-- phpMyAdmin SQL Dump
-- version 4.5.1
-- http://www.phpmyadmin.net
--
-- Host: 127.0.0.1
-- Generation Time: Mar 09, 2018 at 09:26 AM
-- Server version: 10.1.13-MariaDB
-- PHP Version: 5.6.21

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

--
-- Database: `plexcloud`
--

-- --------------------------------------------------------

--
-- Table structure for table `account`
--

CREATE TABLE `account` (
  `account_id` int(11) UNSIGNED NOT NULL,
  `id` char(11) DEFAULT NULL,
  `name` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `subtype` varchar(128) DEFAULT NULL,
  `is_header` varchar(10) DEFAULT NULL,
  `is_subheader` varchar(10) DEFAULT NULL,
  `is_bank` varchar(10) DEFAULT NULL,
  `cash_postable` varchar(10) DEFAULT NULL,
  `description` text,
  `datetime` datetime DEFAULT NULL,
  `opening_balance` decimal(20,2) DEFAULT NULL,
  `balance` decimal(20,2) DEFAULT NULL,
  `order` int(11) DEFAULT NULL,
  `integrated` int(1) DEFAULT NULL,
  `integration_type` varchar(128) DEFAULT NULL,
  `default` int(1) DEFAULT NULL,
  `branch_id` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `account_bank_recon`
--

CREATE TABLE `account_bank_recon` (
  `id` int(11) UNSIGNED NOT NULL,
  `account_id` int(11) DEFAULT NULL,
  `balance` decimal(20,2) DEFAULT NULL,
  `from_date` date DEFAULT NULL,
  `to_date` date DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(255) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(255) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `account_closure`
--

CREATE TABLE `account_closure` (
  `id` int(11) UNSIGNED NOT NULL,
  `year_end_date` date DEFAULT NULL,
  `retained_earnings` decimal(20,2) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `account_payables`
--

CREATE TABLE `account_payables` (
  `id` int(11) UNSIGNED NOT NULL,
  `txn_no` varchar(255) DEFAULT NULL,
  `date` date DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `contact` varchar(255) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `net_amount` decimal(20,2) DEFAULT NULL,
  `tax_amount` decimal(20,2) DEFAULT NULL,
  `tax_code` varchar(32) DEFAULT NULL,
  `reference` varchar(255) DEFAULT NULL,
  `description` text,
  `account_id` int(11) DEFAULT NULL,
  `account` varchar(255) DEFAULT NULL,
  `type` varchar(32) DEFAULT NULL,
  `asset_id` int(11) DEFAULT NULL,
  `asset` varchar(255) DEFAULT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `employee` varchar(255) DEFAULT NULL,
  `void` int(1) DEFAULT '0',
  `void_date` date DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `account_receivables`
--

CREATE TABLE `account_receivables` (
  `id` int(11) UNSIGNED NOT NULL,
  `txn_no` varchar(255) DEFAULT NULL,
  `date` date DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `contact` varchar(255) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `tax_amount` decimal(20,2) DEFAULT NULL,
  `tax_code` varchar(32) DEFAULT NULL,
  `reference` varchar(255) DEFAULT NULL,
  `description` text,
  `account_id` int(11) DEFAULT NULL,
  `account` varchar(255) DEFAULT NULL,
  `type` varchar(32) DEFAULT NULL,
  `asset_id` int(11) DEFAULT NULL,
  `asset` varchar(255) DEFAULT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `employee` varchar(255) DEFAULT NULL,
  `void` int(1) DEFAULT NULL,
  `void_date` date DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `account_transactions`
--

CREATE TABLE `account_transactions` (
  `id` int(11) NOT NULL,
  `gl_id` int(11) DEFAULT NULL,
  `journal` varchar(128) DEFAULT NULL,
  `account_id` text,
  `account_name` varchar(128) DEFAULT NULL,
  `customer_id` int(11) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `type` varchar(10) DEFAULT NULL,
  `date` date DEFAULT NULL,
  `reference` varchar(128) DEFAULT NULL,
  `description` varchar(128) DEFAULT NULL,
  `notes` varchar(128) DEFAULT NULL,
  `group` varchar(128) DEFAULT NULL,
  `closure_id` int(11) DEFAULT NULL,
  `recon_date` date DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `applicants`
--

CREATE TABLE `applicants` (
  `id` int(11) NOT NULL,
  `vacancy_id` int(11) DEFAULT NULL,
  `firstname` varchar(128) DEFAULT NULL,
  `lastname` varchar(128) DEFAULT NULL,
  `location` varchar(128) DEFAULT NULL,
  `gender` varchar(10) DEFAULT NULL,
  `dob` date DEFAULT NULL,
  `phone` varchar(128) DEFAULT NULL,
  `mobile` varchar(128) DEFAULT NULL,
  `remarks` text,
  `status` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `applicants`
--

INSERT INTO `applicants` (`id`, `vacancy_id`, `firstname`, `lastname`, `location`, `gender`, `dob`, `phone`, `mobile`, `remarks`, `status`) VALUES
(1, 2, 'Test', 'es', '13', 'Female', '2015-12-20', 'tes', 'asd', '', 'Called for Interview');

-- --------------------------------------------------------

--
-- Table structure for table `assets`
--

CREATE TABLE `assets` (
  `id` int(11) UNSIGNED NOT NULL,
  `name` varchar(128) DEFAULT NULL,
  `product_name` varchar(128) DEFAULT NULL,
  `barcode` varchar(128) DEFAULT NULL,
  `cost` decimal(20,2) DEFAULT NULL,
  `current_cost` decimal(20,2) DEFAULT NULL,
  `residual_cost` decimal(20,2) DEFAULT NULL,
  `category` varchar(128) DEFAULT NULL,
  `subcategory` varchar(128) DEFAULT NULL,
  `in_service_date` datetime DEFAULT NULL,
  `acquisition_date` datetime DEFAULT NULL,
  `amortization_date` datetime DEFAULT NULL,
  `evaluation_interval` int(11) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `reference` varchar(128) DEFAULT NULL,
  `pv_id` int(11) DEFAULT NULL,
  `account_id` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `asset_depreciations`
--

CREATE TABLE `asset_depreciations` (
  `id` int(11) UNSIGNED NOT NULL,
  `asset_id` int(11) DEFAULT NULL,
  `date` date DEFAULT NULL,
  `depreciation_amount` decimal(20,2) DEFAULT NULL,
  `current_value` decimal(20,2) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `buffer_sale_items`
--

CREATE TABLE `buffer_sale_items` (
  `id` int(11) NOT NULL,
  `txn_no` varchar(32) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `sale_id` int(11) DEFAULT NULL,
  `member_id` int(11) DEFAULT NULL,
  `customer_id` int(11) DEFAULT NULL,
  `pseudo_id` int(11) DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_sku` varchar(128) DEFAULT NULL,
  `item_sku2` varchar(128) DEFAULT NULL,
  `item_name` varchar(128) DEFAULT NULL,
  `item_uom` varchar(128) DEFAULT NULL,
  `sku_select` int(11) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `qty_fraction` int(11) DEFAULT NULL,
  `unit` varchar(128) DEFAULT NULL,
  `price_per_unit` decimal(20,2) DEFAULT NULL,
  `margin` decimal(20,4) DEFAULT NULL,
  `cost` decimal(20,4) DEFAULT NULL,
  `discount_type` varchar(10) DEFAULT NULL,
  `discount_value` decimal(20,2) DEFAULT NULL,
  `discount_amount` decimal(20,2) DEFAULT NULL,
  `global_discount` decimal(20,2) DEFAULT NULL,
  `global_discount_type` varchar(1) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `tax` decimal(20,2) DEFAULT NULL,
  `sold` int(11) DEFAULT NULL,
  `terminal` varchar(32) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `is_redemption` int(11) DEFAULT NULL,
  `points` int(11) DEFAULT NULL,
  `redeemed` int(1) DEFAULT '0',
  `serial_no` varchar(128) DEFAULT NULL,
  `fnb` int(1) DEFAULT NULL,
  `sync` int(11) DEFAULT '0',
  `sync_time` varchar(128) DEFAULT NULL,
  `client_sync_time` varchar(128) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `clinic_dosage` text
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `buffer_sale_itemssales`
--

CREATE TABLE `buffer_sale_itemssales` (
  `id` int(11) NOT NULL,
  `txn_no` varchar(32) DEFAULT NULL,
  `user_id` int(11) DEFAULT NULL,
  `username` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `cost` decimal(20,4) DEFAULT NULL,
  `cc_cost` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `amount_tendered` decimal(20,2) DEFAULT NULL,
  `amount_change` decimal(20,2) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `payment_details` text,
  `terminal` varchar(32) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `is_redemption` int(1) DEFAULT NULL,
  `discount` varchar(32) DEFAULT NULL,
  `discount_type` varchar(32) DEFAULT NULL,
  `adjustment` decimal(20,2) DEFAULT NULL,
  `amount_cc` decimal(20,2) DEFAULT NULL,
  `amount_cheque` decimal(20,2) DEFAULT NULL,
  `amount_credit` decimal(20,2) DEFAULT NULL,
  `amount_cash` decimal(20,2) DEFAULT NULL,
  `amount_bank_deposit` decimal(20,2) DEFAULT NULL,
  `cheque_received` int(1) DEFAULT NULL,
  `card_type` varchar(128) DEFAULT NULL,
  `customer_id` int(11) DEFAULT NULL,
  `customer` varchar(128) DEFAULT NULL,
  `customer_phone` varchar(128) DEFAULT NULL,
  `payment` text,
  `member_id` int(11) DEFAULT NULL,
  `fnb` int(11) DEFAULT NULL,
  `sync` int(11) DEFAULT NULL,
  `sync_time` varchar(128) DEFAULT NULL,
  `client_sync_time` varchar(128) DEFAULT NULL,
  `pseudo_id` int(20) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `taxes` text,
  `tax_amount` decimal(20,2) DEFAULT NULL,
  `shipping` int(11) DEFAULT NULL,
  `shipping_name` varchar(128) DEFAULT NULL,
  `shipping_amount` decimal(20,2) DEFAULT NULL,
  `shipping_weight` decimal(20,4) DEFAULT NULL,
  `remarks` text,
  `added_on` datetime DEFAULT NULL,
  `clinic_consultation_status` varchar(128) DEFAULT NULL,
  `usid` varchar(128) DEFAULT NULL,
  `queue_no` int(5) DEFAULT NULL,
  `consultant_id` int(11) DEFAULT NULL,
  `is_consulted` int(1) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `buffer_sale_item_sales`
--

CREATE TABLE `buffer_sale_item_sales` (
  `id` int(11) NOT NULL,
  `txn_no` varchar(32) DEFAULT NULL,
  `user_id` int(11) DEFAULT NULL,
  `username` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `cost` decimal(20,4) DEFAULT NULL,
  `cc_cost` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `amount_tendered` decimal(20,2) DEFAULT NULL,
  `amount_change` decimal(20,2) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `payment_details` text,
  `terminal` varchar(32) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `is_redemption` int(1) DEFAULT NULL,
  `discount` varchar(32) DEFAULT NULL,
  `discount_type` varchar(32) DEFAULT NULL,
  `adjustment` decimal(20,2) DEFAULT NULL,
  `amount_cc` decimal(20,2) DEFAULT NULL,
  `amount_cheque` decimal(20,2) DEFAULT NULL,
  `amount_credit` decimal(20,2) DEFAULT NULL,
  `amount_cash` decimal(20,2) DEFAULT NULL,
  `amount_bank_deposit` decimal(20,2) DEFAULT NULL,
  `cheque_received` int(1) DEFAULT NULL,
  `card_type` varchar(128) DEFAULT NULL,
  `customer_id` int(11) DEFAULT NULL,
  `customer` varchar(128) DEFAULT NULL,
  `customer_phone` varchar(128) DEFAULT NULL,
  `payment` text,
  `member_id` int(11) DEFAULT NULL,
  `fnb` int(11) DEFAULT NULL,
  `sync` int(11) DEFAULT NULL,
  `sync_time` varchar(128) DEFAULT NULL,
  `client_sync_time` varchar(128) DEFAULT NULL,
  `pseudo_id` int(20) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `taxes` text,
  `tax_amount` decimal(20,2) DEFAULT NULL,
  `shipping` int(11) DEFAULT NULL,
  `shipping_name` varchar(128) DEFAULT NULL,
  `shipping_amount` decimal(20,2) DEFAULT NULL,
  `shipping_weight` decimal(20,4) DEFAULT NULL,
  `remarks` text,
  `added_on` datetime DEFAULT NULL,
  `clinic_consultation_status` varchar(128) DEFAULT NULL,
  `usid` varchar(128) DEFAULT NULL,
  `queue_no` int(5) DEFAULT NULL,
  `consultant_id` int(11) DEFAULT NULL,
  `is_consulted` int(1) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `buffer_tax`
--

CREATE TABLE `buffer_tax` (
  `id` int(11) UNSIGNED NOT NULL,
  `sale_id` int(11) DEFAULT NULL,
  `tax` varchar(128) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `calendar`
--

CREATE TABLE `calendar` (
  `id` int(11) NOT NULL,
  `title` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `location` varchar(128) DEFAULT NULL,
  `allday` varchar(128) DEFAULT NULL,
  `start` datetime DEFAULT NULL,
  `end` datetime DEFAULT NULL,
  `repeat` varchar(20) DEFAULT NULL,
  `notes` text,
  `user` varchar(128) DEFAULT NULL,
  `priority` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `assigned_by` varchar(128) DEFAULT NULL,
  `division` varchar(128) DEFAULT NULL,
  `department` varchar(128) DEFAULT NULL,
  `broadcast` int(1) DEFAULT NULL,
  `new_to_user` int(1) DEFAULT '1',
  `new_to_assigner` int(1) DEFAULT '1',
  `module` varchar(128) DEFAULT NULL,
  `module_id` int(11) DEFAULT NULL,
  `module_type` varchar(128) DEFAULT NULL,
  `branch` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `calendar`
--

INSERT INTO `calendar` (`id`, `title`, `type`, `location`, `allday`, `start`, `end`, `repeat`, `notes`, `user`, `priority`, `status`, `assigned_by`, `division`, `department`, `broadcast`, `new_to_user`, `new_to_assigner`, `module`, `module_id`, `module_type`, `branch`) VALUES
(168, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 1, NULL, NULL, NULL, NULL),
(169, 'Appointment: Shafiq Rizwan', 'appointment', '0', '', '2012-12-04 09:00:00', '2012-12-04 10:30:00', NULL, 'Test', 'admin', NULL, NULL, NULL, '0', NULL, 1, 1, 1, 'Clinic', 0, 'Patient Appointments', 5),
(170, 'Appointment: Shafiq Rizwan', 'Appointment', '0', '', '2012-12-05 11:30:00', '0000-00-00 00:00:00', NULL, 'kjhjhkjh kjkh', 'admin', NULL, NULL, NULL, '0', NULL, 1, 1, 1, 'Clinic', 0, 'Patient Appointments', 5),
(171, 'Appointment: Shafiq Rizwan', 'appointment', '', '', '2013-02-10 12:00:00', '2013-02-10 12:00:00', NULL, 'He''s a geek. BEWARE!!!', 'admin2', 'Normal', 'Pending', NULL, '0', NULL, 1, 1, 1, 'Clinic', 5, 'Patient Appointments', 1),
(172, 'Appointment: ', 'appointment', '', '', '2013-02-20 12:00:00', '2013-02-20 12:00:00', NULL, '', 'admin2', 'Normal', 'Pending', NULL, '0', NULL, 1, 1, 1, 'Clinic', 0, 'Patient Appointments', 1),
(173, 'test', 'schedule', '', '1', '2013-05-17 00:00:00', '2013-05-17 00:00:00', '0', '', 'admin2', 'Low', 'Pending', NULL, '0', NULL, NULL, 1, 1, NULL, NULL, NULL, NULL),
(174, 'Update Bafana JV Document', 'task', '', '', '2014-03-11 07:30:00', '2014-03-12 07:30:00', '0', '', 'azad', 'High', 'Pending', 'azad', '0', NULL, NULL, 1, 1, NULL, NULL, NULL, NULL),
(175, 'Upload new F&B System', 'task', '', '', '2014-03-11 07:30:00', '2014-03-12 07:30:00', '0', '', 'shafiq', 'Very High', 'Pending', 'azad', '0', NULL, NULL, 1, 1, NULL, NULL, NULL, NULL),
(177, 'TEst', 'schedule', '', '1', '2016-01-05 00:00:00', '2016-01-05 00:00:00', '0', '', 'admin', 'Low', 'Pending', NULL, '0', NULL, NULL, 1, 1, NULL, NULL, NULL, NULL),
(178, 'test event', 'schedule', 'KL', '1', '2016-01-07 00:00:00', '1970-01-01 07:30:00', '0', '', 'admin', 'Low', 'Pending', NULL, '0', NULL, NULL, 1, 1, NULL, NULL, NULL, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `calendar_task_logs`
--

CREATE TABLE `calendar_task_logs` (
  `id` int(11) UNSIGNED NOT NULL,
  `task_id` int(11) DEFAULT NULL,
  `comments` text,
  `hidden` int(11) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `campaign`
--

CREATE TABLE `campaign` (
  `id` int(11) NOT NULL,
  `name` varchar(128) DEFAULT NULL,
  `assigned_to` text,
  `division` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `target_audience` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `expected_close_date` date DEFAULT NULL,
  `expected_open_date` date DEFAULT NULL,
  `actual_open_date` date DEFAULT NULL,
  `actual_close_date` date DEFAULT NULL,
  `currency` varchar(128) DEFAULT NULL,
  `sponsor` text,
  `target_size` varchar(128) DEFAULT NULL,
  `product` varchar(128) DEFAULT NULL,
  `budget_cost` varchar(128) DEFAULT NULL,
  `actual_cost` varchar(128) DEFAULT NULL,
  `expected_response` varchar(128) DEFAULT NULL,
  `expected_revenue` varchar(128) DEFAULT NULL,
  `expected_sales_count` varchar(128) DEFAULT NULL,
  `actual_sales_count` varchar(128) DEFAULT NULL,
  `expected_response_count` varchar(128) DEFAULT NULL,
  `actual_response_count` varchar(128) DEFAULT NULL,
  `expected_roi` varchar(128) DEFAULT NULL,
  `actual_roi` varchar(128) DEFAULT NULL,
  `description` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `cash_count`
--

CREATE TABLE `cash_count` (
  `id` int(11) NOT NULL,
  `user_id` int(11) DEFAULT NULL,
  `username` varchar(128) DEFAULT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `employee_username` varchar(128) DEFAULT NULL,
  `from` datetime DEFAULT NULL,
  `to` datetime DEFAULT NULL,
  `deposited` decimal(20,2) DEFAULT NULL,
  `discrepancy` decimal(20,2) DEFAULT NULL,
  `total_sales` decimal(20,2) DEFAULT NULL,
  `total_items` int(11) DEFAULT NULL,
  `sale_breakdown` text,
  `ip_address` varchar(32) DEFAULT NULL,
  `terminal` varchar(32) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `charges`
--

CREATE TABLE `charges` (
  `id` int(11) UNSIGNED NOT NULL,
  `name` varchar(255) DEFAULT NULL,
  `percentage` decimal(20,2) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `charges`
--

INSERT INTO `charges` (`id`, `name`, `percentage`) VALUES
(1, 'Service Charge', '10.00');

-- --------------------------------------------------------

--
-- Table structure for table `config`
--

CREATE TABLE `config` (
  `id` int(11) NOT NULL,
  `config` varchar(128) DEFAULT NULL,
  `value` text,
  `allow_branch_config` int(1) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `config`
--

INSERT INTO `config` (`id`, `config`, `value`, `allow_branch_config`) VALUES
(1, 'till_deposit', '0', 1),
(2, 'currency', 'RM', NULL),
(3, 'system_title', 'Plexcloud&trade;', 1),
(4, 'receipt_header', '', 1),
(5, 'receipt_footer', '', 1),
(119, 'fnbpos_idle_table_duration', '10', NULL),
(6, 'company_name', 'The Daily Dose', 1),
(7, 'company_address', '', 1),
(8, 'company_contact', '', 1),
(9, 'po_store_signee', '0', 1),
(10, 'po_supplier_signee', '0', 1),
(11, 'checkout_cc', '1', 1),
(12, 'checkout_credit', '1', 1),
(13, 'checkout_cheque', '1', 1),
(14, 'discount_allowed', '1', 1),
(15, 'discount_type_default', 'p', 1),
(16, 'revert_allowed', '1', 1),
(17, 'revert_level', 'Manager', 1),
(18, 'report_type', 'Summary', 1),
(19, 'receipt_printing', '0', 1),
(20, 'cd_welcome_1', '0', 1),
(21, 'cd_welcome_2', '0', 1),
(22, 'cd_thankyou', '0', 1),
(23, 'version', '0.9.1', NULL),
(24, 'receipt_type', '3 Inch', 1),
(25, 'custom_price_allowed', '1', 1),
(26, 'member_points', '1', NULL),
(27, 'member_minimum_amount', '1', NULL),
(28, 'member_minimum_point', '1', NULL),
(29, 'cost_update_method', 'fifo', NULL),
(30, 'sales_screen_cost', '1', 1),
(31, 'debug', '{"id":"2941","category":"Uncategorized","subcategory":"Uncategorized","brand":"","location":"","name":"FIFO ITEM","model_no":"","warranty":"","sku":"00000","qty":29,"alert_quantity":"2","max_quantity":"0","cost":"10.0000","price":"15.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","added_on":"2011-07-17 11:59:01","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":"100193","current_po_item":"29703"}', NULL),
(32, 'sales_screen_gp', '1', 1),
(36, 'member_discount', '', 1),
(33, 'license', '{"licensee":"Laguna Bookstore","date":"2011-11-15","id":"10001","company_code":"LBS","hostname":"Win7-PC","ip":"127.0.0.1","type":"Outright","tenure":""}', NULL),
(34, 'corepass', 'd93c1af9f616e273d6866505f9fe5dac', NULL),
(35, 'license_setup', '1', NULL),
(37, 'company_logo', 'receipt_logo.png', NULL),
(38, 'assets_value_update', '1465823258', NULL),
(39, 'checkout_ltc', '1', 1),
(40, 'rounding_adjust', '1', 1),
(41, 'customer_phone', '1', 1),
(42, 'po_tnc', 'PO TNC', 1),
(43, 'dn_tnc', 'DN TNC', 1),
(44, 'quote_tnc', '1. All quotes are valid for the period stated on the quotation.\n', 1),
(101, 'pos_allowed_roles', '', NULL),
(103, 'so_footer', 'Electronic generated document,no signature is required', 1),
(104, 'quote_footer', 'Electronic generated document,no signature is required', 1),
(105, 'po_footer', '', 1),
(106, 'online_sales_footer', 'Electronic generated document,no signature is required', 1),
(45, 'invoice_tnc', '', 1),
(46, 'cn_tnc', '', 1),
(47, 'warehouse_enabled', '1', NULL),
(48, 'country', 'Malaysia', 1),
(49, 'online_sales', '1', NULL),
(50, 'online_sales_api_key', '41bdf44edab45537bef56edb653acdbc', NULL),
(51, 'online_sales_allowed_domains', '198.101.229.153', NULL),
(52, 'diagnose2', '5', NULL),
(53, 'diagnose', 'a1', NULL),
(54, 'online_sales_responder_name', '', NULL),
(55, 'online_sales_responder_email', '', NULL),
(56, 'online_sales_email_new_registration', '', NULL),
(57, 'online_sales_email_password_reset', '', NULL),
(58, 'online_sales_email_new_order', '', NULL),
(59, 'online_sales_email_new_order_bo', '', NULL),
(60, 'online_sales_fb_login', '0', NULL),
(61, 'online_sales_fb_app_id', '', NULL),
(62, 'online_sales_fb_app_secret', '', NULL),
(63, 'so_tnc', '1. All quotes are valid for the period stated on the quotation.\n2. Products that incur a copper fluctuating price will be priced according to the prices available on the day of ordering.\n3. The customer is responsible for ensuring all quantities quoted are accurate and that all orders placed reflect the correct quantities.', NULL),
(64, 'online_sales_email_new_registration_subject', '', NULL),
(65, 'online_sales_email_password_reset_subject', '', NULL),
(66, 'online_sales_email_new_order_subject', '', NULL),
(67, 'online_sales_email_new_order_bo_subject', '', NULL),
(68, 'member_tnc', '', NULL),
(69, 'online_sales_tnc', '', NULL),
(85, 'scratchpad', 'aasdasda\n\na\ndas\nda\nda\n\nasasdasdasdasd\n', NULL),
(117, 'company_reg_no', '1136230-U', NULL),
(118, 'company_tax_no', '', NULL),
(123, 'fnbpos_service_charge', '10', NULL),
(122, 'report_running_numbers', '1', NULL),
(124, 'fnbpos_no_sc_is', 'on', NULL),
(125, 'fnbpos_course_serving', '0', NULL),
(126, 'fnb_table_layout', '[{"table":"T10","position":{"top":120,"left":1050}},{"table":"T8","position":{"top":290,"left":1050}},{"table":"T9","position":{"top":290,"left":1110}},{"table":"T1","position":{"top":120,"left":915}},{"table":"T2","position":{"top":120,"left":840}},{"table":"T3","position":{"top":120,"left":765}},{"table":"T4","position":{"top":120,"left":690}},{"table":"T5","position":{"top":120,"left":600}},{"table":"T6","position":{"top":120,"left":435}},{"table":"T11","position":{"top":120,"left":315}},{"table":"T12","position":{"top":120,"left":135}},{"table":"T13","position":{"top":290,"left":315}},{"table":"T14","position":{"top":290,"left":195}},{"table":"T15","position":{"top":290,"left":90}},{"table":"T7","position":{"top":290,"left":435}},{"table":"T12A","position":{"top":120,"left":75}},{"table":"T11A","position":{"top":120,"left":255}}]', NULL),
(127, 'fnbpos_reroute_wtc', '', NULL),
(128, 'fnbpos_discount_with_customer', '0', NULL),
(130, 'fnbpos_cash_only', '0', NULL),
(131, 'fnbpos_hide_pax', '1', NULL),
(132, 'database_version', '1475138314', NULL),
(133, 'fnbpos_logout_timeout', '', NULL),
(134, 'fnbpos_hide_cardno', '0', NULL),
(135, 'fnbpos_void_reason', 'Reason 1\nReason 2\nReason 3', NULL),
(89, 'company_tel', '604-2519168', NULL),
(90, 'company_address1', '36 Steward Lane ', NULL),
(91, 'company_address2', '', NULL),
(92, 'company_city', 'Georgetown ', NULL),
(93, 'company_zipcode', '10200', NULL),
(94, 'company_state', 'Pulau Pinang', NULL),
(95, 'company_country', 'Malaysia', NULL),
(96, 'company_divisions', '', NULL),
(97, 'hybrid_pos', '0', NULL),
(98, 'fnbpos_print_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to %printer_name% %order%', NULL),
(99, 'fnbpos_print_paper_size', '80mm', NULL),
(100, 'online_sales_so_duration', '', NULL),
(107, 'member_footer', 'Electronic generated document,no signature is required', 1),
(108, 'invoice_footer', 'Electronic generated document,no signature is required.', 1),
(129, 'revert_keycard', '0', NULL),
(109, 'do_footer', 'Electronic generated document,no signature is required', 1),
(110, 'dn_footer', '', 1),
(120, 'plexcloud_id', 'admin', NULL),
(111, 'cn_footer', 'Electronic generated document,no signature is required', 1),
(112, 'checkout_voucher', '1', NULL),
(113, 'pos_retail_item_layout', 'grid', NULL),
(114, 'pr_tnc', 'PO TNC', 1),
(115, 'pr_footer', '', 1),
(121, 'plexcloud_key', 'admin123', NULL),
(70, 'online_sales_responder_txn_email', '', NULL),
(71, 'online_sales_responder_hostname', '', NULL),
(72, 'online_sales_responder_port', '', NULL),
(73, 'online_sales_responder_password', '', NULL),
(74, 'price_rules', 'false', NULL),
(75, 'do_tnc', '1. All quotes are valid for the period stated on the quotation.\n2. Products that incur a copper fluctuating price will be priced according to the prices available on the day of ordering.\n3. The customer is responsible for ensuring all quantities quoted are accurate and that all orders placed reflect the correct quantities.', NULL),
(76, 'online_sales_email_css', '', NULL),
(77, 'online_sales_min_purchase', '1.00', NULL),
(78, 'online_sales_email_order_status', '', NULL),
(79, 'online_sales_email_order_status_subject', '', NULL),
(82, 'checkout_bank_deposit', '0', 1),
(80, 'print_is', '0', 1),
(81, 'print_ta', '0', 1),
(83, 'checkout_remarks', '1', 1),
(84, 'checkout_delivery', '0', 1),
(86, 'warehouse_shared_inventory', '1', NULL),
(87, 'report_secondary_categories', '', NULL),
(88, 'online_sales_item_limit_per_page', '1', NULL),
(116, 'first_setup', '1', NULL);

-- --------------------------------------------------------

--
-- Table structure for table `config_branch`
--

CREATE TABLE `config_branch` (
  `id` int(11) UNSIGNED NOT NULL,
  `config` varchar(128) DEFAULT NULL,
  `value` text,
  `branch_id` int(11) DEFAULT NULL,
  `lastchange` varchar(128) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `config_branch`
--

INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(1, 'so_tnc', '', 5, NULL),
(2, 'do_tnc', '', 5, NULL),
(3, 'member_tnc', '', 5, NULL),
(4, 'online_sales_tnc', '', 5, NULL),
(5, 'price_rules', '{"Agent_Member":""}', 5, NULL),
(6, 'currency', '', 5, NULL),
(7, 'member_points', '1', 5, NULL),
(8, 'member_minimum_amount', '', 5, NULL),
(9, 'member_minimum_point', '', 5, NULL),
(10, 'online_sales', '1', 5, NULL),
(11, 'online_sales_min_purchase', '', 5, NULL),
(12, 'online_sales_responder_name', '', 5, NULL),
(13, 'online_sales_responder_email', '', 5, NULL),
(14, 'online_sales_responder_password', '', 5, NULL),
(15, 'online_sales_responder_txn_email', '', 5, NULL),
(16, 'online_sales_responder_hostname', '', 5, NULL),
(17, 'online_sales_responder_port', '', 5, NULL),
(18, 'online_sales_email_new_registration', '', 5, NULL),
(19, 'online_sales_email_password_reset', '', 5, NULL),
(20, 'online_sales_email_new_order', '', 5, NULL),
(21, 'online_sales_email_new_order_bo', '', 5, NULL),
(22, 'online_sales_email_new_registration_subject', '', 5, NULL),
(23, 'online_sales_email_password_reset_subject', '', 5, NULL),
(24, 'online_sales_email_new_order_subject', '', 5, NULL),
(25, 'online_sales_email_new_order_bo_subject', '', 5, NULL),
(26, 'online_sales_email_order_status', '', 5, NULL),
(27, 'online_sales_email_order_status_subject', '', 5, NULL),
(28, 'online_sales_fb_login', '1', 5, NULL),
(29, 'online_sales_fb_app_id', '', 5, NULL),
(30, 'online_sales_fb_app_secret', '', 5, NULL),
(31, 'online_sales_email_css', '', 5, NULL),
(32, 'quote_tnc', '', 5, NULL),
(33, 'invoice_tnc', '', 5, NULL),
(34, 'cn_tnc', '', 5, NULL),
(35, 'receipt_header', '', 5, NULL),
(36, 'receipt_footer', '', 5, NULL),
(37, 'receipt_printing', '1', 5, NULL),
(38, 'receipt_type', '3 Inch', 5, NULL),
(39, 'till_deposit', '', 5, NULL),
(40, 'po_store_signee', '0', 5, NULL),
(41, 'po_supplier_signee', '0', 5, NULL),
(42, 'cd_welcome_1', '', 5, NULL),
(43, 'cd_welcome_2', '', 5, NULL),
(44, 'cd_thankyou', '', 5, NULL),
(45, 'checkout_cc', '1', 5, NULL),
(46, 'checkout_credit', '1', 5, NULL),
(47, 'checkout_cheque', '1', 5, NULL),
(48, 'checkout_bank_deposit', '1', 5, NULL),
(49, 'checkout_ltc', '1', 5, NULL),
(50, 'checkout_remarks', '1', 5, NULL),
(51, 'checkout_delivery', '1', 5, NULL),
(52, 'discount_allowed', '1', 5, NULL),
(53, 'discount_type_default', 'p', 5, NULL),
(54, 'revert_allowed', '1', 5, NULL),
(55, 'revert_level', 'Manager', 5, NULL),
(56, 'print_is', '1', 5, NULL),
(57, 'print_ta', '1', 5, NULL),
(58, 'report_type', 'Summary', 5, NULL),
(59, 'report_secondary_categories', '', 5, NULL),
(60, 'custom_price_allowed', '1', 5, NULL),
(61, 'sales_screen_cost', '1', 5, NULL),
(62, 'sales_screen_gp', '1', 5, NULL),
(63, 'member_discount', '', 5, NULL),
(64, 'rounding_adjust', '1', 5, NULL),
(65, 'customer_phone', '1', 5, NULL),
(66, 'online_sales_item_limit_per_page', '9', 5, NULL),
(67, 'quote_tnc', '', 7, NULL),
(68, 'invoice_tnc', '', 7, NULL),
(69, 'cn_tnc', '', 7, NULL),
(70, 'receipt_header', '', 7, NULL),
(71, 'receipt_footer', '', 7, NULL),
(72, 'receipt_printing', '1', 7, NULL),
(73, 'receipt_type', '3 Inch', 7, NULL),
(74, 'till_deposit', '', 7, NULL),
(75, 'po_store_signee', '0', 7, NULL),
(76, 'po_supplier_signee', '0', 7, NULL),
(77, 'cd_welcome_1', '', 7, NULL),
(78, 'cd_welcome_2', '', 7, NULL),
(79, 'cd_thankyou', '', 7, NULL),
(80, 'checkout_cc', '1', 7, NULL),
(81, 'checkout_credit', '1', 7, NULL),
(82, 'checkout_cheque', '1', 7, NULL),
(83, 'checkout_bank_deposit', '1', 7, NULL),
(84, 'checkout_ltc', '1', 7, NULL),
(85, 'checkout_remarks', '1', 7, NULL),
(86, 'checkout_delivery', '1', 7, NULL),
(87, 'discount_allowed', '1', 7, NULL),
(88, 'discount_type_default', 'p', 7, NULL),
(89, 'revert_allowed', '1', 7, NULL),
(90, 'revert_level', 'Manager', 7, NULL),
(91, 'print_is', '1', 7, NULL),
(92, 'print_ta', '1', 7, NULL),
(93, 'report_type', 'Summary', 7, NULL),
(94, 'custom_price_allowed', '1', 7, NULL),
(95, 'sales_screen_cost', '1', 7, NULL),
(96, 'sales_screen_gp', '1', 7, NULL),
(97, 'member_discount', '', 7, NULL),
(98, 'rounding_adjust', '1', 7, NULL),
(99, 'customer_phone', '1', 7, NULL),
(100, 'company_name', 'Plex Solutions(PG0293513-D)', 2, NULL),
(101, 'company_address', 'No. 92, Tingkat 3\nD''Piazza Mall\n11950 Bayan Baru\nPulau Pinang', 2, NULL),
(102, 'company_contact', 'Tel : +6014- 3076411 | Email: support@plexsol.com', 2, NULL),
(103, 'receipt_printing', '0', 2, NULL),
(104, 'quote_tnc', '1. All quotes are valid for the period stated on the quotation.\n2. The customer is responsible for ensuring all quantities quoted are accurate and that all orders placed reflect the correct quantities.', 2, NULL),
(105, 'invoice_tnc', '', 2, NULL),
(106, 'cn_tnc', '', 2, NULL),
(107, 'quote_footer', 'Electronic generated document,no signature is required', 2, NULL),
(108, 'so_footer', 'Electronic generated document,no signature is required', 2, NULL),
(109, 'invoice_footer', 'Electronic generated document,no signature is required\nPayment can be made by bank transfer or cheque payable to Plex Solutions (CIMB:07440001007056)', 2, NULL),
(110, 'cn_footer', 'Electronic generated document,no signature is required', 2, NULL),
(111, 'do_footer', 'Electronic generated document,no signature is required', 2, NULL),
(112, 'po_store_signee', '0', 2, NULL),
(113, 'po_supplier_signee', '0', 2, NULL),
(114, 'till_deposit', '0', 2, NULL),
(115, 'cd_welcome_1', '0', 2, NULL),
(116, 'cd_welcome_2', '0', 2, NULL),
(117, 'cd_thankyou', '0', 2, NULL),
(118, 'checkout_cc', '1', 2, NULL),
(119, 'checkout_credit', '1', 2, NULL),
(120, 'checkout_cheque', '1', 2, NULL),
(121, 'checkout_bank_deposit', '1', 2, NULL),
(122, 'checkout_ltc', '1', 2, NULL),
(123, 'checkout_remarks', '1', 2, NULL),
(124, 'checkout_delivery', '1', 2, NULL),
(125, 'discount_allowed', '1', 2, NULL),
(126, 'discount_type_default', 'p', 2, NULL),
(127, 'revert_allowed', '1', 2, NULL),
(128, 'revert_level', 'Manager', 2, NULL),
(129, 'print_is', '0', 2, NULL),
(130, 'print_ta', '0', 2, NULL),
(131, 'report_type', 'Summary', 2, NULL),
(132, 'custom_price_allowed', '1', 2, NULL),
(133, 'sales_screen_cost', '1', 2, NULL),
(134, 'sales_screen_gp', '1', 2, NULL),
(135, 'member_discount', '', 2, NULL),
(136, 'rounding_adjust', '1', 2, NULL),
(137, 'customer_phone', '1', 2, NULL),
(138, 'last_cli', '', 1, NULL),
(139, 'last_cli', '', 1, NULL),
(140, 'last_cli', '', 1, NULL),
(141, 'last_cli', '', 1, NULL),
(142, 'last_cli', '', 1, NULL),
(143, 'last_cli', '', 1, NULL),
(144, 'last_cli', '', 1, NULL),
(145, 'last_cli', '', 1, NULL),
(146, 'log_a', '0.0000064', 1, NULL),
(147, 'log_b', '0.000019019', 1, NULL),
(148, 'log_c', '0.00002508', 1, NULL),
(149, 'log_d', '-0.000596997', 1, NULL),
(150, 'last_cli', '', 1, NULL),
(151, 'last_cli', '', 1, NULL),
(157, 'last_cli', '', 1, NULL),
(158, 'last_cli', '', 1, NULL),
(159, 'last_cli', '', 1, NULL),
(160, 'last_cli', '', 1, NULL),
(161, 'last_cli', '', 1, NULL),
(162, 'last_cli', '', 1, NULL),
(163, 'last_cli', '', 1, NULL),
(164, 'last_cli', '', 1, NULL),
(165, 'last_cli', '', 1, NULL),
(166, 'last_cli', '', 1, NULL),
(167, 'last_cli', '', 1, NULL),
(168, 'last_cli', '', 1, NULL),
(169, 'last_cli', '', 1, NULL),
(170, 'last_cli', '', 1, NULL),
(171, 'last_cli', '', 1, NULL),
(172, 'last_cli', '', 1, NULL),
(173, 'last_cli', '', 1, NULL),
(174, 'last_cli', '', 1, NULL),
(175, 'last_cli', '', 1, NULL),
(176, 'last_cli', '', 1, NULL),
(177, 'last_cli', '', 1, NULL),
(178, 'last_cli', '', 1, NULL),
(179, 'last_cli', '', 1, NULL),
(180, 'last_cli', '', 1, NULL),
(181, 'last_cli', '', 1, NULL),
(182, 'last_cli', '', 1, NULL),
(183, 'last_cli', '', 1, NULL),
(184, 'last_cli', '', 1, NULL),
(185, 'last_cli', '', 1, NULL),
(186, 'last_cli', '', 1, NULL),
(187, 'last_cli', '', 1, NULL),
(188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue6_copy.pdf', 1, NULL),
(190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue6_copy.pdf', 1, NULL),
(192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue6_copy.pdf', 1, NULL),
(194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue6_copy.pdf', 1, NULL),
(196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue6_copy.pdf', 1, NULL),
(198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue6_copy.pdf', 1, NULL),
(200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue7_copy.pdf', 1, NULL),
(202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue7_copy.pdf', 1, NULL),
(204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue7_copy.pdf', 1, NULL),
(206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue12_copy.pdf', 1, NULL),
(212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue12_copy.pdf', 1, NULL),
(214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue12_copy.pdf', 1, NULL),
(216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue12_copy.pdf', 1, NULL),
(218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue12_copy.pdf', 1, NULL),
(220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue12_copy.pdf', 1, NULL),
(222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue12_copy.pdf', 1, NULL),
(224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue12_copy.pdf', 1, NULL),
(226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue12_copy.pdf', 1, NULL),
(228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue12_copy.pdf', 1, NULL),
(230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue12_copy.pdf', 1, NULL),
(232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue12_copy.pdf', 1, NULL),
(234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue12_copy.pdf', 1, NULL),
(236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(1029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(1241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(1242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(1243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(1244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(1245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(1246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(1259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(1260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(1261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(1262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(1263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(1264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(1265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(1266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(1267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(1268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(1269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(1270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(1271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(1272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(1273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(1274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(1275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(1276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(1277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(1278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(1279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(1280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(1281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(1282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(1283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(1284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(1480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(1595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(1596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(1597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(1598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(1599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(1600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(1601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(1602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(1603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(1604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(1605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(1606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(1607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(1608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(1609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(1610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(1611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(1612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(1613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(1614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(1615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(1616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(1617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(1618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(1619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(1620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(1621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(1622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(1623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(1624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(1931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(1998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(1999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(2023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(2024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(2025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(2026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(2027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(2028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(2029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(2030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(2031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(2032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(2127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(2128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(2129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(2130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(2131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(2132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(2133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(2134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(2135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(2136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(2382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(2535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(2536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(2537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(2538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(2539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(2540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(2643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(2644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(2645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(2646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(2647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(2648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(2649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(2650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(2651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(2652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(2653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(2654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(2655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(2656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(2657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(2658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(2659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(2660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(2833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(2998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(2999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(3284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(3499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(3500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(3501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(3502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(3503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(3504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(3505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(3506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(3507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(3508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(3509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(3510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(3511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(3512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(3513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(3514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(3591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(3592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(3735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(3983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(3984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(3998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(3999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(4186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(4637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(4777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(4778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(4779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(4780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(4781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(4782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(4783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(4784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(4785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(4786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(4787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(4788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(4789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(4790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(4998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(4999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(5088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(5539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(5990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(5998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(5999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(6029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(6030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(6031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(6032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(6033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(6034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(6035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(6036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(6037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(6038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(6039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(6040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(6041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(6042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(6043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(6044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(6045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(6046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(6047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(6048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(6049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(6050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(6051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(6052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(6257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(6258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(6259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(6260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(6261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(6262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(6263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(6264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(6265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(6266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(6267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(6268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(6269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(6270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(6271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(6272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(6441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(6892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(6998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(6999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(7337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(7338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(7339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(7340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(7341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(7342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(7343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(7344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(7345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(7346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(7347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(7348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(7349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(7350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(7351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(7352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(7353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(7354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(7355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(7356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(7357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(7358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(7359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(7360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(7361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(7362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(7363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(7364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(7365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(7366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(7367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(7368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(7369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(7370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(7589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(7590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(7591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(7592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(7593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(7594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(7595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(7596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(7794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(7998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(7999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(8245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(8515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(8516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(8517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(8518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(8519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(8520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(8521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(8522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(8523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(8524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(8525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(8526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(8527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(8528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(8696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(8831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(8832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(8833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(8834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(8835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(8836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(8837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(8838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(8839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(8840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(8937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(8938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(8998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(8999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(9147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(9403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(9404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(9405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(9406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(9407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(9408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(9409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue3_copy.pdf', 1, NULL),
(9410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(9411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue3_copy.pdf', 1, NULL),
(9412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(9413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue3_copy.pdf', 1, NULL),
(9414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(9415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue3_copy.pdf', 1, NULL),
(9416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(9417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue3_copy.pdf', 1, NULL),
(9418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(9419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue3_copy.pdf', 1, NULL),
(9420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(9421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue3_copy.pdf', 1, NULL),
(9422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(9423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue3_copy.pdf', 1, NULL),
(9424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(9425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue3_copy.pdf', 1, NULL),
(9426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(9427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue3_copy.pdf', 1, NULL),
(9428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(9429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue3_copy.pdf', 1, NULL),
(9430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(9431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue3_copy.pdf', 1, NULL),
(9432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(9433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue3_copy.pdf', 1, NULL),
(9434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(9435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue3_copy.pdf', 1, NULL),
(9436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(9437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue3_copy.pdf', 1, NULL),
(9438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(9439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue3_copy.pdf', 1, NULL),
(9440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(9597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(9957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(9958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(9998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(9999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(10048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(10301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(10302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(10303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(10304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(10305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(10306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(10307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(10308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(10309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(10310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(10311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(10312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(10313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(10314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(10315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(10316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(10317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(10318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(10319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(10320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(10321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(10322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(10494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(10689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(10690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(10941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(10998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(10999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(11388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(11835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(11959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(11960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(11998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(11999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(12281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(12728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(12921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(12922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(12923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(12924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(12925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(12926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(12927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(12928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(12929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(12930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(12931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(12932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(12995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(12996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(12998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(12999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(13175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(13622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(13719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(13720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(13721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(13722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(13723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(13724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(13993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(13994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(13998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(13999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(14068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(14157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(14158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(14515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(14679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(14680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(14773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(14774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(14962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(14998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(14999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(15409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(15461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(15462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(15463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(15464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(15465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(15466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(15467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(15468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(15469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(15470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(15471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(15472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(15473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(15474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(15856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(15975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(15976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(15998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(15999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(16301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(16302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(16303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(16304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(16749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(16797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(16798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(16799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(16800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(16801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(16802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(16803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(16804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(16805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(16806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(16807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(16808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(16998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(16999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(17196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(17643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(17821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(17822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(17998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(17999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(18090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(18537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(18579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(18580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(18581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(18582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(18583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(18584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(18585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(18586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(18587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(18588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(18589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(18590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(18917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(18918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(18983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(18998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(18999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(19053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(19054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(19055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(19056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(19057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(19058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(19059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(19060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(19061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue2_copy.pdf', 1, NULL),
(19062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(19430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue_copy.pdf', 1, NULL),
(19570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Cashier queues\\queue1.pdf', 1, NULL),
(19571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(19585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(19587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(19589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(19593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to \\\\127.0.0.1\\XP-80C queues\\queue1_copy.pdf', 1, NULL),
(19596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1_copy.pdf', 1, NULL),
(19598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(19599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2_copy.pdf', 1, NULL),
(19600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(19601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3_copy.pdf', 1, NULL),
(19602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(19603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4_copy.pdf', 1, NULL),
(19604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(19605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5_copy.pdf', 1, NULL),
(19606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(19607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6_copy.pdf', 1, NULL),
(19608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(19609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7_copy.pdf', 1, NULL),
(19610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(19611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8_copy.pdf', 1, NULL),
(19612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(19613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9_copy.pdf', 1, NULL),
(19614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(19615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10_copy.pdf', 1, NULL),
(19616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(19617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(19618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(19619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(19620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(19621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(19622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(19623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(19624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(19625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(19626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(19627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(19628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(19629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(19630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(19631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(19632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(19633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(19634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(19635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(19636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(19637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue32.pdf', 1, NULL),
(19638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(19639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue32.pdf', 1, NULL),
(19640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(19641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue34.pdf', 1, NULL),
(19642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(19643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(19645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(19647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(19648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(19650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(19652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(19653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(19654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(19655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(19656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(19657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(19658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(19659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(19660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(19661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(19662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(19663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(19664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(19665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(19666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(19667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(19668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(19669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(19670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(19671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(19672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(19673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(19674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(19675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(19676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(19677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(19678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(19679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(19680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(19681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(19683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(19684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(19685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(19686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(19687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(19688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(19689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(19690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(19691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(19692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(19693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(19694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(19695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(19696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(19697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(19698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(19699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(19700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(19701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(19702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(19703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(19704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(19705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(19706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(19707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(19708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(19709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(19710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(19711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(19712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(19713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(19714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(19715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(19716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(19717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(19718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(19719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(19720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(19721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(19722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(19723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(19724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(19725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(19726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(19727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(19728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(19729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(19730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(19731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(19732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(19733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(19734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(19735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(19737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(19739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(19740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(19741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(19742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(19743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(19744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(19745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(19746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(19747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(19748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(19749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(19750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(19751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(19752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(19753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(19754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(19755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(19756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(19757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(19758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(19759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(19760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(19761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(19762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(19763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(19764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(19765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(19766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(19767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(19768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(19769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(19770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(19771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(19772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(19773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(19774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(19775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue20.pdf', 1, NULL),
(19776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(19777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(19778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(19780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(19781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(19782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(19783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(19784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(19785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(19786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(19787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(19788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(19789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(19790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(19791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(19792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(19793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(19794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(19795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(19796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(19797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(19798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(19799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(19800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(19801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(19802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(19803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(19804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(19805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(19806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(19807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(19808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(19809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(19810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(19811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(19812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(19813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(19814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(19815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(19816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(19817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(19818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(19819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(19820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(19821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(19822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(19823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(19824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(19825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(19826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(19827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(19828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(19829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(19830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(19831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(19832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(19833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(19834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(19835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(19836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(19837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(19838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(19839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(19840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(19841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(19842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(19843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(19844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(19845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(19846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(19847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(19849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(19851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(19853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(19854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(19856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(19857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(19858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(19859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(19860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(19861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(19862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(19863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(19864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(19865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(19866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(19867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(19868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(19869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(19870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(19871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(19872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(19873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(19874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(19875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(19876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(19877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(19878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(19879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(19880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(19881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(19882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(19883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(19884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(19885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(19886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(19887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(19888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(19889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(19890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(19891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(19892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(19893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(19894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(19895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(19896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(19897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(19898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(19899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(19900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(19901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(19902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(19903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(19904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(19905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(19906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(19907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(19908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(19909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(19910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue24.pdf', 1, NULL),
(19911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(19912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(19913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(19914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(19915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(19916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(19917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(19918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue31.pdf', 1, NULL),
(19919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue32.pdf', 1, NULL),
(19920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(19921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue32.pdf', 1, NULL),
(19922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(19923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue32.pdf', 1, NULL),
(19924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(19925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue34.pdf', 1, NULL),
(19926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(19927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(19928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(19929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(19930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue37.pdf', 1, NULL),
(19931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(19932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue39.pdf', 1, NULL),
(19933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue40.pdf', 1, NULL),
(19934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue41.pdf', 1, NULL),
(19935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(19937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(19939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(19940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(19941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(19942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(19943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(19944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(19945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(19946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(19947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(19948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(19949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(19950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(19951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(19952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(19953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(19954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(19955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(19956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(19957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(19958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(19959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(19960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(19962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(19963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(19964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(19965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(19966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(19967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(19968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(19969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(19970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(19971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(19972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(19973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(19974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(19975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(19976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(19977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(19978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(19979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(19980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(19981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(19982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(19983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(19984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(19985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(19986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(19987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(19988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(19989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(19990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(19991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(19992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(19993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(19994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(19995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(19996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(19997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(19998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(19999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(20011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(20012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(20014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(20016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(20018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(20021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(20033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(20038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(20039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(20041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(20043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(20044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(20045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(20047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(20049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(20051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(20053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(20054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(20056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(20057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(20058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(20060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(20061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(20062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(20064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(20065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(20066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(20067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(20068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(20069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(20070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(20071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(20072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(20073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(20074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(20075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(20076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(20077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(20086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(20096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(20097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(20099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(20101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(20102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(20103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(20106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(20108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(20110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(20111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(20113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(20116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(20119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(20120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(20122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(20123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(20124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(20126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(20128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(20129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(20130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(20131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(20132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(20133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(20134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(20135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(20136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(20137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(20138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(20139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(20140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(20141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(20142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue25.pdf', 1, NULL),
(20143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(20144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(20145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(20146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(20147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(20148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(20149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(20150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(20151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(20152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(20153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(20154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(20155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(20156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(20157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(20158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(20159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(20160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(20161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(20162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue32.pdf', 1, NULL),
(20163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue33.pdf', 1, NULL),
(20164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(20170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(20173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(20174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(20176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(20191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(20192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(20194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(20196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(20197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(20198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(20200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(20201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(20204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(20208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(20209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(20210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(20211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(20212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(20213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(20214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(20215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(20216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(20217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(20218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(20219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(20220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(20221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(20223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(20225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(20227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(20228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(20229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(20230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(20231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(20232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(20233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue20.pdf', 1, NULL),
(20234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(20235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(20236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(20237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(20238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(20239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(20240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(20241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(20242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(20243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(20244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(20245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(20246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(20247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue24.pdf', 1, NULL),
(20248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(20249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(20250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(20251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(20252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(20253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue30.pdf', 1, NULL),
(20254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(20255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue30.pdf', 1, NULL),
(20256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue29.pdf', 1, NULL),
(20257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(20258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(20259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(20260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(20261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(20262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(20268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(20269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(20270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(20271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(20272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(20295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(20297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(20300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(20301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(20304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(20305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(20306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(20307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(20308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(20309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(20310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(20311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(20312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(20313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(20314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(20317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(20319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(20320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(20321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(20322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(20324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(20326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(20338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(20339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(20341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(20343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(20354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(20355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(20365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(20366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(20375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(20377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(20382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(20385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(20386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(20397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(20398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(20400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(20402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(20403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(20405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(20406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(20407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(20409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(20410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(20411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(20413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(20414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(20415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(20416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(20417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(20418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(20420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(20421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(20422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(20423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(20424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(20425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(20426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(20427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(20428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(20429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(20430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(20431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(20432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue20.pdf', 1, NULL),
(20433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(20434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(20435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(20436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(20437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(20438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(20439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(20440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(20441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(20442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(20443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(20444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(20445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(20446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(20447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(20448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(20449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue24.pdf', 1, NULL),
(20450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(20451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(20452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(20453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(20454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(20455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(20456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(20457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(20458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(20459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue32.pdf', 1, NULL),
(20460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue33.pdf', 1, NULL),
(20461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(20462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(20463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(20464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(20465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue35.pdf', 1, NULL),
(20466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(20467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue35.pdf', 1, NULL),
(20468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(20469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue37.pdf', 1, NULL),
(20470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(20471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue37.pdf', 1, NULL),
(20472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(20473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue37.pdf', 1, NULL),
(20474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(20475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue37.pdf', 1, NULL),
(20476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(20477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue37.pdf', 1, NULL),
(20478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(20500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(20501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(20508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(20513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(20514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(20515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(20516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(20517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(20519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(20520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(20521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(20523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(20524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(20525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(20526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(20527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(20528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(20530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(20531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(20532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(20534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(20535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(20537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(20538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(20539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(20541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(20542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(20543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(20544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(20545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(20546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(20547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(20548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(20549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(20550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(20551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(20552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(20553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(20554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(20555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(20556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(20557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(20558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue24.pdf', 1, NULL),
(20559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(20560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue24.pdf', 1, NULL),
(20561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(20562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue24.pdf', 1, NULL),
(20563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(20564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue24.pdf', 1, NULL),
(20565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(20566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue24.pdf', 1, NULL),
(20567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(20568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue24.pdf', 1, NULL),
(20569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(20570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue24.pdf', 1, NULL),
(20571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(20572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue24.pdf', 1, NULL),
(20573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(20574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(20575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue25.pdf', 1, NULL),
(20576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(20577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(20578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(20579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(20580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(20581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(20582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(20583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue32.pdf', 1, NULL),
(20584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(20585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue32.pdf', 1, NULL),
(20586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(20587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue34.pdf', 1, NULL),
(20588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(20589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(20590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(20591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue36.pdf', 1, NULL),
(20592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue37.pdf', 1, NULL),
(20593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(20594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue41.pdf', 1, NULL),
(20595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue43.pdf', 1, NULL),
(20596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue44.pdf', 1, NULL),
(20597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue45.pdf', 1, NULL),
(20598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(20620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(20630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(20631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(20632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(20633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(20634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(20635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(20637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(20638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(20640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(20642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(20643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(20644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(20645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(20646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(20647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(20648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(20649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(20650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(20651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(20652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(20653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(20654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(20655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(20656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(20657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(20658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(20659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(20670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(20671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(20685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(20687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(20689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(20690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(20691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(20692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(20694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(20696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(20698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(20700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(20702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(20703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(20704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(20705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(20706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(20707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(20715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(20716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(20732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(20734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(20735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(20737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(20738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(20739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(20743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(20744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(20745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(20746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(20748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(20764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(20765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(20767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(20769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(20771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(20773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(20789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(20790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(20791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(20793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(20796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(20797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(20798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(20799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(20801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(20802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(20803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(20804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(20805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(20806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(20807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(20808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(20809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(20810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(20811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(20812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(20813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(20818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(20822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(20840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(20842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(20844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(20845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(20846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(20848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(20850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(20852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(20854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(20856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(20858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(20860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(20862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(20864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(20865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(20866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(20867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(20868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(20869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(20870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(20871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(20873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(20875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(20877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(20878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(20879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(20881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(20882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(20883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(20884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(20885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(20886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(20887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(20888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(20889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(20890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(20891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(20892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(20893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(20894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(20895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(20896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(20897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(20900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(20902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(20903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(20904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(20905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(20908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(20909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(20910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(20912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(20913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(20915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(20916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(20917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(20918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(20919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(20920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(20921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(20922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(20923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(20924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(20925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(20926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(20927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(20928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(20929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(20930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(20931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(20932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(20933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(20934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(20935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(20936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(20937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(20938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(20939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(20940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(20941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(20942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(20943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(20944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(20945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(20946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(20947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue20.pdf', 1, NULL),
(20948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(20949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(20950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(20951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(20952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(20953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue24.pdf', 1, NULL),
(20954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(20955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue26.pdf', 1, NULL),
(20956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(20957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(20958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(20959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(20960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(20961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(20962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(20963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(20964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(20965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(20966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(20967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(20968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(20969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(20970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(20971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(20972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(20973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(20974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue32.pdf', 1, NULL),
(20975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(20976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue32.pdf', 1, NULL),
(20977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue33.pdf', 1, NULL),
(20978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(20979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue35.pdf', 1, NULL),
(20980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(20981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue37.pdf', 1, NULL),
(20982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(20983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue39.pdf', 1, NULL),
(20984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue40.pdf', 1, NULL),
(20985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue41.pdf', 1, NULL),
(20986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue42.pdf', 1, NULL),
(20987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue43.pdf', 1, NULL),
(20988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue44.pdf', 1, NULL),
(20989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue45.pdf', 1, NULL),
(20990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue46.pdf', 1, NULL),
(20991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue47.pdf', 1, NULL),
(20992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue46.pdf', 1, NULL),
(20993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue47.pdf', 1, NULL),
(20994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue48.pdf', 1, NULL),
(20995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue49.pdf', 1, NULL),
(20996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue49.pdf', 1, NULL),
(20997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue50.pdf', 1, NULL),
(20998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue0.pdf', 1, NULL),
(20999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(21000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(21001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(21005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(21007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(21011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(21023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(21025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(21026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(21028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(21035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(21036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(21038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(21039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(21040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(21041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(21042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(21044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(21046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(21047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(21048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(21049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(21050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(21051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(21052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(21053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(21054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(21055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(21056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(21057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(21058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(21059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(21060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(21061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(21062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(21063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(21064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(21065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(21066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(21067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(21068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(21069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(21076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(21084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(21085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(21087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(21090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(21091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(21092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(21093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(21095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(21096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(21097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(21098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(21099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(21100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(21101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(21103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(21104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(21105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(21106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(21107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(21108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(21109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(21110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(21111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(21112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(21113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(21114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(21115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(21116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(21117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(21118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(21119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(21120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(21121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(21122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(21123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(21139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(21141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(21144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(21159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(21161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(21162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(21163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(21167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(21168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(21185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(21186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(21187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(21188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(21189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(21190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(21191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(21192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(21193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(21194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(21195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(21196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(21197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(21198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(21200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(21201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(21202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(21203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(21204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(21205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(21206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(21207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(21208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(21209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(21210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(21211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(21212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(21213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(21214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(21215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(21216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(21217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(21218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(21219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(21220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(21221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(21228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(21230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(21232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(21233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(21234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(21235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(21237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(21239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(21241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(21247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(21253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(21254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(21255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(21256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(21257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(21258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(21260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(21262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(21263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(21264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(21266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(21267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(21268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(21269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(21270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(21271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(21272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(21273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(21274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(21275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(21276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(21277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(21278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(21279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(21280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(21281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(21282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(21283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(21284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(21285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(21286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(21287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(21288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue24.pdf', 1, NULL),
(21289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(21290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue26.pdf', 1, NULL),
(21291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(21292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(21293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(21294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(21295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(21296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(21297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(21298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue32.pdf', 1, NULL),
(21299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(21300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue32.pdf', 1, NULL),
(21301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(21302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue32.pdf', 1, NULL),
(21303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(21304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue34.pdf', 1, NULL),
(21305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(21306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(21307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue37.pdf', 1, NULL),
(21308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(21309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue37.pdf', 1, NULL),
(21310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(21311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue37.pdf', 1, NULL),
(21312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(21313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue39.pdf', 1, NULL),
(21314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue40.pdf', 1, NULL),
(21315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue41.pdf', 1, NULL),
(21316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue42.pdf', 1, NULL),
(21317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue43.pdf', 1, NULL),
(21318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue44.pdf', 1, NULL),
(21319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue44.pdf', 1, NULL),
(21320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue45.pdf', 1, NULL),
(21321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue46.pdf', 1, NULL),
(21322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue45.pdf', 1, NULL),
(21323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue46.pdf', 1, NULL),
(21324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue47.pdf', 1, NULL),
(21325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue46.pdf', 1, NULL),
(21326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue47.pdf', 1, NULL),
(21327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue47.pdf', 1, NULL),
(21328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue48.pdf', 1, NULL),
(21329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue49.pdf', 1, NULL),
(21330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue50.pdf', 1, NULL),
(21331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue0.pdf', 1, NULL),
(21332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue50.pdf', 1, NULL),
(21333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue0.pdf', 1, NULL),
(21334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue0.pdf', 1, NULL),
(21335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(21336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(21347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(21350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(21352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(21354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(21363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(21365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(21370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(21371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(21372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(21373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(21374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(21375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(21376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(21377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(21379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(21380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(21381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(21382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(21383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(21384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(21385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(21386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(21387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(21388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(21389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(21390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(21391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(21392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(21393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(21394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(21395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(21396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(21397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(21398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(21399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(21400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(21401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(21402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue24.pdf', 1, NULL),
(21403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(21404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(21405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue25.pdf', 1, NULL),
(21406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(21407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(21408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(21409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(21410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(21411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(21412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(21413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(21414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue32.pdf', 1, NULL),
(21415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(21416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(21417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(21418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue36.pdf', 1, NULL),
(21419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue37.pdf', 1, NULL),
(21420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(21421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue36.pdf', 1, NULL),
(21422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue37.pdf', 1, NULL),
(21423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(21424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue37.pdf', 1, NULL),
(21425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(21426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(21427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(21431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(21433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(21434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(21435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(21438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(21440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(21442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(21444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(21448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(21450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(21451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(21452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(21454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(21455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(21456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(21457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(21458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(21459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(21460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(21461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(21462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(21463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(21464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(21473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(21475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(21493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(21494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(21495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(21496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(21498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(21499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(21500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(21501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(21502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(21503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(21504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(21505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(21511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(21513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(21526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(21527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(21530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(21531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(21532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(21533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(21542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(21556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(21557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(21558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(21559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(21560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(21561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(21562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(21563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(21564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(21565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(21567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(21569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(21571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(21572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(21573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(21577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(21579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(21586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(21589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(21590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(21592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(21593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(21594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(21595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(21596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(21598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(21600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(21601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(21602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(21603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(21604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(21605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(21606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(21607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(21608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(21609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(21610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(21611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(21612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(21613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(21614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(21615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(21616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(21617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(21618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(21619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(21620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(21621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(21622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(21623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(21624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(21625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(21626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(21627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(21628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(21629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue25.pdf', 1, NULL),
(21630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(21631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(21632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(21633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(21634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(21635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(21636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue30.pdf', 1, NULL),
(21637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(21638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(21639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(21640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue32.pdf', 1, NULL),
(21641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(21642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue32.pdf', 1, NULL),
(21643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(21644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(21645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(21646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue35.pdf', 1, NULL),
(21647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(21648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue35.pdf', 1, NULL),
(21649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(21650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(21651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue36.pdf', 1, NULL),
(21652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue37.pdf', 1, NULL),
(21653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(21654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue37.pdf', 1, NULL),
(21655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(21656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue37.pdf', 1, NULL),
(21657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue38.pdf', 1, NULL),
(21658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue39.pdf', 1, NULL),
(21659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue40.pdf', 1, NULL),
(21660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue41.pdf', 1, NULL),
(21661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue40.pdf', 1, NULL),
(21662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue40.pdf', 1, NULL),
(21663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue41.pdf', 1, NULL),
(21664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue40.pdf', 1, NULL),
(21665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue41.pdf', 1, NULL),
(21666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue41.pdf', 1, NULL),
(21667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue42.pdf', 1, NULL),
(21668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue43.pdf', 1, NULL),
(21669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue44.pdf', 1, NULL),
(21670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue45.pdf', 1, NULL),
(21671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(21673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(21675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(21676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(21678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(21679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(21690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(21694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(21695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(21696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(21698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(21699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(21700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(21701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(21702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(21703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(21704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(21705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(21706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(21707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(21708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(21709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(21710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(21711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(21712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(21713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(21714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(21715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(21716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(21717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(21718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(21719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(21720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(21721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(21722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(21723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(21724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue24.pdf', 1, NULL),
(21725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(21726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue26.pdf', 1, NULL),
(21727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(21728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(21729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(21730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(21731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(21732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(21733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(21734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(21735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(21736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(21737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(21738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(21739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue32.pdf', 1, NULL),
(21740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(21741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue32.pdf', 1, NULL),
(21742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(21743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue34.pdf', 1, NULL),
(21744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(21745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(21746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue34.pdf', 1, NULL),
(21747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(21748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(21749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue35.pdf', 1, NULL),
(21750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(21751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(21752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue36.pdf', 1, NULL),
(21753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue37.pdf', 1, NULL),
(21754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(21755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue38.pdf', 1, NULL),
(21756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue39.pdf', 1, NULL),
(21757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue40.pdf', 1, NULL),
(21758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue41.pdf', 1, NULL),
(21759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue42.pdf', 1, NULL),
(21760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue43.pdf', 1, NULL),
(21761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue44.pdf', 1, NULL),
(21762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue43.pdf', 1, NULL),
(21763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue44.pdf', 1, NULL),
(21764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue45.pdf', 1, NULL),
(21765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue44.pdf', 1, NULL),
(21766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue44.pdf', 1, NULL),
(21767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue45.pdf', 1, NULL),
(21768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue46.pdf', 1, NULL),
(21769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue47.pdf', 1, NULL),
(21770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue46.pdf', 1, NULL),
(21771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue47.pdf', 1, NULL),
(21772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(21773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(21790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(21791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(21792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(21793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(21794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(21795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(21796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(21797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(21798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(21799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(21800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(21802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(21803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(21804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(21805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(21806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(21807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(21808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(21809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(21810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(21811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(21812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(21813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(21814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(21815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(21824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(21826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(21828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(21829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(21833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(21835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(21837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(21843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(21844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(21845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(21846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(21847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(21849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(21851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(21852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(21853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(21854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(21856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(21868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(21870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(21871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(21873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(21875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(21877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(21879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(21881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(21883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(21886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(21900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(21904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(21905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(21906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(21911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(21913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(21914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(21916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(21922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(21925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(21926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(21928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(21929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(21930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(21932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(21933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(21935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(21937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(21938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(21939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(21940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(21941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(21942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(21943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(21944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(21945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(21946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(21947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(21948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(21949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(21950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(21951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(21952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(21953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(21954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(21955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(21956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(21957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(21958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(21959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(21960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(21961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(21962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(21963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(21964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(21965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(21966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(21967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue31.pdf', 1, NULL),
(21968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue32.pdf', 1, NULL),
(21969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(21970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue32.pdf', 1, NULL),
(21971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(21972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(21973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(21974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(21975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(21978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(21980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(21981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(21982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(21985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(21986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(21987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(21988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(21991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(21992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(21993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(21995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(21997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(21998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(21999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(22001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(22002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(22003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(22004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(22005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(22013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(22020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(22022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(22024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(22026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(22028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(22029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(22030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(22031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(22033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(22034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(22036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(22037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(22038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(22039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(22041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(22042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(22043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(22044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(22045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(22046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(22047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue25.pdf', 1, NULL),
(22048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(22049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(22050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(22051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(22052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(22053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(22054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(22055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(22056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(22057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(22058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(22059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(22060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(22061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(22062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue32.pdf', 1, NULL),
(22063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(22065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(22067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(22069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(22095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(22096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(22098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(22100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(22102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(22103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(22104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(22109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(22112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(22113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(22115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(22117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(22118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(22119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(22121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(22123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(22124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(22126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(22128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(22129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(22130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(22132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(22133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(22134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(22135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(22136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(22137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(22139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(22140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(22141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(22143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(22144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(22146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(22148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue20.pdf', 1, NULL),
(22150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(22151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue20.pdf', 1, NULL),
(22152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(22153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(22154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(22155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(22156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(22157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(22158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(22159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(22160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue24.pdf', 1, NULL),
(22161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(22162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(22163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue25.pdf', 1, NULL),
(22164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(22165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(22166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(22167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(22168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(22169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(22170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(22171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(22172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(22173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(22174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(22175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(22176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue32.pdf', 1, NULL),
(22177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(22178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue32.pdf', 1, NULL),
(22179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue32.pdf', 1, NULL),
(22180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(22182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(22186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(22192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(22194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(22196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(22198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(22203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(22205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(22207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(22208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(22209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(22211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(22213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(22215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(22221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(22222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(22223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(22224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(22225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(22227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(22229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(22231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(22233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(22235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(22236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(22238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(22240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(22242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(22244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(22246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(22247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(22249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(22250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(22252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(22253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(22254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(22255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(22256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue25.pdf', 1, NULL),
(22257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(22258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(22259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(22272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(22274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(22276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(22278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(22280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(22283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(22292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(22294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(22296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(22298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(22299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(22301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(22311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(22312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(22316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(22317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(22318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(22319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(22321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(22323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(22324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(22325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(22327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(22328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(22332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(22333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(22334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(22335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(22336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(22337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(22339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(22341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(22343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(22345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(22347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(22349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(22350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(22352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(22353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(22355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(22356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(22358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(22360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(22362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(22364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(22366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(22368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(22370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(22372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(22388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(22390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(22392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(22394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(22395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(22396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(22397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(22398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(22399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(22400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(22402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(22403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(22404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(22406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(22407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(22410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(22411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(22412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(22413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(22414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(22415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(22416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(22417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(22418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(22419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(22420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(22421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(22423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(22424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(22426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(22428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(22429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(22430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue20.pdf', 1, NULL),
(22433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue20.pdf', 1, NULL),
(22435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(22436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(22437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(22438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(22439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(22440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(22441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(22442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(22443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(22444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(22445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue26.pdf', 1, NULL),
(22446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(22447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(22448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(22449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(22450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(22451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(22452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(22453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(22454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(22455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue32.pdf', 1, NULL),
(22456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(22462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(22464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(22465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(22467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(22495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(22497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(22499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(22503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(22507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(22508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(22509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(22510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(22511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(22512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(22513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(22515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(22518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(22519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(22521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(22523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(22525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(22526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(22527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(22528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(22529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(22531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(22533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(22535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(22537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(22538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(22539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(22541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(22542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(22543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(22544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(22545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(22546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(22547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(22548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue25.pdf', 1, NULL),
(22549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(22550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(22551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(22552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(22553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(22554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(22555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(22556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(22557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(22559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(22573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(22577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(22578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(22585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(22586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(22589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(22590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(22591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(22593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(22595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(22597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(22599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(22601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(22603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(22605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(22607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(22608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(22609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(22610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(22611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(22612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(22613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(22614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(22615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(22616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(22617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(22618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(22619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(22620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(22622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(22624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(22625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(22626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(22627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(22628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(22629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(22631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(22633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(22634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(22636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(22637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(22638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(22639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(22640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(22641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(22642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(22643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(22644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(22645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(22646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(22647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(22648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(22649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(22650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(22651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(22652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(22653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(22654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(22655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(22656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(22657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(22658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue25.pdf', 1, NULL),
(22659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(22660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(22661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(22662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(22663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(22664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(22665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(22666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(22667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(22668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(22669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(22670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(22671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue32.pdf', 1, NULL),
(22672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue31.pdf', 1, NULL),
(22673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue32.pdf', 1, NULL),
(22674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(22675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue32.pdf', 1, NULL),
(22676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(22677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue34.pdf', 1, NULL),
(22678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue33.pdf', 1, NULL),
(22679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(22680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue33.pdf', 1, NULL),
(22681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(22682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue35.pdf', 1, NULL),
(22683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(22684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(22685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue36.pdf', 1, NULL),
(22686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(22687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(22688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(22689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue37.pdf', 1, NULL),
(22690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(22691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue39.pdf', 1, NULL),
(22692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(22693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue39.pdf', 1, NULL),
(22694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue40.pdf', 1, NULL),
(22695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue41.pdf', 1, NULL),
(22696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue42.pdf', 1, NULL),
(22697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue43.pdf', 1, NULL),
(22698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue44.pdf', 1, NULL),
(22699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue44.pdf', 1, NULL),
(22700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue45.pdf', 1, NULL),
(22701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue46.pdf', 1, NULL),
(22702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(22706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(22708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(22710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(22712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(22714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(22715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(22716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(22717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(22718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(22719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(22720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(22722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(22723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(22725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(22727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(22729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(22731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(22733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(22734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(22735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(22736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(22737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(22739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(22740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(22741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(22742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue20.pdf', 1, NULL),
(22744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(22745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(22746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(22747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(22748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(22749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(22750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(22751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(22752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(22753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(22754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue25.pdf', 1, NULL),
(22755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(22756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(22757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(22758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue29.pdf', 1, NULL),
(22759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(22760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(22761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(22762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(22763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue30.pdf', 1, NULL),
(22764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(22765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(22766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(22767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue32.pdf', 1, NULL),
(22768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(22769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue34.pdf', 1, NULL),
(22770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(22771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue36.pdf', 1, NULL),
(22772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue37.pdf', 1, NULL),
(22773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(22774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue37.pdf', 1, NULL),
(22775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(22776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue37.pdf', 1, NULL),
(22777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(22778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue37.pdf', 1, NULL),
(22779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(22780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue37.pdf', 1, NULL),
(22781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(22782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue39.pdf', 1, NULL),
(22783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue40.pdf', 1, NULL),
(22784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue41.pdf', 1, NULL),
(22785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue41.pdf', 1, NULL),
(22786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue42.pdf', 1, NULL),
(22787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue41.pdf', 1, NULL),
(22788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue42.pdf', 1, NULL),
(22789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue43.pdf', 1, NULL),
(22790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue44.pdf', 1, NULL),
(22791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue43.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(22792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue44.pdf', 1, NULL),
(22793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue45.pdf', 1, NULL),
(22794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue46.pdf', 1, NULL),
(22795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue46.pdf', 1, NULL),
(22796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue47.pdf', 1, NULL),
(22797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue47.pdf', 1, NULL),
(22798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue48.pdf', 1, NULL),
(22799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue49.pdf', 1, NULL),
(22800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(22811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(22818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(22820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(22824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(22826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(22828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(22831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(22832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(22833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(22834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(22835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(22836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(22838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(22839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(22840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(22842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(22856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(22858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(22860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(22861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(22863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(22867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(22872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(22873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(22874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(22882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(22883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(22884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(22885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(22886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(22889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(22891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(22893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(22894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(22895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(22896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(22897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(22899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(22901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(22902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(22904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(22905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(22906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(22907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(22908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(22909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(22910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(22911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(22912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(22913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(22914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(22915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(22916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(22917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue26.pdf', 1, NULL),
(22918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(22919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(22920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(22921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(22922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(22923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(22925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(22926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(22927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(22932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(22933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(22937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(22938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(22939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(22941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(22942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(22943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(22944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(22945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(22946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(22948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(22949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(22950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(22951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(22958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(22959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(22960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(22961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(22963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(22965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(22966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(22967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(22968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(22969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(22970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(22971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(22973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(22974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(22975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(22976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(22977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(22978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(22979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(22981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(22982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(22983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(22984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(22986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(22988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(22989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(22990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(22991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(22992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(22993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(22994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(22995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(22996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(22997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(22998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(22999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue24.pdf', 1, NULL),
(23000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(23001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(23013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(23015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(23017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(23019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(23030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(23033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(23035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(23036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(23037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(23039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(23041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(23042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(23044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(23047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(23049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(23050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(23051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(23053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(23054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(23055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(23056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(23057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue20.pdf', 1, NULL),
(23058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(23059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(23060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(23061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(23062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(23080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(23086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(23091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(23092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(23095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(23097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(23098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(23100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(23102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(23104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(23106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(23109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(23110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(23116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(23120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(23123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(23125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(23127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(23128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(23129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(23130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(23131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(23134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(23136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(23138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(23139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(23140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(23141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(23142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(23143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(23144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(23145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(23146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(23147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(23148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(23158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(23160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(23162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(23164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(23166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(23182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(23183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(23186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(23187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(23188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(23190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(23191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(23192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(23193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(23195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(23196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(23197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(23198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(23200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(23202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(23208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(23209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(23217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(23219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(23236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(23243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(23246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(23248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(23249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(23251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(23252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(23254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(23255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(23259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(23261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(23263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(23265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(23267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(23269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(23271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(23273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(23275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(23276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(23277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue20.pdf', 1, NULL),
(23278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(23279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(23280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(23281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue20.pdf', 1, NULL),
(23282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(23283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(23284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(23285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(23286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(23287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(23288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(23289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(23290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue26.pdf', 1, NULL),
(23291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(23292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(23293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(23302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(23304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(23306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(23315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(23317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(23319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(23329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(23334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(23336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(23340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(23341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(23344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(23345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(23346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(23347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(23348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(23349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(23350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(23352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(23354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(23355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(23357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(23359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(23361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(23363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(23365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(23367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(23371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(23376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(23378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(23380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(23382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(23387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(23389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(23391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(23394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(23396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(23400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(23402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(23403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(23404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(23405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(23407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(23408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(23409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(23410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(23411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(23412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(23414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(23416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(23427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(23429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(23435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(23438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(23439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(23441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(23444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(23446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(23447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(23449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(23450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(23452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(23454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(23455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(23464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(23466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(23468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(23480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(23481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(23482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(23483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(23484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(23485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(23487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(23489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(23490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(23491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(23493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(23494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(23495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(23496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(23497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(23498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(23499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(23500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(23501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(23502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(23503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(23506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(23508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(23510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(23511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(23513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(23515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(23525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(23527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(23529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(23532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(23533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(23534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(23535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(23537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(23538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(23540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(23541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(23542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(23544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(23546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(23549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(23551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(23553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(23555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(23557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(23559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(23561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(23563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(23566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(23568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(23579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(23582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(23583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(23584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(23585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(23588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(23589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(23591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(23593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(23594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(23596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(23598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(23599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(23600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(23601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(23602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(23603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(23604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(23605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(23606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(23607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(23609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(23610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(23611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(23612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(23613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(23614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(23615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(23616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(23617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(23618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(23619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(23620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(23621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(23622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(23623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue26.pdf', 1, NULL),
(23624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue25.pdf', 1, NULL),
(23625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(23626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue25.pdf', 1, NULL),
(23627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(23628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(23629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(23630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(23631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(23632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(23633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(23634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue32.pdf', 1, NULL),
(23635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(23636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(23637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(23652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(23659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(23664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(23666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(23668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(23670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(23671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(23672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(23673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(23674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(23675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(23677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(23679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(23680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(23681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(23682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(23684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(23686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(23688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(23692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(23694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(23695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(23696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(23697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(23698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(23699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(23700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(23701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(23702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(23703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(23704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue25.pdf', 1, NULL),
(23705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(23706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(23707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(23708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(23709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(23710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(23711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(23712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(23713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(23714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(23715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(23716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue29.pdf', 1, NULL),
(23717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(23718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(23719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue29.pdf', 1, NULL),
(23720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(23721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(23722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(23723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(23724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(23725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue29.pdf', 1, NULL),
(23726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(23727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(23728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(23729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue31.pdf', 1, NULL),
(23730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue32.pdf', 1, NULL),
(23731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue33.pdf', 1, NULL),
(23732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(23733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue33.pdf', 1, NULL),
(23734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(23735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(23736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(23737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(23738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(23739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue37.pdf', 1, NULL),
(23740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(23741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue37.pdf', 1, NULL),
(23742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(23743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue37.pdf', 1, NULL),
(23744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue38.pdf', 1, NULL),
(23745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue39.pdf', 1, NULL),
(23746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue40.pdf', 1, NULL),
(23747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue41.pdf', 1, NULL),
(23748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue42.pdf', 1, NULL),
(23749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue43.pdf', 1, NULL),
(23750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue44.pdf', 1, NULL),
(23751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue43.pdf', 1, NULL),
(23752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue44.pdf', 1, NULL),
(23753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue45.pdf', 1, NULL),
(23754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue44.pdf', 1, NULL),
(23755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue45.pdf', 1, NULL),
(23756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue46.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(23757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(23759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(23760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(23761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(23767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(23771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(23774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(23776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(23777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(23779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(23780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(23781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(23782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(23784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(23786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(23787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(23789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(23790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(23791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(23795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(23797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(23798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(23799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(23800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(23806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(23808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(23810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(23813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(23817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(23822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(23823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(23824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(23826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(23827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(23828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(23829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(23830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(23832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(23833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(23834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(23850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(23857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(23859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(23860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(23861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(23862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(23863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(23864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(23866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(23867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(23868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(23870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(23871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(23872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(23874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(23876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(23879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(23880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(23881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(23882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(23883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(23884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue20.pdf', 1, NULL),
(23885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(23886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue20.pdf', 1, NULL),
(23887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(23888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(23889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(23890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(23891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(23892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(23893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(23894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(23895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(23896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(23897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(23899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(23901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(23903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(23906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(23908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(23911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(23913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(23914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(23916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(23917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(23918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(23920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(23922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(23924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(23926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(23927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(23928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(23929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(23931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(23933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(23935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(23936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(23937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(23938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(23939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(23940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(23941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(23942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(23944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(23945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(23946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(23947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(23948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(23950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(23952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(23954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(23956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(23957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(23959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(23960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(23961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(23962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(23963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(23964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(23965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(23966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(23967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(23968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(23969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(23970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(23971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(23972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(23973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(23974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(23975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(23976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(23977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(23978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(23979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(23980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(23981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(23982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(23983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(23984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(23985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(23986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(23987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(23988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(23989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(23990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(23991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(23992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(23993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(23994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(23995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(23996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(23997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(23998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(23999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(24000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(24001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue24.pdf', 1, NULL),
(24002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(24003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(24004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue25.pdf', 1, NULL),
(24005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(24006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(24007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(24008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(24009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue30.pdf', 1, NULL),
(24010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(24011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(24012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue31.pdf', 1, NULL),
(24013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue32.pdf', 1, NULL),
(24014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue31.pdf', 1, NULL),
(24015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue32.pdf', 1, NULL),
(24016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue33.pdf', 1, NULL),
(24017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(24018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue36.pdf', 1, NULL),
(24019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue37.pdf', 1, NULL),
(24020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue36.pdf', 1, NULL),
(24021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue37.pdf', 1, NULL),
(24022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(24023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue37.pdf', 1, NULL),
(24024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(24025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue37.pdf', 1, NULL),
(24026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue38.pdf', 1, NULL),
(24027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue39.pdf', 1, NULL),
(24028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue40.pdf', 1, NULL),
(24029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue41.pdf', 1, NULL),
(24030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(24037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(24041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(24044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(24045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(24047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(24049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(24051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(24052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(24054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(24057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(24059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(24062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(24067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(24069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(24071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(24073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(24074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(24075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(24076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(24077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(24078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(24079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(24080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(24081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(24082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(24083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(24084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(24085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(24086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(24087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(24089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(24090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(24093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(24095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(24096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(24097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(24098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(24099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(24100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(24101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(24102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(24103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue25.pdf', 1, NULL),
(24104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(24105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(24106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(24107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(24108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(24109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(24110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(24111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue34.pdf', 1, NULL),
(24112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue33.pdf', 1, NULL),
(24113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(24114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue35.pdf', 1, NULL),
(24115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(24116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue37.pdf', 1, NULL),
(24117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(24118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue39.pdf', 1, NULL),
(24119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(24133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(24134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(24136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(24139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(24141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(24143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(24146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(24148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(24150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(24152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(24154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(24156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(24157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(24158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(24159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(24160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(24161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(24162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(24163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(24164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(24166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(24167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(24168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(24191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(24192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(24195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(24200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(24202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(24203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(24204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(24205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(24206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(24207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(24208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(24209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(24210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(24211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(24212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(24214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(24215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(24216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(24217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(24218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(24219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(24220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(24221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(24222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(24223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(24224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(24225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(24226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(24227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(24228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(24229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(24230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(24231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(24239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(24242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(24244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(24247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(24248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(24249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(24251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(24253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(24255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(24257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(24260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(24261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(24263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(24265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(24268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(24271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(24272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(24274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(24275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(24276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(24277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(24278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(24285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(24294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(24295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(24296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(24299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(24304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(24305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(24306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(24307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(24308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(24309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(24310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(24311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(24312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(24313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(24314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(24315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(24317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(24318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(24319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(24320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(24321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(24322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(24323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(24324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(24332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(24334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(24336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(24338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(24344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(24348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(24350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(24351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(24352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(24353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(24354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(24358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(24360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(24363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(24365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(24367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(24368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(24370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(24372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(24373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(24374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(24375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(24376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(24377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(24378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(24379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(24380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(24381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(24382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(24383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(24384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(24385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(24386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(24387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(24388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(24389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(24390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(24391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(24392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(24393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(24394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(24395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(24397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(24399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(24400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(24401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(24402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue24.pdf', 1, NULL),
(24403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(24404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(24405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(24406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(24407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(24408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(24409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(24410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(24411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(24412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(24421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(24423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(24425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(24427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(24428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(24429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(24432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(24434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(24436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(24439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(24444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(24446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(24448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(24450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(24451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(24452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(24453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(24454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(24455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(24456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(24457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(24459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(24460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(24461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(24463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(24465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(24466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(24467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(24468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(24469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(24470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(24471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(24472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(24473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(24474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue30.pdf', 1, NULL),
(24475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(24476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(24477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue31.pdf', 1, NULL),
(24478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue32.pdf', 1, NULL),
(24479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue33.pdf', 1, NULL),
(24480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(24481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(24482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue34.pdf', 1, NULL),
(24483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(24484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(24485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue35.pdf', 1, NULL),
(24486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(24487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(24488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue36.pdf', 1, NULL),
(24489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue37.pdf', 1, NULL),
(24490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue38.pdf', 1, NULL),
(24491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue39.pdf', 1, NULL),
(24492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue40.pdf', 1, NULL),
(24493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue41.pdf', 1, NULL),
(24494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue42.pdf', 1, NULL),
(24495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue43.pdf', 1, NULL),
(24496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue42.pdf', 1, NULL),
(24497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue43.pdf', 1, NULL),
(24498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue42.pdf', 1, NULL),
(24499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue43.pdf', 1, NULL),
(24500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue44.pdf', 1, NULL),
(24501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue45.pdf', 1, NULL),
(24502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue46.pdf', 1, NULL),
(24503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue48.pdf', 1, NULL),
(24504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(24509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(24518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(24529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(24533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(24535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(24538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(24544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(24548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(24550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(24554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(24556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(24557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(24558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(24559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(24560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(24561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(24562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(24563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(24564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24567, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24568, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24569, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24570, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24571, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24572, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24573, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(24574, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24575, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24576, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24577, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24578, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24579, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24580, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(24581, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24582, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(24583, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24584, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(24585, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24586, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24587, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24588, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24589, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(24590, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24591, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(24592, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(24593, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24594, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(24595, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(24596, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(24597, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(24598, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(24599, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(24600, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(24601, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(24602, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(24603, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(24604, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(24605, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24606, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(24607, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(24608, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(24609, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(24610, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(24611, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue26.pdf', 1, NULL),
(24612, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(24613, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24614, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24615, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24616, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24617, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24618, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24619, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24620, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24621, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24622, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24623, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24624, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24625, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24626, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24627, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24628, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24629, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24630, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24631, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24632, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24633, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(24634, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24635, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(24636, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(24637, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(24638, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(24639, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(24640, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(24641, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24642, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24643, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(24644, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24645, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(24646, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24647, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24648, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(24649, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24650, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24651, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24652, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24653, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(24654, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(24655, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(24656, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24657, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(24658, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(24659, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(24660, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(24661, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(24662, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(24663, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(24664, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(24665, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(24666, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24667, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24668, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24669, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24670, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24671, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24672, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24673, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24674, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24675, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24676, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24677, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24678, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24679, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24680, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24681, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24682, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(24683, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24684, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(24685, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24686, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(24687, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24688, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24689, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(24690, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24691, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(24692, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24693, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24694, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(24695, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(24696, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(24697, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(24698, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(24699, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24700, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24701, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24702, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(24703, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(24704, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(24705, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(24706, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(24707, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(24708, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24709, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(24710, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24711, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(24712, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24713, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(24714, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24715, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24716, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(24717, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24718, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(24719, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24720, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(24721, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(24722, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(24723, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(24724, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(24725, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24726, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24727, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(24728, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(24729, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(24730, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(24731, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(24732, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(24733, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24734, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24735, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24736, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24737, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24738, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24739, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24740, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24741, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24742, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(24743, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24744, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24745, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24746, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(24747, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24748, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24749, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(24750, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24751, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(24752, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24753, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(24754, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24755, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24756, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(24757, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(24758, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24759, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(24760, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24761, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(24762, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24763, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(24764, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24765, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(24766, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24767, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24768, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(24769, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(24770, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(24771, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(24772, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24773, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(24774, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24775, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(24776, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(24777, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(24778, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(24779, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24780, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(24781, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24782, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(24783, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(24784, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24785, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24786, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24787, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24788, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24789, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(24790, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(24791, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24792, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(24793, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24794, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(24795, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24796, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(24797, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(24798, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24799, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24800, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(24801, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24802, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24803, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24804, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(24805, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24806, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(24807, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24808, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(24809, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24810, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(24811, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24812, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(24813, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(24814, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24815, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(24816, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24817, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(24818, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24819, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(24820, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24821, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(24822, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(24823, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(24824, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(24825, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(24826, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(24827, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(24828, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24829, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(24830, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(24831, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(24832, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24833, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24834, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24835, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24836, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24837, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24838, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24839, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(24840, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24841, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(24842, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24843, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24844, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24845, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24846, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24847, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24848, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24849, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24850, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24851, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(24852, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24853, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(24854, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24855, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(24856, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24857, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(24858, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(24859, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24860, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(24861, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24862, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(24863, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24864, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(24865, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(24866, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(24867, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24868, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(24869, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24870, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24871, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(24872, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24873, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(24874, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24875, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(24876, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24877, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(24878, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24879, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(24880, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(24881, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(24882, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24883, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(24884, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(24885, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(24886, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(24887, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(24888, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(24889, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(24890, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24891, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(24892, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24893, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(24894, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24895, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(24896, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24897, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(24898, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24899, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(24900, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(24901, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(24902, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24903, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(24904, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(24905, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(24906, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(24907, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(24908, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(24909, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(24910, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(24911, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(24912, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue20.pdf', 1, NULL),
(24913, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(24914, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(24915, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(24916, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(24917, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(24918, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue20.pdf', 1, NULL),
(24919, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(24920, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(24921, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(24922, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(24923, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(24924, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(24925, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(24926, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(24927, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(24928, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(24929, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(24930, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(24931, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(24932, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(24933, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(24934, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(24935, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(24936, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(24937, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(24938, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(24939, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(24940, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(24941, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(24942, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(24943, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(24944, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue37.pdf', 1, NULL),
(24945, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(24946, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue39.pdf', 1, NULL),
(24947, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue40.pdf', 1, NULL),
(24948, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue40.pdf', 1, NULL),
(24949, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue41.pdf', 1, NULL),
(24950, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue42.pdf', 1, NULL),
(24951, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24952, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24953, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24954, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24955, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24956, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24957, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(24958, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24959, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(24960, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(24961, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24962, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(24963, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(24964, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(24965, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(24966, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(24967, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(24968, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(24969, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(24970, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(24971, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(24972, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24973, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(24974, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24975, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24976, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(24977, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(24978, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24979, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(24980, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(24981, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24982, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(24983, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(24984, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(24985, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(24986, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(24987, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(24988, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(24989, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(24990, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(24991, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(24992, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(24993, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(24994, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(24995, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(24996, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(24997, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(24998, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(24999, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(25000, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(25001, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(25002, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(25003, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(25004, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(25005, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(25006, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(25007, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(25008, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(25009, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(25010, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(25011, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(25012, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(25013, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(25014, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(25015, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(25016, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(25017, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(25018, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(25019, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(25020, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(25021, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(25022, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(25023, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(25024, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(25025, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(25026, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(25027, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(25028, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(25029, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue32.pdf', 1, NULL),
(25030, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(25031, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(25032, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue35.pdf', 1, NULL),
(25033, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue36.pdf', 1, NULL),
(25034, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue37.pdf', 1, NULL),
(25035, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue37.pdf', 1, NULL),
(25036, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue38.pdf', 1, NULL),
(25037, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(25038, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25039, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25040, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(25041, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25042, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(25043, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25044, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(25045, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(25046, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(25047, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(25048, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(25049, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(25050, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(25051, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(25052, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(25053, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(25054, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(25055, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(25056, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(25057, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(25058, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(25059, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(25060, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(25061, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(25062, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(25063, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(25064, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(25065, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(25066, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(25067, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(25068, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(25069, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(25070, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(25071, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(25072, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(25073, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(25074, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(25075, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(25076, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(25077, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(25078, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(25079, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(25080, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(25081, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(25082, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(25083, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(25084, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(25085, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(25086, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25087, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(25088, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25089, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25090, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(25091, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(25092, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(25093, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25094, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(25095, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25096, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(25097, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(25098, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(25099, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(25100, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(25101, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(25102, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(25103, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(25104, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(25105, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(25106, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(25107, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(25108, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(25109, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(25110, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(25111, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(25112, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(25113, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(25114, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(25115, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(25116, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(25117, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(25118, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(25119, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(25120, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(25121, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(25122, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(25123, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(25124, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(25125, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(25126, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(25127, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(25128, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(25129, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25130, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(25131, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25132, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(25133, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(25134, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(25135, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(25136, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(25137, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(25138, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(25139, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(25140, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(25141, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(25142, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(25143, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(25144, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(25145, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(25146, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(25147, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(25148, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(25149, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(25150, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(25151, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25152, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(25153, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(25154, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(25155, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(25156, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(25157, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(25158, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(25159, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(25160, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(25161, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(25162, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(25163, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(25164, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(25165, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(25166, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(25167, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(25168, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(25169, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(25170, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(25171, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(25172, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(25173, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(25174, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(25175, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(25176, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(25177, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(25178, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(25179, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(25180, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(25181, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(25182, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(25183, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(25184, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(25185, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(25186, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(25187, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(25188, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(25189, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(25190, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(25191, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(25192, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(25193, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(25194, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(25195, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(25196, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(25197, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(25198, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(25199, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(25200, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(25201, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(25202, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue32.pdf', 1, NULL),
(25203, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL);
INSERT INTO `config_branch` (`id`, `config`, `value`, `branch_id`, `lastchange`) VALUES
(25204, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(25205, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25206, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(25207, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25208, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(25209, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25210, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(25211, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25212, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(25213, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(25214, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(25215, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25216, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(25217, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(25218, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(25219, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(25220, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(25221, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(25222, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(25223, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(25224, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(25225, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(25226, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(25227, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(25228, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(25229, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(25230, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(25231, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(25232, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(25233, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(25234, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(25235, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(25236, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(25237, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(25238, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(25239, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(25240, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(25241, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(25242, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(25243, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(25244, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(25245, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(25246, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(25247, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(25248, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(25249, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(25250, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(25251, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(25252, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(25253, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(25254, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(25255, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(25256, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(25257, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(25258, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(25259, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue19.pdf', 1, NULL),
(25260, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(25261, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(25262, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(25263, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(25264, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(25265, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(25266, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(25267, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(25268, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(25269, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(25270, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(25271, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(25272, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25273, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25274, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(25275, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25276, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(25277, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(25278, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(25279, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(25280, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25281, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(25282, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(25283, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(25284, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(25285, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(25286, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25287, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25288, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(25289, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(25290, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(25291, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(25292, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(25293, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(25294, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(25295, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(25296, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(25297, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(25298, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(25299, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(25300, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(25301, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(25302, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(25303, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(25304, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(25305, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(25306, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(25307, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(25308, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(25309, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(25310, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(25311, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(25312, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(25313, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(25314, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(25315, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(25316, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(25317, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(25318, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(25319, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(25320, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(25321, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(25322, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(25323, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(25324, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(25325, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(25326, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(25327, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(25328, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(25329, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue20.pdf', 1, NULL),
(25330, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(25331, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(25332, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue21.pdf', 1, NULL),
(25333, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(25334, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(25335, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(25336, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(25337, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(25338, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(25339, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(25340, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(25341, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue24.pdf', 1, NULL),
(25342, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(25343, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(25344, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(25345, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue27.pdf', 1, NULL),
(25346, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(25347, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(25348, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue30.pdf', 1, NULL),
(25349, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(25350, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue30.pdf', 1, NULL),
(25351, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(25352, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(25353, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue31.pdf', 1, NULL),
(25354, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue30.pdf', 1, NULL),
(25355, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(25356, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue30.pdf', 1, NULL),
(25357, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(25358, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue32.pdf', 1, NULL),
(25359, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue33.pdf', 1, NULL),
(25360, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue34.pdf', 1, NULL),
(25361, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(25362, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25363, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25364, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(25365, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(25366, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25367, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25368, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(25369, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25370, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(25371, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(25372, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(25373, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(25374, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(25375, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(25376, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(25377, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(25378, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(25379, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(25380, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(25381, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(25382, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(25383, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(25384, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(25385, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(25386, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(25387, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(25388, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(25389, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(25390, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(25391, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(25392, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(25393, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(25394, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(25395, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(25396, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(25397, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(25398, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(25399, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(25400, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue20.pdf', 1, NULL),
(25401, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(25402, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue20.pdf', 1, NULL),
(25403, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(25404, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(25405, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(25406, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(25407, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(25408, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(25409, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue25.pdf', 1, NULL),
(25410, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(25411, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(25412, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue26.pdf', 1, NULL),
(25413, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue27.pdf', 1, NULL),
(25414, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue28.pdf', 1, NULL),
(25415, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(25416, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(25417, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue28.pdf', 1, NULL),
(25418, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue29.pdf', 1, NULL),
(25419, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue30.pdf', 1, NULL),
(25420, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue31.pdf', 1, NULL),
(25421, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(25422, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25423, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25424, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(25425, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25426, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(25427, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25428, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(25429, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25430, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(25431, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25432, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(25433, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(25434, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(25435, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(25436, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(25437, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(25438, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(25439, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(25440, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(25441, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(25442, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(25443, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(25444, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(25445, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(25446, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(25447, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(25448, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(25449, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue12.pdf', 1, NULL),
(25450, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(25451, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(25452, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(25453, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(25454, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue13.pdf', 1, NULL),
(25455, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(25456, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue15.pdf', 1, NULL),
(25457, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(25458, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(25459, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(25460, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(25461, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue18.pdf', 1, NULL),
(25462, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue19.pdf', 1, NULL),
(25463, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue20.pdf', 1, NULL),
(25464, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue21.pdf', 1, NULL),
(25465, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue22.pdf', 1, NULL),
(25466, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(25467, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue22.pdf', 1, NULL),
(25468, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue23.pdf', 1, NULL),
(25469, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(25470, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue23.pdf', 1, NULL),
(25471, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue24.pdf', 1, NULL),
(25472, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue25.pdf', 1, NULL),
(25473, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(25474, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25475, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25476, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(25477, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25478, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(25479, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(25480, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25481, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(25482, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25483, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(25484, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25485, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25486, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(25487, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25488, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(25489, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(25490, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue3.pdf', 1, NULL),
(25491, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(25492, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(25493, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(25494, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(25495, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue6.pdf', 1, NULL),
(25496, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(25497, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(25498, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(25499, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(25500, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(25501, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(25502, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(25503, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(25504, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(25505, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(25506, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(25507, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(25508, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(25509, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue11.pdf', 1, NULL),
(25510, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(25511, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(25512, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(25513, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(25514, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(25515, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(25516, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(25517, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(25518, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue16.pdf', 1, NULL),
(25519, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL),
(25520, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(25521, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue17.pdf', 1, NULL),
(25522, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue18.pdf', 1, NULL),
(25523, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue.pdf', 1, NULL),
(25524, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25525, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue.pdf', 1, NULL),
(25526, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(25527, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25528, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(25529, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue2.pdf', 1, NULL),
(25530, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue1.pdf', 1, NULL),
(25531, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25532, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue1.pdf', 1, NULL),
(25533, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue2.pdf', 1, NULL),
(25534, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(25535, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(25536, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(25537, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue3.pdf', 1, NULL),
(25538, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue4.pdf', 1, NULL),
(25539, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(25540, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue4.pdf', 1, NULL),
(25541, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue5.pdf', 1, NULL),
(25542, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(25543, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue5.pdf', 1, NULL),
(25544, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue6.pdf', 1, NULL),
(25545, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(25546, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(25547, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue7.pdf', 1, NULL),
(25548, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(25549, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue7.pdf', 1, NULL),
(25550, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue8.pdf', 1, NULL),
(25551, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(25552, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue8.pdf', 1, NULL),
(25553, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue9.pdf', 1, NULL),
(25554, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue10.pdf', 1, NULL),
(25555, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue9.pdf', 1, NULL),
(25556, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue10.pdf', 1, NULL),
(25557, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue11.pdf', 1, NULL),
(25558, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue12.pdf', 1, NULL),
(25559, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue13.pdf', 1, NULL),
(25560, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to Kitchen queues\\queue14.pdf', 1, NULL),
(25561, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(25562, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(25563, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue14.pdf', 1, NULL),
(25564, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue15.pdf', 1, NULL),
(25565, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue16.pdf', 1, NULL),
(25566, 'last_cli', 'queues\\sumatrapdf\\SumatraPDF.exe -print-to cashier queues\\queue17.pdf', 1, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `contacts`
--

CREATE TABLE `contacts` (
  `id` int(11) UNSIGNED NOT NULL,
  `is_customer` int(1) DEFAULT NULL,
  `is_supplier` int(1) DEFAULT NULL,
  `is_debtor` int(1) DEFAULT NULL,
  `is_creditor` int(1) DEFAULT NULL,
  `is_member` int(1) DEFAULT NULL,
  `is_stakeholder` int(1) DEFAULT NULL,
  `is_franchise` int(1) DEFAULT NULL,
  `is_franchisee` int(1) DEFAULT NULL,
  `is_agent` int(1) DEFAULT NULL,
  `is_prospect` int(1) DEFAULT NULL,
  `company_name` text,
  `company_registration` varchar(32) DEFAULT NULL,
  `contact_person` text,
  `contact_number` varchar(128) DEFAULT NULL,
  `credit_limit` decimal(20,2) DEFAULT NULL,
  `credit_term` int(11) DEFAULT NULL,
  `discount_limit` decimal(20,2) DEFAULT NULL,
  `rank` varchar(128) DEFAULT NULL,
  `email` varchar(128) DEFAULT NULL,
  `ic` varchar(128) DEFAULT NULL,
  `password` varchar(128) DEFAULT NULL,
  `introducer_ic` varchar(128) DEFAULT NULL,
  `address1` varchar(128) DEFAULT NULL,
  `address2` varchar(128) DEFAULT NULL,
  `city` varchar(128) DEFAULT NULL,
  `state` varchar(128) DEFAULT NULL,
  `zipcode` varchar(32) DEFAULT NULL,
  `country` varchar(128) DEFAULT NULL,
  `tel` varchar(128) DEFAULT NULL,
  `fax` varchar(128) DEFAULT NULL,
  `general_email` varchar(128) DEFAULT NULL,
  `terms` text,
  `description` text,
  `remarks` text,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `user_type` varchar(128) DEFAULT NULL,
  `user_verified` int(1) DEFAULT NULL,
  `loyalty_points` int(11) DEFAULT NULL,
  `current_session` varchar(128) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `assigned_to` varchar(128) DEFAULT NULL,
  `facebook_id` varchar(128) DEFAULT NULL,
  `nationality` varchar(128) DEFAULT NULL,
  `lastchange` varchar(128) DEFAULT NULL,
  `tax_no` varchar(255) DEFAULT NULL,
  `notes` text
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `contact_cases`
--

CREATE TABLE `contact_cases` (
  `id` int(11) UNSIGNED NOT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `subject` text,
  `description` text,
  `file_location` text,
  `reference_no` varchar(255) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `log_date` datetime DEFAULT NULL,
  `log_status` varchar(128) DEFAULT NULL,
  `log_user` varchar(128) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `assigned_to` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `contact_cases`
--

INSERT INTO `contact_cases` (`id`, `contact_id`, `subject`, `description`, `file_location`, `reference_no`, `status`, `added_on`, `added_by`, `modified_on`, `modified_by`, `log_date`, `log_status`, `log_user`, `division_id`, `assigned_to`) VALUES
(1, 1001, 'WEBSITE', 'asjdalsjdkalsjdlk asj dlkasdkljsad\nas\ndas\nd', NULL, NULL, 'Pending', '2012-09-25 17:48:00', 'admin', NULL, NULL, '2012-09-25 17:49:23', 'High', 'admin', NULL, NULL),
(3, 1057, 'First Order', 'The customer want 10ctn sample', NULL, NULL, 'High', '2012-09-25 21:22:46', 'admin', NULL, NULL, '2012-09-25 21:31:43', 'Medium', 'admin', NULL, NULL),
(4, 1057, 'Second Order', 'The was satisfy with the samples and he need 1300ctn\nBlue and Pink\nThe customer need the goods before 28-Oct-2012', NULL, NULL, 'High', '2012-09-25 21:58:11', 'admin', NULL, NULL, '2012-09-25 22:00:13', 'Low', 'admin', NULL, NULL),
(5, 1062, 'Delay In Sending item', 'They are regretful to inform us that they have failed to meet the time for sending the items..', NULL, NULL, 'High', '2012-10-27 13:04:00', 'admin', NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6, 1015, 'Issues On PlexCloud&PlexCMS;', '1) Can''t change Allowed Domains field', NULL, NULL, 'Pending', '2012-11-16 12:00:54', 'admin', NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7, 1109, 'Customer needs Support on System', 'Customer requires sadasd; sad;ask ;lasd', NULL, NULL, 'Pending', '2012-12-30 20:57:31', 'admin', NULL, NULL, '2012-12-30 20:59:16', 'Low', 'admin', NULL, NULL),
(8, 1087, 'Complaints on Poor Service', 'Customer was not satisfied with our web services.', NULL, NULL, 'Closed Solved', '2012-12-30 22:48:03', 'admin', '2013-02-25 14:09:30', 'admin', '2012-12-30 22:49:09', 'Low', 'admin', NULL, NULL),
(9, 1087, 'Problem 2332', '', NULL, NULL, 'Pending', '2013-02-25 13:47:26', 'admin', NULL, NULL, '2013-02-25 13:47:42', 'Low', 'admin', NULL, NULL),
(10, 1141, 'Enhancement: To print POS receipt in PDF format', 'Halagel is requesting for a new feature whereby a cashier can print the receipt in pdf format. This would be an issue for POS with thermal printer setting since the data format is raw.', NULL, NULL, 'Pending', '2013-12-04 10:39:18', 'admin', NULL, NULL, '2013-12-04 10:40:00', 'High', 'admin', NULL, NULL),
(11, 1093, 'Claims for Breaches of Contracts', '', NULL, NULL, 'Pending', '2013-12-25 14:50:17', 'admin', NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12, 1139, 'Halagel: Inventory Module Enhancement', 'Features:\n\n1) New privilege feature to hide "cost"\n2) Hide Ranking info in POS', '', '', 'Medium', '2014-01-06 14:39:33', 'admin', NULL, NULL, '2014-01-06 14:39:33', 'Medium', 'admin', NULL, NULL),
(13, 1139, 'Change HC Branch Name', 'Halagel Center Sungai Petani requested to change it''s name to Halatrade and the information to be reflected in all documents generated by Plexcloud', '', '', 'Medium', '2014-01-06 14:56:36', 'admin', NULL, NULL, '2014-01-06 14:56:36', 'Medium', 'admin', NULL, NULL),
(14, 1150, 'Clearing Plexcloud After Deploying', '1. Inventory Overview not cleared\n2. Inventory > Purchase Order and Purchase Request not cleared too', '', '', 'Pending', '2014-02-18 14:44:04', 'admin', NULL, NULL, '2014-02-18 14:44:04', 'Pending', 'admin', NULL, NULL),
(15, 1150, 'Logo Not Appearing', 'Tried adding the logo through settings, after "Saving" it does not appear.. ', '', '', 'Closed Solved', '2014-02-18 15:52:18', 'admin', '2014-02-18 16:56:36', 'admin', '2014-02-18 16:56:36', 'Pending', 'admin', NULL, NULL),
(16, 1150, 'Cost Unit Lost', 'Team please check on Item Cost, there''s a bug, when i key in the Cost it does not appear. ', '', '', 'Closed Solved', '2014-02-25 11:43:30', 'admin', '2014-03-09 12:02:10', 'shamiradnan', '2014-03-09 12:02:10', 'Pending', 'admin', NULL, NULL),
(17, 1150, 'Inventory Overview Not Showing Current Inventory Value and Items', 'Inventory Overview Not Showing Current Inventory Value and Items', '', '', 'Closed Solved', '2014-02-25 11:57:53', 'shamiradnan', '2014-03-09 12:05:04', 'shamiradnan', '2014-03-09 12:05:04', 'Pending', 'shamiradnan', NULL, NULL),
(18, 1015, 'Digital Signature Disclaimer', 'Add digital signature disclaimer at all plexcloud generated documents', '', '', 'Closed Solved', '2014-03-02 09:29:40', 'azad', '2014-03-02 23:42:20', 'azad', '2014-03-02 23:42:20', 'Pending', 'azad', NULL, NULL),
(19, 1139, '[Inventory] PO is not properly processed', 'I think there is a bug in the current code when handling PO. If user was to change the status between Partially Received or Received, the stock quantity is not reflected because inv->po_items_received is not invoked in inventory/PO_update_status( ajax call in po_view.php).', '', '', 'Medium', '2014-03-14 10:32:27', 'azad', '2014-03-14 10:58:11', 'azad', '2014-03-14 10:58:11', 'Pending', 'azad', NULL, NULL),
(20, 1139, '[Contacts] Added Case ID and Assignee field', 'It is important to have a unique reference ID when referring to any case ID. ', '', '', 'High', '2014-03-14 10:53:57', 'azad', '2014-03-14 10:57:51', 'azad', '2014-03-14 10:57:51', 'Pending', 'azad', NULL, NULL),
(21, 1139, '[Inventory] zeroinventory to delete all PO,PR and stock movement', 'Should zeroinventory clear PO,PR and Stock Movement too?', '', '', 'Medium', '2014-03-14 11:04:37', 'azad', NULL, NULL, '2014-03-14 11:04:37', 'Medium', 'azad', NULL, NULL),
(22, 1150, 'Permissioning Does not Reflect', 'Edited the User , "Manager" Role in Permission but does not Reflect to the System', '', '', 'Closed Solved', '2014-03-19 08:21:20', 'shamiradnan', '2014-03-19 16:19:30', 'shamiradnan', '2014-03-19 16:19:30', 'High', 'shamiradnan', NULL, NULL),
(23, 1150, 'Adding Item Cost Bug', 'Creating New Item , the "Cost" input wont stick after saving. \n\nNeed to go in and edit and Save then it will stick.', '', '', 'Medium', '2014-03-19 16:21:02', 'shamiradnan', NULL, NULL, '2014-03-19 16:21:02', 'Medium', 'shamiradnan', NULL, NULL),
(24, 1150, 'Inventory > Stock Movement : Cant Delete listed items', 'Cant delete items listed in Stock Movement', '', '', 'Medium', '2014-03-19 16:22:08', 'shamiradnan', NULL, NULL, '2014-03-19 16:22:08', 'Medium', 'shamiradnan', NULL, NULL),
(25, 1150, 'Permission : No Save Button', 'Save button not included here. ', '', '', 'Low', '2014-03-19 16:22:43', 'shamiradnan', NULL, NULL, '2014-03-19 16:22:43', 'Low', 'shamiradnan', NULL, NULL),
(26, 1150, 'Report Request', 'Kas Baiduri request 3 kind of Reports :\nDaily , Weekly and Mothly', '', '', 'Low', '2014-03-19 16:31:04', 'shamiradnan', NULL, NULL, '2014-03-19 16:31:04', 'Low', 'shamiradnan', NULL, NULL),
(27, 1139, 'Invoice Edit Bugs', 'Shafiq, I have encountered two bugs in invoice editing process\n\n1) Saved "Tax information" after Invoice creation is incorrect\n2) Editing invoice will never work because $id in model/sale {edit_invoice} is corrupted', '', '', 'High', '2014-04-04 00:44:03', 'azad', '2014-04-04 00:54:47', 'azad', '2014-04-04 00:54:47', 'Pending', 'azad', NULL, NULL),
(28, 1, 'problen', ' vfbnnhg', '', '', 'Pending', '2015-01-22 15:52:53', 'admin', NULL, NULL, '2015-01-22 15:52:53', 'Pending', 'admin', NULL, NULL),
(31, 13, 'TEST', 'TEST', '', '', 'Pending', '2015-12-27 10:59:54', 'admin', NULL, NULL, '2015-12-27 10:59:54', 'Pending', 'admin', NULL, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `contact_logs`
--

CREATE TABLE `contact_logs` (
  `id` int(11) UNSIGNED NOT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `case_id` int(11) DEFAULT NULL,
  `subject` varchar(128) DEFAULT NULL,
  `description` text,
  `status` varchar(128) DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `file` varchar(255) DEFAULT NULL,
  `current_file` int(1) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `contact_logs`
--

INSERT INTO `contact_logs` (`id`, `contact_id`, `case_id`, `subject`, `description`, `status`, `added_by`, `added_on`, `modified_by`, `modified_on`, `file`, `current_file`) VALUES
(1, 4, 2, 'Work Progress', 'Customer requesting progress on work...', 'Low', 'admin', '2012-06-17 09:12:22', NULL, NULL, NULL, NULL),
(2, 4, 1, 'Customer Sent PC', 'Lenova \ndsa\nd\nasd\n', 'High', 'admin', '2012-06-17 22:20:22', NULL, NULL, NULL, NULL),
(3, 4, 2, 'Customer Marah', 'Tak hantaq gheja lagi. Buat cepat cepat', 'High', 'admin', '2012-06-17 23:52:20', NULL, NULL, NULL, NULL),
(4, 4, 1, 'customer follow up', 'asdasd asjdl askd', 'Low', 'admin', '2012-06-19 13:47:40', NULL, NULL, NULL, NULL),
(5, 1001, 1, 'Customer Submitted Contents', 'Contents submitted partially.', 'Low', 'admin', '2012-09-25 17:48:48', NULL, NULL, NULL, NULL),
(6, 1001, 1, 'Site must be up', 'Customer wants to see the wbesite up on the server. URGENTLY', 'High', 'admin', '2012-09-25 17:49:23', NULL, NULL, NULL, NULL),
(7, 1057, 3, 'The customer bankin the money for samples', 'Bankin slip number 6775866', 'Low', 'admin', '2012-09-25 21:26:43', NULL, NULL, NULL, NULL),
(8, 1057, 3, 'I''ve already give DHL tracking to customer', 'DHL TRACKING NUMBER #64653475435', 'Medium', 'admin', '2012-09-25 21:31:43', NULL, NULL, NULL, NULL),
(9, 1057, 4, 'I''ve inform the production line', 'I''ve inform mr.gum about the order and the urgencies as well', 'Low', 'admin', '2012-09-25 22:00:13', NULL, NULL, NULL, NULL),
(10, 1109, 7, 'I am on it', 'working on the updates and will call the customer asap.', 'Low', 'admin', '2012-12-30 20:58:13', NULL, NULL, NULL, NULL),
(11, 1109, 7, 'customer is mad', 'support was not satisfactory', 'High', 'admin', '2012-12-30 20:58:38', NULL, NULL, NULL, NULL),
(12, 1109, 7, 'case resolved', 'i have spoken to the customer and offered a good deal that is within our capacity.', 'Low', 'admin', '2012-12-30 20:59:16', NULL, NULL, NULL, NULL),
(13, 1087, 8, 'Issue is noted', 'Contacted the client and offered a deal within our capacity. Client is yet to respond.', 'Low', 'admin', '2012-12-30 22:48:53', NULL, NULL, NULL, NULL),
(14, 1087, 8, 'Customer is happy', 'Case can be closed. ', 'Low', 'admin', '2012-12-30 22:49:09', NULL, NULL, NULL, NULL),
(15, 1087, 9, 'Supplier belum datang ', 'sadasdsa das das', 'Low', 'admin', '2013-02-25 13:47:42', NULL, NULL, NULL, NULL),
(16, 1141, 10, 'test', 'test', 'High', 'admin', '2013-12-04 10:39:59', NULL, NULL, NULL, NULL),
(17, 1139, 12, 'Halagel: Inventory Module Enhancement', 'Features:\n\n1) New privilege feature to hide "cost"\n2) Hide Ranking info in POS', 'Medium', 'admin', '2014-01-06 14:39:33', NULL, NULL, NULL, NULL),
(18, 1139, 12, 'Email Sent to Halagel', 'Confirmation on features to be added.', 'Low', 'admin', '2014-01-06 14:50:57', NULL, NULL, 'Screen_Shot_2014-01-06_at_2.49_.08_PM_.png', NULL),
(19, 1139, 13, 'Change HC Branch Name', 'Halagel Center Sungai Petani requested to change it''s name to Halatrade and the information to be reflected in all documents generated by Plexcloud', 'Medium', 'admin', '2014-01-06 14:56:36', NULL, NULL, NULL, NULL),
(20, 1150, 14, 'Clearing Plexcloud After Deploying', '1. Inventory Overview not cleared\n2. Inventory > Purchase Order and Purchase Request not cleared too', 'Pending', 'admin', '2014-02-18 14:44:04', NULL, NULL, NULL, NULL),
(21, 1150, 14, 'Zeroinventory should cover this', 'TRUNCATE TABLE inventory_stock_quantities\n', 'Low', 'admin', '2014-02-18 14:46:23', NULL, NULL, NULL, NULL),
(22, 1150, 15, 'Logo Not Appearing', 'Tried adding the logo through settings, after "Saving" it does not appear.. ', 'Pending', 'admin', '2014-02-18 15:52:18', NULL, NULL, NULL, NULL),
(23, 1150, 15, '[Resolved]', 'When deploying plexcloud to a new hosting, need to ensure /assets folder is also uploaded. Also, ensure the folder''s permission is writable.', 'High', 'admin', '2014-02-21 11:57:49', NULL, NULL, NULL, NULL),
(24, 1150, 16, 'Cost Unit Lost', 'Team please check on Item Cost, there''s a bug, when i key in the Cost it does not appear. ', 'Pending', 'admin', '2014-02-25 11:43:30', NULL, NULL, NULL, NULL),
(25, 1150, 17, 'Inventory Overview Not Showing Current Inventory Value and Items', 'Inventory Overview Not Showing Current Inventory Value and Items', 'Pending', 'shamiradnan', '2014-02-25 11:57:53', NULL, NULL, NULL, NULL),
(26, 1015, 18, 'Digital Signature Disclaimer', 'Add digital signature disclaimer at all plexcloud generated documents', 'Pending', 'azad', '2014-03-02 09:29:40', NULL, NULL, NULL, NULL),
(27, 1015, 18, 'Table effected', 'Config:\nAdded these rows\n1) so_footer\n2) quote_footer\n3) po_footer\n4) online_sales_footer\n5) member_footer\n6) invoice_footer\n7)do_footer\n8)dn_footer\n9)cn_footer', 'Low', 'azad', '2014-03-02 09:32:53', NULL, NULL, NULL, NULL),
(28, 1015, 18, 'Missing T&C for Purchase Request', 'I have added pr_tnc to the config list as well\n', 'Low', 'azad', '2014-03-02 23:23:47', NULL, NULL, NULL, NULL),
(29, 1015, 18, 'Added  new config field', 'pr_footer', 'Low', 'azad', '2014-03-02 23:25:20', NULL, NULL, NULL, NULL),
(30, 1015, 18, 'Files Affected', 'Shafiq, please help to integrate these files from Plexsol Plexcloud sites to your golden copy', 'High', 'azad', '2014-03-02 23:32:16', NULL, NULL, 'Screen_Shot_2014-03-02_at_11.28_.44_PM_.png', NULL),
(31, 1015, 18, 'New config fields', 'Shafiq, these are the new fields . \nDo note that i have also added a new config for "pr_tnc" since it is missing.', 'High', 'azad', '2014-03-02 23:35:30', NULL, NULL, 'Screen_Shot_2014-03-02_at_11.30_.32_PM_.png', NULL),
(32, 1139, 19, '[Inventory] PO is not properly processed', 'I think there is a bug in the current code when handling PO. If user was to change the status between Partially Received or Received, the stock quantity is not reflected because inv->po_items_received is not invoked in inventory/PO_update_status( ajax call in po_view.php).', 'Pending', 'azad', '2014-03-14 10:32:27', NULL, NULL, NULL, NULL),
(33, 1139, 19, 'Solution Proposal', '1) Need to invoke po_items_received when user changes status to "Partially Received" or "Received"\n2) Clear form_warning if ajax call is successful.\n\nAffected Files\n1) views/inventory/po-view.php [ po_view.png ]\n2) controllers/inventory.php [ inventory.png ]', 'High', 'azad', '2014-03-14 10:39:07', NULL, NULL, NULL, NULL),
(34, 1139, 19, 'Fix for po_view.php', '1) Serialize form\n2) Append status to ajax "data"\n3) set form_warning to false', 'High', 'azad', '2014-03-14 10:40:20', NULL, NULL, 'po_view.png', NULL),
(35, 1139, 19, 'Fix for inventory.php', '1) check if status is either "Partially Received" or "Received", invoke inv->po_items_received\n', 'High', 'azad', '2014-03-14 10:41:28', NULL, NULL, 'inventory.png', NULL),
(36, 1139, 20, '[Contacts] Added Case ID and Assignee field', 'It is important to have a unique reference ID when referring to any case ID. ', 'Pending', 'azad', '2014-03-14 10:53:57', NULL, NULL, NULL, NULL),
(37, 1139, 20, 'Affected Files', '1) view/contacts/logs.php\n2) view/contacts/case-filtered.php\n3) view/contacts/case-list.php\n\nThe modified files are available at plexsol''s plexcloud', 'High', 'azad', '2014-03-14 10:55:42', NULL, NULL, NULL, NULL),
(38, 1139, 19, 'Modified files', 'Modified files are only available at bubbles''s plexcloud. If you are okay with my changes, i will integrate them to plexsol''s plexcloud', 'High', 'azad', '2014-03-14 10:56:40', NULL, NULL, NULL, NULL),
(39, 1139, 21, '[Inventory] zeroinventory to delete all PO,PR and stock movement', 'Should zeroinventory clear PO,PR and Stock Movement too?', 'Medium', 'azad', '2014-03-14 11:04:37', NULL, NULL, NULL, NULL),
(40, 1150, 22, 'Permissioning Does not Reflect', 'Edited the User , "Manager" Role in Permission but does not Reflect to the System', 'High', 'shamiradnan', '2014-03-19 08:21:20', NULL, NULL, NULL, NULL),
(41, 1150, 23, 'Adding Item Cost Bug', 'Creating New Item , the "Cost" input wont stick after saving. \n\nNeed to go in and edit and Save then it will stick.', 'Medium', 'shamiradnan', '2014-03-19 16:21:02', NULL, NULL, NULL, NULL),
(42, 1150, 24, 'Inventory > Stock Movement : Cant Delete listed items', 'Cant delete items listed in Stock Movement', 'Medium', 'shamiradnan', '2014-03-19 16:22:08', NULL, NULL, NULL, NULL),
(43, 1150, 25, 'Permission : No Save Button', 'Save button not included here. ', 'Low', 'shamiradnan', '2014-03-19 16:22:43', NULL, NULL, NULL, NULL),
(44, 1150, 26, 'Report Request', 'Kas Baiduri request 3 kind of Reports :\nDaily , Weekly and Mothly', 'Low', 'shamiradnan', '2014-03-19 16:31:04', NULL, NULL, NULL, NULL),
(45, 1150, 25, 'Save button has been added', 'Save button has been added in plexcloud MASTER. To discuss time to patch. ', 'Low', 'shafiq', '2014-03-20 10:16:20', NULL, NULL, 'Screen_Shot_2014-03-20_at_10.15_.05_AM_.png', NULL),
(46, 1150, 24, 'Delete implemented', 'Delete is working perfectly in MASTER copy. To discuss time to patch.', 'Low', 'shafiq', '2014-03-20 10:17:22', NULL, NULL, NULL, NULL),
(47, 1139, 27, 'Invoice Edit Bugs', 'Shafiq, I have encountered two bugs in invoice editing process\n\n1) Saved "Tax information" after Invoice creation is incorrect\n2) Editing invoice will never work because $id in model/sale {edit_invoice} is corrupted', 'Pending', 'azad', '2014-04-04 00:44:03', NULL, NULL, NULL, NULL),
(48, 1139, 27, 'Details on Bug (1) Saved "Tax information" after invoice creation is incorrect', '1) Saved "Tax information" after invoice creation is incorrect\n\nThis bug is caused by two factors\na) invoice-add.php & invoice-edit.php is not cosistent\n    Invoice-add.php stores ONLY TAX ID whereas invoice-edit.php expects "tax:.{TAXID}. It has a trailing string "tax"\nb) The checking on whether radio button TAX to be check upon invoice editing is incorrect. \n     It should be checking whether the tax amount is "0.00" . This is based on assumption of shafiq''s logic determining tax validity. \n\nAffected file : views/sales/invoice-edit.php [ please refer to the document attached ]\n', 'High', 'azad', '2014-04-04 01:04:18', NULL, NULL, NULL, NULL),
(49, 1139, 27, 'Trying to re-upload file', 'Trying to re-upload file', 'High', 'azad', '2014-04-04 01:08:05', NULL, NULL, NULL, NULL),
(51, 1139, 27, 'Can''t upload php file on plexcloud', 'Shafiq, aku tak sempat nk go thru your codes on file upload filtering. i couldn''t upload php file even after changing the extension file. So, i will attached the files on FB. \n\nThe reason i am changing the method to share my changes with you is because my changes may not be accepted thus asking you fetch them from our plexcloud server is very dangerous, in the case i did not revert them back', 'Medium', 'azad', '2014-04-04 01:13:50', NULL, NULL, NULL, NULL),
(52, 1139, 27, 'Detail on Bug (2) Editing Invoice will never work', 'This is because in the edit_invoice function, $id is overwritten when looping the post(''tax'') array.\n\nAffected file: models/sale.php [ line 476 ] ', 'High', 'azad', '2014-04-04 01:16:10', NULL, NULL, NULL, NULL),
(53, 1, 28, 'problen', ' vfbnnhg', 'Pending', 'admin', '2015-01-22 15:52:53', NULL, NULL, NULL, NULL),
(54, 1, 28, 'fbfgnf', 'b bn ', 'High', 'admin', '2015-01-22 15:53:22', NULL, NULL, NULL, NULL),
(55, 0, 29, '123', '', 'Pending', 'admin', '2015-06-09 22:07:03', NULL, NULL, NULL, NULL),
(56, 0, 29, 'File Location Update', 'File location changed to MR HENG', '', 'admin', '2015-06-09 22:07:14', NULL, NULL, NULL, NULL),
(57, 0, 29, 'File Location Update', 'File location changed to RETURN TO FOLDER', '', 'admin', '2015-06-09 22:07:22', NULL, NULL, NULL, NULL),
(58, 9, 30, 'RFQ FOR COFFEE BWANS', '', 'Pending', 'admin', '2015-08-04 10:29:55', NULL, NULL, NULL, NULL),
(59, 9, 30, 'CONTACTED THE CUSTOMER`', 'CUSTOMER HAS NOT YET CONFIRMED THE QUANTITY OF PURCA|HASE', 'Low', 'admin', '2015-08-04 10:31:17', NULL, NULL, NULL, NULL),
(60, 9, 30, 'CUSTOMER RESPONDED', 'CONFIRMED THE QUANTITY', 'High', 'admin', '2015-08-04 10:32:01', NULL, NULL, NULL, NULL),
(61, 13, 31, 'TEST', 'TEST', 'Pending', 'admin', '2015-12-27 10:59:54', NULL, NULL, NULL, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `countries`
--

CREATE TABLE `countries` (
  `id` int(11) NOT NULL,
  `name` varchar(128) DEFAULT NULL,
  `prefix` text
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `countries`
--

INSERT INTO `countries` (`id`, `name`, `prefix`) VALUES
(1, 'United States', 'US'),
(2, 'Canada', 'CA'),
(3, 'Afghanistan', 'AF'),
(4, 'Albania', 'AL'),
(5, 'Algeria', 'DZ'),
(6, 'American Samoa', 'DS'),
(7, 'Andorra', 'AD'),
(8, 'Angola', 'AO'),
(9, 'Anguilla', 'AI'),
(10, 'Antarctica', 'AQ'),
(11, 'Antigua and/or Barbuda', 'AG'),
(12, 'Argentina', 'AR'),
(13, 'Armenia', 'AM'),
(14, 'Aruba', 'AW'),
(15, 'Australia', 'AU'),
(16, 'Austria', 'AT'),
(17, 'Azerbaijan', 'AZ'),
(18, 'Bahamas', 'BS'),
(19, 'Bahrain', 'BH'),
(20, 'Bangladesh', 'BD'),
(21, 'Barbados', 'BB'),
(22, 'Belarus', 'BY'),
(23, 'Belgium', 'BE'),
(24, 'Belize', 'BZ'),
(25, 'Benin', 'BJ'),
(26, 'Bermuda', 'BM'),
(27, 'Bhutan', 'BT'),
(28, 'Bolivia', 'BO'),
(29, 'Bosnia and Herzegovina', 'BA'),
(30, 'Botswana', 'BW'),
(31, 'Bouvet Island', 'BV'),
(32, 'Brazil', 'BR'),
(33, 'British lndian Ocean Territory', 'IO'),
(34, 'Brunei Darussalam', 'BN'),
(35, 'Bulgaria', 'BG'),
(36, 'Burkina Faso', 'BF'),
(37, 'Burundi', 'BI'),
(38, 'Cambodia', 'KH'),
(39, 'Cameroon', 'CM'),
(40, 'Cape Verde', 'CV'),
(41, 'Cayman Islands', 'KY'),
(42, 'Central African Republic', 'CF'),
(43, 'Chad', 'TD'),
(44, 'Chile', 'CL'),
(45, 'China', 'CN'),
(46, 'Christmas Island', 'CX'),
(47, 'Cocos (Keeling) Islands', 'CC'),
(48, 'Colombia', 'CO'),
(49, 'Comoros', 'KM'),
(50, 'Congo', 'CG'),
(51, 'Cook Islands', 'CK'),
(52, 'Costa Rica', 'CR'),
(53, 'Croatia (Hrvatska)', 'HR'),
(54, 'Cuba', 'CU'),
(55, 'Cyprus', 'CY'),
(56, 'Czech Republic', 'CZ'),
(57, 'Denmark', 'DK'),
(58, 'Djibouti', 'DJ'),
(59, 'Dominica', 'DM'),
(60, 'Dominican Republic', 'DO'),
(61, 'East Timor', 'TP'),
(62, 'Ecudaor', 'EC'),
(63, 'Egypt', 'EG'),
(64, 'El Salvador', 'SV'),
(65, 'Equatorial Guinea', 'GQ'),
(66, 'Eritrea', 'ER'),
(67, 'Estonia', 'EE'),
(68, 'Ethiopia', 'ET'),
(69, 'Falkland Islands (Malvinas)', 'FK'),
(70, 'Faroe Islands', 'FO'),
(71, 'Fiji', 'FJ'),
(72, 'Finland', 'FI'),
(73, 'France', 'FR'),
(74, 'France, Metropolitan', 'FX'),
(75, 'French Guiana', 'GF'),
(76, 'French Polynesia', 'PF'),
(77, 'French Southern Territories', 'TF'),
(78, 'Gabon', 'GA'),
(79, 'Gambia', 'GM'),
(80, 'Georgia', 'GE'),
(81, 'Germany', 'DE'),
(82, 'Ghana', 'GH'),
(83, 'Gibraltar', 'GI'),
(84, 'Greece', 'GR'),
(85, 'Greenland', 'GL'),
(86, 'Grenada', 'GD'),
(87, 'Guadeloupe', 'GP'),
(88, 'Guam', 'GU'),
(89, 'Guatemala', 'GT'),
(90, 'Guinea', 'GN'),
(91, 'Guinea-Bissau', 'GW'),
(92, 'Guyana', 'GY'),
(93, 'Haiti', 'HT'),
(94, 'Heard and Mc Donald Islands', 'HM'),
(95, 'Honduras', 'HN'),
(96, 'Hong Kong', 'HK'),
(97, 'Hungary', 'HU'),
(98, 'Iceland', 'IS'),
(99, 'India', 'IN'),
(100, 'Indonesia', 'ID'),
(101, 'Iran (Islamic Republic of)', 'IR'),
(102, 'Iraq', 'IQ'),
(103, 'Ireland', 'IE'),
(104, 'Israel', 'IL'),
(105, 'Italy', 'IT'),
(106, 'Ivory Coast', 'CI'),
(107, 'Jamaica', 'JM'),
(108, 'Japan', 'JP'),
(109, 'Jordan', 'JO'),
(110, 'Kazakhstan', 'KZ'),
(111, 'Kenya', 'KE'),
(112, 'Kiribati', 'KI'),
(113, 'Korea, Democratic People''s Republic of', 'KP'),
(114, 'Korea, Republic of', 'KR'),
(115, 'Kuwait', 'KW'),
(116, 'Kyrgyzstan', 'KG'),
(117, 'Laos', 'LA'),
(118, 'Latvia', 'LV'),
(119, 'Lebanon', 'LB'),
(120, 'Lesotho', 'LS'),
(121, 'Liberia', 'LR'),
(122, 'Libyan Arab Jamahiriya', 'LY'),
(123, 'Liechtenstein', 'LI'),
(124, 'Lithuania', 'LT'),
(125, 'Luxembourg', 'LU'),
(126, 'Macau', 'MO'),
(127, 'Macedonia', 'MK'),
(128, 'Madagascar', 'MG'),
(129, 'Malawi', 'MW'),
(130, 'Malaysia', 'MY'),
(131, 'Maldives', 'MV'),
(132, 'Mali', 'ML'),
(133, 'Malta', 'MT'),
(134, 'Marshall Islands', 'MH'),
(135, 'Martinique', 'MQ'),
(136, 'Mauritania', 'MR'),
(137, 'Mauritius', 'MU'),
(138, 'Mayotte', 'TY'),
(139, 'Mexico', 'MX'),
(140, 'Micronesia, Federated States of', 'FM'),
(141, 'Moldova, Republic of', 'MD'),
(142, 'Monaco', 'MC'),
(143, 'Mongolia', 'MN'),
(144, 'Montserrat', 'MS'),
(145, 'Morocco', 'MA'),
(146, 'Mozambique', 'MZ'),
(147, 'Myanmar', 'MM'),
(148, 'Namibia', 'NA'),
(149, 'Nauru', 'NR'),
(150, 'Nepal', 'NP'),
(151, 'Netherlands', 'NL'),
(152, 'Netherlands Antilles', 'AN'),
(153, 'New Caledonia', 'NC'),
(154, 'New Zealand', 'NZ'),
(155, 'Nicaragua', 'NI'),
(156, 'Niger', 'NE'),
(157, 'Nigeria', 'NG'),
(158, 'Niue', 'NU'),
(159, 'Norfork Island', 'NF'),
(160, 'Northern Mariana Islands', 'MP'),
(161, 'Norway', 'NO'),
(162, 'Oman', 'OM'),
(163, 'Pakistan', 'PK'),
(164, 'Palau', 'PW'),
(165, 'Panama', 'PA'),
(166, 'Papua New Guinea', 'PG'),
(167, 'Paraguay', 'PY'),
(168, 'Peru', 'PE'),
(169, 'Philippines', 'PH'),
(170, 'Pitcairn', 'PN'),
(171, 'Poland', 'PL'),
(172, 'Portugal', 'PT'),
(173, 'Puerto Rico', 'PR'),
(174, 'Qatar', 'QA'),
(175, 'Reunion', 'RE'),
(176, 'Romania', 'RO'),
(177, 'Russian Federation', 'RU'),
(178, 'Rwanda', 'RW'),
(179, 'Saint Kitts and Nevis', 'KN'),
(180, 'Saint Lucia', 'LC'),
(181, 'Saint Vincent and the Grenadines', 'VC'),
(182, 'Samoa', 'WS'),
(183, 'San Marino', 'SM'),
(184, 'Sao Tome and Principe', 'ST'),
(185, 'Saudi Arabia', 'SA'),
(186, 'Senegal', 'SN'),
(187, 'Seychelles', 'SC'),
(188, 'Sierra Leone', 'SL'),
(189, 'Singapore', 'SG'),
(190, 'Slovakia', 'SK'),
(191, 'Slovenia', 'SI'),
(192, 'Solomon Islands', 'SB'),
(193, 'Somalia', 'SO'),
(194, 'South Africa', 'ZA'),
(195, 'South Georgia South Sandwich Islands', 'GS'),
(196, 'Spain', 'ES'),
(197, 'Sri Lanka', 'LK'),
(198, 'St. Helena', 'SH'),
(199, 'St. Pierre and Miquelon', 'PM'),
(200, 'Sudan', 'SD'),
(201, 'Suriname', 'SR'),
(202, 'Svalbarn and Jan Mayen Islands', 'SJ'),
(203, 'Swaziland', 'SZ'),
(204, 'Sweden', 'SE'),
(205, 'Switzerland', 'CH'),
(206, 'Syrian Arab Republic', 'SY'),
(207, 'Taiwan', 'TW'),
(208, 'Tajikistan', 'TJ'),
(209, 'Tanzania, United Republic of', 'TZ'),
(210, 'Thailand', 'TH'),
(211, 'Togo', 'TG'),
(212, 'Tokelau', 'TK'),
(213, 'Tonga', 'TO'),
(214, 'Trinidad and Tobago', 'TT'),
(215, 'Tunisia', 'TN'),
(216, 'Turkey', 'TR'),
(217, 'Turkmenistan', 'TM'),
(218, 'Turks and Caicos Islands', 'TC'),
(219, 'Tuvalu', 'TV'),
(220, 'Uganda', 'UG'),
(221, 'Ukraine', 'UA'),
(222, 'United Arab Emirates', 'AE'),
(223, 'United Kingdom', 'GB'),
(224, 'United States minor outlying islands', 'UM'),
(225, 'Uruguay', 'UY'),
(226, 'Uzbekistan', 'UZ'),
(227, 'Vanuatu', 'VU'),
(228, 'Vatican City State', 'VA'),
(229, 'Venezuela', 'VE'),
(230, 'Vietnam', 'VN'),
(231, 'Virigan Islands (British)', 'VG'),
(232, 'Virgin Islands (U.S.)', 'VI'),
(233, 'Wallis and Futuna Islands', 'WF'),
(234, 'Western Sahara', 'EH'),
(235, 'Yemen', 'YE'),
(236, 'Yugoslavia', 'YU'),
(237, 'Zaire', 'ZR'),
(238, 'Zambia', 'ZM'),
(239, 'Zimbabwe', 'ZW');

-- --------------------------------------------------------

--
-- Table structure for table `credit_cards`
--

CREATE TABLE `credit_cards` (
  `id` int(11) UNSIGNED NOT NULL,
  `name` varchar(128) DEFAULT NULL,
  `percentage` decimal(20,2) DEFAULT NULL,
  `tax` decimal(20,2) DEFAULT NULL,
  `enabled` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `credit_cards`
--

INSERT INTO `credit_cards` (`id`, `name`, `percentage`, `tax`, `enabled`) VALUES
(4, 'Master Card', '1.80', '6.00', '1'),
(5, 'VISA', '1.12', '6.00', '1'),
(6, 'AMEX', '2.75', '6.00', '1'),
(7, 'MEPS', '1.50', '6.00', '1');

-- --------------------------------------------------------

--
-- Table structure for table `credit_notes`
--

CREATE TABLE `credit_notes` (
  `id` int(11) NOT NULL,
  `txn_no` varchar(32) DEFAULT NULL,
  `dn_number` varchar(128) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `contact_person` varchar(128) DEFAULT NULL,
  `received_date` datetime DEFAULT NULL,
  `contact` varchar(128) DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `contact_address` text,
  `delivery_address` text,
  `terms` varchar(128) DEFAULT NULL,
  `remarks` text,
  `status` varchar(128) DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `payment_date` datetime DEFAULT NULL,
  `payment_reference` varchar(128) DEFAULT NULL,
  `payment_contra` varchar(128) DEFAULT NULL,
  `receipt_no` varchar(128) DEFAULT NULL,
  `handling_charges` decimal(20,2) DEFAULT NULL,
  `adjustment` decimal(20,2) DEFAULT NULL,
  `adjustment_type` varchar(32) DEFAULT NULL,
  `total` decimal(20,2) DEFAULT NULL,
  `total_received` decimal(20,2) DEFAULT NULL,
  `tax` text,
  `total_tax` decimal(20,2) DEFAULT NULL,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(32) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(32) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `assigned_to` varchar(128) DEFAULT NULL,
  `paid_amount` decimal(20,2) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `credit_note_items`
--

CREATE TABLE `credit_note_items` (
  `id` int(11) NOT NULL,
  `credit_note_id` int(11) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_name` varchar(128) DEFAULT NULL,
  `item_description` text,
  `discount` varchar(128) DEFAULT NULL,
  `discount_type` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `price_per_unit` decimal(20,4) DEFAULT NULL,
  `price` decimal(20,2) DEFAULT NULL,
  `cost` decimal(20,4) DEFAULT NULL,
  `received` int(11) DEFAULT NULL,
  `received_price` decimal(20,2) DEFAULT NULL,
  `done` int(1) DEFAULT NULL,
  `division_id` int(128) DEFAULT NULL,
  `warehouse_id` int(128) DEFAULT NULL,
  `taxable` int(11) DEFAULT NULL,
  `tax_code` varchar(255) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `customers`
--

CREATE TABLE `customers` (
  `id` int(11) NOT NULL,
  `company_name` varchar(128) DEFAULT NULL,
  `reg_number` varchar(128) DEFAULT NULL,
  `address` text,
  `contact_person` varchar(128) DEFAULT NULL,
  `contact_no` varchar(128) DEFAULT NULL,
  `credit_limit` decimal(20,2) DEFAULT NULL,
  `status` varchar(32) DEFAULT NULL,
  `remarks` text
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `debit_notes`
--

CREATE TABLE `debit_notes` (
  `id` int(11) NOT NULL,
  `txn_no` varchar(32) DEFAULT NULL,
  `cn_number` varchar(128) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `contact_person` varchar(128) DEFAULT NULL,
  `received_date` datetime DEFAULT NULL,
  `supplier` varchar(128) DEFAULT NULL,
  `supplier_id` int(11) DEFAULT NULL,
  `supplier_address` text,
  `delivery_address` text,
  `terms` varchar(128) DEFAULT NULL,
  `remarks` text,
  `status` varchar(128) DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `payment_reference` varchar(128) DEFAULT NULL,
  `payment_date` datetime DEFAULT NULL,
  `payment_contra` varchar(128) DEFAULT NULL,
  `receipt_no` varchar(128) DEFAULT NULL,
  `handling_charges` decimal(20,2) DEFAULT NULL,
  `adjustment` decimal(20,2) DEFAULT NULL,
  `adjustment_type` varchar(32) DEFAULT NULL,
  `total` decimal(20,2) DEFAULT NULL,
  `total_received` decimal(20,2) DEFAULT NULL,
  `tax` text,
  `total_tax` decimal(20,2) DEFAULT NULL,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(32) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(32) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `assigned_to` varchar(128) DEFAULT NULL,
  `paid_amount` decimal(20,2) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `debit_note_items`
--

CREATE TABLE `debit_note_items` (
  `id` int(11) NOT NULL,
  `debit_note_id` int(11) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_name` varchar(128) DEFAULT NULL,
  `item_description` text,
  `discount` varchar(128) DEFAULT NULL,
  `discount_type` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `price_per_unit` decimal(20,4) DEFAULT NULL,
  `price` decimal(20,2) DEFAULT NULL,
  `received` int(11) DEFAULT NULL,
  `received_price` float(20,2) DEFAULT NULL,
  `done` int(1) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `taxable` int(1) DEFAULT NULL,
  `tax_code` varchar(32) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `department`
--

CREATE TABLE `department` (
  `id` int(11) NOT NULL,
  `name` varchar(128) DEFAULT NULL,
  `description` text,
  `company_name` varchar(128) DEFAULT NULL,
  `company_registration` varchar(128) DEFAULT NULL,
  `logo` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `disposal_appreciation`
--

CREATE TABLE `disposal_appreciation` (
  `id` int(11) UNSIGNED NOT NULL,
  `asset_id` int(11) DEFAULT NULL,
  `asset_name` varchar(128) DEFAULT NULL,
  `asset_category` varchar(128) DEFAULT NULL,
  `asset_subcategory` varchar(128) DEFAULT NULL,
  `value_on_disposal` decimal(20,2) DEFAULT NULL,
  `disposed_value` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `disposal_depreciation`
--

CREATE TABLE `disposal_depreciation` (
  `id` int(11) UNSIGNED NOT NULL,
  `asset_id` int(11) DEFAULT NULL,
  `asset_name` varchar(128) DEFAULT NULL,
  `asset_category` varchar(128) DEFAULT NULL,
  `asset_subcategory` varchar(128) DEFAULT NULL,
  `value_on_disposal` decimal(20,2) DEFAULT NULL,
  `disposed_value` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `editor_compilations`
--

CREATE TABLE `editor_compilations` (
  `id` int(11) UNSIGNED NOT NULL,
  `profile_id` int(11) DEFAULT NULL,
  `version` varchar(128) DEFAULT NULL,
  `build_no` varchar(128) DEFAULT NULL,
  `change_log` text,
  `version_type` varchar(128) DEFAULT NULL,
  `svn_url` text,
  `compiled_on` datetime DEFAULT NULL,
  `compiled_by` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `editor_live_contents`
--

CREATE TABLE `editor_live_contents` (
  `id` int(11) UNSIGNED NOT NULL,
  `profile_id` int(11) DEFAULT NULL,
  `item` text,
  `contents` text,
  `datetime` datetime DEFAULT NULL,
  `username` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `editor_profiles`
--

CREATE TABLE `editor_profiles` (
  `id` int(11) UNSIGNED NOT NULL,
  `name` varchar(128) DEFAULT NULL,
  `hostname` varchar(128) DEFAULT NULL,
  `linker_file` text,
  `username` varchar(128) DEFAULT NULL,
  `password` varchar(128) DEFAULT NULL,
  `plexsvn_linker` varchar(128) DEFAULT NULL,
  `api_key` varchar(128) DEFAULT NULL,
  `root_url` text,
  `root_path` varchar(128) DEFAULT NULL,
  `root` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `ftp_protocol` varchar(16) DEFAULT NULL,
  `ftp_port` varchar(10) DEFAULT NULL,
  `ftp_server` varchar(128) DEFAULT NULL,
  `ftp_username` varchar(128) DEFAULT NULL,
  `ftp_password` varchar(128) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `editor_revisions`
--

CREATE TABLE `editor_revisions` (
  `id` int(11) UNSIGNED NOT NULL,
  `profile_id` int(11) DEFAULT NULL,
  `item` text,
  `contents` text,
  `datetime` datetime DEFAULT NULL,
  `user` varchar(128) DEFAULT NULL,
  `commit` int(1) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `editor_revisions`
--

INSERT INTO `editor_revisions` (`id`, `profile_id`, `item`, `contents`, `datetime`, `user`, `commit`) VALUES
(1, 1, '/var/www/_dev/os/application/errors/error_general.php', '<html>\n<head>\n<base href="<?php echo base_url(); ?>" />\n<title>Plexcloud Error</title>\n<style type="text/css">\n\nbody {\n	background-color: #eee;\n	margin: 40px;\n	font-family: Lucida Grande, Verdana, Sans-serif;\n	font-size: 10pt;\n	color: #555;\n}\n\n#content  {\n	padding: 20px 20px 12px 20px;\n}\n\nh1 {\n	font-weight: normal;\n	font-size: 14pt;\n	color: #000088;\n	margin: 20px 0 4px 0;\n}\n\nhr {\n	border-collapse: collapse;\n	border: none;\n	border-top: 1px solid #999;\n	border-bottom: 1px solid #FFF;\n	\n}\n</style>\n</head>\n<body>\n	<div id="content">\n		<img src="images/logo.png" />\n		<hr />\n		<h1><?php echo $heading; ?></h1>\n		<?php echo $message; ?>\n		<div style="margin-top: 100px">\n		<small>plexcloud&trade; Point-of-Sale</small>\n		</div>\n\n	</div>\n	\n	\n</body>\n</html>', '2012-11-07 18:02:40', 'admin', NULL),
(2, 1, '/var/www/_dev/manager/css/main.css', '* {\n	-webkit-user-select: none;\n\n}\n\nbody {\n	margin: 0;\n	padding: 0;\n	font-family: Arial, Helvetica, Tahoma, sans-serif;\n	font-size: 10pt;\n	background: #d6dde5;\n	text-align: center;\n	color: #555;\n	line-height: 150%;\n	overflow: hidden;\n}\n\n\na:active {\n	outline: none;\n}\n\n:-moz-any-link:focus {\n	outline: none;\n}\n\na, a:visited {\n	color: #009eeb;\n	text-decoration: none;\n}\n\np {\n	margin: 5px 0;\n	padding: 0;\n}\n\n#container {\n	margin: 0 auto;\n	text-align: left;\n	min-width: 1000px;\n}\n\n#header {\n	padding: 0;\n	height: 85px;\n	background: url(images/separator.png) bottom repeat-x #FFF;\n}\n\n#header div.user {\n	color: #555;\n	float: right;\n	padding: 10px 20px;\n}\n\n#logo {\n	background: url(images/logo.png) no-repeat;\n	height: 58px;\n	width: 180px;\n	padding: 0;\n	margin-top: 15px;\n	margin-left: 30px;\n	display: block;\n	float: left;\n}\n\n#logo span {\n	display: none;\n}\n\n#nav ul {\n	list-style: none;\n	padding: 0;\n	margin: 0 0 0 0;\n\n	float: left;\n}\n\n#nav li {\n	display: block;\n	float: left;\n}\n\n.shadow {\n	background: -webkit-linear-gradient(rgba(0,0,0,0.30) 0%, rgba(255,255,255,0) 100%);\n	height: 3px;\n	position: absolute;\n	width: 100%;\n	z-index: 1000;\n	top: 40px;\n}\n\n#nav li a {\n	float: left;\n	display: block;\n	width: 30px;\n	height: 30px;\n	margin: 0 8px;\n	color: #555;	\n	font-size: 9pt;\n	opacity: 0.5;\n}\n#nav li {\n	padding: 5px 0 5px 0;\n}\n\n#nav li a:hover {\n	opacity: 1;\n}\n\n#nav li.current {\n	background: #222;\n	box-shadow: 0 0px 3px rgba(0,0,0,1) inset;\n	border-right: 1px solid #555;\n	border-left: 1px solid #555;\n}\n\n#nav li.current a {\n	opacity: 1;\n	width: auto;\n	background-position: 0 0 !important;\n}\n\n#nav li.current a span {\n	display: block;\n	color: #FFF;\n	margin-left: 40px;\n	font-weight: bold;\n	text-shadow: 0 1px 0 rgba(0,0,0,0.7);\n	margin-top: 5px;\n	margin-right: 5px;\n	font-size: 10pt;\n}\n\n#nav li a span {	\n	display: none;\n}\n\n#nav li a.dashboard {\n	background: url(images/modules-dashboard.gif) no-repeat center top;\n}\n\n#nav li a.inventory {\n	background: url(images/modules-inventory.gif) no-repeat center top;\n}\n\n#nav li a.fnb {\n	background: url(images/modules-fnb.gif) no-repeat center top;\n}\n\n#nav li a.assets {\n	background: url(images/modules-assets.gif) no-repeat center top;\n}\n\n#nav li a.services {\n	background: url(images/modules-services.gif) no-repeat center top;\n}\n\n\n#nav li a.accounts {\n	background: url(images/modules-accounts.gif) no-repeat center top;\n}\n\n#nav li a.settings {\n	background: url(images/modules-settings.gif) no-repeat center top;\n}\n\n#nav li a.hr {\n	background: url(images/modules-hr.gif) no-repeat center top;\n}\n\n\n#nav li a.contacts {\n	background: url(images/modules-contacts.gif) no-repeat center top;\n}\n\n#nav li a.sales {\n	background: url(images/modules-sales.gif) no-repeat center top;\n}\n\n#nav li a.reports {\n	background: url(images/modules-reports.gif) no-repeat center top;\n}\n\n\na.header-blue {\n	background: #6699cc;\n	-moz-border-radius: 5px;\n	-webkit-border-radius: 5px;\n	border-radius: 5px;\n}\n\na.header-orange {\n	background: #e2a000;\n	-moz-border-radius: 5px;\n	-webkit-border-radius: 5px;\n	border-radius: 5px;\n}\n\na.header-red {\n	background: #cc3300;\n	-moz-border-radius: 5px;\n	-webkit-border-radius: 5px;\n	border-radius: 5px;\n}\n\na.header-purple {\n	background: #cc0090;\n	-moz-border-radius: 5px;\n	-webkit-border-radius: 5px;\n	border-radius: 5px;\n}\n\na.header-green {\n	background: #008000;\n	-moz-border-radius: 5px;\n	-webkit-border-radius: 5px;\n	border-radius: 5px;\n}\n\n\n\n\n#nav ul li.email {\n	float: right;\n}\n\n\n#nav ul li.email a {\n	background: url(images/mail_icon.gif) no-repeat transparent;\n	background-position: 0 13px;\n	padding-left: 30px;\n}\n\n#nav ul li.email-greyed a {\n	background: url(images/mail_icon_greyed.gif) no-repeat transparent;\n	background-position: 0 13px;	\n	padding-left: 30px;\n	color: #999;	\n}\n\n#nav ul li.email-greyed a:hover {\n	background: url(images/mail_icon.gif) no-repeat transparent;\n	background-position: 0 13px;	\n	color: #FFF;\n}\n\n\n#nav ul li.email-greyed {\n	float: right;\n}\n\n#login_container {\n	width: 450px;\n	text-align: left;\n	margin: 0 auto;\n	margin-top: 170px;\n}\n\n.float_left {\n	float: left;\n}\n\n.float_right {\n	float: right;\n}\n\ndiv.text-canvas {\n	border-top: 1px solid #ccc;\n	overflow-y: auto;\n	padding: 10px;\n}\n\ndiv.text-canvas textarea {\n	border: none;\n	font-size: 10pt;\n	width: 99%;\n}\n\ndiv.text-canvas textarea:focus {\n	outline: none;\n	border: none;\n}\n\n.align-right {\n	text-align: right\n}\n\n.align-center {\n	text-align: center;\n}\n\n.align-left {\n	text-align: center;\n}\n\n#legend {\n	border-top: 1px solid #d8d8d8;\n	padding: 5px 10px;\n}\n\n#legend span.status {\n	float: right;\n	margin: 3px;\n}\n\n.calendar-meeting {\n	background: red;\n	padding: 3px;\n	color: #FFF;\n	-moz-border-radius: 3px; \n	-webkit-border-radius: 3px;\n	border-radius: 3px;\n}\n\n.calendar-appointment {\n	background: #f57802;\n	padding: 3px;\n	color: #FFF;\n	-moz-border-radius: 3px; \n	-webkit-border-radius: 3px;\n	border-radius: 3px;\n}\n\n.calendar-task {\n	background: green;\n	padding: 3px;\n	color: #FFF;\n	-moz-border-radius: 3px; \n	-webkit-border-radius: 3px;\n	border-radius: 3px;\n}\n\n.calendar-schedule {\n	background: #3366cc;\n	padding: 3px;\n	color: #FFF;\n	-moz-border-radius: 3px; \n	-webkit-border-radius: 3px;\n	border-radius: 3px;\n}\n\nbr.clearboth {\n	clear:both;\n}\n\n\ndiv.log {\n	margin: 10px;\n	border: 1px solid #DDD;\n	-moz-border-radius: 10px; \n	-webkit-border-radius: 10px;\n	border-radius: 10px;\n	padding: 10px;\n}\n\ndiv.log:hover {\n	background: #EEE;\n	box-shadow: 0px 2px 1px rgba(0,0,0,0.3);\n}\n\ndiv.log-status {\n	float: right;\n	font-weight: bold;\n	margin-left: 20px;\n}\n\ndiv.log-status-High {\n	color: red;\n}\n\ndiv.log-status-Medium {\n	color: #FF8800;\n}\n\n\ndiv.log-subject {\n	font-weight: bold;\n	font-size: 12pt;\n}\n\ndiv.log-description {\n	margin: 5px 0;\n}\n\ndiv.log-meta {\n	color: #999;\n}\n\n\ndiv.doc-pad {\n	box-shadow: 0 2px 8px rgba(0,0,0,0.5);\n}\n\n\n\n\n\n\n\n#nav a[data-tooltip]:link, #nav a[data-tooltip]:visited {  \n    position: relative;  \n    text-decoration: none;  \n}  \n  \n#nav a[data-tooltip]:before {  \n    content: "";  \n    position: absolute;  \n    border-bottom: 10px solid #000;  \n    border-left: 10px solid transparent;  \n    border-right: 10px solid transparent;  \n    visibility: hidden;  \n    top: 35px;  \n    left: 6px;  \n    z-index: 9000;\n}  \n  \n#nav a[data-tooltip]:after {  \n    content: attr(data-tooltip);  \n    position: absolute;  \n    color: white;  \n    top: 40px;  \n    left: 5px;  \n    background: #000;  \n    padding: 3px 10px;  \n    -webkit-border-radius: 5px;  \n    -moz-border-radius: 5px;  \n    border-radius: 5px;  \n    white-space: nowrap;  \n    visibility: hidden;  \n    z-index: 9000;\n    box-shadow: 0 1px 3px rgba(0,0,0,0.5);\n}  \n  \n#nav a[data-tooltip]:hover:before, #nav a[data-tooltip]:hover:after {  \n    visibility: visible;  \n    -moz-transition: visibility 0s linear .3s;  \n}  ', '2012-11-07 18:11:56', 'admin', NULL),
(3, 1, '/var/www/_dev/manager/css/email.css', '#email-sidebar {\n	float: left;\n	width: 250px;\n	background: #D6DDe5;\n	border-right: 1px solid #a5a5a5;\n}\n\n#email-sidebar ul {\n	list-style: none;\n	padding: 0;\n	margin: 0;\n}\n\n#email-toolbar {\n	background: url(images/toolbar_bg.png) repeat-x;\n	height: 40px;\n	border-bottom: 1px solid #999;\n}\n\n#email-sidebar ul li {\n	margin: 0;\n	padding: 0;\n	border-top: 1px solid #d6dde5;\n	border-bottom: 1px solid #d6dde5;\n}\n\n#email-sidebar ul li a {\n	padding: 5px 15px;\n	color: #555;\n	font-weight: bold;\n	display: block;\n}\n\n#email-content {\n	background: #FFF;\n}\n\n#email-grid {\n	padding: 0 1px;\n	font-family: "Lucida Grande", "Lucida Sans", Arial, sans-serif;\n}\n\n#email-grid table {\n	font-size: 9pt;\n	border-collapse: collapse;\n}\n\n#email-grid table thead {\n	background: url(images/email-list-header-bg.png) repeat-x #EAEAEA;\n	border-top: 1px solid #ccc;\n	border-bottom: 1px solid #ccc;\n}\n\n#email-grid table th {\n	text-align: left;\n	padding: 3px 5px;\n	border-right: 1px solid #ccc;\n	font-size: 8pt;\n	font-weight: normal;\n	color: #111;\n}\n\n#email-grid table td {\n	padding: 3px 5px;\n	border-right: 1px solid #FFF;\n	color: #111;\n}\n\n#email-grid table tbody tr:hover {\n	background: #eee;\n	cursor: pointer;\n}\n\n#email-grid table tbody tr:hover td {\n	border-right: 1px solid #eee;\n}\n\n/* Reset overflow value to hidden for all non-IE browsers. */\nhtml>body #email-grid {\n	overflow: hidden;\n}\n\n/* define width of table. IE browsers only                 */\n#email-grid table {\n	float: left;\n}\n\n/* define width of table. Add 16px to width for scrollbar.           */\n/* All other non-IE browsers.                                        */\nhtml>body #email-grid table {\n	width: 100%;\n}\n\n/* set table header to a fixed position. WinIE 6.x only                                       */\n/* In WinIE 6.x, any element with a position property set to relative and is a child of       */\n/* an element that has an overflow property set, the relative value translates into fixed.    */\n/* Ex: parent element DIV with a class of tableContainer has an overflow property set to auto */\n#email-grid table thead tr {\n	position: relative\n}\n\n/* set THEAD element to have block level attributes. All other non-IE browsers            */\n/* this enables overflow to work on TBODY element. All other non-IE, non-Mozilla browsers */\nhtml>body #email-grid table thead tr {\n	display: block\n}\n\nhtml>body #email-grid table tbody {\n	display: block;\n	overflow: auto;\n	width: 100%\n}\n\n\n\n#email-grid .email-status, #email-grid .email-flag, #email-grid .email-attachment {\n	width: 15px;\n	text-align: center;\n}\n\n#email-grid table td div {\n	height: 14px;\n	overflow: hidden;\n}\n\n#email-sidebar ul a.inbox {\n	background: url(images/email-mailbox.png) no-repeat 15px 6px;\n	padding-left: 40px;\n}\n\n#email-sidebar ul a.trash {\n	background: url(images/email-trash.png) no-repeat 16px 4px;\n	padding-left: 40px;\n}\n\n#email-sidebar ul a.sent {\n	background: url(images/email-sent.png) no-repeat 15px 7px;\n	padding-left: 40px;\n}\n\n#email-sidebar ul a.junk {\n	background: url(images/email-junk.png) no-repeat 15px 7px;\n	padding-left: 40px;\n}\n\n#email-sidebar ul a.draft {\n	background: url(images/email-draft.png) no-repeat 17px 7px;\n	padding-left: 40px;\n}\n\n#email-sidebar ul li.current {\n	border-top: 1px solid #91a0c0;\n	border-bottom: 1px solid #91a0c0;\n	background: url(images/email-select-bg.png) repeat-x;\n}\n\n#email-sidebar ul li.current a {\n	color: #FFF;\n}\n\n#email-separator {\n	background: url(images/email-separator.png) repeat-x;\n	height: 8px;\n	border-top: 1px solid #a5a5a5;\n	border-bottom: 1px solid #a5a5a5;\n}\n\n#email-body-container {\n	overflow: scroll;\n}\n\n#email-grid tr.current {\n	background: #3875d7;\n\n}\n\n#email-grid tr.current td {\n	border-right: 1px solid #3875d7;\n	color: #FFF;\n}\n\n#email-grid tr.current:hover {\n	background: #3875d7;\n}\n\n#email-grid tr.current:hover td {\n	border-right: 1px solid #3875d7;\n}\n\n.im-status { \n	text-align: center;\n}\n\ndiv.email-configuration {\n	background: #eaeaea;\n	margin: 20px;\n	width: 550px;\n	margin: 0 auto;\n	padding: 20px 30px;\n	-webkit-box-shadow: 0 5px 15px #000;\n	-moz-box-shadow: 0 5px 15px #000;\n}\n\ndiv.email-configuration table {\n	font-size: 10pt;\n	width: 100%;\n	margin: 10px 0;\n}\n\ndiv.email-configuration table td.label {\n	width: 35%;\n	text-align: right;\n	font-weight: bold;\n	font-size: 9pt;\n	padding-right: 10px;\n}\n\ndiv.email-configuration table td.input input.text {\n	width: 80%;\n	font-size: 10pt;\n}\n\nhr {\n	color: #555;\n	background: #555;\n	border-top: 1px solid #bbb;\n	border-left: none;\n	border-right: none;\n	border-bottom: 1px solid #fff;\n	margin: 10px 0;\n}', '2012-11-07 18:19:13', 'admin', NULL),
(4, 1, '/var/www/_dev/manager/css/autocomplete.css', '/* \n		This stylesheet belongs to TextboxList - Copyright Guillermo Rauch <http://devthought.com> 2009 \n		TextboxList is not priceless for commercial use. See <http://devthought.com/projects/jquery/textboxlist/> \n		Purchase to remove copyright\n*/\n\n.textboxlist-autocomplete { \n	position: absolute; \n	width: auto; \n	z-index: 5000;\n	min-width: 200px !important;\n}\n\n\n.textboxlist-autocomplete-placeholder, .textboxlist-autocomplete-results { \n	opacity: 0.9; \n	filter: alpha(opacity=90); \n	background: #eee; \n	-webkit-box-shadow: 0 3px 3px #ccc; \n	-moz-box-shadow: 0 3px 3px #ccc; \n	box-shadow: 0 3px 3px #ccc; \n	border: 1px solid #999; \n	border-top: none; \n	display: none;\n	border-bottom-left-radius: 5px;\n	border-bottom-right-radius: 5px;\n}\n\n\n.textboxlist-autocomplete-results {\n	margin-bottom: 5px;\n}\n\n.textboxlist-autocomplete-placeholder { \n	padding: 5px 7px; \n}\n\n.textboxlist-autocomplete-results { \n	margin: 0; \n	padding: 0; \n}\n\n.textboxlist-autocomplete-result { \n	margin: 0; \n	padding: 5px; \n	list-style-type: none; \n	background: #eee; \n	border-bottom-left-radius: 5px;\n	border-bottom-right-radius: 5px;\n\n}\n\n.textboxlist-autocomplete-result-focus { \n	background: #C6D9E4; \n}\n\n.textboxlist-autocomplete-highlight { \n	background: #EEF0C4; \n	font-weight: bold; \n}\n\n/*  TextboxList.Autocomplete Style guidelines \n			Try to keep .textboxlist-autocomplete {} as it is now\n			If you apply custom styles to placeholder, also apply them to results, like it is now.\n			.textboxlist-autocomplete-result {} needs a background for IE.\n*/', '2012-11-07 18:19:15', 'admin', NULL),
(5, 1, '/var/www/_dev/manager/css/jquery.timeentry.css', '/* TimeEntry styles */\n.timeEntry_control {\n	vertical-align: middle;\n	margin-left: 2px;\n}\n* html .timeEntry_control { /* IE only */\n	margin-top: -4px;\n}\n', '2012-11-07 18:19:20', 'admin', NULL),
(6, 1, '/var/www/_dev/os/application/controllers/api.php', '<?php\n\nclass API extends Controller {\n\n	function API(){\n		parent::Controller();\n		header(''Content-type: application/json'');\n		echo ''test'';\n	}\n		\n	function Request_inventory($buffer,$i){\n		if ($i == 0){\n			$start = 0;\n			$stop = $buffer;\n		} else {\n			$stop = $buffer * $i;\n			$start = ($stop - $buffer) + 1;\n		}\n		\n		$query = $this->db->query("SELECT * FROM `inventory` ORDER BY `id` LIMIT $start, $stop");\n		\n		$res->results = $query->result();\n		$res->status = ''ok'';\n		\n		if ($query->num_rows() != $buffer) $res->complete = true;\n		else $res->complete = false;\n		\n		echo json_encode($res);\n		\n	}\n	\n	function Last_updated(){\n		\n		$last_updated = $this->system->config(''inventory_last_updated'');\n		\n		$res->status = ''ok'';\n		$res->last_updated = $last_updated;\n		\n		echo json_encode($res);\n	}\n	\n	function Session_sales_data($session){\n		\n		$query = $this->db->query("SELECT * FROM `sales` WHERE `session` = ?", array($session));\n		$res->sales_data = $query->result();\n		\n		$query = $this->db->query("SELECT * FROM `sale_items` WHERE `session` = ?", array($session));\n		$res->sale_items_data = $query->result();\n		\n		$res->status = ''ok'';\n		\n		echo json_encode($res);\n		\n	}\n	\n	function User_session_data(){\n		\n	}\n	\n	function upstream_sync_sales(){\n		$sales_data = json_decode($this->input->post(''sales''));\n		$sale_items_data = json_decode($this->input->post(''sale_items_data''));\n		\n		foreach ($sales_data as $sale_data){\n			unset($sale_data[''id'']);\n			$query = $this->db->insert_string(''sales'', $sale_data);\n		}\n		\n	}\n	\n\n	\n	\n\n\n}', '2012-11-07 18:20:02', 'admin', NULL),
(7, 1, '/var/www/_dev/os/application/controllers/plexports.php', '<?php\n\nclass Plexports {\n\n	function Trigger_drawer(){\n\n	}\n\n	function Show_display(){\n\n	}\n\n}', '2012-11-07 18:20:06', 'admin', NULL);
INSERT INTO `editor_revisions` (`id`, `profile_id`, `item`, `contents`, `datetime`, `user`, `commit`) VALUES
(8, 1, '/var/www/_dev/os/application/controllers/cartapi.php', '<?php\n\nclass CartAPI extends Controller {\n	\n\n	function CartAPI(){\n		parent::Controller();\n		\n		$this->load->model(''system'');\n		\n\n		$domain = $_SERVER[''REMOTE_ADDR''];\n		$api_key = $this->input->post(''api_key'');\n	\n\n		$this->failed = false;\n\n\n		$allowed_domains = explode('','',str_replace('' '','''',$this->system->config(''online_sales_allowed_domains'')));\n		if (in_array($domain, $allowed_domains)){\n			if (strtoupper($api_key) != strtoupper($this->system->config(''online_sales_api_key''))){\n				$return->status = ''Failed'';\n				$return->reason = ''Invalid API key '' . $api_key . ''.'';\n				\n				echo json_encode($return);\n				$this->failed = true;\n			}	\n		} else {\n			$return->status = ''Failed'';\n			$return->reason = ''Access denied from domain '' . $domain . ''.'';\n\n			echo json_encode($return);\n			$this->failed = true;\n		}\n\n		\n\n	}\n	\n\n	\n	function Order_by_warehouse($output, $args){\n		if ($this->failed) return;\n		$data->enabled = $this->system->config(''warehouse_enabled'');	\n		$data->module = ''Warehouse'';\n		if ($output == ''json'') echo json_encode($data);\n	}\n	\n	function Get_online_min_purchase($output, $args){\n		if ($this->failed) return;\n		$data->min_purchase = $this->system->config(''online_sales_min_purchase'');	\n		$data->currency = $this->system->config(''currency'');\n		if ($output == ''json'') echo json_encode($data);\n	}\n	\n	function Get_currency($output, $args){\n		if ($this->failed) return;\n		$data->currency = $this->system->config(''currency'');\n		if ($output == ''json'') echo json_encode($data);\n	}\n	\n	function Get_categories($output, $args){\n		if ($this->failed) return;\n		\n		$query = $this->db->query("SELECT `category` FROM `inventory` GROUP BY `category` ORDER BY `category` ASC");\n		foreach ($query->result() as $item){\n			$categories[] = $item->category;\n		}\n		if ($output == ''json'') echo json_encode($categories);\n	}\n	\n	function Get_countries($output, $args){\n		if ($this->failed) return;\n		\n		$query = $this->db->query("SELECT * FROM `countries`");\n		foreach ($query->result() as $country){\n			$countries[$country->name] = $country->name;\n		}\n		if ($output == ''json'') echo json_encode($countries);		\n		\n	}\n	\n	function Get_subcategories($output, $args){\n		if ($this->failed) return;\n		\n		$category = $this->input->post(''cat'');\n		if ($category){\n			$query = $this->db->query("SELECT `subcategory` FROM `inventory` WHERE `category` = ? GROUP BY `subcategory` ORDER BY `subcategory` ASC", array($category));\n		} else {\n			$query = $this->db->query("SELECT `subcategory` FROM `inventory` GROUP BY `subcategory` ORDER BY `subcategory` ASC");		\n		}\n		\n		foreach ($query->result() as $item){\n			$subcategories[] = $item->subcategory;\n		}\n		\n		if ($output == ''json'') echo json_encode($subcategories);	\n	}\n	\n	function Get_tags($output, $args){\n		if ($this->failed) return;\n	\n		$query = $this->db->query("SELECT * FROM `inventory` WHERE `tags` LIKE ''%#%''");\n		foreach ($query->result() as $item){\n			if (strpos($item->tags,'','')){\n				foreach (explode('','',$item->tags) as $tag){\n					if ($tag[0] == ''#''){\n						$tags_array[strtolower(str_replace(''#'','''', $tag))] = str_replace(''#'','''', $tag);\n					}\n				}\n			} else {\n				if ($item->tags[0] == ''#''){\n					$tag = str_replace(''#'','''',$item->tags);\n					$tags_array[strtolower($tag)] = $tag;\n				}\n			}\n		}\n		\n		if ($output == ''json'') echo json_encode($tags_array);\n		\n	}\n\n		\n	\n	function Get_items($output, $args){\n		if ($this->failed) return;\n		\n		$filter[] = "`linked` IS NULL";\n		\n		if ($cat = $this->input->post(''cat'')) $filter[] = "`category` = " . $this->db->escape($cat);\n		if ($subcat = $this->input->post(''subcat'')) $filter[] = "`subcategory` = " . $this->db->escape($subcat);\n		if ($term = $this->input->post(''term'')){\n			$filter[] = "(`name` LIKE " . $this->db->escape(''%''.$term.''%'') . " OR `description` LIKE " . $this->db->escape(''%''.$term.''%'') . ")";\n		}\n		if ($tag = $this->input->post(''tag'')){\n			$filter[] = "`tags` LIKE " . $this->db->escape(''%#''.$tag.''%'');\n		}\n		\n		$filter[] = " `ready_for_sale` = 1";\n		\n		$warehouse = $this->input->post(''warehouse'');\n		\n		$orderby = $this->input->post(''orderby'');\n		$order = $this->input->post(''order'');\n		\n		\n		if (count($filter)) $where = implode('' AND '', $filter);\n		else $where = ''1 = 1'';\n		\n		if (!$orderby) $orderby = "`added_on`";\n		if (!$order) $order = "ASC";\n		\n		$rules = json_decode($this->system->config(''price_rules''));\n		\n		$query = $this->db->query("SELECT * FROM `inventory` WHERE $where ORDER BY $orderby $order");\n		foreach ($query->result() as $item){\n			$item->rules = $rules;\n			\n			$item->currency = $this->system->config(''currency'');\n\n			$item->warehouse = $warehouse;\n			$item->qty = $this->get_item_quantity(''return'', array(''warehouse''=>$warehouse, ''item_id''=>$item->id));\n			\n			$query = $this->db->query("SELECT * FROM `sales_discount_item_rules` WHERE `item_id` = ? AND `date_from` <= ? AND `date_to` >= ?", array($item->id, date(''Y-m-d''),date(''Y-m-d'')));\n			$row = $query->row();\n			\n			$item->discount_price 					= $row->discount_price;\n			$item->discount_percentage 				= $row->discount_percentage;\n			$item->discount_applies_to 				= $row->applies_to;\n			$item->discount_performance_based 		= $row->is_performance_based;\n			$item->discount_performance_duration 	= $row->performance_duration;\n			$item->discount_performance_limit 		= $row->performance_limit;\n\n\n\n			$items[] = $item;			\n		}\n		\n\n\n		\n		if ($output == ''json'') echo json_encode($items);\n	\n	}\n	\n	\n	function Get_discount_rules($output, $args){\n		if ($this->failed) return;\n		\n		$query = $this->db->query("SELECT * FROM `sales_discount_item_rules` WHERE `date_from` <= ? AND `date_to` >= ?", array(date(''Y-m-d''),date(''Y-m-d'')));\n		\n		if ($output == ''json'') echo json_encode($query->result());\n	}\n	\n	function Get_item_by_id($output, $args){\n		if ($this->failed) return;\n		\n		$id = $this->input->post(''id'');\n		\n		if (is_array($args)){\n			foreach ($args as $key => $val){\n				${$key} = $val;\n			}\n		}\n		\n		$query = $this->db->query("SELECT * FROM `inventory` WHERE `id` = ? ", array($id));\n		$item = $query->row();\n		\n		$variants = null;\n		if ($item->links){\n			if (strpos($item->links,'','')){\n				foreach (explode('','', $item->links) as $sku){\n					$query = $this->db->query("SELECT * FROM `inventory` WHERE `sku` = ?", array($sku));\n					$variant = $query->row();\n					$variants[] = $variant;\n				}\n			} else {\n				$query = $this->db->query("SELECT * FROM `inventory` WHERE `sku` = ?", array($item->links));\n				$variant = $query->row();\n				$variants[] = $variant;\n			}\n		}\n		\n		$rules = json_decode($this->system->config(''price_rules''));\n		\n		$item->rules = $rules;\n		$item->variants = $variants;\n		$item->currency = $this->system->config(''currency'');\n		\n		$query = $this->db->query("SELECT * FROM `sales_discount_item_rules` WHERE `item_id` = ? AND `date_from` <= ? AND `date_to` >= ?", array($item->id, date(''Y-m-d''),date(''Y-m-d'')));\n		\n		if ($query->num_rows()){\n			$row = $query->row();\n			\n			$item->discount_price 					= $row->discount_price;\n			$item->discount_percentage 				= $row->discount_percentage;\n			$item->discount_applies_to 				= $row->applies_to;\n			$item->discount_performance_based 		= $row->is_performance_based;\n			$item->discount_performance_duration 	= $row->performance_duration;\n			$item->discount_performance_limit 		= $row->performance_limit;\n		}\n		\n		if ($warehouse = $this->input->post(''warehouse'')){\n			$item->warehouse = $warehouse;\n			$item->qty = $this->get_item_quantity(''return'', array(''warehouse''=>$warehouse, ''item_id''=>$item->id));\n		}\n\n		\n		if ($output == ''json'') echo json_encode($item);\n		elseif ($output == ''return'') return $item;\n		\n	}\n	\n	function Verify_contacts_by_field($output,$args){\n		if ($this->failed) return;\n		\n		$query = $this->db->query("SELECT * FROM `contacts` WHERE `email` = ?", array($this->input->post(''email'')));\n		if ($query->num_rows()){\n\n			$data->data = ''email_false'';\n			if ($output == ''json'') echo json_encode($data);\n\n			return;\n		}\n		\n		$query = $this->db->query("SELECT * FROM `contacts` WHERE `ic` = ?", array($this->input->post(''ic'')));\n		if ($query->num_rows()){\n\n			$data->data = ''ic_false'';\n			if ($output == ''json'') echo json_encode($data);\n			return;\n		}\n		\n		\n		$data->data = ''ok'';\n		if ($output == ''json'') echo json_encode($data);\n		\n		\n		\n	}\n	\n	function Verify_customer($output, $args){\n		if ($this->failed) return;\n		\n		\n\n		$code = $this->input->post(''code'');\n		$id = $this->input->post(''id'');		\n		\n				\n		$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($id));\n		$customer = $query->row();\n		\n		if (strpos($customer->tags, '','')){\n			$tags = explode('','',$customer->tags);\n			foreach ($tags as $tag){\n				if ($tag == ''Unverified''){\n					$tag = ''Verified'';\n				}\n				$new_tags[] = $tag;\n			}\n			$tags = implode('','', $new_tags);\n		} else {\n			$tags = str_replace(''Unverified'',''Verified'',$customer->tags);\n		}\n		\n		$this->db->update(''contacts'', array(''tags'' => $tags), "`id` = ''{$id}''");\n\n		$data->code = $code;\n		$data->id = $id;\n		$data->customer = $customer;\n		\n\n		\n		\n		if (strtoupper($code) == strtoupper(md5($customer->id.$customer->email.$customer->contact_person))){\n			$data->data = ''ok'';\n		} else {\n			$data->data = ''false'';\n		}\n\n		if ($output == ''json'') echo json_encode($data);		\n	}	\n	\n	function Register_customer($output, $args){\n		if ($this->failed) return;\n	\n		$query = $this->db->query("SELECT * FROM `contacts` WHERE `email` = ?", array($this->input->post(''email'')));\n		if ($query->num_rows()){\n\n			$data->data = ''false'';\n			if ($output == ''json'') echo json_encode($data);\n\n		} else {\n			\n			$ic = ereg_replace("[^A-Za-z0-9\\s]", "", $this->input->post(''ic'') );		\n			$introducer_ic = ereg_replace("[^A-Za-z0-9\\s]", "", $this->input->post(''introducer_ic''));	\n			\n			$query = $this->db->insert(''contacts'', array(\n				''is_customer''		=> 1,\n				''contact_person''	=> $name = $this->input->post(''name''),\n				''contact_number''	=> $this->input->post(''mobile''),\n				''address1''			=> $this->input->post(''address1''),\n				''address2''			=> $this->input->post(''address2''),\n				''city''				=> $this->input->post(''city''),\n				''state''				=> $this->input->post(''state''),\n				''zipcode''			=> $this->input->post(''zipcode''),\n				''country''			=> $this->input->post(''country''),\n				''email''				=> $email = $this->input->post(''email''),\n				''general_email''		=> $email,\n				''ic''				=> $ic,\n				''introducer_ic''		=> $introducer_ic,				\n				''is_member''			=> 1,\n				''password''			=> $this->input->post(''password''),\n				''added_on''			=> date(''Y-m-d H:i:s''),\n				''added_by''			=> ''@Plexcart'',\n				''tags''				=> ''Online Customer,Unverified''\n			));\n\n			$id = $query->insert_id;	\n							\n			if(strcmp($this->input->post(''country''),''Malaysia'') != 0){\n	\n				$sql = $this->db->update_string(''contacts'',array(\n					''ic''	=> $id\n				),"`id` = ''$id''");\n			}\n			\n			$link = $this->input->post(''link'') . ''verify/'' . $id . ''/'' . md5($id.$email.$name);\n			\n			$message = $this->system->config(''online_sales_email_new_registration'');\n			$message = str_replace(''{name}'', $name, $message);\n			$message = str_replace(''{email}'', $email, $message);\n			$message = str_replace(''{link}'', $link, $message);\n			\n			\n			$config[''protocol''] = ''smtp'';\n			$config[''mailpath''] = ''/usr/sbin/sendmail'';\n			$config[''charset''] = ''iso-8859-1'';\n			$config[''wordwrap''] = TRUE;\n			$config[''mailtype''] = ''html'';\n		\n			$config[''smtp_host''] = $this->system->config(''online_sales_responder_hostname'');\n			$config[''smtp_user''] = $this->system->config(''online_sales_responder_email'');\n			$config[''smtp_pass''] = $this->system->config(''online_sales_responder_password'');\n			$config[''smtp_port''] = ''25'';\n\n			$this->load->library(''email'');		\n			$this->email->initialize($config);\n\n			$this->email->from($this->system->config(''online_sales_responder_email''), $this->system->config(''online_sales_responder_name''));\n			$this->email->to($email);\n			$this->email->bcc($this->system->config(''online_sales_responder_txn_email''));\n			$this->email->subject($this->system->config(''online_sales_email_new_registration_subject''));\n			$this->email->message($message);\n			$this->email->send();\n			\n			\n			\n			$data->data = ''ok'';\n			if ($output == ''json'') echo json_encode($data);\n		}\n	}\n	\n	function Test_mail(){\n\n		\n		$config[''protocol''] = ''smtp'';\n		$config[''mailpath''] = ''/usr/sbin/sendmail'';\n		$config[''charset''] = ''iso-8859-1'';\n		$config[''wordwrap''] = TRUE;\n    	$config[''mailtype''] = ''html'';\n		\n		$config[''smtp_host''] = $this->system->config(''online_sales_responder_hostname'');\n		$config[''smtp_user''] = $this->system->config(''online_sales_responder_username'');\n		$config[''smtp_user''] = ''slm@halagel.com.my'';\n		$config[''smtp_pass''] = $this->system->config(''online_sales_responder_password'');\n		$config[''smtp_pass''] = ''1234567'';\n		$config[''smtp_port''] = ''25'';\n\n		$this->load->library(''email'');		\n		$this->email->initialize($config);\n\n		\n		$this->email->from($this->system->config(''online_sales_responder_email''));\n		$this->email->to(''shafiq.rizwan@gmail.com'');\n		$this->email->message(''test message'');\n		$this->email->send();\n		\n		$data->debug = $this->email->print_debugger();\n		echo json_encode($data);\n	}\n	\n	function Update_account($output, $args){\n		if ($this->failed) return;\n		\n		$id = $this->input->post(''id'');\n		\n		$this->db->update(''contacts'', array(\n				''company_name''		=> $this->input->post(''company''),\n				''contact_person''	=> $this->input->post(''name''),\n				''contact_number''	=> $this->input->post(''mobile''),\n				''address1''			=> $this->input->post(''address1''),\n				''address2''			=> $this->input->post(''address2''),\n				''city''				=> $this->input->post(''city''),\n				''state''				=> $this->input->post(''state''),\n				''zipcode''			=> $this->input->post(''zipcode''),\n				''country''			=> $this->input->post(''country''),\n				''modified_on''		=> date(''Y-m-d H:i:s''),\n				''modified_by''		=> ''_self'',\n		),"`id` = ''{$id}''");\n	\n		if ($password = $this->input->post(''password'')){\n			$this->db->update(''contacts'', array(\n				''password''			=> md5($this->input->post(''password''))\n			), "`id` = ''{$id}''");\n		}\n		\n		if ($output == ''json'') echo json_encode($data);\n	}\n	\n	function Auth_customer($output, $args){\n		if ($this->failed) return;\n		\n		$username = $this->input->post(''username'');\n		$password = $this->input->post(''password'');\n\n		$query = $this->db->query("SELECT * FROM `contacts` WHERE `email` = ?", array($username));\n		$customer = $query->row();\n		\n		$tags_exploded = explode(",", $customer->tags);\n		\n		if ($customer->is_franchise){\n			$data->data = ''incorrect'';	\n			if ($output == ''json'') echo json_encode($data);\n			\n			return;\n		}\n		\n		if (($password == $customer->password) && (in_array(''Verified'', $tags_exploded))){\n		\n			$session = $username . time();\n			$this->db->query("UPDATE `contacts` SET `current_session` = ? WHERE `email` = ?", array($session, $username));\n			\n			$data->data = $session;	\n		\n			if ($output == ''json'') echo json_encode($data);\n		} else {\n		\n			$data->data = ''incorrect'';	\n			if ($output == ''json'') echo json_encode($data);\n			\n		}\n		\n	}\n	\n	function Get_customer_information($output, $args){\n		if ($this->failed) return;\n		\n		$session = $this->input->post(''session'');\n		$query = $this->db->query("SELECT * FROM `contacts` WHERE `current_session` = ?", array($session));\n		\n		$data = $query->row();\n		$data->loyalty_points = $this->get_customer_points($data->id);\n		if ($output == ''json'') echo json_encode($data);\n	}\n	\n	function Get_customer_points($id){\n		$query = $this->db->query("SELECT SUM(FLOOR(`amount`)) AS `total_amount` FROM `sales` WHERE `customer_id` = ? AND `is_redemption` <> 1 AND `type` = ''history''", array($id));\n	    $point_sales = $query->row();\n	    \n	    $query = $this->db->query("SELECT SUM(FLOOR(`total_delivered`)) AS `total_amount` FROM `invoices` WHERE `contact_id` = ? AND `payment_status` = ''Paid''", array($id));\n	    $point_invoices = $query->row();\n	    \n	    $total = $point_sales->total_amount + $point_invoices->total_amount;\n	    \n	    $amount = $this->system->config(''member_minimum_amount'');\n	    $ppa = $this->system->config(''member_minimum_point'');\n	    \n	    $query = $this->db->query("SELECT SUM(`points`) AS `total_points` FROM `sale_items` WHERE `redeemed` = 1 AND `member_id` = ?", array($id));\n	    $points_redeemed = $query->row();\n\n	    return (floor($total / $amount) * $ppa) - $points_redeemed->total_points;\n	}\n	\n	function Get_customer_history($output, $args){\n		if ($this->failed) return;\n		\n		$id = $this->input->post(''id'');\n		$query = $this->db->query("SELECT * FROM `sales_order` WHERE `contact_id` = ? AND `status` = ''Completed'' ORDER BY `date` DESC", array($id));\n		\n		foreach ($query->result() as $so){\n			$query = $this->db->query("SELECT * FROM `invoices` WHERE `sales_order_id` = ?", array($so->id));\n			$invoice = $query->row();\n			$so->invoice = $invoice;\n			$sos[] = $so;\n		}\n		\n		if ($output == ''json'') echo json_encode($sos);\n		\n	}\n	\n	function Get_order_by_id($output, $args){\n		if ($this->failed) return;\n		\n		$id = $this->input->post(''id'');\n		$user_id = $this->input->post(''user_id'');\n		\n		$query = $this->db->query("SELECT * FROM `sales_order` WHERE `id` = ? AND `contact_id` = ?", array($id, $user_id));\n		\n		if ($query->num_rows()){\n			$order = $query->row();\n\n			$query = $this->db->query("SELECT * FROM `sales_order_items` WHERE `sales_order_id` = ?", array($id));\n			$order->items = $query->result();\n			\n			$query = $this->db->query("SELECT * FROM `invoices` WHERE `sales_order_id` = ?", array($id));\n			$order->invoice = $query->row();\n\n		}\n		\n		if ($output == ''json'') echo json_encode($order);\n		\n	}\n	\n	function Get_purchase_by_id($output, $args){\n		if ($this->failed) return;\n		\n		$username = $this->input->post(''username'');\n		$challenge = $this->input->post(''challenge'');\n		$challenge_feedback = $this->input->post(''challenge_feedback'');\n	\n	}\n	\n	function Checkout($output, $args){\n		if ($this->failed) return;\n		\n		$user 				= json_decode($this->input->post(''user''));\n		$items				= json_decode($this->input->post(''items''));\n		$gateway			= json_decode($this->input->post(''gateway''));\n		$shipping 			= json_decode($this->input->post(''shipping''));\n		$delivery			= json_decode($this->input->post(''delivery''));\n		$warehouse_id		= $this->input->post(''warehouse_id'');\n\n\n		$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($user->id));\n		$contact = $query->row();		\n\n		$address->address1	= $contact->address1;\n		$address->address2	= $contact->address2;\n		$address->zipcode	= $contact->zipcode;\n		$address->city		= $contact->city;\n		$address->state		= $contact->state;\n		$address->country	= $contact->country;\n		\n		$date = date(''Y-m-d H:i:s'');\n		$due_date = date(''Y-m-d H:i:s'',time() + (60 * 60 * 24 * 30));\n		\n		$delivery_charges = $this->get_delivery_charges(''return'', array(\n			''service''	=> $shipping->id,\n			''country''	=> $delivery->country,\n			''zipcode''	=> $delivery->zipcode\n		));\n\n		$sql = $this->db->insert_string(''sales_order'',array(\n			''date''				=> $date,\n			''due_date''			=> $due_date,\n			''contact''			=> $contact->company_name ? $contact->company_name : $contact->contact_person,\n			''contact_id''		=> $contact->id,\n			''contact_address''	=> json_encode($address),\n			''delivery_address''	=> json_encode($delivery),\n			''terms''				=> ''Cash'',\n			''duration''			=> $this->input->post(''duration''),\n			''status''			=> ''Pending'',\n			''payment_status''	=> ''Unpaid'',\n			''payment_gateway''	=> $gateway->namespace,\n			''payment_method''	=> $gateway->name,\n			''shipping''			=> $shipping->name,\n			''shipping_id''		=> $shipping->id,\n			''adjustment''		=> $this->input->post(''adjustment''),\n			''adjustment_type''	=> $this->input->post(''adjustment_type''),\n			''handling_charges''	=> $delivery_charges->total_rate,\n			''warehouse_id''		=> $warehouse_id,\n			''tags''				=> ''Online Sales'',\n			''added_on''			=> date(''Y-m-d H:i:s''),\n			''added_by''			=> ''@Plexcart''\n		));\n\n		$query = $this->db->query($sql);\n\n		$so_id = $query->insert_id;\n		\n		$price_rules = json_decode($this->system->config(''price_rules''));\n				\n		foreach ($items as $item){\n			$qty = $item->qty;\n			$item = $this->get_item_by_id(''return'',array(''id''=>$item->id));\n	\n			if ($contact->rank){\n				$item->price = $item->{''price''.$price_rules->{str_replace('' '',''_'',$contact->rank)}};\n			}\n				\n			$sql = $this->db->insert_string(''sales_order_items'',array(\n				''sales_order_id''	=> $so_id,\n				''date''				=> $date,\n				''type''				=> ''product'',\n				''item_sku''			=> $item->sku,\n				''item_name''			=> $item->name,\n				''item_description''	=> $item->description,\n				''item_id''			=> $item->id,\n				''qty''				=> $qty,\n				''cost''				=> $item->cost * $qty,\n				''price''				=> $subtotal = ($item->discount_price ? $item->discount_price : $item->price) * $qty,\n				''price_per_unit''	=> ($item->discount_price ? $item->discount_price : $item->price),\n				''warehouse_id''		=> $warehouse_id\n			));\n			\n			$total += $subtotal;\n			$total_cost += $item->cost;\n			\n			$this->db->query($sql);\n			\n		}\n		\n		$grand_total = $total + $delivery_charges->total_rate;\n		\n		$this->db->update(''sales_order'', array(\n			''cost''	=> $total_cost,\n			''total''	=> $grand_total\n		),"`id` = ''{$so_id}''");\n\n\n\n\n		\n\n		$query = $this->db->query("SELECT * FROM `sales_order` WHERE `id` = ?", array($so_id));\n		$order = $query->row();\n		\n		$query = $this->db->query("SELECT * FROM `sales_order_items` WHERE `sales_order_id` = ?", array($so_id));\n		$order->items = $query->result();\n\n		if ($output == ''json'') echo json_encode($order);\n\n\n	}\n	\n	function Complete($output, $args){\n		if ($this->failed) return;\n		\n		$time			= $this->input->post(''time'');\n		$secret			= $this->input->post(''secret'');\n		$order_id		= $this->input->post(''id'');\n		$payment_status	= $this->input->post(''payment_status'');\n		$status			= $this->input->post(''status'');\n		$remarks		= $this->input->post(''remarks'');\n		$txn_reference 	= $this->input->post(''txn_reference'');\n		$txn_date		= $this->input->post(''txn_date'');\n		\n		$mytime = time();\n		\n			\n		$this->db->update(''sales_order'', array(\n			''status''			=> $status,\n			''remarks''			=> $remarks,\n			''payment_status''	=> $payment_status\n		),"`id` = ''{$order_id}''");\n		\n		if ($payment_status == ''Paid''){\n			$query = $this->db->query("SELECT * FROM `sales_order` WHERE `id` = ?", array($order_id));\n			$so = $query->row();\n			\n			if ($so->invoice_id) return;\n		\n			$sql = $this->db->insert_string(''invoices'',array(\n				''date''				=> date(''Y-m-d H:i:s''),\n				''due_date''			=> $due_date,\n				''sales_order_id''	=> $order_id,\n				''contact_person''	=> $so->contact_person,\n				''contact''			=> $so->contact,\n				''contact_id''		=> $so->contact_id,\n				''contact_address''	=> $so->contact_address,\n				''delivery_address''	=> $so->delivery_address,\n				''delivery_status''	=> ''Pending'',\n				''shipping''			=> $so->shipping,\n				''shipping_id''		=> $so->shipping_id,\n				''terms''				=> ''Cash'',\n				''duration''			=> '''',\n				''payment_status''	=> ''Paid'',\n				''payment_date''		=> $txn_date,\n				''payment_reference''	=> $txn_reference,\n				''status''			=> ''Pending'',\n				''adjustment''		=> $so->adjustment,\n				''adjustment_type''	=> $so->adjustment_type,\n				''handling_charges''	=> $so->handling_charges,\n				''remarks''			=> $so->remarks,\n				''total''				=> $so->total,\n				''tags''				=> ''Online Sales'',\n				''added_on''			=> date(''Y-m-d H:i:s''),\n				''added_by''			=> ''@Plexcart'',\n				''warehouse_id''		=> $so->warehouse_id\n			));\n	\n			$query = $this->db->query($sql);\n	\n			$invoice_id = $query->insert_id;\n			\n\n			$sql = $this->db->update_string(''sales_order'', array(\n				''invoice_id''	=> $invoice_id\n			),"`id` = ''{$order_id}''");\n			$this->db->query($sql);\n\n			$query = $this->db->query("SELECT * FROM `sales_order_items` WHERE `sales_order_id` = ?", array($order_id));\n			$items = $query->result();\n			\n			$date = date(''Y-m-d H:i:s'');\n			\n			foreach ($items as $item){\n				$sql = $this->db->insert_string(''invoice_items'',array(\n					''invoice_id''		=> $invoice_id,\n					''date''				=> $date,\n					''type''				=> $item->type,\n					''item_name''			=> $item->item_name,\n					''item_description''	=> $item->item_description,\n					''item_id''			=> $item->item_id,\n					''item_sku''			=> $item->item_sku,\n					''service_id''		=> $item->service_id,\n					''qty''				=> $item->qty,\n					''price''				=> $item->price,\n					''price_per_unit''	=> $item->price_per_unit,\n					''discount_type''		=> $item->discount_type,\n					''discount''			=> $item->discount,\n					''warehouse_id''		=> $item->warehouse_id\n				));\n				\n				$this->db->query($sql);\n				\n			}\n			\n		}\n		\n		$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($so->contact_id));\n		$contact = $query->row();\n		\n		$total 				= number_format($so->total - $so->handling_charges,2);\n		$handling_charges	= number_format($so->handling_charges,2);\n		$grand_total 		= number_format($so->total,2);\n		\n		$styles = ''<style>'' . $this->system->config(''online_sales_email_css'') . ''</style>'';\n		\n		$order_table = "<table style=\\"border-collapse: collapse;\\"><thead><tr><th>No</th><th>Item</th><th>Unit Price</th><th>Qty</th><th>Subtotal</th></tr></thead>";\n		$order_table .= "<tfoot>\n							<tr>\n								<td colspan=\\"4\\">Total</td>\n								<td style=\\"text-align: right\\">{$total}</td>\n							</tr>\n							<tr>\n								<td colspan=\\"4\\">Shipping: {$so->shipping}</td>\n								<td style=\\"text-align: right\\">{$handling_charges}</td>\n							</tr>\n							<tr>\n								<td colspan=\\"4\\"><strong>Grand Total</strong></td>\n								<td style=\\"text-align: right\\">{$grand_total}</td>	\n							</tr>\n						</tfoot>";\n		$order_table .= "<tbody>";\n		\n		foreach ($items as $item){\n			$z++;\n			$order_table .= "<tr>\n								<td style=\\"text-align: center\\">{$z}</td>\n								<td>{$item->item_name}<br />{$item->item_sku}</td>\n								<td style=\\"text-align: center\\">{$item->price_per_unit}</td>\n								<td style=\\"text-align: center\\">{$item->qty}</td>\n								<td style=\\"text-align: right\\">{$item->price}</td>\n							</tr>";\n		}\n		$order_table .= "</tbody></table>";\n		\n		$address = json_decode($so->contact_address);\n		$billing_address .= $address->address1 ? $address->address1 . "<br />"  : '''';\n		$billing_address .= $address->address2 ? $address->address2 . "<br />"  : '''';\n		$billing_address .= $address->zipcode ? $address->zipcode . '' '' : '''';\n		$billing_address .= $address->city ? $address->city . "<br />" : '''';\n		$billing_address .= $address->state ? $address->state . "<br />" : '''';\n		$billing_address .= $address->country ? $address->country : ''''; \n				\n		$address = json_decode($so->delivery_address);\n    	$delivery_address = $address->name ? $address->name . "<br />" : '''';\n    	$delivery_address .= $address->mobile ? ''Contact No: '' . $address->mobile . "<br />"  : '''';\n    	$delivery_address .= $address->address1 ? $address->address1 . "<br />"  : '''';\n    	$delivery_address .= $address->address2 ? $address->address2 . "<br />"  : '''';\n    	$delivery_address .= $address->zipcode ? $address->zipcode . '' '' : '''';\n    	$delivery_address .= $address->city ? $address->city . "<br />"  : '''';\n    	$delivery_address .= $address->state ? $address->state . "<br />"  : '''';\n    	$delivery_address .= $address->country ? $address->country : '''';\n\n	\n		if ($so->warehouse_id){\n			$query = $this->db->query("SELECT * FROM `warehouses` WHERE `id` = ?", array($so->warehouse_id));\n			$warehouse = $query->row();					\n		}\n		\n		$message = $this->__template(nl2br($this->system->config(''online_sales_email_new_order'')),array(\n			''{name}''			=> $contact->contact_person,\n			''{mobile}''			=> $contact->contact_number,\n			''{email}''			=> $contact->email,\n			''{order_no}''		=> $so->id,\n			''{datetime}''		=> date(''j:iA d/m/Y'',strtotime($so->datetime)),\n			''{bill_addr}''		=> $billing_address,\n			''{delivery_addr}''	=> $delivery_address,\n			''{gateway}''			=> $so->gateway,\n			''{shipping}''		=> $so->shipping,\n			''{order_table}''		=> $order_table,\n			''{warehouse}''		=> $warehouse->name,\n			''{status}''			=> $status,\n			''{payment_status}''	=> $payment_status\n		));\n		\n		$message = ''<html><head>'' . $styles . ''</head><body>'' . $message . ''</body></html>'';\n		\n		$subject = $this->__template($this->system->config(''online_sales_email_new_order_subject''),array(\n			''{name}''			=> $contact->contact_person,\n			''{mobile}''			=> $contact->contact_number,\n			''{email}''			=> $contact->email,\n			''{order_no}''		=> $so->id,\n			''{datetime}''		=> date(''j:iA d/m/Y'',strtotime($so->datetime)),\n			''{bill_addr}''		=> $billing_address,\n			''{delivery_addr}''	=> $delivery_address,\n			''{gateway}''			=> $so->gateway,\n			''{shipping}''		=> $so->shipping,\n			''{warehouse}''		=> $warehouse->name,\n			''{status}''			=> $status,\n			''{payment_status}''	=> $payment_status\n		));\n		\n		$message_bo = $this->__template(nl2br($this->system->config(''online_sales_email_new_order_bo'')),array(\n			''{name}''			=> $contact->contact_person,\n			''{mobile}''			=> $contact->contact_number,\n			''{email}''			=> $contact->email,\n			''{order_no}''		=> $so->id,\n			''{datetime}''		=> date(''j:iA d/m/Y'',strtotime($so->datetime)),\n			''{bill_addr}''		=> $billing_address,\n			''{delivery_addr}''	=> $delivery_address,\n			''{gateway}''			=> $so->gateway,\n			''{shipping}''		=> $so->shipping,\n			''{order_table}''		=> $order_table,\n			''{warehouse}''		=> $warehouse->name,\n			''{status}''			=> $status,\n			''{payment_status}''	=> $payment_status\n		));\n		\n		$message_bo = ''<html><head>'' . $styles . ''</head><body>'' . $message_bo . ''</body></html>'';\n		\n		$subject_bo = $this->__template($this->system->config(''online_sales_email_new_order_bo_subject''),array(\n			''{name}''			=> $contact->contact_person,\n			''{mobile}''			=> $contact->contact_number,\n			''{email}''			=> $contact->email,\n			''{order_no}''		=> $so->id,\n			''{datetime}''		=> date(''j:iA d/m/Y'',strtotime($so->datetime)),\n			''{bill_addr}''		=> $billing_address,\n			''{delivery_addr}''	=> $delivery_address,\n			''{gateway}''			=> $so->gateway,\n			''{shipping}''		=> $so->shipping,\n			''{warehouse}''		=> $warehouse->name,\n			''{status}''			=> $status,\n			''{payment_status}''	=> $payment_status\n		));\n\n		\n    	\n    	$config[''protocol''] = ''smtp'';\n    	$config[''mailpath''] = ''/usr/sbin/sendmail'';\n    	$config[''charset''] = ''iso-8859-1'';\n    	$config[''wordwrap''] = TRUE;\n    	$config[''mailtype''] = ''html'';\n    \n    	$config[''smtp_host''] = $this->system->config(''online_sales_responder_hostname'');\n    	$config[''smtp_user''] = $this->system->config(''online_sales_responder_email'');\n    	$config[''smtp_pass''] = $this->system->config(''online_sales_responder_password'');\n    	$config[''smtp_port''] = ''25'';\n\n    	$this->load->library(''email'');		\n    	$this->email->initialize($config);\n\n    	$this->email->from($this->system->config(''online_sales_responder_email''), $this->system->config(''online_sales_responder_name''));\n    	$this->email->to($contact->email);\n    	$this->email->bcc($this->system->config(''online_sales_responder_txn_email''));\n    	$this->email->subject($subject);\n    	$this->email->message($message);\n    	$this->email->send();\n    	\n    	\n    	$this->email->from($this->system->config(''online_sales_responder_email''), $this->system->config(''online_sales_responder_name''));\n    	if ($so->warehouse_id){\n	    	$this->email->to($this->system->config(''online_sales_responder_email'') . '','' . $warehouse->email);\n    	} else {\n	    	$this->email->to($this->system->config(''online_sales_responder_email''));\n    	}\n    	$this->email->bcc(array($this->system->config(''online_sales_responder_txn_email'')));\n    	$this->email->subject($subject_bo);\n    	$this->email->message($message_bo);\n    	$this->email->send();\n\n    	$notification->type 	= ''New Order'';\n    	$notification->datetime	= date(''Y-m-d H:i:s'');\n    	$notification->by		= ''Auto-Responder'';\n    	$notification->status	= $payment_status;\n    	\n    	$notifications[] = $notification;\n  \n  		$this->db->update(''sales_order'', array(\n  			''notification''	=> json_encode($notifications)\n  		), "`id` = ''{$so->id}''");\n\n			\n		$order->order_id		= $order_id;\n		$order->time			= $time;\n		$order->status			= $status;\n		$order->payment_status	= $payment_status;\n		$order->remarks			= $remarks;\n		\n		if ($output == ''json'') echo json_encode($order);\n		\n		\n		\n	\n	}\n	\n	function Get_payment_gateways($output, $args){\n		if ($this->failed) return;\n	\n		$query = $this->db->query("SELECT * FROM `payment_gateways` WHERE `status` = ''Active''");\n		if ($output == ''json'') echo json_encode($query->result());\n	}\n	\n	function Get_payment_gateway_by_id($output, $args){\n		if ($this->failed) return;\n		\n		$id = $this->input->post(''id'');\n		$query = $this->db->query("SELECT * FROM `payment_gateways` WHERE `id` = ?", array($id));\n		\n		if ($output == ''json'') echo json_encode($query->row());\n	}\n	\n	function Get_shipping_services($output, $args){\n		if ($this->failed) return;\n		\n		$query = $this->db->query("SELECT * FROM `shipping`");\n		\n		if ($output == ''json'') echo json_encode($query->result());\n		\n	}\n\n	\n	function Get_shipping_service_by_id($output, $args){\n		if ($this->failed) return;\n		\n		$id = $this->input->post(''id'');\n		$query = $this->db->query("SELECT * FROM `shipping` WHERE `id` = ?", array($id));\n		\n		if ($output == ''json'') echo json_encode($query->row());\n	}\n	\n	function Get_warehouses($output, $args){\n		if ($this->failed) return;\n		\n		$query = $this->db->query("SELECT * FROM `warehouses`");\n		if ($output == ''json'') echo json_encode($query->result());		\n		\n	}\n	\n	function Get_warehouse_by_id($output, $args){\n		if ($this->failed) return;\n				\n		$id = $this->input->post(''id'');\n		$query = $this->db->query("SELECT * FROM `warehouses` WHERE `id` = ?", array($id));\n		if ($output == ''json'') echo json_encode($query->row());	\n	}\n	\n	function Get_delivery_charges($output, $args){\n		if ($this->failed) return;\n		\n		if ($args){\n			$zipcode = $args[''zipcode''];\n			$country = $args[''country''];\n			$service = $args[''service''];\n		} else {\n			$zipcode = $this->input->post(''zipcode'');\n			$country = $this->input->post(''country'');\n			$service = $this->input->post(''service'');\n		}\n		$items = json_decode($this->input->post(''items''));\n		\n		$query = $this->db->query("SELECT * FROM `shipping` WHERE `id` = ?", array($service));\n		$service = $query->row();\n		\n		\n		if ($country == $this->system->config(''country'')){\n			// local zone\n			$query = $this->db->query("SELECT * FROM `shipping_local_zones` WHERE `zipcode_from` <= ? AND `zipcode_to` >= ?", array($zipcode, $zipcode));\n			$zone = $query->row();\n			\n			$query = $this->db->query("SELECT * FROM `shipping_rates` WHERE `service_id` = ? AND `zone_id` = ? AND `zone_type` = ''Local''", array($service->id, $zone->id));\n			$rate = $query->row();\n						\n		} else {\n\n			$query = $this->db->query("SELECT * FROM `shipping_international_zones` WHERE FIND_IN_SET(?, `countries`)", array($country));\n			$zone = $query->row();\n			\n			$query = $this->db->query("SELECT * FROM `shipping_rates` WHERE `service_id` = ? AND `zone_id` = ? AND `zone_type` = ''International''", array($service->id, $zone->id));\n			$rate = $query->row();\n\n		}\n\n		foreach ($items as $item){\n\n			$query = $this->db->query("SELECT * FROM `inventory` WHERE `id` = ?", array($item->id));\n			$xitem = $query->row();\n			\n\n			if ($service->measurements_type == ''Metric''){\n				\n				$item_weight = $this->__convertWeight($xitem->weight, $xitem->weight_unit, ''kg'');\n				$item_volume = $this->__convertVolume($xitem->volume, $xitem->volume_unit, ''cm3'');\n				$item_volumetric_weight = $item_volume / $service->shipping_factor;\n				\n\n				$weight = $item_weight >= $item_volumetric_weight ? $item_weight : $item_volumetric_weight;\n				$weight *= $item->qty;\n				\n			} else {\n				\n				$item_weight = $this->__convertWeight($xitem->weight, $xitem->weight_unit, ''lb'');\n				$item_volume = $this->__convertVolume($xitem->volume, $xitem->volume_unit, ''in3'');\n				$item_volumetric_weight = $item_volume / $service->shipping_factor;\n				\n				$weight = $item_weight >= $item_volumetric_weight ? $item_weight : $item_volumetric_weight;\n				$weight *= $item->qty;\n				\n			}\n			\n			$total_items += $item->qty;\n			$total_weight += $weight;		\n			\n\n			\n			if ($weight <= $rate->first_weight){\n			    $shipping_rate = $rate->flat_rate + $rate->first_weight_rate;\n			} elseif ($weight >= $rate->max_weight_rate){\n			    $shipping_rate = $rate->flat_rate + $rate->max_weight_rate;\n			} else {\n				$subsequent_rate = ceil(($weight - $rate->first_weight) / $rate->subsequent_weight) * $rate->subsequent_weight_rate;\n			    $shipping_rate = $rate->flat_rate + $rate->first_weight_rate + $subsequent_rate;\n			}\n			\n\n			$total_rates += $shipping_rate;\n\n		}\n\n		$data->total_rate = $total_rates;\n		$data->total_weight = $total_weight;\n		$data->total_items = $total_items;\n		$data->weight_unit = $service->measurements_type == ''Metric'' ? ''kg'' : ''lb'';\n		\n		if ($output == ''json'') echo json_encode($data);\n		else return $data;\n		\n	}\n\n	\n	\n	function Get_item_quantity($output, $args){\n		if ($this->failed) return;\n		\n		$warehouse = $args[''warehouse''] ? $args[''warehouse''] : '''';\n		$item_id = $args[''item_id''] ? $args[''item_id''] : '''';\n		\n		if ($warehouse == ''*'' || $warehouse == ''''){\n			$query = $this->db->query("SELECT SUM(`received`) AS `total_inbound` FROM `purchase_order_items` WHERE `item_id` = ?  GROUP BY `item_id`", array($item_id));\n			$inbound = $query->row();			\n			\n			$query = $this->db->query("SELECT SUM(`received`) AS `total_outbound` FROM `debit_note_items` WHERE `item_id` = ? GROUP BY `item_id`", array($item_id));\n			$returned = $query->row();\n			\n			$query = $this->db->query("SELECT SUM(`received`) AS `total_inbound` FROM `credit_note_items` WHERE `item_id` = ? GROUP BY `item_id`", array($item_id));\n			$c_returned = $query->row();\n			\n			$query = $this->db->query("SELECT SUM(`delivered`) AS `total_outbound`, SUM(`qty`) AS `total_to_outbound` FROM `invoice_items` WHERE `item_id` = ? AND `no_do` IS NULL GROUP BY `item_id`", array($item_id));\n			$invoiced = $query->row();\n			\n			$query = $this->db->query("SELECT SUM(`qty`) AS `total_outbound` FROM `sale_items` WHERE `item_id` = ? AND `sold` = 1  GROUP BY `item_id`", array($item_id));\n			$outbound = $query->row();\n\n		} else {\n			$query = $this->db->query("SELECT SUM(`qty`) AS `total_inbound` FROM `warehouse_movement_items` WHERE `item_id` = ? AND `to_warehouse` = ? GROUP BY `item_id`", array($item_id, $warehouse));\n			$inbound_movement = $query->row();\n			\n			$query = $this->db->query("SELECT SUM(`received`) AS `total_inbound` FROM `purchase_order_items` WHERE `item_id` = ? AND `warehouse_id` = ? GROUP BY `item_id`", array($item_id, $warehouse));\n			$inbound_po = $query->row();			\n			\n			$inbound->total_inbound = $inbound_movement->total_inbound + $inbound_po->total_inbound;\n			\n			$query = $this->db->query("SELECT SUM(`received`) AS `total_outbound` FROM `debit_note_items` WHERE `item_id` = ? AND `warehouse_id` = ? GROUP BY `item_id`", array($item_id, $warehouse));\n			$returned = $query->row();\n			\n			$query = $this->db->query("SELECT SUM(`received`) AS `total_inbound` FROM `credit_note_items` WHERE `item_id` = ? AND `warehouse_id` = ? GROUP BY `item_id`", array($item_id, $warehouse));\n			$c_returned = $query->row();\n			\n			$query = $this->db->query("SELECT SUM(`delivered`) AS `total_outbound`, SUM(`qty`) AS `total_to_outbound` FROM `invoice_items` WHERE `item_id` = ? AND `warehouse_id` = ? AND `no_do` IS NULL GROUP BY `item_id`", array($item_id, $warehouse));\n			$invoiced = $query->row();\n			\n			$query = $this->db->query("SELECT SUM(`qty`) AS `total_outbound` FROM `sale_items` WHERE `item_id` = ? AND `warehouse_id` = ? AND `sold` = 1  GROUP BY `item_id`", array($item_id, $warehouse));\n			$outbound = $query->row();\n		}\n		\n\n		$qty = $inbound->total_inbound - $outbound->total_outbound - $invoiced->total_to_outbound - $returned->total_outbound + $c_returned->total_inbound;\n		\n		$data->qty = $qty;\n		\n		if ($output == ''json'') echo json_encode($data);\n		else return $qty;\n	}\n\n	function Register_fb_user($output, $args){\n		if ($this->failed) return;\n		\n		$userdata = json_decode($this->input->post(''userdata''));\n		\n		$query = $this->db->query("SELECT * FROM `contacts` WHERE `facebook_id` = ?", array($userdata->id));\n		if ($query->num_rows()){\n\n			$session = $username . time();\n			$this->db->query("UPDATE `contacts` SET `current_session` = ? WHERE `facebook_id` = ?", array($session, $userdata->id));\n			\n			$data->data = $session;	\n\n			if ($output == ''json'') echo json_encode($data);\n\n		} else {\n			$this->db->insert(''contacts'', array(\n				''is_customer''		=> 1,\n				''contact_person''	=> $userdata->first_name . '' '' . $userdata->last_name,\n				''contact_number''	=> $this->input->post(''mobile''),\n				''address1''			=> $this->input->post(''address1''),\n				''address2''			=> $this->input->post(''address2''),\n				''city''				=> $this->input->post(''city''),\n				''state''				=> $this->input->post(''state''),\n				''zipcode''			=> $this->input->post(''zipcode''),\n				''country''			=> $this->input->post(''country''),\n				''email''				=> $this->input->post(''email''),\n				''password''			=> $this->input->post(''password''),\n				''added_on''			=> date(''Y-m-d H:i:s''),\n				''added_by''			=> ''@Plexcart'',\n				''tags''				=> ''Online Customer,Facebook User,Unverified''\n			));\n			\n			$data->data = ''ok'';\n			if ($output == ''json'') echo json_encode($data);\n		}\n		\n		$username = $this->input->post(''username'');\n		$password = $this->input->post(''password'');\n\n		$query = $this->db->query("SELECT * FROM `contacts` WHERE `email` = ?", array($username));\n		$customer = $query->row();\n		\n		if ($password == $customer->password){\n		\n			$session = $username . time();\n			$this->db->query("UPDATE `contacts` SET `current_session` = ? WHERE `email` = ?", array($session, $username));\n			\n			$data->data = $session;	\n		\n			if ($output == ''json'') echo json_encode($data);\n		} else {\n		\n			$data->data = ''incorrect'';	\n			if ($output == ''json'') echo json_encode($data);\n			\n		}\n		\n\n		if ($output == ''json'') echo json_encode($data);\n		else return $data;\n		\n	}\n	\n	function Uses_fb_login($output, $args){\n		if ($this->failed) return;\n		\n		$data->enabled = $this->system->config(''online_sales_fb_login'');\n		$data->fb_app_id = $this->system->config(''online_sales_fb_app_id'');\n		$data->fb_app_secret = $this->system->config(''online_sales_fb_app_secret'');\n\n		if ($output == ''json'') echo json_encode($data);\n		else return $data;\n		\n	}\n	\n	function Price_rules($output, $args){\n		if ($this->failed) return;\n		\n		$data->rules = json_encode($this->system->config(''price_rules''));\n		\n		if ($output == ''json'') echo json_encode($data);\n		else return $data;		\n	}\n	\n	function Member_tnc($output, $args){\n		if ($this->failed) return;	\n		\n		$data->tnc = $this->system->config(''member_tnc'');\n\n		if ($output == ''json'') echo json_encode($data);\n		else return $data;\n	}\n	\n	function Request_password_reset($output, $args){\n		if ($this->failed) return;\n		\n		$email	= $this->input->post(''email'');\n		$mobile = $this->input->post(''mobile'');\n		\n		$query = $this->db->query("SELECT * FROM `contacts` WHERE `email` = ? AND `contact_number` = ?", array($email, $mobile));\n		\n		if ($query->num_rows()){\n		\n			$user = $query->row();\n\n			$config[''protocol''] = ''smtp'';\n	    	$config[''mailpath''] = ''/usr/sbin/sendmail'';\n	    	$config[''charset''] = ''iso-8859-1'';\n	    	$config[''wordwrap''] = TRUE;\n	    	$config[''mailtype''] = ''html'';\n	    \n	    	$config[''smtp_host''] = $this->system->config(''online_sales_responder_hostname'');\n	    	$config[''smtp_user''] = $this->system->config(''online_sales_responder_email'');\n	    	$config[''smtp_pass''] = $this->system->config(''online_sales_responder_password'');\n	    	$config[''smtp_port''] = ''25'';\n	\n	    	$this->load->library(''email'');		\n	    	$this->email->initialize($config);\n	    	\n	    	$temp_pass = mt_rand(100,999) . mt_rand(10,99) . mt_rand(100,999);;\n	    	\n	    	$this->db->update(''contacts'', array(\n	    		''password''		=> md5($temp_pass)\n	    	), "`id` = ''{$user->id}''");\n	    	\n	    	$message = $this->__template(nl2br($this->system->config(''online_sales_email_password_reset'')), array(\n	    		''{name}''		=> $user->contact_person,\n	    		''{email}''		=> $user->email,\n	    		''{temp_pass}''	=> $temp_pass\n	    	));\n	\n	    	$this->email->from($this->system->config(''online_sales_responder_email''), $this->system->config(''online_sales_responder_name''));\n	    	$this->email->to($user->email);\n	    	$this->email->bcc($this->system->config(''online_sales_responder_txn_email''));\n	    	$this->email->subject($this->system->config(''online_sales_email_password_reset_subject''));\n	    	$this->email->message($message);\n	    	$this->email->send();\n	    	\n	    	$data->data = ''ok'';\n    	\n    	} else {\n	    	\n	    	$data->data = ''failed'';\n	    	\n    	}\n		\n		\n		if ($output == ''json'') echo json_encode($data);\n		else return $data;\n		\n	}\n	\n	function Reset_password(){\n		\n	}\n	\n	function __convertWeight($value, $from, $to){\n		$unit_ratios = array(\n			''g''		=> 1,\n			''kg''	=> 0.001,\n			''oz''	=> 0.035273962,\n			''lb''	=> 0.0022046226\n		);\n		\n		return ($value / $unit_ratios[$from]) * $unit_ratios[$to];\n	}\n	\n	function __convertVolume($value, $from, $to){\n		$unit_ratios = array(\n			''cm3''	=> 1,\n			''l''		=> 0.001,\n			''in3''	=> 0.0610237441\n		);\n		return ($value / $unit_ratios[$from]) * $unit_ratios[$to];\n	}\n	\n	function __template($template, $data){\n	\n		foreach ($data as $key => $value){\n			$template = str_replace($key, $value, $template);\n		}\n	\n		return $template;\n	}\n\n}', '2012-11-07 18:20:07', 'admin', NULL);
INSERT INTO `editor_revisions` (`id`, `profile_id`, `item`, `contents`, `datetime`, `user`, `commit`) VALUES
(9, 1, '/var/www/_dev/os/application/controllers/pos.php', '<?php\n\nclass POS extends Controller {\n\n    function POS(){\n    	parent::Controller();\n\n    	$this->load->model(''user'');\n    	$this->load->model(''system'');\n    	$this->load->model(''inv'');\n    	$this->load->model(''contact'');\n    	$this->load->model(''credit_cards'');\n    	$this->load->model(''tax'');\n    	$this->load->model(''shipping'');\n\n    	if ($this->uri->segment(1) == ''pos'' && $this->uri->segment(2) == ''terminal''){\n    		// do nothing	\n    		\n    		$ip = $_SERVER[''REMOTE_ADDR''];\n    		$query = $this->db->query("SELECT * FROM `terminals` WHERE `ip` = ?", array($ip));\n    		\n\n\n    		if (!$query->num_rows()){\n\n    			if ($terminal_id = get_cookie(''PLEX_POS_TERM_ID'',true)){\n    				$query = $this->db->query("SELECT * FROM `terminals` WHERE `id` = ?", array($terminal_id));\n    				$terminal = $query->row();\n    				\n    				if (md5($terminal->key . get_cookie(''PLEX_POS_TERM_SESSION'',true)) != get_cookie(''PLEX_POS_TERM_HASH'',true)){\n    					show_error(''Access denied for terminal identifier <strong>'' . get_cookie(''PLEX_POS_TERM_IDENTIFIER'',true) . ''</strong>. Check if your terminal identifier and key is correct.'');\n    				}\n    				\n    			} else {\n    				show_error(''Access denied for IP Address <strong>'' . $_SERVER[''REMOTE_ADDR''] . ''</strong>. Check if your terminal is using Dynamic IP access.'');\n    			}\n    		}\n    		\n    			\n    	} else {\n    		$ip = $_SERVER[''REMOTE_ADDR''];\n    		$query = $this->db->query("SELECT * FROM `terminals` WHERE `ip` = ?", array($ip));\n\n    		if (!$query->num_rows()){\n\n    			if ($terminal_id = get_cookie(''PLEX_POS_TERM_ID'',true)){\n    				$query = $this->db->query("SELECT * FROM `terminals` WHERE `id` = ?", array($terminal_id));\n    				$terminal = $query->row();\n    				\n    				if (md5($terminal->key . get_cookie(''PLEX_POS_TERM_SESSION'',true)) != get_cookie(''PLEX_POS_TERM_HASH'',true)){\n    					show_error(''Access denied for terminal identifier <strong>'' . get_cookie(''PLEX_POS_TERM_IDENTIFIER'',true) . ''</strong>. Check if your terminal identifier and key is correct.'');\n    				}\n    				\n    			} else {\n    				show_error(''Access denied for IP Address <strong>'' . $_SERVER[''REMOTE_ADDR''] . ''</strong>. Check if your terminal is using Dynamic IP access.'');\n    			}\n    		}\n    	}\n    	\n    }\n    \n    function Terminal($identifier, $key){\n    	$query = $this->db->query("SELECT * FROM `terminals` WHERE `identifier` = ? AND `key` = ?", array($identifier, $key));\n\n    	if ($query->num_rows()){\n    		$terminal = $query->row();\n    		$term_session = time();\n    		$expire = 60*60*24*6004; \n\n    		\n    		set_cookie(''PLEX_POS_TERM_ID'',$terminal->id, $expire, $_SERVER[''HTTP_HOST''], ''/'');\n    		set_cookie(''PLEX_POS_TERM_NAME'', $terminal->name, $expire, $_SERVER[''HTTP_HOST''], ''/'');\n    		set_cookie(''PLEX_POS_TERM_IDENTIFIER'', $identifier, $expire, $_SERVER[''HTTP_HOST''], ''/'');\n    		set_cookie(''PLEX_POS_TERM_HASH'', md5($key . $term_session), $expire, $_SERVER[''HTTP_HOST''], ''/'');\n    		set_cookie(''PLEX_POS_TERM_SESSION'', $term_session, $expire, $_SERVER[''HTTP_HOST''], ''/'');\n    		\n    		\n    		redirect(''pos'');\n    	} else {			\n    		show_error(''Access denied for terminal identifier <strong>'' . $identifier . ''</strong>. Check if your terminal identifier and key is correct.'');\n    	}\n    }\n    \n    function Index(){\n\n    	if (!$this->user->check_session()) redirect(''pos/login'');	\n    	redirect(''pos/sales_screen'');\n    				\n    }\n    \n    function Sales_screen(){\n\n    	// IP and Terminal Info\n    	$ip = $this->user->data(''ip'');\n    	if ($ip == ''::1'') $ip = ''localhost'';\n    	$this->d[''terminal''] = get_cookie(''PLEX_POS_TERM_ID'');\n    \n    	// Current user data\n    	$this->d[''user''] 	 = $this->user->data();\n    	$this->d[''username''] = $this->user->data(''username'');\n    	\n    	\n    	// Trigger and Display\n    	$this->d[''trigger_url''] = ''http://localhost/plexports/pos/trigger_drawer/''.$key;\n    	$this->d[''display_url''] = ''http://localhost/plexports/pos/show_display/''.$key;\n    	\n    	\n    	// Quick Items\n    	$query = $this->db->query("SELECT * FROM `inventory` WHERE `quick` = 1");\n    	if (!$query->num_rows()){\n    		$query = $this->db->query("SELECT * FROM `inventory` LIMIT 100");\n    		$this->d[''quick_items''] = $query->result();\n    	} else {\n    		$this->d[''quick_items''] = $query->result();\n    	}\n    	\n    	\n    	// Customers\n    	$query = $this->db->query("SELECT * FROM `contacts` ORDER BY `company_name`, `contact_person` ASC");\n    	$customers[] = ''Select Customer'';\n    	foreach ($query->result() as $customer){\n    		$customers[$customer->id] = $customer->company_name ? $customer->company_name : $customer->contact_person; \n    	}\n    	$this->d[''customers''] = $customers;\n    	\n    	\n    	// Members\n    	if ($this->system->config(''member_points'')){\n    		$members[] = ''Select Customer'';\n    		$query = $this->db->query("SELECT * FROM `contacts` ORDER BY `company_name`, `contact_person` ASC");\n    		foreach ($query->result() as $member){\n    			$members[$member->id] = $member->company_name ? $member->company_name : $member->contact_person; \n    		}\n    		$this->d[''members''] = $members;\n    	}\n    	\n    	\n    	// Credit cards\n    	$cces = $this->credit_cards->get_card_options();\n    	foreach ($cces as $cc){\n    		$cc_array[$cc->id] = $cc->name;\n    	}\n    	$this->d[''cc_array''] = $cc_array;\n    	\n    	$this->d[''taxes''] = $this->tax->get_enabled_taxes();\n    	$this->d[''shipping''] = $this->shipping->get_delivery_services();\n    	\n    	// POS interface\n    	$this->load->view(''retail/main'', $this->d);\n\n    }\n    \n\n    function Login($err){\n    	if ($this->user->check_session()) redirect(''pos'');\n    	if ($err == ''err1'') $this->d[''notice''] = ''Incorrect username or password.'';\n    	if ($err == ''err2'') $this->d[''notice''] = ''User is already logged in.'';\n    	$this->load->view(''retail/login'',$this->d);\n    }\n    \n    function Auth(){\n    	if ($this->user->check_session()) redirect(''pos'');\n    	\n    	$user = $this->user->get_user_by_username($this->input->post(''username''));\n    	if ($user->terminal_active == 1) redirect(''pos/login/err2'');\n    	\n    	if ($this->user->login()) redirect(''pos'');\n    	else redirect(''pos/login/err1'');\n    }\n    \n    function Receipt(){\n    	$this->load->view(''retail/receipt'');\n    }\n    \n    function Ajax($request){\n    	header(''Content-type: application/json'');\n    	switch ($request){\n    		case "return_to_queue":\n    			if ($this->system->config(''revert_level'') == ''Manager''){\n    				$username = $this->input->post(''username'');\n    				$password = $this->input->post(''password'');\n    				$manager = true;\n    			}\n    			\n    			$user = $this->user->get_user_by_username($username);\n    			$query = $this->db->query("SELECT * FROM `permissions` WHERE `user_type` = ?", array($user->type));\n    			$permission = $query->row();\n    			\n    			$action = json_decode($permission->action);\n    			\n    			if ($manager){\n    				if (!$action->sales->to_supervise_pos){\n    					$obj->status = ''Failed'';\n    					echo json_encode($obj);\n    					return;\n    				} else {\n    					if ($user->password !== md5($password)){\n    						$obj->status = ''Failed'';\n    						echo json_encode($obj);\n    						return;\n    					}\n    				}\n    			}\n    			\n    			$queue_id = $this->input->post(''queue'');\n    			\n    			$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?", array($queue_id));\n    			$sale = $query->row();\n    			\n    			$query = $this->db->query("SELECT * FROM `sale_items` WHERE `sale_id` = ?", array($queue_id));\n    			$sale_items = $query->result();\n    			\n    			$data->sale = $sale;\n    			$data->sale_items = $sale_items;\n\n    			$sql = $this->db->update_string(''sales'',array(\n    				''type''		=> ''queue'',\n    				''session''	=> $this->user->data(''terminal_session'')\n    			), "`id` = ''$queue_id''");	\n    			$this->db->query($sql);\n    			\n    			$sql = $this->db->insert_string(''reverts'',array(\n    				''performed_by''  => $manager ? $username : $employee->username,\n    				''data''			=> json_encode($data),\n    				''datetime''		=> date(''Y-m-d H:i:s'')\n    			));\n    			\n    			$this->db->query($sql);\n    			\n    			$obj->status = ''Success'';\n    			echo json_encode($obj);\n    			break;\n\n    		case "receipt":\n    			$queue_id = $this->input->post(''queue'');\n    			$type = $this->input->post(''type'');\n    			\n    			if ($type == ''invoice''){\n    				$query = $this->db->query("SELECT * FROM `invoices` WHERE `id` = ?",array($queue_id));\n    				$sale = $query->row();\n    				$date = date("d/m/Y", strtotime($sale->date));	\n    			} else {\n    				$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?",array($queue_id));\n    				$sale = $query->row();\n    				$date = date("H:i:s d/m/Y", strtotime($sale->datetime));				\n    				for ($i = 0; $i < 6 - strlen($sale->id); $i++){\n    					$trailing_zeroes .= ''0'';\n    				}\n\n    			}\n    			\n    			if ($sale->customer_id){\n    				$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($sale->customer_id));\n    				$contact = $query->row();\n    			}\n    			\n    			if ($type == ''invoice''){\n    				\n    				\n    				if ($this->system->config(''receipt_type'') == ''3 Inch''){\n    					\n    					$output .= "<span style=\\"float: right\\">Inv/DO No.: " . $trailing_zeroes . $sale->id . "</span>{$date}";\n    					$output .= "Prep By: " . $sale->added_by;\n    					\n    					\n    					$output .= "<hr />";\n    					$output .= "<table style=\\"border-collapse: collapse; width: 100%; font-size: 8px\\">";\n    					$query = $this->db->query("SELECT * FROM `invoice_items` WHERE `invoice_id` = ?",array($queue_id));\n    					foreach ($query->result() as $item){\n    						\n    						$output .= "<tr>\n    							<td style=\\"width: 40%\\"><strong style=\\"font-size: 8pt\\">{$item->item_name}</strong><br />{$item->item_sku}</td>\n    							<td style=\\"width: 22%; text-align: center;\\">{$item->qty}</td>\n    							<td style=\\"width: 23%; text-align: right;\\">{$item->delivered_price}</td>\n    						</tr>";\n    						\n    						$subtotal = $grand_total += $item->delivered_price;\n    					}\n    					\n    					$subtotal_display = number_format($subtotal, 2);\n    					$grand_total_display = number_format($sale->total_delivered,2);\n    					$handling_display = number_format($sale->handling_charges,2);\n    					\n    					$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"2\\">Subtotal</td>\n    									<td style=\\"width: 23%; text-align: right\\">{$subtotal_display}</td>\n    								</tr>";\n    				\n    					$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"2\\">Handling Charges</td>\n    									<td style=\\"width: 23%; text-align: right;\\">{$handling_display}</td>\n    								</tr>";\n    					\n    					\n    					$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"2\\">Grand Total</td>\n    									<td style=\\"width: 23%; text-align: right;\\">{$grand_total_display}</td>\n    								</tr>";\n    					\n    					\n    				\n    				} else {\n    				\n    				\n    					$output .= "<span style=\\"float: right\\">Inv/DO No.: " . $trailing_zeroes . $sale->id . "</span>{$date}";\n    					$output .= "Prep By: " . $sale->added_by;\n    				\n    					$output .= "<table style=\\"border-collapse: collapse; width: 100%; font-size: 8px; margin-top: 10px\\">";\n    					$output .= "<thead style=\\"border-bottom: 2px solid #000; padding-top: 10px;\\"><tr><th style=\\"text-align: left\\">Item</th><th style=\\"text-align: center\\">Serial No.</th><th style=\\"text-align: center\\">Qty</th><th style=\\"text-align: right\\">Price</th></tr></thead>";\n    					$query = $this->db->query("SELECT * FROM `invoice_items` WHERE `invoice_id` = ?",array($queue_id));\n    					foreach ($query->result() as $item){\n    						\n    						$output .= "<tr>\n    							<td style=\\"width: 50%;\\"><strong style=\\"font-size: 8pt\\">{$item->item_name}</strong><br />{$item->item_sku}</td>\n    							<td style=\\"width: 15%; text-align: center;\\">{$item->serial_no}</td>\n    							<td style=\\"width: 15%; text-align: center;\\">{$item->qty}</td>\n    							<td style=\\"width: 20%; text-align: right;\\">{$item->delivered_price}</td>\n    						</tr>";\n    						\n    						$grand_total += $item->amount;\n    					}\n    					\n    					$output .= "<tr><td style=\\"padding: 10px;\\" colspan=\\"4\\">&nbsp;</td></tr>";\n    				\n    					\n    					$subtotal_display = number_format($subtotal, 2);\n    					$grand_total_display = number_format($sale->total_delivered,2);\n    					$handling_display = number_format($sale->handling_charges,2);\n    					\n    					$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"2\\">Subtotal</td>\n    									<td style=\\"width: 23%; text-align: right\\">{$subtotal_display}</td>\n    								</tr>";\n    				\n    					$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"2\\">Handling Charges</td>\n    									<td style=\\"width: 23%; text-align: right;\\">{$handling_display}</td>\n    								</tr>";\n    					\n    					$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"3\\">Grand Total</td>\n    									<td style=\\"text-align: right;\\">{$grand_total_display}</td>\n    								</tr>";\n    					\n    					\n    					if ($this->system->config(''checkout_cc'')){\n    						if ($sale->amount_cc != 0){\n    							$show_cash = true;\n    							$amount_cc_display = number_format($sale->amount_cc,2);\n    							$output .=  "<tr>\n    										<td colspan=\\"3\\">Credit Card Tendered ({$sale->card_type})</td>\n    										<td style=\\"text-align: right;\\">{$amount_cc_display}</td>\n    									</tr>";\n    							\n    						}\n    					}\n    				\n    					if ($this->system->config(''checkout_cheque'')){				\n    						if ($sale->amount_cheque != 0){\n    							$show_cash = true;\n    							$amount_cheque_display = number_format($sale->amount_cheque,2);\n    							$output .=  "<tr>\n    										<td colspan=\\"3\\">Cheque Tendered</td>\n    										<td style=\\"text-align: right;\\">{$amount_cheque_display}</td>\n    									</tr>";\n    						}\n    					}\n    					\n    				\n    					\n    					if ($this->system->config(''checkout_credit'')){\n    					\n    						if ($sale->amount_credit != 0){\n    							$show_cash = true;\n    							$amount_credit_display = number_format($sale->amount_credit,2);\n    							$total = number_format($this->contact->get_total_credit($sale->customer_id),2);\n    							\n    							$customer = $this->contact->get_customer_by_id($sale->customer_id);\n    							$credit_limit = number_format($customer->credit_limit,2);\n    							$available_credit = number_format($this->contact->get_credit_balance($sale->customer_id),2);\n    							\n    							\n    							$output .=  "<tr>\n    										<td colspan=\\"3\\">Credit Amount</td>\n    										<td style=\\"text-align: right;\\">{$amount_credit_display}</td>\n    									</tr>";\n    									\n    				\n    							$coutput .=  "<tr>\n    										<td colspan=\\"3\\">Credit Limit</td>\n    										<td style=\\"text-align: right\\">{$credit_limit}</td>\n    									</tr>";\n    				\n    				\n    							$coutput .=  "<tr>\n    										<td colspan=\\"3\\">Available Credit Limit</td>\n    										<td style=\\"text-align: right\\">{$available_credit}</td>\n    									</tr>";			\n    						\n    						}\n    					}\n    					\n    					if ($show_cash){				\n    						if ($sale->amount_cash){\n    							$show_cash = true;\n    							$amount_cheque_display = number_format($sale->amount_cheque,2);\n    							$output .=  "<tr>\n    										<td colspan=\\"3\\">Cash Tendered</td>\n    										<td style=\\"text-align: right;\\">{$amount_cheque_display}</td>\n    									</tr>";\n    						}\n    					}\n    					\n    					if ($coutput){\n    						$output .= "<tr style=\\"border-bottom: 1px solid #000\\"><td colspan=\\"4\\"></td></tr>";\n    						$output .= $coutput;\n    					}\n    					\n    					$output .= "</table>";\n    				\n    				\n    				}\n    				\n    			} else {\n    			\n    				if ($this->system->config(''receipt_type'') == ''3 Inch''){\n    					\n    					$output .= "<span style=\\"float:right\\">Rec No.: " . $trailing_zeroes . $sale->id . "</span>Date: {$date}";\n    					$output .= "&nbsp;&nbsp;&nbsp;&nbsp;Cashier: " . $this->user->data(''username'');\n						if ($contact){\n	    					$output .= "<br />Member: " . $contact->contact_person;\n	    					$output .= "&nbsp;&nbsp;&nbsp;&nbsp;Member ID: " . $contact->ic;\n						}\n    					\n    					$output .= "<hr />";\n    					$output .= "<table style=\\"border-collapse: collapse; width: 100%; font-size: 8px\\">";\n    					$query = $this->db->query("SELECT * FROM `sale_items` WHERE `sale_id` = ?",array($queue_id));\n    					foreach ($query->result() as $item){\n    						\n    						$output .= "<tr>\n    							<td style=\\"width: 40%\\"><strong style=\\"font-size: 8pt\\">{$item->item_name}</strong><br />{$item->item_sku}</td>\n    							<td style=\\"width: 22%; text-align: center;\\">{$item->qty}</td>\n    							<td style=\\"width: 23%; text-align: right;\\">{$item->amount}</td>\n    						</tr>";\n    						\n    						$subtotal = $grand_total += $item->amount;\n    					}\n    					\n    					$grand_total_display = number_format($sale->amount,2);\n    					$discount_display = number_format($grand_total - $sale->amount,2);\n    					$amount_tendered_display = number_format($sale->amount_tendered,2);\n    					$amount_change_display = number_format($sale->amount_change,2);\n    					$subtotal_display = number_format($subtotal,2);\n    					$discount = $sale->discount;\n    					\n    					\n    					$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"2\\">Subtotal</td>\n    									<td style=\\"width: 23%; text-align: right\\">{$subtotal_display}</td>\n    								</tr>";\n    					\n    					if ($discount){\n    						if ($sale->discount_type == ''p''){\n    							$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"2\\">Discount {$discount}%</td>\n    									<td style=\\"width: 23%; text-align: right;\\">{$discount_display}</td>\n    								</tr>";\n    								\n    						} else {\n    							$discount_d = number_format($discount,2);\n    							$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"2\\">Discount RM{$discount_d}</td>\n    									<td style=\\"width: 23%; text-align: right;\\">{$discount_display}</td>\n    								</tr>";\n    						}\n    					}\n    					\n    					if ($sale->shipping_amount){\n   							$output .= "<tr>\n    									<td colspan=\\"3\\">Shipping ($sale->shipping_name)</td>\n    									<td style=\\"text-align: right;\\">{$sale->shipping_amount}</td>\n    								</tr>";\n    					}\n    					\n    					\n    					$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"2\\">Grand Total</td>\n    									<td style=\\"width: 23%; text-align: right;\\">{$grand_total_display}</td>\n    								</tr>\n    								<tr>\n    									<td colspan=\\"2\\">Amount Tendered</td>\n    									<td style=\\"width: 23%; text-align: right;\\">{$amount_tendered_display}</td>\n    								</tr>";\n    					\n    					$output .=  "<tr>\n    									<td colspan=\\"2\\">Change</td>\n    									<td style=\\"width: 23%; text-align: right;\\">{$amount_change_display}</td>\n    								</tr></table>";\n    								\n    					if ($sale->remarks){\n    						$output .=  "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"4\\">\n    										Remarks: {$sale->remarks}\n    									</td>\n    								</tr>";\n	    					\n    					}\n\n    					\n    					if ($this->system->config(''checkout_cc'')){\n    						if ($sale->amount_cc){\n    							$show_cash = true;\n    							$amount_cc_display = number_format($sale->amount_cc,2);\n    							$output .=  "<tr>\n    										<td colspan=\\"2\\">Credit Card Tendered ({$sale->card_type})</td>\n    										<td style=\\"width: 23%; text-align: right;\\">{$amount_cc_display}</td>\n    									</tr></table>";\n    							\n    						}\n    					}\n    				\n    					if ($this->system->config(''checkout_cheque'')){				\n    						if ($sale->amount_cheque){\n    							$show_cash = true;\n    							$amount_cheque_display = number_format($sale->amount_cheque,2);\n    							$output .=  "<tr>\n    										<td colspan=\\"2\\">Cheque Tendered</td>\n    										<td style=\\"width: 23%; text-align: right;\\">{$amount_cheque_display}</td>\n    									</tr></table>";\n    						}\n    					}\n    					\n    					if ($this->system->config(''checkout_credit'')){\n    					\n    						if ($sale->amount_credit){\n    							$show_cash = true;\n    							$amount_credit_display = number_format($sale->amount_credit,2);\n    							$total = number_format($this->contact->get_total_credit($sale->customer_id));\n    							$output .=  "<tr>\n    										<td colspan=\\"2\\">Credit Amount</td>\n    										<td style=\\"width: 23%; text-align: right;\\">{$amount_cheque_display}</td>\n    									</tr></table>";\n    							$output .=  "<tr>\n    										<td colspan=\\"2\\">Total Credit Amount</td>\n    										<td style=\\"width: 23%; text-align: right;\\">{$amount_cheque_display}</td>\n    									</tr></table>";\n    				\n    						\n    						}\n    					}\n    				\n    				} else {\n    				\n    				\n    					$output .= "<span style=\\"float:right\\">Rec No.: " . $trailing_zeroes . $sale->id . "</span>Date: {$date}";\n    					$output .= "&nbsp;&nbsp;&nbsp;&nbsp;Cashier: " . $this->user->data(''username'');\n						if ($contact){\n	    					$output .= "<br />Member: " . $contact->contact_person;\n	    					$output .= "&nbsp;&nbsp;&nbsp;&nbsp;Member ID: " . $contact->ic;\n						}\n    					\n    				\n    					$output .= "<table style=\\"border-collapse: collapse; width: 100%; font-size: 8px; margin-top: 10px\\">";\n    					$output .= "<thead style=\\"border-bottom: 2px solid #000; padding-top: 10px;\\"><tr><th style=\\"text-align: left\\">Item</th><th style=\\"text-align: center\\">Serial No.</th><th style=\\"text-align: center\\">Qty</th><th style=\\"text-align: right\\">Price</th></tr></thead>";\n    					$query = $this->db->query("SELECT * FROM `sale_items` WHERE `sale_id` = ?",array($queue_id));\n    					foreach ($query->result() as $item){\n    						\n    						$output .= "<tr>\n    							<td style=\\"width: 50%;\\"><strong style=\\"font-size: 8pt\\">{$item->item_name}</strong><br />{$item->item_sku}</td>\n    							<td style=\\"width: 15%; text-align: center;\\">{$item->serial_no}</td>\n    							<td style=\\"width: 15%; text-align: center;\\">{$item->qty}</td>\n    							<td style=\\"width: 20%; text-align: right;\\">{$item->amount}</td>\n    						</tr>";\n    						\n    						$grand_total += $item->amount;\n    					}\n    					\n    					$output .= "<tr><td style=\\"padding: 10px;\\" colspan=\\"4\\">&nbsp;</td></tr>";\n    				\n    					\n    					$grand_total_display = number_format($sale->amount,2);\n    					$discount_display = number_format($grand_total - $sale->amount,2);\n    					$amount_tendered_display = number_format($sale->amount_tendered,2);\n    					$amount_change_display = number_format($sale->amount_change,2);\n    					$discount = $sale->discount;\n    					\n    					if ($discount){\n    						if ($sale->discount_type == ''p''){\n    							$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"3\\">Discount {$discount}%</td>\n    									<td style=\\"text-align: right;\\">{$discount_display}</td>\n    								</tr>";\n    								\n    						} else {\n    							$discount_d = number_format($discount,2);\n    							$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"3\\">Discount RM{$discount_d}</td>\n    									<td style=\\"text-align: right;\\">{$discount_display}</td>\n    								</tr>";\n    						}\n    					}\n    					\n    					if ($sale->shipping_amount){\n   							$output .= "<tr>\n    									<td colspan=\\"3\\">Shipping ($sale->shipping_name)</td>\n    									<td style=\\"text-align: right;\\">{$sale->shipping_amount}</td>\n    								</tr>";\n    					}\n    					\n    					$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"3\\">Grand Total</td>\n    									<td style=\\"text-align: right;\\">{$grand_total_display}</td>\n    								</tr>\n    								<tr>\n    									<td colspan=\\"3\\">Amount Tendered</td>\n    									<td style=\\"text-align: right;\\">{$amount_tendered_display}</td>\n    								</tr>";\n    					\n    					$output .=  "<tr>\n    									<td colspan=\\"3\\">Change</td>\n    									<td style=\\"text-align: right;\\">{$amount_change_display}</td>\n    								</tr>";\n    								\n    					if ($sale->remarks){\n    						$output .=  "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"4\\">\n    										Remarks: {$sale->remarks}\n    									</td>\n    								</tr>";\n	    					\n    					}\n    					\n    					if ($this->system->config(''checkout_cc'')){\n    						if ($sale->amount_cc != 0){\n    							$show_cash = true;\n    							$amount_cc_display = number_format($sale->amount_cc,2);\n    							$output .=  "<tr>\n    										<td colspan=\\"3\\">Credit Card Tendered ({$sale->card_type})</td>\n    										<td style=\\"text-align: right;\\">{$amount_cc_display}</td>\n    									</tr>";\n    							\n    						}\n    					}\n    				\n    					if ($this->system->config(''checkout_cheque'')){				\n    						if ($sale->amount_cheque != 0){\n    							$show_cash = true;\n    							$amount_cheque_display = number_format($sale->amount_cheque,2);\n    							$output .=  "<tr>\n    										<td colspan=\\"3\\">Cheque Tendered</td>\n    										<td style=\\"text-align: right;\\">{$amount_cheque_display}</td>\n    									</tr>";\n    						}\n    					}\n    					\n    				\n    					\n    					if ($this->system->config(''checkout_credit'')){\n    					\n    						if ($sale->amount_credit != 0){\n    							$show_cash = true;\n    							$amount_credit_display = number_format($sale->amount_credit,2);\n    							$total = number_format($this->contact->get_total_credit($sale->customer_id),2);\n    							\n    							$customer = $this->contact->get_customer_by_id($sale->customer_id);\n    							$credit_limit = number_format($customer->credit_limit,2);\n    							$available_credit = number_format($this->contact->get_credit_balance($sale->customer_id),2);\n    							\n    							\n    							$output .=  "<tr>\n    										<td colspan=\\"3\\">Credit Amount</td>\n    										<td style=\\"text-align: right;\\">{$amount_credit_display}</td>\n    									</tr>";\n    									\n    				\n    							$coutput .=  "<tr>\n    										<td colspan=\\"3\\">Credit Limit</td>\n    										<td style=\\"text-align: right\\">{$credit_limit}</td>\n    									</tr>";\n    				\n    				\n    							$coutput .=  "<tr>\n    										<td colspan=\\"3\\">Available Credit Limit</td>\n    										<td style=\\"text-align: right\\">{$available_credit}</td>\n    									</tr>";			\n    						\n    						}\n    					}\n    					\n    					if ($show_cash){				\n    						if ($sale->amount_cash){\n    							$show_cash = true;\n    							$amount_cheque_display = number_format($sale->amount_cheque,2);\n    							$output .=  "<tr>\n    										<td colspan=\\"3\\">Cash Tendered</td>\n    										<td style=\\"text-align: right;\\">{$amount_cheque_display}</td>\n    									</tr>";\n    						}\n    					}\n    					\n    					if ($coutput){\n    						$output .= "<tr style=\\"border-bottom: 1px solid #000\\"><td colspan=\\"4\\"></td></tr>";\n    						$output .= $coutput;\n    					}\n    					\n    					$output .= "</table>";\n    				\n    				\n    				}\n\n    			\n    			}\n    			\n    			\n    			\n    			$obj[''status''] = ''Success'';\n    			$obj[''html''] = $output;\n    			\n    			echo json_encode($obj);\n    			\n    			break;\n    		case "add_queue":\n    			$sql = $this->db->insert_string(''sales'',array(\n    				''type''				=> ''queue'',\n    				''payment_status'' 	=> ''Unpaid'',\n    				''username''			=> $this->user->data(''username''),\n    				''user_id''			=> $this->user->data(''id''),\n    				''terminal''			=> $this->user->terminal(),\n    				''session''			=> $this->user->data(''terminal_session'')\n    			));\n    			$query = $this->db->query($sql);\n    			\n    			$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?",array($query->insert_id));\n    			$obj = $query->row();\n    			$obj->status = ''Success'';\n    			echo json_encode($obj);\n    			\n    			break;\n    		case "void_queue":\n    			$queue_id = $this->input->post(''queue'');\n    			$this->db->query("DELETE FROM `sales` WHERE `id` = ? AND `type` = ''queue''",array($queue_id));\n    			\n    			$obj[''status''] = ''Success'';\n    			echo json_encode($obj);\n    		\n    			break;\n    		case "add_item":\n    			$queue_id = $this->input->post(''queue'');\n    			$sku = $this->input->post(''sku'');\n    			$qty = $this->input->post(''qty'');\n    			\n    			if ($sku[0] == ''x'' OR $sku[0] == ''X''){\n    				$qty = str_replace(''X'','''',str_replace(''x'','''',$sku)) - 1;\n    				$sku = $this->session->userdata(''last_sku'');\n    				if (!is_numeric($qty)) $sku = '''';\n    			} else {\n    				$this->session->set_userdata(array(''last_sku''=>$sku));\n    			}\n    			\n    			$query = $this->db->query("SELECT * FROM `inventory` WHERE `sku` = ?",array($sku));\n    			if (!$query->num_rows()){\n    				// secondary SKU search\n    				$found = false;\n    				for ($i = 2; $i <= 4; $i++){\n    					$query = $this->db->query("SELECT * FROM `inventory` WHERE `sku{$i}` = ?", array($sku));\n    					if ($query->num_rows()){\n    						$item = $obj = $query->row();\n    						\n    						$qty = $qty * $item->{''loose_qty''.$i};\n    						$qty_fraction = $item->{''loose_qty''.$i};\n\n    						$sku = $item->sku;\n    						$sku2 = $item->{''sku''.$i};\n    						\n    						$sku_select = $i;\n    						$found = true;\n    					}\n    				}\n    			} else {\n    				$sku_select = 1;\n    				$qty_fraction = 1;\n    				$item = $obj = $query->row();\n    				$found = true;\n    			}\n    			\n    			$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?", array($queue_id));\n    			$sale = $query->row();\n    			\n    			$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($sale->customer_id));\n    			if ($query->num_rows()){\n    				$customer = $query->row();\n    			} else {\n    				$customer = false;\n    			}\n    			\n    			if ($found){\n    			\n    				if ($sku_select == 1){\n    					$query = $this->db->query("SELECT * FROM `sale_items` WHERE `item_sku` = ? AND `sku_select` = ''1'' AND `sale_id` = ?",array($sku,$queue_id));\n    				} else {\n    					$query = $this->db->query("SELECT * FROM `sale_items` WHERE `item_sku2` = ? AND `sale_id` = ?",array($sku2,$queue_id));\n    				}\n    				\n    				if ($item->enter_price) $obj->enter_price = true;\n    				if ($item->enter_serial) $obj->enter_serial = true;\n    				\n    				$price_rules = json_decode($this->system->config(''price_rules''));\n    				\n    				if (!$query->num_rows()){\n    					\n    					if ($this->system->config(''cost_update_method'') == ''fifo''){\n    						$item_cost = $this->inv->get_fifo_cost($item->id, $qty);\n    					} else {\n    						$item_cost = $item->cost * $qty;\n    					}\n    					\n    					\n    						\n    					if ($sku_select == 1){\n    						\n    						if ($customer->rank){\n	    						$item_price = $item->{''price''.$price_rules->{str_replace('' '',''_'',$customer->rank)}};\n	    					} else {\n		    					$item_price = $item->price;\n		    				}\n\n    						$margin = ($item_price * $qty) - $item_cost;\n    					} else {\n    						\n    						if ($customer->rank){\n	    						$item_price = $item->{''price''.$sku_select.$price_rules->{str_replace('' '',''_'',$customer->rank)}};\n	    					} else {\n	    						$item_price = $item->{''price''.$sku_select};\n		    				}\n\n\n    						$margin = ($item_price * $qty / $qty_fraction) - $item_cost;\n    					}\n    					\n    					$sql = $this->db->insert_string(''sale_items'',array(\n    						''sale_id''		=> $queue_id,\n    						''item_id''		=> $item->id,\n    						''date''			=> date(''Y-m-d''),\n    						''item_sku''		=> $sku,\n    						''item_sku2''		=> $sku2,\n    						''item_name''		=> $item->name,\n    						''unit''			=> $item->{''uom''.$sku_select},\n    						''qty''			=> $qty,\n    						''qty_fraction''	=> $qty_fraction,\n    						''sku_select''	=> $sku_select,\n    						''price_per_unit''=> $item_price,\n    						''cost''			=> $item_cost,\n    						''margin''		=> $margin,\n    						''terminal''		=> $this->user->terminal(),\n    						''points''		=> $item->redeem_points,\n    						''session''		=> $this->user->data(''terminal_session''),\n    						''amount''		=> $item_price * ($qty / $qty_fraction)\n    					));\n    					$query = $this->db->query($sql);\n    					$obj->id = $query->insert_id;\n    					$obj->status = ''Success'';\n    					$obj->amount = number_format($item_price * $qty,2);\n    					$obj->qty = $qty;\n    					$obj->name = $item->name;\n    					$obj->price = $item_price;\n    					$obj->outstanding = ($val = $this->update_amount($queue_id)) ? number_format($val,2) : ''0.00'' ;\n\n\n    					\n    				} else {\n    					$existing_item = $query->row();\n    					\n    					if ($this->system->config(''cost_update_method'') == ''fifo''){\n    						$item_cost = $this->inv->get_fifo_cost($item->id, $qty);\n    					} else {\n    						$item_cost = $item->cost * $qty;\n    					}\n    					\n    					if ($sku_select == 1){\n    						$sql = $this->db->update_string(''sale_items'',array(\n    							''qty''			=> $existing_item->qty + $qty,\n    							''cost''			=> $existing_item->cost + ($item_cost),\n    							''margin''		=> $existing_item->margin + (($item->price - $item->cost) * $qty),\n    							''amount''		=> $existing_item->amount + ($item->price * $qty),\n    							''points''		=> $item->redeem_points\n    						),"`sale_id` = ''$queue_id'' AND `item_sku` = ''{$sku}'' AND `sku_select` = 1");\n    					} else {\n    						$item_price = $item->{''price''.$sku_select};\n    						$sql = $this->db->update_string(''sale_items'',array(\n    							''qty''			=> $existing_item->qty + $qty,\n    							''cost''			=> $xcost = $existing_item->cost + ($item_cost),\n    							''amount''		=> $xamount = $existing_item->amount + ($item_price * ($qty / $qty_fraction)),\n    							''margin''		=> $xamount - $xcost,\n    							''points''		=> $item->redeem_points\n    						),"`sale_id` = ''$queue_id'' AND `item_sku2` = ''{$sku2}''");\n    					}\n\n    					$this->db->query($sql);\n    					$obj->status = ''Success'';\n    					$obj->amount = number_format($item->price * $qty,2);\n    					$obj->qty = $qty;\n    					$obj->name = $item->name;\n    					$obj->price = $item->price;\n    					$obj->outstanding = ($val = $this->update_amount($queue_id)) ? number_format($val,2) : ''0.00'' ;\n    					$obj->id = $existing_item->id;\n    				}\n    				\n\n    				\n    			} else {\n    				$obj[''outstanding''] = ($val = $this->update_amount($queue_id)) ? number_format($val,2) : ''0.00'' ;\n    				$obj[''status''] = ''Failed'';\n    			}\n    			echo json_encode($obj);\n\n    			break;\n    			\n    		case "enter_discount":\n    			$item_id	= $this->input->post(''item_id'');\n    			$queue_id	= $this->input->post(''queue_id'');\n    			$type		= $this->input->post(''discount_type'');\n    			$value		= $this->input->post(''discount_value'');\n    			$to			= $this->input->post(''to'');\n    			\n    			if ($to == ''item''){\n    				$query = $this->db->query("SELECT * FROM `sale_items` WHERE `id` = ?", array($item_id));\n    				$sale_item = $query->row();\n    				\n    				$total = $sale_item->price_per_unit * ($sale_item->qty / $sale_item->qty_fraction);\n    				\n    				if ($type == ''d'') $amount = $total - $value;\n    				else $amount = $total * ((100 - $value) / 100);\n    				\n    				\n    				$sql = $this->db->update_string(''sale_items'', array(\n    					''discount_type''		=> $type,\n    					''discount_value''	=> $value,\n    					''discount_amount''	=> $discount_acount,\n    					''amount''			=> $amount\n    				), "`id` = ''{$item_id}''");\n    				\n    				$this->db->query($sql);\n    			} else {\n    				\n    				\n    			\n    				$sql = $this->db->update_string(''sales'', array(\n    					''discount_type''	=> $type,\n    					''discount''		=> $value\n    				), "`id` = ''{$queue_id}''");\n    				\n    				$this->db->query($sql);\n    				\n    				$sql = $this->db->update_string(''sale_items'', array(\n    					''global_discount_type''	=> $type,\n    					''global_discount''		=> $value\n    				), "`sale_id` = ''{$queue_id}''");\n    				$this->db->query($sql);\n\n    			}\n    			\n    			break;\n    			\n    		case "enter_serial":\n    			$id = $this->input->post(''id'');\n    			$serial = $this->input->post(''serial'');\n    			\n    			$query = $this->db->query("SELECT * FROM `sale_items` WHERE `id` = ?", array($id));\n    			$sale_item = $query->row();\n    			\n    			if ($sale_item->serial_no){\n    				$serial_no = $sale_item->serial_no . '', '' . $serial;\n    			} else {\n    				$serial_no = $serial;\n    			}\n    			\n    			$sql = $this->db->update_string(''sale_items'',array(\n    				''serial_no''	=> $serial_no\n    			), "`id` = ''$id''");\n    			\n    			$this->db->query($sql);\n    			\n    			break;\n    		case "enter_price":\n    			$id = $this->input->post(''id'');\n    			$price = $this->input->post(''price'');\n    			$qty = $this->input->post(''qty'');\n    			$replace = $this->input->post(''replace'');\n    			\n\n    			$query = $this->db->query("SELECT * FROM `sale_items` WHERE `id` = ?", array($id));\n    			$sale_item = $query->row();\n    			\n    			$query = $this->db->query("SELECT * FROM `inventory` WHERE `id` = ?", array($sale_item->item_id));\n    			$item = $query->row();\n    			\n    			$markup = (($item->price - $item->cost) / $item->cost) * 100;\n\n    			if ($replace){\n\n    				if ($item->adjust_cost){\n    					$sale_item->cost = (100 / ($markup + 100)) * $price;\n    				}\n    				\n    				$sale_item->amount = $price;\n    				$sale_item->margin = $sale_item->amount - $sale_item->cost;\n    				$sale_item->price_per_unit = $sale_item->amount / $sale_item->qty;				\n\n    			} else {\n    			\n    				if ($item->adjust_cost){\n    					$sale_item->cost = (100 / ($markup + 100)) * $price;\n    				}\n    				\n    				$sale_item->amount += ($price * $qty) - ($item->price * $qty);\n    				$sale_item->margin = ($sale_item->amount * $qty) - ($sale_item->cost * $qty);\n    				$sale_item->price_per_unit = $sale_item->amount / $sale_item->qty;\n    			\n    			}\n    			\n    			\n    			\n    			$this->db->query($this->db->update_string(''sale_items'', array(\n    				''cost''			=> $sale_item->cost,\n    				''amount''		=> $sale_item->amount,\n    				''margin''		=> $sale_item->margin,\n    				''price_per_unit''=> $sale_item->price_per_unit\n    			), "`id` = ''$id''"));\n    			\n    			$this->update_amount($sale_item->sale_id);\n    			\n    			\n    			break;\n    		case "void_item":\n    			$queue_id = $this->input->post(''queue'');\n    			$queue_item_id = $this->input->post(''item'');\n    			\n    			$this->db->query("DELETE FROM `sale_items` WHERE `id` = ?",array($queue_item_id));\n    			$this->update_amount($queue_id);\n    			$obj[''status''] = ''Success'';\n    			\n    			$this->session->set_userdata(array(''last_sku''=>''''));\n    			\n    			echo json_encode($obj);\n    		\n    			break;\n    		case "cash_checkout":\n    			$queue_id = $this->input->post(''queue'');\n    			$amount_tendered = $this->input->post(''amount_tendered'');\n    			\n    			$amount_cc = $this->input->post(''amount_cc'');\n    			$amount_cheque = $this->input->post(''amount_cheque'');\n    			$amount_credit = $this->input->post(''amount_credit'');\n    			$amount_cash = $this->input->post(''amount_cash'');\n    			$card_type = $this->input->post(''card_type'');\n    			$remarks = $this->input->post(''remarks'');\n\n    			$customer_phone = $this->input->post(''customer_phone'');\n    			$member_id = $this->input->post(''member'');\n    		\n    			$amount = $this->update_amount($queue_id);\n    			\n    			$this->session->set_userdata(array(''last_sku''=>''''));\n    			\n    			$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?", array($queue_id));\n    			$sale = $query->row();\n    			\n    			$discount = $sale->discount;\n    			$dtype = $sale->discount_type;\n    			\n\n    			if ($discount){\n    				if ($dtype == ''p''){\n    					$amount = str_replace('','','''',number_format($amount * ((100 - $discount) / 100),2));\n    				} else {\n    					$amount = str_replace('','','''',number_format($amount - $discount,2));\n    				}\n\n    			} \n    			\n    			$taxes = $this->tax->get_enabled_taxes();\n    			foreach ($taxes as $tax){\n    				$saletax[$tax->id] = number_format($tax_amount = ($tax->percentage / 100 * $amount), 2);\n    				$taxes_amount += $tax_amount;\n    			}\n    			\n    			$amount += $taxes_amount;\n    			\n    			list($ones, $decimals) = explode(''.'',$amount);\n    			\n    			if ($decimals[1] <= 2){\n    				$newDec = 0;\n    				$addition = 0;\n    			} else if ($decimals[1] <= 7){\n    				$newDec = 5;\n    				$addition = 0;\n    			} else if ($decimals[1] <= 9){\n    				$newDec = 0;\n   					$addition = 0.1;\n   				}\n    				\n   				$discounted = $ones . ''.'' . $decimals[0] . $newDec;\n   				$discounted += $addition;\n    				\n   				$amount = $discounted;\n   				\n   				$amount += $sale->shipping_amount;\n    			\n    			$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?", array($queue_id));\n    			$sale = $query->row();\n    			\n    			if (!$this->system->config(''checkout_ltc'')){\n    				if ($sale->cost > $amount){\n    					$obj[''status''] = ''failed'';\n    					$obj[''reason''] = ''This sales transaction is lower than cost.'';\n    					echo json_encode($obj);	\n    					return;\n    				}\n    			}\n    			\n    			$change = $amount_tendered - $amount;\n    			\n    			\n    			$sql = $this->db->update_string(''sales'',array(\n    				''type''				=> ''history'',\n    				''payment_status''	=> ''Paid'',\n    				''amount_tendered''	=> $amount_tendered,\n    				''amount_change''		=> $change,\n    				''amount_cheque''		=> $amount_cheque,\n    				''amount_cash''		=> $amount_cash - $change,\n    				''amount_credit''		=> $amount_credit,\n    				''amount_cc''			=> $amount_cc,\n    				''amount''			=> $amount,\n    				''payment_method''	=> ''Cash'',\n    				''discount''			=> $discount,\n    				''taxes''				=> json_encode($taxes),\n    				''tax_amount''		=> $tax_amount,\n    				''card_type''			=> $card_type,\n    				''discount_type''		=> $dtype,\n    				''customer_phone''	=> $customer_phone,\n    				''remarks''			=> $remarks,\n    				''datetime''			=> date(''Y-m-d H:i:s''),\n    				''warehouse_id''		=> $this->user->terminal_data(''warehouse_id'')\n    			),"`id` = ''$queue_id''");\n    			$this->db->query($sql);\n    			\n    			$sql = $this->db->update_string(''sale_items'', array(\n    				''sold''				=> 1,\n    				''date''				=> date(''Y-m-d H:i:s''),\n    				''member_id''			=> $sale->customer_id,\n    				''session''			=> $this->user->data(''terminal_session''),\n    				''warehouse_id''		=> $this->user->terminal_data(''warehouse_id'')\n    			),"`sale_id` = ''$queue_id''");\n    			$this->db->query($sql);\n    			\n    			$sale_items_query = $this->db->query("SELECT * FROM `sale_items` WHERE `sale_id` = ?", array($queue_id));\n    			\n    			foreach ($sale_items_query->result() as $sale_item){\n    			\n    		    	$this->inv->update_item_qty($sale_item->item_id);\n    		    	\n    		    	$sql = $this->db->update_string(''inventory'',array(\n    		    		''last_sold''	=> date(''Y-m-d H:i:s'')\n    		    	),"`id` = ''{$sale_item->item_id}''");\n    		    	$this->db->query($sql);\n    		    	\n    		    	if ($this->system->config(''cost_update_method'') == ''fifo''){									\n    					$query = $this->db->query("SELECT * FROM `fifo` WHERE `item_id` = ? ORDER BY `datetime` ASC", array($sale_item->item_id));	\n\n    			    	$fifo_cost = $item->cost; // defaulting\n    			    	$fifo_qty = 0;\n    			    	\n    			    	$cont = true;\n    			    	\n    			    	foreach ($query->result() as $fifo){\n    			    		$fifo_qty += $fifo->qty;\n    			    		if ($fifo_qty >= $item->qty && $cont){\n    			    			$current_po = $fifo;\n    			    			$cont = false;\n    			    		}\n    			    	}\n    			    	\n    			    	if ($item->cost != $current_po->cost){\n    			    		$this->db->query("UPDATE `inventory` SET `cost` = ?, `current_po` = ?, `current_po_item` = ? WHERE `id` = ?", array($current_po->cost, $current_po->po_id, $current_po->po_item_id,$item->id));\n    			    	}\n    			    	\n    					$margin = $sale_item->amount - $this->inv->get_fifo_cost($sale_item->item_id, $sale_item->qty);\n    			    	\n    			    	$sql = $this->db->update_string(''sale_items'', array(\n    			    		''margin''	=> $margin,\n    			    		''cost''		=> $cost\n    			    	),"`id` = ''{$sale_item->id}''");\n    			    	\n    			    	$this->db->query($sql);\n    				}\n    			}\n    			\n    				\n    			\n    			\n    			if ($this->system->config(''member_points'')){\n    				$min_point = $this->system->config(''member_minimum_point'');\n    				$min_amount = $this->system->config(''member_minimum_amount'');\n    				\n    				$points = floor($amount / $min_amount * $min_point);\n    				\n    				$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($member_id));\n    				$member = $query->row();\n    				\n    				$new_points = $member->points + $points;\n    				\n    				$sql = $this->db->update_string(''contacts'', array(\n    					''loyalty_points''	=> $new_points,\n    				),"`id` = ''$member_id''");\n    				\n    				$this->db->query($sql);\n    				\n    			}\n    			\n    			// Invoice\n    			if ($amount_credit){\n    				$query = $this->db->query("SELECT * FROM `customers` WHERE `id` = ?", array($customer_id));\n    				$customer = $query->row();\n    				$sql = $this->db->insert_string(''invoices'',array(\n    					''date''			=> date(''Y-m-d H:i:s''),\n    					''customer''		=> $customer->company_name,\n    					''customer_id''	=> $customer->id,\n    					''terms''			=> ''Credit'',\n    					''status''		=> ''Delivered'',\n    					''total''			=> $amount,\n    					''total_delivered'' => $amount,\n    					''payment_status''=> ''Unpaid'',\n    					''amount_cash''	=> $amount_cash,\n    					''amount_cc''		=> $amount_cc,\n    					''amount_cheque''	=> $amount_cheque,\n    					''amount_credit''	=> $amount_credit,\n    					''paid_cash''		=> 1,\n    					''paid_cc''		=> 1,\n    					''paid_cheque''	=> 1,\n    					''paid_credit''	=> 0,\n    					''added_on''		=> date(''Y-m-d H:i:s''),\n    					''added_by''		=> $this->user->data(''username''),\n    					''no_do''			=> 1,\n    					''sales_reference_id'' => $queue_id\n    				));\n    				\n    				$query = $this->db->query($sql);\n    				\n    				$invoice_id = $query->insert_id;\n    				\n    				$query = $this->db->query("SELECT * FROM `sale_items` WHERE `sale_id` = ?", array($queue_id));\n    				\n    				foreach ($query->result() as $item){\n    					\n    					$sql = $this->db->insert_string(''invoice_items'',array(\n    		    			''invoice_id''		=> $invoice_id,\n    		    			''date''				=> date(''Y-m-d H:i:s''),\n    		    			''item_id''			=> $item->item_id,\n    		    			''qty''				=> $item->qty,\n    		    			''price''				=> $item->amount,\n    		    			''price_per_unit''	=> $item->price_per_unit,\n    		    			''margin''			=> $item->margin,\n    		    			''cost''				=> $item->cost,\n    		    			''no_do''				=> 1\n    		    		));\n    		    		\n    		    		$this->db->query($sql);\n    		    		\n\n    				}\n\n    			}\n    			\n    			$obj[''tendered''] = number_format($amount_tendered,2);\n    			$obj[''amount_credit''] = number_format($amount_credit,2);\n    			$obj[''amount_cc''] = number_format($amount_cc,2);\n    			$obj[''amount_cash''] = number_format($amount_cash,2);\n    			$obj[''amount_cheque''] = number_format($amount_cheque,2);\n    			$obj[''change''] = number_format($amount_tendered - $amount,2);\n    			$obj[''status''] = ''Success'';\n    			\n\n    			\n    			\n    			echo json_encode($obj);				\n    		\n    			break;\n    		case "redeem":\n    			$queue_id = $this->input->post(''queue'');\n    			$member_id = $this->input->post(''member'');\n    			\n    			$query = $this->db->query("SELECT * FROM `sale_items` WHERE `sale_id` = ?", array($queue_id));\n\n    			foreach ($query->result() as $sale_item){\n    				$query = $this->db->query("SELECT * FROM `inventory` WHERE `id` = ?", array($sale_item->item_id));\n    				$item = $query->row();\n    				$amount += $item->redeem_points * $sale_item->qty;\n    			}\n    			\n\n    			$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?", array($queue_id));\n    			$sale = $query->row();\n    			\n    			$sql = $this->db->update_string(''sales'',array(\n    				''type''				=> ''history'',\n    				''payment_status''	=> ''Redeem'',\n    				''amount''			=> $amount,\n    				''member_id''			=> $member_id,\n    				''customer_id''		=> $member_id,\n    				''is_redemption''		=> 1,\n    				''datetime''			=> date(''Y-m-d H:i:s'')\n    			),"`id` = ''$queue_id''");\n    			$this->db->query($sql);\n    			\n    			$sql = $this->db->update_string(''sale_items'', array(\n    				''sold''				=> 1,\n    				''redeemed''			=> 1,\n    				''session''			=> $this->user->data(''terminal_session''),\n    				''member_id''			=> $member_id\n    			),"`sale_id` = ''$queue_id''");\n    			$this->db->query($sql);\n    				\n    			$query = $this->db->query("SELECT * FROM `members` WHERE `id` = ?", array($member_id));	\n    			$member = $query->row();\n    			\n    			$new_points = $member->points - $amount;\n    				\n    			$sql = $this->db->update_string(''members'', array(\n    				''points''	=> $new_points,\n    			),"`id` = ''$member_id''");\n    			$this->db->query($sql);\n    				\n    			$obj[''amount''] = $amount;\n    			$obj[''balance''] = $new_points;\n    			$obj[''status''] = ''Success'';				\n    			echo json_encode($obj);				\n    		\n    			break;\n\n    			\n    		case "print_receipt":\n    			$queue_id = $this->input->post(''queue'');\n    			\n    			break;\n    		case "reprint_receipt":\n    			$queue_id = $this->input->post(''queue'');\n    			break;\n    		case "get_queue_list":\n    			\n    			$query = $this->db->query("SELECT * FROM `sales` WHERE `type` = ''queue'' AND `session` = ? ORDER BY `id` DESC", array($this->user->data(''terminal_session'')));\n    			\n    			foreach ($query->result() as $queue){\n    				if ($queue->amount){\n    				$output .= "<li id=\\"{$queue->id}\\">\n    						<strong>TXN{$queue->id} - RM{$queue->amount} </strong>\n    					</li>";\n    				} else {\n    				$output .= "<li id=\\"{$queue->id}\\">\n    						<strong>TXN{$queue->id} - RM0.00 </strong>\n    					</li>";\n    				}\n    			}\n    			\n    			$obj[''status''] = ''Success'';\n    			$obj[''html''] = $output;\n    			\n    			echo json_encode($obj);\n    			\n    			break;\n    		case "get_history_list":\n    			$phone = $this->input->post(''phone'');\n    			\n    			if (!$phone){\n    				$query = $this->db->query("SELECT * FROM `sales` WHERE `session` = ? AND `type` = ''history'' ORDER BY `datetime` DESC",array($this->user->data(''terminal_session''), $today,$tomorrow));\n    			} else {\n    				$query = $this->db->query("SELECT * FROM `sales` WHERE `customer_phone` = ? ORDER BY `datetime` DESC",array($phone));\n    			}\n    			foreach ($query->result() as $queue){\n    				$time = date(''h:iA j/m/Y'',strtotime($queue->datetime));\n    				$total_items = $this->get_total_items($queue->id);\n    				$output .= "<li id=\\"{$queue->id}\\">\n    						<strong>TXN{$queue->id} - RM{$queue->amount} </strong><br />\n    						{$total_items} item(s) at {$time} \n    					</li>";\n    			}\n    			\n    			$obj[''status''] = ''Success'';\n    			$obj[''phone''] = $phone;\n    			$obj[''html''] = $output;\n    			\n    			echo json_encode($obj);\n    		\n    			break;\n    		case "get_item_list":\n    			$queue_id = $this->input->post(''queue'');\n    			$type = $this->input->post(''type'');\n    			\n    			if ($type == ''invoice''){\n\n    				$query = $this->db->query("SELECT * FROM `invoices` WHERE `id` = ?",array($queue_id));\n    				$sale = $query->row();\n    				$currency = $this->system->config(''currency'');\n    				$query = $this->db->query("SELECT * FROM `invoice_items` WHERE `invoice_id` = ?",array($queue_id));\n    				foreach ($query->result() as $item){\n    					$qty_in_stock = $this->inv->get_item_quantity($item->item_id);\n    					$act_item = $this->inv->get_item_by_id($item->item_id);\n    					\n    					if ($item->serial_no){\n    						$serial_nos = ''<br />SN: '' . $item->serial_no;\n    					} else {\n    						$serial_nos = '''';\n    					}\n    \n    					if ($this->system->config(''sales_screen_cost'')) $cost = " ({$currency}{$item->cost}) ";\n    					if ($act_item->redeemable) $redeemable = ''1'';\n    					else $redeemable = ''0'';\n    					\n    					if ($item->discount_value){\n    						if ($item->discount_type == ''d'') $discount = ''-'' . number_format($item->discount_value,2);\n    						else $discount = $item->discount_value . ''%'';\n    					} else {\n    						$discount = '''';\n    					}\n    					\n    					$redeem_points = $act_item->redeem_points;\n\n    					$output .= "<li class=\\"\\" redeemable=\\"{$redeemable}\\" points=\\"{$redeem_points}\\" id=\\"{$item->id}\\" qty=\\"{$item->qty}\\" name=\\"{$act_item->name}\\" price=\\"{$act_item->price}\\"><table class=\\"vui-dt-row\\"><tr>\n    						<td style=\\"width: 50%\\"><strong style=\\"font-size: 11pt\\">{$item->item_name}</strong><br />{$act_item->sku} {$cost} {$serial_nos}</td>\n    						<td style=\\"width: 20%; font-weight: bold; font-size: 12pt; text-align: center;\\">{$item->qty} <small>{$item->unit}</small><br /><small style=\\"font-weight:normal; color: #AAA\\">({$qty_in_stock})</small></td>\n    						<td style=\\"width: 15%; font-weight: bold; font-size: 11pt; text-align: center;\\">{$discount}</td>\n    						<td class=\\"item-amount\\" style=\\"width: 20%; text-align: right;\\">{$item->delivered_price}</td>\n    					</tr></table></li>";\n    				}\n    				\n    				$obj[''status''] = ''Success'';\n    				$obj[''discount''] = $sale->discount == ''undefined'' ? 0 : $sale->discount; \n    				$obj[''discount_type''] = $sale->discount_type;\n    				$obj[''gross_profit''] = number_format($sale->total_delivered - $sale->cost,2);\n    				$obj[''amount''] = $sale->total_delivered;\n    				$obj[''delivery''] = $sale->shipping_amount;\n    				$obj[''shipping_id'']	= $sale->shipping;\n    				$obj[''adjustment''] = $sale->adjustment;\n    				$obj[''remarks'']			= $sale->remarks;\n    				$obj[''html''] = $output;\n    			\n    			\n    			} else {\n\n    				$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?",array($queue_id));\n    				$sale = $query->row();\n    				\n    				$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($sale->customer_id));\n    				$customer = $query->row();\n    				\n    				$currency = $this->system->config(''currency'');\n    				$query = $this->db->query("SELECT * FROM `sale_items` WHERE `sale_id` = ?",array($queue_id));\n    				foreach ($query->result() as $item){\n    					$qty_in_stock = $this->inv->get_item_quantity($item->item_id);\n    					\n    					$act_item = $this->inv->get_item_by_id($item->item_id);\n    					\n    					if ($item->serial_no){\n    						$serial_nos = ''<br />SN: '' . $item->serial_no;\n    					} else {\n    						$serial_nos = '''';\n    					}\n    \n    					if ($this->system->config(''sales_screen_cost'')) $cost = " ({$currency}{$item->cost}) ";\n    					if ($act_item->redeemable) $redeemable = ''1'';\n    					else $redeemable = ''0'';\n    					\n    					if ($item->discount_value){\n    						if ($item->discount_type == ''d'') $discount = ''-'' . number_format($item->discount_value,2);\n    						else $discount = $item->discount_value . ''%'';\n    					} else {\n    						$discount = '''';\n    					}\n    					\n    					$redeem_points = $act_item->redeem_points;\n    					if ($item->sku_select == 1){\n    						$output .= "<li class=\\"\\" redeemable=\\"{$redeemable}\\" points=\\"{$redeem_points}\\" id=\\"{$item->id}\\" qty=\\"{$item->qty}\\" name=\\"{$act_item->name}\\" price=\\"{$act_item->price}\\"><table class=\\"vui-dt-row\\"><tr>\n    							<td style=\\"width: 50%\\"><strong style=\\"font-size: 11pt\\">{$item->item_name}</strong><br />{$item->item_sku} {$cost} {$serial_nos}</td>\n    							<td style=\\"width: 20%; font-weight: bold; font-size: 12pt; text-align: center;\\">{$item->qty} <small>{$item->unit}</small><br /><small style=\\"font-weight:normal; color: #AAA\\">({$qty_in_stock})</small></td>\n    							<td style=\\"width: 15%; font-weight: bold; font-size: 11pt; text-align: center;\\">{$discount}</td>\n    							<td class=\\"item-amount\\" style=\\"width: 20%; text-align: right;\\">{$item->amount}</td>\n    						</tr></table></li>";\n    					} else {\n    						$qty_unit = $item->qty / $item->qty_fraction;\n    						$output .= "<li class=\\"\\" redeemable=\\"{$redeemable}\\" points=\\"{$redeem_points}\\" id=\\"{$item->id}\\" qty=\\"{$item->qty}\\" name=\\"{$act_item->name}\\" price=\\"{$act_item->price}\\"><table class=\\"vui-dt-row\\"><tr>\n    							<td style=\\"width: 50%\\"><strong style=\\"font-size: 11pt\\">{$item->item_name}</strong><br />{$item->item_sku2} {$cost} {$serial_nos}</td>\n    							<td style=\\"width: 20%; font-weight: bold; font-size: 12pt; text-align: center;\\">{$qty_unit} <small>{$item->unit}</small><br /><small style=\\"font-weight:normal; color: #AAA\\">({$qty_in_stock})</small></td>\n    							<td style=\\"width: 15%; font-weight: bold; font-size: 11pt; text-align: center;\\">{$discount}</td>\n    							<td class=\\"item-amount\\" style=\\"width: 20%; text-align: right;\\">{$item->amount}</td>\n    						</tr></table></li>";\n    					}\n    				}\n    				\n    				$obj[''status''] 			= ''Success'';\n    				$obj[''discount'']		= $sale->discount == ''undefined'' ? 0 : $sale->discount; \n    				$obj[''discount_type''] 	= $sale->discount_type;\n    				$obj[''gross_profit''] 	= number_format($sale->amount - $sale->cost,2);\n    				$obj[''amount''] 			= $sale->amount;\n    				$obj[''delivery''] 		= $sale->shipping_amount;\n    				$obj[''shipping_id'']		= $sale->shipping;\n    				$obj[''customer'']		= $customer;\n    				$obj[''adjustment''] 		= $sale->adjustment;\n    				$obj[''remarks'']			= $sale->remarks;\n    				$obj[''html''] 			= $output;\n    				\n    			}\n    			\n    			echo json_encode($obj);\n    		\n    			break;\n    		case "search_items":\n    			$name = $this->input->post(''name'');\n    			\n    			$query = $this->db->query("SELECT * FROM `inventory` WHERE `name` LIKE ?", array(''%''.$name.''%''));\n    			foreach ($query->result() as $item){\n    				$output .= "<li sku=\\"{$item->sku}\\">{$item->name}</li>";\n    			}\n    			$obj[''status''] = ''Success'';\n    			$obj[''html''] = $output;\n    			\n    			echo json_encode($obj);\n    			break;\n    			\n    		case "employee_clock_in":\n    			$username = $this->input->post(''username'');\n    			$password = $this->input->post(''password'');\n    			\n    			if ($employee_id = $this->user->verify_authentication($username, $password)){\n    				$this->user->clock_in($employee_id);\n    				$result->status = ''OK'';\n    			} else {\n    				$result->status = ''Auth Failed'';\n    			}\n    			\n    			echo json_encode($result);\n    			\n    			break;\n    		\n    		case "employee_clock_out":\n    			$username = $this->input->post(''username'');\n    			$password = $this->input->post(''password'');\n    			\n    			if ($employee_id = $this->user->verify_authentication($username, $password)){\n    				$co_status = $this->user->clock_out($employee_id);\n    				\n    				if ($co_status){\n    					$result->status = ''OK'';\n    				} else {\n    					$result->status = ''No CI Record'';\n    				}\n    				\n    			} else {\n    				$result->status = ''Auth Failed'';\n    			}\n    			\n    			echo json_encode($result);\n    			\n    			break;\n    			\n    		case "clear_customer":\n	    		$queue_id = $this->input->post(''queue_id'');			\n    			$price_rules = json_decode($this->system->config(''price_rules''));\n    			\n	    			\n	    		$this->db->update(''sales'', array(\n    			    ''customer_id''	=> ''''\n    			), "`id` = ''{$queue_id}''");\n	    		\n	    		$query = $this->db->query("SELECT * FROM `sale_items` WHERE `sale_id` = ?", array($queue_id));\n	    		foreach ($query->result() as $item){\n	    		    $query = $this->db->query("SELECT * FROM `inventory` WHERE `id` = ?", array($item->item_id));\n	    		    $actual_item = $query->row();\n	    		    $item->price = $actual_item->price;\n		    	    \n		    	    $item->price_per_unit = $item->price;\n		    	    $item->amount = $item->price_per_unit * $item->qty;\n		    	    \n		    	    $this->db->update(''sale_items'', array(\n		    	    	''price_per_unit''	=> $item->price_per_unit,\n		    	    	''margin''			=> $item->amount - $item->cost,\n		    	    	''amount''			=> $item->amount\n		    	    ), "`id` = ''{$item->id}''");\n\n	    		}\n\n		    	\n		    	$result->status = ''Success'';\n	    		\n\n    			echo json_encode($result);\n    		\n    			break;\n    			\n    		case "enter_customer":\n    			$id = $this->input->post(''customer_id'');\n    			$queue_id = $this->input->post(''queue_id'');\n    			\n    			$price_rules = json_decode($this->system->config(''price_rules''));\n    			\n    			\n    			$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($id));\n    			if ($query->num_rows()){\n	    			$customer = $query->row();\n	    			\n	    			$this->db->update(''sales'', array(\n    					''customer_id''	=> $customer->id,\n    					''member_id''		=> $customer->id\n    				), "`id` = ''{$queue_id}''");\n    				\n	    			\n	    			$query = $this->db->query("SELECT * FROM `sale_items` WHERE `sale_id` = ?", array($queue_id));\n	    			foreach ($query->result() as $item){\n	    				$query = $this->db->query("SELECT * FROM `inventory` WHERE `id` = ?", array($item->item_id));\n	    				$actual_item = $query->row();\n	    				\n	    				if ($customer->rank){\n		    				$item->price = $actual_item->{''price''.$price_rules->{str_replace('' '',''_'',$customer->rank)}};\n		    			} else {\n			    			$item->price = $actual_item->price;\n		    			}\n		    			\n		    			$item->price_per_unit = $item->price;\n		    			$item->amount = $item->price_per_unit * $item->qty;\n		    			\n		    			$this->db->update(''sale_items'', array(\n		    				''price_per_unit''	=> $item->price_per_unit,\n		    				''margin''			=> $item->amount - $item->cost,\n		    				''amount''			=> $item->amount\n		    			), "`id` = ''{$item->id}''");\n\n	    			}\n		    			\n	    			if ($contact->rank){\n		    			$item->price = $item->{''price''.$price_rules->{str_replace('' '',''_'',$contact->rank)}};\n		    		}\n		    		\n		    		$result->status = ''Success'';\n	    			\n    			} else {\n	    			$result->status = ''Failed'';\n    			}\n    			\n    			echo json_encode($result);\n    			\n    			break;\n    		\n    		case "get_customer":\n    			$identifier = $this->input->post(''identifier'') ? $this->input->post(''identifier'') : ''ic'';\n    			$id 		= $this->input->post(''id'');\n    			\n    			\n    			$query = $this->db->query("SELECT * FROM `contacts` WHERE {$identifier} = ?", array($id));\n    			if ($query->num_rows()){\n	    			$result->status = ''Success'';\n	    			$result->customer = $query->row();\n	    				    			\n    			} else {\n	    			$result->status = ''Failed'';\n    			}\n    			\n    			echo json_encode($result);\n    			\n    			break;\n    		case "get_delivery_charges":\n    		\n    			$queue_id = $this->input->post(''queue'');\n    			$id = $this->input->post(''id'');\n    			\n    			$query = $this->db->query("SELECT * FROM `shipping` WHERE `id` = ?", array($id));\n    			$service = $query->row();\n    			\n    			$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?", array($queue_id));\n    			$sale = $query->row();\n    			\n    			$query = $this->db->query("SELECT * FROM `sale_items` WHERE `sale_id` = ?", array($queue_id));\n    			$items = $query->result();\n    			foreach ($items as $item){\n    				$ditem = null;\n    				$ditem->qty = $item->qty * $item->qty_fraction;\n    				$ditem->id = $item->item_id;\n    				$ditems[] = $ditem;\n    			}\n    			\n    			$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($sale->customer_id));\n    			$contact = $query->row();\n    			\n    			$charges = $this->shipping->get_delivery_charges($id, $contact->country, $contact->zipcode, $ditems);\n    			\n    			$amount = $sale->amount + $charges->total_weight;\n    			\n    			$sql = $this->db->update_string(''sales'',array(\n    				''amount''			=> $amount,\n    				''shipping''			=> $id,\n    				''shipping_name''		=> $service->name,\n    				''shipping_weight''	=> $charges->total_weight,\n    				''shipping_amount''	=> $charges->total_rate\n    			),"`id` = ''$queue_id''");\n    			$this->db->query($sql);\n    			\n    			\n    			\n    			\n    			\n    			$result->sale = $sale;\n    			$result->contact = $contact;\n    			$result->items = $ditems;\n    			$result->service = $id;\n    			$result->queue_id = $queue_id;\n    			$result->charges = $charges;\n    			$result->status = ''Success'';\n    			\n    			echo json_encode($result);\n    			\n    	}\n    }\n    \n    \n    function Update_amount($queue_id){\n    	$query = $this->db->query("SELECT SUM(`amount`) AS `total`, SUM(`cost`) AS `total_cost` FROM `sale_items` WHERE `sale_id` = ? GROUP BY `sale_id`", array($queue_id));\n    	$amount = $query->row();\n    	\n    	if ($this->system->config(''rounding_adjust'')){\n    		list($ones, $cents) = explode(''.'',str_replace('','','''',number_format($amount->total,2)));\n    		\n    		if ($cents[1] == 1){\n    			$cents -= 1;\n    			$adjustment = -1;\n    		} elseif ($cents[1] == 2){\n    			$cents -= 2;\n    			$adjustment = -2;\n    		} elseif ($cents[1] == 3){\n    			$cents += 2;\n    			$adjustment = 2;\n    		} elseif ($cents[1] == 4){\n    			$cents += 1;\n    			$adjustment = 1;\n    		} elseif ($cents[1] == 6){\n    			$cents -= 1;\n    			$adjustment = -1;\n    		} elseif ($cents[1] == 7){\n    			$cents -= 2;\n    			$adjustment = -2;\n    		} elseif ($cents[1] == 8){\n    			$cents += 2;\n    			$adjustment = 2;\n    		} elseif ($cents[1] == 9){\n    			$cents += 1;\n    			$adjustment = 1;\n    		} else {\n    			$adjustment = 0;\n    		}\n    	} else {\n    		$adjustment = 0;\n    	}\n\n    	\n    	$sql = $this->db->update_string(''sales'',array(\n    		''amount''	=> $amount->total + ($adjustment / 100),\n    		''cost''		=> $amount->total_cost,\n    		''adjustment''=> $adjustment / 100\n    	),"`id` = ''$queue_id''");\n    	$this->db->query($sql);\n    	\n    	return $amount->total + ($adjustment / 100);\n    }\n    \n    function Get_total_items($queue_id){\n    	$query = $this->db->query("SELECT * FROM `sale_items` WHERE `sale_id` = ?",$queue_id);\n    	return $que', '2012-11-07 18:20:09', 'admin', NULL);
INSERT INTO `editor_revisions` (`id`, `profile_id`, `item`, `contents`, `datetime`, `user`, `commit`) VALUES
(10, 1, '/var/www/_dev/os/application/controllers/receipt.php', '<?php\n\nclass Receipt extends Controller {\n	\n	function Index(){\n		$this->load->view(''receipt'');\n	}\n\n}', '2012-11-07 18:20:14', 'admin', NULL);
INSERT INTO `editor_revisions` (`id`, `profile_id`, `item`, `contents`, `datetime`, `user`, `commit`) VALUES
(11, 1, '/var/www/_dev/os/application/controllers/pos.php', '<?php\n\nclass POS extends Controller {\n\n    function POS(){\n    	parent::Controller();\n\n    	$this->load->model(''user'');\n    	$this->load->model(''system'');\n    	$this->load->model(''inv'');\n    	$this->load->model(''contact'');\n    	$this->load->model(''credit_cards'');\n    	$this->load->model(''tax'');\n    	$this->load->model(''shipping'');\n\n    	if ($this->uri->segment(1) == ''pos'' && $this->uri->segment(2) == ''terminal''){\n    		// do nothing	\n    		\n    		$ip = $_SERVER[''REMOTE_ADDR''];\n    		$query = $this->db->query("SELECT * FROM `terminals` WHERE `ip` = ?", array($ip));\n    		\n\n\n    		if (!$query->num_rows()){\n\n    			if ($terminal_id = get_cookie(''PLEX_POS_TERM_ID'',true)){\n    				$query = $this->db->query("SELECT * FROM `terminals` WHERE `id` = ?", array($terminal_id));\n    				$terminal = $query->row();\n    				\n    				if (md5($terminal->key . get_cookie(''PLEX_POS_TERM_SESSION'',true)) != get_cookie(''PLEX_POS_TERM_HASH'',true)){\n    					show_error(''Access denied for terminal identifier <strong>'' . get_cookie(''PLEX_POS_TERM_IDENTIFIER'',true) . ''</strong>. Check if your terminal identifier and key is correct.'');\n    				}\n    				\n    			} else {\n    				show_error(''Access denied for IP Address <strong>'' . $_SERVER[''REMOTE_ADDR''] . ''</strong>. Check if your terminal is using Dynamic IP access.'');\n    			}\n    		}\n    		\n    			\n    	} else {\n    		$ip = $_SERVER[''REMOTE_ADDR''];\n    		$query = $this->db->query("SELECT * FROM `terminals` WHERE `ip` = ?", array($ip));\n\n    		if (!$query->num_rows()){\n\n    			if ($terminal_id = get_cookie(''PLEX_POS_TERM_ID'',true)){\n    				$query = $this->db->query("SELECT * FROM `terminals` WHERE `id` = ?", array($terminal_id));\n    				$terminal = $query->row();\n    				\n    				if (md5($terminal->key . get_cookie(''PLEX_POS_TERM_SESSION'',true)) != get_cookie(''PLEX_POS_TERM_HASH'',true)){\n    					show_error(''Access denied for terminal identifier <strong>'' . get_cookie(''PLEX_POS_TERM_IDENTIFIER'',true) . ''</strong>. Check if your terminal identifier and key is correct.'');\n    				}\n    				\n    			} else {\n    				show_error(''Access denied for IP Address <strong>'' . $_SERVER[''REMOTE_ADDR''] . ''</strong>. Check if your terminal is using Dynamic IP access.'');\n    			}\n    		}\n    	}\n    	\n    }\n    \n    function Terminal($identifier, $key){\n    	$query = $this->db->query("SELECT * FROM `terminals` WHERE `identifier` = ? AND `key` = ?", array($identifier, $key));\n\n    	if ($query->num_rows()){\n    		$terminal = $query->row();\n    		$term_session = time();\n    		$expire = 60*60*24*6004; \n\n    		\n    		set_cookie(''PLEX_POS_TERM_ID'',$terminal->id, $expire, $_SERVER[''HTTP_HOST''], ''/'');\n    		set_cookie(''PLEX_POS_TERM_NAME'', $terminal->name, $expire, $_SERVER[''HTTP_HOST''], ''/'');\n    		set_cookie(''PLEX_POS_TERM_IDENTIFIER'', $identifier, $expire, $_SERVER[''HTTP_HOST''], ''/'');\n    		set_cookie(''PLEX_POS_TERM_HASH'', md5($key . $term_session), $expire, $_SERVER[''HTTP_HOST''], ''/'');\n    		set_cookie(''PLEX_POS_TERM_SESSION'', $term_session, $expire, $_SERVER[''HTTP_HOST''], ''/'');\n    		\n    		\n    		redirect(''pos'');\n    	} else {			\n    		show_error(''Access denied for terminal identifier <strong>'' . $identifier . ''</strong>. Check if your terminal identifier and key is correct.'');\n    	}\n    }\n    \n    function Index(){\n\n    	if (!$this->user->check_session()) redirect(''pos/login'');	\n    	redirect(''pos/sales_screen'');\n    				\n    }\n    \n    function Sales_screen(){\n\n    	// IP and Terminal Info\n    	$ip = $this->user->data(''ip'');\n    	if ($ip == ''::1'') $ip = ''localhost'';\n    	$this->d[''terminal''] = get_cookie(''PLEX_POS_TERM_ID'');\n    \n    	// Current user data\n    	$this->d[''user''] 	 = $this->user->data();\n    	$this->d[''username''] = $this->user->data(''username'');\n    	\n    	\n    	// Trigger and Display\n    	$this->d[''trigger_url''] = ''http://localhost/plexports/pos/trigger_drawer/''.$key;\n    	$this->d[''display_url''] = ''http://localhost/plexports/pos/show_display/''.$key;\n    	\n    	\n    	// Quick Items\n    	$query = $this->db->query("SELECT * FROM `inventory` WHERE `quick` = 1");\n    	if (!$query->num_rows()){\n    		$query = $this->db->query("SELECT * FROM `inventory` LIMIT 100");\n    		$this->d[''quick_items''] = $query->result();\n    	} else {\n    		$this->d[''quick_items''] = $query->result();\n    	}\n    	\n    	\n    	// Customers\n    	$query = $this->db->query("SELECT * FROM `contacts` ORDER BY `company_name`, `contact_person` ASC");\n    	$customers[] = ''Select Customer'';\n    	foreach ($query->result() as $customer){\n    		$customers[$customer->id] = $customer->company_name ? $customer->company_name : $customer->contact_person; \n    	}\n    	$this->d[''customers''] = $customers;\n    	\n    	\n    	// Members\n    	if ($this->system->config(''member_points'')){\n    		$members[] = ''Select Customer'';\n    		$query = $this->db->query("SELECT * FROM `contacts` ORDER BY `company_name`, `contact_person` ASC");\n    		foreach ($query->result() as $member){\n    			$members[$member->id] = $member->company_name ? $member->company_name : $member->contact_person; \n    		}\n    		$this->d[''members''] = $members;\n    	}\n    	\n    	\n    	// Credit cards\n    	$cces = $this->credit_cards->get_card_options();\n    	foreach ($cces as $cc){\n    		$cc_array[$cc->id] = $cc->name;\n    	}\n    	$this->d[''cc_array''] = $cc_array;\n    	\n    	$this->d[''taxes''] = $this->tax->get_enabled_taxes();\n    	$this->d[''shipping''] = $this->shipping->get_delivery_services();\n    	\n    	// POS interface\n    	$this->load->view(''retail/main'', $this->d);\n\n    }\n    \n\n    function Login($err){\n    	if ($this->user->check_session()) redirect(''pos'');\n    	if ($err == ''err1'') $this->d[''notice''] = ''Incorrect username or password.'';\n    	if ($err == ''err2'') $this->d[''notice''] = ''User is already logged in.'';\n    	$this->load->view(''retail/login'',$this->d);\n    }\n    \n    function Auth(){\n    	if ($this->user->check_session()) redirect(''pos'');\n    	\n    	$user = $this->user->get_user_by_username($this->input->post(''username''));\n    	if ($user->terminal_active == 1) redirect(''pos/login/err2'');\n    	\n    	if ($this->user->login()) redirect(''pos'');\n    	else redirect(''pos/login/err1'');\n    }\n    \n    function Receipt(){\n    	$this->load->view(''retail/receipt'');\n    }\n    \n    function Ajax($request){\n    	header(''Content-type: application/json'');\n    	switch ($request){\n    		case "return_to_queue":\n    			if ($this->system->config(''revert_level'') == ''Manager''){\n    				$username = $this->input->post(''username'');\n    				$password = $this->input->post(''password'');\n    				$manager = true;\n    			}\n    			\n    			$user = $this->user->get_user_by_username($username);\n    			$query = $this->db->query("SELECT * FROM `permissions` WHERE `user_type` = ?", array($user->type));\n    			$permission = $query->row();\n    			\n    			$action = json_decode($permission->action);\n    			\n    			if ($manager){\n    				if (!$action->sales->to_supervise_pos){\n    					$obj->status = ''Failed'';\n    					echo json_encode($obj);\n    					return;\n    				} else {\n    					if ($user->password !== md5($password)){\n    						$obj->status = ''Failed'';\n    						echo json_encode($obj);\n    						return;\n    					}\n    				}\n    			}\n    			\n    			$queue_id = $this->input->post(''queue'');\n    			\n    			$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?", array($queue_id));\n    			$sale = $query->row();\n    			\n    			$query = $this->db->query("SELECT * FROM `sale_items` WHERE `sale_id` = ?", array($queue_id));\n    			$sale_items = $query->result();\n    			\n    			$data->sale = $sale;\n    			$data->sale_items = $sale_items;\n\n    			$sql = $this->db->update_string(''sales'',array(\n    				''type''		=> ''queue'',\n    				''session''	=> $this->user->data(''terminal_session'')\n    			), "`id` = ''$queue_id''");	\n    			$this->db->query($sql);\n    			\n    			$sql = $this->db->insert_string(''reverts'',array(\n    				''performed_by''  => $manager ? $username : $employee->username,\n    				''data''			=> json_encode($data),\n    				''datetime''		=> date(''Y-m-d H:i:s'')\n    			));\n    			\n    			$this->db->query($sql);\n    			\n    			$obj->status = ''Success'';\n    			echo json_encode($obj);\n    			break;\n\n    		case "receipt":\n    			$queue_id = $this->input->post(''queue'');\n    			$type = $this->input->post(''type'');\n    			\n    			if ($type == ''invoice''){\n    				$query = $this->db->query("SELECT * FROM `invoices` WHERE `id` = ?",array($queue_id));\n    				$sale = $query->row();\n    				$date = date("d/m/Y", strtotime($sale->date));	\n    			} else {\n    				$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?",array($queue_id));\n    				$sale = $query->row();\n    				$date = date("H:i:s d/m/Y", strtotime($sale->datetime));				\n    				for ($i = 0; $i < 6 - strlen($sale->id); $i++){\n    					$trailing_zeroes .= ''0'';\n    				}\n\n    			}\n    			\n    			if ($sale->customer_id){\n    				$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($sale->customer_id));\n    				$contact = $query->row();\n    			}\n    			\n    			if ($type == ''invoice''){\n    				\n    				\n    				if ($this->system->config(''receipt_type'') == ''3 Inch''){\n    					\n    					$output .= "<span style=\\"float: right\\">Inv/DO No.: " . $trailing_zeroes . $sale->id . "</span>{$date}";\n    					$output .= "Prep By: " . $sale->added_by;\n    					\n    					\n    					$output .= "<hr />";\n    					$output .= "<table style=\\"border-collapse: collapse; width: 100%; font-size: 8px\\">";\n    					$query = $this->db->query("SELECT * FROM `invoice_items` WHERE `invoice_id` = ?",array($queue_id));\n    					foreach ($query->result() as $item){\n    						\n    						$output .= "<tr>\n    							<td style=\\"width: 40%\\"><strong style=\\"font-size: 8pt\\">{$item->item_name}</strong><br />{$item->item_sku}</td>\n    							<td style=\\"width: 22%; text-align: center;\\">{$item->qty}</td>\n    							<td style=\\"width: 23%; text-align: right;\\">{$item->delivered_price}</td>\n    						</tr>";\n    						\n    						$subtotal = $grand_total += $item->delivered_price;\n    					}\n    					\n    					$subtotal_display = number_format($subtotal, 2);\n    					$grand_total_display = number_format($sale->total_delivered,2);\n    					$handling_display = number_format($sale->handling_charges,2);\n    					\n    					$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"2\\">Subtotal</td>\n    									<td style=\\"width: 23%; text-align: right\\">{$subtotal_display}</td>\n    								</tr>";\n    				\n    					$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"2\\">Handling Charges</td>\n    									<td style=\\"width: 23%; text-align: right;\\">{$handling_display}</td>\n    								</tr>";\n    					\n    					\n    					$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"2\\">Grand Total</td>\n    									<td style=\\"width: 23%; text-align: right;\\">{$grand_total_display}</td>\n    								</tr>";\n    					\n    					\n    				\n    				} else {\n    				\n    				\n    					$output .= "<span style=\\"float: right\\">Inv/DO No.: " . $trailing_zeroes . $sale->id . "</span>{$date}";\n    					$output .= "Prep By: " . $sale->added_by;\n    				\n    					$output .= "<table style=\\"border-collapse: collapse; width: 100%; font-size: 8px; margin-top: 10px\\">";\n    					$output .= "<thead style=\\"border-bottom: 2px solid #000; padding-top: 10px;\\"><tr><th style=\\"text-align: left\\">Item</th><th style=\\"text-align: center\\">Serial No.</th><th style=\\"text-align: center\\">Qty</th><th style=\\"text-align: right\\">Price</th></tr></thead>";\n    					$query = $this->db->query("SELECT * FROM `invoice_items` WHERE `invoice_id` = ?",array($queue_id));\n    					foreach ($query->result() as $item){\n    						\n    						$output .= "<tr>\n    							<td style=\\"width: 50%;\\"><strong style=\\"font-size: 8pt\\">{$item->item_name}</strong><br />{$item->item_sku}</td>\n    							<td style=\\"width: 15%; text-align: center;\\">{$item->serial_no}</td>\n    							<td style=\\"width: 15%; text-align: center;\\">{$item->qty}</td>\n    							<td style=\\"width: 20%; text-align: right;\\">{$item->delivered_price}</td>\n    						</tr>";\n    						\n    						$grand_total += $item->amount;\n    					}\n    					\n    					$output .= "<tr><td style=\\"padding: 10px;\\" colspan=\\"4\\">&nbsp;</td></tr>";\n    				\n    					\n    					$subtotal_display = number_format($subtotal, 2);\n    					$grand_total_display = number_format($sale->total_delivered,2);\n    					$handling_display = number_format($sale->handling_charges,2);\n    					\n    					$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"2\\">Subtotal</td>\n    									<td style=\\"width: 23%; text-align: right\\">{$subtotal_display}</td>\n    								</tr>";\n    				\n    					$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"2\\">Handling Charges</td>\n    									<td style=\\"width: 23%; text-align: right;\\">{$handling_display}</td>\n    								</tr>";\n    					\n    					$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"3\\">Grand Total</td>\n    									<td style=\\"text-align: right;\\">{$grand_total_display}</td>\n    								</tr>";\n    					\n    					\n    					if ($this->system->config(''checkout_cc'')){\n    						if ($sale->amount_cc != 0){\n    							$show_cash = true;\n    							$amount_cc_display = number_format($sale->amount_cc,2);\n    							$output .=  "<tr>\n    										<td colspan=\\"3\\">Credit Card Tendered ({$sale->card_type})</td>\n    										<td style=\\"text-align: right;\\">{$amount_cc_display}</td>\n    									</tr>";\n    							\n    						}\n    					}\n    				\n    					if ($this->system->config(''checkout_cheque'')){				\n    						if ($sale->amount_cheque != 0){\n    							$show_cash = true;\n    							$amount_cheque_display = number_format($sale->amount_cheque,2);\n    							$output .=  "<tr>\n    										<td colspan=\\"3\\">Cheque Tendered</td>\n    										<td style=\\"text-align: right;\\">{$amount_cheque_display}</td>\n    									</tr>";\n    						}\n    					}\n    					\n    				\n    					\n    					if ($this->system->config(''checkout_credit'')){\n    					\n    						if ($sale->amount_credit != 0){\n    							$show_cash = true;\n    							$amount_credit_display = number_format($sale->amount_credit,2);\n    							$total = number_format($this->contact->get_total_credit($sale->customer_id),2);\n    							\n    							$customer = $this->contact->get_customer_by_id($sale->customer_id);\n    							$credit_limit = number_format($customer->credit_limit,2);\n    							$available_credit = number_format($this->contact->get_credit_balance($sale->customer_id),2);\n    							\n    							\n    							$output .=  "<tr>\n    										<td colspan=\\"3\\">Credit Amount</td>\n    										<td style=\\"text-align: right;\\">{$amount_credit_display}</td>\n    									</tr>";\n    									\n    				\n    							$coutput .=  "<tr>\n    										<td colspan=\\"3\\">Credit Limit</td>\n    										<td style=\\"text-align: right\\">{$credit_limit}</td>\n    									</tr>";\n    				\n    				\n    							$coutput .=  "<tr>\n    										<td colspan=\\"3\\">Available Credit Limit</td>\n    										<td style=\\"text-align: right\\">{$available_credit}</td>\n    									</tr>";			\n    						\n    						}\n    					}\n    					\n    					if ($show_cash){				\n    						if ($sale->amount_cash){\n    							$show_cash = true;\n    							$amount_cheque_display = number_format($sale->amount_cheque,2);\n    							$output .=  "<tr>\n    										<td colspan=\\"3\\">Cash Tendered</td>\n    										<td style=\\"text-align: right;\\">{$amount_cheque_display}</td>\n    									</tr>";\n    						}\n    					}\n    					\n    					if ($coutput){\n    						$output .= "<tr style=\\"border-bottom: 1px solid #000\\"><td colspan=\\"4\\"></td></tr>";\n    						$output .= $coutput;\n    					}\n    					\n    					$output .= "</table>";\n    				\n    				\n    				}\n    				\n    			} else {\n    			\n    				if ($this->system->config(''receipt_type'') == ''3 Inch''){\n    					\n    					$output .= "<span style=\\"float:right\\">Rec No.: " . $trailing_zeroes . $sale->id . "</span>Date: {$date}";\n    					$output .= "&nbsp;&nbsp;&nbsp;&nbsp;Cashier: " . $this->user->data(''username'');\n						if ($contact){\n	    					$output .= "<br />Member: " . $contact->contact_person;\n	    					$output .= "&nbsp;&nbsp;&nbsp;&nbsp;Member ID: " . $contact->ic;\n						}\n    					\n    					$output .= "<hr />";\n    					$output .= "<table style=\\"border-collapse: collapse; width: 100%; font-size: 8px\\">";\n    					$query = $this->db->query("SELECT * FROM `sale_items` WHERE `sale_id` = ?",array($queue_id));\n    					foreach ($query->result() as $item){\n    						\n    						$output .= "<tr>\n    							<td style=\\"width: 40%\\"><strong style=\\"font-size: 8pt\\">{$item->item_name}</strong><br />{$item->item_sku}</td>\n    							<td style=\\"width: 22%; text-align: center;\\">{$item->qty}</td>\n    							<td style=\\"width: 23%; text-align: right;\\">{$item->amount}</td>\n    						</tr>";\n    						\n    						$subtotal = $grand_total += $item->amount;\n    					}\n    					\n    					$grand_total_display = number_format($sale->amount,2);\n    					$discount_display = number_format($grand_total - $sale->amount,2);\n    					$amount_tendered_display = number_format($sale->amount_tendered,2);\n    					$amount_change_display = number_format($sale->amount_change,2);\n    					$subtotal_display = number_format($subtotal,2);\n    					$discount = $sale->discount;\n    					\n    					\n    					$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"2\\">Subtotal</td>\n    									<td style=\\"width: 23%; text-align: right\\">{$subtotal_display}</td>\n    								</tr>";\n    					\n    					if ($discount){\n    						if ($sale->discount_type == ''p''){\n    							$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"2\\">Discount {$discount}%</td>\n    									<td style=\\"width: 23%; text-align: right;\\">{$discount_display}</td>\n    								</tr>";\n    								\n    						} else {\n    							$discount_d = number_format($discount,2);\n    							$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"2\\">Discount RM{$discount_d}</td>\n    									<td style=\\"width: 23%; text-align: right;\\">{$discount_display}</td>\n    								</tr>";\n    						}\n    					}\n    					\n    					if ($sale->shipping_amount){\n   							$output .= "<tr>\n    									<td colspan=\\"3\\">Shipping ($sale->shipping_name)</td>\n    									<td style=\\"text-align: right;\\">{$sale->shipping_amount}</td>\n    								</tr>";\n    					}\n    					\n    					\n    					$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"2\\">Grand Total</td>\n    									<td style=\\"width: 23%; text-align: right;\\">{$grand_total_display}</td>\n    								</tr>\n    								<tr>\n    									<td colspan=\\"2\\">Amount Tendered</td>\n    									<td style=\\"width: 23%; text-align: right;\\">{$amount_tendered_display}</td>\n    								</tr>";\n    					\n    					$output .=  "<tr>\n    									<td colspan=\\"2\\">Change</td>\n    									<td style=\\"width: 23%; text-align: right;\\">{$amount_change_display}</td>\n    								</tr></table>";\n    								\n    					if ($sale->remarks){\n    						$output .=  "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"4\\">\n    										Remarks: {$sale->remarks}\n    									</td>\n    								</tr>";\n	    					\n    					}\n\n    					\n    					if ($this->system->config(''checkout_cc'')){\n    						if ($sale->amount_cc){\n    							$show_cash = true;\n    							$amount_cc_display = number_format($sale->amount_cc,2);\n    							$output .=  "<tr>\n    										<td colspan=\\"2\\">Credit Card Tendered ({$sale->card_type})</td>\n    										<td style=\\"width: 23%; text-align: right;\\">{$amount_cc_display}</td>\n    									</tr></table>";\n    							\n    						}\n    					}\n    				\n    					if ($this->system->config(''checkout_cheque'')){				\n    						if ($sale->amount_cheque){\n    							$show_cash = true;\n    							$amount_cheque_display = number_format($sale->amount_cheque,2);\n    							$output .=  "<tr>\n    										<td colspan=\\"2\\">Cheque Tendered</td>\n    										<td style=\\"width: 23%; text-align: right;\\">{$amount_cheque_display}</td>\n    									</tr></table>";\n    						}\n    					}\n    					\n    					if ($this->system->config(''checkout_credit'')){\n    					\n    						if ($sale->amount_credit){\n    							$show_cash = true;\n    							$amount_credit_display = number_format($sale->amount_credit,2);\n    							$total = number_format($this->contact->get_total_credit($sale->customer_id));\n    							$output .=  "<tr>\n    										<td colspan=\\"2\\">Credit Amount</td>\n    										<td style=\\"width: 23%; text-align: right;\\">{$amount_cheque_display}</td>\n    									</tr></table>";\n    							$output .=  "<tr>\n    										<td colspan=\\"2\\">Total Credit Amount</td>\n    										<td style=\\"width: 23%; text-align: right;\\">{$amount_cheque_display}</td>\n    									</tr></table>";\n    				\n    						\n    						}\n    					}\n    				\n    				} else {\n    				\n    				\n    					$output .= "<span style=\\"float:right\\">Rec No.: " . $trailing_zeroes . $sale->id . "</span>Date: {$date}";\n    					$output .= "&nbsp;&nbsp;&nbsp;&nbsp;Cashier: " . $this->user->data(''username'');\n						if ($contact){\n	    					$output .= "<br />Member: " . $contact->contact_person;\n	    					$output .= "&nbsp;&nbsp;&nbsp;&nbsp;Member ID: " . $contact->ic;\n						}\n    					\n    				\n    					$output .= "<table style=\\"border-collapse: collapse; width: 100%; font-size: 8px; margin-top: 10px\\">";\n    					$output .= "<thead style=\\"border-bottom: 2px solid #000; padding-top: 10px;\\"><tr><th style=\\"text-align: left\\">Item</th><th style=\\"text-align: center\\">Serial No.</th><th style=\\"text-align: center\\">Qty</th><th style=\\"text-align: right\\">Price</th></tr></thead>";\n    					$query = $this->db->query("SELECT * FROM `sale_items` WHERE `sale_id` = ?",array($queue_id));\n    					foreach ($query->result() as $item){\n    						\n    						$output .= "<tr>\n    							<td style=\\"width: 50%;\\"><strong style=\\"font-size: 8pt\\">{$item->item_name}</strong><br />{$item->item_sku}</td>\n    							<td style=\\"width: 15%; text-align: center;\\">{$item->serial_no}</td>\n    							<td style=\\"width: 15%; text-align: center;\\">{$item->qty}</td>\n    							<td style=\\"width: 20%; text-align: right;\\">{$item->amount}</td>\n    						</tr>";\n    						\n    						$grand_total += $item->amount;\n    					}\n    					\n    					$output .= "<tr><td style=\\"padding: 10px;\\" colspan=\\"4\\">&nbsp;</td></tr>";\n    				\n    					\n    					$grand_total_display = number_format($sale->amount,2);\n    					$discount_display = number_format($grand_total - $sale->amount,2);\n    					$amount_tendered_display = number_format($sale->amount_tendered,2);\n    					$amount_change_display = number_format($sale->amount_change,2);\n    					$discount = $sale->discount;\n    					\n    					if ($discount){\n    						if ($sale->discount_type == ''p''){\n    							$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"3\\">Discount {$discount}%</td>\n    									<td style=\\"text-align: right;\\">{$discount_display}</td>\n    								</tr>";\n    								\n    						} else {\n    							$discount_d = number_format($discount,2);\n    							$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"3\\">Discount RM{$discount_d}</td>\n    									<td style=\\"text-align: right;\\">{$discount_display}</td>\n    								</tr>";\n    						}\n    					}\n    					\n    					if ($sale->shipping_amount){\n   							$output .= "<tr>\n    									<td colspan=\\"3\\">Shipping ($sale->shipping_name)</td>\n    									<td style=\\"text-align: right;\\">{$sale->shipping_amount}</td>\n    								</tr>";\n    					}\n    					\n    					$output .= "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"3\\">Grand Total</td>\n    									<td style=\\"text-align: right;\\">{$grand_total_display}</td>\n    								</tr>\n    								<tr>\n    									<td colspan=\\"3\\">Amount Tendered</td>\n    									<td style=\\"text-align: right;\\">{$amount_tendered_display}</td>\n    								</tr>";\n    					\n    					$output .=  "<tr>\n    									<td colspan=\\"3\\">Change</td>\n    									<td style=\\"text-align: right;\\">{$amount_change_display}</td>\n    								</tr>";\n    								\n    					if ($sale->remarks){\n    						$output .=  "<tr style=\\"border-top: 1px solid #333\\">\n    									<td colspan=\\"4\\">\n    										Remarks: {$sale->remarks}\n    									</td>\n    								</tr>";\n	    					\n    					}\n    					\n    					if ($this->system->config(''checkout_cc'')){\n    						if ($sale->amount_cc != 0){\n    							$show_cash = true;\n    							$amount_cc_display = number_format($sale->amount_cc,2);\n    							$output .=  "<tr>\n    										<td colspan=\\"3\\">Credit Card Tendered ({$sale->card_type})</td>\n    										<td style=\\"text-align: right;\\">{$amount_cc_display}</td>\n    									</tr>";\n    							\n    						}\n    					}\n    				\n    					if ($this->system->config(''checkout_cheque'')){				\n    						if ($sale->amount_cheque != 0){\n    							$show_cash = true;\n    							$amount_cheque_display = number_format($sale->amount_cheque,2);\n    							$output .=  "<tr>\n    										<td colspan=\\"3\\">Cheque Tendered</td>\n    										<td style=\\"text-align: right;\\">{$amount_cheque_display}</td>\n    									</tr>";\n    						}\n    					}\n    					\n    				\n    					\n    					if ($this->system->config(''checkout_credit'')){\n    					\n    						if ($sale->amount_credit != 0){\n    							$show_cash = true;\n    							$amount_credit_display = number_format($sale->amount_credit,2);\n    							$total = number_format($this->contact->get_total_credit($sale->customer_id),2);\n    							\n    							$customer = $this->contact->get_customer_by_id($sale->customer_id);\n    							$credit_limit = number_format($customer->credit_limit,2);\n    							$available_credit = number_format($this->contact->get_credit_balance($sale->customer_id),2);\n    							\n    							\n    							$output .=  "<tr>\n    										<td colspan=\\"3\\">Credit Amount</td>\n    										<td style=\\"text-align: right;\\">{$amount_credit_display}</td>\n    									</tr>";\n    									\n    				\n    							$coutput .=  "<tr>\n    										<td colspan=\\"3\\">Credit Limit</td>\n    										<td style=\\"text-align: right\\">{$credit_limit}</td>\n    									</tr>";\n    				\n    				\n    							$coutput .=  "<tr>\n    										<td colspan=\\"3\\">Available Credit Limit</td>\n    										<td style=\\"text-align: right\\">{$available_credit}</td>\n    									</tr>";			\n    						\n    						}\n    					}\n    					\n    					if ($show_cash){				\n    						if ($sale->amount_cash){\n    							$show_cash = true;\n    							$amount_cheque_display = number_format($sale->amount_cheque,2);\n    							$output .=  "<tr>\n    										<td colspan=\\"3\\">Cash Tendered</td>\n    										<td style=\\"text-align: right;\\">{$amount_cheque_display}</td>\n    									</tr>";\n    						}\n    					}\n    					\n    					if ($coutput){\n    						$output .= "<tr style=\\"border-bottom: 1px solid #000\\"><td colspan=\\"4\\"></td></tr>";\n    						$output .= $coutput;\n    					}\n    					\n    					$output .= "</table>";\n    				\n    				\n    				}\n\n    			\n    			}\n    			\n    			\n    			\n    			$obj[''status''] = ''Success'';\n    			$obj[''html''] = $output;\n    			\n    			echo json_encode($obj);\n    			\n    			break;\n    		case "add_queue":\n    			$sql = $this->db->insert_string(''sales'',array(\n    				''type''				=> ''queue'',\n    				''payment_status'' 	=> ''Unpaid'',\n    				''username''			=> $this->user->data(''username''),\n    				''user_id''			=> $this->user->data(''id''),\n    				''terminal''			=> $this->user->terminal(),\n    				''session''			=> $this->user->data(''terminal_session'')\n    			));\n    			$query = $this->db->query($sql);\n    			\n    			$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?",array($query->insert_id));\n    			$obj = $query->row();\n    			$obj->status = ''Success'';\n    			echo json_encode($obj);\n    			\n    			break;\n    		case "void_queue":\n    			$queue_id = $this->input->post(''queue'');\n    			$this->db->query("DELETE FROM `sales` WHERE `id` = ? AND `type` = ''queue''",array($queue_id));\n    			\n    			$obj[''status''] = ''Success'';\n    			echo json_encode($obj);\n    		\n    			break;\n    		case "add_item":\n    			$queue_id = $this->input->post(''queue'');\n    			$sku = $this->input->post(''sku'');\n    			$qty = $this->input->post(''qty'');\n    			\n    			if ($sku[0] == ''x'' OR $sku[0] == ''X''){\n    				$qty = str_replace(''X'','''',str_replace(''x'','''',$sku)) - 1;\n    				$sku = $this->session->userdata(''last_sku'');\n    				if (!is_numeric($qty)) $sku = '''';\n    			} else {\n    				$this->session->set_userdata(array(''last_sku''=>$sku));\n    			}\n    			\n    			$query = $this->db->query("SELECT * FROM `inventory` WHERE `sku` = ?",array($sku));\n    			if (!$query->num_rows()){\n    				// secondary SKU search\n    				$found = false;\n    				for ($i = 2; $i <= 4; $i++){\n    					$query = $this->db->query("SELECT * FROM `inventory` WHERE `sku{$i}` = ?", array($sku));\n    					if ($query->num_rows()){\n    						$item = $obj = $query->row();\n    						\n    						$qty = $qty * $item->{''loose_qty''.$i};\n    						$qty_fraction = $item->{''loose_qty''.$i};\n\n    						$sku = $item->sku;\n    						$sku2 = $item->{''sku''.$i};\n    						\n    						$sku_select = $i;\n    						$found = true;\n    					}\n    				}\n    			} else {\n    				$sku_select = 1;\n    				$qty_fraction = 1;\n    				$item = $obj = $query->row();\n    				$found = true;\n    			}\n    			\n    			$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?", array($queue_id));\n    			$sale = $query->row();\n    			\n    			$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($sale->customer_id));\n    			if ($query->num_rows()){\n    				$customer = $query->row();\n    			} else {\n    				$customer = false;\n    			}\n    			\n    			if ($found){\n    			\n    				if ($sku_select == 1){\n    					$query = $this->db->query("SELECT * FROM `sale_items` WHERE `item_sku` = ? AND `sku_select` = ''1'' AND `sale_id` = ?",array($sku,$queue_id));\n    				} else {\n    					$query = $this->db->query("SELECT * FROM `sale_items` WHERE `item_sku2` = ? AND `sale_id` = ?",array($sku2,$queue_id));\n    				}\n    				\n    				if ($item->enter_price) $obj->enter_price = true;\n    				if ($item->enter_serial) $obj->enter_serial = true;\n    				\n    				$price_rules = json_decode($this->system->config(''price_rules''));\n    				\n    				if (!$query->num_rows()){\n    					\n    					if ($this->system->config(''cost_update_method'') == ''fifo''){\n    						$item_cost = $this->inv->get_fifo_cost($item->id, $qty);\n    					} else {\n    						$item_cost = $item->cost * $qty;\n    					}\n    					\n    					\n    						\n    					if ($sku_select == 1){\n    						\n    						if ($customer->rank){\n	    						$item_price = $item->{''price''.$price_rules->{str_replace('' '',''_'',$customer->rank)}};\n	    					} else {\n		    					$item_price = $item->price;\n		    				}\n\n    						$margin = ($item_price * $qty) - $item_cost;\n    					} else {\n    						\n    						if ($customer->rank){\n	    						$item_price = $item->{''price''.$sku_select.$price_rules->{str_replace('' '',''_'',$customer->rank)}};\n	    					} else {\n	    						$item_price = $item->{''price''.$sku_select};\n		    				}\n\n\n    						$margin = ($item_price * $qty / $qty_fraction) - $item_cost;\n    					}\n    					\n    					$sql = $this->db->insert_string(''sale_items'',array(\n    						''sale_id''		=> $queue_id,\n    						''item_id''		=> $item->id,\n    						''date''			=> date(''Y-m-d''),\n    						''item_sku''		=> $sku,\n    						''item_sku2''		=> $sku2,\n    						''item_name''		=> $item->name,\n    						''unit''			=> $item->{''uom''.$sku_select},\n    						''qty''			=> $qty,\n    						''qty_fraction''	=> $qty_fraction,\n    						''sku_select''	=> $sku_select,\n    						''price_per_unit''=> $item_price,\n    						''cost''			=> $item_cost,\n    						''margin''		=> $margin,\n    						''terminal''		=> $this->user->terminal(),\n    						''points''		=> $item->redeem_points,\n    						''session''		=> $this->user->data(''terminal_session''),\n    						''amount''		=> $item_price * ($qty / $qty_fraction)\n    					));\n    					$query = $this->db->query($sql);\n    					$obj->id = $query->insert_id;\n    					$obj->status = ''Success'';\n    					$obj->amount = number_format($item_price * $qty,2);\n    					$obj->qty = $qty;\n    					$obj->name = $item->name;\n    					$obj->price = $item_price;\n    					$obj->outstanding = ($val = $this->update_amount($queue_id)) ? number_format($val,2) : ''0.00'' ;\n\n\n    					\n    				} else {\n    					$existing_item = $query->row();\n    					\n    					if ($this->system->config(''cost_update_method'') == ''fifo''){\n    						$item_cost = $this->inv->get_fifo_cost($item->id, $qty);\n    					} else {\n    						$item_cost = $item->cost * $qty;\n    					}\n    					\n    					if ($sku_select == 1){\n    						$sql = $this->db->update_string(''sale_items'',array(\n    							''qty''			=> $existing_item->qty + $qty,\n    							''cost''			=> $existing_item->cost + ($item_cost),\n    							''margin''		=> $existing_item->margin + (($item->price - $item->cost) * $qty),\n    							''amount''		=> $existing_item->amount + ($item->price * $qty),\n    							''points''		=> $item->redeem_points\n    						),"`sale_id` = ''$queue_id'' AND `item_sku` = ''{$sku}'' AND `sku_select` = 1");\n    					} else {\n    						$item_price = $item->{''price''.$sku_select};\n    						$sql = $this->db->update_string(''sale_items'',array(\n    							''qty''			=> $existing_item->qty + $qty,\n    							''cost''			=> $xcost = $existing_item->cost + ($item_cost),\n    							''amount''		=> $xamount = $existing_item->amount + ($item_price * ($qty / $qty_fraction)),\n    							''margin''		=> $xamount - $xcost,\n    							''points''		=> $item->redeem_points\n    						),"`sale_id` = ''$queue_id'' AND `item_sku2` = ''{$sku2}''");\n    					}\n\n    					$this->db->query($sql);\n    					$obj->status = ''Success'';\n    					$obj->amount = number_format($item->price * $qty,2);\n    					$obj->qty = $qty;\n    					$obj->name = $item->name;\n    					$obj->price = $item->price;\n    					$obj->outstanding = ($val = $this->update_amount($queue_id)) ? number_format($val,2) : ''0.00'' ;\n    					$obj->id = $existing_item->id;\n    				}\n    				\n\n    				\n    			} else {\n    				$obj[''outstanding''] = ($val = $this->update_amount($queue_id)) ? number_format($val,2) : ''0.00'' ;\n    				$obj[''status''] = ''Failed'';\n    			}\n    			echo json_encode($obj);\n\n    			break;\n    			\n    		case "enter_discount":\n    			$item_id	= $this->input->post(''item_id'');\n    			$queue_id	= $this->input->post(''queue_id'');\n    			$type		= $this->input->post(''discount_type'');\n    			$value		= $this->input->post(''discount_value'');\n    			$to			= $this->input->post(''to'');\n    			\n    			if ($to == ''item''){\n    				$query = $this->db->query("SELECT * FROM `sale_items` WHERE `id` = ?", array($item_id));\n    				$sale_item = $query->row();\n    				\n    				$total = $sale_item->price_per_unit * ($sale_item->qty / $sale_item->qty_fraction);\n    				\n    				if ($type == ''d'') $amount = $total - $value;\n    				else $amount = $total * ((100 - $value) / 100);\n    				\n    				\n    				$sql = $this->db->update_string(''sale_items'', array(\n    					''discount_type''		=> $type,\n    					''discount_value''	=> $value,\n    					''discount_amount''	=> $discount_acount,\n    					''amount''			=> $amount\n    				), "`id` = ''{$item_id}''");\n    				\n    				$this->db->query($sql);\n    			} else {\n    				\n    				\n    			\n    				$sql = $this->db->update_string(''sales'', array(\n    					''discount_type''	=> $type,\n    					''discount''		=> $value\n    				), "`id` = ''{$queue_id}''");\n    				\n    				$this->db->query($sql);\n    				\n    				$sql = $this->db->update_string(''sale_items'', array(\n    					''global_discount_type''	=> $type,\n    					''global_discount''		=> $value\n    				), "`sale_id` = ''{$queue_id}''");\n    				$this->db->query($sql);\n\n    			}\n    			\n    			break;\n    			\n    		case "enter_serial":\n    			$id = $this->input->post(''id'');\n    			$serial = $this->input->post(''serial'');\n    			\n    			$query = $this->db->query("SELECT * FROM `sale_items` WHERE `id` = ?", array($id));\n    			$sale_item = $query->row();\n    			\n    			if ($sale_item->serial_no){\n    				$serial_no = $sale_item->serial_no . '', '' . $serial;\n    			} else {\n    				$serial_no = $serial;\n    			}\n    			\n    			$sql = $this->db->update_string(''sale_items'',array(\n    				''serial_no''	=> $serial_no\n    			), "`id` = ''$id''");\n    			\n    			$this->db->query($sql);\n    			\n    			break;\n    		case "enter_price":\n    			$id = $this->input->post(''id'');\n    			$price = $this->input->post(''price'');\n    			$qty = $this->input->post(''qty'');\n    			$replace = $this->input->post(''replace'');\n    			\n\n    			$query = $this->db->query("SELECT * FROM `sale_items` WHERE `id` = ?", array($id));\n    			$sale_item = $query->row();\n    			\n    			$query = $this->db->query("SELECT * FROM `inventory` WHERE `id` = ?", array($sale_item->item_id));\n    			$item = $query->row();\n    			\n    			$markup = (($item->price - $item->cost) / $item->cost) * 100;\n\n    			if ($replace){\n\n    				if ($item->adjust_cost){\n    					$sale_item->cost = (100 / ($markup + 100)) * $price;\n    				}\n    				\n    				$sale_item->amount = $price;\n    				$sale_item->margin = $sale_item->amount - $sale_item->cost;\n    				$sale_item->price_per_unit = $sale_item->amount / $sale_item->qty;				\n\n    			} else {\n    			\n    				if ($item->adjust_cost){\n    					$sale_item->cost = (100 / ($markup + 100)) * $price;\n    				}\n    				\n    				$sale_item->amount += ($price * $qty) - ($item->price * $qty);\n    				$sale_item->margin = ($sale_item->amount * $qty) - ($sale_item->cost * $qty);\n    				$sale_item->price_per_unit = $sale_item->amount / $sale_item->qty;\n    			\n    			}\n    			\n    			\n    			\n    			$this->db->query($this->db->update_string(''sale_items'', array(\n    				''cost''			=> $sale_item->cost,\n    				''amount''		=> $sale_item->amount,\n    				''margin''		=> $sale_item->margin,\n    				''price_per_unit''=> $sale_item->price_per_unit\n    			), "`id` = ''$id''"));\n    			\n    			$this->update_amount($sale_item->sale_id);\n    			\n    			\n    			break;\n    		case "void_item":\n    			$queue_id = $this->input->post(''queue'');\n    			$queue_item_id = $this->input->post(''item'');\n    			\n    			$this->db->query("DELETE FROM `sale_items` WHERE `id` = ?",array($queue_item_id));\n    			$this->update_amount($queue_id);\n    			$obj[''status''] = ''Success'';\n    			\n    			$this->session->set_userdata(array(''last_sku''=>''''));\n    			\n    			echo json_encode($obj);\n    		\n    			break;\n    		case "cash_checkout":\n    			$queue_id = $this->input->post(''queue'');\n    			$amount_tendered = $this->input->post(''amount_tendered'');\n    			\n    			$amount_cc = $this->input->post(''amount_cc'');\n    			$amount_cheque = $this->input->post(''amount_cheque'');\n    			$amount_credit = $this->input->post(''amount_credit'');\n    			$amount_cash = $this->input->post(''amount_cash'');\n    			$card_type = $this->input->post(''card_type'');\n    			$remarks = $this->input->post(''remarks'');\n\n    			$customer_phone = $this->input->post(''customer_phone'');\n    			$member_id = $this->input->post(''member'');\n    		\n    			$amount = $this->update_amount($queue_id);\n    			\n    			$this->session->set_userdata(array(''last_sku''=>''''));\n    			\n    			$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?", array($queue_id));\n    			$sale = $query->row();\n    			\n    			$discount = $sale->discount;\n    			$dtype = $sale->discount_type;\n    			\n\n    			if ($discount){\n    				if ($dtype == ''p''){\n    					$amount = str_replace('','','''',number_format($amount * ((100 - $discount) / 100),2));\n    				} else {\n    					$amount = str_replace('','','''',number_format($amount - $discount,2));\n    				}\n\n    			} \n    			\n    			$taxes = $this->tax->get_enabled_taxes();\n    			foreach ($taxes as $tax){\n    				$saletax[$tax->id] = number_format($tax_amount = ($tax->percentage / 100 * $amount), 2);\n    				$taxes_amount += $tax_amount;\n    			}\n    			\n    			$amount += $taxes_amount;\n    			\n    			list($ones, $decimals) = explode(''.'',$amount);\n    			\n    			if ($decimals[1] <= 2){\n    				$newDec = 0;\n    				$addition = 0;\n    			} else if ($decimals[1] <= 7){\n    				$newDec = 5;\n    				$addition = 0;\n    			} else if ($decimals[1] <= 9){\n    				$newDec = 0;\n   					$addition = 0.1;\n   				}\n    				\n   				$discounted = $ones . ''.'' . $decimals[0] . $newDec;\n   				$discounted += $addition;\n    				\n   				$amount = $discounted;\n   				\n   				$amount += $sale->shipping_amount;\n    			\n    			$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?", array($queue_id));\n    			$sale = $query->row();\n    			\n    			if (!$this->system->config(''checkout_ltc'')){\n    				if ($sale->cost > $amount){\n    					$obj[''status''] = ''failed'';\n    					$obj[''reason''] = ''This sales transaction is lower than cost.'';\n    					echo json_encode($obj);	\n    					return;\n    				}\n    			}\n    			\n    			$change = $amount_tendered - $amount;\n    			\n    			\n    			$sql = $this->db->update_string(''sales'',array(\n    				''type''				=> ''history'',\n    				''payment_status''	=> ''Paid'',\n    				''amount_tendered''	=> $amount_tendered,\n    				''amount_change''		=> $change,\n    				''amount_cheque''		=> $amount_cheque,\n    				''amount_cash''		=> $amount_cash - $change,\n    				''amount_credit''		=> $amount_credit,\n    				''amount_cc''			=> $amount_cc,\n    				''amount''			=> $amount,\n    				''payment_method''	=> ''Cash'',\n    				''discount''			=> $discount,\n    				''taxes''				=> json_encode($taxes),\n    				''tax_amount''		=> $tax_amount,\n    				''card_type''			=> $card_type,\n    				''discount_type''		=> $dtype,\n    				''customer_phone''	=> $customer_phone,\n    				''remarks''			=> $remarks,\n    				''datetime''			=> date(''Y-m-d H:i:s''),\n    				''warehouse_id''		=> $this->user->terminal_data(''warehouse_id'')\n    			),"`id` = ''$queue_id''");\n    			$this->db->query($sql);\n    			\n    			$sql = $this->db->update_string(''sale_items'', array(\n    				''sold''				=> 1,\n    				''date''				=> date(''Y-m-d H:i:s''),\n    				''member_id''			=> $sale->customer_id,\n    				''session''			=> $this->user->data(''terminal_session''),\n    				''warehouse_id''		=> $this->user->terminal_data(''warehouse_id'')\n    			),"`sale_id` = ''$queue_id''");\n    			$this->db->query($sql);\n    			\n    			$sale_items_query = $this->db->query("SELECT * FROM `sale_items` WHERE `sale_id` = ?", array($queue_id));\n    			\n    			foreach ($sale_items_query->result() as $sale_item){\n    			\n    		    	$this->inv->update_item_qty($sale_item->item_id);\n    		    	\n    		    	$sql = $this->db->update_string(''inventory'',array(\n    		    		''last_sold''	=> date(''Y-m-d H:i:s'')\n    		    	),"`id` = ''{$sale_item->item_id}''");\n    		    	$this->db->query($sql);\n    		    	\n    		    	if ($this->system->config(''cost_update_method'') == ''fifo''){									\n    					$query = $this->db->query("SELECT * FROM `fifo` WHERE `item_id` = ? ORDER BY `datetime` ASC", array($sale_item->item_id));	\n\n    			    	$fifo_cost = $item->cost; // defaulting\n    			    	$fifo_qty = 0;\n    			    	\n    			    	$cont = true;\n    			    	\n    			    	foreach ($query->result() as $fifo){\n    			    		$fifo_qty += $fifo->qty;\n    			    		if ($fifo_qty >= $item->qty && $cont){\n    			    			$current_po = $fifo;\n    			    			$cont = false;\n    			    		}\n    			    	}\n    			    	\n    			    	if ($item->cost != $current_po->cost){\n    			    		$this->db->query("UPDATE `inventory` SET `cost` = ?, `current_po` = ?, `current_po_item` = ? WHERE `id` = ?", array($current_po->cost, $current_po->po_id, $current_po->po_item_id,$item->id));\n    			    	}\n    			    	\n    					$margin = $sale_item->amount - $this->inv->get_fifo_cost($sale_item->item_id, $sale_item->qty);\n    			    	\n    			    	$sql = $this->db->update_string(''sale_items'', array(\n    			    		''margin''	=> $margin,\n    			    		''cost''		=> $cost\n    			    	),"`id` = ''{$sale_item->id}''");\n    			    	\n    			    	$this->db->query($sql);\n    				}\n    			}\n    			\n    				\n    			\n    			\n    			if ($this->system->config(''member_points'')){\n    				$min_point = $this->system->config(''member_minimum_point'');\n    				$min_amount = $this->system->config(''member_minimum_amount'');\n    				\n    				$points = floor($amount / $min_amount * $min_point);\n    				\n    				$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($member_id));\n    				$member = $query->row();\n    				\n    				$new_points = $member->points + $points;\n    				\n    				$sql = $this->db->update_string(''contacts'', array(\n    					''loyalty_points''	=> $new_points,\n    				),"`id` = ''$member_id''");\n    				\n    				$this->db->query($sql);\n    				\n    			}\n    			\n    			// Invoice\n    			if ($amount_credit){\n    				$query = $this->db->query("SELECT * FROM `customers` WHERE `id` = ?", array($customer_id));\n    				$customer = $query->row();\n    				$sql = $this->db->insert_string(''invoices'',array(\n    					''date''			=> date(''Y-m-d H:i:s''),\n    					''customer''		=> $customer->company_name,\n    					''customer_id''	=> $customer->id,\n    					''terms''			=> ''Credit'',\n    					''status''		=> ''Delivered'',\n    					''total''			=> $amount,\n    					''total_delivered'' => $amount,\n    					''payment_status''=> ''Unpaid'',\n    					''amount_cash''	=> $amount_cash,\n    					''amount_cc''		=> $amount_cc,\n    					''amount_cheque''	=> $amount_cheque,\n    					''amount_credit''	=> $amount_credit,\n    					''paid_cash''		=> 1,\n    					''paid_cc''		=> 1,\n    					''paid_cheque''	=> 1,\n    					''paid_credit''	=> 0,\n    					''added_on''		=> date(''Y-m-d H:i:s''),\n    					''added_by''		=> $this->user->data(''username''),\n    					''no_do''			=> 1,\n    					''sales_reference_id'' => $queue_id\n    				));\n    				\n    				$query = $this->db->query($sql);\n    				\n    				$invoice_id = $query->insert_id;\n    				\n    				$query = $this->db->query("SELECT * FROM `sale_items` WHERE `sale_id` = ?", array($queue_id));\n    				\n    				foreach ($query->result() as $item){\n    					\n    					$sql = $this->db->insert_string(''invoice_items'',array(\n    		    			''invoice_id''		=> $invoice_id,\n    		    			''date''				=> date(''Y-m-d H:i:s''),\n    		    			''item_id''			=> $item->item_id,\n    		    			''qty''				=> $item->qty,\n    		    			''price''				=> $item->amount,\n    		    			''price_per_unit''	=> $item->price_per_unit,\n    		    			''margin''			=> $item->margin,\n    		    			''cost''				=> $item->cost,\n    		    			''no_do''				=> 1\n    		    		));\n    		    		\n    		    		$this->db->query($sql);\n    		    		\n\n    				}\n\n    			}\n    			\n    			$obj[''tendered''] = number_format($amount_tendered,2);\n    			$obj[''amount_credit''] = number_format($amount_credit,2);\n    			$obj[''amount_cc''] = number_format($amount_cc,2);\n    			$obj[''amount_cash''] = number_format($amount_cash,2);\n    			$obj[''amount_cheque''] = number_format($amount_cheque,2);\n    			$obj[''change''] = number_format($amount_tendered - $amount,2);\n    			$obj[''status''] = ''Success'';\n    			\n\n    			\n    			\n    			echo json_encode($obj);				\n    		\n    			break;\n    		case "redeem":\n    			$queue_id = $this->input->post(''queue'');\n    			$member_id = $this->input->post(''member'');\n    			\n    			$query = $this->db->query("SELECT * FROM `sale_items` WHERE `sale_id` = ?", array($queue_id));\n\n    			foreach ($query->result() as $sale_item){\n    				$query = $this->db->query("SELECT * FROM `inventory` WHERE `id` = ?", array($sale_item->item_id));\n    				$item = $query->row();\n    				$amount += $item->redeem_points * $sale_item->qty;\n    			}\n    			\n\n    			$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?", array($queue_id));\n    			$sale = $query->row();\n    			\n    			$sql = $this->db->update_string(''sales'',array(\n    				''type''				=> ''history'',\n    				''payment_status''	=> ''Redeem'',\n    				''amount''			=> $amount,\n    				''member_id''			=> $member_id,\n    				''customer_id''		=> $member_id,\n    				''is_redemption''		=> 1,\n    				''datetime''			=> date(''Y-m-d H:i:s'')\n    			),"`id` = ''$queue_id''");\n    			$this->db->query($sql);\n    			\n    			$sql = $this->db->update_string(''sale_items'', array(\n    				''sold''				=> 1,\n    				''redeemed''			=> 1,\n    				''session''			=> $this->user->data(''terminal_session''),\n    				''member_id''			=> $member_id\n    			),"`sale_id` = ''$queue_id''");\n    			$this->db->query($sql);\n    				\n    			$query = $this->db->query("SELECT * FROM `members` WHERE `id` = ?", array($member_id));	\n    			$member = $query->row();\n    			\n    			$new_points = $member->points - $amount;\n    				\n    			$sql = $this->db->update_string(''members'', array(\n    				''points''	=> $new_points,\n    			),"`id` = ''$member_id''");\n    			$this->db->query($sql);\n    				\n    			$obj[''amount''] = $amount;\n    			$obj[''balance''] = $new_points;\n    			$obj[''status''] = ''Success'';				\n    			echo json_encode($obj);				\n    		\n    			break;\n\n    			\n    		case "print_receipt":\n    			$queue_id = $this->input->post(''queue'');\n    			\n    			break;\n    		case "reprint_receipt":\n    			$queue_id = $this->input->post(''queue'');\n    			break;\n    		case "get_queue_list":\n    			\n    			$query = $this->db->query("SELECT * FROM `sales` WHERE `type` = ''queue'' AND `session` = ? ORDER BY `id` DESC", array($this->user->data(''terminal_session'')));\n    			\n    			foreach ($query->result() as $queue){\n    				if ($queue->amount){\n    				$output .= "<li id=\\"{$queue->id}\\">\n    						<strong>TXN{$queue->id} - RM{$queue->amount} </strong>\n    					</li>";\n    				} else {\n    				$output .= "<li id=\\"{$queue->id}\\">\n    						<strong>TXN{$queue->id} - RM0.00 </strong>\n    					</li>";\n    				}\n    			}\n    			\n    			$obj[''status''] = ''Success'';\n    			$obj[''html''] = $output;\n    			\n    			echo json_encode($obj);\n    			\n    			break;\n    		case "get_history_list":\n    			$phone = $this->input->post(''phone'');\n    			\n    			if (!$phone){\n    				$query = $this->db->query("SELECT * FROM `sales` WHERE `session` = ? AND `type` = ''history'' ORDER BY `datetime` DESC",array($this->user->data(''terminal_session''), $today,$tomorrow));\n    			} else {\n    				$query = $this->db->query("SELECT * FROM `sales` WHERE `customer_phone` = ? ORDER BY `datetime` DESC",array($phone));\n    			}\n    			foreach ($query->result() as $queue){\n    				$time = date(''h:iA j/m/Y'',strtotime($queue->datetime));\n    				$total_items = $this->get_total_items($queue->id);\n    				$output .= "<li id=\\"{$queue->id}\\">\n    						<strong>TXN{$queue->id} - RM{$queue->amount} </strong><br />\n    						{$total_items} item(s) at {$time} \n    					</li>";\n    			}\n    			\n    			$obj[''status''] = ''Success'';\n    			$obj[''phone''] = $phone;\n    			$obj[''html''] = $output;\n    			\n    			echo json_encode($obj);\n    		\n    			break;\n    		case "get_item_list":\n    			$queue_id = $this->input->post(''queue'');\n    			$type = $this->input->post(''type'');\n    			\n    			if ($type == ''invoice''){\n\n    				$query = $this->db->query("SELECT * FROM `invoices` WHERE `id` = ?",array($queue_id));\n    				$sale = $query->row();\n    				$currency = $this->system->config(''currency'');\n    				$query = $this->db->query("SELECT * FROM `invoice_items` WHERE `invoice_id` = ?",array($queue_id));\n    				foreach ($query->result() as $item){\n    					$qty_in_stock = $this->inv->get_item_quantity($item->item_id);\n    					$act_item = $this->inv->get_item_by_id($item->item_id);\n    					\n    					if ($item->serial_no){\n    						$serial_nos = ''<br />SN: '' . $item->serial_no;\n    					} else {\n    						$serial_nos = '''';\n    					}\n    \n    					if ($this->system->config(''sales_screen_cost'')) $cost = " ({$currency}{$item->cost}) ";\n    					if ($act_item->redeemable) $redeemable = ''1'';\n    					else $redeemable = ''0'';\n    					\n    					if ($item->discount_value){\n    						if ($item->discount_type == ''d'') $discount = ''-'' . number_format($item->discount_value,2);\n    						else $discount = $item->discount_value . ''%'';\n    					} else {\n    						$discount = '''';\n    					}\n    					\n    					$redeem_points = $act_item->redeem_points;\n\n    					$output .= "<li class=\\"\\" redeemable=\\"{$redeemable}\\" points=\\"{$redeem_points}\\" id=\\"{$item->id}\\" qty=\\"{$item->qty}\\" name=\\"{$act_item->name}\\" price=\\"{$act_item->price}\\"><table class=\\"vui-dt-row\\"><tr>\n    						<td style=\\"width: 50%\\"><strong style=\\"font-size: 11pt\\">{$item->item_name}</strong><br />{$act_item->sku} {$cost} {$serial_nos}</td>\n    						<td style=\\"width: 20%; font-weight: bold; font-size: 12pt; text-align: center;\\">{$item->qty} <small>{$item->unit}</small><br /><small style=\\"font-weight:normal; color: #AAA\\">({$qty_in_stock})</small></td>\n    						<td style=\\"width: 15%; font-weight: bold; font-size: 11pt; text-align: center;\\">{$discount}</td>\n    						<td class=\\"item-amount\\" style=\\"width: 20%; text-align: right;\\">{$item->delivered_price}</td>\n    					</tr></table></li>";\n    				}\n    				\n    				$obj[''status''] = ''Success'';\n    				$obj[''discount''] = $sale->discount == ''undefined'' ? 0 : $sale->discount; \n    				$obj[''discount_type''] = $sale->discount_type;\n    				$obj[''gross_profit''] = number_format($sale->total_delivered - $sale->cost,2);\n    				$obj[''amount''] = $sale->total_delivered;\n    				$obj[''delivery''] = $sale->shipping_amount;\n    				$obj[''shipping_id'']	= $sale->shipping;\n    				$obj[''adjustment''] = $sale->adjustment;\n    				$obj[''remarks'']			= $sale->remarks;\n    				$obj[''html''] = $output;\n    			\n    			\n    			} else {\n\n    				$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?",array($queue_id));\n    				$sale = $query->row();\n    				\n    				$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($sale->customer_id));\n    				$customer = $query->row();\n    				\n    				$currency = $this->system->config(''currency'');\n    				$query = $this->db->query("SELECT * FROM `sale_items` WHERE `sale_id` = ?",array($queue_id));\n    				foreach ($query->result() as $item){\n    					$qty_in_stock = $this->inv->get_item_quantity($item->item_id);\n    					\n    					$act_item = $this->inv->get_item_by_id($item->item_id);\n    					\n    					if ($item->serial_no){\n    						$serial_nos = ''<br />SN: '' . $item->serial_no;\n    					} else {\n    						$serial_nos = '''';\n    					}\n    \n    					if ($this->system->config(''sales_screen_cost'')) $cost = " ({$currency}{$item->cost}) ";\n    					if ($act_item->redeemable) $redeemable = ''1'';\n    					else $redeemable = ''0'';\n    					\n    					if ($item->discount_value){\n    						if ($item->discount_type == ''d'') $discount = ''-'' . number_format($item->discount_value,2);\n    						else $discount = $item->discount_value . ''%'';\n    					} else {\n    						$discount = '''';\n    					}\n    					\n    					$redeem_points = $act_item->redeem_points;\n    					if ($item->sku_select == 1){\n    						$output .= "<li class=\\"\\" redeemable=\\"{$redeemable}\\" points=\\"{$redeem_points}\\" id=\\"{$item->id}\\" qty=\\"{$item->qty}\\" name=\\"{$act_item->name}\\" price=\\"{$act_item->price}\\"><table class=\\"vui-dt-row\\"><tr>\n    							<td style=\\"width: 50%\\"><strong style=\\"font-size: 11pt\\">{$item->item_name}</strong><br />{$item->item_sku} {$cost} {$serial_nos}</td>\n    							<td style=\\"width: 20%; font-weight: bold; font-size: 12pt; text-align: center;\\">{$item->qty} <small>{$item->unit}</small><br /><small style=\\"font-weight:normal; color: #AAA\\">({$qty_in_stock})</small></td>\n    							<td style=\\"width: 15%; font-weight: bold; font-size: 11pt; text-align: center;\\">{$discount}</td>\n    							<td class=\\"item-amount\\" style=\\"width: 20%; text-align: right;\\">{$item->amount}</td>\n    						</tr></table></li>";\n    					} else {\n    						$qty_unit = $item->qty / $item->qty_fraction;\n    						$output .= "<li class=\\"\\" redeemable=\\"{$redeemable}\\" points=\\"{$redeem_points}\\" id=\\"{$item->id}\\" qty=\\"{$item->qty}\\" name=\\"{$act_item->name}\\" price=\\"{$act_item->price}\\"><table class=\\"vui-dt-row\\"><tr>\n    							<td style=\\"width: 50%\\"><strong style=\\"font-size: 11pt\\">{$item->item_name}</strong><br />{$item->item_sku2} {$cost} {$serial_nos}</td>\n    							<td style=\\"width: 20%; font-weight: bold; font-size: 12pt; text-align: center;\\">{$qty_unit} <small>{$item->unit}</small><br /><small style=\\"font-weight:normal; color: #AAA\\">({$qty_in_stock})</small></td>\n    							<td style=\\"width: 15%; font-weight: bold; font-size: 11pt; text-align: center;\\">{$discount}</td>\n    							<td class=\\"item-amount\\" style=\\"width: 20%; text-align: right;\\">{$item->amount}</td>\n    						</tr></table></li>";\n    					}\n    				}\n    				\n    				$obj[''status''] 			= ''Success'';\n    				$obj[''discount'']		= $sale->discount == ''undefined'' ? 0 : $sale->discount; \n    				$obj[''discount_type''] 	= $sale->discount_type;\n    				$obj[''gross_profit''] 	= number_format($sale->amount - $sale->cost,2);\n    				$obj[''amount''] 			= $sale->amount;\n    				$obj[''delivery''] 		= $sale->shipping_amount;\n    				$obj[''shipping_id'']		= $sale->shipping;\n    				$obj[''customer'']		= $customer;\n    				$obj[''adjustment''] 		= $sale->adjustment;\n    				$obj[''remarks'']			= $sale->remarks;\n    				$obj[''html''] 			= $output;\n    				\n    			}\n    			\n    			echo json_encode($obj);\n    		\n    			break;\n    		case "search_items":\n    			$name = $this->input->post(''name'');\n    			\n    			$query = $this->db->query("SELECT * FROM `inventory` WHERE `name` LIKE ?", array(''%''.$name.''%''));\n    			foreach ($query->result() as $item){\n    				$output .= "<li sku=\\"{$item->sku}\\">{$item->name}</li>";\n    			}\n    			$obj[''status''] = ''Success'';\n    			$obj[''html''] = $output;\n    			\n    			echo json_encode($obj);\n    			break;\n    			\n    		case "employee_clock_in":\n    			$username = $this->input->post(''username'');\n    			$password = $this->input->post(''password'');\n    			\n    			if ($employee_id = $this->user->verify_authentication($username, $password)){\n    				$this->user->clock_in($employee_id);\n    				$result->status = ''OK'';\n    			} else {\n    				$result->status = ''Auth Failed'';\n    			}\n    			\n    			echo json_encode($result);\n    			\n    			break;\n    		\n    		case "employee_clock_out":\n    			$username = $this->input->post(''username'');\n    			$password = $this->input->post(''password'');\n    			\n    			if ($employee_id = $this->user->verify_authentication($username, $password)){\n    				$co_status = $this->user->clock_out($employee_id);\n    				\n    				if ($co_status){\n    					$result->status = ''OK'';\n    				} else {\n    					$result->status = ''No CI Record'';\n    				}\n    				\n    			} else {\n    				$result->status = ''Auth Failed'';\n    			}\n    			\n    			echo json_encode($result);\n    			\n    			break;\n    			\n    		case "clear_customer":\n	    		$queue_id = $this->input->post(''queue_id'');			\n    			$price_rules = json_decode($this->system->config(''price_rules''));\n    			\n	    			\n	    		$this->db->update(''sales'', array(\n    			    ''customer_id''	=> ''''\n    			), "`id` = ''{$queue_id}''");\n	    		\n	    		$query = $this->db->query("SELECT * FROM `sale_items` WHERE `sale_id` = ?", array($queue_id));\n	    		foreach ($query->result() as $item){\n	    		    $query = $this->db->query("SELECT * FROM `inventory` WHERE `id` = ?", array($item->item_id));\n	    		    $actual_item = $query->row();\n	    		    $item->price = $actual_item->price;\n		    	    \n		    	    $item->price_per_unit = $item->price;\n		    	    $item->amount = $item->price_per_unit * $item->qty;\n		    	    \n		    	    $this->db->update(''sale_items'', array(\n		    	    	''price_per_unit''	=> $item->price_per_unit,\n		    	    	''margin''			=> $item->amount - $item->cost,\n		    	    	''amount''			=> $item->amount\n		    	    ), "`id` = ''{$item->id}''");\n\n	    		}\n\n		    	\n		    	$result->status = ''Success'';\n	    		\n\n    			echo json_encode($result);\n    		\n    			break;\n    			\n    		case "enter_customer":\n    			$id = $this->input->post(''customer_id'');\n    			$queue_id = $this->input->post(''queue_id'');\n    			\n    			$price_rules = json_decode($this->system->config(''price_rules''));\n    			\n    			\n    			$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($id));\n    			if ($query->num_rows()){\n	    			$customer = $query->row();\n	    			\n	    			$this->db->update(''sales'', array(\n    					''customer_id''	=> $customer->id,\n    					''member_id''		=> $customer->id\n    				), "`id` = ''{$queue_id}''");\n    				\n	    			\n	    			$query = $this->db->query("SELECT * FROM `sale_items` WHERE `sale_id` = ?", array($queue_id));\n	    			foreach ($query->result() as $item){\n	    				$query = $this->db->query("SELECT * FROM `inventory` WHERE `id` = ?", array($item->item_id));\n	    				$actual_item = $query->row();\n	    				\n	    				if ($customer->rank){\n		    				$item->price = $actual_item->{''price''.$price_rules->{str_replace('' '',''_'',$customer->rank)}};\n		    			} else {\n			    			$item->price = $actual_item->price;\n		    			}\n		    			\n		    			$item->price_per_unit = $item->price;\n		    			$item->amount = $item->price_per_unit * $item->qty;\n		    			\n		    			$this->db->update(''sale_items'', array(\n		    				''price_per_unit''	=> $item->price_per_unit,\n		    				''margin''			=> $item->amount - $item->cost,\n		    				''amount''			=> $item->amount\n		    			), "`id` = ''{$item->id}''");\n\n	    			}\n		    			\n	    			if ($contact->rank){\n		    			$item->price = $item->{''price''.$price_rules->{str_replace('' '',''_'',$contact->rank)}};\n		    		}\n		    		\n		    		$result->status = ''Success'';\n	    			\n    			} else {\n	    			$result->status = ''Failed'';\n    			}\n    			\n    			echo json_encode($result);\n    			\n    			break;\n    		\n    		case "get_customer":\n    			$identifier = $this->input->post(''identifier'') ? $this->input->post(''identifier'') : ''ic'';\n    			$id 		= $this->input->post(''id'');\n    			\n    			\n    			$query = $this->db->query("SELECT * FROM `contacts` WHERE {$identifier} = ?", array($id));\n    			if ($query->num_rows()){\n	    			$result->status = ''Success'';\n	    			$result->customer = $query->row();\n	    				    			\n    			} else {\n	    			$result->status = ''Failed'';\n    			}\n    			\n    			echo json_encode($result);\n    			\n    			break;\n    		case "get_delivery_charges":\n    		\n    			$queue_id = $this->input->post(''queue'');\n    			$id = $this->input->post(''id'');\n    			\n    			$query = $this->db->query("SELECT * FROM `shipping` WHERE `id` = ?", array($id));\n    			$service = $query->row();\n    			\n    			$query = $this->db->query("SELECT * FROM `sales` WHERE `id` = ?", array($queue_id));\n    			$sale = $query->row();\n    			\n    			$query = $this->db->query("SELECT * FROM `sale_items` WHERE `sale_id` = ?", array($queue_id));\n    			$items = $query->result();\n    			foreach ($items as $item){\n    				$ditem = null;\n    				$ditem->qty = $item->qty * $item->qty_fraction;\n    				$ditem->id = $item->item_id;\n    				$ditems[] = $ditem;\n    			}\n    			\n    			$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($sale->customer_id));\n    			$contact = $query->row();\n    			\n    			$charges = $this->shipping->get_delivery_charges($id, $contact->country, $contact->zipcode, $ditems);\n    			\n    			$amount = $sale->amount + $charges->total_weight;\n    			\n    			$sql = $this->db->update_string(''sales'',array(\n    				''amount''			=> $amount,\n    				''shipping''			=> $id,\n    				''shipping_name''		=> $service->name,\n    				''shipping_weight''	=> $charges->total_weight,\n    				''shipping_amount''	=> $charges->total_rate\n    			),"`id` = ''$queue_id''");\n    			$this->db->query($sql);\n    			\n    			\n    			\n    			\n    			\n    			$result->sale = $sale;\n    			$result->contact = $contact;\n    			$result->items = $ditems;\n    			$result->service = $id;\n    			$result->queue_id = $queue_id;\n    			$result->charges = $charges;\n    			$result->status = ''Success'';\n    			\n    			echo json_encode($result);\n    			\n    	}\n    }\n    \n    \n    function Update_amount($queue_id){\n    	$query = $this->db->query("SELECT SUM(`amount`) AS `total`, SUM(`cost`) AS `total_cost` FROM `sale_items` WHERE `sale_id` = ? GROUP BY `sale_id`", array($queue_id));\n    	$amount = $query->row();\n    	\n    	if ($this->system->config(''rounding_adjust'')){\n    		list($ones, $cents) = explode(''.'',str_replace('','','''',number_format($amount->total,2)));\n    		\n    		if ($cents[1] == 1){\n    			$cents -= 1;\n    			$adjustment = -1;\n    		} elseif ($cents[1] == 2){\n    			$cents -= 2;\n    			$adjustment = -2;\n    		} elseif ($cents[1] == 3){\n    			$cents += 2;\n    			$adjustment = 2;\n    		} elseif ($cents[1] == 4){\n    			$cents += 1;\n    			$adjustment = 1;\n    		} elseif ($cents[1] == 6){\n    			$cents -= 1;\n    			$adjustment = -1;\n    		} elseif ($cents[1] == 7){\n    			$cents -= 2;\n    			$adjustment = -2;\n    		} elseif ($cents[1] == 8){\n    			$cents += 2;\n    			$adjustment = 2;\n    		} elseif ($cents[1] == 9){\n    			$cents += 1;\n    			$adjustment = 1;\n    		} else {\n    			$adjustment = 0;\n    		}\n    	} else {\n    		$adjustment = 0;\n    	}\n\n    	\n    	$sql = $this->db->update_string(''sales'',array(\n    		''amount''	=> $amount->total + ($adjustment / 100),\n    		''cost''		=> $amount->total_cost,\n    		''adjustment''=> $adjustment / 100\n    	),"`id` = ''$queue_id''");\n    	$this->db->query($sql);\n    	\n    	return $amount->total + ($adjustment / 100);\n    }\n    \n    function Get_total_items($queue_id){\n    	$query = $this->db->query("SELECT * FROM `sale_items` WHERE `sale_id` = ?",$queue_id);\n    	return $que', '2012-11-07 18:20:23', 'admin', NULL);
INSERT INTO `editor_revisions` (`id`, `profile_id`, `item`, `contents`, `datetime`, `user`, `commit`) VALUES
(12, 1, '/var/www/_dev/os/application/controllers/iphone.php', '<?php\n\nclass Iphone extends Controller {\n	\n	// Constructor\n	function Iphone(){\n		parent::Controller();\n\n		// Load employee, system and order models\n		$this->load->model(''user'');\n		$this->load->model(''system'');\n		$this->load->model(''order'');\n		\n		$this->load->library(''user_agent'');\n		\n		if ($this->agent->is_mobile(''iphone'')){\n			$this->session->set_userdata(array(''device''=>''iphone''));\n		} else {\n			$this->session->set_userdata(array(''device''=>''terminal''));\n			redirect(''fnbpos'');\n		}\n		\n		if ($this->uri->segment(1) == ''iphone'' && $this->uri->segment(2) == ''terminal''){\n    		// do nothing	\n    			\n    	} else {\n    		$ip = $_SERVER[''REMOTE_ADDR''];\n    		$query = $this->db->query("SELECT * FROM `terminals` WHERE `ip` = ?", array($ip));\n\n    		if (!$query->num_rows()){\n\n    			if ($terminal_id = get_cookie(''PLEX_POS_TERM_ID'',true)){\n    				$query = $this->db->query("SELECT * FROM `terminals` WHERE `id` = ?", array($terminal_id));\n    				$terminal = $query->row();\n    				\n    				if (md5($terminal->key . get_cookie(''PLEX_POS_TERM_SESSION'',true)) != get_cookie(''PLEX_POS_TERM_HASH'',true)){\n    					show_error(''Access denied for terminal identifier <strong>'' . get_cookie(''PLEX_POS_TERM_IDENTIFIER'',true) . ''</strong>. Check if your terminal identifier and key is correct.'');\n    				}\n    				\n    			} else {\n    				show_error(''Access denied for IP Address <strong>'' . $_SERVER[''REMOTE_ADDR''] . ''</strong>. Check if your terminal is using Dynamic IP access.'');\n    			}\n    		}\n    	}\n\n	}\n	\n	function Terminal($identifier, $key){\n    	$query = $this->db->query("SELECT * FROM `terminals` WHERE `identifier` = ? AND `key` = ?", array($identifier, $key));\n\n    	if ($query->num_rows()){\n    		$terminal = $query->row();\n    		$term_session = time();\n    		$expire = 60*60*24*6004; \n\n    		\n    		set_cookie(''PLEX_POS_TERM_ID'',$terminal->id, $expire, $_SERVER[''HTTP_HOST''], ''/'');\n    		set_cookie(''PLEX_POS_TERM_NAME'', $terminal->name, $expire, $_SERVER[''HTTP_HOST''], ''/'');\n    		set_cookie(''PLEX_POS_TERM_IDENTIFIER'', $identifier, $expire, $_SERVER[''HTTP_HOST''], ''/'');\n    		set_cookie(''PLEX_POS_TERM_HASH'', md5($key . $term_session), $expire, $_SERVER[''HTTP_HOST''], ''/'');\n    		set_cookie(''PLEX_POS_TERM_SESSION'', $term_session, $expire, $_SERVER[''HTTP_HOST''], ''/'');\n    		\n    		\n    		redirect(''iphone'');\n    	} else {			\n    		show_error(''Access denied for terminal identifier <strong>'' . $identifier . ''</strong>. Check if your terminal identifier and key is correct.'');\n    	}\n    }\n	\n	// Index controller\n	function Index(){\n	\n		// Check employee login session. If not logged in, redirect to login page\n		if (!$this->user->check_session(''iphone'')) redirect(''iphone/login'');\n		\n		// Retrieve categories from inventory\n		$query = $this->db->query("SELECT `category` FROM `fnb_inventory` WHERE `iphone` = 1 GROUP BY `category`");\n		$cat = $query->result();\n		\n		// Loop for each category to store item and subcategory data\n		foreach ($cat as $category){\n			// Retrieve items by category\n			$query = $this->db->query("SELECT * FROM `fnb_inventory` WHERE `category` = ? AND `iphone` = 1 ORDER BY `order` ASC", array($category->category));\n			$items = $query->result();\n			\n			$subcategories = null;\n			\n			// Store items into category object\n			$category->items = $items;\n	\n			// Loop for each items to store in subcategory		\n			foreach ($items as $item){\n				$subcategories[$item->subcategory][] = $item;\n			}\n			\n			// Store subcategories into category object\n			$category->subcategories = $subcategories;\n			\n			// Store category into array\n			$categories[] = $category;\n		}\n		\n		// Store categories to interface variables\n		$this->d[''categories''] = $categories;\n		\n		$query = $this->db->query("SELECT * FROM `fnb_inventory` WHERE `iphone` = 1 GROUP BY `category` ORDER BY `category_order` ASC ");\n		$this->d[''cd''] = $query->result();\n		\n		// Load iphone ordering interface\n		$this->load->view(''fnb/iphone'',$this->d);\n	}\n	\n	function Login($err){\n	\n\n\n		// Check employee login session. If logged in redirect to pos interface\n		if ($this->user->check_session(''iphone'')) redirect(''iphone'');\n		\n		// If contains error, set error notice to interface variables\n		if ($err == ''err1'') $this->d[''notice''] = ''Incorrect username or password.'';\n		if ($err == ''err2'') $this->d[''notice''] = ''User is already logged in.'';\n		\n		// Load login interface\n		$this->load->view(''fnb/iphone-login'',$this->d);\n	}\n	\n	// Authentication controller\n	\n	function Auth(){\n		// Check employee login session. If logged in redirect to pos interface\n		if ($this->user->check_session(''iphone'')) redirect(''pos'');\n		\n		// Retrieve input username and password\n		$username = $this->input->post(''username'');\n		$password = $this->input->post(''password'');\n		\n		// Get employee object\n		$user = $this->user->get_user_by_username($username);\n		\n		// Check if employee is logged in. If logged in redirect to login interface with ''err2''\n		if ($user->ip_address != '''') redirect(''iphone/login/err2'');\n		\n		// Log in user. If succeed, redirect to pos interface. Otherwise redirect to login interface with ''err1''\n		if ($this->user->login(''iphone'', $username, $password)) redirect(''iphone'');\n		else redirect(''iphone/login/err1'');\n	}\n	\n	// AJAX Controller for iPhone\n	function Ajax($request){\n		switch ($request){\n			case "create_table":\n				$table_no = $this->input->post(''table_no'');\n				// Create table number\n				$this->order->create_table($table_no);\n				break;\n		\n			case "get_item_list":\n				// Call item list\n				$queue_id = $this->input->post(''queue'');\n				$this->order->get_item_list($queue_id);\n				\n				break;\n			\n			case "active_tables":\n				// Call active tables from order model\n				$this->order->active_tables();\n				\n				break;\n			case "check_table":\n				$table_no = $this->input->post(''table_no'');\n				\n				$this->order->check_table($table_no);\n				\n				break;\n			case "submit_order":\n				// Submit order from order model\n				$this->order->submit_order();\n				\n				break;\n		\n		}\n	\n	}\n	\n	function Logout(){\n		$this->user->logout();\n		redirect(''iphone'');\n	}\n\n}', '2012-11-07 18:20:25', 'admin', NULL),
(13, 1, '/var/www/_dev/os/application/libraries/index.html', '<html>\n<head>\n	<title>403 Forbidden</title>\n</head>\n<body>\n\n<p>Directory access is forbidden.</p>\n\n</body>\n</html>', '2012-11-07 18:24:42', 'admin', NULL),
(14, 1, '/var/www/_dev/os/application/config/index.html', '<html>\n<head>\n	<title>403 Forbidden</title>\n</head>\n<body>\n\n<p>Directory access is forbidden.</p>\n\n</body>\n</html>', '2012-11-07 18:24:52', 'admin', NULL),
(15, 1, '/var/www/_dev/os/application/config/database.php', '<?php  if ( ! defined(''BASEPATH'')) exit(''No direct script access allowed'');\n/*\n| -------------------------------------------------------------------\n| DATABASE CONNECTIVITY SETTINGS\n| -------------------------------------------------------------------\n| This file will contain the settings needed to access your database.\n|\n| For complete instructions please consult the "Database Connection"\n| page of the User Guide.\n|\n| -------------------------------------------------------------------\n| EXPLANATION OF VARIABLES\n| -------------------------------------------------------------------\n|\n|	[''hostname''] The hostname of your database server.\n|	[''username''] The username used to connect to the database\n|	[''password''] The password used to connect to the database\n|	[''database''] The name of the database you want to connect to\n|	[''dbdriver''] The database type. ie: mysql.  Currently supported:\n				 mysql, mysqli, postgre, odbc, mssql, sqlite, oci8\n|	[''dbprefix''] You can add an optional prefix, which will be added\n|				 to the table name when using the  Active Record class\n|	[''pconnect''] TRUE/FALSE - Whether to use a persistent connection\n|	[''db_debug''] TRUE/FALSE - Whether database errors should be displayed.\n|	[''cache_on''] TRUE/FALSE - Enables/disables query caching\n|	[''cachedir''] The path to the folder where cache files should be stored\n|	[''char_set''] The character set used in communicating with the database\n|	[''dbcollat''] The character collation used in communicating with the database\n|\n| The $active_group variable lets you choose which connection group to\n| make active.  By default there is only one group (the "default" group).\n|\n| The $active_record variables lets you determine whether or not to load\n| the active record class\n*/\n\n$active_group = "default";\n$active_record = TRUE;\n\n$db[''default''][''hostname''] = "localhost";\n$db[''default''][''username''] = "root";\n$db[''default''][''password''] = "PlexSol!@#";\n$db[''default''][''database''] = "plexcloud";\n$db[''default''][''dbdriver''] = "mysql";\n$db[''default''][''dbprefix''] = "";\n$db[''default''][''pconnect''] = TRUE;\n$db[''default''][''db_debug''] = TRUE;\n$db[''default''][''cache_on''] = FALSE;\n$db[''default''][''cachedir''] = "";\n$db[''default''][''char_set''] = "utf8";\n$db[''default''][''dbcollat''] = "utf8_general_ci";\n\n\n/* End of file database.php */\n/* Location: ./system/application/config/database.php */', '2012-11-07 18:24:53', 'admin', NULL),
(16, 1, '/var/www/_dev/os/application/config/doctypes.php', '<?php if ( ! defined(''BASEPATH'')) exit(''No direct script access allowed'');\n\n$_doctypes = array(\n					''xhtml11''		=> ''<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">'',\n					''xhtml1-strict''	=> ''<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'',\n					''xhtml1-trans''	=> ''<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'',\n					''xhtml1-frame''	=> ''<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd">'',\n					''html5''			=> ''<!DOCTYPE html>'',\n					''html4-strict''	=> ''<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">'',\n					''html4-trans''	=> ''<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">'',\n					''html4-frame''	=> ''<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN" "http://www.w3.org/TR/html4/frameset.dtd">''\n					);\n\n/* End of file doctypes.php */\n/* Location: application/config/doctypes.php */', '2012-11-07 18:25:11', 'admin', NULL),
(17, 1, '/var/www/_dev/os/application/config/hooks.php', '<?php  if ( ! defined(''BASEPATH'')) exit(''No direct script access allowed'');\n/*\n| -------------------------------------------------------------------------\n| Hooks\n| -------------------------------------------------------------------------\n| This file lets you define "hooks" to extend CI without hacking the core\n| files.  Please see the user guide for info:\n|\n|	http://codeigniter.com/user_guide/general/hooks.html\n|\n*/\n\n\n\n/* End of file hooks.php */\n/* Location: ./system/application/config/hooks.php */', '2012-11-07 18:25:12', 'admin', NULL),
(18, 1, '/var/www/_dev/os/application/config/user_agents.php', '<?php  if ( ! defined(''BASEPATH'')) exit(''No direct script access allowed'');\n/*\n| -------------------------------------------------------------------\n| USER AGENT TYPES\n| -------------------------------------------------------------------\n| This file contains four arrays of user agent data.  It is used by the\n| User Agent Class to help identify browser, platform, robot, and\n| mobile device data.  The array keys are used to identify the device\n| and the array values are used to set the actual name of the item.\n|\n*/\n\n$platforms = array (\n					''windows nt 6.0''	=> ''Windows Longhorn'',\n					''windows nt 5.2''	=> ''Windows 2003'',\n					''windows nt 5.0''	=> ''Windows 2000'',\n					''windows nt 5.1''	=> ''Windows XP'',\n					''windows nt 4.0''	=> ''Windows NT 4.0'',\n					''winnt4.0''			=> ''Windows NT 4.0'',\n					''winnt 4.0''			=> ''Windows NT'',\n					''winnt''				=> ''Windows NT'',\n					''windows 98''		=> ''Windows 98'',\n					''win98''				=> ''Windows 98'',\n					''windows 95''		=> ''Windows 95'',\n					''win95''				=> ''Windows 95'',\n					''windows''			=> ''Unknown Windows OS'',\n					''os x''				=> ''Mac OS X'',\n					''ppc mac''			=> ''Power PC Mac'',\n					''freebsd''			=> ''FreeBSD'',\n					''ppc''				=> ''Macintosh'',\n					''linux''				=> ''Linux'',\n					''debian''			=> ''Debian'',\n					''sunos''				=> ''Sun Solaris'',\n					''beos''				=> ''BeOS'',\n					''apachebench''		=> ''ApacheBench'',\n					''aix''				=> ''AIX'',\n					''irix''				=> ''Irix'',\n					''osf''				=> ''DEC OSF'',\n					''hp-ux''				=> ''HP-UX'',\n					''netbsd''			=> ''NetBSD'',\n					''bsdi''				=> ''BSDi'',\n					''openbsd''			=> ''OpenBSD'',\n					''gnu''				=> ''GNU/Linux'',\n					''unix''				=> ''Unknown Unix OS''\n				);\n\n\n// The order of this array should NOT be changed. Many browsers return\n// multiple browser types so we want to identify the sub-type first.\n$browsers = array(\n					''Opera''				=> ''Opera'',\n					''MSIE''				=> ''Internet Explorer'',\n					''Internet Explorer''	=> ''Internet Explorer'',\n					''Shiira''			=> ''Shiira'',\n					''Firefox''			=> ''Firefox'',\n					''Chimera''			=> ''Chimera'',\n					''Phoenix''			=> ''Phoenix'',\n					''Firebird''			=> ''Firebird'',\n					''Camino''			=> ''Camino'',\n					''Netscape''			=> ''Netscape'',\n					''OmniWeb''			=> ''OmniWeb'',\n					''Safari''			=> ''Safari'',\n					''Mozilla''			=> ''Mozilla'',\n					''Konqueror''			=> ''Konqueror'',\n					''icab''				=> ''iCab'',\n					''Lynx''				=> ''Lynx'',\n					''Links''				=> ''Links'',\n					''hotjava''			=> ''HotJava'',\n					''amaya''				=> ''Amaya'',\n					''IBrowse''			=> ''IBrowse''\n				);\n\n$mobiles = array(\n					// legacy array, old values commented out\n					''mobileexplorer''	=> ''Mobile Explorer'',\n//					''openwave''			=> ''Open Wave'',\n//					''opera mini''		=> ''Opera Mini'',\n//					''operamini''			=> ''Opera Mini'',\n//					''elaine''			=> ''Palm'',\n					''palmsource''		=> ''Palm'',\n//					''digital paths''		=> ''Palm'',\n//					''avantgo''			=> ''Avantgo'',\n//					''xiino''				=> ''Xiino'',\n					''palmscape''			=> ''Palmscape'',\n//					''nokia''				=> ''Nokia'',\n//					''ericsson''			=> ''Ericsson'',\n//					''blackberry''		=> ''BlackBerry'',\n//					''motorola''			=> ''Motorola''\n\n					// Phones and Manufacturers\n					''motorola''			=> "Motorola",\n					''nokia''				=> "Nokia",\n					''palm''				=> "Palm",\n					''iphone''			=> "Apple iPhone",\n					''ipod''				=> "Apple iPod Touch",\n					''sony''				=> "Sony Ericsson",\n					''ericsson''			=> "Sony Ericsson",\n					''blackberry''		=> "BlackBerry",\n					''cocoon''			=> "O2 Cocoon",\n					''blazer''			=> "Treo",\n					''lg''				=> "LG",\n					''amoi''				=> "Amoi",\n					''xda''				=> "XDA",\n					''mda''				=> "MDA",\n					''vario''				=> "Vario",\n					''htc''				=> "HTC",\n					''samsung''			=> "Samsung",\n					''sharp''				=> "Sharp",\n					''sie-''				=> "Siemens",\n					''alcatel''			=> "Alcatel",\n					''benq''				=> "BenQ",\n					''ipaq''				=> "HP iPaq",\n					''mot-''				=> "Motorola",\n					''playstation portable'' 	=> "PlayStation Portable",\n					''hiptop''			=> "Danger Hiptop",\n					''nec-''				=> "NEC",\n					''panasonic''			=> "Panasonic",\n					''philips''			=> "Philips",\n					''sagem''				=> "Sagem",\n					''sanyo''				=> "Sanyo",\n					''spv''				=> "SPV",\n					''zte''				=> "ZTE",\n					''sendo''				=> "Sendo",\n\n					// Operating Systems\n					''symbian''				=> "Symbian",\n					''SymbianOS''				=> "SymbianOS", \n					''elaine''				=> "Palm",\n					''palm''					=> "Palm",\n					''series60''				=> "Symbian S60",\n					''windows ce''			=> "Windows CE",\n\n					// Browsers\n					''obigo''					=> "Obigo",\n					''netfront''				=> "Netfront Browser",\n					''openwave''				=> "Openwave Browser",\n					''mobilexplorer''			=> "Mobile Explorer",\n					''operamini''				=> "Opera Mini",\n					''opera mini''			=> "Opera Mini",\n\n					// Other\n					''digital paths''			=> "Digital Paths",\n					''avantgo''				=> "AvantGo",\n					''xiino''					=> "Xiino",\n					''novarra''				=> "Novarra Transcoder",\n					''vodafone''				=> "Vodafone",\n					''docomo''				=> "NTT DoCoMo",\n					''o2''					=> "O2",\n\n					// Fallback\n					''mobile''				=> "Generic Mobile",\n					''wireless'' 				=> "Generic Mobile",\n					''j2me''					=> "Generic Mobile",\n					''midp''					=> "Generic Mobile",\n					''cldc''					=> "Generic Mobile",\n					''up.link''				=> "Generic Mobile",\n					''up.browser''			=> "Generic Mobile",\n					''smartphone''			=> "Generic Mobile",\n					''cellphone''				=> "Generic Mobile"\n				);\n\n// There are hundreds of bots but these are the most common.\n$robots = array(\n					''googlebot''			=> ''Googlebot'',\n					''msnbot''			=> ''MSNBot'',\n					''slurp''				=> ''Inktomi Slurp'',\n					''yahoo''				=> ''Yahoo'',\n					''askjeeves''			=> ''AskJeeves'',\n					''fastcrawler''		=> ''FastCrawler'',\n					''infoseek''			=> ''InfoSeek Robot 1.0'',\n					''lycos''				=> ''Lycos''\n				);\n\n/* End of file user_agents.php */\n/* Location: ./system/application/config/user_agents.php */', '2012-11-07 18:25:13', 'admin', NULL);
INSERT INTO `editor_revisions` (`id`, `profile_id`, `item`, `contents`, `datetime`, `user`, `commit`) VALUES
(19, 1, '/var/www/_dev/manager/js/jquery.jqplot.min.js', '/**\n * jqPlot\n * Pure JavaScript plotting plugin using jQuery\n *\n * Version: 1.0.0b2_r792\n *\n * Copyright (c) 2009-2011 Chris Leonello\n * jqPlot is currently available for use in all personal or commercial projects \n * under both the MIT (http://www.opensource.org/licenses/mit-license.php) and GPL \n * version 2.0 (http://www.gnu.org/licenses/gpl-2.0.html) licenses. This means that you can \n * choose the license that best suits your project and use it accordingly. \n *\n * Although not required, the author would appreciate an email letting him \n * know of any substantial use of jqPlot.  You can reach the author at: \n * chris at jqplot dot com or see http://www.jqplot.com/info.php .\n *\n * If you are feeling kind and generous, consider supporting the project by\n * making a donation at: http://www.jqplot.com/donate.php .\n *\n * sprintf functions contained in jqplot.sprintf.js by Ash Searle:\n *\n *     version 2007.04.27\n *     author Ash Searle\n *     http://hexmen.com/blog/2007/03/printf-sprintf/\n *     http://hexmen.com/js/sprintf.js\n *     The author (Ash Searle) has placed this code in the public domain:\n *     "This code is unrestricted: you are free to use it however you like."\n * \n */\n(function(w){var l;w.fn.emptyForce=function(){for(var O=0,P;(P=w(this)[O])!=null;O++){if(P.nodeType===1){jQuery.cleanData(P.getElementsByTagName("*"))}if(w.jqplot_use_excanvas){P.outerHTML=""}else{while(P.firstChild){P.removeChild(P.firstChild)}}P=null}return w(this)};w.fn.removeChildForce=function(O){while(O.firstChild){this.removeChildForce(O.firstChild);O.removeChild(O.firstChild)}};w.jqplot=function(U,R,P){var Q,O;if(P==null){if(jQuery.isArray(R)){Q=R;O=null}else{if(typeof(R)==="object"){Q=null;O=R}}}else{Q=R;O=P}var T=new C();w("#"+U).removeClass("jqplot-error");if(w.jqplot.config.catchErrors){try{T.init(U,Q,O);T.draw();T.themeEngine.init.call(T);return T}catch(S){var V=w.jqplot.config.errorMessage||S.message;w("#"+U).append(''<div class="jqplot-error-message">''+V+"</div>");w("#"+U).addClass("jqplot-error");document.getElementById(U).style.background=w.jqplot.config.errorBackground;document.getElementById(U).style.border=w.jqplot.config.errorBorder;document.getElementById(U).style.fontFamily=w.jqplot.config.errorFontFamily;document.getElementById(U).style.fontSize=w.jqplot.config.errorFontSize;document.getElementById(U).style.fontStyle=w.jqplot.config.errorFontStyle;document.getElementById(U).style.fontWeight=w.jqplot.config.errorFontWeight}}else{T.init(U,Q,O);T.draw();T.themeEngine.init.call(T);return T}};w.jqplot.version="1.0.0b2_r792";w.jqplot.CanvasManager=function(){if(typeof w.jqplot.CanvasManager.canvases=="undefined"){w.jqplot.CanvasManager.canvases=[];w.jqplot.CanvasManager.free=[]}var O=[];this.getCanvas=function(){var R;var Q=true;if(!w.jqplot.use_excanvas){for(var S=0,P=w.jqplot.CanvasManager.canvases.length;S<P;S++){if(w.jqplot.CanvasManager.free[S]===true){Q=false;R=w.jqplot.CanvasManager.canvases[S];w.jqplot.CanvasManager.free[S]=false;O.push(S);break}}}if(Q){R=document.createElement("canvas");O.push(w.jqplot.CanvasManager.canvases.length);w.jqplot.CanvasManager.canvases.push(R);w.jqplot.CanvasManager.free.push(false)}return R};this.initCanvas=function(P){if(w.jqplot.use_excanvas){return window.G_vmlCanvasManager.initElement(P)}return P};this.freeAllCanvases=function(){for(var Q=0,P=O.length;Q<P;Q++){this.freeCanvas(O[Q])}O=[]};this.freeCanvas=function(P){if(w.jqplot.use_excanvas){window.G_vmlCanvasManager.uninitElement(w.jqplot.CanvasManager.canvases[P]);w.jqplot.CanvasManager.canvases[P]=null}else{var Q=w.jqplot.CanvasManager.canvases[P];Q.getContext("2d").clearRect(0,0,Q.width,Q.height);w(Q).unbind().removeAttr("class").removeAttr("style");w(Q).css({left:"",top:"",position:""});Q.width=0;Q.height=0;w.jqplot.CanvasManager.free[P]=true}}};w.jqplot.log=function(){if(window.console){console.log.apply(console,arguments)}};w.jqplot.config={enablePlugins:false,defaultHeight:300,defaultWidth:400,UTCAdjust:false,timezoneOffset:new Date(new Date().getTimezoneOffset()*60000),errorMessage:"",errorBackground:"",errorBorder:"",errorFontFamily:"",errorFontSize:"",errorFontStyle:"",errorFontWeight:"",catchErrors:false,defaultTickFormatString:"%.1f",defaultColors:["#4bb2c5","#EAA228","#c5b47f","#579575","#839557","#958c12","#953579","#4b5de4","#d8b83f","#ff5800","#0085cc","#c747a3","#cddf54","#FBD178","#26B4E3","#bd70c7"],defaultNegativeColors:["#498991","#C08840","#9F9274","#546D61","#646C4A","#6F6621","#6E3F5F","#4F64B0","#A89050","#C45923","#187399","#945381","#959E5C","#C7AF7B","#478396","#907294"]};w.jqplot.arrayMax=function(O){return Math.max.apply(Math,O)};w.jqplot.arrayMin=function(O){return Math.min.apply(Math,O)};w.jqplot.enablePlugins=w.jqplot.config.enablePlugins;w.jqplot.support_canvas=function(){if(typeof w.jqplot.support_canvas.result=="undefined"){w.jqplot.support_canvas.result=!!document.createElement("canvas").getContext}return w.jqplot.support_canvas.result};w.jqplot.support_canvas_text=function(){if(typeof w.jqplot.support_canvas_text.result=="undefined"){w.jqplot.support_canvas_text.result=!!(document.createElement("canvas").getContext&&typeof document.createElement("canvas").getContext("2d").fillText=="function")}return w.jqplot.support_canvas_text.result};w.jqplot.use_excanvas=(w.browser.msie&&!w.jqplot.support_canvas())?true:false;w.jqplot.preInitHooks=[];w.jqplot.postInitHooks=[];w.jqplot.preParseOptionsHooks=[];w.jqplot.postParseOptionsHooks=[];w.jqplot.preDrawHooks=[];w.jqplot.postDrawHooks=[];w.jqplot.preDrawSeriesHooks=[];w.jqplot.postDrawSeriesHooks=[];w.jqplot.preDrawLegendHooks=[];w.jqplot.addLegendRowHooks=[];w.jqplot.preSeriesInitHooks=[];w.jqplot.postSeriesInitHooks=[];w.jqplot.preParseSeriesOptionsHooks=[];w.jqplot.postParseSeriesOptionsHooks=[];w.jqplot.eventListenerHooks=[];w.jqplot.preDrawSeriesShadowHooks=[];w.jqplot.postDrawSeriesShadowHooks=[];w.jqplot.ElemContainer=function(){this._elem;this._plotWidth;this._plotHeight;this._plotDimensions={height:null,width:null}};w.jqplot.ElemContainer.prototype.createElement=function(R,T,P,Q,U){this._offsets=T;var O=P||"jqplot";var S=document.createElement(R);this._elem=w(S);this._elem.addClass(O);this._elem.css(Q);this._elem.attr(U);S=null;return this._elem};w.jqplot.ElemContainer.prototype.getWidth=function(){if(this._elem){return this._elem.outerWidth(true)}else{return null}};w.jqplot.ElemContainer.prototype.getHeight=function(){if(this._elem){return this._elem.outerHeight(true)}else{return null}};w.jqplot.ElemContainer.prototype.getPosition=function(){if(this._elem){return this._elem.position()}else{return{top:null,left:null,bottom:null,right:null}}};w.jqplot.ElemContainer.prototype.getTop=function(){return this.getPosition().top};w.jqplot.ElemContainer.prototype.getLeft=function(){return this.getPosition().left};w.jqplot.ElemContainer.prototype.getBottom=function(){return this._elem.css("bottom")};w.jqplot.ElemContainer.prototype.getRight=function(){return this._elem.css("right")};function m(O){w.jqplot.ElemContainer.call(this);this.name=O;this._series=[];this.show=false;this.tickRenderer=w.jqplot.AxisTickRenderer;this.tickOptions={};this.labelRenderer=w.jqplot.AxisLabelRenderer;this.labelOptions={};this.label=null;this.showLabel=true;this.min=null;this.max=null;this.autoscale=false;this.pad=1.2;this.padMax=null;this.padMin=null;this.ticks=[];this.numberTicks;this.tickInterval;this.renderer=w.jqplot.LinearAxisRenderer;this.rendererOptions={};this.showTicks=true;this.showTickMarks=true;this.showMinorTicks=true;this.useSeriesColor=false;this.borderWidth=null;this.borderColor=null;this._dataBounds={min:null,max:null};this._intervalStats=[];this._offsets={min:null,max:null};this._ticks=[];this._label=null;this.syncTicks=null;this.tickSpacing=75;this._min=null;this._max=null;this._tickInterval=null;this._numberTicks=null;this.__ticks=null;this._options={}}m.prototype=new w.jqplot.ElemContainer();m.prototype.constructor=m;m.prototype.init=function(){this.renderer=new this.renderer();this.tickOptions.axis=this.name;if(this.tickOptions.showMark==null){this.tickOptions.showMark=this.showTicks}if(this.tickOptions.showMark==null){this.tickOptions.showMark=this.showTickMarks}if(this.tickOptions.showLabel==null){this.tickOptions.showLabel=this.showTicks}if(this.label==null||this.label==""){this.showLabel=false}else{this.labelOptions.label=this.label}if(this.showLabel==false){this.labelOptions.show=false}if(this.pad==0){this.pad=1}if(this.padMax==0){this.padMax=1}if(this.padMin==0){this.padMin=1}if(this.padMax==null){this.padMax=(this.pad-1)/2+1}if(this.padMin==null){this.padMin=(this.pad-1)/2+1}this.pad=this.padMax+this.padMin-1;if(this.min!=null||this.max!=null){this.autoscale=false}if(this.syncTicks==null&&this.name.indexOf("y")>-1){this.syncTicks=true}else{if(this.syncTicks==null){this.syncTicks=false}}this.renderer.init.call(this,this.rendererOptions)};m.prototype.draw=function(O,P){if(this.__ticks){this.__ticks=null}return this.renderer.draw.call(this,O,P)};m.prototype.set=function(){this.renderer.set.call(this)};m.prototype.pack=function(P,O){if(this.show){this.renderer.pack.call(this,P,O)}if(this._min==null){this._min=this.min;this._max=this.max;this._tickInterval=this.tickInterval;this._numberTicks=this.numberTicks;this.__ticks=this._ticks}};m.prototype.reset=function(){this.renderer.reset.call(this)};m.prototype.resetScale=function(O){w.extend(true,this,{min:null,max:null,numberTicks:null,tickInterval:null,_ticks:[],ticks:[]},O);this.resetDataBounds()};m.prototype.resetDataBounds=function(){var O=this._dataBounds;O.min=null;O.max=null;var R=(this.show)?true:false;for(var Q=0;Q<this._series.length;Q++){var S=this._series[Q];var V=S._plotData;var T=1,U=1;if(S._type!=null&&S._type=="ohlc"){T=3;U=2}for(var P=0;P<V.length;P++){if(this.name=="xaxis"||this.name=="x2axis"){if((V[P][0]!=null&&V[P][0]<O.min)||O.min==null){O.min=V[P][0]}if((V[P][0]!=null&&V[P][0]>O.max)||O.max==null){O.max=V[P][0]}}else{if((V[P][T]!=null&&V[P][T]<O.min)||O.min==null){O.min=V[P][T]}if((V[P][U]!=null&&V[P][U]>O.max)||O.max==null){O.max=V[P][U]}}}if(R&&S.renderer.constructor!==w.jqplot.BarRenderer){R=false}else{if(R&&this._options.hasOwnProperty("forceTickAt0")&&this._options.forceTickAt0==false){R=false}else{if(R&&S.renderer.constructor===w.jqplot.BarRenderer){if(S.barDirection=="vertical"&&this.name!="xaxis"&&this.name!="x2axis"){if(this._options.pad!=null||this._options.padMin!=null){R=false}}else{if(S.barDirection=="horizontal"&&(this.name=="xaxis"||this.name=="x2axis")){if(this._options.pad!=null||this._options.padMin!=null){R=false}}}}}}}if(R&&this.renderer.constructor===w.jqplot.LinearAxisRenderer&&O.min>=0){this.padMin=1;this.forceTickAt0=true}};function h(O){w.jqplot.ElemContainer.call(this);this.show=false;this.location="ne";this.labels=[];this.showLabels=true;this.showSwatches=true;this.placement="insideGrid";this.xoffset=0;this.yoffset=0;this.border;this.background;this.textColor;this.fontFamily;this.fontSize;this.rowSpacing="0.5em";this.renderer=w.jqplot.TableLegendRenderer;this.rendererOptions={};this.preDraw=false;this.marginTop=null;this.marginRight=null;this.marginBottom=null;this.marginLeft=null;this.escapeHtml=false;this._series=[];w.extend(true,this,O)}h.prototype=new w.jqplot.ElemContainer();h.prototype.constructor=h;h.prototype.setOptions=function(O){w.extend(true,this,O);if(this.placement=="inside"){this.placement="insideGrid"}if(this.xoffset>0){if(this.placement=="insideGrid"){switch(this.location){case"nw":case"w":case"sw":if(this.marginLeft==null){this.marginLeft=this.xoffset+"px"}this.marginRight="0px";break;case"ne":case"e":case"se":default:if(this.marginRight==null){this.marginRight=this.xoffset+"px"}this.marginLeft="0px";break}}else{if(this.placement=="outside"){switch(this.location){case"nw":case"w":case"sw":if(this.marginRight==null){this.marginRight=this.xoffset+"px"}this.marginLeft="0px";break;case"ne":case"e":case"se":default:if(this.marginLeft==null){this.marginLeft=this.xoffset+"px"}this.marginRight="0px";break}}}this.xoffset=0}if(this.yoffset>0){if(this.placement=="outside"){switch(this.location){case"sw":case"s":case"se":if(this.marginTop==null){this.marginTop=this.yoffset+"px"}this.marginBottom="0px";break;case"ne":case"n":case"nw":default:if(this.marginBottom==null){this.marginBottom=this.yoffset+"px"}this.marginTop="0px";break}}else{if(this.placement=="insideGrid"){switch(this.location){case"sw":case"s":case"se":if(this.marginBottom==null){this.marginBottom=this.yoffset+"px"}this.marginTop="0px";break;case"ne":case"n":case"nw":default:if(this.marginTop==null){this.marginTop=this.yoffset+"px"}this.marginBottom="0px";break}}}this.yoffset=0}};h.prototype.init=function(){this.renderer=new this.renderer();this.renderer.init.call(this,this.rendererOptions)};h.prototype.draw=function(P){for(var O=0;O<w.jqplot.preDrawLegendHooks.length;O++){w.jqplot.preDrawLegendHooks[O].call(this,P)}return this.renderer.draw.call(this,P)};h.prototype.pack=function(O){this.renderer.pack.call(this,O)};function n(O){w.jqplot.ElemContainer.call(this);this.text=O;this.show=true;this.fontFamily;this.fontSize;this.textAlign;this.textColor;this.renderer=w.jqplot.DivTitleRenderer;this.rendererOptions={}}n.prototype=new w.jqplot.ElemContainer();n.prototype.constructor=n;n.prototype.init=function(){this.renderer=new this.renderer();this.renderer.init.call(this,this.rendererOptions)};n.prototype.draw=function(O){return this.renderer.draw.call(this,O)};n.prototype.pack=function(){this.renderer.pack.call(this)};function D(){w.jqplot.ElemContainer.call(this);this.show=true;this.xaxis="xaxis";this._xaxis;this.yaxis="yaxis";this._yaxis;this.gridBorderWidth=2;this.renderer=w.jqplot.LineRenderer;this.rendererOptions={};this.data=[];this.gridData=[];this.label="";this.showLabel=true;this.color;this.lineWidth=2.5;this.lineJoin="round";this.lineCap="round";this.shadow=true;this.shadowAngle=45;this.shadowOffset=1.25;this.shadowDepth=3;this.shadowAlpha="0.1";this.breakOnNull=false;this.markerRenderer=w.jqplot.MarkerRenderer;this.markerOptions={};this.showLine=true;this.showMarker=true;this.index;this.fill=false;this.fillColor;this.fillAlpha;this.fillAndStroke=false;this.disableStack=false;this._stack=false;this.neighborThreshold=4;this.fillToZero=false;this.fillToValue=0;this.fillAxis="y";this.useNegativeColors=true;this._stackData=[];this._plotData=[];this._plotValues={x:[],y:[]};this._intervals={x:{},y:{}};this._prevPlotData=[];this._prevGridData=[];this._stackAxis="y";this._primaryAxis="_xaxis";this.canvas=new w.jqplot.GenericCanvas();this.shadowCanvas=new w.jqplot.GenericCanvas();this.plugins={};this._sumy=0;this._sumx=0;this._type=""}D.prototype=new w.jqplot.ElemContainer();D.prototype.constructor=D;D.prototype.init=function(Q,U,S){this.index=Q;this.gridBorderWidth=U;var T=this.data;var P=[],R;for(R=0;R<T.length;R++){if(!this.breakOnNull){if(T[R]==null||T[R][0]==null||T[R][1]==null){continue}else{P.push(T[R])}}else{P.push(T[R])}}this.data=P;if(!this.fillColor){this.fillColor=this.color}if(this.fillAlpha){var O=w.jqplot.normalize2rgb(this.fillColor);var O=w.jqplot.getColorComponents(O);this.fillColor="rgba("+O[0]+","+O[1]+","+O[2]+","+this.fillAlpha+")"}this.renderer=new this.renderer();this.renderer.init.call(this,this.rendererOptions,S);this.markerRenderer=new this.markerRenderer();if(!this.markerOptions.color){this.markerOptions.color=this.color}if(this.markerOptions.show==null){this.markerOptions.show=this.showMarker}this.showMarker=this.markerOptions.show;this.markerRenderer.init(this.markerOptions)};D.prototype.draw=function(U,R,T){var P=(R==l)?{}:R;U=(U==l)?this.canvas._ctx:U;var O,S,Q;for(O=0;O<w.jqplot.preDrawSeriesHooks.length;O++){w.jqplot.preDrawSeriesHooks[O].call(this,U,P)}if(this.show){this.renderer.setGridData.call(this,T);if(!P.preventJqPlotSeriesDrawTrigger){w(U.canvas).trigger("jqplotSeriesDraw",[this.data,this.gridData])}S=[];if(P.data){S=P.data}else{if(!this._stack){S=this.data}else{S=this._plotData}}Q=P.gridData||this.renderer.makeGridData.call(this,S,T);this.renderer.draw.call(this,U,Q,P,T)}for(O=0;O<w.jqplot.postDrawSeriesHooks.length;O++){w.jqplot.postDrawSeriesHooks[O].call(this,U,P)}U=R=T=O=S=Q=null};D.prototype.drawShadow=function(U,R,T){var P=(R==l)?{}:R;U=(U==l)?this.shadowCanvas._ctx:U;var O,S,Q;for(O=0;O<w.jqplot.preDrawSeriesShadowHooks.length;O++){w.jqplot.preDrawSeriesShadowHooks[O].call(this,U,P)}if(this.shadow){this.renderer.setGridData.call(this,T);S=[];if(P.data){S=P.data}else{if(!this._stack){S=this.data}else{S=this._plotData}}Q=P.gridData||this.renderer.makeGridData.call(this,S,T);this.renderer.drawShadow.call(this,U,Q,P)}for(O=0;O<w.jqplot.postDrawSeriesShadowHooks.length;O++){w.jqplot.postDrawSeriesShadowHooks[O].call(this,U,P)}U=R=T=O=S=Q=null};D.prototype.toggleDisplay=function(P){var O,Q;if(P.data.series){O=P.data.series}else{O=this}if(P.data.speed){Q=P.data.speed}if(Q){if(O.canvas._elem.is(":hidden")){if(O.shadowCanvas._elem){O.shadowCanvas._elem.fadeIn(Q)}O.canvas._elem.fadeIn(Q);O.canvas._elem.nextAll(".jqplot-point-label.jqplot-series-"+O.index).fadeIn(Q)}else{if(O.shadowCanvas._elem){O.shadowCanvas._elem.fadeOut(Q)}O.canvas._elem.fadeOut(Q);O.canvas._elem.nextAll(".jqplot-point-label.jqplot-series-"+O.index).fadeOut(Q)}}else{if(O.canvas._elem.is(":hidden")){if(O.shadowCanvas._elem){O.shadowCanvas._elem.show()}O.canvas._elem.show();O.canvas._elem.nextAll(".jqplot-point-label.jqplot-series-"+O.index).show()}else{if(O.shadowCanvas._elem){O.shadowCanvas._elem.hide()}O.canvas._elem.hide();O.canvas._elem.nextAll(".jqplot-point-label.jqplot-series-"+O.index).hide()}}};function x(){w.jqplot.ElemContainer.call(this);this.drawGridlines=true;this.gridLineColor="#cccccc";this.gridLineWidth=1;this.background="#fffdf6";this.borderColor="#999999";this.borderWidth=2;this.drawBorder=true;this.shadow=true;this.shadowAngle=45;this.shadowOffset=1.5;this.shadowWidth=3;this.shadowDepth=3;this.shadowColor=null;this.shadowAlpha="0.07";this._left;this._top;this._right;this._bottom;this._width;this._height;this._axes=[];this.renderer=w.jqplot.CanvasGridRenderer;this.rendererOptions={};this._offsets={top:null,bottom:null,left:null,right:null}}x.prototype=new w.jqplot.ElemContainer();x.prototype.constructor=x;x.prototype.init=function(){this.renderer=new this.renderer();this.renderer.init.call(this,this.rendererOptions)};x.prototype.createElement=function(O,P){this._offsets=O;return this.renderer.createElement.call(this,P)};x.prototype.draw=function(){this.renderer.draw.call(this)};w.jqplot.GenericCanvas=function(){w.jqplot.ElemContainer.call(this);this._ctx};w.jqplot.GenericCanvas.prototype=new w.jqplot.ElemContainer();w.jqplot.GenericCanvas.prototype.constructor=w.jqplot.GenericCanvas;w.jqplot.GenericCanvas.prototype.createElement=function(S,Q,P,T){this._offsets=S;var O="jqplot";if(Q!=l){O=Q}var R;R=T.canvasManager.getCanvas();if(P!=null){this._plotDimensions=P}R.width=this._plotDimensions.width-this._offsets.left-this._offsets.right;R.height=this._plotDimensions.height-this._offsets.top-this._offsets.bottom;this._elem=w(R);this._elem.css({position:"absolute",left:this._offsets.left,top:this._offsets.top});this._elem.addClass(O);R=T.canvasManager.initCanvas(R);R=null;return this._elem};w.jqplot.GenericCanvas.prototype.setContext=function(){this._ctx=this._elem.get(0).getContext("2d");return this._ctx};w.jqplot.GenericCanvas.prototype.resetCanvas=function(){if(this._elem){if(w.jqplot.use_excanvas){window.G_vmlCanvasManager.uninitElement(this._elem.get(0))}this._elem.emptyForce()}this._ctx=null};w.jqplot.HooksManager=function(){this.hooks=[]};w.jqplot.HooksManager.prototype.addOnce=function(P){var Q=false,O;for(O=0;O<this.hooks.length;O++){if(this.hooks[O][0]==P){Q=true}}if(!Q){this.hooks.push(P)}};w.jqplot.HooksManager.prototype.add=function(O){this.hooks.push(O)};w.jqplot.EventListenerManager=function(){this.hooks=[]};w.jqplot.EventListenerManager.prototype.addOnce=function(R,Q){var S=false,P,O;for(O=0;O<this.hooks.length;O++){P=this.hooks[O];if(P[0]==R&&P[1]==Q){S=true}}if(!S){this.hooks.push([R,Q])}};w.jqplot.EventListenerManager.prototype.add=function(P,O){this.hooks.push([P,O])};function C(){this.data=[];this.dataRenderer;this.dataRendererOptions;this.noDataIndicator={show:false,indicator:"Loading Data...",axes:{xaxis:{min:0,max:10,tickInterval:2,show:true},yaxis:{min:0,max:12,tickInterval:3,show:true}}};this.targetId=null;this.target=null;this.defaults={axesDefaults:{},axes:{xaxis:{},yaxis:{},x2axis:{},y2axis:{},y3axis:{},y4axis:{},y5axis:{},y6axis:{},y7axis:{},y8axis:{},y9axis:{}},seriesDefaults:{},series:[]};this.series=[];this.axes={xaxis:new m("xaxis"),yaxis:new m("yaxis"),x2axis:new m("x2axis"),y2axis:new m("y2axis"),y3axis:new m("y3axis"),y4axis:new m("y4axis"),y5axis:new m("y5axis"),y6axis:new m("y6axis"),y7axis:new m("y7axis"),y8axis:new m("y8axis"),y9axis:new m("y9axis")};this.grid=new x();this.legend=new h();this.baseCanvas=new w.jqplot.GenericCanvas();this.seriesStack=[];this.previousSeriesStack=[];this.eventCanvas=new w.jqplot.GenericCanvas();this._width=null;this._height=null;this._plotDimensions={height:null,width:null};this._gridPadding={top:null,right:null,bottom:null,left:null};this._defaultGridPadding={top:10,right:10,bottom:23,left:10};this.syncXTicks=true;this.syncYTicks=true;this.seriesColors=w.jqplot.config.defaultColors;this.negativeSeriesColors=w.jqplot.config.defaultNegativeColors;this.sortData=true;var Q=0;this.textColor;this.fontFamily;this.fontSize;this.title=new n();this.options={};this.stackSeries=false;this.defaultAxisStart=1;this._stackData=[];this._plotData=[];this.plugins={};this._drawCount=0;this.drawIfHidden=false;this.captureRightClick=false;this.themeEngine=new w.jqplot.ThemeEngine();this._sumy=0;this._sumx=0;this.preInitHooks=new w.jqplot.HooksManager();this.postInitHooks=new w.jqplot.HooksManager();this.preParseOptionsHooks=new w.jqplot.HooksManager();this.postParseOptionsHooks=new w.jqplot.HooksManager();this.preDrawHooks=new w.jqplot.HooksManager();this.postDrawHooks=new w.jqplot.HooksManager();this.preDrawSeriesHooks=new w.jqplot.HooksManager();this.postDrawSeriesHooks=new w.jqplot.HooksManager();this.preDrawLegendHooks=new w.jqplot.HooksManager();this.addLegendRowHooks=new w.jqplot.HooksManager();this.preSeriesInitHooks=new w.jqplot.HooksManager();this.postSeriesInitHooks=new w.jqplot.HooksManager();this.preParseSeriesOptionsHooks=new w.jqplot.HooksManager();this.postParseSeriesOptionsHooks=new w.jqplot.HooksManager();this.eventListenerHooks=new w.jqplot.EventListenerManager();this.preDrawSeriesShadowHooks=new w.jqplot.HooksManager();this.postDrawSeriesShadowHooks=new w.jqplot.HooksManager();this.colorGenerator=w.jqplot.ColorGenerator;this.canvasManager=new w.jqplot.CanvasManager();this.init=function(Z,W,ab){ab=ab||{};for(var X=0;X<w.jqplot.preInitHooks.length;X++){w.jqplot.preInitHooks[X].call(this,Z,W,ab)}for(var X=0;X<this.preInitHooks.hooks.length;X++){this.preInitHooks.hooks[X].call(this,Z,W,ab)}this.targetId="#"+Z;this.target=w("#"+Z);this.target.removeClass("jqplot-error");if(!this.target.get(0)){throw"No plot target specified"}if(this.target.css("position")=="static"){this.target.css("position","relative")}if(!this.target.hasClass("jqplot-target")){this.target.addClass("jqplot-target")}if(!this.target.height()){var Y;if(ab&&ab.height){Y=parseInt(ab.height,10)}else{if(this.target.attr("data-height")){Y=parseInt(this.target.attr("data-height"),10)}else{Y=parseInt(w.jqplot.config.defaultHeight,10)}}this._height=Y;this.target.css("height",Y+"px")}else{this._height=Y=this.target.height()}if(!this.target.width()){var aa;if(ab&&ab.width){aa=parseInt(ab.width,10)}else{if(this.target.attr("data-width")){aa=parseInt(this.target.attr("data-width"),10)}else{aa=parseInt(w.jqplot.config.defaultWidth,10)}}this._width=aa;this.target.css("width",aa+"px")}else{this._width=aa=this.target.width()}this._plotDimensions.height=this._height;this._plotDimensions.width=this._width;this.grid._plotDimensions=this._plotDimensions;this.title._plotDimensions=this._plotDimensions;this.baseCanvas._plotDimensions=this._plotDimensions;this.eventCanvas._plotDimensions=this._plotDimensions;this.legend._plotDimensions=this._plotDimensions;if(this._height<=0||this._width<=0||!this._height||!this._width){throw"Canvas dimension not set"}if(ab.dataRenderer&&jQuery.isFunction(ab.dataRenderer)){if(ab.dataRendererOptions){this.dataRendererOptions=ab.dataRendererOptions}this.dataRenderer=ab.dataRenderer;W=this.dataRenderer(W,this,this.dataRendererOptions)}if(ab.noDataIndicator&&jQuery.isPlainObject(ab.noDataIndicator)){w.extend(true,this.noDataIndicator,ab.noDataIndicator)}if(W==null||jQuery.isArray(W)==false||W.length==0||jQuery.isArray(W[0])==false||W[0].length==0){if(this.noDataIndicator.show==false){throw {name:"DataError",message:"No data to plot."}}else{for(var S in this.noDataIndicator.axes){for(var U in this.noDataIndicator.axes[S]){this.axes[S][U]=this.noDataIndicator.axes[S][U]}}this.postDrawHooks.add(function(){var ah=this.eventCanvas.getHeight();var ae=this.eventCanvas.getWidth();var ad=w(''<div class="jqplot-noData-container" style="position:absolute;"></div>'');this.target.append(ad);ad.height(ah);ad.width(ae);ad.css("top",this.eventCanvas._offsets.top);ad.css("left",this.eventCanvas._offsets.left);var ag=w(''<div class="jqplot-noData-contents" style="text-align:center; position:relative; margin-left:auto; margin-right:auto;"></div>'');ad.append(ag);ag.html(this.noDataIndicator.indicator);var af=ag.height();var ac=ag.width();ag.height(af);ag.width(ac);ag.css("top",(ah-af)/2+"px")})}}this.data=W;this.parseOptions(ab);if(this.textColor){this.target.css("color",this.textColor)}if(this.fontFamily){this.target.css("font-family",this.fontFamily)}if(this.fontSize){this.target.css("font-size",this.fontSize)}this.title.init();this.legend.init();this._sumy=0;this._sumx=0;for(var X=0;X<this.series.length;X++){this.seriesStack.push(X);this.previousSeriesStack.push(X);this.series[X].shadowCanvas._plotDimensions=this._plotDimensions;this.series[X].canvas._plotDimensions=this._plotDimensions;for(var V=0;V<w.jqplot.preSeriesInitHooks.length;V++){w.jqplot.preSeriesInitHooks[V].call(this.series[X],Z,W,this.options.seriesDefaults,this.options.series[X],this)}for(var V=0;V<this.preSeriesInitHooks.hooks.length;V++){this.preSeriesInitHooks.hooks[V].call(this.series[X],Z,W,this.options.seriesDefaults,this.options.series[X],this)}this.populatePlotData(this.series[X],X);this.series[X]._plotDimensions=this._plotDimensions;this.series[X].init(X,this.grid.borderWidth,this);for(var V=0;V<w.jqplot.postSeriesInitHooks.length;V++){w.jqplot.postSeriesInitHooks[V].call(this.series[X],Z,W,this.options.seriesDefaults,this.options.series[X],this)}for(var V=0;V<this.postSeriesInitHooks.hooks.length;V++){this.postSeriesInitHooks.hooks[V].call(this.series[X],Z,W,this.options.seriesDefaults,this.options.series[X],this)}this._sumy+=this.series[X]._sumy;this._sumx+=this.series[X]._sumx}for(var T in this.axes){this.axes[T]._plotDimensions=this._plotDimensions;this.axes[T].init()}if(this.sortData){O(this.series)}this.grid.init();this.grid._axes=this.axes;this.legend._series=this.series;for(var X=0;X<w.jqplot.postInitHooks.length;X++){w.jqplot.postInitHooks[X].call(this,Z,W,ab)}for(var X=0;X<this.postInitHooks.hooks.length;X++){this.postInitHooks.hooks[X].call(this,Z,W,ab)}};this.resetAxesScale=function(X,T){var V=T||{};var W=X||this.axes;if(W===true){W=this.axes}if(jQuery.isArray(W)){for(var U=0;U<W.length;U++){this.axes[W[U]].resetScale(V[W[U]])}}else{if(typeof(W)==="object"){for(var S in W){this.axes[S].resetScale(V[S])}}}};this.reInitialize=function(){this._height=this.target.height();this._width=this.target.width();if(this._height<=0||this._width<=0||!this._height||!this._width){throw"Target dimension not set"}this._plotDimensions.height=this._height;this._plotDimensions.width=this._width;this.grid._plotDimensions=this._plotDimensions;this.title._plotDimensions=this._plotDimensions;this.baseCanvas._plotDimensions=this._plotDimensions;this.eventCanvas._plotDimensions=this._plotDimensions;this.legend._plotDimensions=this._plotDimensions;for(var W in this.axes){this.axes[W]._plotWidth=this._width;this.axes[W]._plotHeight=this._height}this.title._plotWidth=this._width;if(this.textColor){this.target.css("color",this.textColor)}if(this.fontFamily){this.target.css("font-family",this.fontFamily)}if(this.fontSize){this.target.css("font-size",this.fontSize)}this._sumy=0;this._sumx=0;for(var U=0;U<this.series.length;U++){this.populatePlotData(this.series[U],U);this.series[U]._plotDimensions=this._plotDimensions;this.series[U].canvas._plotDimensions=this._plotDimensions;this._sumy+=this.series[U]._sumy;this._sumx+=this.series[U]._sumx}for(var S in this.axes){var T=this.axes[S]._ticks;for(var U=0;U<T.length;U++){var V=T[U]._elem;if(V){if(w.jqplot.use_excanvas){window.G_vmlCanvasManager.uninitElement(V.get(0))}V.emptyForce();V=null;T._elem=null}}T=null;this.axes[S]._plotDimensions=this._plotDimensions;this.axes[S]._ticks=[];this.axes[S].renderer.init.call(this.axes[S],{})}if(this.sortData){O(this.series)}this.grid._axes=this.axes;this.legend._series=this.series};function O(W){var aa,ab,ac,S,Z;for(var X=0;X<W.length;X++){var T;var Y=[W[X].data,W[X]._stackData,W[X]._plotData,W[X]._prevPlotData];for(var U=0;U<4;U++){T=true;aa=Y[U];if(W[X]._stackAxis=="x"){for(var V=0;V<aa.length;V++){if(typeof(aa[V][1])!="number"){T=false;break}}if(T){aa.sort(function(ae,ad){return ae[1]-ad[1]})}}else{for(var V=0;V<aa.length;V++){if(typeof(aa[V][0])!="number"){T=false;break}}if(T){aa.sort(function(ae,ad){return ae[0]-ad[0]})}}}}}this.populatePlotData=function(W,X){this._plotData=[];this._stackData=[];W._stackData=[];W._plotData=[];var aa={x:[],y:[]};if(this.stackSeries&&!W.disableStack){W._stack=true;var Y=W._stackAxis=="x"?0:1;var Z=Y?0:1;var ab=w.extend(true,[],W.data);var ac=w.extend(true,[],W.data);for(var U=0;U<X;U++){var S=this.series[U].data;for(var T=0;T<S.length;T++){ab[T][0]+=S[T][0];ab[T][1]+=S[T][1];ac[T][Y]+=S[T][Y]}}for(var V=0;V<ac.length;V++){aa.x.push(ac[V][0]);aa.y.push(ac[V][1])}this._plotData.push(ac);this._stackData.push(ab);W._stackData=ab;W._plotData=ac;W._plotValues=aa}else{for(var V=0;V<W.data.length;V++){aa.x.push(W.data[V][0]);aa.y.push(W.data[V][1])}this._stackData.push(W.data);this.series[X]._stackData=W.data;this._plotData.push(W.data);W._plotData=W.data;W._plotValues=aa}if(X>0){W._prevPlotData=this.series[X-1]._plotData}W._sumy=0;W._sumx=0;for(V=W.data.length-1;V>-1;V--){W._sumy+=W.data[V][1];W._sumx+=W.data[V][0]}};this.getNextSeriesColor=(function(T){var S=0;var U=T.seriesColors;return function(){if(S<U.length){return U[S++]}else{S=0;return U[S++]}}})(this);this.parseOptions=function(aa){for(var X=0;X<this.preParseOptionsHooks.hooks.length;X++){this.preParseOptionsHooks.hooks[X].call(this,aa)}for(var X=0;X<w.jqplot.preParseOptionsHooks.length;X++){w.jqplot.preParseOptionsHooks[X].call(this,aa)}this.options=w.extend(true,{},this.defaults,aa);this.stackSeries=this.options.stackSeries;if(this.options.seriesColors){this.seriesColors=this.options.seriesColors}if(this.options.negativeSeriesColors){this.negativeSeriesColors=this.options.negativeSeriesColors}if(this.options.captureRightClick){this.captureRightClick=this.options.captureRightClick}this.defaultAxisStart=(aa&&aa.defaultAxisStart!=null)?aa.defaultAxisStart:this.defaultAxisStart;var S=new this.colorGenerator(this.seriesColors);w.extend(true,this._gridPadding,this.options.gridPadding);this.sortData=(this.options.sortData!=null)?this.options.sortData:this.sortData;for(var T in this.axes){var V=this.axes[T];V._options=w.extend(true,{},this.options.axesDefaults,this.options.axes[T]);w.extend(true,V,this.options.axesDefaults,this.options.axes[T]);V._plotWidth=this._width;V._plotHeight=this._height}var Y=function(ae,ac,af){var ab=[];var ad;ac=ac||"vertical";if(!jQuery.isArray(ae[0])){for(ad=0;ad<ae.length;ad++){if(ac=="vertical"){ab.push([af+ad,ae[ad]])}else{ab.push([ae[ad],af+ad])}}}else{w.extend(true,ab,ae)}return ab};for(var X=0;X<this.data.length;X++){var Z=new D();for(var W=0;W<w.jqplot.preParseSeriesOptionsHooks.length;W++){w.jqplot.preParseSeriesOptionsHooks[W].call(Z,this.options.seriesDefaults,this.options.series[X])}for(var W=0;W<this.preParseSeriesOptionsHooks.hooks.length;W++){this.preParseSeriesOptionsHooks.hooks[W].call(Z,this.options.seriesDefaults,this.options.series[X])}w.extend(true,Z,{seriesColors:this.seriesColors,negativeSeriesColors:this.negativeSeriesColors},this.options.seriesDefaults,this.options.series[X]);var U="vertical";if(Z.renderer===w.jqplot.BarRenderer&&Z.rendererOptions&&Z.rendererOptions.barDirection=="horizontal"){U="horizontal"}Z.data=Y(this.data[X],U,this.defaultAxisStart);switch(Z.xaxis){case"xaxis":Z._xaxis=this.axes.xaxis;break;case"x2axis":Z._xaxis=this.axes.x2axis;break;default:break}Z._yaxis=this.axes[Z.yaxis];Z._xaxis._series.push(Z);Z._yaxis._series.push(Z);if(Z.show){Z._xaxis.show=true;Z._yaxis.show=true}if(!Z.color&&Z.show!=false){Z.color=S.next()}if(!Z.label){Z.label="Series "+(X+1).toString()}this.series.push(Z);for(var W=0;W<w.jqplot.postParseSeriesOptionsHooks.length;W++){w.jqplot.postParseSeriesOptionsHooks[W].call(this.series[X],this.options.seriesDefaults,this.options.series[X])}for(var W=0;W<this.postParseSeriesOptionsHooks.hooks.length;W++){this.postParseSeriesOptionsHooks.hooks[W].call(this.series[X],this.options.seriesDefaults,this.options.series[X])}}w.extend(true,this.grid,this.options.grid);for(var T in this.axes){var V=this.axes[T];if(V.borderWidth==null){V.borderWidth=this.grid.borderWidth}if(V.borderColor==null){if(T!="xaxis"&&T!="x2axis"&&V.useSeriesColor===true&&V.show){V.borderColor=V._series[0].color}else{V.borderColor=this.grid.borderColor}}}if(typeof this.options.title=="string"){this.title.text=this.options.title}else{if(typeof this.options.title=="object"){w.extend(true,this.title,this.options.title)}}this.title._plotWidth=this._width;this.legend.setOptions(this.options.legend);for(var X=0;X<w.jqplot.postParseOptionsHooks.length;X++){w.jqplot.postParseOptionsHooks[X].call(this,aa)}for(var X=0;X<this.postParseOptionsHooks.hooks.length;X++){this.postParseOptionsHooks.hooks[X].call(this,aa)}};this.destroy=function(){this.canvasManager.freeAllCanvases();this.target[0].innerHTML=""};this.replot=function(T){var U=T||{};var S=U.clear||true;var V=U.resetAxes||false;this.target.trigger("jqplotPreReplot");if(S){this.canvasManager.freeAllCanvases();if(this._eventCanvas){this.eventCanvas._elem.unbind()}this.target.unbind();this.target.empty()}this.reInitialize();if(V){this.resetAxesScale(V,U.axes)}this.draw();this.target.trigger("jqplotPostReplot")};this.redraw=function(S){S=(S!=null)?S:true;this.target.trigger("jqplotPreRedraw");if(S){this.canvasManager.freeAllCanvases();this.eventCanvas._elem.unbind();this.target.unbind();this.target.empty()}for(var U in this.axes){this.axes[U]._ticks=[]}for(var T=0;T<this.series.length;T++){this.populatePlotData(this.series[T],T)}this._sumy=0;this._sumx=0;for(T=0;T<this.series.length;T++){this._sumy+=this.series[T]._sumy;this._sumx+=this.series[T]._sumx}this.draw();this.target.trigger("jqplotPostRedraw")};this.draw=function(){if(this.drawIfHidden||this.target.is(":visible")){this.target.trigger("jqplotPreDraw");var Y,X;for(Y=0;Y<w.jqplot.preDrawHooks.length;Y++){w.jqplot.preDrawHooks[Y].call(this)}for(Y=0;Y<this.preDrawHooks.hooks.length;Y++){this.preDrawHooks.hooks[Y].call(this)}this.target.append(this.baseCanvas.createElement({left:0,right:0,top:0,bottom:0},"jqplot-base-canvas",null,this));this.baseCanvas.setContext();this.target.append(this.title.draw());this.title.pack({top:0,left:0});var ad=this.legend.draw();var ac={top:0,left:0,bottom:0,right:0};if(this.legend.placement=="outsideGrid"){this.target.append(ad);switch(this.legend.location){case"n":ac.top+=this.legend.getHeight();break;case"s":ac.bottom+=this.legend.getHeight();break;case"ne":case"e":case"se":ac.right+=this.legend.getWidth();break;case"nw":case"w":case"sw":ac.left+=this.legend.getWidth();break;default:ac.right+=this.legend.getWidth();break}ad=ad.detach()}var S=this.axes;for(var U in S){this.target.append(S[U].draw(this.baseCanvas._ctx,this));S[U].set()}if(S.yaxis.show){ac.left+=S.yaxis.getWidth()}var V=["y2axis","y3axis","y4axis","y5axis","y6axis","y7axis","y8axis","y9axis"];var T=[0,0,0,0,0,0,0,0];var aa=0;var W;for(W=0;W<8;W++){if(S[V[W]].show){aa+=S[V[W]].getWidth();T[W]=aa}}ac.right+=aa;if(S.x2axis.show){ac.top+=S.x2axis.getHeight()}if(this.title.show){ac.top+=this.title.getHeight()}if(S.xaxis.show){ac.bottom+=S.xaxis.getHeight()}var Z=["top","bottom","left","right"];for(var W in Z){if(this._gridPadding[Z[W]]==null&&ac[Z[W]]>0){this._gridPadding[Z[W]]=ac[Z[W]]}else{if(this._gridPadding[Z[W]]==null){this._gridPadding[Z[W]]=this._defaultGridPadding[Z[W]]}}}var ab=(this.legend.placement=="outsideGrid")?{top:this.title.getHeight(),left:0,right:0,bottom:0}:this._gridPadding;S.xaxis.pack({position:"absolute",bottom:this._gridPadding.bottom-S.xaxis.getHeight(),left:0,width:this._width},{min:this._gridPadding.left,max:this._width-this._gridPadding.right});S.yaxis.pack({position:"absolute",top:0,left:this._gridPadding.left-S.yaxis.getWidth(),height:this._height},{min:this._height-this._gridPadding.bottom,max:this._gridPadding.top});S.x2axis.pack({position:"absolute",top:this._gridPadding.top-S.x2axis.getHeight(),left:0,width:this._width},{min:this._gridPadding.left,max:this._width-this._gridPadding.right});for(Y=8;Y>0;Y--){S[V[Y-1]].pack({position:"absolute",top:0,right:this._gridPadding.right-T[Y-1]},{min:this._height-this._gridPadding.bottom,max:this._gridPadding.top})}this.target.append(this.grid.createElement(this._gridPadding,this));this.grid.draw();for(Y=0;Y<this.series.length;Y++){X=this.seriesStack[Y];this.target.append(this.series[X].shadowCanvas.createElement(this._gridPadding,"jqplot-series-shadowCanvas",null,this));this.series[X].shadowCanvas.setContext();this.series[X].shadowCanvas._elem.data("seriesIndex",X)}for(Y=0;Y<this.series.length;Y++){X=this.seriesStack[Y];this.target.append(this.series[X].canvas.createElement(this._gridPadding,"jqplot-series-canvas",null,this));this.series[X].canvas.setContext();this.series[X].canvas._elem.data("seriesIndex",X)}this.target.append(this.eventCanvas.createElement(this._gridPadding,"jqplot-event-canvas",null,this));this.eventCanvas.setContext();this.eventCanvas._ctx.fillStyle="rgba(0,0,0,0)";this.eventCanvas._ctx.fillRect(0,0,this.eventCanvas._ctx.canvas.width,this.eventCanvas._ctx.canvas.height);this.bindCustomEvents();if(this.legend.preDraw){this.eventCanvas._elem.before(ad);this.legend.pack(ab);if(this.legend._elem){this.drawSeries({legendInfo:{location:this.legend.location,placement:this.legend.placement,width:this.legend.getWidth(),height:this.legend.getHeight(),xoffset:this.legend.xoffset,yoffset:this.legend.yoffset}})}else{this.drawSeries()}}else{this.drawSeries();if(this.series.length){w(this.series[this.series.length-1].canvas._elem).after(ad)}this.legend.pack(ab)}for(var Y=0;Y<w.jqplot.eventListenerHooks.length;Y++){this.eventCanvas._elem.bind(w.jqplot.eventListenerHooks[Y][0],{plot:this},w.jqplot.eventListenerHooks[Y][1])}for(var Y=0;Y<this.eventListenerHooks.hooks.length;Y++){this.eventCanvas._elem.bind(this.eventListenerHooks.hooks[Y][0],{plot:this},this.eventListenerHooks.hooks[Y][1])}for(var Y=0;Y<w.jqplot.postDrawHooks.length;Y++){w.jqplot.postDrawHooks[Y].call(this)}for(var Y=0;Y<this.postDrawHooks.hooks.length;Y++){this.postDrawHooks.hooks[Y].call(this)}if(this.target.is(":visible")){this._drawCount+=1}this.target.trigger("jqplotPostDraw",[this])}};this.bindCustomEvents=function(){this.eventCanvas._elem.bind("click",{plot:this},this.onClick);this.eventCanvas._elem.bind("dblclick",{plot:this},this.onDblClick);this.eventCanvas._elem.bind("mousedown",{plot:this},this.onMouseDown);this.eventCanvas._elem.bind("mousemove",{plot:this},this.onMouseMove);this.eventCanvas._elem.bind("mouseenter",{plot:this},this.onMouseEnter);this.eventCanvas._elem.bind("mouseleave",{plot:this},this.onMouseLeave);if(this.captureRightClick){this.eventCanvas._elem.bind("mouseup",{plot:this},this.onRightClick);this.eventCanvas._elem.get(0).oncontextmenu=function(){return false}}else{this.eventCanvas._elem.bind("mouseup",{plot:this},this.onMouseUp)}};function P(aa){var Z=aa.data.plot;var V=Z.eventCanvas._elem.offset();var Y={x:aa.pageX-V.left,y:aa.pageY-V.top};var W={xaxis:null,yaxis:null,x2axis:null,y2axis:null,y3axis:null,y4axis:null,y5axis:null,y6axis:null,y7axis:null,y8axis:null,y9axis:null};var X=["xaxis","yaxis","x2axis","y2axis","y3axis","y4axis","y5axis","y6axis","y7axis","y8axis","y9axis"];var S=Z.axes;var T,U;for(T=11;T>0;T--){U=X[T-1];if(S[U].show){W[U]=S[U].series_p2u(Y[U.charAt(0)])}}return{offsets:V,gridPos:Y,dataPos:W}}function R(S,T){var X=T.series;var aC,aB,aA,av,aw,ap,ao,ac,aa,af,ag,aq;var az,aD,ax,Y,an,at;var U,au;for(aA=T.seriesStack.length-1;aA>=0;aA--){aC=T.seriesStack[aA];av=X[aC];switch(av.renderer.constructor){case w.jqplot.BarRenderer:ap=S.x;ao=S.y;for(aB=0;aB<av._barPoints.length;aB++){an=av._barPoints[aB];ax=av.gridData[aB];if(ap>an[0][0]&&ap<an[2][0]&&ao>an[2][1]&&ao<an[0][1]){return{seriesIndex:av.index,pointIndex:aB,gridData:ax,data:av.data[aB],points:av._barPoints[aB]}}}break;case w.jqplot.DonutRenderer:af=av.startAngle/180*Math.PI;ap=S.x-av._center[0];ao=S.y-av._center[1];aw=Math.sqrt(Math.pow(ap,2)+Math.pow(ao,2));if(ap>0&&-ao>=0){ac=2*Math.PI-Math.atan(-ao/ap)}else{if(ap>0&&-ao<0){ac=-Math.atan(-ao/ap)}else{if(ap<0){ac=Math.PI-Math.atan(-ao/ap)}else{if(ap==0&&-ao>0){ac=3*Math.PI/2}else{if(ap==0&&-ao<0){ac=Math.PI/2}else{if(ap==0&&ao==0){ac=0}}}}}}if(af){ac-=af;if(ac<0){ac+=2*Math.PI}else{if(ac>2*Math.PI){ac-=2*Math.PI}}}aa=av.sliceMargin/180*Math.PI;if(aw<av._radius&&aw>av._innerRadius){for(aB=0;aB<av.gridData.length;aB++){ag=(aB>0)?av.gridData[aB-1][1]+aa:aa;aq=av.gridData[aB][1];if(ac>ag&&ac<aq){return{seriesIndex:av.index,pointIndex:aB,gridData:av.gridData[aB],data:av.data[aB]}}}}break;case w.jqplot.PieRenderer:af=av.startAngle/180*Math.PI;ap=S.x-av._center[0];ao=S.y-av._center[1];aw=Math.sqrt(Math.pow(ap,2)+Math.pow(ao,2));if(ap>0&&-ao>=0){ac=2*Math.PI-Math.atan(-ao/ap)}else{if(ap>0&&-ao<0){ac=-Math.atan(-ao/ap)}else{if(ap<0){ac=Math.PI-Math.atan(-ao/ap)}else{if(ap==0&&-ao>0){ac=3*Math.PI/2}else{if(ap==0&&-ao<0){ac=Math.PI/2}else{if(ap==0&&ao==0){ac=0}}}}}}if(af){ac-=af;if(ac<0){ac+=2*Math.PI}else{if(ac>2*Math.PI){ac-=2*Math.PI}}}aa=av.sliceMargin/180*Math.PI;if(aw<av._radius){for(aB=0;aB<av.gridData.length;aB++){ag=(aB>0)?av.gridData[aB-1][1]+aa:aa;aq=av.gridData[aB][1];if(ac>ag&&ac<aq){return{seriesIndex:av.index,pointIndex:aB,gridData:av.gridData[aB],data:av.data[aB]}}}}break;case w.jqplot.BubbleRenderer:ap=S.x;ao=S.y;var al=null;if(av.show){for(var aB=0;aB<av.gridData.length;aB++){ax=av.gridData[aB];aD=Math.sqrt((ap-ax[0])*(ap-ax[0])+(ao-ax[1])*(ao-ax[1]));if(aD<=ax[2]&&(aD<=az||az==null)){az=aD;al={seriesIndex:aC,pointIndex:aB,gridData:ax,data:av.data[aB]}}}if(al!=null){return al}}break;case w.jqplot.FunnelRenderer:ap=S.x;ao=S.y;var ar=av._vertices,W=ar[0],V=ar[ar.length-1],Z,ak,ae;function ay(aG,aI,aH){var aF=(aI[1]-aH[1])/(aI[0]-aH[0]);var aE=aI[1]-aF*aI[0];var aJ=aG+aI[1];return[(aJ-aE)/aF,aJ]}Z=ay(ao,W[0],V[3]);ak=ay(ao,W[1],V[2]);for(aB=0;aB<ar.length;aB++){ae=ar[aB];if(ao>=ae[0][1]&&ao<=ae[3][1]&&ap>=Z[0]&&ap<=ak[0]){return{seriesIndex:av.index,pointIndex:aB,gridData:null,data:av.data[aB]}}}break;case w.jqplot.LineRenderer:ap=S.x;ao=S.y;aw=av.renderer;if(av.show){if(av.fill){var ad=false;if(ap>av._boundingBox[0][0]&&ap<av._boundingBox[1][0]&&ao>av._boundingBox[1][1]&&ao<av._boundingBox[0][1]){var aj=av._areaPoints.length;var am;var aB=aj-1;for(var am=0;am<aj;am++){var ai=[av._areaPoints[am][0],av._areaPoints[am][1]];var ah=[av._areaPoints[aB][0],av._areaPoints[aB][1]];if(ai[1]<ao&&ah[1]>=ao||ah[1]<ao&&ai[1]>=ao){if(ai[0]+(ao-ai[1])/(ah[1]-ai[1])*(ah[0]-ai[0])<ap){ad=!ad}}aB=am}}if(ad){return{seriesIndex:aC,pointIndex:null,gridData:av.gridData,data:av.data,points:av._areaPoints}}break}else{au=av.markerRenderer.size/2+av.neighborThreshold;U=(au>0)?au:0;for(var aB=0;aB<av.gridData.length;aB++){ax=av.gridData[aB];if(aw.constructor==w.jqplot.OHLCRenderer){if(aw.candleStick){var ab=av._yaxis.series_u2p;if(ap>=ax[0]-aw._bodyWidth/2&&ap<=ax[0]+aw._bodyWidth/2&&ao>=ab(av.data[aB][2])&&ao<=ab(av.data[aB][3])){return{seriesIndex:aC,pointIndex:aB,gridData:ax,data:av.data[aB]}}}else{if(!aw.hlc){var ab=av._yaxis.series_u2p;if(ap>=ax[0]-aw._tickLength&&ap<=ax[0]+aw._tickLength&&ao>=ab(av.data[aB][2])&&ao<=ab(av.data[aB][3])){return{seriesIndex:aC,pointIndex:aB,gridData:ax,data:av.data[aB]}}}else{var ab=av._yaxis.series_u2p;if(ap>=ax[0]-aw._tickLength&&ap<=ax[0]+aw._tickLength&&ao>=ab(av.data[aB][1])&&ao<=ab(av.data[aB][2])){return{seriesIndex:aC,pointIndex:aB,gridData:ax,data:av.data[aB]}}}}}else{if(ax[0]!=null&&ax[1]!=null){aD=Math.sqrt((ap-ax[0])*(ap-ax[0])+(ao-ax[1])*(ao-ax[1]));if(aD<=U&&(aD<=az||az==null)){az=aD;return{seriesIndex:aC,pointIndex:aB,gridData:ax,data:av.data[aB]}}}}}}}break;default:ap=S.x;ao=S.y;aw=av.renderer;if(av.show){au=av.markerRenderer.size/2+av.neighborThreshold;U=(au>0)?au:0;for(var aB=0;aB<av.gridData.length;aB++){ax=av.gridData[aB];if(aw.constructor==w.jqplot.OHLCRenderer){if(aw.candleStick){var ab=av._yaxis.series_u2p;if(ap>=ax[0]-aw._bodyWidth/2&&ap<=ax[0]+aw._bodyWidth/2&&ao>=ab(av.data[aB][2])&&ao<=ab(av.data[aB][3])){return{seriesIndex:aC,pointIndex:aB,gridData:ax,data:av.data[aB]}}}else{if(!aw.hlc){var ab=av._yaxis.series_u2p;if(ap>=ax[0]-aw._tickLength&&ap<=ax[0]+aw._tickLength&&ao>=ab(av.data[aB][2])&&ao<=ab(av.data[aB][3])){return{seriesIndex:aC,pointIndex:aB,gridData:ax,data:av.data[aB]}}}else{var ab=av._yaxis.series_u2p;if(ap>=ax[0]-aw._tickLength&&ap<=ax[0]+aw._tickLength&&ao>=ab(av.data[aB][1])&&ao<=ab(av.data[aB][2])){return{seriesIndex:aC,pointIndex:aB,gridData:ax,data:av.data[aB]}}}}}else{aD=Math.sqrt((ap-ax[0])*(ap-ax[0])+(ao-ax[1])*(ao-ax[1]));if(aD<=U&&(aD<=az||az==null)){az=aD;return{seriesIndex:aC,pointIndex:aB,gridData:ax,data:av.data[aB]}}}}}break}}return null}this.onClick=function(U){var T=P(U);var W=U.data.plot;var V=R(T.gridPos,W);var S=jQuery.Event("jqplotClick");S.pageX=U.pageX;S.pageY=U.pageY;w(this).trigger(S,[T.gridPos,T.dataPos,V,W])};this.onDblClick=function(U){var T=P(U);var W=U.data.plot;var V=R(T.gridPos,W);var S=jQuery.Event("jqplotDblClick");S.pageX=U.pageX;S.pageY=U.pageY;w(this).trigger(S,[T.gridPos,T.dataPos,V,W])};this.onMouseDown=function(U){var T=P(U);var W=U.data.plot;var V=R(T.gridPos,W);var S=jQuery.Event("jqplotMouseDown");S.pageX=U.pageX;S.pageY=U.pageY;w(this).trigger(S,[T.gridPos,T.dataPos,V,W])};this.onMouseUp=function(U){var T=P(U);var S=jQuery.Event("jqplotMouseUp");S.pageX=U.pageX;S.pageY=U.pageY;w(this).trigger(S,[T.gridPos,T.dataPos,null,U.data.plot])};this.onRightClick=function(U){var T=P(U);var W=U.data.plot;var V=R(T.gridPos,W);if(W.captureRightClick){if(U.which==3){var S=jQuery.Event("jqplotRightClick");S.pageX=U.pageX;S.pageY=U.pageY;w(this).trigger(S,[T.gridPos,T.dataPos,V,W])}else{var S=jQuery.Event("jqplotMouseUp");S.pageX=U.pageX;S.pageY=U.pageY;w(this).trigger(S,[T.gridPos,T.dataPos,V,W])}}};this.onMouseMove=function(U){var T=P(U);var W=U.data.plot;var V=R(T.gridPos,W);var S=jQuery.Event("jqplotMouseMove");S.pageX=U.pageX;S.pageY=U.pageY;w(this).trigger(S,[T.gridPos,T.dataPos,V,W])};this.onMouseEnter=function(U){var T=P(U);var V=U.data.plot;var S=jQuery.Event("jqplotMouseEnter");S.pageX=U.pageX;S.pageY=U.pageY;w(this).trigger(S,[T.gridPos,T.dataPos,null,V])};this.onMouseLeave=function(U){var T=P(U);var V=U.data.plot;var S=jQuery.Event("jqplotMouseLeave");S.pageX=U.pageX;S.pageY=U.pageY;w(this).trigger(S,[T.gridPos,T.dataPos,null,V])};this.drawSeries=function(U,S){var W,V,T;S=(typeof(U)==="number"&&S==null)?U:S;U=(typeof(U)==="object")?U:{};if(S!=l){V=this.series[S];T=V.shadowCanvas._ctx;T.clearRect(0,0,T.canvas.width,T.canvas.height);V.drawShadow(T,U,this);T=V.canvas._ctx;T.clearRect(0,0,T.canvas.width,T.canvas.height);V.draw(T,U,this);if(V.renderer.constructor==w.jqplot.BezierCurveRenderer){if(S<this.series.length-1){this.drawSeries(S+1)}}}else{for(W=0;W<this.series.length;W++){V=this.series[W];T=V.shadowCanvas._ctx;T.clearRect(0,0,T.canvas.width,T.canvas.height);V.drawShadow(T,U,this);T=V.canvas._ctx;T.clearRect(0,0,T.canvas.width,T.canvas.height);V.draw(T,U,this)}}U=S=W=V=T=null};this.moveSeriesToFront=function(T){T=parseInt(T,10);var W=w.inArray(T,this.seriesStack);if(W==-1){return}if(W==this.seriesStack.length-1){this.previousSeriesStack=this.seriesStack.slice(0);return}var S=this.seriesStack[this.seriesStack.length-1];var V=this.series[T].canvas._elem.detach();var U=this.series[T].shadowCanvas._elem.detach();this.series[S].shadowCanvas._elem.after(U);this.series[S].canvas._elem.after(V);this.previousSeriesStack=this.seriesStack.slice(0);this.seriesStack.splice(W,1);this.seriesStack.push(T)};this.moveSeriesToBack=function(T){T=parseInt(T,10);var W=w.inArray(T,this.seriesStack);if(W==0||W==-1){return}var S=this.seriesStack[0];var V=this.series[T].canvas._elem.detach();var U=this.series[T].shadowCanvas._elem.detach();this.series[S].shadowCanvas._elem.before(U);this.series[S].canvas._elem.before(V);this.previousSeriesStack=this.seriesStack.slice(0);this.seriesStack.splice(W,1);this.seriesStack.unshift(T)};this.restorePreviousSeriesOrder=function(){var Y,X,W,V,U,S,T;if(this.seriesStack==this.previousSeriesStack){return}for(Y=1;Y<this.previousSeriesStack.length;Y++){S=this.previousSeriesStack[Y];T=this.previousSeriesStack[Y-1];W=this.series[S].canvas._elem.detach();V=this.series[S].shadowCanvas._elem.detach();this.series[T].shadowCanvas._elem.after(V);this.series[T].canvas._elem.after(W)}U=this.seriesStack.slice(0);this.seriesStack=this.previousSeriesStack.slice(0);this.previousSeriesStack=U};this.restoreOriginalSeriesOrder=function(){var W,V,S=[],U,T;for(W=0;W<this.series.length;W++){S.push(W)}if(this.seriesStack==S){return}this.previousSeriesStack=this.seriesStack.slice(0);this.seriesStack=S;for(W=1;W<this.seriesStack.length;W++){U=this.series[W].canvas._elem.detach();T=this.series[W].shadowCanvas._elem.detach();this.series[W-1].shadowCanvas._elem.after(T);this.series[W-1].canvas._elem.after(U)}};this.activateTheme=function(S){this.themeEngine.activate(this,S)}}w.jqplot.computeHighlightColors=function(P){var R;if(jQuery.isArray(P)){R=[];for(var T=0;T<P.length;T++){var S=w.jqplot.getColorComponents(P[T]);var O=[S[0],S[1],S[2]];var U=O[0]+O[1]+O[2];for(var Q=0;Q<3;Q++){O[Q]=(U>570)?O[Q]*0.8:O[Q]+0.3*(255-O[Q]);O[Q]=parseInt(O[Q],10)}R.push("rgb("+O[0]+","+O[1]+","+O[2]+")")}}else{var S=w.jqplot.getColorComponents(P);var O=[S[0],S[1],S[2]];var U=O[0]+O[1]+O[2];for(var Q=0;Q<3;Q++){O[Q]=(U>570)?O[Q]*0.8:O[Q]+0.3*(255-O[Q]);O[Q]=parseInt(O[Q],10)}R="rgb("+O[0]+","+O[1]+","+O[2]+")"}return R};w.jqplot.ColorGenerator=function(P){P=P||w.jqplot.config.defaultColors;var O=0;this.next=function(){if(O<P.length){return P[O++]}else{O=0;return P[O++]}};this.previous=function(){if(O>0){return P[O--]}else{O=P.length-1;return P[O]}};this.get=function(R){var Q=R-P.length*Math.floor(R/P.length);return P[Q]};this.setColors=function(Q){P=Q};this.reset=function(){O=0}};w.jqplot.hex2rgb=function(Q,O){Q=Q.replace("#","");if(Q.length==3){Q=Q.charAt(0)+Q.charAt(0)+Q.charAt(1)+Q.charAt(1)+Q.charAt(2)+Q.charAt(2)}var P;P="rgba("+parseInt(Q.slice(0,2),16)+", "+parseInt(Q.slice(2,4),16)+", "+parseInt(Q.slice(4,6),16);if(O){P+=", "+O}P+=")";return P};w.jqplot.rgb2hex=function(T){var Q=/rgba?\\( *([0-9]{1,3}\\.?[0-9]*%?) *, *([0-9]{1,3}\\.?[0-9]*%?) *, *([0-9]{1,3}\\.?[0-9]*%?) *(?:, *[0-9.]*)?\\)/;var O=T.match(Q);var S="#";for(var R=1;R<4;R++){var P;if(O[R].search(/%/)!=-1){P=parseInt(255*O[R]/100,10).toString(16);if(P.length==1){P="0"+P}}else{P=parseInt(O[R],10).toString(16);if(P.length==1){P="0"+P}}S+=P}return S};w.jqplot.normalize2rgb=function(P,O){if(P.search(/^ *rgba?\\(/)!=-1){return P}else{if(P.search(/^ *#?[0-9a-fA-F]?[0-9a-fA-F]/)!=-1){return w.jqplot.hex2rgb(P,O)}else{throw"invalid color spec"}}};w.jqplot.getColorComponents=function(T){T=w.jqplot.colorKeywordMap[T]||T;var R=w.jqplot.normalize2rgb(T);var Q=/rgba?\\( *([0-9]{1,3}\\.?[0-9]*%?) *, *([0-9]{1,3}\\.?[0-9]*%?) *, *([0-9]{1,3}\\.?[0-9]*%?) *,? *([0-9.]* *)?\\)/;var O=R.match(Q);var P=[];for(var S=1;S<4;S++){if(O[S].search(/%/)!=-1){P[S-1]=parseInt(255*O[S]/100,10)}else{P[S-1]=parseInt(O[S],10)}}P[3]=parseFloat(O[4])?parseFloat(O[4]):1;return P};w.jqplot.colorKeywordMap={aliceblue:"rgb(240, 248, 255)",antiquewhite:"rgb(250, 235, 215)",aqua:"rgb( 0, 255, 255)",aquamarine:"rgb(127, 255, 212)",azure:"rgb(240, 255, 255)",beige:"rgb(245, 245, 220)",bisque:"rgb(255, 228, 196)",black:"rgb( 0, 0, 0)",blanchedalmond:"rgb(255, 235, 205)",blue:"rgb( 0, 0, 255)",blueviolet:"rgb(138, 43, 226)",brown:"rgb(165, 42, 42)",burlywood:"rgb(222, 184, 135)",cadetblue:"rgb( 95, 158, 160)",chartreuse:"rgb(127, 255, 0)",chocolate:"rgb(210, 105, 30)",coral:"rgb(255, 127, 80)",cornflowerblue:"rgb(100, 149, 237)",cornsilk:"rgb(255, 248, 220)",crimson:"rgb(220, 20, 60)",cyan:"rgb( 0, 255, 255)",darkblue:"rgb( 0, 0, 139)",darkcyan:"rgb( 0, 139, 139)",darkgoldenrod:"rgb(184, 134, 11)",darkgray:"rgb(169, 169, 169)",darkgreen:"rgb( 0, 100, 0)",darkgrey:"rgb(169, 169, 169)",darkkhaki:"rgb(189, 183, 107)",darkmagenta:"rgb(139, 0, 139)",darkolivegreen:"rgb( 85, 107, 47)",darkorange:"rgb(255, 140, 0)",darkorchid:"rgb(153, 50, 204)",darkred:"rgb(139, 0, 0)",darksalmon:"rgb(233, 150, 122)",darkseagreen:"rgb(143, 188, 143)",darkslateblue:"rgb( 72, 61, 139)",darkslategray:"rgb( 47, 79, 79)",darkslategrey:"rgb( 47, 79, 79)",darkturquoise:"rgb( 0, 206, 209)",darkviolet:"rgb(148, 0, 211)",deeppink:"rgb(255, 20, 147)",deepskyblue:"rgb( 0, 191, 255)",dimgray:"rgb(105, 105, 105)",dimgrey:"rgb(105, 105, 105)",dodgerblue:"rgb( 30, 144, 255)",firebrick:"rgb(178, 34, 34)",floralwhite:"rgb(255, 250, 240)",forestgreen:"rgb( 34, 139, 34)",fuchsia:"rgb(255, 0, 255)",gainsboro:"rgb(220, 220, 220)",ghostwhite:"rgb(248, 248, 255)",gold:"rgb(255, 215, 0)",goldenrod:"rgb(218, 165, 32)",gray:"rgb(128, 128, 128)",grey:"rgb(128, 128, 128)",green:"rgb( 0, 128, 0)",greenyellow:"rgb(173, 255, 47)",honeydew:"rgb(240, 255, 240)",hotpink:"rgb(255, 105, 180)",indianred:"rgb(205, 92, 92)",indigo:"rgb( 75, 0, 130)",ivory:"rgb(255, 255, 240)",khaki:"rgb(240, 230, 140)",lavender:"rgb(230, 230, 250)",lavenderblush:"rgb(255, 240, 245)",lawngreen:"rgb(124, 252, 0)",lemonchiffon:"rgb(255, 250, 205)",lightblue:"rgb(173, 216, 230)",lightcoral:"rgb(240, 128, 128)",lightcyan:"rgb(224, 255, 255)",lightgoldenrodyellow:"rgb(250, 250, 210)",lightgray:"rgb(211, 211, 211)",lightgreen:"rgb(144, 238, 144)",lightgrey:"rgb(211, 211, 211)",lightpink:"rgb(255, 182, 193)",lightsalmon:"rgb(255, 160, 122)",lightseagreen:"rgb( 32, 178, 170)",lightskyblue:"rgb(135, 206, 250)",lightslategray:"rgb(119, 136, 153)",lightslategrey:"rgb(119, 136, 153)",lightsteelblue:"rgb(176, 196, 222)",lightyellow:"rgb(255, 255, 224)",lime:"rgb( 0, 255, 0)",limegreen:"rgb( 50, 205, 50)",linen:"rgb(250, 240, 230)",magenta:"rgb(255, 0, 255)",maroon:"rgb(128, 0, 0)",mediumaquamarine:"rgb(102, 205, 170)",mediumblue:"rgb( 0, 0, 205)",mediumorchid:"rgb(186, 85, 211)",mediumpurple:"rgb(147, 112, 219)",mediumseagreen:"rgb( 60, 179, 113)",mediumslateblue:"rgb(123, 104, 238)",mediumspringgreen:"rgb( 0, 250, 154)",mediumturquoise:"rgb( 72, 209, 204)",mediumvioletred:"rgb(199, 21, 133)",midnightblue:"rgb( 25, 25, 112)",mintcream:"rgb(245, 255, 250)",mistyrose:"rgb(255, 228, 225)",moccasin:"rgb(255, 228, 181)",navajowhite:"rgb(255, 222, 173)",navy:"rgb( 0, 0, 128)",oldlace:"rgb(253, 245, 230)",olive:"rgb(128, 128, 0)",olivedrab:"rgb(107, 142, 35)",orange:"rgb(255, 165, 0)",orangered:"rgb(255, 69, 0)",orchid:"rgb(218, 112, 214)",palegoldenrod:"rgb(238, 232, 170)",palegreen:"rgb(152, 251, 152)",paleturquoise:"rgb(175, 238, 238)",palevioletred:"rgb(219, 112, 147)",papayawhip:"rgb(255, 239, 213)",peachpuff:"rgb(255, 218, 185)",peru:"rgb(205, 133, 63)",pink:"rgb(255, 192, 203)",plum:"rgb(221, 160, 221)",powderblue:"rgb(176, 224, 230)",purple:"rgb(128, 0, 128)",red:"rgb(255, 0, 0)",rosybrown:"rgb(188, 143, 143)",royalblue:"rgb( 65, 105, 225)",saddlebrown:"rgb(139, 69, 19)",salmon:"rgb(250, 128, 114)",sandybrown:"rgb(244, 164, 96)",seagreen:"rgb( 46, 139, 87)",seashell:"rgb(255, 245, 238)",sienna:"rgb(160, 82, 45)",silver:"rgb(192, 192, 192)",skyblue:"rgb(135, 206, 235)",slateblue:"rgb(106, 90, 205)",slategray:"rgb(112, 128, 144)",slategrey:"rgb(112, 128, 144)",snow:"rgb(255, 250, 250)",springgreen:"rgb( 0, 255, 127)",steelblue:"rgb( 70, 130, 180)",tan:"rgb(210, 180, 140)",teal:"rgb( 0, 128, 128)",thistle:"rgb(216, 191, 216)",tomato:"rgb(255, 99, 71)",turquoise:"rgb( 64, 224, 208)",violet:"rgb(238, 130, 238)",wheat:"rgb(245, 222, 179)",white:"rgb(255, 255, 255)",whitesmoke:"rgb(245, 245, 245)",yellow:"rgb(255, 255, 0)",yellowgreen:"rgb(154, 205, 50)"};w.jqplot.AxisLabelRenderer=function(O){w.jqplot.ElemContainer.call(this);this.axis;this.show=true;this.label="";this.fontFamily=null;this.fontSize=null;this.textColor=null;this._elem;this.escapeHTML=false;w.extend(true,this,O)};w.jqplot.AxisLabelRenderer.prototype=new w.jqplot.ElemContainer();w.jqplot.AxisLabelRenderer.prototype.constructor=w.jqplot.AxisLabelRenderer;w.jqplot.AxisLabelRenderer.prototype.init=function(O){w.extend(true,this,O)};w.jqplot.AxisLabelRenderer.prototype.draw=function(O,P){if(this._elem){this._elem.emptyForce();this._elem=null}this._elem=w(''<div style="position:absolute;" class="jqplot-''+this.axis+''-label"></div>'');if(Number(this.label)){this._elem.css("white-space","nowrap")}if(!this.escapeHTML){this._elem.html(this.label)}else{this._elem.text(this.label)}if(this.fontFamily){this._elem.css("font-family",this.fontFamily)}if(this.fontSize){this._elem.css("font-size",this.fontSize)}if(this.textColor){this._elem.css("color",this.textColor)}return this._elem};w.jqplot.AxisLabelRenderer.prototype.pack=function(){};w.jqplot.AxisTickRenderer=function(O){w.jqplot.ElemContainer.call(this);this.mark="outside";this.axis;this.showMark=true;this.showGridline=true;this.isMinorTick=false;this.size=4;this.markSize=6;this.show=true;this.showLabel=true;this.label="";this.value=null;this._styles={};this.formatter=w.jqplot.DefaultTickFormatter;this.prefix="";this.formatString="";this.fontFamily;this.fontSize;this.textColor;this.escapeHTML=false;this._elem;this._breakTick=false;w.extend(true,this,O)};w.jqplot.AxisTickRenderer.prototype.init=function(O){w.extend(true,this,O)};w.jqplot.AxisTickRenderer.prototype=new w.jqplot.ElemContainer();w.jqplot.AxisTickRenderer.prototype.constructor=w.jqplot.AxisTickRenderer;w.jqplot.AxisTickRenderer.prototype.setTick=function(O,Q,P){this.value=O;this.axis=Q;if(P){this.isMinorTick=true}return this};w.jqplot.AxisTickRenderer.prototype.draw=function(){if(!this.label){this.label=this.prefix+this.formatter(this.formatString,this.value)}var P={position:"absolute"};if(Number(this.label)){P.whitSpace="nowrap"}if(this._elem){this._elem.emptyForce();this._elem=null}this._elem=w(document.createElement("div"));this._elem.addClass("jqplot-"+this.axis+"-tick");if(!this.escapeHTML){this._elem.html(this.label)}else{this._elem.text(this.label)}this._elem.css(P);for(var O in this._styles){this._elem.css(O,this._styles[O])}if(this.fontFamily){this._elem.css("font-family",this.fontFamily)}if(this.fontSize){this._elem.css("font-size",this.fontSize)}if(this.textColor){this._elem.css("color",this.textColor)}if(this._breakTick){this._elem.addClass("jqplot-breakTick")}return this._elem};w.jqplot.DefaultTickFormatter=function(O,P){if(typeof P=="number"){if(!O){O=w.jqplot.config.defaultTickFormatString}return w.jqplot.sprintf(O,P)}else{return String(P)}};w.jqplot.AxisTickRenderer.prototype.pack=function(){};w.jqplot.CanvasGridRenderer=function(){this.shadowRenderer=new w.jqplot.ShadowRenderer()};w.jqplot.CanvasGridRenderer.prototype.init=function(P){this._ctx;w.extend(true,this,P);var O={lineJoin:"miter",lineCap:"round",fill:false,isarc:false,angle:this.shadowAngle,offset:this.shadowOffset,alpha:this.shadowAlpha,depth:this.shadowDepth,lineWidth:this.shadowWidth,closePath:false,strokeStyle:this.shadowColor};this.renderer.shadowRenderer.init(O)};w.jqplot.CanvasGridRenderer.prototype.createElement=function(R){var Q;if(this._elem){if(w.jqplot.use_excanvas){Q=this._elem.get(0);window.G_vmlCanvasManager.uninitElement(Q);Q=null}this._elem.emptyForce();this._elem=null}Q=R.canvasManager.getCanvas();var O=this._plotDimensions.width;var P=this._plotDimensions.height;Q.width=O;Q.height=P;this._elem=w(Q);this._elem.addClass("jqplot-grid-canvas");this._elem.css({position:"absolute",left:0,top:0});Q=R.canvasManager.initCanvas(Q);this._top=this._offsets.top;this._bottom=P-this._offsets.bottom;this._left=this._offsets.left;this._right=O-this._offsets.right;this._width=this._right-this._left;this._height=this._bottom-this._top;Q=null;return this._elem};w.jqplot.CanvasGridRenderer.prototype.draw=function(){this._ctx=this._elem.get(0).getContext("2d");var Y=this._ctx;var ab=this._axes;Y.save();Y.clearRect(0,0,this._plotDimensions.width,this._plotDimensions.height);Y.fillStyle=this.backgroundColor||this.background;Y.fillRect(this._left,this._top,this._width,this._height);if(true){Y.save();Y.lineJoin="miter";Y.lineCap="butt";Y.lineWidth=this.gridLineWidth;Y.strokeStyle=this.gridLineColor;var ae,ad,W,X;var T=["xaxis","yaxis","x2axis","y2axis"];for(var ac=4;ac>0;ac--){var ag=T[ac-1];var O=ab[ag];var af=O._ticks;if(O.show){for(var Z=af.length;Z>0;Z--){var U=af[Z-1];if(U.show){var R=Math.round(O.u2p(U.value))+0.5;switch(ag){case"xaxis":if(U.showGridline&&this.drawGridlines){V(R,this._top,R,this._bottom)}if(U.showMark&&U.mark){W=U.markSize;X=U.mark;var R=Math.round(O.u2p(U.value))+0.5;switch(X){case"outside":ae=this._bottom;ad=this._bottom+W;break;case"inside":ae=this._bottom-W;ad=this._bottom;break;case"cross":ae=this._bottom-W;ad=this._bottom+W;break;default:ae=this._bottom;ad=this._bottom+W;break}if(this.shadow){this.renderer.shadowRenderer.draw(Y,[[R,ae],[R,ad]],{lineCap:"butt",lineWidth:this.gridLineWidth,offset:this.gridLineWidth*0.75,depth:2,fill:false,closePath:false})}V(R,ae,R,ad)}break;case"yaxis":if(U.showGridline&&this.drawGridlines){V(this._right,R,this._left,R)}if(U.showMark&&U.mark){W=U.markSize;X=U.mark;var R=Math.round(O.u2p(U.value))+0.5;switch(X){case"outside":ae=this._left-W;ad=this._left;break;case"inside":ae=this._left;ad=this._left+W;break;case"cross":ae=this._left-W;ad=this._left+W;break;default:ae=this._left-W;ad=this._left;break}if(this.shadow){this.renderer.shadowRenderer.draw(Y,[[ae,R],[ad,R]],{lineCap:"butt",lineWidth:this.gridLineWidth*1.5,offset:this.gridLineWidth*0.75,fill:false,closePath:false})}V(ae,R,ad,R,{strokeStyle:O.borderColor})}break;case"x2axis":if(U.showGridline&&this.drawGridlines){V(R,this._bottom,R,this._top)}if(U.showMark&&U.mark){W=U.markSize;X=U.mark;var R=Math.round(O.u2p(U.value))+0.5;switch(X){case"outside":ae=this._top-W;ad=this._top;break;case"inside":ae=this._top;ad=this._top+W;break;case"cross":ae=this._top-W;ad=this._top+W;break;default:ae=this._top-W;ad=this._top;break}if(this.shadow){this.renderer.shadowRenderer.draw(Y,[[R,ae],[R,ad]],{lineCap:"butt",lineWidth:this.gridLineWidth,offset:this.gridLineWidth*0.75,depth:2,fill:false,closePath:false})}V(R,ae,R,ad)}break;case"y2axis":if(U.showGridline&&this.drawGridlines){V(this._left,R,this._right,R)}if(U.showMark&&U.mark){W=U.markSize;X=U.mark;var R=Math.round(O.u2p(U.value))+0.5;switch(X){case"outside":ae=this._right;ad=this._right+W;break;case"inside":ae=this._right-W;ad=this._right;break;case"cross":ae=this._right-W;ad=this._right+W;break;default:ae=this._right;ad=this._right+W;break}if(this.shadow){this.renderer.shadowRenderer.draw(Y,[[ae,R],[ad,R]],{lineCap:"butt",lineWidth:this.gridLineWidth*1.5,offset:this.gridLineWidth*0.75,fill:false,closePath:false})}V(ae,R,ad,R,{strokeStyle:O.borderColor})}break;default:break}}}U=null}O=null;af=null}T=["y3axis","y4axis","y5axis","y6axis","y7axis","y8axis","y9axis"];for(var ac=7;ac>0;ac--){var O=ab[T[ac-1]];var af=O._ticks;if(O.show){var P=af[O.numberTicks-1];var S=af[0];var Q=O.getLeft();var aa=[[Q,P.getTop()+P.getHeight()/2],[Q,S.getTop()+S.getHeight()/2+1]];if(this.shadow){this.renderer.shadowRenderer.draw(Y,aa,{lineCap:"butt",fill:false,closePath:false})}V(aa[0][0],aa[0][1],aa[1][0],aa[1][1],{lineCap:"butt",strokeStyle:O.borderColor,lineWidth:O.borderWidth});for(var Z=af.length;Z>0;Z--){var U=af[Z-1];W=U.markSize;X=U.mark;var R=Math.round(O.u2p(U.value))+0.5;if(U.showMark&&U.mark){switch(X){case"outside":ae=Q;ad=Q+W;break;case"inside":ae=Q-W;ad=Q;break;case"cross":ae=Q-W;ad=Q+W;break;default:ae=Q;ad=Q+W;break}aa=[[ae,R],[ad,R]];if(this.shadow){this.renderer.shadowRenderer.draw(Y,aa,{lineCap:"butt",lineWidth:this.gridLineWidth*1.5,offset:this.gridLineWidth*0.75,fill:false,closePath:false})}V(ae,R,ad,R,{strokeStyle:O.borderColor})}U=null}S=null}O=null;af=null}Y.restore()}function V(al,ak,ai,ah,aj){Y.save();aj=aj||{};if(aj.lineWidth==null||aj.lineWidth!=0){w.extend(true,Y,aj);Y.beginPath();Y.moveTo(al,ak);Y.lineTo(ai,ah);Y.stroke();Y.restore()}}if(this.shadow){var aa=[[this._left,this._bottom],[this._right,this._bottom],[this._right,this._top]];this.renderer.shadowRenderer.draw(Y,aa)}if(this.borderWidth!=0&&this.drawBorder){V(this._left,this._top,this._right,this._top,{lineCap:"round",strokeStyle:ab.x2axis.borderColor,lineWidth:ab.x2axis.borderWidth});V(this._right,this._', '2012-11-07 18:41:37', 'admin', NULL);
INSERT INTO `editor_revisions` (`id`, `profile_id`, `item`, `contents`, `datetime`, `user`, `commit`) VALUES
(20, 1, '/var/www/_dev/manager/js/jquery1.4.2.js', '/*!\n * jQuery JavaScript Library v1.4.2\n * http://jquery.com/\n *\n * Copyright 2010, John Resig\n * Dual licensed under the MIT or GPL Version 2 licenses.\n * http://jquery.org/license\n *\n * Includes Sizzle.js\n * http://sizzlejs.com/\n * Copyright 2010, The Dojo Foundation\n * Released under the MIT, BSD, and GPL Licenses.\n *\n * Date: Sat Feb 13 22:33:48 2010 -0500\n */\n(function(A,w){function ma(){if(!c.isReady){try{s.documentElement.doScroll("left")}catch(a){setTimeout(ma,1);return}c.ready()}}function Qa(a,b){b.src?c.ajax({url:b.src,async:false,dataType:"script"}):c.globalEval(b.text||b.textContent||b.innerHTML||"");b.parentNode&&b.parentNode.removeChild(b)}function X(a,b,d,f,e,j){var i=a.length;if(typeof b==="object"){for(var o in b)X(a,o,b[o],f,e,d);return a}if(d!==w){f=!j&&f&&c.isFunction(d);for(o=0;o<i;o++)e(a[o],b,f?d.call(a[o],o,e(a[o],b)):d,j);return a}return i?\ne(a[0],b):w}function J(){return(new Date).getTime()}function Y(){return false}function Z(){return true}function na(a,b,d){d[0].type=a;return c.event.handle.apply(b,d)}function oa(a){var b,d=[],f=[],e=arguments,j,i,o,k,n,r;i=c.data(this,"events");if(!(a.liveFired===this||!i||!i.live||a.button&&a.type==="click")){a.liveFired=this;var u=i.live.slice(0);for(k=0;k<u.length;k++){i=u[k];i.origType.replace(O,"")===a.type?f.push(i.selector):u.splice(k--,1)}j=c(a.target).closest(f,a.currentTarget);n=0;for(r=\nj.length;n<r;n++)for(k=0;k<u.length;k++){i=u[k];if(j[n].selector===i.selector){o=j[n].elem;f=null;if(i.preType==="mouseenter"||i.preType==="mouseleave")f=c(a.relatedTarget).closest(i.selector)[0];if(!f||f!==o)d.push({elem:o,handleObj:i})}}n=0;for(r=d.length;n<r;n++){j=d[n];a.currentTarget=j.elem;a.data=j.handleObj.data;a.handleObj=j.handleObj;if(j.handleObj.origHandler.apply(j.elem,e)===false){b=false;break}}return b}}function pa(a,b){return"live."+(a&&a!=="*"?a+".":"")+b.replace(/\\./g,"`").replace(/ /g,\n"&")}function qa(a){return!a||!a.parentNode||a.parentNode.nodeType===11}function ra(a,b){var d=0;b.each(function(){if(this.nodeName===(a[d]&&a[d].nodeName)){var f=c.data(a[d++]),e=c.data(this,f);if(f=f&&f.events){delete e.handle;e.events={};for(var j in f)for(var i in f[j])c.event.add(this,j,f[j][i],f[j][i].data)}}})}function sa(a,b,d){var f,e,j;b=b&&b[0]?b[0].ownerDocument||b[0]:s;if(a.length===1&&typeof a[0]==="string"&&a[0].length<512&&b===s&&!ta.test(a[0])&&(c.support.checkClone||!ua.test(a[0]))){e=\ntrue;if(j=c.fragments[a[0]])if(j!==1)f=j}if(!f){f=b.createDocumentFragment();c.clean(a,b,f,d)}if(e)c.fragments[a[0]]=j?f:1;return{fragment:f,cacheable:e}}function K(a,b){var d={};c.each(va.concat.apply([],va.slice(0,b)),function(){d[this]=a});return d}function wa(a){return"scrollTo"in a&&a.document?a:a.nodeType===9?a.defaultView||a.parentWindow:false}var c=function(a,b){return new c.fn.init(a,b)},Ra=A.jQuery,Sa=A.$,s=A.document,T,Ta=/^[^<]*(<[\\w\\W]+>)[^>]*$|^#([\\w-]+)$/,Ua=/^.[^:#\\[\\.,]*$/,Va=/\\S/,\nWa=/^(\\s|\\u00A0)+|(\\s|\\u00A0)+$/g,Xa=/^<(\\w+)\\s*\\/?>(?:<\\/\\1>)?$/,P=navigator.userAgent,xa=false,Q=[],L,$=Object.prototype.toString,aa=Object.prototype.hasOwnProperty,ba=Array.prototype.push,R=Array.prototype.slice,ya=Array.prototype.indexOf;c.fn=c.prototype={init:function(a,b){var d,f;if(!a)return this;if(a.nodeType){this.context=this[0]=a;this.length=1;return this}if(a==="body"&&!b){this.context=s;this[0]=s.body;this.selector="body";this.length=1;return this}if(typeof a==="string")if((d=Ta.exec(a))&&\n(d[1]||!b))if(d[1]){f=b?b.ownerDocument||b:s;if(a=Xa.exec(a))if(c.isPlainObject(b)){a=[s.createElement(a[1])];c.fn.attr.call(a,b,true)}else a=[f.createElement(a[1])];else{a=sa([d[1]],[f]);a=(a.cacheable?a.fragment.cloneNode(true):a.fragment).childNodes}return c.merge(this,a)}else{if(b=s.getElementById(d[2])){if(b.id!==d[2])return T.find(a);this.length=1;this[0]=b}this.context=s;this.selector=a;return this}else if(!b&&/^\\w+$/.test(a)){this.selector=a;this.context=s;a=s.getElementsByTagName(a);return c.merge(this,\na)}else return!b||b.jquery?(b||T).find(a):c(b).find(a);else if(c.isFunction(a))return T.ready(a);if(a.selector!==w){this.selector=a.selector;this.context=a.context}return c.makeArray(a,this)},selector:"",jquery:"1.4.2",length:0,size:function(){return this.length},toArray:function(){return R.call(this,0)},get:function(a){return a==null?this.toArray():a<0?this.slice(a)[0]:this[a]},pushStack:function(a,b,d){var f=c();c.isArray(a)?ba.apply(f,a):c.merge(f,a);f.prevObject=this;f.context=this.context;if(b===\n"find")f.selector=this.selector+(this.selector?" ":"")+d;else if(b)f.selector=this.selector+"."+b+"("+d+")";return f},each:function(a,b){return c.each(this,a,b)},ready:function(a){c.bindReady();if(c.isReady)a.call(s,c);else Q&&Q.push(a);return this},eq:function(a){return a===-1?this.slice(a):this.slice(a,+a+1)},first:function(){return this.eq(0)},last:function(){return this.eq(-1)},slice:function(){return this.pushStack(R.apply(this,arguments),"slice",R.call(arguments).join(","))},map:function(a){return this.pushStack(c.map(this,\nfunction(b,d){return a.call(b,d,b)}))},end:function(){return this.prevObject||c(null)},push:ba,sort:[].sort,splice:[].splice};c.fn.init.prototype=c.fn;c.extend=c.fn.extend=function(){var a=arguments[0]||{},b=1,d=arguments.length,f=false,e,j,i,o;if(typeof a==="boolean"){f=a;a=arguments[1]||{};b=2}if(typeof a!=="object"&&!c.isFunction(a))a={};if(d===b){a=this;--b}for(;b<d;b++)if((e=arguments[b])!=null)for(j in e){i=a[j];o=e[j];if(a!==o)if(f&&o&&(c.isPlainObject(o)||c.isArray(o))){i=i&&(c.isPlainObject(i)||\nc.isArray(i))?i:c.isArray(o)?[]:{};a[j]=c.extend(f,i,o)}else if(o!==w)a[j]=o}return a};c.extend({noConflict:function(a){A.$=Sa;if(a)A.jQuery=Ra;return c},isReady:false,ready:function(){if(!c.isReady){if(!s.body)return setTimeout(c.ready,13);c.isReady=true;if(Q){for(var a,b=0;a=Q[b++];)a.call(s,c);Q=null}c.fn.triggerHandler&&c(s).triggerHandler("ready")}},bindReady:function(){if(!xa){xa=true;if(s.readyState==="complete")return c.ready();if(s.addEventListener){s.addEventListener("DOMContentLoaded",\nL,false);A.addEventListener("load",c.ready,false)}else if(s.attachEvent){s.attachEvent("onreadystatechange",L);A.attachEvent("onload",c.ready);var a=false;try{a=A.frameElement==null}catch(b){}s.documentElement.doScroll&&a&&ma()}}},isFunction:function(a){return $.call(a)==="[object Function]"},isArray:function(a){return $.call(a)==="[object Array]"},isPlainObject:function(a){if(!a||$.call(a)!=="[object Object]"||a.nodeType||a.setInterval)return false;if(a.constructor&&!aa.call(a,"constructor")&&!aa.call(a.constructor.prototype,\n"isPrototypeOf"))return false;var b;for(b in a);return b===w||aa.call(a,b)},isEmptyObject:function(a){for(var b in a)return false;return true},error:function(a){throw a;},parseJSON:function(a){if(typeof a!=="string"||!a)return null;a=c.trim(a);if(/^[\\],:{}\\s]*$/.test(a.replace(/\\\\(?:["\\\\\\/bfnrt]|u[0-9a-fA-F]{4})/g,"@").replace(/"[^"\\\\\\n\\r]*"|true|false|null|-?\\d+(?:\\.\\d*)?(?:[eE][+\\-]?\\d+)?/g,"]").replace(/(?:^|:|,)(?:\\s*\\[)+/g,"")))return A.JSON&&A.JSON.parse?A.JSON.parse(a):(new Function("return "+\na))();else c.error("Invalid JSON: "+a)},noop:function(){},globalEval:function(a){if(a&&Va.test(a)){var b=s.getElementsByTagName("head")[0]||s.documentElement,d=s.createElement("script");d.type="text/javascript";if(c.support.scriptEval)d.appendChild(s.createTextNode(a));else d.text=a;b.insertBefore(d,b.firstChild);b.removeChild(d)}},nodeName:function(a,b){return a.nodeName&&a.nodeName.toUpperCase()===b.toUpperCase()},each:function(a,b,d){var f,e=0,j=a.length,i=j===w||c.isFunction(a);if(d)if(i)for(f in a){if(b.apply(a[f],\nd)===false)break}else for(;e<j;){if(b.apply(a[e++],d)===false)break}else if(i)for(f in a){if(b.call(a[f],f,a[f])===false)break}else for(d=a[0];e<j&&b.call(d,e,d)!==false;d=a[++e]);return a},trim:function(a){return(a||"").replace(Wa,"")},makeArray:function(a,b){b=b||[];if(a!=null)a.length==null||typeof a==="string"||c.isFunction(a)||typeof a!=="function"&&a.setInterval?ba.call(b,a):c.merge(b,a);return b},inArray:function(a,b){if(b.indexOf)return b.indexOf(a);for(var d=0,f=b.length;d<f;d++)if(b[d]===\na)return d;return-1},merge:function(a,b){var d=a.length,f=0;if(typeof b.length==="number")for(var e=b.length;f<e;f++)a[d++]=b[f];else for(;b[f]!==w;)a[d++]=b[f++];a.length=d;return a},grep:function(a,b,d){for(var f=[],e=0,j=a.length;e<j;e++)!d!==!b(a[e],e)&&f.push(a[e]);return f},map:function(a,b,d){for(var f=[],e,j=0,i=a.length;j<i;j++){e=b(a[j],j,d);if(e!=null)f[f.length]=e}return f.concat.apply([],f)},guid:1,proxy:function(a,b,d){if(arguments.length===2)if(typeof b==="string"){d=a;a=d[b];b=w}else if(b&&\n!c.isFunction(b)){d=b;b=w}if(!b&&a)b=function(){return a.apply(d||this,arguments)};if(a)b.guid=a.guid=a.guid||b.guid||c.guid++;return b},uaMatch:function(a){a=a.toLowerCase();a=/(webkit)[ \\/]([\\w.]+)/.exec(a)||/(opera)(?:.*version)?[ \\/]([\\w.]+)/.exec(a)||/(msie) ([\\w.]+)/.exec(a)||!/compatible/.test(a)&&/(mozilla)(?:.*? rv:([\\w.]+))?/.exec(a)||[];return{browser:a[1]||"",version:a[2]||"0"}},browser:{}});P=c.uaMatch(P);if(P.browser){c.browser[P.browser]=true;c.browser.version=P.version}if(c.browser.webkit)c.browser.safari=\ntrue;if(ya)c.inArray=function(a,b){return ya.call(b,a)};T=c(s);if(s.addEventListener)L=function(){s.removeEventListener("DOMContentLoaded",L,false);c.ready()};else if(s.attachEvent)L=function(){if(s.readyState==="complete"){s.detachEvent("onreadystatechange",L);c.ready()}};(function(){c.support={};var a=s.documentElement,b=s.createElement("script"),d=s.createElement("div"),f="script"+J();d.style.display="none";d.innerHTML="   <link/><table></table><a href=''/a'' style=''color:red;float:left;opacity:.55;''>a</a><input type=''checkbox''/>";\nvar e=d.getElementsByTagName("*"),j=d.getElementsByTagName("a")[0];if(!(!e||!e.length||!j)){c.support={leadingWhitespace:d.firstChild.nodeType===3,tbody:!d.getElementsByTagName("tbody").length,htmlSerialize:!!d.getElementsByTagName("link").length,style:/red/.test(j.getAttribute("style")),hrefNormalized:j.getAttribute("href")==="/a",opacity:/^0.55$/.test(j.style.opacity),cssFloat:!!j.style.cssFloat,checkOn:d.getElementsByTagName("input")[0].value==="on",optSelected:s.createElement("select").appendChild(s.createElement("option")).selected,\nparentNode:d.removeChild(d.appendChild(s.createElement("div"))).parentNode===null,deleteExpando:true,checkClone:false,scriptEval:false,noCloneEvent:true,boxModel:null};b.type="text/javascript";try{b.appendChild(s.createTextNode("window."+f+"=1;"))}catch(i){}a.insertBefore(b,a.firstChild);if(A[f]){c.support.scriptEval=true;delete A[f]}try{delete b.test}catch(o){c.support.deleteExpando=false}a.removeChild(b);if(d.attachEvent&&d.fireEvent){d.attachEvent("onclick",function k(){c.support.noCloneEvent=\nfalse;d.detachEvent("onclick",k)});d.cloneNode(true).fireEvent("onclick")}d=s.createElement("div");d.innerHTML="<input type=''radio'' name=''radiotest'' checked=''checked''/>";a=s.createDocumentFragment();a.appendChild(d.firstChild);c.support.checkClone=a.cloneNode(true).cloneNode(true).lastChild.checked;c(function(){var k=s.createElement("div");k.style.width=k.style.paddingLeft="1px";s.body.appendChild(k);c.boxModel=c.support.boxModel=k.offsetWidth===2;s.body.removeChild(k).style.display="none"});a=function(k){var n=\ns.createElement("div");k="on"+k;var r=k in n;if(!r){n.setAttribute(k,"return;");r=typeof n[k]==="function"}return r};c.support.submitBubbles=a("submit");c.support.changeBubbles=a("change");a=b=d=e=j=null}})();c.props={"for":"htmlFor","class":"className",readonly:"readOnly",maxlength:"maxLength",cellspacing:"cellSpacing",rowspan:"rowSpan",colspan:"colSpan",tabindex:"tabIndex",usemap:"useMap",frameborder:"frameBorder"};var G="jQuery"+J(),Ya=0,za={};c.extend({cache:{},expando:G,noData:{embed:true,object:true,\napplet:true},data:function(a,b,d){if(!(a.nodeName&&c.noData[a.nodeName.toLowerCase()])){a=a==A?za:a;var f=a[G],e=c.cache;if(!f&&typeof b==="string"&&d===w)return null;f||(f=++Ya);if(typeof b==="object"){a[G]=f;e[f]=c.extend(true,{},b)}else if(!e[f]){a[G]=f;e[f]={}}a=e[f];if(d!==w)a[b]=d;return typeof b==="string"?a[b]:a}},removeData:function(a,b){if(!(a.nodeName&&c.noData[a.nodeName.toLowerCase()])){a=a==A?za:a;var d=a[G],f=c.cache,e=f[d];if(b){if(e){delete e[b];c.isEmptyObject(e)&&c.removeData(a)}}else{if(c.support.deleteExpando)delete a[c.expando];\nelse a.removeAttribute&&a.removeAttribute(c.expando);delete f[d]}}}});c.fn.extend({data:function(a,b){if(typeof a==="undefined"&&this.length)return c.data(this[0]);else if(typeof a==="object")return this.each(function(){c.data(this,a)});var d=a.split(".");d[1]=d[1]?"."+d[1]:"";if(b===w){var f=this.triggerHandler("getData"+d[1]+"!",[d[0]]);if(f===w&&this.length)f=c.data(this[0],a);return f===w&&d[1]?this.data(d[0]):f}else return this.trigger("setData"+d[1]+"!",[d[0],b]).each(function(){c.data(this,\na,b)})},removeData:function(a){return this.each(function(){c.removeData(this,a)})}});c.extend({queue:function(a,b,d){if(a){b=(b||"fx")+"queue";var f=c.data(a,b);if(!d)return f||[];if(!f||c.isArray(d))f=c.data(a,b,c.makeArray(d));else f.push(d);return f}},dequeue:function(a,b){b=b||"fx";var d=c.queue(a,b),f=d.shift();if(f==="inprogress")f=d.shift();if(f){b==="fx"&&d.unshift("inprogress");f.call(a,function(){c.dequeue(a,b)})}}});c.fn.extend({queue:function(a,b){if(typeof a!=="string"){b=a;a="fx"}if(b===\nw)return c.queue(this[0],a);return this.each(function(){var d=c.queue(this,a,b);a==="fx"&&d[0]!=="inprogress"&&c.dequeue(this,a)})},dequeue:function(a){return this.each(function(){c.dequeue(this,a)})},delay:function(a,b){a=c.fx?c.fx.speeds[a]||a:a;b=b||"fx";return this.queue(b,function(){var d=this;setTimeout(function(){c.dequeue(d,b)},a)})},clearQueue:function(a){return this.queue(a||"fx",[])}});var Aa=/[\\n\\t]/g,ca=/\\s+/,Za=/\\r/g,$a=/href|src|style/,ab=/(button|input)/i,bb=/(button|input|object|select|textarea)/i,\ncb=/^(a|area)$/i,Ba=/radio|checkbox/;c.fn.extend({attr:function(a,b){return X(this,a,b,true,c.attr)},removeAttr:function(a){return this.each(function(){c.attr(this,a,"");this.nodeType===1&&this.removeAttribute(a)})},addClass:function(a){if(c.isFunction(a))return this.each(function(n){var r=c(this);r.addClass(a.call(this,n,r.attr("class")))});if(a&&typeof a==="string")for(var b=(a||"").split(ca),d=0,f=this.length;d<f;d++){var e=this[d];if(e.nodeType===1)if(e.className){for(var j=" "+e.className+" ",\ni=e.className,o=0,k=b.length;o<k;o++)if(j.indexOf(" "+b[o]+" ")<0)i+=" "+b[o];e.className=c.trim(i)}else e.className=a}return this},removeClass:function(a){if(c.isFunction(a))return this.each(function(k){var n=c(this);n.removeClass(a.call(this,k,n.attr("class")))});if(a&&typeof a==="string"||a===w)for(var b=(a||"").split(ca),d=0,f=this.length;d<f;d++){var e=this[d];if(e.nodeType===1&&e.className)if(a){for(var j=(" "+e.className+" ").replace(Aa," "),i=0,o=b.length;i<o;i++)j=j.replace(" "+b[i]+" ",\n" ");e.className=c.trim(j)}else e.className=""}return this},toggleClass:function(a,b){var d=typeof a,f=typeof b==="boolean";if(c.isFunction(a))return this.each(function(e){var j=c(this);j.toggleClass(a.call(this,e,j.attr("class"),b),b)});return this.each(function(){if(d==="string")for(var e,j=0,i=c(this),o=b,k=a.split(ca);e=k[j++];){o=f?o:!i.hasClass(e);i[o?"addClass":"removeClass"](e)}else if(d==="undefined"||d==="boolean"){this.className&&c.data(this,"__className__",this.className);this.className=\nthis.className||a===false?"":c.data(this,"__className__")||""}})},hasClass:function(a){a=" "+a+" ";for(var b=0,d=this.length;b<d;b++)if((" "+this[b].className+" ").replace(Aa," ").indexOf(a)>-1)return true;return false},val:function(a){if(a===w){var b=this[0];if(b){if(c.nodeName(b,"option"))return(b.attributes.value||{}).specified?b.value:b.text;if(c.nodeName(b,"select")){var d=b.selectedIndex,f=[],e=b.options;b=b.type==="select-one";if(d<0)return null;var j=b?d:0;for(d=b?d+1:e.length;j<d;j++){var i=\ne[j];if(i.selected){a=c(i).val();if(b)return a;f.push(a)}}return f}if(Ba.test(b.type)&&!c.support.checkOn)return b.getAttribute("value")===null?"on":b.value;return(b.value||"").replace(Za,"")}return w}var o=c.isFunction(a);return this.each(function(k){var n=c(this),r=a;if(this.nodeType===1){if(o)r=a.call(this,k,n.val());if(typeof r==="number")r+="";if(c.isArray(r)&&Ba.test(this.type))this.checked=c.inArray(n.val(),r)>=0;else if(c.nodeName(this,"select")){var u=c.makeArray(r);c("option",this).each(function(){this.selected=\nc.inArray(c(this).val(),u)>=0});if(!u.length)this.selectedIndex=-1}else this.value=r}})}});c.extend({attrFn:{val:true,css:true,html:true,text:true,data:true,width:true,height:true,offset:true},attr:function(a,b,d,f){if(!a||a.nodeType===3||a.nodeType===8)return w;if(f&&b in c.attrFn)return c(a)[b](d);f=a.nodeType!==1||!c.isXMLDoc(a);var e=d!==w;b=f&&c.props[b]||b;if(a.nodeType===1){var j=$a.test(b);if(b in a&&f&&!j){if(e){b==="type"&&ab.test(a.nodeName)&&a.parentNode&&c.error("type property can''t be changed");\na[b]=d}if(c.nodeName(a,"form")&&a.getAttributeNode(b))return a.getAttributeNode(b).nodeValue;if(b==="tabIndex")return(b=a.getAttributeNode("tabIndex"))&&b.specified?b.value:bb.test(a.nodeName)||cb.test(a.nodeName)&&a.href?0:w;return a[b]}if(!c.support.style&&f&&b==="style"){if(e)a.style.cssText=""+d;return a.style.cssText}e&&a.setAttribute(b,""+d);a=!c.support.hrefNormalized&&f&&j?a.getAttribute(b,2):a.getAttribute(b);return a===null?w:a}return c.style(a,b,d)}});var O=/\\.(.*)$/,db=function(a){return a.replace(/[^\\w\\s\\.\\|`]/g,\nfunction(b){return"\\\\"+b})};c.event={add:function(a,b,d,f){if(!(a.nodeType===3||a.nodeType===8)){if(a.setInterval&&a!==A&&!a.frameElement)a=A;var e,j;if(d.handler){e=d;d=e.handler}if(!d.guid)d.guid=c.guid++;if(j=c.data(a)){var i=j.events=j.events||{},o=j.handle;if(!o)j.handle=o=function(){return typeof c!=="undefined"&&!c.event.triggered?c.event.handle.apply(o.elem,arguments):w};o.elem=a;b=b.split(" ");for(var k,n=0,r;k=b[n++];){j=e?c.extend({},e):{handler:d,data:f};if(k.indexOf(".")>-1){r=k.split(".");\nk=r.shift();j.namespace=r.slice(0).sort().join(".")}else{r=[];j.namespace=""}j.type=k;j.guid=d.guid;var u=i[k],z=c.event.special[k]||{};if(!u){u=i[k]=[];if(!z.setup||z.setup.call(a,f,r,o)===false)if(a.addEventListener)a.addEventListener(k,o,false);else a.attachEvent&&a.attachEvent("on"+k,o)}if(z.add){z.add.call(a,j);if(!j.handler.guid)j.handler.guid=d.guid}u.push(j);c.event.global[k]=true}a=null}}},global:{},remove:function(a,b,d,f){if(!(a.nodeType===3||a.nodeType===8)){var e,j=0,i,o,k,n,r,u,z=c.data(a),\nC=z&&z.events;if(z&&C){if(b&&b.type){d=b.handler;b=b.type}if(!b||typeof b==="string"&&b.charAt(0)==="."){b=b||"";for(e in C)c.event.remove(a,e+b)}else{for(b=b.split(" ");e=b[j++];){n=e;i=e.indexOf(".")<0;o=[];if(!i){o=e.split(".");e=o.shift();k=new RegExp("(^|\\\\.)"+c.map(o.slice(0).sort(),db).join("\\\\.(?:.*\\\\.)?")+"(\\\\.|$)")}if(r=C[e])if(d){n=c.event.special[e]||{};for(B=f||0;B<r.length;B++){u=r[B];if(d.guid===u.guid){if(i||k.test(u.namespace)){f==null&&r.splice(B--,1);n.remove&&n.remove.call(a,u)}if(f!=\nnull)break}}if(r.length===0||f!=null&&r.length===1){if(!n.teardown||n.teardown.call(a,o)===false)Ca(a,e,z.handle);delete C[e]}}else for(var B=0;B<r.length;B++){u=r[B];if(i||k.test(u.namespace)){c.event.remove(a,n,u.handler,B);r.splice(B--,1)}}}if(c.isEmptyObject(C)){if(b=z.handle)b.elem=null;delete z.events;delete z.handle;c.isEmptyObject(z)&&c.removeData(a)}}}}},trigger:function(a,b,d,f){var e=a.type||a;if(!f){a=typeof a==="object"?a[G]?a:c.extend(c.Event(e),a):c.Event(e);if(e.indexOf("!")>=0){a.type=\ne=e.slice(0,-1);a.exclusive=true}if(!d){a.stopPropagation();c.event.global[e]&&c.each(c.cache,function(){this.events&&this.events[e]&&c.event.trigger(a,b,this.handle.elem)})}if(!d||d.nodeType===3||d.nodeType===8)return w;a.result=w;a.target=d;b=c.makeArray(b);b.unshift(a)}a.currentTarget=d;(f=c.data(d,"handle"))&&f.apply(d,b);f=d.parentNode||d.ownerDocument;try{if(!(d&&d.nodeName&&c.noData[d.nodeName.toLowerCase()]))if(d["on"+e]&&d["on"+e].apply(d,b)===false)a.result=false}catch(j){}if(!a.isPropagationStopped()&&\nf)c.event.trigger(a,b,f,true);else if(!a.isDefaultPrevented()){f=a.target;var i,o=c.nodeName(f,"a")&&e==="click",k=c.event.special[e]||{};if((!k._default||k._default.call(d,a)===false)&&!o&&!(f&&f.nodeName&&c.noData[f.nodeName.toLowerCase()])){try{if(f[e]){if(i=f["on"+e])f["on"+e]=null;c.event.triggered=true;f[e]()}}catch(n){}if(i)f["on"+e]=i;c.event.triggered=false}}},handle:function(a){var b,d,f,e;a=arguments[0]=c.event.fix(a||A.event);a.currentTarget=this;b=a.type.indexOf(".")<0&&!a.exclusive;\nif(!b){d=a.type.split(".");a.type=d.shift();f=new RegExp("(^|\\\\.)"+d.slice(0).sort().join("\\\\.(?:.*\\\\.)?")+"(\\\\.|$)")}e=c.data(this,"events");d=e[a.type];if(e&&d){d=d.slice(0);e=0;for(var j=d.length;e<j;e++){var i=d[e];if(b||f.test(i.namespace)){a.handler=i.handler;a.data=i.data;a.handleObj=i;i=i.handler.apply(this,arguments);if(i!==w){a.result=i;if(i===false){a.preventDefault();a.stopPropagation()}}if(a.isImmediatePropagationStopped())break}}}return a.result},props:"altKey attrChange attrName bubbles button cancelable charCode clientX clientY ctrlKey currentTarget data detail eventPhase fromElement handler keyCode layerX layerY metaKey newValue offsetX offsetY originalTarget pageX pageY prevValue relatedNode relatedTarget screenX screenY shiftKey srcElement target toElement view wheelDelta which".split(" "),\nfix:function(a){if(a[G])return a;var b=a;a=c.Event(b);for(var d=this.props.length,f;d;){f=this.props[--d];a[f]=b[f]}if(!a.target)a.target=a.srcElement||s;if(a.target.nodeType===3)a.target=a.target.parentNode;if(!a.relatedTarget&&a.fromElement)a.relatedTarget=a.fromElement===a.target?a.toElement:a.fromElement;if(a.pageX==null&&a.clientX!=null){b=s.documentElement;d=s.body;a.pageX=a.clientX+(b&&b.scrollLeft||d&&d.scrollLeft||0)-(b&&b.clientLeft||d&&d.clientLeft||0);a.pageY=a.clientY+(b&&b.scrollTop||\nd&&d.scrollTop||0)-(b&&b.clientTop||d&&d.clientTop||0)}if(!a.which&&(a.charCode||a.charCode===0?a.charCode:a.keyCode))a.which=a.charCode||a.keyCode;if(!a.metaKey&&a.ctrlKey)a.metaKey=a.ctrlKey;if(!a.which&&a.button!==w)a.which=a.button&1?1:a.button&2?3:a.button&4?2:0;return a},guid:1E8,proxy:c.proxy,special:{ready:{setup:c.bindReady,teardown:c.noop},live:{add:function(a){c.event.add(this,a.origType,c.extend({},a,{handler:oa}))},remove:function(a){var b=true,d=a.origType.replace(O,"");c.each(c.data(this,\n"events").live||[],function(){if(d===this.origType.replace(O,""))return b=false});b&&c.event.remove(this,a.origType,oa)}},beforeunload:{setup:function(a,b,d){if(this.setInterval)this.onbeforeunload=d;return false},teardown:function(a,b){if(this.onbeforeunload===b)this.onbeforeunload=null}}}};var Ca=s.removeEventListener?function(a,b,d){a.removeEventListener(b,d,false)}:function(a,b,d){a.detachEvent("on"+b,d)};c.Event=function(a){if(!this.preventDefault)return new c.Event(a);if(a&&a.type){this.originalEvent=\na;this.type=a.type}else this.type=a;this.timeStamp=J();this[G]=true};c.Event.prototype={preventDefault:function(){this.isDefaultPrevented=Z;var a=this.originalEvent;if(a){a.preventDefault&&a.preventDefault();a.returnValue=false}},stopPropagation:function(){this.isPropagationStopped=Z;var a=this.originalEvent;if(a){a.stopPropagation&&a.stopPropagation();a.cancelBubble=true}},stopImmediatePropagation:function(){this.isImmediatePropagationStopped=Z;this.stopPropagation()},isDefaultPrevented:Y,isPropagationStopped:Y,\nisImmediatePropagationStopped:Y};var Da=function(a){var b=a.relatedTarget;try{for(;b&&b!==this;)b=b.parentNode;if(b!==this){a.type=a.data;c.event.handle.apply(this,arguments)}}catch(d){}},Ea=function(a){a.type=a.data;c.event.handle.apply(this,arguments)};c.each({mouseenter:"mouseover",mouseleave:"mouseout"},function(a,b){c.event.special[a]={setup:function(d){c.event.add(this,b,d&&d.selector?Ea:Da,a)},teardown:function(d){c.event.remove(this,b,d&&d.selector?Ea:Da)}}});if(!c.support.submitBubbles)c.event.special.submit=\n{setup:function(){if(this.nodeName.toLowerCase()!=="form"){c.event.add(this,"click.specialSubmit",function(a){var b=a.target,d=b.type;if((d==="submit"||d==="image")&&c(b).closest("form").length)return na("submit",this,arguments)});c.event.add(this,"keypress.specialSubmit",function(a){var b=a.target,d=b.type;if((d==="text"||d==="password")&&c(b).closest("form").length&&a.keyCode===13)return na("submit",this,arguments)})}else return false},teardown:function(){c.event.remove(this,".specialSubmit")}};\nif(!c.support.changeBubbles){var da=/textarea|input|select/i,ea,Fa=function(a){var b=a.type,d=a.value;if(b==="radio"||b==="checkbox")d=a.checked;else if(b==="select-multiple")d=a.selectedIndex>-1?c.map(a.options,function(f){return f.selected}).join("-"):"";else if(a.nodeName.toLowerCase()==="select")d=a.selectedIndex;return d},fa=function(a,b){var d=a.target,f,e;if(!(!da.test(d.nodeName)||d.readOnly)){f=c.data(d,"_change_data");e=Fa(d);if(a.type!=="focusout"||d.type!=="radio")c.data(d,"_change_data",\ne);if(!(f===w||e===f))if(f!=null||e){a.type="change";return c.event.trigger(a,b,d)}}};c.event.special.change={filters:{focusout:fa,click:function(a){var b=a.target,d=b.type;if(d==="radio"||d==="checkbox"||b.nodeName.toLowerCase()==="select")return fa.call(this,a)},keydown:function(a){var b=a.target,d=b.type;if(a.keyCode===13&&b.nodeName.toLowerCase()!=="textarea"||a.keyCode===32&&(d==="checkbox"||d==="radio")||d==="select-multiple")return fa.call(this,a)},beforeactivate:function(a){a=a.target;c.data(a,\n"_change_data",Fa(a))}},setup:function(){if(this.type==="file")return false;for(var a in ea)c.event.add(this,a+".specialChange",ea[a]);return da.test(this.nodeName)},teardown:function(){c.event.remove(this,".specialChange");return da.test(this.nodeName)}};ea=c.event.special.change.filters}s.addEventListener&&c.each({focus:"focusin",blur:"focusout"},function(a,b){function d(f){f=c.event.fix(f);f.type=b;return c.event.handle.call(this,f)}c.event.special[b]={setup:function(){this.addEventListener(a,\nd,true)},teardown:function(){this.removeEventListener(a,d,true)}}});c.each(["bind","one"],function(a,b){c.fn[b]=function(d,f,e){if(typeof d==="object"){for(var j in d)this[b](j,f,d[j],e);return this}if(c.isFunction(f)){e=f;f=w}var i=b==="one"?c.proxy(e,function(k){c(this).unbind(k,i);return e.apply(this,arguments)}):e;if(d==="unload"&&b!=="one")this.one(d,f,e);else{j=0;for(var o=this.length;j<o;j++)c.event.add(this[j],d,i,f)}return this}});c.fn.extend({unbind:function(a,b){if(typeof a==="object"&&\n!a.preventDefault)for(var d in a)this.unbind(d,a[d]);else{d=0;for(var f=this.length;d<f;d++)c.event.remove(this[d],a,b)}return this},delegate:function(a,b,d,f){return this.live(b,d,f,a)},undelegate:function(a,b,d){return arguments.length===0?this.unbind("live"):this.die(b,null,d,a)},trigger:function(a,b){return this.each(function(){c.event.trigger(a,b,this)})},triggerHandler:function(a,b){if(this[0]){a=c.Event(a);a.preventDefault();a.stopPropagation();c.event.trigger(a,b,this[0]);return a.result}},\ntoggle:function(a){for(var b=arguments,d=1;d<b.length;)c.proxy(a,b[d++]);return this.click(c.proxy(a,function(f){var e=(c.data(this,"lastToggle"+a.guid)||0)%d;c.data(this,"lastToggle"+a.guid,e+1);f.preventDefault();return b[e].apply(this,arguments)||false}))},hover:function(a,b){return this.mouseenter(a).mouseleave(b||a)}});var Ga={focus:"focusin",blur:"focusout",mouseenter:"mouseover",mouseleave:"mouseout"};c.each(["live","die"],function(a,b){c.fn[b]=function(d,f,e,j){var i,o=0,k,n,r=j||this.selector,\nu=j?this:c(this.context);if(c.isFunction(f)){e=f;f=w}for(d=(d||"").split(" ");(i=d[o++])!=null;){j=O.exec(i);k="";if(j){k=j[0];i=i.replace(O,"")}if(i==="hover")d.push("mouseenter"+k,"mouseleave"+k);else{n=i;if(i==="focus"||i==="blur"){d.push(Ga[i]+k);i+=k}else i=(Ga[i]||i)+k;b==="live"?u.each(function(){c.event.add(this,pa(i,r),{data:f,selector:r,handler:e,origType:i,origHandler:e,preType:n})}):u.unbind(pa(i,r),e)}}return this}});c.each("blur focus focusin focusout load resize scroll unload click dblclick mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave change select submit keydown keypress keyup error".split(" "),\nfunction(a,b){c.fn[b]=function(d){return d?this.bind(b,d):this.trigger(b)};if(c.attrFn)c.attrFn[b]=true});A.attachEvent&&!A.addEventListener&&A.attachEvent("onunload",function(){for(var a in c.cache)if(c.cache[a].handle)try{c.event.remove(c.cache[a].handle.elem)}catch(b){}});(function(){function a(g){for(var h="",l,m=0;g[m];m++){l=g[m];if(l.nodeType===3||l.nodeType===4)h+=l.nodeValue;else if(l.nodeType!==8)h+=a(l.childNodes)}return h}function b(g,h,l,m,q,p){q=0;for(var v=m.length;q<v;q++){var t=m[q];\nif(t){t=t[g];for(var y=false;t;){if(t.sizcache===l){y=m[t.sizset];break}if(t.nodeType===1&&!p){t.sizcache=l;t.sizset=q}if(t.nodeName.toLowerCase()===h){y=t;break}t=t[g]}m[q]=y}}}function d(g,h,l,m,q,p){q=0;for(var v=m.length;q<v;q++){var t=m[q];if(t){t=t[g];for(var y=false;t;){if(t.sizcache===l){y=m[t.sizset];break}if(t.nodeType===1){if(!p){t.sizcache=l;t.sizset=q}if(typeof h!=="string"){if(t===h){y=true;break}}else if(k.filter(h,[t]).length>0){y=t;break}}t=t[g]}m[q]=y}}}var f=/((?:\\((?:\\([^()]+\\)|[^()]+)+\\)|\\[(?:\\[[^[\\]]*\\]|[''"][^''"]*[''"]|[^[\\]''"]+)+\\]|\\\\.|[^ >+~,(\\[\\\\]+)+|[>+~])(\\s*,\\s*)?((?:.|\\r|\\n)*)/g,\ne=0,j=Object.prototype.toString,i=false,o=true;[0,0].sort(function(){o=false;return 0});var k=function(g,h,l,m){l=l||[];var q=h=h||s;if(h.nodeType!==1&&h.nodeType!==9)return[];if(!g||typeof g!=="string")return l;for(var p=[],v,t,y,S,H=true,M=x(h),I=g;(f.exec(""),v=f.exec(I))!==null;){I=v[3];p.push(v[1]);if(v[2]){S=v[3];break}}if(p.length>1&&r.exec(g))if(p.length===2&&n.relative[p[0]])t=ga(p[0]+p[1],h);else for(t=n.relative[p[0]]?[h]:k(p.shift(),h);p.length;){g=p.shift();if(n.relative[g])g+=p.shift();\nt=ga(g,t)}else{if(!m&&p.length>1&&h.nodeType===9&&!M&&n.match.ID.test(p[0])&&!n.match.ID.test(p[p.length-1])){v=k.find(p.shift(),h,M);h=v.expr?k.filter(v.expr,v.set)[0]:v.set[0]}if(h){v=m?{expr:p.pop(),set:z(m)}:k.find(p.pop(),p.length===1&&(p[0]==="~"||p[0]==="+")&&h.parentNode?h.parentNode:h,M);t=v.expr?k.filter(v.expr,v.set):v.set;if(p.length>0)y=z(t);else H=false;for(;p.length;){var D=p.pop();v=D;if(n.relative[D])v=p.pop();else D="";if(v==null)v=h;n.relative[D](y,v,M)}}else y=[]}y||(y=t);y||k.error(D||\ng);if(j.call(y)==="[object Array]")if(H)if(h&&h.nodeType===1)for(g=0;y[g]!=null;g++){if(y[g]&&(y[g]===true||y[g].nodeType===1&&E(h,y[g])))l.push(t[g])}else for(g=0;y[g]!=null;g++)y[g]&&y[g].nodeType===1&&l.push(t[g]);else l.push.apply(l,y);else z(y,l);if(S){k(S,q,l,m);k.uniqueSort(l)}return l};k.uniqueSort=function(g){if(B){i=o;g.sort(B);if(i)for(var h=1;h<g.length;h++)g[h]===g[h-1]&&g.splice(h--,1)}return g};k.matches=function(g,h){return k(g,null,null,h)};k.find=function(g,h,l){var m,q;if(!g)return[];\nfor(var p=0,v=n.order.length;p<v;p++){var t=n.order[p];if(q=n.leftMatch[t].exec(g)){var y=q[1];q.splice(1,1);if(y.substr(y.length-1)!=="\\\\"){q[1]=(q[1]||"").replace(/\\\\/g,"");m=n.find[t](q,h,l);if(m!=null){g=g.replace(n.match[t],"");break}}}}m||(m=h.getElementsByTagName("*"));return{set:m,expr:g}};k.filter=function(g,h,l,m){for(var q=g,p=[],v=h,t,y,S=h&&h[0]&&x(h[0]);g&&h.length;){for(var H in n.filter)if((t=n.leftMatch[H].exec(g))!=null&&t[2]){var M=n.filter[H],I,D;D=t[1];y=false;t.splice(1,1);if(D.substr(D.length-\n1)!=="\\\\"){if(v===p)p=[];if(n.preFilter[H])if(t=n.preFilter[H](t,v,l,p,m,S)){if(t===true)continue}else y=I=true;if(t)for(var U=0;(D=v[U])!=null;U++)if(D){I=M(D,t,U,v);var Ha=m^!!I;if(l&&I!=null)if(Ha)y=true;else v[U]=false;else if(Ha){p.push(D);y=true}}if(I!==w){l||(v=p);g=g.replace(n.match[H],"");if(!y)return[];break}}}if(g===q)if(y==null)k.error(g);else break;q=g}return v};k.error=function(g){throw"Syntax error, unrecognized expression: "+g;};var n=k.selectors={order:["ID","NAME","TAG"],match:{ID:/#((?:[\\w\\u00c0-\\uFFFF-]|\\\\.)+)/,\nCLASS:/\\.((?:[\\w\\u00c0-\\uFFFF-]|\\\\.)+)/,NAME:/\\[name=[''"]*((?:[\\w\\u00c0-\\uFFFF-]|\\\\.)+)[''"]*\\]/,ATTR:/\\[\\s*((?:[\\w\\u00c0-\\uFFFF-]|\\\\.)+)\\s*(?:(\\S?=)\\s*([''"]*)(.*?)\\3|)\\s*\\]/,TAG:/^((?:[\\w\\u00c0-\\uFFFF\\*-]|\\\\.)+)/,CHILD:/:(only|nth|last|first)-child(?:\\((even|odd|[\\dn+-]*)\\))?/,POS:/:(nth|eq|gt|lt|first|last|even|odd)(?:\\((\\d*)\\))?(?=[^-]|$)/,PSEUDO:/:((?:[\\w\\u00c0-\\uFFFF-]|\\\\.)+)(?:\\(([''"]?)((?:\\([^\\)]+\\)|[^\\(\\)]*)+)\\2\\))?/},leftMatch:{},attrMap:{"class":"className","for":"htmlFor"},attrHandle:{href:function(g){return g.getAttribute("href")}},\nrelative:{"+":function(g,h){var l=typeof h==="string",m=l&&!/\\W/.test(h);l=l&&!m;if(m)h=h.toLowerCase();m=0;for(var q=g.length,p;m<q;m++)if(p=g[m]){for(;(p=p.previousSibling)&&p.nodeType!==1;);g[m]=l||p&&p.nodeName.toLowerCase()===h?p||false:p===h}l&&k.filter(h,g,true)},">":function(g,h){var l=typeof h==="string";if(l&&!/\\W/.test(h)){h=h.toLowerCase();for(var m=0,q=g.length;m<q;m++){var p=g[m];if(p){l=p.parentNode;g[m]=l.nodeName.toLowerCase()===h?l:false}}}else{m=0;for(q=g.length;m<q;m++)if(p=g[m])g[m]=\nl?p.parentNode:p.parentNode===h;l&&k.filter(h,g,true)}},"":function(g,h,l){var m=e++,q=d;if(typeof h==="string"&&!/\\W/.test(h)){var p=h=h.toLowerCase();q=b}q("parentNode",h,m,g,p,l)},"~":function(g,h,l){var m=e++,q=d;if(typeof h==="string"&&!/\\W/.test(h)){var p=h=h.toLowerCase();q=b}q("previousSibling",h,m,g,p,l)}},find:{ID:function(g,h,l){if(typeof h.getElementById!=="undefined"&&!l)return(g=h.getElementById(g[1]))?[g]:[]},NAME:function(g,h){if(typeof h.getElementsByName!=="undefined"){var l=[];\nh=h.getElementsByName(g[1]);for(var m=0,q=h.length;m<q;m++)h[m].getAttribute("name")===g[1]&&l.push(h[m]);return l.length===0?null:l}},TAG:function(g,h){return h.getElementsByTagName(g[1])}},preFilter:{CLASS:function(g,h,l,m,q,p){g=" "+g[1].replace(/\\\\/g,"")+" ";if(p)return g;p=0;for(var v;(v=h[p])!=null;p++)if(v)if(q^(v.className&&(" "+v.className+" ").replace(/[\\t\\n]/g," ").indexOf(g)>=0))l||m.push(v);else if(l)h[p]=false;return false},ID:function(g){return g[1].replace(/\\\\/g,"")},TAG:function(g){return g[1].toLowerCase()},\nCHILD:function(g){if(g[1]==="nth"){var h=/(-?)(\\d*)n((?:\\+|-)?\\d*)/.exec(g[2]==="even"&&"2n"||g[2]==="odd"&&"2n+1"||!/\\D/.test(g[2])&&"0n+"+g[2]||g[2]);g[2]=h[1]+(h[2]||1)-0;g[3]=h[3]-0}g[0]=e++;return g},ATTR:function(g,h,l,m,q,p){h=g[1].replace(/\\\\/g,"");if(!p&&n.attrMap[h])g[1]=n.attrMap[h];if(g[2]==="~=")g[4]=" "+g[4]+" ";return g},PSEUDO:function(g,h,l,m,q){if(g[1]==="not")if((f.exec(g[3])||"").length>1||/^\\w/.test(g[3]))g[3]=k(g[3],null,null,h);else{g=k.filter(g[3],h,l,true^q);l||m.push.apply(m,\ng);return false}else if(n.match.POS.test(g[0])||n.match.CHILD.test(g[0]))return true;return g},POS:function(g){g.unshift(true);return g}},filters:{enabled:function(g){return g.disabled===false&&g.type!=="hidden"},disabled:function(g){return g.disabled===true},checked:function(g){return g.checked===true},selected:function(g){return g.selected===true},parent:function(g){return!!g.firstChild},empty:function(g){return!g.firstChild},has:function(g,h,l){return!!k(l[3],g).length},header:function(g){return/h\\d/i.test(g.nodeName)},\ntext:function(g){return"text"===g.type},radio:function(g){return"radio"===g.type},checkbox:function(g){return"checkbox"===g.type},file:function(g){return"file"===g.type},password:function(g){return"password"===g.type},submit:function(g){return"submit"===g.type},image:function(g){return"image"===g.type},reset:function(g){return"reset"===g.type},button:function(g){return"button"===g.type||g.nodeName.toLowerCase()==="button"},input:function(g){return/input|select|textarea|button/i.test(g.nodeName)}},\nsetFilters:{first:function(g,h){return h===0},last:function(g,h,l,m){return h===m.length-1},even:function(g,h){return h%2===0},odd:function(g,h){return h%2===1},lt:function(g,h,l){return h<l[3]-0},gt:function(g,h,l){return h>l[3]-0},nth:function(g,h,l){return l[3]-0===h},eq:function(g,h,l){return l[3]-0===h}},filter:{PSEUDO:function(g,h,l,m){var q=h[1],p=n.filters[q];if(p)return p(g,l,h,m);else if(q==="contains")return(g.textContent||g.innerText||a([g])||"").indexOf(h[3])>=0;else if(q==="not"){h=\nh[3];l=0;for(m=h.length;l<m;l++)if(h[l]===g)return false;return true}else k.error("Syntax error, unrecognized expression: "+q)},CHILD:function(g,h){var l=h[1],m=g;switch(l){case "only":case "first":for(;m=m.previousSibling;)if(m.nodeType===1)return false;if(l==="first")return true;m=g;case "last":for(;m=m.nextSibling;)if(m.nodeType===1)return false;return true;case "nth":l=h[2];var q=h[3];if(l===1&&q===0)return true;h=h[0];var p=g.parentNode;if(p&&(p.sizcache!==h||!g.nodeIndex)){var v=0;for(m=p.firstChild;m;m=\nm.nextSibling)if(m.nodeType===1)m.nodeIndex=++v;p.sizcache=h}g=g.nodeIndex-q;return l===0?g===0:g%l===0&&g/l>=0}},ID:function(g,h){return g.nodeType===1&&g.getAttribute("id")===h},TAG:function(g,h){return h==="*"&&g.nodeType===1||g.nodeName.toLowerCase()===h},CLASS:function(g,h){return(" "+(g.className||g.getAttribute("class"))+" ").indexOf(h)>-1},ATTR:function(g,h){var l=h[1];g=n.attrHandle[l]?n.attrHandle[l](g):g[l]!=null?g[l]:g.getAttribute(l);l=g+"";var m=h[2];h=h[4];return g==null?m==="!=":m===\n"="?l===h:m==="*="?l.indexOf(h)>=0:m==="~="?(" "+l+" ").indexOf(h)>=0:!h?l&&g!==false:m==="!="?l!==h:m==="^="?l.indexOf(h)===0:m==="$="?l.substr(l.length-h.length)===h:m==="|="?l===h||l.substr(0,h.length+1)===h+"-":false},POS:function(g,h,l,m){var q=n.setFilters[h[2]];if(q)return q(g,l,h,m)}}},r=n.match.POS;for(var u in n.match){n.match[u]=new RegExp(n.match[u].source+/(?![^\\[]*\\])(?![^\\(]*\\))/.source);n.leftMatch[u]=new RegExp(/(^(?:.|\\r|\\n)*?)/.source+n.match[u].source.replace(/\\\\(\\d+)/g,function(g,\nh){return"\\\\"+(h-0+1)}))}var z=function(g,h){g=Array.prototype.slice.call(g,0);if(h){h.push.apply(h,g);return h}return g};try{Array.prototype.slice.call(s.documentElement.childNodes,0)}catch(C){z=function(g,h){h=h||[];if(j.call(g)==="[object Array]")Array.prototype.push.apply(h,g);else if(typeof g.length==="number")for(var l=0,m=g.length;l<m;l++)h.push(g[l]);else for(l=0;g[l];l++)h.push(g[l]);return h}}var B;if(s.documentElement.compareDocumentPosition)B=function(g,h){if(!g.compareDocumentPosition||\n!h.compareDocumentPosition){if(g==h)i=true;return g.compareDocumentPosition?-1:1}g=g.compareDocumentPosition(h)&4?-1:g===h?0:1;if(g===0)i=true;return g};else if("sourceIndex"in s.documentElement)B=function(g,h){if(!g.sourceIndex||!h.sourceIndex){if(g==h)i=true;return g.sourceIndex?-1:1}g=g.sourceIndex-h.sourceIndex;if(g===0)i=true;return g};else if(s.createRange)B=function(g,h){if(!g.ownerDocument||!h.ownerDocument){if(g==h)i=true;return g.ownerDocument?-1:1}var l=g.ownerDocument.createRange(),m=\nh.ownerDocument.createRange();l.setStart(g,0);l.setEnd(g,0);m.setStart(h,0);m.setEnd(h,0);g=l.compareBoundaryPoints(Range.START_TO_END,m);if(g===0)i=true;return g};(function(){var g=s.createElement("div"),h="script"+(new Date).getTime();g.innerHTML="<a name=''"+h+"''/>";var l=s.documentElement;l.insertBefore(g,l.firstChild);if(s.getElementById(h)){n.find.ID=function(m,q,p){if(typeof q.getElementById!=="undefined"&&!p)return(q=q.getElementById(m[1]))?q.id===m[1]||typeof q.getAttributeNode!=="undefined"&&\nq.getAttributeNode("id").nodeValue===m[1]?[q]:w:[]};n.filter.ID=function(m,q){var p=typeof m.getAttributeNode!=="undefined"&&m.getAttributeNode("id");return m.nodeType===1&&p&&p.nodeValue===q}}l.removeChild(g);l=g=null})();(function(){var g=s.createElement("div");g.appendChild(s.createComment(""));if(g.getElementsByTagName("*").length>0)n.find.TAG=function(h,l){l=l.getElementsByTagName(h[1]);if(h[1]==="*"){h=[];for(var m=0;l[m];m++)l[m].nodeType===1&&h.push(l[m]);l=h}return l};g.innerHTML="<a href=''#''></a>";\nif(g.firstChild&&typeof g.firstChild.getAttribute!=="undefined"&&g.firstChild.getAttribute("href")!=="#")n.attrHandle.href=function(h){return h.getAttribute("href",2)};g=null})();s.querySelectorAll&&function(){var g=k,h=s.createElement("div");h.innerHTML="<p class=''TEST''></p>";if(!(h.querySelectorAll&&h.querySelectorAll(".TEST").length===0)){k=function(m,q,p,v){q=q||s;if(!v&&q.nodeType===9&&!x(q))try{return z(q.querySelectorAll(m),p)}catch(t){}return g(m,q,p,v)};for(var l in g)k[l]=g[l];h=null}}();\n(function(){var g=s.createElement("div");g.innerHTML="<div class=''test e''></div><div class=''test''></div>";if(!(!g.getElementsByClassName||g.getElementsByClassName("e").length===0)){g.lastChild.className="e";if(g.getElementsByClassName("e").length!==1){n.order.splice(1,0,"CLASS");n.find.CLASS=function(h,l,m){if(typeof l.getElementsByClassName!=="undefined"&&!m)return l.getElementsByClassName(h[1])};g=null}}})();var E=s.compareDocumentPosition?function(g,h){return!!(g.compareDocumentPosition(h)&16)}:\nfunction(g,h){return g!==h&&(g.contains?g.contains(h):true)},x=function(g){return(g=(g?g.ownerDocument||g:0).documentElement)?g.nodeName!=="HTML":false},ga=function(g,h){var l=[],m="",q;for(h=h.nodeType?[h]:h;q=n.match.PSEUDO.exec(g);){m+=q[0];g=g.replace(n.match.PSEUDO,"")}g=n.relative[g]?g+"*":g;q=0;for(var p=h.length;q<p;q++)k(g,h[q],l);return k.filter(m,l)};c.find=k;c.expr=k.selectors;c.expr[":"]=c.expr.filters;c.unique=k.uniqueSort;c.text=a;c.isXMLDoc=x;c.contains=E})();var eb=/Until$/,fb=/^(?:parents|prevUntil|prevAll)/,\ngb=/,/;R=Array.prototype.slice;var Ia=function(a,b,d){if(c.isFunction(b))return c.grep(a,function(e,j){return!!b.call(e,j,e)===d});else if(b.nodeType)return c.grep(a,function(e){return e===b===d});else if(typeof b==="string"){var f=c.grep(a,function(e){return e.nodeType===1});if(Ua.test(b))return c.filter(b,f,!d);else b=c.filter(b,f)}return c.grep(a,function(e){return c.inArray(e,b)>=0===d})};c.fn.extend({find:function(a){for(var b=this.pushStack("","find",a),d=0,f=0,e=this.length;f<e;f++){d=b.length;\nc.find(a,this[f],b);if(f>0)for(var j=d;j<b.length;j++)for(var i=0;i<d;i++)if(b[i]===b[j]){b.splice(j--,1);break}}return b},has:function(a){var b=c(a);return this.filter(function(){for(var d=0,f=b.length;d<f;d++)if(c.contains(this,b[d]))return true})},not:function(a){return this.pushStack(Ia(this,a,false),"not",a)},filter:function(a){return this.pushStack(Ia(this,a,true),"filter",a)},is:function(a){return!!a&&c.filter(a,this).length>0},closest:function(a,b){if(c.isArray(a)){var d=[],f=this[0],e,j=\n{},i;if(f&&a.length){e=0;for(var o=a.length;e<o;e++){i=a[e];j[i]||(j[i]=c.expr.match.POS.test(i)?c(i,b||this.context):i)}for(;f&&f.ownerDocument&&f!==b;){for(i in j){e=j[i];if(e.jquery?e.index(f)>-1:c(f).is(e)){d.push({selector:i,elem:f});delete j[i]}}f=f.parentNode}}return d}var k=c.expr.match.POS.test(a)?c(a,b||this.context):null;return this.map(function(n,r){for(;r&&r.ownerDocument&&r!==b;){if(k?k.index(r)>-1:c(r).is(a))return r;r=r.parentNode}return null})},index:function(a){if(!a||typeof a===\n"string")return c.inArray(this[0],a?c(a):this.parent().children());return c.inArray(a.jquery?a[0]:a,this)},add:function(a,b){a=typeof a==="string"?c(a,b||this.context):c.makeArray(a);b=c.merge(this.get(),a);return this.pushStack(qa(a[0])||qa(b[0])?b:c.unique(b))},andSelf:function(){return this.add(this.prevObject)}});c.each({parent:function(a){return(a=a.parentNode)&&a.nodeType!==11?a:null},parents:function(a){return c.dir(a,"parentNode")},parentsUntil:function(a,b,d){return c.dir(a,"parentNode",\nd)},next:function(a){return c.nth(a,2,"nextSibling")},prev:function(a){return c.nth(a,2,"previousSibling")},nextAll:function(a){return c.dir(a,"nextSibling")},prevAll:function(a){return c.dir(a,"previousSibling")},nextUntil:function(a,b,d){return c.dir(a,"nextSibling",d)},prevUntil:function(a,b,d){return c.dir(a,"previousSibling",d)},siblings:function(a){return c.sibling(a.parentNode.firstChild,a)},children:function(a){return c.sibling(a.firstChild)},contents:function(a){return c.nodeName(a,"iframe")?\na.contentDocument||a.contentWindow.document:c.makeArray(a.childNodes)}},function(a,b){c.fn[a]=function(d,f){var e=c.map(this,b,d);eb.test(a)||(f=d);if(f&&typeof f==="string")e=c.filter(f,e);e=this.length>1?c.unique(e):e;if((this.length>1||gb.test(f))&&fb.test(a))e=e.reverse();return this.pushStack(e,a,R.call(arguments).join(","))}});c.extend({filter:function(a,b,d){if(d)a=":not("+a+")";return c.find.matches(a,b)},dir:function(a,b,d){var f=[];for(a=a[b];a&&a.nodeType!==9&&(d===w||a.nodeType!==1||!c(a).is(d));){a.nodeType===\n1&&f.push(a);a=a[b]}return f},nth:function(a,b,d){b=b||1;for(var f=0;a;a=a[d])if(a.nodeType===1&&++f===b)break;return a},sibling:function(a,b){for(var d=[];a;a=a.nextSibling)a.nodeType===1&&a!==b&&d.push(a);return d}});var Ja=/ jQuery\\d+="(?:\\d+|null)"/g,V=/^\\s+/,Ka=/(<([\\w:]+)[^>]*?)\\/>/g,hb=/^(?:area|br|col|embed|hr|img|input|link|meta|param)$/i,La=/<([\\w:]+)/,ib=/<tbody/i,jb=/<|&#?\\w+;/,ta=/<script|<object|<embed|<option|<style/i,ua=/checked\\s*(?:[^=]|=\\s*.checked.)/i,Ma=function(a,b,d){return hb.test(d)?\na:b+"></"+d+">"},F={option:[1,"<select multiple=''multiple''>","</select>"],legend:[1,"<fieldset>","</fieldset>"],thead:[1,"<table>","</table>"],tr:[2,"<table><tbody>","</tbody></table>"],td:[3,"<table><tbody><tr>","</tr></tbody></table>"],col:[2,"<table><tbody></tbody><colgroup>","</colgroup></table>"],area:[1,"<map>","</map>"],_default:[0,"",""]};F.optgroup=F.option;F.tbody=F.tfoot=F.colgroup=F.caption=F.thead;F.th=F.td;if(!c.support.htmlSerialize)F._default=[1,"div<div>","</div>"];c.fn.extend({text:function(a){if(c.isFunction(a))return this.each(function(b){var d=\nc(this);d.text(a.call(this,b,d.text()))});if(typeof a!=="object"&&a!==w)return this.empty().append((this[0]&&this[0].ownerDocument||s).createTextNode(a));return c.text(this)},wrapAll:function(a){if(c.isFunction(a))return this.each(function(d){c(this).wrapAll(a.call(this,d))});if(this[0]){var b=c(a,this[0].ownerDocument).eq(0).clone(true);this[0].parentNode&&b.insertBefore(this[0]);b.map(function(){for(var d=this;d.firstChild&&d.firstChild.nodeType===1;)d=d.firstChild;return d}).append(this)}return this},\nwrapInner:function(a){if(c.isFunction(a))return this.each(function(b){c(this).wrapInner(a.call(this,b))});return this.each(function(){var b=c(this),d=b.contents();d.length?d.wrapAll(a):b.append(a)})},wrap:function(a){return this.each(function(){c(this).wrapAll(a)})},unwrap:function(){return this.parent().each(function(){c.nodeName(this,"body")||c(this).replaceWith(this.childNodes)}).end()},append:function(){return this.domManip(arguments,true,function(a){this.nodeType===1&&this.appendChild(a)})},\nprepend:function(){return this.domManip(arguments,true,function(a){this.nodeType===1&&this.insertBefore(a,this.firstChild)})},before:function(){if(this[0]&&this[0].parentNode)return this.domManip(arguments,false,function(b){this.parentNode.insertBefore(b,this)});else if(arguments.length){var a=c(arguments[0]);a.push.apply(a,this.toArray());return this.pushStack(a,"before",arguments)}},after:function(){if(this[0]&&this[0].parentNode)return this.domManip(arguments,false,function(b){this.parentNode.insertBefore(b,\nthis.nextSibling)});else if(arguments.length){var a=this.pushStack(this,"after",arguments);a.push.apply(a,c(arguments[0]).toArray());return a}},remove:function(a,b){for(var d=0,f;(f=this[d])!=null;d++)if(!a||c.filter(a,[f]).length){if(!b&&f.nodeType===1){c.cleanData(f.getElementsByTagName("*"));c.cleanData([f])}f.parentNode&&f.parentNode.removeChild(f)}return this},empty:function(){for(var a=0,b;(b=this[a])!=null;a++)for(b.nodeType===1&&c.cleanData(b.getElementsByTagName("*"));b.firstChild;)b.removeChild(b.firstChild);\nreturn this},clone:function(a){var b=this.map(function(){if(!c.support.noCloneEvent&&!c.isXMLDoc(this)){var d=this.outerHTML,f=this.ownerDocument;if(!d){d=f.createElement("div");d.appendChild(this.cloneNode(true));d=d.innerHTML}return c.clean([d.replace(Ja,"").replace(/=([^="''>\\s]+\\/)>/g,''="$1">'').replace(V,"")],f)[0]}else return this.cloneNode(true)});if(a===true){ra(this,b);ra(this.find("*"),b.find("*"))}return b},html:function(a){if(a===w)return this[0]&&this[0].nodeType===1?this[0].innerHTML.replace(Ja,\n""):null;else if(typeof a==="string"&&!ta.test(a)&&(c.support.leadingWhitespace||!V.test(a))&&!F[(La.exec(a)||["",""])[1].toLowerCase()]){a=a.replace(Ka,Ma);try{for(var b=0,d=this.length;b<d;b++)if(this[b].nodeType===1){c.cleanData(this[b].getElementsByTagName("*"));this[b].innerHTML=a}}catch(f){this.empty().append(a)}}else c.isFunction(a)?this.each(function(e){var j=c(this),i=j.html();j.empty().append(function(){return a.call(this,e,i)})}):this.empty().append(a);return this},replaceWith:function(a){if(this[0]&&\nthis[0].parentNode){if(c.isFunction(a))return this.each(function(b){var d=c(this),f=d.html();d.replaceWith(a.call(this,b,f))});if(typeof a!=="string")a=c(a).detach();return this.each(function(){var b=this.nextSibling,d=this.parentNode;c(this).remove();b?c(b).before(a):c(d).append(a)})}else return this.pushStack(c(c.isFunction(a)?a():a),"replaceWith",a)},detach:function(a){return this.remove(a,true)},domManip:function(a,b,d){function f(u){return c.nodeName(u,"table")?u.getElementsByTagName("tbody")[0]||\nu.appendChild(u.ownerDocument.createElement("tbody")):u}var e,j,i=a[0],o=[],k;if(!c.support.checkClone&&arguments.length===3&&typeof i==="string"&&ua.test(i))return this.each(function(){c(this).domManip(a,b,d,true)});if(c.isFunction(i))return this.each(function(u){var z=c(this);a[0]=i.call(this,u,b?z.html():w);z.domManip(a,b,d)});if(this[0]){e=i&&i.parentNode;e=c.support.parentNode&&e&&e.nodeType===11&&e.childNodes.length===this.length?{fragment:e}:sa(a,this,o);k=e.fragment;if(j=k.childNodes.length===\n1?(k=k.firstChild):k.firstChild){b=b&&c.nodeName(j,"tr");for(var n=0,r=this.length;n<r;n++)d.call(b?f(this[n],j):this[n],n>0||e.cacheable||this.length>1?k.cloneNode(true):k)}o.length&&c.each(o,Qa)}return this}});c.fragments={};c.each({appendTo:"append",prependTo:"prepend",insertBefore:"before",insertAfter:"after",replaceAll:"replaceWith"},function(a,b){c.fn[a]=function(d){var f=[];d=c(d);var e=this.length===1&&this[0].parentNode;if(e&&e.nodeType===11&&e.childNodes.length===1&&d.length===1){d[b](this[0]);\nreturn this}else{e=0;for(var j=d.length;e<j;e++){var i=(e>0?this.clone(true):this).get();c.fn[b].apply(c(d[e]),i);f=f.concat(i)}return this.pushStack(f,a,d.selector)}}});c.extend({clean:function(a,b,d,f){b=b||s;if(typeof b.createElement==="undefined")b=b.ownerDocument||b[0]&&b[0].ownerDocument||s;for(var e=[],j=0,i;(i=a[j])!=null;j++){if(typeof i==="number")i+="";if(i){if(typeof i==="string"&&!jb.test(i))i=b.createTextNode(i);else if(typeof i==="string"){i=i.replace(Ka,Ma);var o=(La.exec(i)||["",\n""])[1].toLowerCase(),k=F[o]||F._default,n=k[0],r=b.createElement("div");for(r.innerHTML=k[1]+i+k[2];n--;)r=r.lastChild;if(!c.support.tbody){n=ib.test(i);o=o==="table"&&!n?r.firstChild&&r.firstChild.childNodes:k[1]==="<table>"&&!n?r.childNodes:[];for(k=o.length-1;k>=0;--k)c.nodeName(o[k],"tbody")&&!o[k].childNodes.length&&o[k].parentNode.removeChild(o[k])}!c.support.leadingWhitespace&&V.test(i)&&r.insertBefore(b.createTextNode(V.exec(i)[0]),r.firstChild);i=r.childNodes}if(i.nodeType)e.push(i);else e=\nc.merge(e,i)}}if(d)for(j=0;e[j];j++)if(f&&c.nodeName(e[j],"script")&&(!e[j].type||e[j].type.toLowerCase()==="text/javascript"))f.push(e[j].parentNode?e[j].parentNode.removeChild(e[j]):e[j]);else{e[j].nodeType===1&&e.splice.apply(e,[j+1,0].concat(c.makeArray(e[j].getElementsByTagName("script"))));d.appendChild(e[j])}return e},cleanData:function(a){for(var b,d,f=c.cache,e=c.event.special,j=c.support.deleteExpando,i=0,o;(o=a[i])!=null;i++)if(d=o[c.expando]){b=f[d];if(b.events)for(var k in b.events)e[k]?\nc.event.remove(o,k):Ca(o,k,b.handle);if(j)delete o[c.expando];else o.removeAttribute&&o.removeAttribute(c.expando);delete f[d]}}});var kb=/z-?index|font-?weight|opacity|zoom|line-?height/i,Na=/alpha\\([^)]*\\)/,Oa=/opacity=([^)]*)/,ha=/float/i,ia=/-([a-z])/ig,lb=/([A-Z])/g,mb=/^-?\\d+(?:px)?$/i,nb=/^-?\\d/,ob={position:"absolute",visibility:"hidden",display:"block"},pb=["Left","Right"],qb=["Top","Bottom"],rb=s.defaultView&&s.defaultView.getComputedStyle,Pa=c.support.cssFloat?"cssFloat":"styleFloat",ja=\nfunction(a,b){return b.toUpperCase()};c.fn.css=function(a,b){return X(this,a,b,true,function(d,f,e){if(e===w)return c.curCSS(d,f);if(typeof e==="number"&&!kb.test(f))e+="px";c.style(d,f,e)})};c.extend({style:function(a,b,d){if(!a||a.nodeType===3||a.nodeType===8)return w;if((b==="width"||b==="height")&&parseFloat(d)<0)d=w;var f=a.style||a,e=d!==w;if(!c.support.opacity&&b==="opacity"){if(e){f.zoom=1;b=parseInt(d,10)+""==="NaN"?"":"alpha(opacity="+d*100+")";a=f.filter||c.curCSS(a,"filter")||"";f.filter=\nNa.test(a)?a.replace(Na,b):b}return f.filter&&f.filter.indexOf("opacity=")>=0?parseFloat(Oa.exec(f.filter)[1])/100+"":""}if(ha.test(b))b=Pa;b=b.replace(ia,ja);if(e)f[b]=d;return f[b]},css:function(a,b,d,f){if(b==="width"||b==="height"){var e,j=b==="width"?pb:qb;function i(){e=b==="width"?a.offsetWidth:a.offsetHeight;f!=="border"&&c.each(j,function(){f||(e-=parseFloat(c.curCSS(a,"padding"+this,true))||0);if(f==="margin")e+=parseFloat(c.curCSS(a,"margin"+this,true))||0;else e-=parseFloat(c.curCSS(a,\n"border"+this+"Width",true))||0})}a.offsetWidth!==0?i():c.swap(a,ob,i);return Math.max(0,Math.round(e))}return c.curCSS(a,b,d)},curCSS:function(a,b,d){var f,e=a.style;if(!c.support.opacity&&b==="opacity"&&a.currentStyle){f=Oa.test(a.currentStyle.filter||"")?parseFloat(RegExp.$1)/100+"":"";return f===""?"1":f}if(ha.test(b))b=Pa;if(!d&&e&&e[b])f=e[b];else if(rb){if(ha.test(b))b="float";b=b.replace(lb,"-$1").toLowerCase();e=a.ownerDocument.defaultView;if(!e)return null;if(a=e.getComputedStyle(a,null))f=\na.getPropertyValue(b);if(b==="opacity"&&f==="")f="1"}else if(a.currentStyle){d=b.replace(ia,ja);f=a.currentStyle[b]||a.currentStyle[d];if(!mb.test(f)&&nb.test(f)){b=e.left;var j=a.runtimeStyle.left;a.runtimeStyle.left=a.currentStyle.left;e.left=d==="fontSize"?"1em":f||0;f=e.pixelLeft+"px";e.left=b;a.runtimeStyle.left=j}}return f},swap:function(a,b,d){var f={};for(var e in b){f[e]=a.style[e];a.style[e]=b[e]}d.call(a);for(e in b)a.style[e]=f[e]}});if(c.expr&&c.expr.filters){c.expr.filters.hidden=function(a){var b=\na.offsetWidth,d=a.offsetHeight,f=a.nodeName.toLowerCase()==="tr";return b===0&&d===0&&!f?true:b>0&&d>0&&!f?false:c.curCSS(a,"display")==="none"};c.expr.filters.visible=function(a){return!c.expr.filters.hidden(a)}}var sb=J(),tb=/<script(.|\\s)*?\\/script>/gi,ub=/select|textarea/i,vb=/color|date|datetime|email|hidden|month|number|password|range|search|tel|text|time|url|week/i,N=/=\\?(&|$)/,ka=/\\?/,wb=/(\\?|&)_=.*?(&|$)/,xb=/^(\\w+:)?\\/\\/([^\\/?#]+)/,yb=/%20/g,zb=c.fn.load;c.fn.extend({load:function(a,b,d){if(typeof a!==\n"string")return zb.call(this,a);else if(!this.length)return this;var f=a.indexOf(" ");if(f>=0){var e=a.slice(f,a.length);a=a.slice(0,f)}f="GET";if(b)if(c.isFunction(b)){d=b;b=null}else if(typeof b==="object"){b=c.param(b,c.ajaxSettings.traditional);f="POST"}var j=this;c.ajax({url:a,type:f,dataType:"html",data:b,complete:function(i,o){if(o==="success"||o==="notmodified")j.html(e?c("<div />").append(i.responseText.replace(tb,"")).find(e):i.responseText);d&&j.each(d,[i.responseText,o,i])}});return this},\nserialize:function(){return c.param(this.serializeArray())},serializeArray:function(){return this.map(function(){return this.elements?c.makeArray(this.elements):this}).filter(function(){return this.name&&!this.disabled&&(this.checked||ub.test(this.nodeName)||vb.test(this.type))}).map(function(a,b){a=c(this).val();return a==null?null:c.isArray(a)?c.map(a,function(d){return{name:b.name,value:d}}):{name:b.name,value:a}}).get()}});c.each("ajaxStart ajaxStop ajaxComplete ajaxError ajaxSuccess ajaxSend".split(" "),\nfunction(a,b){c.fn[b]=function(d){return this.bind(b,d)}});c.extend({get:function(a,b,d,f){if(c.isFunction(b)){f=f||d;d=b;b=null}return c.ajax({type:"GET",url:a,data:b,success:d,dataType:f})},getScript:function(a,b){return c.get(a,null,b,"script")},getJSON:function(a,b,d){return c.get(a,b,d,"json")},post:function(a,b,d,f){if(c.isFunction(b)){f=f||d;d=b;b={}}return c.ajax({type:"POST",url:a,data:b,success:d,dataType:f})},ajaxSetup:function(a){c.extend(c.ajaxSettings,a)},ajaxSettings:{url:location.href,\nglobal:true,type:"GET",contentType:"application/x-www-form-urlencoded",processData:true,async:true,xhr:A.XMLHttpRequest&&(A.location.protocol!=="file:"||!A.ActiveXObject)?function(){return new A.XMLHttpRequest}:function(){try{return new A.ActiveXObject("Microsoft.XMLHTTP")}catch(a){}},accepts:{xml:"application/xml, text/xml",html:"text/html",script:"text/javascript, application/javascript",json:"application/json, text/javascript",text:"text/plain",_default:"*/*"}},lastModified:{},etag:{},ajax:function(a){function b(){e.success&&\ne.success.call(k,o,i,x);e.global&&f("ajaxSuccess",[x,e])}function d(){e.complete&&e.complete.call(k,x,i);e.global&&f("ajaxComplete",[x,e]);e.global&&!--c.active&&c.event.trigger("ajaxStop")}function f(q,p){(e.context?c(e.context):c.event).trigger(q,p)}var e=c.extend(true,{},c.ajaxSettings,a),j,i,o,k=a&&a.context||e,n=e.type.toUpperCase();if(e.data&&e.processData&&typeof e.data!=="string")e.data=c.param(e.data,e.traditional);if(e.dataType==="jsonp"){if(n==="GET")N.test(e.url)||(e.url+=(ka.test(e.url)?\n"&":"?")+(e.jsonp||"callback")+"=?");else if(!e.data||!N.test(e.data))e.data=(e.data?e.data+"&":"")+(e.jsonp||"callback")+"=?";e.dataType="json"}if(e.dataType==="json"&&(e.data&&N.test(e.data)||N.test(e.url))){j=e.jsonpCallback||"jsonp"+sb++;if(e.data)e.data=(e.data+"").replace(N,"="+j+"$1");e.url=e.url.replace(N,"="+j+"$1");e.dataType="script";A[j]=A[j]||function(q){o=q;b();d();A[j]=w;try{delete A[j]}catch(p){}z&&z.removeChild(C)}}if(e.dataType==="script"&&e.cache===null)e.cache=false;if(e.cache===\nfalse&&n==="GET"){var r=J(),u=e.url.replace(wb,"$1_="+r+"$2");e.url=u+(u===e.url?(ka.test(e.url)?"&":"?")+"_="+r:"")}if(e.data&&n==="GET")e.url+=(ka.test(e.url)?"&":"?")+e.data;e.global&&!c.active++&&c.event.trigger("ajaxStart");r=(r=xb.exec(e.url))&&(r[1]&&r[1]!==location.protocol||r[2]!==location.host);if(e.dataType==="script"&&n==="GET"&&r){var z=s.getElementsByTagName("head")[0]||s.documentElement,C=s.createElement("script");C.src=e.url;if(e.scriptCharset)C.charset=e.scriptCharset;if(!j){var B=\nfalse;C.onload=C.onreadystatechange=function(){if(!B&&(!this.readyState||this.readyState==="loaded"||this.readyState==="complete")){B=true;b();d();C.onload=C.onreadystatechange=null;z&&C.parentNode&&z.removeChild(C)}}}z.insertBefore(C,z.firstChild);return w}var E=false,x=e.xhr();if(x){e.username?x.open(n,e.url,e.async,e.username,e.password):x.open(n,e.url,e.async);try{if(e.data||a&&a.contentType)x.setRequestHeader("Content-Type",e.contentType);if(e.ifModified){c.lastModified[e.url]&&x.setRequestHeader("If-Modified-Since",\nc.lastModified[e.url]);c.etag[e.url]&&x.setRequestHeader("If-None-Match",c.etag[e.url])}r||x.setRequestHeader("X-Requested-With","XMLHttpRequest");x.setRequestHeader("Accept",e.dataType&&e.accepts[e.dataType]?e.accepts[e.dataType]+", */*":e.accepts._default)}catch(ga){}if(e.beforeSend&&e.beforeSend.call(k,x,e)===false){e.global&&!--c.active&&c.event.trigger("ajaxStop");x.abort();return false}e.global&&f("ajaxSend",[x,e]);var g=x.onreadystatechange=function(q){if(!x||x.readyState===0||q==="abort"){E||\nd();E=true;if(x)x.onreadystatechange=c.noop}else if(!E&&x&&(x.readyState===4||q==="timeout")){E=true;x.onreadystatechange=c.noop;i=q==="timeout"?"timeout":!c.httpSuccess(x)?"error":e.ifModified&&c.httpNotModified(x,e.url)?"notmodified":"success";var p;if(i==="success")try{o=c.httpData(x,e.dataType,e)}catch(v){i="parsererror";p=v}if(i==="success"||i==="notmodified")j||b();else c.handleError(e,x,i,p);d();q==="timeout"&&x.abort();if(e.async)x=null}};try{var h=x.abort;x.abort=function(){x&&h.call(x);\ng("abort")}}catch(l){}e.async&&e.timeout>0&&setTimeout(function(){x&&!E&&g("timeout")},e.timeout);try{x.send(n==="POST"||n==="PUT"||n==="DELETE"?e.data:null)}catch(m){c.handleError(e,x,null,m);d()}e.async||g();return x}},handleError:function(a,b,d,f){if(a.error)a.error.call(a.context||a,b,d,f);if(a.global)(a.context?c(a.context):c.event).trigger("ajaxError",[b,a,f])},active:0,httpSuccess:function(a){try{return!a.status&&location.protocol==="file:"||a.status>=200&&a.status<300||a.status===304||a.status===\n1223||a.status===0}catch(b){}return false},httpNotModified:function(a,b){var d=a.getResponseHeader("Last-Modified"),f=a.getResponseHeader("Etag");if(d)c.lastModified[b]=d;if(f)c.etag[b]=f;return a.status===304||a.status===0},httpData:function(a,b,d){var f=a.getResponseHeader("content-type")||"",e=b==="xml"||!b&&f.indexOf("xml")>=0;a=e?a.responseXML:a.responseText;e&&a.documentElement.nodeName==="parsererror"&&c.error("parsererror");if(d&&d.dataFilter)a=d.dataFilter(a,b);if(typeof a==="string")if(b===\n"json"||!b&&f.indexOf("json")>=0)a=c.parseJSON(a);else if(b==="script"||!b&&f.indexOf("javascript")>=0)c.globalEval(a);return a},param:function(a,b){function d(i,o){if(c.isArray(o))c.each(o,function(k,n){b||/\\[\\]$/.test(i)?f(i,n):d(i+"["+(typeof n==="object"||c.isArray(n)?k:"")+"]",n)});else!b&&o!=null&&typeof o==="object"?c.each(o,function(k,n){d(i+"["+k+"]",n)}):f(i,o)}function f(i,o){o=c.isFunction(o)?o():o;e[e.length]=encodeURIComponent(i)+"="+encodeURIComponent(o)}var e=[];if(b===w)b=c.ajaxSettings.traditional;\nif(c.isArray(a)||a.jquery)c.each(a,function(){f(this.name,this.value)});else for(var j in a)d(j,a[j]);return e.join("&").replace(yb,"+")}});var la={},Ab=/toggle|show|hide/,Bb=/^([+-]=)?([\\d+-.]+)(.*)$/,W,va=[["height","marginTop","marginBottom","paddingTop","paddingBottom"],["width","marginLeft","marginRight","paddingLeft","paddingRight"],["opacity"]];c.fn.extend({show:function(a,b){if(a||a===0)return this.animate(K("show",3),a,b);else{a=0;for(b=this.length;a<b;a++){var d=c.data(this[a],"olddisplay");\nthis[a].style.display=d||"";if(c.css(this[a],"display")==="none"){d=this[a].nodeName;var f;if(la[d])f=la[d];else{var e=c("<"+d+" />").appendTo("body");f=e.css("display");if(f==="none")f="block";e.remove();la[d]=f}c.data(this[a],"olddisplay",f)}}a=0;for(b=this.length;a<b;a++)this[a].style.display=c.data(this[a],"olddisplay")||"";return this}},hide:function(a,b){if(a||a===0)return this.animate(K("hide",3),a,b);else{a=0;for(b=this.length;a<b;a++){var d=c.data(this[a],"olddisplay");!d&&d!=="none"&&c.data(this[a],\n"olddisplay",c.css(this[a],"display"))}a=0;for(b=this.length;a<b;a++)this[a].style.display="none";return this}},_toggle:c.fn.toggle,toggle:function(a,b){var d=typeof a==="boolean";if(c.isFunction(a)&&c.isFunction(b))this._toggle.apply(this,arguments);else a==null||d?this.each(function(){var f=d?a:c(this).is(":hidden");c(this)[f?"show":"hide"]()}):this.animate(K("toggle",3),a,b);return this},fadeTo:function(a,b,d){return this.filter(":hidden").css("opacity",0).show().end().animate({opacity:b},a,d)},\nanimate:function(a,b,d,f){var e=c.speed(b,d,f);if(c.isEmptyObject(a))return this.each(e.complete);return this[e.queue===false?"each":"queue"](function(){var j=c.extend({},e),i,o=this.nodeType===1&&c(this).is(":hidden"),k=this;for(i in a){var n=i.replace(ia,ja);if(i!==n){a[n]=a[i];delete a[i];i=n}if(a[i]==="hide"&&o||a[i]==="show"&&!o)return j.complete.call(this);if((i==="height"||i==="width")&&this.style){j.display=c.css(this,"display");j.overflow=this.style.overflow}if(c.isArray(a[i])){(j.specialEasing=\nj.specialEasing||{})[i]=a[i][1];a[i]=a[i][0]}}if(j.overflow!=null)this.style.overflow="hidden";j.curAnim=c.extend({},a);c.each(a,function(r,u){var z=new c.fx(k,j,r);if(Ab.test(u))z[u==="toggle"?o?"show":"hide":u](a);else{var C=Bb.exec(u),B=z.cur(true)||0;if(C){u=parseFloat(C[2]);var E=C[3]||"px";if(E!=="px"){k.style[r]=(u||1)+E;B=(u||1)/z.cur(true)*B;k.style[r]=B+E}if(C[1])u=(C[1]==="-="?-1:1)*u+B;z.custom(B,u,E)}else z.custom(B,u,"")}});return true})},stop:function(a,b){var d=c.timers;a&&this.queue([]);\nthis.each(function(){for(var f=d.length-1;f>=0;f--)if(d[f].elem===this){b&&d[f](true);d.splice(f,1)}});b||this.dequeue();return this}});c.each({slideDown:K("show",1),slideUp:K("hide",1),slideToggle:K("toggle",1),fadeIn:{opacity:"show"},fadeOut:{opacity:"hide"}},function(a,b){c.fn[a]=function(d,f){return this.animate(b,d,f)}});c.extend({speed:function(a,b,d){var f=a&&typeof a==="object"?a:{complete:d||!d&&b||c.isFunction(a)&&a,duration:a,easing:d&&b||b&&!c.isFunction(b)&&b};f.duration=c.fx.off?0:typeof f.duration===\n"number"?f.duration:c.fx.speeds[f.duration]||c.fx.speeds._default;f.old=f.complete;f.complete=function(){f.queue!==false&&c(this).dequeue();c.isFunction(f.old)&&f.old.call(this)};return f},easing:{linear:function(a,b,d,f){return d+f*a},swing:function(a,b,d,f){return(-Math.cos(a*Math.PI)/2+0.5)*f+d}},timers:[],fx:function(a,b,d){this.options=b;this.elem=a;this.prop=d;if(!b.orig)b.orig={}}});c.fx.prototype={update:function(){this.options.step&&this.options.step.call(this.elem,this.now,this);(c.fx.step[this.prop]||\nc.fx.step._default)(this);if((this.prop==="height"||this.prop==="width")&&this.elem.style)this.elem.style.display="block"},cur:function(a){if(this.elem[this.prop]!=null&&(!this.elem.style||this.elem.style[this.prop]==null))return this.elem[this.prop];return(a=parseFloat(c.css(this.elem,this.prop,a)))&&a>-10000?a:parseFloat(c.curCSS(this.elem,this.prop))||0},custom:function(a,b,d){function f(j){return e.step(j)}this.startTime=J();this.start=a;this.end=b;this.unit=d||this.unit||"px";this.now=this.start;\nthis.pos=this.state=0;var e=this;f.elem=this.elem;if(f()&&c.timers.push(f)&&!W)W=setInterval(c.fx.tick,13)},show:function(){this.options.orig[this.prop]=c.style(this.elem,this.prop);this.options.show=true;this.custom(this.prop==="width"||this.prop==="height"?1:0,this.cur());c(this.elem).show()},hide:function(){this.options.orig[this.prop]=c.style(this.elem,this.prop);this.options.hide=true;this.custom(this.cur(),0)},step:function(a){var b=J(),d=true;if(a||b>=this.options.duration+this.startTime){this.now=\nthis.end;', '2012-11-07 18:41:40', 'admin', NULL);
INSERT INTO `editor_revisions` (`id`, `profile_id`, `item`, `contents`, `datetime`, `user`, `commit`) VALUES
(21, 1, '/var/www/_dev/manager/sql/tables.sql', '# ************************************************************\n# Sequel Pro SQL dump\n# Version 3408\n#\n# http://www.sequelpro.com/\n# http://code.google.com/p/sequel-pro/\n#\n# Host: localhost (MySQL 5.1.44)\n# Database: plexcloud\n# Generation Time: 2012-11-07 07:00:01 +0000\n# ************************************************************\n\n\n/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;\n/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;\n/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;\n/*!40101 SET NAMES utf8 */;\n/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;\n/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE=''NO_AUTO_VALUE_ON_ZERO'' */;\n/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;\n\n\n# Dump of table _files\n# ------------------------------------------------------------\n\nCREATE TABLE `_files` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `datetime` datetime DEFAULT NULL,\n  `filename` text,\n  `uploaded` int(1) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table _txn\n# ------------------------------------------------------------\n\nCREATE TABLE `_txn` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `datetime` datetime DEFAULT NULL,\n  `sql` text,\n  `done` int(1) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table account\n# ------------------------------------------------------------\n\nCREATE TABLE `account` (\n  `id` char(11) DEFAULT NULL,\n  `name` varchar(128) DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `is_header` varchar(10) DEFAULT NULL,\n  `is_subheader` varchar(10) DEFAULT NULL,\n  `is_bank` varchar(10) DEFAULT NULL,\n  `cash_postable` varchar(10) DEFAULT NULL,\n  `description` text,\n  `datetime` datetime DEFAULT NULL,\n  `opening_balance` decimal(20,2) DEFAULT NULL,\n  `balance` decimal(20,2) DEFAULT NULL,\n  `order` int(11) DEFAULT NULL,\n  `integrated` int(1) DEFAULT NULL,\n  `integration_type` varchar(128) DEFAULT NULL,\n  `default` int(1) DEFAULT NULL\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table account_transactions\n# ------------------------------------------------------------\n\nCREATE TABLE `account_transactions` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `journal` varchar(128) DEFAULT NULL,\n  `account_id` text,\n  `account_name` varchar(128) DEFAULT NULL,\n  `customer_id` int(11) DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `type` varchar(10) DEFAULT NULL,\n  `date` date DEFAULT NULL,\n  `reference` varchar(128) DEFAULT NULL,\n  `description` varchar(128) DEFAULT NULL,\n  `notes` varchar(128) DEFAULT NULL,\n  `group` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table applicants\n# ------------------------------------------------------------\n\nCREATE TABLE `applicants` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `vacancy_id` int(11) DEFAULT NULL,\n  `firstname` varchar(128) DEFAULT NULL,\n  `lastname` varchar(128) DEFAULT NULL,\n  `location` varchar(128) DEFAULT NULL,\n  `gender` varchar(10) DEFAULT NULL,\n  `dob` date DEFAULT NULL,\n  `phone` varchar(128) DEFAULT NULL,\n  `mobile` varchar(128) DEFAULT NULL,\n  `remarks` text,\n  `status` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table asset_depreciations\n# ------------------------------------------------------------\n\nCREATE TABLE `asset_depreciations` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `asset_id` int(11) DEFAULT NULL,\n  `date` date DEFAULT NULL,\n  `depreciation_amount` decimal(20,2) DEFAULT NULL,\n  `current_value` decimal(20,2) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table assets\n# ------------------------------------------------------------\n\nCREATE TABLE `assets` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `product_name` varchar(128) DEFAULT NULL,\n  `barcode` varchar(128) DEFAULT NULL,\n  `cost` decimal(20,2) DEFAULT NULL,\n  `current_cost` decimal(20,2) DEFAULT NULL,\n  `residual_cost` decimal(20,2) DEFAULT NULL,\n  `category` varchar(128) DEFAULT NULL,\n  `subcategory` varchar(128) DEFAULT NULL,\n  `in_service_date` datetime DEFAULT NULL,\n  `acquisition_date` datetime DEFAULT NULL,\n  `amortization_date` datetime DEFAULT NULL,\n  `evaluation_interval` int(11) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  `reference` varchar(128) DEFAULT NULL,\n  `pv_id` int(11) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table calendar\n# ------------------------------------------------------------\n\nCREATE TABLE `calendar` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `title` varchar(128) DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `location` varchar(128) DEFAULT NULL,\n  `allday` varchar(128) DEFAULT NULL,\n  `start` datetime DEFAULT NULL,\n  `end` datetime DEFAULT NULL,\n  `repeat` varchar(20) DEFAULT NULL,\n  `notes` text,\n  `user` varchar(128) DEFAULT NULL,\n  `priority` varchar(128) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  `assigned_by` varchar(128) DEFAULT NULL,\n  `division` varchar(128) DEFAULT NULL,\n  `new_to_user` int(1) DEFAULT ''1'',\n  `new_to_assigner` int(1) DEFAULT ''1'',\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table calendar_task_logs\n# ------------------------------------------------------------\n\nCREATE TABLE `calendar_task_logs` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `task_id` int(11) DEFAULT NULL,\n  `comments` text,\n  `hidden` int(11) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table campaign\n# ------------------------------------------------------------\n\nCREATE TABLE `campaign` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `assigned_to` text,\n  `division` varchar(128) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  `target_audience` varchar(128) DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `expected_close_date` date DEFAULT NULL,\n  `expected_open_date` date DEFAULT NULL,\n  `actual_open_date` date DEFAULT NULL,\n  `actual_close_date` date DEFAULT NULL,\n  `currency` varchar(128) DEFAULT NULL,\n  `sponsor` text,\n  `target_size` varchar(128) DEFAULT NULL,\n  `product` varchar(128) DEFAULT NULL,\n  `budget_cost` varchar(128) DEFAULT NULL,\n  `actual_cost` varchar(128) DEFAULT NULL,\n  `expected_response` varchar(128) DEFAULT NULL,\n  `expected_revenue` varchar(128) DEFAULT NULL,\n  `expected_sales_count` varchar(128) DEFAULT NULL,\n  `actual_sales_count` varchar(128) DEFAULT NULL,\n  `expected_response_count` varchar(128) DEFAULT NULL,\n  `actual_response_count` varchar(128) DEFAULT NULL,\n  `expected_roi` varchar(128) DEFAULT NULL,\n  `actual_roi` varchar(128) DEFAULT NULL,\n  `description` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table cash_count\n# ------------------------------------------------------------\n\nCREATE TABLE `cash_count` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `user_id` int(11) DEFAULT NULL,\n  `username` varchar(128) DEFAULT NULL,\n  `employee_id` int(11) DEFAULT NULL,\n  `employee_username` varchar(128) DEFAULT NULL,\n  `from` datetime DEFAULT NULL,\n  `to` datetime DEFAULT NULL,\n  `deposited` decimal(20,2) DEFAULT NULL,\n  `discrepancy` decimal(20,2) DEFAULT NULL,\n  `total_sales` decimal(20,2) DEFAULT NULL,\n  `total_items` int(11) DEFAULT NULL,\n  `ip_address` varchar(32) DEFAULT NULL,\n  `terminal` varchar(32) DEFAULT NULL,\n  `session` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table config\n# ------------------------------------------------------------\n\nCREATE TABLE `config` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `config` varchar(128) DEFAULT NULL,\n  `value` text,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table contact_cases\n# ------------------------------------------------------------\n\nCREATE TABLE `contact_cases` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `contact_id` int(11) DEFAULT NULL,\n  `subject` text,\n  `description` text,\n  `status` varchar(128) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  `log_date` datetime DEFAULT NULL,\n  `log_status` varchar(128) DEFAULT NULL,\n  `log_user` varchar(128) DEFAULT NULL,\n  `division_id` int(11) DEFAULT NULL,\n  `assigned_to` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table contact_logs\n# ------------------------------------------------------------\n\nCREATE TABLE `contact_logs` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `contact_id` int(11) DEFAULT NULL,\n  `case_id` int(11) DEFAULT NULL,\n  `subject` varchar(128) DEFAULT NULL,\n  `description` text,\n  `status` varchar(128) DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table contacts\n# ------------------------------------------------------------\n\nCREATE TABLE `contacts` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `is_customer` int(1) DEFAULT NULL,\n  `is_supplier` int(1) DEFAULT NULL,\n  `is_debtor` int(1) DEFAULT NULL,\n  `is_creditor` int(1) DEFAULT NULL,\n  `is_member` int(11) DEFAULT NULL,\n  `is_stakeholder` int(1) DEFAULT NULL,\n  `is_franchise` int(1) DEFAULT NULL,\n  `company_name` text,\n  `company_registration` varchar(32) DEFAULT NULL,\n  `contact_person` text,\n  `contact_number` varchar(128) DEFAULT NULL,\n  `credit_limit` float(20,2) DEFAULT NULL,\n  `rank` varchar(128) DEFAULT NULL,\n  `address1` varchar(128) DEFAULT NULL,\n  `address2` varchar(128) DEFAULT NULL,\n  `city` varchar(128) DEFAULT NULL,\n  `state` varchar(128) DEFAULT NULL,\n  `zipcode` varchar(32) DEFAULT NULL,\n  `country` varchar(128) DEFAULT NULL,\n  `tel` varchar(128) DEFAULT NULL,\n  `fax` varchar(128) DEFAULT NULL,\n  `general_email` varchar(128) DEFAULT NULL,\n  `email` varchar(128) DEFAULT NULL,\n  `ic` varchar(128) DEFAULT NULL,\n  `terms` text,\n  `description` text,\n  `remarks` text,\n  `tags` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  `user_type` varchar(128) DEFAULT NULL,\n  `user_verified` int(1) DEFAULT NULL,\n  `loyalty_points` int(11) DEFAULT NULL,\n  `password` varchar(128) DEFAULT NULL,\n  `introducer_ic` varchar(128) DEFAULT NULL,\n  `current_session` varchar(128) DEFAULT NULL,\n  `division_id` int(11) DEFAULT NULL,\n  `assigned_to` varchar(128) DEFAULT NULL,\n  `facebook_id` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table countries\n# ------------------------------------------------------------\n\nCREATE TABLE `countries` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `prefix` text,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table credit_cards\n# ------------------------------------------------------------\n\nCREATE TABLE `credit_cards` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `percentage` decimal(20,2) DEFAULT NULL,\n  `enabled` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table credit_note_items\n# ------------------------------------------------------------\n\nCREATE TABLE `credit_note_items` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `credit_note_id` int(11) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `item_id` int(11) DEFAULT NULL,\n  `discount` varchar(128) DEFAULT NULL,\n  `discount_type` varchar(128) DEFAULT NULL,\n  `qty` int(11) DEFAULT NULL,\n  `price_per_unit` decimal(20,4) DEFAULT NULL,\n  `price` decimal(20,2) DEFAULT NULL,\n  `cost` decimal(20,4) DEFAULT NULL,\n  `received` int(11) DEFAULT NULL,\n  `received_price` decimal(20,2) DEFAULT NULL,\n  `done` int(1) DEFAULT NULL,\n  `division_id` int(128) DEFAULT NULL,\n  `warehouse_id` int(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table credit_notes\n# ------------------------------------------------------------\n\nCREATE TABLE `credit_notes` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `dn_number` varchar(128) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `contact_person` varchar(128) DEFAULT NULL,\n  `received_date` datetime DEFAULT NULL,\n  `contact` varchar(128) DEFAULT NULL,\n  `contact_id` int(11) DEFAULT NULL,\n  `contact_address` text,\n  `delivery_address` text,\n  `terms` varchar(128) DEFAULT NULL,\n  `remarks` text,\n  `status` varchar(128) DEFAULT NULL,\n  `payment_status` varchar(128) DEFAULT NULL,\n  `payment_date` datetime DEFAULT NULL,\n  `payment_reference` varchar(128) DEFAULT NULL,\n  `payment_contra` varchar(128) DEFAULT NULL,\n  `receipt_no` varchar(128) DEFAULT NULL,\n  `handling_charges` decimal(20,2) DEFAULT NULL,\n  `adjustment` decimal(20,2) DEFAULT NULL,\n  `adjustment_type` varchar(32) DEFAULT NULL,\n  `total` decimal(20,2) DEFAULT NULL,\n  `total_received` decimal(20,2) DEFAULT NULL,\n  `tags` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(32) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(32) DEFAULT NULL,\n  `division_id` int(11) DEFAULT NULL,\n  `warehouse_id` int(11) DEFAULT NULL,\n  `assigned_to` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table customers\n# ------------------------------------------------------------\n\nCREATE TABLE `customers` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `company_name` varchar(128) DEFAULT NULL,\n  `reg_number` varchar(128) DEFAULT NULL,\n  `address` text,\n  `contact_person` varchar(128) DEFAULT NULL,\n  `contact_no` varchar(128) DEFAULT NULL,\n  `credit_limit` decimal(20,2) DEFAULT NULL,\n  `status` varchar(32) DEFAULT NULL,\n  `remarks` text,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table debit_note_items\n# ------------------------------------------------------------\n\nCREATE TABLE `debit_note_items` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `debit_note_id` int(11) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `item_id` int(11) DEFAULT NULL,\n  `discount` varchar(128) DEFAULT NULL,\n  `discount_type` varchar(128) DEFAULT NULL,\n  `qty` int(11) DEFAULT NULL,\n  `price_per_unit` decimal(20,4) DEFAULT NULL,\n  `price` decimal(20,2) DEFAULT NULL,\n  `received` int(11) DEFAULT NULL,\n  `received_price` float(20,2) DEFAULT NULL,\n  `done` int(1) DEFAULT NULL,\n  `division_id` int(11) DEFAULT NULL,\n  `warehouse_id` int(11) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table debit_notes\n# ------------------------------------------------------------\n\nCREATE TABLE `debit_notes` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `cn_number` varchar(128) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `contact_person` varchar(128) DEFAULT NULL,\n  `received_date` datetime DEFAULT NULL,\n  `supplier` varchar(128) DEFAULT NULL,\n  `supplier_id` int(11) DEFAULT NULL,\n  `supplier_address` text,\n  `delivery_address` text,\n  `terms` varchar(128) DEFAULT NULL,\n  `remarks` text,\n  `status` varchar(128) DEFAULT NULL,\n  `payment_status` varchar(128) DEFAULT NULL,\n  `payment_reference` varchar(128) DEFAULT NULL,\n  `payment_date` datetime DEFAULT NULL,\n  `payment_contra` varchar(128) DEFAULT NULL,\n  `receipt_no` varchar(128) DEFAULT NULL,\n  `handling_charges` decimal(20,2) DEFAULT NULL,\n  `adjustment` decimal(20,2) DEFAULT NULL,\n  `adjustment_type` varchar(32) DEFAULT NULL,\n  `total` decimal(20,2) DEFAULT NULL,\n  `total_received` decimal(20,2) DEFAULT NULL,\n  `tags` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(32) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(32) DEFAULT NULL,\n  `division_id` int(11) DEFAULT NULL,\n  `warehouse_id` int(11) DEFAULT NULL,\n  `assigned_to` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table department\n# ------------------------------------------------------------\n\nCREATE TABLE `department` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `description` text,\n  `company_name` varchar(128) DEFAULT NULL,\n  `company_registration` varchar(128) DEFAULT NULL,\n  `logo` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table disposal_appreciation\n# ------------------------------------------------------------\n\nCREATE TABLE `disposal_appreciation` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `asset_id` int(11) DEFAULT NULL,\n  `asset_name` varchar(128) DEFAULT NULL,\n  `asset_category` varchar(128) DEFAULT NULL,\n  `asset_subcategory` varchar(128) DEFAULT NULL,\n  `value_on_disposal` decimal(20,2) DEFAULT NULL,\n  `disposed_value` decimal(20,2) DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table disposal_depreciation\n# ------------------------------------------------------------\n\nCREATE TABLE `disposal_depreciation` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `asset_id` int(11) DEFAULT NULL,\n  `asset_name` varchar(128) DEFAULT NULL,\n  `asset_category` varchar(128) DEFAULT NULL,\n  `asset_subcategory` varchar(128) DEFAULT NULL,\n  `value_on_disposal` decimal(20,2) DEFAULT NULL,\n  `disposed_value` decimal(20,2) DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table editor_live_contents\n# ------------------------------------------------------------\n\nCREATE TABLE `editor_live_contents` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `profile_id` int(11) DEFAULT NULL,\n  `item` text,\n  `contents` text,\n  `datetime` datetime DEFAULT NULL,\n  `username` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table editor_profiles\n# ------------------------------------------------------------\n\nCREATE TABLE `editor_profiles` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `hostname` varchar(128) DEFAULT NULL,\n  `linker_file` text,\n  `api_key` varchar(128) DEFAULT NULL,\n  `root_url` text,\n  `root_path` varchar(128) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table editor_revisions\n# ------------------------------------------------------------\n\nCREATE TABLE `editor_revisions` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `profile_id` int(11) DEFAULT NULL,\n  `item` text,\n  `contents` text,\n  `datetime` datetime DEFAULT NULL,\n  `user` varchar(128) DEFAULT NULL,\n  `commit` int(1) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table editor_sessions\n# ------------------------------------------------------------\n\nCREATE TABLE `editor_sessions` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `profile_id` int(11) DEFAULT NULL,\n  `username` varchar(128) DEFAULT NULL,\n  `last_change` varchar(128) DEFAULT NULL,\n  `item` text,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table email_notifications\n# ------------------------------------------------------------\n\nCREATE TABLE `email_notifications` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `contact_id` int(11) DEFAULT NULL,\n  `contact_email` varchar(128) DEFAULT NULL,\n  `module` varchar(128) DEFAULT NULL,\n  `transaction` varchar(128) DEFAULT NULL,\n  `transaction_id` int(11) DEFAULT NULL,\n  `remarks` text,\n  `datetime` datetime DEFAULT NULL,\n  `subject` text,\n  `message` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=InnoDB DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table employee_cico\n# ------------------------------------------------------------\n\nCREATE TABLE `employee_cico` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `employee_id` int(11) DEFAULT NULL,\n  `check_in` datetime DEFAULT NULL,\n  `check_out` datetime DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table employee_dependents\n# ------------------------------------------------------------\n\nCREATE TABLE `employee_dependents` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `employee_id` int(11) DEFAULT NULL,\n  `name` varchar(128) DEFAULT NULL,\n  `relationship` varchar(128) DEFAULT NULL,\n  `dob` date DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table employee_documents\n# ------------------------------------------------------------\n\nCREATE TABLE `employee_documents` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `employee_id` int(11) DEFAULT NULL,\n  `filename` varchar(128) DEFAULT NULL,\n  `filetype` varchar(32) DEFAULT NULL,\n  `size` varchar(64) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table employee_education\n# ------------------------------------------------------------\n\nCREATE TABLE `employee_education` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `employee_id` int(11) DEFAULT NULL,\n  `education` varchar(128) DEFAULT NULL,\n  `major` varchar(128) DEFAULT NULL,\n  `year` varchar(4) DEFAULT NULL,\n  `gpa_score` varchar(128) DEFAULT NULL,\n  `start_date` varchar(128) DEFAULT NULL,\n  `end_date` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table employee_emergency_contacts\n# ------------------------------------------------------------\n\nCREATE TABLE `employee_emergency_contacts` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `employee_id` int(11) DEFAULT NULL,\n  `name` varchar(128) DEFAULT NULL,\n  `relationship` varchar(128) DEFAULT NULL,\n  `home_phone` varchar(128) DEFAULT NULL,\n  `mobile` varchar(128) DEFAULT NULL,\n  `work_phone` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table employee_languages\n# ------------------------------------------------------------\n\nCREATE TABLE `employee_languages` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `employee_id` int(11) DEFAULT NULL,\n  `language` varchar(128) DEFAULT NULL,\n  `fluency` varchar(128) DEFAULT NULL,\n  `competency` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table employee_licenses\n# ------------------------------------------------------------\n\nCREATE TABLE `employee_licenses` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `employee_id` int(11) DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `start_date` varchar(128) DEFAULT NULL,\n  `end_date` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table employee_skills\n# ------------------------------------------------------------\n\nCREATE TABLE `employee_skills` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `employee_id` int(11) DEFAULT NULL,\n  `skill` varchar(128) DEFAULT NULL,\n  `years_of_experience` int(11) DEFAULT NULL,\n  `remarks` text,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table employee_work_experience\n# ------------------------------------------------------------\n\nCREATE TABLE `employee_work_experience` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `employee_id` varchar(128) DEFAULT NULL,\n  `employer` varchar(128) DEFAULT NULL,\n  `start_date` date DEFAULT NULL,\n  `end_date` date DEFAULT NULL,\n  `job_title` varchar(128) DEFAULT NULL,\n  `remarks` varchar(128) DEFAULT NULL,\n  `internal` tinyint(4) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table employees\n# ------------------------------------------------------------\n\nCREATE TABLE `employees` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `username` varchar(128) DEFAULT NULL,\n  `password` varchar(128) DEFAULT NULL,\n  `firstname` varchar(128) DEFAULT NULL,\n  `lastname` varchar(128) DEFAULT NULL,\n  `gender` varchar(128) DEFAULT NULL,\n  `nationality` varchar(128) DEFAULT NULL,\n  `dob` date DEFAULT NULL,\n  `marital_status` varchar(128) DEFAULT NULL,\n  `race` varchar(128) DEFAULT NULL,\n  `ic_no` varchar(128) DEFAULT NULL,\n  `photo` text,\n  `address1` text,\n  `address2` text,\n  `city` varchar(128) DEFAULT NULL,\n  `stateprov` varchar(128) DEFAULT NULL,\n  `zipcode` varchar(128) DEFAULT NULL,\n  `country` varchar(128) DEFAULT NULL,\n  `session` int(1) DEFAULT NULL,\n  `active` int(1) DEFAULT NULL,\n  `home_phone` varchar(128) DEFAULT NULL,\n  `mobile` varchar(128) DEFAULT NULL,\n  `work_phone` varchar(128) DEFAULT NULL,\n  `work_email` varchar(128) DEFAULT NULL,\n  `other_email` varchar(128) DEFAULT NULL,\n  `employment_start_date` datetime DEFAULT NULL,\n  `employment_end_date` datetime DEFAULT NULL,\n  `type` varchar(32) DEFAULT NULL,\n  `division` varchar(128) DEFAULT NULL,\n  `ip_address` varchar(32) DEFAULT NULL,\n  `last_login` datetime DEFAULT NULL,\n  `last_logout` datetime DEFAULT NULL,\n  `remarks` text,\n  `status` varchar(32) DEFAULT NULL,\n  `tags` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  `position` varchar(32) DEFAULT NULL,\n  `is_manager` int(1) DEFAULT NULL,\n  `is_cashier` int(1) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table employment\n# ------------------------------------------------------------\n\nCREATE TABLE `employment` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `employee_id` int(11) DEFAULT NULL,\n  `job_title` varchar(128) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  `date` date DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `pay_grade` varchar(128) DEFAULT NULL,\n  `pay_frequency` varchar(128) DEFAULT NULL,\n  `minimum_salary` decimal(20,2) DEFAULT NULL,\n  `maximum_salary` decimal(20,2) DEFAULT NULL,\n  `basic_salary` decimal(20,2) DEFAULT NULL,\n  `division` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table fifo\n# ------------------------------------------------------------\n\nCREATE TABLE `fifo` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `item_id` int(11) DEFAULT NULL,\n  `po_item_id` int(11) DEFAULT NULL,\n  `po_id` int(11) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  `cost` decimal(20,2) DEFAULT NULL,\n  `from_qty` int(11) DEFAULT NULL,\n  `to_qty` int(11) DEFAULT NULL,\n  `qty` int(11) DEFAULT NULL,\n  `done` int(1) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table fnb_buffer_sale_items\n# ------------------------------------------------------------\n\nCREATE TABLE `fnb_buffer_sale_items` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `date` datetime DEFAULT NULL,\n  `sale_id` int(11) DEFAULT NULL,\n  `item_id` int(11) DEFAULT NULL,\n  `item_sku` varchar(128) DEFAULT NULL,\n  `item_name` varchar(128) DEFAULT NULL,\n  `item_option` varchar(128) DEFAULT NULL,\n  `qty` int(11) DEFAULT NULL,\n  `price_per_unit` float(10,2) DEFAULT NULL,\n  `margin` float(10,4) DEFAULT NULL,\n  `cost` float(10,4) DEFAULT NULL,\n  `amount` float(10,2) DEFAULT NULL,\n  `sold` int(11) DEFAULT NULL,\n  `terminal` varchar(32) DEFAULT NULL,\n  `printed` int(1) DEFAULT NULL,\n  `session` varchar(128) DEFAULT NULL,\n  `ordered_by` varchar(128) DEFAULT NULL,\n  `ordered_time` datetime DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table fnb_buffer_sales\n# ------------------------------------------------------------\n\nCREATE TABLE `fnb_buffer_sales` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `table_no` varchar(128) DEFAULT NULL,\n  `user_id` int(11) DEFAULT NULL,\n  `username` varchar(128) DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  `payment_status` varchar(128) DEFAULT NULL,\n  `cost` float(10,4) DEFAULT NULL,\n  `amount` float(10,2) DEFAULT NULL,\n  `amount_tendered` float(10,2) DEFAULT NULL,\n  `amount_change` float(10,2) DEFAULT NULL,\n  `payment_method` varchar(128) DEFAULT NULL,\n  `payment_details` text,\n  `terminal` varchar(32) DEFAULT NULL,\n  `session` varchar(128) DEFAULT NULL,\n  `discount` float DEFAULT NULL,\n  `payment` text,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table fnb_cash_count\n# ------------------------------------------------------------\n\nCREATE TABLE `fnb_cash_count` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `employee_id` int(11) DEFAULT NULL,\n  `employee_username` varchar(128) DEFAULT NULL,\n  `from` datetime DEFAULT NULL,\n  `to` datetime DEFAULT NULL,\n  `deposited` float(10,2) DEFAULT NULL,\n  `discrepancy` float(10,2) DEFAULT NULL,\n  `total_sales` float(10,2) DEFAULT NULL,\n  `total_items` int(11) DEFAULT NULL,\n  `ip_address` varchar(32) DEFAULT NULL,\n  `terminal` varchar(32) DEFAULT NULL,\n  `session` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table fnb_delivery_order_items\n# ------------------------------------------------------------\n\nCREATE TABLE `fnb_delivery_order_items` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `datetime` datetime DEFAULT NULL,\n  `order_id` int(11) DEFAULT NULL,\n  `item_id` int(11) DEFAULT NULL,\n  `item_sku` varchar(128) DEFAULT NULL,\n  `item_name` varchar(128) DEFAULT NULL,\n  `item_option` varchar(128) DEFAULT NULL,\n  `qty` int(11) DEFAULT NULL,\n  `price_per_unit` float(10,2) DEFAULT NULL,\n  `margin` float(10,4) DEFAULT NULL,\n  `cost` float(10,4) DEFAULT NULL,\n  `amount` float(10,2) DEFAULT NULL,\n  `sold` int(11) DEFAULT NULL,\n  `terminal` varchar(32) DEFAULT NULL,\n  `printed` int(1) DEFAULT NULL,\n  `session` varchar(128) DEFAULT NULL,\n  `ordered_by` varchar(128) DEFAULT NULL,\n  `ordered_time` datetime DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table fnb_delivery_orders\n# ------------------------------------------------------------\n\nCREATE TABLE `fnb_delivery_orders` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `datetime` datetime DEFAULT NULL,\n  `session` varchar(128) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  `order_data` text,\n  `type` varchar(128) DEFAULT NULL,\n  `payment_status` varchar(128) DEFAULT NULL,\n  `amount_tendered` decimal(20,2) DEFAULT NULL,\n  `amount_change` decimal(20,2) DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `payment_method` varchar(128) DEFAULT NULL,\n  `online` int(1) DEFAULT NULL,\n  `discount` varchar(128) NOT NULL DEFAULT '''',\n  `customer_id` int(11) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table fnb_inventory\n# ------------------------------------------------------------\n\nCREATE TABLE `fnb_inventory` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `category` varchar(128) DEFAULT NULL,\n  `subcategory` varchar(128) DEFAULT NULL,\n  `location` varchar(128) DEFAULT NULL,\n  `name` varchar(128) DEFAULT NULL,\n  `sku` varchar(128) DEFAULT NULL,\n  `qty` int(11) DEFAULT ''0'',\n  `cost` float(10,4) NOT NULL,\n  `item_price` float(10,2) DEFAULT NULL,\n  `price` text,\n  `options` text,\n  `description` text,\n  `supplier` varchar(128) DEFAULT NULL,\n  `remarks` text,\n  `is_active` varchar(10) DEFAULT NULL,\n  `is_consigned` varchar(10) DEFAULT NULL,\n  `alert_quantity` int(11) DEFAULT NULL,\n  `max_quantity` int(11) DEFAULT NULL,\n  `ordered_quantity` int(11) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  `quick` int(1) DEFAULT NULL,\n  `enter_price` int(1) DEFAULT NULL,\n  `order` int(11) DEFAULT NULL,\n  `category_order` int(11) DEFAULT NULL,\n  `iphone` int(1) DEFAULT NULL,\n  `grouped` int(1) DEFAULT NULL,\n  `printer` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table fnb_printer_map\n# ------------------------------------------------------------\n\nCREATE TABLE `fnb_printer_map` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `categories` text,\n  `subcategories` text,\n  `printer_ip` varchar(32) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table fnb_reverts\n# ------------------------------------------------------------\n\nCREATE TABLE `fnb_reverts` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `performed_by` varchar(128) DEFAULT NULL,\n  `data` text,\n  `datetime` datetime DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=InnoDB DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table fnb_sale_items\n# ------------------------------------------------------------\n\nCREATE TABLE `fnb_sale_items` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `date` datetime DEFAULT NULL,\n  `sale_id` int(11) DEFAULT NULL,\n  `item_id` int(11) DEFAULT NULL,\n  `item_sku` varchar(128) DEFAULT NULL,\n  `item_name` varchar(128) DEFAULT NULL,\n  `item_option` varchar(128) DEFAULT NULL,\n  `qty` int(11) DEFAULT NULL,\n  `price_per_unit` float(10,2) DEFAULT NULL,\n  `margin` float(10,4) DEFAULT NULL,\n  `cost` float(10,4) DEFAULT NULL,\n  `amount` float(10,2) DEFAULT NULL,\n  `sold` int(11) DEFAULT NULL,\n  `terminal` varchar(32) DEFAULT NULL,\n  `printed` int(1) DEFAULT NULL,\n  `session` varchar(128) DEFAULT NULL,\n  `ordered_by` varchar(128) DEFAULT NULL,\n  `ordered_time` datetime DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table fnb_sales\n# ------------------------------------------------------------\n\nCREATE TABLE `fnb_sales` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `table_no` varchar(128) DEFAULT NULL,\n  `user_id` int(11) DEFAULT NULL,\n  `username` varchar(128) DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  `payment_status` varchar(128) DEFAULT NULL,\n  `cost` float(10,4) DEFAULT NULL,\n  `amount` float(10,2) DEFAULT NULL,\n  `amount_tendered` float(10,2) DEFAULT NULL,\n  `amount_change` float(10,2) DEFAULT NULL,\n  `payment_method` varchar(128) DEFAULT NULL,\n  `payment_details` text,\n  `terminal` varchar(32) DEFAULT NULL,\n  `session` varchar(128) DEFAULT NULL,\n  `discount` float DEFAULT NULL,\n  `payment` text,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table im\n# ------------------------------------------------------------\n\nCREATE TABLE `im` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `subject` varchar(128) DEFAULT NULL,\n  `division` varchar(128) DEFAULT NULL,\n  `priority` varchar(128) DEFAULT NULL,\n  `from` varchar(128) DEFAULT NULL,\n  `to` varchar(128) DEFAULT NULL,\n  `message` text,\n  `user_copy` int(1) DEFAULT ''0'',\n  `datetime` datetime DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table inventory\n# ------------------------------------------------------------\n\nCREATE TABLE `inventory` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `primary_image` text,\n  `image` text,\n  `category` varchar(128) DEFAULT NULL,\n  `subcategory` varchar(128) DEFAULT NULL,\n  `brand` varchar(128) DEFAULT NULL,\n  `location` varchar(128) DEFAULT NULL,\n  `name` varchar(128) DEFAULT NULL,\n  `model_no` varchar(128) DEFAULT NULL,\n  `warranty` varchar(128) DEFAULT NULL,\n  `sku` varchar(128) DEFAULT NULL,\n  `sku2` varchar(128) DEFAULT NULL,\n  `sku3` varchar(128) DEFAULT NULL,\n  `sku4` varchar(128) DEFAULT NULL,\n  `qty` int(11) DEFAULT ''0'',\n  `alert_quantity` int(11) DEFAULT NULL,\n  `max_quantity` int(11) DEFAULT NULL,\n  `cost` decimal(10,4) NOT NULL,\n  `average_cost` decimal(10,4) DEFAULT NULL,\n  `price` decimal(10,2) DEFAULT NULL,\n  `price_2` decimal(10,2) DEFAULT NULL,\n  `price_3` decimal(10,2) DEFAULT NULL,\n  `price2` decimal(10,2) DEFAULT NULL,\n  `price2_2` decimal(10,2) DEFAULT NULL,\n  `price2_3` decimal(10,2) DEFAULT NULL,\n  `price3` decimal(10,2) DEFAULT NULL,\n  `price3_2` decimal(10,2) DEFAULT NULL,\n  `price3_3` decimal(10,2) DEFAULT NULL,\n  `price4` decimal(10,2) DEFAULT NULL,\n  `price4_2` decimal(10,2) DEFAULT NULL,\n  `price4_3` decimal(10,2) DEFAULT NULL,\n  `description` text,\n  `supplier` varchar(128) DEFAULT NULL,\n  `remarks` text,\n  `ordered_quantity` int(11) DEFAULT NULL,\n  `is_active` varchar(10) DEFAULT NULL,\n  `is_consigned` varchar(10) DEFAULT NULL,\n  `quick` int(1) DEFAULT NULL,\n  `adjust_cost` int(1) NOT NULL DEFAULT ''0'',\n  `enter_price` int(1) DEFAULT ''0'',\n  `enter_serial` int(1) DEFAULT NULL,\n  `tags` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  `redeemable` int(1) DEFAULT NULL,\n  `redeem_points` int(11) DEFAULT NULL,\n  `current_po` int(11) DEFAULT NULL,\n  `current_po_item` int(11) DEFAULT NULL,\n  `uom1` varchar(128) DEFAULT NULL,\n  `uom2` varchar(128) DEFAULT NULL,\n  `uom3` varchar(128) DEFAULT NULL,\n  `uom4` varchar(128) DEFAULT NULL,\n  `loose_qty2` int(11) DEFAULT NULL,\n  `loose_qty3` int(11) DEFAULT NULL,\n  `loose_qty4` int(11) DEFAULT NULL,\n  `weight` decimal(20,2) DEFAULT NULL,\n  `weight_unit` varchar(10) DEFAULT NULL,\n  `volume` decimal(20,2) DEFAULT NULL,\n  `volume_unit` varchar(10) DEFAULT NULL,\n  `min_cart_qty` int(10) DEFAULT NULL,\n  `max_cart_qty` int(10) DEFAULT NULL,\n  `ready_for_sale` int(1) DEFAULT NULL,\n  `last_sold` datetime DEFAULT NULL,\n  `isbn` varchar(128) DEFAULT NULL,\n  `links` text,\n  `linked` text,\n  `author` text,\n  `publisher` varchar(128) DEFAULT NULL,\n  `lastchange` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table inventory_stock_quantities\n# ------------------------------------------------------------\n\nCREATE TABLE `inventory_stock_quantities` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `item_id` int(11) DEFAULT NULL,\n  `item_sku` varchar(128) DEFAULT NULL,\n  `warehouse_id` int(11) DEFAULT NULL,\n  `qty` int(11) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table invoice_items\n# ------------------------------------------------------------\n\nCREATE TABLE `invoice_items` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `invoice_id` int(11) DEFAULT NULL,\n  `type` varchar(32) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `item_name` text,\n  `item_description` text,\n  `item_id` int(11) DEFAULT NULL,\n  `service_id` int(11) DEFAULT NULL,\n  `item_sku` varchar(128) DEFAULT NULL,\n  `discount` varchar(128) DEFAULT NULL,\n  `discount_type` varchar(128) DEFAULT NULL,\n  `qty` int(11) DEFAULT NULL,\n  `price_per_unit` decimal(20,4) DEFAULT NULL,\n  `price` decimal(20,2) DEFAULT NULL,\n  `cost` decimal(20,2) DEFAULT NULL,\n  `margin` decimal(20,2) DEFAULT NULL,\n  `delivered` int(11) DEFAULT NULL,\n  `delivered_price` decimal(20,2) DEFAULT NULL,\n  `done` int(1) DEFAULT NULL,\n  `no_do` int(1) DEFAULT NULL,\n  `division_id` int(11) DEFAULT NULL,\n  `warehouse_id` int(11) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table invoices\n# ------------------------------------------------------------\n\nCREATE TABLE `invoices` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `quote_id` int(11) DEFAULT NULL,\n  `sales_order_id` int(11) DEFAULT NULL,\n  `number` varchar(128) DEFAULT NULL,\n  `po_number` varchar(128) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `due_date` datetime DEFAULT NULL,\n  `received_date` datetime DEFAULT NULL,\n  `contact_person` varchar(128) DEFAULT NULL,\n  `contact` varchar(128) DEFAULT NULL,\n  `contact_id` int(11) DEFAULT NULL,\n  `contact_address` text,\n  `delivery_address` text,\n  `delivery_tracking_no` varchar(128) DEFAULT NULL,\n  `delivery_status` varchar(128) DEFAULT NULL,\n  `delivery_date` datetime DEFAULT NULL,\n  `shipping` varchar(128) DEFAULT NULL,\n  `shipping_id` int(11) DEFAULT NULL,\n  `terms` varchar(128) DEFAULT NULL,\n  `duration` int(11) DEFAULT NULL,\n  `remarks` text,\n  `status` varchar(128) DEFAULT NULL,\n  `payment_status` varchar(128) DEFAULT NULL,\n  `payment_date` datetime DEFAULT NULL,\n  `payment_reference` varchar(128) DEFAULT NULL,\n  `payment_contra` varchar(128) DEFAULT NULL,\n  `receipt_no` varchar(128) DEFAULT NULL,\n  `handling_charges` decimal(20,2) DEFAULT NULL,\n  `adjustment` decimal(20,2) DEFAULT NULL,\n  `adjustment_type` varchar(32) DEFAULT NULL,\n  `total` decimal(20,2) DEFAULT NULL,\n  `total_delivered` decimal(20,2) DEFAULT NULL,\n  `cost` decimal(20,2) DEFAULT NULL,\n  `tags` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(32) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(32) DEFAULT NULL,\n  `no_do` int(1) DEFAULT NULL,\n  `amount_cash` decimal(20,2) DEFAULT NULL,\n  `amount_cc` decimal(20,2) DEFAULT NULL,\n  `amount_cheque` decimal(20,2) DEFAULT NULL,\n  `amount_credit` decimal(20,2) DEFAULT NULL,\n  `paid_cash` int(1) DEFAULT NULL,\n  `paid_cc` int(1) DEFAULT NULL,\n  `paid_cheque` int(1) DEFAULT NULL,\n  `paid_credit` int(1) DEFAULT NULL,\n  `tax` text,\n  `total_tax` double(20,2) DEFAULT NULL,\n  `sales_reference_id` int(11) DEFAULT NULL,\n  `division_id` int(11) DEFAULT NULL,\n  `warehouse_id` int(11) DEFAULT NULL,\n  `assigned_to` int(11) DEFAULT NULL,\n  `notification` text,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table jobsheet\n# ------------------------------------------------------------\n\nCREATE TABLE `jobsheet` (\n  `id` int(11) DEFAULT NULL,\n  `job` varchar(128) DEFAULT NULL,\n  `department` varchar(128) DEFAULT NULL,\n  `priority` varchar(128) DEFAULT NULL,\n  `deadline` datetime DEFAULT NULL,\n  `start` datetime DEFAULT NULL,\n  `end` datetime DEFAULT NULL,\n  `note` text,\n  `user` varchar(128) DEFAULT NULL,\n  `assignee` varchar(128) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table journal\n# ------------------------------------------------------------\n\nCREATE TABLE `journal` (\n  `id` int(11) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `journal` varchar(128) DEFAULT NULL,\n  `ref` varchar(128) DEFAULT NULL,\n  `description` varchar(128) DEFAULT NULL,\n  `credit_to` varchar(128) DEFAULT NULL,\n  `debit_to` varchar(128) DEFAULT NULL,\n  `currency` varchar(5) DEFAULT NULL,\n  `amount` varchar(128) DEFAULT NULL\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table leads\n# ------------------------------------------------------------\n\nCREATE TABLE `leads` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `firstname` varchar(128) DEFAULT NULL,\n  `lastname` varchar(128) DEFAULT NULL,\n  `company` varchar(128) DEFAULT NULL,\n  `title` varchar(128) DEFAULT NULL,\n  `phone` varchar(128) DEFAULT NULL,\n  `mobile` varchar(128) DEFAULT NULL,\n  `fax` varchar(128) DEFAULT NULL,\n  `email` varchar(128) DEFAULT NULL,\n  `assigned_to` text,\n  `division` varchar(128) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  `source` varchar(128) DEFAULT NULL,\n  `campaign` varchar(128) DEFAULT NULL,\n  `campaign_name` varchar(128) DEFAULT NULL,\n  `address1` varchar(128) DEFAULT NULL,\n  `address2` varchar(128) DEFAULT NULL,\n  `city` varchar(128) DEFAULT NULL,\n  `zipcode` varchar(128) DEFAULT NULL,\n  `state` varchar(128) DEFAULT NULL,\n  `country` varchar(128) DEFAULT NULL,\n  `web` varchar(128) DEFAULT NULL,\n  `description` varchar(128) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table leave\n# ------------------------------------------------------------\n\nCREATE TABLE `leave` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `employee_id` int(11) DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `from` date DEFAULT NULL,\n  `to` date DEFAULT NULL,\n  `remarks` text,\n  `status` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table license\n# ------------------------------------------------------------\n\nCREATE TABLE `license` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `date_form` datetime DEFAULT NULL,\n  `date_to` double DEFAULT NULL,\n  `key` varchar(128) DEFAULT NULL,\n  `vkey` varchar(128) DEFAULT NULL,\n  `count` int(11) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table manufacturing_order\n# ------------------------------------------------------------\n\nCREATE TABLE `manufacturing_order` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `customer_id` int(11) DEFAULT NULL,\n  `customer` varchar(128) DEFAULT NULL,\n  `product_name` varchar(128) DEFAULT NULL,\n  `bom_id` int(11) DEFAULT NULL,\n  `quantity` int(11) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  `progress_date` datetime DEFAULT NULL,\n  `actual_progress_date` datetime DEFAULT NULL,\n  `remarks` text,\n  `end_date` datetime DEFAULT NULL,\n  `actual_end_date` datetime DEFAULT NULL,\n  `actual_quantity` int(11) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table manufacturing_order_components\n# ------------------------------------------------------------\n\nCREATE TABLE `manufacturing_order_components` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `component_id` int(11) DEFAULT NULL,\n  `raw_material_id` int(11) DEFAULT NULL,\n  `name` varchar(128) DEFAULT NULL,\n  `uom` varchar(128) DEFAULT NULL,\n  `remarks` text,\n  `shelf_life` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table members\n# ------------------------------------------------------------\n\nCREATE TABLE `members` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `nric` varchar(32) DEFAULT NULL,\n  `email` varchar(128) DEFAULT NULL,\n  `tel` varchar(11) DEFAULT NULL,\n  `address1` text,\n  `address2` text,\n  `zipcode` varchar(128) DEFAULT NULL,\n  `points` int(11) DEFAULT NULL,\n  `added_on` varchar(32) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `added_by` varchar(32) DEFAULT NULL,\n  `modified_by` varchar(32) DEFAULT NULL,\n  `remarks` text,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table menu_items\n# ------------------------------------------------------------\n\nCREATE TABLE `menu_items` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `category` varchar(128) DEFAULT NULL,\n  `subcategory` varchar(128) DEFAULT NULL,\n  `location` varchar(128) DEFAULT NULL,\n  `name` varchar(128) DEFAULT NULL,\n  `sku` varchar(128) DEFAULT NULL,\n  `qty` int(11) DEFAULT ''0'',\n  `cost` float(10,4) NOT NULL,\n  `item_price` float(10,2) DEFAULT NULL,\n  `price` text,\n  `options` text,\n  `description` text,\n  `supplier` varchar(128) DEFAULT NULL,\n  `remarks` text,\n  `is_active` varchar(10) DEFAULT NULL,\n  `is_consigned` varchar(10) DEFAULT NULL,\n  `alert_quantity` int(11) DEFAULT NULL,\n  `max_quantity` int(11) DEFAULT NULL,\n  `ordered_quantity` int(11) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  `quick` int(1) DEFAULT NULL,\n  `enter_price` int(1) DEFAULT NULL,\n  `order` int(11) DEFAULT NULL,\n  `category_order` int(11) DEFAULT NULL,\n  `iphone` int(1) DEFAULT NULL,\n  `grouped` int(1) DEFAULT NULL,\n  `printer` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table menu_printer_map\n# ------------------------------------------------------------\n\nCREATE TABLE `menu_printer_map` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `categories` tinytext,\n  `printer_ip` varchar(32) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table modules\n# ------------------------------------------------------------\n\nCREATE TABLE `modules` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `controller_name` varchar(128) DEFAULT NULL,\n  `tables` text,\n  `common` varchar(128) DEFAULT NULL,\n  `core` int(1) DEFAULT NULL,\n  `actions` text,\n  `action_names` text,\n  `override` int(1) DEFAULT NULL,\n  `enabled` int(11) DEFAULT NULL,\n  `dependencies` text,\n  `custom_user_field` text,\n  `custom_user_field_name` text,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table notifications\n# ------------------------------------------------------------\n\nCREATE TABLE `notifications` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `module` varchar(128) DEFAULT NULL,\n  `user` varchar(128) DEFAULT NULL,\n  `description` text,\n  `link` text,\n  `status` varchar(128) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  `viewed_datetime` datetime DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table payment_gateways\n# ------------------------------------------------------------\n\nCREATE TABLE `payment_gateways` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `namespace` varchar(128) DEFAULT NULL,\n  `description` text,\n  `initiate_script` text,\n  `callback_script` text,\n  `status` varchar(128) DEFAULT NULL,\n  `percentage` decimal(10,2) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table payment_voucher_breakdown\n# ------------------------------------------------------------\n\nCREATE TABLE `payment_voucher_breakdown` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `pv_id` int(11) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  `contact` varchar(128) DEFAULT NULL,\n  `contact_id` int(11) DEFAULT NULL,\n  `account` text,\n  `account_id` int(11) DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `payment_method` varchar(128) DEFAULT NULL,\n  `payment_reference` varchar(128) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table payment_voucher_items\n# ------------------------------------------------------------\n\nCREATE TABLE `payment_voucher_items` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `pv_id` int(11) DEFAULT NULL,\n  `account_id` int(11) DEFAULT NULL,\n  `account` varchar(128) DEFAULT NULL,\n  `po_id` int(11) DEFAULT NULL,\n  `cn_id` int(11) DEFAULT NULL,\n  `dn_id` int(11) DEFAULT NULL,\n  `invoice_id` int(11) DEFAULT NULL,\n  `asset_id` int(11) DEFAULT NULL,\n  `reference` varchar(128) DEFAULT NULL,\n  `contact_id` int(11) DEFAULT NULL,\n  `contact` varchar(128) DEFAULT NULL,\n  `description` text,\n  `datetime` datetime DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table payment_vouchers\n# ------------------------------------------------------------\n\nCREATE TABLE `payment_vouchers` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `type` varchar(128) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  `account` varchar(128) DEFAULT NULL,\n  `account_id` int(11) DEFAULT NULL,\n  `contact` varchar(128) DEFAULT NULL,\n  `contact_id` int(11) DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `void_date` datetime DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table permissions\n# ------------------------------------------------------------\n\nCREATE TABLE `permissions` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `user_type` varchar(128) DEFAULT NULL,\n  `module` text,\n  `action` text,\n  `divisions` text,\n  `super` int(11) DEFAULT ''0'',\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table potentials\n# ------------------------------------------------------------\n\nCREATE TABLE `potentials` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `related_to` varchar(128) DEFAULT NULL,\n  `lead_id` int(11) DEFAULT NULL,\n  `currency` varchar(128) DEFAULT NULL,\n  `amount` varchar(32) DEFAULT NULL,\n  `assigned_to` text,\n  `division` varchar(128) DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `expected_close_date` date DEFAULT NULL,\n  `lead_source` varchar(128) DEFAULT NULL,\n  `next_step` varchar(128) DEFAULT NULL,\n  `probability` varchar(128) DEFAULT NULL,\n  `campaign` varchar(128) DEFAULT NULL,\n  `campaign_name` varchar(128) DEFAULT NULL,\n  `sales_stage` varchar(128) DEFAULT NULL,\n  `description` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table purchase_order_items\n# ------------------------------------------------------------\n\nCREATE TABLE `purchase_order_items` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `purchase_order_id` int(11) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `item_description` text,\n  `item_name` text,\n  `item_id` int(11) DEFAULT NULL,\n  `discount` varchar(128) DEFAULT NULL,\n  `discount_type` varchar(128) DEFAULT NULL,\n  `qty` int(11) DEFAULT NULL,\n  `price_per_unit` decimal(20,4) DEFAULT NULL,\n  `price` decimal(20,2) DEFAULT NULL,\n  `received` int(11) DEFAULT NULL,\n  `received_price` decimal(20,2) DEFAULT NULL,\n  `done` int(1) DEFAULT NULL,\n  `division_id` int(11) DEFAULT NULL,\n  `warehouse_id` int(11) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table purchase_orders\n# ------------------------------------------------------------\n\nCREATE TABLE `purchase_orders` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `invoice_number` varchar(128) DEFAULT NULL,\n  `number` varchar(128) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `due_date` datetime DEFAULT NULL,\n  `contact_person` varchar(128) DEFAULT NULL,\n  `received_date` datetime DEFAULT NULL,\n  `supplier` varchar(128) DEFAULT NULL,\n  `supplier_id` int(11) DEFAULT NULL,\n  `supplier_address` text,\n  `delivery_address` text,\n  `terms` varchar(128) DEFAULT NULL,\n  `duration` int(11) DEFAULT NULL,\n  `remarks` text,\n  `status` varchar(128) DEFAULT NULL,\n  `receipt_no` varchar(128) DEFAULT NULL,\n  `handling_charges` decimal(20,2) DEFAULT NULL,\n  `adjustment` decimal(20,2) DEFAULT NULL,\n  `adjustment_type` varchar(32) DEFAULT NULL,\n  `total` decimal(20,2) DEFAULT NULL,\n  `total_received` decimal(20,2) DEFAULT NULL,\n  `payment_status` varchar(128) DEFAULT NULL,\n  `payment_date` datetime DEFAULT NULL,\n  `payment_reference` varchar(128) DEFAULT NULL,\n  `payment_contra` varchar(128) DEFAULT NULL,\n  `tags` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(32) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(32) DEFAULT NULL,\n  `division_id` int(11) DEFAULT NULL,\n  `warehouse_id` int(11) DEFAULT NULL,\n  `assigned_to` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table quote_items\n# ------------------------------------------------------------\n\nCREATE TABLE `quote_items` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `quote_id` int(11) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `item_id` int(11) DEFAULT NULL,\n  `service_id` int(11) DEFAULT NULL,\n  `item_name` varchar(128) DEFAULT NULL,\n  `item_description` text,\n  `discount` varchar(128) DEFAULT NULL,\n  `discount_type` varchar(128) DEFAULT NULL,\n  `qty` int(11) DEFAULT NULL,\n  `price_per_unit` decimal(20,4) DEFAULT NULL,\n  `price` decimal(20,2) DEFAULT NULL,\n  `cost` decimal(20,4) DEFAULT NULL,\n  `done` int(1) DEFAULT NULL,\n  `no_do` int(1) DEFAULT NULL,\n  `division_id` int(11) DEFAULT NULL,\n  `warehouse_id` int(11) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table quotes\n# ------------------------------------------------------------\n\nCREATE TABLE `quotes` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `quote_id` int(11) DEFAULT NULL,\n  `invoice_id` int(11) DEFAULT NULL,\n  `sales_order_id` int(11) DEFAULT NULL,\n  `number` varchar(128) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `due_date` datetime DEFAULT NULL,\n  `contact_person` varchar(128) DEFAULT NULL,\n  `payment_date` datetime DEFAULT NULL,\n  `received_date` datetime DEFAULT NULL,\n  `contact` varchar(128) DEFAULT NULL,\n  `contact_id` int(11) DEFAULT NULL,\n  `contact_address` text,\n  `delivery_address` text,\n  `shipping` varchar(128) DEFAULT NULL,\n  `shipping_id` int(11) DEFAULT NULL,\n  `terms` varchar(128) DEFAULT NULL,\n  `duration` int(11) DEFAULT NULL,\n  `remarks` text,\n  `status` varchar(128) DEFAULT NULL,\n  `payment_status` varchar(128) DEFAULT NULL,\n  `receipt_no` varchar(128) DEFAULT NULL,\n  `handling_charges` decimal(20,2) DEFAULT NULL,\n  `adjustment` decimal(20,2) DEFAULT NULL,\n  `adjustment_type` varchar(32) DEFAULT NULL,\n  `total` decimal(20,2) DEFAULT NULL,\n  `total_delivered` decimal(20,2) DEFAULT NULL,\n  `cost` decimal(20,4) DEFAULT NULL,\n  `tags` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(32) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(32) DEFAULT NULL,\n  `no_do` int(1) DEFAULT NULL,\n  `division_id` int(11) DEFAULT NULL,\n  `warehouse_id` int(11) DEFAULT NULL,\n  `assigned_to` int(11) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table receipt_breakdown\n# ------------------------------------------------------------\n\nCREATE TABLE `receipt_breakdown` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `receipt_id` int(11) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  `contact` varchar(128) DEFAULT NULL,\n  `contact_id` int(11) DEFAULT NULL,\n  `account` varchar(128) DEFAULT NULL,\n  `account_id` int(11) DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `amount_fees` decimal(20,2) DEFAULT NULL,\n  `amount_effective` double(20,2) DEFAULT NULL,\n  `payment_method` varchar(128) DEFAULT NULL,\n  `payment_reference` varchar(128) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table receipt_items\n# ------------------------------------------------------------\n\nCREATE TABLE `receipt_items` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `receipt_id` int(11) DEFAULT NULL,\n  `account_id` int(11) DEFAULT NULL,\n  `account` varchar(128) DEFAULT NULL,\n  `po_id` int(11) DEFAULT NULL,\n  `cn_id` int(11) DEFAULT NULL,\n  `dn_id` int(11) DEFAULT NULL,\n  `invoice_id` int(11) DEFAULT NULL,\n  `asset_id` int(11) DEFAULT NULL,\n  `reference` varchar(128) DEFAULT NULL,\n  `contact_id` int(11) DEFAULT NULL,\n  `contact` varchar(128) DEFAULT NULL,\n  `description` text,\n  `datetime` datetime DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table receipts\n# ------------------------------------------------------------\n\nCREATE TABLE `receipts` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `type` varchar(128) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  `account_id` int(11) DEFAULT NULL,\n  `account` varchar(128) DEFAULT NULL,\n  `contact_id` int(11) DEFAULT NULL,\n  `contact` varchar(128) DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `amount_fees` double(20,2) DEFAULT NULL,\n  `amount_effective` double(20,2) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `void_date` datetime DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table report_to\n# ------------------------------------------------------------\n\nCREATE TABLE `report_to` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `supervisor_id` int(11) DEFAULT NULL,\n  `supervisor` varchar(128) DEFAULT NULL,\n  `subordinate_id` int(11) DEFAULT NULL,\n  `subordinate` varchar(128) DEFAULT NULL,\n  `reporting_method` varchar(32) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table reports\n# ------------------------------------------------------------\n\nCREATE TABLE `reports` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `description` text,\n  `modules` text,\n  `permissions` text,\n  `process_script` text,\n  `display_script` text,\n  `script` text,\n  `filters` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table reports_saved\n# ------------------------------------------------------------\n\nCREATE TABLE `reports_saved` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `type` varchar(128) DEFAULT NULL,\n  `title` varchar(128) DEFAULT NULL,\n  `notes` text,\n  `output` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=InnoDB DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table reverts\n# ------------------------------------------------------------\n\nCREATE TABLE `reverts` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `performed_by` varchar(128) DEFAULT NULL,\n  `data` text,\n  `datetime` datetime DEFAULT NULL,\n  `warehouse_id` int(11) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=InnoDB DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table salary_voucher\n# ------------------------------------------------------------\n\nCREATE TABLE `salary_voucher` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `datetime` datetime DEFAULT NULL,\n  `employee_id` int(11) DEFAULT NULL,\n  `employee` varchar(128) DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `amount_employer` decimal(20,2) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table salary_voucher_breakdown\n# ------------------------------------------------------------\n\nCREATE TABLE `salary_voucher_breakdown` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `sv_id` int(11) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  `account` varchar(128) DEFAULT NULL,\n  `account_id` int(11) DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `payment_method` varchar(128) DEFAULT NULL,\n  `payment_reference` varchar(128) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table salary_voucher_format\n# ------------------------------------------------------------\n\nCREATE TABLE `salary_voucher_format` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `field_name` varchar(128) DEFAULT NULL,\n  `type` varchar(10) DEFAULT NULL,\n  `percentage` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table salary_voucher_items\n# ------------------------------------------------------------\n\nCREATE TABLE `salary_voucher_items` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `sv_id` int(11) DEFAULT NULL,\n  `field` varchar(128) DEFAULT NULL,\n  `field_id` int(11) DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `description` text,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table sale_items\n# ------------------------------------------------------------\n\nCREATE TABLE `sale_items` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `date` datetime DEFAULT NULL,\n  `sale_id` int(11) DEFAULT NULL,\n  `pseudo_id` int(11) DEFAULT NULL,\n  `item_id` int(11) DEFAULT NULL,\n  `item_sku` varchar(128) DEFAULT NULL,\n  `item_sku2` varchar(128) DEFAULT NULL,\n  `item_name` varchar(128) DEFAULT NULL,\n  `sku_select` int(11) DEFAULT NULL,\n  `qty` int(11) DEFAULT NULL,\n  `qty_fraction` int(11) DEFAULT NULL,\n  `unit` varchar(128) DEFAULT NULL,\n  `price_per_unit` decimal(20,2) DEFAULT NULL,\n  `margin` decimal(20,4) DEFAULT NULL,\n  `cost` decimal(20,4) DEFAULT NULL,\n  `discount_type` varchar(10) DEFAULT NULL,\n  `discount_value` decimal(20,2) DEFAULT NULL,\n  `discount_amount` decimal(20,2) DEFAULT NULL,\n  `global_discount` decimal(20,2) DEFAULT NULL,\n  `global_discount_type` varchar(1) DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `tax` decimal(20,2) DEFAULT NULL,\n  `sold` int(11) DEFAULT NULL,\n  `terminal` varchar(32) DEFAULT NULL,\n  `session` varchar(128) DEFAULT NULL,\n  `is_redemption` int(11) DEFAULT NULL,\n  `member_id` int(11) DEFAULT NULL,\n  ', '2012-11-07 18:41:52', 'admin', NULL);
INSERT INTO `editor_revisions` (`id`, `profile_id`, `item`, `contents`, `datetime`, `user`, `commit`) VALUES
(22, 1, '/var/www/_dev/manager/index.php', '<?php\n\n$_SERVER[''QUERY_STRING''] = preg_replace(''/&.*/'','''',$_SERVER[''QUERY_STRING'']);\n/*\n|---------------------------------------------------------------\n| PHP ERROR REPORTING LEVEL\n|---------------------------------------------------------------\n|\n| By default CI runs with error reporting set to ALL.  For security\n| reasons you are encouraged to change this when your site goes live.\n| For more info visit:  http://www.php.net/error_reporting\n|\n*/\n	error_reporting(E_ERROR);\n\n/*\n|---------------------------------------------------------------\n| SYSTEM FOLDER NAME\n|---------------------------------------------------------------\n|\n| This variable must contain the name of your "system" folder.\n| Include the path if the folder is not in the same  directory\n| as this file.\n|\n| NO TRAILING SLASH!\n|\n*/\n	$system_folder = "system";\n\n/*\n|---------------------------------------------------------------\n| APPLICATION FOLDER NAME\n|---------------------------------------------------------------\n|\n| If you want this front controller to use a different "application"\n| folder then the default one you can set its name here. The folder \n| can also be renamed or relocated anywhere on your server.\n| For more info please see the user guide:\n| http://codeigniter.com/user_guide/general/managing_apps.html\n|\n|\n| NO TRAILING SLASH!\n|\n*/\n	$application_folder = "application";\n\n/*\n|===============================================================\n| END OF USER CONFIGURABLE SETTINGS\n|===============================================================\n*/\n\n\n/*\n|---------------------------------------------------------------\n| SET THE SERVER PATH\n|---------------------------------------------------------------\n|\n| Let''s attempt to determine the full-server path to the "system"\n| folder in order to reduce the possibility of path problems.\n| Note: We only attempt this if the user hasn''t specified a \n| full server path.\n|\n*/\nif (strpos($system_folder, ''/'') === FALSE)\n{\n	if (function_exists(''realpath'') AND @realpath(dirname(__FILE__)) !== FALSE)\n	{\n		$system_folder = realpath(dirname(__FILE__)).''/''.$system_folder;\n	}\n}\nelse\n{\n	// Swap directory separators to Unix style for consistency\n	$system_folder = str_replace("\\\\", "/", $system_folder); \n}\n\n/*\n|---------------------------------------------------------------\n| DEFINE APPLICATION CONSTANTS\n|---------------------------------------------------------------\n|\n| EXT		- The file extension.  Typically ".php"\n| SELF		- The name of THIS file (typically "index.php")\n| FCPATH	- The full server path to THIS file\n| BASEPATH	- The full server path to the "system" folder\n| APPPATH	- The full server path to the "application" folder\n|\n*/\ndefine(''EXT'', ''.php'');\ndefine(''SELF'', pathinfo(__FILE__, PATHINFO_BASENAME));\ndefine(''FCPATH'', str_replace(SELF, '''', __FILE__));\ndefine(''BASEPATH'', $system_folder.''/'');\n\nif (is_dir($application_folder))\n{\n	define(''APPPATH'', $application_folder.''/'');\n}\nelse\n{\n	if ($application_folder == '''')\n	{\n		$application_folder = ''application'';\n	}\n\n	define(''APPPATH'', BASEPATH.$application_folder.''/'');\n}\n\n/*\n|---------------------------------------------------------------\n| LOAD THE FRONT CONTROLLER\n|---------------------------------------------------------------\n|\n| And away we go...\n|\n*/\nrequire_once BASEPATH.''codeigniter/CodeIgniter''.EXT;\n\n/* End of file index.php */\n/* Location: ./index.php */', '2012-11-07 18:45:50', 'admin', NULL),
(23, 1, '/var/www/_dev/manager/js/antiscroll.js', '\n(function ($) {\n\n  /**\n   * Augment jQuery prototype.\n   */\n\n  $.fn.antiscroll = function (options) {\n    return this.each(function () {\n      if ($(this).data(''antiscroll'')) {\n        $(this).data(''antiscroll'').destroy();\n      }\n\n      $(this).data(''antiscroll'', new $.Antiscroll(this, options));\n    });\n  };\n\n  /**\n   * Expose constructor.\n   */\n\n  $.Antiscroll = Antiscroll;\n\n  /**\n   * Antiscroll pane constructor.\n   *\n   * @param {Element|jQuery} main pane\n   * @parma {Object} options\n   * @api public\n   */\n\n  function Antiscroll (el, opts) {\n    this.el = $(el);\n    this.options = opts || {};\n\n    this.x = false !== this.options.x;\n    this.y = false !== this.options.y;\n    this.padding = undefined == this.options.padding ? 2 : this.options.padding;\n\n    this.inner = this.el.find(''.antiscroll-inner'');\n    this.inner.css({\n        ''width'': ''+='' + scrollbarSize()\n      , ''height'': ''+='' + scrollbarSize()\n    });\n\n    this.refresh();\n  };\n\n  /**\n   * refresh scrollbars\n   *\n   * @api public\n   */\n\n  Antiscroll.prototype.refresh = function() {\n\n    var needHScroll = this.inner.get(0).scrollWidth > this.el.width()\n      , needVScroll = this.inner.get(0).scrollHeight > this.el.height();\n\n    if (!this.horizontal && needHScroll && this.x) {\n      this.horizontal = new Scrollbar.Horizontal(this);\n    } else if (this.horizontal && !needHScroll)  {\n      this.horizontal.destroy();\n      this.horizontal = null\n    }\n\n    if (!this.vertical && needVScroll && this.y) {\n      this.vertical = new Scrollbar.Vertical(this);\n    } else if (this.vertical && !needVScroll)  {\n      this.vertical.destroy();\n      this.vertical = null\n    }\n  };\n\n  /**\n   * Cleans up.\n   *\n   * @return {Antiscroll} for chaining\n   * @api public\n   */\n\n  Antiscroll.prototype.destroy = function () {\n    if (this.horizontal) {\n      this.horizontal.destroy();\n    }\n    if (this.vertical) {\n      this.vertical.destroy();\n    }\n    return this;\n  };\n\n  /**\n   * Rebuild Antiscroll.\n   *\n   * @return {Antiscroll} for chaining\n   * @api public\n   */\n\n  Antiscroll.prototype.rebuild = function () {\n    this.destroy();\n    this.inner.attr(''style'', '''');\n    Antiscroll.call(this, this.el, this.options);\n    return this;\n  };\n\n  /**\n   * Scrollbar constructor.\n   *\n   * @param {Element|jQuery} element\n   * @api public\n   */\n\n  function Scrollbar (pane) {\n    this.pane = pane;\n    this.pane.el.append(this.el);\n    this.innerEl = this.pane.inner.get(0);\n\n    this.dragging = false;\n    this.enter = false;\n    this.shown = false;\n\n    // hovering\n    this.pane.el.mouseenter($.proxy(this, ''mouseenter''));\n    this.pane.el.mouseleave($.proxy(this, ''mouseleave''));\n\n    // dragging\n    this.el.mousedown($.proxy(this, ''mousedown''));\n\n    // scrolling\n    this.pane.inner.scroll($.proxy(this, ''scroll''));\n\n    // wheel -optional-\n    this.pane.inner.bind(''mousewheel'', $.proxy(this, ''mousewheel''));\n\n    // show\n    var initialDisplay = this.pane.options.initialDisplay;\n\n    if (initialDisplay !== false) {\n      this.show();\n      this.hiding = setTimeout($.proxy(this, ''hide''), parseInt(initialDisplay, 10) || 3000);\n    }\n  };\n\n  /**\n   * Cleans up.\n   *\n   * @return {Scrollbar} for chaining\n   * @api public\n   */\n\n  Scrollbar.prototype.destroy = function () {\n    this.el.remove();\n    return this;\n  };\n\n  /**\n   * Called upon mouseenter.\n   *\n   * @api private\n   */\n\n  Scrollbar.prototype.mouseenter = function () {\n    this.enter = true;\n    this.show();\n  };\n\n  /**\n   * Called upon mouseleave.\n   *\n   * @api private\n   */\n\n  Scrollbar.prototype.mouseleave = function () {\n    this.enter = false;\n\n    if (!this.dragging) {\n      this.hide();\n    }\n  }\n\n  /**\n   * Called upon wrap scroll.\n   *\n   * @api private\n   */\n\n  Scrollbar.prototype.scroll = function () {\n    if (!this.shown) {\n      this.show();\n      if (!this.enter && !this.dragging) {\n        this.hiding = setTimeout($.proxy(this, ''hide''), 1500);\n      }\n    }\n\n    this.update();\n  };\n\n  /**\n   * Called upon scrollbar mousedown.\n   *\n   * @api private\n   */\n\n  Scrollbar.prototype.mousedown = function (ev) {\n    ev.preventDefault();\n\n    this.dragging = true;\n\n    this.startPageY = ev.pageY - parseInt(this.el.css(''top''), 10);\n    this.startPageX = ev.pageX - parseInt(this.el.css(''left''), 10);\n\n    // prevent crazy selections on IE\n    document.onselectstart = function () { return false; };\n\n    var pane = this.pane\n      , move = $.proxy(this, ''mousemove'')\n      , self = this\n\n    $(document)\n      .mousemove(move)\n      .mouseup(function () {\n        self.dragging = false;\n        document.onselectstart = null;\n\n        $(document).unbind(''mousemove'', move);\n\n        if (!self.enter) {\n          self.hide();\n        }\n      })\n  };\n\n  /**\n   * Show scrollbar.\n   *\n   * @api private\n   */\n\n  Scrollbar.prototype.show = function (duration) {\n    if (!this.shown) {\n      this.update();\n      this.el.addClass(''antiscroll-scrollbar-shown'');\n      if (this.hiding) {\n        clearTimeout(this.hiding);\n        this.hiding = null;\n      }\n      this.shown = true;\n    }\n  };\n\n  /**\n   * Hide scrollbar.\n   *\n   * @api private\n   */\n\n  Scrollbar.prototype.hide = function () {\n    var autoHide = this.pane.options.autoHide;\n    if (autoHide !== false && this.shown) {\n      // check for dragging\n      this.el.removeClass(''antiscroll-scrollbar-shown'');\n      this.shown = false;\n    }\n  };\n\n  /**\n   * Horizontal scrollbar constructor\n   *\n   * @api private\n   */\n\n  Scrollbar.Horizontal = function (pane) {\n    this.el = $(''<div class="antiscroll-scrollbar antiscroll-scrollbar-horizontal">'');\n    Scrollbar.call(this, pane);\n  }\n\n  /**\n   * Inherits from Scrollbar.\n   */\n\n  inherits(Scrollbar.Horizontal, Scrollbar);\n\n  /**\n   * Updates size/position of scrollbar.\n   *\n   * @api private\n   */\n\n  Scrollbar.Horizontal.prototype.update = function () {\n    var paneWidth = this.pane.el.width()\n      , trackWidth = paneWidth - this.pane.padding * 2\n      , innerEl = this.pane.inner.get(0)\n\n    this.el\n      .css(''width'', trackWidth * paneWidth / innerEl.scrollWidth)\n      .css(''left'', trackWidth * innerEl.scrollLeft / innerEl.scrollWidth)\n  }\n\n  /**\n   * Called upon drag.\n   *\n   * @api private\n   */\n\n  Scrollbar.Horizontal.prototype.mousemove = function (ev) {\n    var trackWidth = this.pane.el.width() - this.pane.padding * 2\n      , pos = ev.pageX - this.startPageX\n      , barWidth = this.el.width()\n      , innerEl = this.pane.inner.get(0)\n\n    // minimum top is 0, maximum is the track height\n    var y = Math.min(Math.max(pos, 0), trackWidth - barWidth)\n\n    innerEl.scrollLeft = (innerEl.scrollWidth - this.pane.el.width())\n      * y / (trackWidth - barWidth)\n  };\n\n  /**\n   * Called upon container mousewheel.\n   *\n   * @api private\n   */\n\n  Scrollbar.Horizontal.prototype.mousewheel = function (ev, delta, x, y) {\n    if ((x < 0 && 0 == this.pane.inner.get(0).scrollLeft) ||\n        (x > 0 && (this.innerEl.scrollLeft + Math.ceil(this.pane.el.width())\n          == this.innerEl.scrollWidth))) {\n      ev.preventDefault();\n      return false;\n    }\n  };\n\n  /**\n   * Vertical scrollbar constructor\n   *\n   * @api private\n   */\n\n  Scrollbar.Vertical = function (pane) {\n    this.el = $(''<div class="antiscroll-scrollbar antiscroll-scrollbar-vertical">'');\n    Scrollbar.call(this, pane);\n  };\n\n  /**\n   * Inherits from Scrollbar.\n   */\n\n  inherits(Scrollbar.Vertical, Scrollbar);\n\n  /**\n   * Updates size/position of scrollbar.\n   *\n   * @api private\n   */\n\n  Scrollbar.Vertical.prototype.update = function () {\n    var paneHeight = this.pane.el.height()\n      , trackHeight = paneHeight - this.pane.padding * 2\n      , innerEl = this.innerEl\n\n    this.el\n      .css(''height'', trackHeight * paneHeight / innerEl.scrollHeight)\n      .css(''top'', trackHeight * innerEl.scrollTop / innerEl.scrollHeight)\n  };\n\n  /**\n   * Called upon drag.\n   *\n   * @api private\n   */\n\n  Scrollbar.Vertical.prototype.mousemove = function (ev) {\n    var paneHeight = this.pane.el.height()\n      , trackHeight = paneHeight - this.pane.padding * 2\n      , pos = ev.pageY - this.startPageY\n      , barHeight = this.el.height()\n      , innerEl = this.innerEl\n\n    // minimum top is 0, maximum is the track height\n    var y = Math.min(Math.max(pos, 0), trackHeight - barHeight)\n\n    innerEl.scrollTop = (innerEl.scrollHeight - paneHeight)\n      * y / (trackHeight - barHeight)\n  };\n\n  /**\n   * Called upon container mousewheel.\n   *\n   * @api private\n   */\n\n  Scrollbar.Vertical.prototype.mousewheel = function (ev, delta, x, y) {\n    if ((y > 0 && 0 == this.innerEl.scrollTop) ||\n        (y < 0 && (this.innerEl.scrollTop + Math.ceil(this.pane.el.height())\n          == this.innerEl.scrollHeight))) {\n      ev.preventDefault();\n      return false;\n    }\n  };\n\n  /**\n   * Cross-browser inheritance.\n   *\n   * @param {Function} constructor\n   * @param {Function} constructor we inherit from\n   * @api private\n   */\n\n  function inherits (ctorA, ctorB) {\n    function f() {};\n    f.prototype = ctorB.prototype;\n    ctorA.prototype = new f;\n  };\n\n  /**\n   * Scrollbar size detection.\n   */\n\n  var size;\n\n  function scrollbarSize () {\n    if (size === undefined) {\n      var div = $(\n          ''<div style="width:50px;height:50px;overflow:hidden;''\n        + ''position:absolute;top:-200px;left:-200px;"><div style="height:100px;">''\n        + ''</div>''\n      );\n\n      $(''body'').append(div);\n\n      var w1 = $(''div'', div).innerWidth();\n      div.css(''overflow-y'', ''scroll'');\n      var w2 = $(''div'', div).innerWidth();\n      $(div).remove();\n\n      size = w1 - w2;\n    }\n\n    return size;\n  };\n\n})(jQuery);\n', '2012-11-07 18:46:18', 'admin', NULL),
(24, 1, '/var/www/_dev/manager/js/controller.js', '\n$(document).ready(function (){\n	\n	try{\n 	    if (base_url) exist=1/0;\n	} catch(e) {\n    	base_url = [];\n	}\n\n	// Anchor Submit Button\n	$(''.submit_button'').click(function (event){\n		$(this).parents(''form'').submit();\n		event.preventDefault();\n	});\n	\n	$(''label'').click(function (event){\n\n		event.preventDefault();\n	});\n	\n	// Gallery Interaction \n	$(''ul.gallery img'').hover(function (){\n		var newImage = $(this).parents(''li'').html();\n		var id = $(this).parents(''ul'').attr(''id'');\n		if (id){\n			$(''div.''+id).html(newImage);\n		} else {\n			$(''div.gallery_view'').html(newImage);\n		}\n	}, function() {\n		// hover out: do nothing\n	});\n	\n	/// Accordion control\n	\n	$(".accordion").accordion({\n			collapsible: true,\n			fillSpace: true,\n			icons: {\n    			header: "ui-icon-circle-arrow-e",\n   				headerSelected: "ui-icon-circle-arrow-s"\n			}\n	});\n	\n	$(".selectable").selectable();\n	\n	// Text input CSS 3 corner sytling\n\n	$(''.action_delete'').click(function (event){\n		if (window.confirm(''Are you sure you want to delete this record?'')){\n			window.location.replace($(this).attr(''href''));\n		} \n		event.preventDefault();\n		\n	});\n\n	setTimeout(function() { \n        $(''p.notice'').fadeOut(''slow'', function(){\n        	$(this).css(''display'',''none'');\n        }); \n        $(''p.warning'').fadeOut(''slow'', function(){\n        	$(this).css(''display'',''none'');\n        }); \n    }, 9000); \n\n	$(''.fastform_date'').datepicker({\n		showOn: ''button'', \n		buttonImage: base_url+''images/calendar.gif'', \n		buttonImageOnly: true, \n		yearRange: ''1900:2010'',\n		dateFormat: ''yy-mm-dd'',\n		changeMonth: true,\n		changeYear: true		\n	});\n	\n	$(''.fastform_date_nobackdate'').datepicker({\n		showOn: ''button'', \n		buttonImage: base_url+''images/calendar.gif'', \n		buttonImageOnly: true, \n		yearRange: ''1900:2010'',\n		dateFormat: ''yy-mm-dd'',\n		changeMonth: true,\n		changeYear: true,\n		minDate: 0\n	});\n	\n	$(''input.fastform_datestart'').datepicker({showOn: ''button'', buttonImage: base_url+''images/calendar.gif'', buttonImageOnly: true, minDate: 0, dateFormat: ''yy-mm-dd'',\n		onSelect: function (dateTime, inst){\n			var start_dt = dateTime.split(''-'');\n			var end = $(''input.fastform_datestop'').val();\n			var end_dt = end.split(''-'');\n			var start_date = new Date(start_dt[0], start_dt[1]-1, start_dt[2]);\n\n			if (end != ''''){\n				var end_date = new Date(end_dt[0], end_dt[1]-1, end_dt[2]);\n			} else {\n				var end_date = new Date(start_dt[0], start_dt[1]-1, start_dt[2]);\n			}\n\n			var new_end_date = new Date();\n			var multiplier;\n			if (duration == null) multiplier = duration;\n			else multiplier = 1;\n			var new_time = start_date.valueOf() + ((1000 * 60 * 60 * 24) * multiplier);\n			new_end_date.setTime(new_time);\n\n			if (start_date.valueOf() >= end_date.valueOf()){\n				var min_date = new_end_date.getDate() + ''-'' + (new_end_date.getMonth()+1) + ''-'' + new_end_date.getFullYear();\n				$(''input.fastform_datestop'').val(new_end_date.getFullYear() + ''-'' + (new_end_date.getMonth() + 1) + ''-'' + new_end_date.getDate());\n			}\n			$(''input.fastform_datestop'').datepicker(''destroy'');\n			$(''input.fastform_datestop'').datepicker({showOn: ''button'', buttonImage: base_url+''images/calendar.gif'', buttonImageOnly: true, minDate: new_end_date, dateFormat: ''yy-mm-dd''});\n\n		}\n	});\n	$(''input.fastform_datestop'').datepicker({showOn: ''button'', buttonImage: base_url+''images/calendar.gif'', buttonImageOnly: true, dateFormat: ''yy-mm-dd''});\n\n		\n	$(''a.btnstick'').click(function(){\n		var rel = $(this).attr(''rel'');\n		$(''a.btnstick[rel=''+rel+'']'').css(''background-position'',''top'');\n		$(this).css(''background-position'',''bottom'');\n	});\n	\n	\n\n	\n\n});\n\nfunction isSet(variable){\n	return(typeof(variable) != ''undefined'');\n}\n\n\n', '2012-11-07 18:46:26', 'admin', NULL),
(25, 1, '/var/www/_dev/manager/js/window.js', 'var delete_href;\nvar delete_id;\nvar delete_tid;\nvar delete_tr;\nvar form_warning = false;\nvar reload_data = null;\nvar reload_sort = null;\nvar reload_order = null;\n\nvar retainQueue = new Array();\nvar navigateQueue = new Array();\nvar cell_update_url = '''';\n\nString.prototype.trim = function() {\n	return this.replace(/^\\s+|\\s+$/g,"");\n}\n\nfunction isArray(what) {\n    return Object.prototype.toString.call(what) === ''[object Array]'';\n}\n\nfunction isObject(what) {\n    return Object.prototype.toString.call(what) === ''[object Object]'';\n}\n\nfunction isString(what) {\n    return Object.prototype.toString.call(what) === ''[object String]'';\n}\n\nfunction isJSON(what){\n	try {\n		eval(''var testJSON = '' + what);\n	} catch(e){\n		return false;\n	}\n	return true;\n}\n\nfunction __convertWeight(value, from, to){\n	var unit_ratios = {\n		''g''		: 1,\n		''kg''	: 0.001,\n		''oz''	: 0.035273962,\n		''lb''	: 0.0022046226\n	};\n		\n	return (value / unit_ratios[from]) * unit_ratios[to];\n}\n	\nfunction __convertVolume(value, from, to){\n	var unit_ratios = {\n		''cm3''	: 1,\n		''l''		: 0.001,\n		''in3''	: 0.0610237441\n	};\n		\n	return (value / unit_ratios[from]) * unit_ratios[to];\n}\n\nvar psSelect = -1;\n$(document).ready(function(){\n\n\n	$(''#product-search input.qty'').live(''keydown'',function(e){\n		\n		if (e.which == 13){\n			$(this).parents(''tr'').find(''input.product-items'').attr(''checked'',true);\n			$(''a.add-product-item'').click();\n			$(''input[name=product_search]'').each(function(){\n				this.select();\n				$(''div.main_full'').scrollTo($(''div.main_full'').get(0).scrollHeight - 880, 500);\n			})\n\n		}\n		\n	});\n	\n	\n	$(''a.settings-button'').click(function(){\n		$(''#global-sidebar li'').removeClass(''current'');\n	})\n		\n	$(''form'').live(''submit'',function(){\n		form_warning = false;\n	});\n\n\n	$(''td.checkbox'').live(''click'',function(){\n		if ($(this).find(''input[type=checkbox]'').attr(''checked'')){\n			$(this).find(''input[type=checkbox]'').attr(''checked'',false);\n		} else {\n			$(this).find(''input[type=checkbox]'').attr(''checked'',true);		\n		}\n	});\n\n	$.preLoadImages(base_url+"images/loading.gif", base_url+"css/images/slide_modal.png");\n	\n	$(''select.v-country'').live(''change'',function(){\n		var country = $(this).val();\n		var citySelect = $(this).parents(''form'').find(''select.v-city'');\n		var city = $(this).attr(''state'');\n		$(citySelect).html(''<option>Loading...</option>'');\n		$.ajax({\n			url: base_url + ''sys/get_city_list'',\n			type: ''POST'',\n			data: ''country='' + country,\n			success: function (html){\n				$(citySelect).html(html);\n				$(citySelect).val(city);\n			}\n		});\n	});\n	\n	$(''td.editable'').live(''dblclick'',function(){\n		var val = $(this).attr(''value'');\n		var type = $(this).attr(''type'');\n		var field = $(this).attr(''field'');\n		var id = $(this).parents(''tr'').attr(''rel'');\n		var callback = $(this).attr(''callback'');\n		\n		var newInput = $(''<input type="text" style="width: 100%" class="''+type+''" field="''+field+''" rel="''+id+''" value="''+val+''" />'');\n				\n		$(this).html(newInput);\n		$(this).find(''input'').each(function(){ this.select() });\n		\n		$(this).find(''input'').keydown(function(e){\n			if (e.which == 13){		\n				updateCell($(this).attr(''rel''), $(this).attr(''field''), $(this).val(), callback);\n			}\n		});\n		\n		$(this).find(''input'').blur(function(){\n			updateCell($(this).attr(''rel''), $(this).attr(''field''), $(this).val(), callback);\n		})\n	});\n	\n	windowResize();\n	\n	$(''div.filter input'').live(''keypress'',function(e){\n		if (e.which == 13){\n			filterItems();\n			$(this).each(function(){\n				this.select();\n			})\n		}\n	});\n	\n	$(''div.filter select'').live(''keypress'',function(e){\n		if (e.which == 13) filterItems();\n	});\n	\n	$(''a.filter-btn'').live(''click'',function(){\n		filterItems();\n	});\n\n	\n	$(window).bind(''resize'',function(){\n		windowResize();\n	});\n\n	$(''table.grid_data tr'').live(''click'',function(){\n		$(''table.grid_data tr.current-row'').removeClass(''current-row'');\n		$(this).addClass(''current-row'');\n	});\n\n	$(''table.grid th.sortable'').live(''click'',function(){\n		$(''th'').not(this).removeClass(''sort-asc'').removeClass(''sort-desc'');\n		\n		var rel = $(this).attr(''rel'');\n		\n		reload_sort = rel;\n		\n		if ($(this).hasClass(''sort-asc'')){\n			$(''table.grid_data tr'').tsort(''td[rel=''+rel+'']'',{order:"desc"});	\n			$(this).addClass(''sort-desc'').removeClass(''sort-asc'');\n			\n			reload_order = ''sort-asc'';\n		} else {\n			$(this).addClass(''sort-asc'').removeClass(''sort-desc'');\n			$(''table.grid_data tr'').tsort(''td[rel=''+rel+'']'',{order:"asc"});\n			\n			reload_order = ''sort-desc'';\n		}\n		\n		$(''table.grid_data tr'').removeClass(''alt'');\n		$(''table.grid_data tr:even'').addClass(''alt'');\n\n	});\n	\n	$(''table.grid th.sortable-date'').live(''click'',function(){\n		$(''th'').not(this).removeClass(''sort-asc'').removeClass(''sort-desc'');\n		\n		var rel = $(this).attr(''rel'');\n		\n		reload_sort = rel;\n		\n		if ($(this).hasClass(''sort-asc'')){\n			$(''table.grid_data tr'').tsort(''td[rel=''+rel+'']'',{attr: "time",order:"desc"});	\n			$(this).addClass(''sort-desc'').removeClass(''sort-asc'');\n			\n			reload_order = ''sort-asc'';\n		} else {\n			$(this).addClass(''sort-asc'').removeClass(''sort-desc'');\n			$(''table.grid_data tr'').tsort(''td[rel=''+rel+'']'',{attr: "time",order:"asc"});\n			\n			reload_order = ''sort-desc'';\n		}\n		\n		$(''table.grid_data tr'').removeClass(''alt'');\n		$(''table.grid_data tr:even'').addClass(''alt'');\n\n	});\n	\n	$(''table.grid th.sortable-field'').live(''click'',function(){\n		$(''th'').not(this).removeClass(''sort-asc'').removeClass(''sort-desc'');\n		\n		var rel = $(this).attr(''rel'');\n		\n		reload_sort = rel;\n		\n		if ($(this).hasClass(''sort-asc'')){			\n			$(''table.grid_data tr'').tsort(''.field'',{attr: "value",order:"desc"});\n			$(this).addClass(''sort-desc'').removeClass(''sort-asc'');\n			\n			reload_order = ''sort-asc'';\n		} else {\n			$(this).addClass(''sort-asc'').removeClass(''sort-desc'');\n			$(''table.grid_data tr'').tsort(''.field'',{attr: "value",order:"asc"});\n			\n			reload_order = ''sort-desc'';\n		}\n		\n		$(''table.grid_data tr'').removeClass(''alt'');\n		$(''table.grid_data tr:even'').addClass(''alt'');\n\n	});\n	\n	$(''input.time'').timeEntry({spinnerImage: base_url+''images/spinnerDefault.png''});\n	$(''input.date'').dateEntry({dateFormat: ''dmy/'',spinnerImage: base_url+''images/spinnerDefault.png''});\n	\n	$(''input.v-number'').live(''keypress'',function(event){\n		var key = event.which;\n		var keychar = String.fromCharCode(key);\n		if ((key==null) || (key==0) || (key==8) ||  (key==9) || (key==13) || (key==27) ) return true;\n		else if ((("0123456789").indexOf(keychar) > -1)) return true;\n		else event.preventDefault();\n	});\n	\n	$(''input.v-number-decimal'').live(''keypress'',function(event){\n		var key = event.which;\n		var keychar = String.fromCharCode(key);\n		if ((key==null) || (key==0) || (key==8) ||  (key==9) || (key==13) || (key==27) ) return true;\n		else if ((("0123456789").indexOf(keychar) > -1)) return true;\n		else if (keychar == "."){\n			var value = $(this).val();\n			if (value.indexOf(''.'') > -1){\n				event.preventDefault()\n			}\n			return true;\n		}\n		else event.preventDefault();\n	});\n	\n	\n	$(''form input'').live(''change'',function(){\n		form_warning = true;\n	});\n	\n	$(''form select'').live(''change'',function(){\n		form_warning = true;\n	});\n	\n	$(''form textarea'').live(''change'',function(){\n		form_warning = true;\n	});\n\n	$(''div.global-tabs a'').live(''click'',function(event){\n		$(this).parents(''div.global-tabs'').find(''a'').removeClass(''current'');\n		$(this).addClass(''current'');\n		event.preventDefault();\n	});\n	\n	$(''#global-sidebar-list li a'').live(''click'',function(event){\n		event.preventDefault();\n		\n		if (form_warning){\n			if (!confirm(''Are you sure you want to proceed without saving?'')){\n				event.preventDefault();\n				return;\n			} else {\n				form_warning = false;\n			}\n		}\n		\n		retainQueue = new Array();\n		navigateQueue = new Array();\n\n		$(''#global-sidebar-list li a'').parents(''li'').removeClass(''current'')\n		$(this).parents(''li'').addClass(''current'');\n		$(''#global-content'').html(''<p><img src="images/loading.gif" /> Loading</p>'');\n		var href = $(this).attr(''href'');\n		$.ajax({type: "POST",\n			url: base_url+href,\n			success: function(html){\n				$(''#global-content'').html(html);\n				populateEvents();\n				form_warning = false;\n			}\n		});\n\n		\n	});\n	\n\n	$(''a.target_main'').live(''click'',function(event){\n		retain();\n		event.preventDefault();\n		\n		if (form_warning){\n			if (!confirm(''Are you sure you want to proceed without saving?'')){\n				return;\n			} else {\n				form_warning = false;\n			}\n		}\n		\n\n		\n		var href = $(this).attr(''href'');\n\n		$(''#global-content'').html(''<p><img src="images/loading.gif" /> Loading</p>'');\n		$.ajax({type: "POST",\n			url: base_url+href,\n			success: function(html){\n				$(''#global-content'').html(html);\n				populateEvents();\n				form_warning = false;\n			}\n		});\n\n	});\n\n	\n	$(''a.grid-action-view'').live(''click'',function(event){\n	\n		if ($(this).hasClass(''prevent-default'')) return;\n\n		retain();\n		event.preventDefault();\n		\n\n\n		var href = $(this).attr(''href'');\n		$(''#global-content'').html(''<p><img src="images/loading.gif" /> Loading</p>'');\n		$.ajax({type: "POST",\n			url: base_url+href,\n			success: function(html){\n				$(''#global-content'').html(html);\n				populateEvents();\n				form_warning = false;\n			}\n		});\n	});\n	\n	$(''a.grid-action-edit'').live(''click'',function(event){\n		\n		if ($(this).hasClass(''prevent-default'')) return;\n		\n		retain();\n		event.preventDefault();\n		\n\n		\n		var href = $(this).attr(''href'');\n		$(''#global-content'').html(''<p><img src="images/loading.gif" /> Loading</p>'');\n		$.ajax({type: "POST",\n			url: base_url+href,\n			success: function(html){\n				$(''#global-content'').html(html);\n				populateEvents();\n				\n				form_warning = false;\n			}\n		});\n	});\n\n	$(''a.grid-action-delete'').live(''click'',function(event){\n	\n		event.preventDefault();\n		\n		if ($(this).hasClass(''prevent-default'')) return;\n\n		\n		delete_href = $(this).attr(''href'');\n		delete_id = $(this).parents(''tr'').attr(''rel'');\n		delete_tid = $(this).parents(''table'').attr(''rel'');\n		delete_tr = $(this).parents(''tr'');\n\n		showDialog(''yesno'',''Delete'',''Confirm delete?'', function(){\n				$.ajax({type: "POST",\n					url: base_url+delete_href,\n					success: function(html){\n					\n						if (html == ''ok''){\n							$(delete_tr).fadeOut(500,''swing'',function(){ \n								$(this).remove() \n								$(''table.grid_data tbody tr'').removeClass(''alt'');\n								$(''table.grid_data tbody tr:even'').addClass(''alt'');\n							});\n							\n						} else {\n							showDialog(''ok'',''Error'',''There was a problem deleting the record from the database.'');\n						}\n					}\n				});\n			},\n			function(){\n			\n			});\n	});\n	\n	$(''a.grid-action-delete-auth'').live(''click'',function(event){\n		event.preventDefault();\n		\n		delete_href = $(this).attr(''href'');\n		delete_id = $(this).parents(''tr'').attr(''rel'');\n		delete_tid = $(this).parents(''table'').attr(''rel'');\n		delete_tr = $(this).parents(''tr'');\n\n		showDialog(''yesno'',''Delete'',''Enter password: <input type="password" class="auth_pass" />'', function(){\n				var pass = $(''input.auth_pass'').val();\n				$.ajax({type: "POST",\n					url: base_url+delete_href,\n					type: ''POST'',\n					data: ''pass=''+ pass,\n					success: function(html){\n						if (html == ''ok''){\n							$(delete_tr).fadeOut(500,''swing'',function(){ \n								$(this).remove();\n								$(''table.grid_data tr'').removeClass(''alt'');\n								$(''table.grid_data tr:even'').addClass(''alt'');\n							});\n						} else {\n							showDialog(''ok'',''Error'',''The password supplied is incorrect.'');\n						}\n					}\n				});\n			});\n	});\n\n		\n	$(''a.back_btn'').live(''click'',function(event){\n		event.preventDefault();\n		if (form_warning){\n			if (!confirm(''Are you sure you want to proceed without saving?'')){\n				return;\n			} else {\n				form_warning = false;\n			}\n		}\n\n		back();\n	});\n	\n	$(''#header'').live(''click'',function(){\n		showModalForm();\n	});\n	\n	hideModalForm();\n\n	\n});\n\nfunction populateEvents(){\n\n	$(''input.time'').timeEntry({spinnerImage: base_url+''images/spinnerDefault.png''});\n	$(''input.date'').dateEntry({dateFormat: ''dmy/'',spinnerImage: base_url+''images/spinnerDefault.png''});\n\n	\n	$(''input.autocomplete-user-single'').textboxlist({unique: true, max: 1, plugins: {autocomplete: {\n		minLength: 1,\n		queryRemote: true,\n		onlyFromValues: true,\n		remote: {url: base_url + ''autocomplete/search/user''}\n	}}});\n	\n	$(''input.autocomplete-tag'').textboxlist({unique: true, plugins: {autocomplete: {\n		minLength: 1,\n		queryRemote: true,\n		onlyFromValues: false,\n		remote: {url: base_url + ''autocomplete/search/tag''}\n	}}});\n\n	\n	$(''input.autocomplete-country'').textboxlist({unique: true, plugins: {autocomplete: {\n		minLength: 1,\n		queryRemote: true,\n		onlyFromValues: true,\n		remote: {url: base_url + ''autocomplete/search/country''}\n	}}});\n	\n	$(''input.autocomplete-user'').textboxlist({unique: true, plugins: {autocomplete: {\n		minLength: 1,\n		queryRemote: true,\n		onlyFromValues: true,\n		remote: {url: base_url + ''autocomplete/search/user''}\n	}}});\n	\n	$(''input.autocomplete-division-single'').textboxlist({unique: true, max:1, plugins: {autocomplete: {\n		minLength: 1,\n		queryRemote: true,\n		onlyFromValues: true,\n		remote: {url: base_url + ''autocomplete/search/division''}\n	}}});\n	\n	$(''input.autocomplete-division'').textboxlist({unique: true, plugins: {autocomplete: {\n		minLength: 1,\n		queryRemote: true,\n		onlyFromValues: true,\n		remote: {url: base_url + ''autocomplete/search/division''}\n	}}});\n	\n\n	windowResize();\n}\n\nfunction windowResize(){\n\n	var headerHeight = $(''#header'').height();\n	var targetHeight = $(window).height() - headerHeight;\n	var targetHeightC = $(window).height() - headerHeight;\n	$(''#global-sidebar'').height(targetHeight);\n	$(''#global-content'').height(targetHeightC);\n\n	\n	targetHeight = $(window).height() - 90;\n	targetWidth = $(window).width() - 180;	// minus sidebar width\n	$(''div.toolbar'').width(targetWidth);\n	\n	$(''#calendar'').fullCalendar(''option'', ''height'', targetHeight);\n 	$(''#calendar'').fullCalendar(''option'', ''width'', targetWidth);\n 	\n 	var toolbarHeight = $(''div.toolbar'').height();\n	var mainHeight = $(window).height() - $(''div.toolbar'').height() - headerHeight;\n\n	$(''div.main_full'').css(''margin-top'', toolbarHeight);\n	$(''div.main_full'').css(''height'', mainHeight);\n	\n}\n\nfunction showModalForm(id){\n	if (!$(''div.global-modal-form[id=''+id+'']'').hasClass(''global-modal-showing'')){\n		targetLeft = ($(window).width() / 2) - ($(''div.global-modal-form[id=''+id+'']'').width() / 2);\n		$(''div.global-modal-form[id=''+id+'']'').css(''left'',targetLeft);\n		var actualHeight = $(''div.global-modal-form[id=''+id+'']'').height();\n		$(''div.global-modal-form[id=''+id+'']'').addClass(''global-modal-showing'');\n		$(''div.global-modal-form[id=''+id+'']'').height(0);\n		$(''div.global-modal-form[id=''+id+'']'').css(''display'',''block'');\n		$(''div.global-modal-form[id=''+id+'']'').animate({height: actualHeight, opacity: 1},200);\n	}\n}\n\nfunction hideModalForm(id){\n	if ($(''div.global-modal-form[id=''+id+'']'').hasClass(''global-modal-showing'')){\n		$(''div.global-modal-form[id=''+id+'']'').removeClass(''global-modal-showing'');\n		var actualHeight = $(''div.global-modal-form[id=''+id+'']'').height();\n		$(''div.global-modal-form[id=''+id+'']'').animate({height: 0, opacity: 0},200,''swing'',\n			function(){ \n				$(this).css({\n					height: actualHeight,\n					display: ''none''\n				})\n			});\n	}\n}\n\nfunction showDialog(type,title,msg,yesfunction,nofunction){\n	switch (type){\n		case ''ok'':\n			if ($(''div.dialog-ok'').hasClass(''dialog-ok'')){\n				$(''div.dialog-ok p.global-dialog-msg'').html(msg);\n				$(''div.dialog-ok h3'').html(title);\n			} else {\n				$(''body'').append(''<div class="global-dialog dialog-ok"><div class="global-dialog-body"><h3>''+title+''</h3><p class="global-dialog-msg">''+msg+''</p><hr /><p class="global-dialog-action"><a class="v-dbtn dialog-ok-button">OK</a></p></div></div>'');\n				\n				\n				$(''div.dialog-ok a.dialog-ok-button'').click(function(event){\n					event.preventDefault();\n					hideDialog(''ok'');\n					try {\n						yesfunction();\n					} catch (e){\n						// do nothing\n					}\n\n					\n				});\n			}\n			\n			if (!$(''div.dialog-ok'').hasClass(''global-dialog-showing'')){\n				targetLeft = ($(window).width() / 2) - ($(''div.dialog-ok'').width() / 2);\n				$(''div.dialog-ok'').css(''left'',targetLeft);\n				var actualHeight = $(''div.dialog-ok'').height();\n				$(''div.dialog-ok'').addClass(''global-dialog-showing'');\n				$(''div.dialog-ok'').height(0);\n				$(''div.dialog-ok'').css(''display'',''block'');\n				$(''div.dialog-ok'').animate({height: actualHeight, opacity: 1},200);\n			}\n			break;\n		case ''yesno'':\n\n			if ($(''div.dialog-yesno'').hasClass(''dialog-yesno'')){\n				$(''div.dialog-yesno p.global-dialog-msg'').html(msg);\n				$(''div.dialog-yesno h3'').html(title);\n			} else {\n				$(''body'').append(''<div class="global-dialog dialog-yesno"><div class="global-dialog-body"><h3>''+title+''</h3><p class="global-dialog-msg">''+msg+''</p><hr /><p class="global-dialog-action"><a class="v-dbtn dialog-yes-button">Yes</a> <a class="v-dbtn dialog-no-button">No</a></p></div></div>'');\n				\n				\n				$(''div.dialog-yesno a.dialog-no-button'').click(function(event){\n					event.preventDefault();\n					try {\n						nofunction();\n					} catch (e){\n						// do nothing\n					}\n					hideDialog(''yesno'');\n				});\n				\n				$(''div.dialog-yesno a.dialog-yes-button'').click(function(event){\n					event.preventDefault();\n					try {\n						yesfunction();\n					} catch (e){\n						// do nothing\n					}\n					hideDialog(''yesno'');\n				});\n			}\n			\n			if (!$(''div.dialog-yesno'').hasClass(''global-dialog-showing'')){\n				targetLeft = ($(window).width() / 2) - ($(''div.dialog-yesno'').width() / 2);\n				$(''div.dialog-yesno'').css(''left'',targetLeft);\n				var actualHeight = $(''div.dialog-yesno'').height();\n				$(''div.dialog-yesno'').addClass(''global-dialog-showing'');\n				$(''div.dialog-yesno'').height(0);\n				$(''div.dialog-yesno'').css(''display'',''block'');\n				$(''div.dialog-yesno'').animate({height: actualHeight, opacity: 1},100);\n			}\n	}\n}\n\nfunction hideDialog(dlg){\n	if ($(''div.dialog-''+dlg).hasClass(''global-dialog-showing'')){\n		$(''div.dialog-''+dlg).removeClass(''global-dialog-showing'');\n		var actualHeight = $(''div.dialog-''+dlg).height();\n		$(''div.dialog-''+dlg).animate({height: 0, opacity: 0},200,''swing'',\n			function(){ \n				$(this).css({\n					height: actualHeight,\n					display: ''none''\n				})\n			});\n	}\n}\n\nfunction showDiag(data){\n	$(''div.diag'').show().html(data);\n}\n\nfunction retain(option){\n	var page = $(''#global-content'').html();\n	retainQueue.unshift($(page));\n	navigateQueue.unshift(''@retain'');\n}\n\nfunction back(){\n	var uri = navigateQueue.shift();\n	if (uri == ''@retain''){\n		var retainedPage = retainQueue.shift();\n		$(''#global-content'').html(retainedPage);\n		reloadGrid();\n	} else {\n		$(''#global-content'').html(''<p><img src="images/loading.gif" /> Loading</p>'');\n		\n		$.ajax({\n			type: "POST",\n			url: base_url + uri,\n			success: function(html){\n				$(''#global-content'').html(html);\n				populateEvents();\n				form_warning = false;\n			}\n		});	\n	}\n	\n}\n\nfunction checkForm(){\n	if (form_warning) return ''All form data will be discarded if you proceed.'';\n}\n\nfunction updateCell(id, field, val, callback){\n	$(''tr[rel=''+id+'']'').find(''td[field=''+field+''] input'').attr(''disabled'',true);\n	$.ajax({\n		url: base_url + cell_update_url,\n		type: ''POST'',\n		data: ''id=''+id+''&field=''+field+''&val=''+val,\n		success: function (value){\n			$(''tr[rel=''+id+'']'').find(''td[field=''+field+'']'').text(value).attr(''value'',value);\n			eval(callback);\n		}\n	})\n}\n\nfunction recalculateMargin(id,val){\n	var cost = parseFloat($(''tr[rel=''+id+'']'').find(''td.cost'').text());\n	var margin = (parseFloat(val) - cost) / parseFloat(val) * 100;\n	$(''tr[rel=''+id+'']'').find(''td.margin'').text(margin.toFixed(2));\n}\n\nwindow.onbeforeunload = checkForm;', '2012-11-07 18:46:38', 'admin', NULL);
INSERT INTO `editor_revisions` (`id`, `profile_id`, `item`, `contents`, `datetime`, `user`, `commit`) VALUES
(26, 1, '/var/www/_dev/manager/js/editor.js', '\nvar scroller;\nvar profile_name;\nvar current_filename;\nvar current_profile_id;\nvar getFileXHR;\n\n$(document).ready(function(){\n\n\n	rescaleFileList();\n\n	$(window).resize(function(){\n		rescaleFileList();\n	})\n	\n 	scroller = $(''div.box-wrap'').antiscroll();\n 	\n 	$(''a.close-profile'').click(function(e){\n 		e.preventDefault();\n	 	$(this).hide();\n	 	$(''a.add-profile'').show();\n	 	\n	 	current_filename = '''';\n	 	current_profile_id = '''';\n	 	$(''div.text-editor'').hide();\n	 	$(''div.profiles'').show();\n	 	$(''h3.grid-title span'').text(''Editor Profiles'');\n	 	$(''ul.file-list'').html(''<li class="no-select" style="text-align: center; padding-top: 10px">No files</li>'');\n	 	$(''ul.file-tabs'').html('''');\n	 	$(''div.select'').hide();\n 	})\n\n	$(''div.profile'').dblclick(function(){\n		$(''h3.grid-title span'').text($(this).find(''span'').text());\n		profile_name = $(this).find(''span'').text();\n		openProfile($(this).attr(''id''));\n		$(''a.close-profile'').show();\n		$(''a.add-profile'').hide();\n	});\n	\n	$(''html'').click(function(){\n		$(''div.file-menu'').fadeOut(100);\n	});	\n\n	$(''div.file-list li a'').live(''contextmenu'', function(e){\n		$(this).click();\n		$(''div.file-menu'').css({\n	    	top: e.pageY+''px'',\n	    	left: e.pageX+''px''\n	    }).show();\n\n		return false;\n	})\n	\n	\n	$(''div.file-list li a'').live(''click'', function(){\n		var offset = $(this).offset();\n		var scrollTop = $(''div.antiscroll-inner'').scrollTop();\n		\n		var offsetHeader = $(''#header'').height();\n		\n		$(''div.select'').css(''top'',offset.top - offsetHeader + scrollTop).hide().fadeIn(100);\n		setTimeout(function(){\n			var scrollWidth = $(''div.antiscroll-inner'').get(0).scrollWidth;\n			$(''div.select'').css(''width'',scrollWidth);\n		},50);\n		\n		$(''div.file-list li'').removeClass(''current-item'');\n		$(this).parent(''li'').addClass(''current-item'');\n	});\n	\n	$(''ul.file-tabs a'').live(''click'',function(){\n		try {\n			getFileXHR.abort();\n		} catch (e){\n			// do nothing\n		}\n	\n		var profile_id = $(this).attr(''profile_id'');\n		var filename = $(this).attr(''path'');\n		\n		$(''h3.grid-title span'').html(profile_name + ''<small style="font-weight:normal"> &raquo; '' + filename + ''</small>'');\n		\n		$(''div.loading'').show();\n\n		getFile(profile_id, filename, function(data){\n			$(''div.loading'').hide();\n			\n			var found = false;\n	    	$(''ul.file-tabs a'').removeClass(''current'').each(function(){\n				if ($(this).attr(''path'') == filename){\n					$(this).addClass(''current'');\n					found = true;\n				}\n			})\n			if (!found) $(''ul.file-tabs'').append(''<li class="opened"><a profile_id="''+profile_id+''" class="opened current" style="width: auto; padding: 2px 5px 0 10px" path="''+filename+''"><span class="close">x</span>''+file+''</a></li>'');\n\n\n		\n	    	if (data.editor){\n	    		current_filename = data.filename;\n	    		\n		    	editor.setOption(''mode'',data.mode);\n	    		editor.setValue(data.contents);\n	    		\n	    		$(''.file-related'').removeClass(''disabled'');\n	    		\n	    		$(''div.text-editor'').show();\n	    		$(''div.no-file-selected'').hide();\n	    	} else {\n	    		\n	    	}\n		});\n	});\n\n	$(''li.file a'').live(''click'', function(){\n		try {\n			getFileXHR.abort();\n		} catch (e){\n			// do nothing\n		}\n		\n		var listItem = $(this).parent(''li'');\n		var profile_id = $(listItem).attr(''profile_id'');\n		var filename = $(this).parent(''li'').attr(''path'');\n		var file = $(this).text();\n		\n		if (!$(listItem).hasClass(''loading'')){\n			$(listItem).addClass(''loading'').prepend(''<img src="images/sidebar-loading.gif" style="right: 0; z-index: 1; margin-top: 2px; position: absolute" />'')\n		}\n		\n		$(''div.loading'').show();\n\n		getFile(profile_id, filename, function(data){\n		\n			$(''div.loading'').hide();\n		\n			$(''h3.grid-title span'').html(profile_name + ''<small style="font-weight:normal"> &raquo; '' + filename + ''</small>'');\n	    	\n	    	current_filename = data.filename;\n	    		\n	    	$(listItem).removeClass(''loading'').find(''img'').remove();\n\n	    	var found = false;\n	    	$(''ul.file-tabs a'').removeClass(''current'').each(function(){\n				if ($(this).attr(''path'') == filename){\n					$(this).addClass(''current'');\n					found = true;\n				}\n			})\n			if (!found) $(''ul.file-tabs'').append(''<li class="opened"><a profile_id="''+profile_id+''" class="opened current" style="width: auto; padding: 2px 5px 0 10px" path="''+filename+''"><span class="close">x</span>''+file+''</a></li>'');\n\n	    	if (data.editor){\n		    	editor.setOption(''mode'',data.mode);\n	    		editor.setValue(data.contents);\n	    		$(''.file-related'').removeClass(''disabled'');\n	    		\n	    		$(''div.text-editor'').show();\n	    		$(''div.no-file-selected'').hide();\n	    	} else {\n	    		\n	    	}\n		});	\n	});\n	\n	$(''li.dir span'').live(''click'', function(){\n		var listItem = $(this).parent(''a'').parent(''li.dir'');\n		\n		if ($(listItem).hasClass(''opened'')){\n			$(this).html(''&#x25BA'');\n			$(listItem).removeClass(''opened'').find(''ul'').hide();\n			\n		} else {\n			\n			$(listItem).addClass(''opened'');\n			var profile_id = $(this).parents(''li.dir'').attr(''profile_id'');\n			var path = $(listItem).attr(''path'');\n			var that = listItem;\n			\n			if (!$(listItem).hasClass(''loading'')){\n				$(listItem).addClass(''loading'').prepend(''<img src="images/sidebar-loading.gif" style="float:right; z-index: 0; margin-top: 2px; position: relative" />'')\n			}\n		\n			getFileList(profile_id, path, function(data){\n				$(listItem).removeClass(''loading'').find(''img'').remove();\n					\n				if (path.indexOf(''/'') == -1){ \n				    $(that).html(''<a><span>&#x25BC;</span>''+path+''</a>'');\n				} else {\n				    var x = path.split(''/'');\n				    $(that).html(''<a><span>&#x25BC;</span>''+x[x.length-1]+''</a>'');\n				}\n				$(that).append(''<ul class="subdir"></ul>'');\n				\n				if (data.hasdir == ''true''){\n				    for (var i = 0; i < (data.directories).length; i++){\n				        var dir = data.directories[i];\n				        $(that).find(''ul.subdir'').append(''<li path="''+path+''/''+dir+''" profile_id="''+profile_id+''" class="dir"><a><span>&#x25BA;</span>''+dir+''</a></li>'');\n				    }\n				}\n\n				if (data.hasfile == ''true''){\n				    for (var i = 0; i < (data.files).length; i++){\n				        var file = data.files[i];\n				        var type = null;\n						if (file.indexOf(''.'') != -1){\n							var parts = file.split(''.'');\n							var type = parts[parts.length-1];\n						}\n\n				        $(that).find(''ul.subdir'').append(''<li path="''+path+''/''+file+''" profile_id="''+profile_id+''" class="file file-''+type+''"><a>''+file+''</a></li>'');\n				    }\n				}\n				\n				scroller = $(''div.box-wrap'').antiscroll();\n			});\n	\n			\n		}\n	})\n	\n	\n	// FILE TABS\n	$(''ul.file-tabs a'').click(function(e){\n		e.preventDefault();\n		\n	});\n	\n	$(''ul.file-tabs'').sortable({ axis: ''x'', distance: 30 });\n	\n	$(''ul.file-tabs span.close'').live(''click'',function(){\n	\n		var nextTab = $(this).parents(''li'').next().hasClass(''opened'') ? $(this).parents(''li'').next() : ($(this).parents(''li'').prev().hasClass(''opened'') ? $(this).parents(''li'').prev() : false);\n		$(''.file-related'').addClass(''disabled'');\n	\n		setTimeout(function(){\n			getFileXHR.abort();\n			$(''div.loading'').hide();\n		}, 20);\n		\n		$(this).parent(''a'').fadeOut(200, function(){\n			$(this).parents(''li'').remove();\n			if (nextTab){\n				$(nextTab).find(''a'').click();\n			} else {\n	    		$(''div.no-file-selected'').show();\n			}\n		});\n	});\n	\n	\n	// FUNCTIONS\n	\n	$(''div.file-menu a'').hover(function(){\n		$(this).addClass(''hover'');\n	}, function(){\n		$(this).removeClass(''hover'');\n	})\n	\n	$(''a.file-save'').click(function(e){\n		e.preventDefault();\n		if ($(this).hasClass(''disabled'')) return;\n		\n		saveFile(function(data){\n			$(''a.file-save'').addClass(''disabled'');\n		})\n	})\n	\n	$(''a.file-commit'').click(function(e){\n		e.preventDefault();\n		if ($(this).hasClass(''disabled'')) return;\n\n		commitFile(function(data){\n			$(''a.file-commit'').addClass(''disabled'');\n		})\n		\n	})\n	\n	$(''a.file-revisions'').click(function(e){\n		e.preventDefault();\n		if ($(this).hasClass(''disabled'')) return;\n\n		getFileRevisions(function(data){\n\n		})\n		\n	})\n\n	\n});\n\n\n\nfunction rescaleFileList(){\n	var offset = $(''#header'').height();\n	$(''#global-sidebar-list li'').each(function(){\n		offset += $(this).height();\n	});\n	var targetHeight = $(window).height() - offset;\n	$(''.box'').css(''height'',targetHeight - 5);\n	$(''.antiscroll-inner'').css(''height'',targetHeight - 5);\n}\n\nfunction openProfile(profile_id){\n	$(''div.profiles'').hide();\n	$(''div.no-file-selected'').show();\n\n\n	$(''div.file-list ul'').html(''<li style="padding: 20px 10px; text-align: center"><img  src="images/sidebar-loading.gif" /></li>'');\n	$.ajax({\n		url: base_url + ''editor/ajax/open_profile'',\n		type: ''post'',\n		data: ''id=''+profile_id,\n		dataType: ''json'',\n		success: function (data){			\n			$(''ul.file-list'').html('''');\n			\n			current_profile_id = profile_id;\n			\n			if (data.hasdir == ''true''){\n				for (var i = 0; i < (data.directories).length; i++){\n					var dir = data.directories[i];\n					$(''ul.file-list'').append(''<li path="''+dir+''" profile_id="''+profile_id+''" class="dir"><a><span>&#x25BA;</span>''+dir+''</a></li>'');\n				}\n			}\n\n			if (data.hasfile == ''true''){\n				for (var i = 0; i < (data.files).length; i++){\n					var file = data.files[i];\n					var type = null;\n					if (file.indexOf(''.'') != -1){\n						var parts = file.split(''.'');\n						var type = parts[parts.length-1];\n					}\n					$(''ul.file-list'').append(''<li path="''+file+''" profile_id="''+profile_id+''" class="file file-''+type+''"><a>''+file+''</a></li>'');\n				}\n			}\n			\n\n			\n			scroller = $(''div.box-wrap'').antiscroll();\n			$(''div.select'').css(''width'',''100%'');\n\n		}\n	})\n}\n\nfunction getFileList(profile_id, path, callback){\n	$.ajax({\n		url: base_url + ''editor/ajax/file_list/'',\n		type: ''post'',\n		data: ''id=''+profile_id+''&path=''+encodeURIComponent(path),\n		dataType: ''json'',\n		success: function (data){\n			try {\n				callback(data);\n			} catch (e){\n				// do nothing\n			}\n		}\n	});\n}\n\nfunction getFile(profile_id, filename, callback){\n	getFileXHR = $.ajax({\n	    url: base_url + ''editor/ajax/get_file'',\n	    type: ''post'',\n	    data: ''filename=''+filename+''&id=''+profile_id,\n	    dataType: ''json'',\n	    success: function (data){\n	    	try {\n		    	callback(data)\n	    	} catch (e){\n	    		// do nothing\n	    	}\n	    }\n	})\n}\n\nfunction saveFile(callback){\n\n	var filename = current_filename;\n	var profile_id = current_profile_id;\n	var contents = editor.getValue();\n\n	$.ajax({\n		url: base_url + ''editor/ajax/save_file'',\n		type: ''post'',\n		data: ''filename=''+filename+''&id=''+profile_id+''&contents=''+encodeURIComponent(contents),\n		dataType: ''json'',\n		success: function (data){\n			console.log(data);\n			try {\n				callback(data);\n			} catch (e){\n				// do nothing\n			}\n		}\n	})\n}\n\n', '2012-11-07 18:46:45', 'admin', NULL),
(27, 1, '/var/www/_dev/manager/js/email.js', '$(document).ready(function(){\n	emailResize();\n	emailListResize();\n	$(window).bind(''resize'',function(){\n		emailResize();\n		emailListResize();\n	});\n	\n	$(''a.email-mailbox'').click(function(event){\n		$(''a.email-mailbox'').parents(''li'').removeClass(''current'')\n		$(this).parents(''li'').addClass(''current'');\n		\n		event.preventDefault();\n	});\n	\n	var scrollTo = $(''#email-grid'').height()\n	$(''#email-grid'').scrollTop(200);\n	\n	$(''#email-grid tr.email-item'').click(function(){\n		$(''#email-grid tr'').removeClass(''current'');\n		$(this).addClass(''current'');\n		var msgno = $(this).attr(''rel'');\n		fetchBody(msgno);\n	});\n});\n\nfunction emailResize(){\n	var targetHeight = $(window).height() - 120;\n	$(''#email-sidebar'').height(targetHeight);\n	\n	$(''#email-body-container'').height(2* (targetHeight/3) - 10);\n	$(''#email-grid'').height((targetHeight/3) );\n	$(''#email-grid tbody'').height((targetHeight/3) - 21);\n}\n\nfunction emailListResize(){\n	var fromCellWidth = $(''#email-grid td.email-from'').width();\n	var subjectCellWidth = $(''#email-grid td.email-subject'').width();\n	var dateCellWidth = $(''#email-grid td.email-date'').width();\n	var tableWidth = $(''#email-grid table'').width();\n	var gridWidth = $(''#email-grid'').width();\n	\n	$(''#email-grid th.email-from'').width(fromCellWidth);\n	$(''#email-grid th.email-subject'').width(subjectCellWidth);\n	$(''#email-grid th.email-date'').width(dateCellWidth);\n	\n}\n\nfunction fetchBody(msgno){\n	$.ajax({type: "POST",\n		url: base_url+"email/body/"+msgno,\n		success: function(html){\n			$(''#email-body-container'').html(html);\n		}\n	});\n}', '2012-11-07 18:46:48', 'admin', NULL),
(28, 1, '/var/www/_dev/manager/js/validator.js', '/*\n * Inline Form Validation Engine 1.6.2, jQuery plugin\n * \n * Copyright(c) 2009, Cedric Dugas\n * http://www.position-relative.net\n *	\n * Form validation engine allowing custom regex rules to be added.\n * Thanks to Francois Duquette\n * Licenced under the MIT Licence\n */\n \n(function($) {\n	\n	$.fn.validationEngine = function(settings) {\n\n	if($.validationEngineLanguage){				// IS THERE A LANGUAGE LOCALISATION ?\n		allRules = $.validationEngineLanguage.allRules;\n	}else{\n		$.validationEngine.debug("Validation engine rules are not loaded check your external file");\n	}\n 	settings = jQuery.extend({\n		allrules:allRules,\n		validationEventTriggers:"blur",					\n		inlineValidation: true,	\n		returnIsValid:false,\n		animateSubmit:true,\n		unbindEngine:true,\n		ajaxSubmit: false,\n		promptPosition: "topRight",	// OPENNING BOX POSITION, IMPLEMENTED: topLeft, topRight, bottomLeft, centerRight, bottomRight\n		success : false,\n		failure : function() {}\n	}, settings);	\n	$.validationEngine.settings = settings;\n	$.validationEngine.ajaxValidArray = new Array();	// ARRAY FOR AJAX: VALIDATION MEMORY \n	\n	if(settings.inlineValidation == true){ 		// Validating Inline ?\n		if(!settings.returnIsValid){					// NEEDED FOR THE SETTING returnIsValid\n			allowReturnIsvalid = false;\n			$(this).find("[class*=validate]").not("[type=checkbox]").bind(settings.validationEventTriggers, function(caller){ _inlinEvent(this); })\n			$(this).find("[class*=validate][type=checkbox]").bind("click", function(caller){ _inlinEvent(this); })\n\n			firstvalid = false;\n		}\n			function _inlinEvent(caller){\n				$.validationEngine.settings = settings;\n				if($.validationEngine.intercept == false || !$.validationEngine.intercept){		// STOP INLINE VALIDATION THIS TIME ONLY\n					$.validationEngine.onSubmitValid=false;\n					$.validationEngine.loadValidation(caller); \n				}else{\n					$.validationEngine.intercept = false;\n				}\n			}\n	}\n	if (settings.returnIsValid){		// Do validation and return true or false, it bypass everything;\n		if ($.validationEngine.submitValidation(this,settings)){\n			return false;\n		}else{\n			return true;\n		}\n	}\n	$(this).bind("submit", function(caller){   // ON FORM SUBMIT, CONTROL AJAX FUNCTION IF SPECIFIED ON DOCUMENT READY\n		$.validationEngine.onSubmitValid = true;\n		$.validationEngine.settings = settings;\n		if($.validationEngine.submitValidation(this,settings) == false){\n			if($.validationEngine.submitForm(this,settings) == true) {return false;}\n		}else{\n			settings.failure && settings.failure(); \n			return false;\n		}		\n	})\n};	\n$.validationEngine = {\n	defaultSetting : function(caller) {	\n		if($.validationEngineLanguage){				// IS THERE A LANGUAGE LOCALISATION ?\n			allRules = $.validationEngineLanguage.allRules;\n		}else{\n			$.validationEngine.debug("Validation engine rules are not loaded check your external file");\n		}	\n		settings = {\n			allrules:allRules,\n			validationEventTriggers:"blur",					\n			inlineValidation: true,	\n			returnIsValid:false,\n			animateSubmit:true,\n			unbindEngine:true,\n			ajaxSubmit: false,\n			promptPosition: "topRight",	// OPENNING BOX POSITION, IMPLEMENTED: topLeft, topRight, bottomLeft, centerRight, bottomRight\n			success : false,\n			failure : function() {}\n		}	\n		$.validationEngine.settings = settings;\n	},\n	loadValidation : function(caller) {		// GET VALIDATIONS TO BE EXECUTED\n		if(!$.validationEngine.settings){\n			$.validationEngine.defaultSetting()\n		}\n		rulesParsing = $(caller).attr(''class'');\n		rulesRegExp = /\\[(.*)\\]/;\n		getRules = rulesRegExp.exec(rulesParsing);\n		str = getRules[1];\n		pattern = /\\W+/;\n		result= str.split(pattern);	\n		\n		var validateCalll = $.validationEngine.validateCall(caller,result)\n		return validateCalll;\n	},\n	validateCall : function(caller,rules) {	// EXECUTE VALIDATION REQUIRED BY THE USER FOR THIS FIELD\n		var promptText =""	\n		\n		if(!$(caller).attr("id")) { $.validationEngine.debug("This field have no ID attribut( name & class displayed): "+$(caller).attr("name")+" "+$(caller).attr("class")) }\n\n		caller = caller;\n		ajaxValidate = false;\n		var callerName = $(caller).attr("name");\n		$.validationEngine.isError = false;\n		$.validationEngine.showTriangle = true;\n		callerType = $(caller).attr("type");\n\n		for (i=0; i<rules.length;i++){\n			switch (rules[i]){\n			case "optional": \n				if(!$(caller).val()){\n					$.validationEngine.closePrompt(caller);\n					return $.validationEngine.isError;\n				}\n			break;\n			case "required": \n				_required(caller,rules);\n			break;\n			case "custom": \n				 _customRegex(caller,rules,i);\n			break;\n			case "ajax": \n				if(!$.validationEngine.onSubmitValid){\n					_ajax(caller,rules,i);	\n				};\n			break;\n			case "length": \n				 _length(caller,rules,i);\n			break;\n			case "maxCheckbox": \n				_maxCheckbox(caller,rules,i);\n			 	groupname = $(caller).attr("name");\n			 	caller = $("input[name=''"+groupname+"'']");\n			break;\n			case "minCheckbox": \n				_minCheckbox(caller,rules,i);\n				groupname = $(caller).attr("name");\n			 	caller = $("input[name=''"+groupname+"'']");\n			break;\n			case "confirm": \n				 _confirm(caller,rules,i);\n			break;\n			default :;\n			};\n		};\n		radioHack();\n		if ($.validationEngine.isError == true){\n			linkTofield = $.validationEngine.linkTofield(caller);\n			\n			($("div."+linkTofield).size() ==0) ? $.validationEngine.buildPrompt(caller,promptText,"error")	: $.validationEngine.updatePromptText(caller,promptText);\n		}else{ $.validationEngine.closePrompt(caller);}			\n		/* UNFORTUNATE RADIO AND CHECKBOX GROUP HACKS */\n		/* As my validation is looping input with id''s we need a hack for my validation to understand to group these inputs */\n		function radioHack(){\n	      if($("input[name=''"+callerName+"'']").size()> 1 && (callerType == "radio" || callerType == "checkbox")) {        // Hack for radio/checkbox group button, the validation go the first radio/checkbox of the group\n	          caller = $("input[name=''"+callerName+"''][type!=hidden]:first");     \n	          $.validationEngine.showTriangle = false;\n	      }      \n	    }\n		/* VALIDATION FUNCTIONS */\n		function _required(caller,rules){   // VALIDATE BLANK FIELD\n			callerType = $(caller).attr("type");\n			if (callerType == "text" || callerType == "password" || callerType == "textarea"){\n								\n				if(!$(caller).val()){\n					$.validationEngine.isError = true;\n					promptText += $.validationEngine.settings.allrules[rules[i]].alertText+"<br />";\n				}	\n			}	\n			if (callerType == "radio" || callerType == "checkbox" ){\n				callerName = $(caller).attr("name");\n		\n				if($("input[name=''"+callerName+"'']:checked").size() == 0) {\n					$.validationEngine.isError = true;\n					if($("input[name=''"+callerName+"'']").size() ==1) {\n						promptText += $.validationEngine.settings.allrules[rules[i]].alertTextCheckboxe+"<br />"; \n					}else{\n						 promptText += $.validationEngine.settings.allrules[rules[i]].alertTextCheckboxMultiple+"<br />";\n					}	\n				}\n			}	\n			if (callerType == "select-one") { // added by paul@kinetek.net for select boxes, Thank you		\n				if(!$(caller).val()) {\n					$.validationEngine.isError = true;\n					promptText += $.validationEngine.settings.allrules[rules[i]].alertText+"<br />";\n				}\n			}\n			if (callerType == "select-multiple") { // added by paul@kinetek.net for select boxes, Thank you	\n				if(!$(caller).find("option:selected").val()) {\n					$.validationEngine.isError = true;\n					promptText += $.validationEngine.settings.allrules[rules[i]].alertText+"<br />";\n				}\n			}\n		}\n		function _customRegex(caller,rules,position){		 // VALIDATE REGEX RULES\n			customRule = rules[position+1];\n			pattern = eval($.validationEngine.settings.allrules[customRule].regex);\n			\n			if(!pattern.test($(caller).attr(''value''))){\n				$.validationEngine.isError = true;\n				promptText += $.validationEngine.settings.allrules[customRule].alertText+"<br />";\n			}\n		}\n		function _ajax(caller,rules,position){				 // VALIDATE AJAX RULES\n			\n			customAjaxRule = rules[position+1];\n			postfile = $.validationEngine.settings.allrules[customAjaxRule].file;\n			fieldValue = $(caller).val();\n			ajaxCaller = caller;\n			fieldId = $(caller).attr("id");\n			ajaxValidate = true;\n			ajaxisError = $.validationEngine.isError;\n			\n			if(!$.validationEngine.settings.allrules[customAjaxRule].extraData){\n				extraData = $.validationEngine.settings.allrules[customAjaxRule].extraData;\n			}else{\n				extraData = "";\n			}\n			/* AJAX VALIDATION HAS ITS OWN UPDATE AND BUILD UNLIKE OTHER RULES */	\n			if(!ajaxisError){\n				$.ajax({\n				   	type: "POST",\n				   	url: postfile,\n				   	async: true,\n				   	data: "validateValue="+fieldValue+"&validateId="+fieldId+"&validateError="+customAjaxRule+extraData,\n				   	beforeSend: function(){		// BUILD A LOADING PROMPT IF LOAD TEXT EXIST		   			\n				   		if($.validationEngine.settings.allrules[customAjaxRule].alertTextLoad){\n				   		\n				   			if(!$("div."+fieldId+"formError")[0]){				   				\n	 			 				return $.validationEngine.buildPrompt(ajaxCaller,$.validationEngine.settings.allrules[customAjaxRule].alertTextLoad,"load");\n	 			 			}else{\n	 			 				$.validationEngine.updatePromptText(ajaxCaller,$.validationEngine.settings.allrules[customAjaxRule].alertTextLoad,"load");\n	 			 			}\n			   			}\n			  	 	},\n			  	 	error: function(data,transport){ $.validationEngine.debug("error in the ajax: "+data.status+" "+transport) },\n					success: function(data){					// GET SUCCESS DATA RETURN JSON\n						data = eval( "("+data+")");				// GET JSON DATA FROM PHP AND PARSE IT\n						ajaxisError = data.jsonValidateReturn[2];\n						customAjaxRule = data.jsonValidateReturn[1];\n						ajaxCaller = $("#"+data.jsonValidateReturn[0])[0];\n						fieldId = ajaxCaller;\n						ajaxErrorLength = $.validationEngine.ajaxValidArray.length;\n						existInarray = false;\n						\n			 			 if(ajaxisError == "false"){			// DATA FALSE UPDATE PROMPT WITH ERROR;\n			 			 	\n			 			 	_checkInArray(false)				// Check if ajax validation alreay used on this field\n			 			 	\n			 			 	if(!existInarray){		 			// Add ajax error to stop submit		 		\n				 			 	$.validationEngine.ajaxValidArray[ajaxErrorLength] =  new Array(2);\n				 			 	$.validationEngine.ajaxValidArray[ajaxErrorLength][0] = fieldId;\n				 			 	$.validationEngine.ajaxValidArray[ajaxErrorLength][1] = false;\n				 			 	existInarray = false;\n			 			 	}\n				\n			 			 	$.validationEngine.ajaxValid = false;\n							promptText += $.validationEngine.settings.allrules[customAjaxRule].alertText+"<br />";\n							$.validationEngine.updatePromptText(ajaxCaller,promptText,"",true);				\n						 }else{	 \n						 	_checkInArray(true);\n						 	$.validationEngine.ajaxValid = true; 						   \n	 			 			if($.validationEngine.settings.allrules[customAjaxRule].alertTextOk){	// NO OK TEXT MEAN CLOSE PROMPT	 			\n	 			 				 				$.validationEngine.updatePromptText(ajaxCaller,$.validationEngine.settings.allrules[customAjaxRule].alertTextOk,"pass",true);\n 			 				}else{\n				 			 	ajaxValidate = false;		 	\n				 			 	$.validationEngine.closePrompt(ajaxCaller);\n 			 				}		\n			 			 }\n			 			function  _checkInArray(validate){\n			 				for(x=0;x<ajaxErrorLength;x++){\n			 			 		if($.validationEngine.ajaxValidArray[x][0] == fieldId){\n			 			 			$.validationEngine.ajaxValidArray[x][1] = validate;\n			 			 			existInarray = true;\n			 			 		\n			 			 		}\n			 			 	}\n			 			}\n			 		}				\n				});\n			}\n		}\n		function _confirm(caller,rules,position){		 // VALIDATE FIELD MATCH\n			confirmField = rules[position+1];\n			\n			if($(caller).attr(''value'') != $("#"+confirmField).attr(''value'')){\n				$.validationEngine.isError = true;\n				promptText += $.validationEngine.settings.allrules["confirm"].alertText+"<br />";\n			}\n		}\n		function _length(caller,rules,position){    	  // VALIDATE LENGTH\n		\n			startLength = eval(rules[position+1]);\n			endLength = eval(rules[position+2]);\n			feildLength = $(caller).attr(''value'').length;\n\n			if(feildLength<startLength || feildLength>endLength){\n				$.validationEngine.isError = true;\n				promptText += $.validationEngine.settings.allrules["length"].alertText+startLength+$.validationEngine.settings.allrules["length"].alertText2+endLength+$.validationEngine.settings.allrules["length"].alertText3+"<br />"\n			}\n		}\n		function _maxCheckbox(caller,rules,position){  	  // VALIDATE CHECKBOX NUMBER\n		\n			nbCheck = eval(rules[position+1]);\n			groupname = $(caller).attr("name");\n			groupSize = $("input[name=''"+groupname+"'']:checked").size();\n			if(groupSize > nbCheck){	\n				$.validationEngine.showTriangle = false;\n				$.validationEngine.isError = true;\n				promptText += $.validationEngine.settings.allrules["maxCheckbox"].alertText+"<br />";\n			}\n		}\n		function _minCheckbox(caller,rules,position){  	  // VALIDATE CHECKBOX NUMBER\n		\n			nbCheck = eval(rules[position+1]);\n			groupname = $(caller).attr("name");\n			groupSize = $("input[name=''"+groupname+"'']:checked").size();\n			if(groupSize < nbCheck){	\n			\n				$.validationEngine.isError = true;\n				$.validationEngine.showTriangle = false;\n				promptText += $.validationEngine.settings.allrules["minCheckbox"].alertText+" "+nbCheck+" "+$.validationEngine.settings.allrules["minCheckbox"].alertText2+"<br />";\n			}\n		}\n		return($.validationEngine.isError) ? $.validationEngine.isError : false;\n	},\n	submitForm : function(caller){\n		if($.validationEngine.settings.ajaxSubmit){		\n			if($.validationEngine.settings.ajaxSubmitExtraData){\n				extraData = $.validationEngine.settings.ajaxSubmitExtraData;\n			}else{\n				extraData = "";\n			}\n			$.ajax({\n			   	type: "POST",\n			   	url: $.validationEngine.settings.ajaxSubmitFile,\n			   	async: true,\n			   	data: $(caller).serialize()+"&"+extraData,\n			   	error: function(data,transport){ $.validationEngine.debug("error in the ajax: "+data.status+" "+transport) },\n			   	success: function(data){\n			   		if(data == "true"){			// EVERYTING IS FINE, SHOW SUCCESS MESSAGE\n			   			$(caller).css("opacity",1)\n			   			$(caller).animate({opacity: 0, height: 0}, function(){\n			   				$(caller).css("display","none");\n			   				$(caller).before("<div class=''ajaxSubmit''>"+$.validationEngine.settings.ajaxSubmitMessage+"</div>");\n			   				$.validationEngine.closePrompt(".formError",true); 	\n			   				$(".ajaxSubmit").show("slow");\n			   				if ($.validationEngine.settings.success){	// AJAX SUCCESS, STOP THE LOCATION UPDATE\n								$.validationEngine.settings.success && $.validationEngine.settings.success(); \n								return false;\n							}\n			   			})\n		   			}else{						// HOUSTON WE GOT A PROBLEM (SOMETING IS NOT VALIDATING)\n			   			data = eval( "("+data+")");	\n			   			if(!data.jsonValidateReturn){\n			   				 $.validationEngine.debug("you are not going into the success fonction and jsonValidateReturn return nothing");\n			   			}\n			   			errorNumber = data.jsonValidateReturn.length	\n			   			for(index=0; index<errorNumber; index++){	\n			   				fieldId = data.jsonValidateReturn[index][0];\n			   				promptError = data.jsonValidateReturn[index][1];\n			   				type = data.jsonValidateReturn[index][2];\n			   				$.validationEngine.buildPrompt(fieldId,promptError,type);\n		   				}\n	   				}\n   				}\n			})	\n			return true;\n		}\n		if ($.validationEngine.settings.success){	// AJAX SUCCESS, STOP THE LOCATION UPDATE\n			if($.validationEngine.settings.unbindEngine){ $(caller).unbind("submit") }\n			$.validationEngine.settings.success && $.validationEngine.settings.success(); \n			return true;\n		}\n		return false;\n	},\n	buildPrompt : function(caller,promptText,type,ajaxed) {			// ERROR PROMPT CREATION AND DISPLAY WHEN AN ERROR OCCUR\n		if(!$.validationEngine.settings){\n			$.validationEngine.defaultSetting()\n		}\n		var divFormError = document.createElement(''div'');\n		var formErrorContent = document.createElement(''div'');\n		\n		linkTofield = $.validationEngine.linkTofield(caller)\n		$(divFormError).addClass("formError")\n		\n		if(type == "pass"){ $(divFormError).addClass("greenPopup") }\n		if(type == "load"){ $(divFormError).addClass("blackPopup") }\n		if(ajaxed){ $(divFormError).addClass("ajaxed") }\n		\n		$(divFormError).addClass(linkTofield);\n		$(formErrorContent).addClass("formErrorContent");\n		\n		$("body").append(divFormError);\n		$(divFormError).append(formErrorContent);\n			\n		if($.validationEngine.showTriangle != false){		// NO TRIANGLE ON MAX CHECKBOX AND RADIO\n			var arrow = document.createElement(''div'');\n			$(arrow).addClass("formErrorArrow");\n			$(divFormError).append(arrow);\n			if($.validationEngine.settings.promptPosition == "bottomLeft" || $.validationEngine.settings.promptPosition == "bottomRight"){\n			$(arrow).addClass("formErrorArrowBottom")\n			$(arrow).html(''<div class="line1"><!-- --></div><div class="line2"><!-- --></div><div class="line3"><!-- --></div><div class="line4"><!-- --></div><div class="line5"><!-- --></div><div class="line6"><!-- --></div><div class="line7"><!-- --></div><div class="line8"><!-- --></div><div class="line9"><!-- --></div><div class="line10"><!-- --></div>'');\n		}\n			if($.validationEngine.settings.promptPosition == "topLeft" || $.validationEngine.settings.promptPosition == "topRight"){\n				$(divFormError).append(arrow);\n				$(arrow).html(''<div class="line10"><!-- --></div><div class="line9"><!-- --></div><div class="line8"><!-- --></div><div class="line7"><!-- --></div><div class="line6"><!-- --></div><div class="line5"><!-- --></div><div class="line4"><!-- --></div><div class="line3"><!-- --></div><div class="line2"><!-- --></div><div class="line1"><!-- --></div>'');\n			}\n		}\n		$(formErrorContent).html(promptText)\n	\n		callerTopPosition = $(caller).offset().top;\n		callerleftPosition = $(caller).offset().left;\n		callerWidth =  $(caller).width();\n		inputHeight = $(divFormError).height();\n	\n		/* POSITIONNING */\n		if($.validationEngine.settings.promptPosition == "topRight"){callerleftPosition +=  callerWidth -30; callerTopPosition += -inputHeight -10; }\n		if($.validationEngine.settings.promptPosition == "topLeft"){ callerTopPosition += -inputHeight -10; }\n		\n		if($.validationEngine.settings.promptPosition == "centerRight"){ callerleftPosition +=  callerWidth +13; }\n		\n		if($.validationEngine.settings.promptPosition == "bottomLeft"){\n			callerHeight =  $(caller).height();\n			callerleftPosition = callerleftPosition;\n			callerTopPosition = callerTopPosition + callerHeight + 15;\n		}\n		if($.validationEngine.settings.promptPosition == "bottomRight"){\n			callerHeight =  $(caller).height();\n			callerleftPosition +=  callerWidth -30;\n			callerTopPosition +=  callerHeight + 15;\n		}\n		$(divFormError).css({\n			top:callerTopPosition,\n			left:callerleftPosition,\n			opacity:0\n		})\n		return $(divFormError).animate({"opacity":0.87},function(){return true;});	\n	},\n	updatePromptText : function(caller,promptText,type,ajaxed) {	// UPDATE TEXT ERROR IF AN ERROR IS ALREADY DISPLAYED\n		\n		linkTofield = $.validationEngine.linkTofield(caller);\n		var updateThisPrompt =  "."+linkTofield;\n		\n		if(type == "pass") { $(updateThisPrompt).addClass("greenPopup") }else{ $(updateThisPrompt).removeClass("greenPopup")};\n		if(type == "load") { $(updateThisPrompt).addClass("blackPopup") }else{ $(updateThisPrompt).removeClass("blackPopup")};\n		if(ajaxed) { $(updateThisPrompt).addClass("ajaxed") }else{ $(updateThisPrompt).removeClass("ajaxed")};\n	\n		$(updateThisPrompt).find(".formErrorContent").html(promptText);\n		callerTopPosition  = $(caller).offset().top;\n		inputHeight = $(updateThisPrompt).height();\n		\n		if($.validationEngine.settings.promptPosition == "bottomLeft" || $.validationEngine.settings.promptPosition == "bottomRight"){\n			callerHeight =  $(caller).height();\n			callerTopPosition =  callerTopPosition + callerHeight + 15;\n		}\n		if($.validationEngine.settings.promptPosition == "centerRight"){  callerleftPosition +=  callerWidth +13;}\n		if($.validationEngine.settings.promptPosition == "topLeft" || $.validationEngine.settings.promptPosition == "topRight"){\n			callerTopPosition = callerTopPosition  -inputHeight -10;\n		}\n		$(updateThisPrompt).animate({ top:callerTopPosition });\n	},\n	linkTofield : function(caller){\n		linkTofield = $(caller).attr("id") + "formError";\n		linkTofield = linkTofield.replace(/\\[/g,""); \n		linkTofield = linkTofield.replace(/\\]/g,"");\n		return linkTofield;\n	},\n	closePrompt : function(caller,outside) {						// CLOSE PROMPT WHEN ERROR CORRECTED\n		if(!$.validationEngine.settings){\n			$.validationEngine.defaultSetting()\n		}\n		if(outside){\n			$(caller).fadeTo("fast",0,function(){\n				$(caller).remove();\n			});\n			return false;\n		}\n		if(!ajaxValidate){\n			linkTofield = $.validationEngine.linkTofield(caller);\n			closingPrompt = "."+linkTofield;\n			$(closingPrompt).fadeTo("fast",0,function(){\n				$(closingPrompt).remove();\n			});\n		}\n	},\n	debug : function(error) {\n		if(!$("#debugMode")[0]){\n			$("body").append("<div id=''debugMode''><div class=''debugError''><strong>This is a debug mode, you got a problem with your form, it will try to help you, refresh when you think you nailed down the problem</strong></div></div>");\n		}\n		$(".debugError").append("<div class=''debugerror''>"+error+"</div>");\n	},			\n	submitValidation : function(caller) {					// FORM SUBMIT VALIDATION LOOPING INLINE VALIDATION\n		var stopForm = false;\n		$.validationEngine.ajaxValid = true;\n		$(caller).find(".formError").remove();\n		var toValidateSize = $(caller).find("[class*=validate]").size();\n		\n		$(caller).find("[class*=validate]").each(function(){\n			linkTofield = $.validationEngine.linkTofield(this);\n			\n			if(!$("."+linkTofield).hasClass("ajaxed")){	// DO NOT UPDATE ALREADY AJAXED FIELDS (only happen if no normal errors, don''t worry)\n				var validationPass = $.validationEngine.loadValidation(this);\n				return(validationPass) ? stopForm = true : "";					\n			};\n		});\n		ajaxErrorLength = $.validationEngine.ajaxValidArray.length;		// LOOK IF SOME AJAX IS NOT VALIDATE\n		for(x=0;x<ajaxErrorLength;x++){\n	 		if($.validationEngine.ajaxValidArray[x][1] == false){\n	 			$.validationEngine.ajaxValid = false;\n 			}\n 		}\n		if(stopForm || !$.validationEngine.ajaxValid){		// GET IF THERE IS AN ERROR OR NOT FROM THIS VALIDATION FUNCTIONS\n			if($.validationEngine.settings.animateSubmit){\n				destination = $(".formError:not(''.greenPopup''):first").offset().top;\n				$(".formError:not(''.greenPopup'')").each(function(){\n					testDestination = $(this).offset().top;\n					if(destination>testDestination){\n						destination = $(this).offset().top;\n					}\n				})\n				$("html:not(:animated),body:not(:animated)").animate({ scrollTop: destination}, 1100);\n			}\n			return true;\n		}else{\n			return false;\n		}\n	}\n}\n})(jQuery);', '2012-11-07 18:47:00', 'admin', NULL),
(29, 1, '/var/www/_dev/os/application/language/english/index.html', '<html>\n<head>\n	<title>403 Forbidden</title>\n</head>\n<body>\n\n<p>Directory access is forbidden.</p>\n\n</body>\n</html>', '2012-11-07 18:50:43', 'admin', NULL),
(30, 1, '/var/www/_dev/os/application/views/fnb/iphone.php', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\n<html>\n	<head>\n		<title>Plexcloud F&amp;B</title>\n		<script type="text/javascript" src="<?php echo base_url(); ?>js/fnb/jquery-1.4.3.min.js"></script>\n		<script type="text/javascript" src="<?php echo base_url(); ?>js/fnb/iphone-webframework.js"></script>\n		<script type="text/javascript" src="<?php echo base_url(); ?>js/fnb/iphone-interactions.js"></script>\n		<script type="text/javascript" src="<?php echo base_url(); ?>js/fnb/iscroll.js"></script>\n		<script type="text/javascript" src="<?php echo base_url(); ?>js/fnb/shake.js"></script>\n		<script type="text/javascript" src="<?php echo base_url(); ?>js/fnb/swipe.js"></script>\n\n		<script type="text/javascript">\n			var base_url = "<?php echo base_url(); ?>";\n			var currency = "<?php echo $this->system->config(''currency''); ?>";\n		</script>\n		\n		<!--\n		<link rel="apple-touch-icon" href="<?php echo base_url(); ?>images/plexcloud_icon.png" />\n		<link rel="apple-touch-startup-image" href="<?php echo base_url(); ?>images/plexcloud_splash.png" />\n		-->\n		\n		<!-- iPhone ICON -->\n        <link href="<?php echo base_url(); ?>images/plexcloud-fnb-icon.png" sizes="57x57" rel="apple-touch-icon">\n        <!-- iPhone (Retina) ICON-->\n        <link href="<?php echo base_url(); ?>images/plexcloud-fnb-icon-retina.png" sizes="114x114" rel="apple-touch-icon">\n\n        <!-- iPhone SPLASHSCREEN-->\n        <link href="<?php echo base_url(); ?>images/plexcloud-fnb-splash.png" media="(device-width: 320px)" rel="apple-touch-startup-image">\n        <!-- iPhone (Retina) SPLASHSCREEN-->\n        <link href="<?php echo base_url(); ?>images/plexcloud-fnb-splash-retina.png" media="(device-width: 320px) and (-webkit-device-pixel-ratio: 2)" rel="apple-touch-startup-image">\n        \n        		\n		<link rel="stylesheet" href="<?php echo base_url(); ?>css/fnb/iphone/style.css?122" />\n		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0;" > \n		<meta name="apple-mobile-web-app-capable" content="yes" />\n		<meta name="apple-mobile-web-app-status-bar-style" content="black" />\n		\n		\n	</head>\n	<body ontouchmove="touchMove(event)">\n	<div id="content">\n		<div class="overlay"></div>\n		<div class="topbar">\n			<button id="btn-logout" rel="home" class="topbar-button" style="float: left; margin-right: 35px;">Logout</button>\n\n			<button id="btn-home" rel="table" class="topbar-button float-left">Back</button>\n			<button id="btn-add-item" rel="table" class="topbar-button">Add Item</button>\n			<button id="btn-back" class="topbar-button">Back</button>\n			<span class="topbar-title">Plexcloud</span>\n		</div>\n		<div id="home" class="screen">\n			<p class="left-pad text-shadowed" style="color: #FFF">Logged in as <strong><?php echo $this->user->data(''username''); ?></strong></p>\n			<div class="p-btn-container" style="color: #FFF">\n				<table style="width: 100%">\n					<tr>\n						<td style="padding: 5px">Table Number</td>\n						<td style="text-align: right"><span class="p-table-field" style="font-size: 15pt; width: 65px;"></span></td>\n						<td><div class="p-btn" style="float: right">GO</div></td>\n					</tr>\n				</table>\n\n				<div class="numbers">\n					<div class="p-btn">1</div>\n					<div class="p-btn">2</div>\n					<div class="p-btn">3</div>\n					<br class="clearboth" />\n					<div class="p-btn">4</div>\n					<div class="p-btn">5</div>\n					<div class="p-btn">6</div>\n					<br class="clearboth" />\n					<div class="p-btn">7</div>\n					<div class="p-btn">8</div>\n					<div class="p-btn">9</div>\n					<br class="clearboth" />\n					<div class="p-btn">.</div>\n					<div class="p-btn">0</div>\n					<div class="p-btn">Clear</div>\n					<br class="clearboth" />\n				</div>\n			</div>\n		\n\n			<div class="scroller-container table-list" style="height: 320px;  display: none">\n				<div id="scroller-table" style="min-height: 320px;">\n					<ul class="list table-list">\n					</ul>\n				</div>\n			</div>\n			\n			<div class="collapse-pane">Show Active Tables</div>\n		</div>\n		\n		<div id="add-table" class="screen allow-back">\n			<p class="left-pad text-shadowed"><strong class="white">Enter Table Number</strong></p>\n			<input type="tel" id="in-table-number" maxlength="4" class="in" />\n			<button id="btn-go-table" style="margin-top: 10px;">Go</button>\n			<p class="left-pad text-shadowed table-errmsg" style="color: red"></p>\n		</div>\n		\n		<div id="table" class="screen">\n\n			<button id="btn-submit-orders" style="margin-top: 10px; float: right; width: 120px; font-size: 10pt;">Submit Order</button>\n\n			<p class="left-pad text-shadowed"><strong class="white">Table #<span class="table-no"></span></strong></p>\n			<p class="left-pad text-shadowed"><strong class="white">Amount due: RM<span class="amount-due"></span></strong></p>\n			<div class="scroller-container">\n				<div id="scroller-order" style="min-height: 320px">\n					<ul class="list order-list">\n				\n					</ul>\n					<br style="clear:both" />\n				</div>\n			</div>\n		</div>\n		\n		<div id="menu" class="screen_overlay">\n			<div class="dropdown">\n				<span class="arrow">&#x25bc;</span>\n				<span class="current">Food</span>\n				<div class="dropdown-content">\n					<ul id="tab-menu" class="list">\n						<?php foreach ($cd as $category): ?>\n						<li class="category" rel="<?php echo str_replace('' '',''-'',$category->category); ?>"><?php echo $category->category; ?></li>\n						<?php endforeach; ?>\n					</ul>\n				</div>\n			</div>\n			<div class="menu" style="margin-top: 10px">\n				<?php foreach ($categories as $category): ?>\n				<?php foreach ($category->subcategories as $subcategory => $items): ?>\n				<ul class="select-list item-list" rel="<?php echo str_replace('' '',''-'',$subcategory); ?>">\n					<?php foreach ($items as $item): ?>\n						<?php \n							$class = null;\n							if ($item->options == ''false''){\n							\n							} else {\n								$item_options = json_decode($item->options);\n								if (!count($item_options)) $class[] = ''no-option'';\n							}\n							if ($item->enter_price) $class[] = ''enter-price'';\n							\n							$io = ''class="''.implode('' '', $class).''"'';\n						?>\n					<li name="<?php echo $item->name; ?>" sku="<?php echo $item->sku; ?>" price="<?php echo $item->item_price; ?>" <?php echo $io; ?> rel="item<?php echo $item->id; ?>"><span><?php echo $item->name; ?></span></li>\n					<?php endforeach; ?>\n				</ul>\n				<?php endforeach; ?>\n				<?php endforeach; ?>\n				\n				<?php foreach ($categories as $category): ?>\n					<ul class="select-list subcat" style="display:none" rel="<?php echo str_replace('' '',''-'',$category->category); ?>">\n					<?php foreach ($category->subcategories as $subcategory => $items): ?>\n						<li class="subcat" rel="<?php echo str_replace('' '',''-'',$subcategory); ?>"><?php echo $subcategory; ?></li>									\n					<?php endforeach; ?>\n					</ul>\n				<?php endforeach; ?>\n\n				<div class="scroller-wrapper">\n				<div class="item-options">\n \n					<?php foreach ($categories as $category): ?>\n					<?php foreach ($category->items as $item): ?>\n					<div class="item-option" rel="item<?php echo $item->id; ?>">\n					\n						<button class="green float-right done-select" style="padding: 10px 28px; margin-right: 3px">Done</button>\n						<button class="float-right option-back" style="padding: 10px 28px;">Back</button>\n						<button class="red float-right clear-select" style="padding: 10px 28px">Clear</button>\n						<br style="clear: right" />						\n						<button class="float-right qty-add" style="padding: 10px 17px; margin-right: 3px">+</button>\n						<button class="float-right qty-deduct" style="padding: 10px 18px">-</button>\n\n						<p style="padding: 0 5px; height:30px">\n							<strong><?php echo $item->name; ?></strong> (<span class="cur-item-price"></span>) x <span class="cur-item-qty"></span><br /><span class="cur-item-option"></span>\n						</p>\n\n						<ul class="select-list item-option">\n							<?php \n								$options = json_decode($item->options);\n								$prices = json_decode($item->price);\n							?>\n							<?php for ($i = 0; $i < count($options); $i++): ?>\n							<li name="<?php echo $item->name; ?>" sku="<?php echo $item->sku; ?>" class="option stay" option="<?php echo str_replace('' '',''_'',$options[$i]); ?>" price="<?php echo $prices[$i]; ?>"><?php echo $options[$i]; ?></li>\n							<?php endfor; ?>\n						</ul>\n						<br class="clearboth" />\n					</div>\n					<?php endforeach; ?>\n					<?php endforeach; ?>\n				</div>\n				</div>\n			</div>\n			<span class="alert" style="float: right; margin-left: 5px"></span>\n			<button id="btn-menu-done" class="green" style="padding-left: 20px; padding-right: 20px">Done</button>\n			<button id="btn-menu-back" class="" style="padding-left: 20px; padding-right: 20px; display: none">Back</button>\n\n		</div>\n		<div id="enter-price" class="screen_overlay">\n			<p style="font-size: 12pt; height: 30px; padding-top: 3px"><input type="tel" id="in-price" class="in" style="text-align: right; margin-right: 6px; width: 120px !important" readonly /><span style="padding: 7px 5px 0 5px; float: left; display: block; font-weight: bold">Price</span></p>\n			<p style="font-size: 12pt; height: 30px; padding-top: 3px"><input type="tel" id="in-qty" class="in" style="text-align: right; margin-right: 6px; width: 120px !important" /><span style="padding: 7px 5px 0 5px; float: left; display: block; font-weight: bold;">Quantity</span></p>\n			<!-- <button id="btn-price-done" class="green float-right" style="padding-left: 20px; padding-right: 20px">Done</button> -->\n			<div class="price-numbers" style="padding-top: 5px">\n				<div class="x-btn">1</div>\n			    <div class="x-btn">2</div>\n			    <div class="x-btn">3</div>\n			    <br class="clearboth" />\n			    <div class="x-btn">4</div>\n			    <div class="x-btn">5</div>\n			    <div class="x-btn">6</div>\n			    <br class="clearboth" />\n			    <div class="x-btn">7</div>\n			    <div class="x-btn">8</div>\n			    <div class="x-btn">9</div>\n			    <br class="clearboth" />\n			    <div class="x-btn">CLR</div>\n			    <div class="x-btn">0</div>\n			    <div class="x-btn">OK</div>\n			    <br class="clearboth" />\n			    <div class="x-btn" style="background: #333; color:#FFF">+</div>\n			    <div class="x-btn" style="background: #333; color:#FFF">-</div>\n			</div>\n		</div>\n	</div>\n	</body>\n</html>', '2012-11-07 18:51:13', 'admin', NULL),
(31, 1, '/var/www/_dev/os/js/fnb/session.js', '$(document).ready(function(){\n	\n	getSessionData();\n	\n\n});\n\nfunction getSessionData(){\n	$.ajax({\n		url: base_url + ''fnbpos/pos_session_data'',\n		dataType: ''json'',\n		success: function (session){\n\n			$(''strong.session_logged_in_time'').text(session.logged_in_time);\n			$(''strong.session_logged_in_duration'').text(session.logged_in_duration);\n			$(''strong.session_logged_in_as'').text(session.logged_in_as);\n			$(''strong.session_time'').text(session.time);\n			\n			setTimeout(''getSessionData()'',3000)\n		}\n	})\n}\n\nfunction getTillCountData(){\n	$.ajax({\n		url: base_url + ''fnbpos/pos_cash_count_data'',\n		dataType: ''json'',\n		success: function (total){\n			var expected = parseFloat(total.expected);\n			$(''#till-expected'').text(expected.toFixed(2));\n		}\n	});\n}', '2012-11-07 19:13:39', 'admin', NULL);
INSERT INTO `editor_revisions` (`id`, `profile_id`, `item`, `contents`, `datetime`, `user`, `commit`) VALUES
(32, 1, '/var/www/_dev/os/js/fnb/iphone-interactions.js', '// Settings\n\nvar currentScreen = ''home'';\n\n// Globals\nvar itemOption = '''';\nvar itemOptionDisplay = '''';\nvar itemPrice = 0.00;\nvar itemSku = '''';\nvar itemName = '''';\nvar itemQty = 1;\nvar tableNo = 0;\nvar saleId = 0;\nvar lastSaleId = 0;\nvar enterPriceItem = '''';\nvar enterPriceRel = '''';\nvar enterPriceSku = 0;\nvar doubleTap = false;\nvar doubleTapOption = null;\nvar moveStarted = false;\nvar moveInitial = 0;\nvar moving = false;\nvar deltaY = 0;\nvar	myScroll = null;\nvar currentCat = null;\nvar undoable = true;\nvar actualPrice = true;\nvar orderSubmitted = false;\n\nvar lastItem = new Array();\nvar lastName = new Array()\nvar lastSku = new Array();\nvar lastQty = new Array();\n\nvar processQueue = new Array();\n\nvar undoName = '''';\nvar undoQty = '''';\nvar undoItem = '''';\n\nvar batteryLevel = 99;\n\n// Set the battery status event listener\nwindow.addEventListener(''touchmove'', function (event) {\n	moving = true;\n}, true);\n\nfunction touchMove(e){\n	e.preventDefault();\n}\n\n\n// Events population when \n$(document).ready(function(){	\n\n	$(''div.collapse-pane'').live(''touchstart'',function(){\n		$(this).addClass(''tap'');	\n	});\n	\n	$(''div.collapse-pane'').live(''touchend'',function(){\n		$(this).removeClass(''tap'');\n		\n		if ($(this).hasClass(''opened'')){\n			$(this).removeClass(''opened'').text(''Show Active Tables'');\n			$(''div.table-list'').hide();\n			$(''div.p-btn-container'').show();\n\n		} else {\n			$(this).addClass(''opened'').text(''Hide Active Tables'');\n			$(''div.p-btn-container'').hide();\n			$(''div.table-list'').show();\n			tableScroll = new iScroll(''scroller-table'');\n		}\n\n\n	});\n	\n	$(''div.x-btn'').live(''touchstart'',function(){\n		$(this).addClass(''tap'');\n	});\n	\n	$(''div.x-btn'').live(''touchend'',function(){\n		$(this).removeClass(''tap'');\n\n		var xin = $(this).text();\n\n		if (xin == ''OK''){\n			var price = $(''#in-price'').val();\n			var qty = $(''#in-qty'').val();\n			\n			if (!price){\n				return ;\n			}\n			\n			// Clear the price and quantity field\n			$(''#in-price'').val('''');\n			$(''#in-qty'').val(''1'');\n			\n			var floatPrice = parseFloat(price);\n			\n			var priceOption = floatPrice.toFixed(2);\n			\n			// Add item to list with price and quantity\n			addToList(enterPriceItem, enterPriceSku, '''' + currency + priceOption, '''' + currency + priceOption, price,qty);\n			$(this).removeClass(''current'');\n				\n			// Alert item has been added\n			alertAdd(enterPriceItem);\n			$(''#enter-price'').hide();\n			return;\n		}\n		\n		if (xin == ''CLR''){\n			$(''#in-price'').val('''');\n			return;\n		}\n		\n		if (xin == ''+''){\n			var qty = parseInt($(''#in-qty'').val());\n			qty++;\n			\n			$(''#in-qty'').val(qty);\n			return;\n		}\n		\n		if (xin == ''-''){\n			var qty = parseInt($(''#in-qty'').val());\n			qty--;\n			\n			if (qty <= 0) qty = 1;\n			\n			$(''#in-qty'').val(qty);\n			return;\n		}\n		\n		$(''#in-price'').val($(''#in-price'').val() + xin); \n		\n		$(''#in-price'').keyup();\n	});\n\n	$(''div.p-btn'').live(''touchstart'',function(){\n		$(this).addClass(''tap'');\n	});\n	\n	$(''div.p-btn'').live(''touchend'',function(){\n		$(this).removeClass(''tap'');\n		\n		if ($(this).text() == ''Clear''){\n			$(''span.p-table-field'').text('''');\n		} else if ($(this).text() == ''GO''){\n			var tn = $(''span.p-table-field'').text();\n\n			$.ajax({\n				url: base_url + ''iphone/ajax/check_table'',\n				type: ''post'',\n				data: ''table_no=''+tn,\n				dataType: ''json'',\n				success: function (res){\n					if (res.exists == true){\n						if (confirm(''Table exists. Continue?'')){\n							$(''ul.order-list'').html('''');\n							$(''span.table-no'').text(tableNo);\n							$(''span.amount-due'').text('''');\n\n					\n			\n						// Clear undo queue\n							var lastItem = new Array();\n							var lastName = new Array();\n							var lastSku = new Array();\n							var lastQty = new Array();\n						\n							saleId = res.sale_id;\n							updateTableItemList(res.sale_id);\n						}\n\n					} else {\n\n							tableNo = tn;\n							$(''ul.order-list'').html('''');\n		\n		\n							// Set details to the screen to show current table no and clear amount due\n							$(''span.table-no'').text(tableNo);\n							$(''span.amount-due'').text('''');\n\n							createTable();\n\n					}\n				}\n			});\n			\n			\n		} else {\n			var curVal = $(''span.p-table-field'').text();\n			var newVal = curVal + $(this).text();\n			$(''span.p-table-field'').text(newVal);\n		}\n	});\n\n	\n	$(''#in-qty'').live(''touchstart'',function(){\n		$(this).each(function(){\n			this.select();\n		});\n	});\n	\n	$(''span.topbar-title'').live(''touchstart'',function(){\n		$.ajax({\n    		url: base_url + ''iphone/ajax/active_tables/'',\n    		cache: false,\n    		type: ''post'',\n    		data: ''battery_level=''+batteryLevel,\n    		dataType: ''json'',\n    		success: function (json){\n    			// Populate active tables to the table list\n    			$(''ul.table-list'').html(json.html);\n    		}\n    	});\n	});\n\n\n\n	orderScroll = new iScroll(''scroller-order'');\n\n	// Start javascript application routine\n	Update_routine();\n	\n    // Create a new instance of Shake event\n    var myShakeEvent = new deviceShake();\n	\n	// Start the shake event instance\n    myShakeEvent.start();\n    \n    // Set the shake event callback\n    myShakeEvent.shakeEventDidOccur = function() {    \n		// Check if undoable\n        if (undoable){\n        	// Get last undo queue item\n        	undoName = lastName.shift();\n        	undoQty = lastQty.shift();\n        	undoItem = lastItem.shift();\n        	\n        	lastName.unshift(undoName);\n        	lastQty.unshift(undoQty);\n        	lastItem.unshift(undoItem);\n        	\n        	// Prompt undo to user\n        	if (undoName){\n		        if (confirm("Undo Order " + undoQty + " x " + undoName + "\\n" + undoItem + " ?")) {\n					undoOrder();\n        		}\n        	}\n        }\n    }\n    \n    $(''#in-price'').keyup(function(){\n		var val = $(this).val();\n		raw = val.replace(''.'','''');\n		raw = val.replace(''.'','''');\n\n		raw = trimNumber(raw);\n		raw = '''' + raw;\n\n    	if (raw.length > 2){\n			var pos = raw.length - 2;\n			var newval = '''';\n			for (var i = 0; i < raw.length; i++){\n				if (pos - 1 == i){\n					newval += raw.charAt(i) + ''.'';\n				} else {\n					newval += raw.charAt(i);\n				}\n			}\n			$(this).val(newval);\n			\n		} else {\n			$(this).val(''0.''+raw);\n		}\n\n    });\n    \n    $(''button.option-back'').live(''touchend'',function(){\n    	$(this).parents(''div.item-option'').hide();\n		$(''div.scroller-wrapper'').hide();\n		itemOption = '''';\n		itemOptionDisplay = '''';\n		itemPrice = 0.00;\n		itemSku = '''';\n		itemName = '''';\n		itemQty = 1;\n\n    });\n    \n    // Login button tap event\n    $(''#btn-login'').live(''touchend'',function(){\n    	// Submit login form\n    	$(this).parents(''form'').submit();\n    });\n	\n	// Add quantity button tap event\n	$(''button.qty-add'').live(''touchend'',function(){\n		// Increment item quantity by 1\n		itemQty = itemQty + 1;;\n		\n		// Set quantity display to the current item quantity\n		$(''span.cur-item-qty'').text(itemQty);\n	});\n	\n	// Btn logout\n	$(''#btn-logout'').live(''touchend'',function(){\n		window.location.href = base_url + ''iphone/logout'';\n	});\n	\n	// Deduct quantity button tap event\n	$(''button.qty-deduct'').live(''touchend'',function(){\n		// Decrement item quantity by 1\n		itemQty = itemQty - 1;\n		\n		// Check if item quantity deducted lower than 1. If lower than 1, revert back to 1\n		if (itemQty < 1) itemQty = 1;\n		\n		// Set quantity display to the current item quantity\n		$(''span.cur-item-qty'').text(itemQty);\n	\n	});\n	\n	\n	// Clear option button tap event\n	$(''button.clear-select'').live(''touchend'',function(){\n		// Clear item option\n		itemOption = '''';\n		itemOptionDisplay = '''';\n		\n		// Clear option display\n		$(''span.cur-item-option'').text('''');\n		$(''span.cur-item-price'').text(actualPrice.toFixed(2));\n		\n		// Remove all selected state of options\n		$(this).parents(''div.item-option'').find(''li'').removeClass(''selected'').removeClass(''current'');\n\n		// Remove all double tap state\n		doubleTap = false;\n	});\n\n	// Back button tap event binding\n	$(''#btn-back'').live(''touchend'',function(){\n		// Update table list\n		updateTableList();\n		// Switch screen to home\n		goto(''home'');\n		$(''span.p-table-field'').text('''');\n	});\n	\n	// Home button tap event\n	$(''#btn-home'').live(''touchend'',function(){\n		// Update list of tables\n		updateTableList();\n		// Switch screen to home		\n		goto(''home'');\n		$(''span.p-table-field'').text('''');\n	})\n\n	// Add table button tap event\n	$(''#btn-add-table'').live(''touchend'',function(){\n		// Go to add table screen and focus on the table number field\n		goto(''add-table'');\n		$(''#in-table-number'').focus();\n		\n	});\n	\n	// Add item button tap event\n	$(''#btn-add-item'').live(''touchend'',function(){\n		// Show menu screen\n		show(''menu'');\n		// Trigger the dropdown\n		$(''div.dropdown'').trigger(''touchend'');\n	});\n	\n	// Table number go button tap event\n	$(''#btn-go-table'').live(''touchend'',function(){\n		// Retrieve table number from field\n		tableNo = $(''#in-table-number'').val();\n		\n		// Check if table number is empty\n		if (tableNo == null){\n			// If empty, show error message and focus on the table number field\n			$(''p.table-errmsg'').text(''Enter table number.'');\n			$(''#in-table-number'').focus();\n			return;\n		}\n		// Clear the order list\n		$(''ul.order-list'').html('''');\n		\n		// Clear the table number field value\n		$(''#in-table-number'').val('''');\n		\n		// Set details to the screen to show current table no and clear amount due\n		$(''span.table-no'').text(tableNo);\n		$(''span.amount-due'').text('''');\n		\n		// Create the table\n		createTable();\n		\n	});	\n\n	// Table list item tap event\n	$(''ul.table-list li'').live(''touchend'',function(){\n		// Check if moving state is on\n		if (!moving){\n			// If not moving, get the current table id and update the table item list\n			saleId = $(this).attr(''id'');\n			updateTableItemList();\n			\n			// Clear undo queue\n			var lastItem = new Array();\n			var lastName = new Array()\n			var lastSku = new Array();\n			var lastQty = new Array();\n		} else {\n			// If moving, revert back the state to false\n			moving = false;\n		}\n\n	});\n	\n	// Item customization done button tap event\n	$(''button.done-select'').live(''touchend'',function(){\n		// Clear current item option\n		itemOption = '''';\n		itemOptionDisplay = '''';\n			\n		// Loop through all selected options\n		$(this).parents(''div.item-option'').children(''ul.select-list'').find(''li.current'').each(function(){\n			\n			// Retrieve option prices\n			var price = parseFloat($(this).attr(''price''));			\n			if (!price) price = 0.00;\n		\n			// Retrieve the option\n			var option = $(this).attr(''option'');\n			var optionDisplay = $(this).text();\n			\n			\n			// Check if item option is blank\n			if (itemOption == ''''){\n				// If blank the option into item option\n				itemOption = option;\n				itemOptionDisplay = optionDisplay;\n			} else {\n				// If not blank, append the option with comma\n				itemOption = itemOption + '','' + option;\n				itemOptionDisplay = itemOptionDisplay + '','' + optionDisplay;\n			}\n			\n			// Increment the item price with option price\n			itemPrice = itemPrice + price;\n\n		});\n		\n	\n		// Clear all selected option\n		$(this).parents(''div.item-option'').find(''li'').removeClass(''selected'').removeClass(''current'');\n\n		// Hide the option screen\n		$(''div.scroller-wrapper'').hide();\n		$(this).parents(''div.item-option'').hide();\n		\n		// Add into the undo queues\n		lastName.unshift(itemName);\n		lastSku.unshift(itemSku);\n		lastItem.unshift(itemOption);\n		lastQty.unshift(itemQty);\n		\n		// Add into the order list\n		addToList(itemName, itemSku, itemOption, itemOptionDisplay, itemPrice,itemQty);\n		\n		// Revert the item quantity to one after adding\n		itemQty = 1;\n\n	});\n\n	// Order list cancel order button tap event	\n	$(''button.cancel-order'').live(''touchend'',function(){\n		// Retrieve the quantity of the current item\n		var qty = parseInt($(this).parents(''li'').find(''span'').text());\n		\n		// Check the quantity \n		if (qty == 1){\n			// If quantity equals to 1, then remove the item from order list\n			$(this).parents(''li'').remove();\n		} else {\n			// If quantity is greater than one, decrement the item quantity by 1\n			$(this).parents(''li'').find(''span'').text(qty - 1);\n		}\n		\n		// Clear undo queue as undo continuity may differ\n		var lastItem = new Array();\n		var lastName = new Array()\n		var lastSku = new Array();\n		var lastQty = new Array();\n		\n		// Update the order list\n		listUpdate();\n\n	});\n	\n	// Item option swipe event\n	$(''ul.item-option li'').live(''touchmove'',function(){\n		// Set the moving state\n		moving = true;\n	});\n	\n	// Item option tap event\n	$(''ul.item-option li'').live(''touchend'',function(){\n		// Check if item moving\n		if (!$(this).hasClass(''selected'')){\n\n	\n			if ($(this).hasClass(''nonoverlap'')){\n				var overlapOption = $(this).attr(''nonoverlap'');\n				$(this).parents(''ul'').find(''li[nonoverlap=''+overlapOption+'']'').removeClass(''selected'').removeClass(''vui-selected'');\n			}\n			\n			$(this).addClass(''selected'').addClass(''vui-selected'');\n		\n			itemPrice = parseFloat(actualPrice);\n			\n			$(''span.cur-item-option'').text('''');\n			$(''span.cur-item-price'').text('''');\n			\n			var x = 0;			\n			$(this).parents(''ul'').find(''li.selected'').each(function(){\n				var price = parseFloat($(this).attr(''price''));\n				var option = $(this).text();\n\n				itemPrice = itemPrice + price;\n\n				if (x == 0){					\n					itemOption = option;\n				} else {\n					itemOption = itemOption + '','' + option;\n				}\n				x++;\n			})\n			\n			$(''span.cur-item-option'').text(itemOption);			\n			$(''span.cur-item-price'').text(itemPrice.toFixed(2));\n\n		} else {\n			$(this).removeClass(''selected'').removeClass(''vui-selected'').removeClass(''current'');\n			itemOption = '''';\n			itemPrice = actualPrice;\n			\n			$(this).parents(''ul.item-option'').find(''li.selected'').each(function(){\n				if (itemOption == ''''){\n					itemOption = $(this).text();\n				} else {\n					itemOption = itemOption + '','' + $(this).text();\n				}\n\n				var price = parseFloat($(this).attr(''price''));\n				if (!price) price = 0.00;\n				itemPrice += price;\n			});\n			\n			$(''span.cur-item-option'').text(itemOption);\n			$(''span.cur-item-price'').text(itemPrice.toFixed(2));\n			\n			\n\n		}\n		\n		currentItemPrice = itemPrice;\n		\n		\n	\n	});\n	\n	$(''#btn-enter-price-plus'').live(''touchend'',function(){\n		var qty = $(''#in-qty'').val();\n		qty++;\n		$(''#in-qty'').val(qty);\n	});\n	\n	$(''#btn-enter-price-minus'').live(''touchend'',function(){\n		var qty = $(''#in-qty'').val();\n		if (qty != 1) qty--;\n		$(''#in-qty'').val(qty);\n	});\n\n\n	$(''#btn-enter-price-back'').live(''touchend'',function(){	\n		// Hide the custom price screen\n		$(''#enter-price'').hide();\n	\n	});\n	\n	\n	// Done custom price button\n	$(''#btn-price-done'').live(''touchend'',function(){\n		// Retrieve the price and quantity\n		var price = $(''#in-price'').val();\n		var qty = $(''#in-qty'').val()\n		\n		if (!price){\n			return ;\n		}\n		\n		// Clear the price and quantity field\n		$(''#in-price'').val('''');\n		$(''#in-qty'').val(''1'');\n		\n		var floatPrice = parseFloat(price);\n		\n		var priceOption = floatPrice.toFixed(2);\n		\n		// Add item to list with price and quantity\n		addToList(enterPriceItem, enterPriceSku, '''' + currency + priceOption, '''' + currency + priceOption, price,qty);\n		$(this).removeClass(''current'');\n			\n		// Alert item has been added\n		alertAdd(enterPriceItem);\n		\n	\n	});\n\n	// Menu item list tap event\n	$(''ul.item-list li'').live(''touchend'',function(){\n		// Retrieve item data\n		var rel = $(this).attr(''rel'');\n		var price = parseFloat($(this).attr(''price''));\n		var name = $(this).attr(''name'');\n		var sku = $(this).attr(''sku'');\n				\n		// If price is not set, set to 0.00\n		if (!price) price = 0.00;\n		\n		// Check if item has customization option\n		if ($(this).hasClass(''no-option'')){\n			// If item has no customization option\n			// Check if item requires custom price\n			if ($(this).hasClass(''enter-price'')){\n				// If require custom price\n				// Set the custom price information from current item\n				enterPriceItem = name;\n				enterPriceRel = rel;\n				enterPriceSku = sku;\n				\n				// Remove the current state of the item\n				$(this).removeClass(''current'');\n\n				// Set the quantity to 1 and focus on the custom item price field and show the custom price screen\n				$(''#in-qty'').val(''1'');\n\n				$(''#enter-price'').show();\n				\n				\n				\n			} else {\n				// If doesnt require custom price\n				// Set the item quantity to 1\n				itemQty = 1;\n\n				// Add into the undo queue\n				lastName.unshift(name);\n				lastSku.unshift(sku);\n				lastItem.unshift('''');\n				lastQty.unshift(1);\n\n				// Add into order list\n				addToList(name, sku, '''', '''', price,1);\n				\n				// Remove the current state of the time\n				$(this).removeClass(''current'');\n				\n				// Alert item added\n				alertAdd(name);\n			}\n\n		} else {\n			// If item has customization\n			\n			// Remove the current state of the item\n			$(this).removeClass(''current'');\n			\n			// Set the item data information\n			itemPrice = price;\n			itemSku = sku;\n			itemName = name;\n			itemQty = 1;\n			actualPrice = itemPrice;\n			\n			// Clear customization quantity and price display			\n			$(''span.cur-item-qty'').text(itemQty);\n			$(''span.cur-item-price'').text(itemPrice.toFixed(2));\n			\n			// Hide all item options\n			$(''div.item-option-active'').hide().removeClass(''item-option-active'');\n			\n			// Show the item option screen\n			$(''div.scroller-wrapper'').show();\n			\n			// Show item option related to the item only\n			$(''div.item-option[rel=''+rel+'']'').show().addClass(''item-option-active'');\n			$(''div.item-option[rel=''+rel+''] ul'').show();\n			\n			// Set the swipe scroll state to the custom option list\n\n			\n		}\n		\n	});\n	\n	// Category drop down menu item tap event\n	$(''#tab-menu li'').live(''touchend'',function(){\n		// Hide the dropdown content\n		$(''div.dropdown-content'').hide();\n		\n		// Get the relation information\n		var rel = $(this).attr(''rel'');\n		\n		// Set current category to the relation information\n		currentCat = rel;\n\n		// Clear the select list item from current state and hide\n		$(''ul.item-list-active li'').removeClass(''current'');\n		$(''ul.item-list-active'').hide().removeClass(''item-list-active'');\n		\n		// Hide the item option screen\n		// $(''div.scroller-wrapper'').hide();\n\n		// Hide menu back button\n		$(''#btn-menu-back'').hide();\n		\n		// Hide all subcategory list\n		$(''ul.subcat-active'').hide().removeClass(''subcat-active'');\n		\n		// Show subcategory screen related to the category\n		$(''ul.subcat[rel=''+rel+'']'').show().addClass(''subcat-active'');\n		\n		\n		// Set the dropdown current value menu to the category name\n		$(''div.dropdown span.current'').text($(this).text());\n\n	});\n	\n	// Menu back button tap event\n	$(''#btn-menu-back'').click(function(){\n		// Hide all subcategory list\n		$(''ul.subcat-active'').hide().removeClass(''subcat-active'');\n		\n		// Show subcategory related to the current category\n		$(''ul.subcat[rel=''+currentCat+'']'').show().addClass(''subcat-active'');\n		\n		// Hide all item list\n		$(''ul.item-list-active'').hide().removeClass(''item-list-active'');\n		\n		// Hide menu back button\n		$(this).hide();\n	});\n	\n	// Subcategory item tap event\n	$(''li.subcat'').live(''touchend'',function(){\n		// Get the relation data of the subcategory item list\n		var rel = $(this).attr(''rel'');\n\n		// Hide all subcategory list\n		$(''ul.subcat-active'').hide().removeClass(''subcat-active'');\n		\n		// Hide all item list\n		$(''ul.item-list-active'').hide().removeClass(''item-list-active'');\n		\n		// Show item list related to the subcategory\n		$(''ul.item-list[rel=''+rel+'']'').show().addClass(''item-list-active'');\n		\n		// Show the menu back button\n		$(''#btn-menu-back'').show();\n	});\n	\n	// Dropdown list\n	$(''div.dropdown'').live(''touchend'',function(){\n		// Check if dropdown already opened\n		if ($(this).hasClass(''opened'')){\n			// If opened, remove opened state and hide content\n			$(this).removeClass(''opened'').children(''div.dropdown-content'').hide();\n		} else {\n			// If closed, add opened state and show content\n			$(''div.item-option-active'').hide().removeClass(''item-list-active'');\n			$(this).addClass(''opened'').children(''div.dropdown-content'').show();\n		}\n		$(''div.scroller-wrapper'').hide();\n	});\n\n	// Menu done button tap event\n	$(''#btn-menu-done'').live(''touchend'',function(){\n		// Hide the menu and unbind the swipe scroll event of the item \n		hide(''menu'');\n		// myScroll.destroy();\n	});\n	\n	// Home button tap event\n	$(''#btn-home'').live(''touchend'',function(){\n		// Go to home screen\n		goto(''home'');\n	});\n	\n	// Submit order tap event\n	$(''#btn-submit-orders'').live(''touchend'',function(){\n		// Perform order submission\n		$(this).hide();\n		submitOrder();\n\n	});\n	\n	// Update the table list when document loads\n	updateTableList();\n\n});\n\n\n\n// AJAX Functions\n\n// Update the active table list\nfunction updateTableList(){\n\n	$.ajax({\n		url: base_url + ''iphone/ajax/active_tables/?12321'',\n		cache: false,\n		dataType: ''json'',\n		success: function (json){\n			// Populate the table list\n\n			$(''ul.table-list'').html(json.html)\n			listUpdate();\n		}\n	});\n	\n	\n}\n\n// Update the current table item list\nfunction updateTableItemList(sid){\n	if (sid) saleId = sid;\n	$.ajax({\n		url: base_url + ''iphone/ajax/get_item_list/'',\n		cache: false,\n		data: ''queue=''+saleId,\n		type: ''post'',\n		dataType: ''json'',\n		success: function (res){\n\n			// Show table\n			goto(''table'');\n			\n			// Update table number and amount due\n			$(''span.table-no'').text(res.table_no);\n			$(''span.amount-due'').text(res.amount);\n			\n			// Populate the item list into the order list\n			$(''ul.order-list'').html('''');\n			$(''ul.order-list'').html(res.html);\n			\n			\n			\n		}\n	});\n}\n\n// Create new table \nfunction createTable(){\n	$.ajax({\n		url: base_url + ''iphone/ajax/create_table/'',\n		cache: false,\n		type: ''post'',\n		data: ''table_no='' + tableNo,\n		dataType: ''json'',\n		success: function (res){\n			// If return failed status\n			if (res.status == ''Failed''){\n				// Show error message table already exists\n				$(''p.table-errmsg'').text(''Table already exists.'');\n				// Focus on the table number field\n				$(''#in-table-number'').focus();\n			} else {\n				// Clear the error message\n				$(''p.table-errmsg'').text('''');\n				saleId = res.id;\n				// Navigate to the table details\n				goto(''table'');\n			}\n		}\n	})\n}\n\n// Submit order \nfunction submitOrder(){\n	// Post data variables\n	var sku = '''';\n	var price = '''';\n	var option = '''';\n	var qty = '''';\n	\n	\n	// Loop increment default\n	var x = 0;\n	\n	// Loop through all unsubmitted items from order list\n	$(''ul.order-list li.new-order'').each(function(){\n		if (x == 0){\n			// Initially set the the post data variable with the values directly\n			sku = $(this).attr(''sku'');\n			price = $(this).attr(''price'');\n			option = $(this).attr(''option'');\n			qty = $(this).find(''span'').text();\n		} else {\n			// After initial item, append with a separator\n			var curOpt = $(this).attr(''option'');\n			if (!curOpt) curOpt = '' '';\n			sku = sku + '','' + $(this).attr(''sku'');\n			price = price + '','' + $(this).attr(''price'');\n			option = option + ''|'' + curOpt;\n			qty = qty + '','' + $(this).find(''span'').text();\n		}\n		// Increment\n		x++;\n	});\n	\n	// If the increment equals to 0\n	if (x == 0){\n		// There are no items to submit therefore alert the user\n		alert("No items to submit.");\n		return;\n	}\n	\n	if (orderSubmitted){\n		alert(''Order is being submitted.'')\n		return;\n	}\n	\n	orderSubmitted = true;\n\n	\n	// Prepare the post data\n	var postData = ''sale_id=''+saleId+''&sku=''+sku+''&price=''+price+''&option=''+option+''&qty=''+qty\n	lastSaleId = saleId;\n	\n	// Perform ajax\n	$.ajax({\n		url: base_url + ''iphone/ajax/submit_order/'',\n		cache: false,\n		type: ''post'',\n		data: postData,\n		success: function (){\n			// When order submitted, update the table item list\n			\n			\n			updateTableItemList();\n			\n			// Clear all undo queue\n			lastItem = new Array();\n			lastName = new Array()\n			lastSku = new Array();\n			lastQty = new Array();\n			\n			orderSubmitted = false;\n			\n			var sku = '''';\n			var price = '''';\n			var option = '''';\n			var qty = '''';\n\n			\n\n\n		},\n		complete: function(xhr, status){\n			\n			if (status == ''timeout''){\n				alert(''Order cannot be submitted at the moment due to no network connectivity. Order has been queued.'');\n				processQueue.unshift(postData);\n				orderSubmitted = false;\n				setTimeout(''resubmitOrder()'',5000);\n			}\n			\n\n		}\n	})\n	\n\n}\n\n// Update routine\nfunction Update_routine(){\n\n	$.ajax({\n		url: base_url + ''iphone/ajax/active_tables/'',\n		cache: false,\n		type: ''post'',\n		data: ''battery_level=''+batteryLevel,\n		dataType: ''json'',\n		success: function (json){\n			// Populate active tables to the table list\n			$(''ul.table-list'').html(json.html);\n			listUpdate();\n			// Callback routine in 5 secs to update the active tables\n			setTimeout(''Update_routine(); '', 60000);\n			batteryLevel -= (1/24);\n		}\n	});\n}\n\n\n// Add item to order list\nfunction addToList(name, sku, option, optionDisplay, price, addQty){\n	// Clear the current item data\n	itemOption = '''';\n	itemOptionDisplay = '''';\n	itemPrice = 0.00;\n	itemName = '''';\n	itemSku = '''';\n	\n	// If add quantity is not set, set to 1\n	if (!addQty) addQty = 1;\n	\n	// Clear item option name\n	$(''span.cur-item-option'').text('''');\n	\n	// Create an ID for the added item based on item code and options\n\n	var id = '''' + sku + option.replace('','',''-'');\n\n\n		$(''ul.order-list'').prepend(''<li id="''+id+''" class="order-item new-order" name="''+name+''" sku="''+sku+''" price="''+price+''" option="''+option+''"><span style="float:right; font-weight: bold">''+addQty+''</span><button class="red cancel-order" style="width: auto; padding: 4px 15px; font-size: 15pt; font-weight: bold; margin-right: 10px; -webkit-border-radius: 7px; float:left; margin-top: -7px; margin-left: -7px">-</button> ''+name+'' - ''+optionDisplay+''</li>'');\n	\n	// Update the list\n	listUpdate();\n	\n	$(''#btn-submit-orders'').show();\n	\n\n}\n\n// Alert item added\nfunction alertAdd(item){\n	// Clear and show the item alert\n	$(''span.alert'').text('''').show();\n	$(''span.alert'').text(item).delay(300).fadeOut(500);\n}\n\n// Undo the order\nfunction undoOrder(){\n	// Get the last ID\n	var id = '''' +lastSku.shift() + lastItem.shift().replace('','',''-'');\n	// Get the quantity\n	var qty = $(''#''+id).find(''span'').text();\n	// Get the last entered quantity\n	var enteredQty = lastQty.shift();\n	\n	// Remove item the undo queue\n	lastName.shift();\n	\n	// Check if item quantity is equals to the undo quantity\n	if (qty == enteredQty){\n		// If the last entered quantity equals to the current quantity\n		// Remove item list\n		$(''#''+id).remove();\n\n	} else {\n		// Otherwise decrement the quantity by the undo quantity\n		$(''#''+id).find(''span'').text(qty-enteredQty);\n	}\n	\n	// Update list\n	listUpdate();\n	\n}\n\n// Update list\nfunction listUpdate(){\n	// Make first and last item have rounded corners\n	$(''ul.list li'').removeClass(''topRounded'').removeClass(''bottomRounded'');\n	$(''ul.list li:first-child'').addClass(''topRounded'');\n	$(''ul.list li:last-child'').addClass(''bottomRounded'');\n\n}\n\nfunction resubmitOrder(){\n	var curPostData = processQueue.shift();\n	processQueue.unshift(curPostData);\n\n	// Perform ajax\n	$.ajax({\n		url: base_url + ''iphone/ajax/submit_order/'',\n		cache: false,\n		type: ''post'',\n		data: curPostData,\n		success: function (){\n			processQueue.shift();\n			alert(''Previous queue has been submitted.'');\n			if (processQueue.length != 0){\n				resubmitOrder();\n			}\n			if (lastSaleId == saleId){\n				updateTableItemList();			\n			}\n\n			\n		},\n		timeout: 5000,\n		complete: function(xhr, status){\n			if (status == ''timeout''){\n				setTimeout(''resubmitOrder()'',5000);\n			}\n		}\n	})\n\n}\n\nfunction trimNumber(s){\n	return s.replace(/^0+/,'''');\n}', '2012-11-07 19:13:42', 'admin', NULL),
(33, 1, '/var/www/_dev/os/js/fnb/iphone-webframework.js', 'var navHistory = new Array();\n\n$(document).ready(function(){\n	goto(currentScreen);\n	\n	// Back button tap event\n	$(''#btn-back'').live(''touchend'',function(){\n		// Navigate back\n		back();\n	});\n	\n	// Tabs item tap event\n	$(''ul.tab li'').live(''touchend'',function(){\n		// Remove tabs ''current'' state\n		$(this).parents(''ul.tab'').children(''li'').removeClass(''current'');\n		\n		// Set ''current'' state to the tapped tab\n		$(this).addClass(''current'');\n	});\n\n	// Selectable list touch start event \n	$(''ul.select-list li'').live(''touchstart'',function(){\n		\n		// Remove list item ''current'' state\n		if (!$(this).hasClass(''stay'')) $(this).parents(''ul'').children(''li'').removeClass(''current'');\n		\n		// Set ''current'' state to the touched start list item\n		$(this).addClass(''current'');\n	});\n});\n\n\n// Screen navigate function\n// param: String screen\n\nfunction goto(screen){\n	// Hide all topbar button\n	$(''div.topbar button'').hide();\n	\n	// Show topbar buttons related to current screen\n	$(''div.topbar button[rel=''+screen+'']'').show();\n	\n	// Hide all screens\n	$(''div.screen'').hide();\n	\n	// Show specified screen\n	$(''#''+screen).show();\n	\n	// Check if screen allows to navigate back\n	if ($(''#''+screen).hasClass(''allow-back'')){\n		// If allow, show back button\n		$(''#btn-back'').show();\n	}\n\n	navHistory.push(currentScreen);\n}\n\n// Screen navigate back function\n\nfunction back(){\n	// Get previous navigation screen \n	var x = navHistory.pop();\n\n	// Hide all topbar buttons\n	$(''div.topbar button'').hide();\n	\n	// Show topbar button related to previous screen\n	$(''div.topbar button[rel=''+x+'']'').show();\n	\n	// Hide all screens\n	$(''div.screen'').hide();\n	\n	// Show previous screen\n	$(''#''+x).show();\n	\n	// Check if screen allows to navigate back\n	if ($(''#''+x).hasClass(''allow-back'')){\n		// If allow, show back button\n		$(''#btn-back'').show();\n	}	\n}\n\n// Set top bar title function\n// param: String title\n\nfunction title(title){\n	$(''span.topbar-title'').text(title);\n}\n\n// Show overlay screen function\n// param: String screen\n\nfunction show(screen){\n	$(''div.overlay'').show();\n	$(''#''+screen).show();\n}\n\n// Hide overlay screen function\n// param: String screen\n\nfunction hide(screen){\n	$(''div.overlay'').hide();\n	$(''#''+screen).hide();\n}', '2012-11-07 19:13:43', 'admin', NULL),
(34, 1, '/var/www/_dev/os/js/fnb/shake.js', ' \n(function() {\n\n    function deviceShake(threshold) {\n\n        // Default velocity threshold for shake to register\n        this.threshold = 20;\n        \n        // Use date to prevent multiple shakes firing            \n        this.lastTime = new Date();     \n    \n        // User defined threshold option\n        if (typeof threshold == ''object'') {\n            this.threshold = threshold;\n        }\n    }\n\n    // Start listening for devicemotion\n    deviceShake.prototype.start = function() {\n\n        this.lastTime = new Date();\n        this.lastX = null;\n        this.lastY = null;\n        this.lastZ = null;\n    \n        if ((''ondevicemotion'' in window)) {\n            window.addEventListener(''devicemotion'', this, false);\n        }\n    };\n\n    // Stop listening for devicemotion\n    deviceShake.prototype.stop = function() {\n\n        if ((''ondevicemotion'' in window)) {\n            window.removeEventListener(''devicemotion'', this, false);\n        }\n    \n        this.lastTime = new Date();\n        this.lastX = null;\n        this.lastY = null;\n        this.lastZ = null;\n    };\n\n    // Calculates if shake did occur\n    deviceShake.prototype.devicemotion = function(e) {\n\n        var current = e.accelerationIncludingGravity;\n\n        if((this.lastX !== null) || (this.lastY !== null) || (this.lastZ !== null)) {\n\n            var deltaX = Math.abs(this.lastX - current.x),\n                deltaY = Math.abs(this.lastY - current.y),\n                deltaZ = Math.abs(this.lastZ - current.z);  \n\n            if(((deltaX > this.threshold) && (deltaY > this.threshold)) || \n            ((deltaX > this.threshold) && (deltaZ > this.threshold)) || \n            ((deltaY > this.threshold) && (deltaZ > this.threshold))) {\n        \n                //calculate time in milliseconds since last shake registered\n                var currentTime = new Date(),\n                    timeDifference = currentTime.getTime() - this.lastTime.getTime();\n            \n                if (timeDifference > 300) {\n                    this.shakeEventDidOccur();  \n                    this.lastTime = new Date();     \n                }\n            }\n        }\n    \n        this.lastX = current.x;\n        this.lastY = current.y;\n        this.lastZ = current.z; \n    };\n\n    // Callback method will be implemented by user\n    deviceShake.prototype.shakeEventDidOccur = function() {\n\n    };\n\n    // Event handler\n    deviceShake.prototype.handleEvent = function(e) {\n\n        if (typeof(this[e.type]) === ''function'' ) {\n            return this[e.type](e);\n        }\n    };\n\n    // Public function\n    window.deviceShake = deviceShake;\n    \n})();\n', '2012-11-07 21:26:48', 'admin', NULL);
INSERT INTO `editor_revisions` (`id`, `profile_id`, `item`, `contents`, `datetime`, `user`, `commit`) VALUES
(35, 1, '/var/www/_dev/os/js/fnb/iscroll.js', '/**\n * \n * Find more about the scrolling function at\n * http://cubiq.org/iscroll\n *\n * Copyright (c) 2010 Matteo Spinelli, http://cubiq.org/\n * Released under MIT license\n * http://cubiq.org/dropbox/mit-license.txt\n * \n * Version 3.7.1 - Last updated: 2010.10.08\n * \n */\n\n(function(){\nfunction iScroll (el, options) {\n    var that = this, i;\n    that.element = typeof el == ''object'' ? el : document.getElementById(el);\n    that.wrapper = that.element.parentNode;\n\n    that.element.style.webkitTransitionProperty = ''-webkit-transform'';\n    that.element.style.webkitTransitionTimingFunction = ''cubic-bezier(0,0,0.25,1)'';\n    that.element.style.webkitTransitionDuration = ''0'';\n    that.element.style.webkitTransform = translateOpen + ''0,0'' + translateClose;\n\n    // Default options\n    that.options = {\n        bounce: has3d,\n        momentum: has3d,\n        checkDOMChanges: true,\n        topOnDOMChanges: false,\n        hScrollbar: has3d,\n        vScrollbar: has3d,\n        fadeScrollbar: isIthing || !isTouch,\n        shrinkScrollbar: isIthing || !isTouch,\n        desktopCompatibility: false,\n        overflow: ''auto'',\n        snap: false,\n        bounceLock: false,\n        scrollbarColor: ''rgba(0,0,0,0.5)'',\n        onScrollEnd: function () {}\n    };\n    \n    // User defined options\n    if (typeof options == ''object'') {\n        for (i in options) {\n            that.options[i] = options[i];\n        }\n    }\n\n    if (that.options.desktopCompatibility) {\n        that.options.overflow = ''hidden'';\n    }\n    \n    that.onScrollEnd = that.options.onScrollEnd;\n    delete that.options.onScrollEnd;\n    \n    that.wrapper.style.overflow = that.options.overflow;\n    \n    that.refresh();\n\n    window.addEventListener(''onorientationchange'' in window ? ''orientationchange'' : ''resize'', that, false);\n\n    if (isTouch || that.options.desktopCompatibility) {\n        that.element.addEventListener(START_EVENT, that, false);\n        that.element.addEventListener(MOVE_EVENT, that, false);\n        that.element.addEventListener(END_EVENT, that, false);\n    }\n    \n    if (that.options.checkDOMChanges) {\n        that.element.addEventListener(''DOMSubtreeModified'', that, false);\n    }\n}\n\niScroll.prototype = {\n    x: 0,\n    y: 0,\n    enabled: true,\n\n    handleEvent: function (e) {\n        var that = this;\n        \n        switch (e.type) {\n            case START_EVENT:\n                that.touchStart(e);\n                break;\n            case MOVE_EVENT:\n                that.touchMove(e);\n                break;\n            case END_EVENT:\n                that.touchEnd(e);\n                break;\n            case ''webkitTransitionEnd'':\n                that.transitionEnd();\n                break;\n            case ''orientationchange'':\n            case ''resize'':\n                that.refresh();\n                break;\n            case ''DOMSubtreeModified'':\n                that.onDOMModified(e);\n                break;\n        }\n    },\n    \n    onDOMModified: function (e) {\n        var that = this;\n\n        // (Hopefully) execute onDOMModified only once\n        if (e.target.parentNode != that.element) {\n            return;\n        }\n\n        setTimeout(function () { that.refresh(); }, 0);\n\n        if (that.options.topOnDOMChanges && (that.x!=0 || that.y!=0)) {\n            that.scrollTo(0,0,''0'');\n        }\n    },\n\n    refresh: function () {\n        var that = this,\n            resetX = that.x, resetY = that.y,\n            snap;\n        \n        that.scrollWidth = that.wrapper.clientWidth;\n        that.scrollHeight = that.wrapper.clientHeight;\n        that.scrollerWidth = that.element.offsetWidth;\n        that.scrollerHeight = that.element.offsetHeight;\n        that.maxScrollX = that.scrollWidth - that.scrollerWidth;\n        that.maxScrollY = that.scrollHeight - that.scrollerHeight;\n        that.directionX = 0;\n        that.directionY = 0;\n\n        if (that.scrollX) {\n            if (that.maxScrollX >= 0) {\n                resetX = 0;\n            } else if (that.x < that.maxScrollX) {\n                resetX = that.maxScrollX;\n            }\n        }\n        if (that.scrollY) {\n            if (that.maxScrollY >= 0) {\n                resetY = 0;\n            } else if (that.y < that.maxScrollY) {\n                resetY = that.maxScrollY;\n            }\n        }\n\n        // Snap\n        if (that.options.snap) {\n            that.maxPageX = -Math.floor(that.maxScrollX/that.scrollWidth);\n            that.maxPageY = -Math.floor(that.maxScrollY/that.scrollHeight);\n\n            snap = that.snap(resetX, resetY);\n            resetX = snap.x;\n            resetY = snap.y;\n        }\n\n        if (resetX!=that.x || resetY!=that.y) {\n            that.setTransitionTime(''0'');\n            that.setPosition(resetX, resetY, true);\n        }\n        \n        that.scrollX = that.scrollerWidth > that.scrollWidth;\n        that.scrollY = !that.options.bounceLock && !that.scrollX || that.scrollerHeight > that.scrollHeight;\n\n        // Update horizontal scrollbar\n        if (that.options.hScrollbar && that.scrollX) {\n            that.scrollBarX = that.scrollBarX || new scrollbar(''horizontal'', that.wrapper, that.options.fadeScrollbar, that.options.shrinkScrollbar, that.options.scrollbarColor);\n            that.scrollBarX.init(that.scrollWidth, that.scrollerWidth);\n        } else if (that.scrollBarX) {\n            that.scrollBarX = that.scrollBarX.remove();\n        }\n\n        // Update vertical scrollbar\n        if (that.options.vScrollbar && that.scrollY && that.scrollerHeight > that.scrollHeight) {\n            that.scrollBarY = that.scrollBarY || new scrollbar(''vertical'', that.wrapper, that.options.fadeScrollbar, that.options.shrinkScrollbar, that.options.scrollbarColor);\n            that.scrollBarY.init(that.scrollHeight, that.scrollerHeight);\n        } else if (that.scrollBarY) {\n            that.scrollBarY = that.scrollBarY.remove();\n        }\n    },\n\n    setPosition: function (x, y, hideScrollBars) {\n        var that = this;\n        \n        that.x = x;\n        that.y = y;\n\n        that.element.style.webkitTransform = translateOpen + that.x + ''px,'' + that.y + ''px'' + translateClose;\n\n        // Move the scrollbars\n        if (!hideScrollBars) {\n            if (that.scrollBarX) {\n                that.scrollBarX.setPosition(that.x);\n            }\n            if (that.scrollBarY) {\n                that.scrollBarY.setPosition(that.y);\n            }\n        }\n    },\n    \n    setTransitionTime: function(time) {\n        var that = this;\n        \n        time = time || ''0'';\n        that.element.style.webkitTransitionDuration = time;\n        \n        if (that.scrollBarX) {\n            that.scrollBarX.bar.style.webkitTransitionDuration = time;\n            that.scrollBarX.wrapper.style.webkitTransitionDuration = has3d && that.options.fadeScrollbar ? ''300ms'' : ''0'';\n        }\n        if (that.scrollBarY) {\n            that.scrollBarY.bar.style.webkitTransitionDuration = time;\n            that.scrollBarY.wrapper.style.webkitTransitionDuration = has3d && that.options.fadeScrollbar ? ''300ms'' : ''0'';\n        }\n    },\n        \n    touchStart: function(e) {\n        var that = this,\n            matrix;\n        \n        if (!that.enabled) {\n            return;\n        }\n\n        e.preventDefault();\n        e.stopPropagation();\n        \n        that.scrolling = true;      // This is probably not needed, but may be useful if iScroll is used in conjuction with other frameworks\n\n        that.moved = false;\n        that.distX = 0;\n        that.distY = 0;\n\n        that.setTransitionTime(''0'');\n\n        // Check if the scroller is really where it should be\n        if (that.options.momentum || that.options.snap) {\n            matrix = new WebKitCSSMatrix(window.getComputedStyle(that.element).webkitTransform);\n            if (matrix.e != that.x || matrix.f != that.y) {\n                document.removeEventListener(''webkitTransitionEnd'', that, false);\n                that.setPosition(matrix.e, matrix.f);\n                that.moved = true;\n            }\n        }\n\n        that.touchStartX = isTouch ? e.changedTouches[0].pageX : e.pageX;\n        that.scrollStartX = that.x;\n\n        that.touchStartY = isTouch ? e.changedTouches[0].pageY : e.pageY;\n        that.scrollStartY = that.y;\n\n        that.scrollStartTime = e.timeStamp;\n\n        that.directionX = 0;\n        that.directionY = 0;\n    },\n    \n    touchMove: function(e) {\n        if (!this.scrolling) {\n            return;\n        }\n\n        var that = this,\n            pageX = isTouch ? e.changedTouches[0].pageX : e.pageX,\n            pageY = isTouch ? e.changedTouches[0].pageY : e.pageY,\n            leftDelta = that.scrollX ? pageX - that.touchStartX : 0,\n            topDelta = that.scrollY ? pageY - that.touchStartY : 0,\n            newX = that.x + leftDelta,\n            newY = that.y + topDelta;\n\n        //e.preventDefault();\n        e.stopPropagation();    // Stopping propagation just saves some cpu cycles (I presume)\n\n        that.touchStartX = pageX;\n        that.touchStartY = pageY;\n\n        // Slow down if outside of the boundaries\n        if (newX >= 0 || newX < that.maxScrollX) {\n            newX = that.options.bounce ? Math.round(that.x + leftDelta / 3) : (newX >= 0 || that.maxScrollX>=0) ? 0 : that.maxScrollX;\n        }\n        if (newY >= 0 || newY < that.maxScrollY) { \n            newY = that.options.bounce ? Math.round(that.y + topDelta / 3) : (newY >= 0 || that.maxScrollY>=0) ? 0 : that.maxScrollY;\n        }\n\n        if (that.distX + that.distY > 5) {          // 5 pixels threshold\n\n            // Lock scroll direction\n            if (that.distX-3 > that.distY) {\n                newY = that.y;\n                topDelta = 0;\n            } else if (that.distY-3 > that.distX) {\n                newX = that.x;\n                leftDelta = 0;\n            }\n\n            that.setPosition(newX, newY);\n            that.moved = true;\n            that.directionX = leftDelta > 0 ? -1 : 1;\n            that.directionY = topDelta > 0 ? -1 : 1;\n        } else {\n            that.distX+= Math.abs(leftDelta);\n            that.distY+= Math.abs(topDelta);\n//          that.dist+= Math.abs(leftDelta) + Math.abs(topDelta);\n        }\n    },\n    \n    touchEnd: function(e) {\n        if (!this.scrolling) {\n            return;\n        }\n\n        var that = this,\n            time = e.timeStamp - that.scrollStartTime,\n            point = isTouch ? e.changedTouches[0] : e,\n            target, ev,\n            momentumX, momentumY,\n            newDuration = 0,\n            newPositionX = that.x, newPositionY = that.y,\n            snap;\n\n        that.scrolling = false;\n\n        if (!that.moved) {\n            that.resetPosition();\n\n            if (isTouch) {\n                // Find the last touched element\n                target = point.target;\n                while (target.nodeType != 1) {\n                    target = target.parentNode;\n                }\n\n                // Create the fake event\n                ev = document.createEvent(''MouseEvents'');\n                ev.initMouseEvent(''click'', true, true, e.view, 1,\n                    point.screenX, point.screenY, point.clientX, point.clientY,\n                    e.ctrlKey, e.altKey, e.shiftKey, e.metaKey,\n                    0, null);\n                ev._fake = true;\n                target.dispatchEvent(ev);\n            }\n\n            return;\n        }\n\n        if (!that.options.snap && time > 250) {         // Prevent slingshot effect\n            that.resetPosition();\n            return;\n        }\n\n        if (that.options.momentum) {\n            momentumX = that.scrollX === true\n                ? that.momentum(that.x - that.scrollStartX,\n                                time,\n                                that.options.bounce ? -that.x + that.scrollWidth/5 : -that.x,\n                                that.options.bounce ? that.x + that.scrollerWidth - that.scrollWidth + that.scrollWidth/5 : that.x + that.scrollerWidth - that.scrollWidth)\n                : { dist: 0, time: 0 };\n\n            momentumY = that.scrollY === true\n                ? that.momentum(that.y - that.scrollStartY,\n                                time,\n                                that.options.bounce ? -that.y + that.scrollHeight/5 : -that.y,\n                                that.options.bounce ? (that.maxScrollY < 0 ? that.y + that.scrollerHeight - that.scrollHeight : 0) + that.scrollHeight/5 : that.y + that.scrollerHeight - that.scrollHeight)\n                : { dist: 0, time: 0 };\n\n            newDuration = Math.max(Math.max(momentumX.time, momentumY.time), 1);        // The minimum animation length must be 1ms\n            newPositionX = that.x + momentumX.dist;\n            newPositionY = that.y + momentumY.dist;\n        }\n\n        if (that.options.snap) {\n            snap = that.snap(newPositionX, newPositionY);\n            newPositionX = snap.x;\n            newPositionY = snap.y;\n            newDuration = Math.max(snap.time, newDuration);\n        }\n\n        that.scrollTo(newPositionX, newPositionY, newDuration + ''ms'');\n    },\n\n    transitionEnd: function () {\n        var that = this;\n        document.removeEventListener(''webkitTransitionEnd'', that, false);\n        that.resetPosition();\n    },\n\n    resetPosition: function () {\n        var that = this,\n            resetX = that.x,\n            resetY = that.y;\n\n        if (that.x >= 0) {\n            resetX = 0;\n        } else if (that.x < that.maxScrollX) {\n            resetX = that.maxScrollX;\n        }\n\n        if (that.y >= 0 || that.maxScrollY > 0) {\n            resetY = 0;\n        } else if (that.y < that.maxScrollY) {\n            resetY = that.maxScrollY;\n        }\n        \n        if (resetX != that.x || resetY != that.y) {\n            that.scrollTo(resetX, resetY);\n        } else {\n            if (that.moved) {\n                that.onScrollEnd();     // Execute custom code on scroll end\n                that.moved = false;\n            }\n\n            // Hide the scrollbars\n            if (that.scrollBarX) {\n                that.scrollBarX.hide();\n            }\n            if (that.scrollBarY) {\n                that.scrollBarY.hide();\n            }\n        }\n    },\n    \n    snap: function (x, y) {\n        var that = this, time;\n\n        if (that.directionX > 0) {\n            x = Math.floor(x/that.scrollWidth);\n        } else if (that.directionX < 0) {\n            x = Math.ceil(x/that.scrollWidth);\n        } else {\n            x = Math.round(x/that.scrollWidth);\n        }\n        that.pageX = -x;\n        x = x * that.scrollWidth;\n        if (x > 0) {\n            x = that.pageX = 0;\n        } else if (x < that.maxScrollX) {\n            that.pageX = that.maxPageX;\n            x = that.maxScrollX;\n        }\n\n        if (that.directionY > 0) {\n            y = Math.floor(y/that.scrollHeight);\n        } else if (that.directionY < 0) {\n            y = Math.ceil(y/that.scrollHeight);\n        } else {\n            y = Math.round(y/that.scrollHeight);\n        }\n        that.pageY = -y;\n        y = y * that.scrollHeight;\n        if (y > 0) {\n            y = that.pageY = 0;\n        } else if (y < that.maxScrollY) {\n            that.pageY = that.maxPageY;\n            y = that.maxScrollY;\n        }\n\n        // Snap with constant speed (proportional duration)\n        time = Math.round(Math.max(\n                Math.abs(that.x - x) / that.scrollWidth * 500,\n                Math.abs(that.y - y) / that.scrollHeight * 500\n            ));\n            \n        return { x: x, y: y, time: time };\n    },\n\n    scrollTo: function (destX, destY, runtime) {\n        var that = this;\n\n        if (that.x == destX && that.y == destY) {\n            that.resetPosition();\n            return;\n        }\n\n        that.moved = true;\n        that.setTransitionTime(runtime || ''350ms'');\n        that.setPosition(destX, destY);\n\n        if (runtime===''0'' || runtime==''0s'' || runtime==''0ms'') {\n            that.resetPosition();\n        } else {\n            document.addEventListener(''webkitTransitionEnd'', that, false);  // At the end of the transition check if we are still inside of the boundaries\n        }\n    },\n    \n    scrollToPage: function (pageX, pageY, runtime) {\n        var that = this, snap;\n\n        if (!that.options.snap) {\n            that.pageX = -Math.round(that.x / that.scrollWidth);\n            that.pageY = -Math.round(that.y / that.scrollHeight);\n        }\n\n        if (pageX == ''next'') {\n            pageX = ++that.pageX;\n        } else if (pageX == ''prev'') {\n            pageX = --that.pageX;\n        }\n\n        if (pageY == ''next'') {\n            pageY = ++that.pageY;\n        } else if (pageY == ''prev'') {\n            pageY = --that.pageY;\n        }\n\n        pageX = -pageX*that.scrollWidth;\n        pageY = -pageY*that.scrollHeight;\n\n        snap = that.snap(pageX, pageY);\n        pageX = snap.x;\n        pageY = snap.y;\n\n        that.scrollTo(pageX, pageY, runtime || ''500ms'');\n    },\n\n    scrollToElement: function (el, runtime) {\n        el = typeof el == ''object'' ? el : this.element.querySelector(el);\n\n        if (!el) {\n            return;\n        }\n\n        var that = this,\n            x = that.scrollX ? -el.offsetLeft : 0,\n            y = that.scrollY ? -el.offsetTop : 0;\n\n        if (x >= 0) {\n            x = 0;\n        } else if (x < that.maxScrollX) {\n            x = that.maxScrollX;\n        }\n\n        if (y >= 0) {\n            y = 0;\n        } else if (y < that.maxScrollY) {\n            y = that.maxScrollY;\n        }\n\n        that.scrollTo(x, y, runtime);\n    },\n\n    momentum: function (dist, time, maxDistUpper, maxDistLower) {\n        var friction = 2.5,\n            deceleration = 1.2,\n            speed = Math.abs(dist) / time * 1000,\n            newDist = speed * speed / friction / 1000,\n            newTime = 0;\n\n        // Proportinally reduce speed if we are outside of the boundaries \n        if (dist > 0 && newDist > maxDistUpper) {\n            speed = speed * maxDistUpper / newDist / friction;\n            newDist = maxDistUpper;\n        } else if (dist < 0 && newDist > maxDistLower) {\n            speed = speed * maxDistLower / newDist / friction;\n            newDist = maxDistLower;\n        }\n        \n        newDist = newDist * (dist < 0 ? -1 : 1);\n        newTime = speed / deceleration;\n\n        return { dist: Math.round(newDist), time: Math.round(newTime) };\n    },\n    \n    destroy: function (full) {\n        var that = this;\n\n        window.removeEventListener(''onorientationchange'' in window ? ''orientationchange'' : ''resize'', that, false);      \n        that.element.removeEventListener(START_EVENT, that, false);\n        that.element.removeEventListener(MOVE_EVENT, that, false);\n        that.element.removeEventListener(END_EVENT, that, false);\n        document.removeEventListener(''webkitTransitionEnd'', that, false);\n\n        if (that.options.checkDOMChanges) {\n            that.element.removeEventListener(''DOMSubtreeModified'', that, false);\n        }\n\n        if (that.scrollBarX) {\n            that.scrollBarX = that.scrollBarX.remove();\n        }\n\n        if (that.scrollBarY) {\n            that.scrollBarY = that.scrollBarY.remove();\n        }\n        \n        if (full) {\n            that.wrapper.parentNode.removeChild(that.wrapper);\n        }\n        \n        return null;\n    }\n};\n\nfunction scrollbar (dir, wrapper, fade, shrink, color) {\n    var that = this,\n        doc = document;\n    \n    that.dir = dir;\n    that.fade = fade;\n    that.shrink = shrink;\n    that.uid = ++uid;\n\n    // Create main scrollbar\n    that.bar = doc.createElement(''div'');\n\n    that.bar.style.cssText = ''position:absolute;top:0;left:0;-webkit-transition-timing-function:cubic-bezier(0,0,0.25,1);pointer-events:none;-webkit-transition-duration:0;-webkit-transition-delay:0;-webkit-transition-property:-webkit-transform;z-index:10;background:'' + color + '';'' +\n        ''-webkit-transform:'' + translateOpen + ''0,0'' + translateClose + '';'' +\n        (dir == ''horizontal'' ? ''-webkit-border-radius:3px 2px;min-width:6px;min-height:5px'' : ''-webkit-border-radius:2px 3px;min-width:5px;min-height:6px'');\n\n    // Create scrollbar wrapper\n    that.wrapper = doc.createElement(''div'');\n    that.wrapper.style.cssText = ''-webkit-mask:-webkit-canvas(scrollbar'' + that.uid + that.dir + '');position:absolute;z-index:10;pointer-events:none;overflow:hidden;opacity:0;-webkit-transition-duration:'' + (fade ? ''300ms'' : ''0'') + '';-webkit-transition-delay:0;-webkit-transition-property:opacity;'' +\n        (that.dir == ''horizontal'' ? ''bottom:2px;left:2px;right:7px;height:5px'' : ''top:2px;right:2px;bottom:7px;width:5px;'');\n\n    // Add scrollbar to the DOM\n    that.wrapper.appendChild(that.bar);\n    wrapper.appendChild(that.wrapper);\n}\n\nscrollbar.prototype = {\n    init: function (scroll, size) {\n        var that = this,\n            doc = document,\n            pi = Math.PI,\n            ctx;\n\n        // Create scrollbar mask\n        if (that.dir == ''horizontal'') {\n            if (that.maxSize != that.wrapper.offsetWidth) {\n                that.maxSize = that.wrapper.offsetWidth;\n                ctx = doc.getCSSCanvasContext("2d", "scrollbar" + that.uid + that.dir, that.maxSize, 5);\n                ctx.fillStyle = "rgb(0,0,0)";\n                ctx.beginPath();\n                ctx.arc(2.5, 2.5, 2.5, pi/2, -pi/2, false);\n                ctx.lineTo(that.maxSize-2.5, 0);\n                ctx.arc(that.maxSize-2.5, 2.5, 2.5, -pi/2, pi/2, false);\n                ctx.closePath();\n                ctx.fill();\n            }\n        } else {\n            if (that.maxSize != that.wrapper.offsetHeight) {\n                that.maxSize = that.wrapper.offsetHeight;\n                ctx = doc.getCSSCanvasContext("2d", "scrollbar" + that.uid + that.dir, 5, that.maxSize);\n                ctx.fillStyle = "rgb(0,0,0)";\n                ctx.beginPath();\n                ctx.arc(2.5, 2.5, 2.5, pi, 0, false);\n                ctx.lineTo(5, that.maxSize-2.5);\n                ctx.arc(2.5, that.maxSize-2.5, 2.5, 0, pi, false);\n                ctx.closePath();\n                ctx.fill();\n            }\n        }\n\n        that.size = Math.max(Math.round(that.maxSize * that.maxSize / size), 6);\n        that.maxScroll = that.maxSize - that.size;\n        that.toWrapperProp = that.maxScroll / (scroll - size);\n        that.bar.style[that.dir == ''horizontal'' ? ''width'' : ''height''] = that.size + ''px'';\n    },\n    \n    setPosition: function (pos) {\n        var that = this;\n        \n        if (that.wrapper.style.opacity != ''1'') {\n            that.show();\n        }\n\n        pos = Math.round(that.toWrapperProp * pos);\n\n        if (pos < 0) {\n            pos = that.shrink ? pos + pos*3 : 0;\n            if (that.size + pos < 7) {\n                pos = -that.size + 6;\n            }\n        } else if (pos > that.maxScroll) {\n            pos = that.shrink ? pos + (pos-that.maxScroll)*3 : that.maxScroll;\n            if (that.size + that.maxScroll - pos < 7) {\n                pos = that.size + that.maxScroll - 6;\n            }\n        }\n\n        pos = that.dir == ''horizontal''\n            ? translateOpen + pos + ''px,0'' + translateClose\n            : translateOpen + ''0,'' + pos + ''px'' + translateClose;\n\n        that.bar.style.webkitTransform = pos;\n    },\n\n    show: function () {\n        if (has3d) {\n            this.wrapper.style.webkitTransitionDelay = ''0'';\n        }\n        this.wrapper.style.opacity = ''1'';\n    },\n\n    hide: function () {\n        if (has3d) {\n            this.wrapper.style.webkitTransitionDelay = ''350ms'';\n        }\n        this.wrapper.style.opacity = ''0'';\n    },\n    \n    remove: function () {\n        this.wrapper.parentNode.removeChild(this.wrapper);\n        return null;\n    }\n};\n\n// Is translate3d compatible?\nvar has3d = (''WebKitCSSMatrix'' in window && ''m11'' in new WebKitCSSMatrix()),\n    // Device sniffing\n    isIthing = (/iphone|ipad/gi).test(navigator.appVersion),\n    isTouch = (''ontouchstart'' in window),\n    // Event sniffing\n    START_EVENT = isTouch ? ''touchstart'' : ''mousedown'',\n    MOVE_EVENT = isTouch ? ''touchmove'' : ''mousemove'',\n    END_EVENT = isTouch ? ''touchend'' : ''mouseup'',\n    // Translate3d helper\n    translateOpen = ''translate'' + (has3d ? ''3d('' : ''(''),\n    translateClose = has3d ? '',0)'' : '')'',\n    // Unique ID\n    uid = 0;\n\n// Expose iScroll to the world\nwindow.iScroll = iScroll;\n})();', '2012-11-07 21:27:02', 'admin', NULL);
INSERT INTO `editor_revisions` (`id`, `profile_id`, `item`, `contents`, `datetime`, `user`, `commit`) VALUES
(36, 2, '/var/www/manager/sql/tables.sql', '# ************************************************************\n# Sequel Pro SQL dump\n# Version 3408\n#\n# http://www.sequelpro.com/\n# http://code.google.com/p/sequel-pro/\n#\n# Host: localhost (MySQL 5.1.44)\n# Database: plexcloud\n# Generation Time: 2012-11-09 09:42:48 +0000\n# ************************************************************\n\n\n/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;\n/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;\n/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;\n/*!40101 SET NAMES utf8 */;\n/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;\n/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE=''NO_AUTO_VALUE_ON_ZERO'' */;\n/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;\n\n\n# Dump of table _files\n# ------------------------------------------------------------\n\nCREATE TABLE `_files` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `datetime` datetime DEFAULT NULL,\n  `filename` text,\n  `uploaded` int(1) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table _txn\n# ------------------------------------------------------------\n\nCREATE TABLE `_txn` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `datetime` datetime DEFAULT NULL,\n  `sql` text,\n  `done` int(1) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table account\n# ------------------------------------------------------------\n\nCREATE TABLE `account` (\n  `id` char(11) DEFAULT NULL,\n  `name` varchar(128) DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `is_header` varchar(10) DEFAULT NULL,\n  `is_subheader` varchar(10) DEFAULT NULL,\n  `is_bank` varchar(10) DEFAULT NULL,\n  `cash_postable` varchar(10) DEFAULT NULL,\n  `description` text,\n  `datetime` datetime DEFAULT NULL,\n  `opening_balance` decimal(20,2) DEFAULT NULL,\n  `balance` decimal(20,2) DEFAULT NULL,\n  `order` int(11) DEFAULT NULL,\n  `integrated` int(1) DEFAULT NULL,\n  `integration_type` varchar(128) DEFAULT NULL,\n  `default` int(1) DEFAULT NULL\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table account_transactions\n# ------------------------------------------------------------\n\nCREATE TABLE `account_transactions` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `journal` varchar(128) DEFAULT NULL,\n  `account_id` text,\n  `account_name` varchar(128) DEFAULT NULL,\n  `customer_id` int(11) DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `type` varchar(10) DEFAULT NULL,\n  `date` date DEFAULT NULL,\n  `reference` varchar(128) DEFAULT NULL,\n  `description` varchar(128) DEFAULT NULL,\n  `notes` varchar(128) DEFAULT NULL,\n  `group` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table applicants\n# ------------------------------------------------------------\n\nCREATE TABLE `applicants` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `vacancy_id` int(11) DEFAULT NULL,\n  `firstname` varchar(128) DEFAULT NULL,\n  `lastname` varchar(128) DEFAULT NULL,\n  `location` varchar(128) DEFAULT NULL,\n  `gender` varchar(10) DEFAULT NULL,\n  `dob` date DEFAULT NULL,\n  `phone` varchar(128) DEFAULT NULL,\n  `mobile` varchar(128) DEFAULT NULL,\n  `remarks` text,\n  `status` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table asset_depreciations\n# ------------------------------------------------------------\n\nCREATE TABLE `asset_depreciations` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `asset_id` int(11) DEFAULT NULL,\n  `date` date DEFAULT NULL,\n  `depreciation_amount` decimal(20,2) DEFAULT NULL,\n  `current_value` decimal(20,2) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table assets\n# ------------------------------------------------------------\n\nCREATE TABLE `assets` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `product_name` varchar(128) DEFAULT NULL,\n  `barcode` varchar(128) DEFAULT NULL,\n  `cost` decimal(20,2) DEFAULT NULL,\n  `current_cost` decimal(20,2) DEFAULT NULL,\n  `residual_cost` decimal(20,2) DEFAULT NULL,\n  `category` varchar(128) DEFAULT NULL,\n  `subcategory` varchar(128) DEFAULT NULL,\n  `in_service_date` datetime DEFAULT NULL,\n  `acquisition_date` datetime DEFAULT NULL,\n  `amortization_date` datetime DEFAULT NULL,\n  `evaluation_interval` int(11) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  `reference` varchar(128) DEFAULT NULL,\n  `pv_id` int(11) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table calendar\n# ------------------------------------------------------------\n\nCREATE TABLE `calendar` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `title` varchar(128) DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `location` varchar(128) DEFAULT NULL,\n  `allday` varchar(128) DEFAULT NULL,\n  `start` datetime DEFAULT NULL,\n  `end` datetime DEFAULT NULL,\n  `repeat` varchar(20) DEFAULT NULL,\n  `notes` text,\n  `user` varchar(128) DEFAULT NULL,\n  `priority` varchar(128) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  `assigned_by` varchar(128) DEFAULT NULL,\n  `division` varchar(128) DEFAULT NULL,\n  `new_to_user` int(1) DEFAULT ''1'',\n  `new_to_assigner` int(1) DEFAULT ''1'',\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table calendar_task_logs\n# ------------------------------------------------------------\n\nCREATE TABLE `calendar_task_logs` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `task_id` int(11) DEFAULT NULL,\n  `comments` text,\n  `hidden` int(11) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table campaign\n# ------------------------------------------------------------\n\nCREATE TABLE `campaign` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `assigned_to` text,\n  `division` varchar(128) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  `target_audience` varchar(128) DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `expected_close_date` date DEFAULT NULL,\n  `expected_open_date` date DEFAULT NULL,\n  `actual_open_date` date DEFAULT NULL,\n  `actual_close_date` date DEFAULT NULL,\n  `currency` varchar(128) DEFAULT NULL,\n  `sponsor` text,\n  `target_size` varchar(128) DEFAULT NULL,\n  `product` varchar(128) DEFAULT NULL,\n  `budget_cost` varchar(128) DEFAULT NULL,\n  `actual_cost` varchar(128) DEFAULT NULL,\n  `expected_response` varchar(128) DEFAULT NULL,\n  `expected_revenue` varchar(128) DEFAULT NULL,\n  `expected_sales_count` varchar(128) DEFAULT NULL,\n  `actual_sales_count` varchar(128) DEFAULT NULL,\n  `expected_response_count` varchar(128) DEFAULT NULL,\n  `actual_response_count` varchar(128) DEFAULT NULL,\n  `expected_roi` varchar(128) DEFAULT NULL,\n  `actual_roi` varchar(128) DEFAULT NULL,\n  `description` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table cash_count\n# ------------------------------------------------------------\n\nCREATE TABLE `cash_count` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `user_id` int(11) DEFAULT NULL,\n  `username` varchar(128) DEFAULT NULL,\n  `employee_id` int(11) DEFAULT NULL,\n  `employee_username` varchar(128) DEFAULT NULL,\n  `from` datetime DEFAULT NULL,\n  `to` datetime DEFAULT NULL,\n  `deposited` decimal(20,2) DEFAULT NULL,\n  `discrepancy` decimal(20,2) DEFAULT NULL,\n  `total_sales` decimal(20,2) DEFAULT NULL,\n  `total_items` int(11) DEFAULT NULL,\n  `ip_address` varchar(32) DEFAULT NULL,\n  `terminal` varchar(32) DEFAULT NULL,\n  `session` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table config\n# ------------------------------------------------------------\n\nCREATE TABLE `config` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `config` varchar(128) DEFAULT NULL,\n  `value` text,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table contact_cases\n# ------------------------------------------------------------\n\nCREATE TABLE `contact_cases` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `contact_id` int(11) DEFAULT NULL,\n  `subject` text,\n  `description` text,\n  `status` varchar(128) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  `log_date` datetime DEFAULT NULL,\n  `log_status` varchar(128) DEFAULT NULL,\n  `log_user` varchar(128) DEFAULT NULL,\n  `division_id` int(11) DEFAULT NULL,\n  `assigned_to` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table contact_logs\n# ------------------------------------------------------------\n\nCREATE TABLE `contact_logs` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `contact_id` int(11) DEFAULT NULL,\n  `case_id` int(11) DEFAULT NULL,\n  `subject` varchar(128) DEFAULT NULL,\n  `description` text,\n  `status` varchar(128) DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table contacts\n# ------------------------------------------------------------\n\nCREATE TABLE `contacts` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `is_customer` int(1) DEFAULT NULL,\n  `is_supplier` int(1) DEFAULT NULL,\n  `is_debtor` int(1) DEFAULT NULL,\n  `is_creditor` int(1) DEFAULT NULL,\n  `is_member` int(11) DEFAULT NULL,\n  `is_stakeholder` int(1) DEFAULT NULL,\n  `is_franchise` int(1) DEFAULT NULL,\n  `company_name` text,\n  `company_registration` varchar(32) DEFAULT NULL,\n  `contact_person` text,\n  `contact_number` varchar(128) DEFAULT NULL,\n  `credit_limit` float(20,2) DEFAULT NULL,\n  `rank` varchar(128) DEFAULT NULL,\n  `address1` varchar(128) DEFAULT NULL,\n  `address2` varchar(128) DEFAULT NULL,\n  `city` varchar(128) DEFAULT NULL,\n  `state` varchar(128) DEFAULT NULL,\n  `zipcode` varchar(32) DEFAULT NULL,\n  `country` varchar(128) DEFAULT NULL,\n  `tel` varchar(128) DEFAULT NULL,\n  `fax` varchar(128) DEFAULT NULL,\n  `general_email` varchar(128) DEFAULT NULL,\n  `email` varchar(128) DEFAULT NULL,\n  `ic` varchar(128) DEFAULT NULL,\n  `terms` text,\n  `description` text,\n  `remarks` text,\n  `tags` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  `user_type` varchar(128) DEFAULT NULL,\n  `user_verified` int(1) DEFAULT NULL,\n  `loyalty_points` int(11) DEFAULT NULL,\n  `password` varchar(128) DEFAULT NULL,\n  `introducer_ic` varchar(128) DEFAULT NULL,\n  `current_session` varchar(128) DEFAULT NULL,\n  `division_id` int(11) DEFAULT NULL,\n  `assigned_to` varchar(128) DEFAULT NULL,\n  `facebook_id` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table countries\n# ------------------------------------------------------------\n\nCREATE TABLE `countries` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `prefix` text,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table credit_cards\n# ------------------------------------------------------------\n\nCREATE TABLE `credit_cards` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `percentage` decimal(20,2) DEFAULT NULL,\n  `enabled` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table credit_note_items\n# ------------------------------------------------------------\n\nCREATE TABLE `credit_note_items` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `credit_note_id` int(11) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `item_id` int(11) DEFAULT NULL,\n  `discount` varchar(128) DEFAULT NULL,\n  `discount_type` varchar(128) DEFAULT NULL,\n  `qty` int(11) DEFAULT NULL,\n  `price_per_unit` decimal(20,4) DEFAULT NULL,\n  `price` decimal(20,2) DEFAULT NULL,\n  `cost` decimal(20,4) DEFAULT NULL,\n  `received` int(11) DEFAULT NULL,\n  `received_price` decimal(20,2) DEFAULT NULL,\n  `done` int(1) DEFAULT NULL,\n  `division_id` int(128) DEFAULT NULL,\n  `warehouse_id` int(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table credit_notes\n# ------------------------------------------------------------\n\nCREATE TABLE `credit_notes` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `dn_number` varchar(128) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `contact_person` varchar(128) DEFAULT NULL,\n  `received_date` datetime DEFAULT NULL,\n  `contact` varchar(128) DEFAULT NULL,\n  `contact_id` int(11) DEFAULT NULL,\n  `contact_address` text,\n  `delivery_address` text,\n  `terms` varchar(128) DEFAULT NULL,\n  `remarks` text,\n  `status` varchar(128) DEFAULT NULL,\n  `payment_status` varchar(128) DEFAULT NULL,\n  `payment_date` datetime DEFAULT NULL,\n  `payment_reference` varchar(128) DEFAULT NULL,\n  `payment_contra` varchar(128) DEFAULT NULL,\n  `receipt_no` varchar(128) DEFAULT NULL,\n  `handling_charges` decimal(20,2) DEFAULT NULL,\n  `adjustment` decimal(20,2) DEFAULT NULL,\n  `adjustment_type` varchar(32) DEFAULT NULL,\n  `total` decimal(20,2) DEFAULT NULL,\n  `total_received` decimal(20,2) DEFAULT NULL,\n  `tags` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(32) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(32) DEFAULT NULL,\n  `division_id` int(11) DEFAULT NULL,\n  `warehouse_id` int(11) DEFAULT NULL,\n  `assigned_to` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table customers\n# ------------------------------------------------------------\n\nCREATE TABLE `customers` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `company_name` varchar(128) DEFAULT NULL,\n  `reg_number` varchar(128) DEFAULT NULL,\n  `address` text,\n  `contact_person` varchar(128) DEFAULT NULL,\n  `contact_no` varchar(128) DEFAULT NULL,\n  `credit_limit` decimal(20,2) DEFAULT NULL,\n  `status` varchar(32) DEFAULT NULL,\n  `remarks` text,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table debit_note_items\n# ------------------------------------------------------------\n\nCREATE TABLE `debit_note_items` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `debit_note_id` int(11) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `item_id` int(11) DEFAULT NULL,\n  `discount` varchar(128) DEFAULT NULL,\n  `discount_type` varchar(128) DEFAULT NULL,\n  `qty` int(11) DEFAULT NULL,\n  `price_per_unit` decimal(20,4) DEFAULT NULL,\n  `price` decimal(20,2) DEFAULT NULL,\n  `received` int(11) DEFAULT NULL,\n  `received_price` float(20,2) DEFAULT NULL,\n  `done` int(1) DEFAULT NULL,\n  `division_id` int(11) DEFAULT NULL,\n  `warehouse_id` int(11) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table debit_notes\n# ------------------------------------------------------------\n\nCREATE TABLE `debit_notes` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `cn_number` varchar(128) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `contact_person` varchar(128) DEFAULT NULL,\n  `received_date` datetime DEFAULT NULL,\n  `supplier` varchar(128) DEFAULT NULL,\n  `supplier_id` int(11) DEFAULT NULL,\n  `supplier_address` text,\n  `delivery_address` text,\n  `terms` varchar(128) DEFAULT NULL,\n  `remarks` text,\n  `status` varchar(128) DEFAULT NULL,\n  `payment_status` varchar(128) DEFAULT NULL,\n  `payment_reference` varchar(128) DEFAULT NULL,\n  `payment_date` datetime DEFAULT NULL,\n  `payment_contra` varchar(128) DEFAULT NULL,\n  `receipt_no` varchar(128) DEFAULT NULL,\n  `handling_charges` decimal(20,2) DEFAULT NULL,\n  `adjustment` decimal(20,2) DEFAULT NULL,\n  `adjustment_type` varchar(32) DEFAULT NULL,\n  `total` decimal(20,2) DEFAULT NULL,\n  `total_received` decimal(20,2) DEFAULT NULL,\n  `tags` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(32) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(32) DEFAULT NULL,\n  `division_id` int(11) DEFAULT NULL,\n  `warehouse_id` int(11) DEFAULT NULL,\n  `assigned_to` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table department\n# ------------------------------------------------------------\n\nCREATE TABLE `department` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `description` text,\n  `company_name` varchar(128) DEFAULT NULL,\n  `company_registration` varchar(128) DEFAULT NULL,\n  `logo` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table disposal_appreciation\n# ------------------------------------------------------------\n\nCREATE TABLE `disposal_appreciation` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `asset_id` int(11) DEFAULT NULL,\n  `asset_name` varchar(128) DEFAULT NULL,\n  `asset_category` varchar(128) DEFAULT NULL,\n  `asset_subcategory` varchar(128) DEFAULT NULL,\n  `value_on_disposal` decimal(20,2) DEFAULT NULL,\n  `disposed_value` decimal(20,2) DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table disposal_depreciation\n# ------------------------------------------------------------\n\nCREATE TABLE `disposal_depreciation` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `asset_id` int(11) DEFAULT NULL,\n  `asset_name` varchar(128) DEFAULT NULL,\n  `asset_category` varchar(128) DEFAULT NULL,\n  `asset_subcategory` varchar(128) DEFAULT NULL,\n  `value_on_disposal` decimal(20,2) DEFAULT NULL,\n  `disposed_value` decimal(20,2) DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table editor_live_contents\n# ------------------------------------------------------------\n\nCREATE TABLE `editor_live_contents` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `profile_id` int(11) DEFAULT NULL,\n  `item` text,\n  `contents` text,\n  `datetime` datetime DEFAULT NULL,\n  `username` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table editor_profiles\n# ------------------------------------------------------------\n\nCREATE TABLE `editor_profiles` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `hostname` varchar(128) DEFAULT NULL,\n  `linker_file` text,\n  `api_key` varchar(128) DEFAULT NULL,\n  `root_url` text,\n  `root_path` varchar(128) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table editor_revisions\n# ------------------------------------------------------------\n\nCREATE TABLE `editor_revisions` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `profile_id` int(11) DEFAULT NULL,\n  `item` text,\n  `contents` text,\n  `datetime` datetime DEFAULT NULL,\n  `user` varchar(128) DEFAULT NULL,\n  `commit` int(1) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table editor_sessions\n# ------------------------------------------------------------\n\nCREATE TABLE `editor_sessions` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `profile_id` int(11) DEFAULT NULL,\n  `username` varchar(128) DEFAULT NULL,\n  `last_change` varchar(128) DEFAULT NULL,\n  `item` text,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table email_notifications\n# ------------------------------------------------------------\n\nCREATE TABLE `email_notifications` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `contact_id` int(11) DEFAULT NULL,\n  `contact_email` varchar(128) DEFAULT NULL,\n  `module` varchar(128) DEFAULT NULL,\n  `transaction` varchar(128) DEFAULT NULL,\n  `transaction_id` int(11) DEFAULT NULL,\n  `remarks` text,\n  `datetime` datetime DEFAULT NULL,\n  `subject` text,\n  `message` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=InnoDB DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table employee_cico\n# ------------------------------------------------------------\n\nCREATE TABLE `employee_cico` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `employee_id` int(11) DEFAULT NULL,\n  `check_in` datetime DEFAULT NULL,\n  `check_out` datetime DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table employee_dependents\n# ------------------------------------------------------------\n\nCREATE TABLE `employee_dependents` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `employee_id` int(11) DEFAULT NULL,\n  `name` varchar(128) DEFAULT NULL,\n  `relationship` varchar(128) DEFAULT NULL,\n  `dob` date DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table employee_documents\n# ------------------------------------------------------------\n\nCREATE TABLE `employee_documents` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `employee_id` int(11) DEFAULT NULL,\n  `filename` varchar(128) DEFAULT NULL,\n  `filetype` varchar(32) DEFAULT NULL,\n  `size` varchar(64) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table employee_education\n# ------------------------------------------------------------\n\nCREATE TABLE `employee_education` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `employee_id` int(11) DEFAULT NULL,\n  `education` varchar(128) DEFAULT NULL,\n  `major` varchar(128) DEFAULT NULL,\n  `year` varchar(4) DEFAULT NULL,\n  `gpa_score` varchar(128) DEFAULT NULL,\n  `start_date` varchar(128) DEFAULT NULL,\n  `end_date` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table employee_emergency_contacts\n# ------------------------------------------------------------\n\nCREATE TABLE `employee_emergency_contacts` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `employee_id` int(11) DEFAULT NULL,\n  `name` varchar(128) DEFAULT NULL,\n  `relationship` varchar(128) DEFAULT NULL,\n  `home_phone` varchar(128) DEFAULT NULL,\n  `mobile` varchar(128) DEFAULT NULL,\n  `work_phone` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table employee_languages\n# ------------------------------------------------------------\n\nCREATE TABLE `employee_languages` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `employee_id` int(11) DEFAULT NULL,\n  `language` varchar(128) DEFAULT NULL,\n  `fluency` varchar(128) DEFAULT NULL,\n  `competency` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table employee_licenses\n# ------------------------------------------------------------\n\nCREATE TABLE `employee_licenses` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `employee_id` int(11) DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `start_date` varchar(128) DEFAULT NULL,\n  `end_date` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table employee_skills\n# ------------------------------------------------------------\n\nCREATE TABLE `employee_skills` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `employee_id` int(11) DEFAULT NULL,\n  `skill` varchar(128) DEFAULT NULL,\n  `years_of_experience` int(11) DEFAULT NULL,\n  `remarks` text,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table employee_work_experience\n# ------------------------------------------------------------\n\nCREATE TABLE `employee_work_experience` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `employee_id` varchar(128) DEFAULT NULL,\n  `employer` varchar(128) DEFAULT NULL,\n  `start_date` date DEFAULT NULL,\n  `end_date` date DEFAULT NULL,\n  `job_title` varchar(128) DEFAULT NULL,\n  `remarks` varchar(128) DEFAULT NULL,\n  `internal` tinyint(4) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table employees\n# ------------------------------------------------------------\n\nCREATE TABLE `employees` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `username` varchar(128) DEFAULT NULL,\n  `password` varchar(128) DEFAULT NULL,\n  `firstname` varchar(128) DEFAULT NULL,\n  `lastname` varchar(128) DEFAULT NULL,\n  `gender` varchar(128) DEFAULT NULL,\n  `nationality` varchar(128) DEFAULT NULL,\n  `dob` date DEFAULT NULL,\n  `marital_status` varchar(128) DEFAULT NULL,\n  `race` varchar(128) DEFAULT NULL,\n  `ic_no` varchar(128) DEFAULT NULL,\n  `photo` text,\n  `address1` text,\n  `address2` text,\n  `city` varchar(128) DEFAULT NULL,\n  `stateprov` varchar(128) DEFAULT NULL,\n  `zipcode` varchar(128) DEFAULT NULL,\n  `country` varchar(128) DEFAULT NULL,\n  `session` int(1) DEFAULT NULL,\n  `active` int(1) DEFAULT NULL,\n  `home_phone` varchar(128) DEFAULT NULL,\n  `mobile` varchar(128) DEFAULT NULL,\n  `work_phone` varchar(128) DEFAULT NULL,\n  `work_email` varchar(128) DEFAULT NULL,\n  `other_email` varchar(128) DEFAULT NULL,\n  `employment_start_date` datetime DEFAULT NULL,\n  `employment_end_date` datetime DEFAULT NULL,\n  `type` varchar(32) DEFAULT NULL,\n  `division` varchar(128) DEFAULT NULL,\n  `ip_address` varchar(32) DEFAULT NULL,\n  `last_login` datetime DEFAULT NULL,\n  `last_logout` datetime DEFAULT NULL,\n  `remarks` text,\n  `status` varchar(32) DEFAULT NULL,\n  `tags` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  `position` varchar(32) DEFAULT NULL,\n  `is_manager` int(1) DEFAULT NULL,\n  `is_cashier` int(1) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table employment\n# ------------------------------------------------------------\n\nCREATE TABLE `employment` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `employee_id` int(11) DEFAULT NULL,\n  `job_title` varchar(128) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  `date` date DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `pay_grade` varchar(128) DEFAULT NULL,\n  `pay_frequency` varchar(128) DEFAULT NULL,\n  `minimum_salary` decimal(20,2) DEFAULT NULL,\n  `maximum_salary` decimal(20,2) DEFAULT NULL,\n  `basic_salary` decimal(20,2) DEFAULT NULL,\n  `division` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table fifo\n# ------------------------------------------------------------\n\nCREATE TABLE `fifo` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `item_id` int(11) DEFAULT NULL,\n  `po_item_id` int(11) DEFAULT NULL,\n  `po_id` int(11) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  `cost` decimal(20,2) DEFAULT NULL,\n  `from_qty` int(11) DEFAULT NULL,\n  `to_qty` int(11) DEFAULT NULL,\n  `qty` int(11) DEFAULT NULL,\n  `done` int(1) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table fnb_buffer_sale_items\n# ------------------------------------------------------------\n\nCREATE TABLE `fnb_buffer_sale_items` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `date` datetime DEFAULT NULL,\n  `sale_id` int(11) DEFAULT NULL,\n  `item_id` int(11) DEFAULT NULL,\n  `item_sku` varchar(128) DEFAULT NULL,\n  `item_name` varchar(128) DEFAULT NULL,\n  `item_option` varchar(128) DEFAULT NULL,\n  `qty` int(11) DEFAULT NULL,\n  `price_per_unit` float(10,2) DEFAULT NULL,\n  `margin` float(10,4) DEFAULT NULL,\n  `cost` float(10,4) DEFAULT NULL,\n  `amount` float(10,2) DEFAULT NULL,\n  `sold` int(11) DEFAULT NULL,\n  `terminal` varchar(32) DEFAULT NULL,\n  `printed` int(1) DEFAULT NULL,\n  `session` varchar(128) DEFAULT NULL,\n  `ordered_by` varchar(128) DEFAULT NULL,\n  `ordered_time` datetime DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table fnb_buffer_sales\n# ------------------------------------------------------------\n\nCREATE TABLE `fnb_buffer_sales` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `table_no` varchar(128) DEFAULT NULL,\n  `user_id` int(11) DEFAULT NULL,\n  `username` varchar(128) DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  `payment_status` varchar(128) DEFAULT NULL,\n  `cost` float(10,4) DEFAULT NULL,\n  `amount` float(10,2) DEFAULT NULL,\n  `amount_tendered` float(10,2) DEFAULT NULL,\n  `amount_change` float(10,2) DEFAULT NULL,\n  `payment_method` varchar(128) DEFAULT NULL,\n  `payment_details` text,\n  `terminal` varchar(32) DEFAULT NULL,\n  `session` varchar(128) DEFAULT NULL,\n  `discount` float DEFAULT NULL,\n  `payment` text,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table fnb_cash_count\n# ------------------------------------------------------------\n\nCREATE TABLE `fnb_cash_count` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `user_id` int(11) DEFAULT NULL,\n  `username` varchar(128) DEFAULT NULL,\n  `from` datetime DEFAULT NULL,\n  `to` datetime DEFAULT NULL,\n  `deposited` float(10,2) DEFAULT NULL,\n  `discrepancy` float(10,2) DEFAULT NULL,\n  `total_sales` float(10,2) DEFAULT NULL,\n  `total_items` int(11) DEFAULT NULL,\n  `ip_address` varchar(32) DEFAULT NULL,\n  `terminal` varchar(32) DEFAULT NULL,\n  `session` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table fnb_delivery_order_items\n# ------------------------------------------------------------\n\nCREATE TABLE `fnb_delivery_order_items` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `datetime` datetime DEFAULT NULL,\n  `order_id` int(11) DEFAULT NULL,\n  `item_id` int(11) DEFAULT NULL,\n  `item_sku` varchar(128) DEFAULT NULL,\n  `item_name` varchar(128) DEFAULT NULL,\n  `item_option` varchar(128) DEFAULT NULL,\n  `qty` int(11) DEFAULT NULL,\n  `price_per_unit` float(10,2) DEFAULT NULL,\n  `margin` float(10,4) DEFAULT NULL,\n  `cost` float(10,4) DEFAULT NULL,\n  `amount` float(10,2) DEFAULT NULL,\n  `sold` int(11) DEFAULT NULL,\n  `terminal` varchar(32) DEFAULT NULL,\n  `printed` int(1) DEFAULT NULL,\n  `session` varchar(128) DEFAULT NULL,\n  `ordered_by` varchar(128) DEFAULT NULL,\n  `ordered_time` datetime DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table fnb_delivery_orders\n# ------------------------------------------------------------\n\nCREATE TABLE `fnb_delivery_orders` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `datetime` datetime DEFAULT NULL,\n  `session` varchar(128) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  `order_data` text,\n  `type` varchar(128) DEFAULT NULL,\n  `payment_status` varchar(128) DEFAULT NULL,\n  `amount_tendered` decimal(20,2) DEFAULT NULL,\n  `amount_change` decimal(20,2) DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `payment_method` varchar(128) DEFAULT NULL,\n  `online` int(1) DEFAULT NULL,\n  `discount` varchar(128) NOT NULL DEFAULT '''',\n  `customer_id` int(11) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table fnb_inventory\n# ------------------------------------------------------------\n\nCREATE TABLE `fnb_inventory` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `category` varchar(128) DEFAULT NULL,\n  `subcategory` varchar(128) DEFAULT NULL,\n  `location` varchar(128) DEFAULT NULL,\n  `name` varchar(128) DEFAULT NULL,\n  `sku` varchar(128) DEFAULT NULL,\n  `qty` int(11) DEFAULT ''0'',\n  `cost` float(10,4) NOT NULL,\n  `item_price` float(10,2) DEFAULT NULL,\n  `price` text,\n  `options` text,\n  `description` text,\n  `supplier` varchar(128) DEFAULT NULL,\n  `remarks` text,\n  `is_active` varchar(10) DEFAULT NULL,\n  `is_consigned` varchar(10) DEFAULT NULL,\n  `alert_quantity` int(11) DEFAULT NULL,\n  `max_quantity` int(11) DEFAULT NULL,\n  `ordered_quantity` int(11) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  `quick` int(1) DEFAULT NULL,\n  `enter_price` int(1) DEFAULT NULL,\n  `order` int(11) DEFAULT NULL,\n  `category_order` int(11) DEFAULT NULL,\n  `iphone` int(1) DEFAULT NULL,\n  `grouped` int(1) DEFAULT NULL,\n  `printer` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table fnb_printer_map\n# ------------------------------------------------------------\n\nCREATE TABLE `fnb_printer_map` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `categories` text,\n  `subcategories` text,\n  `printer_ip` varchar(32) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table fnb_reverts\n# ------------------------------------------------------------\n\nCREATE TABLE `fnb_reverts` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `performed_by` varchar(128) DEFAULT NULL,\n  `data` text,\n  `datetime` datetime DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=InnoDB DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table fnb_sale_items\n# ------------------------------------------------------------\n\nCREATE TABLE `fnb_sale_items` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `date` datetime DEFAULT NULL,\n  `sale_id` int(11) DEFAULT NULL,\n  `item_id` int(11) DEFAULT NULL,\n  `item_sku` varchar(128) DEFAULT NULL,\n  `item_name` varchar(128) DEFAULT NULL,\n  `item_option` varchar(128) DEFAULT NULL,\n  `qty` int(11) DEFAULT NULL,\n  `price_per_unit` float(10,2) DEFAULT NULL,\n  `margin` float(10,4) DEFAULT NULL,\n  `cost` float(10,4) DEFAULT NULL,\n  `amount` float(10,2) DEFAULT NULL,\n  `sold` int(11) DEFAULT NULL,\n  `terminal` varchar(32) DEFAULT NULL,\n  `printed` int(1) DEFAULT NULL,\n  `session` varchar(128) DEFAULT NULL,\n  `ordered_by` varchar(128) DEFAULT NULL,\n  `ordered_time` datetime DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table fnb_sales\n# ------------------------------------------------------------\n\nCREATE TABLE `fnb_sales` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `table_no` varchar(128) DEFAULT NULL,\n  `user_id` int(11) DEFAULT NULL,\n  `username` varchar(128) DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  `payment_status` varchar(128) DEFAULT NULL,\n  `cost` float(10,4) DEFAULT NULL,\n  `amount` float(10,2) DEFAULT NULL,\n  `amount_tendered` float(10,2) DEFAULT NULL,\n  `amount_change` float(10,2) DEFAULT NULL,\n  `payment_method` varchar(128) DEFAULT NULL,\n  `payment_details` text,\n  `terminal` varchar(32) DEFAULT NULL,\n  `session` varchar(128) DEFAULT NULL,\n  `discount` float DEFAULT NULL,\n  `payment` text,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table im\n# ------------------------------------------------------------\n\nCREATE TABLE `im` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `subject` varchar(128) DEFAULT NULL,\n  `division` varchar(128) DEFAULT NULL,\n  `priority` varchar(128) DEFAULT NULL,\n  `from` varchar(128) DEFAULT NULL,\n  `to` varchar(128) DEFAULT NULL,\n  `message` text,\n  `user_copy` int(1) DEFAULT ''0'',\n  `datetime` datetime DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table inventory\n# ------------------------------------------------------------\n\nCREATE TABLE `inventory` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `primary_image` text,\n  `image` text,\n  `category` varchar(128) DEFAULT NULL,\n  `subcategory` varchar(128) DEFAULT NULL,\n  `brand` varchar(128) DEFAULT NULL,\n  `location` varchar(128) DEFAULT NULL,\n  `name` varchar(128) DEFAULT NULL,\n  `model_no` varchar(128) DEFAULT NULL,\n  `warranty` varchar(128) DEFAULT NULL,\n  `sku` varchar(128) DEFAULT NULL,\n  `sku2` varchar(128) DEFAULT NULL,\n  `sku3` varchar(128) DEFAULT NULL,\n  `sku4` varchar(128) DEFAULT NULL,\n  `qty` int(11) DEFAULT ''0'',\n  `alert_quantity` int(11) DEFAULT NULL,\n  `max_quantity` int(11) DEFAULT NULL,\n  `cost` decimal(10,4) NOT NULL,\n  `average_cost` decimal(10,4) DEFAULT NULL,\n  `price` decimal(10,2) DEFAULT NULL,\n  `price_2` decimal(10,2) DEFAULT NULL,\n  `price_3` decimal(10,2) DEFAULT NULL,\n  `price2` decimal(10,2) DEFAULT NULL,\n  `price2_2` decimal(10,2) DEFAULT NULL,\n  `price2_3` decimal(10,2) DEFAULT NULL,\n  `price3` decimal(10,2) DEFAULT NULL,\n  `price3_2` decimal(10,2) DEFAULT NULL,\n  `price3_3` decimal(10,2) DEFAULT NULL,\n  `price4` decimal(10,2) DEFAULT NULL,\n  `price4_2` decimal(10,2) DEFAULT NULL,\n  `price4_3` decimal(10,2) DEFAULT NULL,\n  `description` text,\n  `supplier` varchar(128) DEFAULT NULL,\n  `remarks` text,\n  `ordered_quantity` int(11) DEFAULT NULL,\n  `is_active` varchar(10) DEFAULT NULL,\n  `is_consigned` varchar(10) DEFAULT NULL,\n  `quick` int(1) DEFAULT NULL,\n  `adjust_cost` int(1) NOT NULL DEFAULT ''0'',\n  `enter_price` int(1) DEFAULT ''0'',\n  `enter_serial` int(1) DEFAULT NULL,\n  `tags` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  `redeemable` int(1) DEFAULT NULL,\n  `redeem_points` int(11) DEFAULT NULL,\n  `current_po` int(11) DEFAULT NULL,\n  `current_po_item` int(11) DEFAULT NULL,\n  `uom1` varchar(128) DEFAULT NULL,\n  `uom2` varchar(128) DEFAULT NULL,\n  `uom3` varchar(128) DEFAULT NULL,\n  `uom4` varchar(128) DEFAULT NULL,\n  `loose_qty2` int(11) DEFAULT NULL,\n  `loose_qty3` int(11) DEFAULT NULL,\n  `loose_qty4` int(11) DEFAULT NULL,\n  `weight` decimal(20,2) DEFAULT NULL,\n  `weight_unit` varchar(10) DEFAULT NULL,\n  `volume` decimal(20,2) DEFAULT NULL,\n  `volume_unit` varchar(10) DEFAULT NULL,\n  `min_cart_qty` int(10) DEFAULT NULL,\n  `max_cart_qty` int(10) DEFAULT NULL,\n  `ready_for_sale` int(1) DEFAULT NULL,\n  `last_sold` datetime DEFAULT NULL,\n  `isbn` varchar(128) DEFAULT NULL,\n  `links` text,\n  `linked` text,\n  `author` text,\n  `publisher` varchar(128) DEFAULT NULL,\n  `lastchange` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table inventory_stock_quantities\n# ------------------------------------------------------------\n\nCREATE TABLE `inventory_stock_quantities` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `item_id` int(11) DEFAULT NULL,\n  `item_sku` varchar(128) DEFAULT NULL,\n  `warehouse_id` int(11) DEFAULT NULL,\n  `qty` int(11) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table invoice_items\n# ------------------------------------------------------------\n\nCREATE TABLE `invoice_items` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `invoice_id` int(11) DEFAULT NULL,\n  `type` varchar(32) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `item_name` text,\n  `item_description` text,\n  `item_id` int(11) DEFAULT NULL,\n  `service_id` int(11) DEFAULT NULL,\n  `item_sku` varchar(128) DEFAULT NULL,\n  `discount` varchar(128) DEFAULT NULL,\n  `discount_type` varchar(128) DEFAULT NULL,\n  `qty` int(11) DEFAULT NULL,\n  `price_per_unit` decimal(20,4) DEFAULT NULL,\n  `price` decimal(20,2) DEFAULT NULL,\n  `cost` decimal(20,2) DEFAULT NULL,\n  `margin` decimal(20,2) DEFAULT NULL,\n  `delivered` int(11) DEFAULT NULL,\n  `delivered_price` decimal(20,2) DEFAULT NULL,\n  `done` int(1) DEFAULT NULL,\n  `no_do` int(1) DEFAULT NULL,\n  `division_id` int(11) DEFAULT NULL,\n  `warehouse_id` int(11) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table invoices\n# ------------------------------------------------------------\n\nCREATE TABLE `invoices` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `quote_id` int(11) DEFAULT NULL,\n  `sales_order_id` int(11) DEFAULT NULL,\n  `number` varchar(128) DEFAULT NULL,\n  `po_number` varchar(128) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `due_date` datetime DEFAULT NULL,\n  `received_date` datetime DEFAULT NULL,\n  `contact_person` varchar(128) DEFAULT NULL,\n  `contact` varchar(128) DEFAULT NULL,\n  `contact_id` int(11) DEFAULT NULL,\n  `contact_address` text,\n  `delivery_address` text,\n  `delivery_tracking_no` varchar(128) DEFAULT NULL,\n  `delivery_status` varchar(128) DEFAULT NULL,\n  `delivery_date` datetime DEFAULT NULL,\n  `shipping` varchar(128) DEFAULT NULL,\n  `shipping_id` int(11) DEFAULT NULL,\n  `terms` varchar(128) DEFAULT NULL,\n  `duration` int(11) DEFAULT NULL,\n  `remarks` text,\n  `status` varchar(128) DEFAULT NULL,\n  `payment_status` varchar(128) DEFAULT NULL,\n  `payment_date` datetime DEFAULT NULL,\n  `payment_reference` varchar(128) DEFAULT NULL,\n  `payment_contra` varchar(128) DEFAULT NULL,\n  `receipt_no` varchar(128) DEFAULT NULL,\n  `handling_charges` decimal(20,2) DEFAULT NULL,\n  `adjustment` decimal(20,2) DEFAULT NULL,\n  `adjustment_type` varchar(32) DEFAULT NULL,\n  `total` decimal(20,2) DEFAULT NULL,\n  `total_delivered` decimal(20,2) DEFAULT NULL,\n  `cost` decimal(20,2) DEFAULT NULL,\n  `tags` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(32) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(32) DEFAULT NULL,\n  `no_do` int(1) DEFAULT NULL,\n  `amount_cash` decimal(20,2) DEFAULT NULL,\n  `amount_cc` decimal(20,2) DEFAULT NULL,\n  `amount_cheque` decimal(20,2) DEFAULT NULL,\n  `amount_credit` decimal(20,2) DEFAULT NULL,\n  `amount_bank_deposit` decimal(20,2) DEFAULT NULL,\n  `paid_cash` int(1) DEFAULT NULL,\n  `paid_cc` int(1) DEFAULT NULL,\n  `paid_cheque` int(1) DEFAULT NULL,\n  `paid_credit` int(1) DEFAULT NULL,\n  `paid_bank_deposit` int(1) DEFAULT NULL,\n  `tax` text,\n  `total_tax` double(20,2) DEFAULT NULL,\n  `sales_reference_id` int(11) DEFAULT NULL,\n  `division_id` int(11) DEFAULT NULL,\n  `warehouse_id` int(11) DEFAULT NULL,\n  `assigned_to` int(11) DEFAULT NULL,\n  `notification` text,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table jobsheet\n# ------------------------------------------------------------\n\nCREATE TABLE `jobsheet` (\n  `id` int(11) DEFAULT NULL,\n  `job` varchar(128) DEFAULT NULL,\n  `department` varchar(128) DEFAULT NULL,\n  `priority` varchar(128) DEFAULT NULL,\n  `deadline` datetime DEFAULT NULL,\n  `start` datetime DEFAULT NULL,\n  `end` datetime DEFAULT NULL,\n  `note` text,\n  `user` varchar(128) DEFAULT NULL,\n  `assignee` varchar(128) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table journal\n# ------------------------------------------------------------\n\nCREATE TABLE `journal` (\n  `id` int(11) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `journal` varchar(128) DEFAULT NULL,\n  `ref` varchar(128) DEFAULT NULL,\n  `description` varchar(128) DEFAULT NULL,\n  `credit_to` varchar(128) DEFAULT NULL,\n  `debit_to` varchar(128) DEFAULT NULL,\n  `currency` varchar(5) DEFAULT NULL,\n  `amount` varchar(128) DEFAULT NULL\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table leads\n# ------------------------------------------------------------\n\nCREATE TABLE `leads` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `firstname` varchar(128) DEFAULT NULL,\n  `lastname` varchar(128) DEFAULT NULL,\n  `company` varchar(128) DEFAULT NULL,\n  `title` varchar(128) DEFAULT NULL,\n  `phone` varchar(128) DEFAULT NULL,\n  `mobile` varchar(128) DEFAULT NULL,\n  `fax` varchar(128) DEFAULT NULL,\n  `email` varchar(128) DEFAULT NULL,\n  `assigned_to` text,\n  `division` varchar(128) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  `source` varchar(128) DEFAULT NULL,\n  `campaign` varchar(128) DEFAULT NULL,\n  `campaign_name` varchar(128) DEFAULT NULL,\n  `address1` varchar(128) DEFAULT NULL,\n  `address2` varchar(128) DEFAULT NULL,\n  `city` varchar(128) DEFAULT NULL,\n  `zipcode` varchar(128) DEFAULT NULL,\n  `state` varchar(128) DEFAULT NULL,\n  `country` varchar(128) DEFAULT NULL,\n  `web` varchar(128) DEFAULT NULL,\n  `description` varchar(128) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table leave\n# ------------------------------------------------------------\n\nCREATE TABLE `leave` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `employee_id` int(11) DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `from` date DEFAULT NULL,\n  `to` date DEFAULT NULL,\n  `remarks` text,\n  `status` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table license\n# ------------------------------------------------------------\n\nCREATE TABLE `license` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `date_form` datetime DEFAULT NULL,\n  `date_to` double DEFAULT NULL,\n  `key` varchar(128) DEFAULT NULL,\n  `vkey` varchar(128) DEFAULT NULL,\n  `count` int(11) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table manufacturing_order\n# ------------------------------------------------------------\n\nCREATE TABLE `manufacturing_order` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `customer_id` int(11) DEFAULT NULL,\n  `customer` varchar(128) DEFAULT NULL,\n  `product_name` varchar(128) DEFAULT NULL,\n  `bom_id` int(11) DEFAULT NULL,\n  `quantity` int(11) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  `progress_date` datetime DEFAULT NULL,\n  `actual_progress_date` datetime DEFAULT NULL,\n  `remarks` text,\n  `end_date` datetime DEFAULT NULL,\n  `actual_end_date` datetime DEFAULT NULL,\n  `actual_quantity` int(11) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table manufacturing_order_components\n# ------------------------------------------------------------\n\nCREATE TABLE `manufacturing_order_components` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `component_id` int(11) DEFAULT NULL,\n  `raw_material_id` int(11) DEFAULT NULL,\n  `name` varchar(128) DEFAULT NULL,\n  `uom` varchar(128) DEFAULT NULL,\n  `remarks` text,\n  `shelf_life` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table members\n# ------------------------------------------------------------\n\nCREATE TABLE `members` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `nric` varchar(32) DEFAULT NULL,\n  `email` varchar(128) DEFAULT NULL,\n  `tel` varchar(11) DEFAULT NULL,\n  `address1` text,\n  `address2` text,\n  `zipcode` varchar(128) DEFAULT NULL,\n  `points` int(11) DEFAULT NULL,\n  `added_on` varchar(32) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `added_by` varchar(32) DEFAULT NULL,\n  `modified_by` varchar(32) DEFAULT NULL,\n  `remarks` text,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table menu_items\n# ------------------------------------------------------------\n\nCREATE TABLE `menu_items` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `category` varchar(128) DEFAULT NULL,\n  `subcategory` varchar(128) DEFAULT NULL,\n  `location` varchar(128) DEFAULT NULL,\n  `name` varchar(128) DEFAULT NULL,\n  `sku` varchar(128) DEFAULT NULL,\n  `qty` int(11) DEFAULT ''0'',\n  `cost` float(10,4) NOT NULL,\n  `item_price` float(10,2) DEFAULT NULL,\n  `price` text,\n  `options` text,\n  `description` text,\n  `supplier` varchar(128) DEFAULT NULL,\n  `remarks` text,\n  `is_active` varchar(10) DEFAULT NULL,\n  `is_consigned` varchar(10) DEFAULT NULL,\n  `alert_quantity` int(11) DEFAULT NULL,\n  `max_quantity` int(11) DEFAULT NULL,\n  `ordered_quantity` int(11) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  `quick` int(1) DEFAULT NULL,\n  `enter_price` int(1) DEFAULT NULL,\n  `order` int(11) DEFAULT NULL,\n  `category_order` int(11) DEFAULT NULL,\n  `iphone` int(1) DEFAULT NULL,\n  `grouped` int(1) DEFAULT NULL,\n  `printer` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table menu_printer_map\n# ------------------------------------------------------------\n\nCREATE TABLE `menu_printer_map` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `categories` tinytext,\n  `printer_ip` varchar(32) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table modules\n# ------------------------------------------------------------\n\nCREATE TABLE `modules` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `controller_name` varchar(128) DEFAULT NULL,\n  `tables` text,\n  `common` varchar(128) DEFAULT NULL,\n  `core` int(1) DEFAULT NULL,\n  `actions` text,\n  `action_names` text,\n  `override` int(1) DEFAULT NULL,\n  `enabled` int(11) DEFAULT NULL,\n  `dependencies` text,\n  `custom_user_field` text,\n  `custom_user_field_name` text,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table notifications\n# ------------------------------------------------------------\n\nCREATE TABLE `notifications` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `module` varchar(128) DEFAULT NULL,\n  `user` varchar(128) DEFAULT NULL,\n  `description` text,\n  `link` text,\n  `status` varchar(128) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  `viewed_datetime` datetime DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table payment_gateways\n# ------------------------------------------------------------\n\nCREATE TABLE `payment_gateways` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `namespace` varchar(128) DEFAULT NULL,\n  `description` text,\n  `initiate_script` text,\n  `callback_script` text,\n  `status` varchar(128) DEFAULT NULL,\n  `percentage` decimal(10,2) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table payment_voucher_breakdown\n# ------------------------------------------------------------\n\nCREATE TABLE `payment_voucher_breakdown` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `pv_id` int(11) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  `contact` varchar(128) DEFAULT NULL,\n  `contact_id` int(11) DEFAULT NULL,\n  `account` text,\n  `account_id` int(11) DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `payment_method` varchar(128) DEFAULT NULL,\n  `payment_reference` varchar(128) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table payment_voucher_items\n# ------------------------------------------------------------\n\nCREATE TABLE `payment_voucher_items` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `pv_id` int(11) DEFAULT NULL,\n  `account_id` int(11) DEFAULT NULL,\n  `account` varchar(128) DEFAULT NULL,\n  `po_id` int(11) DEFAULT NULL,\n  `cn_id` int(11) DEFAULT NULL,\n  `dn_id` int(11) DEFAULT NULL,\n  `invoice_id` int(11) DEFAULT NULL,\n  `asset_id` int(11) DEFAULT NULL,\n  `reference` varchar(128) DEFAULT NULL,\n  `contact_id` int(11) DEFAULT NULL,\n  `contact` varchar(128) DEFAULT NULL,\n  `description` text,\n  `datetime` datetime DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table payment_vouchers\n# ------------------------------------------------------------\n\nCREATE TABLE `payment_vouchers` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `type` varchar(128) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  `account` varchar(128) DEFAULT NULL,\n  `account_id` int(11) DEFAULT NULL,\n  `contact` varchar(128) DEFAULT NULL,\n  `contact_id` int(11) DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `void_date` datetime DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table permissions\n# ------------------------------------------------------------\n\nCREATE TABLE `permissions` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `user_type` varchar(128) DEFAULT NULL,\n  `module` text,\n  `action` text,\n  `divisions` text,\n  `super` int(11) DEFAULT ''0'',\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table potentials\n# ------------------------------------------------------------\n\nCREATE TABLE `potentials` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `related_to` varchar(128) DEFAULT NULL,\n  `lead_id` int(11) DEFAULT NULL,\n  `currency` varchar(128) DEFAULT NULL,\n  `amount` varchar(32) DEFAULT NULL,\n  `assigned_to` text,\n  `division` varchar(128) DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `expected_close_date` date DEFAULT NULL,\n  `lead_source` varchar(128) DEFAULT NULL,\n  `next_step` varchar(128) DEFAULT NULL,\n  `probability` varchar(128) DEFAULT NULL,\n  `campaign` varchar(128) DEFAULT NULL,\n  `campaign_name` varchar(128) DEFAULT NULL,\n  `sales_stage` varchar(128) DEFAULT NULL,\n  `description` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table purchase_order_items\n# ------------------------------------------------------------\n\nCREATE TABLE `purchase_order_items` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `purchase_order_id` int(11) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `item_description` text,\n  `item_name` text,\n  `item_id` int(11) DEFAULT NULL,\n  `discount` varchar(128) DEFAULT NULL,\n  `discount_type` varchar(128) DEFAULT NULL,\n  `qty` int(11) DEFAULT NULL,\n  `price_per_unit` decimal(20,4) DEFAULT NULL,\n  `price` decimal(20,2) DEFAULT NULL,\n  `received` int(11) DEFAULT NULL,\n  `received_price` decimal(20,2) DEFAULT NULL,\n  `done` int(1) DEFAULT NULL,\n  `division_id` int(11) DEFAULT NULL,\n  `warehouse_id` int(11) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table purchase_orders\n# ------------------------------------------------------------\n\nCREATE TABLE `purchase_orders` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `invoice_number` varchar(128) DEFAULT NULL,\n  `number` varchar(128) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `due_date` datetime DEFAULT NULL,\n  `contact_person` varchar(128) DEFAULT NULL,\n  `received_date` datetime DEFAULT NULL,\n  `supplier` varchar(128) DEFAULT NULL,\n  `supplier_id` int(11) DEFAULT NULL,\n  `supplier_address` text,\n  `delivery_address` text,\n  `terms` varchar(128) DEFAULT NULL,\n  `duration` int(11) DEFAULT NULL,\n  `remarks` text,\n  `status` varchar(128) DEFAULT NULL,\n  `receipt_no` varchar(128) DEFAULT NULL,\n  `handling_charges` decimal(20,2) DEFAULT NULL,\n  `adjustment` decimal(20,2) DEFAULT NULL,\n  `adjustment_type` varchar(32) DEFAULT NULL,\n  `total` decimal(20,2) DEFAULT NULL,\n  `total_received` decimal(20,2) DEFAULT NULL,\n  `payment_status` varchar(128) DEFAULT NULL,\n  `payment_date` datetime DEFAULT NULL,\n  `payment_reference` varchar(128) DEFAULT NULL,\n  `payment_contra` varchar(128) DEFAULT NULL,\n  `tags` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(32) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(32) DEFAULT NULL,\n  `division_id` int(11) DEFAULT NULL,\n  `warehouse_id` int(11) DEFAULT NULL,\n  `assigned_to` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table quote_items\n# ------------------------------------------------------------\n\nCREATE TABLE `quote_items` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `quote_id` int(11) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `item_id` int(11) DEFAULT NULL,\n  `service_id` int(11) DEFAULT NULL,\n  `item_name` varchar(128) DEFAULT NULL,\n  `item_description` text,\n  `discount` varchar(128) DEFAULT NULL,\n  `discount_type` varchar(128) DEFAULT NULL,\n  `qty` int(11) DEFAULT NULL,\n  `price_per_unit` decimal(20,4) DEFAULT NULL,\n  `price` decimal(20,2) DEFAULT NULL,\n  `cost` decimal(20,4) DEFAULT NULL,\n  `done` int(1) DEFAULT NULL,\n  `no_do` int(1) DEFAULT NULL,\n  `division_id` int(11) DEFAULT NULL,\n  `warehouse_id` int(11) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table quotes\n# ------------------------------------------------------------\n\nCREATE TABLE `quotes` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `quote_id` int(11) DEFAULT NULL,\n  `invoice_id` int(11) DEFAULT NULL,\n  `sales_order_id` int(11) DEFAULT NULL,\n  `number` varchar(128) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `due_date` datetime DEFAULT NULL,\n  `contact_person` varchar(128) DEFAULT NULL,\n  `payment_date` datetime DEFAULT NULL,\n  `received_date` datetime DEFAULT NULL,\n  `contact` varchar(128) DEFAULT NULL,\n  `contact_id` int(11) DEFAULT NULL,\n  `contact_address` text,\n  `delivery_address` text,\n  `shipping` varchar(128) DEFAULT NULL,\n  `shipping_id` int(11) DEFAULT NULL,\n  `terms` varchar(128) DEFAULT NULL,\n  `duration` int(11) DEFAULT NULL,\n  `remarks` text,\n  `status` varchar(128) DEFAULT NULL,\n  `payment_status` varchar(128) DEFAULT NULL,\n  `receipt_no` varchar(128) DEFAULT NULL,\n  `handling_charges` decimal(20,2) DEFAULT NULL,\n  `adjustment` decimal(20,2) DEFAULT NULL,\n  `adjustment_type` varchar(32) DEFAULT NULL,\n  `total` decimal(20,2) DEFAULT NULL,\n  `total_delivered` decimal(20,2) DEFAULT NULL,\n  `cost` decimal(20,4) DEFAULT NULL,\n  `tags` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(32) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(32) DEFAULT NULL,\n  `no_do` int(1) DEFAULT NULL,\n  `division_id` int(11) DEFAULT NULL,\n  `warehouse_id` int(11) DEFAULT NULL,\n  `assigned_to` int(11) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table receipt_breakdown\n# ------------------------------------------------------------\n\nCREATE TABLE `receipt_breakdown` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `receipt_id` int(11) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  `contact` varchar(128) DEFAULT NULL,\n  `contact_id` int(11) DEFAULT NULL,\n  `account` varchar(128) DEFAULT NULL,\n  `account_id` int(11) DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `amount_fees` decimal(20,2) DEFAULT NULL,\n  `amount_effective` double(20,2) DEFAULT NULL,\n  `payment_method` varchar(128) DEFAULT NULL,\n  `payment_reference` varchar(128) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table receipt_items\n# ------------------------------------------------------------\n\nCREATE TABLE `receipt_items` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `receipt_id` int(11) DEFAULT NULL,\n  `account_id` int(11) DEFAULT NULL,\n  `account` varchar(128) DEFAULT NULL,\n  `po_id` int(11) DEFAULT NULL,\n  `cn_id` int(11) DEFAULT NULL,\n  `dn_id` int(11) DEFAULT NULL,\n  `invoice_id` int(11) DEFAULT NULL,\n  `asset_id` int(11) DEFAULT NULL,\n  `reference` varchar(128) DEFAULT NULL,\n  `contact_id` int(11) DEFAULT NULL,\n  `contact` varchar(128) DEFAULT NULL,\n  `description` text,\n  `datetime` datetime DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table receipts\n# ------------------------------------------------------------\n\nCREATE TABLE `receipts` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `type` varchar(128) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  `account_id` int(11) DEFAULT NULL,\n  `account` varchar(128) DEFAULT NULL,\n  `contact_id` int(11) DEFAULT NULL,\n  `contact` varchar(128) DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `amount_fees` double(20,2) DEFAULT NULL,\n  `amount_effective` double(20,2) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `void_date` datetime DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table report_to\n# ------------------------------------------------------------\n\nCREATE TABLE `report_to` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `supervisor_id` int(11) DEFAULT NULL,\n  `supervisor` varchar(128) DEFAULT NULL,\n  `subordinate_id` int(11) DEFAULT NULL,\n  `subordinate` varchar(128) DEFAULT NULL,\n  `reporting_method` varchar(32) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table reports\n# ------------------------------------------------------------\n\nCREATE TABLE `reports` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `description` text,\n  `modules` text,\n  `permissions` text,\n  `process_script` text,\n  `display_script` text,\n  `script` text,\n  `filters` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  `modified_on` datetime DEFAULT NULL,\n  `modified_by` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table reports_saved\n# ------------------------------------------------------------\n\nCREATE TABLE `reports_saved` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `type` varchar(128) DEFAULT NULL,\n  `title` varchar(128) DEFAULT NULL,\n  `notes` text,\n  `output` text,\n  `added_on` datetime DEFAULT NULL,\n  `added_by` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=InnoDB DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table reverts\n# ------------------------------------------------------------\n\nCREATE TABLE `reverts` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `performed_by` varchar(128) DEFAULT NULL,\n  `data` text,\n  `datetime` datetime DEFAULT NULL,\n  `warehouse_id` int(11) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=InnoDB DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table salary_voucher\n# ------------------------------------------------------------\n\nCREATE TABLE `salary_voucher` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `datetime` datetime DEFAULT NULL,\n  `employee_id` int(11) DEFAULT NULL,\n  `employee` varchar(128) DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `amount_employer` decimal(20,2) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table salary_voucher_breakdown\n# ------------------------------------------------------------\n\nCREATE TABLE `salary_voucher_breakdown` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `sv_id` int(11) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  `account` varchar(128) DEFAULT NULL,\n  `account_id` int(11) DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `payment_method` varchar(128) DEFAULT NULL,\n  `payment_reference` varchar(128) DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table salary_voucher_format\n# ------------------------------------------------------------\n\nCREATE TABLE `salary_voucher_format` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `name` varchar(128) DEFAULT NULL,\n  `field_name` varchar(128) DEFAULT NULL,\n  `type` varchar(10) DEFAULT NULL,\n  `percentage` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table salary_voucher_items\n# ------------------------------------------------------------\n\nCREATE TABLE `salary_voucher_items` (\n  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,\n  `sv_id` int(11) DEFAULT NULL,\n  `field` varchar(128) DEFAULT NULL,\n  `field_id` int(11) DEFAULT NULL,\n  `type` varchar(128) DEFAULT NULL,\n  `description` text,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `datetime` datetime DEFAULT NULL,\n  `status` varchar(128) DEFAULT NULL,\n  PRIMARY KEY (`id`)\n) ENGINE=MyISAM DEFAULT CHARSET=latin1;\n\n\n\n# Dump of table sale_items\n# ------------------------------------------------------------\n\nCREATE TABLE `sale_items` (\n  `id` int(11) NOT NULL AUTO_INCREMENT,\n  `txn_no` varchar(32) DEFAULT NULL,\n  `date` datetime DEFAULT NULL,\n  `sale_id` int(11) DEFAULT NULL,\n  `pseudo_id` int(11) DEFAULT NULL,\n  `item_id` int(11) DEFAULT NULL,\n  `item_sku` varchar(128) DEFAULT NULL,\n  `item_sku2` varchar(128) DEFAULT NULL,\n  `item_name` varchar(128) DEFAULT NULL,\n  `sku_select` int(11) DEFAULT NULL,\n  `qty` int(11) DEFAULT NULL,\n  `qty_fraction` int(11) DEFAULT NULL,\n  `unit` varchar(128) DEFAULT NULL,\n  `price_per_unit` decimal(20,2) DEFAULT NULL,\n  `margin` decimal(20,4) DEFAULT NULL,\n  `cost` decimal(20,4) DEFAULT NULL,\n  `discount_type` varchar(10) DEFAULT NULL,\n  `discount_value` decimal(20,2) DEFAULT NULL,\n  `discount_amount` decimal(20,2) DEFAULT NULL,\n  `global_discount` decimal(20,2) DEFAULT NULL,\n  `global_discount_type` varchar(1) DEFAULT NULL,\n  `amount` decimal(20,2) DEFAULT NULL,\n  `tax` decimal(20,2) DEFAULT NULL,\n  `sold` int(11) DEFAULT NULL,\n  `terminal` varchar(32) DEFAULT NULL', '2012-11-10 23:10:44', 'admin', NULL);
INSERT INTO `editor_revisions` (`id`, `profile_id`, `item`, `contents`, `datetime`, `user`, `commit`) VALUES
(37, 2, '/var/www/demo/cart/interface/themes.php', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\n<html>\n	<head>\n		<link rel="stylesheet" href="css/style.css" />\n		<title>LCMS - Users</title>\n		<style>\n			h1 {\n				font-size: 15pt;\n				color: #333;\n				font-weight: bold;\n			}\n			div.header {\n				background: url(<?=base_url()?>css/images/lcms-controller-bg.png) repeat-x;\n				padding: 7px 5px;\n				color: #FFF;\n				font-size: 10pt;\n			}\n			div.header a {\n				color: #FFF;\n				font-family: "Lucida Sans", "Lucida Grande", tahoma,sans-serif;\n				font-size: 10pt;\n				font-weight: bold;\n				text-decoration: none;\n			}\n			table {\n				width: 100%;\n				border-collapse: collapse;\n				font-size: 10pt;\n				font-family: Arial, Helvetica, tahoma, sans-serif;\n				border: 1px solid #DDD;\n				margin: 10px 0;\n			}\n			\n			thead {\n				background: #eee;\n			}\n			\n			table td, table th {\n				padding: 3px;\n			}\n		</style>\n	</head>\n	<body style="text-align: center; background: #eee;">\n		<div id="lcms-container" style="margin: 0 auto; width: 800px; text-align: left; background: #fff; padding: 15px">\n			<h1>LiveCMS</h1>\n			<div class="header">\n				<a href="<?=base_url()?>">Home</a> | \n				<a href="<?=base_url()?>admin/users">Users</a> | \n				<a href="<?=base_url()?>admin/add_user">Add New User</a> | \n				<a href="<?=base_url()?>admin/themes">Themes</a> | \n				<a href="<?=base_url()?>admin/logout">Log Out</a>\n			</div>\n			<?php if ($alert): ?>\n			<p style="border: 1px solid #008800; padding: 5px; font-size: 10pt; font-family: Arial, sans-serif; color: #008800"><?=$alert?></p>\n			<?php endif; ?>\n			<?php if ($error): ?>\n			<p style="border: 1px solid red; padding: 5px; font-size: 10pt; font-family: Arial, sans-serif; color: red"><?=$error?></p>\n			<?php endif; ?>\n			<br />\n			<a href="<?=base_url()?>admin/new_theme/">Create New Theme</a>\n			<table>\n				<thead>\n					<tr>\n						<th>ID</th>\n						<th>Name</th>\n						<th>Author</th>\n						<th>Directory</th>\n						<th>Added On</th>\n						<th>Active</th>\n						<th>Action</th>\n					</tr>\n				</thead>\n				<tbody>\n					<?php foreach($themes as $theme):?>\n					<tr>\n						<td><?=$theme->id?></td>\n						<td><?=$theme->name?></td>\n						<td><?=$theme->auther?></td>\n						<td><?=$theme->directory?></td>\n						<td><?=$theme->added_on?></td>\n						<td><?=$theme->active ? ''Yes'' : ''No''?></td>\n						<td>\n							<a href="<?=base_url()?>/admin/set_active_theme/<?=$theme->id?>">Set Active</a>\n							<?php if ($theme->type != ''installed''): ?>\n\n							<a href="<?=base_url()?>/admin/delete_theme/<?=$theme->id?>">Delete</a>\n							<a href="<?=base_url()?>/admin/view_theme/<?=$theme->id?>">View</a>\n							<?php endif; ?>\n						</td>\n					</tr>\n					<?php endforeach; ?>\n				</tbody>\n			</table>\n		</div>\n		<p>&copy; Copyright LiveCMS 2010. All rights reserved.</p>\n	</body>\n</html>\n', '2012-11-10 23:12:10', 'admin', NULL),
(38, 2, '/var/www/demo/cart/interface/users.php', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\n<html>\n	<head>\n		<link rel="stylesheet" href="css/style.css" />\n		<title>LCMS - Users</title>\n		<style>\n			h1 {\n				font-size: 15pt;\n				color: #333;\n				font-weight: bold;\n			}\n			div.header {\n				background: url(<?=base_url()?>css/images/lcms-controller-bg.png) repeat-x;\n				padding: 7px 5px;\n				color: #FFF;\n				font-size: 10pt;\n			}\n			div.header a {\n				color: #FFF;\n				font-family: "Lucida Sans", "Lucida Grande", tahoma,sans-serif;\n				font-size: 10pt;\n				font-weight: bold;\n				text-decoration: none;\n			}\n			table {\n				width: 100%;\n				border-collapse: collapse;\n				font-size: 10pt;\n				font-family: Arial, Helvetica, tahoma, sans-serif;\n				border: 1px solid #DDD;\n				margin: 10px 0;\n			}\n			\n			thead {\n				background: #eee;\n			}\n			\n			table td, table th {\n				padding: 3px;\n			}\n		</style>\n	</head>\n	<body style="text-align: center; background: #eee;">\n		<div id="lcms-container" style="margin: 0 auto; width: 800px; text-align: left; background: #fff; padding: 15px">\n			<h1>LiveCMS</h1>\n			<div class="header">\n				<a href="<?=base_url()?>">Home</a> | \n				<a href="<?=base_url()?>admin/users">Users</a> | \n				<a href="<?=base_url()?>admin/add_user">Add New User</a> | \n				<a href="<?=base_url()?>admin/themes">Themes</a> | \n				<a href="<?=base_url()?>admin/logout">Log Out</a>\n			</div>\n			<?php if ($alert): ?>\n			<p style="border: 1px solid #008800; padding: 5px; font-size: 10pt; font-family: Arial, sans-serif; color: #008800"><?=$alert?></p>\n			<?php endif; ?>\n			<?php if ($error): ?>\n			<p style="border: 1px solid red; padding: 5px; font-size: 10pt; font-family: Arial, sans-serif; color: red"><?=$error?></p>\n			<?php endif; ?>\n\n			<table>\n				<thead>\n					<tr>\n						<th>ID</th>\n						<th>Username</th>\n						<th>First Name</th>\n						<th>Last Name</th>\n						<th>Email</th>\n						<th>Type</th>\n						<th>Action</th>\n					</tr>\n				</thead>\n				<tbody>\n					<?php foreach($users as $user):?>\n					<tr>\n						<td><?=$user->id?></td>\n						<td><?=$user->username?></td>\n						<td><?=$user->firstname?></td>\n						<td><?=$user->lastname?></td>\n						<td><?=$user->email?></td>\n						<td><?=$user->type?></td>\n						<?php if ($me->username == $user->username): ?>\n							<td><a href="<?=base_url()?>admin/edit_user/<?=$user->id?>">Edit</a></td>\n						<?php elseif ($me->type != ''Super Admin''): ?>\n							<td></td>\n						<?php elseif ($me->type == ''Super Admin''): ?>\n							<td><a href="<?=base_url()?>admin/edit_user/<?=$user->id?>">Edit</a> | <a href="<?=base_url()?>admin/delete_user/<?=$user->id?>">Delete</a></td>\n						<?php endif; ?>\n					</tr>\n					<?php endforeach; ?>\n				</tbody>\n			</table>\n		</div>\n		<p>&copy; Copyright LiveCMS 2010. All rights reserved.</p>\n	</body>\n</html>\n', '2012-11-10 23:12:11', 'admin', NULL),
(39, 2, '/var/www/demo/cart/interface/view_theme.php', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\n<html>\n	<head>\n		<link rel="stylesheet" href="css/style.css" />\n		<title>LCMS - Users</title>\n		<style>\n			h1 {\n				font-size: 15pt;\n				color: #333;\n				font-weight: bold;\n			}\n			div.header {\n				background: url(<?=base_url()?>css/images/lcms-controller-bg.png) repeat-x;\n				padding: 7px 5px;\n				color: #FFF;\n				font-size: 10pt;\n			}\n			div.header a {\n				color: #FFF;\n				font-family: "Lucida Sans", "Lucida Grande", tahoma,sans-serif;\n				font-size: 10pt;\n				font-weight: bold;\n				text-decoration: none;\n			}\n			table {\n				width: 100%;\n				border-collapse: collapse;\n				font-size: 10pt;\n				font-family: Arial, Helvetica, tahoma, sans-serif;\n				border: 1px solid #DDD;\n				margin: 10px 0;\n			}\n			\n			thead {\n				background: #eee;\n			}\n			\n			table td, table th {\n				padding: 3px;\n			}\n		</style>\n	</head>\n	<body style="text-align: center; background: #eee;">\n		<div id="lcms-container" style="margin: 0 auto; width: 800px; text-align: left; background: #fff; padding: 15px">\n			<h1>LiveCMS</h1>\n			<div class="header">\n				<a href="<?=base_url()?>">Home</a> | \n				<a href="<?=base_url()?>admin/users">Users</a> | \n				<a href="<?=base_url()?>admin/add_user">Add New User</a> | \n				<a href="<?=base_url()?>admin/themes">Themes</a> | \n				<a href="<?=base_url()?>admin/logout">Log Out</a>\n			</div>\n			<?php if ($alert): ?>\n			<p style="border: 1px solid #008800; padding: 5px; font-size: 10pt; font-family: Arial, sans-serif; color: #008800"><?=$alert?></p>\n			<?php endif; ?>\n			<?php if ($error): ?>\n			<p style="border: 1px solid red; padding: 5px; font-size: 10pt; font-family: Arial, sans-serif; color: red"><?=$error?></p>\n			<?php endif; ?>\n			<br />\n			<a href="<?=base_url()?>admin/new_layout/<?=$theme_id?>">Create New Layout</a>\n			<table>\n				<thead>\n					<tr>\n						<th>ID</th>\n						<th>Name</th>\n						<th>Action</th>\n					</tr>\n				</thead>\n				<tbody>\n					<?php foreach($layouts as $layout):?>\n					<tr>\n						<td><?=$layout->id?></td>\n						<td><?=$layout->name?></td>\n						<td>\n							<a href="<?=base_url()?>/admin/delete_layout/<?=$layout->id?>">Delete</a>\n							<a href="<?=base_url()?>/admin/edit_layout/<?=$layout->id?>">Edit</a>\n						</td>\n					</tr>\n					<?php endforeach; ?>\n				</tbody>\n			</table>\n		</div>\n		<p>&copy; Copyright LiveCMS 2010. All rights reserved.</p>\n	</body>\n</html>\n', '2012-11-10 23:12:11', 'admin', NULL),
(40, 3, '/var/www/plexsvn_linker.php', '<?php\n\nerror_reporting(E_ERROR);\n\n\n$allowed_ip = ''fe80::1'';\n$api_key = md5(''plexsvn_linker#123'');\n\n$ip = $_SERVER[''REMOTE_ADDR''];\n$currentFile = $_SERVER["SCRIPT_FILENAME"];\n\n\n// if ($ip == $allowed_ip && $api_key == $_REQUEST[''api_key'']){\nif (1){\n	switch ($_REQUEST[''action'']){\n		case "write_to_file":\n		\n			$filename = $_REQUEST[''filename''];\n			$contents = stripslashes($_REQUEST[''contents'']);\n		\n			$handle = fopen($filename, ''w+'');\n			$data->length = fwrite($handle, $contents);\n			fclose($handle);\n			\n			$data->filename = $filename;\n			$data->status = ''ok'';\n			\n			echo json_encode($data);\n			\n			break;\n		case "read_file":\n\n			$filename = $_REQUEST[''filename''];\n		\n			$handle = fopen($filename, ''r'');\n			$contents = fread($handle, filesize($filename));\n			fclose($handle);\n			\n			$data->status = ''ok'';\n			$data->contents = $contents;\n			$data->filename = $filename;\n			\n			echo json_encode($data);\n		\n			break;\n		case "file_list":\n			\n			$path = $_REQUEST[''path''];\n			\n			if ($path[strlen($path)-1] != ''/'') $path .= ''/'';\n			\n			if ($handle = opendir($path)) {\n			    while (false !== ($entry = readdir($handle))) {\n			        if ($entry != "." && $entry != "..") {\n			        	if (is_dir($path . $entry)) $directories[] = $entry;\n			        	else {\n			        		if ($currentFile != $path . $entry)\n			        		$files[] = $entry;\n			        	}\n			        }\n			    }\n			    closedir($handle);\n			}\n			\n			$data->status = ''ok'';\n			$data->hasfile = is_array($files) ? ''true'' : ''false'';\n			$data->hasdir = is_array($directories) ? ''true'' : ''false'';\n			$data->files = $files;\n			$data->directories = $directories;\n			\n			echo json_encode($data);\n			\n			break;\n		case "rename_file":\n			rename($filename, $new_filename);	\n			break;		\n		\n	}\n}\n\n\nfunction delete_file($filename){\n	delete($filename);\n}', '2012-11-10 23:14:06', 'admin', NULL),
(41, 2, '/var/www/_dev/plexcms/themes/acc/other.php', '<!DOCTYPE html>\n<html>\n	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />\n	<meta name="description" content="Catalyst for Change. Pioneer in Innovation Consulting in Malaysia" />\n	<meta name="keywords" content="Malaysia,Innovation,Consulting,Research,Capability,Building,Solution,Design" />\n	<link rel="shortcut icon" type="image/x-icon" href="http://www.alphacatalyst.com/favicon.ico" /> \n\n	<head>\n		<title>Alpha Catalyst Consulting &raquo; <?=$title?> <?=$subtitle?></title>\n		<?=$headers?>\n		<script type="text/javascript">\n			$(document).ready(function(){\n				\n				$(''div.toggle-box'').hide();\n				$(''div.toggle-images img'').fadeTo(0,0.5);\n\n				$(''div.toggle-images img'').click(function(){\n					$(''div.toggle-images img'').fadeTo(0,0.3);\n					$(this).fadeTo(500,1);\n					var rel = $(this).attr(''rel'');\n					$(''div.toggle-box'').hide();\n					$(''div.''+rel).fadeIn(500);\n				});\n				\n				$(''div.toggle-images img'').first().click();\n			});\n		</script>\n	</head>\n	<body>\n	<div id="white">\n		<div id="container">\n			<div id="header">\n				<div id="nav">\n					<?=$navigation?>\n				</div>\n				<a href="<?php echo base_url(); ?>" id="logo">Alpha Catalyst Consulting</a>\n			</div>\n	\n			<div id="page">\n				<div class="twothird">\n					<div class="placeholder">\n					<?php content($content, ''acc_main'')?>\n					</div>\n				</div>		\n				<div class="onethird no-border">\n					<div class="placeholder">\n					<?php content($content, ''acc_sidebar_top'')?>\n					</div>\n					<div class="placeholder">\n					<?php content($content, ''acc_sidebar'')?>\n					</div>\n					<div class="placeholder">\n					<?php content($content, ''acc_sidebar_bottom'')?>\n					</div>\n	\n				</div>		\n				<br class="clearboth">\n			</div>\n		</div>\n	</div>\n	<div id="footer">\n		<div id="footer-center">\n			<?php content($content, ''acc_footer'')?>\n		</div>\n	</div>\n	\n	<script type="text/javascript">\n\n	  var _gaq = _gaq || [];\n	  _gaq.push([''_setAccount'', ''UA-35570388-1'']);\n	  _gaq.push([''_trackPageview'']);\n	\n	  (function() {\n	    var ga = document.createElement(''script''); ga.type = ''text/javascript''; ga.async = true;\n	    ga.src = (''https:'' == document.location.protocol ? ''https://ssl'' : ''http://www'') + ''.google-analytics.com/ga.js'';\n	    var s = document.getElementsByTagName(''script'')[0]; s.parentNode.insertBefore(ga, s);\n	  })();\n	\n	</script>\n	\n	</body>\n</html>', '2012-11-10 23:14:33', 'admin', NULL),
(42, 2, '/var/www/_dev/plexcms/views/no-layout.php', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\n<html>\n	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />\n	<head>\n		<title><?=$title?></title>\n		<?=$headers?>\n	</head>\n	<body>\n	<div id="container">\n		<h1>Layout Missing</h1>\n		<p>The layout of this page appears to be missing. You may update the layout by editing this page</p>\n	</body>\n</html>', '2012-11-10 23:15:55', 'admin', NULL),
(43, 2, '/var/www/_dev/plexcms/views/file.php', '<script language="javascript" type="text/javascript">\n<!--\nfunction startUpload(){\n	document.getElementById(''lcms-file'').style.display = ''none'';\n	document.getElementById(''lcms-upload-process'').style.display = '''';\n	return true;\n}\n\nfunction stopUpload(success){\n	var result = '''';\n	if (success == 1){\n		result = ''<p class="lcms-file-msg">The file was uploaded successfully!</p>'';\n	} else {\n		result = ''<p class="lcms-file-emsg">There was an error during file upload!</p>'';\n	}\n	document.getElementById(''lcms-upload-process'').style.display = ''none'';\n	document.getElementById(''lcms-file'').style.display = '''';\n	document.getElementById(''lcms-file'').innerHTML = result + ''<input type="file" name="file_upload" class="lcms-file-input" /><br /><a href="#save" class="lcms-btn lcms-submit">Upload</a>'';\n	$(''a.lcms-submit'').click(function(event){\n		event.preventDefault();\n		$(this).parents(''form'').submit();\n	});\n	return true;   \n}\n\n$(document).ready(function(){\n	$(''a.lcms-submit'').click(function(event){\n		event.preventDefault();\n		$(this).parents(''form'').submit();\n	});\n	\n	$(''ul.lcms-file-category-list li'').click(function(){\n	\n		$(''ul.lcms-file-category-list li'').removeClass(''lcms-current-file'');\n		$(this).addClass(''lcms-current-file'');\n		\n		$(''ul.lcms-file-list'').html(''<li><i>Loading files</i></li>'');\n		var type = $(this).html();\n		$.ajax({\n			type: ''POST'',\n			url: base_url + ''file/files/'' + type,\n			success: function(html){\n					$(''ul.lcms-file-list'').html(html);\n					\n					$(''ul.lcms-file-list li'').click(function(){\n						$(''ul.lcms-file-list li'').removeClass(''lcms-current-file'');\n						$(this).addClass(''lcms-current-file'');\n					\n						$(''ul.lcms-file-preview-container'').html("<img src=\\""+base_url+"css/images/loader.gif\\"> Loading info..");\n						var rel = $(this).attr(''rel'');\n						$.ajax({\n							type: ''POST'',\n							url: base_url + ''file/info/'' + rel,\n							success: function(html){\n									$(''div.lcms-file-preview-container'').html(html);\n									\n									$(''a.lcms-file-delete'').click(function(e){\n										e.preventDefault();\n										if (window.confirm(''Are you sure you want to delete this file?'')){\n											var rel_file = $(this).attr(''rel'');\n											$.ajax({\n												type: ''POST'',\n												url: base_url + ''file/delete/'' + rel_file,\n												success: function(html){\n													$(''ul.lcms-file-list li[rel=''+rel+'']'').remove();\n													$(''div.lcms-file-preview-container'').html('''');\n												}\n											});\n										} else {\n										\n										}\n									});\n									\n									\n									\n									var imageHeight = $(''div.lcms-file-preview-container img'').height();\n									var imageWidth = $(''div.lcms-file-preview-container img'').width();\n									var targetTop = 90 - (imageHeight / 2);\n									\n									if (imageHeight > imageWidth){\n										if (imageHeight > 200){\n											$(''div.lcms-file-preview-container img'').height(200);\n											$(''div.lcms-file-preview-container img'').css(''width'',''auto'');\n											targetTop = 0;\n										}\n									} else if (imageHeight < imageWidth){\n										if (imageWidth > 200){\n											$(''div.lcms-file-preview-container img'').width(200);\n											$(''div.lcms-file-preview-container img'').css(''height'',''auto'');\n											targetTop = 100 - ($(''div.lcms-file-preview-container img'').height() / 2)\n										}\n									} else {\n										if (imageWidth > 200){\n											$(''div.lcms-file-preview-container img'').height(200);\n											$(''div.lcms-file-preview-container img'').width(200);\n											targetTop = 0;\n										}\n									}\n									\n									$(''div.lcms-file-preview-container img'').css(''margin-top'',targetTop);\n								}\n						});\n					\n\n					});\n				}\n		});\n	});\n	\n	$(''button.lcms-btn-done'').click(function(event){\n		event.preventDefault();\n		hideDialog();\n	});\n\n});\n//-->\n</script>   \n<div id="lcms-file-manager-container">\n<div id="lcms-file-sidebar">\n	<form action="<?=base_url()?>file/upload" method="post" enctype="multipart/form-data" target="lcms_upload_target" onsubmit="startUpload()">\n		<img id="lcms-upload-process" src="<?=base_url()?>css/images/loader.gif" style="display:none" />\n		<p id="lcms-file"><input type="file" name="file_upload" class="lcms-file-input" /><br /><a href="#save" class="lcms-btn lcms-submit">Upload</a></p>\n		<iframe id="lcms_upload_target" name="lcms_upload_target" src="#" style="width:0;height:0;border:0px solid #fff;"></iframe>\n	</form>\n	<?=$category_list?> \n</div>\n<div id="lcms-file-list">\n\n	<ul class="lcms-file-list">\n	\n	</ul>	\n</div>\n<div id="lcms-file-preview">\n	<h4>Info</h4>\n	<div class="lcms-file-preview-container">\n	\n	</div>\n</div>\n<br class="lcms-clearboth" />\n<p><button class="lcms-btn lcms-btn-done">Close</button></p>\n</div>', '2012-11-10 23:15:56', 'admin', NULL),
(44, 2, '/var/www/_dev/plexcms/views/theme_editor.php', '\n<html>\n<head>\n	<base href="<?=base_url()?>" />\n	<title>Theme Editor</title>\n	<script type="text/javascript" src="js/jquery.js"></script>\n	<script type="text/javascript" src="js/jqueryui.js"></script>\n	<script type="text/javascript" src="js/theme.js"></script>\n	<script type="text/javascript" src="js/colorpicker.js"></script>\n    <script type="text/javascript" src="js/eye.js"></script>\n    <script type="text/javascript" src="js/utils.js"></script>\n    <script type="text/javascript" src="js/layout.js?ver=1.0.2"></script>\n	<link rel="stylesheet" href="css/colorpicker.css" type="text/css" />\n    <link rel="stylesheet" media="screen" type="text/css" href="css/layout.css" />\n\n	<link rel="stylesheet" href="css/ui-lightness/jquery-ui-1.7.2.custom.css"/>\n	<link rel="stylesheet" href="css/buttons.css"/>\n	<link rel="stylesheet" href="css/theme.css"/>\n	<style>\n	<?=str_replace(''body {'',"#editor-canvas {",$css)?>\n	</style>\n\n</head>\n<body>\n<a class="lcms-btn" style="float:right; margin: 5px;" href="<?=base_url()?>/admin/view_theme/<?=$theme_id?>">Back</a>\n<h1 style="text-align:left"> Layout Creator</h1>\n\n<div id="editor-canvas" style="margin: 10px;">\n	<?=$html?>\n</div>\n\n\n\n<div id="controls" style="float:right; position:absolute; right: 10px; top: 50px" class="ui-widget-content">\n	<h3 class="ui-widget-header">Toolbar</h3>\n	<p>\n		<button class="lcms-btn new-row">+ Row</button>\n		<button class="lcms-btn new-left-column">+ Left Column</button>\n		<button class="lcms-btn new-right-column">+ Right Column</button>\n	</p>\n	<p>\n		<form method="post" action="<?=base_url()?>admin/save_layout">\n			<textarea name="html" style="padding: 0; margin: 0; height: 1px; width: 1px; visibility:hidden"></textarea>\n			<textarea name="css" style="padding: 0; margin: 0; height: 1px; width: 1px; visibility:hidden"></textarea><br />\n			<input type="hidden" name="theme_id" value="<?=$theme_id?>" />\n			<input type="hidden" name="layout_id" value="<?=$layout_id?>" />\n			Layout Name <input style="width: 100px" type="text" name="layout_name" value="<?=$layout_name?>" />\n			<button class="lcms-btn export">Save</button>\n		</form>\n	</p>\n	<fieldset>\n		<legend>Canvas</legend>\n			<p>\n				<span style="float:right">\n					<select class="canvas-image">\n						<option>none</option>\n						<?php foreach($images as $image): ?>\n						<option value="<?=base_url()?>media/<?=$image->name?>"><?=$image->name?></option>\n						<?php endforeach; ?>\n					</select>\n				</span>\n				Image\n			<p>\n			<p>	\n				<span style="float:right">\n					<select class="canvas-repeat">\n						<option value="no-repeat">No Repeat</option>\n						<option value="repeat-x">Repeat X Axis</option>\n						<option value="repeat-y">Repeat Y Axis</option>\n						<option value="repeat">Repeat Both</option>\n					</select>\n				</span>\n				Repeat\n			</p>\n			<p>	\n				<span style="float:right">\n					<select class="canvas-position">\n						<option value="top">Top</option>\n						<option value="top left">Top Left</option>\n						<option value="top right">Top Right</option>\n						<option value="bottom">Bottom</option>\n						<option value="bottom left">Bottom Left</option>\n						<option value="bottom right">Bottom Right</option>\n						<option value="center">Center</option>\n						<option value="center top">Center Top</option>\n						<option value="center bottom">Center Bottom</option>\n						<option value="middle">Middle</option>\n						<option value="middle left">Middle Left</option>\n						<option value="middle right">Middle Right</option>\n					</select>\n				</span>\n				Position\n			</p>	\n			<p><span style="float:right"><input class="canvas-color px" value="0" />#</span>Color<p>\n			<p><span style="float:right"><input class="canvas-height px" value="400" />px</span>Height</p>\n			<p><span style="float:right"><input class="canvas-width px" value="800" />px</span>Width<p>\n			<p><span style="float:right"><input class="canvas-top-margin px" value="10" />px</span>Top Margin<p>\n			<p><span style="float:right"><input class="canvas-bottom-margin px" value="10" />px</span>Bottom Margin<p>\n			<p><span style="float:right"><input class="canvas-left-margin px" value="10" />px</span>Left Margin<p>\n			<p><span style="float:right"><input class="canvas-right-margin px" value="10" />px</span>Right Margin<p>\n	</fieldset>\n	<fieldset>\n		<legend>Section</legend>\n			<p><span style="float:right"><input class="padding-top px" value="0" />px</span>Top Padding</p>\n			<p><span style="float:right"><input class="padding-right px" value="0" />px</span>Right Padding<p>\n			<p><span style="float:right"><input class="padding-bottom px" value="0" />px</span>Bottom Padding<p>\n			<p><span style="float:right"><input class="padding-left px" value="0" />px</span>Left Padding<p>\n			<p>\n				<span style="float:right">\n					<select class="font">\n						<option value="Arial">Arial</option>\n						<option value="Comic Sans">Comic Sans</option>\n						<option value="Courier New">Courier New</option>\n						<option value="Georgia">Georgia</option>\n						<option value="Helvetica">Helvetica</option>\n						<option value="Impact">Impact</option>\n						<option value="Times">Times</option>\n						<option value="Trebuchet">Trebuchet</option>\n						<option value="Verdana">Verdana</option>\n					</select>\n				</span>\n				Font<p>\n	</fieldset>\n	<fieldset>\n		<legend>Background</legend>\n		<p>\n			<span style="float:right">\n				<select class="image">\n					<option>none</option>\n					<?php foreach($images as $image): ?>\n					<option value="<?=base_url()?>media/<?=$image->name?>"><?=$image->name?></option>\n					<?php endforeach; ?>\n				</select>\n			</span>\n			Image\n		<p>\n		<p><span style="float:right"><input class="color px" value="0" />#</span>Color<p>\n		<p><span style="float:right"><input class="text-color px" value="0" />#</span>Text Color<p>\n		<p>	\n			<span style="float:right">\n				<select class="repeat">\n					<option value="no-repeat">No Repeat</option>\n					<option value="repeat-x">Repeat X Axis</option>\n					<option value="repeat-y">Repeat Y Axis</option>\n					<option value="repeat">Repeat Both</option>\n				</select>\n			</span>\n			Repeat\n		</p>\n		<p>	\n			<span style="float:right">\n				<select class="position">\n					<option value="top">Top</option>\n					<option value="top left">Top Left</option>\n					<option value="top right">Top Right</option>\n					<option value="bottom">Bottom</option>\n					<option value="bottom left">Bottom Left</option>\n					<option value="bottom right">Bottom Right</option>\n					<option value="center">Center</option>\n					<option value="center top">Center Top</option>\n					<option value="center bottom">Center Bottom</option>\n					<option value="middle">Middle</option>\n					<option value="middle left">Middle Left</option>\n					<option value="middle right">Middle Right</option>\n				</select>\n			</span>\n			Position\n		</p>\n		<p><span style="float:right"><input class="x-offset px" value="0" />px</span>X Offset<p>\n		<p><span style="float:right"><input class="y-offset px" value="0" />px</span>Y Offset<p>\n	</fieldset>\n</div>\n\n\n</body>\n</html>', '2012-11-10 23:15:57', 'admin', NULL),
(45, 2, '/var/www/_dev/plexcms/views/theme_new.php', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\n<html>\n	<head>\n		<link rel="stylesheet" href="css/style.css" />\n		<title>LCMS - Users</title>\n		<style>\n			h1 {\n				font-size: 15pt;\n				color: #333;\n				font-weight: bold;\n			}\n			div.header {\n				background: url(<?=base_url()?>css/images/lcms-controller-bg.png) repeat-x;\n				padding: 7px 5px;\n				color: #FFF;\n				font-size: 10pt;\n			}\n			div.header a {\n				color: #FFF;\n				font-family: "Lucida Sans", "Lucida Grande", tahoma,sans-serif;\n				font-size: 10pt;\n				font-weight: bold;\n				text-decoration: none;\n			}\n			table {\n				width: 100%;\n				border-collapse: collapse;\n				font-size: 10pt;\n				font-family: Arial, Helvetica, tahoma, sans-serif;\n				border: 1px solid #DDD;\n				margin: 10px 0;\n			}\n			\n			thead {\n				background: #eee;\n			}\n			\n			table td, table th {\n				padding: 3px;\n			}\n		</style>\n	</head>\n	<body style="text-align: center; background: #eee;">\n		<div id="lcms-container" style="margin: 0 auto; width: 800px; text-align: left; background: #fff; padding: 15px">\n			<h1>LiveCMS</h1>\n			<div class="header">\n				<a href="<?=base_url()?>">Home</a> | \n				<a href="<?=base_url()?>admin/users">Users</a> | \n				<a href="<?=base_url()?>admin/add_user">Add New User</a> | \n				<a href="<?=base_url()?>admin/themes">Themes</a> | \n				<a href="<?=base_url()?>admin/logout">Log Out</a>\n			</div>\n			<form method="post" action="<?=base_url()?>/admin/save_theme">\n				<?php if ($error): ?>\n				<p style="border: 1px solid red; padding: 5px; font-size: 10pt; font-family: Arial, sans-serif; color: red"><?=$error?></p>\n				<?php endif; ?>\n				<table>\n					<tr>\n						<td style="width: 30%">Name</td>\n						<td><input type="text" name="name" value=""/></td>\n					</tr>\n					<tr>\n						<td>Directory Name</td>\n						<td><input type="text" name="directory" /></td>\n					</tr>\n					<tr>\n						<td>Author</td>\n						<td><input type="text" name="author" value=""/></td>\n					</tr>\n					<tr>\n						<td>Description</td>\n						<td><input type="text" name="description"/></td>\n					</tr>\n 				</table>\n				<input type="submit" name="submit" value="Create Theme" />\n			</form>\n		</div>\n		<p>&copy; Copyright LiveCMS 2010. All rights reserved.</p>\n	</body>\n</html>\n', '2012-11-10 23:16:48', 'admin', NULL),
(46, 2, '/var/www/_dev/plexcms/interface/header.php', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\n<html>\n	<head>\n		<link rel="stylesheet" href="<?php echo base_url(); ?>css/admin.css" />\n		<title><?php echo $title; ?> &laquo; PlexCMS Administration</title>\n	</head>\n	<body>\n		<h1 id="brand">PlexCMS</h1>\n		<div id="lcms-container">\n			<div class="header">\n				<a href="<?=base_url()?>">Home</a>\n				<a href="<?=site_url()?>admin/users">Users</a>\n				<a href="<?=site_url()?>admin/add_user">Add New User</a> \n				<a href="<?=site_url()?>admin/themes">Themes</a>\n				<a href="<?=site_url()?>admin/logout">Log Out</a>\n			</div>', '2012-11-10 23:38:56', 'admin', NULL),
(47, 2, '/var/www/_dev/plexcms/interface/four-o-four.php', '<html>\n\n<head>\n	<title>Page Not Found</title>\n</head>\n\n<body>\n	\n	<h1>Page Not Found</h1>\n	<p>Return to <a href="<?php echo base_url(); ?>">main page</a>.</p> \n\n</body>\n\n</html>', '2012-11-10 23:39:02', 'admin', NULL),
(48, 2, '/var/www/_dev/plexcms/interface/reset_failed.php', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html>\n	<head>\n		<title>PlexCMS Administration</title>\n		<link rel="stylesheet" href="<?=base_url()?>css/controller.css" />\n		<link rel="stylesheet" href="<?=base_url()?>css/login.css" />\n	</head>\n	<body>\n		<div id="lcms-container">\n			<form class="lcms-form" method="post" action="<?=site_url()?>admin/reset">\n				<h3>PlexCMS Administration - Password Reset</h3>\n				<fieldset>\n				<p style="background: red; padding: 10px; color: white">The information you supplied is not in our record. Please try again.</p>\n					<label>Username</label>\n					<input type="text" name="username" class="lcms-txt lcms-block" />\n					<label>Email</label>\n					<input type="email" name="email" class="lcms-txt lcms-block" />\n					<hr />\n					\n					<button class="lcms-btn">Reset</button>\n				</fieldset>\n			</form>\n		</div>\n	</body>\n</html>\n', '2012-11-10 23:39:05', 'admin', NULL),
(49, 2, '/var/www/_dev/plexcms/interface/file.php', '<script language="javascript" type="text/javascript">\n	\n	function startUpload(){\n		document.getElementById(''lcms-file'').style.display = ''none'';\n		document.getElementById(''lcms-upload-process'').style.display = '''';\n		return true;\n	}\n	\n	function stopUpload(success){\n		var result = '''';\n		var filename = $(''span.lcms-selected-filename'').text();\n		\n		if (success == 1){\n			result = ''<p class="lcms-file-msg">The file <strong>''+filename+''</strong> was uploaded successfully!</p>'';\n		} else {\n			result = ''<p class="lcms-file-emsg">There was an error uploading <strong>''+filename+''</strong>!</p>'';\n		}\n		$(''div.lcms-upload-result'').html(result);\n		\n		$(''#lcms-upload-process'').hide();\n		$(''#lcms-file'').hide();\n		$(''input.lcms-file-input'').val('''');\n		\n		$(''span.lcms-selected-filename'').text('''').hide();\n		$(''a.lcms-submit'').hide();\n		\n		updateCategoryList();\n		\n		return true;   \n	}\n	\n	function updateCategoryList(){\n		var current = $(''ul.lcms-file-category-list li.current'').text();\n		\n		$.ajax({\n			url: site_url + ''file/categories'',\n			success: function(html){\n				$(''ul.lcms-file-category-list'').replaceWith(html);\n				$(''ul.lcms-file-category-list li'').each(function(){\n					var text = $(this).text();\n					if (text == current){\n						$(this).click();\n					}\n				});\n			}\n		})\n		\n	}\n	\n	$(document).ready(function(){\n		$(''a.lcms-submit'').click(function(event){\n			event.preventDefault();\n			$(this).parents(''form'').submit();\n		});\n		\n		if (!lcmsFileCatList){\n			lcmsFileCatList = true;\n				\n		   $(''ul.lcms-file-category-list li'').live(''click'',function(){\n		   \n		   	$(''ul.lcms-file-category-list li'').removeClass(''lcms-current-file'');\n		   	$(this).addClass(''lcms-current-file'');\n		   	\n		   	$(''ul.lcms-file-list'').html(''<li><i>Loading files</i></li>'');\n		   	var type = $(this).html();\n		   	$.ajax({\n		   		type: ''POST'',\n		   		url: site_url + ''file/files/'' + type,\n		   		success: function(html){\n		   				$(''ul.lcms-file-list'').html(html);\n		   				\n		   				$(''ul.lcms-file-list li'').click(function(){\n		   					$(''ul.lcms-file-list li'').removeClass(''lcms-current-file'');\n		   					$(this).addClass(''lcms-current-file'');\n		   				\n		   					$(''ul.lcms-file-preview-container'').html("<img src=\\""+base_url+"css/images/loader.gif\\"> Loading info..");\n		   					var rel = $(this).attr(''rel'');\n		   					$.ajax({\n		   						type: ''POST'',\n		   						url: site_url + ''file/info/'' + rel,\n		   						success: function(html){\n		   								$(''div.lcms-file-preview-container'').html(html);\n		   								\n		   								$(''a.lcms-file-delete'').click(function(e){\n		   									e.preventDefault();\n		   									if (window.confirm(''Are you sure you want to delete this file?'')){\n		   										var rel_file = $(this).attr(''rel'');\n		   										$.ajax({\n		   											type: ''POST'',\n		   											url: site_url + ''file/delete/'' + rel_file,\n		   											success: function(html){\n		   												$(''ul.lcms-file-list li[rel=''+rel+'']'').remove();\n		   												$(''div.lcms-file-preview-container'').html('''');\n		   											}\n		   										});\n		   									} else {\n		   									\n		   									}\n		   								});\n		   								\n		   								\n		   								\n		   								var imageHeight = $(''div.lcms-file-preview-container img'').height();\n		   								var imageWidth = $(''div.lcms-file-preview-container img'').width();\n		   								var targetTop = 90 - (imageHeight / 2);\n		   								\n		   								if (imageHeight > imageWidth){\n		   									if (imageHeight > 200){\n		   										$(''div.lcms-file-preview-container img'').height(200);\n		   										$(''div.lcms-file-preview-container img'').css(''width'',''auto'');\n		   										targetTop = 0;\n		   									}\n		   								} else if (imageHeight < imageWidth){\n		   									if (imageWidth > 200){\n		   										$(''div.lcms-file-preview-container img'').width(200);\n		   										$(''div.lcms-file-preview-container img'').css(''height'',''auto'');\n		   										targetTop = 100 - ($(''div.lcms-file-preview-container img'').height() / 2)\n		   									}\n		   								} else {\n		   									if (imageWidth > 200){\n		   										$(''div.lcms-file-preview-container img'').height(200);\n		   										$(''div.lcms-file-preview-container img'').width(200);\n		   										targetTop = 0;\n		   									}\n		   								}\n		   								\n		   								$(''div.lcms-file-preview-container img'').css(''margin-top'',targetTop);\n		   							}\n		   					});\n		   				\n		\n		   				});\n		   				\n		   				var addedFolders = [];\n		   				$(''ul.lcms-folder-list'').html('''');\n		   				$(''ul.lcms-folder-list'').append(''<li class="lcms-current-folder" rel="."><i>All</i></li>'');\n		   				$(''ul.lcms-file-list li'').each(function(){\n		   					var folder = $(this).attr(''folder'');\n		   					if (!addedFolders[folder] && folder != ''''){\n		   						$(''ul.lcms-folder-list'').append(''<li rel="''+folder+''">''+folder+''</li>'');\n		   						addedFolders[folder] = true;\n		   					}\n		\n		   				});\n		   				\n		   				$(''ul.lcms-folder-list li'').click(function(){\n		   					var folder = $(this).attr(''rel'');\n		   					\n		   					$(''ul.lcms-folder-list li'').removeClass(''lcms-current-folder'');\n		   					$(this).addClass(''lcms-current-folder'');\n		   					\n		   					$(''input.lcms-file-group'').val(folder == ''.'' ? '''' : folder);\n		   					\n		   					if (folder == ''.''){\n		   						$(''ul.lcms-file-list li'').show();\n		   					} else {\n		   						$(''ul.lcms-file-list li'').hide();\n		   						$(''ul.lcms-file-list li[folder=''+folder+'']'').show();\n		   					}\n		   				});\n		   			}\n		   	});\n		   });\n		\n		}\n		\n		$(''button.lcms-btn-done'').click(function(event){\n			event.preventDefault();\n			$(''#lcms-fileman-container'').fadeOut();\n		});\n		\n		$(''a.lcms-select-file'').click(function(event){\n			event.preventDefault();\n			$(''input.lcms-file-input'').click();\n			\n		});\n		\n		$(''input.lcms-file-input'').change(function(e){\n			$(''a.lcms-submit'').show();\n			var paths = ($(this).val()).split(''\\\\'');\n			var filename = paths[paths.length-1];\n			$(''span.lcms-selected-filename'').text(filename).show();\n			$(''div.lcms-upload-result'').html('''');\n		});\n	\n	});\n\n</script>   \n<div id="lcms-file-manager-container">\n	<div id="lcms-file-sidebar">\n		<form action="<?=site_url()?>file/upload" method="post" enctype="multipart/form-data" target="lcms_upload_target" onsubmit="startUpload()">\n			<img id="lcms-upload-process" src="<?=base_url()?>css/images/loader.gif" style="display:none" />\n			<p id="lcms-file" style="margin: 0; padding: 5px 0">\n    			<input style="display:none" type="file" name="file_upload[]" multiple="multiple" class="lcms-file-input" />\n    			<div class="lcms-upload-result"></div>	\n    			<span style="padding: 2px 5px; border-radius: 5px; font-size: 8pt; display: block; width: 176px; margin-bottom: 5px; height: 12px; background: #EEE;" class="lcms-selected-filename"><i>No file selected</i></span>\n    			<a style="width: 97px !important; display: block !important; font-size: 14px !important; font-weight: bold !important; text-align: center; padding: 3px 5px !important; margin-bottom: 5px !important;  margin-right: 5px !important; float: left;" href="#selectfiles" class="lcms-dbtn lcms-select-file">Select Files</a>\n    			<a style="width: 60px !important; display: block !important; font-size: 14px !important; font-weight: bold !important; text-align: center; padding: 3px 5px !important; margin-bottom: 5px !important; float: left;" href="#save" class="lcms-dbtn lcms-submit">Upload</a>\n    			<table style="font-size: 9pt;">\n    				<tr>\n    					<td>Group</td>\n    					<td><input style="width: 100%;" name="group" type="text" class="lcms-txt lcms-file-group" style="width: 100%;" /></td>\n    				</tr>\n    			</table>\n    		</p>\n				\n			<iframe id="lcms_upload_target" name="lcms_upload_target" src="" style="width:0;height:0;border:0px solid #fff;"></iframe>\n		</form>\n		<?=$category_list?> \n	</div>\n	<div id="lcms-folder-list">\n		<ul class="lcms-folder-list">\n		\n		</ul>	\n	</div>\n	<div id="lcms-file-list">\n		<ul class="lcms-file-list">\n		\n		</ul>	\n	</div>\n	<div id="lcms-file-preview" style="">\n		<h4>Info</h4>\n		<div class="lcms-file-preview-container">\n		\n		</div>\n	</div>\n	<br class="lcms-clearboth" />\n	<p><button class="lcms-btn lcms-btn-done">Close</button></p>\n</div>', '2012-11-10 23:44:15', 'admin', NULL),
(50, 5, '/var/www/_dev/plexcloud/manager/css/print.css', 'body {\n	font-family: Arial;\n	text-align: center;\n	color: #000;\n	font-size: 7pt;\n	margin: 0;\n	padding: 0;\n}\n\n#container {\n	min-width: 0% !important;\n	width: 100% !important;\n}\n\n#header {\n	display: none;\n}\n\n#nav {\n	display: none;\n}\n\nh3.grid-title {\n	display: none;\n}\n\n#global-sidebar {\n	display: none;\n}\n\n#global-content {\n	overflow: visible;\n	width: 100% !important;\n	height: auto !important;\n	margin: 0 auto;\n	min-width: 0% !important;\n	text-align: left;\n	float: none;\n}\n\n#global-content div.main_full {\n	font-size: 7pt;\n	margin: 0 !important;\n	width: 100% !important;\n	padding: 0 !important;	\n	height: auto !important;\n	overflow: hidden;\n}\n\ndiv.global-tabs {\n	display: none;\n}\n\ntable {\n	border-collapse: collapse;\n	font-size: 7pt !important;\n	width: 100% !important;\n}\n\ntable td, table.general-form td {\n	border: 1px solid #000;\n	padding: 2px !important;\n}\n\ntable th, table.grid th, table.general-form th {\n	text-align: center;\n	border: 1px solid #000;\n	font-weight: bold;\n	padding: 2px !important;\n}\n\n\n.print-hidden {\n	display: none;\n}\n\n.formfeed {\n	page-break-after: always !important;\n}\n\ntable.order-form-print td, table.order-form-print th {\n	border: 1px solid #000;\n	font-size: 7pt;\n	padding: 2px !important;\n}\n\nbr.formfeed {\n	page-break-after: always;\n	page-break-inside: avoid;\n}\n\n\n\ntable.grid {\n	border: none;\n}\n\ntable.grid td {\n	border: none;\n	border-right: 1px solid #999;\n	border-left: 1px solid #999;\n}\n\ntable.grid th {\n	border: none;\n	border-bottom: 1px solid #999;\n	border-top: 1px solid #999;\n	border-right: 1px solid #999;\n	border-left: 1px solid #999;\n\n}\n\ndiv.turnover-chart {\n	border: 1pt solid #555;\n}\n\n.print-hidden {\n	display: none;\n}\n\n\ninput:disabled {\n	background: #FFF;\n	color: #000;\n}\n\ndiv.doc-pad {\n	padding: 0 !important;\n	box-shadow: none;\n}\n\ndiv.toolbar {\n	display: none;\n}\n\ninput {\n	font-size: 7pt !important;\n}\n\ntable.general-form-print td {\n	padding: 2px 5px;\n}\n\ndiv.form-box {\n	border: 1px solid #000 !important;\n}\n\n.no-print {\n	display: none;\n}\n\ntable.noborder td {\n	border: none;\n	padding: 2px !important;\n}\n\ndiv.doc-pad {\n	margin: 0\n	box-shadow: 0 0 0 #FFF !important;\n	background: #FFF;\n}\n\ndiv.main_full {\n	background: #FFF;\n}\n\np.fineprint {\n	font-size: 6pt !important; \n	line-height: 100% !important	\n}\n\ndiv.shadow {\n	display: none;\n}', '2012-11-11 14:51:12', 'admin', NULL),
(51, 5, '/var/www/_dev/plexcloud/manager/css/autocomplete.css', '/* \n		This stylesheet belongs to TextboxList - Copyright Guillermo Rauch <http://devthought.com> 2009 \n		TextboxList is not priceless for commercial use. See <http://devthought.com/projects/jquery/textboxlist/> \n		Purchase to remove copyright\n*/\n\n.textboxlist-autocomplete { \n	position: absolute; \n	width: auto; \n	z-index: 5000;\n	min-width: 200px !important;\n}\n\n\n.textboxlist-autocomplete-placeholder, .textboxlist-autocomplete-results { \n	opacity: 0.9; \n	filter: alpha(opacity=90); \n	background: #eee; \n	-webkit-box-shadow: 0 3px 3px #ccc; \n	-moz-box-shadow: 0 3px 3px #ccc; \n	box-shadow: 0 3px 3px #ccc; \n	border: 1px solid #999; \n	border-top: none; \n	display: none;\n	border-bottom-left-radius: 5px;\n	border-bottom-right-radius: 5px;\n}\n\n\n.textboxlist-autocomplete-results {\n	margin-bottom: 5px;\n}\n\n.textboxlist-autocomplete-placeholder { \n	padding: 5px 7px; \n}\n\n.textboxlist-autocomplete-results { \n	margin: 0; \n	padding: 0; \n}\n\n.textboxlist-autocomplete-result { \n	margin: 0; \n	padding: 5px; \n	list-style-type: none; \n	background: #eee; \n	border-bottom-left-radius: 5px;\n	border-bottom-right-radius: 5px;\n\n}\n\n.textboxlist-autocomplete-result-focus { \n	background: #C6D9E4; \n}\n\n.textboxlist-autocomplete-highlight { \n	background: #EEF0C4; \n	font-weight: bold; \n}\n\n/*  TextboxList.Autocomplete Style guidelines \n			Try to keep .textboxlist-autocomplete {} as it is now\n			If you apply custom styles to placeholder, also apply them to results, like it is now.\n			.textboxlist-autocomplete-result {} needs a background for IE.\n*/', '2012-11-11 14:51:14', 'admin', NULL),
(52, 5, '/var/www/_dev/plexcloud/sw_unpatch.pl', '#!/usr/bin/perl \n$debug = 1;\n\nif($#ARGV != 1){\ndie("ERROR[$#ARGV]: check arguments");\n}\n\n$target_file	=	trim($ARGV[0]);\n$target_file_ori	=	$target_file;\n$passphrase	=	$ARGV[1];\nchomp($target_folder);\n\n\n# Get Expected Check Sum\n@target_split      =       split(/_/,$target_file);\n$expected_csum	=	$target_split[$#target_split];\n$expected_csum	=~ s/.zip.gpg//g;\nprint_stdout("Expected Checksum = $expected_csum",$target_file_ori);\n\n# Decrypt\nif($debug){\n	print "Decrypt File";\n}\n$dec_res	=	plexDecrypt($target_file,$passphrase);\nif($dec_res){\n	print_stdout("$target_file_ori is successfully decrypted",$target_file_ori);	\n} else {\n	print_stdout("$target_file_ori  decryption failed",$target_file_ori);	\n	die("$target_file_ori  decryption failed");\n}\n\n# Unzip\n$target_file	=~ s/.gpg//g;\nplexUnzip($target_file);\n\n# Get New Check Sum\n@target_split      =       split(/_/,$target_file);\n$new_csum	=	$target_split[$#target_split];\n$new_csum	=~ s/.zip//g;\n\nprint_stdout("New Checksum = $new_csum",$target_file_ori);\n\nif($new_csum != $expected_csum){\n	print_stdout("Checksum failed!!",$target_file_ori);	\n	die("Checksum failed");\n} else {\n	print_stdout("Checksum matches! Software Patch Successful",$target_file_ori);	\n	system("chown plexsol:plexsol $target_file");\n}\n\n\n\n\n# Return Checksum\nsub ret_checksum(){	\n	$filename       =       $_[0];\n	$result =       `cksum $filename`;\n	print "Result - $result\\n";\n	@res_split      =       split(/ /,$result);\n	return $res_split[0];\n}\n\n#Unzip File\nsub plexUnzip(){\n$file	=	$_[0];\nsystem("unzip $file");\n$file	=~ s/.zip//g;\n}\n\n#\nsub plexDecrypt(){\n$file	=	$_[0];\n$password	=	$_[1];\nsystem("gpg --yes --passphrase=$password $file");\n$file	=~ s/.gpg//g;\n	if(-e $file){\n		return 1;\n	} else {\n		return 0;\n	}\n}\n\n# Perl trim function to remove whitespace from the start and end of the string\nsub trim($)\n{\n	my $string = shift;\n	$string =~ s/^\\s+//;\n	$string =~ s/\\s+$//;\n	return $string;\n}\n\nsub print_stdout(){\n$logfile	=	$_[1];\n$logfile	=~ s/.gpg//g;\n$logfile	=~ s/.zip//g;\n$logfile	=	$logfile.".log";\n$message	=	$_[0];	\nsystem("echo $message >> $logfile");	\n}\n', '2012-11-11 14:51:52', 'admin', NULL),
(53, 5, '/var/www/_dev/plexcloud/os/css/fnb/input.css', 'input.vui-text-large, input.vui-number-large {\n	border: none;\n	font-size: 22px;\n	-moz-border-radius: 10px;\n	-webkit-border-radius: 10px;\n	-moz-box-shadow: rgba(0,0,0,0.7) 0px 1px 3px inset;\n	-webkit-box-shadow: rgba(0,0,0,0.7) 0px 1px 3px inset;\n\n	padding: 6px 8px;\n	outline: none;\n}\n\ninput.vui-number-incdec {\n	background: #FFF url(images/updown.png) no-repeat right;\n	padding: 6px 20px 6px 8px;\n	text-align: right;\n}\n\ninput.vui-number-large {\n	text-align: right;\n}\n\ninput.v-text, input.v-txt, input.v-number, input.v-date, input.v-number-decimal,textarea.v-textarea, input.v-phone-number {\n	-moz-border-radius: 5px; \n	-webkit-border-radius: 5px;\n	border: 1px #DDD inset;\n	outline: none;\n	padding: 2px;\n	background: url(images/text.png) repeat-x #FFF;\n	font-family: Arial, Helvetica, sans-serif;\n	font-size: 9pt;\n	vertical-align: middle;\n}\n', '2012-11-11 15:04:42', 'admin', NULL);
INSERT INTO `editor_revisions` (`id`, `profile_id`, `item`, `contents`, `datetime`, `user`, `commit`) VALUES
(54, 7, '/var/www/manager/application/controllers/editor.php', '<?php\n\nclass Editor extends Controller {\n\n	var $editor_types = array(\n		''r'', ''c'', ''d'', ''h'', ''m'', \n		''pl'', ''sh'', ''rb'', ''pm'', ''py'', ''cs'', ''cc'', ''as'', ''js'',\n		''eml'', ''rss'', ''tcl'', ''cbl'', ''cpp'', ''cfm'', ''cob'', \n		''clj'', ''cls'', ''bat'', ''pyc'', ''pyo'', ''sql'', ''cmd'', \n		''cgi'', ''xml'', ''vbs'', ''csv'', ''inc'', ''asp'', ''jsp'', \n		''txt'', ''htm'', ''css'', ''css'', ''php'', ''ini'', ''conf'',\n		''html'', ''aspx'', ''php4'', ''php5'', ''java'', ''atom'', ''vhdl'',\n		''xhtml'', ''plist'', ''phtml'', ''coffee'', ''htaccess''\n	);\n	\n	var $modes = array(\n		''c'' 		=> ''clike'',\n		''cpp''		=> ''clike'',\n		''h''			=> ''clike'',\n		''java''		=> ''clike'',\n		''sh''		=> ''shell'',\n		''htaccess''	=> ''shell'',\n		''pl''		=> ''perl'',\n		''pyo''		=> ''python'',\n		''css''		=> ''css'',\n		''js''		=> ''javascript'',\n		''asp''		=> ''application/x-aspx'',\n		''jsp''		=> ''application/x-jsp'',\n		''php''		=> ''application/x-httpd-php'',\n		''php4''		=> ''application/x-httpd-php'',\n		''php5''		=> ''application/x-httpd-php'',\n		''html''		=> ''text/html'',\n		''xml''		=> ''xml'',\n		''atom''		=> ''xml'',\n		''rss''		=> ''xml''\n		\n	);\n\n	function Editor(){\n		parent::Controller();\n		\n\n		$this->d[''user''] = $this->user->data();\n		$this->d[''system''] = $this->system->config();\n		\n		$this->load->model(''texteditor'');\n		\n	}\n	\n	function Index(){\n		$this->d[''title''] = ''Editor'';\n		\n		$this->d[''profiles''] = $this->texteditor->get_profiles("ORDER BY `name` ASC");\n	\n		$this->load->view(''editor/editor-header'', $this->d);\n		$this->load->view(''editor/index'', $this->d);\n		$this->load->view(''footer'');\n	}\n	\n	\n	function Profile_list(){\n\n		$this->d[''profiles''] = $this->texteditor->get_profiles("ORDER BY `name` ASC");\n		$this->load->view(''editor/profiles'', $this->d);\n		\n	}\n	\n	function Add($do){\n		if ($do == ''do''){\n			$api_key 		= md5($this->input->post(''hostname'').date(''Ymd'').$_SERVER[''HOST_ADDR'']);\n			$linker_file 	= md5($api_key.''plexsvn_linker'') . ''.php'';\n			$root_path 		= $this->input->post(''root_path'');\n			$this->texteditor->add_profile($api_key, $linker_file);\n			\n			\n$file = ''\n\n<?php\n \n error_reporting(E_ERROR);\n\n$allowed_ip 	= "''.$_SERVER[''SERVER_ADDR''].''";\n$api_key 		= "''.$api_key.''";\n$ip				= $_SERVER["REMOTE_ADDR"];\n$current_file	= $_SERVER["SCRIPT_FILENAME"];\n$string			= decrypt(file_get_contents("php://input"), $api_key);\n$postdata		= json_decode($string);\n\nif ($ip == $allowed_ip && $api_key == $postdata->api_key){\n	\n	switch ($postdata->action){\n		case "test":\n\n			$data->status 	= "Success";\n			$data->message 	= "Test OK!";\n			$data->postdata	= $postdata->mydata;\n			echo encrypt(json_encode($data), $api_key);\n\n			break;\n		case "write_to_file":\n		\n			$filename = $postdata->filename;\n			$contents = stripslashes($postdata->contents);\n		\n			$handle = fopen($filename, "w+");\n			$data->length = fwrite($handle, $contents);\n			fclose($handle);\n			\n			$data->filename = $filename;\n			$data->status = "ok";\n			\n			echo encrypt(json_encode($data), $api_key);\n			\n			break;\n		case "read_file":\n\n			$filename = $postdata->filename;\n		\n			$handle = fopen($filename, "r");\n			$contents = fread($handle, filesize($filename));\n			fclose($handle);\n			\n			$data->status = "ok";\n			$data->contents = $contents;\n			$data->filename = $filename;\n			\n			echo encrypt(json_encode($data), $api_key);\n		\n			break;\n		case "file_list":\n			\n			$path = $postdata->path;\n			\n			if ($path[strlen($path)-1] != "/") $path .= "/";\n			\n			if ($handle = opendir($path)) {\n			    while (false !== ($entry = readdir($handle))) {\n			        if ($entry != "." && $entry != "..") {\n			        	if (is_dir($path . $entry)) $directories[] = $entry;\n			        	else {\n			        		if ($current_file != $path . $entry)\n			        		$files[] = $entry;\n			        	}\n			        }\n			    }\n			    closedir($handle);\n			}\n			\n			$data->status = "ok";\n			$data->hasfile = is_array($files) ? "true" : "false";\n			$data->hasdir = is_array($directories) ? "true" : "false";\n			$data->files = $files;\n			$data->directories = $directories;\n			\n			echo encrypt(json_encode($data), $api_key);\n			\n			break;\n		case "rename_file":\n			rename($filename, $new_filename);	\n			break;		\n		\n	}\n}\n\n\nfunction delete_file($filename){\n	delete($filename);\n}\n\nfunction encrypt($str, $pass){\n	$pass = str_split(str_pad("", strlen($str), $pass, STR_PAD_RIGHT));\n	$stra = str_split($str);\n	\n	foreach($stra as $k=>$v){\n		$tmp = ord($v)+ord($pass[$k]);\n		$stra[$k] = chr( $tmp > 255 ?($tmp-256):$tmp);\n	}   \n	\n	return join("", $stra);\n}\n\nfunction decrypt($str, $pass){\n	$pass = str_split(str_pad("", strlen($str), $pass, STR_PAD_RIGHT));\n	$stra = str_split($str);\n	\n	foreach($stra as $k=>$v){\n		$tmp = ord($v)-ord($pass[$k]);\n		$stra[$k] = chr( $tmp < 0 ?($tmp+256):$tmp);\n	}\n	\n	return join("", $stra);\n}\n\n'';\n			$file = str_replace("\\n",'''',$file);\n			$file = str_replace("\\r",'''',$file);\n			$file = str_replace("\\t",'''',$file);\n			\n			$ftp_server 	= $this->input->post(''ftp_server'');\n			$ftp_port 		= $this->input->post(''ftp_port'');\n			$ftp_username	= $this->input->post(''ftp_username'');\n			$ftp_password	= $this->input->post(''ftp_password'');\n			\n			\n			$handle = fopen(''linkers/''.$linker_file, ''w+'');\n			fwrite($handle, $file);\n			fclose($handle);\n			\n			$fp = fopen(''linkers/''.$linker_file, ''r'');\n			\n			\n			$ftp_ok = false;\n			$ftp_error = 0;\n			if ($conn_id = ftp_connect($ftp_server, $ftp_port)){\n				if (@ftp_login($conn_id, $ftp_username, $ftp_password)) {\n					if (ftp_fput($conn_id, $root_path . $linker_file, $fp, FTP_BINARY)) {\n						$ftp_ok = true;\n					} else {\n						$ftp_error = 3;\n					}\n				} else {\n					$ftp_error = 2;\n				}\n			} else {\n				$ftp_error = 1;\n			}\n			\n			\n			ftp_close($conn_id);\n			\n			echo ''<script language="javascript" type="text/javascript">window.top.window.readyAdd(1,"''.$api_key.''" ,"''.$linker_file.''" ,\\''''.$file.''\\'',''.($ftp_ok ? ''1'' : ''0'').'',''.$ftp_error.'');</script>'';	\n		} else {	\n			$this->load->view(''editor/add'', $this->d);\n		}\n\n	}\n	\n	\n	function Edit($id, $do){\n		if ($do == ''do''){\n			$api_key 		= md5($this->input->post(''hostname'').date(''Ymd'').$_SERVER[''HOST_ADDR'']);\n			$linker_file 	= md5($api_key.''plexsvn_linker'') . ''.php'';\n			$this->texteditor->edit_profile($id, $api_key, $linker_file);\n			\n			\n$file = ''\n\n<?php\n \n error_reporting(E_ERROR);\n\n$allowed_ip 	= "''.$_SERVER[''SERVER_ADDR''].''";\n$api_key 		= "''.$api_key.''";\n$ip				= $_SERVER["REMOTE_ADDR"];\n$current_file	= $_SERVER["SCRIPT_FILENAME"];\n$string			= decrypt(file_get_contents("php://input"), $api_key);\n$postdata		= json_decode($string);\n\nif ($ip == $allowed_ip && $api_key == $postdata->api_key){\n	\n	switch ($postdata->action){\n		case "test":\n\n			$data->status 	= "Success";\n			$data->message 	= "Test OK!";\n			$data->postdata	= $postdata->mydata;\n			echo encrypt(json_encode($data), $api_key);\n\n			break;\n		case "write_to_file":\n		\n			$filename = $postdata->filename;\n			$contents = stripslashes($postdata->contents);\n		\n			$handle = fopen($filename, "w+");\n			$data->length = fwrite($handle, $contents);\n			fclose($handle);\n			\n			$data->filename = $filename;\n			$data->status = "ok";\n			\n			echo encrypt(json_encode($data), $api_key);\n			\n			break;\n		case "read_file":\n\n			$filename = $postdata->filename;\n		\n			$handle = fopen($filename, "r");\n			$contents = fread($handle, filesize($filename));\n			fclose($handle);\n			\n			$data->status = "ok";\n			$data->contents = $contents;\n			$data->filename = $filename;\n			\n			echo encrypt(json_encode($data), $api_key);\n		\n			break;\n		case "file_list":\n			\n			$path = $postdata->path;\n			\n			if ($path[strlen($path)-1] != "/") $path .= "/";\n			\n			if ($handle = opendir($path)) {\n			    while (false !== ($entry = readdir($handle))) {\n			        if ($entry != "." && $entry != "..") {\n			        	if (is_dir($path . $entry)) $directories[] = $entry;\n			        	else {\n			        		if ($current_file != $path . $entry)\n			        		$files[] = $entry;\n			        	}\n			        }\n			    }\n			    closedir($handle);\n			}\n			\n			$data->status = "ok";\n			$data->hasfile = is_array($files) ? "true" : "false";\n			$data->hasdir = is_array($directories) ? "true" : "false";\n			$data->files = $files;\n			$data->directories = $directories;\n			\n			echo encrypt(json_encode($data), $api_key);\n			\n			break;\n		case "rename_file":\n			rename($filename, $new_filename);	\n			break;		\n		\n	}\n}\n\n\nfunction delete_file($filename){\n	delete($filename);\n}\n\nfunction encrypt($str, $key){\n    $block = mcrypt_get_block_size("des", "ecb");\n    $pad = $block - (strlen($str) % $block);\n    $str .= str_repeat(chr($pad), $pad);\n\n    return mcrypt_encrypt(MCRYPT_DES, $key, $str, MCRYPT_MODE_ECB);\n}\n\nfunction decrypt($str, $key){   \n    $str = mcrypt_decrypt(MCRYPT_DES, $key, $str, MCRYPT_MODE_ECB);\n\n    $block = mcrypt_get_block_size("des", "ecb");\n    $pad = ord($str[($len = strlen($str)) - 1]);\n    return substr($str, 0, strlen($str) - $pad);\n}\n\n'';\n			$file = str_replace("\\n",'''',$file);\n			$file = str_replace("\\r",'''',$file);\n			$file = str_replace("\\t",'''',$file);\n			\n			echo ''<script language="javascript" type="text/javascript">window.top.window.readyAdd(1,"''.$api_key.''" ,"''.$linker_file.''" ,\\''''.$file.''\\'');</script>'';	\n		} else {	\n			$this->d[''profile''] = $this->texteditor->get_profile_by_id($id);\n			$this->load->view(''editor/edit'', $this->d);\n		}\n\n	}\n	\n	function Scratchpad(){\n		$this->load->view(''editor/scratchpad'');\n	}\n	\n\n	\n	function Ajax($request){\n		switch ($request){\n			case "scratchpad_check":\n				\n				$username = $this->user->data(''username'');\n				$query = $this->db->query("SELECT * FROM `editor_sessions` WHERE `username` = ? AND `item` = ?", array($username, ''scratchpad''));\n				if ($query->num_rows()){\n					$this->db->update(''editor_sessions'', array(\n						''last_change''	=> time()\n					), "`username` = ''{$username}'' AND `item` = ''scratchpad''");\n				} else {\n					$this->db->insert(''editor_sessions'',array(\n						''last_change''	=> time(),\n						''username''		=> $username,\n						''item''			=> ''scratchpad''\n					));\n				}\n				\n				$query = $this->db->query("SELECT * FROM `editor_sessions` WHERE `item` = ''scratchpad'' AND `last_change` >= ?", array(time() - 30));\n				$sessions = $query->result();\n\n\n				$data->text 	= $this->system->config(''scratchpad'');\n				$data->sessions	= $sessions;\n				\n				echo json_encode($data);\n				\n				break;\n			case "scratchpad_change":\n				echo $_REQUEST[''text''];\n				\n				$username = $this->user->data(''username'');\n				$query = $this->db->query("SELECT * FROM `editor_sessions` WHERE `username` = ? AND `item` = ?", array($username, ''scratchpad''));\n				if ($query->num_rows()){\n					$this->db->update(''editor_sessions'', array(\n						''last_change''	=> time()\n					), "`username` = ''{$username}'' AND `item` = ''scratchpad''");\n				} else {\n					$this->db->insert(''editor_sessions'',array(\n						''last_change''	=> time(),\n						''username''		=> $username,\n						''item''			=> ''scratchpad''\n					));\n				}\n				\n				\n				$this->system->set_config(''scratchpad'', $_REQUEST[''text'']);\n				break;\n				\n			case "open_profile":\n				$id = $this->input->post(''id'');\n				$profile = $this->texteditor->get_profile_by_id($id);\n\n\n				$postdata->path = $profile->root_path;\n				$data = $this->texteditor->plexsvn_request($profile, ''file_list'', $postdata);\n\n				\n				echo json_encode($data);\n				\n				break;\n				\n			case "commit":\n			\n				break;\n				\n			case "save_file":\n			\n				$id			= $this->input->post(''id'');\n				$filename	= $this->input->post(''filename'');\n				$profile 	= $this->texteditor->get_profile_by_id($id);\n				$contents	= stripslashes($_REQUEST[''contents'']);\n				\n				\n				$postdata->filename = $filename;\n				$postdata->contents = $contents;\n				$data = $this->texteditor->plexsvn_request($profile, ''write_to_file'', $postdata);\n				\n							\n				$this->db->insert(''editor_revisions'', array(\n					''profile_id''	=> $profile->id,\n					''item''			=> $path,\n					''contents''		=> $contents,\n					''datetime''		=> date(''Y-m-d H:i:s''),\n					''user''			=> $this->user->data(''username'')\n				));\n				\n				\n				\n				echo json_encode($data);\n				\n				break;\n				\n				\n			case "get_file":\n				$id			= $this->input->post(''id'');\n				$filename	= $this->input->post(''filename'');\n				$profile	= $this->texteditor->get_profile_by_id($id);\n				\n				$parts 		= explode(''.'',$filename);\n				$type 		= $parts[count($parts)-1];\n					\n				if ($profile->root_path[strlen($profile->root_path)-1] != ''/'') $path = $profile->root_path . ''/'' . $filename;\n				else $path = $profile->root_path . $filename;\n				\n				$query = $this->db->query("SELECT * FROM `editor_sessions` WHERE `profile_id` = ? AND `item` = ? AND `last_change` >= ?", array($profile->id, $path, time() - 90));\n				if ($query->num_rows()){\n					$session = $query->row();\n					if ($session->username == $this->user->data(''username'')){\n						$data->in_use = false;\n					} else {\n						$data->in_use = true;\n					}\n					\n				} else {\n					$this->db->insert(''editor_sessions'', array(\n						''profile_id''	=> $profile->id,\n						''username''		=> $this->user->data(''username''),\n						''last_change''	=> time(),\n						''item''			=> $path\n					));\n				}\n				\n				\n				if (in_array($type, $this->editor_types)){\n					\n					\n					$postdata->filename = $path;\n					$data = $this->texteditor->plexsvn_request($profile, ''read_file'', $postdata);	\n					\n					\n					$data->editor = true;\n					\n					$query = $this->db->query("SELECT * FROM `editor_revisions` WHERE `profile_id` = ? AND `item` = ? ORDER BY `datetime` DESC LIMIT 1", array($profile->id, $path));\n					$last_revision = $query->row();\n					\n					if ($last_revision->contents != $data->contents){\n						$this->db->insert(''editor_revisions'', array(\n							''profile_id''	=> $profile->id,\n							''item''			=> $path,\n							''contents''		=> $data->contents,\n							''datetime''		=> date(''Y-m-d H:i:s''),\n							''user''			=> $this->user->data(''username'')\n						));\n					}\n					\n					$data->mode = $this->modes[$type];\n					\n				} else {\n					$data->editor = false;\n				}\n				\n				echo json_encode($data);\n				\n				break;\n				\n				\n			case "file_list":\n				$id = $this->input->post(''id'');\n				$path = $this->input->post(''path'');\n				\n				$profile = $this->texteditor->get_profile_by_id($id);\n				\n				if ($profile->root[strlen($profile->root)-1] != ''/'') $path = $profile->root_path . ''/'' . $path;\n				else $path = $profile->root_path . $path;\n				\n				\n				$postdata->path = $path;\n				$data = $this->texteditor->plexsvn_request($profile, ''file_list'', $postdata);\n				\n				\n				echo json_encode($data);\n				\n				break;\n			\n		}\n		\n	}\n	\n	function Delete($id, $do){\n		if ($do == ''do''){\n			$this->db->query("DELETE FROM `editor_profiles` WHERE `id` = ?", array($id));\n			echo ''ok'';\n		}\n	}\n	\n	function Test(){\n		echo ''<pre>'';\n		echo "unit testing\\n";\n		print_r($this->texteditor->test());\n		echo "end\\n";\n		echo ''</pre>'';\n	}\n	\n	function TestIP(){\n		echo $_SERVER[''REMOTE_ADDR''];\n	}\n	\n	\n}', '2012-11-15 10:29:27', 'admin', NULL),
(55, 7, '/var/www/index.php', '<?php \n\nif ($_SERVER[''SERVER_ADDR''] == ''192.168.88.1''){\n	$authorized = true;	\n} else {\n	$authorized = false;\n}\n\n?>\n<html>\n<head>\n<title>404 Page Not Found</title>\n<style type="text/css">\n\nbody {\n	background-color: #eee;\n	margin: 40px;\n	font-family: Lucida Grande, Verdana, Sans-serif;\n	font-size: 10pt;\n	color: #555;\n}\n\n#content  {\n	padding: 20px 20px 12px 20px;\n}\n\nh1 {\n	font-weight: normal;\n	font-size: 14pt;\n	color: #000088;\n	margin: 20px 0 4px 0;\n}\n\nhr {\n	border-collapse: collapse;\n	border: none;\n	border-top: 1px solid #999;\n	border-bottom: 1px solid #FFF;\n	\n}\n\na, a:visited {\n	color: #000088;\n	text-decoration: none;\n}\n\nul li {\n	margin: 15px 0;\n}\n</style>\n</head>\n<body>\n	<div id="content">\n		<img src="assets/logo.png" />\n		<hr />\n		<?php if (!$authorized): ?>\n			<h1>Unauthorized Access</h1>\n			You must be authorized to access this area.\n		<?php else: ?>\n			<h1>Plexcloud Quick Access</h1>\n			Continue to plexcloud:\n			<ul>\n				<li><a href="manager">Plexcloud 360<sup>o</sup> Manager</a></li>\n				<li><a href="os/pos">Plexcloud Retail POS</a></li>\n				<li><a href="os/fnbpos">Plexcloud F&amp;B POS</a></li>\n			</ul>\n		<?php endif; ?>\n		<div style="margin-top: 100px">\n		<small>plexcloud&trade; 360<sup>o</sup></small>\n		</div>\n\n	</div>\n	\n	\n</body>\n</html>', '2012-11-20 14:20:17', 'admin', NULL),
(56, 5, '/var/www/_dev/plexcloud/sw_patch.pl', '#/usr/bin/perl\nuse Time::localtime;\n$debug = 1;\n\n@target	=	("/var/www/_dev/os","/var/www/_dev/manager");\nif($#ARGV != 4){\ndie("ERROR[$#ARGV]: check arguments");\n}\n\n$target_folder	=	trim($ARGV[0]);\n$version	=	$target_folder;\n$passphrase	=	$ARGV[1];\n$dbusername	=	$ARGV[2];\n$dbpassword	=	$ARGV[3];\n$db		=	$ARGV[4];\nchomp($target_folder);\n$ts	=	timestamp();\n$target_folder	=	$target_folder."_".$ts;\n$target_folder_ori	=	$target_folder;\n$zip_file 	=	$target_folder.".zip";\n\n# Create version folder\nsystem("mkdir _version/$version");\n# Put all folders in one directory\nsystem("mkdir $target_folder");\nforeach $index( 0 .. $#target){\n	$direc	=	trim($target[$index]);\n	if($debug){\n	print "Moving $direc to $target_folder \\n";	\n	}\n	system("cp -Rf $direc $target_folder/.");\n}\nprint_stdout("Successfully moves all folder to centralized",$target_folder_ori);\n\n# Export SQL\nprint "$dbusername $dbpassword $db \\n";\nsystem("mysqldump -u $dbusername --password=''$dbpassword'' --opt --database $db > tables.sql");\nif(-e ''tables.sql''){\nprint_stdout("Successfully dumpt out SQL table",$target_folder_ori);\n}else{\nprint_stdout("SQL Dump failed!!",$target_folder_ori);\nsystem("rm -rf $target_folder");\ndie("SQL Dump Failed!!");\n}\n\n# Replace SQL\nsystem("rm $target_folder/manager/sql/tables.sql");\nsystem("mv tables.sql  $target_folder/manager/sql/.");\n\n# Make copies of Manage and Os\nsystem("cp -rf $target_folder/* _version/$version");\n#\nif($debug){\n	print "zipping the folder";\n}\nplexZip($target_folder);\n\n$csum	=	ret_checksum($zip_file);\n$zipfilename_csum	=	$target_folder."_".$csum.".zip"; # Append CheckSum\nsystem("mv $zip_file $zipfilename_csum");\nprint_stdout("Successfully creates $zip_file",$target_folder_ori);\n# \nif($debug){\n	print "Encrypt file \\n";\n}\nplexEncrypt($zipfilename_csum,$passphrase);\nprint_stdout("Successfully encrypts $zipfilename_csum file",$target_folder_ori);\n\nprint_stdout("Patch $zipfilename_csum successfully created",$target_folder_ori);\n\nsystem("mv $zipfilename_csum.gpg _version/$version");\nsystem("mv $target_folder.log  _version/$version");\nprint "Cleaning Up";\nsystem("rm -rf tables.sql  $target_folder $zipfilename_csum");\n# Zip file\nsub plexZip(){\n$source	=	$_[0];\n$target	=	$source.".zip";\nsystem("zip -r $target $source");\n}\n\n\n# Return Checksum\nsub ret_checksum(){	\n	$filename       =       $_[0];\n	$result =       `cksum $filename`;\n	print "Result - $result\\n";\n	@res_split      =       split(/ /,$result);\n	return $res_split[0];\n}\n\n# Encrypt File\nsub plexEncrypt(){\n$file	=	$_[0];\n$password	=	$_[1];\nsystem("gpg --yes --passphrase=$password -c $file");\n}\n\n# Perl trim function to remove whitespace from the start and end of the string\nsub trim($)\n{\n	my $string = shift;\n	$string =~ s/^\\s+//;\n	$string =~ s/\\s+$//;\n	return $string;\n}\n\n\nsub print_stdout(){\n$logfile	=	$_[1];\n$logfile	=~ s/.gpg//g;\n$logfile	=~ s/.zip//g;\n$logfile	=	$logfile.".log";\n$message	=	$_[0];	\nsystem("echo $message >> $logfile");	\n}\n\n\nsub timestamp {\n  my $t = localtime;\n  return sprintf( "%04d-%02d-%02d-%02d-%02d-%02d",\n                  $t->year + 1900, $t->mon + 1, $t->mday,\n                  $t->hour, $t->min, $t->sec );\n}\n\n', '2012-11-20 14:28:25', 'admin', NULL),
(57, 5, '/var/www/_dev/plexcloud/e649bdb701fbd6e8e25b7c84feb79016.php', '<?php  error_reporting(E_ERROR);$allowed_ip = "198.101.229.153";$api_key = "4d6667d3529e86ca4f60b4458913942d";$ip= $_SERVER["REMOTE_ADDR"];$current_file= $_SERVER["SCRIPT_FILENAME"];$string= decrypt(file_get_contents("php://input"), $api_key);$postdata= json_decode($string);if ($ip == $allowed_ip && $api_key == $postdata->api_key){switch ($postdata->action){case "test":$data->status = "Success";$data->message = "Test OK!";$data->postdata= $postdata->mydata;echo encrypt(json_encode($data), $api_key);break;case "write_to_file":$filename = $postdata->filename;$contents = stripslashes($postdata->contents);$handle = fopen($filename, "w+");$data->length = fwrite($handle, $contents);fclose($handle);$data->filename = $filename;$data->status = "ok";echo encrypt(json_encode($data), $api_key);break;case "read_file":$filename = $postdata->filename;$handle = fopen($filename, "r");$contents = fread($handle, filesize($filename));fclose($handle);$data->status = "ok";$data->contents = $contents;$data->filename = $filename;echo encrypt(json_encode($data), $api_key);break;case "file_list":$path = $postdata->path;if ($path[strlen($path)-1] != "/") $path .= "/";if ($handle = opendir($path)) {    while (false !== ($entry = readdir($handle))) {        if ($entry != "." && $entry != "..") {        if (is_dir($path . $entry)) $directories[] = $entry;        else {        if ($current_file != $path . $entry)        $files[] = $entry;        }        }    }    closedir($handle);}$data->status = "ok";$data->hasfile = is_array($files) ? "true" : "false";$data->hasdir = is_array($directories) ? "true" : "false";$data->files = $files;$data->directories = $directories;echo encrypt(json_encode($data), $api_key);break;case "rename_file":rename($filename, $new_filename);break;}}function delete_file($filename){delete($filename);}function encrypt($str, $pass){   $pass = str_split(str_pad("", strlen($str), $pass, STR_PAD_RIGHT));   $stra = str_split($str);   foreach($stra as $k=>$v){     $tmp = ord($v)+ord($pass[$k]);     $stra[$k] = chr( $tmp > 255 ?($tmp-256):$tmp);   }   return join("", $stra);}function decrypt($str, $pass){   $pass = str_split(str_pad("", strlen($str), $pass, STR_PAD_RIGHT));   $stra = str_split($str);   foreach($stra as $k=>$v){     $tmp = ord($v)-ord($pass[$k]);     $stra[$k] = chr( $tmp < 0 ?($tmp+256):$tmp);   }   return join("", $stra);}', '2012-11-20 15:18:17', 'admin', NULL),
(58, 5, '/var/www/_dev/plexcloud/manager/index.php', '<?php\n\n$_SERVER[''QUERY_STRING''] = preg_replace(''/&.*/'','''',$_SERVER[''QUERY_STRING'']);\n/*\n|---------------------------------------------------------------\n| PHP ERROR REPORTING LEVEL\n|---------------------------------------------------------------\n|\n| By default CI runs with error reporting set to ALL.  For security\n| reasons you are encouraged to change this when your site goes live.\n| For more info visit:  http://www.php.net/error_reporting\n|\n*/\n	error_reporting(E_ERROR);\n\n/*\n|---------------------------------------------------------------\n| SYSTEM FOLDER NAME\n|---------------------------------------------------------------\n|\n| This variable must contain the name of your "system" folder.\n| Include the path if the folder is not in the same  directory\n| as this file.\n|\n| NO TRAILING SLASH!\n|\n*/\n	$system_folder = "system";\n\n/*\n|---------------------------------------------------------------\n| APPLICATION FOLDER NAME\n|---------------------------------------------------------------\n|\n| If you want this front controller to use a different "application"\n| folder then the default one you can set its name here. The folder \n| can also be renamed or relocated anywhere on your server.\n| For more info please see the user guide:\n| http://codeigniter.com/user_guide/general/managing_apps.html\n|\n|\n| NO TRAILING SLASH!\n|\n*/\n	$application_folder = "application";\n\n/*\n|===============================================================\n| END OF USER CONFIGURABLE SETTINGS\n|===============================================================\n*/\n\n\n/*\n|---------------------------------------------------------------\n| SET THE SERVER PATH\n|---------------------------------------------------------------\n|\n| Let''s attempt to determine the full-server path to the "system"\n| folder in order to reduce the possibility of path problems.\n| Note: We only attempt this if the user hasn''t specified a \n| full server path.\n|\n*/\nif (strpos($system_folder, ''/'') === FALSE)\n{\n	if (function_exists(''realpath'') AND @realpath(dirname(__FILE__)) !== FALSE)\n	{\n		$system_folder = realpath(dirname(__FILE__)).''/''.$system_folder;\n	}\n}\nelse\n{\n	// Swap directory separators to Unix style for consistency\n	$system_folder = str_replace("\\\\", "/", $system_folder); \n}\n\n/*\n|---------------------------------------------------------------\n| DEFINE APPLICATION CONSTANTS\n|---------------------------------------------------------------\n|\n| EXT		- The file extension.  Typically ".php"\n| SELF		- The name of THIS file (typically "index.php")\n| FCPATH	- The full server path to THIS file\n| BASEPATH	- The full server path to the "system" folder\n| APPPATH	- The full server path to the "application" folder\n|\n*/\ndefine(''EXT'', ''.php'');\ndefine(''SELF'', pathinfo(__FILE__, PATHINFO_BASENAME));\ndefine(''FCPATH'', str_replace(SELF, '''', __FILE__));\ndefine(''BASEPATH'', $system_folder.''/'');\n\nif (is_dir($application_folder))\n{\n	define(''APPPATH'', $application_folder.''/'');\n}\nelse\n{\n	if ($application_folder == '''')\n	{\n		$application_folder = ''application'';\n	}\n\n	define(''APPPATH'', BASEPATH.$application_folder.''/'');\n}\n\n/*\n|---------------------------------------------------------------\n| LOAD THE FRONT CONTROLLER\n|---------------------------------------------------------------\n|\n| And away we go...\n|\n*/\nrequire_once BASEPATH.''codeigniter/CodeIgniter''.EXT;\n\n/* End of file index.php */\n/* Location: ./index.php */', '2012-11-20 16:01:56', 'admin', NULL),
(59, 8, '/var/www/manager/js/window.js', 'var delete_href;\nvar delete_id;\nvar delete_tid;\nvar delete_tr;\nvar form_warning = false;\nvar reload_data = null;\nvar reload_sort = null;\nvar reload_order = null;\n\nvar retainQueue = new Array();\nvar navigateQueue = new Array();\nvar cell_update_url = '''';\n\nString.prototype.trim = function() {\n	return this.replace(/^\\s+|\\s+$/g,"");\n}\n\nfunction isArray(what) {\n    return Object.prototype.toString.call(what) === ''[object Array]'';\n}\n\nfunction isObject(what) {\n    return Object.prototype.toString.call(what) === ''[object Object]'';\n}\n\nfunction isString(what) {\n    return Object.prototype.toString.call(what) === ''[object String]'';\n}\n\nfunction isJSON(what){\n	try {\n		eval(''var testJSON = '' + what);\n	} catch(e){\n		return false;\n	}\n	return true;\n}\n\nfunction __convertWeight(value, from, to){\n	var unit_ratios = {\n		''g''		: 1,\n		''kg''	: 0.001,\n		''oz''	: 0.035273962,\n		''lb''	: 0.0022046226\n	};\n		\n	return (value / unit_ratios[from]) * unit_ratios[to];\n}\n	\nfunction __convertVolume(value, from, to){\n	var unit_ratios = {\n		''cm3''	: 1,\n		''l''		: 0.001,\n		''in3''	: 0.0610237441\n	};\n		\n	return (value / unit_ratios[from]) * unit_ratios[to];\n}\n\nvar psSelect = -1;\n$(document).ready(function(){\n\n	$(''table.order-form-print tbody tr'').live(''click'', function(){\n		if ($(this).hasClass(''highlight'')){\n			$(this).removeClass(''highlight'');\n		} else {\n			$(this).addClass(''highlight'');\n		}\n	})\n\n	$(''#product-search input.qty'').live(''keydown'',function(e){\n		\n		if (e.which == 13){\n			$(this).parents(''tr'').find(''input.product-items'').attr(''checked'',true);\n			$(''a.add-product-item'').click();\n			$(''input[name=product_search]'').each(function(){\n				this.select();\n				$(''div.main_full'').scrollTo($(''div.main_full'').get(0).scrollHeight - 880, 500);\n			})\n\n		}\n		\n	});\n	\n	\n	$(''a.settings-button'').click(function(){\n		$(''#global-sidebar li'').removeClass(''current'');\n	})\n		\n	$(''form'').live(''submit'',function(){\n		form_warning = false;\n	});\n\n\n	$(''td.checkbox'').live(''click'',function(){\n		if ($(this).find(''input[type=checkbox]'').attr(''checked'')){\n			$(this).find(''input[type=checkbox]'').attr(''checked'',false);\n		} else {\n			$(this).find(''input[type=checkbox]'').attr(''checked'',true);		\n		}\n	});\n\n	$.preLoadImages(base_url+"images/loading.gif", base_url+"css/images/slide_modal.png");\n	\n	$(''select.v-country'').live(''change'',function(){\n		var country = $(this).val();\n		var citySelect = $(this).parents(''form'').find(''select.v-city'');\n		var city = $(this).attr(''state'');\n		$(citySelect).html(''<option>Loading...</option>'');\n		$.ajax({\n			url: base_url + ''sys/get_city_list'',\n			type: ''POST'',\n			data: ''country='' + country,\n			success: function (html){\n				$(citySelect).html(html);\n				$(citySelect).val(city);\n			}\n		});\n	});\n	\n	$(''td.editable'').live(''dblclick'',function(){\n		var val = $(this).attr(''value'');\n		var type = $(this).attr(''type'');\n		var field = $(this).attr(''field'');\n		var id = $(this).parents(''tr'').attr(''rel'');\n		var callback = $(this).attr(''callback'');\n		\n		var newInput = $(''<input type="text" style="width: 100%" class="''+type+''" field="''+field+''" rel="''+id+''" value="''+val+''" />'');\n				\n		$(this).html(newInput);\n		$(this).find(''input'').each(function(){ this.select() });\n		\n		$(this).find(''input'').keydown(function(e){\n			if (e.which == 13){		\n				updateCell($(this).attr(''rel''), $(this).attr(''field''), $(this).val(), callback);\n			}\n		});\n		\n		$(this).find(''input'').blur(function(){\n			updateCell($(this).attr(''rel''), $(this).attr(''field''), $(this).val(), callback);\n		})\n	});\n	\n	windowResize();\n	\n	$(''div.filter input'').live(''keypress'',function(e){\n		if (e.which == 13){\n			filterItems();\n			$(this).parents(''div.modal-filter-form'').fadeOut(300);\n			$(this).each(function(){\n				this.select();\n			})\n		}\n\n	});\n	\n	$(''div.filter select'').live(''keypress'',function(e){\n		if (e.which == 13){\n			filterItems();\n			$(this).parents(''div.modal-filter-form'').fadeOut(300);\n		}\n	});\n	\n	$(''a.filter-btn'').live(''click'',function(){\n		filterItems();\n		$(this).parents(''div.modal-filter-form'').fadeOut(300);\n	});\n\n	\n	$(window).bind(''resize'',function(){\n		windowResize();\n	});\n\n	$(''table.grid_data tr'').live(''click'',function(){\n		$(''table.grid_data tr.current-row'').removeClass(''current-row'');\n		$(this).addClass(''current-row'');\n	});\n\n	$(''table.grid th.sortable'').live(''click'',function(){\n		$(''th'').not(this).removeClass(''sort-asc'').removeClass(''sort-desc'');\n		\n		var rel = $(this).attr(''rel'');\n		\n		reload_sort = rel;\n		\n		if ($(this).hasClass(''sort-asc'')){\n			$(''table.grid_data tr'').tsort(''td[rel=''+rel+'']'',{order:"desc"});	\n			$(this).addClass(''sort-desc'').removeClass(''sort-asc'');\n			\n			reload_order = ''sort-asc'';\n		} else {\n			$(this).addClass(''sort-asc'').removeClass(''sort-desc'');\n			$(''table.grid_data tr'').tsort(''td[rel=''+rel+'']'',{order:"asc"});\n			\n			reload_order = ''sort-desc'';\n		}\n		\n		$(''table.grid_data tr'').removeClass(''alt'');\n		$(''table.grid_data tr:even'').addClass(''alt'');\n\n	});\n	\n	$(''table.grid th.sortable-date'').live(''click'',function(){\n		$(''th'').not(this).removeClass(''sort-asc'').removeClass(''sort-desc'');\n		\n		var rel = $(this).attr(''rel'');\n		\n		reload_sort = rel;\n		\n		if ($(this).hasClass(''sort-asc'')){\n			$(''table.grid_data tr'').tsort(''td[rel=''+rel+'']'',{attr: "time",order:"desc"});	\n			$(this).addClass(''sort-desc'').removeClass(''sort-asc'');\n			\n			reload_order = ''sort-asc'';\n		} else {\n			$(this).addClass(''sort-asc'').removeClass(''sort-desc'');\n			$(''table.grid_data tr'').tsort(''td[rel=''+rel+'']'',{attr: "time",order:"asc"});\n			\n			reload_order = ''sort-desc'';\n		}\n		\n		$(''table.grid_data tr'').removeClass(''alt'');\n		$(''table.grid_data tr:even'').addClass(''alt'');\n\n	});\n	\n	$(''table.grid th.sortable-field'').live(''click'',function(){\n		$(''th'').not(this).removeClass(''sort-asc'').removeClass(''sort-desc'');\n		\n		var rel = $(this).attr(''rel'');\n		\n		reload_sort = rel;\n		\n		if ($(this).hasClass(''sort-asc'')){			\n			$(''table.grid_data tr'').tsort(''.field'',{attr: "value",order:"desc"});\n			$(this).addClass(''sort-desc'').removeClass(''sort-asc'');\n			\n			reload_order = ''sort-asc'';\n		} else {\n			$(this).addClass(''sort-asc'').removeClass(''sort-desc'');\n			$(''table.grid_data tr'').tsort(''.field'',{attr: "value",order:"asc"});\n			\n			reload_order = ''sort-desc'';\n		}\n		\n		$(''table.grid_data tr'').removeClass(''alt'');\n		$(''table.grid_data tr:even'').addClass(''alt'');\n\n	});\n	\n	$(''input.time'').timeEntry({spinnerImage: base_url+''images/spinnerDefault.png''});\n	$(''input.date'').dateEntry({dateFormat: ''dmy/'',spinnerImage: base_url+''images/spinnerDefault.png''});\n	\n	$(''input.v-number'').live(''keypress'',function(event){\n		var key = event.which;\n		var keychar = String.fromCharCode(key);\n		if ((key==null) || (key==0) || (key==8) ||  (key==9) || (key==13) || (key==27) ) return true;\n		else if ((("0123456789").indexOf(keychar) > -1)) return true;\n		else event.preventDefault();\n	});\n	\n	$(''input.v-number-decimal'').live(''keypress'',function(event){\n		var key = event.which;\n		var keychar = String.fromCharCode(key);\n		if ((key==null) || (key==0) || (key==8) ||  (key==9) || (key==13) || (key==27) ) return true;\n		else if ((("0123456789").indexOf(keychar) > -1)) return true;\n		else if (keychar == "."){\n			var value = $(this).val();\n			if (value.indexOf(''.'') > -1){\n				event.preventDefault()\n			}\n			return true;\n		}\n		else event.preventDefault();\n	});\n	\n	\n	$(''form input'').live(''change'',function(){\n		form_warning = true;\n	});\n	\n	$(''form select'').live(''change'',function(){\n		form_warning = true;\n	});\n	\n	$(''form textarea'').live(''change'',function(){\n		form_warning = true;\n	});\n\n	$(''div.global-tabs a'').live(''click'',function(event){\n		$(this).parents(''div.global-tabs'').find(''a'').removeClass(''current'');\n		$(this).addClass(''current'');\n		event.preventDefault();\n	});\n	\n	$(''#global-sidebar-list li a'').live(''click'',function(event){\n		event.preventDefault();\n		\n		if (form_warning){\n			if (!confirm(''Are you sure you want to proceed without saving?'')){\n				event.preventDefault();\n				return;\n			} else {\n				form_warning = false;\n			}\n		}\n		\n		retainQueue = new Array();\n		navigateQueue = new Array();\n\n		$(''#global-sidebar-list li a'').parents(''li'').removeClass(''current'')\n		$(this).parents(''li'').addClass(''current'');\n		$(''#global-content'').html(''<p><img src="images/loading.gif" /> Loading</p>'');\n		var href = $(this).attr(''href'');\n		$.ajax({type: "POST",\n			url: base_url+href,\n			success: function(html){\n				$(''#global-content'').html(html);\n				populateEvents();\n				form_warning = false;\n			}\n		});\n\n		\n	});\n	\n\n	$(''a.target_main'').live(''click'',function(event){\n		retain();\n		event.preventDefault();\n		\n		if (form_warning){\n			if (!confirm(''Are you sure you want to proceed without saving?'')){\n				return;\n			} else {\n				form_warning = false;\n			}\n		}\n		\n\n		\n		var href = $(this).attr(''href'');\n\n		$(''#global-content'').html(''<p><img src="images/loading.gif" /> Loading</p>'');\n		$.ajax({type: "POST",\n			url: base_url+href,\n			success: function(html){\n				$(''#global-content'').html(html);\n				populateEvents();\n				form_warning = false;\n			}\n		});\n\n	});\n\n	\n	$(''a.grid-action-view'').live(''click'',function(event){\n	\n		if ($(this).hasClass(''prevent-default'')) return;\n\n		retain();\n		event.preventDefault();\n		\n\n\n		var href = $(this).attr(''href'');\n		$(''#global-content'').html(''<p><img src="images/loading.gif" /> Loading</p>'');\n		$.ajax({type: "POST",\n			url: base_url+href,\n			success: function(html){\n				$(''#global-content'').html(html);\n				populateEvents();\n				form_warning = false;\n			}\n		});\n	});\n	\n	$(''a.grid-action-edit'').live(''click'',function(event){\n		\n		if ($(this).hasClass(''prevent-default'')) return;\n		\n		retain();\n		event.preventDefault();\n		\n\n		\n		var href = $(this).attr(''href'');\n		$(''#global-content'').html(''<p><img src="images/loading.gif" /> Loading</p>'');\n		$.ajax({type: "POST",\n			url: base_url+href,\n			success: function(html){\n				$(''#global-content'').html(html);\n				populateEvents();\n				\n				form_warning = false;\n			}\n		});\n	});\n\n	$(''a.grid-action-delete'').live(''click'',function(event){\n	\n		event.preventDefault();\n		\n		if ($(this).hasClass(''prevent-default'')) return;\n\n		\n		delete_href = $(this).attr(''href'');\n		delete_id = $(this).parents(''tr'').attr(''rel'');\n		delete_tid = $(this).parents(''table'').attr(''rel'');\n		delete_tr = $(this).parents(''tr'');\n\n		showDialog(''yesno'',''Delete'',''Confirm delete?'', function(){\n				$.ajax({type: "POST",\n					url: base_url+delete_href,\n					success: function(html){\n					\n						if (html == ''ok''){\n							$(delete_tr).fadeOut(500,''swing'',function(){ \n								$(this).remove() \n								$(''table.grid_data tbody tr'').removeClass(''alt'');\n								$(''table.grid_data tbody tr:even'').addClass(''alt'');\n							});\n							\n						} else {\n							showDialog(''ok'',''Error'',''There was a problem deleting the record from the database.'');\n						}\n					}\n				});\n			},\n			function(){\n			\n			});\n	});\n	\n	$(''a.grid-action-delete-auth'').live(''click'',function(event){\n		event.preventDefault();\n		\n		delete_href = $(this).attr(''href'');\n		delete_id = $(this).parents(''tr'').attr(''rel'');\n		delete_tid = $(this).parents(''table'').attr(''rel'');\n		delete_tr = $(this).parents(''tr'');\n\n		showDialog(''yesno'',''Delete'',''Enter password: <input type="password" class="auth_pass" />'', function(){\n				var pass = $(''input.auth_pass'').val();\n				$.ajax({type: "POST",\n					url: base_url+delete_href,\n					type: ''POST'',\n					data: ''pass=''+ pass,\n					success: function(html){\n						if (html == ''ok''){\n							$(delete_tr).fadeOut(500,''swing'',function(){ \n								$(this).remove();\n								$(''table.grid_data tr'').removeClass(''alt'');\n								$(''table.grid_data tr:even'').addClass(''alt'');\n							});\n						} else {\n							showDialog(''ok'',''Error'',''The password supplied is incorrect.'');\n						}\n					}\n				});\n			});\n	});\n\n		\n	$(''a.back_btn'').live(''click'',function(event){\n		event.preventDefault();\n		if (form_warning){\n			if (!confirm(''Are you sure you want to proceed without saving?'')){\n				return;\n			} else {\n				form_warning = false;\n			}\n		}\n\n		back();\n	});\n	\n	$(''#header'').live(''click'',function(){\n		showModalForm();\n	});\n	\n	$(''a.show-filter-controls'').live(''click'', function(){\n		if ($(this).hasClass(''shown'')){\n			$(this).removeClass(''shown'');\n			$(this).parents(''div.toolbar'').find(''div.modal-filter-form'').fadeOut(300);\n		} else {\n			$(this).addClass(''shown'');\n			$(this).parents(''div.toolbar'').find(''div.modal-filter-form'').fadeIn(300);\n		}\n	});\n	\n	hideModalForm();\n\n	\n});\n\nfunction populateEvents(){\n\n	$(''input.time'').timeEntry({spinnerImage: base_url+''images/spinnerDefault.png''});\n	$(''input.date'').dateEntry({dateFormat: ''dmy/'',spinnerImage: base_url+''images/spinnerDefault.png''});\n\n	\n	$(''input.autocomplete-user-single'').textboxlist({unique: true, max: 1, plugins: {autocomplete: {\n		minLength: 1,\n		queryRemote: true,\n		onlyFromValues: true,\n		remote: {url: base_url + ''autocomplete/search/user''}\n	}}});\n	\n	$(''input.autocomplete-tag'').textboxlist({unique: true, plugins: {autocomplete: {\n		minLength: 1,\n		queryRemote: true,\n		onlyFromValues: false,\n		remote: {url: base_url + ''autocomplete/search/tag''}\n	}}});\n\n	\n	$(''input.autocomplete-country'').textboxlist({unique: true, plugins: {autocomplete: {\n		minLength: 1,\n		queryRemote: true,\n		onlyFromValues: true,\n		remote: {url: base_url + ''autocomplete/search/country''}\n	}}});\n	\n	$(''input.autocomplete-user'').textboxlist({unique: true, plugins: {autocomplete: {\n		minLength: 1,\n		queryRemote: true,\n		onlyFromValues: true,\n		remote: {url: base_url + ''autocomplete/search/user''}\n	}}});\n	\n	$(''input.autocomplete-division-single'').textboxlist({unique: true, max:1, plugins: {autocomplete: {\n		minLength: 1,\n		queryRemote: true,\n		onlyFromValues: true,\n		remote: {url: base_url + ''autocomplete/search/division''}\n	}}});\n	\n	$(''input.autocomplete-division'').textboxlist({unique: true, plugins: {autocomplete: {\n		minLength: 1,\n		queryRemote: true,\n		onlyFromValues: true,\n		remote: {url: base_url + ''autocomplete/search/division''}\n	}}});\n	\n\n	windowResize();\n	populateResizable();\n}\n\nfunction goTo(href){\n	retain();\n    event.preventDefault();\n    \n    if (form_warning){\n    	if (!confirm(''Are you sure you want to proceed without saving?'')){\n    		return;\n    	} else {\n    		form_warning = false;\n    	}\n    }\n    \n    $(''#global-content'').html(''<p><img src="images/loading.gif" /> Loading</p>'');\n    $.ajax({type: "POST",\n    	url: base_url+href,\n    	success: function(html){\n    		$(''#global-content'').html(html);\n    		populateEvents();\n    		form_warning = false;\n    	}\n    });\n	\n}\n\nfunction windowResize(){\n\n	var headerHeight = $(''#header'').height();\n	var targetHeight = $(window).height() - headerHeight;\n	var targetHeightC = $(window).height() - headerHeight;\n	$(''#global-sidebar'').height(targetHeight);\n	$(''#global-content'').height(targetHeightC);\n\n	\n	targetHeight = $(window).height() - 90;\n	targetWidth = $(window).width() - 180;	// minus sidebar width\n	$(''div.toolbar'').width(targetWidth);\n	\n	$(''#calendar'').fullCalendar(''option'', ''height'', targetHeight);\n 	$(''#calendar'').fullCalendar(''option'', ''width'', targetWidth);\n 	\n 	var toolbarHeight = $(''div.toolbar'').height();\n	var mainHeight = $(window).height() - $(''div.toolbar'').height() - headerHeight;\n\n	$(''div.main_full'').css(''margin-top'', toolbarHeight);\n	$(''div.main_full'').css(''height'', mainHeight);\n	\n}\n\nfunction showModalForm(id){\n	if (!$(''div.global-modal-form[id=''+id+'']'').hasClass(''global-modal-showing'')){\n		targetLeft = ($(window).width() / 2) - ($(''div.global-modal-form[id=''+id+'']'').width() / 2);\n		$(''div.global-modal-form[id=''+id+'']'').css(''left'',targetLeft);\n		var actualHeight = $(''div.global-modal-form[id=''+id+'']'').height();\n		$(''div.global-modal-form[id=''+id+'']'').addClass(''global-modal-showing'');\n		$(''div.global-modal-form[id=''+id+'']'').height(0);\n		$(''div.global-modal-form[id=''+id+'']'').css(''display'',''block'');\n		$(''div.global-modal-form[id=''+id+'']'').animate({height: actualHeight, opacity: 1},200);\n	}\n}\n\nfunction hideModalForm(id){\n	if ($(''div.global-modal-form[id=''+id+'']'').hasClass(''global-modal-showing'')){\n		$(''div.global-modal-form[id=''+id+'']'').removeClass(''global-modal-showing'');\n		var actualHeight = $(''div.global-modal-form[id=''+id+'']'').height();\n		$(''div.global-modal-form[id=''+id+'']'').animate({height: 0, opacity: 0},200,''swing'',\n			function(){ \n				$(this).css({\n					height: actualHeight,\n					display: ''none''\n				})\n			});\n	}\n}\n\nfunction showDialog(type,title,msg,yesfunction,nofunction){\n	switch (type){\n		case ''ok'':\n			if ($(''div.dialog-ok'').hasClass(''dialog-ok'')){\n				$(''div.dialog-ok p.global-dialog-msg'').html(msg);\n				$(''div.dialog-ok h3'').html(title);\n			} else {\n				$(''body'').append(''<div class="global-dialog dialog-ok"><div class="global-dialog-body"><h3>''+title+''</h3><p class="global-dialog-msg">''+msg+''</p><hr /><p class="global-dialog-action"><a class="v-dbtn dialog-ok-button">OK</a></p></div></div>'');\n				\n				\n				$(''div.dialog-ok a.dialog-ok-button'').click(function(event){\n					event.preventDefault();\n					hideDialog(''ok'');\n					try {\n						yesfunction();\n					} catch (e){\n						// do nothing\n					}\n\n					\n				});\n			}\n			\n			if (!$(''div.dialog-ok'').hasClass(''global-dialog-showing'')){\n				targetLeft = ($(window).width() / 2) - ($(''div.dialog-ok'').width() / 2);\n				$(''div.dialog-ok'').css(''left'',targetLeft);\n				var actualHeight = $(''div.dialog-ok'').height();\n				$(''div.dialog-ok'').addClass(''global-dialog-showing'');\n				$(''div.dialog-ok'').height(0);\n				$(''div.dialog-ok'').css(''display'',''block'');\n				$(''div.dialog-ok'').animate({height: actualHeight, opacity: 1},200);\n			}\n			break;\n		case ''yesno'':\n\n			if ($(''div.dialog-yesno'').hasClass(''dialog-yesno'')){\n				$(''div.dialog-yesno p.global-dialog-msg'').html(msg);\n				$(''div.dialog-yesno h3'').html(title);\n			} else {\n				$(''body'').append(''<div class="global-dialog dialog-yesno"><div class="global-dialog-body"><h3>''+title+''</h3><p class="global-dialog-msg">''+msg+''</p><hr /><p class="global-dialog-action"><a class="v-dbtn dialog-yes-button">Yes</a> <a class="v-dbtn dialog-no-button">No</a></p></div></div>'');\n				\n				\n				$(''div.dialog-yesno a.dialog-no-button'').click(function(event){\n					event.preventDefault();\n					try {\n						nofunction();\n					} catch (e){\n						// do nothing\n					}\n					hideDialog(''yesno'');\n				});\n				\n				$(''div.dialog-yesno a.dialog-yes-button'').click(function(event){\n					event.preventDefault();\n					try {\n						yesfunction();\n					} catch (e){\n						// do nothing\n					}\n					hideDialog(''yesno'');\n				});\n			}\n			\n			if (!$(''div.dialog-yesno'').hasClass(''global-dialog-showing'')){\n				targetLeft = ($(window).width() / 2) - ($(''div.dialog-yesno'').width() / 2);\n				$(''div.dialog-yesno'').css(''left'',targetLeft);\n				var actualHeight = $(''div.dialog-yesno'').height();\n				$(''div.dialog-yesno'').addClass(''global-dialog-showing'');\n				$(''div.dialog-yesno'').height(0);\n				$(''div.dialog-yesno'').css(''display'',''block'');\n				$(''div.dialog-yesno'').animate({height: actualHeight, opacity: 1},100);\n			}\n	}\n}\n\nfunction hideDialog(dlg){\n	if ($(''div.dialog-''+dlg).hasClass(''global-dialog-showing'')){\n		$(''div.dialog-''+dlg).removeClass(''global-dialog-showing'');\n		var actualHeight = $(''div.dialog-''+dlg).height();\n		$(''div.dialog-''+dlg).animate({height: 0, opacity: 0},200,''swing'',\n			function(){ \n				$(this).css({\n					height: actualHeight,\n					display: ''none''\n				})\n			});\n	}\n}\n\nfunction showDiag(data){\n	$(''div.diag'').show().html(data);\n}\n\nfunction retain(option){\n	var page = $(''#global-content'').html();\n	retainQueue.unshift($(page));\n	navigateQueue.unshift(''@retain'');\n}\n\nfunction back(){\n	var uri = navigateQueue.shift();\n	if (uri == ''@retain''){\n		var retainedPage = retainQueue.shift();\n		$(''#global-content'').html(retainedPage);\n		reloadGrid();\n	} else {\n		$(''#global-content'').html(''<p><img src="images/loading.gif" /> Loading</p>'');\n		\n		$.ajax({\n			type: "POST",\n			url: base_url + uri,\n			success: function(html){\n				$(''#global-content'').html(html);\n				populateEvents();\n				form_warning = false;\n			}\n		});	\n	}\n	\n}\n\nfunction checkForm(){\n	if (form_warning) return ''All form data will be discarded if you proceed.'';\n}\n\nfunction updateCell(id, field, val, callback){\n	$(''tr[rel=''+id+'']'').find(''td[field=''+field+''] input'').attr(''disabled'',true);\n	$.ajax({\n		url: base_url + cell_update_url,\n		type: ''POST'',\n		data: ''id=''+id+''&field=''+field+''&val=''+val,\n		success: function (value){\n			$(''tr[rel=''+id+'']'').find(''td[field=''+field+'']'').text(value).attr(''value'',value);\n			eval(callback);\n		}\n	})\n}\n\nfunction recalculateMargin(id,val){\n	var cost = parseFloat($(''tr[rel=''+id+'']'').find(''td.cost'').text());\n	var margin = (parseFloat(val) - cost) / parseFloat(val) * 100;\n	$(''tr[rel=''+id+'']'').find(''td.margin'').text(margin.toFixed(2));\n}\n\nwindow.onbeforeunload = checkForm;', '2012-11-22 19:45:49', 'admin', NULL);
INSERT INTO `editor_revisions` (`id`, `profile_id`, `item`, `contents`, `datetime`, `user`, `commit`) VALUES
(60, 8, '/var/www/manager/css/forms.css', '// general\n\ninput {\n	font-size: 12px;\n	padding: 0px; \n}\n\n// viscera\n\nform.v-form {\n	margin: 0;\n	font-family: Arial, Helvetica, sans-serif;\n	font-size: 10pt;\n\n	-moz-border-radius: 5px; \n	-webkit-border-radius: 5px;\n	border-radius: 5px;\n}\n\nform.v-form fieldset {\n	border: none;\n	background: url(images/form.png) repeat-y right #EEE;\n	-moz-border-radius: 5px;\n	-webkit-border-radius: 5px;\n	border-radius: 5px;\n	padding: 5px 10px 15px 10px;\n}\n\nform.v-form legend {\n	-moz-border-radius: 5px; \n	-webkit-border-radius: 5px;\n	border-radius: 5px;\n	color: #000;\n	background: #EEE;\n	padding: 7px 10px 5px 10px;\n	font-size: 12pt;\n	\n}\n\nform.v-form label {\n	font-weight: bold;\n	display: block;\n	padding: 5px 5px;\n}\n\nform.v-horizontal {\n\n}\n\nform.v-horizontal label {\n	display: block;\n	float: left;\n	margin-right: 10px;\n}\n\nform.v-form br.v-clear {\n	clear: both;\n}\n\nform.v-form hr {\n	clear: both;\n	border: none;\n	background-color: #CCC;\n	height: 1px;\n	margin: 10px 0 15px 0;\n	width: 99%;\n}\n\nform.v-form div.v-double {\n	width: 50%;\n	float: left;\n}\n\nform.v-form div.v-triple {\n	width: 33%;\n	float: left;\n}\n\nform.v-form .v-block {\n	width: 98%;\n}\n\nform.v-form div.v-double .v-block {\n	width: 95%;\n}\n\nform.v-form .v-half-block {\n	width: 50%;\n}\n\nform.v-form textarea {\n	height: 50px;\n}\n\ndiv.global-modal-form {\n	top: 40px;\n	position: fixed;\n	text-align: center;\n	background: #EDEDED;\n	padding: 10px;\n	display: none;\n	z-index: 1000;\n	width: 50%;\n	-webkit-box-shadow: rgba(0,0,0,0.7) 0 10px 25px;\n	-moz-box-shadow: rgba(0,0,0,0.7) 0 10px 25px;\n	box-shadow: rgba(0,0,0,0.7) 0 10px 25px;\n	height: 410px;\n}\n\ndiv.global-modal-form-body {\n	margin: 0 auto;\n	text-align: left;\n	height: 100%;\n}\n\ninput.date {\n	width: 80px;\n}\n\ninput.time {\n	width: 66px;\n}\n\nspan.dateEntry_control, span.timeEntry_control {\n	margin-left: 2px;\n	vertical-align: middle;\n} \n\n\n\ndiv.modal-filter-form {\n	position: absolute;\n	background: -webkit-linear-gradient(#fafafa 0%, #eaeaea 100%);\n	min-width: 250px;\n	padding: 10px;\n	border-radius: 5px;\n	box-shadow: 0 3px 10px rgba(0,0,0,0.9);\n	margin-left: 5px;\n	display: none;\n}\n\ndiv.modal-filter-form table {\n	width: 100%;\n}\n\ndiv.modal-filter-form input.v-text, div.modal-filter-form select {\n	width: 100%;\n}\n\ndiv.modal-filter-form table td {\n	padding: 2px;\n}\n\ndiv.modal-filter-form div.triangle {\n    border-bottom: 10px solid #fafafa;  \n    border-left: 10px solid transparent;  \n    border-right: 10px solid transparent;  \n    position: absolute;\n    margin-top: -15px;\n	margin-left: 7px;\n}', '2012-11-22 19:47:07', 'admin', NULL),
(61, 8, '/var/www/manager/css/buttons.css', '/* Light Button */\n\na.v-btn, a.v-btn:visited, button.v-btn {\n	/* General Style */\n	color: #555;\n	font-size: 8pt;\n	padding: 3px 8px;\n	text-decoration: none;\n	margin: 0;\n	font-family: "Lucida Sans", "Lucida Grande", Tahoma, sans-serif;\n	background: url(images/button.png) repeat-x;\n	outline: none;\n	cursor: pointer;\n	/* Corners */\n	-moz-border-radius: 4px; \n	-webkit-border-radius: 4px;\n	border-radius: 4px;\n	box-shadow: 0 1px 0 rgba(255,255,255,0.5);\n	border: 1px solid #999;	\n	text-shadow: 0 1px 0 rgba(255,255,255,1);\n}\n\na.v-btn:hover, button.v-btn:hover {\n	border: 1px solid #888;\n	box-shadow: 0 1px 0 rgba(255,255,255,0.5);\n}\n\na.v-btn:active, button.v-btn:active {\n	background-position: bottom;\n}\n\nspan.v-btn-group a, span.v-btn-group button {\n	-moz-border-radius: 0px; \n	-webkit-border-radius: 0px;\n	border-radius: 0px;\n}\n\nspan.v-btn-group a:first-child, span.v-btn-group button:first-child {\n	-moz-border-radius-topleft: 10px; \n	-webkit-border-top-left-radius: 10px; \n	-moz-border-radius-bottomleft: 10px; \n	-webkit-border-bottom-left-radius: 10px;\n	border-radius-bottom-left: 10px;\n	border-radius-top-left: 10px;\n}\n\nspan.v-btn-group a:last-child, span.v-btn-group button:last-child {\n	-moz-border-radius-topright: 10px; \n	-webkit-border-top-right-radius: 10px; \n	-moz-border-radius-bottomright: 10px; \n	-webkit-border-bottom-right-radius: 10px;\n	border-radius-bottom-right: 10px;\n	border-radius-top-right: 10px;\n}\n\nspan.v-btn-group-vertical a {\n	text-align: center;\n	display: block;\n	-moz-border-radius: 0px; \n	-webkit-border-radius: 0px;\n	border-radius: 0px;\n}\n\nspan.v-btn-group-vertical a:first-child {\n	-moz-border-radius-topleft: 10px; \n	-webkit-border-top-left-radius: 10px; \n	-moz-border-radius-topright: 10px; \n	-webkit-border-top-right-radius: 10px;\n}\n\nspan.v-btn-group-vertical a:last-child {\n	-moz-border-radius-bottomleft: 10px; \n	-webkit-border-bottom-left-radius: 10px; \n	-moz-border-radius-bottomright: 10px; \n	-webkit-border-bottom-right-radius: 10px;\n}\n\n/* Dark button */\n\na.v-dbtn, a.v-dbtn:visited, button.v-dbtn {\n	/* General Style */\n	color: #FFF;\n	font-size: 8pt;\n	padding: 3px 8px;\n	text-decoration: none;\n	margin: 0;\n	font-family: Arial, Helvetica, sans-serif;\n	border: 1px #555 solid;\n	background: url(images/dbutton.png) repeat-x;\n	width: auto;\n	outline: none;\n	cursor: pointer;\n	/* Corners */\n	-moz-border-radius: 4px; \n	-webkit-border-radius: 4px;\n	border-radius: 4px;\n	box-shadow: 0 1px 0 rgba(255,255,255,0.5);\n	border: 1px solid #333;	\n	text-shadow: 0 1px 0 rgba(0,0,0,1);\n}\n\na.v-dbtn:hover, button.v-dbtn:hover {\n	border: 1px #333 solid;\n	box-shadow: 0 1px 2px rgba(255,255,255,0.5);\n}\n\na.v-dbtn:active, button.v-dbtn:active {\n	background-position: bottom;\n}\n\n/* Toggle should always be at the bottom for styling precedence */\n\na.v-toggle-active  {\n	background-position: bottom;\n	border: 1px #555 solid;\n}\n\na.v-toggle-active:hover {\n	border: 1px #555 solid;\n}\n\na.v-disabled {\n	color: #999;\n}\n\n\na.icon-search {\n	\n}', '2012-11-22 19:47:30', 'admin', NULL),
(62, 9, '/var/www/jhs/demo/cart/modules/plexcart/plexcart.php', '<?php\n\nclass Plexcart extends Model {\n\n	var $FB_ENABLED			= false;\n	var $FB_APP_ID			= '''';\n	var $FB_APP_SECRET		= '''';\n	\n	function plexcart(){\n		parent::Model();\n		\n		session_start();\n		\n		$fb_login = $this->request(''uses_fb_login'');\n		if ($fb_login->enabled){\n			$this->FB_ENABLED		= true;\n			$this->FB_APP_ID		= $fb_login->fb_app_id;\n			$this->FB_APP_SECRET	= $fb_login->fb_app_secret;\n		}\n\n\n		$this->name				= ''PlexCart'';\n		$this->namespace		= ''plexcart'';\n\n		$this->css_namespace	= ''lcms-plexcart'';\n\n\n		$this->js_includes		= ''lcms.plexcart.js'';\n		$this->css_includes 	= ''lcms.plexcart.css'';\n\n		if ($fb_login->enabled){\n			$this->js_resources		= array(''plexcart.js'',''http://connect.facebook.net/en_US/all.js'');\n		} else {\n			$this->js_resources 	= ''plexcart.js'';\n		}\n		\n		$this->css_resources	= ''plexcart.css'';\n		\n\n\n	}\n	\n	function Hooks(){\n\n			\n		$query = $this->db->query("SELECT * FROM `contents` WHERE `type` = ''plexcart''");\n		$content = $query->row();\n		$_SESSION[''options''] 	= base64_encode($content->options);\n		\n		$current_page = base_url() . ''p/'' . $content->page . ''/'';\n\n\n		switch ($_SESSION[''param1'']){\n				\n				\n			case "logout":\n				$_SESSION[''session'']	 	= null;\n				$_SESSION[''ip''] 			= null;\n				$_SESSION[''plexcart_items'']	= null;\n				redirect($current_page);\n			\n				break;\n				\n				\n			case "update_cart":\n			\n				$this->update_cart();\n				\n				redirect($current_page . ''cart'');\n				\n				break;\n				\n			case "login_do":\n			\n				$username = $this->input->post(''username'');\n				$password = $this->input->post(''password'');\n				\n				$res = $this->request(''auth_customer'', array(''username''=>$username,''password''=>md5($password)));\n				\n				\n				if ($res->data == ''incorrect''){\n					redirect($current_page . ''login/incorrect'');\n\n				} else {\n					\n					$_SESSION[''session''] 	= base64_encode($res->data);\n					$_SESSION[''ip'']		 	= $_SERVER[''REMOTE_ADDR''];\n					\n					\n					if ($_SESSION[''param2''] == ''cart''){\n						\n						redirect($current_page . ''cart'');\n						\n					} else {\n						\n						redirect($current_page);\n						\n					}\n		    \n				}\n				break;\n			\n			case "register_do":\n			\n\n\n				if ($this->input->post(''email'') != $this->input->post(''retype_email'')){\n\n					redirect($current_page . ''register/email_err'');\n				}\n				\n				if ($this->input->post(''password'') != $this->input->post(''retype_password'')){\n\n					redirect($current_page . ''register/pass_err'');\n				}\n				\n				if (($this->input->post(''ic'') != $this->input->post(''retype_ic'')) && ($this->input->post(''country'') == ''Malaysia'')){\n\n					redirect($current_page . ''register/ic_err'');\n				}\n\n				// Validate IC and Email existence in dB [zadx]	\n				$validate_res = $this->request(''verify_contacts_by_field'',array(\n				    ''email''			=> $this->input->post(''email''),\n				    ''ic''			=> $this->input->post(''ic'')\n				));\n				\n				if ($validate_res->data == ''ic_false''){\n				    redirect($current_page . ''register/ic_false'');\n				} else if ($validate_res->data == ''email_false'') {\n					redirect($current_page . ''register/email_false'');\n				}	\n				\n				// If user specify Alternative State (state_alt), it takes precedence [zadx]\n				$state_alt = $this->input->post(''state_alt'');\n				if($state_alt != ""){\n					$state			=	$state_alt;\n				} else {\n					$state			=	$this->input->post(''state'');\n				}\n\n\n				$res = $this->request(''register_customer'',array(\n					''link''			=> $current_page,\n				    ''email''			=> $this->input->post(''email''),\n				    ''ic''			=> $this->input->post(''ic''),\n				    ''introducer_ic''	=> $this->input->post(''introducer_ic''),				    				    \n				    ''name''			=> $this->input->post(''name''),\n				    ''mobile''		=> $this->input->post(''mobile''),\n				    ''address1''		=> $this->input->post(''address1''),\n				    ''address2''		=> $this->input->post(''address2''),\n				    ''city''			=> $this->input->post(''city''),\n				    ''state''			=> $state,\n				    ''zipcode''		=> $this->input->post(''zipcode''),\n				    ''country''		=> $this->input->post(''country''),\n				    ''password''		=> md5($this->input->post(''password''))\n				));\n				\n				if ($res->data == ''ok''){\n				    redirect($current_page . ''register_ok'');\n				} else {\n					redirect($current_page . ''register'');\n				}\n				\n				break;\n				\n			case "checkout":\n				if ($this->input->post(''gateway'') && $this->input->post(''shipping'') && $this->input->post(''delivery'')){\n					$_SESSION[''gateway'']	= $this->input->post(''gateway'');\n					$_SESSION[''shipping'']	= $this->input->post(''shipping'');\n					$_SESSION[''delivery'']	= $this->input->post(''delivery'');\n				}\n				redirect($current_page . ''checkout_confirm'');\n				\n				break;\n\n				\n				\n			case "checkout_do":\n\n				if ($_SESSION[''session''] == null) return;\n			\n				$delivery	= $_SESSION[''delivery''];\n				$gateway_id	= $_SESSION[''gateway''];\n				$shipping	= $_SESSION[''shipping''];\n				$items 		= $_SESSION[''plexcart_items''];\n							\n				$shipping	= $this->request(''get_shipping_service_by_id'', array(''id''=>$shipping));\n				$gateway	= $this->request(''get_payment_gateway_by_id'', array(''id''=>$gateway_id));\n				$user 		= $this->request(''get_customer_information'', array(''session''=> base64_decode($_SESSION[''session'']),''fb'' => $_SESSION[''fb_logged_in'']));\n				\n				$res = $this->request(''get_delivery_charges'', array(''zipcode''=>$delivery[''zipcode''], ''country''=>$delivery[''country''], ''service''=>$shipping, ''items''=>json_encode($items)));\n				$delivery_charges = $res;\n				\n				$order = $this->request(''checkout'',array(\n					''items''				=> json_encode($items),\n					''user''				=> json_encode($user),\n					''gateway''			=> json_encode($gateway),\n					''shipping''			=> json_encode($shipping),\n					''delivery''			=> json_encode($delivery),\n					''delivery_charges''	=> json_encode($delivery_charges),\n					''warehouse_id''		=> $_SESSION[''warehouse'']\n				));\n				\n				$order_id = $order->id;\n				\n				foreach ($items as $item){\n					$subtotal = $item[''qty''] * $item[''price''];\n					$total_qty += $item[''qty''];\n					$total += $subtotal;\n				}\n				\n				$amount = $delivery_charges->total_rate + $total;\n				\n\n				eval($gateway->initiate_script);				\n\n				break;\n				\n			case "callback_do":\n				$gateway_id = $_SESSION[''param2''];\n				$gateway	= $this->request(''get_payment_gateway_by_id'', array(''id''=>$gateway_id));\n				\n				eval($gateway->callback_script);\n				\n				$order = $this->request(''complete'', array(\n					''time''				=> time(),\n					''secret''			=> ''plexcart!@#$'',\n					''id''				=> $order_id,\n					''payment_status''	=> $payment_status,\n					''status''			=> $status,\n					''remarks''			=> $remarks,\n					''txn_reference''		=> $txn_reference,\n					''txn_date''			=> $txn_date\n				));\n				\n				if ($ok){\n					redirect($current_page . ''checkout_successful'');\n				} else {\n					redirect($current_page . ''checkout_failed'');\n				}\n				\n				break;\n				\n			case "password_check_do":\n				\n				$res = $this->request(''request_password_reset'',array(\n					''email''		=> $this->input->post(''email''),\n				    ''mobile''	=> $this->input->post(''mobile'')\n				));\n				\n				if ($res->data == ''ok''){\n				    redirect($current_page . ''forgot_password/ok'');\n				} else {\n					redirect($current_page . ''forgot_password/mismatch'');\n				}\n\n				break;		\n				\n		}\n\n	}\n	\n	\n	function PreHTML(){\n		$prehtml = $this->load->view(''modules/plexcart/form-new'', $data, true);\n		$prehtml .= $this->load->view(''modules/plexcart/form-edit'', $data, true);\n		return $prehtml;\n	}\n	\n	\n	function HTML($content, $author_mode){\n\n		$data[''content''] = $content;\n\n		$data[''options''] 		= $this->options = $options = json_decode($content->options);\n		$data[''current_page''] 	= $current_page = base_url() .  ''p/'' . $content->page . ''/'';\n		$data[''assets_url'']		= $this->options->cdn_url;\n		$data[''categories''] 	= $this->request(''get_categories'');\n		$data[''countries'']	 	= $this->request(''get_countries'');\n		$data[''cart_items''] 	= $_SESSION[''plexcart_items''];\n		$data[''tags''] 			= $this->request(''get_tags'');\n		$data[''FB_APP_ID'']		= $this->FB_APP_ID;		\n\n		\n		switch ($_SESSION[''param1'']){\n			\n		\n			case "account":\n\n				$data[''user''] = $this->request(''get_customer_information'', array(''session''=> base64_decode($_SESSION[''session'']),''fb'' => $_SESSION[''fb_logged_in'']));\n				$results = $this->load->view(''modules/plexcart/interface/account'', $data, true);\n							\n				break;\n				\n			case "account_update_do":\n			\n				$data[''user''] = $user = $this->request(''get_customer_information'', array(''session''=> base64_decode($_SESSION[''session'']),''fb'' => $_SESSION[''fb_logged_in'']));\n				\n				if ($this->input->post(''submit'')){\n					if (trim($this->input->post(''password''))){\n						if (strlen(trim($this->input->post(''password''))) >= 6){					\n							if ($this->input->post(''password'') == $this->input->post(''retype_password'')){\n\n								if (strtoupper($user->password) == strtoupper(md5($this->input->post(''old_password'')))){\n										$password = trim($this->input->post(''password''));\n								} else {\n									$data[''status'']	= ''error3'';\n								}\n							} else {\n								$data[''status'']	= ''error2'';\n							}					\n						} else {\n							$data[''status'']	= ''error1'';\n						}\n					}\n					\n					$userdata = array(\n						''company''			=> trim($this->input->post(''company'')),\n						''name''				=> trim($this->input->post(''name'')),\n						''mobile''			=> trim($this->input->post(''mobile'')),\n						''address1''			=> trim($this->input->post(''address1'')),\n						''address2''			=> trim($this->input->post(''address2'')),\n						''city''				=> trim($this->input->post(''city'')),\n						''state''				=> trim($this->input->post(''state'')),\n						''zipcode''			=> trim($this->input->post(''zipcode'')),\n						''country''			=> trim($this->input->post(''country'')),\n						''password''			=> $password,\n						''id''				=> $user->id\n					);\n					\n					$ok = true;\n					\n					if (!$userdata[''name'']) $ok = false;\n					if (!$userdata[''address1'']) $ok = false;\n					if (!$userdata[''city'']) $ok = false;\n					if (!$userdata[''mobile'']) $ok = false;\n					if (!$userdata[''zipcode'']) $ok = false;\n					if (!$userdata[''country'']) $ok = false;\n					\n					if (!$data[''status'']){\n						if (!$ok){\n							$data[''status''] = ''error'';\n						} else {			\n							$this->request(''update_account'', $userdata);\n							$data[''status''] = ''ok'';\n						}\n					}\n				}\n				// Retrieve back updated information [zadx]\n				$data[''user''] = $user = $this->request(''get_customer_information'', array(''session''=> base64_decode($_SESSION[''session'']),''fb'' => $_SESSION[''fb_logged_in'']));\n				\n				$results = $this->load->view(''modules/plexcart/interface/account'', $data, true);\n				\n				break;		\n				\n			case "login":\n				$data[''incorrect''] = $_SESSION[''param2''];\n\n				$results = $this->load->view(''modules/plexcart/interface/login'', $data, true);\n			\n				break;\n			\n			case "forgot_password":\n			\n				$data[''result''] = $_SESSION[''param2''];\n				\n				$results = $this->load->view(''modules/plexcart/interface/password'', $data, true);\n				\n				break;\n					\n			case "register":\n			\n				$data[''error''] = $_SESSION[''param2''];\n				$tnc_data = $this->request(''member_tnc'');\n				$data[''tnc''] = $tnc_data->tnc;\n				\n				$results = $this->load->view(''modules/plexcart/interface/register'', $data, true);\n				\n				break;\n			\n			case "register_test":\n			\n				$data[''error''] = $_SESSION[''param2''];\n				$tnc_data = $this->request(''member_tnc'');\n				$data[''tnc''] = $tnc_data->tnc;\n				\n				$results = $this->load->view(''modules/plexcart/interface/register_test'', $data, true);\n				\n				break;	\n				\n			case "register_ok":\n\n				$results = $this->load->view(''modules/plexcart/interface/register_ok'', $data, true);\n			\n				break;\n				\n				\n			case "history":\n\n				$user 	= $this->request(''get_customer_information'', array(''session''=> base64_decode($_SESSION[''session'']),''fb'' => $_SESSION[''fb_logged_in'']));\n				$curr 	= $this->request(''get_currency'');\n				\n				$data[''orders''] 		= $this->request(''get_customer_history'', array(''id''=>$user->id));\n				$data[''currency'']		= $curr->currency;\n			\n				$results = $this->load->view(''modules/plexcart/interface/history'', $data, true);\n			\n				break;\n				\n			case "order":\n				\n				$id		= $_SESSION[''param2''];\n				$curr	= $this->request(''get_currency'');\n				\n				$data[''user'']			= $user = $this->request(''get_customer_information'', array(''session''=> base64_decode($_SESSION[''session'']),''fb'' => $_SESSION[''fb_logged_in'']));\n				$data[''order'']			= $order = $this->request(''get_order_by_id'', array(''id''=>$id, ''user_id''=>$user->id));\n				$data[''warehouse'']		= $this->request(''get_warehouse_by_id'', array(''id''=>$order->warehouse_id));\n				$data[''currency'']		= $curr->currency;\n				\n				$breadcrumb = "<h3><a href=\\"{$current_page}/history\\">My Orders</a> &raquo; Order #{$order->id}</h3>";\n				\n				$results = $this->load->view(''modules/plexcart/interface/order'', $data, true);\n				\n				break;\n			\n			\n			case "cart":\n			\n				$data[''pgs'']			= $this->request(''get_payment_gateways'');\n				$data[''shippings'']		= $this->request(''get_shipping_services'');\n				$data[''user''] 			= $user = $this->request(''get_customer_information'', array(''session''=> base64_decode($_SESSION[''session'']),''fb'' => $_SESSION[''fb_logged_in'']));\n				$data[''online_rule'']	= $this->request(''get_online_min_purchase'');\n				$results = $this->load->view(''modules/plexcart/interface/cart'', $data, true);\n\n			\n				break;\n				\n			case "checkout_confirm":\n				\n				$data[''gateway'']		= $gateway = $_SESSION[''gateway''];\n				$data[''shipping''] 		= $shipping = $_SESSION[''shipping''];\n				$data[''delivery''] 		= $delivery = $_SESSION[''delivery''];\n				\n				$items 					= $_SESSION[''plexcart_items''];				\n				$res 					= $this->request(''get_delivery_charges'', array(''zipcode''=>$delivery[''zipcode''], ''country''=>$delivery[''country''], ''service''=>$shipping, ''items''=>json_encode($items)));\n				\n				$data[''delivery''] 		= $res;\n				$data[''shipping'']		= $this->request(''get_shipping_service_by_id'', array(''id''=>$shipping));\n				$data[''gateway'']		= $this->request(''get_payment_gateway_by_id'', array(''id''=>$gateway));				\n				$data[''user'']			= $this->request(''get_customer_information'', array(''session''=> base64_decode($_SESSION[''session'']),''fb'' => $_SESSION[''fb_logged_in'']));\n				$data[''items'']			= $items;\n				\n				$data[''warehouse'']		= $this->request(''get_warehouse_by_id'', array(''id''=>$_SESSION[''warehouse'']));\n				\n				$data[''online_rule'']	= $this->request(''get_online_min_purchase'');\n\n				$results = $this->load->view(''modules/plexcart/interface/checkout'', $data, true);\n				\n			\n				break;\n				\n			case "checkout_successful":\n				\n				$_SESSION[''plexcart_items''] = '''';\n				\n				$results = $this->load->view(''modules/plexcart/interface/checkout_successful'', $data, true);\n				\n				break;\n				\n			case "checkout_failed":\n\n				$results = $this->load->view(''modules/plexcart/interface/checkout_failed'', $data, true);			\n				\n				break;\n					\n		    case "search":\n		    \n		    	$data[''is_search_page'']	= true;\n		    	$data[''search_term'']	= $search_term = $this->input->post(''q'');\n		    	$data[''items''] 			= $items = $this->request(''get_items'',array(''term''=>$search_term,''warehouse''=>$_SESSION[''warehouse'']));\n		    	\n		    	$results = $this->load->view(''modules/plexcart/interface/items'', $data, true);\n		    	\n		    	break;\n		    	\n		    case ''verify'':\n				$id		= $_SESSION[''param2''];\n				$code	= $_SESSION[''param3''];\n				\n				\n				$res = $this->request(''verify_customer'', array(''id''=>$id,''code''=>$code));\n				\n				$data[''res''] = $res->data;\n				\n				$results = $this->load->view(''modules/plexcart/interface/verify'', $data, true);\n				\n		    	break;\n\n		    	\n		    case "item":\n		    \n		    	$id 						= $_SESSION[''param2''];		    	\n		    	$data[''item''] 				= $item = $this->request(''get_item_by_id'',array(''id''=>$id,''warehouse''=>$_SESSION[''warehouse'']));\n		    	$data[''category_page'']		= $current_page . ''category/'' . clean_url($item->category);\n		    	$data[''subcategory_page'']	= $current_page . ''category/'' . clean_url($item->category) . ''/'' . clean_url($item->subcategory);\n		    	$data[''cat''] 				= $item->category;\n		    	$data[''subcat'']				= $item->subcategory;\n				$data[''user''] 				= $user = $this->request(''get_customer_information'', array(''session''=> base64_decode($_SESSION[''session'']),''fb'' => $_SESSION[''fb_logged_in'']));\n\n		    	\n		    	$results = $this->load->view(''modules/plexcart/interface/item'', $data, true);\n		    	\n		    	break;\n		    	\n		    case "tag":\n		    \n		    	$data[''tag'']				= $tag = ucwords(reverse_clean_url($_SESSION[''param2'']));\n		    	$data[''items''] 				= $this->request(''get_items'',array(''tag''=>$tag,''warehouse''=>$_SESSION[''warehouse'']));\n		    	$data[''is_tag_page'']		= true;\n		    	$data[''user''] 				= $user = $this->request(''get_customer_information'', array(''session''=> base64_decode($_SESSION[''session'']),''fb'' => $_SESSION[''fb_logged_in'']));\n		    	\n		    	$results = $this->load->view(''modules/plexcart/interface/items'', $data, true);\n		    	\n		    	break;\n		    \n		    case "category":\n		    	$data[''cat''] 				= $cat = ucwords(reverse_clean_url($category_page = $_SESSION[''param2'']));\n		    	$data[''subcat'']				= $subcat = ucwords(reverse_clean_url($subcategory_page = $_SESSION[''param3'']));\n		    	$data[''category_page'']		= $current_page . ''category/'' . $category_page;\n		    	$data[''subcategory_page'']	= $current_page . ''category/'' . $category_page . ''/'' . $subcategory_page;		    	\n		    	$data[''subcategories''] 		= $this->request(''get_subcategories'', array(''cat''=>$cat));\n		    	$data[''items''] 				= $this->request(''get_items'',array(''cat''=>$cat,''subcat''=>$subcat,''warehouse''=>$_SESSION[''warehouse'']));\n		    	$data[''user''] 				= $user = $this->request(''get_customer_information'', array(''session''=> base64_decode($_SESSION[''session'']),''fb'' => $_SESSION[''fb_logged_in'']));\n		    	\n		    	\n		    	if ($subcat){\n		    		$data[''is_subcategory_page''] = true;\n		    		$data[''is_category_page''] = false;\n		    	} else {\n		    		$data[''is_subcategory_page''] = false;\n			    	$data[''is_category_page''] = true;\n		    	}\n		    	\n		    	$results = $this->load->view(''modules/plexcart/interface/items'', $data, true);\n		    	\n		    	break;\n		    	\n		    	\n		    case ''change_store'':\n		    	$_SESSION[''warehouse''] = null;\n			    $_SESSION[''plexcart_items''] = null;\n			    \n		    	$data[''warehouses''] = $this->request(''get_warehouses'');\n		    	$results = $this->load->view(''modules/plexcart/interface/warehouses'', $data, true);\n		    	break;\n		    	\n		    	\n		    	\n		    case ''warehouse'':\n		    	\n		    	$id = $_SESSION[''param2''];\n		    	$_SESSION[''warehouse''] = $id;\n		    	\n		    default: \n		    	$order_by_warehouse = $this->request(''order_by_warehouse'');\n		    	\n\n\n		    	if ($order_by_warehouse->enabled){\n\n			    	if ($_SESSION[''warehouse'']){\n\n				    	$data[''items''] = $items = $this->request(''get_items'', array(''warehouse'' => $_SESSION[''warehouse'']));    	\n				    	$data[''user''] = $user = $this->request(''get_customer_information'', array(''session''=> base64_decode($_SESSION[''session'']),''fb'' => $_SESSION[''fb_logged_in'']));\n				    	$results = $this->load->view(''modules/plexcart/interface/items'', $data, true);\n\n			    	\n			    	} else {\n				    	\n				    	$data[''warehouses''] = $this->request(''get_warehouses'');\n				    	$results = $this->load->view(''modules/plexcart/interface/warehouses'', $data, true);\n				    	\n			    	}\n			    	\n		    	} else {\n\n				    	$data[''items''] = $items = $this->request(''get_items'', array(''warehouse''=>$_SESSION[''warehouse'']));\n				    	$data[''user''] = $user = $this->request(''get_customer_information'', array(''session''=> base64_decode($_SESSION[''session'']),''fb'' => $_SESSION[''fb_logged_in'']));\n				    	$results = $this->load->view(''modules/plexcart/interface/items'', $data, true);\n\n\n		    	}\n		    \n		    	break;\n		}\n		\n		$searchbox = $this->load->view(''modules/plexcart/interface/searchbox'', $data, true);\n		\n		\n		$output .= "<script type=\\"text/javascript\\">\n					var lcms_plexcart_ucc = ''{$options->ucc}'';\n					var lcms_plexcart_ccc = ''{$options->ccc}'';\n				</script>\n				<div class=\\"lcms-plexcart-searchbox\\">{$searchbox}</div>\n				<div class=\\"lcms-plexcart-data\\"></div>\n				<div class=\\"lcms-plexcart-container\\">\n					{$results}\n				</div>";\n		\n		return $output;\n		\n		\n	}\n	\n	function Presave($content, $options){		\n		$data->content = $content;\n		$data->options = $options;\n		return $data;\n	}\n	\n	function Preupdate($id, $content, $options){\n		$data->content = $content;\n		$data->options = $options;\n		return $data;		\n	}\n	\n	function Saved($id, $published){\n		\n	}\n	\n	function Updated($id, $published){\n		\n	}\n	\n	\n	\n	function Add_to_cart(){\n		$id = $this->input->post(''id'');\n		$qty = $this->input->post(''qty'') ? $this->input->post(''qty'') : 1;\n		\n		$item = $this->request(''get_item_by_id'', array(''id''=>$id));\n		$user = $this->request(''get_customer_information'', array(''session''=> base64_decode($_SESSION[''session'']),''fb'' => $_SESSION[''fb_logged_in'']));\n		\n		$items = $_SESSION[''plexcart_items''];\n		\n		if ($items[$id]){\n			$items[$id][''qty''] = $qty;\n		} else {\n		\n			// Get price based on ranking [Azad]\n			if (is_object($user)){\n				//print_r($user);\n				if ($user->rank){\n					$item->price = $item->{''price''.$item->rules->{str_replace('' '',''_'',$user->rank)}};\n				}\n			}	\n			\n			\n			$cart_item[''name''] = $item->name;\n			$cart_item[''price''] = $item->discount_price ? $item->discount_price : $item->price;\n			$cart_item[''actual_price''] = $item->price;\n			$cart_item[''img''] = $item->primary_image;\n			$cart_item[''qty''] = $qty;\n			$cart_item[''id''] = $id;\n			$cart_item[''min''] = $item->min_cart_qty;\n			$cart_item[''max''] = $item->max_cart_qty;\n			\n			$items[$id] = $cart_item;\n		}\n		\n		$_SESSION[''plexcart_items''] = $items;\n\n	}\n	\n	function Remove_from_cart(){\n		$id = $this->input->post(''id'');\n		$items = $_SESSION[''plexcart_items''];\n		\n		foreach ($items as $item_id => $item){\n			if ($id == $item[''id'']){\n			\n			} else {\n				$new_items[$item_id] = $item;\n			}\n		}\n		$_SESSION[''plexcart_items''] = $new_items;\n	}\n	\n	function Cart_data(){\n	\n		session_start();\n	\n		$items = $_SESSION[''plexcart_items''];\n		\n		$total_qty = 0;\n		$total = 0;\n		$user = $this->request(''get_customer_information'', array(''session''=> base64_decode($_SESSION[''session'']),''fb'' => $_SESSION[''fb_logged_in'']));\n\n		$data[''user''] = $user;\n		\n		foreach ($items as $item){\n			$subtotal = $item[''qty''] * $item[''price''];\n			$total_qty += $item[''qty''];\n			$total += $subtotal;\n		}\n		\n		\n		$data[''warehouse''] = $this->request(''get_warehouse_by_id'', array(''id''=> $_SESSION[''warehouse'']));\n		$data[''items''] = $items;\n		$data[''total''] = number_format($total,2);\n		$data[''qty''] = $total_qty;\n\n		\n		$query = $this->db->query("SELECT * FROM `contents` WHERE `type` = ''plexcart'' AND `published` = 1");\n		\n		if (!$query->num_rows()){\n			echo ''false'';	\n			return;	\n		} \n		\n		$content = $query->row();\n		\n		\n		$data[''current_page''] = base_url() . ''p/'' . $content->page . ''/'';\n		\n		\n		$data[''options''] = json_decode($content->options);\n		$order_by_warehouse = $this->request(''order_by_warehouse'');\n\n		$data[''warehouse_enabled'']	= $order_by_warehouse->enabled;\n		$data[''categories'']		 	= $this->request(''get_categories'');\n		\n		$data[''fb_enabled'']			= $this->FB_ENABLED;\n		$data[''fb_app_id'']			= $this->FB_APP_ID;\n		\n		\n		echo $this->load->view(''modules/plexcart/interface/cart_info'', $data, true);\n		\n	}\n	\n	function Update_cart(){\n		$current_items = $_SESSION[''plexcart_items''];\n		$input_item = $this->input->post(''item'');\n				\n		foreach ($current_items as $id => $item){\n			$item[''qty''] = $input_item[$id];\n			$items[$id] = $item;\n		}\n		\n		\n		$_SESSION[''plexcart_items''] = $items;\n	}\n	\n	function FB_login(){\n		$user = $this->FB_user();\n		\n		$res = $this->request(''register_fb_user'',array(''userdata''=>json_encode($user)));\n		\n		if ($user){\n			\n			$_SESSION[''session''] 		= base64_encode($res->data);\n			$_SESSION[''ip'']		 		= $_SERVER[''REMOTE_ADDR''];\n			$_SESSION[''fb_logged_in'']	= true;\n			\n			$obj->status = ''ok'';\n			$obj->user = $user;\n			echo json_encode($obj);\n		} else {\n			$obj->status = ''false'';\n			$obj->user = $user;\n			echo json_encode($obj);\n		}\n	}\n	\n	\n	function FB_user(){\n			echo $this->FB_APP_ID;\n			echo '' S:'' . $this->FB_APP_SECRET;\n\n			$cookie = $this->get_facebook_cookie($this->FB_APP_ID, $this->FB_APP_SECRET);\n			$this->fb_user = json_decode(file_get_contents(''https://graph.facebook.com/me?access_token=''.$cookie[''access_token'']));\n			$this->fb_request = true;\n\n			return $this->fb_user;\n    }\n	\n	\n	function get_facebook_cookie($app_id, $app_secret) {\n	    if ($_COOKIE[''fbsr_'' . $app_id] != '''') {\n	        return $this->get_new_facebook_cookie($app_id, $app_secret);\n	    } else {\n	        return $this->get_old_facebook_cookie($app_id, $app_secret);\n	    }\n	}\n	\n	function get_old_facebook_cookie($app_id, $app_secret) {\n	    $args = array();\n	    parse_str(trim($_COOKIE[''fbs_'' . $app_id], ''\\\\"''), $args);\n	    ksort($args);\n	    $payload = '''';\n	    foreach ($args as $key => $value) {\n	        if ($key != ''sig'') {\n	            $payload .= $key . ''='' . $value;\n	        }\n	    }\n	    if (md5($payload . $app_secret) != $args[''sig'']) {\n	        return array();\n	    }\n	    return $args;   \n	}\n	\n	function get_new_facebook_cookie($app_id, $app_secret) {\n		$signed_request = $this->parse_signed_request($_COOKIE[''fbsr_'' . $app_id], $app_secret);\n		// $signed_request should now have most of the old elements\n		$signed_request[uid] = $signed_request[user_id]; // for compatibility \n		if (!is_null($signed_request)) {\n			// the cookie is valid/signed correctly\n			// lets change "code" into an "access_token"\n			$access_token_response = file_get_contents("https://graph.facebook.com/oauth/access_token?client_id=$app_id&redirect_uri=&client_secret=$app_secret&code=$signed_request[code]");\n			parse_str($access_token_response);\n			$signed_request[access_token] = $access_token;\n			$signed_request[expires] = time() + $expires;\n		}\n		return $signed_request;\n	}\n	\n	function parse_signed_request($signed_request, $secret) {\n		list($encoded_sig, $payload) = explode(''.'', $signed_request, 2); \n	\n		// decode the data\n		$sig = $this->base64_url_decode($encoded_sig);\n		$data = json_decode($this->base64_url_decode($payload), true);\n	\n		if (strtoupper($data[''algorithm'']) !== ''HMAC-SHA256'') {\n			error_log(''Unknown algorithm. Expected HMAC-SHA256'');\n			return null;\n		}\n	\n		// check sig\n		$expected_sig = hash_hmac(''sha256'', $payload, $secret, $raw = true);\n		if ($sig !== $expected_sig) {\n			error_log(''Bad Signed JSON signature!'');\n			return null;\n		}\n\n		return $data;\n	}\n	\n	function base64_url_decode($input) {\n		return base64_decode(strtr($input, ''-_'', ''+/''));\n	}\n\n	\n	\n	function Request($request, $data){\n	\n		$option = json_decode(base64_decode($_SESSION[''options'']));\n		\n		$data[''api_key''] = $option->api_key;\n		\n		$postdata = http_build_query($data);\n	\n	\n		$opts = array(''http'' =>\n	  	    array(\n	  	        ''method''  => ''POST'',\n	  	        ''header''  => ''Content-type: application/x-www-form-urlencoded'',\n	  	        ''content'' => $postdata\n	  	    )\n	  	);\n\n	  	$context  = stream_context_create($opts);					\n	  	\n    	\n	  	$data = json_decode($res = file_get_contents($option->api_url.''/''.$request.''/json'','''',$context));\n	  	\n\n\n	  	if ($data->status == ''Failed''){\n		  	echo ''Request Error: '' . $data->reason;\n	  	} else {\n		  	return $data;\n	  	}\n	}\n	\n}', '2012-12-07 10:54:53', 'admin', NULL);
INSERT INTO `editor_revisions` (`id`, `profile_id`, `item`, `contents`, `datetime`, `user`, `commit`) VALUES
(63, 9, '/var/www/jhs/os/application/controllers/cartapi.php', '<?php\n\nclass CartAPI extends Controller {\n	\n\n	function CartAPI(){\n		parent::Controller();\n		\n		$this->load->model(''system'');\n		\n\n		$domain = $_SERVER[''REMOTE_ADDR''];\n		$api_key = $this->input->post(''api_key'');\n	\n\n		$this->failed = false;\n\n\n		$allowed_domains = explode('','',str_replace('' '','''',$this->system->config(''online_sales_allowed_domains'')));\n		if (in_array($domain, $allowed_domains)){\n			if (strtoupper($api_key) != strtoupper($this->system->config(''online_sales_api_key''))){\n				$return->status = ''Failed'';\n				$return->reason = ''Invalid API key '' . $api_key . ''.'';\n				\n				echo json_encode($return);\n				$this->failed = true;\n			}	\n		} else {\n			$return->status = ''Failed'';\n			$return->reason = ''Access denied from domain '' . $domain . ''.'';\n\n			echo json_encode($return);\n			$this->failed = true;\n		}\n\n		\n\n	}\n	\n\n	\n	function Order_by_warehouse($output, $args){\n		if ($this->failed) return;\n		$data->enabled = $this->system->config(''warehouse_enabled'');	\n		$data->module = ''Warehouse'';\n		if ($output == ''json'') echo json_encode($data);\n	}\n	\n	function Get_online_min_purchase($output, $args){\n		if ($this->failed) return;\n		$data->min_purchase = $this->system->config(''online_sales_min_purchase'');	\n		$data->currency = $this->system->config(''currency'');\n		if ($output == ''json'') echo json_encode($data);\n	}\n	\n	function Get_currency($output, $args){\n		if ($this->failed) return;\n		$data->currency = $this->system->config(''currency'');\n		if ($output == ''json'') echo json_encode($data);\n	}\n	\n	function Get_categories($output, $args){\n		if ($this->failed) return;\n		\n		$query = $this->db->query("SELECT `category` FROM `inventory` GROUP BY `category` ORDER BY `category` ASC");\n		foreach ($query->result() as $item){\n			$categories[] = $item->category;\n		}\n		if ($output == ''json'') echo json_encode($categories);\n	}\n	\n	function Get_countries($output, $args){\n		if ($this->failed) return;\n		\n		$query = $this->db->query("SELECT * FROM `countries`");\n		foreach ($query->result() as $country){\n			$countries[$country->name] = $country->name;\n		}\n		if ($output == ''json'') echo json_encode($countries);		\n		\n	}\n	\n	function Get_subcategories($output, $args){\n		if ($this->failed) return;\n		\n		$category = $this->input->post(''cat'');\n		if ($category){\n			$query = $this->db->query("SELECT `subcategory` FROM `inventory` WHERE `category` = ? GROUP BY `subcategory` ORDER BY `subcategory` ASC", array($category));\n		} else {\n			$query = $this->db->query("SELECT `subcategory` FROM `inventory` GROUP BY `subcategory` ORDER BY `subcategory` ASC");		\n		}\n		\n		foreach ($query->result() as $item){\n			$subcategories[] = $item->subcategory;\n		}\n		\n		if ($output == ''json'') echo json_encode($subcategories);	\n	}\n	\n	function Get_tags($output, $args){\n		if ($this->failed) return;\n	\n		$query = $this->db->query("SELECT * FROM `inventory` WHERE `tags` LIKE ''%#%''");\n		foreach ($query->result() as $item){\n			if (strpos($item->tags,'','')){\n				foreach (explode('','',$item->tags) as $tag){\n					if ($tag[0] == ''#''){\n						$tags_array[strtolower(str_replace(''#'','''', $tag))] = str_replace(''#'','''', $tag);\n					}\n				}\n			} else {\n				if ($item->tags[0] == ''#''){\n					$tag = str_replace(''#'','''',$item->tags);\n					$tags_array[strtolower($tag)] = $tag;\n				}\n			}\n		}\n		\n		if ($output == ''json'') echo json_encode($tags_array);\n		\n	}\n\n		\n	\n	function Get_items($output, $args){\n		if ($this->failed) return;\n		\n		$filter[] = "`linked` IS NULL";\n		\n		if ($cat = $this->input->post(''cat'')) $filter[] = "`category` = " . $this->db->escape($cat);\n		if ($subcat = $this->input->post(''subcat'')) $filter[] = "`subcategory` = " . $this->db->escape($subcat);\n		if ($term = $this->input->post(''term'')){\n			$filter[] = "(`name` LIKE " . $this->db->escape(''%''.$term.''%'') . " OR `description` LIKE " . $this->db->escape(''%''.$term.''%'') . ")";\n		}\n		if ($tag = $this->input->post(''tag'')){\n			$filter[] = "`tags` LIKE " . $this->db->escape(''%#''.$tag.''%'');\n		}\n		\n		$filter[] = " `ready_for_sale` = 1";\n		\n		$warehouse = $this->input->post(''warehouse'');\n		\n		$orderby = $this->input->post(''orderby'');\n		$order = $this->input->post(''order'');\n		\n		\n		if (count($filter)) $where = implode('' AND '', $filter);\n		else $where = ''1 = 1'';\n		\n		if (!$orderby) $orderby = "`added_on`";\n		if (!$order) $order = "ASC";\n		\n		$rules = json_decode($this->system->config(''price_rules''));\n		\n		$query = $this->db->query("SELECT * FROM `inventory` WHERE $where ORDER BY $orderby $order");\n		foreach ($query->result() as $item){\n			$item->rules = $rules;\n			\n			$item->currency = $this->system->config(''currency'');\n\n			$item->warehouse = $warehouse;\n			$item->qty = $this->get_item_quantity(''return'', array(''warehouse''=>$warehouse, ''item_id''=>$item->id));\n			\n			$query = $this->db->query("SELECT * FROM `sales_discount_item_rules` WHERE `item_id` = ? AND `date_from` <= ? AND `date_to` >= ?", array($item->id, date(''Y-m-d''),date(''Y-m-d'')));\n			$row = $query->row();\n			\n			$item->discount_price 					= $row->discount_price;\n			$item->discount_percentage 				= $row->discount_percentage;\n			$item->discount_applies_to 				= $row->applies_to;\n			$item->discount_performance_based 		= $row->is_performance_based;\n			$item->discount_performance_duration 	= $row->performance_duration;\n			$item->discount_performance_limit 		= $row->performance_limit;\n\n\n\n			$items[] = $item;			\n		}\n		\n\n\n		\n		if ($output == ''json'') echo json_encode($items);\n	\n	}\n	\n	\n	function Get_discount_rules($output, $args){\n		if ($this->failed) return;\n		\n		$query = $this->db->query("SELECT * FROM `sales_discount_item_rules` WHERE `date_from` <= ? AND `date_to` >= ?", array(date(''Y-m-d''),date(''Y-m-d'')));\n		\n		if ($output == ''json'') echo json_encode($query->result());\n	}\n	\n	function Get_item_by_id($output, $args){\n		if ($this->failed) return;\n		\n		$id = $this->input->post(''id'');\n		\n		if (is_array($args)){\n			foreach ($args as $key => $val){\n				${$key} = $val;\n			}\n		}\n		\n		$query = $this->db->query("SELECT * FROM `inventory` WHERE `id` = ? ", array($id));\n		$item = $query->row();\n		\n		$variants = null;\n		if ($item->links){\n			if (strpos($item->links,'','')){\n				foreach (explode('','', $item->links) as $sku){\n					$query = $this->db->query("SELECT * FROM `inventory` WHERE `sku` = ?", array($sku));\n					$variant = $query->row();\n					$variants[] = $variant;\n				}\n			} else {\n				$query = $this->db->query("SELECT * FROM `inventory` WHERE `sku` = ?", array($item->links));\n				$variant = $query->row();\n				$variants[] = $variant;\n			}\n		}\n		\n		$rules = json_decode($this->system->config(''price_rules''));\n		\n		$item->rules = $rules;\n		$item->variants = $variants;\n		$item->currency = $this->system->config(''currency'');\n		\n		$query = $this->db->query("SELECT * FROM `sales_discount_item_rules` WHERE `item_id` = ? AND `date_from` <= ? AND `date_to` >= ?", array($item->id, date(''Y-m-d''),date(''Y-m-d'')));\n		\n		if ($query->num_rows()){\n			$row = $query->row();\n			\n			$item->discount_price 					= $row->discount_price;\n			$item->discount_percentage 				= $row->discount_percentage;\n			$item->discount_applies_to 				= $row->applies_to;\n			$item->discount_performance_based 		= $row->is_performance_based;\n			$item->discount_performance_duration 	= $row->performance_duration;\n			$item->discount_performance_limit 		= $row->performance_limit;\n		}\n		\n		if ($warehouse = $this->input->post(''warehouse'')){\n			$item->warehouse = $warehouse;\n			$item->qty = $this->get_item_quantity(''return'', array(''warehouse''=>$warehouse, ''item_id''=>$item->id));\n		}\n\n		\n		if ($output == ''json'') echo json_encode($item);\n		elseif ($output == ''return'') return $item;\n		\n	}\n	\n	function Verify_contacts_by_field($output,$args){\n		if ($this->failed) return;\n		\n		$query = $this->db->query("SELECT * FROM `contacts` WHERE `email` = ?", array($this->input->post(''email'')));\n		if ($query->num_rows()){\n\n			$data->data = ''email_false'';\n			if ($output == ''json'') echo json_encode($data);\n\n			return;\n		}\n		\n		$query = $this->db->query("SELECT * FROM `contacts` WHERE `ic` = ?", array($this->input->post(''ic'')));\n		if ($query->num_rows()){\n\n			$data->data = ''ic_false'';\n			if ($output == ''json'') echo json_encode($data);\n			return;\n		}\n		\n		\n		$data->data = ''ok'';\n		if ($output == ''json'') echo json_encode($data);\n		\n		\n		\n	}\n	\n	function Verify_customer($output, $args){\n		if ($this->failed) return;\n		\n		\n\n		$code = $this->input->post(''code'');\n		$id = $this->input->post(''id'');		\n		\n				\n		$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($id));\n		$customer = $query->row();\n		\n		if (strpos($customer->tags, '','')){\n			$tags = explode('','',$customer->tags);\n			foreach ($tags as $tag){\n				if ($tag == ''Unverified''){\n					$tag = ''Verified'';\n				}\n				$new_tags[] = $tag;\n			}\n			$tags = implode('','', $new_tags);\n		} else {\n			$tags = str_replace(''Unverified'',''Verified'',$customer->tags);\n		}\n		\n		$this->db->update(''contacts'', array(''tags'' => $tags), "`id` = ''{$id}''");\n\n		$data->code = $code;\n		$data->id = $id;\n		$data->customer = $customer;\n		\n\n		\n		\n		if (strtoupper($code) == strtoupper(md5($customer->id.$customer->email.$customer->contact_person))){\n			$data->data = ''ok'';\n		} else {\n			$data->data = ''false'';\n		}\n\n		if ($output == ''json'') echo json_encode($data);		\n	}	\n	\n	function Register_customer($output, $args){\n		if ($this->failed) return;\n	\n		$query = $this->db->query("SELECT * FROM `contacts` WHERE `email` = ?", array($this->input->post(''email'')));\n		if ($query->num_rows()){\n\n			$data->data = ''false'';\n			if ($output == ''json'') echo json_encode($data);\n\n		} else {\n			\n			$ic = ereg_replace("[^A-Za-z0-9\\s]", "", $this->input->post(''ic'') );		\n			$introducer_ic = ereg_replace("[^A-Za-z0-9\\s]", "", $this->input->post(''introducer_ic''));	\n			\n			$query = $this->db->insert(''contacts'', array(\n				''is_customer''		=> 1,\n				''contact_person''	=> $name = $this->input->post(''name''),\n				''contact_number''	=> $this->input->post(''mobile''),\n				''address1''			=> $this->input->post(''address1''),\n				''address2''			=> $this->input->post(''address2''),\n				''city''				=> $this->input->post(''city''),\n				''state''				=> $this->input->post(''state''),\n				''zipcode''			=> $this->input->post(''zipcode''),\n				''country''			=> $this->input->post(''country''),\n				''email''				=> $email = $this->input->post(''email''),\n				''general_email''		=> $email,\n				''ic''				=> $ic,\n				''introducer_ic''		=> $introducer_ic,				\n				''is_member''			=> 1,\n				''password''			=> $this->input->post(''password''),\n				''added_on''			=> date(''Y-m-d H:i:s''),\n				''added_by''			=> ''@Plexcart'',\n				''tags''				=> ''Online Customer,Unverified''\n			));\n\n			$id = $query->insert_id;	\n							\n			if(strcmp($this->input->post(''country''),''Malaysia'') != 0){\n	\n				$sql = $this->db->update_string(''contacts'',array(\n					''ic''	=> $id\n				),"`id` = ''$id''");\n			}\n			\n			$link = $this->input->post(''link'') . ''verify/'' . $id . ''/'' . md5($id.$email.$name);\n			\n			$message = $this->system->config(''online_sales_email_new_registration'');\n			$message = str_replace(''{name}'', $name, $message);\n			$message = str_replace(''{email}'', $email, $message);\n			$message = str_replace(''{link}'', $link, $message);\n			\n			\n			$config[''protocol''] = ''smtp'';\n			$config[''mailpath''] = ''/usr/sbin/sendmail'';\n			$config[''charset''] = ''iso-8859-1'';\n			$config[''wordwrap''] = TRUE;\n			$config[''mailtype''] = ''html'';\n		\n			$config[''smtp_host''] = $this->system->config(''online_sales_responder_hostname'');\n			$config[''smtp_user''] = $this->system->config(''online_sales_responder_email'');\n			$config[''smtp_pass''] = $this->system->config(''online_sales_responder_password'');\n			$config[''smtp_port''] = ''25'';\n\n			$this->load->library(''email'');		\n			$this->email->initialize($config);\n\n			$this->email->from($this->system->config(''online_sales_responder_email''), $this->system->config(''online_sales_responder_name''));\n			$this->email->to($email);\n			$this->email->bcc($this->system->config(''online_sales_responder_txn_email''));\n			$this->email->subject($this->system->config(''online_sales_email_new_registration_subject''));\n			$this->email->message($message);\n			$this->email->send();\n			\n			\n			\n			$data->data = ''ok'';\n			if ($output == ''json'') echo json_encode($data);\n		}\n	}\n	\n	function Test_mail(){\n\n		\n		$config[''protocol''] = ''smtp'';\n		$config[''mailpath''] = ''/usr/sbin/sendmail'';\n		$config[''charset''] = ''iso-8859-1'';\n		$config[''wordwrap''] = TRUE;\n    	$config[''mailtype''] = ''html'';\n		\n		$config[''smtp_host''] = $this->system->config(''online_sales_responder_hostname'');\n		$config[''smtp_user''] = $this->system->config(''online_sales_responder_username'');\n		$config[''smtp_user''] = ''slm@halagel.com.my'';\n		$config[''smtp_pass''] = $this->system->config(''online_sales_responder_password'');\n		$config[''smtp_pass''] = ''1234567'';\n		$config[''smtp_port''] = ''25'';\n\n		$this->load->library(''email'');		\n		$this->email->initialize($config);\n\n		\n		$this->email->from($this->system->config(''online_sales_responder_email''));\n		$this->email->to(''shafiq.rizwan@gmail.com'');\n		$this->email->message(''test message'');\n		$this->email->send();\n		\n		$data->debug = $this->email->print_debugger();\n		echo json_encode($data);\n	}\n	\n	function Update_account($output, $args){\n		if ($this->failed) return;\n		\n		$id = $this->input->post(''id'');\n		\n		$this->db->update(''contacts'', array(\n				''company_name''		=> $this->input->post(''company''),\n				''contact_person''	=> $this->input->post(''name''),\n				''contact_number''	=> $this->input->post(''mobile''),\n				''address1''			=> $this->input->post(''address1''),\n				''address2''			=> $this->input->post(''address2''),\n				''city''				=> $this->input->post(''city''),\n				''state''				=> $this->input->post(''state''),\n				''zipcode''			=> $this->input->post(''zipcode''),\n				''country''			=> $this->input->post(''country''),\n				''modified_on''		=> date(''Y-m-d H:i:s''),\n				''modified_by''		=> ''_self'',\n		),"`id` = ''{$id}''");\n	\n		if ($password = $this->input->post(''password'')){\n			$this->db->update(''contacts'', array(\n				''password''			=> md5($this->input->post(''password''))\n			), "`id` = ''{$id}''");\n		}\n		\n		if ($output == ''json'') echo json_encode($data);\n	}\n	\n	function Auth_customer($output, $args){\n		if ($this->failed) return;\n		\n		$username = $this->input->post(''username'');\n		$password = $this->input->post(''password'');\n\n		$query = $this->db->query("SELECT * FROM `contacts` WHERE `email` = ?", array($username));\n		$customer = $query->row();\n		\n		$tags_exploded = explode(",", $customer->tags);\n		\n		if ($customer->is_franchise){\n			$data->data = ''incorrect'';	\n			if ($output == ''json'') echo json_encode($data);\n			\n			return;\n		}\n		\n		if (($password == $customer->password) && (in_array(''Verified'', $tags_exploded))){\n		\n			$session = $username . time();\n			$this->db->query("UPDATE `contacts` SET `current_session` = ? WHERE `email` = ?", array($session, $username));\n			\n			$data->data = $session;	\n		\n			if ($output == ''json'') echo json_encode($data);\n		} else {\n		\n			$data->data = ''incorrect'';	\n			if ($output == ''json'') echo json_encode($data);\n			\n		}\n		\n	}\n	\n	function Get_customer_information($output, $args){\n		if ($this->failed) return;\n		\n		$session = $this->input->post(''session'');\n		$query = $this->db->query("SELECT * FROM `contacts` WHERE `current_session` = ?", array($session));\n		\n		$data = $query->row();\n		$data->loyalty_points = $this->get_customer_points($data->id);\n		if ($output == ''json'') echo json_encode($data);\n	}\n	\n	function Get_customer_points($id){\n		$query = $this->db->query("SELECT SUM(FLOOR(`amount`)) AS `total_amount` FROM `sales` WHERE `customer_id` = ? AND `is_redemption` <> 1 AND `type` = ''history''", array($id));\n	    $point_sales = $query->row();\n	    \n	    $query = $this->db->query("SELECT SUM(FLOOR(`total_delivered`)) AS `total_amount` FROM `invoices` WHERE `contact_id` = ? AND `payment_status` = ''Paid''", array($id));\n	    $point_invoices = $query->row();\n	    \n	    $total = $point_sales->total_amount + $point_invoices->total_amount;\n	    \n	    $amount = $this->system->config(''member_minimum_amount'');\n	    $ppa = $this->system->config(''member_minimum_point'');\n	    \n	    $query = $this->db->query("SELECT SUM(`points`) AS `total_points` FROM `sale_items` WHERE `redeemed` = 1 AND `member_id` = ?", array($id));\n	    $points_redeemed = $query->row();\n\n	    return (floor($total / $amount) * $ppa) - $points_redeemed->total_points;\n	}\n	\n	function Get_customer_history($output, $args){\n		if ($this->failed) return;\n		\n		$id = $this->input->post(''id'');\n		$query = $this->db->query("SELECT * FROM `sales_order` WHERE `contact_id` = ? AND `status` = ''Completed'' ORDER BY `date` DESC", array($id));\n		\n		foreach ($query->result() as $so){\n			$query = $this->db->query("SELECT * FROM `invoices` WHERE `sales_order_id` = ?", array($so->id));\n			$invoice = $query->row();\n			$so->invoice = $invoice;\n			$sos[] = $so;\n		}\n		\n		if ($output == ''json'') echo json_encode($sos);\n		\n	}\n	\n	function Get_order_by_id($output, $args){\n		if ($this->failed) return;\n		\n		$id = $this->input->post(''id'');\n		$user_id = $this->input->post(''user_id'');\n		\n		$query = $this->db->query("SELECT * FROM `sales_order` WHERE `id` = ? AND `contact_id` = ?", array($id, $user_id));\n		\n		if ($query->num_rows()){\n			$order = $query->row();\n\n			$query = $this->db->query("SELECT * FROM `sales_order_items` WHERE `sales_order_id` = ?", array($id));\n			$order->items = $query->result();\n			\n			$query = $this->db->query("SELECT * FROM `invoices` WHERE `sales_order_id` = ?", array($id));\n			$order->invoice = $query->row();\n\n		}\n		\n		if ($output == ''json'') echo json_encode($order);\n		\n	}\n	\n	function Get_purchase_by_id($output, $args){\n		if ($this->failed) return;\n		\n		$username = $this->input->post(''username'');\n		$challenge = $this->input->post(''challenge'');\n		$challenge_feedback = $this->input->post(''challenge_feedback'');\n	\n	}\n	\n	function Checkout($output, $args){\n		if ($this->failed) return;\n		\n		$user 				= json_decode($this->input->post(''user''));\n		$items				= json_decode($this->input->post(''items''));\n		$gateway			= json_decode($this->input->post(''gateway''));\n		$shipping 			= json_decode($this->input->post(''shipping''));\n		$delivery			= json_decode($this->input->post(''delivery''));\n		$warehouse_id		= $this->input->post(''warehouse_id'');\n\n\n		$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($user->id));\n		$contact = $query->row();		\n\n		$address->address1	= $contact->address1;\n		$address->address2	= $contact->address2;\n		$address->zipcode	= $contact->zipcode;\n		$address->city		= $contact->city;\n		$address->state		= $contact->state;\n		$address->country	= $contact->country;\n		\n		$date = date(''Y-m-d H:i:s'');\n		$due_date = date(''Y-m-d H:i:s'',time() + (60 * 60 * 24 * 30));\n		\n		$delivery_charges = $this->get_delivery_charges(''return'', array(\n			''service''	=> $shipping->id,\n			''country''	=> $delivery->country,\n			''zipcode''	=> $delivery->zipcode\n		));\n\n		$sql = $this->db->insert_string(''sales_order'',array(\n			''date''				=> $date,\n			''due_date''			=> $due_date,\n			''contact''			=> $contact->company_name ? $contact->company_name : $contact->contact_person,\n			''contact_id''		=> $contact->id,\n			''contact_address''	=> json_encode($address),\n			''delivery_address''	=> json_encode($delivery),\n			''terms''				=> ''Cash'',\n			''duration''			=> $this->input->post(''duration''),\n			''status''			=> ''Pending'',\n			''payment_status''	=> ''Unpaid'',\n			''payment_gateway''	=> $gateway->namespace,\n			''payment_method''	=> $gateway->name,\n			''shipping''			=> $shipping->name,\n			''shipping_id''		=> $shipping->id,\n			''adjustment''		=> $this->input->post(''adjustment''),\n			''adjustment_type''	=> $this->input->post(''adjustment_type''),\n			''handling_charges''	=> $delivery_charges->total_rate,\n			''warehouse_id''		=> $warehouse_id,\n			''tags''				=> ''Online Sales'',\n			''added_on''			=> date(''Y-m-d H:i:s''),\n			''added_by''			=> ''@Plexcart''\n		));\n\n		$query = $this->db->query($sql);\n\n		$so_id = $query->insert_id;\n		\n		$price_rules = json_decode($this->system->config(''price_rules''));\n				\n		foreach ($items as $item){\n			$qty = $item->qty;\n			$item = $this->get_item_by_id(''return'',array(''id''=>$item->id));\n	\n			if ($contact->rank){\n				$item->price = $item->{''price''.$price_rules->{str_replace('' '',''_'',$contact->rank)}};\n			}\n				\n			$sql = $this->db->insert_string(''sales_order_items'',array(\n				''sales_order_id''	=> $so_id,\n				''date''				=> $date,\n				''type''				=> ''product'',\n				''item_sku''			=> $item->sku,\n				''item_name''			=> $item->name,\n				''item_description''	=> $item->description,\n				''item_id''			=> $item->id,\n				''qty''				=> $qty,\n				''cost''				=> $item->cost * $qty,\n				''price''				=> $subtotal = ($item->discount_price ? $item->discount_price : $item->price) * $qty,\n				''price_per_unit''	=> ($item->discount_price ? $item->discount_price : $item->price),\n				''warehouse_id''		=> $warehouse_id\n			));\n			\n			$total += $subtotal;\n			$total_cost += $item->cost;\n			\n			$this->db->query($sql);\n			\n		}\n		\n		$grand_total = $total + $delivery_charges->total_rate;\n		\n		$this->db->update(''sales_order'', array(\n			''cost''	=> $total_cost,\n			''total''	=> $grand_total\n		),"`id` = ''{$so_id}''");\n\n\n\n\n		\n\n		$query = $this->db->query("SELECT * FROM `sales_order` WHERE `id` = ?", array($so_id));\n		$order = $query->row();\n		\n		$query = $this->db->query("SELECT * FROM `sales_order_items` WHERE `sales_order_id` = ?", array($so_id));\n		$order->items = $query->result();\n\n		if ($output == ''json'') echo json_encode($order);\n\n\n	}\n	\n	function Complete($output, $args){\n		if ($this->failed) return;\n		\n		$time			= $this->input->post(''time'');\n		$secret			= $this->input->post(''secret'');\n		$order_id		= $this->input->post(''id'');\n		$payment_status	= $this->input->post(''payment_status'');\n		$status			= $this->input->post(''status'');\n		$remarks		= $this->input->post(''remarks'');\n		$txn_reference 	= $this->input->post(''txn_reference'');\n		$txn_date		= $this->input->post(''txn_date'');\n		\n		$mytime = time();\n		\n			\n		$this->db->update(''sales_order'', array(\n			''status''			=> $status,\n			''remarks''			=> $remarks,\n			''payment_status''	=> $payment_status\n		),"`id` = ''{$order_id}''");\n		\n		if ($payment_status == ''Paid''){\n			$query = $this->db->query("SELECT * FROM `sales_order` WHERE `id` = ?", array($order_id));\n			$so = $query->row();\n			\n			if ($so->invoice_id) return;\n		\n			$sql = $this->db->insert_string(''invoices'',array(\n				''date''				=> date(''Y-m-d H:i:s''),\n				''due_date''			=> $due_date,\n				''sales_order_id''	=> $order_id,\n				''contact_person''	=> $so->contact_person,\n				''contact''			=> $so->contact,\n				''contact_id''		=> $so->contact_id,\n				''contact_address''	=> $so->contact_address,\n				''delivery_address''	=> $so->delivery_address,\n				''delivery_status''	=> ''Pending'',\n				''shipping''			=> $so->shipping,\n				''shipping_id''		=> $so->shipping_id,\n				''terms''				=> ''Cash'',\n				''duration''			=> '''',\n				''payment_status''	=> ''Paid'',\n				''payment_date''		=> $txn_date,\n				''payment_reference''	=> $txn_reference,\n				''status''			=> ''Pending'',\n				''adjustment''		=> $so->adjustment,\n				''adjustment_type''	=> $so->adjustment_type,\n				''handling_charges''	=> $so->handling_charges,\n				''remarks''			=> $so->remarks,\n				''total''				=> $so->total,\n				''tags''				=> ''Online Sales'',\n				''added_on''			=> date(''Y-m-d H:i:s''),\n				''added_by''			=> ''@Plexcart'',\n				''warehouse_id''		=> $so->warehouse_id\n			));\n	\n			$query = $this->db->query($sql);\n	\n			$invoice_id = $query->insert_id;\n			\n\n			$sql = $this->db->update_string(''sales_order'', array(\n				''invoice_id''	=> $invoice_id\n			),"`id` = ''{$order_id}''");\n			$this->db->query($sql);\n\n			$query = $this->db->query("SELECT * FROM `sales_order_items` WHERE `sales_order_id` = ?", array($order_id));\n			$items = $query->result();\n			\n			$date = date(''Y-m-d H:i:s'');\n			\n			foreach ($items as $item){\n				$sql = $this->db->insert_string(''invoice_items'',array(\n					''invoice_id''		=> $invoice_id,\n					''date''				=> $date,\n					''type''				=> $item->type,\n					''item_name''			=> $item->item_name,\n					''item_description''	=> $item->item_description,\n					''item_id''			=> $item->item_id,\n					''item_sku''			=> $item->item_sku,\n					''service_id''		=> $item->service_id,\n					''qty''				=> $item->qty,\n					''price''				=> $item->price,\n					''price_per_unit''	=> $item->price_per_unit,\n					''discount_type''		=> $item->discount_type,\n					''discount''			=> $item->discount,\n					''warehouse_id''		=> $item->warehouse_id\n				));\n				\n				$this->db->query($sql);\n				\n			}\n			\n		}\n		\n		$query = $this->db->query("SELECT * FROM `contacts` WHERE `id` = ?", array($so->contact_id));\n		$contact = $query->row();\n		\n		$total 				= number_format($so->total - $so->handling_charges,2);\n		$handling_charges	= number_format($so->handling_charges,2);\n		$grand_total 		= number_format($so->total,2);\n		\n		$styles = ''<style>'' . $this->system->config(''online_sales_email_css'') . ''</style>'';\n		\n		$order_table = "<table style=\\"border-collapse: collapse;\\"><thead><tr><th>No</th><th>Item</th><th>Unit Price</th><th>Qty</th><th>Subtotal</th></tr></thead>";\n		$order_table .= "<tfoot>\n							<tr>\n								<td colspan=\\"4\\">Total</td>\n								<td style=\\"text-align: right\\">{$total}</td>\n							</tr>\n							<tr>\n								<td colspan=\\"4\\">Shipping: {$so->shipping}</td>\n								<td style=\\"text-align: right\\">{$handling_charges}</td>\n							</tr>\n							<tr>\n								<td colspan=\\"4\\"><strong>Grand Total</strong></td>\n								<td style=\\"text-align: right\\">{$grand_total}</td>	\n							</tr>\n						</tfoot>";\n		$order_table .= "<tbody>";\n		\n		foreach ($items as $item){\n			$z++;\n			$order_table .= "<tr>\n								<td style=\\"text-align: center\\">{$z}</td>\n								<td>{$item->item_name}<br />{$item->item_sku}</td>\n								<td style=\\"text-align: center\\">{$item->price_per_unit}</td>\n								<td style=\\"text-align: center\\">{$item->qty}</td>\n								<td style=\\"text-align: right\\">{$item->price}</td>\n							</tr>";\n		}\n		$order_table .= "</tbody></table>";\n		\n		$address = json_decode($so->contact_address);\n		$billing_address .= $address->address1 ? $address->address1 . "<br />"  : '''';\n		$billing_address .= $address->address2 ? $address->address2 . "<br />"  : '''';\n		$billing_address .= $address->zipcode ? $address->zipcode . '' '' : '''';\n		$billing_address .= $address->city ? $address->city . "<br />" : '''';\n		$billing_address .= $address->state ? $address->state . "<br />" : '''';\n		$billing_address .= $address->country ? $address->country : ''''; \n				\n		$address = json_decode($so->delivery_address);\n    	$delivery_address = $address->name ? $address->name . "<br />" : '''';\n    	$delivery_address .= $address->mobile ? ''Contact No: '' . $address->mobile . "<br />"  : '''';\n    	$delivery_address .= $address->address1 ? $address->address1 . "<br />"  : '''';\n    	$delivery_address .= $address->address2 ? $address->address2 . "<br />"  : '''';\n    	$delivery_address .= $address->zipcode ? $address->zipcode . '' '' : '''';\n    	$delivery_address .= $address->city ? $address->city . "<br />"  : '''';\n    	$delivery_address .= $address->state ? $address->state . "<br />"  : '''';\n    	$delivery_address .= $address->country ? $address->country : '''';\n\n	\n		if ($so->warehouse_id){\n			$query = $this->db->query("SELECT * FROM `warehouses` WHERE `id` = ?", array($so->warehouse_id));\n			$warehouse = $query->row();					\n		}\n		\n		$message = $this->__template(nl2br($this->system->config(''online_sales_email_new_order'')),array(\n			''{name}''			=> $contact->contact_person,\n			''{mobile}''			=> $contact->contact_number,\n			''{email}''			=> $contact->email,\n			''{order_no}''		=> $so->id,\n			''{datetime}''		=> date(''j:iA d/m/Y'',strtotime($so->datetime)),\n			''{bill_addr}''		=> $billing_address,\n			''{delivery_addr}''	=> $delivery_address,\n			''{gateway}''			=> $so->gateway,\n			''{shipping}''		=> $so->shipping,\n			''{order_table}''		=> $order_table,\n			''{warehouse}''		=> $warehouse->name,\n			''{status}''			=> $status,\n			''{payment_status}''	=> $payment_status\n		));\n		\n		$message = ''<html><head>'' . $styles . ''</head><body>'' . $message . ''</body></html>'';\n		\n		$subject = $this->__template($this->system->config(''online_sales_email_new_order_subject''),array(\n			''{name}''			=> $contact->contact_person,\n			''{mobile}''			=> $contact->contact_number,\n			''{email}''			=> $contact->email,\n			''{order_no}''		=> $so->id,\n			''{datetime}''		=> date(''j:iA d/m/Y'',strtotime($so->datetime)),\n			''{bill_addr}''		=> $billing_address,\n			''{delivery_addr}''	=> $delivery_address,\n			''{gateway}''			=> $so->gateway,\n			''{shipping}''		=> $so->shipping,\n			''{warehouse}''		=> $warehouse->name,\n			''{status}''			=> $status,\n			''{payment_status}''	=> $payment_status\n		));\n		\n		$message_bo = $this->__template(nl2br($this->system->config(''online_sales_email_new_order_bo'')),array(\n			''{name}''			=> $contact->contact_person,\n			''{mobile}''			=> $contact->contact_number,\n			''{email}''			=> $contact->email,\n			''{order_no}''		=> $so->id,\n			''{datetime}''		=> date(''j:iA d/m/Y'',strtotime($so->datetime)),\n			''{bill_addr}''		=> $billing_address,\n			''{delivery_addr}''	=> $delivery_address,\n			''{gateway}''			=> $so->gateway,\n			''{shipping}''		=> $so->shipping,\n			''{order_table}''		=> $order_table,\n			''{warehouse}''		=> $warehouse->name,\n			''{status}''			=> $status,\n			''{payment_status}''	=> $payment_status\n		));\n		\n		$message_bo = ''<html><head>'' . $styles . ''</head><body>'' . $message_bo . ''</body></html>'';\n		\n		$subject_bo = $this->__template($this->system->config(''online_sales_email_new_order_bo_subject''),array(\n			''{name}''			=> $contact->contact_person,\n			''{mobile}''			=> $contact->contact_number,\n			''{email}''			=> $contact->email,\n			''{order_no}''		=> $so->id,\n			''{datetime}''		=> date(''j:iA d/m/Y'',strtotime($so->datetime)),\n			''{bill_addr}''		=> $billing_address,\n			''{delivery_addr}''	=> $delivery_address,\n			''{gateway}''			=> $so->gateway,\n			''{shipping}''		=> $so->shipping,\n			''{warehouse}''		=> $warehouse->name,\n			''{status}''			=> $status,\n			''{payment_status}''	=> $payment_status\n		));\n\n		\n    	\n    	$config[''protocol''] = ''smtp'';\n    	$config[''mailpath''] = ''/usr/sbin/sendmail'';\n    	$config[''charset''] = ''iso-8859-1'';\n    	$config[''wordwrap''] = TRUE;\n    	$config[''mailtype''] = ''html'';\n    \n    	$config[''smtp_host''] = $this->system->config(''online_sales_responder_hostname'');\n    	$config[''smtp_user''] = $this->system->config(''online_sales_responder_email'');\n    	$config[''smtp_pass''] = $this->system->config(''online_sales_responder_password'');\n    	$config[''smtp_port''] = ''25'';\n\n    	$this->load->library(''email'');		\n    	$this->email->initialize($config);\n\n    	$this->email->from($this->system->config(''online_sales_responder_email''), $this->system->config(''online_sales_responder_name''));\n    	$this->email->to($contact->email);\n    	$this->email->bcc($this->system->config(''online_sales_responder_txn_email''));\n    	$this->email->subject($subject);\n    	$this->email->message($message);\n    	$this->email->send();\n    	\n    	\n    	$this->email->from($this->system->config(''online_sales_responder_email''), $this->system->config(''online_sales_responder_name''));\n    	if ($so->warehouse_id){\n	    	$this->email->to($this->system->config(''online_sales_responder_email'') . '','' . $warehouse->email);\n    	} else {\n	    	$this->email->to($this->system->config(''online_sales_responder_email''));\n    	}\n    	$this->email->bcc(array($this->system->config(''online_sales_responder_txn_email'')));\n    	$this->email->subject($subject_bo);\n    	$this->email->message($message_bo);\n    	$this->email->send();\n\n    	$notification->type 	= ''New Order'';\n    	$notification->datetime	= date(''Y-m-d H:i:s'');\n    	$notification->by		= ''Auto-Responder'';\n    	$notification->status	= $payment_status;\n    	\n    	$notifications[] = $notification;\n  \n  		$this->db->update(''sales_order'', array(\n  			''notification''	=> json_encode($notifications)\n  		), "`id` = ''{$so->id}''");\n\n			\n		$order->order_id		= $order_id;\n		$order->time			= $time;\n		$order->status			= $status;\n		$order->payment_status	= $payment_status;\n		$order->remarks			= $remarks;\n		\n		if ($output == ''json'') echo json_encode($order);\n		\n		\n		\n	\n	}\n	\n	function Get_payment_gateways($output, $args){\n		if ($this->failed) return;\n	\n		$query = $this->db->query("SELECT * FROM `payment_gateways` WHERE `status` = ''Active''");\n		if ($output == ''json'') echo json_encode($query->result());\n	}\n	\n	function Get_payment_gateway_by_id($output, $args){\n		if ($this->failed) return;\n		\n		$id = $this->input->post(''id'');\n		$query = $this->db->query("SELECT * FROM `payment_gateways` WHERE `id` = ?", array($id));\n		\n		if ($output == ''json'') echo json_encode($query->row());\n	}\n	\n	function Get_shipping_services($output, $args){\n		if ($this->failed) return;\n		\n		$query = $this->db->query("SELECT * FROM `shipping`");\n		\n		if ($output == ''json'') echo json_encode($query->result());\n		\n	}\n\n	\n	function Get_shipping_service_by_id($output, $args){\n		if ($this->failed) return;\n		\n		$id = $this->input->post(''id'');\n		$query = $this->db->query("SELECT * FROM `shipping` WHERE `id` = ?", array($id));\n		\n		if ($output == ''json'') echo json_encode($query->row());\n	}\n	\n	function Get_warehouses($output, $args){\n		if ($this->failed) return;\n		\n		$query = $this->db->query("SELECT * FROM `warehouses`");\n		if ($output == ''json'') echo json_encode($query->result());		\n		\n	}\n	\n	function Get_warehouse_by_id($output, $args){\n		if ($this->failed) return;\n				\n		$id = $this->input->post(''id'');\n		$query = $this->db->query("SELECT * FROM `warehouses` WHERE `id` = ?", array($id));\n		if ($output == ''json'') echo json_encode($query->row());	\n	}\n	\n	function Get_delivery_charges($output, $args){\n		if ($this->failed) return;\n		\n		if ($args){\n			$zipcode = $args[''zipcode''];\n			$country = $args[''country''];\n			$service = $args[''service''];\n		} else {\n			$zipcode = $this->input->post(''zipcode'');\n			$country = $this->input->post(''country'');\n			$service = $this->input->post(''service'');\n		}\n		$items = json_decode($this->input->post(''items''));\n		\n		$query = $this->db->query("SELECT * FROM `shipping` WHERE `id` = ?", array($service));\n		$service = $query->row();\n		\n		\n		if ($country == $this->system->config(''country'')){\n			// local zone\n			$query = $this->db->query("SELECT * FROM `shipping_local_zones` WHERE `zipcode_from` <= ? AND `zipcode_to` >= ?", array($zipcode, $zipcode));\n			$zone = $query->row();\n			\n			$query = $this->db->query("SELECT * FROM `shipping_rates` WHERE `service_id` = ? AND `zone_id` = ? AND `zone_type` = ''Local''", array($service->id, $zone->id));\n			$rate = $query->row();\n						\n		} else {\n\n			$query = $this->db->query("SELECT * FROM `shipping_international_zones` WHERE FIND_IN_SET(?, `countries`)", array($country));\n			$zone = $query->row();\n			\n			$query = $this->db->query("SELECT * FROM `shipping_rates` WHERE `service_id` = ? AND `zone_id` = ? AND `zone_type` = ''International''", array($service->id, $zone->id));\n			$rate = $query->row();\n\n		}\n\n		foreach ($items as $item){\n\n			$query = $this->db->query("SELECT * FROM `inventory` WHERE `id` = ?", array($item->id));\n			$xitem = $query->row();\n			\n\n			if ($service->measurements_type == ''Metric''){\n				\n				$item_weight = $this->__convertWeight($xitem->weight, $xitem->weight_unit, ''kg'');\n				$item_volume = $this->__convertVolume($xitem->volume, $xitem->volume_unit, ''cm3'');\n				$item_volumetric_weight = $item_volume / $service->shipping_factor;\n				\n\n				$weight = $item_weight >= $item_volumetric_weight ? $item_weight : $item_volumetric_weight;\n				$weight *= $item->qty;\n				\n			} else {\n				\n				$item_weight = $this->__convertWeight($xitem->weight, $xitem->weight_unit, ''lb'');\n				$item_volume = $this->__convertVolume($xitem->volume, $xitem->volume_unit, ''in3'');\n				$item_volumetric_weight = $item_volume / $service->shipping_factor;\n				\n				$weight = $item_weight >= $item_volumetric_weight ? $item_weight : $item_volumetric_weight;\n				$weight *= $item->qty;\n				\n			}\n			\n			$total_items += $item->qty;\n			$total_weight += $weight;		\n			\n\n			\n			if ($weight <= $rate->first_weight){\n			    $shipping_rate = $rate->flat_rate + $rate->first_weight_rate;\n			} elseif ($weight >= $rate->max_weight_rate){\n			    $shipping_rate = $rate->flat_rate + $rate->max_weight_rate;\n			} else {\n				$subsequent_rate = ceil(($weight - $rate->first_weight) / $rate->subsequent_weight) * $rate->subsequent_weight_rate;\n			    $shipping_rate = $rate->flat_rate + $rate->first_weight_rate + $subsequent_rate;\n			}\n			\n\n			$total_rates += $shipping_rate;\n\n		}\n\n		$data->total_rate = $total_rates;\n		$data->total_weight = $total_weight;\n		$data->total_items = $total_items;\n		$data->weight_unit = $service->measurements_type == ''Metric'' ? ''kg'' : ''lb'';\n		\n		if ($output == ''json'') echo json_encode($data);\n		else return $data;\n		\n	}\n\n	\n	\n	function Get_item_quantity($output, $args){\n		if ($this->failed) return;\n		\n		$warehouse = $args[''warehouse''] ? $args[''warehouse''] : '''';\n		$item_id = $args[''item_id''] ? $args[''item_id''] : '''';\n		\n		if ($warehouse == ''*'' || $warehouse == ''''){\n			$query = $this->db->query("SELECT SUM(`received`) AS `total_inbound` FROM `purchase_order_items` WHERE `item_id` = ?  GROUP BY `item_id`", array($item_id));\n			$inbound = $query->row();			\n			\n			$query = $this->db->query("SELECT SUM(`received`) AS `total_outbound` FROM `debit_note_items` WHERE `item_id` = ? GROUP BY `item_id`", array($item_id));\n			$returned = $query->row();\n			\n			$query = $this->db->query("SELECT SUM(`received`) AS `total_inbound` FROM `credit_note_items` WHERE `item_id` = ? GROUP BY `item_id`", array($item_id));\n			$c_returned = $query->row();\n			\n			$query = $this->db->query("SELECT SUM(`delivered`) AS `total_outbound`, SUM(`qty`) AS `total_to_outbound` FROM `invoice_items` WHERE `item_id` = ? AND `no_do` IS NULL GROUP BY `item_id`", array($item_id));\n			$invoiced = $query->row();\n			\n			$query = $this->db->query("SELECT SUM(`qty`) AS `total_outbound` FROM `sale_items` WHERE `item_id` = ? AND `sold` = 1  GROUP BY `item_id`", array($item_id));\n			$outbound = $query->row();\n\n		} else {\n			$query = $this->db->query("SELECT SUM(`qty`) AS `total_inbound` FROM `warehouse_movement_items` WHERE `item_id` = ? AND `to_warehouse` = ? GROUP BY `item_id`", array($item_id, $warehouse));\n			$inbound_movement = $query->row();\n			\n			$query = $this->db->query("SELECT SUM(`received`) AS `total_inbound` FROM `purchase_order_items` WHERE `item_id` = ? AND `warehouse_id` = ? GROUP BY `item_id`", array($item_id, $warehouse));\n			$inbound_po = $query->row();			\n			\n			$inbound->total_inbound = $inbound_movement->total_inbound + $inbound_po->total_inbound;\n			\n			$query = $this->db->query("SELECT SUM(`received`) AS `total_outbound` FROM `debit_note_items` WHERE `item_id` = ? AND `warehouse_id` = ? GROUP BY `item_id`", array($item_id, $warehouse));\n			$returned = $query->row();\n			\n			$query = $this->db->query("SELECT SUM(`received`) AS `total_inbound` FROM `credit_note_items` WHERE `item_id` = ? AND `warehouse_id` = ? GROUP BY `item_id`", array($item_id, $warehouse));\n			$c_returned = $query->row();\n			\n			$query = $this->db->query("SELECT SUM(`delivered`) AS `total_outbound`, SUM(`qty`) AS `total_to_outbound` FROM `invoice_items` WHERE `item_id` = ? AND `warehouse_id` = ? AND `no_do` IS NULL GROUP BY `item_id`", array($item_id, $warehouse));\n			$invoiced = $query->row();\n			\n			$query = $this->db->query("SELECT SUM(`qty`) AS `total_outbound` FROM `sale_items` WHERE `item_id` = ? AND `warehouse_id` = ? AND `sold` = 1  GROUP BY `item_id`", array($item_id, $warehouse));\n			$outbound = $query->row();\n		}\n		\n\n		$qty = $inbound->total_inbound - $outbound->total_outbound - $invoiced->total_to_outbound - $returned->total_outbound + $c_returned->total_inbound;\n		\n		$data->qty = $qty;\n		\n		if ($output == ''json'') echo json_encode($data);\n		else return $qty;\n	}\n\n	function Register_fb_user($output, $args){\n		if ($this->failed) return;\n		\n		$userdata = json_decode($this->input->post(''userdata''));\n		\n		$query = $this->db->query("SELECT * FROM `contacts` WHERE `facebook_id` = ?", array($userdata->id));\n		if ($query->num_rows()){\n\n			$session = $username . time();\n			$this->db->query("UPDATE `contacts` SET `current_session` = ? WHERE `facebook_id` = ?", array($session, $userdata->id));\n			\n			$data->data = $session;	\n\n			if ($output == ''json'') echo json_encode($data);\n\n		} else {\n			$this->db->insert(''contacts'', array(\n				''is_customer''		=> 1,\n				''contact_person''	=> $userdata->first_name . '' '' . $userdata->last_name,\n				''contact_number''	=> $this->input->post(''mobile''),\n				''address1''			=> $this->input->post(''address1''),\n				''address2''			=> $this->input->post(''address2''),\n				''city''				=> $this->input->post(''city''),\n				''state''				=> $this->input->post(''state''),\n				''zipcode''			=> $this->input->post(''zipcode''),\n				''country''			=> $this->input->post(''country''),\n				''email''				=> $this->input->post(''email''),\n				''password''			=> $this->input->post(''password''),\n				''added_on''			=> date(''Y-m-d H:i:s''),\n				''added_by''			=> ''@Plexcart'',\n				''tags''				=> ''Online Customer,Facebook User,Unverified''\n			));\n			\n			$data->data = ''ok'';\n			if ($output == ''json'') echo json_encode($data);\n		}\n		\n		$username = $this->input->post(''username'');\n		$password = $this->input->post(''password'');\n\n		$query = $this->db->query("SELECT * FROM `contacts` WHERE `email` = ?", array($username));\n		$customer = $query->row();\n		\n		if ($password == $customer->password){\n		\n			$session = $username . time();\n			$this->db->query("UPDATE `contacts` SET `current_session` = ? WHERE `email` = ?", array($session, $username));\n			\n			$data->data = $session;	\n		\n			if ($output == ''json'') echo json_encode($data);\n		} else {\n		\n			$data->data = ''incorrect'';	\n			if ($output == ''json'') echo json_encode($data);\n			\n		}\n		\n\n		if ($output == ''json'') echo json_encode($data);\n		else return $data;\n		\n	}\n	\n	function Uses_fb_login($output, $args){\n		if ($this->failed) return;\n		\n		$data->enabled = $this->system->config(''online_sales_fb_login'');\n		$data->fb_app_id = $this->system->config(''online_sales_fb_app_id'');\n		$data->fb_app_secret = $this->system->config(''online_sales_fb_app_secret'');\n\n		if ($output == ''json'') echo json_encode($data);\n		else return $data;\n		\n	}\n	\n	function Price_rules($output, $args){\n		if ($this->failed) return;\n		\n		$data->rules = json_encode($this->system->config(''price_rules''));\n		\n		if ($output == ''json'') echo json_encode($data);\n		else return $data;		\n	}\n	\n	function Member_tnc($output, $args){\n		if ($this->failed) return;	\n		\n		$data->tnc = $this->system->config(''member_tnc'');\n\n		if ($output == ''json'') echo json_encode($data);\n		else return $data;\n	}\n	\n	function Request_password_reset($output, $args){\n		if ($this->failed) return;\n		\n		$email	= $this->input->post(''email'');\n		$mobile = $this->input->post(''mobile'');\n		\n		$query = $this->db->query("SELECT * FROM `contacts` WHERE `email` = ? AND `contact_number` = ?", array($email, $mobile));\n		\n		if ($query->num_rows()){\n		\n			$user = $query->row();\n\n			$config[''protocol''] = ''smtp'';\n	    	$config[''mailpath''] = ''/usr/sbin/sendmail'';\n	    	$config[''charset''] = ''iso-8859-1'';\n	    	$config[''wordwrap''] = TRUE;\n	    	$config[''mailtype''] = ''html'';\n	    \n	    	$config[''smtp_host''] = $this->system->config(''online_sales_responder_hostname'');\n	    	$config[''smtp_user''] = $this->system->config(''online_sales_responder_email'');\n	    	$config[''smtp_pass''] = $this->system->config(''online_sales_responder_password'');\n	    	$config[''smtp_port''] = ''25'';\n	\n	    	$this->load->library(''email'');		\n	    	$this->email->initialize($config);\n	    	\n	    	$temp_pass = mt_rand(100,999) . mt_rand(10,99) . mt_rand(100,999);;\n	    	\n	    	$this->db->update(''contacts'', array(\n	    		''password''		=> md5($temp_pass)\n	    	), "`id` = ''{$user->id}''");\n	    	\n	    	$message = $this->__template(nl2br($this->system->config(''online_sales_email_password_reset'')), array(\n	    		''{name}''		=> $user->contact_person,\n	    		''{email}''		=> $user->email,\n	    		''{temp_pass}''	=> $temp_pass\n	    	));\n	\n	    	$this->email->from($this->system->config(''online_sales_responder_email''), $this->system->config(''online_sales_responder_name''));\n	    	$this->email->to($user->email);\n	    	$this->email->bcc($this->system->config(''online_sales_responder_txn_email''));\n	    	$this->email->subject($this->system->config(''online_sales_email_password_reset_subject''));\n	    	$this->email->message($message);\n	    	$this->email->send();\n	    	\n	    	$data->data = ''ok'';\n    	\n    	} else {\n	    	\n	    	$data->data = ''failed'';\n	    	\n    	}\n		\n		\n		if ($output == ''json'') echo json_encode($data);\n		else return $data;\n		\n	}\n	\n	function Reset_password(){\n		\n	}\n	\n	function __convertWeight($value, $from, $to){\n		$unit_ratios = array(\n			''g''		=> 1,\n			''kg''	=> 0.001,\n			''oz''	=> 0.035273962,\n			''lb''	=> 0.0022046226\n		);\n		\n		return ($value / $unit_ratios[$from]) * $unit_ratios[$to];\n	}\n	\n	function __convertVolume($value, $from, $to){\n		$unit_ratios = array(\n			''cm3''	=> 1,\n			''l''		=> 0.001,\n			''in3''	=> 0.0610237441\n		);\n		return ($value / $unit_ratios[$from]) * $unit_ratios[$to];\n	}\n	\n	function __template($template, $data){\n	\n		foreach ($data as $key => $value){\n			$template = str_replace($key, $value, $template);\n		}\n	\n		return $template;\n	}\n\n}', '2012-12-07 10:57:23', 'admin', NULL),
(64, 10, '/var/www/jhs/demo/cart/interface/no-layout.php', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\n<html>\n	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />\n	<head>\n		<title><?=$title?></title>\n		<?=$headers?>\n	</head>\n	<body>\n	<div id="container">\n		<h1>Layout Missing</h1>\n		<p>The layout of this page appears to be missing. You may update the layout by editing this page</p>\n	</body>\n</html>', '2012-12-07 17:44:14', 'admin', NULL);
INSERT INTO `editor_revisions` (`id`, `profile_id`, `item`, `contents`, `datetime`, `user`, `commit`) VALUES
(65, 10, '/var/www/jhs/demo/cart/interface/revisions-manager.php', '<script type="text/javascript">\n\n$(document).ready(function(){\n	$(''table.lcms-revisions-table tbody tr'').click(function(){\n		$(''table.lcms-revisions-table tbody tr'').removeClass(''current'');\n		$(this).addClass(''current'');\n		\n		var id = $(this).attr(''rel'');\n		\n		$(lcmsCurrentItem).html(''<div style="text-align: center;"><img src="images/loader.gif" /></div>'');\n		lcmsContentSpotlight();\n		\n		lcmsPreviewRevision(id);\n		\n		\n	});\n	\n	$(''a.lcms-revisions-commit'').click(function(){\n		var current, published;\n		$(''input.lcms-revision-current'').each(function(){\n			if ($(this).attr(''checked'')) current = $(this).val();\n		});\n\n		$(''input.lcms-revision-published'').each(function(){\n			if ($(this).attr(''checked'')) published = $(this).val();\n		});\n			\n		$(lcmsCurrentItem).html(''<div style="text-align: center;"><img src="images/loader.gif" /></div>'');\n		\n		$.ajax({\n			url: base_url + ''page/ajax/commit_revision'',\n			type: ''post'',\n			data: ''current=''+current+''&published=''+published,\n			success: function (res){\n\n				lcmsPreviewRevision(current, true);\n				\n			}\n		})\n	});\n	\n	\n});\n\nfunction lcmsPreviewRevision(id, commit){\n	$.ajax({\n		url: base_url + ''page/ajax/get_content_by_id'',\n		type: ''post'',\n		data: ''id='' + id,\n		success: function(html){\n			if (commit){\n				var newItem = $(html);\n				$(lcmsCurrentItem).replaceWith(newItem);\n				lcmsCurrentItem = newItem;\n\n			} else {\n				$(lcmsCurrentItem).html($(html).html());\n			}\n			lcmsContentSpotlight();\n		}\n			\n	});\n}\n\n\n</script>\n\n	<table class="lcms-revisions-table">\n		<thead>\n			<tr>\n				<th>Revision Date/Time</th>\n				<th style="width: 80px">Current</th>\n				<th style="width: 80px">Published</th>\n				<th style="width: 8px; padding: 0"></th>\n			</tr>\n		</thead>\n	</table>\n	<form>\n	<div style="height: 200px; padding-bottom: 5px; overflow-y: scroll; background: #FFF;">\n		<table class="lcms-revisions-table">\n			<tbody>\n				<?php foreach ($revisions as $revision): ?>\n				<tr rel="<?php echo $revision->id; ?>">\n					<td><?php echo date(''n:iA j F, Y'', strtotime($revision->datetime)); ?></td>\n					<td style="width: 80px; text-align: center"><input type="radio" value="<?php echo $revision->id; ?>" class="lcms-revision-current" name="current" <?php if ($revision->current) echo ''checked="checked"''; ?> /></td>\n					<td style="width: 80px; text-align: center"><input type="radio" value="<?php echo $revision->id; ?>" class="lcms-revision-published" name="published" <?php if ($revision->published) echo ''checked="checked"''; ?> /></td>\n				</tr>\n				<?php endforeach; ?>\n			</tbody>\n		</table>\n\n\n	</div>\n	<br />\n	<a class="lcms-dbtn lcms-revisions-commit">Commit Changes</a>\n	</form>', '2012-12-07 17:44:16', 'admin', NULL),
(66, 10, '/var/www/jhs/demo/cart/interface/theme_editor.php', '\n<html>\n<head>\n	<base href="<?=base_url()?>" />\n	<title>Theme Editor</title>\n	<script type="text/javascript" src="js/jquery.js"></script>\n	<script type="text/javascript" src="js/jqueryui.js"></script>\n	<script type="text/javascript" src="js/theme.js"></script>\n	<script type="text/javascript" src="js/colorpicker.js"></script>\n    <script type="text/javascript" src="js/eye.js"></script>\n    <script type="text/javascript" src="js/utils.js"></script>\n    <script type="text/javascript" src="js/layout.js?ver=1.0.2"></script>\n	<link rel="stylesheet" href="css/colorpicker.css" type="text/css" />\n    <link rel="stylesheet" media="screen" type="text/css" href="css/layout.css" />\n\n	<link rel="stylesheet" href="css/ui-lightness/jquery-ui-1.7.2.custom.css"/>\n	<link rel="stylesheet" href="css/buttons.css"/>\n	<link rel="stylesheet" href="css/theme.css"/>\n	<style>\n	<?=str_replace(''body {'',"#editor-canvas {",$css)?>\n	</style>\n\n</head>\n<body>\n<a class="lcms-btn" style="float:right; margin: 5px;" href="<?=base_url()?>/admin/view_theme/<?=$theme_id?>">Back</a>\n<h1 style="text-align:left"> Layout Creator</h1>\n\n<div id="editor-canvas" style="margin: 10px;">\n	<?=$html?>\n</div>\n\n\n\n<div id="controls" style="float:right; position:absolute; right: 10px; top: 50px" class="ui-widget-content">\n	<h3 class="ui-widget-header">Toolbar</h3>\n	<p>\n		<button class="lcms-btn new-row">+ Row</button>\n		<button class="lcms-btn new-left-column">+ Left Column</button>\n		<button class="lcms-btn new-right-column">+ Right Column</button>\n	</p>\n	<p>\n		<form method="post" action="<?=base_url()?>admin/save_layout">\n			<textarea name="html" style="padding: 0; margin: 0; height: 1px; width: 1px; visibility:hidden"></textarea>\n			<textarea name="css" style="padding: 0; margin: 0; height: 1px; width: 1px; visibility:hidden"></textarea><br />\n			<input type="hidden" name="theme_id" value="<?=$theme_id?>" />\n			<input type="hidden" name="layout_id" value="<?=$layout_id?>" />\n			Layout Name <input style="width: 100px" type="text" name="layout_name" value="<?=$layout_name?>" />\n			<button class="lcms-btn export">Save</button>\n		</form>\n	</p>\n	<fieldset>\n		<legend>Canvas</legend>\n			<p>\n				<span style="float:right">\n					<select class="canvas-image">\n						<option>none</option>\n						<?php foreach($images as $image): ?>\n						<option value="<?=base_url()?>media/<?=$image->name?>"><?=$image->name?></option>\n						<?php endforeach; ?>\n					</select>\n				</span>\n				Image\n			<p>\n			<p>	\n				<span style="float:right">\n					<select class="canvas-repeat">\n						<option value="no-repeat">No Repeat</option>\n						<option value="repeat-x">Repeat X Axis</option>\n						<option value="repeat-y">Repeat Y Axis</option>\n						<option value="repeat">Repeat Both</option>\n					</select>\n				</span>\n				Repeat\n			</p>\n			<p>	\n				<span style="float:right">\n					<select class="canvas-position">\n						<option value="top">Top</option>\n						<option value="top left">Top Left</option>\n						<option value="top right">Top Right</option>\n						<option value="bottom">Bottom</option>\n						<option value="bottom left">Bottom Left</option>\n						<option value="bottom right">Bottom Right</option>\n						<option value="center">Center</option>\n						<option value="center top">Center Top</option>\n						<option value="center bottom">Center Bottom</option>\n						<option value="middle">Middle</option>\n						<option value="middle left">Middle Left</option>\n						<option value="middle right">Middle Right</option>\n					</select>\n				</span>\n				Position\n			</p>	\n			<p><span style="float:right"><input class="canvas-color px" value="0" />#</span>Color<p>\n			<p><span style="float:right"><input class="canvas-height px" value="400" />px</span>Height</p>\n			<p><span style="float:right"><input class="canvas-width px" value="800" />px</span>Width<p>\n			<p><span style="float:right"><input class="canvas-top-margin px" value="10" />px</span>Top Margin<p>\n			<p><span style="float:right"><input class="canvas-bottom-margin px" value="10" />px</span>Bottom Margin<p>\n			<p><span style="float:right"><input class="canvas-left-margin px" value="10" />px</span>Left Margin<p>\n			<p><span style="float:right"><input class="canvas-right-margin px" value="10" />px</span>Right Margin<p>\n	</fieldset>\n	<fieldset>\n		<legend>Section</legend>\n			<p><span style="float:right"><input class="padding-top px" value="0" />px</span>Top Padding</p>\n			<p><span style="float:right"><input class="padding-right px" value="0" />px</span>Right Padding<p>\n			<p><span style="float:right"><input class="padding-bottom px" value="0" />px</span>Bottom Padding<p>\n			<p><span style="float:right"><input class="padding-left px" value="0" />px</span>Left Padding<p>\n			<p>\n				<span style="float:right">\n					<select class="font">\n						<option value="Arial">Arial</option>\n						<option value="Comic Sans">Comic Sans</option>\n						<option value="Courier New">Courier New</option>\n						<option value="Georgia">Georgia</option>\n						<option value="Helvetica">Helvetica</option>\n						<option value="Impact">Impact</option>\n						<option value="Times">Times</option>\n						<option value="Trebuchet">Trebuchet</option>\n						<option value="Verdana">Verdana</option>\n					</select>\n				</span>\n				Font<p>\n	</fieldset>\n	<fieldset>\n		<legend>Background</legend>\n		<p>\n			<span style="float:right">\n				<select class="image">\n					<option>none</option>\n					<?php foreach($images as $image): ?>\n					<option value="<?=base_url()?>media/<?=$image->name?>"><?=$image->name?></option>\n					<?php endforeach; ?>\n				</select>\n			</span>\n			Image\n		<p>\n		<p><span style="float:right"><input class="color px" value="0" />#</span>Color<p>\n		<p><span style="float:right"><input class="text-color px" value="0" />#</span>Text Color<p>\n		<p>	\n			<span style="float:right">\n				<select class="repeat">\n					<option value="no-repeat">No Repeat</option>\n					<option value="repeat-x">Repeat X Axis</option>\n					<option value="repeat-y">Repeat Y Axis</option>\n					<option value="repeat">Repeat Both</option>\n				</select>\n			</span>\n			Repeat\n		</p>\n		<p>	\n			<span style="float:right">\n				<select class="position">\n					<option value="top">Top</option>\n					<option value="top left">Top Left</option>\n					<option value="top right">Top Right</option>\n					<option value="bottom">Bottom</option>\n					<option value="bottom left">Bottom Left</option>\n					<option value="bottom right">Bottom Right</option>\n					<option value="center">Center</option>\n					<option value="center top">Center Top</option>\n					<option value="center bottom">Center Bottom</option>\n					<option value="middle">Middle</option>\n					<option value="middle left">Middle Left</option>\n					<option value="middle right">Middle Right</option>\n				</select>\n			</span>\n			Position\n		</p>\n		<p><span style="float:right"><input class="x-offset px" value="0" />px</span>X Offset<p>\n		<p><span style="float:right"><input class="y-offset px" value="0" />px</span>Y Offset<p>\n	</fieldset>\n</div>\n\n\n</body>\n</html>', '2012-12-07 17:44:19', 'admin', NULL),
(67, 10, '/var/www/jhs/test.php', 'asdas', '2012-12-07 17:45:18', 'admin', NULL),
(68, 10, NULL, 'asdas\n\nasd\nas\ndas\ndas\nd\nas', '2012-12-07 17:45:31', 'admin', NULL),
(69, 10, '/var/www/jhs/os/index.php', '<?php\n\n/*\n|---------------------------------------------------------------\n| PHP ERROR REPORTING LEVEL\n|---------------------------------------------------------------\n|\n| By default CI runs with error reporting set to ALL.  For security\n| reasons you are encouraged to change this when your site goes live.\n| For more info visit:  http://www.php.net/error_reporting\n|\n*/\n	error_reporting(E_ERROR);\n\n/*\n|---------------------------------------------------------------\n| SYSTEM FOLDER NAME\n|---------------------------------------------------------------\n|\n| This variable must contain the name of your "system" folder.\n| Include the path if the folder is not in the same  directory\n| as this file.\n|\n| NO TRAILING SLASH!\n|\n*/\n	$system_folder = "system";\n\n/*\n|---------------------------------------------------------------\n| APPLICATION FOLDER NAME\n|---------------------------------------------------------------\n|\n| If you want this front controller to use a different "application"\n| folder then the default one you can set its name here. The folder \n| can also be renamed or relocated anywhere on your server.\n| For more info please see the user guide:\n| http://codeigniter.com/user_guide/general/managing_apps.html\n|\n|\n| NO TRAILING SLASH!\n|\n*/\n	$application_folder = "application";\n\n/*\n|===============================================================\n| END OF USER CONFIGURABLE SETTINGS\n|===============================================================\n*/\n\n\n/*\n|---------------------------------------------------------------\n| SET THE SERVER PATH\n|---------------------------------------------------------------\n|\n| Let''s attempt to determine the full-server path to the "system"\n| folder in order to reduce the possibility of path problems.\n| Note: We only attempt this if the user hasn''t specified a \n| full server path.\n|\n*/\nif (strpos($system_folder, ''/'') === FALSE)\n{\n	if (function_exists(''realpath'') AND @realpath(dirname(__FILE__)) !== FALSE)\n	{\n		$system_folder = realpath(dirname(__FILE__)).''/''.$system_folder;\n	}\n}\nelse\n{\n	// Swap directory separators to Unix style for consistency\n	$system_folder = str_replace("\\\\", "/", $system_folder); \n}\n\n/*\n|---------------------------------------------------------------\n| DEFINE APPLICATION CONSTANTS\n|---------------------------------------------------------------\n|\n| EXT		- The file extension.  Typically ".php"\n| SELF		- The name of THIS file (typically "index.php")\n| FCPATH	- The full server path to THIS file\n| BASEPATH	- The full server path to the "system" folder\n| APPPATH	- The full server path to the "application" folder\n|\n*/\ndefine(''EXT'', ''.php'');\ndefine(''SELF'', pathinfo(__FILE__, PATHINFO_BASENAME));\ndefine(''FCPATH'', str_replace(SELF, '''', __FILE__));\ndefine(''BASEPATH'', $system_folder.''/'');\n\nif (is_dir($application_folder))\n{\n	define(''APPPATH'', $application_folder.''/'');\n}\nelse\n{\n	if ($application_folder == '''')\n	{\n		$application_folder = ''application'';\n	}\n\n	define(''APPPATH'', BASEPATH.$application_folder.''/'');\n}\n\n/*\n|---------------------------------------------------------------\n| LOAD THE FRONT CONTROLLER\n|---------------------------------------------------------------\n|\n| And away we go...\n|\n*/\nrequire_once BASEPATH.''codeigniter/CodeIgniter''.EXT;\n\n/* End of file index.php */\n/* Location: ./index.php */', '2012-12-07 17:45:34', 'admin', NULL),
(70, 10, NULL, 'asdasasd\nas\nd\nad\nasd\nasd', '2012-12-07 17:45:46', 'admin', NULL),
(71, 10, NULL, 'asdasasdASdasda\n\na\nsd\nasd\nas\ndas\nda\nsd', '2012-12-07 17:46:12', 'admin', NULL),
(72, 5, '/var/www/_dev/plexcloud/manager/.htaccess', 'RewriteEngine On\nRewriteCond %{REQUEST_URI} ^system.*\nRewriteRule ^(.*)$ /index.php/$1 [L,QSA]\nRewriteCond %{REQUEST_FILENAME} !-f\nRewriteCond %{REQUEST_FILENAME} !-d\nRewriteRule ^(.*)$ index.php/$1 [L]', '2012-12-27 10:48:14', 'admin', NULL),
(73, 10, '/var/www/jhs/manager/index.php', '<?php\n\n$_SERVER[''QUERY_STRING''] = preg_replace(''/&.*/'','''',$_SERVER[''QUERY_STRING'']);\n/*\n|---------------------------------------------------------------\n| PHP ERROR REPORTING LEVEL\n|---------------------------------------------------------------\n|\n| By default CI runs with error reporting set to ALL.  For security\n| reasons you are encouraged to change this when your site goes live.\n| For more info visit:  http://www.php.net/error_reporting\n|\n*/\n	error_reporting(E_ERROR);\n\n/*\n|---------------------------------------------------------------\n| SYSTEM FOLDER NAME\n|---------------------------------------------------------------\n|\n| This variable must contain the name of your "system" folder.\n| Include the path if the folder is not in the same  directory\n| as this file.\n|\n| NO TRAILING SLASH!\n|\n*/\n	$system_folder = "system";\n\n/*\n|---------------------------------------------------------------\n| APPLICATION FOLDER NAME\n|---------------------------------------------------------------\n|\n| If you want this front controller to use a different "application"\n| folder then the default one you can set its name here. The folder \n| can also be renamed or relocated anywhere on your server.\n| For more info please see the user guide:\n| http://codeigniter.com/user_guide/general/managing_apps.html\n|\n|\n| NO TRAILING SLASH!\n|\n*/\n	$application_folder = "application";\n\n/*\n|===============================================================\n| END OF USER CONFIGURABLE SETTINGS\n|===============================================================\n*/\n\n\n/*\n|---------------------------------------------------------------\n| SET THE SERVER PATH\n|---------------------------------------------------------------\n|\n| Let''s attempt to determine the full-server path to the "system"\n| folder in order to reduce the possibility of path problems.\n| Note: We only attempt this if the user hasn''t specified a \n| full server path.\n|\n*/\nif (strpos($system_folder, ''/'') === FALSE)\n{\n	if (function_exists(''realpath'') AND @realpath(dirname(__FILE__)) !== FALSE)\n	{\n		$system_folder = realpath(dirname(__FILE__)).''/''.$system_folder;\n	}\n}\nelse\n{\n	// Swap directory separators to Unix style for consistency\n	$system_folder = str_replace("\\\\", "/", $system_folder); \n}\n\n/*\n|---------------------------------------------------------------\n| DEFINE APPLICATION CONSTANTS\n|---------------------------------------------------------------\n|\n| EXT		- The file extension.  Typically ".php"\n| SELF		- The name of THIS file (typically "index.php")\n| FCPATH	- The full server path to THIS file\n| BASEPATH	- The full server path to the "system" folder\n| APPPATH	- The full server path to the "application" folder\n|\n*/\ndefine(''EXT'', ''.php'');\ndefine(''SELF'', pathinfo(__FILE__, PATHINFO_BASENAME));\ndefine(''FCPATH'', str_replace(SELF, '''', __FILE__));\ndefine(''BASEPATH'', $system_folder.''/'');\n\nif (is_dir($application_folder))\n{\n	define(''APPPATH'', $application_folder.''/'');\n}\nelse\n{\n	if ($application_folder == '''')\n	{\n		$application_folder = ''application'';\n	}\n\n	define(''APPPATH'', BASEPATH.$application_folder.''/'');\n}\n\n/*\n|---------------------------------------------------------------\n| LOAD THE FRONT CONTROLLER\n|---------------------------------------------------------------\n|\n| And away we go...\n|\n*/\nrequire_once BASEPATH.''codeigniter/CodeIgniter''.EXT;\n\n/* End of file index.php */\n/* Location: ./index.php */', '2013-01-22 21:20:40', 'admin2', NULL),
(74, 10, '/var/www/jhs/manager/application/libraries/index.html', '<html>\n<head>\n	<title>403 Forbidden</title>\n</head>\n<body>\n\n<p>Directory access is forbidden.</p>\n\n</body>\n</html>', '2013-02-19 16:50:15', 'admin2', NULL);

-- --------------------------------------------------------

--
-- Table structure for table `editor_sessions`
--

CREATE TABLE `editor_sessions` (
  `id` int(11) UNSIGNED NOT NULL,
  `profile_id` int(11) DEFAULT NULL,
  `username` varchar(128) DEFAULT NULL,
  `last_change` varchar(128) DEFAULT NULL,
  `item` text
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `editor_sessions`
--

INSERT INTO `editor_sessions` (`id`, `profile_id`, `username`, `last_change`, `item`) VALUES
(1, 1, 'admin', '1352282560', '/var/www/_dev/os/application/errors/error_general.php'),
(2, 1, 'admin', '1352283116', '/var/www/_dev/manager/css/main.css'),
(3, 1, 'admin', '1352283553', '/var/www/_dev/manager/css/email.css'),
(4, 1, 'admin', '1352283555', '/var/www/_dev/manager/css/autocomplete.css'),
(5, 1, 'admin', '1352283560', '/var/www/_dev/manager/css/jquery.timeentry.css'),
(6, 1, 'admin', '1352283585', '/var/www/_dev/manager/css/close.gif'),
(7, 1, 'admin', '1352283602', '/var/www/_dev/os/application/controllers/api.php'),
(8, 1, 'admin', '1352283606', '/var/www/_dev/os/application/controllers/plexports.php'),
(9, 1, 'admin', '1352283606', '/var/www/_dev/os/application/controllers/cartapi.php'),
(10, 1, 'admin', '1352283607', '/var/www/_dev/os/application/controllers/pos.php'),
(11, 1, 'admin', '1352283614', '/var/www/_dev/os/application/controllers/receipt.php'),
(12, 1, 'admin', '1352283625', '/var/www/_dev/os/application/controllers/iphone.php'),
(13, 1, 'admin', '1352283882', '/var/www/_dev/os/application/libraries/index.html'),
(14, 1, 'admin', '1352283892', '/var/www/_dev/os/application/config/index.html'),
(15, 1, 'admin', '1352283893', '/var/www/_dev/os/application/config/database.php'),
(16, 1, 'admin', '1352283911', '/var/www/_dev/os/application/config/doctypes.php'),
(17, 1, 'admin', '1352283912', '/var/www/_dev/os/application/config/hooks.php'),
(18, 1, 'admin', '1352283913', '/var/www/_dev/os/application/config/user_agents.php'),
(19, 1, 'admin', '1352284038', '/var/www/_dev/os/application/config/hooks.php'),
(20, 1, 'admin', '1352284039', '/var/www/_dev/os/application/config/doctypes.php'),
(21, 1, 'admin', '1352284042', '/var/www/_dev/os/application/config/database.php'),
(22, 1, 'admin', '1352284892', '/var/www/_dev/manager/js/jquery.jqplot.min.js'),
(23, 1, 'admin', '1352284899', '/var/www/_dev/manager/js/jquery1.4.2.js'),
(24, 1, 'admin', '1352284911', '/var/www/_dev/manager/sql/tables.sql'),
(25, 1, 'admin', '1352285150', '/var/www/_dev/manager/index.php'),
(26, 1, 'admin', '1352285174', '/var/www/_dev/manager/js/chili.js'),
(27, 1, 'admin', '1352285178', '/var/www/_dev/manager/js/antiscroll.js'),
(28, 1, 'admin', '1352285186', '/var/www/_dev/manager/js/controller.js'),
(29, 1, 'admin', '1352285198', '/var/www/_dev/manager/js/window.js'),
(30, 1, 'admin', '1352285205', '/var/www/_dev/manager/js/editor.js'),
(31, 1, 'admin', '1352285208', '/var/www/_dev/manager/js/email.js'),
(32, 1, 'admin', '1352285220', '/var/www/_dev/manager/js/validator.js'),
(33, 1, 'admin', '1352285443', '/var/www/_dev/os/application/language/english/index.html'),
(34, 1, 'admin', '1352285473', '/var/www/_dev/os/application/views/fnb/iphone.php'),
(35, 1, 'admin', '1352286819', '/var/www/_dev/os/js/fnb/session.js'),
(36, 1, 'admin', '1352286822', '/var/www/_dev/os/js/fnb/iphone-interactions.js'),
(37, 1, 'admin', '1352286823', '/var/www/_dev/os/js/fnb/iphone-webframework.js'),
(38, 1, 'admin', '1352294804', '/var/www/_dev/os/js/fnb/iphone-interactions.js'),
(39, 1, 'admin', '1352294808', '/var/www/_dev/os/js/fnb/shake.js'),
(40, 1, 'admin', '1352294822', '/var/www/_dev/os/js/fnb/iscroll.js'),
(41, NULL, 'admin', '1421969424', 'scratchpad'),
(42, 2, 'admin', '1352560243', '/var/www/manager/sql/tables.sql'),
(43, 2, 'admin', '1352560330', '/var/www/demo/cart/interface/themes.php'),
(44, 2, 'admin', '1352560331', '/var/www/demo/cart/interface/users.php'),
(45, 2, 'admin', '1352560331', '/var/www/demo/cart/interface/view_theme.php'),
(46, 3, 'admin', '1352560446', '/var/www/plexsvn_linker.php'),
(47, 2, 'admin', '1352560469', '/var/www/_dev/plexcms/themes/acc/logo.png'),
(48, 2, 'admin', '1352560473', '/var/www/_dev/plexcms/themes/acc/other.php'),
(49, 2, 'admin', '1352560555', '/var/www/_dev/plexcms/views/no-layout.php'),
(50, 2, 'admin', '1352560556', '/var/www/_dev/plexcms/views/file.php'),
(51, 2, 'admin', '1352560557', '/var/www/_dev/plexcms/views/theme_editor.php'),
(52, 2, 'admin', '1352560608', '/var/www/_dev/plexcms/views/theme_new.php'),
(53, 2, 'admin', '1352561936', '/var/www/_dev/plexcms/interface/header.php'),
(54, 2, 'admin', '1352561942', '/var/www/_dev/plexcms/interface/four-o-four.php'),
(55, 2, 'admin', '1352561945', '/var/www/_dev/plexcms/interface/reset_failed.php'),
(56, 2, 'admin', '1352562255', '/var/www/_dev/plexcms/interface/file.php'),
(57, 5, 'admin', '1352616672', '/var/www/_dev/plexcloud/manager/css/print.css'),
(58, 5, 'admin', '1352616674', '/var/www/_dev/plexcloud/manager/css/autocomplete.css'),
(59, 5, 'admin', '1352616711', '/var/www/_dev/plexcloud/sw_unpatch.pl'),
(60, 5, 'admin', '1352616860', '/var/www/_dev/plexcloud/manager/css/images/cell_label_bg.png'),
(61, 5, 'admin', '1352616972', '/var/www/_dev/plexcloud/sw_unpatch.pl'),
(62, 5, 'admin', '1352617482', '/var/www/_dev/plexcloud/os/css/fnb/input.css'),
(63, 7, 'admin', '1352946567', '/var/www/manager/application/controllers/editor.php'),
(64, 7, 'admin', '1353392412', '/var/www/_versions/info'),
(65, 7, 'admin', '1353392417', '/var/www/index.php'),
(66, 7, 'admin', '1353392539', '/var/www/_versions/info'),
(67, 7, 'admin', '1353392558', '/var/www/_versions/app/7d6419c0c7fc8f7390235e99ccb8d298/vanilla.zip'),
(68, 5, 'admin', '1353392905', '/var/www/_dev/plexcloud/sw_patch.pl'),
(69, 5, 'admin', '1353392969', '/var/www/_dev/plexcloud/sw_unpatch.pl'),
(70, NULL, 'admin', '1353394587', '/sw_patch.pla'),
(71, NULL, 'admin', '1353394589', '/sw_patch.pla'),
(72, NULL, 'admin', '1353394591', '/sw_patch.pla'),
(73, NULL, 'admin', '1353394617', '/test.php'),
(74, NULL, 'admin', '1353394619', '/test.php'),
(75, NULL, 'admin', '1353394714', '/test.php'),
(76, NULL, 'admin', '1353394725', '/test.php'),
(77, NULL, 'admin', '1353394744', '/test.php'),
(78, NULL, 'admin', '1353394802', '/test.php'),
(79, NULL, 'admin', '1353394804', '/test.php'),
(80, NULL, 'admin', '1353395884', '/test.php'),
(81, 5, 'admin', '1353395893', '/var/www/_dev/plexcloud/test.php'),
(82, 5, 'admin', '1353395897', '/var/www/_dev/plexcloud/e649bdb701fbd6e8e25b7c84feb79016.php'),
(83, 5, 'admin', '1353396638', '/var/www/_dev/plexcloud/asdasdasd'),
(84, 5, 'admin', '1353396710', '/var/www/_dev/plexcloud/sw_patch.pl'),
(85, 5, 'admin', '1353396713', '/var/www/_dev/plexcloud/e649bdb701fbd6e8e25b7c84feb79016.php'),
(86, 5, 'admin', '1353397064', '/var/www/_dev/plexcloud/sw_patch.pl'),
(87, NULL, 'admin', '1353397763', '/bla.php'),
(88, 5, 'admin', '1353397775', '/var/www/_dev/plexcloud/test.php'),
(89, 5, 'admin', '1353397794', '/var/www/_dev/plexcloud/e649bdb701fbd6e8e25b7c84feb79016.php'),
(90, 5, 'admin', '1353398516', '/var/www/_dev/plexcloud/manager/index.php'),
(91, 5, 'admin', '1353398522', '/var/www/_dev/plexcloud/sw_unpatch.pl'),
(92, 5, 'admin', '1353398696', '/var/www/_dev/plexcloud/sw_patch.pl'),
(93, 5, 'admin', '1353398696', '/var/www/_dev/plexcloud/sw_unpatch.pl'),
(94, NULL, 'admin', '1353398873', '/goood.php'),
(95, NULL, 'admin', '1353398875', '/goood.php'),
(96, 5, 'admin', '1353398957', '/var/www/_dev/plexcloud/sw_patch.pla'),
(97, NULL, 'admin', '1353398967', '/test.php'),
(98, NULL, 'admin', '1353398969', '/test.php'),
(99, NULL, 'admin', '1353398975', '/test.php'),
(100, NULL, 'admin', '1353398978', '/test.php'),
(101, 5, 'admin', '1353398995', '/var/www/_dev/plexcloud/test.php'),
(102, 8, 'admin', '1353584749', '/var/www/manager/js/window.js'),
(103, 8, 'admin', '1353584827', '/var/www/manager/css/forms.css'),
(104, 8, 'admin', '1353584850', '/var/www/manager/css/buttons.css'),
(105, 8, 'admin', '1353584943', '/var/www/manager/js/window.js'),
(106, 8, 'admin', '1353585037', '/var/www/manager/js/window.js'),
(107, 9, 'admin', '1354848893', '/var/www/jhs/demo/cart/modules/plexcart/plexcart.php'),
(108, 9, 'admin', '1354849043', '/var/www/jhs/os/application/controllers/cartapi.php'),
(109, 9, 'admin', '1354849321', '/var/www/jhs/os/application/controllers/cartapi.php'),
(110, 10, 'admin', '1354873453', '/var/www/jhs/demo/cart/interface/no-layout.php'),
(111, 10, 'admin', '1354873456', '/var/www/jhs/demo/cart/interface/revisions-manager.php'),
(112, 10, 'admin', '1354873459', '/var/www/jhs/demo/cart/interface/theme_editor.php'),
(113, 10, 'admin', '1354873518', '/var/www/jhs/test.php'),
(114, 10, 'admin', '1354873534', '/var/www/jhs/os/index.php'),
(115, 5, 'admin', '1356576477', '/var/www/_dev/plexcloud/manager/index.php'),
(116, 5, 'admin', '1356576494', '/var/www/_dev/plexcloud/manager/.htaccess'),
(117, 5, 'admin', '1356576497', '/var/www/_dev/plexcloud/sw_unpatch.pl'),
(118, 5, 'admin', '1356577255', '/var/www/_dev/plexcloud/sw_patch.pl'),
(119, 10, 'admin2', '1358860840', '/var/www/jhs/manager/index.php'),
(120, 10, 'admin2', '1361263815', '/var/www/jhs/manager/application/libraries/index.html'),
(121, 5, 'admin', '1392000971', '/var/www/_dev/plexcloud/manager/index.php');

-- --------------------------------------------------------

--
-- Table structure for table `email_notifications`
--

CREATE TABLE `email_notifications` (
  `id` int(11) UNSIGNED NOT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `contact_email` varchar(128) DEFAULT NULL,
  `module` varchar(128) DEFAULT NULL,
  `transaction` varchar(128) DEFAULT NULL,
  `transaction_id` int(11) DEFAULT NULL,
  `remarks` text,
  `datetime` datetime DEFAULT NULL,
  `subject` text,
  `message` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `employees`
--

CREATE TABLE `employees` (
  `id` int(11) NOT NULL,
  `username` varchar(128) DEFAULT NULL,
  `password` varchar(128) DEFAULT NULL,
  `firstname` varchar(128) DEFAULT NULL,
  `lastname` varchar(128) DEFAULT NULL,
  `gender` varchar(128) DEFAULT NULL,
  `nationality` varchar(128) DEFAULT NULL,
  `dob` date DEFAULT NULL,
  `marital_status` varchar(128) DEFAULT NULL,
  `race` varchar(128) DEFAULT NULL,
  `ic_no` varchar(128) DEFAULT NULL,
  `photo` text,
  `address1` text,
  `address2` text,
  `city` varchar(128) DEFAULT NULL,
  `stateprov` varchar(128) DEFAULT NULL,
  `zipcode` varchar(128) DEFAULT NULL,
  `country` varchar(128) DEFAULT NULL,
  `session` int(1) DEFAULT NULL,
  `active` int(1) DEFAULT NULL,
  `home_phone` varchar(128) DEFAULT NULL,
  `mobile` varchar(128) DEFAULT NULL,
  `work_phone` varchar(128) DEFAULT NULL,
  `work_email` varchar(128) DEFAULT NULL,
  `other_email` varchar(128) DEFAULT NULL,
  `employment_start_date` datetime DEFAULT NULL,
  `employment_end_date` datetime DEFAULT NULL,
  `type` varchar(32) DEFAULT NULL,
  `division` varchar(128) DEFAULT NULL,
  `ip_address` varchar(32) DEFAULT NULL,
  `last_login` datetime DEFAULT NULL,
  `last_logout` datetime DEFAULT NULL,
  `remarks` text,
  `status` varchar(32) DEFAULT NULL,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `position` varchar(32) DEFAULT NULL,
  `is_manager` int(1) DEFAULT NULL,
  `is_cashier` int(1) DEFAULT NULL,
  `salary_category` varchar(32) DEFAULT NULL,
  `tax_id` varchar(255) DEFAULT NULL,
  `epf_id` varchar(255) DEFAULT NULL,
  `socso_id` varchar(255) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `employees`
--

INSERT INTO `employees` (`id`, `username`, `password`, `firstname`, `lastname`, `gender`, `nationality`, `dob`, `marital_status`, `race`, `ic_no`, `photo`, `address1`, `address2`, `city`, `stateprov`, `zipcode`, `country`, `session`, `active`, `home_phone`, `mobile`, `work_phone`, `work_email`, `other_email`, `employment_start_date`, `employment_end_date`, `type`, `division`, `ip_address`, `last_login`, `last_logout`, `remarks`, `status`, `tags`, `added_on`, `added_by`, `modified_on`, `modified_by`, `position`, `is_manager`, `is_cashier`, `salary_category`, `tax_id`, `epf_id`, `socso_id`) VALUES
(28, NULL, NULL, 'Jane', 'Doe', 'Female', 'Malaysian', '1988-08-01', 'Married', 'Indian', NULL, NULL, '', '', '', '0', '', '0', NULL, NULL, '', '0123456789', '', 'janedoe@gmail.com', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, 0, 0, '0', NULL, NULL, NULL),
(27, NULL, NULL, 'John', 'Doe', 'Male', 'Malaysian', '2015-08-04', 'Single', 'Chinese', NULL, NULL, 'Address 1', 'Address 2', 'Georgetown', 'Johor', '10800', 'Malaysia', NULL, NULL, '', '012346789', '', 'johndoe@gmail.com', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL),
(29, NULL, NULL, 'Shafiq Rizwan', 'bin Shaukat', 'Male', 'Malaysia', '2016-01-02', 'Single', '', '880102355071', NULL, '', '', '', '0', '', '0', NULL, NULL, '', '', '', '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, 0, 0, '0', NULL, NULL, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `employee_cico`
--

CREATE TABLE `employee_cico` (
  `id` int(11) UNSIGNED NOT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `check_in` datetime DEFAULT NULL,
  `check_out` datetime DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `employee_cico`
--

INSERT INTO `employee_cico` (`id`, `employee_id`, `check_in`, `check_out`, `status`) VALUES
(19, 27, '2015-08-01 12:59:00', NULL, NULL),
(18, 28, '2015-08-01 12:58:00', NULL, NULL),
(17, 29, NULL, '2015-08-01 08:17:00', NULL),
(16, 27, NULL, '2015-08-01 08:15:00', NULL),
(15, 28, NULL, '2015-08-01 08:00:00', NULL);

-- --------------------------------------------------------

--
-- Table structure for table `employee_dependents`
--

CREATE TABLE `employee_dependents` (
  `id` int(11) NOT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `name` varchar(128) DEFAULT NULL,
  `relationship` varchar(128) DEFAULT NULL,
  `dob` date DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `employee_documents`
--

CREATE TABLE `employee_documents` (
  `id` int(11) NOT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `filename` varchar(128) DEFAULT NULL,
  `filetype` varchar(32) DEFAULT NULL,
  `size` varchar(64) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `employee_education`
--

CREATE TABLE `employee_education` (
  `id` int(11) NOT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `education` varchar(128) DEFAULT NULL,
  `major` varchar(128) DEFAULT NULL,
  `year` varchar(4) DEFAULT NULL,
  `gpa_score` varchar(128) DEFAULT NULL,
  `start_date` varchar(128) DEFAULT NULL,
  `end_date` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `employee_emergency_contacts`
--

CREATE TABLE `employee_emergency_contacts` (
  `id` int(11) NOT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `name` varchar(128) DEFAULT NULL,
  `relationship` varchar(128) DEFAULT NULL,
  `home_phone` varchar(128) DEFAULT NULL,
  `mobile` varchar(128) DEFAULT NULL,
  `work_phone` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `employee_languages`
--

CREATE TABLE `employee_languages` (
  `id` int(11) NOT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `language` varchar(128) DEFAULT NULL,
  `fluency` varchar(128) DEFAULT NULL,
  `competency` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `employee_licenses`
--

CREATE TABLE `employee_licenses` (
  `id` int(11) NOT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `start_date` varchar(128) DEFAULT NULL,
  `end_date` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `employee_skills`
--

CREATE TABLE `employee_skills` (
  `id` int(11) NOT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `skill` varchar(128) DEFAULT NULL,
  `years_of_experience` int(11) DEFAULT NULL,
  `remarks` text
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `employee_work_experience`
--

CREATE TABLE `employee_work_experience` (
  `id` int(11) NOT NULL,
  `employee_id` varchar(128) DEFAULT NULL,
  `employer` varchar(128) DEFAULT NULL,
  `start_date` date DEFAULT NULL,
  `end_date` date DEFAULT NULL,
  `job_title` varchar(128) DEFAULT NULL,
  `remarks` varchar(128) DEFAULT NULL,
  `internal` tinyint(4) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `employment`
--

CREATE TABLE `employment` (
  `id` int(11) NOT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `job_title` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `date` date DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `pay_grade` varchar(128) DEFAULT NULL,
  `pay_frequency` varchar(128) DEFAULT NULL,
  `minimum_salary` decimal(20,2) DEFAULT NULL,
  `maximum_salary` decimal(20,2) DEFAULT NULL,
  `basic_salary` decimal(20,2) DEFAULT NULL,
  `division` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `employment`
--

INSERT INTO `employment` (`id`, `employee_id`, `job_title`, `status`, `date`, `type`, `pay_grade`, `pay_frequency`, `minimum_salary`, `maximum_salary`, `basic_salary`, `division`) VALUES
(6, 18, '', '0', '1970-01-01', '0', '0', 'Monthly', '600.00', '900.00', '600.00', NULL),
(7, 24, 'Senior Developer', 'Active', '2012-02-01', 'Full-time', '0', 'Monthly', '5000.00', '12000.00', '5000.00', NULL),
(8, 13, '', '0', '1970-01-01', '0', '0', '0', '0.00', '0.00', '0.00', NULL),
(9, 27, 'Human Resource Executive', 'Active', '2015-01-01', 'Full-time', '0', 'Monthly', '1000.00', '3500.00', '2800.00', NULL),
(10, 28, 'HR Manager', 'Active', '2015-01-01', 'Full-time', '0', 'Monthly', '0.00', '0.00', '4000.00', NULL),
(11, 29, 'Software Engineer', 'Active', '2014-01-01', 'Full-time', '0', 'Monthly', '5000.00', '8000.00', '5500.00', NULL);

-- --------------------------------------------------------

--
-- Table structure for table `fifo`
--

CREATE TABLE `fifo` (
  `id` int(11) UNSIGNED NOT NULL,
  `item_id` int(11) DEFAULT NULL,
  `po_item_id` int(11) DEFAULT NULL,
  `po_id` int(11) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `cost` decimal(20,2) DEFAULT NULL,
  `from_qty` int(11) DEFAULT NULL,
  `to_qty` int(11) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `done` int(1) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `fifo`
--

INSERT INTO `fifo` (`id`, `item_id`, `po_item_id`, `po_id`, `datetime`, `cost`, `from_qty`, `to_qty`, `qty`, `done`) VALUES
(1, 1, 16, 1, '2011-10-07 09:23:32', '1.50', NULL, NULL, 10, NULL),
(2, 2, 17, 1, '2011-10-07 09:23:32', '1.00', NULL, NULL, 10, NULL),
(3, 3, 18, 1, '2011-10-07 09:23:32', '1.20', NULL, NULL, 10, NULL),
(4, 1, 25, 2, '2011-10-07 15:14:17', '1.45', NULL, NULL, 10, NULL),
(5, 1, 26, 3, '2011-10-07 15:44:30', '1.55', NULL, NULL, 10, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `fnb_buffer_sales`
--

CREATE TABLE `fnb_buffer_sales` (
  `id` int(11) NOT NULL,
  `txn_no` varchar(32) DEFAULT NULL,
  `table_no` varchar(128) DEFAULT NULL,
  `user_id` int(11) DEFAULT NULL,
  `username` varchar(128) DEFAULT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `employee_username` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `cost` decimal(20,4) DEFAULT NULL,
  `subtotal` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `amount_cash` decimal(20,2) DEFAULT NULL,
  `amount_cc` decimal(20,2) DEFAULT NULL,
  `amount_tendered` decimal(20,2) DEFAULT NULL,
  `amount_change` decimal(20,2) DEFAULT NULL,
  `amount_voucher` decimal(20,2) DEFAULT NULL,
  `amount_cheque` decimal(20,2) DEFAULT NULL,
  `amount_discount` varchar(128) DEFAULT NULL,
  `adjustment` decimal(10,2) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `payment_details` text,
  `terminal` varchar(32) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `discount_type` varchar(128) DEFAULT NULL,
  `discount` varchar(128) DEFAULT NULL,
  `payment` text,
  `verified` int(1) DEFAULT '1',
  `warehouse_Id` int(11) DEFAULT NULL,
  `taxes` text,
  `taxable_amount` decimal(20,2) DEFAULT NULL,
  `tax_amount` decimal(20,2) DEFAULT NULL,
  `cc_type` int(11) DEFAULT NULL,
  `cc_fee` decimal(20,2) DEFAULT NULL,
  `cc_name` varchar(32) DEFAULT NULL,
  `cc_percentage` decimal(20,2) DEFAULT NULL,
  `cc_tax_percentage` decimal(20,2) DEFAULT NULL,
  `cc_tax` decimal(20,2) DEFAULT NULL,
  `cc_amount` decimal(20,2) DEFAULT NULL,
  `no_of_pax` int(11) DEFAULT NULL,
  `customer_id` int(11) DEFAULT NULL,
  `customer` varchar(255) DEFAULT NULL,
  `service_charge` decimal(20,2) DEFAULT NULL,
  `recon_date` date DEFAULT NULL,
  `table_card_no` varchar(255) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `fnb_buffer_sales`
--

INSERT INTO `fnb_buffer_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_Id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(17256, '116624', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2018-03-09 14:02:05', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520557159', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(17257, '116625', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2018-03-09 14:02:39', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520557159', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(17255, '116623', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-03-09 13:41:24', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520557159', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17254, '116628', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-03-09 15:18:27', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '60.00', '8.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520557159', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17253, '116627', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-03-09 14:32:24', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520557159', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17247, '116618', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-03-09 13:02:08', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520557159', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17252, '116620', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-03-09 13:12:28', 'Paid', NULL, '103.00', '113.30', '113.30', NULL, '125.00', '11.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520557159', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17258, '116626', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-03-09 14:07:14', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520557159', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17250, '116622', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-03-09 13:30:23', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520557159', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17249, '116621', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-03-09 13:22:05', 'Paid', NULL, '65.00', '64.35', '64.35', NULL, '100.00', '35.65', '0.00', '0.00', '7.15', '0.00', 'Cash', NULL, '27', '1520557159', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17248, '116617', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-03-09 12:58:58', 'Paid', NULL, '64.00', '52.80', '52.80', NULL, '55.00', '2.20', '0.00', '0.00', '17.60', '0.00', 'Cash', NULL, '27', '1520557159', 'p', '25', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17244, '116615', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-03-09 11:58:54', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520557159', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17246, '116619', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-03-09 13:11:03', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '15.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520557159', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17245, '116616', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-03-09 12:11:53', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520557159', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17240, '116610', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-03-09 11:10:01', 'Paid', NULL, '52.50', '57.75', '57.75', NULL, '100.00', '42.25', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520557159', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17241, '116613', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-03-09 11:47:39', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '100.00', '61.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520557159', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17242, '116612', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-03-09 11:40:36', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520557159', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17243, '116614', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-03-09 11:57:04', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '26.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520557159', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17238, '116611', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-03-09 11:14:40', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520557159', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17239, '116609', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-03-09 10:32:46', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520557159', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17237, '116608', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-03-09 10:25:30', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520557159', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17236, '116607', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-03-09 10:00:50', 'Paid', NULL, '61.50', '67.65', '67.65', NULL, '100.00', '32.35', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520557159', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');

-- --------------------------------------------------------

--
-- Table structure for table `fnb_buffer_sale_items`
--

CREATE TABLE `fnb_buffer_sale_items` (
  `id` int(11) NOT NULL,
  `date` datetime DEFAULT NULL,
  `ss_terminal` varchar(128) DEFAULT NULL,
  `ss_code` varchar(128) DEFAULT NULL,
  `sale_id` int(11) DEFAULT NULL,
  `si_item_id` int(11) DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_sku` varchar(128) DEFAULT NULL,
  `item_name` varchar(128) DEFAULT NULL,
  `item_option` varchar(128) DEFAULT NULL,
  `category` varchar(128) DEFAULT NULL,
  `subcategory` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `price_per_unit` float(10,2) DEFAULT NULL,
  `margin` float(10,4) DEFAULT NULL,
  `cost` float(10,4) DEFAULT NULL,
  `amount` float(10,2) DEFAULT NULL,
  `sold` int(11) DEFAULT NULL,
  `terminal` varchar(32) DEFAULT NULL,
  `printed` int(1) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `ordered_by` varchar(128) DEFAULT NULL,
  `ordered_time` datetime DEFAULT NULL,
  `serial` varchar(128) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `taxable` int(11) DEFAULT NULL,
  `tax_code` varchar(128) DEFAULT NULL,
  `instant_sale` int(1) DEFAULT NULL,
  `discount` decimal(20,1) DEFAULT NULL,
  `global_discount` decimal(20,1) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `fnb_buffer_sale_items`
--

INSERT INTO `fnb_buffer_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(2498, '2016-07-07 17:46:31', NULL, NULL, 848, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, NULL, '27', 1, NULL, 'admin', '2016-07-07 17:46:31', 'admin-1467874067-14678847917968123', 1, 1, 'SR', NULL, NULL, NULL),
(67727, '2018-03-03 16:26:33', NULL, NULL, 17106, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-03-03 16:26:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63999, '2018-01-20 17:52:56', NULL, NULL, 0, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, NULL, '27', 1, NULL, 'admin', '2018-01-20 17:52:56', 'admin-1516415730-15164419768238420', 1, 1, 'SR', NULL, NULL, NULL),
(31841, '2017-05-17 12:47:24', NULL, NULL, 9284, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-05-17 12:47:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64988, '2018-01-28 15:01:31', NULL, NULL, 16461, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-01-28 15:01:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23248, '2017-03-03 17:27:00', NULL, NULL, 7390, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-03-03 17:27:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38119, '2017-07-02 13:35:53', NULL, NULL, 0, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, NULL, '27', 1, NULL, 'admin', '2017-07-02 13:35:53', 'admin-1498972092-14989737537253795', 1, 1, 'SR', NULL, NULL, NULL),
(39002, '2017-07-08 15:12:51', NULL, NULL, 10843, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-07-08 15:12:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21741, '2017-02-19 17:03:42', NULL, NULL, 7028, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-02-19 17:03:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34307, '2017-06-04 13:27:26', NULL, NULL, 9835, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-06-04 13:27:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38180, '2017-07-02 15:18:22', NULL, NULL, 10661, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-07-02 15:18:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28903, '2017-04-23 12:21:42', NULL, NULL, 8641, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-04-23 12:21:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25823, '2017-03-23 15:00:34', NULL, NULL, 7948, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-03-23 15:00:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38720, '2017-07-07 16:11:28', NULL, NULL, 10788, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-07-07 16:11:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20579, '2017-02-11 17:38:49', NULL, NULL, 6753, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-02-11 17:38:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(67757, '2018-03-03 17:11:00', NULL, NULL, 17112, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-03-03 17:11:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(66076, '2018-02-08 12:22:49', NULL, NULL, 16708, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-02-08 12:22:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51217, '2017-10-06 14:30:28', NULL, NULL, 13490, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-10-06 14:30:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(17281, '2016-12-31 20:51:17', NULL, NULL, 5734, 0, 258, '192', 'NYE Beer Promo', '', 'DISCOUNT ', '0', 1, 12.00, 12.0000, 0.0000, 12.00, NULL, '27', 1, NULL, 'admin', '2016-12-31 20:51:17', 'admin-1483164662-14831886776816990', 1, 0, '', NULL, NULL, NULL),
(585, '2016-06-16 18:30:30', NULL, NULL, 225, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, NULL, '27', 1, NULL, 'Staff', '2016-06-16 18:30:30', 'Staff-1466066029-14660730300841116', 1, 1, 'SR', NULL, NULL, NULL),
(38138, '2017-07-02 14:17:26', NULL, NULL, 10654, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-07-02 14:17:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39112, '2017-07-09 11:16:04', NULL, NULL, 10868, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-07-09 11:16:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31284, '2017-05-13 13:09:31', NULL, NULL, 9145, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-05-13 13:09:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52781, '2017-10-16 15:39:03', NULL, NULL, 13840, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-10-16 15:39:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57306, '2017-11-26 17:40:10', NULL, NULL, 0, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, NULL, '27', 1, NULL, 'admin', '2017-11-26 17:40:10', 'admin-1511656639-15116892108141960', 1, 1, 'SR', NULL, NULL, NULL),
(4429, '2016-07-30 17:03:12', NULL, NULL, 1512, 0, 182, '117', 'Open Drinks ', 'tea', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, NULL, '27', 1, NULL, 'admin', '2016-07-30 17:03:12', 'admin-1469869280-14698693919381558', 1, 0, '', NULL, NULL, NULL),
(46067, '2017-08-27 14:16:12', NULL, NULL, 12398, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-08-27 14:16:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32680, '2017-05-25 17:53:04', NULL, NULL, 9496, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-05-25 17:53:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43966, '2017-08-12 13:51:06', NULL, NULL, 11964, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-08-12 13:51:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(2272, '2016-07-06 15:25:45', NULL, NULL, 776, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, NULL, '27', 1, NULL, 'Staff', '2016-07-06 15:25:45', 'Staff-1467784297-1467789945619149', 1, 1, 'SR', NULL, NULL, NULL),
(38417, '2017-07-06 11:40:09', NULL, NULL, 10717, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-07-06 11:40:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64288, '2018-01-22 12:08:06', NULL, NULL, 0, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, NULL, '27', 1, NULL, 'admin', '2018-01-22 12:08:06', 'admin-1516583211-15165940862315167', 1, 1, 'SR', NULL, NULL, NULL),
(58227, '2017-12-03 14:12:11', NULL, NULL, 14999, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-12-03 14:12:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(66998, '2018-02-24 17:26:57', NULL, NULL, 16926, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-02-24 17:26:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29042, '2017-04-24 11:44:24', NULL, NULL, 8668, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-04-24 11:44:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57362, '2017-11-27 11:14:16', NULL, NULL, 14823, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-11-27 11:14:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24836, '2017-03-16 13:15:19', NULL, NULL, 7738, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-03-16 13:15:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36981, '2017-06-25 16:43:13', NULL, NULL, 10412, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-06-25 16:43:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30169, '2017-05-04 12:19:34', NULL, NULL, 8913, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-05-04 12:19:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30430, '2017-05-06 15:26:05', NULL, NULL, 8961, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-05-06 15:26:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(2499, '2016-07-07 17:46:39', NULL, NULL, 848, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, NULL, '27', 1, NULL, 'admin', '2016-07-07 17:46:39', 'admin-1467874067-14678847997561828', 1, 1, 'SR', NULL, NULL, NULL),
(56225, '2017-11-17 14:00:34', NULL, NULL, 14570, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-11-17 14:00:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53193, '2017-10-19 14:14:16', NULL, NULL, 13925, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-10-19 14:14:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59845, '2017-12-18 18:06:10', NULL, NULL, 0, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, NULL, '27', 1, NULL, 'admin', '2017-12-18 18:06:10', 'admin-1513559204-1513591570433984', 1, 0, '', NULL, NULL, NULL),
(26688, '2017-03-31 11:45:57', NULL, NULL, 8150, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-03-31 11:45:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24870, '2017-03-16 15:37:44', NULL, NULL, 7749, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-03-16 15:37:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39010, '2017-07-08 15:13:51', NULL, NULL, 10847, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-07-08 15:13:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(3003, '2016-07-12 17:17:30', NULL, NULL, 1008, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, NULL, '27', 1, NULL, 'admin', '2016-07-12 17:17:30', 'admin-1468315032-14683150505015755', 1, 1, 'SR', NULL, NULL, NULL),
(46248, '2017-08-28 14:28:53', NULL, NULL, 12446, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-08-28 14:28:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21811, '2017-02-20 14:24:39', NULL, NULL, 7049, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-02-20 14:24:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31110, '2017-05-12 16:49:38', NULL, NULL, 9128, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-05-12 16:49:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22389, '2017-02-25 12:16:21', NULL, NULL, 7181, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-02-25 12:16:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21835, '2017-02-20 17:21:32', NULL, NULL, 7058, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-02-20 17:21:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37568, '2017-06-29 14:20:07', NULL, NULL, 10538, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-06-29 14:20:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24475, '2017-03-12 11:16:24', NULL, NULL, 7661, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-03-12 11:16:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50171, '2017-09-28 16:17:29', NULL, NULL, 13283, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-09-28 16:17:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44236, '2017-08-13 13:05:25', NULL, NULL, 11995, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-08-13 13:05:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56548, '2017-11-19 12:28:31', NULL, NULL, 14638, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-11-19 12:28:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39703, '2017-07-13 14:24:29', NULL, NULL, 11003, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-07-13 14:24:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36863, '2017-06-25 12:39:58', NULL, NULL, 10382, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-06-25 12:39:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60790, '2017-12-27 14:15:53', NULL, NULL, 15575, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-12-27 14:15:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26256, '2017-03-26 13:51:02', NULL, NULL, 8045, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-03-26 13:51:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26249, '2017-03-26 13:49:47', NULL, NULL, 8036, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-03-26 13:49:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24057, '2017-03-08 17:58:17', NULL, NULL, 7571, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-03-08 17:58:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26383, '2017-03-27 15:51:23', NULL, NULL, 8071, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-03-27 15:51:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28727, '2017-04-22 13:43:09', NULL, NULL, 8599, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-04-22 13:43:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26173, '2017-03-26 12:07:24', NULL, NULL, 8030, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-03-26 12:07:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62814, '2018-01-10 14:29:12', NULL, NULL, 0, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, NULL, '27', 1, NULL, 'admin', '2018-01-10 14:29:12', 'admin-1515546225-15155657521956954', 1, 1, 'SR', NULL, NULL, NULL),
(26491, '2017-03-29 12:49:49', NULL, NULL, 8098, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-03-29 12:49:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26454, '2017-03-29 11:29:18', NULL, NULL, 8089, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-03-29 11:29:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41053, '2017-07-22 15:27:36', NULL, NULL, 11301, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-07-22 15:27:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47209, '2017-09-03 16:01:24', NULL, NULL, 0, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, NULL, '27', 1, NULL, 'admin', '2017-09-03 16:01:24', 'admin-1504414860-1504425684299231', 1, 1, 'SR', NULL, NULL, NULL),
(29317, '2017-04-28 12:27:41', NULL, NULL, 8737, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-04-28 12:27:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24164, '2017-03-10 14:51:35', NULL, NULL, 7596, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-03-10 14:51:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54827, '2017-11-03 11:00:13', NULL, NULL, 14275, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-11-03 11:00:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39733, '2017-07-13 15:55:06', NULL, NULL, 11008, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-07-13 15:55:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39862, '2017-07-14 15:41:54', NULL, NULL, 11040, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-07-14 15:41:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25682, '2017-03-22 12:43:20', NULL, NULL, 7914, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-03-22 12:43:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(67453, '2018-03-01 12:42:52', NULL, NULL, 17033, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-03-01 12:42:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57944, '2017-12-02 13:30:05', NULL, NULL, 14946, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-12-02 13:30:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36277, '2017-06-21 13:07:50', NULL, NULL, 10264, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-06-21 13:07:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28224, '2017-04-15 10:19:50', NULL, NULL, 8496, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-04-15 10:19:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32163, '2017-05-20 15:10:58', NULL, NULL, 9364, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-05-20 15:10:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65583, '2018-02-03 12:00:39', NULL, NULL, 16600, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-02-03 12:00:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41481, '2017-07-24 15:22:07', NULL, NULL, 11404, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-07-24 15:22:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37309, '2017-06-28 09:58:07', NULL, NULL, 10481, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-06-28 09:58:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62856, '2018-01-11 11:52:45', NULL, NULL, 16008, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-01-11 11:52:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62815, '2018-01-10 14:29:12', NULL, NULL, 0, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, NULL, '27', 1, NULL, 'admin', '2018-01-10 14:29:12', 'admin-1515546225-15155657521956954', 1, 1, 'SR', NULL, NULL, NULL),
(59843, '2017-12-18 18:06:10', NULL, NULL, 0, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, NULL, '27', 1, NULL, 'admin', '2017-12-18 18:06:10', 'admin-1513559204-1513591570433984', 1, 0, '', NULL, NULL, NULL),
(33843, '2017-06-02 12:02:04', NULL, NULL, 9741, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-06-02 12:02:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48865, '2017-09-17 13:41:53', NULL, NULL, 12981, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-09-17 13:41:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43407, '2017-08-07 15:28:29', NULL, NULL, 11838, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-08-07 15:28:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40962, '2017-07-22 12:02:04', NULL, NULL, 11276, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-07-22 12:02:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(66228, '2018-02-09 11:30:42', NULL, NULL, 16748, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-02-09 11:30:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30147, '2017-05-04 11:23:25', NULL, NULL, 8903, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-05-04 11:23:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47495, '2017-09-07 13:50:42', NULL, NULL, 0, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, NULL, '27', 1, NULL, 'admin', '2017-09-07 13:50:42', 'admin-1504761354-15047634420292035', 1, 0, '', NULL, NULL, NULL),
(59844, '2017-12-18 18:06:10', NULL, NULL, 0, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, NULL, '27', 1, NULL, 'admin', '2017-12-18 18:06:10', 'admin-1513559204-1513591570433984', 1, 0, '', NULL, NULL, NULL),
(52003, '2017-10-12 15:59:04', NULL, NULL, 13674, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-10-12 15:59:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52960, '2017-10-18 12:59:17', NULL, NULL, 13873, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-10-18 12:59:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49031, '2017-09-18 13:25:41', NULL, NULL, 13024, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-09-18 13:25:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36237, '2017-06-21 12:06:34', NULL, NULL, 10251, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-06-21 12:06:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58624, '2017-12-08 12:38:38', NULL, NULL, 15103, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-12-08 12:38:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37480, '2017-06-29 11:50:47', NULL, NULL, 10521, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-06-29 11:50:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38257, '2017-07-03 11:10:06', NULL, NULL, 10677, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-07-03 11:10:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41828, '2017-07-28 13:11:55', NULL, NULL, 11490, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-07-28 13:11:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37969, '2017-07-02 10:46:05', NULL, NULL, 10624, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-07-02 10:46:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45638, '2017-08-26 10:43:29', NULL, NULL, 12327, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-08-26 10:43:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45889, '2017-08-27 10:57:59', NULL, NULL, 12364, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-08-27 10:57:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39502, '2017-07-12 11:41:18', NULL, NULL, 10955, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-07-12 11:41:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51765, '2017-10-09 13:50:33', NULL, NULL, 13607, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-10-09 13:50:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41180, '2017-07-23 10:12:30', NULL, NULL, 11327, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-07-23 10:12:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65188, '2018-01-31 12:18:29', NULL, NULL, 16510, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-01-31 12:18:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33742, '2017-06-01 11:19:22', NULL, NULL, 9714, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-06-01 11:19:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43503, '2017-08-09 12:58:04', NULL, NULL, 11855, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-08-09 12:58:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40477, '2017-07-19 11:03:06', NULL, NULL, 11177, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-07-19 11:03:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(66249, '2018-02-09 12:09:29', NULL, NULL, 16758, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-02-09 12:09:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45214, '2017-08-21 10:29:21', NULL, NULL, 12227, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-08-21 10:29:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46182, '2017-08-28 12:51:49', NULL, NULL, 12429, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-08-28 12:51:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(66088, '2018-02-08 12:43:27', NULL, NULL, 16709, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-02-08 12:43:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(66104, '2018-02-08 12:49:33', NULL, NULL, 16717, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-02-08 12:49:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52144, '2017-10-14 11:08:32', NULL, NULL, 13710, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-10-14 11:08:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49717, '2017-09-24 10:31:15', NULL, NULL, 13169, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-09-24 10:31:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(66792, '2018-02-24 11:32:49', NULL, NULL, 16878, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-02-24 11:32:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64287, '2018-01-22 12:08:06', NULL, NULL, 0, 0, 181, '116', 'Open Food ', 'marmite rice', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, NULL, '27', 1, NULL, 'admin', '2018-01-22 12:08:06', 'admin-1516583211-15165940862315167', 1, 0, '', NULL, NULL, NULL),
(62203, '2018-01-05 15:16:51', NULL, NULL, 15870, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-01-05 15:16:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53429, '2017-10-21 11:23:14', NULL, NULL, 13971, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-10-21 11:23:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62663, '2018-01-08 12:01:53', NULL, NULL, 15964, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-01-08 12:01:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47397, '2017-09-06 11:25:20', NULL, NULL, 0, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, NULL, '27', 1, NULL, 'admin', '2017-09-06 11:25:20', 'admin-1504660309-15046683201957349', 1, 1, 'SR', NULL, NULL, NULL),
(63762, '2018-01-19 12:48:35', NULL, NULL, 0, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, NULL, '27', 1, NULL, 'admin', '2018-01-19 12:48:35', 'admin-1516321469-1516337315491309', 1, 1, 'SR', NULL, NULL, NULL),
(64659, '2018-01-27 09:52:11', NULL, NULL, 16395, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-01-27 09:52:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49675, '2017-09-24 09:59:42', NULL, NULL, 13159, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-09-24 09:59:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55790, '2017-11-12 10:25:26', NULL, NULL, 14471, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2017-11-12 10:25:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64290, '2018-01-22 12:08:06', NULL, NULL, 0, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, NULL, '27', 1, NULL, 'admin', '2018-01-22 12:08:06', 'admin-1516583211-15165940862315167', 1, 0, '', NULL, NULL, NULL),
(63626, '2018-01-18 11:19:21', NULL, NULL, 16170, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-01-18 11:19:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64289, '2018-01-22 12:08:06', NULL, NULL, 0, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, NULL, '27', 1, NULL, 'admin', '2018-01-22 12:08:06', 'admin-1516583211-15165940862315167', 1, 1, 'SR', NULL, NULL, NULL),
(62790, '2018-01-10 12:52:08', NULL, NULL, 15986, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-01-10 12:52:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(66207, '2018-02-09 11:03:28', NULL, NULL, 16744, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-02-09 11:03:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(67049, '2018-02-25 10:57:43', NULL, NULL, 16938, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-02-25 10:57:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62743, '2018-01-10 11:51:52', NULL, NULL, 0, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, NULL, '27', 1, NULL, 'admin', '2018-01-10 11:51:52', 'admin-1515546225-15155563120457034', 1, 0, '', NULL, NULL, NULL),
(62742, '2018-01-10 11:51:52', NULL, NULL, 0, 0, 181, '116', 'Open Food ', 'black fungus noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, NULL, '27', 1, NULL, 'admin', '2018-01-10 11:51:52', 'admin-1515546225-15155563120457034', 1, 0, '', NULL, NULL, NULL),
(62741, '2018-01-10 11:51:52', NULL, NULL, 0, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, NULL, '27', 1, NULL, 'admin', '2018-01-10 11:51:52', 'admin-1515546225-15155563120457034', 1, 0, '', NULL, NULL, NULL),
(62740, '2018-01-10 11:51:52', NULL, NULL, 0, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, NULL, '27', 1, NULL, 'admin', '2018-01-10 11:51:52', 'admin-1515546225-15155563120457034', 1, 0, '', NULL, NULL, NULL),
(65419, '2018-02-02 12:38:20', NULL, NULL, 16558, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-02-02 12:38:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(68392, '2018-03-09 14:38:47', NULL, NULL, 17254, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 14:38:47', 'admin-1520557159-15205775270829597', 1, 1, 'SR', NULL, NULL, NULL),
(68391, '2018-03-09 14:07:04', NULL, NULL, 17258, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 14:07:04', 'admin-1520557159-15205756240018910', 1, 1, 'SR', NULL, NULL, NULL),
(68374, '2018-03-09 13:37:46', NULL, NULL, 17254, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 13:37:46', 'admin-1520557159-15205738664837116', 1, 0, '', NULL, NULL, NULL),
(68375, '2018-03-09 13:37:46', NULL, NULL, 17254, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 13:37:46', 'admin-1520557159-15205738664837116', 1, 1, 'SR', NULL, NULL, NULL),
(68364, '2018-03-09 12:32:04', NULL, NULL, 17252, 0, 291, '225', 'Smoked Duck Red Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:32:04', 'admin-1520557159-15205699243402562', 1, 0, '', NULL, NULL, NULL),
(68365, '2018-03-09 12:32:04', NULL, NULL, 17252, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:32:04', 'admin-1520557159-15205699243402562', 1, 0, '', NULL, NULL, NULL),
(68366, '2018-03-09 12:32:04', NULL, NULL, 17252, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:32:04', 'admin-1520557159-15205699243402562', 1, 0, '', NULL, NULL, NULL),
(68367, '2018-03-09 12:32:35', NULL, NULL, 17248, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Rice', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:32:35', 'admin-1520557159-1520569955850169', 1, 0, '', NULL, NULL, '25.0'),
(68368, '2018-03-09 12:33:24', NULL, NULL, 17252, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:33:24', 'admin-1520557159-15205700042427711', 1, 0, '', NULL, NULL, NULL),
(68384, '2018-03-09 14:01:58', NULL, NULL, 17256, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1520557159', 'admin', '2018-03-09 14:01:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(68370, '2018-03-09 13:34:35', NULL, NULL, 17253, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1520557159', 'admin', '2018-03-09 13:34:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(68371, '2018-03-09 13:34:51', NULL, NULL, 17253, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 13:34:51', 'admin-1520557159-15205736915686434', 1, 0, '', NULL, NULL, NULL),
(68390, '2018-03-09 14:07:04', NULL, NULL, 17258, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 14:07:04', 'admin-1520557159-15205756240018910', 1, 1, 'SR', NULL, NULL, NULL),
(68380, '2018-03-09 13:40:35', NULL, NULL, 17253, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 13:40:35', 'admin-1520557159-1520574035688865', 1, 0, '', NULL, NULL, NULL),
(68381, '2018-03-09 00:00:00', NULL, NULL, 17256, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:19:22', 'admin-1520557159-15205691622513136', 1, 1, 'SR', NULL, NULL, NULL),
(68379, '2018-03-09 13:40:35', NULL, NULL, 17253, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 13:40:35', 'admin-1520557159-1520574035688865', 1, 1, 'SR', NULL, NULL, NULL),
(68376, '2018-03-09 13:37:46', NULL, NULL, 17254, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 13:37:46', 'admin-1520557159-15205738664837116', 1, 1, 'SR', NULL, NULL, NULL),
(68377, '2018-03-09 13:40:09', NULL, NULL, 17255, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1520557159', 'admin', '2018-03-09 13:40:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(68378, '2018-03-09 13:40:16', NULL, NULL, 17255, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 9.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 13:40:16', 'admin-1520557159-15205740163361648', 1, 0, '', NULL, NULL, NULL),
(68310, '2018-03-09 10:21:16', NULL, NULL, 17240, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 10:21:16', 'admin-1520557159-15205620767955319', 1, 0, '', NULL, NULL, NULL),
(68311, '2018-03-09 10:21:16', NULL, NULL, 17240, 0, 181, '116', 'Open Food ', 'sunny side up', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1520557159', 'admin', '2018-03-09 10:21:16', 'admin-1520557159-15205620767955319', 1, 0, '', NULL, NULL, NULL),
(68312, '2018-03-09 10:21:16', NULL, NULL, 17240, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 10:21:16', 'admin-1520557159-15205620767955319', 1, 1, 'SR', NULL, NULL, NULL),
(68313, '2018-03-09 10:42:33', NULL, NULL, 17240, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 10:42:33', 'admin-1520557159-15205633535292124', 1, 1, 'SR', NULL, NULL, NULL),
(68314, '2018-03-09 10:43:56', NULL, NULL, 17240, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 10:43:56', 'admin-1520557159-15205634360948692', 1, 0, '', NULL, NULL, NULL),
(68315, '2018-03-09 10:48:13', NULL, NULL, 17241, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1520557159', 'admin', '2018-03-09 10:48:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(68316, '2018-03-09 10:48:59', NULL, NULL, 17241, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 10:48:59', 'admin-1520557159-1520563739007933', 1, 1, 'SR', NULL, NULL, NULL),
(68317, '2018-03-09 10:48:59', NULL, NULL, 17241, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 10:48:59', 'admin-1520557159-1520563739007933', 1, 1, 'SR', NULL, NULL, NULL),
(68318, '2018-03-09 10:48:59', NULL, NULL, 17241, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 10:48:59', 'admin-1520557159-1520563739007933', 1, 0, '', NULL, NULL, NULL),
(68319, '2018-03-09 10:59:12', NULL, NULL, 17242, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1520557159', 'admin', '2018-03-09 10:59:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(68320, '2018-03-09 11:03:04', NULL, NULL, 17242, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 11:03:04', 'admin-1520557159-15205645840475316', 1, 1, 'SR', NULL, NULL, NULL),
(68321, '2018-03-09 11:03:04', NULL, NULL, 17242, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 11:03:04', 'admin-1520557159-15205645840475316', 1, 1, 'SR', NULL, NULL, NULL),
(68322, '2018-03-09 11:03:04', NULL, NULL, 17242, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 11:03:04', 'admin-1520557159-15205645840475316', 1, 0, '', NULL, NULL, NULL),
(68323, '2018-03-09 11:03:04', NULL, NULL, 17242, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 11:03:04', 'admin-1520557159-15205645840475316', 1, 0, '', NULL, NULL, NULL),
(68324, '2018-03-09 11:05:42', NULL, NULL, 17243, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1520557159', 'admin', '2018-03-09 11:05:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(68325, '2018-03-09 11:05:53', NULL, NULL, 17243, 0, 335, '271', 'Iced Honey Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 11:05:53', 'admin-1520557159-15205647530659039', 1, 0, '', NULL, NULL, NULL),
(68326, '2018-03-09 11:05:53', NULL, NULL, 17243, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 11:05:53', 'admin-1520557159-15205647530659039', 1, 1, 'SR', NULL, NULL, NULL),
(68327, '2018-03-09 11:09:07', NULL, NULL, 17244, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1520557159', 'admin', '2018-03-09 11:09:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(68328, '2018-03-09 11:09:15', NULL, NULL, 17244, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 11:09:15', 'admin-1520557159-15205649551109916', 1, 0, '', NULL, NULL, NULL),
(68329, '2018-03-09 11:09:15', NULL, NULL, 17244, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 11:09:15', 'admin-1520557159-15205649551109916', 1, 1, 'SR', NULL, NULL, NULL),
(68330, '2018-03-09 11:18:06', NULL, NULL, 17245, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1520557159', 'admin', '2018-03-09 11:18:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(68331, '2018-03-09 11:18:10', NULL, NULL, 17245, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 11:18:10', 'admin-1520557159-15205654899627499', 1, 1, 'SR', NULL, NULL, NULL),
(68332, '2018-03-09 11:36:00', NULL, NULL, 17245, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 11:36:00', 'admin-1520557159-15205665600834966', 1, 0, '', NULL, NULL, NULL),
(68333, '2018-03-09 11:36:00', NULL, NULL, 17245, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 11:36:00', 'admin-1520557159-15205665600834966', 1, 0, '', NULL, NULL, NULL),
(68334, '2018-03-09 11:36:00', NULL, NULL, 17245, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 11:36:00', 'admin-1520557159-15205665600834966', 1, 1, 'SR', NULL, NULL, NULL),
(68335, '2018-03-09 11:56:17', NULL, NULL, 17246, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1520557159', 'admin', '2018-03-09 11:56:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(68336, '2018-03-09 11:56:22', NULL, NULL, 17246, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 11:56:22', 'admin-1520557159-15205677821652269', 1, 1, 'SR', NULL, NULL, NULL),
(68337, '2018-03-09 12:14:15', NULL, NULL, 17247, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:14:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(68338, '2018-03-09 12:14:20', NULL, NULL, 17247, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:14:20', 'admin-1520557159-15205688601948173', 1, 1, 'SR', NULL, NULL, NULL),
(68339, '2018-03-09 12:16:50', NULL, NULL, 17248, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:16:50', '0', 1, 1, 'SR', NULL, NULL, '25.0'),
(68340, '2018-03-09 12:17:35', NULL, NULL, 17248, 0, 181, '116', 'Open Food ', 'BKT', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:17:35', 'admin-1520557159-15205690557286590', 1, 0, '', NULL, NULL, '25.0'),
(68341, '2018-03-09 12:17:35', NULL, NULL, 17248, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:17:35', 'admin-1520557159-15205690557286590', 1, 0, '', NULL, NULL, '25.0'),
(68342, '2018-03-09 12:17:35', NULL, NULL, 17248, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:17:35', 'admin-1520557159-15205690557286590', 1, 1, 'SR', NULL, NULL, '25.0'),
(68343, '2018-03-09 12:17:35', NULL, NULL, 17248, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:17:35', 'admin-1520557159-15205690557286590', 1, 0, '', NULL, NULL, '25.0');
INSERT INTO `fnb_buffer_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(68344, '2018-03-09 12:17:55', NULL, NULL, 17249, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:17:55', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(68302, '2018-03-09 09:56:08', NULL, NULL, 17237, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 09:56:08', 'admin-1520557159-15205605678638853', 1, 0, '', NULL, NULL, NULL),
(68373, '2018-03-09 13:37:30', NULL, NULL, 17254, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1520557159', 'admin', '2018-03-09 13:37:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(68372, '2018-03-09 13:34:51', NULL, NULL, 17253, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 13:34:51', 'admin-1520557159-15205736915686434', 1, 0, '', NULL, NULL, NULL),
(68363, '2018-03-09 12:32:04', NULL, NULL, 17252, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:32:04', 'admin-1520557159-15205699243402562', 1, 0, '', NULL, NULL, NULL),
(68361, '2018-03-09 12:31:05', NULL, NULL, 17252, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.30, 0.0000, 0.0000, 10.30, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:31:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(68362, '2018-03-09 12:32:04', NULL, NULL, 17252, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:32:04', 'admin-1520557159-15205699243402562', 1, 1, 'SR', NULL, NULL, NULL),
(68386, '2018-03-09 00:00:00', NULL, NULL, 17257, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:19:22', 'admin-1520557159-15205691622513136', 1, 0, '', NULL, NULL, NULL),
(68383, '2018-03-09 00:00:00', NULL, NULL, 17256, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 13:04:41', 'admin-1520557159-1520571881844999', 1, 0, '', NULL, NULL, NULL),
(68389, '2018-03-09 14:07:00', NULL, NULL, 17258, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 14:07:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(68387, '2018-03-09 00:00:00', NULL, NULL, 17257, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', NULL, NULL, 1, 3.20, NULL, NULL, 3.20, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:18:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(68382, '2018-03-09 00:00:00', NULL, NULL, 17256, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:19:22', 'admin-1520557159-15205691622513136', 1, 1, 'SR', NULL, NULL, NULL),
(68388, '2018-03-09 14:02:19', NULL, NULL, 17251, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-03-09 14:02:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(68385, '2018-03-09 00:00:00', NULL, NULL, 17257, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:28:39', 'admin-1520557159-1520569719806215', 1, 1, 'SR', NULL, NULL, NULL),
(68354, '2018-03-09 12:18:48', NULL, NULL, 17250, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:18:48', 'admin-1520557159-1520569128102666', 1, 0, '', NULL, NULL, NULL),
(68353, '2018-03-09 12:18:48', NULL, NULL, 17250, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:18:48', 'admin-1520557159-1520569128102666', 1, 0, '', NULL, NULL, NULL),
(68351, '2018-03-09 12:18:25', NULL, NULL, 17249, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:18:25', 'admin-1520557159-15205691055996126', 1, 0, '', NULL, NULL, '10.0'),
(68180, '2018-03-07 15:19:21', NULL, NULL, 17205, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, NULL, '27', 1, NULL, 'admin', '2018-03-07 15:19:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(68352, '2018-03-09 12:18:33', NULL, NULL, 17250, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:18:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(68350, '2018-03-09 12:18:25', NULL, NULL, 17249, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:18:25', 'admin-1520557159-15205691055996126', 1, 0, '', NULL, NULL, '10.0'),
(68348, '2018-03-09 12:18:25', NULL, NULL, 17249, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:18:25', 'admin-1520557159-15205691055996126', 1, 1, 'SR', NULL, NULL, '10.0'),
(68349, '2018-03-09 12:18:25', NULL, NULL, 17249, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:18:25', 'admin-1520557159-15205691055996126', 1, 1, 'SR', NULL, NULL, '10.0'),
(68347, '2018-03-09 12:18:25', NULL, NULL, 17249, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:18:25', 'admin-1520557159-15205691055996126', 1, 0, '', NULL, NULL, '10.0'),
(68346, '2018-03-09 12:18:25', NULL, NULL, 17249, 0, 181, '116', 'Open Food ', 'BKT', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:18:25', 'admin-1520557159-15205691055996126', 1, 0, '', NULL, NULL, '10.0'),
(68345, '2018-03-09 12:18:25', NULL, NULL, 17249, 0, 181, '116', 'Open Food ', 'BKT', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 12:18:25', 'admin-1520557159-15205691055996126', 1, 0, '', NULL, NULL, '10.0'),
(68307, '2018-03-09 10:10:46', NULL, NULL, 17239, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 10:10:46', 'admin-1520557159-15205614464242778', 1, 1, 'SR', NULL, NULL, NULL),
(68308, '2018-03-09 10:10:46', NULL, NULL, 17239, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 10:10:46', 'admin-1520557159-15205614464242778', 1, 0, '', NULL, NULL, NULL),
(68309, '2018-03-09 10:20:41', NULL, NULL, 17240, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.25, 0.0000, 0.0000, 5.25, 1, '27', 1, '1520557159', 'admin', '2018-03-09 10:20:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(68297, '2018-03-09 09:09:03', NULL, NULL, 17236, 0, 181, '116', 'Open Food ', 'sunny side up', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1520557159', 'admin', '2018-03-09 09:09:03', 'admin-1520557159-15205577430881953', 1, 0, '', NULL, NULL, NULL),
(68305, '2018-03-09 10:03:39', NULL, NULL, 17238, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 10:03:39', 'admin-1520557159-15205610189271671', 1, 1, 'SR', NULL, NULL, NULL),
(68306, '2018-03-09 10:10:33', NULL, NULL, 17239, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1520557159', 'admin', '2018-03-09 10:10:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(68304, '2018-03-09 10:03:39', NULL, NULL, 17238, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 10:03:39', 'admin-1520557159-15205610189271671', 1, 0, '', NULL, NULL, NULL),
(68300, '2018-03-09 09:56:02', NULL, NULL, 17237, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1520557159', 'admin', '2018-03-09 09:56:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(68301, '2018-03-09 09:56:07', NULL, NULL, 17237, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 09:56:08', 'admin-1520557159-15205605678638853', 1, 1, 'SR', NULL, NULL, NULL),
(68299, '2018-03-09 09:09:03', NULL, NULL, 17236, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 09:09:03', 'admin-1520557159-15205577430881953', 1, 1, 'SR', NULL, NULL, NULL),
(68303, '2018-03-09 10:03:30', NULL, NULL, 17238, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1520557159', 'admin', '2018-03-09 10:03:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(68298, '2018-03-09 09:09:03', NULL, NULL, 17236, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 09:09:03', 'admin-1520557159-15205577430881953', 1, 0, '', NULL, NULL, NULL),
(68295, '2018-03-09 09:09:03', NULL, NULL, 17236, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 09:09:03', 'admin-1520557159-15205577430881953', 1, 0, '', NULL, NULL, NULL),
(68296, '2018-03-09 09:09:03', NULL, NULL, 17236, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520557159', 'admin', '2018-03-09 09:09:03', 'admin-1520557159-15205577430881953', 1, 1, 'SR', NULL, NULL, NULL),
(68294, '2018-03-09 09:07:27', NULL, NULL, 17236, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.15, 0.0000, 0.0000, 6.15, 1, '27', 1, '1520557159', 'admin', '2018-03-09 09:07:27', '0', 1, 1, 'SR', NULL, NULL, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `fnb_cash_count`
--

CREATE TABLE `fnb_cash_count` (
  `id` int(11) NOT NULL,
  `user_id` int(11) DEFAULT NULL,
  `username` varchar(128) DEFAULT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `employee_username` varchar(128) DEFAULT NULL,
  `from` datetime DEFAULT NULL,
  `to` datetime DEFAULT NULL,
  `deposited` float(10,2) DEFAULT NULL,
  `discrepancy` float(10,2) DEFAULT NULL,
  `total_sales` float(10,2) DEFAULT NULL,
  `total_items` int(11) DEFAULT NULL,
  `ip_address` varchar(32) DEFAULT NULL,
  `terminal` varchar(32) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `fnb_cash_count`
--

INSERT INTO `fnb_cash_count` (`id`, `user_id`, `username`, `employee_id`, `employee_username`, `from`, `to`, `deposited`, `discrepancy`, `total_sales`, `total_items`, `ip_address`, `terminal`, `session`) VALUES
(1, 10003, 'admin', NULL, NULL, '2016-06-07 21:28:17', '2016-06-07 22:10:45', 300.00, 0.00, 99.00, NULL, '::1', NULL, '1465306097'),
(2, 10003, 'admin', NULL, NULL, '2016-06-10 12:44:28', '2016-06-10 12:51:10', 500.00, 0.00, 660.00, NULL, '::1', NULL, '1465533868'),
(3, 10011, 'Staff', NULL, NULL, '2016-06-10 16:26:57', '2016-06-10 21:58:39', 500.00, 0.00, 1614.00, NULL, '::1', NULL, '1465547217'),
(4, 10011, 'Staff', NULL, NULL, '2016-06-11 15:41:48', '2016-06-11 22:19:24', 500.00, 0.00, 1146.00, NULL, '::1', NULL, '1465630908'),
(5, 10003, 'admin', NULL, NULL, '2016-06-12 19:02:09', '2016-06-12 22:21:05', 500.00, 0.00, 1724.00, NULL, '::1', NULL, '1465729329'),
(6, 10011, 'Staff', NULL, NULL, '2016-06-13 20:22:26', '2016-06-13 22:20:42', 500.00, 0.00, 657.00, NULL, '::1', NULL, '1465820546'),
(7, 10011, 'Staff', NULL, NULL, '2016-06-14 19:27:43', '2016-06-14 19:27:56', 500.00, 0.00, 533.00, NULL, '::1', NULL, '1465903663'),
(8, 10011, 'Staff', NULL, NULL, '2016-06-16 19:06:14', '2016-06-16 19:13:17', 500.00, 0.00, 326.00, NULL, '::1', NULL, '1466075174'),
(9, 10011, 'Staff', NULL, NULL, '2016-06-17 15:42:43', '2016-06-17 22:12:38', 500.00, 0.00, 1062.00, NULL, '::1', NULL, '1466149363'),
(10, 10011, 'Staff', NULL, NULL, '2016-06-18 21:54:44', '2016-06-18 21:54:56', 500.00, 0.00, 1890.00, NULL, '::1', NULL, '1466258084'),
(11, 10011, 'Staff', NULL, NULL, '2016-06-19 17:51:21', '2016-06-19 21:19:05', 500.00, 0.00, 1413.40, NULL, '::1', NULL, '1466329881'),
(12, 10011, 'Staff', NULL, NULL, '2016-06-20 21:47:50', '2016-06-20 21:48:22', 500.00, 0.00, 743.00, NULL, '::1', NULL, '1466430470'),
(13, 10003, 'admin', NULL, NULL, '2016-06-21 19:58:48', '2016-06-21 22:46:20', 500.00, 0.00, 1024.00, NULL, '::1', NULL, '1466510328'),
(14, NULL, NULL, NULL, NULL, NULL, '2016-06-23 22:24:47', 500.00, 0.00, NULL, NULL, '::1', NULL, NULL),
(15, 10011, 'Staff', NULL, NULL, '2016-06-24 21:35:10', '2016-06-24 21:35:25', 500.00, 0.00, 794.70, NULL, '::1', NULL, '1466775310'),
(16, 10011, 'Staff', NULL, NULL, '2016-06-25 21:40:01', '2016-06-25 21:40:17', 500.00, 0.00, 1907.30, NULL, '::1', NULL, '1466862001'),
(17, 10011, 'Staff', NULL, NULL, '2016-06-26 21:57:20', '2016-06-26 21:57:43', 500.00, 0.00, 1751.35, NULL, '::1', NULL, '1466949440'),
(18, 10011, 'Staff', NULL, NULL, '2016-06-27 21:26:33', '2016-06-27 21:30:36', 500.00, 0.00, 876.80, NULL, '::1', NULL, '1467033993'),
(19, 10011, 'Staff', NULL, NULL, '2016-06-28 20:08:04', '2016-06-28 20:11:27', 500.00, 0.00, 921.20, NULL, '::1', NULL, '1467115684'),
(20, 10011, 'Staff', NULL, NULL, '2016-06-30 19:12:23', '2016-06-30 19:18:04', 500.00, 0.00, 578.00, NULL, '::1', NULL, '1467285143'),
(21, 10011, 'Staff', NULL, NULL, '2016-07-01 22:01:42', '2016-07-01 22:02:02', 500.00, 0.00, 1177.70, NULL, '::1', NULL, '1467381702'),
(22, 10011, 'Staff', NULL, NULL, '2016-07-02 21:29:50', '2016-07-02 21:42:46', 500.00, 0.00, 1172.50, NULL, '::1', NULL, '1467466190'),
(23, 10011, 'Staff', NULL, NULL, '2016-07-03 20:16:14', '2016-07-03 20:16:34', 500.00, 0.00, 1776.60, NULL, '::1', NULL, '1467548174'),
(24, 10011, 'Staff', NULL, NULL, '2016-07-05 21:09:06', '2016-07-05 21:09:22', 500.00, 0.00, 962.00, NULL, '::1', NULL, '1467724146'),
(25, 10011, 'Staff', NULL, NULL, '2016-07-06 21:36:08', '2016-07-06 21:41:39', 500.00, 0.00, 1824.50, NULL, '::1', NULL, '1467812168'),
(26, 10011, 'Staff', NULL, NULL, '2016-07-07 22:10:26', '2016-07-07 22:11:16', 500.00, 0.00, 2143.00, NULL, '::1', NULL, '1467900626'),
(27, 10011, 'Staff', NULL, NULL, '2016-07-08 19:35:05', '2016-07-08 19:35:18', 500.00, 0.00, 1109.00, NULL, '::1', NULL, '1467977705'),
(28, 10011, 'Staff', NULL, NULL, '2016-07-09 22:08:39', '2016-07-09 22:11:15', 500.00, 0.00, 1199.10, NULL, '::1', NULL, '1468073319'),
(29, 10011, 'Staff', NULL, NULL, '2016-07-10 21:27:21', '2016-07-10 21:27:45', 500.00, 0.00, 1674.30, NULL, '::1', NULL, '1468157241'),
(30, 10011, 'Staff', NULL, NULL, '2016-07-11 21:18:57', '2016-07-11 21:19:24', 500.00, 0.00, 767.00, NULL, '::1', NULL, '1468243137'),
(31, 10011, 'Staff', NULL, NULL, '2016-07-12 20:06:16', '2016-07-12 20:06:38', 500.00, 0.00, 525.50, NULL, '::1', NULL, '1468325176'),
(32, 10011, 'Staff', NULL, NULL, '2016-07-14 20:17:04', '2016-07-14 20:17:22', 500.00, 0.00, 887.30, NULL, '::1', NULL, '1468498624'),
(33, 10011, 'Staff', NULL, NULL, '2016-07-15 21:53:58', '2016-07-15 21:54:13', 500.00, 0.00, 1071.70, NULL, '::1', NULL, '1468590838'),
(34, 10011, 'Staff', NULL, NULL, '2016-07-16 21:30:05', '2016-07-16 21:30:22', 500.00, 0.00, 1037.20, NULL, '::1', NULL, '1468675805'),
(35, 10011, 'Staff', NULL, NULL, '2016-07-17 22:38:46', '2016-07-17 22:39:04', 500.00, 0.00, 2065.90, NULL, '::1', NULL, '1468766326'),
(36, 10011, 'Staff', NULL, NULL, '2016-07-18 21:21:13', '2016-07-18 21:21:32', 500.00, 0.00, 832.00, NULL, '::1', NULL, '1468848073'),
(37, 10011, 'Staff', NULL, NULL, '2016-07-19 20:13:58', '2016-07-19 20:14:14', 500.00, 0.00, 892.00, NULL, '::1', NULL, '1468930438'),
(38, 10011, 'Staff', NULL, NULL, '2016-07-21 23:31:05', '2016-07-21 23:32:19', 500.00, 0.00, 944.50, NULL, '::1', NULL, '1469115065'),
(39, 10011, 'Staff', NULL, NULL, '2016-07-22 22:03:17', '2016-07-22 22:03:48', 500.00, 0.00, 764.60, NULL, '::1', NULL, '1469196197'),
(40, 10011, 'Staff', NULL, NULL, '2016-07-23 21:43:16', '2016-07-23 21:45:34', 500.00, 0.00, 1382.00, NULL, '::1', NULL, '1469281396'),
(41, 10010, 'sanni', NULL, NULL, '2016-07-24 19:26:27', '2016-07-24 19:27:40', 500.00, 0.00, 1874.50, NULL, '::1', NULL, '1469359587'),
(42, 10003, 'admin', NULL, NULL, '2016-07-25 19:16:15', '2016-07-25 19:16:46', 500.00, 0.00, 614.00, NULL, '::1', NULL, '1469445375'),
(43, 10003, 'admin', NULL, NULL, '2016-07-26 18:27:43', '2016-07-26 18:28:05', 500.00, 0.00, 430.00, NULL, '::1', NULL, '1469528863'),
(44, 10011, 'Staff', NULL, NULL, '2016-07-28 20:32:43', '2016-07-28 20:55:15', 500.00, 0.00, 767.00, NULL, '::1', NULL, '1469709163'),
(45, 10011, 'Staff', NULL, NULL, '2016-07-29 21:59:07', '2016-07-29 22:00:18', 500.00, 0.00, 950.40, NULL, '::1', NULL, '1469800747'),
(46, 10011, 'Staff', NULL, NULL, '2016-07-30 21:46:45', '2016-07-30 21:47:06', 500.00, 0.00, 1817.00, NULL, '::1', NULL, '1469886405'),
(47, 10003, 'admin', NULL, NULL, '2016-07-31 22:02:53', '2016-07-31 22:03:21', 500.00, 0.00, 1334.00, NULL, '::1', NULL, '1469973773'),
(48, 10011, 'Staff', NULL, NULL, '2016-08-01 11:21:43', '2016-08-01 21:40:52', 500.00, 0.00, 751.00, NULL, '::1', NULL, '1470021703'),
(49, 10003, 'admin', NULL, NULL, '2016-08-02 14:47:18', '2016-08-02 20:20:38', 500.00, 0.00, 432.00, NULL, '::1', NULL, '1470120438'),
(50, 10003, 'admin', NULL, NULL, '2016-08-04 12:37:58', '2016-08-04 20:58:04', 500.00, 0.00, 586.00, NULL, '::1', NULL, '1470285478'),
(51, 10003, 'admin', NULL, NULL, '2016-08-05 19:46:59', '2016-08-05 21:50:50', 500.00, 0.00, 1116.00, NULL, '::1', NULL, '1470397619'),
(52, 10010, 'sanni', NULL, NULL, '2016-08-06 14:32:35', '2016-08-06 21:39:56', 500.00, 0.00, 1817.00, NULL, '::1', NULL, '1470465155'),
(53, 10010, 'sanni', NULL, NULL, '2016-08-07 14:43:33', '2016-08-07 21:21:21', 500.00, 0.00, 2745.70, NULL, '::1', NULL, '1470552213'),
(54, 10003, 'admin', NULL, NULL, '2016-08-08 21:42:53', '2016-08-08 21:44:59', 500.00, 0.00, 1520.00, NULL, '::1', NULL, '1470663773'),
(55, 10010, 'sanni', NULL, NULL, '2016-08-09 12:57:29', '2016-08-09 17:08:04', 500.00, 0.00, 494.90, NULL, '::1', NULL, '1470718649'),
(56, 10003, 'admin', NULL, NULL, '2016-08-11 08:54:55', '2016-08-11 21:48:52', 500.00, 0.00, 751.30, NULL, '::1', NULL, '1470876895'),
(57, 10003, 'admin', NULL, NULL, '2016-08-12 21:20:56', '2016-08-12 22:02:54', 500.00, 0.00, 1030.00, NULL, '::1', NULL, '1471008056'),
(58, 10003, 'admin', NULL, NULL, '2016-08-13 12:57:02', '2016-08-13 21:26:34', 500.00, 0.00, 1184.00, NULL, '::1', NULL, '1471064222'),
(59, 10003, 'admin', NULL, NULL, '2016-08-14 17:22:25', '2016-08-14 19:34:07', 500.00, 0.00, 1610.00, NULL, '::1', NULL, '1471166545'),
(60, 10003, 'admin', NULL, NULL, '2016-08-15 16:14:40', '2016-08-15 22:02:25', 500.00, 0.00, 1412.60, NULL, '::1', NULL, '1471248880'),
(61, 10003, 'admin', NULL, NULL, '2016-08-16 13:07:07', '2016-08-16 19:54:07', 500.00, 0.00, 860.00, NULL, '::1', NULL, '1471324027'),
(62, 10011, 'Staff', NULL, NULL, '2016-08-18 09:29:31', '2016-08-18 21:48:04', 500.00, 0.00, 474.00, NULL, '::1', NULL, '1471483771'),
(63, 10003, 'admin', NULL, NULL, '2016-08-19 21:13:26', '2016-08-19 22:36:46', 500.00, 0.00, 931.80, NULL, '::1', NULL, '1471612406'),
(64, 10003, 'admin', NULL, NULL, '2016-08-20 12:30:29', '2016-08-20 21:39:49', 500.00, 0.00, 882.00, NULL, '::1', NULL, '1471667429'),
(65, 10003, 'admin', NULL, NULL, '2016-08-21 17:07:31', '2016-08-21 21:07:24', 500.00, 0.00, 2036.20, NULL, '::1', NULL, '1471770451'),
(66, 10003, 'admin', NULL, NULL, '2016-08-22 16:55:01', '2016-08-22 21:18:07', 500.00, 0.00, 576.00, NULL, '::1', NULL, '1471856101'),
(67, 10003, 'admin', NULL, NULL, '2016-08-23 09:05:53', '2016-08-23 18:48:34', 500.00, 0.00, 392.35, NULL, '::1', NULL, '1471914353'),
(68, 10003, 'admin', NULL, NULL, '2016-08-25 12:00:19', '2016-08-25 20:34:44', 500.00, 0.00, 1800.00, NULL, '::1', NULL, '1472097619'),
(69, 10003, 'admin', NULL, NULL, '2016-08-26 12:28:14', '2016-08-26 21:17:28', 500.00, 0.00, 876.00, NULL, '::1', NULL, '1472185694'),
(70, 10003, 'admin', NULL, NULL, '2016-08-27 20:26:50', '2016-08-27 22:04:58', 500.00, 0.00, 1818.20, NULL, '::1', NULL, '1472300810'),
(71, 10003, 'admin', NULL, NULL, '2016-08-28 19:00:11', '2016-08-28 21:47:33', 500.00, 0.00, 2569.00, NULL, '::1', NULL, '1472382011'),
(72, 10003, 'admin', NULL, NULL, '2016-08-29 19:44:54', '2016-08-29 22:02:06', 500.00, 0.00, 550.80, NULL, '::1', NULL, '1472471094'),
(73, 10003, 'admin', NULL, NULL, '2016-08-31 19:18:47', '2016-08-31 21:12:35', 500.00, 0.00, 1386.00, NULL, '::1', NULL, '1472642327'),
(74, 10003, 'admin', NULL, NULL, '2016-09-01 11:39:35', '2016-09-01 20:34:44', 500.00, 0.00, 471.30, NULL, '::1', NULL, '1472701175'),
(75, 10003, 'admin', NULL, NULL, '2016-09-02 20:41:22', '2016-09-02 21:36:39', 500.00, 0.00, 1309.10, NULL, '::1', NULL, '1472820082'),
(76, 10003, 'admin', NULL, NULL, '2016-09-03 13:11:09', '2016-09-03 22:29:28', 500.00, 0.00, 1833.10, NULL, '::1', NULL, '1472879469'),
(77, 10003, 'admin', NULL, NULL, '2016-09-04 19:45:30', '2016-09-04 20:43:52', 500.00, 0.00, 2157.00, NULL, '::1', NULL, '1472989530'),
(78, 10003, 'admin', NULL, NULL, '2016-09-05 14:43:59', '2016-09-05 22:08:14', 500.00, 0.00, 905.70, NULL, '::1', NULL, '1473057839'),
(79, 10003, 'admin', NULL, NULL, '2016-09-07 20:29:50', '2016-09-07 21:18:24', 500.00, 0.00, 706.00, NULL, '::1', NULL, '1473251390'),
(80, 10003, 'admin', NULL, NULL, '2016-09-08 15:19:10', '2016-09-08 19:55:03', 500.00, 0.00, 984.00, NULL, '::1', NULL, '1473319150'),
(81, 10003, 'admin', NULL, NULL, '2016-09-09 08:58:05', '2016-09-09 19:29:22', 500.00, 0.00, 320.00, NULL, '::1', NULL, '1473382685'),
(82, 10003, 'admin', NULL, NULL, '2016-09-10 11:36:57', '2016-09-10 21:01:46', 500.00, 0.00, 695.10, NULL, '::1', NULL, '1473478617'),
(83, 10003, 'admin', NULL, NULL, '2016-09-11 20:31:09', '2016-09-11 21:50:48', 500.00, 0.00, 2242.25, NULL, '::1', NULL, '1473597069'),
(84, 10003, 'admin', NULL, NULL, '2016-09-12 17:06:12', '2016-09-12 21:19:18', 500.00, 0.00, 1622.70, NULL, '::1', NULL, '1473671172'),
(85, 10003, 'admin', NULL, NULL, '2016-09-14 12:58:47', '2016-09-14 21:58:50', 500.00, 0.00, 768.00, NULL, '::1', NULL, '1473829127'),
(86, 10010, 'sanni', NULL, NULL, '2016-09-15 14:04:25', '2016-09-15 21:52:12', 500.00, 0.00, 652.00, NULL, '::1', NULL, '1473919465'),
(87, 10003, 'admin', NULL, NULL, '2016-09-16 19:49:46', '2016-09-16 22:42:54', 500.00, 0.00, 1319.50, NULL, '::1', NULL, '1474026586'),
(88, 10003, 'admin', NULL, NULL, '2016-09-17 17:32:13', '2016-09-17 20:42:38', 500.00, 0.00, 2045.20, NULL, '::1', NULL, '1474104733'),
(89, 10003, 'admin', NULL, NULL, '2016-09-18 13:28:15', '2016-09-18 20:30:53', 500.00, 0.00, 1560.00, NULL, '::1', NULL, '1474176495'),
(90, 10003, 'admin', NULL, NULL, '2016-09-19 08:56:30', '2016-09-19 18:27:55', 500.00, 0.00, 360.00, NULL, '::1', NULL, '1474246590'),
(91, 10003, 'admin', NULL, NULL, '2016-09-21 20:53:05', '2016-09-21 21:03:02', 500.00, 0.00, 615.00, NULL, '::1', NULL, '1474462385'),
(92, 10003, 'admin', NULL, NULL, '2016-09-22 12:50:58', '2016-09-22 21:00:13', 500.00, 0.00, 1101.00, NULL, '::1', NULL, '1474519858'),
(93, 10003, 'admin', NULL, NULL, '2016-09-23 09:00:19', '2016-09-23 21:39:19', 500.00, 0.00, 780.00, NULL, '::1', NULL, '1474592419'),
(94, 10003, 'admin', NULL, NULL, '2016-09-24 19:13:35', '2016-09-24 20:53:53', 500.00, 0.00, 1762.10, NULL, '::1', NULL, '1474715615'),
(95, 10003, 'admin', NULL, NULL, '2016-09-25 19:31:27', '2016-09-25 21:57:16', 500.00, 0.00, 2644.50, NULL, '::1', NULL, '1474803087'),
(96, 10003, 'admin', NULL, NULL, '2016-09-26 11:05:19', '2016-09-26 17:43:36', 500.00, 0.00, 623.50, NULL, '::1', NULL, '1474859119'),
(97, 10003, 'admin', NULL, NULL, '2016-09-28 17:08:15', '2016-09-28 17:09:45', 500.00, 0.00, 306.50, NULL, '::1', NULL, '1475053695'),
(98, 10003, 'admin', NULL, NULL, '2016-09-29 18:23:01', '2016-09-29 20:07:22', 500.00, 0.00, 911.70, NULL, '::1', NULL, '1475144581'),
(99, 10003, 'admin', NULL, NULL, '2016-09-30 20:14:26', '2016-09-30 21:41:25', 500.00, 0.00, 1137.70, NULL, '::1', NULL, '1475237666'),
(100, 10003, 'admin', NULL, NULL, '2016-10-01 21:26:40', '2016-10-01 22:07:37', 500.00, 0.00, 1773.00, NULL, '::1', NULL, '1475328400'),
(101, 10003, 'admin', NULL, NULL, '2016-10-02 19:34:40', '2016-10-02 21:55:21', 500.00, 0.00, 1698.50, NULL, '::1', NULL, '1475408080'),
(102, 10003, 'admin', NULL, NULL, '2016-10-03 11:32:22', '2016-10-03 19:38:10', 500.00, 0.00, 1064.00, NULL, '::1', NULL, '1475465542'),
(103, 10003, 'admin', NULL, NULL, '2016-10-05 12:46:28', '2016-10-05 21:04:03', 500.00, 0.00, 781.00, NULL, '::1', NULL, '1475642788'),
(104, 10003, 'admin', NULL, NULL, '2016-10-06 18:11:49', '2016-10-06 21:30:35', 500.00, 0.00, 779.00, NULL, '::1', NULL, '1475748709'),
(105, 10003, 'admin', NULL, NULL, '2016-10-07 20:34:10', '2016-10-07 21:56:26', 500.00, 0.00, 1015.00, NULL, '::1', NULL, '1475843650'),
(106, 10003, 'admin', NULL, NULL, '2016-10-08 20:23:03', '2016-10-08 21:55:59', 500.00, 0.00, 1459.30, NULL, '::1', NULL, '1475929383'),
(107, 10003, 'admin', NULL, NULL, '2016-10-09 18:44:17', '2016-10-09 20:48:35', 500.00, 0.00, 1745.00, NULL, '::1', NULL, '1476009857'),
(108, 10003, 'admin', NULL, NULL, '2016-10-10 13:03:25', '2016-10-10 19:52:28', 500.00, 0.00, 673.00, NULL, '::1', NULL, '1476075805'),
(109, 10003, 'admin', NULL, NULL, '2016-10-12 19:55:39', '2016-10-12 21:52:25', 500.00, 0.00, 1054.80, NULL, '::1', NULL, '1476273339'),
(110, 10003, 'admin', NULL, NULL, '2016-10-13 19:25:29', '2016-10-13 21:44:28', 500.00, 0.00, 730.00, NULL, '::1', NULL, '1476357929'),
(111, 10003, 'admin', NULL, NULL, '2016-10-14 17:01:51', '2016-10-14 21:08:42', 500.00, 0.00, 620.00, NULL, '::1', NULL, '1476435711'),
(112, 10003, 'admin', NULL, NULL, '2016-10-15 12:17:16', '2016-10-15 21:24:22', 500.00, 0.00, 1489.00, NULL, '::1', NULL, '1476505036'),
(113, 10003, 'admin', NULL, NULL, '2016-10-16 12:42:30', '2016-10-16 19:35:37', 500.00, 0.00, 1347.00, NULL, '::1', NULL, '1476592950'),
(114, 10003, 'admin', NULL, NULL, '2016-10-17 19:33:21', '2016-10-17 20:58:30', 500.00, 0.00, 854.50, NULL, '::1', NULL, '1476704001'),
(115, 10003, 'admin', NULL, NULL, '2016-10-19 15:04:02', '2016-10-19 20:17:59', 500.00, 0.00, 687.30, NULL, '::1', NULL, '1476860642'),
(116, 10003, 'admin', NULL, NULL, '2016-10-20 15:53:55', '2016-10-20 19:47:06', 500.00, 0.00, 767.00, NULL, '::1', NULL, '1476950035'),
(117, 10003, 'admin', NULL, NULL, '2016-10-21 19:49:57', '2016-10-21 21:52:26', 500.00, 0.00, 1026.30, NULL, '::1', NULL, '1477050597'),
(118, 10003, 'admin', NULL, NULL, '2016-10-22 17:48:06', '2016-10-22 22:44:13', 500.00, 0.00, 1666.70, NULL, '::1', NULL, '1477129686'),
(119, 10003, 'admin', NULL, NULL, '2016-10-23 18:45:27', '2016-10-23 21:18:55', 500.00, 0.00, 2290.70, NULL, '::1', NULL, '1477219527'),
(120, 10003, 'admin', NULL, NULL, '2016-10-24 20:08:21', '2016-10-24 21:18:22', 500.00, 0.00, 1470.30, NULL, '::1', NULL, '1477310901'),
(121, 10003, 'admin', NULL, NULL, '2016-10-26 12:27:33', '2016-10-26 19:48:13', 500.00, 0.00, 576.20, NULL, '::1', NULL, '1477456053'),
(122, 10003, 'admin', NULL, NULL, '2016-10-27 19:06:07', '2016-10-27 21:02:11', 500.00, 0.00, 592.00, NULL, '::1', NULL, '1477566367'),
(123, 10003, 'admin', NULL, NULL, '2016-10-28 20:08:47', '2016-10-28 22:39:18', 500.00, 0.00, 2076.00, NULL, '::1', NULL, '1477656527'),
(124, 10003, 'admin', NULL, NULL, '2016-10-29 13:40:03', '2016-10-29 20:04:19', 500.00, 0.00, 1599.30, NULL, '::1', NULL, '1477719603'),
(125, 10003, 'admin', NULL, NULL, '2016-10-30 20:52:09', '2016-10-30 21:40:11', 500.00, 0.00, 1893.25, NULL, '::1', NULL, '1477831929'),
(126, 10003, 'admin', NULL, NULL, '2016-10-31 17:52:10', '2016-10-31 20:48:09', 500.00, 0.00, 1043.40, NULL, '::1', NULL, '1477907530'),
(127, 10003, 'admin', NULL, NULL, '2016-11-02 13:04:58', '2016-11-02 20:22:14', 500.00, 0.00, 655.00, NULL, '::1', NULL, '1478063098'),
(128, 10003, 'admin', NULL, NULL, '2016-11-03 09:07:47', '2016-11-03 18:46:27', 500.00, 0.00, 510.30, NULL, '::1', NULL, '1478135267'),
(129, 10003, 'admin', NULL, NULL, '2016-11-04 18:45:45', '2016-11-04 20:40:59', 500.00, 0.00, 1060.00, NULL, '::1', NULL, '1478256345'),
(130, 10003, 'admin', NULL, NULL, '2016-11-05 19:44:02', '2016-11-05 21:39:27', 500.00, 0.00, 1416.00, NULL, '::1', NULL, '1478346242'),
(131, 10003, 'admin', NULL, NULL, '2016-11-06 18:26:39', '2016-11-06 20:20:30', 500.00, 0.00, 1240.00, NULL, '::1', NULL, '1478427999'),
(132, 10003, 'admin', NULL, NULL, '2016-11-07 20:09:23', '2016-11-07 21:22:20', 500.00, 0.00, 813.00, NULL, '::1', NULL, '1478520563'),
(133, 10003, 'admin', NULL, NULL, '2016-11-09 12:54:19', '2016-11-09 21:06:57', 500.00, 0.00, 900.00, NULL, '::1', NULL, '1478667259'),
(134, 10003, 'admin', NULL, NULL, '2016-11-10 21:54:43', '2016-11-10 22:01:51', 500.00, 0.00, 784.00, NULL, '::1', NULL, '1478786083'),
(135, 10003, 'admin', NULL, NULL, '2016-11-11 18:25:43', '2016-11-11 21:25:41', 500.00, 0.00, 583.00, NULL, '::1', NULL, '1478859943'),
(136, 10003, 'admin', NULL, NULL, '2016-11-12 15:44:27', '2016-11-12 22:07:32', 500.00, 0.00, 1475.20, NULL, '::1', NULL, '1478936667'),
(137, 10003, 'admin', NULL, NULL, '2016-11-13 14:25:07', '2016-11-13 19:29:17', 500.00, 0.00, 1160.90, NULL, '::1', NULL, '1479018307'),
(138, 10003, 'admin', NULL, NULL, '2016-11-14 19:58:15', '2016-11-14 21:28:50', 500.00, 0.00, 913.60, NULL, '::1', NULL, '1479124695'),
(139, 10003, 'admin', NULL, NULL, '2016-11-16 15:50:53', '2016-11-16 19:33:35', 500.00, 0.00, 765.30, NULL, '::1', NULL, '1479282653'),
(140, 10003, 'admin', NULL, NULL, '2016-11-17 19:48:07', '2016-11-17 21:53:30', 500.00, 0.00, 525.00, NULL, '::1', NULL, '1479383287'),
(141, 10003, 'admin', NULL, NULL, '2016-11-18 11:17:54', '2016-11-18 21:42:40', 500.00, 0.00, 657.30, NULL, '::1', NULL, '1479439074'),
(142, 10003, 'admin', NULL, NULL, '2016-11-19 21:25:29', '2016-11-19 21:45:46', 500.00, 0.00, 1224.00, NULL, '::1', NULL, '1479561929'),
(143, 10003, 'admin', NULL, NULL, '2016-11-20 16:38:38', '2016-11-20 18:34:09', 500.00, 0.00, 2156.00, NULL, '::1', NULL, '1479631118'),
(144, 10003, 'admin', NULL, NULL, '2016-11-21 20:03:07', '2016-11-21 21:19:38', 500.00, 0.00, 1743.60, NULL, '::1', NULL, '1479729787'),
(145, 10003, 'admin', NULL, NULL, '2016-11-23 12:08:38', '2016-11-23 20:08:44', 500.00, 0.00, 674.00, NULL, '::1', NULL, '1479874118'),
(146, 10003, 'admin', NULL, NULL, '2016-11-24 12:48:39', '2016-11-24 21:10:23', 500.00, 0.00, 679.60, NULL, '::1', NULL, '1479962919'),
(147, 10003, 'admin', NULL, NULL, '2016-11-25 11:18:35', '2016-11-25 21:04:32', 500.00, 0.00, 813.50, NULL, '::1', NULL, '1480043915'),
(148, 10003, 'admin', NULL, NULL, '2016-11-26 16:08:19', '2016-11-26 21:41:09', 500.00, 0.00, 1474.00, NULL, '::1', NULL, '1480147699'),
(149, 10003, 'admin', NULL, NULL, '2016-11-27 17:05:24', '2016-11-27 17:16:00', 500.00, 456.00, 260.00, NULL, '::1', NULL, '1480237524'),
(150, 10003, 'admin', NULL, NULL, '2016-11-28 12:25:44', '2016-11-28 19:25:58', 500.00, 0.00, 721.00, NULL, '::1', NULL, '1480307144'),
(151, 10003, 'admin', NULL, NULL, '2016-11-30 13:18:36', '2016-11-30 17:51:30', 500.00, 0.00, 255.00, NULL, '::1', NULL, '1480483116'),
(152, 10003, 'admin', NULL, NULL, '2016-12-01 13:39:05', '2016-12-01 20:43:39', 500.00, 0.00, 886.50, NULL, '::1', NULL, '1480570745'),
(153, 10003, 'admin', NULL, NULL, '2016-12-02 21:10:20', '2016-12-02 22:04:03', 500.00, 0.00, 1224.00, NULL, '::1', NULL, '1480684220'),
(154, 10003, 'admin', NULL, NULL, '2016-12-03 18:06:59', '2016-12-03 23:07:39', 500.00, 0.00, 1192.00, NULL, '::1', NULL, '1480759619'),
(155, 10003, 'admin', NULL, NULL, '2016-12-04 18:24:02', '2016-12-04 20:35:30', 500.00, 0.00, 1756.00, NULL, '::1', NULL, '1480847042'),
(156, 10003, 'admin', NULL, NULL, '2016-12-05 14:42:40', '2016-12-05 21:03:11', 500.00, 0.00, 710.80, NULL, '::1', NULL, '1480920160'),
(157, 10003, 'admin', NULL, NULL, '2016-12-07 14:59:09', '2016-12-07 20:48:30', 500.00, 0.00, 619.30, NULL, '::1', NULL, '1481093949'),
(158, 10003, 'admin', NULL, NULL, '2016-12-08 14:09:20', '2016-12-08 19:42:46', 500.00, 0.00, 505.00, NULL, '::1', NULL, '1481177360'),
(159, 10003, 'admin', NULL, NULL, '2016-12-09 08:57:44', '2016-12-09 21:09:42', 500.00, 0.00, 552.30, NULL, '::1', NULL, '1481245064'),
(160, 10003, 'admin', NULL, NULL, '2016-12-10 16:28:34', '2016-12-10 20:45:39', 500.00, 0.00, 1577.50, NULL, '::1', NULL, '1481358514'),
(161, 10003, 'admin', NULL, NULL, '2016-12-11 15:56:12', '2016-12-11 20:39:38', 500.00, 0.00, 1080.80, NULL, '::1', NULL, '1481442972'),
(162, 10003, 'admin', NULL, NULL, '2016-12-12 21:28:00', '2016-12-12 21:32:35', 500.00, 0.00, 2130.10, NULL, '::1', NULL, '1481549280'),
(163, 10003, 'admin', NULL, NULL, '2016-12-14 08:30:17', '2016-12-14 21:34:10', 500.00, 0.00, 759.00, NULL, '::1', NULL, '1481675417'),
(164, 10003, 'admin', NULL, NULL, '2016-12-15 13:45:16', '2016-12-15 22:37:54', 500.00, 0.00, 688.00, NULL, '::1', NULL, '1481780716'),
(165, 10003, 'admin', NULL, NULL, '2016-12-16 14:48:00', '2016-12-16 22:37:31', 500.00, 0.00, 944.10, NULL, '::1', NULL, '1481870880'),
(166, 10003, 'admin', NULL, NULL, '2016-12-17 21:21:52', '2016-12-17 22:37:05', 500.00, 0.00, 1599.20, NULL, '::1', NULL, '1481980912'),
(167, 10003, 'admin', NULL, NULL, '2016-12-18 15:44:23', '2016-12-18 21:36:28', 500.00, 0.00, 1953.50, NULL, '::1', NULL, '1482047063'),
(168, 10003, 'admin', NULL, NULL, '2016-12-19 18:28:10', '2016-12-19 19:47:37', 500.00, 0.00, 730.00, NULL, '::1', NULL, '1482143290'),
(169, 10003, 'admin', NULL, NULL, '2016-12-21 11:07:16', '2016-12-21 18:23:40', 500.00, 0.00, 719.00, NULL, '::1', NULL, '1482289636'),
(170, 10003, 'admin', NULL, NULL, '2016-12-22 19:37:19', '2016-12-22 21:03:01', 500.00, 0.00, 921.30, NULL, '::1', NULL, '1482406639'),
(171, 10003, 'admin', NULL, NULL, '2016-12-23 19:13:09', '2016-12-23 21:39:26', 500.00, 0.00, 1361.00, NULL, '::1', NULL, '1482491589'),
(172, 10003, 'admin', NULL, NULL, '2016-12-24 19:48:00', '2016-12-24 21:55:08', 500.00, 0.00, 2289.45, NULL, '::1', NULL, '1482580080'),
(173, 10003, 'admin', NULL, NULL, '2016-12-25 19:33:27', '2016-12-25 21:18:49', 500.00, 0.00, 2383.60, NULL, '::1', NULL, '1482665607'),
(174, 10003, 'admin', NULL, NULL, '2016-12-26 14:14:13', '2016-12-26 20:53:09', 500.00, 0.00, 2431.90, NULL, '::1', NULL, '1482732853'),
(175, 10003, 'admin', NULL, NULL, '2016-12-28 18:26:40', '2016-12-28 20:35:38', 500.00, 0.00, 1316.00, NULL, '::1', NULL, '1482920800'),
(176, 10003, 'admin', NULL, NULL, '2016-12-29 11:02:10', '2016-12-29 19:55:56', 500.00, 0.00, 594.00, NULL, '::1', NULL, '1482980530'),
(177, 10003, 'admin', NULL, NULL, '2016-12-30 10:48:44', '2016-12-30 21:58:15', 500.00, 0.00, 1405.50, NULL, '::1', NULL, '1483066124'),
(178, 10003, 'admin', NULL, NULL, '2016-12-31 20:55:30', '2017-01-01 00:23:37', 500.00, 0.00, 2203.60, NULL, '::1', NULL, '1483188930'),
(179, 10003, 'admin', NULL, NULL, '2017-01-01 15:28:10', '2017-01-01 20:56:21', 500.00, 0.00, 2090.00, NULL, '::1', NULL, '1483255690'),
(180, 10003, 'admin', NULL, NULL, '2017-01-02 14:11:13', '2017-01-02 20:33:05', 500.00, 0.00, 1780.00, NULL, '::1', NULL, '1483337473'),
(181, 10003, 'admin', NULL, NULL, '2017-01-04 13:51:22', '2017-01-04 20:17:18', 500.00, 0.00, 1357.00, NULL, '::1', NULL, '1483509082'),
(182, 10003, 'admin', NULL, NULL, '2017-01-05 12:59:11', '2017-01-05 19:18:09', 500.00, 0.00, 1112.00, NULL, '::1', NULL, '1483592351'),
(183, 10003, 'admin', NULL, NULL, '2017-01-06 12:33:34', '2017-01-06 19:29:11', 500.00, 0.00, 1191.50, NULL, '::1', NULL, '1483677214'),
(184, 10003, 'admin', NULL, NULL, '2017-01-07 20:34:48', '2017-01-07 21:30:56', 500.00, 0.00, 1194.10, NULL, '::1', NULL, '1483792488'),
(185, 10003, 'admin', NULL, NULL, '2017-01-08 20:15:32', '2017-01-08 21:57:48', 500.00, 0.00, 2602.50, NULL, '::1', NULL, '1483877732'),
(186, 10003, 'admin', NULL, NULL, '2017-01-09 11:45:58', '2017-01-09 19:26:17', 500.00, 0.00, 877.00, NULL, '::1', NULL, '1483933558'),
(187, 10003, 'admin', NULL, NULL, '2017-01-11 14:31:07', '2017-01-11 20:55:15', 500.00, 0.00, 730.30, NULL, '::1', NULL, '1484116267'),
(188, 10003, 'admin', NULL, NULL, '2017-01-12 12:28:28', '2017-01-12 20:00:22', 500.00, 0.00, 477.00, NULL, '::1', NULL, '1484195308'),
(189, 10003, 'admin', NULL, NULL, '2017-01-13 11:53:50', '2017-01-13 18:13:14', 500.00, 0.00, 465.00, NULL, '::1', NULL, '1484279630'),
(190, 10003, 'admin', NULL, NULL, '2017-01-14 14:33:02', '2017-01-14 17:52:19', 500.00, 0.00, 1073.00, NULL, '::1', NULL, '1484375582'),
(191, 10003, 'admin', NULL, NULL, '2017-01-15 12:26:59', '2017-01-15 17:58:36', 500.00, 0.00, 1101.50, NULL, '::1', NULL, '1484454419'),
(192, 10003, 'admin', NULL, NULL, '2017-01-16 20:01:02', '2017-01-16 21:24:38', 500.00, 0.00, 1105.40, NULL, '::1', NULL, '1484568062'),
(193, 10003, 'admin', NULL, NULL, '2017-01-18 13:17:16', '2017-01-18 20:53:14', 500.00, 0.00, 952.00, NULL, '::1', NULL, '1484716636'),
(194, 10003, 'admin', NULL, NULL, '2017-01-19 20:34:56', '2017-01-19 20:49:02', 500.00, 0.00, 1262.00, NULL, '::1', NULL, '1484829296'),
(195, 10003, 'admin', NULL, NULL, '2017-01-20 13:28:45', '2017-01-20 18:25:26', 500.00, 0.00, 803.00, NULL, '::1', NULL, '1484890125'),
(196, 10003, 'admin', NULL, NULL, '2017-01-21 13:57:43', '2017-01-21 20:04:41', 500.00, 0.00, 1429.00, NULL, '::1', NULL, '1484978263'),
(197, 10003, 'admin', NULL, NULL, '2017-01-22 14:32:02', '2017-01-22 19:46:27', 500.00, 0.00, 1618.50, NULL, '::1', NULL, '1485066722'),
(198, 10003, 'admin', NULL, NULL, '2017-01-23 12:17:02', '2017-01-23 18:52:09', 500.00, 0.00, 669.10, NULL, '::1', NULL, '1485145022'),
(199, 10003, 'admin', NULL, NULL, '2017-01-25 11:50:11', '2017-01-25 19:11:23', 500.00, 0.00, 650.70, NULL, '::1', NULL, '1485316211'),
(200, 10003, 'admin', NULL, NULL, '2017-01-31 13:04:49', '2017-01-31 13:47:31', 500.00, 0.00, 18.00, NULL, '::1', NULL, '1485839089'),
(201, 10003, 'admin', NULL, NULL, '2017-02-01 14:04:59', '2017-02-01 21:49:50', 500.00, 0.00, 1398.80, NULL, '::1', NULL, '1485929099'),
(202, 10003, 'admin', NULL, NULL, '2017-02-02 14:51:32', '2017-02-02 21:12:35', 500.00, 0.00, 1729.90, NULL, '::1', NULL, '1486018292'),
(203, 10003, 'admin', NULL, NULL, '2017-02-03 18:31:10', '2017-02-03 22:23:50', 500.00, 0.00, 2243.50, NULL, '::1', NULL, '1486117870'),
(204, 10003, 'admin', NULL, NULL, '2017-02-04 14:41:44', '2017-02-04 19:35:41', 500.00, 0.00, 1696.30, NULL, '::1', NULL, '1486190504'),
(205, 10003, 'admin', NULL, NULL, '2017-02-05 21:25:52', '2017-02-05 22:08:28', 500.00, 0.00, 2277.60, NULL, '::1', NULL, '1486301152'),
(206, 10003, 'admin', NULL, NULL, '2017-02-06 14:30:00', '2017-02-06 18:48:11', 500.00, 0.00, 614.00, NULL, '::1', NULL, '1486362600'),
(207, 10003, 'admin', NULL, NULL, '2017-02-08 12:45:37', '2017-02-08 18:02:23', 500.00, 0.00, 317.00, NULL, '::1', NULL, '1486529137'),
(208, 10003, 'admin', NULL, NULL, '2017-02-09 15:34:42', '2017-02-09 19:18:50', 500.00, 0.00, 897.50, NULL, '::1', NULL, '1486625682'),
(209, 10003, 'admin', NULL, NULL, '2017-02-10 13:48:33', '2017-02-10 20:14:44', 500.00, 0.00, 793.50, NULL, '::1', NULL, '1486705713'),
(210, 10003, 'admin', NULL, NULL, '2017-02-11 18:09:05', '2017-02-11 21:11:25', 500.00, 0.00, 1970.00, NULL, '::1', NULL, '1486807745'),
(211, 10003, 'admin', NULL, NULL, '2017-02-12 14:15:31', '2017-02-12 19:01:56', 500.00, 0.00, 1838.20, NULL, '::1', NULL, '1486880131'),
(212, 10003, 'admin', NULL, NULL, '2017-02-13 13:13:56', '2017-02-13 18:21:39', 500.00, 0.00, 1162.00, NULL, '::1', NULL, '1486962836'),
(213, 10003, 'admin', NULL, NULL, '2017-02-15 12:59:37', '2017-02-15 19:58:24', 500.00, 0.00, 1329.25, NULL, '::1', NULL, '1487134777'),
(214, 10003, 'admin', NULL, NULL, '2017-02-16 11:24:51', '2017-02-16 20:36:11', 500.00, 0.00, 752.70, NULL, '::1', NULL, '1487215491'),
(215, 10003, 'admin', NULL, NULL, '2017-02-17 13:08:54', '2017-02-17 19:56:41', 500.00, 0.00, 1379.15, NULL, '::1', NULL, '1487308134'),
(216, 10003, 'admin', NULL, NULL, '2017-02-18 19:47:47', '2017-02-18 20:18:58', 500.00, 0.00, 1737.60, NULL, '::1', NULL, '1487418467'),
(217, 10003, 'admin', NULL, NULL, '2017-02-19 17:06:05', '2017-02-19 17:39:26', 500.00, 0.00, 2218.00, NULL, '::1', NULL, '1487495165'),
(218, 10003, 'admin', NULL, NULL, '2017-02-20 19:14:12', '2017-02-20 20:31:31', 500.00, 0.00, 920.25, NULL, '::1', NULL, '1487589252'),
(219, 10003, 'admin', NULL, NULL, '2017-02-22 09:14:14', '2017-02-22 20:40:47', 500.00, 0.00, 951.35, NULL, '::1', NULL, '1487726054'),
(220, 10003, 'admin', NULL, NULL, '2017-02-23 20:13:33', '2017-02-23 21:19:21', 500.00, 0.00, 1429.10, NULL, '::1', NULL, '1487852013'),
(221, 10003, 'admin', NULL, NULL, '2017-02-24 20:21:30', '2017-02-24 21:17:44', 500.00, 0.00, 1561.00, NULL, '::1', NULL, '1487938890'),
(222, 10003, 'admin', NULL, NULL, '2017-02-25 19:18:18', '2017-02-25 20:35:20', 500.00, 0.00, 2587.60, NULL, '::1', NULL, '1488021498'),
(223, 10003, 'admin', NULL, NULL, '2017-02-26 15:15:51', '2017-02-26 20:01:17', 500.00, 0.00, 1953.50, NULL, '::1', NULL, '1488093351'),
(224, 10003, 'admin', NULL, NULL, '2017-02-27 18:55:00', '2017-02-27 21:11:46', 500.00, 0.00, 1211.85, NULL, '::1', NULL, '1488192900'),
(225, 10003, 'admin', NULL, NULL, '2017-03-01 15:02:37', '2017-03-01 19:47:40', 500.00, 0.00, 1029.40, NULL, '::1', NULL, '1488351757'),
(226, 10003, 'admin', NULL, NULL, '2017-03-02 18:31:41', '2017-03-02 19:59:37', 500.00, 0.00, 1504.70, NULL, '::1', NULL, '1488450701'),
(227, 10003, 'admin', NULL, NULL, '2017-03-03 13:26:39', '2017-03-03 20:03:36', 500.00, 0.00, 1653.70, NULL, '::1', NULL, '1488518799'),
(228, 10003, 'admin', NULL, NULL, '2017-03-04 14:13:22', '2017-03-04 20:30:59', 500.00, 0.00, 2320.65, NULL, '::1', NULL, '1488608002'),
(229, 10003, 'admin', NULL, NULL, '2017-03-05 16:24:26', '2017-03-05 20:09:41', 500.00, 0.00, 3001.95, NULL, '::1', NULL, '1488702266'),
(230, 10003, 'admin', NULL, NULL, '2017-03-06 13:15:03', '2017-03-06 20:43:22', 500.00, 0.00, 1752.60, NULL, '::1', NULL, '1488777303'),
(231, 10003, 'admin', NULL, NULL, '2017-03-08 15:51:38', '2017-03-08 20:41:58', 500.00, 0.00, 1301.20, NULL, '::1', NULL, '1488959498'),
(232, 10003, 'admin', NULL, NULL, '2017-03-09 12:38:43', '2017-03-09 18:33:27', 500.00, 0.00, 428.00, NULL, '::1', NULL, '1489034323'),
(233, 10003, 'admin', NULL, NULL, '2017-03-10 13:25:43', '2017-03-10 18:08:06', 500.00, 0.00, 548.15, NULL, '::1', NULL, '1489123543'),
(234, 10003, 'admin', NULL, NULL, '2017-03-11 14:08:59', '2017-03-11 19:48:20', 500.00, 0.00, 1946.35, NULL, '::1', NULL, '1489212539'),
(235, 10003, 'admin', NULL, NULL, '2017-03-12 14:12:22', '2017-03-12 19:38:31', 500.00, 0.00, 2460.90, NULL, '::1', NULL, '1489299142'),
(236, 10003, 'admin', NULL, NULL, '2017-03-13 13:53:17', '2017-03-13 22:11:22', 500.00, 0.00, 1394.20, NULL, '::1', NULL, '1489384397'),
(237, 10003, 'admin', NULL, NULL, '2017-03-15 13:28:55', '2017-03-15 21:33:58', 500.00, 0.00, 809.30, NULL, '::1', NULL, '1489555735'),
(238, 10003, 'admin', NULL, NULL, '2017-03-16 12:56:09', '2017-03-16 18:43:14', 500.00, 0.00, 773.90, NULL, '::1', NULL, '1489640169'),
(239, 10003, 'admin', NULL, NULL, '2017-03-17 14:32:19', '2017-03-17 21:21:06', 500.00, 0.00, 1429.35, NULL, '::1', NULL, '1489732339'),
(240, 10003, 'admin', NULL, NULL, '2017-03-18 18:36:20', '2017-03-18 21:14:49', 500.00, 0.00, 2629.15, NULL, '::1', NULL, '1489833380'),
(241, 10003, 'admin', NULL, NULL, '2017-03-19 17:45:54', '2017-03-19 19:43:48', 500.00, 0.00, 2181.20, NULL, '::1', NULL, '1489916754'),
(242, 10003, 'admin', NULL, NULL, '2017-03-20 20:44:53', '2017-03-20 22:02:57', 500.00, 0.00, 1286.90, NULL, '::1', NULL, '1490013893'),
(243, 10003, 'admin', NULL, NULL, '2017-03-22 13:45:51', '2017-03-22 19:35:39', 500.00, 0.00, 1410.50, NULL, '::1', NULL, '1490161551'),
(244, 10003, 'admin', NULL, NULL, '2017-03-23 13:45:53', '2017-03-23 18:45:44', 500.00, 0.00, 941.70, NULL, '::1', NULL, '1490247953'),
(245, 10003, 'admin', NULL, NULL, '2017-03-24 13:16:09', '2017-03-24 21:11:34', 500.00, 0.00, 1234.30, NULL, '::1', NULL, '1490332569'),
(246, 10003, 'admin', NULL, NULL, '2017-03-25 14:22:27', '2017-03-25 19:28:32', 500.00, 0.00, 1495.15, NULL, '::1', NULL, '1490422947'),
(247, 10003, 'admin', NULL, NULL, '2017-03-26 13:32:56', '2017-03-26 17:49:38', 500.00, 0.00, 1843.75, NULL, '::1', NULL, '1490506376'),
(248, 10003, 'admin', NULL, NULL, '2017-03-27 15:40:59', '2017-03-27 20:58:01', 500.00, 0.00, 1164.20, NULL, '::1', NULL, '1490600459'),
(249, 10003, 'admin', NULL, NULL, '2017-03-29 13:09:57', '2017-03-29 18:18:20', 500.00, 0.00, 1107.90, NULL, '::1', NULL, '1490764197'),
(250, 10003, 'admin', NULL, NULL, '2017-03-30 11:55:16', '2017-03-30 19:52:39', 500.00, 0.00, 1058.70, NULL, '::1', NULL, '1490846116'),
(251, 10003, 'admin', NULL, NULL, '2017-03-31 18:07:32', '2017-03-31 19:50:04', 500.00, 0.00, 932.00, NULL, '::1', NULL, '1490954852'),
(252, 10003, 'admin', NULL, NULL, '2017-04-01 13:54:12', '2017-04-01 18:37:34', 500.00, 0.00, 1374.75, NULL, '::1', NULL, '1491026052'),
(253, 10003, 'admin', NULL, NULL, '2017-04-02 13:12:26', '2017-04-02 21:14:32', 500.00, 0.00, 2302.45, NULL, '::1', NULL, '1491109946'),
(254, 10003, 'admin', NULL, NULL, '2017-04-03 13:10:25', '2017-04-03 18:37:08', 500.00, 0.00, 977.10, NULL, '::1', NULL, '1491196225'),
(255, 10003, 'admin', NULL, NULL, '2017-04-06 08:49:53', '2017-04-06 08:52:07', 500.00, 0.00, 628.65, NULL, '::1', NULL, '1491439793'),
(256, 10003, 'admin', NULL, NULL, '2017-04-06 18:13:07', '2017-04-06 19:12:47', 500.00, 0.00, 759.10, NULL, '::1', NULL, '1491473587'),
(257, 10003, 'admin', NULL, NULL, '2017-04-07 13:36:04', '2017-04-07 18:16:38', 500.00, 0.00, 690.80, NULL, '::1', NULL, '1491543364'),
(258, 10003, 'admin', NULL, NULL, '2017-04-08 17:41:34', '2017-04-08 19:05:06', 500.00, 0.00, 1544.60, NULL, '::1', NULL, '1491644494'),
(259, 10003, 'admin', NULL, NULL, '2017-04-09 15:48:04', '2017-04-09 17:48:44', 500.00, 0.00, 3294.85, NULL, '::1', NULL, '1491724084'),
(260, 10003, 'admin', NULL, NULL, '2017-04-10 14:16:00', '2017-04-10 19:06:34', 500.00, 0.00, 1056.10, NULL, '::1', NULL, '1491804960'),
(261, 10003, 'admin', NULL, NULL, '2017-04-12 08:51:45', '2017-04-12 19:52:59', 500.00, 0.00, 676.55, NULL, '::1', NULL, '1491958305'),
(262, 10003, 'admin', NULL, NULL, '2017-04-13 10:56:31', '2017-04-13 18:02:16', 500.00, 0.00, 735.55, NULL, '::1', NULL, '1492052191'),
(263, 10003, 'admin', NULL, NULL, '2017-04-14 12:19:47', '2017-04-14 17:40:25', 500.00, 0.00, 1304.40, NULL, '::1', NULL, '1492143587'),
(264, 10003, 'admin', NULL, NULL, '2017-04-15 14:19:15', '2017-04-15 16:51:48', 500.00, 0.00, 1752.50, NULL, '::1', NULL, '1492237155'),
(265, 10003, 'admin', NULL, NULL, '2017-04-16 13:43:02', '2017-04-16 17:33:45', 500.00, 0.00, 2518.45, NULL, '::1', NULL, '1492321382'),
(266, 10003, 'admin', NULL, NULL, '2017-04-22 14:05:55', '2017-04-22 17:22:00', 500.00, 0.00, 1864.25, NULL, '::1', NULL, '1492841155'),
(267, 10003, 'admin', NULL, NULL, '2017-04-23 16:27:28', '2017-04-23 17:35:35', 500.00, 0.00, 2218.70, NULL, '::1', NULL, '1492936048'),
(268, 10003, 'admin', NULL, NULL, '2017-04-24 14:23:12', '2017-04-24 17:56:48', 500.00, 0.00, 1733.45, NULL, '::1', NULL, '1493014992'),
(269, 10003, 'admin', NULL, NULL, '2017-04-26 17:44:54', '2017-04-26 18:40:30', 500.00, 0.00, 712.25, NULL, '::1', NULL, '1493199894'),
(270, 10003, 'admin', NULL, NULL, '2017-04-27 15:27:37', '2017-04-27 18:22:48', 500.00, 0.00, 702.90, NULL, '::1', NULL, '1493278057'),
(271, 10003, 'admin', NULL, NULL, '2017-04-28 12:27:52', '2017-04-28 18:21:41', 500.00, 0.00, 720.80, NULL, '::1', NULL, '1493353672'),
(272, 10003, 'admin', NULL, NULL, '2017-04-29 13:56:38', '2017-04-29 18:55:29', 500.00, 0.00, 1170.50, NULL, '::1', NULL, '1493445398'),
(273, 10003, 'admin', NULL, NULL, '2017-04-30 13:42:23', '2017-04-30 18:00:25', 500.00, 0.00, 2868.80, NULL, '::1', NULL, '1493530943'),
(274, 10003, 'admin', NULL, NULL, '2017-05-01 18:32:34', '2017-05-01 19:17:30', 500.00, 0.00, 3335.45, NULL, '::1', NULL, '1493634754'),
(275, 10003, 'admin', NULL, NULL, '2017-05-03 12:45:46', '2017-05-03 17:51:38', 500.00, 0.00, 981.40, NULL, '::1', NULL, '1493786746'),
(276, 10003, 'admin', NULL, NULL, '2017-05-04 10:25:27', '2017-05-04 18:17:53', 500.00, 0.00, 730.30, NULL, '::1', NULL, '1493864727'),
(277, 10003, 'admin', NULL, NULL, '2017-05-05 09:19:24', '2017-05-05 17:41:50', 500.00, 0.00, 566.60, NULL, '::1', NULL, '1493947164'),
(278, 10003, 'admin', NULL, NULL, '2017-05-06 17:46:07', '2017-05-06 18:32:10', 500.00, 0.00, 2164.85, NULL, '::1', NULL, '1494063967'),
(279, 10003, 'admin', NULL, NULL, '2017-05-07 14:19:06', '2017-05-07 17:44:01', 500.00, 0.00, 2249.40, NULL, '::1', NULL, '1494137946'),
(280, 10003, 'admin', NULL, NULL, '2017-05-08 14:55:10', '2017-05-08 17:54:52', 500.00, 0.00, 962.50, NULL, '::1', NULL, '1494226510'),
(281, 10003, 'admin', NULL, NULL, '2017-05-10 14:44:51', '2017-05-10 18:06:51', 500.00, 0.00, 2005.50, NULL, '::1', NULL, '1494398691'),
(282, 10003, 'admin', NULL, NULL, '2017-05-11 13:11:51', '2017-05-11 18:56:07', 500.00, 0.00, 944.80, NULL, '::1', NULL, '1494479511'),
(283, 10003, 'admin', NULL, NULL, '2017-05-12 13:38:39', '2017-05-12 18:18:32', 500.00, 0.00, 1112.30, NULL, '::1', NULL, '1494567519'),
(284, 10003, 'admin', NULL, NULL, '2017-05-13 12:36:16', '2017-05-13 18:33:34', 500.00, 0.00, 2408.50, NULL, '::1', NULL, '1494650176'),
(285, 10003, 'admin', NULL, NULL, '2017-05-14 13:54:35', '2017-05-14 18:45:46', 500.00, 0.00, 3636.90, NULL, '::1', NULL, '1494741275'),
(286, 10003, 'admin', NULL, NULL, '2017-05-15 13:48:40', '2017-05-15 17:51:39', 500.00, 0.00, 1293.90, NULL, '::1', NULL, '1494827320'),
(287, 10003, 'admin', NULL, NULL, '2017-05-17 13:49:03', '2017-05-17 18:28:22', 500.00, 0.00, 1090.30, NULL, '::1', NULL, '1495000143'),
(288, 10003, 'admin', NULL, NULL, '2017-05-18 13:24:58', '2017-05-18 17:06:42', 500.00, 0.00, 308.45, NULL, '::1', NULL, '1495085098'),
(289, 10003, 'admin', NULL, NULL, '2017-05-19 13:10:43', '2017-05-19 17:33:08', 500.00, 0.00, 719.60, NULL, '::1', NULL, '1495170643'),
(290, 10003, 'admin', NULL, NULL, '2017-05-20 16:24:27', '2017-05-20 17:46:31', 500.00, 0.00, 1726.70, NULL, '::1', NULL, '1495268667'),
(291, 10003, 'admin', NULL, NULL, '2017-05-21 14:55:21', '2017-05-21 18:14:00', 500.00, 0.00, 2476.70, NULL, '::1', NULL, '1495349721'),
(292, 10003, 'admin', NULL, NULL, '2017-05-22 14:56:58', '2017-05-22 17:54:23', 500.00, 0.00, 872.00, NULL, '::1', NULL, '1495436218'),
(293, 10003, 'admin', NULL, NULL, '2017-05-24 09:22:29', '2017-05-24 18:13:41', 500.00, 0.00, 916.30, NULL, '::1', NULL, '1495588949'),
(294, 10003, 'admin', NULL, NULL, '2017-05-25 13:41:38', '2017-05-25 17:54:35', 500.00, 0.00, 1051.80, NULL, '::1', NULL, '1495690898'),
(295, 10003, 'admin', NULL, NULL, '2017-05-26 15:46:21', '2017-05-26 18:30:21', 500.00, 0.00, 1456.80, NULL, '::1', NULL, '1495784781'),
(296, 10003, 'admin', NULL, NULL, '2017-05-27 14:26:17', '2017-05-27 18:23:56', 500.00, 0.00, 3828.75, NULL, '::1', NULL, '1495866377'),
(297, 10003, 'admin', NULL, NULL, '2017-05-28 12:38:02', '2017-05-28 16:57:28', 500.00, 0.00, 2821.30, NULL, '::1', NULL, '1495946282'),
(298, 10003, 'admin', NULL, NULL, '2017-05-29 13:48:45', '2017-05-29 18:07:00', 500.00, 0.00, 1518.20, NULL, '::1', NULL, '1496036925'),
(299, 10003, 'admin', NULL, NULL, '2017-05-31 14:48:40', '2017-05-31 18:11:08', 500.00, 0.00, 1395.30, NULL, '::1', NULL, '1496213320'),
(300, 10003, 'admin', NULL, NULL, '2017-06-01 10:36:16', '2017-06-01 18:20:54', 500.00, 0.00, 959.60, NULL, '::1', NULL, '1496284576'),
(301, 10003, 'admin', NULL, NULL, '2017-06-02 11:03:53', '2017-06-02 18:23:57', 500.00, 0.00, 1147.20, NULL, '::1', NULL, '1496372633'),
(302, 10003, 'admin', NULL, NULL, '2017-06-03 14:27:55', '2017-06-03 17:57:47', 500.00, 0.00, 2726.70, NULL, '::1', NULL, '1496471275'),
(303, 10003, 'admin', NULL, NULL, '2017-06-04 14:13:58', '2017-06-04 16:08:52', 500.00, 0.00, 2225.50, NULL, '::1', NULL, '1496556838'),
(304, 10003, 'admin', NULL, NULL, '2017-06-05 13:42:20', '2017-06-05 17:58:48', 500.00, 0.00, 1196.95, NULL, '::1', NULL, '1496641340'),
(305, 10003, 'admin', NULL, NULL, '2017-06-07 12:44:29', '2017-06-07 18:00:51', 500.00, 0.00, 708.45, NULL, '::1', NULL, '1496810669'),
(306, 10003, 'admin', NULL, NULL, '2017-06-08 14:02:55', '2017-06-08 18:14:50', 500.00, 0.00, 1132.90, NULL, '::1', NULL, '1496901775'),
(307, 10003, 'admin', NULL, NULL, '2017-06-09 14:33:47', '2017-06-09 18:45:04', 500.00, 0.00, 1055.30, NULL, '::1', NULL, '1496990027'),
(308, 10003, 'admin', NULL, NULL, '2017-06-10 15:14:03', '2017-06-10 17:23:20', 500.00, 0.00, 2512.35, NULL, '::1', NULL, '1497078843'),
(309, 10003, 'admin', NULL, NULL, '2017-06-11 13:20:10', '2017-06-11 18:13:09', 500.00, 0.00, 2216.60, NULL, '::1', NULL, '1497158410'),
(310, 10003, 'admin', NULL, NULL, '2017-06-12 15:06:24', '2017-06-12 18:29:15', 500.00, 0.00, 1812.45, NULL, '::1', NULL, '1497251184'),
(311, 10003, 'admin', NULL, NULL, '2017-06-14 11:49:45', '2017-06-14 17:45:30', 500.00, 0.00, 1059.10, NULL, '::1', NULL, '1497412185'),
(312, 10003, 'admin', NULL, NULL, '2017-06-15 14:30:26', '2017-06-15 17:36:31', 500.00, 0.00, 1463.00, NULL, '::1', NULL, '1497508226'),
(313, 10003, 'admin', NULL, NULL, '2017-06-16 14:32:59', '2017-06-16 17:44:37', 500.00, 0.00, 976.25, NULL, '::1', NULL, '1497594779'),
(314, 10003, 'admin', NULL, NULL, '2017-06-17 16:04:02', '2017-06-17 18:01:40', 500.00, 0.00, 2074.15, NULL, '::1', NULL, '1497686642'),
(315, 10003, 'admin', NULL, NULL, '2017-06-18 13:48:22', '2017-06-18 17:38:57', 500.00, 0.00, 2591.30, NULL, '::1', NULL, '1497764902'),
(316, 10003, 'admin', NULL, NULL, '2017-06-19 14:42:05', '2017-06-19 17:56:50', 500.00, 0.00, 1345.75, NULL, '::1', NULL, '1497854525'),
(317, 10003, 'admin', NULL, NULL, '2017-06-21 13:40:46', '2017-06-21 18:04:07', 500.00, 0.00, 1278.80, NULL, '::1', NULL, '1498023646'),
(318, 10003, 'admin', NULL, NULL, '2017-06-22 12:16:48', '2017-06-22 17:41:20', 500.00, 0.00, 1136.90, NULL, '::1', NULL, '1498105008'),
(319, 10003, 'admin', NULL, NULL, '2017-06-23 13:25:04', '2017-06-23 18:10:54', 500.00, 0.00, 988.90, NULL, '::1', NULL, '1498195504'),
(320, 10003, 'admin', NULL, NULL, '2017-06-24 14:55:16', '2017-06-24 17:59:48', 500.00, 0.00, 1905.90, NULL, '::1', NULL, '1498287316'),
(321, 10003, 'admin', NULL, NULL, '2017-06-25 14:04:48', '2017-06-25 18:03:17', 500.00, 0.00, 3304.05, NULL, '::1', NULL, '1498370688'),
(322, 10003, 'admin', NULL, NULL, '2017-06-26 14:05:27', '2017-06-26 18:05:31', 500.00, 0.00, 3474.90, NULL, '::1', NULL, '1498457127'),
(323, 10003, 'admin', NULL, NULL, '2017-06-28 13:06:32', '2017-06-28 18:04:31', 500.00, 0.00, 1398.85, NULL, '::1', NULL, '1498626392'),
(324, 10003, 'admin', NULL, NULL, '2017-06-29 13:34:37', '2017-06-29 17:55:59', 500.00, 0.00, 1828.40, NULL, '::1', NULL, '1498714477'),
(325, 10003, 'admin', NULL, NULL, '2017-06-30 11:06:50', '2017-06-30 18:11:09', 500.00, 0.00, 1040.45, NULL, '::1', NULL, '1498792010'),
(326, 10003, 'admin', NULL, NULL, '2017-07-01 15:56:57', '2017-07-01 17:39:26', 500.00, 0.00, 2235.00, NULL, '::1', NULL, '1498895817'),
(327, 10003, 'admin', NULL, NULL, '2017-07-02 14:25:35', '2017-07-02 17:30:04', 500.00, 0.00, 2942.40, NULL, '::1', NULL, '1498976735'),
(328, 10003, 'admin', NULL, NULL, '2017-07-03 12:29:33', '2017-07-03 14:44:36', 500.00, 0.00, 1187.10, NULL, '::1', NULL, '1499056173'),
(329, 10003, 'admin', NULL, NULL, '2017-07-05 12:22:29', '2017-07-05 17:53:04', 500.00, 0.00, 811.55, NULL, '::1', NULL, '1499228549'),
(330, 10003, 'admin', NULL, NULL, '2017-07-06 14:10:05', '2017-07-06 18:13:36', 500.00, 0.00, 1026.55, NULL, '::1', NULL, '1499321405'),
(331, 10003, 'admin', NULL, NULL, '2017-07-07 14:09:32', '2017-07-07 17:45:01', 500.00, 0.00, 2628.05, NULL, '::1', NULL, '1499407772'),
(332, 10003, 'admin', NULL, NULL, '2017-07-08 14:38:03', '2017-07-08 18:07:36', 500.00, 0.00, 3300.70, NULL, '::1', NULL, '1499495883'),
(333, 10003, 'admin', NULL, NULL, '2017-07-09 13:56:20', '2017-07-09 16:14:41', 500.00, 0.00, 2660.95, NULL, '::1', NULL, '1499579780'),
(334, 10003, 'admin', NULL, NULL, '2017-07-10 12:47:54', '2017-07-10 17:28:54', 500.00, 0.00, 2149.45, NULL, '::1', NULL, '1499662074'),
(335, 10003, 'admin', NULL, NULL, '2017-07-12 15:37:29', '2017-07-12 17:47:07', 500.00, 0.00, 1370.95, NULL, '::1', NULL, '1499845049'),
(336, 10003, 'admin', NULL, NULL, '2017-07-13 15:54:24', '2017-07-13 18:14:18', 500.00, 0.00, 1320.85, NULL, '::1', NULL, '1499932464'),
(337, 10003, 'admin', NULL, NULL, '2017-07-14 14:33:59', '2017-07-14 17:57:35', 500.00, 0.00, 1190.35, NULL, '::1', NULL, '1500014039'),
(338, 10003, 'admin', NULL, NULL, '2017-07-15 16:23:38', '2017-07-15 17:36:34', 500.00, 0.00, 1732.30, NULL, '::1', NULL, '1500107018'),
(339, 10003, 'admin', NULL, NULL, '2017-07-16 15:23:15', '2017-07-16 17:57:42', 500.00, 0.00, 3109.10, NULL, '::1', NULL, '1500189795'),
(340, 10003, 'admin', NULL, NULL, '2017-07-17 13:40:44', '2017-07-17 17:33:48', 500.00, 0.00, 1247.90, NULL, '::1', NULL, '1500270044'),
(341, 10003, 'admin', NULL, NULL, '2017-07-19 17:28:57', '2017-07-19 17:36:49', 500.00, 0.00, 1116.65, NULL, '::1', NULL, '1500456537'),
(342, 10003, 'admin', NULL, NULL, '2017-07-20 13:15:34', '2017-07-20 17:59:34', 500.00, 0.00, 1203.80, NULL, '::1', NULL, '1500527734'),
(343, 10003, 'admin', NULL, NULL, '2017-07-21 12:36:41', '2017-07-21 17:47:21', 500.00, 0.00, 1510.40, NULL, '::1', NULL, '1500611801'),
(344, 10003, 'admin', NULL, NULL, '2017-07-22 15:47:17', '2017-07-22 18:59:18', 500.00, 0.00, 2753.55, NULL, '::1', NULL, '1500709637'),
(345, 10003, 'admin', NULL, NULL, '2017-07-23 11:40:38', '2017-07-23 17:46:27', 500.00, 0.00, 4175.60, NULL, '::1', NULL, '1500781238'),
(346, 10003, 'admin', NULL, NULL, '2017-07-24 13:58:22', '2017-07-24 17:42:41', 500.00, 0.00, 1234.80, NULL, '::1', NULL, '1500875902'),
(347, 10003, 'admin', NULL, NULL, '2017-07-26 15:19:40', '2017-07-26 18:17:22', 500.00, 0.00, 1331.00, NULL, '::1', NULL, '1501053580'),
(348, 10003, 'admin', NULL, NULL, '2017-07-27 17:29:11', '2017-07-27 17:42:33', 500.00, 0.00, 905.75, NULL, '::1', NULL, '1501147751'),
(349, 10003, 'admin', NULL, NULL, '2017-07-28 13:46:53', '2017-07-28 18:07:14', 500.00, 0.00, 1176.65, NULL, '::1', NULL, '1501220813'),
(350, 10003, 'admin', NULL, NULL, '2017-07-29 13:51:27', '2017-07-29 17:14:03', 500.00, 0.00, 2465.45, NULL, '::1', NULL, '1501307487'),
(351, 10003, 'admin', NULL, NULL, '2017-07-30 14:36:32', '2017-07-30 17:25:06', 500.00, 0.00, 3577.30, NULL, '::1', NULL, '1501396592'),
(352, 10003, 'admin', NULL, NULL, '2017-07-31 17:21:36', '2017-07-31 17:30:25', 500.00, 0.00, 1215.05, NULL, '::1', NULL, '1501492896'),
(353, 10003, 'admin', NULL, NULL, '2017-08-02 14:43:27', '2017-08-02 18:23:16', 500.00, 0.00, 1379.20, NULL, '::1', NULL, '1501656207'),
(354, 10003, 'admin', NULL, NULL, '2017-08-03 13:48:27', '2017-08-03 18:00:28', 500.00, 0.00, 511.15, NULL, '::1', NULL, '1501739307'),
(355, 10003, 'admin', NULL, NULL, '2017-08-04 12:14:23', '2017-08-04 18:16:38', 500.00, 0.00, 862.95, NULL, '::1', NULL, '1501820063'),
(356, 10003, 'admin', NULL, NULL, '2017-08-05 16:51:56', '2017-08-05 18:08:15', 500.00, 0.00, 2612.40, NULL, '::1', NULL, '1501923116'),
(357, 10003, 'admin', NULL, NULL, '2017-08-06 16:19:36', '2017-08-06 18:02:27', 500.00, 0.00, 2844.65, NULL, '::1', NULL, '1502007576'),
(358, 10003, 'admin', NULL, NULL, '2017-08-07 13:53:30', '2017-08-07 18:06:41', 500.00, 0.00, 1191.05, NULL, '::1', NULL, '1502085210'),
(359, 10003, 'admin', NULL, NULL, '2017-08-09 15:11:38', '2017-08-09 17:56:48', 500.00, 0.00, 1476.00, NULL, '::1', NULL, '1502262698'),
(360, 10003, 'admin', NULL, NULL, '2017-08-10 12:44:35', '2017-08-10 18:11:38', 500.00, 0.00, 867.10, NULL, '::1', NULL, '1502340275'),
(361, 10003, 'admin', NULL, NULL, '2017-08-11 14:31:20', '2017-08-11 17:37:29', 500.00, 0.00, 1106.20, NULL, '::1', NULL, '1502433080'),
(362, 10003, 'admin', NULL, NULL, '2017-08-12 12:22:35', '2017-08-12 17:35:17', 500.00, 0.00, 2302.00, NULL, '::1', NULL, '1502511755'),
(363, 10003, 'admin', NULL, NULL, '2017-08-13 14:07:26', '2017-08-13 18:04:19', 500.00, 0.00, 3418.50, NULL, '::1', NULL, '1502604446'),
(364, 10003, 'admin', NULL, NULL, '2017-08-14 13:01:42', '2017-08-14 18:07:49', 500.00, 0.00, 1008.90, NULL, '::1', NULL, '1502686902'),
(365, 10003, 'admin', NULL, NULL, '2017-08-16 13:06:26', '2017-08-16 17:56:44', 500.00, 0.00, 1007.95, NULL, '::1', NULL, '1502859986'),
(366, 10003, 'admin', NULL, NULL, '2017-08-17 13:45:28', '2017-08-17 17:54:41', 500.00, 0.00, 1161.45, NULL, '::1', NULL, '1502948728'),
(367, 10003, 'admin', NULL, NULL, '2017-08-18 13:02:41', '2017-08-18 17:25:48', 500.00, 0.00, 682.90, NULL, '::1', NULL, '1503032561'),
(368, 10003, 'admin', NULL, NULL, '2017-08-19 14:09:38', '2017-08-19 17:26:32', 500.00, 0.00, 2217.60, NULL, '::1', NULL, '1503122978'),
(369, 10003, 'admin', NULL, NULL, '2017-08-20 16:30:11', '2017-08-20 17:42:07', 500.00, 0.00, 3437.55, NULL, '::1', NULL, '1503217811'),
(370, 10003, 'admin', NULL, NULL, '2017-08-21 14:25:51', '2017-08-21 17:55:39', 500.00, 0.00, 992.80, NULL, '::1', NULL, '1503296751');
INSERT INTO `fnb_cash_count` (`id`, `user_id`, `username`, `employee_id`, `employee_username`, `from`, `to`, `deposited`, `discrepancy`, `total_sales`, `total_items`, `ip_address`, `terminal`, `session`) VALUES
(371, 10003, 'admin', NULL, NULL, '2017-08-23 13:26:00', '2017-08-23 16:55:56', 500.00, 0.00, 680.15, NULL, '::1', NULL, '1503465960'),
(372, 10003, 'admin', NULL, NULL, '2017-08-24 14:03:49', '2017-08-24 17:56:33', 500.00, 0.00, 801.15, NULL, '::1', NULL, '1503554629'),
(373, 10003, 'admin', NULL, NULL, '2017-08-25 14:37:07', '2017-08-25 18:01:41', 500.00, 0.00, 1389.40, NULL, '::1', NULL, '1503643027'),
(374, 10003, 'admin', NULL, NULL, '2017-08-26 15:07:38', '2017-08-26 17:01:14', 500.00, 0.00, 1956.50, NULL, '::1', NULL, '1503731258'),
(375, 10003, 'admin', NULL, NULL, '2017-08-27 14:15:20', '2017-08-27 17:55:37', 500.00, 0.00, 3769.20, NULL, '::1', NULL, '1503814520'),
(376, 10003, 'admin', NULL, NULL, '2017-08-28 13:38:23', '2017-08-28 18:50:41', 500.00, 0.00, 1411.15, NULL, '::1', NULL, '1503898703'),
(377, 10008, 'lois', NULL, NULL, '2017-08-30 13:18:38', '2017-08-30 17:39:57', 500.00, 0.00, 1553.40, NULL, '::1', NULL, '1504070318'),
(378, 10003, 'admin', NULL, NULL, '2017-08-31 14:37:38', '2017-08-31 18:20:55', 500.00, 0.00, 3017.95, NULL, '::1', NULL, '1504161458'),
(379, 10003, 'admin', NULL, NULL, '2017-09-01 15:46:16', '2017-09-01 17:49:29', 500.00, 0.00, 2644.20, NULL, '::1', NULL, '1504251976'),
(380, 10003, 'admin', NULL, NULL, '2017-09-02 12:01:03', '2017-09-02 16:57:50', 500.00, 0.00, 2009.70, NULL, '::1', NULL, '1504324863'),
(381, 10003, 'admin', NULL, NULL, '2017-09-03 13:01:00', '2017-09-03 16:36:44', 500.00, 0.00, 2226.25, NULL, '::1', NULL, '1504414860'),
(382, 10003, 'admin', NULL, NULL, '2017-09-04 14:24:44', '2017-09-04 17:37:55', 500.00, 0.00, 1964.90, NULL, '::1', NULL, '1504506284'),
(383, 10003, 'admin', NULL, NULL, '2017-09-06 09:11:49', '2017-09-06 17:34:52', 500.00, 0.00, 472.05, NULL, '::1', NULL, '1504660309'),
(384, 10003, 'admin', NULL, NULL, '2017-09-07 13:15:54', '2017-09-07 17:52:38', 500.00, 0.00, 617.15, NULL, '::1', NULL, '1504761354'),
(385, 10003, 'admin', NULL, NULL, '2017-09-08 08:43:57', '2017-09-08 17:42:31', 500.00, 0.00, 491.80, NULL, '::1', NULL, '1504831437'),
(386, 10003, 'admin', NULL, NULL, '2017-09-09 17:24:13', '2017-09-09 17:41:50', 500.00, 0.00, 2427.45, NULL, '::1', NULL, '1504949053'),
(387, 10003, 'admin', NULL, NULL, '2017-09-10 14:42:53', '2017-09-10 17:52:05', 500.00, 0.00, 2464.80, NULL, '::1', NULL, '1505025773'),
(388, 10003, 'admin', NULL, NULL, '2017-09-11 13:56:25', '2017-09-11 17:51:53', 500.00, 0.00, 1933.00, NULL, '::1', NULL, '1505109385'),
(389, 10003, 'admin', NULL, NULL, '2017-09-13 12:22:27', '2017-09-13 18:41:13', 500.00, 0.00, 2134.45, NULL, '::1', NULL, '1505276547'),
(390, 10003, 'admin', NULL, NULL, '2017-09-14 13:17:33', '2017-09-14 17:40:52', 500.00, 0.00, 1552.95, NULL, '::1', NULL, '1505366253'),
(391, 10003, 'admin', NULL, NULL, '2017-09-15 15:00:56', '2017-09-15 17:51:36', 500.00, 0.00, 810.80, NULL, '::1', NULL, '1505458856'),
(392, 10003, 'admin', NULL, NULL, '2017-09-16 15:25:18', '2017-09-16 17:23:42', 500.00, 0.00, 2097.15, NULL, '::1', NULL, '1505546718'),
(393, 10003, 'admin', NULL, NULL, '2017-09-17 14:23:46', '2017-09-17 17:51:41', 500.00, 0.00, 2967.75, NULL, '::1', NULL, '1505629426'),
(394, 10003, 'admin', NULL, NULL, '2017-09-18 12:23:10', '2017-09-18 17:26:13', 500.00, 0.00, 1126.10, NULL, '::1', NULL, '1505708590'),
(395, 10003, 'admin', NULL, NULL, '2017-09-20 15:51:18', '2017-09-20 17:59:32', 500.00, 0.00, 894.05, NULL, '::1', NULL, '1505893878'),
(396, 10003, 'admin', NULL, NULL, '2017-09-21 14:33:39', '2017-09-21 17:38:27', 500.00, 0.00, 1000.35, NULL, '::1', NULL, '1505975619'),
(397, 10003, 'admin', NULL, NULL, '2017-09-22 16:32:33', '2017-09-22 17:36:09', 500.00, 0.00, 2240.35, NULL, '::1', NULL, '1506069153'),
(398, 10003, 'admin', NULL, NULL, '2017-09-23 15:35:10', '2017-09-23 17:09:44', 500.00, 0.00, 2028.05, NULL, '::1', NULL, '1506152110'),
(399, 10003, 'admin', NULL, NULL, '2017-09-24 13:08:01', '2017-09-24 17:49:18', 500.00, 0.00, 3394.55, NULL, '::1', NULL, '1506229681'),
(400, 10003, 'admin', NULL, NULL, '2017-09-25 12:35:21', '2017-09-25 17:52:47', 500.00, 0.00, 1081.55, NULL, '::1', NULL, '1506314121'),
(401, 10003, 'admin', NULL, NULL, '2017-09-27 13:25:28', '2017-09-27 17:59:42', 500.00, 3.00, 592.35, NULL, '::1', NULL, '1506489928'),
(402, 10003, 'admin', NULL, NULL, '2017-09-28 09:33:24', '2017-09-28 17:46:08', 500.00, 0.00, 835.30, NULL, '::1', NULL, '1506562404'),
(403, 10003, 'admin', NULL, NULL, '2017-09-29 14:00:52', '2017-09-29 18:46:58', 500.00, 0.00, 1100.95, NULL, '::1', NULL, '1506664852'),
(404, 10003, 'admin', NULL, NULL, '2017-09-30 13:49:52', '2017-09-30 17:46:57', 500.00, 0.00, 1799.40, NULL, '::1', NULL, '1506750592'),
(405, 10003, 'admin', NULL, NULL, '2017-10-01 14:02:48', '2017-10-01 18:15:03', 500.00, 0.00, 2084.85, NULL, '::1', NULL, '1506837768'),
(406, 10003, 'admin', NULL, NULL, '2017-10-02 11:54:30', '2017-10-02 17:47:56', 500.00, 0.00, 1636.20, NULL, '::1', NULL, '1506916470'),
(407, 10003, 'admin', NULL, NULL, '2017-10-04 16:51:01', '2017-10-04 18:10:11', 500.00, 0.00, 2217.30, NULL, '::1', NULL, '1507107061'),
(408, 10003, 'admin', NULL, NULL, '2017-10-05 13:44:49', '2017-10-05 17:55:40', 500.00, 0.00, 1399.75, NULL, '::1', NULL, '1507182289'),
(409, 10003, 'admin', NULL, NULL, '2017-10-06 13:55:51', '2017-10-06 17:47:59', 500.00, 0.00, 1212.65, NULL, '::1', NULL, '1507269351'),
(410, 10003, 'admin', NULL, NULL, '2017-10-07 14:27:56', '2017-10-07 17:17:28', 500.00, 0.00, 2232.45, NULL, '::1', NULL, '1507357676'),
(411, 10003, 'admin', NULL, NULL, '2017-10-08 16:54:48', '2017-10-08 17:49:59', 500.00, 0.00, 2909.70, NULL, '::1', NULL, '1507452888'),
(412, 10003, 'admin', NULL, NULL, '2017-10-09 15:55:22', '2017-10-09 17:27:07', 500.00, 0.00, 1305.70, NULL, '::1', NULL, '1507535722'),
(413, 10003, 'admin', NULL, NULL, '2017-10-11 17:44:10', '2017-10-11 18:00:17', 500.00, 0.00, 1272.50, NULL, '::1', NULL, '1507715050'),
(414, 10003, 'admin', NULL, NULL, '2017-10-12 12:19:07', '2017-10-12 16:58:08', 500.00, 0.00, 885.80, NULL, '::1', NULL, '1507781947'),
(415, 10003, 'admin', NULL, NULL, '2017-10-13 15:45:16', '2017-10-13 17:29:57', 500.00, 0.00, 895.40, NULL, '::1', NULL, '1507880716'),
(416, 10003, 'admin', NULL, NULL, '2017-10-14 15:58:12', '2017-10-14 18:24:40', 500.00, 0.00, 2125.95, NULL, '::1', NULL, '1507967892'),
(417, 10003, 'admin', NULL, NULL, '2017-10-15 15:20:10', '2017-10-15 17:11:33', 500.00, 0.00, 3509.45, NULL, '::1', NULL, '1508052010'),
(418, 10003, 'admin', NULL, NULL, '2017-10-16 13:10:25', '2017-10-16 17:30:20', 500.00, 0.00, 2009.35, NULL, '::1', NULL, '1508130625'),
(419, 10003, 'admin', NULL, NULL, '2017-10-18 16:25:38', '2017-10-18 17:41:40', 500.00, 0.00, 3193.00, NULL, '::1', NULL, '1508315138'),
(420, 10003, 'admin', NULL, NULL, '2017-10-19 14:02:29', '2017-10-19 16:58:38', 500.00, 0.00, 1432.00, NULL, '::1', NULL, '1508392949'),
(421, 10003, 'admin', NULL, NULL, '2017-10-20 13:06:52', '2017-10-20 17:14:51', 500.00, 0.00, 979.20, NULL, '::1', NULL, '1508476012'),
(422, 10003, 'admin', NULL, NULL, '2017-10-21 13:04:44', '2017-10-21 16:59:06', 500.00, 0.00, 2272.60, NULL, '::1', NULL, '1508562284'),
(423, 10003, 'admin', NULL, NULL, '2017-10-22 12:02:34', '2017-10-22 17:10:18', 500.00, 0.00, 2547.65, NULL, '::1', NULL, '1508644954'),
(424, 10003, 'admin', NULL, NULL, '2017-10-23 12:23:05', '2017-10-23 17:15:25', 500.00, 0.00, 697.00, NULL, '::1', NULL, '1508732585'),
(425, 10003, 'admin', NULL, NULL, '2017-10-25 13:28:50', '2017-10-25 17:36:48', 500.00, 0.00, 984.70, NULL, '::1', NULL, '1508909330'),
(426, 10003, 'admin', NULL, NULL, '2017-10-26 12:47:04', '2017-10-26 17:30:51', 500.00, 0.00, 1215.60, NULL, '::1', NULL, '1508993224'),
(427, 10003, 'admin', NULL, NULL, '2017-10-27 08:55:31', '2017-10-27 17:22:17', 500.00, 0.00, 802.80, NULL, '::1', NULL, '1509065731'),
(428, 10003, 'admin', NULL, NULL, '2017-10-28 14:56:44', '2017-10-28 17:16:39', 500.00, 0.00, 2460.45, NULL, '::1', NULL, '1509173804'),
(429, 10003, 'admin', NULL, NULL, '2017-10-29 15:05:16', '2017-10-29 17:19:17', 500.00, 0.00, 3016.65, NULL, '::1', NULL, '1509260716'),
(430, 10003, 'admin', NULL, NULL, '2017-10-30 11:35:27', '2017-10-30 17:26:55', 500.00, 0.00, 591.15, NULL, '::1', NULL, '1509334527'),
(431, 10003, 'admin', NULL, NULL, '2017-11-01 13:13:50', '2017-11-01 17:17:35', 500.00, 0.00, 738.00, NULL, '::1', NULL, '1509513230'),
(432, 10003, 'admin', NULL, NULL, '2017-11-02 12:05:22', '2017-11-02 17:10:10', 500.00, 0.00, 1206.45, NULL, '::1', NULL, '1509595522'),
(433, 10003, 'admin', NULL, NULL, '2017-11-02 17:10:23', '2017-11-03 17:26:03', 500.00, 0.00, 767.70, NULL, '::1', NULL, '1509613823'),
(434, 10003, 'admin', NULL, NULL, '2017-11-04 12:28:39', '2017-11-04 16:27:34', 500.00, 0.00, 1980.45, NULL, '::1', NULL, '1509769719'),
(435, 10003, 'admin', NULL, NULL, '2017-11-05 14:36:14', '2017-11-05 15:43:12', 500.00, 0.00, 1234.65, NULL, '::1', NULL, '1509863774'),
(436, 10003, 'admin', NULL, NULL, '2017-11-06 15:43:55', '2017-11-06 16:16:36', 500.00, 0.00, 583.80, NULL, '::1', NULL, '1509954235'),
(437, 10003, 'admin', NULL, NULL, '2017-11-08 09:06:49', '2017-11-08 17:56:16', 500.00, 0.00, 772.40, NULL, '::1', NULL, '1510103209'),
(438, 10003, 'admin', NULL, NULL, '2017-11-09 10:41:04', '2017-11-09 18:00:41', 500.00, 0.00, 1093.50, NULL, '::1', NULL, '1510195264'),
(439, 10003, 'admin', NULL, NULL, '2017-11-10 09:11:05', '2017-11-10 17:25:50', 500.00, 0.00, 930.15, NULL, '::1', NULL, '1510276265'),
(440, 10003, 'admin', NULL, NULL, '2017-11-11 15:37:39', '2017-11-11 17:39:58', 500.00, 0.00, 1740.75, NULL, '::1', NULL, '1510385859'),
(441, 10003, 'admin', NULL, NULL, '2017-11-12 09:16:48', '2017-11-12 17:57:48', 500.00, 0.00, 2499.30, NULL, '::1', NULL, '1510449408'),
(442, 10003, 'admin', NULL, NULL, '2017-11-13 09:04:51', '2017-11-13 17:07:07', 500.00, 0.00, 926.95, NULL, '::1', NULL, '1510535091'),
(443, 10003, 'admin', NULL, NULL, '2017-11-15 09:04:21', '2017-11-15 17:53:10', 500.00, 0.00, 838.20, NULL, '::1', NULL, '1510707861'),
(444, 10003, 'admin', NULL, NULL, '2017-11-16 09:00:28', '2017-11-16 17:39:10', 500.00, 0.00, 620.40, NULL, '::1', NULL, '1510794028'),
(445, 10003, 'admin', NULL, NULL, '2017-11-17 09:04:55', '2017-11-17 17:50:28', 500.00, 0.00, 1337.10, NULL, '::1', NULL, '1510880695'),
(446, 10003, 'admin', NULL, NULL, '2017-11-18 09:16:59', '2017-11-18 17:13:59', 500.00, 0.00, 1774.05, NULL, '::1', NULL, '1510967819'),
(447, 10003, 'admin', NULL, NULL, '2017-11-19 08:43:22', '2017-11-19 16:36:18', 500.00, 0.00, 2547.10, NULL, '::1', NULL, '1511052202'),
(448, 10003, 'admin', NULL, NULL, '2017-11-20 08:59:20', '2017-11-20 17:59:48', 500.00, 0.00, 1113.00, NULL, '::1', NULL, '1511139560'),
(449, 10003, 'admin', NULL, NULL, '2017-11-22 11:51:22', '2017-11-22 16:50:10', 500.00, 0.00, 264.25, NULL, '::1', NULL, '1511322682'),
(450, 10003, 'admin', NULL, NULL, '2017-11-23 09:21:20', '2017-11-23 17:35:15', 500.00, 0.00, 622.05, NULL, '::1', NULL, '1511400080'),
(451, 10003, 'admin', NULL, NULL, '2017-11-24 09:01:43', '2017-11-24 17:16:16', 500.00, 0.00, 532.90, NULL, '::1', NULL, '1511485303'),
(452, 10003, 'admin', NULL, NULL, '2017-11-25 08:47:05', '2017-11-25 16:30:43', 500.00, 0.00, 2252.20, NULL, '::1', NULL, '1511570825'),
(453, 10003, 'admin', NULL, NULL, '2017-11-26 17:40:31', '2017-11-26 17:41:30', 500.00, 0.00, 3004.90, NULL, '::1', NULL, '1511689231'),
(454, 10003, 'admin', NULL, NULL, '2017-11-27 09:00:10', '2017-11-27 17:34:59', 500.00, 0.00, 1640.15, NULL, '::1', NULL, '1511744410'),
(455, 10003, 'admin', NULL, NULL, '2017-11-29 09:11:39', '2017-11-29 17:34:40', 500.00, 0.00, 1020.50, NULL, '::1', NULL, '1511917899'),
(456, 10003, 'admin', NULL, NULL, '2017-11-30 12:50:20', '2017-11-30 17:41:36', 500.00, 0.00, 1189.95, NULL, '::1', NULL, '1512017420'),
(457, 10003, 'admin', NULL, NULL, '2017-12-01 09:07:25', '2017-12-01 17:56:51', 500.00, 0.00, 1483.50, NULL, '::1', NULL, '1512090445'),
(458, 10003, 'admin', NULL, NULL, '2017-12-02 08:53:27', '2017-12-02 17:21:05', 500.00, 0.00, 2151.30, NULL, '::1', NULL, '1512176007'),
(459, 10003, 'admin', NULL, NULL, '2017-12-03 12:56:23', '2017-12-03 17:37:26', 500.00, 0.00, 3137.60, NULL, '::1', NULL, '1512276983'),
(460, 10003, 'admin', NULL, NULL, '2017-12-04 08:46:44', '2017-12-04 17:31:43', 500.00, 0.00, 1231.00, NULL, '::1', NULL, '1512348404'),
(461, 10003, 'admin', NULL, NULL, '2017-12-06 09:03:36', '2017-12-06 17:34:12', 500.00, 0.00, 956.10, NULL, '::1', NULL, '1512522216'),
(462, 10003, 'admin', NULL, NULL, '2017-12-07 08:48:36', '2017-12-07 17:49:30', 500.00, 0.00, 791.35, NULL, '::1', NULL, '1512607716'),
(463, 10003, 'admin', NULL, NULL, '2017-12-08 08:55:46', '2017-12-08 17:55:10', 500.00, 0.00, 1278.75, NULL, '::1', NULL, '1512694546'),
(464, 10003, 'admin', NULL, NULL, '2017-12-09 14:48:54', '2017-12-09 18:23:21', 500.00, 0.00, 2729.95, NULL, '::1', NULL, '1512802134'),
(465, 10003, 'admin', NULL, NULL, '2017-12-10 09:00:26', '2017-12-10 16:39:30', 500.00, 0.00, 2082.20, NULL, '::1', NULL, '1512867626'),
(466, 10003, 'admin', NULL, NULL, '2017-12-11 09:03:04', '2017-12-11 17:02:59', 500.00, 0.00, 755.60, NULL, '::1', NULL, '1512954184'),
(467, 10003, 'admin', NULL, NULL, '2017-12-13 09:07:01', '2017-12-13 17:48:08', 500.00, 0.00, 797.80, NULL, '::1', NULL, '1513127221'),
(468, 10003, 'admin', NULL, NULL, '2017-12-14 08:46:48', '2017-12-14 16:41:10', 500.00, 0.00, 660.80, NULL, '::1', NULL, '1513212408'),
(469, 10003, 'admin', NULL, NULL, '2017-12-15 09:02:54', '2017-12-15 17:31:54', 500.00, 0.00, 983.30, NULL, '::1', NULL, '1513299774'),
(470, 10003, 'admin', NULL, NULL, '2017-12-16 09:13:21', '2017-12-16 17:10:32', 500.00, 0.00, 2030.70, NULL, '::1', NULL, '1513386801'),
(471, 10003, 'admin', NULL, NULL, '2017-12-17 08:31:25', '2017-12-17 16:49:59', 500.00, 0.00, 2115.60, NULL, '::1', NULL, '1513470685'),
(472, 10003, 'admin', NULL, NULL, '2017-12-18 18:06:26', '2017-12-18 18:23:41', 500.00, 0.00, 1023.25, NULL, '::1', NULL, '1513591586'),
(473, 10003, 'admin', NULL, NULL, '2017-12-20 08:56:27', '2017-12-20 17:40:26', 500.00, 0.00, 1093.40, NULL, '::1', NULL, '1513731387'),
(474, 10003, 'admin', NULL, NULL, '2017-12-21 16:01:49', '2017-12-21 18:02:40', 500.00, 0.00, 1074.20, NULL, '::1', NULL, '1513843309'),
(475, 10003, 'admin', NULL, NULL, '2017-12-22 08:52:40', '2017-12-22 17:51:30', 500.00, 0.00, 1339.60, NULL, '::1', NULL, '1513903960'),
(476, 10003, 'admin', NULL, NULL, '2017-12-23 09:14:46', '2017-12-23 18:48:20', 500.00, 0.00, 1702.05, NULL, '::1', NULL, '1513991686'),
(477, 10003, 'admin', NULL, NULL, '2017-12-24 08:56:24', '2017-12-24 17:22:20', 500.00, 0.00, 2004.65, NULL, '::1', NULL, '1514076984'),
(478, 10003, 'admin', NULL, NULL, '2017-12-25 08:42:08', '2017-12-25 17:45:50', 500.00, 0.00, 3423.85, NULL, '::1', NULL, '1514162528'),
(479, 10003, 'admin', NULL, NULL, '2017-12-27 09:09:16', '2017-12-27 17:49:50', 500.00, 0.00, 2017.55, NULL, '::1', NULL, '1514336956'),
(480, 10003, 'admin', NULL, NULL, '2017-12-28 08:42:21', '2017-12-28 17:32:51', 500.00, 0.00, 1077.75, NULL, '::1', NULL, '1514421741'),
(481, 10003, 'admin', NULL, NULL, '2017-12-29 09:04:05', '2017-12-29 17:29:07', 500.00, 0.00, 1820.65, NULL, '::1', NULL, '1514509445'),
(482, 10003, 'admin', NULL, NULL, '2017-12-30 09:03:57', '2017-12-30 17:48:06', 500.00, 0.00, 2593.45, NULL, '::1', NULL, '1514595837'),
(483, 10003, 'admin', NULL, NULL, '2017-12-31 09:10:22', '2017-12-31 17:21:41', 500.00, 0.00, 3177.40, NULL, '::1', NULL, '1514682622'),
(484, 10003, 'admin', NULL, NULL, '2018-01-01 08:56:51', '2018-01-01 17:53:23', 500.00, 0.00, 4248.90, NULL, '::1', NULL, '1514768211'),
(485, 10003, 'admin', NULL, NULL, '2018-01-04 09:02:08', '2018-01-04 18:25:26', 500.00, 0.00, 2088.10, NULL, '::1', NULL, '1515027728'),
(486, 10003, 'admin', NULL, NULL, '2018-01-05 08:32:33', '2018-01-05 18:07:26', 500.00, 0.00, 856.35, NULL, '::1', NULL, '1515112353'),
(487, 10003, 'admin', NULL, NULL, '2018-01-06 09:21:52', '2018-01-06 17:59:50', 500.00, 0.00, 2116.50, NULL, '::1', NULL, '1515201712'),
(488, 10003, 'admin', NULL, NULL, '2018-01-07 08:48:16', '2018-01-07 15:30:16', 500.00, 0.00, 2370.85, NULL, '::1', NULL, '1515286096'),
(489, 10003, 'admin', NULL, NULL, '2018-01-08 08:34:43', '2018-01-08 18:20:06', 500.00, 0.00, 1364.50, NULL, '::1', NULL, '1515371683'),
(490, 10003, 'admin', NULL, NULL, '2018-01-10 09:03:45', '2018-01-10 18:57:14', 500.00, 0.00, 1104.95, NULL, '::1', NULL, '1515546225'),
(491, 10003, 'admin', NULL, NULL, '2018-01-10 18:57:33', '2018-01-11 16:10:50', 500.00, 0.00, 643.50, NULL, '::1', NULL, '1515581853'),
(492, 10003, 'admin', NULL, NULL, '2018-01-12 09:03:56', '2018-01-12 18:06:38', 500.00, 0.00, 1660.00, NULL, '::1', NULL, '1515719036'),
(493, 10003, 'admin', NULL, NULL, '2018-01-13 09:11:32', '2018-01-13 17:39:03', 500.00, 0.00, 1943.00, NULL, '::1', NULL, '1515805892'),
(494, 10003, 'admin', NULL, NULL, '2018-01-14 08:50:16', '2018-01-14 17:28:32', 500.00, 0.00, 2276.10, NULL, '::1', NULL, '1515891016'),
(495, 10003, 'admin', NULL, NULL, '2018-01-15 09:08:01', '2018-01-15 17:21:41', 500.00, 0.00, 1133.20, NULL, '::1', NULL, '1515978481'),
(496, 10003, 'admin', NULL, NULL, '2018-01-17 09:06:14', '2018-01-17 16:42:04', 500.00, 0.00, 948.30, NULL, '::1', NULL, '1516151174'),
(497, 10003, 'admin', NULL, NULL, '2018-01-18 09:08:18', '2018-01-18 17:04:43', 500.00, 0.00, 1513.40, NULL, '::1', NULL, '1516237698'),
(498, 10003, 'admin', NULL, NULL, '2018-01-19 08:24:29', '2018-01-19 17:31:34', 500.00, 0.00, 958.30, NULL, '::1', NULL, '1516321469'),
(499, 10003, 'admin', NULL, NULL, '2018-01-20 17:53:19', '2018-01-20 18:23:00', 500.00, 0.00, 2317.80, NULL, '::1', NULL, '1516441999'),
(500, 10003, 'admin', NULL, NULL, '2018-01-21 12:46:05', '2018-01-21 17:29:34', 500.00, 0.00, 2973.90, NULL, '::1', NULL, '1516509965'),
(501, 10003, 'admin', NULL, NULL, '2018-01-22 09:06:51', '2018-01-22 17:23:09', 500.00, 0.00, 926.45, NULL, '::1', NULL, '1516583211'),
(502, 10003, 'admin', NULL, NULL, '2018-01-24 08:54:12', '2018-01-24 16:36:39', 500.00, 0.00, 848.60, NULL, '::1', NULL, '1516755252'),
(503, 10003, 'admin', NULL, NULL, '2018-01-25 09:08:47', '2018-01-25 17:22:18', 500.00, 0.00, 1138.10, NULL, '::1', NULL, '1516842527'),
(504, 10003, 'admin', NULL, NULL, '2018-01-26 09:05:57', '2018-01-26 17:53:45', 500.00, 0.00, 992.80, NULL, '::1', NULL, '1516928757'),
(505, 10003, 'admin', NULL, NULL, '2018-01-27 09:01:51', '2018-01-27 17:48:33', 500.00, 0.00, 1908.15, NULL, '::1', NULL, '1517014911'),
(506, 10003, 'admin', NULL, NULL, '2018-01-28 08:46:27', '2018-01-28 17:10:17', 500.00, 0.00, 2240.95, NULL, '::1', NULL, '1517100387'),
(507, 10003, 'admin', NULL, NULL, '2018-01-29 08:49:55', '2018-01-29 17:53:05', 500.00, 0.00, 1233.30, NULL, '::1', NULL, '1517186995'),
(508, 10003, 'admin', NULL, NULL, '2018-01-31 08:26:33', '2018-01-31 16:48:17', 500.00, 0.00, 1718.70, NULL, '::1', NULL, '1517358393'),
(509, 10003, 'admin', NULL, NULL, '2018-02-01 09:06:09', '2018-02-01 17:12:53', 500.00, 30.00, 1064.05, NULL, '::1', NULL, '1517447169'),
(510, 10003, 'admin', NULL, NULL, '2018-02-02 09:16:20', '2018-02-02 17:20:19', 500.00, 0.00, 946.90, NULL, '::1', NULL, '1517534180'),
(511, 10003, 'admin', NULL, NULL, '2018-02-03 09:12:44', '2018-02-03 18:32:35', 500.00, -5.00, 2207.05, NULL, '::1', NULL, '1517620364'),
(512, 10003, 'admin', NULL, NULL, '2018-02-04 09:29:05', '2018-02-04 17:56:34', 500.00, 0.00, 2414.75, NULL, '::1', NULL, '1517707745'),
(513, 10003, 'admin', NULL, NULL, '2018-02-05 09:11:16', '2018-02-05 17:03:49', 500.00, 0.00, 494.60, NULL, '::1', NULL, '1517793076'),
(514, 10003, 'admin', NULL, NULL, '2018-02-07 09:09:07', '2018-02-07 19:19:11', 500.00, 0.00, 1423.20, NULL, '::1', NULL, '1517965747'),
(515, 10003, 'admin', NULL, NULL, '2018-02-08 09:06:01', '2018-02-08 16:48:05', 500.00, 0.00, 1023.25, NULL, '::1', NULL, '1518051961'),
(516, 10003, 'admin', NULL, NULL, '2018-02-09 08:26:13', '2018-02-09 17:08:29', 500.00, 0.00, 1258.95, NULL, '::1', NULL, '1518135973'),
(517, 10003, 'admin', NULL, NULL, '2018-02-10 08:53:12', '2018-02-20 09:54:43', 500.00, 6354.78, NULL, NULL, '::1', NULL, '1518223992'),
(518, 10003, 'admin', NULL, NULL, '2018-02-20 09:58:39', '2018-02-20 10:59:28', 500.00, 0.00, 3.00, NULL, '::1', NULL, '1519091919'),
(519, 10003, 'admin', NULL, NULL, '2018-02-21 13:15:24', '2018-02-21 17:02:02', 500.00, 0.00, 1467.80, NULL, '::1', NULL, '1519190124'),
(520, 10003, 'admin', NULL, NULL, '2018-02-22 08:57:54', '2018-02-22 16:28:42', 500.00, 0.00, 1284.40, NULL, '::1', NULL, '1519261074'),
(521, 10003, 'admin', NULL, NULL, '2018-02-23 09:17:17', '2018-02-23 17:40:25', 500.00, 0.00, 1358.60, NULL, '::1', NULL, '1519348637'),
(522, 10003, 'admin', NULL, NULL, '2018-02-24 08:59:42', '2018-02-24 17:34:39', 500.00, 0.00, 3388.90, NULL, '::1', NULL, '1519433982'),
(523, 10003, 'admin', NULL, NULL, '2018-02-25 08:55:19', '2018-02-25 17:32:07', 500.00, 0.00, 2365.90, NULL, '::1', NULL, '1519520119'),
(524, 10003, 'admin', NULL, NULL, '2018-02-26 17:13:36', '2018-02-26 17:13:57', 500.00, 0.00, 1078.85, NULL, '::1', NULL, '1519636416'),
(525, 10003, 'admin', NULL, NULL, '2018-02-28 09:08:53', '2018-02-28 17:29:15', 500.00, 0.00, 988.60, NULL, '::1', NULL, '1519780133'),
(526, 10003, 'admin', NULL, NULL, '2018-03-01 09:03:51', '2018-03-01 16:53:36', 500.00, 0.00, 562.20, NULL, '::1', NULL, '1519866231'),
(527, 10003, 'admin', NULL, NULL, '2018-03-01 16:54:52', '2018-03-01 16:55:13', 500.00, 0.00, 562.20, NULL, '::1', NULL, '1519894492'),
(528, 10003, 'admin', NULL, NULL, '2018-03-01 16:56:28', '2018-03-01 16:57:00', 500.00, 0.00, 562.20, NULL, '::1', NULL, '1519894588'),
(529, 10003, 'admin', NULL, NULL, '2018-03-02 08:54:35', '2018-03-02 17:45:06', 500.00, 0.00, 1575.30, NULL, '::1', NULL, '1519952075'),
(530, 10003, 'admin', NULL, NULL, '2018-03-03 08:49:01', '2018-03-03 17:24:51', 500.00, -1575.30, 3177.15, NULL, '::1', NULL, '1520038141'),
(531, 10003, 'admin', NULL, NULL, '2018-03-04 09:00:17', '2018-03-04 17:16:24', 500.00, -3177.15, 5667.35, NULL, '::1', NULL, '1520125217'),
(532, 10003, 'admin', NULL, NULL, '2018-03-05 09:00:07', '2018-03-05 16:06:10', 500.00, -5667.35, 6825.35, NULL, '::1', NULL, '1520211607'),
(533, 10003, 'admin', NULL, NULL, '2018-03-07 09:10:34', '2018-03-07 17:46:44', 500.00, 0.00, 985.00, NULL, '::1', NULL, '1520385034'),
(534, NULL, NULL, NULL, NULL, NULL, '2018-03-08 17:04:17', 500.00, 1239.70, NULL, NULL, '::1', NULL, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `fnb_category_options`
--

CREATE TABLE `fnb_category_options` (
  `id` int(11) UNSIGNED NOT NULL,
  `name` varchar(128) DEFAULT NULL,
  `options` text,
  `customer_options` text,
  `price` text
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `fnb_delivery_orders`
--

CREATE TABLE `fnb_delivery_orders` (
  `id` int(11) UNSIGNED NOT NULL,
  `datetime` datetime DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `order_data` text,
  `type` varchar(128) DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `amount_tendered` decimal(20,2) DEFAULT NULL,
  `amount_change` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `online` int(1) DEFAULT NULL,
  `discount` varchar(128) NOT NULL DEFAULT '',
  `customer_id` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `fnb_delivery_order_items`
--

CREATE TABLE `fnb_delivery_order_items` (
  `id` int(11) NOT NULL,
  `datetime` datetime DEFAULT NULL,
  `order_id` int(11) DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_sku` varchar(128) DEFAULT NULL,
  `item_name` varchar(128) DEFAULT NULL,
  `item_option` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `price_per_unit` float(10,2) DEFAULT NULL,
  `margin` float(10,4) DEFAULT NULL,
  `cost` float(10,4) DEFAULT NULL,
  `amount` float(10,2) DEFAULT NULL,
  `sold` int(11) DEFAULT NULL,
  `terminal` varchar(32) DEFAULT NULL,
  `printed` int(1) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `ordered_by` varchar(128) DEFAULT NULL,
  `ordered_time` datetime DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `fnb_inventory`
--

CREATE TABLE `fnb_inventory` (
  `id` int(11) NOT NULL,
  `category` varchar(128) DEFAULT NULL,
  `subcategory` varchar(128) DEFAULT NULL,
  `frontend_subcategory` varchar(128) DEFAULT NULL,
  `location` varchar(128) DEFAULT NULL,
  `name` varchar(128) DEFAULT NULL,
  `frontend_name` varchar(128) DEFAULT NULL,
  `frontend_show` int(1) DEFAULT '1',
  `sku` varchar(128) DEFAULT NULL,
  `si_item_id` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT '0',
  `cost` decimal(20,2) NOT NULL,
  `item_price` decimal(20,2) DEFAULT NULL,
  `price` text,
  `has_options` int(1) DEFAULT NULL,
  `options` text,
  `customer_price` text,
  `customer_options` text,
  `has_customer_options` int(1) DEFAULT NULL,
  `description` text,
  `supplier` varchar(128) DEFAULT NULL,
  `remarks` text,
  `is_active` varchar(10) DEFAULT NULL,
  `is_consigned` varchar(10) DEFAULT NULL,
  `alert_quantity` int(11) DEFAULT NULL,
  `max_quantity` int(11) DEFAULT NULL,
  `ordered_quantity` int(11) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `quick` int(1) DEFAULT NULL,
  `enter_price` int(1) DEFAULT NULL,
  `order` int(11) DEFAULT NULL,
  `category_order` int(11) DEFAULT NULL,
  `iphone` int(1) DEFAULT NULL,
  `grouped` int(1) DEFAULT NULL,
  `printer` varchar(128) DEFAULT NULL,
  `purchase_tax_code` varchar(128) DEFAULT NULL,
  `purchase_taxable` varchar(128) DEFAULT NULL,
  `supply_tax_code` varchar(128) DEFAULT NULL,
  `supply_taxable` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `fnb_inventory`
--

INSERT INTO `fnb_inventory` (`id`, `category`, `subcategory`, `frontend_subcategory`, `location`, `name`, `frontend_name`, `frontend_show`, `sku`, `si_item_id`, `qty`, `cost`, `item_price`, `price`, `has_options`, `options`, `customer_price`, `customer_options`, `has_customer_options`, `description`, `supplier`, `remarks`, `is_active`, `is_consigned`, `alert_quantity`, `max_quantity`, `ordered_quantity`, `added_on`, `added_by`, `modified_on`, `modified_by`, `quick`, `enter_price`, `order`, `category_order`, `iphone`, `grouped`, `printer`, `purchase_tax_code`, `purchase_taxable`, `supply_tax_code`, `supply_taxable`) VALUES
(1, 'Hot Drinks', 'Coffee', NULL, NULL, 'Espresso', NULL, 1, '1', NULL, 0, '0.00', '6.00', '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(2, 'Hot Drinks', 'Coffee', NULL, '0', 'Espresso Macchiato ', NULL, 1, '2', '', 0, '0.00', '8.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-02-10 18:04:02', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(3, 'Hot Drinks', 'Coffee', NULL, '0', 'Americano', NULL, 1, '3', '', 0, '0.00', '8.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:47:26', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(4, 'Hot Drinks', 'Coffee', NULL, NULL, 'Piccolo', NULL, 1, '4', NULL, 0, '0.00', '9.00', '9', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(5, 'Hot Drinks', 'Coffee', NULL, NULL, 'Cappuccino ', NULL, 1, '5', NULL, 0, '0.00', '11.00', '11', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(6, 'Hot Drinks', 'Coffee', NULL, NULL, 'Latte ', NULL, 1, '6', NULL, 0, '0.00', '11.00', '11', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(7, 'Hot Drinks', 'Coffee', NULL, NULL, 'Mocha ', NULL, 1, '7', NULL, 0, '0.00', '13.00', '13', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(8, 'Hot Drinks', 'Coffee', NULL, NULL, 'Caramel Macchiato ', NULL, 1, '8', NULL, 0, '0.00', '14.00', '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(9, 'Hot Drinks', 'Coffee', NULL, '0', 'Affogato', NULL, 1, '9', '', 0, '0.00', '12.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 15:18:51', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(10, 'Hot Drinks', 'Coffee', NULL, NULL, 'Dirty Chai', NULL, 1, '10', NULL, 0, '0.00', '14.00', '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(11, 'Hot Drinks', 'Coffee', NULL, NULL, 'Vanilla Latte', NULL, 1, '11', NULL, 0, '0.00', '14.00', '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(12, 'Hot Drinks', 'Coffee', NULL, NULL, 'DD Special', NULL, 1, '12', NULL, 0, '0.00', '14.00', '14', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(13, 'Cold Drinks', 'Coffee', NULL, '0', 'Iced Americano', NULL, 1, '13', '', 0, '0.00', '9.00', '["2"]', 0, '["Extra Shot "]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:47:42', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(14, 'Cold Drinks', 'Coffee', NULL, '0', 'Iced Cappucino ', NULL, 1, '14', '', 0, '0.00', '12.00', '["1"]', 0, '["Flavoured Syrup"]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-03-15 08:54:27', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(15, 'Cold Drinks', 'Coffee', NULL, '0', 'Iced Latte ', NULL, 1, '15', '', 0, '0.00', '12.00', '["1"]', 1, '["Flavoured Syrup"]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-09 14:37:59', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(16, 'Cold Drinks', 'Coffee', NULL, '0', 'Iced Mocha ', NULL, 1, '16', '', 0, '0.00', '14.00', '["2"]', 1, '["Extra Shot "]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-09 14:38:10', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(17, 'Cold Drinks', 'Coffee', NULL, '0', 'Iced Caramel Macchiato ', NULL, 1, '17', '', 0, '0.00', '14.00', '["2"]', 0, '["Extra Shot"]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:48:22', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(18, 'Cold Drinks', 'Coffee', NULL, '0', 'Iced Dirty Chai', NULL, 1, '18', '', 0, '0.00', '15.00', '["2"]', 1, '["Extra Shot"]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-09 14:38:40', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(19, 'Cold Drinks', 'Coffee', NULL, '0', 'Iced Vanilla Latte', NULL, 1, '19', '', 0, '0.00', '14.00', '["2"]', 0, '["Extra Shot "]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:48:48', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(20, 'Cold Drinks', 'Coffee', NULL, '0', 'Iced DD Special', NULL, 1, '20', '', 0, '0.00', '15.00', '["2"]', 1, '["Extra Shot"]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-09 14:44:07', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(21, 'Hot Drinks', 'Non Coffee', NULL, NULL, 'Chocolate ', NULL, 1, '21', NULL, 0, '0.00', '10.00', '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(22, 'Hot Drinks', 'Non Coffee', NULL, NULL, 'Honey Milk', NULL, 1, '22', NULL, 0, '0.00', '8.00', '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(23, 'Hot Drinks', 'Non Coffee', NULL, NULL, 'Lemon Tea', NULL, 1, '23', NULL, 0, '0.00', '8.00', '8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(24, 'Hot Drinks', 'Non Coffee', NULL, '0', 'Chai Latte', NULL, 1, '24', '', 0, '0.00', '12.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-11-18 19:08:15', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(25, 'Hot Drinks', 'Non Coffee', NULL, NULL, 'Matcha Latte', NULL, 1, '25', NULL, 0, '0.00', '13.00', '13', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(26, 'Cold Drinks', 'Non Coffee', NULL, '0', 'Iced Honey Lemon', NULL, 1, '26', '', 0, '0.00', '9.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-01-16 11:17:40', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(27, 'Cold Drinks', 'Non Coffee', NULL, '0', 'Iced Chocolate ', NULL, 1, '27', '', 0, '0.00', '11.00', '[""]', 1, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-09 14:44:30', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(28, 'Cold Drinks', 'Non Coffee', NULL, '0', 'Iced Honey Milk', NULL, 1, '28', '', 0, '0.00', '9.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-09 14:44:53', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(29, 'Cold Drinks', 'Non Coffee', NULL, '0', 'Iced Lemon Tea', NULL, 1, '29', '', 0, '0.00', '9.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-09 14:45:03', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(30, 'Cold Drinks', 'Non Coffee', NULL, '0', 'Iced Chai Latte', NULL, 1, '30', '', 0, '0.00', '13.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-09 14:45:20', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(31, 'Cold Drinks', 'Non Coffee', NULL, '0', 'Iced Matcha Latte', NULL, 1, '31', '', 0, '0.00', '14.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-09 14:46:07', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(32, 'Hot Drinks', 'Non Coffee', NULL, '0', 'Tea By Pot ', NULL, 1, '32', '', 0, '0.00', '13.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-09 14:54:09', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(33, 'Cold Drinks', 'Refreshing Drinks', NULL, '0', 'Cucumber Lime ', NULL, 1, '33', '', 0, '0.00', '11.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:51:30', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(34, 'Cold Drinks', 'Refreshing Drinks', NULL, '0', 'Ginger Lemongrass Soda', NULL, 1, '34', '', 0, '0.00', '12.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:51:49', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(35, 'Cold Drinks', 'Refreshing Drinks', NULL, '0', 'Passion Soda', NULL, 1, '35', '', 0, '0.00', '12.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:52:13', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(36, 'Cold Drinks', 'Refreshing Drinks', NULL, '0', 'Lemon Soda', NULL, 1, '36', '', 0, '0.00', '11.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:52:42', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(37, 'Cold Drinks', 'Refreshing Drinks', NULL, '0', 'Pineapple Orange Soda', NULL, 1, '37', '', 0, '0.00', '11.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-07-27 16:24:08', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(38, 'Cold Drinks', 'Smoothie', NULL, '0', 'Mixed Berries Smoothie', NULL, 1, '38', '', 0, '0.00', '15.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-07-18 09:40:56', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(39, 'Cold Drinks', 'Smoothie', NULL, '0', 'Mango Smoothies', NULL, 1, '39', '', 0, '0.00', '14.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-09 14:55:50', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(40, 'Cold Drinks', 'Smoothie', NULL, '0', 'Banana Smoothies', NULL, 1, '40', '', 0, '0.00', '14.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-09 14:56:02', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(41, 'Cold Drinks', 'Smoothie', NULL, '0', 'Blueberry Smoothies', NULL, 1, '41', '', 0, '0.00', '14.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-09 14:56:15', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(42, 'Cold Drinks', 'Smoothie', NULL, '0', 'Passion Smoothies', NULL, 1, '42', '', 0, '0.00', '15.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:57:45', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(43, 'Cold Drinks', 'Smoothie', NULL, '0', 'Strawberry Smoothies', NULL, 1, '43', '', 0, '0.00', '14.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-09 14:57:50', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(44, 'Cold Drinks', 'Soda & Beer', NULL, NULL, 'Tiger ', NULL, 1, '44', NULL, 0, '0.00', '10.00', '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(45, 'Cold Drinks', 'Soda & Beer', NULL, NULL, 'Soda', NULL, 1, '45', NULL, 0, '0.00', '5.00', '5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(46, 'Cold Drinks', 'Soda & Beer', NULL, NULL, 'Coke', NULL, 1, '46', NULL, 0, '0.00', '5.00', '5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(47, 'Cold Drinks', 'Soda & Beer', NULL, NULL, 'Light coke', NULL, 1, '47', NULL, 0, '0.00', '5.00', '5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(310, 'Meals', 'Rice', NULL, '0', 'AA Set - Double Fried Salted Pork', NULL, 1, '246', '', 0, '0.00', '18.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:39:26', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(49, 'Cold Drinks', 'Frappe', NULL, '0', 'Mocha Frappe', NULL, 1, '49', '', 0, '0.00', '14.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-09 14:58:12', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(50, 'Cold Drinks', 'Frappe', NULL, '0', 'Espresso Frappe', NULL, 1, '50', '', 0, '0.00', '14.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-09 14:58:29', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(51, 'Cold Drinks', 'Frappe', NULL, '0', 'Chocolate Frappe', NULL, 1, '51', '', 0, '0.00', '14.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-09 14:58:44', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(52, 'Cold Drinks', 'Frappe', NULL, '0', 'Pure Vanilla Frappe', NULL, 1, '52', '', 0, '0.00', '14.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-09 14:58:58', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(53, 'Cold Drinks', 'Frappe', NULL, '0', 'Matcha Frappe', NULL, 1, '53', '', 0, '0.00', '14.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-09 14:59:13', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(54, 'Cold Drinks', 'Frappe', NULL, '0', 'Chai Frappe', NULL, 1, '54', '', 0, '0.00', '14.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-09 14:59:31', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(59, 'Cold Drinks', 'Fresh Juice', NULL, '0', 'Sunshine', NULL, 1, '59', '', 0, '0.00', '12.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-10 14:14:00', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(60, 'Cold Drinks', 'Fresh Juice', NULL, '0', 'The Hulk', NULL, 1, '60', '', 0, '0.00', '12.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-10 14:14:16', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(61, 'Cold Drinks', 'Fresh Juice', NULL, '0', 'Slim Fit', NULL, 1, '61', '', 0, '0.00', '12.00', '[""]', 0, '[""]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-10 14:14:33', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(62, 'Cold Drinks', 'Fresh Juice', NULL, NULL, 'Orange', NULL, 1, '62', NULL, 0, '0.00', '9.00', '9', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(63, 'Cold Drinks', 'Fresh Juice', NULL, NULL, 'Lime', NULL, 1, '63', NULL, 0, '0.00', '9.00', '9', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(64, 'Cold Drinks', 'Fresh Juice', NULL, NULL, 'Green Apple', NULL, 1, '64', NULL, 0, '0.00', '9.00', '9', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(297, 'Meals', 'Non-Rice', NULL, '0', 'BBQ Pork Soup Noodle', NULL, 1, '233', '', 0, '0.00', '15.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:38:19', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(66, 'Cold Drinks', 'Fresh Juice', NULL, NULL, 'Watermelon ', NULL, 1, '66', NULL, 0, '0.00', '9.00', '9', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(67, 'Cold Drinks', 'Fresh Juice', NULL, NULL, 'Carrot milk', NULL, 1, '67', NULL, 0, '0.00', '9.00', '9', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(68, 'Cold Drinks', 'Fresh Juice', NULL, NULL, 'Mix 2 types ', NULL, 1, '68', NULL, 0, '0.00', '10.00', '10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(69, 'Cold Drinks', 'Fresh Juice', NULL, NULL, 'Mix 3 types', NULL, 1, '69', NULL, 0, '0.00', '12.00', '12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'SR', '1'),
(70, 'Meals', 'Rice', NULL, '0', 'Borneo Pepper Pork', NULL, 1, '70', '', 0, '0.00', '16.00', '["2","2"]', 1, '["Pasta","Takeaway "]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:37:38', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(71, 'Meals', 'Rice', NULL, '0', 'Chinese  Rice Wine Pork', NULL, 1, '71', '', 0, '0.00', '16.00', '["2","2"]', 1, '["Pasta ","Takeaway"]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:39:17', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(72, 'Meals', 'Rice', 'undefined', '0', 'Shimeji Mushroom with Chicken ', NULL, 1, '72', '', 0, '0.00', '16.00', '["2","2"]', 0, '["Pasta ","Takeaway"]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:41:33', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(73, 'Meals', 'Rice', NULL, '0', 'Marmite Chicken ', NULL, 1, '73', '', 0, '0.00', '16.00', '["2","2"]', 1, '["Pasta ","Takeaway"]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:39:33', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(74, 'Meals', 'Rice', NULL, '0', 'Sunrice', NULL, 1, '74', '', 0, '0.00', '13.00', '["2"]', 0, '["Takeaway "]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:40:32', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(75, 'Meals', 'Non-Rice', NULL, '0', 'Meatless Aglio Olio ', NULL, 1, '75', '', 0, '0.00', '16.00', '["4","4","2"]', 1, '["Chicken ","Bacon","Takeaway"]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:38:41', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(76, 'Meals', 'Non-Rice', NULL, '0', 'Meatless Pesto Pasta', NULL, 1, '76', '', 0, '0.00', '17.00', '["4","4","2"]', 1, '["Chicken ","Bacon ","Takeaway"]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:39:47', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(77, 'Meals', 'Non-Rice', NULL, '0', 'Sarawak Kolomee', NULL, 1, '77', '', 0, '0.00', '12.00', '["2"]', 1, '["Takeaway "]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:40:50', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(78, 'Meals', 'Snacks ', NULL, '0', 'Cheesy Baked Mashed Potato', NULL, 1, '78', '', 0, '0.00', '10.00', '["2"]', 0, '["Takeaway "]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-01-16 11:23:35', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(79, 'Meals', 'Salad', NULL, '0', 'Summer Salad ', NULL, 1, '79', '', 0, '0.00', '15.00', '["2"]', 1, '["Takeaway "]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:41:05', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(80, 'Meals', 'Salad', NULL, '0', 'Oriental Chicken Salad', NULL, 1, '80', '', 0, '0.00', '18.00', '["2"]', 1, '["Takeaway "]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:41:48', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', 'SR', '1'),
(301, 'Cold Drinks', 'Coffee', NULL, '0', 'Black Jack', NULL, 1, '237', '', 0, '0.00', '11.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-10-26 13:44:56', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(302, 'Desserts', '0', NULL, '0', 'Ice on the cake', NULL, 1, '238', '', 0, '0.00', '16.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-06 13:09:23', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(303, 'Meals', 'Snacks ', NULL, '0', 'Pan Fried Dumpling', NULL, 1, '239', '', 0, '0.00', '18.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-09 12:06:03', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(304, 'Desserts', '0', NULL, '0', 'Banana is On Fire', NULL, 1, '240', '', 0, '0.00', '12.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 15:28:09', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(305, 'Cold Drinks', 'Soda & Beer', NULL, '0', 'Sprite', NULL, 1, '241', '', 0, '0.00', '5.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-25 14:20:09', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(275, 'Cold Drinks', 'Soda & Beer', NULL, '0', 'Carlsberg', NULL, 1, '209', '', 0, '0.00', '10.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-02-26 17:23:54', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(176, 'Desserts', '0', NULL, '0', 'Scones ', NULL, 1, '111', '', 0, '0.00', '8.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-07 21:22:33', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(274, 'Desserts', '0', NULL, '0', '2 pcs Cookies', NULL, 1, '208', '', 0, '0.00', '7.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-02-25 16:20:36', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(174, 'Desserts', '0', NULL, '0', 'Strawberry Dose ', NULL, 1, '109', '', 0, '0.00', '10.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-07 21:22:09', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(273, 'Desserts', '0', NULL, '0', 'Single Cookies', NULL, 1, '207', '', 0, '0.00', '3.90', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-02-25 16:20:05', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(172, 'Desserts', '0', NULL, '0', 'Daily Berries ', NULL, 1, '106', '', 0, '0.00', '12.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-06-01 13:30:11', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(272, 'Meals', 'Non-Rice', NULL, '0', 'Genius in The Bowl', NULL, 1, '206', '', 0, '0.00', '8.00', '["2"]', 1, '["Takeaway"]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:42:51', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(170, 'Desserts', '0', NULL, '0', 'Daily Cheese ', NULL, 1, '104', '', 0, '0.00', '10.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-07 21:21:18', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(271, 'Meals', 'Morning Bites ', NULL, '0', 'Take It Easy', NULL, 1, '205', '', 0, '0.00', '15.00', '["2"]', 0, '["Takeaway "]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-07-17 12:51:25', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(288, 'Meals', 'Non-Rice', NULL, '0', 'Smoked Duck Pesto Pasta', NULL, 1, '222', '', 0, '0.00', '23.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:39:02', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(327, 'Meals', 'Morning Bites ', NULL, '0', 'Gula Melaka Toast', NULL, 1, '263', '', 0, '0.00', '16.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 15:38:52', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(166, 'Desserts', '0', NULL, '0', 'Chocolate Dose ', NULL, 1, '100', '', 0, '0.00', '12.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-06-01 13:31:45', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(269, 'Hot Drinks', 'Coffee', NULL, '0', 'Espresso Con Panna', NULL, 1, '203', '', 0, '0.00', '8.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-03-15 08:53:06', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(163, 'Desserts', '0', NULL, '0', 'Melting Heart ', NULL, 1, '97', '', 0, '0.00', '12.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 15:26:59', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(162, 'Meals', 'Snacks ', NULL, '0', 'Homemade Chicken Bite ', NULL, 1, '96', '', 0, '0.00', '15.00', '["2"]', 0, '["Takeaway"]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-10-05 11:53:58', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(161, 'Meals', 'Snacks ', NULL, '0', 'Signature Dumpling (10 Pcs) ', NULL, 1, '95', '', 0, '0.00', '16.00', '["2"]', 0, '["Takeaway"]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-01-16 11:26:49', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(160, 'Meals', 'Snacks ', NULL, '0', 'Signature Dumpling (5 Pcs)', NULL, 1, '94', '', 0, '0.00', '9.00', '["2"]', 0, '["Takeaway"]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-01-16 11:27:27', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(159, 'Desserts', '0', NULL, '0', 'Yuzu Marmalade Yogurt Bowl', NULL, 1, '228', '', 0, '0.00', '15.00', '["2"]', 0, '["Takeaway"]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 15:54:59', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(158, 'Meals', 'Morning Bites ', NULL, '0', 'Banana Stuffed Nutella Toast ', NULL, 1, '92', '', 0, '0.00', '16.00', '["2"]', 1, '["Takeaway "]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 15:36:52', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(157, 'Meals', 'Morning Bites ', NULL, '0', 'Classic French Toast', NULL, 1, '91', '', 0, '0.00', '14.00', '["2"]', 1, '["Takeaway"]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 15:37:51', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(156, 'Meals', 'Morning Bites ', NULL, '0', 'House Cheddar Omelet', NULL, 1, '90', '', 0, '0.00', '13.00', '["2"]', 1, '["Takeaway"]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-07-17 12:52:59', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(328, 'Meals', 'Morning Bites ', NULL, '0', 'Basic Blueberries Toast', NULL, 1, '264', '', 0, '0.00', '16.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 15:40:00', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(154, 'Meals', 'Morning Bites ', NULL, '0', 'Daily Dose BLT', NULL, 1, '88', '', 0, '0.00', '16.00', '["2 ",""]', 0, '["Takeaway",""]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-02-10 18:07:53', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(153, 'Meals', 'Morning Bites ', NULL, '0', 'Wake Me Up!', NULL, 1, '87', '', 0, '0.00', '21.00', '["2",""]', 0, '["Takeaway",""]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-02-10 18:08:39', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(287, 'Meals', 'Non-Rice', NULL, '0', 'Meatless Red Pasta', NULL, 1, '221', '', 0, '0.00', '17.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:42:01', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(179, 'Desserts', '0', NULL, '0', 'Creme Brulee ', NULL, 1, '114', '', 0, '0.00', '12.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-05-27 16:16:29', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(181, 'Meals', 'Perfect Meals', NULL, '0', 'Open Food ', NULL, 1, '116', '', 0, '0.00', '0.00', '["0"]', 0, '["Random"]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-28 14:11:21', 'admin', NULL, NULL, 0, 1, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(182, 'Cold Drinks', 'Fresh Juice', NULL, '0', 'Open Drinks ', NULL, 1, '117', '', 0, '0.00', '0.00', '["0"]', 1, '["Random"]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2016-09-25 21:13:43', 'lois', NULL, NULL, 0, 1, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(183, 'Meals', 'Rice', NULL, '0', 'Plain Rice', NULL, 1, '118', '', 0, '0.00', '2.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:45:18', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(195, 'Cold Drinks', 'Non Coffee', NULL, '0', 'Iced Tea', NULL, 1, '130', '', 0, '0.00', '8.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-01-16 11:21:08', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(270, 'Meals', 'Morning Bites ', NULL, '0', 'Homemade Savoury Pancake', NULL, 1, '204', '', 0, '0.00', '18.00', '["2"]', 1, '["Takeaway"]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 15:41:37', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(184, 'Hot Drinks', 'Coffee', NULL, '0', 'Flat White', NULL, 1, '119', '', 0, '0.00', '11.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-09 14:04:38', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(330, 'Meals', 'Morning Bites ', NULL, '0', 'Sunny Pancake', NULL, 1, '266', '', 0, '0.00', '18.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 15:42:05', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(329, 'Meals', 'Morning Bites ', NULL, '0', 'Peanut Butter Toast', NULL, 1, '265', '', 0, '0.00', '16.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 15:41:14', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(185, 'Cold Drinks', 'Soda & Beer', NULL, '0', 'Bottled Water', NULL, 1, '120', '', 0, '0.00', '3.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2016-06-10 14:13:24', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(262, 'Desserts', '0', NULL, '0', 'Cheesy Sticks', NULL, 1, '196', '', 0, '0.00', '3.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-01-18 10:09:38', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(188, 'Meals', 'Non-Rice', NULL, '0', 'Sarawak Laksa', NULL, 1, '123', '', 0, '0.00', '18.00', '["2"]', 1, '["Takeaway"]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:45:34', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(290, 'Meals', 'Non-Rice', NULL, '0', 'Seasoned Chicken Red Pasta', NULL, 1, '224', '', 0, '0.00', '21.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:45:53', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(276, 'Cold Drinks', 'Soda & Beer', NULL, '0', 'Penang Craft Beer', NULL, 1, '210', '', 0, '0.00', '21.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-03-02 14:40:37', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(278, 'Hot Drinks', 'Coffee', NULL, '0', 'Espresso Shot', NULL, 1, '212', '', 0, '0.00', '1.50', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-04-03 14:09:22', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(192, 'Meals', 'Rice', NULL, '0', 'Flaming Hot & Spicy Pork', NULL, 1, '127', '', 0, '0.00', '16.00', '["2"]', 0, '["Takeaway"]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:46:11', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(291, 'Meals', 'Non-Rice', NULL, '0', 'Smoked Duck Red Pasta', NULL, 1, '225', '', 0, '0.00', '23.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:46:28', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(194, 'Meals', 'Snacks ', NULL, '0', 'Deep Fried Chicken Wings', NULL, 1, '129', '', 0, '0.00', '13.00', '["2"]', 0, '["Takeaway "]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-07-17 12:57:51', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(316, 'Meals', 'Rice', NULL, '0', 'AA Set - Sesame Chicken', NULL, 1, '252', '', 0, '0.00', '18.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:42:08', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(219, 'Meals', 'Rice', NULL, '0', 'Fried Rice With Bacon', NULL, 1, '153', '', 0, '0.00', '16.00', '["2"]', 1, '["Takeaway"]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:46:41', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(215, 'Meals', 'Rice', NULL, '0', 'Thai Fish Sauce Garlic Pork', NULL, 1, '149', '', 0, '0.00', '16.00', '["2"]', 0, '["Takeaway"]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:44:58', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(216, 'Meals', 'Snacks ', NULL, '0', 'Chicken In The Blanket', NULL, 1, '150', '', 0, '0.00', '18.00', '["2"]', 0, '["Takeaway "]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-07-17 12:59:20', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(217, 'Meals', 'Rice', NULL, '0', 'Spicy Lemony Wings', NULL, 1, '151', '', 0, '0.00', '16.00', '["2"]', 1, '["Takeaway "]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:43:41', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(277, 'Cold Drinks', 'Non Coffee', NULL, '0', 'Iced Ginger Lemongrass', NULL, 1, '211', '', 0, '0.00', '9.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-03-11 10:15:41', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(265, 'DISCOUNT ', '0', NULL, '0', 'Old Penang PostCard', NULL, 1, '199', '', 0, '0.00', '6.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-08-02 11:16:09', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(207, 'Meals', 'Morning Bites ', NULL, '0', 'Cheesy Bacon Toast', NULL, 1, '142', '', 0, '0.00', '17.00', '["2"]', 0, '["Takeaway"]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-07-17 13:01:11', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(208, 'DISCOUNT ', '0', NULL, '0', 'RM5 DISCOUNT ', NULL, 1, 'D0001', '', 0, '0.00', '-5.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-01-16 11:18:08', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(209, 'Hot Drinks', 'Non Coffee', NULL, '0', 'Honey Lemon', NULL, 1, '143', '', 0, '0.00', '8.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2016-08-28 11:17:43', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(210, 'Cold Drinks', 'Fresh Juice', NULL, '0', 'Red Riding Hood', NULL, 1, '144', '', 0, '0.00', '12.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2016-08-31 14:22:49', 'sanni', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(211, 'Meals', 'Rice', NULL, '0', 'Asian Spicy Lemony Chicken', NULL, 1, '145', '', 0, '0.00', '16.00', '["2"]', 0, '["Takeaway"]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:43:29', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(212, 'Meals', 'Salad', NULL, '0', 'Pork Bacon Salad', NULL, 1, '146', '', 0, '0.00', '18.00', '["2"]', 0, '["Takeaway"]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:42:23', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(317, 'Meals', 'Rice', NULL, '0', 'AA Set - Japanese Curry Rice', NULL, 1, '253', '', 0, '0.00', '18.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:42:53', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(315, 'Meals', 'Rice', NULL, '0', 'AA Set - Asian Spicy Lemony Chicken', NULL, 1, '251', '', 0, '0.00', '18.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:41:48', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(314, 'Meals', 'Rice', NULL, '0', 'AA Set - Thai Styled Garlic Pork', NULL, 1, '250', '', 0, '0.00', '18.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:41:26', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(220, 'Meals', 'Non-Rice', NULL, '0', 'Pork Bacon Pesto Pasta', NULL, 1, '154', '', 0, '0.00', '21.00', '["2"]', 0, '["Takeaway"]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:41:17', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(221, 'Meals', 'Non-Rice', NULL, '0', 'Seasoned Chicken Pesto Pasta', NULL, 1, '155', '', 0, '0.00', '21.00', '["2"]', 1, '["Takeaway "]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:43:16', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(222, 'Meals', 'Non-Rice', NULL, '0', 'Seasoned Chicken Aglio Olio', NULL, 1, '156', '', 0, '0.00', '20.00', '["2"]', 1, '["Takeaway "]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:43:04', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(223, 'Meals', 'Non-Rice', NULL, '0', 'Smoked Duck Aglio Olio', NULL, 1, '226', '', 0, '0.00', '22.00', '["2"]', 0, '["Takeaway"]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:42:12', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(225, 'Meals', 'Salad', NULL, '0', 'Smoked Duck Salad', NULL, 1, '159', '', 0, '0.00', '20.00', '["2"]', 1, '["Takeaway"]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:40:16', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(263, 'DISCOUNT ', '0', NULL, '0', 'Postcard With Postage', NULL, 1, '197', '', 0, '0.00', '4.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-08-02 11:15:43', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(226, 'Meals', 'Snacks ', NULL, '0', 'Cheesy Shepherd Pie', NULL, 1, '160', '', 0, '0.00', '14.00', '["2"]', 0, '["Takeaway "]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-07-17 13:05:31', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(264, 'DISCOUNT ', '0', NULL, '0', 'PostCard', NULL, 1, '198', '', 0, '0.00', '3.50', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-08-02 11:16:51', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(229, 'Meals', 'Non-Rice', NULL, '0', 'Mummy''s Pasta', NULL, 1, '163', '', 0, '0.00', '16.00', '["2"]', 1, '["Takeaway"]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:42:34', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(286, 'Meals', 'Morning Bites ', NULL, '0', 'Joyous Sunny', NULL, 1, '220', '', 0, '0.00', '20.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-08 13:10:08', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(231, 'Meals', 'Rice', NULL, '0', 'Hometown Fried Rice', NULL, 1, '165', '', 0, '0.00', '15.00', '["2"]', 1, '["Takeaway"]', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:43:51', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(232, 'Meals', 'Snacks ', NULL, '0', 'Candied Spicy Bacon Strips', NULL, 1, '166', '', 0, '0.00', '12.00', '["2"]', 0, '["Takeaway"]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-07-17 13:09:48', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(233, 'Desserts', '0', NULL, '0', 'Naugthy Girl', NULL, 1, '167', '', 0, '0.00', '12.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 15:26:10', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(234, 'Desserts', '0', NULL, '0', 'Naughty Boy', NULL, 1, '168', '', 0, '0.00', '12.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 15:26:25', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(235, 'Desserts', '0', NULL, '0', 'I''m Single', NULL, 1, '169', '', 0, '0.00', '4.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 15:27:31', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(236, 'Hot Drinks', 'Non Coffee', NULL, '0', 'Vanilla Milk', NULL, 1, '170', '', 0, '0.00', '8.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2016-11-18 19:04:04', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(237, 'Cold Drinks', 'Non Coffee', NULL, '0', 'Iced Vanilla Milk', NULL, 1, '171', '', 0, '0.00', '9.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2016-11-18 19:04:28', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(238, 'Hot Drinks', 'Non Coffee', NULL, '0', 'Caramel Chocolate', NULL, 1, '172', '', 0, '0.00', '13.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2016-11-18 19:04:53', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(239, 'Cold Drinks', 'Non Coffee', NULL, '0', 'Iced Caramel Chocolate', NULL, 1, '173', '', 0, '0.00', '14.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2016-11-18 19:05:29', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(240, 'Cold Drinks', 'Frappe', NULL, '0', 'Chocolate Affogato', NULL, 1, '174', '', 0, '0.00', '15.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2016-11-18 19:06:32', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(241, 'Cold Drinks', 'Frappe', NULL, '0', 'Caramel Affogato', NULL, 1, '175', '', 0, '0.00', '15.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2016-11-18 19:06:57', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(242, 'Cold Drinks', 'Refreshing Drinks', NULL, '0', 'Citrus Soda', NULL, 1, '176', '', 0, '0.00', '10.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2016-11-18 19:07:28', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(243, 'Hot Drinks', 'Non Coffee', NULL, '0', 'Hot Ginger Lemongrass', NULL, 1, '177', '', 0, '0.00', '8.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2018-01-21 15:48:33', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(244, 'Desserts', '0', NULL, '0', 'Macadamia Scones', NULL, 1, '178', '', 0, '0.00', '10.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2016-12-08 17:52:14', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(247, 'Desserts', '0', NULL, '0', 'Caramel Chocolate Cheese', NULL, 1, '181', '', 0, '0.00', '12.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2016-12-22 17:15:24', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(293, 'Desserts', '0', NULL, '0', 'Classic Yogurt Bowl', NULL, 1, '229', '', 0, '0.00', '16.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 15:54:27', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(306, 'Meals', 'Rice', NULL, '0', 'AA Set - Chinese Rice Wine Pork', NULL, 1, '242', '', 0, '0.00', '18.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:36:27', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(294, 'Meals', 'Rice', NULL, '0', 'Double Fry Salted Pork', NULL, 1, '230', '', 0, '0.00', '16.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:44:39', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(295, 'Meals', 'Rice', NULL, '0', 'Chinese Ginger Garlic Chicken', NULL, 1, '231', '', 0, '0.00', '16.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:44:29', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(253, 'Meals', 'Snacks ', NULL, '0', 'Cheese Baked Nachos', NULL, 1, '187', '', 0, '0.00', '14.00', '["2"]', 0, '["Takeaway"]', '', '', 1, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-07-17 13:13:19', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(268, 'Cold Drinks', 'Coffee', NULL, '0', 'Iced Cocoa Cappucino', NULL, 1, '202', '', 0, '0.00', '15.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-03-15 08:52:06', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(267, 'Hot Drinks', 'Coffee', NULL, '0', 'Cocoa Cappucino', NULL, 1, '201', '', 0, '0.00', '14.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-02-10 18:07:23', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(266, 'Cold Drinks', 'Soda & Beer', NULL, '0', 'Tiger Beer Bucket', NULL, 1, '200', '', 0, '0.00', '48.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-02-01 20:50:57', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(319, 'Meals', 'Non-Rice', NULL, '0', 'AA Set - Spicy Shrimp Macaroni', NULL, 1, '255', '', 0, '0.00', '18.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:44:17', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(318, 'Meals', 'Non-Rice', NULL, '0', 'AA Set - Mummy''s Pasta', NULL, 1, '254', '', 0, '0.00', '18.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:43:25', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(289, 'Meals', 'Non-Rice', NULL, '0', 'Pork Bacon Red Pasta', NULL, 1, '223', '', 0, '0.00', '21.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:44:03', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(299, 'Cold Drinks', 'Coffee', NULL, '0', 'Iced Salted Caramel Latte', NULL, 1, '235', '', 0, '0.00', '14.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-12-08 13:49:42', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(284, 'Desserts', '0', NULL, '0', 'Caramel Waffles', NULL, 1, '218', '', 0, '0.00', '3.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-06-29 17:14:32', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(298, 'Hot Drinks', 'Coffee', NULL, '0', 'Salted Caramel Latte', NULL, 1, '234', '', 0, '0.00', '13.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-12-08 13:50:31', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(300, 'Cold Drinks', 'Smoothie', NULL, '0', 'Special Smoothie', NULL, 1, '236', '', 0, '0.00', '15.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-10-08 10:39:48', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(313, 'Meals', 'Rice', NULL, '0', 'AA Set - Marmite Chicken', NULL, 1, '249', '', 0, '0.00', '18.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:40:43', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(312, 'Meals', 'Rice', NULL, '0', 'AA Set - Salted Chicken w Garlic & Spring Onion', NULL, 1, '248', '', 0, '0.00', '18.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:40:23', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(311, 'Meals', 'Rice', NULL, '0', 'AA Set - Shimeji Mushroom with Chicken', NULL, 1, '247', '', 0, '0.00', '18.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:39:45', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(292, 'Meals', 'Non-Rice', NULL, '0', 'Pork Bacon Aglio Olio', NULL, 1, '227', '', 0, '0.00', '20.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-18 15:44:15', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(309, 'Meals', 'Rice', NULL, '0', 'AA Set - Borneo Pepper Pork', NULL, 1, '245', '', 0, '0.00', '18.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:39:05', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(308, 'Meals', 'Rice', NULL, '0', 'AA Set - Chinese Ginger Garlic chicken', NULL, 1, '244', '', 0, '0.00', '18.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:38:22', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0');
INSERT INTO `fnb_inventory` (`id`, `category`, `subcategory`, `frontend_subcategory`, `location`, `name`, `frontend_name`, `frontend_show`, `sku`, `si_item_id`, `qty`, `cost`, `item_price`, `price`, `has_options`, `options`, `customer_price`, `customer_options`, `has_customer_options`, `description`, `supplier`, `remarks`, `is_active`, `is_consigned`, `alert_quantity`, `max_quantity`, `ordered_quantity`, `added_on`, `added_by`, `modified_on`, `modified_by`, `quick`, `enter_price`, `order`, `category_order`, `iphone`, `grouped`, `printer`, `purchase_tax_code`, `purchase_taxable`, `supply_tax_code`, `supply_taxable`) VALUES
(307, 'Meals', 'Rice', NULL, '0', 'AA Set - Flaming Hot & spicy Pork', NULL, 1, '243', '', 0, '0.00', '18.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:37:45', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(296, 'Meals', 'Morning Bites ', NULL, '0', 'Classic Egg Sandwich', NULL, 1, '232', '', 0, '0.00', '12.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-09-09 08:58:05', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(285, 'Meals', 'Snacks ', NULL, '0', 'Tip Tap Lor Bak', NULL, 1, '219', '', 0, '0.00', '9.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-07-24 16:57:31', 'admin', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(320, 'Meals', 'Non-Rice', NULL, '0', 'AA Set - Sarawak Kolomee', NULL, 1, '256', '', 0, '0.00', '15.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:45:02', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(321, 'Meals', 'Non-Rice', NULL, '0', 'AA Set - Genius In the Bowl', NULL, 1, '257', '', 0, '0.00', '11.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:45:20', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(322, 'Cold Drinks', 'Refreshing Drinks', NULL, '0', 'Yuzu Soda', NULL, 1, '258', '', 0, '0.00', '11.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:53:25', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(323, 'Cold Drinks', 'Refreshing Drinks', NULL, '0', 'Ginger Cucumber Lemon Soda', NULL, 1, '259', '', 0, '0.00', '12.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:54:15', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(324, 'Cold Drinks', 'Refreshing Drinks', NULL, '0', 'Blueberry Lemon Soda', NULL, 1, '260', '', 0, '0.00', '14.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:54:57', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(325, 'Cold Drinks', 'Smoothie', NULL, '0', 'Strawberry Chocolate Smoothie', NULL, 1, '261', '', 0, '0.00', '15.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:56:40', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(326, 'Cold Drinks', 'Smoothie', NULL, '0', 'Strawberry Banana Smoothie', NULL, 1, '262', '', 0, '0.00', '15.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 14:57:15', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(331, 'Meals', 'Morning Bites ', NULL, '0', 'Yuzu Marmalade Pancake', NULL, 1, '267', '', 0, '0.00', '14.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 15:42:52', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(332, 'Meals', 'Salad', NULL, '0', 'Chickpeas & Pumpkin Salad ', NULL, 1, '268', '', 0, '0.00', '18.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 15:43:57', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(333, 'Meals', 'Morning Bites ', NULL, '0', 'Morning Omelette', NULL, 1, '269', '', 0, '0.00', '16.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-29 15:48:09', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(334, 'Hot Drinks', 'Coffee', NULL, '0', 'Honey Latte', NULL, 1, '270', '', 0, '0.00', '13.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-30 09:40:02', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(335, 'Cold Drinks', 'Coffee', NULL, '0', 'Iced Honey Latte', NULL, 1, '271', '', 0, '0.00', '14.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-11-30 09:40:20', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(336, 'Cold Drinks', 'Non Coffee', NULL, '0', 'iced Yuzu', NULL, 1, '272', '', 0, '0.00', '9.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-12-08 13:48:53', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(337, 'Hot Drinks', 'Non Coffee', NULL, '0', 'Hot yuzu', NULL, 1, '273', '', 0, '0.00', '8.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-12-08 13:49:07', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(338, 'Cold Drinks', 'Smoothie', NULL, '0', 'Chocolate Banana Smoothie', NULL, 1, '274', '', 0, '0.00', '15.00', '', 0, '', '', '', 0, '', NULL, '', NULL, NULL, 0, 0, NULL, '2017-12-10 13:21:56', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0'),
(339, 'Cold Drinks', 'Soda & Beer', NULL, '0', '100+', NULL, 1, '275', '', 0, '0.00', '5.00', '', 0, '', '', '', 0, '0', NULL, '', NULL, NULL, 0, 0, NULL, '2017-12-11 15:41:28', 'lois', NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, '', '', '0', '', '0');

-- --------------------------------------------------------

--
-- Table structure for table `fnb_printer_map`
--

CREATE TABLE `fnb_printer_map` (
  `id` int(11) NOT NULL,
  `categories` tinytext,
  `subcategories` text,
  `printer_ip` varchar(32) DEFAULT NULL,
  `waiter_copy` varchar(255) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `fnb_printer_map`
--

INSERT INTO `fnb_printer_map` (`id`, `categories`, `subcategories`, `printer_ip`, `waiter_copy`) VALUES
(1, 'Meals', NULL, 'Kitchen', NULL),
(3, 'Cold Drinks,Desserts,DISCOUNT ,Hot Drinks,Meals', NULL, 'cashier', '0');

-- --------------------------------------------------------

--
-- Table structure for table `fnb_reverts`
--

CREATE TABLE `fnb_reverts` (
  `id` int(11) NOT NULL,
  `performed_by` varchar(128) DEFAULT NULL,
  `data` text,
  `datetime` datetime DEFAULT NULL,
  `revert` int(1) DEFAULT NULL,
  `remarks` text
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `fnb_reverts`
--

INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(1, '', '{"void_item":{"id":"1","date":"2016-06-07 20:30:44","ss_terminal":null,"ss_code":null,"sale_id":"1","si_item_id":null,"item_id":"10","item_sku":"10","item_name":"Dirty Chai","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-07 20:30:44","serial":"admin-1465302255-14653026440269293","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-07 20:30:51', NULL, ''),
(2, 'admin', '{"sale":{"id":"4","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-07 21:51:12","payment_status":"Unpaid","cost":null,"subtotal":"47.00","amount":"47.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1465306097","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"11","date":"2016-06-07 21:51:14","ss_terminal":null,"ss_code":null,"sale_id":"4","si_item_id":null,"item_id":"70","item_sku":"70","item_name":"Pepper Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-07 21:51:14","serial":"admin-1465306097-14653074747488185","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"12","date":"2016-06-07 21:51:14","ss_terminal":null,"ss_code":null,"sale_id":"4","si_item_id":null,"item_id":"76","item_sku":"76","item_name":"Pesto Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-07 21:51:14","serial":"admin-1465306097-14653074747488185","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"13","date":"2016-06-07 21:51:14","ss_terminal":null,"ss_code":null,"sale_id":"4","si_item_id":null,"item_id":"74","item_sku":"74","item_name":"Sunrice","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-07 21:51:14","serial":"admin-1465306097-14653074747488185","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-06-07 21:52:43', NULL, ''),
(3, 'admin', '{"sale":{"id":"5","txn_no":null,"table_no":"T11","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-07 21:52:56","payment_status":"Unpaid","cost":null,"subtotal":"154.00","amount":"77.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":"77.00","adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1465306097","discount_type":"p","discount":"50","payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"16","date":"2016-06-07 21:52:58","ss_terminal":null,"ss_code":null,"sale_id":"5","si_item_id":null,"item_id":"72","item_sku":"72","item_name":"Mushroom Chicken","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-07 21:52:58","serial":"admin-1465306097-14653075782557197","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":"0.0","global_discount":null},{"id":"15","date":"2016-06-07 21:52:58","ss_terminal":null,"ss_code":null,"sale_id":"5","si_item_id":null,"item_id":"76","item_sku":"76","item_name":"Pesto Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-07 21:52:58","serial":"admin-1465306097-14653075782557197","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null},{"id":"14","date":"2016-06-07 21:52:58","ss_terminal":null,"ss_code":null,"sale_id":"5","si_item_id":null,"item_id":"70","item_sku":"70","item_name":"Pepper Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-07 21:52:58","serial":"admin-1465306097-14653075782557197","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"17","date":"2016-06-07 21:58:34","ss_terminal":null,"ss_code":null,"sale_id":"5","si_item_id":"0","item_id":"76","item_sku":"76","item_name":"Pesto Pasta","item_option":"Additional Meat","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"22.00","margin":"22.0000","cost":"0.0000","amount":"22.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-07 21:58:34","serial":"admin-1465306097-14653079145919491","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"18","date":"2016-06-07 21:58:58","ss_terminal":null,"ss_code":null,"sale_id":"5","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"","category":"0","subcategory":"0","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-07 21:58:58","serial":"admin-1465306097-14653079386384371","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"19","date":"2016-06-07 22:01:01","ss_terminal":null,"ss_code":null,"sale_id":"5","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"Eggs","category":"0","subcategory":"0","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-07 22:01:01","serial":"admin-1465306097-14653080613669911","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"20","date":"2016-06-07 22:01:44","ss_terminal":null,"ss_code":null,"sale_id":"5","si_item_id":"0","item_id":"76","item_sku":"76","item_name":"Pesto Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"4","price_per_unit":"18.00","margin":"126.0000","cost":"0.0000","amount":"72.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-07 22:01:44","serial":"admin-1465306097-14653081039256994","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-06-09 09:22:21', NULL, ''),
(4, 'admin', '{"sale":{"id":"6","txn_no":null,"table_no":"T11(S)","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-07 22:02:38","payment_status":"Unpaid","cost":null,"subtotal":"36.00","amount":"36.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1465306097","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":null,"customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":null},"sale_items":[{"id":"21","date":"2016-06-07 00:00:00","ss_terminal":null,"ss_code":null,"sale_id":"6","si_item_id":"0","item_id":"76","item_sku":"76","item_name":"Pesto Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"2","price_per_unit":"18.00","margin":null,"cost":null,"amount":"36.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-07 22:01:44","serial":"admin-1465306097-14653081039256994","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-06-09 09:22:27', NULL, ''),
(5, 'admin', '{"sale":{"id":"7","txn_no":null,"table_no":"T11(S)(S)","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-07 22:02:56","payment_status":"Unpaid","cost":null,"subtotal":"18.00","amount":"18.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1465306097","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":null,"customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":null},"sale_items":[{"id":"22","date":"2016-06-07 00:00:00","ss_terminal":null,"ss_code":null,"sale_id":"7","si_item_id":"0","item_id":"76","item_sku":"76","item_name":"Pesto Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":null,"cost":null,"amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-07 22:01:44","serial":"admin-1465306097-14653081039256994","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-06-09 09:23:45', NULL, ''),
(6, 'admin', '{"sale":{"id":"8","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-07 22:03:21","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1465306097","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-06-09 09:23:51', NULL, ''),
(7, 'lois', '{"void_item":{"id":"28","date":"2016-06-09 10:56:18","ss_terminal":null,"ss_code":null,"sale_id":"13","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-09 10:56:18","serial":"Staff-1465438933-14654409782024216","warehouse_id":"0","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-09 10:57:03', NULL, ''),
(8, 'lois', '{"void_item":{"id":"31","date":"2016-06-09 11:06:10","ss_terminal":null,"ss_code":null,"sale_id":"14","si_item_id":"0","item_id":"75","item_sku":"75","item_name":"Aglio Olio ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"36.0000","cost":"0.0000","amount":"36.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-09 11:06:10","serial":"Staff-1465438933-14654415699897392","warehouse_id":"0","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-09 11:06:23', NULL, ''),
(9, 'lois', '{"void_item":{"id":"31","date":"2016-06-09 11:06:10","ss_terminal":null,"ss_code":null,"sale_id":"14","si_item_id":"0","item_id":"75","item_sku":"75","item_name":"Aglio Olio ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"36.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-09 11:06:10","serial":"Staff-1465438933-14654415699897392","warehouse_id":"0","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-09 11:06:42', NULL, ''),
(10, 'lois', '{"void_item":{"id":"35","date":"2016-06-09 11:07:39","ss_terminal":null,"ss_code":null,"sale_id":"14","si_item_id":"0","item_id":"75","item_sku":"75","item_name":"Aglio Olio ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-09 11:07:39","serial":"Staff-1465438933-14654416591067051","warehouse_id":"0","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-09 11:07:53', NULL, ''),
(11, 'lois', '{"void_item":{"id":"34","date":"2016-06-09 11:07:06","ss_terminal":null,"ss_code":null,"sale_id":"14","si_item_id":"0","item_id":"178","item_sku":"113","item_name":"Brownies ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-09 11:07:06","serial":"Staff-1465438933-14654416264027882","warehouse_id":"0","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-09 11:08:05', NULL, ''),
(12, 'lois', '{"void_item":{"id":"33","date":"2016-06-09 11:07:06","ss_terminal":null,"ss_code":null,"sale_id":"14","si_item_id":"0","item_id":"75","item_sku":"75","item_name":"Aglio Olio ","item_option":"Chicken","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"22.00","margin":"22.0000","cost":"0.0000","amount":"22.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-09 11:07:06","serial":"Staff-1465438933-14654416264027882","warehouse_id":"0","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-09 11:08:14', NULL, ''),
(13, 'lois', '{"void_item":{"id":"32","date":"2016-06-09 11:07:06","ss_terminal":null,"ss_code":null,"sale_id":"14","si_item_id":"0","item_id":"75","item_sku":"75","item_name":"Aglio Olio ","item_option":"Bacon","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"22.00","margin":"22.0000","cost":"0.0000","amount":"22.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-09 11:07:06","serial":"Staff-1465438933-14654416264027882","warehouse_id":"0","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-09 11:08:42', NULL, ''),
(14, 'lois', '{"sale":{"id":"14","txn_no":null,"table_no":"T10","user_id":"10011","username":"Staff","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-09 11:04:55","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1465438933","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-06-09 11:09:14', NULL, ''),
(15, 'admin', '{"sale":{"id":"15","txn_no":null,"table_no":"T7","user_id":"10011","username":"Staff","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-09 11:10:00","payment_status":"Unpaid","cost":null,"subtotal":"18.00","amount":"18.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1465438933","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"36","date":"2016-06-09 11:10:02","ss_terminal":null,"ss_code":null,"sale_id":"15","si_item_id":"0","item_id":"75","item_sku":"75","item_name":"Aglio Olio ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-09 11:10:02","serial":"Staff-1465438933-14654418027076173","warehouse_id":"0","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-06-09 11:10:18', NULL, ''),
(16, '', '{"void_item":{"id":"37","date":"2016-06-09 11:33:55","ss_terminal":null,"ss_code":null,"sale_id":"10","si_item_id":"0","item_id":"182","item_sku":"117","item_name":"Open Drinks ","item_option":"","category":"Open","subcategory":"Drinks","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-09 11:33:55","serial":"Staff-1465438933-14654432349624485","warehouse_id":"0","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-09 11:34:00', NULL, ''),
(17, '', '{"void_item":{"id":"25","date":"2016-06-09 10:22:07","ss_terminal":null,"ss_code":null,"sale_id":"10","si_item_id":"0","item_id":"182","item_sku":"117","item_name":"Open Drinks ","item_option":"","category":"0","subcategory":"0","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-09 10:22:07","serial":"Staff-1465438359-14654389272725684","warehouse_id":"0","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-09 11:34:04', NULL, ''),
(18, 'admin', '{"sale":{"id":"10","txn_no":null,"table_no":"TEST","user_id":"10011","username":"Staff","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-09 10:14:27","payment_status":"Unpaid","cost":null,"subtotal":"17.00","amount":"17.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1465438359","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"43","date":"2016-06-09 11:59:29","ss_terminal":null,"ss_code":null,"sale_id":"10","si_item_id":"0","item_id":"72","item_sku":"72","item_name":"Mushroom Chicken","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-09 11:59:29","serial":"Staff-1465438933-14654447697951264","warehouse_id":"0","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-06-09 12:02:16', NULL, ''),
(19, 'admin', '{"sale":{"id":"18","txn_no":null,"table_no":"TEST","user_id":"10011","username":"Staff","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-09 12:04:08","payment_status":"Unpaid","cost":null,"subtotal":"20.00","amount":"20.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1465438933","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"44","date":"2016-06-09 12:04:23","ss_terminal":null,"ss_code":null,"sale_id":"18","si_item_id":"0","item_id":"83","item_sku":"83","item_name":"Mushroom Chicken ","item_option":"","category":"Meals","subcategory":"Set Lunch","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-09 12:04:23","serial":"Staff-1465438933-14654450630082115","warehouse_id":"0","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-06-09 12:04:38', NULL, ''),
(20, 'admin', '{"sale":{"id":"36","txn_no":"100022","table_no":"TEST","user_id":"10011","username":"Staff","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-06-09 14:41:35","payment_status":"Paid","cost":null,"subtotal":"28.00","amount":"28.00","amount_cash":"28.00","amount_cc":null,"amount_tendered":"28.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1465438933","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"77","date":"2016-06-09 14:41:14","ss_terminal":null,"ss_code":null,"sale_id":"36","si_item_id":null,"item_id":"40","item_sku":"40","item_name":"Banana","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1465438933","ordered_by":"Staff","ordered_time":"2016-06-09 14:41:14","serial":"Staff-1465438933-14654544738882628","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"78","date":"2016-06-09 14:41:27","ss_terminal":null,"ss_code":null,"sale_id":"36","si_item_id":null,"item_id":"39","item_sku":"39","item_name":"Mango","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1465438933","ordered_by":"Staff","ordered_time":"2016-06-09 14:41:27","serial":"Staff-1465438933-14654544869866479","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-06-09 14:42:23', 1, ''),
(21, 'lois', '{"sale":{"id":"36","txn_no":"100022","table_no":"TEST","user_id":"10011","username":"Staff","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-09 14:41:35","payment_status":"Unpaid","cost":null,"subtotal":"28.00","amount":"28.00","amount_cash":"28.00","amount_cc":null,"amount_tendered":"28.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1465438933","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"77","date":"2016-06-09 14:41:14","ss_terminal":null,"ss_code":null,"sale_id":"36","si_item_id":null,"item_id":"40","item_sku":"40","item_name":"Banana","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1465438933","ordered_by":"Staff","ordered_time":"2016-06-09 14:41:14","serial":"Staff-1465438933-14654544738882628","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"78","date":"2016-06-09 14:41:27","ss_terminal":null,"ss_code":null,"sale_id":"36","si_item_id":null,"item_id":"39","item_sku":"39","item_name":"Mango","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1465438933","ordered_by":"Staff","ordered_time":"2016-06-09 14:41:27","serial":"Staff-1465438933-14654544869866479","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-06-09 15:04:11', NULL, ''),
(22, 'lois', '{"sale":{"id":"37","txn_no":"100023","table_no":"T1","user_id":"10011","username":"Staff","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-06-09 15:10:46","payment_status":"Paid","cost":null,"subtotal":"24.00","amount":"24.00","amount_cash":"24.00","amount_cc":null,"amount_tendered":"24.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1465455232","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"80","date":"2016-06-09 15:10:33","ss_terminal":null,"ss_code":null,"sale_id":"37","si_item_id":null,"item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Special House Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1465455232","ordered_by":"Staff","ordered_time":"2016-06-09 15:10:33","serial":"Staff-1465455232-14654562338598555","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"79","date":"2016-06-09 15:10:24","ss_terminal":null,"ss_code":null,"sale_id":"37","si_item_id":null,"item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Special House Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1465455232","ordered_by":"Staff","ordered_time":"2016-06-09 15:10:24","serial":"Staff-1465455232-14654562241182445","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-06-09 15:18:59', 1, ''),
(23, 'lois', '{"void_item":{"id":"79","date":"2016-06-09 15:10:24","ss_terminal":null,"ss_code":null,"sale_id":"37","si_item_id":null,"item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Special House Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1465455232","ordered_by":"Staff","ordered_time":"2016-06-09 15:10:24","serial":"Staff-1465455232-14654562241182445","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-09 15:19:14', NULL, ''),
(24, 'admin', '{"sale":{"id":"38","txn_no":null,"table_no":"T4","user_id":"10011","username":"Staff","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-09 15:21:57","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1465455232","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-06-09 15:23:03', NULL, ''),
(25, 'admin', '{"sale":{"id":"39","txn_no":null,"table_no":"test","user_id":"10011","username":"Staff","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-09 15:23:43","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1465455232","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-06-09 15:24:05', NULL, ''),
(26, 'admin', '{"sale":{"id":"42","txn_no":null,"table_no":"TEST","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-10 12:42:40","payment_status":"Unpaid","cost":null,"subtotal":"18.00","amount":"18.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1465533868","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"86","date":"2016-06-10 12:42:44","ss_terminal":null,"ss_code":null,"sale_id":"42","si_item_id":"0","item_id":"75","item_sku":"75","item_name":"Aglio Olio ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-10 12:42:44","serial":"admin-1465533868-14655337646576565","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-06-10 12:43:59', NULL, ''),
(27, 'lois', '{"void_item":{"id":"290","date":"2016-06-11 14:31:58","ss_terminal":null,"ss_code":null,"sale_id":"111","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-11 14:31:58","serial":"Staff-1465612935-14656267180701424","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-11 15:41:34', NULL, ''),
(28, 'lois', '{"void_item":{"id":"315","date":"2016-06-12 09:10:23","ss_terminal":null,"ss_code":null,"sale_id":"120","si_item_id":"0","item_id":"75","item_sku":"75","item_name":"Aglio Olio ","item_option":"Chicken","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"22.00","margin":"22.0000","cost":"0.0000","amount":"22.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-12 09:10:23","serial":"Staff-1465693602-14656938231493618","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-12 09:11:13', NULL, ''),
(29, 'lois', '{"void_item":{"id":"314","date":"2016-06-12 09:09:23","ss_terminal":null,"ss_code":null,"sale_id":"120","si_item_id":null,"item_id":"21","item_sku":"21","item_name":"Chocolate ","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-12 09:09:23","serial":"Staff-1465693602-14656937631578394","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-12 09:11:38', NULL, ''),
(30, 'lois', '{"sale":{"id":"120","txn_no":null,"table_no":"T0","user_id":"10011","username":"Staff","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-12 09:07:35","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1465693602","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-06-12 09:12:02', NULL, ''),
(31, 'lois', '{"void_item":{"id":"335","date":"2016-06-12 10:26:23","ss_terminal":null,"ss_code":null,"sale_id":"127","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-12 10:26:23","serial":"Staff-1465695063-14656983833923995","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-12 10:26:44', NULL, ''),
(32, 'staff', '{"void_item":{"id":"362","date":"2016-06-12 12:18:01","ss_terminal":null,"ss_code":null,"sale_id":"138","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-12 12:18:01","serial":"Staff-1465698413-1465705081329833","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-12 13:49:24', NULL, ''),
(33, 'staff', '{"void_item":{"id":"390","date":"2016-06-12 13:49:11","ss_terminal":null,"ss_code":null,"sale_id":"138","si_item_id":"0","item_id":"74","item_sku":"74","item_name":"Sunrice","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-12 13:49:11","serial":"Staff-1465705436-14657105508099256","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-12 13:50:38', NULL, ''),
(34, 'staff', '{"void_item":{"id":"391","date":"2016-06-12 13:49:11","ss_terminal":null,"ss_code":null,"sale_id":"138","si_item_id":"0","item_id":"74","item_sku":"74","item_name":"Sunrice","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-12 13:49:11","serial":"Staff-1465705436-14657105508099256","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-12 13:50:55', NULL, ''),
(35, 'lois', '{"sale":{"id":"160","txn_no":null,"table_no":"T7","user_id":"10011","username":"Staff","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-12 18:40:42","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1465705436","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-06-12 18:40:58', NULL, ''),
(36, 'lois', '{"sale":{"id":"164","txn_no":null,"table_no":"4","user_id":"10011","username":"Staff","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-13 09:02:32","payment_status":"Unpaid","cost":null,"subtotal":"13.00","amount":"13.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1465777486","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"430","date":"2016-06-13 09:05:31","ss_terminal":null,"ss_code":null,"sale_id":"164","si_item_id":"0","item_id":"30","item_sku":"30","item_name":"Iced Chai Latte","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-13 09:05:31","serial":"Staff-1465777486-14657799317507451","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-06-13 09:59:02', NULL, ''),
(37, 'lois', '{"void_item":{"id":"442","date":"2016-06-13 10:45:03","ss_terminal":null,"ss_code":null,"sale_id":"168","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-13 10:45:03","serial":"Staff-1465777486-14657859036531311","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-13 10:45:36', NULL, ''),
(38, 'lois', '{"sale":{"id":"174","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-13 12:45:04","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1465790063","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-06-13 12:45:21', NULL, ''),
(39, 'lois', '{"void_item":{"id":"516","date":"2016-06-14 10:43:02","ss_terminal":null,"ss_code":null,"sale_id":"199","si_item_id":null,"item_id":"21","item_sku":"21","item_name":"Chocolate ","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"lois","ordered_time":"2016-06-14 10:43:02","serial":"lois-1465865812-14658721827737136","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-14 10:53:02', NULL, ''),
(40, 'lois', '{"void_item":{"id":"560","date":"2016-06-16 11:59:31","ss_terminal":null,"ss_code":null,"sale_id":"219","si_item_id":"0","item_id":"70","item_sku":"70","item_name":"Pepper Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-16 11:59:31","serial":"Staff-1466038211-14660495713096781","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-16 12:36:14', NULL, ''),
(41, 'lois', '{"void_item":{"id":"561","date":"2016-06-16 11:59:31","ss_terminal":null,"ss_code":null,"sale_id":"219","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-16 11:59:31","serial":"Staff-1466038211-14660495713096781","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-16 12:37:27', NULL, ''),
(42, 'lois', '{"void_item":{"id":"582","date":"2016-06-16 14:55:48","ss_terminal":null,"ss_code":null,"sale_id":"225","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"lois","ordered_time":"2016-06-16 14:55:48","serial":"lois-1466051819-14660601487419356","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-16 16:34:06', NULL, ''),
(43, 'lois', '{"void_item":{"id":"581","date":"2016-06-16 14:55:48","ss_terminal":null,"ss_code":null,"sale_id":"225","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"lois","ordered_time":"2016-06-16 14:55:48","serial":"lois-1466051819-14660601487419356","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-16 16:34:19', NULL, ''),
(44, 'lois', '{"sale":{"id":"225","txn_no":null,"table_no":"T6","user_id":"10008","username":"lois","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-16 14:55:36","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1466051819","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-06-16 16:34:31', NULL, ''),
(45, 'lois', '{"void_item":{"id":"646","date":"2016-06-17 16:59:19","ss_terminal":null,"ss_code":null,"sale_id":"247","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-17 16:59:19","serial":"Staff-1466149363-14661539593093422","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-17 17:10:46', NULL, 'Reason 1'),
(46, 'staff', '{"void_item":{"id":"688","date":"2016-06-18 09:09:29","ss_terminal":null,"ss_code":null,"sale_id":"259","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"French Toast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-18 09:09:29","serial":"admin-1466211596-1466212168927138","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-18 09:33:08', NULL, ''),
(47, 'staff', '{"void_item":{"id":"749","date":"2016-06-18 11:42:20","ss_terminal":null,"ss_code":null,"sale_id":"279","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-18 11:42:20","serial":"admin-1466218339-14662213403594491","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-18 11:44:56', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(48, 'staff', '{"void_item":{"id":"760","date":"2016-06-18 11:56:10","ss_terminal":null,"ss_code":null,"sale_id":"281","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-18 11:56:10","serial":"admin-1466218339-14662221704926698","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-18 11:57:23', NULL, ''),
(49, 'staff', '{"void_item":{"id":"753","date":"2016-06-18 11:44:47","ss_terminal":null,"ss_code":null,"sale_id":"279","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-18 11:44:47","serial":"admin-1466218339-14662214877803679","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-18 11:59:15', NULL, ''),
(50, 'staff', '{"void_item":{"id":"802","date":"2016-06-18 16:15:23","ss_terminal":null,"ss_code":null,"sale_id":"297","si_item_id":"0","item_id":"158","item_sku":"92","item_name":"Nutella Toast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-18 16:15:23","serial":"Staff-1466235501-14662377237848172","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-18 16:22:37', NULL, ''),
(51, 'lois', '{"sale":{"id":"329","txn_no":null,"table_no":"T11","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-19 13:57:05","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1466314204","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-06-19 13:57:18', NULL, ''),
(52, 'lois', '{"sale":{"id":"335","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-19 14:20:46","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1466314204","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-06-19 14:21:19', NULL, ''),
(53, 'sanni', '{"void_item":{"id":"1050","date":"2016-06-21 13:17:00","ss_terminal":null,"ss_code":null,"sale_id":"392","si_item_id":"0","item_id":"179","item_sku":"114","item_name":"Creme Brulee ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-21 13:17:00","serial":"admin-1466470807-14664862203037876","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-21 14:30:49', NULL, 'Reason 1'),
(54, 'lois', '{"sale":{"id":"385","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-21 11:15:24","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1466470807","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-06-21 15:00:42', NULL, 'Reason 1'),
(55, 'lois', '{"void_item":{"id":"1093","date":"2016-06-21 19:47:24","ss_terminal":null,"ss_code":null,"sale_id":"416","si_item_id":null,"item_id":"7","item_sku":"7","item_name":"Mocha ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-21 19:47:24","serial":"admin-1466487575-14665096445928351","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-21 22:39:54', NULL, ''),
(56, 'lois', '{"void_item":{"id":"1092","date":"2016-06-21 19:47:24","ss_terminal":null,"ss_code":null,"sale_id":"416","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-21 19:47:24","serial":"admin-1466487575-14665096445928351","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-21 22:40:03', NULL, ''),
(57, 'lois', '{"sale":{"id":"416","txn_no":null,"table_no":"B2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-21 19:47:02","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1466487575","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-06-21 22:40:11', NULL, ''),
(58, 'lois', '{"void_item":{"id":"1151","date":"2016-06-23 14:26:34","ss_terminal":null,"ss_code":null,"sale_id":"440","si_item_id":"0","item_id":"174","item_sku":"109","item_name":"Strawberry Dose ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-23 14:26:34","serial":"Staff-1466643574-14666631941631580","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-23 19:30:41', NULL, ''),
(59, 'lois', '{"void_item":{"id":"1150","date":"2016-06-23 14:26:34","ss_terminal":null,"ss_code":null,"sale_id":"440","si_item_id":"0","item_id":"43","item_sku":"43","item_name":"Strawberry Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-23 14:26:34","serial":"Staff-1466643574-14666631941631580","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-23 19:30:55', NULL, ''),
(60, 'lois', '{"sale":{"id":"440","txn_no":null,"table_no":"T5","user_id":"10011","username":"Staff","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-23 14:26:21","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1466643574","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-06-23 19:31:11', NULL, ''),
(61, 'lois', '{"void_item":{"id":"1181","date":"2016-06-23 19:49:32","ss_terminal":null,"ss_code":null,"sale_id":"446","si_item_id":"0","item_id":"172","item_sku":"106","item_name":"Daily Berries ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-23 19:49:32","serial":"Staff-1466682532-14666825725993473","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-23 19:49:41', NULL, ''),
(62, 'lois', '{"void_item":{"id":"1175","date":"2016-06-23 19:48:39","ss_terminal":null,"ss_code":null,"sale_id":"446","si_item_id":"0","item_id":"189","item_sku":"124","item_name":"Stuffed Bitter Gourd","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-23 19:48:39","serial":"admin-1466681416-14666825192391752","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-23 20:44:47', NULL, ''),
(63, 'lois', '{"void_item":{"id":"1187","date":"2016-06-23 20:34:27","ss_terminal":null,"ss_code":null,"sale_id":"447","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"BitterG","category":"Open","subcategory":"Food","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-23 20:34:27","serial":"Staff-1466682532-14666852672291276","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-23 21:35:51', NULL, ''),
(64, 'sanni', '{"void_item":{"id":"1211","date":"2016-06-24 11:55:45","ss_terminal":null,"ss_code":null,"sale_id":"452","si_item_id":"0","item_id":"80","item_sku":"80","item_name":"Summer Salad With Chicken ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-24 11:55:45","serial":"admin-1466735869-14667405453881145","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-24 11:55:54', NULL, ''),
(65, 'sanni', '{"void_item":{"id":"1225","date":"2016-06-24 13:08:25","ss_terminal":null,"ss_code":null,"sale_id":"456","si_item_id":null,"item_id":"66","item_sku":"66","item_name":"Watermelon ","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-24 13:08:25","serial":"admin-1466744311-14667449053017748","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-24 13:11:31', NULL, ''),
(66, 'lois', '{"sale":{"id":"483","txn_no":"100452","table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-06-25 11:42:20","payment_status":"Paid","cost":null,"subtotal":"29.00","amount":"29.00","amount_cash":"29.00","amount_cc":null,"amount_tendered":"30.00","amount_change":"1.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1466820201","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"1314","date":"2016-06-25 11:42:10","ss_terminal":null,"ss_code":null,"sale_id":"483","si_item_id":"0","item_id":"72","item_sku":"72","item_name":"Mushroom Chicken","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":"1","terminal":"27","printed":"1","session":"1466820201","ordered_by":"admin","ordered_time":"2016-06-25 11:42:10","serial":"admin-1466820201-14668261298941884","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null},{"id":"1315","date":"2016-06-25 11:42:10","ss_terminal":null,"ss_code":null,"sale_id":"483","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1466820201","ordered_by":"admin","ordered_time":"2016-06-25 11:42:10","serial":"admin-1466820201-14668261298941884","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}]}', '2016-06-25 11:51:31', 1, ''),
(67, 'lois', '{"void_item":{"id":"1315","date":"2016-06-25 11:42:10","ss_terminal":null,"ss_code":null,"sale_id":"483","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1466820201","ordered_by":"admin","ordered_time":"2016-06-25 11:42:10","serial":"admin-1466820201-14668261298941884","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}}', '2016-06-25 11:51:43', NULL, ''),
(68, 'lois', '{"void_item":{"id":"1314","date":"2016-06-25 11:42:10","ss_terminal":null,"ss_code":null,"sale_id":"483","si_item_id":"0","item_id":"72","item_sku":"72","item_name":"Mushroom Chicken","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":"1","terminal":"27","printed":"1","session":"1466820201","ordered_by":"admin","ordered_time":"2016-06-25 11:42:10","serial":"admin-1466820201-14668261298941884","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}}', '2016-06-25 11:51:51', NULL, ''),
(69, 'lois', '{"sale":{"id":"483","txn_no":"100452","table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-25 11:42:20","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":"29.00","amount_cc":null,"amount_tendered":"30.00","amount_change":"1.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1466820201","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-06-25 11:51:59', NULL, ''),
(70, 'lois', '{"sale":{"id":"494","txn_no":null,"table_no":"T5","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-25 12:53:58","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1466827306","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-06-25 13:27:37', NULL, ''),
(71, 'sanni', '{"void_item":{"id":"1364","date":"2016-06-25 14:59:54","ss_terminal":null,"ss_code":null,"sale_id":"501","si_item_id":"0","item_id":"38","item_sku":"38","item_name":"Kiwi Smoothie","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-25 14:59:54","serial":"admin-1466827306-14668379947831338","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-25 15:15:10', NULL, ''),
(72, 'lois', '{"void_item":{"id":"1412","date":"2016-06-26 09:35:14","ss_terminal":null,"ss_code":null,"sale_id":"513","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-26 09:35:14","serial":"admin-1466903924-14669049146417511","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-26 09:35:36', NULL, ''),
(73, 'lois', '{"void_item":{"id":"1411","date":"2016-06-26 09:35:14","ss_terminal":null,"ss_code":null,"sale_id":"513","si_item_id":"0","item_id":"61","item_sku":"61","item_name":"Slim Fit","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-26 09:35:14","serial":"admin-1466903924-14669049146417511","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-26 09:35:46', NULL, ''),
(74, 'lois', '{"sale":{"id":"512","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-26 09:31:53","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1466903924","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-06-26 09:58:12', NULL, ''),
(75, 'lois', '{"sale":{"id":"519","txn_no":"100485","table_no":"T12","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-06-26 10:29:05","payment_status":"Paid","cost":null,"subtotal":"87.00","amount":"87.00","amount_cash":"87.00","amount_cc":null,"amount_tendered":"100.00","amount_change":"13.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1466908083","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"1435","date":"2016-06-26 10:27:45","ss_terminal":null,"ss_code":null,"sale_id":"519","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"House BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1466908083","ordered_by":"admin","ordered_time":"2016-06-26 10:27:45","serial":"admin-1466903924-14669080652565426","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"1436","date":"2016-06-26 10:27:45","ss_terminal":null,"ss_code":null,"sale_id":"519","si_item_id":null,"item_id":"24","item_sku":"24","item_name":"Chai Latte","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1466908083","ordered_by":"admin","ordered_time":"2016-06-26 10:27:45","serial":"admin-1466903924-14669080652565426","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"1440","date":"2016-06-26 10:28:48","ss_terminal":null,"ss_code":null,"sale_id":"519","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1466908083","ordered_by":"admin","ordered_time":"2016-06-26 10:28:48","serial":"admin-1466908083-14669081278854787","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"1437","date":"2016-06-26 10:27:45","ss_terminal":null,"ss_code":null,"sale_id":"519","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"House BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1466908083","ordered_by":"admin","ordered_time":"2016-06-26 10:27:45","serial":"admin-1466903924-14669080652565426","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"1439","date":"2016-06-26 10:28:48","ss_terminal":null,"ss_code":null,"sale_id":"519","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1466908083","ordered_by":"admin","ordered_time":"2016-06-26 10:28:48","serial":"admin-1466908083-14669081278854787","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"1438","date":"2016-06-26 10:27:45","ss_terminal":null,"ss_code":null,"sale_id":"519","si_item_id":"0","item_id":"176","item_sku":"111","item_name":"Scones ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":"1","terminal":"27","printed":"1","session":"1466908083","ordered_by":"admin","ordered_time":"2016-06-26 10:27:45","serial":"admin-1466903924-14669080652565426","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"1434","date":"2016-06-26 10:27:45","ss_terminal":null,"ss_code":null,"sale_id":"519","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"House BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1466908083","ordered_by":"admin","ordered_time":"2016-06-26 10:27:45","serial":"admin-1466903924-14669080652565426","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-06-26 10:38:15', 1, ''),
(76, 'lois', '{"void_item":{"id":"1440","date":"2016-06-26 10:28:48","ss_terminal":null,"ss_code":null,"sale_id":"519","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1466908083","ordered_by":"admin","ordered_time":"2016-06-26 10:28:48","serial":"admin-1466908083-14669081278854787","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-26 10:38:27', NULL, ''),
(77, 'sanni', '{"void_item":{"id":"1474","date":"2016-06-26 12:41:30","ss_terminal":null,"ss_code":null,"sale_id":"529","si_item_id":null,"item_id":"84","item_sku":"84","item_name":"Marmite Chicken","item_option":"","category":"Meals","subcategory":"Set Lunch","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-26 12:41:30","serial":"admin-1466908083-14669160902405499","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-26 12:43:35', NULL, ''),
(78, 'sanni', '{"void_item":{"id":"1489","date":"2016-06-26 12:59:08","ss_terminal":null,"ss_code":null,"sale_id":"531","si_item_id":null,"item_id":"84","item_sku":"84","item_name":"Marmite Chicken","item_option":"","category":"Meals","subcategory":"Set Lunch","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-26 12:59:08","serial":"admin-1466916185-14669171481597213","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-26 13:00:40', NULL, ''),
(79, 'sanni', '{"void_item":{"id":"1518","date":"2016-06-26 15:31:33","ss_terminal":null,"ss_code":null,"sale_id":"538","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"","category":"Open","subcategory":"Food","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-26 15:31:33","serial":"admin-1466925591-14669262937168447","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-26 15:31:58', NULL, ''),
(80, 'sanni', '{"void_item":{"id":"1599","date":"2016-06-27 12:42:06","ss_terminal":null,"ss_code":null,"sale_id":"562","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-27 12:42:06","serial":"admin-1467000232-14670025265198875","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-27 13:15:49', NULL, ''),
(81, 'sanni', '{"void_item":{"id":"1625","date":"2016-06-27 16:10:09","ss_terminal":null,"ss_code":null,"sale_id":"575","si_item_id":"0","item_id":"78","item_sku":"78","item_name":"Baked Mashed Potato","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-06-27 16:10:09","serial":"admin-1467003573-14670150097355690","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-27 16:11:57', NULL, 'Reason 1'),
(82, 'lois', '{"void_item":{"id":"1647","date":"2016-06-28 10:38:03","ss_terminal":null,"ss_code":null,"sale_id":"583","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-06-28 10:38:03","serial":"Staff-1467075958-14670814833726438","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-06-28 10:44:22', NULL, ''),
(83, 'lois', '{"sale":{"id":"616","txn_no":null,"table_no":"T6","user_id":"10011","username":"Staff","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-30 16:00:31","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1467250387","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-06-30 16:01:10', NULL, ''),
(84, 'lois', '{"sale":{"id":"622","txn_no":null,"table_no":"t6","user_id":"10011","username":"Staff","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-06-30 17:47:52","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1467250387","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-06-30 17:54:55', NULL, ''),
(85, 'lois', '{"sale":{"id":"654","txn_no":null,"table_no":"T12","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-07-01 17:30:46","payment_status":"Unpaid","cost":null,"subtotal":"13.00","amount":"13.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1467348189","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"1830","date":"2016-07-01 17:30:54","ss_terminal":null,"ss_code":null,"sale_id":"654","si_item_id":"0","item_id":"32","item_sku":"32","item_name":"Tea By Pot ","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-01 17:30:54","serial":"admin-1467348189-14673654539572271","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-07-01 18:05:11', NULL, ''),
(86, 'sanni', '{"void_item":{"id":"1876","date":"2016-07-02 11:28:54","ss_terminal":null,"ss_code":null,"sale_id":"666","si_item_id":null,"item_id":"9","item_sku":"9","item_name":"Affogato","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-07-02 11:28:54","serial":"Staff-1467422461-1467430134088319","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-02 11:29:03', NULL, ''),
(87, 'lois', '{"sale":{"id":"673","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-07-02 12:12:51","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1467431407","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-07-02 12:13:38', NULL, ''),
(88, 'lois', '{"void_item":{"id":"1898","date":"2016-07-02 13:56:09","ss_terminal":null,"ss_code":null,"sale_id":"676","si_item_id":null,"item_id":"44","item_sku":"44","item_name":"Tiger ","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-02 13:56:09","serial":"admin-1467431407-1467438969510155","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-02 13:58:34', NULL, ''),
(89, 'sanni', '{"void_item":{"id":"2039","date":"2016-07-03 13:39:09","ss_terminal":null,"ss_code":null,"sale_id":"716","si_item_id":"0","item_id":"189","item_sku":"124","item_name":"Stuffed Bitter Gourd","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-03 13:39:09","serial":"admin-1467523870-1467524349674672","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-03 13:42:42', NULL, ''),
(90, 'staff', '{"void_item":{"id":"2055","date":"2016-07-03 13:52:50","ss_terminal":null,"ss_code":null,"sale_id":"708","si_item_id":"0","item_id":"162","item_sku":"96","item_name":"Chicken Bite ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-03 13:52:50","serial":"admin-1467524695-14675251705747515","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-03 13:54:49', NULL, ''),
(91, 'staff', '{"void_item":{"id":"2054","date":"2016-07-03 13:52:50","ss_terminal":null,"ss_code":null,"sale_id":"708","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-03 13:52:50","serial":"admin-1467524695-14675251705747515","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-03 13:55:00', NULL, ''),
(92, 'staff', '{"void_item":{"id":"2023","date":"2016-07-03 13:05:33","ss_terminal":null,"ss_code":null,"sale_id":"713","si_item_id":null,"item_id":"64","item_sku":"64","item_name":"Green Apple","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-03 13:05:33","serial":"admin-1467522176-14675223336183016","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-03 14:07:57', NULL, ''),
(93, 'sanni', '{"void_item":{"id":"2165","date":"2016-07-05 14:06:19","ss_terminal":null,"ss_code":null,"sale_id":"757","si_item_id":"0","item_id":"78","item_sku":"78","item_name":"Baked Mashed Potato","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-05 14:06:19","serial":"admin-1467695051-14676987797321427","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-05 14:09:45', NULL, ''),
(94, 'lois', '{"void_item":{"id":"2207","date":"2016-07-06 11:21:23","ss_terminal":null,"ss_code":null,"sale_id":"773","si_item_id":"0","item_id":"53","item_sku":"53","item_name":"Matcha Frappe","item_option":"","category":"Cold Drinks","subcategory":"Frappe","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-06 11:21:23","serial":"admin-1467764339-14677752829096549","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-06 11:21:58', NULL, ''),
(95, 'lois', '{"sale":{"id":"774","txn_no":null,"table_no":"T5","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-07-06 11:24:20","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1467764339","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-07-06 11:30:32', NULL, ''),
(96, 'staff', '{"void_item":{"id":"2216","date":"2016-07-06 12:19:04","ss_terminal":null,"ss_code":null,"sale_id":"776","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-06 12:19:04","serial":"admin-1467764339-14677787443479043","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-06 12:23:10', NULL, ''),
(97, 'lois', '{"void_item":{"id":"2241","date":"2016-07-06 13:06:50","ss_terminal":null,"ss_code":null,"sale_id":"777","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-06 13:06:50","serial":"admin-1467764339-14677816105242673","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-06 13:30:51', NULL, ''),
(98, 'lois', '{"void_item":{"id":"2318","date":"2016-07-06 19:53:03","ss_terminal":null,"ss_code":null,"sale_id":"806","si_item_id":"0","item_id":"72","item_sku":"72","item_name":"Mushroom Chicken","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-07-06 19:53:03","serial":"Staff-1467789963-14678059831974940","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-06 20:34:25', NULL, ''),
(99, 'lois', '{"void_item":{"id":"2317","date":"2016-07-06 19:53:03","ss_terminal":null,"ss_code":null,"sale_id":"806","si_item_id":"0","item_id":"70","item_sku":"70","item_name":"Pepper Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-07-06 19:53:03","serial":"Staff-1467789963-14678059831974940","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-06 20:35:17', NULL, ''),
(100, 'lois', '{"void_item":{"id":"2343","date":"2016-07-06 20:37:13","ss_terminal":null,"ss_code":null,"sale_id":"806","si_item_id":"0","item_id":"196","item_sku":"131","item_name":"Dinner - Pepper Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-06 20:37:13","serial":"admin-1467807304-1467808633147518","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-06 20:37:23', NULL, ''),
(101, 'staff', '{"void_item":{"id":"2352","date":"2016-07-07 09:55:53","ss_terminal":null,"ss_code":null,"sale_id":"810","si_item_id":null,"item_id":"22","item_sku":"22","item_name":"Honey Milk","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-07 09:55:53","serial":"admin-1467852793-14678565528637150","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-07 09:56:55', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(102, 'lois', '{"sale":{"id":"810","txn_no":"100769","table_no":"T15","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-07-07 09:57:12","payment_status":"Paid","cost":null,"subtotal":"135.00","amount":"135.00","amount_cash":"135.00","amount_cc":null,"amount_tendered":"135.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1467852793","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"2349","date":"2016-07-07 09:55:53","ss_terminal":null,"ss_code":null,"sale_id":"810","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"3","price_per_unit":"20.00","margin":"60.0000","cost":"0.0000","amount":"60.00","sold":"1","terminal":"27","printed":"1","session":"1467852793","ordered_by":"admin","ordered_time":"2016-07-07 09:55:53","serial":"admin-1467852793-14678565528637150","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"2350","date":"2016-07-07 09:55:53","ss_terminal":null,"ss_code":null,"sale_id":"810","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"House BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1467852793","ordered_by":"admin","ordered_time":"2016-07-07 09:55:53","serial":"admin-1467852793-14678565528637150","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"2351","date":"2016-07-07 09:55:53","ss_terminal":null,"ss_code":null,"sale_id":"810","si_item_id":"0","item_id":"156","item_sku":"90","item_name":"Cheese Omelet","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1467852793","ordered_by":"admin","ordered_time":"2016-07-07 09:55:53","serial":"admin-1467852793-14678565528637150","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"2356","date":"2016-07-07 09:57:05","ss_terminal":null,"ss_code":null,"sale_id":"810","si_item_id":"0","item_id":"28","item_sku":"28","item_name":"Iced Honey Milk","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1467852793","ordered_by":"admin","ordered_time":"2016-07-07 09:57:05","serial":"admin-1467852793-1467856625079303","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"2353","date":"2016-07-07 09:56:17","ss_terminal":null,"ss_code":null,"sale_id":"810","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1467852793","ordered_by":"admin","ordered_time":"2016-07-07 09:56:17","serial":"admin-1467852793-14678565771493728","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"2354","date":"2016-07-07 09:56:17","ss_terminal":null,"ss_code":null,"sale_id":"810","si_item_id":null,"item_id":"8","item_sku":"8","item_name":"Caramel Macchiato ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1467852793","ordered_by":"admin","ordered_time":"2016-07-07 09:56:17","serial":"admin-1467852793-14678565771493728","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"2355","date":"2016-07-07 09:56:48","ss_terminal":null,"ss_code":null,"sale_id":"810","si_item_id":"0","item_id":"16","item_sku":"16","item_name":"Iced Mocha ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1467852793","ordered_by":"admin","ordered_time":"2016-07-07 09:56:48","serial":"admin-1467852793-14678566082465518","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-07-07 10:07:26', 1, ''),
(103, 'lois', '{"void_item":{"id":"2354","date":"2016-07-07 09:56:17","ss_terminal":null,"ss_code":null,"sale_id":"810","si_item_id":null,"item_id":"8","item_sku":"8","item_name":"Caramel Macchiato ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1467852793","ordered_by":"admin","ordered_time":"2016-07-07 09:56:17","serial":"admin-1467852793-14678565771493728","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-07 10:07:38', NULL, ''),
(104, 'STAFF', '{"void_item":{"id":"2412","date":"2016-07-07 12:22:34","ss_terminal":null,"ss_code":null,"sale_id":"818","si_item_id":null,"item_id":"8","item_sku":"8","item_name":"Caramel Macchiato ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-07-07 12:22:34","serial":"Staff-1467862578-14678653547266493","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-07 12:35:32', NULL, ''),
(105, 'STAFF', '{"void_item":{"id":"2411","date":"2016-07-07 12:22:34","ss_terminal":null,"ss_code":null,"sale_id":"818","si_item_id":null,"item_id":"8","item_sku":"8","item_name":"Caramel Macchiato ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-07-07 12:22:34","serial":"Staff-1467862578-14678653547266493","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-07 12:35:42', NULL, ''),
(106, 'lois', '{"void_item":{"id":"2444","date":"2016-07-07 13:36:35","ss_terminal":null,"ss_code":null,"sale_id":"834","si_item_id":"0","item_id":"195","item_sku":"130","item_name":"Cucumber Lime Soda BOFO","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-07 13:36:35","serial":"admin-1467865379-14678697953828924","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-07 13:36:45', NULL, ''),
(107, 'lois', '{"void_item":{"id":"2452","date":"2016-07-07 13:52:34","ss_terminal":null,"ss_code":null,"sale_id":"829","si_item_id":"0","item_id":"43","item_sku":"43","item_name":"Strawberry Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-07 13:52:34","serial":"admin-1467865379-14678707542132151","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-07 13:57:30', NULL, ''),
(108, 'lois', '{"void_item":{"id":"2451","date":"2016-07-07 13:52:34","ss_terminal":null,"ss_code":null,"sale_id":"829","si_item_id":"0","item_id":"40","item_sku":"40","item_name":"Banana Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-07 13:52:34","serial":"admin-1467865379-14678707542132151","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-07 13:57:38', NULL, ''),
(109, 'sanni', '{"sale":{"id":"856","txn_no":"100813","table_no":"T8","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-07-07 20:17:32","payment_status":"Paid","cost":null,"subtotal":"89.00","amount":"89.00","amount_cash":"89.00","amount_cc":null,"amount_tendered":"89.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1467891774","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"2521","date":"2016-07-07 19:20:31","ss_terminal":null,"ss_code":null,"sale_id":"856","si_item_id":"0","item_id":"179","item_sku":"114","item_name":"Creme Brulee ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1467891774","ordered_by":"admin","ordered_time":"2016-07-07 19:20:31","serial":"admin-1467885914-14678904317649956","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"2522","date":"2016-07-07 19:20:31","ss_terminal":null,"ss_code":null,"sale_id":"856","si_item_id":"0","item_id":"176","item_sku":"111","item_name":"Scones ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":"1","terminal":"27","printed":"1","session":"1467891774","ordered_by":"admin","ordered_time":"2016-07-07 19:20:31","serial":"admin-1467885914-14678904317649956","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"2523","date":"2016-07-07 19:20:31","ss_terminal":null,"ss_code":null,"sale_id":"856","si_item_id":"0","item_id":"75","item_sku":"75","item_name":"Aglio Olio ","item_option":"Bacon","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"22.00","margin":"22.0000","cost":"0.0000","amount":"22.00","sold":"1","terminal":"27","printed":"1","session":"1467891774","ordered_by":"admin","ordered_time":"2016-07-07 19:20:31","serial":"admin-1467885914-14678904317649956","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"2524","date":"2016-07-07 19:20:31","ss_terminal":null,"ss_code":null,"sale_id":"856","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":"1","terminal":"27","printed":"1","session":"1467891774","ordered_by":"admin","ordered_time":"2016-07-07 19:20:31","serial":"admin-1467885914-14678904317649956","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"2525","date":"2016-07-07 19:20:31","ss_terminal":null,"ss_code":null,"sale_id":"856","si_item_id":"0","item_id":"200","item_sku":"135","item_name":"Dinner - Spicy Wings","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1467891774","ordered_by":"admin","ordered_time":"2016-07-07 19:20:31","serial":"admin-1467885914-14678904317649956","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"2526","date":"2016-07-07 19:20:31","ss_terminal":null,"ss_code":null,"sale_id":"856","si_item_id":"0","item_id":"183","item_sku":"118","item_name":"Plain Rice","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"2.00","margin":"2.0000","cost":"0.0000","amount":"2.00","sold":"1","terminal":"27","printed":"1","session":"1467891774","ordered_by":"admin","ordered_time":"2016-07-07 19:20:31","serial":"admin-1467885914-14678904317649956","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"2527","date":"2016-07-07 19:20:51","ss_terminal":null,"ss_code":null,"sale_id":"856","si_item_id":"0","item_id":"60","item_sku":"60","item_name":"The Hulk","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1467891774","ordered_by":"admin","ordered_time":"2016-07-07 19:20:51","serial":"admin-1467885914-14678904515642014","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"2528","date":"2016-07-07 19:20:51","ss_terminal":null,"ss_code":null,"sale_id":"856","si_item_id":"0","item_id":"20","item_sku":"20","item_name":"Iced DD Special","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1467891774","ordered_by":"admin","ordered_time":"2016-07-07 19:20:51","serial":"admin-1467885914-14678904515642014","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-07-07 20:18:24', 1, 'Reason 1'),
(110, 'sanni', '{"void_item":{"id":"2606","date":"2016-07-08 11:51:39","ss_terminal":null,"ss_code":null,"sale_id":"873","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-08 11:51:39","serial":"admin-1467945991-14679498995339021","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-08 12:05:43', NULL, ''),
(111, 'sanni', '{"void_item":{"id":"2704","date":"2016-07-09 16:24:52","ss_terminal":null,"ss_code":null,"sale_id":"909","si_item_id":null,"item_id":"9","item_sku":"9","item_name":"Affogato","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-09 16:24:52","serial":"admin-1468026127-14680526920083524","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-09 16:25:11', NULL, ''),
(112, 'sanni', '{"void_item":{"id":"2705","date":"2016-07-09 16:24:52","ss_terminal":null,"ss_code":null,"sale_id":"909","si_item_id":null,"item_id":"9","item_sku":"9","item_name":"Affogato","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-09 16:24:52","serial":"admin-1468026127-14680526920083524","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-09 16:25:19', NULL, ''),
(113, 'staff', '{"void_item":{"id":"2769","date":"2016-07-10 09:32:11","ss_terminal":null,"ss_code":null,"sale_id":"927","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-10 09:32:11","serial":"admin-1468110352-14681143315327884","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-10 09:36:13', NULL, ''),
(114, 'sanni', '{"void_item":{"id":"2826","date":"2016-07-10 13:00:30","ss_terminal":null,"ss_code":null,"sale_id":"946","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-10 13:00:30","serial":"admin-1468124266-14681268307206165","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-10 13:09:57', NULL, ''),
(115, 'lois', '{"sale":{"id":"946","txn_no":"100904","table_no":"T11","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-07-10 14:44:55","payment_status":"Paid","cost":null,"subtotal":"48.00","amount":"48.00","amount_cash":"48.00","amount_cc":null,"amount_tendered":"50.00","amount_change":"2.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1468124266","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"2827","date":"2016-07-10 13:10:02","ss_terminal":null,"ss_code":null,"sale_id":"946","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":"1","terminal":"27","printed":"1","session":"1468124266","ordered_by":"admin","ordered_time":"2016-07-10 13:10:02","serial":"admin-1468124266-14681274023287074","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"2823","date":"2016-07-10 13:00:30","ss_terminal":null,"ss_code":null,"sale_id":"946","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1468124266","ordered_by":"admin","ordered_time":"2016-07-10 13:00:30","serial":"admin-1468124266-14681268307206165","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"2824","date":"2016-07-10 13:00:30","ss_terminal":null,"ss_code":null,"sale_id":"946","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1468124266","ordered_by":"admin","ordered_time":"2016-07-10 13:00:30","serial":"admin-1468124266-14681268307206165","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"2825","date":"2016-07-10 13:00:30","ss_terminal":null,"ss_code":null,"sale_id":"946","si_item_id":"0","item_id":"76","item_sku":"76","item_name":"Pesto Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":"1","terminal":"27","printed":"1","session":"1468124266","ordered_by":"admin","ordered_time":"2016-07-10 13:00:30","serial":"admin-1468124266-14681268307206165","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-07-10 14:45:16', 1, ''),
(116, 'lois', '{"void_item":{"id":"2827","date":"2016-07-10 13:10:02","ss_terminal":null,"ss_code":null,"sale_id":"946","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":"1","terminal":"27","printed":"1","session":"1468124266","ordered_by":"admin","ordered_time":"2016-07-10 13:10:02","serial":"admin-1468124266-14681274023287074","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-10 14:45:36', NULL, ''),
(117, 'lois', '{"sale":{"id":"969","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-07-10 19:03:46","payment_status":"Unpaid","cost":null,"subtotal":"14.00","amount":"14.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1468135169","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"2892","date":"2016-07-10 19:04:08","ss_terminal":null,"ss_code":null,"sale_id":"969","si_item_id":"0","item_id":"52","item_sku":"52","item_name":"Pure Vanilla Frappe","item_option":"","category":"Cold Drinks","subcategory":"Frappe","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-10 19:04:08","serial":"admin-1468135169-14681486480229563","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}]}', '2016-07-10 19:04:22', NULL, ''),
(118, 'lois', '{"void_item":{"id":"2916","date":"2016-07-11 12:20:58","ss_terminal":null,"ss_code":null,"sale_id":"979","si_item_id":"0","item_id":"76","item_sku":"76","item_name":"Pesto Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-11 12:20:58","serial":"admin-1468198485-14682108585588737","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-11 12:48:33', NULL, ''),
(119, 'lois', '{"void_item":{"id":"2914","date":"2016-07-11 12:20:58","ss_terminal":null,"ss_code":null,"sale_id":"979","si_item_id":"0","item_id":"70","item_sku":"70","item_name":"Pepper Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-11 12:20:58","serial":"admin-1468198485-14682108585588737","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-11 12:48:43', NULL, ''),
(120, 'sanni', '{"void_item":{"id":"2956","date":"2016-07-11 19:40:12","ss_terminal":null,"ss_code":null,"sale_id":"992","si_item_id":"0","item_id":"71","item_sku":"71","item_name":"Rice Wine Ginger Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-11 19:40:12","serial":"admin-1468231244-14682372126066485","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-11 19:43:40', NULL, ''),
(121, 'sanni', '{"void_item":{"id":"2954","date":"2016-07-11 19:40:12","ss_terminal":null,"ss_code":null,"sale_id":"992","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-11 19:40:12","serial":"admin-1468231244-14682372126066485","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-11 19:44:05', NULL, ''),
(122, 'sanni', '{"void_item":{"id":"3131","date":"2016-07-15 13:42:01","ss_terminal":null,"ss_code":null,"sale_id":"1058","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-15 13:42:01","serial":"admin-1468558997-14685613215687736","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-15 15:12:05', NULL, ''),
(123, 'sanni', '{"void_item":{"id":"3132","date":"2016-07-15 13:42:01","ss_terminal":null,"ss_code":null,"sale_id":"1058","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"plain rice","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"2.00","margin":"2.0000","cost":"0.0000","amount":"2.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-15 13:42:01","serial":"admin-1468558997-14685613215687736","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-15 15:12:13', NULL, ''),
(124, 'sanni', '{"sale":{"id":"1083","txn_no":"101036","table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-07-16 10:12:40","payment_status":"Paid","cost":null,"subtotal":"36.00","amount":"36.00","amount_cash":"36.00","amount_cc":null,"amount_tendered":"36.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1468628611","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"3191","date":"2016-07-16 10:12:35","ss_terminal":null,"ss_code":null,"sale_id":"1083","si_item_id":"0","item_id":"32","item_sku":"32","item_name":"Tea By Pot ","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1468628611","ordered_by":"admin","ordered_time":"2016-07-16 10:12:35","serial":"admin-1468628611-14686351550238937","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"3190","date":"2016-07-16 10:12:35","ss_terminal":null,"ss_code":null,"sale_id":"1083","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":"1","terminal":"27","printed":"1","session":"1468628611","ordered_by":"admin","ordered_time":"2016-07-16 10:12:35","serial":"admin-1468628611-14686351550238937","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"3189","date":"2016-07-16 10:12:35","ss_terminal":null,"ss_code":null,"sale_id":"1083","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"House BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1468628611","ordered_by":"admin","ordered_time":"2016-07-16 10:12:35","serial":"admin-1468628611-14686351550238937","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-07-16 10:13:11', 1, ''),
(125, 'sanni', '{"void_item":{"id":"3231","date":"2016-07-16 13:12:07","ss_terminal":null,"ss_code":null,"sale_id":"1101","si_item_id":"0","item_id":"82","item_sku":"82","item_name":"Rice Wine Ginger Pork","item_option":"","category":"Meals","subcategory":"Set Lunch","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-16 13:12:07","serial":"admin-1468639424-14686459274267658","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-16 13:13:32', NULL, ''),
(126, 'sanni', '{"void_item":{"id":"3230","date":"2016-07-16 13:12:07","ss_terminal":null,"ss_code":null,"sale_id":"1101","si_item_id":"0","item_id":"85","item_sku":"85","item_name":"Aglio Olio ","item_option":"","category":"Meals","subcategory":"Set Lunch","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-16 13:12:07","serial":"admin-1468639424-14686459274267658","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-16 13:14:03', NULL, ''),
(127, 'sanni', '{"sale":{"id":"1121","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-07-16 20:41:52","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1468639424","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-07-16 21:13:03', NULL, ''),
(128, 'staff', '{"void_item":{"id":"3325","date":"2016-07-17 11:30:05","ss_terminal":null,"ss_code":null,"sale_id":"1132","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-07-17 11:30:05","serial":"Staff-1468724310-14687262056468666","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-17 11:30:24', NULL, ''),
(129, 'sanni', '{"void_item":{"id":"3385","date":"2016-07-17 14:01:01","ss_terminal":null,"ss_code":null,"sale_id":"1153","si_item_id":"0","item_id":"76","item_sku":"76","item_name":"Pesto Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-17 14:01:01","serial":"admin-1468731161-14687352612511267","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-17 14:01:32', NULL, ''),
(130, 'staff', '{"void_item":{"id":"3395","date":"2016-07-17 14:49:25","ss_terminal":null,"ss_code":null,"sale_id":"1157","si_item_id":"0","item_id":"71","item_sku":"71","item_name":"Rice Wine Ginger Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-17 14:49:25","serial":"admin-1468735269-14687381648331377","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-17 15:51:18', NULL, ''),
(131, 'sanni', '{"void_item":{"id":"3482","date":"2016-07-17 20:31:30","ss_terminal":null,"ss_code":null,"sale_id":"1182","si_item_id":"0","item_id":"166","item_sku":"100","item_name":"Chocolate Dose ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-17 20:31:30","serial":"admin-1468743545-1468758690381169","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-17 21:00:11', NULL, ''),
(132, 'lois', '{"void_item":{"id":"3486","date":"2016-07-17 20:59:51","ss_terminal":null,"ss_code":null,"sale_id":"1181","si_item_id":"0","item_id":"194","item_sku":"129","item_name":"Chicken Wings","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-17 20:59:51","serial":"admin-1468743545-1468760391595186","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-17 21:07:50', NULL, ''),
(133, 'lois', '{"void_item":{"id":"3479","date":"2016-07-17 20:24:26","ss_terminal":null,"ss_code":null,"sale_id":"1181","si_item_id":"0","item_id":"80","item_sku":"80","item_name":"Summer Salad With Chicken ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-17 20:24:26","serial":"admin-1468743545-14687582666299789","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-17 21:08:51', NULL, ''),
(134, 'sanni', '{"void_item":{"id":"3498","date":"2016-07-18 09:15:46","ss_terminal":null,"ss_code":null,"sale_id":"1184","si_item_id":null,"item_id":"1","item_sku":"1","item_name":"Espresso","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-18 09:15:46","serial":"admin-1468804386-1468804546265441","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-18 09:15:54', NULL, ''),
(135, 'lois', '{"sale":{"id":"1185","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-07-18 09:45:57","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1468804386","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-07-18 09:53:46', NULL, ''),
(136, 'sanni', '{"void_item":{"id":"3564","date":"2016-07-18 19:38:13","ss_terminal":null,"ss_code":null,"sale_id":"1209","si_item_id":"0","item_id":"193","item_sku":"128","item_name":"Braised Pork with Potato","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-18 19:38:13","serial":"admin-1468840398-14688418928456360","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-18 19:38:46', NULL, ''),
(137, 'staff', '{"void_item":{"id":"3596","date":"2016-07-19 12:47:40","ss_terminal":null,"ss_code":null,"sale_id":"1221","si_item_id":"0","item_id":"193","item_sku":"128","item_name":"Braised Pork with Potato","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-07-19 12:47:40","serial":"Staff-1468889111-1468903660417716","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-19 12:49:33', NULL, ''),
(138, 'staff', '{"void_item":{"id":"3659","date":"2016-07-21 10:46:27","ss_terminal":null,"ss_code":null,"sale_id":"1243","si_item_id":"0","item_id":"159","item_sku":"93","item_name":"Granola ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-21 10:46:27","serial":"admin-1469061861-14690691870598746","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-21 10:47:03', NULL, ''),
(139, 'lois', '{"sale":{"id":"1272","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-07-22 13:06:52","payment_status":"Unpaid","cost":null,"subtotal":"11.00","amount":"11.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1469148115","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"3745","date":"2016-07-22 13:07:01","ss_terminal":null,"ss_code":null,"sale_id":"1272","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-22 13:07:01","serial":"admin-1469148115-14691640214016093","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-07-22 19:55:52', NULL, ''),
(140, 'lois', '{"void_item":{"id":"3775","date":"2016-07-22 20:12:41","ss_terminal":null,"ss_code":null,"sale_id":"1285","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-22 20:12:41","serial":"admin-1469148115-14691895609808726","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-22 20:13:03', NULL, ''),
(141, 'lois', '{"void_item":{"id":"3780","date":"2016-07-22 20:45:21","ss_terminal":null,"ss_code":null,"sale_id":"1286","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-22 20:45:21","serial":"admin-1469148115-14691915211258427","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-22 20:47:08', NULL, ''),
(142, 'sanni', '{"void_item":{"id":"3812","date":"2016-07-23 10:27:17","ss_terminal":null,"ss_code":null,"sale_id":"1292","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-23 10:27:17","serial":"admin-1469236076-14692408370634779","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-23 11:15:50', NULL, ''),
(143, 'sanni', '{"void_item":{"id":"3851","date":"2016-07-23 12:31:02","ss_terminal":null,"ss_code":null,"sale_id":"1307","si_item_id":"0","item_id":"176","item_sku":"111","item_name":"Scones ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-23 12:31:02","serial":"admin-1469248158-1469248262044338","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-23 12:36:00', NULL, ''),
(144, 'sanni', '{"void_item":{"id":"3864","date":"2016-07-23 13:39:02","ss_terminal":null,"ss_code":null,"sale_id":"1311","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-23 13:39:02","serial":"admin-1469248158-1469252341825512","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-23 13:40:12', NULL, ''),
(145, 'lois', '{"sale":{"id":"1332","txn_no":"101278","table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-07-24 10:13:44","payment_status":"Paid","cost":null,"subtotal":"58.00","amount":"58.00","amount_cash":"58.00","amount_cc":null,"amount_tendered":"58.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1469326411","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"3930","date":"2016-07-24 10:13:03","ss_terminal":null,"ss_code":null,"sale_id":"1332","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":"1","terminal":"27","printed":"1","session":"1469326411","ordered_by":"admin","ordered_time":"2016-07-24 10:13:03","serial":"admin-1469320347-14693263834689995","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"3931","date":"2016-07-24 10:13:03","ss_terminal":null,"ss_code":null,"sale_id":"1332","si_item_id":null,"item_id":"7","item_sku":"7","item_name":"Mocha ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1469326411","ordered_by":"admin","ordered_time":"2016-07-24 10:13:03","serial":"admin-1469320347-14693263834689995","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"3932","date":"2016-07-24 10:13:03","ss_terminal":null,"ss_code":null,"sale_id":"1332","si_item_id":"0","item_id":"32","item_sku":"32","item_name":"Tea By Pot ","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1469326411","ordered_by":"admin","ordered_time":"2016-07-24 10:13:03","serial":"admin-1469320347-14693263834689995","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"3929","date":"2016-07-24 10:13:03","ss_terminal":null,"ss_code":null,"sale_id":"1332","si_item_id":"0","item_id":"158","item_sku":"92","item_name":"Nutella Toast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1469326411","ordered_by":"admin","ordered_time":"2016-07-24 10:13:03","serial":"admin-1469320347-14693263834689995","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-07-24 10:21:09', 1, ''),
(146, 'lois', '{"void_item":{"id":"3929","date":"2016-07-24 10:13:03","ss_terminal":null,"ss_code":null,"sale_id":"1332","si_item_id":"0","item_id":"158","item_sku":"92","item_name":"Nutella Toast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1469326411","ordered_by":"admin","ordered_time":"2016-07-24 10:13:03","serial":"admin-1469320347-14693263834689995","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-24 10:21:18', NULL, ''),
(147, 'sanni', '{"void_item":{"id":"3962","date":"2016-07-24 11:41:49","ss_terminal":null,"ss_code":null,"sale_id":"1342","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-24 11:41:49","serial":"admin-1469329245-14693317093559794","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-24 11:41:59', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(148, 'sanni', '{"sale":{"id":"1361","txn_no":"101305","table_no":"T15","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-07-24 15:05:43","payment_status":"Paid","cost":null,"subtotal":"45.00","amount":"45.00","amount_cash":"45.00","amount_cc":null,"amount_tendered":"50.00","amount_change":"5.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1469342237","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"4025","date":"2016-07-24 15:05:34","ss_terminal":null,"ss_code":null,"sale_id":"1361","si_item_id":"0","item_id":"75","item_sku":"75","item_name":"Aglio Olio ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":"1","terminal":"27","printed":"1","session":"1469342237","ordered_by":"admin","ordered_time":"2016-07-24 15:05:34","serial":"admin-1469342237-14693439344966198","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"4026","date":"2016-07-24 15:05:34","ss_terminal":null,"ss_code":null,"sale_id":"1361","si_item_id":"0","item_id":"76","item_sku":"76","item_name":"Pesto Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":"1","terminal":"27","printed":"1","session":"1469342237","ordered_by":"admin","ordered_time":"2016-07-24 15:05:34","serial":"admin-1469342237-14693439344966198","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"4027","date":"2016-07-24 15:05:34","ss_terminal":null,"ss_code":null,"sale_id":"1361","si_item_id":null,"item_id":"64","item_sku":"64","item_name":"Green Apple","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1469342237","ordered_by":"admin","ordered_time":"2016-07-24 15:05:34","serial":"admin-1469342237-14693439344966198","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-07-24 15:14:38', 1, ''),
(149, 'sanni', '{"void_item":{"id":"4026","date":"2016-07-24 15:05:34","ss_terminal":null,"ss_code":null,"sale_id":"1361","si_item_id":"0","item_id":"76","item_sku":"76","item_name":"Pesto Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":"1","terminal":"27","printed":"1","session":"1469342237","ordered_by":"admin","ordered_time":"2016-07-24 15:05:34","serial":"admin-1469342237-14693439344966198","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-24 15:15:30', NULL, ''),
(150, 'sanni', '{"void_item":{"id":"4032","date":"2016-07-24 15:18:25","ss_terminal":null,"ss_code":null,"sale_id":"1359","si_item_id":"0","item_id":"162","item_sku":"96","item_name":"Chicken Bite ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-24 15:18:25","serial":"admin-1469342237-14693447049349248","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-24 15:27:44', NULL, ''),
(151, 'sanni', '{"void_item":{"id":"4148","date":"2016-07-26 17:03:24","ss_terminal":null,"ss_code":null,"sale_id":"1402","si_item_id":"0","item_id":"163","item_sku":"97","item_name":"Melting Heart ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-26 17:03:24","serial":"admin-1469506369-1469523804486941","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-26 17:04:45', NULL, ''),
(152, 'lois', '{"sale":{"id":"1404","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-07-28 09:01:32","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1469666931","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-07-28 09:04:57', NULL, ''),
(153, 'staff', '{"void_item":{"id":"4169","date":"2016-07-28 10:00:57","ss_terminal":null,"ss_code":null,"sale_id":"1410","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-28 10:00:57","serial":"admin-1469666931-14696712568564574","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-28 10:01:17', NULL, ''),
(154, 'sanni', '{"void_item":{"id":"4244","date":"2016-07-29 14:01:26","ss_terminal":null,"ss_code":null,"sale_id":"1445","si_item_id":"0","item_id":"193","item_sku":"128","item_name":"Braised Pork with Potato","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-29 14:01:26","serial":"admin-1469752228-1469772085895853","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-29 14:54:55', NULL, ''),
(155, 'sanni', '{"void_item":{"id":"4243","date":"2016-07-29 14:01:26","ss_terminal":null,"ss_code":null,"sale_id":"1445","si_item_id":"0","item_id":"75","item_sku":"75","item_name":"Aglio Olio ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-29 14:01:26","serial":"admin-1469752228-1469772085895853","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-29 14:55:02', NULL, ''),
(156, 'sanni', '{"sale":{"id":"1445","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-07-29 14:00:49","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1469752228","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-07-29 14:55:13', NULL, ''),
(157, 'lois', '{"void_item":{"id":"4263","date":"2016-07-29 15:59:06","ss_terminal":null,"ss_code":null,"sale_id":"1451","si_item_id":"0","item_id":"182","item_sku":"117","item_name":"Open Drinks ","item_option":"ice cream","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-29 15:59:06","serial":"admin-1469752228-14697791467003578","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-29 16:04:58', NULL, ''),
(158, 'lois', '{"void_item":{"id":"4264","date":"2016-07-29 16:05:30","ss_terminal":null,"ss_code":null,"sale_id":"1452","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-29 16:05:30","serial":"admin-1469752228-14697795299102344","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-29 16:05:40', NULL, ''),
(159, 'sanni', '{"void_item":{"id":"4266","date":"2016-07-29 16:05:30","ss_terminal":null,"ss_code":null,"sale_id":"1452","si_item_id":"0","item_id":"16","item_sku":"16","item_name":"Iced Mocha ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-29 16:05:30","serial":"admin-1469752228-14697795299102344","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-29 16:15:25', NULL, ''),
(160, 'lois', '{"void_item":{"id":"4353","date":"2016-07-30 12:38:22","ss_terminal":null,"ss_code":null,"sale_id":"1486","si_item_id":"0","item_id":"74","item_sku":"74","item_name":"Sunrice","item_option":"add bacon","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-30 12:38:22","serial":"admin-1469850386-14698535020958294","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-30 12:52:47', NULL, ''),
(161, 'lois', '{"sale":{"id":"1493","txn_no":null,"table_no":"T0","user_id":"10011","username":"Staff","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-07-30 14:13:22","payment_status":"Unpaid","cost":null,"subtotal":"10.00","amount":"10.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1469857554","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"4372","date":"2016-07-30 14:13:27","ss_terminal":null,"ss_code":null,"sale_id":"1493","si_item_id":"0","item_id":"179","item_sku":"114","item_name":"Creme Brulee ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-07-30 14:13:27","serial":"Staff-1469857554-14698592077672112","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-07-30 16:39:55', NULL, ''),
(162, 'sanni', '{"sale":{"id":"1512","txn_no":"101454","table_no":"T15","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-07-30 16:57:56","payment_status":"Paid","cost":null,"subtotal":"90.00","amount":"81.00","amount_cash":"81.00","amount_cc":null,"amount_tendered":"81.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":"9.00","adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1469862445","discount_type":"p","discount":"10","payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"4415","date":"2016-07-30 16:12:15","ss_terminal":null,"ss_code":null,"sale_id":"1512","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"House BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1469862445","ordered_by":"admin","ordered_time":"2016-07-30 16:12:15","serial":"admin-1469862445-14698663348622714","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"},{"id":"4416","date":"2016-07-30 16:12:15","ss_terminal":null,"ss_code":null,"sale_id":"1512","si_item_id":"0","item_id":"72","item_sku":"72","item_name":"Mushroom Chicken","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":"1","terminal":"27","printed":"1","session":"1469862445","ordered_by":"admin","ordered_time":"2016-07-30 16:12:15","serial":"admin-1469862445-14698663348622714","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":"10.0"},{"id":"4417","date":"2016-07-30 16:12:15","ss_terminal":null,"ss_code":null,"sale_id":"1512","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1469862445","ordered_by":"admin","ordered_time":"2016-07-30 16:12:15","serial":"admin-1469862445-14698663348622714","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"},{"id":"4418","date":"2016-07-30 16:12:15","ss_terminal":null,"ss_code":null,"sale_id":"1512","si_item_id":"0","item_id":"75","item_sku":"75","item_name":"Aglio Olio ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":"1","terminal":"27","printed":"1","session":"1469862445","ordered_by":"admin","ordered_time":"2016-07-30 16:12:15","serial":"admin-1469862445-14698663348622714","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"},{"id":"4419","date":"2016-07-30 16:14:58","ss_terminal":null,"ss_code":null,"sale_id":"1512","si_item_id":"0","item_id":"182","item_sku":"117","item_name":"Open Drinks ","item_option":"tea","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1469862445","ordered_by":"admin","ordered_time":"2016-07-30 16:14:58","serial":"admin-1469862445-14698664987484894","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"},{"id":"4420","date":"2016-07-30 16:38:44","ss_terminal":null,"ss_code":null,"sale_id":"1512","si_item_id":"0","item_id":"163","item_sku":"97","item_name":"Melting Heart ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1469862445","ordered_by":"admin","ordered_time":"2016-07-30 16:38:44","serial":"admin-1469862445-14698679240396219","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"},{"id":"4421","date":"2016-07-30 16:38:44","ss_terminal":null,"ss_code":null,"sale_id":"1512","si_item_id":"0","item_id":"165","item_sku":"99","item_name":"Ice-Cream","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":"1","terminal":"27","printed":"1","session":"1469862445","ordered_by":"admin","ordered_time":"2016-07-30 16:38:44","serial":"admin-1469862445-14698679240396219","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"}]}', '2016-07-30 16:58:08', 1, ''),
(163, 'sanni', '{"void_item":{"id":"4421","date":"2016-07-30 16:38:44","ss_terminal":null,"ss_code":null,"sale_id":"1512","si_item_id":"0","item_id":"165","item_sku":"99","item_name":"Ice-Cream","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":"1","terminal":"27","printed":"1","session":"1469862445","ordered_by":"admin","ordered_time":"2016-07-30 16:38:44","serial":"admin-1469862445-14698679240396219","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"}}', '2016-07-30 16:58:35', NULL, ''),
(164, 'sanni', '{"void_item":{"id":"4420","date":"2016-07-30 16:38:44","ss_terminal":null,"ss_code":null,"sale_id":"1512","si_item_id":"0","item_id":"163","item_sku":"97","item_name":"Melting Heart ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1469862445","ordered_by":"admin","ordered_time":"2016-07-30 16:38:44","serial":"admin-1469862445-14698679240396219","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"}}', '2016-07-30 16:58:48', NULL, ''),
(165, 'sanni', '{"void_item":{"id":"4419","date":"2016-07-30 16:14:58","ss_terminal":null,"ss_code":null,"sale_id":"1512","si_item_id":"0","item_id":"182","item_sku":"117","item_name":"Open Drinks ","item_option":"tea","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1469862445","ordered_by":"admin","ordered_time":"2016-07-30 16:14:58","serial":"admin-1469862445-14698664987484894","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"}}', '2016-07-30 16:58:59', NULL, ''),
(166, 'sanni', '{"void_item":{"id":"4418","date":"2016-07-30 16:12:15","ss_terminal":null,"ss_code":null,"sale_id":"1512","si_item_id":"0","item_id":"75","item_sku":"75","item_name":"Aglio Olio ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":"1","terminal":"27","printed":"1","session":"1469862445","ordered_by":"admin","ordered_time":"2016-07-30 16:12:15","serial":"admin-1469862445-14698663348622714","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"}}', '2016-07-30 16:59:10', NULL, ''),
(167, 'sanni', '{"void_item":{"id":"4417","date":"2016-07-30 16:12:15","ss_terminal":null,"ss_code":null,"sale_id":"1512","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1469862445","ordered_by":"admin","ordered_time":"2016-07-30 16:12:15","serial":"admin-1469862445-14698663348622714","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"}}', '2016-07-30 16:59:16', NULL, ''),
(168, 'sanni', '{"void_item":{"id":"4416","date":"2016-07-30 16:12:15","ss_terminal":null,"ss_code":null,"sale_id":"1512","si_item_id":"0","item_id":"72","item_sku":"72","item_name":"Mushroom Chicken","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":"1","terminal":"27","printed":"1","session":"1469862445","ordered_by":"admin","ordered_time":"2016-07-30 16:12:15","serial":"admin-1469862445-14698663348622714","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":"10.0"}}', '2016-07-30 16:59:22', NULL, ''),
(169, 'sanni', '{"void_item":{"id":"4415","date":"2016-07-30 16:12:15","ss_terminal":null,"ss_code":null,"sale_id":"1512","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"House BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1469862445","ordered_by":"admin","ordered_time":"2016-07-30 16:12:15","serial":"admin-1469862445-14698663348622714","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"}}', '2016-07-30 16:59:29', NULL, ''),
(170, 'sanni', '{"void_item":{"id":"4428","date":"2016-07-30 17:00:20","ss_terminal":null,"ss_code":null,"sale_id":"1512","si_item_id":"0","item_id":"182","item_sku":"117","item_name":"Open Drinks ","item_option":"tea","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-30 17:00:20","serial":"admin-1469862445-1469869220263982","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-07-30 17:01:37', NULL, ''),
(171, 'sanni', '{"sale":{"id":"1516","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-07-30 17:19:22","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1469869414","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-07-30 17:20:03', NULL, ''),
(172, 'staff', '{"void_item":{"id":"4681","date":"2016-08-01 18:50:11","ss_terminal":null,"ss_code":null,"sale_id":"1596","si_item_id":"0","item_id":"31","item_sku":"31","item_name":"Iced Matcha Latte","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-08-01 18:50:11","serial":"Staff-1470021703-14700486112365481","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-01 19:05:35', NULL, ''),
(173, 'lois', '{"void_item":{"id":"4688","date":"2016-08-01 20:33:28","ss_terminal":null,"ss_code":null,"sale_id":"1600","si_item_id":"0","item_id":"182","item_sku":"117","item_name":"Open Drinks ","item_option":"tea","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"Staff","ordered_time":"2016-08-01 20:33:28","serial":"Staff-1470021703-14700548078389024","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-01 21:25:16', NULL, ''),
(174, 'admin', '{"sale":{"id":"1621","txn_no":"101561","table_no":"Test","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-08-04 11:10:01","payment_status":"Paid","cost":null,"subtotal":"11.00","amount":"5.50","amount_cash":"5.50","amount_cc":null,"amount_tendered":"5.50","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":"5.50","adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1470272375","discount_type":"p","discount":"50","payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"4746","date":"2016-08-04 11:09:49","ss_terminal":null,"ss_code":null,"sale_id":"1621","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1470272375","ordered_by":"admin","ordered_time":"2016-08-04 11:09:49","serial":"admin-1470272375-14702801896814824","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":"50.0"}]}', '2016-08-04 11:10:16', 1, ''),
(175, 'admin', '{"sale":{"id":"1621","txn_no":"101561","table_no":"Test","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-08-04 11:10:01","payment_status":"Unpaid","cost":null,"subtotal":"11.00","amount":"11.00","amount_cash":"5.50","amount_cc":null,"amount_tendered":"5.50","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1470272375","discount_type":"p","discount":"0","payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"4746","date":"2016-08-04 11:09:49","ss_terminal":null,"ss_code":null,"sale_id":"1621","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1470272375","ordered_by":"admin","ordered_time":"2016-08-04 11:09:49","serial":"admin-1470272375-14702801896814824","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":"50.0"}]}', '2016-08-04 11:11:04', NULL, ''),
(176, 'sanni', '{"void_item":{"id":"4991","date":"2016-08-06 14:09:38","ss_terminal":null,"ss_code":null,"sale_id":"1703","si_item_id":"0","item_id":"76","item_sku":"76","item_name":"Pesto Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"sanni","ordered_time":"2016-08-06 14:09:38","serial":"sanni-1470459027-14704637779496551","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-06 14:10:50', NULL, ''),
(177, 'lois', '{"sale":{"id":"1711","txn_no":null,"table_no":"T8","user_id":"10010","username":"sanni","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-08-06 16:48:46","payment_status":"Unpaid","cost":null,"subtotal":"19.00","amount":"19.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1470465155","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"5017","date":"2016-08-06 16:48:57","ss_terminal":null,"ss_code":null,"sale_id":"1711","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"sanni","ordered_time":"2016-08-06 16:48:57","serial":"sanni-1470465155-14704733373698281","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"5018","date":"2016-08-06 16:48:57","ss_terminal":null,"ss_code":null,"sale_id":"1711","si_item_id":"0","item_id":"27","item_sku":"27","item_name":"Iced Chocolate ","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"sanni","ordered_time":"2016-08-06 16:48:57","serial":"sanni-1470465155-14704733373698281","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-08-06 20:08:01', NULL, ''),
(178, 'lois', '{"void_item":{"id":"5097","date":"2016-08-07 10:08:31","ss_terminal":null,"ss_code":null,"sale_id":"1735","si_item_id":"0","item_id":"158","item_sku":"92","item_name":"Nutella Toast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"sanni","ordered_time":"2016-08-07 10:08:31","serial":"sanni-1470535040-14705357107499655","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-07 10:09:00', NULL, ''),
(179, 'lois', '{"void_item":{"id":"5095","date":"2016-08-07 10:06:50","ss_terminal":null,"ss_code":null,"sale_id":"1733","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"sanni","ordered_time":"2016-08-07 10:06:50","serial":"sanni-1470535040-14705356105199738","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-07 10:16:04', NULL, ''),
(180, 'sanni', '{"sale":{"id":"1769","txn_no":"101705","table_no":"T1","user_id":"10010","username":"sanni","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-08-07 12:30:39","payment_status":"Paid","cost":null,"subtotal":"22.00","amount":"22.00","amount_cash":"22.00","amount_cc":null,"amount_tendered":"22.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1470541587","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"5193","date":"2016-08-07 12:30:37","ss_terminal":null,"ss_code":null,"sale_id":"1769","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1470541587","ordered_by":"sanni","ordered_time":"2016-08-07 12:30:37","serial":"sanni-1470541587-14705442368584597","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"5194","date":"2016-08-07 12:30:37","ss_terminal":null,"ss_code":null,"sale_id":"1769","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1470541587","ordered_by":"sanni","ordered_time":"2016-08-07 12:30:37","serial":"sanni-1470541587-14705442368584597","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-08-07 12:30:57', 1, ''),
(181, 'sanni', '{"void_item":{"id":"5194","date":"2016-08-07 12:30:37","ss_terminal":null,"ss_code":null,"sale_id":"1769","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1470541587","ordered_by":"sanni","ordered_time":"2016-08-07 12:30:37","serial":"sanni-1470541587-14705442368584597","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-07 12:31:09', NULL, ''),
(182, 'sanni', '{"void_item":{"id":"5223","date":"2016-08-07 14:43:18","ss_terminal":null,"ss_code":null,"sale_id":"1780","si_item_id":"0","item_id":"179","item_sku":"114","item_name":"Creme Brulee ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"sanni","ordered_time":"2016-08-07 14:43:18","serial":"sanni-1470546490-14705521979491617","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-07 14:43:45', NULL, ''),
(183, 'sanni', '{"void_item":{"id":"5243","date":"2016-08-07 15:54:14","ss_terminal":null,"ss_code":null,"sale_id":"1783","si_item_id":"0","item_id":"29","item_sku":"29","item_name":"Iced Lemon Tea","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"sanni","ordered_time":"2016-08-07 15:54:14","serial":"sanni-1470552213-14705564546372344","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-07 16:06:51', NULL, ''),
(184, 'lois', '{"void_item":{"id":"5270","date":"2016-08-07 18:56:03","ss_terminal":null,"ss_code":null,"sale_id":"1790","si_item_id":"0","item_id":"183","item_sku":"118","item_name":"Plain Rice","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"2.00","margin":"2.0000","cost":"0.0000","amount":"2.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"sanni","ordered_time":"2016-08-07 18:56:03","serial":"sanni-1470552213-1470567363422743","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-07 19:13:00', NULL, ''),
(185, 'lois', '{"void_item":{"id":"5305","date":"2016-08-08 09:13:22","ss_terminal":null,"ss_code":null,"sale_id":"1800","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"House BLT","item_option":"add bacon,add bacon","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"34.00","margin":"34.0000","cost":"0.0000","amount":"34.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"sanni","ordered_time":"2016-08-08 09:13:22","serial":"sanni-1470618188-14706188026631531","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-08 09:13:40', NULL, ''),
(186, 'lois', '{"sale":{"id":"1816","txn_no":null,"table_no":"T13","user_id":"10010","username":"sanni","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-08-08 14:08:10","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1470635017","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-08-08 15:03:20', NULL, ''),
(187, 'lois', '{"sale":{"id":"1834","txn_no":"101771","table_no":"T13","user_id":"10010","username":"sanni","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-08-08 17:08:49","payment_status":"Paid","cost":null,"subtotal":"24.00","amount":"24.00","amount_cash":"24.00","amount_cc":null,"amount_tendered":"24.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1470635017","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"5391","date":"2016-08-08 17:08:25","ss_terminal":null,"ss_code":null,"sale_id":"1834","si_item_id":"0","item_id":"28","item_sku":"28","item_name":"Iced Honey Milk","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1470635017","ordered_by":"sanni","ordered_time":"2016-08-08 17:08:25","serial":"sanni-1470635017-14706473053733242","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"5390","date":"2016-08-08 17:08:25","ss_terminal":null,"ss_code":null,"sale_id":"1834","si_item_id":"0","item_id":"17","item_sku":"17","item_name":"Iced Caramel Macchiato ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1470635017","ordered_by":"sanni","ordered_time":"2016-08-08 17:08:25","serial":"sanni-1470635017-14706473053733242","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-08-08 17:11:33', 1, ''),
(188, 'lois', '{"void_item":{"id":"5390","date":"2016-08-08 17:08:25","ss_terminal":null,"ss_code":null,"sale_id":"1834","si_item_id":"0","item_id":"17","item_sku":"17","item_name":"Iced Caramel Macchiato ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1470635017","ordered_by":"sanni","ordered_time":"2016-08-08 17:08:25","serial":"sanni-1470635017-14706473053733242","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-08 17:11:45', NULL, ''),
(189, 'sanni', '{"void_item":{"id":"5433","date":"2016-08-09 12:37:59","ss_terminal":null,"ss_code":null,"sale_id":"1854","si_item_id":"0","item_id":"75","item_sku":"75","item_name":"Aglio Olio ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-09 12:37:59","serial":"admin-1470704366-14707174795827550","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-09 12:38:42', NULL, ''),
(190, 'sanni', '{"void_item":{"id":"5440","date":"2016-08-09 12:39:00","ss_terminal":null,"ss_code":null,"sale_id":"1854","si_item_id":"0","item_id":"183","item_sku":"118","item_name":"Plain Rice","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"2.00","margin":"2.0000","cost":"0.0000","amount":"2.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-09 12:39:00","serial":"admin-1470704366-14707175402326146","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-09 12:57:40', NULL, ''),
(191, 'sanni', '{"void_item":{"id":"5515","date":"2016-08-11 19:26:24","ss_terminal":null,"ss_code":null,"sale_id":"1883","si_item_id":"0","item_id":"56","item_sku":"56","item_name":"House red (Glass)","item_option":"","category":"Cold Drinks","subcategory":"Wine","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-11 19:26:24","serial":"admin-1470876895-1470914784259376","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-11 19:31:49', NULL, ''),
(192, 'sanni', '{"void_item":{"id":"5516","date":"2016-08-11 19:26:24","ss_terminal":null,"ss_code":null,"sale_id":"1883","si_item_id":"0","item_id":"56","item_sku":"56","item_name":"House red (Glass)","item_option":"","category":"Cold Drinks","subcategory":"Wine","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-11 19:26:24","serial":"admin-1470876895-1470914784259376","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-11 19:31:56', NULL, ''),
(193, 'lois', '{"sale":{"id":"1885","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-08-11 20:06:48","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1470876895","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-08-11 20:35:37', NULL, ''),
(194, 'sanni', '{"void_item":{"id":"5527","date":"2016-08-11 20:40:25","ss_terminal":null,"ss_code":null,"sale_id":"1887","si_item_id":null,"item_id":"25","item_sku":"25","item_name":"Matcha Latte","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-11 20:40:25","serial":"admin-1470876895-14709192253463882","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-11 20:44:01', NULL, ''),
(195, 'sanni', '{"void_item":{"id":"5526","date":"2016-08-11 20:40:25","ss_terminal":null,"ss_code":null,"sale_id":"1887","si_item_id":"0","item_id":"61","item_sku":"61","item_name":"Slim Fit","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-11 20:40:25","serial":"admin-1470876895-14709192253463882","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-11 20:45:49', NULL, ''),
(196, 'sanni', '{"void_item":{"id":"5596","date":"2016-08-12 20:03:00","ss_terminal":null,"ss_code":null,"sale_id":"1916","si_item_id":null,"item_id":"37","item_sku":"37","item_name":"Pineapple Orange","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"sanni","ordered_time":"2016-08-12 20:03:00","serial":"sanni-1470976926-14710033799629599","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-12 20:08:20', NULL, ''),
(197, 'lois', '{"sale":{"id":"1922","txn_no":null,"table_no":"T5","user_id":"10010","username":"sanni","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-08-12 21:20:03","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1470976926","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-08-12 22:01:05', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(198, 'lois', '{"sale":{"id":"1925","txn_no":"101860","table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-08-13 10:17:28","payment_status":"Paid","cost":null,"subtotal":"94.00","amount":"94.00","amount_cash":"94.00","amount_cc":null,"amount_tendered":"100.00","amount_change":"6.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1471049773","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"5628","date":"2016-08-13 10:15:41","ss_terminal":null,"ss_code":null,"sale_id":"1925","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"House BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1471049773","ordered_by":"admin","ordered_time":"2016-08-13 10:15:41","serial":"admin-1471049773-14710545413697521","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"5629","date":"2016-08-13 10:15:41","ss_terminal":null,"ss_code":null,"sale_id":"1925","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":"1","terminal":"27","printed":"1","session":"1471049773","ordered_by":"admin","ordered_time":"2016-08-13 10:15:41","serial":"admin-1471049773-14710545413697521","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"5630","date":"2016-08-13 10:15:41","ss_terminal":null,"ss_code":null,"sale_id":"1925","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"House BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1471049773","ordered_by":"admin","ordered_time":"2016-08-13 10:15:41","serial":"admin-1471049773-14710545413697521","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"5631","date":"2016-08-13 10:17:15","ss_terminal":null,"ss_code":null,"sale_id":"1925","si_item_id":"0","item_id":"20","item_sku":"20","item_name":"Iced DD Special","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1471049773","ordered_by":"admin","ordered_time":"2016-08-13 10:17:15","serial":"admin-1471049773-14710546357978323","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"5632","date":"2016-08-13 10:17:15","ss_terminal":null,"ss_code":null,"sale_id":"1925","si_item_id":null,"item_id":"10","item_sku":"10","item_name":"Dirty Chai","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1471049773","ordered_by":"admin","ordered_time":"2016-08-13 10:17:15","serial":"admin-1471049773-14710546357978323","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"5633","date":"2016-08-13 10:17:15","ss_terminal":null,"ss_code":null,"sale_id":"1925","si_item_id":"0","item_id":"17","item_sku":"17","item_name":"Iced Caramel Macchiato ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1471049773","ordered_by":"admin","ordered_time":"2016-08-13 10:17:15","serial":"admin-1471049773-14710546357978323","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-08-13 10:17:59', 1, ''),
(199, 'lois', '{"void_item":{"id":"5632","date":"2016-08-13 10:17:15","ss_terminal":null,"ss_code":null,"sale_id":"1925","si_item_id":null,"item_id":"10","item_sku":"10","item_name":"Dirty Chai","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1471049773","ordered_by":"admin","ordered_time":"2016-08-13 10:17:15","serial":"admin-1471049773-14710546357978323","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-13 10:18:09', NULL, ''),
(200, 'lois', '{"void_item":{"id":"5638","date":"2016-08-13 10:20:22","ss_terminal":null,"ss_code":null,"sale_id":"1926","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"cheesy bacon toast","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-13 10:20:22","serial":"admin-1471049773-14710548219155558","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-13 10:36:18', NULL, ''),
(201, 'lois', '{"sale":{"id":"1942","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-08-13 13:24:33","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1471064222","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-08-13 13:45:40', NULL, ''),
(202, 'lois', '{"sale":{"id":"2013","txn_no":"101947","table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-08-15 10:19:42","payment_status":"Paid","cost":null,"subtotal":"50.00","amount":"50.00","amount_cash":"50.00","amount_cc":null,"amount_tendered":"50.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1471222368","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"5858","date":"2016-08-15 10:18:30","ss_terminal":null,"ss_code":null,"sale_id":"2013","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":"1","terminal":"27","printed":"1","session":"1471222368","ordered_by":"admin","ordered_time":"2016-08-15 10:18:30","serial":"admin-1471222368-14712275106001541","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"5859","date":"2016-08-15 10:18:30","ss_terminal":null,"ss_code":null,"sale_id":"2013","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":"1","terminal":"27","printed":"1","session":"1471222368","ordered_by":"admin","ordered_time":"2016-08-15 10:18:30","serial":"admin-1471222368-14712275106001541","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"5860","date":"2016-08-15 10:18:30","ss_terminal":null,"ss_code":null,"sale_id":"2013","si_item_id":"0","item_id":"184","item_sku":"119","item_name":"Flat White","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1471222368","ordered_by":"admin","ordered_time":"2016-08-15 10:18:30","serial":"admin-1471222368-14712275106001541","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"5861","date":"2016-08-15 10:19:34","ss_terminal":null,"ss_code":null,"sale_id":"2013","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":"1","terminal":"27","printed":"1","session":"1471222368","ordered_by":"admin","ordered_time":"2016-08-15 10:19:34","serial":"admin-1471222368-14712275746252056","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"5862","date":"2016-08-15 10:19:34","ss_terminal":null,"ss_code":null,"sale_id":"2013","si_item_id":"0","item_id":"176","item_sku":"111","item_name":"Scones ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":"1","terminal":"27","printed":"1","session":"1471222368","ordered_by":"admin","ordered_time":"2016-08-15 10:19:34","serial":"admin-1471222368-14712275746252056","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-08-15 11:00:16', 1, ''),
(203, 'lois', '{"void_item":{"id":"5862","date":"2016-08-15 10:19:34","ss_terminal":null,"ss_code":null,"sale_id":"2013","si_item_id":"0","item_id":"176","item_sku":"111","item_name":"Scones ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":"1","terminal":"27","printed":"1","session":"1471222368","ordered_by":"admin","ordered_time":"2016-08-15 10:19:34","serial":"admin-1471222368-14712275746252056","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-15 11:00:29', NULL, ''),
(204, 'lois', '{"sale":{"id":"2126","txn_no":null,"table_no":"T14","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-08-19 19:34:57","payment_status":"Unpaid","cost":null,"subtotal":"20.00","amount":"20.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1471602109","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"6161","date":"2016-08-19 19:35:09","ss_terminal":null,"ss_code":null,"sale_id":"2126","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"curry fish","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-19 19:35:09","serial":"admin-1471602109-14716065094029871","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-08-19 19:35:54', NULL, ''),
(205, 'lois', '{"void_item":{"id":"6160","date":"2016-08-19 19:32:35","ss_terminal":null,"ss_code":null,"sale_id":"2125","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"curry fish,curry pork","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"37.00","margin":"37.0000","cost":"0.0000","amount":"37.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-19 19:32:35","serial":"admin-1471602109-14716063554942094","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-19 19:40:21', NULL, ''),
(206, 'lois', '{"sale":{"id":"2133","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-08-20 09:13:06","payment_status":"Unpaid","cost":null,"subtotal":"12.00","amount":"12.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1471655526","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"6184","date":"2016-08-20 09:14:56","ss_terminal":null,"ss_code":null,"sale_id":"2133","si_item_id":"0","item_id":"178","item_sku":"113","item_name":"Brownies ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-20 09:14:56","serial":"admin-1471655526-1471655696384280","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-08-20 09:15:42', NULL, ''),
(207, 'lois', '{"void_item":{"id":"6225","date":"2016-08-20 12:21:22","ss_terminal":null,"ss_code":null,"sale_id":"2147","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-20 12:21:22","serial":"admin-1471655526-14716668824864584","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-20 12:25:00', NULL, ''),
(208, 'lois', '{"void_item":{"id":"6224","date":"2016-08-20 12:21:22","ss_terminal":null,"ss_code":null,"sale_id":"2147","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-20 12:21:22","serial":"admin-1471655526-14716668824864584","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-20 12:25:08', NULL, ''),
(209, 'lois', '{"sale":{"id":"2141","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-08-20 11:55:01","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1471655526","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-08-20 12:30:43', NULL, ''),
(210, 'lois', '{"void_item":{"id":"6243","date":"2016-08-20 13:56:38","ss_terminal":null,"ss_code":null,"sale_id":"2155","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-20 13:56:38","serial":"admin-1471667429-14716725981309073","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-20 14:09:13', NULL, ''),
(211, 'lois', '{"void_item":{"id":"6266","date":"2016-08-20 20:31:20","ss_terminal":null,"ss_code":null,"sale_id":"2164","si_item_id":"0","item_id":"194","item_sku":"129","item_name":"Chicken Wings","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-20 20:31:20","serial":"admin-1471667429-14716962805321434","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-20 20:32:32', NULL, ''),
(212, 'lois', '{"void_item":{"id":"6306","date":"2016-08-21 09:41:44","ss_terminal":null,"ss_code":null,"sale_id":"2171","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-21 09:41:44","serial":"admin-1471741108-14717437041714863","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-21 09:42:30', NULL, ''),
(213, 'lois', '{"sale":{"id":"2170","txn_no":"102099","table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-08-21 09:39:58","payment_status":"Paid","cost":null,"subtotal":"143.00","amount":"128.70","amount_cash":"128.70","amount_cc":null,"amount_tendered":"150.00","amount_change":"21.30","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":"14.30","adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1471741108","discount_type":"p","discount":"10","payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"6295","date":"2016-08-21 09:31:32","ss_terminal":null,"ss_code":null,"sale_id":"2170","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":"1","terminal":"27","printed":"1","session":"1471741108","ordered_by":"admin","ordered_time":"2016-08-21 09:31:32","serial":"admin-1471741108-1471743092346496","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"},{"id":"6296","date":"2016-08-21 09:31:32","ss_terminal":null,"ss_code":null,"sale_id":"2170","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":"1","terminal":"27","printed":"1","session":"1471741108","ordered_by":"admin","ordered_time":"2016-08-21 09:31:32","serial":"admin-1471741108-1471743092346496","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"},{"id":"6304","date":"2016-08-21 09:31:32","ss_terminal":null,"ss_code":null,"sale_id":"2170","si_item_id":null,"item_id":"4","item_sku":"4","item_name":"Piccolo","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1471741108","ordered_by":"admin","ordered_time":"2016-08-21 09:31:32","serial":"admin-1471741108-1471743092346496","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":"10.0"},{"id":"6303","date":"2016-08-21 09:31:32","ss_terminal":null,"ss_code":null,"sale_id":"2170","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":"1","terminal":"27","printed":"1","session":"1471741108","ordered_by":"admin","ordered_time":"2016-08-21 09:31:32","serial":"admin-1471741108-1471743092346496","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":"10.0"},{"id":"6302","date":"2016-08-21 09:31:32","ss_terminal":null,"ss_code":null,"sale_id":"2170","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"House BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1471741108","ordered_by":"admin","ordered_time":"2016-08-21 09:31:32","serial":"admin-1471741108-1471743092346496","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"},{"id":"6299","date":"2016-08-21 09:31:32","ss_terminal":null,"ss_code":null,"sale_id":"2170","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1471741108","ordered_by":"admin","ordered_time":"2016-08-21 09:31:32","serial":"admin-1471741108-1471743092346496","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"},{"id":"6300","date":"2016-08-21 09:31:32","ss_terminal":null,"ss_code":null,"sale_id":"2170","si_item_id":"0","item_id":"51","item_sku":"51","item_name":"Chocolate Frappe","item_option":"","category":"Cold Drinks","subcategory":"Frappe","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1471741108","ordered_by":"admin","ordered_time":"2016-08-21 09:31:32","serial":"admin-1471741108-1471743092346496","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":"10.0"},{"id":"6301","date":"2016-08-21 09:31:32","ss_terminal":null,"ss_code":null,"sale_id":"2170","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1471741108","ordered_by":"admin","ordered_time":"2016-08-21 09:31:32","serial":"admin-1471741108-1471743092346496","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":"10.0"},{"id":"6298","date":"2016-08-21 09:31:32","ss_terminal":null,"ss_code":null,"sale_id":"2170","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":"1","terminal":"27","printed":"1","session":"1471741108","ordered_by":"admin","ordered_time":"2016-08-21 09:31:32","serial":"admin-1471741108-1471743092346496","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"},{"id":"6297","date":"2016-08-21 09:31:32","ss_terminal":null,"ss_code":null,"sale_id":"2170","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"House BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1471741108","ordered_by":"admin","ordered_time":"2016-08-21 09:31:32","serial":"admin-1471741108-1471743092346496","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"}]}', '2016-08-21 10:18:44', 1, ''),
(214, 'lois', '{"void_item":{"id":"6295","date":"2016-08-21 09:31:32","ss_terminal":null,"ss_code":null,"sale_id":"2170","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":"1","terminal":"27","printed":"1","session":"1471741108","ordered_by":"admin","ordered_time":"2016-08-21 09:31:32","serial":"admin-1471741108-1471743092346496","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"}}', '2016-08-21 10:18:55', NULL, ''),
(215, 'sanni', '{"void_item":{"id":"6401","date":"2016-08-21 16:58:05","ss_terminal":null,"ss_code":null,"sale_id":"2205","si_item_id":"0","item_id":"76","item_sku":"76","item_name":"Pesto Pasta","item_option":"Bacon","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"22.00","margin":"22.0000","cost":"0.0000","amount":"22.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-21 16:58:05","serial":"admin-1471749979-14717698856929910","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-21 16:58:21', NULL, ''),
(216, 'sanni', '{"void_item":{"id":"6423","date":"2016-08-21 17:48:06","ss_terminal":null,"ss_code":null,"sale_id":"2205","si_item_id":"0","item_id":"183","item_sku":"118","item_name":"Plain Rice","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"2.00","margin":"2.0000","cost":"0.0000","amount":"2.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-21 17:48:06","serial":"admin-1471770451-1471772886429867","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-21 17:56:42', NULL, ''),
(217, 'lois', '{"void_item":{"id":"6458","date":"2016-08-22 12:09:40","ss_terminal":null,"ss_code":null,"sale_id":"2226","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-22 12:09:40","serial":"admin-1471827960-14718389808247751","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-22 12:36:38', NULL, ''),
(218, 'lois', '{"void_item":{"id":"6479","date":"2016-08-22 15:34:25","ss_terminal":null,"ss_code":null,"sale_id":"2234","si_item_id":"0","item_id":"208","item_sku":"D0001","item_name":"RM5 DISCOUNT ","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"-5.00","margin":"-5.0000","cost":"0.0000","amount":"-5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-22 15:34:25","serial":"admin-1471827960-14718512655832378","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-22 15:34:59', NULL, ''),
(219, 'lois', '{"sale":{"id":"2234","txn_no":null,"table_no":"TEST","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-08-22 15:33:37","payment_status":"Unpaid","cost":null,"subtotal":"15.00","amount":"15.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1471827960","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"6478","date":"2016-08-22 15:34:25","ss_terminal":null,"ss_code":null,"sale_id":"2234","si_item_id":"0","item_id":"75","item_sku":"75","item_name":"Aglio Olio ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-22 15:34:25","serial":"admin-1471827960-14718512655832378","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-08-22 15:35:09', NULL, ''),
(220, 'lois', '{"void_item":{"id":"6483","date":"2016-08-22 16:25:20","ss_terminal":null,"ss_code":null,"sale_id":"2235","si_item_id":"0","item_id":"176","item_sku":"111","item_name":"Scones ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-22 16:25:20","serial":"admin-1471827960-14718543205701626","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-22 17:35:55', NULL, ''),
(221, 'lois', '{"void_item":{"id":"6513","date":"2016-08-23 13:08:45","ss_terminal":null,"ss_code":null,"sale_id":"2247","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"Hot dog bun","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-23 13:08:45","serial":"admin-1471914353-14719289250207789","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-23 14:23:59', NULL, ''),
(222, 'sanni', '{"sale":{"id":"2293","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-08-26 12:10:00","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1472173408","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-08-26 12:46:02', NULL, ''),
(223, 'lois', '{"sale":{"id":"2320","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-08-26 20:10:21","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1472185694","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-08-26 20:10:39', NULL, ''),
(224, 'sanni', '{"void_item":{"id":"6677","date":"2016-08-27 10:07:09","ss_terminal":null,"ss_code":null,"sale_id":"2324","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"lois","ordered_time":"2016-08-27 10:07:09","serial":"lois-1472258939-14722636292745526","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-27 10:19:47', NULL, ''),
(225, 'lois', '{"void_item":{"id":"6728","date":"2016-08-27 12:20:04","ss_terminal":null,"ss_code":null,"sale_id":"2344","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"lois","ordered_time":"2016-08-27 12:20:04","serial":"lois-1472258939-14722716045767540","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-27 12:20:53', NULL, ''),
(226, 'sanni', '{"sale":{"id":"2346","txn_no":null,"table_no":"T15","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-08-27 12:31:55","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1472271633","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-08-27 12:32:35', NULL, ''),
(227, 'sanni', '{"void_item":{"id":"6743","date":"2016-08-27 13:16:32","ss_terminal":null,"ss_code":null,"sale_id":"2348","si_item_id":"0","item_id":"74","item_sku":"74","item_name":"Sunrice","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-27 13:16:32","serial":"admin-1472274868-14722749921926365","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-27 13:48:16', NULL, ''),
(228, 'sanni', '{"void_item":{"id":"6772","date":"2016-08-27 14:27:13","ss_terminal":null,"ss_code":null,"sale_id":"2355","si_item_id":null,"item_id":"34","item_sku":"34","item_name":"Ginger Lemongrass ","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-27 14:27:13","serial":"admin-1472274868-14722792338273362","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-27 14:27:58', NULL, ''),
(229, 'sanni', '{"void_item":{"id":"6771","date":"2016-08-27 14:26:57","ss_terminal":null,"ss_code":null,"sale_id":"2355","si_item_id":null,"item_id":"34","item_sku":"34","item_name":"Ginger Lemongrass ","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-27 14:26:57","serial":"admin-1472274868-14722792171034516","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-27 14:28:09', NULL, ''),
(230, 'sanni', '{"void_item":{"id":"6785","date":"2016-08-27 15:36:30","ss_terminal":null,"ss_code":null,"sale_id":"2360","si_item_id":"0","item_id":"168","item_sku":"102","item_name":"Black & White ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-27 15:36:30","serial":"admin-1472281391-14722833903932585","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-27 20:39:24', NULL, ''),
(231, 'lois', '{"void_item":{"id":"6879","date":"2016-08-28 09:40:34","ss_terminal":null,"ss_code":null,"sale_id":"2392","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-28 09:40:34","serial":"admin-1472344579-14723484345694678","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-28 09:41:00', NULL, ''),
(232, 'sanni', '{"sale":{"id":"2430","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-08-28 14:54:23","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1472360478","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-08-28 15:01:57', NULL, ''),
(233, 'sanni', '{"sale":[],"sale_items":[{"id":"4722","date":"2016-08-02 17:28:20","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-02 17:28:20","serial":"admin-1470120438-14701301006259992","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"4723","date":"2016-08-02 17:28:20","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-02 17:28:20","serial":"admin-1470120438-14701301006259992","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"4724","date":"2016-08-02 17:28:20","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-02 17:28:20","serial":"admin-1470120438-14701301006259992","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"3633","date":"2016-07-19 16:44:35","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":null,"item_id":"44","item_sku":"44","item_name":"Tiger ","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-19 16:44:35","serial":"admin-1468911956-14689178745162299","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"3636","date":"2016-07-19 18:46:02","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":"0","item_id":"42","item_sku":"42","item_name":"Passion Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-19 18:46:02","serial":"admin-1468911956-14689251620097956","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"4277","date":"2016-07-29 17:09:49","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":"0","item_id":"55","item_sku":"55","item_name":"House White (Glass)","item_option":"","category":"Cold Drinks","subcategory":"Wine","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-29 17:09:49","serial":"admin-1469752228-1469783389032888","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"5561","date":"2016-08-12 13:01:36","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":"0","item_id":"60","item_sku":"60","item_name":"The Hulk","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"sanni","ordered_time":"2016-08-12 13:01:36","serial":"sanni-1470976926-1470978096754132","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"6002","date":"2016-08-16 12:47:55","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-16 12:47:55","serial":"admin-1471319531-14713228757253348","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"6003","date":"2016-08-16 12:47:55","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-16 12:47:55","serial":"admin-1471319531-14713228757253348","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-08-28 16:49:21', 1, ''),
(234, 'sanni', '{"void_item":{"id":"7055","date":"2016-08-28 18:19:36","ss_terminal":null,"ss_code":null,"sale_id":"2447","si_item_id":"0","item_id":"75","item_sku":"75","item_name":"Aglio Olio ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-28 18:19:36","serial":"admin-1472360478-14723795761808948","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-28 18:37:26', NULL, ''),
(235, 'sanni', '{"void_item":{"id":"7058","date":"2016-08-28 18:37:34","ss_terminal":null,"ss_code":null,"sale_id":"2447","si_item_id":"0","item_id":"199","item_sku":"134","item_name":"Dinner - Marmite Chicken","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-28 18:37:34","serial":"admin-1472360478-14723806543436739","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-28 18:38:34', NULL, ''),
(236, 'sanni', '{"void_item":{"id":"7136","date":"2016-08-31 09:30:49","ss_terminal":null,"ss_code":null,"sale_id":"2470","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"House BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-31 09:30:49","serial":"admin-1472606948-14726070490285392","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-31 09:31:09', NULL, ''),
(237, 'sanni', '{"void_item":{"id":"7148","date":"2016-08-31 10:10:41","ss_terminal":null,"ss_code":null,"sale_id":"2473","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-31 10:10:41","serial":"admin-1472606948-14726094409886614","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-31 10:11:13', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(238, 'lois', '{"sale":{"id":"2476","txn_no":"102392","table_no":"T13","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-08-31 10:20:44","payment_status":"Paid","cost":null,"subtotal":"15.00","amount":"15.00","amount_cash":"15.00","amount_cc":null,"amount_tendered":"20.00","amount_change":"5.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1472609459","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"7155","date":"2016-08-31 10:20:37","ss_terminal":null,"ss_code":null,"sale_id":"2476","si_item_id":"0","item_id":"159","item_sku":"93","item_name":"Granola ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1472609459","ordered_by":"admin","ordered_time":"2016-08-31 10:20:37","serial":"admin-1472609459-14726100370252240","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-08-31 10:42:50', 1, ''),
(239, 'lois', '{"void_item":{"id":"7155","date":"2016-08-31 10:20:37","ss_terminal":null,"ss_code":null,"sale_id":"2476","si_item_id":"0","item_id":"159","item_sku":"93","item_name":"Granola ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1472609459","ordered_by":"admin","ordered_time":"2016-08-31 10:20:37","serial":"admin-1472609459-14726100370252240","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-31 10:43:04', NULL, ''),
(240, 'lois', '{"void_item":{"id":"7141","date":"2016-08-31 10:00:27","ss_terminal":null,"ss_code":null,"sale_id":"2471","si_item_id":"0","item_id":"42","item_sku":"42","item_name":"Passion Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-31 10:00:27","serial":"admin-1472606948-14726088268079896","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-08-31 10:43:29', NULL, ''),
(241, 'lois', '{"void_item":{"id":"7264","date":"2016-09-01 12:41:08","ss_terminal":null,"ss_code":null,"sale_id":"2521","si_item_id":"0","item_id":"197","item_sku":"132","item_name":"Dinner - Rice Wine Ginger Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-01 12:41:08","serial":"admin-1472701175-1472704868478434","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-01 12:41:50', NULL, ''),
(242, 'lois', '{"void_item":{"id":"7351","date":"2016-09-02 19:30:09","ss_terminal":null,"ss_code":null,"sale_id":"2550","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"15.00","margin":"45.0000","cost":"0.0000","amount":"45.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-02 19:30:09","serial":"admin-1472804577-1472815809502783","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-02 20:32:29', NULL, ''),
(243, 'sanni', '{"void_item":{"id":"7466","date":"2016-09-03 14:58:05","ss_terminal":null,"ss_code":null,"sale_id":"2587","si_item_id":null,"item_id":"7","item_sku":"7","item_name":"Mocha ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-03 14:58:05","serial":"admin-1472879469-14728858854769961","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-03 14:58:39', NULL, ''),
(244, 'lois', '{"void_item":{"id":"7490","date":"2016-09-03 20:22:33","ss_terminal":null,"ss_code":null,"sale_id":"2597","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"Cheesy Potato","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-03 20:22:33","serial":"admin-1472879469-1472905352991961","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-03 20:50:59', NULL, ''),
(245, 'sanni', '{"void_item":{"id":"7561","date":"2016-09-04 11:42:01","ss_terminal":null,"ss_code":null,"sale_id":"2618","si_item_id":"0","item_id":"60","item_sku":"60","item_name":"The Hulk","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-04 11:42:02","serial":"admin-1472960110-14729605218176514","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-04 11:42:41', NULL, ''),
(246, 'sanni', '{"void_item":{"id":"7583","date":"2016-09-04 12:39:04","ss_terminal":null,"ss_code":null,"sale_id":"2624","si_item_id":"0","item_id":"158","item_sku":"92","item_name":"Nutella Toast ","item_option":"Takeaway","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-04 12:39:04","serial":"admin-1472960110-14729639441502060","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-04 12:39:17', NULL, ''),
(247, 'lois', '{"void_item":{"id":"7588","date":"2016-09-04 12:58:29","ss_terminal":null,"ss_code":null,"sale_id":"2625","si_item_id":"0","item_id":"76","item_sku":"76","item_name":"Pesto Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-04 12:58:29","serial":"admin-1472963973-14729651089511699","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-04 12:59:14', NULL, ''),
(248, 'sanni', '{"sale":{"id":"2657","txn_no":"102573","table_no":"T13","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-09-05 11:48:46","payment_status":"Paid","cost":null,"subtotal":"42.00","amount":"42.00","amount_cash":"42.00","amount_cc":null,"amount_tendered":"42.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1473037573","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"7682","date":"2016-09-05 11:48:35","ss_terminal":null,"ss_code":null,"sale_id":"2657","si_item_id":"0","item_id":"72","item_sku":"72","item_name":"Mushroom Chicken","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":"1","terminal":"27","printed":"1","session":"1473037573","ordered_by":"admin","ordered_time":"2016-09-05 11:48:35","serial":"admin-1473037573-14730473148706457","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"7681","date":"2016-09-05 11:48:35","ss_terminal":null,"ss_code":null,"sale_id":"2657","si_item_id":"0","item_id":"73","item_sku":"73","item_name":"Marmite Chicken ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":"1","terminal":"27","printed":"1","session":"1473037573","ordered_by":"admin","ordered_time":"2016-09-05 11:48:35","serial":"admin-1473037573-14730473148706457","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"7680","date":"2016-09-05 11:48:35","ss_terminal":null,"ss_code":null,"sale_id":"2657","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":"1","terminal":"27","printed":"1","session":"1473037573","ordered_by":"admin","ordered_time":"2016-09-05 11:48:35","serial":"admin-1473037573-14730473148706457","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-09-05 11:49:44', 1, ''),
(249, 'sanni', '{"void_item":{"id":"7680","date":"2016-09-05 11:48:35","ss_terminal":null,"ss_code":null,"sale_id":"2657","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":"1","terminal":"27","printed":"1","session":"1473037573","ordered_by":"admin","ordered_time":"2016-09-05 11:48:35","serial":"admin-1473037573-14730473148706457","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-05 11:49:55', NULL, ''),
(250, 'lois', '{"void_item":{"id":"7707","date":"2016-09-05 14:42:24","ss_terminal":null,"ss_code":null,"sale_id":"2669","si_item_id":"0","item_id":"76","item_sku":"76","item_name":"Pesto Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-05 14:42:24","serial":"admin-1473037573-1473057744351666","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-05 14:43:38', NULL, ''),
(251, 'lois', '{"void_item":{"id":"7746","date":"2016-09-05 19:18:08","ss_terminal":null,"ss_code":null,"sale_id":"2680","si_item_id":"0","item_id":"183","item_sku":"118","item_name":"Plain Rice","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"2.00","margin":"2.0000","cost":"0.0000","amount":"2.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-05 19:18:08","serial":"admin-1473057839-14730742887066849","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-05 21:09:39', NULL, ''),
(252, 'lois', '{"void_item":{"id":"7743","date":"2016-09-05 19:18:08","ss_terminal":null,"ss_code":null,"sale_id":"2680","si_item_id":"0","item_id":"196","item_sku":"131","item_name":"Dinner - Pepper Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-05 19:18:08","serial":"admin-1473057839-14730742887066849","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-05 21:09:54', NULL, ''),
(253, 'lois', '{"void_item":{"id":"7782","date":"2016-09-07 13:00:26","ss_terminal":null,"ss_code":null,"sale_id":"2695","si_item_id":"0","item_id":"72","item_sku":"72","item_name":"Mushroom Chicken","item_option":"without rice","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-07 13:00:26","serial":"admin-1473210396-14732244267237464","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-07 13:14:12', NULL, ''),
(254, 'lois', '{"void_item":{"id":"7838","date":"2016-09-08 10:03:29","ss_terminal":null,"ss_code":null,"sale_id":"2714","si_item_id":null,"item_id":"12","item_sku":"12","item_name":"DD Special","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-08 10:03:29","serial":"admin-1473296496-14733002088487987","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-08 10:03:40', NULL, ''),
(255, 'lois', '{"void_item":{"id":"7837","date":"2016-09-08 10:03:29","ss_terminal":null,"ss_code":null,"sale_id":"2714","si_item_id":null,"item_id":"12","item_sku":"12","item_name":"DD Special","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-08 10:03:29","serial":"admin-1473296496-14733002088487987","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-08 10:03:47', NULL, ''),
(256, 'sanni', '{"void_item":{"id":"7847","date":"2016-09-08 11:29:22","ss_terminal":null,"ss_code":null,"sale_id":"2718","si_item_id":"0","item_id":"156","item_sku":"90","item_name":"Cheese Omelet","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-08 11:29:22","serial":"admin-1473296496-14733053627696083","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-08 12:47:42', NULL, ''),
(257, 'sanni', '{"void_item":{"id":"7846","date":"2016-09-08 11:18:26","ss_terminal":null,"ss_code":null,"sale_id":"2718","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-08 11:18:26","serial":"admin-1473296496-1473304706458699","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-08 12:47:57', NULL, ''),
(258, 'lois', '{"void_item":{"id":"7886","date":"2016-09-08 15:18:13","ss_terminal":null,"ss_code":null,"sale_id":"2725","si_item_id":"0","item_id":"172","item_sku":"106","item_name":"Daily Berries ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-08 15:18:13","serial":"admin-1473310160-1473319092983771","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-08 15:18:31', NULL, ''),
(259, 'lois', '{"void_item":{"id":"7886","date":"2016-09-08 15:18:13","ss_terminal":null,"ss_code":null,"sale_id":"2725","si_item_id":"0","item_id":"172","item_sku":"106","item_name":"Daily Berries ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-08 15:18:13","serial":"admin-1473310160-1473319092983771","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-08 15:18:31', NULL, ''),
(260, 'lois', '{"void_item":{"id":"7895","date":"2016-09-08 16:35:53","ss_terminal":null,"ss_code":null,"sale_id":"2734","si_item_id":null,"item_id":"66","item_sku":"66","item_name":"Watermelon ","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-08 16:35:53","serial":"admin-1473319150-14733237533566892","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-08 16:36:05', NULL, ''),
(261, 'lois', '{"void_item":{"id":"8146","date":"2016-09-11 19:51:12","ss_terminal":null,"ss_code":null,"sale_id":"2826","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-11 19:51:12","serial":"admin-1473583045-1473594672636223","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-11 19:51:29', NULL, ''),
(262, 'lois', '{"void_item":{"id":"8188","date":"2016-09-12 09:59:58","ss_terminal":null,"ss_code":null,"sale_id":"2835","si_item_id":"0","item_id":"170","item_sku":"104","item_name":"Daily Cheese ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-12 09:59:58","serial":"admin-1473641025-14736455984151861","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-12 10:00:41', NULL, ''),
(263, 'lois', '{"void_item":{"id":"8231","date":"2016-09-12 12:43:33","ss_terminal":null,"ss_code":null,"sale_id":"2848","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-12 12:43:33","serial":"admin-1473651429-14736554134064980","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-12 12:43:49', NULL, ''),
(264, 'sanni', '{"void_item":{"id":"8228","date":"2016-09-12 12:42:49","ss_terminal":null,"ss_code":null,"sale_id":"2847","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"plain wholemeal toast","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-12 12:42:49","serial":"admin-1473651429-1473655369029521","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-12 13:43:36', NULL, ''),
(265, 'sanni', '{"void_item":{"id":"8281","date":"2016-09-12 16:19:32","ss_terminal":null,"ss_code":null,"sale_id":"2866","si_item_id":null,"item_id":"33","item_sku":"33","item_name":"Cucumber Lime ","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-12 16:19:32","serial":"admin-1473656393-14736683726554850","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-12 17:28:00', NULL, ''),
(266, 'sanni', '{"void_item":{"id":"8280","date":"2016-09-12 16:19:32","ss_terminal":null,"ss_code":null,"sale_id":"2866","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-12 16:19:32","serial":"admin-1473656393-14736683726554850","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-12 17:28:30', NULL, ''),
(267, 'sanni', '{"sale":{"id":"2866","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-09-12 16:19:22","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1473656393","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-09-12 17:28:54', NULL, ''),
(268, 'lois', '{"sale":{"id":"2875","txn_no":"102787","table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-09-12 19:55:31","payment_status":"Paid","cost":null,"subtotal":"52.00","amount":"52.00","amount_cash":"52.00","amount_cc":null,"amount_tendered":"100.00","amount_change":"48.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1473671172","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"8305","date":"2016-09-12 19:54:49","ss_terminal":null,"ss_code":null,"sale_id":"2875","si_item_id":"0","item_id":"76","item_sku":"76","item_name":"Pesto Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1473671172","ordered_by":"admin","ordered_time":"2016-09-12 19:54:49","serial":"admin-1473671172-1473681289044655","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"8306","date":"2016-09-12 19:54:49","ss_terminal":null,"ss_code":null,"sale_id":"2875","si_item_id":"0","item_id":"75","item_sku":"75","item_name":"Aglio Olio ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1473671172","ordered_by":"admin","ordered_time":"2016-09-12 19:54:49","serial":"admin-1473671172-1473681289044655","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"8307","date":"2016-09-12 19:55:09","ss_terminal":null,"ss_code":null,"sale_id":"2875","si_item_id":null,"item_id":"44","item_sku":"44","item_name":"Tiger ","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1473671172","ordered_by":"admin","ordered_time":"2016-09-12 19:55:09","serial":"admin-1473671172-14736813092589862","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"8308","date":"2016-09-12 19:55:23","ss_terminal":null,"ss_code":null,"sale_id":"2875","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1473671172","ordered_by":"admin","ordered_time":"2016-09-12 19:55:23","serial":"admin-1473671172-14736813228138977","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-09-12 20:09:09', 1, ''),
(269, 'lois', '{"void_item":{"id":"8307","date":"2016-09-12 19:55:09","ss_terminal":null,"ss_code":null,"sale_id":"2875","si_item_id":null,"item_id":"44","item_sku":"44","item_name":"Tiger ","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1473671172","ordered_by":"admin","ordered_time":"2016-09-12 19:55:09","serial":"admin-1473671172-14736813092589862","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-12 20:09:20', NULL, ''),
(270, 'lois', '{"void_item":{"id":"8409","date":"2016-09-15 14:39:27","ss_terminal":null,"ss_code":null,"sale_id":"2906","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"sanni","ordered_time":"2016-09-15 14:39:27","serial":"sanni-1473919465-14739215671584943","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-15 14:40:07', NULL, ''),
(271, 'lois', '{"sale":{"id":"2905","txn_no":null,"table_no":"T13","user_id":"10010","username":"sanni","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-09-15 14:10:24","payment_status":"Unpaid","cost":null,"subtotal":"14.00","amount":"14.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1473919465","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"8408","date":"2016-09-15 14:10:29","ss_terminal":null,"ss_code":null,"sale_id":"2905","si_item_id":null,"item_id":"10","item_sku":"10","item_name":"Dirty Chai","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"sanni","ordered_time":"2016-09-15 14:10:29","serial":"sanni-1473919465-14739198294883366","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-09-15 16:40:18', NULL, ''),
(272, 'lois', '{"void_item":{"id":"8466","date":"2016-09-16 12:53:21","ss_terminal":null,"ss_code":null,"sale_id":"2929","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-16 12:53:21","serial":"admin-1473995493-1474001601515723","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}}', '2016-09-16 12:54:01', NULL, ''),
(273, 'sanni', '{"void_item":{"id":"8504","date":"2016-09-16 16:29:40","ss_terminal":null,"ss_code":null,"sale_id":"2944","si_item_id":null,"item_id":"8","item_sku":"8","item_name":"Caramel Macchiato ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-16 16:29:40","serial":"admin-1474007121-14740145806436653","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-16 16:32:47', NULL, ''),
(274, 'sanni', '{"void_item":{"id":"8526","date":"2016-09-16 19:49:33","ss_terminal":null,"ss_code":null,"sale_id":"2954","si_item_id":"0","item_id":"183","item_sku":"118","item_name":"Plain Rice","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"2.00","margin":"2.0000","cost":"0.0000","amount":"2.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-16 19:49:33","serial":"admin-1474007121-14740265737145578","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-16 20:28:31', NULL, ''),
(275, 'sanni', '{"void_item":{"id":"8525","date":"2016-09-16 19:49:33","ss_terminal":null,"ss_code":null,"sale_id":"2954","si_item_id":"0","item_id":"196","item_sku":"131","item_name":"Dinner - Pepper Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-16 19:49:33","serial":"admin-1474007121-14740265737145578","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-16 20:28:38', NULL, ''),
(276, 'lois', '{"sale":{"id":"2977","txn_no":"102886","table_no":"T12","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-09-17 12:22:56","payment_status":"Paid","cost":null,"subtotal":"23.00","amount":"23.00","amount_cash":"23.00","amount_cc":null,"amount_tendered":"23.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1474085850","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"8603","date":"2016-09-17 12:22:50","ss_terminal":null,"ss_code":null,"sale_id":"2977","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"French Toast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1474085850","ordered_by":"admin","ordered_time":"2016-09-17 12:22:50","serial":"admin-1474085850-14740861699236927","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"8604","date":"2016-09-17 12:22:50","ss_terminal":null,"ss_code":null,"sale_id":"2977","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1474085850","ordered_by":"admin","ordered_time":"2016-09-17 12:22:50","serial":"admin-1474085850-14740861699236927","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-09-17 12:41:14', 1, ''),
(277, 'lois', '{"void_item":{"id":"8603","date":"2016-09-17 12:22:50","ss_terminal":null,"ss_code":null,"sale_id":"2977","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"French Toast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1474085850","ordered_by":"admin","ordered_time":"2016-09-17 12:22:50","serial":"admin-1474085850-14740861699236927","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-17 12:41:23', NULL, ''),
(278, 'sanni', '{"void_item":{"id":"8616","date":"2016-09-17 12:50:34","ss_terminal":null,"ss_code":null,"sale_id":"2980","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-17 12:50:34","serial":"admin-1474085850-14740878339657127","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-17 12:52:18', NULL, ''),
(279, 'lois', '{"void_item":{"id":"8680","date":"2016-09-17 16:23:32","ss_terminal":null,"ss_code":null,"sale_id":"2996","si_item_id":"0","item_id":"170","item_sku":"104","item_name":"Daily Cheese ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-17 16:23:32","serial":"admin-1474091738-14741006127082852","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-17 17:27:31', NULL, ''),
(280, 'lois', '{"void_item":{"id":"8679","date":"2016-09-17 16:23:26","ss_terminal":null,"ss_code":null,"sale_id":"2996","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-17 16:23:26","serial":"admin-1474091738-14741006060575863","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-17 17:27:42', NULL, ''),
(281, 'lois', '{"void_item":{"id":"8693","date":"2016-09-17 17:32:00","ss_terminal":null,"ss_code":null,"sale_id":"3000","si_item_id":"0","item_id":"162","item_sku":"96","item_name":"Chicken Bite ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-17 17:32:00","serial":"admin-1474091738-14741047206921898","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-17 17:32:43', NULL, ''),
(282, 'lois', '{"sale":{"id":"3002","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-09-17 18:05:57","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1474104733","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-09-17 18:07:34', NULL, ''),
(283, 'lois', '{"sale":{"id":"3003","txn_no":null,"table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-09-17 18:07:01","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1474104733","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-09-17 18:07:42', NULL, ''),
(284, 'lois', '{"void_item":{"id":"8860","date":"2016-09-19 13:10:00","ss_terminal":null,"ss_code":null,"sale_id":"3061","si_item_id":null,"item_id":"9","item_sku":"9","item_name":"Affogato","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-19 13:10:00","serial":"admin-1474246590-14742618006176130","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}}', '2016-09-19 13:10:12', NULL, ''),
(285, 'lois', '{"sale":{"id":"3068","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-09-21 11:22:52","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1474419959","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-09-21 15:18:42', NULL, ''),
(286, 'lois', '{"void_item":{"id":"8948","date":"2016-09-22 11:49:41","ss_terminal":null,"ss_code":null,"sale_id":"3090","si_item_id":"0","item_id":"75","item_sku":"75","item_name":"Sauted Mushroom Aglio Olio ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-22 11:49:41","serial":"admin-1474506276-14745161812626068","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-22 13:03:11', NULL, ''),
(287, 'sanni', '{"void_item":{"id":"8996","date":"2016-09-22 17:19:09","ss_terminal":null,"ss_code":null,"sale_id":"3103","si_item_id":"0","item_id":"176","item_sku":"111","item_name":"Scones ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-22 17:19:09","serial":"admin-1474519858-1474535948980240","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-22 17:19:19', NULL, ''),
(288, 'sanni', '{"void_item":{"id":"8995","date":"2016-09-22 17:09:37","ss_terminal":null,"ss_code":null,"sale_id":"3101","si_item_id":"0","item_id":"78","item_sku":"78","item_name":"Baked Mashed Potato","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-22 17:09:37","serial":"admin-1474519858-14745353776876893","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-22 17:30:01', NULL, ''),
(289, 'lois', '{"sale":{"id":"3116","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-09-23 10:55:12","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1474592419","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-09-23 10:56:54', NULL, ''),
(290, 'sanni', '{"void_item":{"id":"9108","date":"2016-09-24 09:34:29","ss_terminal":null,"ss_code":null,"sale_id":"3147","si_item_id":null,"item_id":"25","item_sku":"25","item_name":"Matcha Latte","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-24 09:34:29","serial":"admin-1474678577-14746808697134794","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-24 09:34:57', NULL, ''),
(291, 'lois', '{"void_item":{"id":"9121","date":"2016-09-24 10:24:24","ss_terminal":null,"ss_code":null,"sale_id":"3153","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"House BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-24 10:24:24","serial":"admin-1474680879-14746838644092920","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-24 10:24:37', NULL, ''),
(292, 'sanni', '{"sale":{"id":"3161","txn_no":"103066","table_no":"T13","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-09-24 11:21:26","payment_status":"Paid","cost":null,"subtotal":"50.00","amount":"50.00","amount_cash":"50.00","amount_cc":null,"amount_tendered":"50.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1474687052","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"9151","date":"2016-09-24 11:21:20","ss_terminal":null,"ss_code":null,"sale_id":"3161","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":"1","terminal":"27","printed":"1","session":"1474687052","ordered_by":"admin","ordered_time":"2016-09-24 11:21:20","serial":"admin-1474687052-14746872799917914","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"9152","date":"2016-09-24 11:21:20","ss_terminal":null,"ss_code":null,"sale_id":"3161","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1474687052","ordered_by":"admin","ordered_time":"2016-09-24 11:21:20","serial":"admin-1474687052-14746872799917914","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"9153","date":"2016-09-24 11:21:20","ss_terminal":null,"ss_code":null,"sale_id":"3161","si_item_id":"0","item_id":"163","item_sku":"97","item_name":"Melting Heart ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1474687052","ordered_by":"admin","ordered_time":"2016-09-24 11:21:20","serial":"admin-1474687052-14746872799917914","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"9154","date":"2016-09-24 11:21:20","ss_terminal":null,"ss_code":null,"sale_id":"3161","si_item_id":null,"item_id":"47","item_sku":"47","item_name":"Light coke","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":"1","terminal":"27","printed":"1","session":"1474687052","ordered_by":"admin","ordered_time":"2016-09-24 11:21:20","serial":"admin-1474687052-14746872799917914","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-09-24 11:23:01', 1, ''),
(293, 'sanni', '{"void_item":{"id":"9151","date":"2016-09-24 11:21:20","ss_terminal":null,"ss_code":null,"sale_id":"3161","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":"1","terminal":"27","printed":"1","session":"1474687052","ordered_by":"admin","ordered_time":"2016-09-24 11:21:20","serial":"admin-1474687052-14746872799917914","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-24 11:23:15', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(294, 'lois', '{"sale":{"id":"3159","txn_no":"103070","table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-09-24 11:52:02","payment_status":"Paid","cost":null,"subtotal":"39.00","amount":"39.00","amount_cash":"39.00","amount_cc":null,"amount_tendered":"50.00","amount_change":"11.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1474689107","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"9144","date":"2016-09-24 11:12:51","ss_terminal":null,"ss_code":null,"sale_id":"3159","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":"1","terminal":"27","printed":"1","session":"1474689107","ordered_by":"admin","ordered_time":"2016-09-24 11:12:51","serial":"admin-1474683903-14746867709734175","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"9145","date":"2016-09-24 11:12:51","ss_terminal":null,"ss_code":null,"sale_id":"3159","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1474689107","ordered_by":"admin","ordered_time":"2016-09-24 11:12:51","serial":"admin-1474683903-14746867709734175","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"9146","date":"2016-09-24 11:12:51","ss_terminal":null,"ss_code":null,"sale_id":"3159","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Joyous Sunny ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1474689107","ordered_by":"admin","ordered_time":"2016-09-24 11:12:51","serial":"admin-1474683903-14746867709734175","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"9161","date":"2016-09-24 11:32:28","ss_terminal":null,"ss_code":null,"sale_id":"3159","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":"1","terminal":"27","printed":"1","session":"1474689107","ordered_by":"admin","ordered_time":"2016-09-24 11:32:28","serial":"admin-1474687052-147468794799863","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-09-24 11:54:22', 1, ''),
(295, 'sanni', '{"void_item":{"id":"9171","date":"2016-09-24 12:17:12","ss_terminal":null,"ss_code":null,"sale_id":"3169","si_item_id":"0","item_id":"75","item_sku":"75","item_name":"Sauted Mushroom Aglio Olio ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-24 12:17:12","serial":"admin-1474689107-1474690632673879","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-24 12:18:12', NULL, ''),
(296, 'sanni', '{"void_item":{"id":"9165","date":"2016-09-24 11:53:08","ss_terminal":null,"ss_code":null,"sale_id":"3166","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-24 11:53:08","serial":"admin-1474689107-14746891883834270","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-24 12:25:19', NULL, ''),
(297, 'sanni', '{"void_item":{"id":"9164","date":"2016-09-24 11:53:08","ss_terminal":null,"ss_code":null,"sale_id":"3166","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-24 11:53:08","serial":"admin-1474689107-14746891883834270","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-24 12:25:29', NULL, ''),
(298, 'sanni', '{"sale":{"id":"3166","txn_no":null,"table_no":"T1","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-09-24 11:52:51","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1474689107","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-09-24 12:25:39', NULL, ''),
(299, 'sanni', '{"sale":{"id":"3178","txn_no":"103081","table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-09-24 13:35:51","payment_status":"Paid","cost":null,"subtotal":"20.00","amount":"20.00","amount_cash":"20.00","amount_cc":null,"amount_tendered":"50.00","amount_change":"30.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1474692039","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"9188","date":"2016-09-24 13:35:37","ss_terminal":null,"ss_code":null,"sale_id":"3178","si_item_id":null,"item_id":"36","item_sku":"36","item_name":"Lemon Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1474692039","ordered_by":"admin","ordered_time":"2016-09-24 13:35:37","serial":"admin-1474692039-14746953373787137","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null},{"id":"9189","date":"2016-09-24 13:35:37","ss_terminal":null,"ss_code":null,"sale_id":"3178","si_item_id":null,"item_id":"36","item_sku":"36","item_name":"Lemon Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1474692039","ordered_by":"admin","ordered_time":"2016-09-24 13:35:37","serial":"admin-1474692039-14746953373787137","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}]}', '2016-09-24 13:38:27', 1, ''),
(300, 'sanni', '{"void_item":{"id":"9189","date":"2016-09-24 13:35:37","ss_terminal":null,"ss_code":null,"sale_id":"3178","si_item_id":null,"item_id":"36","item_sku":"36","item_name":"Lemon Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1474692039","ordered_by":"admin","ordered_time":"2016-09-24 13:35:37","serial":"admin-1474692039-14746953373787137","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}}', '2016-09-24 13:38:37', NULL, ''),
(301, 'sanni', '{"void_item":{"id":"9188","date":"2016-09-24 13:35:37","ss_terminal":null,"ss_code":null,"sale_id":"3178","si_item_id":null,"item_id":"36","item_sku":"36","item_name":"Lemon Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1474692039","ordered_by":"admin","ordered_time":"2016-09-24 13:35:37","serial":"admin-1474692039-14746953373787137","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}}', '2016-09-24 13:38:43', NULL, ''),
(302, 'sanni', '{"sale":{"id":"3178","txn_no":"103081","table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-09-24 13:35:51","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":"20.00","amount_cc":null,"amount_tendered":"50.00","amount_change":"30.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1474692039","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-09-24 13:38:52', NULL, ''),
(303, 'lois', '{"void_item":{"id":"9310","date":"2016-09-25 12:26:43","ss_terminal":null,"ss_code":null,"sale_id":"3217","si_item_id":null,"item_id":"62","item_sku":"62","item_name":"Orange","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-25 12:26:43","serial":"admin-1474772709-14747776030561733","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-25 12:27:10', NULL, ''),
(304, 'lois', '{"void_item":{"id":"9369","date":"2016-09-25 14:54:46","ss_terminal":null,"ss_code":null,"sale_id":"3233","si_item_id":"0","item_id":"192","item_sku":"127","item_name":"Stir Fried Hot & Spicy Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-25 14:54:46","serial":"admin-1474781409-14747864861851810","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-25 14:55:51', NULL, ''),
(305, 'sanni', '{"void_item":{"id":"9509","date":"2016-09-28 12:26:04","ss_terminal":null,"ss_code":null,"sale_id":"3280","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"House BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-28 12:26:04","serial":"admin-1475023641-14750367643751637","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-28 12:27:14', NULL, ''),
(306, 'sanni', '{"void_item":{"id":"9600","date":"2016-09-29 18:22:44","ss_terminal":null,"ss_code":null,"sale_id":"3324","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-29 18:22:44","serial":"admin-1475123385-14751445643586059","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-09-29 18:23:15', NULL, ''),
(307, 'lois', '{"void_item":{"id":"9724","date":"2016-10-01 10:57:51","ss_terminal":null,"ss_code":null,"sale_id":"3365","si_item_id":null,"item_id":"68","item_sku":"68","item_name":"Mix 2 types ","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-01 10:57:51","serial":"admin-1475283098-14752906717228738","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-01 10:58:40', NULL, ''),
(308, 'sanni', '{"void_item":{"id":"9803","date":"2016-10-01 19:15:37","ss_terminal":null,"ss_code":null,"sale_id":"3391","si_item_id":null,"item_id":"22","item_sku":"22","item_name":"Honey Milk","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-01 19:15:37","serial":"admin-1475302551-14753205368865166","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-01 19:15:45', NULL, ''),
(309, 'sanni', '{"void_item":{"id":"9802","date":"2016-10-01 19:15:37","ss_terminal":null,"ss_code":null,"sale_id":"3391","si_item_id":null,"item_id":"22","item_sku":"22","item_name":"Honey Milk","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-01 19:15:37","serial":"admin-1475302551-14753205368865166","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-01 19:15:52', NULL, ''),
(310, 'sanni', '{"sale":{"id":"3422","txn_no":"103321","table_no":"T1","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-10-02 14:51:29","payment_status":"Paid","cost":null,"subtotal":"37.00","amount":"37.00","amount_cash":"37.00","amount_cc":null,"amount_tendered":"37.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1475388484","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"9908","date":"2016-10-02 14:51:11","ss_terminal":null,"ss_code":null,"sale_id":"3422","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1475388484","ordered_by":"admin","ordered_time":"2016-10-02 14:51:11","serial":"admin-1475388484-14753910717185214","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"9907","date":"2016-10-02 14:51:11","ss_terminal":null,"ss_code":null,"sale_id":"3422","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1475388484","ordered_by":"admin","ordered_time":"2016-10-02 14:51:11","serial":"admin-1475388484-14753910717185214","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"9906","date":"2016-10-02 14:51:11","ss_terminal":null,"ss_code":null,"sale_id":"3422","si_item_id":"0","item_id":"73","item_sku":"73","item_name":"Marmite Chicken ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1475388484","ordered_by":"admin","ordered_time":"2016-10-02 14:51:11","serial":"admin-1475388484-14753910717185214","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-10-02 14:52:16', 1, ''),
(311, 'sanni', '{"void_item":{"id":"9908","date":"2016-10-02 14:51:11","ss_terminal":null,"ss_code":null,"sale_id":"3422","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1475388484","ordered_by":"admin","ordered_time":"2016-10-02 14:51:11","serial":"admin-1475388484-14753910717185214","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-02 14:52:32', NULL, ''),
(312, 'sanni', '{"void_item":{"id":"9955","date":"2016-10-02 18:13:27","ss_terminal":null,"ss_code":null,"sale_id":"3439","si_item_id":"0","item_id":"222","item_sku":"156","item_name":"Chicken Aglio Olio","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"19.00","margin":"19.0000","cost":"0.0000","amount":"19.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-02 18:13:27","serial":"admin-1475395156-14754032069786387","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-02 18:13:46', NULL, ''),
(313, 'lois', '{"sale":{"id":"3452","txn_no":"103352","table_no":"T5","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-10-03 09:43:31","payment_status":"Paid","cost":null,"subtotal":"58.00","amount":"58.00","amount_cash":"58.00","amount_cc":null,"amount_tendered":"100.00","amount_change":"42.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1475459002","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"9990","date":"2016-10-03 09:43:02","ss_terminal":null,"ss_code":null,"sale_id":"3452","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"French Toast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1475459002","ordered_by":"admin","ordered_time":"2016-10-03 09:43:02","serial":"admin-1475456291-1475458982401549","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"9991","date":"2016-10-03 09:43:02","ss_terminal":null,"ss_code":null,"sale_id":"3452","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":"1","terminal":"27","printed":"1","session":"1475459002","ordered_by":"admin","ordered_time":"2016-10-03 09:43:02","serial":"admin-1475456291-1475458982401549","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"9992","date":"2016-10-03 09:43:02","ss_terminal":null,"ss_code":null,"sale_id":"3452","si_item_id":null,"item_id":"10","item_sku":"10","item_name":"Dirty Chai","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1475459002","ordered_by":"admin","ordered_time":"2016-10-03 09:43:02","serial":"admin-1475456291-1475458982401549","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"9993","date":"2016-10-03 09:43:02","ss_terminal":null,"ss_code":null,"sale_id":"3452","si_item_id":"0","item_id":"18","item_sku":"18","item_name":"Iced Dirty Chai","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1475459002","ordered_by":"admin","ordered_time":"2016-10-03 09:43:02","serial":"admin-1475456291-1475458982401549","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-10-03 10:23:53', 1, ''),
(314, 'lois', '{"void_item":{"id":"9993","date":"2016-10-03 09:43:02","ss_terminal":null,"ss_code":null,"sale_id":"3452","si_item_id":"0","item_id":"18","item_sku":"18","item_name":"Iced Dirty Chai","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1475459002","ordered_by":"admin","ordered_time":"2016-10-03 09:43:02","serial":"admin-1475456291-1475458982401549","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-03 10:24:02', NULL, ''),
(315, 'sanni', '{"sale":{"id":"3481","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-10-05 11:52:15","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1475631304","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-10-05 12:25:29', NULL, ''),
(316, 'lois', '{"void_item":{"id":"10133","date":"2016-10-06 11:51:47","ss_terminal":null,"ss_code":null,"sale_id":"3510","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-06 11:51:47","serial":"admin-1475714739-14757259075654275","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-06 12:05:46', NULL, ''),
(317, 'sanni', '{"void_item":{"id":"10213","date":"2016-10-07 12:53:08","ss_terminal":null,"ss_code":null,"sale_id":"3540","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-07 12:53:08","serial":"admin-1475802181-14758159884822867","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-07 12:54:12', NULL, ''),
(318, 'sanni', '{"void_item":{"id":"10242","date":"2016-10-07 17:43:42","ss_terminal":null,"ss_code":null,"sale_id":"3551","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-07 17:43:42","serial":"admin-1475825142-147583342234886","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-07 20:31:03', NULL, ''),
(319, 'sanni', '{"void_item":{"id":"10246","date":"2016-10-07 18:50:06","ss_terminal":null,"ss_code":null,"sale_id":"3551","si_item_id":"0","item_id":"188","item_sku":"123","item_name":"Sarawak Laksa","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-07 18:50:06","serial":"admin-1475825142-14758374061772165","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-07 20:31:19', NULL, ''),
(320, 'sanni', '{"void_item":{"id":"10247","date":"2016-10-07 18:50:06","ss_terminal":null,"ss_code":null,"sale_id":"3551","si_item_id":"0","item_id":"188","item_sku":"123","item_name":"Sarawak Laksa","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-07 18:50:06","serial":"admin-1475825142-14758374061772165","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-07 20:31:29', NULL, ''),
(321, 'sanni', '{"sale":{"id":"3551","txn_no":null,"table_no":"T5","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-10-07 17:43:38","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1475825142","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-10-07 20:31:45', NULL, ''),
(322, 'sanni', '{"void_item":{"id":"10290","date":"2016-10-08 10:04:56","ss_terminal":null,"ss_code":null,"sale_id":"3568","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-08 10:04:56","serial":"admin-1475888684-14758922968093049","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-08 10:05:21', NULL, ''),
(323, 'sanni', '{"void_item":{"id":"10430","date":"2016-10-09 13:11:04","ss_terminal":null,"ss_code":null,"sale_id":"3615","si_item_id":null,"item_id":"63","item_sku":"63","item_name":"Lime","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-09 13:11:04","serial":"admin-1475987700-1475989863788838","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-09 13:11:19', NULL, ''),
(324, 'lois', '{"void_item":{"id":"10469","date":"2016-10-09 14:10:56","ss_terminal":null,"ss_code":null,"sale_id":"3625","si_item_id":"0","item_id":"162","item_sku":"96","item_name":"Homemade Chicken Bite ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-09 14:10:56","serial":"admin-1475991027-14759934564089893","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-09 14:40:35', NULL, ''),
(325, 'sanni', '{"void_item":{"id":"10545","date":"2016-10-10 12:35:17","ss_terminal":null,"ss_code":null,"sale_id":"3649","si_item_id":null,"item_id":"33","item_sku":"33","item_name":"Cucumber Lime ","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-10 12:35:17","serial":"admin-1476064220-14760741171248848","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-10 13:01:29', NULL, ''),
(326, 'sanni', '{"sale":{"id":"3649","txn_no":null,"table_no":"T8","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-10-10 12:35:11","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1476064220","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-10-10 13:01:38', NULL, ''),
(327, 'sanni', '{"sale":{"id":"3689","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-10-12 19:26:29","payment_status":"Unpaid","cost":null,"subtotal":"17.00","amount":"17.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1476251885","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"10662","date":"2016-10-12 19:26:45","ss_terminal":null,"ss_code":null,"sale_id":"3689","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"BFF","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-12 19:26:45","serial":"admin-1476251885-14762716050681350","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"10663","date":"2016-10-12 19:27:10","ss_terminal":null,"ss_code":null,"sale_id":"3689","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-12 19:27:10","serial":"admin-1476251885-1476271630526570","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-10-12 19:55:51', NULL, ''),
(328, 'sanni', '{"sale":{"id":"3686","txn_no":null,"table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-10-12 17:57:44","payment_status":"Unpaid","cost":null,"subtotal":"36.00","amount":"36.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1476251885","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"10653","date":"2016-10-12 17:57:50","ss_terminal":null,"ss_code":null,"sale_id":"3686","si_item_id":"0","item_id":"16","item_sku":"16","item_name":"Iced Mocha ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-12 17:57:50","serial":"admin-1476251885-14762662699419865","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"10658","date":"2016-10-12 19:06:45","ss_terminal":null,"ss_code":null,"sale_id":"3686","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-12 19:06:45","serial":"admin-1476251885-14762704053898684","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"10654","date":"2016-10-12 17:59:16","ss_terminal":null,"ss_code":null,"sale_id":"3686","si_item_id":"0","item_id":"16","item_sku":"16","item_name":"Iced Mocha ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-12 17:59:16","serial":"admin-1476251885-14762663562697868","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-10-12 19:57:22', NULL, ''),
(329, 'lois', '{"void_item":{"id":"10674","date":"2016-10-12 20:41:28","ss_terminal":null,"ss_code":null,"sale_id":"3692","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-12 20:41:28","serial":"admin-1476273339-1476276087760925","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-12 20:55:11', NULL, ''),
(330, 'lois', '{"sale":{"id":"3692","txn_no":null,"table_no":"T5","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-10-12 20:41:23","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1476273339","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-10-12 20:55:19', NULL, ''),
(331, 'sanni', '{"void_item":{"id":"10750","date":"2016-10-14 13:23:17","ss_terminal":null,"ss_code":null,"sale_id":"3721","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-14 13:23:17","serial":"admin-1476406799-1476422597274963","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-14 13:29:27', NULL, ''),
(332, 'sanni', '{"sale":{"id":"3721","txn_no":"103615","table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-10-14 14:28:11","payment_status":"Paid","cost":null,"subtotal":"89.00","amount":"89.00","amount_cash":"89.00","amount_cc":null,"amount_tendered":"100.00","amount_change":"11.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1476424723","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"10763","date":"2016-10-14 14:24:41","ss_terminal":null,"ss_code":null,"sale_id":"3721","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1476424723","ordered_by":"admin","ordered_time":"2016-10-14 14:24:41","serial":"admin-1476424723-14764262814015283","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"10747","date":"2016-10-14 13:22:11","ss_terminal":null,"ss_code":null,"sale_id":"3721","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1476424723","ordered_by":"admin","ordered_time":"2016-10-14 13:22:11","serial":"admin-1476406799-14764225312767993","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"10748","date":"2016-10-14 13:22:11","ss_terminal":null,"ss_code":null,"sale_id":"3721","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1476424723","ordered_by":"admin","ordered_time":"2016-10-14 13:22:11","serial":"admin-1476406799-14764225312767993","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"10749","date":"2016-10-14 13:23:17","ss_terminal":null,"ss_code":null,"sale_id":"3721","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1476424723","ordered_by":"admin","ordered_time":"2016-10-14 13:23:17","serial":"admin-1476406799-1476422597274963","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"10755","date":"2016-10-14 13:56:29","ss_terminal":null,"ss_code":null,"sale_id":"3721","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1476424723","ordered_by":"admin","ordered_time":"2016-10-14 13:56:29","serial":"admin-1476406799-14764245887829524","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"10754","date":"2016-10-14 13:34:05","ss_terminal":null,"ss_code":null,"sale_id":"3721","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1476424723","ordered_by":"admin","ordered_time":"2016-10-14 13:34:05","serial":"admin-1476406799-14764232452415413","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"10753","date":"2016-10-14 13:33:55","ss_terminal":null,"ss_code":null,"sale_id":"3721","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":"1","terminal":"27","printed":"1","session":"1476424723","ordered_by":"admin","ordered_time":"2016-10-14 13:33:55","serial":"admin-1476406799-14764232352684069","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"10751","date":"2016-10-14 13:23:17","ss_terminal":null,"ss_code":null,"sale_id":"3721","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1476424723","ordered_by":"admin","ordered_time":"2016-10-14 13:23:17","serial":"admin-1476406799-1476422597274963","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-10-14 14:31:10', 1, ''),
(333, 'sanni', '{"void_item":{"id":"10755","date":"2016-10-14 13:56:29","ss_terminal":null,"ss_code":null,"sale_id":"3721","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1476424723","ordered_by":"admin","ordered_time":"2016-10-14 13:56:29","serial":"admin-1476406799-14764245887829524","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-14 14:31:25', NULL, ''),
(334, 'sanni', '{"void_item":{"id":"10856","date":"2016-10-15 12:37:03","ss_terminal":null,"ss_code":null,"sale_id":"3750","si_item_id":"0","item_id":"61","item_sku":"61","item_name":"Slim Fit","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-15 12:37:03","serial":"admin-1476505036-14765062238026948","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-15 12:37:10', NULL, ''),
(335, 'sanni', '{"void_item":{"id":"11001","date":"2016-10-16 12:50:29","ss_terminal":null,"ss_code":null,"sale_id":"3791","si_item_id":null,"item_id":"8","item_sku":"8","item_name":"Caramel Macchiato ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-16 12:50:29","serial":"admin-1476592950-14765934291031847","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-16 12:50:37', NULL, ''),
(336, 'sanni', '{"void_item":{"id":"11049","date":"2016-10-17 12:35:48","ss_terminal":null,"ss_code":null,"sale_id":"3810","si_item_id":"0","item_id":"75","item_sku":"75","item_name":"Meatless Aglio Olio ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-17 12:35:48","serial":"admin-1476666131-1476678948535168","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-17 12:36:13', NULL, ''),
(337, 'sanni', '{"void_item":{"id":"11137","date":"2016-10-19 13:08:55","ss_terminal":null,"ss_code":null,"sale_id":"3833","si_item_id":"0","item_id":"227","item_sku":"161","item_name":"Cranberry Velvet","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-19 13:08:55","serial":"admin-1476853703-14768537350458814","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-19 13:47:37', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(338, 'sanni', '{"sale":{"id":"3855","txn_no":"103749","table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-10-20 13:22:33","payment_status":"Paid","cost":null,"subtotal":"72.00","amount":"72.00","amount_cash":"72.00","amount_cc":null,"amount_tendered":"72.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1476929641","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"11194","date":"2016-10-20 13:17:35","ss_terminal":null,"ss_code":null,"sale_id":"3855","si_item_id":"0","item_id":"220","item_sku":"154","item_name":"Smoked Bacon Basil Pesto","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":"1","terminal":"27","printed":"1","session":"1476929641","ordered_by":"admin","ordered_time":"2016-10-20 13:17:35","serial":"admin-1476929641-14769406551417883","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"11195","date":"2016-10-20 13:17:35","ss_terminal":null,"ss_code":null,"sale_id":"3855","si_item_id":"0","item_id":"212","item_sku":"146","item_name":"Crispy Bacon Salad","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":"1","terminal":"27","printed":"1","session":"1476929641","ordered_by":"admin","ordered_time":"2016-10-20 13:17:35","serial":"admin-1476929641-14769406551417883","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"11196","date":"2016-10-20 13:17:35","ss_terminal":null,"ss_code":null,"sale_id":"3855","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1476929641","ordered_by":"admin","ordered_time":"2016-10-20 13:17:35","serial":"admin-1476929641-14769406551417883","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"11197","date":"2016-10-20 13:22:10","ss_terminal":null,"ss_code":null,"sale_id":"3855","si_item_id":"0","item_id":"222","item_sku":"156","item_name":"Seasoned Chicken Angel Hair","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"19.00","margin":"19.0000","cost":"0.0000","amount":"19.00","sold":"1","terminal":"27","printed":"1","session":"1476929641","ordered_by":"admin","ordered_time":"2016-10-20 13:22:10","serial":"admin-1476929641-14769409302828147","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-10-20 13:35:00', 1, ''),
(339, 'sanni', '{"void_item":{"id":"11195","date":"2016-10-20 13:17:35","ss_terminal":null,"ss_code":null,"sale_id":"3855","si_item_id":"0","item_id":"212","item_sku":"146","item_name":"Crispy Bacon Salad","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":"1","terminal":"27","printed":"1","session":"1476929641","ordered_by":"admin","ordered_time":"2016-10-20 13:17:35","serial":"admin-1476929641-14769406551417883","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-20 13:35:10', NULL, ''),
(340, 'sanni', '{"void_item":{"id":"11207","date":"2016-10-20 14:48:25","ss_terminal":null,"ss_code":null,"sale_id":"3860","si_item_id":null,"item_id":"24","item_sku":"24","item_name":"Chai Latte","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-20 14:48:25","serial":"admin-1476941852-14769461056521236","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-20 14:49:36', NULL, ''),
(341, 'lois', '{"void_item":{"id":"11247","date":"2016-10-21 10:31:54","ss_terminal":null,"ss_code":null,"sale_id":"3876","si_item_id":"0","item_id":"156","item_sku":"90","item_name":"Cheese Omelet","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-21 10:31:54","serial":"admin-1477012120-14770171146049811","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-21 10:42:57', NULL, ''),
(342, 'lois', '{"sale":{"id":"3920","txn_no":null,"table_no":"T14","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-10-22 13:43:10","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1477104610","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-10-22 13:43:27', NULL, ''),
(343, 'sanni', '{"sale":{"id":"3928","txn_no":null,"table_no":"T1","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-10-22 15:12:50","payment_status":"Unpaid","cost":null,"subtotal":"9.00","amount":"9.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1477115932","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"11398","date":"2016-10-22 15:12:56","ss_terminal":null,"ss_code":null,"sale_id":"3928","si_item_id":"0","item_id":"29","item_sku":"29","item_name":"Iced Lemon Tea","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-22 15:12:56","serial":"admin-1477115932-14771203762387956","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-10-22 15:16:52', NULL, ''),
(344, 'sanni', '{"void_item":{"id":"11404","date":"2016-10-22 15:23:34","ss_terminal":null,"ss_code":null,"sale_id":"3930","si_item_id":"0","item_id":"185","item_sku":"120","item_name":"Bottled Water","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-22 15:23:34","serial":"admin-1477115932-14771210138908596","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-22 15:35:06', NULL, ''),
(345, 'sanni', '{"void_item":{"id":"11403","date":"2016-10-22 15:23:34","ss_terminal":null,"ss_code":null,"sale_id":"3930","si_item_id":"0","item_id":"185","item_sku":"120","item_name":"Bottled Water","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-22 15:23:34","serial":"admin-1477115932-14771210138908596","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-22 15:35:14', NULL, ''),
(346, 'sanni', '{"void_item":{"id":"11400","date":"2016-10-22 15:17:16","ss_terminal":null,"ss_code":null,"sale_id":"3922","si_item_id":"0","item_id":"70","item_sku":"70","item_name":"Pepper Pork","item_option":"Takeaway","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-22 15:17:16","serial":"admin-1477115932-14771206366586589","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-22 15:38:28', NULL, ''),
(347, 'sanni', '{"void_item":{"id":"11455","date":"2016-10-22 22:14:05","ss_terminal":null,"ss_code":null,"sale_id":"3950","si_item_id":"0","item_id":"228","item_sku":"162","item_name":"Golden Brown","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-22 22:14:05","serial":"admin-1477129686-14771456457673789","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-22 22:14:33', NULL, ''),
(348, 'sanni', '{"void_item":{"id":"11454","date":"2016-10-22 22:14:05","ss_terminal":null,"ss_code":null,"sale_id":"3950","si_item_id":"0","item_id":"228","item_sku":"162","item_name":"Golden Brown","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-22 22:14:05","serial":"admin-1477129686-14771456457673789","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-22 22:14:40', NULL, ''),
(349, 'sanni', '{"sale":{"id":"3964","txn_no":null,"table_no":"T1","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-10-23 11:02:21","payment_status":"Unpaid","cost":null,"subtotal":"59.00","amount":"59.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1477191161","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"11526","date":"2016-10-23 11:26:22","ss_terminal":null,"ss_code":null,"sale_id":"3964","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-23 11:26:22","serial":"admin-1477191161-14771931827976193","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"11527","date":"2016-10-23 11:27:08","ss_terminal":null,"ss_code":null,"sale_id":"3964","si_item_id":"0","item_id":"159","item_sku":"93","item_name":"Granola ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-23 11:27:08","serial":"admin-1477191161-14771932286688840","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"11517","date":"2016-10-23 11:07:53","ss_terminal":null,"ss_code":null,"sale_id":"3964","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-23 11:07:53","serial":"admin-1477191161-14771920735225386","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"11507","date":"2016-10-23 11:02:29","ss_terminal":null,"ss_code":null,"sale_id":"3964","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-23 11:02:29","serial":"admin-1477191161-1477191749491839","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-10-23 12:02:24', NULL, ''),
(350, 'sanni', '{"void_item":{"id":"11534","date":"2016-10-23 11:42:55","ss_terminal":null,"ss_code":null,"sale_id":"3970","si_item_id":"0","item_id":"32","item_sku":"32","item_name":"Tea By Pot ","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-23 11:42:55","serial":"admin-1477191161-14771941750186095","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-23 12:27:52', NULL, ''),
(351, 'sanni', '{"void_item":{"id":"11589","date":"2016-10-23 13:17:05","ss_terminal":null,"ss_code":null,"sale_id":"3982","si_item_id":"0","item_id":"70","item_sku":"70","item_name":"Pepper Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-23 13:17:05","serial":"admin-1477198892-14771998257287191","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-23 13:18:16', NULL, ''),
(352, 'sanni', '{"void_item":{"id":"11579","date":"2016-10-23 13:08:09","ss_terminal":null,"ss_code":null,"sale_id":"3981","si_item_id":null,"item_id":"1","item_sku":"1","item_name":"Espresso","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-23 13:08:09","serial":"admin-1477198892-14771992892166422","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-23 13:33:49', NULL, ''),
(353, 'lois', '{"sale":{"id":"3989","txn_no":null,"table_no":"T13","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-10-23 14:49:01","payment_status":"Unpaid","cost":null,"subtotal":"17.00","amount":"17.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1477200211","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"11610","date":"2016-10-23 14:49:43","ss_terminal":null,"ss_code":null,"sale_id":"3989","si_item_id":"0","item_id":"14","item_sku":"14","item_name":"Iced Cappuccino ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-23 14:49:43","serial":"admin-1477200211-14772053829202276","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"11609","date":"2016-10-23 14:49:43","ss_terminal":null,"ss_code":null,"sale_id":"3989","si_item_id":null,"item_id":"47","item_sku":"47","item_name":"Light coke","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-23 14:49:43","serial":"admin-1477200211-14772053829202276","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-10-23 20:27:28', NULL, ''),
(354, 'sanni', '{"void_item":{"id":"11689","date":"2016-10-24 11:54:03","ss_terminal":null,"ss_code":null,"sale_id":"4012","si_item_id":"0","item_id":"41","item_sku":"41","item_name":"Blueberry Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-24 11:54:03","serial":"admin-1477279327-14772812428294528","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-24 11:55:55', NULL, ''),
(355, 'lois', '{"void_item":{"id":"11867","date":"2016-10-27 15:19:05","ss_terminal":null,"ss_code":null,"sale_id":"4073","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-27 15:19:05","serial":"admin-1477542726-14775527453147612","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-27 15:19:13', NULL, ''),
(356, 'lois', '{"sale":[],"sale_items":[{"id":"4722","date":"2016-08-02 17:28:20","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-02 17:28:20","serial":"admin-1470120438-14701301006259992","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"4723","date":"2016-08-02 17:28:20","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-02 17:28:20","serial":"admin-1470120438-14701301006259992","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"4724","date":"2016-08-02 17:28:20","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-02 17:28:20","serial":"admin-1470120438-14701301006259992","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"3633","date":"2016-07-19 16:44:35","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":null,"item_id":"44","item_sku":"44","item_name":"Tiger ","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-19 16:44:35","serial":"admin-1468911956-14689178745162299","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"3636","date":"2016-07-19 18:46:02","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":"0","item_id":"42","item_sku":"42","item_name":"Passion Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-19 18:46:02","serial":"admin-1468911956-14689251620097956","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"4277","date":"2016-07-29 17:09:49","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":"0","item_id":"55","item_sku":"55","item_name":"House White (Glass)","item_option":"","category":"Cold Drinks","subcategory":"Wine","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-07-29 17:09:49","serial":"admin-1469752228-1469783389032888","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"5561","date":"2016-08-12 13:01:36","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":"0","item_id":"60","item_sku":"60","item_name":"The Hulk","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"sanni","ordered_time":"2016-08-12 13:01:36","serial":"sanni-1470976926-1470978096754132","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"6002","date":"2016-08-16 12:47:55","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-16 12:47:55","serial":"admin-1471319531-14713228757253348","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"6003","date":"2016-08-16 12:47:55","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-16 12:47:55","serial":"admin-1471319531-14713228757253348","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"7130","date":"2016-08-31 09:28:44","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"House BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-31 09:28:44","serial":"admin-1472605428-14726069244159826","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"8548","date":"2016-09-17 09:33:10","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":"0","item_id":"16","item_sku":"16","item_name":"Iced Mocha ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-17 09:33:10","serial":"admin-1474073436-14740759901495416","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"8549","date":"2016-09-17 09:33:10","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":"0","item_id":"20","item_sku":"20","item_name":"Iced DD Special","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-09-17 09:33:10","serial":"admin-1474073436-14740759901495416","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"7126","date":"2016-08-31 09:28:44","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-31 09:28:44","serial":"admin-1472605428-14726069244159826","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"7127","date":"2016-08-31 09:28:44","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-31 09:28:44","serial":"admin-1472605428-14726069244159826","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"7128","date":"2016-08-31 09:28:44","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-31 09:28:44","serial":"admin-1472605428-14726069244159826","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"7129","date":"2016-08-31 09:28:44","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"House BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-08-31 09:28:44","serial":"admin-1472605428-14726069244159826","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-10-27 16:35:10', NULL, ''),
(357, 'lois', '{"sale":{"id":"4074","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-10-27 16:15:25","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1477542726","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-10-27 16:35:22', NULL, ''),
(358, 'lois', '{"void_item":{"id":"11871","date":"2016-10-27 16:37:41","ss_terminal":null,"ss_code":null,"sale_id":"4075","si_item_id":"0","item_id":"42","item_sku":"42","item_name":"Passion Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-27 16:37:41","serial":"admin-1477542726-14775574614963883","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-27 16:43:38', NULL, ''),
(359, 'sanni', '{"void_item":{"id":"11967","date":"2016-10-28 19:52:39","ss_terminal":null,"ss_code":null,"sale_id":"4107","si_item_id":"0","item_id":"220","item_sku":"154","item_name":"Smoked Bacon Basil Pesto","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-28 19:52:39","serial":"admin-1477635614-14776555592273318","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-28 19:56:57', NULL, ''),
(360, 'sanni', '{"void_item":{"id":"11966","date":"2016-10-28 19:52:39","ss_terminal":null,"ss_code":null,"sale_id":"4107","si_item_id":"0","item_id":"221","item_sku":"155","item_name":"Seasoned Chicken Pesto Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-28 19:52:39","serial":"admin-1477635614-14776555592273318","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-28 19:57:06', NULL, ''),
(361, 'sanni', '{"sale":{"id":"4107","txn_no":null,"table_no":"2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-10-28 19:52:06","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1477635614","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-10-28 20:03:47', NULL, ''),
(362, 'sanni', '{"void_item":{"id":"11969","date":"2016-10-28 20:08:36","ss_terminal":null,"ss_code":null,"sale_id":"4108","si_item_id":null,"item_id":"45","item_sku":"45","item_name":"Soda","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-28 20:08:36","serial":"admin-1477635614-14776565161396121","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-28 20:09:06', NULL, ''),
(363, 'sanni', '{"void_item":{"id":"12111","date":"2016-10-29 14:49:44","ss_terminal":null,"ss_code":null,"sale_id":"4142","si_item_id":"0","item_id":"216","item_sku":"150","item_name":"Chicken In The Blanket","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-29 14:49:44","serial":"admin-1477719603-14777237843673240","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-29 14:50:44', NULL, ''),
(364, 'sanni', '{"void_item":{"id":"12128","date":"2016-10-29 16:28:30","ss_terminal":null,"ss_code":null,"sale_id":"4148","si_item_id":"0","item_id":"176","item_sku":"111","item_name":"Scones ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-29 16:28:30","serial":"admin-1477719603-14777297099933946","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-29 16:33:24', NULL, ''),
(365, 'sanni', '{"void_item":{"id":"12331","date":"2016-10-31 12:41:25","ss_terminal":null,"ss_code":null,"sale_id":"4207","si_item_id":null,"item_id":"66","item_sku":"66","item_name":"Watermelon ","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-31 12:41:25","serial":"admin-1477884683-14778888856784588","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-10-31 12:58:51', NULL, ''),
(366, 'sanni', '{"sale":{"id":"4206","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-10-31 12:08:31","payment_status":"Unpaid","cost":null,"subtotal":"80.00","amount":"80.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1477884683","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"12312","date":"2016-10-31 12:08:42","ss_terminal":null,"ss_code":null,"sale_id":"4206","si_item_id":"0","item_id":"213","item_sku":"147","item_name":"Set Lemony Chicken","item_option":"","category":"Meals","subcategory":"Set Lunch","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-31 12:08:42","serial":"admin-1477884683-1477886922565759","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"12313","date":"2016-10-31 12:08:42","ss_terminal":null,"ss_code":null,"sale_id":"4206","si_item_id":"0","item_id":"82","item_sku":"82","item_name":"Set Rice Wine Ginger Pork","item_option":"","category":"Meals","subcategory":"Set Lunch","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-31 12:08:42","serial":"admin-1477884683-1477886922565759","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"12314","date":"2016-10-31 12:08:42","ss_terminal":null,"ss_code":null,"sale_id":"4206","si_item_id":"0","item_id":"82","item_sku":"82","item_name":"Set Rice Wine Ginger Pork","item_option":"","category":"Meals","subcategory":"Set Lunch","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-31 12:08:42","serial":"admin-1477884683-1477886922565759","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"12315","date":"2016-10-31 12:08:42","ss_terminal":null,"ss_code":null,"sale_id":"4206","si_item_id":"0","item_id":"214","item_sku":"148","item_name":"Set Hot & Spicy Pork","item_option":"","category":"Meals","subcategory":"Set Lunch","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-31 12:08:42","serial":"admin-1477884683-1477886922565759","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-10-31 14:12:49', NULL, ''),
(367, 'lois', '{"sale":{"id":"4224","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-10-31 17:26:59","payment_status":"Unpaid","cost":null,"subtotal":"11.00","amount":"11.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1477892543","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"12381","date":"2016-10-31 17:27:02","ss_terminal":null,"ss_code":null,"sale_id":"4224","si_item_id":null,"item_id":"9","item_sku":"9","item_name":"Affogato","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-31 17:27:02","serial":"admin-1477892543-14779060226392397","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}]}', '2016-10-31 17:27:43', NULL, ''),
(368, 'lois', '{"sale":{"id":"4241","txn_no":null,"table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-11-02 14:27:58","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1478063098","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-11-02 14:30:00', NULL, ''),
(369, 'sanni', '{"void_item":{"id":"12474","date":"2016-11-03 13:13:30","ss_terminal":null,"ss_code":null,"sale_id":"4260","si_item_id":"0","item_id":"230","item_sku":"164","item_name":"Coffee Cheese","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-03 13:13:30","serial":"admin-1478135267-14781500098608018","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-03 13:29:34', NULL, ''),
(370, 'sanni', '{"void_item":{"id":"12492","date":"2016-11-03 17:20:17","ss_terminal":null,"ss_code":null,"sale_id":"4265","si_item_id":"0","item_id":"170","item_sku":"104","item_name":"Daily Cheese ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-03 17:20:17","serial":"admin-1478135267-14781648168609788","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-03 17:25:38', NULL, ''),
(371, 'lois', '{"void_item":{"id":"12547","date":"2016-11-04 13:39:00","ss_terminal":null,"ss_code":null,"sale_id":"4278","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-04 13:39:00","serial":"admin-1478229899-14782379406107678","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-04 13:43:34', NULL, ''),
(372, 'lois', '{"void_item":{"id":"12563","date":"2016-11-04 14:45:19","ss_terminal":null,"ss_code":null,"sale_id":"4284","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"cheesy bacon toast is take away","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-04 14:45:19","serial":"admin-1478239163-14782419190207081","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-04 14:50:18', NULL, ''),
(373, 'sanni', '{"void_item":{"id":"12569","date":"2016-11-04 14:50:55","ss_terminal":null,"ss_code":null,"sale_id":"4284","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-04 14:50:55","serial":"admin-1478239163-14782422556519532","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-04 14:51:23', NULL, ''),
(374, 'sanni', '{"void_item":{"id":"12618","date":"2016-11-05 10:07:11","ss_terminal":null,"ss_code":null,"sale_id":"4304","si_item_id":null,"item_id":"1","item_sku":"1","item_name":"Espresso","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-05 10:07:11","serial":"admin-1478307790-14783116310195088","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-05 10:07:29', NULL, ''),
(375, 'sanni', '{"void_item":{"id":"12617","date":"2016-11-05 10:07:11","ss_terminal":null,"ss_code":null,"sale_id":"4304","si_item_id":null,"item_id":"2","item_sku":"2","item_name":"Macchiato ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-05 10:07:11","serial":"admin-1478307790-14783116310195088","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-05 10:07:41', NULL, ''),
(376, 'lois', '{"sale":{"id":"4305","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-11-05 10:15:49","payment_status":"Unpaid","cost":null,"subtotal":"15.00","amount":"15.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1478307790","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"12621","date":"2016-11-05 10:15:54","ss_terminal":null,"ss_code":null,"sale_id":"4305","si_item_id":"0","item_id":"19","item_sku":"19","item_name":"Iced Vanilla Latte","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-05 10:15:54","serial":"admin-1478307790-14783121540536494","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-11-05 10:25:02', NULL, ''),
(377, 'lois', '{"void_item":{"id":"12653","date":"2016-11-05 11:47:12","ss_terminal":null,"ss_code":null,"sale_id":"4315","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-05 11:47:12","serial":"admin-1478315211-14783176324404799","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-05 11:47:25', NULL, ''),
(378, 'lois', '{"void_item":{"id":"12744","date":"2016-11-06 10:39:16","ss_terminal":null,"ss_code":null,"sale_id":"4342","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-06 10:39:16","serial":"admin-1478396082-14783999558714336","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-06 11:45:42', NULL, ''),
(379, 'lois', '{"void_item":{"id":"12767","date":"2016-11-06 11:45:54","ss_terminal":null,"ss_code":null,"sale_id":"4342","si_item_id":null,"item_id":"12","item_sku":"12","item_name":"DD Special","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-06 11:45:54","serial":"admin-1478402088-1478403954772324","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-06 11:46:30', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(380, 'sanni', '{"void_item":{"id":"12827","date":"2016-11-06 18:19:49","ss_terminal":null,"ss_code":null,"sale_id":"4362","si_item_id":"0","item_id":"220","item_sku":"154","item_name":"Smoked Bacon Basil Pesto","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-06 18:19:49","serial":"admin-1478407929-14784275892085430","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-06 18:22:21', NULL, ''),
(381, 'sanni', '{"void_item":{"id":"12832","date":"2016-11-06 18:26:30","ss_terminal":null,"ss_code":null,"sale_id":"4363","si_item_id":"0","item_id":"226","item_sku":"160","item_name":"Cheesy Shepherd Pie","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-06 18:26:30","serial":"admin-1478407929-14784279907577619","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-06 18:27:45', NULL, ''),
(382, 'sanni', '{"void_item":{"id":"12880","date":"2016-11-07 16:04:06","ss_terminal":null,"ss_code":null,"sale_id":"4379","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-07 16:04:06","serial":"admin-1478491786-14785058458433264","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-07 16:09:27', NULL, ''),
(383, 'sanni', '{"void_item":{"id":"12895","date":"2016-11-07 19:14:20","ss_terminal":null,"ss_code":null,"sale_id":"4384","si_item_id":null,"item_id":"47","item_sku":"47","item_name":"Light coke","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-07 19:14:20","serial":"admin-1478491786-14785172607315750","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-07 19:15:23', NULL, ''),
(384, 'lois', '{"sale":{"id":"4391","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-11-09 11:20:04","payment_status":"Unpaid","cost":null,"subtotal":"64.00","amount":"64.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1478660244","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"12927","date":"2016-11-09 11:20:21","ss_terminal":null,"ss_code":null,"sale_id":"4391","si_item_id":"0","item_id":"224","item_sku":"158","item_name":"Set Garlic Pork","item_option":"","category":"Meals","subcategory":"Set Lunch","qty":"1","price_per_unit":"22.00","margin":"22.0000","cost":"0.0000","amount":"22.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-09 11:20:21","serial":"admin-1478660244-1478661620887706","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"12928","date":"2016-11-09 11:21:14","ss_terminal":null,"ss_code":null,"sale_id":"4391","si_item_id":"0","item_id":"86","item_sku":"86","item_name":"Set Pesto Pasta ","item_option":"","category":"Meals","subcategory":"Set Lunch","qty":"1","price_per_unit":"22.00","margin":"22.0000","cost":"0.0000","amount":"22.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-09 11:21:14","serial":"admin-1478660244-14786616740985394","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"12926","date":"2016-11-09 11:20:21","ss_terminal":null,"ss_code":null,"sale_id":"4391","si_item_id":"0","item_id":"86","item_sku":"86","item_name":"Pesto Pasta ","item_option":"","category":"Meals","subcategory":"Set Lunch","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-09 11:20:21","serial":"admin-1478660244-1478661620887706","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-11-09 11:21:21', NULL, ''),
(385, 'lois', '{"void_item":{"id":"13019","date":"2016-11-10 15:29:46","ss_terminal":null,"ss_code":null,"sale_id":"4423","si_item_id":null,"item_id":"7","item_sku":"7","item_name":"Mocha ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-10 15:29:46","serial":"admin-1478739804-14787629858762875","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-10 15:39:03', NULL, ''),
(386, 'lois', '{"sale":{"id":"4424","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-11-10 15:47:42","payment_status":"Unpaid","cost":null,"subtotal":"6.00","amount":"6.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1478739804","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"13021","date":"2016-11-10 15:47:45","ss_terminal":null,"ss_code":null,"sale_id":"4424","si_item_id":null,"item_id":"1","item_sku":"1","item_name":"Espresso","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-10 15:47:45","serial":"admin-1478739804-14787640653941850","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-11-10 15:55:06', NULL, ''),
(387, 'lois', '{"void_item":{"id":"13023","date":"2016-11-10 15:51:23","ss_terminal":null,"ss_code":null,"sale_id":"4425","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-10 15:51:23","serial":"admin-1478739804-14787642828761221","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-10 15:55:26', NULL, ''),
(388, 'sanni', '{"sale":{"id":"4458","txn_no":"104335","table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-11-12 11:05:00","payment_status":"Paid","cost":null,"subtotal":"33.00","amount":"33.00","amount_cash":"33.00","amount_cc":null,"amount_tendered":"53.00","amount_change":"20.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1478911379","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"13129","date":"2016-11-12 11:04:41","ss_terminal":null,"ss_code":null,"sale_id":"4458","si_item_id":null,"item_id":"9","item_sku":"9","item_name":"Affogato","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1478911379","ordered_by":"admin","ordered_time":"2016-11-12 11:04:41","serial":"admin-1478911379-1478919880817354","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"13128","date":"2016-11-12 11:04:08","ss_terminal":null,"ss_code":null,"sale_id":"4458","si_item_id":"0","item_id":"165","item_sku":"99","item_name":"Ice-Cream","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":"1","terminal":"27","printed":"1","session":"1478911379","ordered_by":"admin","ordered_time":"2016-11-12 11:04:08","serial":"admin-1478911379-147891984807332","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"13127","date":"2016-11-12 11:04:08","ss_terminal":null,"ss_code":null,"sale_id":"4458","si_item_id":null,"item_id":"9","item_sku":"9","item_name":"Affogato","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1478911379","ordered_by":"admin","ordered_time":"2016-11-12 11:04:08","serial":"admin-1478911379-147891984807332","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"13126","date":"2016-11-12 11:04:08","ss_terminal":null,"ss_code":null,"sale_id":"4458","si_item_id":null,"item_id":"1","item_sku":"1","item_name":"Espresso","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":"1","terminal":"27","printed":"1","session":"1478911379","ordered_by":"admin","ordered_time":"2016-11-12 11:04:08","serial":"admin-1478911379-147891984807332","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-11-12 11:14:04', 1, ''),
(389, 'sanni', '{"void_item":{"id":"13126","date":"2016-11-12 11:04:08","ss_terminal":null,"ss_code":null,"sale_id":"4458","si_item_id":null,"item_id":"1","item_sku":"1","item_name":"Espresso","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":"1","terminal":"27","printed":"1","session":"1478911379","ordered_by":"admin","ordered_time":"2016-11-12 11:04:08","serial":"admin-1478911379-147891984807332","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-12 11:14:14', NULL, ''),
(390, 'lois', '{"void_item":{"id":"13211","date":"2016-11-12 20:21:18","ss_terminal":null,"ss_code":null,"sale_id":"4487","si_item_id":"0","item_id":"223","item_sku":"157","item_name":"Crispy Bacon Angel Hair","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"19.00","margin":"19.0000","cost":"0.0000","amount":"19.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-12 20:21:18","serial":"admin-1478936667-14789532784617075","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-12 20:43:18', NULL, ''),
(391, 'lois', '{"void_item":{"id":"13229","date":"2016-11-12 21:00:42","ss_terminal":null,"ss_code":null,"sale_id":"4490","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-12 21:00:42","serial":"admin-1478936667-14789556423589846","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-12 21:01:10', NULL, ''),
(392, 'sanni', '{"void_item":{"id":"13312","date":"2016-11-13 13:36:14","ss_terminal":null,"ss_code":null,"sale_id":"4512","si_item_id":null,"item_id":"1","item_sku":"1","item_name":"Espresso","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-13 13:36:14","serial":"admin-1479010921-14790153741366427","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-13 13:36:43', NULL, ''),
(393, 'lois', '{"void_item":{"id":"13370","date":"2016-11-14 12:29:28","ss_terminal":null,"ss_code":null,"sale_id":"4532","si_item_id":"0","item_id":"80","item_sku":"80","item_name":"Oriental Chicken Salad","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-14 12:29:28","serial":"admin-1479094199-14790977685296222","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-14 12:32:33', NULL, ''),
(394, 'sanni', '{"void_item":{"id":"13389","date":"2016-11-14 15:13:13","ss_terminal":null,"ss_code":null,"sale_id":"4540","si_item_id":"0","item_id":"30","item_sku":"30","item_name":"Iced Chai Latte","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-14 15:13:13","serial":"admin-1479097840-1479107593015165","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-14 15:13:21', NULL, ''),
(395, 'sanni', '{"void_item":{"id":"13408","date":"2016-11-14 19:23:01","ss_terminal":null,"ss_code":null,"sale_id":"4545","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-14 19:23:01","serial":"admin-1479097840-14791225816401653","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-14 19:24:00', NULL, ''),
(396, 'sanni', '{"sale":{"id":"4550","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-11-16 10:43:48","payment_status":"Unpaid","cost":null,"subtotal":"11.00","amount":"11.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1479260187","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"13440","date":"2016-11-16 10:43:52","ss_terminal":null,"ss_code":null,"sale_id":"4550","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-16 10:43:52","serial":"admin-1479260187-14792642318514687","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-11-16 12:44:45', NULL, ''),
(397, 'sanni', '{"void_item":{"id":"13499","date":"2016-11-16 15:51:02","ss_terminal":null,"ss_code":null,"sale_id":"4574","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"French Toast with Fruits","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-16 15:51:02","serial":"admin-1479282653-14792826627372952","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-16 16:46:53', NULL, ''),
(398, 'sanni', '{"void_item":{"id":"13516","date":"2016-11-17 13:10:24","ss_terminal":null,"ss_code":null,"sale_id":"4582","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-17 13:10:24","serial":"admin-1479353349-14793594239923258","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-17 13:12:49', NULL, ''),
(399, 'lois', '{"void_item":{"id":"13600","date":"2016-11-18 18:55:19","ss_terminal":null,"ss_code":null,"sale_id":"4612","si_item_id":"0","item_id":"231","item_sku":"165","item_name":"Hometown Fried Rice","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-18 18:55:19","serial":"admin-1479439074-14794665192843324","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-18 18:55:27', NULL, ''),
(400, 'lois', '{"sale":[],"sale_items":[{"id":"12391","date":"2016-10-31 17:52:04","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":null,"item_id":"34","item_sku":"34","item_name":"Ginger Lemongrass ","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-31 17:52:04","serial":"admin-1477892543-1477907524596295","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"12390","date":"2016-10-31 17:52:04","ss_terminal":null,"ss_code":null,"sale_id":"0","si_item_id":null,"item_id":"9","item_sku":"9","item_name":"Affogato","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-10-31 17:52:04","serial":"admin-1477892543-1477907524596295","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-11-18 19:08:38', NULL, ''),
(401, 'lois', '{"sale":{"id":"4612","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-11-18 18:55:09","payment_status":"Unpaid","cost":null,"subtotal":"15.00","amount":"15.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1479439074","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"13601","date":"2016-11-18 18:56:02","ss_terminal":null,"ss_code":null,"sale_id":"4612","si_item_id":"0","item_id":"229","item_sku":"163","item_name":"Mummy''s Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-18 18:56:02","serial":"admin-1479439074-14794665625315295","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-11-18 19:08:47', NULL, ''),
(402, 'sanni', '{"sale":{"id":"4666","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-11-20 13:27:25","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1479619611","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-11-20 13:27:36', NULL, ''),
(403, 'sanni', '{"void_item":{"id":"13819","date":"2016-11-20 14:44:58","ss_terminal":null,"ss_code":null,"sale_id":"4671","si_item_id":null,"item_id":"10","item_sku":"10","item_name":"Dirty Chai","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-20 14:44:58","serial":"admin-1479619611-14796242981235046","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-20 14:45:26', NULL, ''),
(404, 'sanni', '{"void_item":{"id":"13908","date":"2016-11-21 13:00:18","ss_terminal":null,"ss_code":null,"sale_id":"4696","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-21 13:00:18","serial":"admin-1479704386-14797044181961282","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-21 13:13:25', NULL, ''),
(405, 'lois', '{"void_item":{"id":"13933","date":"2016-11-21 13:55:46","ss_terminal":null,"ss_code":null,"sale_id":"4698","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-21 13:55:46","serial":"admin-1479706880-14797077463127380","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-21 14:05:01', NULL, ''),
(406, 'lois', '{"void_item":{"id":"13996","date":"2016-11-21 19:58:43","ss_terminal":null,"ss_code":null,"sale_id":"4720","si_item_id":"0","item_id":"238","item_sku":"172","item_name":"Caramel Chocolate","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-21 19:58:43","serial":"admin-1479727483-1479729523274363","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-21 19:58:52', NULL, ''),
(407, 'lois', '{"void_item":{"id":"14010","date":"2016-11-23 10:29:02","ss_terminal":null,"ss_code":null,"sale_id":"4724","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Joyous Sunny ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-23 10:29:02","serial":"admin-1479862626-14798681425199332","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-23 10:30:37', NULL, ''),
(408, 'sanni', '{"void_item":{"id":"14094","date":"2016-11-24 17:39:06","ss_terminal":null,"ss_code":null,"sale_id":"4756","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-24 17:39:06","serial":"admin-1479962919-14799803460352188","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-24 20:23:03', NULL, ''),
(409, 'sanni', '{"void_item":{"id":"14184","date":"2016-11-26 09:31:29","ss_terminal":null,"ss_code":null,"sale_id":"4785","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Joyous Sunny ","item_option":"egg welldone","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-26 09:31:29","serial":"admin-1480119748-14801238895216614","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-26 09:32:32', NULL, ''),
(410, 'sanni', '{"sale":{"id":"4816","txn_no":null,"table_no":"T10","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-11-26 18:25:57","payment_status":"Unpaid","cost":null,"subtotal":"6.00","amount":"6.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1480147699","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"14298","date":"2016-11-26 18:26:08","ss_terminal":null,"ss_code":null,"sale_id":"4816","si_item_id":null,"item_id":"1","item_sku":"1","item_name":"Espresso","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-26 18:26:08","serial":"admin-1480147699-14801559682002661","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-11-26 18:27:10', NULL, ''),
(411, 'sanni', '{"void_item":{"id":"14403","date":"2016-11-28 14:37:50","ss_terminal":null,"ss_code":null,"sale_id":"4857","si_item_id":"0","item_id":"55","item_sku":"55","item_name":"House White (Glass)","item_option":"","category":"Cold Drinks","subcategory":"Wine","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-11-28 14:37:50","serial":"admin-1480307144-14803150698381593","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-11-28 14:46:11', NULL, ''),
(412, 'sanni', '{"void_item":{"id":"14462","date":"2016-12-01 10:51:37","ss_terminal":null,"ss_code":null,"sale_id":"4871","si_item_id":null,"item_id":"9","item_sku":"9","item_name":"Affogato","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-01 10:51:37","serial":"admin-1480559541-14805606968458449","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-01 10:54:20', NULL, ''),
(413, 'sanni', '{"sale":{"id":"4887","txn_no":"104755","table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-12-01 19:20:38","payment_status":"Paid","cost":null,"subtotal":"50.00","amount":"50.00","amount_cash":"50.00","amount_cc":null,"amount_tendered":"50.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1480570745","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"14508","date":"2016-12-01 18:55:00","ss_terminal":null,"ss_code":null,"sale_id":"4887","si_item_id":"0","item_id":"56","item_sku":"56","item_name":"House red (Glass)","item_option":"","category":"Cold Drinks","subcategory":"Wine","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":"1","terminal":"27","printed":"1","session":"1480570745","ordered_by":"admin","ordered_time":"2016-12-01 18:55:00","serial":"admin-1480570745-14805897001755311","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"14510","date":"2016-12-01 18:55:00","ss_terminal":null,"ss_code":null,"sale_id":"4887","si_item_id":"0","item_id":"172","item_sku":"106","item_name":"Daily Berries ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1480570745","ordered_by":"admin","ordered_time":"2016-12-01 18:55:00","serial":"admin-1480570745-14805897001755311","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"14509","date":"2016-12-01 18:55:00","ss_terminal":null,"ss_code":null,"sale_id":"4887","si_item_id":"0","item_id":"56","item_sku":"56","item_name":"House red (Glass)","item_option":"","category":"Cold Drinks","subcategory":"Wine","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":"1","terminal":"27","printed":"1","session":"1480570745","ordered_by":"admin","ordered_time":"2016-12-01 18:55:00","serial":"admin-1480570745-14805897001755311","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-12-01 19:21:43', 1, ''),
(414, 'sanni', '{"sale":{"id":"4902","txn_no":"104775","table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-12-02 13:56:49","payment_status":"Paid","cost":null,"subtotal":"82.00","amount":"82.00","amount_cash":"82.00","amount_cc":null,"amount_tendered":"82.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1480656735","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"14555","date":"2016-12-02 13:21:01","ss_terminal":null,"ss_code":null,"sale_id":"4902","si_item_id":"0","item_id":"75","item_sku":"75","item_name":"Meatless Aglio Olio ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1480656735","ordered_by":"admin","ordered_time":"2016-12-02 13:21:01","serial":"admin-1480654444-14806560613843071","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"14556","date":"2016-12-02 13:21:01","ss_terminal":null,"ss_code":null,"sale_id":"4902","si_item_id":"0","item_id":"74","item_sku":"74","item_name":"Sunrice","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1480656735","ordered_by":"admin","ordered_time":"2016-12-02 13:21:01","serial":"admin-1480654444-14806560613843071","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"14557","date":"2016-12-02 13:21:20","ss_terminal":null,"ss_code":null,"sale_id":"4902","si_item_id":null,"item_id":"62","item_sku":"62","item_name":"Orange","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1480656735","ordered_by":"admin","ordered_time":"2016-12-02 13:21:20","serial":"admin-1480654444-14806560805527513","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"14558","date":"2016-12-02 13:21:20","ss_terminal":null,"ss_code":null,"sale_id":"4902","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1480656735","ordered_by":"admin","ordered_time":"2016-12-02 13:21:20","serial":"admin-1480654444-14806560805527513","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"14562","date":"2016-12-02 13:30:35","ss_terminal":null,"ss_code":null,"sale_id":"4902","si_item_id":"0","item_id":"222","item_sku":"156","item_name":"Seasoned Chicken Aglio Olio","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":"1","terminal":"27","printed":"1","session":"1480656735","ordered_by":"admin","ordered_time":"2016-12-02 13:30:35","serial":"admin-1480654444-14806566356654082","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"14554","date":"2016-12-02 13:20:08","ss_terminal":null,"ss_code":null,"sale_id":"4902","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"French Toast with Fruits","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1480656735","ordered_by":"admin","ordered_time":"2016-12-02 13:20:08","serial":"admin-1480654444-14806560084107874","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-12-02 13:57:08', 1, ''),
(415, 'lois', '{"void_item":{"id":"14571","date":"2016-12-02 14:35:10","ss_terminal":null,"ss_code":null,"sale_id":"4909","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-02 14:35:10","serial":"admin-1480656735-1480660510150123","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-02 14:35:20', NULL, ''),
(416, 'sanni', '{"void_item":{"id":"14691","date":"2016-12-03 19:07:48","ss_terminal":null,"ss_code":null,"sale_id":"4946","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-03 19:07:48","serial":"admin-1480759619-1480763267933881","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-03 19:08:15', NULL, ''),
(417, 'sanni', '{"void_item":{"id":"14737","date":"2016-12-04 10:36:31","ss_terminal":null,"ss_code":null,"sale_id":"4963","si_item_id":null,"item_id":"34","item_sku":"34","item_name":"Ginger Lemongrass ","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-04 10:36:31","serial":"admin-1480813323-14808189914654415","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-04 10:43:12', NULL, ''),
(418, 'lois', '{"void_item":{"id":"14781","date":"2016-12-04 12:41:03","ss_terminal":null,"ss_code":null,"sale_id":"4970","si_item_id":"0","item_id":"19","item_sku":"19","item_name":"Iced Vanilla Latte","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-04 12:41:03","serial":"admin-1480826222-1480826462857242","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-04 12:41:18', NULL, ''),
(419, 'sanni', '{"void_item":{"id":"14831","date":"2016-12-04 15:45:50","ss_terminal":null,"ss_code":null,"sale_id":"4982","si_item_id":"0","item_id":"234","item_sku":"168","item_name":"Naughty Boy","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-04 15:45:50","serial":"admin-1480826222-14808375503117113","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-04 15:46:16', NULL, ''),
(420, 'lois', '{"sale":{"id":"5001","txn_no":"104874","table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-12-05 14:57:28","payment_status":"Paid","cost":null,"subtotal":"72.00","amount":"72.00","amount_cash":"72.00","amount_cc":null,"amount_tendered":"100.00","amount_change":"28.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1480920160","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"14895","date":"2016-12-05 13:49:19","ss_terminal":null,"ss_code":null,"sale_id":"5001","si_item_id":"0","item_id":"163","item_sku":"97","item_name":"Melting Heart ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1480920160","ordered_by":"admin","ordered_time":"2016-12-05 13:49:19","serial":"admin-1480899050-1480916958857110","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"14894","date":"2016-12-05 13:49:19","ss_terminal":null,"ss_code":null,"sale_id":"5001","si_item_id":"0","item_id":"86","item_sku":"86","item_name":"Set Pesto Pasta ","item_option":"","category":"Meals","subcategory":"Set Lunch","qty":"1","price_per_unit":"22.00","margin":"22.0000","cost":"0.0000","amount":"22.00","sold":"1","terminal":"27","printed":"1","session":"1480920160","ordered_by":"admin","ordered_time":"2016-12-05 13:49:19","serial":"admin-1480899050-1480916958857110","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"14889","date":"2016-12-05 13:27:15","ss_terminal":null,"ss_code":null,"sale_id":"5001","si_item_id":"0","item_id":"172","item_sku":"106","item_name":"Daily Berries ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1480920160","ordered_by":"admin","ordered_time":"2016-12-05 13:27:15","serial":"admin-1480899050-14809156353717296","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"14885","date":"2016-12-05 13:24:14","ss_terminal":null,"ss_code":null,"sale_id":"5001","si_item_id":"0","item_id":"38","item_sku":"38","item_name":"Mixed Berries Smoothie","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1480920160","ordered_by":"admin","ordered_time":"2016-12-05 13:24:14","serial":"admin-1480899050-14809154545826320","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"14884","date":"2016-12-05 13:24:14","ss_terminal":null,"ss_code":null,"sale_id":"5001","si_item_id":"0","item_id":"20","item_sku":"20","item_name":"Iced DD Special","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1480920160","ordered_by":"admin","ordered_time":"2016-12-05 13:24:14","serial":"admin-1480899050-14809154545826320","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-12-05 15:09:19', 1, ''),
(421, 'lois', '{"void_item":{"id":"14895","date":"2016-12-05 13:49:19","ss_terminal":null,"ss_code":null,"sale_id":"5001","si_item_id":"0","item_id":"163","item_sku":"97","item_name":"Melting Heart ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1480920160","ordered_by":"admin","ordered_time":"2016-12-05 13:49:19","serial":"admin-1480899050-1480916958857110","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-05 15:09:28', NULL, ''),
(422, 'sanni', '{"void_item":{"id":"15032","date":"2016-12-09 14:09:30","ss_terminal":null,"ss_code":null,"sale_id":"5059","si_item_id":null,"item_id":"26","item_sku":"26","item_name":"Tea By Cup","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-09 14:09:30","serial":"admin-1481245064-14812637699701936","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-09 14:09:40', NULL, ''),
(423, 'lois', '{"void_item":{"id":"15148","date":"2016-12-10 14:15:37","ss_terminal":null,"ss_code":null,"sale_id":"5092","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"Fried Vege","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-10 14:15:37","serial":"admin-1481349068-14813505377756013","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-10 14:30:02', NULL, ''),
(424, 'sanni', '{"void_item":{"id":"15164","date":"2016-12-10 16:28:25","ss_terminal":null,"ss_code":null,"sale_id":"5090","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-10 16:28:25","serial":"admin-1481349068-14813585048403728","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-10 18:33:44', NULL, ''),
(425, 'sanni', '{"void_item":{"id":"15192","date":"2016-12-11 12:30:57","ss_terminal":null,"ss_code":null,"sale_id":"5108","si_item_id":"0","item_id":"71","item_sku":"71","item_name":"Rice Wine Ginger Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-11 12:30:57","serial":"admin-1481417882-14814306570613140","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-11 12:45:16', NULL, ''),
(426, 'sanni', '{"void_item":{"id":"15203","date":"2016-12-11 13:11:08","ss_terminal":null,"ss_code":null,"sale_id":"5108","si_item_id":"0","item_id":"170","item_sku":"104","item_name":"Daily Cheese ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-11 13:11:08","serial":"admin-1481431060-14814330679781799","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-11 13:33:09', NULL, ''),
(427, 'sanni', '{"void_item":{"id":"15343","date":"2016-12-12 11:24:18","ss_terminal":null,"ss_code":null,"sale_id":"5145","si_item_id":"0","item_id":"78","item_sku":"78","item_name":"Cheesy Baked Mashed Potato","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-12 11:24:18","serial":"admin-1481511523-14815130585776522","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-12 11:40:54', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(428, 'sanni', '{"void_item":{"id":"15407","date":"2016-12-12 12:45:05","ss_terminal":null,"ss_code":null,"sale_id":"5150","si_item_id":"0","item_id":"232","item_sku":"166","item_name":"Candied Spicy Bacon Strips","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-12 12:45:05","serial":"admin-1481511523-14815179052238376","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-12 12:45:37', NULL, ''),
(429, 'sanni', '{"sale":{"id":"5175","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-12-12 16:46:27","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1481517910","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-12-12 16:47:47', NULL, ''),
(430, 'sanni', '{"void_item":{"id":"15458","date":"2016-12-12 19:33:53","ss_terminal":null,"ss_code":null,"sale_id":"5178","si_item_id":null,"item_id":"63","item_sku":"63","item_name":"Lime","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-12 19:33:53","serial":"admin-1481517910-14815424336724365","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-12 19:34:29', NULL, ''),
(431, 'lois', '{"void_item":{"id":"15479","date":"2016-12-14 10:44:08","ss_terminal":null,"ss_code":null,"sale_id":"5184","si_item_id":"0","item_id":"184","item_sku":"119","item_name":"Flat White","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-14 10:44:08","serial":"admin-1481675417-14816834484836687","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-14 10:45:04', NULL, ''),
(432, 'sanni', '{"sale":{"id":"5251","txn_no":"105115","table_no":"T14","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-12-17 14:01:24","payment_status":"Paid","cost":null,"subtotal":"56.00","amount":"56.00","amount_cash":"56.00","amount_cc":null,"amount_tendered":"56.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1481947331","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"15721","date":"2016-12-17 13:20:46","ss_terminal":null,"ss_code":null,"sale_id":"5251","si_item_id":null,"item_id":"25","item_sku":"25","item_name":"Matcha Latte","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1481947331","ordered_by":"admin","ordered_time":"2016-12-17 13:20:46","serial":"admin-1481947331-14819520463068284","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"15720","date":"2016-12-17 13:20:46","ss_terminal":null,"ss_code":null,"sale_id":"5251","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":"1","terminal":"27","printed":"1","session":"1481947331","ordered_by":"admin","ordered_time":"2016-12-17 13:20:46","serial":"admin-1481947331-14819520463068284","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"15719","date":"2016-12-17 13:20:46","ss_terminal":null,"ss_code":null,"sale_id":"5251","si_item_id":"0","item_id":"223","item_sku":"157","item_name":"Crispy Bacon Aglio Olio","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":"1","terminal":"27","printed":"1","session":"1481947331","ordered_by":"admin","ordered_time":"2016-12-17 13:20:46","serial":"admin-1481947331-14819520463068284","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"15718","date":"2016-12-17 13:20:46","ss_terminal":null,"ss_code":null,"sale_id":"5251","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"House BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1481947331","ordered_by":"admin","ordered_time":"2016-12-17 13:20:46","serial":"admin-1481947331-14819520463068284","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-12-17 14:01:38', 1, ''),
(433, 'sanni', '{"void_item":{"id":"15791","date":"2016-12-17 19:51:55","ss_terminal":null,"ss_code":null,"sale_id":"5269","si_item_id":"0","item_id":"73","item_sku":"73","item_name":"Marmite Chicken ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-17 19:51:55","serial":"admin-1481975059-14819755154085857","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-17 19:52:51', NULL, ''),
(434, 'sanni', '{"void_item":{"id":"15798","date":"2016-12-17 20:03:26","ss_terminal":null,"ss_code":null,"sale_id":"5269","si_item_id":"0","item_id":"72","item_sku":"72","item_name":"Mushroom Chicken","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-17 20:03:26","serial":"admin-1481975059-14819762063447138","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-17 20:04:14', NULL, ''),
(435, 'lois', '{"void_item":{"id":"15814","date":"2016-12-17 21:21:43","ss_terminal":null,"ss_code":null,"sale_id":"5271","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"600.00","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-17 21:21:43","serial":"admin-1481976364-14819809031653823","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-17 21:22:05', NULL, ''),
(436, 'lois', '{"void_item":{"id":"15817","date":"2016-12-17 21:24:57","ss_terminal":null,"ss_code":null,"sale_id":"5271","si_item_id":"0","item_id":"182","item_sku":"117","item_name":"Open Drinks ","item_option":"Corkage Charge","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"50.00","margin":"50.0000","cost":"0.0000","amount":"50.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-17 21:24:57","serial":"admin-1481980912-1481981097618953","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-17 22:08:59', NULL, ''),
(437, 'sanni', '{"void_item":{"id":"16072","date":"2016-12-21 12:23:56","ss_terminal":null,"ss_code":null,"sale_id":"5354","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-21 12:23:56","serial":"admin-1482289636-14822942362004719","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-21 12:24:15', NULL, ''),
(438, 'lois', '{"void_item":{"id":"16091","date":"2016-12-21 14:35:11","ss_terminal":null,"ss_code":null,"sale_id":"5356","si_item_id":"0","item_id":"176","item_sku":"111","item_name":"Scones ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-21 14:35:11","serial":"admin-1482289636-1482302110878338","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-21 14:35:35', NULL, ''),
(439, 'lois', '{"sale":{"id":"5367","txn_no":null,"table_no":"T5","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-12-22 11:38:52","payment_status":"Unpaid","cost":null,"subtotal":"11.00","amount":"11.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1482374420","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"16119","date":"2016-12-22 11:39:14","ss_terminal":null,"ss_code":null,"sale_id":"5367","si_item_id":"0","item_id":"219","item_sku":"153","item_name":"Fried Rice With Bacon","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-22 11:39:14","serial":"admin-1482377945-14823779544592213","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"16120","date":"2016-12-22 11:39:20","ss_terminal":null,"ss_code":null,"sale_id":"5367","si_item_id":"0","item_id":"208","item_sku":"D0001","item_name":"RM5 DISCOUNT ","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"-5.00","margin":"-5.0000","cost":"0.0000","amount":"-5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-22 11:39:20","serial":"admin-1482377945-14823779599213998","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-12-22 11:39:52', NULL, ''),
(440, 'lois', '{"sale":{"id":"5382","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-12-23 10:32:02","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1482454049","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2016-12-23 10:34:35', NULL, ''),
(441, 'sanni', '{"void_item":{"id":"16172","date":"2016-12-23 10:52:22","ss_terminal":null,"ss_code":null,"sale_id":"5384","si_item_id":null,"item_id":"8","item_sku":"8","item_name":"Caramel Macchiato ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-23 10:52:22","serial":"admin-1482454049-14824615417893315","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-23 11:00:22', NULL, ''),
(442, 'sanni', '{"void_item":{"id":"16253","date":"2016-12-23 17:39:27","ss_terminal":null,"ss_code":null,"sale_id":"5421","si_item_id":null,"item_id":"66","item_sku":"66","item_name":"Watermelon ","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-23 17:39:27","serial":"admin-1482471260-14824859673271595","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-23 17:56:39', NULL, ''),
(443, 'sanni', '{"void_item":{"id":"16269","date":"2016-12-23 18:41:07","ss_terminal":null,"ss_code":null,"sale_id":"5422","si_item_id":"0","item_id":"73","item_sku":"73","item_name":"Marmite Chicken ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-23 18:41:07","serial":"admin-1482471260-14824896675689980","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-23 18:42:42', NULL, ''),
(444, 'sanni', '{"void_item":{"id":"16268","date":"2016-12-23 18:41:07","ss_terminal":null,"ss_code":null,"sale_id":"5422","si_item_id":"0","item_id":"73","item_sku":"73","item_name":"Marmite Chicken ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-23 18:41:07","serial":"admin-1482471260-14824896675689980","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-23 18:42:50', NULL, ''),
(445, 'sanni', '{"void_item":{"id":"16274","date":"2016-12-23 18:50:28","ss_terminal":null,"ss_code":null,"sale_id":"5423","si_item_id":"0","item_id":"170","item_sku":"104","item_name":"Daily Cheese ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-23 18:50:28","serial":"admin-1482489687-14824902282512190","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-23 18:53:11', NULL, ''),
(446, 'lois', '{"void_item":{"id":"16259","date":"2016-12-23 17:39:45","ss_terminal":null,"ss_code":null,"sale_id":"5421","si_item_id":null,"item_id":"63","item_sku":"63","item_name":"Lime","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-23 17:39:45","serial":"admin-1482471260-14824859856991061","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-23 19:12:37', NULL, ''),
(447, 'lois', '{"void_item":{"id":"16254","date":"2016-12-23 17:39:27","ss_terminal":null,"ss_code":null,"sale_id":"5421","si_item_id":null,"item_id":"63","item_sku":"63","item_name":"Lime","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-23 17:39:27","serial":"admin-1482471260-14824859673271595","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-23 19:12:49', NULL, ''),
(448, 'lois', '{"void_item":{"id":"16255","date":"2016-12-23 17:39:27","ss_terminal":null,"ss_code":null,"sale_id":"5421","si_item_id":"0","item_id":"242","item_sku":"176","item_name":"Citrus Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-23 17:39:27","serial":"admin-1482471260-14824859673271595","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-23 19:12:58', NULL, ''),
(449, 'sanni', '{"void_item":{"id":"16478","date":"2016-12-25 10:16:17","ss_terminal":null,"ss_code":null,"sale_id":"5480","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-25 10:16:17","serial":"admin-1482626290-1482632176908764","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-25 10:42:26', NULL, ''),
(450, 'sanni', '{"void_item":{"id":"16577","date":"2016-12-25 14:38:29","ss_terminal":null,"ss_code":null,"sale_id":"5507","si_item_id":null,"item_id":"7","item_sku":"7","item_name":"Mocha ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-25 14:38:29","serial":"admin-1482643824-14826479091428192","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-25 15:37:10', NULL, ''),
(451, 'sanni', '{"void_item":{"id":"16634","date":"2016-12-25 18:56:14","ss_terminal":null,"ss_code":null,"sale_id":"5535","si_item_id":"0","item_id":"252","item_sku":"186","item_name":"Dinner Seasoned Chicken Aglio Olio","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"26.90","margin":"26.9000","cost":"0.0000","amount":"26.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-25 18:56:14","serial":"admin-1482651451-14826633747765591","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-25 18:59:36', NULL, ''),
(452, 'sanni', '{"void_item":{"id":"16662","date":"2016-12-26 10:38:34","ss_terminal":null,"ss_code":null,"sale_id":"5544","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"House BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-26 10:38:34","serial":"admin-1482714671-14827199143189527","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-26 10:38:47', NULL, ''),
(453, 'sanni', '{"void_item":{"id":"16676","date":"2016-12-26 10:43:14","ss_terminal":null,"ss_code":null,"sale_id":"5545","si_item_id":null,"item_id":"36","item_sku":"36","item_name":"Lemon Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-26 10:43:14","serial":"admin-1482720017-14827201944056339","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-26 10:43:32', NULL, ''),
(454, 'sanni', '{"void_item":{"id":"16869","date":"2016-12-28 09:52:02","ss_terminal":null,"ss_code":null,"sale_id":"5594","si_item_id":"0","item_id":"159","item_sku":"93","item_name":"Granola ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-28 09:52:02","serial":"admin-1482886119-14828899225705985","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-28 09:59:30', NULL, ''),
(455, 'lois', '{"void_item":{"id":"17067","date":"2016-12-30 13:19:43","ss_terminal":null,"ss_code":null,"sale_id":"5662","si_item_id":"0","item_id":"255","item_sku":"189","item_name":"Ault NYE Beer","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"64.90","margin":"64.9000","cost":"0.0000","amount":"64.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-30 13:19:43","serial":"admin-1483066124-14830751834074281","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-30 13:41:07', NULL, ''),
(456, 'lois', '{"sale":{"id":"5662","txn_no":null,"table_no":"T5","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-12-30 13:12:23","payment_status":"Unpaid","cost":null,"subtotal":"201.80","amount":"201.80","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1483066124","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"17075","date":"2016-12-30 13:42:31","ss_terminal":null,"ss_code":null,"sale_id":"5662","si_item_id":"0","item_id":"260","item_sku":"194","item_name":"Coronado Beer Single","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-30 13:42:31","serial":"admin-1483066124-14830765509824152","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"17070","date":"2016-12-30 13:42:17","ss_terminal":null,"ss_code":null,"sale_id":"5662","si_item_id":"0","item_id":"255","item_sku":"189","item_name":"Ault NYE Beer","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"59.90","margin":"59.9000","cost":"0.0000","amount":"59.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-30 13:42:17","serial":"admin-1483066124-14830765368499140","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"17071","date":"2016-12-30 13:42:17","ss_terminal":null,"ss_code":null,"sale_id":"5662","si_item_id":"0","item_id":"258","item_sku":"192","item_name":"NYE Beer Promo","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-30 13:42:17","serial":"admin-1483066124-14830765368499140","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"17072","date":"2016-12-30 13:42:17","ss_terminal":null,"ss_code":null,"sale_id":"5662","si_item_id":"0","item_id":"256","item_sku":"190","item_name":"Kid NYE","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"25.00","margin":"25.0000","cost":"0.0000","amount":"25.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-30 13:42:17","serial":"admin-1483066124-14830765368499140","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"17073","date":"2016-12-30 13:42:17","ss_terminal":null,"ss_code":null,"sale_id":"5662","si_item_id":"0","item_id":"257","item_sku":"191","item_name":"Kid 6 YO & Below","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-30 13:42:17","serial":"admin-1483066124-14830765368499140","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"17069","date":"2016-12-30 13:42:17","ss_terminal":null,"ss_code":null,"sale_id":"5662","si_item_id":"0","item_id":"254","item_sku":"188","item_name":"Adult NYE","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"49.90","margin":"49.9000","cost":"0.0000","amount":"49.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-30 13:42:17","serial":"admin-1483066124-14830765368499140","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"17074","date":"2016-12-30 13:42:31","ss_terminal":null,"ss_code":null,"sale_id":"5662","si_item_id":"0","item_id":"259","item_sku":"193","item_name":"Coronado Beer Set","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"40.00","margin":"40.0000","cost":"0.0000","amount":"40.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-30 13:42:31","serial":"admin-1483066124-14830765509824152","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-12-30 13:42:40', NULL, ''),
(457, 'lois', '{"void_item":{"id":"17128","date":"2016-12-30 20:12:01","ss_terminal":null,"ss_code":null,"sale_id":"5684","si_item_id":"0","item_id":"260","item_sku":"194","item_name":"Coronado Beer Single","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-30 20:12:01","serial":"admin-1483066124-14830999212732069","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-30 20:41:47', NULL, ''),
(458, 'sanni', '{"void_item":{"id":"17154","date":"2016-12-31 10:08:03","ss_terminal":null,"ss_code":null,"sale_id":"5692","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-31 10:08:03","serial":"admin-1483145031-14831500834617039","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-31 11:13:15', NULL, ''),
(459, 'sanni', '{"void_item":{"id":"17211","date":"2016-12-31 13:11:57","ss_terminal":null,"ss_code":null,"sale_id":"5711","si_item_id":"0","item_id":"192","item_sku":"127","item_name":"Stir Fried Hot & Spicy Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-31 13:11:57","serial":"admin-1483160790-14831611171486376","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-31 13:29:21', NULL, ''),
(460, 'lois', '{"sale":{"id":"5724","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-12-31 18:06:21","payment_status":"Unpaid","cost":null,"subtotal":"168.40","amount":"168.40","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1483164662","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"17256","date":"2016-12-31 18:08:39","ss_terminal":null,"ss_code":null,"sale_id":"5724","si_item_id":"0","item_id":"254","item_sku":"188","item_name":"Adult NYE","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"49.90","margin":"49.9000","cost":"0.0000","amount":"49.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-31 18:08:39","serial":"admin-1483164662-14831789195204020","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"17257","date":"2016-12-31 18:08:39","ss_terminal":null,"ss_code":null,"sale_id":"5724","si_item_id":"0","item_id":"255","item_sku":"189","item_name":"Ault NYE Beer","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"59.90","margin":"59.9000","cost":"0.0000","amount":"59.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-31 18:08:39","serial":"admin-1483164662-14831789195204020","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"17258","date":"2016-12-31 18:08:39","ss_terminal":null,"ss_code":null,"sale_id":"5724","si_item_id":"0","item_id":"258","item_sku":"192","item_name":"NYE Beer Promo","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-31 18:08:39","serial":"admin-1483164662-14831789195204020","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"17259","date":"2016-12-31 18:08:39","ss_terminal":null,"ss_code":null,"sale_id":"5724","si_item_id":"0","item_id":"257","item_sku":"191","item_name":"Kid 6 YO & Below","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-31 18:08:39","serial":"admin-1483164662-14831789195204020","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"17260","date":"2016-12-31 18:08:39","ss_terminal":null,"ss_code":null,"sale_id":"5724","si_item_id":"0","item_id":"256","item_sku":"190","item_name":"Kid NYE","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"25.00","margin":"25.0000","cost":"0.0000","amount":"25.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-31 18:08:39","serial":"admin-1483164662-14831789195204020","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"17261","date":"2016-12-31 18:09:09","ss_terminal":null,"ss_code":null,"sale_id":"5724","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"10.80","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-31 18:09:09","serial":"admin-1483164662-14831789497447468","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":"10.0","global_discount":null},{"id":"17262","date":"2016-12-31 18:09:36","ss_terminal":null,"ss_code":null,"sale_id":"5724","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"10.80","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-31 18:09:36","serial":"admin-1483164662-14831789761257292","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":"10.0","global_discount":null}]}', '2016-12-31 18:10:00', NULL, ''),
(461, 'sanni', '{"sale":{"id":"5725","txn_no":null,"table_no":"T1","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-12-31 18:10:14","payment_status":"Unpaid","cost":null,"subtotal":"145.70","amount":"145.70","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1483164662","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"17263","date":"2016-12-31 18:10:47","ss_terminal":null,"ss_code":null,"sale_id":"5725","si_item_id":"0","item_id":"254","item_sku":"188","item_name":"Adult NYE","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"49.90","margin":"49.9000","cost":"0.0000","amount":"49.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-31 18:10:47","serial":"admin-1483164662-14831790477004316","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"17264","date":"2016-12-31 18:10:47","ss_terminal":null,"ss_code":null,"sale_id":"5725","si_item_id":"0","item_id":"56","item_sku":"56","item_name":"House red (Glass)","item_option":"","category":"Cold Drinks","subcategory":"Wine","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-31 18:10:47","serial":"admin-1483164662-14831790477004316","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":"10.0","global_discount":null},{"id":"17265","date":"2016-12-31 18:11:28","ss_terminal":null,"ss_code":null,"sale_id":"5725","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"10.80","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-31 18:11:28","serial":"admin-1483164662-14831790883807836","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":"10.0","global_discount":null},{"id":"17266","date":"2016-12-31 18:13:05","ss_terminal":null,"ss_code":null,"sale_id":"5725","si_item_id":"0","item_id":"258","item_sku":"192","item_name":"NYE Beer Promo","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-31 18:13:05","serial":"admin-1483164662-14831791856285169","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"17267","date":"2016-12-31 18:13:05","ss_terminal":null,"ss_code":null,"sale_id":"5725","si_item_id":"0","item_id":"260","item_sku":"194","item_name":"Coronado Beer Single","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-31 18:13:05","serial":"admin-1483164662-14831791856285169","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"17268","date":"2016-12-31 18:13:05","ss_terminal":null,"ss_code":null,"sale_id":"5725","si_item_id":"0","item_id":"259","item_sku":"193","item_name":"Coronado Beer Set","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"40.00","margin":"40.0000","cost":"0.0000","amount":"40.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-31 18:13:05","serial":"admin-1483164662-14831791856285169","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-12-31 19:19:03', NULL, ''),
(462, 'sanni', '{"void_item":{"id":"17279","date":"2016-12-31 20:48:00","ss_terminal":null,"ss_code":null,"sale_id":"5734","si_item_id":"0","item_id":"258","item_sku":"192","item_name":"NYE Beer Promo","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-31 20:48:00","serial":"admin-1483164662-14831884806248136","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2016-12-31 20:50:58', NULL, ''),
(463, 'sanni', '{"sale":{"id":"5734","txn_no":null,"table_no":"T12","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-12-31 20:47:53","payment_status":"Unpaid","cost":null,"subtotal":"24.00","amount":"24.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1483164662","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"17278","date":"2016-12-31 20:48:00","ss_terminal":null,"ss_code":null,"sale_id":"5734","si_item_id":"0","item_id":"258","item_sku":"192","item_name":"NYE Beer Promo","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-31 20:48:00","serial":"admin-1483164662-14831884806248136","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"17280","date":"2016-12-31 20:48:00","ss_terminal":null,"ss_code":null,"sale_id":"5734","si_item_id":"0","item_id":"258","item_sku":"192","item_name":"NYE Beer Promo","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2016-12-31 20:48:00","serial":"admin-1483164662-14831884806248136","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-12-31 20:51:08', NULL, ''),
(464, 'lois', '{"sale":{"id":"5743","txn_no":"105596","table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2016-12-31 21:38:55","payment_status":"Paid","cost":null,"subtotal":"99.80","amount":"99.80","amount_cash":"99.80","amount_cc":null,"amount_tendered":"99.80","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1483188930","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"17295","date":"2016-12-31 21:38:47","ss_terminal":null,"ss_code":null,"sale_id":"5743","si_item_id":"0","item_id":"254","item_sku":"188","item_name":"Adult NYE","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"49.90","margin":"49.9000","cost":"0.0000","amount":"49.90","sold":"1","terminal":"27","printed":"1","session":"1483188930","ordered_by":"admin","ordered_time":"2016-12-31 21:38:47","serial":"admin-1483188930-14831915275058342","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"17294","date":"2016-12-31 21:38:47","ss_terminal":null,"ss_code":null,"sale_id":"5743","si_item_id":"0","item_id":"254","item_sku":"188","item_name":"Adult NYE","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"49.90","margin":"49.9000","cost":"0.0000","amount":"49.90","sold":"1","terminal":"27","printed":"1","session":"1483188930","ordered_by":"admin","ordered_time":"2016-12-31 21:38:47","serial":"admin-1483188930-14831915275058342","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-12-31 21:41:24', 1, ''),
(465, 'lois', '{"sale":{"id":"5743","txn_no":"105596","table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2016-12-31 21:38:55","payment_status":"Unpaid","cost":null,"subtotal":"99.80","amount":"99.80","amount_cash":"99.80","amount_cc":null,"amount_tendered":"99.80","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1483188930","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"17295","date":"2016-12-31 21:38:47","ss_terminal":null,"ss_code":null,"sale_id":"5743","si_item_id":"0","item_id":"254","item_sku":"188","item_name":"Adult NYE","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"49.90","margin":"49.9000","cost":"0.0000","amount":"49.90","sold":"1","terminal":"27","printed":"1","session":"1483188930","ordered_by":"admin","ordered_time":"2016-12-31 21:38:47","serial":"admin-1483188930-14831915275058342","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"17294","date":"2016-12-31 21:38:47","ss_terminal":null,"ss_code":null,"sale_id":"5743","si_item_id":"0","item_id":"254","item_sku":"188","item_name":"Adult NYE","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"49.90","margin":"49.9000","cost":"0.0000","amount":"49.90","sold":"1","terminal":"27","printed":"1","session":"1483188930","ordered_by":"admin","ordered_time":"2016-12-31 21:38:47","serial":"admin-1483188930-14831915275058342","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2016-12-31 21:41:32', NULL, ''),
(466, 'lois', '{"void_item":{"id":"17354","date":"2017-01-01 12:56:25","ss_terminal":null,"ss_code":null,"sale_id":"5757","si_item_id":"0","item_id":"254","item_sku":"188","item_name":"Adult NYE","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"49.90","margin":"49.9000","cost":"0.0000","amount":"49.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-01 12:56:25","serial":"admin-1483241065-1483246585103851","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-01 12:57:14', NULL, ''),
(467, 'sanni', '{"void_item":{"id":"17412","date":"2017-01-01 14:29:30","ss_terminal":null,"ss_code":null,"sale_id":"5770","si_item_id":"0","item_id":"209","item_sku":"143","item_name":"Honey Lemon","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-01 14:29:30","serial":"admin-1483251145-1483252170640739","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-01 14:39:56', NULL, ''),
(468, 'sanni', '{"void_item":{"id":"17624","date":"2017-01-04 10:06:06","ss_terminal":null,"ss_code":null,"sale_id":"5847","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-04 10:06:06","serial":"admin-1483490976-14834955661468292","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-04 10:07:57', NULL, ''),
(469, 'sanni', '{"void_item":{"id":"17754","date":"2017-01-05 11:10:26","ss_terminal":null,"ss_code":null,"sale_id":"5885","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"French Toast with Fruits","item_option":"bacon","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-05 11:10:26","serial":"admin-1483585789-14835858258805173","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-05 11:25:30', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(470, 'sanni', '{"void_item":{"id":"17752","date":"2017-01-05 11:10:26","ss_terminal":null,"ss_code":null,"sale_id":"5885","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"French Toast with Fruits","item_option":"bacon","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-05 11:10:26","serial":"admin-1483585789-14835858258805173","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-05 11:25:39', NULL, ''),
(471, 'sanni', '{"void_item":{"id":"17753","date":"2017-01-05 11:10:26","ss_terminal":null,"ss_code":null,"sale_id":"5885","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"French Toast with Fruits","item_option":"bacon","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-05 11:10:26","serial":"admin-1483585789-14835858258805173","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-05 11:25:52', NULL, ''),
(472, 'lois', '{"void_item":{"id":"17844","date":"2017-01-06 10:54:18","ss_terminal":null,"ss_code":null,"sale_id":"5914","si_item_id":"0","item_id":"158","item_sku":"92","item_name":"Nutella Toast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-06 10:54:18","serial":"admin-1483669204-1483671258717539","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-06 10:56:57', NULL, ''),
(473, 'sanni', '{"void_item":{"id":"17872","date":"2017-01-06 13:33:46","ss_terminal":null,"ss_code":null,"sale_id":"5923","si_item_id":"0","item_id":"80","item_sku":"80","item_name":"Oriental Chicken Salad","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-06 13:33:46","serial":"admin-1483677214-14836808263417796","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-06 13:34:54', NULL, ''),
(474, 'sanni', '{"void_item":{"id":"17886","date":"2017-01-06 15:23:35","ss_terminal":null,"ss_code":null,"sale_id":"5928","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-06 15:23:35","serial":"admin-1483677214-14836874152579377","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-06 15:25:23', NULL, ''),
(475, 'sanni', '{"void_item":{"id":"17902","date":"2017-01-07 08:51:42","ss_terminal":null,"ss_code":null,"sale_id":"5936","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-07 08:51:42","serial":"admin-1483749998-14837503022011957","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-07 08:51:56', NULL, ''),
(476, 'sanni', '{"sale":{"id":"5936","txn_no":null,"table_no":"T0","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-01-07 08:47:58","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1483749998","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2017-01-07 08:52:45', NULL, ''),
(477, 'sanni', '{"sale":{"id":"5977","txn_no":"105819","table_no":"T13","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-01-08 10:32:28","payment_status":"Paid","cost":null,"subtotal":"56.00","amount":"56.00","amount_cash":"56.00","amount_cc":null,"amount_tendered":"56.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1483841634","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"18053","date":"2017-01-08 10:22:35","ss_terminal":null,"ss_code":null,"sale_id":"5977","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":"1","terminal":"27","printed":"1","session":"1483841634","ordered_by":"admin","ordered_time":"2017-01-08 10:22:35","serial":"admin-1483841634-14838421553427872","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"18054","date":"2017-01-08 10:22:35","ss_terminal":null,"ss_code":null,"sale_id":"5977","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"French Toast with Fruits","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1483841634","ordered_by":"admin","ordered_time":"2017-01-08 10:22:35","serial":"admin-1483841634-14838421553427872","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"18055","date":"2017-01-08 10:22:35","ss_terminal":null,"ss_code":null,"sale_id":"5977","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1483841634","ordered_by":"admin","ordered_time":"2017-01-08 10:22:35","serial":"admin-1483841634-14838421553427872","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"18056","date":"2017-01-08 10:22:35","ss_terminal":null,"ss_code":null,"sale_id":"5977","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":"1","terminal":"27","printed":"1","session":"1483841634","ordered_by":"admin","ordered_time":"2017-01-08 10:22:35","serial":"admin-1483841634-14838421553427872","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"18057","date":"2017-01-08 10:22:35","ss_terminal":null,"ss_code":null,"sale_id":"5977","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1483841634","ordered_by":"admin","ordered_time":"2017-01-08 10:22:35","serial":"admin-1483841634-14838421553427872","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"18066","date":"2017-01-08 10:32:17","ss_terminal":null,"ss_code":null,"sale_id":"5977","si_item_id":"0","item_id":"208","item_sku":"D0001","item_name":"RM5 DISCOUNT ","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"-5.00","margin":"-5.0000","cost":"0.0000","amount":"-5.00","sold":"1","terminal":"27","printed":"1","session":"1483841634","ordered_by":"admin","ordered_time":"2017-01-08 10:32:17","serial":"admin-1483841634-14838427374061090","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-01-08 10:38:06', 1, ''),
(478, 'sanni', '{"void_item":{"id":"18066","date":"2017-01-08 10:32:17","ss_terminal":null,"ss_code":null,"sale_id":"5977","si_item_id":"0","item_id":"208","item_sku":"D0001","item_name":"RM5 DISCOUNT ","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"-5.00","margin":"-5.0000","cost":"0.0000","amount":"-5.00","sold":"1","terminal":"27","printed":"1","session":"1483841634","ordered_by":"admin","ordered_time":"2017-01-08 10:32:17","serial":"admin-1483841634-14838427374061090","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-08 10:38:17', NULL, ''),
(479, 'sanni', '{"void_item":{"id":"18162","date":"2017-01-08 14:47:49","ss_terminal":null,"ss_code":null,"sale_id":"6000","si_item_id":"0","item_id":"172","item_sku":"106","item_name":"Daily Berries ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-08 14:47:49","serial":"admin-1483854060-14838580689253457","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-08 15:25:21', NULL, ''),
(480, 'sanni', '{"sale":{"id":"6020","txn_no":"105865","table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-01-08 20:50:41","payment_status":"Paid","cost":null,"subtotal":"44.00","amount":"44.00","amount_cash":"44.00","amount_cc":null,"amount_tendered":"50.00","amount_change":"6.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1483877732","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"18210","date":"2017-01-08 20:49:39","ss_terminal":null,"ss_code":null,"sale_id":"6020","si_item_id":"0","item_id":"70","item_sku":"70","item_name":"Pepper Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1483877732","ordered_by":"admin","ordered_time":"2017-01-08 20:49:39","serial":"admin-1483877732-148387977944867","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"18211","date":"2017-01-08 20:49:39","ss_terminal":null,"ss_code":null,"sale_id":"6020","si_item_id":"0","item_id":"229","item_sku":"163","item_name":"Mummy''s Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1483877732","ordered_by":"admin","ordered_time":"2017-01-08 20:49:39","serial":"admin-1483877732-148387977944867","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"18212","date":"2017-01-08 20:50:36","ss_terminal":null,"ss_code":null,"sale_id":"6020","si_item_id":"0","item_id":"24","item_sku":"24","item_name":"Chai Latte","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1483877732","ordered_by":"admin","ordered_time":"2017-01-08 20:50:36","serial":"admin-1483877732-14838798363801228","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-01-08 21:06:53', 1, ''),
(481, 'sanni', '{"void_item":{"id":"18211","date":"2017-01-08 20:49:39","ss_terminal":null,"ss_code":null,"sale_id":"6020","si_item_id":"0","item_id":"229","item_sku":"163","item_name":"Mummy''s Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1483877732","ordered_by":"admin","ordered_time":"2017-01-08 20:49:39","serial":"admin-1483877732-148387977944867","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-08 21:07:08', NULL, ''),
(482, 'lois', '{"void_item":{"id":"18240","date":"2017-01-09 11:59:14","ss_terminal":null,"ss_code":null,"sale_id":"6028","si_item_id":null,"item_id":"9","item_sku":"9","item_name":"Affogato","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-09 11:59:14","serial":"admin-1483933558-14839343545579190","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-09 11:59:30', NULL, ''),
(483, 'lois', '{"sale":{"id":"6027","txn_no":null,"table_no":"TEST","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-01-09 11:56:24","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1483933558","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"18239","date":"2017-01-09 11:56:24","ss_terminal":null,"ss_code":null,"sale_id":"6027","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-09 11:56:24","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-01-09 11:59:41', NULL, ''),
(484, 'lois', '{"sale":{"id":"6028","txn_no":null,"table_no":"T5","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-01-09 11:59:10","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1483933558","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2017-01-09 11:59:51', NULL, ''),
(485, 'sanni', '{"void_item":{"id":"18272","date":"2017-01-09 14:27:15","ss_terminal":null,"ss_code":null,"sale_id":"6043","si_item_id":null,"item_id":"46","item_sku":"46","item_name":"Coke","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-09 14:27:15","serial":"admin-1483933558-1483943235624441","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-09 14:27:24', NULL, ''),
(486, 'lois', '{"sale":{"id":"6082","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-01-12 13:34:30","payment_status":"Unpaid","cost":null,"subtotal":"6.00","amount":"6.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1484195308","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"18368","date":"2017-01-12 13:34:34","ss_terminal":null,"ss_code":null,"sale_id":"6082","si_item_id":null,"item_id":"1","item_sku":"1","item_name":"Espresso","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-12 13:34:34","serial":"admin-1484195308-14841992741753682","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-01-12 13:37:20', NULL, ''),
(487, 'lois', '{"void_item":{"id":"18402","date":"2017-01-13 11:41:16","ss_terminal":null,"ss_code":null,"sale_id":"6096","si_item_id":"0","item_id":"209","item_sku":"143","item_name":"Honey Lemon","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-13 11:41:16","serial":"admin-1484269647-14842788759382160","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-13 11:47:28', NULL, ''),
(488, 'sanni', '{"void_item":{"id":"18460","date":"2017-01-14 11:00:51","ss_terminal":null,"ss_code":null,"sale_id":"6119","si_item_id":"0","item_id":"176","item_sku":"111","item_name":"Scones ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-14 11:00:51","serial":"admin-1484360491-14843628504155687","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-14 11:06:00', NULL, ''),
(489, 'sanni', '{"void_item":{"id":"18456","date":"2017-01-14 10:59:36","ss_terminal":null,"ss_code":null,"sale_id":"6119","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"House BLT","item_option":"Takeaway","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-14 10:59:36","serial":"admin-1484360491-14843627765511355","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-14 11:07:28', NULL, ''),
(490, 'sanni', '{"sale":{"id":"6125","txn_no":null,"table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-01-14 11:51:03","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1484363814","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2017-01-14 11:51:16', NULL, ''),
(491, 'lois', '{"sale":{"id":"6153","txn_no":"105991","table_no":"T4(S)","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-01-15 11:54:56","payment_status":"Paid","cost":null,"subtotal":"45.00","amount":"45.00","amount_cash":"45.00","amount_cc":null,"amount_tendered":"50.00","amount_change":"5.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1484448920","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":null,"customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":null},"sale_items":[{"id":"18576","date":"2017-01-15 11:54:50","ss_terminal":null,"ss_code":null,"sale_id":"6153","si_item_id":null,"item_id":"11","item_sku":"11","item_name":"Vanilla Latte","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1484448920","ordered_by":"admin","ordered_time":"2017-01-15 11:54:50","serial":"admin-1484448920-14844524900412548","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"18574","date":"2017-01-15 00:00:00","ss_terminal":null,"ss_code":null,"sale_id":"6153","si_item_id":null,"item_id":"11","item_sku":"11","item_name":"Vanilla Latte","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":null,"cost":null,"amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1484448920","ordered_by":"admin","ordered_time":"2017-01-15 11:12:01","serial":"admin-1484448920-14844499216507628","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"18575","date":"2017-01-15 00:00:00","ss_terminal":null,"ss_code":null,"sale_id":"6153","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":null,"cost":null,"amount":"17.00","sold":"1","terminal":"27","printed":"1","session":"1484448920","ordered_by":"admin","ordered_time":"2017-01-15 11:11:39","serial":"admin-1484448920-14844498997507989","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-01-15 11:59:19', 1, ''),
(492, 'lois', '{"void_item":{"id":"18576","date":"2017-01-15 11:54:50","ss_terminal":null,"ss_code":null,"sale_id":"6153","si_item_id":null,"item_id":"11","item_sku":"11","item_name":"Vanilla Latte","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1484448920","ordered_by":"admin","ordered_time":"2017-01-15 11:54:50","serial":"admin-1484448920-14844524900412548","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-15 11:59:29', NULL, ''),
(493, 'sanni', '{"void_item":{"id":"18704","date":"2017-01-16 20:32:33","ss_terminal":null,"ss_code":null,"sale_id":"6199","si_item_id":"0","item_id":"251","item_sku":"184","item_name":"Dinner Crispy Bacon Aglio Olio","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"26.90","margin":"26.9000","cost":"0.0000","amount":"26.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-16 20:32:33","serial":"admin-1484568062-14845699537864521","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-16 20:32:42', NULL, ''),
(494, 'admin', '{"sale":{"id":"6218","txn_no":null,"table_no":"TEST","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-01-18 14:09:52","payment_status":"Unpaid","cost":null,"subtotal":"55.90","amount":"61.50","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.01","payment_method":null,"payment_details":null,"terminal":"27","session":"1484716636","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"18772","date":"2017-01-18 14:10:01","ss_terminal":null,"ss_code":null,"sale_id":"6218","si_item_id":"0","item_id":"250","item_sku":"185","item_name":"Double Trouble Burger","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"28.90","margin":"28.9000","cost":"0.0000","amount":"28.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-18 14:10:01","serial":"admin-1484716636-1484719801431845","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"18773","date":"2017-01-18 14:10:01","ss_terminal":null,"ss_code":null,"sale_id":"6218","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-18 14:10:01","serial":"admin-1484716636-1484719801431845","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"18771","date":"2017-01-18 14:10:01","ss_terminal":null,"ss_code":null,"sale_id":"6218","si_item_id":"0","item_id":"223","item_sku":"157","item_name":"Crispy Bacon Aglio Olio","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-18 14:10:01","serial":"admin-1484716636-1484719801431845","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"18770","date":"2017-01-18 14:09:52","ss_terminal":null,"ss_code":null,"sale_id":"6218","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"5.59","margin":"0.0000","cost":"0.0000","amount":"5.59","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-18 14:09:52","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-01-18 14:10:41', NULL, ''),
(495, 'lois', '{"sale":{"id":"6227","txn_no":null,"table_no":"T5","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-01-18 19:01:43","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1484716636","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2017-01-18 20:26:32', NULL, ''),
(496, 'sanni', '{"void_item":{"id":"18844","date":"2017-01-19 13:47:56","ss_terminal":null,"ss_code":null,"sale_id":"6245","si_item_id":"0","item_id":"81","item_sku":"81","item_name":"Set Pepper Pork","item_option":"","category":"Meals","subcategory":"Set Lunch","qty":"1","price_per_unit":"22.00","margin":"22.0000","cost":"0.0000","amount":"22.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-19 13:47:56","serial":"admin-1484804348-14848048761527184","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-19 13:50:18', NULL, ''),
(497, 'lois', '{"void_item":{"id":"18896","date":"2017-01-19 20:34:50","ss_terminal":null,"ss_code":null,"sale_id":"6260","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"fried egg","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"1.50","margin":"1.5000","cost":"0.0000","amount":"1.50","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-19 20:34:50","serial":"admin-1484822774-14848292903756424","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-19 20:35:23', NULL, ''),
(498, 'lois', '{"void_item":{"id":"18934","date":"2017-01-20 12:29:32","ss_terminal":null,"ss_code":null,"sale_id":"6272","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-20 12:29:32","serial":"admin-1484883241-14848865718186633","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-20 12:34:48', NULL, ''),
(499, 'lois', '{"void_item":{"id":"19094","date":"2017-01-22 09:41:17","ss_terminal":null,"ss_code":null,"sale_id":"6330","si_item_id":null,"item_id":"4","item_sku":"4","item_name":"Piccolo","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-22 09:41:17","serial":"admin-1485046061-14850492773052691","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-22 09:41:26', NULL, ''),
(500, 'sanni', '{"void_item":{"id":"19095","date":"2017-01-22 09:41:31","ss_terminal":null,"ss_code":null,"sale_id":"6330","si_item_id":null,"item_id":"8","item_sku":"8","item_name":"Caramel Macchiato ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-22 09:41:31","serial":"admin-1485046061-1485049291457742","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-22 09:54:00', NULL, ''),
(501, 'sanni', '{"sale":{"id":"6375","txn_no":"106210","table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-01-23 10:52:17","payment_status":"Paid","cost":null,"subtotal":"36.00","amount":"36.00","amount_cash":"36.00","amount_cc":null,"amount_tendered":"36.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1485133228","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"19238","date":"2017-01-23 10:51:20","ss_terminal":null,"ss_code":null,"sale_id":"6375","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":"1","terminal":"27","printed":"1","session":"1485133228","ordered_by":"admin","ordered_time":"2017-01-23 10:51:20","serial":"admin-1485133228-14851398801554868","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"19239","date":"2017-01-23 10:51:20","ss_terminal":null,"ss_code":null,"sale_id":"6375","si_item_id":null,"item_id":"21","item_sku":"21","item_name":"Chocolate ","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1485133228","ordered_by":"admin","ordered_time":"2017-01-23 10:51:20","serial":"admin-1485133228-14851398801554868","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"19240","date":"2017-01-23 10:51:51","ss_terminal":null,"ss_code":null,"sale_id":"6375","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1485133228","ordered_by":"admin","ordered_time":"2017-01-23 10:51:51","serial":"admin-1485133228-1485139910869114","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-01-23 10:54:42', 1, ''),
(502, 'sanni', '{"void_item":{"id":"19240","date":"2017-01-23 10:51:51","ss_terminal":null,"ss_code":null,"sale_id":"6375","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1485133228","ordered_by":"admin","ordered_time":"2017-01-23 10:51:51","serial":"admin-1485133228-1485139910869114","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-23 10:54:57', NULL, ''),
(503, 'sanni', '{"void_item":{"id":"19253","date":"2017-01-23 11:35:02","ss_terminal":null,"ss_code":null,"sale_id":"6380","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-23 11:35:02","serial":"admin-1485142394-14851425021606473","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-23 11:36:21', NULL, ''),
(504, 'sanni', '{"sale":{"id":"6389","txn_no":"106223","table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-01-23 16:21:01","payment_status":"Paid","cost":null,"subtotal":"9.00","amount":"8.10","amount_cash":"8.10","amount_cc":null,"amount_tendered":"8.10","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":"0.90","adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1485145022","discount_type":"p","discount":"10","payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"19289","date":"2017-01-23 16:20:48","ss_terminal":null,"ss_code":null,"sale_id":"6389","si_item_id":null,"item_id":"64","item_sku":"64","item_name":"Green Apple","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1485145022","ordered_by":"admin","ordered_time":"2017-01-23 16:20:48","serial":"admin-1485145022-14851596479651915","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":"10.0"}]}', '2017-01-23 16:21:53', 1, ''),
(505, 'sanni', '{"void_item":{"id":"19304","date":"2017-01-25 10:28:38","ss_terminal":null,"ss_code":null,"sale_id":"6395","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Joyous Sunny ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-25 10:28:38","serial":"admin-1485305093-1485311318637342","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-25 10:50:08', NULL, ''),
(506, 'sanni', '{"void_item":{"id":"19348","date":"2017-01-31 13:41:24","ss_terminal":null,"ss_code":null,"sale_id":"6418","si_item_id":null,"item_id":"22","item_sku":"22","item_name":"Honey Milk","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-01-31 13:41:24","serial":"admin-1485839089-1485841284765483","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-01-31 13:43:47', NULL, ''),
(507, 'lois', '{"void_item":{"id":"19437","date":"2017-02-01 15:05:14","ss_terminal":null,"ss_code":null,"sale_id":"6443","si_item_id":"0","item_id":"236","item_sku":"170","item_name":"Vanilla Milk","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-01 15:05:14","serial":"admin-1485929099-14859327144862758","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-01 15:05:32', NULL, ''),
(508, 'sanni', '{"sale":{"id":"6460","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-02-01 19:20:03","payment_status":"Unpaid","cost":null,"subtotal":"6.00","amount":"6.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1485929099","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"19470","date":"2017-02-01 19:20:07","ss_terminal":null,"ss_code":null,"sale_id":"6460","si_item_id":null,"item_id":"1","item_sku":"1","item_name":"Espresso","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-01 19:20:07","serial":"admin-1485929099-14859480068741176","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-02-01 19:23:26', NULL, ''),
(509, 'sanni', '{"void_item":{"id":"19476","date":"2017-02-01 20:19:15","ss_terminal":null,"ss_code":null,"sale_id":"6461","si_item_id":"0","item_id":"260","item_sku":"194","item_name":"Coronado Beer Single","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-01 20:19:15","serial":"admin-1485929099-14859515553483079","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-01 20:19:31', NULL, ''),
(510, 'sanni', '{"void_item":{"id":"19475","date":"2017-02-01 20:19:15","ss_terminal":null,"ss_code":null,"sale_id":"6461","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-01 20:19:15","serial":"admin-1485929099-14859515553483079","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-01 21:02:23', NULL, ''),
(511, 'lois', '{"void_item":{"id":"19545","date":"2017-02-02 14:39:55","ss_terminal":null,"ss_code":null,"sale_id":"6486","si_item_id":"0","item_id":"31","item_sku":"31","item_name":"Iced Matcha Latte","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-02 14:39:55","serial":"admin-1486011162-14860175951508758","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-02 14:40:33', NULL, ''),
(512, 'lois', '{"void_item":{"id":"19554","date":"2017-02-02 14:51:24","ss_terminal":null,"ss_code":null,"sale_id":"6491","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-02 14:51:24","serial":"admin-1486011162-1486018284683323","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-02 14:51:46', NULL, ''),
(513, 'lois', '{"void_item":{"id":"19553","date":"2017-02-02 14:51:24","ss_terminal":null,"ss_code":null,"sale_id":"6491","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-02 14:51:24","serial":"admin-1486011162-1486018284683323","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-02 14:51:53', NULL, ''),
(514, 'lois', '{"void_item":{"id":"19552","date":"2017-02-02 14:51:24","ss_terminal":null,"ss_code":null,"sale_id":"6491","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-02 14:51:24","serial":"admin-1486011162-1486018284683323","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-02 14:52:02', NULL, ''),
(515, 'lois', '{"void_item":{"id":"19546","date":"2017-02-02 14:39:55","ss_terminal":null,"ss_code":null,"sale_id":"6486","si_item_id":"0","item_id":"31","item_sku":"31","item_name":"Iced Matcha Latte","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-02 14:39:55","serial":"admin-1486011162-14860175951508758","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-02 14:56:31', NULL, ''),
(516, 'lois', '{"void_item":{"id":"19542","date":"2017-02-02 14:18:07","ss_terminal":null,"ss_code":null,"sale_id":"6486","si_item_id":"0","item_id":"31","item_sku":"31","item_name":"Iced Matcha Latte","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"14.00","margin":"42.0000","cost":"0.0000","amount":"42.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-02 14:18:07","serial":"admin-1486011162-14860162870408039","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-02 14:56:58', NULL, ''),
(517, 'sanni', '{"void_item":{"id":"19648","date":"2017-02-03 10:58:18","ss_terminal":null,"ss_code":null,"sale_id":"6520","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-03 10:58:18","serial":"admin-1486083430-14860906982088498","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-03 10:58:45', NULL, ''),
(518, 'sanni', '{"void_item":{"id":"19706","date":"2017-02-03 14:07:50","ss_terminal":null,"ss_code":null,"sale_id":"6536","si_item_id":"0","item_id":"86","item_sku":"86","item_name":"Set Meatless Pesto Pasta ","item_option":"","category":"Meals","subcategory":"Set Lunch","qty":"1","price_per_unit":"22.00","margin":"22.0000","cost":"0.0000","amount":"22.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-03 14:07:50","serial":"admin-1486100235-14861020702748763","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-03 14:08:25', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(519, 'sanni', '{"void_item":{"id":"19744","date":"2017-02-03 16:56:20","ss_terminal":null,"ss_code":null,"sale_id":"6546","si_item_id":"0","item_id":"253","item_sku":"187","item_name":"Cheese Baked Nachos","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-03 16:56:20","serial":"admin-1486103352-14861121799107227","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-03 16:56:29', NULL, ''),
(520, 'sanni', '{"void_item":{"id":"19745","date":"2017-02-03 16:56:43","ss_terminal":null,"ss_code":null,"sale_id":"6546","si_item_id":"0","item_id":"78","item_sku":"78","item_name":"Cheesy Baked Mashed Potato","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-03 16:56:43","serial":"admin-1486103352-14861122037657646","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-03 17:01:30', NULL, ''),
(521, 'lois', '{"void_item":{"id":"19780","date":"2017-02-03 20:03:57","ss_terminal":null,"ss_code":null,"sale_id":"6553","si_item_id":"0","item_id":"29","item_sku":"29","item_name":"Iced Lemon Tea","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-03 20:03:57","serial":"admin-1486117870-14861234369497078","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-03 20:04:30', NULL, ''),
(522, 'lois', '{"void_item":{"id":"19779","date":"2017-02-03 20:03:57","ss_terminal":null,"ss_code":null,"sale_id":"6553","si_item_id":"0","item_id":"29","item_sku":"29","item_name":"Iced Lemon Tea","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-03 20:03:57","serial":"admin-1486117870-14861234369497078","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-03 20:04:43', NULL, ''),
(523, 'lois', '{"void_item":{"id":"19781","date":"2017-02-03 20:03:57","ss_terminal":null,"ss_code":null,"sale_id":"6553","si_item_id":"0","item_id":"17","item_sku":"17","item_name":"Iced Caramel Macchiato ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-03 20:03:57","serial":"admin-1486117870-14861234369497078","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-03 20:04:57', NULL, ''),
(524, 'sanni', '{"void_item":{"id":"19835","date":"2017-02-04 09:52:10","ss_terminal":null,"ss_code":null,"sale_id":"6565","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-04 09:52:10","serial":"admin-1486169067-1486173130613375","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-04 10:04:02', NULL, ''),
(525, 'sanni', '{"void_item":{"id":"19834","date":"2017-02-04 09:52:10","ss_terminal":null,"ss_code":null,"sale_id":"6565","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-04 09:52:10","serial":"admin-1486169067-1486173130613375","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-04 10:04:09', NULL, ''),
(526, 'sanni', '{"void_item":{"id":"19843","date":"2017-02-04 10:26:49","ss_terminal":null,"ss_code":null,"sale_id":"6567","si_item_id":null,"item_id":"9","item_sku":"9","item_name":"Affogato","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-04 10:26:49","serial":"admin-1486173135-14861752092356772","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-04 10:27:43', NULL, ''),
(527, 'sanni', '{"void_item":{"id":"19853","date":"2017-02-04 11:18:13","ss_terminal":null,"ss_code":null,"sale_id":"6570","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-04 11:18:13","serial":"admin-1486173135-14861782928397198","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-04 11:49:08', NULL, ''),
(528, 'sanni', '{"void_item":{"id":"19917","date":"2017-02-04 13:51:26","ss_terminal":null,"ss_code":null,"sale_id":"6586","si_item_id":"0","item_id":"222","item_sku":"156","item_name":"Seasoned Chicken Aglio Olio","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-04 13:51:26","serial":"admin-1486185769-14861874864043088","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-04 13:56:48', NULL, ''),
(529, 'sanni', '{"void_item":{"id":"20082","date":"2017-02-05 13:52:54","ss_terminal":null,"ss_code":null,"sale_id":"6617","si_item_id":"0","item_id":"251","item_sku":"184","item_name":"Dinner Crispy Bacon Aglio Olio","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"26.90","margin":"26.9000","cost":"0.0000","amount":"26.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-05 13:52:54","serial":"admin-1486271966-1486273973988113","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-05 14:23:32', NULL, ''),
(530, 'sanni', '{"void_item":{"id":"20046","date":"2017-02-05 13:17:52","ss_terminal":null,"ss_code":null,"sale_id":"6617","si_item_id":"0","item_id":"194","item_sku":"129","item_name":"Deep Fried Chicken Wings","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-05 13:17:52","serial":"admin-1486270446-14862718725387444","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-05 14:23:52', NULL, ''),
(531, 'sanni', '{"void_item":{"id":"20101","date":"2017-02-05 14:32:39","ss_terminal":null,"ss_code":null,"sale_id":"6627","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Joyous Sunny ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-05 14:32:39","serial":"admin-1486274323-14862763590008579","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-05 14:33:37', NULL, ''),
(532, 'sanni', '{"void_item":{"id":"20103","date":"2017-02-05 14:32:39","ss_terminal":null,"ss_code":null,"sale_id":"6627","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-05 14:32:39","serial":"admin-1486274323-14862763590008579","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-05 14:33:46', NULL, ''),
(533, 'lois', '{"sale":{"id":"6628","txn_no":"106459","table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-02-05 15:24:08","payment_status":"Paid","cost":null,"subtotal":"65.00","amount":"65.00","amount_cash":"65.00","amount_cc":null,"amount_tendered":"65.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1486277816","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"20110","date":"2017-02-05 14:45:43","ss_terminal":null,"ss_code":null,"sale_id":"6628","si_item_id":"0","item_id":"223","item_sku":"157","item_name":"Crispy Bacon Aglio Olio","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":"1","terminal":"27","printed":"1","session":"1486277816","ordered_by":"admin","ordered_time":"2017-02-05 14:45:43","serial":"admin-1486274323-14862771433228422","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"20111","date":"2017-02-05 14:45:43","ss_terminal":null,"ss_code":null,"sale_id":"6628","si_item_id":null,"item_id":"11","item_sku":"11","item_name":"Vanilla Latte","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1486277816","ordered_by":"admin","ordered_time":"2017-02-05 14:45:43","serial":"admin-1486274323-14862771433228422","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"20112","date":"2017-02-05 14:45:43","ss_terminal":null,"ss_code":null,"sale_id":"6628","si_item_id":null,"item_id":"33","item_sku":"33","item_name":"Cucumber Lime ","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1486277816","ordered_by":"admin","ordered_time":"2017-02-05 14:45:43","serial":"admin-1486274323-14862771433228422","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"20109","date":"2017-02-05 14:45:43","ss_terminal":null,"ss_code":null,"sale_id":"6628","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Big Breakfast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":"1","terminal":"27","printed":"1","session":"1486277816","ordered_by":"admin","ordered_time":"2017-02-05 14:45:43","serial":"admin-1486274323-14862771433228422","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-02-05 15:36:41', 1, ''),
(534, 'sanni', '{"void_item":{"id":"20180","date":"2017-02-05 19:55:34","ss_terminal":null,"ss_code":null,"sale_id":"6644","si_item_id":"0","item_id":"78","item_sku":"78","item_name":"Cheesy Baked Mashed Potato","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-05 19:55:34","serial":"admin-1486277816-14862957341277337","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-05 19:59:53', NULL, ''),
(535, 'lois', '{"void_item":{"id":"20204","date":"2017-02-06 11:52:53","ss_terminal":null,"ss_code":null,"sale_id":"6650","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Signature Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-06 11:52:53","serial":"admin-1486344182-14863531730566283","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-06 11:55:00', NULL, ''),
(536, 'lois', '{"sale":{"id":"6659","txn_no":null,"table_no":"T8","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-02-06 14:29:25","payment_status":"Unpaid","cost":null,"subtotal":"10.00","amount":"10.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1486357499","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"20231","date":"2017-02-06 14:29:35","ss_terminal":null,"ss_code":null,"sale_id":"6659","si_item_id":"0","item_id":"78","item_sku":"78","item_name":"Cheesy Baked Mashed Potato","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-06 14:29:35","serial":"admin-1486357499-14863625750862644","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-02-06 18:17:57', NULL, ''),
(537, 'sanni', '{"sale":{"id":"6679","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-02-09 09:54:51","payment_status":"Unpaid","cost":null,"subtotal":"25.00","amount":"25.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1486602045","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"20284","date":"2017-02-09 09:54:55","ss_terminal":null,"ss_code":null,"sale_id":"6679","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-09 09:54:55","serial":"admin-1486602045-1486605294954540","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null},{"id":"20285","date":"2017-02-09 09:54:55","ss_terminal":null,"ss_code":null,"sale_id":"6679","si_item_id":null,"item_id":"10","item_sku":"10","item_name":"Dirty Chai","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-09 09:54:55","serial":"admin-1486602045-1486605294954540","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-02-09 09:55:14', NULL, ''),
(538, 'lois', '{"sale":{"id":"6716","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-02-10 17:59:57","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1486705713","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2017-02-10 19:41:23', NULL, ''),
(539, 'sanni', '{"void_item":{"id":"20489","date":"2017-02-11 13:33:48","ss_terminal":null,"ss_code":null,"sale_id":"6732","si_item_id":"0","item_id":"71","item_sku":"71","item_name":"Stir Fried Rice Wine Ginger Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-11 13:33:48","serial":"admin-1486781920-14867912281155953","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-11 13:35:39', NULL, ''),
(540, 'sanni', '{"void_item":{"id":"20488","date":"2017-02-11 13:33:48","ss_terminal":null,"ss_code":null,"sale_id":"6732","si_item_id":"0","item_id":"70","item_sku":"70","item_name":"Pepper Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-11 13:33:48","serial":"admin-1486781920-14867912281155953","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-11 13:35:48', NULL, ''),
(541, 'sanni', '{"void_item":{"id":"20490","date":"2017-02-11 13:33:56","ss_terminal":null,"ss_code":null,"sale_id":"6732","si_item_id":"0","item_id":"210","item_sku":"144","item_name":"Red Riding Hood","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-11 13:33:56","serial":"admin-1486781920-14867912364729841","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-11 13:36:00', NULL, ''),
(542, 'lois', '{"void_item":{"id":"20495","date":"2017-02-11 13:44:12","ss_terminal":null,"ss_code":null,"sale_id":"6734","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"7.70","margin":"0.0000","cost":"0.0000","amount":"7.70","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-11 13:44:12","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-11 14:46:06', NULL, ''),
(543, 'lois', '{"void_item":{"id":"20548","date":"2017-02-11 16:31:31","ss_terminal":null,"ss_code":null,"sale_id":"6749","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.30","margin":"0.0000","cost":"0.0000","amount":"0.30","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-11 16:31:31","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-11 16:31:48', NULL, ''),
(544, 'sanni', '{"sale":{"id":"6749","txn_no":null,"table_no":"T1","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-02-11 16:31:31","payment_status":"Unpaid","cost":null,"subtotal":"3.00","amount":"3.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1486791391","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"20549","date":"2017-02-11 16:31:35","ss_terminal":null,"ss_code":null,"sale_id":"6749","si_item_id":"0","item_id":"263","item_sku":"197","item_name":"Postcard With Postage","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-11 16:31:35","serial":"admin-1486791391-14868018948996774","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-02-11 16:52:37', NULL, ''),
(545, 'sanni', '{"void_item":{"id":"20564","date":"2017-02-11 17:06:49","ss_terminal":null,"ss_code":null,"sale_id":"6753","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"scone","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-11 17:06:49","serial":"admin-1486791391-1486804009385799","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-11 17:08:51', NULL, ''),
(546, 'sanni', '{"void_item":{"id":"20647","date":"2017-02-12 10:32:06","ss_terminal":null,"ss_code":null,"sale_id":"6777","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-12 10:32:06","serial":"admin-1486861609-14868667264666338","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-12 10:34:02', NULL, ''),
(547, 'sanni', '{"sale":{"id":"6796","txn_no":null,"table_no":"T10","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-02-12 13:16:23","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1486873925","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"20746","date":"2017-02-12 13:16:24","ss_terminal":null,"ss_code":null,"sale_id":"6796","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-12 13:16:24","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-02-12 13:17:17', NULL, ''),
(548, 'sanni', '{"sale":{"id":"6818","txn_no":null,"table_no":"T9","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-02-12 16:00:27","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1486880131","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"20831","date":"2017-02-12 16:00:27","ss_terminal":null,"ss_code":null,"sale_id":"6818","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-12 16:00:27","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-02-12 16:48:06', NULL, ''),
(549, 'lois', '{"sale":{"id":"6813","txn_no":null,"table_no":"T11","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-02-12 15:09:33","payment_status":"Unpaid","cost":null,"subtotal":"20.00","amount":"22.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1486880131","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"20811","date":"2017-02-12 15:09:33","ss_terminal":null,"ss_code":null,"sale_id":"6813","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.00","margin":"0.0000","cost":"0.0000","amount":"2.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-12 15:09:33","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"20820","date":"2017-02-12 15:25:16","ss_terminal":null,"ss_code":null,"sale_id":"6813","si_item_id":"0","item_id":"243","item_sku":"177","item_name":"Hot Ginger Lemongrass","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-12 15:25:16","serial":"admin-1486880131-14868843163075490","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"20812","date":"2017-02-12 15:09:44","ss_terminal":null,"ss_code":null,"sale_id":"6813","si_item_id":"0","item_id":"243","item_sku":"177","item_name":"Hot Ginger Lemongrass","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-12 15:09:44","serial":"admin-1486880131-14868833842534036","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-02-12 17:26:22', NULL, ''),
(550, 'lois', '{"void_item":{"id":"20893","date":"2017-02-13 11:46:05","ss_terminal":null,"ss_code":null,"sale_id":"6834","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-13 11:46:05","serial":"admin-1486956031-14869575651416568","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-13 11:46:15', NULL, ''),
(551, 'sanni', '{"void_item":{"id":"20909","date":"2017-02-13 12:03:15","ss_terminal":null,"ss_code":null,"sale_id":"6837","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-13 12:03:15","serial":"admin-1486956031-14869585957161888","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-13 12:52:09', NULL, ''),
(552, 'sanni', '{"void_item":{"id":"20908","date":"2017-02-13 12:03:15","ss_terminal":null,"ss_code":null,"sale_id":"6837","si_item_id":null,"item_id":"66","item_sku":"66","item_name":"Watermelon ","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-13 12:03:15","serial":"admin-1486956031-14869585957161888","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-13 12:52:16', NULL, ''),
(553, 'sanni', '{"void_item":{"id":"20905","date":"2017-02-13 12:02:59","ss_terminal":null,"ss_code":null,"sale_id":"6837","si_item_id":"0","item_id":"84","item_sku":"84","item_name":"Set Marmite Chicken","item_option":"","category":"Meals","subcategory":"Set Lunch","qty":"1","price_per_unit":"22.00","margin":"22.0000","cost":"0.0000","amount":"22.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-13 12:02:59","serial":"admin-1486956031-14869585797511733","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-13 12:52:31', NULL, ''),
(554, 'lois', '{"sale":{"id":"6839","txn_no":null,"table_no":"T8","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-02-13 12:19:19","payment_status":"Unpaid","cost":null,"subtotal":"28.00","amount":"30.80","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1486956031","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"20916","date":"2017-02-13 12:19:19","ss_terminal":null,"ss_code":null,"sale_id":"6839","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.80","margin":"0.0000","cost":"0.0000","amount":"2.80","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-13 12:19:19","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"20917","date":"2017-02-13 12:19:24","ss_terminal":null,"ss_code":null,"sale_id":"6839","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-13 12:19:24","serial":"admin-1486956031-14869595639734319","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"20918","date":"2017-02-13 12:19:24","ss_terminal":null,"ss_code":null,"sale_id":"6839","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-13 12:19:24","serial":"admin-1486956031-14869595639734319","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"20928","date":"2017-02-13 12:39:52","ss_terminal":null,"ss_code":null,"sale_id":"6839","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-13 12:39:52","serial":"admin-1486956031-14869607921306216","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"20927","date":"2017-02-13 12:39:52","ss_terminal":null,"ss_code":null,"sale_id":"6839","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-13 12:39:52","serial":"admin-1486956031-14869607921306216","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-02-13 14:31:46', NULL, ''),
(555, 'lois', '{"sale":{"id":"6849","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-02-13 14:00:54","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1486962836","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"20951","date":"2017-02-13 14:00:54","ss_terminal":null,"ss_code":null,"sale_id":"6849","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-13 14:00:54","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-02-13 14:32:05', NULL, ''),
(556, 'lois', '{"sale":{"id":"6852","txn_no":"106672","table_no":"T15","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-02-13 16:56:06","payment_status":"Paid","cost":null,"subtotal":"59.50","amount":"65.45","amount_cash":"65.45","amount_cc":null,"amount_tendered":"66.00","amount_change":"0.55","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1486962836","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"20968","date":"2017-02-13 15:00:58","ss_terminal":null,"ss_code":null,"sale_id":"6852","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1486962836","ordered_by":"admin","ordered_time":"2017-02-13 15:00:58","serial":"admin-1486962836-14869692584306786","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"20969","date":"2017-02-13 15:04:51","ss_terminal":null,"ss_code":null,"sale_id":"6852","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"fried egg","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"1.50","margin":"1.5000","cost":"0.0000","amount":"1.50","sold":"1","terminal":"27","printed":"1","session":"1486962836","ordered_by":"admin","ordered_time":"2017-02-13 15:04:51","serial":"admin-1486962836-14869694918358638","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"20970","date":"2017-02-13 15:04:52","ss_terminal":null,"ss_code":null,"sale_id":"6852","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1486962836","ordered_by":"admin","ordered_time":"2017-02-13 15:04:52","serial":"admin-1486962836-14869694918358638","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"20971","date":"2017-02-13 15:34:30","ss_terminal":null,"ss_code":null,"sale_id":"6852","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":"1","terminal":"27","printed":"1","session":"1486962836","ordered_by":"admin","ordered_time":"2017-02-13 15:34:30","serial":"admin-1486962836-1486971270579314","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"20972","date":"2017-02-13 15:34:30","ss_terminal":null,"ss_code":null,"sale_id":"6852","si_item_id":"0","item_id":"31","item_sku":"31","item_name":"Iced Matcha Latte","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1486962836","ordered_by":"admin","ordered_time":"2017-02-13 15:34:30","serial":"admin-1486962836-1486971270579314","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"20966","date":"2017-02-13 14:46:24","ss_terminal":null,"ss_code":null,"sale_id":"6852","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"5.95","margin":"0.0000","cost":"0.0000","amount":"5.95","sold":"1","terminal":"27","printed":"1","session":"1486962836","ordered_by":"admin","ordered_time":"2017-02-13 14:46:24","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"20967","date":"2017-02-13 14:46:28","ss_terminal":null,"ss_code":null,"sale_id":"6852","si_item_id":"0","item_id":"211","item_sku":"145","item_name":"Stir Fried Lemony Chicken","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1486962836","ordered_by":"admin","ordered_time":"2017-02-13 14:46:28","serial":"admin-1486962836-14869683885267311","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-02-13 16:56:47', 1, ''),
(557, 'lois', '{"sale":{"id":"6857","txn_no":null,"table_no":"T8","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-02-15 11:38:33","payment_status":"Unpaid","cost":null,"subtotal":"76.00","amount":"83.60","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1487120746","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"21010","date":"2017-02-15 12:20:23","ss_terminal":null,"ss_code":null,"sale_id":"6857","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-15 12:20:23","serial":"admin-1487130775-14871324237293160","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"21009","date":"2017-02-15 12:20:23","ss_terminal":null,"ss_code":null,"sale_id":"6857","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-15 12:20:23","serial":"admin-1487130775-14871324237293160","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"21035","date":"2017-02-15 13:20:54","ss_terminal":null,"ss_code":null,"sale_id":"6857","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-15 13:20:54","serial":"admin-1487134777-14871360545346652","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"21034","date":"2017-02-15 13:20:54","ss_terminal":null,"ss_code":null,"sale_id":"6857","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-15 13:20:54","serial":"admin-1487134777-14871360545346652","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"20991","date":"2017-02-15 11:38:33","ss_terminal":null,"ss_code":null,"sale_id":"6857","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"7.60","margin":"0.0000","cost":"0.0000","amount":"7.60","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-15 11:38:33","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"20992","date":"2017-02-15 11:38:44","ss_terminal":null,"ss_code":null,"sale_id":"6857","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-15 11:38:44","serial":"admin-1487120746-14871299238039135","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"20993","date":"2017-02-15 11:38:44","ss_terminal":null,"ss_code":null,"sale_id":"6857","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-15 11:38:44","serial":"admin-1487120746-14871299238039135","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"20994","date":"2017-02-15 11:38:44","ss_terminal":null,"ss_code":null,"sale_id":"6857","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-15 11:38:44","serial":"admin-1487120746-14871299238039135","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"20995","date":"2017-02-15 11:38:44","ss_terminal":null,"ss_code":null,"sale_id":"6857","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-15 11:38:44","serial":"admin-1487120746-14871299238039135","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-02-15 13:21:01', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(558, 'lois', '{"void_item":{"id":"21085","date":"2017-02-15 15:14:28","ss_terminal":null,"ss_code":null,"sale_id":"6873","si_item_id":"0","item_id":"176","item_sku":"111","item_name":"Scones ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-15 15:14:28","serial":"admin-1487134777-14871428687948741","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-15 15:15:00', NULL, ''),
(559, 'lois', '{"sale":{"id":"6876","txn_no":null,"table_no":"T1","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-02-15 15:13:20","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1487134777","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"21082","date":"2017-02-15 15:13:20","ss_terminal":null,"ss_code":null,"sale_id":"6876","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-15 15:13:20","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-02-15 15:20:33', NULL, ''),
(560, 'lois', '{"void_item":{"id":"21177","date":"2017-02-16 13:47:16","ss_terminal":null,"ss_code":null,"sale_id":"6904","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.90","margin":"0.0000","cost":"0.0000","amount":"1.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-16 13:47:16","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-16 13:47:39', NULL, ''),
(561, 'sanni', '{"sale":{"id":"6927","txn_no":"106740","table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-02-17 12:58:05","payment_status":"Paid","cost":null,"subtotal":"52.00","amount":"57.20","amount_cash":"57.20","amount_cc":null,"amount_tendered":"57.20","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1487305904","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"21258","date":"2017-02-17 12:23:03","ss_terminal":null,"ss_code":null,"sale_id":"6927","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"5.20","margin":"0.0000","cost":"0.0000","amount":"5.20","sold":"1","terminal":"27","printed":"1","session":"1487305904","ordered_by":"admin","ordered_time":"2017-02-17 12:23:03","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"21259","date":"2017-02-17 12:24:57","ss_terminal":null,"ss_code":null,"sale_id":"6927","si_item_id":null,"item_id":"64","item_sku":"64","item_name":"Green Apple","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1487305904","ordered_by":"admin","ordered_time":"2017-02-17 12:24:57","serial":"admin-1487300076-14873054968905622","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"21260","date":"2017-02-17 12:24:57","ss_terminal":null,"ss_code":null,"sale_id":"6927","si_item_id":null,"item_id":"37","item_sku":"37","item_name":"Pineapple Orange","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1487305904","ordered_by":"admin","ordered_time":"2017-02-17 12:24:57","serial":"admin-1487300076-14873054968905622","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"21261","date":"2017-02-17 12:24:57","ss_terminal":null,"ss_code":null,"sale_id":"6927","si_item_id":null,"item_id":"33","item_sku":"33","item_name":"Cucumber Lime ","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1487305904","ordered_by":"admin","ordered_time":"2017-02-17 12:24:57","serial":"admin-1487300076-14873054968905622","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"21262","date":"2017-02-17 12:24:57","ss_terminal":null,"ss_code":null,"sale_id":"6927","si_item_id":"0","item_id":"262","item_sku":"196","item_name":"Cheesy Sticks","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":"1","terminal":"27","printed":"1","session":"1487305904","ordered_by":"admin","ordered_time":"2017-02-17 12:24:57","serial":"admin-1487300076-14873054968905622","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"21263","date":"2017-02-17 12:24:57","ss_terminal":null,"ss_code":null,"sale_id":"6927","si_item_id":"0","item_id":"262","item_sku":"196","item_name":"Cheesy Sticks","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":"1","terminal":"27","printed":"1","session":"1487305904","ordered_by":"admin","ordered_time":"2017-02-17 12:24:57","serial":"admin-1487300076-14873054968905622","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"21264","date":"2017-02-17 12:24:57","ss_terminal":null,"ss_code":null,"sale_id":"6927","si_item_id":"0","item_id":"176","item_sku":"111","item_name":"Scones ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":"1","terminal":"27","printed":"1","session":"1487305904","ordered_by":"admin","ordered_time":"2017-02-17 12:24:57","serial":"admin-1487300076-14873054968905622","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"21265","date":"2017-02-17 12:24:57","ss_terminal":null,"ss_code":null,"sale_id":"6927","si_item_id":"0","item_id":"176","item_sku":"111","item_name":"Scones ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":"1","terminal":"27","printed":"1","session":"1487305904","ordered_by":"admin","ordered_time":"2017-02-17 12:24:57","serial":"admin-1487300076-14873054968905622","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-02-17 12:59:11', 1, ''),
(562, 'sanni', '{"void_item":{"id":"21265","date":"2017-02-17 12:24:57","ss_terminal":null,"ss_code":null,"sale_id":"6927","si_item_id":"0","item_id":"176","item_sku":"111","item_name":"Scones ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":"1","terminal":"27","printed":"1","session":"1487305904","ordered_by":"admin","ordered_time":"2017-02-17 12:24:57","serial":"admin-1487300076-14873054968905622","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-17 12:59:40', NULL, ''),
(563, 'lois', '{"void_item":{"id":"21338","date":"2017-02-17 16:49:16","ss_terminal":null,"ss_code":null,"sale_id":"6941","si_item_id":"0","item_id":"70","item_sku":"70","item_name":"Pepper Pork","item_option":"Fried Egg","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-17 16:49:16","serial":"admin-1487308134-14873213562311196","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-17 17:34:37', NULL, ''),
(564, 'lois', '{"void_item":{"id":"21392","date":"2017-02-18 10:45:44","ss_terminal":null,"ss_code":null,"sale_id":"6953","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.90","margin":"0.0000","cost":"0.0000","amount":"0.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-18 10:45:44","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-18 10:46:25', NULL, ''),
(565, 'lois', '{"void_item":{"id":"21423","date":"2017-02-18 11:38:03","ss_terminal":null,"ss_code":null,"sale_id":"6961","si_item_id":"0","item_id":"158","item_sku":"92","item_name":"Banana Stuffed Nutella Toast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-18 11:38:03","serial":"admin-1487386808-14873890832365085","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-18 11:38:38', NULL, ''),
(566, 'sanni', '{"sale":{"id":"6966","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-02-18 12:59:04","payment_status":"Unpaid","cost":null,"subtotal":"39.00","amount":"42.90","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1487392068","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"21446","date":"2017-02-18 12:59:04","ss_terminal":null,"ss_code":null,"sale_id":"6966","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"3.90","margin":"0.0000","cost":"0.0000","amount":"3.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-18 12:59:04","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"21447","date":"2017-02-18 12:59:34","ss_terminal":null,"ss_code":null,"sale_id":"6966","si_item_id":"0","item_id":"211","item_sku":"145","item_name":"Stir Fried Lemony Chicken","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-18 12:59:34","serial":"admin-1487392068-14873939738567759","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"21448","date":"2017-02-18 12:59:34","ss_terminal":null,"ss_code":null,"sale_id":"6966","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-18 12:59:34","serial":"admin-1487392068-14873939738567759","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"21449","date":"2017-02-18 12:59:34","ss_terminal":null,"ss_code":null,"sale_id":"6966","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-18 12:59:34","serial":"admin-1487392068-14873939738567759","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-02-18 13:02:38', NULL, ''),
(567, 'sanni', '{"sale":{"id":"6967","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-02-18 13:02:26","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1487392068","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"21450","date":"2017-02-18 13:02:26","ss_terminal":null,"ss_code":null,"sale_id":"6967","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-18 13:02:26","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-02-18 13:05:12', NULL, ''),
(568, 'sanni', '{"sale":{"id":"6980","txn_no":null,"table_no":"T8","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-02-18 16:15:27","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1487397442","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"21488","date":"2017-02-18 16:15:27","ss_terminal":null,"ss_code":null,"sale_id":"6980","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-18 16:15:27","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-02-18 16:23:25', NULL, ''),
(569, 'sanni', '{"sale":{"id":"6992","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-02-19 10:53:58","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1487465265","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"21539","date":"2017-02-19 10:53:58","ss_terminal":null,"ss_code":null,"sale_id":"6992","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-19 10:53:58","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-02-19 11:31:12', NULL, ''),
(570, 'sanni', '{"void_item":{"id":"21621","date":"2017-02-19 12:18:45","ss_terminal":null,"ss_code":null,"sale_id":"6998","si_item_id":"0","item_id":"209","item_sku":"143","item_name":"Honey Lemon","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-19 12:18:45","serial":"admin-1487477240-14874779254498551","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-19 12:22:35', NULL, ''),
(571, 'sanni', '{"void_item":{"id":"21620","date":"2017-02-19 12:18:45","ss_terminal":null,"ss_code":null,"sale_id":"6998","si_item_id":"0","item_id":"270","item_sku":"204","item_name":"Homemade Savoury Pancake","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-19 12:18:45","serial":"admin-1487477240-14874779254498551","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-19 12:24:24', NULL, ''),
(572, 'sanni', '{"void_item":{"id":"21642","date":"2017-02-19 12:32:49","ss_terminal":null,"ss_code":null,"sale_id":"7009","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-19 12:32:49","serial":"admin-1487477240-14874787693744154","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-19 13:21:19', NULL, ''),
(573, 'sanni', '{"void_item":{"id":"21641","date":"2017-02-19 12:32:49","ss_terminal":null,"ss_code":null,"sale_id":"7009","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-19 12:32:49","serial":"admin-1487477240-14874787693744154","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-19 13:21:38', NULL, ''),
(574, 'lois', '{"void_item":{"id":"21698","date":"2017-02-19 14:33:47","ss_terminal":null,"ss_code":null,"sale_id":"7021","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"3.20","margin":"0.0000","cost":"0.0000","amount":"3.20","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-19 14:33:47","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-19 17:06:21', NULL, ''),
(575, 'sanni', '{"void_item":{"id":"21787","date":"2017-02-20 12:22:25","ss_terminal":null,"ss_code":null,"sale_id":"7046","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-20 12:22:25","serial":"admin-1487550909-14875645453088638","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-20 12:22:48', NULL, ''),
(576, 'sanni', '{"void_item":{"id":"21857","date":"2017-02-22 09:31:51","ss_terminal":null,"ss_code":null,"sale_id":"7068","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-22 09:31:51","serial":"admin-1487726054-14877271114973112","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-22 09:40:27', NULL, ''),
(577, 'lois', '{"void_item":{"id":"21932","date":"2017-02-22 14:15:42","ss_terminal":null,"ss_code":null,"sale_id":"7087","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.00","margin":"0.0000","cost":"0.0000","amount":"1.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-22 14:15:42","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-22 14:16:31', NULL, ''),
(578, 'lois', '{"sale":{"id":"7089","txn_no":"106897","table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-02-22 15:06:19","payment_status":"Paid","cost":null,"subtotal":"19.00","amount":"20.90","amount_cash":"20.90","amount_cc":null,"amount_tendered":"50.00","amount_change":"29.10","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1487726054","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"21942","date":"2017-02-22 14:43:32","ss_terminal":null,"ss_code":null,"sale_id":"7089","si_item_id":null,"item_id":"23","item_sku":"23","item_name":"Lemon Tea","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":"1","terminal":"27","printed":"1","session":"1487726054","ordered_by":"admin","ordered_time":"2017-02-22 14:43:32","serial":"admin-1487726054-1487745812528355","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"21940","date":"2017-02-22 14:42:49","ss_terminal":null,"ss_code":null,"sale_id":"7089","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.90","margin":"0.0000","cost":"0.0000","amount":"1.90","sold":"1","terminal":"27","printed":"1","session":"1487726054","ordered_by":"admin","ordered_time":"2017-02-22 14:42:49","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"21941","date":"2017-02-22 14:43:32","ss_terminal":null,"ss_code":null,"sale_id":"7089","si_item_id":null,"item_id":"34","item_sku":"34","item_name":"Ginger Lemongrass ","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1487726054","ordered_by":"admin","ordered_time":"2017-02-22 14:43:32","serial":"admin-1487726054-1487745812528355","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-02-22 15:06:51', 1, ''),
(579, 'sanni', '{"void_item":{"id":"21892","date":"2017-02-22 11:38:12","ss_terminal":null,"ss_code":null,"sale_id":"7077","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-22 11:38:12","serial":"admin-1487726054-14877346918488761","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-22 19:50:09', NULL, ''),
(580, 'sanni', '{"void_item":{"id":"21891","date":"2017-02-22 11:38:12","ss_terminal":null,"ss_code":null,"sale_id":"7077","si_item_id":"0","item_id":"61","item_sku":"61","item_name":"Slim Fit","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-22 11:38:12","serial":"admin-1487726054-14877346918488761","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-22 19:50:19', NULL, ''),
(581, 'lois', '{"sale":{"id":"7121","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-02-23 17:29:25","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1487830626","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2017-02-23 17:30:20', NULL, ''),
(582, 'sanni', '{"sale":{"id":"7136","txn_no":null,"table_no":"T8","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-02-24 11:44:54","payment_status":"Unpaid","cost":null,"subtotal":"28.00","amount":"30.80","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1487906895","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"22149","date":"2017-02-24 12:28:33","ss_terminal":null,"ss_code":null,"sale_id":"7136","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-24 12:28:33","serial":"admin-1487906895-1487910512986684","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"22148","date":"2017-02-24 12:28:33","ss_terminal":null,"ss_code":null,"sale_id":"7136","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-24 12:28:33","serial":"admin-1487906895-1487910512986684","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"22128","date":"2017-02-24 11:44:58","ss_terminal":null,"ss_code":null,"sale_id":"7136","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-24 11:44:58","serial":"admin-1487906895-14879078983169138","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"22126","date":"2017-02-24 11:44:54","ss_terminal":null,"ss_code":null,"sale_id":"7136","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.80","margin":"0.0000","cost":"0.0000","amount":"2.80","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-24 11:44:54","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"22127","date":"2017-02-24 11:44:58","ss_terminal":null,"ss_code":null,"sale_id":"7136","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-24 11:44:58","serial":"admin-1487906895-14879078983169138","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-02-24 14:17:41', NULL, ''),
(583, 'sanni', '{"void_item":{"id":"22231","date":"2017-02-24 19:33:50","ss_terminal":null,"ss_code":null,"sale_id":"7158","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"Bff","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-24 19:33:50","serial":"admin-1487913138-14879360305765535","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-24 20:20:53', NULL, ''),
(584, 'sanni', '{"void_item":{"id":"22243","date":"2017-02-24 20:20:42","ss_terminal":null,"ss_code":null,"sale_id":"7163","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-24 20:20:42","serial":"admin-1487913138-1487938841877799","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-24 20:21:04', NULL, ''),
(585, 'lois', '{"void_item":{"id":"22228","date":"2017-02-24 19:25:15","ss_terminal":null,"ss_code":null,"sale_id":"7163","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.70","margin":"0.0000","cost":"0.0000","amount":"2.70","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-24 19:25:15","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-24 20:32:52', NULL, ''),
(586, 'lois', '{"sale":{"id":"7158","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-02-24 17:49:44","payment_status":"Unpaid","cost":null,"subtotal":"14.00","amount":"15.40","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1487913138","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"22220","date":"2017-02-24 17:49:50","ss_terminal":null,"ss_code":null,"sale_id":"7158","si_item_id":"0","item_id":"31","item_sku":"31","item_name":"Iced Matcha Latte","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-24 17:49:50","serial":"admin-1487913138-148792979022756","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"22219","date":"2017-02-24 17:49:44","ss_terminal":null,"ss_code":null,"sale_id":"7158","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.40","margin":"0.0000","cost":"0.0000","amount":"1.40","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-24 17:49:44","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-02-24 20:41:36', NULL, ''),
(587, 'sanni', '{"sale":{"id":"7176","txn_no":null,"table_no":"T8","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-02-25 11:01:46","payment_status":"Unpaid","cost":null,"subtotal":"22.00","amount":"24.20","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1487988459","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"22298","date":"2017-02-25 11:01:46","ss_terminal":null,"ss_code":null,"sale_id":"7176","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.20","margin":"0.0000","cost":"0.0000","amount":"2.20","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-25 11:01:46","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"22299","date":"2017-02-25 11:01:50","ss_terminal":null,"ss_code":null,"sale_id":"7176","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-25 11:01:50","serial":"admin-1487988459-14879917103718282","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"22300","date":"2017-02-25 11:01:50","ss_terminal":null,"ss_code":null,"sale_id":"7176","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-25 11:01:50","serial":"admin-1487988459-14879917103718282","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-02-25 11:10:35', NULL, ''),
(588, 'sanni', '{"void_item":[]}', '2017-02-25 11:33:50', NULL, ''),
(589, 'lois', '{"void_item":{"id":"22320","date":"2017-02-25 11:33:07","ss_terminal":null,"ss_code":null,"sale_id":"7181","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-25 11:33:07","serial":"admin-1487988459-1487993587029416","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-25 11:36:15', NULL, ''),
(590, 'lois', '{"void_item":{"id":"22321","date":"2017-02-25 11:33:07","ss_terminal":null,"ss_code":null,"sale_id":"7181","si_item_id":"0","item_id":"16","item_sku":"16","item_name":"Iced Mocha ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-25 11:33:07","serial":"admin-1487988459-1487993587029416","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-25 11:36:24', NULL, ''),
(591, 'sanni', '{"void_item":{"id":"22350","date":"2017-02-25 11:56:01","ss_terminal":null,"ss_code":null,"sale_id":"7185","si_item_id":"0","item_id":"226","item_sku":"160","item_name":"Cheesy Shepherd Pie","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-25 11:56:01","serial":"admin-1487988459-14879949611952432","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-25 11:58:01', NULL, ''),
(592, 'sanni', '{"void_item":{"id":"22351","date":"2017-02-25 11:56:01","ss_terminal":null,"ss_code":null,"sale_id":"7185","si_item_id":"0","item_id":"216","item_sku":"150","item_name":"Chicken In The Blanket","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-25 11:56:01","serial":"admin-1487988459-14879949611952432","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-25 13:00:57', NULL, ''),
(593, 'sanni', '{"void_item":{"id":"22460","date":"2017-02-25 14:05:12","ss_terminal":null,"ss_code":null,"sale_id":"7206","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-25 14:05:12","serial":"admin-1488002678-1488002712427968","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-25 14:05:53', NULL, ''),
(594, 'sanni', '{"void_item":{"id":"22464","date":"2017-02-25 14:21:08","ss_terminal":null,"ss_code":null,"sale_id":"7212","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-25 14:21:08","serial":"admin-1488002678-14880036686899685","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-25 14:21:27', NULL, ''),
(595, 'lois', '{"void_item":{"id":"22470","date":"2017-02-25 15:01:35","ss_terminal":null,"ss_code":null,"sale_id":"7214","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.30","margin":"0.0000","cost":"0.0000","amount":"1.30","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-25 15:01:35","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-25 15:41:30', NULL, ''),
(596, 'lois', '{"void_item":{"id":"22476","date":"2017-02-25 16:05:35","ss_terminal":null,"ss_code":null,"sale_id":"7216","si_item_id":"0","item_id":"243","item_sku":"177","item_name":"Hot Ginger Lemongrass","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-25 16:05:35","serial":"admin-1488004602-14880099349864629","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-25 16:06:39', NULL, ''),
(597, 'sanni', '{"sale":{"id":"7222","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-02-25 18:19:04","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1488004602","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2017-02-25 18:21:50', NULL, ''),
(598, 'sanni', '{"void_item":{"id":"22528","date":"2017-02-26 09:15:45","ss_terminal":null,"ss_code":null,"sale_id":"7228","si_item_id":"0","item_id":"270","item_sku":"204","item_name":"Homemade Savoury Pancake","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-26 09:15:45","serial":"admin-1488070900-14880717452949991","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-26 09:16:27', NULL, ''),
(599, 'lois', '{"void_item":{"id":"22609","date":"2017-02-26 12:45:39","ss_terminal":null,"ss_code":null,"sale_id":"7241","si_item_id":"0","item_id":"251","item_sku":"184","item_name":"Dinner Crispy Bacon Aglio Olio","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"26.90","margin":"26.9000","cost":"0.0000","amount":"26.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-26 12:45:39","serial":"admin-1488074363-14880843392052411","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-26 12:46:09', NULL, ''),
(600, 'sanni', '{"void_item":{"id":"22610","date":"2017-02-26 12:46:33","ss_terminal":null,"ss_code":null,"sale_id":"7241","si_item_id":"0","item_id":"212","item_sku":"146","item_name":"Crispy Bacon Salad","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-26 12:46:33","serial":"admin-1488074363-14880843935926956","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-26 13:02:35', NULL, ''),
(601, 'sanni', '{"void_item":{"id":"22628","date":"2017-02-26 14:04:40","ss_terminal":null,"ss_code":null,"sale_id":"7241","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-26 14:04:40","serial":"admin-1488074363-14880890802176270","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-26 14:08:00', NULL, ''),
(602, 'lois', '{"void_item":{"id":"22719","date":"2017-02-27 10:25:43","ss_terminal":null,"ss_code":null,"sale_id":"7269","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Cheesy Chicken Gratin","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-27 10:25:43","serial":"admin-1488156993-1488162343044349","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-02-27 10:51:50', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(603, 'lois', '{"sale":{"id":"7278","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-02-27 13:17:37","payment_status":"Unpaid","cost":null,"subtotal":"18.00","amount":"19.80","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1488171734","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"22765","date":"2017-02-27 13:17:40","ss_terminal":null,"ss_code":null,"sale_id":"7278","si_item_id":"0","item_id":"188","item_sku":"123","item_name":"Sarawak Laksa","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-27 13:17:40","serial":"admin-1488171734-14881726607316437","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"22764","date":"2017-02-27 13:17:37","ss_terminal":null,"ss_code":null,"sale_id":"7278","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.80","margin":"0.0000","cost":"0.0000","amount":"1.80","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-02-27 13:17:37","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-02-27 14:00:41', NULL, ''),
(604, 'sanni', '{"sale":{"id":"7307","txn_no":null,"table_no":"T8","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-03-01 13:49:14","payment_status":"Unpaid","cost":null,"subtotal":"20.00","amount":"22.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1488344010","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"22885","date":"2017-03-01 13:49:19","ss_terminal":null,"ss_code":null,"sale_id":"7307","si_item_id":"0","item_id":"242","item_sku":"176","item_name":"Citrus Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-01 13:49:19","serial":"admin-1488344010-14883473589567022","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"22886","date":"2017-03-01 13:49:19","ss_terminal":null,"ss_code":null,"sale_id":"7307","si_item_id":"0","item_id":"242","item_sku":"176","item_name":"Citrus Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-01 13:49:19","serial":"admin-1488344010-14883473589567022","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"22884","date":"2017-03-01 13:49:14","ss_terminal":null,"ss_code":null,"sale_id":"7307","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.00","margin":"0.0000","cost":"0.0000","amount":"2.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-01 13:49:14","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-03-01 14:11:21', NULL, ''),
(605, 'sanni', '{"sale":{"id":"7323","txn_no":"107119","table_no":"T10","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-03-01 17:45:08","payment_status":"Paid","cost":null,"subtotal":"37.00","amount":"34.60","amount_cash":"34.60","amount_cc":null,"amount_tendered":"50.00","amount_change":"15.40","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":"6.11","adjustment":"0.01","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1488351757","discount_type":"p","discount":"15","payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"22934","date":"2017-03-01 17:39:48","ss_terminal":null,"ss_code":null,"sale_id":"7323","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"3.70","margin":"0.0000","cost":"0.0000","amount":"3.70","sold":"1","terminal":"27","printed":"1","session":"1488351757","ordered_by":"admin","ordered_time":"2017-03-01 17:39:48","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":"15.0"},{"id":"22935","date":"2017-03-01 17:40:44","ss_terminal":null,"ss_code":null,"sale_id":"7323","si_item_id":"0","item_id":"56","item_sku":"56","item_name":"House red (Glass)","item_option":"","category":"Cold Drinks","subcategory":"Wine","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":"1","terminal":"27","printed":"1","session":"1488351757","ordered_by":"admin","ordered_time":"2017-03-01 17:40:44","serial":"admin-1488351757-1488361243848519","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":"15.0"},{"id":"22936","date":"2017-03-01 17:40:44","ss_terminal":null,"ss_code":null,"sale_id":"7323","si_item_id":"0","item_id":"170","item_sku":"104","item_name":"Daily Cheese ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1488351757","ordered_by":"admin","ordered_time":"2017-03-01 17:40:44","serial":"admin-1488351757-1488361243848519","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"15.0"},{"id":"22937","date":"2017-03-01 17:40:44","ss_terminal":null,"ss_code":null,"sale_id":"7323","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":"1","terminal":"27","printed":"1","session":"1488351757","ordered_by":"admin","ordered_time":"2017-03-01 17:40:44","serial":"admin-1488351757-1488361243848519","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":"15.0"}]}', '2017-03-01 17:49:18', 1, ''),
(606, 'sanni', '{"sale":{"id":"7323","txn_no":"107119","table_no":"T10","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-03-01 17:45:08","payment_status":"Unpaid","cost":null,"subtotal":"37.00","amount":"34.60","amount_cash":"34.60","amount_cc":null,"amount_tendered":"50.00","amount_change":"15.40","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":"6.11","adjustment":"0.01","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1488351757","discount_type":"p","discount":"15","payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"22934","date":"2017-03-01 17:39:48","ss_terminal":null,"ss_code":null,"sale_id":"7323","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"3.70","margin":"0.0000","cost":"0.0000","amount":"3.70","sold":"1","terminal":"27","printed":"1","session":"1488351757","ordered_by":"admin","ordered_time":"2017-03-01 17:39:48","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":"15.0"},{"id":"22935","date":"2017-03-01 17:40:44","ss_terminal":null,"ss_code":null,"sale_id":"7323","si_item_id":"0","item_id":"56","item_sku":"56","item_name":"House red (Glass)","item_option":"","category":"Cold Drinks","subcategory":"Wine","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":"1","terminal":"27","printed":"1","session":"1488351757","ordered_by":"admin","ordered_time":"2017-03-01 17:40:44","serial":"admin-1488351757-1488361243848519","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":"15.0"},{"id":"22936","date":"2017-03-01 17:40:44","ss_terminal":null,"ss_code":null,"sale_id":"7323","si_item_id":"0","item_id":"170","item_sku":"104","item_name":"Daily Cheese ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1488351757","ordered_by":"admin","ordered_time":"2017-03-01 17:40:44","serial":"admin-1488351757-1488361243848519","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"15.0"},{"id":"22937","date":"2017-03-01 17:40:44","ss_terminal":null,"ss_code":null,"sale_id":"7323","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":"1","terminal":"27","printed":"1","session":"1488351757","ordered_by":"admin","ordered_time":"2017-03-01 17:40:44","serial":"admin-1488351757-1488361243848519","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":"15.0"}]}', '2017-03-01 17:49:31', NULL, ''),
(607, 'sanni', '{"void_item":{"id":"23009","date":"2017-03-02 11:03:48","ss_terminal":null,"ss_code":null,"sale_id":"7334","si_item_id":"0","item_id":"270","item_sku":"204","item_name":"Homemade Savoury Pancake","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-02 11:03:48","serial":"admin-1488421861-14884238285602993","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-02 11:04:05', NULL, ''),
(608, 'sanni', '{"sale":{"id":"7339","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-03-02 12:15:59","payment_status":"Unpaid","cost":null,"subtotal":"12.00","amount":"13.20","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1488421861","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"23018","date":"2017-03-02 12:15:59","ss_terminal":null,"ss_code":null,"sale_id":"7339","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.20","margin":"0.0000","cost":"0.0000","amount":"1.20","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-02 12:15:59","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"23019","date":"2017-03-02 12:16:04","ss_terminal":null,"ss_code":null,"sale_id":"7339","si_item_id":"0","item_id":"61","item_sku":"61","item_name":"Slim Fit","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-02 12:16:04","serial":"admin-1488421861-1488428164730613","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-03-02 13:01:04', NULL, ''),
(609, 'lois', '{"void_item":{"id":"23068","date":"2017-03-02 15:46:00","ss_terminal":null,"ss_code":null,"sale_id":"7351","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.10","margin":"0.0000","cost":"0.0000","amount":"1.10","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-02 15:46:00","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-02 16:17:16', NULL, ''),
(610, 'lois', '{"sale":{"id":"7380","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-03-03 13:16:42","payment_status":"Unpaid","cost":null,"subtotal":"13.00","amount":"14.30","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1488514799","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"23196","date":"2017-03-03 13:17:26","ss_terminal":null,"ss_code":null,"sale_id":"7380","si_item_id":"0","item_id":"272","item_sku":"206","item_name":"Genius in The Bowl","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-03 13:17:26","serial":"admin-1488514799-14885182459341065","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"23195","date":"2017-03-03 13:16:42","ss_terminal":null,"ss_code":null,"sale_id":"7380","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.30","margin":"0.0000","cost":"0.0000","amount":"1.30","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-03 13:16:42","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"23197","date":"2017-03-03 13:17:26","ss_terminal":null,"ss_code":null,"sale_id":"7380","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"bff","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-03 13:17:26","serial":"admin-1488514799-14885182459341065","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-03-03 13:50:08', NULL, ''),
(611, 'sanni', '{"void_item":{"id":"23268","date":"2017-03-04 09:18:15","ss_terminal":null,"ss_code":null,"sale_id":"7400","si_item_id":"0","item_id":"194","item_sku":"129","item_name":"Deep Fried Chicken Wings","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-04 09:18:15","serial":"admin-1488588848-14885902954407762","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-04 09:21:17', NULL, ''),
(612, 'sanni', '{"void_item":{"id":"23267","date":"2017-03-04 09:18:15","ss_terminal":null,"ss_code":null,"sale_id":"7400","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-04 09:18:15","serial":"admin-1488588848-14885902954407762","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-04 09:21:26', NULL, ''),
(613, 'sanni', '{"void_item":{"id":"23373","date":"2017-03-04 12:55:10","ss_terminal":null,"ss_code":null,"sale_id":"7422","si_item_id":"0","item_id":"70","item_sku":"70","item_name":"Pepper Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-04 12:55:10","serial":"admin-1488599397-14886033107013880","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-04 13:08:10', NULL, ''),
(614, 'sanni', '{"void_item":{"id":"23407","date":"2017-03-04 14:06:50","ss_terminal":null,"ss_code":null,"sale_id":"7431","si_item_id":"0","item_id":"79","item_sku":"79","item_name":"Summer Salad ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-04 14:06:50","serial":"admin-1488603664-14886076100665889","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-04 14:13:08', NULL, ''),
(615, 'sanni', '{"void_item":{"id":"23415","date":"2017-03-04 14:22:44","ss_terminal":null,"ss_code":null,"sale_id":"7432","si_item_id":"0","item_id":"182","item_sku":"117","item_name":"Open Drinks ","item_option":"plain water","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-04 14:22:44","serial":"admin-1488608002-14886085643537659","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-04 14:39:30', NULL, ''),
(616, 'sanni', '{"void_item":{"id":"23494","date":"2017-03-05 09:18:49","ss_terminal":null,"ss_code":null,"sale_id":"7453","si_item_id":null,"item_id":"1","item_sku":"1","item_name":"Espresso","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-05 09:18:49","serial":"admin-1488674581-14886767295777936","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-05 09:36:47', NULL, ''),
(617, 'sanni', '{"void_item":{"id":"23493","date":"2017-03-05 09:18:49","ss_terminal":null,"ss_code":null,"sale_id":"7453","si_item_id":null,"item_id":"1","item_sku":"1","item_name":"Espresso","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-05 09:18:49","serial":"admin-1488674581-14886767295777936","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-05 09:36:53', NULL, ''),
(618, 'sanni', '{"void_item":{"id":"23492","date":"2017-03-05 09:18:49","ss_terminal":null,"ss_code":null,"sale_id":"7453","si_item_id":null,"item_id":"1","item_sku":"1","item_name":"Espresso","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-05 09:18:49","serial":"admin-1488674581-14886767295777936","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-05 09:36:59', NULL, ''),
(619, 'sanni', '{"void_item":{"id":"23491","date":"2017-03-05 09:18:49","ss_terminal":null,"ss_code":null,"sale_id":"7453","si_item_id":null,"item_id":"1","item_sku":"1","item_name":"Espresso","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-05 09:18:49","serial":"admin-1488674581-14886767295777936","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-05 09:37:05', NULL, ''),
(620, 'lois', '{"void_item":{"id":"23533","date":"2017-03-05 10:14:44","ss_terminal":null,"ss_code":null,"sale_id":"7460","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-05 10:14:44","serial":"admin-1488678420-1488680084690317","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-05 10:47:53', NULL, ''),
(621, 'sanni', '{"void_item":{"id":"23591","date":"2017-03-05 11:03:53","ss_terminal":null,"ss_code":null,"sale_id":"7471","si_item_id":null,"item_id":"8","item_sku":"8","item_name":"Caramel Macchiato ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-05 11:03:53","serial":"admin-1488680401-14886830332143388","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-05 11:06:19', NULL, ''),
(622, 'sanni', '{"sale":{"id":"7462","txn_no":"107259","table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-03-05 11:33:06","payment_status":"Paid","cost":null,"subtotal":"62.00","amount":"68.20","amount_cash":"68.20","amount_cc":null,"amount_tendered":"70.00","amount_change":"1.80","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1488683386","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"23553","date":"2017-03-05 10:35:06","ss_terminal":null,"ss_code":null,"sale_id":"7462","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"6.20","margin":"0.0000","cost":"0.0000","amount":"6.20","sold":"1","terminal":"27","printed":"1","session":"1488683386","ordered_by":"admin","ordered_time":"2017-03-05 10:35:06","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"23554","date":"2017-03-05 10:35:19","ss_terminal":null,"ss_code":null,"sale_id":"7462","si_item_id":null,"item_id":"11","item_sku":"11","item_name":"Vanilla Latte","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1488683386","ordered_by":"admin","ordered_time":"2017-03-05 10:35:19","serial":"admin-1488680401-14886813187719219","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"23555","date":"2017-03-05 10:35:19","ss_terminal":null,"ss_code":null,"sale_id":"7462","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1488683386","ordered_by":"admin","ordered_time":"2017-03-05 10:35:19","serial":"admin-1488680401-14886813187719219","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"23556","date":"2017-03-05 10:35:19","ss_terminal":null,"ss_code":null,"sale_id":"7462","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":"1","terminal":"27","printed":"1","session":"1488683386","ordered_by":"admin","ordered_time":"2017-03-05 10:35:19","serial":"admin-1488680401-14886813187719219","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"23557","date":"2017-03-05 10:35:19","ss_terminal":null,"ss_code":null,"sale_id":"7462","si_item_id":"0","item_id":"270","item_sku":"204","item_name":"Homemade Savoury Pancake","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1488683386","ordered_by":"admin","ordered_time":"2017-03-05 10:35:19","serial":"admin-1488680401-14886813187719219","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-03-05 11:38:52', 1, ''),
(623, 'lois', '{"void_item":{"id":"23625","date":"2017-03-05 11:58:46","ss_terminal":null,"ss_code":null,"sale_id":"7480","si_item_id":"0","item_id":"78","item_sku":"78","item_name":"Cheesy Baked Mashed Potato","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-05 11:58:46","serial":"admin-1488685968-14886863266945926","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-05 12:04:54', NULL, ''),
(624, 'lois', '{"void_item":{"id":"23621","date":"2017-03-05 11:58:10","ss_terminal":null,"ss_code":null,"sale_id":"7480","si_item_id":"0","item_id":"78","item_sku":"78","item_name":"Cheesy Baked Mashed Potato","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-05 11:58:10","serial":"admin-1488685968-14886862906245531","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-05 12:05:01', NULL, ''),
(625, 'lois', '{"sale":{"id":"7485","txn_no":"107267","table_no":"T14(S)","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-03-05 12:30:31","payment_status":"Paid","cost":null,"subtotal":"11.00","amount":"12.10","amount_cash":"12.10","amount_cc":null,"amount_tendered":"20.60","amount_change":"8.50","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1488687133","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":null,"customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":null},"sale_items":[{"id":"23646","date":"2017-03-05 12:28:36","ss_terminal":null,"ss_code":null,"sale_id":"7485","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"","category":"SERVICE CHARGE","subcategory":"SERVICE CHARGE","qty":"1","price_per_unit":"1.10","margin":"0.0000","cost":"0.0000","amount":"1.10","sold":"1","terminal":"27","printed":"1","session":"1488687133","ordered_by":"admin","ordered_time":"2017-03-05 12:28:36","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"23645","date":"2017-03-05 00:00:00","ss_terminal":null,"ss_code":null,"sale_id":"7485","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":null,"cost":null,"amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1488687133","ordered_by":"admin","ordered_time":"2017-03-05 11:05:39","serial":"admin-1488680401-14886831393934511","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-03-05 12:30:45', 1, ''),
(626, 'lois', '{"sale":{"id":"7475","txn_no":null,"table_no":"T0","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-03-05 11:21:26","payment_status":"Unpaid","cost":null,"subtotal":"15.00","amount":"16.50","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1488683386","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"23603","date":"2017-03-05 11:21:26","ss_terminal":null,"ss_code":null,"sale_id":"7475","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.50","margin":"0.0000","cost":"0.0000","amount":"1.50","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-05 11:21:26","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"23604","date":"2017-03-05 11:21:31","ss_terminal":null,"ss_code":null,"sale_id":"7475","si_item_id":"0","item_id":"18","item_sku":"18","item_name":"Iced Dirty Chai","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-05 11:21:31","serial":"admin-1488683386-14886840909941970","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-03-05 12:34:01', NULL, ''),
(627, 'sanni', '{"void_item":{"id":"23667","date":"2017-03-05 13:20:58","ss_terminal":null,"ss_code":null,"sale_id":"7491","si_item_id":"0","item_id":"71","item_sku":"71","item_name":"Stir Fried Rice Wine Ginger Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-05 13:20:58","serial":"admin-1488687133-14886912584928872","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-05 13:28:15', NULL, ''),
(628, 'lois', '{"void_item":{"id":"23618","date":"2017-03-05 11:57:39","ss_terminal":null,"ss_code":null,"sale_id":"7480","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"13.80","margin":"0.0000","cost":"0.0000","amount":"13.80","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-05 11:57:39","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-05 13:36:55', NULL, ''),
(629, 'lois', '{"void_item":{"id":"23682","date":"2017-03-05 13:40:26","ss_terminal":null,"ss_code":null,"sale_id":"7493","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-05 13:40:26","serial":"admin-1488692103-1488692425954421","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-05 13:44:46', NULL, ''),
(630, 'lois', '{"void_item":{"id":"23681","date":"2017-03-05 13:40:26","ss_terminal":null,"ss_code":null,"sale_id":"7493","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-05 13:40:26","serial":"admin-1488692103-1488692425954421","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-05 13:45:00', NULL, ''),
(631, 'sanni', '{"sale":{"id":"7491","txn_no":"107280","table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-03-05 14:06:34","payment_status":"Paid","cost":null,"subtotal":"101.00","amount":"111.10","amount_cash":"111.10","amount_cc":null,"amount_tendered":"111.10","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1488692103","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"23665","date":"2017-03-05 13:20:58","ss_terminal":null,"ss_code":null,"sale_id":"7491","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1488692103","ordered_by":"admin","ordered_time":"2017-03-05 13:20:58","serial":"admin-1488687133-14886912584928872","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"23666","date":"2017-03-05 13:20:58","ss_terminal":null,"ss_code":null,"sale_id":"7491","si_item_id":"0","item_id":"222","item_sku":"156","item_name":"Seasoned Chicken Aglio Olio","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":"1","terminal":"27","printed":"1","session":"1488692103","ordered_by":"admin","ordered_time":"2017-03-05 13:20:58","serial":"admin-1488687133-14886912584928872","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"23669","date":"2017-03-05 13:28:24","ss_terminal":null,"ss_code":null,"sale_id":"7491","si_item_id":"0","item_id":"192","item_sku":"127","item_name":"Stir Fried Hot & Spicy Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1488692103","ordered_by":"admin","ordered_time":"2017-03-05 13:28:24","serial":"admin-1488687133-1488691704413832","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"23678","date":"2017-03-05 13:39:50","ss_terminal":null,"ss_code":null,"sale_id":"7491","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":"1","terminal":"27","printed":"1","session":"1488692103","ordered_by":"admin","ordered_time":"2017-03-05 13:39:50","serial":"admin-1488692103-14886923906313572","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"23677","date":"2017-03-05 13:35:22","ss_terminal":null,"ss_code":null,"sale_id":"7491","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1488692103","ordered_by":"admin","ordered_time":"2017-03-05 13:35:22","serial":"admin-1488692103-14886921220622320","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"23687","date":"2017-03-05 14:05:30","ss_terminal":null,"ss_code":null,"sale_id":"7491","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"scone","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"4.00","margin":"4.0000","cost":"0.0000","amount":"4.00","sold":"1","terminal":"27","printed":"1","session":"1488692103","ordered_by":"admin","ordered_time":"2017-03-05 14:05:30","serial":"admin-1488692103-14886939302439888","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"23664","date":"2017-03-05 13:20:45","ss_terminal":null,"ss_code":null,"sale_id":"7491","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"10.10","margin":"0.0000","cost":"0.0000","amount":"10.10","sold":"1","terminal":"27","printed":"1","session":"1488692103","ordered_by":"admin","ordered_time":"2017-03-05 13:20:45","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"23668","date":"2017-03-05 13:28:24","ss_terminal":null,"ss_code":null,"sale_id":"7491","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1488692103","ordered_by":"admin","ordered_time":"2017-03-05 13:28:24","serial":"admin-1488687133-1488691704413832","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"23670","date":"2017-03-05 13:28:32","ss_terminal":null,"ss_code":null,"sale_id":"7491","si_item_id":"0","item_id":"28","item_sku":"28","item_name":"Iced Honey Milk","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1488692103","ordered_by":"admin","ordered_time":"2017-03-05 13:28:32","serial":"admin-1488687133-14886917119594374","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-03-05 14:35:29', 1, ''),
(632, 'sanni', '{"sale":{"id":"7490","txn_no":null,"table_no":"T14","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-03-05 13:05:02","payment_status":"Unpaid","cost":null,"subtotal":"79.00","amount":"86.90","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1488687133","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"23686","date":"2017-03-05 13:48:46","ss_terminal":null,"ss_code":null,"sale_id":"7490","si_item_id":"0","item_id":"234","item_sku":"168","item_name":"Naughty Boy","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-05 13:48:46","serial":"admin-1488692103-14886929260559938","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"23658","date":"2017-03-05 13:05:02","ss_terminal":null,"ss_code":null,"sale_id":"7490","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"7.90","margin":"0.0000","cost":"0.0000","amount":"7.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-05 13:05:02","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"23659","date":"2017-03-05 13:05:14","ss_terminal":null,"ss_code":null,"sale_id":"7490","si_item_id":"0","item_id":"270","item_sku":"204","item_name":"Homemade Savoury Pancake","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-05 13:05:14","serial":"admin-1488687133-14886903143071656","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"23660","date":"2017-03-05 13:05:14","ss_terminal":null,"ss_code":null,"sale_id":"7490","si_item_id":"0","item_id":"156","item_sku":"90","item_name":"House Cheddar Omelet","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-05 13:05:14","serial":"admin-1488687133-14886903143071656","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"23663","date":"2017-03-05 13:20:42","ss_terminal":null,"ss_code":null,"sale_id":"7490","si_item_id":"0","item_id":"43","item_sku":"43","item_name":"Strawberry Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-05 13:20:42","serial":"admin-1488687133-14886912420695337","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"23662","date":"2017-03-05 13:05:14","ss_terminal":null,"ss_code":null,"sale_id":"7490","si_item_id":null,"item_id":"8","item_sku":"8","item_name":"Caramel Macchiato ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-05 13:05:14","serial":"admin-1488687133-14886903143071656","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"23661","date":"2017-03-05 13:05:14","ss_terminal":null,"ss_code":null,"sale_id":"7490","si_item_id":"0","item_id":"232","item_sku":"166","item_name":"Candied Spicy Bacon Strips","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-05 13:05:14","serial":"admin-1488687133-14886903143071656","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-03-05 14:36:29', NULL, ''),
(633, 'lois', '{"void_item":{"id":"23700","date":"2017-03-05 14:39:19","ss_terminal":null,"ss_code":null,"sale_id":"7496","si_item_id":"0","item_id":"78","item_sku":"78","item_name":"Cheesy Baked Mashed Potato","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-05 14:39:19","serial":"admin-1488692103-14886959589269567","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-05 14:40:57', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(634, 'lois', '{"sale":{"id":"7535","txn_no":"107325","table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-03-06 14:09:56","payment_status":"Paid","cost":null,"subtotal":"79.00","amount":"86.90","amount_cash":"86.90","amount_cc":null,"amount_tendered":"100.00","amount_change":"13.10","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1488777303","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"23880","date":"2017-03-06 13:08:08","ss_terminal":null,"ss_code":null,"sale_id":"7535","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"7.90","margin":"0.0000","cost":"0.0000","amount":"7.90","sold":"1","terminal":"27","printed":"1","session":"1488777303","ordered_by":"admin","ordered_time":"2017-03-06 13:08:08","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"23881","date":"2017-03-06 13:08:12","ss_terminal":null,"ss_code":null,"sale_id":"7535","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1488777303","ordered_by":"admin","ordered_time":"2017-03-06 13:08:12","serial":"admin-1488774486-14887768923453860","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"23882","date":"2017-03-06 13:09:41","ss_terminal":null,"ss_code":null,"sale_id":"7535","si_item_id":"0","item_id":"71","item_sku":"71","item_name":"Stir Fried Rice Wine Ginger Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1488777303","ordered_by":"admin","ordered_time":"2017-03-06 13:09:41","serial":"admin-1488774486-14887769814376572","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"23883","date":"2017-03-06 13:09:41","ss_terminal":null,"ss_code":null,"sale_id":"7535","si_item_id":"0","item_id":"32","item_sku":"32","item_name":"Tea By Pot ","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1488777303","ordered_by":"admin","ordered_time":"2017-03-06 13:09:41","serial":"admin-1488774486-14887769814376572","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"23884","date":"2017-03-06 13:10:06","ss_terminal":null,"ss_code":null,"sale_id":"7535","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1488777303","ordered_by":"admin","ordered_time":"2017-03-06 13:10:06","serial":"admin-1488774486-14887770064151559","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"23886","date":"2017-03-06 13:13:14","ss_terminal":null,"ss_code":null,"sale_id":"7535","si_item_id":"0","item_id":"212","item_sku":"146","item_name":"Crispy Bacon Salad","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":"1","terminal":"27","printed":"1","session":"1488777303","ordered_by":"admin","ordered_time":"2017-03-06 13:13:14","serial":"admin-1488774486-14887771942168918","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"23887","date":"2017-03-06 13:13:14","ss_terminal":null,"ss_code":null,"sale_id":"7535","si_item_id":null,"item_id":"34","item_sku":"34","item_name":"Ginger Lemongrass ","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1488777303","ordered_by":"admin","ordered_time":"2017-03-06 13:13:14","serial":"admin-1488774486-14887771942168918","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-03-06 14:12:03', 1, ''),
(635, 'lois', '{"void_item":{"id":"23884","date":"2017-03-06 13:10:06","ss_terminal":null,"ss_code":null,"sale_id":"7535","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1488777303","ordered_by":"admin","ordered_time":"2017-03-06 13:10:06","serial":"admin-1488774486-14887770064151559","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-06 14:12:17', NULL, ''),
(636, 'lois', '{"void_item":{"id":"23903","date":"2017-03-06 14:51:25","ss_terminal":null,"ss_code":null,"sale_id":"7540","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.80","margin":"0.0000","cost":"0.0000","amount":"2.80","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-06 14:51:25","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-06 16:14:21', NULL, ''),
(637, 'lois', '{"void_item":{"id":"23937","date":"2017-03-06 19:54:32","ss_terminal":null,"ss_code":null,"sale_id":"7548","si_item_id":"0","item_id":"233","item_sku":"167","item_name":"Naugthy Girl","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-06 19:54:32","serial":"admin-1488777303-14888012718983428","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}}', '2017-03-06 19:54:46', NULL, ''),
(638, 'lois', '{"void_item":{"id":"24039","date":"2017-03-08 16:02:39","ss_terminal":null,"ss_code":null,"sale_id":"7568","si_item_id":"0","item_id":"233","item_sku":"167","item_name":"Naugthy Girl","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-08 16:02:39","serial":"admin-1488959498-14889601589429974","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-08 16:53:01', NULL, ''),
(639, 'sanni', '{"void_item":{"id":"24072","date":"2017-03-09 09:51:23","ss_terminal":null,"ss_code":null,"sale_id":"7577","si_item_id":null,"item_id":"62","item_sku":"62","item_name":"Orange","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-09 09:51:23","serial":"admin-1489020426-14890242832773269","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-09 09:56:41', NULL, ''),
(640, 'lois', '{"sale":{"id":"7600","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-03-10 14:32:47","payment_status":"Unpaid","cost":null,"subtotal":"14.00","amount":"15.40","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1489123543","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"24155","date":"2017-03-10 14:32:47","ss_terminal":null,"ss_code":null,"sale_id":"7600","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.40","margin":"0.0000","cost":"0.0000","amount":"1.40","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-10 14:32:47","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"24156","date":"2017-03-10 14:32:52","ss_terminal":null,"ss_code":null,"sale_id":"7600","si_item_id":"0","item_id":"40","item_sku":"40","item_name":"Banana Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-10 14:32:52","serial":"admin-1489123543-14891275724283177","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-03-10 16:02:52', NULL, ''),
(641, 'lois', '{"void_item":{"id":"24179","date":"2017-03-10 16:54:21","ss_terminal":null,"ss_code":null,"sale_id":"7607","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.40","margin":"0.0000","cost":"0.0000","amount":"1.40","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-10 16:54:21","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-10 18:01:01', NULL, ''),
(642, 'sanni', '{"void_item":{"id":"24217","date":"2017-03-11 10:46:29","ss_terminal":null,"ss_code":null,"sale_id":"7615","si_item_id":"0","item_id":"209","item_sku":"143","item_name":"Honey Lemon","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-11 10:46:29","serial":"admin-1489194179-14892003890394082","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-11 10:57:19', NULL, ''),
(643, 'sanni', '{"void_item":{"id":"24445","date":"2017-03-12 10:45:09","ss_terminal":null,"ss_code":null,"sale_id":"7662","si_item_id":"0","item_id":"236","item_sku":"170","item_name":"Vanilla Milk","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-12 10:45:09","serial":"admin-1489285491-1489286709602874","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-12 10:45:37', NULL, ''),
(644, 'sanni', '{"sale":{"id":"7675","txn_no":null,"table_no":"T14","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-03-12 13:11:01","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1489293234","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"24509","date":"2017-03-12 13:11:01","ss_terminal":null,"ss_code":null,"sale_id":"7675","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-12 13:11:01","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-03-12 13:25:20', NULL, ''),
(645, 'sanni', '{"void_item":{"id":"24499","date":"2017-03-12 12:12:24","ss_terminal":null,"ss_code":null,"sale_id":"7673","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-12 12:12:24","serial":"admin-1489287976-14892919442033513","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-12 13:32:00', NULL, ''),
(646, 'sanni', '{"void_item":{"id":"24705","date":"2017-03-15 09:23:04","ss_terminal":null,"ss_code":null,"sale_id":"7717","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-15 09:23:04","serial":"admin-1489538992-14895409845719199","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-15 09:24:20', NULL, ''),
(647, 'sanni', '{"void_item":{"id":"24730","date":"2017-03-15 10:32:51","ss_terminal":null,"ss_code":null,"sale_id":"7721","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Signature Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-15 10:32:51","serial":"admin-1489544898-14895451710087838","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-15 10:50:05', NULL, ''),
(648, 'lois', '{"void_item":{"id":"24873","date":"2017-03-16 17:06:57","ss_terminal":null,"ss_code":null,"sale_id":"7754","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"3.90","margin":"0.0000","cost":"0.0000","amount":"3.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-16 17:06:57","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-16 17:24:54', NULL, ''),
(649, 'lois', '{"void_item":{"id":"24884","date":"2017-03-16 17:36:10","ss_terminal":null,"ss_code":null,"sale_id":"7754","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"","category":"SERVICE CHARGE","subcategory":"SERVICE CHARGE","qty":"1","price_per_unit":"3.90","margin":"0.0000","cost":"0.0000","amount":"3.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-16 17:36:10","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-16 17:36:43', NULL, ''),
(650, 'lois', '{"sale":{"id":"7757","txn_no":"107539","table_no":"T2(S)","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-03-16 17:36:13","payment_status":"Paid","cost":null,"subtotal":"14.00","amount":"15.40","amount_cash":"15.40","amount_cc":null,"amount_tendered":"20.00","amount_change":"4.60","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1489640169","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":null,"customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":null},"sale_items":[{"id":"24883","date":"2017-03-16 17:36:10","ss_terminal":null,"ss_code":null,"sale_id":"7757","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"","category":"SERVICE CHARGE","subcategory":"SERVICE CHARGE","qty":"1","price_per_unit":"1.40","margin":"0.0000","cost":"0.0000","amount":"1.40","sold":"1","terminal":"27","printed":"1","session":"1489640169","ordered_by":"admin","ordered_time":"2017-03-16 17:36:10","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"24882","date":"2017-03-16 00:00:00","ss_terminal":null,"ss_code":null,"sale_id":"7757","si_item_id":"0","item_id":"40","item_sku":"40","item_name":"Banana Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":null,"cost":null,"amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1489640169","ordered_by":"admin","ordered_time":"2017-03-16 17:25:26","serial":"admin-1489640169-14896563260677080","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-03-16 17:37:22', 1, ''),
(651, 'lois', '{"void_item":{"id":"24883","date":"2017-03-16 17:36:10","ss_terminal":null,"ss_code":null,"sale_id":"7757","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"","category":"SERVICE CHARGE","subcategory":"SERVICE CHARGE","qty":"1","price_per_unit":"1.40","margin":"0.0000","cost":"0.0000","amount":"1.40","sold":"1","terminal":"27","printed":"1","session":"1489640169","ordered_by":"admin","ordered_time":"2017-03-16 17:36:10","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-16 17:37:31', NULL, ''),
(652, 'lois', '{"sale":{"id":"7763","txn_no":"107544","table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-03-17 10:46:45","payment_status":"Paid","cost":null,"subtotal":"49.50","amount":"54.45","amount_cash":"54.45","amount_cc":null,"amount_tendered":"54.45","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1489711683","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"24901","date":"2017-03-17 10:22:11","ss_terminal":null,"ss_code":null,"sale_id":"7763","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"4.95","margin":"0.0000","cost":"0.0000","amount":"4.95","sold":"1","terminal":"27","printed":"1","session":"1489711683","ordered_by":"admin","ordered_time":"2017-03-17 10:22:11","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"24902","date":"2017-03-17 10:22:18","ss_terminal":null,"ss_code":null,"sale_id":"7763","si_item_id":"0","item_id":"184","item_sku":"119","item_name":"Flat White","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1489711683","ordered_by":"admin","ordered_time":"2017-03-17 10:22:18","serial":"admin-1489711683-14897173386554667","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"24903","date":"2017-03-17 10:22:18","ss_terminal":null,"ss_code":null,"sale_id":"7763","si_item_id":"0","item_id":"184","item_sku":"119","item_name":"Flat White","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1489711683","ordered_by":"admin","ordered_time":"2017-03-17 10:22:18","serial":"admin-1489711683-14897173386554667","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"24904","date":"2017-03-17 10:25:13","ss_terminal":null,"ss_code":null,"sale_id":"7763","si_item_id":null,"item_id":"7","item_sku":"7","item_name":"Mocha ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1489711683","ordered_by":"admin","ordered_time":"2017-03-17 10:25:13","serial":"admin-1489711683-14897175135445293","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"24905","date":"2017-03-17 10:25:13","ss_terminal":null,"ss_code":null,"sale_id":"7763","si_item_id":"0","item_id":"170","item_sku":"104","item_name":"Daily Cheese ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1489711683","ordered_by":"admin","ordered_time":"2017-03-17 10:25:13","serial":"admin-1489711683-14897175135445293","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"24906","date":"2017-03-17 10:25:13","ss_terminal":null,"ss_code":null,"sale_id":"7763","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"scones","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"4.50","margin":"4.5000","cost":"0.0000","amount":"4.50","sold":"1","terminal":"27","printed":"1","session":"1489711683","ordered_by":"admin","ordered_time":"2017-03-17 10:25:13","serial":"admin-1489711683-14897175135445293","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-03-17 11:08:01', 1, ''),
(653, 'lois', '{"void_item":{"id":"24924","date":"2017-03-17 11:09:49","ss_terminal":null,"ss_code":null,"sale_id":"7768","si_item_id":"0","item_id":"14","item_sku":"14","item_name":"Iced Cappucino ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-17 11:09:49","serial":"admin-1489711683-1489720188996723","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}}', '2017-03-17 11:09:58', NULL, ''),
(654, 'lois', '{"sale":{"id":"7768","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-03-17 11:09:45","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1489711683","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2017-03-17 11:10:09', NULL, ''),
(655, 'lois', '{"void_item":{"id":"24990","date":"2017-03-17 14:12:05","ss_terminal":null,"ss_code":null,"sale_id":"7782","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-17 14:12:05","serial":"admin-1489729230-14897311250765288","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-17 14:31:47', NULL, ''),
(656, 'lois', '{"void_item":{"id":"24988","date":"2017-03-17 14:12:05","ss_terminal":null,"ss_code":null,"sale_id":"7782","si_item_id":"0","item_id":"221","item_sku":"155","item_name":"Seasoned Chicken Pesto Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-17 14:12:05","serial":"admin-1489729230-14897311250765288","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-17 14:31:54', NULL, ''),
(657, 'lois', '{"void_item":{"id":"24995","date":"2017-03-17 14:24:32","ss_terminal":null,"ss_code":null,"sale_id":"7777","si_item_id":"0","item_id":"72","item_sku":"72","item_name":"Mushroom Chicken","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-17 14:24:32","serial":"admin-1489729230-14897318721756326","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-17 14:32:06', NULL, ''),
(658, 'lois', '{"sale":{"id":"7787","txn_no":"107568","table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-03-17 16:20:29","payment_status":"Paid","cost":null,"subtotal":"22.00","amount":"22.00","amount_cash":"22.00","amount_cc":null,"amount_tendered":"50.00","amount_change":"28.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1489732339","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"25018","date":"2017-03-17 16:20:27","ss_terminal":null,"ss_code":null,"sale_id":"7787","si_item_id":"0","item_id":"247","item_sku":"181","item_name":"Caramel Chocolate Cheese","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1489732339","ordered_by":"admin","ordered_time":"2017-03-17 16:20:27","serial":"admin-1489732339-14897388268829435","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null},{"id":"25017","date":"2017-03-17 16:20:27","ss_terminal":null,"ss_code":null,"sale_id":"7787","si_item_id":"0","item_id":"172","item_sku":"106","item_name":"Daily Berries ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1489732339","ordered_by":"admin","ordered_time":"2017-03-17 16:20:27","serial":"admin-1489732339-14897388268829435","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-03-17 16:20:59', 1, ''),
(659, 'lois', '{"void_item":{"id":"25018","date":"2017-03-17 16:20:27","ss_terminal":null,"ss_code":null,"sale_id":"7787","si_item_id":"0","item_id":"247","item_sku":"181","item_name":"Caramel Chocolate Cheese","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1489732339","ordered_by":"admin","ordered_time":"2017-03-17 16:20:27","serial":"admin-1489732339-14897388268829435","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}}', '2017-03-17 16:21:09', NULL, ''),
(660, 'sanni', '{"sale":{"id":"7796","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-03-18 09:06:02","payment_status":"Unpaid","cost":null,"subtotal":"52.00","amount":"52.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1489798849","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"25046","date":"2017-03-18 09:06:25","ss_terminal":null,"ss_code":null,"sale_id":"7796","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-18 09:06:25","serial":"admin-1489798849-1489799185697641","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null},{"id":"25047","date":"2017-03-18 09:06:25","ss_terminal":null,"ss_code":null,"sale_id":"7796","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-18 09:06:25","serial":"admin-1489798849-1489799185697641","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null},{"id":"25048","date":"2017-03-18 09:06:25","ss_terminal":null,"ss_code":null,"sale_id":"7796","si_item_id":"0","item_id":"41","item_sku":"41","item_name":"Blueberry Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-18 09:06:25","serial":"admin-1489798849-1489799185697641","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null},{"id":"25045","date":"2017-03-18 09:06:25","ss_terminal":null,"ss_code":null,"sale_id":"7796","si_item_id":"0","item_id":"16","item_sku":"16","item_name":"Iced Mocha ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-18 09:06:25","serial":"admin-1489798849-1489799185697641","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-03-18 09:10:17', NULL, ''),
(661, 'sanni', '{"void_item":{"id":"25205","date":"2017-03-18 13:11:43","ss_terminal":null,"ss_code":null,"sale_id":"7828","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-18 13:11:43","serial":"admin-1489812004-14898139037411163","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-18 13:22:24', NULL, ''),
(662, 'sanni', '{"void_item":{"id":"25377","date":"2017-03-19 13:08:45","ss_terminal":null,"ss_code":null,"sale_id":"7864","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-19 13:08:45","serial":"admin-1489891524-14899001256359550","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-19 13:24:58', NULL, ''),
(663, 'sanni', '{"void_item":{"id":"25414","date":"2017-03-19 15:53:51","ss_terminal":null,"ss_code":null,"sale_id":"7872","si_item_id":"0","item_id":"219","item_sku":"153","item_name":"Fried Rice With Bacon","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-19 15:53:51","serial":"admin-1489891524-1489910031190142","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-19 15:56:54', NULL, ''),
(664, 'sanni', '{"void_item":{"id":"25434","date":"2017-03-19 17:06:39","ss_terminal":null,"ss_code":null,"sale_id":"7874","si_item_id":"0","item_id":"38","item_sku":"38","item_name":"Mixed Berries Smoothie","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-19 17:06:39","serial":"admin-1489910045-14899143995792038","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-19 17:37:26', NULL, ''),
(665, 'sanni', '{"void_item":{"id":"25469","date":"2017-03-19 18:23:57","ss_terminal":null,"ss_code":null,"sale_id":"7880","si_item_id":"0","item_id":"250","item_sku":"185","item_name":"Double Trouble Burger","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"28.90","margin":"28.9000","cost":"0.0000","amount":"28.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-19 18:23:57","serial":"admin-1489916754-1489919037180166","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-19 18:26:30', NULL, ''),
(666, 'sanni', '{"void_item":{"id":"25578","date":"2017-03-20 20:08:57","ss_terminal":null,"ss_code":null,"sale_id":"7903","si_item_id":"0","item_id":"277","item_sku":"211","item_name":"Iced Ginger Lemongrass","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-20 20:08:57","serial":"admin-1489970962-14900117376064595","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-20 20:15:38', NULL, ''),
(667, 'sanni', '{"void_item":{"id":"25574","date":"2017-03-20 20:08:17","ss_terminal":null,"ss_code":null,"sale_id":"7903","si_item_id":"0","item_id":"31","item_sku":"31","item_name":"Iced Matcha Latte","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-20 20:08:17","serial":"admin-1489970962-14900116969821188","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-20 20:15:46', NULL, ''),
(668, 'lois', '{"void_item":{"id":"25581","date":"2017-03-20 20:35:35","ss_terminal":null,"ss_code":null,"sale_id":"7903","si_item_id":"0","item_id":"253","item_sku":"187","item_name":"Cheese Baked Nachos","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-20 20:35:35","serial":"admin-1489970962-14900133354341443","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-20 20:43:11', NULL, ''),
(669, 'sanni', '{"sale":{"id":"7906","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-03-20 20:43:13","payment_status":"Unpaid","cost":null,"subtotal":"12.00","amount":"12.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1489970962","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"25582","date":"2017-03-20 20:43:20","ss_terminal":null,"ss_code":null,"sale_id":"7906","si_item_id":"0","item_id":"232","item_sku":"166","item_name":"Candied Spicy Bacon Strips","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-20 20:43:20","serial":"admin-1489970962-14900138007883150","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-03-20 20:45:35', NULL, ''),
(670, 'sanni', '{"void_item":{"id":"25565","date":"2017-03-20 19:47:18","ss_terminal":null,"ss_code":null,"sale_id":"7903","si_item_id":"0","item_id":"234","item_sku":"168","item_name":"Naughty Boy","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-20 19:47:19","serial":"admin-1489970962-14900104387111282","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-20 20:47:56', NULL, ''),
(671, 'sanni', '{"void_item":{"id":"25563","date":"2017-03-20 19:47:18","ss_terminal":null,"ss_code":null,"sale_id":"7903","si_item_id":"0","item_id":"195","item_sku":"130","item_name":"Iced Tea","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-20 19:47:18","serial":"admin-1489970962-14900104387111282","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-20 20:50:56', NULL, ''),
(672, 'lois', '{"void_item":{"id":"25607","date":"2017-03-22 09:42:52","ss_terminal":null,"ss_code":null,"sale_id":"7913","si_item_id":null,"item_id":"21","item_sku":"21","item_name":"Chocolate ","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-22 09:42:52","serial":"admin-1490144908-14901469725502921","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-22 09:51:34', NULL, ''),
(673, 'lois', '{"void_item":{"id":"25615","date":"2017-03-22 10:31:47","ss_terminal":null,"ss_code":null,"sale_id":"7914","si_item_id":null,"item_id":"34","item_sku":"34","item_name":"Ginger Lemongrass ","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-22 10:31:47","serial":"admin-1490144908-14901499068594439","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-22 10:32:51', NULL, ''),
(674, 'sanni', '{"void_item":{"id":"25790","date":"2017-03-23 13:22:15","ss_terminal":null,"ss_code":null,"sale_id":"7947","si_item_id":"0","item_id":"52","item_sku":"52","item_name":"Pure Vanilla Frappe","item_option":"","category":"Cold Drinks","subcategory":"Frappe","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-23 13:22:15","serial":"admin-1490244611-14902465355242918","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-23 13:30:25', NULL, ''),
(675, 'lois', '{"sale":[],"sale_items":[]}', '2017-03-23 18:01:56', NULL, ''),
(676, 'lois', '{"sale":{"id":"7958","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-03-23 17:49:16","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1490247953","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2017-03-23 18:42:13', NULL, ''),
(677, 'lois', '{"sale":{"id":"7983","txn_no":"107759","table_no":"T7(S)","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-03-24 20:46:14","payment_status":"Paid","cost":null,"subtotal":"24.00","amount":"26.40","amount_cash":"26.40","amount_cc":null,"amount_tendered":"40.40","amount_change":"14.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1490332569","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":null,"customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":null},"sale_items":[{"id":"25948","date":"2017-03-24 20:45:33","ss_terminal":null,"ss_code":null,"sale_id":"7983","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"","category":"SERVICE CHARGE","subcategory":"SERVICE CHARGE","qty":"1","price_per_unit":"2.40","margin":"0.0000","cost":"0.0000","amount":"2.40","sold":"1","terminal":"27","printed":"1","session":"1490332569","ordered_by":"admin","ordered_time":"2017-03-24 20:45:33","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"25946","date":"2017-03-24 00:00:00","ss_terminal":null,"ss_code":null,"sale_id":"7983","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":null,"cost":null,"amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1490332569","ordered_by":"admin","ordered_time":"2017-03-24 19:50:56","serial":"admin-1490332569-14903562560857016","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"25947","date":"2017-03-24 00:00:00","ss_terminal":null,"ss_code":null,"sale_id":"7983","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":null,"cost":null,"amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1490332569","ordered_by":"admin","ordered_time":"2017-03-24 20:19:19","serial":"admin-1490332569-14903579591038433","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-03-24 20:47:22', 1, ''),
(678, 'lois', '{"void_item":{"id":"25946","date":"2017-03-24 00:00:00","ss_terminal":null,"ss_code":null,"sale_id":"7983","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":null,"cost":null,"amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1490332569","ordered_by":"admin","ordered_time":"2017-03-24 19:50:56","serial":"admin-1490332569-14903562560857016","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-24 20:47:30', NULL, ''),
(679, 'lois', '{"void_item":{"id":"25939","date":"2017-03-24 19:50:49","ss_terminal":null,"ss_code":null,"sale_id":"7982","si_item_id":"0","item_id":"74","item_sku":"74","item_name":"Sunrice","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-24 19:50:49","serial":"admin-1490332569-1490356249014955","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-24 20:48:44', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(680, 'sanni', '{"void_item":{"id":"25976","date":"2017-03-25 10:25:10","ss_terminal":null,"ss_code":null,"sale_id":"7988","si_item_id":"0","item_id":"162","item_sku":"96","item_name":"Homemade Chicken Bite ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-25 10:25:10","serial":"admin-1490402245-14904087098203782","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-25 10:27:08', NULL, ''),
(681, 'sanni', '{"sale":{"id":"7993","txn_no":null,"table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-03-25 11:36:53","payment_status":"Unpaid","cost":null,"subtotal":"20.00","amount":"22.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1490408968","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"25995","date":"2017-03-25 11:36:58","ss_terminal":null,"ss_code":null,"sale_id":"7993","si_item_id":null,"item_id":"4","item_sku":"4","item_name":"Piccolo","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-25 11:36:58","serial":"admin-1490408968-14904130181445114","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"25994","date":"2017-03-25 11:36:58","ss_terminal":null,"ss_code":null,"sale_id":"7993","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-25 11:36:58","serial":"admin-1490408968-14904130181445114","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"25993","date":"2017-03-25 11:36:53","ss_terminal":null,"ss_code":null,"sale_id":"7993","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.00","margin":"0.0000","cost":"0.0000","amount":"2.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-25 11:36:53","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-03-25 11:42:59', NULL, ''),
(682, 'sanni', '{"void_item":{"id":"26059","date":"2017-03-25 14:09:23","ss_terminal":null,"ss_code":null,"sale_id":"8007","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Cheesy Chicken Gratin","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-25 14:09:23","serial":"admin-1490416195-14904221629763425","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-25 14:15:49', NULL, ''),
(683, 'sanni', '{"sale":{"id":"8019","txn_no":"107795","table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-03-26 09:52:27","payment_status":"Paid","cost":null,"subtotal":"75.00","amount":"82.50","amount_cash":"82.50","amount_cc":null,"amount_tendered":"82.50","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1490490760","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"26106","date":"2017-03-26 09:13:11","ss_terminal":null,"ss_code":null,"sale_id":"8019","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":"1","terminal":"27","printed":"1","session":"1490490760","ordered_by":"admin","ordered_time":"2017-03-26 09:13:11","serial":"admin-1490490760-14904907910504198","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"26127","date":"2017-03-26 09:23:03","ss_terminal":null,"ss_code":null,"sale_id":"8019","si_item_id":"0","item_id":"158","item_sku":"92","item_name":"Banana Stuffed Nutella Toast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1490490760","ordered_by":"admin","ordered_time":"2017-03-26 09:23:03","serial":"admin-1490490760-1490491383575109","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"26109","date":"2017-03-26 09:13:21","ss_terminal":null,"ss_code":null,"sale_id":"8019","si_item_id":null,"item_id":"21","item_sku":"21","item_name":"Chocolate ","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1490490760","ordered_by":"admin","ordered_time":"2017-03-26 09:13:21","serial":"admin-1490490760-14904908017039315","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"26108","date":"2017-03-26 09:13:21","ss_terminal":null,"ss_code":null,"sale_id":"8019","si_item_id":null,"item_id":"25","item_sku":"25","item_name":"Matcha Latte","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1490490760","ordered_by":"admin","ordered_time":"2017-03-26 09:13:21","serial":"admin-1490490760-14904908017039315","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"26107","date":"2017-03-26 09:13:11","ss_terminal":null,"ss_code":null,"sale_id":"8019","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":"1","terminal":"27","printed":"1","session":"1490490760","ordered_by":"admin","ordered_time":"2017-03-26 09:13:11","serial":"admin-1490490760-14904907910504198","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"26105","date":"2017-03-26 09:12:58","ss_terminal":null,"ss_code":null,"sale_id":"8019","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"7.50","margin":"0.0000","cost":"0.0000","amount":"7.50","sold":"1","terminal":"27","printed":"1","session":"1490490760","ordered_by":"admin","ordered_time":"2017-03-26 09:12:58","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-03-26 09:53:07', 1, ''),
(684, 'sanni', '{"void_item":{"id":"26162","date":"2017-03-26 11:41:54","ss_terminal":null,"ss_code":null,"sale_id":"8030","si_item_id":"0","item_id":"170","item_sku":"104","item_name":"Daily Cheese ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-26 11:41:54","serial":"admin-1490493485-14904997140206444","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-26 11:49:22', NULL, ''),
(685, 'sanni', '{"void_item":{"id":"26199","date":"2017-03-26 12:53:51","ss_terminal":null,"ss_code":null,"sale_id":"8038","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-26 12:53:51","serial":"admin-1490503360-1490504031171351","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-26 12:55:21', NULL, ''),
(686, 'sanni', '{"void_item":{"id":"26210","date":"2017-03-26 13:00:27","ss_terminal":null,"ss_code":null,"sale_id":"8038","si_item_id":"0","item_id":"250","item_sku":"185","item_name":"Double Trouble Burger","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"28.90","margin":"28.9000","cost":"0.0000","amount":"28.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-26 13:00:27","serial":"admin-1490503360-14905044272689934","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-26 13:10:29', NULL, ''),
(687, 'sanni', '{"void_item":{"id":"26208","date":"2017-03-26 13:00:27","ss_terminal":null,"ss_code":null,"sale_id":"8038","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-26 13:00:27","serial":"admin-1490503360-14905044272689934","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-26 13:10:47', NULL, ''),
(688, 'sanni', '{"void_item":{"id":"26214","date":"2017-03-26 13:02:05","ss_terminal":null,"ss_code":null,"sale_id":"8040","si_item_id":"0","item_id":"272","item_sku":"206","item_name":"Genius in The Bowl","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-26 13:02:05","serial":"admin-1490503360-14905045252508998","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-26 13:32:39', NULL, ''),
(689, 'sanni', '{"void_item":{"id":"26520","date":"2017-03-29 13:24:53","ss_terminal":null,"ss_code":null,"sale_id":"8111","si_item_id":null,"item_id":"22","item_sku":"22","item_name":"Honey Milk","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-29 13:24:53","serial":"admin-1490764197-14907650936356020","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-29 13:30:18', NULL, ''),
(690, 'lois', '{"sale":{"id":"8105","txn_no":null,"table_no":"T15","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-03-29 12:50:42","payment_status":"Unpaid","cost":null,"subtotal":"7.00","amount":"7.70","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1490756895","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"26523","date":"2017-03-29 13:45:20","ss_terminal":null,"ss_code":null,"sale_id":"8105","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-29 13:45:20","serial":"admin-1490764197-14907663204864464","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"26492","date":"2017-03-29 12:50:42","ss_terminal":null,"ss_code":null,"sale_id":"8105","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.70","margin":"0.0000","cost":"0.0000","amount":"0.70","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-29 12:50:42","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-03-29 17:41:27', NULL, ''),
(691, 'sanni', '{"void_item":{"id":"26554","date":"2017-03-30 10:31:50","ss_terminal":null,"ss_code":null,"sale_id":"8122","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Cheesy Chicken Gratin","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-30 10:31:50","serial":"admin-1490835159-14908411105924271","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-30 10:34:26', NULL, ''),
(692, 'sanni', '{"void_item":{"id":"26606","date":"2017-03-30 13:56:40","ss_terminal":null,"ss_code":null,"sale_id":"8133","si_item_id":"0","item_id":"76","item_sku":"76","item_name":"Meatless Pesto Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-30 13:56:40","serial":"admin-1490846116-1490853400463548","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-30 14:31:07', NULL, ''),
(693, 'lois', '{"void_item":{"id":"26639","date":"2017-03-30 16:54:00","ss_terminal":null,"ss_code":null,"sale_id":"8143","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-30 16:54:00","serial":"admin-1490846116-14908640404718646","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-30 17:29:34', NULL, ''),
(694, 'sanni', '{"void_item":{"id":"26705","date":"2017-03-31 12:32:33","ss_terminal":null,"ss_code":null,"sale_id":"8158","si_item_id":"0","item_id":"220","item_sku":"154","item_name":"Smoked Bacon Basil Pesto","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-31 12:32:33","serial":"admin-1490926551-14909347537505994","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-03-31 12:34:00', NULL, ''),
(695, 'lois', '{"sale":{"id":"8164","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-03-31 15:25:03","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1490934758","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2017-03-31 16:47:16', NULL, ''),
(696, 'lois', '{"sale":{"id":"8166","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-03-31 17:10:39","payment_status":"Unpaid","cost":null,"subtotal":"29.00","amount":"29.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1490934758","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"26735","date":"2017-03-31 17:41:54","ss_terminal":null,"ss_code":null,"sale_id":"8166","si_item_id":"0","item_id":"32","item_sku":"32","item_name":"Tea By Pot ","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-31 17:41:54","serial":"admin-1490934758-14909533145427086","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"26736","date":"2017-03-31 17:43:31","ss_terminal":null,"ss_code":null,"sale_id":"8166","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-31 17:43:31","serial":"admin-1490934758-14909534113606694","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-03-31 18:06:58', NULL, ''),
(697, 'lois', '{"sale":{"id":"8167","txn_no":null,"table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-03-31 17:10:42","payment_status":"Unpaid","cost":null,"subtotal":"19.00","amount":"19.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1490934758","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"26737","date":"2017-03-31 18:06:41","ss_terminal":null,"ss_code":null,"sale_id":"8167","si_item_id":null,"item_id":"33","item_sku":"33","item_name":"Cucumber Lime ","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-31 18:06:41","serial":"admin-1490934758-14909548011496664","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"26738","date":"2017-03-31 18:06:41","ss_terminal":null,"ss_code":null,"sale_id":"8167","si_item_id":null,"item_id":"66","item_sku":"66","item_name":"Watermelon ","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-03-31 18:06:41","serial":"admin-1490934758-14909548011496664","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-03-31 18:07:46', NULL, ''),
(698, 'sanni', '{"void_item":{"id":"26805","date":"2017-04-01 12:16:13","ss_terminal":null,"ss_code":null,"sale_id":"8184","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"fried egg","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"1.50","margin":"1.5000","cost":"0.0000","amount":"1.50","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-01 12:16:13","serial":"admin-1491016270-14910201730105046","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-01 12:19:34', NULL, ''),
(699, 'lois', '{"void_item":{"id":"27112","date":"2017-04-03 13:11:13","ss_terminal":null,"ss_code":null,"sale_id":"8258","si_item_id":"0","item_id":"182","item_sku":"117","item_name":"Open Drinks ","item_option":"esp shot","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"1.50","margin":"1.5000","cost":"0.0000","amount":"1.50","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-03 13:11:13","serial":"admin-1491196225-14911962731686333","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-03 14:09:34', NULL, ''),
(700, 'sanni', '{"sale":{"id":"8277","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-04-05 10:42:03","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1491354607","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"27181","date":"2017-04-05 10:42:03","ss_terminal":null,"ss_code":null,"sale_id":"8277","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-05 10:42:03","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-04-05 10:51:56', NULL, ''),
(701, 'sanni', '{"sale":{"id":"8289","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-04-05 13:19:53","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1491368731","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"27230","date":"2017-04-05 13:19:53","ss_terminal":null,"ss_code":null,"sale_id":"8289","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-05 13:19:53","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-04-05 13:20:10', NULL, ''),
(702, 'sanni', '{"sale":{"id":"8291","txn_no":null,"table_no":"T10","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-04-05 14:01:10","payment_status":"Unpaid","cost":null,"subtotal":"14.00","amount":"15.40","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1491368731","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"27239","date":"2017-04-05 14:01:19","ss_terminal":null,"ss_code":null,"sale_id":"8291","si_item_id":null,"item_id":"1","item_sku":"1","item_name":"Espresso","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-05 14:01:19","serial":"admin-1491368731-14913720794906016","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"27238","date":"2017-04-05 14:01:19","ss_terminal":null,"ss_code":null,"sale_id":"8291","si_item_id":"0","item_id":"269","item_sku":"203","item_name":"Espresso Con Panna","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-05 14:01:19","serial":"admin-1491368731-14913720794906016","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"27237","date":"2017-04-05 14:01:10","ss_terminal":null,"ss_code":null,"sale_id":"8291","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.40","margin":"0.0000","cost":"0.0000","amount":"1.40","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-05 14:01:10","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-04-05 15:15:53', NULL, ''),
(703, 'sanni', '{"void_item":{"id":"27305","date":"2017-04-06 17:06:10","ss_terminal":null,"ss_code":null,"sale_id":"8307","si_item_id":"0","item_id":"20","item_sku":"20","item_name":"Iced DD Special","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-06 17:06:10","serial":"admin-1491453550-14914695699239791","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-06 17:30:20', NULL, ''),
(704, 'sanni', '{"sale":{"id":"8316","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-04-07 10:08:45","payment_status":"Unpaid","cost":null,"subtotal":"12.00","amount":"13.20","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1491525861","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"27342","date":"2017-04-07 10:08:45","ss_terminal":null,"ss_code":null,"sale_id":"8316","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.20","margin":"0.0000","cost":"0.0000","amount":"1.20","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-07 10:08:45","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"27343","date":"2017-04-07 10:08:50","ss_terminal":null,"ss_code":null,"sale_id":"8316","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-07 10:08:50","serial":"admin-1491525861-1491530930251535","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-04-07 10:38:41', NULL, ''),
(705, 'lois', '{"void_item":{"id":"27421","date":"2017-04-08 09:25:13","ss_terminal":null,"ss_code":null,"sale_id":"8333","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Cheesy Chicken Gratin","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-08 09:25:13","serial":"admin-1491613344-1491614713453644","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-08 09:25:39', NULL, ''),
(706, 'sanni', '{"sale":{"id":"8396","txn_no":"108149","table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-04-09 13:15:47","payment_status":"Paid","cost":null,"subtotal":"57.00","amount":"62.70","amount_cash":"62.70","amount_cc":null,"amount_tendered":"100.00","amount_change":"37.30","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1491710701","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"27713","date":"2017-04-09 13:10:07","ss_terminal":null,"ss_code":null,"sale_id":"8396","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"5.70","margin":"0.0000","cost":"0.0000","amount":"5.70","sold":"1","terminal":"27","printed":"1","session":"1491710701","ordered_by":"admin","ordered_time":"2017-04-09 13:10:07","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"27714","date":"2017-04-09 13:10:16","ss_terminal":null,"ss_code":null,"sale_id":"8396","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1491710701","ordered_by":"admin","ordered_time":"2017-04-09 13:10:16","serial":"admin-1491710701-14917146160962858","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"27715","date":"2017-04-09 13:10:16","ss_terminal":null,"ss_code":null,"sale_id":"8396","si_item_id":"0","item_id":"223","item_sku":"157","item_name":"Crispy Bacon Aglio Olio","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":"1","terminal":"27","printed":"1","session":"1491710701","ordered_by":"admin","ordered_time":"2017-04-09 13:10:16","serial":"admin-1491710701-14917146160962858","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"27717","date":"2017-04-09 13:10:16","ss_terminal":null,"ss_code":null,"sale_id":"8396","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":"1","terminal":"27","printed":"1","session":"1491710701","ordered_by":"admin","ordered_time":"2017-04-09 13:10:16","serial":"admin-1491710701-14917146160962858","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"27716","date":"2017-04-09 13:10:16","ss_terminal":null,"ss_code":null,"sale_id":"8396","si_item_id":null,"item_id":"11","item_sku":"11","item_name":"Vanilla Latte","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1491710701","ordered_by":"admin","ordered_time":"2017-04-09 13:10:16","serial":"admin-1491710701-14917146160962858","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-04-09 13:20:45', 1, ''),
(707, 'sanni', '{"void_item":{"id":"27768","date":"2017-04-09 14:26:18","ss_terminal":null,"ss_code":null,"sale_id":"8402","si_item_id":"0","item_id":"79","item_sku":"79","item_name":"Summer Salad ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-09 14:26:18","serial":"admin-1491718642-14917191785465628","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-09 14:28:38', NULL, ''),
(708, 'lois', '{"void_item":{"id":"27803","date":"2017-04-09 15:18:12","ss_terminal":null,"ss_code":null,"sale_id":"8409","si_item_id":"0","item_id":"225","item_sku":"159","item_name":"Smoked Duck Salad","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-09 15:18:12","serial":"admin-1491721105-1491722292702992","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-09 15:21:10', NULL, ''),
(709, 'lois', '{"void_item":{"id":"27802","date":"2017-04-09 15:18:12","ss_terminal":null,"ss_code":null,"sale_id":"8409","si_item_id":"0","item_id":"225","item_sku":"159","item_name":"Smoked Duck Salad","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-09 15:18:12","serial":"admin-1491721105-1491722292702992","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-09 15:21:18', NULL, ''),
(710, 'lois', '{"void_item":{"id":"27920","date":"2017-04-10 17:08:57","ss_terminal":null,"ss_code":null,"sale_id":"8432","si_item_id":"0","item_id":"235","item_sku":"169","item_name":"I''m Single","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-10 17:08:57","serial":"admin-1491804960-14918153372025554","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-10 17:09:57', NULL, ''),
(711, 'lois', '{"void_item":{"id":"27983","date":"2017-04-12 17:44:04","ss_terminal":null,"ss_code":null,"sale_id":"8451","si_item_id":"0","item_id":"72","item_sku":"72","item_name":"Mushroom Chicken","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-12 17:44:04","serial":"admin-1491958305-14919902447037480","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-12 17:45:13', NULL, ''),
(712, 'sanni', '{"void_item":{"id":"28028","date":"2017-04-13 10:49:16","ss_terminal":null,"ss_code":null,"sale_id":"8462","si_item_id":"0","item_id":"226","item_sku":"160","item_name":"Cheesy Shepherd Pie","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-13 10:49:16","serial":"admin-1492045605-1492051755997764","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-13 10:51:39', NULL, ''),
(713, 'sanni', '{"void_item":{"id":"28026","date":"2017-04-13 10:49:16","ss_terminal":null,"ss_code":null,"sale_id":"8462","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Cheesy Chicken Gratin","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-13 10:49:16","serial":"admin-1492045605-1492051755997764","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-13 10:51:50', NULL, ''),
(714, 'lois', '{"sale":{"id":"8482","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-04-14 11:53:21","payment_status":"Unpaid","cost":null,"subtotal":"23.00","amount":"23.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1492130095","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"28115","date":"2017-04-14 11:53:27","ss_terminal":null,"ss_code":null,"sale_id":"8482","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-14 11:53:27","serial":"admin-1492130095-1492142007132390","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null},{"id":"28116","date":"2017-04-14 11:53:27","ss_terminal":null,"ss_code":null,"sale_id":"8482","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-14 11:53:27","serial":"admin-1492130095-1492142007132390","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-04-14 11:55:50', NULL, ''),
(715, 'lois', '{"void_item":{"id":"28167","date":"2017-04-15 09:09:30","ss_terminal":null,"ss_code":null,"sale_id":"8496","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-15 09:09:30","serial":"admin-1492217881-14922185699761964","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-15 09:11:03', NULL, ''),
(716, 'lois', '{"sale":{"id":"8510","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-04-15 11:06:20","payment_status":"Unpaid","cost":null,"subtotal":"-5.00","amount":"-5.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1492219535","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"28243","date":"2017-04-15 11:06:23","ss_terminal":null,"ss_code":null,"sale_id":"8510","si_item_id":"0","item_id":"208","item_sku":"D0001","item_name":"RM5 DISCOUNT ","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"-5.00","margin":"-5.0000","cost":"0.0000","amount":"-5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-15 11:06:23","serial":"admin-1492219535-1492225583403467","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-04-15 11:09:03', NULL, ''),
(717, 'lois', '{"void_item":{"id":"28318","date":"2017-04-15 14:53:34","ss_terminal":null,"ss_code":null,"sale_id":"8527","si_item_id":"0","item_id":"41","item_sku":"41","item_name":"Blueberry Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-15 14:53:34","serial":"admin-1492237155-14922392138982287","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-15 14:54:00', NULL, ''),
(718, 'lois', '{"void_item":{"id":"28363","date":"2017-04-16 09:35:51","ss_terminal":null,"ss_code":null,"sale_id":"8536","si_item_id":null,"item_id":"22","item_sku":"22","item_name":"Honey Milk","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-16 09:35:51","serial":"admin-1492303857-14923065513795589","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-16 09:42:07', NULL, ''),
(719, 'lois', '{"void_item":{"id":"28408","date":"2017-04-16 10:50:02","ss_terminal":null,"ss_code":null,"sale_id":"8545","si_item_id":"0","item_id":"176","item_sku":"111","item_name":"Scones ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-16 10:50:02","serial":"admin-1492310042-14923110018175065","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-16 11:31:31', NULL, ''),
(720, 'lois', '{"void_item":{"id":"28457","date":"2017-04-16 11:33:26","ss_terminal":null,"ss_code":null,"sale_id":"8546","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Cheesy Chicken Gratin","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-16 11:33:26","serial":"admin-1492313316-1492313606577443","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-16 11:35:14', NULL, ''),
(721, 'lois', '{"void_item":{"id":"28456","date":"2017-04-16 11:33:12","ss_terminal":null,"ss_code":null,"sale_id":"8546","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-16 11:33:12","serial":"admin-1492313316-14923135926132947","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-16 11:35:22', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(722, 'lois', '{"sale":{"id":"8558","txn_no":"108301","table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-04-16 11:44:29","payment_status":"Paid","cost":null,"subtotal":"10.00","amount":"10.00","amount_cash":"10.00","amount_cc":null,"amount_tendered":"10.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1492313698","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"28474","date":"2017-04-16 11:44:26","ss_terminal":null,"ss_code":null,"sale_id":"8558","si_item_id":null,"item_id":"47","item_sku":"47","item_name":"Light coke","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":"1","terminal":"27","printed":"1","session":"1492313698","ordered_by":"admin","ordered_time":"2017-04-16 11:44:26","serial":"admin-1492313698-1492314266689440","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null},{"id":"28473","date":"2017-04-16 11:44:26","ss_terminal":null,"ss_code":null,"sale_id":"8558","si_item_id":null,"item_id":"47","item_sku":"47","item_name":"Light coke","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":"1","terminal":"27","printed":"1","session":"1492313698","ordered_by":"admin","ordered_time":"2017-04-16 11:44:26","serial":"admin-1492313698-1492314266689440","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-04-16 11:44:45', 1, ''),
(723, 'lois', '{"void_item":{"id":"28473","date":"2017-04-16 11:44:26","ss_terminal":null,"ss_code":null,"sale_id":"8558","si_item_id":null,"item_id":"47","item_sku":"47","item_name":"Light coke","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":"1","terminal":"27","printed":"1","session":"1492313698","ordered_by":"admin","ordered_time":"2017-04-16 11:44:26","serial":"admin-1492313698-1492314266689440","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}}', '2017-04-16 11:44:56', NULL, ''),
(724, '', '{"void_item":{"id":"28479","date":"2017-04-16 11:53:09","ss_terminal":null,"ss_code":null,"sale_id":"8560","si_item_id":"0","item_id":"232","item_sku":"166","item_name":"Candied Spicy Bacon Strips","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-16 11:53:09","serial":"admin-1492313698-1492314789342486","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-16 12:05:08', NULL, ''),
(725, 'lois', '{"sale":{"id":"8570","txn_no":null,"table_no":"T10","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-04-16 13:41:38","payment_status":"Unpaid","cost":null,"subtotal":"30.00","amount":"33.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1492317061","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"28532","date":"2017-04-16 13:41:38","ss_terminal":null,"ss_code":null,"sale_id":"8570","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"3.00","margin":"0.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-16 13:41:38","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"28533","date":"2017-04-16 13:42:14","ss_terminal":null,"ss_code":null,"sale_id":"8570","si_item_id":"0","item_id":"170","item_sku":"104","item_name":"Daily Cheese ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-16 13:42:14","serial":"admin-1492317061-14923213346772731","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"28534","date":"2017-04-16 13:42:14","ss_terminal":null,"ss_code":null,"sale_id":"8570","si_item_id":"0","item_id":"170","item_sku":"104","item_name":"Daily Cheese ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-16 13:42:14","serial":"admin-1492317061-14923213346772731","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"28535","date":"2017-04-16 13:42:14","ss_terminal":null,"ss_code":null,"sale_id":"8570","si_item_id":"0","item_id":"170","item_sku":"104","item_name":"Daily Cheese ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-16 13:42:14","serial":"admin-1492317061-14923213346772731","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-04-16 15:14:31', NULL, ''),
(726, 'lois', '{"void_item":{"id":"28710","date":"2017-04-22 13:18:19","ss_terminal":null,"ss_code":null,"sale_id":"8606","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-22 13:18:19","serial":"admin-1492835891-14928382996973768","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-22 13:28:53', NULL, ''),
(727, 'lois', '{"void_item":{"id":"28836","date":"2017-04-23 10:39:09","ss_terminal":null,"ss_code":null,"sale_id":"8634","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-23 10:39:09","serial":"admin-1492914672-14929151490715830","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-23 10:48:54', NULL, ''),
(728, 'lois', '{"sale":{"id":"8637","txn_no":"108389","table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-04-23 11:33:37","payment_status":"Paid","cost":null,"subtotal":"41.00","amount":"45.10","amount_cash":"45.10","amount_cc":null,"amount_tendered":"50.00","amount_change":"4.90","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1492914672","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"28848","date":"2017-04-23 10:56:29","ss_terminal":null,"ss_code":null,"sale_id":"8637","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"4.10","margin":"0.0000","cost":"0.0000","amount":"4.10","sold":"1","terminal":"27","printed":"1","session":"1492914672","ordered_by":"admin","ordered_time":"2017-04-23 10:56:29","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"28849","date":"2017-04-23 10:57:12","ss_terminal":null,"ss_code":null,"sale_id":"8637","si_item_id":"0","item_id":"24","item_sku":"24","item_name":"Chai Latte","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1492914672","ordered_by":"admin","ordered_time":"2017-04-23 10:57:12","serial":"admin-1492914672-14929162322822088","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"28850","date":"2017-04-23 10:57:12","ss_terminal":null,"ss_code":null,"sale_id":"8637","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1492914672","ordered_by":"admin","ordered_time":"2017-04-23 10:57:12","serial":"admin-1492914672-14929162322822088","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"28851","date":"2017-04-23 10:57:12","ss_terminal":null,"ss_code":null,"sale_id":"8637","si_item_id":"0","item_id":"60","item_sku":"60","item_name":"The Hulk","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1492914672","ordered_by":"admin","ordered_time":"2017-04-23 10:57:12","serial":"admin-1492914672-14929162322822088","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"28852","date":"2017-04-23 10:57:12","ss_terminal":null,"ss_code":null,"sale_id":"8637","si_item_id":null,"item_id":"45","item_sku":"45","item_name":"Soda","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":"1","terminal":"27","printed":"1","session":"1492914672","ordered_by":"admin","ordered_time":"2017-04-23 10:57:12","serial":"admin-1492914672-14929162322822088","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-04-23 11:34:48', 1, ''),
(729, 'lois', '{"void_item":{"id":"28850","date":"2017-04-23 10:57:12","ss_terminal":null,"ss_code":null,"sale_id":"8637","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1492914672","ordered_by":"admin","ordered_time":"2017-04-23 10:57:12","serial":"admin-1492914672-14929162322822088","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-23 11:35:05', NULL, ''),
(730, '', '{"void_item":{"id":"28845","date":"2017-04-23 10:50:27","ss_terminal":null,"ss_code":null,"sale_id":"8634","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-23 10:50:27","serial":"admin-1492914672-14929158273424796","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":"0.0","global_discount":null}}', '2017-04-23 11:56:12', NULL, 'Reason 1'),
(731, '', '{"void_item":{"id":"28881","date":"2017-04-23 11:52:25","ss_terminal":null,"ss_code":null,"sale_id":"8634","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-23 11:52:25","serial":"admin-1492919495-14929195448634314","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-23 11:57:18', NULL, ''),
(732, 'lois', '{"sale":{"id":"8649","txn_no":null,"table_no":"T15","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-04-23 13:02:02","payment_status":"Unpaid","cost":null,"subtotal":"29.00","amount":"31.90","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1492919495","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"28921","date":"2017-04-23 13:02:02","ss_terminal":null,"ss_code":null,"sale_id":"8649","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.90","margin":"0.0000","cost":"0.0000","amount":"2.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-23 13:02:02","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"28922","date":"2017-04-23 13:04:04","ss_terminal":null,"ss_code":null,"sale_id":"8649","si_item_id":null,"item_id":"63","item_sku":"63","item_name":"Lime","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-23 13:04:04","serial":"admin-1492919495-14929238446938515","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"28923","date":"2017-04-23 13:04:04","ss_terminal":null,"ss_code":null,"sale_id":"8649","si_item_id":"0","item_id":"225","item_sku":"159","item_name":"Smoked Duck Salad","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-23 13:04:04","serial":"admin-1492919495-14929238446938515","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-04-23 13:18:05', NULL, ''),
(733, 'lois', '{"sale":{"id":"8669","txn_no":null,"table_no":"T11","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-04-24 11:03:45","payment_status":"Unpaid","cost":null,"subtotal":"12.00","amount":"13.20","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1493000362","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"29012","date":"2017-04-24 11:03:45","ss_terminal":null,"ss_code":null,"sale_id":"8669","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.20","margin":"0.0000","cost":"0.0000","amount":"1.20","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-24 11:03:45","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"29013","date":"2017-04-24 11:03:59","ss_terminal":null,"ss_code":null,"sale_id":"8669","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-24 11:03:59","serial":"admin-1493000362-1493003039144616","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-04-24 12:17:21', NULL, ''),
(734, '', '{"void_item":{"id":"29068","date":"2017-04-24 13:07:40","ss_terminal":null,"ss_code":null,"sale_id":"8681","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-24 13:07:40","serial":"admin-1493005029-14930104603696233","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-24 13:09:04', NULL, ''),
(735, '', '{"void_item":{"id":"29095","date":"2017-04-24 14:03:10","ss_terminal":null,"ss_code":null,"sale_id":"8684","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Signature Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-24 14:03:10","serial":"admin-1493013350-14930137902647648","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-24 14:26:50', NULL, ''),
(736, '', '{"void_item":{"id":"29097","date":"2017-04-24 14:03:38","ss_terminal":null,"ss_code":null,"sale_id":"8684","si_item_id":"0","item_id":"223","item_sku":"157","item_name":"Crispy Bacon Aglio Olio","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-24 14:03:38","serial":"admin-1493013350-14930138181177957","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-24 14:26:59', NULL, ''),
(737, 'lois', '{"void_item":{"id":"29094","date":"2017-04-24 14:02:42","ss_terminal":null,"ss_code":null,"sale_id":"8685","si_item_id":"0","item_id":"236","item_sku":"170","item_name":"Vanilla Milk","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-24 14:02:42","serial":"admin-1493013350-14930137620395318","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-24 14:35:44', NULL, ''),
(738, 'lois', '{"sale":{"id":"8688","txn_no":null,"table_no":"T8","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-04-24 14:53:22","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1493014992","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"29107","date":"2017-04-24 14:53:22","ss_terminal":null,"ss_code":null,"sale_id":"8688","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-24 14:53:22","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-04-24 14:58:28', NULL, ''),
(739, 'sanni', '{"sale":{"id":"8701","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-04-26 13:39:47","payment_status":"Unpaid","cost":null,"subtotal":"15.00","amount":"16.50","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1493168226","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"29148","date":"2017-04-26 13:39:47","ss_terminal":null,"ss_code":null,"sale_id":"8701","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.50","margin":"0.0000","cost":"0.0000","amount":"1.50","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-26 13:39:47","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"29149","date":"2017-04-26 13:39:54","ss_terminal":null,"ss_code":null,"sale_id":"8701","si_item_id":"0","item_id":"20","item_sku":"20","item_name":"Iced DD Special","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-26 13:39:54","serial":"admin-1493168226-14931851938858122","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-04-26 14:21:19', NULL, ''),
(740, 'lois', '{"void_item":{"id":"29240","date":"2017-04-27 15:26:38","ss_terminal":null,"ss_code":null,"sale_id":"8725","si_item_id":"0","item_id":"30","item_sku":"30","item_name":"Iced Chai Latte","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-27 15:26:38","serial":"admin-1493268508-1493277997967632","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-27 15:33:26', NULL, ''),
(741, 'sanni', '{"void_item":{"id":"29302","date":"2017-04-28 11:49:27","ss_terminal":null,"ss_code":null,"sale_id":"8735","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-28 11:49:27","serial":"admin-1493349202-14933513671624952","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-28 11:51:33', NULL, ''),
(742, 'lois', '{"void_item":{"id":"29318","date":"2017-04-28 14:25:23","ss_terminal":null,"ss_code":null,"sale_id":"8741","si_item_id":null,"item_id":"4","item_sku":"4","item_name":"Piccolo","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-28 14:25:23","serial":"admin-1493353672-14933607234612644","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}}', '2017-04-28 14:25:34', NULL, ''),
(743, 'sanni', '{"void_item":{"id":"29394","date":"2017-04-29 14:42:36","ss_terminal":null,"ss_code":null,"sale_id":"8757","si_item_id":"0","item_id":"232","item_sku":"166","item_name":"Candied Spicy Bacon Strips","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-29 14:42:36","serial":"admin-1493445398-1493448156315549","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-29 14:45:19', NULL, ''),
(744, 'lois', '{"void_item":{"id":"29437","date":"2017-04-29 18:18:28","ss_terminal":null,"ss_code":null,"sale_id":"8767","si_item_id":"0","item_id":"275","item_sku":"209","item_name":"Carlsberg","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-29 18:18:28","serial":"admin-1493445398-1493461108419851","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-29 18:53:00', NULL, ''),
(745, 'sanni', '{"void_item":{"id":"29566","date":"2017-04-30 12:36:24","ss_terminal":null,"ss_code":null,"sale_id":"8795","si_item_id":"0","item_id":"272","item_sku":"206","item_name":"Genius in The Bowl","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-30 12:36:24","serial":"admin-1493523673-14935269846204776","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-04-30 12:40:34', NULL, ''),
(746, 'lois', '{"sale":{"id":"8802","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-04-30 13:41:16","payment_status":"Unpaid","cost":null,"subtotal":"9.00","amount":"9.90","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1493527337","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"29627","date":"2017-04-30 13:42:45","ss_terminal":null,"ss_code":null,"sale_id":"8802","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-30 13:42:45","serial":"admin-1493530943-149353096571282","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"29624","date":"2017-04-30 13:41:16","ss_terminal":null,"ss_code":null,"sale_id":"8802","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.90","margin":"0.0000","cost":"0.0000","amount":"0.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-04-30 13:41:16","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-04-30 13:44:14', NULL, ''),
(747, 'lois', '{"void_item":{"id":"29820","date":"2017-05-01 11:01:51","ss_terminal":null,"ss_code":null,"sale_id":"8835","si_item_id":"0","item_id":"28","item_sku":"28","item_name":"Iced Honey Milk","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-01 11:01:51","serial":"admin-1493605313-14936077108926822","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-01 11:52:53', NULL, ''),
(748, 'lois', '{"sale":{"id":"8856","txn_no":"108598","table_no":"T12","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-05-01 14:29:32","payment_status":"Paid","cost":null,"subtotal":"54.00","amount":"59.40","amount_cash":"59.40","amount_cc":null,"amount_tendered":"100.40","amount_change":"41.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1493611353","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"29926","date":"2017-05-01 14:07:16","ss_terminal":null,"ss_code":null,"sale_id":"8856","si_item_id":"0","item_id":"247","item_sku":"181","item_name":"Caramel Chocolate Cheese","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1493611353","ordered_by":"admin","ordered_time":"2017-05-01 14:07:16","serial":"admin-1493611353-14936188365476940","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"29924","date":"2017-05-01 14:00:02","ss_terminal":null,"ss_code":null,"sale_id":"8856","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1493611353","ordered_by":"admin","ordered_time":"2017-05-01 14:00:02","serial":"admin-1493611353-14936184024722774","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"29925","date":"2017-05-01 14:00:17","ss_terminal":null,"ss_code":null,"sale_id":"8856","si_item_id":"0","item_id":"170","item_sku":"104","item_name":"Daily Cheese ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1493611353","ordered_by":"admin","ordered_time":"2017-05-01 14:00:17","serial":"admin-1493611353-1493618416924842","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"29920","date":"2017-05-01 13:59:56","ss_terminal":null,"ss_code":null,"sale_id":"8856","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"5.40","margin":"0.0000","cost":"0.0000","amount":"5.40","sold":"1","terminal":"27","printed":"1","session":"1493611353","ordered_by":"admin","ordered_time":"2017-05-01 13:59:56","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"29921","date":"2017-05-01 14:00:02","ss_terminal":null,"ss_code":null,"sale_id":"8856","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":"1","terminal":"27","printed":"1","session":"1493611353","ordered_by":"admin","ordered_time":"2017-05-01 14:00:02","serial":"admin-1493611353-14936184024722774","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"29922","date":"2017-05-01 14:00:02","ss_terminal":null,"ss_code":null,"sale_id":"8856","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":"1","terminal":"27","printed":"1","session":"1493611353","ordered_by":"admin","ordered_time":"2017-05-01 14:00:02","serial":"admin-1493611353-14936184024722774","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"29923","date":"2017-05-01 14:00:02","ss_terminal":null,"ss_code":null,"sale_id":"8856","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":"1","terminal":"27","printed":"1","session":"1493611353","ordered_by":"admin","ordered_time":"2017-05-01 14:00:02","serial":"admin-1493611353-14936184024722774","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-01 14:45:55', 1, ''),
(749, 'sanni', '{"void_item":{"id":"29999","date":"2017-05-03 09:06:37","ss_terminal":null,"ss_code":null,"sale_id":"8871","si_item_id":"0","item_id":"156","item_sku":"90","item_name":"House Cheddar Omelet","item_option":"add bacon","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-03 09:06:37","serial":"admin-1493773560-14937735973276153","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-03 09:17:23', NULL, ''),
(750, 'sanni', '{"void_item":{"id":"30052","date":"2017-05-03 12:47:06","ss_terminal":null,"ss_code":null,"sale_id":"8884","si_item_id":"0","item_id":"217","item_sku":"151","item_name":"Spicy Lemony Wings","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-03 12:47:06","serial":"admin-1493786746-14937868266817270","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-03 12:48:51', NULL, ''),
(751, 'lois', '{"sale":{"id":"8872","txn_no":"108615","table_no":"T1","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-05-03 09:46:51","payment_status":"Paid","cost":null,"subtotal":"57.00","amount":"62.70","amount_cash":"62.70","amount_cc":null,"amount_tendered":"70.00","amount_change":"7.30","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1493773560","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"30008","date":"2017-05-03 09:16:57","ss_terminal":null,"ss_code":null,"sale_id":"8872","si_item_id":null,"item_id":"25","item_sku":"25","item_name":"Matcha Latte","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1493773560","ordered_by":"admin","ordered_time":"2017-05-03 09:16:57","serial":"admin-1493773560-14937742175016961","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"30007","date":"2017-05-03 09:16:57","ss_terminal":null,"ss_code":null,"sale_id":"8872","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":"1","terminal":"27","printed":"1","session":"1493773560","ordered_by":"admin","ordered_time":"2017-05-03 09:16:57","serial":"admin-1493773560-14937742175016961","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"30006","date":"2017-05-03 09:16:57","ss_terminal":null,"ss_code":null,"sale_id":"8872","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1493773560","ordered_by":"admin","ordered_time":"2017-05-03 09:16:57","serial":"admin-1493773560-14937742175016961","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"30005","date":"2017-05-03 09:16:57","ss_terminal":null,"ss_code":null,"sale_id":"8872","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":"1","terminal":"27","printed":"1","session":"1493773560","ordered_by":"admin","ordered_time":"2017-05-03 09:16:57","serial":"admin-1493773560-14937742175016961","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"30004","date":"2017-05-03 09:16:45","ss_terminal":null,"ss_code":null,"sale_id":"8872","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"5.70","margin":"0.0000","cost":"0.0000","amount":"5.70","sold":"1","terminal":"27","printed":"1","session":"1493773560","ordered_by":"admin","ordered_time":"2017-05-03 09:16:45","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-03 13:39:05', 1, ''),
(752, 'lois', '{"sale":{"id":"8871","txn_no":"108616","table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-05-03 09:55:47","payment_status":"Paid","cost":null,"subtotal":"68.00","amount":"74.80","amount_cash":"74.80","amount_cc":null,"amount_tendered":"74.80","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1493776542","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"30003","date":"2017-05-03 09:06:46","ss_terminal":null,"ss_code":null,"sale_id":"8871","si_item_id":null,"item_id":"66","item_sku":"66","item_name":"Watermelon ","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1493776542","ordered_by":"admin","ordered_time":"2017-05-03 09:06:46","serial":"admin-1493773560-14937736063332722","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"30002","date":"2017-05-03 09:06:46","ss_terminal":null,"ss_code":null,"sale_id":"8871","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1493776542","ordered_by":"admin","ordered_time":"2017-05-03 09:06:46","serial":"admin-1493773560-14937736063332722","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"30001","date":"2017-05-03 09:06:46","ss_terminal":null,"ss_code":null,"sale_id":"8871","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1493776542","ordered_by":"admin","ordered_time":"2017-05-03 09:06:46","serial":"admin-1493773560-14937736063332722","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"30009","date":"2017-05-03 09:17:42","ss_terminal":null,"ss_code":null,"sale_id":"8871","si_item_id":"0","item_id":"156","item_sku":"90","item_name":"House Cheddar Omelet","item_option":"add bacon","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1493776542","ordered_by":"admin","ordered_time":"2017-05-03 09:17:42","serial":"admin-1493773560-14937742618777538","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"30000","date":"2017-05-03 09:06:37","ss_terminal":null,"ss_code":null,"sale_id":"8871","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":"1","terminal":"27","printed":"1","session":"1493776542","ordered_by":"admin","ordered_time":"2017-05-03 09:06:37","serial":"admin-1493773560-14937735973276153","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"29998","date":"2017-05-03 09:06:20","ss_terminal":null,"ss_code":null,"sale_id":"8871","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"6.80","margin":"0.0000","cost":"0.0000","amount":"6.80","sold":"1","terminal":"27","printed":"1","session":"1493776542","ordered_by":"admin","ordered_time":"2017-05-03 09:06:20","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-03 13:39:14', 1, ''),
(753, 'lois', '{"sale":{"id":"8879","txn_no":"108621","table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-05-03 11:57:15","payment_status":"Paid","cost":null,"subtotal":"15.00","amount":"16.50","amount_cash":"16.50","amount_cc":null,"amount_tendered":"20.00","amount_change":"3.50","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1493776542","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"30036","date":"2017-05-03 11:29:27","ss_terminal":null,"ss_code":null,"sale_id":"8879","si_item_id":"0","item_id":"159","item_sku":"93","item_name":"Fruits & Yogurt Granola","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1493776542","ordered_by":"admin","ordered_time":"2017-05-03 11:29:27","serial":"admin-1493776542-14937821668394573","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"30035","date":"2017-05-03 11:29:23","ss_terminal":null,"ss_code":null,"sale_id":"8879","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.50","margin":"0.0000","cost":"0.0000","amount":"1.50","sold":"1","terminal":"27","printed":"1","session":"1493776542","ordered_by":"admin","ordered_time":"2017-05-03 11:29:23","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-03 13:39:25', 1, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(754, 'lois', '{"sale":{"id":"8879","txn_no":"108621","table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-05-03 11:57:15","payment_status":"Unpaid","cost":null,"subtotal":"15.00","amount":"16.50","amount_cash":"16.50","amount_cc":null,"amount_tendered":"20.00","amount_change":"3.50","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1493776542","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"30036","date":"2017-05-03 11:29:27","ss_terminal":null,"ss_code":null,"sale_id":"8879","si_item_id":"0","item_id":"159","item_sku":"93","item_name":"Fruits & Yogurt Granola","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1493776542","ordered_by":"admin","ordered_time":"2017-05-03 11:29:27","serial":"admin-1493776542-14937821668394573","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"30035","date":"2017-05-03 11:29:23","ss_terminal":null,"ss_code":null,"sale_id":"8879","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.50","margin":"0.0000","cost":"0.0000","amount":"1.50","sold":"1","terminal":"27","printed":"1","session":"1493776542","ordered_by":"admin","ordered_time":"2017-05-03 11:29:23","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-03 13:39:53', NULL, ''),
(755, 'lois', '{"sale":{"id":"8871","txn_no":"108616","table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-05-03 09:55:47","payment_status":"Unpaid","cost":null,"subtotal":"68.00","amount":"74.80","amount_cash":"74.80","amount_cc":null,"amount_tendered":"74.80","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1493776542","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"30003","date":"2017-05-03 09:06:46","ss_terminal":null,"ss_code":null,"sale_id":"8871","si_item_id":null,"item_id":"66","item_sku":"66","item_name":"Watermelon ","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1493776542","ordered_by":"admin","ordered_time":"2017-05-03 09:06:46","serial":"admin-1493773560-14937736063332722","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"30002","date":"2017-05-03 09:06:46","ss_terminal":null,"ss_code":null,"sale_id":"8871","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1493776542","ordered_by":"admin","ordered_time":"2017-05-03 09:06:46","serial":"admin-1493773560-14937736063332722","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"30001","date":"2017-05-03 09:06:46","ss_terminal":null,"ss_code":null,"sale_id":"8871","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1493776542","ordered_by":"admin","ordered_time":"2017-05-03 09:06:46","serial":"admin-1493773560-14937736063332722","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"30009","date":"2017-05-03 09:17:42","ss_terminal":null,"ss_code":null,"sale_id":"8871","si_item_id":"0","item_id":"156","item_sku":"90","item_name":"House Cheddar Omelet","item_option":"add bacon","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1493776542","ordered_by":"admin","ordered_time":"2017-05-03 09:17:42","serial":"admin-1493773560-14937742618777538","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"30000","date":"2017-05-03 09:06:37","ss_terminal":null,"ss_code":null,"sale_id":"8871","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":"1","terminal":"27","printed":"1","session":"1493776542","ordered_by":"admin","ordered_time":"2017-05-03 09:06:37","serial":"admin-1493773560-14937735973276153","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"29998","date":"2017-05-03 09:06:20","ss_terminal":null,"ss_code":null,"sale_id":"8871","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"6.80","margin":"0.0000","cost":"0.0000","amount":"6.80","sold":"1","terminal":"27","printed":"1","session":"1493776542","ordered_by":"admin","ordered_time":"2017-05-03 09:06:20","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-03 13:40:02', NULL, ''),
(756, 'lois', '{"sale":{"id":"8872","txn_no":"108615","table_no":"T1","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-05-03 09:46:51","payment_status":"Unpaid","cost":null,"subtotal":"57.00","amount":"62.70","amount_cash":"62.70","amount_cc":null,"amount_tendered":"70.00","amount_change":"7.30","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1493773560","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"30008","date":"2017-05-03 09:16:57","ss_terminal":null,"ss_code":null,"sale_id":"8872","si_item_id":null,"item_id":"25","item_sku":"25","item_name":"Matcha Latte","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1493773560","ordered_by":"admin","ordered_time":"2017-05-03 09:16:57","serial":"admin-1493773560-14937742175016961","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"30007","date":"2017-05-03 09:16:57","ss_terminal":null,"ss_code":null,"sale_id":"8872","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":"1","terminal":"27","printed":"1","session":"1493773560","ordered_by":"admin","ordered_time":"2017-05-03 09:16:57","serial":"admin-1493773560-14937742175016961","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"30006","date":"2017-05-03 09:16:57","ss_terminal":null,"ss_code":null,"sale_id":"8872","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1493773560","ordered_by":"admin","ordered_time":"2017-05-03 09:16:57","serial":"admin-1493773560-14937742175016961","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"30005","date":"2017-05-03 09:16:57","ss_terminal":null,"ss_code":null,"sale_id":"8872","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":"1","terminal":"27","printed":"1","session":"1493773560","ordered_by":"admin","ordered_time":"2017-05-03 09:16:57","serial":"admin-1493773560-14937742175016961","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"30004","date":"2017-05-03 09:16:45","ss_terminal":null,"ss_code":null,"sale_id":"8872","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"5.70","margin":"0.0000","cost":"0.0000","amount":"5.70","sold":"1","terminal":"27","printed":"1","session":"1493773560","ordered_by":"admin","ordered_time":"2017-05-03 09:16:45","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-03 13:40:12', NULL, ''),
(757, 'lois', '{"sale":{"id":"8897","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-05-03 17:09:00","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1493786746","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"30102","date":"2017-05-03 17:09:00","ss_terminal":null,"ss_code":null,"sale_id":"8897","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-03 17:09:00","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-03 17:11:37', NULL, ''),
(758, 'lois', '{"void_item":{"id":"30108","date":"2017-05-04 10:00:42","ss_terminal":null,"ss_code":null,"sale_id":"8899","si_item_id":"0","item_id":"283","item_sku":"217","item_name":"Weight Gain Deal - TBP \\/ Junior BLT","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-04 10:00:42","serial":"admin-1493860053-14938632426071213","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-04 10:07:37', NULL, ''),
(759, 'lois', '{"void_item":{"id":"30107","date":"2017-05-04 10:00:42","ss_terminal":null,"ss_code":null,"sale_id":"8899","si_item_id":"0","item_id":"281","item_sku":"215","item_name":"Weight Gain Deal - Latte \\/ Junior BLT","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-04 10:00:42","serial":"admin-1493860053-14938632426071213","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-04 10:07:44', NULL, ''),
(760, 'sanni', '{"sale":{"id":"8927","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-05-05 10:44:43","payment_status":"Unpaid","cost":null,"subtotal":"15.00","amount":"16.50","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1493947164","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"30213","date":"2017-05-05 10:44:43","ss_terminal":null,"ss_code":null,"sale_id":"8927","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.50","margin":"0.0000","cost":"0.0000","amount":"1.50","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-05 10:44:43","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"30214","date":"2017-05-05 10:44:48","ss_terminal":null,"ss_code":null,"sale_id":"8927","si_item_id":"0","item_id":"38","item_sku":"38","item_name":"Mixed Berries Smoothie","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-05 10:44:48","serial":"admin-1493947164-1493952287788528","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-05 10:47:57', NULL, ''),
(761, 'lois', '{"void_item":{"id":"30421","date":"2017-05-06 15:13:10","ss_terminal":null,"ss_code":null,"sale_id":"8980","si_item_id":"0","item_id":"40","item_sku":"40","item_name":"Banana Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-06 15:13:10","serial":"admin-1494052450-14940547905118330","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-06 15:14:17', NULL, ''),
(762, 'lois', '{"void_item":{"id":"30567","date":"2017-05-07 13:32:12","ss_terminal":null,"ss_code":null,"sale_id":"9014","si_item_id":null,"item_id":"44","item_sku":"44","item_name":"Tiger ","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-07 13:32:12","serial":"admin-1494134862-1494135132583514","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-07 13:39:13', NULL, ''),
(763, 'sanni', '{"sale":{"id":"9014","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-05-07 13:31:52","payment_status":"Unpaid","cost":null,"subtotal":"45.00","amount":"49.50","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1494134862","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"30564","date":"2017-05-07 13:31:52","ss_terminal":null,"ss_code":null,"sale_id":"9014","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"4.50","margin":"0.0000","cost":"0.0000","amount":"4.50","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-07 13:31:52","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"30568","date":"2017-05-07 13:33:55","ss_terminal":null,"ss_code":null,"sale_id":"9014","si_item_id":"0","item_id":"276","item_sku":"210","item_name":"Penang Craft Beer","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-07 13:33:55","serial":"admin-1494134862-14941352354554740","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"30565","date":"2017-05-07 13:32:12","ss_terminal":null,"ss_code":null,"sale_id":"9014","si_item_id":"0","item_id":"40","item_sku":"40","item_name":"Banana Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-07 13:32:12","serial":"admin-1494134862-1494135132583514","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"30566","date":"2017-05-07 13:32:12","ss_terminal":null,"ss_code":null,"sale_id":"9014","si_item_id":null,"item_id":"33","item_sku":"33","item_name":"Cucumber Lime ","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-07 13:32:12","serial":"admin-1494134862-1494135132583514","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-07 14:39:51', NULL, ''),
(764, 'sanni', '{"sale":{"id":"9019","txn_no":"108751","table_no":"T13","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-05-07 15:09:15","payment_status":"Paid","cost":null,"subtotal":"48.00","amount":"52.80","amount_cash":"52.80","amount_cc":null,"amount_tendered":"53.00","amount_change":"0.20","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1494137946","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"30601","date":"2017-05-07 14:17:10","ss_terminal":null,"ss_code":null,"sale_id":"9019","si_item_id":null,"item_id":"12","item_sku":"12","item_name":"DD Special","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1494137946","ordered_by":"admin","ordered_time":"2017-05-07 14:17:10","serial":"admin-1494137499-14941378301355891","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"30602","date":"2017-05-07 14:17:10","ss_terminal":null,"ss_code":null,"sale_id":"9019","si_item_id":null,"item_id":"7","item_sku":"7","item_name":"Mocha ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1494137946","ordered_by":"admin","ordered_time":"2017-05-07 14:17:10","serial":"admin-1494137499-14941378301355891","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"30614","date":"2017-05-07 14:28:06","ss_terminal":null,"ss_code":null,"sale_id":"9019","si_item_id":"0","item_id":"276","item_sku":"210","item_name":"Penang Craft Beer","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":"1","terminal":"27","printed":"1","session":"1494137946","ordered_by":"admin","ordered_time":"2017-05-07 14:28:06","serial":"admin-1494137946-1494138486594836","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"30600","date":"2017-05-07 14:17:06","ss_terminal":null,"ss_code":null,"sale_id":"9019","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"4.80","margin":"0.0000","cost":"0.0000","amount":"4.80","sold":"1","terminal":"27","printed":"1","session":"1494137946","ordered_by":"admin","ordered_time":"2017-05-07 14:17:06","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-07 15:09:50', 1, ''),
(765, 'sanni', '{"void_item":{"id":"30614","date":"2017-05-07 14:28:06","ss_terminal":null,"ss_code":null,"sale_id":"9019","si_item_id":"0","item_id":"276","item_sku":"210","item_name":"Penang Craft Beer","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":"1","terminal":"27","printed":"1","session":"1494137946","ordered_by":"admin","ordered_time":"2017-05-07 14:28:06","serial":"admin-1494137946-1494138486594836","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-07 15:10:06', NULL, ''),
(766, 'lois', '{"sale":{"id":"9018","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-05-07 14:16:36","payment_status":"Unpaid","cost":null,"subtotal":"45.00","amount":"49.50","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1494137499","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"30605","date":"2017-05-07 14:18:24","ss_terminal":null,"ss_code":null,"sale_id":"9018","si_item_id":"0","item_id":"70","item_sku":"70","item_name":"Pepper Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-07 14:18:24","serial":"admin-1494137499-1494137904604432","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"30609","date":"2017-05-07 14:19:58","ss_terminal":null,"ss_code":null,"sale_id":"9018","si_item_id":"0","item_id":"19","item_sku":"19","item_name":"Iced Vanilla Latte","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-07 14:19:58","serial":"admin-1494137946-14941379978541615","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"30598","date":"2017-05-07 14:16:36","ss_terminal":null,"ss_code":null,"sale_id":"9018","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"4.50","margin":"0.0000","cost":"0.0000","amount":"4.50","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-07 14:16:36","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"30599","date":"2017-05-07 14:16:46","ss_terminal":null,"ss_code":null,"sale_id":"9018","si_item_id":"0","item_id":"40","item_sku":"40","item_name":"Banana Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-07 14:16:46","serial":"admin-1494137499-14941378059686813","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-07 15:29:55', NULL, ''),
(767, 'lois', '{"void_item":{"id":"30622","date":"2017-05-07 14:44:03","ss_terminal":null,"ss_code":null,"sale_id":"9022","si_item_id":null,"item_id":"9","item_sku":"9","item_name":"Affogato","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-07 14:44:03","serial":"admin-1494137946-1494139443466492","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-07 15:30:05', NULL, ''),
(768, 'lois', '{"void_item":{"id":"30649","date":"2017-05-08 09:18:05","ss_terminal":null,"ss_code":null,"sale_id":"9030","si_item_id":"0","item_id":"280","item_sku":"214","item_name":"Diet Meal - Piccolo \\/ Egg Sandwich","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-08 09:18:05","serial":"admin-1494205239-14942062853635196","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-08 10:09:42', NULL, ''),
(769, 'sanni', '{"sale":{"id":"9032","txn_no":null,"table_no":"T1","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-05-08 10:09:25","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1494205239","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"30652","date":"2017-05-08 10:09:25","ss_terminal":null,"ss_code":null,"sale_id":"9032","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-08 10:09:25","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-08 11:16:32', NULL, ''),
(770, 'lois', '{"void_item":{"id":"30719","date":"2017-05-08 14:35:25","ss_terminal":null,"ss_code":null,"sale_id":"9043","si_item_id":null,"item_id":"33","item_sku":"33","item_name":"Cucumber Lime ","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-08 14:35:25","serial":"admin-1494218794-14942253248804887","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-08 14:39:56', NULL, ''),
(771, 'lois', '{"sale":{"id":"9045","txn_no":null,"table_no":"T0","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-05-08 14:51:57","payment_status":"Unpaid","cost":null,"subtotal":"0.00","amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1494218794","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"30723","date":"2017-05-08 14:51:57","ss_terminal":null,"ss_code":null,"sale_id":"9045","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-08 14:51:57","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"30724","date":"2017-05-08 14:52:06","ss_terminal":null,"ss_code":null,"sale_id":"9045","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"come to take the scone","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-08 14:52:06","serial":"admin-1494218794-14942263266787930","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-08 15:01:17', NULL, ''),
(772, 'sanni', '{"void_item":{"id":"30794","date":"2017-05-10 10:32:48","ss_terminal":null,"ss_code":null,"sale_id":"9057","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Cheesy Chicken Gratin","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-10 10:32:48","serial":"admin-1494383458-14943835685928887","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-10 10:37:05', NULL, ''),
(773, 'sanni', '{"sale":{"id":"9071","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-05-10 12:44:35","payment_status":"Unpaid","cost":null,"subtotal":"30.00","amount":"33.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1494389252","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"30866","date":"2017-05-10 12:44:35","ss_terminal":null,"ss_code":null,"sale_id":"9071","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"3.00","margin":"0.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-10 12:44:35","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"30867","date":"2017-05-10 12:44:53","ss_terminal":null,"ss_code":null,"sale_id":"9071","si_item_id":"0","item_id":"226","item_sku":"160","item_name":"Cheesy Shepherd Pie","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-10 12:44:53","serial":"admin-1494389252-14943914929718436","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"30868","date":"2017-05-10 12:48:50","ss_terminal":null,"ss_code":null,"sale_id":"9071","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-10 12:48:50","serial":"admin-1494389252-14943917304288390","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-10 12:50:29', NULL, ''),
(774, 'sanni', '{"sale":{"id":"9083","txn_no":null,"table_no":"T8","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-05-11 09:52:40","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1494463371","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"30915","date":"2017-05-11 09:52:40","ss_terminal":null,"ss_code":null,"sale_id":"9083","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-11 09:52:40","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-11 09:52:55', NULL, ''),
(775, 'sanni', '{"void_item":{"id":"30998","date":"2017-05-12 09:50:09","ss_terminal":null,"ss_code":null,"sale_id":"9104","si_item_id":"0","item_id":"282","item_sku":"216","item_name":"Weight Gain Deal - Cappucino \\/ Junior BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-12 09:50:09","serial":"admin-1494551748-14945538092425141","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-12 09:50:46', NULL, ''),
(776, 'lois', '{"sale":{"id":"9124","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-05-12 13:56:35","payment_status":"Unpaid","cost":null,"subtotal":"12.00","amount":"13.20","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1494567519","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"31081","date":"2017-05-12 13:56:40","ss_terminal":null,"ss_code":null,"sale_id":"9124","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-12 13:56:40","serial":"admin-1494567519-14945685999082226","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"31080","date":"2017-05-12 13:56:35","ss_terminal":null,"ss_code":null,"sale_id":"9124","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.20","margin":"0.0000","cost":"0.0000","amount":"1.20","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-12 13:56:35","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-12 14:08:02', NULL, ''),
(777, 'lois', '{"void_item":{"id":"31099","date":"2017-05-12 15:57:51","ss_terminal":null,"ss_code":null,"sale_id":"9128","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-12 15:57:51","serial":"admin-1494567519-14945758713377641","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-12 16:48:31', NULL, ''),
(778, 'lois', '{"sale":{"id":"9133","txn_no":null,"table_no":"T2(S)","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-05-12 16:49:38","payment_status":"Unpaid","cost":null,"subtotal":"8.00","amount":"8.80","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1494567519","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":null,"customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":null},"sale_items":[{"id":"31109","date":"2017-05-12 00:00:00","ss_terminal":null,"ss_code":null,"sale_id":"9133","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":null,"subcategory":null,"qty":"1","price_per_unit":"0.80","margin":null,"cost":null,"amount":"0.80","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-12 15:29:29","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"31108","date":"2017-05-12 00:00:00","ss_terminal":null,"ss_code":null,"sale_id":"9133","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":null,"cost":null,"amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-12 15:57:51","serial":"admin-1494567519-14945758713377641","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-12 16:49:46', NULL, ''),
(779, 'lois', '{"void_item":{"id":"31206","date":"2017-05-13 11:27:22","ss_terminal":null,"ss_code":null,"sale_id":"9145","si_item_id":"0","item_id":"158","item_sku":"92","item_name":"Banana Stuffed Nutella Toast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-13 11:27:22","serial":"admin-1494644569-14946460423414273","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-13 11:36:57', NULL, ''),
(780, 'lois', '{"sale":{"id":"9150","txn_no":null,"table_no":"T11","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-05-13 11:20:55","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1494644569","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"31200","date":"2017-05-13 11:20:55","ss_terminal":null,"ss_code":null,"sale_id":"9150","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-13 11:20:55","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-13 11:50:21', NULL, ''),
(781, 'lois', '{"void_item":{"id":"31287","date":"2017-05-13 13:23:24","ss_terminal":null,"ss_code":null,"sale_id":"9168","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Cheesy Chicken Gratin","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-13 13:23:24","serial":"admin-1494650176-14946530040216465","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-13 13:25:33', NULL, ''),
(782, 'lois', '{"void_item":{"id":"31312","date":"2017-05-13 14:18:34","ss_terminal":null,"ss_code":null,"sale_id":"9175","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"9.40","margin":"0.0000","cost":"0.0000","amount":"9.40","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-13 14:18:34","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-13 15:04:41', NULL, ''),
(783, 'sanni', '{"sale":{"id":"9182","txn_no":null,"table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-05-13 18:08:34","payment_status":"Unpaid","cost":null,"subtotal":"21.00","amount":"23.10","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1494650176","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"31337","date":"2017-05-13 18:08:34","ss_terminal":null,"ss_code":null,"sale_id":"9182","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.10","margin":"0.0000","cost":"0.0000","amount":"2.10","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-13 18:08:34","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"31338","date":"2017-05-13 18:12:28","ss_terminal":null,"ss_code":null,"sale_id":"9182","si_item_id":"0","item_id":"276","item_sku":"210","item_name":"Penang Craft Beer","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-13 18:12:28","serial":"admin-1494650176-14946703486157039","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-13 18:13:54', NULL, ''),
(784, 'sanni', '{"void_item":{"id":"31378","date":"2017-05-14 09:51:58","ss_terminal":null,"ss_code":null,"sale_id":"9188","si_item_id":null,"item_id":"62","item_sku":"62","item_name":"Orange","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-14 09:51:58","serial":"admin-1494723283-1494726717992239","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-14 10:03:00', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(785, 'sanni', '{"void_item":{"id":"31616","date":"2017-05-14 14:20:51","ss_terminal":null,"ss_code":null,"sale_id":"9226","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-14 14:20:51","serial":"admin-1494741275-14947428509316272","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-14 14:24:08', NULL, ''),
(786, 'sanni', '{"void_item":{"id":"31687","date":"2017-05-15 11:25:15","ss_terminal":null,"ss_code":null,"sale_id":"9250","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Cheesy Chicken Gratin","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-15 11:25:15","serial":"admin-1494812307-1494818714988602","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-15 11:27:40', NULL, ''),
(787, 'sanni', '{"sale":{"id":"9281","txn_no":null,"table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-05-17 11:18:38","payment_status":"Unpaid","cost":null,"subtotal":"31.00","amount":"34.10","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1494990515","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"31805","date":"2017-05-17 11:18:50","ss_terminal":null,"ss_code":null,"sale_id":"9281","si_item_id":null,"item_id":"11","item_sku":"11","item_name":"Vanilla Latte","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-17 11:18:50","serial":"admin-1494990515-14949911307629916","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"31804","date":"2017-05-17 11:18:50","ss_terminal":null,"ss_code":null,"sale_id":"9281","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-17 11:18:50","serial":"admin-1494990515-14949911307629916","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"31803","date":"2017-05-17 11:18:38","ss_terminal":null,"ss_code":null,"sale_id":"9281","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"3.10","margin":"0.0000","cost":"0.0000","amount":"3.10","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-17 11:18:38","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-17 11:51:41', NULL, ''),
(788, 'lois', '{"void_item":{"id":"31855","date":"2017-05-17 13:01:55","ss_terminal":null,"ss_code":null,"sale_id":"9290","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"5.40","margin":"0.0000","cost":"0.0000","amount":"5.40","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-17 13:01:55","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-17 16:11:21', NULL, ''),
(789, 'sanni', '{"void_item":{"id":"31907","date":"2017-05-18 12:12:38","ss_terminal":null,"ss_code":null,"sale_id":"9303","si_item_id":null,"item_id":"11","item_sku":"11","item_name":"Vanilla Latte","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-18 12:12:38","serial":"admin-1495069191-14950807578933930","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-18 12:16:08', NULL, ''),
(790, 'sanni', '{"void_item":{"id":"32150","date":"2017-05-20 15:01:03","ss_terminal":null,"ss_code":null,"sale_id":"9366","si_item_id":null,"item_id":"1","item_sku":"1","item_name":"Espresso","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-20 15:01:03","serial":"admin-1495255615-14952636635238772","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-20 15:03:44', NULL, ''),
(791, 'lois', '{"void_item":{"id":"32296","date":"2017-05-21 13:33:05","ss_terminal":null,"ss_code":null,"sale_id":"9397","si_item_id":"0","item_id":"170","item_sku":"104","item_name":"Daily Cheese ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-21 13:33:05","serial":"admin-1495337880-14953447855171965","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-21 13:43:37', NULL, ''),
(792, 'sanni', '{"void_item":{"id":"32431","date":"2017-05-22 11:22:50","ss_terminal":null,"ss_code":null,"sale_id":"9432","si_item_id":"0","item_id":"281","item_sku":"215","item_name":"Weight Gain Deal - Latte \\/ Junior BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-22 11:22:50","serial":"admin-1495423135-14954233705666782","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-22 11:23:26', NULL, ''),
(793, 'lois', '{"void_item":{"id":"32462","date":"2017-05-22 14:37:56","ss_terminal":null,"ss_code":null,"sale_id":"9440","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"mummy pasta dont out chilie flakes","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-22 14:37:56","serial":"admin-1495425366-14954350767099926","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-22 14:38:09', NULL, ''),
(794, 'lois', '{"void_item":{"id":"32465","date":"2017-05-22 14:56:52","ss_terminal":null,"ss_code":null,"sale_id":"9439","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"Come an dhelp me to toast the scone","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-22 14:56:52","serial":"admin-1495425366-14954362124596062","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-22 14:57:10', NULL, ''),
(795, 'lois', '{"void_item":{"id":"32647","date":"2017-05-25 14:26:00","ss_terminal":null,"ss_code":null,"sale_id":"9491","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.20","margin":"0.0000","cost":"0.0000","amount":"1.20","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-25 14:26:00","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-25 15:31:58', NULL, ''),
(796, 'lois', '{"void_item":{"id":"32669","date":"2017-05-25 17:13:16","ss_terminal":null,"ss_code":null,"sale_id":"9494","si_item_id":"0","item_id":"34","item_sku":"34","item_name":"Ginger Lemongrass Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-25 17:13:16","serial":"admin-1495690898-1495703595926361","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-25 17:18:47', NULL, ''),
(797, 'sanni', '{"sale":{"id":"9519","txn_no":"109237","table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-05-26 11:51:19","payment_status":"Paid","cost":null,"subtotal":"48.00","amount":"52.80","amount_cash":"52.80","amount_cc":null,"amount_tendered":"100.00","amount_change":"47.20","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1495768302","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"32751","date":"2017-05-26 11:31:52","ss_terminal":null,"ss_code":null,"sale_id":"9519","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"4.80","margin":"0.0000","cost":"0.0000","amount":"4.80","sold":"1","terminal":"27","printed":"1","session":"1495768302","ordered_by":"admin","ordered_time":"2017-05-26 11:31:52","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"32752","date":"2017-05-26 11:32:03","ss_terminal":null,"ss_code":null,"sale_id":"9519","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"French Toast with Fruits","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1495768302","ordered_by":"admin","ordered_time":"2017-05-26 11:32:03","serial":"admin-1495768302-14957695229264484","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"32753","date":"2017-05-26 11:32:03","ss_terminal":null,"ss_code":null,"sale_id":"9519","si_item_id":"0","item_id":"156","item_sku":"90","item_name":"House Cheddar Omelet","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1495768302","ordered_by":"admin","ordered_time":"2017-05-26 11:32:03","serial":"admin-1495768302-14957695229264484","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"32754","date":"2017-05-26 11:32:07","ss_terminal":null,"ss_code":null,"sale_id":"9519","si_item_id":"0","item_id":"184","item_sku":"119","item_name":"Flat White","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1495768302","ordered_by":"admin","ordered_time":"2017-05-26 11:32:07","serial":"admin-1495768302-14957695275514166","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"32755","date":"2017-05-26 11:32:07","ss_terminal":null,"ss_code":null,"sale_id":"9519","si_item_id":"0","item_id":"184","item_sku":"119","item_name":"Flat White","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1495768302","ordered_by":"admin","ordered_time":"2017-05-26 11:32:07","serial":"admin-1495768302-14957695275514166","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-26 11:52:25', 1, ''),
(798, 'sanni', '{"void_item":{"id":"32773","date":"2017-05-26 13:05:59","ss_terminal":null,"ss_code":null,"sale_id":"9521","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-26 13:05:59","serial":"admin-1495768302-14957751595238221","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-26 13:07:00', NULL, ''),
(799, 'lois', '{"void_item":{"id":"32905","date":"2017-05-27 10:22:26","ss_terminal":null,"ss_code":null,"sale_id":"9542","si_item_id":"0","item_id":"261","item_sku":"195","item_name":"Marble Cheese","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-27 10:22:26","serial":"admin-1495850051-14958517466116468","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-27 10:31:58', NULL, ''),
(800, 'sanni', '{"void_item":{"id":"32947","date":"2017-05-27 11:01:16","ss_terminal":null,"ss_code":null,"sale_id":"9555","si_item_id":"0","item_id":"156","item_sku":"90","item_name":"House Cheddar Omelet","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-27 11:01:16","serial":"admin-1495853268-14958540764385642","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-27 12:08:47', NULL, ''),
(801, 'sanni', '{"void_item":{"id":"33008","date":"2017-05-27 11:53:52","ss_terminal":null,"ss_code":null,"sale_id":"9567","si_item_id":null,"item_id":"9","item_sku":"9","item_name":"Affogato","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-27 11:53:52","serial":"admin-1495854225-1495857232249182","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-27 12:41:32', NULL, ''),
(802, 'sanni', '{"void_item":{"id":"33058","date":"2017-05-27 13:32:56","ss_terminal":null,"ss_code":null,"sale_id":"9577","si_item_id":"0","item_id":"176","item_sku":"111","item_name":"Scones ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-27 13:32:56","serial":"admin-1495861619-14958631766716692","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-27 13:37:15', NULL, ''),
(803, 'lois', '{"void_item":{"id":"33114","date":"2017-05-27 14:18:51","ss_terminal":null,"ss_code":null,"sale_id":"9579","si_item_id":"0","item_id":"79","item_sku":"79","item_name":"Summer Salad ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-27 14:18:51","serial":"admin-1495865063-14958659309066777","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-27 14:24:28', NULL, ''),
(804, 'lois', '{"void_item":{"id":"33091","date":"2017-05-27 14:03:53","ss_terminal":null,"ss_code":null,"sale_id":"9579","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Signature Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-27 14:03:53","serial":"admin-1495864484-14958650332543139","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-27 14:24:42', NULL, ''),
(805, 'sanni', '{"sale":{"id":"9580","txn_no":null,"table_no":"T10","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-05-27 13:52:35","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1495861619","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"33076","date":"2017-05-27 13:52:35","ss_terminal":null,"ss_code":null,"sale_id":"9580","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-27 13:52:35","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-27 14:41:25', NULL, ''),
(806, 'sanni', '{"void_item":{"id":"33274","date":"2017-05-28 11:53:53","ss_terminal":null,"ss_code":null,"sale_id":"9601","si_item_id":"0","item_id":"159","item_sku":"93","item_name":"Fruits & Yogurt Granola","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-28 11:53:53","serial":"admin-1495942548-14959436330695269","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-28 12:04:08', NULL, ''),
(807, 'lois', '{"void_item":{"id":"33296","date":"2017-05-28 12:37:50","ss_terminal":null,"ss_code":null,"sale_id":"9619","si_item_id":"0","item_id":"208","item_sku":"D0001","item_name":"RM5 DISCOUNT ","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"-5.00","margin":"-5.0000","cost":"0.0000","amount":"-5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-28 12:37:50","serial":"admin-1495945072-14959462706587720","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}}', '2017-05-28 12:38:15', NULL, ''),
(808, 'sanni', '{"void_item":{"id":"33306","date":"2017-05-28 13:12:24","ss_terminal":null,"ss_code":null,"sale_id":"9621","si_item_id":"0","item_id":"236","item_sku":"170","item_name":"Vanilla Milk","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-28 13:12:24","serial":"admin-1495946282-14959483437379893","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-28 13:17:04', NULL, ''),
(809, 'sanni', '{"sale":{"id":"9625","txn_no":null,"table_no":"T8","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-05-28 13:31:22","payment_status":"Unpaid","cost":null,"subtotal":"10.00","amount":"11.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1495946282","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"33320","date":"2017-05-28 13:31:22","ss_terminal":null,"ss_code":null,"sale_id":"9625","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.00","margin":"0.0000","cost":"0.0000","amount":"1.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-28 13:31:22","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"33321","date":"2017-05-28 13:31:27","ss_terminal":null,"ss_code":null,"sale_id":"9625","si_item_id":null,"item_id":"33","item_sku":"33","item_name":"Cucumber Lime ","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-28 13:31:27","serial":"admin-1495946282-14959494868798175","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-28 13:33:11', NULL, ''),
(810, 'sanni', '{"sale":{"id":"9619","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-05-28 12:37:46","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1495945072","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2017-05-28 13:37:21', NULL, ''),
(811, 'sanni', '{"sale":{"id":"9628","txn_no":null,"table_no":"T1","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-05-28 13:45:05","payment_status":"Unpaid","cost":null,"subtotal":"14.00","amount":"15.40","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1495946282","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"33329","date":"2017-05-28 13:45:05","ss_terminal":null,"ss_code":null,"sale_id":"9628","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.40","margin":"0.0000","cost":"0.0000","amount":"1.40","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-28 13:45:05","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"33330","date":"2017-05-28 13:45:13","ss_terminal":null,"ss_code":null,"sale_id":"9628","si_item_id":"0","item_id":"49","item_sku":"49","item_name":"Mocha Frappe","item_option":"","category":"Cold Drinks","subcategory":"Frappe","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-28 13:45:13","serial":"admin-1495946282-14959503136542193","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-05-28 14:23:23', NULL, ''),
(812, 'sanni', '{"sale":{"id":"9656","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-05-29 11:31:56","payment_status":"Unpaid","cost":null,"subtotal":"20.00","amount":"20.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1496027243","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"33455","date":"2017-05-29 11:32:08","ss_terminal":null,"ss_code":null,"sale_id":"9656","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-29 11:32:08","serial":"admin-1496027243-14960287280755075","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null},{"id":"33456","date":"2017-05-29 11:32:08","ss_terminal":null,"ss_code":null,"sale_id":"9656","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-29 11:32:08","serial":"admin-1496027243-14960287280755075","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-05-29 11:47:29', NULL, ''),
(813, 'sanni', '{"void_item":{"id":"33534","date":"2017-05-29 14:18:46","ss_terminal":null,"ss_code":null,"sale_id":"9671","si_item_id":"0","item_id":"74","item_sku":"74","item_name":"Sunrice","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-29 14:18:46","serial":"admin-1496036925-14960387262741580","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-29 14:21:55', NULL, ''),
(814, 'sanni', '{"void_item":{"id":"33630","date":"2017-05-31 13:56:59","ss_terminal":null,"ss_code":null,"sale_id":"9693","si_item_id":"0","item_id":"162","item_sku":"96","item_name":"Homemade Chicken Bite ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-31 13:56:59","serial":"admin-1496209864-14962102193551425","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-31 14:01:37', NULL, ''),
(815, 'lois', '{"void_item":{"id":"33671","date":"2017-05-31 14:48:26","ss_terminal":null,"ss_code":null,"sale_id":"9700","si_item_id":null,"item_id":"21","item_sku":"21","item_name":"Chocolate ","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-05-31 14:48:26","serial":"admin-1496209864-14962133061284156","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-05-31 14:57:05', NULL, ''),
(816, 'lois', '{"void_item":{"id":"33763","date":"2017-06-01 13:31:10","ss_terminal":null,"ss_code":null,"sale_id":"9722","si_item_id":"0","item_id":"247","item_sku":"181","item_name":"Caramel Chocolate Cheese","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-01 13:31:10","serial":"admin-1496284576-1496295070725624","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-01 13:31:20', NULL, ''),
(817, 'lois', '{"void_item":{"id":"33762","date":"2017-06-01 13:31:10","ss_terminal":null,"ss_code":null,"sale_id":"9722","si_item_id":"0","item_id":"168","item_sku":"102","item_name":"Black & White ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-01 13:31:10","serial":"admin-1496284576-1496295070725624","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-01 13:31:30', NULL, ''),
(818, 'lois', '{"sale":{"id":"9728","txn_no":null,"table_no":"T8","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-06-01 15:34:31","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1496284576","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"33781","date":"2017-06-01 15:34:31","ss_terminal":null,"ss_code":null,"sale_id":"9728","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-01 15:34:31","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-06-01 15:35:43', NULL, ''),
(819, 'sanni', '{"void_item":{"id":"33831","date":"2017-06-02 11:31:52","ss_terminal":null,"ss_code":null,"sale_id":"9741","si_item_id":"0","item_id":"40","item_sku":"40","item_name":"Banana Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"28.0000","cost":"0.0000","amount":"28.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-02 11:31:52","serial":"admin-1496372633-14963743125033026","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-02 11:58:55', NULL, ''),
(820, 'sanni', '{"void_item":{"id":"33847","date":"2017-06-02 12:03:23","ss_terminal":null,"ss_code":null,"sale_id":"9747","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-02 12:03:23","serial":"admin-1496372633-14963762027686456","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-02 12:16:27', NULL, ''),
(821, 'sanni', '{"void_item":{"id":"33851","date":"2017-06-02 12:04:23","ss_terminal":null,"ss_code":null,"sale_id":"9748","si_item_id":"0","item_id":"237","item_sku":"171","item_name":"Iced Vanilla Milk","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-02 12:04:23","serial":"admin-1496372633-1496376263012989","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-02 12:42:59', NULL, ''),
(822, 'sanni', '{"void_item":{"id":"34014","date":"2017-06-03 11:09:25","ss_terminal":null,"ss_code":null,"sale_id":"9770","si_item_id":"0","item_id":"237","item_sku":"171","item_name":"Iced Vanilla Milk","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-03 11:09:25","serial":"admin-1496456994-14964593655902046","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":"0.0","global_discount":null}}', '2017-06-03 11:10:20', NULL, ''),
(823, 'lois', '{"void_item":{"id":"34028","date":"2017-06-03 11:20:44","ss_terminal":null,"ss_code":null,"sale_id":"9779","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-03 11:20:44","serial":"admin-1496456994-14964600441864529","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-03 11:44:14', NULL, ''),
(824, 'lois', '{"void_item":{"id":"34061","date":"2017-06-03 12:02:43","ss_terminal":null,"ss_code":null,"sale_id":"9787","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Cheesy Chicken Gratin","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-03 12:02:43","serial":"admin-1496460619-14964625637209253","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-03 12:07:51', NULL, ''),
(825, 'lois', '{"void_item":{"id":"34070","date":"2017-06-03 12:07:59","ss_terminal":null,"ss_code":null,"sale_id":"9787","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-03 12:07:59","serial":"admin-1496460619-14964628796966338","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-03 12:10:16', NULL, ''),
(826, 'sanni', '{"void_item":{"id":"34099","date":"2017-06-03 12:57:03","ss_terminal":null,"ss_code":null,"sale_id":"9793","si_item_id":"0","item_id":"250","item_sku":"185","item_name":"Double Trouble Burger","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"28.90","margin":"28.9000","cost":"0.0000","amount":"28.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-03 12:57:03","serial":"admin-1496463066-14964658230162063","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-03 12:57:37', NULL, ''),
(827, 'sanni', '{"void_item":{"id":"34107","date":"2017-06-03 13:12:39","ss_terminal":null,"ss_code":null,"sale_id":"9795","si_item_id":"0","item_id":"272","item_sku":"206","item_name":"Genius in The Bowl","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-03 13:12:39","serial":"admin-1496466110-14964667597439186","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-03 13:20:13', NULL, ''),
(828, 'sanni', '{"void_item":{"id":"34112","date":"2017-06-03 13:21:57","ss_terminal":null,"ss_code":null,"sale_id":"9795","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-03 13:21:57","serial":"admin-1496466110-1496467317154158","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-03 13:35:45', NULL, ''),
(829, 'lois', '{"void_item":{"id":"34433","date":"2017-06-05 14:50:01","ss_terminal":null,"ss_code":null,"sale_id":"9871","si_item_id":"0","item_id":"208","item_sku":"D0001","item_name":"RM5 DISCOUNT ","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"-5.00","margin":"-5.0000","cost":"0.0000","amount":"-5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-05 14:50:01","serial":"admin-1496641340-1496645401126829","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}}', '2017-06-05 14:50:16', NULL, ''),
(830, 'lois', '{"void_item":{"id":"34430","date":"2017-06-05 14:44:46","ss_terminal":null,"ss_code":null,"sale_id":"9870","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.70","margin":"0.0000","cost":"0.0000","amount":"2.70","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-05 14:44:46","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-05 15:24:40', NULL, ''),
(831, 'lois', '{"sale":{"id":"9871","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-06-05 14:49:58","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1496641340","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2017-06-05 15:46:28', NULL, ''),
(832, 'sanni', '{"sale":{"id":"9884","txn_no":null,"table_no":"T5","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-06-07 14:25:59","payment_status":"Unpaid","cost":null,"subtotal":"16.00","amount":"17.60","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1496810669","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"34503","date":"2017-06-07 14:25:59","ss_terminal":null,"ss_code":null,"sale_id":"9884","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.60","margin":"0.0000","cost":"0.0000","amount":"1.60","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-07 14:25:59","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"34504","date":"2017-06-07 14:26:08","ss_terminal":null,"ss_code":null,"sale_id":"9884","si_item_id":"0","item_id":"211","item_sku":"145","item_name":"Stir Fried Lemony Chicken","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-07 14:26:08","serial":"admin-1496810669-14968167686921210","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-06-07 14:27:13', NULL, ''),
(833, 'sanni', '{"void_item":{"id":"34569","date":"2017-06-08 12:02:58","ss_terminal":null,"ss_code":null,"sale_id":"9899","si_item_id":"0","item_id":"41","item_sku":"41","item_name":"Blueberry Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-08 12:02:58","serial":"admin-1496894388-1496894578463847","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-08 12:45:04', NULL, ''),
(834, 'lois', '{"void_item":{"id":"34584","date":"2017-06-08 12:47:27","ss_terminal":null,"ss_code":null,"sale_id":"9902","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-08 12:47:27","serial":"admin-1496894388-14968972468605078","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-08 12:47:41', NULL, ''),
(835, 'sanni', '{"void_item":{"id":"34610","date":"2017-06-08 14:02:43","ss_terminal":null,"ss_code":null,"sale_id":"9905","si_item_id":"0","item_id":"223","item_sku":"157","item_name":"Crispy Bacon Aglio Olio","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-08 14:02:43","serial":"admin-1496897411-14969017628465182","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-08 14:03:07', NULL, ''),
(836, 'sanni', '{"void_item":{"id":"34655","date":"2017-06-09 11:55:21","ss_terminal":null,"ss_code":null,"sale_id":"9917","si_item_id":"0","item_id":"267","item_sku":"201","item_name":"Cocoa Cappucino","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-09 11:55:21","serial":"admin-1496977505-14969805208577070","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-09 12:20:37', NULL, ''),
(837, 'sanni', '{"void_item":{"id":"34647","date":"2017-06-09 11:04:30","ss_terminal":null,"ss_code":null,"sale_id":"9916","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Cheesy Chicken Gratin","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-09 11:04:30","serial":"admin-1496968353-14969774705278151","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-09 12:26:00', NULL, ''),
(838, 'sanni', '{"void_item":{"id":"34682","date":"2017-06-09 14:11:59","ss_terminal":null,"ss_code":null,"sale_id":"9921","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"macadamia scone,scone","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-09 14:11:59","serial":"admin-1496985770-14969887192339696","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}}', '2017-06-09 14:12:14', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(839, 'sanni', '{"sale":{"id":"9922","txn_no":"109629","table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-06-09 14:12:30","payment_status":"Paid","cost":null,"subtotal":"10.00","amount":"10.00","amount_cash":"10.00","amount_cc":null,"amount_tendered":"10.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1496985770","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"34683","date":"2017-06-09 14:12:27","ss_terminal":null,"ss_code":null,"sale_id":"9922","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"scone","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1496985770","ordered_by":"admin","ordered_time":"2017-06-09 14:12:27","serial":"admin-1496985770-14969887468556848","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-06-09 14:16:06', 1, ''),
(840, 'sanni', '{"sale":{"id":"9922","txn_no":"109629","table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-06-09 14:12:30","payment_status":"Unpaid","cost":null,"subtotal":"10.00","amount":"10.00","amount_cash":"10.00","amount_cc":null,"amount_tendered":"10.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1496985770","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"34683","date":"2017-06-09 14:12:27","ss_terminal":null,"ss_code":null,"sale_id":"9922","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"scone","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1496985770","ordered_by":"admin","ordered_time":"2017-06-09 14:12:27","serial":"admin-1496985770-14969887468556848","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-06-09 14:16:24', NULL, ''),
(841, 'sanni', '{"void_item":{"id":"34718","date":"2017-06-10 08:18:21","ss_terminal":null,"ss_code":null,"sale_id":"9932","si_item_id":null,"item_id":"44","item_sku":"44","item_name":"Tiger ","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-10 08:18:21","serial":"admin-1497053888-14970539011839745","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}}', '2017-06-10 08:18:31', NULL, ''),
(842, 'sanni', '{"void_item":{"id":"34717","date":"2017-06-10 08:18:21","ss_terminal":null,"ss_code":null,"sale_id":"9932","si_item_id":null,"item_id":"44","item_sku":"44","item_name":"Tiger ","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-10 08:18:21","serial":"admin-1497053888-14970539011839745","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}}', '2017-06-10 08:18:39', NULL, ''),
(843, 'sanni', '{"sale":{"id":"9931","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-06-10 08:18:12","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1497053888","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2017-06-10 09:10:54', NULL, ''),
(844, 'sanni', '{"void_item":{"id":"34726","date":"2017-06-10 09:06:24","ss_terminal":null,"ss_code":null,"sale_id":"9934","si_item_id":"0","item_id":"279","item_sku":"213","item_name":"Diet Meal - Americano \\/ Egg Sandwich","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-10 09:06:24","serial":"admin-1497056454-14970567847607793","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-10 09:26:52', NULL, ''),
(845, 'sanni', '{"void_item":{"id":"35010","date":"2017-06-11 10:11:35","ss_terminal":null,"ss_code":null,"sale_id":"9987","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Cheesy Chicken Gratin","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-11 10:11:35","serial":"admin-1497141346-14971470955111782","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-11 10:47:00', NULL, ''),
(846, 'sanni', '{"void_item":{"id":"35143","date":"2017-06-12 09:22:46","ss_terminal":null,"ss_code":null,"sale_id":"10017","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Cheesy Chicken Gratin","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-12 09:22:46","serial":"admin-1497228235-14972305662297678","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-12 09:25:16', NULL, ''),
(847, 'sanni', '{"void_item":{"id":"35264","date":"2017-06-12 13:57:38","ss_terminal":null,"ss_code":null,"sale_id":"10038","si_item_id":"0","item_id":"156","item_sku":"90","item_name":"House Cheddar Omelet","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-12 13:57:38","serial":"admin-1497246792-14972470585587766","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-12 13:58:19', NULL, ''),
(848, 'sanni', '{"sale":{"id":"10029","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-06-12 11:50:09","payment_status":"Unpaid","cost":null,"subtotal":"54.00","amount":"59.40","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1497234420","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"35199","date":"2017-06-12 11:50:09","ss_terminal":null,"ss_code":null,"sale_id":"10029","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"5.40","margin":"0.0000","cost":"0.0000","amount":"5.40","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-12 11:50:09","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"35200","date":"2017-06-12 11:50:32","ss_terminal":null,"ss_code":null,"sale_id":"10029","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-12 11:50:32","serial":"admin-1497234420-14972394327738172","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"35201","date":"2017-06-12 11:50:32","ss_terminal":null,"ss_code":null,"sale_id":"10029","si_item_id":"0","item_id":"223","item_sku":"157","item_name":"Crispy Bacon Aglio Olio","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-12 11:50:32","serial":"admin-1497234420-14972394327738172","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"35202","date":"2017-06-12 11:50:32","ss_terminal":null,"ss_code":null,"sale_id":"10029","si_item_id":null,"item_id":"63","item_sku":"63","item_name":"Lime","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-12 11:50:32","serial":"admin-1497234420-14972394327738172","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"35203","date":"2017-06-12 11:50:32","ss_terminal":null,"ss_code":null,"sale_id":"10029","si_item_id":null,"item_id":"66","item_sku":"66","item_name":"Watermelon ","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-12 11:50:32","serial":"admin-1497234420-14972394327738172","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-06-12 15:08:38', NULL, ''),
(849, 'lois', '{"sale":{"id":"10068","txn_no":null,"table_no":"T8","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-06-14 12:49:16","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1497412185","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"35368","date":"2017-06-14 12:49:16","ss_terminal":null,"ss_code":null,"sale_id":"10068","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-14 12:49:16","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-06-14 12:49:26', NULL, ''),
(850, 'sanni', '{"void_item":{"id":"35404","date":"2017-06-15 09:09:43","ss_terminal":null,"ss_code":null,"sale_id":"10082","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Cheesy Chicken Gratin","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-15 09:09:43","serial":"admin-1497488415-14974889837051482","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-15 09:16:26', NULL, ''),
(851, 'lois', '{"void_item":{"id":"35438","date":"2017-06-15 11:25:13","ss_terminal":null,"ss_code":null,"sale_id":"10087","si_item_id":"0","item_id":"158","item_sku":"92","item_name":"Banana Stuffed Nutella Toast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-15 11:25:13","serial":"admin-1497488415-14974971132246293","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-15 11:26:20', NULL, ''),
(852, 'sanni', '{"sale":{"id":"10087","txn_no":"109792","table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-06-15 12:33:10","payment_status":"Paid","cost":null,"subtotal":"107.00","amount":"117.70","amount_cash":"117.70","amount_cc":null,"amount_tendered":"200.00","amount_change":"82.30","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1497497140","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"35450","date":"2017-06-15 11:26:27","ss_terminal":null,"ss_code":null,"sale_id":"10087","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"French Toast with Fruits","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1497497140","ordered_by":"admin","ordered_time":"2017-06-15 11:26:27","serial":"admin-1497497140-14974971874629926","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"35439","date":"2017-06-15 11:25:13","ss_terminal":null,"ss_code":null,"sale_id":"10087","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1497497140","ordered_by":"admin","ordered_time":"2017-06-15 11:25:13","serial":"admin-1497488415-14974971132246293","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"35440","date":"2017-06-15 11:25:13","ss_terminal":null,"ss_code":null,"sale_id":"10087","si_item_id":"0","item_id":"184","item_sku":"119","item_name":"Flat White","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1497497140","ordered_by":"admin","ordered_time":"2017-06-15 11:25:13","serial":"admin-1497488415-14974971132246293","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"35441","date":"2017-06-15 11:25:13","ss_terminal":null,"ss_code":null,"sale_id":"10087","si_item_id":"0","item_id":"29","item_sku":"29","item_name":"Iced Lemon Tea","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1497497140","ordered_by":"admin","ordered_time":"2017-06-15 11:25:13","serial":"admin-1497488415-14974971132246293","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"35434","date":"2017-06-15 11:24:49","ss_terminal":null,"ss_code":null,"sale_id":"10087","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"10.70","margin":"0.0000","cost":"0.0000","amount":"10.70","sold":"1","terminal":"27","printed":"1","session":"1497497140","ordered_by":"admin","ordered_time":"2017-06-15 11:24:49","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"35435","date":"2017-06-15 11:25:13","ss_terminal":null,"ss_code":null,"sale_id":"10087","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":"1","terminal":"27","printed":"1","session":"1497497140","ordered_by":"admin","ordered_time":"2017-06-15 11:25:13","serial":"admin-1497488415-14974971132246293","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"35436","date":"2017-06-15 11:25:13","ss_terminal":null,"ss_code":null,"sale_id":"10087","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":"1","terminal":"27","printed":"1","session":"1497497140","ordered_by":"admin","ordered_time":"2017-06-15 11:25:13","serial":"admin-1497488415-14974971132246293","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"35437","date":"2017-06-15 11:25:13","ss_terminal":null,"ss_code":null,"sale_id":"10087","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":"1","terminal":"27","printed":"1","session":"1497497140","ordered_by":"admin","ordered_time":"2017-06-15 11:25:13","serial":"admin-1497488415-14974971132246293","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-06-15 12:33:27', 1, ''),
(853, 'sanni', '{"void_item":{"id":"35471","date":"2017-06-15 13:02:55","ss_terminal":null,"ss_code":null,"sale_id":"10091","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"French Toast with Fruits","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-15 13:02:55","serial":"admin-1497497140-14975029749596025","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-15 13:05:27', NULL, ''),
(854, 'lois', '{"sale":{"id":"10104","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-06-15 16:31:10","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1497508226","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"35530","date":"2017-06-15 16:31:10","ss_terminal":null,"ss_code":null,"sale_id":"10104","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-15 16:31:10","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-06-15 16:34:58', NULL, ''),
(855, 'lois', '{"void_item":{"id":"35598","date":"2017-06-16 13:33:07","ss_terminal":null,"ss_code":null,"sale_id":"10122","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"with fried egg,without meat","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-16 13:33:07","serial":"admin-1497585921-14975911869182795","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-16 14:06:03', NULL, ''),
(856, 'lois', '{"sale":{"id":"10115","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-06-16 12:24:57","payment_status":"Unpaid","cost":null,"subtotal":"11.00","amount":"11.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1497585921","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"35574","date":"2017-06-16 12:25:05","ss_terminal":null,"ss_code":null,"sale_id":"10115","si_item_id":"0","item_id":"34","item_sku":"34","item_name":"Ginger Lemongrass Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-16 12:25:05","serial":"admin-1497585921-14975871057614554","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-06-16 15:58:12', NULL, ''),
(857, 'sanni', '{"void_item":{"id":"35787","date":"2017-06-17 16:42:52","ss_terminal":null,"ss_code":null,"sale_id":"10163","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-17 16:42:52","serial":"admin-1497686642-1497688972106869","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-17 17:09:02', NULL, ''),
(858, 'lois', '{"sale":{"id":"10200","txn_no":"109898","table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-06-18 14:38:51","payment_status":"Paid","cost":null,"subtotal":"92.00","amount":"101.20","amount_cash":"101.20","amount_cc":null,"amount_tendered":"102.00","amount_change":"0.80","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1497764902","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"35990","date":"2017-06-18 13:48:58","ss_terminal":null,"ss_code":null,"sale_id":"10200","si_item_id":null,"item_id":"33","item_sku":"33","item_name":"Cucumber Lime ","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1497764902","ordered_by":"admin","ordered_time":"2017-06-18 13:48:58","serial":"admin-1497764902-14977649378594438","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"35989","date":"2017-06-18 13:48:58","ss_terminal":null,"ss_code":null,"sale_id":"10200","si_item_id":"0","item_id":"184","item_sku":"119","item_name":"Flat White","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1497764902","ordered_by":"admin","ordered_time":"2017-06-18 13:48:58","serial":"admin-1497764902-14977649378594438","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"35988","date":"2017-06-18 13:48:58","ss_terminal":null,"ss_code":null,"sale_id":"10200","si_item_id":"0","item_id":"184","item_sku":"119","item_name":"Flat White","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1497764902","ordered_by":"admin","ordered_time":"2017-06-18 13:48:58","serial":"admin-1497764902-14977649378594438","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"35986","date":"2017-06-18 13:48:14","ss_terminal":null,"ss_code":null,"sale_id":"10200","si_item_id":"0","item_id":"80","item_sku":"80","item_name":"Oriental Chicken Salad","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":"1","terminal":"27","printed":"1","session":"1497764902","ordered_by":"admin","ordered_time":"2017-06-18 13:48:14","serial":"admin-1497762058-14977648940938275","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"35984","date":"2017-06-18 13:47:45","ss_terminal":null,"ss_code":null,"sale_id":"10200","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"9.20","margin":"0.0000","cost":"0.0000","amount":"9.20","sold":"1","terminal":"27","printed":"1","session":"1497764902","ordered_by":"admin","ordered_time":"2017-06-18 13:47:45","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"35985","date":"2017-06-18 13:48:14","ss_terminal":null,"ss_code":null,"sale_id":"10200","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1497764902","ordered_by":"admin","ordered_time":"2017-06-18 13:48:14","serial":"admin-1497762058-14977648940938275","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"35991","date":"2017-06-18 13:48:58","ss_terminal":null,"ss_code":null,"sale_id":"10200","si_item_id":"0","item_id":"34","item_sku":"34","item_name":"Ginger Lemongrass Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1497764902","ordered_by":"admin","ordered_time":"2017-06-18 13:48:58","serial":"admin-1497764902-14977649378594438","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"35987","date":"2017-06-18 13:48:58","ss_terminal":null,"ss_code":null,"sale_id":"10200","si_item_id":"0","item_id":"159","item_sku":"93","item_name":"Fruits & Yogurt Granola","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1497764902","ordered_by":"admin","ordered_time":"2017-06-18 13:48:58","serial":"admin-1497764902-14977649378594438","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-06-18 14:39:59', 1, ''),
(859, 'sanni', '{"void_item":{"id":"36013","date":"2017-06-18 15:39:27","ss_terminal":null,"ss_code":null,"sale_id":"10206","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-18 15:39:27","serial":"admin-1497764902-14977715675342235","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-18 15:40:55', NULL, ''),
(860, 'sanni', '{"void_item":{"id":"36012","date":"2017-06-18 15:39:27","ss_terminal":null,"ss_code":null,"sale_id":"10206","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-18 15:39:27","serial":"admin-1497764902-14977715675342235","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-18 15:41:02', NULL, ''),
(861, 'sanni', '{"void_item":{"id":"36019","date":"2017-06-18 15:40:43","ss_terminal":null,"ss_code":null,"sale_id":"10207","si_item_id":null,"item_id":"10","item_sku":"10","item_name":"Dirty Chai","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-18 15:40:43","serial":"admin-1497764902-14977716430926364","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-18 15:42:34', NULL, ''),
(862, 'sanni', '{"sale":{"id":"10221","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-06-19 10:40:40","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1497836447","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"36071","date":"2017-06-19 10:40:40","ss_terminal":null,"ss_code":null,"sale_id":"10221","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-19 10:40:40","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-06-19 10:50:42', NULL, ''),
(863, 'sanni', '{"sale":{"id":"10236","txn_no":null,"table_no":"T2(S)","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-06-19 13:31:27","payment_status":"Unpaid","cost":null,"subtotal":"20.00","amount":"22.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1497844586","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":null,"customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":null},"sale_items":[{"id":"36134","date":"2017-06-19 00:00:00","ss_terminal":null,"ss_code":null,"sale_id":"10236","si_item_id":"0","item_id":"222","item_sku":"156","item_name":"Seasoned Chicken Aglio Olio","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"20.00","margin":null,"cost":null,"amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-19 11:56:21","serial":"admin-1497836447-14978445807234668","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"36135","date":"2017-06-19 13:31:27","ss_terminal":null,"ss_code":null,"sale_id":"10236","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"","category":"SERVICE CHARGE","subcategory":"SERVICE CHARGE","qty":"1","price_per_unit":"2.00","margin":"0.0000","cost":"0.0000","amount":"2.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-19 13:31:27","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-06-19 13:33:00', NULL, ''),
(864, 'sanni', '{"sale":{"id":"10227","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-06-19 11:56:01","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1497836447","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"36093","date":"2017-06-19 11:56:01","ss_terminal":null,"ss_code":null,"sale_id":"10227","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-19 11:56:01","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-06-19 13:33:28', NULL, ''),
(865, 'lois', '{"sale":{"id":"10244","txn_no":null,"table_no":"T8","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-06-19 15:37:06","payment_status":"Unpaid","cost":null,"subtotal":"9.00","amount":"9.90","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1497854525","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"36165","date":"2017-06-19 15:37:06","ss_terminal":null,"ss_code":null,"sale_id":"10244","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.90","margin":"0.0000","cost":"0.0000","amount":"0.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-19 15:37:06","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"36166","date":"2017-06-19 15:37:10","ss_terminal":null,"ss_code":null,"sale_id":"10244","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-19 15:37:10","serial":"admin-1497854525-14978578301633997","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-06-19 15:43:46', NULL, ''),
(866, 'lois', '{"void_item":{"id":"36202","date":"2017-06-21 11:12:06","ss_terminal":null,"ss_code":null,"sale_id":"10254","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-21 11:12:06","serial":"admin-1498007850-14980147263188211","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-21 11:51:27', NULL, ''),
(867, 'lois', '{"void_item":{"id":"36201","date":"2017-06-21 11:12:06","ss_terminal":null,"ss_code":null,"sale_id":"10254","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-21 11:12:06","serial":"admin-1498007850-14980147263188211","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-21 11:51:34', NULL, ''),
(868, 'lois', '{"void_item":{"id":"36306","date":"2017-06-21 15:47:40","ss_terminal":null,"ss_code":null,"sale_id":"10277","si_item_id":"0","item_id":"76","item_sku":"76","item_name":"Meatless Pesto Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-21 15:47:40","serial":"admin-1498023646-14980312607647380","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-21 15:48:24', NULL, ''),
(869, 'lois', '{"void_item":{"id":"36506","date":"2017-06-24 09:34:02","ss_terminal":null,"ss_code":null,"sale_id":"10318","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"Scone set","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-24 09:34:02","serial":"admin-1498265512-14982680427745633","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-24 09:37:30', NULL, ''),
(870, 'sanni', '{"void_item":{"id":"36542","date":"2017-06-24 10:19:17","ss_terminal":null,"ss_code":null,"sale_id":"10324","si_item_id":"0","item_id":"253","item_sku":"187","item_name":"Cheese Baked Nachos","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-24 10:19:17","serial":"admin-1498270351-14982707570268397","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-24 10:35:24', NULL, ''),
(871, 'sanni', '{"void_item":{"id":"36597","date":"2017-06-24 12:00:05","ss_terminal":null,"ss_code":null,"sale_id":"10336","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.30","margin":"0.0000","cost":"0.0000","amount":"2.30","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-24 12:00:05","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-24 12:04:44', NULL, ''),
(872, 'sanni', '{"void_item":{"id":"36722","date":"2017-06-25 10:21:26","ss_terminal":null,"ss_code":null,"sale_id":"10357","si_item_id":"0","item_id":"156","item_sku":"90","item_name":"House Cheddar Omelet","item_option":"Takeaway","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-25 10:21:26","serial":"admin-1498355160-1498357286662647","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-25 10:29:52', NULL, ''),
(873, 'sanni', '{"sale":{"id":"10366","txn_no":null,"table_no":"T12A","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-06-25 10:33:56","payment_status":"Unpaid","cost":null,"subtotal":"37.00","amount":"40.70","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1498357366","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"36733","date":"2017-06-25 10:33:56","ss_terminal":null,"ss_code":null,"sale_id":"10366","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"3.70","margin":"0.0000","cost":"0.0000","amount":"3.70","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-25 10:33:56","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"36734","date":"2017-06-25 10:34:15","ss_terminal":null,"ss_code":null,"sale_id":"10366","si_item_id":"0","item_id":"156","item_sku":"90","item_name":"House Cheddar Omelet","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-25 10:34:15","serial":"admin-1498357366-14983580553925816","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"36735","date":"2017-06-25 10:34:15","ss_terminal":null,"ss_code":null,"sale_id":"10366","si_item_id":"0","item_id":"159","item_sku":"93","item_name":"Fruits & Yogurt Granola","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-25 10:34:15","serial":"admin-1498357366-14983580553925816","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"36736","date":"2017-06-25 10:34:15","ss_terminal":null,"ss_code":null,"sale_id":"10366","si_item_id":"0","item_id":"28","item_sku":"28","item_name":"Iced Honey Milk","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-25 10:34:15","serial":"admin-1498357366-14983580553925816","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-06-25 11:15:59', NULL, ''),
(874, 'sanni', '{"void_item":{"id":"36879","date":"2017-06-25 13:01:23","ss_terminal":null,"ss_code":null,"sale_id":"10396","si_item_id":"0","item_id":"78","item_sku":"78","item_name":"Cheesy Baked Mashed Potato","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-25 13:01:23","serial":"admin-1498365799-14983668832808378","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-25 13:02:34', NULL, ''),
(875, 'sanni', '{"void_item":{"id":"36925","date":"2017-06-25 14:43:56","ss_terminal":null,"ss_code":null,"sale_id":"10404","si_item_id":"0","item_id":"253","item_sku":"187","item_name":"Cheese Baked Nachos","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-25 14:43:56","serial":"admin-1498370688-14983730361014426","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-25 14:46:53', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(876, 'sanni', '{"sale":{"id":"10403","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-06-25 14:42:04","payment_status":"Unpaid","cost":null,"subtotal":"35.00","amount":"38.50","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1498370688","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"36918","date":"2017-06-25 14:42:04","ss_terminal":null,"ss_code":null,"sale_id":"10403","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"3.50","margin":"0.0000","cost":"0.0000","amount":"3.50","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-25 14:42:04","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"36921","date":"2017-06-25 14:42:36","ss_terminal":null,"ss_code":null,"sale_id":"10403","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-25 14:42:36","serial":"admin-1498370688-14983729566697041","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"36920","date":"2017-06-25 14:42:36","ss_terminal":null,"ss_code":null,"sale_id":"10403","si_item_id":null,"item_id":"7","item_sku":"7","item_name":"Mocha ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-25 14:42:36","serial":"admin-1498370688-14983729566697041","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"36919","date":"2017-06-25 14:42:36","ss_terminal":null,"ss_code":null,"sale_id":"10403","si_item_id":"0","item_id":"40","item_sku":"40","item_name":"Banana Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-25 14:42:36","serial":"admin-1498370688-14983729566697041","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-06-25 14:48:09', NULL, ''),
(877, 'sanni', '{"sale":{"id":"10425","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-06-26 09:19:46","payment_status":"Unpaid","cost":null,"subtotal":"24.00","amount":"24.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1498438916","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"37001","date":"2017-06-26 09:19:51","ss_terminal":null,"ss_code":null,"sale_id":"10425","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-26 09:19:51","serial":"admin-1498438916-14984399913421724","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null},{"id":"37002","date":"2017-06-26 09:20:25","ss_terminal":null,"ss_code":null,"sale_id":"10425","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"French Toast with Fruits","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-26 09:20:25","serial":"admin-1498438916-14984400250832130","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-06-26 09:21:19', NULL, ''),
(878, 'sanni', '{"void_item":{"id":"37109","date":"2017-06-26 11:06:45","ss_terminal":null,"ss_code":null,"sale_id":"10445","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-26 11:06:45","serial":"admin-1498445415-1498446405635333","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-26 11:09:17', NULL, ''),
(879, 'sanni', '{"sale":{"id":"10440","txn_no":null,"table_no":"T5","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-06-26 10:36:51","payment_status":"Unpaid","cost":null,"subtotal":"32.00","amount":"35.20","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1498443768","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"37079","date":"2017-06-26 10:37:04","ss_terminal":null,"ss_code":null,"sale_id":"10440","si_item_id":null,"item_id":"21","item_sku":"21","item_name":"Chocolate ","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-26 10:37:04","serial":"admin-1498443768-1498444623838456","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"37081","date":"2017-06-26 10:37:39","ss_terminal":null,"ss_code":null,"sale_id":"10440","si_item_id":null,"item_id":"35","item_sku":"35","item_name":"Passion Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-26 10:37:39","serial":"admin-1498443768-14984446594473467","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"37078","date":"2017-06-26 10:36:51","ss_terminal":null,"ss_code":null,"sale_id":"10440","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"3.20","margin":"0.0000","cost":"0.0000","amount":"3.20","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-26 10:36:51","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"37080","date":"2017-06-26 10:37:39","ss_terminal":null,"ss_code":null,"sale_id":"10440","si_item_id":null,"item_id":"37","item_sku":"37","item_name":"Pineapple Orange","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-26 10:37:39","serial":"admin-1498443768-14984446594473467","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-06-26 11:13:12', NULL, ''),
(880, 'sanni', '{"void_item":{"id":"37152","date":"2017-06-26 11:35:29","ss_terminal":null,"ss_code":null,"sale_id":"10447","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"two bread","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"2.00","margin":"2.0000","cost":"0.0000","amount":"2.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-26 11:35:29","serial":"admin-1498447642-14984481290507767","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-26 11:51:03', NULL, ''),
(881, 'sanni', '{"void_item":{"id":"37201","date":"2017-06-26 12:28:23","ss_terminal":null,"ss_code":null,"sale_id":"10463","si_item_id":"0","item_id":"264","item_sku":"198","item_name":"PostCard","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"2.50","margin":"2.5000","cost":"0.0000","amount":"2.50","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-26 12:28:23","serial":"admin-1498450740-14984513030452067","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-26 13:15:08', NULL, ''),
(882, 'lois', '{"void_item":{"id":"37223","date":"2017-06-26 13:51:24","ss_terminal":null,"ss_code":null,"sale_id":"10468","si_item_id":"0","item_id":"229","item_sku":"163","item_name":"Mummy''s Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-26 13:51:24","serial":"admin-1498456261-14984562846219785","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-26 13:53:21', NULL, ''),
(883, 'sanni', '{"void_item":{"id":"37253","date":"2017-06-26 14:24:46","ss_terminal":null,"ss_code":null,"sale_id":"10471","si_item_id":"0","item_id":"162","item_sku":"96","item_name":"Homemade Chicken Bite ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-26 14:24:46","serial":"admin-1498457127-14984582864666353","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-26 14:26:51', NULL, ''),
(884, 'sanni', '{"sale":{"id":"10466","txn_no":"110156","table_no":"T11A","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-06-26 14:38:28","payment_status":"Paid","cost":null,"subtotal":"105.00","amount":"115.50","amount_cash":"115.50","amount_cc":null,"amount_tendered":"120.00","amount_change":"4.50","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1498457127","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"37219","date":"2017-06-26 13:43:00","ss_terminal":null,"ss_code":null,"sale_id":"10466","si_item_id":null,"item_id":"33","item_sku":"33","item_name":"Cucumber Lime ","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1498457127","ordered_by":"admin","ordered_time":"2017-06-26 13:43:00","serial":"admin-1498450740-1498455779993687","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"37220","date":"2017-06-26 13:43:13","ss_terminal":null,"ss_code":null,"sale_id":"10466","si_item_id":null,"item_id":"62","item_sku":"62","item_name":"Orange","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1498457127","ordered_by":"admin","ordered_time":"2017-06-26 13:43:13","serial":"admin-1498450740-14984557932936063","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"37213","date":"2017-06-26 13:32:33","ss_terminal":null,"ss_code":null,"sale_id":"10466","si_item_id":"0","item_id":"70","item_sku":"70","item_name":"Pepper Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1498457127","ordered_by":"admin","ordered_time":"2017-06-26 13:32:33","serial":"admin-1498450740-14984551535083649","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"37214","date":"2017-06-26 13:32:33","ss_terminal":null,"ss_code":null,"sale_id":"10466","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Signature Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1498457127","ordered_by":"admin","ordered_time":"2017-06-26 13:32:33","serial":"admin-1498450740-14984551535083649","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"37230","date":"2017-06-26 14:04:34","ss_terminal":null,"ss_code":null,"sale_id":"10466","si_item_id":"0","item_id":"219","item_sku":"153","item_name":"Fried Rice With Bacon","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1498457127","ordered_by":"admin","ordered_time":"2017-06-26 14:04:34","serial":"admin-1498456261-14984570738575199","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"37212","date":"2017-06-26 13:31:42","ss_terminal":null,"ss_code":null,"sale_id":"10466","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"10.50","margin":"0.0000","cost":"0.0000","amount":"10.50","sold":"1","terminal":"27","printed":"1","session":"1498457127","ordered_by":"admin","ordered_time":"2017-06-26 13:31:42","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"37215","date":"2017-06-26 13:32:33","ss_terminal":null,"ss_code":null,"sale_id":"10466","si_item_id":"0","item_id":"212","item_sku":"146","item_name":"Crispy Bacon Salad","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":"1","terminal":"27","printed":"1","session":"1498457127","ordered_by":"admin","ordered_time":"2017-06-26 13:32:33","serial":"admin-1498450740-14984551535083649","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"37237","date":"2017-06-26 14:10:29","ss_terminal":null,"ss_code":null,"sale_id":"10466","si_item_id":"0","item_id":"223","item_sku":"157","item_name":"Crispy Bacon Aglio Olio","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":"1","terminal":"27","printed":"1","session":"1498457127","ordered_by":"admin","ordered_time":"2017-06-26 14:10:29","serial":"admin-1498457127-14984574288489532","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-06-26 14:39:55', 1, ''),
(885, 'sanni', '{"void_item":{"id":"37230","date":"2017-06-26 14:04:34","ss_terminal":null,"ss_code":null,"sale_id":"10466","si_item_id":"0","item_id":"219","item_sku":"153","item_name":"Fried Rice With Bacon","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1498457127","ordered_by":"admin","ordered_time":"2017-06-26 14:04:34","serial":"admin-1498456261-14984570738575199","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-26 14:40:10', NULL, ''),
(886, 'sanni', '{"void_item":{"id":"37283","date":"2017-06-26 15:58:00","ss_terminal":null,"ss_code":null,"sale_id":"10478","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-26 15:58:00","serial":"admin-1498457127-14984638804139475","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-26 17:05:15', NULL, ''),
(887, 'lois', '{"void_item":{"id":"37325","date":"2017-06-28 10:34:39","ss_terminal":null,"ss_code":null,"sale_id":"10490","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-28 10:34:39","serial":"admin-1498617250-14986172793513159","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-28 10:36:11', NULL, ''),
(888, 'lois', '{"void_item":{"id":"37336","date":"2017-06-28 11:21:17","ss_terminal":null,"ss_code":null,"sale_id":"10493","si_item_id":null,"item_id":"8","item_sku":"8","item_name":"Caramel Macchiato ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-28 11:21:17","serial":"admin-1498617250-14986200775897243","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-28 11:22:08', NULL, ''),
(889, 'sanni', '{"void_item":{"id":"37430","date":"2017-06-29 09:16:00","ss_terminal":null,"ss_code":null,"sale_id":"10515","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"24.0000","cost":"0.0000","amount":"24.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-29 09:16:00","serial":"admin-1498696035-14986989608563163","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-29 09:16:11', NULL, ''),
(890, 'sanni', '{"void_item":{"id":"37504","date":"2017-06-29 12:34:16","ss_terminal":null,"ss_code":null,"sale_id":"10531","si_item_id":"0","item_id":"162","item_sku":"96","item_name":"Homemade Chicken Bite ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-29 12:34:16","serial":"admin-1498704985-1498710856796211","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-29 13:06:30', NULL, ''),
(891, 'lois', '{"void_item":{"id":"37606","date":"2017-06-29 17:17:24","ss_terminal":null,"ss_code":null,"sale_id":"10552","si_item_id":"0","item_id":"262","item_sku":"196","item_name":"Cheesy Sticks","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-29 17:17:24","serial":"admin-1498714477-1498727844427249","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-29 17:18:07', NULL, ''),
(892, 'lois', '{"void_item":{"id":"37605","date":"2017-06-29 17:17:24","ss_terminal":null,"ss_code":null,"sale_id":"10552","si_item_id":"0","item_id":"262","item_sku":"196","item_name":"Cheesy Sticks","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-06-29 17:17:24","serial":"admin-1498714477-1498727844427249","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-06-29 17:18:13', NULL, ''),
(893, 'sanni', '{"void_item":{"id":"37766","date":"2017-07-01 11:34:42","ss_terminal":null,"ss_code":null,"sale_id":"10578","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-01 11:34:42","serial":"admin-1498876031-1498880081886585","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-01 11:41:57', NULL, ''),
(894, 'sanni', '{"void_item":{"id":"37784","date":"2017-07-01 11:50:42","ss_terminal":null,"ss_code":null,"sale_id":"10589","si_item_id":"0","item_id":"217","item_sku":"151","item_name":"Spicy Lemony Wings","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-01 11:50:42","serial":"admin-1498880635-14988810423686084","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-01 11:53:27', NULL, ''),
(895, 'sanni', '{"void_item":{"id":"38068","date":"2017-07-02 12:38:34","ss_terminal":null,"ss_code":null,"sale_id":"10636","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-02 12:38:34","serial":"admin-1498970043-14989703138385342","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-02 12:51:59', NULL, ''),
(896, 'sanni', '{"void_item":{"id":"38049","date":"2017-07-02 12:29:46","ss_terminal":null,"ss_code":null,"sale_id":"10644","si_item_id":"0","item_id":"2","item_sku":"2","item_name":"Espresso Macchiato ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-02 12:29:46","serial":"admin-1498968964-14989697867653354","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-02 13:15:52', NULL, ''),
(897, 'sanni', '{"void_item":{"id":"38115","date":"2017-07-02 13:30:01","ss_terminal":null,"ss_code":null,"sale_id":"10650","si_item_id":"0","item_id":"71","item_sku":"71","item_name":"Stir Fried Rice Wine Ginger Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-02 13:30:01","serial":"admin-1498972092-14989734007679073","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-02 13:30:39', NULL, ''),
(898, 'sanni', '{"void_item":{"id":"38194","date":"2017-07-03 09:15:21","ss_terminal":null,"ss_code":null,"sale_id":"10671","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"French Toast with Fruits","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-03 09:15:21","serial":"admin-1499043648-14990445213858057","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-03 09:35:05', NULL, ''),
(899, 'sanni', '{"void_item":{"id":"38277","date":"2017-07-03 12:40:14","ss_terminal":null,"ss_code":null,"sale_id":"10685","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-03 12:40:14","serial":"admin-1499056173-14990568147871421","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-03 12:48:47', NULL, ''),
(900, 'sanni', '{"void_item":{"id":"38346","date":"2017-07-05 12:43:28","ss_terminal":null,"ss_code":null,"sale_id":"10702","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"24.0000","cost":"0.0000","amount":"24.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-05 12:43:28","serial":"admin-1499228549-14992298086897095","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-05 13:59:55', NULL, ''),
(901, 'sanni', '{"sale":{"id":"10704","txn_no":null,"table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-07-05 13:51:50","payment_status":"Unpaid","cost":null,"subtotal":"40.00","amount":"39.60","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":"4.40","adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1499228549","discount_type":"p","discount":"10","payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"38352","date":"2017-07-05 13:54:10","ss_terminal":null,"ss_code":null,"sale_id":"10704","si_item_id":"0","item_id":"182","item_sku":"117","item_name":"Open Drinks ","item_option":"apple","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"2.00","margin":"2.0000","cost":"0.0000","amount":"2.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-05 13:54:10","serial":"admin-1499228549-14992340499685919","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"38353","date":"2017-07-05 13:54:47","ss_terminal":null,"ss_code":null,"sale_id":"10704","si_item_id":"0","item_id":"159","item_sku":"93","item_name":"Fruits & Yogurt Granola","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-05 13:54:47","serial":"admin-1499228549-14992340868268241","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"38351","date":"2017-07-05 13:54:10","ss_terminal":null,"ss_code":null,"sale_id":"10704","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-05 13:54:10","serial":"admin-1499228549-14992340499685919","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"38350","date":"2017-07-05 13:54:10","ss_terminal":null,"ss_code":null,"sale_id":"10704","si_item_id":"0","item_id":"38","item_sku":"38","item_name":"Mixed Berries Smoothie","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-05 13:54:10","serial":"admin-1499228549-14992340499685919","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"38349","date":"2017-07-05 13:51:50","ss_terminal":null,"ss_code":null,"sale_id":"10704","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"4.00","margin":"0.0000","cost":"0.0000","amount":"4.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-05 13:51:50","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-07-05 14:03:49', NULL, ''),
(902, 'lois', '{"void_item":{"id":"38437","date":"2017-07-06 13:05:01","ss_terminal":null,"ss_code":null,"sale_id":"10724","si_item_id":"0","item_id":"272","item_sku":"206","item_name":"Genius in The Bowl","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-06 13:05:01","serial":"admin-1499317491-14993175013957564","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-06 13:48:39', NULL, ''),
(903, 'sanni', '{"void_item":{"id":"38518","date":"2017-07-07 10:14:38","ss_terminal":null,"ss_code":null,"sale_id":"10747","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"sausages sunny side up","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-07 10:14:38","serial":"admin-1499387663-14993936785931263","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-07 10:31:53', NULL, ''),
(904, 'lois', '{"void_item":{"id":"38524","date":"2017-07-07 10:20:08","ss_terminal":null,"ss_code":null,"sale_id":"10747","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-07 10:20:08","serial":"admin-1499387663-14993940082786947","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-07 10:59:39', NULL, ''),
(905, 'sanni', '{"void_item":{"id":"38595","date":"2017-07-07 12:30:38","ss_terminal":null,"ss_code":null,"sale_id":"10763","si_item_id":"0","item_id":"27","item_sku":"27","item_name":"Iced Chocolate ","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-07 12:30:38","serial":"admin-1499401813-14994018383618213","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-07 12:39:00', NULL, ''),
(906, 'lois', '{"void_item":{"id":"38645","date":"2017-07-07 13:41:09","ss_terminal":null,"ss_code":null,"sale_id":"10771","si_item_id":null,"item_id":"7","item_sku":"7","item_name":"Mocha ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-07 13:41:09","serial":"admin-1499404413-14994060688623975","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-07 13:41:22', NULL, ''),
(907, 'sanni', '{"void_item":{"id":"38637","date":"2017-07-07 13:40:26","ss_terminal":null,"ss_code":null,"sale_id":"10769","si_item_id":"0","item_id":"242","item_sku":"176","item_name":"Citrus Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-07 13:40:26","serial":"admin-1499404413-149940602605769","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-07 14:06:41', NULL, ''),
(908, 'lois', '{"void_item":{"id":"38968","date":"2017-07-08 14:32:38","ss_terminal":null,"ss_code":null,"sale_id":"10838","si_item_id":"0","item_id":"232","item_sku":"166","item_name":"Candied Spicy Bacon Strips","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-08 14:32:38","serial":"admin-1499490738-14994955586468472","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-08 14:45:05', NULL, ''),
(909, 'lois', '{"sale":{"id":"10852","txn_no":null,"table_no":"T14","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-07-08 15:52:32","payment_status":"Unpaid","cost":null,"subtotal":"10.00","amount":"11.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1499495883","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"39019","date":"2017-07-08 15:52:32","ss_terminal":null,"ss_code":null,"sale_id":"10852","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.00","margin":"0.0000","cost":"0.0000","amount":"1.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-08 15:52:32","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"39020","date":"2017-07-08 15:52:36","ss_terminal":null,"ss_code":null,"sale_id":"10852","si_item_id":null,"item_id":"68","item_sku":"68","item_name":"Mix 2 types ","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-08 15:52:36","serial":"admin-1499495883-14995003567673715","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-07-08 16:48:59', NULL, ''),
(910, 'sanni', '{"void_item":{"id":"39040","date":"2017-07-09 09:26:09","ss_terminal":null,"ss_code":null,"sale_id":"10859","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-09 09:26:09","serial":"admin-1499560967-14995635692684410","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-09 09:43:08', NULL, ''),
(911, 'sanni', '{"void_item":{"id":"39222","date":"2017-07-09 13:19:27","ss_terminal":null,"ss_code":null,"sale_id":"10884","si_item_id":null,"item_id":"23","item_sku":"23","item_name":"Lemon Tea","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-09 13:19:27","serial":"admin-1499577344-14995775677306732","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-09 13:50:33', NULL, ''),
(912, 'sanni', '{"void_item":{"id":"39254","date":"2017-07-09 14:47:37","ss_terminal":null,"ss_code":null,"sale_id":"10897","si_item_id":"0","item_id":"34","item_sku":"34","item_name":"Ginger Lemongrass Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-09 14:47:37","serial":"admin-1499579780-14995828569826949","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-09 14:48:25', NULL, ''),
(913, 'lois', '{"void_item":{"id":"39361","date":"2017-07-10 11:35:09","ss_terminal":null,"ss_code":null,"sale_id":"10920","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-10 11:35:09","serial":"admin-1499655310-14996577097697741","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-10 12:34:33', NULL, ''),
(914, 'lois', '{"void_item":{"id":"39361","date":"2017-07-10 11:35:09","ss_terminal":null,"ss_code":null,"sale_id":"10920","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"16.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-10 11:35:09","serial":"admin-1499655310-14996577097697741","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-10 12:44:19', NULL, ''),
(915, 'sanni', '{"void_item":{"id":"39383","date":"2017-07-10 12:46:42","ss_terminal":null,"ss_code":null,"sale_id":"10924","si_item_id":"0","item_id":"253","item_sku":"187","item_name":"Cheese Baked Nachos","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-10 12:46:42","serial":"admin-1499655310-14996620020586550","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-10 12:48:51', NULL, ''),
(916, 'lois', '{"void_item":{"id":"39394","date":"2017-07-10 13:22:03","ss_terminal":null,"ss_code":null,"sale_id":"10928","si_item_id":"0","item_id":"220","item_sku":"154","item_name":"Smoked Bacon Basil Pesto","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-10 13:22:03","serial":"admin-1499662074-14996641236505684","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-10 13:29:37', NULL, ''),
(917, 'lois', '{"void_item":{"id":"39456","date":"2017-07-10 15:26:28","ss_terminal":null,"ss_code":null,"sale_id":"10940","si_item_id":"0","item_id":"185","item_sku":"120","item_name":"Bottled Water","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-10 15:26:28","serial":"admin-1499662074-14996715879179784","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-10 15:33:14', NULL, ''),
(918, 'lois', '{"void_item":{"id":"39457","date":"2017-07-10 15:26:28","ss_terminal":null,"ss_code":null,"sale_id":"10940","si_item_id":"0","item_id":"185","item_sku":"120","item_name":"Bottled Water","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-10 15:26:28","serial":"admin-1499662074-14996715879179784","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-10 15:33:21', NULL, ''),
(919, 'lois', '{"sale":{"id":"10938","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-07-10 14:43:53","payment_status":"Unpaid","cost":null,"subtotal":"11.00","amount":"12.10","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1499662074","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"39443","date":"2017-07-10 14:44:02","ss_terminal":null,"ss_code":null,"sale_id":"10938","si_item_id":"0","item_id":"281","item_sku":"215","item_name":"Weight Gain Deal - Latte \\/ Junior BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-10 14:44:02","serial":"admin-1499662074-14996690422617736","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"39442","date":"2017-07-10 14:43:53","ss_terminal":null,"ss_code":null,"sale_id":"10938","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.10","margin":"0.0000","cost":"0.0000","amount":"1.10","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-10 14:43:53","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-07-10 15:47:38', NULL, ''),
(920, 'sanni', '{"void_item":{"id":"39508","date":"2017-07-12 11:50:10","ss_terminal":null,"ss_code":null,"sale_id":"10958","si_item_id":"0","item_id":"74","item_sku":"74","item_name":"Sunrice","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"13.00","margin":"39.0000","cost":"0.0000","amount":"39.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-12 11:50:10","serial":"admin-1499831389-14998314106534242","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-12 11:50:23', NULL, ''),
(921, 'sanni', '{"void_item":{"id":"39508","date":"2017-07-12 11:50:10","ss_terminal":null,"ss_code":null,"sale_id":"10958","si_item_id":"0","item_id":"74","item_sku":"74","item_name":"Sunrice","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"13.00","margin":"39.0000","cost":"0.0000","amount":"26.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-12 11:50:10","serial":"admin-1499831389-14998314106534242","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-12 11:50:45', NULL, ''),
(922, 'sanni', '{"void_item":{"id":"39508","date":"2017-07-12 11:50:10","ss_terminal":null,"ss_code":null,"sale_id":"10958","si_item_id":"0","item_id":"74","item_sku":"74","item_name":"Sunrice","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"13.00","margin":"39.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-12 11:50:10","serial":"admin-1499831389-14998314106534242","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-12 11:51:05', NULL, ''),
(923, 'sanni', '{"void_item":{"id":"39548","date":"2017-07-12 13:46:25","ss_terminal":null,"ss_code":null,"sale_id":"10968","si_item_id":null,"item_id":"46","item_sku":"46","item_name":"Coke","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-12 13:46:25","serial":"admin-1499836063-14998383856716028","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-12 13:47:06', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(924, 'sanni', '{"sale":{"id":"10992","txn_no":null,"table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-07-13 12:58:58","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1499913735","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"39653","date":"2017-07-13 12:58:58","ss_terminal":null,"ss_code":null,"sale_id":"10992","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-13 12:58:58","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-07-13 13:56:38', NULL, ''),
(925, 'sanni', '{"void_item":{"id":"39765","date":"2017-07-14 10:21:53","ss_terminal":null,"ss_code":null,"sale_id":"11019","si_item_id":"0","item_id":"185","item_sku":"120","item_name":"Bottled Water","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-14 10:21:53","serial":"admin-1499993902-14999989133056752","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-14 10:26:36', NULL, ''),
(926, 'lois', '{"sale":{"id":"11020","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-07-14 10:26:45","payment_status":"Unpaid","cost":null,"subtotal":"11.00","amount":"11.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1499993902","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"39766","date":"2017-07-14 10:26:49","ss_terminal":null,"ss_code":null,"sale_id":"11020","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-14 10:26:49","serial":"admin-1499993902-14999992089558381","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-07-14 12:02:36', NULL, ''),
(927, 'sanni', '{"sale":{"id":"11058","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-07-15 11:50:05","payment_status":"Unpaid","cost":null,"subtotal":"15.00","amount":"16.50","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1500084910","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"39935","date":"2017-07-15 11:50:05","ss_terminal":null,"ss_code":null,"sale_id":"11058","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.50","margin":"0.0000","cost":"0.0000","amount":"1.50","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-15 11:50:05","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"39936","date":"2017-07-15 11:50:12","ss_terminal":null,"ss_code":null,"sale_id":"11058","si_item_id":"0","item_id":"235","item_sku":"169","item_name":"I''m Single","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-15 11:50:12","serial":"admin-1500084910-15000906127379441","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"39937","date":"2017-07-15 11:50:12","ss_terminal":null,"ss_code":null,"sale_id":"11058","si_item_id":"0","item_id":"235","item_sku":"169","item_name":"I''m Single","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-15 11:50:12","serial":"admin-1500084910-15000906127379441","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"39940","date":"2017-07-15 11:50:13","ss_terminal":null,"ss_code":null,"sale_id":"11058","si_item_id":"0","item_id":"235","item_sku":"169","item_name":"I''m Single","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-15 11:50:13","serial":"admin-1500084910-15000906127379441","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"39939","date":"2017-07-15 11:50:12","ss_terminal":null,"ss_code":null,"sale_id":"11058","si_item_id":"0","item_id":"235","item_sku":"169","item_name":"I''m Single","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-15 11:50:12","serial":"admin-1500084910-15000906127379441","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"39938","date":"2017-07-15 11:50:12","ss_terminal":null,"ss_code":null,"sale_id":"11058","si_item_id":"0","item_id":"235","item_sku":"169","item_name":"I''m Single","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-15 11:50:12","serial":"admin-1500084910-15000906127379441","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-07-15 12:00:02', NULL, ''),
(928, 'sanni', '{"void_item":{"id":"39956","date":"2017-07-15 11:58:16","ss_terminal":null,"ss_code":null,"sale_id":"11061","si_item_id":"0","item_id":"70","item_sku":"70","item_name":"Pepper Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-15 11:58:16","serial":"admin-1500084910-15000910961731448","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-15 12:00:25', NULL, ''),
(929, 'sanni', '{"sale":{"id":"11080","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-07-15 16:24:09","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1500107018","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"40041","date":"2017-07-15 16:24:09","ss_terminal":null,"ss_code":null,"sale_id":"11080","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-15 16:24:09","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-07-15 16:25:58', NULL, ''),
(930, 'sanni', '{"sale":{"id":"11101","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-07-16 11:17:43","payment_status":"Unpaid","cost":null,"subtotal":"24.00","amount":"26.40","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1500172442","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"40146","date":"2017-07-16 11:17:43","ss_terminal":null,"ss_code":null,"sale_id":"11101","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.40","margin":"0.0000","cost":"0.0000","amount":"2.40","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-16 11:17:43","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"40147","date":"2017-07-16 11:17:50","ss_terminal":null,"ss_code":null,"sale_id":"11101","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-16 11:17:50","serial":"admin-1500172442-15001750705013190","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"40148","date":"2017-07-16 11:17:50","ss_terminal":null,"ss_code":null,"sale_id":"11101","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-16 11:17:50","serial":"admin-1500172442-15001750705013190","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-07-16 11:20:03', NULL, ''),
(931, 'sanni', '{"sale":{"id":"11125","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-07-16 13:44:22","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1500181895","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2017-07-16 14:49:45', NULL, ''),
(932, 'lois', '{"sale":{"id":"11139","txn_no":"110799","table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-07-16 17:20:51","payment_status":"Paid","cost":null,"subtotal":"6.00","amount":"6.00","amount_cash":"6.00","amount_cc":null,"amount_tendered":"10.60","amount_change":"4.60","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1500189795","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"40315","date":"2017-07-16 17:20:42","ss_terminal":null,"ss_code":null,"sale_id":"11139","si_item_id":null,"item_id":"1","item_sku":"1","item_name":"Espresso","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":"1","terminal":"27","printed":"1","session":"1500189795","ordered_by":"admin","ordered_time":"2017-07-16 17:20:42","serial":"admin-1500189795-15001968419577527","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-07-16 17:21:19', 1, ''),
(933, 'lois', '{"sale":{"id":"11139","txn_no":"110799","table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-07-16 17:20:51","payment_status":"Unpaid","cost":null,"subtotal":"6.00","amount":"6.00","amount_cash":"6.00","amount_cc":null,"amount_tendered":"10.60","amount_change":"4.60","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1500189795","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"40315","date":"2017-07-16 17:20:42","ss_terminal":null,"ss_code":null,"sale_id":"11139","si_item_id":null,"item_id":"1","item_sku":"1","item_name":"Espresso","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":"1","terminal":"27","printed":"1","session":"1500189795","ordered_by":"admin","ordered_time":"2017-07-16 17:20:42","serial":"admin-1500189795-15001968419577527","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-07-16 17:21:32', NULL, ''),
(934, 'sanni', '{"void_item":{"id":"40348","date":"2017-07-17 11:08:11","ss_terminal":null,"ss_code":null,"sale_id":"11149","si_item_id":"0","item_id":"2","item_sku":"2","item_name":"Espresso Macchiato ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-17 11:08:11","serial":"admin-1500252965-15002608914468866","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-17 11:09:01', NULL, ''),
(935, 'lois', '{"void_item":{"id":"40326","date":"2017-07-17 10:37:00","ss_terminal":null,"ss_code":null,"sale_id":"11143","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"No bacon","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-17 10:37:00","serial":"admin-1500252965-15002590202716372","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-17 11:19:32', NULL, ''),
(936, 'lois', '{"void_item":{"id":"40362","date":"2017-07-17 11:42:05","ss_terminal":null,"ss_code":null,"sale_id":"11150","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-17 11:42:05","serial":"admin-1500261032-15002629249786288","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-17 11:43:07', NULL, ''),
(937, 'sanni', '{"sale":{"id":"11156","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-07-17 12:10:55","payment_status":"Unpaid","cost":null,"subtotal":"24.00","amount":"26.40","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1500261032","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"40369","date":"2017-07-17 12:10:55","ss_terminal":null,"ss_code":null,"sale_id":"11156","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.40","margin":"0.0000","cost":"0.0000","amount":"2.40","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-17 12:10:55","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"40370","date":"2017-07-17 12:11:07","ss_terminal":null,"ss_code":null,"sale_id":"11156","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"2","price_per_unit":"12.00","margin":"24.0000","cost":"0.0000","amount":"24.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-17 12:11:07","serial":"admin-1500261032-15002646669955948","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-07-17 12:18:13', NULL, ''),
(938, 'lois', '{"void_item":{"id":"40443","date":"2017-07-17 15:15:16","ss_terminal":null,"ss_code":null,"sale_id":"11169","si_item_id":"0","item_id":"210","item_sku":"144","item_name":"Red Riding Hood","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-17 15:15:16","serial":"admin-1500270044-15002757165288934","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-17 15:16:31', NULL, ''),
(939, 'lois', '{"sale":{"id":"11163","txn_no":null,"table_no":"TEST","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-07-17 12:59:41","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1500265652","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"40389","date":"2017-07-17 12:59:41","ss_terminal":null,"ss_code":null,"sale_id":"11163","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-17 12:59:41","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-07-17 16:03:22', NULL, ''),
(940, 'sanni', '{"void_item":{"id":"40512","date":"2017-07-19 12:44:31","ss_terminal":null,"ss_code":null,"sale_id":"11190","si_item_id":null,"item_id":"35","item_sku":"35","item_name":"Passion Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-19 12:44:31","serial":"admin-1500439386-15004394717281941","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-19 13:02:25', NULL, ''),
(941, 'lois', '{"void_item":{"id":"40673","date":"2017-07-20 14:24:10","ss_terminal":null,"ss_code":null,"sale_id":"11226","si_item_id":"0","item_id":"247","item_sku":"181","item_name":"Caramel Chocolate Cheese","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-20 14:24:10","serial":"admin-1500527734-1500531850211737","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-20 14:25:41', NULL, ''),
(942, 'lois', '{"void_item":{"id":"40792","date":"2017-07-21 12:33:54","ss_terminal":null,"ss_code":null,"sale_id":"11251","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Cheesy Chicken Gratin","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-21 12:33:54","serial":"admin-1500606849-1500611633747268","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-21 12:36:25', NULL, ''),
(943, 'sanni', '{"void_item":{"id":"40879","date":"2017-07-22 10:27:20","ss_terminal":null,"ss_code":null,"sale_id":"11272","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-22 10:27:20","serial":"admin-1500684602-15006904399475716","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-22 10:45:17', NULL, ''),
(944, 'sanni', '{"void_item":{"id":"40885","date":"2017-07-22 10:32:10","ss_terminal":null,"ss_code":null,"sale_id":"11273","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-22 10:32:10","serial":"admin-1500690447-1500690730710827","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-22 10:46:10', NULL, ''),
(945, 'sanni', '{"void_item":{"id":"40884","date":"2017-07-22 10:32:10","ss_terminal":null,"ss_code":null,"sale_id":"11273","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"French Toast with Fruits","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-22 10:32:10","serial":"admin-1500690447-1500690730710827","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-22 10:46:20', NULL, ''),
(946, 'sanni', '{"sale":{"id":"11278","txn_no":"110928","table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-07-22 10:56:04","payment_status":"Paid","cost":null,"subtotal":"72.00","amount":"79.20","amount_cash":"79.20","amount_cc":null,"amount_tendered":"80.00","amount_change":"0.80","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1500691734","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"40908","date":"2017-07-22 10:53:10","ss_terminal":null,"ss_code":null,"sale_id":"11278","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"7.20","margin":"0.0000","cost":"0.0000","amount":"7.20","sold":"1","terminal":"27","printed":"1","session":"1500691734","ordered_by":"admin","ordered_time":"2017-07-22 10:53:10","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"40909","date":"2017-07-22 10:53:33","ss_terminal":null,"ss_code":null,"sale_id":"11278","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":"1","terminal":"27","printed":"1","session":"1500691734","ordered_by":"admin","ordered_time":"2017-07-22 10:53:33","serial":"admin-1500691734-1500692012951223","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"40910","date":"2017-07-22 10:53:33","ss_terminal":null,"ss_code":null,"sale_id":"11278","si_item_id":"0","item_id":"158","item_sku":"92","item_name":"Banana Stuffed Nutella Toast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1500691734","ordered_by":"admin","ordered_time":"2017-07-22 10:53:33","serial":"admin-1500691734-1500692012951223","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"40911","date":"2017-07-22 10:53:33","ss_terminal":null,"ss_code":null,"sale_id":"11278","si_item_id":"0","item_id":"253","item_sku":"187","item_name":"Cheese Baked Nachos","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1500691734","ordered_by":"admin","ordered_time":"2017-07-22 10:53:33","serial":"admin-1500691734-1500692012951223","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"40912","date":"2017-07-22 10:53:47","ss_terminal":null,"ss_code":null,"sale_id":"11278","si_item_id":"0","item_id":"28","item_sku":"28","item_name":"Iced Honey Milk","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1500691734","ordered_by":"admin","ordered_time":"2017-07-22 10:53:47","serial":"admin-1500691734-1500692027685798","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"40913","date":"2017-07-22 10:53:47","ss_terminal":null,"ss_code":null,"sale_id":"11278","si_item_id":null,"item_id":"11","item_sku":"11","item_name":"Vanilla Latte","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1500691734","ordered_by":"admin","ordered_time":"2017-07-22 10:53:47","serial":"admin-1500691734-1500692027685798","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-07-22 11:08:56', 1, ''),
(947, 'sanni', '{"sale":{"id":"11340","txn_no":null,"table_no":"T5","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-07-23 10:32:42","payment_status":"Unpaid","cost":null,"subtotal":"11.00","amount":"12.10","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1500776009","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"41202","date":"2017-07-23 10:32:42","ss_terminal":null,"ss_code":null,"sale_id":"11340","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.10","margin":"0.0000","cost":"0.0000","amount":"1.10","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-23 10:32:42","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"41203","date":"2017-07-23 10:32:47","ss_terminal":null,"ss_code":null,"sale_id":"11340","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-23 10:32:47","serial":"admin-1500776009-15007771675517937","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-07-23 10:48:05', NULL, ''),
(948, 'sanni', '{"void_item":{"id":"41277","date":"2017-07-23 11:19:27","ss_terminal":null,"ss_code":null,"sale_id":"11356","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-23 11:19:27","serial":"admin-1500779539-1500779967562225","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-23 11:33:19', NULL, ''),
(949, 'sanni', '{"void_item":{"id":"41271","date":"2017-07-23 11:18:29","ss_terminal":null,"ss_code":null,"sale_id":"11355","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-23 11:18:29","serial":"admin-1500779539-15007799096571993","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-23 12:24:28', NULL, ''),
(950, 'sanni', '{"sale":{"id":"11362","txn_no":null,"table_no":"T9","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-07-23 12:20:00","payment_status":"Unpaid","cost":null,"subtotal":"23.00","amount":"25.30","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1500781238","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"41310","date":"2017-07-23 12:20:11","ss_terminal":null,"ss_code":null,"sale_id":"11362","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-23 12:20:11","serial":"admin-1500781238-15007836108861995","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"41309","date":"2017-07-23 12:20:11","ss_terminal":null,"ss_code":null,"sale_id":"11362","si_item_id":"0","item_id":"172","item_sku":"106","item_name":"Daily Berries ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-23 12:20:11","serial":"admin-1500781238-15007836108861995","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"41308","date":"2017-07-23 12:20:00","ss_terminal":null,"ss_code":null,"sale_id":"11362","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.30","margin":"0.0000","cost":"0.0000","amount":"2.30","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-23 12:20:00","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-07-23 15:51:57', NULL, ''),
(951, 'lois', '{"void_item":{"id":"41454","date":"2017-07-24 13:11:24","ss_terminal":null,"ss_code":null,"sale_id":"11401","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Signature Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-24 13:11:24","serial":"admin-1500871739-1500873083897314","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-24 13:37:08', NULL, ''),
(952, 'lois', '{"void_item":{"id":"41453","date":"2017-07-24 13:11:24","ss_terminal":null,"ss_code":null,"sale_id":"11401","si_item_id":"0","item_id":"194","item_sku":"129","item_name":"Deep Fried Chicken Wings","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-24 13:11:24","serial":"admin-1500871739-1500873083897314","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-24 13:37:17', NULL, ''),
(953, 'lois', '{"void_item":{"id":"41452","date":"2017-07-24 13:11:24","ss_terminal":null,"ss_code":null,"sale_id":"11401","si_item_id":"0","item_id":"253","item_sku":"187","item_name":"Cheese Baked Nachos","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-24 13:11:24","serial":"admin-1500871739-1500873083897314","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-24 13:37:31', NULL, ''),
(954, 'lois', '{"void_item":{"id":"41491","date":"2017-07-24 16:43:49","ss_terminal":null,"ss_code":null,"sale_id":"11411","si_item_id":"0","item_id":"285","item_sku":"219","item_name":"Lor Bak","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-24 16:43:49","serial":"admin-1500875902-15008858288508631","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-24 16:57:42', NULL, ''),
(955, 'lois', '{"void_item":{"id":"41508","date":"2017-07-26 10:19:30","ss_terminal":null,"ss_code":null,"sale_id":"11415","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.50","margin":"0.0000","cost":"0.0000","amount":"1.50","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-26 10:19:30","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-26 10:19:48', NULL, ''),
(956, 'sanni', '{"void_item":{"id":"41535","date":"2017-07-26 11:26:24","ss_terminal":null,"ss_code":null,"sale_id":"11422","si_item_id":null,"item_id":"9","item_sku":"9","item_name":"Affogato","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-26 11:26:24","serial":"admin-1501037957-15010395847365399","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-26 11:41:04', NULL, ''),
(957, 'sanni', '{"void_item":{"id":"41569","date":"2017-07-26 12:27:35","ss_terminal":null,"ss_code":null,"sale_id":"11429","si_item_id":"0","item_id":"162","item_sku":"96","item_name":"Homemade Chicken Bite ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-26 12:27:35","serial":"admin-1501040900-15010432557225489","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-26 12:29:43', NULL, ''),
(958, 'sanni', '{"void_item":{"id":"41580","date":"2017-07-26 13:02:20","ss_terminal":null,"ss_code":null,"sale_id":"11431","si_item_id":"0","item_id":"251","item_sku":"184","item_name":"Dinner Crispy Bacon Aglio Olio","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"26.90","margin":"26.9000","cost":"0.0000","amount":"26.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-26 13:02:20","serial":"admin-1501044964-15010453402495435","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-26 13:16:37', NULL, ''),
(959, 'lois', '{"void_item":{"id":"41592","date":"2017-07-26 13:30:55","ss_terminal":null,"ss_code":null,"sale_id":"11435","si_item_id":"0","item_id":"34","item_sku":"34","item_name":"Ginger Lemongrass Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-26 13:30:55","serial":"admin-1501044964-15010470548902745","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}}', '2017-07-26 17:11:24', NULL, ''),
(960, 'lois', '{"sale":{"id":"11435","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-07-26 13:30:42","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1501044964","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2017-07-26 17:11:46', NULL, ''),
(961, 'lois', '{"sale":{"id":"11452","txn_no":"111103","table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-07-27 11:27:15","payment_status":"Paid","cost":null,"subtotal":"5.00","amount":"5.00","amount_cash":"5.00","amount_cc":null,"amount_tendered":"5.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1501115441","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"41643","date":"2017-07-27 11:27:06","ss_terminal":null,"ss_code":null,"sale_id":"11452","si_item_id":null,"item_id":"46","item_sku":"46","item_name":"Coke","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":"1","terminal":"27","printed":"1","session":"1501115441","ordered_by":"admin","ordered_time":"2017-07-27 11:27:06","serial":"admin-1501115441-15011260258364575","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-07-27 11:29:44', 1, ''),
(962, 'lois', '{"sale":{"id":"11452","txn_no":"111103","table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-07-27 11:27:15","payment_status":"Unpaid","cost":null,"subtotal":"5.00","amount":"5.00","amount_cash":"5.00","amount_cc":null,"amount_tendered":"5.00","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1501115441","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"41643","date":"2017-07-27 11:27:06","ss_terminal":null,"ss_code":null,"sale_id":"11452","si_item_id":null,"item_id":"46","item_sku":"46","item_name":"Coke","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":"1","terminal":"27","printed":"1","session":"1501115441","ordered_by":"admin","ordered_time":"2017-07-27 11:27:06","serial":"admin-1501115441-15011260258364575","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-07-27 11:29:57', NULL, ''),
(963, 'sanni', '{"void_item":{"id":"41746","date":"2017-07-28 09:18:54","ss_terminal":null,"ss_code":null,"sale_id":"11480","si_item_id":"0","item_id":"271","item_sku":"205","item_name":"Take It Easy","item_option":"No yogurt","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-28 09:18:54","serial":"admin-1501203783-15012047343798996","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-28 09:44:07', NULL, ''),
(964, 'sanni', '{"void_item":{"id":"41813","date":"2017-07-28 13:07:19","ss_terminal":null,"ss_code":null,"sale_id":"11490","si_item_id":"0","item_id":"43","item_sku":"43","item_name":"Strawberry Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-28 13:07:19","serial":"admin-1501213126-1501218439506916","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-28 13:07:58', NULL, ''),
(965, 'sanni', '{"void_item":{"id":"41925","date":"2017-07-29 10:59:01","ss_terminal":null,"ss_code":null,"sale_id":"11521","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-29 10:59:01","serial":"admin-1501296421-15012971410738122","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-29 11:09:44', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(966, 'lois', '{"void_item":{"id":"41927","date":"2017-07-29 11:04:30","ss_terminal":null,"ss_code":null,"sale_id":"11520","si_item_id":"0","item_id":"232","item_sku":"166","item_name":"Candied Spicy Bacon Strips","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-29 11:04:30","serial":"admin-1501296421-15012974701889282","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-29 11:26:35', NULL, ''),
(967, 'sanni', '{"void_item":{"id":"42034","date":"2017-07-29 13:22:07","ss_terminal":null,"ss_code":null,"sale_id":"11539","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-29 13:22:07","serial":"admin-1501304242-15013057273715637","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-29 13:38:14', NULL, ''),
(968, 'lois', '{"void_item":{"id":"42071","date":"2017-07-29 15:54:29","ss_terminal":null,"ss_code":null,"sale_id":"11544","si_item_id":"0","item_id":"40","item_sku":"40","item_name":"Banana Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-29 15:54:29","serial":"admin-1501307487-15013148690125854","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-29 15:59:04', NULL, ''),
(969, 'lois', '{"void_item":{"id":"42074","date":"2017-07-29 16:24:43","ss_terminal":null,"ss_code":null,"sale_id":"11545","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.20","margin":"0.0000","cost":"0.0000","amount":"1.20","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-29 16:24:43","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-29 16:24:59', NULL, ''),
(970, 'sanni', '{"void_item":{"id":"42210","date":"2017-07-30 11:35:48","ss_terminal":null,"ss_code":null,"sale_id":"11572","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Cheesy Chicken Gratin","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-30 11:35:48","serial":"admin-1501384088-15013857483309777","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-30 12:13:04', NULL, ''),
(971, 'sanni', '{"void_item":{"id":"42267","date":"2017-07-30 12:10:39","ss_terminal":null,"ss_code":null,"sale_id":"11581","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-30 12:10:39","serial":"admin-1501386887-15013878391058092","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-30 12:14:10', NULL, ''),
(972, 'sanni', '{"void_item":{"id":"42268","date":"2017-07-30 12:12:06","ss_terminal":null,"ss_code":null,"sale_id":"11581","si_item_id":"0","item_id":"270","item_sku":"204","item_name":"Homemade Savoury Pancake","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-30 12:12:06","serial":"admin-1501386887-15013879261144138","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-30 12:14:22', NULL, ''),
(973, 'sanni', '{"void_item":{"id":"42295","date":"2017-07-30 12:50:11","ss_terminal":null,"ss_code":null,"sale_id":"11586","si_item_id":"0","item_id":"232","item_sku":"166","item_name":"Candied Spicy Bacon Strips","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-30 12:50:11","serial":"admin-1501388385-15013902108776758","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-30 12:55:30', NULL, ''),
(974, 'sanni', '{"void_item":{"id":"42376","date":"2017-07-30 15:23:44","ss_terminal":null,"ss_code":null,"sale_id":"11603","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"nutella toast","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"4.00","margin":"4.0000","cost":"0.0000","amount":"4.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-30 15:23:44","serial":"admin-1501396592-1501399423753405","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-30 15:24:10', NULL, ''),
(975, 'sanni', '{"void_item":{"id":"42410","date":"2017-07-31 09:58:19","ss_terminal":null,"ss_code":null,"sale_id":"11613","si_item_id":"0","item_id":"159","item_sku":"93","item_name":"Fruits & Yogurt Granola","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-07-31 09:58:19","serial":"admin-1501464189-15014662995019426","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-07-31 10:19:59', NULL, ''),
(976, 'sanni', '{"void_item":{"id":"42558","date":"2017-08-02 11:28:33","ss_terminal":null,"ss_code":null,"sale_id":"11648","si_item_id":"0","item_id":"232","item_sku":"166","item_name":"Candied Spicy Bacon Strips","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-02 11:28:33","serial":"admin-1501642747-15016445130238933","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-02 11:31:01', NULL, ''),
(977, 'sanni', '{"void_item":{"id":"42602","date":"2017-08-02 13:13:37","ss_terminal":null,"ss_code":null,"sale_id":"11657","si_item_id":"0","item_id":"270","item_sku":"204","item_name":"Homemade Savoury Pancake","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-02 13:13:37","serial":"admin-1501650691-15016508170632311","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-02 13:14:29', NULL, ''),
(978, 'sanni', '{"sale":{"id":"11651","txn_no":"111301","table_no":"T11","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-08-02 13:35:30","payment_status":"Paid","cost":null,"subtotal":"112.00","amount":"123.20","amount_cash":"123.20","amount_cc":null,"amount_tendered":"200.00","amount_change":"76.80","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1501650691","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"42582","date":"2017-08-02 12:36:21","ss_terminal":null,"ss_code":null,"sale_id":"11651","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1501650691","ordered_by":"admin","ordered_time":"2017-08-02 12:36:21","serial":"admin-1501642747-15016485814465231","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"42577","date":"2017-08-02 12:21:09","ss_terminal":null,"ss_code":null,"sale_id":"11651","si_item_id":null,"item_id":"62","item_sku":"62","item_name":"Orange","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1501650691","ordered_by":"admin","ordered_time":"2017-08-02 12:21:09","serial":"admin-1501642747-1501647668834312","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"42571","date":"2017-08-02 12:14:36","ss_terminal":null,"ss_code":null,"sale_id":"11651","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"11.20","margin":"0.0000","cost":"0.0000","amount":"11.20","sold":"1","terminal":"27","printed":"1","session":"1501650691","ordered_by":"admin","ordered_time":"2017-08-02 12:14:36","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"42572","date":"2017-08-02 12:18:29","ss_terminal":null,"ss_code":null,"sale_id":"11651","si_item_id":"0","item_id":"219","item_sku":"153","item_name":"Fried Rice With Bacon","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1501650691","ordered_by":"admin","ordered_time":"2017-08-02 12:18:29","serial":"admin-1501642747-1501647509794655","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"42573","date":"2017-08-02 12:18:29","ss_terminal":null,"ss_code":null,"sale_id":"11651","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"Garlic Fried Rice","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":"1","terminal":"27","printed":"1","session":"1501650691","ordered_by":"admin","ordered_time":"2017-08-02 12:18:29","serial":"admin-1501642747-1501647509794655","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"42574","date":"2017-08-02 12:18:29","ss_terminal":null,"ss_code":null,"sale_id":"11651","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1501650691","ordered_by":"admin","ordered_time":"2017-08-02 12:18:29","serial":"admin-1501642747-1501647509794655","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"42575","date":"2017-08-02 12:18:29","ss_terminal":null,"ss_code":null,"sale_id":"11651","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1501650691","ordered_by":"admin","ordered_time":"2017-08-02 12:18:29","serial":"admin-1501642747-1501647509794655","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"42583","date":"2017-08-02 12:36:21","ss_terminal":null,"ss_code":null,"sale_id":"11651","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1501650691","ordered_by":"admin","ordered_time":"2017-08-02 12:36:21","serial":"admin-1501642747-15016485814465231","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"42578","date":"2017-08-02 12:21:09","ss_terminal":null,"ss_code":null,"sale_id":"11651","si_item_id":"0","item_id":"37","item_sku":"37","item_name":"Pineapple Orange Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1501650691","ordered_by":"admin","ordered_time":"2017-08-02 12:21:09","serial":"admin-1501642747-1501647668834312","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"42576","date":"2017-08-02 12:18:30","ss_terminal":null,"ss_code":null,"sale_id":"11651","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"French Toast with Fruits","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1501650691","ordered_by":"admin","ordered_time":"2017-08-02 12:18:30","serial":"admin-1501642747-1501647509794655","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-08-02 13:36:12', 1, ''),
(979, 'lois', '{"void_item":{"id":"42640","date":"2017-08-02 15:57:00","ss_terminal":null,"ss_code":null,"sale_id":"11665","si_item_id":"0","item_id":"263","item_sku":"197","item_name":"Postcard With Postage","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"4.00","margin":"4.0000","cost":"0.0000","amount":"4.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-02 15:57:00","serial":"admin-1501656207-15016606203867840","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-02 15:58:04', NULL, ''),
(980, 'lois', '{"void_item":{"id":"42639","date":"2017-08-02 15:57:00","ss_terminal":null,"ss_code":null,"sale_id":"11665","si_item_id":"0","item_id":"263","item_sku":"197","item_name":"Postcard With Postage","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"4.00","margin":"4.0000","cost":"0.0000","amount":"4.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-02 15:57:00","serial":"admin-1501656207-15016606203867840","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-02 15:58:11', NULL, ''),
(981, 'lois', '{"void_item":{"id":"42727","date":"2017-08-03 17:59:14","ss_terminal":null,"ss_code":null,"sale_id":"11685","si_item_id":null,"item_id":"44","item_sku":"44","item_name":"Tiger ","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-03 17:59:14","serial":"admin-1501739307-15017543542557478","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}}', '2017-08-03 17:59:26', NULL, ''),
(982, 'lois', '{"void_item":{"id":"42728","date":"2017-08-03 17:59:32","ss_terminal":null,"ss_code":null,"sale_id":"11685","si_item_id":null,"item_id":"4","item_sku":"4","item_name":"Piccolo","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-03 17:59:32","serial":"admin-1501739307-15017543725851519","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}}', '2017-08-03 17:59:46', NULL, ''),
(983, 'lois', '{"sale":{"id":"11685","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-08-03 17:59:09","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1501739307","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2017-08-03 17:59:53', NULL, ''),
(984, 'sanni', '{"void_item":{"id":"42741","date":"2017-08-04 10:24:46","ss_terminal":null,"ss_code":null,"sale_id":"11690","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-04 10:24:46","serial":"admin-1501806629-15018134864016329","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-04 10:26:00', NULL, ''),
(985, 'sanni', '{"void_item":{"id":"42740","date":"2017-08-04 10:24:46","ss_terminal":null,"ss_code":null,"sale_id":"11690","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-04 10:24:46","serial":"admin-1501806629-15018134864016329","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-04 10:26:07', NULL, ''),
(986, 'lois', '{"sale":{"id":"11703","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-08-04 14:27:20","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1501820063","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"42790","date":"2017-08-04 14:27:20","ss_terminal":null,"ss_code":null,"sale_id":"11703","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-04 14:27:20","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-08-04 15:18:36', NULL, ''),
(987, 'lois', '{"void_item":{"id":"42993","date":"2017-08-05 14:42:19","ss_terminal":null,"ss_code":null,"sale_id":"11746","si_item_id":"0","item_id":"240","item_sku":"174","item_name":"Chocolate Affogato","item_option":"","category":"Cold Drinks","subcategory":"Frappe","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-05 14:42:19","serial":"admin-1501912953-15019153389523656","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-05 14:44:41', NULL, ''),
(988, 'lois', '{"sale":{"id":"11761","txn_no":null,"table_no":"IS","user_id":null,"username":null,"employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-08-05 16:51:35","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":null,"discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2017-08-05 17:00:17', NULL, ''),
(989, 'lois', '{"sale":{"id":"11760","txn_no":null,"table_no":"IS","user_id":null,"username":null,"employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-08-05 16:51:35","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":null,"discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2017-08-05 17:00:34', NULL, ''),
(990, 'lois', '{"sale":{"id":"11757","txn_no":null,"table_no":"T8","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-08-05 16:51:24","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1501915458","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"43037","date":"2017-08-05 16:51:24","ss_terminal":null,"ss_code":null,"sale_id":"11757","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-05 16:51:24","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-08-05 17:00:46', NULL, ''),
(991, 'lois', '{"sale":{"id":"11758","txn_no":null,"table_no":"T8","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-08-05 16:51:24","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1501915458","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"43036","date":"2017-08-05 16:51:24","ss_terminal":null,"ss_code":null,"sale_id":"11758","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-05 16:51:24","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-08-05 17:00:54', NULL, ''),
(992, 'lois', '{"sale":{"id":"11752","txn_no":"111405","table_no":"T14","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-08-05 17:36:14","payment_status":"Paid","cost":null,"subtotal":"48.00","amount":"52.80","amount_cash":"52.80","amount_cc":null,"amount_tendered":"55.00","amount_change":"2.20","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1501923116","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"43023","date":"2017-08-05 15:27:52","ss_terminal":null,"ss_code":null,"sale_id":"11752","si_item_id":null,"item_id":"67","item_sku":"67","item_name":"Carrot milk","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1501923116","ordered_by":"admin","ordered_time":"2017-08-05 15:27:52","serial":"admin-1501915458-15019180723045819","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"43024","date":"2017-08-05 15:27:52","ss_terminal":null,"ss_code":null,"sale_id":"11752","si_item_id":"0","item_id":"61","item_sku":"61","item_name":"Slim Fit","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1501923116","ordered_by":"admin","ordered_time":"2017-08-05 15:27:52","serial":"admin-1501915458-15019180723045819","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"43022","date":"2017-08-05 15:27:52","ss_terminal":null,"ss_code":null,"sale_id":"11752","si_item_id":"0","item_id":"159","item_sku":"93","item_name":"Fruits & Yogurt Granola","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":"1","terminal":"27","printed":"1","session":"1501923116","ordered_by":"admin","ordered_time":"2017-08-05 15:27:52","serial":"admin-1501915458-15019180723045819","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"43021","date":"2017-08-05 15:27:37","ss_terminal":null,"ss_code":null,"sale_id":"11752","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"4.80","margin":"0.0000","cost":"0.0000","amount":"4.80","sold":"1","terminal":"27","printed":"1","session":"1501923116","ordered_by":"admin","ordered_time":"2017-08-05 15:27:37","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"43051","date":"2017-08-05 17:15:50","ss_terminal":null,"ss_code":null,"sale_id":"11752","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1501923116","ordered_by":"admin","ordered_time":"2017-08-05 17:15:50","serial":"admin-1501923116-15019245505622097","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-08-05 17:37:07', 1, ''),
(993, 'lois', '{"sale":{"id":"11766","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-08-05 17:59:27","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1501923116","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"43055","date":"2017-08-05 17:59:27","ss_terminal":null,"ss_code":null,"sale_id":"11766","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-05 17:59:27","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-08-05 18:08:03', NULL, ''),
(994, 'sanni', '{"void_item":{"id":"43157","date":"2017-08-06 12:13:02","ss_terminal":null,"ss_code":null,"sale_id":"11783","si_item_id":"0","item_id":"233","item_sku":"167","item_name":"Naugthy Girl","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-06 12:13:02","serial":"admin-1501990006-15019927824089516","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-06 12:18:37', NULL, ''),
(995, 'sanni', '{"void_item":{"id":"43364","date":"2017-08-07 12:57:48","ss_terminal":null,"ss_code":null,"sale_id":"11829","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-07 12:57:48","serial":"admin-1502076683-15020818686741647","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-07 12:59:59', NULL, ''),
(996, 'sanni', '{"void_item":{"id":"43365","date":"2017-08-07 12:58:57","ss_terminal":null,"ss_code":null,"sale_id":"11829","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"BFF","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-07 12:58:57","serial":"admin-1502076683-15020819371204861","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-07 13:04:33', NULL, ''),
(997, 'lois', '{"sale":{"id":"11866","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-08-09 13:09:38","payment_status":"Unpaid","cost":null,"subtotal":"24.00","amount":"26.40","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1502254762","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"43512","date":"2017-08-09 13:09:38","ss_terminal":null,"ss_code":null,"sale_id":"11866","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.40","margin":"0.0000","cost":"0.0000","amount":"2.40","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-09 13:09:38","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"43515","date":"2017-08-09 13:10:00","ss_terminal":null,"ss_code":null,"sale_id":"11866","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"No need soup","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-09 13:10:00","serial":"admin-1502254762-1502255400765421","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"43514","date":"2017-08-09 13:10:00","ss_terminal":null,"ss_code":null,"sale_id":"11866","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-09 13:10:00","serial":"admin-1502254762-1502255400765421","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"43513","date":"2017-08-09 13:10:00","ss_terminal":null,"ss_code":null,"sale_id":"11866","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-09 13:10:00","serial":"admin-1502254762-1502255400765421","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-08-09 13:15:58', NULL, ''),
(998, 'lois', '{"void_item":{"id":"43482","date":"2017-08-09 12:26:58","ss_terminal":null,"ss_code":null,"sale_id":"11857","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-09 12:26:58","serial":"admin-1502250878-15022528179002041","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-09 13:43:50', NULL, ''),
(999, 'lois', '{"sale":{"id":"11873","txn_no":null,"table_no":"T10","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-08-09 13:52:02","payment_status":"Unpaid","cost":null,"subtotal":"6.00","amount":"6.60","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1502256100","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"43546","date":"2017-08-09 13:52:03","ss_terminal":null,"ss_code":null,"sale_id":"11873","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.60","margin":"0.0000","cost":"0.0000","amount":"0.60","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-09 13:52:03","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"43548","date":"2017-08-09 13:52:19","ss_terminal":null,"ss_code":null,"sale_id":"11873","si_item_id":"0","item_id":"262","item_sku":"196","item_name":"Cheesy Sticks","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-09 13:52:19","serial":"admin-1502256100-15022579391873093","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"43547","date":"2017-08-09 13:52:19","ss_terminal":null,"ss_code":null,"sale_id":"11873","si_item_id":"0","item_id":"262","item_sku":"196","item_name":"Cheesy Sticks","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-09 13:52:19","serial":"admin-1502256100-15022579391873093","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-08-09 13:54:17', NULL, ''),
(1000, 'sanni', '{"void_item":{"id":"43658","date":"2017-08-10 12:38:55","ss_terminal":null,"ss_code":null,"sale_id":"11900","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-10 12:38:55","serial":"admin-1502335407-15023399347367691","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-10 12:41:30', NULL, ''),
(1001, 'sanni', '{"void_item":{"id":"43725","date":"2017-08-11 11:39:08","ss_terminal":null,"ss_code":null,"sale_id":"11914","si_item_id":"0","item_id":"182","item_sku":"117","item_name":"Open Drinks ","item_option":"yogurt","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-11 11:39:08","serial":"admin-1502422481-15024227480145822","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-11 11:47:54', NULL, ''),
(1002, 'sanni', '{"void_item":{"id":"43745","date":"2017-08-11 12:58:13","ss_terminal":null,"ss_code":null,"sale_id":"11920","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-11 12:58:13","serial":"admin-1502422481-15024274934874839","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-11 12:59:23', NULL, ''),
(1003, 'lois', '{"sale":{"id":"11937","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-08-12 09:24:37","payment_status":"Unpaid","cost":null,"subtotal":"83.00","amount":"91.30","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1502499757","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"43820","date":"2017-08-12 09:24:47","ss_terminal":null,"ss_code":null,"sale_id":"11937","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-12 09:24:47","serial":"admin-1502499757-15025010869069499","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"43821","date":"2017-08-12 09:24:47","ss_terminal":null,"ss_code":null,"sale_id":"11937","si_item_id":"0","item_id":"271","item_sku":"205","item_name":"Take It Easy","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-12 09:24:47","serial":"admin-1502499757-15025010869069499","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"43825","date":"2017-08-12 09:25:06","ss_terminal":null,"ss_code":null,"sale_id":"11937","si_item_id":null,"item_id":"64","item_sku":"64","item_name":"Green Apple","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-12 09:25:06","serial":"admin-1502501091-15025011060375784","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"43824","date":"2017-08-12 09:25:06","ss_terminal":null,"ss_code":null,"sale_id":"11937","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-12 09:25:06","serial":"admin-1502501091-15025011060375784","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"43823","date":"2017-08-12 09:25:06","ss_terminal":null,"ss_code":null,"sale_id":"11937","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-12 09:25:06","serial":"admin-1502501091-15025011060375784","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"43822","date":"2017-08-12 09:24:47","ss_terminal":null,"ss_code":null,"sale_id":"11937","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-12 09:24:47","serial":"admin-1502499757-15025010869069499","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"43819","date":"2017-08-12 09:24:37","ss_terminal":null,"ss_code":null,"sale_id":"11937","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"8.30","margin":"0.0000","cost":"0.0000","amount":"8.30","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-12 09:24:37","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-08-12 10:03:56', NULL, ''),
(1004, 'lois', '{"sale":[],"sale_items":[]}', '2017-08-12 10:03:58', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(1005, 'sanni', '{"sale":{"id":"11967","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-08-12 13:52:53","payment_status":"Unpaid","cost":null,"subtotal":"16.00","amount":"17.60","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1502511755","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"43969","date":"2017-08-12 13:53:01","ss_terminal":null,"ss_code":null,"sale_id":"11967","si_item_id":"0","item_id":"75","item_sku":"75","item_name":"Meatless Aglio Olio ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-12 13:53:01","serial":"admin-1502511755-15025171815236954","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"43968","date":"2017-08-12 13:52:53","ss_terminal":null,"ss_code":null,"sale_id":"11967","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.60","margin":"0.0000","cost":"0.0000","amount":"1.60","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-12 13:52:53","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-08-12 14:59:43', NULL, ''),
(1006, 'sanni', '{"void_item":{"id":"44052","date":"2017-08-13 09:33:57","ss_terminal":null,"ss_code":null,"sale_id":"11983","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-13 09:33:57","serial":"admin-1502588024-1502588037118595","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-13 09:38:11', NULL, ''),
(1007, 'sanni', '{"void_item":{"id":"44098","date":"2017-08-13 09:57:00","ss_terminal":null,"ss_code":null,"sale_id":"11985","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-13 09:57:00","serial":"admin-1502589215-15025894204524832","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-13 09:58:01', NULL, ''),
(1008, 'sanni', '{"void_item":{"id":"44097","date":"2017-08-13 09:57:00","ss_terminal":null,"ss_code":null,"sale_id":"11985","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-13 09:57:00","serial":"admin-1502589215-15025894204524832","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-13 09:58:13', NULL, ''),
(1009, 'sanni', '{"void_item":{"id":"44048","date":"2017-08-13 09:28:05","ss_terminal":null,"ss_code":null,"sale_id":"11982","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-13 09:28:05","serial":"admin-1502586496-15025876857426412","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-13 10:01:11', NULL, ''),
(1010, 'lois', '{"void_item":{"id":"44083","date":"2017-08-13 09:46:05","ss_terminal":null,"ss_code":null,"sale_id":"11989","si_item_id":"0","item_id":"159","item_sku":"93","item_name":"Fruits & Yogurt Granola","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-13 09:46:05","serial":"admin-1502588024-15025887654273744","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-13 10:32:28', NULL, ''),
(1011, 'sanni', '{"sale":{"id":"11991","txn_no":null,"table_no":"T8","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-08-13 09:53:42","payment_status":"Unpaid","cost":null,"subtotal":"12.00","amount":"13.20","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1502589215","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"44094","date":"2017-08-13 09:53:42","ss_terminal":null,"ss_code":null,"sale_id":"11991","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.20","margin":"0.0000","cost":"0.0000","amount":"1.20","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-13 09:53:42","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"44095","date":"2017-08-13 09:54:03","ss_terminal":null,"ss_code":null,"sale_id":"11991","si_item_id":"0","item_id":"24","item_sku":"24","item_name":"Chai Latte","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-13 09:54:03","serial":"admin-1502589215-15025892428843465","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-08-13 11:55:14', NULL, ''),
(1012, 'sanni', '{"void_item":{"id":"44178","date":"2017-08-13 11:51:41","ss_terminal":null,"ss_code":null,"sale_id":"12004","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-13 11:51:41","serial":"admin-1502592651-15025963017629024","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-13 12:01:58', NULL, ''),
(1013, 'sanni', '{"void_item":{"id":"44182","date":"2017-08-13 11:53:33","ss_terminal":null,"ss_code":null,"sale_id":"12005","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-13 11:53:33","serial":"admin-1502592651-15025964129109875","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-13 12:31:30', NULL, ''),
(1014, 'lois', '{"void_item":{"id":"44450","date":"2017-08-16 11:26:41","ss_terminal":null,"ss_code":null,"sale_id":"12068","si_item_id":null,"item_id":"22","item_sku":"22","item_name":"Honey Milk","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-16 11:26:41","serial":"admin-1502845141-15028540017588550","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-16 11:39:20', NULL, ''),
(1015, 'sanni', '{"void_item":{"id":"44621","date":"2017-08-17 15:17:19","ss_terminal":null,"ss_code":null,"sale_id":"12111","si_item_id":"0","item_id":"243","item_sku":"177","item_name":"Hot Ginger Lemongrass","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-17 15:17:19","serial":"admin-1502948728-1502954239218154","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-17 15:34:27', NULL, ''),
(1016, 'lois', '{"void_item":{"id":"44684","date":"2017-08-18 12:56:36","ss_terminal":null,"ss_code":null,"sale_id":"12128","si_item_id":"0","item_id":"60","item_sku":"60","item_name":"The Hulk","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-18 12:56:36","serial":"admin-1503016596-15030321961614669","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-18 13:24:39', NULL, ''),
(1017, 'sanni', '{"void_item":{"id":"44876","date":"2017-08-19 14:12:59","ss_terminal":null,"ss_code":null,"sale_id":"12165","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-19 14:12:59","serial":"admin-1503122978-15031231790362871","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-19 14:19:18', NULL, ''),
(1018, 'sanni', '{"void_item":{"id":"44875","date":"2017-08-19 14:12:59","ss_terminal":null,"ss_code":null,"sale_id":"12165","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-19 14:12:59","serial":"admin-1503122978-15031231790362871","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-19 14:19:41', NULL, ''),
(1019, 'sanni', '{"void_item":{"id":"44877","date":"2017-08-19 14:19:31","ss_terminal":null,"ss_code":null,"sale_id":"12164","si_item_id":"0","item_id":"183","item_sku":"118","item_name":"Plain Rice","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"2.00","margin":"2.0000","cost":"0.0000","amount":"2.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-19 14:19:31","serial":"admin-1503122978-15031235713943841","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-19 14:27:15', NULL, ''),
(1020, 'lois', '{"void_item":{"id":"44884","date":"2017-08-19 15:17:58","ss_terminal":null,"ss_code":null,"sale_id":"12167","si_item_id":"0","item_id":"28","item_sku":"28","item_name":"Iced Honey Milk","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-19 15:17:58","serial":"admin-1503122978-15031270784007731","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-19 15:20:14', NULL, ''),
(1021, '', '{"void_item":{"id":"44939","date":"2017-08-20 09:33:55","ss_terminal":null,"ss_code":null,"sale_id":"12177","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-20 09:33:55","serial":"admin-1503192542-15031928348572295","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-20 09:39:17', NULL, ''),
(1022, 'lois', '{"void_item":{"id":"45105","date":"2017-08-20 13:54:23","ss_terminal":null,"ss_code":null,"sale_id":"12203","si_item_id":"0","item_id":"217","item_sku":"151","item_name":"Spicy Lemony Wings","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-20 13:54:23","serial":"admin-1503207695-15032084630533549","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-20 13:59:17', NULL, ''),
(1023, 'lois', '{"void_item":{"id":"45103","date":"2017-08-20 13:53:16","ss_terminal":null,"ss_code":null,"sale_id":"12199","si_item_id":"0","item_id":"26","item_sku":"26","item_name":"Iced Honey Lemon","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-20 13:53:16","serial":"admin-1503207695-15032083962515029","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-20 14:01:12', NULL, ''),
(1024, 'lois', '{"sale":{"id":"12216","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-08-20 15:19:22","payment_status":"Unpaid","cost":null,"subtotal":"22.00","amount":"24.20","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1503211146","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"45149","date":"2017-08-20 15:19:22","ss_terminal":null,"ss_code":null,"sale_id":"12216","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.20","margin":"0.0000","cost":"0.0000","amount":"2.20","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-20 15:19:22","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"45150","date":"2017-08-20 15:19:30","ss_terminal":null,"ss_code":null,"sale_id":"12216","si_item_id":"0","item_id":"43","item_sku":"43","item_name":"Strawberry Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-20 15:19:30","serial":"admin-1503211146-15032135702376836","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"45151","date":"2017-08-20 15:19:30","ss_terminal":null,"ss_code":null,"sale_id":"12216","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-20 15:19:30","serial":"admin-1503211146-15032135702376836","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-08-20 17:04:36', NULL, ''),
(1025, 'sanni', '{"void_item":{"id":"45304","date":"2017-08-23 11:08:55","ss_terminal":null,"ss_code":null,"sale_id":"12256","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-23 11:08:55","serial":"admin-1503451445-15034577357666495","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-23 11:30:44', NULL, ''),
(1026, 'sanni', '{"void_item":{"id":"45329","date":"2017-08-23 11:54:27","ss_terminal":null,"ss_code":null,"sale_id":"12260","si_item_id":"0","item_id":"277","item_sku":"211","item_name":"Iced Ginger Lemongrass","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-23 11:54:27","serial":"admin-1503451445-15034604672946071","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-23 11:55:38', NULL, ''),
(1027, 'sanni', '{"void_item":{"id":"45404","date":"2017-08-24 11:51:35","ss_terminal":null,"ss_code":null,"sale_id":"12280","si_item_id":"0","item_id":"17","item_sku":"17","item_name":"Iced Caramel Macchiato ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-24 11:51:35","serial":"admin-1503544242-15035466956421877","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-24 11:52:04', NULL, ''),
(1028, 'sanni', '{"void_item":{"id":"45471","date":"2017-08-25 10:57:09","ss_terminal":null,"ss_code":null,"sale_id":"12296","si_item_id":"0","item_id":"60","item_sku":"60","item_name":"The Hulk","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-25 10:57:09","serial":"admin-1503622823-15036298296706353","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-25 11:01:38', NULL, ''),
(1029, 'sanni', '{"void_item":{"id":"45703","date":"2017-08-26 12:18:43","ss_terminal":null,"ss_code":null,"sale_id":"12346","si_item_id":"0","item_id":"270","item_sku":"204","item_name":"Homemade Savoury Pancake","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-26 12:18:43","serial":"admin-1503718638-15037211232929485","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-26 12:24:39', NULL, ''),
(1030, 'lois', '{"void_item":{"id":"45863","date":"2017-08-27 10:46:17","ss_terminal":null,"ss_code":null,"sale_id":"12373","si_item_id":null,"item_id":"68","item_sku":"68","item_name":"Mix 2 types ","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-27 10:46:17","serial":"admin-1503800947-15038019769416861","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-27 11:02:09', NULL, ''),
(1031, 'lois', '{"void_item":{"id":"46258","date":"2017-08-28 15:51:49","ss_terminal":null,"ss_code":null,"sale_id":"12439","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-28 15:51:49","serial":"admin-1503898703-15039067092225353","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-28 15:52:25', NULL, ''),
(1032, 'lois', '{"void_item":{"id":"46272","date":"2017-08-30 09:32:03","ss_terminal":null,"ss_code":null,"sale_id":"12456","si_item_id":"0","item_id":"270","item_sku":"204","item_name":"Homemade Savoury Pancake","item_option":"CHANGE TO BREAD","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-30 09:32:03","serial":"admin-1504055748-15040567231205932","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-30 09:32:39', NULL, ''),
(1033, 'sanni', '{"void_item":{"id":"46331","date":"2017-08-30 12:44:23","ss_terminal":null,"ss_code":null,"sale_id":"12466","si_item_id":"0","item_id":"229","item_sku":"163","item_name":"Mummy''s Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-30 12:44:23","serial":"admin-1504060332-15040682630061289","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-30 12:46:04', NULL, ''),
(1034, 'lois', '{"void_item":{"id":"46325","date":"2017-08-30 12:32:57","ss_terminal":null,"ss_code":null,"sale_id":"12465","si_item_id":"0","item_id":"253","item_sku":"187","item_name":"Cheese Baked Nachos","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-30 12:32:57","serial":"admin-1504060332-15040675775011393","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-30 13:21:58', NULL, ''),
(1035, 'sanni', '{"void_item":{"id":"46509","date":"2017-08-31 13:46:31","ss_terminal":null,"ss_code":null,"sale_id":"12500","si_item_id":"0","item_id":"20","item_sku":"20","item_name":"Iced DD Special","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-31 13:46:31","serial":"admin-1504152136-15041583911059558","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-08-31 13:49:43', NULL, ''),
(1036, 'sanni', '{"void_item":{"id":"46530","date":"2017-08-31 14:36:59","ss_terminal":null,"ss_code":null,"sale_id":"12507","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-08-31 14:36:59","serial":"admin-1504152136-15041614191778469","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}}', '2017-08-31 14:37:27', NULL, ''),
(1037, 'sanni', '{"sale":{"id":"12536","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-09-01 11:26:43","payment_status":"Unpaid","cost":null,"subtotal":"19.00","amount":"20.90","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1504235199","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"46701","date":"2017-09-01 11:27:04","ss_terminal":null,"ss_code":null,"sale_id":"12536","si_item_id":"0","item_id":"286","item_sku":"220","item_name":"Joyous Sunny","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"19.00","margin":"19.0000","cost":"0.0000","amount":"19.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-01 11:27:04","serial":"admin-1504235199-15042364244262324","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"46700","date":"2017-09-01 11:26:43","ss_terminal":null,"ss_code":null,"sale_id":"12536","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.90","margin":"0.0000","cost":"0.0000","amount":"1.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-01 11:26:43","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-01 11:50:13', NULL, ''),
(1038, 'sanni', '{"sale":{"id":"12532","txn_no":null,"table_no":"T13","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-09-01 11:00:13","payment_status":"Unpaid","cost":null,"subtotal":"97.00","amount":"106.70","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1504226956","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"46676","date":"2017-09-01 11:00:56","ss_terminal":null,"ss_code":null,"sale_id":"12532","si_item_id":"0","item_id":"156","item_sku":"90","item_name":"House Cheddar Omelet","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-01 11:00:56","serial":"admin-1504226956-1504234856682816","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"46674","date":"2017-09-01 11:00:13","ss_terminal":null,"ss_code":null,"sale_id":"12532","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"9.70","margin":"0.0000","cost":"0.0000","amount":"9.70","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-01 11:00:13","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"46675","date":"2017-09-01 11:00:56","ss_terminal":null,"ss_code":null,"sale_id":"12532","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-01 11:00:56","serial":"admin-1504226956-1504234856682816","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"46680","date":"2017-09-01 11:00:56","ss_terminal":null,"ss_code":null,"sale_id":"12532","si_item_id":null,"item_id":"7","item_sku":"7","item_name":"Mocha ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-01 11:00:56","serial":"admin-1504226956-1504234856682816","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"46681","date":"2017-09-01 11:00:56","ss_terminal":null,"ss_code":null,"sale_id":"12532","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-01 11:00:56","serial":"admin-1504226956-1504234856682816","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"46677","date":"2017-09-01 11:00:56","ss_terminal":null,"ss_code":null,"sale_id":"12532","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"French Toast with Fruits","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-01 11:00:56","serial":"admin-1504226956-1504234856682816","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"46678","date":"2017-09-01 11:00:56","ss_terminal":null,"ss_code":null,"sale_id":"12532","si_item_id":"0","item_id":"159","item_sku":"93","item_name":"Fruits & Yogurt Granola","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-01 11:00:56","serial":"admin-1504226956-1504234856682816","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"46679","date":"2017-09-01 11:00:56","ss_terminal":null,"ss_code":null,"sale_id":"12532","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-01 11:00:56","serial":"admin-1504226956-1504234856682816","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-01 12:36:30', NULL, ''),
(1039, 'sanni', '{"sale":{"id":"12542","txn_no":null,"table_no":"T13","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-09-01 12:36:42","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1504238239","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"46726","date":"2017-09-01 12:36:42","ss_terminal":null,"ss_code":null,"sale_id":"12542","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-01 12:36:42","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-01 12:37:12', NULL, ''),
(1040, 'sanni', '{"sale":{"id":"12559","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-09-01 15:43:41","payment_status":"Unpaid","cost":null,"subtotal":"9.00","amount":"9.90","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1504244728","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"46812","date":"2017-09-01 15:43:41","ss_terminal":null,"ss_code":null,"sale_id":"12559","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.90","margin":"0.0000","cost":"0.0000","amount":"0.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-01 15:43:41","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"46813","date":"2017-09-01 15:46:01","ss_terminal":null,"ss_code":null,"sale_id":"12559","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"americano with cookies","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-01 15:46:01","serial":"admin-1504244728-1504251961154730","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-01 15:49:52', NULL, ''),
(1041, 'sanni', '{"sale":{"id":"12564","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-09-01 16:09:15","payment_status":"Unpaid","cost":null,"subtotal":"33.00","amount":"36.30","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1504251976","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"46827","date":"2017-09-01 16:09:15","ss_terminal":null,"ss_code":null,"sale_id":"12564","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"3.30","margin":"0.0000","cost":"0.0000","amount":"3.30","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-01 16:09:15","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"46828","date":"2017-09-01 16:09:30","ss_terminal":null,"ss_code":null,"sale_id":"12564","si_item_id":"0","item_id":"163","item_sku":"97","item_name":"Melting Heart ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-01 16:09:30","serial":"admin-1504251976-15042533705495581","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"46830","date":"2017-09-01 16:09:30","ss_terminal":null,"ss_code":null,"sale_id":"12564","si_item_id":"0","item_id":"27","item_sku":"27","item_name":"Iced Chocolate ","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-01 16:09:30","serial":"admin-1504251976-15042533705495581","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"46829","date":"2017-09-01 16:09:30","ss_terminal":null,"ss_code":null,"sale_id":"12564","si_item_id":"0","item_id":"247","item_sku":"181","item_name":"Caramel Chocolate Cheese","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-01 16:09:30","serial":"admin-1504251976-15042533705495581","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-01 16:48:59', NULL, ''),
(1042, 'sanni', '{"void_item":{"id":"46901","date":"2017-09-02 10:37:24","ss_terminal":null,"ss_code":null,"sale_id":"12578","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"French Toast with Fruits","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"sanni","ordered_time":"2017-09-02 10:37:24","serial":"sanni-1504259386-15043196750566271","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-02 10:39:22', NULL, ''),
(1043, 'sanni', '{"void_item":{"id":"46900","date":"2017-09-02 10:37:24","ss_terminal":null,"ss_code":null,"sale_id":"12578","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"sanni","ordered_time":"2017-09-02 10:37:24","serial":"sanni-1504259386-15043196750566271","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-02 10:39:32', NULL, ''),
(1044, 'sanni', '{"void_item":{"id":"46945","date":"2017-09-02 11:53:00","ss_terminal":null,"ss_code":null,"sale_id":"12587","si_item_id":null,"item_id":"44","item_sku":"44","item_name":"Tiger ","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-02 11:53:00","serial":"admin-1504319848-15043243806975991","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-02 11:54:12', NULL, ''),
(1045, 'sanni', '{"void_item":{"id":"47072","date":"2017-09-03 10:52:21","ss_terminal":null,"ss_code":null,"sale_id":"12615","si_item_id":"0","item_id":"78","item_sku":"78","item_name":"Cheesy Baked Mashed Potato","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-03 10:52:21","serial":"admin-1504400131-15044071412156035","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-03 10:53:33', NULL, ''),
(1046, 'sanni', '{"void_item":{"id":"47250","date":"2017-09-04 10:47:53","ss_terminal":null,"ss_code":null,"sale_id":"12648","si_item_id":null,"item_id":"21","item_sku":"21","item_name":"Chocolate ","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-04 10:47:53","serial":"admin-1504485270-15044932733729425","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-04 11:32:40', NULL, ''),
(1047, 'sanni', '{"void_item":{"id":"47251","date":"2017-09-04 10:47:53","ss_terminal":null,"ss_code":null,"sale_id":"12648","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-04 10:47:53","serial":"admin-1504485270-15044932733729425","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-04 11:32:47', NULL, ''),
(1048, 'sanni', '{"void_item":{"id":"47255","date":"2017-09-04 10:49:56","ss_terminal":null,"ss_code":null,"sale_id":"12649","si_item_id":null,"item_id":"67","item_sku":"67","item_name":"Carrot milk","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-04 10:49:56","serial":"admin-1504485270-15044933959746612","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-04 11:49:56', NULL, ''),
(1049, 'sanni', '{"void_item":{"id":"47254","date":"2017-09-04 10:49:56","ss_terminal":null,"ss_code":null,"sale_id":"12649","si_item_id":null,"item_id":"21","item_sku":"21","item_name":"Chocolate ","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-04 10:49:56","serial":"admin-1504485270-15044933959746612","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-04 11:50:03', NULL, ''),
(1050, 'sanni', '{"void_item":{"id":"47253","date":"2017-09-04 10:49:56","ss_terminal":null,"ss_code":null,"sale_id":"12649","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-04 10:49:56","serial":"admin-1504485270-15044933959746612","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-04 11:50:12', NULL, ''),
(1051, 'sanni', '{"sale":{"id":"12652","txn_no":null,"table_no":"T5","user_id":"10008","username":"lois","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-09-04 11:01:24","payment_status":"Unpaid","cost":null,"subtotal":"25.00","amount":"27.50","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1504493749","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"47271","date":"2017-09-04 11:01:44","ss_terminal":null,"ss_code":null,"sale_id":"12652","si_item_id":null,"item_id":"10","item_sku":"10","item_name":"Dirty Chai","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"lois","ordered_time":"2017-09-04 11:01:44","serial":"lois-1504493749-15044941043837959","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"47270","date":"2017-09-04 11:01:44","ss_terminal":null,"ss_code":null,"sale_id":"12652","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"lois","ordered_time":"2017-09-04 11:01:44","serial":"lois-1504493749-15044941043837959","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"47269","date":"2017-09-04 11:01:24","ss_terminal":null,"ss_code":null,"sale_id":"12652","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.50","margin":"0.0000","cost":"0.0000","amount":"2.50","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"lois","ordered_time":"2017-09-04 11:01:24","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-04 11:51:38', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(1052, 'sanni', '{"void_item":{"id":"47320","date":"2017-09-04 12:15:13","ss_terminal":null,"ss_code":null,"sale_id":"12661","si_item_id":"0","item_id":"184","item_sku":"119","item_name":"Flat White","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"lois","ordered_time":"2017-09-04 12:15:13","serial":"lois-1504493749-1504498513704746","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-04 12:56:17', NULL, ''),
(1053, 'lois', '{"void_item":{"id":"47359","date":"2017-09-04 15:38:31","ss_terminal":null,"ss_code":null,"sale_id":"12670","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Signature Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-04 15:38:31","serial":"admin-1504506284-15045107115288155","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-04 15:45:34', NULL, ''),
(1054, 'lois', '{"void_item":{"id":"47363","date":"2017-09-04 15:40:29","ss_terminal":null,"ss_code":null,"sale_id":"12671","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Signature Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-04 15:40:29","serial":"admin-1504506284-15045108296184536","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-04 15:45:48', NULL, ''),
(1055, 'lois', '{"void_item":{"id":"47382","date":"2017-09-04 16:30:48","ss_terminal":null,"ss_code":null,"sale_id":"12675","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.80","margin":"0.0000","cost":"0.0000","amount":"0.80","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-04 16:30:48","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-04 16:33:57', NULL, ''),
(1056, 'lois', '{"sale":{"id":"12684","txn_no":null,"table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-09-06 12:25:10","payment_status":"Unpaid","cost":null,"subtotal":"25.00","amount":"27.50","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1504660309","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"47413","date":"2017-09-06 12:25:16","ss_terminal":null,"ss_code":null,"sale_id":"12684","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-06 12:25:16","serial":"admin-1504660309-15046719159484676","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"47411","date":"2017-09-06 12:25:10","ss_terminal":null,"ss_code":null,"sale_id":"12684","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.50","margin":"0.0000","cost":"0.0000","amount":"2.50","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-06 12:25:10","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"47412","date":"2017-09-06 12:25:16","ss_terminal":null,"ss_code":null,"sale_id":"12684","si_item_id":"0","item_id":"70","item_sku":"70","item_name":"Pepper Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-06 12:25:16","serial":"admin-1504660309-15046719159484676","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-06 13:10:08', NULL, ''),
(1057, 'sanni', '{"sale":{"id":"12686","txn_no":null,"table_no":"T1","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-09-06 12:58:29","payment_status":"Unpaid","cost":null,"subtotal":"12.00","amount":"13.20","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1504660309","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"47418","date":"2017-09-06 12:58:34","ss_terminal":null,"ss_code":null,"sale_id":"12686","si_item_id":"0","item_id":"247","item_sku":"181","item_name":"Caramel Chocolate Cheese","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-06 12:58:34","serial":"admin-1504660309-15046739145113670","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"47417","date":"2017-09-06 12:58:29","ss_terminal":null,"ss_code":null,"sale_id":"12686","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.20","margin":"0.0000","cost":"0.0000","amount":"1.20","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-06 12:58:29","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-06 13:19:10', NULL, ''),
(1058, 'lois', '{"void_item":{"id":"47428","date":"2017-09-06 13:29:17","ss_terminal":null,"ss_code":null,"sale_id":"12689","si_item_id":"0","item_id":"74","item_sku":"74","item_name":"Sunrice","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-06 13:29:17","serial":"admin-1504660309-1504675757188697","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-06 13:39:25', NULL, ''),
(1059, 'sanni', '{"void_item":{"id":"47462","date":"2017-09-07 11:28:56","ss_terminal":null,"ss_code":null,"sale_id":"12699","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-07 11:28:56","serial":"admin-1504746280-1504754936546215","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-07 12:25:07', NULL, ''),
(1060, 'sanni', '{"void_item":{"id":"47461","date":"2017-09-07 11:28:56","ss_terminal":null,"ss_code":null,"sale_id":"12699","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-07 11:28:56","serial":"admin-1504746280-1504754936546215","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":"0.0","global_discount":null}}', '2017-09-07 12:25:14', NULL, ''),
(1061, 'sanni', '{"void_item":{"id":"47479","date":"2017-09-07 12:59:01","ss_terminal":null,"ss_code":null,"sale_id":"12703","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Signature Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-07 12:59:01","serial":"admin-1504746280-1504760341827637","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-07 13:15:38', NULL, ''),
(1062, 'lois', '{"sale":{"id":"12724","txn_no":null,"table_no":"T14","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-09-08 15:47:14","payment_status":"Unpaid","cost":null,"subtotal":"10.00","amount":"11.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1504831437","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"47559","date":"2017-09-08 15:47:14","ss_terminal":null,"ss_code":null,"sale_id":"12724","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.00","margin":"0.0000","cost":"0.0000","amount":"1.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-08 15:47:14","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"47560","date":"2017-09-08 15:47:18","ss_terminal":null,"ss_code":null,"sale_id":"12724","si_item_id":null,"item_id":"33","item_sku":"33","item_name":"Cucumber Lime ","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-08 15:47:18","serial":"admin-1504831437-15048568380165597","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-08 16:38:11', NULL, ''),
(1063, 'lois', '{"sale":{"id":"12726","txn_no":null,"table_no":"T12","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-09-08 17:25:31","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1504831437","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"47563","date":"2017-09-08 17:25:31","ss_terminal":null,"ss_code":null,"sale_id":"12726","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-08 17:25:31","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-08 17:31:02', NULL, ''),
(1064, 'lois', '{"void_item":{"id":"47687","date":"2017-09-09 11:39:09","ss_terminal":null,"ss_code":null,"sale_id":"12747","si_item_id":"0","item_id":"270","item_sku":"204","item_name":"Homemade Savoury Pancake","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-09 11:39:09","serial":"admin-1504925273-15049283490745161","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-09 11:42:17', NULL, ''),
(1065, 'sanni', '{"void_item":{"id":"47760","date":"2017-09-09 15:12:26","ss_terminal":null,"ss_code":null,"sale_id":"12764","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-09 15:12:26","serial":"admin-1504933524-15049411460271143","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-09 15:32:02', NULL, ''),
(1066, 'sanni', '{"void_item":{"id":"47917","date":"2017-09-10 13:23:18","ss_terminal":null,"ss_code":null,"sale_id":"12797","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-10 13:23:18","serial":"admin-1505015850-15050209983097289","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-10 13:26:46', NULL, ''),
(1067, 'lois', '{"sale":{"id":"12798","txn_no":null,"table_no":"T8","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-09-10 13:44:49","payment_status":"Unpaid","cost":null,"subtotal":"46.00","amount":"50.60","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1505015850","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"47929","date":"2017-09-10 13:45:02","ss_terminal":null,"ss_code":null,"sale_id":"12798","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-10 13:45:02","serial":"admin-1505015850-15050223019744788","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"47930","date":"2017-09-10 13:45:02","ss_terminal":null,"ss_code":null,"sale_id":"12798","si_item_id":null,"item_id":"62","item_sku":"62","item_name":"Orange","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-10 13:45:02","serial":"admin-1505015850-15050223019744788","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"47926","date":"2017-09-10 13:44:49","ss_terminal":null,"ss_code":null,"sale_id":"12798","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"4.60","margin":"0.0000","cost":"0.0000","amount":"4.60","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-10 13:44:49","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"47927","date":"2017-09-10 13:45:02","ss_terminal":null,"ss_code":null,"sale_id":"12798","si_item_id":"0","item_id":"271","item_sku":"205","item_name":"Take It Easy","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-10 13:45:02","serial":"admin-1505015850-15050223019744788","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"47928","date":"2017-09-10 13:45:02","ss_terminal":null,"ss_code":null,"sale_id":"12798","si_item_id":"0","item_id":"271","item_sku":"205","item_name":"Take It Easy","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-10 13:45:02","serial":"admin-1505015850-15050223019744788","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-10 14:01:07', NULL, ''),
(1068, 'sanni', '{"void_item":{"id":"47972","date":"2017-09-10 16:17:47","ss_terminal":null,"ss_code":null,"sale_id":"12808","si_item_id":"0","item_id":"49","item_sku":"49","item_name":"Mocha Frappe","item_option":"","category":"Cold Drinks","subcategory":"Frappe","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-10 16:17:47","serial":"admin-1505025773-15050314671029878","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-10 16:34:25', NULL, ''),
(1069, 'sanni', '{"void_item":{"id":"48038","date":"2017-09-11 11:13:47","ss_terminal":null,"ss_code":null,"sale_id":"12818","si_item_id":"0","item_id":"182","item_sku":"117","item_name":"Open Drinks ","item_option":"esp","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"1.00","margin":"1.0000","cost":"0.0000","amount":"1.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-11 11:13:47","serial":"admin-1505099080-15050996273158260","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-11 11:19:26', NULL, ''),
(1070, 'lois', '{"void_item":{"id":"48054","date":"2017-09-11 11:41:33","ss_terminal":null,"ss_code":null,"sale_id":"12824","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"breakfast potato 1 bowl","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-11 11:41:33","serial":"admin-1505099080-15051012934117622","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-11 11:44:23', NULL, ''),
(1071, 'sanni', '{"void_item":{"id":"48015","date":"2017-09-11 10:50:05","ss_terminal":null,"ss_code":null,"sale_id":"12817","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"lois","ordered_time":"2017-09-11 10:50:05","serial":"lois-1505091452-15050982050676338","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-11 11:47:47', NULL, ''),
(1072, 'lois', '{"void_item":{"id":"48089","date":"2017-09-11 12:46:53","ss_terminal":null,"ss_code":null,"sale_id":"12830","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-11 12:46:53","serial":"admin-1505102471-15051052137273324","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-11 13:06:48', NULL, ''),
(1073, 'lois', '{"void_item":{"id":"48123","date":"2017-09-11 13:40:30","ss_terminal":null,"ss_code":null,"sale_id":"12835","si_item_id":"0","item_id":"291","item_sku":"225","item_name":"Smoked Duck Red Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"23.00","margin":"23.0000","cost":"0.0000","amount":"23.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-11 13:40:30","serial":"admin-1505106729-1505108430819232","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-11 13:40:41', NULL, ''),
(1074, 'sanni', '{"void_item":{"id":"48221","date":"2017-09-13 12:32:07","ss_terminal":null,"ss_code":null,"sale_id":"12858","si_item_id":"0","item_id":"38","item_sku":"38","item_name":"Mixed Berries Smoothie","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-13 12:32:07","serial":"admin-1505276547-15052771275559098","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-13 12:42:33', NULL, ''),
(1075, 'sanni', '{"sale":{"id":"12861","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-09-13 14:00:33","payment_status":"Unpaid","cost":null,"subtotal":"10.00","amount":"11.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1505276547","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"48230","date":"2017-09-13 14:00:33","ss_terminal":null,"ss_code":null,"sale_id":"12861","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.00","margin":"0.0000","cost":"0.0000","amount":"1.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-13 14:00:33","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"48231","date":"2017-09-13 14:00:40","ss_terminal":null,"ss_code":null,"sale_id":"12861","si_item_id":null,"item_id":"44","item_sku":"44","item_name":"Tiger ","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-13 14:00:40","serial":"admin-1505276547-1505282440521376","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-13 14:00:57', NULL, ''),
(1076, 'lois', '{"void_item":{"id":"48246","date":"2017-09-13 15:07:46","ss_terminal":null,"ss_code":null,"sale_id":"12865","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"90.72","margin":"0.0000","cost":"0.0000","amount":"90.72","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-13 15:07:46","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-13 15:08:56', NULL, ''),
(1077, 'sanni', '{"void_item":{"id":"48445","date":"2017-09-15 14:18:11","ss_terminal":null,"ss_code":null,"sale_id":"12907","si_item_id":"0","item_id":"294","item_sku":"230","item_name":"Double Fry Salted Pork","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-15 14:18:11","serial":"admin-1505444587-1505456291301141","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-15 14:22:01', NULL, ''),
(1078, 'sanni', '{"sale":{"id":"12925","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-09-16 10:33:29","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1505524105","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"48520","date":"2017-09-16 10:33:29","ss_terminal":null,"ss_code":null,"sale_id":"12925","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-16 10:33:29","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-16 10:33:45', NULL, ''),
(1079, 'lois', '{"void_item":{"id":"48514","date":"2017-09-16 10:29:59","ss_terminal":null,"ss_code":null,"sale_id":"12922","si_item_id":"0","item_id":"270","item_sku":"204","item_name":"Homemade Savoury Pancake","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-16 10:29:59","serial":"admin-1505524105-15055289990178022","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-16 10:43:26', NULL, ''),
(1080, 'lois', '{"void_item":{"id":"48532","date":"2017-09-16 10:46:08","ss_terminal":null,"ss_code":null,"sale_id":"12928","si_item_id":"0","item_id":"244","item_sku":"178","item_name":"Macadamia Scones","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-16 10:46:08","serial":"admin-1505529213-15055299680166838","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-16 10:46:55', NULL, ''),
(1081, 'sanni', '{"void_item":{"id":"48628","date":"2017-09-16 14:33:33","ss_terminal":null,"ss_code":null,"sale_id":"12948","si_item_id":"0","item_id":"220","item_sku":"154","item_name":"Pork Bacon Pesto Pasta","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-16 14:33:33","serial":"admin-1505541957-15055436134194053","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-16 15:01:10', NULL, ''),
(1082, 'lois', '{"sale":{"id":"12950","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-09-16 15:21:16","payment_status":"Unpaid","cost":null,"subtotal":"65.00","amount":"64.35","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":"7.15","adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1505541957","discount_type":"p","discount":"10","payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"48643","date":"2017-09-16 15:21:16","ss_terminal":null,"ss_code":null,"sale_id":"12950","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"6.50","margin":"0.0000","cost":"0.0000","amount":"6.50","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-16 15:21:16","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"48647","date":"2017-09-16 15:25:45","ss_terminal":null,"ss_code":null,"sale_id":"12950","si_item_id":"0","item_id":"295","item_sku":"231","item_name":"Chinese Ginger Garlic Chicken","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-16 15:25:45","serial":"admin-1505546718-15055467449414971","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"48644","date":"2017-09-16 15:25:45","ss_terminal":null,"ss_code":null,"sale_id":"12950","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"French Toast with Fruits","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-16 15:25:45","serial":"admin-1505546718-15055467449414971","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"48646","date":"2017-09-16 15:25:45","ss_terminal":null,"ss_code":null,"sale_id":"12950","si_item_id":"0","item_id":"79","item_sku":"79","item_name":"Summer Salad ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-16 15:25:45","serial":"admin-1505546718-15055467449414971","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"48645","date":"2017-09-16 15:25:45","ss_terminal":null,"ss_code":null,"sale_id":"12950","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-16 15:25:45","serial":"admin-1505546718-15055467449414971","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-16 15:57:16', NULL, ''),
(1083, 'sanni', '{"void_item":{"id":"48737","date":"2017-09-17 10:48:39","ss_terminal":null,"ss_code":null,"sale_id":"12966","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-17 10:48:39","serial":"admin-1505614815-15056165194792252","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-17 11:19:25', NULL, ''),
(1084, 'sanni', '{"void_item":{"id":"48867","date":"2017-09-17 13:43:57","ss_terminal":null,"ss_code":null,"sale_id":"12994","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-17 13:43:57","serial":"admin-1505625561-15056270368494139","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-17 13:44:50', NULL, ''),
(1085, 'lois', '{"void_item":{"id":"48888","date":"2017-09-17 14:04:36","ss_terminal":null,"ss_code":null,"sale_id":"12996","si_item_id":"0","item_id":"211","item_sku":"145","item_name":"Asian Spicy Lemony Chicken","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-17 14:04:36","serial":"admin-1505625561-15056282763722846","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-17 14:05:48', NULL, ''),
(1086, 'lois', '{"sale":{"id":"12997","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-09-17 14:10:21","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1505625561","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2017-09-17 14:12:20', NULL, ''),
(1087, 'lois', '{"void_item":{"id":"49079","date":"2017-09-20 10:17:01","ss_terminal":null,"ss_code":null,"sale_id":"13044","si_item_id":null,"item_id":"8","item_sku":"8","item_name":"Caramel Macchiato ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-20 10:17:01","serial":"admin-1505869259-15058738198557677","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-20 10:17:25', NULL, ''),
(1088, 'sanni', '{"sale":{"id":"13048","txn_no":"112649","table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-09-20 13:02:10","payment_status":"Paid","cost":null,"subtotal":"43.00","amount":"47.30","amount_cash":"47.30","amount_cc":null,"amount_tendered":"100.00","amount_change":"52.70","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1505873825","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"49101","date":"2017-09-20 12:44:07","ss_terminal":null,"ss_code":null,"sale_id":"13048","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"4.30","margin":"0.0000","cost":"0.0000","amount":"4.30","sold":"1","terminal":"27","printed":"1","session":"1505873825","ordered_by":"admin","ordered_time":"2017-09-20 12:44:07","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"49102","date":"2017-09-20 12:44:17","ss_terminal":null,"ss_code":null,"sale_id":"13048","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"BFF","category":"Meals","subcategory":"Perfect Meals","qty":"2","price_per_unit":"8.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1505873825","ordered_by":"admin","ordered_time":"2017-09-20 12:44:17","serial":"admin-1505873825-15058826574696550","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"49103","date":"2017-09-20 12:52:07","ss_terminal":null,"ss_code":null,"sale_id":"13048","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"bacon change sausage","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1505873825","ordered_by":"admin","ordered_time":"2017-09-20 12:52:07","serial":"admin-1505873825-15058831270866981","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"49104","date":"2017-09-20 12:52:13","ss_terminal":null,"ss_code":null,"sale_id":"13048","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1505873825","ordered_by":"admin","ordered_time":"2017-09-20 12:52:13","serial":"admin-1505873825-1505883132983813","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-20 13:03:45', 1, ''),
(1089, 'lois', '{"void_item":{"id":"49220","date":"2017-09-21 15:11:01","ss_terminal":null,"ss_code":null,"sale_id":"13078","si_item_id":"0","item_id":"215","item_sku":"149","item_name":"Thai Fish Sauce Garlic Pork","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-21 15:11:01","serial":"admin-1505975619-15059778610504662","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-21 15:12:33', NULL, ''),
(1090, 'lois', '{"void_item":{"id":"49228","date":"2017-09-21 15:32:39","ss_terminal":null,"ss_code":null,"sale_id":"13078","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"Kitchen closed","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-21 15:32:39","serial":"admin-1505975619-15059791594558431","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-21 15:33:08', NULL, ''),
(1091, 'sanni', '{"void_item":{"id":"49253","date":"2017-09-22 10:06:34","ss_terminal":null,"ss_code":null,"sale_id":"13081","si_item_id":"0","item_id":"184","item_sku":"119","item_name":"Flat White","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-22 10:06:34","serial":"admin-1506042971-15060459945611554","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-22 10:13:13', NULL, ''),
(1092, 'lois', '{"sale":{"id":"13086","txn_no":null,"table_no":"T10","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-09-22 10:40:17","payment_status":"Unpaid","cost":null,"subtotal":"22.00","amount":"24.20","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1506042971","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"49270","date":"2017-09-22 10:40:17","ss_terminal":null,"ss_code":null,"sale_id":"13086","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.20","margin":"0.0000","cost":"0.0000","amount":"2.20","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-22 10:40:17","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"49271","date":"2017-09-22 10:40:23","ss_terminal":null,"ss_code":null,"sale_id":"13086","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-22 10:40:23","serial":"admin-1506042971-15060480229505010","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"49272","date":"2017-09-22 10:40:23","ss_terminal":null,"ss_code":null,"sale_id":"13086","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-22 10:40:23","serial":"admin-1506042971-15060480229505010","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-22 10:48:12', NULL, ''),
(1093, 'sanni', '{"sale":{"id":"13109","txn_no":null,"table_no":"T1","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-09-22 13:43:15","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1506055637","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"49387","date":"2017-09-22 13:43:15","ss_terminal":null,"ss_code":null,"sale_id":"13109","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-22 13:43:15","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-22 13:59:03', NULL, ''),
(1094, 'sanni', '{"void_item":{"id":"49401","date":"2017-09-22 14:11:26","ss_terminal":null,"ss_code":null,"sale_id":"13112","si_item_id":"0","item_id":"176","item_sku":"111","item_name":"Scones ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-22 14:11:26","serial":"admin-1506055637-15060606864641232","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-22 14:24:34', NULL, ''),
(1095, 'sanni ', '{"void_item":{"id":"49403","date":"2017-09-22 14:22:03","ss_terminal":null,"ss_code":null,"sale_id":"13113","si_item_id":"0","item_id":"70","item_sku":"70","item_name":"Borneo Pepper Pork","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-22 14:22:03","serial":"admin-1506055637-1506061323311531","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-22 14:25:13', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(1096, 'lois', '{"void_item":{"id":"49472","date":"2017-09-23 10:42:02","ss_terminal":null,"ss_code":null,"sale_id":"13130","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-23 10:42:02","serial":"admin-1506129025-15061345222448723","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-23 10:42:30', NULL, ''),
(1097, 'sanni', '{"void_item":{"id":"49546","date":"2017-09-23 12:41:59","ss_terminal":null,"ss_code":null,"sale_id":"13144","si_item_id":"0","item_id":"272","item_sku":"206","item_name":"Genius in The Bowl","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-23 12:41:59","serial":"admin-1506141352-15061417196984992","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-23 12:49:41', NULL, ''),
(1098, 'lois', '{"void_item":{"id":"49560","date":"2017-09-23 13:12:10","ss_terminal":null,"ss_code":null,"sale_id":"13146","si_item_id":"0","item_id":"272","item_sku":"206","item_name":"Genius in The Bowl","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-23 13:12:10","serial":"admin-1506141352-15061435302868963","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-23 13:15:12', NULL, ''),
(1099, 'lois', '{"void_item":{"id":"49561","date":"2017-09-23 13:12:16","ss_terminal":null,"ss_code":null,"sale_id":"13146","si_item_id":"0","item_id":"34","item_sku":"34","item_name":"Ginger Lemongrass Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-23 13:12:16","serial":"admin-1506141352-1506143536441469","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-23 13:15:28', NULL, ''),
(1100, 'sanni', '{"sale":{"id":"13166","txn_no":null,"table_no":"T10","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-09-24 09:41:04","payment_status":"Unpaid","cost":null,"subtotal":"10.00","amount":"11.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1506214529","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"49648","date":"2017-09-24 09:41:19","ss_terminal":null,"ss_code":null,"sale_id":"13166","si_item_id":null,"item_id":"45","item_sku":"45","item_name":"Soda","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-24 09:41:19","serial":"admin-1506214529-15062172795127450","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"49647","date":"2017-09-24 09:41:19","ss_terminal":null,"ss_code":null,"sale_id":"13166","si_item_id":null,"item_id":"45","item_sku":"45","item_name":"Soda","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-24 09:41:19","serial":"admin-1506214529-15062172795127450","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"49646","date":"2017-09-24 09:41:04","ss_terminal":null,"ss_code":null,"sale_id":"13166","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.00","margin":"0.0000","cost":"0.0000","amount":"1.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-24 09:41:04","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-24 09:44:04', NULL, ''),
(1101, 'sanni', '{"void_item":{"id":"49626","date":"2017-09-24 09:28:42","ss_terminal":null,"ss_code":null,"sale_id":"13162","si_item_id":"0","item_id":"267","item_sku":"201","item_name":"Cocoa Cappucino","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-24 09:28:42","serial":"admin-1506214529-15062165220767786","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-24 10:11:12', NULL, ''),
(1102, 'sanni', '{"void_item":{"id":"49766","date":"2017-09-24 11:07:00","ss_terminal":null,"ss_code":null,"sale_id":"13174","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-24 11:07:00","serial":"admin-1506220539-15062224206281490","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-24 11:30:08', NULL, ''),
(1103, 'sanni', '{"void_item":{"id":"49890","date":"2017-09-24 14:13:53","ss_terminal":null,"ss_code":null,"sale_id":"13204","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-24 14:13:53","serial":"admin-1506229681-15062336332783552","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-24 15:17:18', NULL, ''),
(1104, 'sanni', '{"sale":{"id":"13238","txn_no":"112831","table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-09-25 14:39:19","payment_status":"Paid","cost":null,"subtotal":"86.00","amount":"94.60","amount_cash":"94.60","amount_cc":null,"amount_tendered":"100.00","amount_change":"5.40","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1506314121","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"49998","date":"2017-09-25 14:25:46","ss_terminal":null,"ss_code":null,"sale_id":"13238","si_item_id":"0","item_id":"170","item_sku":"104","item_name":"Daily Cheese ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1506314121","ordered_by":"admin","ordered_time":"2017-09-25 14:25:46","serial":"admin-1506314121-15063207459712662","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"49984","date":"2017-09-25 13:46:16","ss_terminal":null,"ss_code":null,"sale_id":"13238","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1506314121","ordered_by":"admin","ordered_time":"2017-09-25 13:46:16","serial":"admin-1506314121-1506318376234164","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"49981","date":"2017-09-25 13:46:04","ss_terminal":null,"ss_code":null,"sale_id":"13238","si_item_id":"0","item_id":"229","item_sku":"163","item_name":"Mummy''s Pasta","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1506314121","ordered_by":"admin","ordered_time":"2017-09-25 13:46:04","serial":"admin-1506314121-15063183646428971","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"49982","date":"2017-09-25 13:46:04","ss_terminal":null,"ss_code":null,"sale_id":"13238","si_item_id":"0","item_id":"225","item_sku":"159","item_name":"Smoked Duck Salad","item_option":"","category":"Meals","subcategory":"Salad","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":"1","terminal":"27","printed":"1","session":"1506314121","ordered_by":"admin","ordered_time":"2017-09-25 13:46:04","serial":"admin-1506314121-15063183646428971","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"49983","date":"2017-09-25 13:46:16","ss_terminal":null,"ss_code":null,"sale_id":"13238","si_item_id":"0","item_id":"210","item_sku":"144","item_name":"Red Riding Hood","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1506314121","ordered_by":"admin","ordered_time":"2017-09-25 13:46:16","serial":"admin-1506314121-1506318376234164","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"49980","date":"2017-09-25 13:46:04","ss_terminal":null,"ss_code":null,"sale_id":"13238","si_item_id":"0","item_id":"192","item_sku":"127","item_name":"Flaming Hot & Spicy Pork","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1506314121","ordered_by":"admin","ordered_time":"2017-09-25 13:46:04","serial":"admin-1506314121-15063183646428971","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"49979","date":"2017-09-25 13:42:50","ss_terminal":null,"ss_code":null,"sale_id":"13238","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"8.60","margin":"0.0000","cost":"0.0000","amount":"8.60","sold":"1","terminal":"27","printed":"1","session":"1506314121","ordered_by":"admin","ordered_time":"2017-09-25 13:42:50","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-25 14:40:53', 1, ''),
(1105, 'sanni', '{"void_item":{"id":"50027","date":"2017-09-27 10:07:39","ss_terminal":null,"ss_code":null,"sale_id":"13247","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-27 10:07:39","serial":"admin-1506475268-15064780590854784","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-27 10:07:48', NULL, ''),
(1106, 'lois', '{"sale":{"id":"13256","txn_no":null,"table_no":"T5","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-09-27 13:25:09","payment_status":"Unpaid","cost":null,"subtotal":"8.00","amount":"8.80","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1506475268","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"50059","date":"2017-09-27 13:38:24","ss_terminal":null,"ss_code":null,"sale_id":"13256","si_item_id":"0","item_id":"272","item_sku":"206","item_name":"Genius in The Bowl","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-27 13:38:24","serial":"admin-1506489928-15064907047328416","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"50056","date":"2017-09-27 13:25:09","ss_terminal":null,"ss_code":null,"sale_id":"13256","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.80","margin":"0.0000","cost":"0.0000","amount":"0.80","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-27 13:25:09","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-27 14:31:38', NULL, ''),
(1107, 'lois', '{"sale":{"id":"13297","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-09-29 12:11:36","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1506647044","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"50207","date":"2017-09-29 12:11:36","ss_terminal":null,"ss_code":null,"sale_id":"13297","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-29 12:11:36","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-29 12:12:27', NULL, ''),
(1108, 'lois', '{"sale":{"id":"13296","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-09-29 12:11:36","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1506647044","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"50206","date":"2017-09-29 12:11:36","ss_terminal":null,"ss_code":null,"sale_id":"13296","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-29 12:11:36","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-29 12:12:37', NULL, ''),
(1109, 'sanni', '{"void_item":{"id":"50214","date":"2017-09-29 12:15:30","ss_terminal":null,"ss_code":null,"sale_id":"13299","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-29 12:15:30","serial":"admin-1506658325-15066585298273537","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-29 13:15:08', NULL, ''),
(1110, 'lois', '{"void_item":{"id":"50243","date":"2017-09-29 13:54:52","ss_terminal":null,"ss_code":null,"sale_id":"13304","si_item_id":"0","item_id":"267","item_sku":"201","item_name":"Cocoa Cappucino","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-29 13:54:52","serial":"admin-1506658325-15066644921465330","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-29 15:07:56', NULL, ''),
(1111, 'lois', '{"void_item":{"id":"50329","date":"2017-09-30 11:01:21","ss_terminal":null,"ss_code":null,"sale_id":"13321","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"sunny side up","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-30 11:01:21","serial":"admin-1506739636-15067404810292177","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-30 11:04:17', NULL, ''),
(1112, 'sanni', '{"sale":{"id":"13320","txn_no":"112907","table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-09-30 11:00:49","payment_status":"Paid","cost":null,"subtotal":"67.00","amount":"73.70","amount_cash":"73.70","amount_cc":null,"amount_tendered":"100.00","amount_change":"26.30","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1506739636","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"50303","date":"2017-09-30 10:30:58","ss_terminal":null,"ss_code":null,"sale_id":"13320","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"6.70","margin":"0.0000","cost":"0.0000","amount":"6.70","sold":"1","terminal":"27","printed":"1","session":"1506739636","ordered_by":"admin","ordered_time":"2017-09-30 10:30:58","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"50304","date":"2017-09-30 10:31:14","ss_terminal":null,"ss_code":null,"sale_id":"13320","si_item_id":"0","item_id":"156","item_sku":"90","item_name":"House Cheddar Omelet","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1506739636","ordered_by":"admin","ordered_time":"2017-09-30 10:31:14","serial":"admin-1506732936-15067386740398143","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"50305","date":"2017-09-30 10:31:14","ss_terminal":null,"ss_code":null,"sale_id":"13320","si_item_id":"0","item_id":"156","item_sku":"90","item_name":"House Cheddar Omelet","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1506739636","ordered_by":"admin","ordered_time":"2017-09-30 10:31:14","serial":"admin-1506732936-15067386740398143","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"50306","date":"2017-09-30 10:31:14","ss_terminal":null,"ss_code":null,"sale_id":"13320","si_item_id":"0","item_id":"80","item_sku":"80","item_name":"Oriental Chicken Salad","item_option":"","category":"Meals","subcategory":"Salad","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":"1","terminal":"27","printed":"1","session":"1506739636","ordered_by":"admin","ordered_time":"2017-09-30 10:31:14","serial":"admin-1506732936-15067386740398143","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"50308","date":"2017-09-30 10:31:22","ss_terminal":null,"ss_code":null,"sale_id":"13320","si_item_id":"0","item_id":"61","item_sku":"61","item_name":"Slim Fit","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1506739636","ordered_by":"admin","ordered_time":"2017-09-30 10:31:22","serial":"admin-1506732936-15067386822705126","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"50307","date":"2017-09-30 10:31:22","ss_terminal":null,"ss_code":null,"sale_id":"13320","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1506739636","ordered_by":"admin","ordered_time":"2017-09-30 10:31:22","serial":"admin-1506732936-15067386822705126","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-30 11:31:02', 1, ''),
(1113, 'lois', '{"sale":{"id":"13318","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-09-30 10:17:40","payment_status":"Unpaid","cost":null,"subtotal":"54.00","amount":"59.40","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1506732936","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"50298","date":"2017-09-30 10:18:02","ss_terminal":null,"ss_code":null,"sale_id":"13318","si_item_id":null,"item_id":"4","item_sku":"4","item_name":"Piccolo","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-30 10:18:02","serial":"admin-1506732936-15067378821729728","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"50294","date":"2017-09-30 10:17:40","ss_terminal":null,"ss_code":null,"sale_id":"13318","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"5.40","margin":"0.0000","cost":"0.0000","amount":"5.40","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-30 10:17:40","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"50297","date":"2017-09-30 10:18:02","ss_terminal":null,"ss_code":null,"sale_id":"13318","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-30 10:18:02","serial":"admin-1506732936-15067378821729728","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"50296","date":"2017-09-30 10:18:02","ss_terminal":null,"ss_code":null,"sale_id":"13318","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-30 10:18:02","serial":"admin-1506732936-15067378821729728","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"50295","date":"2017-09-30 10:18:02","ss_terminal":null,"ss_code":null,"sale_id":"13318","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-30 10:18:02","serial":"admin-1506732936-15067378821729728","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-09-30 12:16:54', NULL, ''),
(1114, 'lois', '{"void_item":{"id":"50409","date":"2017-09-30 13:55:58","ss_terminal":null,"ss_code":null,"sale_id":"13336","si_item_id":"0","item_id":"179","item_sku":"114","item_name":"Creme Brulee ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-09-30 13:55:58","serial":"admin-1506750592-15067509581587996","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-09-30 14:10:39', NULL, ''),
(1115, 'lois', '{"void_item":{"id":"50464","date":"2017-10-01 09:55:04","ss_terminal":null,"ss_code":null,"sale_id":"13353","si_item_id":"0","item_id":"182","item_sku":"117","item_name":"Open Drinks ","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-01 09:55:04","serial":"admin-1506818470-15068229039349162","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-01 09:55:13', NULL, ''),
(1116, 'sanni', '{"sale":{"id":"13354","txn_no":null,"table_no":"T1","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-01 09:58:39","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1506818470","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"50466","date":"2017-10-01 09:58:39","ss_terminal":null,"ss_code":null,"sale_id":"13354","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-01 09:58:39","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-10-01 10:31:13', NULL, ''),
(1117, 'sanni', '{"void_item":{"id":"50539","date":"2017-10-01 12:06:55","ss_terminal":null,"ss_code":null,"sale_id":"13372","si_item_id":"0","item_id":"209","item_sku":"143","item_name":"Honey Lemon","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-01 12:06:55","serial":"admin-1506828994-15068308152288452","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-01 12:16:49', NULL, ''),
(1118, 'lois', '{"sale":{"id":"13361","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-01 10:48:19","payment_status":"Unpaid","cost":null,"subtotal":"65.00","amount":"71.50","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1506825944","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"50488","date":"2017-10-01 10:48:26","ss_terminal":null,"ss_code":null,"sale_id":"13361","si_item_id":"0","item_id":"225","item_sku":"159","item_name":"Smoked Duck Salad","item_option":"","category":"Meals","subcategory":"Salad","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-01 10:48:26","serial":"admin-1506825944-1506826106381447","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"50489","date":"2017-10-01 10:48:35","ss_terminal":null,"ss_code":null,"sale_id":"13361","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-01 10:48:35","serial":"admin-1506825944-15068261149358113","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"50490","date":"2017-10-01 10:48:35","ss_terminal":null,"ss_code":null,"sale_id":"13361","si_item_id":null,"item_id":"25","item_sku":"25","item_name":"Matcha Latte","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-01 10:48:35","serial":"admin-1506825944-15068261149358113","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"50487","date":"2017-10-01 10:48:26","ss_terminal":null,"ss_code":null,"sale_id":"13361","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-01 10:48:26","serial":"admin-1506825944-1506826106381447","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"50486","date":"2017-10-01 10:48:19","ss_terminal":null,"ss_code":null,"sale_id":"13361","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"6.50","margin":"0.0000","cost":"0.0000","amount":"6.50","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-01 10:48:19","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-10-01 14:45:27', NULL, ''),
(1119, 'lois', '{"sale":{"id":"13433","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-04 12:33:40","payment_status":"Unpaid","cost":null,"subtotal":"23.00","amount":"23.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1507079160","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"50885","date":"2017-10-04 12:33:49","ss_terminal":null,"ss_code":null,"sale_id":"13433","si_item_id":"0","item_id":"34","item_sku":"34","item_name":"Ginger Lemongrass Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-04 12:33:49","serial":"admin-1507079160-15070916296709625","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null},{"id":"50884","date":"2017-10-04 12:33:49","ss_terminal":null,"ss_code":null,"sale_id":"13433","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-04 12:33:49","serial":"admin-1507079160-15070916296709625","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-10-05 09:16:53', NULL, ''),
(1120, 'lois', '{"void_item":{"id":"51005","date":"2017-10-05 10:00:05","ss_terminal":null,"ss_code":null,"sale_id":"13455","si_item_id":"0","item_id":"270","item_sku":"204","item_name":"Homemade Savoury Pancake","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-05 10:00:05","serial":"admin-1507167722-15071688050275426","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-05 10:03:28', NULL, ''),
(1121, 'sanni', '{"void_item":{"id":"51049","date":"2017-10-05 11:51:00","ss_terminal":null,"ss_code":null,"sale_id":"13464","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"French Toast with Fruits","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-05 11:51:00","serial":"admin-1507167722-1507175460079411","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-05 11:51:58', NULL, ''),
(1122, 'lois', '{"sale":{"id":"13461","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-05 10:57:58","payment_status":"Unpaid","cost":null,"subtotal":"3.00","amount":"3.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1507167722","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"51039","date":"2017-10-05 10:58:10","ss_terminal":null,"ss_code":null,"sale_id":"13461","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"scones promo","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-05 10:58:10","serial":"admin-1507167722-15071722901298345","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-10-05 13:03:51', NULL, ''),
(1123, 'lois', '{"void_item":{"id":"51108","date":"2017-10-06 09:18:53","ss_terminal":null,"ss_code":null,"sale_id":"13479","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.30","margin":"0.0000","cost":"0.0000","amount":"2.30","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-06 09:18:53","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-06 09:19:13', NULL, ''),
(1124, 'lois', '{"void_item":{"id":"51141","date":"2017-10-06 10:40:59","ss_terminal":null,"ss_code":null,"sale_id":"13486","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-06 10:40:59","serial":"admin-1507197410-15072576588804316","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-06 10:43:16', NULL, ''),
(1125, 'lois', '{"void_item":{"id":"51148","date":"2017-10-06 10:44:26","ss_terminal":null,"ss_code":null,"sale_id":"13486","si_item_id":"0","item_id":"14","item_sku":"14","item_name":"Iced Cappucino ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-06 10:44:26","serial":"admin-1507257843-15072578663022837","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-06 10:45:01', NULL, ''),
(1126, 'sanni', '{"void_item":{"id":"51156","date":"2017-10-06 11:47:59","ss_terminal":null,"ss_code":null,"sale_id":"13487","si_item_id":null,"item_id":"62","item_sku":"62","item_name":"Orange","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-06 11:47:59","serial":"admin-1507257843-1507261678943174","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-06 11:49:43', NULL, ''),
(1127, 'lois', '{"void_item":{"id":"51231","date":"2017-10-06 16:08:29","ss_terminal":null,"ss_code":null,"sale_id":"13502","si_item_id":null,"item_id":"1","item_sku":"1","item_name":"Espresso","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-06 16:08:29","serial":"admin-1507269351-15072773095356785","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-06 16:38:13', NULL, ''),
(1128, 'sanni', '{"sale":{"id":"13551","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-08 09:59:37","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1507424713","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2017-10-08 10:34:23', NULL, ''),
(1129, 'lois', '{"sale":{"id":"13565","txn_no":null,"table_no":"T15","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-08 11:11:08","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1507424713","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"51506","date":"2017-10-08 11:11:08","ss_terminal":null,"ss_code":null,"sale_id":"13565","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-08 11:11:08","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-10-08 11:11:49', NULL, ''),
(1130, 'lois', '{"void_item":{"id":"51561","date":"2017-10-08 12:20:37","ss_terminal":null,"ss_code":null,"sale_id":"13573","si_item_id":"0","item_id":"176","item_sku":"111","item_name":"Scones ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-08 12:20:37","serial":"admin-1507432281-15074364368707824","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-08 12:24:47', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(1131, 'lois', '{"sale":{"id":"13579","txn_no":"113152","table_no":"T1","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-10-08 13:14:00","payment_status":"Paid","cost":null,"subtotal":"17.00","amount":"18.70","amount_cash":"18.70","amount_cc":null,"amount_tendered":"20.00","amount_change":"1.30","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1507438407","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"51585","date":"2017-10-08 13:00:25","ss_terminal":null,"ss_code":null,"sale_id":"13579","si_item_id":"0","item_id":"262","item_sku":"196","item_name":"Cheesy Sticks","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":"1","terminal":"27","printed":"1","session":"1507438407","ordered_by":"admin","ordered_time":"2017-10-08 13:00:25","serial":"admin-1507438407-15074388248756494","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"51583","date":"2017-10-08 12:59:56","ss_terminal":null,"ss_code":null,"sale_id":"13579","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.70","margin":"0.0000","cost":"0.0000","amount":"1.70","sold":"1","terminal":"27","printed":"1","session":"1507438407","ordered_by":"admin","ordered_time":"2017-10-08 12:59:56","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"51584","date":"2017-10-08 13:00:25","ss_terminal":null,"ss_code":null,"sale_id":"13579","si_item_id":null,"item_id":"8","item_sku":"8","item_name":"Caramel Macchiato ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1507438407","ordered_by":"admin","ordered_time":"2017-10-08 13:00:25","serial":"admin-1507438407-15074388248756494","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-10-08 13:14:10', 1, ''),
(1132, 'sanni', '{"void_item":{"id":"51670","date":"2017-10-08 16:40:28","ss_terminal":null,"ss_code":null,"sale_id":"13595","si_item_id":"0","item_id":"34","item_sku":"34","item_name":"Ginger Lemongrass Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-08 16:40:28","serial":"admin-1507442048-1507452027968325","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-08 16:48:07', NULL, ''),
(1133, 'sanni', '{"sale":{"id":"13607","txn_no":"113193","table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-10-09 13:49:13","payment_status":"Paid","cost":null,"subtotal":"58.00","amount":"63.80","amount_cash":"63.80","amount_cc":null,"amount_tendered":"63.80","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1507522881","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"51716","date":"2017-10-09 12:08:21","ss_terminal":null,"ss_code":null,"sale_id":"13607","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1507522881","ordered_by":"admin","ordered_time":"2017-10-09 12:08:21","serial":"admin-1507511191-1507522101446145","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"51717","date":"2017-10-09 12:08:21","ss_terminal":null,"ss_code":null,"sale_id":"13607","si_item_id":null,"item_id":"62","item_sku":"62","item_name":"Orange","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1507522881","ordered_by":"admin","ordered_time":"2017-10-09 12:08:21","serial":"admin-1507511191-1507522101446145","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"51714","date":"2017-10-09 12:04:34","ss_terminal":null,"ss_code":null,"sale_id":"13607","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"5.80","margin":"0.0000","cost":"0.0000","amount":"5.80","sold":"1","terminal":"27","printed":"1","session":"1507522881","ordered_by":"admin","ordered_time":"2017-10-09 12:04:34","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"51715","date":"2017-10-09 12:08:21","ss_terminal":null,"ss_code":null,"sale_id":"13607","si_item_id":"0","item_id":"221","item_sku":"155","item_name":"Seasoned Chicken Pesto Pasta","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":"1","terminal":"27","printed":"1","session":"1507522881","ordered_by":"admin","ordered_time":"2017-10-09 12:08:21","serial":"admin-1507511191-1507522101446145","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"51718","date":"2017-10-09 12:08:21","ss_terminal":null,"ss_code":null,"sale_id":"13607","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1507522881","ordered_by":"admin","ordered_time":"2017-10-09 12:08:21","serial":"admin-1507511191-1507522101446145","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-10-09 13:49:25', 1, ''),
(1134, 'lois', '{"void_item":{"id":"51773","date":"2017-10-09 14:24:31","ss_terminal":null,"ss_code":null,"sale_id":"13619","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"15.12","margin":"0.0000","cost":"0.0000","amount":"15.12","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-09 14:24:31","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-09 14:24:56', NULL, ''),
(1135, 'sanni', '{"sale":{"id":"13645","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-11 15:26:11","payment_status":"Unpaid","cost":null,"subtotal":"8.00","amount":"8.80","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1507689985","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"51891","date":"2017-10-11 15:26:23","ss_terminal":null,"ss_code":null,"sale_id":"13645","si_item_id":"0","item_id":"263","item_sku":"197","item_name":"Postcard With Postage","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"4.00","margin":"4.0000","cost":"0.0000","amount":"4.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-11 15:26:23","serial":"admin-1507689985-15077067835386663","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"51890","date":"2017-10-11 15:26:23","ss_terminal":null,"ss_code":null,"sale_id":"13645","si_item_id":"0","item_id":"263","item_sku":"197","item_name":"Postcard With Postage","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"4.00","margin":"4.0000","cost":"0.0000","amount":"4.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-11 15:26:23","serial":"admin-1507689985-15077067835386663","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"51889","date":"2017-10-11 15:26:11","ss_terminal":null,"ss_code":null,"sale_id":"13645","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.80","margin":"0.0000","cost":"0.0000","amount":"0.80","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-11 15:26:11","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-10-11 15:31:16', NULL, ''),
(1136, 'sanni', '{"sale":{"id":"13660","txn_no":null,"table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-12 11:19:26","payment_status":"Unpaid","cost":null,"subtotal":"11.00","amount":"12.10","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1507769350","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"51948","date":"2017-10-12 11:19:34","ss_terminal":null,"ss_code":null,"sale_id":"13660","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-12 11:19:34","serial":"admin-1507769350-15077783739095491","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"51947","date":"2017-10-12 11:19:26","ss_terminal":null,"ss_code":null,"sale_id":"13660","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.10","margin":"0.0000","cost":"0.0000","amount":"1.10","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-12 11:19:26","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-10-12 11:22:29', NULL, ''),
(1137, 'lois', '{"sale":{"id":"13666","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-12 12:21:48","payment_status":"Unpaid","cost":null,"subtotal":"8.00","amount":"8.80","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1507781947","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"51971","date":"2017-10-12 12:21:48","ss_terminal":null,"ss_code":null,"sale_id":"13666","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.80","margin":"0.0000","cost":"0.0000","amount":"0.80","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-12 12:21:48","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"51972","date":"2017-10-12 12:21:56","ss_terminal":null,"ss_code":null,"sale_id":"13666","si_item_id":"0","item_id":"272","item_sku":"206","item_name":"Genius in The Bowl","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-12 12:21:56","serial":"admin-1507781947-15077821165226293","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-10-12 12:22:08', NULL, ''),
(1138, 'sanni', '{"sale":{"id":"13721","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-14 12:23:25","payment_status":"Unpaid","cost":null,"subtotal":"53.00","amount":"58.30","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1507948472","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"52186","date":"2017-10-14 12:23:25","ss_terminal":null,"ss_code":null,"sale_id":"13721","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"5.30","margin":"0.0000","cost":"0.0000","amount":"5.30","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-14 12:23:25","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"52187","date":"2017-10-14 12:23:56","ss_terminal":null,"ss_code":null,"sale_id":"13721","si_item_id":"0","item_id":"286","item_sku":"220","item_name":"Joyous Sunny","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-14 12:23:56","serial":"admin-1507948472-15079550367428338","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"52188","date":"2017-10-14 12:23:56","ss_terminal":null,"ss_code":null,"sale_id":"13721","si_item_id":"0","item_id":"286","item_sku":"220","item_name":"Joyous Sunny","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-14 12:23:56","serial":"admin-1507948472-15079550367428338","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":"0.0","global_discount":null},{"id":"52194","date":"2017-10-14 12:30:57","ss_terminal":null,"ss_code":null,"sale_id":"13721","si_item_id":"0","item_id":"156","item_sku":"90","item_name":"House Cheddar Omelet","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-14 12:30:57","serial":"admin-1507948472-15079554570764263","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-10-14 12:38:38', NULL, ''),
(1139, 'sanni', '{"sale":{"id":"13727","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-14 12:47:57","payment_status":"Unpaid","cost":null,"subtotal":"9.00","amount":"9.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1507955619","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"52203","date":"2017-10-14 12:48:30","ss_terminal":null,"ss_code":null,"sale_id":"13727","si_item_id":"0","item_id":"277","item_sku":"211","item_name":"Iced Ginger Lemongrass","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-14 12:48:30","serial":"admin-1507955619-150795651068582","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-10-14 12:52:37', NULL, ''),
(1140, 'sanni', '{"sale":{"id":"13731","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-14 13:23:27","payment_status":"Unpaid","cost":null,"subtotal":"38.00","amount":"41.80","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1507955619","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"52227","date":"2017-10-14 13:23:27","ss_terminal":null,"ss_code":null,"sale_id":"13731","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"3.80","margin":"0.0000","cost":"0.0000","amount":"3.80","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-14 13:23:27","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"52228","date":"2017-10-14 13:23:49","ss_terminal":null,"ss_code":null,"sale_id":"13731","si_item_id":null,"item_id":"62","item_sku":"62","item_name":"Orange","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-14 13:23:49","serial":"admin-1507955619-15079586294365961","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"52231","date":"2017-10-14 13:23:49","ss_terminal":null,"ss_code":null,"sale_id":"13731","si_item_id":null,"item_id":"36","item_sku":"36","item_name":"Lemon Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-14 13:23:49","serial":"admin-1507955619-15079586294365961","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"52229","date":"2017-10-14 13:23:49","ss_terminal":null,"ss_code":null,"sale_id":"13731","si_item_id":null,"item_id":"62","item_sku":"62","item_name":"Orange","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-14 13:23:49","serial":"admin-1507955619-15079586294365961","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"52230","date":"2017-10-14 13:23:49","ss_terminal":null,"ss_code":null,"sale_id":"13731","si_item_id":null,"item_id":"36","item_sku":"36","item_name":"Lemon Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-14 13:23:49","serial":"admin-1507955619-15079586294365961","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-10-14 14:58:28', NULL, ''),
(1141, 'sanni', '{"sale":{"id":"13741","txn_no":null,"table_no":"T10","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-14 15:08:52","payment_status":"Unpaid","cost":null,"subtotal":"7.00","amount":"7.70","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1507955619","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"52267","date":"2017-10-14 15:09:00","ss_terminal":null,"ss_code":null,"sale_id":"13741","si_item_id":"0","item_id":"274","item_sku":"208","item_name":"2 pcs Cookies","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-14 15:09:00","serial":"admin-1507955619-15079649404523489","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"52266","date":"2017-10-14 15:08:52","ss_terminal":null,"ss_code":null,"sale_id":"13741","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.70","margin":"0.0000","cost":"0.0000","amount":"0.70","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-14 15:08:52","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-10-14 15:09:45', NULL, ''),
(1142, 'sanni', '{"sale":{"id":"13744","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-14 15:28:15","payment_status":"Unpaid","cost":null,"subtotal":"7.00","amount":"7.70","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1507955619","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"52269","date":"2017-10-14 15:28:15","ss_terminal":null,"ss_code":null,"sale_id":"13744","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.70","margin":"0.0000","cost":"0.0000","amount":"0.70","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-14 15:28:15","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"52270","date":"2017-10-14 15:28:19","ss_terminal":null,"ss_code":null,"sale_id":"13744","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-14 15:28:19","serial":"admin-1507955619-1507966099558646","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-10-14 15:30:08', NULL, ''),
(1143, 'sanni', '{"void_item":{"id":"52302","date":"2017-10-15 09:24:12","ss_terminal":null,"ss_code":null,"sale_id":"13751","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-15 09:24:12","serial":"admin-1508028344-15080306525194492","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-15 09:36:13', NULL, ''),
(1144, 'sanni', '{"void_item":{"id":"52377","date":"2017-10-15 10:31:41","ss_terminal":null,"ss_code":null,"sale_id":"13755","si_item_id":null,"item_id":"12","item_sku":"12","item_name":"DD Special","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-15 10:31:41","serial":"admin-1508033215-15080347010698275","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-15 10:34:58', NULL, ''),
(1145, 'sanni', '{"void_item":{"id":"52376","date":"2017-10-15 10:31:41","ss_terminal":null,"ss_code":null,"sale_id":"13755","si_item_id":"0","item_id":"299","item_sku":"235","item_name":"Iced Salted Caramel Machiato","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-15 10:31:41","serial":"admin-1508033215-15080347010698275","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-15 10:35:05', NULL, ''),
(1146, 'sanni', '{"void_item":{"id":"52375","date":"2017-10-15 10:31:41","ss_terminal":null,"ss_code":null,"sale_id":"13755","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-15 10:31:41","serial":"admin-1508033215-15080347010698275","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-15 10:35:18', NULL, ''),
(1147, 'sanni', '{"void_item":{"id":"52374","date":"2017-10-15 10:31:41","ss_terminal":null,"ss_code":null,"sale_id":"13755","si_item_id":"0","item_id":"293","item_sku":"229","item_name":"Classic Yogurt Bowl","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-15 10:31:41","serial":"admin-1508033215-15080347010698275","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-15 10:35:30', NULL, ''),
(1148, 'sanni', '{"sale":{"id":"13767","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-15 10:39:33","payment_status":"Unpaid","cost":null,"subtotal":"0.00","amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1508034832","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"52388","date":"2017-10-15 10:40:11","ss_terminal":null,"ss_code":null,"sale_id":"13767","si_item_id":"0","item_id":"182","item_sku":"117","item_name":"Open Drinks ","item_option":"americano","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-15 10:40:11","serial":"admin-1508034832-1508035211162941","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-10-15 10:44:55', NULL, ''),
(1149, 'sanni', '{"void_item":{"id":"52412","date":"2017-10-15 11:07:08","ss_terminal":null,"ss_code":null,"sale_id":"13773","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-15 11:07:08","serial":"admin-1508034832-15080368278319760","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-15 11:27:37', NULL, ''),
(1150, 'sanni', '{"sale":{"id":"13802","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-15 15:06:26","payment_status":"Unpaid","cost":null,"subtotal":"48.00","amount":"52.80","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1508045791","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"52566","date":"2017-10-15 15:07:01","ss_terminal":null,"ss_code":null,"sale_id":"13802","si_item_id":"0","item_id":"272","item_sku":"206","item_name":"Genius in The Bowl","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-15 15:07:01","serial":"admin-1508045791-1508051221702878","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"52567","date":"2017-10-15 15:07:01","ss_terminal":null,"ss_code":null,"sale_id":"13802","si_item_id":"0","item_id":"272","item_sku":"206","item_name":"Genius in The Bowl","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-15 15:07:01","serial":"admin-1508045791-1508051221702878","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"52568","date":"2017-10-15 15:07:01","ss_terminal":null,"ss_code":null,"sale_id":"13802","si_item_id":"0","item_id":"272","item_sku":"206","item_name":"Genius in The Bowl","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-15 15:07:01","serial":"admin-1508045791-1508051221702878","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"52570","date":"2017-10-15 15:07:01","ss_terminal":null,"ss_code":null,"sale_id":"13802","si_item_id":"0","item_id":"272","item_sku":"206","item_name":"Genius in The Bowl","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-15 15:07:01","serial":"admin-1508045791-1508051221702878","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"52571","date":"2017-10-15 15:08:38","ss_terminal":null,"ss_code":null,"sale_id":"13802","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"additional 3 fried egg","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-15 15:08:38","serial":"admin-1508045791-1508051318025919","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"52569","date":"2017-10-15 15:07:01","ss_terminal":null,"ss_code":null,"sale_id":"13802","si_item_id":"0","item_id":"272","item_sku":"206","item_name":"Genius in The Bowl","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-15 15:07:01","serial":"admin-1508045791-1508051221702878","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"52565","date":"2017-10-15 15:07:01","ss_terminal":null,"ss_code":null,"sale_id":"13802","si_item_id":"0","item_id":"272","item_sku":"206","item_name":"Genius in The Bowl","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-15 15:07:01","serial":"admin-1508045791-1508051221702878","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"52564","date":"2017-10-15 15:06:26","ss_terminal":null,"ss_code":null,"sale_id":"13802","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"4.80","margin":"0.0000","cost":"0.0000","amount":"4.80","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-15 15:06:26","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-10-15 15:11:40', NULL, ''),
(1151, 'lois', '{"void_item":{"id":"52586","date":"2017-10-15 16:03:43","ss_terminal":null,"ss_code":null,"sale_id":"13807","si_item_id":"0","item_id":"272","item_sku":"206","item_name":"Genius in The Bowl","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-15 16:03:43","serial":"admin-1508052010-15080546235135199","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}}', '2017-10-15 16:04:37', NULL, ''),
(1152, 'lois', '{"void_item":{"id":"52585","date":"2017-10-15 15:58:19","ss_terminal":null,"ss_code":null,"sale_id":"13806","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"add egg","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-15 15:58:19","serial":"admin-1508052010-15080542990642868","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-15 16:05:02', NULL, ''),
(1153, 'lois', '{"void_item":{"id":"52583","date":"2017-10-15 15:57:48","ss_terminal":null,"ss_code":null,"sale_id":"13806","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.90","margin":"0.0000","cost":"0.0000","amount":"0.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-15 15:57:48","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-15 16:05:18', NULL, ''),
(1154, 'lois', '{"sale":{"id":"13807","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-15 16:03:39","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1508052010","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2017-10-15 16:05:33', NULL, ''),
(1155, 'sanni', '{"void_item":{"id":"52740","date":"2017-10-16 13:44:36","ss_terminal":null,"ss_code":null,"sale_id":"13838","si_item_id":"0","item_id":"270","item_sku":"204","item_name":"Homemade Savoury Pancake","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-16 13:44:36","serial":"admin-1508130625-15081326764796495","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-16 14:17:15', NULL, ''),
(1156, 'sanni', '{"void_item":{"id":"52769","date":"2017-10-16 15:25:52","ss_terminal":null,"ss_code":null,"sale_id":"13844","si_item_id":"0","item_id":"271","item_sku":"205","item_name":"Take It Easy","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-16 15:25:52","serial":"admin-1508130625-1508138752272115","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-16 15:49:42', NULL, ''),
(1157, 'lois', '{"void_item":{"id":"52803","date":"2017-10-18 09:30:49","ss_terminal":null,"ss_code":null,"sale_id":"13853","si_item_id":"0","item_id":"286","item_sku":"220","item_name":"Joyous Sunny","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-18 09:30:49","serial":"admin-1508287842-15082902491954020","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-18 09:34:11', NULL, ''),
(1158, 'lois', '{"void_item":{"id":"52802","date":"2017-10-18 09:30:49","ss_terminal":null,"ss_code":null,"sale_id":"13853","si_item_id":"0","item_id":"270","item_sku":"204","item_name":"Homemade Savoury Pancake","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-18 09:30:49","serial":"admin-1508287842-15082902491954020","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-18 09:34:18', NULL, ''),
(1159, 'sanni', '{"void_item":{"id":"52932","date":"2017-10-18 12:23:06","ss_terminal":null,"ss_code":null,"sale_id":"13878","si_item_id":"0","item_id":"288","item_sku":"222","item_name":"Smoked Duck Pesto Pasta","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"23.00","margin":"23.0000","cost":"0.0000","amount":"23.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-18 12:23:06","serial":"admin-1508297123-15083005867887444","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-18 12:33:44', NULL, ''),
(1160, 'sanni', '{"void_item":{"id":"52940","date":"2017-10-18 12:40:15","ss_terminal":null,"ss_code":null,"sale_id":"13879","si_item_id":"0","item_id":"42","item_sku":"42","item_name":"Passion Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-18 12:40:15","serial":"admin-1508300693-15083016156958885","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-18 12:40:43', NULL, ''),
(1161, 'lois', '{"void_item":{"id":"53034","date":"2017-10-18 14:23:29","ss_terminal":null,"ss_code":null,"sale_id":"13895","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Signature Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-18 14:23:29","serial":"admin-1508305602-15083078095893823","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-18 14:30:48', NULL, ''),
(1162, 'sanni', '{"void_item":{"id":"53003","date":"2017-10-18 13:55:27","ss_terminal":null,"ss_code":null,"sale_id":"13891","si_item_id":"0","item_id":"272","item_sku":"206","item_name":"Genius in The Bowl","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-18 13:55:27","serial":"admin-1508305602-15083061276827881","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-18 14:33:52', NULL, ''),
(1163, 'sanni', '{"void_item":{"id":"53006","date":"2017-10-18 13:55:27","ss_terminal":null,"ss_code":null,"sale_id":"13891","si_item_id":"0","item_id":"34","item_sku":"34","item_name":"Ginger Lemongrass Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-18 13:55:27","serial":"admin-1508305602-15083061276827881","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-18 14:34:00', NULL, ''),
(1164, 'lois', '{"void_item":{"id":"53109","date":"2017-10-19 09:57:53","ss_terminal":null,"ss_code":null,"sale_id":"13912","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-19 09:57:53","serial":"admin-1508373476-15083782736624323","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-19 10:39:27', NULL, ''),
(1165, 'sanni', '{"void_item":{"id":"53151","date":"2017-10-19 12:26:24","ss_terminal":null,"ss_code":null,"sale_id":"13921","si_item_id":"0","item_id":"217","item_sku":"151","item_name":"Spicy Lemony Wings","item_option":"half rice","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-19 12:26:24","serial":"admin-1508381954-15083871839057976","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-19 12:37:33', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(1166, 'sanni', '{"void_item":{"id":"53272","date":"2017-10-20 12:54:18","ss_terminal":null,"ss_code":null,"sale_id":"13950","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-20 12:54:18","serial":"admin-1508461080-15084752579532798","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-20 13:08:59', NULL, ''),
(1167, 'lois', '{"void_item":{"id":"53321","date":"2017-10-20 15:18:06","ss_terminal":null,"ss_code":null,"sale_id":"13960","si_item_id":"0","item_id":"263","item_sku":"197","item_name":"Postcard With Postage","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"4.00","margin":"4.0000","cost":"0.0000","amount":"4.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-20 15:18:06","serial":"admin-1508476012-15084838859341958","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-20 15:18:19', NULL, ''),
(1168, 'sanni', '{"sale":{"id":"13980","txn_no":null,"table_no":"T10","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-21 11:13:45","payment_status":"Unpaid","cost":null,"subtotal":"20.00","amount":"22.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1508553952","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"53417","date":"2017-10-21 11:13:48","ss_terminal":null,"ss_code":null,"sale_id":"13980","si_item_id":"0","item_id":"243","item_sku":"177","item_name":"Hot Ginger Lemongrass","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-21 11:13:48","serial":"admin-1508553952-15085556286593239","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"53416","date":"2017-10-21 11:13:48","ss_terminal":null,"ss_code":null,"sale_id":"13980","si_item_id":null,"item_id":"21","item_sku":"21","item_name":"Chocolate ","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-21 11:13:48","serial":"admin-1508553952-15085556286593239","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"53415","date":"2017-10-21 11:13:45","ss_terminal":null,"ss_code":null,"sale_id":"13980","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.00","margin":"0.0000","cost":"0.0000","amount":"2.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-21 11:13:45","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-10-21 13:31:43', NULL, ''),
(1169, 'sanni', '{"void_item":{"id":"53479","date":"2017-10-21 14:24:44","ss_terminal":null,"ss_code":null,"sale_id":"13992","si_item_id":"0","item_id":"52","item_sku":"52","item_name":"Pure Vanilla Frappe","item_option":"","category":"Cold Drinks","subcategory":"Frappe","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-21 14:24:44","serial":"admin-1508562284-15085670840044050","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-21 14:25:00', NULL, ''),
(1170, 'lois', '{"void_item":{"id":"53664","date":"2017-10-22 12:54:06","ss_terminal":null,"ss_code":null,"sale_id":"14028","si_item_id":"0","item_id":"288","item_sku":"222","item_name":"Smoked Duck Pesto Pasta","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"23.00","margin":"23.0000","cost":"0.0000","amount":"23.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-22 12:54:06","serial":"admin-1508644954-1508648046710335","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-22 12:55:53', NULL, ''),
(1171, 'lois', '{"void_item":{"id":"53676","date":"2017-10-22 13:28:41","ss_terminal":null,"ss_code":null,"sale_id":"14030","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-22 13:28:41","serial":"admin-1508644954-1508650121244589","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-22 13:30:37', NULL, ''),
(1172, 'lois', '{"sale":{"id":"14046","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-23 10:04:33","payment_status":"Unpaid","cost":null,"subtotal":"29.50","amount":"32.45","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1508720150","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"53748","date":"2017-10-23 10:05:23","ss_terminal":null,"ss_code":null,"sale_id":"14046","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"fried egg","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"1.50","margin":"1.5000","cost":"0.0000","amount":"1.50","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-23 10:05:23","serial":"admin-1508720150-15087243228489344","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"53751","date":"2017-10-23 10:07:58","ss_terminal":null,"ss_code":null,"sale_id":"14046","si_item_id":"0","item_id":"234","item_sku":"168","item_name":"Naughty Boy","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-23 10:07:58","serial":"admin-1508720150-1508724478688411","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"53752","date":"2017-10-23 10:07:58","ss_terminal":null,"ss_code":null,"sale_id":"14046","si_item_id":"0","item_id":"233","item_sku":"167","item_name":"Naugthy Girl","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-23 10:07:58","serial":"admin-1508720150-1508724478688411","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"53753","date":"2017-10-23 10:07:58","ss_terminal":null,"ss_code":null,"sale_id":"14046","si_item_id":"0","item_id":"163","item_sku":"97","item_name":"Melting Heart ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-23 10:07:58","serial":"admin-1508720150-1508724478688411","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"53749","date":"2017-10-23 10:06:30","ss_terminal":null,"ss_code":null,"sale_id":"14046","si_item_id":"0","item_id":"208","item_sku":"D0001","item_name":"RM5 DISCOUNT ","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"-5.00","margin":"-5.0000","cost":"0.0000","amount":"-5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-23 10:06:30","serial":"admin-1508720150-15087243905558251","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"53750","date":"2017-10-23 10:07:58","ss_terminal":null,"ss_code":null,"sale_id":"14046","si_item_id":"0","item_id":"235","item_sku":"169","item_name":"I''m Single","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-23 10:07:58","serial":"admin-1508720150-1508724478688411","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"53747","date":"2017-10-23 10:04:33","ss_terminal":null,"ss_code":null,"sale_id":"14046","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.95","margin":"0.0000","cost":"0.0000","amount":"2.95","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-23 10:04:33","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-10-23 10:08:15', NULL, ''),
(1173, 'lois', '{"void_item":{"id":"53790","date":"2017-10-23 12:23:27","ss_terminal":null,"ss_code":null,"sale_id":"14055","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"cocktail sosej","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"4.00","margin":"4.0000","cost":"0.0000","amount":"4.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-23 12:23:27","serial":"admin-1508732585-15087326075898464","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-23 12:28:47', NULL, ''),
(1174, 'sanni', '{"void_item":{"id":"53804","date":"2017-10-23 13:42:02","ss_terminal":null,"ss_code":null,"sale_id":"14057","si_item_id":"0","item_id":"172","item_sku":"106","item_name":"Daily Berries ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-23 13:42:02","serial":"admin-1508732585-15087373225258878","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-23 14:11:21', NULL, ''),
(1175, 'sanni', '{"void_item":{"id":"53865","date":"2017-10-25 12:49:23","ss_terminal":null,"ss_code":null,"sale_id":"14075","si_item_id":"0","item_id":"293","item_sku":"229","item_name":"Classic Yogurt Bowl","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-25 12:49:23","serial":"admin-1508892781-15089069633322633","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-25 12:58:33', NULL, ''),
(1176, 'sanni', '{"void_item":{"id":"53873","date":"2017-10-25 12:54:34","ss_terminal":null,"ss_code":null,"sale_id":"14077","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"Garlic Fried Rice","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-25 12:54:34","serial":"admin-1508892781-1508907274060987","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-25 12:59:25', NULL, ''),
(1177, 'sanni', '{"void_item":{"id":"53942","date":"2017-10-26 11:51:48","ss_terminal":null,"ss_code":null,"sale_id":"14092","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-26 11:51:48","serial":"admin-1508978592-15089899080182011","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-26 12:00:25', NULL, ''),
(1178, 'lois', '{"void_item":{"id":"53977","date":"2017-10-26 13:10:45","ss_terminal":null,"ss_code":null,"sale_id":"14098","si_item_id":"0","item_id":"80","item_sku":"80","item_name":"Oriental Chicken Salad","item_option":"","category":"Meals","subcategory":"Salad","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-26 13:10:45","serial":"admin-1508993224-15089946454162142","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-26 13:13:30', NULL, ''),
(1179, 'sanni', '{"void_item":{"id":"53985","date":"2017-10-26 13:20:45","ss_terminal":null,"ss_code":null,"sale_id":"14099","si_item_id":"0","item_id":"72","item_sku":"72","item_name":"Shimeji Mushroom with Chicken ","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-26 13:20:45","serial":"admin-1508993224-15089952453329597","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-26 13:24:14', NULL, ''),
(1180, 'lois', '{"void_item":{"id":"53979","date":"2017-10-26 13:11:01","ss_terminal":null,"ss_code":null,"sale_id":"14097","si_item_id":"0","item_id":"301","item_sku":"237","item_name":"Black Bomb","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-26 13:11:01","serial":"admin-1508993224-15089946614372222","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-26 13:45:53', NULL, ''),
(1181, 'lois', '{"void_item":{"id":"53978","date":"2017-10-26 13:11:01","ss_terminal":null,"ss_code":null,"sale_id":"14097","si_item_id":"0","item_id":"301","item_sku":"237","item_name":"Black Bomb","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-26 13:11:01","serial":"admin-1508993224-15089946614372222","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-26 13:46:01', NULL, ''),
(1182, 'lois', '{"void_item":{"id":"53972","date":"2017-10-26 12:51:05","ss_terminal":null,"ss_code":null,"sale_id":"14097","si_item_id":"0","item_id":"72","item_sku":"72","item_name":"Shimeji Mushroom with Chicken ","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-26 12:51:05","serial":"admin-1508993224-1508993465302551","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-26 13:47:41', NULL, ''),
(1183, 'lois', '{"void_item":{"id":"53986","date":"2017-10-26 13:23:36","ss_terminal":null,"ss_code":null,"sale_id":"14099","si_item_id":"0","item_id":"233","item_sku":"167","item_name":"Naugthy Girl","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-26 13:23:36","serial":"admin-1508993224-15089954164113567","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-26 13:55:24', NULL, ''),
(1184, 'sanni', '{"sale":{"id":"14114","txn_no":"113671","table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-10-27 13:43:12","payment_status":"Paid","cost":null,"subtotal":"34.00","amount":"37.40","amount_cash":"37.40","amount_cc":null,"amount_tendered":"50.50","amount_change":"13.10","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1509065731","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"54058","date":"2017-10-27 12:30:02","ss_terminal":null,"ss_code":null,"sale_id":"14114","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"3.40","margin":"0.0000","cost":"0.0000","amount":"3.40","sold":"1","terminal":"27","printed":"1","session":"1509065731","ordered_by":"admin","ordered_time":"2017-10-27 12:30:02","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"54060","date":"2017-10-27 12:30:19","ss_terminal":null,"ss_code":null,"sale_id":"14114","si_item_id":null,"item_id":"23","item_sku":"23","item_name":"Lemon Tea","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":"1","terminal":"27","printed":"1","session":"1509065731","ordered_by":"admin","ordered_time":"2017-10-27 12:30:19","serial":"admin-1509065731-15090786191797818","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"54059","date":"2017-10-27 12:30:19","ss_terminal":null,"ss_code":null,"sale_id":"14114","si_item_id":"0","item_id":"71","item_sku":"71","item_name":"Chinese  Rice Wine Pork","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1509065731","ordered_by":"admin","ordered_time":"2017-10-27 12:30:19","serial":"admin-1509065731-15090786191797818","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"54067","date":"2017-10-27 13:23:26","ss_terminal":null,"ss_code":null,"sale_id":"14114","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"Fried dumpling","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1509065731","ordered_by":"admin","ordered_time":"2017-10-27 13:23:26","serial":"admin-1509065731-15090818066914710","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-10-27 13:44:01', 1, ''),
(1185, 'sanni', '{"sale":{"id":"14148","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-28 12:07:24","payment_status":"Unpaid","cost":null,"subtotal":"0.00","amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1509162920","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"54219","date":"2017-10-28 12:07:50","ss_terminal":null,"ss_code":null,"sale_id":"14148","si_item_id":"0","item_id":"182","item_sku":"117","item_name":"Open Drinks ","item_option":"americano","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-28 12:07:50","serial":"admin-1509162920-15091636702573640","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-10-28 13:41:02', NULL, ''),
(1186, 'lois', '{"void_item":{"id":"54298","date":"2017-10-28 16:42:47","ss_terminal":null,"ss_code":null,"sale_id":"14161","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.20","margin":"0.0000","cost":"0.0000","amount":"1.20","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-28 16:42:47","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-28 16:43:14', NULL, ''),
(1187, 'lois', '{"void_item":{"id":"54299","date":"2017-10-28 16:43:03","ss_terminal":null,"ss_code":null,"sale_id":"14161","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-28 16:43:03","serial":"admin-1509173804-15091801834288688","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-28 16:43:21', NULL, ''),
(1188, 'lois', '{"sale":{"id":"14161","txn_no":null,"table_no":"T1","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-28 16:42:47","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1509173804","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2017-10-28 16:43:28', NULL, ''),
(1189, 'lois', '{"void_item":{"id":"54300","date":"2017-10-28 16:43:34","ss_terminal":null,"ss_code":null,"sale_id":"14162","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-28 16:43:34","serial":"admin-1509173804-15091802142424641","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}}', '2017-10-28 16:43:54', NULL, ''),
(1190, 'sanni', '{"void_item":{"id":"54383","date":"2017-10-29 10:52:13","ss_terminal":null,"ss_code":null,"sale_id":"14179","si_item_id":"0","item_id":"225","item_sku":"159","item_name":"Smoked Duck Salad","item_option":"","category":"Meals","subcategory":"Salad","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-29 10:52:13","serial":"admin-1509243968-1509245532897394","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-29 11:12:55', NULL, ''),
(1191, 'sanni', '{"void_item":{"id":"54427","date":"2017-10-29 11:40:53","ss_terminal":null,"ss_code":null,"sale_id":"14187","si_item_id":null,"item_id":"69","item_sku":"69","item_name":"Mix 3 types","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-29 11:40:53","serial":"admin-1509246111-15092484529742729","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-29 11:41:18', NULL, ''),
(1192, 'lois', '{"void_item":{"id":"54443","date":"2017-10-29 12:04:20","ss_terminal":null,"ss_code":null,"sale_id":"14191","si_item_id":"0","item_id":"286","item_sku":"220","item_name":"Joyous Sunny","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-29 12:04:20","serial":"admin-1509246111-15092498600336942","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-29 12:10:49', NULL, ''),
(1193, 'lois', '{"sale":{"id":"14198","txn_no":null,"table_no":"T11A","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-29 13:31:22","payment_status":"Unpaid","cost":null,"subtotal":"37.00","amount":"40.70","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1509249892","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"54485","date":"2017-10-29 13:31:27","ss_terminal":null,"ss_code":null,"sale_id":"14198","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-29 13:31:27","serial":"admin-1509249892-1509255086872541","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"54483","date":"2017-10-29 13:31:22","ss_terminal":null,"ss_code":null,"sale_id":"14198","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"3.70","margin":"0.0000","cost":"0.0000","amount":"3.70","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-29 13:31:22","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"54484","date":"2017-10-29 13:31:27","ss_terminal":null,"ss_code":null,"sale_id":"14198","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-29 13:31:27","serial":"admin-1509249892-1509255086872541","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-10-29 14:06:29', NULL, ''),
(1194, 'sanni', '{"void_item":{"id":"54504","date":"2017-10-29 14:13:51","ss_terminal":null,"ss_code":null,"sale_id":"14200","si_item_id":"0","item_id":"210","item_sku":"144","item_name":"Red Riding Hood","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-29 14:13:51","serial":"admin-1509257350-1509257631677437","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-29 14:26:03', NULL, ''),
(1195, 'sanni', '{"void_item":{"id":"54528","date":"2017-10-29 14:39:27","ss_terminal":null,"ss_code":null,"sale_id":"14207","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"French Toast with Fruits","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-29 14:39:27","serial":"admin-1509257350-15092591669032443","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-29 14:41:05', NULL, ''),
(1196, 'sanni', '{"void_item":{"id":"54536","date":"2017-10-29 14:56:42","ss_terminal":null,"ss_code":null,"sale_id":"14209","si_item_id":"0","item_id":"274","item_sku":"208","item_name":"2 pcs Cookies","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-29 14:56:42","serial":"admin-1509257350-1509260202434816","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-29 14:59:33', NULL, ''),
(1197, 'sanni', '{"void_item":{"id":"54519","date":"2017-10-29 14:24:08","ss_terminal":null,"ss_code":null,"sale_id":"14206","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"potatos to beans","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-29 14:24:08","serial":"admin-1509257350-15092582480238826","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-29 15:14:43', NULL, ''),
(1198, 'lois', '{"sale":{"id":"14227","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-10-30 12:19:34","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1509334527","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"54603","date":"2017-10-30 12:19:34","ss_terminal":null,"ss_code":null,"sale_id":"14227","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-30 12:19:34","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-10-30 13:40:25', NULL, ''),
(1199, 'sanni', '{"void_item":{"id":"54609","date":"2017-10-30 14:31:23","ss_terminal":null,"ss_code":null,"sale_id":"14230","si_item_id":"0","item_id":"76","item_sku":"76","item_name":"Meatless Pesto Pasta","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-10-30 14:31:23","serial":"admin-1509334527-15093450837515682","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-10-30 14:31:38', NULL, ''),
(1200, 'sanni', '{"void_item":{"id":"54733","date":"2017-11-02 12:05:15","ss_terminal":null,"ss_code":null,"sale_id":"14255","si_item_id":"0","item_id":"192","item_sku":"127","item_name":"Flaming Hot & Spicy Pork","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-02 12:05:15","serial":"admin-1509583757-15095955157117864","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-02 12:23:59', NULL, ''),
(1201, 'sanni', '{"void_item":{"id":"54923","date":"2017-11-04 10:27:39","ss_terminal":null,"ss_code":null,"sale_id":"14300","si_item_id":"0","item_id":"270","item_sku":"204","item_name":"Homemade Savoury Pancake","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-04 10:27:39","serial":"admin-1509761400-15097624588814487","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-04 10:31:32', NULL, ''),
(1202, 'sanni', '{"void_item":{"id":"55020","date":"2017-11-04 12:33:32","ss_terminal":null,"ss_code":null,"sale_id":"14317","si_item_id":"0","item_id":"242","item_sku":"176","item_name":"Citrus Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-04 12:33:32","serial":"admin-1509769719-15097700120878524","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-04 12:52:35', NULL, ''),
(1203, 'lois', '{"sale":{"id":"14311","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-11-04 11:45:38","payment_status":"Unpaid","cost":null,"subtotal":"7.00","amount":"7.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1509763941","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"54992","date":"2017-11-04 11:45:45","ss_terminal":null,"ss_code":null,"sale_id":"14311","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-04 11:45:45","serial":"admin-1509763941-15097671457204949","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-11-04 14:41:56', NULL, ''),
(1204, 'lois', '{"sale":{"id":"14323","txn_no":null,"table_no":"T5","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-11-05 08:42:22","payment_status":"Unpaid","cost":null,"subtotal":"14.00","amount":"15.40","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1509842535","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"55046","date":"2017-11-05 08:42:26","ss_terminal":null,"ss_code":null,"sale_id":"14323","si_item_id":"0","item_id":"158","item_sku":"92","item_name":"Banana Stuffed Nutella Toast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-05 08:42:26","serial":"admin-1509842535-1509842546256812","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55045","date":"2017-11-05 08:42:23","ss_terminal":null,"ss_code":null,"sale_id":"14323","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.40","margin":"0.0000","cost":"0.0000","amount":"1.40","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-05 08:42:23","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-11-05 08:42:40', NULL, ''),
(1205, 'sanni', '{"sale":{"id":"14340","txn_no":"113882","table_no":"T5","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-11-05 12:26:22","payment_status":"Paid","cost":null,"subtotal":"29.00","amount":"28.70","amount_cash":"28.70","amount_cc":null,"amount_tendered":"50.00","amount_change":"21.30","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":"3.19","adjustment":"-0.01","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1509855311","discount_type":"p","discount":"10","payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"55137","date":"2017-11-05 12:26:05","ss_terminal":null,"ss_code":null,"sale_id":"14340","si_item_id":"0","item_id":"70","item_sku":"70","item_name":"Borneo Pepper Pork","item_option":"Takeaway","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":"1","terminal":"27","printed":"1","session":"1509855311","ordered_by":"admin","ordered_time":"2017-11-05 12:26:05","serial":"admin-1509855311-150985596491872","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":"10.0"},{"id":"55138","date":"2017-11-05 12:26:05","ss_terminal":null,"ss_code":null,"sale_id":"14340","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"Takeaway","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1509855311","ordered_by":"admin","ordered_time":"2017-11-05 12:26:05","serial":"admin-1509855311-150985596491872","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"},{"id":"55136","date":"2017-11-05 12:25:43","ss_terminal":null,"ss_code":null,"sale_id":"14340","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.90","margin":"0.0000","cost":"0.0000","amount":"2.90","sold":"1","terminal":"27","printed":"1","session":"1509855311","ordered_by":"admin","ordered_time":"2017-11-05 12:25:43","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":"10.0"}]}', '2017-11-05 12:26:48', 1, ''),
(1206, 'sanni', '{"void_item":{"id":"55138","date":"2017-11-05 12:26:05","ss_terminal":null,"ss_code":null,"sale_id":"14340","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"Takeaway","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1509855311","ordered_by":"admin","ordered_time":"2017-11-05 12:26:05","serial":"admin-1509855311-150985596491872","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"}}', '2017-11-05 12:26:59', NULL, ''),
(1207, 'sanni', '{"sale":{"id":"14340","txn_no":"113882","table_no":"T5","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-11-05 12:27:35","payment_status":"Paid","cost":null,"subtotal":"36.00","amount":"35.65","amount_cash":"35.65","amount_cc":null,"amount_tendered":"50.00","amount_change":"14.35","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":"3.96","adjustment":"0.01","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1509855311","discount_type":"p","discount":"10","payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"55137","date":"2017-11-05 12:26:05","ss_terminal":null,"ss_code":null,"sale_id":"14340","si_item_id":"0","item_id":"70","item_sku":"70","item_name":"Borneo Pepper Pork","item_option":"Takeaway","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":"1","terminal":"27","printed":"1","session":"1509855311","ordered_by":"admin","ordered_time":"2017-11-05 12:26:05","serial":"admin-1509855311-150985596491872","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":"10.0"},{"id":"55139","date":"2017-11-05 12:27:07","ss_terminal":null,"ss_code":null,"sale_id":"14340","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Signature Dumpling (10 Pcs) ","item_option":"Takeaway","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":"1","terminal":"27","printed":"1","session":"1509855311","ordered_by":"admin","ordered_time":"2017-11-05 12:27:07","serial":"admin-1509855311-15098560275471630","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"},{"id":"55136","date":"2017-11-05 12:25:43","ss_terminal":null,"ss_code":null,"sale_id":"14340","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"3.60","margin":"0.0000","cost":"0.0000","amount":"3.60","sold":"1","terminal":"27","printed":"1","session":"1509855311","ordered_by":"admin","ordered_time":"2017-11-05 12:25:43","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":"10.0"}]}', '2017-11-05 12:28:07', 1, ''),
(1208, 'sanni', '{"void_item":{"id":"55139","date":"2017-11-05 12:27:07","ss_terminal":null,"ss_code":null,"sale_id":"14340","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Signature Dumpling (10 Pcs) ","item_option":"Takeaway","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":"1","terminal":"27","printed":"1","session":"1509855311","ordered_by":"admin","ordered_time":"2017-11-05 12:27:07","serial":"admin-1509855311-15098560275471630","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":"10.0"}}', '2017-11-05 12:28:26', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(1209, 'sanni', '{"sale":{"id":"14350","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-11-06 09:59:15","payment_status":"Unpaid","cost":null,"subtotal":"23.00","amount":"25.30","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1509929750","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"55171","date":"2017-11-06 09:59:15","ss_terminal":null,"ss_code":null,"sale_id":"14350","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.30","margin":"0.0000","cost":"0.0000","amount":"2.30","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 09:59:15","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55172","date":"2017-11-06 09:59:26","ss_terminal":null,"ss_code":null,"sale_id":"14350","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"Takeaway","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"23.00","margin":"23.0000","cost":"0.0000","amount":"23.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 09:59:26","serial":"admin-1509929750-15099335659837142","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-11-06 10:13:28', NULL, ''),
(1210, 'admin', '{"sale":{"id":"14354","txn_no":null,"table_no":"T1","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-11-06 10:56:35","payment_status":"Unpaid","cost":null,"subtotal":"29.00","amount":"31.90","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1509929750","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"55182","date":"2017-11-06 10:56:46","ss_terminal":null,"ss_code":null,"sale_id":"14354","si_item_id":"0","item_id":"231","item_sku":"165","item_name":"Hometown Fried Rice","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 10:56:46","serial":"admin-1509929750-15099370065284232","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55183","date":"2017-11-06 10:56:46","ss_terminal":null,"ss_code":null,"sale_id":"14354","si_item_id":"0","item_id":"16","item_sku":"16","item_name":"Iced Mocha ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 10:56:46","serial":"admin-1509929750-15099370065284232","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55181","date":"2017-11-06 10:56:35","ss_terminal":null,"ss_code":null,"sale_id":"14354","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.90","margin":"0.0000","cost":"0.0000","amount":"2.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 10:56:35","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-11-06 10:58:06', NULL, 'Reason 1'),
(1211, 'admin', '{"sale":{"id":"14355","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-11-06 10:57:26","payment_status":"Unpaid","cost":null,"subtotal":"32.00","amount":"35.20","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1509929750","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"55184","date":"2017-11-06 10:57:26","ss_terminal":null,"ss_code":null,"sale_id":"14355","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"3.20","margin":"0.0000","cost":"0.0000","amount":"3.20","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 10:57:26","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55186","date":"2017-11-06 10:57:33","ss_terminal":null,"ss_code":null,"sale_id":"14355","si_item_id":"0","item_id":"295","item_sku":"231","item_name":"Chinese Ginger Garlic Chicken","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 10:57:33","serial":"admin-1509929750-15099370532039192","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55185","date":"2017-11-06 10:57:33","ss_terminal":null,"ss_code":null,"sale_id":"14355","si_item_id":"0","item_id":"73","item_sku":"73","item_name":"Marmite Chicken ","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 10:57:33","serial":"admin-1509929750-15099370532039192","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-11-06 10:58:14', NULL, 'Reason 1'),
(1212, 'admin', '{"sale":{"id":"14353","txn_no":null,"table_no":"TEST","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-11-06 10:56:02","payment_status":"Unpaid","cost":null,"subtotal":"5.00","amount":"5.50","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1509929750","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"55179","date":"2017-11-06 10:56:02","ss_terminal":null,"ss_code":null,"sale_id":"14353","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.50","margin":"0.0000","cost":"0.0000","amount":"0.50","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 10:56:02","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55180","date":"2017-11-06 10:56:05","ss_terminal":null,"ss_code":null,"sale_id":"14353","si_item_id":null,"item_id":"46","item_sku":"46","item_name":"Coke","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 10:56:05","serial":"admin-1509929750-15099369657739938","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-11-06 10:58:22', NULL, 'Reason 1'),
(1213, 'admin', '{"sale":{"id":"14358","txn_no":null,"table_no":null,"user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-11-06 11:02:00","payment_status":"Unpaid","cost":null,"subtotal":"26.00","amount":"28.60","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1509929750","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":null},"sale_items":[{"id":"55192","date":"2017-11-06 11:02:25","ss_terminal":null,"ss_code":null,"sale_id":"14358","si_item_id":"0","item_id":"73","item_sku":"73","item_name":"Marmite Chicken ","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:02:25","serial":"admin-1509929750-15099373452255492","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55194","date":"2017-11-06 11:02:25","ss_terminal":null,"ss_code":null,"sale_id":"14358","si_item_id":null,"item_id":"45","item_sku":"45","item_name":"Soda","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:02:25","serial":"admin-1509929750-15099373452255492","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55193","date":"2017-11-06 11:02:25","ss_terminal":null,"ss_code":null,"sale_id":"14358","si_item_id":null,"item_id":"46","item_sku":"46","item_name":"Coke","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:02:25","serial":"admin-1509929750-15099373452255492","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55191","date":"2017-11-06 11:02:00","ss_terminal":null,"ss_code":null,"sale_id":"14358","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.60","margin":"0.0000","cost":"0.0000","amount":"2.60","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:02:00","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-11-06 11:03:02', NULL, ''),
(1214, 'admin', '{"sale":{"id":"14357","txn_no":null,"table_no":"TEST","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-11-06 10:59:07","payment_status":"Unpaid","cost":null,"subtotal":"27.00","amount":"29.70","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1509929750","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"55190","date":"2017-11-06 10:59:20","ss_terminal":null,"ss_code":null,"sale_id":"14357","si_item_id":null,"item_id":"47","item_sku":"47","item_name":"Light coke","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 10:59:20","serial":"admin-1509929750-15099371600126381","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55189","date":"2017-11-06 10:59:20","ss_terminal":null,"ss_code":null,"sale_id":"14357","si_item_id":null,"item_id":"46","item_sku":"46","item_name":"Coke","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 10:59:20","serial":"admin-1509929750-15099371600126381","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55188","date":"2017-11-06 10:59:20","ss_terminal":null,"ss_code":null,"sale_id":"14357","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 10:59:20","serial":"admin-1509929750-15099371600126381","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55187","date":"2017-11-06 10:59:07","ss_terminal":null,"ss_code":null,"sale_id":"14357","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.70","margin":"0.0000","cost":"0.0000","amount":"2.70","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 10:59:07","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-11-06 11:05:34', NULL, ''),
(1215, 'admin', '{"sale":{"id":"14359","txn_no":null,"table_no":"Test2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-11-06 11:03:22","payment_status":"Unpaid","cost":null,"subtotal":"37.00","amount":"40.70","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1509929750","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"55195","date":"2017-11-06 11:03:22","ss_terminal":null,"ss_code":null,"sale_id":"14359","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"3.70","margin":"0.0000","cost":"0.0000","amount":"3.70","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:03:22","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55197","date":"2017-11-06 11:03:43","ss_terminal":null,"ss_code":null,"sale_id":"14359","si_item_id":"0","item_id":"56","item_sku":"56","item_name":"House red (Glass)","item_option":"","category":"Cold Drinks","subcategory":"Wine","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:03:43","serial":"admin-1509929750-15099374233532743","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55196","date":"2017-11-06 11:03:43","ss_terminal":null,"ss_code":null,"sale_id":"14359","si_item_id":"0","item_id":"76","item_sku":"76","item_name":"Meatless Pesto Pasta","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:03:43","serial":"admin-1509929750-15099374233532743","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-11-06 11:05:41', NULL, ''),
(1216, 'admin', '{"sale":{"id":"14363","txn_no":null,"table_no":"TEST2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-11-06 11:31:48","payment_status":"Unpaid","cost":null,"subtotal":"205.00","amount":"225.50","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1509929750","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"55236","date":"2017-11-06 11:35:01","ss_terminal":null,"ss_code":null,"sale_id":"14363","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:35:01","serial":"admin-1509929750-15099393012938321","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55237","date":"2017-11-06 11:35:33","ss_terminal":null,"ss_code":null,"sale_id":"14363","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Cheesy Chicken Gratin","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:35:33","serial":"admin-1509929750-15099393337844529","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55238","date":"2017-11-06 11:35:33","ss_terminal":null,"ss_code":null,"sale_id":"14363","si_item_id":"0","item_id":"296","item_sku":"232","item_name":"Classic Egg Sandwich","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:35:33","serial":"admin-1509929750-15099393337844529","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55239","date":"2017-11-06 11:35:34","ss_terminal":null,"ss_code":null,"sale_id":"14363","si_item_id":"0","item_id":"268","item_sku":"202","item_name":"Iced Cocoa Cappucino","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:35:34","serial":"admin-1509929750-15099393337844529","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55235","date":"2017-11-06 11:35:01","ss_terminal":null,"ss_code":null,"sale_id":"14363","si_item_id":"0","item_id":"73","item_sku":"73","item_name":"Marmite Chicken ","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:35:01","serial":"admin-1509929750-15099393012938321","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55243","date":"2017-11-06 11:46:43","ss_terminal":null,"ss_code":null,"sale_id":"14363","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Cheesy Chicken Gratin","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:46:43","serial":"admin-1509929750-15099400029481269","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55244","date":"2017-11-06 11:46:43","ss_terminal":null,"ss_code":null,"sale_id":"14363","si_item_id":"0","item_id":"296","item_sku":"232","item_name":"Classic Egg Sandwich","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:46:43","serial":"admin-1509929750-15099400029481269","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55245","date":"2017-11-06 11:46:43","ss_terminal":null,"ss_code":null,"sale_id":"14363","si_item_id":"0","item_id":"14","item_sku":"14","item_name":"Iced Cappucino ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:46:43","serial":"admin-1509929750-15099400029481269","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55234","date":"2017-11-06 11:35:01","ss_terminal":null,"ss_code":null,"sale_id":"14363","si_item_id":"0","item_id":"231","item_sku":"165","item_name":"Hometown Fried Rice","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:35:01","serial":"admin-1509929750-15099393012938321","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55229","date":"2017-11-06 11:31:48","ss_terminal":null,"ss_code":null,"sale_id":"14363","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"20.50","margin":"0.0000","cost":"0.0000","amount":"20.50","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:31:48","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55246","date":"2017-11-06 11:46:43","ss_terminal":null,"ss_code":null,"sale_id":"14363","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:46:43","serial":"admin-1509929750-15099400029481269","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55240","date":"2017-11-06 11:35:34","ss_terminal":null,"ss_code":null,"sale_id":"14363","si_item_id":"0","item_id":"17","item_sku":"17","item_name":"Iced Caramel Macchiato ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:35:34","serial":"admin-1509929750-15099393337844529","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55233","date":"2017-11-06 11:32:00","ss_terminal":null,"ss_code":null,"sale_id":"14363","si_item_id":"0","item_id":"17","item_sku":"17","item_name":"Iced Caramel Macchiato ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:32:00","serial":"admin-1509929750-1509939120234939","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55231","date":"2017-11-06 11:32:00","ss_terminal":null,"ss_code":null,"sale_id":"14363","si_item_id":"0","item_id":"73","item_sku":"73","item_name":"Marmite Chicken ","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:32:00","serial":"admin-1509929750-1509939120234939","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55232","date":"2017-11-06 11:32:00","ss_terminal":null,"ss_code":null,"sale_id":"14363","si_item_id":"0","item_id":"14","item_sku":"14","item_name":"Iced Cappucino ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:32:00","serial":"admin-1509929750-1509939120234939","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55230","date":"2017-11-06 11:32:00","ss_terminal":null,"ss_code":null,"sale_id":"14363","si_item_id":"0","item_id":"231","item_sku":"165","item_name":"Hometown Fried Rice","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:32:00","serial":"admin-1509929750-1509939120234939","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-11-06 11:47:26', NULL, ''),
(1217, 'admin', '{"sale":{"id":"14360","txn_no":null,"table_no":"Test","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-11-06 11:05:45","payment_status":"Unpaid","cost":null,"subtotal":"74.00","amount":"81.40","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1509929750","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"55198","date":"2017-11-06 11:05:45","ss_terminal":null,"ss_code":null,"sale_id":"14360","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"7.40","margin":"0.0000","cost":"0.0000","amount":"7.40","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:05:45","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55199","date":"2017-11-06 11:05:59","ss_terminal":null,"ss_code":null,"sale_id":"14360","si_item_id":"0","item_id":"78","item_sku":"78","item_name":"Cheesy Baked Mashed Potato","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:05:59","serial":"admin-1509929750-15099375595489138","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55224","date":"2017-11-06 11:28:03","ss_terminal":null,"ss_code":null,"sale_id":"14360","si_item_id":"0","item_id":"70","item_sku":"70","item_name":"Borneo Pepper Pork","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:28:03","serial":"admin-1509929750-15099388837128016","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55200","date":"2017-11-06 11:05:59","ss_terminal":null,"ss_code":null,"sale_id":"14360","si_item_id":"0","item_id":"253","item_sku":"187","item_name":"Cheese Baked Nachos","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:05:59","serial":"admin-1509929750-15099375595489138","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55201","date":"2017-11-06 11:05:59","ss_terminal":null,"ss_code":null,"sale_id":"14360","si_item_id":null,"item_id":"69","item_sku":"69","item_name":"Mix 3 types","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:05:59","serial":"admin-1509929750-15099375595489138","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55202","date":"2017-11-06 11:05:59","ss_terminal":null,"ss_code":null,"sale_id":"14360","si_item_id":null,"item_id":"68","item_sku":"68","item_name":"Mix 2 types ","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:05:59","serial":"admin-1509929750-15099375595489138","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55203","date":"2017-11-06 11:05:59","ss_terminal":null,"ss_code":null,"sale_id":"14360","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:05:59","serial":"admin-1509929750-15099375595489138","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-11-06 11:47:39', NULL, ''),
(1218, 'admin', '{"sale":{"id":"14361","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-11-06 11:06:21","payment_status":"Unpaid","cost":null,"subtotal":"20.00","amount":"22.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1509929750","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"55207","date":"2017-11-06 11:06:26","ss_terminal":null,"ss_code":null,"sale_id":"14361","si_item_id":null,"item_id":"47","item_sku":"47","item_name":"Light coke","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:06:26","serial":"admin-1509929750-15099375865465374","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55205","date":"2017-11-06 11:06:26","ss_terminal":null,"ss_code":null,"sale_id":"14361","si_item_id":"0","item_id":"275","item_sku":"209","item_name":"Carlsberg","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:06:26","serial":"admin-1509929750-15099375865465374","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55206","date":"2017-11-06 11:06:26","ss_terminal":null,"ss_code":null,"sale_id":"14361","si_item_id":null,"item_id":"46","item_sku":"46","item_name":"Coke","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:06:26","serial":"admin-1509929750-15099375865465374","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55204","date":"2017-11-06 11:06:21","ss_terminal":null,"ss_code":null,"sale_id":"14361","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.00","margin":"0.0000","cost":"0.0000","amount":"2.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:06:21","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-11-06 11:47:50', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(1219, 'admin', '{"sale":{"id":"14362","txn_no":null,"table_no":"T11A","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-11-06 11:06:45","payment_status":"Unpaid","cost":null,"subtotal":"219.00","amount":"240.90","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1509929750","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"55221","date":"2017-11-06 11:09:02","ss_terminal":null,"ss_code":null,"sale_id":"14362","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:09:02","serial":"admin-1509929750-1509937742070845","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55222","date":"2017-11-06 11:09:02","ss_terminal":null,"ss_code":null,"sale_id":"14362","si_item_id":"0","item_id":"225","item_sku":"159","item_name":"Smoked Duck Salad","item_option":"","category":"Meals","subcategory":"Salad","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:09:02","serial":"admin-1509929750-1509937742070845","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55214","date":"2017-11-06 11:07:15","ss_terminal":null,"ss_code":null,"sale_id":"14362","si_item_id":"0","item_id":"267","item_sku":"201","item_name":"Cocoa Cappucino","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:07:15","serial":"admin-1509929750-15099376350984655","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55211","date":"2017-11-06 11:06:53","ss_terminal":null,"ss_code":null,"sale_id":"14362","si_item_id":"0","item_id":"50","item_sku":"50","item_name":"Espresso Frappe","item_option":"","category":"Cold Drinks","subcategory":"Frappe","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:06:53","serial":"admin-1509929750-15099376135877552","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55212","date":"2017-11-06 11:07:15","ss_terminal":null,"ss_code":null,"sale_id":"14362","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:07:15","serial":"admin-1509929750-15099376350984655","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55213","date":"2017-11-06 11:07:15","ss_terminal":null,"ss_code":null,"sale_id":"14362","si_item_id":null,"item_id":"8","item_sku":"8","item_name":"Caramel Macchiato ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:07:15","serial":"admin-1509929750-15099376350984655","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55223","date":"2017-11-06 11:09:02","ss_terminal":null,"ss_code":null,"sale_id":"14362","si_item_id":"0","item_id":"79","item_sku":"79","item_name":"Summer Salad ","item_option":"","category":"Meals","subcategory":"Salad","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:09:02","serial":"admin-1509929750-1509937742070845","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55227","date":"2017-11-06 11:28:24","ss_terminal":null,"ss_code":null,"sale_id":"14362","si_item_id":null,"item_id":"46","item_sku":"46","item_name":"Coke","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:28:24","serial":"admin-1509929750-15099389046447040","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55219","date":"2017-11-06 11:08:42","ss_terminal":null,"ss_code":null,"sale_id":"14362","si_item_id":"0","item_id":"284","item_sku":"218","item_name":"Caramel Waffles","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:08:42","serial":"admin-1509929750-15099377220167984","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55220","date":"2017-11-06 11:08:42","ss_terminal":null,"ss_code":null,"sale_id":"14362","si_item_id":"0","item_id":"262","item_sku":"196","item_name":"Cheesy Sticks","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:08:42","serial":"admin-1509929750-15099377220167984","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55215","date":"2017-11-06 11:07:25","ss_terminal":null,"ss_code":null,"sale_id":"14362","si_item_id":"0","item_id":"231","item_sku":"165","item_name":"Hometown Fried Rice","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:07:25","serial":"admin-1509929750-15099376456812596","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55228","date":"2017-11-06 11:28:24","ss_terminal":null,"ss_code":null,"sale_id":"14362","si_item_id":"0","item_id":"275","item_sku":"209","item_name":"Carlsberg","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:28:24","serial":"admin-1509929750-15099389046447040","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55226","date":"2017-11-06 11:28:24","ss_terminal":null,"ss_code":null,"sale_id":"14362","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Cheesy Chicken Gratin","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:28:24","serial":"admin-1509929750-15099389046447040","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55218","date":"2017-11-06 11:08:42","ss_terminal":null,"ss_code":null,"sale_id":"14362","si_item_id":"0","item_id":"247","item_sku":"181","item_name":"Caramel Chocolate Cheese","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:08:42","serial":"admin-1509929750-15099377220167984","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55217","date":"2017-11-06 11:08:34","ss_terminal":null,"ss_code":null,"sale_id":"14362","si_item_id":"0","item_id":"265","item_sku":"199","item_name":"Old Penang PostCard","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:08:34","serial":"admin-1509929750-15099377141515669","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55216","date":"2017-11-06 11:07:25","ss_terminal":null,"ss_code":null,"sale_id":"14362","si_item_id":"0","item_id":"73","item_sku":"73","item_name":"Marmite Chicken ","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:07:25","serial":"admin-1509929750-15099376456812596","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55225","date":"2017-11-06 11:28:24","ss_terminal":null,"ss_code":null,"sale_id":"14362","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:28:24","serial":"admin-1509929750-15099389046447040","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55210","date":"2017-11-06 11:06:53","ss_terminal":null,"ss_code":null,"sale_id":"14362","si_item_id":"0","item_id":"51","item_sku":"51","item_name":"Chocolate Frappe","item_option":"","category":"Cold Drinks","subcategory":"Frappe","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:06:53","serial":"admin-1509929750-15099376135877552","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55209","date":"2017-11-06 11:06:53","ss_terminal":null,"ss_code":null,"sale_id":"14362","si_item_id":"0","item_id":"240","item_sku":"174","item_name":"Chocolate Affogato","item_option":"","category":"Cold Drinks","subcategory":"Frappe","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:06:53","serial":"admin-1509929750-15099376135877552","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55208","date":"2017-11-06 11:06:45","ss_terminal":null,"ss_code":null,"sale_id":"14362","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"21.90","margin":"0.0000","cost":"0.0000","amount":"21.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:06:45","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-11-06 11:47:56', NULL, ''),
(1220, 'sanni', '{"sale":{"id":"14370","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-11-06 13:21:26","payment_status":"Unpaid","cost":null,"subtotal":"12.00","amount":"2.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":"10.00","adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1509929750","discount_type":"d","discount":"10","payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"55272","date":"2017-11-06 13:21:32","ss_terminal":null,"ss_code":null,"sale_id":"14370","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 13:21:32","serial":"admin-1509929750-15099456920093740","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-11-06 13:22:27', NULL, ''),
(1221, 'sanni', '{"sale":{"id":"14372","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-11-06 13:23:38","payment_status":"Unpaid","cost":null,"subtotal":"24.00","amount":"14.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":"10.00","adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1509929750","discount_type":"d","discount":"10","payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"55275","date":"2017-11-06 13:23:49","ss_terminal":null,"ss_code":null,"sale_id":"14372","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 13:23:49","serial":"admin-1509929750-15099458289799730","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null},{"id":"55274","date":"2017-11-06 13:23:49","ss_terminal":null,"ss_code":null,"sale_id":"14372","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 13:23:49","serial":"admin-1509929750-15099458289799730","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-11-06 13:24:56', NULL, ''),
(1222, 'sanni', '{"sale":{"id":"14365","txn_no":null,"table_no":"test","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-11-06 11:48:10","payment_status":"Unpaid","cost":null,"subtotal":"86.00","amount":"94.60","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1509929750","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"55253","date":"2017-11-06 11:48:24","ss_terminal":null,"ss_code":null,"sale_id":"14365","si_item_id":"0","item_id":"268","item_sku":"202","item_name":"Iced Cocoa Cappucino","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:48:24","serial":"admin-1509929750-15099401041322667","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55252","date":"2017-11-06 11:48:24","ss_terminal":null,"ss_code":null,"sale_id":"14365","si_item_id":"0","item_id":"17","item_sku":"17","item_name":"Iced Caramel Macchiato ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:48:24","serial":"admin-1509929750-15099401041322667","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55251","date":"2017-11-06 11:48:24","ss_terminal":null,"ss_code":null,"sale_id":"14365","si_item_id":"0","item_id":"14","item_sku":"14","item_name":"Iced Cappucino ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:48:24","serial":"admin-1509929750-15099401041322667","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55247","date":"2017-11-06 11:48:10","ss_terminal":null,"ss_code":null,"sale_id":"14365","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"8.60","margin":"0.0000","cost":"0.0000","amount":"8.60","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:48:10","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55248","date":"2017-11-06 11:48:24","ss_terminal":null,"ss_code":null,"sale_id":"14365","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:48:24","serial":"admin-1509929750-15099401041322667","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55249","date":"2017-11-06 11:48:24","ss_terminal":null,"ss_code":null,"sale_id":"14365","si_item_id":"0","item_id":"155","item_sku":"89","item_name":"Cheesy Chicken Gratin","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:48:24","serial":"admin-1509929750-15099401041322667","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55250","date":"2017-11-06 11:48:24","ss_terminal":null,"ss_code":null,"sale_id":"14365","si_item_id":"0","item_id":"296","item_sku":"232","item_name":"Classic Egg Sandwich","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 11:48:24","serial":"admin-1509929750-15099401041322667","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-11-06 14:21:19', NULL, ''),
(1223, 'admin', '{"sale":{"id":"14381","txn_no":null,"table_no":"Test","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-11-06 14:35:04","payment_status":"Unpaid","cost":null,"subtotal":"67.00","amount":"73.70","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1509929750","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"55302","date":"2017-11-06 14:35:21","ss_terminal":null,"ss_code":null,"sale_id":"14381","si_item_id":"0","item_id":"247","item_sku":"181","item_name":"Caramel Chocolate Cheese","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 14:35:21","serial":"admin-1509929750-15099501209969056","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55300","date":"2017-11-06 14:35:21","ss_terminal":null,"ss_code":null,"sale_id":"14381","si_item_id":"0","item_id":"17","item_sku":"17","item_name":"Iced Caramel Macchiato ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 14:35:21","serial":"admin-1509929750-15099501209969056","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55301","date":"2017-11-06 14:35:21","ss_terminal":null,"ss_code":null,"sale_id":"14381","si_item_id":"0","item_id":"269","item_sku":"203","item_name":"Espresso Con Panna","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 14:35:21","serial":"admin-1509929750-15099501209969056","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55299","date":"2017-11-06 14:35:21","ss_terminal":null,"ss_code":null,"sale_id":"14381","si_item_id":"0","item_id":"70","item_sku":"70","item_name":"Borneo Pepper Pork","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 14:35:21","serial":"admin-1509929750-15099501209969056","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55297","date":"2017-11-06 14:35:04","ss_terminal":null,"ss_code":null,"sale_id":"14381","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"6.70","margin":"0.0000","cost":"0.0000","amount":"6.70","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 14:35:04","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55298","date":"2017-11-06 14:35:21","ss_terminal":null,"ss_code":null,"sale_id":"14381","si_item_id":"0","item_id":"211","item_sku":"145","item_name":"Asian Spicy Lemony Chicken","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 14:35:21","serial":"admin-1509929750-15099501209969056","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-11-06 14:39:26', NULL, ''),
(1224, 'lois', '{"sale":{"id":"14384","txn_no":null,"table_no":"TEST","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-11-06 15:34:51","payment_status":"Unpaid","cost":null,"subtotal":"48.00","amount":"52.80","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1509929750","discount_type":"d","discount":"0","payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"55310","date":"2017-11-06 15:35:03","ss_terminal":null,"ss_code":null,"sale_id":"14384","si_item_id":"0","item_id":"192","item_sku":"127","item_name":"Flaming Hot & Spicy Pork","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 15:35:03","serial":"admin-1509929750-1509953702927264","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55309","date":"2017-11-06 15:35:03","ss_terminal":null,"ss_code":null,"sale_id":"14384","si_item_id":"0","item_id":"294","item_sku":"230","item_name":"Double Fry Salted Pork","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 15:35:03","serial":"admin-1509929750-1509953702927264","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55308","date":"2017-11-06 15:35:03","ss_terminal":null,"ss_code":null,"sale_id":"14384","si_item_id":"0","item_id":"70","item_sku":"70","item_name":"Borneo Pepper Pork","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 15:35:03","serial":"admin-1509929750-1509953702927264","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55307","date":"2017-11-06 15:34:51","ss_terminal":null,"ss_code":null,"sale_id":"14384","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"4.80","margin":"0.0000","cost":"0.0000","amount":"4.80","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-06 15:34:51","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-11-06 15:42:21', NULL, ''),
(1225, 'lois', '{"void_item":{"id":"55364","date":"2017-11-08 13:33:50","ss_terminal":null,"ss_code":null,"sale_id":"14398","si_item_id":"0","item_id":"288","item_sku":"222","item_name":"Smoked Duck Pesto Pasta","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"23.00","margin":"23.0000","cost":"0.0000","amount":"23.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-08 13:33:50","serial":"admin-1510103209-15101192298604524","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-08 13:58:33', NULL, ''),
(1226, 'lois', '{"void_item":{"id":"55429","date":"2017-11-09 11:49:40","ss_terminal":null,"ss_code":null,"sale_id":"14412","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"pan fried dumpling","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-09 11:49:40","serial":"admin-1510195264-15101993799906229","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-09 12:06:30', NULL, ''),
(1227, 'sanni', '{"sale":{"id":"14420","txn_no":null,"table_no":"T10","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-11-09 15:05:51","payment_status":"Unpaid","cost":null,"subtotal":"9.00","amount":"-0.10","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":"10.00","adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1510195264","discount_type":"d","discount":"10","payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"55464","date":"2017-11-09 15:05:51","ss_terminal":null,"ss_code":null,"sale_id":"14420","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.90","margin":"0.0000","cost":"0.0000","amount":"0.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-09 15:05:51","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55465","date":"2017-11-09 15:05:56","ss_terminal":null,"ss_code":null,"sale_id":"14420","si_item_id":"0","item_id":"28","item_sku":"28","item_name":"Iced Honey Milk","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-09 15:05:56","serial":"admin-1510195264-15102111566378845","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-11-09 16:57:31', NULL, ''),
(1228, 'lois', '{"void_item":{"id":"55516","date":"2017-11-10 11:40:08","ss_terminal":null,"ss_code":null,"sale_id":"14431","si_item_id":"0","item_id":"298","item_sku":"234","item_name":"Salted Caramel Machiato","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-10 11:40:08","serial":"admin-1510276265-15102852077501686","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-10 12:22:16', NULL, ''),
(1229, 'sanni', '{"void_item":{"id":"55570","date":"2017-11-11 09:28:01","ss_terminal":null,"ss_code":null,"sale_id":"14446","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-11 09:28:01","serial":"admin-1510362498-15103636809439529","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-11 09:29:46', NULL, ''),
(1230, 'lois', '{"void_item":{"id":"55569","date":"2017-11-11 09:28:01","ss_terminal":null,"ss_code":null,"sale_id":"14446","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-11 09:28:01","serial":"admin-1510362498-15103636809439529","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-11 09:34:03', NULL, ''),
(1231, 'sanni', '{"void_item":{"id":"55602","date":"2017-11-11 10:28:53","ss_terminal":null,"ss_code":null,"sale_id":"14452","si_item_id":"0","item_id":"267","item_sku":"201","item_name":"Cocoa Cappucino","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-11 10:28:53","serial":"admin-1510362498-15103673328894133","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-11 10:37:51', NULL, ''),
(1232, 'sanni', '{"void_item":{"id":"55614","date":"2017-11-11 10:41:09","ss_terminal":null,"ss_code":null,"sale_id":"14454","si_item_id":null,"item_id":"68","item_sku":"68","item_name":"Mix 2 types ","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-11 10:41:09","serial":"admin-1510362498-1510368069703439","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-11 10:47:14', NULL, ''),
(1233, 'lois', '{"void_item":{"id":"55667","date":"2017-11-11 13:43:50","ss_terminal":null,"ss_code":null,"sale_id":"14465","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"add marmite 8pcs","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-11 13:43:50","serial":"admin-1510362498-15103790303946411","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-11 13:44:11', NULL, ''),
(1234, 'sanni', '{"void_item":{"id":"55730","date":"2017-11-12 09:36:54","ss_terminal":null,"ss_code":null,"sale_id":"14472","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-12 09:36:54","serial":"admin-1510449408-151045061438148","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-12 09:38:36', NULL, ''),
(1235, 'sanni', '{"void_item":{"id":"55845","date":"2017-11-12 12:03:41","ss_terminal":null,"ss_code":null,"sale_id":"14493","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-12 12:03:41","serial":"admin-1510449408-15104594213101183","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-12 12:16:10', NULL, ''),
(1236, 'lois', '{"sale":{"id":"14489","txn_no":"114013","table_no":"T14","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-11-12 11:58:03","payment_status":"Paid","cost":null,"subtotal":"46.00","amount":"50.60","amount_cash":"50.60","amount_cc":null,"amount_tendered":"101.00","amount_change":"50.40","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1510449408","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"55829","date":"2017-11-12 11:33:18","ss_terminal":null,"ss_code":null,"sale_id":"14489","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"4.60","margin":"0.0000","cost":"0.0000","amount":"4.60","sold":"1","terminal":"27","printed":"1","session":"1510449408","ordered_by":"admin","ordered_time":"2017-11-12 11:33:18","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"55832","date":"2017-11-12 11:33:32","ss_terminal":null,"ss_code":null,"sale_id":"14489","si_item_id":"0","item_id":"184","item_sku":"119","item_name":"Flat White","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1510449408","ordered_by":"admin","ordered_time":"2017-11-12 11:33:32","serial":"admin-1510449408-1510457612162546","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55831","date":"2017-11-12 11:33:32","ss_terminal":null,"ss_code":null,"sale_id":"14489","si_item_id":"0","item_id":"158","item_sku":"92","item_name":"Banana Stuffed Nutella Toast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1510449408","ordered_by":"admin","ordered_time":"2017-11-12 11:33:32","serial":"admin-1510449408-1510457612162546","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"55830","date":"2017-11-12 11:33:32","ss_terminal":null,"ss_code":null,"sale_id":"14489","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":"1","terminal":"27","printed":"1","session":"1510449408","ordered_by":"admin","ordered_time":"2017-11-12 11:33:32","serial":"admin-1510449408-1510457612162546","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-11-12 12:48:40', 1, ''),
(1237, 'lois', '{"void_item":{"id":"55923","date":"2017-11-12 15:36:28","ss_terminal":null,"ss_code":null,"sale_id":"14511","si_item_id":"0","item_id":"61","item_sku":"61","item_name":"Slim Fit","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-12 15:36:28","serial":"admin-1510449408-15104721886358510","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-12 15:52:14', NULL, ''),
(1238, 'lois', '{"void_item":{"id":"55958","date":"2017-11-13 13:38:17","ss_terminal":null,"ss_code":null,"sale_id":"14523","si_item_id":"0","item_id":"192","item_sku":"127","item_name":"Flaming Hot & Spicy Pork","item_option":"Add rice","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-13 13:38:17","serial":"admin-1510535091-15105514976996770","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-13 14:37:51', NULL, ''),
(1239, 'lois', '{"void_item":{"id":"55994","date":"2017-11-15 10:29:41","ss_terminal":null,"ss_code":null,"sale_id":"14530","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-15 10:29:41","serial":"admin-1510707861-15107129816917731","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-15 10:35:09', NULL, ''),
(1240, 'lois', '{"void_item":{"id":"55993","date":"2017-11-15 10:29:41","ss_terminal":null,"ss_code":null,"sale_id":"14530","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-15 10:29:41","serial":"admin-1510707861-15107129816917731","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-15 10:35:16', NULL, ''),
(1241, 'lois', '{"void_item":{"id":"56043","date":"2017-11-15 14:30:03","ss_terminal":null,"ss_code":null,"sale_id":"14539","si_item_id":"0","item_id":"229","item_sku":"163","item_name":"Mummy''s Pasta","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-15 14:30:03","serial":"admin-1510707861-15107274032557349","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-15 14:30:13', NULL, ''),
(1242, 'lois', '{"void_item":{"id":"56333","date":"2017-11-18 12:59:45","ss_terminal":null,"ss_code":null,"sale_id":"14598","si_item_id":"0","item_id":"272","item_sku":"206","item_name":"Genius in The Bowl","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-18 12:59:45","serial":"admin-1510967819-1510981185148175","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-18 13:01:09', NULL, ''),
(1243, 'sanni', '{"void_item":{"id":"56598","date":"2017-11-19 14:30:53","ss_terminal":null,"ss_code":null,"sale_id":"14655","si_item_id":"0","item_id":"42","item_sku":"42","item_name":"Passion Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-19 14:30:53","serial":"admin-1511052202-1511073053522378","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-19 14:32:57', NULL, ''),
(1244, 'lois', '{"void_item":{"id":"56680","date":"2017-11-20 12:39:16","ss_terminal":null,"ss_code":null,"sale_id":"14671","si_item_id":"0","item_id":"211","item_sku":"145","item_name":"Asian Spicy Lemony Chicken","item_option":"no rice","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"28.00","margin":"28.0000","cost":"0.0000","amount":"28.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-20 12:39:16","serial":"admin-1511139560-15111527564681522","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-20 12:52:54', NULL, ''),
(1245, 'sanni', '{"sale":{"id":"14682","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-11-22 11:50:57","payment_status":"Unpaid","cost":null,"subtotal":"12.00","amount":"2.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":"10.00","adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1511312483","discount_type":"d","discount":"10","payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"56726","date":"2017-11-22 11:51:03","ss_terminal":null,"ss_code":null,"sale_id":"14682","si_item_id":"0","item_id":"15","item_sku":"15","item_name":"Iced Latte ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-22 11:51:03","serial":"admin-1511312483-15113226633343310","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-11-22 11:53:50', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(1246, 'sanni', '{"sale":{"id":"14730","txn_no":"114253","table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-11-25 10:55:29","payment_status":"Paid","cost":null,"subtotal":"44.00","amount":"48.40","amount_cash":"48.40","amount_cc":null,"amount_tendered":"50.00","amount_change":"1.60","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1511570825","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"56894","date":"2017-11-25 10:11:02","ss_terminal":null,"ss_code":null,"sale_id":"14730","si_item_id":null,"item_id":"67","item_sku":"67","item_name":"Carrot milk","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1511570825","ordered_by":"admin","ordered_time":"2017-11-25 10:11:02","serial":"admin-1511570825-15115758622272078","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"56893","date":"2017-11-25 10:10:54","ss_terminal":null,"ss_code":null,"sale_id":"14730","si_item_id":"0","item_id":"212","item_sku":"146","item_name":"Pork Bacon Salad","item_option":"","category":"Meals","subcategory":"Salad","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":"1","terminal":"27","printed":"1","session":"1511570825","ordered_by":"admin","ordered_time":"2017-11-25 10:10:54","serial":"admin-1511570825-15115758540124073","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"56892","date":"2017-11-25 10:10:54","ss_terminal":null,"ss_code":null,"sale_id":"14730","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":"1","terminal":"27","printed":"1","session":"1511570825","ordered_by":"admin","ordered_time":"2017-11-25 10:10:54","serial":"admin-1511570825-15115758540124073","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"56891","date":"2017-11-25 10:10:43","ss_terminal":null,"ss_code":null,"sale_id":"14730","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"4.40","margin":"0.0000","cost":"0.0000","amount":"4.40","sold":"1","terminal":"27","printed":"1","session":"1511570825","ordered_by":"admin","ordered_time":"2017-11-25 10:10:43","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-11-25 11:02:44', 1, ''),
(1247, 'sanni', '{"void_item":{"id":"56949","date":"2017-11-25 10:54:29","ss_terminal":null,"ss_code":null,"sale_id":"14740","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-25 10:54:29","serial":"admin-1511570825-15115784694037417","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-25 11:29:25', NULL, ''),
(1248, 'sanni', '{"void_item":{"id":"56997","date":"2017-11-25 13:05:16","ss_terminal":null,"ss_code":null,"sale_id":"14749","si_item_id":"0","item_id":"290","item_sku":"224","item_name":"Seasoned Chicken Red Pasta","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-25 13:05:16","serial":"admin-1511570825-15115863164242076","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-25 13:18:39', NULL, ''),
(1249, 'sanni', '{"void_item":{"id":"56999","date":"2017-11-25 13:05:34","ss_terminal":null,"ss_code":null,"sale_id":"14749","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-25 13:05:34","serial":"admin-1511570825-1511586334488357","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-25 13:18:56', NULL, ''),
(1250, 'lois', '{"void_item":{"id":"57158","date":"2017-11-26 10:55:54","ss_terminal":null,"ss_code":null,"sale_id":"14780","si_item_id":"0","item_id":"243","item_sku":"177","item_name":"Hot Ginger Lemongrass","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-26 10:55:54","serial":"admin-1511656639-15116649541452075","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-26 11:47:14', NULL, ''),
(1251, 'sanni', '{"void_item":{"id":"57210","date":"2017-11-26 12:21:34","ss_terminal":null,"ss_code":null,"sale_id":"14790","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-26 12:21:34","serial":"admin-1511656639-15116700948286499","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-26 12:25:02', NULL, ''),
(1252, 'lois', '{"void_item":{"id":"57272","date":"2017-11-26 14:12:23","ss_terminal":null,"ss_code":null,"sale_id":"14801","si_item_id":"0","item_id":"286","item_sku":"220","item_name":"Joyous Sunny","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-26 14:12:23","serial":"admin-1511656639-15116767435254296","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-26 14:13:06', NULL, ''),
(1253, 'sanni', '{"sale":{"id":"14811","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-11-26 16:48:22","payment_status":"Unpaid","cost":null,"subtotal":"38.00","amount":"38.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1511656639","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"57298","date":"2017-11-26 16:48:35","ss_terminal":null,"ss_code":null,"sale_id":"14811","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"coffee beans","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"38.00","margin":"38.0000","cost":"0.0000","amount":"38.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-26 16:48:35","serial":"admin-1511656639-15116861153948833","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-11-26 16:56:57', NULL, ''),
(1254, 'sanni', '{"void_item":{"id":"57311","date":"2017-11-27 09:08:24","ss_terminal":null,"ss_code":null,"sale_id":"14816","si_item_id":null,"item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"7.00","margin":"7.0000","cost":"0.0000","amount":"7.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-27 09:08:24","serial":"admin-1511744410-15117449038472870","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-27 10:02:30', NULL, ''),
(1255, 'lois', '{"void_item":{"id":"57426","date":"2017-11-27 14:22:59","ss_terminal":null,"ss_code":null,"sale_id":"14839","si_item_id":"0","item_id":"210","item_sku":"144","item_name":"Red Riding Hood","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-27 14:22:59","serial":"admin-1511744410-15117637796236649","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-27 14:24:43', NULL, ''),
(1256, 'lois', '{"void_item":{"id":"57544","date":"2017-11-29 12:52:59","ss_terminal":null,"ss_code":null,"sale_id":"14863","si_item_id":"0","item_id":"70","item_sku":"70","item_name":"Borneo Pepper Pork","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-29 12:52:59","serial":"admin-1511917899-15119311795031328","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-29 12:56:02', NULL, ''),
(1257, 'lois', '{"void_item":{"id":"57543","date":"2017-11-29 12:52:59","ss_terminal":null,"ss_code":null,"sale_id":"14863","si_item_id":"0","item_id":"70","item_sku":"70","item_name":"Borneo Pepper Pork","item_option":"1 salad change to potato","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-29 12:52:59","serial":"admin-1511917899-15119311795031328","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-29 12:56:09', NULL, ''),
(1258, 'sanni', '{"void_item":{"id":"57602","date":"2017-11-30 12:28:48","ss_terminal":null,"ss_code":null,"sale_id":"14875","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-30 12:28:48","serial":"admin-1512004065-15120161279104196","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-30 12:43:27', NULL, ''),
(1259, 'lois', '{"sale":{"id":"14875","txn_no":"114394","table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-11-30 12:59:11","payment_status":"Paid","cost":null,"subtotal":"27.00","amount":"29.70","amount_cash":"29.70","amount_cc":null,"amount_tendered":"50.00","amount_change":"20.30","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1512017420","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"57613","date":"2017-11-30 12:43:54","ss_terminal":null,"ss_code":null,"sale_id":"14875","si_item_id":"0","item_id":"158","item_sku":"92","item_name":"Banana Stuffed Nutella Toast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1512017420","ordered_by":"admin","ordered_time":"2017-11-30 12:43:54","serial":"admin-1512004065-15120170343979749","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"57600","date":"2017-11-30 12:28:23","ss_terminal":null,"ss_code":null,"sale_id":"14875","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.70","margin":"0.0000","cost":"0.0000","amount":"2.70","sold":"1","terminal":"27","printed":"1","session":"1512017420","ordered_by":"admin","ordered_time":"2017-11-30 12:28:23","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"57601","date":"2017-11-30 12:28:48","ss_terminal":null,"ss_code":null,"sale_id":"14875","si_item_id":"0","item_id":"321","item_sku":"257","item_name":"AA Set - Genius In the Bowl","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":"1","terminal":"27","printed":"1","session":"1512017420","ordered_by":"admin","ordered_time":"2017-11-30 12:28:48","serial":"admin-1512004065-15120161279104196","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-11-30 12:59:24', 1, ''),
(1260, 'lois', '{"void_item":{"id":"57630","date":"2017-11-30 13:03:44","ss_terminal":null,"ss_code":null,"sale_id":"14879","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.30","margin":"0.0000","cost":"0.0000","amount":"1.30","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-30 13:03:44","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-11-30 13:34:00', NULL, ''),
(1261, 'sanni', '{"sale":{"id":"14874","txn_no":null,"table_no":"T3(S)","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-11-30 12:12:19","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1512004065","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"57594","date":"2017-11-30 12:12:19","ss_terminal":null,"ss_code":null,"sale_id":"14874","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-11-30 12:12:19","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-11-30 14:01:20', NULL, ''),
(1262, 'lois', '{"void_item":{"id":"57808","date":"2017-12-02 09:58:32","ss_terminal":null,"ss_code":null,"sale_id":"14924","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-02 09:58:32","serial":"admin-1512176007-15121799119667152","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-02 09:58:53', NULL, ''),
(1263, 'lois', '{"sale":{"id":"14928","txn_no":null,"table_no":"T7(S)","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-12-02 10:13:02","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1512176007","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"57823","date":"2017-12-02 10:13:02","ss_terminal":null,"ss_code":null,"sale_id":"14928","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-02 10:13:02","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-12-02 13:39:32', NULL, ''),
(1264, 'sanni', '{"void_item":{"id":"57979","date":"2017-12-02 14:49:05","ss_terminal":null,"ss_code":null,"sale_id":"14964","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-02 14:49:05","serial":"admin-1512176007-1512197344998224","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-02 14:54:53', NULL, ''),
(1265, 'sanni', '{"void_item":{"id":"58078","date":"2017-12-03 11:01:55","ss_terminal":null,"ss_code":null,"sale_id":"14982","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-03 11:01:55","serial":"admin-1512262587-15122701154073310","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-03 11:13:42', NULL, ''),
(1266, 'sanni', '{"void_item":{"id":"58100","date":"2017-12-03 11:45:03","ss_terminal":null,"ss_code":null,"sale_id":"14981","si_item_id":"0","item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-03 11:45:03","serial":"admin-1512262587-15122727030649591","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-03 11:53:34', NULL, ''),
(1267, 'sanni', '{"void_item":{"id":"58102","date":"2017-12-03 11:56:34","ss_terminal":null,"ss_code":null,"sale_id":"14971","si_item_id":"0","item_id":"192","item_sku":"127","item_name":"Flaming Hot & Spicy Pork","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-03 11:56:34","serial":"admin-1512262587-15122733944823520","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-03 12:37:26', NULL, ''),
(1268, 'sanni', '{"void_item":{"id":"58103","date":"2017-12-03 11:56:34","ss_terminal":null,"ss_code":null,"sale_id":"14971","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-03 11:56:34","serial":"admin-1512262587-15122733944823520","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-03 12:37:38', NULL, ''),
(1269, 'sanni', '{"void_item":{"id":"58164","date":"2017-12-03 12:55:59","ss_terminal":null,"ss_code":null,"sale_id":"14987","si_item_id":null,"item_id":"10","item_sku":"10","item_name":"Dirty Chai","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-03 12:55:59","serial":"admin-1512262587-1512276959185318","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-03 12:57:57', NULL, ''),
(1270, 'sanni', '{"void_item":{"id":"58163","date":"2017-12-03 12:55:59","ss_terminal":null,"ss_code":null,"sale_id":"14987","si_item_id":null,"item_id":"62","item_sku":"62","item_name":"Orange","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-03 12:55:59","serial":"admin-1512262587-1512276959185318","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-03 12:58:05', NULL, ''),
(1271, 'sanni', '{"void_item":{"id":"58161","date":"2017-12-03 12:55:59","ss_terminal":null,"ss_code":null,"sale_id":"14987","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-03 12:55:59","serial":"admin-1512262587-1512276959185318","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-03 12:58:13', NULL, ''),
(1272, 'sanni', '{"void_item":{"id":"58158","date":"2017-12-03 12:55:59","ss_terminal":null,"ss_code":null,"sale_id":"14987","si_item_id":null,"item_id":"68","item_sku":"68","item_name":"Mix 2 types ","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-03 12:55:59","serial":"admin-1512262587-1512276959185318","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-03 12:58:20', NULL, ''),
(1273, 'sanni', '{"void_item":{"id":"58159","date":"2017-12-03 12:55:59","ss_terminal":null,"ss_code":null,"sale_id":"14987","si_item_id":null,"item_id":"67","item_sku":"67","item_name":"Carrot milk","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-03 12:55:59","serial":"admin-1512262587-1512276959185318","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-03 12:58:28', NULL, ''),
(1274, 'sanni', '{"void_item":{"id":"58160","date":"2017-12-03 12:55:59","ss_terminal":null,"ss_code":null,"sale_id":"14987","si_item_id":null,"item_id":"64","item_sku":"64","item_name":"Green Apple","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-03 12:55:59","serial":"admin-1512262587-1512276959185318","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-03 12:58:35', NULL, ''),
(1275, 'sanni', '{"void_item":{"id":"58162","date":"2017-12-03 12:55:59","ss_terminal":null,"ss_code":null,"sale_id":"14987","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-03 12:55:59","serial":"admin-1512262587-1512276959185318","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-03 12:58:43', NULL, ''),
(1276, 'lois', '{"void_item":{"id":"58256","date":"2017-12-03 15:25:01","ss_terminal":null,"ss_code":null,"sale_id":"15016","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"Chocolate ice cream","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-03 15:25:01","serial":"admin-1512276983-1512285901429915","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-03 15:26:39', NULL, ''),
(1277, 'lois', '{"void_item":{"id":"58255","date":"2017-12-03 15:25:01","ss_terminal":null,"ss_code":null,"sale_id":"15016","si_item_id":"0","item_id":"302","item_sku":"238","item_name":"Ice on the cake","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-03 15:25:01","serial":"admin-1512276983-1512285901429915","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-03 15:26:46', NULL, ''),
(1278, 'lois', '{"void_item":{"id":"58372","date":"2017-12-04 14:28:32","ss_terminal":null,"ss_code":null,"sale_id":"15042","si_item_id":"0","item_id":"184","item_sku":"119","item_name":"Flat White","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-04 14:28:32","serial":"admin-1512348404-1512368912363835","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-04 14:57:38', NULL, ''),
(1279, 'lois', '{"void_item":{"id":"58394","date":"2017-12-06 09:21:53","ss_terminal":null,"ss_code":null,"sale_id":"15049","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"small BLT","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-06 09:21:53","serial":"admin-1512522216-1512523313635995","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-06 09:22:39', NULL, ''),
(1280, 'sanni', '{"void_item":{"id":"58396","date":"2017-12-06 09:22:52","ss_terminal":null,"ss_code":null,"sale_id":"15049","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"small BLT","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-06 09:22:52","serial":"admin-1512522216-15125233721787918","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-06 09:23:27', NULL, ''),
(1281, 'sanni', '{"void_item":{"id":"58431","date":"2017-12-06 12:00:14","ss_terminal":null,"ss_code":null,"sale_id":"15057","si_item_id":"0","item_id":"320","item_sku":"256","item_name":"AA Set - Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-06 12:00:14","serial":"admin-1512522216-15125328138878547","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-06 12:03:23', NULL, ''),
(1282, 'lois', '{"void_item":{"id":"58438","date":"2017-12-06 12:21:43","ss_terminal":null,"ss_code":null,"sale_id":"15057","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"Boil egg now","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-06 12:21:43","serial":"admin-1512522216-15125341030626478","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-06 12:21:52', NULL, ''),
(1283, 'lois', '{"void_item":{"id":"58445","date":"2017-12-06 12:50:49","ss_terminal":null,"ss_code":null,"sale_id":"15060","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"come to eat","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-06 12:50:49","serial":"admin-1512522216-15125358494428765","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-06 12:50:57', NULL, ''),
(1284, 'sanni', '{"sale":{"id":"15067","txn_no":null,"table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-12-06 14:14:19","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1512522216","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"58472","date":"2017-12-06 14:14:19","ss_terminal":null,"ss_code":null,"sale_id":"15067","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-06 14:14:19","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-12-06 14:15:35', NULL, ''),
(1285, 'sanni', '{"sale":{"id":"15073","txn_no":null,"table_no":"T1","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-12-07 09:09:13","payment_status":"Unpaid","cost":null,"subtotal":"42.00","amount":"46.20","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1512607716","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"58487","date":"2017-12-07 09:12:43","ss_terminal":null,"ss_code":null,"sale_id":"15073","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-07 09:12:43","serial":"admin-1512607716-15126091633353424","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"58488","date":"2017-12-07 09:12:43","ss_terminal":null,"ss_code":null,"sale_id":"15073","si_item_id":"0","item_id":"276","item_sku":"210","item_name":"Penang Craft Beer","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-07 09:12:43","serial":"admin-1512607716-15126091633353424","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"58486","date":"2017-12-07 09:09:13","ss_terminal":null,"ss_code":null,"sale_id":"15073","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"4.20","margin":"0.0000","cost":"0.0000","amount":"4.20","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-07 09:09:13","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-12-07 09:25:32', NULL, ''),
(1286, 'sanni', '{"void_item":{"id":"58509","date":"2017-12-07 10:32:39","ss_terminal":null,"ss_code":null,"sale_id":"15078","si_item_id":"0","item_id":"32","item_sku":"32","item_name":"Tea By Pot ","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-07 10:32:39","serial":"admin-1512607716-15126139591077565","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-07 10:36:23', NULL, ''),
(1287, 'lois', '{"void_item":{"id":"58538","date":"2017-12-07 13:19:49","ss_terminal":null,"ss_code":null,"sale_id":"15086","si_item_id":"0","item_id":"156","item_sku":"90","item_name":"House Cheddar Omelet","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-07 13:19:49","serial":"admin-1512607716-15126239891934762","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-07 13:26:35', NULL, ''),
(1288, 'lois', '{"sale":{"id":"15101","txn_no":null,"table_no":"T5","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-12-08 11:44:57","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1512694546","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"58604","date":"2017-12-08 11:44:57","ss_terminal":null,"ss_code":null,"sale_id":"15101","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-08 11:44:57","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-12-08 12:39:40', NULL, ''),
(1289, 'sanni', '{"sale":{"id":"15127","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-12-09 10:24:52","payment_status":"Unpaid","cost":null,"subtotal":"60.00","amount":"60.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1512781827","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"58712","date":"2017-12-09 10:25:05","ss_terminal":null,"ss_code":null,"sale_id":"15127","si_item_id":"0","item_id":"286","item_sku":"220","item_name":"Joyous Sunny","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-09 10:25:05","serial":"admin-1512781827-15127863053725442","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null},{"id":"58710","date":"2017-12-09 10:25:05","ss_terminal":null,"ss_code":null,"sale_id":"15127","si_item_id":"0","item_id":"286","item_sku":"220","item_name":"Joyous Sunny","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-09 10:25:05","serial":"admin-1512781827-15127863053725442","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null},{"id":"58711","date":"2017-12-09 10:25:05","ss_terminal":null,"ss_code":null,"sale_id":"15127","si_item_id":"0","item_id":"286","item_sku":"220","item_name":"Joyous Sunny","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-09 10:25:05","serial":"admin-1512781827-15127863053725442","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-12-09 10:25:16', NULL, ''),
(1290, 'sanni', '{"void_item":{"id":"58767","date":"2017-12-09 11:48:40","ss_terminal":null,"ss_code":null,"sale_id":"15129","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"double salted pork","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-09 11:48:40","serial":"admin-1512781827-15127913201044361","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-09 12:47:44', NULL, ''),
(1291, 'sanni', '{"void_item":{"id":"58802","date":"2017-12-09 12:49:12","ss_terminal":null,"ss_code":null,"sale_id":"15146","si_item_id":"0","item_id":"302","item_sku":"238","item_name":"Ice on the cake","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-09 12:49:12","serial":"admin-1512781827-15127949525221756","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-09 12:56:57', NULL, ''),
(1292, 'sanni', '{"void_item":{"id":"58862","date":"2017-12-09 14:53:30","ss_terminal":null,"ss_code":null,"sale_id":"15157","si_item_id":"0","item_id":"294","item_sku":"230","item_name":"Double Fry Salted Pork","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-09 14:53:30","serial":"admin-1512802134-15128024103289411","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-09 14:57:29', NULL, ''),
(1293, 'sanni', '{"void_item":{"id":"58886","date":"2017-12-09 15:38:24","ss_terminal":null,"ss_code":null,"sale_id":"15160","si_item_id":"0","item_id":"76","item_sku":"76","item_name":"Meatless Pesto Pasta","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-09 15:38:24","serial":"admin-1512802134-1512805104561419","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-09 15:39:20', NULL, ''),
(1294, 'sanni', '{"sale":{"id":"15166","txn_no":null,"table_no":"T6","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-12-09 17:08:30","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1512802134","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"58912","date":"2017-12-09 17:08:30","ss_terminal":null,"ss_code":null,"sale_id":"15166","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-09 17:08:30","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-12-09 17:37:21', NULL, ''),
(1295, 'sanni', '{"void_item":{"id":"58944","date":"2017-12-10 10:11:24","ss_terminal":null,"ss_code":null,"sale_id":"15173","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"Classic French Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-10 10:11:24","serial":"admin-1512867626-15128718840476830","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-10 10:24:38', NULL, ''),
(1296, 'sanni', '{"void_item":{"id":"58975","date":"2017-12-10 11:09:14","ss_terminal":null,"ss_code":null,"sale_id":"15179","si_item_id":"0","item_id":"159","item_sku":"228","item_name":"Yuzu Marmalade Yogurt Bowl","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-10 11:09:14","serial":"admin-1512867626-15128753540663879","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-10 11:30:32', NULL, ''),
(1297, 'lois', '{"void_item":{"id":"58990","date":"2017-12-10 11:30:58","ss_terminal":null,"ss_code":null,"sale_id":"15179","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-10 11:30:58","serial":"admin-1512867626-15128766584144564","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-10 11:32:08', NULL, ''),
(1298, 'lois', '{"void_item":{"id":"59023","date":"2017-12-10 12:40:55","ss_terminal":null,"ss_code":null,"sale_id":"15187","si_item_id":"0","item_id":"325","item_sku":"261","item_name":"Strawberry Chocolate Smoothie","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-10 12:40:55","serial":"admin-1512867626-15128808548209017","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-10 13:22:16', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(1299, 'lois', '{"sale":{"id":"15197","txn_no":"114703","table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-12-10 14:06:11","payment_status":"Paid","cost":null,"subtotal":"52.00","amount":"57.20","amount_cash":"57.20","amount_cc":null,"amount_tendered":"60.20","amount_change":"3.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1512867626","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"59059","date":"2017-12-10 13:57:49","ss_terminal":null,"ss_code":null,"sale_id":"15197","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"5.20","margin":"0.0000","cost":"0.0000","amount":"5.20","sold":"1","terminal":"27","printed":"1","session":"1512867626","ordered_by":"admin","ordered_time":"2017-12-10 13:57:49","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"59060","date":"2017-12-10 13:57:52","ss_terminal":null,"ss_code":null,"sale_id":"15197","si_item_id":"0","item_id":"334","item_sku":"270","item_name":"Honey Latte","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1512867626","ordered_by":"admin","ordered_time":"2017-12-10 13:57:52","serial":"admin-1512867626-15128854726218329","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"59063","date":"2017-12-10 14:05:48","ss_terminal":null,"ss_code":null,"sale_id":"15197","si_item_id":null,"item_id":"12","item_sku":"12","item_name":"DD Special","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1512867626","ordered_by":"admin","ordered_time":"2017-12-10 14:05:48","serial":"admin-1512867626-15128859485633264","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"59064","date":"2017-12-10 14:05:48","ss_terminal":null,"ss_code":null,"sale_id":"15197","si_item_id":"0","item_id":"24","item_sku":"24","item_name":"Chai Latte","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":"1","terminal":"27","printed":"1","session":"1512867626","ordered_by":"admin","ordered_time":"2017-12-10 14:05:48","serial":"admin-1512867626-15128859485633264","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"59061","date":"2017-12-10 14:00:30","ss_terminal":null,"ss_code":null,"sale_id":"15197","si_item_id":"0","item_id":"298","item_sku":"234","item_name":"Salted Caramel Latte","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1512867626","ordered_by":"admin","ordered_time":"2017-12-10 14:00:30","serial":"admin-1512867626-15128856306526166","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-12-10 14:07:04', 1, ''),
(1300, 'lois', '{"void_item":{"id":"59063","date":"2017-12-10 14:05:48","ss_terminal":null,"ss_code":null,"sale_id":"15197","si_item_id":null,"item_id":"12","item_sku":"12","item_name":"DD Special","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1512867626","ordered_by":"admin","ordered_time":"2017-12-10 14:05:48","serial":"admin-1512867626-15128859485633264","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-10 14:07:15', NULL, ''),
(1301, 'sanni', '{"void_item":{"id":"59078","date":"2017-12-10 15:01:13","ss_terminal":null,"ss_code":null,"sale_id":"15200","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-10 15:01:13","serial":"admin-1512867626-15128892733228460","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-10 15:42:35', NULL, ''),
(1302, 'sanni', '{"sale":{"id":"15209","txn_no":"114729","table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-12-11 12:54:48","payment_status":"Paid","cost":null,"subtotal":"10.00","amount":"9.00","amount_cash":"9.00","amount_cc":null,"amount_tendered":"20.00","amount_change":"11.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":"1.00","adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1512954184","discount_type":"p","discount":"10","payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"59105","date":"2017-12-11 10:36:07","ss_terminal":null,"ss_code":null,"sale_id":"15209","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"bacon,eggs,sosej","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1512954184","ordered_by":"admin","ordered_time":"2017-12-11 10:36:07","serial":"admin-1512954184-15129597671339781","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":"10.0"}]}', '2017-12-11 12:55:16', 1, ''),
(1303, 'sanni', '{"sale":{"id":"15209","txn_no":"114729","table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-12-11 12:54:48","payment_status":"Unpaid","cost":null,"subtotal":"10.00","amount":"9.00","amount_cash":"9.00","amount_cc":null,"amount_tendered":"20.00","amount_change":"11.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":"1.00","adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1512954184","discount_type":"p","discount":"10","payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"59105","date":"2017-12-11 10:36:07","ss_terminal":null,"ss_code":null,"sale_id":"15209","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"bacon,eggs,sosej","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1512954184","ordered_by":"admin","ordered_time":"2017-12-11 10:36:07","serial":"admin-1512954184-15129597671339781","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":"10.0"}]}', '2017-12-11 12:55:29', NULL, ''),
(1304, 'lois', '{"void_item":{"id":"59161","date":"2017-12-11 13:54:56","ss_terminal":null,"ss_code":null,"sale_id":"15225","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"Table 3 change to T6","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-11 13:54:56","serial":"admin-1512954184-15129716960436986","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-11 14:24:02', NULL, ''),
(1305, 'sanni', '{"void_item":{"id":"59190","date":"2017-12-13 12:55:46","ss_terminal":null,"ss_code":null,"sale_id":"15236","si_item_id":"0","item_id":"292","item_sku":"227","item_name":"Pork Bacon Aglio Olio","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-13 12:55:46","serial":"admin-1513127221-15131409458342484","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-13 12:56:57', NULL, ''),
(1306, 'sanni', '{"void_item":{"id":"59189","date":"2017-12-13 12:55:46","ss_terminal":null,"ss_code":null,"sale_id":"15236","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-13 12:55:46","serial":"admin-1513127221-15131409458342484","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-13 13:09:08', NULL, ''),
(1307, 'lois', '{"void_item":{"id":"59210","date":"2017-12-13 13:43:42","ss_terminal":null,"ss_code":null,"sale_id":"15240","si_item_id":"0","item_id":"38","item_sku":"38","item_name":"Mixed Berries Smoothie","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-13 13:43:42","serial":"admin-1513127221-15131438227601139","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-13 13:44:29', NULL, ''),
(1308, 'sanni', '{"void_item":{"id":"59285","date":"2017-12-14 13:40:51","ss_terminal":null,"ss_code":null,"sale_id":"15259","si_item_id":"0","item_id":"210","item_sku":"144","item_name":"Red Riding Hood","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-14 13:40:51","serial":"admin-1513212408-15132300516605924","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-14 13:44:01', NULL, ''),
(1309, 'lois', '{"void_item":{"id":"59429","date":"2017-12-16 10:15:32","ss_terminal":null,"ss_code":null,"sale_id":"15292","si_item_id":"0","item_id":"333","item_sku":"269","item_name":"Morning Omelette","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-16 10:15:32","serial":"admin-1513386801-15133905324967377","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-16 10:16:54', NULL, ''),
(1310, 'lois', '{"void_item":{"id":"59541","date":"2017-12-16 15:00:39","ss_terminal":null,"ss_code":null,"sale_id":"15313","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"huey ying go to buy coconut","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-16 15:00:39","serial":"admin-1513386801-15134076395402882","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-16 15:00:46', NULL, ''),
(1311, 'sanni', '{"void_item":{"id":"59565","date":"2017-12-16 16:41:53","ss_terminal":null,"ss_code":null,"sale_id":"15321","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":" i will go once i finishe my coconut,pls dun miss me","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-16 16:41:53","serial":"admin-1513386801-15134137136715924","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-17 09:49:13', NULL, ''),
(1312, 'sanni', '{"void_item":{"id":"59599","date":"2017-12-17 10:01:27","ss_terminal":null,"ss_code":null,"sale_id":"15327","si_item_id":null,"item_id":"1","item_sku":"1","item_name":"Espresso","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-17 10:01:27","serial":"admin-1513470685-15134760872164743","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-17 10:05:26', NULL, ''),
(1313, 'lois', '{"void_item":{"id":"59841","date":"2017-12-18 18:05:02","ss_terminal":null,"ss_code":null,"sale_id":"15389","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.40","margin":"0.0000","cost":"0.0000","amount":"1.40","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-18 18:05:02","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-18 18:05:14', NULL, ''),
(1314, 'lois', '{"void_item":{"id":"59896","date":"2017-12-20 12:29:26","ss_terminal":null,"ss_code":null,"sale_id":"15400","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-20 12:29:26","serial":"admin-1513731387-15137441661685810","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-20 12:46:20', NULL, ''),
(1315, 'lois', '{"void_item":{"id":"59913","date":"2017-12-20 13:19:58","ss_terminal":null,"ss_code":null,"sale_id":"15403","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"sanni come to bar","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-20 13:19:58","serial":"admin-1513731387-151374719876963","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-20 13:20:05', NULL, ''),
(1316, 'lois', '{"sale":{"id":"15411","txn_no":null,"table_no":"IS","user_id":"10008","username":"lois","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-12-21 11:08:14","payment_status":"Unpaid","cost":null,"subtotal":"1050.00","amount":"550.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":"500.00","adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1513825690","discount_type":"d","discount":"500.00","payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"59942","date":"2017-12-21 11:08:41","ss_terminal":null,"ss_code":null,"sale_id":"15411","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"Farlim Christmas Catering","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"1050.00","margin":"1050.0000","cost":"0.0000","amount":"1050.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"lois","ordered_time":"2017-12-21 11:08:41","serial":"lois-1513825690-15138257211375690","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}]}', '2017-12-21 11:09:57', NULL, ''),
(1317, 'lois', '{"sale":{"id":"15484","txn_no":null,"table_no":"T5","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-12-24 11:07:58","payment_status":"Unpaid","cost":null,"subtotal":"29.00","amount":"31.90","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1514076984","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"60285","date":"2017-12-24 11:07:58","ss_terminal":null,"ss_code":null,"sale_id":"15484","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.90","margin":"0.0000","cost":"0.0000","amount":"2.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-24 11:07:58","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"60286","date":"2017-12-24 11:08:10","ss_terminal":null,"ss_code":null,"sale_id":"15484","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-24 11:08:10","serial":"admin-1514076984-15140848906674288","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"60287","date":"2017-12-24 11:08:10","ss_terminal":null,"ss_code":null,"sale_id":"15484","si_item_id":"0","item_id":"61","item_sku":"61","item_name":"Slim Fit","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-24 11:08:10","serial":"admin-1514076984-15140848906674288","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-12-24 11:23:37', NULL, ''),
(1318, 'lois', '{"sale":{"id":"15489","txn_no":null,"table_no":"T5","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-12-24 11:55:00","payment_status":"Unpaid","cost":null,"subtotal":"0.00","amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1514076984","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"60300","date":"2017-12-24 11:55:00","ss_terminal":null,"ss_code":null,"sale_id":"15489","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-24 11:55:00","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"60301","date":"2017-12-24 11:55:15","ss_terminal":null,"ss_code":null,"sale_id":"15489","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"defroze last 9 steamboat food","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-24 11:55:15","serial":"admin-1514076984-1514087715307455","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-12-24 12:31:06', NULL, ''),
(1319, '', '{"void_item":{"id":"60369","date":"2017-12-25 09:04:50","ss_terminal":null,"ss_code":null,"sale_id":"15504","si_item_id":"0","item_id":"172","item_sku":"106","item_name":"Daily Berries ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-25 09:04:50","serial":"admin-1514162528-1514163890796654","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":"25.0","global_discount":null}}', '2017-12-25 09:05:17', NULL, ''),
(1320, '', '{"void_item":{"id":"60368","date":"2017-12-25 09:04:50","ss_terminal":null,"ss_code":null,"sale_id":"15504","si_item_id":"0","item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-25 09:04:50","serial":"admin-1514162528-1514163890796654","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-25 09:05:34', NULL, ''),
(1321, 'sanni', '{"sale":{"id":"15504","txn_no":null,"table_no":"T1","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-12-25 09:04:38","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1514162528","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"60367","date":"2017-12-25 09:04:38","ss_terminal":null,"ss_code":null,"sale_id":"15504","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-25 09:04:38","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-12-25 09:05:46', NULL, ''),
(1322, '', '{"void_item":{"id":"60613","date":"2017-12-25 14:32:43","ss_terminal":null,"ss_code":null,"sale_id":"15552","si_item_id":null,"item_id":"62","item_sku":"62","item_name":"Orange","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-25 14:32:43","serial":"admin-1514162528-15141835630147313","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-25 14:51:03', NULL, ''),
(1323, 'lois', '{"sale":{"id":"15567","txn_no":"115067","table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2017-12-27 10:58:44","payment_status":"Paid","cost":null,"subtotal":"35.00","amount":"38.50","amount_cash":"38.50","amount_cc":null,"amount_tendered":"50.30","amount_change":"11.80","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1514336956","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"60682","date":"2017-12-27 10:24:56","ss_terminal":null,"ss_code":null,"sale_id":"15567","si_item_id":null,"item_id":"10","item_sku":"10","item_name":"Dirty Chai","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1514336956","ordered_by":"admin","ordered_time":"2017-12-27 10:24:56","serial":"admin-1514336956-15143414966603535","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"60683","date":"2017-12-27 10:24:56","ss_terminal":null,"ss_code":null,"sale_id":"15567","si_item_id":"0","item_id":"298","item_sku":"234","item_name":"Salted Caramel Latte","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1514336956","ordered_by":"admin","ordered_time":"2017-12-27 10:24:56","serial":"admin-1514336956-15143414966603535","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"60681","date":"2017-12-27 10:24:56","ss_terminal":null,"ss_code":null,"sale_id":"15567","si_item_id":"0","item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":"1","terminal":"27","printed":"1","session":"1514336956","ordered_by":"admin","ordered_time":"2017-12-27 10:24:56","serial":"admin-1514336956-15143414966603535","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"60680","date":"2017-12-27 10:24:46","ss_terminal":null,"ss_code":null,"sale_id":"15567","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"3.50","margin":"0.0000","cost":"0.0000","amount":"3.50","sold":"1","terminal":"27","printed":"1","session":"1514336956","ordered_by":"admin","ordered_time":"2017-12-27 10:24:46","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-12-27 10:59:09', 1, ''),
(1324, 'sanni', '{"void_item":{"id":"60812","date":"2017-12-27 14:47:52","ss_terminal":null,"ss_code":null,"sale_id":"15589","si_item_id":"0","item_id":"270","item_sku":"204","item_name":"Homemade Savoury Pancake","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-27 14:47:52","serial":"admin-1514336956-15143572726417116","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-27 14:56:20', NULL, ''),
(1325, 'sanni', '{"void_item":{"id":"60798","date":"2017-12-27 14:22:10","ss_terminal":null,"ss_code":null,"sale_id":"15589","si_item_id":"0","item_id":"220","item_sku":"154","item_name":"Pork Bacon Pesto Pasta","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-27 14:22:10","serial":"admin-1514336956-15143557305872185","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-27 15:09:37', NULL, ''),
(1326, '', '{"void_item":{"id":"61081","date":"2017-12-29 16:30:53","ss_terminal":null,"ss_code":null,"sale_id":"15650","si_item_id":null,"item_id":"22","item_sku":"22","item_name":"Honey Milk","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-29 16:30:53","serial":"admin-1514509445-15145362534304049","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-29 16:46:23', NULL, ''),
(1327, '', '{"void_item":{"id":"61224","date":"2017-12-30 13:23:55","ss_terminal":null,"ss_code":null,"sale_id":"15677","si_item_id":null,"item_id":"11","item_sku":"11","item_name":"Vanilla Latte","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-30 13:23:55","serial":"admin-1514595837-15146114353768071","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-30 13:34:52', NULL, ''),
(1328, 'lois', '{"void_item":{"id":"61290","date":"2017-12-30 16:07:07","ss_terminal":null,"ss_code":null,"sale_id":"15691","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":" regular customer,kitchen hold on","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-30 16:07:07","serial":"admin-1514595837-15146212270669531","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-30 16:07:16', NULL, ''),
(1329, '', '{"void_item":{"id":"61301","date":"2017-12-30 16:38:49","ss_terminal":null,"ss_code":null,"sale_id":"15690","si_item_id":"0","item_id":"61","item_sku":"61","item_name":"Slim Fit","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-30 16:38:49","serial":"admin-1514595837-15146231290618854","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-30 16:40:51', NULL, ''),
(1330, 'lois', '{"sale":{"id":"15690","txn_no":null,"table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2017-12-30 15:55:03","payment_status":"Unpaid","cost":null,"subtotal":"11.00","amount":"12.10","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1514595837","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"61287","date":"2017-12-30 15:55:03","ss_terminal":null,"ss_code":null,"sale_id":"15690","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.10","margin":"0.0000","cost":"0.0000","amount":"1.10","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-30 15:55:03","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"61288","date":"2017-12-30 15:55:09","ss_terminal":null,"ss_code":null,"sale_id":"15690","si_item_id":"0","item_id":"36","item_sku":"36","item_name":"Lemon Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-30 15:55:09","serial":"admin-1514595837-15146205096023568","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2017-12-30 17:12:03', NULL, ''),
(1331, '', '{"void_item":{"id":"61511","date":"2017-12-31 13:00:41","ss_terminal":null,"ss_code":null,"sale_id":"15734","si_item_id":"0","item_id":"166","item_sku":"100","item_name":"Chocolate Dose ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-31 13:00:41","serial":"admin-1514682622-15146964412384255","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-31 13:17:55', NULL, ''),
(1332, 'lois', '{"void_item":{"id":"61533","date":"2017-12-31 13:25:54","ss_terminal":null,"ss_code":null,"sale_id":"15738","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"T3 moved to T14","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2017-12-31 13:25:54","serial":"admin-1514682622-1514697954467526","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2017-12-31 14:04:04', NULL, ''),
(1333, '', '{"void_item":{"id":"61583","date":"2018-01-01 09:22:10","ss_terminal":null,"ss_code":null,"sale_id":"15751","si_item_id":null,"item_id":"67","item_sku":"67","item_name":"Carrot milk","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-01 09:22:10","serial":"admin-1514768211-15147697305078420","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-01 09:22:18', NULL, ''),
(1334, '', '{"void_item":{"id":"61891","date":"2018-01-01 16:02:22","ss_terminal":null,"ss_code":null,"sale_id":"15804","si_item_id":"0","item_id":"60","item_sku":"60","item_name":"The Hulk","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-01 16:02:22","serial":"admin-1514768211-15147937419807766","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-01 16:07:03', NULL, ''),
(1335, 'lois', '{"void_item":{"id":"61897","date":"2018-01-01 16:08:58","ss_terminal":null,"ss_code":null,"sale_id":"15805","si_item_id":"0","item_id":"302","item_sku":"238","item_name":"Ice on the cake","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-01 16:08:58","serial":"admin-1514768211-151479413866635","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-01 16:13:46', NULL, ''),
(1336, '', '{"void_item":{"id":"61955","date":"2018-01-04 10:30:35","ss_terminal":null,"ss_code":null,"sale_id":"15819","si_item_id":"0","item_id":"159","item_sku":"228","item_name":"Yuzu Marmalade Yogurt Bowl","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-04 10:30:35","serial":"admin-1515027728-15150330355214273","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-04 10:46:48', NULL, ''),
(1337, '', '{"void_item":{"id":"62018","date":"2018-01-04 13:00:25","ss_terminal":null,"ss_code":null,"sale_id":"15835","si_item_id":"0","item_id":"223","item_sku":"226","item_name":"Smoked Duck Aglio Olio","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"22.00","margin":"22.0000","cost":"0.0000","amount":"22.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-04 13:00:25","serial":"admin-1515027728-15150420250321795","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-04 13:03:02', NULL, ''),
(1338, '', '{"void_item":{"id":"62044","date":"2018-01-04 13:22:51","ss_terminal":null,"ss_code":null,"sale_id":"15823","si_item_id":"0","item_id":"80","item_sku":"80","item_name":"Oriental Chicken Salad","item_option":"","category":"Meals","subcategory":"Salad","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-04 13:22:51","serial":"admin-1515027728-15150433712591741","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-04 13:24:16', NULL, ''),
(1339, 'sanni', '{"sale":{"id":"15837","txn_no":null,"table_no":"5","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2018-01-04 13:08:22","payment_status":"Unpaid","cost":null,"subtotal":"18.00","amount":"19.80","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1515027728","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"62029","date":"2018-01-04 13:08:32","ss_terminal":null,"ss_code":null,"sale_id":"15837","si_item_id":null,"item_id":"62","item_sku":"62","item_name":"Orange","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-04 13:08:32","serial":"admin-1515027728-15150425127803969","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"62027","date":"2018-01-04 13:08:22","ss_terminal":null,"ss_code":null,"sale_id":"15837","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.80","margin":"0.0000","cost":"0.0000","amount":"1.80","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-04 13:08:22","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"62028","date":"2018-01-04 13:08:32","ss_terminal":null,"ss_code":null,"sale_id":"15837","si_item_id":null,"item_id":"63","item_sku":"63","item_name":"Lime","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-04 13:08:32","serial":"admin-1515027728-15150425127803969","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2018-01-04 14:06:22', NULL, ''),
(1340, 'sanni', '{"sale":{"id":"15840","txn_no":null,"table_no":"T7","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2018-01-04 13:33:00","payment_status":"Unpaid","cost":null,"subtotal":"81.00","amount":"89.10","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1515027728","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"62051","date":"2018-01-04 13:35:21","ss_terminal":null,"ss_code":null,"sale_id":"15840","si_item_id":"0","item_id":"35","item_sku":"35","item_name":"Passion Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-04 13:35:21","serial":"admin-1515027728-15150441212674819","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"62052","date":"2018-01-04 13:35:21","ss_terminal":null,"ss_code":null,"sale_id":"15840","si_item_id":"0","item_id":"36","item_sku":"36","item_name":"Lemon Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-04 13:35:21","serial":"admin-1515027728-15150441212674819","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"62053","date":"2018-01-04 13:36:22","ss_terminal":null,"ss_code":null,"sale_id":"15840","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-04 13:36:22","serial":"admin-1515027728-15150441825069587","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"62054","date":"2018-01-04 13:36:22","ss_terminal":null,"ss_code":null,"sale_id":"15840","si_item_id":"0","item_id":"267","item_sku":"201","item_name":"Cocoa Cappucino","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-04 13:36:22","serial":"admin-1515027728-15150441825069587","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"62049","date":"2018-01-04 13:33:00","ss_terminal":null,"ss_code":null,"sale_id":"15840","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"8.10","margin":"0.0000","cost":"0.0000","amount":"8.10","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-04 13:33:00","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"62085","date":"2018-01-04 14:28:31","ss_terminal":null,"ss_code":null,"sale_id":"15840","si_item_id":"0","item_id":"61","item_sku":"61","item_name":"Slim Fit","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-04 14:28:31","serial":"admin-1515027728-15150473112869351","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"62050","date":"2018-01-04 13:35:21","ss_terminal":null,"ss_code":null,"sale_id":"15840","si_item_id":"0","item_id":"221","item_sku":"155","item_name":"Seasoned Chicken Pesto Pasta","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-04 13:35:21","serial":"admin-1515027728-15150441212674819","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2018-01-04 14:28:48', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(1341, 'sanni', '{"sale":{"id":"15847","txn_no":"115338","table_no":"T3","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2018-01-04 14:35:57","payment_status":"Paid","cost":null,"subtotal":"24.00","amount":"26.40","amount_cash":"26.40","amount_cc":null,"amount_tendered":"50.00","amount_change":"23.60","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1515027728","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"62091","date":"2018-01-04 14:35:09","ss_terminal":null,"ss_code":null,"sale_id":"15847","si_item_id":null,"item_id":"1","item_sku":"1","item_name":"Espresso","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"6.00","margin":"6.0000","cost":"0.0000","amount":"6.00","sold":"1","terminal":"27","printed":"1","session":"1515027728","ordered_by":"admin","ordered_time":"2018-01-04 14:35:09","serial":"admin-1515027728-15150477095475629","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"62090","date":"2018-01-04 14:35:09","ss_terminal":null,"ss_code":null,"sale_id":"15847","si_item_id":null,"item_id":"63","item_sku":"63","item_name":"Lime","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1515027728","ordered_by":"admin","ordered_time":"2018-01-04 14:35:09","serial":"admin-1515027728-15150477095475629","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"62089","date":"2018-01-04 14:35:09","ss_terminal":null,"ss_code":null,"sale_id":"15847","si_item_id":null,"item_id":"63","item_sku":"63","item_name":"Lime","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1515027728","ordered_by":"admin","ordered_time":"2018-01-04 14:35:09","serial":"admin-1515027728-15150477095475629","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"62088","date":"2018-01-04 14:34:44","ss_terminal":null,"ss_code":null,"sale_id":"15847","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.40","margin":"0.0000","cost":"0.0000","amount":"2.40","sold":"1","terminal":"27","printed":"1","session":"1515027728","ordered_by":"admin","ordered_time":"2018-01-04 14:34:44","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2018-01-04 14:39:13', 1, ''),
(1342, 'sanni', '{"sale":{"id":"15832","txn_no":null,"table_no":"T1(S)","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2018-01-04 12:54:26","payment_status":"Unpaid","cost":null,"subtotal":"20.00","amount":"22.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1515027728","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":null,"customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":null},"sale_items":[{"id":"62065","date":"2018-01-04 14:01:25","ss_terminal":null,"ss_code":null,"sale_id":"15832","si_item_id":"0","item_id":"13","item_sku":"13","item_name":"Iced Americano","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-04 14:01:25","serial":"admin-1515027728-15150456854217312","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"62010","date":"2018-01-04 12:56:48","ss_terminal":null,"ss_code":null,"sale_id":"15832","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-04 12:56:48","serial":"admin-1515027728-15150418078581194","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"62007","date":"2018-01-04 12:54:26","ss_terminal":null,"ss_code":null,"sale_id":"15832","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"","category":"SERVICE CHARGE","subcategory":"SERVICE CHARGE","qty":"1","price_per_unit":"2.00","margin":"0.0000","cost":"0.0000","amount":"2.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-04 12:54:26","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2018-01-04 16:10:13', NULL, ''),
(1343, '', '{"void_item":{"id":"62362","date":"2018-01-06 14:29:31","ss_terminal":null,"ss_code":null,"sale_id":"15907","si_item_id":"0","item_id":"324","item_sku":"260","item_name":"Blueberry Lemon Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-06 14:29:31","serial":"admin-1515201712-15152201718046979","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-06 14:32:39', NULL, ''),
(1344, '', '{"void_item":{"id":"62361","date":"2018-01-06 14:29:31","ss_terminal":null,"ss_code":null,"sale_id":"15907","si_item_id":"0","item_id":"324","item_sku":"260","item_name":"Blueberry Lemon Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-06 14:29:31","serial":"admin-1515201712-15152201718046979","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-06 14:32:46', NULL, ''),
(1345, 'sanni', '{"void_item":{"id":"62351","date":"2018-01-06 14:07:48","ss_terminal":null,"ss_code":null,"sale_id":"15905","si_item_id":"0","item_id":"161","item_sku":"95","item_name":"Signature Dumpling (10 Pcs) ","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-06 14:07:48","serial":"admin-1515201712-15152188682401456","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-06 14:39:46', NULL, ''),
(1346, '', '{"void_item":{"id":"62381","date":"2018-01-06 14:59:08","ss_terminal":null,"ss_code":null,"sale_id":"15909","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-06 14:59:08","serial":"admin-1515201712-15152219485108537","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-06 14:59:53', NULL, ''),
(1347, 'lois', '{"void_item":{"id":"62393","date":"2018-01-06 15:37:30","ss_terminal":null,"ss_code":null,"sale_id":"15911","si_item_id":"0","item_id":"34","item_sku":"34","item_name":"Ginger Lemongrass Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-06 15:37:30","serial":"admin-1515201712-15152242503008974","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-06 15:40:41', NULL, ''),
(1348, 'lois', '{"void_item":{"id":"62392","date":"2018-01-06 15:37:30","ss_terminal":null,"ss_code":null,"sale_id":"15911","si_item_id":"0","item_id":"34","item_sku":"34","item_name":"Ginger Lemongrass Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-06 15:37:30","serial":"admin-1515201712-15152242503008974","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-06 15:40:49', NULL, ''),
(1349, 'lois', '{"sale":{"id":"15914","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2018-01-06 16:49:04","payment_status":"Unpaid","cost":null,"subtotal":"18.00","amount":"18.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1515201712","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"62406","date":"2018-01-06 16:49:07","ss_terminal":null,"ss_code":null,"sale_id":"15914","si_item_id":"0","item_id":"315","item_sku":"251","item_name":"AA Set - Asian Spicy Lemony Chicken","item_option":"","category":"Meals","subcategory":"Rice","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-06 16:49:07","serial":"admin-1515201712-15152285471806429","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}]}', '2018-01-06 16:49:31', NULL, ''),
(1350, 'sanni', '{"void_item":{"id":"62541","date":"2018-01-07 11:30:58","ss_terminal":null,"ss_code":null,"sale_id":"15938","si_item_id":"0","item_id":"209","item_sku":"143","item_name":"Honey Lemon","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-07 11:30:58","serial":"admin-1515286096-15152958585385612","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-07 11:44:28', NULL, ''),
(1351, '', '{"void_item":{"id":"62540","date":"2018-01-07 11:30:58","ss_terminal":null,"ss_code":null,"sale_id":"15938","si_item_id":"0","item_id":"209","item_sku":"143","item_name":"Honey Lemon","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-07 11:30:58","serial":"admin-1515286096-15152958585385612","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-07 11:44:35', NULL, ''),
(1352, 'lois', '{"void_item":{"id":"62557","date":"2018-01-07 12:14:47","ss_terminal":null,"ss_code":null,"sale_id":"15942","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"why wmu so long","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-07 12:14:47","serial":"admin-1515286096-15152984874781968","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-07 12:15:55', NULL, ''),
(1353, '', '{"void_item":{"id":"62670","date":"2018-01-08 12:19:28","ss_terminal":null,"ss_code":null,"sale_id":"15967","si_item_id":null,"item_id":"68","item_sku":"68","item_name":"Mix 2 types ","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-08 12:19:28","serial":"admin-1515371683-1515385168819482","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-08 12:20:12', NULL, ''),
(1354, '', '{"void_item":{"id":"62669","date":"2018-01-08 12:19:28","ss_terminal":null,"ss_code":null,"sale_id":"15967","si_item_id":null,"item_id":"68","item_sku":"68","item_name":"Mix 2 types ","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-08 12:19:28","serial":"admin-1515371683-1515385168819482","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-08 12:20:21', NULL, ''),
(1355, '', '{"void_item":{"id":"62691","date":"2018-01-08 13:05:42","ss_terminal":null,"ss_code":null,"sale_id":"15959","si_item_id":"0","item_id":"34","item_sku":"34","item_name":"Ginger Lemongrass Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-08 13:05:42","serial":"admin-1515371683-15153879424474178","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-08 13:35:51', NULL, ''),
(1356, '', '{"sale":{"id":"15976","txn_no":"115462","table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2018-01-08 13:45:17","payment_status":"Paid","cost":null,"subtotal":"3.50","amount":"3.50","amount_cash":"3.50","amount_cc":null,"amount_tendered":"3.50","amount_change":"0.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1515371683","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"62710","date":"2018-01-08 13:44:02","ss_terminal":null,"ss_code":null,"sale_id":"15976","si_item_id":"0","item_id":"264","item_sku":"198","item_name":"PostCard","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"3.50","margin":"3.5000","cost":"0.0000","amount":"3.50","sold":"1","terminal":"27","printed":"1","session":"1515371683","ordered_by":"admin","ordered_time":"2018-01-08 13:44:02","serial":"admin-1515371683-15153902421934011","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}]}', '2018-01-08 13:45:44', 1, ''),
(1357, '', '{"void_item":{"id":"62710","date":"2018-01-08 13:44:02","ss_terminal":null,"ss_code":null,"sale_id":"15976","si_item_id":"0","item_id":"264","item_sku":"198","item_name":"PostCard","item_option":"","category":"DISCOUNT ","subcategory":"0","qty":"1","price_per_unit":"3.50","margin":"3.5000","cost":"0.0000","amount":"3.50","sold":"1","terminal":"27","printed":"1","session":"1515371683","ordered_by":"admin","ordered_time":"2018-01-08 13:44:02","serial":"admin-1515371683-15153902421934011","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":"1","discount":null,"global_discount":null}}', '2018-01-08 13:45:55', NULL, ''),
(1358, '', '{"void_item":{"id":"62797","date":"2018-01-10 13:14:30","ss_terminal":null,"ss_code":null,"sale_id":"15992","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-10 13:14:30","serial":"admin-1515546225-15155612703703340","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-10 14:23:30', NULL, ''),
(1359, '', '{"void_item":{"id":"62843","date":"2018-01-11 11:14:28","ss_terminal":null,"ss_code":null,"sale_id":"16004","si_item_id":null,"item_id":"11","item_sku":"11","item_name":"Vanilla Latte","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-11 11:14:28","serial":"admin-1515581853-15156404685599988","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-11 11:21:10', NULL, ''),
(1360, 'sanni', '{"sale":{"id":"16009","txn_no":null,"table_no":"IS(S)","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2018-01-11 11:52:45","payment_status":"Unpaid","cost":null,"subtotal":"11.00","amount":"12.10","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1515581853","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":null,"customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":null},"sale_items":[{"id":"62855","date":"2018-01-11 11:52:45","ss_terminal":null,"ss_code":null,"sale_id":"16009","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"","category":"SERVICE CHARGE","subcategory":"SERVICE CHARGE","qty":"1","price_per_unit":"1.10","margin":"0.0000","cost":"0.0000","amount":"1.10","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-11 11:52:45","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"62854","date":"2018-01-11 00:00:00","ss_terminal":null,"ss_code":null,"sale_id":"16009","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":null,"cost":null,"amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-11 11:52:20","serial":"admin-1515581853-15156427406933623","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2018-01-11 11:53:55', NULL, ''),
(1361, 'sanni', '{"sale":{"id":"16020","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2018-01-11 13:49:52","payment_status":"Unpaid","cost":null,"subtotal":"8.00","amount":"8.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1515581853","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"62893","date":"2018-01-11 13:50:01","ss_terminal":null,"ss_code":null,"sale_id":"16020","si_item_id":null,"item_id":"22","item_sku":"22","item_name":"Honey Milk","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-11 13:50:01","serial":"admin-1515581853-15156498014523051","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}]}', '2018-01-11 13:51:40', NULL, ''),
(1362, '', '{"void_item":{"id":"62973","date":"2018-01-12 12:37:48","ss_terminal":null,"ss_code":null,"sale_id":"16035","si_item_id":"0","item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-12 12:37:48","serial":"admin-1515719036-15157318688065767","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-12 12:38:01', NULL, ''),
(1363, '', '{"void_item":{"id":"62972","date":"2018-01-12 12:37:48","ss_terminal":null,"ss_code":null,"sale_id":"16035","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"macaroni","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-12 12:37:48","serial":"admin-1515719036-15157318688065767","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-12 12:38:07', NULL, ''),
(1364, '', '{"void_item":{"id":"62971","date":"2018-01-12 12:37:48","ss_terminal":null,"ss_code":null,"sale_id":"16035","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"rice wine RICE","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-12 12:37:48","serial":"admin-1515719036-15157318688065767","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-12 12:38:11', NULL, ''),
(1365, '', '{"void_item":{"id":"63006","date":"2018-01-12 13:30:25","ss_terminal":null,"ss_code":null,"sale_id":"16040","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"rice wine RICE","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-12 13:30:25","serial":"admin-1515719036-15157350250674097","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-12 13:31:53', NULL, ''),
(1366, '', '{"void_item":{"id":"63201","date":"2018-01-13 15:28:59","ss_terminal":null,"ss_code":null,"sale_id":"16083","si_item_id":"0","item_id":"292","item_sku":"227","item_name":"Pork Bacon Aglio Olio","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-13 15:28:59","serial":"admin-1515805892-15158285388886052","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-13 15:30:47', NULL, ''),
(1367, 'lois', '{"void_item":{"id":"63485","date":"2018-01-15 14:14:11","ss_terminal":null,"ss_code":null,"sale_id":"16139","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.90","margin":"0.0000","cost":"0.0000","amount":"0.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-15 14:14:11","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-15 14:14:29', NULL, ''),
(1368, '', '{"void_item":{"id":"63598","date":"2018-01-18 10:16:52","ss_terminal":null,"ss_code":null,"sale_id":"16167","si_item_id":"0","item_id":"159","item_sku":"228","item_name":"Yuzu Marmalade Yogurt Bowl","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-18 10:16:52","serial":"admin-1516237698-15162418127185536","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-18 10:17:59', NULL, ''),
(1369, '', '{"void_item":{"id":"63649","date":"2018-01-18 12:33:46","ss_terminal":null,"ss_code":null,"sale_id":"16177","si_item_id":"0","item_id":"78","item_sku":"78","item_name":"Cheesy Baked Mashed Potato","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-18 12:33:46","serial":"admin-1516237698-15162500261054769","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-18 12:53:36', NULL, ''),
(1370, '', '{"void_item":{"id":"63648","date":"2018-01-18 12:33:46","ss_terminal":null,"ss_code":null,"sale_id":"16177","si_item_id":"0","item_id":"78","item_sku":"78","item_name":"Cheesy Baked Mashed Potato","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-18 12:33:46","serial":"admin-1516237698-15162500261054769","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-18 12:53:40', NULL, ''),
(1371, '', '{"void_item":{"id":"63660","date":"2018-01-18 12:42:59","ss_terminal":null,"ss_code":null,"sale_id":"16179","si_item_id":"0","item_id":"321","item_sku":"257","item_name":"AA Set - Genius In the Bowl","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-18 12:42:59","serial":"admin-1516237698-15162505792261124","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-18 12:54:22', NULL, ''),
(1372, 'lois', '{"void_item":{"id":"63679","date":"2018-01-18 14:22:51","ss_terminal":null,"ss_code":null,"sale_id":"16168","si_item_id":"0","item_id":"232","item_sku":"166","item_name":"Candied Spicy Bacon Strips","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-18 14:22:51","serial":"admin-1516237698-15162565710583179","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-18 14:27:30', NULL, ''),
(1373, '', '{"void_item":{"id":"63732","date":"2018-01-19 10:57:07","ss_terminal":null,"ss_code":null,"sale_id":"16190","si_item_id":"0","item_id":"267","item_sku":"201","item_name":"Cocoa Cappucino","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-19 10:57:07","serial":"admin-1516321469-15163306277495284","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-19 10:58:36', NULL, ''),
(1374, 'lois', '{"void_item":{"id":"63997","date":"2018-01-20 17:51:42","ss_terminal":null,"ss_code":null,"sale_id":"16245","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"coffee beans","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"38.00","margin":"38.0000","cost":"0.0000","amount":"38.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-20 17:51:42","serial":"admin-1516415730-1516441902153636","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-20 17:52:13', NULL, ''),
(1375, '', '{"void_item":{"id":"64039","date":"2018-01-21 10:06:19","ss_terminal":null,"ss_code":null,"sale_id":"16256","si_item_id":null,"item_id":"10","item_sku":"10","item_name":"Dirty Chai","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-21 10:06:19","serial":"admin-1516496615-15165003789812135","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-21 10:10:06', NULL, ''),
(1376, '', '{"void_item":{"id":"64202","date":"2018-01-21 14:06:57","ss_terminal":null,"ss_code":null,"sale_id":"16285","si_item_id":"0","item_id":"290","item_sku":"224","item_name":"Seasoned Chicken Red Pasta","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-21 14:06:57","serial":"admin-1516509965-1516514817484378","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-21 14:08:16', NULL, ''),
(1377, '', '{"void_item":{"id":"64248","date":"2018-01-21 15:56:10","ss_terminal":null,"ss_code":null,"sale_id":"16295","si_item_id":"0","item_id":"166","item_sku":"100","item_name":"Chocolate Dose ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"9.60","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-21 15:56:10","serial":"admin-1516509965-15165213705946038","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":"20.0","global_discount":null}}', '2018-01-21 16:28:27', NULL, ''),
(1378, 'sanni', '{"void_item":{"id":"64526","date":"2018-01-25 15:21:09","ss_terminal":null,"ss_code":null,"sale_id":"16363","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-25 15:21:09","serial":"admin-1516842527-15168648694503136","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-25 15:22:13', NULL, ''),
(1379, '', '{"void_item":{"id":"64640","date":"2018-01-27 09:06:48","ss_terminal":null,"ss_code":null,"sale_id":"16394","si_item_id":"0","item_id":"329","item_sku":"265","item_name":"Peanut Butter Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-27 09:06:48","serial":"admin-1517014911-15170152088007131","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-27 09:08:58', NULL, ''),
(1380, 'sanni', '{"void_item":{"id":"64666","date":"2018-01-27 10:30:53","ss_terminal":null,"ss_code":null,"sale_id":"16401","si_item_id":"0","item_id":"76","item_sku":"76","item_name":"Meatless Pesto Pasta","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-27 10:30:53","serial":"admin-1517014911-15170202538196221","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-27 10:32:02', NULL, ''),
(1381, '', '{"void_item":{"id":"64928","date":"2018-01-28 13:49:13","ss_terminal":null,"ss_code":null,"sale_id":"16456","si_item_id":"0","item_id":"327","item_sku":"263","item_name":"Gula Melaka Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-28 13:49:13","serial":"admin-1517100387-15171185536053511","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-28 13:49:54', NULL, ''),
(1382, '', '{"void_item":{"id":"65048","date":"2018-01-29 12:07:09","ss_terminal":null,"ss_code":null,"sale_id":"16484","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"pepper pork","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"108.0000","cost":"0.0000","amount":"108.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-29 12:07:09","serial":"admin-1517186995-15171988298095813","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-29 12:12:12', NULL, ''),
(1383, 'sanni', '{"void_item":{"id":"65048","date":"2018-01-29 12:07:09","ss_terminal":null,"ss_code":null,"sale_id":"16484","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"pepper pork","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"108.0000","cost":"0.0000","amount":"90.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-29 12:07:09","serial":"admin-1517186995-15171988298095813","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-29 12:57:18', NULL, ''),
(1384, 'sanni', '{"void_item":{"id":"65048","date":"2018-01-29 12:07:09","ss_terminal":null,"ss_code":null,"sale_id":"16484","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"pepper pork","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"108.0000","cost":"0.0000","amount":"72.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-29 12:07:09","serial":"admin-1517186995-15171988298095813","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-29 12:57:34', NULL, ''),
(1385, '', '{"void_item":{"id":"65048","date":"2018-01-29 12:07:09","ss_terminal":null,"ss_code":null,"sale_id":"16484","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"pepper pork","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"108.0000","cost":"0.0000","amount":"54.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-29 12:07:09","serial":"admin-1517186995-15171988298095813","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-29 12:57:44', NULL, ''),
(1386, '', '{"void_item":{"id":"65048","date":"2018-01-29 12:07:09","ss_terminal":null,"ss_code":null,"sale_id":"16484","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"pepper pork","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"108.0000","cost":"0.0000","amount":"36.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-29 12:07:09","serial":"admin-1517186995-15171988298095813","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-29 12:57:53', NULL, ''),
(1387, '', '{"void_item":{"id":"65048","date":"2018-01-29 12:07:09","ss_terminal":null,"ss_code":null,"sale_id":"16484","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"pepper pork","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"18.00","margin":"108.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-29 12:07:09","serial":"admin-1517186995-15171988298095813","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-29 12:57:57', NULL, ''),
(1388, '', '{"void_item":{"id":"65081","date":"2018-01-29 13:11:44","ss_terminal":null,"ss_code":null,"sale_id":"16489","si_item_id":"0","item_id":"220","item_sku":"154","item_name":"Pork Bacon Pesto Pasta","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-29 13:11:44","serial":"admin-1517186995-15172027039914090","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-29 13:17:28', NULL, ''),
(1389, 'sanni', '{"void_item":{"id":"65096","date":"2018-01-29 14:04:46","ss_terminal":null,"ss_code":null,"sale_id":"16490","si_item_id":"0","item_id":"302","item_sku":"238","item_name":"Ice on the cake","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-29 14:04:46","serial":"admin-1517186995-15172058859856827","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-29 14:19:26', NULL, ''),
(1390, 'sanni', '{"sale":{"id":"16514","txn_no":"115994","table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2018-01-31 12:45:16","payment_status":"Paid","cost":null,"subtotal":"20.00","amount":"18.00","amount_cash":"18.00","amount_cc":null,"amount_tendered":"20.00","amount_change":"2.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":"2.00","adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1517358393","discount_type":"p","discount":"10","payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"65195","date":"2018-01-31 12:44:59","ss_terminal":null,"ss_code":null,"sale_id":"16514","si_item_id":null,"item_id":"44","item_sku":"44","item_name":"Tiger ","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1517358393","ordered_by":"admin","ordered_time":"2018-01-31 12:44:59","serial":"admin-1517358393-1517373899224139","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":"10.0"},{"id":"65194","date":"2018-01-31 12:44:59","ss_terminal":null,"ss_code":null,"sale_id":"16514","si_item_id":"0","item_id":"78","item_sku":"78","item_name":"Cheesy Baked Mashed Potato","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1517358393","ordered_by":"admin","ordered_time":"2018-01-31 12:44:59","serial":"admin-1517358393-1517373899224139","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":"10.0"}]}', '2018-01-31 12:49:41', 1, ''),
(1391, 'sanni', '{"void_item":{"id":"65194","date":"2018-01-31 12:44:59","ss_terminal":null,"ss_code":null,"sale_id":"16514","si_item_id":"0","item_id":"78","item_sku":"78","item_name":"Cheesy Baked Mashed Potato","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1517358393","ordered_by":"admin","ordered_time":"2018-01-31 12:44:59","serial":"admin-1517358393-1517373899224139","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":"10.0"}}', '2018-01-31 12:49:57', NULL, ''),
(1392, '', '{"void_item":{"id":"65200","date":"2018-01-31 12:53:24","ss_terminal":null,"ss_code":null,"sale_id":"16515","si_item_id":null,"item_id":"7","item_sku":"7","item_name":"Mocha ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"13.00","margin":"13.0000","cost":"0.0000","amount":"13.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-31 12:53:24","serial":"admin-1517358393-15173744038389768","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-31 12:57:12', NULL, ''),
(1393, '', '{"void_item":{"id":"65215","date":"2018-01-31 13:31:58","ss_terminal":null,"ss_code":null,"sale_id":"16519","si_item_id":"0","item_id":"80","item_sku":"80","item_name":"Oriental Chicken Salad","item_option":"","category":"Meals","subcategory":"Salad","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-31 13:31:58","serial":"admin-1517358393-1517376718380654","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-31 13:32:44', NULL, ''),
(1394, 'sanni', '{"void_item":{"id":"65204","date":"2018-01-31 13:11:28","ss_terminal":null,"ss_code":null,"sale_id":"16516","si_item_id":"0","item_id":"36","item_sku":"36","item_name":"Lemon Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-31 13:11:28","serial":"admin-1517358393-15173754883699532","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-31 14:20:22', NULL, ''),
(1395, 'lois', '{"void_item":{"id":"65268","date":"2018-01-31 16:27:40","ss_terminal":null,"ss_code":null,"sale_id":"16529","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-01-31 16:27:40","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-01-31 16:28:36', NULL, ''),
(1396, '', '{"void_item":{"id":"65276","date":"2018-02-01 09:13:06","ss_terminal":null,"ss_code":null,"sale_id":"16532","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"junior BLT","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-01 09:13:06","serial":"admin-1517447169-15174475863714552","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-01 09:23:55', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(1397, 'sanni', '{"sale":{"id":"16529","txn_no":null,"table_no":"T1","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2018-01-31 16:27:40","payment_status":"Unpaid","cost":null,"subtotal":"51.00","amount":"51.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1517358393","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"65288","date":"2018-02-01 09:43:25","ss_terminal":null,"ss_code":null,"sale_id":"16529","si_item_id":"0","item_id":"333","item_sku":"269","item_name":"Morning Omelette","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-01 09:43:25","serial":"admin-1517447169-15174494055437435","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"65285","date":"2018-02-01 09:43:25","ss_terminal":null,"ss_code":null,"sale_id":"16529","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-01 09:43:25","serial":"admin-1517447169-15174494055437435","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"65286","date":"2018-02-01 09:43:25","ss_terminal":null,"ss_code":null,"sale_id":"16529","si_item_id":null,"item_id":"22","item_sku":"22","item_name":"Honey Milk","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-01 09:43:25","serial":"admin-1517447169-15174494055437435","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"65287","date":"2018-02-01 09:43:25","ss_terminal":null,"ss_code":null,"sale_id":"16529","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-01 09:43:25","serial":"admin-1517447169-15174494055437435","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2018-02-01 10:30:15', NULL, ''),
(1398, 'sanni', '{"sale":{"id":"16574","txn_no":null,"table_no":"T2","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2018-02-02 13:41:15","payment_status":"Unpaid","cost":null,"subtotal":"10.00","amount":"11.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1517534180","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"65453","date":"2018-02-02 13:41:22","ss_terminal":null,"ss_code":null,"sale_id":"16574","si_item_id":null,"item_id":"45","item_sku":"45","item_name":"Soda","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-02 13:41:22","serial":"admin-1517534180-15175500825484830","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"65451","date":"2018-02-02 13:41:15","ss_terminal":null,"ss_code":null,"sale_id":"16574","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.00","margin":"0.0000","cost":"0.0000","amount":"1.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-02 13:41:15","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"65452","date":"2018-02-02 13:41:22","ss_terminal":null,"ss_code":null,"sale_id":"16574","si_item_id":null,"item_id":"45","item_sku":"45","item_name":"Soda","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-02 13:41:22","serial":"admin-1517534180-15175500825484830","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2018-02-02 13:41:58', NULL, ''),
(1399, '', '{"void_item":{"id":"65511","date":"2018-02-03 10:02:18","ss_terminal":null,"ss_code":null,"sale_id":"16590","si_item_id":null,"item_id":"8","item_sku":"8","item_name":"Caramel Macchiato ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-03 10:02:18","serial":"admin-1517620364-15176233379217077","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-03 10:09:08', NULL, ''),
(1400, '', '{"void_item":{"id":"65751","date":"2018-02-04 11:48:09","ss_terminal":null,"ss_code":null,"sale_id":"16638","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-04 11:48:09","serial":"admin-1517707745-151771608896867","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-04 11:52:35', NULL, ''),
(1401, '', '{"void_item":{"id":"65777","date":"2018-02-04 12:23:13","ss_terminal":null,"ss_code":null,"sale_id":"16642","si_item_id":"0","item_id":"209","item_sku":"143","item_name":"Honey Lemon","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-04 12:23:13","serial":"admin-1517707745-1517718193418934","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-04 12:31:28', NULL, ''),
(1402, '', '{"void_item":{"id":"65811","date":"2018-02-04 12:59:18","ss_terminal":null,"ss_code":null,"sale_id":"16650","si_item_id":"0","item_id":"170","item_sku":"104","item_name":"Daily Cheese ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-04 12:59:18","serial":"admin-1517707745-15177203585627816","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-04 13:01:29', NULL, ''),
(1403, '', '{"void_item":{"id":"65762","date":"2018-02-04 12:05:59","ss_terminal":null,"ss_code":null,"sale_id":"16639","si_item_id":"0","item_id":"333","item_sku":"269","item_name":"Morning Omelette","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-04 12:05:59","serial":"admin-1517707745-15177171597757558","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-04 13:06:45', NULL, ''),
(1404, '', '{"void_item":{"id":"65842","date":"2018-02-04 14:12:08","ss_terminal":null,"ss_code":null,"sale_id":"16658","si_item_id":"0","item_id":"293","item_sku":"229","item_name":"Classic Yogurt Bowl","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-04 14:12:08","serial":"admin-1517707745-15177247280829856","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-04 14:16:38', NULL, ''),
(1405, 'lois', '{"void_item":{"id":"65849","date":"2018-02-04 14:25:08","ss_terminal":null,"ss_code":null,"sale_id":"16658","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"are u guys done","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-04 14:25:08","serial":"admin-1517707745-15177255088054122","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-04 14:25:18', NULL, ''),
(1406, '', '{"void_item":{"id":"65936","date":"2018-02-07 11:01:03","ss_terminal":null,"ss_code":null,"sale_id":"16687","si_item_id":"0","item_id":"327","item_sku":"263","item_name":"Gula Melaka Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-07 11:01:03","serial":"admin-1517965747-15179724634304858","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-07 11:05:05', NULL, ''),
(1407, '', '{"void_item":{"id":"65937","date":"2018-02-07 11:01:03","ss_terminal":null,"ss_code":null,"sale_id":"16687","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-07 11:01:03","serial":"admin-1517965747-15179724634304858","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-07 11:05:13', NULL, ''),
(1408, '', '{"void_item":{"id":"65938","date":"2018-02-07 11:01:03","ss_terminal":null,"ss_code":null,"sale_id":"16687","si_item_id":"0","item_id":"184","item_sku":"119","item_name":"Flat White","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-07 11:01:03","serial":"admin-1517965747-15179724634304858","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-07 11:05:19', NULL, ''),
(1409, '', '{"void_item":{"id":"66060","date":"2018-02-08 11:54:25","ss_terminal":null,"ss_code":null,"sale_id":"16709","si_item_id":"0","item_id":"233","item_sku":"167","item_name":"Naugthy Girl","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-08 11:54:25","serial":"admin-1518051961-15180620654915023","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-08 12:03:22', NULL, ''),
(1410, '', '{"void_item":{"id":"66091","date":"2018-02-08 12:44:30","ss_terminal":null,"ss_code":null,"sale_id":"16718","si_item_id":"0","item_id":"302","item_sku":"238","item_name":"Ice on the cake","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-08 12:44:30","serial":"admin-1518051961-15180650701862575","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-08 12:53:08', NULL, ''),
(1411, '', '{"void_item":{"id":"66117","date":"2018-02-08 13:22:30","ss_terminal":null,"ss_code":null,"sale_id":"16723","si_item_id":"0","item_id":"292","item_sku":"227","item_name":"Pork Bacon Aglio Olio","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-08 13:22:30","serial":"admin-1518051961-15180673503685280","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-08 13:48:27', NULL, ''),
(1412, 'lois', '{"void_item":{"id":"66151","date":"2018-02-08 16:39:45","ss_terminal":null,"ss_code":null,"sale_id":"16737","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.00","margin":"0.0000","cost":"0.0000","amount":"2.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-08 16:39:45","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-08 16:40:11', NULL, ''),
(1413, 'lois', '{"void_item":{"id":"66253","date":"2018-02-09 12:20:04","ss_terminal":null,"ss_code":null,"sale_id":"16762","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-09 12:20:04","serial":"admin-1518135973-15181500047126416","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-09 12:20:39', NULL, ''),
(1414, 'sanni', '{"sale":{"id":"16774","txn_no":null,"table_no":"T1","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2018-02-09 15:10:42","payment_status":"Unpaid","cost":null,"subtotal":"10.00","amount":"11.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1518135973","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"66293","date":"2018-02-09 15:10:54","ss_terminal":null,"ss_code":null,"sale_id":"16774","si_item_id":null,"item_id":"44","item_sku":"44","item_name":"Tiger ","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-09 15:10:54","serial":"admin-1518135973-15181602544523658","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"66292","date":"2018-02-09 15:10:42","ss_terminal":null,"ss_code":null,"sale_id":"16774","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.00","margin":"0.0000","cost":"0.0000","amount":"1.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-09 15:10:42","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2018-02-09 15:11:36', NULL, ''),
(1415, 'lois', '{"sale":{"id":"16778","txn_no":null,"table_no":"T10","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2018-02-20 10:03:45","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1519091919","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"66297","date":"2018-02-20 10:03:45","ss_terminal":null,"ss_code":null,"sale_id":"16778","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-20 10:03:45","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2018-02-20 10:59:12', NULL, ''),
(1416, 'lois', '{"sale":{"id":"16780","txn_no":null,"table_no":"T11","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2018-02-21 08:38:27","payment_status":"Unpaid","cost":null,"subtotal":"32.00","amount":"35.20","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1519173495","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"66299","date":"2018-02-21 08:38:27","ss_terminal":null,"ss_code":null,"sale_id":"16780","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"3.20","margin":"0.0000","cost":"0.0000","amount":"3.20","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-21 08:38:27","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"66300","date":"2018-02-21 08:38:37","ss_terminal":null,"ss_code":null,"sale_id":"16780","si_item_id":"0","item_id":"328","item_sku":"264","item_name":"Basic Blueberries Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-21 08:38:37","serial":"admin-1519173495-15191735172111199","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"66301","date":"2018-02-21 08:38:37","ss_terminal":null,"ss_code":null,"sale_id":"16780","si_item_id":"0","item_id":"328","item_sku":"264","item_name":"Basic Blueberries Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-21 08:38:37","serial":"admin-1519173495-15191735172111199","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2018-02-21 08:39:04', NULL, ''),
(1417, 'sanni', '{"void_item":{"id":"66317","date":"2018-02-21 09:26:21","ss_terminal":null,"ss_code":null,"sale_id":"16784","si_item_id":"0","item_id":"60","item_sku":"60","item_name":"The Hulk","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-21 09:26:21","serial":"admin-1519173495-15191763815879580","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-21 09:34:17', NULL, ''),
(1418, 'lois', '{"void_item":{"id":"66352","date":"2018-02-21 12:32:48","ss_terminal":null,"ss_code":null,"sale_id":"16790","si_item_id":"0","item_id":"327","item_sku":"263","item_name":"Gula Melaka Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-21 12:32:48","serial":"admin-1519173495-15191875687301829","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-21 12:33:51', NULL, ''),
(1419, '', '{"void_item":{"id":"66399","date":"2018-02-21 13:54:01","ss_terminal":null,"ss_code":null,"sale_id":"16800","si_item_id":"0","item_id":"299","item_sku":"235","item_name":"Iced Salted Caramel Latte","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-21 13:54:01","serial":"admin-1519190124-15191924409663292","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-21 13:56:10', NULL, ''),
(1420, '', '{"void_item":{"id":"66486","date":"2018-02-22 12:03:56","ss_terminal":null,"ss_code":null,"sale_id":"16821","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-22 12:03:56","serial":"admin-1519261074-15192722360953316","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-22 12:14:22', NULL, ''),
(1421, '', '{"void_item":{"id":"66485","date":"2018-02-22 12:03:56","ss_terminal":null,"ss_code":null,"sale_id":"16821","si_item_id":"0","item_id":"80","item_sku":"80","item_name":"Oriental Chicken Salad","item_option":"","category":"Meals","subcategory":"Salad","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-22 12:03:56","serial":"admin-1519261074-15192722360953316","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-22 12:14:34', NULL, ''),
(1422, '', '{"void_item":{"id":"66497","date":"2018-02-22 12:14:54","ss_terminal":null,"ss_code":null,"sale_id":"16821","si_item_id":"0","item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-22 12:14:54","serial":"admin-1519261074-15192728946205239","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-22 12:15:05', NULL, ''),
(1423, '', '{"void_item":{"id":"66497","date":"2018-02-22 12:14:54","ss_terminal":null,"ss_code":null,"sale_id":"16821","si_item_id":"0","item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"16.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-22 12:14:54","serial":"admin-1519261074-15192728946205239","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-22 12:15:18', NULL, ''),
(1424, '', '{"void_item":{"id":"66500","date":"2018-02-22 12:28:11","ss_terminal":null,"ss_code":null,"sale_id":"16824","si_item_id":"0","item_id":"78","item_sku":"78","item_name":"Cheesy Baked Mashed Potato","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-22 12:28:11","serial":"admin-1519261074-15192736909304513","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-22 12:29:47', NULL, ''),
(1425, '', '{"void_item":{"id":"66711","date":"2018-02-24 10:40:37","ss_terminal":null,"ss_code":null,"sale_id":"16873","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"total 3 eggs","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"22.50","margin":"22.5000","cost":"0.0000","amount":"22.50","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-24 10:40:37","serial":"admin-1519433982-1519440037758715","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-24 10:44:13', NULL, ''),
(1426, '', '{"void_item":{"id":"66814","date":"2018-02-24 12:08:43","ss_terminal":null,"ss_code":null,"sale_id":"16889","si_item_id":"0","item_id":"166","item_sku":"100","item_name":"Chocolate Dose ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-24 12:08:43","serial":"admin-1519433982-15194453235179338","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-24 12:35:24', NULL, ''),
(1427, '', '{"void_item":{"id":"66812","date":"2018-02-24 12:08:43","ss_terminal":null,"ss_code":null,"sale_id":"16889","si_item_id":"0","item_id":"170","item_sku":"104","item_name":"Daily Cheese ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-24 12:08:43","serial":"admin-1519433982-15194453235179338","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-24 12:35:36', NULL, ''),
(1428, '', '{"void_item":{"id":"66813","date":"2018-02-24 12:08:43","ss_terminal":null,"ss_code":null,"sale_id":"16889","si_item_id":"0","item_id":"170","item_sku":"104","item_name":"Daily Cheese ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-24 12:08:43","serial":"admin-1519433982-15194453235179338","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-24 12:35:46', NULL, ''),
(1429, '', '{"void_item":{"id":"66815","date":"2018-02-24 12:08:43","ss_terminal":null,"ss_code":null,"sale_id":"16889","si_item_id":"0","item_id":"166","item_sku":"100","item_name":"Chocolate Dose ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-24 12:08:43","serial":"admin-1519433982-15194453235179338","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-24 12:35:54', NULL, ''),
(1430, '', '{"void_item":{"id":"66825","date":"2018-02-24 12:39:51","ss_terminal":null,"ss_code":null,"sale_id":"16890","si_item_id":null,"item_id":"23","item_sku":"23","item_name":"Lemon Tea","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-24 12:39:51","serial":"admin-1519433982-15194471911683831","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-24 12:42:23', NULL, ''),
(1431, 'sanni', '{"sale":{"id":"16910","txn_no":"116371","table_no":"T1","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2018-02-24 14:56:04","payment_status":"Paid","cost":null,"subtotal":"84.00","amount":"92.40","amount_cash":"92.40","amount_cc":null,"amount_tendered":"100.00","amount_change":"7.60","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1519433982","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"66924","date":"2018-02-24 14:06:54","ss_terminal":null,"ss_code":null,"sale_id":"16910","si_item_id":null,"item_id":"63","item_sku":"63","item_name":"Lime","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1519433982","ordered_by":"admin","ordered_time":"2018-02-24 14:06:54","serial":"admin-1519433982-15194524146143316","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"66925","date":"2018-02-24 14:06:54","ss_terminal":null,"ss_code":null,"sale_id":"16910","si_item_id":null,"item_id":"4","item_sku":"4","item_name":"Piccolo","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1519433982","ordered_by":"admin","ordered_time":"2018-02-24 14:06:54","serial":"admin-1519433982-15194524146143316","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"66923","date":"2018-02-24 14:06:54","ss_terminal":null,"ss_code":null,"sale_id":"16910","si_item_id":null,"item_id":"67","item_sku":"67","item_name":"Carrot milk","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1519433982","ordered_by":"admin","ordered_time":"2018-02-24 14:06:54","serial":"admin-1519433982-15194524146143316","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"66919","date":"2018-02-24 14:06:54","ss_terminal":null,"ss_code":null,"sale_id":"16910","si_item_id":"0","item_id":"207","item_sku":"142","item_name":"Cheesy Bacon Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":"1","terminal":"27","printed":"1","session":"1519433982","ordered_by":"admin","ordered_time":"2018-02-24 14:06:54","serial":"admin-1519433982-15194524146143316","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"66920","date":"2018-02-24 14:06:54","ss_terminal":null,"ss_code":null,"sale_id":"16910","si_item_id":"0","item_id":"154","item_sku":"88","item_name":"Daily Dose BLT","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":"16.0000","cost":"0.0000","amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1519433982","ordered_by":"admin","ordered_time":"2018-02-24 14:06:54","serial":"admin-1519433982-15194524146143316","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"66918","date":"2018-02-24 14:06:13","ss_terminal":null,"ss_code":null,"sale_id":"16910","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"8.40","margin":"0.0000","cost":"0.0000","amount":"8.40","sold":"1","terminal":"27","printed":"1","session":"1519433982","ordered_by":"admin","ordered_time":"2018-02-24 14:06:13","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"66922","date":"2018-02-24 14:06:54","ss_terminal":null,"ss_code":null,"sale_id":"16910","si_item_id":"0","item_id":"78","item_sku":"78","item_name":"Cheesy Baked Mashed Potato","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1519433982","ordered_by":"admin","ordered_time":"2018-02-24 14:06:54","serial":"admin-1519433982-15194524146143316","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"66921","date":"2018-02-24 14:06:54","ss_terminal":null,"ss_code":null,"sale_id":"16910","si_item_id":"0","item_id":"157","item_sku":"91","item_name":"Classic French Toast","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":"1","terminal":"27","printed":"1","session":"1519433982","ordered_by":"admin","ordered_time":"2018-02-24 14:06:54","serial":"admin-1519433982-15194524146143316","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2018-02-24 14:57:13', 1, ''),
(1432, '', '{"void_item":{"id":"66925","date":"2018-02-24 14:06:54","ss_terminal":null,"ss_code":null,"sale_id":"16910","si_item_id":null,"item_id":"4","item_sku":"4","item_name":"Piccolo","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1519433982","ordered_by":"admin","ordered_time":"2018-02-24 14:06:54","serial":"admin-1519433982-15194524146143316","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-24 14:57:24', NULL, ''),
(1433, '', '{"void_item":{"id":"66922","date":"2018-02-24 14:06:54","ss_terminal":null,"ss_code":null,"sale_id":"16910","si_item_id":"0","item_id":"78","item_sku":"78","item_name":"Cheesy Baked Mashed Potato","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":"1","terminal":"27","printed":"1","session":"1519433982","ordered_by":"admin","ordered_time":"2018-02-24 14:06:54","serial":"admin-1519433982-15194524146143316","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-24 14:57:36', NULL, ''),
(1434, '', '{"sale":{"id":"16917","txn_no":null,"table_no":"T10","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2018-02-24 15:55:04","payment_status":"Unpaid","cost":null,"subtotal":"22.00","amount":"24.20","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1519433982","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"66956","date":"2018-02-24 15:55:15","ss_terminal":null,"ss_code":null,"sale_id":"16917","si_item_id":"0","item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-24 15:55:15","serial":"admin-1519433982-15194589152321560","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"66955","date":"2018-02-24 15:55:04","ss_terminal":null,"ss_code":null,"sale_id":"16917","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"2.20","margin":"0.0000","cost":"0.0000","amount":"2.20","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-24 15:55:04","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"66957","date":"2018-02-24 15:55:15","ss_terminal":null,"ss_code":null,"sale_id":"16917","si_item_id":"0","item_id":"19","item_sku":"19","item_name":"Iced Vanilla Latte","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-24 15:55:15","serial":"admin-1519433982-15194589152321560","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2018-02-24 15:55:41', NULL, ''),
(1435, '', '{"void_item":{"id":"66959","date":"2018-02-24 16:05:20","ss_terminal":null,"ss_code":null,"sale_id":"16918","si_item_id":null,"item_id":"46","item_sku":"46","item_name":"Coke","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"5.00","margin":"5.0000","cost":"0.0000","amount":"5.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-24 16:05:20","serial":"admin-1519433982-15194595204547911","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":"1","discount":null,"global_discount":null}}', '2018-02-24 16:05:40', NULL, ''),
(1436, '', '{"sale":{"id":"16942","txn_no":"116401","table_no":"T4(S)","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2018-02-25 10:54:18","payment_status":"Paid","cost":null,"subtotal":"38.00","amount":"41.80","amount_cash":"41.80","amount_cc":null,"amount_tendered":"50.00","amount_change":"8.20","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1519520119","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":null,"customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":null},"sale_items":[{"id":"67035","date":"2018-02-25 00:00:00","ss_terminal":null,"ss_code":null,"sale_id":"16942","si_item_id":"0","item_id":"156","item_sku":"90","item_name":"House Cheddar Omelet","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"13.00","margin":null,"cost":null,"amount":"13.00","sold":"1","terminal":"27","printed":"1","session":"1519520119","ordered_by":"admin","ordered_time":"2018-02-25 10:06:28","serial":"admin-1519520119-15195243886144655","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"67036","date":"2018-02-25 00:00:00","ss_terminal":null,"ss_code":null,"sale_id":"16942","si_item_id":"0","item_id":"158","item_sku":"92","item_name":"Banana Stuffed Nutella Toast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":null,"cost":null,"amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1519520119","ordered_by":"admin","ordered_time":"2018-02-25 10:06:28","serial":"admin-1519520119-15195243886144655","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"67038","date":"2018-02-25 10:54:11","ss_terminal":null,"ss_code":null,"sale_id":"16942","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"","category":"SERVICE CHARGE","subcategory":"SERVICE CHARGE","qty":"1","price_per_unit":"3.80","margin":"0.0000","cost":"0.0000","amount":"3.80","sold":"1","terminal":"27","printed":"1","session":"1519520119","ordered_by":"admin","ordered_time":"2018-02-25 10:54:11","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"67037","date":"2018-02-25 00:00:00","ss_terminal":null,"ss_code":null,"sale_id":"16942","si_item_id":null,"item_id":"62","item_sku":"62","item_name":"Orange","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":null,"cost":null,"amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1519520119","ordered_by":"admin","ordered_time":"2018-02-25 10:06:28","serial":"admin-1519520119-15195243886144655","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2018-02-25 10:54:55', 1, ''),
(1437, '', '{"void_item":{"id":"67036","date":"2018-02-25 00:00:00","ss_terminal":null,"ss_code":null,"sale_id":"16942","si_item_id":"0","item_id":"158","item_sku":"92","item_name":"Banana Stuffed Nutella Toast ","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"16.00","margin":null,"cost":null,"amount":"16.00","sold":"1","terminal":"27","printed":"1","session":"1519520119","ordered_by":"admin","ordered_time":"2018-02-25 10:06:28","serial":"admin-1519520119-15195243886144655","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-25 10:55:09', NULL, ''),
(1438, 'sanni', '{"void_item":{"id":"67144","date":"2018-02-25 13:19:13","ss_terminal":null,"ss_code":null,"sale_id":"16957","si_item_id":"0","item_id":"287","item_sku":"221","item_name":"Meatless Red Pasta","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-25 13:19:13","serial":"admin-1519520119-15195359529937289","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-25 13:50:09', NULL, ''),
(1439, 'sanni', '{"void_item":{"id":"67125","date":"2018-02-25 12:51:38","ss_terminal":null,"ss_code":null,"sale_id":"16957","si_item_id":"0","item_id":"291","item_sku":"225","item_name":"Smoked Duck Red Pasta","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"23.00","margin":"23.0000","cost":"0.0000","amount":"23.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-25 12:51:38","serial":"admin-1519520119-15195342981806360","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-25 13:54:20', NULL, ''),
(1440, 'sanni', '{"void_item":{"id":"67132","date":"2018-02-25 12:51:38","ss_terminal":null,"ss_code":null,"sale_id":"16957","si_item_id":"0","item_id":"29","item_sku":"29","item_name":"Iced Lemon Tea","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-25 12:51:38","serial":"admin-1519520119-15195342981806360","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-25 13:54:36', NULL, ''),
(1441, 'sanni', '{"void_item":{"id":"67166","date":"2018-02-25 14:07:28","ss_terminal":null,"ss_code":null,"sale_id":"16962","si_item_id":"0","item_id":"76","item_sku":"76","item_name":"Meatless Pesto Pasta","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"17.00","margin":"17.0000","cost":"0.0000","amount":"17.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-25 14:07:28","serial":"admin-1519520119-15195388482359791","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-25 14:12:10', NULL, ''),
(1442, 'lois', '{"void_item":{"id":"67190","date":"2018-02-25 16:04:06","ss_terminal":null,"ss_code":null,"sale_id":"16970","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-25 16:04:06","serial":"admin-1519520119-15195458458482346","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-25 16:23:09', NULL, ''),
(1443, 'lois', '{"void_item":{"id":"67205","date":"2018-02-25 16:53:08","ss_terminal":null,"ss_code":null,"sale_id":"16973","si_item_id":null,"item_id":"63","item_sku":"63","item_name":"Lime","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-25 16:53:08","serial":"admin-1519520119-15195487880538696","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-25 16:57:05', NULL, '');
INSERT INTO `fnb_reverts` (`id`, `performed_by`, `data`, `datetime`, `revert`, `remarks`) VALUES
(1444, 'lois', '{"void_item":{"id":"67203","date":"2018-02-25 16:53:08","ss_terminal":null,"ss_code":null,"sale_id":"16973","si_item_id":null,"item_id":"63","item_sku":"63","item_name":"Lime","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-25 16:53:08","serial":"admin-1519520119-15195487880538696","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-25 16:57:15', NULL, ''),
(1445, 'lois', '{"void_item":{"id":"67204","date":"2018-02-25 16:53:08","ss_terminal":null,"ss_code":null,"sale_id":"16973","si_item_id":null,"item_id":"63","item_sku":"63","item_name":"Lime","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-25 16:53:08","serial":"admin-1519520119-15195487880538696","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-25 16:57:24', NULL, ''),
(1446, 'lois', '{"void_item":{"id":"67357","date":"2018-02-28 11:37:14","ss_terminal":null,"ss_code":null,"sale_id":"17013","si_item_id":"0","item_id":"170","item_sku":"104","item_name":"Daily Cheese ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"10.00","margin":"10.0000","cost":"0.0000","amount":"10.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-28 11:37:14","serial":"admin-1519780133-15197890347129247","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-28 11:44:42', NULL, ''),
(1447, 'lois', '{"void_item":{"id":"67363","date":"2018-02-28 12:17:15","ss_terminal":null,"ss_code":null,"sale_id":"17014","si_item_id":"0","item_id":"153","item_sku":"87","item_name":"Wake Me Up!","item_option":"","category":"Meals","subcategory":"Morning Bites ","qty":"1","price_per_unit":"21.00","margin":"21.0000","cost":"0.0000","amount":"21.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-02-28 12:17:15","serial":"admin-1519780133-15197914350076152","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-02-28 13:08:28', NULL, ''),
(1448, 'sanni', '{"sale":{"id":"17024","txn_no":"116484","table_no":"T15","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"history","datetime":"2018-02-28 14:15:04","payment_status":"Paid","cost":null,"subtotal":"73.00","amount":"80.30","amount_cash":"80.30","amount_cc":null,"amount_tendered":"100.30","amount_change":"20.00","amount_voucher":"0.00","amount_cheque":"0.00","amount_discount":null,"adjustment":"0.00","payment_method":"Cash","payment_details":null,"terminal":"27","session":"1519780133","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"67406","date":"2018-02-28 13:20:26","ss_terminal":null,"ss_code":null,"sale_id":"17024","si_item_id":"0","item_id":"292","item_sku":"227","item_name":"Pork Bacon Aglio Olio","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"20.00","margin":"20.0000","cost":"0.0000","amount":"20.00","sold":"1","terminal":"27","printed":"1","session":"1519780133","ordered_by":"admin","ordered_time":"2018-02-28 13:20:26","serial":"admin-1519780133-15197952263986123","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"67407","date":"2018-02-28 13:20:26","ss_terminal":null,"ss_code":null,"sale_id":"17024","si_item_id":"0","item_id":"160","item_sku":"94","item_name":"Signature Dumpling (5 Pcs)","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1519780133","ordered_by":"admin","ordered_time":"2018-02-28 13:20:26","serial":"admin-1519780133-15197952263986123","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"67408","date":"2018-02-28 13:20:26","ss_terminal":null,"ss_code":null,"sale_id":"17024","si_item_id":"0","item_id":"209","item_sku":"143","item_name":"Honey Lemon","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":"1","terminal":"27","printed":"1","session":"1519780133","ordered_by":"admin","ordered_time":"2018-02-28 13:20:26","serial":"admin-1519780133-15197952263986123","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"67409","date":"2018-02-28 13:20:26","ss_terminal":null,"ss_code":null,"sale_id":"17024","si_item_id":null,"item_id":"62","item_sku":"62","item_name":"Orange","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1519780133","ordered_by":"admin","ordered_time":"2018-02-28 13:20:26","serial":"admin-1519780133-15197952263986123","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"67410","date":"2018-02-28 13:20:26","ss_terminal":null,"ss_code":null,"sale_id":"17024","si_item_id":null,"item_id":"62","item_sku":"62","item_name":"Orange","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":"1","terminal":"27","printed":"1","session":"1519780133","ordered_by":"admin","ordered_time":"2018-02-28 13:20:26","serial":"admin-1519780133-15197952263986123","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"67405","date":"2018-02-28 13:20:26","ss_terminal":null,"ss_code":null,"sale_id":"17024","si_item_id":"0","item_id":"80","item_sku":"80","item_name":"Oriental Chicken Salad","item_option":"","category":"Meals","subcategory":"Salad","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":"1","terminal":"27","printed":"1","session":"1519780133","ordered_by":"admin","ordered_time":"2018-02-28 13:20:26","serial":"admin-1519780133-15197952263986123","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"67404","date":"2018-02-28 13:19:47","ss_terminal":null,"ss_code":null,"sale_id":"17024","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"7.30","margin":"0.0000","cost":"0.0000","amount":"7.30","sold":"1","terminal":"27","printed":"1","session":"1519780133","ordered_by":"admin","ordered_time":"2018-02-28 13:19:47","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2018-02-28 14:50:28', 1, ''),
(1449, 'sanni', '{"sale":{"id":"17025","txn_no":null,"table_no":"IS","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2018-02-28 15:01:58","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1519780133","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"1","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[]}', '2018-02-28 15:33:33', NULL, ''),
(1450, 'sanni', '{"void_item":{"id":"67508","date":"2018-03-02 12:04:43","ss_terminal":null,"ss_code":null,"sale_id":"17054","si_item_id":"0","item_id":"320","item_sku":"256","item_name":"AA Set - Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-02 12:04:43","serial":"admin-1519952075-15199634838408617","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-03-02 12:15:25', NULL, ''),
(1451, '', '{"void_item":{"id":"67515","date":"2018-03-02 12:11:15","ss_terminal":null,"ss_code":null,"sale_id":"17056","si_item_id":"0","item_id":"320","item_sku":"256","item_name":"AA Set - Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-02 12:11:15","serial":"admin-1519952075-15199638752897667","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-03-02 12:40:22', NULL, ''),
(1452, 'sanni', '{"sale":{"id":"17066","txn_no":null,"table_no":"T2(S)","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2018-03-02 15:35:03","payment_status":"Unpaid","cost":null,"subtotal":"39.00","amount":"38.60","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":"4.29","adjustment":"-0.01","payment_method":null,"payment_details":null,"terminal":"27","session":"1519952075","discount_type":"p","discount":"10","payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"67561","date":"2018-03-02 16:00:57","ss_terminal":null,"ss_code":null,"sale_id":"17066","si_item_id":"0","item_id":"277","item_sku":"211","item_name":"Iced Ginger Lemongrass","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-02 16:00:57","serial":"admin-1519952075-1519977657758461","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"67565","date":"2018-03-02 16:08:18","ss_terminal":null,"ss_code":null,"sale_id":"17066","si_item_id":"0","item_id":"172","item_sku":"106","item_name":"Daily Berries ","item_option":"","category":"Desserts","subcategory":"0","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-02 16:08:18","serial":"admin-1519952075-15199780980781481","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"67559","date":"2018-03-02 15:35:15","ss_terminal":null,"ss_code":null,"sale_id":"17066","si_item_id":"0","item_id":"277","item_sku":"211","item_name":"Iced Ginger Lemongrass","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-02 15:35:15","serial":"admin-1519952075-15199761152512013","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"67558","date":"2018-03-02 15:35:03","ss_terminal":null,"ss_code":null,"sale_id":"17066","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"3.90","margin":"0.0000","cost":"0.0000","amount":"3.90","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-02 15:35:03","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"67560","date":"2018-03-02 15:35:15","ss_terminal":null,"ss_code":null,"sale_id":"17066","si_item_id":"0","item_id":"277","item_sku":"211","item_name":"Iced Ginger Lemongrass","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"9.00","margin":"9.0000","cost":"0.0000","amount":"9.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-02 15:35:15","serial":"admin-1519952075-15199761152512013","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2018-03-02 16:54:55', NULL, ''),
(1453, '', '{"void_item":{"id":"67663","date":"2018-03-03 12:17:47","ss_terminal":null,"ss_code":null,"sale_id":"17095","si_item_id":"0","item_id":"3","item_sku":"3","item_name":"Americano","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-03 12:17:47","serial":"admin-1520038141-15200506678472289","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-03-03 12:33:58', NULL, ''),
(1454, '', '{"void_item":{"id":"67685","date":"2018-03-03 14:01:36","ss_terminal":null,"ss_code":null,"sale_id":"17100","si_item_id":"0","item_id":"323","item_sku":"259","item_name":"Ginger Cucumber Lemon Soda","item_option":"","category":"Cold Drinks","subcategory":"Refreshing Drinks","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-03 14:01:36","serial":"admin-1520038141-15200568958945570","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-03-03 14:05:53', NULL, ''),
(1455, 'admin', '{"void_item":{"id":"67739","date":"2018-03-03 16:57:14","ss_terminal":null,"ss_code":null,"sale_id":"17113","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"1.20","margin":"0.0000","cost":"0.0000","amount":"1.20","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-03 16:57:14","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":"10.0","global_discount":null}}', '2018-03-03 16:58:47', NULL, 'Reason 2'),
(1456, 'sanni', '{"void_item":{"id":"67740","date":"2018-03-03 16:57:23","ss_terminal":null,"ss_code":null,"sale_id":"17113","si_item_id":"0","item_id":"14","item_sku":"14","item_name":"Iced Cappucino ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-03 16:57:23","serial":"admin-1520038141-15200674433053318","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-03-03 16:59:45', NULL, ''),
(1457, 'sanni', '{"sale":{"id":"17113","txn_no":null,"table_no":"T5","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2018-03-03 16:57:14","payment_status":"Unpaid","cost":null,"subtotal":"12.00","amount":"12.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1520038141","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"67741","date":"2018-03-03 16:59:52","ss_terminal":null,"ss_code":null,"sale_id":"17113","si_item_id":"0","item_id":"14","item_sku":"14","item_name":"Iced Cappucino ","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-03 16:59:52","serial":"admin-1520038141-15200675919844964","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2018-03-03 17:00:20', NULL, ''),
(1458, 'sanni', '{"void_item":{"id":"67736","date":"2018-03-03 16:48:08","ss_terminal":null,"ss_code":null,"sale_id":"17112","si_item_id":"0","item_id":"27","item_sku":"27","item_name":"Iced Chocolate ","item_option":"","category":"Cold Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-03 16:48:08","serial":"admin-1520038141-15200668885008754","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-03-03 17:01:29', NULL, ''),
(1459, 'sanni', '{"void_item":{"id":"67737","date":"2018-03-03 16:48:39","ss_terminal":null,"ss_code":null,"sale_id":"17112","si_item_id":"0","item_id":"2","item_sku":"2","item_name":"Espresso Macchiato ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-03 16:48:39","serial":"admin-1520038141-15200669191112846","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-03-03 17:01:55', NULL, ''),
(1460, 'lois', '{"void_item":{"id":"67871","date":"2018-03-04 10:53:16","ss_terminal":null,"ss_code":null,"sale_id":"17134","si_item_id":"0","item_id":"38","item_sku":"38","item_name":"Mixed Berries Smoothie","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-04 10:53:16","serial":"admin-1520125217-15201319963384050","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-03-04 11:03:05', NULL, ''),
(1461, 'sanni', '{"void_item":{"id":"67884","date":"2018-03-04 11:01:15","ss_terminal":null,"ss_code":null,"sale_id":"17137","si_item_id":null,"item_id":"5","item_sku":"5","item_name":"Cappuccino ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-04 11:01:15","serial":"admin-1520125217-15201324750297796","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-03-04 11:14:53', NULL, ''),
(1462, '', '{"void_item":{"id":"67901","date":"2018-03-04 12:02:15","ss_terminal":null,"ss_code":null,"sale_id":"17141","si_item_id":null,"item_id":"22","item_sku":"22","item_name":"Honey Milk","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-04 12:02:15","serial":"admin-1520125217-15201361352818260","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-03-04 12:09:32', NULL, ''),
(1463, '', '{"void_item":{"id":"67915","date":"2018-03-04 12:31:45","ss_terminal":null,"ss_code":null,"sale_id":"17145","si_item_id":"0","item_id":"267","item_sku":"201","item_name":"Cocoa Cappucino","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-04 12:31:45","serial":"admin-1520125217-15201379056927351","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-03-04 12:32:34', NULL, ''),
(1464, '', '{"void_item":{"id":"67937","date":"2018-03-04 13:02:43","ss_terminal":null,"ss_code":null,"sale_id":"17149","si_item_id":"0","item_id":"77","item_sku":"77","item_name":"Sarawak Kolomee","item_option":"","category":"Meals","subcategory":"Non-Rice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-04 13:02:43","serial":"admin-1520125217-15201397638002986","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-03-04 13:03:33', NULL, ''),
(1465, 'sanni', '{"sale":{"id":"17145","txn_no":null,"table_no":"T4","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2018-03-04 12:31:33","payment_status":"Unpaid","cost":null,"subtotal":"30.00","amount":"33.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1520125217","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"67914","date":"2018-03-04 12:31:33","ss_terminal":null,"ss_code":null,"sale_id":"17145","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"3.00","margin":"0.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-04 12:31:33","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null},{"id":"67916","date":"2018-03-04 12:31:45","ss_terminal":null,"ss_code":null,"sale_id":"17145","si_item_id":"0","item_id":"20","item_sku":"20","item_name":"Iced DD Special","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-04 12:31:45","serial":"admin-1520125217-15201379056927351","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null},{"id":"67917","date":"2018-03-04 12:32:40","ss_terminal":null,"ss_code":null,"sale_id":"17145","si_item_id":"0","item_id":"268","item_sku":"202","item_name":"Iced Cocoa Cappucino","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"15.00","margin":"15.0000","cost":"0.0000","amount":"15.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-04 12:32:40","serial":"admin-1520125217-15201379605066412","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}]}', '2018-03-04 15:31:45', NULL, ''),
(1466, '', '{"void_item":{"id":"67980","date":"2018-03-05 09:00:42","ss_terminal":null,"ss_code":null,"sale_id":"17159","si_item_id":"0","item_id":"181","item_sku":"116","item_name":"Open Food ","item_option":"Junior BLT","category":"Meals","subcategory":"Perfect Meals","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-05 09:00:42","serial":"admin-1520211607-15202116423851460","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-03-05 09:53:36', NULL, ''),
(1467, 'sanni', '{"void_item":{"id":"68015","date":"2018-03-05 11:54:32","ss_terminal":null,"ss_code":null,"sale_id":"17165","si_item_id":"0","item_id":"41","item_sku":"41","item_name":"Blueberry Smoothies","item_option":"","category":"Cold Drinks","subcategory":"Smoothie","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-05 11:54:32","serial":"admin-1520211607-15202220721542916","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-03-05 11:58:54', NULL, ''),
(1468, '', '{"void_item":{"id":"68020","date":"2018-03-05 11:59:19","ss_terminal":null,"ss_code":null,"sale_id":"17168","si_item_id":"0","item_id":"332","item_sku":"268","item_name":"Chickpeas & Pumpkin Salad ","item_option":"","category":"Meals","subcategory":"Salad","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-05 11:59:19","serial":"admin-1520211607-1520222358875836","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-03-05 12:03:43', NULL, ''),
(1469, '', '{"void_item":{"id":"68059","date":"2018-03-05 12:52:06","ss_terminal":null,"ss_code":null,"sale_id":"17171","si_item_id":"0","item_id":"303","item_sku":"239","item_name":"Pan Fried Dumpling","item_option":"","category":"Meals","subcategory":"Snacks ","qty":"1","price_per_unit":"18.00","margin":"18.0000","cost":"0.0000","amount":"18.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-05 12:52:06","serial":"admin-1520211607-15202255262749223","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-03-05 12:52:57', NULL, ''),
(1470, '', '{"void_item":{"id":"68083","date":"2018-03-05 13:53:00","ss_terminal":null,"ss_code":null,"sale_id":"17183","si_item_id":"0","item_id":"185","item_sku":"120","item_name":"Bottled Water","item_option":"","category":"Cold Drinks","subcategory":"Soda & Beer","qty":"1","price_per_unit":"3.00","margin":"3.0000","cost":"0.0000","amount":"3.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-05 13:53:00","serial":"admin-1520211607-15202291806703761","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-03-05 13:56:29', NULL, ''),
(1471, 'sanni', '{"void_item":{"id":"68115","date":"2018-03-07 11:41:32","ss_terminal":null,"ss_code":null,"sale_id":"17193","si_item_id":"0","item_id":"335","item_sku":"271","item_name":"Iced Honey Latte","item_option":"","category":"Cold Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"14.00","margin":"14.0000","cost":"0.0000","amount":"14.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-07 11:41:32","serial":"admin-1520385034-15203940925251633","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-03-07 11:41:44', NULL, ''),
(1472, '', '{"void_item":{"id":"68113","date":"2018-03-07 11:40:26","ss_terminal":null,"ss_code":null,"sale_id":"17192","si_item_id":null,"item_id":"6","item_sku":"6","item_name":"Latte ","item_option":"","category":"Hot Drinks","subcategory":"Coffee","qty":"1","price_per_unit":"11.00","margin":"11.0000","cost":"0.0000","amount":"11.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-07 11:40:26","serial":"admin-1520385034-1520394026725410","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-03-07 11:54:43', NULL, ''),
(1473, '', '{"void_item":{"id":"68174","date":"2018-03-07 14:53:34","ss_terminal":null,"ss_code":null,"sale_id":"17208","si_item_id":"0","item_id":"236","item_sku":"170","item_name":"Vanilla Milk","item_option":"","category":"Hot Drinks","subcategory":"Non Coffee","qty":"1","price_per_unit":"8.00","margin":"8.0000","cost":"0.0000","amount":"8.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-07 14:53:34","serial":"admin-1520385034-1520405614263958","warehouse_id":"1","taxable":"0","tax_code":"","instant_sale":null,"discount":null,"global_discount":null}}', '2018-03-07 14:53:40', NULL, ''),
(1474, 'sanni', '{"sale":{"id":"17204","txn_no":null,"table_no":"T5","user_id":"10003","username":"admin","employee_id":null,"employee_username":null,"type":"queue","datetime":"2018-03-07 14:21:02","payment_status":"Unpaid","cost":null,"subtotal":null,"amount":"0.00","amount_cash":null,"amount_cc":null,"amount_tendered":null,"amount_change":null,"amount_voucher":null,"amount_cheque":null,"amount_discount":null,"adjustment":"0.00","payment_method":null,"payment_details":null,"terminal":"27","session":"1520385034","discount_type":null,"discount":null,"payment":null,"verified":"1","warehouse_Id":null,"taxes":"null","taxable_amount":null,"tax_amount":null,"cc_type":null,"cc_fee":null,"cc_name":null,"cc_percentage":null,"cc_tax_percentage":null,"cc_tax":null,"cc_amount":null,"no_of_pax":"0","customer_id":null,"customer":null,"service_charge":null,"recon_date":null,"table_card_no":"0"},"sale_items":[{"id":"68162","date":"2018-03-07 14:21:02","ss_terminal":null,"ss_code":null,"sale_id":"17204","si_item_id":"0","item_id":"0","item_sku":"_SC","item_name":"Service Charge (10%)","item_option":"SERVICE CHARGE","category":"SERVICE CHARGE","subcategory":"","qty":"1","price_per_unit":"0.00","margin":"0.0000","cost":"0.0000","amount":"0.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-07 14:21:02","serial":"0","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}]}', '2018-03-07 15:01:49', NULL, ''),
(1475, '', '{"void_item":{"id":"68358","date":"2018-03-09 12:19:22","ss_terminal":null,"ss_code":null,"sale_id":"17251","si_item_id":"0","item_id":"59","item_sku":"59","item_name":"Sunshine","item_option":"","category":"Cold Drinks","subcategory":"Fresh Juice","qty":"1","price_per_unit":"12.00","margin":"12.0000","cost":"0.0000","amount":"12.00","sold":null,"terminal":"27","printed":"1","session":null,"ordered_by":"admin","ordered_time":"2018-03-09 12:19:22","serial":"admin-1520557159-15205691622513136","warehouse_id":"1","taxable":"1","tax_code":"SR","instant_sale":null,"discount":null,"global_discount":null}}', '2018-03-09 12:33:51', NULL, '');

-- --------------------------------------------------------

--
-- Table structure for table `fnb_sales`
--

CREATE TABLE `fnb_sales` (
  `id` int(11) NOT NULL,
  `txn_no` varchar(32) DEFAULT NULL,
  `table_no` varchar(128) DEFAULT NULL,
  `user_id` int(11) DEFAULT NULL,
  `username` varchar(128) DEFAULT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `employee_username` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `cost` decimal(20,4) DEFAULT NULL,
  `subtotal` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `amount_cash` decimal(20,2) DEFAULT NULL,
  `amount_cc` decimal(20,2) DEFAULT NULL,
  `amount_tendered` decimal(20,2) DEFAULT NULL,
  `amount_change` decimal(20,2) DEFAULT NULL,
  `amount_voucher` decimal(20,2) DEFAULT NULL,
  `amount_cheque` decimal(20,2) DEFAULT NULL,
  `amount_discount` varchar(128) DEFAULT NULL,
  `adjustment` decimal(10,2) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `payment_details` text,
  `terminal` varchar(32) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `discount_type` varchar(128) DEFAULT NULL,
  `discount` varchar(128) DEFAULT NULL,
  `payment` text,
  `verified` int(1) DEFAULT '1',
  `warehouse_id` int(11) DEFAULT NULL,
  `taxes` text,
  `taxable_amount` decimal(20,2) DEFAULT NULL,
  `tax_amount` decimal(20,2) DEFAULT NULL,
  `cc_type` int(11) DEFAULT NULL,
  `cc_fee` decimal(20,2) DEFAULT NULL,
  `cc_name` varchar(32) DEFAULT NULL,
  `cc_percentage` decimal(20,2) DEFAULT NULL,
  `cc_tax_percentage` decimal(20,2) DEFAULT NULL,
  `cc_tax` decimal(20,2) DEFAULT NULL,
  `cc_amount` decimal(20,2) DEFAULT NULL,
  `no_of_pax` int(11) DEFAULT NULL,
  `customer_id` int(11) DEFAULT NULL,
  `customer` varchar(255) DEFAULT NULL,
  `service_charge` decimal(20,2) DEFAULT NULL,
  `recon_date` date DEFAULT NULL,
  `table_card_no` varchar(255) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `fnb_sales`
--

INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(1, '100002', 'B1', 10003, 'admin', NULL, NULL, 'history', '2016-06-07 21:49:06', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '70.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465306097', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3, '100003', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-06-07 21:50:17', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465306097', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2, '100001', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-06-07 21:47:08', 'Paid', NULL, '28.00', '28.00', '0.00', '28.00', '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1465306097', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '0.50', 'Master Card', '1.80', NULL, '0.03', '27.47', 0, NULL, NULL, NULL, NULL, '0'),
(21, '100010', 'T12', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 12:46:29', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16, '100021', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 14:39:19', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '102.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17, '100007', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 11:53:40', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '25.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(20, '100009', 'T12', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 12:45:37', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13, '100006', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 10:57:24', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '100.00', '77.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12, '100005', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 10:40:28', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(19, '100008', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 12:34:13', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9, '100004', 'T10', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 10:13:27', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(22, '100011', 'T5', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 12:47:42', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(23, '100012', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 12:48:25', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(24, '100013', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 13:02:33', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '20.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(25, '100014', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 13:03:31', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(26, '100015', 'T15', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 13:05:04', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '22.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(27, '100017', 'T12', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 13:33:42', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(28, '100025', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 15:33:02', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(29, '100016', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 13:21:31', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(30, '100018', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 13:58:47', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(31, '100019', 'T11(S)', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 14:03:00', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(32, '100024', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 15:13:19', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(33, '100020', 'T10', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 14:14:16', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(34, '100022', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 14:57:19', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '55.00', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(41, '100026', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 16:52:36', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(37, '100024', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-06-09 15:19:35', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(40, '100027', 'T10', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 12:49:29', 'Paid', NULL, '155.00', '155.00', '155.00', NULL, '155.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465533868', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(64, '100052', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 15:53:03', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(65, '100048', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 14:16:18', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '15.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(66, '100050', 'T15', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 15:24:31', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '58.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(62, '100047', 'T9', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 13:44:20', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(63, '100045', 'B1', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 13:30:36', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(61, '100049', '11', 10003, 'admin', NULL, NULL, 'history', '2016-06-10 14:38:22', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '100.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(60, '100046', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-10 13:37:04', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(59, '100044', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-10 13:04:58', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '59.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(58, '100043', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-10 13:04:36', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(57, '100042', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-10 13:04:23', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(56, '100041', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-10 13:04:02', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(55, '100040', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-10 13:03:53', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(54, '100039', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-10 13:03:04', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(53, '100038', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-10 13:02:31', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(52, '100037', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-10 13:02:10', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(51, '100036', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-10 13:01:57', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(50, '100035', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-10 13:01:32', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(49, '100034', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-10 13:00:15', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(48, '100033', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-10 13:00:06', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(47, '100032', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-10 12:59:57', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(46, '100031', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-10 12:59:41', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(44, '100029', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-10 12:58:47', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(45, '100030', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-10 12:59:24', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(43, '100028', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-10 12:57:56', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(67, '100054', 'T10', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 16:04:36', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(68, '100058', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 16:25:33', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(69, '100051', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 15:51:53', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(70, '100053', 'T8', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 15:56:56', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(71, '100055', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 16:05:07', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(72, '100056', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 16:05:47', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(73, '100057', 'B4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 16:08:41', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(74, '100060', '6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 17:21:42', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '102.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(75, '100059', 'T0', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 17:09:07', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(76, '100070', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 21:48:20', 'Paid', NULL, '309.00', '309.00', '309.00', NULL, '309.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(77, '100061', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 17:25:43', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '100.00', '82.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(78, '100062', 'T15', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 17:58:29', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(79, '100063', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 17:59:39', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(80, '100064', 'T5', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 18:24:19', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(81, '100065', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 18:36:09', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(82, '100067', '9', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 20:23:25', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(83, '100068', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 21:02:09', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '90.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(84, '100066', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 19:56:58', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '55.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(85, '100069', 'T14', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 21:15:21', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(86, '100071', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-10 21:49:03', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465547217', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(119, '100103', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 21:52:14', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(118, '100101', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 20:15:33', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '100.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(117, '100100', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 20:11:28', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(116, '100102', 'T9', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 21:40:00', 'Paid', NULL, '128.00', '128.00', '128.00', NULL, '128.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(115, '100098', 't3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 17:00:27', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(114, '100099', 'B5', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 17:27:13', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '101.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(112, '100094', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 14:36:08', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(113, '100096', 'T0', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 15:12:43', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(110, '100093', 'T14', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 14:00:48', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '70.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(111, '100097', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 16:08:19', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(108, '100092', 'B1', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 13:43:24', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(109, '100095', 'T15', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 14:50:36', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '20.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(107, '100091', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 13:34:18', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '100.00', '53.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(106, '100088', 'T0', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 12:46:20', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '25.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(105, '100087', 'T5', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 12:43:12', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(104, '100086', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 12:40:10', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(103, '100089', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 12:48:25', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(102, '100084', 'T5', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 12:14:37', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(101, '100090', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 13:13:54', 'Paid', NULL, '114.00', '114.00', '114.00', NULL, '150.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(100, '100082', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 11:21:19', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(99, '100083', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 12:04:25', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(98, '100081', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 10:55:58', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(97, '100079', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 10:50:23', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(96, '100085', 'T12', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 12:20:51', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(95, '100080', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 10:54:13', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(94, '100078', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 10:19:54', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(93, '100077', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 10:12:07', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(92, '100076', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 10:11:29', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(91, '100075', 'T12', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 10:05:13', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(90, '100073', 'T5', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 09:55:24', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(89, '100074', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 10:00:01', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(88, '100072', '2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-11 09:35:03', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '100.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465630908', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(163, '100145', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-12 19:54:30', 'Paid', NULL, '472.00', '472.00', '472.00', NULL, '472.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(161, '100143', 'T14', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 18:42:18', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '40.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(162, '100144', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 19:52:27', 'Paid', NULL, '135.00', '135.00', '135.00', NULL, '150.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(158, '100140', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 16:56:46', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(159, '100142', '11', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 17:46:46', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(157, '100139', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 16:37:55', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '10.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(156, '100137', 'T3(S)', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 16:36:36', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(155, '100138', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 16:37:22', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(154, '100136', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 16:16:06', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '20.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(153, '100135', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 15:54:36', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '100.00', '82.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(152, '100134', 'T0', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 15:54:06', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(151, '100133', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 15:09:27', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(150, '100131', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 14:17:33', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(149, '100130', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 14:11:32', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(148, '100129', 'T14', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 14:05:58', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(147, '100141', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 17:44:48', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '68.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(146, '100128', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 13:14:54', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(142, '100123', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 12:39:20', 'Paid', NULL, '79.00', '79.00', '0.00', '79.00', '79.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '1.42', 'Master Card', '1.80', NULL, '0.09', '77.49', 0, NULL, NULL, NULL, NULL, '0'),
(143, '100124', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 12:53:53', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '100.00', '46.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(144, '100125', 'T14', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 12:57:15', 'Paid', NULL, '72.00', '72.00', '72.00', NULL, '72.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(145, '100126', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 13:01:11', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(141, '100122', 'T15', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 12:27:36', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(140, '100120', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 12:24:12', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(135, '100118', 'T12', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 12:15:03', 'Paid', NULL, '1.00', '1.00', '1.00', NULL, '1.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(136, '100127', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 13:12:50', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(137, '100119', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 12:16:36', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(138, '100132', 'T5', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 14:21:31', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '58.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(139, '100121', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 12:26:45', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(134, '100117', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 11:18:30', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(133, '100116', 'T5', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 11:14:34', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(132, '100115', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 10:47:37', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(131, '100114', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 10:46:43', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(130, '100113', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 10:44:34', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(129, '100112', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 10:29:17', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(128, '100111', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 10:28:11', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '37.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(127, '100110', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 10:27:15', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(125, '100108', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 10:24:27', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '100.00', '65.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(126, '100109', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 10:25:45', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(124, '100107', 'T5', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 10:19:32', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(122, '100105', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 09:47:58', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '36.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(123, '100106', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-12 10:06:37', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(121, '100104', 'T1', 10008, 'lois', NULL, NULL, 'history', '2016-06-12 09:32:41', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465729329', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(193, '100170', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-06-13 20:19:23', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(194, '100172', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-13 20:39:23', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(192, '100171', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-13 20:33:53', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(191, '100169', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-13 20:16:56', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(187, '100173', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-06-13 20:57:46', 'Paid', NULL, '177.00', '177.00', '0.00', '177.00', '177.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '3.19', 'Master Card', '1.80', NULL, '0.19', '173.62', 0, NULL, NULL, NULL, NULL, '0'),
(188, '100167', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-06-13 18:48:15', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(189, '100168', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-06-13 20:09:14', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '100.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(190, '100174', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-06-13 21:19:33', 'Paid', NULL, '138.00', '138.00', '0.00', '138.00', '138.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '2.48', 'Master Card', '1.80', NULL, '0.15', '135.37', 0, NULL, NULL, NULL, NULL, '0'),
(185, '100165', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-13 18:26:15', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(186, '100166', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-06-13 18:36:35', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(182, '100162', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-06-13 17:46:28', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(183, '100163', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-13 18:10:13', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(184, '100164', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-06-13 18:21:08', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(175, '100155', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-06-13 14:12:42', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(176, '100156', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-13 14:32:33', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(177, '100157', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-13 15:00:55', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(178, '100158', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-06-13 15:01:39', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(179, '100159', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-06-13 16:23:02', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '52.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(180, '100160', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-06-13 17:00:25', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(181, '100161', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-06-13 17:05:21', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(173, '100154', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-13 12:40:56', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(172, '100153', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-13 12:31:52', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '100.00', '63.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(170, '100152', 'T14', 10008, 'lois', NULL, NULL, 'history', '2016-06-13 12:13:38', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(169, '100151', 'T7', 10008, 'lois', NULL, NULL, 'history', '2016-06-13 11:54:28', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(171, '100150', 'T11', 10008, 'lois', NULL, NULL, 'history', '2016-06-13 11:49:12', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '100.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(166, '100148', 'T9', 10011, 'Staff', NULL, NULL, 'history', '2016-06-13 10:51:34', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(168, '100147', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-13 10:45:41', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(167, '100146', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-13 10:36:07', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '56.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(165, '100149', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-13 11:31:48', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '70.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465820546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(211, '100191', 'T12', 10008, 'lois', NULL, NULL, 'history', '2016-06-14 16:13:25', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465903663', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(212, '100193', 'T2', 10008, 'lois', NULL, NULL, 'history', '2016-06-14 17:49:17', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465903663', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(213, '100192', 'T10', 10008, 'lois', NULL, NULL, 'history', '2016-06-14 17:32:07', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465903663', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(204, '100186', 'T11', 10008, 'lois', NULL, NULL, 'history', '2016-06-14 14:33:04', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465903663', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(205, '100182', 'T6', 10008, 'lois', NULL, NULL, 'history', '2016-06-14 13:30:44', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465903663', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(206, '100183', 'T5', 10008, 'lois', NULL, NULL, 'history', '2016-06-14 14:07:50', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465903663', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(207, '100184', 'T1', 10008, 'lois', NULL, NULL, 'history', '2016-06-14 14:14:53', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465903663', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(208, '100187', 'T3', 10008, 'lois', NULL, NULL, 'history', '2016-06-14 14:41:57', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465903663', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(209, '100190', 'T2', 10008, 'lois', NULL, NULL, 'history', '2016-06-14 15:56:02', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465903663', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(210, '100189', 'T3', 10008, 'lois', NULL, NULL, 'history', '2016-06-14 15:10:24', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465903663', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(203, '100181', 'T11', 10008, 'lois', NULL, NULL, 'history', '2016-06-14 12:03:04', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '75.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465903663', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(200, '100180', 'T7', 10008, 'lois', NULL, NULL, 'history', '2016-06-14 11:36:14', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465903663', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(202, '100185', 'T13', 10008, 'lois', NULL, NULL, 'history', '2016-06-14 14:31:28', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465903663', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(201, '100178', 'T3', 10008, 'lois', NULL, NULL, 'history', '2016-06-14 11:15:01', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465903663', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(198, '100179', 'T11', 10008, 'lois', NULL, NULL, 'history', '2016-06-14 11:29:08', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465903663', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(199, '100188', 'T4', 10008, 'lois', NULL, NULL, 'history', '2016-06-14 15:08:16', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465903663', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(196, '100176', 'T14', 10008, 'lois', NULL, NULL, 'history', '2016-06-14 09:48:16', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '55.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465903663', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(197, '100177', 'T11', 10008, 'lois', NULL, NULL, 'history', '2016-06-14 10:13:22', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465903663', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(195, '100175', 'T11', 10008, 'lois', NULL, NULL, 'history', '2016-06-14 09:26:34', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465903663', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(223, '100201', 'IS', 10008, 'lois', NULL, NULL, 'history', '2016-06-16 13:41:15', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '15.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466075174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(224, '100204', 'IS', 10008, 'lois', NULL, NULL, 'history', '2016-06-16 14:40:33', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466075174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(228, '100207', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-16 19:07:03', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466075174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(226, '100205', 'T5', 10008, 'lois', NULL, NULL, 'history', '2016-06-16 14:57:43', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466075174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(227, '100206', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-16 15:17:19', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466075174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(222, '100203', 'T9', 10008, 'lois', NULL, NULL, 'history', '2016-06-16 14:01:36', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '50.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466075174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(219, '100200', 'T10', 10011, 'Staff', NULL, NULL, 'history', '2016-06-16 13:17:52', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466075174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(220, '100202', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-06-16 13:45:37', 'Paid', NULL, '101.00', '101.00', '101.00', NULL, '110.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466075174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(221, '100199', 'T5', 10008, 'lois', NULL, NULL, 'history', '2016-06-16 13:14:22', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '25.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466075174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(215, '100195', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-16 11:10:55', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466075174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(216, '100196', 'T5', 10011, 'Staff', NULL, NULL, 'history', '2016-06-16 11:49:55', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466075174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(217, '100197', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-16 12:13:20', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466075174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(218, '100198', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-16 12:44:39', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466075174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(214, '100194', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-06-16 10:10:58', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '50.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466075174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(255, '100232', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 18:13:45', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(256, '100235', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 20:08:45', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(257, '100234', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 19:17:15', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '60.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(258, '100236', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 21:09:52', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '100.00', '60.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(250, '100231', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 18:08:57', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(251, '100225', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 17:37:57', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(252, '100226', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 17:38:28', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(253, '100227', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 17:39:22', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '50.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(254, '100228', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 17:40:10', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '50.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(249, '100229', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 17:42:14', 'Paid', NULL, '84.00', '84.00', '84.00', NULL, '100.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(248, '100233', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 18:28:07', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '100.00', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(247, '100230', 'T15', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 17:50:35', 'Paid', NULL, '127.00', '127.00', '127.00', NULL, '150.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(246, '100224', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 15:53:18', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(240, '100219', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 14:30:28', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(241, '100216', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 13:01:54', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(242, '100218', 'T14', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 14:15:43', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '100.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(243, '100220', 'T5', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 15:12:04', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(244, '100221', 'B1', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 15:13:34', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(245, '100223', 'B2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 15:48:24', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(238, '100215', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 12:27:28', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(234, '100212', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 11:04:26', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(235, '100214', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 11:29:31', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(236, '100222', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 15:20:48', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(239, '100217', 'T8', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 13:07:06', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(229, '100208', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 10:08:14', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '102.00', '60.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(230, '100209', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 10:28:40', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(231, '100210', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 10:29:10', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(232, '100211', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 10:29:50', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '20.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(233, '100213', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-17 11:10:22', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '50.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466149363', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(301, '100278', 'T15', 10008, 'lois', NULL, NULL, 'history', '2016-06-18 20:04:11', 'Paid', NULL, '157.00', '157.00', '0.00', '157.00', '157.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '1.76', 'VISA', '1.12', NULL, '0.11', '155.14', 0, NULL, NULL, NULL, NULL, '0'),
(302, '100279', 'T12', 10008, 'lois', NULL, NULL, 'history', '2016-06-18 21:31:08', 'Paid', NULL, '129.00', '129.00', '129.00', NULL, '130.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(303, '100280', 'T4', 10008, 'lois', NULL, NULL, 'history', '2016-06-18 21:34:10', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(300, '100276', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-18 17:17:43', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(277, '100256', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 12:12:04', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(299, '100273', 'T0', 10011, 'Staff', NULL, NULL, 'history', '2016-06-18 16:17:50', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(298, '100272', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-06-18 16:04:59', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(286, '100258', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 12:44:10', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(287, '100262', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 13:28:58', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(288, '100263', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 13:31:11', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(289, '100264', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 13:31:50', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(290, '100266', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 13:49:09', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(291, '100267', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 14:06:00', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(292, '100270', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 15:22:34', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(293, '100268', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-06-18 14:44:35', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(294, '100269', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-06-18 15:05:34', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '20.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(295, '100274', 'T13', 10011, 'Staff', NULL, NULL, 'history', '2016-06-18 16:34:50', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(296, '100277', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-06-18 17:41:46', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(297, '100275', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-18 17:03:36', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(280, '100255', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 11:53:28', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(281, '100271', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 15:32:30', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(282, '100281', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 21:35:05', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(283, '100261', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 13:17:03', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(284, '100260', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 12:48:51', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(285, '100265', '6', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 13:44:14', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '100.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(279, '100257', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 12:43:47', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '59.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(278, '100251', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 11:34:35', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(276, '100259', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 12:44:38', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(275, '100249', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 10:59:44', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(264, '100241', 'T12', 10011, 'Staff', NULL, NULL, 'history', '2016-06-18 10:34:44', 'Paid', NULL, '83.00', '83.00', '83.00', NULL, '83.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(265, '100243', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-18 10:42:12', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(266, '100244', 'T10', 10011, 'Staff', NULL, NULL, 'history', '2016-06-18 10:48:49', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(267, '100254', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-18 11:43:53', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(268, '100252', 'T14', 10011, 'Staff', NULL, NULL, 'history', '2016-06-18 11:38:50', 'Paid', NULL, '110.00', '110.00', '110.00', NULL, '110.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(269, '100242', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 10:38:08', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(270, '100253', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 11:42:48', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(271, '100245', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 10:49:38', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(272, '100246', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 10:50:17', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(273, '100247', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 10:50:56', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(274, '100248', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 10:52:40', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(263, '100239', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-18 10:28:10', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '0.00', '-57.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(262, '100240', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-06-18 10:30:56', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '58.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(261, '100250', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 11:07:03', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(260, '100237', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 10:01:53', 'Paid', NULL, '86.00', '86.00', '86.00', NULL, '86.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(259, '100238', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-06-18 10:19:58', 'Paid', NULL, '185.00', '185.00', '185.00', NULL, '185.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466258084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(348, '100324', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 20:02:57', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(349, '100325', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 21:12:09', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(346, '100322', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 18:38:26', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(345, '100320', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 18:33:20', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(347, '100323', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 18:39:37', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(344, '100319', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 18:22:23', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(342, '100321', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-06-19 18:35:39', 'Paid', NULL, '90.00', '90.00', '0.00', '90.00', '90.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '1.01', 'VISA', '1.12', NULL, '0.06', '88.93', 0, NULL, NULL, NULL, NULL, '0'),
(343, '100318', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 18:21:34', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(322, '100297', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 12:17:42', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(323, '100298', 'T10', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 12:23:01', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '21.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(324, '100299', 'T10', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 12:32:52', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(325, '100301', 'T12', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 12:39:05', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(326, '100300', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 12:38:16', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(327, '100302', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 12:40:39', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(328, '100303', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 12:48:01', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(330, '100307', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-06-19 13:58:56', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(331, '100308', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-06-19 14:00:46', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '102.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(332, '100309', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-06-19 14:01:29', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(333, '100310', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-06-19 14:07:16', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(334, '100311', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-06-19 14:12:50', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '25.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(336, '100314', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-06-19 15:02:38', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '100.00', '68.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(337, '100312', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-19 14:37:07', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '100.00', '82.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(338, '100315', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-06-19 15:37:48', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '100.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(339, '100313', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-06-19 15:00:36', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '55.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(340, '100317', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-19 17:47:53', 'Paid', NULL, '167.00', '167.00', '0.00', '167.00', '167.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '3.01', 'Master Card', '1.80', NULL, '0.18', '163.81', 0, NULL, NULL, NULL, NULL, '0'),
(341, '100316', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-19 17:44:46', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '100.00', '83.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(320, '100295', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 12:12:22', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(321, '100296', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 12:14:47', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(319, '100294', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 12:02:06', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(318, '100304', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 12:50:52', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(317, '100306', 'T15', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 13:30:26', 'Paid', NULL, '106.00', '95.40', '95.40', NULL, '100.00', '4.60', '0.00', '0.00', '10.60', '0.00', 'Cash', NULL, '27', '1466329881', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(316, '100305', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 12:54:11', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '59.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(315, '100291', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 11:00:00', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(314, '100292', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 11:16:31', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '67.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(313, '100290', 'T15', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 10:33:26', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(312, '100289', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 10:32:39', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(311, '100288', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 10:31:45', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(310, '100287', 'T15', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 10:30:48', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(309, '100286', 'T15', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 10:27:48', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '70.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(308, '100293', 'T12', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 11:36:51', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(307, '100285', 'T14', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 09:35:54', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(306, '100284', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 09:26:53', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(305, '100283', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 09:24:56', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(304, '100282', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-06-19 09:20:39', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466329881', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(380, '100355', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-06-20 20:49:15', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '100.00', '54.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(363, '100340', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-06-20 13:07:59', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(364, '100339', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-06-20 12:20:35', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(365, '100341', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-06-20 13:11:02', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(366, '100342', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-06-20 13:54:58', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(367, '100344', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-20 14:27:53', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(368, '100343', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-06-20 14:20:09', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(369, '100345', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-06-20 14:30:35', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(370, '100347', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-06-20 16:00:17', 'Paid', NULL, '74.00', '74.00', '74.00', NULL, '74.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(371, '100346', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-20 15:50:24', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(373, '100348', 'B1', 10003, 'admin', NULL, NULL, 'history', '2016-06-20 16:24:12', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(374, '100349', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-06-20 17:46:12', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(375, '100350', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-20 18:14:31', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(376, '100351', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-20 18:15:00', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(377, '100352', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-20 18:34:24', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '103.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(378, '100353', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-06-20 20:01:38', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(379, '100354', 't4', 10003, 'admin', NULL, NULL, 'history', '2016-06-20 20:09:05', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(362, '100338', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-06-20 12:18:50', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(361, '100337', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-06-20 12:18:09', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(360, '100336', 'T15', 10011, 'Staff', NULL, NULL, 'history', '2016-06-20 12:17:35', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(359, '100335', 'T15', 10011, 'Staff', NULL, NULL, 'history', '2016-06-20 12:13:59', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(358, '100334', 'T15', 10011, 'Staff', NULL, NULL, 'history', '2016-06-20 12:13:06', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(357, '100333', 'T15', 10011, 'Staff', NULL, NULL, 'history', '2016-06-20 12:12:12', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(356, '100332', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-20 12:11:39', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(355, '100331', 'T15', 10011, 'Staff', NULL, NULL, 'history', '2016-06-20 12:10:46', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(354, '100330', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-20 12:01:19', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(353, '100328', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-20 11:15:49', 'Paid', NULL, '70.00', '70.00', '70.00', NULL, '70.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(352, '100327', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-20 11:14:11', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(351, '100329', 'T10', 10011, 'Staff', NULL, NULL, 'history', '2016-06-20 11:28:52', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '105.00', '94.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(350, '100326', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-20 10:36:25', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466430470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(421, '100394', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 22:41:16', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '100.00', '86.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(422, '100393', 'T16', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 22:10:43', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '40.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(420, '100392', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 22:01:04', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '100.00', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(419, '100391', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 21:13:23', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '109.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(394, '100367', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 13:00:33', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(395, '100368', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 13:17:09', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(396, '100369', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 13:36:31', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(397, '100370', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 13:37:23', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '53.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(398, '100371', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 13:39:43', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(399, '100372', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 13:40:22', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(400, '100373', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 13:40:52', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(401, '100374', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 13:43:59', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '105.00', '71.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(402, '100375', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 13:48:40', 'Paid', NULL, '93.00', '93.00', '93.00', NULL, '93.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(403, '100376', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 13:52:27', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(404, '100379', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 14:41:10', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(405, '100377', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 14:29:50', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '25.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(407, '100381', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 15:56:11', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(408, '100382', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 16:09:59', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(409, '100383', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 16:14:51', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(410, '100384', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 16:42:29', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(411, '100385', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 17:29:16', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(412, '100388', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 19:44:58', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(413, '100386', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 18:42:09', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(414, '100395', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 22:45:29', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '53.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(415, '100387', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 19:07:19', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(417, '100389', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 19:59:48', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(418, '100390', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 20:08:49', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(393, '100366', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 12:59:53', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(392, '100378', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 14:31:02', 'Paid', NULL, '81.00', '81.00', '81.00', NULL, '81.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(391, '100365', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 12:35:09', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(390, '100364', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 12:30:33', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(389, '100363', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 12:25:48', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(388, '100362', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 12:22:02', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '50.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(387, '100361', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 11:24:56', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(406, '100380', 'B1', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 15:55:28', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(386, '100360', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 11:17:07', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(384, '100359', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 10:33:02', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '100.00', '90.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(383, '100358', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 10:32:44', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(382, '100357', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 10:32:22', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '20.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(381, '100356', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-21 09:22:42', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466510328', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(435, '100410', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 14:50:40', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '69.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(436, '100408', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 13:03:54', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(437, '100413', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 15:15:49', 'Paid', NULL, '124.00', '124.00', '124.00', NULL, '150.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(438, '100409', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 14:03:51', 'Paid', NULL, '9.90', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(439, '100411', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 14:57:30', 'Paid', NULL, '82.00', '82.00', '82.00', NULL, '82.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(446, '100417', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-06-23 21:32:52', 'Paid', NULL, '203.00', '203.00', '203.00', NULL, '203.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(441, '100414', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 15:21:37', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(442, '100412', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 15:08:30', 'Paid', NULL, '31.50', '31.50', '31.50', NULL, '31.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(443, '100415', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 16:29:47', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(444, '100416', 'T12', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 19:44:19', 'Paid', NULL, '100.00', '100.00', '100.00', NULL, '100.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(445, '100418', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 22:21:32', 'Paid', NULL, '33.00', '26.40', '26.40', NULL, '30.50', '4.10', '0.00', '0.00', '6.60', '0.00', 'Cash', NULL, '27', NULL, 'p', '20', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(447, '100419', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 22:22:44', 'Paid', NULL, '86.00', '86.00', '86.00', NULL, '106.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(434, '100407', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 12:28:08', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(433, '100406', 'T8', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 11:20:15', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(432, '100405', 'T5', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 10:56:33', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(431, '100404', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 10:30:25', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(430, '100403', 'T14', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 10:29:34', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(428, '100401', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 10:14:27', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(429, '100402', 'T14', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 10:29:00', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(426, '100399', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 10:11:30', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '100.00', '71.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(427, '100400', 'T5', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 10:13:41', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(425, '100398', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 10:08:46', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(424, '100397', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 10:00:02', 'Paid', NULL, '64.00', '64.00', '0.00', '64.00', '64.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '1.15', 'Master Card', '1.80', NULL, '0.07', '62.78', 0, NULL, NULL, NULL, NULL, '0'),
(423, '100396', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-23 09:08:22', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(461, '100431', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-06-24 14:48:16', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466775310', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(462, '100432', 'B1', 10003, 'admin', NULL, NULL, 'history', '2016-06-24 15:00:08', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '101.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466775310', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(463, '100434', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-06-24 15:32:08', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466775310', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(464, '100435', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-06-24 16:32:44', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '39.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466775310', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(465, '100436', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-06-24 16:39:29', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466775310', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(466, '100437', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-24 18:07:09', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466775310', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(467, '100438', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-06-24 19:22:21', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466775310', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(468, '100439', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-24 20:50:08', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466775310', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(469, '100440', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-24 21:11:59', 'Paid', NULL, '23.40', '23.40', '23.40', NULL, '50.40', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466775310', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(470, '100441', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-06-24 21:31:22', 'Paid', NULL, '12.70', '12.70', '12.70', NULL, '12.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466775310', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(459, '100427', 'B2', 10003, 'admin', NULL, NULL, 'history', '2016-06-24 13:30:07', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466775310', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(460, '100430', 'B3', 10003, 'admin', NULL, NULL, 'history', '2016-06-24 14:32:51', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466775310', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(457, '100426', 'B1', 10003, 'admin', NULL, NULL, 'history', '2016-06-24 13:24:19', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466775310', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(456, '100429', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-06-24 14:24:22', 'Paid', NULL, '153.00', '153.00', '153.00', NULL, '153.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466775310', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(455, '100428', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-06-24 13:44:16', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466775310', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(453, '100424', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-24 12:53:36', 'Paid', NULL, '78.00', '78.00', '78.00', NULL, '100.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466775310', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(454, '100433', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-24 15:04:35', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466775310', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(451, '100425', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-06-24 12:59:29', 'Paid', NULL, '55.80', '55.80', '55.80', NULL, '60.00', '4.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466775310', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(452, '100423', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-06-24 12:18:50', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466775310', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(449, '100420', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-24 10:38:12', 'Paid', NULL, '19.80', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466775310', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(450, '100422', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-24 11:23:22', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '57.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466775310', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(448, '100421', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-24 11:08:26', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466775310', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(497, '100465', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 13:41:41', 'Paid', NULL, '163.00', '163.00', '163.00', NULL, '200.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(499, '100467', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 13:59:21', 'Paid', NULL, '12.75', '12.75', '12.75', NULL, '12.75', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(500, '100470', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 15:28:23', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(501, '100473', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 16:30:25', 'Paid', NULL, '149.00', '149.00', '149.00', NULL, '149.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(502, '100469', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 15:14:28', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(503, '100471', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 15:51:28', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(504, '100472', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 16:11:30', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(505, '100474', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 17:06:52', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '20.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(506, '100476', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 17:57:05', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(507, '100475', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 17:17:06', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(508, '100478', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 20:20:34', 'Paid', NULL, '113.00', '113.00', '113.00', NULL, '200.00', '87.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(509, '100479', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 21:32:40', 'Paid', NULL, '97.00', '97.00', '97.00', NULL, '100.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(510, '100477', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 19:21:18', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(482, '100451', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 11:41:31', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(485, '100462', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 13:27:24', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(484, '100460', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 12:38:14', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(486, '100458', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 12:31:47', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '100.00', '62.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(487, '100453', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 12:15:24', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(488, '100454', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 12:16:47', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(489, '100455', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 12:17:23', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(490, '100456', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 12:17:43', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(491, '100457', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 12:21:36', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(492, '100463', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 13:32:32', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(493, '100466', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 13:58:06', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '103.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(498, '100464', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 13:36:57', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(495, '100461', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 12:54:50', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(496, '100468', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 14:55:18', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '50.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(481, '100459', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 12:33:44', 'Paid', NULL, '151.75', '136.55', '136.55', NULL, '150.00', '13.45', '0.00', '0.00', '15.18', '-0.02', 'Cash', NULL, '27', '1466862001', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(480, '100449', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 10:40:28', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(478, '100448', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 10:03:28', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(479, '100452', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 12:01:58', 'Paid', NULL, '81.00', '81.00', '81.00', NULL, '100.00', '19.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(477, '100447', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 10:00:08', 'Paid', NULL, '136.00', '136.00', '136.00', NULL, '136.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(476, '100446', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 09:41:03', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(475, '100450', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 11:04:54', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(474, '100445', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 09:27:10', 'Paid', NULL, '105.00', '105.00', '105.00', NULL, '105.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(473, '100444', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 09:22:42', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(472, '100443', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 09:08:38', 'Paid', NULL, '102.00', '102.00', '102.00', NULL, '102.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(471, '100442', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-25 09:02:46', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466862001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(550, '100519', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 21:46:50', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(551, '100518', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 21:07:56', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(523, '100492', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 12:00:28', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(524, '100491', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 11:53:43', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(525, '100493', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 12:01:16', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(526, '100494', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 12:20:11', 'Paid', NULL, '82.00', '82.00', '82.00', NULL, '82.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(527, '100495', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 12:27:22', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(528, '100496', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 12:32:04', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(529, '100501', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 13:38:37', 'Paid', NULL, '142.00', '142.00', '142.00', NULL, '152.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(530, '100497', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 12:45:26', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '100.00', '66.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(531, '100504', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 14:24:33', 'Paid', NULL, '215.00', '215.00', '0.00', '215.00', '215.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '3.87', 'Master Card', '1.80', NULL, '0.23', '210.90', 0, NULL, NULL, NULL, NULL, '0'),
(532, '100498', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 13:13:02', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(533, '100499', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 13:15:16', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(534, '100500', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 13:23:26', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(535, '100503', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 14:17:34', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(536, '100502', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 13:48:02', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(537, '100505', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 15:21:36', 'Paid', NULL, '55.00', '55.00', '0.00', '55.00', '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '0.99', 'Master Card', '1.80', NULL, '0.06', '53.95', 0, NULL, NULL, NULL, NULL, '0'),
(538, '100508', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 16:36:03', 'Paid', NULL, '105.00', '105.00', '105.00', NULL, '105.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(539, '100506', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 15:37:41', 'Paid', NULL, '12.75', '12.75', '12.75', NULL, '12.75', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(540, '100507', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 16:00:30', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(541, '100509', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 17:00:48', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(542, '100511', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 18:14:48', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '51.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(543, '100510', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 17:58:05', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(544, '100514', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 18:58:48', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(545, '100512', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 18:28:00', 'Paid', NULL, '116.00', '116.00', '116.00', NULL, '150.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(546, '100513', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 18:30:24', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(547, '100516', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 19:45:16', 'Paid', NULL, '139.00', '125.10', '125.10', NULL, '150.10', '25.00', '0.00', '0.00', '13.90', '0.00', 'Cash', NULL, '27', '1466949440', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(548, '100515', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 19:05:01', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(549, '100517', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 20:52:38', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(522, '100490', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 11:33:52', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(521, '100489', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 10:54:11', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(520, '100488', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 10:49:59', 'Paid', NULL, '148.00', '148.00', '148.00', NULL, '148.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(519, '100486', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 10:38:31', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '76.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(518, '100486', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 10:37:07', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(517, '100484', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 10:18:16', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(516, '100482', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 10:09:27', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(514, '100481', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 09:45:49', 'Paid', NULL, '100.50', '100.50', '100.50', NULL, '100.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(513, '100480', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 09:36:11', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '60.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(515, '100487', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 10:39:56', 'Paid', NULL, '83.00', '83.00', '83.00', NULL, '83.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(511, '100483', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-26 10:10:40', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1466949440', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(563, '100528', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 12:34:46', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '100.00', '78.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(564, '100529', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 12:59:39', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(565, '100532', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 13:12:11', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(566, '100534', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 13:21:03', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(567, '100535', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 13:30:10', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(568, '100537', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 14:00:17', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(569, '100536', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 13:49:23', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(570, '100538', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 15:17:16', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(571, '100539', 'B1', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 15:27:27', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '38.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(572, '100540', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 15:31:14', 'Paid', NULL, '19.80', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(573, '100545', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 18:14:41', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(574, '100541', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 15:57:46', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(575, '100542', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 16:30:36', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '100.00', '65.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(576, '100543', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 17:02:20', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(577, '100544', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 17:56:33', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(578, '100547', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 19:22:02', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '100.00', '76.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(579, '100546', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 19:05:49', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(580, '100548', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 20:57:10', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(562, '100533', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 13:16:52', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(561, '100531', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 13:10:33', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(560, '100526', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 12:04:16', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '58.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(559, '100525', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 11:46:12', 'Paid', NULL, '74.00', '74.00', '74.00', NULL, '100.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(558, '100527', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 12:13:17', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(557, '100524', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 11:30:58', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(556, '100523', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 11:21:04', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(555, '100530', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 13:06:52', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '100.00', '46.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(554, '100522', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 10:49:46', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(553, '100521', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 10:35:26', 'Paid', NULL, '71.00', '71.00', '71.00', NULL, '101.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(552, '100520', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-27 10:27:00', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '50.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467033993', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(592, '100560', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-06-28 13:44:54', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '50.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467115684', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(593, '100559', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-28 13:24:38', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467115684', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(594, '100563', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-06-28 14:00:34', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '101.00', '60.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467115684', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(595, '100564', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-06-28 14:13:56', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467115684', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(596, '100561', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-28 13:48:09', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467115684', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(597, '100562', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-06-28 14:00:01', 'Paid', NULL, '10.80', '10.80', '10.80', NULL, '10.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467115684', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(598, '100567', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-06-28 16:19:12', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467115684', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(599, '100565', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-06-28 14:37:54', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467115684', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(600, '100568', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-06-28 16:45:27', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467115684', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(601, '100569', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-06-28 17:49:58', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467115684', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(591, '100558', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-06-28 12:58:00', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467115684', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(590, '100557', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-06-28 12:49:51', 'Paid', NULL, '121.00', '121.00', '121.00', NULL, '150.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467115684', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(589, '100556', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-06-28 12:40:27', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467115684', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(588, '100566', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-06-28 14:39:08', 'Paid', NULL, '176.00', '158.40', '158.40', NULL, '160.00', '1.60', '0.00', '0.00', '17.60', '0.00', 'Cash', NULL, '27', '1467115684', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(587, '100554', 't2', 10003, 'admin', NULL, NULL, 'history', '2016-06-28 11:59:37', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467115684', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(586, '100555', 'B1', 10011, 'Staff', NULL, NULL, 'history', '2016-06-28 12:33:13', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '70.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467115684', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(585, '100552', 't4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-28 11:42:32', 'Paid', NULL, '128.00', '128.00', '128.00', NULL, '200.00', '72.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467115684', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(584, '100553', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-06-28 11:51:22', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '100.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467115684', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(583, '100551', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-28 11:27:29', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '100.00', '53.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467115684', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(582, '100550', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-28 11:14:14', 'Paid', NULL, '132.00', '132.00', '132.00', NULL, '150.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467115684', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(581, '100549', 'T10', 10011, 'Staff', NULL, NULL, 'history', '2016-06-28 09:53:43', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467115684', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(614, '100580', 'T10', 10011, 'Staff', NULL, NULL, 'history', '2016-06-30 15:23:23', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467285143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(617, '100581', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-30 16:05:53', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467285143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(618, '100583', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-30 16:49:07', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467285143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(619, '100584', 'T5', 10011, 'Staff', NULL, NULL, 'history', '2016-06-30 17:19:20', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467285143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(620, '100587', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-30 17:52:16', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467285143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(621, '100586', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-06-30 17:39:29', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467285143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(624, '100590', 'T9', 10011, 'Staff', NULL, NULL, 'history', '2016-06-30 19:14:27', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467285143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(623, '100588', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-30 17:53:56', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467285143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(625, '100589', 'T10', 10011, 'Staff', NULL, NULL, 'history', '2016-06-30 19:14:22', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467285143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(609, '100585', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-06-30 17:32:36', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '55.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467285143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(610, '100582', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-06-30 16:25:56', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '20.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467285143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(611, '100579', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-30 15:03:16', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467285143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(612, '100577', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-30 14:12:55', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467285143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(613, '100578', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-06-30 14:54:48', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '103.00', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467285143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(608, '100576', 'T10', 10011, 'Staff', NULL, NULL, 'history', '2016-06-30 13:47:23', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467285143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(607, '100575', 'T15', 10011, 'Staff', NULL, NULL, 'history', '2016-06-30 13:43:13', 'Paid', NULL, '132.00', '132.00', '132.00', NULL, '132.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467285143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(606, '100573', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-06-30 10:51:37', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '51.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467285143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(605, '100572', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-06-30 10:30:01', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467285143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(604, '100571', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-06-30 10:25:09', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467285143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(603, '100570', 'T5', 10011, 'Staff', NULL, NULL, 'history', '2016-06-30 10:19:52', 'Paid', NULL, '62.00', '62.00', '0.00', '62.00', '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1467285143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '0.69', 'VISA', '1.12', NULL, '0.04', '61.26', 0, NULL, NULL, NULL, NULL, '0'),
(602, '100574', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-06-30 12:06:39', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467285143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(663, '100626', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 21:59:49', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '100.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(662, '100625', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 21:59:23', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '100.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(660, '100624', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 20:49:32', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(659, '100623', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 20:42:21', 'Paid', NULL, '128.00', '115.20', '0.00', '115.20', '115.20', '0.00', '0.00', '0.00', '12.80', '0.00', 'Credit Card', NULL, '27', '1467381702', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, 5, '1.29', 'VISA', '1.12', NULL, '0.08', '113.83', 0, NULL, NULL, NULL, NULL, '0'),
(658, '100621', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 19:36:35', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(655, '100619', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 17:44:30', 'Paid', NULL, '13.00', '11.70', '11.70', NULL, '11.70', '0.00', '0.00', '0.00', '1.30', '0.00', 'Cash', NULL, '27', '1467381702', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(656, '100622', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 19:49:21', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(657, '100620', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 18:13:07', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(653, '100618', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 17:15:04', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(652, '100614', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 13:42:40', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(651, '100613', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 13:37:15', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(650, '100616', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 14:06:18', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(649, '100612', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 13:19:32', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(648, '100611', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 12:58:26', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(647, '100610', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 12:45:48', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(639, '100601', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 11:53:04', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(640, '100602', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 11:54:15', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '40.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(641, '100605', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 12:27:42', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(642, '100607', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 12:35:41', 'Paid', NULL, '103.00', '103.00', '103.00', NULL, '110.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(643, '100606', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 12:33:18', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(644, '100608', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 12:36:32', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '55.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(645, '100609', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 12:37:33', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '100.00', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(646, '100617', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 15:48:03', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '65.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(638, '100615', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 14:01:15', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(633, '100598', 'T14', 10011, 'Staff', NULL, NULL, 'history', '2016-07-01 10:38:21', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(634, '100599', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-07-01 10:45:08', 'Paid', NULL, '89.00', '89.00', '89.00', NULL, '100.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(635, '100603', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 12:03:46', 'Paid', NULL, '73.00', '73.00', '73.00', NULL, '75.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(636, '100600', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 11:35:47', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(637, '100604', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-01 12:15:36', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(632, '100597', 'T14', 10011, 'Staff', NULL, NULL, 'history', '2016-07-01 10:37:38', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(631, '100596', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-07-01 10:19:32', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(629, '100594', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-07-01 09:50:40', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(630, '100595', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-07-01 10:09:42', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(628, '100593', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-07-01 09:28:40', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(627, '100592', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-07-01 09:27:43', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(626, '100591', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-07-01 09:26:31', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467381702', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(694, '100658', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 21:19:35', 'Paid', NULL, '55.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', '5.50', '0.00', 'Cash', NULL, '27', '1467466190', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(695, '100656', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 21:15:59', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '100.00', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(696, '100657', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 21:17:57', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(693, '100655', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 20:37:34', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '38.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(692, '100653', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 19:35:36', 'Paid', NULL, '112.00', '112.00', '112.00', NULL, '120.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(686, '100647', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 16:15:32', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(688, '100651', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 17:06:53', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(689, '100650', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 16:49:45', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(690, '100652', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 17:20:52', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(691, '100654', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 19:41:19', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(687, '100649', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 16:34:25', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '103.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(677, '100636', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 14:03:27', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(678, '100637', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 14:04:31', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(679, '100638', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 14:06:03', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(680, '100640', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 14:13:35', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(681, '100641', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 14:40:33', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(682, '100642', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 15:03:25', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '25.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(683, '100643', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 15:43:00', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(684, '100645', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 15:58:12', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(685, '100646', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 16:02:07', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(670, '100631', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-07-02 11:50:16', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(676, '100644', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 15:45:27', 'Paid', NULL, '121.00', '121.00', '121.00', NULL, '121.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(675, '100648', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 16:32:35', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '100.00', '71.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(674, '100635', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 12:36:49', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(672, '100632', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 12:05:59', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(671, '100633', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-02 12:06:36', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(669, '100630', 'T12', 10011, 'Staff', NULL, NULL, 'history', '2016-07-02 11:42:51', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(668, '100629', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-07-02 11:37:14', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(667, '100628', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-07-02 11:32:25', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(666, '100639', 'T14', 10011, 'Staff', NULL, NULL, 'history', '2016-07-02 14:08:05', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(665, '100634', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-07-02 12:33:14', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '103.00', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(664, '100627', 'T8', 10011, 'Staff', NULL, NULL, 'history', '2016-07-02 10:25:33', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467466190', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(733, '100694', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 19:53:35', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '100.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(730, '100692', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 17:24:07', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(732, '100695', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 20:10:25', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(731, '100693', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 18:13:52', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(729, '100688', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 15:27:10', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '38.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(726, '100690', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-07-03 15:33:52', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(727, '100685', 'T12', 10011, 'Staff', NULL, NULL, 'history', '2016-07-03 14:49:34', 'Paid', NULL, '4.00', '4.00', '4.00', NULL, '50.00', '46.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(728, '100691', 'T8', 10010, 'sanni', NULL, NULL, 'history', '2016-07-03 16:49:37', 'Paid', NULL, '13.00', '11.70', '11.70', NULL, '12.00', '0.30', '0.00', '0.00', '1.30', '0.00', 'Cash', NULL, '27', '1467548174', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(725, '100683', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 14:35:00', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(720, '100676', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 13:43:51', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(724, '100682', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 14:32:54', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(718, '100674', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 13:40:17', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(723, '100681', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 14:09:51', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '102.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(722, '100687', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 15:04:40', 'Paid', NULL, '21.00', '18.90', '18.90', NULL, '20.00', '1.10', '0.00', '0.00', '2.10', '0.00', 'Cash', NULL, '27', '1467548174', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(721, '100679', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 13:59:59', 'Paid', NULL, '73.00', '73.00', '73.00', NULL, '80.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(719, '100675', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 13:40:48', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(717, '100673', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 13:39:32', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(716, '100684', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 14:38:54', 'Paid', NULL, '147.00', '147.00', '147.00', NULL, '147.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(715, '100686', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 15:03:08', 'Paid', NULL, '213.00', '213.00', '213.00', NULL, '213.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(714, '100672', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 13:31:33', 'Paid', NULL, '2.00', '2.00', '2.00', NULL, '2.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(713, '100680', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 14:08:06', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(712, '100671', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 13:04:55', 'Paid', NULL, '82.00', '82.00', '82.00', NULL, '100.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(711, '100670', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 13:03:48', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(710, '100669', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 12:43:29', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(709, '100677', '6', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 13:51:53', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(708, '100678', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 13:55:36', 'Paid', NULL, '158.00', '158.00', '158.00', NULL, '158.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(707, '100689', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 15:28:24', 'Paid', NULL, '78.00', '78.00', '78.00', NULL, '100.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(706, '100668', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 12:08:08', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(705, '100667', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 11:42:23', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '100.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(704, '100665', '12', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 11:17:16', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(703, '100664', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 10:40:08', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(702, '100661', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 10:10:36', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(701, '100660', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 10:06:35', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(700, '100666', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 11:24:38', 'Paid', NULL, '85.00', '85.00', '85.00', NULL, '100.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(699, '100663', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 10:19:31', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(698, '100659', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 09:31:41', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(697, '100662', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-03 10:14:17', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '55.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467548174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(768, '100728', 'B1', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 16:39:16', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(767, '100727', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 16:38:18', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(766, '100730', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 20:04:32', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(764, '100726', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 15:41:50', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(765, '100729', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 18:14:00', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(759, '100717', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 14:24:02', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(760, '100718', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 14:25:29', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(755, '100719', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 14:30:12', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(762, '100724', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 15:34:51', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '40.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(763, '100723', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 15:28:42', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(761, '100721', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 14:59:48', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(757, '100720', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 14:41:54', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(758, '100725', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 15:36:31', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '103.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(756, '100716', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 14:18:49', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '30.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(754, '100722', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 15:21:12', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(753, '100714', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 13:03:31', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(752, '100713', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 12:29:35', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(751, '100712', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 12:21:04', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '100.00', '73.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(750, '100711', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 12:16:46', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '30.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(749, '100715', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 13:28:27', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(748, '100709', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 12:03:53', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(747, '100708', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 11:59:00', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(746, '100710', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 12:08:53', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(745, '100705', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 11:37:17', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(744, '100704', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 11:20:19', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(743, '100702', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 11:10:31', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(742, '100700', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 10:59:11', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(741, '100707', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 11:44:35', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(740, '100703', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 11:15:26', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(739, '100699', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 10:45:11', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(738, '100698', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 10:41:11', 'Paid', NULL, '71.00', '71.00', '71.00', NULL, '71.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(737, '100701', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 11:08:08', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(736, '100697', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 10:15:38', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(735, '100706', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 11:38:24', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(734, '100696', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-05 09:10:00', 'Paid', NULL, '73.00', '73.00', '73.00', NULL, '100.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467724146', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(806, '100766', 'T15', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 20:52:50', 'Paid', NULL, '221.00', '221.00', '221.00', NULL, '255.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(807, '100767', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 21:11:15', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(805, '100764', 'T10', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 19:55:10', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(804, '100762', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 19:21:17', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(803, '100765', 'T8', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 20:33:27', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(801, '100760', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 18:45:58', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(802, '100763', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 19:42:47', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(793, '100755', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 17:05:39', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(794, '100758', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 17:55:04', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '50.00', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(795, '100753', 'T14', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 16:28:01', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(796, '100754', 'T0', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 16:29:41', 'Paid', NULL, '10.50', '10.50', '10.50', NULL, '10.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(797, '100757', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 17:54:00', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(798, '100756', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 17:31:35', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(799, '100761', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 18:54:06', 'Paid', NULL, '77.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(800, '100759', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 18:12:00', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(792, '100751', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 15:49:01', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(791, '100752', 'T12', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 16:17:18', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '50.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(790, '100750', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 15:28:03', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(789, '100749', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 15:27:10', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(788, '100748', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 15:26:34', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(787, '100746', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 15:03:18', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(786, '100745', 't3', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 14:46:30', 'Paid', NULL, '96.00', '96.00', '96.00', NULL, '100.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(785, '100741', 't11', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 14:01:56', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '100.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(784, '100740', 'T14', 10011, 'Staff', NULL, NULL, 'history', '2016-07-06 13:59:35', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(783, '100743', '12', 10003, 'admin', NULL, NULL, 'history', '2016-07-06 14:22:48', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(782, '100744', 't6', 10003, 'admin', NULL, NULL, 'history', '2016-07-06 14:25:11', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '70.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(781, '100737', 't2', 10003, 'admin', NULL, NULL, 'history', '2016-07-06 13:05:52', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(779, '100738', 'B1', 10003, 'admin', NULL, NULL, 'history', '2016-07-06 13:22:29', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(778, '100742', 't7', 10003, 'admin', NULL, NULL, 'history', '2016-07-06 14:16:39', 'Paid', NULL, '81.00', '81.00', '81.00', NULL, '81.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(777, '100747', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-06 15:20:32', 'Paid', NULL, '95.00', '95.00', '95.00', NULL, '95.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(776, '100739', 't15', 10003, 'admin', NULL, NULL, 'history', '2016-07-06 13:36:43', 'Paid', NULL, '215.00', '215.00', '201.00', NULL, '201.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(775, '100736', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-06 12:51:16', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(773, '100734', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-06 11:22:25', 'Paid', NULL, '80.00', '80.00', '80.00', NULL, '100.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(772, '100735', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-06 12:02:22', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '60.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(771, '100733', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-06 10:52:34', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(770, '100731', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-06 09:58:21', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(769, '100732', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-06 10:06:24', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467812168', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(851, '100810', 'B1', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 18:04:26', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(852, '100811', 'B2', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 18:04:54', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(853, '100812', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 18:36:26', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(854, '100815', 't6', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 21:27:13', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(855, '100816', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 22:09:20', 'Paid', NULL, '386.00', '386.00', '0.00', '386.00', '386.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '6.95', 'Master Card', '1.80', NULL, '0.42', '378.64', 0, NULL, NULL, NULL, NULL, '0'),
(856, '100813', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 20:18:55', 'Paid', NULL, '89.00', '89.00', '0.00', '89.00', '89.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '1.00', 'VISA', '1.12', NULL, '0.06', '87.94', 0, NULL, NULL, NULL, NULL, '0'),
(847, '100804', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 15:33:48', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(848, '100805', 't4', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 15:38:24', 'Paid', NULL, '96.00', '96.00', '68.00', NULL, '100.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(849, '100807', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 15:52:29', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(850, '100809', 't1', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 18:00:54', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(844, '100808', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 15:56:57', 'Paid', NULL, '92.00', '92.00', '92.00', NULL, '102.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(845, '100806', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 15:44:26', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(846, '100803', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 15:22:49', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(843, '100800', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 14:35:19', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(842, '100798', 'B1', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 14:29:08', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(841, '100797', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 14:25:06', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '50.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(839, '100795', 't4', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 14:06:20', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '50.00', '19.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(840, '100796', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 14:11:35', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(830, '100785', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 13:22:49', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(831, '100786', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 13:23:49', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(832, '100787', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 13:27:59', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(833, '100789', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 13:34:37', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(834, '100790', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 13:40:03', 'Paid', NULL, '78.00', '78.00', '78.00', NULL, '108.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(835, '100794', 't4', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 13:59:25', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '54.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(836, '100802', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 15:06:21', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(837, '100792', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 13:54:40', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '50.00', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(838, '100801', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 14:37:07', 'Paid', NULL, '70.00', '70.00', '70.00', NULL, '70.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(829, '100793', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 13:57:44', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(828, '100784', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 13:02:27', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '69.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(827, '100788', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 13:33:22', 'Paid', NULL, '79.00', '79.00', '79.00', NULL, '79.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(826, '100783', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 12:51:30', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(825, '100780', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 12:28:15', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(824, '100779', 't4', 10011, 'Staff', NULL, NULL, 'history', '2016-07-07 12:22:00', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(823, '100778', 't4', 10011, 'Staff', NULL, NULL, 'history', '2016-07-07 12:21:18', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(821, '100782', 'T15', 10011, 'Staff', NULL, NULL, 'history', '2016-07-07 12:48:48', 'Paid', NULL, '204.00', '204.00', '204.00', NULL, '210.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(820, '100781', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-07-07 12:32:56', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(819, '100776', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-07-07 11:43:44', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '40.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(818, '100791', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-07-07 13:40:30', 'Paid', NULL, '85.00', '85.00', '85.00', NULL, '100.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(817, '100775', 'B1', 10011, 'Staff', NULL, NULL, 'history', '2016-07-07 11:23:23', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(816, '100777', 'T12', 10011, 'Staff', NULL, NULL, 'history', '2016-07-07 12:13:18', 'Paid', NULL, '99.00', '99.00', '99.00', NULL, '99.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(815, '100799', 't16', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 14:33:45', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(814, '100773', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 10:29:24', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(813, '100771', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 10:26:23', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '100.00', '62.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(812, '100769', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 10:16:59', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(811, '100774', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 10:42:53', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(810, '100770', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 10:17:19', 'Paid', NULL, '136.00', '136.00', '136.00', NULL, '136.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(809, '100768', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 09:49:37', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(808, '100772', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 10:27:51', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '58.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(857, '100814', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-07 20:40:48', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '100.00', '66.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467900626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(882, '100840', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 14:35:00', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '20.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(883, '100841', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 14:37:52', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(884, '100842', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 14:51:14', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '100.00', '64.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(889, '100846', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 15:02:36', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(890, '100847', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 15:16:11', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(886, '100843', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 14:58:05', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(887, '100844', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 14:58:30', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(888, '100845', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 14:58:56', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(891, '100848', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 16:00:30', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(892, '100849', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 16:46:52', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(881, '100839', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 14:25:56', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '20.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(880, '100838', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 14:05:11', 'Paid', NULL, '73.00', '73.00', '73.00', NULL, '103.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(879, '100837', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 13:55:41', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(878, '100835', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 12:59:06', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(877, '100833', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 12:45:52', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(876, '100834', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 12:56:03', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(875, '100836', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 13:00:30', 'Paid', NULL, '71.00', '71.00', '71.00', NULL, '101.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(874, '100831', 't4', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 12:38:40', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(873, '100832', 't3', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 12:39:42', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(872, '100829', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 11:09:50', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(871, '100830', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 11:50:49', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(870, '100827', 't3', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 10:52:53', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(869, '100826', 't4', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 10:46:39', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(868, '100828', 't1', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 11:09:10', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '100.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(867, '100823', 'B2', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 10:19:10', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(866, '100825', 't1', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 10:32:06', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '100.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(865, '100822', 'B1', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 10:17:14', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(864, '100821', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 10:11:35', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '60.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(862, '100819', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 09:58:33', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(860, '100818', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 09:37:36', 'Paid', NULL, '84.00', '84.00', '84.00', NULL, '100.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(863, '100820', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 10:00:41', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(858, '100824', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 10:20:37', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(859, '100817', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-08 09:22:55', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '71.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1467977705', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(924, '100877', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 20:48:57', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(925, '100878', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 21:08:02', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '100.00', '60.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(923, '100879', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 21:24:07', 'Paid', NULL, '63.50', '63.50', '63.50', NULL, '100.00', '36.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(916, '100872', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 17:28:41', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '100.00', '65.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(917, '100873', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 17:29:38', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(918, '100874', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 18:39:24', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(919, '100876', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 19:46:31', 'Paid', NULL, '111.00', '99.90', '99.90', NULL, '100.00', '0.10', '0.00', '0.00', '11.10', '0.00', 'Cash', NULL, '27', '1468073319', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(920, '100875', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 19:11:37', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(921, '100880', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 21:37:57', 'Paid', NULL, '141.00', '141.00', '141.00', NULL, '141.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(922, '100881', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 22:07:33', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(915, '100870', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 17:06:03', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '50.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(914, '100871', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 17:25:16', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '100.00', '84.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(913, '100869', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 16:46:42', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(911, '100867', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 16:31:56', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '50.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(912, '100868', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 16:41:48', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '20.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(909, '100866', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 16:25:36', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(908, '100865', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 15:43:45', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(907, '100864', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 15:21:54', 'Paid', NULL, '81.00', '81.00', '81.00', NULL, '81.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(906, '100863', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 15:14:11', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(905, '100862', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 14:57:09', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(904, '100861', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 14:10:22', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(903, '100860', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 14:09:30', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(902, '100859', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 14:08:45', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(901, '100858', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 14:08:32', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(900, '100857', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 14:07:31', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(899, '100856', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 12:32:49', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '51.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(895, '100852', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 11:19:20', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(898, '100855', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 12:31:48', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(897, '100853', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 11:39:00', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '100.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(896, '100851', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 11:14:23', 'Paid', NULL, '122.00', '122.00', '122.00', NULL, '150.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(894, '100854', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 11:39:37', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468073319', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(893, '100850', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-09 09:04:03', 'Paid', NULL, '73.00', '65.70', '65.70', NULL, '70.00', '4.30', '0.00', '0.00', '7.30', '0.00', 'Cash', NULL, '27', '1468073319', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(971, '100925', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 19:25:25', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(972, '100926', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 20:35:28', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '51.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(973, '100927', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 20:39:41', 'Paid', NULL, '100.00', '100.00', '100.00', NULL, '100.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(966, '100923', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 18:43:00', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(967, '100921', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 18:20:28', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(968, '100922', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 18:33:00', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(970, '100924', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 19:06:12', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(965, '100920', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 17:58:52', 'Paid', NULL, '10.80', '10.80', '10.80', NULL, '10.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(964, '100919', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 17:28:02', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(963, '100917', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 17:00:11', 'Paid', NULL, '28.80', '28.80', '28.80', NULL, '28.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(959, '100910', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 15:38:09', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(960, '100913', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 16:15:52', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(961, '100916', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 16:53:29', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(958, '100911', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 15:43:22', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(962, '100912', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 15:49:21', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(957, '100915', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 16:31:51', 'Paid', NULL, '23.00', '20.70', '20.70', NULL, '21.00', '0.30', '0.00', '0.00', '2.30', '0.00', 'Cash', NULL, '27', '1468157241', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(948, '100901', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 14:04:18', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(949, '100914', '11', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 16:26:02', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '35.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(950, '100902', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 14:05:08', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(951, '100906', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 14:58:42', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(952, '100908', '5', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 15:02:27', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(953, '100903', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 14:28:16', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(954, '100909', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 15:32:06', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(955, '100905', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 14:57:50', 'Paid', NULL, '90.00', '90.00', '90.00', NULL, '90.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(956, '100918', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 17:16:36', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(947, '100900', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 13:41:36', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(945, '100907', '12', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 15:00:09', 'Paid', NULL, '70.00', '70.00', '70.00', NULL, '70.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(946, '100904', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 14:46:11', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(944, '100897', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 12:18:28', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(943, '100896', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-07-10 12:17:25', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(940, '100892', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-07-10 11:52:14', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '15.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(941, '100894', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-07-10 12:10:57', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(938, '100891', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-07-10 11:51:33', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '15.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(942, '100895', 'T14', 10011, 'Staff', NULL, NULL, 'history', '2016-07-10 12:12:20', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(937, '100890', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-07-10 11:50:31', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(936, '100898', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-07-10 12:33:06', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(935, '100899', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 13:19:17', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(934, '100888', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 11:30:19', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(933, '100893', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 11:57:21', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(931, '100883', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 10:17:55', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(932, '100889', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 11:37:44', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '69.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(930, '100886', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 10:41:33', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '100.00', '56.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(929, '100884', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 10:20:07', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(928, '100885', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 10:22:16', 'Paid', NULL, '73.00', '73.00', '73.00', NULL, '73.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(927, '100882', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 09:38:05', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(926, '100887', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-10 11:16:54', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468157241', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(992, '100946', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-11 20:36:31', 'Paid', NULL, '80.00', '80.00', '80.00', NULL, '100.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468243137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(990, '100944', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-11 18:01:15', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468243137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(991, '100945', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-11 18:40:13', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468243137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(989, '100943', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-11 17:44:42', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468243137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(987, '100942', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-11 16:09:55', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468243137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(988, '100940', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-11 15:36:45', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468243137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(985, '100941', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-11 15:45:56', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '55.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468243137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(986, '100938', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-11 14:41:13', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468243137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(984, '100939', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-11 14:47:15', 'Paid', NULL, '126.00', '126.00', '126.00', NULL, '150.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468243137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(983, '100937', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-11 14:00:00', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468243137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(982, '100934', 't2', 10003, 'admin', NULL, NULL, 'history', '2016-07-11 12:25:31', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468243137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(981, '100933', 't14', 10003, 'admin', NULL, NULL, 'history', '2016-07-11 12:24:20', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468243137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(979, '100936', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-11 13:19:37', 'Paid', NULL, '85.00', '85.00', '85.00', NULL, '106.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468243137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(980, '100935', 't12', 10003, 'admin', NULL, NULL, 'history', '2016-07-11 13:14:17', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468243137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(978, '100932', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-11 11:17:17', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468243137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(976, '100929', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-11 10:13:29', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '60.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468243137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(977, '100931', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-11 10:49:46', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '13.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468243137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(975, '100928', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-11 10:07:18', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468243137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(974, '100930', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-11 10:43:13', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468243137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1013, '100965', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-12 19:48:47', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468325176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1011, '100964', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-12 18:55:10', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468325176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1012, '100966', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-12 20:05:39', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '50.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468325176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1009, '100962', 'B1', 10003, 'admin', NULL, NULL, 'history', '2016-07-12 17:18:05', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468325176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1010, '100963', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-12 18:04:35', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468325176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1005, '100957', 'T16', 10003, 'admin', NULL, NULL, 'history', '2016-07-12 15:15:20', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468325176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1006, '100959', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-12 15:33:24', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '50.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468325176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1007, '100960', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-12 15:52:37', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468325176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1003, '100956', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-07-12 14:35:26', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '50.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468325176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1004, '100958', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-12 15:27:22', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468325176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1000, '100953', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-07-12 13:35:19', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468325176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1001, '100961', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-12 16:04:56', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '107.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468325176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1002, '100955', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-12 14:33:23', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468325176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(998, '100952', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-12 13:21:06', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468325176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(999, '100954', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-12 13:56:07', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '50.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468325176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(997, '100950', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-12 12:30:35', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468325176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(994, '100948', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-12 11:19:42', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '20.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468325176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(995, '100951', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-12 12:46:15', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '100.00', '52.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468325176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(996, '100949', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-12 12:30:11', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468325176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(993, '100947', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-12 09:10:40', 'Paid', NULL, '35.00', '31.50', '31.50', NULL, '31.50', '0.00', '0.00', '0.00', '3.50', '0.00', 'Cash', NULL, '27', '1468325176', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1038, '100991', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-07-14 16:34:09', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1039, '100992', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-07-14 16:49:38', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1040, '100993', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-07-14 16:56:45', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1041, '100994', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-14 18:18:54', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1042, '100995', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-14 19:00:49', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1043, '100996', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-14 19:27:05', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1033, '100986', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-07-14 14:23:46', 'Paid', NULL, '26.00', '22.10', '22.10', NULL, '100.10', '78.00', '0.00', '0.00', '3.90', '0.00', 'Cash', NULL, '27', '1468498624', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1034, '100987', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-07-14 14:57:43', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1035, '100988', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-07-14 15:00:07', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1036, '100989', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-07-14 15:49:07', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1037, '100990', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-07-14 15:50:00', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '30.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1030, '100983', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-14 13:23:28', 'Paid', NULL, '20.70', '20.70', '20.70', NULL, '20.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1031, '100984', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-07-14 13:42:43', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1032, '100985', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-07-14 14:17:36', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1029, '100981', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-14 13:05:26', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1027, '100979', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-14 13:03:57', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '20.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1028, '100980', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-14 13:04:56', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '20.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1026, '100978', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-14 12:48:51', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1025, '100977', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-14 12:37:17', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '54.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1023, '100976', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-14 12:34:03', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '30.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1024, '100982', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-14 13:14:20', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1021, '100975', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-14 12:18:40', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1022, '100974', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-14 12:00:22', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1019, '100973', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-14 11:23:49', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1020, '100972', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-14 11:02:53', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '60.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1015, '100967', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-14 09:41:45', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1018, '100971', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-14 10:30:28', 'Paid', NULL, '13.50', '13.50', '13.50', NULL, '13.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1017, '100969', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-14 10:04:59', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1016, '100968', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-14 09:47:54', 'Paid', NULL, '125.00', '125.00', '125.00', NULL, '125.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1014, '100970', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-14 10:06:45', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468498624', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1080, '101033', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 21:53:30', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1074, '101026', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 20:09:38', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1078, '101031', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 21:21:45', 'Paid', NULL, '96.00', '96.00', '96.00', NULL, '96.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1079, '101032', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 21:50:24', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1075, '101027', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 20:13:55', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1076, '101028', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 20:22:08', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1077, '101029', 'T9(S)', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 20:23:42', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(1073, '101030', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 20:24:34', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1067, '101020', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 17:35:10', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1068, '101021', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 19:19:35', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1069, '101023', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 19:42:43', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '38.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1070, '101022', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 19:41:48', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '100.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(1071, '101024', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 19:43:30', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '101.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1072, '101025', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 19:44:18', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1062, '101014', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 13:59:56', 'Paid', NULL, '13.00', '11.70', '11.70', NULL, '50.00', '38.30', '0.00', '0.00', '1.30', '0.00', 'Cash', NULL, '27', '1468590838', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1063, '101015', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 14:43:15', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1064, '101017', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 15:43:22', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1065, '101018', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 16:40:30', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '51.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1066, '101019', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 17:17:43', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1060, '101012', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 13:39:00', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1061, '101013', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 13:39:40', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1059, '101011', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 13:38:12', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1057, '101009', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 13:30:21', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '100.00', '64.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1058, '101016', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 15:12:42', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1056, '101010', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 13:31:17', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1055, '101008', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 12:41:42', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1054, '101007', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 12:25:42', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1051, '101003', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 11:19:26', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1052, '101005', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 12:06:12', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '100.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1053, '101006', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 12:21:44', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1048, '101000', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 10:49:26', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1049, '101002', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 11:09:28', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1050, '101004', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 11:36:45', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1047, '101001', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 10:57:48', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1045, '100998', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 10:14:44', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1046, '100999', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 10:24:00', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1044, '100997', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-15 09:44:26', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468590838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1119, '101071', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 20:39:21', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1120, '101073', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 21:12:37', 'Paid', NULL, '77.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', '7.70', '0.00', 'Cash', NULL, '27', '1468675805', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(1118, '101072', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 20:43:10', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1117, '101070', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 18:55:40', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1115, '101067', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 18:23:51', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1112, '101064', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 18:21:36', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1111, '101062', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 17:07:37', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1116, '101068', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 18:27:18', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1114, '101066', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 18:23:04', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1113, '101065', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 18:22:33', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1110, '101063', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 17:23:05', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '52.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1109, '101069', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 18:35:06', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1108, '101061', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 15:48:50', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1107, '101060', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 15:32:05', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1106, '101059', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 15:05:01', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '30.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1105, '101058', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 14:49:18', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1104, '101057', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 14:32:12', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1103, '101055', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 13:55:55', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1096, '101047', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 11:40:15', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1097, '101052', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 12:27:39', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1098, '101050', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 12:23:13', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1099, '101051', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 12:23:36', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1100, '101053', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 12:41:31', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1101, '101056', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 14:09:40', 'Paid', NULL, '166.00', '166.00', '0.00', '166.00', '166.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '1.86', 'VISA', '1.12', NULL, '0.11', '164.03', 0, NULL, NULL, NULL, NULL, '0'),
(1102, '101054', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 13:25:45', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1094, '101045', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 11:38:45', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1095, '101046', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 11:39:22', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1093, '101044', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 11:38:23', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1092, '101043', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 11:37:51', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1091, '101042', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 11:37:07', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1088, '101048', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 11:44:39', 'Paid', NULL, '95.00', '95.00', '95.00', NULL, '95.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1089, '101040', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 11:25:11', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '70.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1090, '101041', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 11:34:28', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1086, '101039', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 11:02:58', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '100.00', '90.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1087, '101049', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 11:54:23', 'Paid', NULL, '25.00', '22.50', '22.50', NULL, '22.50', '0.00', '0.00', '0.00', '2.50', '0.00', 'Cash', NULL, '27', '1468675805', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1085, '101038', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 10:36:19', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1082, '101035', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 10:11:47', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1084, '101037', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 10:21:58', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1083, '101036', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 10:14:05', 'Paid', NULL, '36.00', '32.40', '32.40', NULL, '35.00', '2.60', '0.00', '0.00', '3.60', '0.00', 'Cash', NULL, '27', '1468675805', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1081, '101034', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-16 08:24:35', 'Paid', NULL, '110.00', '110.00', '0.00', '110.00', '110.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1468675805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '1.23', 'VISA', '1.12', NULL, '0.07', '108.69', 0, NULL, NULL, NULL, NULL, '0'),
(1166, '101114', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 15:44:52', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '50.00', '39.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1167, '101115', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 15:46:33', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1168, '101120', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 16:52:44', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1169, '101119', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 16:51:40', 'Paid', NULL, '9.90', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1170, '101123', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 17:24:15', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '15.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1171, '101122', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 17:19:55', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1165, '101113', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 15:43:48', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1163, '101111', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 15:42:23', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1164, '101112', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 15:43:12', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1161, '101117', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 16:28:14', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '36.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1162, '101110', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 15:37:00', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1160, '101109', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 15:20:58', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '36.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1159, '101126', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 18:12:25', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '100.00', '82.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1158, '101118', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 16:36:55', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '100.00', '74.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1155, '101106', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 14:05:59', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1157, '101116', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 15:51:31', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1156, '101107', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 14:19:16', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1153, '101108', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 14:42:59', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1154, '101105', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 14:04:45', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1152, '101104', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 13:55:01', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1151, '101102', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 13:35:57', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1150, '101101', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 13:26:21', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1149, '101103', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 13:50:20', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1148, '101098', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 13:14:54', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1147, '101097', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 13:08:46', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1146, '101100', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-07-17 13:24:53', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '100.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1145, '101094', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-07-17 12:45:51', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1144, '101091', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-07-17 12:35:08', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1141, '101095', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-07-17 12:53:49', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1142, '101089', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-07-17 12:33:13', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1143, '101090', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-07-17 12:33:59', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1129, '101079', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 10:58:40', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1130, '101084', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-07-17 11:51:48', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1131, '101080', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-07-17 11:08:15', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '60.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1132, '101082', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-07-17 11:32:19', 'Paid', NULL, '52.00', '52.00', '0.00', '52.00', '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '0.94', 'Master Card', '1.80', NULL, '0.06', '51.01', 0, NULL, NULL, NULL, NULL, '0'),
(1133, '101093', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-07-17 12:42:53', 'Paid', NULL, '73.00', '73.00', '73.00', NULL, '73.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1134, '101096', '12', 10011, 'Staff', NULL, NULL, 'history', '2016-07-17 12:57:58', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '38.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1135, '101087', 'T5', 10011, 'Staff', NULL, NULL, 'history', '2016-07-17 12:18:40', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '36.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1136, '101092', '1', 10011, 'Staff', NULL, NULL, 'history', '2016-07-17 12:41:31', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1137, '101085', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-07-17 11:57:27', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1138, '101099', 'T14', 10011, 'Staff', NULL, NULL, 'history', '2016-07-17 13:15:28', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1139, '101086', 'T15', 10011, 'Staff', NULL, NULL, 'history', '2016-07-17 12:01:15', 'Paid', NULL, '80.00', '80.00', '80.00', NULL, '80.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1140, '101088', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-07-17 12:22:53', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1127, '101081', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 11:17:56', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1128, '101083', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 11:33:30', 'Paid', NULL, '126.00', '126.00', '126.00', NULL, '126.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1125, '101077', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 10:40:25', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '100.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1126, '101076', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 10:23:44', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1123, '101074', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 09:52:06', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1124, '101078', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 10:49:10', 'Paid', NULL, '96.00', '96.00', '96.00', NULL, '96.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1122, '101075', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 10:08:25', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1172, '101121', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 17:19:22', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1173, '101127', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 18:20:04', 'Paid', NULL, '94.00', '94.00', '94.00', NULL, '104.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1174, '101124', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 17:51:18', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1175, '101125', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 17:54:59', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1176, '101128', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 19:05:07', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1177, '101134', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 21:24:01', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '51.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1178, '101129', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 19:51:54', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '20.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1179, '101130', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 20:08:36', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1180, '101131', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 20:15:38', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1181, '101135', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 22:23:08', 'Paid', NULL, '395.00', '395.00', '0.00', '395.00', '395.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '4.42', 'VISA', '1.12', NULL, '0.27', '390.31', 0, NULL, NULL, NULL, NULL, '0'),
(1182, '101133', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 21:11:13', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1183, '101132', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-17 21:05:24', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468766326', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1206, '101154', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 18:44:12', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '53.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1207, '101157', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 19:13:57', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1208, '101162', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 20:33:24', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1209, '101158', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 19:39:34', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1210, '101159', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 19:50:05', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1211, '101161', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 20:18:55', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '15.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1212, '101160', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 20:15:00', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1204, '101155', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 18:56:56', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '40.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1205, '101156', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 19:04:48', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1200, '101150', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 14:50:54', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1201, '101151', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 14:51:42', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1202, '101153', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 18:06:57', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1203, '101152', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 16:36:30', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '50.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1199, '101149', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 14:49:50', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1198, '101147', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 13:16:46', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1196, '101145', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 12:42:05', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1197, '101148', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 14:10:59', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '64.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1194, '101143', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 11:35:35', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1193, '101142', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 11:32:53', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1192, '101140', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 11:29:43', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1191, '101139', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 11:28:52', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1190, '101138', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 11:28:07', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1189, '101137', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 11:26:53', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '100.00', '61.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1188, '101141', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 11:32:08', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1187, '101144', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 11:40:12', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1184, '101136', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 09:16:07', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1186, '101146', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-18 12:55:06', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '100.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468848073', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1233, '101179', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-19 16:15:24', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1234, '101181', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-19 16:33:48', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1235, '101182', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-19 16:48:30', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1236, '101185', 't1', 10003, 'admin', NULL, NULL, 'history', '2016-07-19 18:47:49', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1237, '101188', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-19 19:55:28', 'Paid', NULL, '83.00', '83.00', '83.00', NULL, '83.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1238, '101186', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-19 18:52:20', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1239, '101187', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-19 19:32:15', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1240, '101190', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-07-19 20:12:41', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1241, '101189', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-19 20:04:58', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1232, '101178', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2016-07-19 15:51:31', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(1223, '101169', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-19 13:27:14', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1224, '101170', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-19 13:28:11', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1225, '101171', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-19 13:34:09', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1227, '101176', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-19 14:34:38', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1228, '101175', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-07-19 14:18:55', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1229, '101180', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-19 16:32:29', 'Paid', NULL, '78.00', '78.00', '78.00', NULL, '100.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1230, '101177', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-19 15:13:16', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1231, '101184', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-19 18:18:32', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1222, '101173', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-19 13:57:23', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1221, '101183', 'T12', 10011, 'Staff', NULL, NULL, 'history', '2016-07-19 17:28:12', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(1219, '101166', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-07-19 12:39:42', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '52.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1220, '101167', 'T11', 10011, 'Staff', NULL, NULL, 'history', '2016-07-19 12:43:43', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '100.00', '56.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1218, '101174', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-07-19 13:58:30', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '51.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1217, '101168', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-07-19 13:03:44', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '70.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1216, '101165', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-07-19 11:48:08', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1215, '101172', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-07-19 13:51:28', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1214, '101164', 'T10', 10011, 'Staff', NULL, NULL, 'history', '2016-07-19 10:45:44', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '53.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1213, '101163', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-07-19 10:06:59', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1468930438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1257, '101206', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 16:27:31', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469115065', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1258, '101205', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 16:20:32', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '20.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469115065', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1259, '101208', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 17:21:46', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469115065', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1260, '101209', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 17:57:06', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469115065', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1261, '101210', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 19:18:23', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469115065', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1262, '101211', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 20:03:42', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '55.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469115065', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1263, '101213', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 23:18:58', 'Paid', NULL, '198.00', '178.20', '178.20', NULL, '200.20', '22.00', '0.00', '0.00', '19.80', '0.00', 'Cash', NULL, '27', '1469115065', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1264, '101212', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 22:43:12', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469115065', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1246, '101195', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 11:29:23', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '20.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469115065', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1245, '101193', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 11:09:05', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '70.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469115065', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1254, '101204', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 15:11:25', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469115065', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1255, '101207', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 17:10:50', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469115065', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1256, '101203', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 15:06:14', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469115065', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1244, '101194', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 11:27:42', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '53.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469115065', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1247, '101196', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 11:29:56', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '20.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469115065', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1248, '101201', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 13:51:15', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469115065', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1249, '101197', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 11:31:02', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469115065', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1250, '101198', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 12:39:02', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469115065', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1251, '101199', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 13:05:55', 'Paid', NULL, '112.00', '112.00', '112.00', NULL, '112.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469115065', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1252, '101200', '11', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 13:36:39', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '100.00', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469115065', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1253, '101202', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 14:25:56', 'Paid', NULL, '67.00', '60.30', '60.30', NULL, '71.00', '10.70', '0.00', '0.00', '6.70', '0.00', 'Cash', NULL, '27', '1469115065', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1242, '101191', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 10:26:10', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469115065', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1243, '101192', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-21 10:47:22', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469115065', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1280, '101229', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-22 18:52:22', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469196197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1281, '101227', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-22 17:52:41', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469196197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1283, '101228', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-22 17:59:15', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469196197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1284, '101230', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-07-22 19:08:38', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '0.00', '-52.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469196197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1286, '101231', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-22 20:48:12', 'Paid', NULL, '110.00', '110.00', '110.00', NULL, '110.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469196197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1287, '101234', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-22 21:48:25', 'Paid', NULL, '82.00', '82.00', '82.00', NULL, '100.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469196197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1288, '101233', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-22 21:19:10', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469196197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1269, '101217', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-22 11:30:53', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469196197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1270, '101218', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-22 12:45:45', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469196197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1267, '101216', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-22 11:23:45', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469196197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1268, '101219', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-22 13:17:57', 'Paid', NULL, '74.00', '74.00', '74.00', NULL, '74.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469196197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1275, '101226', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-07-22 16:48:55', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469196197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1285, '101232', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-22 21:18:03', 'Paid', NULL, '84.00', '75.60', '75.60', NULL, '105.60', '30.00', '0.00', '0.00', '8.40', '0.00', 'Cash', NULL, '27', '1469196197', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1273, '101220', 'T13(S)', 10003, 'admin', NULL, NULL, 'history', '2016-07-22 13:30:46', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469196197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(1274, '101221', 'T13(S)', 10003, 'admin', NULL, NULL, 'history', '2016-07-22 14:41:31', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469196197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(1276, '101222', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-22 15:19:22', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '100.00', '76.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469196197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1277, '101224', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-22 15:52:50', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469196197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1278, '101223', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-22 15:26:21', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469196197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1279, '101225', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-22 16:42:55', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469196197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1266, '101215', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-22 10:49:13', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469196197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1265, '101214', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-22 09:45:26', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469196197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1326, '101271', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 18:32:10', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1327, '101273', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 21:42:54', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '58.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1322, '101272', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 18:45:36', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1323, '101270', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 18:25:04', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1324, '101268', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 17:36:35', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1325, '101269', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 18:21:51', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1321, '101266', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 17:05:09', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1320, '101265', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 16:32:24', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1319, '101267', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 17:11:48', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1291, '101242', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 11:04:38', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '50.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1292, '101252', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 12:27:56', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '65.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1293, '101237', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 10:26:31', 'Paid', NULL, '82.00', '82.00', '82.00', NULL, '100.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1294, '101238', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 10:39:11', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1295, '101243', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 11:05:32', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1296, '101245', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 11:28:24', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1297, '101239', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 10:48:10', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1298, '101240', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 11:02:26', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1299, '101241', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 11:04:17', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1300, '101244', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 11:09:22', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '100.00', '85.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1301, '101246', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 11:30:51', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1302, '101247', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 11:31:36', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1303, '101248', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 11:32:17', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1304, '101249', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 11:33:06', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1305, '101250', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 11:35:11', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1306, '101251', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 12:13:02', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1307, '101253', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 13:10:24', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '50.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1308, '101254', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 13:13:45', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1309, '101255', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 13:21:42', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1310, '101256', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 13:22:32', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1311, '101263', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 15:26:23', 'Paid', NULL, '80.00', '80.00', '80.00', NULL, '100.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1312, '101257', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 13:54:26', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1313, '101258', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 14:16:48', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1314, '101259', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 14:26:41', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1315, '101261', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 14:37:54', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1316, '101260', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 14:30:03', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1317, '101262', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 14:40:13', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1318, '101264', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 16:00:20', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '43.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1290, '101236', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 09:57:33', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '100.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1289, '101235', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-23 09:08:11', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469281396', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1373, '101319', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 19:11:50', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1372, '101318', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 18:52:24', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1371, '101317', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 18:32:03', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1370, '101316', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 18:06:43', 'Paid', NULL, '34.00', '30.60', '30.60', NULL, '100.00', '69.40', '0.00', '0.00', '3.40', '0.00', 'Cash', NULL, '27', '1469359587', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1369, '101315', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 17:33:45', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1368, '101313', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 16:41:48', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1367, '101312', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 16:33:42', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1365, '101314', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 16:55:19', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '42.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1366, '101309', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 16:01:36', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1359, '101308', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 15:58:51', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '67.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1360, '101304', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 15:03:45', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1361, '101306', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 15:16:02', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1362, '101307', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 15:18:52', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1363, '101311', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 16:06:19', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1364, '101310', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 16:03:24', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1330, '101275', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 09:50:11', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1331, '101277', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 10:11:30', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1332, '101278', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 10:22:02', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1333, '101279', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 10:26:01', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1334, '101280', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 10:29:49', 'Paid', NULL, '71.00', '71.00', '71.00', NULL, '71.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1335, '101281', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 10:43:08', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1336, '101282', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 11:01:08', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '38.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1337, '101303', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 14:45:24', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1338, '101283', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 11:37:09', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1339, '101284', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 11:37:56', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '36.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1340, '101285', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 11:38:46', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1341, '101286', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 11:39:48', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1342, '101287', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 11:42:45', 'Paid', NULL, '100.00', '100.00', '100.00', NULL, '100.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1343, '101288', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 11:44:48', 'Paid', NULL, '79.00', '79.00', '79.00', NULL, '100.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1344, '101289', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 11:45:52', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1345, '101290', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 11:47:07', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '100.00', '69.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1346, '101291', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 11:48:29', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '100.00', '61.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1347, '101292', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 11:49:22', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1348, '101293', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 11:54:55', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1349, '101297', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 13:08:13', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1350, '101294', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 12:28:33', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1351, '101295', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 12:47:02', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1352, '101296', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 13:02:12', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1353, '101299', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 14:30:44', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '100.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1354, '101302', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 14:45:06', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1355, '101298', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 14:05:03', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '100.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1356, '101300', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 14:43:27', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1357, '101306', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 15:13:50', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '100.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1358, '101301', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 14:44:14', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1329, '101274', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 09:41:51', 'Paid', NULL, '81.00', '72.90', '72.90', NULL, '100.00', '27.10', '0.00', '0.00', '8.10', '0.00', 'Cash', NULL, '27', '1469359587', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1328, '101276', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-24 09:59:26', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469359587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1375, '101321', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-07-25 10:04:22', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '70.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469445375', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1376, '101322', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-07-25 11:05:37', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469445375', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1377, '101323', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-07-25 12:07:20', 'Paid', NULL, '82.00', '82.00', '82.00', NULL, '82.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469445375', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1378, '101324', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-07-25 12:57:09', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '39.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469445375', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1379, '101326', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-07-25 13:23:18', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469445375', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1380, '101327', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-07-25 13:37:46', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469445375', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1381, '101325', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-25 13:15:01', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '100.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469445375', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1382, '101328', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-25 14:48:49', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469445375', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1383, '101329', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-25 15:26:19', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469445375', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1384, '101330', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-25 15:30:39', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469445375', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(1385, '101331', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-25 15:43:42', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469445375', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1386, '101333', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-25 16:38:51', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '20.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469445375', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1387, '101332', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-25 16:04:49', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469445375', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1388, '101334', 't13', 10003, 'admin', NULL, NULL, 'history', '2016-07-25 16:43:40', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469445375', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1389, '101337', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-25 19:07:17', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '100.00', '76.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469445375', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1390, '101335', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-25 17:07:07', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469445375', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1391, '101336', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-07-25 18:35:13', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469445375', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1374, '101320', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-07-25 10:02:46', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '64.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469445375', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1393, '101340', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-26 12:43:49', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '100.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469528863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1394, '101338', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-26 12:31:28', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469528863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1395, '101341', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-26 13:05:40', 'Paid', NULL, '109.00', '109.00', '109.00', NULL, '109.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469528863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1396, '101342', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-07-26 13:58:29', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '40.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469528863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1397, '101347', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-26 17:18:37', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469528863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1398, '101345', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-26 15:58:55', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469528863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1399, '101343', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-26 14:43:36', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469528863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1400, '101344', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-26 15:45:43', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469528863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1401, '101349', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-26 18:03:25', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469528863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1402, '101346', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-26 17:06:36', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469528863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1403, '101348', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-26 17:19:06', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '102.00', '60.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469528863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1392, '101339', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-26 12:32:21', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '70.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469528863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1434, '101377', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-28 18:55:24', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1433, '101378', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-28 18:57:33', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1432, '101376', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-28 18:44:18', 'Paid', NULL, '72.00', '72.00', '72.00', NULL, '102.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1431, '101375', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-28 18:17:35', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '100.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1430, '101374', 't1', 10003, 'admin', NULL, NULL, 'history', '2016-07-28 18:05:29', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1429, '101373', 't13', 10003, 'admin', NULL, NULL, 'history', '2016-07-28 18:05:00', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '20.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1428, '101372', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-07-28 18:04:35', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1427, '101371', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-28 16:56:07', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1426, '101370', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-28 16:11:17', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '30.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1425, '101369', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-07-28 15:06:08', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1424, '101368', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-07-28 15:00:21', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1423, '101367', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-07-28 14:15:26', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1422, '101366', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-07-28 13:49:21', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1421, '101364', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-07-28 13:44:12', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '36.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1419, '101362', 'T15(S)', 10011, 'Staff', NULL, NULL, 'history', '2016-07-28 13:20:43', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(1418, '101361', 'T15(S)', 10011, 'Staff', NULL, NULL, 'history', '2016-07-28 13:20:02', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(1420, '101363', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-07-28 13:29:51', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1416, '101365', 'T7', 10011, 'Staff', NULL, NULL, 'history', '2016-07-28 13:48:13', 'Paid', NULL, '81.00', '81.00', '81.00', NULL, '81.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1415, '101360', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-07-28 13:02:58', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1414, '101359', 'T5', 10011, 'Staff', NULL, NULL, 'history', '2016-07-28 12:57:02', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '0.00', '-62.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1413, '101358', 'T12', 10011, 'Staff', NULL, NULL, 'history', '2016-07-28 12:42:39', 'Paid', NULL, '73.00', '73.00', '73.00', NULL, '100.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1412, '101357', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-28 11:08:55', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1411, '101355', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2016-07-28 10:00:39', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(1410, '101356', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-28 10:01:38', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1406, '101351', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-28 09:08:21', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1407, '101352', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-28 09:19:19', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '30.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1408, '101353', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-28 09:23:16', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1409, '101354', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-28 09:29:29', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '100.00', '78.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1405, '101350', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-28 09:05:34', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469709163', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1464, '101405', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 21:08:44', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1465, '101406', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 21:13:23', 'Paid', NULL, '90.00', '90.00', '90.00', NULL, '100.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1466, '101407', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 21:15:50', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1467, '101408', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 21:16:23', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1468, '101409', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 21:16:52', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1469, '101411', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 21:53:00', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '100.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1463, '101410', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 21:47:55', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1462, '101404', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 20:26:55', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1461, '101412', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 21:54:52', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1460, '101403', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 19:50:26', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1459, '101400', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 19:25:12', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1458, '101401', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 19:33:07', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1457, '101402', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 19:43:27', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '70.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1456, '101398', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 17:10:13', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1455, '101397', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 17:04:42', 'Paid', NULL, '85.00', '85.00', '85.00', NULL, '100.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1454, '101395', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 16:25:49', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1453, '101394', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 16:20:09', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1452, '101396', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 16:51:46', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1451, '101399', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 17:24:21', 'Paid', NULL, '72.00', '72.00', '72.00', NULL, '72.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1448, '101391', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 15:25:18', 'Paid', NULL, '38.00', '34.20', '34.20', NULL, '50.20', '16.00', '0.00', '0.00', '3.80', '0.00', 'Cash', NULL, '27', '1469800747', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1449, '101390', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 14:54:24', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1447, '101389', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 14:45:14', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1450, '101393', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 16:19:13', 'Paid', NULL, '28.00', '25.20', '25.20', NULL, '50.00', '24.80', '0.00', '0.00', '2.80', '0.00', 'Cash', NULL, '27', '1469800747', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1446, '101388', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 14:15:58', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1444, '101387', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 13:35:39', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1443, '101386', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 13:34:31', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1442, '101392', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 15:50:30', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '70.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1441, '101384', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 13:12:31', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1437, '101381', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 10:52:42', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1436, '101380', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 10:14:57', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1438, '101382', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 10:58:58', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1439, '101383', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 11:44:09', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1440, '101385', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 13:30:59', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1435, '101379', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-29 10:07:55', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469800747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1521, '101461', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 20:39:03', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1522, '101462', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 20:40:36', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1523, '101463', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 20:45:35', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '38.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1525, '101465', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 20:51:06', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1526, '101467', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 21:28:50', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '20.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1524, '101464', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 20:49:07', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1517, '101458', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 18:47:47', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1518, '101459', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 19:19:13', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1519, '101460', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 20:35:42', 'Paid', NULL, '151.00', '151.00', '151.00', NULL, '151.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1520, '101466', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 20:53:56', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '56.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1514, '101456', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 17:10:05', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1515, '101457', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 18:21:11', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1513, '101455', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 17:03:56', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1512, '101454', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 17:01:50', 'Paid', NULL, '90.00', '81.00', '72.00', NULL, '100.00', '28.00', '0.00', '0.00', '9.00', '0.00', 'Cash', NULL, '27', '1469886405', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1511, '101452', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 15:57:35', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '36.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1509, '101450', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 15:21:48', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1510, '101451', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 15:49:11', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1508, '101449', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 15:17:49', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1497, '101437', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-07-30 14:19:56', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1498, '101438', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-07-30 14:20:48', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1499, '101439', 'T10', 10008, 'lois', NULL, NULL, 'history', '2016-07-30 14:21:38', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1500, '101440', 'T2', 10008, 'lois', NULL, NULL, 'history', '2016-07-30 14:23:13', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1501, '101448', 'T12', 10008, 'lois', NULL, NULL, 'history', '2016-07-30 15:10:49', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '103.00', '60.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1502, '101441', 'T2', 10008, 'lois', NULL, NULL, 'history', '2016-07-30 14:36:21', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '20.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1503, '101447', 'T1', 10008, 'lois', NULL, NULL, 'history', '2016-07-30 15:06:05', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1504, '101443', 'T15', 10008, 'lois', NULL, NULL, 'history', '2016-07-30 14:55:04', 'Paid', NULL, '81.00', '81.00', '81.00', NULL, '105.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1505, '101444', 'T11', 10008, 'lois', NULL, NULL, 'history', '2016-07-30 14:57:48', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1506, '101446', 'T11', 10008, 'lois', NULL, NULL, 'history', '2016-07-30 15:00:07', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '20.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1507, '101453', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 16:35:20', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1494, '101434', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-07-30 14:18:07', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '50.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1495, '101435', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-07-30 14:18:43', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1496, '101436', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-07-30 14:19:05', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1488, '101431', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 13:38:54', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '100.00', '51.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1489, '101442', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 14:51:28', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '100.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1490, '101432', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 13:46:03', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1491, '101433', 'T6', 10011, 'Staff', NULL, NULL, 'history', '2016-07-30 14:03:26', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1492, '101445', 'T13', 10011, 'Staff', NULL, NULL, 'history', '2016-07-30 14:58:08', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1486, '101430', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 13:09:40', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '100.00', '62.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1487, '101428', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 12:42:09', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1483, '101426', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 12:10:30', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1484, '101427', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 12:16:48', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1485, '101429', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 13:06:16', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1481, '101424', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 11:46:36', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1482, '101425', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 11:47:13', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1480, '101423', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 11:43:09', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1479, '101422', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 11:38:32', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1477, '101420', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 11:37:04', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1478, '101421', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 11:37:59', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1471, '101414', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 10:05:56', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1475, '101418', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 11:35:08', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1476, '101419', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 11:36:09', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '55.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1474, '101417', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 11:29:11', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '100.00', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1473, '101416', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 11:24:55', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1472, '101415', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 10:52:04', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1470, '101413', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-30 09:14:39', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '76.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469886405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1566, '101508', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 21:42:45', 'Paid', NULL, '298.00', '298.00', '0.00', '298.00', '298.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '5.36', 'Master Card', '1.80', NULL, '0.32', '292.31', 0, NULL, NULL, NULL, NULL, '0'),
(1567, '101507', 'T11', 10008, 'lois', NULL, NULL, 'history', '2016-07-31 20:49:19', 'Paid', NULL, '71.00', '71.00', '71.00', NULL, '71.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1565, '101506', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 20:39:25', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1554, '101502', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 15:16:12', 'Paid', NULL, '80.00', '80.00', '80.00', NULL, '100.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1555, '101494', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 15:02:37', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1556, '101495', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 15:02:57', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '10.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1557, '101496', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 15:03:18', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '21.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1558, '101497', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 15:03:40', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1559, '101498', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 15:03:54', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(1560, '101499', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 15:06:35', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1561, '101500', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 15:07:08', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1562, '101501', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 15:13:24', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1563, '101503', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 15:19:13', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '21.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1564, '101504', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 15:21:20', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1547, '101487', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 11:42:03', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1548, '101490', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 12:22:38', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1549, '101488', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 11:51:38', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1546, '101485', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 11:31:20', 'Paid', NULL, '81.00', '81.00', '81.00', NULL, '101.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1545, '101484', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 11:29:14', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1553, '101493', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 14:22:24', 'Paid', NULL, '106.00', '106.00', '106.00', NULL, '106.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1552, '101492', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 13:13:09', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1551, '101491', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 12:30:12', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1550, '101489', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 12:17:07', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1540, '101480', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 11:14:56', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1541, '101505', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 17:15:59', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1542, '101481', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 11:25:57', 'Paid', NULL, '85.00', '85.00', '85.00', NULL, '100.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1543, '101482', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 11:27:39', 'Paid', NULL, '80.00', '80.00', '80.00', NULL, '80.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1544, '101483', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 11:28:47', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1538, '101478', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 11:10:36', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1539, '101479', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 11:13:40', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1537, '101486', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 11:33:12', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1535, '101475', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 10:32:30', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1536, '101477', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 10:52:14', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1533, '101473', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 10:06:30', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1534, '101474', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 10:06:53', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1531, '101476', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 10:33:24', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '100.00', '74.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1532, '101472', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 10:05:36', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1530, '101471', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 09:40:05', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '30.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1528, '101469', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 09:12:49', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1529, '101470', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 09:27:42', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1527, '101468', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-07-31 09:10:33', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '51.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1469973773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1589, '101528', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 15:02:49', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '20.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1590, '101529', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 15:03:07', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1591, '101530', 'T12', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 15:47:08', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '30.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1592, '101531', 'T0', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 15:47:50', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1593, '101532', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 16:02:43', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1594, '101534', 'T15', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 17:41:40', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '58.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1595, '101533', 't4', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 17:23:59', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1596, '101538', 'T12', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 19:37:06', 'Paid', NULL, '84.00', '84.00', '84.00', NULL, '84.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1597, '101536', 'T14(S)', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 18:50:50', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(1598, '101537', 'T14(S)', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 18:51:05', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '50.00', '39.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(1600, '101540', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 21:25:30', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1588, '101527', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 14:26:25', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1586, '101525', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 14:16:33', 'Paid', NULL, '73.00', '73.00', '73.00', NULL, '100.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1587, '101526', 'T9', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 14:25:24', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1580, '101520', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 12:46:26', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1581, '101521', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 12:48:20', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '25.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1582, '101522', 'T9', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 13:21:12', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '100.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1583, '101523', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 13:43:20', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1599, '101539', 'T12', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 19:50:42', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1585, '101524', 'T14(S)', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 14:14:10', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(1579, '101519', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 12:44:37', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '20.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1577, '101517', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 12:20:11', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1578, '101518', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 12:22:37', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1575, '101513', 'T15', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 12:06:30', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '100.00', '81.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1576, '101516', 'IS', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 12:15:24', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1574, '101512', 'T5(S)', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 11:45:48', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(1572, '101511', 'T8', 10008, 'lois', NULL, NULL, 'history', '2016-08-01 11:44:15', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1573, '101514', 'T10', 10011, 'Staff', NULL, NULL, 'history', '2016-08-01 12:06:53', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '15.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1569, '101510', 'T4', 10008, 'lois', NULL, NULL, 'history', '2016-08-01 10:39:16', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1571, '101535', 'T5', 10008, 'lois', NULL, NULL, 'history', '2016-08-01 18:06:05', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1570, '101515', 'T12', 10008, 'lois', NULL, NULL, 'history', '2016-08-01 12:13:28', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1568, '101509', 'T7', 10008, 'lois', NULL, NULL, 'history', '2016-08-01 10:23:14', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470021703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1614, '101553', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-02 17:56:53', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470120438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1615, '101554', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-02 18:14:53', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470120438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1612, '101552', 't1', 10003, 'admin', NULL, NULL, 'history', '2016-08-02 17:28:55', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470120438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1613, '101555', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-02 20:19:26', 'Paid', NULL, '126.00', '126.00', '126.00', NULL, '150.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470120438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1609, '101550', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-02 16:14:18', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470120438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1610, '101551', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-02 16:27:04', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470120438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1611, '101549', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-02 15:57:31', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470120438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1607, '101547', 't13', 10003, 'admin', NULL, NULL, 'history', '2016-08-02 13:52:54', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470120438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1608, '101548', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-02 14:46:54', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470120438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1604, '101544', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-08-02 11:29:42', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470120438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1605, '101546', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-08-02 13:46:16', 'Paid', NULL, '115.00', '103.50', '0.00', '103.50', '103.50', '0.00', '0.00', '0.00', '11.50', '0.00', 'Credit Card', NULL, '27', '1470120438', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, 4, '1.86', 'Master Card', '1.80', NULL, '0.11', '101.53', 0, NULL, NULL, NULL, NULL, '0'),
(1606, '101545', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-02 13:40:28', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470120438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1602, '101542', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-02 10:22:17', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470120438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1603, '101543', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-02 10:51:09', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470120438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1601, '101541', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-02 10:13:33', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470120438', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1634, '101572', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-08-04 18:00:59', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470285478', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1635, '101574', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-04 18:59:58', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470285478', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1630, '101568', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-04 16:26:48', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470285478', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1631, '101569', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-04 16:30:57', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470285478', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1632, '101573', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-04 18:03:30', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470285478', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1633, '101571', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-04 17:26:07', 'Paid', NULL, '55.00', '55.00', '0.00', '55.00', '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1470285478', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '0.62', 'VISA', '1.12', NULL, '0.04', '54.35', 0, NULL, NULL, NULL, NULL, '0'),
(1626, '101564', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-04 13:54:38', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '110.00', '52.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470285478', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1627, '101565', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-04 14:06:16', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470285478', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1628, '101570', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-08-04 17:01:05', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '100.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470285478', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1629, '101567', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-08-04 15:33:58', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470285478', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1622, '101561', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-04 11:48:03', 'Paid', NULL, '103.00', '103.00', '103.00', NULL, '103.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470285478', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1623, '101563', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-08-04 13:06:29', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470285478', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1624, '101566', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-04 15:07:00', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470285478', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1617, '101557', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-04 10:14:25', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470285478', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1618, '101560', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-08-04 10:30:00', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470285478', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1619, '101556', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-04 10:13:21', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470285478', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1625, '101562', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-08-04 12:34:42', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '100.00', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470285478', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1620, '101559', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-04 10:27:20', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '100.00', '94.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470285478', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1616, '101558', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-04 10:15:47', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '51.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470285478', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1663, '101601', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 18:02:06', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1664, '101603', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 19:19:33', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1665, '101606', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 19:59:46', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1666, '101605', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 19:51:25', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1667, '101604', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 19:31:48', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '35.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1668, '101607', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 20:06:21', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1669, '101610', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 21:06:10', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '100.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1670, '101608', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 20:32:14', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '50.00', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1671, '101609', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 20:39:23', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1672, '101611', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 21:34:54', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1662, '101600', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 17:37:50', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1656, '101595', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 15:11:07', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '100.00', '72.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1657, '101596', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 15:30:06', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '20.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1658, '101597', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 15:30:58', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1659, '101598', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 15:56:16', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1660, '101599', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 16:05:23', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1661, '101602', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 18:20:11', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1653, '101589', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-05 13:38:53', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1654, '101590', 'T9', 10010, 'sanni', NULL, NULL, 'history', '2016-08-05 13:44:57', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1655, '101594', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 15:07:45', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1649, '101585', 'T10', 10010, 'sanni', NULL, NULL, 'history', '2016-08-05 13:22:44', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1650, '101586', 'T7', 10010, 'sanni', NULL, NULL, 'history', '2016-08-05 13:25:21', 'Paid', NULL, '62.00', '62.00', '0.00', '62.00', '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '1.12', 'Master Card', '1.80', NULL, '0.07', '60.82', 0, NULL, NULL, NULL, NULL, '0'),
(1651, '101593', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-08-05 14:30:05', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1652, '101588', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-05 13:32:18', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1645, '101582', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 12:56:17', 'Paid', NULL, '155.00', '155.00', '0.00', '155.00', '155.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '1.74', 'VISA', '1.12', NULL, '0.10', '153.16', 0, NULL, NULL, NULL, NULL, '0'),
(1639, '101578', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-05 10:18:14', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1640, '101579', 'T7', 10010, 'sanni', NULL, NULL, 'history', '2016-08-05 10:33:21', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '60.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1641, '101581', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 12:37:30', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '40.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1642, '101580', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 11:59:04', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1643, '101592', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 13:51:25', 'Paid', NULL, '82.00', '82.00', '0.00', '82.00', '82.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '1.48', 'Master Card', '1.80', NULL, '0.09', '80.44', 0, NULL, NULL, NULL, NULL, '0'),
(1644, '101587', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 13:27:10', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1646, '101583', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 13:06:54', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1647, '101591', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 13:48:03', 'Paid', NULL, '122.00', '122.00', '122.00', NULL, '122.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1648, '101584', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-05 13:19:30', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1637, '101576', 'T6', 10010, 'sanni', NULL, NULL, 'history', '2016-08-05 09:17:32', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1638, '101577', 'T6', 10010, 'sanni', NULL, NULL, 'history', '2016-08-05 09:23:37', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '51.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1636, '101575', 'T7', 10010, 'sanni', NULL, NULL, 'history', '2016-08-05 09:03:11', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470397619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1721, '101658', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 20:46:43', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1718, '101659', 'T14', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 21:05:17', 'Paid', NULL, '72.00', '72.00', '72.00', NULL, '72.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1720, '101657', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 20:14:38', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1717, '101655', 'T14', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 17:57:30', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '70.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1716, '101654', 'T12', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 17:48:22', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1715, '101653', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 17:47:01', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1719, '101656', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 20:08:38', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '50.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1712, '101649', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 16:50:06', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1713, '101651', 'T2', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 17:14:06', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1714, '101652', 'T12', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 17:46:44', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1710, '101648', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 16:36:00', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1700, '101637', 'IS', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 13:17:02', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(1701, '101638', 'T6', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 13:17:33', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '100.00', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1702, '101639', 'T15', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 13:57:41', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1703, '101643', 'T2', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 14:41:21', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '101.00', '60.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1704, '101640', 'T6', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 14:25:18', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1705, '101641', 'T7', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 14:32:46', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1706, '101646', 'T6', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 16:02:53', 'Paid', NULL, '74.00', '74.00', '74.00', NULL, '100.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1707, '101645', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 15:23:59', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1708, '101650', 'T10', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 16:51:14', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1709, '101647', 'T5', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 16:20:14', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1692, '101630', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-08-06 12:27:12', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1693, '101631', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-06 12:35:08', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1694, '101632', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-06 12:38:33', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1695, '101633', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-06 12:39:21', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1696, '101634', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-06 12:44:33', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1697, '101642', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-06 14:40:19', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '106.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1698, '101635', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-06 12:50:36', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '50.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1699, '101636', 'T12', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 13:07:38', 'Paid', NULL, '2.00', '2.00', '2.00', NULL, '2.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1689, '101627', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-06 11:49:41', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1690, '101628', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-08-06 11:50:33', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1685, '101623', 'T12', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 10:42:22', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1686, '101624', 'T7', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 10:44:38', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '100.00', '54.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1687, '101625', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-08-06 10:45:37', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '15.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1688, '101644', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-08-06 14:58:14', 'Paid', NULL, '102.00', '102.00', '102.00', NULL, '102.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1691, '101629', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-06 11:59:19', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1674, '101613', 'T13', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 09:56:42', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1675, '101614', 'T15', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 10:18:01', 'Paid', NULL, '83.00', '83.00', '83.00', NULL, '100.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1676, '101615', 'T8', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 10:21:08', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '56.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1677, '101616', 'T8', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 10:22:05', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1678, '101617', 'T9', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 10:22:31', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1679, '101618', 'T9', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 10:23:07', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1680, '101619', 'T10', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 10:24:03', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1681, '101626', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 11:48:56', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1682, '101620', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 10:28:58', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1683, '101621', 'T12', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 10:40:30', 'Paid', NULL, '210.00', '210.00', '210.00', NULL, '210.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1684, '101622', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 10:41:10', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1673, '101612', 'T7', 10010, 'sanni', NULL, NULL, 'history', '2016-08-06 09:41:18', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470465155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1786, '101723', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 17:26:12', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '36.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1783, '101724', 'T12', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 17:43:08', 'Paid', NULL, '102.00', '91.80', '91.80', NULL, '101.80', '10.00', '0.00', '0.00', '10.20', '0.00', 'Cash', NULL, '27', '1470552213', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1784, '101721', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 15:57:37', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1785, '101722', 'T13', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 16:44:50', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1770, '101706', 'T7', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 12:32:55', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1771, '101707', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 12:36:48', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1772, '101708', 'T10', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 12:52:48', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1773, '101711', 'T13', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 13:00:07', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '58.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1774, '101712', 'T13', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 13:08:30', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '68.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1775, '101713', 'T5', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 13:24:35', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1776, '101714', 'T13', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 13:57:19', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '70.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1777, '101715', 'T5', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 14:06:52', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1778, '101716', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 14:17:41', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1779, '101717', 'T1', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 14:26:43', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '40.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1780, '101718', 'T2', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 14:46:11', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '20.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1781, '101719', 'T7', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 15:01:08', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '52.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1782, '101720', 'T14', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 15:41:23', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1767, '101703', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 12:04:35', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '50.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1768, '101709', 'T5', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 12:54:43', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1769, '101705', 'T1', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 12:31:12', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1766, '101701', 'T8', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 12:01:24', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1765, '101710', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 12:57:43', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1761, '101697', 'T0', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 11:47:28', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1762, '101698', 'T1', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 11:49:15', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1763, '101699', 'T8', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 11:51:53', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1764, '101700', 'T1', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 11:58:03', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1759, '101695', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-08-07 11:45:04', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1760, '101696', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-08-07 11:45:52', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '70.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1749, '101704', 'T7', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 12:13:19', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1750, '101686', 'T6', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 11:15:31', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1751, '101687', 'T8', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 11:20:07', 'Paid', NULL, '105.00', '105.00', '0.00', '105.00', '105.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '1.89', 'Master Card', '1.80', NULL, '0.11', '103.00', 0, NULL, NULL, NULL, NULL, '0'),
(1752, '101688', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 11:22:35', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1753, '101689', 'T8', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 11:26:12', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1754, '101690', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 11:26:58', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1755, '101691', 'T8', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 11:27:37', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1756, '101692', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 11:28:34', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1757, '101693', 'T8', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 11:31:20', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1758, '101694', 'T1', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 11:43:40', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1734, '101671', 'T2', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 09:57:30', 'Paid', NULL, '89.00', '89.00', '89.00', NULL, '100.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1735, '101672', 'T10', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 10:09:33', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1736, '101673', 'T2', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 10:10:21', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '100.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1737, '101674', 'T7', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 10:19:10', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1738, '101702', 'T13', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 12:03:50', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '100.00', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1739, '101681', 'T5', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 10:47:10', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1740, '101675', 'T14', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 10:27:04', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '30.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1741, '101676', 'T14', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 10:27:32', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '30.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1742, '101678', 'T1', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 10:32:42', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '50.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1743, '101679', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 10:34:22', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '60.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1744, '101680', 'T14', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 10:44:16', 'Paid', NULL, '107.00', '107.00', '107.00', NULL, '120.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1745, '101682', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 10:56:55', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1746, '101683', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 11:02:06', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1747, '101684', 'T15', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 11:02:57', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1748, '101685', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 11:07:04', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1733, '101677', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 10:28:35', 'Paid', NULL, '131.00', '117.90', '117.90', NULL, '150.00', '32.10', '0.00', '0.00', '13.10', '0.00', 'Cash', NULL, '27', '1470552213', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1732, '101670', 'T6', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 09:43:28', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1731, '101669', 'T8', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 09:25:30', 'Paid', NULL, '169.00', '169.00', '169.00', NULL, '169.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1730, '101668', 'T6', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 09:22:58', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1729, '101667', 'T7', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 09:22:20', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1728, '101666', 'T7', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 09:21:44', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1727, '101665', 'T13', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 09:21:10', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1726, '101664', 'T13', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 09:20:07', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1725, '101663', 'T13', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 09:19:29', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1724, '101662', 'T13', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 09:18:49', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1723, '101661', 'T13', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 09:18:03', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1722, '101660', 'T14', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 09:17:31', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1787, '101725', 'T6', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 18:00:38', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1788, '101726', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 18:16:43', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1789, '101730', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 19:57:19', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '52.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1790, '101727', 'T14', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 19:38:13', 'Paid', NULL, '106.00', '106.00', '106.00', NULL, '106.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1791, '101728', 'T2', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 19:49:55', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1792, '101729', 'T2', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 19:51:08', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1793, '101731', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 20:22:18', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '40.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1794, '101732', 'T6', 10010, 'sanni', NULL, NULL, 'history', '2016-08-07 20:28:48', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470552213', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1841, '101777', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 21:14:23', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1822, '101758', 'T14', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 14:19:59', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1823, '101760', 'T14', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 14:35:33', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1824, '101759', 'IS', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 14:35:08', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '50.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1825, '101761', 'IS', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 14:46:57', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1826, '101762', 'IS', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 14:55:23', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1828, '101765', 'IS', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 15:49:53', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1829, '101766', 'T2', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 16:09:50', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1830, '101767', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 16:14:05', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '20.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1831, '101768', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 16:16:39', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1832, '101769', 'T10', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 16:50:09', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1833, '101770', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 16:56:14', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1834, '101771', 'T13', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 17:11:56', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1835, '101774', 'T9', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 17:34:54', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1836, '101772', 'T8', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 17:31:16', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1837, '101773', 'T7', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 17:34:24', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1838, '101775', 'T14', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 18:20:12', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1839, '101778', 'T14', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 21:43:59', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '100.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1840, '101776', 'T2', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 20:07:14', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1815, '101752', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 14:05:27', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1827, '101764', 'IS', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 15:29:26', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1817, '101754', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 14:13:49', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1818, '101755', 'IS', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 14:14:23', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '52.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1819, '101756', 'T14', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 14:17:48', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1820, '101763', 'T6', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 15:04:49', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1821, '101757', 'T14', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 14:19:01', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1814, '101751', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 13:47:56', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1813, '101750', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-08 13:43:43', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1812, '101749', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-08 13:41:07', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1811, '101748', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-08 13:40:14', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '50.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1810, '101753', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-08 14:10:23', 'Paid', NULL, '124.00', '124.00', '124.00', NULL, '124.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1809, '101747', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-08 13:13:55', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '80.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1808, '101745', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-08 12:24:10', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '53.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1807, '101744', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-08 11:23:52', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1806, '101746', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-08 12:43:25', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1805, '101743', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-08 11:00:25', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '20.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1803, '101741', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-08 10:05:52', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1804, '101742', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-08 10:29:39', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(1802, '101740', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-08 09:36:28', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1801, '101738', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-08 09:15:54', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1800, '101739', 'T9', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 09:16:35', 'Paid', NULL, '92.00', '92.00', '92.00', NULL, '100.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1799, '101737', 'T2', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 09:08:00', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1798, '101736', 'T2', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 09:07:02', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1797, '101735', 'T2', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 09:06:33', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1796, '101734', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 09:05:44', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1795, '101733', 'T8', 10010, 'sanni', NULL, NULL, 'history', '2016-08-08 09:04:53', 'Paid', NULL, '165.00', '165.00', '165.00', NULL, '165.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470663773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1861, '101797', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-09 15:05:58', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470718649', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1862, '101798', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-08-09 15:10:20', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470718649', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1860, '101799', 'T15', 10010, 'sanni', NULL, NULL, 'history', '2016-08-09 16:50:35', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470718649', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1859, '101796', 'T14', 10010, 'sanni', NULL, NULL, 'history', '2016-08-09 15:03:15', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470718649', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1858, '101794', 'T2', 10010, 'sanni', NULL, NULL, 'history', '2016-08-09 14:09:47', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470718649', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1857, '101795', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-09 14:18:45', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470718649', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1854, '101790', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-09 13:23:26', 'Paid', NULL, '101.00', '90.90', '90.90', NULL, '100.00', '9.10', '0.00', '0.00', '10.10', '0.00', 'Cash', NULL, '27', '1470718649', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1855, '101792', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-08-09 13:48:20', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470718649', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1856, '101791', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-09 13:29:16', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '100.00', '75.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470718649', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1853, '101789', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-09 12:27:14', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470718649', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1852, '101787', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-09 12:25:59', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470718649', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1850, '101788', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-09 12:26:17', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470718649', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1851, '101786', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-09 12:25:33', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470718649', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1847, '101784', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-09 11:59:36', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470718649', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1849, '101793', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-09 13:50:52', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '60.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470718649', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1848, '101785', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-09 12:12:27', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470718649', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1846, '101782', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-09 11:30:32', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470718649', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1845, '101783', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-09 11:30:52', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470718649', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1844, '101781', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-09 11:29:53', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470718649', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1843, '101780', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-09 10:07:31', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '50.00', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470718649', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1842, '101779', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-09 09:37:36', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470718649', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1882, '101819', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 19:25:55', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1883, '101821', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 19:58:27', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '45.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1884, '101820', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 19:53:51', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1887, '101825', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 21:15:13', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1886, '101822', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 20:08:17', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1888, '101823', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 21:10:57', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '52.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1889, '101824', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 21:13:43', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '20.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1881, '101818', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 19:22:02', 'Paid', NULL, '107.00', '96.30', '96.30', NULL, '100.00', '3.70', '0.00', '0.00', '10.70', '0.00', 'Cash', NULL, '27', '1470876895', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1880, '101817', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 18:55:26', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1870, '101807', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 13:24:49', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1871, '101808', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 13:27:36', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '25.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1872, '101809', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 13:33:13', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1873, '101811', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 14:37:33', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '100.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1874, '101810', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 14:19:22', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1875, '101816', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 16:51:38', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1876, '101812', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 16:21:18', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1877, '101813', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 16:22:40', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1878, '101814', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 16:28:10', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1879, '101815', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 16:28:44', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1868, '101805', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 11:10:18', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '51.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1869, '101806', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 13:18:13', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1867, '101803', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 10:22:54', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1866, '101802', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 09:50:31', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '20.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1865, '101801', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 09:41:24', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '40.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1864, '101800', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 09:14:46', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '25.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1863, '101804', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-11 10:45:45', 'Paid', NULL, '86.00', '86.00', '86.00', NULL, '100.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1470876895', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1918, '101850', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-08-12 20:31:23', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '20.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1919, '101852', 'T15', 10010, 'sanni', NULL, NULL, 'history', '2016-08-12 21:11:46', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '52.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1920, '101854', 'T14', 10010, 'sanni', NULL, NULL, 'history', '2016-08-12 21:19:01', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '60.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1921, '101855', 'IS', 10010, 'sanni', NULL, NULL, 'history', '2016-08-12 21:19:37', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1917, '101851', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-08-12 20:46:10', 'Paid', NULL, '81.00', '81.00', '81.00', NULL, '81.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1916, '101857', 'T2', 10010, 'sanni', NULL, NULL, 'history', '2016-08-12 22:00:49', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1909, '101846', 'T13', 10010, 'sanni', NULL, NULL, 'history', '2016-08-12 15:55:08', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1910, '101845', 'T1', 10010, 'sanni', NULL, NULL, 'history', '2016-08-12 15:50:18', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '50.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1911, '101847', 'T5', 10010, 'sanni', NULL, NULL, 'history', '2016-08-12 17:50:18', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1912, '101856', 'T13', 10010, 'sanni', NULL, NULL, 'history', '2016-08-12 21:21:08', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '30.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1913, '101848', 'T10', 10010, 'sanni', NULL, NULL, 'history', '2016-08-12 18:55:27', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '100.00', '72.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1914, '101853', 'T12', 10010, 'sanni', NULL, NULL, 'history', '2016-08-12 21:16:08', 'Paid', NULL, '164.00', '164.00', '164.00', NULL, '200.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1915, '101849', 'T6', 10010, 'sanni', NULL, NULL, 'history', '2016-08-12 19:47:31', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1908, '101844', 'T7', 10010, 'sanni', NULL, NULL, 'history', '2016-08-12 14:02:15', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1895, '101830', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-12 11:47:53', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1896, '101831', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-12 11:49:24', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1897, '101832', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-12 12:08:51', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1898, '101833', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-12 12:31:02', 'Paid', NULL, '71.00', '71.00', '71.00', NULL, '71.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1899, '101834', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-12 12:40:45', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1900, '101835', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-12 12:42:12', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1901, '101836', 'T12', 10010, 'sanni', NULL, NULL, 'history', '2016-08-12 12:42:38', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1902, '101838', 'T12', 10010, 'sanni', NULL, NULL, 'history', '2016-08-12 12:59:09', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1903, '101839', 'T12', 10010, 'sanni', NULL, NULL, 'history', '2016-08-12 13:00:05', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1904, '101840', 'T12', 10010, 'sanni', NULL, NULL, 'history', '2016-08-12 13:02:49', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1906, '101842', 'T5', 10010, 'sanni', NULL, NULL, 'history', '2016-08-12 13:21:35', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '40.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1907, '101843', 'IS', 10010, 'sanni', NULL, NULL, 'history', '2016-08-12 13:34:53', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1905, '101841', 'T7', 10010, 'sanni', NULL, NULL, 'history', '2016-08-12 13:09:14', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1894, '101829', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-12 11:47:27', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1893, '101828', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-12 11:46:29', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1892, '101827', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-12 11:42:45', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1891, '101837', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-12 12:42:52', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1890, '101826', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-12 10:40:48', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471008056', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1952, '101886', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 16:43:30', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1953, '101887', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 16:48:10', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1954, '101888', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 17:49:57', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '30.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1955, '101889', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 18:17:52', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1956, '101890', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 18:18:25', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1957, '101891', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 18:19:19', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1958, '101892', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 18:31:34', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1959, '101896', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 20:37:32', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1960, '101893', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 19:15:59', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1961, '101894', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 19:40:55', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1962, '101895', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 20:09:49', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1963, '101897', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 21:11:26', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1951, '101885', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 16:42:41', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1950, '101884', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 16:15:03', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '23.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1944, '101881', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 15:35:20', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1943, '101877', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 13:25:47', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1945, '101878', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 14:45:38', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1946, '101883', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 16:05:08', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1947, '101879', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 14:50:48', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1948, '101880', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 15:05:44', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1949, '101882', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 16:00:45', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1931, '101865', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 11:08:56', 'Paid', NULL, '98.00', '98.00', '0.00', '98.00', '98.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '1.10', 'VISA', '1.12', NULL, '0.07', '96.84', 0, NULL, NULL, NULL, NULL, '0'),
(1932, '101866', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 11:38:30', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1933, '101867', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 11:39:34', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1934, '101868', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 11:40:19', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1935, '101869', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 11:44:59', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1936, '101871', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 12:01:25', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '55.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1937, '101872', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 12:15:06', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '51.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1938, '101873', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 12:34:49', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1939, '101874', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 12:54:21', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1940, '101875', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 12:57:12', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1941, '101876', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 13:24:59', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1928, '101862', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 10:43:47', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1929, '101863', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 10:44:06', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1930, '101864', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 11:05:39', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '70.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1927, '101861', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 10:41:56', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1926, '101870', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 11:53:59', 'Paid', NULL, '93.00', '93.00', '93.00', NULL, '100.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1925, '101860', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 10:18:21', 'Paid', NULL, '95.00', '95.00', '95.00', NULL, '95.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1924, '101859', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 09:31:51', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1923, '101858', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-13 09:25:40', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471064222', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2009, '101943', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 18:40:20', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1991, '101923', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 13:18:35', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1992, '101925', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 13:27:56', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1993, '101926', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 13:49:49', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1994, '101928', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 14:08:16', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '102.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1995, '101929', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 14:17:11', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1996, '101930', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 14:37:43', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1997, '101935', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 16:25:43', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1998, '101931', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 14:49:27', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '30.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1999, '101932', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 15:48:42', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2000, '101933', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 15:49:38', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2001, '101934', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 16:20:25', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2002, '101936', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 16:40:38', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '50.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2003, '101942', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 18:09:49', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '100.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2004, '101937', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 16:57:09', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2005, '101938', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 17:17:12', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2006, '101939', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 17:19:12', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2007, '101941', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 17:35:34', 'Paid', NULL, '2.00', '2.00', '2.00', NULL, '2.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2008, '101940', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 17:22:36', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1990, '101922', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 13:15:38', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(1983, '101916', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 11:18:14', 'Paid', NULL, '104.00', '104.00', '104.00', NULL, '104.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1989, '101927', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 13:55:39', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1988, '101921', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 12:25:58', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1987, '101924', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 13:25:18', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '100.00', '39.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1986, '101920', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 12:09:39', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1985, '101919', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 11:39:45', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '67.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1984, '101917', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 11:26:04', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1969, '101903', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 09:33:10', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1970, '101904', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 09:39:32', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1971, '101905', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 09:40:58', 'Paid', NULL, '1.00', '1.00', '1.00', NULL, '1.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1972, '101906', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 09:44:16', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(1973, '101907', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 09:46:21', 'Paid', NULL, '92.00', '92.00', '92.00', NULL, '102.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1974, '101908', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 10:35:42', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1975, '101909', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 10:38:57', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '100.00', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1976, '101910', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 10:40:23', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1977, '101911', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 10:41:20', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1978, '101912', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 10:42:36', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1979, '101913', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 10:43:15', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1980, '101914', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 10:46:49', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1981, '101915', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 10:56:49', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '100.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1982, '101918', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 11:31:14', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1968, '101902', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 09:32:17', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1967, '101901', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 09:31:17', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '60.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1966, '101900', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 09:26:03', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '100.00', '86.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1965, '101899', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 09:24:44', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(1964, '101898', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-14 09:16:31', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471166545', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2054, '101988', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 20:58:58', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2055, '101989', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 21:41:40', 'Paid', NULL, '134.00', '120.60', '120.60', NULL, '121.00', '0.40', '0.00', '0.00', '13.40', '0.00', 'Cash', NULL, '27', '1471248880', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2056, '101990', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 21:46:02', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '52.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2033, '101967', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 15:21:24', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2034, '101968', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 15:30:16', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2035, '101969', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 15:49:05', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2036, '101970', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 16:05:46', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2037, '101971', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 16:07:29', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '20.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2038, '101972', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 16:14:57', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '105.00', '61.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2039, '101973', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 16:15:59', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2040, '101974', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 16:16:29', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '21.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2041, '101975', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 16:23:20', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2042, '101980', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 17:35:00', 'Paid', NULL, '100.00', '100.00', '100.00', NULL, '100.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2043, '101976', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 17:01:10', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2044, '101977', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 17:04:56', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '20.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2045, '101978', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 17:05:34', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2046, '101979', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 17:06:00', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2047, '101981', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 17:53:05', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2048, '101982', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 18:17:28', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2049, '101983', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 18:18:21', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2050, '101984', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 18:52:12', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2051, '101985', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 19:39:42', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '100.00', '49.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2052, '101987', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 19:49:01', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2053, '101986', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 19:43:49', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2032, '101966', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 15:13:06', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '36.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2031, '101965', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 14:53:17', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2030, '101964', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 14:42:47', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2029, '101962', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 14:28:21', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(2028, '101963', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 14:38:17', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '40.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2027, '101960', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 13:21:52', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2026, '101959', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 12:38:18', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2025, '101958', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 12:34:09', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2024, '101957', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 12:27:22', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2023, '101961', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 14:14:57', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2022, '101955', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 12:06:33', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '101.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2021, '101954', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 11:50:25', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '25.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2020, '101956', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 12:07:35', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2019, '101953', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 11:23:56', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2018, '101952', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 11:07:55', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2017, '101951', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 11:03:51', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2016, '101950', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 11:01:56', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2015, '101948', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 10:28:00', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '100.00', '47.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2014, '101949', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 10:54:45', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '38.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2013, '101949', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 11:00:33', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2012, '101946', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 10:14:30', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '102.00', '90.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2011, '101945', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 10:07:12', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2010, '101944', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-15 09:06:01', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '100.00', '60.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471248880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2080, '102014', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 17:45:48', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2081, '102012', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 17:22:12', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2082, '102015', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 18:02:33', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2083, '102016', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 19:39:08', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2084, '102017', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 19:44:48', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2079, '102013', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 17:33:31', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2077, '102010', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 15:23:44', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2078, '102011', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 16:22:53', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '30.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2076, '102009', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 14:28:57', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2075, '102008', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 14:27:25', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2074, '102007', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 13:55:49', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2073, '102005', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 13:24:55', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2072, '102004', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 13:14:46', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2071, '102003', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 13:09:43', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2070, '102006', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 13:29:09', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2069, '102002', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 13:05:25', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2068, '102001', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 12:49:51', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '20.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2067, '102000', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 12:49:01', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '101.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2066, '101999', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 12:04:27', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '65.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2065, '101998', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 11:53:52', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2064, '101997', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 11:53:21', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2063, '101996', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 11:52:33', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2062, '101995', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 11:50:07', 'Paid', NULL, '117.00', '117.00', '117.00', NULL, '150.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2061, '101993', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 10:20:14', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2060, '101994', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 10:39:45', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '20.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2058, '101992', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 09:21:47', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '50.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2057, '101991', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-08-16 09:18:16', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471324027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2099, '102031', 'T13', 10011, 'Staff', NULL, NULL, 'history', '2016-08-18 19:54:55', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '51.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471483771', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2098, '102032', 'T14', 10011, 'Staff', NULL, NULL, 'history', '2016-08-18 21:45:53', 'Paid', NULL, '95.00', '95.00', '95.00', NULL, '100.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471483771', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2097, '102030', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-08-18 18:11:03', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471483771', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2096, '102029', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-08-18 17:08:45', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '15.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471483771', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2095, '102028', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-08-18 15:31:55', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471483771', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2094, '102026', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-08-18 14:38:26', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '40.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471483771', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2093, '102027', 'T14', 10011, 'Staff', NULL, NULL, 'history', '2016-08-18 15:08:03', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471483771', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2092, '102023', 'T10', 10011, 'Staff', NULL, NULL, 'history', '2016-08-18 13:48:16', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471483771', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2091, '102022', 'T3', 10011, 'Staff', NULL, NULL, 'history', '2016-08-18 13:29:02', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471483771', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2090, '102025', 'T15', 10011, 'Staff', NULL, NULL, 'history', '2016-08-18 14:11:42', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471483771', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2089, '102024', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-08-18 14:11:16', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471483771', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2088, '102021', 'T9', 10011, 'Staff', NULL, NULL, 'history', '2016-08-18 12:55:14', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471483771', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2086, '102018', 'T2', 10011, 'Staff', NULL, NULL, 'history', '2016-08-18 10:55:03', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471483771', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2087, '102019', 'T1', 10011, 'Staff', NULL, NULL, 'history', '2016-08-18 11:08:38', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471483771', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2085, '102020', 'T4', 10011, 'Staff', NULL, NULL, 'history', '2016-08-18 11:11:12', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471483771', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2122, '102054', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 18:22:09', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2123, '102056', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 18:44:40', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '100.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2124, '102057', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 19:19:54', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2125, '102060', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 21:15:52', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '50.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2127, '102059', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 20:38:03', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2128, '102058', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 20:17:58', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '100.00', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2129, '102061', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 21:18:12', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2130, '102064', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 22:32:00', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '35.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2131, '102063', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 22:31:39', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2132, '102062', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 22:11:52', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '50.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2119, '102052', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 17:15:49', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2121, '102055', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 18:27:25', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '39.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2120, '102053', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 17:18:00', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2118, '102051', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 15:47:17', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2117, '102050', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 15:21:24', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '53.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2116, '102049', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 15:10:32', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2115, '102046', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 14:54:52', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '50.00', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2114, '102045', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 14:41:54', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2113, '102047', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 15:02:20', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '52.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2112, '102044', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 13:34:50', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2111, '102043', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 12:54:58', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2110, '102048', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 15:03:03', 'Paid', NULL, '42.00', '37.80', '37.80', NULL, '40.00', '2.20', '0.00', '0.00', '4.20', '0.00', 'Cash', NULL, '27', '1471612406', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2109, '102042', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 12:42:46', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2107, '102039', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 12:30:20', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2108, '102040', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 12:31:42', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2106, '102038', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 12:27:57', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2105, '102041', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 12:37:07', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2104, '102037', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 12:16:54', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2103, '102036', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 12:06:00', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2102, '102035', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 12:05:10', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2101, '102034', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 11:29:27', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '57.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2100, '102033', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-19 10:42:14', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '100.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471612406', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(2156, '102083', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 14:09:50', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2157, '102084', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 14:15:06', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2158, '102085', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 14:16:26', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '20.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2159, '102087', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 15:39:46', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2160, '102091', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 19:32:01', 'Paid', NULL, '72.00', '72.00', '72.00', NULL, '72.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2161, '102089', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 17:09:23', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2162, '102090', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 18:27:56', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2163, '102092', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 20:16:43', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2164, '102093', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 21:22:36', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2155, '102082', '5', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 14:09:28', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2154, '102081', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 13:40:09', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2153, '102086', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 14:18:25', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2152, '102080', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 13:06:16', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2151, '102077', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 13:00:06', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2150, '102076', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 12:56:55', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '20.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2149, '102075', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 12:55:24', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2147, '102079', '3', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 13:03:33', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2146, '102070', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 12:28:26', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2145, '102078', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 13:01:47', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2148, '102088', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 16:15:30', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2142, '102072', '4', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 12:29:44', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2143, '102073', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 12:41:58', 'Paid', NULL, '91.00', '91.00', '91.00', NULL, '101.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2144, '102074', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 12:46:13', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '60.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2140, '102069', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 12:02:15', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2138, '102068', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 11:34:27', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(2137, '102067', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 11:34:22', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(2139, '102071', '7', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 12:28:55', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2135, '102065', '9', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 10:38:44', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2134, '102066', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-20 10:53:10', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471667429', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2216, '102144', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 20:22:37', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '5.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2217, '102145', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 20:28:30', 'Paid', NULL, '30.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', '3.00', '0.00', 'Cash', NULL, '27', '1471770451', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(2212, '102139', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 17:51:24', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2213, '102140', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 18:08:36', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2214, '102141', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 18:19:09', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2215, '102143', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 19:42:02', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '50.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2209, '102136', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 17:29:57', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2210, '102137', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 17:33:58', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2211, '102138', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 17:48:34', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '51.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2204, '102133', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 16:53:17', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2205, '102146', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 21:06:28', 'Paid', NULL, '35.00', '31.50', '31.50', NULL, '52.00', '20.50', '0.00', '0.00', '3.50', '0.00', 'Cash', NULL, '27', '1471770451', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2206, '102142', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 18:31:34', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2207, '102134', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 17:19:17', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2208, '102135', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 17:20:07', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2179, '102112', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 10:54:03', 'Paid', NULL, '71.00', '71.00', '71.00', NULL, '100.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2180, '102108', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 10:33:43', 'Paid', NULL, '47.00', '42.30', '42.30', NULL, '100.00', '57.70', '0.00', '0.00', '4.70', '0.00', 'Cash', NULL, '27', '1471770451', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2181, '102109', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 10:44:33', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '100.00', '64.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2182, '102110', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 10:45:40', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '55.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2183, '102111', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 10:47:38', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2184, '102113', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 11:14:45', 'Paid', NULL, '77.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2185, '102114', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 11:17:33', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2186, '102124', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 13:48:27', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2187, '102115', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 11:52:09', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2188, '102121', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 13:07:10', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2189, '102116', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 12:18:49', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '57.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2190, '102117', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 12:19:32', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2191, '102118', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 12:26:34', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2192, '102119', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 12:34:28', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2193, '102120', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 12:41:36', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2194, '102122', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 13:17:45', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '105.00', '51.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2195, '102123', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 13:23:05', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2196, '102127', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 15:05:04', 'Paid', NULL, '74.00', '74.00', '74.00', NULL, '74.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2197, '102125', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 14:25:39', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2198, '102126', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 14:26:06', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2199, '102128', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 15:26:50', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2200, '102131', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 16:24:01', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2201, '102132', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 16:42:26', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2202, '102129', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 16:07:46', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2203, '102130', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 16:16:52', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2178, '102107', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 10:26:56', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '70.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2167, '102096', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 09:16:50', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2169, '102098', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 09:27:33', 'Paid', NULL, '133.00', '133.00', '133.00', NULL, '150.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2170, '102104', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 10:19:00', 'Paid', NULL, '126.00', '113.40', '113.40', NULL, '113.40', '0.00', '0.00', '0.00', '12.60', '0.00', 'Cash', NULL, '27', '1471770451', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2171, '102100', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 09:42:45', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '100.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2172, '102101', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 09:45:41', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '50.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2173, '102102', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 09:50:22', 'Paid', NULL, '77.00', '77.00', '77.00', NULL, '80.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2174, '102103', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 09:51:36', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2175, '102104', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 09:53:14', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '100.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2176, '102106', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 10:19:53', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2177, '102105', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 10:19:44', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2168, '102097', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 09:19:46', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2166, '102095', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 09:14:21', 'Paid', NULL, '85.00', '85.00', '85.00', NULL, '100.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2165, '102094', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-21 09:03:44', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471770451', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2233, '102160', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-22 16:11:12', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471856101', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2235, '102165', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-08-22 17:37:02', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471856101', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2236, '102161', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-22 16:26:42', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471856101', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2237, '102162', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-22 16:55:11', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471856101', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2238, '102164', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-22 17:10:26', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471856101', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2239, '102166', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-08-22 21:14:37', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '50.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471856101', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2232, '102159', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-08-22 15:00:57', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '50.00', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471856101', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2221, '102149', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-22 09:29:12', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471856101', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2222, '102150', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-22 10:34:46', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '100.00', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471856101', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2223, '102151', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-22 11:45:07', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471856101', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2224, '102153', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-22 12:28:21', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471856101', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2225, '102152', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-22 12:03:46', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471856101', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2226, '102154', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-22 12:37:02', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471856101', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2227, '102155', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-22 12:39:00', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471856101', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2228, '102156', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-22 12:55:14', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471856101', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2229, '102157', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-22 13:31:20', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471856101', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2230, '102158', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-22 13:47:03', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471856101', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2231, '102163', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-22 17:06:30', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471856101', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2220, '102148', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-22 09:28:45', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471856101', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2219, '102147', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-22 09:06:16', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '50.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471856101', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2254, '102180', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-23 15:44:51', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471914353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2253, '102179', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-23 15:13:24', 'Paid', NULL, '11.00', '9.35', '9.35', NULL, '10.00', '0.65', '0.00', '0.00', '1.65', '0.00', 'Cash', NULL, '27', '1471914353', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2242, '102169', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-23 10:44:16', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471914353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2243, '102170', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-23 11:09:02', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471914353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2244, '102173', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-23 13:12:40', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471914353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2245, '102171', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-23 13:00:15', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471914353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2246, '102172', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-23 13:00:52', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471914353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2247, '102177', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-08-23 14:24:20', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471914353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2248, '102174', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-23 13:21:22', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471914353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2249, '102175', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-23 13:24:10', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471914353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2250, '102176', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-23 14:19:59', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471914353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2251, '102181', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-23 15:57:21', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471914353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2252, '102178', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-23 14:47:11', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '52.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471914353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2240, '102167', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-23 09:06:43', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471914353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2241, '102168', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-08-23 10:34:52', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1471914353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2269, '102194', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-08-25 11:54:15', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2270, '102195', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-25 11:58:40', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '50.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2271, '102197', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-08-25 12:37:21', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2272, '102196', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-25 12:02:10', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2273, '102198', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-25 12:38:07', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2274, '102202', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-25 13:58:22', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2275, '102203', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-08-25 14:24:55', 'Paid', NULL, '79.00', '79.00', '79.00', NULL, '100.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2276, '102200', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-25 13:12:57', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2277, '102201', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-25 13:32:07', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2278, '102204', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-25 14:35:40', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2279, '102205', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-25 14:36:14', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '20.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2281, '102206', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-08-25 16:15:18', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2282, '102207', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-25 17:03:04', 'Paid', NULL, '972.00', '972.00', '972.00', NULL, '972.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2283, '102208', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-25 17:06:36', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2284, '102209', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-25 17:12:22', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2285, '102210', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-25 17:14:47', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2286, '102211', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-25 19:45:52', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2287, '102212', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-25 20:33:03', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2257, '102184', 'IS', 10008, 'lois', NULL, NULL, 'history', '2016-08-25 09:11:29', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2268, '102199', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-25 12:44:11', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2267, '102193', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-25 11:00:20', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2266, '102191', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-25 10:48:17', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '100.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2265, '102192', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-25 10:48:58', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2264, '102190', 'T7', 10008, 'lois', NULL, NULL, 'history', '2016-08-25 10:37:10', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '50.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2263, '102189', 'IS', 10008, 'lois', NULL, NULL, 'history', '2016-08-25 10:19:24', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2262, '102188', 'IS', 10008, 'lois', NULL, NULL, 'history', '2016-08-25 09:33:29', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2260, '102187', 'T4', 10008, 'lois', NULL, NULL, 'history', '2016-08-25 09:24:56', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2259, '102186', 'T4', 10008, 'lois', NULL, NULL, 'history', '2016-08-25 09:24:24', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '100.00', '74.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2258, '102185', 'T7', 10008, 'lois', NULL, NULL, 'history', '2016-08-25 09:16:39', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2256, '102183', 'T4', 10008, 'lois', NULL, NULL, 'history', '2016-08-25 09:02:45', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(2255, '102182', 'T4', 10008, 'lois', NULL, NULL, 'history', '2016-08-25 09:00:01', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472097619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2301, '102225', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 13:05:41', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2302, '102226', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 13:09:51', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2303, '102227', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 13:15:17', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '50.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2304, '102228', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 13:16:38', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '100.00', '46.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2305, '102229', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 13:33:39', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '50.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2306, '102232', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 15:42:59', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2307, '102230', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 14:51:42', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2308, '102231', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 15:23:35', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '51.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2309, '102233', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 15:49:58', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2310, '102234', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 15:50:41', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2311, '102235', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 16:09:29', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2312, '102236', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 16:34:29', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2313, '102237', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 16:42:16', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '20.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2315, '102238', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 18:14:39', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2316, '102239', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 18:29:24', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2317, '102241', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 20:01:30', 'Paid', NULL, '100.00', '100.00', '100.00', NULL, '100.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2318, '102240', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 19:31:25', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2319, '102245', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 21:02:04', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2321, '102242', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 20:10:58', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2322, '102243', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 20:11:32', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2323, '102244', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 20:19:02', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '50.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2300, '102224', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 13:04:28', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2298, '102221', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 12:37:32', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2297, '102220', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 12:34:14', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2295, '102218', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 12:12:37', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2296, '102219', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 12:28:24', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '100.00', '85.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2299, '102223', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 13:01:05', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '50.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2294, '102217', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 12:11:46', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2292, '102216', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 12:11:00', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2290, '102222', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 12:45:08', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '50.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2291, '102215', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 12:08:44', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2289, '102214', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 11:01:14', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2288, '102213', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-26 10:35:42', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '100.00', '81.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472185694', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2369, '102288', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 16:44:45', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2370, '102289', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 16:46:12', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2372, '102290', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 16:47:44', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2373, '102292', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 17:09:47', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2374, '102293', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 17:36:14', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2375, '102294', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 19:54:37', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2376, '102295', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 19:56:33', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2377, '102300', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 21:41:37', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2378, '102299', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 21:18:33', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2379, '102296', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 20:27:12', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2380, '102297', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 20:36:49', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2381, '102298', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 20:41:03', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2368, '102287', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 16:43:45', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '60.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2364, '102284', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 15:57:31', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '52.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2365, '102285', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 16:05:27', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '36.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2366, '102291', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 16:48:08', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2367, '102286', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 16:28:54', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2363, '102283', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 15:52:23', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '100.00', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2362, '102282', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 15:50:03', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2336, '102256', 'IS', 10008, 'lois', NULL, NULL, 'history', '2016-08-27 11:35:46', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2337, '102257', 'IS', 10008, 'lois', NULL, NULL, 'history', '2016-08-27 11:46:38', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2338, '102266', 'T6', 10008, 'lois', NULL, NULL, 'history', '2016-08-27 12:55:12', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '30.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2339, '102259', 'T2', 10008, 'lois', NULL, NULL, 'history', '2016-08-27 12:02:48', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2340, '102258', 'T2(S)', 10008, 'lois', NULL, NULL, 'history', '2016-08-27 12:01:31', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(2341, '102260', 'T2(S)', 10008, 'lois', NULL, NULL, 'history', '2016-08-27 12:03:22', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(2342, '102261', 'T2', 10008, 'lois', NULL, NULL, 'history', '2016-08-27 12:04:15', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2343, '102276', 'T5', 10008, 'lois', NULL, NULL, 'history', '2016-08-27 14:51:24', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2344, '102263', 'T13', 10008, 'lois', NULL, NULL, 'history', '2016-08-27 12:21:42', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '100.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2345, '102265', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 12:29:19', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2347, '102267', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 13:01:54', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2348, '102270', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 13:57:41', 'Paid', NULL, '119.00', '119.00', '119.00', NULL, '119.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2349, '102271', ' T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 14:08:59', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2350, '102268', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 13:49:44', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '55.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2351, '102269', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 13:57:09', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2352, '102272', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 14:14:48', 'Paid', NULL, '118.00', '118.00', '118.00', NULL, '118.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2353, '102273', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 14:21:26', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2354, '102274', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 14:21:52', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2355, '102275', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 14:29:39', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2356, '102277', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 15:03:25', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '100.00', '89.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2357, '102278', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 15:12:10', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '58.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2358, '102279', 'B1', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 15:27:06', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2359, '102281', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 15:48:39', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '25.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2360, '102301', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 21:48:29', 'Paid', NULL, '40.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', '4.00', '0.00', 'Cash', NULL, '27', '1472300810', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2361, '102280', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-27 15:37:59', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2332, '102253', 'T12', 10008, 'lois', NULL, NULL, 'history', '2016-08-27 11:25:04', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '30.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2334, '102255', 'IS', 10008, 'lois', NULL, NULL, 'history', '2016-08-27 11:27:28', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '100.00', '78.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2335, '102264', 'T4', 10008, 'lois', NULL, NULL, 'history', '2016-08-27 12:22:03', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2333, '102254', 'T12', 10008, 'lois', NULL, NULL, 'history', '2016-08-27 11:26:27', 'Paid', NULL, '70.00', '70.00', '70.00', NULL, '100.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2330, '102251', 'T4', 10008, 'lois', NULL, NULL, 'history', '2016-08-27 10:51:09', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2331, '102252', 'T8', 10008, 'lois', NULL, NULL, 'history', '2016-08-27 11:02:55', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '40.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2329, '102250', 'T13', 10008, 'lois', NULL, NULL, 'history', '2016-08-27 10:47:26', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2326, '102247', 'T6', 10008, 'lois', NULL, NULL, 'history', '2016-08-27 10:45:22', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '40.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2328, '102249', 'T13', 10008, 'lois', NULL, NULL, 'history', '2016-08-27 10:47:04', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2327, '102248', 'T4', 10008, 'lois', NULL, NULL, 'history', '2016-08-27 10:46:35', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2325, '102246', 'T4', 10008, 'lois', NULL, NULL, 'history', '2016-08-27 10:31:14', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '20.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472300810', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2324, '102262', 'T7', 10008, 'lois', NULL, NULL, 'history', '2016-08-27 12:05:03', 'Paid', NULL, '48.00', '43.20', '43.20', NULL, '50.00', '6.80', '0.00', '0.00', '4.80', '0.00', 'Cash', NULL, '27', '1472300810', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2453, '102371', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 21:01:58', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2421, '102339', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 13:23:14', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2422, '102340', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 13:31:16', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '50.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2423, '102341', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 13:45:28', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2424, '102342', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 14:22:50', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2425, '102343', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 14:23:39', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2426, '102344', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 14:32:27', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '100.00', '84.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2427, '102345', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 14:39:46', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2428, '102346', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 14:40:38', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2429, '102347', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 14:46:12', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2432, '102360', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 17:58:25', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2431, '102348', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 14:55:24', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '50.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2433, '102356', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 16:47:53', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2434, '102351', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 16:13:21', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2435, '102350', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 16:12:22', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(2436, '102352', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 16:14:51', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2437, '102353', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 16:15:18', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2438, '102354', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 16:26:16', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2439, '102355', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 16:32:42', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2440, '102359', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 17:29:48', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2441, '102357', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 16:49:57', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2442, '102358', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 17:23:42', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2443, '102361', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 17:59:29', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2444, '102368', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 19:21:51', 'Paid', NULL, '227.00', '227.00', '227.00', NULL, '227.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2445, '102362', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 18:16:30', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2446, '102363', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 18:16:59', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2447, '102370', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 20:50:44', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2448, '102364', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 18:32:09', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2449, '102365', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 19:00:49', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2450, '102366', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 19:01:35', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2451, '102369', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 19:54:46', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2452, '102367', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 19:07:55', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2420, '102338', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 13:01:27', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2410, '102329', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 11:47:59', 'Paid', NULL, '96.00', '96.00', '96.00', NULL, '96.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2411, '102330', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 12:05:57', 'Paid', NULL, '158.00', '158.00', '158.00', NULL, '158.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2412, '102331', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 12:30:39', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '100.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2413, '102332', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 12:33:26', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2414, '102349', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 16:07:05', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2415, '102333', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 12:47:54', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2416, '102334', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 12:49:51', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '39.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2417, '102335', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 12:53:10', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '30.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2418, '102336', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 12:56:15', 'Paid', NULL, '90.00', '90.00', '90.00', NULL, '100.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2419, '102337', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 12:59:53', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2392, '102311', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 09:41:10', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2393, '102312', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 09:46:46', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '40.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2394, '102313', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 10:09:35', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2395, '102314', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 10:10:10', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2396, '102315', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 10:12:15', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '100.00', '71.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2397, '102316', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 10:15:21', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2398, '102319', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 10:35:19', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '60.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2399, '102317', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 10:33:17', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2400, '102318', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 10:33:58', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '52.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2401, '102320', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 10:42:28', 'Paid', NULL, '79.00', '79.00', '79.00', NULL, '79.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2402, '102321', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 10:45:14', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2403, '102322', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 10:50:22', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2404, '102323', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 10:54:10', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2405, '102324', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 10:57:41', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(2406, '102325', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 11:04:30', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2407, '102326', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 11:16:03', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '58.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2408, '102327', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 11:29:36', 'Paid', NULL, '72.00', '72.00', '72.00', NULL, '72.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2409, '102328', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 11:42:54', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2390, '102309', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 09:37:15', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(2391, '102310', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 09:38:01', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2388, '102307', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 09:36:09', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(2389, '102308', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 09:36:48', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(2386, '102306', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 09:33:04', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2384, '102304', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 09:20:03', 'Paid', NULL, '85.00', '85.00', '85.00', NULL, '100.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2385, '102305', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 09:30:38', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2383, '102303', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 09:07:28', 'Paid', NULL, '84.00', '84.00', '84.00', NULL, '84.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2382, '102302', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-28 09:04:22', 'Paid', NULL, '72.00', '72.00', '72.00', NULL, '72.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472382011', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2462, '102381', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-29 15:52:15', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '60.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472471094', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2463, '102380', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-29 14:47:00', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '101.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472471094', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2464, '102382', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-29 16:53:12', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '24.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472471094', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2465, '102383', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-29 17:17:02', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472471094', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2466, '102384', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-29 19:05:18', 'Paid', NULL, '22.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', '2.20', '0.00', 'Cash', NULL, '27', '1472471094', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2467, '102385', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-29 22:01:23', 'Paid', NULL, '108.00', '108.00', '108.00', NULL, '108.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472471094', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2461, '102378', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-29 13:12:28', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472471094', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2460, '102377', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-29 12:54:16', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '100.00', '60.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472471094', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2456, '102374', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-29 10:06:54', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472471094', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2457, '102375', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-29 10:55:44', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '54.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472471094', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2458, '102376', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-29 11:08:38', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472471094', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2459, '102379', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-29 13:13:01', 'Paid', NULL, '107.00', '107.00', '107.00', NULL, '107.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472471094', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2455, '102373', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-29 09:53:10', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472471094', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2454, '102372', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-29 09:50:25', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472471094', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2508, '102423', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 19:18:12', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2509, '102425', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 19:18:52', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2510, '102426', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 19:20:29', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2511, '102427', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 20:42:15', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2500, '102415', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 16:06:28', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2497, '102410', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 15:17:36', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2498, '102413', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 15:58:24', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2499, '102414', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 16:05:38', 'Paid', NULL, '98.00', '98.00', '98.00', NULL, '98.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2501, '102417', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 16:37:32', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2502, '102419', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 18:27:25', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '51.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2503, '102428', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 20:58:11', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '20.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2504, '102424', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 19:18:19', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2505, '102420', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 19:14:24', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '37.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2506, '102422', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 19:17:56', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2507, '102421', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 19:16:35', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2476, '102397', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 10:43:14', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2477, '102393', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 10:21:13', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2478, '102394', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 10:21:49', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '51.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2479, '102395', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 10:22:18', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '102.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2480, '102396', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 10:23:17', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2481, '102397', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 10:30:26', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2482, '102400', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 11:56:01', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '100.00', '76.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2483, '102398', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 11:16:01', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2484, '102399', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 11:47:38', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2485, '102401', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 12:06:43', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '50.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2486, '102402', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 12:07:50', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2487, '102412', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 15:42:55', 'Paid', NULL, '72.00', '72.00', '72.00', NULL, '72.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2488, '102405', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 12:54:39', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2489, '102406', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 13:05:31', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2490, '102407', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 13:07:04', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2491, '102408', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 13:45:42', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2493, '102418', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 17:44:52', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '30.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2494, '102416', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 16:15:25', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2495, '102409', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 14:40:36', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2496, '102411', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 15:37:28', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2475, '102391', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 10:19:55', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2470, '102388', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 09:31:31', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2471, '102404', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 12:13:30', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '60.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2472, '102403', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 12:09:33', 'Paid', NULL, '79.00', '79.00', '79.00', NULL, '79.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2473, '102389', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 10:11:46', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2474, '102390', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 10:14:03', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2469, '102386', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 09:27:32', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2468, '102387', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-08-31 09:30:31', 'Paid', NULL, '81.00', '81.00', '81.00', NULL, '100.00', '19.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472642327', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2520, '102437', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-01 11:51:49', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472701175', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2521, '102440', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-01 13:59:24', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472701175', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2522, '102438', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-01 12:35:26', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472701175', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2523, '102439', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-09-01 13:22:20', 'Paid', NULL, '27.00', '24.30', '24.30', NULL, '25.00', '0.70', '0.00', '0.00', '2.70', '0.00', 'Cash', NULL, '27', '1472701175', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2524, '102441', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-01 15:59:16', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472701175', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2525, '102442', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-01 16:22:33', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472701175', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2526, '102443', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-01 16:30:14', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472701175', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2527, '102444', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-01 17:10:19', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '52.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472701175', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2528, '102445', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-01 17:38:57', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472701175', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2514, '102431', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-01 09:51:55', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '20.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472701175', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2515, '102432', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-01 10:01:08', 'Paid', NULL, '83.00', '83.00', '83.00', NULL, '100.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472701175', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2516, '102433', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-01 10:37:44', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472701175', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2517, '102434', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-01 10:43:44', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472701175', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2518, '102435', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-01 11:31:14', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472701175', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2519, '102436', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-01 11:39:45', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472701175', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2513, '102429', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-01 09:21:41', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472701175', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2512, '102430', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-01 09:33:57', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472701175', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2531, '102447', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 09:28:04', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2532, '102448', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 09:44:58', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '50.00', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2533, '102449', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 09:54:29', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '100.00', '52.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2534, '102451', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 10:07:59', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '100.00', '73.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2535, '102452', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 10:12:54', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2536, '102453', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 10:30:53', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '70.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2537, '102454', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 11:19:02', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2538, '102457', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 12:37:58', 'Paid', NULL, '92.00', '92.00', '92.00', NULL, '92.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2539, '102455', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 11:37:52', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2540, '102456', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 12:09:44', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '50.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2541, '102458', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 13:19:37', 'Paid', NULL, '208.00', '187.20', '187.20', NULL, '190.00', '2.80', '0.00', '0.00', '20.80', '0.00', 'Cash', NULL, '27', '1472820082', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2542, '102461', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 13:54:45', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '60.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2543, '102459', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 13:31:28', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2544, '102460', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 13:43:50', 'Paid', NULL, '81.00', '81.00', '81.00', NULL, '81.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2545, '102465', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 16:23:09', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '50.00', '19.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2546, '102464', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 16:04:35', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2547, '102462', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 14:24:21', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2548, '102463', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 15:58:21', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2549, '102467', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 19:53:49', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2550, '102472', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 21:36:10', 'Paid', NULL, '231.00', '207.90', '207.90', NULL, '207.90', '0.00', '0.00', '0.00', '23.10', '0.00', 'Cash', NULL, '27', '1472820082', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2551, '102466', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 17:45:20', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2552, '102468', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 20:34:46', 'Paid', NULL, '100.00', '100.00', '100.00', NULL, '100.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(2553, '102471', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 21:24:26', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '70.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2554, '102469', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 20:57:08', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2555, '102470', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 20:59:13', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2530, '102446', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 09:11:53', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '40.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2529, '102450', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-02 10:06:31', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '59.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472820082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2585, '102507', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 16:14:05', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2583, '102499', 'T5(S)', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 13:59:11', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(2584, '102500', 'T5(S)', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 13:59:23', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(2586, '102501', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 14:42:42', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '50.00', '19.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2587, '102502', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 14:59:01', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2588, '102503', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 15:01:55', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2589, '102504', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 15:27:41', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2590, '102505', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 15:33:04', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2591, '102506', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 15:39:14', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2592, '102508', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 16:20:33', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2593, '102509', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 17:05:55', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2594, '102510', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 17:45:43', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2595, '102511', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 17:48:57', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2596, '102512', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 19:53:52', 'Paid', NULL, '130.00', '130.00', '130.00', NULL, '130.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2597, '102516', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 22:08:18', 'Paid', NULL, '148.00', '133.20', '133.20', NULL, '150.00', '16.80', '0.00', '0.00', '14.80', '0.00', 'Cash', NULL, '27', '1472879469', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2598, '102513', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 20:28:32', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2599, '102517', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 22:25:01', 'Paid', NULL, '128.00', '128.00', '128.00', NULL, '130.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2600, '102515', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 21:48:35', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2601, '102514', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 21:19:56', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(2581, '102498', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 13:36:17', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2580, '102497', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 13:19:10', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2579, '102496', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 13:15:31', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2578, '102495', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 13:14:23', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2577, '102494', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 13:13:48', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2576, '102493', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 13:13:02', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '35.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2575, '102492', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 13:11:18', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2574, '102491', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 13:10:31', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '52.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2573, '102490', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 13:09:09', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2572, '102489', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 13:08:37', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2571, '102488', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 13:08:11', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '40.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2570, '102487', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 12:58:34', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2569, '102486', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 12:47:08', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '58.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2568, '102485', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 12:41:54', 'Paid', NULL, '144.00', '144.00', '144.00', NULL, '150.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(2567, '102483', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 11:45:24', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2566, '102482', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 11:31:02', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2565, '102481', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 11:29:41', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '100.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2564, '102480', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 11:25:58', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2563, '102479', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 11:15:56', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2562, '102484', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 12:21:53', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2561, '102478', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 10:11:29', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2560, '102477', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 09:45:00', 'Paid', NULL, '114.00', '114.00', '114.00', NULL, '114.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2558, '102475', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 09:21:24', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2559, '102476', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 09:26:28', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2557, '102474', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 09:13:08', 'Paid', NULL, '51.00', '45.90', '45.90', NULL, '50.00', '4.10', '0.00', '0.00', '5.10', '0.00', 'Cash', NULL, '27', '1472879469', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2556, '102473', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-03 09:08:15', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472879469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2629, '102543', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 13:35:50', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '100.00', '73.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2630, '102549', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 14:21:20', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2631, '102545', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 13:47:01', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2632, '102546', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 13:48:12', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2633, '102553', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 14:36:29', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2634, '102547', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 14:05:49', 'Paid', NULL, '70.00', '70.00', '70.00', NULL, '70.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2635, '102548', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 14:07:19', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '40.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2636, '102556', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 15:07:02', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2637, '102551', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 14:32:35', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2638, '102552', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 14:35:41', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2639, '102554', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 14:48:55', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2640, '102555', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 14:52:51', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2641, '102557', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 15:11:04', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '30.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2642, '102558', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 15:24:21', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '53.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2643, '102559', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 15:25:35', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2644, '102564', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 16:09:29', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2645, '102563', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 16:03:40', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2646, '102560', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 15:50:03', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '50.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2647, '102561', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 15:50:29', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '15.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2648, '102562', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 15:55:32', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2649, '102565', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 17:51:02', 'Paid', NULL, '71.00', '71.00', '71.00', NULL, '71.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2650, '102566', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 18:12:18', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2651, '102567', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 18:24:44', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2652, '102568', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 19:34:07', 'Paid', NULL, '103.00', '103.00', '103.00', NULL, '103.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2653, '102569', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 19:47:08', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2628, '102542', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 13:31:06', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2627, '102541', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 13:06:49', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2626, '102550', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 14:30:19', 'Paid', NULL, '190.00', '190.00', '190.00', NULL, '190.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2625, '102544', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 13:42:57', 'Paid', NULL, '114.00', '114.00', '114.00', NULL, '114.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2623, '102538', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 12:16:23', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2624, '102540', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 12:39:37', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2622, '102537', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 12:08:55', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2621, '102536', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 12:01:39', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '100.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2620, '102539', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 12:29:15', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '38.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2619, '102535', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 11:47:57', 'Paid', NULL, '176.00', '176.00', '176.00', NULL, '200.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2618, '102534', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 11:42:46', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '50.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2617, '102533', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 11:39:58', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '20.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2609, '102524', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 10:34:41', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2610, '102526', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 11:19:31', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '59.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2611, '102527', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 11:21:44', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2612, '102528', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 11:22:08', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2613, '102529', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 11:27:19', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2615, '102531', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 11:39:19', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2616, '102532', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 11:39:44', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2614, '102530', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 11:35:24', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2608, '102523', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-04 10:33:32', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2607, '102521', 'T12', 10010, 'sanni', NULL, NULL, 'history', '2016-09-04 10:25:52', 'Paid', NULL, '145.00', '145.00', '145.00', NULL, '150.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2606, '102525', 'T13', 10010, 'sanni', NULL, NULL, 'history', '2016-09-04 10:51:28', 'Paid', NULL, '77.00', '77.00', '77.00', NULL, '80.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2603, '102519', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-09-04 09:17:15', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2604, '102520', 'T6', 10010, 'sanni', NULL, NULL, 'history', '2016-09-04 09:29:43', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '100.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2605, '102522', 'T2', 10010, 'sanni', NULL, NULL, 'history', '2016-09-04 10:27:00', 'Paid', NULL, '109.00', '109.00', '109.00', NULL, '109.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2602, '102518', 'T7', 10010, 'sanni', NULL, NULL, 'history', '2016-09-04 09:11:40', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1472989530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2682, '102596', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 20:29:24', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '51.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2683, '102598', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 21:19:20', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2684, '102599', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 21:53:48', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2685, '102600', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 22:07:11', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '20.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2681, '102594', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 19:48:52', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2680, '102597', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 21:10:22', 'Paid', NULL, '116.00', '116.00', '116.00', NULL, '116.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2678, '102591', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 18:05:19', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '70.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2679, '102593', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 19:03:24', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2677, '102592', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 19:00:54', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2676, '102590', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 17:05:52', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '20.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2675, '102595', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 20:21:25', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2674, '102588', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 15:19:54', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2673, '102587', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 15:17:08', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2671, '102586', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 15:00:22', 'Paid', NULL, '13.00', '11.70', '11.70', NULL, '11.70', '0.00', '0.00', '0.00', '1.30', '0.00', 'Cash', NULL, '27', '1473057839', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2670, '102585', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 14:59:21', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2669, '102584', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 14:44:12', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2661, '102577', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 12:28:32', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '105.00', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2662, '102578', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 12:58:03', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2663, '102581', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 13:58:27', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2664, '102579', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 13:34:06', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2665, '102589', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 15:38:32', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2666, '102580', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 13:56:08', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2667, '102582', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 14:03:14', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2668, '102583', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 14:24:45', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2660, '102576', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 12:23:25', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2659, '102575', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 12:01:29', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2655, '102571', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 10:49:48', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2657, '102573', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 11:50:01', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2658, '102574', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 12:00:14', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2656, '102572', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 11:09:17', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2654, '102570', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-05 10:33:50', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473057839', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2709, '102623', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 20:30:00', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2708, '102624', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 21:04:04', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2707, '102622', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 19:59:23', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2706, '102621', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 19:59:02', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2705, '102620', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 19:05:06', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2704, '102619', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 18:59:16', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '50.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2703, '102617', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 18:37:02', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2702, '102618', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 18:45:01', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2701, '102615', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 17:02:31', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2693, '102607', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 12:54:17', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2694, '102608', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 12:58:06', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '100.00', '53.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2695, '102609', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 13:39:51', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2696, '102613', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 14:38:15', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2697, '102611', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 14:08:32', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2698, '102614', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 14:51:13', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2699, '102612', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 14:20:38', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2700, '102616', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 17:40:00', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '100.00', '66.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2692, '102606', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 12:35:04', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2690, '102610', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 14:00:29', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2691, '102605', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 11:58:41', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2687, '102602', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 09:38:51', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '25.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2688, '102603', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 10:00:01', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '65.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2689, '102604', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 10:13:06', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2686, '102601', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-07 09:36:04', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473251390', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2737, '102651', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 17:57:45', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2738, '102652', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 17:58:41', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '20.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2739, '102653', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 18:02:45', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '20.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2740, '102654', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 18:17:52', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2735, '102649', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 16:44:07', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2736, '102650', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 17:40:05', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2734, '102648', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 16:36:23', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2733, '102647', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 16:20:37', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2732, '102646', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 15:38:50', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2731, '102645', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 15:24:42', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2730, '102643', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 15:01:28', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2729, '102642', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 14:59:13', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2728, '102641', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 14:53:22', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '20.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2727, '102640', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 14:14:45', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2726, '102638', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 13:37:09', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2717, '102630', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 11:16:05', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2718, '102636', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 13:13:39', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '100.00', '64.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2719, '102632', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 12:33:26', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2720, '102639', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 13:58:51', 'Paid', NULL, '78.00', '78.00', '78.00', NULL, '100.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2721, '102631', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 12:30:23', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2723, '102634', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 12:56:54', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2724, '102637', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 13:24:41', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2725, '102644', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 15:18:43', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2716, '102635', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 12:58:04', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2711, '102626', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 09:17:20', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2712, '102627', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 09:33:20', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '60.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2714, '102629', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 10:04:03', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '51.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2715, '102633', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 12:37:57', 'Paid', NULL, '80.00', '80.00', '80.00', NULL, '100.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(2713, '102628', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 09:49:21', 'Paid', NULL, '83.00', '83.00', '83.00', NULL, '100.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2710, '102625', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-08 09:06:34', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '40.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473319150', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2748, '102662', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-09-09 17:03:50', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '52.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473382685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2749, '102663', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-09 17:35:40', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473382685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2750, '102664', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-09 18:32:07', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473382685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2751, '102665', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-09 18:48:49', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '21.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473382685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2752, '102666', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-09-09 18:57:34', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473382685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2753, '102667', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-09 19:23:04', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473382685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2745, '102658', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-09 13:56:29', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473382685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2746, '102659', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-09 14:23:47', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473382685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2747, '102661', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-09 15:01:17', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473382685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2742, '102656', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-09 10:03:38', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473382685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2743, '102657', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-09 12:57:09', 'Paid', NULL, '82.00', '82.00', '82.00', NULL, '100.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473382685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2744, '102660', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-09 14:57:53', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473382685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2741, '102655', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-09 09:25:28', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473382685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2776, '102690', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 20:42:27', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473478617', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2775, '102688', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 19:09:32', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '50.00', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473478617', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2774, '102689', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 20:06:10', 'Paid', NULL, '89.00', '89.00', '89.00', NULL, '89.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473478617', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2771, '102684', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 15:34:27', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '100.00', '76.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473478617', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2772, '102686', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 16:23:36', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473478617', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2773, '102687', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 16:52:04', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473478617', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2769, '102683', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 15:06:19', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473478617', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2770, '102682', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 15:02:42', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '100.00', '62.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473478617', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2755, '102669', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 09:49:24', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473478617', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2768, '102681', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 14:56:15', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '30.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473478617', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2767, '102685', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 16:22:21', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473478617', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2766, '102680', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 14:32:56', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473478617', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2765, '102677', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 13:51:10', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '20.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473478617', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2762, '102674', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 12:44:46', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473478617', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2763, '102679', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 13:58:33', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473478617', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2764, '102678', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 13:54:17', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '100.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473478617', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2756, '102670', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 10:15:32', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473478617', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2757, '102671', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 10:30:46', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '50.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473478617', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2758, '102672', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 12:00:36', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '50.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473478617', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2759, '102676', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 13:11:56', 'Paid', NULL, '49.00', '44.10', '44.10', NULL, '50.10', '6.00', '0.00', '0.00', '4.90', '0.00', 'Cash', NULL, '27', '1473478617', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2760, '102673', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 12:39:06', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '100.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473478617', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2761, '102675', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 13:09:10', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '50.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473478617', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2754, '102668', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-10 09:20:37', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473478617', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2804, '102715', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 12:42:09', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '100.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2805, '102716', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 12:52:10', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2806, '102719', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 13:32:17', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '100.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2807, '102720', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 13:33:57', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2808, '102721', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 13:40:00', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2809, '102722', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 13:44:14', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2810, '102723', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 14:09:49', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2811, '102736', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 17:19:55', 'Paid', NULL, '72.00', '72.00', '72.00', NULL, '72.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2812, '102724', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 14:26:54', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2813, '102734', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 16:42:50', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2814, '102725', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 14:34:43', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2815, '102726', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 15:10:13', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2816, '102727', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 15:20:55', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2817, '102728', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 15:23:52', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2818, '102729', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 15:25:01', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '51.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2819, '102733', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 16:41:47', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2820, '102731', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 15:44:41', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2821, '102732', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 16:18:27', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2822, '102741', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 20:32:03', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2823, '102735', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 16:45:19', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2824, '102737', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 18:19:32', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '21.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2825, '102738', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 19:28:01', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2826, '102739', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 19:53:08', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '70.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2827, '102740', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 19:58:29', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '55.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2828, '102743', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 20:38:24', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2829, '102745', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 21:05:40', 'Paid', NULL, '159.00', '135.15', '135.15', NULL, '150.00', '14.85', '0.00', '0.00', '23.85', '0.00', 'Cash', NULL, '27', '1473597069', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2830, '102742', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 20:32:33', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2831, '102744', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 20:48:30', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2832, '102746', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 21:17:15', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '20.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2803, '102714', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 12:36:34', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2800, '102712', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 12:27:32', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2801, '102713', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 12:34:43', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2802, '102730', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 15:40:57', 'Paid', NULL, '96.00', '96.00', '96.00', NULL, '100.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2799, '102718', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 13:12:53', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2798, '102711', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 12:23:46', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '70.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2792, '102717', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 13:00:25', 'Paid', NULL, '95.00', '95.00', '95.00', NULL, '95.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2793, '102706', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 11:56:43', 'Paid', NULL, '33.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', '3.30', '0.00', 'Cash', NULL, '27', '1473597069', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2794, '102707', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 12:02:43', 'Paid', NULL, '66.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', '6.60', '0.00', 'Cash', NULL, '27', '1473597069', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2795, '102708', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 12:03:27', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '50.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2796, '102709', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 12:11:51', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2797, '102710', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 12:20:29', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2780, '102701', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 10:54:32', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2781, '102694', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 10:25:23', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2782, '102695', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 10:38:14', 'Paid', NULL, '127.00', '127.00', '127.00', NULL, '150.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2783, '102696', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 10:40:27', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2784, '102697', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 10:41:47', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2785, '102698', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 10:42:38', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2786, '102699', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 10:48:32', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2778, '102692', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 10:17:42', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2779, '102693', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 10:19:22', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2787, '102700', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 10:50:32', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2788, '102705', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 11:54:59', 'Paid', NULL, '124.00', '124.00', '124.00', NULL, '124.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2789, '102702', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 11:05:08', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2790, '102703', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 11:23:57', 'Paid', NULL, '77.00', '77.00', '77.00', NULL, '80.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2791, '102704', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 11:33:42', 'Paid', NULL, '125.00', '125.00', '125.00', NULL, '125.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2777, '102691', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-11 10:13:27', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473597069', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2858, '102773', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 15:11:08', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2859, '102771', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 14:34:44', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2860, '102772', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 14:42:39', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2861, '102774', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 15:18:25', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '40.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2862, '102775', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 15:19:51', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2863, '102776', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 15:48:38', 'Paid', NULL, '83.00', '83.00', '83.00', NULL, '83.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2864, '102777', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 15:51:12', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2865, '102778', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 16:10:47', 'Paid', NULL, '31.00', '27.90', '27.90', NULL, '30.00', '2.10', '0.00', '0.00', '3.10', '0.00', 'Cash', NULL, '27', '1473671172', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2872, '102784', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 19:16:30', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2867, '102779', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 16:23:55', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '100.00', '47.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2868, '102781', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 16:38:59', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2869, '102782', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 17:07:06', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2870, '102783', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 18:33:38', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2871, '102789', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 21:18:09', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2873, '102785', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 19:26:24', 'Paid', NULL, '21.00', '18.90', '18.90', NULL, '20.00', '1.10', '0.00', '0.00', '2.10', '0.00', 'Cash', NULL, '27', '1473671172', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2874, '102786', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 19:53:44', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2875, '102787', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 20:09:31', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2876, '102788', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 20:58:19', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2855, '102768', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 13:50:43', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2856, '102769', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 14:21:19', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2857, '102780', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 16:37:18', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2853, '102765', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 13:33:28', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '50.00', '39.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2854, '102766', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 13:38:08', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '64.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2835, '102749', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 10:02:12', 'Paid', NULL, '81.00', '72.90', '72.90', NULL, '103.00', '30.10', '0.00', '0.00', '8.10', '0.00', 'Cash', NULL, '27', '1473671172', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2834, '102748', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 09:55:11', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2852, '102764', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 13:25:59', 'Paid', NULL, '4.00', '4.00', '4.00', NULL, '4.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2851, '102763', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 13:17:26', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2850, '102762', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 13:00:12', 'Paid', NULL, '83.00', '83.00', '83.00', NULL, '100.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2849, '102761', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 12:52:46', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2848, '102759', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 12:44:04', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '51.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2847, '102767', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 13:44:20', 'Paid', NULL, '82.00', '82.00', '82.00', NULL, '82.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2846, '102770', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 14:32:31', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2845, '102760', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 12:51:22', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2844, '102758', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 12:34:06', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2843, '102755', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 11:37:31', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '70.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2842, '102754', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 11:00:25', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2840, '102757', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 11:48:55', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2841, '102756', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 11:41:27', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2839, '102753', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 10:29:07', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2838, '102752', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 10:22:40', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2837, '102751', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 10:14:02', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2836, '102750', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 10:03:30', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '20.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2833, '102747', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-12 09:54:40', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473671172', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2890, '102803', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-14 16:55:18', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '101.00', '90.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473829127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2891, '102804', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-14 17:10:41', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '20.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473829127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2892, '102808', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-14 21:51:05', 'Paid', NULL, '82.00', '82.00', '82.00', NULL, '102.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473829127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2893, '102805', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-14 18:46:53', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473829127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2894, '102806', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-09-14 20:11:38', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473829127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2895, '102807', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-14 20:54:51', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473829127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2896, '102809', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-14 21:51:24', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473829127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2889, '102802', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-14 16:14:36', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473829127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2888, '102801', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-14 16:08:39', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '55.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473829127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2886, '102798', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-14 14:56:09', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473829127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(2887, '102800', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-14 15:39:35', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473829127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2885, '102799', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-14 15:12:28', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473829127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2883, '102794', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-14 13:01:26', 'Paid', NULL, '94.00', '94.00', '94.00', NULL, '94.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473829127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2884, '102797', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-14 13:58:02', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473829127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2882, '102796', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-14 13:18:46', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '100.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473829127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2881, '102793', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-14 12:02:01', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473829127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2878, '102790', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-14 10:03:27', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '102.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473829127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2879, '102792', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-14 11:14:04', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '100.00', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473829127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2880, '102791', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-14 10:48:04', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473829127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2877, '102795', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-14 13:09:17', 'Paid', NULL, '100.00', '100.00', '100.00', NULL, '100.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473829127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2911, '102822', 'T5', 10010, 'sanni', NULL, NULL, 'history', '2016-09-15 19:13:22', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473919465', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2912, '102824', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-09-15 20:00:05', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '100.00', '82.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473919465', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2913, '102825', 'T7', 10010, 'sanni', NULL, NULL, 'history', '2016-09-15 20:03:47', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473919465', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2914, '102826', 'T7', 10010, 'sanni', NULL, NULL, 'history', '2016-09-15 20:34:41', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473919465', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2915, '102827', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-09-15 21:25:27', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473919465', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2909, '102821', 'IS', 10010, 'sanni', NULL, NULL, 'history', '2016-09-15 17:44:46', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473919465', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2908, '102820', 'IS', 10010, 'sanni', NULL, NULL, 'history', '2016-09-15 16:40:40', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '20.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473919465', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2910, '102823', 'T2', 10010, 'sanni', NULL, NULL, 'history', '2016-09-15 19:38:21', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473919465', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2906, '102819', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-09-15 15:05:54', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '30.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473919465', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2907, '102818', 'IS', 10010, 'sanni', NULL, NULL, 'history', '2016-09-15 14:50:22', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '51.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473919465', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2903, '102816', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-15 13:50:50', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '70.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473919465', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2904, '102817', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-15 14:05:11', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '39.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473919465', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2902, '102814', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-15 13:24:27', 'Paid', NULL, '122.00', '122.00', '122.00', NULL, '200.00', '78.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473919465', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2898, '102811', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-15 10:30:36', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473919465', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2900, '102812', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-15 11:31:56', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473919465', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2901, '102813', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-15 12:49:03', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '25.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473919465', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2899, '102815', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-15 13:46:31', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473919465', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2897, '102810', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-15 10:07:19', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '60.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1473919465', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2928, '102840', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 12:52:39', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2929, '102841', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 12:54:08', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2930, '102845', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 14:02:22', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2931, '102846', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 14:25:46', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2932, '102842', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 13:57:45', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2933, '102843', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 13:58:04', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2934, '102844', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 13:58:38', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2935, '102847', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 14:35:23', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2936, '102848', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 14:36:57', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2937, '102849', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 14:41:05', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2938, '102850', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 14:42:14', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2939, '102853', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 16:07:21', 'Paid', NULL, '126.00', '126.00', '126.00', NULL, '150.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2940, '102851', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 15:23:21', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2941, '102852', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 15:39:54', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2942, '102855', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 16:28:13', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '20.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2943, '102854', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 16:19:13', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '100.00', '66.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2944, '102857', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 17:02:32', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2945, '102856', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 16:58:22', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2946, '102858', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 17:18:02', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2947, '102859', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 17:18:25', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2948, '102860', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 17:21:01', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2949, '102861', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 17:21:34', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2950, '102862', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 17:22:23', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2951, '102863', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 17:23:16', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2952, '102864', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 17:25:32', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2953, '102865', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 18:50:56', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2954, '102868', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 22:00:08', 'Paid', NULL, '125.00', '125.00', '125.00', NULL, '125.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2955, '102867', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 21:40:23', 'Paid', NULL, '40.50', '40.50', '40.50', NULL, '50.00', '9.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2956, '102866', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 20:33:51', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2957, '102869', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 22:31:18', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '56.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2958, '102870', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 22:32:07', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(2925, '102837', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 12:08:33', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2926, '102838', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 12:16:08', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2924, '102835', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 11:45:10', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2927, '102839', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 12:22:09', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2922, '102836', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 11:56:25', 'Paid', NULL, '74.00', '74.00', '74.00', NULL, '74.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2923, '102834', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 11:42:36', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2920, '102832', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 10:29:39', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2921, '102833', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 10:35:01', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '70.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2917, '102829', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 09:45:34', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2918, '102830', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 10:10:57', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2919, '102831', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 10:22:17', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '100.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2916, '102828', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-16 09:45:23', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474026586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2970, '102894', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 13:28:09', 'Paid', NULL, '85.00', '85.00', '85.00', NULL, '100.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2971, '102881', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 11:44:18', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2972, '102882', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 11:48:18', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2973, '102883', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 11:58:52', 'Paid', NULL, '84.00', '84.00', '84.00', NULL, '100.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2974, '102889', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 12:49:50', 'Paid', NULL, '84.00', '84.00', '84.00', NULL, '100.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2975, '102885', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 12:22:19', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2976, '102884', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 12:21:57', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '60.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2977, '102887', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 12:41:29', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2978, '102887', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 12:37:52', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2979, '102888', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 12:43:02', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2980, '102890', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 12:52:57', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2981, '102891', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 13:00:26', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '100.00', '47.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2982, '102898', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 13:37:12', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2983, '102892', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 13:06:44', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2984, '102893', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 13:12:15', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2985, '102906', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 14:46:22', 'Paid', NULL, '106.00', '106.00', '106.00', NULL, '106.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2986, '102895', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 13:33:22', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2987, '102896', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 13:35:15', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2988, '102897', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 13:35:51', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2989, '102899', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 13:41:18', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '100.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2990, '102904', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 13:57:58', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '59.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2991, '102902', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 13:54:27', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '70.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2992, '102901', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 13:51:10', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2993, '102903', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 13:55:53', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '40.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2994, '102905', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 14:24:34', 'Paid', NULL, '2.00', '2.00', '2.00', NULL, '2.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2995, '102907', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 15:19:23', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2996, '102909', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 17:28:02', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '100.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2997, '102914', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 18:39:59', 'Paid', NULL, '93.00', '93.00', '93.00', NULL, '93.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2998, '102908', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 16:35:45', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2999, '102911', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 17:37:23', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3000, '102910', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 17:32:59', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '50.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3001, '102912', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 17:42:12', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3004, '102913', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 18:13:29', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '52.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3005, '102915', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 19:20:48', 'Paid', NULL, '70.00', '70.00', '70.00', NULL, '70.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3006, '102916', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 19:24:53', 'Paid', NULL, '109.00', '109.00', '109.00', NULL, '150.00', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3007, '102917', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 20:29:30', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2967, '102879', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 10:58:41', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2968, '102880', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 10:59:45', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2969, '102900', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 13:48:08', 'Paid', NULL, '38.00', '34.20', '34.20', NULL, '50.00', '15.80', '0.00', '0.00', '3.80', '0.00', 'Cash', NULL, '27', '1474104733', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2965, '102876', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 10:36:50', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2966, '102878', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 10:48:25', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2960, '102872', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 09:33:34', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2961, '102877', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 10:42:38', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '100.00', '78.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2962, '102873', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 09:38:45', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2963, '102874', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 10:11:22', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '45.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2964, '102875', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 10:12:20', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(2959, '102871', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-17 09:23:54', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474104733', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3050, '102959', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 18:42:20', 'Paid', NULL, '10.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1474176495', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3051, '102960', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 19:28:22', 'Paid', NULL, '20.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', '2.00', '0.00', 'Cash', NULL, '27', '1474176495', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3019, '102929', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 11:49:33', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3020, '102930', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 11:52:07', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3021, '102931', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 11:58:03', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3022, '102935', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 12:33:45', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '51.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3023, '102932', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 12:04:07', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '53.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3024, '102933', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 12:10:39', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '57.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3025, '102934', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 12:26:15', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3026, '102939', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 13:14:23', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '52.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3027, '102936', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 12:49:16', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3028, '102937', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 12:55:28', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3029, '102938', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 13:12:06', 'Paid', NULL, '80.00', '80.00', '80.00', NULL, '100.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3030, '102940', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 13:14:50', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3031, '102942', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 13:28:32', 'Paid', NULL, '120.00', '120.00', '120.00', NULL, '120.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3032, '102941', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 13:26:18', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3033, '102943', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 13:29:10', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3034, '102946', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 14:55:50', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3035, '102944', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 13:46:12', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '60.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3036, '102945', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 14:35:34', 'Paid', NULL, '143.00', '143.00', '143.00', NULL, '143.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3038, '102947', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 15:16:57', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3039, '102948', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 15:31:12', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3040, '102949', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 15:31:42', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3041, '102950', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 15:39:52', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3042, '102951', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 16:01:01', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3043, '102952', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 16:01:27', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3044, '102953', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 16:01:52', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3045, '102954', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 16:18:13', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3046, '102955', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 16:19:55', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(3047, '102956', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 16:34:25', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3048, '102957', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 16:41:22', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3049, '102958', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 17:56:57', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3016, '102925', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 10:52:36', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '20.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3017, '102927', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 11:10:17', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '50.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3018, '102928', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 11:32:10', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3009, '102918', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 09:58:53', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3010, '102919', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 10:10:36', 'Paid', NULL, '78.00', '78.00', '78.00', NULL, '100.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3012, '102921', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 10:27:42', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3013, '102922', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 10:29:56', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3014, '102923', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 10:36:16', 'Paid', NULL, '84.00', '84.00', '84.00', NULL, '100.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3015, '102924', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 10:45:25', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3011, '102920', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 10:26:29', 'Paid', NULL, '92.00', '92.00', '92.00', NULL, '92.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3008, '102926', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-18 10:56:13', 'Paid', NULL, '93.00', '93.00', '93.00', NULL, '100.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474176495', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3063, '102970', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-19 14:28:21', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474246590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3064, '102972', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-19 14:41:53', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474246590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3065, '102971', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-19 14:38:11', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '100.00', '79.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474246590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3058, '102968', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-19 12:50:49', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '100.00', '72.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474246590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3059, '102967', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-19 12:07:18', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474246590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3060, '102974', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-19 18:24:41', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474246590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3061, '102969', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-19 13:10:22', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474246590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3062, '102973', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-19 14:49:21', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '101.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474246590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3053, '102963', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-19 10:56:54', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '100.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474246590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3054, '102962', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-19 10:33:14', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474246590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3055, '102964', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-19 11:30:03', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474246590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3056, '102965', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-19 11:35:52', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '100.00', '78.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474246590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3057, '102966', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-19 12:00:39', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474246590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3052, '102961', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-19 09:49:01', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474246590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3079, '102986', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-21 19:15:47', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474462385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3080, '102987', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-21 19:41:01', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474462385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3081, '102988', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-21 20:00:27', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474462385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3082, '102989', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2016-09-21 20:53:34', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '15.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474462385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(3083, '102990', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2016-09-21 20:53:49', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474462385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(3084, '102991', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2016-09-21 20:54:17', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474462385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(3085, '102992', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2016-09-21 20:56:32', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '30.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474462385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(3067, '102976', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-21 09:24:18', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474462385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3075, '102983', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-21 15:57:44', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474462385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3069, '102977', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-21 11:33:52', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474462385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3070, '102979', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-21 13:54:17', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474462385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3071, '102982', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-21 15:51:07', 'Paid', NULL, '73.00', '73.00', '73.00', NULL, '100.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474462385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3072, '102978', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-09-21 13:53:32', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474462385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3073, '102981', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-21 15:11:18', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474462385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3074, '102980', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-21 14:56:53', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '100.00', '74.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474462385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3076, '102984', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-21 17:03:06', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474462385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3077, '102985', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-21 18:58:12', 'Paid', NULL, '145.00', '145.00', '145.00', NULL, '145.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474462385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3066, '102975', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-21 09:18:55', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474462385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3088, '102997', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 12:06:29', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '100.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3089, '102995', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 11:40:51', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '100.00', '68.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3087, '102994', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 10:24:45', 'Paid', NULL, '94.00', '94.00', '94.00', NULL, '94.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3099, '103006', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 15:15:56', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3100, '103007', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 15:21:52', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3101, '103013', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 17:57:10', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '106.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3102, '103008', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 15:36:57', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3103, '103014', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 18:11:10', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3104, '103009', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 16:37:00', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3105, '103010', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 16:37:43', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3106, '103011', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 17:20:16', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3107, '103012', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 17:28:34', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3108, '103015', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 18:23:56', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3109, '103017', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 20:49:55', 'Paid', NULL, '217.00', '217.00', '217.00', NULL, '217.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3110, '103016', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 20:45:43', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3098, '103003', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 13:57:39', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3097, '103002', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 13:48:34', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3096, '103004', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 14:03:12', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '100.00', '82.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3095, '103001', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 13:35:10', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '100.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3094, '102999', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 13:27:37', 'Paid', NULL, '95.00', '95.00', '95.00', NULL, '100.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3093, '102998', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 12:54:19', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3092, '102996', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 12:03:35', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '64.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3091, '103000', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 13:31:35', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3090, '103005', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 14:14:25', 'Paid', NULL, '161.00', '161.00', '161.00', NULL, '161.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3086, '102993', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-22 09:45:18', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474519858', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3141, '103047', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 21:09:11', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3142, '103046', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 20:29:08', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '100.00', '92.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3143, '103048', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 21:26:32', 'Paid', NULL, '30.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', '3.00', '0.00', 'Cash', NULL, '27', '1474592419', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3122, '103027', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 14:03:05', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3123, '103028', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 14:03:39', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3124, '103029', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 14:05:54', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3125, '103030', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 14:27:12', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3126, '103031', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 14:27:46', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3127, '103032', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 14:28:29', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3128, '103033', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 14:41:53', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3129, '103038', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 15:03:25', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3130, '103034', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 14:52:00', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3131, '103035', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 14:52:48', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3132, '103036', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 14:53:13', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3133, '103042', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 17:18:53', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3134, '103039', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 15:29:38', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3135, '103041', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 15:42:22', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3136, '103040', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 15:41:13', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3137, '103045', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 19:36:39', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3138, '103043', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 19:03:54', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '10.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3139, '103044', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 19:06:36', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3140, '103049', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 21:35:45', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '55.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3121, '103037', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 14:53:44', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3120, '103026', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 13:43:48', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3118, '103025', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 12:16:17', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3119, '103024', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 12:00:31', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '51.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3117, '103022', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 11:08:54', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3115, '103023', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 11:29:24', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3114, '103020', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 10:31:19', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '40.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(3112, '103021', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 10:32:06', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3113, '103019', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 10:30:45', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(3111, '103018', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-23 10:21:32', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '50.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474592419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3187, '103089', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 16:17:02', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3188, '103090', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 16:38:28', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3189, '103092', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 17:49:01', 'Paid', NULL, '9.00', '8.10', '8.10', NULL, '8.10', '0.00', '0.00', '0.00', '0.90', '0.00', 'Cash', NULL, '27', '1474715615', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3190, '103093', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 17:55:17', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3191, '103094', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 18:43:57', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3192, '103095', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 19:11:02', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3193, '103096', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 19:13:53', 'Paid', NULL, '94.00', '94.00', '94.00', NULL, '100.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3194, '103097', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 19:39:33', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3195, '103098', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 20:05:37', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3196, '103100', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 20:46:40', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3197, '103099', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 20:27:19', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '20.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3183, '103085', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 15:21:51', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '58.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3184, '103086', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 15:45:18', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3185, '103091', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 16:49:45', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '100.00', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3186, '103087', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 16:11:42', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '37.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3182, '103084', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 14:49:06', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3175, '103077', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 12:41:35', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3176, '103079', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 12:53:19', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3177, '103088', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 16:16:07', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3180, '103082', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 14:11:33', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3179, '103082', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 13:38:14', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3181, '103083', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 14:22:40', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '50.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3174, '103076', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 12:40:46', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3153, '103058', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 10:25:26', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3154, '103059', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 10:27:09', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3155, '103060', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 10:38:26', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3156, '103061', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 10:44:11', 'Paid', NULL, '80.00', '80.00', '80.00', NULL, '80.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3157, '103063', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 11:01:34', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '59.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3158, '103064', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 11:05:11', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '100.00', '46.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3159, '103080', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 12:54:35', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3160, '103065', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 11:18:54', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3161, '103066', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 11:23:19', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3162, '103067', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 11:24:48', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3163, '103068', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 11:26:01', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '52.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3164, '103069', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 11:28:10', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '30.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3165, '103070', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 11:54:28', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3171, '103074', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 12:28:56', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3167, '103071', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 11:56:00', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3168, '103072', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 12:01:42', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3169, '103073', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 12:19:11', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '70.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3170, '103101', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 20:46:54', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3172, '103078', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 12:49:15', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3173, '103075', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 12:36:16', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3152, '103057', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 10:11:09', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(3149, '103055', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 09:38:54', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '100.00', '76.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3150, '103056', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 10:09:30', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3151, '103062', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 10:48:06', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3148, '103054', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 09:37:06', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3146, '103052', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 09:28:21', 'Paid', NULL, '117.00', '117.00', '117.00', NULL, '150.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3145, '103051', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 09:23:38', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3147, '103053', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 09:35:15', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '100.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3144, '103050', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-24 09:10:41', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '60.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474715615', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3235, '103138', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 14:59:03', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '55.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3236, '103139', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 14:59:58', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '102.00', '90.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3237, '103141', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 15:18:53', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3238, '103142', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 15:22:29', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3239, '103144', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 16:55:15', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3240, '103143', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 16:33:24', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3241, '103145', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 16:59:28', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3242, '103146', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 18:10:54', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '60.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3243, '103155', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 21:20:35', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3244, '103147', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 18:37:49', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3245, '103148', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 19:12:25', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3246, '103149', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 19:31:41', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '100.00', '67.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3247, '103151', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 19:45:28', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3248, '103150', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 19:45:11', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3249, '103152', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 19:46:38', 'Paid', NULL, '70.00', '70.00', '70.00', NULL, '70.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3250, '103157', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 21:23:07', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3251, '103158', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 21:23:20', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3252, '103156', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 21:22:04', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3253, '103153', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 21:15:21', 'Paid', NULL, '200.00', '200.00', '0.00', '200.00', '200.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '2.24', 'VISA', '1.12', NULL, '0.13', '197.63', 0, NULL, NULL, NULL, NULL, '0'),
(3254, '103154', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 21:20:06', 'Paid', NULL, '48.50', '48.50', '48.50', NULL, '50.50', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(3234, '103137', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 14:57:34', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3229, '103130', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 13:43:49', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '50.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3228, '103135', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 14:55:22', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3227, '103131', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 14:00:40', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3233, '103136', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 14:56:49', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3232, '103140', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 15:06:35', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '70.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3231, '103134', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 14:28:03', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '100.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3230, '103132', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 14:09:00', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3206, '103114', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 11:34:02', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3207, '103115', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 11:39:46', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '100.00', '57.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3208, '103110', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 11:04:38', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3209, '103118', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 12:04:51', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '100.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3210, '103111', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 11:08:37', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3211, '103112', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 11:13:24', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3212, '103113', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 11:27:19', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3213, '103116', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 11:51:35', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3214, '103117', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 12:02:16', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3215, '103119', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 12:11:56', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '50.00', '19.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3216, '103120', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 12:18:48', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3217, '103121', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 12:27:41', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '59.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3218, '103122', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 12:30:42', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3219, '103123', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 12:44:04', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3220, '103128', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 13:19:16', 'Paid', NULL, '105.00', '105.00', '105.00', NULL, '105.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3221, '103124', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 12:56:28', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3222, '103133', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 14:20:51', 'Paid', NULL, '134.00', '134.00', '134.00', NULL, '150.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3223, '103125', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 13:05:04', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '100.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3224, '103126', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 13:06:12', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3225, '103127', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 13:10:32', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '100.00', '56.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3226, '103129', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 13:28:25', 'Paid', NULL, '98.00', '98.00', '98.00', NULL, '98.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3205, '103109', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 10:59:42', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3204, '103108', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 10:20:50', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '69.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3203, '103107', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 10:11:01', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3199, '103102', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 09:20:17', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3200, '103103', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 09:37:51', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '70.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3201, '103105', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 09:52:04', 'Paid', NULL, '80.00', '80.00', '80.00', NULL, '80.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3202, '103106', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 10:02:35', 'Paid', NULL, '108.00', '108.00', '108.00', NULL, '108.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3198, '103104', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-25 09:46:46', 'Paid', NULL, '239.00', '239.00', '239.00', NULL, '250.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474803087', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3276, '103179', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-26 14:51:06', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '21.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474859119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3275, '103178', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-26 14:48:55', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474859119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3274, '103176', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-26 14:10:48', 'Paid', NULL, '10.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1474859119', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3273, '103174', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-26 13:25:11', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474859119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3272, '103173', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-26 13:07:33', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474859119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3271, '103172', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-26 13:00:55', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '52.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474859119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3270, '103171', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-26 12:59:30', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474859119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3269, '103170', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-26 12:58:49', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474859119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3267, '103169', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-26 12:58:08', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474859119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3266, '103168', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-26 12:56:06', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '50.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474859119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3265, '103177', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-26 14:27:27', 'Paid', NULL, '77.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474859119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3264, '103175', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-26 13:32:00', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474859119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3263, '103167', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-26 11:33:05', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '70.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474859119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3262, '103166', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-09-26 11:05:48', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474859119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3261, '103165', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-26 10:56:20', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '100.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474859119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3256, '103160', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-26 09:11:52', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474859119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3257, '103161', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-26 09:30:34', 'Paid', NULL, '24.50', '24.50', '24.50', NULL, '100.00', '75.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474859119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3260, '103164', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-26 10:15:26', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '53.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474859119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3259, '103163', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-26 10:10:34', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474859119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3258, '103162', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-26 09:41:41', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '51.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474859119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3255, '103159', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-26 09:09:39', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1474859119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3286, '103188', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-09-28 16:52:06', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475053695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3285, '103187', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-28 15:43:58', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475053695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3284, '103186', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-28 15:10:03', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475053695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3281, '103189', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-28 17:06:03', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475053695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3282, '103183', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-28 13:37:47', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475053695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3283, '103185', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-28 14:26:54', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475053695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3280, '103184', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-28 13:48:41', 'Paid', NULL, '73.00', '73.00', '73.00', NULL, '100.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475053695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3278, '103181', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-28 11:51:06', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475053695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3279, '103182', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-28 12:30:46', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '100.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475053695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3277, '103180', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-28 09:45:14', 'Paid', NULL, '21.50', '21.50', '21.50', NULL, '22.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475053695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3324, '103226', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 18:48:10', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3325, '103227', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 19:52:11', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '20.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3320, '103223', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 16:41:49', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3321, '103221', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 16:25:10', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3323, '103225', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 17:12:43', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3322, '103224', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 17:07:07', 'Paid', NULL, '34.00', '30.60', '30.60', NULL, '30.60', '0.00', '0.00', '0.00', '3.40', '0.00', 'Cash', NULL, '27', '1475144581', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3319, '103220', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 16:19:06', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3318, '103219', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 16:18:07', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3316, '103222', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 16:39:16', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3317, '103218', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 16:17:33', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3315, '103217', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 16:00:14', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3314, '103216', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 15:39:39', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3313, '103215', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 15:36:12', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3311, '103214', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 15:32:43', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3312, '103212', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 14:39:04', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3309, '103210', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 14:29:42', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3308, '103209', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 14:13:49', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '20.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3307, '103208', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 14:06:59', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3305, '103213', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 15:01:19', 'Paid', NULL, '79.00', '71.10', '71.10', NULL, '101.10', '30.00', '0.00', '0.00', '7.90', '0.00', 'Cash', NULL, '27', '1475144581', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3306, '103207', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 14:05:29', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3304, '103206', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 13:20:21', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '20.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3303, '103211', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 14:38:38', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3302, '103205', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 13:11:24', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3301, '103204', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 12:31:00', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3300, '103203', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 12:30:30', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3299, '103202', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 12:29:58', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3298, '103201', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 12:24:18', 'Paid', NULL, '10.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1475144581', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3297, '103200', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 12:14:07', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '70.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3296, '103199', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 11:18:07', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3295, '103198', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 11:09:29', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '50.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3294, '103197', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-29 10:59:27', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3291, '103194', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-09-29 10:53:43', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3292, '103195', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-09-29 10:54:08', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3293, '103196', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-09-29 10:55:03', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3288, '103190', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-09-29 10:04:10', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3290, '103193', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-09-29 10:52:40', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3289, '103192', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2016-09-29 10:51:49', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '20.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3287, '103191', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2016-09-29 10:43:19', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475144581', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3355, '103258', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 21:35:47', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3356, '103255', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 21:05:04', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3354, '103254', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 20:14:59', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3353, '103253', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 19:37:02', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '20.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3352, '103252', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 19:34:37', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3351, '103257', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 21:34:57', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3347, '103248', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 17:46:33', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3348, '103249', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 18:01:21', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '30.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3349, '103250', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 18:04:51', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '100.00', '82.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3350, '103251', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 18:14:45', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3346, '103247', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 16:54:00', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3343, '103243', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 14:55:52', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '100.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3344, '103245', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 15:17:36', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(3345, '103246', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 16:00:00', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3342, '103242', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 14:11:18', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '100.00', '71.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3341, '103241', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 14:09:26', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3340, '103239', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 13:48:13', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '100.00', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3339, '103256', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 21:30:32', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '37.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3338, '103244', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 15:02:49', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '70.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3337, '103236', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 12:58:34', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3336, '103235', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 12:53:05', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3335, '103234', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 12:52:15', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3334, '103233', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 12:31:09', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3333, '103238', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 13:34:11', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '100.00', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3329, '103231', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 11:34:05', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3330, '103237', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 13:00:07', 'Paid', NULL, '61.50', '61.50', '61.50', NULL, '70.00', '8.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3331, '103232', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 12:05:09', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '100.00', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3332, '103240', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 13:48:59', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3327, '103230', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 11:04:06', 'Paid', NULL, '108.00', '97.20', '97.20', NULL, '100.20', '3.00', '0.00', '0.00', '10.80', '0.00', 'Cash', NULL, '27', '1475237666', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3328, '103229', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 10:17:09', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3326, '103228', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-09-30 09:29:46', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '100.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475237666', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3393, '103300', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 22:06:38', 'Paid', NULL, '163.00', '163.00', '163.00', NULL, '180.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3394, '103298', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 21:26:50', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3395, '103295', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 20:42:54', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3396, '103296', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 20:51:03', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3397, '103299', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 22:01:07', 'Paid', NULL, '99.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3398, '103297', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 21:15:43', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '50.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3389, '103290', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 16:31:38', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3390, '103292', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 18:49:39', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3391, '103293', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 19:16:11', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3392, '103294', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 20:28:16', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3388, '103289', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 16:09:57', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3387, '103291', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 16:44:46', 'Paid', NULL, '21.00', '18.90', '18.90', NULL, '20.00', '1.10', '0.00', '0.00', '2.10', '0.00', 'Cash', NULL, '27', '1475328400', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3385, '103285', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 14:43:29', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '20.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3386, '103288', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 15:51:18', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3384, '103286', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 15:16:14', 'Paid', NULL, '118.00', '118.00', '118.00', NULL, '150.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3383, '103282', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 13:58:01', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '100.00', '71.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3382, '103287', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 15:39:17', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3378, '103279', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 12:30:52', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3379, '103283', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 14:07:11', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '75.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3380, '103281', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 13:24:13', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3381, '103284', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 14:07:42', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3377, '103276', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 12:05:09', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '70.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3374, '103273', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 11:30:46', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3375, '103274', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 11:45:19', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3376, '103275', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 12:02:41', 'Paid', NULL, '111.00', '111.00', '111.00', NULL, '111.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3373, '103277', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 12:12:14', 'Paid', NULL, '49.00', '44.10', '44.10', NULL, '50.10', '6.00', '0.00', '0.00', '4.90', '0.00', 'Cash', NULL, '27', '1475328400', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3372, '103278', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 12:18:27', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3365, '103266', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 10:58:59', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '25.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3366, '103267', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 10:59:43', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '50.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3367, '103268', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 11:00:47', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3368, '103269', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 11:02:07', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3369, '103270', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 11:02:52', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3370, '103271', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 11:04:26', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3371, '103272', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 11:06:01', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3364, '103280', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 12:46:10', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3358, '103260', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 10:07:36', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '60.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3359, '103263', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 10:28:49', 'Paid', NULL, '126.00', '126.00', '126.00', NULL, '126.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3360, '103261', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 10:26:25', 'Paid', NULL, '83.00', '83.00', '83.00', NULL, '103.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3361, '103262', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 10:26:52', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3362, '103264', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 10:50:18', 'Paid', NULL, '81.00', '81.00', '81.00', NULL, '100.00', '19.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3363, '103265', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 10:56:53', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '10.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3357, '103259', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-01 09:30:31', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '45.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475328400', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3437, '103336', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 16:57:27', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3438, '103340', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 18:05:45', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3439, '103341', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 18:13:52', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3440, '103338', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 18:01:21', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3441, '103343', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 19:33:47', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '65.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3442, '103342', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 18:20:31', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3443, '103344', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 19:34:45', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3444, '103348', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 21:51:54', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3445, '103345', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 20:07:12', 'Paid', NULL, '51.00', '45.90', '45.90', NULL, '50.00', '4.10', '0.00', '0.00', '5.10', '0.00', 'Cash', NULL, '27', '1475408080', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3446, '103346', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 20:51:24', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3447, '103347', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 21:15:42', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3431, '103329', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 15:49:09', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '20.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3432, '103337', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 17:55:36', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3433, '103332', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 16:04:33', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3434, '103333', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 16:12:59', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3435, '103339', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 18:04:28', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '100.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3430, '103328', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 15:43:24', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3428, '103326', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 15:32:54', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3429, '103327', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 15:34:59', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3424, '103323', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 15:06:14', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '50.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3425, '103331', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 15:59:22', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3426, '103324', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 15:30:10', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3427, '103325', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 15:31:56', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '100.00', '88.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3423, '103322', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 15:01:22', 'Paid', NULL, '112.00', '112.00', '112.00', NULL, '112.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3406, '103308', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 10:46:20', 'Paid', NULL, '79.00', '79.00', '79.00', NULL, '100.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3407, '103309', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 11:01:08', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3408, '103310', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 11:19:42', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3409, '103313', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 12:05:59', 'Paid', NULL, '84.00', '84.00', '84.00', NULL, '84.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3410, '103311', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 12:02:01', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3411, '103312', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 12:05:04', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3412, '103314', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 13:13:00', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '54.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3413, '103334', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 16:14:09', 'Paid', NULL, '26.00', '23.40', '23.40', NULL, '25.00', '1.60', '0.00', '0.00', '2.60', '0.00', 'Cash', NULL, '27', '1475408080', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3414, '103315', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 13:18:39', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '10.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3415, '103316', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 13:18:55', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3416, '103317', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 13:36:51', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3417, '103318', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 13:42:01', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3418, '103335', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 16:38:17', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '50.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3419, '103319', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 14:08:20', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3420, '103320', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 14:09:28', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3421, '103330', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 15:49:35', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3422, '103321', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 14:52:37', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3400, '103302', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 09:57:41', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '35.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3405, '103307', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 10:43:36', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3404, '103305', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 10:31:37', 'Paid', NULL, '88.00', '79.20', '79.20', NULL, '79.20', '0.00', '0.00', '0.00', '8.80', '0.00', 'Cash', NULL, '27', '1475408080', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3403, '103304', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 10:07:11', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '100.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3402, '103303', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 10:00:07', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '100.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3401, '103306', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 10:42:02', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3399, '103301', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-02 09:52:59', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475408080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3473, '103374', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 18:06:42', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3474, '103376', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 18:24:35', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3475, '103375', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 18:19:55', 'Paid', NULL, '74.00', '74.00', '74.00', NULL, '74.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3472, '103373', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 17:32:28', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3455, '103356', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 10:19:58', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '100.00', '52.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3456, '103358', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 11:18:28', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3457, '103357', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 11:18:15', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3458, '103360', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 13:10:40', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3459, '103359', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 11:33:15', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3460, '103362', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 14:03:51', 'Paid', NULL, '106.00', '106.00', '106.00', NULL, '106.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3461, '103361', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 13:14:54', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3462, '103366', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 14:14:58', 'Paid', NULL, '95.00', '95.00', '95.00', NULL, '95.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3463, '103365', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 14:14:19', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3464, '103364', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 14:13:20', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3465, '103363', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 14:07:36', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3466, '103371', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 16:16:17', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3467, '103367', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 14:40:38', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3468, '103368', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 15:40:02', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3469, '103369', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 15:43:35', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3470, '103370', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 16:13:21', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '50.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3471, '103372', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 16:21:19', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '10.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3449, '103349', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 09:27:13', 'Paid', NULL, '97.00', '97.00', '97.00', NULL, '100.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3454, '103355', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 10:11:17', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3453, '103354', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 10:09:56', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '20.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3452, '103356', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 10:24:09', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3450, '103350', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 09:31:24', 'Paid', NULL, '87.00', '87.00', '87.00', NULL, '100.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3451, '103351', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 09:41:25', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3448, '103353', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-03 09:44:00', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475465542', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3502, '103401', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 20:05:24', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '100.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3503, '103403', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 21:03:36', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3500, '103402', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 20:21:12', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3485, '103388', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 13:48:54', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '59.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3482, '103382', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 12:02:15', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3483, '103385', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 12:50:35', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3484, '103383', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 12:36:04', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3486, '103384', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 12:42:10', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3487, '103390', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 14:18:39', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '37.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3488, '103387', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 13:47:11', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3489, '103386', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 13:36:55', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(3490, '103389', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 13:55:55', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3491, '103395', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 18:12:40', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3492, '103392', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 16:08:43', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3493, '103399', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 19:40:51', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3494, '103393', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 16:13:59', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3495, '103391', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 16:01:27', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '55.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3496, '103398', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 19:18:49', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3497, '103394', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 17:49:43', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3498, '103396', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 18:14:54', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3501, '103400', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 20:02:41', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3499, '103397', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 19:10:22', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3480, '103380', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 11:08:43', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3477, '103379', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 10:39:16', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3478, '103378', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 10:15:56', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3479, '103381', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 11:30:27', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3476, '103377', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-05 09:41:29', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475642788', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3510, '103413', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 12:39:29', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3511, '103409', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 12:03:13', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3512, '103411', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 12:23:35', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3513, '103412', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 12:29:48', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3514, '103415', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 14:44:12', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3515, '103416', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 14:48:55', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3516, '103414', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 14:43:47', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3517, '103417', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 15:32:31', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3518, '103418', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 16:05:51', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3519, '103421', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 16:38:52', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3520, '103419', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 16:17:22', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3521, '103420', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 16:35:53', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3522, '103422', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 17:48:19', 'Paid', NULL, '2.00', '2.00', '2.00', NULL, '2.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3523, '103423', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 18:11:57', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3524, '103424', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 19:08:14', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3525, '103425', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 20:02:34', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3526, '103426', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 20:57:15', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3527, '103428', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 21:26:40', 'Paid', NULL, '100.00', '100.00', '100.00', NULL, '100.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3528, '103427', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 21:06:48', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3509, '103410', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 12:13:34', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3505, '103405', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 09:24:39', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3506, '103406', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 09:25:08', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3508, '103408', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 11:02:40', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '20.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3507, '103407', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 10:31:26', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3504, '103404', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-06 09:24:10', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475748709', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3554, '103451', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 18:42:46', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3555, '103459', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 21:31:45', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3556, '103457', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 21:05:21', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '50.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3557, '103453', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 19:48:34', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3558, '103456', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 20:19:40', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '50.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3559, '103455', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 20:18:44', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3560, '103458', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 21:14:09', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3561, '103462', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 21:51:59', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3563, '103461', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 21:40:10', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3535, '103436', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 12:16:01', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3536, '103435', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 12:15:28', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3537, '103437', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 12:16:35', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3538, '103442', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 13:54:40', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3539, '103438', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 12:49:00', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3540, '103443', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 14:45:53', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3541, '103444', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 15:14:37', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3542, '103439', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 13:19:45', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3543, '103440', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 13:34:11', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3544, '103441', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 13:52:42', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3545, '103449', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 17:41:26', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3546, '103445', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 15:52:36', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3547, '103446', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 16:01:17', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3548, '103447', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 16:13:52', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3549, '103448', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 16:15:01', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3550, '103454', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 19:52:13', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3562, '103460', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 21:38:20', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3552, '103450', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 18:20:49', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3553, '103452', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 19:22:13', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '15.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3532, '103430', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 10:56:03', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '50.00', '19.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3534, '103433', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 11:46:15', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3533, '103434', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 11:52:05', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3530, '103431', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 11:00:37', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3531, '103432', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 11:25:34', 'Paid', NULL, '40.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', '4.00', '0.00', 'Cash', NULL, '27', '1475843650', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3529, '103429', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-07 09:17:14', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475843650', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3590, '103489', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 18:31:59', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3591, '103490', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 18:47:12', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3592, '103498', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 21:47:42', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3593, '103492', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 20:25:16', 'Paid', NULL, '109.00', '109.00', '109.00', NULL, '109.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3594, '103494', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 21:01:18', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '100.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3595, '103491', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 20:08:28', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3596, '103493', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 20:47:33', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3597, '103499', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 21:48:54', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '52.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3598, '103497', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 21:39:50', 'Paid', NULL, '70.00', '70.00', '70.00', NULL, '70.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3599, '103496', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 21:10:44', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3600, '103495', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 21:03:50', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3570, '103474', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 13:17:39', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '88.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3571, '103469', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 10:30:44', 'Paid', NULL, '57.00', '51.30', '51.30', NULL, '51.30', '0.00', '0.00', '0.00', '5.70', '0.00', 'Cash', NULL, '27', '1475929383', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3572, '103470', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 11:17:09', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3573, '103471', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 12:34:45', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3574, '103472', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 12:58:50', 'Paid', NULL, '119.00', '119.00', '119.00', NULL, '150.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3575, '103473', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 13:06:46', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3576, '103475', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 13:38:03', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '25.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3577, '103476', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 13:51:44', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3578, '103481', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 15:03:35', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '100.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3579, '103477', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 14:06:56', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3580, '103478', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 14:28:13', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '55.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3581, '103482', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 15:07:52', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3582, '103484', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 16:06:56', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3583, '103479', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 15:01:10', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3584, '103480', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 15:01:57', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3585, '103483', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 15:37:02', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3586, '103485', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 16:18:11', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3587, '103486', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 16:24:36', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '40.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3588, '103487', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 16:32:53', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3589, '103488', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 18:26:22', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '50.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3566, '103465', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 09:43:55', 'Paid', NULL, '100.00', '100.00', '100.00', NULL, '100.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3567, '103466', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 09:59:24', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3565, '103464', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 09:42:43', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3568, '103467', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 10:05:37', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '100.00', '51.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3569, '103468', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 10:12:19', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3564, '103463', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-08 09:24:24', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '72.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1475929383', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3639, '103539', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 19:52:30', 'Paid', NULL, '185.00', '185.00', '185.00', NULL, '200.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3640, '103540', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 20:21:31', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '100.00', '58.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3641, '103538', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 19:02:50', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3627, '103522', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 14:42:47', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3628, '103524', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 14:51:48', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3629, '103527', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 14:56:59', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3630, '103530', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 15:43:52', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3631, '103531', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 15:44:36', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3632, '103535', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 16:06:48', 'Paid', NULL, '107.00', '107.00', '107.00', NULL, '107.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3633, '103529', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 15:37:47', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3634, '103528', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 15:33:05', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '100.00', '81.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3635, '103536', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 16:10:40', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3636, '103533', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 15:56:01', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3637, '103534', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 15:57:50', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '100.00', '86.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3638, '103537', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 18:57:34', 'Paid', NULL, '73.00', '73.00', '73.00', NULL, '73.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3602, '103504', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 10:45:38', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3603, '103501', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 10:22:52', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3604, '103502', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 10:25:41', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '50.00', '39.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3605, '103503', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 10:43:28', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3606, '103505', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 11:21:30', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3607, '103507', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 12:01:55', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '50.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3608, '103506', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 12:01:30', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3609, '103508', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 12:04:04', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3610, '103512', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 12:48:18', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3611, '103509', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 12:18:05', 'Paid', NULL, '79.00', '79.00', '79.00', NULL, '100.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3612, '103517', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 13:46:25', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3613, '103510', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 12:36:14', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3614, '103511', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 12:44:23', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '50.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3615, '103532', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 15:54:25', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3616, '103513', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 13:11:37', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3617, '103514', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 13:21:23', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '20.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3618, '103519', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 14:29:44', 'Paid', NULL, '195.00', '195.00', '195.00', NULL, '200.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3619, '103518', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 14:15:08', 'Paid', NULL, '83.00', '83.00', '83.00', NULL, '83.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3620, '103515', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 13:36:11', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3621, '103526', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 14:55:32', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(3623, '103525', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 14:54:45', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '75.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3624, '103523', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 14:43:33', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '88.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3625, '103521', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 14:40:59', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3626, '103520', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 14:39:58', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3622, '103516', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 13:40:20', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3601, '103500', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-09 09:51:13', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '20.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476009857', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3648, '103545', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-10 12:33:18', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476075805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3651, '103553', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-10 15:29:01', 'Paid', NULL, '168.00', '168.00', '168.00', NULL, '200.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476075805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3650, '103546', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-10 13:03:13', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476075805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3652, '103551', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-10 14:23:55', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '59.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476075805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3653, '103549', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-10 13:38:18', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476075805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3654, '103550', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-10 14:17:34', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476075805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3655, '103552', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-10 14:48:38', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476075805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3656, '103554', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-10 16:09:32', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476075805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3657, '103555', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-10 16:18:13', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '50.00', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476075805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3658, '103558', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-10 17:42:20', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '20.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476075805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3659, '103556', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-10 17:10:42', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '100.00', '51.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476075805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3660, '103557', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-10 17:13:20', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476075805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3661, '103559', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-10 19:12:15', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476075805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3643, '103542', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-10 10:48:28', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476075805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3644, '103543', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-10 11:22:06', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '51.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476075805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3645, '103544', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-10 11:30:32', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476075805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3646, '103547', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-10 13:12:04', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476075805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3647, '103548', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-10 13:21:55', 'Paid', NULL, '60.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', '6.00', '0.00', 'Cash', NULL, '27', '1476075805', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3642, '103541', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-10 10:40:20', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476075805', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3663, '103561', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 09:22:59', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3664, '103562', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 09:23:57', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '20.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3665, '103563', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 09:31:01', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '65.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3666, '103564', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 09:37:28', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '21.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3667, '103565', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 11:33:58', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3668, '103566', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 11:38:30', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '30.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3669, '103567', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 12:09:19', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3670, '103573', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 14:00:00', 'Paid', NULL, '101.00', '101.00', '101.00', NULL, '110.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3671, '103569', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 12:57:53', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3672, '103568', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 12:27:44', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '100.00', '62.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3673, '103574', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 14:11:16', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3674, '103570', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 13:01:41', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3675, '103571', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 13:02:26', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3676, '103572', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 13:11:18', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3677, '103576', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 14:54:54', 'Paid', NULL, '74.00', '74.00', '74.00', NULL, '100.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3678, '103575', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 14:44:36', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3679, '103577', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 15:20:34', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '36.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3680, '103578', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 15:45:02', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '51.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3681, '103579', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 16:18:19', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '100.00', '78.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3682, '103585', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 19:56:51', 'Paid', NULL, '122.00', '109.80', '109.80', NULL, '110.00', '0.20', '0.00', '0.00', '12.20', '0.00', 'Cash', NULL, '27', '1476273339', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3683, '103580', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 16:29:31', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '20.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3684, '103582', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 18:15:08', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3685, '103581', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 17:34:49', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3690, '103586', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 20:22:05', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3687, '103583', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 18:42:59', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3688, '103584', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 19:51:23', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3691, '103591', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 21:42:42', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '100.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3693, '103592', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 21:52:04', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3694, '103587', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 21:27:32', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3695, '103588', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 21:28:07', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3696, '103589', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 21:28:59', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3697, '103590', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 21:29:30', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3662, '103560', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-12 09:11:13', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476273339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3699, '103594', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-13 11:32:11', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476357929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3700, '103596', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-13 12:29:47', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476357929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3701, '103595', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-13 12:19:39', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476357929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3702, '103597', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-13 12:49:14', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476357929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3703, '103598', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-13 12:55:36', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476357929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3704, '103599', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-13 14:29:35', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476357929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3705, '103600', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-13 15:13:17', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476357929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3706, '103602', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-13 16:27:39', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476357929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3707, '103601', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-13 16:10:21', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476357929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3708, '103603', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-13 19:39:17', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476357929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3709, '103611', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-13 21:11:45', 'Paid', NULL, '166.00', '166.00', '166.00', NULL, '200.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476357929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3710, '103606', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-13 20:12:48', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476357929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3711, '103605', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-13 19:58:58', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476357929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3712, '103604', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-13 19:58:01', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '20.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476357929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3713, '103612', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-13 21:12:19', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476357929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3714, '103607', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-13 20:17:21', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476357929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3715, '103610', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-13 21:03:37', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '50.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476357929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3716, '103609', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-13 20:46:24', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476357929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3717, '103608', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-13 20:40:55', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476357929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3718, '103613', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-13 21:33:40', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476357929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3698, '103593', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-13 11:10:21', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476357929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3720, '103616', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-14 14:50:33', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '67.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476435711', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3721, '103615', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-14 14:31:34', 'Paid', NULL, '77.00', '77.00', '77.00', NULL, '77.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476435711', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3722, '103617', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-14 16:02:57', 'Paid', NULL, '106.00', '106.00', '106.00', NULL, '106.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476435711', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3723, '103620', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-14 16:29:48', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476435711', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3724, '103618', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-14 16:09:08', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476435711', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3725, '103619', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-14 16:19:57', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '50.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476435711', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3726, '103622', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-14 17:07:20', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476435711', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3727, '103621', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-14 16:57:44', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476435711', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3728, '103624', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-14 18:34:56', 'Paid', NULL, '71.00', '71.00', '71.00', NULL, '71.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476435711', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3729, '103623', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-14 17:35:58', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476435711', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3730, '103625', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-14 19:27:57', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476435711', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3731, '103626', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-14 19:56:02', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '50.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476435711', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3732, '103627', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-14 20:20:33', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476435711', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3733, '103628', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-14 20:45:44', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476435711', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3719, '103614', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-14 12:22:24', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476435711', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3771, '103663', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 21:08:13', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3770, '103664', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 21:22:06', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3769, '103662', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 21:06:39', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3768, '103665', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 21:23:21', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '70.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3767, '103661', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 20:01:30', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3766, '103660', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 19:31:34', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3765, '103659', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 18:58:01', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3764, '103657', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 17:41:56', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3763, '103655', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 17:24:23', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3762, '103658', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 18:00:49', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '101.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3761, '103656', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 17:33:57', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '50.00', '19.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3760, '103653', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 16:59:41', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3759, '103652', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 16:54:56', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3757, '103651', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 14:35:04', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '69.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(3756, '103650', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 14:33:54', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(3755, '103649', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 14:09:16', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3754, '103648', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 14:08:05', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3758, '103654', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 17:20:34', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3752, '103647', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 13:13:40', 'Paid', NULL, '80.00', '80.00', '80.00', NULL, '100.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3751, '103646', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 13:08:37', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3750, '103644', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 12:37:30', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '100.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3749, '103642', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 12:26:43', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3748, '103645', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 12:41:57', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3747, '103643', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 12:33:31', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '100.00', '59.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3746, '103641', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 11:09:46', 'Paid', NULL, '84.00', '84.00', '84.00', NULL, '100.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3745, '103639', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 10:31:33', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3744, '103638', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 10:30:48', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3743, '103636', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 10:17:19', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '100.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3742, '103640', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 10:55:16', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3741, '103635', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 09:55:09', 'Paid', NULL, '87.00', '87.00', '87.00', NULL, '100.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3740, '103634', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 09:50:38', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3735, '103637', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 10:24:21', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3736, '103630', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 09:16:07', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3737, '103631', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 09:36:32', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3738, '103632', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 09:44:12', 'Paid', NULL, '119.00', '119.00', '119.00', NULL, '119.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3739, '103633', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 09:46:36', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3734, '103629', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-15 09:05:08', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '64.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476505036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3806, '103700', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 18:35:21', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3805, '103699', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 18:14:37', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '50.00', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3804, '103697', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 16:51:59', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3803, '103695', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 16:04:15', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '51.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3802, '103698', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 17:36:08', 'Paid', NULL, '94.00', '94.00', '94.00', NULL, '94.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3801, '103694', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 15:41:39', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3800, '103692', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 14:27:33', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '100.00', '57.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3799, '103691', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 14:16:17', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3798, '103690', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 14:13:55', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '50.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3797, '103693', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 15:00:24', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3796, '103696', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 16:41:20', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3794, '103689', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 13:56:21', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3795, '103688', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 13:55:21', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '100.00', '66.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3793, '103686', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 13:13:31', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3792, '103682', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 12:55:42', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '10.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3791, '103684', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 12:59:14', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(3790, '103681', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 12:43:09', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3789, '103680', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 12:31:06', 'Paid', NULL, '116.00', '116.00', '116.00', NULL, '116.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3788, '103685', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 13:01:20', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3787, '103683', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 12:57:00', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3786, '103687', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 13:33:41', 'Paid', NULL, '98.00', '98.00', '98.00', NULL, '100.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3785, '103679', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 12:09:04', 'Paid', NULL, '109.00', '109.00', '109.00', NULL, '109.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3784, '103677', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 11:43:37', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3783, '103678', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 11:55:41', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3782, '103676', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 11:17:32', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3781, '103675', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 11:17:14', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3780, '103673', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 11:00:32', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3779, '103674', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 11:00:47', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3773, '103666', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 09:22:35', 'Paid', NULL, '112.00', '112.00', '112.00', NULL, '112.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3774, '103667', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 09:56:17', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3775, '103668', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 10:01:15', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3776, '103670', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 10:25:53', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3777, '103672', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 10:31:17', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3778, '103671', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 10:30:55', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3772, '103669', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-16 10:03:18', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476592950', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3822, '103716', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 16:32:08', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '38.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3829, '103723', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 20:12:07', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3828, '103722', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 20:09:39', 'Paid', NULL, '48.50', '48.50', '48.50', NULL, '100.00', '51.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3827, '103719', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 18:52:02', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3826, '103720', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 18:58:03', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3825, '103721', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 19:18:09', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '50.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3824, '103718', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 18:29:53', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3823, '103717', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 16:32:45', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3821, '103714', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 15:05:19', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3820, '103715', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 15:11:58', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '100.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3819, '103712', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 14:38:02', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3817, '103710', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 13:49:05', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3818, '103711', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 14:18:31', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3816, '103709', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 13:44:42', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '40.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3815, '103708', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 13:19:34', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '52.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3808, '103701', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 10:55:40', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '30.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3809, '103703', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 12:14:40', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3810, '103704', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 12:36:40', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3811, '103705', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 12:41:36', 'Paid', NULL, '117.00', '117.00', '117.00', NULL, '117.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3812, '103713', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 14:42:30', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3813, '103706', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 13:10:06', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3814, '103707', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 13:11:33', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3807, '103702', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-17 11:06:45', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476704001', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3848, '103741', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-19 19:17:10', 'Paid', NULL, '2.00', '1.00', '1.00', NULL, '1.00', '0.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1476860642', 'p', '50', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3847, '103742', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-19 19:18:42', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '25.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476860642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3846, '103740', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-19 18:32:09', 'Paid', NULL, '138.00', '124.20', '124.20', NULL, '130.20', '6.00', '0.00', '0.00', '13.80', '0.00', 'Cash', NULL, '27', '1476860642', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3845, '103739', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-19 18:23:19', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476860642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3844, '103738', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-19 16:43:18', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '50.00', '39.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476860642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3843, '103737', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-19 16:03:39', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476860642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3842, '103734', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-19 15:05:27', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476860642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3841, '103736', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-19 15:39:30', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476860642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3840, '103735', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-19 15:38:56', 'Paid', NULL, '59.00', '53.10', '53.10', NULL, '53.10', '0.00', '0.00', '0.00', '5.90', '0.00', 'Cash', NULL, '27', '1476860642', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3839, '103732', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-19 14:20:40', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476860642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3831, '103726', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-19 12:31:22', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476860642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3832, '103725', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-19 12:21:52', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '100.00', '72.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476860642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3833, '103730', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-19 13:54:43', 'Paid', NULL, '73.00', '73.00', '73.00', NULL, '100.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476860642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3834, '103727', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-19 12:53:55', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476860642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3835, '103733', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-10-19 15:03:28', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476860642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3836, '103728', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-19 13:41:48', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476860642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3837, '103731', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-19 14:11:42', 'Paid', NULL, '73.00', '73.00', '73.00', NULL, '100.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476860642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3838, '103729', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-19 13:51:56', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '50.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476860642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3830, '103724', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-19 10:57:49', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476860642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3871, '103764', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 19:19:01', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3870, '103765', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 19:27:03', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3869, '103762', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 18:55:48', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3867, '103760', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 17:17:40', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3868, '103763', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 18:58:58', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3866, '103759', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 17:06:26', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3865, '103758', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 16:21:15', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3864, '103761', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 17:24:04', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '107.00', '90.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3859, '103753', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 14:26:13', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3861, '103755', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 14:51:08', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3862, '103756', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 15:19:07', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3863, '103757', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 15:36:48', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3860, '103754', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 14:49:39', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3858, '103752', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 13:46:46', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3850, '103747', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 11:00:35', 'Paid', NULL, '101.00', '101.00', '101.00', NULL, '101.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3851, '103744', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 10:23:55', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3852, '103745', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 10:53:56', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3853, '103746', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 10:57:14', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3854, '103748', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 11:08:16', 'Paid', NULL, '4.00', '4.00', '4.00', NULL, '4.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3855, '103749', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 13:35:35', 'Paid', NULL, '73.00', '73.00', '73.00', NULL, '73.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3856, '103750', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 13:37:44', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3857, '103751', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 13:44:28', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3849, '103743', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-20 10:15:00', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1476950035', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3900, '103793', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 21:46:23', 'Paid', NULL, '51.00', '45.90', '45.90', NULL, '100.00', '54.10', '0.00', '0.00', '5.10', '0.00', 'Cash', NULL, '27', '1477050597', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3899, '103791', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 20:16:43', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3898, '103792', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 20:32:31', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3897, '103790', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 20:07:01', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '50.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3895, '103788', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 19:33:43', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3896, '103789', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 19:51:44', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '100.00', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3894, '103787', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 19:12:34', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3893, '103785', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 17:56:28', 'Paid', NULL, '36.00', '32.40', '32.40', NULL, '50.00', '17.60', '0.00', '0.00', '3.60', '0.00', 'Cash', NULL, '27', '1477050597', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3891, '103784', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 17:19:25', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3892, '103786', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 18:01:10', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3890, '103783', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 17:12:00', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3889, '103781', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 14:43:43', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3884, '103777', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 13:52:36', 'Paid', NULL, '119.00', '119.00', '119.00', NULL, '119.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3885, '103779', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 14:35:50', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3886, '103778', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 14:15:26', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3887, '103782', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 15:02:14', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3888, '103780', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 14:42:02', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3883, '103774', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 11:54:18', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3882, '103776', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 13:23:49', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3881, '103772', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 11:25:32', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '15.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3880, '103769', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 11:00:03', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '50.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3879, '103768', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 10:59:43', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3878, '103767', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 10:59:20', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3877, '103771', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 11:21:51', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3876, '103773', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 11:38:07', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3875, '103775', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 12:31:53', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3874, '103766', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 10:18:07', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '70.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3873, '103770', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-21 11:00:34', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '100.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477050597', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3939, '103828', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 17:08:10', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3940, '103832', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 19:11:01', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3941, '103830', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 17:40:37', 'Paid', NULL, '81.00', '81.00', '81.00', NULL, '81.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3942, '103833', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 19:21:13', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3943, '103834', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 19:22:34', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '30.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3944, '103838', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 21:46:07', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3945, '103835', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 21:22:41', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '40.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3946, '103836', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 21:29:25', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3947, '103837', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 21:29:57', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3948, '103841', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 22:43:04', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '100.00', '66.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3949, '103840', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 22:41:17', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3950, '103839', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 22:15:00', 'Paid', NULL, '24.00', '19.20', '19.20', NULL, '50.20', '31.00', '0.00', '0.00', '4.80', '0.00', 'Cash', NULL, '27', '1477129686', 'p', '20', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3938, '103827', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 17:02:47', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3937, '103825', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 17:00:45', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3935, '103831', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 17:50:27', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3936, '103826', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 17:01:21', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3934, '103823', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 16:28:42', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3933, '103819', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 16:03:04', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3932, '103821', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 16:15:53', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3931, '103816', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 15:23:51', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3930, '103824', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 16:36:19', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '30.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3929, '103822', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 16:18:20', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3927, '103820', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 16:13:55', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3926, '103829', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 17:32:05', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3924, '103813', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 14:42:47', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3925, '103815', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 15:04:22', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3921, '103812', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 13:44:22', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3922, '103817', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 15:38:41', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '60.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3923, '103814', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 14:56:31', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3919, '103811', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 13:34:46', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3918, '103808', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 12:55:43', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3917, '103807', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 12:55:07', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3916, '103806', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 12:39:54', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3915, '103805', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 12:24:41', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3914, '103818', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 15:48:08', 'Paid', NULL, '80.50', '80.50', '80.50', NULL, '100.00', '19.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(3913, '103803', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 11:57:50', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3912, '103802', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 11:46:45', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3911, '103809', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 12:57:21', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '100.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3910, '103810', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 13:22:05', 'Paid', NULL, '92.00', '92.00', '92.00', NULL, '102.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3909, '103804', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 12:21:10', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '100.00', '53.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3908, '103799', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 10:58:33', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3907, '103800', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 11:19:43', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '100.00', '63.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3906, '103801', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 11:26:06', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '68.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3905, '103795', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 09:30:36', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3904, '103797', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 09:44:02', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3903, '103798', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 09:46:43', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3902, '103794', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 09:29:11', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '100.00', '71.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3901, '103796', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-22 09:32:41', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '88.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477129686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3988, '103878', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 14:16:35', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4003, '103891', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 20:36:10', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3990, '103880', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 15:52:10', 'Paid', NULL, '93.00', '93.00', '93.00', NULL, '93.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3991, '103879', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 15:02:10', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3992, '103883', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 16:52:44', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3993, '103881', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 16:27:06', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '36.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3994, '103882', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 16:33:53', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3995, '103886', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 18:16:32', 'Paid', NULL, '83.00', '83.00', '83.00', NULL, '100.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3996, '103884', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 18:08:51', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3997, '103885', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 18:10:59', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3998, '103889', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 18:54:13', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3999, '103887', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 18:38:31', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4000, '103888', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 18:46:00', 'Paid', NULL, '78.00', '78.00', '78.00', NULL, '80.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4001, '103890', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 19:34:16', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4002, '103892', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 21:18:05', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3986, '103875', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 14:03:06', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3987, '103877', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 14:04:44', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(3984, '103870', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 13:21:21', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3985, '103872', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 13:22:41', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3977, '103863', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 12:28:44', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3983, '103869', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 13:20:42', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3982, '103876', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 14:03:18', 'Paid', NULL, '160.00', '160.00', '160.00', NULL, '170.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3981, '103874', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 13:54:46', 'Paid', NULL, '154.50', '154.50', '154.50', NULL, '154.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3979, '103873', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 13:53:31', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3980, '103871', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 13:21:46', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3978, '103866', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 13:06:46', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3976, '103867', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 13:15:10', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3975, '103861', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 12:21:16', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3971, '103865', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 12:37:45', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3972, '103859', 'T1(S)', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 12:01:37', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '100.00', '61.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(3974, '103868', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 13:15:40', 'Paid', NULL, '143.00', '143.00', '143.00', NULL, '150.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3970, '103862', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 12:28:05', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3969, '103864', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 12:30:24', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3968, '103858', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 11:18:32', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3967, '103856', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 11:14:19', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3966, '103855', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 11:07:09', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '58.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3973, '103860', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 12:19:10', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3965, '103854', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 11:03:25', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3963, '103852', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 10:56:10', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3962, '103857', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 11:15:56', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3961, '103848', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 10:23:42', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3960, '103847', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 10:20:56', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3959, '103846', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 10:19:43', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3958, '103845', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 10:09:38', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '70.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3957, '103853', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 11:01:44', 'Paid', NULL, '106.00', '106.00', '106.00', NULL, '106.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3956, '103849', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 10:28:37', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3955, '103850', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 10:29:43', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3954, '103844', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 09:50:12', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3953, '103851', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 10:54:19', 'Paid', NULL, '58.00', '52.20', '52.20', NULL, '52.20', '0.00', '0.00', '0.00', '5.80', '0.00', 'Cash', NULL, '27', '1477219527', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3952, '103842', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 09:10:10', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '100.00', '67.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(3951, '103843', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-23 09:42:45', 'Paid', NULL, '112.00', '112.00', '112.00', NULL, '112.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477219527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4035, '103924', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 21:01:00', 'Paid', NULL, '226.00', '226.00', '226.00', NULL, '250.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4034, '103922', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 20:36:59', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4033, '103923', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 20:45:51', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '55.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4030, '103920', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 20:16:01', 'Paid', NULL, '51.00', '40.80', '40.80', NULL, '40.80', '0.00', '0.00', '0.00', '10.20', '0.00', 'Cash', NULL, '27', '1477310901', 'p', '20', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4032, '103921', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 20:35:53', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4031, '103919', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 19:56:22', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4029, '103918', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 17:53:00', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4028, '103917', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 17:22:32', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4024, '103912', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 16:02:36', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4025, '103913', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 16:16:22', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4026, '103915', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 16:40:23', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4027, '103916', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 16:47:04', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4022, '103911', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 15:30:46', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4023, '103914', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 16:24:18', 'Paid', NULL, '137.00', '137.00', '137.00', NULL, '150.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4021, '103909', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 14:32:56', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '55.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4020, '103907', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 13:59:39', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '50.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4019, '103910', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 15:18:54', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4018, '103908', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 14:28:14', 'Paid', NULL, '86.00', '86.00', '86.00', NULL, '100.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4017, '103904', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 12:48:41', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4006, '103896', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 10:27:54', 'Paid', NULL, '74.00', '74.00', '74.00', NULL, '74.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4016, '103906', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 13:20:53', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4015, '103899', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 12:14:56', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '50.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4014, '103903', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 12:42:05', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '51.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4013, '103897', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 11:54:50', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4012, '103905', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 13:18:53', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4011, '103901', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 12:28:56', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4010, '103900', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 12:23:14', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4009, '103898', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 11:56:08', 'Paid', NULL, '112.50', '112.50', '112.50', NULL, '150.00', '37.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4008, '103902', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 12:34:55', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4007, '103895', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 10:12:08', 'Paid', NULL, '86.00', '86.00', '86.00', NULL, '100.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4005, '103894', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 09:47:25', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '50.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4004, '103893', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-24 09:19:00', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477310901', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4055, '103944', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-26 17:40:43', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477456053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4056, '103945', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-26 18:29:50', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '50.00', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477456053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4057, '103946', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-26 19:47:22', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477456053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4053, '103942', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-26 17:39:22', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477456053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4054, '103943', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-26 17:40:04', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '21.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477456053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4052, '103941', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-26 17:38:50', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477456053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4051, '103940', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-26 17:19:22', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477456053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4050, '103938', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-26 15:47:05', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477456053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4049, '103936', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-26 14:58:54', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477456053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4048, '103939', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-26 16:18:55', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '51.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477456053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4047, '103937', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-26 15:11:27', 'Paid', NULL, '68.00', '61.20', '61.20', NULL, '70.20', '9.00', '0.00', '0.00', '6.80', '0.00', 'Cash', NULL, '27', '1477456053', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4046, '103935', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-26 13:17:24', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477456053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4045, '103934', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-26 13:16:43', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '52.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477456053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4044, '103930', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-26 12:28:06', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477456053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4043, '103929', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-26 12:27:41', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477456053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4042, '103933', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-26 13:05:48', 'Paid', NULL, '95.00', '95.00', '95.00', NULL, '95.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477456053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4041, '103931', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-26 12:31:35', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477456053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4040, '103932', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-26 12:44:01', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477456053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4039, '103928', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-26 11:51:12', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '38.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477456053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4038, '103927', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-26 11:05:34', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477456053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4037, '103926', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-26 10:49:02', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '60.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477456053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4036, '103925', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-26 09:31:11', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '101.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477456053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4075, '103963', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-27 17:03:36', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477566367', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4076, '103964', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-27 18:31:17', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477566367', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4077, '103965', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-27 20:19:28', 'Paid', NULL, '86.00', '86.00', '86.00', NULL, '100.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477566367', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4073, '103962', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-27 16:21:58', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477566367', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4070, '103957', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-27 13:46:30', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477566367', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4071, '103960', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-27 15:11:30', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477566367', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4072, '103961', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-27 15:18:34', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477566367', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4069, '103954', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-27 13:03:20', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477566367', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4068, '103958', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-27 14:27:27', 'Paid', NULL, '91.00', '91.00', '0.00', '91.00', '91.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1477566367', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '1.64', 'Master Card', '1.80', NULL, '0.10', '89.26', 0, NULL, NULL, NULL, NULL, '0'),
(4067, '103953', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-27 12:37:46', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477566367', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4066, '103952', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-27 12:33:22', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477566367', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4065, '103956', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-27 13:42:19', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '100.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477566367', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4064, '103951', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-10-27 12:01:42', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477566367', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4063, '103949', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-27 11:44:47', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477566367', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4062, '103950', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-27 11:47:49', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477566367', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4060, '103959', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-27 14:30:44', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477566367', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4061, '103948', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-27 10:48:02', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '65.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477566367', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4059, '103955', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-27 13:32:07', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477566367', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4058, '103947', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-27 09:37:41', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477566367', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4109, '103996', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 22:37:30', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '20.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4105, '103991', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 18:05:06', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4106, '103993', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 20:39:33', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '100.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4108, '103994', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 21:18:43', 'Paid', NULL, '90.00', '90.00', '90.00', NULL, '100.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4104, '103995', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 22:22:51', 'Paid', NULL, '976.00', '976.00', '976.00', NULL, '976.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4103, '103992', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 18:39:10', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4102, '103990', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 17:47:58', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4098, '103984', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 15:12:04', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4099, '103986', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 15:55:23', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '40.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4100, '103988', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 16:23:49', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(4101, '103989', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 17:20:45', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4097, '103983', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 15:01:47', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4094, '103976', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 13:56:39', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4095, '103978', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 14:09:16', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4096, '103985', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 15:18:31', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '38.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4093, '103975', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 13:56:17', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4091, '103982', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 14:32:31', 'Paid', NULL, '71.00', '71.00', '71.00', NULL, '71.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4092, '103977', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 14:07:51', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '22.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4089, '103980', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 14:11:06', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4090, '103979', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 14:10:36', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4088, '103974', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 12:59:54', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4086, '103981', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 14:26:46', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4087, '103987', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 16:20:56', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4085, '103972', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 12:30:12', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4084, '103973', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 12:53:03', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '100.00', '51.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4083, '103970', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 11:07:34', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4082, '103971', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 12:17:28', 'Paid', NULL, '189.00', '189.00', '189.00', NULL, '200.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4081, '103969', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 10:38:00', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '15.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4080, '103967', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 10:11:34', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4079, '103966', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 10:10:45', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '54.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4078, '103968', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-28 10:27:30', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477656527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4145, '104031', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 16:03:53', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4146, '104030', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 16:01:29', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4147, '104032', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 16:10:13', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4148, '104035', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 16:33:38', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4149, '104036', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 18:57:51', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '100.00', '57.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4144, '104029', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 15:58:47', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4143, '104026', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 14:56:39', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4140, '104024', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 14:39:11', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4141, '104033', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 16:10:33', 'Paid', NULL, '37.00', '33.30', '33.30', NULL, '33.30', '0.00', '0.00', '0.00', '3.70', '0.00', 'Cash', NULL, '27', '1477719603', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4142, '104034', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 16:29:39', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '100.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4139, '104022', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 14:29:07', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4138, '104023', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 14:38:08', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4137, '104021', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 14:14:38', 'Paid', NULL, '71.00', '71.00', '71.00', NULL, '101.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4136, '104020', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 14:01:17', 'Paid', NULL, '137.00', '137.00', '0.00', '137.00', '137.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '1.53', 'VISA', '1.12', NULL, '0.09', '135.37', 0, NULL, NULL, NULL, NULL, '0'),
(4135, '104018', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 12:59:30', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4134, '104017', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 12:56:23', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4133, '104027', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 15:14:49', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '76.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4132, '104012', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 12:42:36', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '30.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4129, '104016', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 12:55:52', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4130, '104009', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 12:27:16', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '100.00', '90.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4131, '104028', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 15:46:16', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4126, '104019', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 13:20:51', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4127, '104015', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 12:54:53', 'Paid', NULL, '63.00', '63.00', '0.00', '63.00', '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '1.13', 'Master Card', '1.80', NULL, '0.07', '61.80', 0, NULL, NULL, NULL, NULL, '0'),
(4128, '104025', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 14:54:06', 'Paid', NULL, '138.00', '138.00', '138.00', NULL, '138.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4125, '104010', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 12:30:42', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4123, '104014', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 12:49:49', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4124, '104008', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 12:21:00', 'Paid', NULL, '83.00', '83.00', '83.00', NULL, '100.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4121, '104004', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 10:48:29', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4122, '104013', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 12:44:43', 'Paid', NULL, '70.00', '70.00', '70.00', NULL, '70.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4120, '104007', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 12:00:19', 'Paid', NULL, '84.00', '84.00', '84.00', NULL, '100.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4118, '104000', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 10:10:48', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4119, '104003', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 10:47:53', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4117, '104002', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 10:37:23', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '52.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4116, '103999', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 10:06:32', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '51.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4115, '104005', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 11:28:37', 'Paid', NULL, '135.00', '135.00', '135.00', NULL, '150.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4113, '103998', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 09:25:20', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4114, '104001', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 10:29:40', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4112, '104011', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 12:31:34', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4111, '104006', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 11:37:10', 'Paid', NULL, '92.00', '92.00', '92.00', NULL, '102.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4110, '103997', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-29 09:08:38', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477719603', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4173, '104057', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 12:32:16', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4174, '104059', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 13:37:28', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4175, '104060', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 14:06:34', 'Paid', NULL, '145.00', '145.00', '145.00', NULL, '145.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4176, '104061', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 14:12:48', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4177, '104064', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 15:37:39', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '36.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4178, '104067', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 16:15:53', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4179, '104063', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 14:56:03', 'Paid', NULL, '10.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1477831929', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4180, '104066', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 16:14:57', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4181, '104065', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 16:10:17', 'Paid', NULL, '24.00', '21.60', '21.60', NULL, '25.00', '3.40', '0.00', '0.00', '2.40', '0.00', 'Cash', NULL, '27', '1477831929', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4182, '104068', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 16:27:09', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4183, '104069', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 16:35:49', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4184, '104074', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 18:22:11', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '60.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4185, '104070', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 17:11:19', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4186, '104071', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 17:33:57', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4187, '104072', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 17:48:09', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4188, '104073', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 18:08:12', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4189, '104075', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 18:43:42', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4190, '104077', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 20:06:49', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4191, '104076', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 19:23:30', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4192, '104079', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 20:30:36', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4193, '104078', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 20:27:25', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4194, '104080', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 20:31:24', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4195, '104081', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 20:32:04', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4196, '104083', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 21:18:32', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4197, '104082', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 21:18:02', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4170, '104055', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 12:20:54', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4171, '104062', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 14:35:02', 'Paid', NULL, '128.50', '115.65', '115.65', NULL, '115.65', '0.00', '0.00', '0.00', '12.85', '0.00', 'Cash', NULL, '27', '1477831929', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4172, '104058', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 13:07:03', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4167, '104050', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 11:23:49', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '60.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4168, '104053', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 11:55:13', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4169, '104056', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 12:31:31', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4165, '104048', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 11:12:41', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4163, '104047', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 11:12:17', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4166, '104049', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 11:15:12', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4162, '104045', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 11:03:13', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '39.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4160, '104054', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 12:05:35', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4161, '104044', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 11:00:01', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4158, '104043', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 10:39:54', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4159, '104046', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 11:08:11', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4156, '104042', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 10:29:49', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4157, '104051', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 11:27:54', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4155, '104052', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 11:50:39', 'Paid', NULL, '94.00', '94.00', '94.00', NULL, '100.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4154, '104038', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 09:52:58', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4153, '104037', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 09:51:57', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4152, '104040', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 10:03:58', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4151, '104041', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 10:25:24', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4150, '104039', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-10-30 09:57:20', 'Paid', NULL, '70.00', '70.00', '70.00', NULL, '70.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477831929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4221, '104104', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 16:55:53', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4222, '104106', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 17:17:34', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4223, '104105', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 17:15:05', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '20.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4225, '104108', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 17:52:27', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4226, '104109', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 17:59:27', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '55.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4227, '104111', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 18:52:10', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '40.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4228, '104112', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 19:38:58', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '100.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4218, '104101', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 16:33:57', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4219, '104102', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 16:38:08', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4220, '104103', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 16:51:50', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '100.00', '78.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4213, '104096', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 14:11:59', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4215, '104098', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 15:05:45', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4216, '104107', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 17:29:50', 'Paid', NULL, '103.00', '103.00', '0.00', '103.00', '103.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '1.15', 'VISA', '1.12', NULL, '0.07', '101.78', 0, NULL, NULL, NULL, NULL, '0'),
(4217, '104110', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 18:16:03', 'Paid', NULL, '12.00', '10.80', '10.80', NULL, '51.00', '40.20', '0.00', '0.00', '1.20', '0.00', 'Cash', NULL, '27', '1477907530', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4212, '104097', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 14:50:20', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4211, '104094', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 14:10:58', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '60.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4209, '104093', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 14:04:04', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4210, '104092', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 13:39:26', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '100.00', '46.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4208, '104091', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 13:35:21', 'Paid', NULL, '193.00', '193.00', '0.00', '193.00', '193.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '2.16', 'VISA', '1.12', NULL, '0.13', '190.71', 0, NULL, NULL, NULL, NULL, '0'),
(4207, '104095', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 14:11:37', 'Paid', NULL, '209.00', '209.00', '209.00', NULL, '209.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4214, '104100', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 15:48:45', 'Paid', NULL, '64.00', '57.60', '57.60', NULL, '60.00', '2.40', '0.00', '0.00', '6.40', '0.00', 'Cash', NULL, '27', '1477907530', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4205, '104099', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 15:09:43', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4204, '104090', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 12:33:14', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '25.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4203, '104087', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 11:19:27', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '64.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4202, '104086', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 11:18:03', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '50.00', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4201, '104085', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 11:17:37', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '100.00', '56.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4200, '104088', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 11:21:24', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '59.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4199, '104089', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 11:40:47', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4198, '104084', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-10-31 11:07:59', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1477907530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4249, '104130', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 16:43:56', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4250, '104136', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 20:20:43', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '20.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4251, '104135', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 19:18:38', 'Paid', NULL, '79.00', '79.00', '79.00', NULL, '100.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4252, '104133', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 19:10:58', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4253, '104134', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 19:11:45', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4254, '104137', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 20:21:10', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4247, '104129', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 16:35:45', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4248, '104132', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 17:44:57', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4237, '104127', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 16:08:39', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4238, '104122', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 14:28:37', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '20.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(4240, '104126', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 15:35:12', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4243, '104124', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 14:49:42', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4242, '104123', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 14:29:36', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4244, '104125', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 15:25:11', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4245, '104128', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 16:10:46', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4246, '104131', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 16:54:25', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '27.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4239, '104121', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 14:06:23', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4236, '104120', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 13:28:17', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '50.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4235, '104118', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 13:00:57', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4234, '104119', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 13:05:10', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4233, '104116', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 12:42:13', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4232, '104117', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 12:55:33', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4231, '104115', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 12:25:00', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '60.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4230, '104114', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 10:34:20', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4229, '104113', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-02 10:18:36', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478063098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4264, '104148', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-11-03 18:29:58', 'Paid', NULL, '117.00', '105.30', '105.30', NULL, '106.00', '0.70', '0.00', '0.00', '11.70', '0.00', 'Cash', NULL, '27', '1478135267', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4265, '104147', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-03 17:34:17', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478135267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4266, '104149', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-03 18:32:56', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '100.00', '63.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478135267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4263, '104146', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-03 17:32:16', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478135267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4262, '104145', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-03 15:18:19', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478135267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4261, '104144', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-03 15:08:44', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '35.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478135267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4260, '104141', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-03 13:30:01', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478135267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4259, '104142', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-03 13:36:27', 'Paid', NULL, '86.00', '86.00', '86.00', NULL, '100.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478135267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4258, '104143', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-03 13:52:57', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '101.00', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478135267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4257, '104139', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-03 11:39:56', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478135267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4256, '104140', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-03 12:41:23', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478135267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4255, '104138', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-03 09:10:21', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478135267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4286, '104166', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 14:48:39', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '100.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4288, '104170', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 16:03:44', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4289, '104171', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 16:06:41', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4290, '104172', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 16:08:45', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4291, '104173', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 16:20:53', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4292, '104175', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 17:14:32', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4293, '104174', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 17:07:16', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '50.00', '39.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4294, '104178', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 18:30:05', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '100.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4295, '104176', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 17:20:18', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4296, '104177', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 18:12:49', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4297, '104179', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 19:39:47', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4298, '104180', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 20:17:34', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '51.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4285, '104165', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 14:48:13', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4276, '104157', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 12:49:35', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4277, '104156', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 12:17:14', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4278, '104168', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 15:52:47', 'Paid', NULL, '112.00', '112.00', '112.00', NULL, '120.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4279, '104159', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 13:04:53', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '58.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4280, '104161', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 13:59:51', 'Paid', NULL, '101.00', '101.00', '101.00', NULL, '101.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4281, '104163', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 14:09:52', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '20.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4282, '104164', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 14:23:48', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '40.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4287, '104169', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 15:55:06', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4284, '104167', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 15:01:50', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '103.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4275, '104158', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 12:59:55', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4274, '104154', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 11:08:06', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4273, '104155', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 11:22:52', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4272, '104150', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 10:43:31', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4271, '104153', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 11:06:06', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '51.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4270, '104152', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 10:49:13', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4269, '104160', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 13:09:28', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4268, '104162', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 14:03:02', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '50.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4267, '104151', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-04 10:48:13', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478256345', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4319, '104198', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 12:39:49', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '100.00', '74.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4320, '104202', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 13:19:46', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4321, '104200', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 12:57:15', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4322, '104201', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 13:14:44', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4323, '104208', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 14:04:32', 'Paid', NULL, '85.00', '85.00', '85.00', NULL, '100.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4324, '104204', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 13:35:13', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '25.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4325, '104206', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 13:39:53', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4326, '104205', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 13:39:19', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '100.00', '88.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4327, '104207', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 13:41:13', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4328, '104209', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 14:47:50', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '100.00', '63.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4329, '104212', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 15:39:34', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4330, '104210', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 15:10:48', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4331, '104213', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 15:47:20', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4332, '104211', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 15:28:39', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4333, '104214', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 18:33:50', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4334, '104215', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 19:44:18', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4335, '104218', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 20:51:09', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4336, '104216', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 20:32:38', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4337, '104219', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 21:14:16', 'Paid', NULL, '140.00', '140.00', '140.00', NULL, '150.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4338, '104217', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 20:36:47', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '52.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4318, '104197', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 12:30:00', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4309, '104189', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 10:53:50', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4310, '104199', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 12:48:42', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '100.00', '47.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4311, '104190', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 10:57:23', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4312, '104192', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 11:42:05', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '100.00', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4313, '104194', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 12:00:45', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4314, '104195', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 12:03:06', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4315, '104193', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 11:49:12', 'Paid', NULL, '44.00', '44.00', '0.00', '44.00', '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '0.49', 'VISA', '1.12', NULL, '0.03', '43.48', 0, NULL, NULL, NULL, NULL, '0'),
(4316, '104196', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 12:23:32', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4317, '104203', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 13:24:40', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '65.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4306, '104186', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 10:17:46', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4308, '104191', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 11:25:46', 'Paid', NULL, '125.00', '125.00', '0.00', '125.00', '125.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '1.40', 'VISA', '1.12', NULL, '0.08', '123.52', 0, NULL, NULL, NULL, NULL, '0'),
(4307, '104187', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 10:27:26', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4304, '104185', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 10:08:09', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4303, '104188', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 10:33:00', 'Paid', NULL, '106.00', '106.00', '106.00', NULL, '106.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4302, '104184', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 10:06:27', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4301, '104183', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 09:11:10', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4300, '104182', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 09:09:41', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '70.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4299, '104181', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-11-05 09:07:37', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '100.00', '48.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478346242', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4358, '104239', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 16:18:30', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '52.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4359, '104240', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 16:27:56', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4360, '104242', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 18:48:49', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4361, '104241', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 18:00:07', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4362, '104244', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 19:34:02', 'Paid', NULL, '103.00', '103.00', '103.00', NULL, '103.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4363, '104243', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 18:55:40', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4364, '104245', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 20:06:13', 'Paid', NULL, '72.00', '72.00', '72.00', NULL, '72.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4357, '104238', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 15:50:20', 'Paid', NULL, '105.00', '105.00', '105.00', NULL, '105.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4350, '104230', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 12:43:22', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '60.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4351, '104232', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 13:04:31', 'Paid', NULL, '121.00', '121.00', '121.00', NULL, '121.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4352, '104234', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 14:26:27', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4353, '104233', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 13:40:31', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4355, '104235', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 15:08:18', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4356, '104236', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 15:09:58', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '100.00', '78.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4346, '104224', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 11:44:22', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4347, '104225', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 11:45:17', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4348, '104227', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 11:48:09', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '52.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4349, '104231', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 12:51:04', 'Paid', NULL, '43.00', '43.00', '0.00', '43.00', '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '0.48', 'VISA', '1.12', NULL, '0.03', '42.49', 0, NULL, NULL, NULL, NULL, '0'),
(4354, '104237', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 15:11:41', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4345, '104229', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 12:25:29', 'Paid', NULL, '83.00', '83.00', '83.00', NULL, '100.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4344, '104226', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 11:46:13', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4343, '104223', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 11:16:40', 'Paid', NULL, '70.00', '70.00', '0.00', '70.00', '70.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '1.26', 'Master Card', '1.80', NULL, '0.08', '68.66', 0, NULL, NULL, NULL, NULL, '0'),
(4342, '104228', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 12:21:13', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4341, '104222', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 11:03:08', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '100.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4340, '104221', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 10:53:21', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '75.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4339, '104220', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-06 10:23:49', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478427999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4384, '104265', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-07 20:18:22', 'Paid', NULL, '166.00', '166.00', '166.00', NULL, '166.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478520563', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4385, '104267', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-07 21:16:08', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '20.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478520563', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4386, '104266', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-07 20:53:11', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478520563', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4380, '104260', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-07 16:30:53', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478520563', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4381, '104261', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-07 16:31:26', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478520563', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4382, '104263', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-07 17:10:11', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478520563', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4383, '104264', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-07 18:43:31', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '58.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478520563', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4372, '104251', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-07 12:43:59', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478520563', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4378, '104259', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-07 15:34:33', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478520563', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4379, '104262', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-07 16:46:55', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478520563', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4373, '104255', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-07 13:56:22', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478520563', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4374, '104256', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-07 14:19:07', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '60.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478520563', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4375, '104254', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-07 13:24:59', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '100.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478520563', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4376, '104257', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-07 14:58:54', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478520563', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4377, '104258', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-07 15:21:18', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '50.00', '39.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478520563', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4371, '104252', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-07 12:54:13', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478520563', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4369, '104249', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-07 11:31:50', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '40.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478520563', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4370, '104250', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-07 11:53:40', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '50.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478520563', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4368, '104247', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-07 10:59:22', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478520563', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4367, '104253', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-07 13:10:45', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478520563', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4366, '104246', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-07 09:52:58', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478520563', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4365, '104248', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-07 11:26:55', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '37.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478520563', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4407, '104286', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 19:00:01', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4408, '104287', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 19:32:58', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '70.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(4409, '104290', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 21:02:19', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4410, '104291', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 21:03:02', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '40.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4411, '104289', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 21:01:59', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '25.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4402, '104284', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 16:37:34', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '50.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4403, '104282', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 15:50:27', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4404, '104283', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 16:36:26', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4405, '104288', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 19:47:23', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '101.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4406, '104285', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 18:40:20', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4395, '104276', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 13:23:04', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4396, '104273', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 12:54:43', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '30.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4401, '104280', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 15:14:20', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '53.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4400, '104281', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 15:29:16', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4399, '104279', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 14:29:53', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '100.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4398, '104278', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 14:12:21', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '100.00', '56.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4397, '104274', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 12:55:49', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4394, '104272', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 12:20:45', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4393, '104275', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 12:58:44', 'Paid', NULL, '72.00', '72.00', '72.00', NULL, '100.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4392, '104277', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 13:45:30', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '51.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4390, '104270', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 10:57:39', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4389, '104269', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 10:23:59', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4388, '104271', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 11:02:08', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4387, '104268', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-09 10:19:27', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478667259', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4426, '104305', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-11-10 18:04:57', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '51.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478786083', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4425, '104303', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-10 16:11:35', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478786083', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4427, '104306', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-10 18:10:30', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478786083', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4428, '104307', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-10 20:25:50', 'Paid', NULL, '120.00', '120.00', '120.00', NULL, '120.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478786083', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4429, '104310', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-10 21:54:16', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478786083', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4430, '104309', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-10 21:05:46', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478786083', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4431, '104308', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-10 20:54:33', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478786083', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4423, '104304', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-11-10 16:59:01', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478786083', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4422, '104302', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-11-10 15:08:33', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478786083', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4421, '104301', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-10 14:56:43', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478786083', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4419, '104298', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-10 13:41:52', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478786083', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4420, '104300', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-10 14:37:01', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '25.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478786083', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4418, '104299', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-10 13:47:05', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478786083', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4417, '104295', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-11-10 13:06:33', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '30.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478786083', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4416, '104294', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-10 12:49:25', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478786083', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4415, '104296', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-11-10 13:07:39', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '100.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478786083', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4414, '104293', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-10 12:31:53', 'Paid', NULL, '113.00', '113.00', '113.00', NULL, '150.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478786083', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4413, '104297', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-10 13:11:48', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478786083', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4412, '104292', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-10 11:27:03', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478786083', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4448, '104327', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-11 21:09:59', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478859943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4444, '104324', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-11 19:16:58', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478859943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4445, '104323', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-11 18:25:52', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '100.00', '58.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478859943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4446, '104325', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-11 19:49:09', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '55.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478859943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4447, '104326', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-11 20:23:21', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478859943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4443, '104322', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-11 17:41:23', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '20.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478859943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4442, '104321', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-11 15:51:25', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '39.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478859943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4439, '104318', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-11 14:52:22', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '100.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478859943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4441, '104320', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-11 15:08:58', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478859943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4440, '104319', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-11 14:53:55', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '30.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478859943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4438, '104317', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-11 14:46:27', 'Paid', NULL, '70.00', '70.00', '70.00', NULL, '100.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478859943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4437, '104316', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-11 12:46:28', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478859943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4436, '104314', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-11 12:14:24', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478859943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4435, '104313', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-11 12:08:32', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478859943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4434, '104311', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-11 11:05:27', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '15.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478859943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4433, '104312', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-11 11:06:54', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478859943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4432, '104315', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-11-11 12:31:47', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '100.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478859943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4468, '104341', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 12:33:09', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '30.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4469, '104348', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 13:20:54', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '60.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4470, '104346', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 12:56:01', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4471, '104347', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 13:02:21', 'Paid', NULL, '13.00', '11.70', '11.70', NULL, '20.00', '8.30', '0.00', '0.00', '1.30', '0.00', 'Cash', NULL, '27', '1478936667', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4472, '104351', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 14:26:26', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4473, '104355', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 15:35:24', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '100.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4474, '104352', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 14:43:02', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '100.00', '76.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4475, '104353', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 14:55:27', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '100.00', '78.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4476, '104356', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 15:42:02', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4477, '104363', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 18:07:25', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4478, '104358', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 15:55:23', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4479, '104354', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 15:30:30', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4480, '104360', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 16:17:23', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '50.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4481, '104357', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 15:44:39', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4484, '104361', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 16:36:22', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4483, '104359', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 16:01:14', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '36.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4485, '104362', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 17:43:29', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '36.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4486, '104364', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 19:51:57', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4487, '104369', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 21:45:13', 'Paid', NULL, '210.00', '210.00', '0.00', '210.00', '210.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '2.35', 'VISA', '1.12', NULL, '0.14', '207.51', 0, NULL, NULL, NULL, NULL, '0'),
(4488, '104365', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 20:31:00', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '57.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4489, '104367', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 21:22:26', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4490, '104368', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 21:32:51', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '65.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4491, '104366', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 21:00:06', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4492, '104370', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 21:53:11', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4493, '104371', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 21:54:01', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4465, '104343', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 12:46:34', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4466, '104349', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 13:21:43', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '70.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4467, '104342', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 12:45:29', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '102.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4461, '104338', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 11:13:16', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '25.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4462, '104350', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 14:19:38', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '60.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4463, '104340', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 12:24:48', 'Paid', NULL, '65.00', '58.50', '58.50', NULL, '100.00', '41.50', '0.00', '0.00', '6.50', '0.00', 'Cash', NULL, '27', '1478936667', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4464, '104344', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 12:49:59', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '20.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4460, '104337', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 11:08:51', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4458, '104338', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 11:14:30', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '38.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4459, '104336', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 11:06:52', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4456, '104333', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 10:41:06', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4457, '104345', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 12:52:34', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4455, '104332', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 10:39:58', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4454, '104331', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 10:34:50', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '52.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4453, '104339', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 11:15:50', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4452, '104330', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 10:13:47', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4451, '104334', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 10:42:51', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4450, '104328', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 09:38:32', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4449, '104329', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-12 09:53:20', 'Paid', NULL, '168.00', '168.00', '168.00', NULL, '168.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1478936667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4513, '104387', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 13:41:59', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4514, '104390', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 14:25:55', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '36.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4515, '104394', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 15:16:15', 'Paid', NULL, '99.00', '99.00', '99.00', NULL, '99.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4516, '104393', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 15:11:50', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4517, '104392', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 15:10:40', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4518, '104398', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 15:39:42', 'Paid', NULL, '50.00', '50.00', '0.00', '50.00', '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '0.56', 'VISA', '1.12', NULL, '0.03', '49.41', 0, NULL, NULL, NULL, NULL, '0'),
(4519, '104395', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 15:32:47', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4520, '104402', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 18:36:13', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4521, '104396', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 15:35:34', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4522, '104397', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 15:36:24', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4523, '104399', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 16:23:59', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4524, '104400', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 17:35:20', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4510, '104388', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 13:47:20', 'Paid', NULL, '41.00', '36.90', '36.90', NULL, '50.00', '13.10', '0.00', '0.00', '4.10', '0.00', 'Cash', NULL, '27', '1479018307', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4511, '104389', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 14:07:18', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4512, '104391', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 14:34:55', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4506, '104401', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 17:43:30', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4507, '104383', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 13:01:03', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4508, '104384', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 13:02:42', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4509, '104385', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 13:03:09', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4505, '104382', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 12:59:02', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '65.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4501, '104376', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 11:15:59', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '40.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4502, '104380', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 11:58:15', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4503, '104386', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 13:04:43', 'Paid', NULL, '72.00', '72.00', '72.00', NULL, '72.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4504, '104381', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 12:57:56', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4500, '104375', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 11:12:37', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4499, '104374', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 11:01:39', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4498, '104378', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 11:49:33', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4497, '104379', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 11:57:50', 'Paid', NULL, '95.00', '95.00', '95.00', NULL, '95.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4496, '104377', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 11:18:53', 'Paid', NULL, '74.00', '74.00', '74.00', NULL, '100.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4495, '104372', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 09:47:15', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4494, '104373', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-13 10:53:35', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '50.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479018307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4545, '104422', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-14 20:22:19', 'Paid', NULL, '125.00', '125.00', '125.00', NULL, '150.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479124695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4546, '104423', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-11-14 21:24:41', 'Paid', NULL, '192.00', '192.00', '192.00', NULL, '202.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479124695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4542, '104418', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-14 16:58:36', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479124695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4543, '104419', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-14 17:10:25', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479124695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4544, '104421', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-14 19:18:57', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479124695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4537, '104415', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-14 15:20:48', 'Paid', NULL, '31.00', '27.90', '27.90', NULL, '50.00', '22.10', '0.00', '0.00', '3.10', '0.00', 'Cash', NULL, '27', '1479124695', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4538, '104417', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-14 16:05:49', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479124695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4540, '104416', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-14 15:21:33', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479124695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4541, '104420', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-14 18:12:05', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479124695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4536, '104414', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-14 14:11:00', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479124695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4531, '104411', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-14 13:11:15', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '70.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479124695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4532, '104409', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-14 12:57:41', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479124695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4533, '104410', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-14 12:59:12', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479124695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4534, '104412', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-14 13:32:11', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479124695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(4535, '104413', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-14 14:06:51', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '100.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479124695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4530, '104408', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-14 12:10:07', 'Paid', NULL, '53.00', '47.70', '47.70', NULL, '50.00', '2.30', '0.00', '0.00', '5.30', '0.00', 'Cash', NULL, '27', '1479124695', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4529, '104406', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-14 11:32:39', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '100.00', '58.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479124695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4528, '104407', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-14 12:04:12', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479124695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4527, '104405', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-14 10:30:37', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479124695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4526, '104404', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-14 10:07:28', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479124695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4525, '104403', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-14 10:04:12', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479124695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4567, '104438', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 13:35:18', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4568, '104439', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 13:35:40', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '56.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4570, '104442', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 13:43:13', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4571, '104445', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 14:28:00', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4572, '104444', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 14:18:32', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4573, '104446', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 14:37:03', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '20.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4574, '104449', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 16:47:19', 'Paid', NULL, '37.00', '33.30', '33.30', NULL, '33.30', '0.00', '0.00', '0.00', '3.70', '0.00', 'Cash', NULL, '27', '1479282653', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4575, '104448', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 16:20:44', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '20.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4576, '104450', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 19:13:44', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4565, '104436', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 13:31:08', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '30.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4566, '104437', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 13:33:05', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4559, '104440', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 13:36:36', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4560, '104434', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 13:13:46', 'Paid', NULL, '74.00', '74.00', '74.00', NULL, '100.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4562, '104433', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 13:12:07', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '100.00', '71.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4569, '104441', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 13:39:45', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4564, '104443', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 13:59:41', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '100.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4557, '104432', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 10:55:46', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4552, '104427', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 10:52:25', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4553, '104428', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 10:53:00', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4554, '104429', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 10:53:38', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4555, '104430', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 10:54:37', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4556, '104431', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 10:55:26', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4551, '104426', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 10:52:04', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4561, '104435', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 13:15:29', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4549, '104425', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 10:50:11', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4548, '104424', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 09:44:48', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4558, '104447', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-16 16:19:56', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '25.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479282653', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4589, '104462', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-17 20:42:33', 'Paid', NULL, '77.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479383287', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4590, '104463', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-17 21:34:33', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479383287', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4591, '104464', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-17 21:53:12', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479383287', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4588, '104461', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-17 20:04:36', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479383287', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4587, '104460', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-17 18:35:47', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479383287', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4586, '104459', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-17 16:25:03', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479383287', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4585, '104457', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-17 14:21:40', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479383287', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4584, '104458', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-17 14:36:42', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '100.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479383287', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4583, '104453', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-17 13:46:32', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479383287', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4582, '104456', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-17 14:03:48', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479383287', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4581, '104452', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-17 12:43:42', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479383287', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4579, '104451', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-17 10:36:57', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '100.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479383287', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4580, '104454', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-17 13:51:37', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '70.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479383287', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4577, '104455', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-17 13:52:41', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '40.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479383287', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4611, '104484', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-18 18:10:19', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '20.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479439074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4613, '104485', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-11-18 20:43:39', 'Paid', NULL, '294.00', '264.60', '0.00', '264.60', '264.60', '0.00', '0.00', '0.00', '29.40', '0.00', 'Credit Card', NULL, '27', '1479439074', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, 5, '2.96', 'VISA', '1.12', NULL, '0.18', '261.46', 0, NULL, NULL, NULL, NULL, '0'),
(4614, '104486', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-18 21:13:02', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479439074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4610, '104483', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-18 18:09:25', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479439074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4609, '104482', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-18 17:03:23', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '50.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479439074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4604, '104476', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-18 12:46:32', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479439074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4605, '104478', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-18 13:06:33', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479439074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4606, '104479', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-18 13:11:25', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479439074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4607, '104480', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-18 13:59:12', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479439074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4608, '104481', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-18 15:33:45', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '20.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479439074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4602, '104474', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-18 12:05:27', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479439074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4603, '104475', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-18 12:13:44', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '71.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479439074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4600, '104471', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-18 11:26:49', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479439074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4601, '104472', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-18 11:44:50', 'Paid', NULL, '77.00', '69.30', '69.30', NULL, '69.30', '0.00', '0.00', '0.00', '7.70', '0.00', 'Cash', NULL, '27', '1479439074', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4599, '104473', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-18 12:01:26', 'Paid', NULL, '78.00', '78.00', '78.00', NULL, '100.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479439074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4592, '104465', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-18 09:43:31', 'Paid', NULL, '73.00', '73.00', '73.00', NULL, '100.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479439074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4593, '104466', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-18 09:46:24', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479439074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4594, '104467', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-18 09:55:09', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479439074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4595, '104469', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-18 10:56:39', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '20.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479439074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4596, '104477', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-18 12:48:58', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '105.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479439074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4597, '104468', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-18 10:47:09', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479439074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4598, '104470', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-18 10:58:53', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '100.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479439074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4634, '104505', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 17:44:04', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '50.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4635, '104506', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 18:13:03', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4636, '104508', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 20:31:48', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4637, '104511', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 21:43:48', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4638, '104510', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 21:40:43', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '100.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4639, '104509', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 21:01:46', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4628, '104504', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 16:41:24', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '100.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4629, '104499', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 14:50:11', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4630, '104500', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 15:57:28', 'Paid', NULL, '111.00', '111.00', '111.00', NULL, '111.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4631, '104507', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 18:23:09', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4632, '104501', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 16:30:37', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '60.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4633, '104503', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 16:37:57', 'Paid', NULL, '176.00', '176.00', '0.00', '176.00', '176.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '3.17', 'Master Card', '1.80', NULL, '0.19', '172.64', 1, NULL, NULL, NULL, NULL, '0'),
(4626, '104497', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 13:25:56', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4627, '104502', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 16:30:55', 'Paid', NULL, '124.00', '124.00', '124.00', NULL, '124.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4623, '104495', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 12:48:09', 'Paid', NULL, '100.00', '100.00', '100.00', NULL, '100.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4624, '104496', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 12:51:16', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4625, '104498', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 14:35:40', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4622, '104494', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 12:28:25', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4621, '104493', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 12:20:01', 'Paid', NULL, '71.00', '71.00', '71.00', NULL, '71.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4620, '104492', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 12:08:34', 'Paid', NULL, '120.00', '120.00', '120.00', NULL, '150.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4619, '104490', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 11:08:31', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4618, '104491', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 11:24:00', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4617, '104489', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 10:53:44', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4616, '104487', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 10:03:34', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4615, '104488', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-19 10:17:45', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479561929', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4660, '104529', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 12:49:14', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4661, '104531', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 13:22:40', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4662, '104539', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 14:41:57', 'Paid', NULL, '209.00', '209.00', '209.00', NULL, '209.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4663, '104532', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 13:24:44', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4664, '104533', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 13:25:22', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4665, '104537', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 14:25:39', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4667, '104534', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 13:50:44', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4668, '104536', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 14:24:10', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4669, '104542', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 15:36:01', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4670, '104538', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 14:41:02', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4671, '104540', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 14:45:48', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4672, '104541', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 14:46:35', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4673, '104550', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 18:31:07', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4674, '104545', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 16:59:12', 'Paid', NULL, '662.00', '662.00', '662.00', NULL, '702.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4675, '104543', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 15:55:12', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4676, '104544', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 16:23:10', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '50.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4677, '104546', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 17:25:52', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4678, '104547', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 18:08:29', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4679, '104548', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 18:12:39', 'Paid', NULL, '96.00', '96.00', '96.00', NULL, '100.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4680, '104549', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 18:25:03', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4659, '104535', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 14:04:27', 'Paid', NULL, '79.00', '79.00', '79.00', NULL, '79.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4653, '104520', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 11:32:13', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4654, '104526', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 12:28:50', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4655, '104525', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 12:20:37', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4656, '104523', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 12:10:06', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4657, '104524', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 12:10:26', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4658, '104527', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 12:35:52', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4649, '104530', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 13:22:05', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '64.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4650, '104522', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 11:46:26', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '50.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4651, '104518', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 11:30:34', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4652, '104519', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 11:31:33', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4647, '104528', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 12:43:36', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '100.00', '61.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4646, '104521', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 11:38:30', 'Paid', NULL, '80.00', '80.00', '80.00', NULL, '100.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4645, '104517', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 10:37:54', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '64.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4644, '104516', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 09:59:02', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4643, '104515', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 09:58:11', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4642, '104514', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 09:49:16', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '50.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4641, '104512', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 09:15:17', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4640, '104513', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-20 09:27:19', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479631118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4700, '104573', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 14:48:08', 'Paid', NULL, '54.00', '48.60', '48.60', NULL, '50.00', '1.40', '0.00', '0.00', '5.40', '0.00', 'Cash', NULL, '27', '1479729787', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4701, '104569', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 14:15:08', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4702, '104566', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 13:59:24', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4703, '104565', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 13:58:02', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4704, '104572', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 14:42:09', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '100.00', '47.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4705, '104567', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 14:04:11', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4706, '104584', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 18:45:13', 'Paid', NULL, '60.00', '54.00', '54.00', NULL, '100.00', '46.00', '0.00', '0.00', '6.00', '0.00', 'Cash', NULL, '27', '1479729787', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4707, '104576', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 15:45:41', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '35.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4708, '104578', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 16:04:44', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4709, '104579', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 16:23:14', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4710, '104577', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 15:48:32', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4711, '104580', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 16:35:59', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4712, '104581', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 16:53:44', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(4713, '104582', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 17:00:58', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4714, '104583', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 18:38:55', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4715, '104587', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 19:20:24', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4716, '104585', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 19:13:42', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4717, '104586', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 19:14:42', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4718, '104589', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 20:22:52', 'Paid', NULL, '74.00', '74.00', '74.00', NULL, '100.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4719, '104588', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 20:16:14', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4720, '104590', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 21:18:21', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4694, '104561', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 13:00:30', 'Paid', NULL, '82.00', '82.00', '82.00', NULL, '82.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4690, '104571', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 14:25:14', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '53.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4689, '104556', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 11:17:27', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4699, '104575', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 14:52:33', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4698, '104570', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 14:16:09', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4697, '104568', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 14:04:41', 'Paid', NULL, '70.00', '70.00', '70.00', NULL, '70.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4696, '104562', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 13:27:38', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4695, '104563', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 13:36:35', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '100.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4693, '104559', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 12:10:58', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '51.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4692, '104574', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 14:50:57', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '60.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4691, '104558', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 12:08:15', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4688, '104555', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 11:07:22', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '60.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4687, '104564', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 13:42:12', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4686, '104560', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 12:55:04', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4685, '104557', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 11:26:44', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4684, '104554', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 11:00:53', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '100.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4683, '104553', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 10:44:58', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4682, '104552', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 10:12:51', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '50.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4681, '104551', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-21 09:54:06', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '55.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479729787', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4738, '104608', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-23 19:11:00', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479874118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4737, '104607', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-23 16:41:17', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479874118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4736, '104604', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-23 15:12:03', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '55.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479874118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4735, '104602', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-23 14:38:23', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '50.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479874118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4734, '104603', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-23 14:49:26', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479874118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4733, '104601', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-23 14:34:41', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479874118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4732, '104606', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-23 15:51:05', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479874118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4731, '104605', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-23 15:27:44', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '58.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479874118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4730, '104598', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-11-23 12:42:09', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '50.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479874118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4729, '104600', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-11-23 13:20:44', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479874118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4728, '104596', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-11-23 12:02:36', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479874118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4727, '104594', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-23 11:15:44', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479874118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4726, '104599', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-23 12:47:22', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479874118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4725, '104597', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-23 12:26:20', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479874118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4724, '104593', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-23 11:15:09', 'Paid', NULL, '162.00', '162.00', '162.00', NULL, '162.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479874118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4723, '104595', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-23 11:47:40', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479874118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4722, '104592', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-23 11:07:42', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479874118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4721, '104591', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-23 09:09:20', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479874118', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4761, '104631', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 21:00:31', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '20.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479962919', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4758, '104627', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 19:26:47', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479962919', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4759, '104629', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 20:23:45', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479962919', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4760, '104630', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 20:25:50', 'Paid', NULL, '9.00', '8.10', '8.10', NULL, '8.10', '0.00', '0.00', '0.00', '0.90', '0.00', 'Cash', NULL, '27', '1479962919', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4756, '104628', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 20:23:12', 'Paid', NULL, '21.00', '16.80', '16.80', NULL, '50.00', '33.20', '0.00', '0.00', '4.20', '0.00', 'Cash', NULL, '27', '1479962919', 'p', '20', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4757, '104626', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 19:24:11', 'Paid', NULL, '166.00', '166.00', '166.00', NULL, '170.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479962919', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4755, '104623', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 17:17:09', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479962919', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4754, '104624', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 17:17:33', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479962919', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4753, '104622', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 16:33:27', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479962919', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4752, '104621', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 16:25:41', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479962919', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4751, '104625', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 17:20:50', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479962919', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4750, '104619', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 15:11:45', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479962919', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4749, '104618', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 15:10:44', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '70.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479962919', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4748, '104617', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 14:52:17', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479962919', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4747, '104616', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 14:51:42', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479962919', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4745, '104615', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 14:19:46', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '45.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479962919', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4746, '104620', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 15:18:27', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '15.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479962919', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4744, '104612', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 13:22:09', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479962919', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4743, '104610', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 12:48:56', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479962919', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4742, '104614', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 14:10:37', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479962919', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4741, '104613', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 13:22:44', 'Paid', NULL, '23.00', '20.70', '20.70', NULL, '51.00', '30.30', '0.00', '0.00', '2.30', '0.00', 'Cash', NULL, '27', '1479962919', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4740, '104611', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 13:01:25', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479962919', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4739, '104609', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-24 11:42:21', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '101.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1479962919', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4783, '104653', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 18:43:09', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4784, '104654', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 21:03:58', 'Paid', NULL, '98.00', '98.00', '98.00', NULL, '100.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4779, '104649', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 16:09:22', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '50.00', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4780, '104650', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 16:30:41', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '50.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4781, '104651', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 17:15:51', 'Paid', NULL, '1.50', '1.50', '1.50', NULL, '1.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4782, '104652', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 17:21:19', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4778, '104648', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 16:05:27', 'Paid', NULL, '96.00', '96.00', '96.00', NULL, '100.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4777, '104647', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 15:45:48', 'Paid', NULL, '131.00', '131.00', '131.00', NULL, '131.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4776, '104643', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 14:01:50', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4775, '104641', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 13:25:45', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4774, '104642', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 13:51:29', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4773, '104644', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 14:07:29', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4772, '104639', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 12:37:25', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4770, '104638', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 12:15:05', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4771, '104640', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 13:12:10', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '100.00', '75.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4764, '104633', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 11:02:41', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4765, '104636', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 11:19:45', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '70.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4769, '104646', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 15:24:30', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4768, '104645', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 14:31:37', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4767, '104634', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 11:13:59', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4766, '104637', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 11:39:37', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4763, '104632', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 10:42:27', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4762, '104635', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-11-25 11:15:47', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '102.00', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480043915', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4819, '104688', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 20:07:52', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '23.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4818, '104687', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 19:58:55', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4817, '104686', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 19:50:41', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4815, '104684', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 18:16:27', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4814, '104685', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 18:23:53', 'Paid', NULL, '80.00', '80.00', '80.00', NULL, '80.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4812, '104682', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 17:27:46', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '30.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4813, '104683', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 17:32:22', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '20.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4811, '104681', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 17:03:36', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4810, '104679', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 16:42:55', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4809, '104680', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 16:56:21', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '60.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4806, '104675', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 14:45:04', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4808, '104678', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 16:34:38', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4807, '104677', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 16:21:48', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '50.00', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4805, '104674', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 14:19:00', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '100.00', '76.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4804, '104673', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 14:17:41', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4803, '104676', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 14:56:34', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4802, '104672', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 14:02:31', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4801, '104670', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 13:20:52', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4800, '104664', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 12:30:11', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4798, '104667', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 12:55:56', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '80.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4799, '104669', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 12:59:02', 'Paid', NULL, '71.00', '71.00', '71.00', NULL, '71.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4797, '104666', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 12:34:30', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '64.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4796, '104668', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 12:57:08', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4793, '104662', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 12:15:50', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '101.00', '60.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4794, '104671', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 13:29:11', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4795, '104661', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 11:50:09', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4792, '104665', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 12:30:24', 'Paid', NULL, '205.00', '205.00', '205.00', NULL, '205.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4791, '104659', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 11:20:50', 'Paid', NULL, '71.00', '71.00', '71.00', NULL, '71.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4790, '104663', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 12:17:55', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4789, '104658', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 10:32:01', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4788, '104655', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 09:47:09', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4787, '104660', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 11:30:10', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4786, '104656', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 10:17:21', 'Paid', NULL, '135.00', '135.00', '135.00', NULL, '135.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4785, '104657', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-26 10:20:14', 'Paid', NULL, '70.00', '70.00', '70.00', NULL, '100.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480147699', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4839, '104707', 'T4', NULL, NULL, NULL, NULL, 'history', '2016-11-27 16:32:01', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, NULL, '1480237524', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4835, '104703', 'T6', NULL, NULL, NULL, NULL, 'history', '2016-11-27 15:53:02', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, NULL, '1480237524', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4837, '104705', 'T3', NULL, NULL, NULL, NULL, 'history', '2016-11-27 16:05:43', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, NULL, '1480237524', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4838, '104706', 'T3', NULL, NULL, NULL, NULL, 'history', '2016-11-27 16:31:13', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, NULL, '1480237524', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4836, '104708', 'T5', NULL, NULL, NULL, NULL, 'history', '2016-11-27 16:44:18', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, NULL, '1480237524', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4828, '104694', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-27 13:17:35', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '50.00', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480237524', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4829, '104698', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-27 13:59:02', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '30.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, NULL, '1480237524', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4834, '104704', 'T3', NULL, NULL, NULL, NULL, 'history', '2016-11-27 15:57:35', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '38.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, NULL, '1480237524', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4830, '104700', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-11-27 14:29:00', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, NULL, '1480237524', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4831, '104697', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-27 13:39:51', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, NULL, '1480237524', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4832, '104701', 'T7', NULL, NULL, NULL, NULL, 'history', '2016-11-27 15:05:22', 'Paid', NULL, '94.00', '94.00', '94.00', NULL, '100.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, NULL, '1480237524', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4833, '104702', 'T4', NULL, NULL, NULL, NULL, 'history', '2016-11-27 15:09:01', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, NULL, '1480237524', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4827, '104699', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-27 14:01:57', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, NULL, '1480237524', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4826, '104696', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-27 13:36:41', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, NULL, '1480237524', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4825, '104695', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-27 13:20:16', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480237524', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4824, '104690', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-27 11:20:14', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '60.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480237524', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4823, '104692', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-11-27 11:47:10', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480237524', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4822, '104691', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-11-27 11:42:16', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '50.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480237524', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4821, '104693', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-27 12:19:04', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '50.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480237524', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4820, '104689', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-27 11:03:04', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480237524', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4859, '104728', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-28 16:55:46', 'Paid', NULL, '78.00', '78.00', '78.00', NULL, '108.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480307144', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4858, '104727', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-28 16:03:17', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480307144', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4852, '104722', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-28 14:19:33', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480307144', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(4853, '104721', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-28 14:11:44', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480307144', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4854, '104720', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-28 14:00:53', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '100.00', '73.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480307144', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4857, '104726', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-11-28 15:14:23', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480307144', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4856, '104723', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-11-28 14:36:02', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480307144', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4855, '104724', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-28 14:41:35', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480307144', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4848, '104725', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-28 15:06:51', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '20.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480307144', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4850, '104719', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-11-28 13:52:14', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480307144', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4851, '104718', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-28 13:49:07', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480307144', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4849, '104715', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-28 12:50:30', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480307144', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4847, '104717', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-11-28 13:27:31', 'Paid', NULL, '110.00', '110.00', '110.00', NULL, '110.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480307144', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4846, '104716', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-11-28 13:14:57', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480307144', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4845, '104714', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-28 12:07:12', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480307144', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4844, '104710', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-11-28 10:42:58', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480307144', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4843, '104712', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-11-28 11:00:46', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480307144', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4842, '104713', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-28 11:46:36', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '50.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480307144', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4841, '104711', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-28 10:52:22', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480307144', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4840, '104709', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-11-28 09:57:46', 'Paid', NULL, '77.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480307144', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4866, '104735', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-11-30 17:42:57', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480483116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4865, '104734', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-11-30 15:46:06', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480483116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4864, '104733', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-30 15:20:28', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480483116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4863, '104732', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-11-30 14:49:07', 'Paid', NULL, '110.00', '110.00', '110.00', NULL, '110.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480483116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4862, '104731', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-11-30 11:39:32', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480483116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4861, '104730', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-30 11:26:14', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '20.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480483116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4860, '104729', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-11-30 10:36:13', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480483116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4888, '104754', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-01 19:09:03', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480570745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4887, '104757', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-01 19:53:36', 'Paid', NULL, '90.00', '90.00', '90.00', NULL, '90.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480570745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4886, '104756', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-01 19:36:21', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480570745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4881, '104749', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-01 15:40:31', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '51.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480570745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4882, '104751', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-01 17:09:26', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480570745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4883, '104750', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-01 16:46:25', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480570745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4884, '104753', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-01 18:23:27', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480570745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4885, '104755', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-01 19:21:49', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480570745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4880, '104748', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-01 15:39:33', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480570745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4879, '104752', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-01 17:10:49', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480570745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4878, '104745', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-01 14:20:24', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480570745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4875, '104746', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-01 14:29:29', 'Paid', NULL, '80.00', '80.00', '0.00', '80.00', '80.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1480570745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '1.44', 'Master Card', '1.80', NULL, '0.09', '78.47', 0, NULL, NULL, NULL, NULL, '0'),
(4876, '104747', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-01 14:35:43', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480570745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4877, '104744', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-01 14:12:44', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '40.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480570745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4874, '104743', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-12-01 13:39:16', 'Paid', NULL, '74.00', '74.00', '74.00', NULL, '100.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480570745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4873, '104741', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-01 12:00:10', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480570745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4872, '104742', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-01 12:01:03', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480570745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4871, '104740', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-01 11:53:09', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480570745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4870, '104738', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-01 11:26:18', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '105.00', '52.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480570745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4869, '104739', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-01 11:51:31', 'Paid', NULL, '142.00', '142.00', '142.00', NULL, '152.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480570745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4868, '104736', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-01 10:23:22', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480570745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4867, '104737', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-01 11:19:01', 'Paid', NULL, '45.00', '40.50', '40.50', NULL, '50.50', '10.00', '0.00', '0.00', '4.50', '0.00', 'Cash', NULL, '27', '1480570745', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4921, '104787', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 21:26:59', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4920, '104786', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 21:25:11', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4919, '104785', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 21:24:47', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4917, '104790', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 22:00:36', 'Paid', NULL, '170.00', '170.00', '170.00', NULL, '200.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4918, '104788', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 21:32:17', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4916, '104789', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 21:58:52', 'Paid', NULL, '123.00', '123.00', '123.00', NULL, '150.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4915, '104784', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 18:46:10', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4914, '104783', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 18:14:47', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4912, '104779', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 15:40:52', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4913, '104782', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 17:26:05', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4910, '104780', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 15:42:18', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '100.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4911, '104776', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 15:02:14', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4909, '104778', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 15:35:28', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4908, '104777', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 15:08:07', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '100.00', '54.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4903, '104771', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 13:26:01', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4904, '104772', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 13:27:10', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '50.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4905, '104773', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 13:32:22', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4906, '104781', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 15:46:05', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4907, '104774', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 13:52:59', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4899, '104765', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 11:29:20', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4900, '104769', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 13:12:22', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4901, '104768', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 12:54:58', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '75.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4902, '104775', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 13:57:17', 'Paid', NULL, '82.00', '82.00', '0.00', '82.00', '82.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '0.92', 'VISA', '1.12', NULL, '0.06', '81.03', 0, NULL, NULL, NULL, NULL, '0'),
(4898, '104766', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 11:29:48', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4897, '104767', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 11:37:42', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4896, '104770', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 13:17:16', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4895, '104761', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 10:43:42', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '21.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4894, '104760', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 10:43:13', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '100.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4893, '104763', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 10:49:09', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '15.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4892, '104762', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 10:44:42', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4891, '104764', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 11:10:06', 'Paid', NULL, '108.00', '108.00', '108.00', NULL, '108.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4890, '104759', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 09:58:14', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4889, '104758', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-02 09:17:24', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480684220', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4949, '104818', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 21:03:14', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '100.00', '72.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4955, '104823', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 23:04:47', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '100.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4954, '104822', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 23:04:17', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4953, '104821', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 23:03:56', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4950, '104819', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 22:03:51', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '36.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4952, '104820', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 23:03:35', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4948, '104814', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 19:32:41', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4947, '104816', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 19:35:20', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4944, '104812', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 18:27:12', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4945, '104813', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 18:56:54', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '100.00', '48.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4946, '104815', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 19:33:22', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4943, '104810', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 17:43:10', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4942, '104817', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 19:59:59', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4941, '104811', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 18:07:07', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4935, '104804', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 15:37:57', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '30.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4936, '104805', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 15:49:41', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4937, '104806', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 16:00:07', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4938, '104809', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 17:41:23', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4933, '104802', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 14:27:36', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4934, '104803', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 14:29:26', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4931, '104800', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 13:06:50', 'Paid', NULL, '78.00', '78.00', '78.00', NULL, '100.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4940, '104808', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 17:36:23', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4939, '104807', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 16:44:34', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4932, '104801', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 13:13:56', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4930, '104797', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 12:12:25', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4928, '104798', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 12:31:53', 'Paid', NULL, '90.00', '90.00', '90.00', NULL, '90.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4929, '104799', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 12:39:36', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4927, '104795', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 11:45:38', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4926, '104792', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 10:59:11', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4925, '104793', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 11:08:17', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '51.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4924, '104794', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 11:25:36', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '60.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4923, '104796', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 11:57:58', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '50.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4922, '104791', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-03 10:19:45', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '101.00', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480759619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4990, '104856', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 19:24:22', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '10.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4991, '104858', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 20:23:18', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4989, '104855', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 19:18:48', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4987, '104853', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 17:56:03', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4988, '104857', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 19:30:10', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4984, '104854', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 18:09:23', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '10.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4985, '104851', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 17:54:59', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4986, '104852', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 17:55:47', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4982, '104850', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 16:52:56', 'Paid', NULL, '92.00', '92.00', '92.00', NULL, '102.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4981, '104846', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 15:00:19', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '40.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4980, '104845', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 14:53:17', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4976, '104840', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 14:13:00', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4977, '104842', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 14:25:00', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4978, '104844', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 14:37:07', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '65.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4979, '104849', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 15:15:27', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4968, '104834', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 12:28:18', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4969, '104833', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 12:28:01', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4970, '104837', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 13:28:21', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '100.00', '39.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4971, '104847', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 15:00:59', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4972, '104841', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 14:17:13', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '100.00', '46.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4973, '104843', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 14:30:11', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4974, '104848', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 15:05:05', 'Paid', NULL, '170.00', '170.00', '170.00', NULL, '170.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4975, '104838', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 13:53:58', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '50.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(4966, '104839', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 13:57:28', 'Paid', NULL, '175.00', '175.00', '175.00', NULL, '175.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4967, '104836', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 13:23:17', 'Paid', NULL, '119.00', '119.00', '119.00', NULL, '119.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4965, '104835', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 13:04:56', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '100.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4964, '104831', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 11:44:10', 'Paid', NULL, '100.00', '100.00', '100.00', NULL, '100.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4963, '104829', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 11:10:38', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4962, '104830', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 11:23:42', 'Paid', NULL, '202.00', '202.00', '202.00', NULL, '202.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4961, '104832', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 11:57:42', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '110.00', '51.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4960, '104828', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 10:10:13', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4959, '104827', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 09:39:30', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4958, '104826', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 09:19:44', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4957, '104825', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 09:12:42', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4956, '104824', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-04 09:07:33', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '58.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480847042', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(5009, '104876', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 16:29:18', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480920160', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5010, '104877', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 17:03:48', 'Paid', NULL, '7.00', '6.30', '6.30', NULL, '10.00', '3.70', '0.00', '0.00', '0.70', '0.00', 'Cash', NULL, '27', '1480920160', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5011, '104878', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 17:55:39', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480920160', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5012, '104879', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 19:24:19', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480920160', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5013, '104880', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 19:38:09', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480920160', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5003, '104866', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 13:35:45', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480920160', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5004, '104873', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 14:47:56', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480920160', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5005, '104867', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 13:57:25', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480920160', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5006, '104868', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 13:59:26', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480920160', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5007, '104869', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 14:00:23', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480920160', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5002, '104871', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 14:40:25', 'Paid', NULL, '78.00', '78.00', '78.00', NULL, '100.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480920160', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5014, '104881', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 20:56:21', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '52.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480920160', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5008, '104872', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 14:42:46', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480920160', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5001, '104875', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 15:09:43', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '67.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480920160', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5000, '104870', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 14:38:14', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '59.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480920160', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4999, '104865', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 13:15:25', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480920160', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4998, '104875', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 14:59:01', 'Paid', NULL, '35.50', '35.50', '35.50', NULL, '50.00', '14.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480920160', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4997, '104863', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 12:41:24', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480920160', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4996, '104864', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 12:52:15', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480920160', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4995, '104862', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 12:40:59', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '20.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480920160', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4994, '104861', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 12:40:07', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480920160', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4993, '104860', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 11:48:07', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480920160', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(4992, '104859', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-05 09:50:35', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '100.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1480920160', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5034, '104901', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-07 20:40:05', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481093949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5033, '104900', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-07 19:55:08', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481093949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5032, '104899', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-07 19:16:49', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481093949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5031, '104898', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-07 17:56:27', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481093949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5030, '104897', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-07 16:36:01', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '54.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481093949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5029, '104895', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-07 15:42:09', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481093949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5027, '104893', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-07 14:19:20', 'Paid', NULL, '56.00', '50.40', '50.40', NULL, '50.40', '0.00', '0.00', '0.00', '5.60', '0.00', 'Cash', NULL, '27', '1481093949', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5028, '104894', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-07 14:34:23', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481093949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5025, '104891', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-07 13:56:04', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481093949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5026, '104896', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-07 16:03:24', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '100.00', '56.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481093949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5024, '104890', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-07 13:16:55', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481093949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5023, '104892', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-07 13:57:39', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481093949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5022, '104888', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-07 12:12:59', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481093949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5021, '104889', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-07 12:31:26', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481093949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5020, '104886', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-07 11:25:40', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481093949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5019, '104887', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-07 11:59:04', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481093949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5018, '104884', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-07 10:58:50', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481093949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5017, '104883', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-07 10:43:02', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481093949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5016, '104885', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-07 11:22:09', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1481093949', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5015, '104882', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-07 09:54:01', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481093949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5050, '104917', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-08 19:40:07', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481177360', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5049, '104915', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-08 18:06:53', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481177360', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5047, '104914', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-08 16:25:00', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481177360', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5048, '104916', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-08 18:26:25', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '100.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481177360', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5046, '104912', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-08 15:44:55', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481177360', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5045, '104913', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-08 15:53:04', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481177360', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5044, '104911', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-08 15:02:20', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481177360', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5042, '104907', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-08 12:51:13', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481177360', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5043, '104908', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-08 13:30:48', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481177360', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5041, '104910', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-08 13:32:09', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '54.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481177360', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5036, '104902', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-08 09:35:03', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '15.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481177360', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5040, '104909', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-08 13:31:03', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481177360', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5039, '104906', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-08 11:54:34', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481177360', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5038, '104904', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-08 10:39:40', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481177360', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5037, '104905', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-08 10:59:09', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '100.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481177360', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5035, '104903', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-08 10:12:40', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '50.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481177360', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5070, '104937', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-09 21:06:23', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481245064', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5069, '104935', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-09 20:35:44', 'Paid', NULL, '9.00', '8.10', '8.10', NULL, '8.10', '0.00', '0.00', '0.00', '0.90', '0.00', 'Cash', NULL, '27', '1481245064', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5068, '104936', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-09 20:56:57', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '30.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481245064', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5067, '104934', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-09 18:37:17', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481245064', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5066, '104933', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-09 18:08:44', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481245064', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5065, '104931', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-09 17:05:47', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481245064', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5064, '104932', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-09 17:11:07', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481245064', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5063, '104930', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-09 16:50:54', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481245064', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5061, '104927', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-09 15:03:04', 'Paid', NULL, '38.00', '34.20', '34.20', NULL, '50.00', '15.80', '0.00', '0.00', '3.80', '0.00', 'Cash', NULL, '27', '1481245064', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5062, '104928', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-09 15:38:03', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481245064', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5058, '104925', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-09 14:28:05', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481245064', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5059, '104926', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-09 14:36:18', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481245064', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5060, '104929', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-09 15:42:37', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '51.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481245064', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5057, '104924', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-09 13:34:01', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481245064', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5056, '104922', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-09 12:18:33', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '101.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481245064', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5055, '104923', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-09 12:35:27', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481245064', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5054, '104921', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-09 12:14:37', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481245064', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5053, '104920', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-09 11:45:48', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481245064', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5052, '104919', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-09 11:03:55', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '101.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481245064', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5051, '104918', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-09 09:16:07', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481245064', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5098, '104964', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 17:34:29', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5099, '104967', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 19:34:25', 'Paid', NULL, '101.00', '101.00', '101.00', NULL, '101.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5100, '104966', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 19:10:20', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5097, '104962', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 15:44:33', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5096, '104961', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 15:23:50', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '55.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5095, '104960', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 15:21:39', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5094, '104963', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 16:13:22', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '100.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5093, '104958', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 14:55:23', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5092, '104957', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 14:53:27', 'Paid', NULL, '35.50', '35.50', '35.50', NULL, '50.00', '14.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5089, '104956', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 14:51:45', 'Paid', NULL, '140.00', '140.00', '140.00', NULL, '140.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5090, '104965', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 18:34:25', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5091, '104959', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 15:07:18', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5088, '104955', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 13:09:49', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5087, '104954', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 12:26:33', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5086, '104952', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 12:08:15', 'Paid', NULL, '82.00', '82.00', '82.00', NULL, '100.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5085, '104951', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 11:44:47', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '59.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5084, '104950', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 11:01:14', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5078, '104944', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 09:52:55', 'Paid', NULL, '90.00', '90.00', '90.00', NULL, '90.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5079, '104943', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 09:49:13', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5080, '104945', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 09:56:15', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5082, '104948', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 10:12:58', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5083, '104953', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 12:24:19', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '58.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5081, '104947', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 10:09:39', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '100.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5077, '104941', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 09:38:42', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5076, '104940', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 09:37:22', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '40.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5075, '104939', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 09:35:57', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5074, '104949', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 10:30:03', 'Paid', NULL, '87.00', '87.00', '87.00', NULL, '100.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5073, '104946', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 10:04:44', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '100.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5072, '104942', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 09:39:54', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5071, '104938', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-10 09:06:28', 'Paid', NULL, '82.00', '82.00', '82.00', NULL, '82.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481358514', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5132, '104998', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 20:35:19', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '40.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5125, '104990', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 15:59:37', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5126, '104992', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 16:21:03', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5127, '104994', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 17:31:41', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5128, '104995', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 18:29:20', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5129, '104996', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 18:30:14', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5130, '104997', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 19:32:29', 'Paid', NULL, '82.00', '82.00', '82.00', NULL, '100.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5131, '104999', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 20:36:52', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '37.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5119, '104988', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 15:22:05', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '50.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5120, '104986', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 15:02:17', 'Paid', NULL, '73.00', '73.00', '73.00', NULL, '103.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5121, '104987', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 15:07:19', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5122, '104989', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 15:59:14', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5123, '104993', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 16:31:34', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5124, '104991', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 16:02:12', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5118, '104985', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 14:56:13', 'Paid', NULL, '60.00', '60.00', '0.00', '60.00', '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '0.67', 'VISA', '1.12', NULL, '0.04', '59.29', 0, NULL, NULL, NULL, NULL, '0'),
(5117, '104983', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 14:29:17', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5116, '104984', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 14:32:28', 'Paid', NULL, '67.00', '67.00', '0.00', '67.00', '67.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '0.75', 'VISA', '1.12', NULL, '0.05', '66.20', 0, NULL, NULL, NULL, NULL, '0'),
(5115, '104977', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 13:40:52', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5109, '104974', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 12:38:13', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '20.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5111, '104980', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 13:50:23', 'Paid', NULL, '117.00', '117.00', '117.00', NULL, '117.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5112, '104976', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 13:17:13', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5113, '104981', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 13:50:52', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '100.00', '57.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5114, '104979', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 13:46:03', 'Paid', NULL, '74.00', '74.00', '74.00', NULL, '74.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5110, '104982', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 14:21:25', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5108, '104978', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 13:45:15', 'Paid', NULL, '132.00', '118.80', '118.80', NULL, '120.00', '1.20', '0.00', '0.00', '13.20', '0.00', 'Cash', NULL, '27', '1481442972', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5107, '104973', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 12:28:48', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5106, '104971', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 11:47:28', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '50.00', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5105, '104972', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 11:54:18', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5104, '104975', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 13:01:23', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '100.00', '53.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5103, '104970', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 10:38:59', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5102, '104968', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 10:20:05', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '60.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5101, '104969', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-11 10:35:22', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481442972', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5179, '105043', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 21:03:25', 'Paid', NULL, '52.50', '52.50', '52.50', NULL, '60.00', '7.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5178, '105044', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 21:28:08', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5177, '105042', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 19:53:22', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '50.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5176, '105040', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 17:19:26', 'Paid', NULL, '72.00', '72.00', '72.00', NULL, '102.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5174, '105041', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 18:19:30', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '105.00', '63.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5173, '105037', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 16:24:54', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '21.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(5172, '105038', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 16:33:49', 'Paid', NULL, '73.00', '73.00', '73.00', NULL, '100.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5171, '105036', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 15:58:06', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '10.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5170, '105034', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 15:02:24', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5167, '105033', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 14:44:52', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '100.00', '52.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5168, '105032', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 14:35:26', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5169, '105035', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 15:05:23', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '30.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5165, '105028', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 13:51:34', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '0.00', '-34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5166, '105030', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 14:05:53', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '100.00', '68.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5163, '105021', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 12:47:20', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5157, '105026', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 13:18:54', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5158, '105031', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 14:09:29', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5159, '105017', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 12:42:17', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '100.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5160, '105018', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 12:46:11', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '25.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5161, '105019', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 12:46:44', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5162, '105020', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 12:47:03', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5149, '105008', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 11:40:16', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5150, '105022', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 12:49:14', 'Paid', NULL, '119.00', '119.00', '119.00', NULL, '120.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5151, '105010', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 11:47:57', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5152, '105011', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 11:48:55', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '59.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5153, '105013', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 12:12:27', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5154, '105012', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 11:54:22', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5155, '105024', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 13:06:15', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5156, '105025', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 13:16:13', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '55.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5164, '105027', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 13:35:06', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '70.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5140, '105006', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 11:20:39', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5147, '105039', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 16:44:40', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '100.00', '51.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5142, '105016', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 12:31:27', 'Paid', NULL, '79.00', '79.00', '0.00', '79.00', '79.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '0.88', 'VISA', '1.12', NULL, '0.05', '78.06', 0, NULL, NULL, NULL, NULL, '0'),
(5143, '105029', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 13:53:03', 'Paid', NULL, '96.00', '96.00', '96.00', NULL, '96.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5144, '105023', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 13:02:10', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '100.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5145, '105014', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 12:15:59', 'Paid', NULL, '144.00', '144.00', '144.00', NULL, '144.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5146, '105015', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 12:18:30', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5141, '105009', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 11:44:56', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5139, '105004', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 11:12:38', 'Paid', NULL, '51.00', '51.00', '0.00', '51.00', '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '0.92', 'Master Card', '1.80', NULL, '0.06', '50.03', 0, NULL, NULL, NULL, NULL, '0'),
(5138, '105003', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 10:59:50', 'Paid', NULL, '93.00', '93.00', '93.00', NULL, '100.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5137, '105005', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 11:15:20', 'Paid', NULL, '71.00', '71.00', '71.00', NULL, '71.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5136, '105007', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 11:26:40', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5135, '105002', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 10:59:02', 'Paid', NULL, '172.00', '172.00', '172.00', NULL, '172.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5134, '105000', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 10:12:27', 'Paid', NULL, '78.00', '78.00', '78.00', NULL, '100.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481549280', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5133, '105001', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-12 10:13:04', 'Paid', NULL, '54.00', '48.60', '48.60', NULL, '100.00', '51.40', '0.00', '0.00', '5.40', '0.00', 'Cash', NULL, '27', '1481549280', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5195, '105060', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-14 17:52:00', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481675417', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5196, '105061', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-14 20:18:19', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481675417', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5197, '105063', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-14 21:27:45', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '65.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481675417', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5198, '105062', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-14 20:52:51', 'Paid', NULL, '2.00', '2.00', '2.00', NULL, '2.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481675417', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5191, '105056', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-14 15:07:48', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '58.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481675417', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5192, '105057', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-14 15:17:40', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481675417', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5193, '105058', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-14 16:59:20', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '30.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481675417', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5194, '105059', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-14 17:48:59', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481675417', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5186, '105049', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-14 11:15:19', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481675417', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5187, '105052', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-14 11:59:45', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481675417', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5188, '105053', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-14 12:53:06', 'Paid', NULL, '245.00', '245.00', '245.00', NULL, '245.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481675417', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5189, '105055', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-14 13:42:55', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481675417', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5190, '105054', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-14 13:34:43', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481675417', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5185, '105048', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-14 10:55:06', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481675417', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5184, '105047', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-14 10:45:32', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481675417', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5183, '105046', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-14 10:15:38', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481675417', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5182, '105050', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-14 11:28:45', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '100.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481675417', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5181, '105051', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-14 11:55:25', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '37.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481675417', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5180, '105045', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-14 09:54:27', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '57.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481675417', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5211, '105076', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-15 19:28:30', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481780716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5212, '105078', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-15 21:07:33', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481780716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5213, '105080', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-15 22:07:16', 'Paid', NULL, '77.00', '77.00', '77.00', NULL, '77.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481780716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5214, '105079', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-15 21:16:32', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '100.00', '67.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481780716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5215, '105077', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-15 21:06:50', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481780716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5216, '105081', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-15 22:37:40', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '36.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481780716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5210, '105074', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-15 16:27:49', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481780716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5209, '105075', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-15 16:57:43', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481780716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5205, '105070', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-15 14:26:29', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481780716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5206, '105073', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-15 16:11:53', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481780716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5207, '105071', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-15 14:58:12', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481780716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5208, '105072', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-15 15:10:45', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '25.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481780716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5204, '105069', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-15 14:15:36', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481780716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5202, '105066', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-15 12:55:30', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481780716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5203, '105067', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-15 13:19:10', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '100.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481780716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5201, '105064', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-15 11:47:55', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481780716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5200, '105065', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-15 11:57:25', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '114.00', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481780716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5199, '105068', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-15 13:28:13', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '40.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481780716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5231, '105094', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-16 15:01:53', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '50.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481870880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5232, '105097', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-16 17:49:31', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481870880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5233, '105098', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-16 17:55:04', 'Paid', NULL, '82.00', '82.00', '82.00', NULL, '102.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481870880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5234, '105100', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-16 18:29:05', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481870880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5235, '105099', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-16 18:09:15', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481870880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5236, '105101', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-16 19:24:25', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481870880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5237, '105102', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-16 22:22:35', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481870880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5228, '105093', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-16 14:40:11', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481870880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5229, '105096', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-16 15:28:09', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '60.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481870880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5230, '105095', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-16 15:13:06', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481870880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5223, '105089', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-16 13:14:23', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481870880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5224, '105088', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-16 12:30:57', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481870880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5225, '105091', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-16 13:59:19', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481870880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5226, '105090', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-16 13:29:46', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '100.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481870880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5227, '105092', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-16 14:10:14', 'Paid', NULL, '39.00', '35.10', '35.10', NULL, '50.00', '14.90', '0.00', '0.00', '3.90', '0.00', 'Cash', NULL, '27', '1481870880', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5222, '105087', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-16 12:05:27', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481870880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5219, '105085', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-16 10:35:21', 'Paid', NULL, '99.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481870880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5220, '105084', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-16 10:25:45', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '100.00', '84.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481870880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5221, '105086', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-16 10:57:51', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481870880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5218, '105083', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-16 10:24:06', 'Paid', NULL, '109.00', '109.00', '109.00', NULL, '120.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481870880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5217, '105082', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-16 10:00:12', 'Paid', NULL, '81.00', '81.00', '81.00', NULL, '101.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481870880', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5271, '105137', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 22:12:19', 'Paid', NULL, '695.00', '695.00', '0.00', '695.00', '695.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '7.78', 'VISA', '1.12', NULL, '0.47', '686.75', 0, NULL, NULL, NULL, NULL, '0'),
(5272, '105134', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 20:06:19', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5267, '105132', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 19:50:26', 'Paid', NULL, '95.00', '95.00', '95.00', NULL, '100.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5266, '105130', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 18:58:28', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '100.00', '52.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5270, '105133', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 19:54:23', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5268, '105135', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 20:28:40', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '100.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5269, '105136', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 21:23:26', 'Paid', NULL, '263.00', '236.70', '236.70', NULL, '250.00', '13.30', '0.00', '0.00', '26.30', '0.00', 'Cash', NULL, '27', '1481980912', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5252, '105113', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 13:51:23', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '100.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5253, '105121', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 15:44:57', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '76.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5254, '105119', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 15:32:20', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5255, '105123', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 16:28:27', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '100.00', '65.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5256, '105118', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 15:30:02', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5257, '105120', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 15:44:31', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5258, '105122', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 15:56:21', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5259, '105126', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 17:38:09', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5260, '105124', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 17:12:35', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5261, '105125', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 17:34:37', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5262, '105127', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 17:41:34', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5263, '105129', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 18:28:59', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '100.00', '51.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5264, '105131', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 18:59:05', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5265, '105128', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 18:11:51', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5250, '105117', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 14:26:15', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5251, '105115', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 14:02:28', 'Paid', NULL, '56.00', '56.00', '0.00', '56.00', '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '1.01', 'Master Card', '1.80', NULL, '0.06', '54.93', 0, NULL, NULL, NULL, NULL, '0'),
(5249, '105114', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 13:55:27', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '50.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5243, '105110', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 11:35:48', 'Paid', NULL, '139.00', '139.00', '0.00', '139.00', '139.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '2.50', 'Master Card', '1.80', NULL, '0.15', '136.35', 0, NULL, NULL, NULL, NULL, '0'),
(5244, '105109', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 11:31:09', 'Paid', NULL, '100.00', '100.00', '100.00', NULL, '100.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5245, '105106', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 10:28:31', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5246, '105116', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 14:18:41', 'Paid', NULL, '65.00', '58.50', '58.50', NULL, '100.00', '41.50', '0.00', '0.00', '6.50', '0.00', 'Cash', NULL, '27', '1481980912', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5247, '105112', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 13:32:35', 'Paid', NULL, '105.00', '105.00', '105.00', NULL, '105.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5248, '105111', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 12:23:26', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '50.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5242, '105108', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 11:05:32', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5241, '105105', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 10:23:46', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5240, '105104', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 10:21:51', 'Paid', NULL, '109.00', '109.00', '109.00', NULL, '110.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5239, '105107', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 10:41:10', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '30.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5238, '105103', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-17 09:45:40', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1481980912', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5312, '105174', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 20:28:39', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5311, '105176', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 20:58:34', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '50.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5310, '105173', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 20:24:43', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5309, '105175', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 20:31:43', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '101.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5308, '105177', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 21:11:00', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5305, '105170', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 17:41:41', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5306, '105171', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 17:49:04', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '40.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5307, '105172', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 18:26:59', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5302, '105169', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 16:43:47', 'Paid', NULL, '96.00', '96.00', '96.00', NULL, '96.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5303, '105165', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 15:52:10', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '102.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5304, '105167', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 16:09:59', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5301, '105164', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 15:50:17', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5300, '105166', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 16:00:12', 'Paid', NULL, '114.50', '114.50', '114.50', NULL, '120.00', '5.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5299, '105168', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 16:21:14', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5281, '105141', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 10:15:12', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '50.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(5282, '105148', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 11:16:16', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5283, '105150', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 11:39:30', 'Paid', NULL, '62.00', '62.00', '0.00', '62.00', '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '0.69', 'VISA', '1.12', NULL, '0.04', '61.26', 0, NULL, NULL, NULL, NULL, '0'),
(5284, '105147', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 11:10:20', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5285, '105153', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 12:01:21', 'Paid', NULL, '80.00', '80.00', '80.00', NULL, '80.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5286, '105149', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 11:31:20', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5287, '105154', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 12:11:12', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5288, '105155', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 12:24:03', 'Paid', NULL, '137.00', '137.00', '137.00', NULL, '137.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5289, '105151', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 11:54:57', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5290, '105152', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 11:57:58', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5291, '105156', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 13:23:48', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5292, '105159', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 14:39:57', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5293, '105157', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 14:02:57', 'Paid', NULL, '73.00', '73.00', '73.00', NULL, '100.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5294, '105160', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 14:44:50', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5278, '105146', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 11:04:47', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '65.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5298, '105163', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 15:42:54', 'Paid', NULL, '80.00', '80.00', '80.00', NULL, '80.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5297, '105161', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 15:02:23', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5295, '105158', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 14:12:15', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '50.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5296, '105162', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 15:28:55', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5280, '105145', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 10:59:43', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '100.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5279, '105144', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 10:50:50', 'Paid', NULL, '95.00', '95.00', '95.00', NULL, '95.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5277, '105143', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 10:48:52', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5276, '105142', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 10:19:49', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5275, '105140', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 10:07:37', 'Paid', NULL, '96.00', '96.00', '96.00', NULL, '100.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5274, '105139', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 09:44:40', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '59.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5273, '105138', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-18 09:30:06', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482047063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5340, '105204', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 19:33:19', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5320, '105183', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 11:44:15', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5321, '105184', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 11:46:50', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5322, '105186', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 12:02:55', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5323, '105189', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 13:23:45', 'Paid', NULL, '83.00', '83.00', '83.00', NULL, '100.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5324, '105190', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 13:50:54', 'Paid', NULL, '77.00', '77.00', '77.00', NULL, '77.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5325, '105187', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 12:54:32', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5326, '105188', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 13:13:36', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5327, '105191', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 14:04:49', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '100.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5332, '105194', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 14:15:54', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5329, '105196', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 14:51:55', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5330, '105192', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 14:09:48', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '50.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5331, '105193', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 14:10:25', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5333, '105197', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 14:52:16', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5334, '105198', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 15:43:30', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5335, '105201', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 17:58:21', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5336, '105199', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 16:02:26', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5337, '105200', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 17:29:20', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5338, '105202', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 18:02:08', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5339, '105203', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 18:28:27', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5318, '105195', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 14:37:57', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5319, '105182', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 11:37:13', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '53.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5317, '105185', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 12:02:10', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5316, '105180', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 10:08:13', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5315, '105179', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 10:05:35', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5314, '105178', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 09:57:01', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5313, '105181', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-19 11:20:40', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '100.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482143290', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5346, '105209', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-21 11:10:43', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482289636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5347, '105212', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-21 11:19:46', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482289636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5348, '105216', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-21 12:20:32', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '100.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482289636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5349, '105210', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-21 11:14:54', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482289636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5350, '105213', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-21 11:26:36', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482289636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5351, '105214', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-21 11:40:08', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '100.00', '68.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482289636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5352, '105215', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-21 11:55:29', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482289636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5353, '105218', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-21 12:33:15', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482289636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5354, '105221', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-21 15:22:58', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482289636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5355, '105217', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-21 12:32:12', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482289636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5356, '105222', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-21 15:31:26', 'Paid', NULL, '123.00', '123.00', '123.00', NULL, '123.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482289636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5357, '105219', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-21 14:01:01', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '100.00', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482289636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5358, '105220', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-21 14:33:39', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '50.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482289636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5359, '105223', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-21 15:38:11', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482289636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5360, '105224', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-21 18:19:43', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482289636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5345, '105207', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-21 10:26:03', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '50.00', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482289636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5344, '105208', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-21 10:57:43', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482289636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5343, '105211', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-21 11:16:20', 'Paid', NULL, '91.00', '91.00', '91.00', NULL, '91.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482289636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5342, '105206', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-21 10:19:06', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482289636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5341, '105205', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-21 09:07:37', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '60.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482289636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5380, '105241', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-22 19:49:15', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482406639', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5379, '105240', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-22 19:47:02', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482406639', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5378, '105242', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-22 20:11:32', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482406639', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5377, '105239', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-22 19:33:00', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482406639', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5376, '105238', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-22 17:46:56', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482406639', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5375, '105243', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-12-22 21:00:50', 'Paid', NULL, '253.30', '253.30', '253.30', NULL, '254.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482406639', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5366, '105229', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-22 11:28:17', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '50.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482406639', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5368, '105231', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-22 14:05:41', 'Paid', NULL, '85.00', '85.00', '85.00', NULL, '100.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482406639', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5369, '105232', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-22 14:23:30', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '100.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482406639', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5370, '105233', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-22 15:23:01', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482406639', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5371, '105236', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-22 16:50:41', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '100.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482406639', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5372, '105237', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-22 16:53:44', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482406639', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5373, '105234', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-22 16:34:18', 'Paid', NULL, '4.00', '4.00', '4.00', NULL, '4.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482406639', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5374, '105235', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-22 16:46:03', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482406639', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5365, '105230', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-22 11:36:48', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482406639', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5364, '105227', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-22 10:47:11', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482406639', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5363, '105225', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-22 10:14:00', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '40.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482406639', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5362, '105228', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-22 10:57:13', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '100.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482406639', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5361, '105226', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-22 10:40:34', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '30.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482406639', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5424, '105285', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 19:50:08', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5425, '105287', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 20:16:47', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5423, '105283', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 18:53:18', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5422, '105286', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 20:05:14', 'Paid', NULL, '128.00', '128.00', '128.00', NULL, '128.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5421, '105284', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 19:23:15', 'Paid', NULL, '217.60', '217.60', '0.00', '217.60', '217.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '3.92', 'Master Card', '1.80', NULL, '0.24', '213.45', 0, NULL, NULL, NULL, NULL, '0'),
(5420, '105282', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 18:47:07', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '100.00', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5419, '105280', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 17:17:49', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5418, '105281', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 18:07:55', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5417, '105279', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 16:33:47', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5416, '105278', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 16:20:09', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5415, '105276', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 16:16:06', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5408, '105271', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 14:36:32', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5409, '105269', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 14:30:11', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5410, '105270', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 14:34:00', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5411, '105277', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 16:19:06', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5412, '105273', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 15:19:55', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5413, '105274', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 15:32:14', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5414, '105275', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 16:06:10', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '55.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5407, '105266', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 13:58:59', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5406, '105265', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 13:58:36', 'Paid', NULL, NULL, '0.00', '0.00', NULL, '0.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5405, '105267', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 14:04:20', 'Paid', NULL, '122.00', '122.00', '122.00', NULL, '125.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5404, '105264', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 13:47:06', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5403, '105263', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 13:45:55', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5402, '105261', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 13:32:34', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5401, '105260', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 13:11:15', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5395, '105254', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 13:06:50', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5396, '105255', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 13:07:25', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5397, '105256', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 13:08:44', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5398, '105257', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 13:09:20', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5399, '105258', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 13:10:20', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5400, '105259', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 13:10:50', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5387, '105248', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 12:03:39', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5394, '105253', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 13:06:05', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5393, '105268', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 14:10:57', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '100.00', '73.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5392, '105272', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 14:57:13', 'Paid', NULL, '110.00', '110.00', '110.00', NULL, '110.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5391, '105262', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 13:35:26', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5390, '105250', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 12:20:19', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5389, '105249', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 12:19:56', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5388, '105252', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 12:41:07', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5386, '105247', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 11:59:46', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5385, '105251', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 12:25:05', 'Paid', NULL, '114.00', '114.00', '114.00', NULL, '150.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5384, '105246', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 11:11:00', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5383, '105245', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 10:43:09', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '21.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5381, '105244', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-23 09:54:03', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '100.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482491589', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5477, '105337', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 21:40:17', 'Paid', NULL, '78.80', '78.80', '78.80', NULL, '100.00', '21.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5475, '105336', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 21:20:03', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5476, '105334', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 20:36:04', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5474, '105338', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 21:43:34', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5473, '105333', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 20:25:26', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '69.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5472, '105335', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 20:36:23', 'Paid', NULL, '55.80', '55.80', '55.80', NULL, '100.00', '44.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5471, '105326', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 19:20:00', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '50.00', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5468, '105330', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 20:04:08', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5469, '105327', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 19:28:32', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5470, '105332', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 20:13:33', 'Paid', NULL, '100.80', '100.80', '100.80', NULL, '101.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5467, '105328', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 19:42:02', 'Paid', NULL, '162.50', '146.25', '146.25', NULL, '200.25', '54.00', '0.00', '0.00', '16.25', '0.00', 'Cash', NULL, '27', '1482580080', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5466, '105329', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 19:42:37', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(5465, '105325', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 18:42:12', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5464, '105324', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 18:10:22', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5463, '105322', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 17:47:06', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5462, '105331', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 20:07:12', 'Paid', NULL, '134.80', '134.80', '134.80', NULL, '150.00', '15.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5461, '105321', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 17:26:06', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5457, '105318', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 16:23:46', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5458, '105319', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 16:29:15', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5459, '105320', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 16:42:11', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5460, '105323', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 18:06:45', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5436, '105296', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 11:19:27', 'Paid', NULL, '136.00', '136.00', '136.00', NULL, '150.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5437, '105301', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 11:57:51', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5438, '105295', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 11:05:03', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5439, '105303', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 12:48:56', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5440, '105299', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 11:56:47', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5441, '105300', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 11:57:37', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5442, '105302', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 12:35:14', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5443, '105305', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 13:18:27', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5445, '105304', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 13:07:10', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5446, '105311', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 14:45:09', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5447, '105306', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 14:12:16', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5448, '105308', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 14:18:27', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5449, '105316', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 15:56:01', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '70.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5450, '105309', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 14:31:01', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5452, '105310', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 14:38:43', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5453, '105313', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 15:22:13', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5454, '105314', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 15:40:50', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5455, '105315', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 15:53:11', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5456, '105317', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 16:22:23', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5444, '105307', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 14:13:21', 'Paid', NULL, '94.00', '94.00', '94.00', NULL, '100.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5435, '105297', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 11:19:54', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '60.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5434, '105298', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 11:21:01', 'Paid', NULL, '192.00', '192.00', '192.00', NULL, '202.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5433, '105294', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 10:36:50', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '59.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5431, '105293', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 09:18:09', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5432, '105312', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 15:18:50', 'Paid', NULL, '117.00', '117.00', '117.00', NULL, '117.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5430, '105292', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 09:12:56', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5429, '105291', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 09:10:21', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5428, '105290', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 09:09:43', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5427, '105289', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 09:08:26', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5426, '105288', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-24 09:05:46', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482580080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5539, '105397', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 19:36:36', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5540, '105400', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 20:57:16', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5536, '105394', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 19:00:45', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5537, '105395', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 19:01:13', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5538, '105399', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 20:27:37', 'Paid', NULL, '93.90', '93.90', '93.90', NULL, '100.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5534, '105398', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 19:50:00', 'Paid', NULL, '116.80', '116.80', '116.80', NULL, '116.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5535, '105396', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 19:20:43', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5532, '105391', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 18:36:18', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5533, '105393', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 18:46:10', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5531, '105390', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 18:18:02', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5525, '105387', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 17:59:57', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '100.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5528, '105392', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 18:45:34', 'Paid', NULL, '58.90', '58.90', '58.90', NULL, '60.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5529, '105384', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 17:40:30', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5530, '105389', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 18:12:35', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5527, '105383', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 17:38:34', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5526, '105388', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 18:10:24', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5520, '105382', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 17:20:49', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5521, '105378', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 16:09:39', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5522, '105380', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 16:42:58', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5523, '105379', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 16:40:27', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5524, '105381', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 16:56:41', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5519, '105377', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 16:00:38', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5518, '105376', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 15:51:58', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5517, '105386', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 17:56:17', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5516, '105373', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 15:21:43', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5515, '105385', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 17:45:40', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5514, '105374', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 15:34:53', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '100.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5513, '105368', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 13:52:31', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5509, '105369', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 14:01:07', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5510, '105372', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 14:16:56', 'Paid', NULL, '117.00', '117.00', '117.00', NULL, '150.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5511, '105367', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 13:37:09', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5512, '105371', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 14:11:51', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5507, '105375', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 15:37:43', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5508, '105366', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 13:35:32', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5501, '105355', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 11:45:12', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5486, '105345', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 10:58:08', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5487, '105346', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 11:06:42', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5488, '105349', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 11:15:49', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5489, '105348', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 11:15:17', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5490, '105350', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 11:29:45', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5492, '105344', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 10:57:30', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5493, '105356', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 11:45:39', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5494, '105362', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 12:37:36', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5495, '105358', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 12:23:20', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5496, '105360', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 12:29:49', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5497, '105352', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 11:40:45', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5498, '105359', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 12:27:41', 'Paid', NULL, '70.00', '70.00', '70.00', NULL, '70.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5499, '105353', 'T14(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 11:42:41', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5500, '105354', 'T14(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 11:43:08', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '100.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5502, '105363', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 12:46:08', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5503, '105365', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 13:31:33', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5504, '105361', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 12:33:05', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5505, '105364', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 13:00:32', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5506, '105370', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 14:03:50', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5491, '105357', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 11:53:10', 'Paid', NULL, '99.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5483, '105342', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 10:54:48', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5484, '105343', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 10:55:34', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5482, '105347', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 11:07:38', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5481, '105351', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 11:34:46', 'Paid', NULL, '70.00', '70.00', '70.00', NULL, '100.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5480, '105341', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 10:42:43', 'Paid', NULL, '117.00', '117.00', '117.00', NULL, '150.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5479, '105339', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 09:52:39', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5478, '105340', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-25 10:11:10', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482665607', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5589, '105448', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 18:39:14', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5590, '105449', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 19:31:39', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5591, '105450', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 20:32:39', 'Paid', NULL, '63.90', '63.90', '63.90', NULL, '100.00', '36.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5578, '105443', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 16:05:14', 'Paid', NULL, '96.00', '96.00', '96.00', NULL, '100.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5579, '105432', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 14:41:18', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5580, '105435', 'T1(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 15:03:43', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5581, '105437', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 15:13:29', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5582, '105442', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 15:53:25', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5583, '105439', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 15:36:27', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5584, '105440', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 15:36:48', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5585, '105441', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 15:37:41', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5586, '105445', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 16:24:11', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5587, '105444', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 16:17:17', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5588, '105447', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 18:23:20', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '58.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5577, '105446', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 17:51:47', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5576, '105430', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 14:23:01', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '54.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5575, '105429', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 14:20:42', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5570, '105427', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 14:12:05', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '0.00', '-20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5571, '105436', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 15:12:53', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5572, '105424', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 14:07:12', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5574, '105428', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 14:14:26', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '59.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5573, '105433', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 14:48:42', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5557, '105410', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 12:05:01', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '100.00', '63.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5558, '105411', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 12:06:05', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5559, '105412', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 12:07:36', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '70.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5560, '105413', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 12:08:26', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5561, '105414', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 12:08:42', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5563, '105422', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 13:15:51', 'Paid', NULL, '200.00', '200.00', '200.00', NULL, '200.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5564, '105434', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 14:59:26', 'Paid', NULL, '200.00', '200.00', '200.00', NULL, '200.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5565, '105425', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 14:07:33', 'Paid', NULL, '84.00', '84.00', '84.00', NULL, '100.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5566, '105431', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 14:27:44', 'Paid', NULL, '162.00', '162.00', '162.00', NULL, '162.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5567, '105426', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 14:10:54', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '37.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5568, '105423', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 13:38:35', 'Paid', NULL, '86.00', '86.00', '86.00', NULL, '100.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5569, '105438', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 15:15:24', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5555, '105419', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 12:51:35', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5556, '105418', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 12:37:59', 'Paid', NULL, '104.00', '104.00', '104.00', NULL, '104.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5554, '105417', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 12:21:31', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5553, '105415', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 12:14:06', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '60.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5552, '105416', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 12:20:21', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '100.00', '57.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5551, '105409', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 11:59:41', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5550, '105420', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 12:52:21', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5562, '105421', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 13:00:37', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '100.00', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5549, '105407', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 11:21:10', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5546, '105405', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 10:53:32', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '50.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5547, '105406', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 11:04:30', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '100.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5545, '105404', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 10:43:44', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(5544, '105408', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 11:24:29', 'Paid', NULL, '244.00', '244.00', '244.00', NULL, '244.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5543, '105403', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 10:32:10', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5542, '105401', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 10:27:15', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5541, '105402', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-26 10:31:07', 'Paid', NULL, '71.00', '71.00', '71.00', NULL, '71.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482732853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5619, '105479', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 18:03:06', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5620, '105477', 'T5(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 17:41:26', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5621, '105478', 'T5(S)', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 17:41:42', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5624, '105482', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 19:36:05', 'Paid', NULL, '50.50', '50.50', '50.50', NULL, '50.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5613, '105470', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 15:17:19', 'Paid', NULL, '74.00', '74.00', '74.00', NULL, '100.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5614, '105471', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 15:22:04', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5615, '105476', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 16:28:53', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5616, '105473', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 15:34:51', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '51.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5617, '105475', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 16:27:53', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5622, '105480', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 18:04:12', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5623, '105481', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 18:33:21', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '50.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5602, '105457', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 12:58:34', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5603, '105459', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 13:04:13', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5604, '105458', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 12:59:14', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5605, '105464', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 13:55:02', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5606, '105465', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 13:59:21', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5607, '105467', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 14:34:48', 'Paid', NULL, '82.00', '82.00', '82.00', NULL, '82.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5609, '105466', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 14:27:15', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5610, '105472', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 15:23:06', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '38.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5611, '105474', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 15:43:07', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5612, '105469', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 15:12:25', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5608, '105468', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 14:40:15', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5600, '105462', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 13:47:44', 'Paid', NULL, '141.00', '141.00', '141.00', NULL, '141.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5601, '105461', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 13:30:46', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '76.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5598, '105463', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 13:49:55', 'Paid', NULL, '15.00', '13.50', '13.50', NULL, '50.00', '36.50', '0.00', '0.00', '1.50', '0.00', 'Cash', NULL, '27', '1482920800', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5597, '105460', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 13:04:46', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5599, '105456', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 12:40:08', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5596, '105455', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 11:30:04', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5595, '105454', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 11:11:45', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5594, '105453', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 10:47:12', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5593, '105452', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 09:55:09', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5592, '105451', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-28 09:50:33', 'Paid', NULL, '100.00', '100.00', '100.00', NULL, '100.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482920800', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5636, '105500', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-29 14:41:27', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482980530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5637, '105493', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-29 13:13:30', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482980530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5638, '105496', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-12-29 13:49:49', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '40.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482980530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5639, '105498', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-29 14:14:08', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482980530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5640, '105494', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-29 13:23:16', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482980530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5641, '105495', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-29 13:46:08', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482980530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5642, '105497', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-29 13:51:05', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482980530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5643, '105501', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-29 14:43:35', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '53.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482980530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5644, '105502', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-29 17:17:03', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482980530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5645, '105503', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-29 19:10:07', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '37.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482980530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5634, '105487', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-29 11:28:16', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482980530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5630, '105486', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-29 11:26:34', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482980530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5631, '105489', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-29 11:37:49', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482980530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5635, '105499', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-29 14:40:21', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482980530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5633, '105491', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-29 11:51:57', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482980530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5632, '105492', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-29 12:55:11', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482980530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5629, '105490', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-29 11:48:48', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482980530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5628, '105485', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-29 11:08:53', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '51.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482980530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5627, '105484', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-29 11:06:05', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482980530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5626, '105488', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-29 11:35:55', 'Paid', NULL, '104.00', '104.00', '104.00', NULL, '104.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482980530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5625, '105483', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-29 10:32:39', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1482980530', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5675, '105529', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 16:49:23', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5676, '105531', 'T11', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 16:51:22', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5677, '105532', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 16:52:49', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5678, '105534', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 16:59:46', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5679, '105535', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 17:08:29', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5680, '105537', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 17:25:18', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '100.00', '60.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5681, '105538', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 17:54:39', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '20.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5682, '105539', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 17:56:45', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5683, '105540', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 19:47:44', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5684, '105541', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 21:22:54', 'Paid', NULL, '85.00', '85.00', '85.00', NULL, '100.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5685, '105543', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 21:55:46', 'Paid', NULL, '113.00', '113.00', '113.00', NULL, '113.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5686, '105542', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 21:26:07', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5668, '105525', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 16:28:23', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '70.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5669, '105522', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 16:22:47', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5670, '105521', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 16:22:28', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5671, '105526', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 16:39:34', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '30.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5672, '105527', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 16:40:11', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5673, '105528', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 16:47:10', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '100.00', '60.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5674, '105536', 'T12', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 17:11:49', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5665, '105524', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 16:26:53', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '36.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5666, '105530', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 16:50:47', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '36.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5667, '105533', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 16:58:50', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5651, '105508', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 10:47:04', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '100.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5652, '105512', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 11:21:14', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5653, '105509', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 10:49:34', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5654, '105513', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 11:45:34', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '100.00', '47.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5655, '105511', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 11:00:41', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5656, '105514', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 11:47:25', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '50.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5657, '105515', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 11:49:24', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5658, '105516', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 11:51:18', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5659, '105518', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 12:21:45', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '100.00', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5660, '105519', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 12:45:29', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5661, '105517', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 12:06:33', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5664, '105523', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 16:25:01', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5663, '105520', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 13:59:36', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '20.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5650, '105507', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 10:31:14', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5649, '105505', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 10:03:20', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5648, '105506', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 10:14:07', 'Paid', NULL, '23.50', '23.50', '23.50', NULL, '23.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5647, '105510', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 10:55:17', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5646, '105504', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-30 09:36:24', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '100.00', '46.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483066124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5747, '105600', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 00:09:21', 'Paid', NULL, '80.00', '80.00', '80.00', NULL, '80.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5744, '105596', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 21:53:02', 'Paid', NULL, '49.90', '49.90', '49.90', NULL, '50.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5745, '105597', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 22:06:49', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5746, '105598', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 22:34:13', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5742, '105595', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 21:33:10', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5741, '105599', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 22:55:16', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5740, '105594', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 21:16:32', 'Paid', NULL, '10.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1483188930', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5739, '105593', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 21:03:46', 'Paid', NULL, '6.30', '6.30', '6.30', NULL, '10.00', '3.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5738, '105592', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 20:54:28', 'Paid', NULL, '49.90', '49.90', '49.90', NULL, '49.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5733, '105588', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 20:32:47', 'Paid', NULL, '13.50', '13.50', '13.50', NULL, '50.00', '36.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5735, '105589', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 20:51:42', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5736, '105590', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 20:52:04', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5732, '105587', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 19:47:36', 'Paid', NULL, '59.90', '59.90', '59.90', NULL, '100.00', '40.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5737, '105591', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 20:52:17', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5731, '105586', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 19:47:15', 'Paid', NULL, '49.90', '49.90', '49.90', NULL, '49.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5730, '105585', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 19:44:00', 'Paid', NULL, '25.50', '25.50', '25.50', NULL, '25.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5729, '105584', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 19:20:23', 'Paid', NULL, '49.90', '49.90', '49.90', NULL, '49.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5727, '105582', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 19:18:36', 'Paid', NULL, '49.90', '49.90', '49.90', NULL, '49.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5726, '105581', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 18:30:28', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5728, '105583', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 19:19:42', 'Paid', NULL, '49.90', '49.90', '49.90', NULL, '49.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5723, '105574', 'T0', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 14:32:57', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5722, '105580', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 15:03:53', 'Paid', NULL, '71.00', '71.00', '71.00', NULL, '101.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5721, '105569', 'T9', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 14:12:02', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '50.00', '47.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5720, '105578', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 14:59:52', 'Paid', NULL, '70.00', '70.00', '70.00', NULL, '100.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5719, '105576', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 14:38:31', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5718, '105573', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 14:29:41', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '50.00', '39.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5717, '105575', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 14:37:42', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5716, '105577', '4', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 14:58:51', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '56.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5715, '105571', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 14:20:44', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '55.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5707, '105564', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 12:45:57', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5708, '105565', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 12:53:32', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5709, '105567', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 13:28:42', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5710, '105568', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 14:04:49', 'Paid', NULL, '99.00', '99.00', '99.00', NULL, '99.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5711, '105579', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 15:01:46', 'Paid', NULL, '97.00', '97.00', '97.00', NULL, '97.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5712, '105566', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 13:27:12', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5713, '105570', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 14:17:30', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5714, '105572', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 14:23:27', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5695, '105554', 'T2', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 11:33:06', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '76.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5696, '105561', 'T1', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 12:15:47', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '67.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5697, '105551', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 11:17:36', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '101.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5693, '105549', 'T5', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 11:03:11', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5694, '105546', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 10:21:35', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5692, '105550', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 11:13:30', 'Paid', NULL, '72.00', '72.00', '72.00', NULL, '100.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5706, '105558', 'IS', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 12:01:33', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5705, '105557', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 11:59:25', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '20.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5704, '105559', 'T8', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 12:06:37', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '37.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5703, '105562', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 12:20:39', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5702, '105560', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 12:12:18', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '70.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5701, '105563', 'T3', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 12:24:12', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5700, '105556', 'T15', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 11:49:51', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '106.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(5699, '105555', 'T14', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 11:37:17', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5698, '105553', 'T13', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 11:26:18', 'Paid', NULL, '84.00', '84.00', '84.00', NULL, '100.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5690, '105547', 'T7', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 10:28:24', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5691, '105548', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 10:54:41', 'Paid', NULL, '72.00', '72.00', '72.00', NULL, '100.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5689, '105545', 'T4', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 09:38:25', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5688, '105552', 'T6', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 11:19:44', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5687, '105544', 'T10', 10003, 'admin', NULL, NULL, 'history', '2016-12-31 09:04:36', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483188930', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5789, '105641', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 20:52:24', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5788, '105640', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 20:33:40', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5787, '105636', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 19:54:19', 'Paid', NULL, '53.50', '53.50', '53.50', NULL, '54.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5786, '105638', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 20:16:17', 'Paid', NULL, '71.00', '71.00', '0.00', '71.00', '71.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '0.80', 'VISA', '1.12', NULL, '0.05', '70.16', 0, NULL, NULL, NULL, NULL, '0'),
(5785, '105639', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 20:26:52', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5784, '105637', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 19:56:35', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '100.00', '51.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5783, '105633', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 17:56:09', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5782, '105631', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 16:33:51', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5781, '105634', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 18:01:51', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5780, '105630', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 16:10:49', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5779, '105629', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 16:10:24', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5776, '105626', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 15:24:18', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5777, '105627', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 15:26:40', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5778, '105628', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 15:59:44', 'Paid', NULL, '92.00', '92.00', '92.00', NULL, '92.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5760, '105611', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 12:50:24', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '69.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5761, '105613', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 13:26:31', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5762, '105614', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 13:55:20', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '59.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5763, '105615', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 14:05:41', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '65.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5764, '105616', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 14:07:51', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '100.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5765, '105621', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 15:02:43', 'Paid', NULL, '241.50', '241.50', '241.50', NULL, '241.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5766, '105632', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 16:53:16', 'Paid', NULL, '120.00', '120.00', '120.00', NULL, '120.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5767, '105619', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 14:56:08', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '50.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5768, '105617', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 14:34:57', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5769, '105620', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 14:57:58', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5775, '105624', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 15:19:08', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5774, '105635', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 18:06:24', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5773, '105623', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 15:13:22', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5772, '105625', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 15:23:07', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5770, '105622', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 15:07:57', 'Paid', NULL, '150.00', '150.00', '150.00', NULL, '150.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5771, '105618', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 14:54:34', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5758, '105610', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 12:34:54', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5759, '105606', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 12:01:35', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5754, '105607', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 12:04:23', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5755, '105604', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 11:33:15', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5756, '105609', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 12:08:48', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '60.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5757, '105612', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 12:57:34', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '58.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5753, '105605', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 11:37:49', 'Paid', NULL, '89.00', '89.00', '89.00', NULL, '100.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5752, '105608', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 12:08:05', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5750, '105602', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 11:09:07', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '100.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5749, '105601', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 10:12:43', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5748, '105603', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-01 11:10:34', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483255690', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5841, '105692', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 20:30:01', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5840, '105689', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 19:48:39', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5834, '105684', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 18:09:28', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5835, '105688', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 19:28:28', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5836, '105690', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 19:58:11', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5837, '105685', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 19:06:31', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5838, '105686', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 19:07:57', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5839, '105687', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 19:25:50', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5833, '105691', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 20:24:56', 'Paid', NULL, '92.00', '92.00', '92.00', NULL, '102.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5831, '105681', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 17:26:06', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5832, '105682', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 17:31:47', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5830, '105679', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 17:12:33', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5828, '105680', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 17:13:04', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5829, '105678', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 17:00:14', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '21.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5827, '105677', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 16:47:57', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5826, '105683', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 17:58:44', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5825, '105676', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 16:06:01', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5824, '105675', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 15:40:54', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '53.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5821, '105670', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 14:11:29', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5823, '105672', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 14:49:54', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5822, '105673', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 15:07:05', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5820, '105674', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 15:27:42', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5806, '105661', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 11:55:03', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5807, '105655', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 11:23:35', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5808, '105663', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 12:11:24', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5809, '105656', 'T1(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 11:31:12', 'Paid', NULL, '80.00', '80.00', '80.00', NULL, '100.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5810, '105657', 'T1(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 11:31:33', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '54.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5812, '105659', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 11:47:05', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '37.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5813, '105664', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 12:41:24', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5814, '105662', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 12:02:40', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5815, '105671', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 14:30:16', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '51.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5816, '105669', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 14:10:06', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '100.00', '60.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5817, '105666', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 13:34:37', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5818, '105665', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 13:21:37', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5819, '105668', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 13:44:23', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5805, '105660', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 11:47:53', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5804, '105652', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 10:49:39', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5802, '105650', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 10:48:19', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '53.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5803, '105651', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 10:48:53', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5801, '105649', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 10:45:56', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5795, '105667', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 13:40:57', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '71.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5796, '105654', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 11:12:23', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5811, '105658', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 11:32:49', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5798, '105648', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 10:45:37', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5799, '105646', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 10:43:31', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5800, '105647', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 10:44:36', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5794, '105645', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 10:40:39', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5793, '105653', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 11:05:14', 'Paid', NULL, '78.00', '78.00', '78.00', NULL, '100.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5792, '105644', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 10:17:25', 'Paid', NULL, '151.00', '151.00', '151.00', NULL, '151.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5791, '105642', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 09:11:23', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5790, '105643', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-02 10:06:14', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483337473', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5877, '105727', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 19:44:40', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5874, '105724', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 17:22:53', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5875, '105725', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 17:27:07', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5876, '105726', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 18:26:37', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5873, '105723', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 17:21:42', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '56.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5867, '105716', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 15:05:06', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5868, '105718', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 15:38:34', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5869, '105717', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 15:18:58', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5870, '105719', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 15:46:54', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5871, '105722', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 17:14:08', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5872, '105720', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 16:44:55', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5854, '105700', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 10:39:53', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5855, '105701', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 10:42:54', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5856, '105708', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 11:46:52', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5857, '105702', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 10:43:31', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5858, '105709', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 11:58:41', 'Paid', NULL, '106.00', '106.00', '106.00', NULL, '106.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5859, '105707', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 11:40:05', 'Paid', NULL, '173.00', '173.00', '173.00', NULL, '200.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5860, '105706', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 11:35:18', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5861, '105711', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 12:33:19', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5862, '105714', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 13:32:30', 'Paid', NULL, '119.00', '119.00', '119.00', NULL, '119.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5866, '105715', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 14:04:12', 'Paid', NULL, '48.50', '48.50', '48.50', NULL, '50.00', '1.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5864, '105721', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 16:57:30', 'Paid', NULL, '45.50', '45.50', '45.50', NULL, '50.00', '4.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5865, '105712', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 13:10:49', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5850, '105704', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 11:03:39', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5853, '105699', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 10:37:53', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5848, '105705', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 11:34:14', 'Paid', NULL, '71.00', '71.00', '71.00', NULL, '101.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5849, '105703', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 10:59:15', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5863, '105713', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 13:17:50', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5852, '105698', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 10:35:22', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '100.00', '85.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5851, '105697', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 10:35:00', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5846, '105710', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 12:31:54', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5845, '105695', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 09:38:10', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5843, '105694', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 09:16:21', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '20.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5844, '105696', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 09:49:32', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '70.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5842, '105693', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-04 09:11:26', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483509082', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5903, '105752', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 17:47:57', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5888, '105738', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 12:24:49', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5905, '105755', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 18:47:26', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5904, '105754', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 18:36:07', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5893, '105741', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 13:39:58', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5894, '105743', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 14:20:50', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5895, '105746', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 15:08:32', 'Paid', NULL, '99.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5896, '105748', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 15:28:21', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5897, '105745', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 14:41:41', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5898, '105747', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 15:11:18', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5899, '105749', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 16:05:02', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5900, '105750', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 16:32:08', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5901, '105751', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 16:57:10', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(5902, '105753', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 18:00:06', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5889, '105744', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 14:31:37', 'Paid', NULL, '275.00', '275.00', '275.00', NULL, '300.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5890, '105740', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 13:19:50', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5891, '105742', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 13:51:32', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5892, '105739', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 13:04:29', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5885, '105735', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 11:55:57', 'Paid', NULL, '77.00', '77.00', '77.00', NULL, '77.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5886, '105737', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 12:21:48', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5879, '105733', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 10:14:13', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5887, '105736', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 12:07:28', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '100.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5884, '105734', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 11:53:25', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5883, '105732', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 10:10:09', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5882, '105731', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 10:09:13', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5881, '105729', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 09:57:53', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5880, '105728', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 09:54:12', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5878, '105730', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-05 10:04:31', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483592351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5933, '105783', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 18:01:14', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '25.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5934, '105784', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 18:23:36', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5935, '105785', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 18:38:07', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5932, '105781', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 16:09:38', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5931, '105780', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 15:59:19', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5917, '105764', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 12:18:31', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5918, '105767', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 12:53:09', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5919, '105765', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 12:18:46', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5920, '105773', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 13:39:58', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '69.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5921, '105770', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 13:10:13', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '50.00', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5922, '105771', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 13:29:23', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5923, '105772', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 13:35:03', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5924, '105774', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 14:15:53', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5925, '105775', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 14:29:01', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5926, '105776', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 14:47:13', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5927, '105778', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 15:40:37', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5928, '105782', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 16:43:57', 'Paid', NULL, '70.00', '70.00', '70.00', NULL, '70.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5929, '105777', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 15:13:34', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5930, '105779', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 15:58:28', 'Paid', NULL, '72.00', '72.00', '72.00', NULL, '80.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5912, '105760', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 10:35:07', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5913, '105761', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 10:44:57', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5914, '105762', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 11:44:05', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '50.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5915, '105769', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 12:54:16', 'Paid', NULL, '87.00', '87.00', '87.00', NULL, '100.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5916, '105768', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 12:53:20', 'Paid', NULL, '104.00', '104.00', '104.00', NULL, '105.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5911, '105758', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 10:21:59', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5910, '105759', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 10:22:30', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5909, '105757', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 10:18:48', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '70.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5907, '105766', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 12:19:03', 'Paid', NULL, '205.50', '205.50', '205.50', NULL, '205.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5908, '105763', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 12:12:34', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '64.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5906, '105756', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-06 10:11:51', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483677214', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5965, '105813', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 21:22:10', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5964, '105812', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 20:59:46', 'Paid', NULL, '63.50', '63.50', '63.50', NULL, '100.00', '36.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5962, '105810', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 17:18:51', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5963, '105811', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 18:37:26', 'Paid', NULL, '24.00', '21.60', '21.60', NULL, '52.00', '30.40', '0.00', '0.00', '2.40', '0.00', 'Cash', NULL, '27', '1483792488', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5948, '105797', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 14:12:30', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5949, '105796', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 13:48:56', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '39.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5950, '105800', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 14:39:13', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '70.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5951, '105799', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 14:34:26', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5952, '105801', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 15:11:16', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '60.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5953, '105802', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 15:39:33', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5954, '105803', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 15:46:42', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5955, '105804', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 16:06:35', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '50.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5956, '105805', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 16:18:44', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5957, '105809', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 17:05:49', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5958, '105806', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 16:55:45', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5959, '105807', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 16:56:23', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '102.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5960, '105808', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 16:58:59', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5943, '105793', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 11:58:32', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '70.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5944, '105790', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 11:13:02', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5945, '105794', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 13:11:54', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5946, '105795', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 13:15:33', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '50.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5947, '105798', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 14:16:11', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5941, '105791', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 11:31:45', 'Paid', NULL, '112.00', '112.00', '112.00', NULL, '120.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5942, '105792', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 11:51:07', 'Paid', NULL, '111.00', '111.00', '111.00', NULL, '111.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5940, '105789', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 10:42:19', 'Paid', NULL, '83.00', '83.00', '83.00', NULL, '90.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5939, '105787', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 10:13:06', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5938, '105788', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 10:25:55', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5937, '105786', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-07 10:05:44', 'Paid', NULL, '128.00', '128.00', '128.00', NULL, '150.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483792488', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6019, '105867', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 21:32:22', 'Paid', NULL, '26.50', '26.50', '26.50', NULL, '50.00', '23.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6020, '105866', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 21:07:24', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6018, '105866', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 20:56:36', 'Paid', NULL, '70.00', '70.00', '70.00', NULL, '70.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6017, '105863', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 20:05:21', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6016, '105864', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 20:15:54', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6010, '105856', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 17:36:42', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '64.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6011, '105857', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 17:48:31', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6012, '105859', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 18:35:17', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6013, '105861', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 19:32:31', 'Paid', NULL, '78.00', '78.00', '78.00', NULL, '100.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6014, '105860', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 19:07:01', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6015, '105862', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 19:42:07', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6009, '105858', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 18:05:47', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6007, '105853', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 16:54:05', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6008, '105855', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 17:26:52', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6005, '105851', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 16:30:23', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6006, '105852', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 16:35:26', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6004, '105850', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 16:28:14', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6003, '105854', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 17:01:45', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5999, '105846', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 15:06:11', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6000, '105849', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 16:04:31', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '42.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6001, '105847', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 15:16:29', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6002, '105848', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 15:31:28', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(5998, '105845', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 14:17:54', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '20.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5997, '105844', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 14:13:48', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '100.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5993, '105837', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 13:07:21', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5994, '105838', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 13:07:58', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5996, '105841', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 13:49:08', 'Paid', NULL, '80.00', '80.00', '80.00', NULL, '80.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5991, '105842', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 13:56:55', 'Paid', NULL, '112.00', '112.00', '112.00', NULL, '150.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5992, '105843', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 13:57:51', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5977, '105821', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 11:19:08', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '70.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5978, '105825', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 11:33:46', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5979, '105823', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 11:31:14', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '60.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5980, '105833', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 12:19:33', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5981, '105829', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 11:49:51', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '70.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5982, '105826', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 11:34:31', 'Paid', NULL, '126.00', '126.00', '126.00', NULL, '126.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5983, '105831', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 11:58:18', 'Paid', NULL, '71.00', '71.00', '71.00', NULL, '100.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5984, '105830', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 11:56:07', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5985, '105832', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 12:10:51', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5986, '105827', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 11:37:46', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5987, '105828', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 11:41:31', 'Paid', NULL, '76.00', '76.00', '76.00', NULL, '80.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5995, '105840', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 13:38:36', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5989, '105836', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 13:06:33', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '69.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5990, '105839', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 13:32:07', 'Paid', NULL, '74.00', '74.00', '74.00', NULL, '74.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5970, '105818', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 10:26:09', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5971, '105819', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 10:39:52', 'Paid', NULL, '100.00', '100.00', '100.00', NULL, '100.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5972, '105834', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 12:26:36', 'Paid', NULL, '94.00', '94.00', '94.00', NULL, '94.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5973, '105820', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 10:46:39', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '55.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5974, '105824', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 11:32:53', 'Paid', NULL, '126.00', '126.00', '126.00', NULL, '126.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5975, '105835', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 12:53:39', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '70.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5976, '105822', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 11:28:46', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '60.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5969, '105817', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 10:13:09', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5968, '105816', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 09:43:36', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5967, '105815', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 09:33:52', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(5966, '105814', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-08 09:27:11', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483877732', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6048, '105894', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 17:55:49', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6049, '105893', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 17:12:37', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6025, '105874', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 12:35:23', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6026, '105871', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 11:48:39', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6047, '105892', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 16:11:32', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6029, '105876', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 12:47:56', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '59.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6030, '105880', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 13:31:43', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6031, '105873', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 12:26:22', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6032, '105875', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 12:41:25', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6033, '105878', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 13:03:08', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6034, '105877', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 12:49:49', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6035, '105882', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 14:00:17', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6036, '105881', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 13:33:30', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6037, '105888', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 15:16:24', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6038, '105879', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 13:29:15', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6039, '105890', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 15:28:24', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6040, '105885', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 14:41:06', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '20.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6041, '105884', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 14:09:44', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '55.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6042, '105883', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 14:05:18', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6043, '105887', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 15:13:17', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '22.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(6044, '105886', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 14:51:37', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '21.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6045, '105891', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 16:02:22', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '70.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6046, '105889', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 15:25:41', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '100.00', '71.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6024, '105870', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 11:46:37', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '52.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6023, '105872', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 12:06:24', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6022, '105869', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 10:44:48', 'Paid', NULL, '123.00', '123.00', '123.00', NULL, '133.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6021, '105868', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-09 10:30:45', 'Paid', NULL, '110.00', '110.00', '110.00', NULL, '150.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1483933558', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6054, '105897', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-11 12:51:40', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484116267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6070, '105914', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-11 20:00:27', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '20.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484116267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6069, '105912', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-11 19:39:58', 'Paid', NULL, '16.50', '16.50', '16.50', NULL, '20.50', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484116267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6068, '105913', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-11 19:51:32', 'Paid', NULL, '62.00', '55.80', '55.80', NULL, '70.00', '14.20', '0.00', '0.00', '6.20', '0.00', 'Cash', NULL, '27', '1484116267', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6067, '105911', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-11 17:53:05', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484116267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6066, '105910', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-11 16:10:16', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484116267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6065, '105909', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-11 15:41:58', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484116267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6063, '105906', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-11 14:40:40', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484116267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6062, '105905', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-11 14:40:18', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '30.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484116267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6061, '105908', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-11 14:58:17', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484116267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6060, '105903', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-11 14:24:25', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484116267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6059, '105899', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-11 13:52:57', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '51.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484116267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6058, '105898', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-11 13:37:09', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484116267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6057, '105901', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-01-11 13:57:57', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '50.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484116267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6056, '105904', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-01-11 14:25:10', 'Paid', NULL, '104.00', '104.00', '104.00', NULL, '105.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484116267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6055, '105902', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-01-11 14:20:25', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '100.00', '46.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484116267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6053, '105900', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-11 13:55:02', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484116267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6064, '105907', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-11 14:41:16', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '15.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484116267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6051, '105896', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-11 12:19:59', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '70.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484116267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6050, '105895', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-11 09:51:54', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484116267', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6089, '105932', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-12 19:59:54', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '20.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484195308', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6088, '105931', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-12 18:50:11', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484195308', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6087, '105930', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-12 18:49:27', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484195308', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6073, '105917', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-12 12:15:55', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '70.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484195308', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6075, '105918', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-12 12:23:05', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484195308', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6076, '105922', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-12 13:01:30', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484195308', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6077, '105921', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-12 12:53:28', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484195308', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6078, '105924', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-12 13:09:12', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484195308', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6079, '105925', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-12 13:39:54', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484195308', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6081, '105923', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-12 13:08:19', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484195308', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6083, '105926', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-12 14:01:51', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484195308', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6084, '105927', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-12 17:26:42', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484195308', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6085, '105929', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-12 18:48:35', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484195308', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6086, '105928', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-12 18:48:19', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484195308', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6080, '105920', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-12 12:49:21', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484195308', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6074, '105919', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-12 12:35:24', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484195308', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6072, '105916', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-12 10:02:47', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484195308', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6071, '105915', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-12 09:08:58', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484195308', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6107, '105950', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-13 15:54:14', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484279630', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6108, '105951', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-13 16:02:10', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '21.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484279630', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6106, '105948', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-13 15:31:59', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '20.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484279630', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6094, '105937', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-13 11:22:02', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484279630', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6095, '105936', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-13 11:10:53', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '15.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484279630', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6096, '105943', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-13 12:54:15', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484279630', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6097, '105941', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-13 12:25:31', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484279630', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6098, '105939', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-13 12:10:44', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484279630', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6099, '105940', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-13 12:16:37', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484279630', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6100, '105942', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-13 12:50:59', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484279630', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6101, '105944', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-13 12:58:15', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484279630', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6102, '105949', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-13 15:40:15', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484279630', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6103, '105945', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-13 13:24:03', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484279630', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6104, '105946', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-13 13:47:22', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484279630', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6105, '105947', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-13 15:17:28', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '50.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484279630', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6093, '105934', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-13 11:03:22', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484279630', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6092, '105938', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-13 11:34:19', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484279630', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6091, '105935', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-13 11:07:18', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484279630', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6090, '105933', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-13 10:02:43', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '40.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484279630', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6132, '105971', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 14:59:00', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6133, '105974', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 15:54:59', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6131, '105975', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 17:46:02', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6130, '105968', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 14:06:33', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '20.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6126, '105965', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 12:44:47', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6127, '105966', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 12:50:51', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '50.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6128, '105970', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 14:20:50', 'Paid', NULL, '176.00', '176.00', '176.00', NULL, '200.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6129, '105973', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 15:33:25', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6113, '105958', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 11:17:26', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6124, '105967', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 13:53:11', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6123, '105964', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 12:01:15', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6122, '105961', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 11:35:24', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '30.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6121, '105972', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 15:18:47', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6120, '105969', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 14:06:56', 'Paid', NULL, '99.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6119, '105960', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 11:29:24', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '55.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6118, '105962', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 11:50:37', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '45.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6117, '105963', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 11:59:22', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '100.00', '75.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6116, '105959', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 11:21:09', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '20.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6115, '105957', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 11:00:15', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6114, '105956', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 10:50:07', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '70.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6112, '105953', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 09:59:07', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6111, '105954', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 10:11:12', 'Paid', NULL, '86.00', '86.00', '86.00', NULL, '90.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6110, '105952', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 09:41:41', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6109, '105955', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-14 10:26:03', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484375582', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6166, '106006', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 17:25:45', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6167, '106007', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 17:56:31', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '20.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6164, '106004', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 15:43:13', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6165, '106005', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 16:10:20', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6162, '106002', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 14:26:43', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '30.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6163, '106003', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 14:33:33', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '15.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6161, '106000', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 13:52:41', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6157, '105996', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 12:49:15', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '50.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6158, '105998', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 13:23:22', 'Paid', NULL, '77.50', '77.50', '77.50', NULL, '100.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6159, '105999', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 13:35:06', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '59.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6160, '106001', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 14:08:53', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6156, '105995', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 12:27:54', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '100.00', '60.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6151, '105989', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 11:52:48', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6152, '105990', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 11:54:19', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6153, '105992', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 11:59:51', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6155, '105992', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 11:57:51', 'Paid', NULL, '79.00', '79.00', '79.00', NULL, '100.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6150, '105988', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 11:52:07', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6149, '105986', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 11:41:38', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6147, '105984', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 11:29:32', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6146, '105983', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 11:28:59', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6145, '105982', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 11:28:07', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6154, '105994', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 12:26:11', 'Paid', NULL, '76.00', '76.00', '0.00', '76.00', '76.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '1.37', 'Master Card', '1.80', NULL, '0.08', '74.55', 0, NULL, NULL, NULL, NULL, '0'),
(6144, '105981', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 11:27:31', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6148, '105987', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 11:48:51', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6141, '105985', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 11:29:57', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6140, '105993', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 12:07:53', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6138, '105997', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 12:51:52', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6139, '105979', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 11:03:23', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '100.00', '67.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6137, '105977', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 10:18:59', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6136, '105980', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 11:06:07', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6135, '105978', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 10:27:08', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '88.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6134, '105976', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-15 09:42:09', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484454419', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6197, '106036', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 20:23:35', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6198, '106038', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 20:58:41', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6199, '106039', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 21:22:11', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6194, '106035', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 19:53:47', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6195, '106034', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 19:15:45', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6196, '106037', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 20:52:30', 'Paid', NULL, '47.40', '47.40', '47.40', NULL, '50.00', '2.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6193, '106032', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 18:30:18', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6179, '106016', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 12:03:39', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6180, '106021', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 13:31:34', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '23.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6181, '106019', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 13:15:16', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6182, '106024', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 13:55:08', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6185, '106018', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 13:10:45', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6187, '106022', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 13:32:06', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6188, '106031', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 18:21:25', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6189, '106030', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 17:14:52', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6183, '106027', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 14:56:19', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6184, '106025', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 14:14:40', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6192, '106033', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 19:07:15', 'Paid', NULL, '101.00', '101.00', '101.00', NULL, '101.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6190, '106028', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 16:34:48', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6191, '106029', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 16:56:12', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6178, '106020', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 13:19:05', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6186, '106026', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 14:49:00', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6177, '106023', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 13:34:32', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6176, '106014', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 11:41:07', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '52.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6175, '106013', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 11:40:48', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6172, '106009', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 10:24:47', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6174, '106015', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 11:41:28', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '55.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(6173, '106012', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 11:25:46', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6171, '106011', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 11:15:45', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '53.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6170, '106017', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 12:20:16', 'Paid', NULL, '97.00', '97.00', '97.00', NULL, '100.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6169, '106010', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 11:11:11', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6168, '106008', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-16 09:31:15', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484568062', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6219, '106058', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 14:43:38', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6220, '106059', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 15:16:45', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '21.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6221, '106060', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 15:43:21', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6222, '106061', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 16:16:39', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '20.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6223, '106062', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 16:44:04', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '55.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6224, '106063', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 16:45:45', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6216, '106055', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 13:58:48', 'Paid', NULL, '96.00', '96.00', '96.00', NULL, '100.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6217, '106056', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 14:02:10', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '51.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6215, '106054', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 13:32:49', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6226, '106064', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 18:28:57', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '50.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6225, '106065', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 20:39:10', 'Paid', NULL, '154.00', '154.00', '154.00', NULL, '154.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6210, '106047', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 11:11:52', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '50.00', '47.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6211, '106048', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 11:12:55', 'Paid', NULL, '1.00', '1.00', '1.00', NULL, '1.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6212, '106050', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 11:40:11', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6213, '106052', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 13:03:06', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '68.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6214, '106057', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 14:37:11', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6206, '106044', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 10:36:32', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6207, '106046', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 10:44:00', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6208, '106051', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 12:03:08', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '100.00', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6209, '106049', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 11:18:27', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6204, '106053', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 13:24:12', 'Paid', NULL, '85.00', '85.00', '85.00', NULL, '100.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6205, '106043', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 10:19:48', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6203, '106045', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 10:39:28', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '68.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6202, '106042', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 09:08:07', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6201, '106041', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 09:07:09', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '53.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6200, '106040', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-18 09:03:20', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484716636', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6258, '106094', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 19:15:10', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6259, '106095', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 19:20:58', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6260, '106098', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 20:35:48', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '104.00', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6261, '106099', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 20:41:28', 'Paid', NULL, '68.00', '68.00', '68.00', NULL, '68.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6244, '106085', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 14:26:40', 'Paid', NULL, '85.00', '85.00', '85.00', NULL, '100.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6245, '106086', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 14:48:14', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6246, '106079', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 14:00:02', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '50.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6247, '106080', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 14:00:29', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6248, '106081', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 14:00:53', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6249, '106088', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 15:07:07', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '55.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6250, '106087', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 14:50:09', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6251, '106090', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 16:34:07', 'Paid', NULL, '82.00', '82.00', '82.00', NULL, '100.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6252, '106089', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 16:24:01', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6253, '106091', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 17:49:46', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6254, '106092', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 18:22:19', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6255, '106096', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 19:25:02', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6256, '106093', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 18:35:26', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6257, '106097', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 20:23:16', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6238, '106073', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 13:15:41', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '102.00', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6239, '106076', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 13:51:50', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '60.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6240, '106084', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 14:22:37', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6241, '106078', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 13:58:34', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6242, '106077', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 13:57:55', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6243, '106082', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 14:06:06', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '100.00', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6232, '106070', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 11:50:24', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6233, '106083', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 14:18:08', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '40.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6234, '106074', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 13:18:18', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6235, '106071', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 12:12:01', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6236, '106072', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 12:53:28', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6237, '106075', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 13:20:18', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6231, '106069', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 11:07:42', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6230, '106068', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 10:52:02', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6229, '106067', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 10:37:22', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6228, '106066', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-19 09:10:05', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484829296', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6278, '106116', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-20 15:05:42', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484890125', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6279, '106117', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-20 15:51:35', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484890125', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6280, '106119', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-20 16:16:07', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484890125', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6281, '106118', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-20 16:13:19', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '15.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484890125', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6282, '106120', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-20 17:16:20', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '100.00', '72.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484890125', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6277, '106113', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-20 14:04:06', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484890125', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6266, '106104', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-20 11:25:56', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '52.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484890125', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6267, '106105', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-20 11:50:37', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '100.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484890125', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6268, '106115', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-01-20 14:36:10', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '100.00', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484890125', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6269, '106106', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-01-20 12:46:06', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484890125', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6270, '106109', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-20 13:20:43', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484890125', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6271, '106107', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-20 12:47:13', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484890125', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6272, '106111', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-20 13:23:24', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484890125', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6273, '106108', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-20 12:54:19', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484890125', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6274, '106112', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-20 13:29:58', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '100.00', '63.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484890125', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6275, '106110', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-20 13:22:05', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484890125', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6276, '106114', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-20 14:32:38', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '100.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484890125', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6265, '106103', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-01-20 10:52:15', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484890125', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6264, '106102', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-20 10:28:10', 'Paid', NULL, '122.00', '122.00', '122.00', NULL, '200.00', '78.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484890125', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6263, '106100', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-20 09:35:53', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484890125', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6262, '106101', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-20 09:53:14', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484890125', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6327, '106164', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 18:54:56', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6326, '106161', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 18:03:39', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6325, '106160', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 17:50:07', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6324, '106159', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 17:49:11', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6321, '106156', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 17:09:41', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '100.00', '86.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6322, '106157', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 17:10:23', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6323, '106158', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 17:13:51', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6320, '106155', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 17:09:04', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6319, '106154', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 17:07:12', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6318, '106153', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 17:06:06', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6313, '106150', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 15:11:04', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '20.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6314, '106163', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 18:38:27', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6315, '106151', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 15:25:27', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6316, '106152', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 16:59:54', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '50.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6317, '106162', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 18:16:19', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '30.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6312, '106149', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 14:30:39', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6311, '106148', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 14:29:30', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6310, '106147', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 13:58:17', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '20.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6308, '106143', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 13:31:11', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6309, '106146', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 13:44:31', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6299, '106133', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 11:28:48', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6300, '106141', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 13:18:16', 'Paid', NULL, '107.00', '107.00', '107.00', NULL, '110.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6301, '106138', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 12:17:28', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6302, '106140', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 13:07:00', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6303, '106135', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 12:13:37', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6304, '106137', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 12:17:13', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '20.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6305, '106142', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 13:20:09', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6306, '106139', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 12:46:37', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6307, '106144', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 13:40:02', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6288, '106134', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 11:46:53', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '30.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6287, '106128', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 11:00:15', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6298, '106136', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 12:15:07', 'Paid', NULL, '86.00', '86.00', '86.00', NULL, '100.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6296, '106132', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 11:26:44', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6295, '106131', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 11:26:10', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '30.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6294, '106130', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 11:25:32', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6297, '106129', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 11:09:36', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6292, '106127', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 11:00:11', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '28.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6291, '106145', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 13:42:15', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6290, '106126', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 10:59:26', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '25.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6289, '106125', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 10:58:29', 'Paid', NULL, '81.00', '81.00', '81.00', NULL, '100.00', '19.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6286, '106123', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 10:34:56', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '100.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6284, '106122', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 09:37:10', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6285, '106124', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 10:52:15', 'Paid', NULL, '99.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6283, '106121', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-21 09:25:37', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1484978263', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6372, '106206', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 19:37:12', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6371, '106207', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 19:45:22', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6366, '106201', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 16:23:27', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '102.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6367, '106202', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 16:35:20', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '30.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6368, '106203', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 17:02:39', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '100.00', '66.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6369, '106205', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 18:06:01', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6370, '106204', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 18:04:32', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6364, '106199', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 16:06:02', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6363, '106198', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 16:05:09', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6358, '106191', 'T14(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 14:36:11', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '50.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6359, '106192', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 14:41:26', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6360, '106196', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 15:56:00', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6361, '106200', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 16:21:41', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6362, '106197', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 15:59:09', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6357, '106189', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 14:32:10', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6356, '106188', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 14:31:21', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6355, '106195', '13', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 15:44:55', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '70.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(6353, '106190', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 14:32:24', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6354, '106194', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 15:06:11', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6339, '106172', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 11:24:46', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '100.00', '63.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6340, '106183', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 13:06:27', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6341, '106176', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 12:09:32', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6348, '106186', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 13:47:19', 'Paid', NULL, '73.00', '73.00', '73.00', NULL, '73.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6343, '106177', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 12:22:42', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6344, '106178', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 12:23:01', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '30.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6345, '106179', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 12:23:34', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '70.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6346, '106180', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 12:23:56', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '30.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6347, '106181', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 12:24:53', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6349, '106184', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 13:08:38', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6338, '106175', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 12:03:18', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6352, '106187', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 13:51:14', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6351, '106193', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 14:44:52', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6350, '106185', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 13:44:59', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6336, '106169', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 10:45:04', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6337, '106182', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 12:33:18', 'Paid', NULL, '108.00', '108.00', '108.00', NULL, '108.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6335, '106173', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 11:36:30', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '100.00', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6334, '106171', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 11:11:19', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6332, '106170', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 11:03:53', 'Paid', NULL, '109.00', '109.00', '109.00', NULL, '109.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6333, '106174', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 11:47:22', 'Paid', NULL, '124.00', '124.00', '124.00', NULL, '124.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6331, '106168', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 10:28:44', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '100.00', '51.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6330, '106167', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 10:24:05', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '59.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6329, '106166', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 10:07:23', 'Paid', NULL, '54.50', '54.50', '54.50', NULL, '54.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6328, '106165', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-22 09:36:27', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '100.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485066722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6385, '106221', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-23 14:56:14', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485145022', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6387, '106222', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-23 15:10:49', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485145022', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6388, '106224', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-23 16:27:32', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '40.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485145022', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6389, '106223', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-23 16:22:03', 'Paid', NULL, '9.00', '8.10', '8.10', NULL, '8.10', '0.00', '0.00', '0.00', '0.90', '0.00', 'Cash', NULL, '27', '1485145022', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6390, '106225', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-23 16:51:55', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485145022', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6391, '106226', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-23 17:05:06', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '20.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485145022', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6386, '106220', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-23 14:16:13', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '50.00', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485145022', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6383, '106214', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-23 12:34:28', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485145022', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6384, '106217', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-23 12:53:37', 'Paid', NULL, '66.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485145022', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6382, '106218', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-23 13:28:40', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485145022', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6381, '106216', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-23 12:37:18', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '65.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485145022', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6380, '106215', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-23 12:35:28', 'Paid', NULL, '79.00', '79.00', '79.00', NULL, '100.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485145022', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6379, '106213', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-23 12:07:31', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485145022', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6378, '106219', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-23 13:58:06', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485145022', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6377, '106211', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-23 11:55:07', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485145022', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6376, '106212', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-23 12:04:33', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485145022', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6375, '106210', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-23 10:55:10', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485145022', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6374, '106209', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-23 10:31:15', 'Paid', NULL, '51.00', '51.00', '51.00', NULL, '55.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485145022', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6373, '106208', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-23 09:57:50', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485145022', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6416, '106251', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 18:51:04', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6415, '106250', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 18:19:29', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '13.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6414, '106247', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 15:57:27', 'Paid', NULL, '13.00', '11.70', '11.70', NULL, '11.70', '0.00', '0.00', '0.00', '1.30', '0.00', 'Cash', NULL, '27', '1485316211', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6405, '106240', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 14:26:51', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6406, '106241', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 14:27:17', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '100.00', '84.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6407, '106242', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 14:40:30', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6408, '106244', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 15:38:41', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6409, '106243', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 15:36:14', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6410, '106249', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 17:07:54', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6411, '106245', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 15:40:54', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6412, '106246', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 15:47:21', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '20.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6413, '106248', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 16:08:32', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6404, '106236', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 13:08:10', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6403, '106239', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 14:21:49', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '50.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6402, '106234', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 12:16:08', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6401, '106238', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 13:14:01', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6400, '106237', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 13:12:02', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '100.00', '51.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6399, '106232', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 11:39:22', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6398, '106235', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 12:37:57', 'Paid', NULL, '77.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6397, '106231', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 11:25:31', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6396, '106229', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 10:52:29', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6395, '106233', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 11:52:28', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6394, '106230', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 11:05:23', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6393, '106228', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 10:12:21', 'Paid', NULL, '85.00', '85.00', '85.00', NULL, '100.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6392, '106227', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-01-25 10:11:02', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485316211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6418, '106253', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-01-31 13:43:51', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485839089', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6417, '106252', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-01-31 13:13:13', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485839089', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6464, '106295', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 21:11:31', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6463, '106294', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 20:52:23', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6457, '106290', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 19:03:18', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6458, '106292', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 19:51:38', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '55.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6459, '106291', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 19:19:08', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6461, '106296', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 21:28:52', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6462, '106293', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 20:37:32', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6456, '106297', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 21:43:53', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6455, '106289', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 18:09:15', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '100.00', '60.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6454, '106286', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 17:15:15', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6452, '106284', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 16:38:44', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6451, '106285', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 17:11:49', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6453, '106287', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 17:15:43', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6446, '106278', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 15:31:10', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '15.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6447, '106280', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 15:35:57', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6448, '106282', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 15:50:07', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '20.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6449, '106283', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 16:15:36', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '20.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6450, '106288', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 17:29:53', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6445, '106277', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 15:24:46', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6444, '106274', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 15:07:29', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6443, '106275', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 15:09:45', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '20.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6442, '106272', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 14:46:50', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6432, '106264', 'T14(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 12:42:55', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6434, '106271', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 14:20:38', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6435, '106265', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 12:50:31', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '100.00', '58.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6436, '106268', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 13:12:13', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6437, '106281', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 15:45:27', 'Paid', NULL, '53.00', '47.70', '47.70', NULL, '50.00', '2.30', '0.00', '0.00', '5.30', '0.00', 'Cash', NULL, '27', '1485929099', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6438, '106270', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 14:16:09', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '100.00', '65.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6439, '106279', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 15:31:29', 'Paid', NULL, '85.00', '85.00', '85.00', NULL, '85.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6440, '106273', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 14:54:55', 'Paid', NULL, '70.00', '70.00', '70.00', NULL, '70.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6441, '106276', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 15:15:50', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6431, '106263', 'T14(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 12:42:30', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6429, '106261', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 12:32:52', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6430, '106267', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 13:11:40', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '100.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6428, '106266', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 12:53:40', 'Paid', NULL, '129.00', '116.10', '116.10', NULL, '120.00', '3.90', '0.00', '0.00', '12.90', '0.00', 'Cash', NULL, '27', '1485929099', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6433, '106269', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 13:52:33', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '57.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6426, '106260', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 12:13:04', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6425, '106258', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 11:31:26', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6424, '106259', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 11:45:08', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6423, '106257', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 10:58:44', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '50.00', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6422, '106262', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 12:33:59', 'Paid', NULL, '108.00', '108.00', '108.00', NULL, '120.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6421, '106256', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 10:53:42', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6420, '106255', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 10:15:58', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6419, '106254', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-01 09:57:05', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1485929099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6508, '106340', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 20:20:30', 'Paid', NULL, '97.00', '97.00', '97.00', NULL, '100.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6509, '106341', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 20:28:27', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6510, '106342', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 20:30:51', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6511, '106344', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 21:03:04', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6507, '106339', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 19:58:05', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6502, '106334', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 18:11:44', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6503, '106338', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 19:21:16', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6504, '106336', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 19:16:16', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6505, '106337', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 19:18:05', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6506, '106343', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 20:56:54', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6500, '106331', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 17:40:02', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6501, '106335', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 18:54:45', 'Paid', NULL, '64.00', '64.00', '64.00', NULL, '64.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6499, '106333', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 18:05:50', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '100.00', '72.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6497, '106330', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 17:11:42', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6498, '106332', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 17:59:31', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '50.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6494, '106328', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 16:35:17', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6495, '106324', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 15:45:03', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '22.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6496, '106327', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 16:16:50', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '20.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6488, '106318', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 14:40:03', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '50.00', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6489, '106319', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 14:45:46', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6490, '106323', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 15:22:25', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6491, '106325', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 15:50:46', 'Paid', NULL, '111.90', '111.90', '111.90', NULL, '120.00', '8.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6492, '106326', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 16:00:52', 'Paid', NULL, '72.00', '72.00', '72.00', NULL, '100.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6493, '106329', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 16:45:37', 'Paid', NULL, '79.00', '79.00', '79.00', NULL, '100.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6487, '106321', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 15:00:43', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '57.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6486, '106320', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 14:58:03', 'Paid', NULL, '106.00', '106.00', '0.00', '106.00', '106.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '1.91', 'Master Card', '1.80', NULL, '0.11', '103.98', 0, NULL, NULL, NULL, NULL, '0'),
(6473, '106311', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 12:53:03', 'Paid', NULL, '85.00', '85.00', '85.00', NULL, '100.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6474, '106304', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 11:43:26', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6475, '106310', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 12:16:08', 'Paid', NULL, '77.00', '77.00', '77.00', NULL, '107.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6476, '106307', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 11:59:01', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '20.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6477, '106308', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 12:08:24', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(6478, '106309', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 12:13:48', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6479, '106316', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 13:59:10', 'Paid', NULL, '94.00', '94.00', '94.00', NULL, '100.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6480, '106312', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 13:00:59', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6481, '106315', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 13:20:31', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6482, '106313', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 13:17:25', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6483, '106314', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 13:20:07', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6484, '106322', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 15:01:04', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '100.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6485, '106317', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 14:19:25', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6472, '106305', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 11:44:32', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6471, '106306', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 11:51:43', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6470, '106303', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 11:11:22', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '70.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6469, '106302', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 10:35:17', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '40.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6468, '106300', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 09:45:32', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6467, '106301', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 10:14:42', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '70.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6466, '106299', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 09:28:50', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '100.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6465, '106298', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-02 09:04:42', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486018292', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6556, '106387', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 21:01:42', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6557, '106386', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 20:53:13', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6558, '106392', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 22:09:54', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '35.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6559, '106391', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 21:51:07', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6555, '106389', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 21:21:55', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6548, '106380', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 18:10:04', 'Paid', NULL, '15.00', '13.50', '13.50', NULL, '50.00', '36.50', '0.00', '0.00', '1.50', '0.00', 'Cash', NULL, '27', '1486117870', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6549, '106384', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 19:35:45', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6550, '106383', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 19:34:36', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6551, '106382', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 18:44:39', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6552, '106390', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 21:27:06', 'Paid', NULL, '170.00', '170.00', '170.00', NULL, '170.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6553, '106388', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 21:12:25', 'Paid', NULL, '167.00', '167.00', '167.00', NULL, '170.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6554, '106385', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 20:06:44', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6546, '106379', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 17:50:16', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6547, '106381', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 18:12:24', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6545, '106376', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 16:45:49', 'Paid', NULL, '105.00', '105.00', '105.00', NULL, '150.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6538, '106377', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 16:53:42', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6539, '106372', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 15:18:06', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '100.00', '51.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6540, '106367', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 14:32:17', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6541, '106373', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 15:45:03', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6542, '106374', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 16:12:09', 'Paid', NULL, '78.00', '78.00', '78.00', NULL, '100.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6543, '106378', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 17:29:57', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '100.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6544, '106375', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 16:14:23', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6534, '106362', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 14:04:03', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6535, '106369', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 15:03:12', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '50.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6536, '106368', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 14:53:44', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6537, '106371', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 15:17:12', 'Paid', NULL, '58.00', '58.00', '58.00', NULL, '60.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6520, '106354', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 11:58:08', 'Paid', NULL, '85.00', '85.00', '85.00', NULL, '100.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6521, '106370', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 15:05:07', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '50.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6522, '106353', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 11:54:56', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '52.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6523, '106355', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 12:21:01', 'Paid', NULL, '80.00', '80.00', '80.00', NULL, '100.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6524, '106352', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 11:39:43', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6525, '106359', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 13:47:30', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6526, '106357', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 13:38:39', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6527, '106363', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 14:10:31', 'Paid', NULL, '72.00', '72.00', '72.00', NULL, '72.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6528, '106356', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 13:21:09', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6529, '106361', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 14:02:29', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6530, '106364', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 14:14:33', 'Paid', NULL, '77.00', '77.00', '77.00', NULL, '77.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6531, '106358', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 13:40:10', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6532, '106366', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 14:30:29', 'Paid', NULL, '110.00', '110.00', '110.00', NULL, '110.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6533, '106365', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 14:29:22', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '100.00', '78.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6519, '106351', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 11:07:49', 'Paid', NULL, '49.00', '49.00', '49.00', NULL, '49.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6518, '106360', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 13:49:56', 'Paid', NULL, '113.00', '113.00', '113.00', NULL, '113.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6517, '106348', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 10:03:43', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6516, '106347', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 09:59:58', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6515, '106346', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 09:59:35', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6514, '106345', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 09:51:34', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6513, '106350', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 10:31:04', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '100.00', '67.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6512, '106349', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-03 10:17:32', 'Paid', NULL, '67.00', '67.00', '67.00', NULL, '67.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486117870', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6597, '106429', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 17:28:46', 'Paid', NULL, '15.00', '13.50', '13.50', NULL, '13.50', '0.00', '0.00', '0.00', '1.50', '0.00', 'Cash', NULL, '27', '1486190504', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6598, '106430', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 17:57:18', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '50.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6599, '106431', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 19:07:38', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6600, '106432', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 19:08:11', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6601, '106433', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 19:08:40', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6602, '106434', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 19:09:33', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6596, '106428', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 17:27:04', 'Paid', NULL, '27.00', '24.30', '24.30', NULL, '40.00', '15.70', '0.00', '0.00', '2.70', '0.00', 'Cash', NULL, '27', '1486190504', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6593, '106421', 'T1(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 15:35:39', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6594, '106422', 'T1(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 15:36:51', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6592, '106423', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 15:53:50', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6589, '106426', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 16:48:48', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6590, '106420', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 15:28:12', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6591, '106424', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 16:07:33', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6586, '106416', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 14:32:14', 'Paid', NULL, '40.00', '36.00', '36.00', NULL, '50.00', '14.00', '0.00', '0.00', '4.00', '0.00', 'Cash', NULL, '27', '1486190504', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6587, '106425', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 16:13:25', 'Paid', NULL, '74.50', '74.50', '74.50', NULL, '74.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6588, '106419', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 15:05:07', 'Paid', NULL, '91.00', '91.00', '91.00', NULL, '91.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6568, '106399', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 11:04:39', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6569, '106407', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 13:11:09', 'Paid', NULL, '71.00', '71.00', '71.00', NULL, '71.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6570, '106405', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 13:00:09', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6571, '106402', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 12:16:34', 'Paid', NULL, '84.00', '84.00', '84.00', NULL, '100.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6573, '106404', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 12:23:51', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '34.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6574, '106418', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 14:59:42', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6575, '106406', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 13:06:24', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '100.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6576, '106408', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 13:26:05', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6577, '106414', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 14:12:22', 'Paid', NULL, '91.00', '91.00', '91.00', NULL, '101.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6595, '106427', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 16:54:09', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6579, '106409', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 13:29:20', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6580, '106412', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 14:03:43', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6581, '106417', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 14:41:03', 'Paid', NULL, '71.00', '71.00', '71.00', NULL, '71.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6582, '106410', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 13:47:30', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '100.00', '64.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6583, '106411', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 14:01:55', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '26.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6584, '106413', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 14:10:11', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '40.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6585, '106415', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 14:17:54', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '70.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6572, '106403', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 12:21:06', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6567, '106397', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 10:30:56', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '10.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6566, '106398', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 11:03:41', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '69.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6565, '106400', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 11:24:49', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '52.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6564, '106396', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 10:25:50', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6563, '106395', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 10:11:52', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '100.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6562, '106394', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 10:08:15', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6561, '106393', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 09:27:55', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6560, '106401', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-04 11:34:54', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486190504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6638, '106471', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 18:42:36', 'Paid', NULL, '138.00', '124.20', '124.20', NULL, '150.00', '25.80', '0.00', '0.00', '13.80', '0.00', 'Cash', NULL, '27', '1486301152', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6639, '106469', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 18:09:16', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6640, '106473', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 19:16:14', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '100.00', '56.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6641, '106476', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 21:26:08', 'Paid', NULL, '182.00', '182.00', '182.00', NULL, '182.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6642, '106472', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 19:02:05', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '20.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6643, '106474', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 19:52:34', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6644, '106475', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 20:37:10', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6636, '106467', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 16:42:16', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '102.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6637, '106470', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 18:21:07', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6635, '106466', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 16:09:57', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6633, '106463', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 15:50:48', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6634, '106468', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 17:27:50', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '100.00', '46.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6632, '106462', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 15:46:09', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6615, '106447', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 13:32:50', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6616, '106443', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 12:55:19', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6617, '106456', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 14:47:17', 'Paid', NULL, '459.00', '413.10', '0.00', '413.10', '413.10', '0.00', '0.00', '0.00', '45.90', '0.00', 'Credit Card', NULL, '27', '1486301152', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, 5, '4.63', 'VISA', '1.12', NULL, '0.28', '408.20', 0, NULL, NULL, NULL, NULL, '0'),
(6618, '106451', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 14:05:39', 'Paid', NULL, '103.00', '103.00', '103.00', NULL, '103.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6619, '106449', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 13:59:41', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6620, '106453', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 14:17:57', 'Paid', NULL, '78.00', '78.00', '78.00', NULL, '78.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6621, '106446', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 13:24:16', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6622, '106450', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 14:03:49', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '100.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6612, '106444', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 12:56:13', 'Paid', NULL, '70.00', '70.00', '70.00', NULL, '70.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6613, '106445', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 12:59:07', 'Paid', NULL, '41.00', '41.00', '41.00', NULL, '41.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6614, '106448', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 13:49:45', 'Paid', NULL, '59.00', '59.00', '59.00', NULL, '59.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6611, '106452', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 14:12:48', 'Paid', NULL, '75.00', '75.00', '75.00', NULL, '100.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6631, '106465', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 15:58:04', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6630, '106457', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 15:16:52', 'Paid', NULL, '47.00', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6629, '106464', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 15:55:33', 'Paid', NULL, '66.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', '6.60', '0.00', 'Cash', NULL, '27', '1486301152', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6628, '106459', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 15:36:58', 'Paid', NULL, '65.00', '65.00', '65.00', NULL, '100.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6627, '106460', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 15:40:17', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '56.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6626, '106455', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 14:30:09', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6625, '106458', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 15:18:22', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6624, '106454', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 14:22:17', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '40.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6623, '106461', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 15:41:06', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6610, '106442', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 12:43:59', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6609, '106441', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 12:23:32', 'Paid', NULL, '87.00', '87.00', '87.00', NULL, '100.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6608, '106440', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 11:56:54', 'Paid', NULL, '88.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6607, '106437', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 10:24:15', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '50.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6606, '106438', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 10:31:07', 'Paid', NULL, '77.00', '77.00', '77.00', NULL, '77.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6605, '106436', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 10:02:40', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6604, '106439', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 11:15:01', 'Paid', NULL, '193.00', '193.00', '193.00', NULL, '200.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(6603, '106435', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-05 09:12:05', 'Paid', NULL, '53.00', '53.00', '53.00', NULL, '53.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486301152', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6663, '106493', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-06 18:29:38', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486362600', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6660, '106490', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-06 17:13:38', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486362600', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6661, '106491', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-06 17:41:50', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '10.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486362600', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6662, '106492', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-06 17:57:39', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486362600', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6657, '106485', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-06 14:09:40', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486362600', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6656, '106488', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-06 14:49:47', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486362600', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6655, '106486', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-06 14:20:10', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486362600', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6653, '106484', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-06 13:29:14', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486362600', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6654, '106487', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-06 14:30:32', 'Paid', NULL, '82.00', '82.00', '82.00', NULL, '100.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486362600', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6652, '106483', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-06 13:20:42', 'Paid', NULL, '95.50', '95.50', '95.50', NULL, '100.00', '4.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486362600', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6651, '106489', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-06 15:40:20', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486362600', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6650, '106481', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-06 12:19:49', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486362600', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6649, '106480', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-06 11:24:15', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '20.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486362600', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6648, '106482', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-06 13:08:05', 'Paid', NULL, '31.50', '31.50', '31.50', NULL, '40.00', '8.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486362600', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6647, '106479', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-06 10:53:58', 'Paid', NULL, '103.00', '103.00', '103.00', NULL, '103.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486362600', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6646, '106477', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-06 09:42:06', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '50.00', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486362600', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6645, '106478', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-06 09:48:22', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '30.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486362600', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6675, '106505', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-08 16:05:37', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '50.00', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486529137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6674, '106504', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-08 15:50:41', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486529137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6672, '106501', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-08 14:57:19', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486529137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6673, '106503', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-08 15:43:53', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486529137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6671, '106500', 'T12A(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-08 14:23:36', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486529137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6670, '106499', 'T12A(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-08 13:51:01', 'Paid', NULL, '37.00', '37.00', '37.00', NULL, '50.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486529137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6669, '106502', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-02-08 15:42:32', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486529137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6668, '106498', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-08 13:21:29', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486529137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6667, '106497', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-08 12:07:28', 'Paid', NULL, '2.00', '2.00', '2.00', NULL, '2.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486529137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6665, '106494', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-08 10:47:18', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '50.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486529137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6666, '106496', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-08 11:23:39', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486529137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6664, '106495', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-08 10:47:32', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486529137', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6695, '106525', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-09 18:45:46', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486625682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6696, '106524', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-09 16:43:35', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '50.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486625682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6697, '106526', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-09 19:06:29', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486625682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6690, '106519', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-09 14:41:48', 'Paid', NULL, '60.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', '6.00', '0.00', 'Cash', NULL, '27', '1486625682', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6691, '106522', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-09 15:16:43', 'Paid', NULL, '50.00', '50.00', '50.00', NULL, '50.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486625682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6692, '106520', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-09 15:04:56', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486625682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6693, '106523', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-09 16:29:49', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486625682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6694, '106521', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-09 15:14:23', 'Paid', NULL, '15.00', '13.50', '13.50', NULL, '25.00', '11.50', '0.00', '0.00', '1.50', '0.00', 'Cash', NULL, '27', '1486625682', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6689, '106516', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-09 13:40:39', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486625682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6688, '106518', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-09 14:16:29', 'Paid', NULL, '61.00', '61.00', '61.00', NULL, '61.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486625682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6687, '106517', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-09 13:52:59', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486625682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6686, '106515', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-09 13:07:45', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486625682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6682, '106511', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-09 12:14:11', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '50.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486625682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6684, '106512', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-09 12:17:55', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486625682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6685, '106514', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-09 12:40:36', 'Paid', NULL, '71.00', '71.00', '71.00', NULL, '100.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486625682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6683, '106513', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-09 12:26:22', 'Paid', NULL, '55.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486625682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6681, '106510', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-09 12:11:00', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486625682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6680, '106509', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-09 11:37:13', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '100.00', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486625682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6678, '106508', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-09 11:08:00', 'Paid', NULL, '62.00', '62.00', '62.00', NULL, '62.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486625682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6677, '106506', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-09 10:01:45', 'Paid', NULL, '82.00', '82.00', '82.00', NULL, '82.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486625682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6676, '106507', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-09 10:03:58', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486625682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6710, '106541', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-10 15:34:01', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '31.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486705713', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6711, '106539', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-10 14:51:57', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '52.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486705713', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6712, '106540', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-10 15:09:41', 'Paid', NULL, '15.00', '13.50', '13.50', NULL, '50.00', '36.50', '0.00', '0.00', '1.50', '0.00', 'Cash', NULL, '27', '1486705713', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6713, '106543', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-10 17:49:43', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '29.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486705713', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6714, '106542', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-10 17:04:13', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486705713', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6715, '106544', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-10 17:59:07', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '20.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486705713', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6709, '106538', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-10 13:50:22', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486705713', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6708, '106533', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-10 12:28:05', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486705713', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6704, '106537', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-10 13:19:53', 'Paid', NULL, '72.00', '72.00', '72.00', NULL, '72.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486705713', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6705, '106534', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-10 12:34:27', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486705713', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6706, '106535', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-10 13:13:57', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486705713', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6707, '106536', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-10 13:16:01', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486705713', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6703, '106532', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-10 12:26:17', 'Paid', NULL, '69.00', '69.00', '69.00', NULL, '100.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486705713', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6702, '106531', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-10 10:58:10', 'Paid', NULL, '87.00', '87.00', '87.00', NULL, '100.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486705713', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6701, '106530', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-10 10:48:06', 'Paid', NULL, '80.00', '80.00', '80.00', NULL, '80.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486705713', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6700, '106529', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-10 10:15:51', 'Paid', NULL, '46.00', '46.00', '46.00', NULL, '46.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486705713', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6699, '106528', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-10 10:12:50', 'Paid', NULL, '82.00', '82.00', '82.00', NULL, '100.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486705713', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6698, '106527', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-10 09:57:14', 'Paid', NULL, '56.00', '56.00', '56.00', NULL, '100.00', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486705713', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6770, '106591', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 20:03:04', 'Paid', NULL, '2.50', '2.50', '2.50', NULL, '2.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6769, '106593', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 20:54:56', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '100.00', '6.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6768, '106589', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 19:38:08', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '22.10', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6764, '106585', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 18:56:09', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6765, '106592', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 20:09:13', 'Paid', NULL, '30.00', '29.70', '29.70', NULL, '29.70', '0.00', '0.00', '0.00', '3.30', '0.00', 'Cash', NULL, '27', '1486807745', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6766, '106587', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 19:09:30', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6767, '106590', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 19:45:24', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6763, '106594', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 21:06:12', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6755, '106576', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 17:33:52', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6756, '106577', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 17:38:26', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6757, '106578', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 17:38:59', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6759, '106583', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 18:18:47', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '14.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6760, '106586', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 19:05:03', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.00', '30.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6761, '106584', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 18:33:27', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6762, '106588', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 19:15:24', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6754, '106575', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 17:30:51', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6752, '106573', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 16:46:52', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6748, '106582', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 18:10:00', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6758, '106579', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 17:52:14', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '17.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6750, '106571', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 16:32:28', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6729, '106556', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 13:31:10', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '104.00', '20.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6730, '106558', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 13:49:45', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6731, '106557', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 13:46:56', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6732, '106564', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 14:51:53', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.40', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6733, '106559', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 14:06:59', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '13.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6734, '106562', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 14:46:39', 'Paid', NULL, '72.00', '72.00', '72.00', NULL, '100.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6735, '106560', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 14:20:21', 'Paid', NULL, '63.00', '69.30', '0.00', '69.30', '69.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '0.78', 'VISA', '1.12', NULL, '0.05', '68.48', 0, NULL, NULL, NULL, NULL, '0'),
(6736, '106565', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 14:57:34', 'Paid', NULL, '56.00', '55.45', '55.45', NULL, '56.00', '0.55', '0.00', '0.00', '6.16', '0.01', 'Cash', NULL, '27', '1486807745', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6737, '106566', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 15:20:44', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6738, '106580', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 17:57:24', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.10', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6739, '106561', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 14:28:07', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6740, '106568', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 16:02:42', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '41.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6741, '106567', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 16:00:52', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6742, '106574', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 17:12:39', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '40.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6743, '106572', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 16:45:10', 'Paid', NULL, '33.50', '36.85', '36.85', NULL, '100.00', '63.15', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6744, '106569', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 16:25:39', 'Paid', NULL, '15.00', '13.50', '13.50', NULL, '13.50', '0.00', '0.00', '0.00', '1.50', '0.00', 'Cash', NULL, '27', '1486807745', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6745, '106570', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 16:30:29', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6751, '106581', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 18:00:25', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6728, '106555', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 12:50:49', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '100.00', '6.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6727, '106552', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 11:20:40', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6726, '106563', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 14:49:16', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6725, '106553', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 11:26:14', 'Paid', NULL, '149.00', '163.90', '163.90', NULL, '163.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6724, '106550', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 11:08:08', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.30', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6723, '106547', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 10:41:04', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6722, '106546', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 10:19:58', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '50.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6721, '106548', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 10:47:42', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '100.00', '51.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6720, '106549', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 11:07:20', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6719, '106551', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 11:15:29', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.10', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6718, '106545', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 09:42:40', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6717, '106554', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-11 12:11:21', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486807745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6822, '106643', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 18:50:23', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6820, '106642', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 18:32:52', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '60.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6819, '106633', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 16:01:02', 'Paid', NULL, '30.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', '3.00', '0.00', 'Cash', NULL, '27', '1486880131', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6815, '106635', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 16:13:10', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6816, '106639', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 17:30:12', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6817, '106636', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 16:25:16', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6821, '106641', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 18:09:47', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6810, '106631', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 15:35:56', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6811, '106630', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 15:29:01', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6812, '106632', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 15:44:07', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '55.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6814, '106638', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 16:47:48', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6808, '106626', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 14:26:36', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6809, '106629', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 15:15:28', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '80.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6806, '106628', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 15:02:28', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6807, '106625', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 14:25:33', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6801, '106623', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 14:12:03', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6802, '106620', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 13:39:34', 'Paid', NULL, '13.00', '11.70', '11.70', NULL, '20.00', '8.30', '0.00', '0.00', '1.30', '0.00', 'Cash', NULL, '27', '1486880131', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6803, '106637', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 16:37:00', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6804, '106627', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 14:50:01', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6805, '106634', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 16:10:45', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6789, '106611', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 12:58:39', 'Paid', NULL, '139.00', '152.90', '0.00', '152.90', '152.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '2.75', 'Master Card', '1.80', NULL, '0.17', '149.98', 0, NULL, NULL, NULL, NULL, '0'),
(6790, '106640', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 17:38:55', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6791, '106618', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 13:31:37', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '40.00', '3.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6792, '106621', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 13:50:56', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '64.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6793, '106617', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 13:30:39', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6794, '106622', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 13:55:48', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6795, '106619', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 13:37:05', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6798, '106614', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 13:24:02', 'Paid', NULL, '52.00', '57.20', '0.00', '57.20', '57.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '0.64', 'VISA', '1.12', NULL, '0.04', '56.52', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(6797, '106613', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 13:16:53', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6799, '106615', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 13:27:45', 'Paid', NULL, '83.00', '91.30', '0.00', '91.30', '91.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '1.64', 'Master Card', '1.80', NULL, '0.10', '89.56', NULL, NULL, NULL, NULL, NULL, NULL),
(6800, '106624', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 14:14:00', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6784, '106608', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 12:15:26', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6785, '106605', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 11:53:46', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6786, '106606', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 11:54:30', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6787, '106616', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 13:29:36', 'Paid', NULL, '82.00', '90.20', '0.00', '90.20', '90.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '1.62', 'Master Card', '1.80', NULL, '0.10', '88.48', 0, NULL, NULL, NULL, NULL, '0'),
(6788, '106612', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 13:00:52', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6783, '106609', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 12:31:07', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6782, '106604', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 11:45:58', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6781, '106603', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 11:43:40', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6780, '106602', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 11:39:35', 'Paid', NULL, '118.00', '129.80', '129.80', NULL, '140.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6778, '106601', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 11:38:49', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6779, '106607', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 11:55:06', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '55.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6776, '106610', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 12:54:31', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6777, '106600', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 11:05:55', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6775, '106598', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 10:46:50', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6774, '106596', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 10:33:34', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6773, '106597', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 10:45:10', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '63.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6772, '106599', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 10:47:24', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '67.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6771, '106595', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-12 09:45:29', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '71.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486880131', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6843, '106659', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 13:12:46', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6844, '106666', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 14:30:13', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6845, '106661', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 13:26:00', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '20.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6846, '106665', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 14:09:41', 'Paid', NULL, '45.00', '44.55', '44.55', NULL, '50.00', '5.45', '0.00', '0.00', '4.95', '0.00', 'Cash', NULL, '27', '1486962836', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6847, '106667', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 14:31:22', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '40.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6848, '106669', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 15:07:32', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '81.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6853, '106671', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 16:33:45', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '45.00', '5.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6851, '106668', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 14:57:06', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6850, '106670', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 15:35:29', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '10.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6841, '106660', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 13:21:53', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6842, '106662', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 13:26:20', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6837, '106658', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 13:07:38', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6838, '106654', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 12:14:59', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '50.00', '31.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6852, '106672', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 16:57:07', 'Paid', NULL, '54.50', '59.95', '59.95', NULL, '66.00', '6.05', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6840, '106664', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 13:54:11', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6830, '106651', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 12:05:28', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6831, '106650', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 11:52:37', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6832, '106653', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 12:12:04', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.20', '11.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6833, '106652', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 12:09:41', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6834, '106656', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 12:34:01', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6836, '106655', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 12:27:09', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6835, '106657', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 12:46:28', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.00', '4.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6829, '106649', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 10:52:24', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '31.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6828, '106663', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 13:35:21', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6827, '106647', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 10:25:42', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '60.00', '14.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6826, '106648', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 10:40:59', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '100.10', '55.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6825, '106644', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 09:26:22', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6824, '106645', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 09:34:42', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6823, '106646', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-13 09:43:46', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '27.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1486962836', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6875, '106689', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 15:33:29', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.00', '3.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6877, '106690', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 15:56:59', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6878, '106696', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 17:11:25', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6879, '106700', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 18:11:23', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6880, '106702', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 19:25:31', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '9.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6881, '106695', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 16:38:47', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '5.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6883, '106698', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 17:58:40', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.00', '9.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6884, '106697', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 17:52:44', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '53.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6885, '106701', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 18:12:39', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6886, '106699', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 18:06:54', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6887, '106704', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 19:40:10', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6888, '106703', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 19:39:21', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6889, '106705', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 19:40:29', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6873, '106691', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 15:57:36', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '81.00', '30.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6874, '106688', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 15:10:11', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6870, '106684', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 14:49:21', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6871, '106687', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 15:07:24', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '100.00', '76.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6872, '106685', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 15:00:22', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '67.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6869, '106694', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 16:25:55', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '100.60', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6861, '106681', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 14:16:10', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6862, '106683', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 14:37:32', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6863, '106680', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 13:58:35', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.40', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6864, '106686', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 15:04:20', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '103.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6866, '106692', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 16:04:01', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6867, '106693', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 16:19:01', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6868, '106682', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 14:33:06', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6860, '106679', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 13:44:07', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6859, '106676', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 12:09:29', 'Paid', NULL, '30.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', '3.00', '0.00', 'Cash', NULL, '27', '1487134777', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6858, '106677', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 12:35:13', 'Paid', NULL, '153.00', '151.45', '151.45', NULL, '152.00', '0.55', '0.00', '0.00', '16.83', '-0.02', 'Cash', NULL, '27', '1487134777', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6856, '106674', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 11:24:30', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6865, '106678', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 13:40:37', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.10', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6855, '106675', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 11:36:27', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6854, '106673', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-15 10:01:24', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487134777', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6905, '106722', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 14:46:44', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6906, '106721', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 14:16:49', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6907, '106723', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 15:19:07', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.10', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6908, '106726', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 17:24:15', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '56.40', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6909, '106725', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 17:09:12', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6910, '106724', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 16:22:30', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6911, '106728', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 17:48:08', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.30', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6912, '106729', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 18:15:59', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6913, '106727', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 17:35:00', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '29.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6914, '106730', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 18:37:39', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.50', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6915, '106731', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 18:44:02', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6916, '106732', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 19:30:24', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6917, '106733', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 19:47:00', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '35.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6904, '106717', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 13:48:29', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6897, '106709', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 11:24:59', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6898, '106715', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 12:31:25', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6899, '106713', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 11:50:29', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '5.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6900, '106714', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 11:54:19', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '14.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6901, '106718', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 13:57:54', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6902, '106716', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 13:15:57', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6903, '106719', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 14:02:47', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.00', '5.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6895, '106720', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 14:06:15', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.00', '37.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6896, '106712', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 11:43:15', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6894, '106710', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 11:32:42', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6893, '106707', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 10:41:03', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6892, '106708', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 10:56:34', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '100.00', '50.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6891, '106711', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 11:41:53', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6890, '106706', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-16 09:44:44', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '54.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487215491', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6932, '106746', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 13:45:05', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '91.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6933, '106752', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 14:30:43', 'Paid', NULL, '121.00', '119.80', '119.80', NULL, '120.00', '0.20', '0.00', '0.00', '13.31', '0.01', 'Cash', NULL, '27', '1487308134', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6934, '106750', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 13:50:29', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6935, '106753', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 15:25:46', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6936, '106747', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 13:46:08', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6937, '106749', 'T10(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 13:49:07', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6938, '106755', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 17:48:22', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6939, '106754', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 16:22:02', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.20', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6940, '106758', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 18:30:00', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '101.00', '70.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6941, '106760', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 19:00:28', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '53.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6942, '106756', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 17:49:14', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6943, '106757', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 17:55:19', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6944, '106762', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 19:46:30', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '50.00', '33.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6945, '106759', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 18:57:32', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6946, '106761', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 19:10:21', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6931, '106743', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 13:14:21', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6930, '106748', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 13:48:37', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6929, '106742', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 13:06:01', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6928, '106744', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 13:14:58', 'Paid', NULL, '126.00', '138.60', '138.60', NULL, '150.00', '11.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6927, '106740', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 12:59:45', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '48.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6926, '106741', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 13:00:48', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '100.00', '18.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6925, '106751', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 14:16:27', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6924, '106745', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 13:36:50', 'Paid', NULL, '47.00', '46.55', '46.55', NULL, '50.00', '3.45', '0.00', '0.00', '5.17', '0.02', 'Cash', NULL, '27', '1487308134', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6923, '106738', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 12:06:21', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6922, '106737', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 12:00:24', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.00', '43.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6921, '106735', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 11:15:00', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6920, '106736', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 11:54:18', 'Paid', NULL, '132.00', '145.20', '145.20', NULL, '150.20', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6919, '106739', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 12:20:58', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6918, '106734', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-17 10:06:04', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487308134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6987, '106799', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 18:55:33', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6988, '106800', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 19:56:29', 'Paid', NULL, '85.90', '94.50', '94.50', NULL, '100.00', '5.50', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6983, '106796', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 17:33:14', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6981, '106791', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 16:17:54', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '10.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6982, '106792', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 16:21:10', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6984, '106794', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 16:33:53', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6985, '106795', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 17:20:07', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(6986, '106798', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 18:49:15', 'Paid', NULL, '80.00', '79.20', '79.20', NULL, '100.00', '20.80', '0.00', '0.00', '8.80', '0.00', 'Cash', NULL, '27', '1487418467', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6979, '106790', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 16:14:37', 'Paid', NULL, '14.00', '12.60', '12.60', NULL, '12.60', '0.00', '0.00', '0.00', '1.40', '0.00', 'Cash', NULL, '27', '1487418467', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6978, '106797', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 17:34:06', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6977, '106789', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 15:58:56', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6976, '106787', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 14:19:46', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6975, '106786', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 14:19:28', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '40.00', '2.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6974, '106793', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 16:33:31', 'Paid', NULL, '29.00', '28.70', '28.70', NULL, '30.00', '1.30', '0.00', '0.00', '3.19', '-0.01', 'Cash', NULL, '27', '1487418467', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6973, '106788', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 14:42:52', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6972, '106783', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 13:37:04', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6971, '106781', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 13:16:24', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '50.00', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6969, '106782', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 13:29:07', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '45.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6970, '106785', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 14:13:54', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '63.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6968, '106779', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 13:03:00', 'Paid', NULL, '12.00', '10.80', '10.80', NULL, '20.00', '9.20', '0.00', '0.00', '1.20', '0.00', 'Cash', NULL, '27', '1487418467', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6965, '106780', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 13:04:46', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6964, '106784', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 14:13:02', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '54.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6962, '106777', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 12:32:45', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6963, '106778', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 13:00:08', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '27.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6961, '106774', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 12:19:56', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.50', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6960, '106770', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 11:20:47', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6959, '106775', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 12:24:52', 'Paid', NULL, '126.00', '138.60', '138.60', NULL, '150.00', '11.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6958, '106769', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 11:17:32', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(6957, '106773', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 12:10:17', 'Paid', NULL, '93.00', '102.30', '102.30', NULL, '105.40', '3.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6956, '106768', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 11:13:08', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6955, '106771', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 11:45:08', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6953, '106766', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 10:49:52', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6952, '106776', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 12:29:44', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6951, '106767', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 11:00:45', 'Paid', NULL, '104.00', '114.40', '114.40', NULL, '125.00', '10.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6950, '106765', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 10:48:38', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.00', '29.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6949, '106764', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 10:15:10', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6948, '106772', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 11:52:04', 'Paid', NULL, '115.00', '126.50', '126.50', NULL, '150.00', '23.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6947, '106763', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-18 09:44:36', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '55.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487418467', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7027, '106838', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 16:42:15', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7029, '106837', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 16:41:24', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7030, '106839', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 16:43:54', 'Paid', NULL, '13.50', '13.50', '13.50', NULL, '15.00', '1.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7031, '106840', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 16:45:14', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7032, '106841', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 17:02:29', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7033, '106842', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 17:03:26', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7034, '106843', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 17:04:11', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.00', '7.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7025, '106835', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 15:52:03', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.00', '15.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7023, '106829', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 15:12:43', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7024, '106832', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 15:24:19', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7026, '106831', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 15:23:58', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '50.00', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7015, '106824', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 14:23:33', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7016, '106828', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 15:05:31', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '57.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7017, '106826', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 14:41:28', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7018, '106834', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 15:43:28', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7019, '106836', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 16:27:27', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7020, '106830', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 15:15:31', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '100.00', '70.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7021, '106844', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 17:06:38', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '32.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7022, '106833', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 15:29:20', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '59.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7014, '106827', '13', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 15:01:33', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '52.00', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7013, '106823', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 14:16:18', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '41.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7012, '106822', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 13:59:58', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '50.00', '40.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7011, '106821', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 13:49:09', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7009, '106818', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 13:22:21', 'Paid', NULL, '153.00', '168.30', '168.30', NULL, '168.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7010, '106816', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 13:13:09', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7008, '106819', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 13:32:04', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '52.00', '21.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7007, '106809', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 12:26:43', 'Paid', NULL, '4.00', '4.00', '4.00', NULL, '4.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7006, '106817', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 13:17:56', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '31.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7004, '106820', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 13:32:49', 'Paid', NULL, '110.00', '121.00', '121.00', NULL, '150.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7005, '106815', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 13:10:27', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7003, '106812', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 12:44:55', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '70.30', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7002, '106813', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 12:53:46', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '70.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7000, '106811', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 12:44:16', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7001, '106814', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 13:09:19', 'Paid', NULL, '126.00', '138.60', '138.60', NULL, '150.00', '11.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6999, '106810', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 12:28:20', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '75.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6997, '106808', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 12:06:27', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '27.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6996, '106807', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 11:54:40', 'Paid', NULL, '206.00', '226.60', '226.60', NULL, '226.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6995, '106806', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 11:53:56', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '65.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6994, '106805', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 11:51:37', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6993, '106804', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 11:42:10', 'Paid', NULL, '121.00', '133.10', '133.10', NULL, '150.10', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6998, '106825', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 14:30:56', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6991, '106803', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 11:38:58', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6990, '106802', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 10:29:34', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(6989, '106801', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-19 10:23:18', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487495165', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7061, '106867', 'T10(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 17:21:12', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7062, '106868', 'T10(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 17:21:35', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7064, '106873', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 19:25:48', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.00', '7.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7065, '106874', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 19:29:08', 'Paid', NULL, '95.00', '104.50', '104.50', NULL, '110.00', '5.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7066, '106871', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 18:59:02', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7059, '106870', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 18:30:30', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '40.00', '3.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7060, '106872', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 19:14:43', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7063, '106869', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 18:04:02', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7057, '106866', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 16:02:33', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7054, '106861', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 14:38:19', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7050, '106864', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 15:38:19', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '52.20', '40.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7051, '106862', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 14:53:37', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '52.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7052, '106859', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 14:24:26', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7053, '106860', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 14:24:45', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7055, '106863', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 15:33:41', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7056, '106865', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 15:53:33', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '19.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7048, '106857', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 13:33:08', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7047, '106858', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 14:18:56', 'Paid', NULL, '41.50', '45.65', '45.65', NULL, '50.00', '4.35', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7046, '106855', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 12:51:55', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7045, '106854', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 12:42:46', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '50.00', '43.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7044, '106856', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 13:31:50', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '14.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7043, '106851', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 11:39:07', 'Paid', NULL, '48.00', '48.00', '48.00', NULL, '48.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7042, '106852', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 11:39:23', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7041, '106849', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 11:30:50', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '100.00', '84.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7040, '106853', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 11:45:22', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7039, '106850', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 11:31:22', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '100.00', '82.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7038, '106848', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 11:09:18', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7037, '106847', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 10:58:59', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.10', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7036, '106845', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 10:12:26', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '103.00', '30.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7035, '106846', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-20 10:28:19', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '82.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487589252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7097, '106904', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 19:10:46', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '14.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7098, '106905', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 19:26:30', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '29.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7090, '106898', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 15:26:17', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7091, '106896', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 15:01:00', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '10.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7092, '106899', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 15:34:46', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '55.00', '3.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7093, '106900', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 17:14:58', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.20', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7094, '106902', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 17:41:07', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '50.00', '39.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7095, '106901', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 17:30:57', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7096, '106903', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 18:25:28', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7089, '106897', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 15:07:02', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '50.00', '29.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7081, '106888', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 13:12:49', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '50.90', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7082, '106885', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 12:55:50', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7083, '106889', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 13:19:58', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7084, '106886', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 13:07:41', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7085, '106894', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 14:27:28', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7086, '106895', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 14:32:19', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7087, '106892', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 14:16:38', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7088, '106893', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 14:22:28', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7077, '106906', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 20:39:47', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.30', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7079, '106884', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 12:37:09', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.20', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7080, '106890', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 13:32:19', 'Paid', NULL, '119.00', '130.90', '130.90', NULL, '130.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7078, '106887', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 13:10:00', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '14.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7075, '106881', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 11:57:15', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7076, '106882', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 12:09:23', 'Paid', NULL, '45.50', '50.05', '50.05', NULL, '50.05', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7074, '106891', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 13:47:04', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7073, '106879', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 11:37:02', 'Paid', NULL, '38.00', '37.60', '37.60', NULL, '50.00', '12.40', '0.00', '0.00', '4.18', '-0.02', 'Cash', NULL, '27', '1487726054', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7072, '106878', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 10:53:52', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7071, '106880', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 11:45:01', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.50', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7070, '106877', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 10:35:09', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7069, '106883', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 12:24:33', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7068, '106876', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 10:09:10', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.00', '30.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7067, '106875', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-22 10:02:33', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487726054', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7125, '106934', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 21:18:44', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '90.70', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7126, '106930', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 20:55:05', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7127, '106933', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 21:18:29', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7128, '106932', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 21:15:50', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.00', '30.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7113, '106922', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 15:11:00', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7124, '106929', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 19:13:49', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7114, '106920', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 14:32:23', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7115, '106924', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 15:32:46', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7116, '106923', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 15:21:24', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7117, '106925', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 15:48:10', 'Paid', NULL, '131.00', '144.10', '144.10', NULL, '144.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(7119, '106926', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 16:01:34', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7120, '106928', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 17:52:52', 'Paid', NULL, '15.90', '17.50', '17.50', NULL, '50.00', '32.50', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7123, '106931', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 20:55:47', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '100.30', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7122, '106927', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 17:29:30', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7110, '106916', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 13:24:09', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7111, '106919', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 14:22:43', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '52.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7112, '106921', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 15:07:14', 'Paid', NULL, '165.00', '181.50', '181.50', NULL, '181.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7109, '106917', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 13:35:13', 'Paid', NULL, '145.00', '159.50', '159.50', NULL, '159.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7108, '106915', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 13:22:15', 'Paid', NULL, '44.50', '48.95', '48.95', NULL, '50.00', '1.05', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7107, '106913', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 12:44:42', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7106, '106912', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 12:17:29', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7105, '106911', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 12:12:57', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7104, '106918', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 13:45:08', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '101.00', '70.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7103, '106914', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 13:16:54', 'Paid', NULL, '56.00', '55.45', '55.45', NULL, '60.00', '4.55', '0.00', '0.00', '6.16', '0.01', 'Cash', NULL, '27', '1487852013', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7102, '106908', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 11:03:02', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7101, '106909', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 11:13:26', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '10.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7100, '106907', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 10:57:36', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '29.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7099, '106910', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-23 11:26:16', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '101.30', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487852013', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7162, '106964', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 19:19:12', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7163, '106969', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 20:32:59', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7164, '106966', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 20:12:19', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.30', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7165, '106968', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 20:20:15', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7159, '106963', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 18:42:10', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '7.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7160, '106965', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 19:26:08', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7161, '106967', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 20:18:56', 'Paid', NULL, '108.00', '118.80', '118.80', NULL, '150.00', '31.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7151, '106953', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 14:16:09', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7153, '106958', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 16:21:02', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7154, '106957', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 16:08:59', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '50.00', '41.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7155, '106962', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 17:24:52', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '23.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7144, '106950', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 13:58:14', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7145, '106951', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 14:04:26', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7146, '106946', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 13:25:33', 'Paid', NULL, '26.00', '23.40', '23.40', NULL, '25.00', '1.60', '0.00', '0.00', '2.60', '0.00', 'Cash', NULL, '27', '1487938890', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7147, '106955', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 14:57:05', 'Paid', NULL, '96.00', '105.60', '105.60', NULL, '105.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7148, '106948', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 13:33:53', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '13.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7149, '106956', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 15:10:34', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7150, '106952', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 14:06:14', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.40', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7143, '106949', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 13:47:06', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7157, '106961', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 17:24:17', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '15.20', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7156, '106960', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 17:23:37', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '20.00', '11.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7142, '106947', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 13:31:00', 'Paid', NULL, '149.00', '163.90', '163.90', NULL, '170.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7134, '106941', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 12:17:12', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '81.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7135, '106940', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 12:11:37', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7137, '106954', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 14:28:19', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '52.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7138, '106942', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 12:37:56', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '80.00', '4.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7139, '106945', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 13:23:17', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '70.00', '10.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7140, '106939', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 12:11:09', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '20.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7141, '106944', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 13:06:43', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7152, '106959', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 16:39:11', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.30', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7132, '106943', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 13:01:40', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7133, '106937', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 10:55:30', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7131, '106935', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 10:08:52', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '59.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7130, '106938', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 11:37:08', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '70.00', '11.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7129, '106936', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-24 10:29:37', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.00', '3.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1487938890', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7224, '107026', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 19:21:09', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '80.00', '4.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7223, '107023', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 18:19:19', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7225, '107027', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 19:54:50', 'Paid', NULL, '123.00', '135.30', '135.30', NULL, '140.00', '4.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7226, '107025', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 19:18:55', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7227, '107028', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 19:58:52', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7221, '107024', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 19:03:30', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7220, '107020', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 16:53:23', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7219, '107019', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 16:48:43', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7218, '107021', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 17:19:52', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7217, '107018', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 16:29:08', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7216, '107022', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 18:14:40', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7215, '107013', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 15:21:31', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '50.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7214, '107014', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 15:41:34', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '50.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7213, '107017', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 16:24:17', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.50', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7200, '106995', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 13:00:15', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7201, '106998', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 13:04:06', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7202, '107000', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 13:10:16', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '15.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7203, '107001', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 13:12:23', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7204, '107006', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 14:06:56', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '120.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7205, '107007', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 14:07:43', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7206, '107009', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 14:24:55', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '54.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7207, '107008', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 14:13:22', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7208, '107011', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 14:27:09', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '54.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7209, '107010', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 14:26:03', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '100.10', '77.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7210, '107012', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 14:45:46', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7211, '107016', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 16:10:16', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7212, '107015', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 16:06:08', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '50.00', '31.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7199, '106994', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 12:59:40', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7184, '107003', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 13:14:05', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.30', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7185, '106996', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 13:01:07', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7186, '106999', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 13:04:57', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '107.00', '11.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7187, '107002', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 13:12:57', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7188, '107004', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 13:14:58', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7189, '106982', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 12:14:12', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7190, '106983', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 12:14:32', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '100.00', '71.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7191, '106984', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 12:15:12', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7192, '106985', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 12:15:43', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '35.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7193, '106986', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 12:16:04', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '18.00', '5.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7194, '106987', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 12:16:34', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7196, '106989', 'T1(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 12:19:38', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '20.00', '11.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7197, '107005', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 13:15:34', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '100.00', '47.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7198, '106993', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 12:58:50', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.00', '15.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7195, '106997', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 13:01:41', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7182, '106988', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 12:17:44', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.20', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7183, '106991', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 12:39:22', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.00', '10.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7172, '106977', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 11:05:25', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '100.20', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7173, '106980', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 11:43:34', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '100.00', '86.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7174, '106976', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 10:53:35', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7175, '106978', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 11:28:32', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.10', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7178, '106990', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 12:36:01', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7177, '106979', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 11:41:13', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7179, '106992', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 12:57:21', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7180, '106981', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 12:04:34', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7171, '106972', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 10:41:42', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7170, '106974', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 10:51:37', 'Paid', NULL, '93.00', '102.30', '102.30', NULL, '102.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7169, '106971', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 10:35:33', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '70.00', '11.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7168, '106975', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 10:53:15', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '63.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7167, '106970', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 10:33:03', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.20', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7166, '106973', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-25 10:42:18', 'Paid', NULL, '99.00', '108.90', '108.90', NULL, '109.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488021498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7260, '107058', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 17:36:56', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7261, '107064', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 19:34:03', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '15.00', '2.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7262, '107065', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 19:44:56', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7263, '107059', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 18:08:20', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '106.00', '90.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7264, '107061', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 18:20:39', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7265, '107066', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 19:53:33', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '100.00', '71.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7259, '107060', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 18:09:54', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '51.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7236, '107041', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 13:30:04', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7237, '107039', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 13:20:15', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '100.00', '50.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7238, '107038', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 12:50:43', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7239, '107040', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 13:28:48', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '35.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7240, '107037', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 12:49:09', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7241, '107044', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 14:12:50', 'Paid', NULL, '223.00', '245.30', '245.30', NULL, '250.00', '4.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7243, '107048', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 15:44:00', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7245, '107045', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 15:00:02', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7246, '107046', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 15:09:57', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.40', '14.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7247, '107049', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 15:52:15', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7249, '107050', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 16:14:18', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.30', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7250, '107052', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 16:19:13', 'Paid', NULL, '100.00', '110.00', '0.00', '110.00', '110.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '1.98', 'Master Card', '1.80', NULL, '0.12', '107.90', 0, NULL, NULL, NULL, NULL, '0'),
(7252, '107051', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 16:17:58', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7253, '107056', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 16:56:05', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7254, '107054', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 16:46:57', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7255, '107053', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 16:42:38', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7256, '107062', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 18:48:56', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7257, '107055', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 16:53:15', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7258, '107063', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 19:07:54', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '46.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7251, '107047', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 15:25:06', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7248, '107057', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 17:22:52', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7244, '107043', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 14:07:43', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7242, '107042', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 14:03:58', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.10', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7235, '107034', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 11:35:29', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '55.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7234, '107035', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 12:03:59', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.60', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7233, '107033', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 10:52:14', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7232, '107032', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 10:48:07', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.10', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7231, '107036', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 12:29:24', 'Paid', NULL, '150.00', '165.00', '165.00', NULL, '200.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(7230, '107030', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 10:29:34', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.30', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7229, '107031', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 10:40:18', 'Paid', NULL, '169.00', '185.90', '185.90', NULL, '200.00', '14.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7228, '107029', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-26 10:06:37', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488093351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7291, '107091', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 19:34:03', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '49.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7292, '107092', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 19:34:48', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '36.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7293, '107093', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 20:21:23', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7294, '107094', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 20:45:12', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.70', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7276, '107080', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 15:08:30', 'Paid', NULL, '149.00', '163.90', '163.90', NULL, '165.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7277, '107074', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 13:40:10', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7282, '107083', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 16:07:23', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '103.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7279, '107077', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 14:19:52', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.40', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7280, '107082', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 15:56:47', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '60.00', '12.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7281, '107078', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 14:33:47', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.30', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7283, '107081', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 15:56:04', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '13.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7284, '107085', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 16:29:03', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7285, '107086', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 17:16:25', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '65.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7286, '107084', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 16:24:11', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7287, '107087', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 17:53:15', 'Paid', NULL, '6.00', '5.40', '5.40', NULL, '10.00', '4.60', '0.00', '0.00', '0.60', '0.00', 'Cash', NULL, '27', '1488192900', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7288, '107088', 'B1', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 18:32:23', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7289, '107089', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 19:22:57', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7290, '107090', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 19:23:22', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7274, '107073', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 13:28:43', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7275, '107079', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 14:53:56', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7273, '107076', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 13:52:25', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '57.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7272, '107075', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 13:41:27', 'Paid', NULL, '39.50', '43.45', '43.45', NULL, '44.00', '0.55', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7271, '107072', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 12:47:32', 'Paid', NULL, '12.90', '14.20', '14.20', NULL, '20.00', '5.80', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7270, '107071', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 12:05:14', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '21.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7269, '107069', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 11:35:12', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '121.00', '49.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7268, '107070', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 11:44:30', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7267, '107068', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 10:49:38', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '49.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7266, '107067', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-02-27 10:31:53', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488192900', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7314, '107111', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 15:42:49', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7315, '107117', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 17:18:40', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7316, '107115', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 16:33:07', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '50.40', '36.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7317, '107114', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 16:16:35', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '50.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7318, '107116', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 17:03:38', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '10.00', '4.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7319, '107121', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 17:52:00', 'Paid', NULL, '29.00', '27.10', '27.10', NULL, '27.10', '0.00', '0.00', '0.00', '4.79', '-0.01', 'Cash', NULL, '27', '1488351757', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7320, '107120', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 17:49:42', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '100.60', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7321, '107118', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 17:37:37', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7322, '107123', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 18:26:53', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.00', '7.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7325, '107122', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 18:10:49', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7324, '107120', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 17:46:52', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7326, '107124', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 19:20:23', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7303, '107102', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 12:26:21', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7304, '107104', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 12:59:56', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '58.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7305, '107105', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 13:31:30', 'Paid', NULL, '149.00', '163.90', '163.90', NULL, '170.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7306, '107106', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 14:29:12', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '70.20', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7310, '107109', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 15:20:12', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7308, '107107', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 15:02:48', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '53.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7309, '107108', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 15:09:46', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '101.00', '70.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7311, '107112', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 15:56:00', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7312, '107110', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 15:36:09', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7313, '107113', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 16:08:14', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7302, '107100', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 12:25:46', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7301, '107099', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 12:20:21', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '50.00', '31.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7300, '107101', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 12:26:06', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7299, '107103', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 12:33:27', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '103.00', '50.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7298, '107097', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 11:16:19', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7297, '107098', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 11:19:07', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '49.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7296, '107096', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 10:13:28', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '50.50', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7295, '107095', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-01 09:52:31', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488351757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7358, '107154', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 19:46:51', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7359, '107156', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 19:59:03', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7355, '107153', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 18:57:39', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7356, '107151', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 18:32:01', 'Paid', NULL, '14.00', '12.60', '12.60', NULL, '12.60', '0.00', '0.00', '0.00', '1.40', '0.00', 'Cash', NULL, '27', '1488450701', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7357, '107152', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 18:33:37', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7335, '107131', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 11:39:54', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7336, '107133', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 11:45:12', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7337, '107132', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 11:44:15', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.70', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7338, '107139', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 13:32:09', 'Paid', NULL, '22.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', '2.20', '0.00', 'Cash', NULL, '27', '1488450701', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7344, '107141', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 13:49:39', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7340, '107136', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 12:50:00', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '40.00', '1.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7341, '107143', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 14:28:55', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '51.90', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7342, '107142', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 14:00:13', 'Paid', NULL, '136.00', '149.60', '149.60', NULL, '200.00', '50.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7343, '107137', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 13:00:27', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.20', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7345, '107138', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 13:28:20', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7346, '107140', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 13:43:49', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7347, '107144', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 14:31:53', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '67.20', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7348, '107145', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 14:39:31', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '25.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7349, '107146', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 16:09:23', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '30.00', '4.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7350, '107148', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 16:47:24', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '41.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7351, '107147', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 16:17:21', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7352, '107149', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 17:25:19', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7353, '107150', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 18:15:25', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7354, '107155', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 19:47:57', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7334, '107134', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 11:47:40', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7333, '107128', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 11:18:55', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.20', '4.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7332, '107126', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 10:31:25', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7331, '107129', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 11:28:16', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '73.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7330, '107130', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 11:38:16', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7329, '107135', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 12:23:54', 'Paid', NULL, '212.00', '233.20', '233.20', NULL, '240.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7328, '107127', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 11:07:06', 'Paid', NULL, '147.00', '161.70', '161.70', NULL, '162.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7327, '107125', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-02 10:22:52', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488450701', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7393, '107185', 't2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 17:27:49', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7395, '107190', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 18:49:08', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7396, '107193', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 19:39:56', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.10', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7397, '107191', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 19:27:10', 'Paid', NULL, '10.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1488518799', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7398, '107192', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 19:27:52', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7394, '107188', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 18:22:47', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.70', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7391, '107186', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 17:31:59', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '16.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7392, '107184', 't2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 17:26:48', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '53.10', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7386, '107181', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 16:34:43', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7387, '107187', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 17:48:28', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7388, '107182', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 16:45:41', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '50.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7389, '107183', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 17:08:44', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7367, '107173', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 13:33:15', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7368, '107164', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 11:57:01', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '100.00', '42.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7369, '107165', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 11:57:58', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.00', '29.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7370, '107162', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 11:42:07', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '70.00', '8.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7371, '107167', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 12:27:49', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7372, '107166', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 12:16:49', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7373, '107169', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 12:46:32', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7374, '107174', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 13:50:26', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '101.00', '5.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7375, '107170', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 12:57:59', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7376, '107171', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 13:07:42', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '100.00', '5.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7377, '107175', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 13:51:22', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '27.60', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7378, '107176', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 13:51:38', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7379, '107172', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 13:30:05', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7383, '107180', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 16:22:35', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7381, '107178', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 14:43:20', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '75.80', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7382, '107177', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 14:33:07', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7384, '107179', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 16:22:04', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7385, '107189', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 18:24:16', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7365, '107160', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 11:17:27', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '100.00', '60.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7366, '107168', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 12:28:53', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7364, '107163', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 11:46:01', 'Paid', NULL, '66.00', '65.35', '65.35', NULL, '70.00', '4.65', '0.00', '0.00', '7.26', '0.01', 'Cash', NULL, '27', '1488518799', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7363, '107158', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 10:34:25', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7362, '107159', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 10:50:33', 'Paid', NULL, '15.50', '17.05', '17.05', NULL, '50.00', '32.95', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7361, '107161', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 11:32:49', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7360, '107157', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-03 10:00:06', 'Paid', NULL, '265.00', '291.50', '291.50', NULL, '300.00', '8.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488518799', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7449, '107240', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 19:14:55', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.00', '30.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7450, '107241', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 19:22:54', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '31.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7448, '107238', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 17:58:10', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7446, '107234', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 16:56:57', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7447, '107239', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 18:06:50', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7429, '107221', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 14:19:52', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7430, '107225', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 14:36:14', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7431, '107224', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 14:35:19', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '70.00', '7.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7432, '107233', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 16:54:24', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7433, '107223', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 14:27:25', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7434, '107242', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 19:29:10', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7435, '107226', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 14:46:01', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '20.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7438, '107227', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 14:46:46', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '20.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7439, '107228', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 14:47:24', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7440, '107229', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 14:50:41', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '20.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7441, '107236', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 17:11:52', 'Paid', NULL, '106.00', '116.60', '116.60', NULL, '150.00', '33.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7443, '107237', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 17:36:09', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(7444, '107235', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 16:58:11', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7445, '107232', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 16:50:44', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '50.00', '40.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7406, '107197', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 10:32:36', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '50.00', '39.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7407, '107199', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 11:15:19', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '120.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7408, '107202', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 11:30:40', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '73.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7409, '107220', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 14:05:00', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '100.00', '68.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7410, '107204', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 11:43:18', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7411, '107210', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 12:37:17', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7412, '107206', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 12:00:56', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '90.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7413, '107209', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 12:29:28', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7414, '107207', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 12:07:44', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '54.20', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7415, '107208', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 12:27:21', 'Paid', NULL, '15.50', '17.05', '17.05', NULL, '20.00', '2.95', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7416, '107211', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 13:01:20', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '100.00', '68.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7417, '107205', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 11:44:32', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7418, '107213', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 13:09:21', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '38.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7419, '107212', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 13:08:54', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '70.50', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7420, '107214', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 13:16:04', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.00', '7.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7421, '107222', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 14:25:28', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '81.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7422, '107216', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 13:35:30', 'Paid', NULL, '57.90', '63.70', '63.70', NULL, '70.00', '6.30', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7423, '107219', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 14:04:23', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.50', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7424, '107230', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 14:58:53', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7425, '107231', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 15:12:37', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.30', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7426, '107215', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 13:33:12', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7427, '107217', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 13:46:15', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7428, '107218', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 13:47:40', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7405, '107200', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 11:18:18', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.10', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7404, '107203', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 11:34:15', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7403, '107198', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 10:52:04', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.00', '4.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7402, '107195', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 10:04:38', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '100.20', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7401, '107196', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 10:23:26', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7400, '107201', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 11:20:56', 'Paid', NULL, '158.00', '173.80', '173.80', NULL, '204.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7399, '107194', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-04 08:55:42', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488608002', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7508, '107298', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 19:12:50', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7509, '107300', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 19:30:26', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '55.10', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7510, '107299', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 19:30:07', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7511, '107301', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 20:08:31', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '27.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7507, '107297', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 18:29:08', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.00', '7.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7505, '107292', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 17:21:25', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7506, '107296', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 18:22:59', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7504, '107291', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 17:14:59', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '103.80', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7503, '107293', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 17:43:39', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7501, '107288', 'T12A(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 16:30:11', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7502, '107289', 'T12A(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 16:30:34', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '57.00', '40.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7499, '107285', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 16:13:18', 'Paid', NULL, '92.00', '101.20', '101.20', NULL, '101.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7500, '107287', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 16:28:26', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '55.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7497, '107283', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 15:28:10', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7498, '107286', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 16:24:42', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '100.00', '75.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7458, '107253', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 10:58:32', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7459, '107257', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 11:25:13', 'Paid', NULL, '191.00', '210.10', '210.10', NULL, '210.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7460, '107252', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 10:56:24', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7461, '107259', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 11:39:09', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7462, '107260', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 11:48:20', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '68.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7463, '107255', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 11:13:28', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7464, '107262', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 11:56:32', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.30', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7465, '107261', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 11:53:48', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '120.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7466, '107278', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 13:46:40', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7467, '107249', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 10:51:46', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '50.00', '29.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7468, '107250', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 10:52:34', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7469, '107254', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 11:11:57', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '50.00', '39.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7470, '107263', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 11:57:26', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7471, '107267', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 12:30:52', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.60', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7472, '107264', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 12:17:00', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '70.10', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7473, '107265', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 12:18:39', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '55.00', '4.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7474, '107256', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 11:15:16', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7486, '107269', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 12:34:44', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7476, '107258', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 11:26:36', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7477, '107270', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 12:41:08', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '60.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7478, '107271', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 12:41:46', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7479, '107266', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 12:19:48', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7480, '107277', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 13:37:23', 'Paid', NULL, '138.00', '138.00', '138.00', NULL, '138.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7481, '107281', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 14:38:33', 'Paid', NULL, '44.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7482, '107272', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 12:43:10', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7483, '107275', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 13:02:05', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7484, '107276', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 13:22:52', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '64.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7485, '107268', 'T14(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 12:31:06', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.00', '37.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7487, '107274', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 13:00:24', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '8.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7488, '107279', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 13:54:04', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7489, '107273', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 12:53:02', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7496, '107295', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 18:02:46', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.30', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7491, '107280', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 14:37:45', 'Paid', NULL, '101.00', '111.10', '111.10', NULL, '120.00', '8.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7492, '107290', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 16:48:55', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7493, '107282', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 14:52:52', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7494, '107284', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 15:57:13', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7495, '107294', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 17:52:14', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7457, '107248', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 10:47:36', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7456, '107247', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 10:34:32', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7455, '107251', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 10:53:17', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7454, '107246', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 10:29:11', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.00', '3.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7453, '107245', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 10:13:49', 'Paid', NULL, '112.00', '123.20', '123.20', NULL, '123.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7452, '107244', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 09:56:27', 'Paid', NULL, '44.50', '48.95', '48.95', NULL, '50.00', '1.05', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7451, '107243', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-05 09:50:24', 'Paid', NULL, '169.00', '185.90', '185.90', NULL, '200.00', '14.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488702266', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7519, '107309', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 11:12:56', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7520, '107305', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 10:47:32', 'Paid', NULL, '112.00', '112.00', '112.00', NULL, '112.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7521, '107306', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 10:49:52', 'Paid', NULL, '215.00', '215.00', '215.00', NULL, '255.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7522, '107307', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 10:50:41', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7523, '107310', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 11:18:06', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7524, '107318', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 13:05:51', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.30', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7525, '107316', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 12:44:43', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7526, '107312', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 11:40:19', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7527, '107317', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 13:02:11', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7528, '107323', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 13:41:03', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '100.00', '5.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7529, '107319', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 13:12:05', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.70', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7530, '107315', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 12:37:04', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '28.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7531, '107321', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 13:27:07', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '67.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7532, '107328', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 15:03:25', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7533, '107322', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 13:33:56', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '13.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7534, '107320', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 13:20:33', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7535, '107325', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 14:12:25', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7536, '107326', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 14:30:12', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7537, '107324', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 13:53:19', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7538, '107330', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 15:29:19', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.20', '8.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7539, '107327', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 14:46:15', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7540, '107332', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 16:14:26', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7541, '107333', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 16:44:42', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '53.10', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7542, '107329', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 15:25:04', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7543, '107331', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 15:55:46', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7544, '107336', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 19:31:03', 'Paid', NULL, '144.00', '158.40', '158.40', NULL, '200.00', '41.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7545, '107334', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 19:09:18', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7546, '107335', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 19:29:44', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.00', '5.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7547, '107338', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 19:58:37', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7548, '107337', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 19:55:09', 'Paid', NULL, '4.00', '4.00', '4.00', NULL, '20.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7518, '107314', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 12:14:11', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '50.00', '33.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7517, '107311', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 11:21:11', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7516, '107313', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 11:59:28', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '20.00', '12.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7515, '107304', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 10:34:45', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7514, '107308', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 10:59:16', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7513, '107302', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 09:15:26', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '15.00', '2.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7512, '107303', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-06 10:13:50', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488777303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7574, '107362', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 18:23:50', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7573, '107360', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 17:58:20', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7572, '107359', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 17:58:13', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7575, '107364', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 20:32:02', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7570, '107363', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 18:24:11', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7569, '107361', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 18:08:10', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7568, '107358', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 16:53:36', 'Paid', NULL, '101.00', '111.10', '111.10', NULL, '112.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7567, '107357', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 16:52:10', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.20', '11.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7556, '107356', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 16:30:05', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7557, '107346', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 14:19:14', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '72.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7558, '107349', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 14:52:04', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7559, '107350', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 14:56:54', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '70.00', '12.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7560, '107351', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 15:00:40', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '50.00', '33.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7561, '107347', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 14:35:11', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7562, '107353', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 15:50:36', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7563, '107348', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 14:40:37', 'Paid', NULL, '17.90', '19.70', '19.70', NULL, '20.00', '0.30', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7564, '107354', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 15:52:56', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '102.00', '50.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7565, '107352', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 15:45:35', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7566, '107355', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 15:59:24', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(7555, '107344', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 13:26:20', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7554, '107345', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 13:36:58', 'Paid', NULL, '133.00', '146.30', '146.30', NULL, '150.00', '3.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7553, '107343', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 13:18:08', 'Paid', NULL, '128.00', '140.80', '140.80', NULL, '200.00', '59.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7552, '107342', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 12:36:48', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7551, '107340', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 11:45:20', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '13.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7550, '107341', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 11:49:58', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '64.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7549, '107339', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-08 10:44:49', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1488959498', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7583, '107370', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-09 13:23:18', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '65.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489034323', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7588, '107376', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-09 17:58:21', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489034323', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7587, '107377', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-09 18:02:51', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489034323', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7586, '107374', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-09 16:07:00', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489034323', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7585, '107375', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-09 16:15:49', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '53.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489034323', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7584, '107371', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-09 13:24:42', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489034323', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7582, '107372', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-09 13:41:18', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '65.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489034323', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7581, '107373', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-09 15:34:57', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '48.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489034323', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7580, '107367', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-09 11:37:35', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489034323', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7579, '107366', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-09 11:36:42', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '20.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489034323', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7578, '107368', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-09 11:46:31', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489034323', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7577, '107365', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-09 11:11:32', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '90.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489034323', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7576, '107369', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-09 12:20:07', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489034323', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7602, '107386', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-10 14:51:08', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489123543', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7603, '107387', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-10 14:51:50', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489123543', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7606, '107393', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-10 16:54:14', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '6.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489123543', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7607, '107394', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-10 18:01:04', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489123543', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7605, '107392', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-10 16:37:25', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489123543', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7601, '107389', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-10 15:07:40', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489123543', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7599, '107385', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-10 14:31:42', 'Paid', NULL, '11.90', '13.10', '13.10', NULL, '14.00', '0.90', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1489123543', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7598, '107388', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-10 15:06:54', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489123543', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7604, '107390', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-10 15:31:41', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489123543', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7597, '107391', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-10 16:00:33', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489123543', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7595, '107384', 'T3', 10008, 'lois', NULL, NULL, 'history', '2017-03-10 14:19:54', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '49.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489123543', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7594, '107381', 'IS', 10008, 'lois', NULL, NULL, 'history', '2017-03-10 12:39:48', 'Paid', NULL, '7.50', '7.50', '7.50', NULL, '10.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489123543', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7593, '107380', 'IS', 10008, 'lois', NULL, NULL, 'history', '2017-03-10 12:37:36', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489123543', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7592, '107383', 'T13', 10008, 'lois', NULL, NULL, 'history', '2017-03-10 14:13:38', 'Paid', NULL, '88.50', '97.35', '97.35', NULL, '100.00', '2.65', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489123543', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7591, '107382', 'T7', 10008, 'lois', NULL, NULL, 'history', '2017-03-10 13:08:42', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '101.00', '50.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489123543', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7590, '107379', 'T2', 10008, 'lois', NULL, NULL, 'history', '2017-03-10 12:01:43', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489123543', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7589, '107378', 'T6', 10008, 'lois', NULL, NULL, 'history', '2017-03-10 11:49:51', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.30', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489123543', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7646, '107431', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 16:58:04', 'Paid', NULL, '3.90', '3.90', '3.90', NULL, '3.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7645, '107430', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 16:57:28', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.00', '7.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7644, '107433', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 18:42:35', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7643, '107432', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 17:25:16', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '37.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7642, '107428', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 16:34:44', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7641, '107424', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 15:54:14', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7640, '107429', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 16:48:42', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7639, '107427', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 16:08:26', 'Paid', NULL, '74.50', '81.95', '81.95', NULL, '100.00', '18.05', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7638, '107425', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 16:02:05', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7637, '107426', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 16:02:50', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '24.00', '10.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7636, '107423', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 15:33:55', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '50.00', '42.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7635, '107422', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 15:30:37', 'Paid', NULL, '93.00', '102.30', '102.30', NULL, '103.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7631, '107416', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 14:29:59', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '55.00', '4.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7632, '107417', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 14:35:44', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7633, '107420', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 15:13:21', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '46.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7634, '107421', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 15:26:40', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '29.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7630, '107419', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 14:40:48', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.30', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7627, '107415', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 14:11:53', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7628, '107414', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 14:05:42', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.80', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7629, '107418', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 14:38:46', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7624, '107411', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 12:47:30', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '50.00', '33.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7625, '107413', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 14:04:16', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7626, '107412', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 13:29:00', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '51.00', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7618, '107401', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 11:33:44', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '14.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7619, '107406', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 12:07:02', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '86.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7620, '107405', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 11:58:36', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7621, '107410', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 12:37:35', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.00', '9.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7622, '107407', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 12:24:04', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7623, '107409', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 12:35:06', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7616, '107402', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 11:38:43', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.20', '22.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7617, '107404', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 11:44:48', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '100.00', '62.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7615, '107403', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 11:40:33', 'Paid', NULL, '131.00', '144.10', '144.10', NULL, '150.20', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7613, '107400', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 10:59:58', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7614, '107408', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 12:24:53', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7612, '107399', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 10:43:38', 'Paid', NULL, '111.00', '122.10', '122.10', NULL, '150.10', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7611, '107398', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 10:34:35', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7610, '107396', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 09:55:33', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '70.00', '8.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7609, '107397', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 09:59:00', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7608, '107395', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-11 09:38:25', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489212539', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7693, '107478', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 19:29:06', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '40.00', '2.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7692, '107474', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 16:24:20', 'Paid', NULL, '12.00', '10.80', '10.80', NULL, '20.00', '9.20', '0.00', '0.00', '1.20', '0.00', 'Cash', NULL, '27', '1489299142', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7691, '107476', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 17:00:20', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7690, '107477', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 17:12:28', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7689, '107470', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 15:26:42', 'Paid', NULL, '14.00', '12.60', '12.60', NULL, '12.60', '0.00', '0.00', '0.00', '1.40', '0.00', 'Cash', NULL, '27', '1489299142', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7688, '107472', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 15:44:34', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7687, '107471', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 15:41:27', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7686, '107473', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 16:17:09', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7685, '107469', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 15:19:40', 'Paid', NULL, '173.00', '190.30', '190.30', NULL, '190.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7683, '107467', '14', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 14:38:24', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '70.00', '7.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7684, '107475', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 16:48:49', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '16.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7682, '107466', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 14:27:43', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7681, '107468', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 14:46:13', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7676, '107463', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 14:02:19', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '75.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7678, '107461', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 13:31:32', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7679, '107465', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 14:19:46', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '56.00', '20.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7680, '107464', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 14:11:44', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7677, '107460', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 13:30:59', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7670, '107458', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 13:10:25', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '100.00', '53.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7671, '107456', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 12:48:08', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '61.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7672, '107457', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 12:56:31', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '51.00', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7673, '107462', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 13:32:09', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7674, '107459', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 13:24:39', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7668, '107447', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 11:16:27', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7666, '107450', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 11:38:01', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7667, '107446', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 11:16:09', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7662, '107448', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 11:34:17', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7663, '107451', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 11:39:17', 'Paid', NULL, '95.00', '104.50', '104.50', NULL, '150.50', '46.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7664, '107452', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 11:44:39', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '100.00', '8.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7658, '107444', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 11:07:14', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.30', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7659, '107453', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 11:46:13', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '47.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7660, '107449', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 11:36:40', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7669, '107454', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 12:21:11', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7654, '107442', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 10:38:44', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7665, '107455', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 12:40:28', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7655, '107438', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 10:16:43', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.00', '5.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7656, '107443', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 10:56:49', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7657, '107445', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 11:14:59', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7653, '107440', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 10:25:14', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '51.00', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7652, '107441', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 10:28:43', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '110.00', '6.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7651, '107437', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 10:16:20', 'Paid', NULL, '96.00', '105.60', '105.60', NULL, '105.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7650, '107439', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 10:24:34', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7649, '107436', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 10:11:57', 'Paid', NULL, '82.90', '91.20', '91.20', NULL, '101.20', '10.00', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7648, '107434', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 09:50:12', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '80.00', '6.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7647, '107435', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-12 09:57:00', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489299142', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7715, '107500', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 21:22:59', 'Paid', NULL, '169.00', '185.90', '185.90', NULL, '200.00', '14.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489384397', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7716, '107501', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 21:58:57', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.20', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489384397', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7713, '107498', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 19:51:07', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489384397', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7714, '107499', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 20:10:27', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489384397', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7701, '107492', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 15:02:13', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.10', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489384397', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7711, '107496', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 19:20:34', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '50.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489384397', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7712, '107497', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 19:37:08', 'Paid', NULL, '144.00', '158.40', '158.40', NULL, '160.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489384397', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7702, '107484', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 12:07:23', 'Paid', NULL, '10.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1489384397', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7703, '107487', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 13:08:56', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489384397', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7704, '107489', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 14:20:15', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489384397', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7705, '107491', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 14:46:34', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '90.00', '5.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489384397', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7706, '107488', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 13:57:34', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489384397', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7707, '107493', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 15:24:09', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489384397', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7708, '107490', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 14:39:24', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '40.00', '16.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489384397', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7709, '107494', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 15:42:34', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489384397', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7710, '107495', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 16:37:16', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '100.40', '52.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489384397', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7700, '107483', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 11:59:52', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '13.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489384397', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7699, '107486', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 12:37:25', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489384397', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7698, '107485', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 12:10:54', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489384397', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7697, '107481', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 11:17:38', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489384397', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7696, '107482', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 11:19:34', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '80.00', '7.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489384397', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7695, '107479', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 10:02:26', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489384397', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7694, '107480', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-13 10:21:08', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.00', '41.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489384397', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7724, '107507', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-15 11:49:05', 'Paid', NULL, '7.50', '7.50', '7.50', NULL, '10.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489555735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7725, '107508', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-15 11:50:04', 'Paid', NULL, '7.50', '7.50', '7.50', NULL, '7.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489555735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7726, '107511', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-15 13:52:30', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489555735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(7727, '107512', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-15 14:21:56', 'Paid', NULL, '114.00', '125.40', '125.40', NULL, '150.00', '24.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489555735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7728, '107514', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-15 15:45:37', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489555735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7729, '107513', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-15 15:25:31', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489555735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7730, '107515', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-15 18:32:57', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489555735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7731, '107516', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-15 19:51:57', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489555735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7732, '107517', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-15 20:35:11', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '100.00', '65.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489555735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7723, '107510', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-15 13:08:47', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489555735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7722, '107506', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-15 11:46:40', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '70.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489555735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7721, '107509', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-15 11:52:15', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '100.20', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489555735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7720, '107504', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-15 10:56:14', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489555735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7719, '107505', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-15 11:05:07', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '65.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489555735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7718, '107503', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-15 10:48:01', 'Paid', NULL, '113.00', '124.30', '124.30', NULL, '130.30', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489555735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7717, '107502', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-15 10:04:47', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489555735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7754, '107540', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 17:37:40', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '39.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7755, '107537', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 17:20:14', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7756, '107538', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 17:21:48', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7757, '107539', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 17:37:35', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7758, '107542', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 18:41:56', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7759, '107541', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 18:18:04', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '20.00', '11.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7752, '107535', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 15:37:49', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7751, '107534', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 15:37:34', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7753, '107536', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 17:18:31', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '8.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7750, '107533', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 15:37:12', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7748, '107532', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 15:01:55', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7747, '107529', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 13:35:47', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7746, '107530', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 14:05:41', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7744, '107526', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 13:15:32', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7743, '107525', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 13:15:07', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7740, '107528', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 13:32:46', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7741, '107523', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 13:14:04', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7742, '107524', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 13:14:38', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7739, '107531', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 14:50:47', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7745, '107527', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 13:25:58', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '50.00', '29.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7737, '107522', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 12:43:12', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.40', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7736, '107521', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 12:05:28', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7735, '107520', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 11:50:46', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7734, '107518', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 11:14:33', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '70.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7733, '107519', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-16 11:14:48', 'Paid', NULL, '52.90', '58.20', '58.20', NULL, '60.20', '2.00', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1489640169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7793, '107574', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 20:14:43', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7794, '107575', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 20:15:16', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7795, '107577', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 20:26:50', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '25.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7788, '107569', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 17:21:54', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7789, '107570', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 17:43:24', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7790, '107572', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 18:40:24', 'Paid', NULL, '15.90', '17.50', '17.50', NULL, '17.50', '0.00', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7791, '107573', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 19:28:17', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '27.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7792, '107576', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 20:19:53', 'Paid', NULL, '131.00', '144.10', '0.00', '144.10', '144.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '1.61', 'VISA', '1.12', NULL, '0.10', '142.39', 0, NULL, NULL, NULL, NULL, '0'),
(7787, '107568', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 16:21:20', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7780, '107561', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 14:19:18', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7781, '107562', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 14:55:56', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '51.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7782, '107563', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 15:04:29', 'Paid', NULL, '87.50', '96.25', '96.25', NULL, '100.00', '3.75', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7783, '107567', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 16:10:01', 'Paid', NULL, '145.00', '159.50', '159.50', NULL, '170.00', '10.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7784, '107565', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 15:51:47', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7785, '107566', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 15:54:59', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.20', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7786, '107571', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 17:50:51', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7778, '107559', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 13:38:31', 'Paid', NULL, '158.00', '173.80', '173.80', NULL, '173.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7779, '107558', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 13:13:55', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '20.00', '12.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7777, '107564', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 15:08:10', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.00', '7.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7776, '107555', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 12:26:03', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7775, '107560', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 13:42:44', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '17.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7766, '107548', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 11:14:09', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7765, '107549', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 11:36:26', 'Paid', NULL, '10.50', '11.55', '11.55', NULL, '11.55', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7767, '107554', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 12:22:50', 'Paid', NULL, '73.50', '80.85', '80.85', NULL, '81.00', '0.15', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7769, '107551', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 11:53:12', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '31.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7770, '107557', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 12:30:45', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7771, '107552', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 12:07:09', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7772, '107556', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 12:28:34', 'Paid', NULL, '112.00', '123.20', '123.20', NULL, '125.20', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7773, '107550', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 11:36:52', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7774, '107553', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 12:09:26', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7764, '107546', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 10:56:39', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '41.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7763, '107547', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 11:13:52', 'Paid', NULL, '49.50', '54.45', '54.45', NULL, '55.00', '0.55', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7762, '107546', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 11:09:25', 'Paid', NULL, '53.50', '58.85', '58.85', NULL, '58.85', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7761, '107545', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 10:55:28', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7760, '107543', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-17 10:22:51', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489732339', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7840, '107621', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 17:28:26', 'Paid', NULL, '39.00', '39.00', '39.00', NULL, '50.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7841, '107623', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 19:24:48', 'Paid', NULL, '150.00', '165.00', '165.00', NULL, '165.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7842, '107622', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 19:04:08', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7843, '107624', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 19:49:56', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '40.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7838, '107620', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 16:39:13', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7839, '107619', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 16:33:43', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '10.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7837, '107615', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 15:11:02', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '100.20', '54.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7834, '107613', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 14:37:19', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7835, '107618', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 15:44:00', 'Paid', NULL, '103.00', '113.30', '113.30', NULL, '113.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7836, '107614', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 14:58:22', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7833, '107617', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 15:33:26', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7831, '107607', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 13:40:11', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7832, '107608', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 13:47:53', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.30', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7829, '107603', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 13:12:13', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7830, '107612', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 14:31:14', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '65.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7826, '107604', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 13:14:57', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7827, '107605', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 13:16:25', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7828, '107611', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 14:16:34', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7823, '107602', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 13:07:57', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7824, '107601', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 13:06:28', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7825, '107610', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 14:10:33', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7815, '107606', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 13:21:39', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '72.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7816, '107598', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 13:02:48', 'Paid', NULL, '117.00', '128.70', '128.70', NULL, '150.00', '21.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7817, '107609', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 13:54:07', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '60.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7818, '107597', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 12:30:19', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7819, '107599', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 13:04:56', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '80.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7820, '107616', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 15:12:58', 'Paid', NULL, '121.00', '133.10', '133.10', NULL, '150.10', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7821, '107596', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 12:06:16', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7822, '107600', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 13:05:37', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '81.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7813, '107592', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 11:28:22', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7814, '107595', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 11:50:05', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '100.00', '68.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7812, '107587', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 10:57:00', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '20.00', '12.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7811, '107593', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 11:36:04', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7802, '107594', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 11:42:30', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7809, '107589', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 11:00:58', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7810, '107591', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 11:20:56', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '80.00', '1.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7808, '107588', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 10:59:56', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7807, '107586', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 10:44:00', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7806, '107585', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 10:42:00', 'Paid', NULL, '84.50', '92.95', '92.95', NULL, '100.00', '7.05', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7805, '107590', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 11:08:33', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7804, '107584', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 10:36:53', 'Paid', NULL, '166.00', '182.60', '182.60', NULL, '200.00', '17.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7803, '107583', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 10:17:50', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '100.10', '66.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7801, '107582', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 10:15:59', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '80.50', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7800, '107581', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 09:59:04', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '35.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7798, '107579', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 09:35:29', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7797, '107578', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 09:15:39', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '43.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7799, '107580', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-18 09:51:15', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.30', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489833380', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7874, '107655', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 18:29:45', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7875, '107658', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 18:43:07', 'Paid', NULL, '92.00', '101.20', '101.20', NULL, '101.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7876, '107657', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 18:42:15', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '100.00', '8.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7877, '107656', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 18:30:05', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7878, '107659', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 18:44:36', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '69.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7879, '107660', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 19:02:07', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '100.00', '53.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7880, '107661', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 19:32:03', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '40.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7870, '107652', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 16:22:17', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '57.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7871, '107651', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 15:50:12', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7872, '107654', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 17:54:29', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.30', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7873, '107653', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 16:57:33', 'Paid', NULL, '129.00', '141.90', '141.90', NULL, '160.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7861, '107641', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 12:56:09', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7862, '107639', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 12:21:21', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '10.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7863, '107643', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 13:10:04', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7864, '107646', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 14:14:08', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7865, '107644', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 13:48:17', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7866, '107645', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 13:50:02', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.00', '15.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7867, '107648', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 14:46:51', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7869, '107649', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 14:50:33', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7868, '107647', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 14:45:42', 'Paid', NULL, '84.00', '84.00', '84.00', NULL, '85.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7851, '107634', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 11:30:15', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7852, '107631', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 11:11:27', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.00', '2.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7853, '107635', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 11:37:58', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '80.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7854, '107636', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 11:39:57', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7855, '107633', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 11:23:08', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7856, '107640', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 12:50:41', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '67.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7857, '107637', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 11:54:42', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '28.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(7858, '107638', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 12:15:25', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '58.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7859, '107642', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 13:09:33', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7860, '107650', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 15:40:25', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7849, '107626', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 10:14:15', 'Paid', NULL, '14.90', '14.90', '14.90', NULL, '50.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7850, '107632', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 11:22:07', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7848, '107630', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 10:33:59', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7847, '107627', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 10:15:08', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '110.00', '12.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7846, '107629', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 10:21:11', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7845, '107625', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 09:50:54', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '89.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7844, '107628', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-03-19 10:18:53', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1489916754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7912, '107691', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 21:43:20', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7908, '107686', 'T14(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 20:51:18', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7907, '107687', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 21:17:44', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7909, '107688', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 21:25:02', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.30', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7910, '107692', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 21:55:44', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7911, '107689', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 21:37:03', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7898, '107675', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 16:21:47', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7899, '107680', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 17:02:09', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7900, '107678', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 16:58:19', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7901, '107682', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 18:35:49', 'Paid', NULL, '101.00', '111.10', '111.10', NULL, '111.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7902, '107684', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 20:00:47', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7903, '107690', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 21:40:05', 'Paid', NULL, '203.00', '223.30', '223.30', NULL, '223.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7904, '107683', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 19:51:04', 'Paid', NULL, '10.00', '9.00', '9.00', NULL, '50.00', '41.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1490013893', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7905, '107685', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 20:10:21', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7886, '107668', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 11:21:45', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7887, '107669', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 11:45:14', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '70.00', '10.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7888, '107667', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 11:20:56', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7889, '107670', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 13:08:58', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7890, '107671', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 14:02:10', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7891, '107672', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 14:59:23', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7892, '107673', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 15:07:31', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7893, '107674', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 15:52:48', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7894, '107681', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 17:27:32', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.20', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7895, '107677', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 16:52:31', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '100.00', '63.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7896, '107679', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 17:00:12', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7897, '107676', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 16:50:00', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7885, '107664', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 10:28:14', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7884, '107665', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 10:30:37', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7882, '107663', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 10:25:47', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7883, '107662', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 10:19:28', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '100.00', '42.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7881, '107666', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-20 10:42:36', 'Paid', NULL, '104.00', '114.40', '114.40', NULL, '120.00', '5.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490013893', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7931, '107711', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 15:46:52', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490161551', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7932, '107709', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 15:09:38', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '51.00', '35.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490161551', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7933, '107714', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 16:21:15', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490161551', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7934, '107712', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 15:58:04', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '50.00', '39.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490161551', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7935, '107713', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 15:58:45', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490161551', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7936, '107715', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 18:44:58', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '51.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490161551', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7917, '107698', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 12:06:21', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490161551', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7918, '107696', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 11:28:51', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.40', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490161551', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7919, '107697', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 12:04:28', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490161551', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7920, '107701', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 13:02:20', 'Paid', NULL, '509.00', '503.90', '503.90', NULL, '504.00', '0.10', '0.00', '0.00', '55.99', '-0.01', 'Cash', NULL, '27', '1490161551', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7921, '107699', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 12:43:05', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '40.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490161551', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7922, '107700', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 12:43:32', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490161551', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7924, '107702', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 13:49:00', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490161551', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7925, '107705', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 14:44:02', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490161551', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7926, '107708', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 15:08:51', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490161551', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7927, '107707', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 14:57:55', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490161551', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7928, '107703', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 14:20:25', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490161551', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7929, '107704', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 14:43:36', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490161551', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7930, '107710', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 15:27:27', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490161551', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7923, '107706', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 14:45:43', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490161551', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7915, '107695', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 11:26:51', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490161551', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7916, '107694', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 11:18:20', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.70', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490161551', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7913, '107693', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-22 10:21:17', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '100.00', '6.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490161551', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7959, '107736', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-23 17:49:47', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490247953', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7953, '107730', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-23 15:01:19', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490247953', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7955, '107735', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-23 16:51:23', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '26.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490247953', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7956, '107734', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-23 16:36:58', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490247953', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7957, '107732', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-23 15:20:36', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '25.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490247953', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7938, '107718', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-23 11:41:13', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '57.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490247953', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7939, '107717', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-23 11:16:01', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490247953', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7940, '107719', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-23 12:31:28', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490247953', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7941, '107727', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-23 14:40:00', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490247953', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7942, '107720', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-23 13:09:26', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490247953', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7943, '107721', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-23 13:33:31', 'Paid', NULL, '180.00', '198.00', '198.00', NULL, '200.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490247953', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7945, '107725', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-23 13:58:05', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490247953', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7947, '107724', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-23 13:57:54', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490247953', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7954, '107731', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-23 15:15:16', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490247953', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7949, '107726', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-23 14:39:13', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490247953', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7950, '107733', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-23 16:23:18', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '57.00', '30.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490247953', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7951, '107728', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-23 14:48:33', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490247953', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7952, '107729', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-23 14:48:59', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490247953', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7946, '107722', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-23 13:37:00', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490247953', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7944, '107723', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-23 13:46:04', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490247953', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7937, '107716', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-23 10:24:40', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490247953', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7982, '107761', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 20:49:55', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7983, '107759', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 20:47:43', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '27.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7984, '107760', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 20:48:00', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7981, '107758', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 20:06:45', 'Paid', NULL, '115.00', '126.50', '126.50', NULL, '126.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7969, '107747', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 12:09:33', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7970, '107752', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 14:32:47', 'Paid', NULL, '129.00', '141.90', '141.90', NULL, '152.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7971, '107746', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 12:06:49', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7972, '107749', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 12:49:56', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7973, '107748', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 12:43:46', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '100.00', '50.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7974, '107750', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 13:28:10', 'Paid', NULL, '114.00', '125.40', '125.40', NULL, '126.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7975, '107751', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 13:37:16', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.40', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7976, '107753', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 14:43:25', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '75.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7977, '107754', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 15:17:15', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '51.00', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7978, '107755', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 15:53:29', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7979, '107756', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 16:21:05', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7980, '107757', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 18:21:54', 'Paid', NULL, '20.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', '2.00', '0.00', 'Cash', NULL, '27', '1490332569', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7963, '107738', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 10:26:40', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7964, '107740', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 10:47:01', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7965, '107742', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 11:12:55', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.60', '39.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7966, '107744', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 11:15:31', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7967, '107745', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 11:43:46', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7968, '107741', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 10:47:52', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7961, '107739', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 10:28:38', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7962, '107743', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 11:14:55', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7960, '107737', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-24 09:15:17', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '16.50', '-7.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490332569', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8012, '107793', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 18:35:25', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8013, '107788', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 17:08:49', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8014, '107790', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 17:38:24', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8015, '107787', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 16:39:43', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8016, '107789', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 17:23:40', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '19.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8017, '107791', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 17:55:39', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8018, '107792', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 18:07:38', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8011, '107785', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 15:10:16', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8008, '107779', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 14:55:44', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8009, '107782', 'T1(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 15:05:12', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8010, '107783', 'T1(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 15:06:11', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.20', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(7999, '107773', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 12:54:05', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7997, '107780', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 15:02:02', 'Paid', NULL, '150.50', '165.55', '165.55', NULL, '166.00', '0.45', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7998, '107770', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 12:35:42', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7986, '107767', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 11:51:00', 'Paid', NULL, '104.00', '114.40', '114.40', NULL, '120.00', '5.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8007, '107784', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 15:06:51', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.20', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8006, '107781', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 15:04:14', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8005, '107778', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 14:38:40', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8004, '107775', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 14:25:49', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8003, '107786', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 15:20:16', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8002, '107777', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 14:29:34', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '100.00', '52.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8001, '107776', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 14:29:03', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.20', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8000, '107774', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 13:01:42', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7987, '107765', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 11:30:41', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7988, '107764', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 11:11:59', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7989, '107763', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 10:33:18', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7990, '107769', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 12:23:14', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.70', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7991, '107768', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 12:19:27', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '88.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7995, '107772', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 12:44:58', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '70.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7994, '107766', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 11:42:36', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '100.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(7996, '107771', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 12:43:24', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '46.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(7985, '107762', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-25 09:08:29', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490422947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8048, '107816', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 13:57:48', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '20.70', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8047, '107815', 'T7(S)(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 13:51:08', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '29.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8049, '107818', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 14:33:03', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '34.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8050, '107822', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 15:07:53', 'Paid', NULL, '93.00', '102.30', '102.30', NULL, '102.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8051, '107821', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 15:00:18', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(8052, '107824', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 15:13:24', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '25.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8053, '107825', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 15:17:52', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8054, '107827', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 16:57:57', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8055, '107826', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 16:09:55', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8056, '107828', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 17:14:50', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8044, '107813', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 13:49:19', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '0.00', '-46.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8041, '107820', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 14:51:56', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8042, '107817', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 14:02:02', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.00', '20.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8043, '107823', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 15:10:28', 'Paid', NULL, '98.00', '107.80', '107.80', NULL, '110.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8021, '107795', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 10:05:55', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '102.00', '40.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8022, '107794', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 09:35:59', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8023, '107796', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 10:12:03', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '100.30', '75.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8024, '107798', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 10:34:10', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8025, '107799', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 10:42:34', 'Paid', NULL, '51.50', '56.65', '56.65', NULL, '100.00', '43.35', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8026, '107801', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 10:52:38', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8027, '107802', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 10:53:19', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8028, '107803', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 11:43:53', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.10', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8029, '107804', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 11:47:15', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8035, '107808', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 12:29:51', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8031, '107812', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 13:39:49', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8020, '107797', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 10:18:06', 'Paid', NULL, '193.00', '212.30', '212.30', NULL, '212.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8032, '107805', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 11:54:15', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8033, '107806', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 12:07:00', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8034, '107807', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 12:07:29', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8046, '107814', 'T7(S)(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 13:50:37', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8037, '107810', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 13:29:11', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '101.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8038, '107811', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 13:37:07', 'Paid', NULL, '160.00', '176.00', '176.00', NULL, '200.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8039, '107809', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 13:23:48', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8040, '107819', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 14:36:46', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.50', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8019, '107800', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-26 10:44:17', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490506376', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8083, '107853', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 19:25:32', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.40', '3.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8084, '107854', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 19:26:58', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8085, '107856', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 20:57:17', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8058, '107834', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 10:57:15', 'Paid', NULL, '104.00', '114.40', '114.40', NULL, '120.50', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8059, '107833', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 10:38:48', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8060, '107830', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 10:17:00', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8061, '107831', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 10:22:31', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8062, '107836', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 11:46:56', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '35.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8063, '107832', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 10:34:20', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8064, '107835', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 11:36:01', 'Paid', NULL, '110.00', '121.00', '121.00', NULL, '121.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8065, '107838', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 12:14:10', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '57.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8066, '107837', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 12:01:33', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '93.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8067, '107840', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 13:42:28', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '45.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8068, '107839', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 12:56:38', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '35.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8069, '107841', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 14:13:45', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8070, '107842', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 14:15:11', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8080, '107851', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 17:04:27', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8072, '107849', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 16:15:35', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '50.00', '44.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8073, '107843', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 14:19:16', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '13.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8074, '107844', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 15:12:30', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8075, '107848', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 16:15:04', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '40.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8076, '107847', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 15:58:06', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '40.00', '14.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8077, '107850', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 16:17:26', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.50', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8078, '107845', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 15:51:07', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '30.10', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8079, '107846', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 15:52:43', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8081, '107855', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 20:57:01', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8082, '107852', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 19:05:09', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8057, '107829', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-27 10:15:16', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490600459', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8087, '107857', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 09:20:30', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8088, '107859', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 09:31:09', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.70', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8097, '107871', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 12:52:25', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8090, '107860', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 11:23:41', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8091, '107865', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 11:41:42', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8092, '107866', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 11:51:27', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8093, '107861', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 11:26:45', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8094, '107862', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 11:27:16', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8095, '107863', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 11:29:10', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8096, '107864', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 11:30:56', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8099, '107872', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 13:22:33', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '60.00', '8.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8100, '107873', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 13:55:26', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8101, '107867', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 12:49:17', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8102, '107868', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 12:49:32', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '45.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8103, '107869', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 12:49:43', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '28.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8104, '107870', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 12:49:52', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8106, '107884', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 16:21:20', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '34.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8107, '107876', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 14:19:17', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '40.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8108, '107874', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 13:59:30', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8109, '107875', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 14:04:56', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8110, '107878', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 14:36:33', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8111, '107877', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 14:22:43', 'Paid', NULL, '92.00', '101.20', '101.20', NULL, '101.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8112, '107882', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 15:53:18', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8113, '107879', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 14:39:22', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8114, '107883', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 16:06:53', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '8.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8115, '107881', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 15:53:01', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8116, '107880', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 15:11:47', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '31.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8117, '107886', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 17:50:46', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8118, '107887', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 17:57:45', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '35.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8119, '107885', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 17:29:02', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '50.00', '19.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8086, '107858', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-29 09:20:59', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490764197', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8140, '107907', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 16:38:30', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8141, '107905', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 16:24:19', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8142, '107909', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 17:26:35', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.00', '30.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8143, '107910', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 17:35:56', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '56.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8146, '107911', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 17:43:12', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '20.00', '13.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8144, '107914', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 19:48:54', 'Paid', NULL, '98.00', '107.80', '107.80', NULL, '110.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8145, '107908', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 17:19:09', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '25.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8139, '107913', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 19:07:35', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '31.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8138, '107903', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 16:14:48', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8137, '107906', 't1', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 16:37:22', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8136, '107912', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 17:45:15', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '27.00', '10.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8135, '107900', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 14:28:40', 'Paid', NULL, '17.90', '19.70', '19.70', NULL, '50.00', '30.30', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8134, '107899', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 14:25:55', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8133, '107901', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 14:32:05', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '40.20', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8132, '107904', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 16:20:39', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8131, '107895', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 13:57:13', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '105.00', '79.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8130, '107902', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 15:21:54', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '50.00', '35.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8129, '107897', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 14:02:16', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8128, '107898', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 14:03:02', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '65.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8121, '107888', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 10:19:31', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8122, '107892', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 12:48:11', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8123, '107890', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 12:09:12', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '5.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8124, '107894', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 13:36:06', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8125, '107891', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 12:38:36', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8126, '107893', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 13:09:24', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8127, '107896', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 14:00:18', 'Paid', NULL, '131.00', '144.10', '144.10', NULL, '150.00', '5.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8120, '107889', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-30 10:26:56', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490846116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8171, '107935', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-31 19:38:29', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '100.00', '65.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490954852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8170, '107933', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-31 18:18:00', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '51.00', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490954852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8168, '107932', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-31 17:10:57', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490954852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8165, '107931', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-31 15:25:52', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '50.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490954852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8162, '107928', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-03-31 13:50:51', 'Paid', NULL, '95.00', '104.50', '104.50', NULL, '105.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490954852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8163, '107929', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-03-31 13:53:57', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '50.00', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490954852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8169, '107934', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-03-31 19:05:55', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '40.00', '8.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490954852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8148, '107915', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-31 09:57:10', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490954852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8149, '107918', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-31 11:28:23', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490954852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8158, '107926', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-03-31 13:43:42', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490954852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8159, '107923', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-03-31 13:00:33', 'Paid', NULL, '31.90', '35.10', '35.10', NULL, '35.10', '0.00', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1490954852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8160, '107927', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-31 13:45:25', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490954852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8161, '107930', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-31 15:08:53', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490954852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8155, '107925', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-03-31 13:29:41', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490954852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8151, '107917', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-31 11:12:05', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '100.00', '60.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490954852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8152, '107919', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-31 11:38:37', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490954852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8153, '107920', 'T14(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-31 11:45:37', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490954852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8154, '107921', 'T14(S)', 10003, 'admin', NULL, NULL, 'history', '2017-03-31 11:46:03', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '37.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490954852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8156, '107922', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-03-31 12:46:28', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490954852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8157, '107924', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-03-31 13:01:03', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490954852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8147, '107916', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-03-31 10:16:03', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1490954852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8200, '107965', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 18:19:58', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '70.00', '16.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8201, '107964', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 18:19:32', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '27.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8191, '107954', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 14:52:06', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '90.00', '3.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8192, '107956', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 14:59:44', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '13.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8193, '107953', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 14:50:28', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8194, '107951', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 14:31:51', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '100.10', '55.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8195, '107957', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 15:01:27', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '40.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8196, '107960', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 16:07:53', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8197, '107961', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 17:01:56', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '27.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8198, '107955', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 14:58:58', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(8199, '107962', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 17:20:14', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '50.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8189, '107958', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 15:05:30', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8190, '107959', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 15:33:52', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.40', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8180, '107944', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 11:58:36', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '75.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8181, '107943', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 11:53:33', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '100.00', '85.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8182, '107947', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 12:40:47', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8183, '107946', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 12:39:31', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8184, '107948', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 12:50:48', 'Paid', NULL, '50.50', '55.55', '55.55', NULL, '55.60', '0.05', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8185, '107949', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 13:32:34', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8186, '107952', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 14:40:57', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8187, '107950', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 14:00:53', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '70.20', '14.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8188, '107963', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 18:18:54', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8175, '107938', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 10:55:02', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '60.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8179, '107945', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 12:25:18', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8178, '107939', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 10:58:41', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8176, '107941', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 11:09:41', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.80', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8177, '107940', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 11:00:45', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '80.10', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8174, '107942', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 11:18:03', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.00', '9.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8173, '107936', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 09:50:11', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8172, '107937', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-01 10:16:17', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491026052', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8246, '108009', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 20:08:43', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8247, '108011', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 21:13:57', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8243, '108007', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 18:43:30', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8244, '108008', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 20:05:35', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8245, '108010', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 20:53:17', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8241, '108005', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 18:03:23', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8242, '108006', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 18:22:30', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8240, '108003', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 16:50:14', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '20.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8239, '108002', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 16:48:18', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '30.10', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8238, '108001', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 16:30:48', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8222, '107984', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 13:45:36', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8223, '107992', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 14:44:39', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.10', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8224, '107985', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 14:03:21', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '54.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8225, '107988', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 14:07:22', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '102.00', '40.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8226, '107990', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 14:37:23', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8227, '107989', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 14:29:00', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8228, '107991', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 14:39:13', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8229, '107996', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 16:01:43', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '60.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8230, '107994', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 15:17:42', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8231, '107993', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 15:04:00', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '100.00', '51.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8232, '107995', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 15:37:10', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8233, '108000', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 16:26:12', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8234, '108004', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 17:04:36', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8235, '107999', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 16:25:01', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '25.10', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8236, '107997', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 16:02:22', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8237, '107998', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 16:14:45', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8221, '107986', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 14:04:38', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '103.00', '29.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8220, '107981', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 13:05:38', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8208, '107971', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 11:19:53', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '63.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8209, '107973', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 11:33:01', 'Paid', NULL, '86.50', '95.15', '95.15', NULL, '100.00', '4.85', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8210, '107975', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 12:01:02', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8211, '107974', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 11:54:00', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.00', '2.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8212, '107976', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 12:01:56', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '55.20', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8213, '107977', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 12:03:29', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.20', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8214, '107978', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 12:09:05', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8215, '107987', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 14:05:21', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8216, '107980', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 12:40:04', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '100.00', '49.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8217, '107979', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 12:39:17', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8218, '107982', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 13:34:07', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8219, '107983', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 13:39:51', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '42.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8205, '107969', '13', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 10:46:55', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '49.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8206, '107970', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 11:16:51', 'Paid', NULL, '95.00', '104.50', '104.50', NULL, '105.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8207, '107972', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 11:22:28', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.20', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8204, '107967', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 10:34:12', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8203, '107968', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 10:38:12', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '90.00', '16.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8202, '107966', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-02 10:16:55', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491109946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8266, '108027', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 15:01:59', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8267, '108029', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 15:40:58', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '83.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8268, '108031', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 16:21:43', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8269, '108033', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 17:06:41', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8270, '108038', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 18:30:44', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '50.00', '41.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8271, '108034', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 17:20:47', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '51.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8272, '108035', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 17:55:29', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8273, '108037', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 18:07:36', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8274, '108036', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 17:55:59', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8275, '108039', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 18:36:10', 'Paid', NULL, '28.90', '31.80', '31.80', NULL, '50.00', '18.20', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8251, '108016', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 11:24:03', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '17.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8252, '108017', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 11:32:49', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8253, '108014', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 11:12:07', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8254, '108032', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 16:59:48', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8255, '108020', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 13:49:12', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '103.70', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8256, '108019', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 13:23:33', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8257, '108018', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 13:19:57', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '100.20', '77.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8258, '108024', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 14:38:00', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8259, '108023', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 14:36:50', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.00', '19.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8260, '108026', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 14:41:44', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '56.40', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8261, '108021', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 13:56:52', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8262, '108028', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 15:35:07', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '101.30', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8263, '108022', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 14:27:23', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8264, '108025', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 14:39:47', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8265, '108030', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 16:11:45', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.30', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8250, '108013', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 10:59:15', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8249, '108012', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 09:49:41', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8248, '108015', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-03 11:23:32', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491196225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8280, '108045', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-05 12:49:58', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491439793', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8281, '108042', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-04-05 12:03:36', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491439793', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8282, '108043', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-05 12:44:28', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.00', '15.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491439793', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8283, '108052', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-05 14:21:57', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491439793', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8284, '108047', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-05 13:26:11', 'Paid', NULL, '86.50', '95.15', '95.15', NULL, '100.20', '5.05', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491439793', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8285, '108048', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-05 13:39:10', 'Paid', NULL, '101.00', '111.10', '111.10', NULL, '111.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491439793', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8286, '108046', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-05 13:14:06', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491439793', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8287, '108049', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-05 13:47:20', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491439793', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8288, '108054', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-05 14:27:14', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491439793', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8290, '108053', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-05 14:26:28', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.20', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491439793', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8292, '108050', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-05 14:13:07', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '7.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491439793', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8293, '108051', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-05 14:19:54', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.30', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491439793', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8279, '108041', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-05 11:35:06', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491439793', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8278, '108044', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-05 12:45:20', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.00', '37.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491439793', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8276, '108040', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-04-05 10:44:40', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '100.20', '76.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491439793', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8297, '108057', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-06 10:52:56', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '52.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491473587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8298, '108059', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-04-06 12:02:29', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.00', '20.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491473587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8299, '108061', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-06 12:28:24', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491473587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8300, '108060', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-06 12:21:25', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491473587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8301, '108062', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-06 12:47:06', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.80', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491473587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8302, '108063', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-06 13:30:50', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '101.00', '50.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491473587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8303, '108065', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-06 14:29:22', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '86.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491473587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8304, '108066', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-06 14:41:19', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491473587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8305, '108064', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-06 14:02:07', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '50.00', '41.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491473587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8306, '108067', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-06 14:56:35', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491473587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8307, '108068', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-06 17:30:49', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491473587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8308, '108069', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-06 18:01:06', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491473587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8309, '108070', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-06 18:52:13', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491473587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8310, '108072', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-06 19:12:01', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491473587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8311, '108071', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-06 18:59:26', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491473587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8296, '108058', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-06 10:58:53', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491473587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8295, '108056', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-06 10:46:56', 'Paid', NULL, '43.00', '43.00', '43.00', NULL, '100.00', '57.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491473587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8294, '108055', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-06 10:31:33', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491473587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8330, '108089', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-07 15:10:40', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491543364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8329, '108086', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-07 14:25:38', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '38.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491543364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8328, '108084', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-07 14:24:43', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491543364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8327, '108083', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-07 14:24:14', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491543364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8326, '108087', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-07 14:26:10', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491543364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8325, '108088', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-07 14:42:27', 'Paid', NULL, '95.00', '104.50', '104.50', NULL, '105.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491543364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8324, '108085', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-07 14:25:30', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491543364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8323, '108082', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-07 13:24:10', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '30.10', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491543364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8322, '108081', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-07 13:23:54', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.50', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491543364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8321, '108079', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-07 11:37:45', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '30.00', '4.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491543364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8320, '108080', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-07 11:41:57', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491543364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8318, '108090', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-07 17:25:30', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491543364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8319, '108077', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-07 11:02:17', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.10', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491543364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8317, '108076', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-07 10:37:13', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491543364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8315, '108078', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-07 11:04:47', 'Paid', NULL, '103.00', '113.30', '113.30', NULL, '113.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491543364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8314, '108074', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-07 10:31:28', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '20.00', '11.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491543364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8313, '108073', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-07 10:18:56', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '60.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491543364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8312, '108075', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-07 10:35:57', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '102.60', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491543364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8371, '108129', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 18:54:38', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8372, '108130', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 18:54:42', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(8370, '108126', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 17:42:07', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8367, '108127', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 18:53:24', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '100.00', '60.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8368, '108124', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 17:13:39', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.50', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8369, '108125', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 17:19:26', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8365, '108118', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 13:59:41', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8366, '108123', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 16:37:55', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8362, '108122', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 15:41:19', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8363, '108117', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 13:59:04', 'Paid', NULL, '4.50', '4.50', '4.50', NULL, '4.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8361, '108121', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 14:51:13', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '53.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8360, '108128', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 18:54:23', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8359, '108119', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 14:03:04', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8358, '108116', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 13:40:41', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '40.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8357, '108120', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 14:46:51', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '40.00', '5.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8356, '108114', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 13:09:48', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8355, '108115', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 13:13:18', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8354, '108113', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 12:59:59', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '23.00', '9.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8352, '108112', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 12:07:25', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.20', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8353, '108106', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 11:20:25', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8351, '108111', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 11:59:13', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '34.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8350, '108131', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 18:55:22', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8338, '108102', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 10:45:21', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '63.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8340, '108094', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 10:13:43', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '20.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8341, '108095', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 10:18:57', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8342, '108096', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 10:19:44', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '20.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8343, '108105', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 11:14:17', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '100.00', '47.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8344, '108098', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 10:24:31', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8345, '108110', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 11:48:57', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '55.00', '3.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8346, '108104', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 11:06:19', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8347, '108107', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 11:22:59', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.20', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8348, '108109', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 11:40:49', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8349, '108108', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 11:24:03', 'Paid', NULL, '14.90', '16.40', '16.40', NULL, '20.00', '3.60', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8339, '108093', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 10:13:09', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '7.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8336, '108101', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 10:36:28', 'Paid', NULL, '93.00', '102.30', '102.30', NULL, '102.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8337, '108100', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 10:29:47', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '40.20', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8334, '108099', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 10:27:55', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '60.00', '8.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8335, '108103', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 10:45:58', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '40.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8333, '108097', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 10:21:07', 'Paid', NULL, '143.00', '157.30', '157.30', NULL, '157.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8332, '108091', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 10:09:20', 'Paid', NULL, '100.00', '110.00', '110.00', NULL, '110.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8331, '108092', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-08 10:11:06', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491644494', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8413, '108170', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 17:00:28', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8412, '108167', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 16:08:31', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '102.00', '40.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8411, '108172', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 17:27:12', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '52.70', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8410, '108169', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 16:42:02', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8407, '108168', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 16:11:16', 'Paid', NULL, '21.50', '23.65', '23.65', NULL, '100.00', '76.35', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8408, '108171', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 17:17:36', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8409, '108166', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 15:57:44', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '58.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8405, '108163', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 15:48:29', 'Paid', NULL, '105.00', '115.50', '115.50', NULL, '120.00', '4.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8406, '108165', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 15:54:20', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '55.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8404, '108161', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 15:02:08', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8402, '108162', '13', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 15:15:23', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8403, '108158', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 14:43:04', 'Paid', NULL, '95.00', '104.50', '104.50', NULL, '120.00', '15.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8401, '108159', '12', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 14:47:41', 'Paid', NULL, '161.00', '177.10', '177.10', NULL, '177.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8397, '108157', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 14:22:13', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8400, '108160', '14', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 14:57:15', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8399, '108153', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 14:08:19', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '78.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8398, '108155', '11', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 14:14:52', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8396, '108154', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 14:13:16', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '70.00', '7.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8395, '108152', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 13:47:09', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8393, '108150', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 13:16:22', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8394, '108151', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 13:38:43', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.40', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8386, '108145', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 12:24:46', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '69.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8387, '108144', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 12:17:56', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '40.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8388, '108151', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 13:17:44', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.20', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8389, '108156', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 14:20:57', 'Paid', NULL, '110.00', '121.00', '121.00', NULL, '121.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8390, '108147', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 12:46:19', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8391, '108148', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 12:56:15', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '101.30', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8392, '108164', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 15:51:30', 'Paid', NULL, '109.00', '119.90', '119.90', NULL, '120.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8380, '108140', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 11:22:13', 'Paid', NULL, '116.00', '127.60', '127.60', NULL, '150.00', '22.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8381, '108138', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 11:18:10', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8382, '108141', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 11:29:38', 'Paid', NULL, '147.00', '161.70', '161.70', NULL, '161.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8383, '108142', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 11:41:53', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.60', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8384, '108146', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 12:37:32', 'Paid', NULL, '172.00', '170.30', '170.30', NULL, '200.30', '30.00', '0.00', '0.00', '18.92', '0.02', 'Cash', NULL, '27', '1491724084', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8385, '108143', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 11:56:43', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8376, '108135', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 10:34:46', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8377, '108137', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 10:58:50', 'Paid', NULL, '224.00', '246.40', '246.40', NULL, '250.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8379, '108133', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 10:16:51', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8378, '108139', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 11:19:45', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8375, '108136', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 10:56:30', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '62.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8374, '108134', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 10:18:46', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '90.00', '5.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8373, '108132', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-09 09:50:33', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491724084', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8434, '108192', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-10 18:39:19', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491804960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8427, '108184', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-10 15:01:26', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '50.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491804960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8428, '108193', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-10 18:40:25', 'Paid', NULL, '128.00', '140.80', '140.80', NULL, '150.80', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491804960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8429, '108187', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-10 16:36:10', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491804960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8430, '108190', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-10 17:32:47', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491804960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8431, '108191', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-10 18:22:03', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491804960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8432, '108189', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-10 17:23:57', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '42.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491804960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8433, '108188', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-10 17:20:29', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491804960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8419, '108179', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-10 13:38:42', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '107.00', '50.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491804960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8420, '108178', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-10 13:34:20', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.00', '3.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491804960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8421, '108182', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-10 14:35:17', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491804960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8422, '108180', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-10 14:20:38', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '86.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491804960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8423, '108183', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-10 14:46:41', 'Paid', NULL, '119.00', '130.90', '130.90', NULL, '150.00', '19.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491804960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8424, '108181', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-10 14:33:34', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '15.10', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491804960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8425, '108185', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-04-10 15:51:22', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '100.40', '77.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491804960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8426, '108186', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-04-10 16:18:58', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.70', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491804960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8417, '108175', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-10 12:06:54', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '100.00', '56.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491804960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8418, '108177', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-10 12:41:08', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491804960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8416, '108176', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-10 12:34:18', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491804960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8415, '108174', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-10 11:30:44', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491804960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8414, '108173', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-10 10:44:58', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491804960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8454, '108213', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 18:52:07', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491958305', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8455, '108216', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 19:40:34', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491958305', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8456, '108214', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 19:24:03', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.10', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491958305', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8457, '108215', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 19:29:00', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491958305', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8448, '108207', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 16:42:48', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491958305', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8449, '108209', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 17:41:08', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491958305', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8450, '108208', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 17:15:45', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491958305', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8451, '108211', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 18:32:48', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491958305', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8452, '108212', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 18:49:17', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '100.00', '67.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491958305', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8453, '108210', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 18:22:41', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491958305', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8438, '108196', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 11:25:58', 'Paid', NULL, '12.00', '10.80', '10.80', NULL, '20.00', '9.20', '0.00', '0.00', '1.20', '0.00', 'Cash', NULL, '27', '1491958305', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8439, '108199', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 14:14:10', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491958305', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8440, '108198', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 14:06:09', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '110.00', '52.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491958305', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8441, '108200', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 14:21:10', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491958305', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8442, '108201', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 14:43:59', 'Paid', NULL, '16.00', '15.85', '15.85', NULL, '20.00', '4.15', '0.00', '0.00', '1.76', '0.01', 'Cash', NULL, '27', '1491958305', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8443, '108202', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 14:45:42', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '55.20', '32.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491958305', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8444, '108203', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 14:56:34', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491958305', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8445, '108206', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 16:18:28', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491958305', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8446, '108205', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 15:55:26', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491958305', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8447, '108204', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 15:18:45', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491958305', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8437, '108197', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 12:06:10', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491958305', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8436, '108195', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 10:16:25', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491958305', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8435, '108194', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-12 09:44:30', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1491958305', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8461, '108219', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-13 09:47:05', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '100.00', '82.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492052191', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8462, '108222', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-13 12:05:04', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '90.00', '4.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492052191', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8463, '108221', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-13 11:50:17', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492052191', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8464, '108224', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-13 12:52:58', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492052191', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8465, '108225', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-13 12:53:59', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492052191', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8466, '108223', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-13 12:48:01', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492052191', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8467, '108226', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-13 14:01:13', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492052191', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8468, '108227', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-13 14:23:01', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492052191', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8469, '108228', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-13 15:18:40', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.30', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492052191', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8470, '108229', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-13 16:11:33', 'Paid', NULL, '33.50', '36.85', '36.85', NULL, '50.00', '13.15', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492052191', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8471, '108230', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-13 17:33:05', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492052191', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8460, '108220', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-13 11:33:57', 'Paid', NULL, '173.00', '190.30', '190.30', NULL, '200.00', '9.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492052191', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8459, '108218', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-13 09:15:33', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492052191', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8458, '108217', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-13 09:07:13', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '100.00', '72.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492052191', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8492, '108250', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 15:52:36', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '51.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8493, '108253', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 17:17:20', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8494, '108251', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 16:16:01', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '40.00', '14.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8495, '108252', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 16:46:07', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '40.00', '3.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8491, '108248', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 15:12:25', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '83.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8490, '108249', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 15:14:34', 'Paid', NULL, '75.00', '82.50', '0.00', '82.50', '82.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '1.49', 'Master Card', '1.80', NULL, '0.09', '80.93', 0, NULL, NULL, NULL, NULL, '0'),
(8489, '108246', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 14:42:46', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '28.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8488, '108247', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 15:00:59', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '25.10', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8487, '108245', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 14:20:09', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '40.40', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(8486, '108244', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 13:43:49', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '50.00', '39.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8485, '108243', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 13:09:43', 'Paid', NULL, '2.00', '2.00', '2.00', NULL, '2.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8483, '108238', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 11:58:01', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8484, '108242', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 12:59:09', 'Paid', NULL, '534.00', '587.40', '587.40', NULL, '600.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8475, '108235', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 11:21:20', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '65.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8476, '108234', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 11:05:34', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '20.00', '13.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8477, '108240', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 12:09:59', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8478, '108236', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 11:35:09', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '26.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8479, '108237', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 11:55:08', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '40.20', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8480, '108239', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 12:03:48', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '21.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8481, '108241', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 12:26:06', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8474, '108232', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 10:39:55', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8473, '108231', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 10:31:30', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8472, '108233', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-14 10:52:11', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.00', '41.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492143587', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8515, '108276', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 13:54:53', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.10', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8516, '108269', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 12:49:25', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8517, '108272', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 13:49:13', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8518, '108268', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 12:31:33', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8519, '108273', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 13:50:17', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8520, '108274', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 13:50:48', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8521, '108279', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 14:43:36', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '82.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8522, '108278', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 14:40:54', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8523, '108280', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 14:47:26', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.60', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8524, '108277', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 14:40:36', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8525, '108283', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 15:45:13', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.00', '7.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8526, '108284', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 15:52:23', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8527, '108286', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 16:22:30', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8528, '108282', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 15:34:04', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8529, '108281', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 15:14:22', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.00', '4.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8530, '108287', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 16:23:54', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '51.00', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8531, '108285', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 16:14:26', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8532, '108288', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 16:30:26', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '36.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8514, '108270', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 13:00:53', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8513, '108271', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 13:19:56', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8512, '108275', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 13:52:29', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.20', '3.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8511, '108267', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 12:06:44', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8509, '108266', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 11:29:44', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8499, '108261', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 10:24:47', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '80.00', '7.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8508, '108265', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 11:09:16', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8500, '108264', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 11:06:43', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '55.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8501, '108255', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 10:17:34', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '52.00', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8502, '108260', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 10:20:19', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8503, '108256', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 10:18:31', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8504, '108257', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 10:18:57', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8505, '108258', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 10:19:39', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '51.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8506, '108259', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 10:19:59', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '100.00', '70.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8498, '108254', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 10:13:50', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8497, '108262', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 10:53:31', 'Paid', NULL, '138.00', '151.80', '151.80', NULL, '152.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8507, '108263', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-15 11:03:41', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.40', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492237155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8577, '108330', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 16:07:25', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8578, '108335', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 17:26:28', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8579, '108332', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 16:27:52', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8580, '108333', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 16:56:20', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8573, '108326', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 14:23:26', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8574, '108328', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 14:53:30', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8575, '108331', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 16:21:23', 'Paid', NULL, '226.00', '248.60', '248.60', NULL, '250.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8572, '108327', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 14:47:33', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8576, '108334', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 17:21:30', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '78.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8571, '108329', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 15:07:09', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8569, '108322', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 13:29:27', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8550, '108325', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 13:58:37', 'Paid', NULL, '121.00', '133.10', '133.10', NULL, '135.10', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8551, '108305', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 12:06:17', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8552, '108309', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 12:29:42', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8553, '108307', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 12:17:30', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8554, '108310', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 12:30:08', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8555, '108313', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 12:39:43', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '51.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8556, '108318', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 13:18:41', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '100.00', '42.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8557, '108316', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 12:53:37', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8558, '108301', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 11:45:06', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8559, '108312', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 12:37:30', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '31.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8560, '108304', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 12:05:24', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8561, '108317', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 12:56:07', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '70.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8562, '108315', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 12:52:59', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8563, '108323', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 13:43:18', 'Paid', NULL, '124.00', '136.40', '136.40', NULL, '137.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8564, '108319', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 13:26:43', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '100.00', '18.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8565, '108311', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 12:35:53', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '25.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8566, '108324', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 13:47:16', 'Paid', NULL, '14.90', '16.40', '16.40', NULL, '16.40', '0.00', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8567, '108320', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 13:27:47', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8568, '108321', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 13:28:09', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8549, '108306', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 12:15:48', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '110.00', '6.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8547, '108299', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 11:20:42', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8548, '108308', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 12:21:38', 'Paid', NULL, '138.00', '151.80', '0.00', '151.80', '151.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '1.70', 'VISA', '1.12', NULL, '0.10', '150.00', 0, NULL, NULL, NULL, NULL, '0'),
(8546, '108303', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 11:55:38', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8543, '108297', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 11:09:51', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8544, '108298', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 11:20:03', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8545, '108314', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 12:44:40', 'Paid', NULL, '116.00', '127.60', '127.60', NULL, '150.00', '22.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8542, '108300', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 11:28:48', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8541, '108302', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 11:55:05', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8540, '108294', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 10:25:46', 'Paid', NULL, '84.00', '84.00', '84.00', NULL, '100.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8539, '108295', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 10:34:33', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '37.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8538, '108296', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 10:38:08', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8537, '108293', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 10:21:27', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '90.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8536, '108291', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 10:13:18', 'Paid', NULL, '101.00', '111.10', '0.00', '111.10', '111.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 5, '1.24', 'VISA', '1.12', NULL, '0.07', '109.78', 0, NULL, NULL, NULL, NULL, '0'),
(8534, '108292', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 10:16:03', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.20', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8535, '108290', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 09:46:10', 'Paid', NULL, '12.50', '13.75', '13.75', NULL, '20.00', '6.25', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8533, '108289', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-16 09:28:35', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492321382', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8619, '108371', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 16:18:50', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8620, '108376', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 17:16:28', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.00', '4.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8621, '108373', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 16:53:04', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '19.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8622, '108372', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 16:23:54', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8618, '108375', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 17:16:13', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8617, '108370', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 16:18:23', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8604, '108354', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 13:11:55', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '7.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8605, '108364', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 13:56:07', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8606, '108355', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 13:29:02', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '100.00', '81.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8607, '108356', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 13:35:01', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '17.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8608, '108357', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 13:40:55', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8609, '108358', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 13:41:22', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8610, '108359', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 13:42:04', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '35.50', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8611, '108360', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 13:42:43', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8612, '108361', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 13:43:18', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8614, '108367', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 15:04:31', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '50.00', '42.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8615, '108368', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 15:22:37', 'Paid', NULL, '51.00', '50.50', '50.50', NULL, '50.50', '0.00', '0.00', '0.00', '5.61', '0.01', 'Cash', NULL, '27', '1492841155', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8616, '108374', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 17:02:33', 'Paid', NULL, '124.00', '136.40', '136.40', NULL, '140.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8595, '108349', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 12:38:35', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '80.00', '7.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8596, '108352', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 12:52:29', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '42.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8597, '108353', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 12:56:13', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8598, '108351', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 12:50:46', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '69.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8613, '108366', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 14:46:12', 'Paid', NULL, '37.50', '41.25', '41.25', NULL, '51.30', '10.05', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8600, '108365', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 13:57:55', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.20', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8601, '108369', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 15:28:36', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '20.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8602, '108363', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 13:53:05', 'Paid', NULL, '151.00', '166.10', '166.10', NULL, '167.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8603, '108362', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 13:44:55', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.20', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8594, '108350', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 12:39:52', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '110.40', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8593, '108348', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 12:17:20', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8592, '108346', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 12:13:30', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8591, '108347', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 12:16:54', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.20', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8590, '108342', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 10:59:18', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.10', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8589, '108341', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 10:53:58', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '100.00', '60.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8588, '108343', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 11:02:35', 'Paid', NULL, '111.00', '122.10', '122.10', NULL, '123.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8586, '108339', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 10:43:50', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8587, '108344', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 11:06:37', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8585, '108340', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 10:44:49', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8582, '108345', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 11:29:47', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '70.50', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8584, '108338', 't3', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 10:23:15', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8583, '108337', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 10:10:52', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '70.00', '17.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8581, '108336', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-22 09:47:20', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492841155', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8646, '108399', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 13:17:30', 'Paid', NULL, '154.00', '169.40', '169.40', NULL, '200.00', '30.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8642, '108395', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 12:24:11', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8643, '108397', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 12:37:27', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '70.00', '8.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8644, '108393', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 12:21:20', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8645, '108394', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 12:21:58', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.30', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8647, '108401', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 13:40:21', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '101.00', '20.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8648, '108403', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 14:13:19', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '105.60', '80.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8651, '108402', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 14:05:44', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.00', '43.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8652, '108409', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 17:13:54', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8653, '108406', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 16:51:25', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(8654, '108405', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 16:40:36', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '70.00', '9.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8655, '108404', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 16:24:42', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8656, '108407', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 17:05:39', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '75.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8650, '108400', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 13:35:19', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.30', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8657, '108408', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 17:10:18', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8638, '108391', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 11:39:29', 'Paid', NULL, '118.00', '129.80', '129.80', NULL, '130.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8639, '108390', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 11:35:55', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.80', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8640, '108398', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 12:41:23', 'Paid', NULL, '113.00', '124.30', '124.30', NULL, '150.00', '25.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8637, '108389', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 11:35:13', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8636, '108385', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 11:12:38', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '51.00', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8635, '108386', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 11:17:36', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8634, '108396', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 12:24:55', 'Paid', NULL, '130.00', '143.00', '143.00', NULL, '143.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8631, '108381', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 10:39:29', 'Paid', NULL, '112.00', '123.20', '123.20', NULL, '130.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8632, '108383', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 10:56:14', 'Paid', NULL, '130.00', '143.00', '143.00', NULL, '200.00', '57.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8633, '108384', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 11:08:44', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.00', '43.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8630, '108392', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 11:44:57', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8624, '108378', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 10:23:11', 'Paid', NULL, '172.00', '189.20', '189.20', NULL, '200.00', '10.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8627, '108379', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 10:28:07', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8629, '108382', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 10:47:23', 'Paid', NULL, '92.00', '101.20', '101.20', NULL, '101.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8628, '108380', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 10:31:38', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.00', '41.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8625, '108388', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 11:21:00', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '100.00', '49.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8626, '108387', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 11:18:20', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8623, '108377', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-23 10:02:14', 'Paid', NULL, '105.00', '115.50', '115.50', NULL, '150.00', '34.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1492936048', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8691, '108439', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 15:32:49', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8694, '108443', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 17:35:39', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '100.00', '53.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8692, '108442', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 17:34:45', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '25.00', '1.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8693, '108440', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 17:32:17', 'Paid', NULL, '23.00', '22.75', '22.75', NULL, '30.00', '7.25', '0.00', '0.00', '2.53', '-0.02', 'Cash', NULL, '27', '1493014992', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8690, '108441', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 17:33:25', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8689, '108437', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 14:53:40', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8687, '108438', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 14:59:09', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8686, '108436', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 14:46:05', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8685, '108434', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 14:36:00', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8684, '108435', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 14:42:03', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '110.00', '6.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8681, '108433', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 14:23:22', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '31.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8682, '108432', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 14:13:11', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8683, '108430', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 13:25:39', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8679, '108431', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 13:27:54', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '150.00', '32.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8680, '108428', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 13:22:59', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8675, '108420', 'T5(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 11:44:07', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8676, '108421', 'T5(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 11:44:30', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.00', '7.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8674, '108425', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 12:16:14', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8665, '108417', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 11:09:06', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8677, '108429', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 13:24:23', 'Paid', NULL, '102.00', '112.20', '112.20', NULL, '112.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8670, '108422', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 12:02:36', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8671, '108426', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 12:49:21', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8672, '108424', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 12:04:21', 'Paid', NULL, '98.00', '107.80', '107.80', NULL, '110.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8673, '108423', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 12:03:14', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '60.00', '8.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8666, '108415', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 11:01:10', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '24.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8667, '108418', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 11:24:47', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8678, '108427', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 13:05:07', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.10', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8664, '108419', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 11:37:31', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '65.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8659, '108410', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 10:09:28', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8660, '108411', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 10:29:13', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.00', '10.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8661, '108414', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 10:51:42', 'Paid', NULL, '60.00', '66.00', '0.00', '66.00', '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '1.19', 'Master Card', '1.80', NULL, '0.07', '64.74', 0, NULL, NULL, NULL, NULL, '0'),
(8662, '108413', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 10:43:28', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '53.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8663, '108416', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 11:07:54', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '75.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8658, '108412', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-24 10:31:58', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493014992', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8706, '108454', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-26 18:28:07', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '14.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493199894', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8707, '108453', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-26 18:08:01', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493199894', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8708, '108455', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-26 18:29:37', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.00', '29.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493199894', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8709, '108456', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-26 18:30:28', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493199894', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8698, '108447', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-04-26 11:44:16', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '100.00', '71.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493199894', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8699, '108452', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-04-26 15:41:42', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493199894', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8704, '108448', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-26 14:24:43', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493199894', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8702, '108450', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-26 14:50:44', 'Paid', NULL, '86.00', '85.15', '85.15', NULL, '100.00', '14.85', '0.00', '0.00', '9.46', '0.01', 'Cash', NULL, '27', '1493199894', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8703, '108451', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-26 14:55:42', 'Paid', NULL, '128.00', '140.80', '140.80', NULL, '150.00', '9.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493199894', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8700, '108449', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-26 14:38:07', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '100.60', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493199894', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8697, '108445', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-26 10:51:28', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493199894', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8696, '108446', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-26 11:09:36', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493199894', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8695, '108444', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-26 10:00:49', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '64.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493199894', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8716, '108466', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-27 14:11:09', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493278057', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8717, '108465', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-27 13:49:33', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '58.50', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493278057', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8718, '108467', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-27 14:13:38', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493278057', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8719, '108472', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-27 16:16:43', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493278057', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8720, '108463', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-27 13:36:47', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '8.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493278057', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8721, '108464', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-27 13:42:03', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493278057', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8722, '108468', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-27 14:36:35', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493278057', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8723, '108469', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-27 15:19:14', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '100.00', '73.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493278057', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8724, '108471', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-27 16:16:11', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493278057', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8725, '108470', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-27 16:15:33', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493278057', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8726, '108473', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-27 18:11:53', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.50', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493278057', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8714, '108462', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-27 12:58:51', 'Paid', NULL, '121.00', '133.10', '133.10', NULL, '150.10', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493278057', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8715, '108461', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-27 12:47:33', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493278057', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8713, '108459', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-27 11:46:54', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493278057', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8712, '108460', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-27 12:27:13', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '57.00', '20.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493278057', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8711, '108458', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-27 11:35:17', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493278057', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8710, '108457', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-27 09:16:42', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493278057', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8731, '108478', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-28 11:05:58', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493353672', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8732, '108479', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-28 11:45:14', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.00', '9.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493353672', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8733, '108483', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-28 11:57:01', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493353672', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8734, '108481', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-28 11:54:55', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '73.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493353672', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8735, '108482', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-28 11:55:34', 'Paid', NULL, '107.90', '118.70', '118.70', NULL, '150.00', '31.30', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1493353672', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8736, '108480', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-28 11:46:15', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '40.00', '3.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493353672', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8738, '108486', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-28 12:42:29', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493353672', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8739, '108484', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-28 12:28:19', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '54.10', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493353672', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8740, '108485', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-28 12:28:51', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '36.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493353672', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8742, '108487', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-28 14:25:45', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493353672', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8743, '108488', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-28 14:56:42', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '45.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493353672', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8744, '108489', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-28 17:51:15', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493353672', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8730, '108475', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-28 10:17:10', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493353672', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8729, '108474', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-28 10:06:56', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493353672', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8728, '108477', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-28 11:04:33', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493353672', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8727, '108476', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-28 10:39:02', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '59.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493353672', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8769, '108514', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 18:54:10', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8767, '108513', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 18:53:15', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8768, '108512', 't7', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 18:42:54', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8766, '108510', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 17:57:01', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8748, '108493', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 13:44:32', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8749, '108494', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 14:06:11', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '70.00', '7.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8750, '108497', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 14:17:12', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '52.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8751, '108498', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 14:34:22', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8752, '108499', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 14:34:45', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8753, '108495', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 14:08:55', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8754, '108496', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 14:13:49', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8765, '108509', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 17:49:13', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8764, '108508', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 17:39:10', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8763, '108507', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 17:38:05', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '40.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8762, '108506', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 17:02:39', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '40.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8761, '108511', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 18:26:38', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8756, '108502', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 15:33:48', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.40', '25.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8757, '108501', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 15:05:09', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '51.40', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8758, '108504', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 15:35:38', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8759, '108503', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 15:35:14', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '25.20', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8760, '108505', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 16:23:53', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8755, '108500', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 14:55:38', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.00', '3.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8747, '108492', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 12:01:02', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8746, '108491', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 10:45:03', 'Paid', NULL, '163.00', '179.30', '179.30', NULL, '200.00', '20.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8745, '108490', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-29 10:16:00', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.50', '5.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493445398', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8808, '108550', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 15:12:53', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8809, '108552', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 15:48:38', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8810, '108556', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 16:16:45', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8811, '108555', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 16:11:27', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '27.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8812, '108559', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 17:06:53', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8813, '108554', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 16:10:39', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8814, '108558', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 17:04:58', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8815, '108557', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 16:38:42', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8816, '108560', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 17:56:22', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8817, '108561', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 17:59:36', 'Paid', NULL, '140.00', '154.00', '154.00', NULL, '154.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8807, '108553', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 15:49:33', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '100.50', '52.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8806, '108551', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 15:30:55', 'Paid', NULL, '127.00', '139.70', '139.70', NULL, '150.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8805, '108549', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 15:06:34', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '73.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8801, '108546', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 14:37:51', 'Paid', NULL, '112.00', '123.20', '123.20', NULL, '123.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8804, '108547', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 14:43:49', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8803, '108543', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 14:02:38', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8800, '108545', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 14:10:15', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '100.00', '6.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8799, '108548', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 14:46:06', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '80.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8796, '108541', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 13:18:11', 'Paid', NULL, '164.00', '180.40', '180.40', NULL, '200.00', '19.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(8797, '108542', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 13:34:04', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '30.50', '5.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8798, '108544', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 14:09:52', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8795, '108540', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 13:14:16', 'Paid', NULL, '147.00', '161.70', '161.70', NULL, '200.00', '38.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8794, '108537', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 12:39:30', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8791, '108535', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 12:27:39', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8792, '108536', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 12:32:10', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8793, '108538', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 12:43:54', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '68.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8784, '108531', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 12:18:39', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '40.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8785, '108529', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 12:02:24', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8786, '108534', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 12:23:58', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8787, '108533', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 12:23:09', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8788, '108528', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 11:56:49', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8789, '108530', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 12:13:54', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8790, '108532', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 12:22:23', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.20', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8783, '108526', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 11:13:20', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '50.00', '42.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8782, '108523', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 11:07:21', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.50', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8781, '108527', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 11:49:03', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.30', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8780, '108539', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 12:58:15', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8774, '108518', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 10:10:57', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.10', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8779, '108525', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 11:12:18', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8778, '108524', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 11:08:46', 'Paid', NULL, '149.00', '163.90', '163.90', NULL, '200.00', '36.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8777, '108521', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 10:41:36', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8776, '108522', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 10:42:37', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8775, '108519', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 10:27:26', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '100.00', '58.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8773, '108517', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 10:04:17', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '77.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8772, '108516', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 09:59:31', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '70.00', '11.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8771, '108515', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 09:57:34', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8770, '108520', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-04-30 10:35:58', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '102.00', '40.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493530943', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8870, '108613', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 19:09:57', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8868, '108612', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 18:50:57', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '75.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8869, '108614', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 19:16:28', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8867, '108611', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 18:44:25', 'Paid', NULL, '53.00', '49.55', '49.55', NULL, '100.00', '50.45', '0.00', '0.00', '8.75', '0.00', 'Cash', NULL, '27', '1493634754', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8853, '108602', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 16:26:24', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '85.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8854, '108599', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 15:14:24', 'Paid', NULL, '102.00', '95.35', '95.35', NULL, '100.00', '4.65', '0.00', '0.00', '16.83', '-0.02', 'Cash', NULL, '27', '1493634754', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8855, '108597', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 14:07:58', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.00', '43.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8856, '108598', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 14:46:32', 'Paid', NULL, '54.00', '50.50', '50.50', NULL, '50.50', '0.00', '0.00', '0.00', '8.91', '0.01', 'Cash', NULL, '27', '1493634754', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8857, '108600', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 15:27:03', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '100.00', '42.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8858, '108601', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 16:16:49', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '51.00', '19.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8859, '108606', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 16:48:40', 'Paid', NULL, '77.00', '72.00', '72.00', NULL, '72.00', '0.00', '0.00', '0.00', '12.71', '0.01', 'Cash', NULL, '27', '1493634754', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8860, '108604', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 16:41:30', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8861, '108609', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 17:23:22', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8862, '108603', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 16:38:05', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.00', '29.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8863, '108607', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 16:59:11', 'Paid', NULL, '97.00', '106.70', '106.70', NULL, '110.00', '3.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8864, '108605', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 16:42:20', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8865, '108608', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 17:04:02', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8866, '108610', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 17:41:24', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8850, '108592', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 13:15:54', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8851, '108596', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 13:56:13', 'Paid', NULL, '51.00', '47.70', '47.70', NULL, '50.00', '2.30', '0.00', '0.00', '8.42', '0.02', 'Cash', NULL, '27', '1493634754', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8852, '108595', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 13:39:38', 'Paid', NULL, '18.00', '16.85', '16.85', NULL, '20.00', '3.15', '0.00', '0.00', '2.97', '0.02', 'Cash', NULL, '27', '1493634754', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8848, '108594', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 13:30:26', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8849, '108593', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 13:17:54', 'Paid', NULL, '104.00', '114.40', '114.40', NULL, '114.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8847, '108591', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 13:05:14', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8846, '108589', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 12:45:51', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '69.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8845, '108579', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 11:36:22', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '6.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8839, '108590', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 12:46:56', 'Paid', NULL, '81.00', '75.75', '75.75', NULL, '100.00', '24.25', '0.00', '0.00', '13.37', '0.02', 'Cash', NULL, '27', '1493634754', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8840, '108584', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 12:06:38', 'Paid', NULL, '37.00', '34.60', '34.60', NULL, '50.00', '15.40', '0.00', '0.00', '6.11', '0.01', 'Cash', NULL, '27', '1493634754', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8841, '108585', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 12:10:52', 'Paid', NULL, '113.00', '124.30', '124.30', NULL, '124.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8842, '108588', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 12:32:42', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8843, '108580', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 11:40:33', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '50.00', '39.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8844, '108586', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 12:27:04', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8838, '108587', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 12:28:44', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8832, '108576', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 11:24:10', 'Paid', NULL, '56.00', '52.35', '52.35', NULL, '53.00', '0.65', '0.00', '0.00', '9.24', '-0.01', 'Cash', NULL, '27', '1493634754', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8833, '108575', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 11:22:42', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.50', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8834, '108581', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 11:46:21', 'Paid', NULL, '135.00', '126.20', '126.20', NULL, '150.20', '24.00', '0.00', '0.00', '22.28', '-0.02', 'Cash', NULL, '27', '1493634754', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8835, '108582', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 12:03:27', 'Paid', NULL, '107.00', '100.05', '100.05', NULL, '100.05', '0.00', '0.00', '0.00', '17.66', '0.01', 'Cash', NULL, '27', '1493634754', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8836, '108578', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 11:33:16', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8837, '108583', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 12:04:18', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8824, '108567', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 10:31:51', 'Paid', NULL, '157.00', '146.80', '146.80', NULL, '150.00', '3.20', '0.00', '0.00', '25.91', '0.01', 'Cash', NULL, '27', '1493634754', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8825, '108566', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 10:27:34', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '45.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8826, '108569', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 10:42:45', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8827, '108574', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 11:13:57', 'Paid', NULL, '120.00', '112.20', '112.20', NULL, '112.20', '0.00', '0.00', '0.00', '19.80', '0.00', 'Cash', NULL, '27', '1493634754', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8828, '108562', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 10:04:08', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '10.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8829, '108572', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 10:54:14', 'Paid', NULL, '52.00', '48.60', '48.60', NULL, '50.00', '1.40', '0.00', '0.00', '8.58', '-0.02', 'Cash', NULL, '27', '1493634754', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8830, '108573', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 10:57:41', 'Paid', NULL, '27.00', '25.25', '25.25', NULL, '50.30', '25.05', '0.00', '0.00', '4.46', '0.01', 'Cash', NULL, '27', '1493634754', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8831, '108577', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 11:25:16', 'Paid', NULL, '101.00', '111.10', '111.10', NULL, '111.20', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8822, '108563', '0', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 10:06:33', 'Paid', NULL, '35.00', '32.70', '32.70', NULL, '100.00', '67.30', '0.00', '0.00', '5.78', '-0.02', 'Cash', NULL, '27', '1493634754', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8823, '108571', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 10:53:05', 'Paid', NULL, '98.00', '91.65', '91.65', NULL, '101.65', '10.00', '0.00', '0.00', '16.17', '0.02', 'Cash', NULL, '27', '1493634754', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8821, '108570', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 10:52:14', 'Paid', NULL, '208.00', '194.50', '194.50', NULL, '200.00', '5.50', '0.00', '0.00', '34.32', '0.02', 'Cash', NULL, '27', '1493634754', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8820, '108568', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 10:41:22', 'Paid', NULL, '154.00', '144.00', '144.00', NULL, '150.00', '6.00', '0.00', '0.00', '25.41', '0.01', 'Cash', NULL, '27', '1493634754', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8819, '108565', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 10:15:50', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493634754', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8818, '108564', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-01 10:13:07', 'Paid', NULL, '130.00', '121.55', '121.55', NULL, '150.00', '28.45', '0.00', '0.00', '21.45', '0.00', 'Cash', NULL, '27', '1493634754', 'p', '15', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8895, '108636', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 16:50:41', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8896, '108637', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 16:56:29', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8889, '108627', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 13:18:34', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8890, '108630', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 15:01:13', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8891, '108628', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 13:51:52', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8873, '108619', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 10:49:42', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8875, '108618', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 10:46:13', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8876, '108620', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 11:28:31', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8877, '108622', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 12:08:25', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8894, '108633', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 16:00:36', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8880, '108634', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 16:33:28', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8881, '108624', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 12:52:42', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '31.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8882, '108625', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 12:53:14', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8883, '108628', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 13:24:36', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '71.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8884, '108627', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 13:41:01', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '70.00', '10.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8885, '108629', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 13:29:56', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8886, '108632', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 15:07:30', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.00', '29.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8887, '108626', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 13:07:05', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8888, '108629', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 14:07:33', 'Paid', NULL, '111.00', '122.10', '122.10', NULL, '150.00', '27.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8878, '108623', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 12:36:36', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8874, '108617', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 10:14:36', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '100.00', '67.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8892, '108635', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 16:34:21', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '20.00', '12.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8893, '108631', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-03 15:05:11', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493786746', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8921, '108659', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-04 18:12:09', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.20', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493864727', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8902, '108639', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-05-04 10:16:32', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '20.00', '12.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493864727', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8910, '108648', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-04 11:57:32', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493864727', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8904, '108647', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-04 11:32:15', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493864727', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8905, '108642', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-04 11:08:31', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493864727', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8906, '108644', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-04 11:13:20', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '24.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493864727', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8907, '108653', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-04 12:52:38', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493864727', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8908, '108645', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-04 11:23:13', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493864727', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8909, '108646', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-04 11:23:43', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '51.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493864727', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8911, '108652', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-04 12:42:44', 'Paid', NULL, '14.90', '16.40', '16.40', NULL, '16.40', '0.00', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1493864727', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8912, '108654', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-05-04 12:54:41', 'Paid', NULL, '119.00', '130.90', '130.90', NULL, '150.00', '19.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493864727', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8917, '108655', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-04 14:12:46', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493864727', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8914, '108649', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-04 12:18:56', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '20.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493864727', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8915, '108650', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-04 12:19:27', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493864727', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8916, '108651', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-04 12:19:39', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493864727', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8918, '108657', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-04 15:40:46', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493864727', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8919, '108656', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-04 15:08:32', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '100.20', '87.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493864727', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8920, '108658', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-04 17:21:58', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.00', '5.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493864727', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8901, '108641', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-04 11:06:51', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493864727', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8900, '108643', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-04 11:10:24', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '100.00', '53.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493864727', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8899, '108640', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-04 10:41:28', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493864727', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8898, '108638', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-04 10:16:03', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493864727', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8926, '108664', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-05 10:41:34', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493947164', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8928, '108665', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-05 10:48:06', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493947164', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8929, '108667', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-05 12:01:22', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493947164', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8930, '108666', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-05 11:29:23', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493947164', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8931, '108668', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-05 12:20:12', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '50.00', '40.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493947164', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8932, '108671', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-05 12:30:39', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493947164', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8933, '108669', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-05 12:20:33', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493947164', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8934, '108670', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-05 12:22:18', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '20.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493947164', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8935, '108672', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-05 12:55:19', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '33.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493947164', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8936, '108673', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-05 13:27:13', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.50', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493947164', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8937, '108675', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-05 13:46:30', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493947164', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8938, '108674', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-05 13:45:51', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493947164', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8939, '108676', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-05 14:00:44', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493947164', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8940, '108677', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-05 15:08:15', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '18.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493947164', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8941, '108680', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-05 16:07:02', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493947164', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8942, '108678', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-05 15:58:02', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '50.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493947164', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8943, '108679', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-05 15:59:18', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493947164', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8944, '108681', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-05 17:35:09', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.30', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493947164', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8925, '108661', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-05 10:14:07', 'Paid', NULL, '34.90', '38.40', '38.40', NULL, '50.00', '11.60', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1493947164', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8924, '108662', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-05 10:32:56', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '100.00', '73.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493947164', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8923, '108663', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-05 10:34:56', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.20', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493947164', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(8922, '108660', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-05 10:13:37', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.00', '15.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1493947164', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8980, '108717', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 15:55:20', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8981, '108715', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 15:25:44', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8982, '108716', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 15:26:16', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(8984, '108718', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 16:32:53', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8985, '108719', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 17:10:05', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8986, '108720', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 17:30:29', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '20.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8987, '108723', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 18:31:52', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8979, '108713', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 15:10:04', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8976, '108712', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 15:08:52', 'Paid', NULL, '99.00', '108.90', '108.90', NULL, '110.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8977, '108707', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 14:24:12', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '50.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8978, '108714', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 15:10:39', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8975, '108708', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 14:33:18', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8974, '108711', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 15:04:13', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '100.00', '52.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8971, '108703', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 13:56:16', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8972, '108709', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 14:44:12', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '52.00', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8973, '108721', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 17:42:30', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8970, '108710', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 14:47:49', 'Paid', NULL, '100.00', '110.00', '110.00', NULL, '150.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8969, '108704', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 13:58:20', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8968, '108701', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 13:50:24', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '75.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8967, '108699', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 13:38:19', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.10', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8966, '108705', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 13:59:40', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.00', '30.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8965, '108706', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 14:15:44', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '55.10', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8964, '108697', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 13:23:53', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8963, '108702', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 13:50:53', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8983, '108722', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 17:48:40', 'Paid', NULL, '73.00', '72.25', '72.25', NULL, '100.30', '28.05', '0.00', '0.00', '8.03', '-0.02', 'Cash', NULL, '27', '1494063967', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8962, '108693', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 12:46:12', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8960, '108696', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 13:23:25', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8959, '108698', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 13:24:34', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '55.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8958, '108695', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 12:58:45', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.00', '20.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8957, '108700', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 13:50:12', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8956, '108692', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 12:45:09', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '100.00', '64.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8955, '108691', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 12:08:40', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8954, '108694', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 12:48:35', 'Paid', NULL, '111.00', '122.10', '122.10', NULL, '150.20', '28.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8949, '108687', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 11:02:31', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '79.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8950, '108688', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 11:23:45', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8951, '108685', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 10:42:58', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '30.00', '6.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8952, '108690', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 11:47:51', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8953, '108689', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 11:47:30', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.70', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8948, '108686', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 10:49:19', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8947, '108684', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 10:19:27', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.20', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8946, '108682', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 10:06:36', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '100.00', '47.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8945, '108683', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-06 10:09:48', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494063967', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9017, '108750', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 14:50:19', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9024, '108761', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 17:35:28', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9019, '108751', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 15:10:15', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '53.00', '23.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9020, '108754', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 15:32:57', 'Paid', NULL, '186.00', '204.60', '204.60', NULL, '205.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9021, '108752', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 15:19:51', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '52.00', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9023, '108758', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 17:07:10', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '25.40', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9025, '108757', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 16:18:10', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9026, '108760', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 17:13:19', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9027, '108759', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 17:09:51', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9009, '108742', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 13:22:23', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9010, '108744', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 13:45:21', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '40.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9011, '108746', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 14:01:53', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9012, '108748', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 14:12:31', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9013, '108747', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 14:09:53', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9022, '108755', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 15:37:08', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9015, '108756', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 16:09:08', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '58.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9016, '108753', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 15:25:27', 'Paid', NULL, '180.00', '198.00', '198.00', NULL, '200.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9003, '108737', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 12:16:44', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9004, '108739', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 12:59:35', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9005, '108741', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 13:14:52', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '31.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9006, '108740', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 13:00:29', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '103.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9008, '108745', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 13:47:30', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.00', '29.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9007, '108743', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 13:44:38', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9002, '108735', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 12:07:50', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9001, '108734', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 12:03:00', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8999, '108738', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 12:41:57', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9000, '108732', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 11:43:17', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.90', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8998, '108749', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 14:20:30', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8992, '108726', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 10:26:10', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8997, '108733', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 11:50:24', 'Paid', NULL, '100.00', '110.00', '110.00', NULL, '110.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8996, '108731', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 11:41:55', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.30', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8995, '108730', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 11:40:12', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '41.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8994, '108728', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 10:38:52', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '20.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(8993, '108736', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 12:08:50', 'Paid', NULL, '123.00', '135.30', '135.30', NULL, '150.00', '14.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8991, '108729', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 10:52:41', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8990, '108725', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 10:25:46', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '104.00', '40.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8989, '108727', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 10:28:45', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(8988, '108724', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-07 09:45:27', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494137946', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9040, '108771', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-08 13:28:14', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '16.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494226510', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9041, '108774', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-08 14:13:53', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.50', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494226510', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9042, '108776', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-08 15:43:05', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494226510', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9043, '108775', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-08 14:55:44', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '90.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494226510', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9044, '108778', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-08 17:48:07', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494226510', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9046, '108777', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-08 17:36:45', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494226510', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9038, '108773', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-08 13:45:14', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494226510', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9039, '108772', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-08 13:30:10', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.20', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494226510', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9036, '108766', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-08 11:32:01', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494226510', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9035, '108769', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-08 12:30:42', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '101.30', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494226510', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9034, '108768', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-08 11:58:07', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494226510', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9037, '108770', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-08 13:25:06', 'Paid', NULL, '139.00', '152.90', '152.90', NULL, '160.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494226510', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9033, '108765', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-08 11:17:01', 'Paid', NULL, '115.00', '126.50', '126.50', NULL, '150.00', '23.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494226510', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9031, '108767', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-08 11:55:40', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '50.00', '43.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494226510', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9030, '108763', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-08 10:10:22', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '20.00', '12.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494226510', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9029, '108762', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-08 09:27:38', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494226510', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9028, '108764', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-08 10:58:21', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494226510', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9053, '108785', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 10:49:25', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '56.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9054, '108787', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 11:07:39', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '90.10', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9055, '108800', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 13:13:28', 'Paid', NULL, '208.90', '229.80', '229.80', NULL, '230.00', '0.20', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9056, '108790', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 11:43:15', 'Paid', NULL, '124.00', '136.40', '136.40', NULL, '150.00', '13.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9057, '108788', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 11:25:39', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9058, '108792', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 11:56:52', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9059, '108789', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 11:36:40', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9060, '108791', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 11:46:25', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9061, '108793', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 11:59:06', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '40.20', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9062, '108786', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 11:05:31', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9063, '108794', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 12:02:00', 'Paid', NULL, '77.90', '85.70', '85.70', NULL, '100.00', '14.30', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9064, '108798', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 12:42:30', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '80.00', '4.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9065, '108795', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 12:05:21', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '70.00', '7.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9066, '108796', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 12:14:51', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9067, '108797', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 12:26:29', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9068, '108802', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 13:38:58', 'Paid', NULL, '139.00', '152.90', '152.90', NULL, '160.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9069, '108801', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 13:26:17', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9070, '108799', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 13:11:42', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9072, '108804', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 15:37:02', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '53.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9073, '108803', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 15:27:08', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '70.40', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9074, '108806', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 16:02:53', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9075, '108805', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 15:48:39', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9076, '108807', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 16:03:22', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9077, '108810', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 17:38:11', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '52.00', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9078, '108808', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 16:49:53', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '39.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9079, '108809', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 17:36:41', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '14.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9080, '108811', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 17:55:58', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9051, '108783', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 10:40:45', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.00', '19.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9052, '108784', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 10:46:55', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '65.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9050, '108781', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 10:13:19', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.30', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9049, '108780', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 10:01:52', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '55.20', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9048, '108782', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 10:31:21', 'Paid', NULL, '114.00', '125.40', '125.40', NULL, '150.00', '24.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9047, '108779', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-10 09:44:41', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494398691', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9086, '108815', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-11 11:18:54', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '50.00', '40.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494479511', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9087, '108817', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-11 12:35:36', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.40', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494479511', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9088, '108819', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-11 13:12:52', 'Paid', NULL, '102.00', '112.20', '112.20', NULL, '120.00', '7.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494479511', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9089, '108816', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-11 12:33:12', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '80.10', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494479511', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9090, '108818', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-11 13:08:15', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494479511', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9091, '108820', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-11 13:21:53', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494479511', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9092, '108821', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-11 13:47:23', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '48.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494479511', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9093, '108825', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-11 14:07:03', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.30', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494479511', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9094, '108827', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-11 14:14:34', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494479511', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9095, '108824', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-11 13:55:05', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494479511', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9096, '108822', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-11 13:48:07', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.10', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494479511', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9097, '108826', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-11 14:09:16', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '64.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494479511', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9098, '108823', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-11 13:51:00', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '25.00', '4.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494479511', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9099, '108828', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-11 15:57:57', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494479511', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9100, '108831', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-11 18:30:13', 'Paid', NULL, '15.90', '17.50', '17.50', NULL, '20.00', '2.50', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1494479511', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9101, '108830', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-11 18:14:22', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494479511', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(9102, '108832', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-11 18:54:24', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494479511', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9085, '108814', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-11 11:11:13', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494479511', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9084, '108829', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-11 17:55:31', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494479511', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9082, '108812', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-11 10:16:54', 'Paid', NULL, '111.00', '122.10', '122.10', NULL, '150.10', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494479511', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9081, '108813', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-11 10:27:23', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494479511', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9132, '108860', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 16:49:31', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9131, '108859', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 16:49:03', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.00', '5.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9130, '108858', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 16:19:58', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '52.10', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9129, '108857', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 15:48:52', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9127, '108855', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 15:19:49', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9126, '108856', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 15:21:57', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '80.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9125, '108851', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 14:02:18', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9105, '108835', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 10:46:28', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9106, '108836', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 10:51:23', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9107, '108837', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 11:26:10', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.00', '5.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9108, '108838', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 11:45:23', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9109, '108841', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 12:42:57', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '100.00', '56.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9110, '108848', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 13:38:57', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '58.50', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9111, '108839', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 11:58:28', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.10', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9112, '108849', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 13:44:04', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.00', '30.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9113, '108840', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 12:24:51', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '6.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9114, '108842', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 12:57:38', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9115, '108843', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 13:04:02', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.40', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9116, '108844', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 13:11:16', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9117, '108852', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 14:32:03', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9118, '108845', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 13:15:18', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '100.00', '69.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9119, '108847', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 13:30:43', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '118.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9120, '108846', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 13:29:09', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9121, '108850', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 13:59:34', 'Paid', NULL, '116.00', '127.60', '127.60', NULL, '130.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9122, '108853', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 14:42:38', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.10', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9123, '108854', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 14:43:07', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '90.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9104, '108833', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 10:23:41', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9103, '108834', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-12 10:27:03', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '40.00', '8.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494567519', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9183, '108904', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 18:12:37', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9180, '108906', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 18:20:40', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '51.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9181, '108907', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 18:31:46', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9177, '108902', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 17:20:38', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '100.30', '75.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9178, '108901', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 17:00:08', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9179, '108905', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 18:18:22', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9176, '108903', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 17:40:52', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '30.30', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9175, '108897', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 15:05:11', 'Paid', NULL, '94.00', '94.00', '94.00', NULL, '100.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9174, '108895', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 14:47:22', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9173, '108900', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 15:18:51', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9172, '108898', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 15:11:33', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9171, '108890', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 13:55:29', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '50.00', '40.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9170, '108899', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 15:16:37', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9169, '108893', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 14:22:07', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.00', '19.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9167, '108889', 'T13(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 13:09:37', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '25.00', '1.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9166, '108888', 'T13(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 13:09:14', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9165, '108887', 'T13(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 13:08:48', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9164, '108886', 'T13(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 13:08:13', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9163, '108885', 'T13(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 13:07:30', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.00', '20.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9162, '108891', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 14:03:35', 'Paid', NULL, '208.00', '228.80', '228.80', NULL, '230.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9161, '108892', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 14:08:13', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9159, '108875', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 12:29:33', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '20.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9160, '108896', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 14:50:00', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '77.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9158, '108884', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 12:50:14', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9136, '108874', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 12:15:52', 'Paid', NULL, '137.00', '150.70', '150.70', NULL, '151.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9137, '108865', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 11:07:13', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9138, '108862', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 10:29:09', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '40.00', '15.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9139, '108864', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 10:50:35', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9140, '108866', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 11:13:41', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9141, '108868', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 11:19:12', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '100.00', '6.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9142, '108871', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 11:44:12', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9143, '108869', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 11:40:09', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '60.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9144, '108867', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 11:18:27', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '54.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9168, '108894', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 14:40:27', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9146, '108870', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 11:43:52', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.00', '41.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9147, '108879', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 12:44:31', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '71.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9148, '108881', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 12:46:52', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '73.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9149, '108880', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 12:45:43', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '57.00', '30.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9155, '108878', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 12:43:00', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.40', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9151, '108883', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 12:48:47', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '71.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9152, '108877', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 12:38:01', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '21.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9153, '108873', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 12:13:27', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9154, '108882', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 12:47:13', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.20', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9156, '108872', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 11:57:35', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9157, '108876', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 12:37:01', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '29.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9135, '108861', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 09:58:16', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '24.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9134, '108863', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-13 10:42:43', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494650176', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9229, '108952', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 17:10:04', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '25.00', '1.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9230, '108955', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 18:13:39', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9231, '108954', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 17:45:24', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9232, '108958', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 18:41:26', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9233, '108957', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 18:38:42', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '50.00', '35.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9228, '108953', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 17:11:30', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9234, '108956', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 18:20:53', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9225, '108950', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 15:09:26', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9226, '108947', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 14:54:46', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '65.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9227, '108951', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 16:23:02', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9219, '108943', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 14:06:14', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9220, '108949', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 15:01:57', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '100.60', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9221, '108944', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 14:31:12', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9222, '108948', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 14:57:48', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9223, '108942', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 13:57:22', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9224, '108946', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 14:46:04', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9218, '108941', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 13:56:54', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9217, '108934', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 13:14:53', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9216, '108940', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 13:55:23', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9215, '108945', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 14:32:23', 'Paid', NULL, '112.00', '123.20', '123.20', NULL, '155.20', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9214, '108936', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 13:21:23', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9213, '108939', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 13:53:05', 'Paid', NULL, '117.00', '128.70', '128.70', NULL, '150.00', '21.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9212, '108929', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 12:45:27', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '10.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9210, '108935', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 13:19:10', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.60', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9211, '108933', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 13:05:29', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9208, '108926', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 12:33:23', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.00', '20.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9209, '108931', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 12:54:35', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9186, '108911', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 10:31:14', 'Paid', NULL, '133.00', '146.30', '146.30', NULL, '150.00', '3.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9207, '108930', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 12:46:23', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9187, '108917', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 11:23:15', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9188, '108913', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 10:45:42', 'Paid', NULL, '123.00', '135.30', '135.30', NULL, '135.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9189, '108910', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 10:20:15', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '25.00', '1.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9190, '108915', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 10:46:19', 'Paid', NULL, '109.00', '119.90', '119.90', NULL, '119.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9191, '108914', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 10:46:09', 'Paid', NULL, '93.00', '102.30', '102.30', NULL, '102.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9192, '108912', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 10:38:13', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9193, '108916', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 11:00:35', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '100.00', '18.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9194, '108921', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 11:45:07', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9195, '108918', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 11:28:47', 'Paid', NULL, '170.00', '187.00', '187.00', NULL, '200.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9196, '108938', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 13:36:39', 'Paid', NULL, '211.00', '232.10', '232.10', NULL, '233.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9197, '108922', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 11:52:18', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9198, '108920', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 11:42:13', 'Paid', NULL, '168.00', '184.80', '184.80', NULL, '184.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9199, '108937', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 13:24:57', 'Paid', NULL, '116.00', '127.60', '127.60', NULL, '150.00', '22.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9200, '108919', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 11:35:23', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9201, '108932', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 12:56:20', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.30', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9202, '108923', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 11:59:29', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '90.00', '7.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9203, '108924', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 12:16:07', 'Paid', NULL, '108.00', '118.80', '118.80', NULL, '120.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9204, '108927', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 12:40:24', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.00', '7.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9205, '108925', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 12:32:57', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '39.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9206, '108928', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 12:44:28', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9185, '108909', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 10:11:54', 'Paid', NULL, '123.00', '135.30', '135.30', NULL, '150.00', '14.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9184, '108908', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-14 10:01:31', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494741275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9269, '108993', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 17:23:46', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.10', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9268, '108992', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 17:19:37', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.00', '30.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9258, '108980', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 13:05:11', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9259, '108984', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 13:57:35', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '100.00', '50.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9260, '108985', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 14:10:02', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '75.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9261, '108982', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 13:24:56', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9262, '108987', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 14:24:06', 'Paid', NULL, '97.00', '106.70', '106.70', NULL, '150.00', '43.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9263, '108986', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 14:20:01', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9264, '108989', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 15:33:17', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9265, '108988', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 15:21:17', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9266, '108991', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 17:13:47', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9267, '108990', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 15:46:30', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '60.00', '11.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9237, '108966', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 10:43:10', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9239, '108960', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 09:57:50', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9240, '108962', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 10:04:31', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9241, '108964', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 10:26:31', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(9242, '108970', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 11:20:13', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9243, '108965', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 10:28:57', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9244, '108969', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 11:03:21', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9245, '108967', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 10:55:00', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.00', '5.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9246, '108971', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 11:34:31', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '40.00', '4.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9247, '108968', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 10:55:34', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9248, '108972', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 11:59:16', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9249, '108976', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 12:40:24', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9250, '108973', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 12:00:52', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9251, '108974', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 12:05:41', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9252, '108975', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 12:06:04', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9253, '108977', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 12:56:35', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '100.00', '8.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9254, '108979', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 12:59:58', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '80.50', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9255, '108978', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 12:59:19', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '26.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9256, '108981', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 13:17:58', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9257, '108983', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 13:57:14', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9238, '108963', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 10:22:19', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9236, '108959', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 09:53:28', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.10', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9235, '108961', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-15 10:01:18', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1494827320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9298, '109020', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 16:53:11', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9293, '109017', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 15:37:29', 'Paid', NULL, '73.50', '80.85', '80.85', NULL, '100.00', '19.15', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9294, '109015', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 14:35:53', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '67.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9295, '109013', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 14:16:42', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9296, '109016', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 15:20:11', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9297, '109018', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 16:07:05', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.10', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9272, '108997', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 10:00:21', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9273, '108996', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 09:53:34', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9274, '108999', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 10:56:35', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9275, '108998', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 10:51:28', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9276, '109003', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 12:06:54', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.30', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9277, '109000', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 10:57:44', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9278, '109001', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 11:49:10', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '40.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9279, '109002', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 11:53:30', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9280, '109004', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 12:09:58', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9282, '109005', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 12:14:20', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9283, '109009', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 13:06:33', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.00', '41.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9289, '109010', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 13:30:29', 'Paid', NULL, '105.00', '115.50', '115.50', NULL, '120.00', '4.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9285, '109011', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 13:31:27', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9286, '109008', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 13:04:16', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9287, '109006', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 12:47:14', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '49.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9288, '109007', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 12:47:32', 'Paid', NULL, '38.90', '42.80', '42.80', NULL, '50.00', '7.20', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9290, '109019', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 16:11:28', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '60.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9291, '109012', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 13:58:59', 'Paid', NULL, '54.50', '59.95', '59.95', NULL, '100.00', '40.05', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9292, '109014', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 14:32:45', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '51.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9271, '108995', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 09:44:49', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9270, '108994', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-05-17 09:14:44', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495000143', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9301, '109024', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-18 11:35:59', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '100.00', '71.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495085098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9302, '109023', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-18 10:59:20', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.20', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495085098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9303, '109026', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-18 12:57:27', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495085098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9304, '109028', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-18 13:41:29', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495085098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9305, '109025', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-18 12:34:45', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495085098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9306, '109027', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-18 13:09:34', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495085098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9307, '109029', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-18 13:47:29', 'Paid', NULL, '25.50', '28.05', '28.05', NULL, '100.10', '72.05', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495085098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9308, '109031', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-18 14:03:35', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495085098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9309, '109030', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-18 13:50:17', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '25.00', '4.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495085098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9310, '109032', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-18 15:30:37', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495085098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9300, '109021', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-05-18 10:09:22', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '50.00', '29.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495085098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9299, '109022', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-18 10:18:47', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495085098', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9334, '109056', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 17:32:46', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9333, '109055', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 17:11:40', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '50.00', '35.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9332, '109051', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 15:09:54', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9331, '109054', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 16:51:29', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '56.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9330, '109052', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 15:14:06', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9329, '109053', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 15:42:21', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9313, '109033', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 10:00:23', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9314, '109034', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 10:16:24', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '75.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9315, '109037', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 10:51:58', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9316, '109041', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 11:24:04', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '54.20', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9317, '109040', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 11:09:49', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.10', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9318, '109036', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 10:38:38', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9319, '109044', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 12:28:36', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '8.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9320, '109038', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 11:01:32', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9321, '109042', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 11:34:22', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9322, '109039', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 11:06:13', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '50.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9323, '109045', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 13:07:58', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9324, '109046', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 13:30:20', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '50.50', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9325, '109047', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 13:56:48', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.70', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9326, '109048', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 14:22:51', 'Paid', NULL, '114.00', '125.40', '125.40', NULL, '125.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9327, '109050', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 14:36:53', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '16.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9328, '109049', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 14:30:20', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9312, '109043', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 12:03:13', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9311, '109035', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-19 10:30:00', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495170643', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9376, '109097', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 17:31:18', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '50.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9372, '109092', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 16:23:26', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9373, '109093', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 16:23:50', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '6.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9374, '109094', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 16:25:13', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9375, '109095', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 16:54:28', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9371, '109091', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 16:22:40', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9367, '109096', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 17:06:38', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '75.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9368, '109084', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 15:10:43', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '50.00', '29.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9369, '109085', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 15:11:15', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9360, '109082', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 14:33:17', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '31.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9361, '109088', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 16:03:03', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.20', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9362, '109089', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 16:19:32', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.20', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9363, '109087', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 15:28:18', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '80.00', '4.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9370, '109090', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 16:22:11', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.20', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9365, '109083', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 15:09:27', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9366, '109086', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 15:26:23', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '8.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9359, '109081', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 14:03:47', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.20', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9358, '109079', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 13:33:33', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9357, '109080', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 13:38:42', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '107.10', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9356, '109078', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 13:23:29', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '100.00', '61.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9355, '109075', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 12:53:03', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.50', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9354, '109074', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 12:47:08', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9353, '109076', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 13:03:12', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '38.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9337, '109060', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 10:24:56', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '80.20', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9352, '109073', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 12:35:05', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9351, '109072', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 12:30:39', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '100.00', '73.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9350, '109071', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 12:23:14', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.10', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9349, '109077', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 13:22:49', 'Paid', NULL, '109.00', '119.90', '119.90', NULL, '150.00', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9348, '109070', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 11:53:51', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9347, '109069', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 11:22:42', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9346, '109066', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 11:06:55', 'Paid', NULL, '28.90', '31.80', '31.80', NULL, '50.00', '18.20', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9345, '109063', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 10:46:07', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9344, '109067', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 11:07:27', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9343, '109059', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 10:21:09', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9342, '109065', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 11:05:09', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9341, '109064', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 11:00:28', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9340, '109068', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 11:09:46', 'Paid', NULL, '218.00', '239.80', '239.80', NULL, '240.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9339, '109062', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 10:43:20', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9338, '109061', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 10:41:26', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9336, '109058', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 10:06:47', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '63.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9335, '109057', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-20 09:48:59', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495268667', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9417, '109139', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 17:23:59', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9418, '109135', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 16:14:19', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9419, '109141', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 18:13:38', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9420, '109140', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 17:35:12', 'Paid', NULL, '14.90', '16.40', '16.40', NULL, '16.40', '0.00', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9414, '109133', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 16:01:55', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9415, '109137', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 16:23:14', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '103.00', '40.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9416, '109134', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 16:02:23', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '120.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9412, '109127', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 14:43:47', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '50.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9410, '109131', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 15:13:16', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '35.10', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9411, '109136', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 16:15:16', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.10', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9413, '109130', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 15:09:04', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9408, '109129', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 15:04:43', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9409, '109132', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 15:19:54', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9403, '109126', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 14:36:09', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9404, '109122', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 14:16:25', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '15.00', '2.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9405, '109124', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 14:32:11', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9406, '109125', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 14:34:02', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9407, '109138', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 16:44:18', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9396, '109116', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 13:21:39', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9397, '109119', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 13:44:29', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '100.00', '56.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9398, '109121', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 13:57:30', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9399, '109117', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 13:38:00', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9400, '109128', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 14:55:59', 'Paid', NULL, '112.00', '123.20', '123.20', NULL, '150.00', '26.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9401, '109123', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 14:17:39', 'Paid', NULL, '39.00', '38.60', '38.60', NULL, '100.00', '61.40', '0.00', '0.00', '4.29', '-0.01', 'Cash', NULL, '27', '1495349721', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(9402, '109120', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 13:49:27', 'Paid', NULL, '3.90', '3.90', '3.90', NULL, '5.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9394, '109115', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 13:03:25', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9395, '109118', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 13:38:33', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.10', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9393, '109114', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 13:01:45', 'Paid', NULL, '35.00', '35.00', '35.00', NULL, '50.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9392, '109112', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 12:48:58', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '47.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9390, '109113', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 12:49:56', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9391, '109111', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 12:43:54', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9384, '109103', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 11:29:47', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9385, '109110', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 12:16:46', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9386, '109108', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 12:01:43', 'Paid', NULL, '148.00', '162.80', '162.80', NULL, '163.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9387, '109107', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 12:00:56', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '77.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9388, '109106', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 11:52:11', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9389, '109109', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 12:11:52', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.00', '10.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9383, '109100', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 11:01:00', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9382, '109105', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 11:49:00', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '74.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9381, '109099', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 10:30:28', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9379, '109102', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 11:08:19', 'Paid', NULL, '171.00', '188.10', '188.10', NULL, '200.10', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9380, '109101', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 11:05:35', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '102.00', '30.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9378, '109098', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 10:13:57', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9377, '109104', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-21 11:47:22', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '100.00', '5.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495349721', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9444, '109164', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 17:33:00', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9440, '109160', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 16:01:01', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9441, '109162', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 16:10:05', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9442, '109163', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 16:39:38', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '23.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9443, '109165', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 17:54:05', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '29.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9439, '109161', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 16:02:56', 'Paid', NULL, '92.00', '101.20', '101.20', NULL, '102.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9438, '109159', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 13:26:29', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9437, '109157', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 12:30:45', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9434, '109155', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 12:21:39', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9435, '109156', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 12:22:10', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9436, '109148', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 11:40:44', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9427, '109143', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 11:05:04', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.20', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9428, '109153', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 12:15:22', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9429, '109158', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 12:41:36', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '52.10', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9423, '109144', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 11:09:57', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9433, '109154', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 12:21:14', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '50.00', '29.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9432, '109145', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 11:24:42', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9430, '109147', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 11:35:16', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.10', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9431, '109149', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 11:43:17', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9424, '109146', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 11:31:57', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9426, '109142', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 10:54:43', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.20', '8.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9425, '109152', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 11:49:14', 'Paid', NULL, '111.00', '122.10', '122.10', NULL, '122.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9422, '109150', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 11:45:32', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.00', '7.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9421, '109151', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-22 11:46:47', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495436218', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9464, '109186', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 16:07:28', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9465, '109185', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 15:52:26', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9466, '109187', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 17:22:58', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9467, '109188', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 17:45:27', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9463, '109181', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 14:05:27', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9460, '109184', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 15:34:49', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '100.00', '5.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9461, '109180', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 14:01:43', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9462, '109182', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 14:44:32', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9459, '109178', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 13:14:00', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '16.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9458, '109179', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 13:33:57', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '100.70', '71.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9449, '109171', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 11:11:51', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9450, '109169', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 10:32:46', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9451, '109173', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 11:42:21', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9452, '109172', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 11:17:18', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9453, '109177', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 12:59:43', 'Paid', NULL, '36.90', '40.60', '40.60', NULL, '51.00', '10.40', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9454, '109175', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 11:48:35', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.40', '3.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9455, '109174', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 11:48:04', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '30.10', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9456, '109176', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 11:50:24', 'Paid', NULL, '227.00', '249.70', '249.70', NULL, '250.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9457, '109183', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 15:31:15', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9447, '109168', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 10:26:40', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9448, '109170', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 10:51:05', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9446, '109167', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 10:24:27', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '15.00', '2.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9445, '109166', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-24 10:15:23', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.00', '19.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495588949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9494, '109216', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 17:46:16', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9495, '109215', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 17:05:02', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9497, '109219', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 17:53:30', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.50', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9498, '109218', 'T1(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 17:53:21', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9499, '109217', 'T1(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 17:53:06', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9487, '109214', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 16:51:01', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9488, '109213', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 16:28:13', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9489, '109212', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 16:27:33', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '100.00', '49.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9490, '109208', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 14:45:42', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9491, '109209', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 15:32:09', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9492, '109210', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 15:46:25', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '55.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9493, '109211', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 16:26:43', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9486, '109205', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 13:42:04', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9483, '109203', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 12:38:34', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9484, '109204', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 12:56:34', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9485, '109207', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 14:44:27', 'Paid', NULL, '99.00', '108.90', '108.90', NULL, '120.00', '11.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9481, '109198', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 11:01:40', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '31.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9482, '109206', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 13:44:41', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '31.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9470, '109191', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 09:40:02', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9471, '109194', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 10:49:59', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9472, '109190', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 09:39:06', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9473, '109202', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 12:30:24', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.20', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9474, '109193', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 10:47:06', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '35.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9475, '109196', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 10:59:00', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9476, '109199', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 11:35:52', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '27.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9477, '109200', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 11:42:23', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '34.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9478, '109201', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 11:52:33', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.10', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9479, '109195', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 10:56:02', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.30', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9480, '109197', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 11:01:27', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '31.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9469, '109192', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 09:48:01', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9468, '109189', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-05-25 09:26:41', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495690898', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9532, '109252', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 18:25:41', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9526, '109247', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 16:03:40', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9527, '109246', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 16:01:03', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '100.00', '61.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9528, '109248', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 17:34:43', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9529, '109249', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 17:49:53', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9530, '109250', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 17:58:53', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9531, '109251', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 18:14:18', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '15.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9520, '109244', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 14:56:32', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9521, '109241', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 14:01:58', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9522, '109240', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 13:57:16', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9523, '109243', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 14:45:17', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9524, '109242', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 14:09:48', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9525, '109245', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 14:57:58', 'Paid', NULL, '113.00', '124.30', '124.30', NULL, '124.50', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9518, '109237', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 11:53:01', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '100.00', '51.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9519, '109239', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 12:31:48', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9514, '109234', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 11:22:40', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9515, '109235', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 11:29:33', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '41.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9517, '109231', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 11:15:27', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9516, '109230', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 11:14:04', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9513, '109238', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 12:02:44', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9502, '109226', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 10:56:33', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '58.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9503, '109227', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 11:02:41', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9504, '109221', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 10:32:08', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9505, '109236', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 11:30:11', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.00', '37.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9506, '109224', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 10:49:07', 'Paid', NULL, '118.00', '129.80', '129.80', NULL, '1501.00', '1371.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9507, '109232', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 11:16:51', 'Paid', NULL, '104.00', '114.40', '114.40', NULL, '124.40', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9508, '109228', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 11:10:29', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '55.00', '3.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9509, '109233', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 11:17:56', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9510, '109225', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 10:51:23', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '50.00', '33.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9511, '109229', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 11:13:41', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.10', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9512, '109222', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 10:32:43', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9501, '109223', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 10:34:03', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9500, '109220', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-26 09:59:20', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495784781', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9589, '109308', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 18:20:49', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9586, '109303', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 16:24:00', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9587, '109306', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 18:09:49', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9588, '109307', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 18:13:45', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '100.00', '48.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9578, '109302', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 16:05:50', 'Paid', NULL, '113.00', '124.30', '124.30', NULL, '150.00', '25.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9579, '109299', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 14:40:38', 'Paid', NULL, '304.00', '334.40', '334.40', NULL, '350.00', '15.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9584, '109304', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 16:37:57', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.10', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9581, '109296', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 14:12:14', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9582, '109295', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 14:03:12', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9583, '109301', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 15:14:19', 'Paid', NULL, '105.50', '116.05', '116.05', NULL, '120.05', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9585, '109305', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 16:45:26', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '91.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9574, '109291', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 13:47:54', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9575, '109297', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 14:22:50', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9576, '109300', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 14:44:46', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9577, '109290', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 13:45:02', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9572, '109298', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 14:29:00', 'Paid', NULL, '143.00', '157.30', '157.30', NULL, '157.50', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(9573, '109294', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 14:02:29', 'Paid', NULL, '95.00', '104.50', '104.50', NULL, '105.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9559, '109268', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 11:11:24', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9560, '109287', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 12:57:00', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '80.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9561, '109274', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 11:38:39', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9562, '109281', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 12:23:16', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9563, '109282', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 12:25:46', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9564, '109283', 'T02', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 12:35:21', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9565, '109284', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 12:36:33', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '117.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9566, '109280', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 12:18:57', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9567, '109285', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 12:41:44', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9568, '109292', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 13:49:12', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.20', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9569, '109288', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 12:59:34', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9570, '109289', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 13:14:04', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9571, '109293', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 13:49:41', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '60.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9558, '109278', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 11:55:01', 'Paid', NULL, '74.00', '73.25', '73.25', NULL, '100.00', '26.75', '0.00', '0.00', '8.14', '-0.01', 'Cash', NULL, '27', '1495866377', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9557, '109265', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 11:04:58', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9556, '109264', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 11:04:02', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9555, '109279', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 12:09:19', 'Paid', NULL, '104.00', '102.95', '102.95', NULL, '105.00', '2.05', '0.00', '0.00', '11.44', '-0.01', 'Cash', NULL, '27', '1495866377', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9554, '109286', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 12:43:06', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '101.00', '30.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9551, '109275', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 11:39:43', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.40', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9552, '109270', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 11:21:30', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '40.00', '15.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9553, '109276', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 11:44:28', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9547, '109277', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 11:47:46', 'Paid', NULL, '133.00', '146.30', '146.30', NULL, '150.30', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9548, '109271', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 11:29:43', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '45.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9549, '109273', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 11:37:55', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9550, '109272', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 11:35:35', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9535, '109254', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 09:54:57', 'Paid', NULL, '108.00', '118.80', '118.80', NULL, '120.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9537, '109256', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 10:13:02', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '90.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9538, '109257', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 10:29:49', 'Paid', NULL, '135.00', '148.50', '148.50', NULL, '150.00', '1.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9539, '109258', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 10:36:04', 'Paid', NULL, '109.00', '119.90', '119.90', NULL, '120.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9540, '109266', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 11:07:37', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9541, '109259', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 10:37:31', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '65.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9542, '109260', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 10:45:08', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '90.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9543, '109261', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 10:48:04', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9544, '109262', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 10:58:59', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9545, '109263', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 11:02:31', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9546, '109269', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 11:12:34', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9536, '109255', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 10:07:02', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9534, '109254', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 09:44:21', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9533, '109267', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-27 11:10:09', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495866377', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9645, '109361', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 16:57:02', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '63.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9644, '109353', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 15:48:51', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9638, '109349', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 15:38:37', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '65.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9639, '109355', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 15:56:56', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9640, '109359', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 16:33:58', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9641, '109358', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 16:10:28', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '55.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9642, '109360', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 16:49:24', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '30.30', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9643, '109352', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 15:48:07', 'Paid', NULL, '3.00', '3.30', '3.30', NULL, '3.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9634, '109344', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 14:47:26', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '50.00', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9635, '109348', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 15:27:28', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '90.10', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9636, '109347', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 15:07:47', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9637, '109351', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 15:47:12', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9622, '109339', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 13:47:51', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9623, '109342', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 14:07:59', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9624, '109345', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 14:52:26', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9626, '109356', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 15:58:35', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '65.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9632, '109357', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 16:09:54', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '36.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9629, '109340', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 13:48:58', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9630, '109346', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 14:58:43', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.10', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9631, '109350', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 15:45:16', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '21.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9633, '109354', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 15:56:06', 'Paid', NULL, '169.00', '185.90', '185.90', NULL, '200.00', '14.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9611, '109330', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 12:32:05', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9612, '109326', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 12:02:05', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9613, '109333', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 12:38:30', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9614, '109329', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 12:28:13', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '61.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9615, '109331', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 12:33:15', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '50.90', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9617, '109337', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 13:32:03', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9618, '109335', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 13:10:47', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9627, '109343', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 14:16:24', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9620, '109341', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 13:49:33', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9621, '109338', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 13:35:29', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9616, '109336', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 13:13:32', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9608, '109325', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 11:59:03', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9609, '109332', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 12:36:31', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9610, '109327', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 12:15:57', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '79.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9603, '109315', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 11:08:34', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9604, '109322', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 11:45:48', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9605, '109321', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 11:43:01', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9606, '109324', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 11:55:30', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.00', '43.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9607, '109328', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 12:23:42', 'Paid', NULL, '135.00', '148.50', '148.50', NULL, '200.00', '51.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9592, '109312', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 10:19:25', 'Paid', NULL, '121.00', '133.10', '133.10', NULL, '150.00', '16.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9593, '109310', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 10:14:50', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9594, '109313', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 10:50:34', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9595, '109318', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 11:10:45', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9596, '109314', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 11:04:57', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9597, '109317', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 11:10:11', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9598, '109319', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 11:11:48', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9599, '109316', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 11:09:05', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '75.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9600, '109320', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 11:31:44', 'Paid', NULL, '115.00', '126.50', '126.50', NULL, '150.00', '23.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9601, '109334', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 12:56:54', 'Paid', NULL, '102.00', '112.20', '112.20', NULL, '113.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9602, '109323', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 11:47:59', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.50', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9591, '109311', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 10:17:03', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.00', '10.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9590, '109309', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-28 09:37:51', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1495946282', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9673, '109388', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 16:29:18', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '50.00', '35.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9674, '109389', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 17:58:12', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9665, '109381', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 14:03:36', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '74.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9666, '109379', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 13:50:32', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '72.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9667, '109382', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 14:06:53', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '75.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9668, '109383', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 14:33:45', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9669, '109385', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 15:05:47', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.80', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9670, '109384', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 14:34:53', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '75.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9671, '109386', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 15:26:04', 'Paid', NULL, '138.00', '136.60', '136.60', NULL, '150.00', '13.40', '0.00', '0.00', '15.18', '-0.02', 'Cash', NULL, '27', '1496036925', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9672, '109387', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 15:33:14', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9648, '109365', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 10:59:55', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9649, '109364', 'T0', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 10:28:24', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.10', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9650, '109369', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 11:33:48', 'Paid', NULL, '121.00', '133.10', '133.10', NULL, '133.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9651, '109367', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 11:30:46', 'Paid', NULL, '97.00', '106.70', '106.70', NULL, '120.70', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9652, '109366', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 11:29:03', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '35.00', '3.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9653, '109370', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 11:40:49', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '35.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9654, '109368', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 11:32:44', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '14.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9655, '109374', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 12:24:06', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '45.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9660, '109371', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 11:56:01', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9657, '109372', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 12:08:19', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9658, '109373', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 12:18:55', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9659, '109377', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 13:15:24', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '80.00', '4.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9661, '109375', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 12:49:27', 'Paid', NULL, '99.00', '108.90', '108.90', NULL, '110.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9662, '109378', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 13:29:03', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9663, '109376', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 13:06:36', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '100.50', '73.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9664, '109380', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 14:01:21', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '106.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9647, '109363', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 10:19:46', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.20', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9646, '109362', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-29 09:56:10', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496036925', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9707, '109421', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 17:35:14', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '20.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9701, '109415', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 15:44:13', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9702, '109418', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 16:12:14', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9703, '109417', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 16:07:47', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9704, '109419', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 17:19:35', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '25.00', '1.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9705, '109422', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 18:09:14', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '53.10', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9706, '109420', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 17:24:24', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '40.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9677, '109393', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 11:18:36', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9678, '109392', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 10:29:45', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '100.00', '76.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9679, '109394', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 11:36:57', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9680, '109395', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 11:38:48', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9681, '109407', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 14:31:36', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9682, '109397', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 12:08:31', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9683, '109396', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 11:57:55', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9684, '109398', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 12:12:54', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9685, '109399', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 13:30:09', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '52.00', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9686, '109403', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 13:51:26', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.40', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9687, '109401', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 13:45:21', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9688, '109404', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 13:53:06', 'Paid', NULL, '96.00', '105.60', '105.60', NULL, '106.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9689, '109413', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 15:30:39', 'Paid', NULL, '147.00', '161.70', '161.70', NULL, '170.00', '8.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9690, '109400', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 13:34:15', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9691, '109405', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 14:10:27', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9692, '109402', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 13:45:44', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9693, '109410', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 14:50:24', 'Paid', NULL, '56.90', '62.60', '62.60', NULL, '100.00', '37.40', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9694, '109416', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 15:49:51', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '99.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9695, '109412', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 15:28:57', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '8.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(9696, '109409', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 14:48:50', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '10.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9697, '109406', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 14:24:23', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '25.00', '4.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9698, '109408', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 14:33:01', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9699, '109411', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 15:24:01', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9700, '109414', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 15:32:39', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '100.00', '5.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9676, '109390', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 09:24:40', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.00', '5.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9675, '109391', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-05-31 09:37:05', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496213320', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9710, '109425', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-01 10:23:57', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496284576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9711, '109431', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-01 11:32:22', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '47.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496284576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9712, '109426', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-01 10:47:13', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '30.50', '5.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496284576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9713, '109427', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-01 10:54:40', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496284576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9720, '109434', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-01 11:55:24', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '51.00', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496284576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9715, '109428', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-01 11:16:07', 'Paid', NULL, '125.00', '137.50', '137.50', NULL, '140.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496284576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9717, '109433', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-01 11:50:44', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '103.60', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496284576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9718, '109429', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-01 11:19:12', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '15.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496284576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9719, '109430', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-01 11:19:29', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496284576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9721, '109432', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-01 11:44:40', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.20', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496284576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9722, '109437', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-01 13:36:02', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496284576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9723, '109436', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-01 13:32:06', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496284576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9724, '109439', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-01 14:59:10', 'Paid', NULL, '103.00', '113.30', '113.30', NULL, '120.40', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496284576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9725, '109440', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-01 15:45:21', 'Paid', NULL, '115.00', '126.50', '126.50', NULL, '130.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496284576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9726, '109438', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-01 14:07:16', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '55.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496284576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9727, '109443', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-01 16:40:07', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496284576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9729, '109441', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-01 15:56:34', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496284576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9730, '109442', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-01 16:05:59', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496284576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9716, '109435', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-01 12:22:07', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '55.10', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496284576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9709, '109423', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-01 09:30:43', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '13.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496284576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9708, '109424', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-01 09:34:17', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '53.10', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496284576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9761, '109473', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 18:22:15', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9760, '109472', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 18:13:57', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9759, '109471', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 17:17:54', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '41.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9758, '109470', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 16:37:41', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '16.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9733, '109448', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 10:59:45', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9734, '109445', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 10:14:33', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '30.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9735, '109451', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 11:26:47', 'Paid', NULL, '96.00', '105.60', '105.60', NULL, '110.00', '4.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9736, '109447', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 10:58:56', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9737, '109456', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 12:10:43', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9738, '109450', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 11:20:02', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '64.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9739, '109449', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 11:07:50', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '14.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9740, '109460', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 13:17:58', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9746, '109461', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 13:18:51', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9742, '109452', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 11:59:35', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '5.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9743, '109453', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 12:00:37', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9744, '109455', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 12:02:42', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9745, '109454', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 12:02:11', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9747, '109457', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 12:28:55', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9748, '109458', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 12:43:22', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9749, '109462', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 13:21:53', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '58.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9750, '109465', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 14:23:56', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9751, '109459', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 13:07:52', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9752, '109466', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 14:29:42', 'Paid', NULL, '92.00', '101.20', '101.20', NULL, '102.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9753, '109464', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 13:49:28', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9754, '109463', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 13:22:34', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9755, '109467', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 14:36:41', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9756, '109468', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 16:07:43', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9757, '109469', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 16:23:17', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9732, '109446', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 10:43:49', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9731, '109444', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-02 09:35:10', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496372633', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9803, '109515', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 17:15:05', 'Paid', NULL, '31.00', '31.00', '31.00', NULL, '55.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9804, '109516', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 17:55:32', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9794, '109509', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 14:20:47', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '71.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9795, '109510', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 14:28:35', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '86.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9796, '109506', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 13:44:36', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9797, '109507', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 14:18:13', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9798, '109508', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 14:20:13', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '25.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9799, '109512', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 15:29:21', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '10.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9800, '109511', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 14:57:15', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '55.20', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9801, '109513', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 16:09:13', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.40', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9802, '109514', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 17:09:10', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9793, '109505', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 13:30:43', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9792, '109504', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 13:27:10', 'Paid', NULL, '132.00', '145.20', '145.20', NULL, '150.20', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9791, '109498', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 12:41:21', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.20', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9790, '109500', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 12:49:56', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '51.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9764, '109475', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 10:02:13', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '100.00', '42.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9765, '109477', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 10:20:33', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '60.00', '8.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9766, '109481', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 10:42:12', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9767, '109479', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 10:28:00', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9768, '109480', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 10:40:11', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9769, '109478', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 10:27:34', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '15.10', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9770, '109484', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 11:12:59', 'Paid', NULL, '204.00', '224.40', '224.40', NULL, '225.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9771, '109483', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 11:12:43', 'Paid', NULL, '160.00', '176.00', '176.00', NULL, '176.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9772, '109482', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 11:02:46', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '100.30', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9773, '109490', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 11:31:12', 'Paid', NULL, '159.00', '174.90', '174.90', NULL, '200.00', '25.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9774, '109492', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 11:45:56', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '76.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9775, '109486', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 11:19:37', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9776, '109489', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 11:25:26', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '55.00', '3.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9777, '109487', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 11:20:30', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '15.10', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9780, '109485', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 11:18:29', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9781, '109488', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 11:24:16', 'Paid', NULL, '3.90', '3.90', '3.90', NULL, '5.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9782, '109495', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 12:22:36', 'Paid', NULL, '133.00', '146.30', '146.30', NULL, '150.30', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9783, '109494', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 12:21:58', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '70.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9784, '109496', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 12:31:28', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9785, '109497', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 12:39:45', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9786, '109503', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 13:04:14', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9787, '109499', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 12:49:06', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9788, '109501', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 12:51:31', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.10', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9789, '109502', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 13:02:37', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '73.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9778, '109491', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 11:38:15', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9779, '109493', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 11:47:11', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '100.00', '42.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9763, '109476', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 10:05:32', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '100.00', '6.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9762, '109474', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-03 09:42:02', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.50', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496471275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9845, '109556', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 14:55:11', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9846, '109558', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 15:11:36', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9847, '109557', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 15:08:23', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9843, '109555', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 14:29:14', 'Paid', NULL, '115.00', '126.50', '126.50', NULL, '126.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9844, '109552', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 13:46:09', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9841, '109551', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 13:44:59', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9836, '109554', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 14:14:23', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9837, '109544', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 13:21:30', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9838, '109545', 'T10(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 13:26:29', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9839, '109546', 'T10(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 13:27:11', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '25.00', '1.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9840, '109547', 'T10(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 13:27:34', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9842, '109553', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 14:08:46', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9834, '109542', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 13:13:00', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9833, '109539', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 12:55:30', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9816, '109537', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 12:29:20', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9832, '109550', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 13:40:41', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9831, '109548', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 13:27:52', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9830, '109535', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 12:20:45', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9829, '109549', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 13:28:34', 'Paid', NULL, '106.00', '116.60', '116.60', NULL, '150.00', '33.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9828, '109543', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 13:18:48', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9827, '109538', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 12:34:51', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '89.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9826, '109534', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 12:20:18', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '55.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9825, '109536', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 12:27:06', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9824, '109541', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 13:09:10', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9823, '109526', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 11:35:26', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9822, '109529', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 11:40:44', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9821, '109533', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 11:49:32', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '70.20', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9820, '109527', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 11:36:43', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9808, '109521', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 10:53:19', 'Paid', NULL, '199.00', '218.90', '218.90', NULL, '250.00', '31.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9809, '109524', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 11:08:39', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9810, '109523', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 11:06:28', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '48.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9811, '109522', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 10:55:42', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.00', '30.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9812, '109540', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 13:07:24', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9813, '109525', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 11:15:36', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9814, '109531', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 11:44:29', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.00', '7.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9807, '109518', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 10:09:21', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9819, '109528', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 11:39:09', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9818, '109520', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 10:51:38', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9817, '109530', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 11:43:31', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '31.40', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9815, '109532', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 11:47:17', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9806, '109519', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 10:24:37', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9805, '109517', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-04 09:54:34', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496556838', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9867, '109583', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 17:42:48', 'Paid', NULL, '210.00', '231.00', '231.00', NULL, '251.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9872, '109579', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 15:26:04', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9873, '109582', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 17:39:39', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '55.30', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9870, '109578', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 15:24:46', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '50.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(9869, '109580', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 15:26:11', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '14.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9868, '109581', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 16:12:39', 'Paid', NULL, '33.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9866, '109577', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 15:16:41', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '41.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9865, '109574', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 14:29:40', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9864, '109575', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 14:31:17', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9863, '109573', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 14:28:54', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9854, '109564', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 10:55:59', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9862, '109572', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 14:10:24', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '110.50', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9861, '109576', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 14:50:33', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.10', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9860, '109568', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 13:11:23', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9859, '109571', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 14:10:10', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9858, '109569', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 13:29:02', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9857, '109567', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 12:45:50', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9856, '109570', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 14:02:00', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9855, '109561', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 10:35:58', 'Paid', NULL, '26.50', '29.15', '29.15', NULL, '30.00', '0.85', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9853, '109566', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 12:26:06', 'Paid', NULL, '103.00', '113.30', '113.30', NULL, '113.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9852, '109560', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 10:28:17', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.00', '29.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9850, '109562', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 10:40:15', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.50', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9851, '109559', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 09:49:50', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9849, '109563', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 10:46:33', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '29.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9848, '109565', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-05 11:23:09', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '37.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496641340', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9880, '109588', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-07 12:58:18', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496810669', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9881, '109591', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-07 14:16:10', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496810669', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9882, '109599', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-07 17:56:52', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496810669', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9883, '109592', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-07 14:25:05', 'Paid', NULL, '111.00', '122.10', '122.10', NULL, '122.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496810669', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9885, '109593', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-07 14:36:10', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '20.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496810669', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9886, '109594', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-07 15:46:35', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496810669', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9887, '109596', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-07 16:48:45', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496810669', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9888, '109595', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-07 16:33:11', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '16.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496810669', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9889, '109597', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-07 17:31:36', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '13.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496810669', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9890, '109598', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-07 17:36:45', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496810669', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9879, '109590', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-07 13:46:03', 'Paid', NULL, '114.00', '112.85', '112.85', NULL, '113.00', '0.15', '0.00', '0.00', '12.54', '-0.01', 'Cash', NULL, '27', '1496810669', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9876, '109585', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-07 12:38:45', 'Paid', NULL, '109.00', '119.90', '119.90', NULL, '120.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496810669', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9877, '109589', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-07 13:00:52', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496810669', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9878, '109586', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-07 12:51:40', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '100.00', '48.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496810669', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9875, '109587', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-07 12:56:39', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '50.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496810669', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9874, '109584', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-07 11:33:21', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496810669', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9910, '109619', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-08 17:54:15', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '10.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496901775', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9895, '109606', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-08 12:38:02', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '70.00', '7.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496901775', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9892, '109601', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-08 10:19:22', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496901775', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9893, '109602', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-08 10:24:01', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.20', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496901775', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9900, '109613', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-08 13:27:49', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '55.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496901775', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9901, '109607', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-08 12:39:29', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '44.10', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496901775', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9902, '109608', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-08 12:47:53', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496901775', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9903, '109612', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-08 13:25:34', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496901775', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9904, '109610', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-08 12:55:23', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496901775', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9905, '109615', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-08 14:04:25', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '100.30', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496901775', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9906, '109614', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-08 13:57:03', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.00', '19.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496901775', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9907, '109617', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-08 14:16:12', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496901775', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9908, '109616', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-08 14:09:07', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '52.00', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496901775', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9909, '109618', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-08 15:51:57', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '100.00', '76.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496901775', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9896, '109611', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-08 13:17:37', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '100.00', '56.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496901775', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9899, '109609', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-08 12:53:47', 'Paid', NULL, '114.00', '125.40', '125.40', NULL, '150.40', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496901775', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9898, '109604', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-08 12:31:46', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496901775', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9897, '109605', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-08 12:33:17', 'Paid', NULL, '135.00', '148.50', '148.50', NULL, '1501.00', '1352.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496901775', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9894, '109603', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-08 11:01:07', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '40.00', '9.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496901775', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9891, '109600', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-08 09:45:06', 'Paid', NULL, '122.00', '134.20', '134.20', NULL, '150.00', '15.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496901775', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9920, '109629', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-09 14:32:48', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '40.00', '2.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496990027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9921, '109630', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-09 14:47:59', 'Paid', NULL, '118.00', '118.00', '118.00', NULL, '120.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496990027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9923, '109631', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-09 15:10:01', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '42.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496990027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9924, '109632', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-09 15:17:06', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496990027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9917, '109625', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-09 12:21:01', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496990027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9918, '109627', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-09 14:09:57', 'Paid', NULL, '136.00', '149.60', '149.60', NULL, '150.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496990027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9913, '109623', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-09 11:35:15', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.00', '32.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496990027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9930, '109638', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-09 18:27:21', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496990027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9929, '109637', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-09 17:50:23', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496990027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9928, '109636', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-09 17:19:57', 'Paid', NULL, '39.50', '43.45', '43.45', NULL, '50.00', '6.55', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496990027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9927, '109635', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-09 16:48:18', 'Paid', NULL, '23.50', '25.85', '25.85', NULL, '50.00', '24.15', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496990027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9926, '109634', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-09 15:54:13', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.10', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496990027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9925, '109633', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-09 15:47:29', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496990027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9919, '109628', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-09 14:10:53', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496990027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9916, '109626', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-09 12:26:20', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '67.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496990027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9914, '109622', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-09 11:23:56', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.20', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496990027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9915, '109624', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-09 11:56:51', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '63.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496990027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9912, '109620', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-09 10:40:41', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496990027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9911, '109621', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-09 10:54:04', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '63.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1496990027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9967, '109675', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 14:34:51', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.50', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9968, '109677', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 14:42:41', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.20', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9969, '109672', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 14:19:43', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9970, '109674', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 14:24:09', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '56.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9971, '109678', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 15:15:51', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9972, '109679', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 15:28:58', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.30', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9973, '109680', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 15:45:48', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.20', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9974, '109684', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 17:08:35', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '39.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9975, '109681', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 15:57:25', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9976, '109683', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 16:40:40', 'Paid', NULL, '28.40', '31.25', '31.25', NULL, '32.00', '0.75', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9977, '109682', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 16:18:07', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '50.00', '41.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9964, '109668', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 13:47:02', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '5.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9965, '109673', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 14:20:50', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9962, '109671', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 14:14:59', 'Paid', NULL, '172.50', '189.75', '189.75', NULL, '200.00', '10.25', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9966, '109670', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 14:00:56', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9963, '109669', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 13:59:44', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9959, '109665', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 13:11:20', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9960, '109664', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 13:08:27', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '15.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9961, '109667', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 13:34:18', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9957, '109658', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 12:01:39', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9958, '109663', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 13:06:54', 'Paid', NULL, '151.00', '166.10', '166.10', NULL, '200.00', '33.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9953, '109657', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 11:57:02', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9954, '109655', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 11:55:50', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '40.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9955, '109666', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 13:27:20', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '70.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9956, '109661', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 12:31:40', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9949, '109676', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 14:40:23', 'Paid', NULL, '120.00', '132.00', '132.00', NULL, '150.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9950, '109662', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 12:51:40', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9951, '109660', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 12:21:02', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9952, '109656', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 11:56:28', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9948, '109653', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 11:23:55', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9938, '109650', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 10:50:10', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9939, '109645', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 10:27:58', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9940, '109647', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 10:40:38', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9941, '109651', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 10:51:49', 'Paid', NULL, '26.50', '29.15', '29.15', NULL, '31.00', '1.85', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9942, '109649', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 10:45:44', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '53.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9943, '109646', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 10:40:17', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9944, '109643', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 10:23:04', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(9945, '109659', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 12:15:35', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '71.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9946, '109654', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 11:46:00', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '83.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9947, '109652', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 11:14:16', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9934, '109640', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 09:39:53', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9937, '109644', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 10:23:49', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '72.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9936, '109642', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 10:10:06', 'Paid', NULL, '145.00', '159.50', '159.50', NULL, '160.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9933, '109641', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 09:43:32', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9935, '109648', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 10:42:16', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9932, '109639', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-10 08:18:47', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497078843', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10009, '109713', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 15:04:38', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10010, '109716', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 15:25:16', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10011, '109717', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 16:28:53', 'Paid', NULL, '28.50', '31.35', '31.35', NULL, '100.00', '68.65', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10012, '109718', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 16:41:03', 'Paid', NULL, '5.50', '6.05', '6.05', NULL, '6.05', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10013, '109720', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 17:59:08', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '80.00', '4.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10014, '109719', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 17:58:08', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.00', '7.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10008, '109715', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 15:24:09', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10004, '109721', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 17:59:37', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10005, '109714', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 15:06:41', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10006, '109710', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 14:34:11', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '50.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10007, '109712', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 14:54:22', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '5.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9999, '109701', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 12:30:54', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '5.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10000, '109702', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 12:31:44', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10001, '109707', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 13:22:50', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10002, '109708', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 14:20:27', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '100.00', '18.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10003, '109709', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 14:22:11', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9995, '109705', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 13:07:58', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9996, '109698', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 11:54:24', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.00', '21.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9997, '109704', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 12:55:35', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9998, '109706', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 13:16:29', 'Paid', NULL, '99.00', '108.90', '108.90', NULL, '108.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9994, '109700', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 12:24:34', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9979, '109685', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 09:53:04', 'Paid', NULL, '188.00', '206.80', '206.80', NULL, '220.00', '13.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9981, '109687', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 10:03:57', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9982, '109703', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 12:45:22', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '70.00', '7.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9983, '109689', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 10:23:13', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(9984, '109690', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 10:41:26', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '56.30', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9985, '109691', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 10:44:14', 'Paid', NULL, '99.00', '108.90', '108.90', NULL, '110.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9986, '109697', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 11:47:05', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9987, '109699', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 11:56:02', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9988, '109692', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 10:59:17', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9989, '109693', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 11:01:58', 'Paid', NULL, '102.00', '112.20', '112.20', NULL, '112.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9990, '109694', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 11:04:27', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9991, '109695', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 11:33:35', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '100.00', '73.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9992, '109696', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 11:43:39', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9993, '109711', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 14:49:50', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '23.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9980, '109688', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 10:13:00', 'Paid', NULL, '151.00', '166.10', '166.10', NULL, '200.10', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(9978, '109686', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-11 09:59:45', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '83.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497158410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10046, '109753', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 18:21:22', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10047, '109752', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 17:57:29', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10042, '109747', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 15:06:47', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10044, '109750', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 16:34:24', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10045, '109751', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 17:05:30', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10041, '109748', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 15:11:46', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10031, '109736', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 12:22:48', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.20', '44.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10032, '109737', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 12:59:46', 'Paid', NULL, '115.00', '126.50', '126.50', NULL, '126.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10033, '109738', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 13:15:55', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '74.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10034, '109741', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 13:30:16', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10035, '109740', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 13:28:52', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '70.00', '11.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10036, '109742', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 14:14:36', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10037, '109745', 't12', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 14:23:41', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '150.00', '46.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10038, '109743', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 14:16:12', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '100.00', '59.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10039, '109746', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 14:30:48', 'Paid', NULL, '97.00', '106.70', '106.70', NULL, '107.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10040, '109744', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 14:22:22', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.10', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10043, '109749', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 16:17:44', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10030, '109739', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 13:21:05', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10028, '109735', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 11:53:27', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '70.00', '16.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10027, '109734', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 11:41:50', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10026, '109733', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 11:31:06', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10025, '109732', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 11:29:05', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.40', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10024, '109729', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 11:02:27', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10016, '109724', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 10:08:28', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.40', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10017, '109723', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 10:05:23', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '103.00', '50.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10018, '109728', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 10:56:48', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10019, '109726', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 10:49:17', 'Paid', NULL, '28.50', '31.35', '31.35', NULL, '51.40', '20.05', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10020, '109725', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 10:25:27', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10021, '109727', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 10:50:05', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.00', '32.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10022, '109730', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 11:04:32', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.30', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10023, '109731', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 11:15:10', 'Paid', NULL, '130.00', '143.00', '143.00', NULL, '150.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10015, '109722', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-12 09:15:30', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497251184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10077, '109781', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 15:17:03', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10078, '109783', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 16:33:11', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10079, '109785', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 17:12:38', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10080, '109784', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 16:41:18', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '50.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10075, '109778', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 14:12:18', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10076, '109780', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 14:43:29', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.70', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10065, '109767', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 12:33:14', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10066, '109770', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 13:11:05', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '49.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10067, '109772', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 13:22:05', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10069, '109782', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 16:30:22', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '50.00', '39.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10070, '109776', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 13:46:45', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10071, '109775', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 13:43:23', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '36.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10072, '109779', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 14:26:00', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10073, '109777', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 13:59:50', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '15.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10074, '109774', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 13:28:34', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10064, '109773', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 13:25:54', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10062, '109769', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 12:37:01', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10063, '109768', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 12:35:52', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10061, '109764', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 11:47:08', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10049, '109755', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 09:51:45', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10060, '109763', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 11:46:21', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10059, '109762', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 11:43:29', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10058, '109761', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 11:39:35', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '20.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10050, '109759', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 10:35:15', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10057, '109771', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 13:18:36', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10056, '109766', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 11:51:36', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10055, '109765', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 11:47:46', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10054, '109760', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 11:30:27', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.00', '3.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10053, '109757', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 10:19:15', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10052, '109758', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 10:25:25', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '105.00', '40.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10051, '109756', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 10:08:13', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '20.00', '12.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10048, '109754', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-14 09:51:13', 'Paid', NULL, '117.00', '128.70', '128.70', NULL, '150.00', '21.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497412185', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10099, '109800', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 14:46:23', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10100, '109803', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 15:35:16', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '102.00', '20.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10101, '109801', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 15:00:11', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10102, '109808', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 16:06:11', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10103, '109805', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 15:51:46', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.00', '7.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10095, '109799', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 14:28:35', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '100.00', '75.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10096, '109804', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 15:42:33', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.90', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10097, '109806', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 15:54:08', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.20', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10098, '109807', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 15:55:35', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10094, '109802', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 15:13:59', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '60.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10093, '109798', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 14:22:50', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10092, '109796', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 14:13:44', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '100.00', '72.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10091, '109795', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 13:44:47', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10090, '109797', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 14:20:17', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '103.80', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10089, '109792', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 12:33:36', 'Paid', NULL, '167.00', '183.70', '183.70', NULL, '200.00', '16.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10088, '109794', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 12:34:47', 'Paid', NULL, '105.00', '115.50', '115.50', NULL, '115.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10087, '109793', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 12:34:20', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '120.70', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10086, '109790', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 11:44:49', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10085, '109791', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 11:56:13', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10084, '109789', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 11:31:58', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '100.30', '53.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10082, '109788', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 11:05:48', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10083, '109786', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 10:09:14', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '100.00', '8.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10081, '109787', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-15 10:17:33', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497508226', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10119, '109821', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-16 13:09:33', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497594779', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10120, '109823', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-16 13:40:31', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '73.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497594779', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10121, '109825', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-16 14:16:15', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497594779', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10122, '109824', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-16 14:06:15', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '100.00', '80.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497594779', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10123, '109826', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-06-16 14:34:05', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '37.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497594779', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10124, '109829', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-16 16:19:49', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.20', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497594779', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10125, '109830', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-16 16:23:30', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497594779', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10126, '109828', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-06-16 16:11:38', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '100.00', '50.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497594779', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10127, '109827', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-16 16:06:08', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497594779', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10118, '109822', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-16 13:11:14', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '45.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497594779', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10117, '109820', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-16 13:08:24', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497594779', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10116, '109817', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-16 12:25:53', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497594779', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10114, '109816', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-16 12:17:01', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497594779', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10113, '109815', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-16 12:09:04', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '5.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497594779', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10112, '109818', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-16 12:26:26', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497594779', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10111, '109819', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-16 12:37:45', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497594779', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10110, '109814', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-16 11:32:27', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497594779', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10109, '109812', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-16 10:28:41', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497594779', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10106, '109810', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-16 09:55:22', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.50', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497594779', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10108, '109811', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-16 10:18:15', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497594779', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10107, '109813', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-16 10:29:48', 'Paid', NULL, '39.50', '43.45', '43.45', NULL, '100.00', '56.55', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497594779', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10105, '109809', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-16 09:50:07', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '67.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497594779', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10157, '109860', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 15:41:43', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.00', '15.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10158, '109859', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 15:23:25', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10159, '109863', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 16:47:41', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10160, '109861', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 16:40:26', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.40', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10161, '109864', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 17:01:45', 'Paid', NULL, '186.00', '204.60', '204.60', NULL, '210.00', '5.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10162, '109866', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 17:06:40', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '40.00', '11.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10163, '109868', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 17:44:36', 'Paid', NULL, '96.00', '105.60', '105.60', NULL, '106.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10164, '109862', 'T5(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 16:46:41', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10165, '109867', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 17:08:17', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '13.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10166, '109865', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 17:02:30', 'Paid', NULL, '54.00', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10142, '109841', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 12:30:56', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10143, '109844', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 12:38:45', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '70.00', '8.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10144, '109842', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 12:37:00', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.00', '29.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10145, '109850', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 13:44:53', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10146, '109846', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 12:56:12', 'Paid', NULL, '95.00', '104.50', '104.50', NULL, '120.00', '15.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10147, '109852', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 14:07:56', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '62.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10155, '109856', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 14:52:51', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10156, '109857', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 15:07:07', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10148, '109855', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 14:50:08', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10149, '109851', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 13:46:54', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10150, '109849', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 13:36:24', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10151, '109848', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 13:26:51', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10153, '109854', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 14:48:13', 'Paid', NULL, '93.00', '102.30', '102.30', NULL, '103.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10154, '109858', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 15:11:22', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10141, '109847', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 13:12:08', 'Paid', NULL, '31.50', '34.65', '34.65', NULL, '50.00', '15.35', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10138, '109840', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 11:46:57', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '54.10', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(10139, '109845', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 12:50:33', 'Paid', NULL, '131.00', '144.10', '144.10', NULL, '150.00', '5.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10140, '109843', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 12:37:58', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '67.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10137, '109839', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 11:42:01', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.00', '30.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10136, '109838', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 11:29:41', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10135, '109853', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 14:22:11', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10134, '109836', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 11:13:30', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10133, '109837', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 11:20:37', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '36.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10131, '109833', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 10:28:52', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10132, '109834', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 11:06:07', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10129, '109832', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 10:16:46', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10130, '109835', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 11:13:01', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.10', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10128, '109831', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-17 10:13:31', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497686642', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10189, '109896', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 14:26:32', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '70.00', '9.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10190, '109888', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 13:13:25', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10191, '109889', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 13:15:01', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10192, '109897', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 14:34:33', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10193, '109894', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 13:58:59', 'Paid', NULL, '109.00', '119.90', '119.90', NULL, '150.00', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10194, '109891', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 13:33:12', 'Paid', NULL, '97.00', '106.70', '106.70', NULL, '110.00', '3.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10195, '109898', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 14:40:07', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '102.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10196, '109893', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 13:55:05', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10197, '109904', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 15:09:36', 'Paid', NULL, '148.00', '162.80', '162.80', NULL, '200.00', '37.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10198, '109895', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 14:18:53', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '90.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10199, '109902', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 14:53:44', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10200, '109899', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 14:41:26', 'Paid', NULL, '92.00', '101.20', '101.20', NULL, '120.00', '18.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10201, '109892', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 13:53:54', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10202, '109910', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 17:15:34', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10203, '109909', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 16:35:32', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10204, '109903', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 15:05:13', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10205, '109905', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 15:52:18', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '50.00', '29.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10206, '109907', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 16:29:25', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10207, '109908', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 16:32:36', 'Paid', NULL, '96.00', '105.60', '105.60', NULL, '105.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10208, '109911', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 17:24:41', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.20', '38.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10209, '109912', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 17:38:37', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '35.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10211, '109906', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 16:25:58', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10181, '109901', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 14:47:34', 'Paid', NULL, '113.00', '124.30', '124.30', NULL, '130.30', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10182, '109881', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 12:26:15', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10183, '109885', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 12:37:28', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10184, '109883', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 12:32:33', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '15.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10185, '109890', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 13:23:52', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10186, '109886', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 12:56:07', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10187, '109887', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 13:00:03', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10188, '109900', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 14:41:52', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.00', '19.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10174, '109874', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 10:46:31', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10175, '109878', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 12:01:28', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10176, '109879', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 12:24:59', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10177, '109882', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 12:30:21', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '81.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10178, '109880', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 12:25:35', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '55.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10179, '109877', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 11:39:49', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '20.00', '14.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10180, '109884', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 12:35:06', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '80.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10173, '109876', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 11:04:56', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10172, '109875', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 10:49:25', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '101.40', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10168, '109870', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 10:16:53', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '70.00', '8.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10169, '109871', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 10:18:10', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10171, '109873', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 10:43:25', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10170, '109872', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 10:22:28', 'Paid', NULL, '93.00', '102.30', '102.30', NULL, '102.40', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10167, '109869', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-18 10:06:07', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497764902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10237, '109931', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 14:06:13', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10228, '109925', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 12:41:37', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10229, '109926', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 12:56:20', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10230, '109930', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 13:52:42', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '52.00', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10231, '109932', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 14:19:32', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10232, '109933', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 15:13:28', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10233, '109927', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 13:29:54', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10234, '109928', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 13:30:34', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '25.10', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10235, '109929', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 13:32:34', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10238, '109935', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 15:25:23', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10239, '109936', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 15:31:06', 'Paid', NULL, '97.00', '106.70', '106.70', NULL, '107.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10240, '109934', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 15:24:34', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10241, '109937', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 15:35:36', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10242, '109941', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 17:48:05', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '53.10', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10243, '109938', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 15:36:46', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '50.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10245, '109940', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 16:50:23', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10219, '109924', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 12:34:42', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10220, '109921', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 12:03:08', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.20', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10226, '109942', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 17:50:00', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '69.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10222, '109939', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 15:44:24', 'Paid', NULL, '59.50', '65.45', '65.45', NULL, '100.00', '34.55', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10223, '109919', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 11:01:05', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10224, '109920', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 11:25:06', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10225, '109923', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 12:30:33', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10213, '109917', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 10:01:50', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10218, '109922', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 12:21:42', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '100.00', '73.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10216, '109916', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 09:48:55', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '51.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10217, '109918', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 10:37:53', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.30', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10214, '109915', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 09:47:53', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10215, '109913', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 09:18:39', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '25.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10212, '109914', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-19 09:44:37', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1497854525', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10277, '109972', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 17:36:32', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10276, '109969', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 15:44:27', 'Paid', NULL, '12.00', '10.80', '10.80', NULL, '10.80', '0.00', '0.00', '0.00', '1.20', '0.00', 'Cash', NULL, '27', '1498023646', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10275, '109970', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 16:22:36', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '68.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10274, '109968', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 15:23:32', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '20.00', '13.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10273, '109971', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 17:35:58', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '14.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10272, '109966', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 15:03:43', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '20.00', '10.10', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1498023646', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10271, '109967', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 15:19:52', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10269, '109958', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 13:08:24', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10268, '109957', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 13:07:37', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '5.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10267, '109959', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 13:17:02', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.50', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10260, '109952', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 12:06:20', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '29.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10261, '109953', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 12:06:48', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10263, '109963', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 14:21:36', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '90.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10270, '109965', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 14:45:03', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '99.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10265, '109961', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 13:30:38', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10266, '109956', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 12:41:19', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '26.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10259, '109951', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 12:04:54', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10258, '109948', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 11:58:32', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '29.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10257, '109947', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 11:57:53', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.50', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10256, '109960', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 13:19:45', 'Paid', NULL, '122.00', '134.20', '134.20', NULL, '150.20', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10255, '109946', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 11:42:01', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10253, '109950', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 12:02:05', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10254, '109955', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 12:15:15', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10252, '109949', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 12:01:05', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '101.00', '40.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10262, '109962', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 13:31:49', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10247, '109944', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 10:11:10', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.10', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10248, '109964', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 14:23:01', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10249, '109945', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 10:31:28', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10250, '109954', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 12:11:00', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10246, '109943', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-21 09:31:11', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '100.10', '77.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498023646', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10299, '109994', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 16:21:00', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '31.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10300, '109995', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 17:24:35', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.20', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10296, '109990', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 14:46:59', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '51.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10297, '109991', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 14:58:08', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.80', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10295, '109992', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 14:59:41', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.30', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10298, '109993', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 16:01:06', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10283, '109979', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 11:13:06', 'Paid', NULL, '308.00', '338.80', '338.80', NULL, '350.00', '11.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10285, '109978', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 10:47:28', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '70.00', '19.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10286, '109980', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 11:18:18', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '28.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10287, '109981', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 11:19:17', 'Paid', NULL, '10.50', '10.50', '10.50', NULL, '10.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10288, '109985', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 12:46:32', 'Paid', NULL, '113.00', '124.30', '124.30', NULL, '125.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10289, '109983', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 12:07:09', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '100.00', '94.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10290, '109986', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 12:50:52', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '79.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10291, '109987', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 12:55:04', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10292, '109984', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 12:44:43', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.10', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10293, '109988', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 13:30:53', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10294, '109989', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 14:30:48', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10284, '109977', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 10:39:41', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.20', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10282, '109975', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 10:04:43', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10281, '109982', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 11:51:45', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '100.00', '52.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10279, '109976', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 10:21:59', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10280, '109974', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 09:59:09', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10278, '109973', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-22 09:47:59', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498105008', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10306, '110001', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-23 11:02:58', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '21.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498195504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10307, '110002', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-23 11:54:18', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.10', '20.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498195504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10308, '110003', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-23 12:28:15', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '103.00', '30.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498195504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10309, '110005', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-23 14:04:20', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498195504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10310, '110004', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-23 14:01:50', 'Paid', NULL, '112.00', '123.20', '123.20', NULL, '200.00', '76.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498195504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10311, '110006', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-23 15:02:49', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '120.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498195504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10312, '110009', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-23 18:05:10', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498195504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10313, '110011', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-23 18:08:18', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498195504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(10314, '110010', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-23 18:06:33', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '107.20', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498195504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10315, '110007', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-23 18:03:29', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498195504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10316, '110008', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-23 18:04:31', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498195504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10305, '109999', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-23 10:31:47', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498195504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10304, '109996', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-23 10:21:47', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498195504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10302, '109998', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-23 10:30:46', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498195504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10303, '109997', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-23 10:29:46', 'Paid', NULL, '159.00', '174.90', '174.90', NULL, '200.00', '25.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498195504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10301, '110000', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-23 10:41:28', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498195504', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10351, '110045', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 16:13:42', 'Paid', NULL, '23.00', '20.70', '20.70', NULL, '50.00', '29.30', '0.00', '0.00', '2.30', '0.00', 'Cash', NULL, '27', '1498287316', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10352, '110046', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 16:44:57', 'Paid', NULL, '10.00', '9.00', '9.00', NULL, '20.00', '11.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1498287316', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10353, '110047', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 17:44:29', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '51.80', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10350, '110040', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 15:28:35', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '8.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10349, '110043', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 15:46:13', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '17.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10348, '110041', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 15:33:00', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10347, '110042', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 15:35:09', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '56.40', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10346, '110038', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 14:41:24', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10345, '110036', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 14:16:45', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10344, '110037', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 14:34:41', 'Paid', NULL, '141.00', '155.10', '155.10', NULL, '156.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10343, '110048', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 17:51:10', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '68.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10342, '110032', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 13:15:04', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10337, '110039', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 14:42:13', 'Paid', NULL, '32.00', '31.70', '31.70', NULL, '52.00', '20.30', '0.00', '0.00', '3.52', '0.02', 'Cash', NULL, '27', '1498287316', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10338, '110030', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 12:32:31', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '40.00', '4.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10339, '110033', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 13:18:12', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10340, '110044', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 15:54:22', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10341, '110035', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 13:44:49', 'Paid', NULL, '101.00', '111.10', '111.10', NULL, '111.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10322, '110014', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 10:37:46', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10323, '110019', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 11:15:59', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10324, '110021', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 11:19:47', 'Paid', NULL, '96.00', '105.60', '105.60', NULL, '106.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10325, '110020', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 11:17:46', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '80.00', '7.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10326, '110017', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 10:57:34', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10327, '110018', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 11:15:05', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10328, '110029', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 12:20:28', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '55.00', '3.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10329, '110024', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 11:43:48', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '60.20', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10330, '110026', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 11:55:40', 'Paid', NULL, '93.00', '102.30', '102.30', NULL, '102.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10331, '110028', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 12:19:40', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.40', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10332, '110031', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 12:52:28', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '68.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10333, '110025', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 11:49:38', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10334, '110034', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 13:34:52', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.20', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10335, '110023', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 11:34:47', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '13.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10336, '110027', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 12:06:10', 'Paid', NULL, '23.00', '20.70', '20.70', NULL, '21.00', '0.30', '0.00', '0.00', '2.30', '0.00', 'Cash', NULL, '27', '1498287316', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10321, '110022', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 11:30:14', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10320, '110016', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 10:57:05', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '41.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10318, '110013', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 10:23:02', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '99.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10319, '110015', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 10:39:44', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '70.50', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10317, '110012', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-24 09:31:23', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498287316', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10421, '110112', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 17:48:43', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10418, '110107', 'T10(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 16:43:31', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '29.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10420, '110109', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 17:39:08', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '27.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10419, '110108', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 17:30:33', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.00', '5.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10413, '110101', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 15:51:24', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10414, '110103', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 16:28:48', 'Paid', NULL, '93.00', '102.30', '102.30', NULL, '102.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10415, '110110', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 17:46:26', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10416, '110104', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 16:29:31', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10417, '110106', 'T10(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 16:42:43', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10411, '110099', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 15:47:41', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10410, '110096', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 15:25:28', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '8.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10409, '110095', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 15:21:03', 'Paid', NULL, '9.00', '8.10', '8.10', NULL, '8.10', '0.00', '0.00', '0.00', '0.90', '0.00', 'Cash', NULL, '27', '1498370688', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10405, '110102', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 15:55:09', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.50', '8.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10407, '110100', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 15:48:24', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.00', '19.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10408, '110098', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 15:39:20', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10388, '110082', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 13:20:45', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10389, '110084', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 13:32:12', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10390, '110076', 'T14(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 12:39:37', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '28.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10391, '110077', 'T14(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 12:40:06', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '37.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10393, '110085', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 13:33:31', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '50.00', '35.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10394, '110097', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 15:26:39', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10395, '110080', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 12:51:38', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10396, '110088', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 14:06:35', 'Paid', NULL, '114.00', '125.40', '125.40', NULL, '150.00', '24.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10397, '110087', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 13:57:11', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10398, '110090', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 14:12:23', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10399, '110111', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 17:48:21', 'Paid', NULL, '23.00', '20.70', '20.70', NULL, '20.70', '0.00', '0.00', '0.00', '2.30', '0.00', 'Cash', NULL, '27', '1498370688', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10400, '110092', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 14:45:55', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10401, '110094', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 15:20:04', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10402, '110089', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 14:11:27', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10406, '110105', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 16:33:41', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10404, '110093', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 15:08:47', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '28.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10392, '110083', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 13:29:57', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10383, '110086', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 13:56:15', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10384, '110079', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 12:45:27', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10385, '110069', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 12:00:13', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10386, '110081', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 13:06:06', 'Paid', NULL, '98.00', '107.80', '107.80', NULL, '108.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10387, '110075', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 12:36:44', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10380, '110065', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 11:38:15', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10381, '110078', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 12:43:43', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10362, '110058', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 11:05:19', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10363, '110057', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 11:02:06', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '101.50', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10364, '110051', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 10:30:50', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.70', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10359, '110054', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 10:40:46', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10360, '110056', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 10:54:27', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.40', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10361, '110055', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 10:53:47', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10365, '110062', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 11:30:30', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '62.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10373, '110059', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 11:18:07', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10367, '110061', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 11:28:00', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10368, '110060', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 11:21:05', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10369, '110063', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 11:33:30', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '65.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10370, '110066', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 11:38:56', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10371, '110067', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 11:47:11', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.40', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10372, '110072', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 12:18:11', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10374, '110068', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 11:58:35', 'Paid', NULL, '114.00', '125.40', '125.40', NULL, '125.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10375, '110071', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 12:16:41', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10376, '110074', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 12:28:48', 'Paid', NULL, '111.00', '122.10', '122.10', NULL, '150.00', '27.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10377, '110073', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 12:18:47', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10378, '110070', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 12:02:25', 'Paid', NULL, '23.50', '25.85', '25.85', NULL, '50.00', '24.15', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10379, '110064', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 11:36:18', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10358, '110053', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 10:38:18', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10357, '110052', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 10:31:18', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10355, '110049', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 10:04:26', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '70.00', '16.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10356, '110091', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 14:36:37', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10354, '110050', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-25 10:24:40', 'Paid', NULL, '129.00', '141.90', '141.90', NULL, '141.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498370688', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10476, '110161', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 15:30:20', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '9.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10477, '110165', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 16:09:11', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.50', '5.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10478, '110168', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 17:44:23', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10479, '110167', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 16:55:58', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10473, '110158', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 15:17:46', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10474, '110166', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 16:25:59', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10475, '110160', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 15:26:59', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10452, '110138', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 12:26:16', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10453, '110142', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 12:39:37', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.50', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10454, '110141', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 12:32:34', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '100.40', '52.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10455, '110162', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 15:38:10', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10456, '110144', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 12:49:31', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10457, '110146', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 12:55:43', 'Paid', NULL, '85.00', '84.15', '84.15', NULL, '100.00', '15.85', '0.00', '0.00', '9.35', '0.00', 'Cash', NULL, '27', '1498457127', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10458, '110145', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 12:51:54', 'Paid', NULL, '96.00', '105.60', '105.60', NULL, '105.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10459, '110153', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 13:36:23', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.30', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10460, '110149', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 13:18:37', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.30', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10461, '110147', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 13:12:33', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '57.30', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10462, '110152', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 13:34:28', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.40', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10463, '110148', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 13:15:26', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10464, '110151', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 13:20:21', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '34.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10465, '110143', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 12:46:32', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '100.60', '61.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10466, '110156', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 14:40:19', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '97.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10467, '110164', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 16:04:35', 'Paid', NULL, '93.00', '92.05', '92.05', NULL, '100.05', '8.00', '0.00', '0.00', '10.23', '-0.02', 'Cash', NULL, '27', '1498457127', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10468, '110155', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 14:36:53', 'Paid', NULL, '92.00', '101.20', '101.20', NULL, '101.50', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10451, '110134', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 12:07:22', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '40.00', '1.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10469, '110157', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 15:06:48', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '41.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10470, '110159', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 15:18:37', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10471, '110154', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 14:27:46', 'Paid', NULL, '149.00', '163.90', '163.90', NULL, '173.90', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10472, '110163', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 16:01:35', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10428, '110117', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 10:10:50', 'Paid', NULL, '111.00', '122.10', '122.10', NULL, '122.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10429, '110120', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 10:34:30', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.40', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10431, '110121', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 10:55:10', 'Paid', NULL, '197.00', '216.70', '216.70', NULL, '220.00', '3.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10432, '110124', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 11:04:24', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '100.00', '61.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10433, '110123', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 10:59:07', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '50.00', '31.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10434, '110127', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 11:19:50', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.10', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10435, '110122', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 10:57:47', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10436, '110126', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 11:18:29', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10437, '110139', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 12:27:42', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '77.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(10438, '110125', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 11:14:23', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.00', '2.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10439, '110119', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 10:32:56', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '100.00', '63.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10448, '110132', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 12:00:24', 'Paid', NULL, '95.00', '104.50', '104.50', NULL, '120.00', '15.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10441, '110128', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 11:37:24', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '65.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10442, '110137', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 12:17:31', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '70.00', '11.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10443, '110129', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 11:38:45', 'Paid', NULL, '135.00', '148.50', '148.50', NULL, '150.00', '1.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10444, '110135', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 12:09:31', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '70.00', '8.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10445, '110130', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 11:46:13', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10446, '110150', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 13:18:58', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10447, '110131', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 11:51:18', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.00', '29.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10449, '110140', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 12:30:14', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '103.00', '10.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10450, '110136', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 12:16:48', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '100.00', '49.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10430, '110118', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 10:19:15', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10427, '110116', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 10:09:36', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10426, '110115', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 10:08:02', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10424, '110133', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 12:04:22', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '81.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10423, '110113', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 09:10:13', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10422, '110114', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-26 09:37:11', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '70.00', '10.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498457127', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10513, '110199', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 17:56:18', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10514, '110198', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 17:35:04', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '103.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10505, '110192', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 15:43:45', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10506, '110193', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 15:56:32', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10507, '110194', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 16:05:29', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '74.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10508, '110196', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 17:24:40', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.20', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10509, '110200', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 17:56:52', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '50.00', '41.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10510, '110195', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 16:48:14', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '8.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10511, '110202', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 17:59:47', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '40.00', '11.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10512, '110201', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 17:58:29', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '61.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10486, '110175', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 10:28:43', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10487, '110173', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 10:14:34', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10488, '110176', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 11:15:19', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '21.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10489, '110174', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 10:27:46', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '50.00', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10490, '110177', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 11:15:47', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10491, '110178', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 11:29:50', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '70.70', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10492, '110180', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 11:57:09', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10493, '110179', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 11:49:40', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10494, '110181', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 12:41:39', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10495, '110183', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 13:32:09', 'Paid', NULL, '106.00', '116.60', '116.60', NULL, '150.00', '33.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10496, '110191', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 14:07:49', 'Paid', NULL, '113.00', '111.85', '111.85', NULL, '112.00', '0.15', '0.00', '0.00', '12.43', '-0.02', 'Cash', NULL, '27', '1498626392', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10497, '110184', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 13:33:55', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '100.60', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10498, '110189', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 13:50:58', 'Paid', NULL, '123.00', '135.30', '135.30', NULL, '150.00', '14.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10499, '110188', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 13:43:36', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10500, '110186', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 13:41:42', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.20', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10501, '110185', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 13:36:31', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '15.00', '2.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10502, '110187', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 13:42:14', 'Paid', NULL, '3.90', '3.90', '3.90', NULL, '5.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10503, '110190', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 13:52:57', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.00', '15.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10504, '110197', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 17:33:41', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '53.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10484, '110171', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 09:58:36', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10483, '110170', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 09:57:50', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '15.50', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10485, '110182', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 12:42:26', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.10', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10482, '110172', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 10:12:51', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10480, '110169', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-28 09:46:22', 'Paid', NULL, '61.90', '68.10', '68.10', NULL, '70.10', '2.00', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1498626392', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10549, '110234', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 16:40:24', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10550, '110232', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 16:31:25', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '25.00', '1.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10551, '110237', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 17:52:16', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '26.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10552, '110239', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 17:54:06', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '40.10', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10553, '110238', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 17:52:49', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '30.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10540, '110228', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 14:47:44', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '90.00', '5.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10541, '110225', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 14:19:07', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10542, '110226', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 14:19:54', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10543, '110227', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 14:20:13', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10545, '110229', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 14:58:45', 'Paid', NULL, '38.00', '37.60', '37.60', NULL, '50.00', '12.40', '0.00', '0.00', '4.18', '-0.02', 'Cash', NULL, '27', '1498714477', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10546, '110235', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 17:15:41', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10547, '110230', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 15:41:49', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10548, '110236', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 17:17:39', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10519, '110207', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 11:26:31', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10520, '110213', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 12:46:00', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10527, '110211', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 12:10:38', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '20.00', '11.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10522, '110212', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 12:20:49', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '70.00', '9.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10523, '110220', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 13:45:51', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '102.70', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10524, '110208', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 11:50:10', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10525, '110209', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 11:50:27', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10526, '110210', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 11:51:01', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '16.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10528, '110214', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 12:57:24', 'Paid', NULL, '113.00', '124.30', '124.30', NULL, '150.40', '26.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10529, '110233', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 16:32:02', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.50', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10530, '110216', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 13:24:52', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10531, '110215', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 13:07:13', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10532, '110222', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 14:00:38', 'Paid', NULL, '111.00', '122.10', '122.10', NULL, '150.10', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10533, '110217', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 13:26:26', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10534, '110219', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 13:35:52', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '68.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10535, '110218', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 13:32:57', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10536, '110224', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 14:11:56', 'Paid', NULL, '110.00', '121.00', '121.00', NULL, '121.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10537, '110221', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 13:46:23', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.00', '4.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10544, '110231', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 16:24:14', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10539, '110223', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 14:06:10', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '21.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10516, '110204', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 10:25:31', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.00', '2.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10517, '110203', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 10:24:43', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10518, '110206', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 11:03:45', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10515, '110205', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-29 10:42:24', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498714477', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10566, '110252', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-30 12:08:59', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '100.00', '64.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498792010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10567, '110250', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-30 11:40:16', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498792010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10568, '110253', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-30 12:39:03', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498792010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10570, '110255', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-30 13:07:33', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '101.00', '30.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498792010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10571, '110254', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-30 13:01:47', 'Paid', NULL, '142.00', '156.20', '156.20', NULL, '160.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498792010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10572, '110257', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-30 13:33:45', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '103.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498792010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10573, '110256', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-30 13:33:02', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '100.40', '63.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498792010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10574, '110258', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-06-30 16:05:26', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '70.50', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498792010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10555, '110246', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-06-30 11:28:14', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.40', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498792010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10556, '110242', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-06-30 10:53:16', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498792010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10557, '110241', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-30 10:43:24', 'Paid', NULL, '24.00', '23.75', '23.75', NULL, '50.00', '26.25', '0.00', '0.00', '2.64', '-0.01', 'Cash', NULL, '27', '1498792010', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10558, '110243', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-30 11:08:12', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '71.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498792010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10559, '110244', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-30 11:09:51', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498792010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10560, '110245', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-06-30 11:19:05', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '50.00', '41.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498792010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10561, '110249', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-30 11:30:53', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '40.00', '9.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498792010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10562, '110247', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-30 11:29:41', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498792010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10569, '110259', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-06-30 16:21:15', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498792010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10565, '110251', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-06-30 11:52:57', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '54.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498792010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10564, '110248', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-06-30 11:30:12', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498792010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10554, '110240', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-06-30 10:03:50', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498792010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10607, '110286', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 15:32:59', 'Paid', NULL, '36.00', '36.00', '36.00', NULL, '51.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10608, '110289', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 16:09:55', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10609, '110292', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 16:43:34', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '63.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10610, '110299', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 17:35:16', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10611, '110294', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 17:00:37', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.20', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10612, '110296', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 17:20:32', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '52.10', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10613, '110297', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 17:26:52', 'Paid', NULL, '17.00', '15.30', '15.30', NULL, '15.30', '0.00', '0.00', '0.00', '1.70', '0.00', 'Cash', NULL, '27', '1498895817', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10614, '110293', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 16:59:32', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10606, '110290', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 16:19:53', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10605, '110295', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 17:05:29', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '117.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10604, '110298', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 17:31:34', 'Paid', NULL, '105.00', '103.95', '103.95', NULL, '104.00', '0.05', '0.00', '0.00', '11.55', '0.00', 'Cash', NULL, '27', '1498895817', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10579, '110263', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 10:53:56', 'Paid', NULL, '154.00', '169.40', '169.40', NULL, '200.00', '30.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10580, '110264', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 10:59:31', 'Paid', NULL, '174.00', '191.40', '191.40', NULL, '202.00', '10.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10581, '110265', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 11:19:17', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '101.00', '30.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10582, '110266', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 11:23:16', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10583, '110268', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 11:55:53', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10584, '110267', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 11:40:41', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10585, '110281', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 13:39:43', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10586, '110282', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 13:48:32', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '100.00', '8.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10587, '110269', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 12:25:00', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.20', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10588, '110275', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 12:55:46', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.20', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10589, '110273', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 12:48:37', 'Paid', NULL, '101.00', '111.10', '111.10', NULL, '111.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10590, '110272', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 12:45:39', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '105.00', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10591, '110274', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 12:54:04', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.00', '15.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10592, '110276', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 13:03:12', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.10', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10593, '110277', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 13:07:48', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.30', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10594, '110279', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 13:14:04', 'Paid', NULL, '15.00', '14.85', '14.85', NULL, '50.00', '35.15', '0.00', '0.00', '1.65', '0.00', 'Cash', NULL, '27', '1498895817', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10595, '110278', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 13:09:58', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10596, '110271', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 12:35:54', 'Paid', NULL, NULL, '0.00', '0.00', NULL, '0.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10597, '110280', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 13:25:02', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10598, '110283', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 13:56:28', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10599, '110285', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 14:44:54', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.30', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10600, '110284', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 14:23:02', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10601, '110287', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 15:46:15', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10602, '110291', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 16:37:04', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10603, '110288', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 16:00:22', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10578, '110270', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 12:29:05', 'Paid', NULL, '18.00', '17.80', '17.80', NULL, '17.80', '0.00', '0.00', '0.00', '1.98', '-0.02', 'Cash', NULL, '27', '1498895817', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10576, '110261', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 10:37:41', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(10577, '110262', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 10:50:50', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '65.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10575, '110260', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-01 10:01:22', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498895817', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10667, '110349', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 16:42:33', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10662, '110348', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 16:34:37', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10663, '110344', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 15:31:14', 'Paid', NULL, '117.00', '128.70', '128.70', NULL, '140.00', '11.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10664, '110350', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 17:16:05', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '100.50', '62.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10665, '110342', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 15:18:09', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10666, '110343', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 15:18:33', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '100.00', '67.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10668, '110347', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 16:31:15', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10669, '110351', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 17:26:22', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10660, '110341', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 14:59:22', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10659, '110340', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 14:40:07', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10645, '110328', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 13:30:51', 'Paid', NULL, '119.00', '130.90', '130.90', NULL, '130.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10646, '110330', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 13:36:25', 'Paid', NULL, '146.00', '160.60', '160.60', NULL, '160.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10647, '110329', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 13:35:19', 'Paid', NULL, '141.00', '155.10', '155.10', NULL, '155.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10648, '110338', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 14:26:55', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10657, '110335', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 14:18:29', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.40', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10649, '110339', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 14:27:57', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10650, '110336', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 14:22:58', 'Paid', NULL, '91.00', '90.10', '90.10', NULL, '100.10', '10.00', '0.00', '0.00', '10.01', '0.01', 'Cash', NULL, '27', '1498976735', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10651, '110331', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 13:52:54', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.00', '32.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10652, '110325', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 13:15:35', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10653, '110333', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 14:14:19', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '68.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10658, '110345', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 15:34:46', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '51.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10655, '110346', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 16:27:28', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '10.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10656, '110334', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 14:17:07', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10622, '110304', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 10:29:49', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10623, '110309', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 10:47:42', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10629, '110312', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 11:47:42', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10625, '110314', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 11:57:54', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '105.00', '40.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10626, '110315', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 12:02:35', 'Paid', NULL, '125.00', '137.50', '137.50', NULL, '200.00', '62.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10627, '110307', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 10:45:49', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '17.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10628, '110308', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 10:46:22', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10630, '110311', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 11:29:27', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '55.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10631, '110313', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 11:55:48', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '57.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10632, '110319', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 12:24:10', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '73.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10633, '110316', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 12:07:30', 'Paid', NULL, '111.00', '122.10', '122.10', NULL, '150.10', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10634, '110318', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 12:13:15', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10635, '110317', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 12:09:46', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10636, '110321', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 12:52:32', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.10', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10637, '110320', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 12:43:11', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '51.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10638, '110332', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 14:13:42', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '67.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10639, '110337', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 14:23:26', 'Paid', NULL, '100.00', '110.00', '110.00', NULL, '110.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10619, '110302', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 10:10:52', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10620, '110305', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 10:33:28', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '52.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10621, '110306', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 10:44:32', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10640, '110327', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 13:29:19', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10641, '110324', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 13:12:04', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '73.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10642, '110322', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 12:58:20', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '100.00', '51.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10643, '110323', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 12:59:55', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '70.00', '8.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10644, '110326', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 13:16:04', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10616, '110300', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 09:50:40', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.40', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10618, '110310', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 11:19:04', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '58.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10617, '110301', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 10:01:11', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10615, '110303', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-02 10:13:35', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1498976735', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10684, '110363', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-03 13:06:56', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499056173', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10685, '110367', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-03 13:58:47', 'Paid', NULL, '48.00', '47.50', '47.50', NULL, '50.00', '2.50', '0.00', '0.00', '5.28', '-0.02', 'Cash', NULL, '27', '1499056173', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10688, '110368', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-03 14:09:24', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '40.20', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499056173', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10687, '110369', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-03 14:15:19', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '89.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499056173', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10686, '110366', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-03 13:50:03', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499056173', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10673, '110354', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-03 10:22:49', 'Paid', NULL, '166.00', '182.60', '182.60', NULL, '200.00', '17.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499056173', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10674, '110356', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-03 10:38:40', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499056173', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10675, '110357', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-03 10:54:25', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.10', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499056173', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10676, '110360', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-03 11:52:45', 'Paid', NULL, '104.00', '114.40', '114.40', NULL, '150.00', '35.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499056173', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10681, '110362', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-03 12:14:43', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499056173', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10678, '110361', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-03 12:06:03', 'Paid', NULL, '123.00', '135.30', '135.30', NULL, '150.50', '15.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499056173', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10679, '110358', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-03 11:09:55', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499056173', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10680, '110359', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-03 11:10:14', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499056173', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10682, '110364', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-03 13:11:53', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '55.00', '23.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499056173', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10683, '110365', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-03 13:15:38', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '100.00', '42.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499056173', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10671, '110355', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-03 10:25:38', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '100.00', '6.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499056173', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10672, '110353', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-03 10:21:48', 'Paid', NULL, '123.00', '135.30', '135.30', NULL, '150.00', '14.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499056173', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10670, '110352', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-03 10:12:41', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499056173', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10702, '110383', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-05 14:01:10', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '55.20', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499228549', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10703, '110380', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-05 13:05:11', 'Paid', NULL, '28.00', '25.20', '25.20', NULL, '50.00', '24.80', '0.00', '0.00', '2.80', '0.00', 'Cash', NULL, '27', '1499228549', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10707, '110387', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-05 16:10:20', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499228549', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10705, '110382', 'T14(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-05 14:00:37', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '36.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499228549', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10706, '110389', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-05 17:45:40', 'Paid', NULL, '26.00', '25.75', '25.75', NULL, '50.00', '24.25', '0.00', '0.00', '2.86', '0.01', 'Cash', NULL, '27', '1499228549', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10708, '110386', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-05 15:34:42', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.30', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499228549', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10709, '110388', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-05 16:45:02', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499228549', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10690, '110372', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-05 11:17:10', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499228549', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10691, '110371', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-05 11:13:04', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.10', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499228549', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10692, '110377', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-05 12:09:13', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '72.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499228549', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10693, '110374', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-05 11:36:57', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.10', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499228549', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10694, '110378', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-05 12:22:54', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '40.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499228549', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10695, '110373', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-05 11:21:00', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499228549', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10696, '110375', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-05 11:37:33', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499228549', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10697, '110376', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-05 11:51:50', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499228549', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10698, '110379', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-05 12:47:31', 'Paid', NULL, '98.90', '108.80', '108.80', NULL, '110.00', '1.20', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1499228549', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10699, '110384', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-05 14:03:16', 'Paid', NULL, '48.00', '47.50', '47.50', NULL, '50.00', '2.50', '0.00', '0.00', '5.28', '-0.02', 'Cash', NULL, '27', '1499228549', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10700, '110381', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-05 13:22:08', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499228549', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10701, '110385', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-05 15:18:13', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499228549', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10689, '110370', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-05 10:28:21', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '41.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499228549', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10711, '110392', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 10:35:46', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10712, '110391', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 10:33:08', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '100.00', '68.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10713, '110393', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 10:45:57', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '57.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10714, '110394', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 11:28:05', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10715, '110400', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 11:52:25', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.20', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10722, '110401', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 11:57:59', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10718, '110396', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 11:39:13', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10719, '110397', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 11:39:31', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10720, '110398', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 11:40:06', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '5.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10721, '110399', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 11:40:24', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.20', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10723, '110403', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 13:04:28', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10724, '110407', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 13:49:22', 'Paid', NULL, '61.00', '60.40', '60.40', NULL, '100.40', '40.00', '0.00', '0.00', '6.71', '0.01', 'Cash', NULL, '27', '1499321405', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10725, '110402', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 12:40:44', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10726, '110405', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 13:39:06', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.20', '16.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10727, '110404', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 13:36:23', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10728, '110406', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 13:39:41', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.30', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10729, '110408', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 14:16:45', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10730, '110409', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 14:30:19', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10731, '110410', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 14:37:02', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10732, '110412', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 15:26:31', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '51.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10733, '110411', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 15:21:52', 'Paid', NULL, '47.00', '46.55', '46.55', NULL, '100.00', '53.45', '0.00', '0.00', '5.17', '0.02', 'Cash', NULL, '27', '1499321405', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10734, '110415', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 17:14:24', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '53.20', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10735, '110413', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 16:33:54', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '49.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10736, '110414', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 16:56:55', 'Paid', NULL, '10.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1499321405', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10737, '110417', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 17:53:20', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10738, '110418', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 17:54:05', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10739, '110416', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 17:49:24', 'Paid', NULL, '12.00', '10.80', '10.80', NULL, '10.80', '0.00', '0.00', '0.00', '1.20', '0.00', 'Cash', NULL, '27', '1499321405', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10716, '110395', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 11:38:51', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10710, '110390', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-06 10:31:23', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '101.00', '60.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499321405', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10786, '110463', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 15:09:30', 'Paid', NULL, '23.00', '20.70', '20.70', NULL, '50.00', '29.30', '0.00', '0.00', '2.30', '0.00', 'Cash', NULL, '27', '1499407772', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10787, '110466', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 16:09:27', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10794, '110472', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 17:38:38', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.40', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10789, '110471', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 16:49:19', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10784, '110462', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 15:05:15', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10785, '110465', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 15:46:21', 'Paid', NULL, '33.00', '32.65', '32.65', NULL, '50.00', '17.35', '0.00', '0.00', '3.63', '-0.02', 'Cash', NULL, '27', '1499407772', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10790, '110470', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 16:20:45', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10791, '110467', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 16:10:24', 'Paid', NULL, '12.00', '11.90', '11.90', NULL, '11.90', '0.00', '0.00', '0.00', '1.32', '0.02', 'Cash', NULL, '27', '1499407772', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10792, '110468', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 16:11:10', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '45.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10793, '110469', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 16:11:51', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '71.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10783, '110457', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 14:36:16', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.00', '41.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10782, '110464', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 15:19:41', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10781, '110452', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 14:10:05', 'Paid', NULL, '28.00', '27.70', '27.70', NULL, '27.70', '0.00', '0.00', '0.00', '3.08', '-0.02', 'Cash', NULL, '27', '1499407772', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10780, '110460', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 14:52:05', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10741, '110420', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 10:16:02', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10742, '110423', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 10:37:38', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10743, '110424', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 10:42:36', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '62.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10745, '110422', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 10:37:10', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '70.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10746, '110426', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 11:02:05', 'Paid', NULL, '89.00', '88.10', '88.10', NULL, '100.10', '12.00', '0.00', '0.00', '9.79', '-0.01', 'Cash', NULL, '27', '1499407772', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10763, '110461', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 14:56:34', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '101.60', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10764, '110448', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 13:42:52', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10765, '110443', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 13:27:36', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.30', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10766, '110439', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 12:57:53', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10767, '110440', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 12:58:09', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '50.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10768, '110441', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 12:58:59', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(10769, '110451', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 14:06:58', 'Paid', NULL, '28.00', '27.70', '27.70', NULL, '100.00', '72.30', '0.00', '0.00', '3.08', '-0.02', 'Cash', NULL, '27', '1499407772', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10770, '110447', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 13:38:27', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '15.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10771, '110456', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 14:30:21', 'Paid', NULL, '140.00', '154.00', '154.00', NULL, '200.00', '46.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10772, '110449', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 13:47:59', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10773, '110453', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 14:10:34', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10774, '110444', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 13:28:12', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10775, '110445', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 13:28:23', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10776, '110450', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 13:52:32', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10777, '110458', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 14:36:36', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10778, '110455', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 14:25:41', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '14.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10779, '110454', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 14:25:21', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10747, '110425', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 11:00:13', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '61.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10748, '110429', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 11:36:56', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10749, '110427', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 11:07:06', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '59.50', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10750, '110428', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 11:08:49', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.70', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10751, '110430', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 11:44:36', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10752, '110432', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 12:05:39', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10753, '110438', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 12:32:43', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10754, '110431', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 11:46:17', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '14.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10755, '110433', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 12:07:14', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10756, '110442', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 13:15:04', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10757, '110434', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 12:13:16', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '80.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10758, '110459', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 14:44:02', 'Paid', NULL, '123.00', '135.30', '135.30', NULL, '155.30', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10759, '110435', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 12:18:06', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '62.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10760, '110437', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 12:31:19', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '55.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10761, '110446', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 13:32:59', 'Paid', NULL, '92.00', '101.20', '101.20', NULL, '102.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10762, '110436', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 12:21:03', 'Paid', NULL, '29.00', '26.10', '26.10', NULL, '50.00', '23.90', '0.00', '0.00', '2.90', '0.00', 'Cash', NULL, '27', '1499407772', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10744, '110421', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 10:25:20', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '80.10', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10740, '110419', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-07 10:03:52', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '80.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499407772', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10856, '110530', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 17:24:12', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '6.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10857, '110531', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 17:29:33', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '40.00', '11.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10855, '110529', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 17:08:33', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10854, '110532', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 17:42:04', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10853, '110527', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 16:13:57', 'Paid', NULL, '21.00', '18.90', '18.90', NULL, '100.00', '81.10', '0.00', '0.00', '2.10', '0.00', 'Cash', NULL, '27', '1499495883', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10840, '110525', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 15:44:30', 'Paid', NULL, '129.00', '141.90', '141.90', NULL, '142.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10841, '110513', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 14:22:17', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10842, '110523', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 15:14:50', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10848, '110521', 'T2(S)(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 15:13:15', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10844, '110519', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 15:09:54', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10845, '110518', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 15:07:38', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10846, '110520', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 15:12:05', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '20.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10850, '110526', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 15:59:02', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10849, '110522', 'T2(S)(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 15:14:05', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10851, '110528', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 16:17:26', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10832, '110512', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 14:13:30', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10833, '110514', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 14:22:37', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10834, '110516', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 14:36:04', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '61.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10835, '110505', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 13:41:18', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10836, '110509', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 13:49:33', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10837, '110517', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 14:37:19', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10838, '110524', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 15:15:49', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.00', '7.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10839, '110515', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 14:33:33', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.20', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10796, '110477', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 10:04:19', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10797, '110474', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 09:53:13', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '100.00', '47.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10798, '110475', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 09:55:54', 'Paid', NULL, '154.00', '169.40', '169.40', NULL, '200.00', '30.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10800, '110478', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 10:06:29', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10801, '110479', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 10:30:43', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.00', '7.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10802, '110480', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 10:40:24', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10803, '110481', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 10:43:17', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10804, '110490', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 11:20:42', 'Paid', NULL, '99.00', '108.90', '108.90', NULL, '110.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10805, '110484', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 11:04:35', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '53.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10806, '110485', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 11:06:49', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '100.00', '8.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10807, '110486', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 11:14:24', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '53.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10808, '110488', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 11:17:48', 'Paid', NULL, '98.00', '107.80', '107.80', NULL, '110.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10809, '110483', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 11:00:53', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10810, '110492', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 11:25:02', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '100.00', '71.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10811, '110491', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 11:22:59', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10812, '110495', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 12:12:12', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '80.00', '6.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10813, '110482', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 10:56:30', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '40.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10814, '110493', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 11:51:14', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10815, '110487', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 11:15:26', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '100.00', '92.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10816, '110489', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 11:19:37', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10817, '110496', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 12:18:12', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.30', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10818, '110506', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 13:47:24', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10819, '110494', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 12:00:26', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '100.00', '60.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10820, '110498', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 12:47:16', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10821, '110497', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 12:46:02', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.00', '43.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10822, '110501', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 13:16:58', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.40', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10823, '110499', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 13:04:55', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10824, '110500', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 13:07:49', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.40', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10825, '110503', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 13:23:05', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.50', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10826, '110504', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 13:26:35', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '100.00', '8.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10827, '110507', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 13:47:54', 'Paid', NULL, '99.00', '108.90', '108.90', NULL, '110.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10828, '110508', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 13:48:49', 'Paid', NULL, '130.00', '143.00', '143.00', NULL, '150.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10829, '110502', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 13:19:32', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '20.00', '12.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10830, '110511', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 14:11:16', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10831, '110510', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 13:59:20', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '58.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10799, '110476', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 10:02:59', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10795, '110473', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-08 09:31:53', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '30.10', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499495883', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10863, '110539', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 11:07:37', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10864, '110542', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 11:14:17', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10865, '110540', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 11:09:46', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.10', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10866, '110538', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 10:54:46', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.00', '7.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10867, '110541', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 11:13:37', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '54.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10875, '110550', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 12:00:50', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10869, '110547', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 11:37:21', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '92.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10870, '110548', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 11:41:13', 'Paid', NULL, '110.00', '121.00', '121.00', NULL, '121.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10871, '110545', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 11:28:54', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '40.00', '1.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10873, '110543', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 11:15:29', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10874, '110544', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 11:16:34', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10860, '110536', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 10:32:27', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10861, '110537', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 10:51:17', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '68.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10862, '110535', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 10:26:21', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10859, '110534', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 10:21:43', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10899, '110573', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 16:00:22', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '28.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10898, '110570', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 15:10:32', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10897, '110572', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 15:32:26', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '36.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10896, '110567', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 14:30:33', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10895, '110571', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 15:12:27', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10894, '110569', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 14:44:40', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '70.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10893, '110561', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 13:36:33', 'Paid', NULL, '13.00', '11.70', '11.70', NULL, '20.00', '8.30', '0.00', '0.00', '1.30', '0.00', 'Cash', NULL, '27', '1499579780', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10892, '110566', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 14:18:18', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10891, '110565', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 14:10:07', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '150.00', '32.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10890, '110568', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 14:33:29', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.30', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10889, '110560', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 13:26:47', 'Paid', NULL, '114.00', '125.40', '125.40', NULL, '125.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10888, '110559', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 13:26:07', 'Paid', NULL, '108.00', '118.80', '118.80', NULL, '120.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10887, '110563', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 13:55:12', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '58.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10886, '110558', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 13:02:54', 'Paid', NULL, '15.00', '14.85', '14.85', NULL, '20.00', '5.15', '0.00', '0.00', '1.65', '0.00', 'Cash', NULL, '27', '1499579780', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10885, '110562', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 13:48:58', 'Paid', NULL, '197.00', '216.70', '216.70', NULL, '220.00', '3.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10884, '110564', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 14:04:11', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10883, '110556', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 12:47:46', 'Paid', NULL, '198.00', '217.80', '217.80', NULL, '228.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10882, '110553', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 12:35:30', 'Paid', NULL, '108.00', '118.80', '118.80', NULL, '118.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10881, '110555', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 12:41:43', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '100.90', '69.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10880, '110552', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 12:26:11', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10879, '110554', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 12:41:04', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10878, '110557', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 12:53:25', 'Paid', NULL, '116.00', '127.60', '127.60', NULL, '150.00', '22.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10877, '110551', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 12:08:27', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10876, '110549', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 11:56:08', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10872, '110546', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 11:33:39', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10858, '110533', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-09 09:24:23', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499579780', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10944, '110615', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 17:06:51', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10943, '110617', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 17:26:56', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '15.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10941, '110612', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 15:16:58', 'Paid', NULL, '20.00', '18.00', '18.00', NULL, '50.00', '32.00', '0.00', '0.00', '2.00', '0.00', 'Cash', NULL, '27', '1499662074', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10937, '110611', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 15:01:38', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '24.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10942, '110616', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 17:10:34', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.20', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10939, '110613', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 15:28:28', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10940, '110614', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 15:53:56', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10901, '110574', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 09:42:12', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '53.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10902, '110576', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 10:12:06', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10904, '110584', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 10:59:32', 'Paid', NULL, '96.00', '105.60', '105.60', NULL, '110.00', '4.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10905, '110579', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 10:26:34', 'Paid', NULL, '96.00', '105.60', '105.60', NULL, '105.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10906, '110578', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 10:25:21', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10907, '110581', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 10:38:11', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10908, '110583', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 10:47:22', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '100.00', '53.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10909, '110580', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 10:37:42', 'Paid', NULL, '95.00', '104.50', '104.50', NULL, '110.50', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10910, '110582', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 10:39:53', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '100.00', '67.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(10911, '110586', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 11:08:34', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.10', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10912, '110585', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 11:00:19', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10913, '110587', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 11:15:35', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.20', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10914, '110588', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 11:24:37', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '73.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10915, '110593', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 12:19:11', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '70.00', '7.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10916, '110589', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 11:43:12', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10918, '110590', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 11:46:32', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10919, '110602', 't15', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 14:13:42', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10920, '110596', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 12:44:30', 'Paid', NULL, '16.00', '15.85', '15.85', NULL, '20.00', '4.15', '0.00', '0.00', '1.76', '0.01', 'Cash', NULL, '27', '1499662074', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10921, '110592', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 12:12:15', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10922, '110595', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 12:31:14', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10923, '110594', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 12:23:47', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10924, '110600', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 13:58:22', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '79.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10925, '110598', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 13:34:56', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '6.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10926, '110606', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 14:34:22', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '50.00', '31.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10927, '110601', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 13:59:17', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '35.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10928, '110610', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 14:43:01', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10929, '110599', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 13:48:50', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '70.00', '13.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10930, '110597', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 13:33:42', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '20.00', '11.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10931, '110605', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 14:31:57', 'Paid', NULL, '109.00', '119.90', '119.90', NULL, '120.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10932, '110608', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 14:38:12', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.00', '41.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10933, '110603', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 14:21:04', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10934, '110604', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 14:26:49', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10935, '110607', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 14:36:32', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '15.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10936, '110609', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 14:42:43', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '50.00', '35.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10917, '110591', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 11:56:59', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10903, '110577', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 10:23:14', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10900, '110575', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-10 10:02:07', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499662074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10949, '110622', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 10:09:16', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10948, '110621', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 10:08:23', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10977, '110645', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 17:07:52', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10976, '110649', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 17:30:19', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10975, '110644', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 17:04:40', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10974, '110648', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 17:29:16', 'Paid', NULL, '112.00', '123.20', '123.20', NULL, '150.00', '26.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10973, '110646', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 17:12:18', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '64.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10972, '110642', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 15:06:20', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '106.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10971, '110638', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 14:09:35', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10970, '110643', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 15:46:52', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '39.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10969, '110636', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 13:47:27', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '20.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10968, '110640', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 14:29:38', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '90.00', '8.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10967, '110637', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 13:58:08', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '30.00', '9.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10966, '110641', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 14:40:45', 'Paid', NULL, '53.00', '52.45', '52.45', NULL, '52.45', '0.00', '0.00', '0.00', '5.83', '-0.02', 'Cash', NULL, '27', '1499845049', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10965, '110634', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 13:09:24', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.00', '4.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10964, '110639', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 14:18:20', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10963, '110633', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 12:55:56', 'Paid', NULL, '13.00', '11.70', '11.70', NULL, '20.00', '8.30', '0.00', '0.00', '1.30', '0.00', 'Cash', NULL, '27', '1499845049', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10962, '110647', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 17:28:22', 'Paid', NULL, '111.00', '122.10', '122.10', NULL, '130.10', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10961, '110628', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 12:31:07', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '6.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10960, '110632', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 12:53:07', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10958, '110631', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 12:38:23', 'Paid', NULL, '98.00', '107.80', '107.80', NULL, '110.80', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10957, '110626', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 11:41:58', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10956, '110625', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 11:40:50', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '20.00', '13.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10959, '110630', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 12:36:46', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10954, '110629', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 12:32:44', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '21.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10953, '110635', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 13:09:56', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '45.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10952, '110627', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 11:44:04', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10951, '110624', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 11:00:28', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '100.00', '77.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10950, '110623', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 10:40:31', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10947, '110618', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 09:51:33', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10946, '110620', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 10:03:22', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10945, '110619', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-12 09:55:04', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499845049', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11011, '110679', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 15:28:41', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11012, '110681', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 15:54:55', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11013, '110682', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 15:55:32', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '40.00', '1.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11015, '110684', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 18:07:25', 'Paid', NULL, '84.00', '83.15', '83.15', NULL, '100.00', '16.85', '0.00', '0.00', '9.24', '-0.01', 'Cash', NULL, '27', '1499932464', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11010, '110678', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 15:28:18', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11014, '110683', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 16:33:52', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '51.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11009, '110677', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 15:27:56', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11007, '110680', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 15:31:41', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '71.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11002, '110669', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 14:20:51', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11006, '110674', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 14:34:38', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '28.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11005, '110671', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 14:24:33', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '21.50', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11000, '110675', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 14:35:03', 'Paid', NULL, '130.00', '128.70', '128.70', NULL, '150.00', '21.30', '0.00', '0.00', '14.30', '0.00', 'Cash', NULL, '27', '1499932464', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11001, '110666', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 13:48:20', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1499932464', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(10999, '110673', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 14:26:29', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10998, '110667', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 14:06:33', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '69.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10997, '110676', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 14:37:48', 'Paid', NULL, '118.00', '116.80', '116.80', NULL, '150.00', '33.20', '0.00', '0.00', '12.98', '-0.02', 'Cash', NULL, '27', '1499932464', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10996, '110664', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 13:42:59', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10995, '110668', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 14:08:16', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10994, '110663', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 13:41:54', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10993, '110665', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 13:47:25', 'Paid', NULL, '18.00', '17.80', '17.80', NULL, '20.00', '2.20', '0.00', '0.00', '1.98', '-0.02', 'Cash', NULL, '27', '1499932464', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11004, '110670', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 14:24:15', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '17.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(10991, '110661', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 12:57:42', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '15.20', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10987, '110658', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 11:42:22', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '55.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10988, '110659', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 12:04:24', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '6.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10989, '110662', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 13:04:15', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '74.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10990, '110672', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 14:25:30', 'Paid', NULL, '20.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', '2.20', '0.00', 'Cash', NULL, '27', '1499932464', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10986, '110657', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 11:18:20', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10983, '110653', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 10:59:54', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10984, '110655', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 11:16:31', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '45.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10985, '110660', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 12:35:07', 'Paid', NULL, '32.00', '31.70', '31.70', NULL, '50.00', '18.30', '0.00', '0.00', '3.52', '0.02', 'Cash', NULL, '27', '1499932464', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10981, '110654', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 11:09:00', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10982, '110656', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 11:16:48', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '50.00', '42.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10980, '110651', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 10:11:59', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10979, '110650', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 09:50:55', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(10978, '110652', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-13 10:19:52', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '50.00', '31.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1499932464', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11043, '110707', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 15:42:16', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '30.00', '4.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11041, '110709', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 16:16:39', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '100.00', '56.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11042, '110710', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 17:53:01', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11032, '110697', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 13:16:52', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.20', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11034, '110701', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 14:03:19', 'Paid', NULL, '18.00', '16.20', '16.20', NULL, '100.00', '83.80', '0.00', '0.00', '1.80', '0.00', 'Cash', NULL, '27', '1500014039', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11035, '110702', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 14:24:23', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11036, '110703', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 14:25:46', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11037, '110704', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 14:28:45', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11038, '110700', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 13:57:37', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '20.00', '13.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11039, '110708', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 15:43:33', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.50', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11033, '110705', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 14:40:40', 'Paid', NULL, '56.00', '55.45', '55.45', NULL, '55.45', '0.00', '0.00', '0.00', '6.16', '0.01', 'Cash', NULL, '27', '1500014039', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11031, '110699', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 13:48:16', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11030, '110706', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 15:22:51', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '100.10', '55.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11029, '110695', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 13:05:59', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.40', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11028, '110698', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 13:19:46', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '57.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11024, '110692', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 12:01:52', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '71.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11025, '110693', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 12:37:55', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '59.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11027, '110696', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 13:08:44', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '56.40', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11019, '110689', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 11:07:25', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11026, '110694', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 13:00:47', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11021, '110687', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 10:32:08', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1500014039', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11022, '110690', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 11:10:22', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11023, '110691', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 11:22:06', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11018, '110688', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 10:32:31', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11017, '110686', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 10:18:57', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11016, '110685', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-14 09:55:30', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500014039', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11075, '110739', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 15:22:02', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11077, '110740', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 15:30:18', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11078, '110745', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 16:43:45', 'Paid', NULL, '112.00', '123.20', '123.20', NULL, '150.00', '26.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11079, '110743', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 16:03:20', 'Paid', NULL, '20.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', '2.00', '0.00', 'Cash', NULL, '27', '1500107018', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11081, '110746', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 16:53:53', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11076, '110742', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 15:54:18', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '92.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11074, '110741', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 15:35:10', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11062, '110728', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 13:02:08', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11063, '110726', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 12:34:44', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '55.00', '30.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11064, '110727', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 12:58:45', 'Paid', NULL, '53.90', '59.30', '59.30', NULL, '60.00', '0.70', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11065, '110732', ' T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 13:37:50', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '80.00', '5.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11066, '110733', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 13:42:56', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '39.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11067, '110730', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 13:08:22', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11068, '110735', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 14:00:18', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11069, '110734', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 13:53:28', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.20', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11070, '110736', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 14:29:33', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11071, '110738', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 14:31:23', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11072, '110737', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 14:29:46', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11061, '110731', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 13:28:55', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11073, '110744', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 16:25:30', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11059, '110723', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 12:15:41', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11060, '110725', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 12:32:33', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11053, '110718', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 11:17:08', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11054, '110729', '10', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 13:03:23', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11055, '110724', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 12:21:36', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11056, '110722', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 11:47:04', 'Paid', NULL, '18.90', '20.80', '20.80', NULL, '21.00', '0.20', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(11047, '110712', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 09:49:22', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11048, '110717', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 11:07:15', 'Paid', NULL, '142.00', '156.20', '156.20', NULL, '200.20', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11049, '110714', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 10:51:04', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '24.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11057, '110721', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 11:31:41', 'Paid', NULL, '20.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', '2.20', '0.00', 'Cash', NULL, '27', '1500107018', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11052, '110719', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 11:20:09', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11051, '110720', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 11:21:08', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11050, '110716', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 10:57:13', 'Paid', NULL, '114.00', '125.40', '125.40', NULL, '150.00', '24.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11046, '110715', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 10:52:57', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11045, '110713', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 10:02:14', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11044, '110711', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-15 09:02:49', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '25.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500107018', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11140, '110799', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 17:21:42', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '6.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11141, '110802', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 17:40:30', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '100.00', '56.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11138, '110797', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 16:53:26', 'Paid', NULL, '10.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1500189795', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11127, '110791', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 14:45:18', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11128, '110789', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 14:37:22', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.10', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11129, '110792', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 14:50:04', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11130, '110785', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 14:25:05', 'Paid', NULL, '16.00', '15.85', '15.85', NULL, '50.00', '34.15', '0.00', '0.00', '1.76', '0.01', 'Cash', NULL, '27', '1500189795', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11132, '110800', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 17:23:27', 'Paid', NULL, '10.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1500189795', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11133, '110794', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 15:26:53', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11134, '110793', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 15:20:36', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11135, '110795', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 16:04:35', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11136, '110803', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 17:43:16', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11137, '110801', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 17:38:27', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.00', '7.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11131, '110796', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 16:09:09', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '99.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11126, '110790', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 14:40:15', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11124, '110788', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 14:36:02', 'Paid', NULL, '128.00', '126.70', '126.70', NULL, '126.70', '0.00', '0.00', '0.00', '14.08', '-0.02', 'Cash', NULL, '27', '1500189795', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11123, '110786', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 14:27:46', 'Paid', NULL, '70.00', '69.30', '69.30', NULL, '69.30', '0.00', '0.00', '0.00', '7.70', '0.00', 'Cash', NULL, '27', '1500189795', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11122, '110798', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 17:20:28', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11121, '110787', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 14:34:44', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.00', '4.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11113, '110769', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 12:20:55', 'Paid', NULL, '8.00', '7.90', '7.90', NULL, '10.00', '2.10', '0.00', '0.00', '0.88', '-0.02', 'Cash', NULL, '27', '1500189795', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11114, '110770', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 12:23:00', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11115, '110778', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 13:23:31', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '100.00', '49.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11116, '110781', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 13:42:34', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.10', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11117, '110777', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 13:23:12', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.20', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11118, '110780', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 13:35:34', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11119, '110779', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 13:28:41', 'Paid', NULL, '97.00', '106.70', '106.70', NULL, '110.00', '3.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11120, '110783', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 14:05:23', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '80.20', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11100, '110772', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 12:37:58', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11103, '110767', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 12:11:58', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '60.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11102, '110760', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 11:19:21', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11104, '110764', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 11:54:12', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '52.00', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11105, '110766', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 12:06:08', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11106, '110773', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 12:45:48', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.30', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11107, '110771', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 12:26:07', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11108, '110782', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 13:48:52', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.00', '4.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11109, '110775', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 13:09:04', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.80', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11110, '110768', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 12:20:23', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '7.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11111, '110774', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 12:54:35', 'Paid', NULL, '175.00', '192.50', '192.50', NULL, '200.00', '7.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11112, '110776', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 13:14:36', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '64.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11097, '110761', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 11:27:37', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11098, '110763', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 11:52:57', 'Paid', NULL, '95.00', '104.50', '104.50', NULL, '104.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11099, '110758', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 11:06:52', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11088, '110752', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 10:25:18', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.20', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11089, '110754', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 10:37:11', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '105.40', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11090, '110753', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 10:30:32', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11091, '110757', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 10:54:43', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '55.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11092, '110755', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 10:39:58', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '59.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11093, '110762', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 11:39:48', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '45.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11094, '110784', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 14:10:46', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11095, '110765', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 12:01:24', 'Paid', NULL, '35.00', '34.65', '34.65', NULL, '50.00', '15.35', '0.00', '0.00', '3.85', '0.00', 'Cash', NULL, '27', '1500189795', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11096, '110759', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 11:16:05', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '101.00', '20.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11087, '110756', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 10:44:15', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '45.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11085, '110751', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 10:06:41', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11086, '110747', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 09:29:28', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '100.00', '5.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11084, '110749', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 10:02:44', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '104.00', '30.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11083, '110750', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 10:03:42', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11082, '110748', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-16 09:51:30', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '38.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500189795', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11173, '110829', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 15:01:22', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11158, '110819', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 12:45:34', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11157, '110818', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 12:43:37', 'Paid', NULL, '95.00', '104.50', '104.50', NULL, '105.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11159, '110820', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 12:51:09', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '55.10', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11161, '110822', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 13:39:15', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11162, '110821', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 13:17:20', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11174, '110833', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 16:25:26', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '100.00', '73.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11164, '110826', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 14:35:36', 'Paid', NULL, '106.00', '116.60', '116.60', NULL, '120.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11165, '110830', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 15:29:28', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11166, '110828', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 14:53:48', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11167, '110823', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 13:57:35', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11168, '110827', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 14:51:22', 'Paid', NULL, '100.00', '110.00', '110.00', NULL, '110.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11169, '110832', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 15:50:48', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11170, '110824', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 14:05:32', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11171, '110831', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 15:36:41', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11172, '110825', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 14:18:41', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '45.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11148, '110805', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 11:02:33', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11149, '110814', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 12:06:03', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11150, '110811', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 11:43:10', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '26.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11151, '110813', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 11:50:50', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '50.00', '42.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11152, '110810', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 11:33:39', 'Paid', NULL, '17.00', '17.00', '17.00', NULL, '17.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11153, '110817', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 12:43:11', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11154, '110815', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 12:06:44', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '14.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11155, '110816', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 12:32:39', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '13.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11145, '110809', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 11:30:04', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '70.00', '10.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11147, '110806', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 11:02:52', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '16.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11146, '110804', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 11:01:47', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '24.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11144, '110808', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 11:27:33', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11143, '110812', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 11:45:49', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11142, '110807', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-17 11:10:47', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500270044', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11193, '110847', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 13:34:53', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11194, '110848', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 13:43:21', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11195, '110854', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 14:29:12', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '64.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11196, '110853', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 14:27:45', 'Paid', NULL, '7.00', '6.30', '6.30', NULL, '10.30', '4.00', '0.00', '0.00', '0.70', '0.00', 'Cash', NULL, '27', '1500456537', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11197, '110856', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 14:37:50', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '50.00', '29.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11198, '110855', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 14:30:21', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11199, '110857', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 15:12:32', 'Paid', NULL, '24.90', '27.40', '27.40', NULL, '40.00', '12.60', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11191, '110846', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 13:26:35', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11206, '110863', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 17:28:01', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11205, '110864', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 17:30:29', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11204, '110858', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 16:07:03', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.60', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11203, '110861', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 16:35:37', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11202, '110862', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 17:14:04', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '102.00', '70.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11201, '110859', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 16:11:49', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11200, '110860', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 16:14:22', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11192, '110844', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 13:13:54', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1500456537', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11180, '110837', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 11:02:54', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11181, '110838', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 11:03:11', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11183, '110840', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 11:53:53', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11184, '110839', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 11:50:57', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11185, '110841', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 12:29:00', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '67.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11186, '110851', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 14:16:12', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11187, '110843', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 13:06:30', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11188, '110842', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 13:00:39', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '105.00', '51.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11189, '110852', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 14:16:52', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11190, '110850', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 13:55:15', 'Paid', NULL, '106.00', '104.95', '104.95', NULL, '105.00', '0.05', '0.00', '0.00', '11.66', '0.01', 'Cash', NULL, '27', '1500456537', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11178, '110835', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 10:52:37', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '5.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11179, '110845', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 13:24:48', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '50.00', '40.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11182, '110849', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 13:45:53', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11176, '110836', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 10:54:42', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.00', '21.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11175, '110834', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-19 10:31:05', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500456537', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11222, '110878', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 13:32:16', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '52.00', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11223, '110882', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 14:02:53', 'Paid', NULL, '93.00', '92.05', '92.05', NULL, '102.05', '10.00', '0.00', '0.00', '10.23', '-0.02', 'Cash', NULL, '27', '1500527734', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11224, '110880', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 13:48:29', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11225, '110881', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 13:48:47', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '100.00', '73.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11226, '110885', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 14:29:00', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11227, '110884', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 14:26:17', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11228, '110886', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 14:33:32', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11229, '110888', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 15:29:50', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.20', '27.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11230, '110890', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 16:13:43', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11231, '110887', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 15:20:22', 'Paid', NULL, '10.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1500527734', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11232, '110889', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 16:11:50', 'Paid', NULL, '10.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1500527734', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11233, '110891', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 16:59:20', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11219, '110875', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 13:11:33', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '75.00', '13.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11220, '110877', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 13:31:43', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11221, '110874', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 13:08:45', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11209, '110868', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 10:49:08', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '17.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11210, '110866', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 10:25:16', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '57.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11211, '110870', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 10:56:39', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11212, '110871', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 11:11:32', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(11213, '110867', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 10:44:54', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11214, '110872', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 11:38:18', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11215, '110883', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 14:04:36', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11216, '110876', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 13:17:52', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11217, '110873', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 12:19:14', 'Paid', NULL, '45.00', '44.55', '44.55', NULL, '50.00', '5.45', '0.00', '0.00', '4.95', '0.00', 'Cash', NULL, '27', '1500527734', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11218, '110879', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 13:44:02', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11208, '110869', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 10:55:13', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '27.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11207, '110865', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-20 09:46:13', 'Paid', NULL, '115.00', '126.50', '126.50', NULL, '150.00', '23.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500527734', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11249, '110907', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 13:05:16', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11250, '110910', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 13:21:09', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.10', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11251, '110912', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 13:28:33', 'Paid', NULL, '244.00', '268.40', '268.40', NULL, '300.40', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11252, '110911', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 13:26:58', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11253, '110913', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 13:31:45', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11254, '110906', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 12:51:41', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11255, '110916', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 13:52:21', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11256, '110908', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 13:10:27', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '20.00', '10.10', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1500611801', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11257, '110915', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 13:42:45', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.20', '38.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11258, '110919', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 13:58:58', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11259, '110914', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 13:36:00', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '35.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11260, '110917', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 13:53:08', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '25.00', '10.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11261, '110918', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 13:54:10', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11262, '110920', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 14:36:25', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '100.00', '56.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11263, '110921', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 15:23:55', 'Paid', NULL, '16.00', '14.40', '14.40', NULL, '20.00', '5.60', '0.00', '0.00', '1.60', '0.00', 'Cash', NULL, '27', '1500611801', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11236, '110894', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 10:44:15', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '63.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11237, '110895', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 10:57:00', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '100.00', '5.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11238, '110909', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 13:20:12', 'Paid', NULL, '30.00', '29.70', '29.70', NULL, '29.70', '0.00', '0.00', '0.00', '3.30', '0.00', 'Cash', NULL, '27', '1500611801', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11240, '110896', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 11:08:15', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11241, '110902', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 11:41:11', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11242, '110901', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 11:40:33', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '81.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11243, '110899', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 11:28:24', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11244, '110898', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 11:26:13', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '30.30', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11245, '110905', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 12:20:37', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '100.00', '6.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11246, '110904', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 11:59:04', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11247, '110900', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 11:38:18', 'Paid', NULL, '21.50', '21.50', '21.50', NULL, '50.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11248, '110903', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 11:47:15', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11239, '110897', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 11:25:10', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11235, '110893', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 10:08:16', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.50', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11234, '110892', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-21 10:03:31', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '100.00', '47.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500611801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11323, '110975', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 18:02:03', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '36.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11322, '110974', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 18:01:24', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '8.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11319, '110978', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 18:41:58', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '61.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11320, '110979', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 18:47:37', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11321, '110973', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 18:00:20', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11315, '110967', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 16:23:20', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11316, '110968', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 16:31:23', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11317, '110971', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 17:19:17', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11318, '110972', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 17:55:42', 'Paid', NULL, '21.00', '20.80', '20.80', NULL, '100.80', '80.00', '0.00', '0.00', '2.31', '0.01', 'Cash', NULL, '27', '1500709637', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11305, '110970', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 17:14:51', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11306, '110956', 'T11A(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 15:27:03', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11307, '110957', 'T11A(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 15:27:40', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11309, '110976', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 18:02:29', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '100.00', '68.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11310, '110977', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 18:06:12', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '100.00', '71.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11311, '110964', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 16:00:57', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11312, '110965', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 16:03:28', 'Paid', NULL, '23.00', '22.75', '22.75', NULL, '25.00', '2.25', '0.00', '0.00', '2.53', '-0.02', 'Cash', NULL, '27', '1500709637', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11313, '110969', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 16:57:01', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '15.00', '2.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11314, '110966', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 16:19:08', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11304, '110963', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 15:59:34', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '69.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11303, '110961', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 15:48:15', 'Paid', NULL, '118.00', '129.80', '129.80', NULL, '150.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11308, '110960', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 15:44:03', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11302, '110958', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 15:29:32', 'Paid', NULL, '92.00', '91.10', '91.10', NULL, '101.10', '10.00', '0.00', '0.00', '10.12', '0.02', 'Cash', NULL, '27', '1500709637', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11299, '110962', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 15:54:14', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11298, '110953', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 14:48:58', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '15.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11300, '110959', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 15:30:22', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11291, '110948', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 12:55:33', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11277, '110932', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 11:36:25', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11278, '110942', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 12:03:23', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.00', '20.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11279, '110936', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 11:45:53', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '49.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11280, '110939', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 11:53:33', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11281, '110938', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 11:51:49', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11282, '110937', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 11:47:46', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11283, '110944', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 12:27:32', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11284, '110933', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 11:37:13', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11285, '110934', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 11:37:53', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11286, '110943', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 12:10:09', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11287, '110947', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 12:44:56', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '81.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11288, '110946', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 12:29:37', 'Paid', NULL, '40.00', '39.60', '39.60', NULL, '100.00', '60.40', '0.00', '0.00', '4.40', '0.00', 'Cash', NULL, '27', '1500709637', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11289, '110940', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 12:01:56', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11290, '110941', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 12:02:16', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '10.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11292, '110945', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 12:27:49', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11293, '110955', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 15:18:04', 'Paid', NULL, '143.00', '157.30', '157.30', NULL, '200.00', '42.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11294, '110950', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 14:25:32', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.50', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11295, '110954', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 14:57:08', 'Paid', NULL, '98.00', '97.00', '97.00', NULL, '97.00', '0.00', '0.00', '0.00', '10.78', '-0.02', 'Cash', NULL, '27', '1500709637', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11296, '110952', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 14:41:08', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '69.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11297, '110951', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 14:40:20', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11266, '110922', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 09:41:38', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11267, '110925', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 10:51:20', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11268, '110928', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 11:09:17', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '79.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11269, '110926', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 10:52:41', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.10', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11270, '110924', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 10:49:38', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11271, '110927', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 10:54:14', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '100.00', '47.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11272, '110935', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 11:44:51', 'Paid', NULL, '56.00', '55.45', '55.45', NULL, '60.00', '4.55', '0.00', '0.00', '6.16', '0.01', 'Cash', NULL, '27', '1500709637', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11273, '110929', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 11:21:51', 'Paid', NULL, '77.00', '76.25', '76.25', NULL, '77.00', '0.75', '0.00', '0.00', '8.47', '0.02', 'Cash', NULL, '27', '1500709637', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11274, '110930', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 11:23:06', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '102.60', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11275, '110931', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 11:23:51', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.50', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11265, '110923', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 10:29:01', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.10', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11264, '110949', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-22 13:35:28', 'Paid', NULL, '146.00', '160.60', '160.60', NULL, '200.00', '39.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500709637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11374, '111023', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 16:25:46', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '38.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11375, '111030', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 17:38:43', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11376, '111027', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 17:01:18', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11377, '111028', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 17:19:46', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11378, '111032', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 17:40:57', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '15.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11379, '111033', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 17:44:38', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '25.00', '11.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11380, '111029', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 17:34:46', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11366, '111026', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 16:51:10', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11367, '111020', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 15:19:35', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11368, '111018', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 14:50:16', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '50.00', '39.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11369, '111021', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 15:43:42', 'Paid', NULL, '24.00', '21.60', '21.60', NULL, '21.60', '0.00', '0.00', '0.00', '2.40', '0.00', 'Cash', NULL, '27', '1500781238', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11370, '111022', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 15:51:40', 'Paid', NULL, '23.00', '20.70', '20.70', NULL, '20.70', '0.00', '0.00', '0.00', '2.30', '0.00', 'Cash', NULL, '27', '1500781238', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11372, '111025', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 16:40:10', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '53.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11373, '111031', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 17:39:29', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11365, '111019', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 14:56:42', 'Paid', NULL, '1384.00', '1522.40', '1522.40', NULL, '1525.00', '2.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11364, '111017', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 13:53:01', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11360, '111015', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 12:28:21', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11361, '111009', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 12:01:35', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11371, '111024', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 16:31:27', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11363, '111016', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 13:30:44', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11326, '110984', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 10:15:27', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '63.90', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11337, '110995', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 11:08:08', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.20', '3.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11328, '110985', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 10:17:38', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.20', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11329, '110987', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 10:26:19', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.60', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11330, '110989', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 10:34:50', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '65.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11331, '110986', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 10:23:45', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.10', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11332, '110988', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 10:26:57', 'Paid', NULL, '106.00', '116.60', '116.60', NULL, '150.00', '33.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11333, '110992', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 10:49:08', 'Paid', NULL, '104.00', '114.40', '114.40', NULL, '114.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11334, '110990', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 10:38:43', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11335, '110982', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 10:12:02', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11338, '110994', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 11:05:49', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '100.00', '6.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11339, '110993', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 10:59:03', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '103.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11346, '110999', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 11:17:25', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '40.00', '3.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11341, '110997', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 11:11:25', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11342, '111002', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 11:34:50', 'Paid', NULL, '48.90', '53.80', '53.80', NULL, '54.00', '0.20', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11344, '110991', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 10:46:29', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11345, '111006', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 11:54:50', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11347, '111008', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 11:58:56', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11348, '111003', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 11:43:27', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '100.00', '47.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11349, '111004', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 11:45:25', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '101.50', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11350, '111001', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 11:33:50', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11351, '111005', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 11:49:57', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11352, '110996', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 11:09:58', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '34.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11353, '111010', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 12:07:56', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '80.00', '8.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11354, '111007', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 11:56:41', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11355, '111014', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 12:24:37', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '49.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11356, '111012', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 12:15:03', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '73.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11357, '111013', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 12:17:12', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11358, '111000', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 11:27:47', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11359, '111011', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 12:14:04', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(11343, '110998', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 11:13:01', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.00', '41.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11336, '110983', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 10:12:35', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11325, '110981', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 10:05:14', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.10', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11324, '110980', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-23 10:02:47', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.00', '30.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500781238', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11409, '111061', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 16:40:58', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11405, '111060', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 16:18:33', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '70.00', '16.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11406, '111057', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 15:21:43', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11411, '111063', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 17:42:24', 'Paid', NULL, '72.00', '71.30', '71.30', NULL, '71.30', '0.00', '0.00', '0.00', '7.92', '0.02', 'Cash', NULL, '27', '1500875902', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11410, '111062', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 17:41:34', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '17.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11408, '111059', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 15:22:09', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '10.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11407, '111058', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 15:21:53', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '10.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11383, '111035', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 10:21:24', 'Paid', NULL, '12.00', '10.80', '10.80', NULL, '50.00', '39.20', '0.00', '0.00', '1.20', '0.00', 'Cash', NULL, '27', '1500875902', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11384, '111039', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 11:07:50', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '71.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11385, '111038', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 10:53:06', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '101.50', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11386, '111037', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 10:50:59', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11387, '111041', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 11:44:10', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11388, '111040', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 11:23:30', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '52.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11389, '111043', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 12:31:49', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11390, '111042', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 12:31:19', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '27.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11391, '111046', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 12:58:54', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11392, '111047', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 13:03:10', 'Paid', NULL, '51.00', '50.50', '50.50', NULL, '50.50', '0.00', '0.00', '0.00', '5.61', '0.01', 'Cash', NULL, '27', '1500875902', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11393, '111044', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 12:43:23', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11394, '111045', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 12:45:15', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '59.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11395, '111048', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 13:15:39', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11396, '111049', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 13:27:52', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '100.00', '47.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11397, '111050', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 13:33:48', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11398, '111051', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 13:49:00', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '100.00', '6.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11399, '111052', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 13:50:06', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '90.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11400, '111053', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 13:53:23', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '30.00', '6.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11401, '111055', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 13:59:25', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '74.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11402, '111056', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 14:53:29', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11403, '111054', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 13:55:08', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11382, '111036', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 10:44:36', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '40.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11381, '111034', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-24 10:04:25', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1500875902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11446, '111095', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 17:42:35', 'Paid', NULL, '9.00', '8.10', '8.10', NULL, '10.00', '1.90', '0.00', '0.00', '0.90', '0.00', 'Cash', NULL, '27', '1501053580', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11437, '111086', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 13:44:08', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11438, '111089', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 15:34:58', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11439, '111093', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 16:16:18', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '100.00', '67.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11440, '111097', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 18:13:19', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.20', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11441, '111088', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 15:30:16', 'Paid', NULL, '3.00', '3.30', '3.30', NULL, '10.00', '6.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11442, '111092', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 16:06:12', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11443, '111090', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 15:55:27', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '50.00', '33.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11444, '111091', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 15:56:13', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11445, '111098', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 18:15:26', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11447, '111096', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 18:04:43', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11436, '111094', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 17:13:59', 'Paid', NULL, '27.00', '24.30', '24.30', NULL, '25.00', '0.70', '0.00', '0.00', '2.70', '0.00', 'Cash', NULL, '27', '1501053580', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11434, '111082', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 13:26:59', 'Paid', NULL, '12.00', '10.80', '10.80', NULL, '20.00', '9.20', '0.00', '0.00', '1.20', '0.00', 'Cash', NULL, '27', '1501053580', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11433, '111085', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 13:40:34', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11432, '111084', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 13:37:27', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '53.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11431, '111083', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 13:28:44', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '101.00', '50.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11430, '111087', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 13:45:07', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11429, '111081', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 13:07:36', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11428, '111076', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 12:19:31', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '100.40', '74.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11427, '111075', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 12:19:03', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.20', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11426, '111074', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 12:18:27', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '51.00', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11425, '111077', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 12:20:01', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11424, '111080', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 12:57:29', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11423, '111079', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 12:25:23', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '65.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11422, '111078', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 12:20:23', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11421, '111073', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 12:15:17', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11420, '111072', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 11:44:10', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '72.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11419, '111071', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 11:36:19', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11418, '111069', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 11:24:44', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11417, '111070', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 11:28:08', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '100.20', '54.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11416, '111068', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 11:20:47', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '53.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11414, '111067', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 10:38:14', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '52.00', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11415, '111066', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 10:20:20', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11413, '111065', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 10:13:56', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11412, '111064', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-26 09:50:17', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501053580', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11473, '111124', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 16:32:32', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '15.20', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11474, '111122', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 15:44:01', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '51.00', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11475, '111123', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 15:55:25', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '25.00', '1.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11476, '111128', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 17:35:21', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11477, '111126', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 17:02:39', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '50.00', '41.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11478, '111127', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 17:25:51', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11469, '111119', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 14:36:39', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11471, '111125', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 16:51:02', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11472, '111121', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 15:31:30', 'Paid', NULL, '93.00', '102.30', '102.30', NULL, '200.00', '97.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11470, '111118', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 14:32:19', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.30', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11468, '111117', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 14:16:55', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.10', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11466, '111120', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 14:51:03', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '40.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11467, '111114', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 13:56:46', 'Paid', NULL, '27.00', '26.75', '26.75', NULL, '50.00', '23.25', '0.00', '0.00', '2.97', '0.02', 'Cash', NULL, '27', '1501147751', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11465, '111116', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 14:10:32', 'Paid', NULL, '69.00', '68.30', '68.30', NULL, '100.00', '31.70', '0.00', '0.00', '7.59', '-0.01', 'Cash', NULL, '27', '1501147751', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11464, '111112', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 13:39:27', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.80', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11463, '111115', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 14:01:31', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11462, '111113', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 13:45:10', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11461, '111109', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 12:38:39', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '50.00', '39.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11460, '111111', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 13:16:08', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11459, '111108', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 12:26:47', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.10', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11454, '111103', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 11:30:07', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '5.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11453, '111105', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 12:05:36', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11455, '111104', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 11:30:29', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11456, '111110', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 12:49:09', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.40', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11457, '111106', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 12:24:10', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11458, '111107', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 12:25:59', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11450, '111100', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 11:16:47', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '35.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11451, '111101', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 11:18:57', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '50.00', '35.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11449, '111102', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 11:22:28', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11448, '111099', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-27 09:52:53', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501147751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11502, '111152', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 14:37:38', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '79.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11503, '111151', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 14:12:03', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11504, '111154', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 16:06:50', 'Paid', NULL, '18.00', '17.80', '17.80', NULL, '20.00', '2.20', '0.00', '0.00', '1.98', '-0.02', 'Cash', NULL, '27', '1501220813', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11505, '111153', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 15:41:18', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.60', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11506, '111155', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 17:25:35', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11507, '111156', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 17:49:14', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11508, '111157', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 17:50:21', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '65.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11501, '111148', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 13:45:16', 'Paid', NULL, '16.00', '14.40', '14.40', NULL, '14.40', '0.00', '0.00', '0.00', '1.60', '0.00', 'Cash', NULL, '27', '1501220813', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11495, '111149', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 13:59:58', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11498, '111143', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 13:11:36', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '27.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11499, '111144', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 13:12:59', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.70', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11496, '111141', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 13:08:13', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11497, '111142', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 13:10:19', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.70', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11494, '111146', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 13:26:34', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11493, '111139', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 12:33:32', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '25.20', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11492, '111147', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 13:27:25', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11500, '111150', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 14:09:06', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11491, '111140', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 12:55:40', 'Paid', NULL, '37.00', '36.65', '36.65', NULL, '50.00', '13.35', '0.00', '0.00', '4.07', '0.02', 'Cash', NULL, '27', '1501220813', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11484, '111134', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 11:37:02', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.90', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11485, '111138', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 12:15:20', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11486, '111136', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 11:43:48', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '30.00', '6.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11487, '111133', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 11:19:06', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11488, '111137', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 11:57:00', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '20.00', '11.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11489, '111145', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 13:17:44', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11483, '111135', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 11:41:17', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.00', '29.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11481, '111131', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 10:46:52', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.30', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11482, '111132', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 10:59:55', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '40.00', '9.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11480, '111129', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 09:54:26', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '31.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11479, '111130', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-28 10:02:04', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '120.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501220813', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11546, '111195', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 17:09:32', 'Paid', NULL, '15.90', '17.50', '17.50', NULL, '50.00', '32.50', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11545, '111193', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 16:25:10', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '100.00', '88.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11544, '111194', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 16:57:52', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '52.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11543, '111192', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 16:03:21', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '60.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11542, '111191', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 15:26:30', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11541, '111190', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 15:09:56', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '50.00', '31.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11540, '111189', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 14:40:41', 'Paid', NULL, '135.00', '148.50', '148.50', NULL, '150.00', '1.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11532, '111174', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 12:39:39', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '15.00', '2.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11533, '111180', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 13:28:44', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11534, '111182', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 13:31:31', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.20', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11535, '111183', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 13:46:47', 'Paid', NULL, '163.00', '179.30', '179.30', NULL, '180.30', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11536, '111188', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 14:29:47', 'Paid', NULL, '105.00', '115.50', '115.50', NULL, '150.00', '34.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11537, '111187', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 14:25:51', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11538, '111186', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 14:14:58', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11539, '111185', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 14:04:45', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11531, '111179', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 13:04:42', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11530, '111173', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 12:36:33', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '50.00', '42.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11528, '111171', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 12:16:26', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '61.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11529, '111181', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 13:29:09', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(11525, '111170', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 12:07:27', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11526, '111176', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 12:49:23', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11527, '111177', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 12:50:29', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11521, '111166', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 11:24:29', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '35.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11522, '111175', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 12:46:58', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.30', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11523, '111168', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 11:52:04', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11524, '111172', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 12:18:45', 'Paid', NULL, '76.50', '84.15', '84.15', NULL, '100.00', '15.85', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11516, '111163', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 11:16:22', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11515, '111169', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 12:03:39', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11511, '111159', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 10:23:39', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11520, '111167', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 11:26:54', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11519, '111178', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 12:51:18', 'Paid', NULL, '108.00', '118.80', '118.80', NULL, '150.00', '31.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11518, '111165', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 11:19:13', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '101.00', '50.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11517, '111184', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 13:51:50', 'Paid', NULL, '33.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', '3.30', '0.00', 'Cash', NULL, '27', '1501307487', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11512, '111161', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 10:50:32', 'Paid', NULL, '98.00', '107.80', '107.80', NULL, '110.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11514, '111162', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 11:07:09', 'Paid', NULL, '108.00', '118.80', '118.80', NULL, '120.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11513, '111164', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 11:18:37', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.10', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11510, '111160', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 10:39:14', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '48.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11509, '111158', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-29 10:00:06', 'Paid', NULL, '104.00', '114.40', '114.40', NULL, '114.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501307487', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11610, '111258', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 17:18:23', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11609, '111257', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 17:12:41', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11608, '111254', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 16:53:34', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '14.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11604, '111255', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 16:56:01', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11605, '111259', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 17:23:48', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11606, '111252', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 16:36:28', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11607, '111253', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 16:41:12', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11601, '111246', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 15:16:47', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11602, '111256', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 17:01:17', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1501396592', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11603, '111250', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 15:57:52', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '100.00', '70.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11600, '111251', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 16:33:02', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '40.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11599, '111247', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 15:19:01', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11598, '111244', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 15:13:11', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11597, '111249', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 15:40:16', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11596, '111242', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 14:38:28', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11595, '111239', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 14:11:14', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.30', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11594, '111248', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 15:22:02', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '100.00', '51.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11591, '111237', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 13:46:20', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '101.60', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11592, '111240', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 14:13:20', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11593, '111238', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 14:07:56', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '80.00', '7.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11590, '111241', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 14:29:17', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.00', '10.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11585, '111235', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 13:21:45', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.70', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11586, '111234', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 13:20:21', 'Paid', NULL, '122.00', '134.20', '134.20', NULL, '150.00', '15.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11587, '111243', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 14:42:57', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '47.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11588, '111236', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 13:40:53', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11589, '111231', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 13:06:46', 'Paid', NULL, '2.00', '2.00', '2.00', NULL, '2.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11584, '111233', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 13:12:58', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11583, '111230', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 13:03:21', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11582, '111245', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 15:15:02', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11565, '111222', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 12:11:26', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.00', '4.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11566, '111216', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 11:38:11', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '51.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11567, '111211', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 11:15:57', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11579, '111227', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 12:42:18', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11580, '111229', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 12:54:12', 'Paid', NULL, '159.00', '157.40', '157.40', NULL, '200.00', '42.60', '0.00', '0.00', '17.49', '-0.01', 'Cash', NULL, '27', '1501396592', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11581, '111232', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 13:07:21', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '70.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11568, '111217', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 11:41:50', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11569, '111218', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 11:52:32', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '100.50', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11570, '111219', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 11:53:07', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11571, '111220', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 12:00:58', 'Paid', NULL, '45.90', '50.50', '50.50', NULL, '51.00', '0.50', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11572, '111223', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 12:13:23', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11573, '111215', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 11:36:05', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11574, '111226', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 12:41:42', 'Paid', NULL, '195.00', '214.50', '214.50', NULL, '220.00', '5.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11575, '111221', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 12:03:40', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '35.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11576, '111225', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 12:29:20', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '100.00', '54.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11577, '111224', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 12:20:20', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11578, '111228', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 12:48:27', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11549, '111197', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 10:39:43', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11550, '111199', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 10:43:38', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '99.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11553, '111204', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 10:55:33', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.00', '10.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11554, '111203', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 10:50:22', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '90.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11555, '111205', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 10:58:26', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11556, '111210', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 11:11:43', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11557, '111206', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 11:02:37', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11558, '111209', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 11:10:40', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '40.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11559, '111212', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 11:19:50', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11560, '111207', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 11:05:54', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.30', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11561, '111202', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 10:47:19', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11562, '111213', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 11:22:27', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11563, '111214', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 11:31:09', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.40', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11564, '111208', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 11:08:45', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.50', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11551, '111200', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 10:44:28', 'Paid', NULL, '95.00', '104.50', '104.50', NULL, '104.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11552, '111201', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 10:46:35', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11548, '111196', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 10:03:48', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11547, '111198', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-07-30 10:42:11', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '70.00', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501396592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11624, '111272', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 13:37:01', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11625, '111279', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 15:14:22', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '51.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11626, '111275', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 14:59:59', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '100.00', '6.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11627, '111274', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 14:58:05', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '100.00', '63.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11628, '111277', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 15:09:18', 'Paid', NULL, '110.00', '121.00', '121.00', NULL, '150.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11629, '111278', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 15:10:13', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11630, '111273', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 14:45:36', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.20', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11631, '111280', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 15:18:06', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11632, '111276', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 15:01:21', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11633, '111281', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 15:47:10', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11634, '111283', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 16:18:33', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '57.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11635, '111285', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 17:07:06', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11636, '111284', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 17:06:46', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11637, '111286', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 17:22:45', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11638, '111287', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 17:23:37', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11614, '111262', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 11:06:02', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '72.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11615, '111265', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 11:33:25', 'Paid', NULL, '188.00', '206.80', '206.80', NULL, '250.00', '43.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11616, '111261', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 10:23:42', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '10.00', '4.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11617, '111264', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 11:26:42', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11618, '111267', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 12:06:24', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11619, '111270', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 13:08:03', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11620, '111268', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 12:38:14', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11621, '111269', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 13:06:02', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11622, '111271', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 13:34:27', 'Paid', NULL, '98.00', '107.80', '107.80', NULL, '108.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11613, '111266', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 11:52:52', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '26.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11623, '111282', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 15:53:13', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11612, '111263', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 11:07:05', 'Paid', NULL, '7.00', '6.95', '6.95', NULL, '10.00', '3.05', '0.00', '0.00', '0.77', '0.02', 'Cash', NULL, '27', '1501492896', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11611, '111260', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-07-31 09:46:16', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.00', '15.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501492896', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11669, '111318', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 18:22:34', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11668, '111314', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 16:45:51', 'Paid', NULL, '57.00', '57.00', '57.00', NULL, '60.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11667, '111316', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 16:55:35', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '15.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11666, '111313', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 16:28:47', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '16.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11665, '111311', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 15:59:01', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11664, '111312', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 16:20:16', 'Paid', NULL, '117.00', '128.70', '128.70', NULL, '130.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11663, '111310', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 15:32:09', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '100.00', '59.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11662, '111315', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 16:50:33', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '104.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11661, '111317', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 16:58:20', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '14.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11660, '111308', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 14:37:35', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.60', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11659, '111307', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 14:18:48', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.10', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11658, '111306', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 14:09:45', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '34.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11654, '111302', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 13:38:29', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11655, '111309', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 14:59:50', 'Paid', NULL, '40.00', '40.00', '40.00', NULL, '50.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11656, '111303', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 13:49:08', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '57.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11657, '111304', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 13:55:10', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11653, '111299', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 12:53:44', 'Paid', NULL, '9.00', '8.10', '8.10', NULL, '8.10', '0.00', '0.00', '0.00', '0.90', '0.00', 'Cash', NULL, '27', '1501656207', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11652, '111300', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 13:01:18', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11651, '111301', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 13:36:40', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '200.00', '82.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11650, '111298', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 12:43:36', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.40', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11649, '111305', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 13:56:47', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.00', '19.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11648, '111297', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 12:29:42', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11647, '111296', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 11:40:38', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '100.00', '63.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11643, '111295', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 11:18:48', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11644, '111293', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 11:08:52', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11645, '111292', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 11:02:59', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11646, '111294', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 11:10:32', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11641, '111289', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 09:48:11', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11642, '111290', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 09:48:18', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11640, '111291', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 09:52:31', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '29.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11639, '111288', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-02 09:47:22', 'Paid', NULL, '112.00', '123.20', '123.20', NULL, '124.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501656207', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11682, '111331', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-03 15:03:32', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501739307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11683, '111332', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-03 17:20:42', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501739307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11684, '111333', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-03 17:58:10', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '101.00', '70.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501739307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11686, '111334', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-03 18:00:02', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501739307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11681, '111328', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-03 14:03:41', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '30.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501739307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(11680, '111325', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-03 12:57:49', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501739307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11679, '111326', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-03 13:13:00', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501739307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11678, '111327', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-03 13:48:52', 'Paid', NULL, '47.50', '47.00', '47.00', NULL, '47.00', '0.00', '0.00', '0.00', '5.23', '-0.02', 'Cash', NULL, '27', '1501739307', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11672, '111323', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-03 11:44:29', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '59.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501739307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11673, '111322', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-03 11:42:54', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '100.00', '67.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501739307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11674, '111321', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-03 11:36:22', 'Paid', NULL, '68.00', '67.30', '67.30', NULL, '100.00', '32.70', '0.00', '0.00', '7.48', '-0.02', 'Cash', NULL, '27', '1501739307', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11675, '111324', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-03 11:56:18', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501739307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11677, '111329', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-03 14:21:50', 'Paid', NULL, '64.00', '63.35', '63.35', NULL, '100.35', '37.00', '0.00', '0.00', '7.04', '-0.01', 'Cash', NULL, '27', '1501739307', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11676, '111330', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-03 14:47:42', 'Paid', NULL, '25.00', '24.75', '24.75', NULL, '24.75', '0.00', '0.00', '0.00', '2.75', '0.00', 'Cash', NULL, '27', '1501739307', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11671, '111320', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-03 10:24:45', 'Paid', NULL, '53.00', '52.45', '52.45', NULL, '100.00', '47.55', '0.00', '0.00', '5.83', '-0.02', 'Cash', NULL, '27', '1501739307', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11670, '111319', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-03 10:06:15', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '50.00', '31.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501739307', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11709, '111356', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-04 18:04:16', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501820063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11708, '111355', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-04 18:00:00', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501820063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11689, '111336', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-04 10:50:13', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '100.00', '50.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501820063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11690, '111338', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-04 11:07:35', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501820063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11691, '111339', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-04 11:33:48', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '80.00', '6.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501820063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11692, '111341', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-04 11:51:42', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501820063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11693, '111340', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-04 11:48:36', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '106.10', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501820063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11694, '111342', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-04 12:42:51', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '103.00', '30.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501820063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11695, '111346', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-04 14:38:41', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501820063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11696, '111343', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-04 14:08:26', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501820063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11697, '111345', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-04 14:35:21', 'Paid', NULL, '25.00', '24.75', '24.75', NULL, '50.00', '25.25', '0.00', '0.00', '2.75', '0.00', 'Cash', NULL, '27', '1501820063', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11698, '111347', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-04 14:46:09', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501820063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11699, '111350', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-04 15:22:38', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '53.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501820063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11700, '111344', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-04 14:19:32', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '30.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501820063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11701, '111352', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-08-04 15:30:33', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '23.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501820063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11702, '111349', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-04 14:49:05', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501820063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11707, '111354', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-04 17:24:45', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501820063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11704, '111348', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-04 14:47:54', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501820063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11705, '111351', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-08-04 15:25:37', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501820063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11706, '111353', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-04 15:37:54', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501820063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11688, '111337', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-04 10:59:22', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.30', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501820063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11687, '111335', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-04 09:44:21', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '50.00', '35.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501820063', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11762, '111402', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 16:57:23', 'Paid', NULL, '22.00', '21.80', '21.80', NULL, '52.00', '30.20', '0.00', '0.00', '2.42', '0.02', 'Cash', NULL, '27', '1501923116', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11764, '111404', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 17:12:16', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11763, '111406', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 17:36:44', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '100.00', '63.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11759, '111401', 'IS', NULL, NULL, NULL, NULL, 'history', '2017-08-05 16:52:30', 'Paid', NULL, '26.00', '23.40', '23.40', NULL, '50.00', '26.60', '0.00', '0.00', '2.60', '0.00', 'Cash', NULL, '27', '1501923116', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11765, '111407', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 17:56:04', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.10', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11756, '111400', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 16:38:47', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11750, '111397', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 16:08:46', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '52.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11751, '111399', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 16:33:28', 'Paid', NULL, '52.00', '51.50', '51.50', NULL, '52.00', '0.50', '0.00', '0.00', '5.72', '0.02', 'Cash', NULL, '27', '1501923116', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11752, '111406', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 17:37:24', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '55.00', '7.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11753, '111403', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 16:57:48', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11754, '111398', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 16:32:31', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11744, '111386', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 14:16:22', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11745, '111395', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 15:38:02', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.20', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11746, '111394', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 15:34:43', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '105.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11747, '111393', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 15:30:40', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11749, '111396', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 15:59:45', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '50.00', '35.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11748, '111392', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 15:29:51', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11743, '111391', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 15:12:44', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '103.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11742, '111389', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 14:54:32', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11741, '111390', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 15:01:15', 'Paid', NULL, '115.00', '126.50', '126.50', NULL, '150.00', '23.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11740, '111388', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 14:43:01', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11739, '111385', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 14:13:15', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '100.20', '54.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11738, '111384', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 13:47:51', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11737, '111382', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 13:42:51', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11731, '111378', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 12:49:21', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11732, '111379', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 12:52:50', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.30', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11733, '111380', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 13:13:37', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '60.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11734, '111376', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 12:46:14', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11735, '111381', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 13:33:08', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.00', '43.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11736, '111387', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 14:18:32', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '100.00', '84.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11712, '111357', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 10:09:59', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11713, '111358', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 10:11:32', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.50', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11714, '111360', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 10:27:20', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '78.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11715, '111362', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 10:37:41', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11716, '111363', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 10:41:21', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11717, '111365', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 10:46:11', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '60.00', '8.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11718, '111366', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 10:50:10', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.50', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11719, '111364', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 10:45:16', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '40.00', '5.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11720, '111367', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 11:17:11', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11721, '111383', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 13:44:56', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '120.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11722, '111368', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 11:21:19', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.60', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11723, '111370', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 11:39:04', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '102.00', '30.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11724, '111371', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 11:51:10', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '100.00', '42.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11725, '111369', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 11:37:16', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11726, '111372', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 12:11:19', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11727, '111375', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 12:18:56', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '78.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11728, '111373', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 12:12:20', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11729, '111374', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 12:13:01', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '20.00', '11.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11730, '111377', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 12:48:07', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11711, '111361', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 10:35:44', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11710, '111359', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-05 10:14:58', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1501923116', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11814, '111455', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 17:45:08', 'Paid', NULL, '63.00', '62.35', '62.35', NULL, '100.00', '37.65', '0.00', '0.00', '6.93', '-0.02', 'Cash', NULL, '27', '1502007576', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11815, '111456', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 17:45:43', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11813, '111454', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 17:01:22', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11804, '111441', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 15:01:17', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '51.20', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11805, '111447', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 15:28:09', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '53.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11806, '111448', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 15:36:36', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '100.00', '42.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11807, '111453', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 16:58:20', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11808, '111446', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 15:22:33', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11809, '111444', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 15:08:50', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11810, '111450', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 16:09:08', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11811, '111451', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 16:17:29', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.50', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11812, '111452', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 16:38:26', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '6.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11799, '111442', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 15:02:42', 'Paid', NULL, '105.00', '115.50', '115.50', NULL, '120.50', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11800, '111439', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 14:44:45', 'Paid', NULL, '204.00', '224.40', '224.40', NULL, '250.00', '25.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11801, '111449', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 15:37:49', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11802, '111443', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 15:03:16', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '70.00', '7.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11803, '111445', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 15:21:43', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11798, '111436', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 13:33:15', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.10', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11797, '111437', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 14:02:44', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.20', '3.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11796, '111440', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 14:50:53', 'Paid', NULL, '156.00', '171.60', '171.60', NULL, '172.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11795, '111434', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 13:25:07', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11769, '111408', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 10:06:39', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11770, '111411', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 10:25:32', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '57.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11771, '111410', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 10:25:00', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11772, '111412', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 10:39:34', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.00', '3.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11773, '111419', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 11:29:01', 'Paid', NULL, '171.00', '188.10', '188.10', NULL, '189.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11774, '111415', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 11:16:31', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '55.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11775, '111414', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 11:12:58', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '80.00', '5.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11776, '111416', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 11:20:49', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '71.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11777, '111417', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 11:21:21', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '71.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11778, '111418', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 11:28:23', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '41.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11779, '111421', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 11:41:25', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11780, '111420', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 11:40:32', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '53.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11781, '111422', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 11:59:48', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11782, '111424', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 12:17:07', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11783, '111432', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 13:23:18', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11784, '111426', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 12:31:39', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11785, '111425', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 12:23:34', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '50.70', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11786, '111423', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 12:12:01', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11787, '111429', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 12:53:19', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11788, '111431', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 13:05:58', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11789, '111428', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 12:51:40', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.00', '4.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11790, '111430', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 13:03:11', 'Paid', NULL, '131.00', '144.10', '144.10', NULL, '200.00', '55.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11791, '111427', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 12:40:49', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11792, '111438', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 14:27:47', 'Paid', NULL, '99.00', '108.90', '108.90', NULL, '110.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11793, '111435', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 13:29:50', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '54.20', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11794, '111433', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 13:24:56', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11768, '111413', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 10:54:35', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11767, '111409', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-06 10:07:47', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502007576', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11818, '111460', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 11:09:44', 'Paid', NULL, '184.00', '202.40', '202.40', NULL, '205.40', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11819, '111457', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 10:07:09', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11820, '111461', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 11:20:44', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11821, '111463', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 12:00:38', 'Paid', NULL, '73.00', '72.25', '72.25', NULL, '80.00', '7.75', '0.00', '0.00', '8.03', '-0.02', 'Cash', NULL, '27', '1502085210', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11822, '111464', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 12:05:53', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11823, '111477', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 14:57:52', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11824, '111466', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 12:38:11', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.10', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11825, '111462', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 11:56:16', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11826, '111468', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 13:15:42', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11827, '111465', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 12:17:53', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '100.00', '90.10', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1502085210', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11828, '111467', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 13:13:03', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.00', '9.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11829, '111472', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 14:03:12', 'Paid', NULL, '36.00', '35.65', '35.65', NULL, '50.00', '14.35', '0.00', '0.00', '3.96', '0.01', 'Cash', NULL, '27', '1502085210', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11830, '111473', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 14:10:17', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11831, '111469', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 13:53:45', 'Paid', NULL, '23.50', '25.85', '25.85', NULL, '50.00', '24.15', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(11832, '111470', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 13:59:11', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '8.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11833, '111474', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 14:19:04', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11834, '111475', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 14:25:25', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.50', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11835, '111482', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 16:45:59', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11836, '111471', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 13:59:16', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11837, '111476', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 14:44:14', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11842, '111485', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 17:58:59', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.30', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11839, '111478', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 15:11:39', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11840, '111479', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 15:28:13', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '50.00', '40.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11841, '111480', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 15:28:36', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11843, '111483', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 16:50:23', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '46.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11845, '111481', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 16:25:26', 'Paid', NULL, '15.00', '13.50', '13.50', NULL, '13.50', '0.00', '0.00', '0.00', '1.50', '0.00', 'Cash', NULL, '27', '1502085210', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11846, '111484', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 17:55:45', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11817, '111459', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 10:34:41', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11816, '111458', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-07 10:13:14', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '71.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502085210', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11884, '111521', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 17:38:34', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11885, '111520', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 17:14:57', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11886, '111522', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 17:51:54', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '56.00', '20.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11880, '111513', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 16:21:37', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11881, '111514', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 16:21:57', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11882, '111515', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 16:22:29', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11883, '111519', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 17:04:05', 'Paid', NULL, '9.90', '10.90', '10.90', NULL, '10.90', '0.00', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11879, '111512', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 16:21:15', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11878, '111518', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 17:03:21', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11877, '111516', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 16:23:06', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11876, '111517', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 16:23:24', 'Paid', NULL, NULL, '0.00', '0.00', NULL, '0.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11875, '111510', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 15:34:32', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11874, '111509', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 15:12:55', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11872, '111507', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 14:52:01', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11871, '111506', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 14:22:40', 'Paid', NULL, '102.00', '112.20', '112.20', NULL, '120.00', '7.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11870, '111504', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 13:53:28', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11869, '111503', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 13:51:07', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.20', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11867, '111501', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 13:41:09', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '19.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11868, '111505', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 14:00:07', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '86.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11865, '111499', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 13:22:25', 'Paid', NULL, '23.00', '25.30', '0.00', '25.30', '30.00', '4.70', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '0.46', 'Master Card', '1.80', NULL, '0.03', '24.82', 0, NULL, NULL, NULL, NULL, '0'),
(11863, '111498', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 12:58:21', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11862, '111497', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 12:57:44', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.40', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11861, '111496', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 12:56:36', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '55.10', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11860, '111495', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 12:55:53', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11858, '111493', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 12:40:25', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '52.00', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11859, '111494', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 12:54:15', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11857, '111502', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 13:44:01', 'Paid', NULL, '39.00', '38.60', '38.60', NULL, '50.00', '11.40', '0.00', '0.00', '4.29', '-0.01', 'Cash', NULL, '27', '1502262698', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11853, '111490', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 11:12:30', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11854, '111511', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 15:51:14', 'Paid', NULL, '222.00', '244.20', '244.20', NULL, '300.00', '55.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11864, '111508', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 14:58:46', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.20', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11856, '111500', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 13:25:00', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11852, '111488', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 10:56:21', 'Paid', NULL, '52.00', '51.50', '51.50', NULL, '60.00', '8.50', '0.00', '0.00', '5.72', '0.02', 'Cash', NULL, '27', '1502262698', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11851, '111489', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 11:02:15', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11849, '111492', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 11:23:46', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '56.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11850, '111491', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 11:14:37', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '70.00', '8.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11848, '111487', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 10:04:16', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '10.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11847, '111486', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-09 09:48:38', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502262698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11898, '111531', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-10 12:17:55', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '14.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502340275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11899, '111540', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-10 15:55:18', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '100.00', '53.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502340275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11900, '111537', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-08-10 13:41:00', 'Paid', NULL, '133.00', '131.65', '131.65', NULL, '152.00', '20.35', '0.00', '0.00', '14.63', '-0.02', 'Cash', NULL, '27', '1502340275', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11905, '111539', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-10 15:21:33', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502340275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11906, '111542', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-10 17:00:29', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '41.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502340275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11904, '111538', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-08-10 15:03:26', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '50.00', '33.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502340275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11902, '111535', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-10 13:29:02', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502340275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11903, '111541', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-10 15:59:35', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '17.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502340275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11901, '111536', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-10 13:35:14', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502340275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11896, '111532', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-10 12:43:51', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502340275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11897, '111528', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-10 12:04:06', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502340275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11889, '111524', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-10 10:36:29', 'Paid', NULL, '74.00', '73.25', '73.25', NULL, '100.25', '27.00', '0.00', '0.00', '8.14', '-0.01', 'Cash', NULL, '27', '1502340275', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11890, '111525', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-10 10:59:09', 'Paid', NULL, '16.00', '14.40', '14.40', NULL, '50.00', '35.60', '0.00', '0.00', '1.60', '0.00', 'Cash', NULL, '27', '1502340275', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11891, '111527', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-08-10 11:31:46', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502340275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11892, '111530', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-10 12:14:06', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '100.00', '56.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502340275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11893, '111533', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-10 12:57:18', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502340275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11894, '111526', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-10 11:13:27', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '20.60', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502340275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11895, '111529', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-10 12:05:40', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '100.20', '54.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502340275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11888, '111534', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-10 13:15:35', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.30', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502340275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11887, '111523', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-10 10:34:04', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '100.00', '5.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502340275', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11932, '111568', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 16:55:05', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '15.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11909, '111545', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 11:19:09', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11910, '111544', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 10:47:26', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '20.00', '12.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11911, '111546', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 11:19:47', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11913, '111548', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 12:21:52', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11914, '111550', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 12:28:02', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '71.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11915, '111559', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 13:56:22', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.00', '7.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11916, '111547', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 12:10:30', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11917, '111552', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 13:24:20', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11918, '111553', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 13:24:38', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '40.00', '4.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11919, '111555', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 13:29:23', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11920, '111556', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 13:34:29', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '74.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11921, '111558', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 13:44:16', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.00', '7.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11922, '111557', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 13:39:16', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11923, '111561', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 14:12:20', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11924, '111554', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 13:25:24', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '10.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11925, '111562', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 14:16:07', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11926, '111564', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 14:36:31', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11927, '111563', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 14:31:35', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11928, '111560', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 14:04:14', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11929, '111565', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 15:01:17', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.10', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11930, '111566', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 15:29:48', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '100.00', '69.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11931, '111567', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 16:38:14', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '50.50', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11912, '111551', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 12:32:09', 'Paid', NULL, '92.90', '102.20', '102.20', NULL, '150.00', '47.80', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11908, '111549', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 12:24:21', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '40.10', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11907, '111543', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-11 09:36:52', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.30', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502433080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11976, '111609', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 17:26:54', 'Paid', NULL, '42.40', '46.65', '46.65', NULL, '50.00', '3.35', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11972, '111607', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 16:48:58', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11968, '111599', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 14:34:14', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.10', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11969, '111608', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 16:55:49', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11970, '111603', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 15:34:09', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.20', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11971, '111602', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 14:59:10', 'Paid', NULL, '16.00', '14.40', '14.40', NULL, '50.00', '35.60', '0.00', '0.00', '1.60', '0.00', 'Cash', NULL, '27', '1502511755', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11966, '111597', 'T1(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 13:51:13', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '53.10', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(11965, '111600', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 14:36:27', 'Paid', NULL, '96.90', '106.60', '106.60', NULL, '106.60', '0.00', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11975, '111606', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 16:44:39', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11974, '111604', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 16:38:08', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11973, '111605', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 16:40:27', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11963, '111593', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 12:41:42', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '50.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11962, '111601', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 14:46:56', 'Paid', NULL, '126.00', '138.60', '138.60', NULL, '150.00', '11.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11961, '111598', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 13:54:28', 'Paid', NULL, '29.00', '28.70', '28.70', NULL, '50.00', '21.30', '0.00', '0.00', '3.19', '-0.01', 'Cash', NULL, '27', '1502511755', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11952, '111587', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 11:47:13', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11953, '111589', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 11:55:12', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '26.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11954, '111590', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 11:55:51', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '65.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11955, '111591', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 12:08:12', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '80.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11956, '111585', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 11:34:13', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11957, '111594', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 13:06:32', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.00', '7.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11958, '111586', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 11:46:39', 'Paid', NULL, '25.00', '25.00', '25.00', NULL, '50.00', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11959, '111596', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 13:37:09', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11960, '111595', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 13:13:04', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '100.00', '60.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11935, '111583', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 11:12:17', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11936, '111570', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 09:48:47', 'Paid', NULL, '46.00', '45.55', '45.55', NULL, '50.00', '4.45', '0.00', '0.00', '5.06', '0.01', 'Cash', NULL, '27', '1502511755', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11946, '111572', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 10:05:30', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.00', '20.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11938, '111575', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 10:30:06', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11939, '111573', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 10:11:23', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11940, '111574', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 10:13:11', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11941, '111588', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 11:49:58', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.40', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11942, '111576', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 10:40:06', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11943, '111577', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 10:43:57', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11944, '111582', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 11:05:38', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '40.00', '4.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11945, '111580', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 11:00:17', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '62.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11947, '111579', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 10:52:20', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '40.00', '15.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11948, '111578', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 10:51:40', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '70.10', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11949, '111584', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 11:32:24', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '55.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11950, '111581', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 11:05:00', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.00', '2.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11951, '111592', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 12:10:54', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11934, '111571', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 09:59:13', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.40', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11933, '111569', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-12 09:35:30', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502511755', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12039, '111670', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 17:46:16', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '21.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12035, '111666', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 16:52:26', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12036, '111663', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 16:20:26', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.00', '15.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12037, '111665', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 16:50:01', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '100.00', '18.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12038, '111667', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 17:15:23', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12034, '111660', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 15:41:12', 'Paid', NULL, '3.90', '3.85', '3.85', NULL, '5.00', '1.15', '0.00', '0.00', '0.43', '-0.01', 'Cash', NULL, '27', '1502604446', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12025, '111658', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 15:24:15', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '83.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(12026, '111655', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 15:07:58', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12027, '111657', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 15:24:02', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12028, '111662', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 15:52:24', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12029, '111661', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 15:51:12', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.00', '9.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12030, '111664', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 16:23:43', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '52.00', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12031, '111656', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 15:20:33', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '30.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12032, '111669', 't13', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 17:37:35', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12033, '111659', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 15:38:48', 'Paid', NULL, '33.00', '29.70', '29.70', NULL, '29.70', '0.00', '0.00', '0.00', '3.30', '0.00', 'Cash', NULL, '27', '1502604446', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12018, '111644', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 13:05:42', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12020, '111649', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 13:47:41', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12021, '111652', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 14:03:19', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.20', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12022, '111651', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 13:53:51', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12023, '111653', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 14:21:40', 'Paid', NULL, '48.00', '47.50', '47.50', NULL, '100.00', '52.50', '0.00', '0.00', '5.28', '-0.02', 'Cash', NULL, '27', '1502604446', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12024, '111650', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 13:49:10', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12013, '111648', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 13:24:40', 'Paid', NULL, '99.00', '108.90', '108.90', NULL, '110.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12014, '111640', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 13:04:09', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '30.10', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12015, '111641', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 13:04:28', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12016, '111642', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 13:04:50', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12017, '111643', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 13:05:15', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12012, '111647', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 13:12:58', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '55.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12011, '111646', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 13:07:33', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '100.10', '66.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12010, '111633', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 12:28:58', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12008, '111639', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 12:58:02', 'Paid', NULL, '99.00', '108.90', '108.90', NULL, '110.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12009, '111635', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 12:41:46', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '17.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12007, '111637', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 12:47:01', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '100.60', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12005, '111668', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 17:36:34', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '51.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12004, '111636', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 12:43:12', 'Paid', NULL, '99.00', '108.90', '108.90', NULL, '109.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11979, '111611', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 09:30:22', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11980, '111613', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 09:58:47', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11981, '111610', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 09:26:59', 'Paid', NULL, NULL, '0.00', '0.00', NULL, '0.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11982, '111614', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 10:05:30', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.00', '9.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11983, '111623', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 11:21:00', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11984, '111624', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 11:21:16', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(11985, '111618', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 10:42:15', 'Paid', NULL, '152.00', '150.50', '150.50', NULL, '200.00', '49.50', '0.00', '0.00', '16.72', '0.02', 'Cash', NULL, '27', '1502604446', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11986, '111625', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 11:26:17', 'Paid', NULL, '99.00', '108.90', '108.90', NULL, '110.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11987, '111616', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 10:30:18', 'Paid', NULL, '118.00', '129.80', '129.80', NULL, '150.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11989, '111617', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 10:33:00', 'Paid', NULL, '74.00', '73.25', '73.25', NULL, '90.00', '16.75', '0.00', '0.00', '8.14', '-0.01', 'Cash', NULL, '27', '1502604446', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11990, '111619', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 10:49:54', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12006, '111632', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 12:27:54', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '10.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11992, '111620', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 10:54:33', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '65.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11993, '111621', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 11:10:11', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11994, '111622', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 11:14:22', 'Paid', NULL, '96.00', '105.60', '105.60', NULL, '110.00', '4.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12019, '111654', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 14:43:31', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11996, '111627', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 11:30:22', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11997, '111629', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 11:54:34', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11998, '111626', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 11:28:14', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11999, '111628', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 11:49:38', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '100.00', '67.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12000, '111631', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 12:08:06', 'Paid', NULL, '120.00', '132.00', '132.00', NULL, '150.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12001, '111638', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 12:52:25', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12002, '111645', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 13:06:41', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '80.00', '5.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12003, '111634', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 12:30:44', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '49.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11988, '111630', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 12:00:46', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '25.00', '1.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11978, '111615', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 10:23:26', 'Paid', NULL, '146.00', '160.60', '160.60', NULL, '200.00', '39.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(11977, '111612', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-13 09:49:22', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '101.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502604446', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12058, '111685', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-14 14:28:41', 'Paid', NULL, '10.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1502686902', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12059, '111690', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-14 16:47:07', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502686902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12060, '111691', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-14 17:11:39', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '40.00', '1.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502686902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12061, '111692', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-14 17:12:24', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '16.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502686902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12042, '111676', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-14 11:19:27', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502686902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12043, '111673', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-14 11:03:02', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '100.00', '72.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502686902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12044, '111675', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-14 11:15:46', 'Paid', NULL, '50.50', '55.55', '55.55', NULL, '55.55', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502686902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12045, '111671', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-14 10:38:30', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502686902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12046, '111686', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-14 14:35:23', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502686902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12047, '111677', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-14 13:03:22', 'Paid', NULL, '112.00', '123.20', '123.20', NULL, '150.00', '26.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502686902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12048, '111678', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-14 13:27:40', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '53.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502686902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12049, '111688', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-14 14:45:04', 'Paid', NULL, '66.00', '65.35', '65.35', NULL, '70.00', '4.65', '0.00', '0.00', '7.26', '0.01', 'Cash', NULL, '27', '1502686902', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12050, '111680', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-14 13:33:40', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502686902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12051, '111681', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-14 13:38:41', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.00', '3.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502686902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12052, '111679', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-14 13:33:08', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502686902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12053, '111683', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-14 14:07:56', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502686902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12054, '111682', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-14 14:05:57', 'Paid', NULL, '19.00', '18.80', '18.80', NULL, '21.00', '2.20', '0.00', '0.00', '2.09', '-0.01', 'Cash', NULL, '27', '1502686902', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12055, '111684', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-14 14:15:59', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.20', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502686902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12056, '111689', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-14 14:50:36', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502686902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12057, '111687', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-14 14:44:20', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '70.00', '17.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502686902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12041, '111674', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-14 11:09:40', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '63.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502686902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12040, '111672', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-14 11:00:55', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502686902', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12064, '111698', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 12:22:26', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502859986', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12065, '111696', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 11:25:05', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '102.00', '50.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502859986', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12066, '111695', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 10:59:45', 'Paid', NULL, '12.50', '11.25', '11.25', NULL, '11.25', '0.00', '0.00', '0.00', '1.25', '0.00', 'Cash', NULL, '27', '1502859986', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12067, '111697', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 11:42:30', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502859986', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12068, '111699', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 12:50:45', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502859986', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12069, '111700', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 13:04:39', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502859986', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12070, '111702', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 13:30:22', 'Paid', NULL, '152.00', '167.20', '167.20', NULL, '200.00', '32.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502859986', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12071, '111701', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 13:22:26', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '110.00', '50.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502859986', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12072, '111704', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 13:43:30', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502859986', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12073, '111703', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 13:43:05', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502859986', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12074, '111706', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 14:01:07', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '53.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502859986', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12075, '111709', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 14:16:43', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502859986', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12076, '111708', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 14:09:43', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502859986', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12077, '111705', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 13:51:20', 'Paid', NULL, '19.00', '18.80', '18.80', NULL, '20.00', '1.20', '0.00', '0.00', '2.09', '-0.01', 'Cash', NULL, '27', '1502859986', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12078, '111707', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 14:02:59', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502859986', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12079, '111710', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 14:37:43', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '100.00', '72.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502859986', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12080, '111711', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 16:03:25', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.50', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502859986', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12081, '111716', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 17:42:31', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502859986', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12082, '111713', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 16:20:50', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502859986', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12083, '111712', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 16:15:23', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '10.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502859986', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12084, '111714', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 16:51:20', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502859986', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12085, '111715', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 17:03:04', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502859986', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12063, '111694', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 10:54:28', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502859986', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12062, '111693', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-16 10:43:21', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502859986', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12112, '111740', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 15:57:27', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '100.00', '61.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12113, '111743', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 16:49:56', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '51.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12114, '111746', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 17:52:54', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12115, '111745', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 17:16:32', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12111, '111742', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 16:38:07', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12110, '111741', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 16:18:11', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '57.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12109, '111744', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 16:59:41', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12108, '111737', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 15:12:50', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '106.00', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12107, '111736', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 14:47:24', 'Paid', NULL, '74.00', '73.25', '73.25', NULL, '100.00', '26.75', '0.00', '0.00', '8.14', '-0.01', 'Cash', NULL, '27', '1502948728', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12106, '111739', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 15:35:41', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12105, '111735', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 14:43:30', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '40.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12104, '111733', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 14:21:55', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '40.00', '4.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12103, '111732', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 14:21:28', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12102, '111734', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 14:30:48', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12101, '111730', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 13:20:32', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12100, '111731', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 14:00:27', 'Paid', NULL, '63.00', '62.35', '62.35', NULL, '70.00', '7.65', '0.00', '0.00', '6.93', '-0.02', 'Cash', NULL, '27', '1502948728', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12099, '111729', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 12:56:16', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12098, '111728', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 12:48:55', 'Paid', NULL, '20.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', '2.20', '0.00', 'Cash', NULL, '27', '1502948728', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12097, '111738', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 15:13:31', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12096, '111725', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 12:18:10', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '31.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12095, '111723', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 11:29:55', 'Paid', NULL, '10.00', '9.00', '9.00', NULL, '50.00', '41.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1502948728', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12094, '111722', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 11:11:51', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12093, '111727', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 12:33:16', 'Paid', NULL, '37.00', '36.65', '36.65', NULL, '50.65', '14.00', '0.00', '0.00', '4.07', '0.02', 'Cash', NULL, '27', '1502948728', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12088, '111718', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 10:30:38', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12089, '111720', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 10:59:46', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.60', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12090, '111721', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 11:00:23', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12091, '111726', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 12:27:37', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12092, '111724', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 11:55:34', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '75.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12087, '111717', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 10:26:37', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.30', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12086, '111719', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-17 10:50:55', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.40', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1502948728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12134, '111761', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-18 16:12:48', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.10', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503032561', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12135, '111764', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-18 17:19:37', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503032561', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12133, '111765', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-18 17:25:05', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503032561', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12125, '111756', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-18 13:09:15', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503032561', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12126, '111753', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-18 12:47:16', 'Paid', NULL, '18.90', '20.80', '20.80', NULL, '50.00', '29.20', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1503032561', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12127, '111754', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-18 12:57:37', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503032561', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12128, '111759', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-18 13:25:59', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503032561', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12129, '111757', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-18 13:12:32', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503032561', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12130, '111762', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-18 16:13:39', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.20', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503032561', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12132, '111763', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-18 16:54:19', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '29.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503032561', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12131, '111760', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-18 14:57:19', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503032561', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12119, '111749', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-18 11:27:39', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '58.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503032561', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12120, '111750', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-18 11:56:14', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503032561', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12121, '111751', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-18 12:14:20', 'Paid', NULL, '41.90', '46.10', '46.10', NULL, '50.10', '4.00', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1503032561', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12122, '111755', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-18 13:03:57', 'Paid', NULL, '115.00', '126.50', '126.50', NULL, '127.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503032561', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12123, '111752', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-18 12:22:36', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503032561', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12124, '111758', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-18 13:25:06', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '52.00', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503032561', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(12117, '111748', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-18 10:48:16', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503032561', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12116, '111747', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-18 10:21:26', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503032561', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12163, '111792', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 14:35:58', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.00', '30.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12164, '111793', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 14:41:05', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12165, '111795', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 14:59:04', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.40', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12166, '111794', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 14:51:38', 'Paid', NULL, '10.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1503122978', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12167, '111797', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 15:42:42', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.00', '15.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12168, '111798', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 16:10:03', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12169, '111799', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 16:24:48', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12170, '111800', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 17:20:11', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12162, '111796', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 15:00:08', 'Paid', NULL, '68.00', '67.30', '67.30', NULL, '100.30', '33.00', '0.00', '0.00', '7.48', '-0.02', 'Cash', NULL, '27', '1503122978', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12160, '111788', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 13:17:29', 'Paid', NULL, '29.00', '28.70', '28.70', NULL, '50.00', '21.30', '0.00', '0.00', '3.19', '-0.01', 'Cash', NULL, '27', '1503122978', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12161, '111790', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 13:27:47', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12156, '111787', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 13:15:41', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '57.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12157, '111778', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 12:23:44', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1503122978', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12158, '111786', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 13:14:18', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '100.00', '5.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12159, '111789', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 13:21:57', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12152, '111785', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 13:06:36', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.30', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12154, '111784', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 12:56:38', 'Paid', NULL, '22.00', '21.80', '21.80', NULL, '50.00', '28.20', '0.00', '0.00', '2.42', '0.02', 'Cash', NULL, '27', '1503122978', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12155, '111791', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 13:33:45', 'Paid', NULL, '202.00', '222.20', '222.20', NULL, '250.20', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12153, '111782', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 12:50:33', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '70.00', '7.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12138, '111768', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 10:13:45', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '88.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12139, '111767', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 10:04:12', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '103.50', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12140, '111770', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 10:35:46', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '40.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12141, '111771', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 10:49:45', 'Paid', NULL, '108.00', '118.80', '118.80', NULL, '120.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12142, '111772', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 11:03:34', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '57.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12143, '111780', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 12:37:07', 'Paid', NULL, '154.00', '169.40', '169.40', NULL, '170.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12144, '111773', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 11:57:00', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12151, '111777', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 12:23:03', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12150, '111776', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 12:18:38', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '100.00', '56.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12149, '111779', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 12:24:13', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '69.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12148, '111781', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 12:48:57', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12147, '111783', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 12:50:57', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '100.00', '81.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12146, '111775', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 12:03:50', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12145, '111774', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 11:58:27', 'Paid', NULL, '108.00', '118.80', '118.80', NULL, '150.00', '31.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12137, '111769', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 10:14:42', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '40.30', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12136, '111766', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-08-19 09:44:05', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503122978', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12218, '111839', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 15:25:02', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12219, '111851', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 17:16:39', 'Paid', NULL, '103.00', '113.30', '113.30', NULL, '113.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12220, '111845', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 16:23:44', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.20', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12221, '111849', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 17:01:16', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '71.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12222, '111850', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 17:01:24', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12223, '111842', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 16:16:36', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12224, '111852', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 17:40:21', 'Paid', NULL, '190.00', '209.00', '209.00', NULL, '209.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12211, '111837', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 15:00:55', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '100.00', '18.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12212, '111847', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 16:46:18', 'Paid', NULL, '50.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', '5.50', '0.00', 'Cash', NULL, '27', '1503217811', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12213, '111841', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 16:12:46', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12214, '111844', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 16:20:29', 'Paid', NULL, '34.00', '33.65', '33.65', NULL, '100.00', '66.35', '0.00', '0.00', '3.74', '-0.01', 'Cash', NULL, '27', '1503217811', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12215, '111840', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 16:09:41', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '70.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12198, '111825', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 13:12:35', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '68.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12199, '111834', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 14:18:22', 'Paid', NULL, '234.00', '257.40', '257.40', NULL, '270.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12200, '111827', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 13:24:09', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12201, '111829', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 13:48:44', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '59.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12202, '111838', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 15:01:16', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12203, '111831', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 14:13:46', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.00', '41.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12204, '111833', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 14:17:36', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12205, '111846', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 16:33:15', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12206, '111832', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 14:16:31', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12207, '111836', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 14:57:12', 'Paid', NULL, '97.00', '106.70', '106.70', NULL, '120.00', '13.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12208, '111848', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 16:52:58', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.00', '3.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12209, '111843', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 16:19:07', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '27.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12210, '111835', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 14:49:45', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '105.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12197, '111830', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 14:13:10', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12196, '111824', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 12:50:44', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '95.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12195, '111826', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 13:21:35', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12193, '111828', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 13:47:24', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '51.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12194, '111821', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 12:04:19', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '54.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12179, '111809', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 10:36:44', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12180, '111808', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 10:36:03', 'Paid', NULL, '105.00', '115.50', '115.50', NULL, '115.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12191, '111813', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 11:20:10', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.20', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12192, '111823', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 12:18:22', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12175, '111806', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 10:16:23', 'Paid', NULL, '37.50', '41.25', '41.25', NULL, '51.28', '10.03', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12181, '111817', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 11:32:43', 'Paid', NULL, '117.00', '128.70', '128.70', NULL, '150.00', '21.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12182, '111812', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 11:17:14', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12183, '111819', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 11:45:29', 'Paid', NULL, '102.00', '112.20', '112.20', NULL, '120.00', '7.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12184, '111815', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 11:31:33', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12185, '111816', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 11:32:15', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12186, '111814', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 11:27:33', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '65.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12187, '111822', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 12:08:49', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12188, '111811', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 10:51:51', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '100.00', '92.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12189, '111818', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 11:39:41', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.20', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12190, '111820', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 11:55:31', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '53.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12178, '111810', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 10:37:25', 'Paid', NULL, '125.00', '137.50', '137.50', NULL, '150.00', '12.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12177, '111807', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 10:20:20', 'Paid', NULL, '24.00', '23.75', '23.75', NULL, '107.00', '83.25', '0.00', '0.00', '2.64', '-0.01', 'Cash', NULL, '27', '1503217811', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12176, '111802', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 09:32:23', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12173, '111801', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 09:18:02', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '101.00', '20.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12174, '111804', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 10:10:41', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12172, '111803', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 09:44:15', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '75.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12171, '111805', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-20 10:12:02', 'Paid', NULL, '126.00', '138.60', '138.60', NULL, '150.00', '11.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503217811', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12252, '111878', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 16:28:03', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12253, '111879', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 16:49:22', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '50.00', '33.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12250, '111877', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 16:26:13', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12251, '111880', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 16:54:53', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12248, '111874', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 15:02:16', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '50.00', '31.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12249, '111876', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 15:51:47', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.60', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12244, '111871', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 14:42:39', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12245, '111872', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 14:43:09', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '104.00', '30.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12246, '111873', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 15:01:49', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12247, '111875', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 15:19:43', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '38.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12231, '111858', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 11:10:12', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.20', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12228, '111857', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 10:53:23', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12229, '111855', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 10:29:08', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12230, '111856', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 10:29:27', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12232, '111860', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 11:36:31', 'Paid', NULL, '118.00', '129.80', '129.80', NULL, '200.00', '70.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12233, '111863', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 12:10:35', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12234, '111861', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 11:56:58', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12235, '111862', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 12:06:03', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12236, '111859', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 11:34:57', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '50.00', '40.10', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1503296751', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12237, '111864', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 12:23:50', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12238, '111865', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 13:42:59', 'Paid', NULL, '72.00', '71.30', '71.30', NULL, '75.00', '3.70', '0.00', '0.00', '7.92', '0.02', 'Cash', NULL, '27', '1503296751', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12239, '111866', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 13:48:34', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.00', '15.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12240, '111869', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 13:56:41', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12241, '111870', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 14:12:27', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12242, '111867', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 13:53:44', 'Paid', NULL, '10.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1503296751', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12243, '111868', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 13:54:25', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12226, '111854', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 10:22:51', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12225, '111853', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-21 10:19:50', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '25.10', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503296751', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12256, '111884', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-23 11:36:37', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503465960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12257, '111883', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-23 11:17:34', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503465960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12258, '111885', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-23 11:57:58', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503465960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12259, '111886', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-23 12:19:33', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '76.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503465960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12260, '111887', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-23 12:34:44', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503465960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12261, '111888', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-23 12:35:11', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '100.00', '73.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503465960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12262, '111889', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-23 12:43:32', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '80.00', '6.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503465960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12263, '111890', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-23 12:46:23', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503465960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12265, '111891', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-23 13:05:40', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503465960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12266, '111892', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-23 13:26:29', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503465960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12267, '111894', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-23 13:52:08', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '100.00', '81.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503465960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12268, '111893', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-23 13:38:33', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503465960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12269, '111895', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-23 14:08:02', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '55.00', '4.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503465960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12270, '111898', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-23 15:10:19', 'Paid', NULL, '16.00', '15.85', '15.85', NULL, '50.00', '34.15', '0.00', '0.00', '1.76', '0.01', 'Cash', NULL, '27', '1503465960', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12271, '111897', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-23 14:42:14', 'Paid', NULL, '28.00', '25.20', '25.20', NULL, '25.20', '0.00', '0.00', '0.00', '2.80', '0.00', 'Cash', NULL, '27', '1503465960', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12272, '111899', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-23 15:47:48', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503465960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12273, '111900', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-23 16:49:18', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '100.20', '87.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503465960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12264, '111896', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-23 14:09:16', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503465960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12255, '111882', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-23 10:41:11', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503465960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12254, '111881', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-23 10:13:32', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503465960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12291, '111917', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-24 17:17:05', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503554629', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12290, '111916', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-24 16:32:42', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503554629', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12289, '111913', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-24 14:43:46', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '17.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503554629', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12276, '111903', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-24 10:43:47', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503554629', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12277, '111904', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-24 11:01:16', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.20', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503554629', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12278, '111905', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-24 11:04:17', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503554629', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12279, '111906', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-24 12:24:51', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503554629', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12280, '111907', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-24 12:33:22', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '80.00', '1.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503554629', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12281, '111911', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-24 14:25:32', 'Paid', NULL, '47.00', '46.55', '46.55', NULL, '100.00', '53.45', '0.00', '0.00', '5.17', '0.02', 'Cash', NULL, '27', '1503554629', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12282, '111908', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-24 13:34:00', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503554629', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(12283, '111909', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-24 13:41:38', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '50.00', '42.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503554629', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12284, '111915', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-24 14:55:31', 'Paid', NULL, '60.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', '6.60', '0.00', 'Cash', NULL, '27', '1503554629', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12285, '111910', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-24 14:23:37', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503554629', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12286, '111912', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-24 14:30:19', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.10', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503554629', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12287, '111918', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-24 17:28:22', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '53.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503554629', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12288, '111914', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-24 14:52:55', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '103.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503554629', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12275, '111902', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-24 10:09:05', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503554629', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12274, '111901', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-24 09:48:21', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503554629', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12318, '111945', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 17:06:50', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '31.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12319, '111946', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 17:14:03', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12320, '111947', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 17:50:59', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12316, '111944', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 16:31:50', 'Paid', NULL, '59.00', '58.40', '58.40', NULL, '60.00', '1.60', '0.00', '0.00', '6.49', '-0.01', 'Cash', NULL, '27', '1503643027', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12317, '111942', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 16:09:20', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12314, '111938', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 15:12:43', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12315, '111940', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 16:04:40', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '51.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12313, '111939', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 15:50:52', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '90.00', '4.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12312, '111936', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 15:01:18', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12311, '111937', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 15:11:32', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.20', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12310, '111935', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 14:20:58', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12309, '111933', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 13:53:44', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '61.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12294, '111921', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 11:08:43', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12295, '111923', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 11:33:32', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12296, '111924', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 11:43:08', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.00', '41.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12297, '111922', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 11:29:56', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12298, '111927', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 12:12:57', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '60.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12299, '111926', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 11:54:55', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.80', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12300, '111925', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 11:49:49', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '18.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12301, '111931', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 13:00:46', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12302, '111928', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 12:25:06', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12303, '111930', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 12:38:25', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12304, '111929', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 12:31:53', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '37.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12305, '111932', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 13:17:35', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12306, '111941', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 16:05:15', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12307, '111943', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 16:23:49', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12308, '111934', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 14:16:47', 'Paid', NULL, '104.00', '114.40', '114.40', NULL, '120.40', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12293, '111920', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 10:36:04', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12292, '111919', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-25 10:30:33', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.50', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503643027', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12347, '111980', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 16:34:00', 'Paid', NULL, '112.00', '123.20', '123.20', NULL, '123.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12348, '111970', 'T4', 10008, 'lois', NULL, NULL, 'history', '2017-08-26 13:17:03', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12349, '111975', 'T14', 10008, 'lois', NULL, NULL, 'history', '2017-08-26 14:41:11', 'Paid', NULL, '51.00', '50.50', '50.50', NULL, '50.50', '0.00', '0.00', '0.00', '5.61', '0.01', 'Cash', NULL, '27', '1503731258', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12350, '111974', 'T8', 10008, 'lois', NULL, NULL, 'history', '2017-08-26 13:50:14', 'Paid', NULL, '26.00', '25.75', '25.75', NULL, '50.00', '24.25', '0.00', '0.00', '2.86', '0.01', 'Cash', NULL, '27', '1503731258', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12351, '111978', 'T12', 10008, 'lois', NULL, NULL, 'history', '2017-08-26 16:01:42', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '52.00', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12352, '111981', 'T2', 10008, 'lois', NULL, NULL, 'history', '2017-08-26 16:41:16', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '90.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12353, '111979', 'T5', 10008, 'lois', NULL, NULL, 'history', '2017-08-26 16:17:46', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '100.00', '67.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12354, '111977', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 16:00:41', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '100.50', '75.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12355, '111976', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 15:53:54', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.20', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12356, '111982', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 16:51:11', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12346, '111969', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 13:14:40', 'Paid', NULL, '111.00', '122.10', '122.10', NULL, '130.10', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12345, '111973', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 13:49:05', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.40', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12344, '111972', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 13:47:13', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12343, '111968', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 12:51:32', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12342, '111971', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 13:19:44', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12323, '111950', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 10:04:55', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '52.90', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12325, '111953', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 10:25:40', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '100.10', '66.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12326, '111951', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 10:22:52', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12341, '111967', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 12:42:23', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12340, '111964', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 12:29:37', 'Paid', NULL, '26.00', '25.75', '25.75', NULL, '30.75', '5.00', '0.00', '0.00', '2.86', '0.01', 'Cash', NULL, '27', '1503731258', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12339, '111961', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 12:01:06', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12338, '111963', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 12:21:13', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '100.00', '6.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12337, '111966', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 12:31:34', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12336, '111962', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 12:11:36', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '62.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12335, '111965', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 12:30:47', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12334, '111960', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 11:54:50', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12332, '111955', 'T10(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 10:43:42', 'Paid', NULL, '29.90', '32.90', '32.90', NULL, '50.00', '17.10', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12331, '111954', 'T10(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 10:43:10', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '30.20', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12330, '111958', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 11:30:25', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12329, '111956', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 10:49:00', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12328, '111957', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 11:06:21', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12333, '111959', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 11:42:02', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12324, '111952', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 10:23:19', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12322, '111948', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 09:57:42', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.00', '43.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12321, '111949', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-26 10:00:13', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '87.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503731258', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12422, '112046', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 17:54:28', 'Paid', NULL, '25.90', '28.50', '28.50', NULL, '100.00', '71.50', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12419, '112043', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 17:42:03', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12420, '112042', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 16:55:23', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12421, '112045', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 17:53:04', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.40', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12415, '112041', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 16:50:28', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12416, '112040', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 16:28:53', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '87.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12417, '112039', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 16:13:51', 'Paid', NULL, '12.00', '11.90', '11.90', NULL, '50.00', '38.10', '0.00', '0.00', '1.32', '0.02', 'Cash', NULL, '27', '1503814520', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12418, '112044', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 17:51:12', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12413, '112036', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 15:26:17', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12414, '112037', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 15:38:20', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.40', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12411, '112028', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 14:16:18', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12410, '112027', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 14:15:55', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12409, '112038', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 16:05:40', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12408, '112035', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 15:18:31', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12412, '112032', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 14:42:44', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '29.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12399, '112021', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 13:36:09', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12400, '112018', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 13:04:56', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1503814520', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12401, '112025', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 14:04:03', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12402, '112029', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 14:28:30', 'Paid', NULL, '54.00', '53.45', '53.45', NULL, '60.00', '6.55', '0.00', '0.00', '5.94', '-0.01', 'Cash', NULL, '27', '1503814520', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12403, '112026', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 14:13:36', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.10', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12404, '112030', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 14:29:49', 'Paid', NULL, '135.00', '148.50', '148.50', NULL, '150.00', '1.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12405, '112023', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 13:40:53', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12406, '112034', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 15:01:16', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '50.00', '35.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12407, '112031', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 14:41:17', 'Paid', NULL, '169.00', '185.90', '185.90', NULL, '200.00', '14.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12396, '112022', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 13:36:39', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '100.00', '47.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12397, '112033', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 14:52:15', 'Paid', NULL, '93.00', '102.30', '102.30', NULL, '105.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12395, '112020', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 13:10:26', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12371, '112000', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 11:15:50', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '100.00', '49.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12372, '112002', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 11:25:28', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.10', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12394, '112019', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 13:05:29', 'Paid', NULL, '32.90', '36.20', '36.20', NULL, '50.20', '14.00', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12384, '112008', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 11:56:18', 'Paid', NULL, '112.00', '123.20', '123.20', NULL, '123.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12385, '112007', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 11:55:14', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '100.50', '95.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12386, '112013', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 12:37:18', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.00', '7.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12387, '112011', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 12:26:28', 'Paid', NULL, '93.00', '102.30', '102.30', NULL, '110.00', '7.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12388, '112016', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 12:46:29', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '105.00', '40.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12389, '112014', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 12:39:24', 'Paid', NULL, '109.00', '119.90', '119.90', NULL, '120.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12390, '112009', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 12:14:29', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '39.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12391, '112015', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 12:40:30', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '63.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12392, '112017', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 13:00:19', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12393, '112024', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 13:46:46', 'Paid', NULL, '41.00', '40.60', '40.60', NULL, '51.00', '10.40', '0.00', '0.00', '4.51', '0.01', 'Cash', NULL, '27', '1503814520', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12383, '112012', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 12:33:40', 'Paid', NULL, '96.00', '95.05', '95.05', NULL, '105.10', '10.05', '0.00', '0.00', '10.56', '0.01', 'Cash', NULL, '27', '1503814520', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12382, '111999', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 11:07:04', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.20', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12374, '112003', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 11:26:25', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12376, '111989', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 10:55:26', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '28.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12377, '111990', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 10:56:06', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '28.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12378, '111991', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 10:57:15', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '27.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12379, '111992', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 10:57:46', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12380, '111993', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 10:58:10', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '51.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12375, '112004', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 11:27:46', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12373, '111995', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 11:02:57', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12370, '111994', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 11:00:45', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12369, '112005', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 11:33:49', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '55.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12368, '112001', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 11:17:05', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '70.00', '7.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12367, '111997', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 11:05:05', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12366, '112010', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 12:16:17', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '61.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12381, '112006', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 11:37:32', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12365, '111996', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 11:03:38', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12359, '111986', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 10:30:38', 'Paid', NULL, '122.00', '134.20', '134.20', NULL, '134.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12363, '111988', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 10:51:43', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '70.00', '8.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12362, '111998', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 11:06:03', 'Paid', NULL, '151.00', '166.10', '166.10', NULL, '200.10', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12361, '111987', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 10:37:05', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.00', '21.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12360, '111985', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 10:16:55', 'Paid', NULL, '143.00', '157.30', '157.30', NULL, '200.30', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12358, '111984', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 10:02:32', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.00', '20.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12357, '111983', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-27 09:41:31', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503814520', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12453, '112075', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 17:44:09', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12454, '112076', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 18:34:17', 'Paid', NULL, '63.00', '62.35', '62.35', NULL, '65.00', '2.65', '0.00', '0.00', '6.93', '-0.02', 'Cash', NULL, '27', '1503898703', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12440, '112062', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 14:14:05', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12441, '112060', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 14:10:26', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.00', '29.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12442, '112067', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 14:38:28', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12443, '112069', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 15:10:56', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12444, '112063', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 14:24:13', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '21.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12445, '112070', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 15:25:45', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '20.00', '12.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12449, '112066', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 14:33:58', 'Paid', NULL, '21.00', '18.90', '18.90', NULL, '50.00', '31.10', '0.00', '0.00', '2.10', '0.00', 'Cash', NULL, '27', '1503898703', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12447, '112068', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 15:09:45', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.30', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(12448, '112064', 'T1(S)(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 14:29:19', 'Paid', NULL, '13.90', '15.30', '15.30', NULL, '20.00', '4.70', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12450, '112071', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 15:42:41', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12451, '112074', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 16:35:57', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12431, '112053', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 12:50:36', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12432, '112065', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 14:30:10', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '8.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12433, '112054', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 12:51:19', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12434, '112055', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 12:51:42', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12452, '112072', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 15:52:03', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12439, '112073', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 15:52:36', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '60.00', '8.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12438, '112058', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 13:57:18', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.00', '21.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12435, '112056', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 12:51:58', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12437, '112061', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 14:12:20', 'Paid', NULL, '48.00', '47.50', '47.50', NULL, '100.00', '52.50', '0.00', '0.00', '5.28', '-0.02', 'Cash', NULL, '27', '1503898703', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12436, '112059', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 14:02:05', 'Paid', NULL, '101.00', '111.10', '111.10', NULL, '120.00', '8.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12430, '112051', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 12:20:25', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12425, '112050', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 12:18:37', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12428, '112052', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 12:47:52', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12427, '112057', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 12:53:44', 'Paid', NULL, '65.90', '72.50', '72.50', NULL, '72.50', '0.00', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12426, '112049', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 11:13:39', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12424, '112048', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 10:41:00', 'Paid', NULL, '118.00', '129.80', '129.80', NULL, '150.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12423, '112047', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-28 10:10:19', 'Paid', NULL, '98.00', '107.80', '107.80', NULL, '107.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1503898703', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12465, '112089', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-30 13:55:35', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.10', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504070318', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12466, '112088', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-08-30 13:23:38', 'Paid', NULL, '138.00', '151.80', '151.80', NULL, '151.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504070318', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12467, '112087', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-30 13:05:57', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504070318', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12468, '112090', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-30 14:28:58', 'Paid', NULL, '496.60', '546.25', '546.25', NULL, '550.00', '3.75', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1504070318', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12469, '112091', 'T10', 10008, 'lois', NULL, NULL, 'history', '2017-08-30 15:14:37', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504070318', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12463, '112084', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-30 11:50:45', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504070318', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12462, '112085', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-30 11:54:31', 'Paid', NULL, '150.00', '165.00', '165.00', NULL, '200.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504070318', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12470, '112092', 'T10', 10008, 'lois', NULL, NULL, 'history', '2017-08-30 17:20:33', 'Paid', NULL, '14.00', '13.85', '13.85', NULL, '15.05', '1.20', '0.00', '0.00', '1.54', '-0.01', 'Cash', NULL, '27', '1504070318', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12464, '112086', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-30 12:36:13', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '100.00', '83.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504070318', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12461, '112083', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-30 11:29:41', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.20', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504070318', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12460, '112081', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-30 11:07:49', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504070318', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12459, '112079', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-30 10:58:36', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504070318', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12457, '112080', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-30 11:04:50', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504070318', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12458, '112082', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-30 11:13:42', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504070318', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12456, '112078', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-30 10:39:45', 'Paid', NULL, '111.00', '122.10', '122.10', NULL, '122.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504070318', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12455, '112077', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-30 09:43:09', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '50.00', '31.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504070318', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12520, '112141', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 18:04:55', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '21.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12514, '112135', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 16:48:56', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.50', '5.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12515, '112140', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 18:03:04', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12516, '112138', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 17:34:30', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '50.70', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12517, '112142', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 18:06:30', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12518, '112137', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 17:26:06', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12519, '112139', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 17:43:14', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12509, '112131', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 15:55:14', 'Paid', NULL, '47.00', '46.55', '46.55', NULL, '47.00', '0.45', '0.00', '0.00', '5.17', '0.02', 'Cash', NULL, '27', '1504161458', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12511, '112133', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 16:22:20', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12512, '112132', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 16:07:40', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12513, '112136', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 16:58:00', 'Paid', NULL, '268.90', '295.80', '295.80', NULL, '300.00', '4.20', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12510, '112134', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 16:28:27', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12504, '112123', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 13:57:18', 'Paid', NULL, '21.00', '18.90', '18.90', NULL, '20.00', '1.10', '0.00', '0.00', '2.10', '0.00', 'Cash', NULL, '27', '1504161458', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12505, '112127', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 14:36:38', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12506, '112129', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 15:37:12', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '15.20', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12507, '112128', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 14:37:57', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '20.00', '10.10', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1504161458', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12508, '112130', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 15:52:23', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12499, '112119', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 13:34:56', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12500, '112124', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 14:24:29', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12501, '112120', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 13:50:47', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12502, '112126', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 14:35:47', 'Paid', NULL, '92.00', '101.20', '101.20', NULL, '101.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12503, '112122', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 13:56:51', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12498, '112125', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 14:33:43', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.30', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12494, '112111', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 12:48:02', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '25.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12495, '112116', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 13:10:52', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '74.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12496, '112117', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 13:16:37', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12497, '112121', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 13:56:00', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12473, '112095', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 10:08:58', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12475, '112099', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 10:26:20', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12476, '112093', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 09:45:01', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12477, '112109', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 11:52:05', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '80.00', '7.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12478, '112096', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 10:13:38', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '100.10', '77.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12479, '112097', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 10:15:02', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12480, '112104', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 11:18:40', 'Paid', NULL, '114.00', '125.40', '125.40', NULL, '150.40', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12481, '112106', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 11:39:42', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.20', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12482, '112105', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 11:23:13', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12483, '112101', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 10:46:27', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.30', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12484, '112103', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 10:56:44', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12485, '112102', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 10:56:06', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.40', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12486, '112107', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 11:45:54', 'Paid', NULL, '109.00', '119.90', '119.90', NULL, '120.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12487, '112108', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 11:50:04', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '45.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12488, '112110', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 12:03:33', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '63.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12489, '112114', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 12:59:13', 'Paid', NULL, '150.00', '165.00', '165.00', NULL, '170.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12490, '112115', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 13:08:31', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12491, '112112', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 12:56:19', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12492, '112113', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 12:58:57', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12493, '112118', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 13:20:02', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12474, '112098', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 10:15:27', 'Paid', NULL, '105.00', '115.50', '115.50', NULL, '120.00', '4.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12472, '112094', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 10:01:54', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '105.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12471, '112100', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-08-31 10:27:21', 'Paid', NULL, '136.00', '149.60', '149.60', NULL, '150.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504161458', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12557, '112185', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 17:18:42', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '28.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12558, '112175', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 15:57:48', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12561, '112186', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 17:27:30', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '50.00', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12560, '112176', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 16:11:36', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '35.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12562, '112174', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 15:53:41', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12563, '112180', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 16:42:33', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '34.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12569, '112182', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 17:00:22', 'Paid', NULL, '4.00', '4.00', '4.00', NULL, '50.00', '46.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12565, '112177', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 16:15:35', 'Paid', NULL, '10.00', '9.00', '9.00', NULL, '20.00', '11.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1504251976', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12566, '112183', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 17:03:23', 'Paid', NULL, '36.90', '40.60', '40.60', NULL, '50.00', '9.40', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12567, '112178', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 16:28:16', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '100.30', '75.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12568, '112184', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 17:07:31', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12552, '112170', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 14:45:40', 'Paid', NULL, '96.00', '105.60', '105.60', NULL, '150.00', '44.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12553, '112169', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 14:32:44', 'Paid', NULL, '24.00', '23.75', '23.75', NULL, '50.00', '26.25', '0.00', '0.00', '2.64', '-0.01', 'Cash', NULL, '27', '1504251976', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12554, '112171', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 15:26:27', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.10', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12555, '112172', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 15:27:18', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12556, '112173', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 15:46:40', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '80.00', '5.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12551, '112179', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 16:37:16', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '53.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12539, '112159', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 12:44:39', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12540, '112160', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 12:52:00', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '70.00', '10.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12541, '112165', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 13:58:09', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12544, '112163', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 13:13:20', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12545, '112164', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 13:46:11', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.40', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12546, '112166', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 14:06:20', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '72.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12547, '112162', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 13:06:06', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '100.00', '48.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12548, '112167', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 14:10:01', 'Paid', NULL, '182.00', '200.20', '200.20', NULL, '200.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12549, '112181', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 16:48:21', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '47.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12550, '112168', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 14:25:52', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12523, '112144', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 09:55:01', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '50.00', '42.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12524, '112146', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 10:20:28', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '53.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12525, '112143', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 09:51:43', 'Paid', NULL, '35.00', '34.65', '34.65', NULL, '50.65', '16.00', '0.00', '0.00', '3.85', '0.00', 'Cash', NULL, '27', '1504251976', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12526, '112148', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 10:49:39', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12527, '112149', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 11:06:53', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12528, '112154', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 11:52:27', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '88.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12529, '112147', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 10:47:30', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12530, '112157', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 12:28:36', 'Paid', NULL, '207.00', '227.70', '227.70', NULL, '228.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12531, '112151', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 11:28:07', 'Paid', NULL, '37.00', '36.65', '36.65', NULL, '50.00', '13.35', '0.00', '0.00', '4.07', '0.02', 'Cash', NULL, '27', '1504251976', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12543, '112158', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 12:37:32', 'Paid', NULL, '18.70', '18.70', '18.70', NULL, '18.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12533, '112153', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 11:50:42', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12534, '112152', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 11:49:18', 'Paid', NULL, '63.50', '69.85', '69.85', NULL, '70.00', '0.15', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12535, '112155', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 12:12:09', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12538, '112156', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 12:27:30', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12537, '112161', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 12:53:56', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12522, '112145', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 10:10:04', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12521, '112150', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-01 11:11:03', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.00', '21.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504251976', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12603, '112221', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 16:38:42', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12604, '112219', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 16:16:49', 'Paid', NULL, '16.00', '14.40', '14.40', NULL, '15.00', '0.60', '0.00', '0.00', '1.60', '0.00', 'Cash', NULL, '27', '1504324863', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12605, '112220', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 16:36:55', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12598, '112215', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 14:22:40', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.00', '41.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12599, '112217', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 15:05:19', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12600, '112216', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 14:29:48', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '21.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12601, '112222', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 16:46:07', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '72.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12602, '112218', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 15:35:37', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '17.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12597, '112210', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 13:22:11', 'Paid', NULL, '16.00', '14.40', '14.40', NULL, '50.00', '35.60', '0.00', '0.00', '1.60', '0.00', 'Cash', NULL, '27', '1504324863', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12572, '112192', 'T4', 10010, 'sanni', NULL, NULL, 'history', '2017-09-02 10:25:27', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12573, '112188', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2017-09-02 09:54:51', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '40.00', '4.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12574, '112190', 'T1', 10010, 'sanni', NULL, NULL, 'history', '2017-09-02 10:17:02', 'Paid', NULL, '128.00', '140.80', '140.80', NULL, '150.80', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12575, '112194', 'T6', 10010, 'sanni', NULL, NULL, 'history', '2017-09-02 10:55:28', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.00', '29.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12577, '112197', 'T5', 10010, 'sanni', NULL, NULL, 'history', '2017-09-02 11:17:47', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12578, '112196', 'T3', 10010, 'sanni', NULL, NULL, 'history', '2017-09-02 10:58:10', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12579, '112195', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 10:56:57', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.40', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12580, '112193', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 10:41:15', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(12581, '112198', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 11:19:56', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12582, '112199', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 11:21:36', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '45.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12583, '112200', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 11:57:22', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12584, '112203', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 12:39:17', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12585, '112202', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 12:19:08', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.60', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12586, '112214', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 13:47:15', 'Paid', NULL, '101.00', '111.10', '111.10', NULL, '120.10', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12587, '112204', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 12:46:04', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.30', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12588, '112213', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 13:31:51', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '54.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12589, '112205', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 12:48:24', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12590, '112208', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 13:00:37', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '90.10', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12591, '112206', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 12:50:39', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12592, '112209', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 13:12:53', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12593, '112201', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 12:14:38', 'Paid', NULL, '12.00', '10.80', '10.80', NULL, '20.00', '9.20', '0.00', '0.00', '1.20', '0.00', 'Cash', NULL, '27', '1504324863', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12594, '112211', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 13:23:47', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '100.00', '73.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12595, '112207', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 12:56:30', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.30', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12596, '112212', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-02 13:27:11', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12576, '112191', 'T10', 10010, 'sanni', NULL, NULL, 'history', '2017-09-02 10:20:02', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12571, '112189', 'T7', 10010, 'sanni', NULL, NULL, 'history', '2017-09-02 10:11:49', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12570, '112187', 'T6', 10010, 'sanni', NULL, NULL, 'history', '2017-09-02 09:46:37', 'Paid', NULL, '117.00', '128.70', '128.70', NULL, '132.00', '3.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504324863', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12635, '112258', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 16:11:44', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '78.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12636, '112247', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 14:15:04', 'Paid', NULL, '21.00', '18.90', '18.90', NULL, '20.00', '1.10', '0.00', '0.00', '2.10', '0.00', 'Cash', NULL, '27', '1504414860', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12637, '112254', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 15:43:13', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.60', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12638, '112255', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 15:48:38', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '49.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12639, '112251', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 15:21:37', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12640, '112256', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 15:59:17', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '100.00', '68.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12641, '112257', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 16:02:10', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '50.00', '40.10', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1504414860', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12634, '112244', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 13:58:48', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.50', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12633, '112252', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 15:38:34', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '64.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12612, '112236', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 11:59:32', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '64.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12613, '112228', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 11:21:37', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12614, '112230', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 11:23:33', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12615, '112229', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 11:22:17', 'Paid', NULL, '67.00', '66.35', '66.35', NULL, '100.00', '33.65', '0.00', '0.00', '7.37', '0.02', 'Cash', NULL, '27', '1504414860', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12616, '112231', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 11:31:56', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '100.00', '51.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12617, '112248', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 14:19:56', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12609, '112226', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 11:01:04', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12610, '112227', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 11:13:32', 'Paid', NULL, '205.00', '225.50', '225.50', NULL, '225.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12611, '112233', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 11:41:47', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12608, '112225', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 10:22:49', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.40', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12632, '112240', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 13:03:50', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12631, '112250', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 14:38:47', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '100.60', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12630, '112249', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 14:21:34', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12629, '112246', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 14:12:13', 'Paid', NULL, '116.00', '127.60', '127.60', NULL, '150.00', '22.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12628, '112243', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 13:39:08', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '100.00', '48.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12627, '112242', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 13:21:08', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.50', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12626, '112245', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 13:59:37', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12625, '112238', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 12:59:12', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '36.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12624, '112241', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 13:10:10', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '89.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12623, '112253', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 15:38:49', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12622, '112239', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 13:03:32', 'Paid', NULL, '99.00', '108.90', '108.90', NULL, '108.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12621, '112235', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 11:54:33', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12620, '112234', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 11:49:25', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12619, '112237', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 12:38:47', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '80.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12618, '112232', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 11:40:09', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12607, '112223', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 09:46:51', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12606, '112224', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-03 10:02:05', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '64.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504414860', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12651, '112266', 'T12', 10008, 'lois', NULL, NULL, 'history', '2017-09-04 11:50:36', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12659, '112280', 'T4', 10008, 'lois', NULL, NULL, 'history', '2017-09-04 13:51:38', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '100.00', '8.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12653, '112269', 'T15', 10008, 'lois', NULL, NULL, 'history', '2017-09-04 12:15:54', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12654, '112263', 'T11', 10008, 'lois', NULL, NULL, 'history', '2017-09-04 11:23:59', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12655, '112271', 'T2', 10008, 'lois', NULL, NULL, 'history', '2017-09-04 12:31:28', 'Paid', NULL, '92.00', '101.20', '101.20', NULL, '101.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12656, '112273', 'T11', 10008, 'lois', NULL, NULL, 'history', '2017-09-04 12:34:07', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12657, '112278', 'T14', 10008, 'lois', NULL, NULL, 'history', '2017-09-04 13:06:41', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '75.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12658, '112270', 'T6', 10008, 'lois', NULL, NULL, 'history', '2017-09-04 12:16:26', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12660, '112276', 'T8', 10008, 'lois', NULL, NULL, 'history', '2017-09-04 12:54:54', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12661, '112277', 'T7', 10008, 'lois', NULL, NULL, 'history', '2017-09-04 12:56:36', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '60.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12662, '112275', 'T5', 10008, 'lois', NULL, NULL, 'history', '2017-09-04 12:47:29', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12663, '112279', 'T12', 10008, 'lois', NULL, NULL, 'history', '2017-09-04 13:27:02', 'Paid', NULL, '137.00', '150.70', '150.70', NULL, '150.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12664, '112274', 'T10', 10008, 'lois', NULL, NULL, 'history', '2017-09-04 12:45:08', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.00', '37.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12665, '112281', 'T1', 10008, 'lois', NULL, NULL, 'history', '2017-09-04 14:15:08', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12666, '112282', 'T4', 10008, 'lois', NULL, NULL, 'history', '2017-09-04 14:38:31', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '49.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12667, '112285', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-04 16:22:39', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.90', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12668, '112283', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-04 15:53:54', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12669, '112284', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-04 15:59:13', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12670, '112289', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-04 16:41:41', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '74.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12671, '112286', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-04 16:25:31', 'Paid', NULL, '97.00', '106.70', '106.70', NULL, '110.00', '3.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12672, '112290', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-04 16:43:16', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '55.20', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12673, '112291', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-04 17:20:14', 'Paid', NULL, '44.00', '43.55', '43.55', NULL, '50.00', '6.45', '0.00', '0.00', '4.84', '-0.01', 'Cash', NULL, '27', '1504506284', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12674, '112288', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-04 16:37:45', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12675, '112287', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-09-04 16:34:58', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12650, '112265', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-04 11:43:05', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12644, '112261', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-04 10:24:09', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '21.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12647, '112264', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-04 11:24:46', 'Paid', NULL, '92.00', '101.20', '101.20', NULL, '102.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12646, '112267', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-04 12:05:13', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '40.00', '11.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12645, '112262', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-04 11:15:14', 'Paid', NULL, '156.00', '154.45', '154.45', NULL, '160.00', '5.55', '0.00', '0.00', '17.16', '0.01', 'Cash', NULL, '27', '1504506284', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12648, '112272', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-09-04 12:33:36', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '100.00', '81.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12649, '112268', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-04 12:08:05', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12643, '112260', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-04 10:22:23', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '40.10', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12642, '112259', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-09-04 10:08:00', 'Paid', NULL, '131.00', '144.10', '144.10', NULL, '150.00', '5.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504506284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12691, '112307', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-06 17:09:21', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504660309', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12692, '112306', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-06 16:58:42', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504660309', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12693, '112305', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-06 16:22:59', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '15.00', '2.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504660309', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12685, '112302', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-06 13:53:17', 'Paid', NULL, '44.00', '43.55', '43.55', NULL, '50.00', '6.45', '0.00', '0.00', '4.84', '-0.01', 'Cash', NULL, '27', '1504660309', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12689, '112304', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-06 15:59:52', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504660309', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12687, '112299', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-06 13:01:04', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504660309', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12688, '112300', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-06 13:12:12', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504660309', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12678, '112292', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-06 10:47:01', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504660309', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12679, '112295', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-06 11:26:10', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504660309', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12680, '112296', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-06 11:27:04', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504660309', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12681, '112298', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-06 12:48:58', 'Paid', NULL, '47.00', '46.55', '46.55', NULL, '50.00', '3.45', '0.00', '0.00', '5.17', '0.02', 'Cash', NULL, '27', '1504660309', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12682, '112297', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-06 12:03:02', 'Paid', NULL, '13.50', '14.85', '14.85', NULL, '15.00', '0.15', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504660309', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12683, '112301', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-09-06 13:23:13', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '100.00', '73.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504660309', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12690, '112303', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-06 15:27:13', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.20', '33.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504660309', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12677, '112294', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-06 11:19:50', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504660309', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12676, '112293', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-06 11:08:04', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '101.00', '25.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504660309', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12696, '112309', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-07 10:29:59', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504761354', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12697, '112311', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-07 12:11:14', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504761354', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12698, '112310', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-07 11:20:45', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504761354', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12699, '112315', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-07 13:01:08', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '70.00', '11.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504761354', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12700, '112312', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-07 12:29:16', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504761354', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12701, '112322', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-07 14:58:35', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504761354', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12702, '112313', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-07 12:31:11', 'Paid', NULL, '23.00', '22.75', '22.75', NULL, '22.75', '0.00', '0.00', '0.00', '2.53', '-0.02', 'Cash', NULL, '27', '1504761354', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12703, '112316', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-07 13:24:52', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504761354', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12704, '112317', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-09-07 13:27:01', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '18.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504761354', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12705, '112318', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-07 13:50:15', 'Paid', NULL, '49.00', '48.50', '48.50', NULL, '50.00', '1.50', '0.00', '0.00', '5.39', '-0.01', 'Cash', NULL, '27', '1504761354', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12706, '112319', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-07 13:50:51', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504761354', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12707, '112320', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-07 14:04:46', 'Paid', NULL, '19.00', '18.80', '18.80', NULL, '23.00', '4.20', '0.00', '0.00', '2.09', '-0.01', 'Cash', NULL, '27', '1504761354', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12708, '112321', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-07 14:38:23', 'Paid', NULL, '10.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1504761354', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12709, '112323', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-07 15:48:10', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '52.00', '9.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504761354', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12710, '112324', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-07 16:53:10', 'Paid', NULL, '32.00', '31.70', '31.70', NULL, '50.00', '18.30', '0.00', '0.00', '3.52', '0.02', 'Cash', NULL, '27', '1504761354', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12695, '112314', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-07 12:46:03', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '50.00', '29.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504761354', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12694, '112308', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-07 09:52:31', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '50.00', '31.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504761354', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12713, '112328', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-08 12:01:22', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504831437', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12714, '112327', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-09-08 11:45:58', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504831437', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12715, '112329', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-08 12:47:35', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504831437', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12716, '112331', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-08 12:54:34', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '36.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504831437', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12717, '112332', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-08 13:09:41', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504831437', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12718, '112330', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-08 12:49:19', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504831437', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12719, '112334', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-08 14:37:29', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '51.00', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504831437', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12720, '112333', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-08 14:35:59', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '50.00', '29.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504831437', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12721, '112335', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-08 14:38:18', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '51.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504831437', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12722, '112336', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-08 15:28:57', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '100.30', '53.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504831437', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12723, '112337', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-08 15:42:13', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504831437', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12725, '112338', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-09-08 17:17:37', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '7.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504831437', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12712, '112326', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-08 11:38:00', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504831437', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12711, '112325', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-08 11:30:12', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '61.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504831437', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12769, '112380', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 17:24:27', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '47.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12765, '112379', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 16:37:10', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '53.10', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12766, '112377', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 15:38:04', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12767, '112378', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 16:01:42', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '100.00', '83.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12768, '112381', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 17:39:07', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '53.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12761, '112375', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 15:27:55', 'Paid', NULL, '24.00', '21.10', '21.10', NULL, '25.10', '4.00', '0.00', '0.00', '5.28', '-0.02', 'Cash', NULL, '27', '1504949053', 'p', '20', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12762, '112373', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 15:11:10', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.30', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12763, '112372', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 15:03:23', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12764, '112376', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 15:37:48', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '17.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12760, '112370', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 14:18:42', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '101.50', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12759, '112368', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 13:50:58', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12758, '112374', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 15:19:59', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(12757, '112371', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 14:19:52', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12756, '112367', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 13:38:34', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '54.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12755, '112366', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 13:17:20', 'Paid', NULL, '25.50', '28.05', '28.05', NULL, '50.10', '22.05', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12754, '112369', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 13:51:57', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12753, '112364', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 13:04:01', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12752, '112360', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 12:40:58', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12751, '112365', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 13:09:22', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12750, '112359', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 12:40:10', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.20', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12749, '112362', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 12:53:58', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '70.00', '9.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12748, '112358', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 12:34:21', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12747, '112363', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 12:57:12', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12746, '112350', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 11:29:54', 'Paid', NULL, '16.00', '15.85', '15.85', NULL, '20.00', '4.15', '0.00', '0.00', '1.76', '0.01', 'Cash', NULL, '27', '1504949053', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12745, '112357', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 12:23:00', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12744, '112356', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 12:17:34', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '71.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12743, '112352', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 11:43:39', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12742, '112354', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 11:45:42', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12741, '112351', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 11:34:25', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12740, '112347', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 11:11:07', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12739, '112355', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 11:57:49', 'Paid', NULL, '152.00', '167.20', '167.20', NULL, '200.20', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12738, '112345', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 10:59:55', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '41.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12737, '112348', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 11:16:43', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '72.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12736, '112349', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 11:24:17', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12729, '112340', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 10:07:14', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '100.00', '49.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12730, '112342', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 10:11:02', 'Paid', NULL, '103.00', '113.30', '113.30', NULL, '150.00', '36.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12731, '112344', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 10:48:51', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.20', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12732, '112343', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 10:34:17', 'Paid', NULL, '167.50', '184.25', '184.25', NULL, '185.00', '0.75', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12733, '112353', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 11:44:02', 'Paid', NULL, '127.00', '139.70', '139.70', NULL, '150.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12734, '112346', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 11:09:03', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '101.00', '11.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12735, '112361', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 12:46:40', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12728, '112341', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 10:10:02', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12727, '112339', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-09 09:50:19', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1504949053', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12806, '112419', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 17:28:45', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '52.00', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12807, '112415', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 16:48:05', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12808, '112417', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 17:26:29', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.20', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12809, '112420', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 17:38:53', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '25.00', '1.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12805, '112413', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 16:16:19', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '99.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12804, '112414', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 16:18:51', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12803, '112416', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 17:25:42', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '30.00', '4.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12802, '112418', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 17:27:22', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12801, '112411', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 14:55:39', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '50.00', '40.10', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1505025773', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12797, '112408', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 14:02:24', 'Paid', NULL, '230.00', '253.00', '253.00', NULL, '253.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12799, '112410', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 14:19:00', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12800, '112412', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 15:19:39', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '105.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12793, '112405', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 13:21:52', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12794, '112404', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 13:19:59', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '52.00', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12795, '112406', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 13:36:07', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12796, '112409', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 14:13:55', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12792, '112401', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 12:38:57', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12774, '112387', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 10:20:13', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12776, '112388', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 10:41:51', 'Paid', NULL, '145.00', '159.50', '159.50', NULL, '160.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12777, '112390', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 11:00:50', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12778, '112389', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 10:55:25', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12779, '112391', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 11:23:10', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12780, '112392', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 11:26:43', 'Paid', NULL, '138.00', '151.80', '151.80', NULL, '155.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12781, '112398', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 12:24:33', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '53.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12782, '112394', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 11:44:51', 'Paid', NULL, '99.00', '108.90', '108.90', NULL, '110.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12783, '112395', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 11:48:41', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '100.00', '49.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12784, '112393', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 11:39:33', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '70.20', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12785, '112402', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 12:48:54', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '34.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12786, '112396', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 12:07:05', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '53.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12787, '112399', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 12:33:07', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '64.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12788, '112397', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 12:08:29', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12789, '112403', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 12:50:52', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12790, '112400', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 12:33:30', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12791, '112407', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 14:00:36', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12775, '112383', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 09:45:45', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12773, '112385', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 10:00:25', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '53.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12772, '112386', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 10:06:38', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '55.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12771, '112382', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 09:43:04', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12770, '112384', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-10 09:56:38', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505025773', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12847, '112458', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 17:51:40', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12842, '112453', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 15:39:10', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12843, '112454', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 16:20:03', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '40.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12844, '112455', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 16:24:47', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.20', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12845, '112452', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 15:17:17', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12846, '112457', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 17:20:55', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '40.00', '1.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12840, '112449', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 14:59:43', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12841, '112447', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 14:28:22', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.40', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12839, '112448', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 14:37:21', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12837, '112443', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 14:06:42', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12838, '112442', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 14:05:05', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12815, '112428', 'T3', 10008, 'lois', NULL, NULL, 'history', '2017-09-11 11:26:56', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12825, '112437', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 12:55:32', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12826, '112436', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 12:41:02', 'Paid', NULL, '125.00', '137.50', '137.50', NULL, '150.50', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12827, '112431', 'T14(S)', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 12:01:31', 'Paid', NULL, '12.50', '13.75', '13.75', NULL, '20.00', '6.25', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12824, '112433', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 12:05:29', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.00', '4.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12816, '112424', 'T5', 10008, 'lois', NULL, NULL, 'history', '2017-09-11 10:52:19', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12817, '112430', 'T4', 10008, 'lois', NULL, NULL, 'history', '2017-09-11 11:47:56', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12818, '112435', 'T14', 10008, 'lois', NULL, NULL, 'history', '2017-09-11 12:35:17', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '50.00', '33.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12819, '112425', 'T8', 10008, 'lois', NULL, NULL, 'history', '2017-09-11 10:54:49', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '20.00', '12.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12820, '112429', 'T15', 10008, 'lois', NULL, NULL, 'history', '2017-09-11 11:31:01', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '105.00', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12821, '112434', 'T2', 10008, 'lois', NULL, NULL, 'history', '2017-09-11 12:06:47', 'Paid', NULL, '131.00', '144.10', '144.10', NULL, '150.00', '5.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12822, '112446', 'T6', 10008, 'lois', NULL, NULL, 'history', '2017-09-11 14:20:12', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '70.00', '8.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12823, '112432', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 12:02:25', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12828, '112438', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 13:10:02', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12829, '112450', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 15:13:54', 'Paid', NULL, '98.00', '107.80', '107.80', NULL, '150.00', '42.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12830, '112444', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 14:16:34', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.00', '20.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12831, '112439', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 13:33:43', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12832, '112440', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 13:41:11', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12833, '112445', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 14:19:55', 'Paid', NULL, '51.00', '50.50', '50.50', NULL, '51.00', '0.50', '0.00', '0.00', '5.61', '0.01', 'Cash', NULL, '27', '1505109385', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12834, '112441', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 13:57:16', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.30', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12835, '112456', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 17:11:15', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12836, '112451', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-11 15:15:28', 'Paid', NULL, '25.00', '24.75', '24.75', NULL, '25.00', '0.25', '0.00', '0.00', '2.75', '0.00', 'Cash', NULL, '27', '1505109385', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12813, '112423', 'T2', 10008, 'lois', NULL, NULL, 'history', '2017-09-11 10:16:10', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12814, '112427', 'T6', 10008, 'lois', NULL, NULL, 'history', '2017-09-11 11:01:55', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '21.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12812, '112422', 'T4', 10008, 'lois', NULL, NULL, 'history', '2017-09-11 10:09:21', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '57.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12811, '112421', 'T3', 10008, 'lois', NULL, NULL, 'history', '2017-09-11 09:43:21', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12810, '112426', 'T7', 10008, 'lois', NULL, NULL, 'history', '2017-09-11 11:01:18', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.30', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505109385', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12854, '112463', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-13 11:43:59', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505276547', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12855, '112464', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-09-13 11:57:29', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.20', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505276547', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12865, '112473', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-13 15:09:10', 'Paid', NULL, '907.20', '907.20', '907.20', NULL, '910.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505276547', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12866, '112477', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-13 18:28:05', 'Paid', NULL, '284.00', '281.15', '281.15', NULL, '300.00', '18.85', '0.00', '0.00', '31.24', '-0.01', 'Cash', NULL, '27', '1505276547', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12867, '112476', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-13 17:46:46', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.00', '3.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505276547', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12856, '112465', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-13 12:22:40', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '105.20', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505276547', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12857, '112468', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-09-13 13:09:39', 'Paid', NULL, '158.00', '173.80', '173.80', NULL, '174.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505276547', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12858, '112469', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-13 13:18:48', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505276547', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12859, '112471', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-13 14:51:06', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '50.00', '29.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505276547', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12860, '112472', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-13 15:00:44', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.40', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505276547', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12862, '112470', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-13 14:01:07', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505276547', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12863, '112475', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-13 15:35:55', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '81.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505276547', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12864, '112474', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-13 15:32:15', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505276547', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12853, '112466', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-13 12:23:29', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '101.50', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505276547', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12851, '112467', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-13 12:52:11', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '102.00', '40.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505276547', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12852, '112462', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-13 11:41:51', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505276547', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12850, '112460', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-13 10:54:42', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505276547', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12849, '112459', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-13 10:39:28', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505276547', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12848, '112461', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-13 11:29:11', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505276547', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12891, '112502', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 15:36:57', 'Paid', NULL, '47.90', '47.40', '47.40', NULL, '50.00', '2.60', '0.00', '0.00', '5.27', '-0.02', 'Cash', NULL, '27', '1505366253', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12892, '112495', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 14:08:19', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12893, '112498', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 14:33:56', 'Paid', NULL, '3.90', '3.90', '3.90', NULL, '4.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12894, '112504', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 16:02:05', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '56.30', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12895, '112506', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 16:12:42', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '102.70', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12896, '112503', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 15:59:18', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.00', '29.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12897, '112507', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 16:17:12', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.30', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12898, '112505', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 16:08:14', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.30', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12873, '112483', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 11:50:15', 'Paid', NULL, '127.00', '139.70', '139.70', NULL, '150.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12874, '112482', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 11:33:47', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12875, '112485', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 12:10:20', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12876, '112486', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 12:13:02', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12877, '112501', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 15:35:52', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.00', '15.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12878, '112484', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 11:51:15', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '15.10', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12879, '112487', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 12:27:32', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12880, '112491', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 13:34:37', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '75.70', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12881, '112489', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 13:20:13', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '52.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12882, '112490', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 13:26:36', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '41.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12883, '112496', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 14:15:10', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12884, '112492', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 13:36:34', 'Paid', NULL, '47.00', '46.55', '46.55', NULL, '50.00', '3.45', '0.00', '0.00', '5.17', '0.02', 'Cash', NULL, '27', '1505366253', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(12886, '112499', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 14:34:57', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12887, '112500', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 15:34:19', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '57.40', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12888, '112488', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 13:17:40', 'Paid', NULL, '12.00', '10.80', '10.80', NULL, '50.00', '39.20', '0.00', '0.00', '1.20', '0.00', 'Cash', NULL, '27', '1505366253', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12889, '112493', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 13:51:11', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12890, '112497', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 14:33:02', 'Paid', NULL, '112.00', '123.20', '123.20', NULL, '150.00', '26.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12872, '112494', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 14:05:03', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '45.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12871, '112480', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 11:24:36', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '45.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12870, '112479', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 10:58:51', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12869, '112478', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 10:48:42', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12868, '112481', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-14 11:32:43', 'Paid', NULL, '175.00', '192.50', '192.50', NULL, '200.00', '7.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505366253', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12914, '112521', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-15 16:21:17', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505458856', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12913, '112522', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-15 16:23:15', 'Paid', NULL, '115.00', '126.50', '126.50', NULL, '126.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505458856', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12912, '112518', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-15 15:13:53', 'Paid', NULL, '16.00', '14.40', '14.40', NULL, '20.00', '5.60', '0.00', '0.00', '1.60', '0.00', 'Cash', NULL, '27', '1505458856', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12911, '112519', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-15 15:31:07', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '50.00', '35.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505458856', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12910, '112515', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-15 14:56:41', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '50.00', '42.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505458856', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12909, '112520', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-15 15:52:24', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505458856', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12908, '112516', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-15 15:07:25', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505458856', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12907, '112517', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-15 15:08:34', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505458856', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12905, '112513', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-15 13:38:05', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505458856', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12906, '112511', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-15 12:54:35', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '27.00', '3.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505458856', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12904, '112512', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-15 13:35:54', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505458856', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12903, '112510', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-15 12:35:12', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '94.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505458856', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12902, '112523', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-15 16:33:02', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505458856', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12901, '112514', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-15 14:32:02', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505458856', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12900, '112508', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-15 12:15:27', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505458856', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12899, '112509', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-15 12:31:17', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505458856', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12953, '112558', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 16:52:31', 'Paid', NULL, '33.00', '29.70', '29.70', NULL, '29.70', '0.00', '0.00', '0.00', '3.30', '0.00', 'Cash', NULL, '27', '1505546718', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12954, '112559', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 17:19:50', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12951, '112557', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 16:46:29', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '100.00', '47.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12952, '112554', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 16:13:11', 'Paid', NULL, '92.75', '102.05', '102.05', NULL, '103.00', '0.95', '0.00', '0.00', NULL, '0.02', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12949, '112553', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 16:00:58', 'Paid', NULL, '125.00', '137.50', '137.50', NULL, '140.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12948, '112555', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 16:34:38', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12947, '112551', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 15:05:22', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12946, '112556', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 16:42:39', 'Paid', NULL, '62.00', '61.40', '61.40', NULL, '62.00', '0.60', '0.00', '0.00', '6.82', '0.02', 'Cash', NULL, '27', '1505546718', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12945, '112548', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 14:50:05', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12944, '112550', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 15:00:01', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.00', '29.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12940, '112546', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 14:13:34', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '47.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12941, '112549', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 14:54:58', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12942, '112547', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 14:24:53', 'Paid', NULL, '99.00', '108.90', '108.90', NULL, '150.00', '41.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12943, '112552', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 16:00:06', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '100.00', '6.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12939, '112545', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 13:57:05', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12938, '112544', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 13:32:11', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12937, '112543', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 13:12:03', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '45.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12936, '112542', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 12:53:58', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12935, '112541', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 12:50:59', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12934, '112536', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 11:43:11', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12933, '112538', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 12:04:11', 'Paid', NULL, '92.00', '101.20', '101.20', NULL, '101.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12931, '112535', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 11:27:18', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12932, '112539', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 12:08:34', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.00', '29.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12930, '112532', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 11:03:46', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12929, '112530', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 10:58:38', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(12928, '112534', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 11:26:34', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12926, '112537', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 11:46:09', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12927, '112533', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 11:11:34', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12921, '112527', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 10:41:49', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12922, '112531', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 10:58:44', 'Paid', NULL, '101.00', '111.10', '111.10', NULL, '111.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12920, '112540', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 12:11:16', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '100.10', '55.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12919, '112526', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 10:25:04', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12918, '112528', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 10:42:18', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12917, '112529', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 10:45:08', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '100.00', '8.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12916, '112525', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 09:52:53', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12915, '112524', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-16 09:47:43', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505546718', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13013, '112615', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 17:51:25', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13006, '112602', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 15:27:05', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1505629426', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13007, '112603', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 15:28:10', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13008, '112605', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 15:33:22', 'Paid', NULL, '3.90', '3.90', '3.90', NULL, '3.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13009, '112612', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 17:06:11', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13010, '112611', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 17:00:42', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.50', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13011, '112609', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 16:51:49', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '35.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13012, '112610', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 16:58:17', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13005, '112613', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 17:24:42', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '40.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13002, '112606', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 15:33:47', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13003, '112608', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 16:34:19', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '36.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13004, '112614', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 17:28:09', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '52.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13000, '112601', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 15:20:25', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13001, '112607', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 15:38:31', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12993, '112590', 'T11A(S)', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 13:41:59', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12995, '112595', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 14:10:59', 'Paid', NULL, '48.00', '47.50', '47.50', NULL, '50.00', '2.50', '0.00', '0.00', '5.28', '-0.02', 'Cash', NULL, '27', '1505629426', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12996, '112599', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 14:30:48', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12999, '112604', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 15:31:17', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12986, '112582', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 13:01:10', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12987, '112592', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 13:47:37', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12988, '112593', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 13:49:48', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12989, '112591', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 13:44:58', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12990, '112586', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 13:15:23', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12991, '112594', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 14:05:01', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12992, '112589', 'T11A(S)', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 13:41:40', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12983, '112584', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 13:09:51', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12984, '112597', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 14:14:41', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.00', '4.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12985, '112588', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 13:25:57', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '47.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12994, '112598', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 14:22:47', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12982, '112587', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 13:22:57', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12972, '112575', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 12:14:50', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12973, '112580', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 12:57:17', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '40.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12974, '112577', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 12:27:58', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12975, '112581', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 12:58:50', 'Paid', NULL, '134.00', '147.40', '147.40', NULL, '150.00', '2.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12976, '112579', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 12:37:01', 'Paid', NULL, '44.50', '48.95', '48.95', NULL, '50.00', '1.05', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12977, '112585', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 13:14:26', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '63.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12978, '112596', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 14:12:00', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12979, '112600', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 14:47:52', 'Paid', NULL, '182.00', '180.20', '180.20', NULL, '200.00', '19.80', '0.00', '0.00', '20.02', '0.02', 'Cash', NULL, '27', '1505629426', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12980, '112583', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 13:08:17', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12970, '112576', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 12:16:05', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '100.00', '5.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12971, '112578', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 12:31:38', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '69.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12968, '112572', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 11:54:22', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '100.00', '8.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12969, '112574', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 12:10:54', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '69.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12966, '112569', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 11:20:01', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '59.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12967, '112571', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 11:47:39', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '55.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12965, '112566', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 11:01:17', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12964, '112573', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 12:01:52', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12963, '112567', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 11:06:41', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '29.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12961, '112565', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 10:59:24', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '28.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12962, '112570', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 11:30:00', 'Paid', NULL, '134.00', '147.40', '147.40', NULL, '200.00', '52.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12960, '112564', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 10:56:24', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12959, '112568', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 11:13:50', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12958, '112562', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 10:22:44', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12957, '112563', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 10:30:18', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12956, '112561', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 10:22:07', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(12955, '112560', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-17 09:57:11', 'Paid', NULL, '112.00', '123.20', '123.20', NULL, '124.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505629426', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13034, '112636', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-18 16:57:29', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505708590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13035, '112635', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-18 16:37:32', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.00', '37.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505708590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13036, '112637', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-18 17:16:24', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '50.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505708590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13020, '112622', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-18 11:50:08', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '56.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505708590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13033, '112634', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-18 15:53:46', 'Paid', NULL, '32.00', '31.70', '31.70', NULL, '32.00', '0.30', '0.00', '0.00', '3.52', '0.02', 'Cash', NULL, '27', '1505708590', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13030, '112628', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-09-18 13:25:52', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.00', '15.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505708590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13032, '112631', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-18 13:41:32', 'Paid', NULL, '10.00', '9.00', '9.00', NULL, '50.00', '41.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1505708590', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13029, '112627', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-09-18 13:25:31', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505708590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13028, '112626', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-09-18 13:24:45', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '70.00', '8.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505708590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13027, '112632', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-18 13:52:49', 'Paid', NULL, '18.00', '17.80', '17.80', NULL, '100.00', '82.20', '0.00', '0.00', '1.98', '-0.02', 'Cash', NULL, '27', '1505708590', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13026, '112629', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-18 13:26:23', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505708590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13025, '112630', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-18 13:40:19', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505708590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13031, '112633', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-18 14:51:51', 'Paid', NULL, '40.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', '4.40', '0.00', 'Cash', NULL, '27', '1505708590', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13023, '112625', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-18 13:20:18', 'Paid', NULL, '104.00', '114.40', '114.40', NULL, '120.00', '5.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505708590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13021, '112623', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-18 12:26:00', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505708590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13022, '112624', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-18 13:17:05', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505708590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13019, '112621', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-18 11:15:32', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505708590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13018, '112620', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-18 11:07:52', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '59.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505708590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13017, '112619', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-18 10:51:55', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505708590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13016, '112617', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-18 10:35:58', 'Paid', NULL, '113.00', '124.30', '124.30', NULL, '150.00', '25.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505708590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13015, '112616', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-18 10:16:41', 'Paid', NULL, '129.00', '141.90', '141.90', NULL, '142.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505708590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13014, '112618', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-18 10:37:48', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505708590', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13046, '112648', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-20 12:45:48', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505893878', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13047, '112646', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-20 12:39:48', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505893878', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13048, '112651', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-20 13:35:53', 'Paid', NULL, '43.00', '42.55', '42.55', NULL, '42.55', '0.00', '0.00', '0.00', '4.73', '-0.02', 'Cash', NULL, '27', '1505893878', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13049, '112650', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-09-20 13:03:05', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '100.00', '60.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505893878', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13050, '112652', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-20 14:08:58', 'Paid', NULL, '119.00', '130.90', '130.90', NULL, '150.00', '19.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505893878', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13051, '112650', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-20 13:29:04', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505893878', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13052, '112657', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-09-20 17:18:30', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505893878', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(13053, '112653', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-20 14:49:52', 'Paid', NULL, NULL, '0.00', '0.00', NULL, '0.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505893878', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13055, '112654', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-20 14:57:44', 'Paid', NULL, '5.00', '4.95', '4.95', NULL, '5.50', '0.55', '0.00', '0.00', '0.55', '0.00', 'Cash', NULL, '27', '1505893878', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13056, '112656', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-20 17:05:53', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '30.00', '4.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505893878', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13057, '112655', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-20 16:13:30', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505893878', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13058, '112658', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-20 17:47:23', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505893878', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13045, '112645', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-20 12:30:14', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505893878', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13043, '112641', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-20 10:43:31', 'Paid', NULL, '25.50', '28.05', '28.05', NULL, '28.05', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505893878', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13044, '112644', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-09-20 11:18:37', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '40.00', '2.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505893878', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13042, '112647', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-20 12:44:39', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505893878', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13041, '112643', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-20 11:17:20', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505893878', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13040, '112639', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-20 10:37:38', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505893878', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13039, '112642', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-20 10:58:41', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505893878', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13038, '112638', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-09-20 10:34:10', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '101.80', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505893878', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13037, '112640', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-20 10:41:49', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.40', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505893878', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13068, '112670', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-21 13:14:57', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.00', '29.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505975619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13069, '112669', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-21 13:09:23', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '55.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505975619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13070, '112667', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-09-21 12:44:47', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505975619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13071, '112668', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-09-21 12:45:47', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505975619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13072, '112675', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-21 15:20:41', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.10', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505975619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13073, '112673', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-21 15:07:54', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '90.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505975619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13074, '112674', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-21 15:20:09', 'Paid', NULL, '27.00', '26.75', '26.75', NULL, '50.00', '23.25', '0.00', '0.00', '2.97', '0.02', 'Cash', NULL, '27', '1505975619', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13075, '112676', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-21 15:47:15', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505975619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13076, '112678', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-09-21 17:26:29', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505975619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13077, '112672', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-21 14:54:02', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505975619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13078, '112677', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-21 15:51:40', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505975619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13079, '112680', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-21 17:37:17', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505975619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13080, '112679', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-09-21 17:28:00', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '20.00', '11.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505975619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13067, '112671', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-21 13:44:22', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.80', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505975619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13065, '112665', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-21 11:54:00', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '78.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505975619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13066, '112666', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-21 12:19:24', 'Paid', NULL, '55.90', '61.50', '61.50', NULL, '102.00', '40.50', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1505975619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13064, '112664', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-21 11:23:24', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.00', '29.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505975619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13063, '112663', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-21 11:13:08', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505975619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13062, '112662', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-21 11:07:16', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505975619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13061, '112661', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-21 10:45:51', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505975619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13060, '112659', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-21 10:05:59', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505975619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13059, '112660', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-21 10:26:49', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '100.20', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1505975619', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13121, '112718', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 16:56:40', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '6.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13120, '112719', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 17:03:49', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13119, '112716', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 16:29:37', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13118, '112713', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 16:00:53', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '44.20', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13117, '112715', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 16:06:54', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13116, '112714', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 16:04:06', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.60', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13115, '112712', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 15:20:09', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13114, '112707', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 14:25:49', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13113, '112717', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 16:34:41', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13111, '112710', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 15:04:12', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13112, '112708', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 14:51:02', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '100.00', '6.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13110, '112706', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 14:23:56', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '100.00', '78.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13108, '112705', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 14:08:04', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.50', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13107, '112709', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 15:01:09', 'Paid', NULL, '90.00', '89.10', '89.10', NULL, '100.10', '11.00', '0.00', '0.00', '9.90', '0.00', 'Cash', NULL, '27', '1506069153', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13106, '112702', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 13:30:01', 'Paid', NULL, '97.00', '106.70', '106.70', NULL, '200.00', '93.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13105, '112701', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 13:20:59', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13104, '112704', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 13:31:28', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13103, '112703', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 13:30:28', 'Paid', NULL, '104.00', '102.95', '102.95', NULL, '105.00', '2.05', '0.00', '0.00', '11.44', '-0.01', 'Cash', NULL, '27', '1506069153', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13102, '112711', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 15:16:36', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '70.20', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13091, '112690', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 11:48:51', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.10', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13092, '112689', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 11:37:15', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '63.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13093, '112696', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 12:29:48', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '60.00', '8.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13094, '112695', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 12:09:56', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13095, '112694', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 12:02:41', 'Paid', NULL, '118.00', '129.80', '129.80', NULL, '150.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13096, '112688', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 11:26:38', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13097, '112692', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 12:01:23', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13098, '112697', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 12:32:02', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13099, '112700', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 13:12:03', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13100, '112699', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 12:44:41', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13101, '112693', 'T10(S)', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 12:01:53', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13089, '112687', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 11:25:19', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.50', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13087, '112691', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 11:50:50', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '70.00', '10.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13088, '112683', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 10:46:14', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13090, '112686', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 11:23:21', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.00', '30.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13085, '112698', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 12:34:51', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '104.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13084, '112685', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 11:19:17', 'Paid', NULL, '134.00', '147.40', '147.40', NULL, '150.00', '2.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13083, '112684', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 11:13:22', 'Paid', NULL, '133.00', '146.30', '146.30', NULL, '200.00', '53.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13082, '112682', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 10:29:53', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13081, '112681', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-22 10:16:53', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506069153', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13156, '112751', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 16:04:28', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13149, '112749', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 16:02:36', 'Paid', NULL, '51.00', '50.50', '50.50', NULL, '51.00', '0.50', '0.00', '0.00', '5.61', '0.01', 'Cash', NULL, '27', '1506152110', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13150, '112745', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 15:02:41', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '100.70', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13151, '112746', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 15:20:40', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '55.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13152, '112748', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 15:59:28', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '46.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13154, '112750', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 16:03:14', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13155, '112752', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 16:04:47', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13153, '112747', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 15:55:25', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.00', '19.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13145, '112740', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 13:28:19', 'Paid', NULL, '19.00', '18.80', '18.80', NULL, '20.00', '1.20', '0.00', '0.00', '2.09', '-0.01', 'Cash', NULL, '27', '1506152110', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13146, '112742', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 13:47:18', 'Paid', NULL, '66.00', '65.35', '65.35', NULL, '66.00', '0.65', '0.00', '0.00', '7.26', '0.01', 'Cash', NULL, '27', '1506152110', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13147, '112744', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 14:27:58', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13148, '112743', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 14:21:10', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '102.00', '40.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13144, '112741', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 13:35:47', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13143, '112738', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 13:08:27', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13131, '112726', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 11:19:39', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.30', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13142, '112739', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 13:13:18', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.40', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13141, '112736', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 13:00:37', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13140, '112734', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 12:26:35', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13139, '112737', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 13:08:04', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13138, '112731', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 12:14:23', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13137, '112753', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 16:09:12', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13136, '112733', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 12:15:58', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13135, '112735', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 12:36:13', 'Paid', NULL, '143.00', '157.30', '157.30', NULL, '160.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13134, '112732', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 12:14:44', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13133, '112728', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 11:41:42', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13132, '112730', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 12:05:22', 'Paid', NULL, '108.00', '118.80', '118.80', NULL, '120.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13130, '112725', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 11:05:04', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13128, '112723', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 10:57:47', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13129, '112729', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 11:44:07', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.00', '30.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13127, '112722', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 10:47:37', 'Paid', NULL, '108.00', '118.80', '118.80', NULL, '130.00', '11.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13126, '112754', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 16:40:59', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13125, '112724', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 10:58:13', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13124, '112727', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 11:41:06', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.20', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13123, '112720', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 10:18:14', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13122, '112721', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-23 10:42:48', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506152110', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13214, '112809', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 15:22:21', 'Paid', NULL, '104.00', '114.40', '114.40', NULL, '120.40', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13215, '112810', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 15:23:33', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13216, '112811', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 15:28:12', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '51.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13217, '112814', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 16:30:05', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '31.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13218, '112812', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 15:52:02', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13219, '112805', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 14:40:11', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '100.00', '92.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13220, '112813', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 16:04:12', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13221, '112816', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 17:44:21', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '38.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13222, '112815', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 17:28:01', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '100.00', '56.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13223, '112817', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 17:45:19', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13203, '112798', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 13:41:55', 'Paid', NULL, '121.00', '133.10', '133.10', NULL, '133.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13204, '112808', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 15:21:56', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13205, '112801', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 14:02:48', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '100.00', '53.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13206, '112803', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 14:27:03', 'Paid', NULL, '124.00', '136.40', '136.40', NULL, '150.00', '13.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13207, '112802', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 14:26:32', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '101.30', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13208, '112795', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 13:23:50', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13209, '112799', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 13:52:31', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13210, '112800', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 13:55:50', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13211, '112804', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 14:38:02', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '74.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13212, '112807', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 15:11:56', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '100.00', '73.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13213, '112806', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 15:03:02', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '100.60', '94.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13202, '112796', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 13:27:59', 'Paid', NULL, '154.00', '169.40', '169.40', NULL, '200.00', '30.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13201, '112793', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 12:28:32', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13200, '112797', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 13:37:00', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13199, '112787', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 12:14:21', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13198, '112786', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 12:13:15', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13162, '112761', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 10:11:28', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13164, '112769', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 10:39:01', 'Paid', NULL, '136.00', '149.60', '149.60', NULL, '150.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13181, '112774', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 11:10:27', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13167, '112757', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 09:41:56', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13168, '112763', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 10:24:56', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '110.00', '6.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13170, '112764', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 10:29:34', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '100.00', '69.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13171, '112759', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 09:59:25', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13172, '112760', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 09:59:51', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13174, '112777', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 11:30:26', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.10', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13175, '112771', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 11:00:08', 'Paid', NULL, '49.00', '48.50', '48.50', NULL, '53.90', '5.40', '0.00', '0.00', '5.39', '-0.01', 'Cash', NULL, '27', '1506229681', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13176, '112776', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 11:25:13', 'Paid', NULL, '87.50', '96.25', '96.25', NULL, '100.25', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(13177, '112773', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 11:09:38', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '40.10', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13178, '112765', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 10:30:23', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13179, '112766', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 10:30:56', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13180, '112767', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 10:31:33', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '31.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13182, '112772', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 11:08:28', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '100.00', '60.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13183, '112775', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 11:16:05', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.40', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13184, '112780', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 11:37:33', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13185, '112778', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 11:31:52', 'Paid', NULL, '113.00', '124.30', '124.30', NULL, '150.00', '25.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13186, '112781', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 11:43:31', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13187, '112782', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 11:55:02', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '70.00', '10.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13188, '112791', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 12:24:01', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '40.00', '1.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13189, '112779', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 11:33:44', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13190, '112784', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 12:04:58', 'Paid', NULL, '186.00', '204.60', '204.60', NULL, '250.00', '45.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13191, '112785', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 12:10:01', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13192, '112790', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 12:22:26', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '99.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13193, '112792', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 12:24:29', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13194, '112788', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 12:14:46', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13195, '112783', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 12:02:49', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.10', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13196, '112789', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 12:21:14', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13197, '112794', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 12:38:34', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13165, '112768', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 10:36:08', 'Paid', NULL, '51.00', '50.50', '50.50', NULL, '50.50', '0.00', '0.00', '0.00', '5.61', '0.01', 'Cash', NULL, '27', '1506229681', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13163, '112756', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 09:31:32', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '68.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13161, '112758', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 09:54:59', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '70.00', '13.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13160, '112762', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 10:15:04', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '100.60', '61.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13173, '112770', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 10:57:47', 'Paid', NULL, '131.00', '144.10', '144.10', NULL, '200.00', '55.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13158, '112755', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-24 09:26:38', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506229681', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13238, '112831', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 14:41:19', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.00', '10.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506314121', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13239, '112834', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 15:18:18', 'Paid', NULL, '106.00', '116.60', '116.60', NULL, '120.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506314121', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13240, '112830', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 14:26:26', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506314121', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13241, '112833', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 14:58:57', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506314121', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13242, '112835', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 16:06:58', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506314121', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13243, '112836', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 16:42:55', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506314121', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13244, '112840', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 17:44:16', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '36.50', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506314121', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13245, '112838', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 17:24:49', 'Paid', NULL, '7.00', '6.95', '6.95', NULL, '10.00', '3.05', '0.00', '0.00', '0.77', '0.02', 'Cash', NULL, '27', '1506314121', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13246, '112837', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 17:04:22', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506314121', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13225, '112818', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 09:41:50', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.10', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506314121', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13227, '112822', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 11:08:48', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '70.20', '14.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506314121', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13228, '112821', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 11:05:12', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '57.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506314121', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13229, '112825', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 11:29:38', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506314121', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13230, '112823', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 11:13:09', 'Paid', NULL, '28.00', '27.70', '27.70', NULL, '50.00', '22.30', '0.00', '0.00', '3.08', '-0.02', 'Cash', NULL, '27', '1506314121', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13231, '112824', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 11:28:30', 'Paid', NULL, '61.00', '60.40', '60.40', NULL, '60.40', '0.00', '0.00', '0.00', '6.71', '0.01', 'Cash', NULL, '27', '1506314121', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13232, '112826', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 12:23:29', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506314121', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13233, '112827', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 12:59:54', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506314121', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13234, '112832', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 14:43:43', 'Paid', NULL, '52.00', '51.50', '51.50', NULL, '51.50', '0.00', '0.00', '0.00', '5.72', '0.02', 'Cash', NULL, '27', '1506314121', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13235, '112828', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 13:48:40', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506314121', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13236, '112829', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 14:12:20', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506314121', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13237, '112839', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 17:43:31', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '80.20', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506314121', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13226, '112820', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 10:05:57', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.00', '15.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506314121', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13224, '112819', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-25 09:50:04', 'Paid', NULL, '20.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', '2.20', '0.00', 'Cash', NULL, '27', '1506314121', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13261, '112852', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-27 15:36:40', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506489928', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13262, '112854', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-27 16:26:44', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506489928', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13263, '112855', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-27 17:50:26', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506489928', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13247, '112843', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-27 11:53:03', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506489928', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13248, '112841', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-27 10:46:44', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506489928', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13249, '112842', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-27 11:41:04', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506489928', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13250, '112844', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-27 11:53:26', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '53.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506489928', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13251, '112845', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-27 12:02:13', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506489928', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13253, '112848', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-27 14:05:44', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506489928', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13255, '112846', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-27 13:47:04', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.50', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506489928', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13260, '112853', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-27 16:00:16', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.50', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506489928', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13257, '112851', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-27 14:58:27', 'Paid', NULL, '43.00', '42.55', '42.55', NULL, '102.55', '60.00', '0.00', '0.00', '4.73', '-0.02', 'Cash', NULL, '27', '1506489928', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13258, '112849', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-27 14:11:17', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506489928', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13259, '112850', 'T5(S)', 10003, 'admin', NULL, NULL, 'history', '2017-09-27 14:19:31', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506489928', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13254, '112847', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-27 13:55:37', 'Paid', NULL, '62.00', '61.40', '61.40', NULL, '71.40', '10.00', '0.00', '0.00', '6.82', '0.02', 'Cash', NULL, '27', '1506489928', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13267, '112858', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-28 10:13:37', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506562404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13268, '112861', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-28 11:15:11', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506562404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13269, '112862', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-28 11:15:23', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506562404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13270, '112860', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-28 11:02:16', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506562404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13271, '112863', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-28 11:27:20', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.00', '41.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506562404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13272, '112864', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-28 11:34:28', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506562404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13273, '112865', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-28 12:00:30', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '35.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506562404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13274, '112866', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-28 12:22:41', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.80', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506562404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13275, '112867', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-28 12:49:48', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '21.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506562404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13276, '112869', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-28 13:27:22', 'Paid', NULL, '58.00', '57.40', '57.40', NULL, '60.00', '2.60', '0.00', '0.00', '6.38', '-0.02', 'Cash', NULL, '27', '1506562404', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13277, '112868', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-28 13:24:50', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '40.00', '1.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506562404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13278, '112870', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-28 13:49:16', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '50.00', '33.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506562404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13279, '112871', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-28 13:52:30', 'Paid', NULL, '10.00', '9.90', '9.90', NULL, '20.00', '10.10', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1506562404', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13280, '112873', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-09-28 14:39:21', 'Paid', NULL, '19.00', '18.80', '18.80', NULL, '20.00', '1.20', '0.00', '0.00', '2.09', '-0.01', 'Cash', NULL, '27', '1506562404', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13281, '112872', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-28 14:35:48', 'Paid', NULL, '21.00', '18.90', '18.90', NULL, '20.00', '1.10', '0.00', '0.00', '2.10', '0.00', 'Cash', NULL, '27', '1506562404', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13282, '112874', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-28 15:51:16', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '50.90', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506562404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13284, '112877', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-28 17:24:10', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '50.00', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506562404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13285, '112875', 'T5(S)', 10003, 'admin', NULL, NULL, 'history', '2017-09-28 16:17:18', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.40', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506562404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13286, '112876', 'T5(S)', 10003, 'admin', NULL, NULL, 'history', '2017-09-28 16:17:55', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.10', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506562404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13264, '112856', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-28 09:45:52', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506562404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13265, '112857', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-28 10:09:46', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506562404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13266, '112859', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-28 10:28:57', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506562404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13290, '112880', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 11:09:54', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506664852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13291, '112882', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 11:42:34', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '58.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506664852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13292, '112883', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 11:53:02', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.40', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506664852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13293, '112889', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 14:11:01', 'Paid', NULL, '63.00', '62.35', '62.35', NULL, '65.35', '3.00', '0.00', '0.00', '6.93', '-0.02', 'Cash', NULL, '27', '1506664852', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13294, '112884', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 12:09:51', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '71.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506664852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13295, '112885', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 12:39:27', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506664852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13299, '112886', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 13:41:58', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506664852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13300, '112895', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 15:10:10', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506664852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13298, '112890', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 14:19:17', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506664852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13301, '112888', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 14:02:16', 'Paid', NULL, '98.00', '107.80', '107.80', NULL, '110.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506664852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13302, '112887', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 14:01:13', 'Paid', NULL, '44.00', '43.55', '43.55', NULL, '50.00', '6.45', '0.00', '0.00', '4.84', '-0.01', 'Cash', NULL, '27', '1506664852', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13303, '112891', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 14:22:45', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '58.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506664852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13304, '112894', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 15:08:13', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '52.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506664852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13305, '112892', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 14:30:27', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506664852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13306, '112893', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 14:51:04', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506664852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13307, '112896', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 15:20:56', 'Paid', NULL, '77.00', '76.25', '76.25', NULL, '80.00', '3.75', '0.00', '0.00', '8.47', '0.02', 'Cash', NULL, '27', '1506664852', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13308, '112897', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 15:28:31', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '53.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506664852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13309, '112898', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 16:37:47', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '56.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506664852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13310, '112899', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 16:58:00', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506664852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13311, '112900', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 17:31:25', 'Paid', NULL, '63.00', '63.00', '63.00', NULL, '63.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506664852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13312, '112901', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 17:33:01', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506664852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13289, '112879', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 10:48:09', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '70.00', '12.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506664852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13288, '112881', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 11:37:00', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506664852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13287, '112878', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-29 10:07:06', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506664852', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13347, '112932', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 16:49:23', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '20.00', '12.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13346, '112933', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 16:58:11', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13345, '112931', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 16:38:15', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13344, '112935', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 17:22:46', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '57.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13343, '112930', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 16:24:13', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13342, '112929', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 14:52:58', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1506750592', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13341, '112928', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 14:52:21', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '50.00', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13340, '112934', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 17:20:05', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '15.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13337, '112925', 'T11', 10010, 'sanni', NULL, NULL, 'history', '2017-09-30 14:20:30', 'Paid', NULL, '102.00', '112.20', '112.20', NULL, '112.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13338, '112926', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 14:44:43', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '70.00', '10.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13339, '112924', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 14:16:20', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '108.00', '75.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13336, '112927', 'T14', 10010, 'sanni', NULL, NULL, 'history', '2017-09-30 14:51:01', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '80.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13335, '112923', 'T7', 10010, 'sanni', NULL, NULL, 'history', '2017-09-30 14:09:21', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13334, '112921', 'T12', 10010, 'sanni', NULL, NULL, 'history', '2017-09-30 13:38:56', 'Paid', NULL, '152.00', '167.20', '167.20', NULL, '170.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13333, '112922', 'T1', 10010, 'sanni', NULL, NULL, 'history', '2017-09-30 13:59:09', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13331, '112919', 'T7', 10010, 'sanni', NULL, NULL, 'history', '2017-09-30 12:53:57', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13330, '112920', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 13:16:46', 'Paid', NULL, '84.50', '83.65', '83.65', NULL, '100.00', '16.35', '0.00', '0.00', '9.30', '0.00', 'Cash', NULL, '27', '1506750592', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13329, '112917', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 12:34:00', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13328, '112916', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 12:30:53', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.30', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13327, '112908', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 11:05:44', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '50.00', '43.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13326, '112912', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 11:38:15', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13325, '112915', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 11:52:33', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.50', '22.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13324, '112914', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 11:42:20', 'Paid', NULL, '102.00', '112.20', '112.20', NULL, '150.20', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13323, '112909', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 11:20:57', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13322, '112911', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 11:29:51', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.50', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13321, '112910', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 11:22:53', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13320, '112911', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 11:31:35', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '74.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13332, '112918', 'T2', 10010, 'sanni', NULL, NULL, 'history', '2017-09-30 12:48:45', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13319, '112913', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 11:39:22', 'Paid', NULL, '35.00', '34.65', '34.65', NULL, '50.00', '15.35', '0.00', '0.00', '3.85', '0.00', 'Cash', NULL, '27', '1506750592', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13316, '112903', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 10:32:27', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '25.10', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13317, '112906', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 10:59:45', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '80.00', '6.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13315, '112904', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 10:34:50', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13314, '112905', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 10:43:05', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13313, '112902', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-09-30 10:06:49', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '70.00', '12.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506750592', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13390, '112976', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 18:05:18', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13389, '112972', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 15:58:58', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13388, '112971', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 15:38:49', 'Paid', NULL, '16.00', '15.85', '15.85', NULL, '16.00', '0.15', '0.00', '0.00', '1.76', '0.01', 'Cash', NULL, '27', '1506837768', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(13386, '112969', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 14:54:44', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '40.00', '14.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13385, '112973', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 16:09:52', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13384, '112965', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 14:35:03', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13383, '112968', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 14:47:04', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.40', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13382, '112962', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 14:12:48', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13379, '112974', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 17:26:21', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.20', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13381, '112975', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 17:51:57', 'Paid', NULL, '136.00', '149.60', '149.60', NULL, '150.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13380, '112961', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 14:10:12', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13378, '112966', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 14:36:43', 'Paid', NULL, '74.00', '73.25', '73.25', NULL, '100.00', '26.75', '0.00', '0.00', '8.14', '-0.01', 'Cash', NULL, '27', '1506837768', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13377, '112967', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 14:40:47', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.10', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13374, '112959', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 13:42:33', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13371, '112953', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 12:31:56', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '78.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13376, '112964', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 14:16:18', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13375, '112960', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 13:46:35', 'Paid', NULL, '86.00', '85.15', '85.15', NULL, '100.15', '15.00', '0.00', '0.00', '9.46', '0.01', 'Cash', NULL, '27', '1506837768', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13373, '112956', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 13:01:25', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13372, '112955', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 12:48:46', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13366, '112957', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 13:28:30', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13367, '112952', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 12:28:36', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '69.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13368, '112946', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 11:21:53', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1506837768', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13369, '112963', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 14:16:14', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13370, '112954', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 12:34:13', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13365, '112950', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 11:49:25', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '80.00', '15.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13364, '112949', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 11:36:46', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13363, '112958', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 13:35:27', 'Paid', NULL, '114.00', '125.40', '125.40', NULL, '150.40', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13387, '112970', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 15:07:09', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13362, '112947', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 11:22:46', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '80.00', '7.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13360, '112948', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 11:23:37', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13359, '112943', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 11:13:51', 'Paid', NULL, '18.00', '17.80', '17.80', NULL, '17.80', '0.00', '0.00', '0.00', '1.98', '-0.02', 'Cash', NULL, '27', '1506837768', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13358, '112945', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 11:18:07', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '45.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13356, '112942', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 10:41:24', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '15.20', '3.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13357, '112951', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 12:16:17', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13355, '112944', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 11:15:12', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13351, '112940', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 10:25:54', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '70.50', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13353, '112938', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 10:13:55', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13352, '112939', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 10:19:33', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '104.00', '20.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13350, '112936', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 09:34:57', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13349, '112937', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 09:38:52', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13348, '112941', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-01 10:35:51', 'Paid', NULL, '97.00', '106.70', '106.70', NULL, '110.00', '3.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506837768', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13422, '113006', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 16:57:27', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '42.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13423, '113009', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 17:43:55', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13417, '113003', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 15:20:47', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13418, '113002', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 15:19:21', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13415, '113001', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 15:04:20', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.00', '7.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13416, '113004', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 15:23:14', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '57.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13419, '113005', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 15:36:09', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '100.00', '73.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13420, '113007', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 17:00:04', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13421, '113008', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 17:40:46', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.70', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13413, '112994', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 13:54:46', 'Paid', NULL, '19.00', '18.80', '18.80', NULL, '20.00', '1.20', '0.00', '0.00', '2.09', '-0.01', 'Cash', NULL, '27', '1506916470', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13414, '112999', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 14:33:46', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.00', '3.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13412, '112997', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 14:28:23', 'Paid', NULL, '16.00', '15.85', '15.85', NULL, '20.00', '4.15', '0.00', '0.00', '1.76', '0.01', 'Cash', NULL, '27', '1506916470', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13407, '112993', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 13:30:14', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '100.20', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13408, '112995', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 13:55:44', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13409, '112991', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 13:12:44', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13410, '112998', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 14:32:48', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '100.00', '60.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13411, '113000', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 14:36:24', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.20', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13396, '112982', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 11:03:38', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13397, '112983', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 12:02:37', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '80.00', '9.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13398, '112989', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 12:56:59', 'Paid', NULL, '57.00', '56.45', '56.45', NULL, '100.00', '43.55', '0.00', '0.00', '6.27', '0.02', 'Cash', NULL, '27', '1506916470', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13399, '112985', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 12:30:52', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13400, '112996', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 14:18:44', 'Paid', NULL, '47.00', '46.55', '46.55', NULL, '50.00', '3.45', '0.00', '0.00', '5.17', '0.02', 'Cash', NULL, '27', '1506916470', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13401, '112984', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 12:11:40', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13402, '112986', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 12:40:40', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13403, '112987', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 12:49:52', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '31.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13404, '112990', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 13:07:10', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13405, '112992', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 13:21:32', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '103.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13406, '112988', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 12:51:05', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '36.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13395, '112979', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 10:02:45', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13393, '112977', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 09:54:05', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13394, '112980', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 10:32:24', 'Paid', NULL, '112.00', '123.20', '123.20', NULL, '124.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1506916470', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13392, '112978', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 10:01:50', 'Paid', NULL, '46.00', '45.55', '45.55', NULL, '50.00', '4.45', '0.00', '0.00', '5.06', '0.01', 'Cash', NULL, '27', '1506916470', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13391, '112981', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-02 10:50:43', 'Paid', NULL, '61.00', '60.40', '60.40', NULL, '100.40', '40.00', '0.00', '0.00', '6.71', '0.01', 'Cash', NULL, '27', '1506916470', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13441, '113021', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 14:05:59', 'Paid', NULL, '27.00', '26.75', '26.75', NULL, '50.00', '23.25', '0.00', '0.00', '2.97', '0.02', 'Cash', NULL, '27', '1507107061', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13442, '113022', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 14:07:13', 'Paid', NULL, '16.00', '15.85', '15.85', NULL, '50.00', '34.15', '0.00', '0.00', '1.76', '0.01', 'Cash', NULL, '27', '1507107061', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13444, '113035', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 17:31:36', 'Paid', NULL, '18.00', '17.80', '17.80', NULL, '20.00', '2.20', '0.00', '0.00', '1.98', '-0.02', 'Cash', NULL, '27', '1507107061', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13445, '113029', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 14:50:01', 'Paid', NULL, '23.90', '26.30', '26.30', NULL, '40.30', '14.00', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13446, '113027', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 14:29:38', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '17.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13447, '113031', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 15:13:34', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13448, '113032', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 16:51:08', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.20', '16.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13449, '113033', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 16:52:03', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '100.20', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13434, '113017', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 13:15:29', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13435, '113030', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 14:51:30', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13431, '113019', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 13:18:07', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13432, '113018', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 13:17:26', 'Paid', NULL, '103.00', '113.30', '113.30', NULL, '150.30', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13430, '113016', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 13:02:19', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '105.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13426, '113013', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 11:53:57', 'Paid', NULL, '119.00', '130.90', '130.90', NULL, '150.90', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13451, '113036', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 17:40:52', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13450, '113034', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 17:19:04', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13443, '113028', 't5', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 14:47:16', 'Paid', NULL, '11.90', '13.10', '13.10', NULL, '15.00', '1.90', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13440, '113024', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 14:11:31', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13439, '113023', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 14:10:31', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.00', '41.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13438, '113025', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 14:16:41', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '102.50', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13437, '113026', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 14:27:37', 'Paid', NULL, '137.00', '150.70', '150.70', NULL, '151.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13436, '113020', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 13:33:29', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13427, '113012', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 11:46:11', 'Paid', NULL, '218.00', '239.80', '239.80', NULL, '240.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13429, '113015', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 12:35:36', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13428, '113014', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 12:15:51', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13425, '113011', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 11:33:21', 'Paid', NULL, '678.00', '745.80', '745.80', NULL, '750.00', '4.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13424, '113010', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-04 10:07:30', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507107061', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13474, '113054', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 14:02:26', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507182289', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13475, '113058', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 14:45:17', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '102.00', '10.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507182289', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13476, '113060', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 14:53:13', 'Paid', NULL, '24.00', '23.75', '23.75', NULL, '50.00', '26.25', '0.00', '0.00', '2.64', '-0.01', 'Cash', NULL, '27', '1507182289', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13477, '113062', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 17:43:38', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507182289', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13478, '113061', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 17:41:07', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.00', '7.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507182289', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13452, '113040', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 10:38:55', 'Paid', NULL, '140.00', '154.00', '154.00', NULL, '155.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507182289', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13453, '113037', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 10:29:55', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507182289', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13454, '113041', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 10:40:54', 'Paid', NULL, '271.00', '298.10', '298.10', NULL, '300.10', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507182289', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13455, '113039', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 10:34:28', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '55.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507182289', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13456, '113038', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 10:30:55', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507182289', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13457, '113042', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 10:56:29', 'Paid', NULL, '146.00', '160.60', '0.00', '160.60', '200.00', '39.40', '0.00', '0.00', NULL, '0.00', 'Credit Card', NULL, '27', '1507182289', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, 4, '2.89', 'Master Card', '1.80', NULL, '0.17', '157.54', 0, NULL, NULL, NULL, NULL, '0'),
(13458, '113044', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 11:28:52', 'Paid', NULL, '101.00', '111.10', '111.10', NULL, '111.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507182289', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13459, '113055', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 14:06:53', 'Paid', NULL, '12.00', '11.90', '11.90', NULL, '20.00', '8.10', '0.00', '0.00', '1.32', '0.02', 'Cash', NULL, '27', '1507182289', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13460, '113046', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 12:32:49', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '34.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507182289', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13468, '113057', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 14:09:12', 'Paid', NULL, '89.00', '88.10', '88.10', NULL, '100.10', '12.00', '0.00', '0.00', '9.79', '-0.01', 'Cash', NULL, '27', '1507182289', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13462, '113043', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 11:26:52', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '25.00', '1.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507182289', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13463, '113045', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 12:16:43', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507182289', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13464, '113047', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 12:52:06', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.20', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507182289', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13465, '113053', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 13:56:37', 'Paid', NULL, '20.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', '2.20', '0.00', 'Cash', NULL, '27', '1507182289', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13466, '113048', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 12:55:01', 'Paid', NULL, '117.00', '128.70', '128.70', NULL, '150.00', '21.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507182289', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13467, '113051', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 13:44:56', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '54.20', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507182289', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13469, '113049', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 13:18:34', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '22.10', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507182289', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13470, '113056', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 14:07:49', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507182289', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13471, '113050', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 13:30:39', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507182289', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13472, '113052', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 13:52:52', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507182289', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13473, '113059', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-05 14:48:32', 'Paid', NULL, '51.00', '50.50', '50.50', NULL, '100.50', '50.00', '0.00', '0.00', '5.61', '0.01', 'Cash', NULL, '27', '1507182289', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13486, '113069', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 11:22:59', 'Paid', NULL, '129.00', '141.90', '141.90', NULL, '152.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13487, '113071', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 12:31:24', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '60.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13488, '113072', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 12:43:53', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13489, '113073', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 12:46:04', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13501, '113083', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 15:52:37', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '25.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13491, '113074', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 14:21:45', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '72.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13492, '113075', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 14:26:59', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.10', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13493, '113084', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 15:54:06', 'Paid', NULL, '104.00', '114.40', '114.40', NULL, '115.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13494, '113081', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 15:03:23', 'Paid', NULL, '26.00', '25.75', '25.75', NULL, '25.75', '0.00', '0.00', '0.00', '2.86', '0.01', 'Cash', NULL, '27', '1507269351', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13495, '113082', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 15:10:28', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13496, '113076', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 14:28:53', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '45.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13497, '113077', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 14:29:24', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13498, '113078', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 14:29:47', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '30.00', '4.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13499, '113079', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 14:30:13', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13500, '113080', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 14:30:32', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13502, '113087', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 17:18:01', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13503, '113085', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 16:16:02', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13504, '113088', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 17:20:10', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '30.00', '4.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13505, '113086', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 16:29:43', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13485, '113070', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 11:36:24', 'Paid', NULL, '102.00', '112.20', '112.20', NULL, '113.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13484, '113068', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 11:08:36', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '20.00', '13.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13483, '113066', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 10:26:18', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(13482, '113064', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 10:19:50', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13481, '113067', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 10:29:35', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '100.00', '52.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13480, '113065', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 10:23:41', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13479, '113063', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-06 09:19:23', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '50.00', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507269351', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13545, '113126', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 16:31:51', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '35.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13544, '113124', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 16:19:45', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.80', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13543, '113121', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 15:36:15', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13542, '113127', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 16:50:52', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13531, '113119', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 15:02:16', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '80.50', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13532, '113118', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 15:01:38', 'Paid', NULL, '103.00', '113.30', '113.30', NULL, '115.40', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13533, '113110', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 14:23:02', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13534, '113123', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 15:57:08', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '82.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13535, '113115', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 14:57:49', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13536, '113116', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 14:58:38', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13537, '113128', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 17:11:49', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '53.20', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13541, '113123', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 15:53:49', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13540, '113125', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 16:24:47', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13538, '113120', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 15:27:28', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '100.00', '60.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13539, '113113', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 14:46:03', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13530, '113114', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 14:54:15', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '102.00', '10.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13529, '113112', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 14:38:23', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.60', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13528, '113105', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 13:43:02', 'Paid', NULL, '8.00', '7.20', '7.20', NULL, '10.00', '2.80', '0.00', '0.00', '0.80', '0.00', 'Cash', NULL, '27', '1507357676', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13513, '113096', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 10:39:04', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13514, '113097', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 11:00:56', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13515, '113098', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 11:32:28', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13516, '113099', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 11:48:19', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13517, '113102', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 13:36:19', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '101.30', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13518, '113103', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 13:38:44', 'Paid', NULL, '83.00', '82.15', '82.15', NULL, '102.15', '20.00', '0.00', '0.00', '9.13', '-0.02', 'Cash', NULL, '27', '1507357676', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13519, '113100', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 13:03:57', 'Paid', NULL, '116.00', '127.60', '127.60', NULL, '150.00', '22.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13520, '113101', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 13:12:05', 'Paid', NULL, '109.00', '119.90', '119.90', NULL, '120.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13521, '113111', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 14:36:50', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13522, '113106', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 13:50:44', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '80.20', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13523, '113108', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 14:01:34', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13524, '113107', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 13:52:20', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '60.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13525, '113117', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 14:59:51', 'Paid', NULL, '95.00', '104.50', '104.50', NULL, '105.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13526, '113109', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 14:12:18', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '6.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13527, '113104', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 13:39:57', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '20.00', '10.10', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1507357676', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13512, '113090', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 10:03:38', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13511, '113092', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 10:12:22', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '17.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13510, '113093', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 10:15:07', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '101.00', '60.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13509, '113094', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 10:18:47', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '65.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13508, '113095', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 10:35:42', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13507, '113091', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 10:05:40', 'Paid', NULL, '147.00', '161.70', '161.70', NULL, '162.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13506, '113089', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-07 09:41:51', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507357676', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13595, '113177', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 17:35:10', 'Paid', NULL, '119.00', '130.90', '130.90', NULL, '150.00', '19.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13596, '113175', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 17:11:49', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '40.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13597, '113176', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 17:33:20', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13592, '113168', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 15:14:44', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13593, '113172', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 16:10:01', 'Paid', NULL, '62.00', '61.40', '61.40', NULL, '70.20', '8.80', '0.00', '0.00', '6.82', '0.02', 'Cash', NULL, '27', '1507452888', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13594, '113173', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 16:38:08', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '100.00', '72.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13591, '113165', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 15:06:19', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '100.00', '73.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13585, '113170', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 15:39:49', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '75.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13586, '113167', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 15:11:39', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13587, '113169', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 15:24:45', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '100.00', '61.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13588, '113163', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 14:48:35', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13589, '113174', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 16:54:56', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '15.20', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13590, '113171', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 15:42:25', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13584, '113164', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 14:49:28', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.00', '41.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13574, '113157', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 13:34:22', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13575, '113155', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 13:25:14', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.10', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13576, '113154', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 13:18:27', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13577, '113159', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 13:39:58', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13578, '113158', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 13:35:08', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '90.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13579, '113153', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 13:15:39', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '50.00', '31.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13580, '113160', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 13:46:12', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13581, '113162', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 14:16:01', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.10', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13582, '113178', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 17:36:09', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13583, '113161', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 14:12:54', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13571, '113149', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 12:34:58', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13573, '113166', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 15:11:01', 'Paid', NULL, '100.00', '110.00', '110.00', NULL, '110.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13572, '113150', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 12:41:59', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13554, '113133', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 10:40:51', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '20.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13553, '113135', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 10:43:44', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13555, '113141', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 11:39:30', 'Paid', NULL, '48.90', '53.80', '53.80', NULL, '54.00', '0.20', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13556, '113152', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 13:15:05', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13557, '113139', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 11:10:50', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13558, '113134', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 10:43:02', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.00', '37.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13559, '113142', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 11:50:27', 'Paid', NULL, '260.00', '286.00', '286.00', NULL, '300.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13560, '113140', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 11:12:20', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '71.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13562, '113146', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 12:13:00', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '55.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13563, '113156', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 13:33:53', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13564, '113144', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 11:56:43', 'Paid', NULL, '117.00', '128.70', '128.70', NULL, '150.00', '21.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13566, '113143', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 11:54:20', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '72.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13567, '113148', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 12:25:32', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '69.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13568, '113151', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 13:09:33', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13569, '113145', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 12:09:39', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '102.00', '20.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13570, '113147', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 12:21:43', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13552, '113137', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 11:07:56', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13561, '113136', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 10:46:00', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13550, '113132', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 10:26:14', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13549, '113131', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 10:08:28', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13548, '113138', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 11:09:53', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.00', '7.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13547, '113130', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 09:56:11', 'Paid', NULL, '131.00', '144.10', '144.10', NULL, '150.00', '5.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13546, '113129', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-08 09:39:04', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '29.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507452888', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13613, '113196', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 14:12:06', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '6.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507535722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13614, '113193', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 13:50:19', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.50', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507535722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13615, '113194', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 13:50:57', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '40.30', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507535722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13617, '113198', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 14:30:11', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '38.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507535722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13619, '113197', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 14:25:17', 'Paid', NULL, '151.20', '151.20', '151.20', NULL, '200.00', '48.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507535722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13620, '113199', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 15:55:28', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507535722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13621, '113200', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 16:43:54', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507535722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13622, '113201', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 17:01:13', 'Paid', NULL, '23.00', '20.70', '20.70', NULL, '50.00', '29.30', '0.00', '0.00', '2.30', '0.00', 'Cash', NULL, '27', '1507535722', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13603, '113183', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 11:27:26', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '42.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507535722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13604, '113187', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 12:27:28', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507535722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13605, '113184', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 11:44:32', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507535722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13606, '113188', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 12:55:02', 'Paid', NULL, '47.00', '46.55', '46.55', NULL, '50.00', '3.45', '0.00', '0.00', '5.17', '0.02', 'Cash', NULL, '27', '1507535722', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13616, '113195', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 14:09:21', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507535722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13608, '113186', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 12:23:03', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507535722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13609, '113189', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 13:22:17', 'Paid', NULL, '200.00', '220.00', '220.00', NULL, '220.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507535722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13610, '113192', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 13:37:28', 'Paid', NULL, '106.00', '104.95', '104.95', NULL, '110.00', '5.05', '0.00', '0.00', '11.66', '0.01', 'Cash', NULL, '27', '1507535722', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13612, '113190', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 13:28:48', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '70.00', '12.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507535722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13611, '113191', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 13:34:59', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507535722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13602, '113185', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 12:13:22', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507535722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13601, '113182', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 10:39:34', 'Paid', NULL, '110.00', '121.00', '121.00', NULL, '121.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507535722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13600, '113179', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 09:48:04', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '10.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507535722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13599, '113181', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 10:38:27', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507535722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13598, '113180', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-09 09:49:14', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.30', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507535722', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13650, '113227', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 17:29:50', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507715050', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13630, '113205', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 10:21:44', 'Paid', NULL, '10.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1507715050', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13631, '113209', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 10:47:56', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507715050', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13632, '113216', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 12:22:19', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '97.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507715050', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13633, '113211', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 11:00:15', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '100.00', '75.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507715050', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13634, '113213', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 11:56:32', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507715050', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13635, '113212', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 11:02:17', 'Paid', NULL, '4.00', '4.40', '4.40', NULL, '4.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507715050', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13636, '113217', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 12:47:43', 'Paid', NULL, '96.00', '95.05', '95.05', NULL, '100.05', '5.00', '0.00', '0.00', '10.56', '0.01', 'Cash', NULL, '27', '1507715050', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13637, '113215', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 12:20:32', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '25.10', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507715050', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13638, '113214', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 12:16:36', 'Paid', NULL, '139.00', '152.90', '152.90', NULL, '155.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507715050', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13639, '113218', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 12:54:40', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.10', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507715050', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13640, '113219', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 13:03:02', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507715050', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13641, '113220', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 13:47:48', 'Paid', NULL, '24.00', '23.75', '23.75', NULL, '50.00', '26.25', '0.00', '0.00', '2.64', '-0.01', 'Cash', NULL, '27', '1507715050', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13642, '113221', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 14:53:25', 'Paid', NULL, '19.50', '19.30', '19.30', NULL, '20.00', '0.70', '0.00', '0.00', '2.15', '0.00', 'Cash', NULL, '27', '1507715050', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13643, '113228', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 17:58:32', 'Paid', NULL, '82.00', '81.20', '81.20', NULL, '101.20', '20.00', '0.00', '0.00', '9.02', '0.02', 'Cash', NULL, '27', '1507715050', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13644, '113222', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 15:18:38', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507715050', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13647, '113224', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 16:16:34', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507715050', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13646, '113223', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 15:53:43', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507715050', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13648, '113225', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 16:22:48', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507715050', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13649, '113226', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 16:37:47', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '20.00', '13.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507715050', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13628, '113208', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 10:37:24', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '73.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507715050', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13629, '113210', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 10:50:36', 'Paid', NULL, '113.00', '124.30', '124.30', NULL, '200.00', '75.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507715050', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13627, '113206', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 10:22:46', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '70.00', '8.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507715050', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13626, '113204', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 10:11:13', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '70.00', '8.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507715050', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13625, '113202', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 10:03:24', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507715050', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13624, '113203', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 10:08:06', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507715050', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13623, '113207', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-11 10:23:26', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507715050', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13656, '113231', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-12 10:45:44', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507781947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13657, '113235', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-12 11:50:02', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507781947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13658, '113234', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-12 11:34:36', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '53.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507781947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(13659, '113239', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-10-12 12:34:31', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507781947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13662, '113238', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-12 12:19:15', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507781947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13661, '113237', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-12 12:17:13', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507781947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13663, '113236', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-12 12:06:18', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507781947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13664, '113240', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-12 12:44:29', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507781947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13665, '113241', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-12 12:45:32', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '29.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507781947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13667, '113246', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-12 13:57:45', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507781947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13668, '113244', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-12 13:44:11', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507781947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13669, '113243', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-12 13:38:13', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507781947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13670, '113248', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-12 14:08:06', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507781947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13671, '113247', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-12 14:00:35', 'Paid', NULL, '18.90', '20.80', '20.80', NULL, '21.00', '0.20', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1507781947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13672, '113245', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-12 13:57:11', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507781947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13673, '113249', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-12 14:49:49', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '200.00', '182.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507781947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13675, '113250', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-12 15:59:12', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '45.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507781947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13655, '113232', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-12 10:51:57', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507781947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13654, '113233', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-12 11:07:40', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.00', '3.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507781947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13653, '113242', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-12 13:14:02', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507781947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13652, '113230', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-12 10:42:46', 'Paid', NULL, '103.00', '113.30', '113.30', NULL, '115.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507781947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13651, '113229', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-12 10:24:41', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507781947', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13699, '113273', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 16:51:55', 'Paid', NULL, '12.00', '10.80', '10.80', NULL, '10.80', '0.00', '0.00', '0.00', '1.20', '0.00', 'Cash', NULL, '27', '1507880716', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13698, '113274', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 17:19:43', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507880716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13697, '113270', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 15:45:42', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '100.00', '51.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507880716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13696, '113271', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 15:49:04', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '54.10', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507880716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13695, '113272', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 15:54:23', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '40.00', '1.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507880716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13694, '113266', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 13:54:48', 'Paid', NULL, '16.00', '14.40', '14.40', NULL, '15.00', '0.60', '0.00', '0.00', '1.60', '0.00', 'Cash', NULL, '27', '1507880716', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13693, '113267', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 14:46:16', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '55.10', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507880716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13692, '113268', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 15:06:16', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.40', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507880716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13691, '113269', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 15:11:23', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507880716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13690, '113264', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 13:32:27', 'Paid', NULL, '2.00', '2.20', '2.20', NULL, '10.20', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507880716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13689, '113263', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 13:31:49', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507880716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13688, '113265', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 13:37:35', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507880716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13687, '113259', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 12:31:08', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507880716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13686, '113262', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 13:30:31', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507880716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13681, '113255', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 11:41:57', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '31.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507880716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13682, '113258', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 12:07:57', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507880716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13683, '113260', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 12:33:09', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507880716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13684, '113257', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 12:00:20', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '50.00', '43.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507880716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13685, '113261', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 13:00:44', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507880716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13680, '113254', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 11:31:10', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507880716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13679, '113253', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 11:30:23', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507880716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13678, '113256', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 11:48:22', 'Paid', NULL, '99.00', '108.90', '108.90', NULL, '120.90', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507880716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13677, '113252', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 10:06:08', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507880716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13676, '113251', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-13 10:03:46', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.80', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507880716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13739, '113314', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 16:26:16', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '93.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13743, '113310', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 15:09:21', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13745, '113312', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 15:47:29', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13746, '113313', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 16:17:17', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13747, '113315', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 16:48:26', 'Paid', NULL, '125.00', '137.50', '137.50', NULL, '150.00', '12.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13748, '113316', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 17:53:53', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '103.00', '50.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13734, '113307', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 14:32:17', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13735, '113304', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 14:04:42', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13736, '113306', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 14:23:52', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '100.00', '79.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13737, '113308', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 14:33:32', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '31.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13738, '113305', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 14:08:22', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13728, '113302', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 13:40:52', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13729, '113303', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 13:50:20', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13730, '113296', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 13:08:00', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '36.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13740, '113311', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 15:34:42', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '70.00', '13.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13732, '113299', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 13:25:56', 'Paid', NULL, '16.00', '14.40', '14.40', NULL, '50.00', '35.60', '0.00', '0.00', '1.60', '0.00', 'Cash', NULL, '27', '1507967892', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13733, '113309', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 15:07:46', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13724, '113298', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 13:15:16', 'Paid', NULL, '138.00', '151.80', '151.80', NULL, '200.00', '48.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13725, '113291', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 12:56:02', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13723, '113292', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 12:56:59', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13726, '113295', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 13:03:39', 'Paid', NULL, '21.00', '18.90', '18.90', NULL, '50.00', '31.10', '0.00', '0.00', '2.10', '0.00', 'Cash', NULL, '27', '1507967892', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13722, '113297', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 13:08:16', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13720, '113294', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 12:59:44', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '57.00', '30.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13719, '113301', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 13:29:55', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '54.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13718, '113293', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 12:58:18', 'Paid', NULL, '120.00', '132.00', '132.00', NULL, '150.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13717, '113300', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 13:27:22', 'Paid', NULL, '51.00', '50.50', '50.50', NULL, '50.50', '0.00', '0.00', '0.00', '5.61', '0.01', 'Cash', NULL, '27', '1507967892', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13716, '113290', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 12:17:14', 'Paid', NULL, '97.00', '106.70', '106.70', NULL, '107.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13715, '113288', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 12:00:42', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13714, '113289', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 12:10:37', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13713, '113283', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 11:18:44', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.70', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13711, '113280', 'T10(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 11:07:38', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13712, '113281', 'T10(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 11:08:45', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13705, '113286', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 11:32:44', 'Paid', NULL, '63.00', '62.35', '62.35', NULL, '63.00', '0.65', '0.00', '0.00', '6.93', '-0.02', 'Cash', NULL, '27', '1507967892', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13709, '113282', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 11:17:16', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13708, '113285', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 11:30:02', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13707, '113284', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 11:28:40', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.00', '43.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13706, '113277', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 10:16:42', 'Paid', NULL, '9.90', '10.90', '10.90', NULL, '51.00', '40.10', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13704, '113278', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 10:27:46', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13703, '113276', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 10:15:33', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '100.00', '52.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13702, '113287', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 11:41:03', 'Paid', NULL, '105.00', '115.50', '115.50', NULL, '150.00', '34.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13701, '113279', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 10:34:52', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13700, '113275', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-14 09:55:55', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1507967892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13803, '113372', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 16:41:10', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.50', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13804, '113371', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 16:17:16', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13805, '113369', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 16:04:05', 'Paid', NULL, '27.90', '30.70', '30.70', NULL, '50.00', '19.30', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13806, '113370', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 16:05:22', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13808, '113373', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 16:47:27', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '100.00', '61.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13809, '113374', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 16:54:07', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13810, '113375', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 16:55:51', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13800, '113359', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 14:32:27', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1508052010', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13801, '113368', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 15:46:14', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13798, '113363', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 14:47:15', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13799, '113366', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 15:21:23', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13781, '113341', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 12:24:02', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13782, '113351', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 13:19:05', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13783, '113353', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 13:39:30', 'Paid', NULL, '192.00', '211.20', '211.20', NULL, '211.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13784, '113354', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 13:44:32', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13785, '113348', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 13:06:07', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '50.00', '31.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13786, '113349', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 13:08:21', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13787, '113356', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 13:48:04', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.40', '31.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13788, '113350', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 13:16:43', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '100.00', '70.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13789, '113362', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 14:45:57', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13790, '113358', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 14:11:09', 'Paid', NULL, '191.00', '210.10', '210.10', NULL, '210.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13791, '113360', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 14:33:04', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '60.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13792, '113357', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 14:04:26', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13793, '113361', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 14:39:49', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13794, '113364', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 14:48:52', 'Paid', NULL, '150.00', '165.00', '165.00', NULL, '170.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13795, '113367', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 15:26:08', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13796, '113355', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 13:46:19', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13797, '113365', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 15:21:09', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '68.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13780, '113346', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 12:41:23', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '49.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13778, '113343', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 12:35:54', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13779, '113342', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 12:25:26', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.00', '21.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13772, '113326', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 11:05:33', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13773, '113335', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 11:56:50', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '70.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13774, '113340', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 12:16:04', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13775, '113336', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 11:57:03', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13776, '113347', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 12:45:36', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.00', '20.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13777, '113344', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 12:38:12', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.20', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13771, '113332', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 11:28:31', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '59.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13765, '113330', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 11:25:46', 'Paid', NULL, '35.00', '34.65', '34.65', NULL, '50.00', '15.35', '0.00', '0.00', '3.85', '0.00', 'Cash', NULL, '27', '1508052010', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13766, '113338', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 12:03:49', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13768, '113339', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 12:04:30', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13769, '113334', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 11:43:24', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '100.00', '49.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13770, '113325', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 11:01:39', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13759, '113328', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 11:15:06', 'Paid', NULL, '97.00', '106.70', '106.70', NULL, '110.00', '3.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13760, '113345', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 12:39:58', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '91.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13762, '113337', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 11:59:36', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13763, '113331', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 11:27:19', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13764, '113333', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 11:33:42', 'Paid', NULL, '114.00', '125.40', '125.40', NULL, '126.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13761, '113329', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 11:16:03', 'Paid', NULL, '125.00', '137.50', '137.50', NULL, '150.00', '12.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13758, '113352', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 13:22:31', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '20.00', '12.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13757, '113322', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 10:41:38', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13756, '113324', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 10:58:07', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.20', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13754, '113319', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 10:16:20', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '73.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13755, '113321', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 10:35:35', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '59.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13753, '113327', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 11:09:34', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.20', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13752, '113323', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 10:50:08', 'Paid', NULL, '112.00', '123.20', '123.20', NULL, '150.00', '26.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13751, '113320', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 10:18:08', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '61.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13750, '113317', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 09:56:20', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '105.20', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13749, '113318', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-15 10:12:44', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508052010', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13835, '113401', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 14:35:29', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '104.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13836, '113402', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 14:37:43', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13837, '113397', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 13:57:06', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(13838, '113403', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 14:44:48', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13839, '113400', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 14:27:34', 'Paid', NULL, '19.00', '18.80', '18.80', NULL, '20.00', '1.20', '0.00', '0.00', '2.09', '-0.01', 'Cash', NULL, '27', '1508130625', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13848, '113410', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 16:07:08', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13841, '113413', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 16:53:51', 'Paid', NULL, '10.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1508130625', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13842, '113405', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 15:23:51', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13843, '113406', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 15:24:20', 'Paid', NULL, '30.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', '3.30', '0.00', 'Cash', NULL, '27', '1508130625', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13844, '113414', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 17:07:04', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13845, '113407', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 15:38:45', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '27.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13846, '113409', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 15:39:25', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13847, '113408', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 15:39:06', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13849, '113411', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 16:33:31', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13850, '113412', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 16:42:22', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13826, '113391', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 13:07:10', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13828, '113399', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 14:20:58', 'Paid', NULL, '50.00', '49.50', '49.50', NULL, '49.50', '0.00', '0.00', '0.00', '5.50', '0.00', 'Cash', NULL, '27', '1508130625', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13829, '113395', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 13:49:51', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '100.00', '6.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13830, '113393', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 13:26:01', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13831, '113394', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 13:32:12', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13827, '113387', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 12:23:32', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13816, '113381', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 11:11:25', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '100.00', '42.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13834, '113398', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 14:17:52', 'Paid', NULL, '92.00', '101.20', '101.20', NULL, '101.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13833, '113404', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 15:06:50', 'Paid', NULL, '104.00', '102.95', '102.95', NULL, '105.00', '2.05', '0.00', '0.00', '11.44', '-0.01', 'Cash', NULL, '27', '1508130625', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13832, '113396', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 13:51:01', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13821, '113386', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 12:20:02', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13822, '113390', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 12:48:36', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13824, '113392', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 13:15:02', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '100.00', '18.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13825, '113389', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 12:44:41', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13823, '113388', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 12:32:30', 'Paid', NULL, '137.00', '150.70', '150.70', NULL, '150.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13820, '113385', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 12:17:39', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '50.00', '31.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13817, '113377', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 10:45:03', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1508130625', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13818, '113383', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 11:43:33', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13819, '113384', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 11:56:24', 'Paid', NULL, '167.00', '183.70', '183.70', NULL, '200.70', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13815, '113380', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 11:02:50', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '102.00', '20.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13814, '113382', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 11:25:55', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.00', '4.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13813, '113378', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 10:50:32', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13812, '113379', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 10:57:50', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '100.00', '51.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13811, '113376', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-16 09:53:59', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508130625', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13902, '113463', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 16:45:23', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13903, '113464', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 16:49:55', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13904, '113465', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 17:06:01', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.20', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13905, '113467', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 17:14:21', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '17.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13900, '113468', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 17:26:41', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13901, '113466', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 17:12:34', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '80.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13896, '113459', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 15:58:57', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '56.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13897, '113461', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 16:27:48', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '80.00', '4.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13898, '113460', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 16:20:42', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.70', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13899, '113462', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 16:37:53', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13884, '113440', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 13:01:11', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13874, '113435', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 12:18:00', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13875, '113453', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 14:30:01', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.20', '3.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13876, '113446', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 13:35:03', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13877, '113444', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 13:31:03', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '52.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13878, '113448', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 13:47:42', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.20', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13879, '113445', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 13:32:14', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13880, '113452', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 14:19:15', 'Paid', NULL, '108.00', '118.80', '118.80', NULL, '200.00', '81.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13881, '113437', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 12:57:35', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '37.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13882, '113438', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 12:58:53', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '51.00', '16.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13883, '113439', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 12:59:29', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13885, '113449', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 14:03:38', 'Paid', NULL, '113.00', '124.30', '124.30', NULL, '150.00', '25.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13886, '113441', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 13:09:20', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '100.00', '62.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13887, '113442', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 13:10:06', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13888, '113447', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 13:41:20', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13889, '113451', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 14:16:19', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '105.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13890, '113450', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 14:04:15', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '20.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13891, '113454', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 14:34:52', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '41.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13892, '113455', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 14:39:29', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.00', '20.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13893, '113458', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 15:34:12', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13894, '113456', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 15:04:39', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13895, '113457', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 15:19:13', 'Paid', NULL, '181.00', '199.10', '199.10', NULL, '200.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13865, '113427', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 11:47:08', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '100.00', '5.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13866, '113425', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 11:35:41', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13867, '113432', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 11:56:01', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13868, '113428', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 11:49:32', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '52.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13869, '113434', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 12:15:54', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13870, '113436', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 12:46:57', 'Paid', NULL, '133.00', '146.30', '146.30', NULL, '150.30', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13871, '113443', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 13:11:28', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13872, '113430', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 11:54:33', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '20.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13861, '113426', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 11:43:43', 'Paid', NULL, '111.00', '122.10', '122.10', NULL, '122.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13862, '113433', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 12:08:06', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '77.10', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13863, '113420', 'T1(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 10:57:02', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '38.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13856, '113422', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 11:06:03', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '57.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13864, '113421', 'T1(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 10:57:57', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '40.00', '4.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13857, '113418', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 10:32:52', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '24.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13860, '113424', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 11:33:56', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.10', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13859, '113423', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 11:32:17', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13858, '113429', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 11:51:49', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '48.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13855, '113417', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 10:20:15', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13854, '113416', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 10:19:06', 'Paid', NULL, '127.00', '139.70', '139.70', NULL, '140.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13853, '113415', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 10:17:48', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13852, '113431', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 11:55:14', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13851, '113419', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-18 10:44:47', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508315138', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13928, '113488', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 14:14:04', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13929, '113489', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 14:14:31', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13931, '113490', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 14:55:58', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.00', '41.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13932, '113492', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 15:03:27', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13933, '113491', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 15:01:51', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13934, '113494', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 15:12:06', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '20.00', '10.10', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1508392949', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13935, '113496', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 15:16:11', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '34.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13936, '113498', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 16:10:08', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13937, '113500', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 16:57:35', 'Paid', NULL, '36.00', '32.40', '32.40', NULL, '50.00', '17.60', '0.00', '0.00', '3.60', '0.00', 'Cash', NULL, '27', '1508392949', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13938, '113499', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 16:44:45', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '55.00', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13921, '113484', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 13:31:27', 'Paid', NULL, '167.00', '183.70', '183.70', NULL, '200.00', '16.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13922, '113483', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 13:24:22', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '100.20', '65.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13923, '113486', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 13:43:17', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '50.00', '39.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13924, '113487', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 13:58:38', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.00', '30.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13930, '113497', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 15:16:57', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '38.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13926, '113485', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 13:33:16', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13927, '113493', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 15:08:15', 'Paid', NULL, '101.00', '111.10', '111.10', NULL, '150.00', '38.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13913, '113476', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 10:59:20', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13914, '113478', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 11:14:37', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '102.00', '30.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13915, '113474', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 10:38:59', 'Paid', NULL, '19.00', '18.80', '18.80', NULL, '20.00', '1.20', '0.00', '0.00', '2.09', '-0.01', 'Cash', NULL, '27', '1508392949', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13916, '113481', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 11:46:10', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13917, '113479', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 11:37:45', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '75.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13918, '113480', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 11:43:54', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13919, '113495', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 15:14:37', 'Paid', NULL, '68.00', '67.30', '67.30', NULL, '100.30', '33.00', '0.00', '0.00', '7.48', '-0.02', 'Cash', NULL, '27', '1508392949', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13920, '113482', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 13:13:26', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '101.70', '40.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13909, '113472', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 10:19:52', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '73.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13911, '113469', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 09:48:36', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13912, '113475', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 10:39:57', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.10', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13910, '113473', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 10:22:04', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13908, '113471', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 10:17:32', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13907, '113470', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 10:11:01', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13906, '113477', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-19 11:08:04', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508392949', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13954, '113514', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-20 13:54:22', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508476012', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13955, '113515', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-20 13:54:52', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508476012', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13956, '113522', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-20 15:32:26', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.30', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508476012', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13958, '113518', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-20 14:36:47', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '10.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508476012', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13959, '113519', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-20 14:59:55', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508476012', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13960, '113521', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-20 15:22:31', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '94.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508476012', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13961, '113520', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-20 15:18:29', 'Paid', NULL, '4.00', '4.00', '4.00', NULL, '4.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508476012', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13943, '113510', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-20 12:45:52', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '52.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508476012', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13944, '113504', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-20 11:21:05', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1508476012', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13945, '113507', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-20 12:26:38', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.00', '5.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508476012', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13946, '113506', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-20 12:13:06', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508476012', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13947, '113508', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-20 12:41:44', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.20', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508476012', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13948, '113509', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-20 12:43:44', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508476012', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13949, '113512', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-20 13:30:45', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508476012', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13950, '113513', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-20 13:45:32', 'Paid', NULL, '100.00', '110.00', '110.00', NULL, '110.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508476012', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13951, '113516', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-20 13:55:32', 'Paid', NULL, '33.90', '37.30', '37.30', NULL, '40.00', '2.70', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1508476012', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13952, '113517', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-20 14:20:18', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508476012', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13953, '113511', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-20 13:15:54', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508476012', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13942, '113505', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-20 11:49:23', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508476012', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13941, '113502', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-20 11:00:26', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508476012', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13940, '113503', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-20 11:04:01', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.20', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508476012', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13939, '113501', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-20 10:43:49', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508476012', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14002, '113558', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 16:04:01', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14003, '113559', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 16:19:49', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '69.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(14004, '113560', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 16:24:53', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13985, '113539', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 12:02:43', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '22.20', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13986, '113541', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 12:24:49', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13987, '113545', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 13:20:25', 'Paid', NULL, '130.00', '128.70', '128.70', NULL, '150.00', '21.30', '0.00', '0.00', '14.30', '0.00', 'Cash', NULL, '27', '1508562284', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13988, '113547', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 13:39:50', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13989, '113548', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 13:59:39', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '63.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13990, '113549', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 14:14:38', 'Paid', NULL, '129.00', '141.90', '141.90', NULL, '152.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13991, '113546', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 13:26:43', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(13993, '113551', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 14:43:28', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '13.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13994, '113553', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 15:13:38', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13995, '113562', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 16:43:51', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13996, '113554', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 15:15:08', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '100.00', '6.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13997, '113561', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 16:38:03', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13998, '113555', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 15:19:15', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13999, '113556', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 15:52:27', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14000, '113557', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 15:59:40', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14001, '113563', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 16:44:16', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13966, '113543', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 12:50:11', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '71.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13967, '113526', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 10:46:55', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '106.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13969, '113528', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 11:05:19', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '100.00', '52.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13970, '113536', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 11:55:04', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13984, '113542', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 12:38:41', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.60', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13972, '113533', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 11:24:52', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.30', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13973, '113527', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 11:04:09', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.50', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13978, '113537', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 11:58:01', 'Paid', NULL, '160.00', '176.00', '176.00', NULL, '200.00', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13979, '113540', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 12:22:37', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '72.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13992, '113552', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 14:46:16', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13981, '113544', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 13:15:27', 'Paid', NULL, '70.00', '69.30', '69.30', NULL, '100.30', '31.00', '0.00', '0.00', '7.70', '0.00', 'Cash', NULL, '27', '1508562284', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13982, '113531', 'T13(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 11:22:21', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.00', '7.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13983, '113532', 'T13(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 11:23:24', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13977, '113538', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 12:00:21', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '90.30', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13976, '113535', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 11:45:41', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '75.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13975, '113550', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 14:34:55', 'Paid', NULL, '154.00', '169.40', '169.40', NULL, '169.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13974, '113534', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 11:37:39', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '100.00', '52.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13968, '113529', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 11:15:17', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '100.60', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13965, '113525', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 10:39:16', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '101.70', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13964, '113523', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 09:50:40', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13963, '113530', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 11:15:51', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(13962, '113524', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-21 10:05:35', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.10', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508562284', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14043, '113600', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 16:18:14', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14042, '113599', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 16:12:53', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14025, '113584', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 13:04:28', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14026, '113589', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 14:07:19', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '100.00', '61.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14027, '113585', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 13:39:05', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '55.00', '3.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14028, '113591', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 14:38:46', 'Paid', NULL, '97.00', '106.70', '106.70', NULL, '150.70', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14029, '113587', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 13:48:32', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '31.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14030, '113592', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 15:08:59', 'Paid', NULL, '177.00', '194.70', '194.70', NULL, '200.00', '5.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14031, '113590', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 14:24:35', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '40.60', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14032, '113586', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 13:45:53', 'Paid', NULL, '40.00', '36.00', '36.00', NULL, '36.00', '0.00', '0.00', '0.00', '4.00', '0.00', 'Cash', NULL, '27', '1508644954', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14033, '113588', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 13:48:55', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14034, '113601', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 16:26:32', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14035, '113602', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 16:26:39', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14036, '113593', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 15:19:32', 'Paid', NULL, '118.00', '129.80', '129.80', NULL, '130.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14037, '113594', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 15:29:58', 'Paid', NULL, '52.00', '51.50', '51.50', NULL, '51.50', '0.00', '0.00', '0.00', '5.72', '0.02', 'Cash', NULL, '27', '1508644954', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14038, '113596', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 15:41:26', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14039, '113597', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 15:43:08', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '40.00', '1.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14040, '113595', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 15:40:25', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14041, '113598', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 16:10:39', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '100.00', '62.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14009, '113566', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 10:04:26', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '63.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14010, '113567', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 10:05:56', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '100.00', '67.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14011, '113569', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 10:33:50', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '70.00', '7.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14012, '113571', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 10:50:26', 'Paid', NULL, '262.00', '288.20', '288.20', NULL, '300.00', '11.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14013, '113576', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 11:47:49', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14014, '113574', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 11:24:07', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '70.00', '11.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14015, '113572', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 11:09:16', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14016, '113573', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 11:10:19', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14017, '113575', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 11:44:37', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14018, '113577', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 11:50:16', 'Paid', NULL, '111.00', '122.10', '122.10', NULL, '153.00', '30.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14019, '113579', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 12:23:05', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '67.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14020, '113583', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 13:03:14', 'Paid', NULL, '189.00', '207.90', '207.90', NULL, '210.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14021, '113581', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 12:44:59', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.90', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14022, '113580', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 12:36:14', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14023, '113578', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 11:51:28', 'Paid', NULL, '12.00', '10.80', '10.80', NULL, '15.00', '4.20', '0.00', '0.00', '1.20', '0.00', 'Cash', NULL, '27', '1508644954', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14024, '113582', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 12:45:25', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '100.20', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14008, '113565', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 09:58:37', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14007, '113570', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 10:49:23', 'Paid', NULL, '131.00', '144.10', '144.10', NULL, '150.00', '5.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14006, '113564', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 09:56:14', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14005, '113568', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-22 10:09:37', 'Paid', NULL, '82.50', '90.75', '90.75', NULL, '100.00', '9.25', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508644954', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14051, '113615', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-23 14:51:55', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508732585', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14050, '113608', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-23 12:39:52', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508732585', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14052, '113609', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-23 12:47:50', 'Paid', NULL, '113.00', '124.30', '124.30', NULL, '130.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508732585', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14053, '113607', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-23 12:33:20', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.40', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508732585', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14054, '113613', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-23 14:27:53', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.00', '21.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508732585', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14055, '113616', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-23 15:06:27', 'Paid', NULL, '26.00', '25.75', '25.75', NULL, '25.75', '0.00', '0.00', '0.00', '2.86', '0.01', 'Cash', NULL, '27', '1508732585', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14056, '113610', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-23 13:23:08', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508732585', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14057, '113612', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-23 14:11:41', 'Paid', NULL, '26.00', '25.75', '25.75', NULL, '26.00', '0.25', '0.00', '0.00', '2.86', '0.01', 'Cash', NULL, '27', '1508732585', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14058, '113611', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-23 13:56:33', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508732585', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14059, '113614', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-23 14:43:44', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508732585', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14061, '113617', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-23 15:23:27', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '15.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508732585', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14062, '113619', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-23 17:05:36', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '54.20', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508732585', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14060, '113618', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-23 15:47:57', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508732585', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14048, '113605', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-23 10:22:54', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508732585', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14047, '113606', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-23 10:51:29', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.40', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508732585', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14045, '113604', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-23 10:03:23', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '106.10', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508732585', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14044, '113603', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-23 09:02:07', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '40.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508732585', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14067, '113624', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 10:51:53', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '51.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508909330', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14069, '113630', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 13:22:04', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.30', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508909330', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14070, '113628', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 12:14:28', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '65.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508909330', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14071, '113627', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 12:09:41', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508909330', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14072, '113626', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 12:08:04', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508909330', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14073, '113639', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 15:08:04', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '27.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508909330', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14074, '113631', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 13:22:57', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508909330', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14075, '113632', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 13:29:15', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508909330', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14076, '113629', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 13:11:49', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '27.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508909330', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14077, '113633', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 13:47:28', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508909330', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14078, '113635', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 13:49:46', 'Paid', NULL, '54.00', '53.45', '53.45', NULL, '55.00', '1.55', '0.00', '0.00', '5.94', '-0.01', 'Cash', NULL, '27', '1508909330', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14079, '113634', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 13:47:56', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508909330', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14080, '113636', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 13:53:37', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.20', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508909330', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14081, '113637', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 14:04:35', 'Paid', NULL, '52.90', '52.35', '52.35', NULL, '103.00', '50.65', '0.00', '0.00', '5.82', '-0.02', 'Cash', NULL, '27', '1508909330', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14082, '113638', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 14:04:56', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508909330', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14083, '113642', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 17:16:16', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508909330', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14084, '113640', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 17:02:36', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508909330', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14085, '113641', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 17:12:40', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508909330', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14068, '113625', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 11:39:31', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.50', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508909330', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14066, '113623', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 10:21:06', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508909330', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14065, '113621', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 09:58:55', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508909330', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14064, '113620', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 09:09:43', 'Paid', NULL, '173.00', '190.30', '190.30', NULL, '200.00', '9.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508909330', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14063, '113622', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-25 09:59:21', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508909330', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14090, '113648', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-26 12:13:31', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.50', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508993224', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14091, '113646', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-26 11:35:04', 'Paid', NULL, '101.00', '111.10', '111.10', NULL, '111.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508993224', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14092, '113649', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-26 12:32:01', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508993224', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14093, '113657', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-26 14:00:03', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '63.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508993224', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14094, '113651', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-26 13:36:38', 'Paid', NULL, '180.00', '198.00', '198.00', NULL, '200.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508993224', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14095, '113652', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-26 13:46:44', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '100.00', '5.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508993224', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14096, '113654', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-26 13:48:45', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '14.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508993224', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14097, '113653', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-26 13:48:13', 'Paid', NULL, '45.50', '45.05', '45.05', NULL, '50.00', '4.95', '0.00', '0.00', '5.01', '0.01', 'Cash', NULL, '27', '1508993224', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14098, '113655', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-26 13:51:49', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '55.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508993224', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14099, '113656', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-26 13:55:49', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.30', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508993224', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14100, '113650', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-26 13:36:05', 'Paid', NULL, '29.00', '29.00', '29.00', NULL, '40.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508993224', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14101, '113660', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-26 14:46:11', 'Paid', NULL, '106.00', '116.60', '116.60', NULL, '150.00', '33.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508993224', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14102, '113658', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-26 14:18:53', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508993224', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14103, '113659', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-26 14:30:00', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508993224', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14104, '113663', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-26 16:12:12', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.10', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508993224', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14105, '113664', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-26 16:21:51', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '55.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508993224', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14106, '113661', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-26 15:43:09', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '54.00', '40.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508993224', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14107, '113662', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-26 16:09:09', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '80.00', '16.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508993224', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14089, '113647', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-26 11:35:13', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '103.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508993224', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14088, '113645', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-26 10:31:10', 'Paid', NULL, '12.50', '11.25', '11.25', NULL, '11.25', '0.00', '0.00', '0.00', '1.25', '0.00', 'Cash', NULL, '27', '1508993224', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14087, '113643', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-26 10:26:00', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508993224', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14086, '113644', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-26 10:30:33', 'Paid', NULL, '111.00', '122.10', '122.10', NULL, '200.10', '78.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1508993224', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14112, '113669', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-27 12:15:02', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509065731', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14113, '113670', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-27 13:11:21', 'Paid', NULL, '144.00', '158.40', '158.40', NULL, '200.00', '41.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509065731', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14114, '113671', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-27 13:44:34', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.40', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509065731', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14115, '113676', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-27 14:33:11', 'Paid', NULL, '62.00', '61.40', '61.40', NULL, '61.40', '0.00', '0.00', '0.00', '6.82', '0.02', 'Cash', NULL, '27', '1509065731', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14116, '113672', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-27 13:45:08', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '50.50', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509065731', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14117, '113673', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-27 14:02:14', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509065731', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14118, '113675', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-27 14:32:55', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.50', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509065731', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(14119, '113674', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-27 14:31:59', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '103.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509065731', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14120, '113677', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-27 16:00:02', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509065731', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14110, '113667', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-27 11:08:49', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.00', '19.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509065731', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14111, '113668', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-27 11:29:30', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509065731', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14109, '113666', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-27 10:18:39', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '107.20', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509065731', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14108, '113665', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-27 10:01:40', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '100.00', '73.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509065731', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14165, '113719', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 17:16:27', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14157, '113713', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 15:05:29', 'Paid', NULL, '114.00', '125.40', '125.40', NULL, '150.00', '24.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14160, '113717', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 17:14:55', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14162, '113716', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 16:44:06', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14163, '113718', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 17:15:25', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14158, '113714', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 15:46:29', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.10', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14159, '113715', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 15:49:10', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14156, '113712', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 14:56:31', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '101.30', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14155, '113710', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 14:54:28', 'Paid', NULL, '69.50', '76.45', '76.45', NULL, '100.00', '23.55', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14153, '113708', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 13:55:59', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '103.00', '40.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14152, '113711', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 14:55:25', 'Paid', NULL, '93.00', '102.30', '102.30', NULL, '103.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14151, '113706', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 13:17:21', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14150, '113703', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 12:43:22', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '60.00', '8.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14154, '113709', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 14:48:41', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14149, '113704', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 12:50:30', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14147, '113700', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 12:40:00', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14146, '113701', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 12:41:13', 'Paid', NULL, '140.00', '154.00', '154.00', NULL, '154.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14145, '113707', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 13:18:59', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14144, '113697', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 12:13:06', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '13.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14143, '113696', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 12:03:58', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.00', '3.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14142, '113699', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 12:29:22', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14141, '113694', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 11:57:53', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '31.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14140, '113702', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 12:42:37', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '76.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14139, '113705', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 12:57:27', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14125, '113681', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 10:19:24', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14126, '113682', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 10:33:20', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.10', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14127, '113683', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 10:45:13', 'Paid', NULL, '100.00', '110.00', '110.00', NULL, '110.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14128, '113687', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 11:02:41', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.40', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14129, '113685', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 10:58:39', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '100.20', '65.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14130, '113689', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 11:37:21', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14131, '113691', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 11:42:01', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '69.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14132, '113690', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 11:39:06', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14133, '113688', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 11:23:07', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14134, '113686', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 11:01:22', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14135, '113695', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 12:00:57', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14136, '113698', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 12:13:48', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14137, '113693', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 11:56:42', 'Paid', NULL, '31.00', '30.70', '30.70', NULL, '50.00', '19.30', '0.00', '0.00', '3.41', '0.01', 'Cash', NULL, '27', '1509173804', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14138, '113692', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 11:55:50', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '21.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14124, '113684', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 10:57:32', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '71.00', '3.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14123, '113680', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 10:14:49', 'Paid', NULL, '136.00', '149.60', '149.60', NULL, '1450.00', '1300.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14122, '113679', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 10:05:18', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '83.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14121, '113678', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-28 10:04:12', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509173804', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14216, '113766', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 16:23:42', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '50.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14215, '113767', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 17:08:18', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '52.00', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14212, '113762', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 15:51:03', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14213, '113765', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 16:04:44', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '103.00', '30.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14214, '113768', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 17:08:34', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '15.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14210, '113756', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 14:59:08', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14211, '113761', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 15:26:14', 'Paid', NULL, '16.00', '15.85', '15.85', NULL, '16.00', '0.15', '0.00', '0.00', '1.76', '0.01', 'Cash', NULL, '27', '1509260716', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14204, '113763', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 15:59:33', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14205, '113750', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 14:19:04', 'Paid', NULL, '26.00', '26.00', '26.00', NULL, '40.00', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14206, '113760', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 15:14:57', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14207, '113764', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 16:04:07', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14208, '113759', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 15:13:59', 'Paid', NULL, '47.00', '46.55', '46.55', NULL, '50.00', '3.45', '0.00', '0.00', '5.17', '0.02', 'Cash', NULL, '27', '1509260716', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14209, '113758', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 15:09:49', 'Paid', NULL, '15.90', '17.50', '17.50', NULL, '20.00', '2.50', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14203, '113757', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 15:02:12', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14202, '113753', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 14:34:22', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '20.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14201, '113754', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 14:45:40', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.20', '44.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14200, '113752', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 14:26:25', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14199, '113751', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 14:21:47', 'Paid', NULL, '97.00', '106.70', '106.70', NULL, '110.70', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14193, '113745', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 13:10:18', 'Paid', NULL, '108.00', '118.80', '118.80', NULL, '120.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14194, '113743', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 13:02:01', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '55.00', '3.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14197, '113749', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 14:04:47', 'Paid', NULL, '117.00', '128.70', '128.70', NULL, '150.00', '21.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14195, '113748', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 13:46:07', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14196, '113755', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 14:57:41', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '100.00', '48.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14186, '113737', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 12:30:24', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14187, '113738', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 12:37:38', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.30', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14188, '113736', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 12:21:50', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14189, '113747', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 13:16:30', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14190, '113740', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 12:49:56', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14191, '113744', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 13:03:50', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14192, '113741', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 12:57:18', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.10', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14170, '113726', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 11:16:14', 'Paid', NULL, '95.00', '104.50', '104.50', NULL, '104.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14171, '113724', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 10:55:04', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '80.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14172, '113725', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 11:13:55', 'Paid', NULL, '175.00', '192.50', '192.50', NULL, '200.00', '7.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14173, '113727', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 11:19:17', 'Paid', NULL, '111.00', '122.10', '122.10', NULL, '122.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14174, '113728', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 11:31:13', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.30', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14175, '113729', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 11:32:00', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.00', '43.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14176, '113730', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 11:36:24', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '71.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14177, '113731', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 11:37:19', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14179, '113732', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 11:39:37', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '55.80', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14180, '113742', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 12:59:04', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.10', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14181, '113733', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 11:53:58', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.00', '2.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14182, '113734', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 12:07:16', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14183, '113735', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 12:07:41', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14184, '113739', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 12:41:35', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14185, '113746', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 13:14:39', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14169, '113723', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 10:52:40', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '120.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14168, '113720', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 10:10:00', 'Paid', NULL, '105.00', '103.95', '103.95', NULL, '105.00', '1.05', '0.00', '0.00', '11.55', '0.00', 'Cash', NULL, '27', '1509260716', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14167, '113722', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 10:22:42', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14166, '113721', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-29 10:11:44', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509260716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14219, '113772', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-10-30 11:08:14', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '100.00', '50.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509334527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14220, '113771', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-30 10:24:00', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '50.00', '33.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509334527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14221, '113773', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-30 11:28:09', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509334527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14222, '113775', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-10-30 11:35:35', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509334527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14223, '113774', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-30 11:29:40', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509334527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14224, '113776', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-10-30 11:39:46', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509334527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14225, '113777', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-30 12:13:57', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '28.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509334527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14226, '113778', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-30 12:52:41', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509334527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14229, '113779', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-10-30 14:24:50', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509334527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14228, '113780', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-10-30 14:45:09', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '51.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509334527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14230, '113783', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-10-30 15:22:33', 'Paid', NULL, '25.00', '24.75', '24.75', NULL, '25.00', '0.25', '0.00', '0.00', '2.75', '0.00', 'Cash', NULL, '27', '1509334527', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14231, '113782', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-30 14:55:08', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '100.00', '70.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509334527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14232, '113781', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-30 14:53:49', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '39.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509334527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14233, '113784', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-10-30 17:19:43', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.00', '7.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509334527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14218, '113770', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-10-30 10:05:32', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509334527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14217, '113769', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-10-30 10:04:58', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509334527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14246, '113797', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-01 17:09:57', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509513230', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14245, '113796', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-01 16:31:50', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '30.00', '4.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509513230', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14244, '113794', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-01 14:27:48', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509513230', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14243, '113793', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-11-01 14:27:29', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509513230', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14242, '113795', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-01 14:58:38', 'Paid', NULL, '72.00', '71.30', '71.30', NULL, '71.30', '0.00', '0.00', '0.00', '7.92', '0.02', 'Cash', NULL, '27', '1509513230', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14241, '113792', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-01 13:40:45', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.40', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509513230', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14240, '113791', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-01 13:13:56', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '45.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509513230', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14239, '113788', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-11-01 12:14:29', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509513230', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14238, '113790', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-01 12:59:48', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '80.00', '1.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509513230', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14236, '113787', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-11-01 11:49:26', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509513230', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14237, '113789', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-01 12:16:47', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509513230', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14235, '113786', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-01 10:56:38', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '67.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509513230', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14234, '113785', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-01 10:24:18', 'Paid', NULL, '195.00', '214.50', '214.50', NULL, '250.00', '35.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509513230', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14263, '113812', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 14:05:59', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509595522', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14264, '113815', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 14:18:00', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509595522', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14265, '113811', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 13:54:45', 'Paid', NULL, '22.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', '2.20', '0.00', 'Cash', NULL, '27', '1509595522', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14266, '113818', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 15:42:33', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '100.00', '18.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509595522', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14267, '113816', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 15:07:44', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509595522', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14268, '113819', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 15:52:50', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509595522', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14269, '113820', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 16:13:00', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509595522', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14270, '113821', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 16:46:31', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.00', '7.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509595522', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14262, '113807', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 13:28:32', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509595522', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14261, '113814', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 14:15:28', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509595522', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14260, '113813', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 14:06:50', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509595522', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14259, '113810', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 13:43:14', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '100.00', '71.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509595522', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14258, '113817', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 15:09:52', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509595522', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14256, '113808', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 13:33:02', 'Paid', NULL, '27.00', '26.75', '26.75', NULL, '26.75', '0.00', '0.00', '0.00', '2.97', '0.02', 'Cash', NULL, '27', '1509595522', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14257, '113809', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 13:33:13', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '38.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509595522', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14255, '113805', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 12:54:02', 'Paid', NULL, '166.00', '182.60', '182.60', NULL, '200.00', '17.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509595522', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14254, '113803', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 11:21:51', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509595522', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14253, '113802', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 11:21:08', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509595522', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14252, '113800', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 11:16:23', 'Paid', NULL, '109.00', '119.90', '119.90', NULL, '119.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509595522', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14249, '113798', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 10:39:26', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '40.00', '11.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509595522', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14250, '113804', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 11:28:10', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '70.00', '7.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509595522', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(14251, '113801', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 11:16:57', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.20', '33.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509595522', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14248, '113806', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 13:11:03', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.60', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509595522', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14247, '113799', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-02 10:46:57', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '29.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509595522', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14284, '113835', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-03 14:02:26', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509613823', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14285, '113834', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-11-03 13:37:12', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509613823', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14286, '113836', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-11-03 14:15:04', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '6.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509613823', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14287, '113838', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-03 14:39:04', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.20', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509613823', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14288, '113837', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-03 14:31:15', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509613823', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14289, '113839', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-11-03 15:49:34', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509613823', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14290, '113840', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-03 16:42:24', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509613823', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14291, '113841', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-03 16:49:08', 'Paid', NULL, '12.00', '10.80', '10.80', NULL, '10.80', '0.00', '0.00', '0.00', '1.20', '0.00', 'Cash', NULL, '27', '1509613823', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14281, '113832', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-03 12:26:36', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509613823', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14282, '113831', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-11-03 12:19:03', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '51.40', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509613823', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14283, '113833', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-03 13:04:55', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.10', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509613823', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14280, '113829', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-03 11:57:07', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509613823', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14273, '113823', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-03 10:46:52', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509613823', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14274, '113824', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-03 10:57:58', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509613823', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14279, '113830', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-03 12:05:49', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509613823', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14276, '113828', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-03 11:26:22', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.00', '4.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509613823', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14277, '113825', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-03 10:59:58', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509613823', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14278, '113826', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-03 11:00:34', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509613823', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14272, '113827', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-03 11:01:28', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '6.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509613823', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14271, '113822', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-03 10:41:30', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509613823', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14320, '113870', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 15:48:43', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14321, '113871', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 16:05:19', 'Paid', NULL, '26.00', '25.75', '25.75', NULL, '50.75', '25.00', '0.00', '0.00', '2.86', '0.01', 'Cash', NULL, '27', '1509769719', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14322, '113869', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 15:23:06', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.20', '22.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14318, '113866', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 13:41:29', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14319, '113868', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 13:50:54', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14304, '113856', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 11:46:52', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14305, '113857', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 11:49:00', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14306, '113858', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 12:10:40', 'Paid', NULL, '140.00', '154.00', '154.00', NULL, '165.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14307, '113854', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 11:34:26', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14308, '113860', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 12:29:07', 'Paid', NULL, '120.00', '132.00', '132.00', NULL, '150.00', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14309, '113863', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 12:48:34', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14310, '113861', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 12:39:55', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.00', '32.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14312, '113855', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 11:46:22', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '8.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14313, '113859', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 12:22:51', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14314, '113862', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 12:41:24', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14315, '113867', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 13:47:54', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.50', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14316, '113864', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 13:11:35', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14317, '113865', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 13:17:19', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14301, '113852', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 11:23:03', 'Paid', NULL, '133.00', '146.30', '146.30', NULL, '150.00', '3.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14302, '113850', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 11:13:09', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14303, '113851', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 11:19:26', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14295, '113845', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 10:24:48', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14296, '113846', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 10:36:21', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '120.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14297, '113849', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 11:01:20', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14298, '113847', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 10:41:33', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '14.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14294, '113842', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 09:36:55', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14300, '113848', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 10:59:51', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14299, '113853', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 11:29:58', 'Paid', NULL, '60.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', '6.60', '0.00', 'Cash', NULL, '27', '1509769719', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14293, '113844', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 10:08:42', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14292, '113843', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-04 09:54:09', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509769719', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14347, '113893', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 14:26:07', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509863774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14333, '113880', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 11:41:00', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.00', '43.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509863774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14334, '113884', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 12:37:25', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '150.00', '32.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509863774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14335, '113887', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 13:01:06', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '53.20', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509863774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14336, '113883', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 12:30:33', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509863774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14337, '113885', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 12:37:53', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509863774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14338, '113890', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 13:18:19', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509863774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14339, '113888', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 13:01:31', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.50', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509863774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14340, '113882', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 12:29:05', 'Paid', NULL, '18.00', '17.80', '17.80', NULL, '50.00', '32.20', '0.00', '0.00', '1.98', '-0.02', 'Cash', NULL, '27', '1509863774', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14341, '113886', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 12:51:28', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509863774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14342, '113889', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 13:17:36', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '28.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509863774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14343, '113892', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 14:24:28', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509863774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14344, '113894', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 14:36:20', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509863774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14345, '113891', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 14:19:28', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '100.10', '88.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509863774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14346, '113895', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 15:22:54', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509863774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14332, '113881', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 11:45:18', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.00', '29.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509863774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14331, '113878', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 11:23:10', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509863774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14330, '113875', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 10:56:48', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509863774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14329, '113877', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 11:06:26', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509863774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14328, '113879', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 11:31:29', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509863774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14326, '113876', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 11:03:20', 'Paid', NULL, '122.00', '134.20', '134.20', NULL, '150.00', '15.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509863774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14327, '113872', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 10:18:15', 'Paid', NULL, '12.50', '11.25', '11.25', NULL, '50.00', '38.75', '0.00', '0.00', '1.25', '0.00', 'Cash', NULL, '27', '1509863774', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14325, '113874', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 10:47:32', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509863774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14324, '113873', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-05 10:44:18', 'Paid', NULL, '111.00', '122.10', '122.10', NULL, '122.20', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509863774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14368, '113906', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-06 13:49:49', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '100.40', '19.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509954235', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14367, '113901', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-06 12:55:30', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '80.00', '11.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509954235', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14380, '113912', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-06 15:06:00', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.20', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509954235', 'd', '0', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14366, '113904', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-11-06 13:27:11', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '100.10', '88.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509954235', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14364, '113900', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-06 11:41:03', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '13.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509954235', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14369, '113905', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-06 13:46:41', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.10', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509954235', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14373, '113903', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-06 13:25:18', 'Paid', NULL, '10.80', '10.80', '10.80', NULL, '10.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509954235', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14371, '113902', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-06 13:24:22', 'Paid', NULL, '10.80', '10.80', '10.80', NULL, '10.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509954235', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14374, '113911', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-06 14:22:06', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509954235', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14375, '113909', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-06 14:17:37', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509954235', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14376, '113907', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-06 14:14:09', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509954235', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14377, '113914', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-06 15:50:28', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509954235', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14378, '113908', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-11-06 14:15:53', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509954235', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14379, '113910', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-06 14:20:53', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509954235', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14382, '113913', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-06 15:42:42', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '15.20', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509954235', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14383, '113915', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-06 16:06:44', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509954235', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14351, '113896', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-06 10:13:00', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509954235', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14352, '113899', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-11-06 10:53:59', 'Paid', NULL, '19.00', '18.80', '18.80', NULL, '20.00', '1.20', '0.00', '0.00', '2.09', '-0.01', 'Cash', NULL, '27', '1509954235', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14349, '113898', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-06 10:29:38', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509954235', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14348, '113897', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-06 10:14:13', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.50', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1509954235', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14401, '113930', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-11-08 15:28:05', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.00', '15.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510103209', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14400, '113931', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-11-08 15:46:50', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.10', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510103209', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14399, '113929', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-08 14:37:57', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510103209', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14398, '113927', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-08 14:05:54', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510103209', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14397, '113928', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-08 14:15:11', 'Paid', NULL, '58.00', '57.40', '57.40', NULL, '57.40', '0.00', '0.00', '0.00', '6.38', '-0.02', 'Cash', NULL, '27', '1510103209', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14396, '113926', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-08 13:52:51', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '98.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510103209', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14395, '113924', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-08 13:14:27', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '101.00', '40.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510103209', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14394, '113925', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-08 13:49:53', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '100.00', '6.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510103209', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14393, '113923', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-11-08 12:21:32', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510103209', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14392, '113922', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-08 11:30:29', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.30', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510103209', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14391, '113921', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-08 11:29:58', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '51.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510103209', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14389, '113918', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-08 10:55:05', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '40.20', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510103209', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14390, '113920', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-08 11:21:26', 'Paid', NULL, '104.00', '114.40', '114.40', NULL, '115.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510103209', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14388, '113919', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-08 11:13:33', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.40', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510103209', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14387, '113917', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-08 10:03:42', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '30.30', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510103209', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14386, '113916', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-08 09:37:11', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510103209', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14423, '113952', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-09 16:57:08', 'Paid', NULL, '9.00', '8.90', '8.90', NULL, '20.00', '11.10', '0.00', '0.00', '0.99', '-0.01', 'Cash', NULL, '27', '1510195264', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14422, '113951', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-09 16:50:07', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510195264', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14421, '113950', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-09 16:49:47', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510195264', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14419, '113948', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-09 16:23:51', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.20', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510195264', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14418, '113949', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-09 16:43:20', 'Paid', NULL, '187.00', '205.70', '205.70', NULL, '220.00', '14.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510195264', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14417, '113947', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-09 15:03:02', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510195264', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14414, '113942', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-09 13:38:47', 'Paid', NULL, '97.00', '106.70', '106.70', NULL, '120.00', '13.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510195264', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14415, '113943', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-11-09 13:42:58', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '10.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510195264', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14416, '113945', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-09 14:06:04', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1510195264', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14413, '113941', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-09 13:38:21', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510195264', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14412, '113939', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-09 12:35:49', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '55.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510195264', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14411, '113944', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-11-09 13:52:46', 'Paid', NULL, '58.00', '57.40', '57.40', NULL, '60.00', '2.60', '0.00', '0.00', '6.38', '-0.02', 'Cash', NULL, '27', '1510195264', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14410, '113938', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-09 11:58:52', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.00', '9.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510195264', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14409, '113940', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-09 12:39:01', 'Paid', NULL, '12.00', '10.80', '10.80', NULL, '10.80', '0.00', '0.00', '0.00', '1.20', '0.00', 'Cash', NULL, '27', '1510195264', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14408, '113932', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-09 10:16:55', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510195264', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14407, '113936', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-09 11:03:42', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '70.10', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510195264', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14404, '113937', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-09 11:20:15', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510195264', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14405, '113935', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-09 10:53:26', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510195264', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14406, '113933', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-09 10:24:50', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510195264', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14403, '113946', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-09 14:34:18', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510195264', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14402, '113934', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-09 10:52:55', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '41.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510195264', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14445, '113973', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-10 17:12:34', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510276265', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14444, '113971', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-10 15:45:04', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '50.00', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510276265', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14442, '113970', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-10 14:56:33', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510276265', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14443, '113969', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-10 14:50:36', 'Paid', NULL, '139.00', '152.90', '152.90', NULL, '160.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510276265', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14441, '113974', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-10 17:13:24', 'Paid', NULL, '12.00', '10.80', '10.80', NULL, '10.80', '0.00', '0.00', '0.00', '1.20', '0.00', 'Cash', NULL, '27', '1510276265', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14440, '113966', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-10 13:49:41', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510276265', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14439, '113972', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-10 16:04:25', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510276265', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14437, '113964', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-10 13:30:58', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510276265', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14438, '113967', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-10 14:10:31', 'Paid', NULL, '21.00', '20.80', '20.80', NULL, '50.00', '29.20', '0.00', '0.00', '2.31', '0.01', 'Cash', NULL, '27', '1510276265', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14432, '113962', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-10 12:35:10', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510276265', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14433, '113960', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-10 12:30:30', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '23.50', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510276265', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14434, '113968', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-10 14:45:30', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '30.10', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510276265', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14435, '113963', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-10 13:21:45', 'Paid', NULL, '34.00', '33.65', '33.65', NULL, '100.00', '66.35', '0.00', '0.00', '3.74', '-0.01', 'Cash', NULL, '27', '1510276265', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(14436, '113965', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-10 13:39:10', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510276265', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14431, '113961', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-10 12:31:20', 'Paid', NULL, '35.50', '35.15', '35.15', NULL, '50.15', '15.00', '0.00', '0.00', '3.91', '0.01', 'Cash', NULL, '27', '1510276265', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14430, '113958', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-10 11:37:46', 'Paid', NULL, '149.50', '164.45', '164.45', NULL, '164.45', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510276265', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14426, '113957', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-10 10:53:01', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '39.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510276265', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14427, '113956', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-11-10 10:50:38', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510276265', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14428, '113955', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-10 10:36:03', 'Paid', NULL, '11.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1510276265', 'd', '1.00', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14429, '113959', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-10 12:19:18', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.40', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510276265', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14425, '113954', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-10 10:15:52', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510276265', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14424, '113953', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-10 10:12:58', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510276265', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14469, '113996', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 15:50:22', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510385859', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14470, '113999', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 17:35:05', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510385859', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14464, '113991', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 13:23:35', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510385859', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14465, '113992', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 14:35:10', 'Paid', NULL, '79.00', '78.20', '78.20', NULL, '100.00', '21.80', '0.00', '0.00', '8.69', '-0.01', 'Cash', NULL, '27', '1510385859', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14466, '113998', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 17:07:45', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510385859', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14461, '113994', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 15:22:42', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510385859', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14468, '113997', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 15:57:05', 'Paid', NULL, '165.00', '181.50', '181.50', NULL, '182.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510385859', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14467, '113993', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 15:05:18', 'Paid', NULL, '113.00', '124.30', '124.30', NULL, '130.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510385859', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14462, '113990', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 13:22:09', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510385859', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14463, '113989', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 13:20:51', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '73.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510385859', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14459, '113988', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 12:46:09', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '117.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510385859', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14460, '113995', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 15:37:28', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '53.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510385859', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14456, '113986', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 11:48:13', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '100.00', '50.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510385859', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14457, '113984', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 11:38:43', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510385859', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14458, '113985', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 11:41:13', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '40.50', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510385859', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14454, '113981', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 11:25:14', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.30', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510385859', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14455, '113982', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 11:36:19', 'Paid', NULL, '106.00', '116.60', '116.60', NULL, '120.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510385859', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14453, '113980', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 11:09:16', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '65.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510385859', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14448, '113976', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 10:10:56', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '100.00', '57.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510385859', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14452, '113983', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 11:37:07', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.20', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510385859', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14451, '113978', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 10:17:22', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1510385859', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14450, '113979', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 10:50:54', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510385859', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14449, '113977', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 10:13:34', 'Paid', NULL, '36.00', '35.65', '35.65', NULL, '50.00', '14.35', '0.00', '0.00', '3.96', '0.01', 'Cash', NULL, '27', '1510385859', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14447, '113975', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 10:09:18', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '57.00', '20.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510385859', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14446, '113987', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-11-11 12:07:47', 'Paid', NULL, '211.00', '232.10', '232.10', NULL, '250.00', '17.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510385859', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14514, '114040', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 16:53:06', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14515, '114041', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 17:08:26', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14513, '114043', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 17:27:59', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14502, '114023', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 13:19:05', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '54.00', '30.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14503, '114028', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 13:52:54', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14504, '114033', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 14:44:58', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14505, '114032', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 14:40:15', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.10', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14506, '114034', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 15:08:59', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '100.00', '18.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14507, '114039', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 16:22:47', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14508, '114038', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 16:04:53', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14509, '114042', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 17:27:45', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '53.10', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14510, '114037', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 15:54:49', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14511, '114036', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 15:52:27', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14512, '114035', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 15:38:11', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14499, '114030', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 14:09:47', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14500, '114024', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 13:37:15', 'Paid', NULL, '158.00', '173.80', '173.80', NULL, '175.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14501, '114022', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 13:06:06', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14498, '114019', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 12:45:56', 'Paid', NULL, '11.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1510449408', 'd', '1', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14497, '114031', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 14:25:03', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '20.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14495, '114025', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 13:37:54', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14496, '114027', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 13:40:21', 'Paid', NULL, '137.00', '150.70', '150.70', NULL, '200.70', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14494, '114020', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 12:46:22', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.00', '2.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14491, '114017', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 12:25:18', 'Paid', NULL, '99.00', '108.90', '108.90', NULL, '110.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14492, '114011', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 11:56:48', 'Paid', NULL, '21.00', '18.90', '18.90', NULL, '50.00', '31.10', '0.00', '0.00', '2.10', '0.00', 'Cash', NULL, '27', '1510449408', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14493, '114018', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 12:41:36', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.10', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14487, '114014', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 11:58:42', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.00', '30.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14488, '114021', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 12:57:18', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '93.60', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14489, '114029', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 13:56:26', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14490, '114016', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 12:10:41', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.50', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14485, '114010', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 11:47:23', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14486, '114012', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 11:57:16', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '40.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14481, '114005', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 10:25:47', 'Paid', NULL, '116.00', '127.60', '127.60', NULL, '150.00', '22.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14483, '114020', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 12:48:53', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14484, '114026', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 13:40:00', 'Paid', NULL, '124.00', '136.40', '136.40', NULL, '140.40', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14479, '114015', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 11:59:23', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '35.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14480, '114004', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 10:25:00', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14477, '114002', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 10:18:39', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14478, '114003', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 10:19:22', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14476, '114007', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 10:43:50', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.00', '43.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14473, '114000', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 09:47:56', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14474, '114006', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 10:26:33', 'Paid', NULL, '224.00', '246.40', '246.40', NULL, '250.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14475, '114008', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 11:01:42', 'Paid', NULL, '114.00', '125.40', '125.40', NULL, '150.00', '24.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14472, '114001', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 10:13:17', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '100.00', '5.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14482, '114009', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-11-12 11:44:45', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.70', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510449408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14526, '114051', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-13 14:02:19', 'Paid', NULL, '11.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1510535091', 'd', '1.00', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14527, '114054', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-13 15:47:38', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510535091', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14524, '114055', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-13 16:19:18', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510535091', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14525, '114052', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-13 14:33:51', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '100.00', '18.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510535091', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14522, '114050', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-13 13:04:53', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510535091', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14523, '114053', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-13 14:39:01', 'Paid', NULL, '507.60', '558.35', '558.35', NULL, '560.00', '1.65', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1510535091', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14518, '114048', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-13 11:47:59', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '22.10', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510535091', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14519, '114045', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-13 10:54:11', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1510535091', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14520, '114047', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-11-13 11:10:47', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '5.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510535091', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14521, '114049', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-13 12:30:23', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510535091', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14517, '114044', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-13 10:02:42', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510535091', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14516, '114046', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-13 11:08:46', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510535091', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14542, '114070', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-15 17:02:49', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510707861', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14543, '114071', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-15 17:38:24', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510707861', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14541, '114069', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-11-15 15:20:55', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510707861', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14539, '114068', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-15 15:09:19', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '16.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510707861', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14540, '114063', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-15 13:48:14', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510707861', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14538, '114065', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-15 13:53:53', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.00', '9.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510707861', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14537, '114066', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-15 13:55:32', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510707861', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14531, '114059', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-15 12:18:45', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.00', '41.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510707861', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14532, '114060', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-15 12:43:13', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510707861', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14533, '114061', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-15 12:53:09', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '100.00', '50.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510707861', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14535, '114067', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-15 13:56:01', 'Paid', NULL, '83.90', '92.30', '92.30', NULL, '100.30', '8.00', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1510707861', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14536, '114062', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-15 13:39:46', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510707861', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14534, '114064', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-15 13:49:14', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '67.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510707861', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14529, '114056', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-15 10:20:17', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '30.00', '4.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510707861', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14530, '114058', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-15 11:04:04', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.50', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510707861', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14528, '114057', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-15 10:30:50', 'Paid', NULL, '93.00', '102.30', '102.30', NULL, '120.30', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510707861', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14557, '114084', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-16 16:54:52', 'Paid', NULL, '11.00', '10.90', '10.90', NULL, '10.90', '0.00', '0.00', '0.00', '1.21', '0.01', 'Cash', NULL, '27', '1510794028', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14554, '114081', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-16 15:19:50', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510794028', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14555, '114083', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-16 16:37:24', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510794028', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14556, '114085', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-16 17:18:25', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510794028', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14553, '114079', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-16 14:50:34', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.00', '4.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510794028', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14545, '114073', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-16 10:43:14', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510794028', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14546, '114075', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-16 11:04:51', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510794028', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14547, '114076', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-11-16 12:08:25', 'Paid', NULL, '101.00', '111.10', '111.10', NULL, '111.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510794028', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14548, '114072', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-16 10:39:37', 'Paid', NULL, '11.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1510794028', 'd', '1', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14549, '114077', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-16 12:47:40', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510794028', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14550, '114078', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-16 13:02:17', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510794028', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14551, '114080', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-16 15:01:22', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510794028', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14552, '114082', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-16 15:24:43', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510794028', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14544, '114074', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-16 10:44:01', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510794028', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14572, '114100', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-17 14:14:10', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510880695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14573, '114103', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-17 15:33:38', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '40.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510880695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14574, '114098', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-17 14:00:11', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510880695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14575, '114099', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-17 14:00:40', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510880695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14577, '114104', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-11-17 16:38:38', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510880695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14578, '114105', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-17 17:33:32', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.40', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510880695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14579, '114106', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-17 17:41:11', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.00', '4.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510880695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14568, '114096', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-17 13:37:48', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510880695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14569, '114101', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-11-17 14:49:53', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510880695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14576, '114102', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-17 15:09:00', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '42.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510880695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14571, '114097', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-17 13:38:24', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '36.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510880695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14559, '114087', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-17 10:31:26', 'Paid', NULL, '122.00', '134.20', '134.20', NULL, '134.50', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510880695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14560, '114088', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-11-17 10:48:38', 'Paid', NULL, '116.00', '127.60', '127.60', NULL, '200.00', '72.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510880695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14561, '114091', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-17 11:29:42', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510880695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14562, '114094', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-17 11:48:08', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.20', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510880695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14563, '114092', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-17 11:34:53', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510880695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14564, '114093', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-17 11:36:32', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510880695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14567, '114095', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-17 12:37:08', 'Paid', NULL, '93.00', '102.30', '102.30', NULL, '106.00', '3.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510880695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14566, '114089', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-17 11:17:55', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510880695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14565, '114090', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-17 11:26:45', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '92.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510880695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14558, '114086', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-17 10:30:45', 'Paid', NULL, '165.00', '181.50', '181.50', NULL, '181.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510880695', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14597, '114120', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 12:59:13', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14594, '114119', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 12:22:35', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14595, '114133', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 14:46:00', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '53.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14596, '114123', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 13:27:45', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.40', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14598, '114121', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 13:06:05', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14599, '114128', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 13:30:41', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(14600, '114122', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 13:26:55', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '17.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14601, '114124', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 13:28:26', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14602, '114125', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 13:28:47', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14603, '114126', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 13:29:40', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '24.00', '9.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14604, '114127', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 13:30:21', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '40.00', '3.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14605, '114129', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 13:38:29', 'Paid', NULL, '21.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1510967819', 'd', '1', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14606, '114141', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 15:47:29', 'Paid', NULL, '102.00', '112.20', '112.20', NULL, '115.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14607, '114134', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 14:47:25', 'Paid', NULL, '62.00', '61.40', '61.40', NULL, '61.40', '0.00', '0.00', '0.00', '6.82', '0.02', 'Cash', NULL, '27', '1510967819', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14608, '114137', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 15:06:10', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14609, '114138', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 15:10:33', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14610, '114132', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 14:26:12', 'Paid', NULL, '19.00', '19.00', '19.00', NULL, '50.00', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14611, '114135', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 14:51:46', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14612, '114136', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 14:59:03', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.60', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14613, '114142', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 15:54:49', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '75.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14614, '114140', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 15:34:38', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14615, '114139', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 15:27:04', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14616, '114143', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 16:50:18', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14584, '114111', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 10:44:08', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14585, '114114', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 11:27:15', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '63.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14586, '114113', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 11:17:28', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.20', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14587, '114116', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 11:36:15', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '54.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14589, '114115', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 11:35:36', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14590, '114117', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 11:54:49', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '70.10', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14591, '114118', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 12:12:20', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14592, '114130', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 13:45:05', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '40.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14593, '114131', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 14:20:46', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '67.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14588, '114112', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 11:09:01', 'Paid', NULL, '8.50', '9.35', '9.35', NULL, '10.00', '0.65', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14583, '114110', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 10:27:26', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '52.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14581, '114109', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 10:14:56', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14582, '114108', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 10:03:10', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14580, '114107', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-18 09:56:02', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '30.10', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1510967819', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14657, '114184', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 16:26:51', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.00', '19.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14658, '114182', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 15:45:29', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '20.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14656, '114181', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 15:31:43', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.00', '41.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14640, '114160', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 12:25:57', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '51.00', '27.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14641, '114161', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 12:26:47', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14642, '114162', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 12:27:12', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '51.00', '15.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14643, '114163', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 12:28:21', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '14.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14644, '114164', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 12:28:36', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14646, '114172', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 13:13:00', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '55.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14647, '114168', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 13:03:51', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '65.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14648, '114173', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 13:32:08', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14649, '114179', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 14:56:05', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.00', '32.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14650, '114175', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 14:02:02', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '40.30', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14651, '114177', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 14:16:29', 'Paid', NULL, '99.00', '108.90', '108.90', NULL, '120.00', '11.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14652, '114178', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 14:24:05', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14653, '114176', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 14:05:00', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14654, '114183', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 16:11:35', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.10', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14655, '114180', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 15:26:38', 'Paid', NULL, '163.00', '179.30', '179.30', NULL, '180.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14623, '114149', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 11:09:06', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14624, '114148', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 11:05:19', 'Paid', NULL, '125.00', '137.50', '137.50', NULL, '150.00', '12.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14625, '114147', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 11:02:08', 'Paid', NULL, '51.90', '57.10', '57.10', NULL, '60.00', '2.90', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14626, '114170', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 13:10:08', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '71.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14627, '114152', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 11:30:46', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14628, '114155', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 11:44:42', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14629, '114156', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 11:47:08', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '104.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14630, '114153', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 11:38:00', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '35.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14631, '114151', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 11:23:54', 'Paid', NULL, '19.00', '18.80', '18.80', NULL, '20.00', '1.20', '0.00', '0.00', '2.09', '-0.01', 'Cash', NULL, '27', '1511052202', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14632, '114157', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 11:51:05', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '70.00', '12.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14633, '114167', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 13:03:03', 'Paid', NULL, '99.00', '108.90', '108.90', NULL, '150.00', '41.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14634, '114158', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 12:08:06', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.10', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14635, '114165', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 12:29:22', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '90.00', '17.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14636, '114159', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 12:22:33', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14637, '114169', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 13:07:01', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14645, '114166', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 13:02:08', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '70.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14639, '114171', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 13:10:55', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14622, '114150', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 11:17:16', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14618, '114174', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 13:32:33', 'Paid', NULL, '110.00', '121.00', '121.00', NULL, '151.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14619, '114154', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 11:39:52', 'Paid', NULL, '168.00', '184.80', '184.80', NULL, '190.00', '5.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14620, '114145', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 10:49:18', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14621, '114146', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 10:50:32', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14617, '114144', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-19 09:39:17', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '72.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511052202', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14668, '114194', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-20 13:06:44', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511139560', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14669, '114196', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-20 13:26:09', 'Paid', NULL, '41.90', '46.10', '46.10', NULL, '46.10', '0.00', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1511139560', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14670, '114199', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-20 13:37:15', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511139560', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14671, '114202', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-20 14:23:37', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511139560', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14672, '114195', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-11-20 13:10:56', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '20.00', '14.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511139560', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14673, '114197', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-20 13:29:07', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511139560', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14674, '114198', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-20 13:32:59', 'Paid', NULL, '139.00', '152.90', '152.90', NULL, '152.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511139560', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14675, '114204', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-20 15:42:00', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.20', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511139560', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14676, '114201', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-20 14:13:24', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511139560', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14677, '114200', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-20 13:54:51', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1511139560', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14678, '114205', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-20 16:30:14', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511139560', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14679, '114203', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-20 15:25:50', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511139560', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14662, '114188', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-20 11:33:42', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '35.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511139560', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14664, '114191', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-20 11:48:14', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511139560', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14665, '114192', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-20 12:16:53', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511139560', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14666, '114190', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-20 11:47:33', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511139560', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14660, '114186', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-20 10:19:15', 'Paid', NULL, '31.90', '35.10', '35.10', NULL, '50.00', '14.90', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1511139560', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14667, '114193', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-20 12:59:15', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511139560', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14663, '114189', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-20 11:46:19', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '63.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511139560', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14661, '114187', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-20 10:52:52', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511139560', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14659, '114185', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-20 09:45:55', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '100.00', '50.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511139560', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14683, '114206', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-22 11:53:25', 'Paid', NULL, '12.00', '10.80', '10.80', NULL, '11.00', '0.20', '0.00', '0.00', '1.20', '0.00', 'Cash', NULL, '27', '1511322682', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14686, '114212', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-22 13:54:56', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511322682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14687, '114214', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-22 14:14:35', 'Paid', NULL, '14.00', '13.85', '13.85', NULL, '13.85', '0.00', '0.00', '0.00', '1.54', '-0.01', 'Cash', NULL, '27', '1511322682', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14688, '114210', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-22 13:28:51', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '17.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511322682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14689, '114213', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-22 14:13:48', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1511322682', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14690, '114216', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-22 14:53:10', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '40.00', '14.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511322682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14691, '114215', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-22 14:45:42', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '18.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511322682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14685, '114211', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-22 13:47:08', 'Paid', NULL, '45.00', '44.55', '44.55', NULL, '50.05', '5.50', '0.00', '0.00', '4.95', '0.00', 'Cash', NULL, '27', '1511322682', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14684, '114209', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-22 12:40:30', 'Paid', NULL, '47.00', '46.55', '46.55', NULL, '50.00', '3.45', '0.00', '0.00', '5.17', '0.02', 'Cash', NULL, '27', '1511322682', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14681, '114207', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-11-22 12:01:28', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511322682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14680, '114208', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-22 12:05:25', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '55.20', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511322682', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14710, '114231', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-23 16:02:04', 'Paid', NULL, '11.00', '11.10', '11.10', NULL, '11.10', '0.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1511400080', 'd', '1', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14709, '114235', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-23 17:30:07', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511400080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14708, '114233', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-23 16:45:46', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511400080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14707, '114230', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-23 15:45:52', 'Paid', NULL, '3.00', '2.70', '2.70', NULL, '2.70', '0.00', '0.00', '0.00', '0.30', '0.00', 'Cash', NULL, '27', '1511400080', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14706, '114229', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-23 15:45:28', 'Paid', NULL, '4.00', '4.00', '4.00', NULL, '4.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511400080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14705, '114232', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-23 16:25:52', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '105.10', '60.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511400080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14704, '114227', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-23 15:29:26', 'Paid', NULL, '5.00', '4.50', '4.50', NULL, '4.50', '0.00', '0.00', '0.00', '0.50', '0.00', 'Cash', NULL, '27', '1511400080', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14701, '114226', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-23 15:01:22', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511400080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14702, '114228', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-23 15:42:51', 'Paid', NULL, '46.90', '46.45', '46.45', NULL, '50.00', '3.55', '0.00', '0.00', '5.16', '0.02', 'Cash', NULL, '27', '1511400080', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14703, '114234', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-23 17:16:25', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '101.30', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511400080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14695, '114220', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-23 13:19:31', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511400080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14696, '114224', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-23 14:12:55', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '105.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511400080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14697, '114225', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-23 14:22:13', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '501.00', '483.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511400080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14698, '114222', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-23 13:49:41', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.50', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511400080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14699, '114223', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-11-23 13:52:12', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511400080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14700, '114221', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-23 13:38:54', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511400080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14693, '114218', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-23 11:37:00', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511400080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14694, '114219', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-23 12:48:31', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.30', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511400080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14692, '114217', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-23 10:48:31', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '70.00', '11.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511400080', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14715, '114244', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-24 14:04:16', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511485303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14716, '114245', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-24 14:12:02', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511485303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14717, '114243', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-24 14:02:18', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511485303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14723, '114247', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-24 17:06:48', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.40', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511485303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14719, '114246', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-11-24 14:41:55', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '40.00', '3.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511485303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14720, '114239', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-24 13:25:45', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511485303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14721, '114240', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-24 13:26:06', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '50.00', '33.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511485303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14722, '114241', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-11-24 13:48:20', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511485303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14712, '114236', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-24 12:02:08', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '100.00', '5.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511485303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14713, '114237', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-24 12:54:46', 'Paid', NULL, '90.50', '89.60', '89.60', NULL, '100.60', '11.00', '0.00', '0.00', '9.96', '0.01', 'Cash', NULL, '27', '1511485303', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14714, '114238', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-24 13:01:45', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511485303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14711, '114242', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-24 13:59:34', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511485303', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14747, '114271', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 13:30:13', 'Paid', NULL, '75.90', '83.50', '83.50', NULL, '100.00', '16.50', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14748, '114273', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 14:02:05', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '120.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14757, '114279', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 15:14:08', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '63.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14758, '114285', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 16:15:45', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.00', '20.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14759, '114281', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 15:19:53', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14760, '114283', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 15:52:35', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14761, '114278', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 15:08:56', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14749, '114272', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 13:47:45', 'Paid', NULL, '97.00', '106.70', '106.70', NULL, '110.00', '3.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14750, '114274', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 14:03:15', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14751, '114270', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 13:10:31', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14752, '114280', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 15:14:48', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(14753, '114276', 't4', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 14:53:32', 'Paid', NULL, '58.00', '57.40', '57.40', NULL, '60.50', '3.10', '0.00', '0.00', '6.38', '-0.02', 'Cash', NULL, '27', '1511570825', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14754, '114275', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 14:20:44', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '8.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14755, '114282', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 15:24:52', 'Paid', NULL, '60.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', '6.60', '0.00', 'Cash', NULL, '27', '1511570825', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14762, '114284', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 16:02:49', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.30', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14746, '114277', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 15:05:45', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14745, '114269', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 12:51:06', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '81.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14744, '114267', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 12:13:22', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14743, '114268', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 12:31:45', 'Paid', NULL, '103.00', '113.30', '113.30', NULL, '113.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14742, '114266', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 11:59:44', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14741, '114264', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 11:44:09', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14740, '114263', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 11:42:39', 'Paid', NULL, '96.00', '105.60', '105.60', NULL, '110.00', '4.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14739, '114265', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 11:50:06', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14736, '114258', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 11:14:16', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14737, '114259', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 11:22:18', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.00', '30.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14738, '114260', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 11:25:07', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14725, '114248', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 09:55:49', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14726, '114257', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 11:08:33', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14727, '114250', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 10:04:50', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14728, '114254', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 10:58:30', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14729, '114254', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 11:03:14', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '78.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14730, '114255', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 11:04:26', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14731, '114262', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 11:39:18', 'Paid', NULL, '212.00', '233.20', '233.20', NULL, '233.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14732, '114256', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 11:08:05', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14733, '114261', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 11:34:35', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14734, '114251', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 10:44:16', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14735, '114252', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 10:45:47', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14724, '114249', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-25 10:02:24', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '47.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511570825', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14814, '114334', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 17:24:01', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '54.20', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14812, '114335', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 17:36:42', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '18.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14813, '114333', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 16:56:37', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '38.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14815, '114336', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 17:41:10', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '7.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14807, '114327', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 15:10:31', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '21.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14808, '114329', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 15:57:55', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '103.00', '50.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14809, '114330', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 16:33:59', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.20', '26.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14805, '114328', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 15:40:23', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '54.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14810, '114331', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 16:35:17', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '100.00', '73.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14804, '114324', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 14:34:51', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14803, '114322', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 14:27:10', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14802, '114326', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 14:49:12', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14785, '114314', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 13:12:38', 'Paid', NULL, '114.00', '125.40', '125.40', NULL, '150.00', '24.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14801, '114332', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 16:40:55', 'Paid', NULL, '105.00', '115.50', '115.50', NULL, '200.50', '85.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14800, '114323', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 14:32:26', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14799, '114325', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 14:38:48', 'Paid', NULL, '130.00', '143.00', '143.00', NULL, '150.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14798, '114319', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 14:05:08', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '40.00', '3.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14797, '114320', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 14:14:26', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14796, '114321', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 14:19:58', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14787, '114305', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 12:05:08', 'Paid', NULL, '3.90', '3.90', '3.90', NULL, '3.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14788, '114308', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 12:14:49', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14789, '114313', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 13:09:52', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14790, '114311', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 12:50:43', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14791, '114310', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 12:23:36', 'Paid', NULL, '4.00', '4.00', '4.00', NULL, '4.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14792, '114312', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 13:06:19', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '105.10', '82.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14793, '114316', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 13:25:15', 'Paid', NULL, '96.00', '105.60', '105.60', NULL, '106.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14794, '114317', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 13:29:45', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14795, '114315', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 13:14:57', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14786, '114306', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 12:08:28', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14784, '114307', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 12:14:17', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '40.00', '3.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14783, '114318', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 13:30:52', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '103.00', '20.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14782, '114301', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 11:55:00', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14781, '114298', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 11:42:19', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14780, '114299', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 11:47:39', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '105.20', '81.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14779, '114296', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 11:38:06', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14775, '114300', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 11:49:56', 'Paid', NULL, '115.00', '126.50', '126.50', NULL, '150.00', '23.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14776, '114303', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 12:01:47', 'Paid', NULL, '51.00', '50.50', '50.50', NULL, '51.00', '0.50', '0.00', '0.00', '5.61', '0.01', 'Cash', NULL, '27', '1511689231', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14777, '114309', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 12:18:23', 'Paid', NULL, '159.00', '174.90', '174.90', NULL, '200.00', '25.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14778, '114304', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 12:02:30', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '40.00', '12.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14774, '114297', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 11:38:56', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14773, '114295', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 11:23:33', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '35.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14772, '114294', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 11:13:13', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.00', '3.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14771, '114302', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 11:58:24', 'Paid', NULL, '179.00', '196.90', '196.90', NULL, '200.00', '3.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14770, '114291', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 10:32:47', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14769, '114292', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 10:40:12', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '70.00', '8.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14768, '114289', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 10:10:19', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14767, '114290', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 10:28:28', 'Paid', NULL, '129.00', '141.90', '141.90', NULL, '150.00', '8.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14764, '114288', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 09:52:07', 'Paid', NULL, '96.00', '105.60', '105.60', NULL, '106.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14765, '114287', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 09:45:16', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14766, '114293', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 10:47:19', 'Paid', NULL, '97.00', '106.70', '106.70', NULL, '110.70', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14763, '114286', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-26 09:43:57', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '31.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511689231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14833, '114353', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 12:59:23', 'Paid', NULL, '104.00', '114.40', '114.40', NULL, '150.00', '35.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14834, '114354', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 13:13:27', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14835, '114352', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 12:56:22', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14836, '114356', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 14:11:28', 'Paid', NULL, '143.00', '157.30', '157.30', NULL, '160.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14837, '114358', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 14:52:05', 'Paid', NULL, '150.00', '148.50', '148.50', NULL, '150.00', '1.50', '0.00', '0.00', '16.50', '0.00', 'Cash', NULL, '27', '1511744410', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14838, '114357', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 14:26:54', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14839, '114359', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 15:03:06', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14840, '114360', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 15:07:57', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14841, '114361', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 15:17:54', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '70.00', '16.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14842, '114366', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 17:22:38', 'Paid', NULL, '23.00', '22.75', '22.75', NULL, '50.00', '27.25', '0.00', '0.00', '2.53', '-0.02', 'Cash', NULL, '27', '1511744410', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14843, '114362', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 15:51:11', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14844, '114364', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 16:02:53', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.90', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14845, '114363', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 15:57:37', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '50.00', '29.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14846, '114365', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 16:46:48', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '40.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14847, '114367', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 17:26:12', 'Paid', NULL, '42.00', '42.00', '42.00', NULL, '102.00', '60.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14828, '114344', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 11:14:32', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '36.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14831, '114355', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 13:31:49', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.30', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14832, '114351', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 12:32:58', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '50.00', '40.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14830, '114349', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 12:11:12', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14827, '114345', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 11:14:36', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14826, '114346', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 11:14:39', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14825, '114348', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 12:00:50', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '57.00', '20.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14824, '114343', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 11:13:56', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14829, '114350', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 12:25:08', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14822, '114339', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 10:10:38', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14821, '114347', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 11:20:22', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.60', '40.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14820, '114342', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 10:40:38', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14817, '114338', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 10:05:15', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14819, '114341', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 10:34:29', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.40', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14818, '114340', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 10:18:56', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '46.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14816, '114337', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-27 10:02:35', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511744410', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14863, '114384', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-29 14:11:25', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '80.10', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511917899', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14864, '114383', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-29 14:09:09', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511917899', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14865, '114385', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-29 15:46:49', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511917899', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14866, '114386', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-29 16:26:04', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511917899', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14867, '114387', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-29 17:07:12', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511917899', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14861, '114380', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-29 13:06:24', 'Paid', NULL, '54.00', '53.45', '53.45', NULL, '54.00', '0.55', '0.00', '0.00', '5.94', '-0.01', 'Cash', NULL, '27', '1511917899', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14862, '114381', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-29 13:15:39', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511917899', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14855, '114376', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-29 12:27:48', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.00', '19.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511917899', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14857, '114382', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-11-29 13:17:09', 'Paid', NULL, '7.00', '7.70', '7.70', NULL, '10.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511917899', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14858, '114377', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-11-29 12:33:37', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511917899', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14859, '114375', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-29 12:11:28', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511917899', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14860, '114378', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-29 12:42:51', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511917899', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14856, '114379', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-29 12:56:49', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '61.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511917899', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14854, '114373', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-29 11:48:05', 'Paid', NULL, '114.00', '125.40', '125.40', NULL, '125.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511917899', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14853, '114372', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-11-29 11:17:28', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511917899', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14852, '114371', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-29 10:46:40', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '65.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511917899', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14851, '114369', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-11-29 10:32:31', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.50', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511917899', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14849, '114368', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-29 10:20:42', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '50.00', '31.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511917899', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14850, '114370', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-29 10:34:49', 'Paid', NULL, '113.00', '111.85', '111.85', NULL, '150.00', '38.15', '0.00', '0.00', '12.43', '-0.02', 'Cash', NULL, '27', '1511917899', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14848, '114374', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-29 12:11:00', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '88.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1511917899', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14883, '114401', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 13:53:08', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512017420', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14884, '114402', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 13:53:41', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '40.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512017420', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14886, '114403', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 14:28:09', 'Paid', NULL, '12.00', '10.80', '10.80', NULL, '10.80', '0.00', '0.00', '0.00', '1.20', '0.00', 'Cash', NULL, '27', '1512017420', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14887, '114409', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 15:59:19', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512017420', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14888, '114406', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 15:46:24', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '55.30', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512017420', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14889, '114408', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 15:54:38', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '106.20', '60.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512017420', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14890, '114407', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 15:50:46', 'Paid', NULL, '9.00', '8.10', '8.10', NULL, '50.10', '42.00', '0.00', '0.00', '0.90', '0.00', 'Cash', NULL, '27', '1512017420', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14891, '114410', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 16:03:00', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '8.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512017420', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14880, '114398', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 13:51:26', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '54.10', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512017420', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14881, '114399', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 13:51:58', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '55.20', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512017420', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14882, '114400', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 13:52:30', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '31.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512017420', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14885, '114405', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 14:59:01', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.90', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512017420', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14875, '114394', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 12:59:45', 'Paid', NULL, '27.00', '26.75', '26.75', NULL, '50.00', '23.25', '0.00', '0.00', '2.97', '0.02', 'Cash', NULL, '27', '1512017420', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14876, '114404', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 14:55:47', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.10', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512017420', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14877, '114395', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 13:26:47', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512017420', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14878, '114397', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 13:38:39', 'Paid', NULL, '135.00', '148.50', '148.50', NULL, '150.00', '1.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512017420', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14879, '114396', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 13:35:34', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '50.00', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512017420', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(14873, '114393', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 11:57:04', 'Paid', NULL, '131.00', '144.10', '144.10', NULL, '144.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512017420', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14872, '114392', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 11:37:58', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512017420', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14869, '114389', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 10:57:15', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '120.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512017420', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14870, '114391', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 11:18:52', 'Paid', NULL, '68.00', '67.30', '67.30', NULL, '100.00', '32.70', '0.00', '0.00', '7.48', '-0.02', 'Cash', NULL, '27', '1512017420', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14871, '114388', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 10:44:29', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512017420', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14868, '114390', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-11-30 10:58:48', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512017420', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14906, '114423', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 12:53:53', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '63.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14908, '114427', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 13:20:00', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '200.00', '82.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14911, '114437', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 16:48:53', 'Paid', NULL, '20.90', '20.70', '20.70', NULL, '20.70', '0.00', '0.00', '0.00', '2.30', '0.01', 'Cash', NULL, '27', '1512090445', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14912, '114428', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 14:42:06', 'Paid', NULL, '32.00', '31.70', '31.70', NULL, '50.00', '18.30', '0.00', '0.00', '3.52', '0.02', 'Cash', NULL, '27', '1512090445', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14913, '114432', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 16:01:35', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14914, '114430', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 15:45:58', 'Paid', NULL, '15.00', '14.85', '14.85', NULL, '20.00', '5.15', '0.00', '0.00', '1.65', '0.00', 'Cash', NULL, '27', '1512090445', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14915, '114433', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 16:04:33', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14916, '114434', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 16:05:05', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14917, '114431', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 15:59:40', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14918, '114436', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 16:33:33', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '100.00', '61.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14919, '114440', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 17:49:57', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '21.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14920, '114438', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 17:14:42', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14921, '114439', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 17:38:30', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14922, '114441', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 17:54:44', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '36.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14900, '114419', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 11:50:08', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '30.00', '4.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14899, '114421', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 12:00:44', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14909, '114429', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 14:52:12', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '103.80', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14910, '114435', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 16:15:37', 'Paid', NULL, '55.00', '54.45', '54.45', NULL, '60.00', '5.55', '0.00', '0.00', '6.05', '0.00', 'Cash', NULL, '27', '1512090445', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14907, '114426', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 13:07:15', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '100.20', '43.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14905, '114424', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 12:56:14', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14904, '114425', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 12:57:00', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '75.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14903, '114422', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 12:18:02', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14901, '114420', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 11:55:56', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14902, '114418', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 11:36:07', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14898, '114417', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 11:28:46', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '51.00', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14897, '114414', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 10:45:43', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14893, '114413', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 10:44:48', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14896, '114416', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 10:55:23', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.00', '29.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14895, '114415', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 10:54:32', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.10', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14894, '114412', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 10:36:22', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '100.00', '18.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14892, '114411', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-01 10:26:02', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '100.00', '49.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512090445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14966, '114484', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 16:36:55', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14967, '114483', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 16:30:12', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14968, '114487', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 16:50:07', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '40.00', '2.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14969, '114486', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 16:49:12', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14970, '114485', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 16:37:47', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14964, '114480', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 15:53:33', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14965, '114482', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 16:25:18', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14963, '114479', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 15:16:00', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14962, '114473', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 14:40:48', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14935, '114448', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 10:55:20', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '20.00', '11.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14936, '114455', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 12:29:57', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14937, '114462', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 12:58:49', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '52.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14938, '114477', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 14:56:44', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '41.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14939, '114454', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 12:24:18', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '21.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14940, '114463', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 13:00:26', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '100.00', '42.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14941, '114453', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 12:14:28', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14942, '114456', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 12:34:49', 'Paid', NULL, '68.00', '67.30', '67.30', NULL, '67.30', '0.00', '0.00', '0.00', '7.48', '-0.02', 'Cash', NULL, '27', '1512176007', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14943, '114458', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 12:50:23', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.00', '20.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14944, '114457', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 12:46:51', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14945, '114459', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 12:51:24', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '84.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14958, '114472', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 14:28:24', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '63.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14947, '114464', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 13:18:24', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.00', '41.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14948, '114478', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 14:58:13', 'Paid', NULL, '95.00', '104.50', '104.50', NULL, '150.00', '45.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14949, '114481', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 16:13:06', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '51.00', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14950, '114460', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 12:52:23', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(14951, '114465', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 13:21:10', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '80.00', '5.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14952, '114470', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 13:55:56', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '100.00', '49.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14953, '114466', 'T11A(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 13:27:41', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '40.00', '1.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14954, '114467', 'T11A(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 13:28:29', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14955, '114468', 'T11A(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 13:29:26', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.80', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14956, '114469', 'T11A(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 13:30:09', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '50.00', '31.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14959, '114475', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 14:52:24', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.20', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14960, '114474', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 14:41:48', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14961, '114476', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 14:53:04', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14934, '114447', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 10:55:00', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14933, '114452', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 11:39:48', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '102.00', '20.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14931, '114461', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 12:52:49', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '52.00', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14932, '114450', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 11:11:11', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.30', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14924, '114444', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 10:31:21', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '40.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14925, '114446', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 10:49:07', 'Paid', NULL, '19.00', '18.80', '18.80', NULL, '50.00', '31.20', '0.00', '0.00', '2.09', '-0.01', 'Cash', NULL, '27', '1512176007', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14926, '114445', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 10:40:05', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '52.90', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14927, '114443', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 10:29:59', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '100.00', '18.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14957, '114471', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 14:17:00', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '103.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14929, '114449', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 10:56:42', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14930, '114451', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 11:15:54', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '53.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14923, '114442', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-02 09:54:27', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512176007', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15013, '114527', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 15:22:09', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15014, '114534', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 16:35:08', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.10', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15015, '114532', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 16:03:01', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15016, '114533', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 16:23:17', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15017, '114529', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 15:29:32', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15018, '114531', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 15:38:32', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '15.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15019, '114536', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 17:37:11', 'Paid', NULL, '98.00', '107.80', '107.80', NULL, '107.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15020, '114535', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 17:35:36', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15011, '114528', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 15:29:05', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15012, '114525', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 15:07:09', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15010, '114521', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 14:36:53', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.00', '37.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15008, '114517', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 14:12:20', 'Paid', NULL, '56.90', '62.60', '62.60', NULL, '63.00', '0.40', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(15007, '114516', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 14:11:41', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14983, '114503', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 12:42:24', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14984, '114499', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 12:21:54', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14985, '114498', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 12:17:39', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.10', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14986, '114500', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 12:25:00', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14987, '114504', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 12:58:53', 'Paid', NULL, '158.00', '173.80', '173.80', NULL, '0.00', '-173.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14988, '114512', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 13:54:32', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14989, '114506', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 13:27:31', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14990, '114507', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 13:28:06', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14991, '114510', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 13:45:57', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '71.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14992, '114508', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 13:30:34', 'Paid', NULL, '110.00', '121.00', '121.00', NULL, '121.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14993, '114513', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 13:54:53', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14994, '114515', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 14:09:52', 'Paid', NULL, '237.00', '260.70', '260.70', NULL, '300.00', '39.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14995, '114505', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 13:20:10', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '20.00', '13.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14996, '114511', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 13:51:57', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '102.00', '40.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14997, '114519', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 14:32:09', 'Paid', NULL, '46.90', '51.60', '51.60', NULL, '52.00', '0.40', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14998, '114509', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 13:31:00', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '25.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15009, '114523', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 14:56:49', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15000, '114514', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 14:06:01', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '102.00', '70.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15001, '114518', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 14:17:12', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '100.00', '63.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15002, '114524', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 15:05:19', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '26.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15003, '114526', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 15:07:36', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15004, '114520', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 14:33:34', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15005, '114530', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 15:29:41', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15006, '114522', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 14:54:56', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.10', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14981, '114501', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 12:30:44', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '80.00', '4.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14982, '114497', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 12:03:35', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '120.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14972, '114490', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 10:56:40', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14973, '114489', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 10:50:23', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14974, '114492', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 11:15:53', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14975, '114491', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 11:06:39', 'Paid', NULL, '163.00', '179.30', '179.30', NULL, '200.00', '20.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14976, '114488', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 10:42:44', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '9.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14977, '114493', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 11:26:30', 'Paid', NULL, '168.00', '184.80', '184.80', NULL, '200.00', '15.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14978, '114494', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 11:34:52', 'Paid', NULL, '98.00', '107.80', '107.80', NULL, '108.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14979, '114495', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 11:48:41', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '95.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14980, '114496', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 11:55:02', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(14971, '114502', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-03 12:38:17', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '120.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512276983', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15033, '114548', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 12:24:29', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.70', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15034, '114558', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 15:11:08', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '55.10', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15035, '114550', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 13:08:07', 'Paid', NULL, '49.00', '48.50', '48.50', NULL, '50.00', '1.50', '0.00', '0.00', '5.39', '-0.01', 'Cash', NULL, '27', '1512348404', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15036, '114551', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 13:09:02', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '36.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15037, '114553', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 14:39:18', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.00', '5.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15038, '114555', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 15:00:18', 'Paid', NULL, '43.00', '42.55', '42.55', NULL, '50.00', '7.45', '0.00', '0.00', '4.73', '-0.02', 'Cash', NULL, '27', '1512348404', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15039, '114559', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 15:36:22', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '65.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15040, '114552', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 14:18:42', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '10.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15041, '114556', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 15:02:40', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15042, '114554', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 14:57:53', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15043, '114557', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 15:06:39', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15044, '114562', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 17:25:57', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15045, '114561', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 17:19:58', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '29.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15046, '114563', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 17:28:45', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.10', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(15047, '114560', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 17:17:15', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15022, '114538', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 09:48:35', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '100.00', '67.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15023, '114542', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 11:35:00', 'Paid', NULL, '21.00', '20.80', '20.80', NULL, '50.00', '29.20', '0.00', '0.00', '2.31', '0.01', 'Cash', NULL, '27', '1512348404', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15025, '114540', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 10:54:20', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15026, '114546', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 11:53:06', 'Paid', NULL, '76.00', '75.25', '75.25', NULL, '80.00', '4.75', '0.00', '0.00', '8.36', '0.01', 'Cash', NULL, '27', '1512348404', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15027, '114541', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 11:10:10', 'Paid', NULL, '104.00', '114.40', '114.40', NULL, '150.00', '35.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15028, '114544', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 11:45:54', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '50.30', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15029, '114543', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 11:45:10', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15030, '114545', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 11:50:07', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15031, '114547', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 12:01:07', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15032, '114549', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 12:33:34', 'Paid', NULL, '199.00', '218.90', '218.90', NULL, '220.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15024, '114539', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 10:30:11', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15021, '114537', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-04 09:41:28', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512348404', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15071, '114586', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 16:19:17', 'Paid', NULL, '18.00', '17.80', '17.80', NULL, '20.00', '2.20', '0.00', '0.00', '1.98', '-0.02', 'Cash', NULL, '27', '1512522216', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15072, '114585', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 16:13:22', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.00', '5.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512522216', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15053, '114569', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 11:15:14', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '58.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512522216', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15054, '114571', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 11:52:52', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.30', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512522216', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15055, '114570', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 11:42:06', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.00', '7.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512522216', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15056, '114577', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 13:17:12', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512522216', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15057, '114572', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 12:34:41', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.00', '41.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512522216', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15058, '114573', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 13:00:25', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512522216', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15059, '114578', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 13:22:17', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512522216', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15060, '114574', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 13:13:30', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512522216', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15061, '114579', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 14:12:36', 'Paid', NULL, '42.00', '41.60', '41.60', NULL, '50.00', '8.40', '0.00', '0.00', '4.62', '0.02', 'Cash', NULL, '27', '1512522216', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15062, '114580', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 14:13:11', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512522216', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15063, '114581', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 14:19:40', 'Paid', NULL, '27.00', '26.75', '26.75', NULL, '50.00', '23.25', '0.00', '0.00', '2.97', '0.02', 'Cash', NULL, '27', '1512522216', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15064, '114575', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 13:15:56', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.90', '19.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512522216', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(15065, '114576', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 13:16:55', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512522216', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(15066, '114583', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 14:59:24', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '81.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512522216', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15070, '114584', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 15:29:52', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512522216', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15068, '114582', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 14:24:22', 'Paid', NULL, '18.00', '18.00', '18.00', NULL, '18.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512522216', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15069, '114587', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 16:34:37', 'Paid', NULL, '17.00', '16.85', '16.85', NULL, '20.00', '3.15', '0.00', '0.00', '1.87', '0.02', 'Cash', NULL, '27', '1512522216', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15050, '114565', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 10:17:47', 'Paid', NULL, '98.00', '107.80', '107.80', NULL, '200.00', '92.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512522216', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15051, '114568', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 11:00:16', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512522216', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15052, '114566', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 10:24:29', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512522216', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15049, '114567', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 10:37:33', 'Paid', NULL, '18.00', '17.80', '17.80', NULL, '20.00', '2.20', '0.00', '0.00', '1.98', '-0.02', 'Cash', NULL, '27', '1512522216', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15048, '114564', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-06 09:58:40', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512522216', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15082, '114595', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-07 11:47:33', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '6.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512607716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15083, '114596', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-07 12:09:57', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512607716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15084, '114598', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-07 13:18:04', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512607716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15085, '114600', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-07 14:22:46', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '65.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512607716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15086, '114603', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-07 15:35:44', 'Paid', NULL, '42.00', '41.60', '41.60', NULL, '52.00', '10.40', '0.00', '0.00', '4.62', '0.02', 'Cash', NULL, '27', '1512607716', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15087, '114599', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-07 13:57:06', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512607716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15088, '114601', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-07 14:47:32', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512607716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15089, '114602', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-07 15:09:54', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512607716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15090, '114605', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-12-07 16:41:52', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512607716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15091, '114604', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-07 16:11:31', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '16.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512607716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15074, '114588', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-07 10:13:40', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512607716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15076, '114589', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-07 10:39:18', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512607716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15077, '114594', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-07 11:45:15', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512607716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15078, '114590', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-07 11:00:12', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512607716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15079, '114597', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-07 12:43:07', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '80.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512607716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15080, '114591', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-07 11:12:32', 'Paid', NULL, '24.00', '23.75', '23.75', NULL, '50.00', '26.25', '0.00', '0.00', '2.64', '-0.01', 'Cash', NULL, '27', '1512607716', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15081, '114593', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-07 11:42:04', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512607716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15075, '114592', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-07 11:26:01', 'Paid', NULL, '97.00', '106.70', '106.70', NULL, '150.00', '43.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512607716', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15093, '114606', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 10:00:52', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15094, '114609', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 10:21:20', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15095, '114608', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 10:08:47', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15096, '114612', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 11:36:59', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '93.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15097, '114611', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 11:16:54', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '65.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15098, '114610', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 11:14:42', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15099, '114614', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 12:03:10', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.20', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15100, '114613', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 11:48:21', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15106, '114631', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 17:05:58', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15102, '114617', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 13:27:34', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15107, '114623', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 14:08:47', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.30', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15104, '114615', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 12:38:25', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(15105, '114616', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 12:38:58', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(15108, '114622', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 14:07:13', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '55.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15109, '114619', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 13:44:23', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.30', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15110, '114618', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 13:42:56', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '50.00', '41.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15111, '114624', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 14:19:03', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.00', '21.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15112, '114621', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 13:54:40', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15113, '114620', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 13:53:15', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '50.00', '33.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15114, '114626', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 14:48:46', 'Paid', NULL, '115.00', '126.50', '126.50', NULL, '150.00', '23.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15115, '114627', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 15:16:45', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15116, '114628', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 15:17:25', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15117, '114625', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 14:45:27', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15118, '114630', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 16:06:30', 'Paid', NULL, '25.00', '24.75', '24.75', NULL, '25.00', '0.25', '0.00', '0.00', '2.75', '0.00', 'Cash', NULL, '27', '1512694546', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15119, '114629', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 15:19:54', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15092, '114607', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-08 10:03:20', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512694546', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15155, '114671', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 16:28:10', 'Paid', NULL, '311.00', '342.10', '342.10', NULL, '350.10', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15156, '114673', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 16:36:18', 'Paid', NULL, '118.00', '116.80', '116.80', NULL, '120.00', '3.20', '0.00', '0.00', '12.98', '-0.02', 'Cash', NULL, '27', '1512802134', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15157, '114667', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 15:40:29', 'Paid', NULL, '93.00', '102.30', '102.30', NULL, '105.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15158, '114666', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 15:30:23', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15159, '114675', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 16:54:55', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15160, '114669', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 16:11:50', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15161, '114674', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 16:45:06', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '51.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15162, '114670', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 16:24:15', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15163, '114668', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 15:46:27', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15164, '114672', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 16:29:57', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15165, '114676', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 16:55:59', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15151, '114660', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 14:16:10', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '100.40', '19.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15152, '114658', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 13:51:39', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '100.00', '58.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15153, '114662', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 14:47:54', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15154, '114664', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 14:50:42', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15148, '114665', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 15:14:51', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15149, '114653', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 13:09:02', 'Paid', NULL, '18.00', '16.20', '16.20', NULL, '50.20', '34.00', '0.00', '0.00', '1.80', '0.00', 'Cash', NULL, '27', '1512802134', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15150, '114655', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 13:14:13', 'Paid', NULL, '3.90', '3.90', '3.90', NULL, '3.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15146, '114663', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 14:48:24', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '100.00', '47.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15147, '114652', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 13:07:30', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15145, '114656', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 13:16:35', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15144, '114647', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 12:42:31', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '69.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15143, '114650', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 12:58:51', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '52.00', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15142, '114661', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 14:20:11', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15141, '114654', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 13:10:16', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15140, '114646', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 12:41:47', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '82.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15139, '114657', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 13:37:04', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15138, '114644', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 12:26:19', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '57.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15137, '114645', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 12:39:56', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15134, '114642', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 12:13:04', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.90', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15135, '114641', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 12:07:29', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15136, '114643', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 12:15:28', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15133, '114651', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 13:03:15', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '17.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15132, '114640', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 11:56:44', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '63.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15131, '114639', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 11:51:01', 'Paid', NULL, '118.00', '129.80', '129.80', NULL, '129.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15130, '114648', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 12:45:32', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '64.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15129, '114649', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 12:48:02', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15128, '114659', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 13:52:49', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '69.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15126, '114638', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 11:37:00', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15125, '114637', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 10:55:42', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.10', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15124, '114634', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 10:28:53', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '100.00', '18.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15123, '114635', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 10:29:48', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '53.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15121, '114633', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 10:14:57', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15122, '114636', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 10:33:30', 'Paid', NULL, '17.00', '16.85', '16.85', NULL, '20.00', '3.15', '0.00', '0.00', '1.87', '0.02', 'Cash', NULL, '27', '1512802134', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15120, '114632', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-09 10:13:20', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512802134', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15203, '114710', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 15:42:09', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(15198, '114709', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 15:00:09', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '70.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15202, '114713', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 16:28:15', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '101.00', '50.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15194, '114699', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 13:41:05', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15195, '114708', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 14:35:06', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15196, '114701', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 13:46:38', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '51.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15197, '114703', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 14:08:30', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '58.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15187, '114706', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 14:25:36', 'Paid', NULL, '207.00', '227.70', '227.70', NULL, '250.00', '22.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15188, '114698', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 13:38:33', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.50', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15176, '114686', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 11:15:54', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15201, '114712', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 16:27:11', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.40', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15200, '114711', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 15:42:45', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15199, '114705', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 14:17:10', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15189, '114697', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 13:30:40', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15190, '114700', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 13:41:48', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '61.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15191, '114702', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 13:57:04', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '100.00', '60.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15192, '114707', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 14:33:43', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15193, '114704', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 14:15:31', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '75.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15179, '114688', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 11:33:49', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15180, '114685', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 11:14:24', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15181, '114691', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 12:11:11', 'Paid', NULL, '93.00', '102.30', '102.30', NULL, '103.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(15182, '114695', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 13:05:39', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15183, '114692', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 12:28:54', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15184, '114694', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 12:51:25', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15185, '114693', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 12:46:17', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15186, '114696', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 13:23:07', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '72.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15178, '114687', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 11:18:53', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15177, '114689', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 11:36:40', 'Paid', NULL, '95.00', '104.50', '104.50', NULL, '110.00', '5.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15174, '114684', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 10:48:04', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.10', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15168, '114683', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 10:45:32', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15175, '114690', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 11:56:14', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '35.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15173, '114681', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 10:43:26', 'Paid', NULL, '157.00', '172.70', '172.70', NULL, '200.00', '27.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15172, '114682', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 10:43:59', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15169, '114679', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 10:14:07', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.00', '2.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15171, '114680', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 10:14:37', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '71.00', '10.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15170, '114678', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 10:02:28', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15167, '114677', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-10 09:41:21', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '100.00', '51.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512867626', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15229, '114736', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 15:42:01', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512954184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15230, '114735', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 15:41:57', 'Paid', NULL, '5.00', '5.00', '5.00', NULL, '5.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512954184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15224, '114732', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 13:50:20', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '100.60', '72.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512954184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15225, '114734', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 14:24:12', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512954184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15220, '114731', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 13:40:36', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512954184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15221, '114729', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 12:55:47', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512954184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15222, '114733', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 14:01:08', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512954184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15215, '114724', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 12:12:24', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '51.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512954184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15216, '114721', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 11:58:24', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512954184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15217, '114728', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 12:54:19', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.10', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512954184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15218, '114726', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 12:32:01', 'Paid', NULL, '18.00', '16.20', '16.20', NULL, '50.20', '34.00', '0.00', '0.00', '1.80', '0.00', 'Cash', NULL, '27', '1512954184', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15219, '114727', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 12:53:29', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '6.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512954184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15213, '114722', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 12:00:13', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '75.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512954184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15214, '114723', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 12:06:39', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512954184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15223, '114730', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 13:19:25', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512954184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15210, '114720', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 11:36:28', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512954184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15211, '114719', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 11:29:11', 'Paid', NULL, '20.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', '2.20', '0.00', 'Cash', NULL, '27', '1512954184', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15212, '114718', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 11:18:04', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '35.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512954184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15207, '114715', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 10:26:27', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512954184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15208, '114716', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 10:32:06', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512954184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15205, '114725', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 12:23:54', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512954184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15206, '114717', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 10:43:11', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.30', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512954184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15204, '114714', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-11 09:33:16', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '100.00', '70.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1512954184', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15246, '114749', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-13 16:04:40', 'Paid', NULL, '42.00', '37.80', '37.80', NULL, '50.00', '12.20', '0.00', '0.00', '4.20', '0.00', 'Cash', NULL, '27', '1513127221', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15247, '114753', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-13 17:46:35', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '53.10', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513127221', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15242, '114748', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-13 16:03:36', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513127221', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15243, '114752', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-13 17:29:51', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513127221', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15244, '114750', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-13 17:23:49', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '70.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513127221', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15245, '114751', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-13 17:28:39', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513127221', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15240, '114746', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-13 14:19:48', 'Paid', NULL, '132.00', '145.20', '145.20', NULL, '150.00', '4.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513127221', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15241, '114747', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-13 15:50:10', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '51.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513127221', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15232, '114738', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-13 11:04:21', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '40.70', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513127221', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15233, '114739', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-13 11:12:48', 'Paid', NULL, '100.00', '110.00', '110.00', NULL, '110.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513127221', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15234, '114741', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-13 11:54:07', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '100.00', '70.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513127221', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15235, '114740', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-13 11:46:56', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513127221', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15236, '114745', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-13 14:16:44', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '70.00', '7.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513127221', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15237, '114742', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-13 13:18:12', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '39.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513127221', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15238, '114743', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-13 13:53:09', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513127221', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15239, '114744', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-13 14:09:40', 'Paid', NULL, '60.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', '6.60', '0.00', 'Cash', NULL, '27', '1513127221', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15231, '114737', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-13 10:40:41', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.70', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513127221', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15262, '114768', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-14 16:09:38', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513212408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15259, '114765', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-14 14:28:39', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513212408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15260, '114766', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-14 14:50:30', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513212408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15261, '114767', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-14 15:27:14', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513212408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15250, '114756', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-14 11:40:23', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513212408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15251, '114757', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-14 11:57:03', 'Paid', NULL, '10.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1513212408', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15249, '114755', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-14 11:04:03', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513212408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15252, '114758', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-14 11:57:26', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513212408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15253, '114759', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-14 12:30:42', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513212408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15254, '114760', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-14 12:56:10', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.00', '19.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513212408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15255, '114762', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-14 13:08:37', 'Paid', NULL, '57.00', '56.45', '56.45', NULL, '60.00', '3.55', '0.00', '0.00', '6.27', '0.02', 'Cash', NULL, '27', '1513212408', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15256, '114761', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-14 13:04:08', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513212408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15257, '114763', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-14 14:08:25', 'Paid', NULL, '27.00', '26.75', '26.75', NULL, '30.00', '3.25', '0.00', '0.00', '2.97', '0.02', 'Cash', NULL, '27', '1513212408', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15258, '114764', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-14 14:16:42', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513212408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15248, '114754', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-14 09:52:40', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '107.20', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513212408', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15282, '114788', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-15 16:44:48', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513299774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15283, '114789', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-12-15 17:31:01', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513299774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15278, '114784', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-15 14:03:54', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513299774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15279, '114781', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-15 13:38:44', 'Paid', NULL, '25.00', '24.75', '24.75', NULL, '50.00', '25.25', '0.00', '0.00', '2.75', '0.00', 'Cash', NULL, '27', '1513299774', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(15280, '114786', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-15 14:37:20', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513299774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15281, '114787', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-15 15:44:13', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513299774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15264, '114771', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-15 11:07:18', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513299774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15265, '114772', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-15 11:11:29', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513299774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15266, '114770', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-15 10:49:19', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513299774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15267, '114775', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-15 12:06:17', 'Paid', NULL, '22.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', '2.20', '0.00', 'Cash', NULL, '27', '1513299774', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15268, '114776', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-15 12:14:43', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '68.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513299774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15269, '114774', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-15 12:05:26', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '84.00', '1.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513299774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15270, '114773', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-15 11:38:14', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '50.00', '40.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513299774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15271, '114779', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-15 12:50:46', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '35.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513299774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15272, '114780', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-15 13:11:48', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513299774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15273, '114782', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-15 13:39:27', 'Paid', NULL, '26.00', '25.75', '25.75', NULL, '50.00', '24.25', '0.00', '0.00', '2.86', '0.01', 'Cash', NULL, '27', '1513299774', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15274, '114777', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-15 12:27:09', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513299774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15275, '114778', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-15 12:48:27', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513299774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15276, '114785', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-15 14:10:00', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '72.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513299774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15277, '114783', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-15 13:58:34', 'Paid', NULL, '143.00', '157.30', '157.30', NULL, '160.30', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513299774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15263, '114769', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-15 10:35:17', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '46.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513299774', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15318, '114820', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 15:53:12', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15319, '114825', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 16:55:58', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '57.00', '30.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15320, '114824', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 16:44:18', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '14.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15314, '114818', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 15:49:24', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15315, '114822', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 15:59:46', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15316, '114826', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 17:03:14', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '40.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15317, '114816', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 15:42:29', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '20.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15313, '114817', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 15:48:30', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '80.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15306, '114813', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 14:38:44', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15307, '114810', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 13:59:47', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15308, '114819', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 15:51:30', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15309, '114812', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 14:29:39', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.00', '20.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15310, '114823', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 16:09:36', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15311, '114815', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 15:33:38', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '100.00', '61.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15312, '114814', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 15:05:45', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '71.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15302, '114807', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 13:12:25', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.10', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15303, '114811', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 14:06:58', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15304, '114806', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 13:04:08', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15286, '114792', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 10:10:21', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '72.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15287, '114794', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 10:18:13', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15288, '114791', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 10:01:33', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15285, '114793', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 10:11:02', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15305, '114803', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 12:41:40', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '50.00', '41.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15301, '114821', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 15:55:38', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '150.00', '32.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15300, '114808', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 13:19:03', 'Paid', NULL, '117.00', '128.70', '128.70', NULL, '130.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15299, '114802', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 12:07:04', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15298, '114804', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 12:48:51', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '213.00', '192.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15297, '114809', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 13:47:36', 'Paid', NULL, '225.00', '247.50', '247.50', NULL, '300.00', '52.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15296, '114805', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 12:58:49', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '70.50', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15294, '114799', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 11:04:00', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '100.00', '61.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15295, '114801', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 11:51:30', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15293, '114800', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 11:06:49', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15292, '114798', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 10:49:15', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '60.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15291, '114796', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 10:37:22', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '70.00', '7.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15290, '114797', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 10:45:42', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15289, '114795', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 10:34:11', 'Paid', NULL, '138.00', '151.80', '151.80', NULL, '152.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15284, '114790', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-16 09:45:49', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '100.00', '49.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513386801', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15321, '114830', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 10:33:31', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '50.00', '33.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15357, '114865', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 16:02:02', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '90.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15358, '114864', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 15:51:38', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.30', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15359, '114863', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 15:50:49', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15360, '114866', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 16:46:12', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15356, '114860', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 15:44:35', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '60.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15351, '114859', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 15:24:31', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.10', '44.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15352, '114861', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 15:46:58', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15353, '114852', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 14:10:46', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.50', '8.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15354, '114858', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 15:15:29', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15355, '114854', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 14:20:57', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15350, '114856', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 15:01:53', 'Paid', NULL, '159.00', '174.90', '174.90', NULL, '200.00', '25.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15347, '114846', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 13:42:40', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15348, '114855', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 14:27:01', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15349, '114862', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 15:49:14', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15332, '114837', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 11:25:11', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15333, '114839', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 11:49:08', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15335, '114838', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 11:48:45', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '54.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(15336, '114850', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 14:08:54', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15337, '114840', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 12:25:11', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15338, '114851', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 14:09:17', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15339, '114844', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 13:02:11', 'Paid', NULL, '103.00', '113.30', '113.30', NULL, '120.00', '6.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15340, '114843', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 12:49:34', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '100.00', '42.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15341, '114848', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 13:51:30', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '58.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15342, '114845', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 13:15:48', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15343, '114857', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 15:14:42', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15344, '114847', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 13:49:33', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '100.00', '68.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15345, '114853', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 14:19:47', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '40.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15346, '114849', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 13:58:24', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '51.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15334, '114842', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 12:49:02', 'Paid', NULL, '15.90', '17.50', '17.50', NULL, '18.00', '0.50', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15331, '114841', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 12:40:06', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.10', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15329, '114834', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 10:47:05', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15330, '114835', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 11:10:31', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15328, '114836', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 11:21:00', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15327, '114831', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 10:37:37', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15326, '114833', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 10:44:04', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15325, '114829', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 10:20:30', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '70.00', '11.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15323, '114827', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 09:55:45', 'Paid', NULL, '114.00', '125.40', '125.40', NULL, '150.00', '24.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15324, '114828', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 10:05:53', 'Paid', NULL, '109.00', '119.90', '119.90', NULL, '119.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15322, '114832', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-17 10:39:44', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513470685', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15388, '114893', 'T1(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 17:32:54', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '50.30', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(15389, '114895', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 18:05:21', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '20.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15390, '114896', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 18:06:52', 'Paid', NULL, '34.00', '34.00', '34.00', NULL, '35.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15385, '114894', 'T1(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 17:33:32', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '22.10', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15386, '114892', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 17:00:06', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '46.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15387, '114891', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 16:38:38', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15371, '114877', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 13:26:32', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '73.80', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15372, '114874', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 12:28:29', 'Paid', NULL, '18.00', '16.20', '16.20', NULL, '16.20', '0.00', '0.00', '0.00', '1.80', '0.00', 'Cash', NULL, '27', '1513591586', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15373, '114881', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 13:53:23', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '100.00', '47.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15374, '114880', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 13:52:17', 'Paid', NULL, '63.00', '62.35', '62.35', NULL, '70.00', '7.65', '0.00', '0.00', '6.93', '-0.02', 'Cash', NULL, '27', '1513591586', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15375, '114884', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 14:39:57', 'Paid', NULL, '11.90', '13.10', '13.10', NULL, '15.00', '1.90', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15376, '114882', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 13:55:42', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15377, '114879', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 13:40:44', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '10.00', '4.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15378, '114883', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 14:39:37', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '0.00', '-41.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(15379, '114887', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 14:53:16', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15380, '114885', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 14:41:15', 'Paid', NULL, '1.50', '1.50', '1.50', NULL, '1.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15381, '114886', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 14:51:00', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.80', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15382, '114888', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 14:58:05', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15383, '114889', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 15:09:38', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '6.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15384, '114890', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 16:11:55', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15370, '114876', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 13:03:25', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15368, '114878', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 13:37:28', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '63.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15369, '114875', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 12:29:01', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '52.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15367, '114873', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 10:42:40', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '50.00', '41.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15366, '114871', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 10:30:39', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15365, '114872', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 10:31:12', 'Paid', NULL, '108.00', '118.80', '118.80', NULL, '118.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15362, '114868', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 09:07:14', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15363, '114869', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 09:50:55', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '82.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15364, '114870', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 10:11:08', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '70.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15361, '114867', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-18 09:06:56', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513591586', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15401, '114907', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-20 13:22:34', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513731387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15402, '114905', 'T1(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-20 12:41:11', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513731387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(15403, '114909', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-20 14:29:36', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '52.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513731387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15404, '114908', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-20 13:57:19', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513731387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15405, '114911', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-20 14:38:48', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513731387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15406, '114910', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-20 14:31:50', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513731387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15407, '114914', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-20 15:56:57', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.50', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513731387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15408, '114915', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-20 16:00:31', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.00', '7.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513731387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15409, '114913', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-20 15:51:06', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '27.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513731387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15410, '114916', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-20 16:18:43', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513731387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15398, '114904', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-20 12:31:12', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513731387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15399, '114906', 'T1(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-20 12:41:44', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513731387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15400, '114912', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-20 15:07:45', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '79.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513731387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15397, '114903', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-20 11:29:30', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513731387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15396, '114902', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-20 11:18:35', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513731387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15395, '114901', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-20 10:41:42', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '75.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513731387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15391, '114898', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-20 09:54:36', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.30', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513731387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15392, '114897', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-20 09:41:22', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '77.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513731387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15393, '114900', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-20 10:16:51', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '101.00', '20.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513731387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15394, '114899', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-20 10:12:47', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '67.50', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513731387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15414, '114919', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-12-21 17:33:26', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513843309', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15413, '114917', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-21 16:23:04', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '50.00', '41.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513843309', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15412, '114918', 'IS', 10008, 'lois', NULL, NULL, 'history', '2017-12-21 16:26:17', 'Paid', NULL, '1050.00', '1050.00', '1050.00', NULL, '1050.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513843309', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15438, '114942', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 17:48:03', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513903960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15425, '114930', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 12:27:41', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '100.00', '49.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513903960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15426, '114932', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 12:49:17', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513903960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15427, '114931', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 12:32:51', 'Paid', NULL, '50.90', '56.00', '56.00', NULL, '60.00', '4.00', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1513903960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15428, '114933', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 12:54:12', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '101.00', '22.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513903960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15429, '114934', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 13:01:21', 'Paid', NULL, '59.00', '58.40', '58.40', NULL, '60.00', '1.60', '0.00', '0.00', '6.49', '-0.01', 'Cash', NULL, '27', '1513903960', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15430, '114935', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 13:08:21', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '105.00', '70.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513903960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15431, '114937', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 13:47:39', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '40.00', '13.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513903960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15432, '114936', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 13:27:41', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '70.00', '10.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513903960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15433, '114938', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 14:06:29', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513903960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15434, '114939', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 14:17:42', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513903960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15435, '114941', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 17:03:25', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.00', '9.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513903960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15436, '114940', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 16:03:59', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '100.00', '48.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513903960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15437, '114943', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 17:48:18', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513903960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15422, '114925', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 11:27:16', 'Paid', NULL, '112.00', '123.20', '123.20', NULL, '200.20', '77.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513903960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15423, '114926', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 11:40:42', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513903960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15424, '114929', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 12:15:38', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513903960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15421, '114922', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 10:36:01', 'Paid', NULL, '22.00', '21.80', '21.80', NULL, '50.00', '28.20', '0.00', '0.00', '2.42', '0.02', 'Cash', NULL, '27', '1513903960', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15420, '114927', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 11:42:19', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513903960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15419, '114924', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 11:23:16', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513903960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15418, '114923', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 11:05:37', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513903960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15417, '114928', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 11:56:13', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '67.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513903960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15416, '114920', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 10:08:03', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '102.00', '20.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513903960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15415, '114921', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-22 10:13:09', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513903960', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15464, '114969', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 15:09:19', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '53.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15465, '114970', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 15:28:35', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15466, '114971', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 17:26:49', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.30', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15463, '114968', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 14:44:28', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15458, '114965', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 13:39:45', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '75.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15459, '114962', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 13:28:32', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '100.00', '74.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15460, '114963', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 13:30:44', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.00', '37.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15461, '114960', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 13:16:34', 'Paid', NULL, '12.00', '10.80', '10.80', NULL, '50.00', '39.20', '0.00', '0.00', '1.20', '0.00', 'Cash', NULL, '27', '1513991686', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15462, '114967', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 14:22:06', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15450, '114956', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 12:57:11', 'Paid', NULL, '29.00', '28.70', '28.70', NULL, '50.00', '21.30', '0.00', '0.00', '3.19', '-0.01', 'Cash', NULL, '27', '1513991686', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15451, '114964', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 13:37:58', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15452, '114961', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 13:26:28', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15453, '114966', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 14:01:56', 'Paid', NULL, '201.00', '199.00', '199.00', NULL, '199.00', '0.00', '0.00', '0.00', '22.11', '0.01', 'Cash', NULL, '27', '1513991686', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15454, '114953', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 12:42:58', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.00', '15.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15455, '114954', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 12:44:42', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15456, '114959', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 13:13:26', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.30', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15457, '114958', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 13:10:48', 'Paid', NULL, '54.00', '53.45', '53.45', NULL, '100.00', '46.55', '0.00', '0.00', '5.94', '-0.01', 'Cash', NULL, '27', '1513991686', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15445, '114948', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 11:17:03', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15446, '114949', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 11:20:33', 'Paid', NULL, '143.00', '157.30', '157.30', NULL, '159.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15447, '114951', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 11:40:58', 'Paid', NULL, '192.00', '211.20', '211.20', NULL, '211.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15448, '114952', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 11:43:09', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '102.50', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15449, '114950', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 11:32:28', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.80', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15444, '114947', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 11:03:34', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15443, '114945', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 10:49:10', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15442, '114955', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 12:50:50', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '65.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15441, '114946', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 10:56:35', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '53.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15440, '114957', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 13:06:17', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15439, '114944', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-23 10:07:44', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '60.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1513991686', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15497, '115000', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 15:41:52', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15498, '115001', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 15:46:07', 'Paid', NULL, '140.00', '154.00', '154.00', NULL, '154.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15499, '115002', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 15:54:38', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15500, '115005', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 16:46:07', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '100.00', '62.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15501, '115003', 'T9', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 16:01:57', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15502, '115004', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 16:44:13', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15503, '115006', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 17:19:29', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15496, '114998', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 14:14:39', 'Paid', NULL, '3.90', '4.30', '4.30', NULL, '10.00', '5.70', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15493, '114999', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 15:06:18', 'Paid', NULL, '168.00', '184.80', '184.80', NULL, '200.00', '15.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15490, '114995', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 13:26:26', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15491, '114992', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 12:41:35', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '34.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15495, '114997', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 14:00:50', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '80.00', '5.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15483, '114990', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 11:48:41', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15480, '114985', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 11:31:29', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '75.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15481, '114988', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 11:40:20', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15482, '114989', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 11:46:44', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15474, '114977', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 10:33:30', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15475, '114979', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 10:55:56', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '43.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15473, '114975', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 10:13:14', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15494, '114996', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 13:45:19', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '17.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(15492, '114994', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 12:51:41', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15488, '114991', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 11:59:22', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15487, '114993', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 12:49:02', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15486, '114986', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 11:32:04', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15485, '114987', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 11:36:10', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15479, '114982', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 11:07:33', 'Paid', NULL, '75.50', '83.05', '83.05', NULL, '100.05', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15478, '114981', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 11:05:30', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '110.00', '15.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15477, '114983', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 11:12:19', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.10', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15476, '114976', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 10:25:16', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15472, '114974', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 10:10:15', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.70', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15471, '114973', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 10:08:25', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15470, '114972', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 09:59:36', 'Paid', NULL, '118.00', '129.80', '129.80', NULL, '129.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15469, '114984', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 11:16:19', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15468, '114978', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 10:46:18', 'Paid', NULL, '136.00', '149.60', '149.60', NULL, '150.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15467, '114980', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-24 11:00:23', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514076984', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15554, '115054', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 15:29:30', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15555, '115057', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 16:07:44', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.00', '3.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15556, '115061', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 17:25:53', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15557, '115058', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 17:03:11', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15558, '115060', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 17:16:15', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15559, '115062', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 17:40:13', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15560, '115059', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 17:12:35', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15553, '115052', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 15:17:22', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15549, '115049', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 14:37:14', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15550, '115050', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 14:40:08', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '40.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15551, '115051', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 14:50:26', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15552, '115053', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 15:18:09', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '71.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15548, '115056', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 15:59:44', 'Paid', NULL, '139.00', '152.90', '152.90', NULL, '160.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15547, '115048', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 14:27:00', 'Paid', NULL, '116.00', '127.60', '127.60', NULL, '150.00', '22.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15545, '115044', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 13:58:02', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '53.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15546, '115043', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 13:50:14', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15543, '115055', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 15:54:39', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15544, '115045', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 14:06:20', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15531, '115024', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 11:41:43', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15532, '115033', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 12:31:43', 'Paid', NULL, '138.00', '151.80', '151.80', NULL, '155.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15533, '115037', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 12:42:20', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '59.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15534, '115040', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 12:57:56', 'Paid', NULL, '41.50', '45.65', '45.65', NULL, '100.00', '54.35', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15535, '115039', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 12:53:32', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15536, '115047', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 14:24:07', 'Paid', NULL, '110.00', '121.00', '121.00', NULL, '151.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15537, '115042', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 13:17:05', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '90.30', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15538, '115036', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 12:42:14', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15539, '115034', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 12:37:45', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15540, '115041', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 13:00:24', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15541, '115046', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 14:21:54', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15542, '115035', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 12:38:11', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '101.00', '90.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15530, '115038', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 12:46:18', 'Paid', NULL, '55.50', '61.05', '61.05', NULL, '101.10', '40.05', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15529, '115032', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 12:23:03', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.00', '21.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15528, '115029', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 12:10:08', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15527, '115030', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 12:11:36', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '70.00', '10.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15517, '115018', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 11:19:27', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15518, '115017', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 11:16:57', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15519, '115020', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 11:26:29', 'Paid', NULL, '92.00', '101.20', '101.20', NULL, '101.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15520, '115025', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 11:42:27', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15521, '115027', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 11:59:29', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '53.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15522, '115023', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 11:40:56', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15523, '115031', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 12:19:02', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.10', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15524, '115028', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 12:06:28', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15525, '115022', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 11:37:35', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15526, '115026', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 11:49:35', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15515, '115021', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 11:27:45', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '103.00', '10.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15516, '115019', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 11:24:40', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15514, '115016', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 11:15:27', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '100.00', '42.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15513, '115014', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 11:12:45', 'Paid', NULL, '114.00', '125.40', '125.40', NULL, '126.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15512, '115012', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 10:40:12', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '101.00', '20.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15511, '115015', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 11:15:06', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.00', '30.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15510, '115013', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 10:57:39', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.10', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15509, '115010', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 10:25:15', 'Paid', NULL, '133.00', '131.65', '131.65', NULL, '150.00', '18.35', '0.00', '0.00', '14.63', '-0.02', 'Cash', NULL, '27', '1514162528', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15508, '115007', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 09:39:51', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15507, '115011', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 10:26:35', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '53.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15506, '115008', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 09:57:16', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15505, '115009', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-25 10:08:09', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '104.00', '40.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514162528', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15581, '115083', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 14:36:03', 'Paid', NULL, '38.00', '37.60', '37.60', NULL, '37.60', '0.00', '0.00', '0.00', '4.18', '-0.02', 'Cash', NULL, '27', '1514336956', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15582, '115090', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 15:13:58', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.70', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15583, '115086', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 14:45:06', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15584, '115087', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 15:06:14', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '71.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15585, '115079', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 14:15:09', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '51.80', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(15586, '115080', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 14:15:38', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(15587, '115081', 'T12(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 14:15:59', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(15589, '115088', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 15:09:57', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15590, '115097', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 16:09:59', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15591, '115084', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 14:36:43', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '38.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15592, '115095', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 15:44:07', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '100.00', '5.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15593, '115091', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 15:15:39', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15594, '115096', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 16:01:41', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '22.10', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15595, '115093', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 15:22:08', 'Paid', NULL, '9.00', '8.90', '8.90', NULL, '10.00', '1.10', '0.00', '0.00', '0.99', '-0.01', 'Cash', NULL, '27', '1514336956', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15577, '115089', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 15:13:12', 'Paid', NULL, '94.00', '103.40', '103.40', NULL, '110.50', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15588, '115092', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 15:18:29', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '81.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15576, '115076', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 13:12:36', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '100.00', '70.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15566, '115069', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 11:23:46', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15597, '115098', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 16:34:14', 'Paid', NULL, '112.00', '123.20', '123.20', NULL, '150.20', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15571, '115072', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 11:57:28', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15596, '115094', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 15:23:37', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '56.40', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15568, '115068', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 11:16:26', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '54.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15580, '115085', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 14:39:31', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.00', '30.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15579, '115082', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 14:20:17', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15578, '115078', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 13:18:34', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '102.70', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15574, '115075', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 12:54:54', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15573, '115074', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 12:49:08', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '52.00', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15572, '115077', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 13:16:11', 'Paid', NULL, '67.00', '66.35', '66.35', NULL, '70.35', '4.00', '0.00', '0.00', '7.37', '0.02', 'Cash', NULL, '27', '1514336956', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15569, '115070', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 11:32:34', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.00', '7.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15570, '115073', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 12:26:29', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '82.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15567, '115067', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 10:59:15', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.50', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15564, '115066', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 10:55:31', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.20', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15565, '115071', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 11:52:50', 'Paid', NULL, '189.00', '207.90', '207.90', NULL, '210.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15563, '115065', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 10:48:55', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.30', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15562, '115063', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 10:03:55', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15561, '115064', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-27 10:20:20', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514336956', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15614, '115116', 'T13', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 15:53:45', 'Paid', NULL, '29.90', '32.90', '32.90', NULL, '50.90', '18.00', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1514421741', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15615, '115115', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 15:50:10', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514421741', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15616, '115118', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 16:36:42', 'Paid', NULL, '14.00', '13.85', '13.85', NULL, '15.00', '1.15', '0.00', '0.00', '1.54', '-0.01', 'Cash', NULL, '27', '1514421741', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15617, '115119', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 16:42:58', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '31.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514421741', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15618, '115117', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 16:03:04', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.20', '16.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514421741', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15619, '115120', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 17:23:47', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '51.00', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514421741', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15620, '115121', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 17:32:23', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514421741', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15613, '115114', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 15:21:58', 'Paid', NULL, '102.00', '101.00', '101.00', NULL, '101.00', '0.00', '0.00', '0.00', '11.22', '0.02', 'Cash', NULL, '27', '1514421741', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15608, '115109', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 13:38:18', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '71.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514421741', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15609, '115112', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 14:56:09', 'Paid', NULL, '25.00', '22.50', '22.50', NULL, '50.00', '27.50', '0.00', '0.00', '2.50', '0.00', 'Cash', NULL, '27', '1514421741', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15610, '115111', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 14:02:21', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514421741', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15611, '115110', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 13:42:33', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.00', '7.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514421741', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15612, '115113', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 15:14:36', 'Paid', NULL, '129.00', '141.90', '141.90', NULL, '152.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514421741', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15607, '115108', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 13:13:18', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514421741', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15604, '115105', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 12:51:04', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '68.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514421741', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15605, '115106', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 12:53:31', 'Paid', NULL, '112.00', '123.20', '123.20', NULL, '123.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514421741', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15606, '115107', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 13:04:02', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514421741', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15603, '115104', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 12:13:25', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '50.00', '33.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514421741', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15602, '115102', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 11:40:37', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514421741', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15601, '115103', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 12:05:39', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.50', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514421741', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15600, '115101', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 10:34:47', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514421741', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15599, '115099', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 10:10:30', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.00', '5.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514421741', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15598, '115100', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-28 10:12:12', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514421741', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15648, '115147', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 15:03:19', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15649, '115150', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 16:28:15', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.10', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15650, '115152', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 17:03:57', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15651, '115151', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 16:31:18', 'Paid', NULL, '28.00', '28.00', '28.00', NULL, '50.00', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15646, '115148', '3', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 15:18:17', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15647, '115149', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 15:34:13', 'Paid', NULL, '21.00', '20.80', '20.80', NULL, '51.00', '30.20', '0.00', '0.00', '2.31', '0.01', 'Cash', NULL, '27', '1514509445', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15637, '115140', '4', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 13:36:02', 'Paid', NULL, '117.00', '128.70', '128.70', NULL, '200.00', '71.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15638, '115137', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 12:41:17', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15639, '115139', '12', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 13:28:51', 'Paid', NULL, '158.00', '173.80', '173.80', NULL, '200.00', '26.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15640, '115138', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 12:42:40', 'Paid', NULL, '1.50', '1.50', '1.50', NULL, '1.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15641, '115141', '7', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 14:07:47', 'Paid', NULL, '131.00', '144.10', '144.10', NULL, '145.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15642, '115146', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 14:53:46', 'Paid', NULL, '48.00', '47.50', '47.50', NULL, '50.00', '2.50', '0.00', '0.00', '5.28', '-0.02', 'Cash', NULL, '27', '1514509445', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15643, '115143', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 14:17:45', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15644, '115142', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 14:16:55', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.10', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15645, '115145', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 14:53:11', 'Paid', NULL, '53.10', '52.55', '52.55', NULL, '60.00', '7.45', '0.00', '0.00', '5.84', '-0.02', 'Cash', NULL, '27', '1514509445', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15636, '115144', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 14:39:31', 'Paid', NULL, '29.00', '28.70', '28.70', NULL, '40.00', '11.30', '0.00', '0.00', '3.19', '-0.01', 'Cash', NULL, '27', '1514509445', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(15627, '115128', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 11:03:55', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15628, '115127', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 10:54:54', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '100.00', '61.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15629, '115132', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 11:34:40', 'Paid', NULL, '131.00', '144.10', '144.10', NULL, '155.00', '10.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15630, '115130', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 11:28:52', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15631, '115133', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 11:57:42', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.10', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15632, '115131', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 11:33:34', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15633, '115136', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 12:26:15', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15634, '115135', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 12:19:21', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15635, '115134', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 12:02:30', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15626, '115124', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 10:01:17', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15625, '115126', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 10:44:04', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15624, '115129', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 11:09:16', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15623, '115125', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 10:31:10', 'Paid', NULL, '114.00', '125.40', '125.40', NULL, '125.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15622, '115123', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 10:00:29', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '100.00', '18.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15621, '115122', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-29 09:29:47', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514509445', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15693, '115190', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 16:41:19', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.10', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15691, '115191', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 16:52:50', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '61.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15692, '115192', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 17:36:02', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.00', '20.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15688, '115187', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 16:02:14', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15689, '115189', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 16:13:17', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15680, '115181', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 15:22:50', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15681, '115182', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 15:35:03', 'Paid', NULL, '106.00', '116.60', '116.60', NULL, '150.00', '33.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15682, '115179', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 14:42:11', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.00', '7.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15683, '115186', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 15:57:33', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15684, '115183', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 15:45:43', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15685, '115180', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 15:17:24', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15686, '115185', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 15:56:51', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '51.90', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15687, '115184', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 15:54:23', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15678, '115188', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 16:09:56', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.00', '29.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15679, '115177', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 14:19:54', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15669, '115165', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 11:04:14', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15670, '115169', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 11:18:25', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15671, '115166', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 11:05:27', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '10.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15672, '115172', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 12:32:14', 'Paid', NULL, '12.00', '10.80', '10.80', NULL, '20.00', '9.20', '0.00', '0.00', '1.20', '0.00', 'Cash', NULL, '27', '1514595837', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15673, '115173', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 13:32:48', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '85.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15674, '115175', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 14:01:45', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '82.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15675, '115176', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 14:17:37', 'Paid', NULL, '136.00', '149.60', '149.60', NULL, '150.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15676, '115174', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 13:58:23', 'Paid', NULL, '106.00', '104.95', '104.95', NULL, '110.00', '5.05', '0.00', '0.00', '11.66', '0.01', 'Cash', NULL, '27', '1514595837', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15677, '115178', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 14:26:44', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15667, '115164', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 11:03:02', 'Paid', NULL, '109.00', '119.90', '119.90', NULL, '120.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15668, '115168', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 11:12:03', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15657, '115153', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 10:01:13', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '100.00', '6.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15658, '115159', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 10:20:37', 'Paid', NULL, '64.00', '63.35', '63.35', NULL, '63.35', '0.00', '0.00', '0.00', '7.04', '-0.01', 'Cash', NULL, '27', '1514595837', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15659, '115156', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 10:10:26', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15660, '115155', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 10:09:28', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '40.60', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15661, '115161', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 10:30:02', 'Paid', NULL, '123.00', '135.30', '135.30', NULL, '150.30', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15662, '115170', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 11:24:10', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '61.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15663, '115162', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 10:56:03', 'Paid', NULL, '185.50', '204.05', '204.05', NULL, '205.00', '0.95', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15666, '115167', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 11:06:25', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '65.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15665, '115163', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 10:56:35', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '100.00', '58.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15656, '115158', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 10:11:58', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.00', '20.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15655, '115160', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 10:26:36', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15654, '115157', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 10:10:51', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '46.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15653, '115171', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 11:33:59', 'Paid', NULL, '145.00', '159.50', '159.50', NULL, '160.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15652, '115154', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-30 10:07:49', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '100.00', '78.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514595837', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15741, '115239', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 14:46:07', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '80.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15742, '115238', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 14:42:07', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '20.80', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15743, '115242', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 15:53:24', 'Paid', NULL, '60.28', '66.30', '66.30', NULL, '100.00', '33.70', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15744, '115245', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 16:36:59', 'Paid', NULL, '45.28', '49.80', '49.80', NULL, '50.00', '0.20', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15745, '115246', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 16:38:48', 'Paid', NULL, '100.00', '110.00', '110.00', NULL, '150.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15746, '115243', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 16:17:23', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15747, '115244', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 16:17:29', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '28.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15748, '115247', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 16:42:32', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '100.10', '88.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15749, '115248', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 17:17:47', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '51.90', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15734, '115229', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 13:27:54', 'Paid', NULL, '26.90', '29.60', '29.60', NULL, '100.00', '70.40', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15735, '115240', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 14:55:47', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.00', '19.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15736, '115234', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 14:19:07', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15737, '115231', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 14:00:26', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15738, '115232', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 14:04:49', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '84.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15739, '115237', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 14:35:50', 'Paid', NULL, '4.00', '4.00', '4.00', NULL, '4.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15740, '115241', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 15:27:44', 'Paid', NULL, '12.00', '10.80', '10.80', NULL, '11.00', '0.20', '0.00', '0.00', '1.20', '0.00', 'Cash', NULL, '27', '1514682622', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15732, '115236', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 14:22:29', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15733, '115233', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 14:15:12', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15730, '115227', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 13:22:00', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15731, '115228', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 13:24:56', 'Paid', NULL, '62.00', '61.40', '61.40', NULL, '100.00', '38.60', '0.00', '0.00', '6.82', '0.02', 'Cash', NULL, '27', '1514682622', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15729, '115235', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 14:21:52', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '52.90', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15720, '115221', 'T10', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 12:26:07', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15721, '115226', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 12:56:14', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15722, '115224', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 12:30:38', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '34.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15723, '115214', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 12:00:06', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(15724, '115230', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 13:36:27', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15725, '115218', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 12:23:46', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.00', '37.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15726, '115219', 'T8', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 12:24:35', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.20', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15727, '115222', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 12:28:09', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '54.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15728, '115223', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 12:29:56', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15719, '115212', 'IS', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 11:46:29', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15702, '115200', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 10:42:18', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15703, '115202', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 10:56:20', 'Paid', NULL, '93.00', '102.30', '102.30', NULL, '102.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15704, '115205', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 11:12:42', 'Paid', NULL, '90.28', '99.30', '99.30', NULL, '100.30', '1.00', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15705, '115203', 'T11', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 10:59:24', 'Paid', NULL, '240.00', '264.00', '264.00', NULL, '300.00', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15706, '115206', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 11:14:26', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15707, '115204', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 11:06:26', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15708, '115208', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 11:30:49', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15709, '115207', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 11:22:40', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15710, '115210', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 11:41:00', 'Paid', NULL, '85.90', '94.50', '94.50', NULL, '100.00', '5.50', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15711, '115209', 'T15', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 11:31:41', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15712, '115213', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 11:57:08', 'Paid', NULL, '130.00', '143.00', '143.00', NULL, '150.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15713, '115211', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 11:44:30', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '63.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15714, '115215', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 12:00:47', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '62.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15715, '115216', 'T4', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 12:09:44', 'Paid', NULL, '48.90', '53.80', '53.80', NULL, '55.00', '1.20', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15716, '115217', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 12:17:00', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15717, '115220', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 12:25:23', 'Paid', NULL, '41.28', '45.40', '45.40', NULL, '50.40', '5.00', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15718, '115225', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 12:36:29', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '77.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15701, '115201', 'T12', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 10:47:35', 'Paid', NULL, '133.00', '146.30', '146.30', NULL, '200.00', '53.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15700, '115199', 'T14', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 10:36:00', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '71.00', '10.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15699, '115197', 'T1', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 10:29:57', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.10', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15698, '115195', 'T3', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 10:12:17', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15697, '115198', 'T6', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 10:34:17', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '100.00', '8.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15696, '115193', 'T2', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 09:49:44', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15695, '115194', 'T7', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 10:09:28', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15694, '115196', 'T5', 10003, 'admin', NULL, NULL, 'history', '2017-12-31 10:27:37', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '71.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514682622', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15808, '115307', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 17:24:25', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15809, '115308', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 17:43:36', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15807, '115306', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 17:23:59', 'Paid', NULL, '59.36', '65.30', '65.30', NULL, '100.00', '34.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15806, '115302', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 16:36:29', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15804, '115303', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 16:39:24', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15805, '115305', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 17:18:24', 'Paid', NULL, '92.58', '101.85', '101.85', NULL, '102.00', '0.15', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15786, '115284', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 14:32:26', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '70.20', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15787, '115279', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 13:51:57', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15788, '115285', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 14:33:51', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '80.10', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15789, '115287', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 14:37:27', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.00', '7.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15790, '115291', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 14:53:22', 'Paid', NULL, '19.90', '21.90', '21.90', NULL, '50.00', '28.10', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15791, '115283', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 14:13:45', 'Paid', NULL, '17.00', '15.30', '15.30', NULL, '50.00', '34.70', '0.00', '0.00', '1.70', '0.00', 'Cash', NULL, '27', '1514768211', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15792, '115289', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 14:49:58', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.60', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15793, '115292', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 15:06:57', 'Paid', NULL, '94.94', '104.45', '104.45', NULL, '105.00', '0.55', '0.00', '0.00', NULL, '0.02', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15794, '115295', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 15:41:25', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15795, '115298', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 16:07:31', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15796, '115294', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 15:37:32', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15797, '115293', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 15:36:48', 'Paid', NULL, '65.68', '72.25', '72.25', NULL, '100.00', '27.75', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15798, '115299', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 16:18:20', 'Paid', NULL, '28.68', '31.55', '31.55', NULL, '50.00', '18.45', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15799, '115300', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 16:19:17', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '72.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15800, '115297', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 15:55:14', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '55.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15801, '115301', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 16:23:51', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.40', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15802, '115304', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 16:42:29', 'Paid', NULL, '165.00', '181.50', '181.50', NULL, '201.50', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15803, '115296', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 15:49:50', 'Paid', NULL, '37.90', '41.70', '41.70', NULL, '45.00', '3.30', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15785, '115288', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 14:43:46', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15780, '115276', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 13:11:12', 'Paid', NULL, '31.90', '35.10', '35.10', NULL, '40.00', '4.90', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15781, '115278', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 13:45:12', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '105.00', '40.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15782, '115282', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 14:11:22', 'Paid', NULL, '103.00', '113.30', '113.30', NULL, '150.00', '36.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15783, '115286', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 14:34:50', 'Paid', NULL, '131.00', '144.10', '144.10', NULL, '150.10', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15784, '115280', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 14:01:53', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '52.00', '10.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15776, '115275', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 13:10:15', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '72.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15777, '115274', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 12:41:03', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15778, '115281', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 14:07:33', 'Paid', NULL, '207.00', '227.70', '227.70', NULL, '250.00', '22.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15779, '115277', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 13:25:09', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15775, '115267', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 12:01:56', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15767, '115272', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 12:28:02', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '106.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(15768, '115265', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 11:58:24', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '100.00', '59.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15769, '115266', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 12:00:52', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '60.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15770, '115268', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 12:05:24', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15771, '115269', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 12:08:31', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.00', '32.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15772, '115270', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 12:16:49', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '51.80', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15773, '115271', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 12:19:53', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15774, '115290', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 14:51:23', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.10', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15756, '115252', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 10:45:19', 'Paid', NULL, '115.00', '126.50', '126.50', NULL, '150.00', '23.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15757, '115260', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 11:20:20', 'Paid', NULL, '142.00', '156.20', '156.20', NULL, '160.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15758, '115258', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 11:08:31', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15759, '115273', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 12:30:06', 'Paid', NULL, '129.00', '141.90', '141.90', NULL, '152.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15760, '115257', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 11:06:30', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '70.30', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15761, '115262', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 11:26:54', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '61.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15762, '115264', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 11:35:07', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '64.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15763, '115253', 'T9', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 10:46:03', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15764, '115263', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 11:27:33', 'Paid', NULL, '130.00', '143.00', '143.00', NULL, '200.00', '57.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15765, '115261', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 11:24:57', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15766, '115259', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 11:11:09', 'Paid', NULL, '12.00', '11.50', '11.50', NULL, '11.50', '0.00', '0.00', '0.00', '0.50', '0.00', 'Cash', NULL, '27', '1514768211', 'd', '0.50', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15755, '115256', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 10:59:11', 'Paid', NULL, '96.00', '105.60', '105.60', NULL, '105.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15754, '115255', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 10:57:46', 'Paid', NULL, '161.00', '177.10', '177.10', NULL, '177.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15753, '115250', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 10:25:35', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15752, '115251', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 10:30:07', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15751, '115254', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 10:57:15', 'Paid', NULL, '130.00', '143.00', '143.00', NULL, '150.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15750, '115249', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-01 09:36:22', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1514768211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15846, '115347', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 16:47:10', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '90.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15848, '115344', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 15:24:37', 'Paid', NULL, '54.90', '60.40', '60.40', NULL, '60.40', '0.00', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15849, '115341', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 15:11:54', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '51.00', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15850, '115345', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 15:40:54', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15851, '115343', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 15:14:05', 'Paid', NULL, '24.00', '24.00', '24.00', NULL, '24.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15852, '115352', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 17:43:49', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '50.00', '33.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15853, '115348', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 16:47:43', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '40.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15855, '115351', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 17:02:39', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15856, '115349', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 16:50:42', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15845, '115340', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 15:01:44', 'Paid', NULL, '108.00', '118.80', '118.80', NULL, '120.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15839, '115334', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 14:29:03', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15847, '115342', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 15:13:54', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15841, '115336', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 14:33:04', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.00', '29.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15842, '115330', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 13:42:31', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15843, '115333', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 14:22:44', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '38.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15838, '115339', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 14:37:22', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15831, '115327', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 13:23:47', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15854, '115350', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 16:54:26', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '100.00', '56.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15833, '115323', 'T1(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 12:55:41', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(15834, '115331', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 13:53:26', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '80.00', '6.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15817, '115321', '7', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 12:26:43', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15816, '115314', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 10:41:45', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15844, '115339', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 14:52:35', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15836, '115332', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 14:13:06', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15835, '115337', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 14:34:13', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '70.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15830, '115324', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 13:06:48', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15829, '115322', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 12:38:42', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15828, '115328', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 13:35:50', 'Paid', NULL, '50.00', '49.50', '49.50', NULL, '49.50', '0.00', '0.00', '0.00', '5.50', '0.00', 'Cash', NULL, '27', '1515027728', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15827, '115346', 'T1(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 16:09:44', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15826, '115326', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 13:15:03', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15825, '115329', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 13:41:22', 'Paid', NULL, '171.00', '188.10', '188.10', NULL, '200.00', '11.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15824, '115325', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 13:07:44', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15823, '115335', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 14:31:50', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '93.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15822, '115320', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 11:45:26', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15821, '115319', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 11:31:32', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.10', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15820, '115316', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 10:53:27', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15819, '115318', '1', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 11:19:54', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.00', '30.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15818, '115313', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 10:25:13', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '56.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15815, '115317', '3', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 10:55:56', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '50.30', '36.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15814, '115315', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 10:44:12', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '31.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15813, '115312', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 10:22:40', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15812, '115309', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 10:02:09', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15811, '115311', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 10:10:33', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15810, '115310', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-04 10:03:55', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515027728', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15875, '115369', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-05 16:44:29', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '5.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515112353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15876, '115371', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-05 17:15:07', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '45.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515112353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15877, '115373', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-05 17:49:55', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515112353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15878, '115370', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-05 16:52:18', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515112353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15879, '115374', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-05 17:55:01', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515112353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15873, '115365', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-05 15:17:06', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '17.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515112353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(15872, '115364', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-05 15:16:18', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '51.40', '25.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515112353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(15874, '115372', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-05 17:18:52', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515112353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15871, '115368', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-05 15:44:22', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515112353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15869, '115367', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-05 15:37:59', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '40.00', '4.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515112353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15868, '115363', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-05 14:11:04', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '15.20', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515112353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15866, '115366', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-05 15:18:57', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '77.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515112353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15867, '115360', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-05 13:20:45', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '55.00', '30.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515112353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15863, '115358', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-05 12:41:15', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515112353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15864, '115362', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-05 13:41:00', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '59.00', '30.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515112353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15865, '115361', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-05 13:32:25', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '50.00', '41.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515112353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15862, '115356', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-05 11:10:46', 'Paid', NULL, '69.50', '76.45', '76.45', NULL, '100.00', '23.55', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515112353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15861, '115353', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-05 10:14:22', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '50.00', '29.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515112353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15860, '115359', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-05 13:01:02', 'Paid', NULL, '104.00', '114.40', '114.40', NULL, '120.00', '5.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515112353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15859, '115357', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-05 11:50:51', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515112353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15858, '115354', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-05 10:21:00', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515112353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15857, '115355', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-05 10:29:24', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515112353', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15913, '115408', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 16:33:57', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '40.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15906, '115399', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 14:52:37', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.20', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15907, '115403', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 15:45:00', 'Paid', NULL, '71.00', '70.30', '70.30', NULL, '100.30', '30.00', '0.00', '0.00', '7.81', '0.01', 'Cash', NULL, '27', '1515201712', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15912, '115407', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 16:29:21', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '76.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15908, '115402', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 15:17:24', 'Paid', NULL, '144.00', '158.40', '158.40', NULL, '200.00', '41.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15909, '115404', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 15:46:22', 'Paid', NULL, '93.00', '102.30', '102.30', NULL, '110.40', '8.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15910, '115405', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 15:48:59', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15911, '115406', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 15:54:19', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15896, '115391', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 13:50:26', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15897, '115395', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 14:04:19', 'Paid', NULL, '95.00', '104.50', '104.50', NULL, '105.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15898, '115390', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 13:50:15', 'Paid', NULL, '110.00', '121.00', '121.00', NULL, '121.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15899, '115393', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 13:56:57', 'Paid', NULL, '95.00', '104.50', '104.50', NULL, '110.00', '5.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15900, '115387', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 13:25:41', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15901, '115396', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 14:26:51', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '101.50', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15902, '115397', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 14:36:53', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15903, '115394', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 13:58:17', 'Paid', NULL, '14.00', '14.00', '14.00', NULL, '14.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15904, '115401', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 15:14:30', 'Paid', NULL, '101.00', '111.10', '111.10', NULL, '111.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15905, '115398', 'T13', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 14:40:17', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15894, '115400', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 14:55:41', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15895, '115388', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 13:26:09', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15893, '115386', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 12:48:22', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15886, '115381', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 11:47:56', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15887, '115384', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 12:21:25', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15888, '115389', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 13:39:14', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.00', '41.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15889, '115383', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 12:20:54', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15890, '115385', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 12:31:46', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15891, '115382', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 12:18:57', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '15.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15892, '115392', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 13:51:39', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15885, '115380', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 11:05:10', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15884, '115378', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 10:35:38', 'Paid', NULL, '110.00', '121.00', '121.00', NULL, '201.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15883, '115375', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 10:16:56', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15882, '115377', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 10:31:05', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '102.00', '40.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15881, '115376', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 10:30:14', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.50', '21.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15880, '115379', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-06 10:39:38', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515201712', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15951, '115443', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 14:22:44', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15950, '115445', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 14:34:48', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15948, '115444', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 14:23:14', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '77.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15949, '115441', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 14:00:20', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15947, '115439', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 13:21:05', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15940, '115432', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 12:32:24', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15941, '115435', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 12:48:53', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '51.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15942, '115436', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 12:49:33', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '55.10', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15943, '115434', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 12:37:23', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '21.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15944, '115440', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 13:43:29', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '100.00', '54.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15945, '115437', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 13:11:21', 'Paid', NULL, '103.00', '113.30', '113.30', NULL, '113.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15946, '115438', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 13:18:44', 'Paid', NULL, '17.00', '16.85', '16.85', NULL, '20.00', '3.15', '0.00', '0.00', '1.87', '0.02', 'Cash', NULL, '27', '1515286096', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15930, '115422', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 11:23:30', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15931, '115424', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 11:36:41', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '101.40', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15932, '115419', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 11:04:25', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15933, '115428', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 11:58:02', 'Paid', NULL, '96.00', '105.60', '105.60', NULL, '110.00', '4.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15934, '115429', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 12:15:08', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15935, '115427', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 11:48:44', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15936, '115431', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 12:21:52', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '120.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15937, '115426', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 11:48:04', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15938, '115433', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 12:36:52', 'Paid', NULL, '203.00', '223.30', '223.30', NULL, '250.30', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15939, '115423', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 11:34:26', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15929, '115414', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 10:46:53', 'Paid', NULL, '27.00', '27.00', '27.00', NULL, '27.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(15921, '115430', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 12:17:39', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '83.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15922, '115442', 'T1(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 14:21:44', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15923, '115412', 'T1(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 10:23:39', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '15.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(15924, '115418', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 11:02:16', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15925, '115413', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 10:39:01', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15926, '115420', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 11:15:07', 'Paid', NULL, '197.00', '216.70', '216.70', NULL, '220.00', '3.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15927, '115425', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 11:37:37', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.00', '30.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15928, '115421', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 11:20:22', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '100.10', '66.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15920, '115415', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 10:52:45', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15919, '115410', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 10:01:45', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '102.00', '40.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15918, '115417', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 10:59:12', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '91.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15917, '115411', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 10:02:17', 'Paid', NULL, '114.00', '125.40', '125.40', NULL, '150.00', '24.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15916, '115416', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 10:53:54', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15915, '115409', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-07 09:48:46', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.40', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515286096', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15971, '115461', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 13:44:48', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15972, '115464', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 13:57:43', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '45.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15973, '115466', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 14:03:04', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15974, '115465', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 13:58:38', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.20', '27.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15975, '115467', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 14:16:06', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15976, '115462', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 13:46:02', 'Paid', NULL, '4.00', '4.00', '4.00', NULL, '4.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15977, '115471', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 16:19:08', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '90.00', '19.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15978, '115472', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 17:49:56', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '17.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15979, '115469', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 15:02:40', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15980, '115470', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 15:51:09', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '75.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15958, '115459', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 13:18:55', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15959, '115463', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 13:55:11', 'Paid', NULL, '98.00', '107.80', '107.80', NULL, '110.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15960, '115451', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 11:33:57', 'Paid', NULL, '13.00', '13.00', '13.00', NULL, '53.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(15961, '115457', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 13:14:09', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15962, '115453', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 12:22:50', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15966, '115454', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 12:42:03', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15965, '115452', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 12:02:07', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '40.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(15967, '115455', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 13:00:40', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '61.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15968, '115458', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 13:16:19', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15969, '115460', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 13:26:59', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '21.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15970, '115468', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 14:17:41', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15957, '115450', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 10:50:14', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '100.00', '38.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15956, '115456', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 13:08:42', 'Paid', NULL, '102.00', '112.20', '112.20', NULL, '112.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15955, '115449', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 10:30:26', 'Paid', NULL, '106.00', '116.60', '116.60', NULL, '120.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15954, '115447', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 10:14:59', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '59.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15953, '115446', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 10:14:23', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '53.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15952, '115448', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-08 10:26:07', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515371683', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15987, '115475', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-10 12:47:05', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515546225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15988, '115477', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-10 13:16:20', 'Paid', NULL, '112.00', '123.20', '123.20', NULL, '150.00', '26.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515546225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15989, '115482', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-10 14:12:41', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515546225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15990, '115479', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-10 13:28:02', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.30', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515546225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15991, '115476', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-10 12:52:28', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.40', '41.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515546225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(15993, '115480', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-10 13:55:40', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515546225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15994, '115486', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-10 14:26:43', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '51.00', '34.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515546225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15995, '115481', 'T13', 10003, 'admin', NULL, NULL, 'history', '2018-01-10 13:56:17', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515546225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15996, '115484', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-10 14:20:38', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.00', '19.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515546225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15997, '115488', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-10 14:41:21', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515546225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15998, '115493', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-10 17:45:41', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515546225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15999, '115491', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-10 15:50:34', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515546225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16000, '115489', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-10 15:47:18', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515546225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16001, '115490', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-10 15:47:45', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515546225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16002, '115492', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-10 16:26:19', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515546225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15992, '115485', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-10 14:24:33', 'Paid', NULL, '55.00', '54.45', '54.45', NULL, '60.00', '5.55', '0.00', '0.00', '6.05', '0.00', 'Cash', NULL, '27', '1515546225', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15985, '115487', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-10 14:31:02', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '80.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515546225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15984, '115483', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-10 14:19:05', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '71.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515546225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15983, '115474', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-10 12:38:11', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.20', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515546225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15982, '115473', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-10 11:50:09', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '100.00', '65.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515546225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(15981, '115478', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-10 13:22:00', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.20', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515546225', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16010, '115496', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-11 11:54:49', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515581853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16011, '115500', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-11 12:44:36', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '70.00', '10.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515581853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16012, '115504', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-11 14:03:55', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.40', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515581853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16013, '115502', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-11 13:50:34', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515581853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16014, '115505', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-11 14:13:14', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '100.20', '65.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515581853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16015, '115503', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-11 14:00:39', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '28.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515581853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16016, '115501', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-11 13:48:35', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515581853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16017, '115506', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-11 14:14:50', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '80.00', '4.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515581853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16018, '115509', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-11 14:28:01', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.00', '21.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515581853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16019, '115510', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-11 15:02:27', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '100.40', '63.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515581853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16021, '115511', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-11 15:49:45', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '100.00', '52.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515581853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16022, '115508', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-11 14:24:44', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.50', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515581853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16023, '115507', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-11 14:17:44', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515581853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16007, '115499', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-11 12:22:11', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '20.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515581853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16006, '115498', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-11 12:20:11', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515581853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16005, '115497', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-11 12:04:17', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '50.90', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515581853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16004, '115495', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-11 11:45:43', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515581853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16003, '115494', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-11 10:35:20', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515581853', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16051, '115538', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 17:34:24', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16050, '115536', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 16:59:56', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16029, '115519', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 12:24:35', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '53.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16030, '115517', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 12:15:23', 'Paid', NULL, '115.00', '126.50', '126.50', NULL, '126.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16031, '115526', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 14:13:51', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '41.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16032, '115518', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 12:20:44', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16033, '115521', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 13:00:49', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16034, '115520', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 12:58:00', 'Paid', NULL, '83.00', '91.30', '91.30', NULL, '100.30', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16035, '115528', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 14:41:31', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.60', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16036, '115522', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 13:05:56', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16037, '115523', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 13:38:11', 'Paid', NULL, '227.00', '249.70', '249.70', NULL, '250.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16038, '115525', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 13:44:20', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '100.00', '50.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16039, '115524', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 13:38:38', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16040, '115531', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 14:49:28', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '63.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16041, '115529', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 14:42:42', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16042, '115530', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 14:43:19', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '72.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16043, '115527', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 14:39:10', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16044, '115532', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 15:41:10', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '100.00', '6.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16045, '115533', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 15:56:30', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16046, '115539', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 17:41:47', 'Paid', NULL, '57.90', '63.70', '63.70', NULL, '65.00', '1.30', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16047, '115534', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 16:34:58', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16048, '115537', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 17:25:50', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16049, '115535', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 16:52:57', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '17.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16028, '115515', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 11:11:51', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '65.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16027, '115516', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 11:34:19', 'Paid', NULL, '115.00', '126.50', '126.50', NULL, '150.50', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16026, '115514', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 10:23:16', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '52.00', '20.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16025, '115513', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 10:20:27', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '101.00', '40.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16024, '115512', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-12 09:43:38', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515719036', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16088, '115576', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 17:24:57', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '30.10', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16087, '115572', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 16:23:01', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16086, '115574', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 16:44:51', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '27.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16085, '115570', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 16:01:16', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '50.00', '35.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16084, '115573', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 16:31:54', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16083, '115571', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 16:11:39', 'Paid', NULL, '137.00', '150.70', '150.70', NULL, '151.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16082, '115567', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 15:42:34', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '54.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16081, '115566', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 15:17:58', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.40', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16080, '115565', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 15:13:18', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '120.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16079, '115569', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 15:46:59', 'Paid', NULL, '93.00', '102.30', '102.30', NULL, '105.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16078, '115563', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 14:35:03', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16057, '115545', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 11:23:40', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '100.00', '46.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16077, '115564', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 14:49:46', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16076, '115568', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 15:43:53', 'Paid', NULL, '121.00', '133.10', '133.10', NULL, '140.20', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16075, '115560', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 13:59:16', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16074, '115562', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 14:28:09', 'Paid', NULL, '103.90', '114.30', '114.30', NULL, '115.00', '0.70', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16073, '115559', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 13:19:48', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '40.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16072, '115558', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 13:06:13', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16071, '115561', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 14:17:36', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.00', '7.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16070, '115556', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 13:02:39', 'Paid', NULL, '18.00', '16.20', '16.20', NULL, '50.20', '34.00', '0.00', '0.00', '1.80', '0.00', 'Cash', NULL, '27', '1515805892', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16069, '115551', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 12:29:27', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16068, '115557', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 13:03:27', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16067, '115552', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 12:37:39', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '39.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16066, '115554', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 12:39:39', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16065, '115550', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 12:00:23', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '28.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16064, '115555', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 12:41:59', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.70', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16063, '115548', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 11:40:48', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '50.00', '35.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16062, '115575', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 17:16:14', 'Paid', NULL, '34.80', '34.80', '34.80', NULL, '50.00', '15.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16061, '115546', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 11:24:51', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '70.00', '11.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16060, '115549', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 11:41:33', 'Paid', NULL, '49.10', '54.00', '54.00', NULL, '54.00', '0.00', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16059, '115553', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 12:38:16', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.90', '19.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16058, '115544', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 11:15:22', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '101.00', '60.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16056, '115543', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 10:53:22', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16055, '115542', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 10:38:15', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '20.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16054, '115541', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 10:30:56', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '70.00', '10.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16053, '115540', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 10:20:05', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '65.00', '3.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16052, '115547', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-13 11:25:35', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515805892', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16110, '115595', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 13:15:29', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.00', '7.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16111, '115597', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 13:27:53', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '90.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(16112, '115594', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 13:06:54', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.00', '39.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16113, '115599', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 13:31:06', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16114, '115598', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 13:30:40', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16115, '115601', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 13:42:48', 'Paid', NULL, '110.00', '108.90', '108.90', NULL, '110.00', '1.10', '0.00', '0.00', '12.10', '0.00', 'Cash', NULL, '27', '1515891016', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16116, '115602', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 14:00:15', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '58.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16117, '115603', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 14:53:35', 'Paid', NULL, '139.00', '152.90', '152.90', NULL, '170.00', '17.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16118, '115605', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 15:06:26', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16119, '115604', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 14:54:50', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '37.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16120, '115609', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 15:40:19', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '40.00', '13.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16121, '115607', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 15:11:54', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16122, '115610', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 16:55:40', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '40.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16096, '115582', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 10:47:57', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '62.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16097, '115588', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 11:42:46', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16098, '115584', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 11:00:16', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16099, '115606', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 15:08:22', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16100, '115587', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 11:30:17', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16101, '115589', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 12:01:15', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.20', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16102, '115590', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 12:26:04', 'Paid', NULL, '154.00', '169.40', '169.40', NULL, '200.00', '30.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16103, '115586', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 11:28:33', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '10.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16105, '115596', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 13:22:05', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16107, '115591', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 12:53:23', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16108, '115593', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 13:02:36', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.10', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16109, '115608', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 15:34:51', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16106, '115600', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 13:36:04', 'Paid', NULL, '102.00', '112.20', '112.20', NULL, '113.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16104, '115592', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 12:54:57', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '40.60', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16094, '115581', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 10:47:31', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16095, '115585', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 11:05:00', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16093, '115578', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 09:53:38', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16092, '115583', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 10:56:51', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '63.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16091, '115580', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 10:41:57', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16090, '115579', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 10:40:27', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '74.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16089, '115577', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-14 09:52:14', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515891016', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16128, '115615', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-15 11:15:51', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515978481', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16129, '115617', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-15 11:19:41', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515978481', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16130, '115614', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-15 10:38:06', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '21.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515978481', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16131, '115619', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-15 13:25:19', 'Paid', NULL, '137.00', '150.70', '150.70', NULL, '150.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515978481', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16132, '115626', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-15 14:10:13', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.00', '29.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515978481', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16133, '115620', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-15 13:35:37', 'Paid', NULL, '171.00', '188.10', '188.10', NULL, '200.00', '11.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515978481', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16134, '115621', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-15 13:39:37', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.00', '2.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515978481', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16135, '115623', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-15 13:54:39', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.60', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515978481', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16136, '115622', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-15 13:44:03', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515978481', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16137, '115625', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-15 14:02:31', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515978481', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16138, '115624', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-15 14:00:46', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '54.00', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515978481', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16139, '115627', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-15 14:14:36', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515978481', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16140, '115629', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-15 16:16:12', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515978481', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16141, '115628', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-15 15:44:44', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '80.00', '6.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515978481', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16142, '115630', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-15 16:44:49', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515978481', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16127, '115618', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-15 11:21:08', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515978481', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16126, '115616', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-15 11:19:20', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515978481', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16125, '115613', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-15 10:28:33', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '65.00', '4.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515978481', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16124, '115612', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-15 10:04:04', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515978481', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16123, '115611', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-15 09:55:57', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '40.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1515978481', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16163, '115648', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-17 15:05:29', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '15.10', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516151174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16162, '115647', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-17 14:31:03', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '36.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516151174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16161, '115642', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-17 14:01:30', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516151174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16158, '115644', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-17 14:16:20', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516151174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16157, '115639', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-17 13:39:16', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '10.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516151174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16156, '115645', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-17 14:19:02', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516151174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16155, '115643', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-17 14:08:44', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516151174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16154, '115641', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-17 13:59:05', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '100.20', '44.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516151174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16153, '115649', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-17 15:35:55', 'Paid', NULL, '98.00', '107.80', '107.80', NULL, '107.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516151174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16152, '115646', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-17 14:30:05', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '100.00', '45.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516151174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16151, '115638', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-17 13:20:13', 'Paid', NULL, '104.00', '114.40', '114.40', NULL, '200.50', '86.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516151174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16150, '115640', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-17 13:47:12', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '72.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516151174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16148, '115633', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-17 12:29:23', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '31.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516151174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16149, '115637', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-17 13:05:16', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '55.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516151174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16147, '115635', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-17 12:32:23', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '70.50', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516151174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16146, '115634', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-17 12:31:10', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '58.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516151174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16145, '115636', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-17 12:55:02', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '75.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516151174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16144, '115632', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-17 10:43:16', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '70.00', '10.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516151174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16143, '115631', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-17 10:17:08', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '57.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516151174', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16185, '115671', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-18 16:14:57', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '103.00', '20.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516237698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16186, '115670', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-18 16:12:04', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '28.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516237698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16184, '115669', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-18 16:11:09', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516237698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16175, '115664', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-18 14:24:53', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516237698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16176, '115658', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-18 12:58:15', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.00', '4.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516237698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16177, '115662', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-18 13:43:42', 'Paid', NULL, '217.00', '238.70', '238.70', NULL, '238.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516237698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16178, '115667', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-18 15:06:14', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '50.00', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516237698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16179, '115661', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-18 13:33:10', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.10', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516237698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16183, '115668', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-18 15:46:40', 'Paid', NULL, '135.00', '148.50', '148.50', NULL, '150.00', '1.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516237698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16182, '115665', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-18 14:31:59', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '102.50', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516237698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16181, '115663', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-18 14:04:42', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516237698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16180, '115659', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-18 13:02:01', 'Paid', NULL, '52.00', '52.00', '52.00', NULL, '52.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516237698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16173, '115655', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-18 11:19:23', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516237698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16172, '115654', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-18 11:19:08', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516237698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16169, '115657', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-18 11:29:43', 'Paid', NULL, '123.00', '135.30', '135.30', NULL, '135.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516237698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16171, '115651', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-18 10:54:21', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516237698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16174, '115660', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-18 13:12:23', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '75.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516237698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16168, '115666', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-18 14:56:36', 'Paid', NULL, '113.00', '124.30', '124.30', NULL, '150.00', '25.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516237698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16167, '115653', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-18 11:10:03', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '102.00', '40.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516237698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16166, '115652', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-18 11:09:38', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516237698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16165, '115656', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-18 11:20:40', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516237698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16164, '115650', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-18 10:01:55', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516237698', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16192, '115678', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-19 12:26:54', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516321469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16193, '115677', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-19 12:15:14', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516321469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16194, '115686', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-19 13:42:00', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516321469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16195, '115679', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-19 12:47:26', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516321469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16196, '115681', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-19 13:03:23', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516321469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16198, '115680', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-19 12:53:57', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '20.00', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516321469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16199, '115683', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-19 13:30:39', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '100.00', '59.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516321469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16200, '115685', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-19 13:41:20', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516321469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16201, '115684', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-19 13:40:02', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516321469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16202, '115688', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-19 14:38:36', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516321469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16203, '115689', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-19 14:39:26', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516321469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16204, '115690', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-19 15:36:11', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '17.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516321469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16205, '115687', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-19 14:37:10', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516321469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16206, '115691', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-19 17:25:36', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '28.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516321469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16197, '115682', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-19 13:10:31', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516321469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16191, '115676', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-19 11:52:12', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.50', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516321469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16190, '115675', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-19 11:50:16', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '70.00', '12.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516321469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16189, '115674', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-19 10:46:46', 'Paid', NULL, '203.00', '223.30', '223.30', NULL, '250.00', '26.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516321469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16188, '115673', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-19 10:07:38', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516321469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16187, '115672', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-19 09:51:43', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.10', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516321469', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16249, '115733', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 17:54:04', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16236, '115720', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 15:13:45', 'Paid', NULL, '58.10', '63.90', '63.90', NULL, '65.00', '1.10', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16237, '115726', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 15:55:48', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16238, '115722', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 15:24:43', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16239, '115727', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 16:14:11', 'Paid', NULL, '166.00', '182.60', '182.60', NULL, '182.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16240, '115723', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 15:29:56', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16241, '115721', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 15:21:50', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16242, '115725', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 15:41:17', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16243, '115728', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 16:37:18', 'Paid', NULL, '147.60', '162.35', '162.35', NULL, '200.00', '37.65', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16244, '115729', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 17:02:05', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '100.00', '59.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16245, '115734', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 18:11:26', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16246, '115730', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 17:15:58', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.30', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16247, '115731', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 17:52:35', 'Paid', NULL, '38.00', '38.00', '38.00', NULL, '100.00', '62.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16248, '115732', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 17:53:30', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16222, '115707', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 12:00:40', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16223, '115701', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 11:20:57', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16224, '115712', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 12:30:34', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '101.00', '50.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16225, '115713', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 12:52:13', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '72.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16226, '115711', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 12:14:00', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16227, '115709', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 12:10:27', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16228, '115710', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 12:10:40', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16229, '115714', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 12:53:00', 'Paid', NULL, '109.00', '119.90', '119.90', NULL, '150.00', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16230, '115715', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 12:57:01', 'Paid', NULL, '101.00', '111.10', '111.10', NULL, '111.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16231, '115716', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 13:54:20', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16232, '115717', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 14:41:42', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16233, '115719', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 15:07:16', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16234, '115724', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 15:33:28', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16235, '115718', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 14:48:36', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16212, '115699', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 10:38:46', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '62.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16213, '115698', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 10:37:07', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16214, '115697', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 10:26:30', 'Paid', NULL, '35.20', '38.70', '38.70', NULL, '50.00', '11.30', '0.00', '0.00', NULL, '-0.02', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16215, '115705', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 11:47:54', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16216, '115700', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 10:56:01', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '42.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16217, '115703', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 11:28:06', 'Paid', NULL, '38.60', '42.45', '42.45', NULL, '100.00', '57.55', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(16218, '115708', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 12:06:13', 'Paid', NULL, '46.90', '51.60', '51.60', NULL, '51.60', '0.00', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16219, '115702', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 11:24:55', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16220, '115704', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 11:34:35', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16221, '115706', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 11:54:10', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16211, '115696', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 10:19:21', 'Paid', NULL, '119.00', '130.90', '130.90', NULL, '131.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16210, '115693', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 09:54:52', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16209, '115694', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 10:00:41', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16208, '115692', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 09:52:57', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.20', '32.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16207, '115695', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-20 10:14:22', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516441999', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16297, '115780', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 16:56:46', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16296, '115778', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 16:21:59', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16295, '115779', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 16:28:52', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.20', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16294, '115774', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 15:53:59', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '5.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16293, '115773', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 15:52:30', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '6.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16291, '115777', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 16:00:51', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16292, '115781', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 17:00:50', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16280, '115766', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 14:04:11', 'Paid', NULL, '166.00', '182.60', '182.60', NULL, '183.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16281, '115762', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 13:38:46', 'Paid', NULL, '45.60', '50.15', '50.15', NULL, '55.00', '4.85', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16282, '115757', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 13:16:14', 'Paid', NULL, '28.20', '28.20', '28.20', NULL, '50.00', '21.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16283, '115765', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 13:51:50', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.10', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16284, '115769', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 14:38:15', 'Paid', NULL, '4.00', '4.40', '4.40', NULL, '5.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16285, '115770', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 14:53:11', 'Paid', NULL, '116.00', '127.60', '127.60', NULL, '130.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16286, '115771', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 14:57:24', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16287, '115775', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 15:59:21', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16288, '115772', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 15:47:23', 'Paid', NULL, '32.60', '35.85', '35.85', NULL, '50.00', '14.15', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16289, '115782', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 17:10:43', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.00', '20.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16290, '115776', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 15:59:58', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16255, '115740', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 10:38:58', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '102.00', '30.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16256, '115738', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 10:18:40', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16257, '115741', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 10:50:42', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16258, '115764', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 13:46:37', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '27.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16259, '115748', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 11:59:16', 'Paid', NULL, '154.60', '170.05', '170.05', NULL, '170.05', '0.00', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16260, '115742', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 10:54:08', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16261, '115744', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 11:20:18', 'Paid', NULL, '35.60', '39.15', '39.15', NULL, '50.00', '10.85', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16262, '115745', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 11:37:44', 'Paid', NULL, '99.00', '108.90', '108.90', NULL, '110.00', '1.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16263, '115746', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 11:38:13', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '102.00', '60.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16264, '115754', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 12:25:41', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.10', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16265, '115751', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 12:20:49', 'Paid', NULL, '57.60', '63.35', '63.35', NULL, '70.00', '6.65', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16266, '115747', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 11:40:28', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '41.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16267, '115749', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 12:13:37', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16268, '115750', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 12:16:09', 'Paid', NULL, '157.00', '172.70', '172.70', NULL, '200.70', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16269, '115763', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 13:46:03', 'Paid', NULL, '97.60', '107.35', '107.35', NULL, '107.35', '0.00', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16270, '115752', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 12:22:59', 'Paid', NULL, '128.60', '141.45', '141.45', NULL, '152.00', '10.55', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16271, '115755', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 12:33:31', 'Paid', NULL, '104.00', '114.40', '114.40', NULL, '120.00', '5.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16272, '115753', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 12:24:15', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16273, '115760', 'T13', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 13:24:54', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16274, '115767', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 14:15:50', 'Paid', NULL, '66.60', '73.25', '73.25', NULL, '100.00', '26.75', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16275, '115768', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 14:16:47', 'Paid', NULL, '93.00', '102.30', '102.30', NULL, '102.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16276, '115756', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 12:42:27', 'Paid', NULL, '9.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16277, '115759', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 13:23:50', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.00', '20.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16278, '115758', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 13:18:24', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16279, '115761', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 13:25:08', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '28.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16254, '115739', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 10:23:54', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '54.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16253, '115743', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 11:12:17', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16252, '115737', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 10:13:43', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16251, '115735', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 09:36:55', 'Paid', NULL, '114.00', '125.40', '125.40', NULL, '150.00', '24.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16250, '115736', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-21 09:53:29', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516509965', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16303, '115787', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 11:41:13', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '62.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16304, '115790', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 12:02:46', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.20', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16305, '115788', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 11:41:54', 'Paid', NULL, '23.00', '23.00', '23.00', NULL, '23.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16306, '115797', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 14:16:54', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16307, '115793', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 12:56:46', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '70.00', '7.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16308, '115791', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 12:43:16', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16309, '115792', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 12:53:28', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16310, '115794', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 13:15:21', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '62.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16311, '115796', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 14:03:22', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '81.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16312, '115795', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 13:44:38', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16313, '115800', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 15:36:00', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16314, '115805', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 16:48:28', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16315, '115799', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 15:05:04', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16316, '115798', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 14:25:11', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '50.00', '41.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16317, '115803', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 15:52:59', 'Paid', NULL, '26.00', '25.75', '25.75', NULL, '26.00', '0.25', '0.00', '0.00', '2.86', '0.01', 'Cash', NULL, '27', '1516583211', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16318, '115802', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 15:40:03', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16319, '115801', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 15:37:14', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16320, '115804', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 16:48:11', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16321, '115806', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 16:57:06', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16302, '115786', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 11:17:30', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16301, '115785', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 10:59:09', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '24.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16300, '115783', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 10:34:47', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '50.00', '41.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16299, '115784', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 10:44:55', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '72.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16298, '115789', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-22 11:43:23', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '22.20', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516583211', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16327, '115811', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-24 11:43:06', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516755252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16328, '115812', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-24 12:15:22', 'Paid', NULL, '104.00', '114.40', '114.40', NULL, '115.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516755252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16329, '115814', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-24 12:52:13', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '102.00', '50.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516755252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16330, '115821', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-24 14:50:57', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516755252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16331, '115813', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-24 12:51:31', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '53.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516755252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16332, '115818', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-24 14:23:14', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516755252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16333, '115817', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-24 13:53:52', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.90', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516755252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16334, '115816', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-24 13:33:46', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516755252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16335, '115820', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-24 14:47:51', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516755252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16336, '115822', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-24 14:53:35', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '100.50', '73.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516755252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16337, '115819', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-24 14:31:02', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516755252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16338, '115824', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-24 16:24:16', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '50.00', '41.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516755252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16339, '115823', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-24 15:29:57', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.00', '3.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516755252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16326, '115815', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-24 13:09:46', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '25.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516755252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16325, '115810', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-24 11:20:57', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '100.00', '71.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516755252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16324, '115809', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-24 11:15:30', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.00', '4.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516755252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16323, '115808', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-24 10:25:12', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516755252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16322, '115807', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-24 10:12:25', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516755252', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16367, '115852', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 17:21:13', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.40', '35.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16366, '115851', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 16:44:42', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '100.50', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16365, '115847', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 15:51:21', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '30.00', '4.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16364, '115849', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 16:27:03', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16363, '115848', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 16:19:52', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16362, '115846', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 15:36:24', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '60.00', '8.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16361, '115850', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 16:41:39', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16360, '115844', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 14:44:59', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16359, '115843', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 14:43:53', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '55.40', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16358, '115841', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 14:29:25', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16357, '115842', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 14:35:08', 'Paid', NULL, '102.90', '113.20', '113.20', NULL, '113.20', '0.00', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16356, '115838', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 13:58:47', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16355, '115840', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 14:09:58', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '100.00', '65.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16354, '115839', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 14:07:51', 'Paid', NULL, '66.80', '73.50', '73.50', NULL, '100.00', '26.50', '0.00', '0.00', NULL, '0.02', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16353, '115837', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 13:39:28', 'Paid', NULL, '102.00', '112.20', '112.20', NULL, '150.20', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16352, '115836', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 13:14:13', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16351, '115831', 'T11A(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 11:41:47', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.40', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16345, '115828', 'T11A(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 10:42:44', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16346, '115834', 'T9', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 11:54:10', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16347, '115835', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 12:16:50', 'Paid', NULL, '45.90', '50.50', '50.50', NULL, '50.50', '0.00', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16348, '115845', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 15:17:11', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16349, '115829', 'T11A(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 11:40:21', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16350, '115830', 'T11A(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 11:41:12', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16344, '115827', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 10:32:25', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16343, '115833', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 11:43:53', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '42.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16342, '115832', 'T11A(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 11:42:05', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16341, '115826', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 10:16:27', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '65.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16340, '115825', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-25 09:56:48', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516842527', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16392, '115877', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 17:46:41', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '50.00', '29.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16391, '115876', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 16:56:21', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16390, '115873', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 16:11:40', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.00', '4.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16389, '115874', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 16:21:40', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '102.00', '60.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16388, '115872', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 15:20:28', 'Paid', NULL, '16.00', '16.00', '16.00', NULL, '16.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16387, '115875', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 16:32:47', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16382, '115865', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 14:25:35', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16383, '115871', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 15:15:24', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16384, '115866', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 14:34:35', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.40', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16385, '115867', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 14:41:16', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '105.30', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16386, '115868', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 14:47:22', 'Paid', NULL, '22.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16381, '115863', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 13:57:29', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16380, '115869', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 14:48:19', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16370, '115855', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 10:36:18', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16372, '115858', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 11:09:49', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16373, '115860', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 11:45:36', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '54.10', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16374, '115859', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 11:32:52', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.40', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16375, '115854', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 10:29:26', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16376, '115861', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 12:41:03', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '80.50', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16377, '115864', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 14:01:05', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(16378, '115862', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 13:19:03', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16379, '115870', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 15:07:25', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '100.00', '60.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16371, '115857', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 11:01:09', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '90.00', '14.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16369, '115853', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 10:12:52', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16368, '115856', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-26 10:46:37', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '50.00', '32.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1516928757', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16432, '115916', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 17:36:39', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16431, '115915', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 17:16:12', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16430, '115914', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 17:12:55', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '51.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16429, '115913', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 16:42:42', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.50', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16428, '115912', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 16:00:09', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16427, '115910', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 15:25:10', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16426, '115911', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 15:54:39', 'Paid', NULL, '138.00', '151.80', '151.80', NULL, '155.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16425, '115909', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 15:04:19', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16424, '115908', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 14:36:34', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '50.00', '33.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16423, '115902', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 14:01:51', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16422, '115905', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 14:15:51', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '100.00', '31.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16421, '115903', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 14:06:46', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16420, '115899', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 13:43:15', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16419, '115901', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 13:54:51', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.30', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16417, '115906', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 14:17:06', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16418, '115900', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 13:47:01', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '100.00', '15.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16416, '115904', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 14:14:25', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16414, '115892', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 12:01:41', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16415, '115897', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 13:17:11', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '101.50', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16413, '115896', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 12:47:07', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16408, '115895', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 12:24:47', 'Paid', NULL, '95.00', '104.50', '104.50', NULL, '110.50', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16409, '115893', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 12:03:46', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16410, '115891', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 11:57:45', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16411, '115898', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 13:34:10', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16412, '115907', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 14:26:44', 'Paid', NULL, '155.00', '170.50', '170.50', NULL, '200.00', '29.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16407, '115894', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 12:04:56', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '70.00', '10.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16396, '115883', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 10:06:00', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16398, '115880', 'T10(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 09:51:56', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16399, '115881', 'T10(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 09:52:15', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '8.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16401, '115886', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 11:09:07', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16402, '115885', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 11:04:05', 'Paid', NULL, '42.60', '46.85', '46.85', NULL, '50.00', '3.15', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16403, '115888', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 11:16:43', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16404, '115884', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 10:42:19', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16405, '115889', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 11:20:27', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16406, '115887', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 11:13:27', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '23.20', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16397, '115882', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 10:03:53', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.00', '15.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16400, '115890', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 11:26:24', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16394, '115878', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 09:32:01', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16393, '115879', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-27 09:45:36', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '53.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517014911', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16471, '115952', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 17:06:12', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16466, '115941', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 15:00:47', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16470, '115953', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 17:09:57', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '8.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16468, '115943', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 15:01:36', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16467, '115942', 'T15(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 15:01:12', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16465, '115940', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 14:54:48', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '15.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16464, '115949', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 15:33:23', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.00', '5.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16458, '115950', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 16:25:31', 'Paid', NULL, '245.50', '270.05', '270.05', NULL, '271.00', '0.95', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16459, '115948', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 15:16:57', 'Paid', NULL, '82.00', '90.20', '90.20', NULL, '100.00', '9.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16460, '115939', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 14:53:43', 'Paid', NULL, '60.60', '66.65', '66.65', NULL, '70.00', '3.35', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16469, '115951', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 16:37:02', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16462, '115947', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 15:15:41', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.40', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16463, '115946', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 15:14:49', 'Paid', NULL, '61.60', '67.75', '67.75', NULL, '70.00', '2.25', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16457, '115945', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 15:10:47', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '71.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16454, '115944', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 15:06:57', 'Paid', NULL, '150.00', '165.00', '165.00', NULL, '170.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16455, '115938', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 14:32:26', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16456, '115954', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 17:10:01', 'Paid', NULL, '29.60', '32.55', '32.55', NULL, '32.55', '0.00', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16453, '115935', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 13:20:59', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16452, '115936', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 13:21:18', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16447, '115930', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 12:19:44', 'Paid', NULL, '172.00', '189.20', '189.20', NULL, '200.00', '10.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16448, '115927', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 12:07:32', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16449, '115931', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 12:21:26', 'Paid', NULL, '6.00', '6.60', '6.60', NULL, '6.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16450, '115933', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 12:41:12', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16451, '115937', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 14:00:39', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16444, '115932', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 12:35:37', 'Paid', NULL, '152.60', '167.85', '167.85', NULL, '170.00', '2.15', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16445, '115934', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 12:41:26', 'Paid', NULL, '40.60', '44.65', '44.65', NULL, '50.00', '5.35', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16443, '115929', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 12:19:03', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.20', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16446, '115928', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 12:17:43', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.20', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16435, '115921', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 10:43:41', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16436, '115922', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 11:18:55', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '103.90', '50.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16437, '115917', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 10:09:34', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '26.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16438, '115920', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 10:41:34', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.00', '7.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16439, '115923', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 11:27:11', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '34.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16440, '115925', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 11:37:17', 'Paid', NULL, '106.60', '117.25', '117.25', NULL, '150.00', '32.75', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16442, '115926', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 11:40:51', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '83.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16441, '115924', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 11:31:44', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '100.40', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16434, '115919', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 10:27:07', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16433, '115918', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-28 10:11:19', 'Paid', NULL, '119.00', '130.90', '130.90', NULL, '150.00', '19.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517100387', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16496, '115977', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 17:07:26', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16493, '115978', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 17:08:03', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16494, '115976', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 17:03:55', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16495, '115979', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 17:11:50', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.10', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16492, '115974', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 15:13:04', 'Paid', NULL, '90.60', '99.65', '99.65', NULL, '100.00', '0.35', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16491, '115972', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 14:23:19', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '20.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16484, '115968', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 12:59:46', 'Paid', NULL, '181.00', '199.10', '199.10', NULL, '200.10', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16485, '115969', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 13:22:27', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16486, '115967', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 12:37:19', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.10', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16487, '115970', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 13:32:29', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16488, '115971', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 14:21:09', 'Paid', NULL, '50.60', '55.65', '55.65', NULL, '60.00', '4.35', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16489, '115975', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 15:20:57', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.10', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16490, '115973', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 14:31:05', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.00', '28.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16476, '115963', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 11:23:56', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16477, '115959', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 10:42:25', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.10', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16478, '115961', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 10:50:28', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '20.00', '5.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16479, '115957', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 10:13:51', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.20', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16480, '115965', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 11:28:06', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '62.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16481, '115960', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 10:45:56', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16482, '115962', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 10:53:22', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16483, '115964', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 11:25:47', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16474, '115966', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 11:36:27', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16475, '115958', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 10:20:14', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16473, '115956', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 10:05:45', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '100.50', '29.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16472, '115955', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-29 09:56:04', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517186995', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16530, '116010', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 16:28:54', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16528, '116008', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 16:23:27', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16523, '116004', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 14:55:32', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16524, '116005', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 15:40:21', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16525, '116006', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 16:05:25', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.10', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16526, '116007', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 16:07:43', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '103.20', '80.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16527, '116011', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 16:45:13', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '100.00', '80.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16521, '116001', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 14:31:18', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16522, '116002', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 14:44:20', 'Paid', NULL, '89.00', '97.90', '97.90', NULL, '100.00', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16518, '115999', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 14:20:54', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16519, '115998', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 14:17:01', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16520, '116003', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 14:48:32', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '67.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16517, '115996', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 13:12:25', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16509, '115995', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 12:48:06', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '29.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16513, '115997', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 13:12:57', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16511, '115992', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 12:18:10', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '21.00', '11.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16512, '115993', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 12:18:50', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '16.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16514, '115995', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 12:50:06', 'Paid', NULL, '10.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1517358393', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16515, '116009', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 16:25:37', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16516, '116000', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 14:24:06', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '73.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16499, '115984', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 10:23:04', 'Paid', NULL, '126.00', '138.60', '138.60', NULL, '150.00', '11.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16500, '115982', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 10:14:22', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '90.00', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16501, '115985', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 10:34:53', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '101.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16502, '115986', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 10:52:43', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '24.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16503, '115983', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 10:19:53', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16504, '115987', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 11:04:17', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '40.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16505, '115989', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 11:28:22', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.00', '2.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16506, '115988', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 11:09:22', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16507, '115990', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 11:29:55', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '83.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16508, '115991', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 12:02:52', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16498, '115981', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 10:04:05', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '90.00', '3.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16497, '115980', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-01-31 09:43:36', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '72.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517358393', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16537, '116015', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 10:49:30', 'Paid', NULL, '10.80', '10.80', '10.80', NULL, '10.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517447169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16538, '116018', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 11:18:43', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517447169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16539, '116020', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 11:34:17', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517447169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16540, '116021', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 11:59:00', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '34.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517447169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16541, '116023', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 12:37:06', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '100.00', '24.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517447169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16542, '116022', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 12:36:04', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '55.10', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517447169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16543, '116024', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 13:17:03', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '40.50', '5.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517447169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16544, '116025', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 13:36:22', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '75.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517447169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(16545, '116026', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 13:43:12', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '80.00', '6.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517447169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16546, '116027', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 14:03:57', 'Paid', NULL, '97.00', '106.70', '106.70', NULL, '106.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517447169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16547, '116029', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 15:10:19', 'Paid', NULL, '56.00', '55.45', '55.45', NULL, '60.00', '4.55', '0.00', '0.00', '6.16', '0.01', 'Cash', NULL, '27', '1517447169', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16548, '116028', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 14:39:46', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '35.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517447169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16549, '116033', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 16:51:43', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.50', '2.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517447169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16550, '116032', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 16:06:36', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517447169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16551, '116031', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 15:45:26', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '55.00', '3.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517447169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16552, '116030', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 15:26:02', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517447169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16553, '116034', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 17:12:18', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '39.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517447169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16533, '116013', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 10:02:02', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517447169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16534, '116017', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 11:14:53', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517447169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16535, '116016', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 11:08:11', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '70.00', '7.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517447169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16536, '116014', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 10:29:27', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '70.10', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517447169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16532, '116019', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 11:19:33', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '100.50', '62.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517447169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16531, '116012', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-01 09:50:15', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517447169', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16583, '116062', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 17:16:09', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16582, '116061', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 16:01:09', 'Paid', NULL, '11.00', '10.90', '10.90', NULL, '10.90', '0.00', '0.00', '0.00', '1.21', '0.01', 'Cash', NULL, '27', '1517534180', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16581, '116059', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 15:12:06', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16580, '116056', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 15:08:59', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16579, '116055', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 15:07:48', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16578, '116054', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 14:48:10', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16577, '116058', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 15:11:25', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '39.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16576, '116050', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 13:50:51', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16575, '116049', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 13:42:08', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16573, '116060', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 15:36:57', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '20.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16572, '116057', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 15:11:09', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '17.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16571, '116053', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 14:13:01', 'Paid', NULL, '103.00', '113.30', '113.30', NULL, '120.30', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16556, '116039', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 12:18:25', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16557, '116036', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 10:27:35', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16567, '116052', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 14:09:02', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '56.50', '30.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16559, '116047', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 13:13:06', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16560, '116044', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 12:54:22', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16561, '116038', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 12:12:13', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '100.10', '77.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16562, '116043', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 12:39:19', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16563, '116045', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 13:04:35', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16564, '116040', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 12:36:16', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '20.00', '9.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16565, '116041', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 12:37:54', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '100.20', '76.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16566, '116042', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 12:38:36', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '26.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16568, '116051', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 13:53:16', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16569, '116048', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 13:31:00', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16570, '116046', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 13:09:00', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16555, '116035', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 10:04:46', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '35.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16554, '116037', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-02 10:54:21', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517534180', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16624, '116101', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 16:58:42', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16625, '116102', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 18:03:37', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '53.10', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16623, '116103', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 18:11:00', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16622, '116099', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 15:48:25', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.40', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16620, '116096', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 15:14:14', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '78.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16621, '116098', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 15:41:50', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16619, '116093', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 14:33:53', 'Paid', NULL, '22.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', '2.20', '0.00', 'Cash', NULL, '27', '1517620364', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16618, '116097', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 15:32:58', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16617, '116100', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 16:53:39', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '50.00', '41.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16616, '116092', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 14:31:43', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16615, '116095', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 15:08:09', 'Paid', NULL, '67.60', '74.35', '74.35', NULL, '100.00', '25.65', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16614, '116090', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 14:01:43', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16613, '116094', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 14:42:02', 'Paid', NULL, '156.00', '171.60', '171.60', NULL, '200.00', '28.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16612, '116089', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 13:44:51', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '50.00', '8.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16611, '116091', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 14:16:56', 'Paid', NULL, '102.00', '112.20', '112.20', NULL, '150.20', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16610, '116086', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 13:13:53', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '51.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16608, '116087', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 13:17:37', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '28.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16609, '116085', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 13:09:57', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '15.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16607, '116084', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 12:47:15', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '60.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16605, '116081', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 12:00:48', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '15.00', '2.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16604, '116080', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 12:00:22', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '16.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16603, '116083', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 12:29:23', 'Paid', NULL, '92.00', '101.20', '101.20', NULL, '101.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16602, '116078', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 11:51:53', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16606, '116088', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 13:23:49', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16601, '116077', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 11:49:53', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16586, '116065', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 10:19:34', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16599, '116075', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 11:41:36', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16590, '116069', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 10:52:28', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16591, '116076', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 11:48:23', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '88.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16592, '116068', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 10:51:38', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16593, '116071', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 11:06:15', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16594, '116079', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 11:59:45', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '42.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16595, '116073', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 11:16:16', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16596, '116072', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 11:14:00', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16597, '116074', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 11:17:29', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.00', '2.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16598, '116082', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 12:08:47', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.10', '22.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16589, '116066', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 10:20:24', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16588, '116067', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 10:23:14', 'Paid', NULL, '133.00', '146.30', '146.30', NULL, '150.00', '3.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16587, '116070', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 10:55:41', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.00', '41.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16585, '116063', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 09:56:58', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '60.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16584, '116064', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-03 10:11:13', 'Paid', NULL, '68.80', '75.70', '75.70', NULL, '80.70', '5.00', '0.00', '0.00', NULL, '0.02', 'Cash', NULL, '27', '1517620364', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16665, '116142', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 17:12:36', 'Paid', NULL, '10.00', '9.00', '9.00', NULL, '9.00', '0.00', '0.00', '0.00', '1.00', '0.00', 'Cash', NULL, '27', '1517707745', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16664, '116141', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 16:37:59', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '20.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16662, '116140', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 15:38:31', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16663, '116139', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 15:35:41', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.00', '26.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16661, '116138', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 15:34:17', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16660, '116137', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 15:28:00', 'Paid', NULL, '50.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', '5.50', '0.00', 'Cash', NULL, '27', '1517707745', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16659, '116143', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 17:40:58', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '21.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16658, '116132', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 14:40:59', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '70.00', '2.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16655, '116131', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 14:13:32', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.30', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16656, '116134', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 14:57:33', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16657, '116135', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 14:59:12', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '30.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16654, '116136', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 15:02:50', 'Paid', NULL, '65.00', '64.35', '64.35', NULL, '100.00', '35.65', '0.00', '0.00', '7.15', '0.00', 'Cash', NULL, '27', '1517707745', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16653, '116124', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 13:12:50', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16652, '116123', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 13:11:22', 'Paid', NULL, '1.00', '1.00', '1.00', NULL, '1.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16648, '116129', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 13:39:04', 'Paid', NULL, '95.00', '104.50', '104.50', NULL, '110.50', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16649, '116133', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 14:44:06', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16650, '116130', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 13:49:31', 'Paid', NULL, '61.60', '67.75', '67.75', NULL, '70.00', '2.25', '0.00', '0.00', NULL, '-0.01', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16651, '116121', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 13:08:13', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16641, '116127', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 13:29:40', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16646, '116125', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 13:17:31', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.00', '15.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16647, '116126', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 13:26:06', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '80.00', '1.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16642, '116119', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 12:53:35', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16643, '116114', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 12:29:34', 'Paid', NULL, '15.00', '15.00', '15.00', NULL, '20.00', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16644, '116116', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 12:33:48', 'Paid', NULL, '5.00', '5.50', '5.50', NULL, '10.00', '4.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16645, '116117', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 12:35:13', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.00', '7.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16640, '116128', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 13:37:54', 'Paid', NULL, '98.00', '107.80', '107.80', NULL, '110.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16631, '116108', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 11:16:20', 'Paid', NULL, '109.00', '119.90', '119.90', NULL, '130.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16632, '116110', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 11:51:40', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '50.00', '6.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16633, '116120', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 13:03:15', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.00', '5.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16634, '116115', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 12:29:51', 'Paid', NULL, '268.00', '294.80', '294.80', NULL, '300.00', '5.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16635, '116111', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 12:08:54', 'Paid', NULL, '124.00', '136.40', '136.40', NULL, '140.50', '4.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16636, '116112', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 12:18:06', 'Paid', NULL, '96.00', '105.60', '105.60', NULL, '110.00', '4.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16637, '116113', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 12:28:26', 'Paid', NULL, '164.00', '162.35', '162.35', NULL, '200.00', '37.65', '0.00', '0.00', '18.04', '-0.01', 'Cash', NULL, '27', '1517707745', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16638, '116118', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 12:38:29', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16639, '116122', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 13:10:15', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '65.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16630, '116109', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 11:17:00', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '104.00', '20.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16628, '116106', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 11:03:09', 'Paid', NULL, '32.00', '31.70', '31.70', NULL, '50.00', '18.30', '0.00', '0.00', '3.52', '0.02', 'Cash', NULL, '27', '1517707745', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16629, '116104', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 10:13:42', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16627, '116107', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 11:07:38', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '80.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16626, '116105', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-04 10:21:35', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '60.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517707745', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16680, '116160', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-05 16:55:06', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517793076', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16681, '116158', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-05 16:38:36', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '22.10', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517793076', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16682, '116159', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-05 16:46:10', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '100.00', '40.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517793076', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16676, '116156', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-05 16:09:55', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '8.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517793076', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16677, '116153', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-05 14:13:29', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517793076', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16678, '116157', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-05 16:10:07', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517793076', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16679, '116155', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-05 15:44:12', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '40.20', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517793076', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16670, '116147', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-02-05 11:59:06', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.00', '12.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517793076', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16671, '116151', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-05 13:27:23', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517793076', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16672, '116148', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-05 12:15:58', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517793076', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16673, '116150', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-05 13:14:45', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '30.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517793076', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16674, '116152', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-05 13:55:51', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517793076', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16668, '116146', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-05 11:30:28', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '65.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517793076', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16675, '116154', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-05 14:29:15', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '40.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517793076', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16669, '116149', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-05 12:24:33', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517793076', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16667, '116145', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-05 10:34:51', 'Paid', NULL, '11.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', '1.10', '0.00', 'Cash', NULL, '27', '1517793076', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16666, '116144', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-05 10:25:26', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '64.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517793076', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16705, '116182', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 17:57:50', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '82.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517965747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16695, '116173', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 14:24:46', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517965747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16696, '116168', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 13:00:28', 'Paid', NULL, '11.00', '9.05', '9.05', NULL, '10.00', '0.95', '0.00', '0.00', '3.03', '-0.02', 'Cash', NULL, '27', '1517965747', 'p', '25', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16697, '116171', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 13:18:59', 'Paid', NULL, '150.00', '150.00', '150.00', NULL, '150.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517965747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16698, '116181', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 16:09:37', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517965747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16699, '116177', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 14:59:15', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '100.00', '37.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517965747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(16700, '116174', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 14:25:11', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.50', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517965747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16701, '116176', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 14:31:20', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517965747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16702, '116178', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 15:03:38', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517965747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16703, '116179', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 15:12:16', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517965747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16704, '116180', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 15:37:40', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517965747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16694, '116172', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 13:31:05', 'Paid', NULL, '255.00', '280.50', '280.50', NULL, '300.50', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517965747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16693, '116169', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 13:09:00', 'Paid', NULL, '26.00', '25.75', '25.75', NULL, '100.75', '75.00', '0.00', '0.00', '2.86', '0.01', 'Cash', NULL, '27', '1517965747', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16685, '116183', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 18:09:40', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517965747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16686, '116163', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 11:23:20', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '100.00', '64.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517965747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16687, '116164', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 11:49:01', 'Paid', NULL, '107.00', '117.70', '117.70', NULL, '117.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517965747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16688, '116165', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 11:55:26', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517965747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16689, '116166', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 12:13:54', 'Paid', NULL, '88.00', '96.80', '96.80', NULL, '100.00', '3.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517965747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16690, '116167', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 12:16:10', 'Paid', NULL, '32.00', '31.70', '31.70', NULL, '31.70', '0.00', '0.00', '0.00', '3.52', '0.02', 'Cash', NULL, '27', '1517965747', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16691, '116170', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 13:15:14', 'Paid', NULL, '121.00', '133.10', '133.10', NULL, '150.50', '17.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517965747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16692, '116175', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 14:27:17', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.00', '17.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517965747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16684, '116162', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 10:41:08', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '74.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517965747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16683, '116161', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-07 10:11:57', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1517965747', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16737, '116212', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 16:40:39', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16738, '116211', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 16:40:34', 'Paid', NULL, '45.00', '45.00', '45.00', NULL, '45.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16739, '116213', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 16:41:28', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16736, '116214', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 16:46:56', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16734, '116205', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 15:01:31', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16735, '116203', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 14:39:13', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '30.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16733, '116206', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 15:02:19', 'Paid', NULL, '21.00', '20.80', '20.80', NULL, '50.00', '29.20', '0.00', '0.00', '2.31', '0.01', 'Cash', NULL, '27', '1518051961', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16722, '116196', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 13:51:09', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.20', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16719, '116190', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 12:48:34', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16720, '116191', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 12:49:13', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.50', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16721, '116192', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 12:49:40', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16723, '116202', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 14:33:55', 'Paid', NULL, '25.00', '24.75', '24.75', NULL, '50.00', '25.25', '0.00', '0.00', '2.75', '0.00', 'Cash', NULL, '27', '1518051961', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16724, '116200', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 14:28:04', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '100.00', '67.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16725, '116194', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 13:14:03', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16726, '116197', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 13:53:43', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '30.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16727, '116209', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 15:19:38', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '99.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16728, '116210', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 15:33:22', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '8.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16729, '116199', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 14:25:00', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '20.00', '2.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16730, '116201', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 14:31:27', 'Paid', NULL, '30.70', '30.40', '30.40', NULL, '50.40', '20.00', '0.00', '0.00', '3.38', '0.01', 'Cash', NULL, '27', '1518051961', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16731, '116204', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 14:43:38', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16732, '116207', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 15:02:42', 'Paid', NULL, '60.00', '60.00', '60.00', NULL, '60.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16710, '116186', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 12:17:10', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16712, '116208', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 15:05:37', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.40', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16713, '116187', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 12:22:27', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16714, '116188', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 12:22:57', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16716, '116189', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 12:33:33', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.60', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16711, '116198', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 14:20:29', 'Paid', NULL, '12.00', '11.90', '11.90', NULL, '11.90', '0.00', '0.00', '0.00', '1.32', '0.02', 'Cash', NULL, '27', '1518051961', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16718, '116195', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 13:21:58', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '60.00', '1.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16715, '116193', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 13:13:37', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16707, '116184', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 11:41:25', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '35.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16706, '116185', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-08 12:15:10', 'Paid', NULL, '101.00', '111.10', '111.10', NULL, '120.00', '8.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518051961', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16773, '116241', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 14:51:49', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16776, '116245', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 16:33:49', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.40', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16775, '116244', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 15:11:17', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16772, '116240', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 14:48:41', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16762, '116233', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 12:56:10', 'Paid', NULL, '52.00', '42.90', '42.90', NULL, '100.00', '57.10', '0.00', '0.00', '14.30', '0.00', 'Cash', NULL, '27', '1518135973', 'p', '25', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16763, '116235', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 13:26:48', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '52.00', '38.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16754, '116221', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 11:30:08', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '50.00', '34.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16755, '116222', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 11:31:04', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16757, '116231', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 12:15:02', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16759, '116234', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 13:26:09', 'Paid', NULL, '36.00', '35.65', '35.65', NULL, '50.65', '15.00', '0.00', '0.00', '3.96', '0.01', 'Cash', NULL, '27', '1518135973', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16760, '116228', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 12:09:06', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '50.50', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16761, '116229', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 12:09:52', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '55.20', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16764, '116236', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 14:09:33', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16767, '116237', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 14:19:09', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.00', '5.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16768, '116238', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 14:23:15', 'Paid', NULL, '78.00', '85.80', '85.80', NULL, '100.00', '14.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16769, '116239', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 14:40:44', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16770, '116242', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 14:52:20', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16771, '116243', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 14:54:40', 'Paid', NULL, '110.00', '121.00', '121.00', NULL, '151.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16746, '116223', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 11:49:50', 'Paid', NULL, '55.00', '60.50', '60.50', NULL, '70.00', '9.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16747, '116227', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 12:06:13', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '100.00', '47.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16749, '116218', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 11:03:02', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16750, '116219', 'T8(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 11:03:33', 'Paid', NULL, '37.00', '40.70', '40.70', NULL, '50.00', '9.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16752, '116224', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 11:52:24', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '64.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16753, '116230', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 12:12:07', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '103.00', '70.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16742, '116232', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 12:37:15', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16743, '116217', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 10:37:35', 'Paid', NULL, '49.00', '53.90', '53.90', NULL, '60.00', '6.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16756, '116226', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 12:00:21', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.00', '37.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16745, '116220', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 11:27:49', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16751, '116225', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 11:56:10', 'Paid', NULL, '98.00', '107.80', '107.80', NULL, '110.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16741, '116216', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 10:13:27', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '50.00', '30.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16740, '116215', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-09 09:41:33', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '100.00', '6.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1518135973', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16779, '116246', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-20 10:32:28', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519091919', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16809, '116273', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 16:29:43', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.20', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16810, '116278', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 17:01:06', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '19.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16811, '116271', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 16:02:47', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16812, '116276', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 16:57:13', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16797, '116261', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 14:34:40', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '44.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16798, '116275', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 16:36:00', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '20.00', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16790, '116257', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 13:16:14', 'Paid', NULL, '113.00', '124.30', '124.30', NULL, '150.00', '25.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16796, '116258', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 14:03:26', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16791, '116256', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 13:14:18', 'Paid', NULL, '53.00', '43.70', '43.70', NULL, '43.70', '0.00', '0.00', '0.00', '14.58', '-0.02', 'Cash', NULL, '27', '1519190124', 'p', '25', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16792, '116272', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 16:14:26', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16793, '116274', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 16:30:15', 'Paid', NULL, '108.00', '118.80', '118.80', NULL, '150.00', '31.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16794, '116267', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 15:09:46', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '100.50', '18.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16795, '116264', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 14:37:15', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16799, '116265', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 14:38:29', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16800, '116266', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 15:02:35', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '100.00', '40.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16801, '116259', 'T13', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 14:17:08', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16802, '116260', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 14:19:58', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '100.00', '86.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16803, '116277', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 17:00:44', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '51.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16804, '116262', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 14:36:18', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16805, '116263', 'T3(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 14:36:56', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '40.00', '1.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16806, '116268', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 15:16:05', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '50.00', '40.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16807, '116270', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 16:00:39', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '105.00', '31.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16808, '116269', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 16:00:00', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16783, '116249', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 09:52:46', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '13.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16784, '116250', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 10:09:05', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16786, '116252', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 11:28:40', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.00', '13.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16787, '116253', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 12:29:54', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16788, '116254', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 12:52:40', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '104.70', '31.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16789, '116255', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 13:09:05', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16785, '116251', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 10:15:51', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '31.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16781, '116247', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 09:39:33', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '70.00', '7.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16782, '116248', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-21 09:51:59', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519190124', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16820, '116293', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 13:46:06', 'Paid', NULL, '25.00', '24.75', '24.75', NULL, '100.00', '75.25', '0.00', '0.00', '2.75', '0.00', 'Cash', NULL, '27', '1519261074', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16821, '116292', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 13:43:52', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '100.00', '70.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519261074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16822, '116285', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 12:26:30', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519261074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16823, '116287', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 13:16:00', 'Paid', NULL, '158.00', '173.80', '173.80', NULL, '174.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519261074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16824, '116297', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 13:54:09', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.10', '11.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519261074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16825, '116299', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 14:11:13', 'Paid', NULL, '51.00', '50.50', '50.50', NULL, '50.50', '0.00', '0.00', '0.00', '5.61', '0.01', 'Cash', NULL, '27', '1519261074', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16826, '116290', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 13:40:03', 'Paid', NULL, '124.00', '136.40', '136.40', NULL, '140.00', '3.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519261074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16827, '116300', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 14:59:52', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '105.10', '60.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519261074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16828, '116291', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 13:43:27', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519261074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16829, '116294', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 13:46:46', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519261074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16830, '116288', 'T13', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 13:36:02', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519261074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16831, '116296', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 13:48:41', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.10', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519261074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16832, '116298', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 14:09:49', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '32.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519261074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16833, '116289', 'T7(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 13:38:22', 'Paid', NULL, '72.00', '71.30', '71.30', NULL, '102.00', '30.70', '0.00', '0.00', '7.92', '0.02', 'Cash', NULL, '27', '1519261074', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16834, '116295', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 13:47:11', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '30.00', '5.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519261074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16835, '116302', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 15:52:20', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '20.00', '11.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519261074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16836, '116301', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 15:33:41', 'Paid', NULL, '12.00', '10.80', '10.80', NULL, '50.00', '39.20', '0.00', '0.00', '1.20', '0.00', 'Cash', NULL, '27', '1519261074', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16837, '116303', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 16:01:09', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '50.10', '16.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519261074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16838, '116304', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 16:25:02', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519261074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16815, '116281', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 10:48:40', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519261074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16816, '116282', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 10:56:00', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '66.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519261074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16817, '116283', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 11:21:01', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519261074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16818, '116284', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 11:33:53', 'Paid', NULL, '65.00', '64.35', '64.35', NULL, '65.00', '0.65', '0.00', '0.00', '7.15', '0.00', 'Cash', NULL, '27', '1519261074', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16819, '116286', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 12:34:50', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519261074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16814, '116280', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 10:23:29', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '100.10', '33.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519261074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16813, '116279', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-22 09:56:25', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '105.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519261074', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16865, '116330', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 17:38:43', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16841, '116307', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 11:23:14', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '30.00', '2.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16842, '116308', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 11:45:05', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16843, '116314', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 13:47:50', 'Paid', NULL, '77.00', '84.70', '84.70', NULL, '104.20', '19.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16844, '116309', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 12:27:50', 'Paid', NULL, '73.90', '73.15', '73.15', NULL, '103.15', '30.00', '0.00', '0.00', '8.13', '-0.01', 'Cash', NULL, '27', '1519348637', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16845, '116311', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 12:50:14', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '62.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16846, '116310', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 12:42:34', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16847, '116322', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 15:11:16', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '50.00', '38.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(16848, '116312', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 13:03:06', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '50.00', '17.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16849, '116316', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 14:12:24', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16850, '116313', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 13:18:55', 'Paid', NULL, '29.00', '28.70', '28.70', NULL, '28.70', '0.00', '0.00', '0.00', '3.19', '-0.01', 'Cash', NULL, '27', '1519348637', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16851, '116317', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 14:17:05', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16852, '116318', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 14:39:21', 'Paid', NULL, '77.00', '76.25', '76.25', NULL, '80.00', '3.75', '0.00', '0.00', '8.47', '0.02', 'Cash', NULL, '27', '1519348637', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16853, '116315', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 14:09:06', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '50.30', '14.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16854, '116324', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 15:42:24', 'Paid', NULL, '173.00', '190.30', '190.30', NULL, '190.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16855, '116319', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 14:40:31', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.00', '3.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16856, '116323', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 15:11:51', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.10', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16857, '116320', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 15:02:14', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '57.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16858, '116321', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 15:08:50', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '64.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16859, '116326', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 16:05:54', 'Paid', NULL, '100.00', '110.00', '110.00', NULL, '110.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16860, '116325', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 15:56:12', 'Paid', NULL, '32.00', '32.00', '32.00', NULL, '52.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16861, '116327', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 16:08:57', 'Paid', NULL, '20.00', '20.00', '20.00', NULL, '20.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16862, '116328', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 17:34:43', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16863, '116329', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 17:37:23', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '100.00', '69.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16864, '116331', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 17:39:24', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.20', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16840, '116306', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 10:34:36', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16839, '116305', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-23 09:52:04', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519348637', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16932, '116393', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 17:26:47', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '16.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16933, '116394', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 17:27:33', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.50', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16931, '116392', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 17:26:10', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '16.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16930, '116391', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 17:25:26', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '17.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16929, '116389', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 16:56:48', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16928, '116388', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 16:55:22', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16927, '116387', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 16:52:57', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16923, '116383', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 16:39:06', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16924, '116384', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 16:39:40', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '100.00', '83.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16925, '116385', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 16:40:34', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '15.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16921, '116381', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 16:36:34', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '39.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16922, '116382', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 16:38:11', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '13.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16914, '116380', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 16:16:00', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.50', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16915, '116395', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 17:33:10', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16916, '116379', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 16:12:17', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '20.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16918, '116378', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 16:05:50', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16919, '116386', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 16:41:16', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '22.10', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16920, '116390', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 17:11:20', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '51.80', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16913, '116376', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 15:40:29', 'Paid', NULL, '45.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16912, '116377', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 15:49:43', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.20', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16911, '116370', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 14:54:07', 'Paid', NULL, '31.00', '34.10', '34.10', NULL, '35.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16910, '116371', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 14:57:48', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '71.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16909, '116374', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 15:02:58', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '75.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16908, '116372', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 14:59:00', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16907, '116366', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 14:28:24', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16904, '116364', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 14:22:19', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16905, '116362', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 14:17:53', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.10', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16906, '116369', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 14:41:04', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16903, '116359', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 13:41:35', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '15.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16902, '116373', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 15:00:35', 'Paid', NULL, '85.00', '93.50', '93.50', NULL, '100.00', '6.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16900, '116363', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 14:20:57', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.80', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16901, '116365', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 14:25:16', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.00', '36.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16881, '116349', 'T12A', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 12:19:56', 'Paid', NULL, '117.00', '128.70', '128.70', NULL, '130.70', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16875, '116338', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 11:31:31', 'Paid', NULL, '97.00', '106.70', '106.70', NULL, '110.00', '3.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16876, '116357', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 13:32:07', 'Paid', NULL, '75.00', '82.50', '82.50', NULL, '85.50', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16877, '116343', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 11:43:15', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '100.00', '7.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16885, '116341', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 11:36:11', 'Paid', NULL, '30.00', '30.00', '30.00', NULL, '50.00', '20.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16879, '116344', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 11:49:35', 'Paid', NULL, '134.00', '147.40', '147.40', NULL, '150.00', '2.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16880, '116348', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 12:01:58', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16867, '116346', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 11:53:35', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '41.90', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16868, '116333', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 10:41:15', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '100.30', '42.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16869, '116332', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 10:37:55', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16870, '116337', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 11:25:54', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16871, '116335', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 11:00:48', 'Paid', NULL, '37.00', '36.65', '36.65', NULL, '50.00', '13.35', '0.00', '0.00', '4.07', '0.02', 'Cash', NULL, '27', '1519433982', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16872, '116336', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 11:07:13', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '50.00', '29.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16873, '116347', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 11:54:50', 'Paid', NULL, '62.50', '68.75', '68.75', NULL, '100.00', '31.25', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16899, '116360', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 13:53:00', 'Paid', NULL, '69.00', '75.90', '75.90', NULL, '76.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16898, '116361', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 13:55:22', 'Paid', NULL, '134.00', '147.40', '147.40', NULL, '200.00', '52.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16897, '116375', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 15:25:22', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '50.00', '3.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16896, '116368', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 14:38:05', 'Paid', NULL, '129.00', '141.90', '141.90', NULL, '150.00', '8.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16895, '116358', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 13:40:17', 'Paid', NULL, '103.00', '113.30', '113.30', NULL, '114.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16894, '116367', 'T13', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 14:28:45', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16893, '116354', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 13:08:24', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '20.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16892, '116355', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 13:11:11', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.00', '1.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16891, '116353', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 13:01:17', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16889, '116351', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 12:36:10', 'Paid', NULL, '30.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', '3.30', '0.00', 'Cash', NULL, '27', '1519433982', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16890, '116352', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 12:55:46', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '65.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16887, '116342', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 11:41:53', 'Paid', NULL, '180.00', '180.00', '180.00', NULL, '180.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16888, '116356', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 13:12:22', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16884, '116340', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 11:33:36', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '73.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16883, '116339', 'T11(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 11:32:33', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16882, '116350', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 12:33:41', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '63.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16874, '116345', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 11:51:26', 'Paid', NULL, '90.00', '99.00', '99.00', NULL, '100.00', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16866, '116334', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-24 10:57:52', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '65.00', '2.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519433982', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16973, '116435', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 17:19:14', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '56.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16974, '116434', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 17:15:49', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16952, '116415', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 13:40:14', 'Paid', NULL, '53.00', '58.30', '58.30', NULL, '58.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16953, '116416', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 13:40:32', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '31.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16954, '116413', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 12:53:41', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16955, '116417', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 13:52:09', 'Paid', NULL, '243.00', '267.30', '267.30', NULL, '300.00', '32.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16956, '116418', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 13:52:46', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16957, '116419', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 13:55:12', 'Paid', NULL, '128.00', '140.80', '140.80', NULL, '150.00', '9.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16958, '116414', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 13:36:13', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '50.00', '10.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16959, '116421', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 14:30:09', 'Paid', NULL, '87.00', '95.70', '95.70', NULL, '100.70', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16960, '116420', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 14:05:25', 'Paid', NULL, '162.00', '178.20', '178.20', NULL, '200.00', '21.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16961, '116432', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 17:00:25', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16962, '116422', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 14:48:04', 'Paid', NULL, '53.80', '59.20', '59.20', NULL, '60.20', '1.00', '0.00', '0.00', NULL, '0.02', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16963, '116423', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 15:02:00', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16964, '116429', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 16:31:23', 'Paid', NULL, '10.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16965, '116424', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 15:28:57', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16966, '116426', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 16:02:26', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16967, '116430', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 16:32:37', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '30.20', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16968, '116431', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 16:39:15', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.00', '4.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16969, '116425', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 15:57:30', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '61.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16970, '116433', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 17:08:43', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '84.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16971, '116427', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 16:22:32', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16972, '116428', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 16:25:19', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '3333330.00', '3333316.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16951, '116412', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 12:40:34', 'Paid', NULL, '30.00', '33.00', '33.00', NULL, '33.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16947, '116408', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 12:03:34', 'Paid', NULL, '74.00', '81.40', '81.40', NULL, '100.00', '18.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16948, '116407', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 12:00:26', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.20', '15.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16949, '116409', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 12:19:23', 'Paid', NULL, '179.00', '196.90', '196.90', NULL, '200.00', '3.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16950, '116406', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 11:54:05', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.10', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16944, '116403', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 10:57:23', 'Paid', NULL, '29.00', '31.90', '31.90', NULL, '50.00', '18.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16945, '116404', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 10:57:51', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16942, '116401', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 10:55:51', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16943, '116402', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 10:56:54', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16940, '116410', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 12:20:49', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '58.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16941, '116400', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 10:42:01', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '15.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16946, '116411', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 12:27:12', 'Paid', NULL, '98.00', '107.80', '107.80', NULL, '110.00', '2.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16939, '116405', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 11:19:37', 'Paid', NULL, '57.00', '62.70', '62.70', NULL, '73.00', '10.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16936, '116398', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 10:28:28', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16937, '116397', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 10:27:13', 'Paid', NULL, '86.00', '94.60', '94.60', NULL, '100.00', '5.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16935, '116399', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 10:30:47', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16934, '116396', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-25 09:46:50', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519520119', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16991, '116454', 'T1', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 14:04:25', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16992, '116452', 'T2', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 13:48:51', 'Paid', NULL, '60.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', '13.20', '0.00', 'Cash', NULL, '27', '1519636416', 'p', '20', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16993, '116449', 'IS', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 13:29:38', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16994, '116453', 'T14', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 13:49:21', 'Paid', NULL, '71.00', '78.10', '78.10', NULL, '100.00', '21.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16995, '116451', 'T15', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 13:46:59', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '50.00', '28.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16996, '116458', 'T11', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 15:18:39', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '50.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16997, '116456', 'T2', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 14:54:00', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '50.00', '25.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16998, '116457', 'T1', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 14:55:07', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '63.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16999, '116463', 'T1', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 15:58:30', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '16.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17000, '116459', 'IS', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 15:53:32', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(17001, '116460', 'T2', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 15:54:51', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '15.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17002, '116461', 'IS', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 15:55:06', 'Paid', NULL, '8.00', '8.00', '8.00', NULL, '20.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(17003, '116462', 'IS', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 15:57:01', 'Paid', NULL, '7.00', '7.00', '7.00', NULL, '7.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(17004, '116465', 'T7', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 16:52:19', 'Paid', NULL, '15.00', '16.50', '16.50', NULL, '20.00', '3.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16990, '116450', 'T3', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 13:31:31', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '20.10', '8.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16983, '116442', 'T6', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 11:40:52', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '60.00', '7.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16984, '116446', 'T2', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 12:48:27', 'Paid', NULL, '33.00', '36.30', '36.30', NULL, '36.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16985, '116445', 'T3', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 12:22:05', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16988, '116447', 'T14', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 12:53:04', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '100.00', '19.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16989, '116455', 'T6', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 14:38:40', 'Paid', NULL, '62.00', '61.40', '61.40', NULL, '61.40', '0.00', '0.00', '0.00', '6.82', '0.02', 'Cash', NULL, '27', '1519636416', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16986, '116448', 'T7', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 13:24:49', 'Paid', NULL, '120.00', '132.00', '132.00', NULL, '132.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16987, '116444', 'T8', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 12:18:03', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '100.40', '74.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16980, '116440', 'IS', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 10:37:47', 'Paid', NULL, '11.00', '11.00', '11.00', NULL, '11.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(16981, '116464', 't4', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 16:17:24', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');
INSERT INTO `fnb_sales` (`id`, `txn_no`, `table_no`, `user_id`, `username`, `employee_id`, `employee_username`, `type`, `datetime`, `payment_status`, `cost`, `subtotal`, `amount`, `amount_cash`, `amount_cc`, `amount_tendered`, `amount_change`, `amount_voucher`, `amount_cheque`, `amount_discount`, `adjustment`, `payment_method`, `payment_details`, `terminal`, `session`, `discount_type`, `discount`, `payment`, `verified`, `warehouse_id`, `taxes`, `taxable_amount`, `tax_amount`, `cc_type`, `cc_fee`, `cc_name`, `cc_percentage`, `cc_tax_percentage`, `cc_tax`, `cc_amount`, `no_of_pax`, `customer_id`, `customer`, `service_charge`, `recon_date`, `table_card_no`) VALUES
(16982, '116443', 'T7', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 11:42:13', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.40', '24.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16977, '116439', 'T2', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 10:36:34', 'Paid', NULL, '66.00', '72.60', '72.60', NULL, '100.00', '27.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16979, '116438', 'T10', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 10:35:14', 'Paid', NULL, '37.00', '36.65', '36.65', NULL, '50.00', '13.35', '0.00', '0.00', '4.07', '0.02', 'Cash', NULL, '27', '1519636416', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16978, '116437', 'T8', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 10:19:14', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '8.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16976, '116436', 'T4', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 09:40:02', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '50.00', '19.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519636416', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(16975, '116441', 'T7', 10008, 'lois', NULL, NULL, 'history', '2018-02-26 11:09:25', 'Paid', NULL, '50.00', '49.50', '49.50', NULL, '50.00', '0.50', '0.00', '0.00', '5.50', '0.00', 'Cash', NULL, '27', '1519636416', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17020, '116475', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-28 12:43:27', 'Paid', NULL, '10.00', '10.00', '10.00', NULL, '10.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519780133', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(17021, '116482', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-28 13:51:35', 'Paid', NULL, '79.00', '86.90', '86.90', NULL, '100.00', '13.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519780133', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17022, '116486', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-02-28 15:34:46', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '57.20', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519780133', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17023, '116483', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-28 14:07:48', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519780133', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17024, '116484', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-02-28 14:50:50', 'Paid', NULL, '73.00', '80.30', '80.30', NULL, '80.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519780133', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17027, '116487', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-28 15:35:44', 'Paid', NULL, '2.00', '2.00', '2.00', NULL, '2.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519780133', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(17026, '116485', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-02-28 15:02:30', 'Paid', NULL, '21.00', '21.00', '21.00', NULL, '21.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519780133', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(17013, '116473', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-02-28 12:33:21', 'Paid', NULL, '34.00', '37.40', '37.40', NULL, '50.40', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519780133', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17014, '116478', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-28 13:10:08', 'Paid', NULL, '84.00', '92.40', '92.40', NULL, '102.40', '10.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519780133', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17015, '116474', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-02-28 12:34:00', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '9.90', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519780133', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17016, '116476', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-28 13:01:14', 'Paid', NULL, '54.00', '59.40', '59.40', NULL, '70.00', '10.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519780133', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17017, '116479', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-02-28 13:12:14', 'Paid', NULL, '65.00', '53.60', '53.60', NULL, '53.60', '0.00', '0.00', '0.00', '17.88', '-0.02', 'Cash', NULL, '27', '1519780133', 'p', '25', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17018, '116480', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-28 13:26:25', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519780133', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17019, '116477', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-28 13:07:22', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519780133', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17009, '116468', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-02-28 11:40:39', 'Paid', NULL, '91.00', '100.10', '100.10', NULL, '100.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519780133', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17010, '116481', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-02-28 13:27:16', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '20.00', '11.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519780133', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17011, '116471', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-02-28 12:26:44', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519780133', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17012, '116469', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-02-28 11:45:30', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '100.00', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519780133', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17007, '116467', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-02-28 10:13:45', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '50.00', '41.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519780133', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17008, '116470', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-28 12:16:09', 'Paid', NULL, '36.00', '39.60', '39.60', NULL, '40.00', '0.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519780133', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17006, '116466', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-02-28 10:09:38', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '53.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519780133', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17005, '116472', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-02-28 12:28:27', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519780133', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17028, 'A00002', 'B1', 10003, 'admin', NULL, NULL, 'history', '2018-02-20 21:49:06', 'Paid', NULL, '6354.78', '6354.78', '6354.78', NULL, '6354.78', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1465306099', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17036, '116492', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2018-03-01 12:42:39', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '20.00', '1.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519866231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(17037, '116493', 'T4(S)', 10003, 'admin', NULL, NULL, 'history', '2018-03-01 12:43:19', 'Paid', NULL, '16.00', '17.60', '17.60', NULL, '17.60', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519866231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(17039, '116497', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-03-01 13:54:46', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '25.00', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519866231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17040, '116502', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-03-01 16:43:38', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.00', '26.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519866231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17041, '116500', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-03-01 15:47:00', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.50', '23.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519866231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17042, '116499', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-03-01 15:37:55', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519866231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17030, '116501', 't4', 10003, 'admin', NULL, NULL, 'history', '2018-03-01 15:58:06', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519866231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17031, '116491', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-03-01 12:40:33', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519866231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17032, '116495', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-03-01 12:55:10', 'Paid', NULL, '104.00', '114.40', '114.40', NULL, '120.00', '5.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519866231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17038, '116498', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-03-01 15:29:37', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.20', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519866231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17034, '116494', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-03-01 12:54:14', 'Paid', NULL, '59.00', '58.40', '58.40', NULL, '70.50', '12.10', '0.00', '0.00', '6.49', '-0.01', 'Cash', NULL, '27', '1519866231', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17035, '116496', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-03-01 13:26:00', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '70.00', '0.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519866231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17029, '116490', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-03-01 12:07:50', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519866231', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17074, '116543', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 16:54:21', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '53.00', '10.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17059, '116530', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 13:33:27', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '55.00', '3.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17060, '116534', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 14:08:38', 'Paid', NULL, '64.00', '70.40', '70.40', NULL, '71.00', '0.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17061, '116532', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 13:42:20', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17062, '116533', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 14:04:36', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '50.10', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17063, '116535', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 14:24:59', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '102.00', '80.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17065, '116538', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 15:31:48', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '50.00', '37.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17067, '116540', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 16:44:10', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '15.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17064, '116536', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 14:54:43', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '100.00', '35.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17068, '116546', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 17:12:42', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '50.00', '40.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17069, '116544', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 16:57:54', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '36.00', '0.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17070, '116539', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 16:22:36', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '10.00', '7.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(17071, '116541', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 16:45:46', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17072, '116545', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 17:00:42', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.00', '4.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17073, '116542', 'T2(S)', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 16:52:06', 'Paid', NULL, '9.00', '8.90', '8.90', NULL, '20.00', '11.10', '0.00', '0.00', '0.99', '-0.01', 'Cash', NULL, '27', '1519952075', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(17058, '116527', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 12:24:09', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '50.00', '24.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17057, '116537', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 15:16:03', 'Paid', NULL, '19.00', '20.90', '20.90', NULL, '25.00', '4.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17044, '116520', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 10:26:41', 'Paid', NULL, '42.00', '46.20', '46.20', NULL, '100.20', '54.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17045, '116517', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 10:00:53', 'Paid', NULL, '6.00', '6.00', '6.00', NULL, '6.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(17046, '116518', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 10:01:52', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(17047, '116519', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 10:03:08', 'Paid', NULL, '3.00', '3.00', '3.00', NULL, '3.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(17048, '116521', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 10:55:05', 'Paid', NULL, '47.00', '51.70', '51.70', NULL, '52.00', '0.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17049, '116522', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 11:18:43', 'Paid', NULL, '49.00', '48.50', '48.50', NULL, '50.00', '1.50', '0.00', '0.00', '5.39', '-0.01', 'Cash', NULL, '27', '1519952075', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17050, '116524', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 11:41:49', 'Paid', NULL, '35.00', '34.65', '34.65', NULL, '35.00', '0.35', '0.00', '0.00', '3.85', '0.00', 'Cash', NULL, '27', '1519952075', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17051, '116523', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 11:39:56', 'Paid', NULL, '27.00', '29.70', '29.70', NULL, '50.00', '20.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17052, '116525', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 12:01:49', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17053, '116526', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 12:13:44', 'Paid', NULL, '23.00', '22.75', '22.75', NULL, '50.00', '27.25', '0.00', '0.00', '2.53', '-0.02', 'Cash', NULL, '27', '1519952075', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17054, '116529', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 13:27:19', 'Paid', NULL, '63.00', '69.30', '69.30', NULL, '100.00', '30.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17055, '116528', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 13:26:40', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '50.00', '7.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17056, '116531', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 13:34:51', 'Paid', NULL, '100.00', '110.00', '110.00', NULL, '110.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17043, '116516', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-03-02 09:41:49', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '50.00', '21.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1519952075', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17104, '116611', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 17:07:50', 'Paid', NULL, '44.00', '48.40', '48.40', NULL, '50.00', '1.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17105, '116608', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 16:32:24', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '50.30', '3.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17103, '116602', 'T13', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 15:21:39', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.50', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17102, '116601', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 15:02:01', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '22.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17101, '116603', 'T12', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 15:34:35', 'Paid', NULL, '99.00', '108.90', '108.90', NULL, '200.00', '91.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17100, '116600', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 14:49:38', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '50.00', '14.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17099, '116598', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 14:13:22', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17098, '116593', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 13:11:30', 'Paid', NULL, '51.00', '56.10', '56.10', NULL, '60.00', '3.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17096, '116591', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 12:39:18', 'Paid', NULL, '12.00', '12.00', '12.00', NULL, '12.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(17097, '116596', 'T11A', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 13:31:02', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '70.00', '4.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17095, '116590', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 12:34:32', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '8.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17092, '116592', 'T15', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 12:51:09', 'Paid', NULL, '38.00', '41.80', '41.80', NULL, '100.00', '58.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17093, '116595', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 13:30:03', 'Paid', NULL, '26.00', '28.60', '28.60', NULL, '30.60', '2.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17094, '116597', 'T11', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 14:12:36', 'Paid', NULL, '75.90', '83.50', '83.50', NULL, '100.00', '16.50', '0.00', '0.00', NULL, '0.01', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17089, '116599', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 14:37:16', 'Paid', NULL, '60.00', '66.00', '66.00', NULL, '100.00', '34.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17088, '116588', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 12:19:37', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '100.00', '25.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17090, '116589', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 12:31:39', 'Paid', NULL, '43.00', '47.30', '47.30', NULL, '509.00', '461.70', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17091, '116594', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 13:12:19', 'Paid', NULL, '110.00', '121.00', '121.00', NULL, '151.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17083, '116585', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 11:55:16', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '74.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17084, '116586', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 12:07:24', 'Paid', NULL, '56.00', '61.60', '61.60', NULL, '70.00', '8.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17082, '116587', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 12:12:12', 'Paid', NULL, '59.00', '64.90', '64.90', NULL, '70.00', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17077, '116580', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 10:39:03', 'Paid', NULL, '80.00', '88.00', '88.00', NULL, '100.00', '12.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17078, '116582', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 10:55:07', 'Paid', NULL, '48.00', '52.80', '52.80', NULL, '70.00', '17.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17079, '116581', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 10:43:34', 'Paid', NULL, '13.00', '14.30', '14.30', NULL, '14.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17080, '116583', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 11:08:33', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17081, '116584', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 11:26:54', 'Paid', NULL, '23.00', '22.75', '22.75', NULL, '25.00', '2.25', '0.00', '0.00', '2.53', '-0.02', 'Cash', NULL, '27', '1520038141', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17076, '116579', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-03-03 10:18:50', 'Paid', NULL, '40.00', '44.00', '44.00', NULL, '100.00', '56.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520038141', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17187, '116710', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 10:15:16', 'Paid', NULL, '62.00', '68.20', '68.20', NULL, '70.00', '1.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520385034', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17188, '116711', 'T10', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 10:18:30', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '8.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520385034', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17189, '116713', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 11:05:29', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '100.10', '55.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520385034', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17190, '116712', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 10:26:45', 'Paid', NULL, '23.00', '25.30', '25.30', NULL, '25.30', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520385034', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17191, '116715', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 12:09:57', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '100.80', '37.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520385034', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17192, '116727', 'T10(S)', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 15:01:21', 'Paid', NULL, '67.00', '73.70', '73.70', NULL, '100.70', '27.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520385034', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17193, '116714', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 11:42:24', 'Paid', NULL, '13.50', '14.85', '14.85', NULL, '100.00', '85.15', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520385034', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17194, '116723', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 13:52:34', 'Paid', NULL, '26.00', '25.75', '25.75', NULL, '50.00', '24.25', '0.00', '0.00', '2.86', '0.01', 'Cash', NULL, '27', '1520385034', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17195, '116717', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 12:59:11', 'Paid', NULL, '76.00', '83.60', '83.60', NULL, '100.00', '16.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520385034', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17196, '116719', 'T7', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 13:02:50', 'Paid', NULL, '64.00', '52.80', '52.80', NULL, '52.80', '0.00', '0.00', '0.00', '17.60', '0.00', 'Cash', NULL, '27', '1520385034', 'p', '25', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17197, '116718', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 13:02:00', 'Paid', NULL, '65.00', '71.50', '71.50', NULL, '71.50', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520385034', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17198, '116720', 'T2', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 13:03:38', 'Paid', NULL, '24.00', '26.40', '26.40', NULL, '50.00', '23.60', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520385034', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17199, '116722', 'T3', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 13:11:10', 'Paid', NULL, '41.00', '45.10', '45.10', NULL, '50.20', '5.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520385034', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17200, '116716', 'T8', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 12:48:57', 'Paid', NULL, '8.00', '8.80', '8.80', NULL, '10.00', '1.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520385034', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17201, '116721', '12', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 13:08:54', 'Paid', NULL, '52.00', '57.20', '57.20', NULL, '60.00', '2.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520385034', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17202, '116731', 'T14', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 15:37:50', 'Paid', NULL, '18.00', '19.80', '19.80', NULL, '19.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520385034', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17203, '116724', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 13:59:52', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '75.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520385034', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17209, '116728', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 15:19:06', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '50.00', '31.30', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520385034', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(17211, '116732', 'IS', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 15:53:26', 'Paid', NULL, '45.90', '41.30', '41.30', NULL, '50.00', '8.70', '0.00', '0.00', '4.59', '-0.01', 'Cash', NULL, '27', '1520385034', 'p', '10', NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, '0'),
(17206, '116725', 'T1', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 14:37:13', 'Paid', NULL, '14.00', '15.40', '15.40', NULL, '20.40', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520385034', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17207, '116726', 'T10(S)', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 14:43:36', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '23.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520385034', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(17208, '116730', 'T4', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 15:35:44', 'Paid', NULL, '70.00', '77.00', '77.00', NULL, '77.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520385034', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17210, '116729', 'T6(S)', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 15:19:33', 'Paid', NULL, '17.00', '18.70', '18.70', NULL, '18.70', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520385034', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(17212, '116733', 'T6', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 16:30:03', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '20.00', '6.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520385034', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17213, '116584', 'T5', 10003, 'admin', NULL, NULL, 'history', '2018-03-07 17:35:00', 'Paid', NULL, '11.00', '12.10', '12.10', NULL, '12.10', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', '1520385034', NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17235, '116605', 'T2', 10008, 'lois', NULL, NULL, 'history', '2018-03-08 15:38:56', 'Paid', NULL, '32.00', '35.20', '35.20', NULL, '40.20', '5.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17234, '116602', 'T6', 10008, 'lois', NULL, NULL, 'history', '2018-03-08 15:29:47', 'Paid', NULL, '72.00', '79.20', '79.20', NULL, '100.20', '21.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17233, '116604', 'T14', 10008, 'lois', NULL, NULL, 'history', '2018-03-08 15:37:07', 'Paid', NULL, '61.00', '67.10', '67.10', NULL, '68.00', '0.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17232, '116601', 'T15', 10008, 'lois', NULL, NULL, 'history', '2018-03-08 15:04:40', 'Paid', NULL, '35.00', '38.50', '38.50', NULL, '50.00', '11.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17231, '116599', 'T7', 10008, 'lois', NULL, NULL, 'history', '2018-03-08 14:55:07', 'Paid', NULL, '21.00', '23.10', '23.10', NULL, '53.10', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17230, '116600', 'T12', 10008, 'lois', NULL, NULL, 'history', '2018-03-08 14:59:31', 'Paid', NULL, '20.00', '22.00', '22.00', NULL, '52.00', '30.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17229, '116606', 'T4', 10008, 'lois', NULL, NULL, 'history', '2018-03-08 15:52:58', 'Paid', NULL, '25.00', '27.50', '27.50', NULL, '50.00', '22.50', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17228, '116595', 'T2', 10008, 'lois', NULL, NULL, 'history', '2018-03-08 14:02:52', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '31.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17227, '116596', 'T7', 10008, 'lois', NULL, NULL, 'history', '2018-03-08 14:24:10', 'Paid', NULL, '50.00', '55.00', '55.00', NULL, '55.00', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17226, '116603', 'T13', 10008, 'lois', NULL, NULL, 'history', '2018-03-08 15:36:11', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '51.00', '20.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17225, '116598', 'T5', 10008, 'lois', NULL, NULL, 'history', '2018-03-08 14:26:57', 'Paid', NULL, '39.00', '42.90', '42.90', NULL, '103.00', '60.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17224, '116597', 'T6', 10008, 'lois', NULL, NULL, 'history', '2018-03-08 14:26:03', 'Paid', NULL, '68.00', '74.80', '74.80', NULL, '80.00', '5.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17223, '116594', 'T14', 10008, 'lois', NULL, NULL, 'history', '2018-03-08 13:51:05', 'Paid', NULL, '22.00', '24.20', '24.20', NULL, '25.20', '1.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17222, '116593', 'T15', 10008, 'lois', NULL, NULL, 'history', '2018-03-08 13:47:04', 'Paid', NULL, '58.00', '63.80', '63.80', NULL, '70.00', '6.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17220, '116589', 'T3', 10008, 'lois', NULL, NULL, 'history', '2018-03-08 12:14:00', 'Paid', NULL, '9.00', '9.90', '9.90', NULL, '10.00', '0.10', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17221, '116592', 'T7', 10008, 'lois', NULL, NULL, 'history', '2018-03-08 13:00:19', 'Paid', NULL, '98.00', '107.80', '107.80', NULL, '108.00', '0.20', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17218, '116591', 'T6', 10008, 'lois', NULL, NULL, 'history', '2018-03-08 12:37:32', 'Paid', NULL, '12.00', '13.20', '13.20', NULL, '50.00', '36.80', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17219, '116590', 'T14', 10008, 'lois', NULL, NULL, 'history', '2018-03-08 12:14:42', 'Paid', NULL, '81.00', '89.10', '89.10', NULL, '100.00', '10.90', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17217, '116585', 'T12', 10008, 'lois', NULL, NULL, 'history', '2018-03-08 10:39:13', 'Paid', NULL, '124.00', '136.40', '136.40', NULL, '136.40', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17216, '116587', 'T1', 10008, 'lois', NULL, NULL, 'history', '2018-03-08 10:55:13', 'Paid', NULL, '28.00', '30.80', '30.80', NULL, '30.80', '0.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17215, '116586', 'T4', 10008, 'lois', NULL, NULL, 'history', '2018-03-08 10:42:53', 'Paid', NULL, '170.00', '187.00', '187.00', NULL, '200.00', '13.00', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0'),
(17214, '116588', 'T7', 10008, 'lois', NULL, NULL, 'history', '2018-03-08 11:34:33', 'Paid', NULL, '46.00', '50.60', '50.60', NULL, '60.00', '9.40', '0.00', '0.00', NULL, '0.00', 'Cash', NULL, '27', NULL, NULL, NULL, NULL, 1, NULL, 'null', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0');

-- --------------------------------------------------------

--
-- Table structure for table `fnb_sale_items`
--

CREATE TABLE `fnb_sale_items` (
  `id` int(11) NOT NULL,
  `date` datetime DEFAULT NULL,
  `ss_terminal` varchar(128) DEFAULT NULL,
  `ss_code` varchar(128) DEFAULT NULL,
  `sale_id` int(11) DEFAULT NULL,
  `si_item_id` int(11) DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_sku` varchar(128) DEFAULT NULL,
  `item_name` varchar(128) DEFAULT NULL,
  `item_option` varchar(128) DEFAULT NULL,
  `category` varchar(128) DEFAULT NULL,
  `subcategory` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `price_per_unit` float(10,2) DEFAULT NULL,
  `margin` float(10,4) DEFAULT NULL,
  `cost` float(10,4) DEFAULT NULL,
  `amount` float(10,2) DEFAULT NULL,
  `sold` int(11) DEFAULT NULL,
  `terminal` varchar(32) DEFAULT NULL,
  `printed` int(1) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `ordered_by` varchar(128) DEFAULT NULL,
  `ordered_time` datetime DEFAULT NULL,
  `serial` varchar(128) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `taxable` int(11) DEFAULT NULL,
  `tax_code` varchar(128) DEFAULT NULL,
  `instant_sale` int(1) DEFAULT NULL,
  `discount` decimal(20,1) DEFAULT NULL,
  `global_discount` decimal(20,1) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `fnb_sale_items`
--

INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(1, '2016-06-07 21:41:51', NULL, NULL, 2, 0, 180, '115', 'Free Breakfast ', '', 'Meals', 'Morning Bites ', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1465306097', 'admin', '2016-06-07 21:41:51', 'admin-1465306097-14653069113278399', 1, 0, '', NULL, NULL, NULL),
(2, '2016-06-07 21:41:51', NULL, NULL, 2, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465306097', 'admin', '2016-06-07 21:41:51', 'admin-1465306097-14653069113278399', 1, 1, 'SR', NULL, NULL, NULL),
(3, '2016-06-07 21:43:42', NULL, NULL, 2, NULL, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1465306097', 'admin', '2016-06-07 21:43:42', 'admin-1465306097-14653070226209669', 1, 1, 'SR', NULL, NULL, NULL),
(4, '2016-06-07 21:48:36', NULL, NULL, 1, NULL, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1465306097', 'admin', '2016-06-07 21:48:36', 'admin-1465306097-14653073162263990', 1, 1, 'SR', NULL, NULL, NULL),
(5, '2016-06-07 21:48:36', NULL, NULL, 1, NULL, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1465306097', 'admin', '2016-06-07 21:48:36', 'admin-1465306097-14653073162263990', 1, 1, 'SR', NULL, NULL, NULL),
(6, '2016-06-07 21:48:36', NULL, NULL, 1, NULL, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1465306097', 'admin', '2016-06-07 21:48:36', 'admin-1465306097-14653073162263990', 1, 1, 'SR', NULL, NULL, NULL),
(7, '2016-06-07 21:49:33', NULL, NULL, 3, NULL, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1465306097', 'admin', '2016-06-07 21:49:33', 'admin-1465306097-14653073734083926', 1, 1, 'SR', NULL, NULL, NULL),
(8, '2016-06-07 21:49:33', NULL, NULL, 3, NULL, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1465306097', 'admin', '2016-06-07 21:49:33', 'admin-1465306097-14653073734083926', 1, 1, 'SR', NULL, NULL, NULL),
(9, '2016-06-07 21:49:33', NULL, NULL, 3, NULL, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465306097', 'admin', '2016-06-07 21:49:33', 'admin-1465306097-14653073734083926', 1, 1, 'SR', NULL, NULL, NULL),
(10, '2016-06-09 12:45:25', NULL, NULL, 20, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 12:45:25', 'Staff-1465438933-1465447525571615', 1, 1, 'SR', NULL, NULL, NULL),
(11, '2016-06-09 12:45:25', NULL, NULL, 20, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 12:45:25', 'Staff-1465438933-1465447525571615', 1, 0, '', NULL, NULL, NULL),
(12, '2016-06-09 12:45:25', NULL, NULL, 20, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 12:45:25', 'Staff-1465438933-1465447525571615', 1, 1, 'SR', NULL, NULL, NULL),
(13, '2016-06-09 12:45:25', NULL, NULL, 20, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 12:45:25', 'Staff-1465438933-1465447525571615', 1, 1, 'SR', NULL, NULL, NULL),
(14, '2016-06-09 12:45:25', NULL, NULL, 20, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 12:45:25', 'Staff-1465438933-1465447525571615', 1, 1, 'SR', NULL, NULL, NULL),
(15, '2016-06-09 12:34:04', NULL, NULL, 19, NULL, 48, '48', 'Isotonic 100 Plus', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 12:34:04', 'Staff-1465438933-14654468438901288', 1, 1, 'SR', NULL, NULL, NULL),
(16, '2016-06-09 12:34:04', NULL, NULL, 19, NULL, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Special House Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 12:34:04', 'Staff-1465438933-14654468438901288', 1, 1, 'SR', NULL, NULL, NULL),
(17, '2016-06-09 11:53:30', NULL, NULL, 17, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 11:53:30', 'Staff-1465438933-14654444100332487', 0, 1, 'SR', NULL, NULL, NULL),
(18, '2016-06-09 11:53:30', NULL, NULL, 17, 0, 182, '117', 'Open Drinks ', 'bottled water', 'Open', 'Drinks', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 11:53:30', 'Staff-1465438933-14654444100332487', 0, 0, '', NULL, NULL, NULL),
(19, '2016-06-09 11:53:30', NULL, NULL, 17, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 11:53:30', 'Staff-1465438933-14654444100332487', 0, 1, 'SR', NULL, NULL, NULL),
(20, '2016-06-09 11:51:26', NULL, NULL, 16, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 11:51:26', 'Staff-1465438933-1465444286775522', 0, 1, 'SR', NULL, NULL, NULL),
(21, '2016-06-09 10:57:19', NULL, NULL, 13, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 10:57:19', 'Staff-1465438933-14654410390519483', 0, 1, 'SR', NULL, NULL, NULL),
(22, '2016-06-09 10:56:18', NULL, NULL, 13, 0, 15, '15', 'Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 10:56:18', 'Staff-1465438933-14654409782024216', 0, 1, 'SR', NULL, NULL, NULL),
(23, '2016-06-09 10:40:16', NULL, NULL, 12, 0, 180, '115', 'Free Breakfast ', '', 'Meals', 'Morning Bites ', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 10:40:16', 'Staff-1465438933-14654400166269490', 0, 0, '', 1, NULL, NULL),
(24, '2016-06-09 10:40:16', NULL, NULL, 12, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 10:40:16', 'Staff-1465438933-14654400166269490', 0, 1, 'SR', 1, NULL, NULL),
(25, '2016-06-09 11:51:26', NULL, NULL, 16, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 11:51:26', 'Staff-1465438933-1465444286775522', 0, 1, 'SR', NULL, NULL, NULL),
(26, '2016-06-09 10:13:21', NULL, NULL, 9, 0, 180, '115', 'Free Breakfast ', '', 'Meals', 'Morning Bites ', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 10:13:21', 'Staff-1465438359-14654384016992843', 0, 0, '', NULL, NULL, NULL),
(27, '2016-06-09 10:13:21', NULL, NULL, 9, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 10:13:21', 'Staff-1465438359-14654384016992843', 0, 1, 'SR', NULL, NULL, NULL),
(28, '2016-06-09 12:46:23', NULL, NULL, 21, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 12:46:23', 'Staff-1465438933-1465447583357790', 1, 1, 'SR', NULL, NULL, NULL),
(29, '2016-06-09 12:46:23', NULL, NULL, 21, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 12:46:23', 'Staff-1465438933-1465447583357790', 1, 1, 'SR', NULL, NULL, NULL),
(30, '2016-06-09 12:47:36', NULL, NULL, 22, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 12:47:36', 'Staff-1465438933-1465447656631491', 1, 1, 'SR', NULL, NULL, NULL),
(31, '2016-06-09 12:47:36', NULL, NULL, 22, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 12:47:36', 'Staff-1465438933-1465447656631491', 1, 0, '', NULL, NULL, NULL),
(32, '2016-06-09 12:48:22', NULL, NULL, 23, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 12:48:22', 'Staff-1465438933-14654477020461827', 1, 1, 'SR', 1, NULL, NULL),
(33, '2016-06-09 12:48:22', NULL, NULL, 23, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 12:48:22', 'Staff-1465438933-14654477020461827', 1, 1, 'SR', 1, NULL, NULL),
(34, '2016-06-09 13:02:15', NULL, NULL, 24, 0, 13, '13', 'Americano', '', 'Cold Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 13:02:15', 'Staff-1465438933-14654485354348232', 1, 0, '', 1, NULL, NULL),
(35, '2016-06-09 13:03:16', NULL, NULL, 25, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 13:03:16', 'Staff-1465438933-14654485965992420', 1, 1, 'SR', 1, NULL, NULL),
(36, '2016-06-09 13:03:16', NULL, NULL, 25, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 13:03:16', 'Staff-1465438933-14654485965992420', 1, 1, 'SR', 1, NULL, NULL),
(37, '2016-06-09 13:04:47', NULL, NULL, 26, 0, 14, '14', 'Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 13:04:47', 'Staff-1465438933-14654486877288041', 1, 1, 'SR', NULL, NULL, NULL),
(38, '2016-06-09 13:05:43', NULL, NULL, 27, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 13:05:43', 'Staff-1465438933-14654487428909334', 1, 1, 'SR', NULL, NULL, NULL),
(39, '2016-06-09 14:13:24', NULL, NULL, 32, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 14:13:24', 'Staff-1465438933-14654528043398987', 1, 1, 'SR', NULL, NULL, NULL),
(40, '2016-06-09 13:12:10', NULL, NULL, 28, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 13:12:10', 'Staff-1465438933-14654491308133551', 1, 1, 'SR', NULL, NULL, NULL),
(41, '2016-06-09 13:12:11', NULL, NULL, 28, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 13:12:11', 'Staff-1465438933-14654491308133551', 1, 1, 'SR', NULL, NULL, NULL),
(42, '2016-06-09 13:21:23', NULL, NULL, 29, NULL, 84, '84', 'Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 13:21:23', 'Staff-1465438933-14654496829365862', 1, 1, 'SR', 1, NULL, NULL),
(43, '2016-06-09 13:36:25', NULL, NULL, 30, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 13:36:25', 'Staff-1465438933-14654505853888314', 1, 1, 'SR', NULL, NULL, NULL),
(44, '2016-06-09 13:38:35', NULL, NULL, 16, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 13:38:35', 'Staff-1465438933-14654507153866956', 1, 1, 'SR', NULL, NULL, NULL),
(45, '2016-06-09 13:38:35', NULL, NULL, 16, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 13:38:35', 'Staff-1465438933-14654507153866956', 1, 1, 'SR', NULL, NULL, NULL),
(46, '2016-06-09 00:00:00', NULL, NULL, 31, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 13:12:10', 'Staff-1465438933-14654491308133551', 1, 1, 'SR', NULL, NULL, NULL),
(47, '2016-06-09 14:13:24', NULL, NULL, 32, NULL, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Special House Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 14:13:24', 'Staff-1465438933-14654528043398987', 1, 1, 'SR', NULL, NULL, NULL),
(48, '2016-06-09 14:13:24', NULL, NULL, 32, NULL, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Special House Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 14:13:24', 'Staff-1465438933-14654528043398987', 1, 1, 'SR', NULL, NULL, NULL),
(49, '2016-06-09 14:14:08', NULL, NULL, 33, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 14:14:08', 'Staff-1465438933-14654528483425551', 1, 1, 'SR', NULL, NULL, NULL),
(50, '2016-06-09 14:28:31', NULL, NULL, 32, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 14:28:31', 'Staff-1465438933-14654537113624520', 1, 0, '', NULL, NULL, NULL),
(51, '2016-06-09 14:36:36', NULL, NULL, 34, 0, 27, '27', 'Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 14:36:36', 'Staff-1465438933-14654541965704073', 1, 0, '', NULL, NULL, NULL),
(52, '2016-06-09 15:10:33', NULL, NULL, 37, NULL, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Special House Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 15:10:33', 'Staff-1465455232-14654562338598555', 1, 1, 'SR', NULL, NULL, NULL),
(53, '2016-06-09 15:19:27', NULL, NULL, 37, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 15:19:27', 'Staff-1465455232-14654567676269088', 1, 0, '', NULL, NULL, NULL),
(54, '2016-06-09 15:57:54', NULL, NULL, 40, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 15:57:54', 'Staff-1465455232-14654590741867350', 1, 1, 'SR', NULL, NULL, NULL),
(55, '2016-06-09 15:57:54', NULL, NULL, 40, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 15:57:54', 'Staff-1465455232-14654590741867350', 1, 1, 'SR', NULL, NULL, NULL),
(56, '2016-06-09 16:29:45', NULL, NULL, 41, 0, 39, '39', 'Mango Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 16:29:45', 'Staff-1465455232-14654609856531559', 1, 1, 'SR', NULL, NULL, NULL),
(57, '2016-06-09 16:29:45', NULL, NULL, 41, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465533868', 'Staff', '2016-06-09 16:29:45', 'Staff-1465455232-14654609856531559', 1, 0, '', NULL, NULL, NULL),
(58, '2016-06-10 12:49:22', NULL, NULL, 40, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465533868', 'admin', '2016-06-10 12:49:22', 'admin-1465533868-14655341626658569', 1, 1, 'SR', NULL, NULL, NULL),
(59, '2016-06-10 12:49:22', NULL, NULL, 40, NULL, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Special House Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465533868', 'admin', '2016-06-10 12:49:22', 'admin-1465533868-14655341626658569', 1, 1, 'SR', NULL, NULL, NULL),
(60, '2016-06-10 12:49:22', NULL, NULL, 40, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465533868', 'admin', '2016-06-10 12:49:22', 'admin-1465533868-14655341626658569', 1, 1, 'SR', NULL, NULL, NULL),
(61, '2016-06-10 12:49:22', NULL, NULL, 40, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465533868', 'admin', '2016-06-10 12:49:22', 'admin-1465533868-14655341626658569', 1, 1, 'SR', NULL, NULL, NULL),
(62, '2016-06-10 12:49:22', NULL, NULL, 40, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465533868', 'admin', '2016-06-10 12:49:22', 'admin-1465533868-14655341626658569', 1, 1, 'SR', NULL, NULL, NULL),
(63, '2016-06-10 12:49:22', NULL, NULL, 40, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465533868', 'admin', '2016-06-10 12:49:22', 'admin-1465533868-14655341626658569', 1, 1, 'SR', NULL, NULL, NULL),
(64, '2016-06-10 12:49:22', NULL, NULL, 40, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465533868', 'admin', '2016-06-10 12:49:22', 'admin-1465533868-14655341626658569', 1, 1, 'SR', NULL, NULL, NULL),
(65, '2016-06-10 12:49:22', NULL, NULL, 40, 0, 182, '117', 'Open Drinks ', 'shot', 'Open', 'Drinks', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1465533868', 'admin', '2016-06-10 12:49:22', 'admin-1465533868-14655341626658569', 1, 0, '', NULL, NULL, NULL),
(66, '2016-06-10 12:49:22', NULL, NULL, 40, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465533868', 'admin', '2016-06-10 12:49:22', 'admin-1465533868-14655341626658569', 1, 0, '', NULL, NULL, NULL),
(67, '2016-06-10 12:49:22', NULL, NULL, 40, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465533868', 'admin', '2016-06-10 12:49:22', 'admin-1465533868-14655341626658569', 1, 1, 'SR', NULL, NULL, NULL),
(68, '2016-06-10 12:49:22', NULL, NULL, 40, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465533868', 'admin', '2016-06-10 12:49:22', 'admin-1465533868-14655341626658569', 1, 1, 'SR', NULL, NULL, NULL),
(69, '2016-06-10 12:49:22', NULL, NULL, 40, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465533868', 'admin', '2016-06-10 12:49:22', 'admin-1465533868-14655341626658569', 1, 0, '', NULL, NULL, NULL),
(70, '2016-06-10 12:49:22', NULL, NULL, 40, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465533868', 'admin', '2016-06-10 12:49:22', 'admin-1465533868-14655341626658569', 1, 0, '', NULL, NULL, NULL),
(71, '2016-06-10 13:30:16', NULL, NULL, 63, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 13:30:16', 'Staff-1465535644-14655366164479048', 1, 1, 'SR', NULL, NULL, NULL),
(72, '2016-06-10 13:16:09', NULL, NULL, 62, NULL, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Special House Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 13:16:09', 'Staff-1465535644-14655357691402890', 1, 1, 'SR', NULL, NULL, NULL),
(73, '2016-06-10 13:16:09', NULL, NULL, 62, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 13:16:09', 'Staff-1465535644-14655357691402890', 1, 1, 'SR', NULL, NULL, NULL),
(74, '2016-06-10 13:06:00', NULL, NULL, 61, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:06:00', 'admin-1465534456-1465535160806223', 1, 1, 'SR', NULL, NULL, NULL),
(75, '2016-06-10 13:06:00', NULL, NULL, 61, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:06:00', 'admin-1465534456-1465535160806223', 1, 1, 'SR', NULL, NULL, NULL),
(76, '2016-06-10 13:06:00', NULL, NULL, 61, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:06:00', 'admin-1465534456-1465535160806223', 1, 0, '', NULL, NULL, NULL),
(77, '2016-06-10 13:05:32', NULL, NULL, 60, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:05:32', 'admin-1465534456-14655351326885774', 1, 1, 'SR', NULL, NULL, NULL),
(78, '2016-06-10 13:06:00', NULL, NULL, 61, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:06:00', 'admin-1465534456-1465535160806223', 1, 1, 'SR', NULL, NULL, NULL),
(79, '2016-06-10 13:05:32', NULL, NULL, 60, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:05:32', 'admin-1465534456-14655351326885774', 1, 1, 'SR', NULL, NULL, NULL),
(80, '2016-06-10 13:04:56', NULL, NULL, 59, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:04:56', 'admin-1465534456-14655350960838572', 1, 1, 'SR', 1, NULL, NULL),
(81, '2016-06-10 13:04:56', NULL, NULL, 59, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:04:56', 'admin-1465534456-14655350960838572', 1, 1, 'SR', 1, NULL, NULL),
(82, '2016-06-10 13:04:56', NULL, NULL, 59, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:04:56', 'admin-1465534456-14655350960838572', 1, 1, 'SR', 1, NULL, NULL),
(83, '2016-06-10 13:04:56', NULL, NULL, 59, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:04:56', 'admin-1465534456-14655350960838572', 1, 0, '', 1, NULL, NULL),
(84, '2016-06-10 13:04:33', NULL, NULL, 58, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:04:33', 'admin-1465534456-14655350737446370', 1, 1, 'SR', 1, NULL, NULL),
(85, '2016-06-10 13:04:21', NULL, NULL, 57, 0, 159, '93', 'Granola ', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:04:21', 'admin-1465534456-1465535061420337', 1, 0, '', 1, NULL, NULL),
(86, '2016-06-10 13:04:21', NULL, NULL, 57, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:04:21', 'admin-1465534456-1465535061420337', 1, 1, 'SR', 1, NULL, NULL),
(87, '2016-06-10 13:04:00', NULL, NULL, 56, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:04:00', 'admin-1465534456-14655350398781689', 1, 1, 'SR', 1, NULL, NULL),
(88, '2016-06-10 13:04:00', NULL, NULL, 56, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:04:00', 'admin-1465534456-14655350398781689', 1, 1, 'SR', 1, NULL, NULL),
(89, '2016-06-10 13:03:50', NULL, NULL, 55, 0, 86, '86', 'Pesto Pata ', 'Americano', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:03:50', 'admin-1465534456-14655350304486038', 1, 1, 'SR', 1, NULL, NULL),
(90, '2016-06-10 13:03:50', NULL, NULL, 55, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:03:50', 'admin-1465534456-14655350304486038', 1, 0, '', 1, NULL, NULL),
(91, '2016-06-10 13:03:50', NULL, NULL, 55, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:03:50', 'admin-1465534456-14655350304486038', 1, 0, '', 1, NULL, NULL),
(92, '2016-06-10 13:03:02', NULL, NULL, 54, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:03:02', 'admin-1465534456-14655349822784453', 1, 0, '', 1, NULL, NULL),
(93, '2016-06-10 13:03:02', NULL, NULL, 54, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:03:02', 'admin-1465534456-14655349822784453', 1, 0, '', 1, NULL, NULL),
(94, '2016-06-10 13:03:02', NULL, NULL, 54, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:03:02', 'admin-1465534456-14655349822784453', 1, 1, 'SR', 1, NULL, NULL),
(95, '2016-06-10 13:03:02', NULL, NULL, 54, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:03:02', 'admin-1465534456-14655349822784453', 1, 1, 'SR', 1, NULL, NULL),
(96, '2016-06-10 13:02:29', NULL, NULL, 53, 0, 180, '115', 'Free Breakfast ', '', 'Meals', 'Morning Bites ', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:02:29', 'admin-1465534456-14655349490964017', 1, 0, '', 1, NULL, NULL),
(97, '2016-06-10 13:02:29', NULL, NULL, 53, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:02:29', 'admin-1465534456-14655349490964017', 1, 1, 'SR', 1, NULL, NULL),
(98, '2016-06-10 13:02:08', NULL, NULL, 52, 0, 180, '115', 'Free Breakfast ', '', 'Meals', 'Morning Bites ', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:02:08', 'admin-1465534456-1465534928019217', 1, 0, '', 1, NULL, NULL),
(99, '2016-06-10 13:02:08', NULL, NULL, 52, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:02:08', 'admin-1465534456-1465534928019217', 1, 1, 'SR', 1, NULL, NULL),
(100, '2016-06-10 13:01:55', NULL, NULL, 51, 0, 180, '115', 'Free Breakfast ', '', 'Meals', 'Morning Bites ', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:01:55', 'admin-1465534456-14655349154979214', 1, 0, '', 1, NULL, NULL),
(101, '2016-06-10 13:01:55', NULL, NULL, 51, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:01:55', 'admin-1465534456-14655349154979214', 1, 0, '', 1, NULL, NULL),
(102, '2016-06-10 13:01:55', NULL, NULL, 51, 0, 180, '115', 'Free Breakfast ', '', 'Meals', 'Morning Bites ', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:01:55', 'admin-1465534456-14655349154979214', 1, 0, '', 1, NULL, NULL),
(103, '2016-06-10 13:01:55', NULL, NULL, 51, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:01:55', 'admin-1465534456-14655349154979214', 1, 1, 'SR', 1, NULL, NULL),
(104, '2016-06-10 13:01:29', NULL, NULL, 50, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:01:29', 'admin-1465534456-1465534889375842', 1, 0, '', 1, NULL, NULL),
(105, '2016-06-10 13:01:29', NULL, NULL, 50, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:01:29', 'admin-1465534456-1465534889375842', 1, 0, '', 1, NULL, NULL),
(106, '2016-06-10 13:01:29', NULL, NULL, 50, 0, 182, '117', 'Open Drinks ', '', 'Open', 'Drinks', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:01:29', 'admin-1465534456-1465534889375842', 1, 0, '', 1, NULL, NULL),
(107, '2016-06-10 13:01:55', NULL, NULL, 51, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:01:55', 'admin-1465534456-14655349154979214', 1, 1, 'SR', 1, NULL, NULL),
(108, '2016-06-10 13:01:29', NULL, NULL, 50, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:01:29', 'admin-1465534456-1465534889375842', 1, 1, 'SR', 1, NULL, NULL),
(109, '2016-06-10 13:00:12', NULL, NULL, 49, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:00:12', 'admin-1465534456-14655348123583782', 1, 1, 'SR', 1, NULL, NULL),
(110, '2016-06-10 13:01:29', NULL, NULL, 50, 0, 180, '115', 'Free Breakfast ', '', 'Meals', 'Morning Bites ', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:01:29', 'admin-1465534456-1465534889375842', 1, 0, '', 1, NULL, NULL),
(111, '2016-06-10 13:01:29', NULL, NULL, 50, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:01:29', 'admin-1465534456-1465534889375842', 1, 1, 'SR', 1, NULL, NULL),
(112, '2016-06-10 13:01:29', NULL, NULL, 50, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:01:29', 'admin-1465534456-1465534889375842', 1, 0, '', 1, NULL, NULL),
(113, '2016-06-10 13:00:12', NULL, NULL, 49, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:00:12', 'admin-1465534456-14655348123583782', 1, 1, 'SR', 1, NULL, NULL),
(114, '2016-06-10 13:00:03', NULL, NULL, 48, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 13:00:03', 'admin-1465534456-1465534803584995', 1, 1, 'SR', 1, NULL, NULL),
(115, '2016-06-10 12:59:54', NULL, NULL, 47, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 12:59:54', 'admin-1465534456-14655347947521797', 1, 1, 'SR', 1, NULL, NULL),
(116, '2016-06-10 12:59:38', NULL, NULL, 46, 0, 180, '115', 'Free Breakfast ', '', 'Meals', 'Morning Bites ', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 12:59:38', 'admin-1465534456-1465534778733436', 1, 0, '', 1, NULL, NULL),
(117, '2016-06-10 12:59:38', NULL, NULL, 46, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 12:59:38', 'admin-1465534456-1465534778733436', 1, 1, 'SR', 1, NULL, NULL),
(118, '2016-06-10 12:59:22', NULL, NULL, 45, 0, 180, '115', 'Free Breakfast ', '', 'Meals', 'Morning Bites ', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 12:59:22', 'admin-1465534456-14655347621694448', 1, 0, '', 1, NULL, NULL),
(119, '2016-06-10 12:59:22', NULL, NULL, 45, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 12:59:22', 'admin-1465534456-14655347621694448', 1, 1, 'SR', 1, NULL, NULL),
(120, '2016-06-10 12:59:22', NULL, NULL, 45, NULL, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Special House Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 12:59:22', 'admin-1465534456-14655347621694448', 1, 1, 'SR', 1, NULL, NULL),
(121, '2016-06-10 12:58:45', NULL, NULL, 44, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 12:58:45', 'admin-1465534456-14655347248665261', 1, 0, '', 1, NULL, NULL),
(122, '2016-06-10 12:58:45', NULL, NULL, 44, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 12:58:45', 'admin-1465534456-14655347248665261', 1, 0, '', 1, NULL, NULL),
(123, '2016-06-10 12:58:45', NULL, NULL, 44, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 12:58:45', 'admin-1465534456-14655347248665261', 1, 1, 'SR', 1, NULL, NULL),
(124, '2016-06-10 12:58:45', NULL, NULL, 44, NULL, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Special House Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 12:58:45', 'admin-1465534456-14655347248665261', 1, 1, 'SR', 1, NULL, NULL),
(125, '2016-06-10 12:58:45', NULL, NULL, 44, NULL, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Special House Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 12:58:45', 'admin-1465534456-14655347248665261', 1, 1, 'SR', 1, NULL, NULL),
(126, '2016-06-10 12:57:51', NULL, NULL, 43, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 12:57:51', 'admin-1465534456-14655346709133670', 1, 1, 'SR', 1, NULL, NULL),
(127, '2016-06-10 12:57:51', NULL, NULL, 43, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 12:57:51', 'admin-1465534456-14655346709133670', 1, 1, 'SR', 1, NULL, NULL),
(128, '2016-06-10 12:57:51', NULL, NULL, 43, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 12:57:51', 'admin-1465534456-14655346709133670', 1, 0, '', 1, NULL, NULL),
(129, '2016-06-10 12:57:51', NULL, NULL, 43, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465547217', 'admin', '2016-06-10 12:57:51', 'admin-1465534456-14655346709133670', 1, 0, '', 1, NULL, NULL),
(130, '2016-06-10 13:30:16', NULL, NULL, 63, NULL, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Special House Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 13:30:16', 'Staff-1465535644-14655366164479048', 1, 1, 'SR', NULL, NULL, NULL),
(131, '2016-06-10 13:34:36', NULL, NULL, 61, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 13:34:36', 'Staff-1465535644-14655368766491269', 1, 1, 'SR', NULL, NULL, NULL),
(132, '2016-06-10 14:10:20', NULL, NULL, 64, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 14:10:20', 'Staff-1465535644-14655390207027561', 1, 1, 'SR', NULL, NULL, NULL),
(133, '2016-06-10 14:10:20', NULL, NULL, 64, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 14:10:20', 'Staff-1465535644-14655390207027561', 1, 1, 'SR', NULL, NULL, NULL),
(134, '2016-06-10 14:16:01', NULL, NULL, 65, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 14:16:01', 'Staff-1465535644-1465539361726925', 1, 1, 'SR', NULL, NULL, NULL),
(135, '2016-06-10 15:16:13', NULL, NULL, 66, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 15:16:13', 'Staff-1465535644-14655429733642193', 1, 1, 'SR', NULL, NULL, NULL),
(136, '2016-06-10 15:16:13', NULL, NULL, 66, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 15:16:13', 'Staff-1465535644-14655429733642193', 1, 1, 'SR', NULL, NULL, NULL),
(137, '2016-06-10 15:16:13', NULL, NULL, 66, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 15:16:13', 'Staff-1465535644-14655429733642193', 1, 0, '', NULL, NULL, NULL),
(138, '2016-06-10 15:16:13', NULL, NULL, 66, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 15:16:13', 'Staff-1465535644-14655429733642193', 1, 1, 'SR', NULL, NULL, NULL),
(139, '2016-06-10 15:16:13', NULL, NULL, 66, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 15:16:13', 'Staff-1465535644-14655429733642193', 1, 0, '', NULL, NULL, NULL),
(140, '2016-06-10 15:16:13', NULL, NULL, 66, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 15:16:13', 'Staff-1465535644-14655429733642193', 1, 0, '', NULL, NULL, NULL),
(141, '2016-06-10 15:16:59', NULL, NULL, 67, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 15:16:59', 'Staff-1465535644-14655430197038620', 1, 0, '', NULL, NULL, NULL),
(142, '2016-06-10 15:16:59', NULL, NULL, 67, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 15:16:59', 'Staff-1465535644-14655430197038620', 1, 1, 'SR', NULL, NULL, NULL),
(143, '2016-06-10 15:34:26', NULL, NULL, 68, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 15:34:26', 'Staff-1465535644-14655440658204083', 1, 1, 'SR', NULL, NULL, NULL),
(144, '2016-06-10 15:34:26', NULL, NULL, 68, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 15:34:26', 'Staff-1465535644-14655440658204083', 1, 0, '', NULL, NULL, NULL),
(145, '2016-06-10 15:34:26', NULL, NULL, 68, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 15:34:26', 'Staff-1465535644-14655440658204083', 1, 1, 'SR', NULL, NULL, NULL),
(146, '2016-06-10 15:51:49', NULL, NULL, 69, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 15:51:49', 'Staff-1465535644-14655451089501692', 1, 1, 'SR', NULL, NULL, NULL),
(147, '2016-06-10 15:56:30', NULL, NULL, 70, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 15:56:30', 'Staff-1465535644-14655453904178362', 1, 1, 'SR', NULL, NULL, NULL),
(148, '2016-06-10 15:56:30', NULL, NULL, 70, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 15:56:30', 'Staff-1465535644-14655453904178362', 1, 0, '', NULL, NULL, NULL),
(149, '2016-06-10 15:56:30', NULL, NULL, 70, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 15:56:30', 'Staff-1465535644-14655453904178362', 1, 1, 'SR', NULL, NULL, NULL),
(150, '2016-06-10 15:56:50', NULL, NULL, 70, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 15:56:50', 'Staff-1465535644-1465545410062392', 1, 0, '', NULL, NULL, NULL),
(151, '2016-06-10 16:04:28', NULL, NULL, 68, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 16:04:28', 'Staff-1465535644-14655458680026715', 1, 0, '', NULL, NULL, NULL),
(152, '2016-06-10 16:05:04', NULL, NULL, 71, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 16:05:04', 'Staff-1465535644-14655459042479082', 1, 0, '', NULL, NULL, NULL),
(153, '2016-06-10 16:05:04', NULL, NULL, 71, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 16:05:04', 'Staff-1465535644-14655459042479082', 1, 0, '', NULL, NULL, NULL),
(154, '2016-06-10 16:05:41', NULL, NULL, 72, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 16:05:41', 'Staff-1465535644-14655459416277186', 1, 0, '', NULL, NULL, NULL),
(155, '2016-06-10 16:05:41', NULL, NULL, 72, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 16:05:41', 'Staff-1465535644-14655459416277186', 1, 1, 'SR', NULL, NULL, NULL),
(156, '2016-06-10 16:08:34', NULL, NULL, 73, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 16:08:34', 'Staff-1465535644-14655461145241411', 1, 0, '', NULL, NULL, NULL),
(157, '2016-06-10 17:08:47', NULL, NULL, 74, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 17:08:47', 'Staff-1465547217-14655497275179173', 1, 0, '', NULL, NULL, NULL),
(158, '2016-06-10 17:08:47', NULL, NULL, 74, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 17:08:47', 'Staff-1465547217-14655497275179173', 1, 1, 'SR', NULL, NULL, NULL),
(159, '2016-06-10 17:08:47', NULL, NULL, 74, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 17:08:47', 'Staff-1465547217-14655497275179173', 1, 1, 'SR', NULL, NULL, NULL),
(160, '2016-06-10 17:08:56', NULL, NULL, 75, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 17:08:56', 'Staff-1465547217-14655497359303068', 1, 1, 'SR', NULL, NULL, NULL),
(161, '2016-06-10 17:11:41', NULL, NULL, 76, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 2, 15.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 17:11:41', 'Staff-1465547217-14655499013499170', 1, 0, '', NULL, NULL, NULL),
(162, '2016-06-10 17:11:49', NULL, NULL, 76, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 17:11:49', 'Staff-1465547217-14655499098058533', 1, 0, '', NULL, NULL, NULL),
(163, '2016-06-10 17:12:16', NULL, NULL, 76, 0, 182, '117', 'Open Drinks ', 'Riesling', 'Open', 'Drinks', 1, 100.00, 100.0000, 0.0000, 100.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 17:12:16', 'Staff-1465547217-1465549936159873', 1, 0, '', NULL, NULL, NULL),
(164, '2016-06-10 17:22:03', NULL, NULL, 76, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 17:22:03', 'Staff-1465547217-1465550523130447', 1, 0, '', NULL, NULL, NULL),
(165, '2016-06-10 17:25:07', NULL, NULL, 77, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 17:25:07', 'Staff-1465547217-14655507071922233', 1, 1, 'SR', NULL, NULL, NULL),
(166, '2016-06-10 17:25:07', NULL, NULL, 77, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 17:25:07', 'Staff-1465547217-14655507071922233', 1, 1, 'SR', NULL, NULL, NULL),
(167, '2016-06-10 17:58:26', NULL, NULL, 78, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 17:58:26', 'Staff-1465547217-14655527064307155', 1, 0, '', NULL, NULL, NULL),
(168, '2016-06-10 17:59:34', NULL, NULL, 79, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 17:59:34', 'Staff-1465547217-14655527746979955', 1, 0, '', NULL, NULL, NULL),
(169, '2016-06-10 17:59:34', NULL, NULL, 79, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 17:59:34', 'Staff-1465547217-14655527746979955', 1, 1, 'SR', NULL, NULL, NULL),
(170, '2016-06-10 17:59:34', NULL, NULL, 79, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 17:59:34', 'Staff-1465547217-14655527746979955', 1, 1, 'SR', NULL, NULL, NULL),
(171, '2016-06-10 18:23:29', NULL, NULL, 80, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 18:23:29', 'Staff-1465547217-14655542088942475', 1, 1, 'SR', NULL, NULL, NULL),
(172, '2016-06-10 18:24:10', NULL, NULL, 80, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 18:24:10', 'Staff-1465547217-14655542500965875', 1, 1, 'SR', NULL, NULL, NULL),
(173, '2016-06-10 18:24:10', NULL, NULL, 80, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 18:24:10', 'Staff-1465547217-14655542500965875', 1, 1, 'SR', NULL, NULL, NULL),
(174, '2016-06-10 18:33:29', NULL, NULL, 76, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 18:33:29', 'Staff-1465547217-14655548091936129', 1, 0, '', NULL, NULL, NULL),
(175, '2016-06-10 18:33:29', NULL, NULL, 76, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 18:33:29', 'Staff-1465547217-14655548091936129', 1, 0, '', NULL, NULL, NULL),
(176, '2016-06-10 18:36:06', NULL, NULL, 81, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 18:36:06', 'Staff-1465547217-1465554966407188', 1, 0, '', NULL, NULL, NULL),
(177, '2016-06-10 19:19:34', NULL, NULL, 82, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 19:19:34', 'Staff-1465547217-14655575743833458', 1, 1, 'SR', NULL, NULL, NULL),
(178, '2016-06-10 19:19:34', NULL, NULL, 82, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 19:19:34', 'Staff-1465547217-14655575743833458', 1, 1, 'SR', NULL, NULL, NULL),
(179, '2016-06-10 19:19:34', NULL, NULL, 82, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 19:19:34', 'Staff-1465547217-14655575743833458', 1, 0, '', NULL, NULL, NULL),
(180, '2016-06-10 19:19:34', NULL, NULL, 82, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 19:19:34', 'Staff-1465547217-14655575743833458', 1, 1, 'SR', NULL, NULL, NULL),
(181, '2016-06-10 19:32:56', NULL, NULL, 83, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 19:32:56', 'Staff-1465547217-1465558376663641', 1, 1, 'SR', NULL, NULL, NULL),
(182, '2016-06-10 19:32:56', NULL, NULL, 83, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 19:32:56', 'Staff-1465547217-1465558376663641', 1, 1, 'SR', NULL, NULL, NULL),
(183, '2016-06-10 19:33:44', NULL, NULL, 83, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 19:33:44', 'Staff-1465547217-14655584244088449', 1, 1, 'SR', NULL, NULL, NULL),
(184, '2016-06-10 19:33:44', NULL, NULL, 83, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 19:33:44', 'Staff-1465547217-14655584244088449', 1, 1, 'SR', NULL, NULL, NULL),
(185, '2016-06-10 19:54:50', NULL, NULL, 84, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 19:54:50', 'Staff-1465547217-14655596905343555', 1, 0, '', NULL, NULL, NULL),
(186, '2016-06-10 19:54:50', NULL, NULL, 84, 0, 71, '71', 'Rice Wine Ginger Pork', 'Pasta', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 19:54:50', 'Staff-1465547217-14655596905343555', 1, 1, 'SR', NULL, NULL, NULL),
(187, '2016-06-10 19:56:07', NULL, NULL, 84, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 19:56:07', 'Staff-1465547217-14655597670193284', 1, 1, 'SR', NULL, NULL, NULL),
(188, '2016-06-10 19:56:27', NULL, NULL, 84, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 19:56:27', 'Staff-1465547217-1465559787535156', 1, 1, 'SR', NULL, NULL, NULL),
(189, '2016-06-10 20:16:18', NULL, NULL, 85, 0, 70, '70', 'Pepper Pork', 'Pasta', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 20:16:18', 'Staff-1465547217-14655609778523936', 1, 1, 'SR', NULL, NULL, NULL),
(190, '2016-06-10 20:16:34', NULL, NULL, 86, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 20:16:34', 'Staff-1465547217-14655609945447285', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(191, '2016-06-10 20:17:51', NULL, NULL, 83, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 20:17:51', 'Staff-1465547217-14655610711883480', 1, 0, '', NULL, NULL, NULL),
(192, '2016-06-10 20:17:51', NULL, NULL, 83, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 20:17:51', 'Staff-1465547217-14655610711883480', 1, 1, 'SR', NULL, NULL, NULL),
(193, '2016-06-10 20:24:03', NULL, NULL, 76, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 2, 18.00, 36.0000, 0.0000, 36.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 20:24:03', 'Staff-1465547217-14655614431906185', 1, 0, '', NULL, NULL, NULL),
(194, '2016-06-10 20:24:03', NULL, NULL, 76, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 20:24:03', 'Staff-1465547217-14655614431906185', 1, 1, 'SR', NULL, NULL, NULL),
(195, '2016-06-10 20:25:51', NULL, NULL, 76, NULL, 57, '57', 'House Red Bottle', '', 'Cold Drinks', 'Wine', 1, 88.00, 88.0000, 0.0000, 88.00, 1, '27', 1, '1465547217', 'Staff', '2016-06-10 20:25:51', 'Staff-1465547217-14655615510987194', 1, 1, 'SR', NULL, NULL, NULL),
(196, '2016-06-11 21:40:47', NULL, NULL, 119, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 21:40:47', 'Staff-1465630908-14656524474476547', 1, 1, 'SR', NULL, NULL, NULL),
(197, '2016-06-11 20:15:14', NULL, NULL, 118, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 20:15:14', 'Staff-1465630908-1465647314011578', 1, 1, 'SR', NULL, NULL, NULL),
(198, '2016-06-11 20:15:14', NULL, NULL, 118, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 20:15:14', 'Staff-1465630908-1465647314011578', 1, 0, '', NULL, NULL, NULL),
(199, '2016-06-11 21:18:40', NULL, NULL, 116, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 21:18:40', 'Staff-1465630908-14656511199362798', 1, 1, 'SR', NULL, NULL, NULL),
(200, '2016-06-11 21:40:47', NULL, NULL, 119, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 21:40:47', 'Staff-1465630908-14656524474476547', 1, 1, 'SR', NULL, NULL, NULL),
(201, '2016-06-11 20:15:14', NULL, NULL, 118, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 20:15:14', 'Staff-1465630908-1465647314011578', 1, 1, 'SR', NULL, NULL, NULL),
(202, '2016-06-11 20:15:14', NULL, NULL, 118, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 20:15:14', 'Staff-1465630908-1465647314011578', 1, 1, 'SR', NULL, NULL, NULL),
(203, '2016-06-11 20:15:14', NULL, NULL, 118, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 20:15:14', 'Staff-1465630908-1465647314011578', 1, 0, '', NULL, NULL, NULL),
(204, '2016-06-11 20:13:28', NULL, NULL, 118, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 20:13:28', 'Staff-1465630908-14656472084172078', 1, 0, '', NULL, NULL, NULL),
(205, '2016-06-11 20:13:28', NULL, NULL, 118, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 20:13:28', 'Staff-1465630908-14656472084172078', 1, 1, 'SR', NULL, NULL, NULL),
(206, '2016-06-11 20:11:17', NULL, NULL, 117, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 20:11:17', 'Staff-1465630908-14656470772216492', 1, 1, 'SR', NULL, NULL, NULL),
(207, '2016-06-11 20:11:17', NULL, NULL, 117, NULL, 48, '48', 'Isotonic 100 Plus', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 20:11:17', 'Staff-1465630908-14656470772216492', 1, 1, 'SR', NULL, NULL, NULL),
(208, '2016-06-11 20:11:17', NULL, NULL, 117, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 20:11:17', 'Staff-1465630908-14656470772216492', 1, 0, '', NULL, NULL, NULL),
(209, '2016-06-11 19:41:43', NULL, NULL, 116, NULL, 57, '57', 'House Red Bottle', '', 'Cold Drinks', 'Wine', 1, 88.00, 88.0000, 0.0000, 88.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 19:41:43', 'Staff-1465630908-14656453037997828', 1, 1, 'SR', NULL, NULL, NULL),
(210, '2016-06-11 16:41:59', NULL, NULL, 115, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 16:41:59', 'Staff-1465630908-1465634519362445', 1, 1, 'SR', NULL, NULL, NULL),
(211, '2016-06-11 16:33:08', NULL, NULL, 114, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 16:33:08', 'Staff-1465630908-1465633988310672', 1, 1, 'SR', NULL, NULL, NULL),
(212, '2016-06-11 15:40:44', NULL, NULL, 111, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 15:40:44', 'Staff-1465612935-14656308440598114', 1, 0, '', NULL, NULL, NULL),
(213, '2016-06-11 16:33:08', NULL, NULL, 114, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 16:33:08', 'Staff-1465630908-1465633988310672', 1, 1, 'SR', NULL, NULL, NULL),
(214, '2016-06-11 15:40:44', NULL, NULL, 111, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 15:40:44', 'Staff-1465612935-14656308440598114', 1, 1, 'SR', NULL, NULL, NULL),
(215, '2016-06-11 15:40:44', NULL, NULL, 111, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 15:40:44', 'Staff-1465612935-14656308440598114', 1, 1, 'SR', NULL, NULL, NULL),
(216, '2016-06-11 14:36:02', NULL, NULL, 112, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 14:36:02', 'Staff-1465612935-14656269620957544', 1, 1, 'SR', NULL, NULL, NULL),
(217, '2016-06-11 15:12:30', NULL, NULL, 113, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 15:12:30', 'Staff-1465612935-14656291507559377', 1, 1, 'SR', NULL, NULL, NULL),
(218, '2016-06-11 15:40:44', NULL, NULL, 111, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 15:40:44', 'Staff-1465612935-14656308440598114', 1, 1, 'SR', NULL, NULL, NULL),
(219, '2016-06-11 14:03:52', NULL, NULL, 109, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 14:03:52', 'Staff-1465612935-14656250321988346', 1, 0, '', NULL, NULL, NULL),
(220, '2016-06-11 13:59:24', NULL, NULL, 110, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 13:59:24', 'Staff-1465612935-14656247642551887', 1, 0, '', NULL, NULL, NULL),
(221, '2016-06-11 13:59:24', NULL, NULL, 110, NULL, 65, '65', 'Pineapple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 13:59:24', 'Staff-1465612935-14656247642551887', 1, 1, 'SR', NULL, NULL, NULL),
(222, '2016-06-11 13:59:24', NULL, NULL, 110, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 13:59:24', 'Staff-1465612935-14656247642551887', 1, 1, 'SR', NULL, NULL, NULL),
(223, '2016-06-11 13:59:24', NULL, NULL, 110, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 13:59:24', 'Staff-1465612935-14656247642551887', 1, 1, 'SR', NULL, NULL, NULL),
(224, '2016-06-11 13:59:24', NULL, NULL, 110, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 13:59:24', 'Staff-1465612935-14656247642551887', 1, 1, 'SR', NULL, NULL, NULL),
(225, '2016-06-11 13:52:27', NULL, NULL, 109, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 13:52:27', 'Staff-1465612935-14656243468986833', 1, 1, 'SR', NULL, NULL, NULL),
(226, '2016-06-11 13:43:10', NULL, NULL, 108, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 13:43:10', 'Staff-1465612935-14656237900666873', 1, 0, '', NULL, NULL, NULL),
(227, '2016-06-11 13:43:10', NULL, NULL, 108, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 13:43:10', 'Staff-1465612935-14656237900666873', 1, 1, 'SR', NULL, NULL, NULL),
(228, '2016-06-11 13:43:10', NULL, NULL, 108, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 13:43:10', 'Staff-1465612935-14656237900666873', 1, 1, 'SR', NULL, NULL, NULL),
(229, '2016-06-11 13:33:53', NULL, NULL, 107, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 13:33:53', 'Staff-1465612935-14656232333519098', 1, 1, 'SR', NULL, NULL, NULL),
(230, '2016-06-11 13:33:53', NULL, NULL, 107, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 13:33:53', 'Staff-1465612935-14656232333519098', 1, 0, '', NULL, NULL, NULL),
(231, '2016-06-11 13:33:53', NULL, NULL, 107, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 13:33:53', 'Staff-1465612935-14656232333519098', 1, 1, 'SR', NULL, NULL, NULL),
(232, '2016-06-11 13:33:53', NULL, NULL, 107, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 13:33:53', 'Staff-1465612935-14656232333519098', 1, 1, 'SR', NULL, NULL, NULL),
(233, '2016-06-11 13:13:42', NULL, NULL, 101, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 13:13:42', 'Staff-1465612935-1465622022036712', 1, 0, '', NULL, NULL, NULL),
(234, '2016-06-11 13:13:42', NULL, NULL, 101, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 13:13:42', 'Staff-1465612935-1465622022036712', 1, 0, '', NULL, NULL, NULL),
(235, '2016-06-11 12:46:14', NULL, NULL, 106, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 12:46:14', 'Staff-1465612935-1465620374722156', 1, 1, 'SR', NULL, NULL, NULL),
(236, '2016-06-11 12:42:58', NULL, NULL, 105, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 12:42:58', 'Staff-1465612935-14656201781868739', 1, 1, 'SR', NULL, NULL, NULL),
(237, '2016-06-11 12:39:55', NULL, NULL, 104, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 12:39:55', 'Staff-1465612935-14656199954625181', 1, 1, 'SR', NULL, NULL, NULL),
(238, '2016-06-11 12:39:55', NULL, NULL, 104, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 12:39:55', 'Staff-1465612935-14656199954625181', 1, 1, 'SR', NULL, NULL, NULL),
(239, '2016-06-11 12:35:15', NULL, NULL, 103, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 12:35:15', 'Staff-1465612935-14656197152971339', 1, 1, 'SR', NULL, NULL, NULL),
(240, '2016-06-11 12:35:15', NULL, NULL, 103, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 12:35:15', 'Staff-1465612935-14656197152971339', 1, 1, 'SR', NULL, NULL, NULL),
(241, '2016-06-11 12:20:36', NULL, NULL, 96, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 12:20:36', 'Staff-1465612935-14656188362114848', 1, 1, 'SR', NULL, NULL, NULL),
(242, '2016-06-11 12:14:03', NULL, NULL, 102, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 12:14:03', 'Staff-1465612935-14656184433086314', 1, 0, '', NULL, NULL, NULL),
(243, '2016-06-11 12:13:52', NULL, NULL, 102, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 12:13:52', 'Staff-1465612935-14656184324718380', 1, 1, 'SR', NULL, NULL, NULL),
(244, '2016-06-11 12:13:52', NULL, NULL, 102, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 12:13:52', 'Staff-1465612935-14656184324718380', 1, 1, 'SR', NULL, NULL, NULL),
(245, '2016-06-11 12:12:10', NULL, NULL, 101, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 12:12:10', 'Staff-1465612935-14656183302984443', 1, 1, 'SR', NULL, NULL, NULL),
(246, '2016-06-11 12:12:10', NULL, NULL, 101, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 12:12:10', 'Staff-1465612935-14656183302984443', 1, 1, 'SR', NULL, NULL, NULL),
(247, '2016-06-11 12:12:10', NULL, NULL, 101, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 12:12:10', 'Staff-1465612935-14656183302984443', 1, 1, 'SR', NULL, NULL, NULL),
(248, '2016-06-11 12:12:10', NULL, NULL, 101, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 12:12:10', 'Staff-1465612935-14656183302984443', 1, 1, 'SR', NULL, NULL, NULL),
(249, '2016-06-11 12:12:10', NULL, NULL, 101, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 12:12:10', 'Staff-1465612935-14656183302984443', 1, 1, 'SR', NULL, NULL, NULL),
(250, '2016-06-11 12:12:10', NULL, NULL, 101, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 12:12:10', 'Staff-1465612935-14656183302984443', 1, 0, '', NULL, NULL, NULL),
(251, '2016-06-11 12:12:10', NULL, NULL, 101, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 12:12:10', 'Staff-1465612935-14656183302984443', 1, 1, 'SR', NULL, NULL, NULL),
(252, '2016-06-11 12:03:42', NULL, NULL, 99, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 12:03:42', 'Staff-1465612935-14656178227726411', 1, 1, 'SR', NULL, NULL, NULL),
(253, '2016-06-11 11:22:14', NULL, NULL, 99, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 11:22:14', 'Staff-1465612935-14656153341202479', 1, 0, '', NULL, NULL, NULL),
(254, '2016-06-11 11:20:55', NULL, NULL, 100, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 11:20:55', 'Staff-1465612935-14656152557133797', 1, 1, 'SR', NULL, NULL, NULL),
(255, '2016-06-11 10:55:49', NULL, NULL, 98, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 10:55:49', 'Staff-1465612935-14656137495828837', 1, 0, '', NULL, NULL, NULL),
(256, '2016-06-11 10:55:49', NULL, NULL, 98, 0, 159, '93', 'Granola ', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 10:55:49', 'Staff-1465612935-14656137495828837', 1, 0, '', NULL, NULL, NULL),
(257, '2016-06-11 10:55:49', NULL, NULL, 98, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 10:55:49', 'Staff-1465612935-14656137495828837', 1, 1, 'SR', NULL, NULL, NULL),
(258, '2016-06-11 10:55:49', NULL, NULL, 98, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 10:55:49', 'Staff-1465612935-14656137495828837', 1, 1, 'SR', NULL, NULL, NULL),
(259, '2016-06-11 10:50:14', NULL, NULL, 97, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 10:50:14', 'Staff-1465612935-14656134145163692', 1, 1, 'SR', NULL, NULL, NULL),
(260, '2016-06-11 10:42:48', NULL, NULL, 96, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 10:42:48', 'Staff-1465612935-14656129683348184', 1, 1, 'SR', NULL, NULL, NULL),
(261, '2016-06-11 10:42:48', NULL, NULL, 96, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 10:42:48', 'Staff-1465612935-14656129683348184', 1, 0, '', NULL, NULL, NULL),
(262, '2016-06-11 10:35:50', NULL, NULL, 95, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 10:35:50', 'Staff-1465604650-14656125504338937', 1, 0, '', NULL, NULL, NULL),
(263, '2016-06-11 10:19:42', NULL, NULL, 94, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 10:19:42', 'Staff-1465604650-14656115825112518', 1, 1, 'SR', NULL, NULL, NULL),
(264, '2016-06-11 10:19:42', NULL, NULL, 94, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 10:19:42', 'Staff-1465604650-14656115825112518', 1, 1, 'SR', NULL, NULL, NULL),
(265, '2016-06-11 10:19:42', NULL, NULL, 94, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 10:19:42', 'Staff-1465604650-14656115825112518', 1, 0, '', NULL, NULL, NULL),
(266, '2016-06-11 10:19:42', NULL, NULL, 94, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 10:19:42', 'Staff-1465604650-14656115825112518', 1, 0, '', NULL, NULL, NULL),
(267, '2016-06-11 10:11:59', NULL, NULL, 93, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 10:11:59', 'Staff-1465604650-14656111189195523', 1, 0, '', NULL, NULL, NULL),
(268, '2016-06-11 10:11:19', NULL, NULL, 92, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 10:11:19', 'Staff-1465604650-14656110791603446', 1, 0, '', NULL, NULL, NULL),
(269, '2016-06-11 10:11:19', NULL, NULL, 92, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 10:11:19', 'Staff-1465604650-14656110791603446', 1, 1, 'SR', NULL, NULL, NULL),
(270, '2016-06-11 09:55:05', NULL, NULL, 90, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 09:55:05', 'Staff-1465604650-14656101051833939', 1, 1, 'SR', NULL, NULL, NULL),
(271, '2016-06-11 09:55:05', NULL, NULL, 90, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 09:55:05', 'Staff-1465604650-14656101051833939', 1, 1, 'SR', NULL, NULL, NULL),
(272, '2016-06-11 09:34:47', NULL, NULL, 88, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 09:34:47', 'Staff-1465604650-14656088873621014', 1, 0, '', NULL, NULL, NULL),
(273, '2016-06-11 09:34:47', NULL, NULL, 88, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 09:34:47', 'Staff-1465604650-14656088873621014', 1, 1, 'SR', NULL, NULL, NULL),
(274, '2016-06-11 09:30:07', NULL, NULL, 89, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 09:30:07', 'Staff-1465604650-14656086076193592', 1, 0, '', NULL, NULL, NULL),
(275, '2016-06-11 09:30:07', NULL, NULL, 89, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 09:30:07', 'Staff-1465604650-14656086076193592', 1, 1, 'SR', NULL, NULL, NULL),
(276, '2016-06-11 10:04:50', NULL, NULL, 91, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 10:04:50', 'Staff-1465604650-14656106900655137', 1, 1, 'SR', NULL, NULL, NULL),
(277, '2016-06-11 09:30:07', NULL, NULL, 89, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 09:30:07', 'Staff-1465604650-14656086076193592', 1, 1, 'SR', NULL, NULL, NULL),
(278, '2016-06-11 10:11:59', NULL, NULL, 93, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 10:11:59', 'Staff-1465604650-14656111189195523', 1, 1, 'SR', NULL, NULL, NULL),
(279, '2016-06-11 09:34:47', NULL, NULL, 88, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 09:34:47', 'Staff-1465604650-14656088873621014', 1, 1, 'SR', NULL, NULL, NULL),
(280, '2016-06-11 10:42:48', NULL, NULL, 96, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 10:42:48', 'Staff-1465612935-14656129683348184', 1, 1, 'SR', NULL, NULL, NULL),
(281, '2016-06-11 10:42:48', NULL, NULL, 96, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 10:42:48', 'Staff-1465612935-14656129683348184', 1, 0, '', NULL, NULL, NULL),
(282, '2016-06-11 09:30:07', NULL, NULL, 89, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465630908', 'Staff', '2016-06-11 09:30:07', 'Staff-1465604650-14656086076193592', 1, 1, 'SR', NULL, NULL, NULL),
(283, '2016-06-12 19:37:28', NULL, NULL, 162, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465729329', 'admin', '2016-06-12 19:37:28', 'admin-1465729329-1465731448113589', 1, 1, 'SR', NULL, NULL, NULL),
(284, '2016-06-12 19:37:28', NULL, NULL, 162, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465729329', 'admin', '2016-06-12 19:37:28', 'admin-1465729329-1465731448113589', 1, 1, 'SR', NULL, NULL, NULL),
(285, '2016-06-12 19:52:00', NULL, NULL, 163, 0, 181, '116', 'Open Food ', 'party lorong', 'Open', 'Food', 1, 472.00, 472.0000, 0.0000, 472.00, 1, '27', 1, '1465729329', 'admin', '2016-06-12 19:52:00', 'admin-1465729329-14657323208137097', 1, 0, '', NULL, NULL, NULL),
(286, '2016-06-12 19:02:47', NULL, NULL, 162, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465729329', 'admin', '2016-06-12 19:02:47', 'admin-1465729329-14657293677622386', 1, 0, '', NULL, NULL, NULL),
(287, '2016-06-12 19:02:47', NULL, NULL, 162, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465729329', 'admin', '2016-06-12 19:02:47', 'admin-1465729329-14657293677622386', 1, 1, 'SR', NULL, NULL, NULL),
(288, '2016-06-12 18:58:29', NULL, NULL, 162, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 18:58:29', 'Staff-1465705436-14657291092692252', 1, 1, 'SR', NULL, NULL, NULL),
(289, '2016-06-12 18:58:29', NULL, NULL, 162, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 18:58:29', 'Staff-1465705436-14657291092692252', 1, 1, 'SR', NULL, NULL, NULL),
(290, '2016-06-12 18:58:29', NULL, NULL, 162, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 18:58:29', 'Staff-1465705436-14657291092692252', 1, 1, 'SR', NULL, NULL, NULL),
(291, '2016-06-12 18:58:29', NULL, NULL, 162, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 18:58:29', 'Staff-1465705436-14657291092692252', 1, 1, 'SR', NULL, NULL, NULL),
(292, '2016-06-12 18:58:29', NULL, NULL, 162, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 18:58:29', 'Staff-1465705436-14657291092692252', 1, 1, 'SR', NULL, NULL, NULL),
(293, '2016-06-12 18:58:29', NULL, NULL, 162, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 18:58:29', 'Staff-1465705436-14657291092692252', 1, 0, '', NULL, NULL, NULL),
(294, '2016-06-12 18:41:57', NULL, NULL, 161, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 18:41:57', 'Staff-1465705436-14657281178125087', 1, 1, 'SR', NULL, NULL, NULL),
(295, '2016-06-12 18:41:57', NULL, NULL, 161, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 18:41:57', 'Staff-1465705436-14657281178125087', 1, 1, 'SR', NULL, NULL, NULL),
(296, '2016-06-12 18:58:29', NULL, NULL, 162, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 18:58:29', 'Staff-1465705436-14657291092692252', 1, 0, '', NULL, NULL, NULL),
(297, '2016-06-12 18:41:57', NULL, NULL, 161, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 18:41:57', 'Staff-1465705436-14657281178125087', 1, 0, '', NULL, NULL, NULL),
(298, '2016-06-12 00:00:00', NULL, NULL, 156, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 16:35:50', 'Staff-1465705436-14657205500683069', 1, 1, 'SR', NULL, NULL, NULL),
(299, '2016-06-12 00:00:00', NULL, NULL, 156, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 16:36:11', 'Staff-1465705436-14657205716007564', 1, 0, '', NULL, NULL, NULL),
(300, '2016-06-12 16:37:15', NULL, NULL, 155, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 16:37:15', 'Staff-1465705436-14657206350547264', 1, 1, 'SR', NULL, NULL, NULL),
(301, '2016-06-12 16:37:49', NULL, NULL, 157, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 16:37:49', 'Staff-1465705436-14657206688928515', 1, 1, 'SR', NULL, NULL, NULL),
(302, '2016-06-12 16:56:38', NULL, NULL, 158, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 16:56:38', 'Staff-1465705436-14657217987513329', 1, 0, '', NULL, NULL, NULL),
(303, '2016-06-12 17:05:43', NULL, NULL, 159, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 17:05:43', 'Staff-1465705436-1465722343052948', 1, 1, 'SR', 1, NULL, NULL),
(304, '2016-06-12 16:35:50', NULL, NULL, 155, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 20.0000, 0.0000, 10.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 16:35:50', 'Staff-1465705436-14657205500683069', 1, 1, 'SR', NULL, NULL, NULL),
(305, '2016-06-12 15:57:25', NULL, NULL, 147, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 15:57:25', 'Staff-1465705436-14657182454463870', 1, 1, 'SR', NULL, NULL, NULL),
(306, '2016-06-12 16:15:57', NULL, NULL, 154, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 16:15:57', 'Staff-1465705436-146571935700363', 1, 1, 'SR', NULL, NULL, NULL),
(307, '2016-06-12 15:54:27', NULL, NULL, 153, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 15:54:27', 'Staff-1465705436-14657180674299874', 1, 1, 'SR', NULL, NULL, NULL),
(308, '2016-06-12 15:09:15', NULL, NULL, 151, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 15:09:15', 'Staff-1465705436-14657153551118418', 1, 0, '', 1, NULL, NULL),
(309, '2016-06-12 15:54:01', NULL, NULL, 152, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 15:54:01', 'Staff-1465705436-14657180410402279', 1, 1, 'SR', NULL, NULL, NULL),
(310, '2016-06-12 15:54:27', NULL, NULL, 153, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 15:54:27', 'Staff-1465705436-14657180674299874', 1, 1, 'SR', NULL, NULL, NULL),
(311, '2016-06-12 14:25:56', NULL, NULL, 147, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 14:25:56', 'Staff-1465705436-1465712755902325', 1, 1, 'SR', NULL, NULL, NULL),
(312, '2016-06-12 14:17:25', NULL, NULL, 150, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 14:17:25', 'Staff-1465705436-14657122451143424', 1, 1, 'SR', 1, NULL, NULL),
(313, '2016-06-12 14:11:18', NULL, NULL, 147, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 14:11:18', 'Staff-1465705436-14657118785657627', 1, 1, 'SR', NULL, NULL, NULL),
(314, '2016-06-12 14:11:28', NULL, NULL, 149, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 14:11:28', 'Staff-1465705436-1465711887988295', 1, 1, 'SR', NULL, NULL, NULL),
(315, '2016-06-12 13:51:07', NULL, NULL, 138, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 13:51:07', 'Staff-1465705436-1465710667392801', 1, 1, 'SR', NULL, NULL, NULL),
(316, '2016-06-12 13:51:38', NULL, NULL, 147, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 13:51:38', 'Staff-1465705436-14657106980243478', 1, 1, 'SR', NULL, NULL, NULL),
(317, '2016-06-12 13:54:49', NULL, NULL, 148, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 13:54:49', 'Staff-1465705436-14657108895667396', 1, 0, '', NULL, NULL, NULL),
(318, '2016-06-12 13:32:57', NULL, NULL, 147, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 13:32:57', 'Staff-1465705436-1465709576991277', 1, 1, 'SR', NULL, NULL, NULL),
(319, '2016-06-12 13:49:11', NULL, NULL, 138, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 13:49:11', 'Staff-1465705436-14657105508099256', 1, 1, 'SR', NULL, NULL, NULL),
(320, '2016-06-12 13:49:11', NULL, NULL, 138, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 13:49:11', 'Staff-1465705436-14657105508099256', 1, 1, 'SR', NULL, NULL, NULL),
(321, '2016-06-12 13:56:58', NULL, NULL, 147, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 13:56:58', 'Staff-1465705436-14657110179357246', 1, 1, 'SR', NULL, NULL, NULL),
(322, '2016-06-12 12:56:55', NULL, NULL, 144, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:56:55', 'Staff-1465705436-1465707415614735', 1, 1, 'SR', NULL, NULL, NULL),
(323, '2016-06-12 13:00:55', NULL, NULL, 145, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 13:00:55', 'Staff-1465705436-14657076552798065', 1, 0, '', NULL, NULL, NULL),
(324, '2016-06-12 13:00:55', NULL, NULL, 145, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 13:00:55', 'Staff-1465705436-14657076552798065', 1, 1, 'SR', NULL, NULL, NULL),
(325, '2016-06-12 13:14:38', NULL, NULL, 146, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 13:14:38', 'Staff-1465705436-14657084782327638', 1, 1, 'SR', NULL, NULL, NULL),
(326, '2016-06-12 12:56:55', NULL, NULL, 144, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:56:55', 'Staff-1465705436-1465707415614735', 1, 1, 'SR', NULL, NULL, NULL),
(327, '2016-06-12 12:56:55', NULL, NULL, 144, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:56:55', 'Staff-1465705436-1465707415614735', 1, 1, 'SR', NULL, NULL, NULL),
(328, '2016-06-12 12:56:55', NULL, NULL, 144, 0, 83, '83', 'Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:56:55', 'Staff-1465705436-1465707415614735', 1, 1, 'SR', NULL, NULL, NULL),
(329, '2016-06-12 12:53:46', NULL, NULL, 143, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:53:46', 'Staff-1465705436-14657072260926933', 1, 1, 'SR', NULL, NULL, NULL),
(330, '2016-06-12 12:53:46', NULL, NULL, 143, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:53:46', 'Staff-1465705436-14657072260926933', 1, 0, '', NULL, NULL, NULL),
(331, '2016-06-12 12:53:46', NULL, NULL, 143, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:53:46', 'Staff-1465705436-14657072260926933', 1, 1, 'SR', NULL, NULL, NULL),
(332, '2016-06-12 12:53:46', NULL, NULL, 143, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:53:46', 'Staff-1465705436-14657072260926933', 1, 1, 'SR', NULL, NULL, NULL),
(333, '2016-06-12 12:38:12', NULL, NULL, 142, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:38:12', 'Staff-1465705436-14657062927311471', 1, 1, 'SR', NULL, NULL, NULL),
(334, '2016-06-12 12:38:55', NULL, NULL, 142, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:38:55', 'Staff-1465705436-14657063352591997', 1, 1, 'SR', NULL, NULL, NULL),
(335, '2016-06-12 12:38:55', NULL, NULL, 142, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:38:55', 'Staff-1465705436-14657063352591997', 1, 1, 'SR', NULL, NULL, NULL),
(336, '2016-06-12 12:38:12', NULL, NULL, 142, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:38:12', 'Staff-1465705436-14657062927311471', 1, 0, '', NULL, NULL, NULL),
(337, '2016-06-12 12:23:01', NULL, NULL, 140, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:23:01', 'Staff-1465698413-14657053813461268', 1, 1, 'SR', NULL, NULL, NULL),
(338, '2016-06-12 12:26:24', NULL, NULL, 139, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:26:24', 'Staff-1465705436-14657055845236358', 1, 0, '', NULL, NULL, NULL),
(339, '2016-06-12 12:26:24', NULL, NULL, 139, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:26:24', 'Staff-1465705436-14657055845236358', 1, 0, '', NULL, NULL, NULL),
(340, '2016-06-12 12:27:30', NULL, NULL, 141, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:27:30', 'Staff-1465705436-14657056505864181', 1, 1, 'SR', NULL, NULL, NULL),
(341, '2016-06-12 12:38:12', NULL, NULL, 142, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:38:12', 'Staff-1465705436-14657062927311471', 1, 1, 'SR', NULL, NULL, NULL),
(342, '2016-06-12 12:26:24', NULL, NULL, 139, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:26:24', 'Staff-1465705436-14657055845236358', 1, 1, 'SR', NULL, NULL, NULL),
(343, '2016-06-12 12:26:24', NULL, NULL, 139, 0, 154, '88', 'House BLT', 'egg yolk all cooked', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:26:24', 'Staff-1465705436-14657055845236358', 1, 0, '', NULL, NULL, NULL),
(344, '2016-06-12 12:23:01', NULL, NULL, 140, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:23:01', 'Staff-1465698413-14657053813461268', 1, 0, '', NULL, NULL, NULL),
(345, '2016-06-12 10:47:32', NULL, NULL, 132, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:47:32', 'Staff-1465698413-14656996520736179', 1, 1, 'SR', NULL, NULL, NULL),
(346, '2016-06-12 10:25:33', NULL, NULL, 126, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:25:33', 'Staff-1465695063-14656983336367537', 1, 1, 'SR', NULL, NULL, NULL),
(347, '2016-06-12 10:25:33', NULL, NULL, 126, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:25:33', 'Staff-1465695063-14656983336367537', 1, 1, 'SR', NULL, NULL, NULL),
(348, '2016-06-12 10:26:23', NULL, NULL, 127, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:26:23', 'Staff-1465695063-14656983833923995', 1, 0, '', NULL, NULL, NULL),
(349, '2016-06-12 10:26:23', NULL, NULL, 127, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:26:23', 'Staff-1465695063-14656983833923995', 1, 0, '', NULL, NULL, NULL),
(350, '2016-06-12 10:27:06', NULL, NULL, 127, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:27:06', 'Staff-1465698413-14656984263105252', 1, 1, 'SR', NULL, NULL, NULL),
(351, '2016-06-12 10:26:23', NULL, NULL, 127, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:26:23', 'Staff-1465695063-14656983833923995', 1, 1, 'SR', NULL, NULL, NULL),
(352, '2016-06-12 10:28:04', NULL, NULL, 128, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:28:04', 'Staff-1465698413-14656984842668865', 1, 1, 'SR', NULL, NULL, NULL),
(353, '2016-06-12 10:28:04', NULL, NULL, 128, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:28:04', 'Staff-1465698413-14656984842668865', 1, 1, 'SR', NULL, NULL, NULL),
(354, '2016-06-12 10:28:04', NULL, NULL, 128, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:28:04', 'Staff-1465698413-14656984842668865', 1, 0, '', NULL, NULL, NULL),
(355, '2016-06-12 10:29:09', NULL, NULL, 129, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:29:09', 'Staff-1465698413-14656985491086053', 1, 0, '', NULL, NULL, NULL),
(356, '2016-06-12 10:29:09', NULL, NULL, 129, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:29:09', 'Staff-1465698413-14656985491086053', 1, 1, 'SR', NULL, NULL, NULL),
(357, '2016-06-12 10:29:09', NULL, NULL, 129, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:29:09', 'Staff-1465698413-14656985491086053', 1, 1, 'SR', NULL, NULL, NULL),
(358, '2016-06-12 10:29:09', NULL, NULL, 129, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:29:09', 'Staff-1465698413-14656985491086053', 1, 0, '', NULL, NULL, NULL),
(359, '2016-06-12 10:44:20', NULL, NULL, 130, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:44:20', 'Staff-1465698413-14656994604256486', 1, 1, 'SR', NULL, NULL, NULL),
(360, '2016-06-12 10:44:20', NULL, NULL, 130, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:44:20', 'Staff-1465698413-14656994604256486', 1, 0, '', NULL, NULL, NULL),
(361, '2016-06-12 10:46:38', NULL, NULL, 131, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:46:38', 'Staff-1465698413-14656995980953496', 1, 0, '', NULL, NULL, NULL),
(362, '2016-06-12 10:46:38', NULL, NULL, 131, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:46:38', 'Staff-1465698413-14656995980953496', 1, 0, '', NULL, NULL, NULL),
(363, '2016-06-12 10:46:38', NULL, NULL, 131, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:46:38', 'Staff-1465698413-14656995980953496', 1, 0, '', NULL, NULL, NULL),
(364, '2016-06-12 10:47:32', NULL, NULL, 132, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:47:32', 'Staff-1465698413-14656996520736179', 1, 1, 'SR', NULL, NULL, NULL),
(365, '2016-06-12 11:14:28', NULL, NULL, 133, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 11:14:28', 'Staff-1465698413-14657012682883340', 1, 1, 'SR', NULL, NULL, NULL),
(366, '2016-06-12 11:18:04', NULL, NULL, 134, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 11:18:04', 'Staff-1465698413-14657014846686633', 1, 0, '', NULL, NULL, NULL),
(367, '2016-06-12 11:18:04', NULL, NULL, 134, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 11:18:04', 'Staff-1465698413-14657014846686633', 1, 1, 'SR', NULL, NULL, NULL),
(368, '2016-06-12 09:32:29', NULL, NULL, 121, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 09:32:29', 'Staff-1465695063-14656951496523857', 1, 1, 'SR', NULL, NULL, NULL),
(369, '2016-06-12 09:32:29', NULL, NULL, 121, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 09:32:29', 'Staff-1465695063-14656951496523857', 1, 1, 'SR', NULL, NULL, NULL),
(370, '2016-06-12 09:47:44', NULL, NULL, 122, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 09:47:44', 'Staff-1465695063-14656960643477913', 1, 0, '', NULL, NULL, NULL),
(371, '2016-06-12 09:47:44', NULL, NULL, 122, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 09:47:44', 'Staff-1465695063-14656960643477913', 1, 0, '', NULL, NULL, NULL),
(372, '2016-06-12 09:47:44', NULL, NULL, 122, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 09:47:44', 'Staff-1465695063-14656960643477913', 1, 1, 'SR', NULL, NULL, NULL),
(373, '2016-06-12 10:06:19', NULL, NULL, 123, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:06:19', 'Staff-1465695063-14656971788206288', 1, 0, '', NULL, NULL, NULL),
(374, '2016-06-12 10:06:19', NULL, NULL, 123, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:06:19', 'Staff-1465695063-14656971788206288', 1, 0, '', NULL, NULL, NULL),
(375, '2016-06-12 10:06:19', NULL, NULL, 123, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:06:19', 'Staff-1465695063-14656971788206288', 1, 1, 'SR', NULL, NULL, NULL),
(376, '2016-06-12 10:06:19', NULL, NULL, 123, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:06:19', 'Staff-1465695063-14656971788206288', 1, 1, 'SR', NULL, NULL, NULL),
(377, '2016-06-12 10:19:28', NULL, NULL, 124, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:19:28', 'Staff-1465695063-14656979680173420', 1, 1, 'SR', NULL, NULL, NULL),
(378, '2016-06-12 10:24:04', NULL, NULL, 125, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:24:04', 'Staff-1465695063-14656982444494165', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(379, '2016-06-12 10:24:04', NULL, NULL, 125, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:24:04', 'Staff-1465695063-14656982444494165', 1, 0, '', NULL, NULL, NULL),
(380, '2016-06-12 10:25:33', NULL, NULL, 126, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:25:33', 'Staff-1465695063-14656983336367537', 1, 0, '', NULL, NULL, NULL),
(381, '2016-06-12 10:25:33', NULL, NULL, 126, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 10:25:33', 'Staff-1465695063-14656983336367537', 1, 0, '', NULL, NULL, NULL),
(382, '2016-06-12 12:23:01', NULL, NULL, 140, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:23:01', 'Staff-1465698413-14657053813461268', 1, 1, 'SR', NULL, NULL, NULL),
(383, '2016-06-12 11:18:04', NULL, NULL, 134, 0, 159, '93', 'Granola ', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 11:18:04', 'Staff-1465698413-14657014846686633', 1, 0, '', NULL, NULL, NULL),
(384, '2016-06-12 11:18:04', NULL, NULL, 134, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 11:18:04', 'Staff-1465698413-14657014846686633', 1, 1, 'SR', NULL, NULL, NULL),
(385, '2016-06-12 12:02:41', NULL, NULL, 136, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:02:41', 'Staff-1465698413-14657041617239634', 1, 1, 'SR', NULL, NULL, NULL),
(386, '2016-06-12 12:02:41', NULL, NULL, 136, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:02:41', 'Staff-1465698413-14657041617239634', 1, 1, 'SR', NULL, NULL, NULL),
(387, '2016-06-12 12:13:10', NULL, NULL, 137, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:13:10', 'Staff-1465698413-14657047903326070', 1, 1, 'SR', NULL, NULL, NULL),
(388, '2016-06-12 12:14:58', NULL, NULL, 135, 0, 182, '117', 'Open Drinks ', '', 'Open', 'Drinks', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 12:14:58', 'Staff-1465698413-14657048987418492', 1, 0, '', NULL, NULL, NULL),
(389, '2016-06-12 14:11:18', NULL, NULL, 147, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 14:11:18', 'Staff-1465705436-14657118785657627', 1, 1, 'SR', NULL, NULL, NULL),
(390, '2016-06-12 11:14:28', NULL, NULL, 133, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 11:14:28', 'Staff-1465698413-14657012682883340', 1, 0, '', NULL, NULL, NULL),
(391, '2016-06-12 09:32:29', NULL, NULL, 121, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465729329', 'Staff', '2016-06-12 09:32:29', 'Staff-1465695063-14656951496523857', 1, 0, '', NULL, NULL, NULL),
(392, '2016-06-13 11:49:03', NULL, NULL, 171, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465820546', 'lois', '2016-06-13 11:49:03', 'lois-1465785916-14657897436844143', 1, 0, '', NULL, NULL, NULL),
(393, '2016-06-13 12:31:46', NULL, NULL, 172, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 12:31:46', 'admin-1465790063-14657923064447627', 1, 1, 'SR', NULL, NULL, NULL),
(394, '2016-06-13 12:40:54', NULL, NULL, 173, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 12:40:54', 'admin-1465790063-14657928541204994', 1, 0, '', NULL, NULL, NULL),
(395, '2016-06-13 14:12:29', NULL, NULL, 175, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 14:12:29', 'admin-1465790063-14657983493883017', 1, 1, 'SR', NULL, NULL, NULL),
(396, '2016-06-13 14:12:29', NULL, NULL, 175, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 14:12:29', 'admin-1465790063-14657983493883017', 1, 1, 'SR', NULL, NULL, NULL),
(397, '2016-06-13 14:32:27', NULL, NULL, 176, NULL, 26, '26', 'Tea By Cup', '', 'Hot Drinks', 'Non Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 14:32:27', 'admin-1465790063-14657995474887957', 1, 1, 'SR', NULL, NULL, NULL),
(398, '2016-06-13 14:58:08', NULL, NULL, 177, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 14:58:08', 'admin-1465790063-14658010880817253', 1, 0, '', NULL, NULL, NULL),
(399, '2016-06-13 15:01:29', NULL, NULL, 178, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 15:01:29', 'admin-1465790063-14658012889225928', 1, 1, 'SR', NULL, NULL, NULL),
(400, '2016-06-13 15:01:29', NULL, NULL, 178, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 15:01:29', 'admin-1465790063-14658012889225928', 1, 1, 'SR', NULL, NULL, NULL),
(401, '2016-06-13 16:22:46', NULL, NULL, 179, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 16:22:46', 'admin-1465790063-14658061664659380', 1, 1, 'SR', NULL, NULL, NULL),
(402, '2016-06-13 16:22:46', NULL, NULL, 179, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 16:22:46', 'admin-1465790063-14658061664659380', 1, 1, 'SR', NULL, NULL, NULL),
(403, '2016-06-13 16:22:46', NULL, NULL, 179, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 16:22:46', 'admin-1465790063-14658061664659380', 1, 1, 'SR', NULL, NULL, NULL),
(404, '2016-06-13 17:00:09', NULL, NULL, 180, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 17:00:09', 'admin-1465790063-14658084092596216', 1, 1, 'SR', NULL, NULL, NULL),
(405, '2016-06-13 17:46:19', NULL, NULL, 182, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 17:46:19', 'admin-1465790063-14658111797703543', 1, 1, 'SR', NULL, NULL, NULL),
(406, '2016-06-13 18:09:57', NULL, NULL, 183, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 18:09:57', 'admin-1465790063-14658125970683955', 1, 1, 'SR', NULL, NULL, NULL),
(407, '2016-06-13 18:09:57', NULL, NULL, 183, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 18:09:57', 'admin-1465790063-14658125970683955', 1, 1, 'SR', NULL, NULL, NULL),
(408, '2016-06-13 18:09:57', NULL, NULL, 183, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 18:09:57', 'admin-1465790063-14658125970683955', 1, 1, 'SR', NULL, NULL, NULL),
(409, '2016-06-13 18:20:50', NULL, NULL, 184, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 18:20:50', 'admin-1465790063-14658132504033329', 1, 1, 'SR', NULL, NULL, NULL),
(410, '2016-06-13 18:20:50', NULL, NULL, 184, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 18:20:50', 'admin-1465790063-14658132504033329', 1, 0, '', NULL, NULL, NULL),
(411, '2016-06-13 18:20:50', NULL, NULL, 184, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 18:20:50', 'admin-1465790063-14658132504033329', 1, 1, 'SR', NULL, NULL, NULL),
(412, '2016-06-13 18:20:50', NULL, NULL, 184, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 18:20:50', 'admin-1465790063-14658132504033329', 1, 1, 'SR', NULL, NULL, NULL),
(413, '2016-06-13 18:25:57', NULL, NULL, 185, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 18:25:57', 'admin-1465790063-14658135570841048', 1, 1, 'SR', NULL, NULL, NULL),
(414, '2016-06-13 18:36:31', NULL, NULL, 186, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 18:36:31', 'admin-1465790063-14658141914674262', 1, 1, 'SR', NULL, NULL, NULL),
(415, '2016-06-13 18:45:24', NULL, NULL, 187, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 18:45:24', 'admin-1465790063-14658147247306587', 1, 1, 'SR', NULL, NULL, NULL),
(416, '2016-06-13 18:45:24', NULL, NULL, 187, 0, 75, '75', 'Aglio Olio ', 'Chicken', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 18:45:24', 'admin-1465790063-14658147247306587', 1, 0, '', NULL, NULL, NULL),
(417, '2016-06-13 18:45:24', NULL, NULL, 187, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 18:45:24', 'admin-1465790063-14658147247306587', 1, 1, 'SR', NULL, NULL, NULL),
(418, '2016-06-13 18:48:03', NULL, NULL, 188, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 18:48:03', 'admin-1465790063-14658148829165381', 1, 1, 'SR', NULL, NULL, NULL),
(419, '2016-06-13 19:05:31', NULL, NULL, 187, 0, 182, '117', 'Open Drinks ', 'Barwang', 'Open', 'Drinks', 1, 128.00, 128.0000, 0.0000, 128.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 19:05:31', 'admin-1465790063-14658159318373750', 1, 0, '', NULL, NULL, NULL),
(420, '2016-06-13 19:07:53', NULL, NULL, 189, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 19:07:53', 'admin-1465790063-14658160737961540', 1, 0, '', NULL, NULL, NULL),
(421, '2016-06-13 19:07:53', NULL, NULL, 189, 0, 70, '70', 'Pepper Pork', 'Pasta', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 19:07:53', 'admin-1465790063-14658160737961540', 1, 1, 'SR', NULL, NULL, NULL),
(422, '2016-06-13 19:07:53', NULL, NULL, 189, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 19:07:53', 'admin-1465790063-14658160737961540', 1, 1, 'SR', NULL, NULL, NULL),
(423, '2016-06-13 19:07:53', NULL, NULL, 189, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 19:07:53', 'admin-1465790063-14658160737961540', 1, 0, '', NULL, NULL, NULL),
(424, '2016-06-13 19:23:43', NULL, NULL, 190, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 19:23:43', 'admin-1465790063-1465817023609222', 1, 1, 'SR', NULL, NULL, NULL),
(425, '2016-06-13 20:16:51', NULL, NULL, 191, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 20:16:51', 'admin-1465790063-14658202110036898', 1, 1, 'SR', NULL, NULL, NULL),
(426, '2016-06-13 20:17:16', NULL, NULL, 192, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 20:17:16', 'admin-1465790063-14658202365082580', 1, 1, 'SR', NULL, NULL, NULL),
(427, '2016-06-13 20:18:11', NULL, NULL, 190, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 20:18:11', 'admin-1465790063-14658202914354178', 1, 0, '', NULL, NULL, NULL),
(428, '2016-06-13 20:18:11', NULL, NULL, 190, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 20:18:11', 'admin-1465790063-14658202914354178', 1, 1, 'SR', NULL, NULL, NULL),
(429, '2016-06-13 20:18:11', NULL, NULL, 190, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 20:18:11', 'admin-1465790063-14658202914354178', 1, 1, 'SR', NULL, NULL, NULL),
(430, '2016-06-13 20:18:11', NULL, NULL, 190, 0, 70, '70', 'Pepper Pork', 'Pasta', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 20:18:11', 'admin-1465790063-14658202914354178', 1, 1, 'SR', NULL, NULL, NULL),
(431, '2016-06-13 20:18:11', NULL, NULL, 190, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 20:18:11', 'admin-1465790063-14658202914354178', 1, 1, 'SR', NULL, NULL, NULL),
(432, '2016-06-13 20:19:17', NULL, NULL, 193, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 20:19:17', 'admin-1465790063-14658203571163675', 1, 1, 'SR', NULL, NULL, NULL),
(433, '2016-06-13 20:39:16', NULL, NULL, 194, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465820546', 'Staff', '2016-06-13 20:39:16', 'Staff-1465820546-14658215565441532', 1, 1, 'SR', NULL, NULL, NULL),
(434, '2016-06-13 20:39:16', NULL, NULL, 194, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465820546', 'Staff', '2016-06-13 20:39:16', 'Staff-1465820546-14658215565441532', 1, 1, 'SR', NULL, NULL, NULL),
(435, '2016-06-13 11:10:11', NULL, NULL, 169, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465820546', 'lois', '2016-06-13 11:10:11', 'lois-1465785916-1465787411104755', 1, 1, 'SR', NULL, NULL, NULL),
(436, '2016-06-13 11:10:11', NULL, NULL, 169, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465820546', 'lois', '2016-06-13 11:10:11', 'lois-1465785916-1465787411104755', 1, 0, '', NULL, NULL, NULL),
(437, '2016-06-13 11:18:47', NULL, NULL, 170, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465820546', 'lois', '2016-06-13 11:18:47', 'lois-1465785916-14657879273423272', 1, 0, '', NULL, NULL, NULL),
(438, '2016-06-13 11:18:47', NULL, NULL, 170, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465820546', 'lois', '2016-06-13 11:18:47', 'lois-1465785916-14657879273423272', 1, 1, 'SR', NULL, NULL, NULL),
(439, '2016-06-13 11:49:03', NULL, NULL, 171, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465820546', 'lois', '2016-06-13 11:49:03', 'lois-1465785916-14657897436844143', 1, 0, '', NULL, NULL, NULL),
(440, '2016-06-13 11:49:03', NULL, NULL, 171, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1465820546', 'lois', '2016-06-13 11:49:03', 'lois-1465785916-14657897436844143', 1, 0, '', NULL, NULL, NULL),
(441, '2016-06-13 10:04:45', NULL, NULL, 165, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1465820546', 'Staff', '2016-06-13 10:04:45', 'Staff-1465777486-14657834851583015', 1, 1, 'SR', NULL, NULL, NULL),
(442, '2016-06-13 10:04:45', NULL, NULL, 165, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465820546', 'Staff', '2016-06-13 10:04:45', 'Staff-1465777486-14657834851583015', 1, 1, 'SR', NULL, NULL, NULL),
(443, '2016-06-13 10:04:45', NULL, NULL, 165, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465820546', 'Staff', '2016-06-13 10:04:45', 'Staff-1465777486-14657834851583015', 1, 1, 'SR', NULL, NULL, NULL),
(444, '2016-06-13 10:04:45', NULL, NULL, 165, 0, 180, '115', 'Free Breakfast ', '', 'Meals', 'Morning Bites ', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1465820546', 'Staff', '2016-06-13 10:04:45', 'Staff-1465777486-14657834851583015', 1, 0, '', NULL, NULL, NULL),
(445, '2016-06-13 10:04:45', NULL, NULL, 165, 0, 180, '115', 'Free Breakfast ', '', 'Meals', 'Morning Bites ', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1465820546', 'Staff', '2016-06-13 10:04:45', 'Staff-1465777486-14657834851583015', 1, 0, '', NULL, NULL, NULL),
(446, '2016-06-13 10:04:45', NULL, NULL, 165, 0, 180, '115', 'Free Breakfast ', '', 'Meals', 'Morning Bites ', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1465820546', 'Staff', '2016-06-13 10:04:45', 'Staff-1465777486-14657834851583015', 1, 0, '', NULL, NULL, NULL),
(447, '2016-06-13 10:12:09', NULL, NULL, 166, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465820546', 'Staff', '2016-06-13 10:12:09', 'Staff-1465777486-14657839291734445', 1, 1, 'SR', NULL, NULL, NULL),
(448, '2016-06-13 10:19:41', NULL, NULL, 165, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465820546', 'Staff', '2016-06-13 10:19:41', 'Staff-1465777486-14657843815617497', 1, 0, '', NULL, NULL, NULL),
(449, '2016-06-13 10:35:50', NULL, NULL, 167, 0, 159, '93', 'Granola ', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465820546', 'Staff', '2016-06-13 10:35:51', 'Staff-1465777486-14657853508421243', 1, 0, '', NULL, NULL, NULL),
(450, '2016-06-13 10:35:51', NULL, NULL, 167, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465820546', 'Staff', '2016-06-13 10:35:51', 'Staff-1465777486-14657853508421243', 1, 1, 'SR', NULL, NULL, NULL),
(451, '2016-06-13 10:35:51', NULL, NULL, 167, 0, 180, '115', 'Free Breakfast ', '', 'Meals', 'Morning Bites ', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1465820546', 'Staff', '2016-06-13 10:35:51', 'Staff-1465777486-14657853508421243', 1, 0, '', NULL, NULL, NULL),
(452, '2016-06-13 10:51:28', NULL, NULL, 166, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465820546', 'lois', '2016-06-13 10:51:28', 'lois-1465785916-14657862887559513', 1, 1, 'SR', NULL, NULL, NULL),
(453, '2016-06-13 20:09:06', NULL, NULL, 189, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 20:09:06', 'admin-1465790063-1465819746403304', 1, 0, '', NULL, NULL, NULL),
(454, '2016-06-13 19:23:43', NULL, NULL, 190, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 19:23:43', 'admin-1465790063-1465817023609222', 1, 1, 'SR', NULL, NULL, NULL),
(455, '2016-06-13 19:23:43', NULL, NULL, 190, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 19:23:43', 'admin-1465790063-1465817023609222', 1, 1, 'SR', NULL, NULL, NULL),
(456, '2016-06-13 19:23:43', NULL, NULL, 190, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 19:23:43', 'admin-1465790063-1465817023609222', 1, 0, '', NULL, NULL, NULL),
(457, '2016-06-13 17:04:13', NULL, NULL, 181, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 17:04:13', 'admin-1465790063-1465808653554293', 1, 1, 'SR', NULL, NULL, NULL),
(458, '2016-06-13 12:31:46', NULL, NULL, 172, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 12:31:46', 'admin-1465790063-14657923064447627', 1, 0, '', NULL, NULL, NULL),
(459, '2016-06-13 12:31:46', NULL, NULL, 172, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465820546', 'admin', '2016-06-13 12:31:46', 'admin-1465790063-14657923064447627', 1, 0, '', NULL, NULL, NULL),
(460, '2016-06-13 10:45:03', NULL, NULL, 168, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465820546', 'Staff', '2016-06-13 10:45:03', 'Staff-1465777486-14657859036531311', 1, 1, 'SR', NULL, NULL, NULL),
(461, '2016-06-14 09:48:05', NULL, NULL, 196, 0, 180, '115', 'Free Breakfast ', '', 'Meals', 'Morning Bites ', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 09:48:05', 'lois-1465865812-14658688855809337', 1, 0, '', NULL, NULL, NULL),
(462, '2016-06-14 09:48:05', NULL, NULL, 196, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 09:48:05', 'lois-1465865812-14658688855809337', 1, 1, 'SR', NULL, NULL, NULL),
(463, '2016-06-14 09:48:05', NULL, NULL, 196, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 09:48:05', 'lois-1465865812-14658688855809337', 1, 1, 'SR', NULL, NULL, NULL),
(464, '2016-06-14 10:13:13', NULL, NULL, 197, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 10:13:13', 'lois-1465865812-14658703930946776', 1, 1, 'SR', NULL, NULL, NULL),
(465, '2016-06-14 10:17:18', NULL, NULL, 198, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 10:17:18', 'lois-1465865812-14658706382418464', 1, 1, 'SR', NULL, NULL, NULL),
(466, '2016-06-14 10:17:18', NULL, NULL, 198, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 10:17:18', 'lois-1465865812-14658706382418464', 1, 1, 'SR', NULL, NULL, NULL),
(467, '2016-06-14 10:17:18', NULL, NULL, 198, 0, 180, '115', 'Free Breakfast ', '', 'Meals', 'Morning Bites ', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 10:17:18', 'lois-1465865812-14658706382418464', 1, 0, '', NULL, NULL, NULL),
(468, '2016-06-14 10:17:18', NULL, NULL, 198, 0, 180, '115', 'Free Breakfast ', '', 'Meals', 'Morning Bites ', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 10:17:18', 'lois-1465865812-14658706382418464', 1, 0, '', NULL, NULL, NULL),
(469, '2016-06-14 10:34:52', NULL, NULL, 198, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 10:34:52', 'lois-1465865812-14658716920204450', 1, 0, '', NULL, NULL, NULL),
(470, '2016-06-14 10:43:02', NULL, NULL, 199, 0, 180, '115', 'Free Breakfast ', '', 'Meals', 'Morning Bites ', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 10:43:02', 'lois-1465865812-14658721827737136', 1, 0, '', NULL, NULL, NULL),
(471, '2016-06-14 10:53:08', NULL, NULL, 199, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 10:53:08', 'lois-1465865812-14658727881008476', 1, 1, 'SR', NULL, NULL, NULL),
(472, '2016-06-14 10:55:00', NULL, NULL, 200, 0, 180, '115', 'Free Breakfast ', '', 'Meals', 'Morning Bites ', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 10:55:00', 'lois-1465865812-14658729005694371', 1, 0, '', NULL, NULL, NULL),
(473, '2016-06-14 10:55:00', NULL, NULL, 200, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 10:55:00', 'lois-1465865812-14658729005694371', 1, 0, '', NULL, NULL, NULL),
(474, '2016-06-14 10:55:00', NULL, NULL, 200, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 10:55:00', 'lois-1465865812-14658729005694371', 1, 1, 'SR', NULL, NULL, NULL),
(475, '2016-06-14 10:55:00', NULL, NULL, 200, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 10:55:00', 'lois-1465865812-14658729005694371', 1, 1, 'SR', NULL, NULL, NULL),
(476, '2016-06-14 11:14:46', NULL, NULL, 201, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 11:14:46', 'lois-1465872921-14658740859577327', 1, 1, 'SR', NULL, NULL, NULL),
(477, '2016-06-14 11:14:46', NULL, NULL, 201, 0, 159, '93', 'Granola ', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 11:14:46', 'lois-1465872921-14658740859577327', 1, 0, '', NULL, NULL, NULL),
(478, '2016-06-14 11:14:46', NULL, NULL, 201, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 11:14:46', 'lois-1465872921-14658740859577327', 1, 0, '', NULL, NULL, NULL),
(479, '2016-06-14 11:14:46', NULL, NULL, 201, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 11:14:46', 'lois-1465872921-14658740859577327', 1, 1, 'SR', NULL, NULL, NULL),
(480, '2016-06-14 11:42:06', NULL, NULL, 202, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 11:42:06', 'lois-1465872921-14658757261989772', 1, 1, 'SR', NULL, NULL, NULL),
(481, '2016-06-14 11:42:06', NULL, NULL, 202, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 11:42:06', 'lois-1465872921-14658757261989772', 1, 1, 'SR', NULL, NULL, NULL),
(482, '2016-06-14 11:42:06', NULL, NULL, 202, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 11:42:06', 'lois-1465872921-14658757261989772', 1, 0, '', NULL, NULL, NULL),
(483, '2016-06-14 12:01:30', NULL, NULL, 203, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 12:01:30', 'lois-1465872921-1465876890588356', 1, 0, '', NULL, NULL, NULL),
(484, '2016-06-14 12:01:30', NULL, NULL, 203, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 12:01:30', 'lois-1465872921-1465876890588356', 1, 1, 'SR', NULL, NULL, NULL),
(485, '2016-06-14 12:01:30', NULL, NULL, 203, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 12:01:30', 'lois-1465872921-1465876890588356', 1, 1, 'SR', NULL, NULL, NULL),
(486, '2016-06-14 12:01:30', NULL, NULL, 203, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 12:01:30', 'lois-1465872921-1465876890588356', 1, 1, 'SR', NULL, NULL, NULL),
(487, '2016-06-14 12:02:50', NULL, NULL, 203, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 12:02:50', 'lois-1465872921-1465876969907369', 1, 1, 'SR', NULL, NULL, NULL),
(488, '2016-06-14 13:06:52', NULL, NULL, 204, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 13:06:52', 'lois-1465872921-1465880812689116', 1, 1, 'SR', NULL, NULL, NULL),
(489, '2016-06-14 13:06:52', NULL, NULL, 204, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 13:06:52', 'lois-1465872921-1465880812689116', 1, 1, 'SR', NULL, NULL, NULL),
(490, '2016-06-14 13:06:52', NULL, NULL, 204, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 13:06:52', 'lois-1465872921-1465880812689116', 1, 1, 'SR', NULL, NULL, NULL),
(491, '2016-06-14 13:30:23', NULL, NULL, 205, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 13:30:23', 'lois-1465872921-14658822230024474', 1, 1, 'SR', NULL, NULL, NULL),
(492, '2016-06-14 14:07:46', NULL, NULL, 206, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 14:07:46', 'lois-1465872921-14658844661447311', 1, 1, 'SR', NULL, NULL, NULL),
(493, '2016-06-14 14:14:43', NULL, NULL, 207, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 14:14:43', 'lois-1465872921-1465884883057193', 1, 1, 'SR', NULL, NULL, NULL),
(494, '2016-06-14 14:14:43', NULL, NULL, 207, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 14:14:43', 'lois-1465872921-1465884883057193', 1, 1, 'SR', NULL, NULL, NULL),
(495, '2016-06-14 14:14:43', NULL, NULL, 207, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 14:14:43', 'lois-1465872921-1465884883057193', 1, 0, '', NULL, NULL, NULL),
(496, '2016-06-14 14:41:34', NULL, NULL, 208, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 14:41:34', 'lois-1465872921-14658864945885834', 1, 1, 'SR', NULL, NULL, NULL),
(497, '2016-06-14 14:41:34', NULL, NULL, 208, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 14:41:34', 'lois-1465872921-14658864945885834', 1, 0, '', NULL, NULL, NULL),
(498, '2016-06-14 14:41:34', NULL, NULL, 208, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 14:41:34', 'lois-1465872921-14658864945885834', 1, 0, '', NULL, NULL, NULL),
(499, '2016-06-14 15:10:07', NULL, NULL, 209, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 15:10:07', 'lois-1465872921-14658882076096812', 1, 0, '', NULL, NULL, NULL),
(500, '2016-06-14 15:10:07', NULL, NULL, 209, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 15:10:07', 'lois-1465872921-14658882076096812', 1, 1, 'SR', NULL, NULL, NULL),
(501, '2016-06-14 15:10:16', NULL, NULL, 210, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 15:10:16', 'lois-1465872921-1465888216542521', 1, 0, '', NULL, NULL, NULL),
(502, '2016-06-14 16:13:03', NULL, NULL, 211, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 16:13:03', 'lois-1465872921-14658919835374862', 1, 1, 'SR', NULL, NULL, NULL),
(503, '2016-06-14 16:13:03', NULL, NULL, 211, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 16:13:03', 'lois-1465872921-14658919835374862', 1, 1, 'SR', NULL, NULL, NULL),
(504, '2016-06-14 17:29:34', NULL, NULL, 212, NULL, 26, '26', 'Tea By Cup', '', 'Hot Drinks', 'Non Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 17:29:34', 'lois-1465872921-14658965743846757', 1, 1, 'SR', NULL, NULL, NULL),
(505, '2016-06-14 17:32:04', NULL, NULL, 213, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 17:32:04', 'lois-1465872921-14658967241211997', 1, 1, 'SR', NULL, NULL, NULL),
(506, '2016-06-14 09:48:05', NULL, NULL, 196, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 09:48:05', 'lois-1465865812-14658688855809337', 1, 0, '', NULL, NULL, NULL),
(507, '2016-06-14 09:48:05', NULL, NULL, 196, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 09:48:05', 'lois-1465865812-14658688855809337', 1, 0, '', NULL, NULL, NULL),
(508, '2016-06-14 09:26:10', NULL, NULL, 195, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 09:26:10', 'lois-1465865812-14658675701836921', 1, 0, '', NULL, NULL, NULL),
(509, '2016-06-14 09:26:10', NULL, NULL, 195, 0, 180, '115', 'Free Breakfast ', '', 'Meals', 'Morning Bites ', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 09:26:10', 'lois-1465865812-14658675701836921', 1, 0, '', NULL, NULL, NULL),
(510, '2016-06-14 09:26:10', NULL, NULL, 195, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1465903663', 'lois', '2016-06-14 09:26:10', 'lois-1465865812-14658675701836921', 1, 1, 'SR', NULL, NULL, NULL),
(511, '2016-06-16 11:58:33', NULL, NULL, 218, NULL, 84, '84', 'Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466075174', 'Staff', '2016-06-16 11:58:33', 'Staff-1466038211-14660495133206722', 1, 1, 'SR', NULL, NULL, NULL),
(512, '2016-06-16 11:58:33', NULL, NULL, 218, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466075174', 'Staff', '2016-06-16 11:58:33', 'Staff-1466038211-14660495133206722', 1, 1, 'SR', NULL, NULL, NULL),
(513, '2016-06-16 11:58:33', NULL, NULL, 218, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466075174', 'Staff', '2016-06-16 11:58:33', 'Staff-1466038211-14660495133206722', 1, 0, '', NULL, NULL, NULL),
(514, '2016-06-16 11:59:31', NULL, NULL, 219, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466075174', 'Staff', '2016-06-16 11:59:31', 'Staff-1466038211-14660495713096781', 1, 1, 'SR', NULL, NULL, NULL),
(515, '2016-06-16 12:37:36', NULL, NULL, 219, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466075174', 'lois', '2016-06-16 12:37:36', 'lois-1466051819-14660518559725765', 1, 1, 'SR', NULL, NULL, NULL),
(516, '2016-06-16 12:37:36', NULL, NULL, 219, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466075174', 'lois', '2016-06-16 12:37:36', 'lois-1466051819-14660518559725765', 1, 1, 'SR', NULL, NULL, NULL),
(517, '2016-06-16 12:35:02', NULL, NULL, 220, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466075174', 'Staff', '2016-06-16 12:35:02', 'Staff-1466038211-14660517023528153', 1, 0, '', NULL, NULL, NULL),
(518, '2016-06-16 12:35:21', NULL, NULL, 220, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466075174', 'Staff', '2016-06-16 12:35:21', 'Staff-1466038211-14660517217915121', 1, 1, 'SR', NULL, NULL, NULL),
(519, '2016-06-16 12:35:21', NULL, NULL, 220, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466075174', 'Staff', '2016-06-16 12:35:21', 'Staff-1466038211-14660517217915121', 1, 1, 'SR', NULL, NULL, NULL),
(520, '2016-06-16 12:35:21', NULL, NULL, 220, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466075174', 'Staff', '2016-06-16 12:35:21', 'Staff-1466038211-14660517217915121', 1, 0, '', NULL, NULL, NULL),
(521, '2016-06-16 12:47:50', NULL, NULL, 220, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1466075174', 'lois', '2016-06-16 12:47:50', 'lois-1466051819-1466052469990613', 1, 0, '', NULL, NULL, NULL),
(522, '2016-06-16 12:47:50', NULL, NULL, 220, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1466075174', 'lois', '2016-06-16 12:47:50', 'lois-1466051819-1466052469990613', 1, 0, '', NULL, NULL, NULL),
(523, '2016-06-16 12:47:50', NULL, NULL, 220, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1466075174', 'lois', '2016-06-16 12:47:50', 'lois-1466051819-1466052469990613', 1, 0, '', NULL, NULL, NULL),
(524, '2016-06-16 13:14:10', NULL, NULL, 221, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466075174', 'lois', '2016-06-16 13:14:10', 'lois-1466051819-14660540503388045', 1, 1, 'SR', NULL, NULL, NULL),
(525, '2016-06-16 13:14:10', NULL, NULL, 221, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466075174', 'lois', '2016-06-16 13:14:10', 'lois-1466051819-14660540503388045', 1, 1, 'SR', NULL, NULL, NULL),
(526, '2016-06-16 13:16:39', NULL, NULL, 220, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466075174', 'lois', '2016-06-16 13:16:39', 'lois-1466051819-1466054199360495', 1, 1, 'SR', NULL, NULL, NULL),
(527, '2016-06-16 13:16:39', NULL, NULL, 220, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1466075174', 'lois', '2016-06-16 13:16:39', 'lois-1466051819-1466054199360495', 1, 1, 'SR', NULL, NULL, NULL),
(528, '2016-06-16 13:16:39', NULL, NULL, 220, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466075174', 'lois', '2016-06-16 13:16:39', 'lois-1466051819-1466054199360495', 1, 0, '', NULL, NULL, NULL),
(529, '2016-06-16 13:35:54', NULL, NULL, 222, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466075174', 'lois', '2016-06-16 13:35:54', 'lois-1466051819-14660553546577757', 1, 0, '', NULL, NULL, NULL),
(530, '2016-06-16 13:35:54', NULL, NULL, 222, 0, 182, '117', 'Open Drinks ', 'iced tea', 'Open', 'Drinks', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466075174', 'lois', '2016-06-16 13:35:54', 'lois-1466051819-14660553546577757', 1, 0, '', NULL, NULL, NULL),
(531, '2016-06-16 13:41:10', NULL, NULL, 223, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466075174', 'lois', '2016-06-16 13:41:10', 'lois-1466051819-14660556702542470', 1, 1, 'SR', 1, NULL, NULL),
(532, '2016-06-16 13:44:33', NULL, NULL, 220, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1466075174', 'lois', '2016-06-16 13:44:33', 'lois-1466051819-14660558738541662', 1, 0, '', NULL, NULL, NULL),
(533, '2016-06-16 14:40:29', NULL, NULL, 224, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466075174', 'lois', '2016-06-16 14:40:29', 'lois-1466051819-14660592291157355', 1, 1, 'SR', 1, NULL, NULL),
(534, '2016-06-16 19:06:59', NULL, NULL, 228, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466075174', 'Staff', '2016-06-16 19:06:59', 'Staff-1466075174-14660752193625259', 1, 1, 'SR', NULL, NULL, NULL),
(535, '2016-06-16 14:56:10', NULL, NULL, 226, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466075174', 'lois', '2016-06-16 14:56:10', 'lois-1466051819-14660601702924850', 1, 1, 'SR', NULL, NULL, NULL),
(536, '2016-06-16 14:57:59', NULL, NULL, 227, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466075174', 'Staff', '2016-06-16 14:57:59', 'Staff-1466060240-1466060279748398', 1, 1, 'SR', NULL, NULL, NULL),
(537, '2016-06-16 11:49:45', NULL, NULL, 216, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466075174', 'Staff', '2016-06-16 11:49:45', 'Staff-1466038211-14660489848294979', 1, 1, 'SR', NULL, NULL, NULL),
(538, '2016-06-16 10:10:53', NULL, NULL, 214, 0, 182, '117', 'Open Drinks ', 'iced tea', 'Open', 'Drinks', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466075174', 'Staff', '2016-06-16 10:10:53', 'Staff-1466038211-14660430531546373', 1, 0, '', 1, NULL, NULL),
(539, '2016-06-16 11:57:55', NULL, NULL, 217, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466075174', 'Staff', '2016-06-16 11:57:55', 'Staff-1466038211-1466049475256648', 1, 1, 'SR', NULL, NULL, NULL),
(540, '2016-06-16 11:10:50', NULL, NULL, 215, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466075174', 'Staff', '2016-06-16 11:10:50', 'Staff-1466038211-14660466507486742', 1, 1, 'SR', NULL, NULL, NULL),
(541, '2016-06-17 19:16:57', NULL, NULL, 257, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 19:16:57', 'Staff-1466149363-14661622173944662', 1, 0, '', NULL, NULL, NULL),
(542, '2016-06-17 19:42:01', NULL, NULL, 258, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 19:42:01', 'Staff-1466149363-14661637216417490', 1, 0, '', NULL, NULL, NULL),
(543, '2016-06-17 19:42:13', NULL, NULL, 258, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 19:42:13', 'Staff-1466149363-14661637331415399', 1, 1, 'SR', NULL, NULL, NULL),
(544, '2016-06-17 19:44:38', NULL, NULL, 258, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 19:44:38', 'Staff-1466149363-14661638781854569', 1, 0, '', NULL, NULL, NULL),
(545, '2016-06-17 19:16:57', NULL, NULL, 257, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 19:16:57', 'Staff-1466149363-14661622173944662', 1, 1, 'SR', NULL, NULL, NULL),
(546, '2016-06-17 19:15:59', NULL, NULL, 257, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 19:15:59', 'Staff-1466149363-14661621596219782', 1, 1, 'SR', NULL, NULL, NULL),
(547, '2016-06-17 18:50:38', NULL, NULL, 256, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 18:50:38', 'Staff-1466149363-14661606379328225', 1, 0, '', NULL, NULL, NULL),
(548, '2016-06-17 18:50:38', NULL, NULL, 256, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 18:50:38', 'Staff-1466149363-14661606379328225', 1, 1, 'SR', NULL, NULL, NULL),
(549, '2016-06-17 18:50:38', NULL, NULL, 256, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 18:50:38', 'Staff-1466149363-14661606379328225', 1, 1, 'SR', NULL, NULL, NULL),
(550, '2016-06-17 18:50:38', NULL, NULL, 256, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 18:50:38', 'Staff-1466149363-14661606379328225', 1, 1, 'SR', NULL, NULL, NULL),
(551, '2016-06-17 18:13:35', NULL, NULL, 255, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 18:13:35', 'Staff-1466149363-14661584157024037', 1, 1, 'SR', NULL, NULL, NULL),
(552, '2016-06-17 18:13:35', NULL, NULL, 255, 0, 54, '54', 'Chai Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 18:13:35', 'Staff-1466149363-14661584157024037', 1, 1, 'SR', NULL, NULL, NULL),
(553, '2016-06-17 17:40:01', NULL, NULL, 254, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 17:40:01', 'Staff-1466149363-14661564016392519', 1, 1, 'SR', 1, NULL, NULL),
(554, '2016-06-17 17:40:01', NULL, NULL, 254, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 17:40:01', 'Staff-1466149363-14661564016392519', 1, 0, '', 1, NULL, NULL),
(555, '2016-06-17 17:39:02', NULL, NULL, 253, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 17:39:02', 'Staff-1466149363-1466156342111475', 1, 0, '', 1, NULL, NULL),
(556, '2016-06-17 17:39:02', NULL, NULL, 253, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 17:39:02', 'Staff-1466149363-1466156342111475', 1, 1, 'SR', 1, NULL, NULL),
(557, '2016-06-17 17:38:16', NULL, NULL, 252, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 17:38:16', 'Staff-1466149363-14661562958593599', 1, 1, 'SR', 1, NULL, NULL),
(558, '2016-06-17 17:38:16', NULL, NULL, 252, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 17:38:16', 'Staff-1466149363-14661562958593599', 1, 1, 'SR', 1, NULL, NULL),
(559, '2016-06-17 17:37:53', NULL, NULL, 251, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 17:37:53', 'Staff-1466149363-14661562734063326', 1, 0, '', 1, NULL, NULL),
(560, '2016-06-17 10:28:24', NULL, NULL, 230, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 10:28:24', 'Staff-1466123960-14661305045684465', 1, 1, 'SR', NULL, NULL, NULL),
(561, '2016-06-17 10:07:50', NULL, NULL, 229, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 10:07:50', 'Staff-1466123960-14661292700441525', 1, 0, '', NULL, NULL, NULL),
(562, '2016-06-17 10:07:50', NULL, NULL, 229, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 10:07:50', 'Staff-1466123960-14661292700441525', 1, 1, 'SR', NULL, NULL, NULL),
(563, '2016-06-17 10:29:34', NULL, NULL, 232, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 10:29:34', 'Staff-1466123960-14661305744527511', 1, 1, 'SR', 1, NULL, NULL),
(564, '2016-06-17 10:29:34', NULL, NULL, 232, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 10:29:34', 'Staff-1466123960-14661305744527511', 1, 0, '', 1, NULL, NULL),
(565, '2016-06-17 10:38:11', NULL, NULL, 233, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 10:38:11', 'Staff-1466123960-14661310911896060', 1, 0, '', NULL, NULL, NULL),
(566, '2016-06-17 10:38:11', NULL, NULL, 233, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 10:38:11', 'Staff-1466123960-14661310911896060', 1, 0, '', NULL, NULL, NULL),
(567, '2016-06-17 10:38:11', NULL, NULL, 233, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 10:38:11', 'Staff-1466123960-14661310911896060', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(568, '2016-06-17 10:38:11', NULL, NULL, 233, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 10:38:11', 'Staff-1466123960-14661310911896060', 1, 1, 'SR', NULL, NULL, NULL),
(569, '2016-06-17 10:45:54', NULL, NULL, 233, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 10:45:54', 'Staff-1466123960-1466131554790871', 1, 0, '', NULL, NULL, NULL),
(570, '2016-06-17 11:04:22', NULL, NULL, 234, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 11:04:22', 'Staff-1466123960-14661326625774098', 1, 1, 'SR', NULL, NULL, NULL),
(571, '2016-06-17 11:29:09', NULL, NULL, 235, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 11:29:09', 'Staff-1466123960-14661341496318654', 1, 1, 'SR', NULL, NULL, NULL),
(572, '2016-06-17 11:29:09', NULL, NULL, 235, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 11:29:09', 'Staff-1466123960-14661341496318654', 1, 1, 'SR', NULL, NULL, NULL),
(573, '2016-06-17 11:29:09', NULL, NULL, 235, 0, 159, '93', 'Granola ', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 11:29:09', 'Staff-1466123960-14661341496318654', 1, 0, '', NULL, NULL, NULL),
(574, '2016-06-17 12:16:05', NULL, NULL, 236, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 12:16:05', 'Staff-1466123960-14661369651075198', 1, 1, 'SR', NULL, NULL, NULL),
(575, '2016-06-17 12:27:25', NULL, NULL, 238, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 12:27:25', 'Staff-1466123960-1466137644985745', 1, 0, '', 1, NULL, NULL),
(576, '2016-06-17 12:44:48', NULL, NULL, 239, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 12:44:48', 'Staff-1466123960-14661386887295833', 1, 0, '', NULL, NULL, NULL),
(577, '2016-06-17 12:44:48', NULL, NULL, 239, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 12:44:48', 'Staff-1466123960-14661386887295833', 1, 1, 'SR', NULL, NULL, NULL),
(578, '2016-06-17 12:44:48', NULL, NULL, 239, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 12:44:48', 'Staff-1466123960-14661386887295833', 1, 1, 'SR', NULL, NULL, NULL),
(579, '2016-06-17 12:59:00', NULL, NULL, 240, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 12:59:00', 'Staff-1466123960-14661395399322575', 1, 1, 'SR', NULL, NULL, NULL),
(580, '2016-06-17 13:01:10', NULL, NULL, 241, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 13:01:10', 'Staff-1466123960-14661396703112728', 1, 1, 'SR', NULL, NULL, NULL),
(581, '2016-06-17 13:01:30', NULL, NULL, 241, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 13:01:30', 'Staff-1466123960-1466139690823842', 1, 1, 'SR', NULL, NULL, NULL),
(582, '2016-06-17 13:01:31', NULL, NULL, 241, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 13:01:31', 'Staff-1466123960-1466139690823842', 1, 1, 'SR', NULL, NULL, NULL),
(583, '2016-06-17 13:18:34', NULL, NULL, 240, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 13:18:34', 'Staff-1466123960-1466140714276453', 1, 1, 'SR', NULL, NULL, NULL),
(584, '2016-06-17 17:11:26', NULL, NULL, 250, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 17:11:26', 'Staff-1466149363-14661546867706211', 1, 1, 'SR', NULL, NULL, NULL),
(585, '2016-06-17 17:11:26', NULL, NULL, 250, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 17:11:26', 'Staff-1466149363-14661546867706211', 1, 1, 'SR', NULL, NULL, NULL),
(586, '2016-06-17 13:18:34', NULL, NULL, 240, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 13:18:34', 'Staff-1466123960-1466140714276453', 1, 1, 'SR', NULL, NULL, NULL),
(587, '2016-06-17 14:15:27', NULL, NULL, 242, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 14:15:27', 'Staff-1466123960-14661441275908042', 1, 1, 'SR', NULL, NULL, NULL),
(588, '2016-06-17 14:15:27', NULL, NULL, 242, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 14:15:27', 'Staff-1466123960-14661441275908042', 1, 1, 'SR', NULL, NULL, NULL),
(589, '2016-06-17 14:15:27', NULL, NULL, 242, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 14:15:27', 'Staff-1466123960-14661441275908042', 1, 1, 'SR', NULL, NULL, NULL),
(590, '2016-06-17 14:15:27', NULL, NULL, 242, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 14:15:27', 'Staff-1466123960-14661441275908042', 1, 0, '', NULL, NULL, NULL),
(591, '2016-06-17 14:15:27', NULL, NULL, 242, 0, 164, '98', 'Banana Fritters ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 14:15:27', 'Staff-1466123960-14661441275908042', 1, 0, '', NULL, NULL, NULL),
(592, '2016-06-17 14:22:11', NULL, NULL, 236, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 14:22:11', 'Staff-1466123960-14661445311545011', 1, 0, '', NULL, NULL, NULL),
(593, '2016-06-17 15:00:07', NULL, NULL, 243, 0, 74, '74', 'Sunrice', 'Takeaway', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 15:00:07', 'Staff-1466123960-14661468077222795', 1, 1, 'SR', NULL, NULL, NULL),
(594, '2016-06-17 15:11:13', NULL, NULL, 243, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 15:11:13', 'Staff-1466123960-1466147473704250', 1, 1, 'SR', NULL, NULL, NULL),
(595, '2016-06-17 15:13:14', NULL, NULL, 244, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 15:13:14', 'Staff-1466123960-14661475939956449', 1, 1, 'SR', NULL, NULL, NULL),
(596, '2016-06-17 15:48:15', NULL, NULL, 245, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 15:48:15', 'Staff-1466149363-1466149695710602', 1, 0, '', NULL, NULL, NULL),
(597, '2016-06-17 15:53:15', NULL, NULL, 246, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 15:53:15', 'Staff-1466149363-14661499955996061', 1, 1, 'SR', NULL, NULL, NULL),
(598, '2016-06-17 15:53:15', NULL, NULL, 246, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 15:53:15', 'Staff-1466149363-14661499955996061', 1, 1, 'SR', NULL, NULL, NULL),
(599, '2016-06-17 16:16:51', NULL, NULL, 247, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 16:16:51', 'Staff-1466149363-1466151411465417', 1, 1, 'SR', NULL, NULL, NULL),
(600, '2016-06-17 16:16:51', NULL, NULL, 247, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 16:16:51', 'Staff-1466149363-1466151411465417', 1, 1, 'SR', NULL, NULL, NULL),
(601, '2016-06-17 16:16:51', NULL, NULL, 247, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 16:16:51', 'Staff-1466149363-1466151411465417', 1, 0, '', NULL, NULL, NULL),
(602, '2016-06-17 16:16:51', NULL, NULL, 247, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 16:16:51', 'Staff-1466149363-1466151411465417', 1, 0, '', NULL, NULL, NULL),
(603, '2016-06-17 16:16:51', NULL, NULL, 247, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 16:16:51', 'Staff-1466149363-1466151411465417', 1, 0, '', NULL, NULL, NULL),
(604, '2016-06-17 16:16:51', NULL, NULL, 247, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 16:16:51', 'Staff-1466149363-1466151411465417', 1, 0, '', NULL, NULL, NULL),
(605, '2016-06-17 16:16:51', NULL, NULL, 247, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 16:16:51', 'Staff-1466149363-1466151411465417', 1, 1, 'SR', NULL, NULL, NULL),
(606, '2016-06-17 16:30:20', NULL, NULL, 248, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 16:30:20', 'Staff-1466149363-1466152220396341', 1, 1, 'SR', NULL, NULL, NULL),
(607, '2016-06-17 16:30:20', NULL, NULL, 248, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 16:30:20', 'Staff-1466149363-1466152220396341', 1, 1, 'SR', NULL, NULL, NULL),
(608, '2016-06-17 16:30:20', NULL, NULL, 248, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 16:30:20', 'Staff-1466149363-1466152220396341', 1, 1, 'SR', NULL, NULL, NULL),
(609, '2016-06-17 16:30:20', NULL, NULL, 248, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 16:30:20', 'Staff-1466149363-1466152220396341', 1, 0, '', NULL, NULL, NULL),
(610, '2016-06-17 16:30:20', NULL, NULL, 248, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 16:30:20', 'Staff-1466149363-1466152220396341', 1, 1, 'SR', NULL, NULL, NULL),
(611, '2016-06-17 16:38:53', NULL, NULL, 249, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 16:38:53', 'Staff-1466149363-1466152733624787', 1, 0, '', NULL, NULL, NULL),
(612, '2016-06-17 16:38:53', NULL, NULL, 249, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 16:38:53', 'Staff-1466149363-1466152733624787', 1, 0, '', NULL, NULL, NULL),
(613, '2016-06-17 16:38:53', NULL, NULL, 249, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 16:38:53', 'Staff-1466149363-1466152733624787', 1, 0, '', NULL, NULL, NULL),
(614, '2016-06-17 16:38:53', NULL, NULL, 249, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 16:38:53', 'Staff-1466149363-1466152733624787', 1, 1, 'SR', NULL, NULL, NULL),
(615, '2016-06-17 16:38:53', NULL, NULL, 249, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 16:38:53', 'Staff-1466149363-1466152733624787', 1, 1, 'SR', NULL, NULL, NULL),
(616, '2016-06-17 17:10:59', NULL, NULL, 247, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 17:10:59', 'Staff-1466149363-14661546591224514', 1, 0, '', NULL, NULL, NULL),
(617, '2016-06-17 17:11:26', NULL, NULL, 250, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 17:11:26', 'Staff-1466149363-14661546867706211', 1, 0, '', NULL, NULL, NULL),
(618, '2016-06-17 19:15:59', NULL, NULL, 257, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 19:15:59', 'Staff-1466149363-14661621596219782', 1, 0, '', NULL, NULL, NULL),
(619, '2016-06-17 19:07:52', NULL, NULL, 256, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 19:07:52', 'Staff-1466149363-14661616725767063', 1, 0, '', NULL, NULL, NULL),
(620, '2016-06-17 17:18:39', NULL, NULL, 249, 0, 182, '117', 'Open Drinks ', 'shot', 'Open', 'Drinks', 2, 2.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 17:18:39', 'Staff-1466149363-14661551196492071', 1, 0, '', NULL, NULL, NULL),
(621, '2016-06-17 17:11:26', NULL, NULL, 250, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 17:11:26', 'Staff-1466149363-14661546867706211', 1, 1, 'SR', NULL, NULL, NULL),
(622, '2016-06-17 17:18:39', NULL, NULL, 249, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 17:18:39', 'Staff-1466149363-14661551196492071', 1, 1, 'SR', NULL, NULL, NULL),
(623, '2016-06-17 10:07:50', NULL, NULL, 229, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 10:07:50', 'Staff-1466123960-14661292700441525', 1, 1, 'SR', NULL, NULL, NULL),
(624, '2016-06-17 10:29:00', NULL, NULL, 231, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 10:29:00', 'Staff-1466123960-14661305402137485', 1, 0, '', 1, NULL, NULL),
(625, '2016-06-17 10:29:00', NULL, NULL, 231, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 10:29:00', 'Staff-1466123960-14661305402137485', 1, 1, 'SR', 1, NULL, NULL),
(626, '2016-06-17 10:28:24', NULL, NULL, 230, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 10:28:24', 'Staff-1466123960-14661305045684465', 1, 0, '', NULL, NULL, NULL),
(627, '2016-06-17 10:07:50', NULL, NULL, 229, 0, 180, '115', 'Free Breakfast ', '', 'Meals', 'Morning Bites ', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1466149363', 'Staff', '2016-06-17 10:07:50', 'Staff-1466123960-14661292700441525', 1, 0, '', NULL, NULL, NULL),
(628, '2016-06-18 19:04:56', NULL, NULL, 301, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 19:04:56', 'lois-1466242801-14662478960337936', 1, 0, '', NULL, NULL, NULL),
(629, '2016-06-18 19:04:56', NULL, NULL, 301, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 19:04:56', 'lois-1466242801-14662478960337936', 1, 1, 'SR', NULL, NULL, NULL),
(630, '2016-06-18 19:04:56', NULL, NULL, 301, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 19:04:56', 'lois-1466242801-14662478960337936', 1, 0, '', NULL, NULL, NULL),
(631, '2016-06-18 19:04:56', NULL, NULL, 301, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 19:04:56', 'lois-1466242801-14662478960337936', 1, 1, 'SR', NULL, NULL, NULL),
(632, '2016-06-18 19:04:56', NULL, NULL, 301, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 2, 15.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 19:04:56', 'lois-1466242801-14662478960337936', 1, 0, '', NULL, NULL, NULL),
(633, '2016-06-18 19:04:56', NULL, NULL, 301, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 19:04:56', 'lois-1466242801-14662478960337936', 1, 1, 'SR', NULL, NULL, NULL),
(634, '2016-06-18 17:17:36', NULL, NULL, 300, 0, 54, '54', 'Chai Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 17:17:36', 'Staff-1466235501-14662414558752954', 1, 1, 'SR', NULL, NULL, NULL),
(635, '2016-06-18 17:40:10', NULL, NULL, 296, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 16.20, 1, '27', 1, '1466258084', 'lois', '2016-06-18 17:40:10', 'lois-1466242801-1466242810328426', 1, 0, '', NULL, '10.0', NULL),
(636, '2016-06-18 16:17:41', NULL, NULL, 299, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 16:17:41', 'Staff-1466235501-14662378615011040', 1, 1, 'SR', NULL, NULL, NULL),
(637, '2016-06-18 17:17:36', NULL, NULL, 300, 0, 164, '98', 'Banana Fritters ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 17:17:36', 'Staff-1466235501-14662414558752954', 1, 0, '', NULL, NULL, NULL),
(638, '2016-06-18 17:17:36', NULL, NULL, 300, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 17:17:36', 'Staff-1466235501-14662414558752954', 1, 1, 'SR', NULL, NULL, NULL),
(639, '2016-06-18 16:04:50', NULL, NULL, 298, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 16:04:50', 'Staff-1466235501-14662370907911310', 1, 0, '', NULL, NULL, NULL),
(640, '2016-06-18 16:07:58', NULL, NULL, 297, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 16:07:58', 'Staff-1466235501-14662372780575225', 1, 0, '', NULL, NULL, NULL),
(641, '2016-06-18 16:04:50', NULL, NULL, 298, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 16:04:50', 'Staff-1466235501-14662370907911310', 1, 1, 'SR', NULL, NULL, NULL),
(642, '2016-06-18 16:03:25', NULL, NULL, 297, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 16:03:25', 'Staff-1466235501-14662370058103015', 1, 1, 'SR', NULL, NULL, NULL),
(643, '2016-06-18 16:03:25', NULL, NULL, 297, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 16:03:25', 'Staff-1466235501-14662370058103015', 1, 1, 'SR', NULL, NULL, NULL),
(644, '2016-06-18 16:03:25', NULL, NULL, 297, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 16:03:25', 'Staff-1466235501-14662370058103015', 1, 1, 'SR', NULL, NULL, NULL),
(645, '2016-06-18 15:55:03', NULL, NULL, 296, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 9.90, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 15:55:03', 'Staff-1466235501-1466236503796969', 1, 1, 'SR', NULL, '10.0', NULL),
(646, '2016-06-18 15:05:29', NULL, NULL, 294, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 15:05:29', 'Staff-1466232247-14662335288701059', 1, 0, '', NULL, NULL, NULL),
(647, '2016-06-18 14:44:29', NULL, NULL, 293, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 14:44:29', 'Staff-1466232247-14662322689316138', 1, 0, '', NULL, NULL, NULL),
(648, '2016-06-18 15:39:47', NULL, NULL, 295, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 15:39:47', 'Staff-1466235501-14662355875646468', 1, 1, 'SR', NULL, NULL, NULL),
(649, '2016-06-18 15:55:03', NULL, NULL, 296, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 9.90, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 15:55:03', 'Staff-1466235501-1466236503796969', 1, 1, 'SR', NULL, '10.0', NULL),
(650, '2016-06-18 14:14:30', NULL, NULL, 292, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 14:14:30', 'admin-1466218339-14662304701629244', 1, 1, 'SR', NULL, NULL, NULL),
(651, '2016-06-18 14:41:50', NULL, NULL, 292, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 14:41:50', 'admin-1466218339-14662321104878277', 1, 0, '', NULL, NULL, NULL),
(652, '2016-06-18 14:44:29', NULL, NULL, 293, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 14:44:29', 'Staff-1466232247-14662322689316138', 1, 1, 'SR', NULL, NULL, NULL),
(653, '2016-06-18 14:14:30', NULL, NULL, 292, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 14:14:30', 'admin-1466218339-14662304701629244', 1, 1, 'SR', NULL, NULL, NULL),
(654, '2016-06-18 14:14:30', NULL, NULL, 292, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 14:14:30', 'admin-1466218339-14662304701629244', 1, 0, '', NULL, NULL, NULL),
(655, '2016-06-18 14:05:53', NULL, NULL, 291, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 14:05:53', 'admin-1466218339-14662299531694975', 1, 1, 'SR', NULL, NULL, NULL),
(656, '2016-06-18 13:48:59', NULL, NULL, 290, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 13:48:59', 'admin-1466218339-14662289391808566', 1, 0, '', NULL, NULL, NULL),
(657, '2016-06-18 13:48:59', NULL, NULL, 290, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 13:48:59', 'admin-1466218339-14662289391808566', 1, 1, 'SR', NULL, NULL, NULL),
(658, '2016-06-18 13:17:36', NULL, NULL, 287, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 13:17:36', 'admin-1466218339-1466227056556151', 1, 1, 'SR', NULL, NULL, NULL),
(659, '2016-06-18 13:31:02', NULL, NULL, 288, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 13:31:02', 'admin-1466218339-14662278625213495', 1, 1, 'SR', NULL, NULL, NULL),
(660, '2016-06-18 13:31:02', NULL, NULL, 288, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 13:31:02', 'admin-1466218339-14662278625213495', 1, 1, 'SR', NULL, NULL, NULL),
(661, '2016-06-18 13:31:42', NULL, NULL, 289, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 13:31:42', 'admin-1466218339-14662279024498274', 1, 1, 'SR', NULL, NULL, NULL),
(662, '2016-06-18 13:31:42', NULL, NULL, 289, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 13:31:42', 'admin-1466218339-14662279024498274', 1, 1, 'SR', NULL, NULL, NULL),
(663, '2016-06-18 13:31:42', NULL, NULL, 289, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 13:31:42', 'admin-1466218339-14662279024498274', 1, 1, 'SR', NULL, NULL, NULL),
(664, '2016-06-18 13:16:36', NULL, NULL, 283, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 13:16:36', 'admin-1466218339-14662269967181467', 1, 0, '', NULL, NULL, NULL),
(665, '2016-06-18 09:53:11', NULL, NULL, 264, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 09:53:11', 'Staff-1466214196-14662147917635798', 1, 0, '', NULL, NULL, NULL),
(666, '2016-06-18 09:53:11', NULL, NULL, 264, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 09:53:11', 'Staff-1466214196-14662147917635798', 1, 1, 'SR', NULL, NULL, NULL),
(667, '2016-06-18 09:53:11', NULL, NULL, 264, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 09:53:11', 'Staff-1466214196-14662147917635798', 1, 1, 'SR', NULL, NULL, NULL),
(668, '2016-06-18 09:53:11', NULL, NULL, 264, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 09:53:11', 'Staff-1466214196-14662147917635798', 1, 1, 'SR', NULL, NULL, NULL),
(669, '2016-06-18 09:55:49', NULL, NULL, 265, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 09:55:49', 'Staff-1466214196-14662149494803998', 1, 0, '', NULL, NULL, NULL),
(670, '2016-06-18 09:55:49', NULL, NULL, 265, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 09:55:49', 'Staff-1466214196-14662149494803998', 1, 0, '', NULL, NULL, NULL),
(671, '2016-06-18 09:55:49', NULL, NULL, 265, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 09:55:49', 'Staff-1466214196-14662149494803998', 1, 1, 'SR', NULL, NULL, NULL),
(672, '2016-06-18 09:55:49', NULL, NULL, 265, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 09:55:49', 'Staff-1466214196-14662149494803998', 1, 1, 'SR', NULL, NULL, NULL),
(673, '2016-06-18 10:01:06', NULL, NULL, 266, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 10:01:06', 'Staff-1466214196-14662152662063211', 1, 1, 'SR', NULL, NULL, NULL),
(674, '2016-06-18 10:50:11', NULL, NULL, 272, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 10:50:11', 'admin-1466216375-14662182115988313', 1, 1, 'SR', NULL, NULL, NULL),
(675, '2016-06-18 10:50:11', NULL, NULL, 272, 0, 159, '93', 'Granola ', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 10:50:11', 'admin-1466216375-14662182115988313', 1, 0, '', NULL, NULL, NULL),
(676, '2016-06-18 10:50:50', NULL, NULL, 273, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 10:50:50', 'admin-1466216375-14662182504988839', 1, 0, '', NULL, NULL, NULL),
(677, '2016-06-18 10:51:18', NULL, NULL, 274, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 10:51:18', 'admin-1466216375-14662182786903919', 1, 1, 'SR', NULL, NULL, NULL),
(678, '2016-06-18 10:51:18', NULL, NULL, 274, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 10:51:18', 'admin-1466216375-14662182786903919', 1, 0, '', NULL, NULL, NULL),
(679, '2016-06-18 10:59:38', NULL, NULL, 275, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 10:59:38', 'admin-1466218339-14662187782031456', 1, 1, 'SR', NULL, NULL, NULL),
(680, '2016-06-18 10:18:50', NULL, NULL, 268, 0, 153, '87', 'Big Breakfast ', 'fried egg', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 10:18:50', 'Staff-1466214196-14662163299926022', 1, 0, '', NULL, NULL, NULL),
(681, '2016-06-18 10:18:50', NULL, NULL, 268, 0, 39, '39', 'Mango Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 10:18:50', 'Staff-1466214196-14662163299926022', 1, 1, 'SR', NULL, NULL, NULL),
(682, '2016-06-18 10:18:50', NULL, NULL, 268, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 10:18:50', 'Staff-1466214196-14662163299926022', 1, 1, 'SR', NULL, NULL, NULL),
(683, '2016-06-18 10:18:50', NULL, NULL, 268, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 10:18:50', 'Staff-1466214196-14662163299926022', 1, 0, '', NULL, NULL, NULL),
(684, '2016-06-18 10:18:50', NULL, NULL, 268, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 10:18:50', 'Staff-1466214196-14662163299926022', 1, 1, 'SR', NULL, NULL, NULL),
(685, '2016-06-18 10:18:50', NULL, NULL, 268, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 10:18:50', 'Staff-1466214196-14662163299926022', 1, 1, 'SR', NULL, NULL, NULL),
(686, '2016-06-18 09:46:29', NULL, NULL, 263, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 09:46:29', 'Staff-1466214196-14662143888118054', 1, 1, 'SR', NULL, NULL, NULL),
(687, '2016-06-18 10:31:37', NULL, NULL, 267, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 10:31:37', 'admin-1466216375-14662170975956772', 1, 0, '', NULL, NULL, NULL),
(688, '2016-06-18 10:38:02', NULL, NULL, 269, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 10:38:02', 'admin-1466216375-14662174824344876', 1, 0, '', 1, NULL, NULL),
(689, '2016-06-18 10:41:07', NULL, NULL, 270, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 10:41:07', 'admin-1466216375-14662176669619879', 1, 0, '', NULL, NULL, NULL),
(690, '2016-06-18 10:41:07', NULL, NULL, 270, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 10:41:07', 'admin-1466216375-14662176669619879', 1, 1, 'SR', NULL, NULL, NULL),
(691, '2016-06-18 10:41:07', NULL, NULL, 270, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 10:41:07', 'admin-1466216375-14662176669619879', 1, 1, 'SR', NULL, NULL, NULL),
(692, '2016-06-18 10:59:38', NULL, NULL, 275, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 10:59:38', 'admin-1466218339-14662187782031456', 1, 1, 'SR', NULL, NULL, NULL),
(693, '2016-06-18 10:59:38', NULL, NULL, 275, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 2, 13.00, 26.0000, 0.0000, 26.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 10:59:38', 'admin-1466218339-14662187782031456', 1, 1, 'SR', NULL, NULL, NULL),
(694, '2016-06-18 11:02:12', NULL, NULL, 268, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:02:12', 'admin-1466218339-14662189318703062', 1, 1, 'SR', NULL, NULL, NULL),
(695, '2016-06-18 11:02:12', NULL, NULL, 268, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:02:12', 'admin-1466218339-14662189318703062', 1, 1, 'SR', NULL, NULL, NULL),
(696, '2016-06-18 09:05:39', NULL, NULL, 259, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 09:05:39', 'admin-1466211596-14662119397006244', 1, 0, '', NULL, NULL, NULL),
(697, '2016-06-18 09:05:39', NULL, NULL, 259, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 09:05:39', 'admin-1466211596-14662119397006244', 1, 1, 'SR', NULL, NULL, NULL),
(698, '2016-06-18 09:05:39', NULL, NULL, 259, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 09:05:39', 'admin-1466211596-14662119397006244', 1, 1, 'SR', NULL, NULL, NULL),
(699, '2016-06-18 09:07:49', NULL, NULL, 260, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 09:07:49', 'admin-1466211596-1466212069168416', 1, 0, '', NULL, NULL, NULL),
(700, '2016-06-18 09:07:49', NULL, NULL, 260, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 09:07:49', 'admin-1466211596-1466212069168416', 1, 1, 'SR', NULL, NULL, NULL),
(701, '2016-06-18 09:07:49', NULL, NULL, 260, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 09:07:49', 'admin-1466211596-1466212069168416', 1, 0, '', NULL, NULL, NULL),
(702, '2016-06-18 09:07:49', NULL, NULL, 260, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 09:07:49', 'admin-1466211596-1466212069168416', 1, 1, 'SR', NULL, NULL, NULL),
(703, '2016-06-18 09:07:49', NULL, NULL, 260, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 09:07:49', 'admin-1466211596-1466212069168416', 1, 1, 'SR', NULL, NULL, NULL),
(704, '2016-06-18 09:33:19', NULL, NULL, 259, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 09:33:19', 'admin-1466211596-14662135997823796', 1, 0, '', NULL, NULL, NULL),
(705, '2016-06-18 09:09:29', NULL, NULL, 259, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 09:09:29', 'admin-1466211596-1466212168927138', 1, 1, 'SR', NULL, NULL, NULL),
(706, '2016-06-18 09:32:38', NULL, NULL, 260, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 09:32:38', 'admin-1466211596-14662135585659241', 1, 0, '', NULL, NULL, NULL),
(707, '2016-06-18 09:32:57', NULL, NULL, 259, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 09:32:57', 'admin-1466211596-14662135770154888', 1, 1, 'SR', NULL, NULL, NULL),
(708, '2016-06-18 09:40:54', NULL, NULL, 261, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 09:40:54', 'admin-1466211596-14662140545632585', 1, 0, '', NULL, NULL, NULL),
(709, '2016-06-18 09:40:54', NULL, NULL, 261, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 09:40:54', 'admin-1466211596-14662140545632585', 1, 0, '', NULL, NULL, NULL),
(710, '2016-06-18 09:44:05', NULL, NULL, 262, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 09:44:05', 'Staff-1466214196-14662142457084827', 1, 0, '', NULL, NULL, NULL),
(711, '2016-06-18 09:44:05', NULL, NULL, 262, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 09:44:05', 'Staff-1466214196-14662142457084827', 1, 0, '', NULL, NULL, NULL),
(712, '2016-06-18 09:44:05', NULL, NULL, 262, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 09:44:05', 'Staff-1466214196-14662142457084827', 1, 0, '', NULL, NULL, NULL),
(713, '2016-06-18 09:44:05', NULL, NULL, 262, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 09:44:05', 'Staff-1466214196-14662142457084827', 1, 1, 'SR', NULL, NULL, NULL),
(714, '2016-06-18 09:44:05', NULL, NULL, 262, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 09:44:05', 'Staff-1466214196-14662142457084827', 1, 1, 'SR', NULL, NULL, NULL),
(715, '2016-06-18 09:44:05', NULL, NULL, 262, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 09:44:05', 'Staff-1466214196-14662142457084827', 1, 1, 'SR', NULL, NULL, NULL),
(716, '2016-06-18 11:25:35', NULL, NULL, 276, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:25:35', 'admin-1466218339-14662203353074356', 1, 1, 'SR', NULL, NULL, NULL),
(717, '2016-06-18 11:25:35', NULL, NULL, 276, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:25:35', 'admin-1466218339-14662203353074356', 1, 1, 'SR', NULL, NULL, NULL),
(718, '2016-06-18 11:25:35', NULL, NULL, 276, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:25:35', 'admin-1466218339-14662203353074356', 1, 0, '', NULL, NULL, NULL),
(719, '2016-06-18 11:25:35', NULL, NULL, 276, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:25:35', 'admin-1466218339-14662203353074356', 1, 0, '', NULL, NULL, NULL),
(720, '2016-06-18 11:32:38', NULL, NULL, 277, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:32:38', 'admin-1466218339-14662207587577660', 1, 1, 'SR', NULL, NULL, NULL),
(721, '2016-06-18 11:32:38', NULL, NULL, 277, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:32:38', 'admin-1466218339-14662207587577660', 1, 1, 'SR', NULL, NULL, NULL),
(722, '2016-06-18 11:32:38', NULL, NULL, 277, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:32:38', 'admin-1466218339-14662207587577660', 1, 1, 'SR', NULL, NULL, NULL),
(723, '2016-06-18 11:32:38', NULL, NULL, 277, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:32:38', 'admin-1466218339-14662207587577660', 1, 1, 'SR', NULL, NULL, NULL),
(724, '2016-06-18 11:34:28', NULL, NULL, 278, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:34:28', 'admin-1466218339-14662208686905079', 1, 0, '', NULL, NULL, NULL),
(725, '2016-06-18 11:53:21', NULL, NULL, 280, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:53:21', 'admin-1466218339-14662220017892767', 1, 1, 'SR', NULL, NULL, NULL),
(726, '2016-06-18 11:42:20', NULL, NULL, 279, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:42:20', 'admin-1466218339-14662213403594491', 1, 0, '', NULL, NULL, NULL),
(727, '2016-06-18 11:42:20', NULL, NULL, 279, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:42:20', 'admin-1466218339-14662213403594491', 1, 1, 'SR', NULL, NULL, NULL),
(728, '2016-06-18 11:43:46', NULL, NULL, 267, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:43:46', 'admin-1466218339-14662214260138387', 1, 0, '', NULL, NULL, NULL),
(729, '2016-06-18 11:59:25', NULL, NULL, 279, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:59:25', 'admin-1466218339-1466222365622457', 1, 0, '', NULL, NULL, NULL),
(730, '2016-06-18 11:53:21', NULL, NULL, 280, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:53:21', 'admin-1466218339-14662220017892767', 1, 0, '', NULL, NULL, NULL),
(731, '2016-06-18 11:56:10', NULL, NULL, 281, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:56:10', 'admin-1466218339-14662221704926698', 1, 0, '', NULL, NULL, NULL),
(732, '2016-06-18 11:56:10', NULL, NULL, 281, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:56:10', 'admin-1466218339-14662221704926698', 1, 0, '', NULL, NULL, NULL),
(733, '2016-06-18 11:56:10', NULL, NULL, 281, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:56:10', 'admin-1466218339-14662221704926698', 1, 1, 'SR', NULL, NULL, NULL),
(734, '2016-06-18 11:56:10', NULL, NULL, 281, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:56:10', 'admin-1466218339-14662221704926698', 1, 1, 'SR', NULL, NULL, NULL),
(735, '2016-06-18 11:57:55', NULL, NULL, 282, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:57:55', 'admin-1466218339-146622227484725', 1, 0, '', NULL, NULL, NULL),
(736, '2016-06-18 11:58:52', NULL, NULL, 281, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 11:58:52', 'admin-1466218339-14662223322049613', 1, 0, '', NULL, NULL, NULL),
(737, '2016-06-18 12:03:55', NULL, NULL, 282, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 12:03:55', 'admin-1466218339-14662226357953945', 1, 1, 'SR', NULL, NULL, NULL),
(738, '2016-06-18 12:06:14', NULL, NULL, 283, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 12:06:14', 'admin-1466218339-14662227745678666', 1, 0, '', NULL, NULL, NULL),
(739, '2016-06-18 12:06:14', NULL, NULL, 283, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 12:06:14', 'admin-1466218339-14662227745678666', 1, 1, 'SR', NULL, NULL, NULL),
(740, '2016-06-18 12:06:14', NULL, NULL, 283, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 12:06:14', 'admin-1466218339-14662227745678666', 1, 0, '', NULL, NULL, NULL),
(741, '2016-06-18 12:07:02', NULL, NULL, 279, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 12:07:02', 'admin-1466218339-14662228222261863', 1, 1, 'SR', NULL, NULL, NULL),
(742, '2016-06-18 12:13:07', NULL, NULL, 284, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 12:13:07', 'admin-1466218339-14662231878107137', 1, 1, 'SR', NULL, NULL, NULL),
(743, '2016-06-18 12:41:33', NULL, NULL, 285, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 12:41:33', 'admin-1466218339-14662248928533685', 1, 1, 'SR', NULL, NULL, NULL),
(744, '2016-06-18 12:41:33', NULL, NULL, 285, NULL, 84, '84', 'Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 12:41:33', 'admin-1466218339-14662248928533685', 1, 1, 'SR', NULL, NULL, NULL),
(745, '2016-06-18 12:42:18', NULL, NULL, 286, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 12:42:18', 'admin-1466218339-14662249380165683', 1, 0, '', NULL, NULL, NULL),
(746, '2016-06-18 12:42:18', NULL, NULL, 286, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 12:42:18', 'admin-1466218339-14662249380165683', 1, 1, 'SR', NULL, NULL, NULL),
(747, '2016-06-18 12:43:28', NULL, NULL, 285, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 12:43:28', 'admin-1466218339-14662250081442493', 1, 1, 'SR', NULL, NULL, NULL),
(748, '2016-06-18 13:08:21', NULL, NULL, 285, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 13:08:21', 'admin-1466218339-14662265017306322', 1, 0, '', NULL, NULL, NULL),
(749, '2016-06-18 10:49:30', NULL, NULL, 271, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 10:49:30', 'admin-1466216375-14662181704985588', 1, 0, '', NULL, NULL, NULL),
(750, '2016-06-18 10:01:06', NULL, NULL, 266, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 10:01:06', 'Staff-1466214196-14662152662063211', 1, 1, 'SR', NULL, NULL, NULL),
(751, '2016-06-18 10:15:55', NULL, NULL, 267, 0, 159, '93', 'Granola ', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 10:15:55', 'Staff-1466214196-14662161557634590', 1, 0, '', NULL, NULL, NULL),
(752, '2016-06-18 09:53:11', NULL, NULL, 264, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 09:53:11', 'Staff-1466214196-14662147917635798', 1, 0, '', NULL, NULL, NULL),
(753, '2016-06-18 09:53:11', NULL, NULL, 264, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 09:53:11', 'Staff-1466214196-14662147917635798', 1, 0, '', NULL, NULL, NULL),
(754, '2016-06-18 09:45:56', NULL, NULL, 263, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 09:45:56', 'Staff-1466214196-1466214355827554', 1, 0, '', NULL, NULL, NULL),
(755, '2016-06-18 09:45:56', NULL, NULL, 263, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 09:45:56', 'Staff-1466214196-1466214355827554', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(756, '2016-06-18 09:45:56', NULL, NULL, 263, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'Staff', '2016-06-18 09:45:56', 'Staff-1466214196-1466214355827554', 1, 1, 'SR', NULL, NULL, NULL),
(757, '2016-06-18 09:05:39', NULL, NULL, 259, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 09:05:39', 'admin-1466211596-14662119397006244', 1, 0, '', NULL, NULL, NULL),
(758, '2016-06-18 09:05:39', NULL, NULL, 259, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 09:05:39', 'admin-1466211596-14662119397006244', 1, 1, 'SR', NULL, NULL, NULL),
(759, '2016-06-18 09:05:39', NULL, NULL, 259, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 09:05:39', 'admin-1466211596-14662119397006244', 1, 0, '', NULL, NULL, NULL),
(760, '2016-06-18 09:05:39', NULL, NULL, 259, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 09:05:39', 'admin-1466211596-14662119397006244', 1, 1, 'SR', NULL, NULL, NULL),
(761, '2016-06-18 09:05:39', NULL, NULL, 259, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466258084', 'admin', '2016-06-18 09:05:39', 'admin-1466211596-14662119397006244', 1, 0, '', NULL, NULL, NULL),
(762, '2016-06-18 19:04:56', NULL, NULL, 301, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 19:04:56', 'lois-1466242801-14662478960337936', 1, 0, '', NULL, NULL, NULL),
(763, '2016-06-18 19:04:56', NULL, NULL, 301, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 19:04:56', 'lois-1466242801-14662478960337936', 1, 1, 'SR', NULL, NULL, NULL),
(764, '2016-06-18 19:05:06', NULL, NULL, 301, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 19:05:06', 'lois-1466242801-1466247906418440', 1, 1, 'SR', NULL, NULL, NULL),
(765, '2016-06-18 19:48:30', NULL, NULL, 301, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 19:48:30', 'lois-1466242801-14662505106256323', 1, 1, 'SR', NULL, NULL, NULL),
(766, '2016-06-18 19:48:30', NULL, NULL, 301, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 19:48:30', 'lois-1466242801-14662505106256323', 1, 0, '', NULL, NULL, NULL),
(767, '2016-06-18 19:48:30', NULL, NULL, 301, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 19:48:30', 'lois-1466242801-14662505106256323', 1, 0, '', NULL, NULL, NULL),
(768, '2016-06-18 19:48:30', NULL, NULL, 301, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 19:48:30', 'lois-1466242801-14662505106256323', 1, 0, '', NULL, NULL, NULL),
(769, '2016-06-18 20:14:43', NULL, NULL, 302, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 20:14:43', 'lois-1466242801-14662520834006978', 1, 1, 'SR', NULL, NULL, NULL),
(770, '2016-06-18 20:14:43', NULL, NULL, 302, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 20:14:43', 'lois-1466242801-14662520834006978', 1, 1, 'SR', NULL, NULL, NULL),
(771, '2016-06-18 20:14:43', NULL, NULL, 302, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 20:14:43', 'lois-1466242801-14662520834006978', 1, 0, '', NULL, NULL, NULL),
(772, '2016-06-18 20:14:43', NULL, NULL, 302, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 20:14:43', 'lois-1466242801-14662520834006978', 1, 1, 'SR', NULL, NULL, NULL),
(773, '2016-06-18 20:14:43', NULL, NULL, 302, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 20:14:43', 'lois-1466242801-14662520834006978', 1, 1, 'SR', NULL, NULL, NULL),
(774, '2016-06-18 20:14:43', NULL, NULL, 302, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 20:14:43', 'lois-1466242801-14662520834006978', 1, 1, 'SR', NULL, NULL, NULL),
(775, '2016-06-18 20:14:43', NULL, NULL, 302, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 20:14:43', 'lois-1466242801-14662520834006978', 1, 0, '', NULL, NULL, NULL),
(776, '2016-06-18 21:01:08', NULL, NULL, 302, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 21:01:08', 'lois-1466242801-1466254868284405', 1, 0, '', NULL, NULL, NULL),
(777, '2016-06-18 21:03:00', NULL, NULL, 302, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 21:03:00', 'lois-1466242801-14662549806334452', 1, 1, 'SR', NULL, NULL, NULL),
(778, '2016-06-18 21:19:23', NULL, NULL, 303, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 2, 17.00, 34.0000, 0.0000, 34.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 21:19:23', 'lois-1466242801-14662559636698287', 1, 1, 'SR', NULL, NULL, NULL),
(779, '2016-06-18 21:19:23', NULL, NULL, 303, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466258084', 'lois', '2016-06-18 21:19:23', 'lois-1466242801-14662559636698287', 1, 1, 'SR', NULL, NULL, NULL),
(780, '2016-06-19 20:36:14', NULL, NULL, 349, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 20:36:14', 'Staff-1466329881-14663397740315638', 1, 1, 'SR', NULL, NULL, NULL),
(781, '2016-06-19 20:36:35', NULL, NULL, 349, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 20:36:35', 'Staff-1466329881-14663397955574515', 1, 0, '', NULL, NULL, NULL),
(782, '2016-06-19 20:36:14', NULL, NULL, 349, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 20:36:14', 'Staff-1466329881-14663397740315638', 1, 1, 'SR', NULL, NULL, NULL),
(783, '2016-06-19 19:48:44', NULL, NULL, 348, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 19:48:44', 'Staff-1466329881-14663369242666465', 1, 1, 'SR', NULL, NULL, NULL),
(784, '2016-06-19 20:36:14', NULL, NULL, 349, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 20:36:14', 'Staff-1466329881-14663397740315638', 1, 0, '', NULL, NULL, NULL),
(785, '2016-06-19 18:38:19', NULL, NULL, 346, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 18:38:19', 'Staff-1466329881-14663326992702890', 1, 0, '', NULL, NULL, NULL),
(786, '2016-06-19 18:39:34', NULL, NULL, 347, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 18:39:34', 'Staff-1466329881-14663327746957984', 1, 1, 'SR', NULL, NULL, NULL),
(787, '2016-06-19 19:48:44', NULL, NULL, 348, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 19:48:44', 'Staff-1466329881-14663369242666465', 1, 1, 'SR', NULL, NULL, NULL),
(788, '2016-06-19 17:54:41', NULL, NULL, 342, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 17:54:41', 'Staff-1466329881-14663300813752445', 1, 1, 'SR', NULL, NULL, NULL),
(789, '2016-06-19 18:21:31', NULL, NULL, 343, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 18:21:31', 'Staff-1466329881-14663316915306839', 1, 1, 'SR', NULL, NULL, NULL),
(790, '2016-06-19 18:22:01', NULL, NULL, 344, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 18:22:01', 'Staff-1466329881-14663317212181679', 1, 1, 'SR', NULL, NULL, NULL),
(791, '2016-06-19 18:22:01', NULL, NULL, 344, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 18:22:01', 'Staff-1466329881-14663317212181679', 1, 0, '', NULL, NULL, NULL),
(792, '2016-06-19 18:33:13', NULL, NULL, 345, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 18:33:13', 'Staff-1466329881-1466332393267957', 1, 1, 'SR', NULL, NULL, NULL),
(793, '2016-06-19 11:50:00', NULL, NULL, 317, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 11:50:00', 'Staff-1466303435-1466308199811336', 1, 0, '', NULL, NULL, '10.0'),
(794, '2016-06-19 11:50:29', NULL, NULL, 318, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 11:50:29', 'Staff-1466303435-14663082294275326', 1, 1, 'SR', NULL, NULL, NULL),
(795, '2016-06-19 11:50:29', NULL, NULL, 318, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 11:50:29', 'Staff-1466303435-14663082294275326', 1, 0, '', NULL, NULL, NULL),
(796, '2016-06-19 11:50:29', NULL, NULL, 318, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 11:50:29', 'Staff-1466303435-14663082294275326', 1, 1, 'SR', NULL, NULL, NULL),
(797, '2016-06-19 12:01:46', NULL, NULL, 319, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:01:46', 'Staff-1466308855-14663089066045683', 1, 1, 'SR', NULL, NULL, NULL),
(798, '2016-06-19 12:01:46', NULL, NULL, 319, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:01:46', 'Staff-1466308855-14663089066045683', 1, 1, 'SR', NULL, NULL, NULL),
(799, '2016-06-19 12:01:46', NULL, NULL, 319, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:01:46', 'Staff-1466308855-14663089066045683', 1, 1, 'SR', NULL, NULL, NULL),
(800, '2016-06-19 12:01:46', NULL, NULL, 319, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:01:46', 'Staff-1466308855-14663089066045683', 1, 0, '', NULL, NULL, NULL),
(801, '2016-06-19 12:01:46', NULL, NULL, 319, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:01:46', 'Staff-1466308855-14663089066045683', 1, 0, '', NULL, NULL, NULL),
(802, '2016-06-19 12:12:12', NULL, NULL, 320, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:12:12', 'Staff-1466308855-14663095324164740', 1, 0, '', NULL, NULL, NULL),
(803, '2016-06-19 12:12:12', NULL, NULL, 320, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:12:12', 'Staff-1466308855-14663095324164740', 1, 1, 'SR', NULL, NULL, NULL),
(804, '2016-06-19 12:14:37', NULL, NULL, 321, 0, 39, '39', 'Mango Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:14:37', 'Staff-1466308855-14663096773569519', 1, 1, 'SR', NULL, NULL, NULL),
(805, '2016-06-19 12:17:34', NULL, NULL, 322, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:17:34', 'Staff-1466308855-14663098542295721', 1, 0, '', NULL, NULL, NULL),
(806, '2016-06-19 12:17:34', NULL, NULL, 322, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:17:34', 'Staff-1466308855-14663098542295721', 1, 1, 'SR', NULL, NULL, NULL),
(807, '2016-06-19 12:17:34', NULL, NULL, 322, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:17:34', 'Staff-1466308855-14663098542295721', 1, 0, '', NULL, NULL, NULL),
(808, '2016-06-19 12:17:34', NULL, NULL, 322, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:17:34', 'Staff-1466308855-14663098542295721', 1, 0, '', NULL, NULL, NULL),
(809, '2016-06-19 12:22:52', NULL, NULL, 323, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:22:52', 'Staff-1466308855-14663101725539168', 1, 1, 'SR', NULL, NULL, NULL),
(810, '2016-06-19 12:32:46', NULL, NULL, 324, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:32:46', 'Staff-1466308855-14663107664846147', 1, 1, 'SR', NULL, NULL, NULL),
(811, '2016-06-19 12:37:51', NULL, NULL, 325, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:37:51', 'Staff-1466308855-1466311071015293', 1, 0, '', NULL, NULL, NULL),
(812, '2016-06-19 12:37:51', NULL, NULL, 325, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:37:51', 'Staff-1466308855-1466311071015293', 1, 0, '', NULL, NULL, NULL),
(813, '2016-06-19 12:37:51', NULL, NULL, 325, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:37:51', 'Staff-1466308855-1466311071015293', 1, 1, 'SR', NULL, NULL, NULL),
(814, '2016-06-19 12:38:10', NULL, NULL, 326, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:38:10', 'Staff-1466308855-14663110904326478', 1, 1, 'SR', NULL, NULL, NULL),
(815, '2016-06-19 12:38:10', NULL, NULL, 326, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:38:10', 'Staff-1466308855-14663110904326478', 1, 1, 'SR', NULL, NULL, NULL),
(816, '2016-06-19 12:40:30', NULL, NULL, 327, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:40:30', 'Staff-1466308855-14663112304455838', 1, 0, '', NULL, NULL, NULL),
(817, '2016-06-19 12:40:30', NULL, NULL, 327, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:40:30', 'Staff-1466308855-14663112304455838', 1, 1, 'SR', NULL, NULL, NULL),
(818, '2016-06-19 12:40:30', NULL, NULL, 327, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:40:30', 'Staff-1466308855-14663112304455838', 1, 1, 'SR', NULL, NULL, NULL),
(819, '2016-06-19 12:47:56', NULL, NULL, 328, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 12:47:56', 'Staff-1466311287-1466311676052659', 1, 1, 'SR', NULL, NULL, NULL),
(820, '2016-06-19 13:58:22', NULL, NULL, 330, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 13:58:22', 'admin-1466314204-14663159025448749', 1, 1, 'SR', NULL, NULL, NULL),
(821, '2016-06-19 13:58:22', NULL, NULL, 330, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 13:58:22', 'admin-1466314204-14663159025448749', 1, 1, 'SR', NULL, NULL, NULL),
(822, '2016-06-19 14:00:32', NULL, NULL, 331, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 14:00:32', 'admin-1466314204-14663160326557335', 1, 0, '', NULL, NULL, NULL),
(823, '2016-06-19 14:00:32', NULL, NULL, 331, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 14:00:32', 'admin-1466314204-14663160326557335', 1, 1, 'SR', NULL, NULL, NULL),
(824, '2016-06-19 14:00:32', NULL, NULL, 331, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 14:00:32', 'admin-1466314204-14663160326557335', 1, 1, 'SR', NULL, NULL, NULL),
(825, '2016-06-19 10:29:56', NULL, NULL, 310, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 10:29:56', 'Staff-1466297541-14663033963934676', 1, 0, '', NULL, NULL, NULL),
(826, '2016-06-19 10:29:56', NULL, NULL, 310, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 10:29:56', 'Staff-1466297541-14663033963934676', 1, 0, '', NULL, NULL, NULL),
(827, '2016-06-19 10:31:35', NULL, NULL, 311, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 10:31:35', 'Staff-1466303435-14663034953343178', 1, 1, 'SR', NULL, NULL, NULL),
(828, '2016-06-19 10:31:35', NULL, NULL, 311, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 10:31:35', 'Staff-1466303435-14663034953343178', 1, 0, '', NULL, NULL, NULL),
(829, '2016-06-19 10:32:30', NULL, NULL, 312, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 10:32:30', 'Staff-1466303435-14663035500858693', 1, 0, '', NULL, NULL, NULL),
(830, '2016-06-19 10:32:30', NULL, NULL, 312, 0, 17, '17', 'Iced Caramel Macchiato ', 'less ice', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 10:32:30', 'Staff-1466303435-14663035500858693', 1, 1, 'SR', NULL, NULL, NULL),
(831, '2016-06-19 10:33:19', NULL, NULL, 313, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 10:33:19', 'Staff-1466303435-14663035998022229', 1, 1, 'SR', NULL, NULL, NULL),
(832, '2016-06-19 10:33:19', NULL, NULL, 313, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 10:33:19', 'Staff-1466303435-14663035998022229', 1, 0, '', NULL, NULL, NULL),
(833, '2016-06-19 10:42:54', NULL, NULL, 314, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 10:42:54', 'Staff-1466303435-14663041747364750', 1, 0, '', NULL, NULL, NULL),
(834, '2016-06-19 10:42:54', NULL, NULL, 314, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 10:42:54', 'Staff-1466303435-14663041747364750', 1, 0, '', NULL, NULL, NULL),
(835, '2016-06-19 10:42:54', NULL, NULL, 314, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 10:42:54', 'Staff-1466303435-14663041747364750', 1, 1, 'SR', NULL, NULL, NULL),
(836, '2016-06-19 10:42:54', NULL, NULL, 314, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 10:42:54', 'Staff-1466303435-14663041747364750', 1, 1, 'SR', NULL, NULL, NULL),
(837, '2016-06-19 10:59:39', NULL, NULL, 315, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 10:59:39', 'Staff-1466303435-1466305179138493', 1, 0, '', NULL, NULL, NULL),
(838, '2016-06-19 10:59:39', NULL, NULL, 315, 0, 15, '15', 'Iced Latte ', 'chill', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 10:59:39', 'Staff-1466303435-1466305179138493', 1, 1, 'SR', NULL, NULL, NULL),
(839, '2016-06-19 10:59:39', NULL, NULL, 315, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 10:59:39', 'Staff-1466303435-1466305179138493', 1, 0, '', NULL, NULL, NULL),
(840, '2016-06-19 11:01:54', NULL, NULL, 316, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 11:01:54', 'Staff-1466303435-14663053140825484', 1, 1, 'SR', NULL, NULL, NULL),
(841, '2016-06-19 11:01:54', NULL, NULL, 316, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 11:01:54', 'Staff-1466303435-14663053140825484', 1, 1, 'SR', NULL, NULL, NULL),
(842, '2016-06-19 11:01:54', NULL, NULL, 316, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 11:01:54', 'Staff-1466303435-14663053140825484', 1, 0, '', NULL, NULL, NULL),
(843, '2016-06-19 11:01:54', NULL, NULL, 316, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 11:01:54', 'Staff-1466303435-14663053140825484', 1, 0, '', NULL, NULL, NULL),
(844, '2016-06-19 11:49:59', NULL, NULL, 317, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 11:49:59', 'Staff-1466303435-1466308199811336', 1, 1, 'SR', NULL, NULL, '10.0'),
(845, '2016-06-19 14:01:21', NULL, NULL, 332, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 14:01:21', 'admin-1466314204-14663160816518144', 1, 0, '', NULL, NULL, NULL),
(846, '2016-06-19 14:01:21', NULL, NULL, 332, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 14:01:21', 'admin-1466314204-14663160816518144', 1, 1, 'SR', NULL, NULL, NULL),
(847, '2016-06-19 14:12:30', NULL, NULL, 334, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 14:12:30', 'admin-1466314204-14663167501247821', 1, 0, '', NULL, NULL, NULL),
(848, '2016-06-19 14:21:42', NULL, NULL, 336, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 14:21:42', 'admin-1466314204-14663173018363613', 1, 1, 'SR', NULL, NULL, NULL),
(849, '2016-06-19 14:21:42', NULL, NULL, 336, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 14:21:42', 'admin-1466314204-14663173018363613', 1, 1, 'SR', NULL, NULL, NULL),
(850, '2016-06-19 14:36:54', NULL, NULL, 337, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 14:36:54', 'admin-1466314204-14663182140965496', 1, 1, 'SR', NULL, NULL, NULL),
(851, '2016-06-19 14:36:54', NULL, NULL, 337, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 14:36:54', 'admin-1466314204-14663182140965496', 1, 1, 'SR', NULL, NULL, NULL),
(852, '2016-06-19 14:41:43', NULL, NULL, 338, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 14:41:43', 'admin-1466314204-146631850294478', 1, 1, 'SR', NULL, NULL, NULL),
(853, '2016-06-19 14:41:43', NULL, NULL, 338, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 14:41:43', 'admin-1466314204-146631850294478', 1, 1, 'SR', NULL, NULL, NULL),
(854, '2016-06-19 14:59:31', NULL, NULL, 339, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 14:59:31', 'admin-1466314204-14663195715004672', 1, 1, 'SR', NULL, NULL, NULL),
(855, '2016-06-19 14:59:31', NULL, NULL, 339, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 14:59:31', 'admin-1466314204-14663195715004672', 1, 0, '', NULL, NULL, NULL),
(856, '2016-06-19 14:59:31', NULL, NULL, 339, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 14:59:31', 'admin-1466314204-14663195715004672', 1, 1, 'SR', NULL, NULL, NULL),
(857, '2016-06-19 14:59:42', NULL, NULL, 339, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 14:59:42', 'admin-1466314204-14663195827002041', 1, 1, 'SR', NULL, NULL, NULL),
(858, '2016-06-19 16:50:44', NULL, NULL, 340, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 16:50:44', 'admin-1466314204-14663262440342443', 1, 0, '', NULL, NULL, NULL),
(859, '2016-06-19 16:50:44', NULL, NULL, 340, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 16:50:44', 'admin-1466314204-14663262440342443', 1, 1, 'SR', NULL, NULL, NULL),
(860, '2016-06-19 16:50:44', NULL, NULL, 340, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 16:50:44', 'admin-1466314204-14663262440342443', 1, 1, 'SR', NULL, NULL, NULL),
(861, '2016-06-19 16:50:44', NULL, NULL, 340, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 16:50:44', 'admin-1466314204-14663262440342443', 1, 1, 'SR', NULL, NULL, NULL),
(862, '2016-06-19 16:50:44', NULL, NULL, 340, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 16:50:44', 'admin-1466314204-14663262440342443', 1, 1, 'SR', NULL, NULL, NULL),
(863, '2016-06-19 16:50:44', NULL, NULL, 340, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 16:50:44', 'admin-1466314204-14663262440342443', 1, 0, '', NULL, NULL, NULL),
(864, '2016-06-19 16:50:44', NULL, NULL, 340, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 16:50:44', 'admin-1466314204-14663262440342443', 1, 0, '', NULL, NULL, NULL),
(865, '2016-06-19 17:15:19', NULL, NULL, 340, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 17:15:19', 'admin-1466314204-14663277197534485', 1, 0, '', NULL, NULL, NULL),
(866, '2016-06-19 17:15:19', NULL, NULL, 340, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 2, 14.00, 28.0000, 0.0000, 28.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 17:15:19', 'admin-1466314204-14663277197534485', 1, 1, 'SR', NULL, NULL, NULL),
(867, '2016-06-19 17:15:19', NULL, NULL, 340, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 17:15:19', 'admin-1466314204-14663277197534485', 1, 1, 'SR', NULL, NULL, NULL),
(868, '2016-06-19 17:15:19', NULL, NULL, 340, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 17:15:19', 'admin-1466314204-14663277197534485', 1, 0, '', NULL, NULL, NULL),
(869, '2016-06-19 17:15:19', NULL, NULL, 340, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 17:15:19', 'admin-1466314204-14663277197534485', 1, 0, '', NULL, NULL, NULL),
(870, '2016-06-19 17:44:38', NULL, NULL, 341, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 17:44:38', 'admin-1466327744-14663294779377799', 1, 1, 'SR', NULL, NULL, NULL),
(871, '2016-06-19 17:44:38', NULL, NULL, 341, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 17:44:38', 'admin-1466327744-14663294779377799', 1, 0, '', NULL, NULL, NULL),
(872, '2016-06-19 17:54:41', NULL, NULL, 342, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 17:54:41', 'Staff-1466329881-14663300813752445', 1, 1, 'SR', NULL, NULL, NULL),
(873, '2016-06-19 17:54:41', NULL, NULL, 342, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 17:54:41', 'Staff-1466329881-14663300813752445', 1, 0, '', NULL, NULL, NULL),
(874, '2016-06-19 17:54:41', NULL, NULL, 342, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 17:54:41', 'Staff-1466329881-14663300813752445', 1, 0, '', NULL, NULL, NULL),
(875, '2016-06-19 17:54:41', NULL, NULL, 342, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 17:54:41', 'Staff-1466329881-14663300813752445', 1, 0, '', NULL, NULL, NULL),
(876, '2016-06-19 17:54:41', NULL, NULL, 342, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 17:54:41', 'Staff-1466329881-14663300813752445', 1, 1, 'SR', NULL, NULL, NULL),
(877, '2016-06-19 17:54:41', NULL, NULL, 342, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 17:54:41', 'Staff-1466329881-14663300813752445', 1, 1, 'SR', NULL, NULL, NULL),
(878, '2016-06-19 14:07:13', NULL, NULL, 333, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 14:07:13', 'admin-1466314204-14663164330903770', 1, 1, 'SR', NULL, NULL, NULL),
(879, '2016-06-19 14:00:32', NULL, NULL, 331, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466329881', 'admin', '2016-06-19 14:00:32', 'admin-1466314204-14663160326557335', 1, 0, '', NULL, NULL, NULL),
(880, '2016-06-19 11:49:59', NULL, NULL, 317, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 11:49:59', 'Staff-1466303435-1466308199811336', 1, 0, '', NULL, NULL, '10.0'),
(881, '2016-06-19 11:49:59', NULL, NULL, 317, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 11:49:59', 'Staff-1466303435-1466308199811336', 1, 1, 'SR', NULL, NULL, '10.0'),
(882, '2016-06-19 11:49:59', NULL, NULL, 317, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 11:49:59', 'Staff-1466303435-1466308199811336', 1, 0, '', NULL, NULL, '10.0'),
(883, '2016-06-19 11:49:59', NULL, NULL, 317, NULL, 65, '65', 'Pineapple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 11:49:59', 'Staff-1466303435-1466308199811336', 1, 1, 'SR', NULL, NULL, '10.0'),
(884, '2016-06-19 11:49:59', NULL, NULL, 317, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 11:49:59', 'Staff-1466303435-1466308199811336', 1, 1, 'SR', NULL, NULL, '10.0'),
(885, '2016-06-19 11:49:59', NULL, NULL, 317, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 11:49:59', 'Staff-1466303435-1466308199811336', 1, 1, 'SR', NULL, NULL, '10.0'),
(886, '2016-06-19 11:49:59', NULL, NULL, 317, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 11:49:59', 'Staff-1466303435-1466308199811336', 1, 1, 'SR', NULL, NULL, '10.0'),
(887, '2016-06-19 11:49:59', NULL, NULL, 317, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 11:49:59', 'Staff-1466303435-1466308199811336', 1, 1, 'SR', NULL, NULL, '10.0'),
(888, '2016-06-19 10:27:20', NULL, NULL, 309, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 10:27:20', 'Staff-1466297541-14663032398113921', 1, 1, 'SR', NULL, NULL, NULL),
(889, '2016-06-19 10:27:20', NULL, NULL, 309, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 10:27:20', 'Staff-1466297541-14663032398113921', 1, 1, 'SR', NULL, NULL, NULL),
(890, '2016-06-19 10:27:20', NULL, NULL, 309, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 10:27:20', 'Staff-1466297541-14663032398113921', 1, 1, 'SR', NULL, NULL, NULL),
(891, '2016-06-19 10:27:20', NULL, NULL, 309, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 10:27:20', 'Staff-1466297541-14663032398113921', 1, 0, '', NULL, NULL, NULL),
(892, '2016-06-19 10:27:19', NULL, NULL, 309, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 10:27:19', 'Staff-1466297541-14663032398113921', 1, 0, '', NULL, NULL, NULL),
(893, '2016-06-19 10:27:19', NULL, NULL, 309, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 10:27:19', 'Staff-1466297541-14663032398113921', 1, 0, '', NULL, NULL, NULL),
(894, '2016-06-19 09:55:28', NULL, NULL, 308, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 09:55:28', 'Staff-1466297541-14663013278065035', 1, 1, 'SR', NULL, NULL, NULL),
(895, '2016-06-19 09:35:44', NULL, NULL, 307, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 09:35:44', 'Staff-1466297541-14663001439053055', 1, 1, 'SR', NULL, NULL, NULL),
(896, '2016-06-19 09:35:44', NULL, NULL, 307, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 09:35:44', 'Staff-1466297541-14663001439053055', 1, 1, 'SR', NULL, NULL, NULL),
(897, '2016-06-19 09:35:44', NULL, NULL, 307, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 09:35:44', 'Staff-1466297541-14663001439053055', 1, 0, '', NULL, NULL, NULL),
(898, '2016-06-19 09:35:44', NULL, NULL, 307, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 09:35:44', 'Staff-1466297541-14663001439053055', 1, 0, '', NULL, NULL, NULL),
(899, '2016-06-19 09:26:46', NULL, NULL, 306, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 09:26:46', 'Staff-1466297541-14662996062322995', 1, 1, 'SR', NULL, NULL, NULL),
(900, '2016-06-19 09:24:50', NULL, NULL, 305, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 09:24:50', 'Staff-1466297541-14662994900168484', 1, 0, '', NULL, NULL, NULL),
(901, '2016-06-19 09:24:50', NULL, NULL, 305, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 09:24:50', 'Staff-1466297541-14662994900168484', 1, 1, 'SR', NULL, NULL, NULL),
(902, '2016-06-19 09:24:50', NULL, NULL, 305, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 09:24:50', 'Staff-1466297541-14662994900168484', 1, 0, '', NULL, NULL, NULL),
(903, '2016-06-19 09:20:34', NULL, NULL, 304, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 09:20:34', 'Staff-1466297541-14662992339673284', 1, 1, 'SR', NULL, NULL, NULL),
(904, '2016-06-19 09:26:46', NULL, NULL, 306, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 09:26:46', 'Staff-1466297541-14662996062322995', 1, 0, '', NULL, NULL, NULL),
(905, '2016-06-19 09:26:46', NULL, NULL, 306, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 09:26:46', 'Staff-1466297541-14662996062322995', 1, 0, '', NULL, NULL, NULL),
(906, '2016-06-19 09:24:50', NULL, NULL, 305, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 09:24:50', 'Staff-1466297541-14662994900168484', 1, 1, 'SR', NULL, NULL, NULL),
(907, '2016-06-19 09:20:34', NULL, NULL, 304, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466329881', 'Staff', '2016-06-19 09:20:34', 'Staff-1466297541-14662992339673284', 1, 0, '', NULL, NULL, NULL),
(908, '2016-06-20 19:41:23', NULL, NULL, 378, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 19:41:23', 'admin-1466406496-14664228831887140', 1, 0, '', NULL, NULL, NULL),
(909, '2016-06-20 19:58:50', NULL, NULL, 379, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 19:58:50', 'admin-1466406496-14664239303742043', 1, 0, '', NULL, NULL, NULL),
(910, '2016-06-20 20:03:31', NULL, NULL, 380, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 20:03:31', 'admin-1466406496-14664242111403027', 1, 1, 'SR', NULL, NULL, NULL),
(911, '2016-06-20 20:03:31', NULL, NULL, 380, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 20:03:31', 'admin-1466406496-14664242111403027', 1, 1, 'SR', NULL, NULL, NULL),
(912, '2016-06-20 20:48:46', NULL, NULL, 380, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 20:48:46', 'admin-1466406496-14664269265126236', 1, 1, 'SR', NULL, NULL, NULL),
(913, '2016-06-20 18:14:17', NULL, NULL, 375, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 18:14:17', 'admin-1466406496-14664176576431729', 1, 1, 'SR', 1, NULL, NULL),
(914, '2016-06-20 14:51:10', NULL, NULL, 370, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 14:51:10', 'admin-1466404225-14664054702268086', 1, 0, '', NULL, NULL, NULL),
(915, '2016-06-20 14:52:29', NULL, NULL, 370, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 14:52:29', 'admin-1466404225-14664055492211981', 1, 0, '', NULL, NULL, NULL),
(916, '2016-06-20 15:50:14', NULL, NULL, 371, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 15:50:14', 'admin-1466406496-14664090140194552', 1, 1, 'SR', NULL, NULL, NULL),
(917, '2016-06-20 15:50:14', NULL, NULL, 371, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 15:50:14', 'admin-1466406496-14664090140194552', 1, 1, 'SR', NULL, NULL, NULL),
(918, '2016-06-20 16:23:27', NULL, NULL, 373, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 16:23:27', 'admin-1466406496-1466411007474459', 1, 1, 'SR', 1, NULL, NULL),
(919, '2016-06-20 12:14:44', NULL, NULL, 360, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466430470', 'Staff', '2016-06-20 12:14:44', 'Staff-1466385425-14663960839912348', 1, 1, 'SR', NULL, NULL, NULL),
(920, '2016-06-20 12:18:02', NULL, NULL, 361, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 12:18:02', 'admin-1466396248-14663962823922042', 1, 0, '', NULL, NULL, NULL),
(921, '2016-06-20 12:18:02', NULL, NULL, 361, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 12:18:02', 'admin-1466396248-14663962823922042', 1, 1, 'SR', NULL, NULL, NULL),
(922, '2016-06-20 12:18:38', NULL, NULL, 362, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 12:18:38', 'admin-1466396248-14663963184669715', 1, 1, 'SR', NULL, NULL, NULL),
(923, '2016-06-20 12:18:38', NULL, NULL, 362, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 12:18:38', 'admin-1466396248-14663963184669715', 1, 0, '', NULL, NULL, NULL),
(924, '2016-06-20 12:20:09', NULL, NULL, 363, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 12:20:09', 'admin-1466396248-14663964097502273', 1, 1, 'SR', NULL, NULL, NULL),
(925, '2016-06-20 12:20:09', NULL, NULL, 363, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 12:20:09', 'admin-1466396248-14663964097502273', 1, 1, 'SR', NULL, NULL, NULL),
(926, '2016-06-20 12:20:09', NULL, NULL, 363, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 12:20:09', 'admin-1466396248-14663964097502273', 1, 1, 'SR', NULL, NULL, NULL),
(927, '2016-06-20 12:20:29', NULL, NULL, 364, 0, 39, '39', 'Mango Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 12:20:29', 'admin-1466396248-14663964289454066', 1, 1, 'SR', NULL, NULL, NULL),
(928, '2016-06-20 12:58:43', NULL, NULL, 365, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 12:58:43', 'admin-1466396248-14663987233764491', 1, 1, 'SR', NULL, NULL, NULL),
(929, '2016-06-20 13:04:16', NULL, NULL, 363, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 13:04:16', 'admin-1466396248-14663990565975237', 1, 0, '', NULL, NULL, NULL),
(930, '2016-06-20 13:07:44', NULL, NULL, 366, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 13:07:44', 'admin-1466396248-14663992641405736', 1, 1, 'SR', NULL, NULL, NULL),
(931, '2016-06-20 13:53:18', NULL, NULL, 367, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 13:53:18', 'admin-1466396248-14664019981732584', 1, 0, '', NULL, NULL, NULL),
(932, '2016-06-20 13:53:18', NULL, NULL, 367, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 13:53:18', 'admin-1466396248-14664019981732584', 1, 0, '', NULL, NULL, NULL),
(933, '2016-06-20 13:53:18', NULL, NULL, 367, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 13:53:18', 'admin-1466396248-14664019981732584', 1, 1, 'SR', NULL, NULL, NULL),
(934, '2016-06-20 13:53:18', NULL, NULL, 367, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 13:53:18', 'admin-1466396248-14664019981732584', 1, 1, 'SR', NULL, NULL, NULL),
(935, '2016-06-20 14:19:54', NULL, NULL, 368, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 14:19:54', 'admin-1466396248-14664035941458960', 1, 1, 'SR', NULL, NULL, NULL),
(936, '2016-06-20 14:19:54', NULL, NULL, 368, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 14:19:54', 'admin-1466396248-14664035941458960', 1, 1, 'SR', NULL, NULL, NULL),
(937, '2016-06-20 14:19:54', NULL, NULL, 368, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 14:19:54', 'admin-1466396248-14664035941458960', 1, 1, 'SR', NULL, NULL, NULL),
(938, '2016-06-20 14:29:44', NULL, NULL, 369, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 14:29:44', 'admin-1466396248-1466404183974638', 1, 1, 'SR', NULL, NULL, NULL),
(939, '2016-06-20 19:41:23', NULL, NULL, 378, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 19:41:23', 'admin-1466406496-14664228831887140', 1, 0, '', NULL, NULL, NULL),
(940, '2016-06-20 18:33:42', NULL, NULL, 377, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 18:33:42', 'admin-1466406496-14664188217503288', 1, 1, 'SR', 1, NULL, NULL),
(941, '2016-06-20 18:33:42', NULL, NULL, 377, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 18:33:42', 'admin-1466406496-14664188217503288', 1, 1, 'SR', 1, NULL, NULL),
(942, '2016-06-20 18:14:56', NULL, NULL, 376, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 18:14:56', 'admin-1466406496-14664176963138080', 1, 1, 'SR', 1, NULL, NULL),
(943, '2016-06-20 17:46:08', NULL, NULL, 374, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 17:46:08', 'admin-1466406496-146641596834117', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(944, '2016-06-20 14:51:10', NULL, NULL, 370, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 14:51:10', 'admin-1466404225-14664054702268086', 1, 1, 'SR', NULL, NULL, NULL),
(945, '2016-06-20 14:51:10', NULL, NULL, 370, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 14:51:10', 'admin-1466404225-14664054702268086', 1, 0, '', NULL, NULL, NULL),
(946, '2016-06-20 14:51:10', NULL, NULL, 370, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 14:51:10', 'admin-1466404225-14664054702268086', 1, 1, 'SR', NULL, NULL, NULL),
(947, '2016-06-20 14:51:10', NULL, NULL, 370, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466430470', 'admin', '2016-06-20 14:51:10', 'admin-1466404225-14664054702268086', 1, 0, '', NULL, NULL, NULL),
(948, '2016-06-20 12:13:00', NULL, NULL, 358, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466430470', 'Staff', '2016-06-20 12:13:00', 'Staff-1466385425-1466395980125635', 1, 1, 'SR', NULL, NULL, NULL),
(949, '2016-06-20 12:13:54', NULL, NULL, 359, 0, 159, '93', 'Granola ', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466430470', 'Staff', '2016-06-20 12:13:54', 'Staff-1466385425-14663960346771012', 1, 0, '', NULL, NULL, NULL),
(950, '2016-06-20 12:14:44', NULL, NULL, 360, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466430470', 'Staff', '2016-06-20 12:14:44', 'Staff-1466385425-14663960839912348', 1, 0, '', NULL, NULL, NULL),
(951, '2016-06-20 12:13:00', NULL, NULL, 358, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466430470', 'Staff', '2016-06-20 12:13:00', 'Staff-1466385425-1466395980125635', 1, 0, '', NULL, NULL, NULL),
(952, '2016-06-20 12:12:05', NULL, NULL, 357, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466430470', 'Staff', '2016-06-20 12:12:05', 'Staff-1466385425-14663959248971444', 1, 1, 'SR', NULL, NULL, NULL),
(953, '2016-06-20 12:11:37', NULL, NULL, 356, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466430470', 'Staff', '2016-06-20 12:11:37', 'Staff-1466385425-14663958969861315', 1, 1, 'SR', NULL, NULL, NULL),
(954, '2016-06-20 12:10:38', NULL, NULL, 355, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466430470', 'Staff', '2016-06-20 12:10:38', 'Staff-1466385425-14663958380094857', 1, 0, '', NULL, NULL, NULL),
(955, '2016-06-20 11:36:17', NULL, NULL, 354, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466430470', 'Staff', '2016-06-20 11:36:17', 'Staff-1466385425-14663937776357433', 1, 1, 'SR', NULL, NULL, NULL),
(956, '2016-06-20 12:10:38', NULL, NULL, 355, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466430470', 'Staff', '2016-06-20 12:10:38', 'Staff-1466385425-14663958380094857', 1, 1, 'SR', NULL, NULL, NULL),
(957, '2016-06-20 11:15:41', NULL, NULL, 353, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466430470', 'Staff', '2016-06-20 11:15:41', 'Staff-1466385425-14663925407541392', 1, 1, 'SR', NULL, NULL, NULL),
(958, '2016-06-20 11:15:41', NULL, NULL, 353, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466430470', 'Staff', '2016-06-20 11:15:41', 'Staff-1466385425-14663925407541392', 1, 0, '', NULL, NULL, NULL),
(959, '2016-06-20 11:15:40', NULL, NULL, 353, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466430470', 'Staff', '2016-06-20 11:15:40', 'Staff-1466385425-14663925407541392', 1, 1, 'SR', NULL, NULL, NULL),
(960, '2016-06-20 11:15:40', NULL, NULL, 353, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466430470', 'Staff', '2016-06-20 11:15:40', 'Staff-1466385425-14663925407541392', 1, 0, '', NULL, NULL, NULL),
(961, '2016-06-20 10:36:16', NULL, NULL, 350, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466430470', 'Staff', '2016-06-20 10:36:16', 'Staff-1466385425-14663901761104477', 1, 0, '', NULL, NULL, NULL),
(962, '2016-06-20 11:13:17', NULL, NULL, 351, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466430470', 'Staff', '2016-06-20 11:13:17', 'Staff-1466385425-1466392397251751', 1, 1, 'SR', NULL, NULL, NULL),
(963, '2016-06-20 11:14:01', NULL, NULL, 352, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466430470', 'Staff', '2016-06-20 11:14:01', 'Staff-1466385425-1466392440910717', 1, 1, 'SR', NULL, NULL, NULL),
(964, '2016-06-20 11:14:01', NULL, NULL, 352, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466430470', 'Staff', '2016-06-20 11:14:01', 'Staff-1466385425-1466392440910717', 1, 1, 'SR', NULL, NULL, NULL),
(965, '2016-06-20 11:14:01', NULL, NULL, 352, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466430470', 'Staff', '2016-06-20 11:14:01', 'Staff-1466385425-1466392440910717', 1, 0, '', NULL, NULL, NULL),
(966, '2016-06-20 11:15:40', NULL, NULL, 353, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466430470', 'Staff', '2016-06-20 11:15:40', 'Staff-1466385425-14663925407541392', 1, 1, 'SR', NULL, NULL, NULL),
(967, '2016-06-20 11:14:01', NULL, NULL, 352, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466430470', 'Staff', '2016-06-20 11:14:01', 'Staff-1466385425-1466392440910717', 1, 0, '', NULL, NULL, NULL),
(968, '2016-06-20 10:36:16', NULL, NULL, 350, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466430470', 'Staff', '2016-06-20 10:36:16', 'Staff-1466385425-14663901761104477', 1, 1, 'SR', NULL, NULL, NULL),
(969, '2016-06-21 16:14:48', NULL, NULL, 409, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 16:14:48', 'admin-1466487575-14664968878331230', 1, 1, 'SR', 1, NULL, NULL),
(970, '2016-06-21 16:42:16', NULL, NULL, 410, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 16:42:16', 'admin-1466487575-14664985358096038', 1, 1, 'SR', 1, NULL, NULL),
(971, '2016-06-21 16:42:16', NULL, NULL, 410, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 16:42:16', 'admin-1466487575-14664985358096038', 1, 0, '', 1, NULL, NULL),
(972, '2016-06-21 17:29:03', NULL, NULL, 411, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 17:29:03', 'admin-1466487575-14665013428578093', 1, 0, '', 1, NULL, NULL),
(973, '2016-06-21 17:54:41', NULL, NULL, 412, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 17:54:41', 'admin-1466487575-14665028811576487', 1, 0, '', NULL, NULL, NULL),
(974, '2016-06-21 17:54:41', NULL, NULL, 412, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 17:54:41', 'admin-1466487575-14665028811576487', 1, 1, 'SR', NULL, NULL, NULL),
(975, '2016-06-21 18:25:55', NULL, NULL, 413, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 18:25:55', 'admin-1466487575-1466504755262785', 1, 1, 'SR', NULL, NULL, NULL),
(976, '2016-06-21 18:26:06', NULL, NULL, 414, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 18:26:06', 'admin-1466487575-1466504766298422', 1, 1, 'SR', NULL, NULL, NULL),
(977, '2016-06-21 19:07:02', NULL, NULL, 415, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 19:07:02', 'admin-1466487575-14665072220067477', 1, 1, 'SR', 1, NULL, NULL),
(978, '2016-06-21 19:07:02', NULL, NULL, 415, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 19:07:02', 'admin-1466487575-14665072220067477', 1, 0, '', 1, NULL, NULL),
(979, '2016-06-21 19:20:53', NULL, NULL, 414, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 19:20:53', 'admin-1466487575-14665080533485058', 1, 1, 'SR', NULL, NULL, NULL),
(980, '2016-06-21 19:21:20', NULL, NULL, 412, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 19:21:20', 'admin-1466487575-14665080805628288', 1, 1, 'SR', NULL, NULL, NULL),
(981, '2016-06-21 19:59:21', NULL, NULL, 417, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 19:59:21', 'admin-1466510328-14665103612918713', 1, 1, 'SR', 1, NULL, NULL),
(982, '2016-06-21 20:00:33', NULL, NULL, 418, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 20:00:33', 'admin-1466510328-1466510433471431', 1, 1, 'SR', NULL, NULL, NULL),
(983, '2016-06-21 21:13:06', NULL, NULL, 419, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 21:13:06', 'admin-1466510328-1466514786148619', 1, 1, 'SR', NULL, NULL, NULL),
(984, '2016-06-21 21:13:06', NULL, NULL, 419, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 21:13:06', 'admin-1466510328-1466514786148619', 1, 0, '', NULL, NULL, NULL),
(985, '2016-06-21 21:13:06', NULL, NULL, 419, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 21:13:06', 'admin-1466510328-1466514786148619', 1, 1, 'SR', NULL, NULL, NULL),
(986, '2016-06-21 21:13:06', NULL, NULL, 419, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 21:13:06', 'admin-1466510328-1466514786148619', 1, 1, 'SR', NULL, NULL, NULL),
(987, '2016-06-21 21:13:06', NULL, NULL, 419, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 21:13:06', 'admin-1466510328-1466514786148619', 1, 1, 'SR', NULL, NULL, NULL),
(988, '2016-06-21 21:25:19', NULL, NULL, 420, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 21:25:19', 'admin-1466510328-14665155191997652', 1, 1, 'SR', NULL, NULL, NULL),
(989, '2016-06-21 21:25:19', NULL, NULL, 420, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 21:25:19', 'admin-1466510328-14665155191997652', 1, 0, '', NULL, NULL, NULL),
(990, '2016-06-21 21:25:19', NULL, NULL, 420, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 21:25:19', 'admin-1466510328-14665155191997652', 1, 0, '', NULL, NULL, NULL),
(991, '2016-06-21 21:25:19', NULL, NULL, 420, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 21:25:19', 'admin-1466510328-14665155191997652', 1, 1, 'SR', NULL, NULL, NULL),
(992, '2016-06-21 21:25:19', NULL, NULL, 420, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 21:25:19', 'admin-1466510328-14665155191997652', 1, 1, 'SR', NULL, NULL, NULL),
(993, '2016-06-21 21:47:01', NULL, NULL, 421, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 21:47:01', 'admin-1466510328-14665168215519263', 1, 1, 'SR', NULL, NULL, NULL),
(994, '2016-06-21 21:47:01', NULL, NULL, 421, 0, 182, '117', 'Open Drinks ', 'MILK', 'Open', 'Drinks', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 21:47:01', 'admin-1466510328-14665168215519263', 1, 0, '', NULL, NULL, NULL),
(995, '2016-06-21 13:52:19', NULL, NULL, 403, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 13:52:19', 'admin-1466487575-14664883391597127', 1, 1, 'SR', NULL, NULL, NULL),
(996, '2016-06-21 13:52:19', NULL, NULL, 403, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 13:52:19', 'admin-1466487575-14664883391597127', 1, 1, 'SR', NULL, NULL, NULL),
(997, '2016-06-21 14:08:58', NULL, NULL, 404, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 14:08:58', 'admin-1466487575-14664893385384944', 1, 1, 'SR', NULL, NULL, NULL),
(998, '2016-06-21 14:09:07', NULL, NULL, 404, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 14:09:07', 'admin-1466487575-14664893471873914', 1, 1, 'SR', NULL, NULL, NULL),
(999, '2016-06-21 14:29:43', NULL, NULL, 405, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 14:29:43', 'admin-1466487575-14664905834033946', 1, 0, '', NULL, NULL, NULL),
(1000, '2016-06-21 12:37:55', NULL, NULL, 392, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 12:37:55', 'admin-1466470807-14664838752081496', 1, 1, 'SR', NULL, NULL, NULL),
(1001, '2016-06-21 12:37:55', NULL, NULL, 392, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 12:37:55', 'admin-1466470807-14664838752081496', 1, 1, 'SR', NULL, NULL, NULL),
(1002, '2016-06-21 12:44:16', NULL, NULL, 392, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 12:44:16', 'admin-1466470807-14664842565621216', 1, 1, 'SR', NULL, NULL, NULL),
(1003, '2016-06-21 12:44:16', NULL, NULL, 392, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 12:44:16', 'admin-1466470807-14664842565621216', 1, 0, '', NULL, NULL, NULL),
(1004, '2016-06-21 12:59:43', NULL, NULL, 393, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 12:59:43', 'admin-1466470807-14664851834218222', 1, 1, 'SR', NULL, NULL, NULL),
(1005, '2016-06-21 13:00:26', NULL, NULL, 394, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 13:00:26', 'admin-1466470807-14664852267076421', 1, 1, 'SR', NULL, NULL, NULL),
(1006, '2016-06-21 15:55:10', NULL, NULL, 406, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 15:55:10', 'admin-1466487575-14664957098919871', 1, 1, 'SR', NULL, NULL, NULL),
(1007, '2016-06-21 13:17:07', NULL, NULL, 395, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 13:17:07', 'admin-1466470807-14664862272774177', 1, 1, 'SR', NULL, NULL, NULL),
(1008, '2016-06-21 13:36:18', NULL, NULL, 396, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 13:36:18', 'admin-1466470807-146648737871359', 1, 0, '', 1, NULL, NULL),
(1009, '2016-06-21 13:36:18', NULL, NULL, 396, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 13:36:18', 'admin-1466470807-146648737871359', 1, 0, '', 1, NULL, NULL),
(1010, '2016-06-21 13:37:08', NULL, NULL, 397, 0, 38, '38', 'Kiwi Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 13:37:08', 'admin-1466470807-14664874282087522', 1, 1, 'SR', 1, NULL, NULL),
(1011, '2016-06-21 13:37:08', NULL, NULL, 397, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 13:37:08', 'admin-1466470807-14664874282087522', 1, 1, 'SR', 1, NULL, NULL),
(1012, '2016-06-21 13:39:22', NULL, NULL, 398, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 13:39:22', 'admin-1466470807-14664875619833838', 1, 1, 'SR', NULL, NULL, NULL),
(1013, '2016-06-21 13:40:18', NULL, NULL, 399, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 13:40:18', 'admin-1466487575-1466487618621288', 1, 1, 'SR', NULL, NULL, NULL),
(1014, '2016-06-21 13:40:49', NULL, NULL, 400, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 13:40:49', 'admin-1466487575-14664876491728055', 1, 1, 'SR', NULL, NULL, NULL),
(1015, '2016-06-21 13:43:38', NULL, NULL, 401, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 13:43:38', 'admin-1466487575-1466487818115263', 1, 1, 'SR', NULL, NULL, NULL),
(1016, '2016-06-21 13:43:38', NULL, NULL, 401, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 13:43:38', 'admin-1466487575-1466487818115263', 1, 1, 'SR', NULL, NULL, NULL),
(1017, '2016-06-21 13:43:38', NULL, NULL, 401, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 13:43:38', 'admin-1466487575-1466487818115263', 1, 1, 'SR', NULL, NULL, NULL),
(1018, '2016-06-21 13:48:30', NULL, NULL, 402, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 13:48:30', 'admin-1466487575-14664881102569917', 1, 0, '', NULL, NULL, NULL),
(1019, '2016-06-21 13:48:30', NULL, NULL, 402, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 13:48:30', 'admin-1466487575-14664881102569917', 1, 1, 'SR', NULL, NULL, NULL),
(1020, '2016-06-21 21:47:22', NULL, NULL, 422, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 21:47:22', 'admin-1466510328-1466516841913429', 1, 0, '', NULL, NULL, NULL),
(1021, '2016-06-21 21:47:22', NULL, NULL, 422, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 21:47:22', 'admin-1466510328-1466516841913429', 1, 0, '', NULL, NULL, NULL),
(1022, '2016-06-21 16:09:51', NULL, NULL, 408, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 16:09:51', 'admin-1466487575-1466496591826156', 1, 0, '', 1, NULL, NULL),
(1023, '2016-06-21 15:56:06', NULL, NULL, 407, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 15:56:06', 'admin-1466487575-14664957662955157', 1, 1, 'SR', 1, NULL, NULL),
(1024, '2016-06-21 16:09:51', NULL, NULL, 408, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 16:09:51', 'admin-1466487575-1466496591826156', 1, 1, 'SR', 1, NULL, NULL),
(1025, '2016-06-21 15:55:10', NULL, NULL, 406, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 15:55:10', 'admin-1466487575-14664957098919871', 1, 1, 'SR', NULL, NULL, NULL),
(1026, '2016-06-21 15:55:10', NULL, NULL, 406, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 15:55:10', 'admin-1466487575-14664957098919871', 1, 1, 'SR', NULL, NULL, NULL),
(1027, '2016-06-21 13:52:19', NULL, NULL, 403, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 13:52:19', 'admin-1466487575-14664883391597127', 1, 0, '', NULL, NULL, NULL),
(1028, '2016-06-21 13:48:30', NULL, NULL, 402, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 13:48:30', 'admin-1466487575-14664881102569917', 1, 1, 'SR', NULL, NULL, NULL),
(1029, '2016-06-21 13:48:30', NULL, NULL, 402, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 13:48:30', 'admin-1466487575-14664881102569917', 1, 1, 'SR', NULL, NULL, NULL),
(1030, '2016-06-21 13:48:30', NULL, NULL, 402, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 13:48:30', 'admin-1466487575-14664881102569917', 1, 1, 'SR', NULL, NULL, NULL),
(1031, '2016-06-21 12:35:06', NULL, NULL, 391, 0, 181, '116', 'Open Food ', 'marmite', 'Open', 'Food', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 12:35:06', 'admin-1466470807-14664837065273828', 1, 0, '', NULL, NULL, NULL),
(1032, '2016-06-21 12:37:55', NULL, NULL, 392, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 12:37:55', 'admin-1466470807-14664838752081496', 1, 1, 'SR', NULL, NULL, NULL),
(1033, '2016-06-21 12:37:55', NULL, NULL, 392, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 12:37:55', 'admin-1466470807-14664838752081496', 1, 1, 'SR', NULL, NULL, NULL),
(1034, '2016-06-21 12:30:14', NULL, NULL, 390, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 12:30:14', 'admin-1466470807-14664834139613690', 1, 1, 'SR', NULL, NULL, NULL),
(1035, '2016-06-21 12:25:45', NULL, NULL, 389, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 12:25:45', 'admin-1466470807-14664831450869831', 1, 1, 'SR', NULL, NULL, NULL),
(1036, '2016-06-21 12:21:56', NULL, NULL, 388, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 12:21:56', 'admin-1466470807-14664829167524740', 1, 1, 'SR', NULL, NULL, NULL),
(1037, '2016-06-21 11:24:47', NULL, NULL, 387, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 11:24:47', 'admin-1466470807-14664794877605436', 1, 0, '', NULL, NULL, NULL),
(1038, '2016-06-21 11:24:47', NULL, NULL, 387, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 11:24:47', 'admin-1466470807-14664794877605436', 1, 0, '', NULL, NULL, NULL),
(1039, '2016-06-21 11:24:47', NULL, NULL, 387, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 11:24:47', 'admin-1466470807-14664794877605436', 1, 0, '', NULL, NULL, NULL),
(1040, '2016-06-21 11:24:47', NULL, NULL, 387, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 11:24:47', 'admin-1466470807-14664794877605436', 1, 1, 'SR', NULL, NULL, NULL),
(1041, '2016-06-21 11:16:59', NULL, NULL, 386, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 11:16:59', 'admin-1466470807-14664790192198781', 1, 0, '', NULL, NULL, NULL),
(1042, '2016-06-21 11:16:59', NULL, NULL, 386, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 11:16:59', 'admin-1466470807-14664790192198781', 1, 0, '', NULL, NULL, NULL),
(1043, '2016-06-21 09:22:28', NULL, NULL, 381, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 09:22:28', 'admin-1466470807-14664721488047090', 1, 0, '', NULL, NULL, NULL),
(1044, '2016-06-21 09:22:28', NULL, NULL, 381, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 09:22:29', 'admin-1466470807-14664721488047090', 1, 1, 'SR', NULL, NULL, NULL),
(1045, '2016-06-21 09:22:29', NULL, NULL, 381, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 09:22:29', 'admin-1466470807-14664721488047090', 1, 1, 'SR', NULL, NULL, NULL),
(1046, '2016-06-21 10:32:17', NULL, NULL, 382, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 10:32:17', 'admin-1466470807-14664763370852885', 1, 1, 'SR', NULL, NULL, NULL),
(1047, '2016-06-21 10:32:40', NULL, NULL, 383, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 10:32:40', 'admin-1466470807-14664763602353533', 1, 1, 'SR', 1, NULL, NULL),
(1048, '2016-06-21 10:32:56', NULL, NULL, 384, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 10:32:56', 'admin-1466470807-14664763762182877', 1, 1, 'SR', 1, NULL, NULL),
(1049, '2016-06-21 11:16:59', NULL, NULL, 386, 0, 38, '38', 'Kiwi Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 11:16:59', 'admin-1466470807-14664790192198781', 1, 1, 'SR', NULL, NULL, NULL),
(1050, '2016-06-21 11:16:59', NULL, NULL, 386, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 11:16:59', 'admin-1466470807-14664790192198781', 1, 1, 'SR', NULL, NULL, NULL),
(1051, '2016-06-21 09:22:28', NULL, NULL, 381, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466510328', 'admin', '2016-06-21 09:22:28', 'admin-1466470807-14664721488047090', 1, 0, '', NULL, NULL, NULL),
(1052, '2016-06-23 16:29:42', NULL, NULL, 443, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 16:29:42', 'Staff-1466643574-14666705819342425', 1, 0, '', 1, NULL, NULL),
(1053, '2016-06-23 17:30:15', NULL, NULL, 444, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 17:30:15', 'Staff-1466643574-14666742153312473', 1, 1, 'SR', NULL, NULL, NULL),
(1054, '2016-06-23 17:30:15', NULL, NULL, 444, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 17:30:15', 'Staff-1466643574-14666742153312473', 1, 1, 'SR', NULL, NULL, NULL),
(1055, '2016-06-23 17:30:15', NULL, NULL, 444, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 17:30:15', 'Staff-1466643574-14666742153312473', 1, 0, '', NULL, NULL, NULL),
(1056, '2016-06-23 17:30:15', NULL, NULL, 444, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 17:30:15', 'Staff-1466643574-14666742153312473', 1, 1, 'SR', NULL, NULL, NULL),
(1057, '2016-06-23 17:30:15', NULL, NULL, 444, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 17:30:15', 'Staff-1466643574-14666742153312473', 1, 1, 'SR', NULL, NULL, NULL),
(1058, '2016-06-23 17:30:15', NULL, NULL, 444, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 17:30:15', 'Staff-1466643574-14666742153312473', 1, 1, 'SR', NULL, NULL, NULL),
(1059, '2016-06-23 21:37:21', NULL, NULL, 447, 0, 190, '125', 'Tiger Bucket ', '', 'Cold Drinks', 'Soda & Beer', 1, 48.00, 48.0000, 0.0000, 48.00, 1, '27', 1, NULL, 'lois', '2016-06-23 21:37:21', 'lois-1466685867-14666890412637117', 1, 0, '', NULL, NULL, NULL),
(1060, '2016-06-23 21:36:30', NULL, NULL, 447, 0, 189, '124', 'Stuffed Bitter Gourd', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, NULL, 'lois', '2016-06-23 21:36:30', 'lois-1466685867-14666889898768197', 1, 0, '', NULL, NULL, NULL),
(1061, '2016-06-23 21:32:30', NULL, NULL, 446, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, NULL, 'lois', '2016-06-23 21:32:30', 'lois-1466685867-14666887504974195', 1, 1, 'SR', NULL, NULL, NULL),
(1062, '2016-06-23 21:32:30', NULL, NULL, 446, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, NULL, 'lois', '2016-06-23 21:32:30', 'lois-1466685867-14666887504974195', 1, 1, 'SR', NULL, NULL, NULL),
(1063, '2016-06-23 21:32:30', NULL, NULL, 446, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, NULL, 'lois', '2016-06-23 21:32:30', 'lois-1466685867-14666887504974195', 1, 1, 'SR', NULL, NULL, NULL),
(1064, '2016-06-23 20:45:02', NULL, NULL, 446, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, NULL, 'lois', '2016-06-23 20:45:02', 'lois-1466685867-1466685902274428', 1, 1, 'SR', NULL, NULL, NULL),
(1065, '2016-06-23 20:34:51', NULL, NULL, 446, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 20:34:51', 'Staff-1466682532-14666852914351459', 1, 1, 'SR', NULL, NULL, NULL),
(1066, '2016-06-23 20:34:27', NULL, NULL, 447, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 20:34:27', 'Staff-1466682532-14666852672291276', 1, 0, '', NULL, NULL, NULL),
(1067, '2016-06-23 21:36:30', NULL, NULL, 447, 0, 181, '116', 'Open Food ', 'Kampung Pasta', 'Open', 'Food', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, NULL, 'lois', '2016-06-23 21:36:30', 'lois-1466685867-14666889898768197', 1, 0, '', NULL, NULL, NULL),
(1068, '2016-06-23 19:50:39', NULL, NULL, 445, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 19:50:39', 'Staff-1466682532-14666826398123585', 1, 0, '', NULL, NULL, '20.0'),
(1069, '2016-06-23 19:50:31', NULL, NULL, 446, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 19:50:31', 'Staff-1466682532-14666826314986687', 1, 1, 'SR', NULL, NULL, NULL),
(1070, '2016-06-23 19:50:31', NULL, NULL, 446, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 19:50:31', 'Staff-1466682532-14666826314986687', 1, 0, '', NULL, NULL, NULL),
(1071, '2016-06-23 19:50:01', NULL, NULL, 446, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 19:50:01', 'Staff-1466682532-14666826012138937', 1, 0, '', NULL, NULL, NULL),
(1072, '2016-06-23 19:50:01', NULL, NULL, 446, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 19:50:01', 'Staff-1466682532-14666826012138937', 1, 0, '', NULL, NULL, NULL),
(1073, '2016-06-23 19:49:32', NULL, NULL, 446, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 19:49:32', 'Staff-1466682532-14666825725993473', 1, 1, 'SR', NULL, NULL, NULL),
(1074, '2016-06-23 19:49:32', NULL, NULL, 446, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 19:49:32', 'Staff-1466682532-14666825725993473', 1, 1, 'SR', NULL, NULL, NULL),
(1075, '2016-06-23 19:49:32', NULL, NULL, 446, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 19:49:32', 'Staff-1466682532-14666825725993473', 1, 1, 'SR', NULL, NULL, NULL),
(1076, '2016-06-23 19:49:32', NULL, NULL, 446, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 19:49:32', 'Staff-1466682532-14666825725993473', 1, 1, 'SR', NULL, NULL, NULL),
(1077, '2016-06-23 14:58:25', NULL, NULL, 437, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 14:58:25', 'Staff-1466643574-14666651053792894', 1, 1, 'SR', NULL, NULL, NULL),
(1078, '2016-06-23 14:58:37', NULL, NULL, 441, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 3, 12.00, 36.0000, 0.0000, 36.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 14:58:37', 'Staff-1466643574-14666651173255311', 1, 1, 'SR', NULL, NULL, NULL),
(1079, '2016-06-23 15:08:14', NULL, NULL, 442, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 8.10, 1, '27', 1, NULL, 'Staff', '2016-06-23 15:08:14', 'Staff-1466643574-14666656941637488', 1, 1, 'SR', NULL, '10.0', NULL),
(1080, '2016-06-23 15:08:14', NULL, NULL, 442, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 8.10, 1, '27', 1, NULL, 'Staff', '2016-06-23 15:08:14', 'Staff-1466643574-14666656941637488', 1, 1, 'SR', NULL, '10.0', NULL),
(1081, '2016-06-23 15:08:14', NULL, NULL, 442, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 8.10, 1, '27', 1, NULL, 'Staff', '2016-06-23 15:08:14', 'Staff-1466643574-14666656941637488', 1, 1, 'SR', NULL, '10.0', NULL),
(1082, '2016-06-23 15:08:14', NULL, NULL, 442, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 7.20, 1, '27', 1, NULL, 'Staff', '2016-06-23 15:08:14', 'Staff-1466643574-14666656941637488', 1, 1, 'SR', NULL, '10.0', NULL),
(1083, '2016-06-23 12:51:08', NULL, NULL, 435, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 12:51:08', 'Staff-1466643574-1466657468347985', 1, 1, 'SR', NULL, NULL, NULL),
(1084, '2016-06-23 12:51:08', NULL, NULL, 435, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 12:51:08', 'Staff-1466643574-1466657468347985', 1, 1, 'SR', NULL, NULL, NULL),
(1085, '2016-06-23 13:03:45', NULL, NULL, 436, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 13:03:45', 'Staff-1466643574-14666582253088594', 1, 1, 'SR', NULL, NULL, NULL),
(1086, '2016-06-23 13:03:45', NULL, NULL, 436, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 13:03:45', 'Staff-1466643574-14666582253088594', 1, 1, 'SR', NULL, NULL, NULL),
(1087, '2016-06-23 13:03:45', NULL, NULL, 436, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 13:03:45', 'Staff-1466643574-14666582253088594', 1, 1, 'SR', NULL, NULL, NULL),
(1088, '2016-06-23 13:03:45', NULL, NULL, 436, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 13:03:45', 'Staff-1466643574-14666582253088594', 1, 1, 'SR', NULL, NULL, NULL),
(1089, '2016-06-23 13:14:55', NULL, NULL, 437, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 13:14:55', 'Staff-1466643574-14666588951746211', 1, 0, '', NULL, NULL, NULL),
(1090, '2016-06-23 13:46:28', NULL, NULL, 437, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 13:46:28', 'Staff-1466643574-14666607885083313', 1, 0, '', NULL, NULL, NULL),
(1091, '2016-06-23 13:46:28', NULL, NULL, 437, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 3, 12.00, 36.0000, 0.0000, 36.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 13:46:28', 'Staff-1466643574-14666607885083313', 1, 1, 'SR', NULL, NULL, NULL),
(1092, '2016-06-23 13:46:28', NULL, NULL, 437, 0, 181, '116', 'Open Food ', 'bittergourd', 'Open', 'Food', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 13:46:28', 'Staff-1466643574-14666607885083313', 1, 0, '', NULL, NULL, NULL),
(1093, '2016-06-23 14:03:33', NULL, NULL, 438, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 9.90, 1, '27', 1, NULL, 'Staff', '2016-06-23 14:03:33', 'Staff-1466643574-14666618129978415', 1, 1, 'SR', NULL, '10.0', NULL),
(1094, '2016-06-23 14:12:12', NULL, NULL, 437, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 14:12:12', 'Staff-1466643574-14666623323634112', 1, 1, 'SR', NULL, NULL, NULL),
(1095, '2016-06-23 14:19:32', NULL, NULL, 439, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 14:19:32', 'Staff-1466643574-14666627721595277', 1, 1, 'SR', NULL, NULL, NULL),
(1096, '2016-06-23 14:19:32', NULL, NULL, 439, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 14:19:32', 'Staff-1466643574-14666627721595277', 1, 1, 'SR', NULL, NULL, NULL),
(1097, '2016-06-23 14:19:32', NULL, NULL, 439, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 14:19:32', 'Staff-1466643574-14666627721595277', 1, 1, 'SR', NULL, NULL, NULL),
(1098, '2016-06-23 14:19:32', NULL, NULL, 439, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 14:19:32', 'Staff-1466643574-14666627721595277', 1, 0, '', NULL, NULL, NULL),
(1099, '2016-06-23 14:19:32', NULL, NULL, 439, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 14:19:32', 'Staff-1466643574-14666627721595277', 1, 1, 'SR', NULL, NULL, NULL),
(1100, '2016-06-23 14:19:32', NULL, NULL, 439, 0, 181, '116', 'Open Food ', 'bitter melon', 'Open', 'Food', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 14:19:32', 'Staff-1466643574-14666627721595277', 1, 0, '', NULL, NULL, NULL),
(1101, '2016-06-23 14:19:57', NULL, NULL, 439, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 14:19:57', 'Staff-1466643574-14666627968758967', 1, 1, 'SR', NULL, NULL, NULL),
(1102, '2016-06-23 20:44:56', NULL, NULL, 446, 0, 189, '124', 'Stuffed Bitter Gourd', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, NULL, 'lois', '2016-06-23 20:44:56', 'lois-1466685867-1466685896223316', 1, 0, '', NULL, NULL, NULL),
(1103, '2016-06-23 19:49:32', NULL, NULL, 446, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 19:49:32', 'Staff-1466682532-14666825725993473', 1, 1, 'SR', NULL, NULL, NULL),
(1104, '2016-06-23 19:27:37', NULL, NULL, 444, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 19:27:37', 'Staff-1466680982-14666812569097923', 1, 0, '', NULL, NULL, NULL),
(1105, '2016-06-23 19:27:53', NULL, NULL, 445, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 19:27:53', 'Staff-1466680982-14666812736629446', 1, 1, 'SR', NULL, NULL, '20.0'),
(1106, '2016-06-23 15:15:15', NULL, NULL, 437, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 15:15:15', 'Staff-1466643574-14666661152508089', 1, 0, '', NULL, NULL, NULL),
(1107, '2016-06-23 15:15:15', NULL, NULL, 437, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 15:15:15', 'Staff-1466643574-14666661152508089', 1, 0, '', NULL, NULL, NULL),
(1108, '2016-06-23 15:15:15', NULL, NULL, 437, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 15:15:15', 'Staff-1466643574-14666661152508089', 1, 0, '', NULL, NULL, NULL),
(1109, '2016-06-23 15:15:15', NULL, NULL, 437, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 15:15:15', 'Staff-1466643574-14666661152508089', 1, 1, 'SR', NULL, NULL, NULL),
(1110, '2016-06-23 19:41:52', NULL, NULL, 445, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, NULL, 'admin', '2016-06-23 19:41:52', 'admin-1466681416-14666821127938521', 1, 1, 'SR', NULL, NULL, '20.0'),
(1111, '2016-06-23 14:26:45', NULL, NULL, 437, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 14:26:45', 'Staff-1466643574-1466663205377546', 1, 1, 'SR', NULL, NULL, NULL),
(1112, '2016-06-23 14:26:45', NULL, NULL, 437, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 14:26:45', 'Staff-1466643574-1466663205377546', 1, 1, 'SR', NULL, NULL, NULL),
(1113, '2016-06-23 14:26:45', NULL, NULL, 437, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 14:26:45', 'Staff-1466643574-1466663205377546', 1, 1, 'SR', NULL, NULL, NULL),
(1114, '2016-06-23 12:49:27', NULL, NULL, 435, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 12:49:27', 'Staff-1466643574-14666573673625333', 1, 1, 'SR', NULL, NULL, NULL),
(1115, '2016-06-23 12:49:27', NULL, NULL, 435, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 12:49:27', 'Staff-1466643574-14666573673625333', 1, 1, 'SR', NULL, NULL, NULL),
(1116, '2016-06-23 12:49:27', NULL, NULL, 435, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 12:49:27', 'Staff-1466643574-14666573673625333', 1, 1, 'SR', NULL, NULL, NULL),
(1117, '2016-06-23 11:00:53', NULL, NULL, 433, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 11:00:53', 'Staff-1466643574-1466650853354897', 1, 0, '', NULL, NULL, NULL),
(1118, '2016-06-23 11:19:25', NULL, NULL, 434, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 11:19:25', 'Staff-1466643574-14666519654603677', 1, 1, 'SR', NULL, NULL, NULL),
(1119, '2016-06-23 10:40:47', NULL, NULL, 432, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 10:40:47', 'Staff-1466643574-14666496472764431', 1, 1, 'SR', NULL, NULL, NULL),
(1120, '2016-06-23 11:00:53', NULL, NULL, 433, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 11:00:53', 'Staff-1466643574-1466650853354897', 1, 1, 'SR', NULL, NULL, NULL),
(1121, '2016-06-23 10:14:23', NULL, NULL, 428, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 10:14:23', 'Staff-1466643574-14666480630701471', 1, 0, '', NULL, NULL, NULL),
(1122, '2016-06-23 10:28:52', NULL, NULL, 429, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 10:28:52', 'Staff-1466643574-14666489326037377', 1, 1, 'SR', NULL, NULL, NULL),
(1123, '2016-06-23 10:29:25', NULL, NULL, 430, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 10:29:25', 'Staff-1466643574-14666489657647429', 1, 1, 'SR', NULL, NULL, NULL),
(1124, '2016-06-23 10:30:22', NULL, NULL, 431, 0, 54, '54', 'Chai Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 10:30:22', 'Staff-1466643574-14666490219201828', 1, 1, 'SR', NULL, NULL, NULL),
(1125, '2016-06-23 09:59:46', NULL, NULL, 424, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 09:59:46', 'Staff-1466643574-14666471865287471', 1, 0, '', NULL, NULL, NULL),
(1126, '2016-06-23 10:08:37', NULL, NULL, 425, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 10:08:37', 'Staff-1466643574-14666477175939953', 1, 1, 'SR', NULL, NULL, NULL),
(1127, '2016-06-23 10:08:37', NULL, NULL, 425, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 10:08:37', 'Staff-1466643574-14666477175939953', 1, 1, 'SR', NULL, NULL, NULL),
(1128, '2016-06-23 10:10:31', NULL, NULL, 426, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 10:10:31', 'Staff-1466643574-14666478312396851', 1, 1, 'SR', NULL, NULL, NULL),
(1129, '2016-06-23 09:08:18', NULL, NULL, 423, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 09:08:18', 'Staff-1466643574-14666440987588290', 1, 1, 'SR', NULL, NULL, NULL),
(1130, '2016-06-23 10:13:37', NULL, NULL, 427, 0, 159, '93', 'Granola ', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 10:13:37', 'Staff-1466643574-1466648017360894', 1, 0, '', NULL, NULL, NULL),
(1131, '2016-06-23 10:11:20', NULL, NULL, 426, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 10:11:20', 'Staff-1466643574-14666478807804938', 1, 0, '', NULL, NULL, NULL),
(1132, '2016-06-23 09:59:46', NULL, NULL, 424, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 09:59:46', 'Staff-1466643574-14666471865287471', 1, 0, '', NULL, NULL, NULL),
(1133, '2016-06-23 09:59:46', NULL, NULL, 424, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 09:59:46', 'Staff-1466643574-14666471865287471', 1, 0, '', NULL, NULL, NULL),
(1134, '2016-06-23 09:59:46', NULL, NULL, 424, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, NULL, 'Staff', '2016-06-23 09:59:46', 'Staff-1466643574-14666471865287471', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(1135, '2016-06-24 16:39:03', NULL, NULL, 465, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 16:39:03', 'admin-1466750877-1466757543109677', 1, 1, 'SR', NULL, NULL, NULL),
(1136, '2016-06-24 18:07:04', NULL, NULL, 466, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 18:07:04', 'admin-1466750877-1466762824786815', 1, 1, 'SR', 1, NULL, NULL),
(1137, '2016-06-24 21:31:18', NULL, NULL, 470, 0, 182, '117', 'Open Drinks ', 'fOODSION', 'Open', 'Drinks', 1, 12.70, 12.7000, 0.0000, 12.70, 1, '27', 1, '1466775310', 'admin', '2016-06-24 21:31:18', 'admin-1466750877-14667750785945095', 1, 0, '', NULL, NULL, NULL),
(1138, '2016-06-24 21:11:33', NULL, NULL, 469, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 8.10, 1, '27', 1, '1466775310', 'admin', '2016-06-24 21:11:33', 'admin-1466750877-14667738931985456', 1, 1, 'SR', NULL, '10.0', NULL),
(1139, '2016-06-24 20:27:31', NULL, NULL, 468, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 20:27:31', 'admin-1466750877-1466771251255967', 1, 0, '', NULL, NULL, NULL),
(1140, '2016-06-24 20:36:54', NULL, NULL, 469, 0, 189, '124', 'Stuffed Bitter Gourd', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 15.30, 1, '27', 1, '1466775310', 'admin', '2016-06-24 20:36:54', 'admin-1466750877-14667718147015298', 1, 0, '', NULL, '10.0', NULL),
(1141, '2016-06-24 20:13:23', NULL, NULL, 468, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 20:13:23', 'admin-1466750877-14667704032418658', 1, 1, 'SR', NULL, NULL, NULL),
(1142, '2016-06-24 20:12:47', NULL, NULL, 468, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 20:12:47', 'admin-1466750877-14667703677087116', 1, 1, 'SR', NULL, NULL, NULL),
(1143, '2016-06-24 20:12:47', NULL, NULL, 468, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 20:12:47', 'admin-1466750877-14667703677087116', 1, 1, 'SR', NULL, NULL, NULL),
(1144, '2016-06-24 20:12:47', NULL, NULL, 468, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 20:12:47', 'admin-1466750877-14667703677087116', 1, 1, 'SR', NULL, NULL, NULL),
(1145, '2016-06-24 18:59:44', NULL, NULL, 467, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 3, 20.00, 60.0000, 0.0000, 60.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 18:59:44', 'admin-1466750877-1466765984794467', 1, 1, 'SR', NULL, NULL, NULL),
(1146, '2016-06-24 12:58:13', NULL, NULL, 451, 0, 189, '124', 'Stuffed Bitter Gourd', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 15.30, 1, '27', 1, '1466775310', 'admin', '2016-06-24 12:58:13', 'admin-1466735869-14667442937143692', 1, 0, '', NULL, '10.0', NULL),
(1147, '2016-06-24 13:04:14', NULL, NULL, 455, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 2, 15.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 13:04:14', 'admin-1466744311-14667446540642167', 1, 1, 'SR', NULL, NULL, NULL),
(1148, '2016-06-24 13:04:14', NULL, NULL, 455, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 13:04:14', 'admin-1466744311-14667446540642167', 1, 1, 'SR', NULL, NULL, NULL),
(1149, '2016-06-24 13:08:25', NULL, NULL, 456, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 13:08:25', 'admin-1466744311-14667449053017748', 1, 0, '', NULL, NULL, NULL),
(1150, '2016-06-24 13:08:25', NULL, NULL, 456, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 13:08:25', 'admin-1466744311-14667449053017748', 1, 1, 'SR', NULL, NULL, NULL),
(1151, '2016-06-24 13:23:42', NULL, NULL, 457, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 13:23:42', 'admin-1466744311-14667458226486823', 1, 1, 'SR', NULL, NULL, NULL),
(1152, '2016-06-24 13:08:25', NULL, NULL, 456, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 13:08:25', 'admin-1466744311-14667449053017748', 1, 1, 'SR', NULL, NULL, NULL),
(1153, '2016-06-24 13:08:25', NULL, NULL, 456, 0, 38, '38', 'Kiwi Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 13:08:25', 'admin-1466744311-14667449053017748', 1, 1, 'SR', NULL, NULL, NULL),
(1154, '2016-06-24 13:08:25', NULL, NULL, 456, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 13:08:25', 'admin-1466744311-14667449053017748', 1, 1, 'SR', NULL, NULL, NULL),
(1155, '2016-06-24 13:08:25', NULL, NULL, 456, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 13:08:25', 'admin-1466744311-14667449053017748', 1, 1, 'SR', NULL, NULL, NULL),
(1156, '2016-06-24 13:08:25', NULL, NULL, 456, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 13:08:25', 'admin-1466744311-14667449053017748', 1, 1, 'SR', NULL, NULL, NULL),
(1157, '2016-06-24 13:08:25', NULL, NULL, 456, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 13:08:25', 'admin-1466744311-14667449053017748', 1, 1, 'SR', NULL, NULL, NULL),
(1158, '2016-06-24 13:08:25', NULL, NULL, 456, 0, 38, '38', 'Kiwi Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 13:08:25', 'admin-1466744311-14667449053017748', 1, 1, 'SR', NULL, NULL, NULL),
(1159, '2016-06-24 13:11:16', NULL, NULL, 455, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 13:11:16', 'admin-1466744311-14667450764819336', 1, 1, 'SR', NULL, NULL, NULL),
(1160, '2016-06-24 13:23:42', NULL, NULL, 457, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 13:23:42', 'admin-1466744311-14667458226486823', 1, 1, 'SR', NULL, NULL, NULL),
(1161, '2016-06-24 13:29:32', NULL, NULL, 459, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 13:29:32', 'admin-1466744311-14667461725611538', 1, 1, 'SR', NULL, NULL, NULL),
(1162, '2016-06-24 13:29:55', NULL, NULL, 459, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 13:29:55', 'admin-1466744311-14667461951784878', 1, 1, 'SR', NULL, NULL, NULL),
(1163, '2016-06-24 14:23:33', NULL, NULL, 456, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 14:23:33', 'admin-1466744311-14667494132619638', 1, 0, '', NULL, NULL, NULL),
(1164, '2016-06-24 14:32:40', NULL, NULL, 460, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 14:32:40', 'admin-1466744311-14667499604524575', 1, 0, '', NULL, NULL, NULL),
(1165, '2016-06-24 14:32:40', NULL, NULL, 460, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 14:32:40', 'admin-1466744311-14667499604524575', 1, 0, '', NULL, NULL, NULL),
(1166, '2016-06-24 16:32:27', NULL, NULL, 464, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 16:32:27', 'admin-1466750877-14667571476313912', 1, 1, 'SR', NULL, NULL, NULL),
(1167, '2016-06-24 16:32:27', NULL, NULL, 464, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 2, 9.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 16:32:27', 'admin-1466750877-14667571476313912', 1, 1, 'SR', NULL, NULL, NULL),
(1168, '2016-06-24 15:31:41', NULL, NULL, 463, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 15:31:41', 'admin-1466750877-14667535011883566', 1, 0, '', NULL, NULL, NULL),
(1169, '2016-06-24 16:32:27', NULL, NULL, 464, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 16:32:27', 'admin-1466750877-14667571476313912', 1, 1, 'SR', NULL, NULL, NULL),
(1170, '2016-06-24 15:31:05', NULL, NULL, 463, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 15:31:05', 'admin-1466750877-14667534656897425', 1, 1, 'SR', NULL, NULL, NULL),
(1171, '2016-06-24 14:59:50', NULL, NULL, 462, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 14:59:50', 'admin-1466750877-1466751590195442', 1, 0, '', NULL, NULL, NULL),
(1172, '2016-06-24 14:59:50', NULL, NULL, 462, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 14:59:50', 'admin-1466750877-1466751590195442', 1, 1, 'SR', NULL, NULL, NULL),
(1173, '2016-06-24 14:59:50', NULL, NULL, 462, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 14:59:50', 'admin-1466750877-1466751590195442', 1, 1, 'SR', NULL, NULL, NULL),
(1174, '2016-06-24 14:48:13', NULL, NULL, 461, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 14:48:13', 'admin-1466750877-14667508936557613', 1, 1, 'SR', NULL, NULL, NULL),
(1175, '2016-06-24 14:48:13', NULL, NULL, 461, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 14:48:13', 'admin-1466750877-14667508936557613', 1, 1, 'SR', NULL, NULL, NULL),
(1176, '2016-06-24 12:05:10', NULL, NULL, 453, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 12:05:10', 'admin-1466735869-14667411103096883', 1, 1, 'SR', NULL, NULL, NULL),
(1177, '2016-06-24 12:29:47', NULL, NULL, 453, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 12:29:47', 'admin-1466735869-14667425876874998', 1, 1, 'SR', NULL, NULL, NULL),
(1178, '2016-06-24 12:54:51', NULL, NULL, 454, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 12:54:51', 'admin-1466735869-14667440910713270', 1, 1, 'SR', NULL, NULL, NULL),
(1179, '2016-06-24 12:29:47', NULL, NULL, 453, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 12:29:47', 'admin-1466735869-14667425876874998', 1, 0, '', NULL, NULL, NULL),
(1180, '2016-06-24 12:05:10', NULL, NULL, 453, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 12:05:10', 'admin-1466735869-14667411103096883', 1, 0, '', NULL, NULL, NULL),
(1181, '2016-06-24 11:55:45', NULL, NULL, 452, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 11:55:45', 'admin-1466735869-14667405453881145', 1, 0, '', NULL, NULL, NULL),
(1182, '2016-06-24 12:05:10', NULL, NULL, 453, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 12:05:10', 'admin-1466735869-14667411103096883', 1, 1, 'SR', NULL, NULL, NULL),
(1183, '2016-06-24 11:56:08', NULL, NULL, 451, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 13.50, 1, '27', 1, '1466775310', 'admin', '2016-06-24 11:56:08', 'admin-1466735869-1466740568033109', 1, 1, 'SR', NULL, '10.0', NULL),
(1184, '2016-06-24 12:04:50', NULL, NULL, 453, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 12:04:50', 'admin-1466735869-14667410905078689', 1, 0, '', NULL, NULL, NULL),
(1185, '2016-06-24 11:55:45', NULL, NULL, 452, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 11:55:45', 'admin-1466735869-14667405453881145', 1, 0, '', NULL, NULL, NULL),
(1186, '2016-06-24 11:53:20', NULL, NULL, 451, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 7.20, 1, '27', 1, '1466775310', 'admin', '2016-06-24 11:53:20', 'admin-1466735869-14667404006853687', 1, 0, '', NULL, '10.0', NULL),
(1187, '2016-06-24 11:53:29', NULL, NULL, 451, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 9.90, 1, '27', 1, '1466775310', 'admin', '2016-06-24 11:53:29', 'admin-1466735869-14667404089449744', 1, 1, 'SR', NULL, '10.0', NULL),
(1188, '2016-06-24 10:08:36', NULL, NULL, 448, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466775310', 'Staff', '2016-06-24 10:08:36', 'Staff-1466692225-1466734116796872', 1, 0, '', NULL, NULL, NULL),
(1189, '2016-06-24 11:55:45', NULL, NULL, 452, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 11:55:45', 'admin-1466735869-14667405453881145', 1, 1, 'SR', NULL, NULL, NULL),
(1190, '2016-06-24 11:55:45', NULL, NULL, 452, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 11:55:45', 'admin-1466735869-14667405453881145', 1, 1, 'SR', NULL, NULL, NULL),
(1191, '2016-06-24 11:53:29', NULL, NULL, 451, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 9.90, 1, '27', 1, '1466775310', 'admin', '2016-06-24 11:53:29', 'admin-1466735869-14667404089449744', 1, 1, 'SR', NULL, '10.0', NULL),
(1192, '2016-06-24 11:22:57', NULL, NULL, 450, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 11:22:57', 'admin-1466735869-14667385769769459', 1, 0, '', NULL, NULL, NULL),
(1193, '2016-06-24 11:22:51', NULL, NULL, 450, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466775310', 'admin', '2016-06-24 11:22:51', 'admin-1466735869-14667385712643626', 1, 1, 'SR', NULL, NULL, NULL),
(1194, '2016-06-24 10:37:27', NULL, NULL, 449, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 9.90, 1, '27', 1, '1466775310', 'Staff', '2016-06-24 10:37:27', 'Staff-1466692225-1466735847267440', 1, 1, 'SR', NULL, '10.0', NULL),
(1195, '2016-06-24 10:37:27', NULL, NULL, 449, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 9.90, 1, '27', 1, '1466775310', 'Staff', '2016-06-24 10:37:27', 'Staff-1466692225-1466735847267440', 1, 1, 'SR', NULL, '10.0', NULL),
(1196, '2016-06-24 10:08:36', NULL, NULL, 448, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466775310', 'Staff', '2016-06-24 10:08:36', 'Staff-1466692225-1466734116796872', 1, 1, 'SR', NULL, NULL, NULL),
(1197, '2016-06-25 20:11:07', NULL, NULL, 508, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 20:11:07', 'admin-1466856643-14668566674982565', 1, 0, '', NULL, NULL, NULL),
(1198, '2016-06-25 20:41:23', NULL, NULL, 509, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 20:41:23', 'admin-1466856643-14668584833311548', 1, 1, 'SR', NULL, NULL, NULL),
(1199, '2016-06-25 19:34:21', NULL, NULL, 508, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 19:34:21', 'admin-1466838809-1466854460839320', 1, 0, '', NULL, NULL, NULL),
(1200, '2016-06-25 19:34:21', NULL, NULL, 508, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 19:34:21', 'admin-1466838809-1466854460839320', 1, 1, 'SR', NULL, NULL, NULL),
(1201, '2016-06-25 20:10:52', NULL, NULL, 509, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 20:10:52', 'admin-1466856643-14668566518112891', 1, 0, '', NULL, NULL, NULL),
(1202, '2016-06-25 19:21:11', NULL, NULL, 510, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 19:21:11', 'admin-1466838809-1466853671490492', 1, 1, 'SR', NULL, NULL, NULL),
(1203, '2016-06-25 19:21:11', NULL, NULL, 510, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 19:21:11', 'admin-1466838809-1466853671490492', 1, 0, '', NULL, NULL, NULL),
(1204, '2016-06-25 19:21:11', NULL, NULL, 510, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 19:21:11', 'admin-1466838809-1466853671490492', 1, 0, '', NULL, NULL, NULL),
(1205, '2016-06-25 19:21:11', NULL, NULL, 510, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 19:21:11', 'admin-1466838809-1466853671490492', 1, 0, '', NULL, NULL, NULL),
(1206, '2016-06-25 19:19:36', NULL, NULL, 509, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 19:19:36', 'admin-1466838809-14668535763694420', 1, 1, 'SR', NULL, NULL, NULL),
(1207, '2016-06-25 19:19:36', NULL, NULL, 509, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 19:19:36', 'admin-1466838809-14668535763694420', 1, 1, 'SR', NULL, NULL, NULL),
(1208, '2016-06-25 19:19:36', NULL, NULL, 509, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 19:19:36', 'admin-1466838809-14668535763694420', 1, 0, '', NULL, NULL, NULL),
(1209, '2016-06-25 19:19:36', NULL, NULL, 509, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 19:19:36', 'admin-1466838809-14668535763694420', 1, 1, 'SR', NULL, NULL, NULL),
(1210, '2016-06-25 19:10:36', NULL, NULL, 508, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 19:10:36', 'admin-1466838809-14668530359653611', 1, 1, 'SR', NULL, NULL, NULL),
(1211, '2016-06-25 19:10:36', NULL, NULL, 508, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 19:10:36', 'admin-1466838809-14668530359653611', 1, 0, '', NULL, NULL, NULL),
(1212, '2016-06-25 19:10:36', NULL, NULL, 508, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 19:10:36', 'admin-1466838809-14668530359653611', 1, 0, '', NULL, NULL, NULL),
(1213, '2016-06-25 19:10:36', NULL, NULL, 508, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 19:10:36', 'admin-1466838809-14668530359653611', 1, 0, '', NULL, NULL, NULL),
(1214, '2016-06-25 19:10:36', NULL, NULL, 508, 0, 181, '116', 'Open Food ', 'Pork', 'Open', 'Food', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 19:10:36', 'admin-1466838809-14668530359653611', 1, 0, '', NULL, NULL, NULL),
(1215, '2016-06-25 19:10:36', NULL, NULL, 508, 0, 181, '116', 'Open Food ', 'Chicken', 'Open', 'Food', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 19:10:36', 'admin-1466838809-14668530359653611', 1, 0, '', NULL, NULL, NULL),
(1216, '2016-06-25 19:19:36', NULL, NULL, 509, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 19:19:36', 'admin-1466838809-14668535763694420', 1, 1, 'SR', NULL, NULL, NULL),
(1217, '2016-06-25 17:16:23', NULL, NULL, 507, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 17:16:23', 'admin-1466838809-14668461830652329', 1, 1, 'SR', NULL, NULL, NULL),
(1218, '2016-06-25 19:10:36', NULL, NULL, 508, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 19:10:36', 'admin-1466838809-14668530359653611', 1, 0, '', NULL, NULL, NULL),
(1219, '2016-06-25 19:10:36', NULL, NULL, 508, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 19:10:36', 'admin-1466838809-14668530359653611', 1, 1, 'SR', NULL, NULL, NULL),
(1220, '2016-06-25 17:07:47', NULL, NULL, 506, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 17:07:47', 'admin-1466838809-14668456675039459', 1, 1, 'SR', NULL, NULL, NULL),
(1221, '2016-06-25 17:06:47', NULL, NULL, 506, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 17:06:47', 'admin-1466838809-14668456070179839', 1, 1, 'SR', NULL, NULL, NULL),
(1222, '2016-06-25 17:06:47', NULL, NULL, 506, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 17:06:47', 'admin-1466838809-14668456070179839', 1, 0, '', NULL, NULL, NULL),
(1223, '2016-06-25 16:49:36', NULL, NULL, 505, 0, 161, '95', 'Dumpling (10 Pcs) ', 'Takeaway', 'Meals', 'Snacks ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 16:49:36', 'admin-1466838809-14668445762586262', 1, 0, '', NULL, NULL, NULL),
(1224, '2016-06-25 12:55:25', NULL, NULL, 492, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:55:25', 'admin-1466827306-14668305253038219', 1, 1, 'SR', NULL, NULL, NULL),
(1225, '2016-06-25 12:55:25', NULL, NULL, 492, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:55:25', 'admin-1466827306-14668305253038219', 1, 0, '', NULL, NULL, NULL),
(1226, '2016-06-25 12:54:34', NULL, NULL, 495, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:54:34', 'admin-1466827306-14668304744618684', 1, 0, '', NULL, NULL, NULL),
(1227, '2016-06-25 12:54:34', NULL, NULL, 495, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:54:34', 'admin-1466827306-14668304744618684', 1, 1, 'SR', NULL, NULL, NULL),
(1228, '2016-06-25 12:54:34', NULL, NULL, 495, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:54:34', 'admin-1466827306-14668304744618684', 1, 0, '', NULL, NULL, NULL),
(1229, '2016-06-25 12:52:47', NULL, NULL, 492, 0, 187, '122', 'Iced Tea ', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:52:47', 'admin-1466827306-14668303669224052', 1, 0, '', NULL, NULL, NULL),
(1230, '2016-06-25 12:51:32', NULL, NULL, 493, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:51:32', 'admin-1466827306-14668302926692344', 1, 1, 'SR', NULL, NULL, NULL),
(1231, '2016-06-25 12:51:32', NULL, NULL, 493, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:51:32', 'admin-1466827306-14668302926692344', 1, 1, 'SR', NULL, NULL, NULL),
(1232, '2016-06-25 12:52:47', NULL, NULL, 492, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:52:47', 'admin-1466827306-14668303669224052', 1, 0, '', NULL, NULL, NULL),
(1233, '2016-06-25 12:51:32', NULL, NULL, 493, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:51:32', 'admin-1466827306-14668302926692344', 1, 0, '', NULL, NULL, NULL),
(1234, '2016-06-25 11:41:18', NULL, NULL, 482, 0, 39, '39', 'Mango Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 11:41:18', 'admin-1466820201-14668260784908818', 1, 1, 'SR', NULL, NULL, NULL),
(1235, '2016-06-25 11:52:11', NULL, NULL, 485, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 11:52:11', 'admin-1466820201-1466826731816538', 1, 1, 'SR', NULL, NULL, NULL),
(1236, '2016-06-25 11:52:11', NULL, NULL, 485, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 11:52:11', 'admin-1466820201-1466826731816538', 1, 1, 'SR', NULL, NULL, NULL),
(1237, '2016-06-25 11:43:13', NULL, NULL, 484, 0, 189, '124', 'Stuffed Bitter Gourd', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 11:43:13', 'admin-1466820201-14668261930668234', 1, 0, '', NULL, NULL, NULL),
(1238, '2016-06-25 11:43:13', NULL, NULL, 484, 0, 189, '124', 'Stuffed Bitter Gourd', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 11:43:13', 'admin-1466820201-14668261930668234', 1, 0, '', NULL, NULL, NULL),
(1239, '2016-06-25 11:43:13', NULL, NULL, 484, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 11:43:13', 'admin-1466820201-14668261930668234', 1, 1, 'SR', NULL, NULL, NULL),
(1240, '2016-06-25 11:43:13', NULL, NULL, 484, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 11:43:13', 'admin-1466820201-14668261930668234', 1, 1, 'SR', NULL, NULL, NULL),
(1241, '2016-06-25 11:52:18', NULL, NULL, 481, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 11:52:18', 'admin-1466820201-14668267385905220', 1, 0, '', NULL, NULL, '10.0'),
(1242, '2016-06-25 12:02:38', NULL, NULL, 486, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:02:38', 'admin-1466827306-14668273579668575', 1, 0, '', NULL, NULL, NULL),
(1243, '2016-06-25 12:02:38', NULL, NULL, 486, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:02:38', 'admin-1466827306-14668273579668575', 1, 1, 'SR', NULL, NULL, NULL),
(1244, '2016-06-25 12:02:38', NULL, NULL, 486, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:02:38', 'admin-1466827306-14668273579668575', 1, 1, 'SR', NULL, NULL, NULL),
(1245, '2016-06-25 12:08:58', NULL, NULL, 481, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:08:58', 'admin-1466827306-14668277379383632', 1, 1, 'SR', NULL, NULL, '10.0'),
(1246, '2016-06-25 12:15:10', NULL, NULL, 487, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:15:10', 'admin-1466827306-14668281102292453', 1, 1, 'SR', NULL, NULL, NULL),
(1247, '2016-06-25 12:51:04', NULL, NULL, 492, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:51:04', 'admin-1466827306-14668302644447958', 1, 0, '', NULL, NULL, NULL),
(1248, '2016-06-25 12:51:04', NULL, NULL, 492, NULL, 65, '65', 'Pineapple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:51:04', 'admin-1466827306-14668302644447958', 1, 1, 'SR', NULL, NULL, NULL),
(1249, '2016-06-25 12:51:32', NULL, NULL, 493, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:51:32', 'admin-1466827306-14668302926692344', 1, 0, '', NULL, NULL, NULL),
(1250, '2016-06-25 12:33:23', NULL, NULL, 481, 0, 181, '116', 'Open Food ', 'magazine', 'Open', 'Food', 1, 12.75, 12.7500, 0.0000, 12.75, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:33:23', 'admin-1466827306-1466829203811995', 1, 0, '', NULL, NULL, '10.0'),
(1251, '2016-06-25 12:33:06', NULL, NULL, 481, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:33:06', 'admin-1466827306-14668291863598671', 1, 0, '', NULL, NULL, '10.0'),
(1252, '2016-06-25 12:33:06', NULL, NULL, 481, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:33:06', 'admin-1466827306-14668291863598671', 1, 0, '', NULL, NULL, '10.0'),
(1253, '2016-06-25 12:21:32', NULL, NULL, 491, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:21:32', 'admin-1466827306-1466828491915740', 1, 0, '', NULL, NULL, NULL),
(1254, '2016-06-25 10:40:20', NULL, NULL, 480, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 10:40:20', 'admin-1466820201-14668224203315789', 1, 1, 'SR', NULL, NULL, NULL),
(1255, '2016-06-25 09:27:02', NULL, NULL, 474, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:27:02', 'admin-1466816172-1466818022431924', 1, 1, 'SR', NULL, NULL, NULL),
(1256, '2016-06-25 09:27:02', NULL, NULL, 474, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:27:02', 'admin-1466816172-1466818022431924', 1, 1, 'SR', NULL, NULL, NULL),
(1257, '2016-06-25 09:27:02', NULL, NULL, 474, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:27:02', 'admin-1466816172-1466818022431924', 1, 1, 'SR', NULL, NULL, NULL),
(1258, '2016-06-25 09:28:39', NULL, NULL, 475, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:28:39', 'admin-1466816172-14668181194664176', 1, 1, 'SR', NULL, NULL, NULL),
(1259, '2016-06-25 09:28:39', NULL, NULL, 475, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:28:39', 'admin-1466816172-14668181194664176', 1, 1, 'SR', NULL, NULL, NULL),
(1260, '2016-06-25 09:40:52', NULL, NULL, 476, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:40:52', 'admin-1466816172-14668188523459394', 1, 0, '', NULL, NULL, NULL),
(1261, '2016-06-25 09:40:52', NULL, NULL, 476, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:40:52', 'admin-1466816172-14668188523459394', 1, 0, '', NULL, NULL, NULL),
(1262, '2016-06-25 09:59:43', NULL, NULL, 477, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:59:43', 'admin-1466816172-14668199831114642', 1, 0, '', NULL, NULL, NULL),
(1263, '2016-06-25 09:59:43', NULL, NULL, 477, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:59:43', 'admin-1466816172-14668199831114642', 1, 0, '', NULL, NULL, NULL),
(1264, '2016-06-25 09:59:43', NULL, NULL, 477, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:59:43', 'admin-1466816172-14668199831114642', 1, 0, '', NULL, NULL, NULL),
(1265, '2016-06-25 09:59:43', NULL, NULL, 477, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:59:43', 'admin-1466816172-14668199831114642', 1, 0, '', NULL, NULL, NULL),
(1266, '2016-06-25 09:59:43', NULL, NULL, 477, 0, 38, '38', 'Kiwi Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:59:43', 'admin-1466816172-14668199831114642', 1, 1, 'SR', NULL, NULL, NULL),
(1267, '2016-06-25 09:59:43', NULL, NULL, 477, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:59:43', 'admin-1466816172-14668199831114642', 1, 0, '', NULL, NULL, NULL),
(1268, '2016-06-25 09:59:43', NULL, NULL, 477, 0, 38, '38', 'Kiwi Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:59:43', 'admin-1466816172-14668199831114642', 1, 1, 'SR', NULL, NULL, NULL),
(1269, '2016-06-25 09:59:43', NULL, NULL, 477, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:59:43', 'admin-1466816172-14668199831114642', 1, 0, '', NULL, NULL, NULL),
(1270, '2016-06-25 10:03:11', NULL, NULL, 478, 0, 159, '93', 'Granola ', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 10:03:11', 'admin-1466816172-1466820190949958', 1, 0, '', NULL, NULL, NULL),
(1271, '2016-06-25 10:03:11', NULL, NULL, 478, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 10:03:11', 'admin-1466816172-1466820190949958', 1, 0, '', NULL, NULL, NULL),
(1272, '2016-06-25 10:03:11', NULL, NULL, 478, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 10:03:11', 'admin-1466816172-1466820190949958', 1, 1, 'SR', NULL, NULL, NULL),
(1273, '2016-06-25 10:27:55', NULL, NULL, 479, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 10:27:55', 'admin-1466820201-14668216754043469', 1, 0, '', NULL, NULL, NULL),
(1274, '2016-06-25 16:11:08', NULL, NULL, 504, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 16:11:08', 'admin-1466838809-1466842268661948', 1, 0, '', NULL, NULL, NULL),
(1275, '2016-06-25 16:11:08', NULL, NULL, 504, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 16:11:08', 'admin-1466838809-1466842268661948', 1, 0, '', NULL, NULL, NULL),
(1276, '2016-06-25 16:11:08', NULL, NULL, 504, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 16:11:08', 'admin-1466838809-1466842268661948', 1, 0, '', NULL, NULL, NULL),
(1277, '2016-06-25 15:51:21', NULL, NULL, 503, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 15:51:21', 'admin-1466838809-14668410817877122', 1, 1, 'SR', NULL, NULL, NULL),
(1278, '2016-06-25 15:51:21', NULL, NULL, 503, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 15:51:21', 'admin-1466838809-14668410817877122', 1, 1, 'SR', NULL, NULL, NULL),
(1279, '2016-06-25 15:43:08', NULL, NULL, 501, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 15:43:08', 'admin-1466838809-14668405885764146', 1, 1, 'SR', NULL, NULL, NULL),
(1280, '2016-06-25 15:43:08', NULL, NULL, 501, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 15:43:08', 'admin-1466838809-14668405885764146', 1, 1, 'SR', NULL, NULL, NULL),
(1281, '2016-06-25 15:43:08', NULL, NULL, 501, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 15:43:08', 'admin-1466838809-14668405885764146', 1, 1, 'SR', NULL, NULL, NULL),
(1282, '2016-06-25 15:14:15', NULL, NULL, 502, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 15:14:15', 'admin-1466838809-14668388550161821', 1, 0, '', NULL, NULL, NULL),
(1283, '2016-06-25 15:14:15', NULL, NULL, 502, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 15:14:15', 'admin-1466838809-14668388550161821', 1, 1, 'SR', NULL, NULL, NULL),
(1284, '2016-06-25 15:14:15', NULL, NULL, 502, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 15:14:15', 'admin-1466838809-14668388550161821', 1, 0, '', NULL, NULL, NULL),
(1285, '2016-06-25 15:43:08', NULL, NULL, 501, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 15:43:08', 'admin-1466838809-14668405885764146', 1, 1, 'SR', NULL, NULL, NULL),
(1286, '2016-06-25 14:59:54', NULL, NULL, 501, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 14:59:54', 'admin-1466827306-14668379947831338', 1, 0, '', NULL, NULL, NULL),
(1287, '2016-06-25 14:58:50', NULL, NULL, 501, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 14:58:50', 'admin-1466827306-14668379304308333', 1, 1, 'SR', NULL, NULL, NULL),
(1288, '2016-06-25 14:58:50', NULL, NULL, 501, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 14:58:50', 'admin-1466827306-14668379304308333', 1, 1, 'SR', NULL, NULL, NULL),
(1289, '2016-06-25 14:58:50', NULL, NULL, 501, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 14:58:50', 'admin-1466827306-14668379304308333', 1, 1, 'SR', NULL, NULL, NULL),
(1290, '2016-06-25 14:58:50', NULL, NULL, 501, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 14:58:50', 'admin-1466827306-14668379304308333', 1, 0, '', NULL, NULL, NULL),
(1291, '2016-06-25 14:58:50', NULL, NULL, 501, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 14:58:50', 'admin-1466827306-14668379304308333', 1, 1, 'SR', NULL, NULL, NULL),
(1292, '2016-06-25 14:54:55', NULL, NULL, 501, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 14:54:55', 'admin-1466827306-14668376955479084', 1, 0, '', NULL, NULL, NULL),
(1293, '2016-06-25 14:45:51', NULL, NULL, 500, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 14:45:51', 'admin-1466827306-14668371515557814', 1, 1, 'SR', NULL, NULL, NULL),
(1294, '2016-06-25 13:59:16', NULL, NULL, 499, 0, 181, '116', 'Open Food ', 'Magazine', 'Open', 'Food', 1, 12.75, 12.7500, 0.0000, 12.75, 1, '27', 1, '1466862001', 'admin', '2016-06-25 13:59:16', 'admin-1466827306-14668343559777790', 1, 0, '', NULL, NULL, NULL),
(1295, '2016-06-25 13:36:51', NULL, NULL, 498, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 13:36:51', 'admin-1466827306-14668330117303848', 1, 1, 'SR', NULL, NULL, NULL),
(1296, '2016-06-25 13:36:51', NULL, NULL, 498, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 13:36:51', 'admin-1466827306-14668330117303848', 1, 1, 'SR', NULL, NULL, NULL),
(1297, '2016-06-25 13:26:19', NULL, NULL, 497, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 4, 12.00, 48.0000, 0.0000, 48.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 13:26:19', 'admin-1466827306-146683237932913', 1, 1, 'SR', NULL, NULL, NULL),
(1298, '2016-06-25 13:26:19', NULL, NULL, 497, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 9, 12.00, 108.0000, 0.0000, 108.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 13:26:19', 'admin-1466827306-146683237932913', 1, 1, 'SR', NULL, NULL, NULL),
(1299, '2016-06-25 13:26:19', NULL, NULL, 497, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 13:26:19', 'admin-1466827306-146683237932913', 1, 1, 'SR', NULL, NULL, NULL),
(1300, '2016-06-25 13:07:28', NULL, NULL, 496, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 13:07:28', 'admin-1466827306-14668312482402567', 1, 1, 'SR', NULL, NULL, NULL),
(1301, '2016-06-25 13:07:28', NULL, NULL, 496, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 13:07:28', 'admin-1466827306-14668312482402567', 1, 1, 'SR', NULL, NULL, NULL),
(1302, '2016-06-25 12:17:15', NULL, NULL, 489, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:17:15', 'admin-1466827306-14668282352114068', 1, 0, '', NULL, NULL, NULL),
(1303, '2016-06-25 12:17:38', NULL, NULL, 490, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:17:38', 'admin-1466827306-1466828257880511', 1, 1, 'SR', NULL, NULL, NULL),
(1304, '2016-06-25 11:41:18', NULL, NULL, 482, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 11:41:18', 'admin-1466820201-14668260784908818', 1, 1, 'SR', NULL, NULL, NULL),
(1305, '2016-06-25 12:16:28', NULL, NULL, 488, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:16:28', 'admin-1466827306-14668281884217358', 1, 1, 'SR', NULL, NULL, NULL),
(1306, '2016-06-25 12:15:10', NULL, NULL, 487, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 12:15:10', 'admin-1466827306-14668281102292453', 1, 1, 'SR', NULL, NULL, NULL),
(1307, '2016-06-25 11:40:35', NULL, NULL, 481, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 11:40:35', 'admin-1466820201-14668260354796732', 1, 0, '', NULL, NULL, '10.0'),
(1308, '2016-06-25 11:40:35', NULL, NULL, 481, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 11:40:35', 'admin-1466820201-14668260354796732', 1, 1, 'SR', NULL, NULL, '10.0'),
(1309, '2016-06-25 11:40:35', NULL, NULL, 481, 0, 38, '38', 'Kiwi Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 11:40:35', 'admin-1466820201-14668260354796732', 1, 1, 'SR', NULL, NULL, '10.0'),
(1310, '2016-06-25 11:40:35', NULL, NULL, 481, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 11:40:35', 'admin-1466820201-14668260354796732', 1, 0, '', NULL, NULL, '10.0'),
(1311, '2016-06-25 11:40:35', NULL, NULL, 481, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 11:40:35', 'admin-1466820201-14668260354796732', 1, 0, '', NULL, NULL, '10.0'),
(1312, '2016-06-25 11:40:35', NULL, NULL, 481, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 11:40:35', 'admin-1466820201-14668260354796732', 1, 0, '', NULL, NULL, '10.0'),
(1313, '2016-06-25 10:27:55', NULL, NULL, 479, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 10:27:55', 'admin-1466820201-14668216754043469', 1, 0, '', NULL, NULL, NULL),
(1314, '2016-06-25 10:27:55', NULL, NULL, 479, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 10:27:55', 'admin-1466820201-14668216754043469', 1, 1, 'SR', NULL, NULL, NULL),
(1315, '2016-06-25 10:27:55', NULL, NULL, 479, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 10:27:55', 'admin-1466820201-14668216754043469', 1, 1, 'SR', NULL, NULL, NULL),
(1316, '2016-06-25 10:27:55', NULL, NULL, 479, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 10:27:55', 'admin-1466820201-14668216754043469', 1, 1, 'SR', NULL, NULL, NULL),
(1317, '2016-06-25 10:40:20', NULL, NULL, 480, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 10:40:20', 'admin-1466820201-14668224203315789', 1, 1, 'SR', NULL, NULL, NULL),
(1318, '2016-06-25 10:27:55', NULL, NULL, 479, 0, 159, '93', 'Granola ', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 10:27:55', 'admin-1466820201-14668216754043469', 1, 0, '', NULL, NULL, NULL),
(1319, '2016-06-25 09:27:02', NULL, NULL, 474, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:27:02', 'admin-1466816172-1466818022431924', 1, 0, '', NULL, NULL, NULL),
(1320, '2016-06-25 09:27:02', NULL, NULL, 474, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:27:02', 'admin-1466816172-1466818022431924', 1, 0, '', NULL, NULL, NULL),
(1321, '2016-06-25 09:27:02', NULL, NULL, 474, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:27:02', 'admin-1466816172-1466818022431924', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(1322, '2016-06-25 09:27:02', NULL, NULL, 474, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:27:02', 'admin-1466816172-1466818022431924', 1, 0, '', NULL, NULL, NULL),
(1323, '2016-06-25 09:27:02', NULL, NULL, 474, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:27:02', 'admin-1466816172-1466818022431924', 1, 1, 'SR', NULL, NULL, NULL),
(1324, '2016-06-25 09:08:14', NULL, NULL, 472, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:08:14', 'admin-1466816172-14668168947467671', 1, 0, '', NULL, NULL, NULL),
(1325, '2016-06-25 09:08:14', NULL, NULL, 472, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:08:14', 'admin-1466816172-14668168947467671', 1, 1, 'SR', NULL, NULL, NULL),
(1326, '2016-06-25 09:08:14', NULL, NULL, 472, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:08:14', 'admin-1466816172-14668168947467671', 1, 1, 'SR', NULL, NULL, NULL),
(1327, '2016-06-25 09:08:14', NULL, NULL, 472, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:08:14', 'admin-1466816172-14668168947467671', 1, 1, 'SR', NULL, NULL, NULL),
(1328, '2016-06-25 09:22:27', NULL, NULL, 473, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:22:27', 'admin-1466816172-14668177471605890', 1, 0, '', NULL, NULL, NULL),
(1329, '2016-06-25 09:22:27', NULL, NULL, 473, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:22:27', 'admin-1466816172-14668177471605890', 1, 1, 'SR', NULL, NULL, NULL),
(1330, '2016-06-25 09:08:14', NULL, NULL, 472, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:08:14', 'admin-1466816172-14668168947467671', 1, 0, '', NULL, NULL, NULL),
(1331, '2016-06-25 09:02:32', NULL, NULL, 471, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:02:32', 'admin-1466816172-1466816552139491', 1, 0, '', NULL, NULL, NULL),
(1332, '2016-06-25 09:08:14', NULL, NULL, 472, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:08:14', 'admin-1466816172-14668168947467671', 1, 0, '', NULL, NULL, NULL),
(1333, '2016-06-25 09:08:14', NULL, NULL, 472, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:08:14', 'admin-1466816172-14668168947467671', 1, 0, '', NULL, NULL, NULL),
(1334, '2016-06-25 09:02:32', NULL, NULL, 471, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466862001', 'admin', '2016-06-25 09:02:32', 'admin-1466816172-1466816552139491', 1, 1, 'SR', NULL, NULL, NULL),
(1335, '2016-06-26 20:18:35', NULL, NULL, 550, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 20:18:35', 'admin-1466926301-14669435148618279', 1, 1, 'SR', NULL, NULL, NULL),
(1336, '2016-06-26 20:20:07', NULL, NULL, 550, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 20:20:07', 'admin-1466926301-14669436069827145', 1, 1, 'SR', NULL, NULL, NULL),
(1337, '2016-06-26 20:18:34', NULL, NULL, 550, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 20:18:35', 'admin-1466926301-14669435148618279', 1, 0, '', NULL, NULL, NULL),
(1338, '2016-06-26 19:37:00', NULL, NULL, 547, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 19:37:00', 'admin-1466926301-14669410206732259', 1, 0, '', NULL, NULL, '10.0'),
(1339, '2016-06-26 19:36:52', NULL, NULL, 549, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 19:36:52', 'admin-1466926301-14669410127883266', 1, 1, 'SR', NULL, NULL, NULL),
(1340, '2016-06-26 19:36:52', NULL, NULL, 549, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 19:36:52', 'admin-1466926301-14669410127883266', 1, 1, 'SR', NULL, NULL, NULL),
(1341, '2016-06-26 19:04:56', NULL, NULL, 548, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 19:04:56', 'admin-1466926301-14669390959287695', 1, 1, 'SR', NULL, NULL, NULL),
(1342, '2016-06-26 18:51:51', NULL, NULL, 547, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 18:51:51', 'admin-1466926301-14669383113613852', 1, 1, 'SR', NULL, NULL, '10.0'),
(1343, '2016-06-26 18:51:51', NULL, NULL, 547, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 18:51:51', 'admin-1466926301-14669383113613852', 1, 1, 'SR', NULL, NULL, '10.0'),
(1344, '2016-06-26 18:51:51', NULL, NULL, 547, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 18:51:51', 'admin-1466926301-14669383113613852', 1, 0, '', NULL, NULL, '10.0'),
(1345, '2016-06-26 18:51:51', NULL, NULL, 547, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 18:51:51', 'admin-1466926301-14669383113613852', 1, 1, 'SR', NULL, NULL, '10.0'),
(1346, '2016-06-26 18:51:51', NULL, NULL, 547, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 18:51:51', 'admin-1466926301-14669383113613852', 1, 0, '', NULL, NULL, '10.0'),
(1347, '2016-06-26 18:51:51', NULL, NULL, 547, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 3, 12.00, 36.0000, 0.0000, 36.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 18:51:51', 'admin-1466926301-14669383113613852', 1, 1, 'SR', NULL, NULL, '10.0'),
(1348, '2016-06-26 18:51:51', NULL, NULL, 547, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 18:51:51', 'admin-1466926301-14669383113613852', 1, 1, 'SR', NULL, NULL, '10.0'),
(1349, '2016-06-26 18:51:51', NULL, NULL, 547, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 18:51:51', 'admin-1466926301-14669383113613852', 1, 1, 'SR', NULL, NULL, '10.0'),
(1350, '2016-06-26 18:51:51', NULL, NULL, 547, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 18:51:51', 'admin-1466926301-14669383113613852', 1, 1, 'SR', NULL, NULL, '10.0'),
(1351, '2016-06-26 18:27:49', NULL, NULL, 545, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 18:27:49', 'admin-1466926301-14669368689786932', 1, 1, 'SR', NULL, NULL, NULL),
(1352, '2016-06-26 18:27:49', NULL, NULL, 545, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 18:27:49', 'admin-1466926301-14669368689786932', 1, 1, 'SR', NULL, NULL, NULL),
(1353, '2016-06-26 18:30:18', NULL, NULL, 546, 0, 181, '116', 'Open Food ', 'Rice', 'Open', 'Food', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 18:30:18', 'admin-1466926301-14669370182819392', 1, 0, '', NULL, NULL, NULL),
(1354, '2016-06-26 18:30:18', NULL, NULL, 546, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 18:30:18', 'admin-1466926301-14669370182819392', 1, 1, 'SR', NULL, NULL, NULL),
(1355, '2016-06-26 18:23:51', NULL, NULL, 544, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 18:23:51', 'admin-1466926301-14669366309071963', 1, 1, 'SR', NULL, NULL, NULL),
(1356, '2016-06-26 18:27:49', NULL, NULL, 545, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 18:27:49', 'admin-1466926301-14669368689786932', 1, 1, 'SR', NULL, NULL, NULL),
(1357, '2016-06-26 18:27:49', NULL, NULL, 545, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 18:27:49', 'admin-1466926301-14669368689786932', 1, 1, 'SR', NULL, NULL, NULL),
(1358, '2016-06-26 18:27:49', NULL, NULL, 545, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 18:27:49', 'admin-1466926301-14669368689786932', 1, 1, 'SR', NULL, NULL, NULL),
(1359, '2016-06-26 18:27:49', NULL, NULL, 545, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 18:27:49', 'admin-1466926301-14669368689786932', 1, 0, '', NULL, NULL, NULL),
(1360, '2016-06-26 18:27:49', NULL, NULL, 545, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 18:27:49', 'admin-1466926301-14669368689786932', 1, 0, '', NULL, NULL, NULL),
(1361, '2016-06-26 18:27:49', NULL, NULL, 545, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 18:27:49', 'admin-1466926301-14669368689786932', 1, 1, 'SR', NULL, NULL, NULL),
(1362, '2016-06-26 18:27:49', NULL, NULL, 545, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 18:27:49', 'admin-1466926301-14669368689786932', 1, 1, 'SR', NULL, NULL, NULL),
(1363, '2016-06-26 17:37:13', NULL, NULL, 542, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 17:37:13', 'admin-1466926301-14669338329486646', 1, 1, 'SR', NULL, NULL, NULL),
(1364, '2016-06-26 17:57:58', NULL, NULL, 543, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 17:57:58', 'admin-1466926301-14669350786371364', 1, 1, 'SR', NULL, NULL, NULL),
(1365, '2016-06-26 17:57:58', NULL, NULL, 543, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 17:57:58', 'admin-1466926301-14669350786371364', 1, 1, 'SR', NULL, NULL, NULL),
(1366, '2016-06-26 17:57:58', NULL, NULL, 543, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 17:57:58', 'admin-1466926301-14669350786371364', 1, 0, '', NULL, NULL, NULL),
(1367, '2016-06-26 17:37:13', NULL, NULL, 542, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 17:37:13', 'admin-1466926301-14669338329486646', 1, 1, 'SR', NULL, NULL, NULL),
(1368, '2016-06-26 16:24:48', NULL, NULL, 541, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 16:24:48', 'admin-1466926301-14669294879775125', 1, 0, '', NULL, NULL, NULL),
(1369, '2016-06-26 13:02:11', NULL, NULL, 531, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 13:02:11', 'admin-1466917220-14669173311986135', 1, 1, 'SR', NULL, NULL, NULL),
(1370, '2016-06-26 16:00:13', NULL, NULL, 540, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 16:00:13', 'admin-1466926301-14669280130944326', 1, 0, '', NULL, NULL, NULL),
(1371, '2016-06-26 16:00:06', NULL, NULL, 540, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 16:00:06', 'admin-1466926301-14669280062616490', 1, 0, '', NULL, NULL, NULL),
(1372, '2016-06-26 15:37:36', NULL, NULL, 539, 0, 181, '116', 'Open Food ', 'magazine', 'Open', 'Food', 1, 12.75, 12.7500, 0.0000, 12.75, 1, '27', 1, '1466949440', 'admin', '2016-06-26 15:37:36', 'admin-1466926301-14669266563844416', 1, 0, '', NULL, NULL, NULL),
(1373, '2016-06-26 15:32:25', NULL, NULL, 538, 0, 181, '116', 'Open Food ', 'Chicken Wing', 'Open', 'Food', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 15:32:25', 'admin-1466926301-14669263451457844', 1, 0, '', NULL, NULL, NULL),
(1374, '2016-06-26 15:13:28', NULL, NULL, 538, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 15:13:28', 'admin-1466917220-14669252081232310', 1, 0, '', NULL, NULL, NULL),
(1375, '2016-06-26 14:50:26', NULL, NULL, 538, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 14:50:26', 'admin-1466917220-14669238258261957', 1, 1, 'SR', NULL, NULL, NULL),
(1376, '2016-06-26 14:50:26', NULL, NULL, 538, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 14:50:26', 'admin-1466917220-14669238258261957', 1, 1, 'SR', NULL, NULL, NULL),
(1377, '2016-06-26 14:50:26', NULL, NULL, 538, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 14:50:26', 'admin-1466917220-14669238258261957', 1, 0, '', NULL, NULL, NULL),
(1378, '2016-06-26 14:50:26', NULL, NULL, 538, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 14:50:26', 'admin-1466917220-14669238258261957', 1, 1, 'SR', NULL, NULL, NULL),
(1379, '2016-06-26 14:50:26', NULL, NULL, 538, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 14:50:26', 'admin-1466917220-14669238258261957', 1, 1, 'SR', NULL, NULL, NULL),
(1380, '2016-06-26 10:49:48', NULL, NULL, 520, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:49:48', 'admin-1466908083-14669093880702896', 1, 0, '', NULL, NULL, NULL),
(1381, '2016-06-26 10:49:48', NULL, NULL, 520, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:49:48', 'admin-1466908083-14669093880702896', 1, 0, '', NULL, NULL, NULL),
(1382, '2016-06-26 10:49:48', NULL, NULL, 520, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:49:48', 'admin-1466908083-14669093880702896', 1, 0, '', NULL, NULL, NULL),
(1383, '2016-06-26 10:49:48', NULL, NULL, 520, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:49:48', 'admin-1466908083-14669093880702896', 1, 1, 'SR', NULL, NULL, NULL),
(1384, '2016-06-26 10:49:48', NULL, NULL, 520, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:49:48', 'admin-1466908083-14669093880702896', 1, 1, 'SR', NULL, NULL, NULL),
(1385, '2016-06-26 10:49:48', NULL, NULL, 520, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:49:48', 'admin-1466908083-14669093880702896', 1, 1, 'SR', NULL, NULL, NULL),
(1386, '2016-06-26 10:54:04', NULL, NULL, 521, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:54:04', 'admin-1466908083-14669096447377530', 1, 0, '', NULL, NULL, NULL),
(1387, '2016-06-26 10:54:04', NULL, NULL, 521, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:54:04', 'admin-1466908083-14669096447377530', 1, 0, '', NULL, NULL, NULL),
(1388, '2016-06-26 10:54:04', NULL, NULL, 521, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:54:04', 'admin-1466908083-14669096447377530', 1, 1, 'SR', NULL, NULL, NULL),
(1389, '2016-06-26 10:54:04', NULL, NULL, 521, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:54:04', 'admin-1466908083-14669096447377530', 1, 1, 'SR', NULL, NULL, NULL),
(1390, '2016-06-26 11:32:51', NULL, NULL, 522, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 11:32:51', 'admin-1466908083-14669119716346815', 1, 0, '', NULL, NULL, NULL),
(1391, '2016-06-26 11:32:51', NULL, NULL, 522, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 11:32:51', 'admin-1466908083-14669119716346815', 1, 1, 'SR', NULL, NULL, NULL),
(1392, '2016-06-26 11:33:02', NULL, NULL, 523, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 11:33:02', 'admin-1466908083-14669119825655369', 1, 1, 'SR', NULL, NULL, NULL),
(1393, '2016-06-26 11:33:08', NULL, NULL, 523, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 11:33:08', 'admin-1466908083-14669119880457386', 1, 1, 'SR', NULL, NULL, NULL),
(1394, '2016-06-26 11:53:32', NULL, NULL, 524, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 11:53:32', 'admin-1466908083-14669132124181936', 1, 1, 'SR', NULL, NULL, NULL),
(1395, '2016-06-26 10:27:45', NULL, NULL, 519, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:27:45', 'admin-1466903924-14669080652565426', 1, 0, '', NULL, NULL, NULL),
(1396, '2016-06-26 10:27:45', NULL, NULL, 519, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:27:45', 'admin-1466903924-14669080652565426', 1, 1, 'SR', NULL, NULL, NULL),
(1397, '2016-06-26 14:50:26', NULL, NULL, 538, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 14:50:26', 'admin-1466917220-14669238258261957', 1, 0, '', NULL, NULL, NULL),
(1398, '2016-06-26 14:34:20', NULL, NULL, 537, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 14:34:20', 'admin-1466917220-14669228597897919', 1, 0, '', NULL, NULL, NULL),
(1399, '2016-06-26 14:34:19', NULL, NULL, 537, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 14:34:19', 'admin-1466917220-14669228597897919', 1, 0, '', NULL, NULL, NULL),
(1400, '2016-06-26 11:53:32', NULL, NULL, 524, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 11:53:32', 'admin-1466908083-14669132124181936', 1, 1, 'SR', NULL, NULL, NULL),
(1401, '2016-06-26 10:03:10', NULL, NULL, 515, 0, 39, '39', 'Mango Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:03:10', 'admin-1466903924-14669065899839456', 1, 1, 'SR', NULL, NULL, NULL),
(1402, '2016-06-26 10:03:58', NULL, NULL, 515, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:03:58', 'admin-1466903924-1466906638657375', 1, 1, 'SR', NULL, NULL, NULL),
(1403, '2016-06-26 10:03:10', NULL, NULL, 515, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:03:10', 'admin-1466903924-14669065899839456', 1, 1, 'SR', NULL, NULL, NULL),
(1404, '2016-06-26 14:34:19', NULL, NULL, 537, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 14:34:19', 'admin-1466917220-14669228597897919', 1, 1, 'SR', NULL, NULL, NULL),
(1405, '2016-06-26 14:34:19', NULL, NULL, 537, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 14:34:19', 'admin-1466917220-14669228597897919', 1, 1, 'SR', NULL, NULL, NULL),
(1406, '2016-06-26 13:56:44', NULL, NULL, 531, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 13:56:44', 'admin-1466917220-1466920604653164', 1, 1, 'SR', NULL, NULL, NULL),
(1407, '2016-06-26 13:47:58', NULL, NULL, 536, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 13:47:58', 'admin-1466917220-14669200784978843', 1, 0, '', 1, NULL, NULL),
(1408, '2016-06-26 13:47:58', NULL, NULL, 536, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 13:47:58', 'admin-1466917220-14669200784978843', 1, 0, '', 1, NULL, NULL),
(1409, '2016-06-26 13:28:18', NULL, NULL, 535, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 13:28:18', 'admin-1466917220-14669188986606621', 1, 1, 'SR', NULL, NULL, NULL),
(1410, '2016-06-26 13:28:18', NULL, NULL, 535, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 13:28:18', 'admin-1466917220-14669188986606621', 1, 1, 'SR', NULL, NULL, NULL),
(1411, '2016-06-26 13:28:18', NULL, NULL, 535, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 13:28:18', 'admin-1466917220-14669188986606621', 1, 1, 'SR', NULL, NULL, NULL),
(1412, '2016-06-26 13:23:18', NULL, NULL, 534, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 13:23:18', 'admin-1466917220-14669185983189586', 1, 1, 'SR', NULL, NULL, NULL),
(1413, '2016-06-26 13:15:07', NULL, NULL, 533, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 13:15:07', 'admin-1466917220-14669181074072342', 1, 1, 'SR', NULL, NULL, NULL),
(1414, '2016-06-26 13:12:54', NULL, NULL, 532, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 13:12:54', 'admin-1466917220-1466917974656856', 1, 1, 'SR', NULL, NULL, NULL),
(1415, '2016-06-26 13:02:11', NULL, NULL, 531, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 13:02:11', 'admin-1466917220-14669173311986135', 1, 0, '', NULL, NULL, NULL),
(1416, '2016-06-26 13:02:11', NULL, NULL, 531, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 13:02:11', 'admin-1466917220-14669173311986135', 1, 1, 'SR', NULL, NULL, NULL),
(1417, '2016-06-26 13:02:11', NULL, NULL, 531, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 13:02:11', 'admin-1466917220-14669173311986135', 1, 1, 'SR', NULL, NULL, NULL),
(1418, '2016-06-26 13:02:11', NULL, NULL, 531, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 13:02:11', 'admin-1466917220-14669173311986135', 1, 1, 'SR', NULL, NULL, NULL),
(1419, '2016-06-26 13:02:11', NULL, NULL, 531, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 2, 14.00, 28.0000, 0.0000, 28.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 13:02:11', 'admin-1466917220-14669173311986135', 1, 1, 'SR', NULL, NULL, NULL),
(1420, '2016-06-26 13:02:11', NULL, NULL, 531, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 13:02:11', 'admin-1466917220-14669173311986135', 1, 1, 'SR', NULL, NULL, NULL),
(1421, '2016-06-26 13:02:11', NULL, NULL, 531, 0, 83, '83', 'Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 13:02:11', 'admin-1466917220-14669173311986135', 1, 1, 'SR', NULL, NULL, NULL),
(1422, '2016-06-26 12:59:08', NULL, NULL, 531, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:59:08', 'admin-1466916185-14669171481597213', 1, 1, 'SR', NULL, NULL, NULL),
(1423, '2016-06-26 12:59:08', NULL, NULL, 531, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:59:08', 'admin-1466916185-14669171481597213', 1, 1, 'SR', NULL, NULL, NULL),
(1424, '2016-06-26 12:59:08', NULL, NULL, 531, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:59:08', 'admin-1466916185-14669171481597213', 1, 1, 'SR', NULL, NULL, NULL),
(1425, '2016-06-26 12:59:08', NULL, NULL, 531, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:59:08', 'admin-1466916185-14669171481597213', 1, 1, 'SR', NULL, NULL, NULL),
(1426, '2016-06-26 12:45:13', NULL, NULL, 530, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:45:13', 'admin-1466916185-14669163130834391', 1, 0, '', NULL, NULL, NULL),
(1427, '2016-06-26 12:45:13', NULL, NULL, 530, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:45:13', 'admin-1466916185-14669163130834391', 1, 1, 'SR', NULL, NULL, NULL),
(1428, '2016-06-26 12:45:13', NULL, NULL, 530, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:45:13', 'admin-1466916185-14669163130834391', 1, 1, 'SR', NULL, NULL, NULL),
(1429, '2016-06-26 12:44:21', NULL, NULL, 529, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:44:21', 'admin-1466916185-14669162617415776', 1, 1, 'SR', NULL, NULL, NULL),
(1430, '2016-06-26 12:41:30', NULL, NULL, 529, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:41:30', 'admin-1466908083-14669160902405499', 1, 1, 'SR', NULL, NULL, NULL),
(1431, '2016-06-26 12:43:46', NULL, NULL, 529, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:43:46', 'admin-1466916185-14669162263722419', 1, 0, '', NULL, NULL, NULL),
(1432, '2016-06-26 12:41:30', NULL, NULL, 529, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:41:30', 'admin-1466908083-14669160902405499', 1, 1, 'SR', NULL, NULL, NULL),
(1433, '2016-06-26 12:41:30', NULL, NULL, 529, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:41:30', 'admin-1466908083-14669160902405499', 1, 1, 'SR', NULL, NULL, NULL),
(1434, '2016-06-26 12:43:46', NULL, NULL, 529, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:43:46', 'admin-1466916185-14669162263722419', 1, 0, '', NULL, NULL, NULL),
(1435, '2016-06-26 12:41:30', NULL, NULL, 529, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:41:30', 'admin-1466908083-14669160902405499', 1, 0, '', NULL, NULL, NULL),
(1436, '2016-06-26 12:41:30', NULL, NULL, 529, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:41:30', 'admin-1466908083-14669160902405499', 1, 1, 'SR', NULL, NULL, NULL),
(1437, '2016-06-26 11:53:32', NULL, NULL, 524, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 11:53:32', 'admin-1466908083-14669132124181936', 1, 1, 'SR', NULL, NULL, NULL),
(1438, '2016-06-26 12:01:12', NULL, NULL, 525, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:01:12', 'admin-1466908083-14669136718041476', 1, 1, 'SR', NULL, NULL, NULL),
(1439, '2016-06-26 12:19:59', NULL, NULL, 526, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:19:59', 'admin-1466908083-1466914799486726', 1, 0, '', NULL, NULL, NULL),
(1440, '2016-06-26 12:19:59', NULL, NULL, 526, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:19:59', 'admin-1466908083-1466914799486726', 1, 1, 'SR', NULL, NULL, NULL),
(1441, '2016-06-26 12:19:59', NULL, NULL, 526, 0, 83, '83', 'Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:19:59', 'admin-1466908083-1466914799486726', 1, 1, 'SR', NULL, NULL, NULL),
(1442, '2016-06-26 12:19:59', NULL, NULL, 526, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:19:59', 'admin-1466908083-1466914799486726', 1, 0, '', NULL, NULL, NULL),
(1443, '2016-06-26 12:19:59', NULL, NULL, 526, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:19:59', 'admin-1466908083-1466914799486726', 1, 0, '', NULL, NULL, NULL),
(1444, '2016-06-26 12:32:00', NULL, NULL, 528, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:32:00', 'admin-1466908083-14669155202913952', 1, 0, '', NULL, NULL, NULL),
(1445, '2016-06-26 12:41:30', NULL, NULL, 529, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:41:30', 'admin-1466908083-14669160902405499', 1, 1, 'SR', NULL, NULL, NULL),
(1446, '2016-06-26 12:27:20', NULL, NULL, 527, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:27:20', 'admin-1466908083-14669152401122093', 1, 0, '', NULL, NULL, NULL),
(1447, '2016-06-26 12:32:00', NULL, NULL, 528, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 12:32:00', 'admin-1466908083-14669155202913952', 1, 0, '', NULL, NULL, NULL),
(1448, '2016-06-26 11:53:32', NULL, NULL, 524, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 11:53:32', 'admin-1466908083-14669132124181936', 1, 1, 'SR', NULL, NULL, NULL),
(1449, '2016-06-26 10:49:48', NULL, NULL, 520, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:49:48', 'admin-1466908083-14669093880702896', 1, 0, '', NULL, NULL, NULL),
(1450, '2016-06-26 10:49:48', NULL, NULL, 520, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:49:48', 'admin-1466908083-14669093880702896', 1, 0, '', NULL, NULL, NULL),
(1451, '2016-06-26 10:49:48', NULL, NULL, 520, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:49:48', 'admin-1466908083-14669093880702896', 1, 1, 'SR', NULL, NULL, NULL),
(1452, '2016-06-26 10:49:48', NULL, NULL, 520, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:49:48', 'admin-1466908083-14669093880702896', 1, 1, 'SR', NULL, NULL, NULL),
(1453, '2016-06-26 10:27:45', NULL, NULL, 519, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:27:45', 'admin-1466903924-14669080652565426', 1, 0, '', NULL, NULL, NULL),
(1454, '2016-06-26 10:28:48', NULL, NULL, 519, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:28:48', 'admin-1466908083-14669081278854787', 1, 1, 'SR', NULL, NULL, NULL),
(1455, '2016-06-26 10:27:45', NULL, NULL, 519, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:27:45', 'admin-1466903924-14669080652565426', 1, 0, '', NULL, NULL, NULL),
(1456, '2016-06-26 10:19:17', NULL, NULL, 518, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:19:17', 'admin-1466903924-14669075569963620', 1, 1, 'SR', NULL, NULL, NULL),
(1457, '2016-06-26 10:19:17', NULL, NULL, 518, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:19:17', 'admin-1466903924-14669075569963620', 1, 1, 'SR', NULL, NULL, NULL),
(1458, '2016-06-26 10:19:25', NULL, NULL, 515, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:19:25', 'admin-1466903924-1466907565641504', 1, 1, 'SR', NULL, NULL, NULL),
(1459, '2016-06-26 10:27:45', NULL, NULL, 519, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:27:45', 'admin-1466903924-14669080652565426', 1, 0, '', NULL, NULL, NULL),
(1460, '2016-06-26 10:17:54', NULL, NULL, 517, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:17:54', 'admin-1466903924-14669074741087930', 1, 0, '', NULL, NULL, NULL),
(1461, '2016-06-26 10:17:54', NULL, NULL, 517, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:17:54', 'admin-1466903924-14669074741087930', 1, 0, '', NULL, NULL, NULL),
(1462, '2016-06-26 10:09:21', NULL, NULL, 516, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:09:21', 'admin-1466903924-14669069616014453', 1, 1, 'SR', NULL, NULL, NULL),
(1463, '2016-06-26 10:03:10', NULL, NULL, 515, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:03:10', 'admin-1466903924-14669065899839456', 1, 0, '', NULL, NULL, NULL),
(1464, '2016-06-26 09:45:06', NULL, NULL, 514, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 09:45:06', 'admin-1466903924-14669055062114449', 1, 0, '', NULL, NULL, NULL),
(1465, '2016-06-26 09:45:06', NULL, NULL, 514, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 09:45:06', 'admin-1466903924-14669055062114449', 1, 0, '', NULL, NULL, NULL),
(1466, '2016-06-26 09:45:06', NULL, NULL, 514, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 09:45:06', 'admin-1466903924-14669055062114449', 1, 0, '', NULL, NULL, NULL),
(1467, '2016-06-26 10:03:10', NULL, NULL, 515, 0, 159, '93', 'Granola ', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:03:10', 'admin-1466903924-14669065899839456', 1, 0, '', NULL, NULL, NULL),
(1468, '2016-06-26 10:03:10', NULL, NULL, 515, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:03:10', 'admin-1466903924-14669065899839456', 1, 0, '', NULL, NULL, NULL),
(1469, '2016-06-26 09:35:01', NULL, NULL, 513, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 09:35:01', 'admin-1466903924-14669049016334972', 1, 0, '', NULL, NULL, NULL),
(1470, '2016-06-26 09:35:57', NULL, NULL, 513, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 09:35:57', 'admin-1466903924-14669049574591588', 1, 0, '', NULL, NULL, NULL),
(1471, '2016-06-26 09:45:06', NULL, NULL, 514, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 18.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 09:45:06', 'admin-1466903924-14669055062114449', 1, 0, '', NULL, '10.0', NULL),
(1472, '2016-06-26 09:45:06', NULL, NULL, 514, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 13.50, 1, '27', 1, '1466949440', 'admin', '2016-06-26 09:45:06', 'admin-1466903924-14669055062114449', 1, 0, '', NULL, '10.0', NULL),
(1473, '2016-06-26 09:45:06', NULL, NULL, 514, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 13.50, 1, '27', 1, '1466949440', 'admin', '2016-06-26 09:45:06', 'admin-1466903924-14669055062114449', 1, 0, '', NULL, '10.0', NULL),
(1474, '2016-06-26 09:45:06', NULL, NULL, 514, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 13.50, 1, '27', 1, '1466949440', 'admin', '2016-06-26 09:45:06', 'admin-1466903924-14669055062114449', 1, 0, '', NULL, '10.0', NULL),
(1475, '2016-06-26 09:35:01', NULL, NULL, 513, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 09:35:01', 'admin-1466903924-14669049016334972', 1, 0, '', NULL, NULL, NULL),
(1476, '2016-06-26 09:35:01', NULL, NULL, 513, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 09:35:01', 'admin-1466903924-14669049016334972', 1, 0, '', NULL, NULL, NULL),
(1477, '2016-06-26 10:17:54', NULL, NULL, 517, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 10:17:54', 'admin-1466903924-14669074741087930', 1, 0, '', NULL, NULL, NULL),
(1478, '2016-06-26 09:26:22', NULL, NULL, 511, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 09:26:22', 'admin-1466903924-14669043823431456', 1, 1, 'SR', NULL, NULL, NULL),
(1479, '2016-06-26 09:26:22', NULL, NULL, 511, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 09:26:22', 'admin-1466903924-14669043823431456', 1, 0, '', NULL, NULL, NULL),
(1480, '2016-06-26 09:26:22', NULL, NULL, 511, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 09:26:22', 'admin-1466903924-14669043823431456', 1, 1, 'SR', NULL, NULL, NULL),
(1481, '2016-06-26 20:20:07', NULL, NULL, 550, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 20:20:07', 'admin-1466926301-14669436069827145', 1, 1, 'SR', NULL, NULL, NULL),
(1482, '2016-06-26 20:20:07', NULL, NULL, 550, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 20:20:07', 'admin-1466926301-14669436069827145', 1, 1, 'SR', NULL, NULL, NULL),
(1483, '2016-06-26 20:52:10', NULL, NULL, 551, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 20:52:10', 'admin-1466926301-14669455307051160', 1, 1, 'SR', NULL, NULL, NULL),
(1484, '2016-06-26 20:52:10', NULL, NULL, 551, NULL, 65, '65', 'Pineapple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1466949440', 'admin', '2016-06-26 20:52:10', 'admin-1466926301-14669455307051160', 1, 1, 'SR', NULL, NULL, NULL),
(1485, '2016-06-27 17:02:13', NULL, NULL, 576, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 17:02:13', 'admin-1467003573-1467018133195261', 1, 1, 'SR', 1, NULL, NULL),
(1486, '2016-06-27 17:04:51', NULL, NULL, 577, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 17:04:51', 'admin-1467003573-14670182911743852', 1, 1, 'SR', NULL, NULL, NULL),
(1487, '2016-06-27 18:43:25', NULL, NULL, 578, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 18:43:25', 'admin-1467003573-14670242055866190', 1, 0, '', NULL, NULL, NULL),
(1488, '2016-06-27 18:43:25', NULL, NULL, 578, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 18:43:25', 'admin-1467003573-14670242055866190', 1, 0, '', NULL, NULL, NULL),
(1489, '2016-06-27 19:05:44', NULL, NULL, 579, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 19:05:44', 'admin-1467003573-1467025544649981', 1, 1, 'SR', 1, NULL, NULL),
(1490, '2016-06-27 20:56:52', NULL, NULL, 580, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 20:56:52', 'admin-1467003573-14670322128136252', 1, 1, 'SR', NULL, NULL, NULL),
(1491, '2016-06-27 20:56:52', NULL, NULL, 580, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 20:56:52', 'admin-1467003573-14670322128136252', 1, 1, 'SR', NULL, NULL, NULL),
(1492, '2016-06-27 20:56:52', NULL, NULL, 580, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 20:56:52', 'admin-1467003573-14670322128136252', 1, 1, 'SR', NULL, NULL, NULL),
(1493, '2016-06-27 20:56:52', NULL, NULL, 580, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 20:56:52', 'admin-1467003573-14670322128136252', 1, 1, 'SR', NULL, NULL, NULL),
(1494, '2016-06-27 12:03:43', NULL, NULL, 560, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 12:03:43', 'admin-1466989350-14670002232049061', 1, 1, 'SR', NULL, NULL, NULL),
(1495, '2016-06-27 12:03:43', NULL, NULL, 560, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 12:03:43', 'admin-1466989350-14670002232049061', 1, 1, 'SR', NULL, NULL, NULL),
(1496, '2016-06-27 12:18:41', NULL, NULL, 561, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 12:18:41', 'admin-1467000232-14670011209667769', 1, 0, '', NULL, NULL, NULL),
(1497, '2016-06-27 12:18:41', NULL, NULL, 561, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 12:18:41', 'admin-1467000232-14670011209667769', 1, 1, 'SR', NULL, NULL, NULL),
(1498, '2016-06-27 12:18:41', NULL, NULL, 561, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 12:18:41', 'admin-1467000232-14670011209667769', 1, 0, '', NULL, NULL, NULL),
(1499, '2016-06-27 12:27:25', NULL, NULL, 555, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 12:27:25', 'admin-1467000232-14670016451506198', 1, 0, '', NULL, NULL, NULL),
(1500, '2016-06-27 12:27:25', NULL, NULL, 555, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 12:27:25', 'admin-1467000232-14670016451506198', 1, 1, 'SR', NULL, NULL, NULL),
(1501, '2016-06-27 12:30:54', NULL, NULL, 562, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 12:30:54', 'admin-1467000232-14670018545174737', 1, 1, 'SR', NULL, NULL, NULL),
(1502, '2016-06-27 12:30:54', NULL, NULL, 562, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 12:30:54', 'admin-1467000232-14670018545174737', 1, 1, 'SR', NULL, NULL, NULL),
(1503, '2016-06-27 12:34:35', NULL, NULL, 563, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 12:34:35', 'admin-1467000232-14670020752412151', 1, 1, 'SR', NULL, NULL, NULL),
(1504, '2016-06-27 12:34:35', NULL, NULL, 563, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 12:34:35', 'admin-1467000232-14670020752412151', 1, 1, 'SR', NULL, NULL, NULL),
(1505, '2016-06-27 13:21:00', NULL, NULL, 566, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 13:21:00', 'admin-1467003573-14670048602136779', 1, 1, 'SR', NULL, NULL, NULL),
(1506, '2016-06-27 12:48:28', NULL, NULL, 561, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 12:48:28', 'admin-1467000232-14670029081675519', 1, 0, '', NULL, NULL, NULL),
(1507, '2016-06-27 12:59:19', NULL, NULL, 564, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 12:59:19', 'admin-1467000232-146700355977268', 1, 1, 'SR', NULL, NULL, NULL),
(1508, '2016-06-27 12:59:19', NULL, NULL, 564, NULL, 84, '84', 'Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 12:59:19', 'admin-1467000232-146700355977268', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(1509, '2016-06-27 13:11:25', NULL, NULL, 565, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 13:11:25', 'admin-1467003573-1467004285031740', 1, 1, 'SR', NULL, NULL, NULL),
(1510, '2016-06-27 13:21:00', NULL, NULL, 566, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 13:21:00', 'admin-1467003573-14670048602136779', 1, 1, 'SR', NULL, NULL, NULL),
(1511, '2016-06-27 13:21:00', NULL, NULL, 566, 0, 182, '117', 'Open Drinks ', 'Americano', 'Open', 'Drinks', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 13:21:00', 'admin-1467003573-14670048602136779', 1, 0, '', NULL, NULL, NULL),
(1512, '2016-06-27 13:21:00', NULL, NULL, 566, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 13:21:00', 'admin-1467003573-14670048602136779', 1, 0, '', NULL, NULL, NULL),
(1513, '2016-06-27 13:30:05', NULL, NULL, 567, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 13:30:05', 'admin-1467003573-14670054054252920', 1, 1, 'SR', NULL, NULL, NULL),
(1514, '2016-06-27 13:32:18', NULL, NULL, 568, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 13:32:18', 'admin-1467003573-14670055384112342', 1, 1, 'SR', NULL, NULL, NULL),
(1515, '2016-06-27 13:49:14', NULL, NULL, 569, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 13:49:14', 'admin-1467003573-14670065548111688', 1, 1, 'SR', NULL, NULL, NULL),
(1516, '2016-06-27 15:17:08', NULL, NULL, 570, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 15:17:08', 'admin-1467003573-14670118280182631', 1, 1, 'SR', NULL, NULL, NULL),
(1517, '2016-06-27 15:27:09', NULL, NULL, 571, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 15:27:09', 'admin-1467003573-14670124290674347', 1, 0, '', NULL, NULL, NULL),
(1518, '2016-06-27 15:27:09', NULL, NULL, 571, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 2, 14.00, 28.0000, 0.0000, 28.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 15:27:09', 'admin-1467003573-14670124290674347', 1, 1, 'SR', NULL, NULL, NULL),
(1519, '2016-06-27 15:30:34', NULL, NULL, 572, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 9.90, 1, '27', 1, '1467033993', 'admin', '2016-06-27 15:30:34', 'admin-1467003573-14670126344474814', 1, 1, 'SR', NULL, '10.0', NULL),
(1520, '2016-06-27 15:30:34', NULL, NULL, 572, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 9.90, 1, '27', 1, '1467033993', 'admin', '2016-06-27 15:30:34', 'admin-1467003573-14670126344474814', 1, 1, 'SR', NULL, '10.0', NULL),
(1521, '2016-06-27 15:52:12', NULL, NULL, 573, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 15:52:12', 'admin-1467003573-14670139326595123', 1, 1, 'SR', NULL, NULL, NULL),
(1522, '2016-06-27 15:52:12', NULL, NULL, 573, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 15:52:12', 'admin-1467003573-14670139326595123', 1, 0, '', NULL, NULL, NULL),
(1523, '2016-06-27 16:10:09', NULL, NULL, 575, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 16:10:09', 'admin-1467003573-14670150097355690', 1, 1, 'SR', NULL, NULL, NULL),
(1524, '2016-06-27 16:10:09', NULL, NULL, 575, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 16:10:09', 'admin-1467003573-14670150097355690', 1, 0, '', NULL, NULL, NULL),
(1525, '2016-06-27 16:10:09', NULL, NULL, 575, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 16:10:09', 'admin-1467003573-14670150097355690', 1, 0, '', NULL, NULL, NULL),
(1526, '2016-06-27 15:57:33', NULL, NULL, 574, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 15:57:33', 'admin-1467003573-14670142531929769', 1, 1, 'SR', NULL, NULL, NULL),
(1527, '2016-06-27 15:57:33', NULL, NULL, 574, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 15:57:33', 'admin-1467003573-14670142531929769', 1, 1, 'SR', NULL, NULL, NULL),
(1528, '2016-06-27 12:03:43', NULL, NULL, 560, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 12:03:43', 'admin-1466989350-14670002232049061', 1, 0, '', NULL, NULL, NULL),
(1529, '2016-06-27 12:03:43', NULL, NULL, 560, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 12:03:43', 'admin-1466989350-14670002232049061', 1, 0, '', NULL, NULL, NULL),
(1530, '2016-06-27 11:45:57', NULL, NULL, 559, 0, 182, '117', 'Open Drinks ', 'Americano', 'Open', 'Drinks', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 11:45:57', 'admin-1466989350-14669991574612520', 1, 0, '', NULL, NULL, NULL),
(1531, '2016-06-27 11:45:57', NULL, NULL, 559, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 11:45:57', 'admin-1466989350-14669991574612520', 1, 0, '', NULL, NULL, NULL),
(1532, '2016-06-27 11:37:31', NULL, NULL, 558, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 11:37:31', 'admin-1466989350-14669986515023462', 1, 1, 'SR', NULL, NULL, NULL),
(1533, '2016-06-27 11:37:31', NULL, NULL, 558, NULL, 65, '65', 'Pineapple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 11:37:31', 'admin-1466989350-14669986515023462', 1, 1, 'SR', NULL, NULL, NULL),
(1534, '2016-06-27 11:37:31', NULL, NULL, 558, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 11:37:31', 'admin-1466989350-14669986515023462', 1, 1, 'SR', NULL, NULL, NULL),
(1535, '2016-06-27 11:45:57', NULL, NULL, 559, NULL, 84, '84', 'Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 11:45:57', 'admin-1466989350-14669991574612520', 1, 1, 'SR', NULL, NULL, NULL),
(1536, '2016-06-27 11:45:57', NULL, NULL, 559, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 11:45:57', 'admin-1466989350-14669991574612520', 1, 1, 'SR', NULL, NULL, NULL),
(1537, '2016-06-27 11:45:57', NULL, NULL, 559, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 11:45:57', 'admin-1466989350-14669991574612520', 1, 1, 'SR', NULL, NULL, NULL),
(1538, '2016-06-27 11:20:42', NULL, NULL, 556, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 11:20:42', 'admin-1466989350-14669976426849267', 1, 0, '', NULL, NULL, NULL),
(1539, '2016-06-27 11:20:42', NULL, NULL, 556, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 11:20:42', 'admin-1466989350-14669976426849267', 1, 1, 'SR', NULL, NULL, NULL),
(1540, '2016-06-27 11:20:42', NULL, NULL, 556, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 11:20:42', 'admin-1466989350-14669976426849267', 1, 1, 'SR', NULL, NULL, NULL),
(1541, '2016-06-27 11:30:54', NULL, NULL, 557, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 11:30:54', 'admin-1466989350-14669982545614531', 1, 1, 'SR', NULL, NULL, NULL),
(1542, '2016-06-27 11:37:31', NULL, NULL, 558, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 11:37:31', 'admin-1466989350-14669986515023462', 1, 0, '', NULL, NULL, NULL),
(1543, '2016-06-27 11:37:31', NULL, NULL, 558, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 11:37:31', 'admin-1466989350-14669986515023462', 1, 0, '', NULL, NULL, NULL),
(1544, '2016-06-27 11:14:08', NULL, NULL, 555, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 11:14:08', 'admin-1466989350-14669972479105764', 1, 1, 'SR', NULL, NULL, NULL),
(1545, '2016-06-27 11:14:08', NULL, NULL, 555, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 11:14:08', 'admin-1466989350-14669972479105764', 1, 0, '', NULL, NULL, NULL),
(1546, '2016-06-27 11:20:42', NULL, NULL, 556, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 11:20:42', 'admin-1466989350-14669976426849267', 1, 0, '', NULL, NULL, NULL),
(1547, '2016-06-27 10:35:08', NULL, NULL, 553, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 10:35:08', 'admin-1466989350-14669949087135379', 1, 0, '', NULL, NULL, NULL),
(1548, '2016-06-27 10:35:08', NULL, NULL, 553, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 10:35:08', 'admin-1466989350-14669949087135379', 1, 1, 'SR', NULL, NULL, NULL),
(1549, '2016-06-27 10:35:08', NULL, NULL, 553, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 10:35:08', 'admin-1466989350-14669949087135379', 1, 1, 'SR', NULL, NULL, NULL),
(1550, '2016-06-27 10:49:38', NULL, NULL, 554, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 10:49:38', 'admin-1466989350-14669957782419774', 1, 1, 'SR', NULL, NULL, NULL),
(1551, '2016-06-27 10:35:08', NULL, NULL, 553, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 10:35:08', 'admin-1466989350-14669949087135379', 1, 0, '', NULL, NULL, NULL),
(1552, '2016-06-27 10:35:08', NULL, NULL, 553, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 10:35:08', 'admin-1466989350-14669949087135379', 1, 0, '', NULL, NULL, NULL),
(1553, '2016-06-27 10:26:24', NULL, NULL, 552, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 10:26:24', 'admin-1466989350-14669943847636620', 1, 0, '', NULL, NULL, NULL),
(1554, '2016-06-27 10:26:24', NULL, NULL, 552, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1467033993', 'admin', '2016-06-27 10:26:24', 'admin-1466989350-14669943847636620', 1, 1, 'SR', NULL, NULL, NULL),
(1555, '2016-06-28 13:34:24', NULL, NULL, 594, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 13:34:24', 'admin-1467090670-14670920640992493', 1, 1, 'SR', NULL, NULL, NULL),
(1556, '2016-06-28 13:34:24', NULL, NULL, 594, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 13:34:24', 'admin-1467090670-14670920640992493', 1, 1, 'SR', NULL, NULL, NULL),
(1557, '2016-06-28 13:34:24', NULL, NULL, 594, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 13:34:24', 'admin-1467090670-14670920640992493', 1, 1, 'SR', NULL, NULL, NULL),
(1558, '2016-06-28 13:42:22', NULL, NULL, 595, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 13:42:22', 'admin-1467090670-1467092542438144', 1, 1, 'SR', NULL, NULL, NULL),
(1559, '2016-06-28 17:49:51', NULL, NULL, 601, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 17:49:51', 'admin-1467090670-14671073912647111', 1, 1, 'SR', NULL, NULL, NULL),
(1560, '2016-06-28 16:19:41', NULL, NULL, 600, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 16:19:41', 'admin-1467090670-14671019815671241', 1, 1, 'SR', NULL, NULL, NULL),
(1561, '2016-06-28 14:13:46', NULL, NULL, 595, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 14:13:46', 'admin-1467090670-14670944266676628', 1, 1, 'SR', NULL, NULL, NULL),
(1562, '2016-06-28 14:13:46', NULL, NULL, 595, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 14:13:46', 'admin-1467090670-14670944266676628', 1, 0, '', NULL, NULL, NULL),
(1563, '2016-06-28 14:37:51', NULL, NULL, 599, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 14:37:51', 'admin-1467090670-14670958717122165', 1, 1, 'SR', 1, NULL, NULL),
(1564, '2016-06-28 14:38:33', NULL, NULL, 588, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 14:38:33', 'admin-1467090670-14670959133652927', 1, 1, 'SR', NULL, NULL, '10.0'),
(1565, '2016-06-28 16:19:41', NULL, NULL, 600, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 16:19:41', 'admin-1467090670-14671019815671241', 1, 1, 'SR', NULL, NULL, NULL),
(1566, '2016-06-28 16:19:41', NULL, NULL, 600, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 16:19:41', 'admin-1467090670-14671019815671241', 1, 1, 'SR', NULL, NULL, NULL),
(1567, '2016-06-28 11:52:39', NULL, NULL, 586, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 11:52:39', 'Staff-1467075958-14670859593397136', 1, 0, '', NULL, NULL, NULL),
(1568, '2016-06-28 11:52:39', NULL, NULL, 586, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 11:52:39', 'Staff-1467075958-14670859593397136', 1, 0, '', NULL, NULL, NULL),
(1569, '2016-06-28 11:52:39', NULL, NULL, 586, 0, 159, '93', 'Granola ', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 11:52:39', 'Staff-1467075958-14670859593397136', 1, 0, '', NULL, NULL, NULL),
(1570, '2016-06-28 11:52:39', NULL, NULL, 586, 0, 187, '122', 'Iced Tea ', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 11:52:39', 'Staff-1467075958-14670859593397136', 1, 0, '', NULL, NULL, NULL),
(1571, '2016-06-28 11:52:39', NULL, NULL, 586, NULL, 65, '65', 'Pineapple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 11:52:39', 'Staff-1467075958-14670859593397136', 1, 1, 'SR', NULL, NULL, NULL),
(1572, '2016-06-28 11:52:39', NULL, NULL, 586, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 11:52:39', 'Staff-1467075958-14670859593397136', 1, 1, 'SR', NULL, NULL, NULL),
(1573, '2016-06-28 11:59:29', NULL, NULL, 587, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 11:59:29', 'admin-1467085981-14670863690743059', 1, 1, 'SR', NULL, NULL, NULL),
(1574, '2016-06-28 12:10:33', NULL, NULL, 588, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 12:10:33', 'admin-1467087017-1467087033102118', 1, 1, 'SR', NULL, NULL, '10.0'),
(1575, '2016-06-28 12:10:33', NULL, NULL, 588, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 12:10:33', 'admin-1467087017-1467087033102118', 1, 1, 'SR', NULL, NULL, '10.0'),
(1576, '2016-06-28 12:10:33', NULL, NULL, 588, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 12:10:33', 'admin-1467087017-1467087033102118', 1, 1, 'SR', NULL, NULL, '10.0'),
(1577, '2016-06-28 12:10:33', NULL, NULL, 588, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 12:10:33', 'admin-1467087017-1467087033102118', 1, 1, 'SR', NULL, NULL, '10.0'),
(1578, '2016-06-28 12:17:47', NULL, NULL, 589, 0, 181, '116', 'Open Food ', 'Pasta', 'Open', 'Food', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 12:17:47', 'admin-1467087017-14670874676239480', 1, 0, '', NULL, NULL, NULL),
(1579, '2016-06-28 12:26:22', NULL, NULL, 588, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 12:26:22', 'admin-1467087017-14670879821139040', 1, 1, 'SR', NULL, NULL, '10.0'),
(1580, '2016-06-28 12:31:43', NULL, NULL, 588, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 12:31:43', 'admin-1467087017-14670883036943653', 1, 1, 'SR', NULL, NULL, '10.0'),
(1581, '2016-06-28 12:31:43', NULL, NULL, 588, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 12:31:43', 'admin-1467087017-14670883036943653', 1, 0, '', NULL, NULL, '10.0'),
(1582, '2016-06-28 12:33:58', NULL, NULL, 588, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 12:33:58', 'admin-1467087017-1467088438248308', 1, 1, 'SR', NULL, NULL, '10.0'),
(1583, '2016-06-28 12:49:29', NULL, NULL, 590, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 12:49:29', 'admin-1467087017-14670893696445524', 1, 1, 'SR', NULL, NULL, NULL),
(1584, '2016-06-28 12:49:29', NULL, NULL, 590, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 12:49:29', 'admin-1467087017-14670893696445524', 1, 0, '', NULL, NULL, NULL),
(1585, '2016-06-28 12:49:29', NULL, NULL, 590, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 12:49:29', 'admin-1467087017-14670893696445524', 1, 1, 'SR', NULL, NULL, NULL),
(1586, '2016-06-28 12:49:29', NULL, NULL, 590, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 12:49:29', 'admin-1467087017-14670893696445524', 1, 0, '', NULL, NULL, NULL),
(1587, '2016-06-28 12:49:29', NULL, NULL, 590, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 12:49:29', 'admin-1467087017-14670893696445524', 1, 1, 'SR', NULL, NULL, NULL),
(1588, '2016-06-28 12:49:29', NULL, NULL, 590, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 12:49:29', 'admin-1467087017-14670893696445524', 1, 0, '', NULL, NULL, NULL),
(1589, '2016-06-28 12:49:29', NULL, NULL, 590, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 12:49:29', 'admin-1467087017-14670893696445524', 1, 1, 'SR', NULL, NULL, NULL),
(1590, '2016-06-28 12:49:29', NULL, NULL, 590, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 12:49:29', 'admin-1467087017-14670893696445524', 1, 1, 'SR', NULL, NULL, NULL),
(1591, '2016-06-28 14:01:31', NULL, NULL, 588, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 14:01:31', 'admin-1467090670-1467093691610421', 1, 1, 'SR', NULL, NULL, '10.0'),
(1592, '2016-06-28 14:01:31', NULL, NULL, 588, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 14:01:31', 'admin-1467090670-1467093691610421', 1, 0, '', NULL, NULL, '10.0'),
(1593, '2016-06-28 14:01:31', NULL, NULL, 588, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 14:01:31', 'admin-1467090670-1467093691610421', 1, 1, 'SR', NULL, NULL, '10.0'),
(1594, '2016-06-28 14:01:13', NULL, NULL, 598, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 14:01:13', 'admin-1467090670-14670936729026923', 1, 1, 'SR', NULL, NULL, NULL),
(1595, '2016-06-28 13:59:42', NULL, NULL, 597, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 10.80, 1, '27', 1, '1467115684', 'admin', '2016-06-28 13:59:42', 'admin-1467090670-14670935826042265', 1, 1, 'SR', NULL, '10.0', NULL),
(1596, '2016-06-28 13:47:49', NULL, NULL, 596, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 13:47:49', 'admin-1467090670-14670928691577746', 1, 0, '', 1, NULL, NULL),
(1597, '2016-06-28 13:24:29', NULL, NULL, 593, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 13:24:29', 'admin-1467090670-14670914692431449', 1, 1, 'SR', 1, NULL, NULL),
(1598, '2016-06-28 13:34:24', NULL, NULL, 594, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 13:34:24', 'admin-1467090670-14670920640992493', 1, 1, 'SR', NULL, NULL, NULL),
(1599, '2016-06-28 12:57:48', NULL, NULL, 591, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 12:57:48', 'admin-1467087017-14670898683732288', 1, 1, 'SR', NULL, NULL, NULL),
(1600, '2016-06-28 13:10:56', NULL, NULL, 592, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467115684', 'admin', '2016-06-28 13:10:56', 'admin-1467087017-14670906561314991', 1, 0, '', NULL, NULL, NULL),
(1601, '2016-06-28 11:42:12', NULL, NULL, 585, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 11:42:12', 'Staff-1467075958-14670853322321642', 1, 1, 'SR', NULL, NULL, NULL),
(1602, '2016-06-28 11:42:12', NULL, NULL, 585, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 11:42:12', 'Staff-1467075958-14670853322321642', 1, 1, 'SR', NULL, NULL, NULL),
(1603, '2016-06-28 10:38:03', NULL, NULL, 583, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 10:38:03', 'Staff-1467075958-14670814833726438', 1, 1, 'SR', NULL, NULL, NULL),
(1604, '2016-06-28 10:44:38', NULL, NULL, 583, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 10:44:38', 'Staff-1467075958-14670818780859297', 1, 1, 'SR', NULL, NULL, NULL),
(1605, '2016-06-28 10:49:28', NULL, NULL, 584, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 10:49:28', 'Staff-1467075958-14670821678715662', 1, 0, '', NULL, NULL, NULL),
(1606, '2016-06-28 10:49:28', NULL, NULL, 584, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 10:49:28', 'Staff-1467075958-14670821678715662', 1, 0, '', NULL, NULL, NULL),
(1607, '2016-06-28 10:49:28', NULL, NULL, 584, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 10:49:28', 'Staff-1467075958-14670821678715662', 1, 1, 'SR', NULL, NULL, NULL),
(1608, '2016-06-28 10:49:28', NULL, NULL, 584, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 10:49:28', 'Staff-1467075958-14670821678715662', 1, 1, 'SR', NULL, NULL, NULL),
(1609, '2016-06-28 11:06:27', NULL, NULL, 582, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 11:06:27', 'Staff-1467075958-14670831878066611', 1, 1, 'SR', NULL, NULL, NULL),
(1610, '2016-06-28 11:41:53', NULL, NULL, 585, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 11:41:53', 'Staff-1467075958-14670853131812674', 1, 0, '', NULL, NULL, NULL),
(1611, '2016-06-28 11:41:53', NULL, NULL, 585, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 11:41:53', 'Staff-1467075958-14670853131812674', 1, 0, '', NULL, NULL, NULL),
(1612, '2016-06-28 11:41:53', NULL, NULL, 585, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 11:41:53', 'Staff-1467075958-14670853131812674', 1, 1, 'SR', NULL, NULL, NULL),
(1613, '2016-06-28 11:41:53', NULL, NULL, 585, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 11:41:53', 'Staff-1467075958-14670853131812674', 1, 1, 'SR', NULL, NULL, NULL),
(1614, '2016-06-28 11:41:53', NULL, NULL, 585, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 11:41:53', 'Staff-1467075958-14670853131812674', 1, 1, 'SR', NULL, NULL, NULL),
(1615, '2016-06-28 11:41:53', NULL, NULL, 585, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 11:41:53', 'Staff-1467075958-14670853131812674', 1, 1, 'SR', NULL, NULL, NULL),
(1616, '2016-06-28 11:41:53', NULL, NULL, 585, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 11:41:53', 'Staff-1467075958-14670853131812674', 1, 1, 'SR', NULL, NULL, NULL),
(1617, '2016-06-28 10:38:03', NULL, NULL, 583, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 10:38:03', 'Staff-1467075958-14670814833726438', 1, 0, '', NULL, NULL, NULL),
(1618, '2016-06-28 10:15:56', NULL, NULL, 582, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 10:15:56', 'Staff-1467075958-14670801567009334', 1, 0, '', NULL, NULL, NULL),
(1619, '2016-06-28 10:15:56', NULL, NULL, 582, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 10:15:56', 'Staff-1467075958-14670801567009334', 1, 1, 'SR', NULL, NULL, NULL),
(1620, '2016-06-28 10:15:56', NULL, NULL, 582, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 10:15:56', 'Staff-1467075958-14670801567009334', 1, 1, 'SR', NULL, NULL, NULL),
(1621, '2016-06-28 10:15:56', NULL, NULL, 582, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 10:15:56', 'Staff-1467075958-14670801567009334', 1, 1, 'SR', NULL, NULL, NULL),
(1622, '2016-06-28 10:38:03', NULL, NULL, 583, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 10:38:03', 'Staff-1467075958-14670814833726438', 1, 0, '', NULL, NULL, NULL),
(1623, '2016-06-28 10:15:56', NULL, NULL, 582, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 10:15:56', 'Staff-1467075958-14670801567009334', 1, 0, '', NULL, NULL, NULL),
(1624, '2016-06-28 11:41:53', NULL, NULL, 585, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 11:41:53', 'Staff-1467075958-14670853131812674', 1, 1, 'SR', NULL, NULL, NULL),
(1625, '2016-06-28 10:15:56', NULL, NULL, 582, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 10:15:56', 'Staff-1467075958-14670801567009334', 1, 0, '', NULL, NULL, NULL),
(1626, '2016-06-28 09:53:40', NULL, NULL, 581, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 09:53:40', 'Staff-1467075958-14670788200078427', 1, 1, 'SR', NULL, NULL, NULL),
(1627, '2016-06-28 10:15:56', NULL, NULL, 582, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 10:15:56', 'Staff-1467075958-14670801567009334', 1, 0, '', NULL, NULL, NULL),
(1628, '2016-06-28 10:15:56', NULL, NULL, 582, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467115684', 'Staff', '2016-06-28 10:15:56', 'Staff-1467075958-14670801567009334', 1, 0, '', NULL, NULL, NULL),
(1629, '2016-06-30 18:38:58', NULL, NULL, 624, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 18:38:58', 'Staff-1467250387-1467283137967892', 1, 1, 'SR', NULL, NULL, NULL),
(1630, '2016-06-30 19:02:48', NULL, NULL, 625, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 19:02:48', 'Staff-1467250387-14672845683513084', 1, 1, 'SR', NULL, NULL, NULL),
(1631, '2016-06-30 17:25:08', NULL, NULL, 620, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 17:25:08', 'Staff-1467250387-14672787079664828', 1, 1, 'SR', NULL, NULL, NULL),
(1632, '2016-06-30 17:39:18', NULL, NULL, 621, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 17:39:18', 'Staff-1467250387-14672795588121631', 1, 1, 'SR', 1, NULL, NULL),
(1633, '2016-06-30 14:10:46', NULL, NULL, 610, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 14:10:46', 'Staff-1467250387-14672670460058965', 1, 1, 'SR', NULL, NULL, NULL),
(1634, '2016-06-30 14:10:55', NULL, NULL, 611, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 14:10:55', 'Staff-1467250387-14672670550314882', 1, 1, 'SR', NULL, NULL, NULL),
(1635, '2016-06-30 14:12:25', NULL, NULL, 612, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 14:12:25', 'Staff-1467250387-14672671451696530', 1, 0, '', NULL, NULL, NULL),
(1636, '2016-06-30 14:12:25', NULL, NULL, 612, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 14:12:25', 'Staff-1467250387-14672671451696530', 1, 1, 'SR', NULL, NULL, NULL),
(1637, '2016-06-30 14:15:21', NULL, NULL, 613, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 2, 15.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 14:15:21', 'Staff-1467250387-14672673209638273', 1, 1, 'SR', NULL, NULL, NULL),
(1638, '2016-06-30 17:53:43', NULL, NULL, 623, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 17:53:43', 'Staff-1467250387-14672804231311737', 1, 1, 'SR', NULL, NULL, NULL),
(1639, '2016-06-30 17:53:43', NULL, NULL, 623, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 17:53:43', 'Staff-1467250387-14672804231311737', 1, 0, '', NULL, NULL, NULL),
(1640, '2016-06-30 17:19:14', NULL, NULL, 619, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 17:19:14', 'Staff-1467250387-14672783541723675', 1, 1, 'SR', NULL, NULL, NULL),
(1641, '2016-06-30 16:05:38', NULL, NULL, 617, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 16:05:38', 'Staff-1467250387-14672739380636921', 1, 0, '', NULL, NULL, NULL),
(1642, '2016-06-30 16:49:02', NULL, NULL, 618, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 16:49:02', 'Staff-1467250387-1467276541929224', 1, 1, 'SR', NULL, NULL, NULL),
(1643, '2016-06-30 15:27:08', NULL, NULL, 609, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 15:27:08', 'Staff-1467250387-14672716283466746', 1, 1, 'SR', NULL, NULL, NULL),
(1644, '2016-06-30 16:05:38', NULL, NULL, 617, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 16:05:38', 'Staff-1467250387-14672739380636921', 1, 1, 'SR', NULL, NULL, NULL),
(1645, '2016-06-30 14:21:48', NULL, NULL, 609, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 14:21:48', 'Staff-1467250387-14672677087239037', 1, 0, '', NULL, NULL, NULL),
(1646, '2016-06-30 15:23:19', NULL, NULL, 614, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 15:23:19', 'Staff-1467250387-14672713988893864', 1, 0, '', NULL, NULL, NULL),
(1647, '2016-06-30 15:23:19', NULL, NULL, 614, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 15:23:19', 'Staff-1467250387-14672713988893864', 1, 1, 'SR', NULL, NULL, NULL),
(1648, '2016-06-30 14:21:48', NULL, NULL, 609, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 14:21:48', 'Staff-1467250387-14672677087239037', 1, 0, '', NULL, NULL, NULL),
(1649, '2016-06-30 14:15:21', NULL, NULL, 613, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 14:15:21', 'Staff-1467250387-14672673209638273', 1, 1, 'SR', NULL, NULL, NULL),
(1650, '2016-06-30 14:15:21', NULL, NULL, 613, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 14:15:21', 'Staff-1467250387-14672673209638273', 1, 1, 'SR', NULL, NULL, NULL),
(1651, '2016-06-30 12:44:17', NULL, NULL, 607, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 12:44:17', 'Staff-1467250387-14672618575336659', 1, 1, 'SR', NULL, NULL, NULL),
(1652, '2016-06-30 12:44:17', NULL, NULL, 607, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 12:44:17', 'Staff-1467250387-14672618575336659', 1, 1, 'SR', NULL, NULL, NULL),
(1653, '2016-06-30 12:44:17', NULL, NULL, 607, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 12:44:17', 'Staff-1467250387-14672618575336659', 1, 1, 'SR', NULL, NULL, NULL),
(1654, '2016-06-30 12:44:17', NULL, NULL, 607, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 12:44:17', 'Staff-1467250387-14672618575336659', 1, 1, 'SR', NULL, NULL, NULL),
(1655, '2016-06-30 12:44:17', NULL, NULL, 607, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 12:44:17', 'Staff-1467250387-14672618575336659', 1, 1, 'SR', NULL, NULL, NULL),
(1656, '2016-06-30 13:47:20', NULL, NULL, 608, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 13:47:20', 'Staff-1467250387-1467265640243334', 1, 1, 'SR', NULL, NULL, NULL),
(1657, '2016-06-30 13:52:33', NULL, NULL, 609, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 13:52:33', 'Staff-1467250387-14672659536991913', 1, 1, 'SR', NULL, NULL, NULL),
(1658, '2016-06-30 10:20:43', NULL, NULL, 602, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 10:20:43', 'Staff-1467250387-14672532438355122', 1, 1, 'SR', NULL, NULL, NULL),
(1659, '2016-06-30 10:24:56', NULL, NULL, 604, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 10:24:56', 'Staff-1467250387-1467253496284693', 1, 0, '', NULL, NULL, NULL),
(1660, '2016-06-30 10:24:56', NULL, NULL, 604, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 10:24:56', 'Staff-1467250387-1467253496284693', 1, 0, '', NULL, NULL, NULL),
(1661, '2016-06-30 10:29:44', NULL, NULL, 605, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 10:29:44', 'Staff-1467250387-1467253783946667', 1, 1, 'SR', 1, NULL, NULL),
(1662, '2016-06-30 10:51:23', NULL, NULL, 606, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 10:51:23', 'Staff-1467250387-14672550829078596', 1, 0, '', NULL, NULL, NULL),
(1663, '2016-06-30 10:51:23', NULL, NULL, 606, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 10:51:23', 'Staff-1467250387-14672550829078596', 1, 0, '', NULL, NULL, NULL),
(1664, '2016-06-30 10:51:23', NULL, NULL, 606, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 10:51:23', 'Staff-1467250387-14672550829078596', 1, 0, '', NULL, NULL, NULL),
(1665, '2016-06-30 12:06:24', NULL, NULL, 602, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 12:06:24', 'Staff-1467250387-1467259584192247', 1, 0, '', NULL, NULL, NULL),
(1666, '2016-06-30 12:42:24', NULL, NULL, 607, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 12:42:24', 'Staff-1467250387-14672617441624428', 1, 0, '', NULL, NULL, NULL),
(1667, '2016-06-30 12:42:24', NULL, NULL, 607, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 12:42:24', 'Staff-1467250387-14672617441624428', 1, 0, '', NULL, NULL, NULL),
(1668, '2016-06-30 12:42:24', NULL, NULL, 607, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 12:42:24', 'Staff-1467250387-14672617441624428', 1, 0, '', NULL, NULL, NULL),
(1669, '2016-06-30 12:42:24', NULL, NULL, 607, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 12:42:24', 'Staff-1467250387-14672617441624428', 1, 0, '', NULL, NULL, NULL),
(1670, '2016-06-30 12:42:24', NULL, NULL, 607, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 12:42:24', 'Staff-1467250387-14672617441624428', 1, 0, '', NULL, NULL, NULL),
(1671, '2016-06-30 10:17:13', NULL, NULL, 603, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 10:17:13', 'Staff-1467250387-1467253032992202', 1, 0, '', NULL, NULL, NULL),
(1672, '2016-06-30 10:17:57', NULL, NULL, 603, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 10:17:57', 'Staff-1467250387-14672530777577983', 1, 0, '', NULL, NULL, NULL),
(1673, '2016-06-30 10:17:57', NULL, NULL, 603, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 10:17:57', 'Staff-1467250387-14672530777577983', 1, 0, '', NULL, NULL, NULL),
(1674, '2016-06-30 10:17:13', NULL, NULL, 603, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 10:17:13', 'Staff-1467250387-1467253032992202', 1, 0, '', NULL, NULL, NULL),
(1675, '2016-06-30 10:17:13', NULL, NULL, 603, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 10:17:13', 'Staff-1467250387-1467253032992202', 1, 0, '', NULL, NULL, NULL),
(1676, '2016-06-30 09:56:42', NULL, NULL, 602, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467285143', 'Staff', '2016-06-30 09:56:42', 'Staff-1467250387-14672518021081928', 1, 1, 'SR', NULL, NULL, NULL),
(1677, '2016-07-01 18:05:27', NULL, NULL, 656, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 18:05:27', 'admin-1467348189-1467367527752866', 1, 0, '', NULL, NULL, NULL),
(1678, '2016-07-01 18:05:27', NULL, NULL, 656, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 18:05:27', 'admin-1467348189-1467367527752866', 1, 1, 'SR', NULL, NULL, NULL),
(1679, '2016-07-01 17:44:11', NULL, NULL, 655, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 17:44:11', 'admin-1467348189-14673662515803690', 1, 1, 'SR', 1, NULL, '10.0'),
(1680, '2016-07-01 17:14:46', NULL, NULL, 653, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 17:14:46', 'admin-1467348189-1467364486156635', 1, 0, '', NULL, NULL, NULL),
(1681, '2016-07-01 18:05:27', NULL, NULL, 656, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 18:05:27', 'admin-1467348189-1467367527752866', 1, 0, '', NULL, NULL, NULL),
(1682, '2016-07-01 17:14:46', NULL, NULL, 653, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 17:14:46', 'admin-1467348189-1467364486156635', 1, 1, 'SR', NULL, NULL, NULL),
(1683, '2016-07-01 17:14:46', NULL, NULL, 653, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 17:14:46', 'admin-1467348189-1467364486156635', 1, 1, 'SR', NULL, NULL, NULL),
(1684, '2016-07-01 12:35:11', NULL, NULL, 642, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:35:11', 'admin-1467341003-1467347710950644', 1, 0, '', NULL, NULL, NULL),
(1685, '2016-07-01 12:35:31', NULL, NULL, 642, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:35:31', 'admin-1467341003-14673477308417866', 1, 1, 'SR', NULL, NULL, NULL),
(1686, '2016-07-01 12:35:31', NULL, NULL, 642, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:35:31', 'admin-1467341003-14673477308417866', 1, 1, 'SR', NULL, NULL, NULL),
(1687, '2016-07-01 12:36:27', NULL, NULL, 644, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:36:27', 'admin-1467341003-14673477868866730', 1, 0, '', NULL, NULL, NULL),
(1688, '2016-07-01 12:35:11', NULL, NULL, 642, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:35:11', 'admin-1467341003-1467347710950644', 1, 0, '', NULL, NULL, NULL),
(1689, '2016-07-01 11:44:07', NULL, NULL, 637, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 11:44:07', 'admin-1467341003-14673446476819561', 1, 0, '', NULL, NULL, NULL),
(1690, '2016-07-01 11:44:07', NULL, NULL, 637, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 11:44:07', 'admin-1467341003-14673446476819561', 1, 1, 'SR', NULL, NULL, NULL),
(1691, '2016-07-01 11:50:59', NULL, NULL, 638, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 11:50:59', 'admin-1467341003-14673450588184081', 1, 0, '', NULL, NULL, NULL),
(1692, '2016-07-01 11:50:59', NULL, NULL, 638, 0, 38, '38', 'Kiwi Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 11:50:59', 'admin-1467341003-14673450588184081', 1, 1, 'SR', NULL, NULL, NULL),
(1693, '2016-07-01 14:06:01', NULL, NULL, 650, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 14:06:01', 'admin-1467348189-14673531608935284', 1, 0, '', NULL, NULL, NULL),
(1694, '2016-07-01 12:37:16', NULL, NULL, 645, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:37:16', 'admin-1467341003-1467347835900185', 1, 1, 'SR', NULL, NULL, NULL),
(1695, '2016-07-01 12:38:20', NULL, NULL, 646, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:38:20', 'admin-1467341003-14673478998962750', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(1696, '2016-07-01 12:38:20', NULL, NULL, 646, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:38:20', 'admin-1467341003-14673478998962750', 1, 1, 'SR', NULL, NULL, NULL),
(1697, '2016-07-01 12:38:20', NULL, NULL, 646, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:38:20', 'admin-1467341003-14673478998962750', 1, 0, '', NULL, NULL, NULL),
(1698, '2016-07-01 12:45:35', NULL, NULL, 647, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:45:35', 'admin-1467348189-14673483349466715', 1, 1, 'SR', NULL, NULL, NULL),
(1699, '2016-07-01 12:45:35', NULL, NULL, 647, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:45:35', 'admin-1467348189-14673483349466715', 1, 1, 'SR', NULL, NULL, NULL),
(1700, '2016-07-01 12:45:35', NULL, NULL, 647, 0, 182, '117', 'Open Drinks ', 'americano', 'Desserts', '0', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:45:35', 'admin-1467348189-14673483349466715', 1, 0, '', NULL, NULL, NULL),
(1701, '2016-07-01 12:45:35', NULL, NULL, 647, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:45:35', 'admin-1467348189-14673483349466715', 1, 1, 'SR', NULL, NULL, NULL),
(1702, '2016-07-01 12:58:17', NULL, NULL, 648, NULL, 84, '84', 'Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:58:17', 'admin-1467348189-14673490975972849', 1, 1, 'SR', NULL, NULL, NULL),
(1703, '2016-07-01 12:58:17', NULL, NULL, 648, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:58:17', 'admin-1467348189-14673490975972849', 1, 1, 'SR', NULL, NULL, NULL),
(1704, '2016-07-01 13:10:18', NULL, NULL, 646, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 13:10:18', 'admin-1467348189-14673498183834946', 1, 1, 'SR', NULL, NULL, NULL),
(1705, '2016-07-01 13:19:24', NULL, NULL, 649, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 13:19:24', 'admin-1467348189-14673503644509826', 1, 1, 'SR', NULL, NULL, NULL),
(1706, '2016-07-01 13:19:24', NULL, NULL, 649, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 13:19:24', 'admin-1467348189-14673503644509826', 1, 1, 'SR', NULL, NULL, NULL),
(1707, '2016-07-01 13:26:54', NULL, NULL, 650, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 13:26:54', 'admin-1467348189-14673508143704444', 1, 1, 'SR', NULL, NULL, NULL),
(1708, '2016-07-01 13:26:54', NULL, NULL, 650, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 13:26:54', 'admin-1467348189-14673508143704444', 1, 1, 'SR', NULL, NULL, NULL),
(1709, '2016-07-01 13:26:54', NULL, NULL, 650, 0, 182, '117', 'Open Drinks ', 'americano', 'Desserts', '0', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 13:26:54', 'admin-1467348189-14673508143704444', 1, 0, '', NULL, NULL, NULL),
(1710, '2016-07-01 13:36:46', NULL, NULL, 651, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 13:36:46', 'admin-1467348189-1467351405889227', 1, 1, 'SR', NULL, NULL, NULL),
(1711, '2016-07-01 13:42:37', NULL, NULL, 652, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 13:42:37', 'admin-1467348189-14673517576464774', 1, 0, '', NULL, NULL, NULL),
(1712, '2016-07-01 13:42:37', NULL, NULL, 652, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 13:42:37', 'admin-1467348189-14673517576464774', 1, 0, '', NULL, NULL, NULL),
(1713, '2016-07-01 12:37:16', NULL, NULL, 645, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:37:16', 'admin-1467341003-1467347835900185', 1, 0, '', NULL, NULL, NULL),
(1714, '2016-07-01 12:37:16', NULL, NULL, 645, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:37:16', 'admin-1467341003-1467347835900185', 1, 1, 'SR', NULL, NULL, NULL),
(1715, '2016-07-01 00:00:00', NULL, NULL, 662, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 20:35:43', 'admin-1467367956-14673765436228228', 1, 1, 'SR', NULL, NULL, NULL),
(1716, '2016-07-01 00:00:00', NULL, NULL, 662, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 21:40:24', 'admin-1467367956-14673804243916337', 1, 1, 'SR', NULL, NULL, NULL),
(1717, '2016-07-01 00:00:00', NULL, NULL, 663, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 20:35:43', 'admin-1467367956-14673765436228228', 1, 1, 'SR', NULL, NULL, NULL),
(1718, '2016-07-01 00:00:00', NULL, NULL, 663, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 21:40:24', 'admin-1467367956-14673804243916337', 1, 1, 'SR', NULL, NULL, NULL),
(1719, '2016-07-01 00:00:00', NULL, NULL, 662, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 20:35:43', 'admin-1467367956-14673765436228228', 1, 1, 'SR', NULL, NULL, NULL),
(1720, '2016-07-01 00:00:00', NULL, NULL, 663, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 20:35:43', 'admin-1467367956-14673765436228228', 1, 1, 'SR', NULL, NULL, NULL),
(1721, '2016-07-01 00:00:00', NULL, NULL, 663, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 20:35:43', 'admin-1467367956-14673765436228228', 1, 0, '', NULL, NULL, NULL),
(1722, '2016-07-01 00:00:00', NULL, NULL, 662, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 20:35:43', 'admin-1467367956-14673765436228228', 1, 1, 'SR', NULL, NULL, NULL),
(1723, '2016-07-01 20:31:25', NULL, NULL, 659, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 20:31:25', 'admin-1467367956-14673762849662261', 1, 0, '', NULL, NULL, '10.0'),
(1724, '2016-07-01 20:14:39', NULL, NULL, 659, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 20:14:39', 'admin-1467367956-14673752798042331', 1, 1, 'SR', NULL, NULL, '10.0'),
(1725, '2016-07-01 20:31:25', NULL, NULL, 659, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 20:31:25', 'admin-1467367956-14673762849662261', 1, 0, '', NULL, NULL, '10.0'),
(1726, '2016-07-01 20:13:01', NULL, NULL, 660, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 20:13:01', 'admin-1467367956-14673751809756241', 1, 1, 'SR', NULL, NULL, NULL),
(1727, '2016-07-01 20:13:01', NULL, NULL, 660, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 20:13:01', 'admin-1467367956-14673751809756241', 1, 0, '', NULL, NULL, NULL),
(1728, '2016-07-01 20:13:01', NULL, NULL, 660, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 20:13:01', 'admin-1467367956-14673751809756241', 1, 1, 'SR', NULL, NULL, NULL),
(1729, '2016-07-01 20:10:02', NULL, NULL, 659, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 20:10:02', 'admin-1467367956-14673750020574728', 1, 0, '', NULL, NULL, '10.0'),
(1730, '2016-07-01 19:36:24', NULL, NULL, 658, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 19:36:24', 'admin-1467367956-14673729839232823', 1, 1, 'SR', NULL, NULL, NULL),
(1731, '2016-07-01 19:54:04', NULL, NULL, 659, 0, 189, '124', 'Stuffed Bitter Gourd', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 19:54:04', 'admin-1467367956-14673740439981549', 1, 0, '', NULL, NULL, '10.0'),
(1732, '2016-07-01 19:54:04', NULL, NULL, 659, 0, 181, '116', 'Open Food ', 'Pork', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 19:54:04', 'admin-1467367956-14673740439981549', 1, 0, '', NULL, NULL, '10.0'),
(1733, '2016-07-01 19:54:04', NULL, NULL, 659, 0, 181, '116', 'Open Food ', 'Chicken Wing', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 19:54:04', 'admin-1467367956-14673740439981549', 1, 0, '', NULL, NULL, '10.0'),
(1734, '2016-07-01 19:54:04', NULL, NULL, 659, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 19:54:04', 'admin-1467367956-14673740439981549', 1, 1, 'SR', NULL, NULL, '10.0'),
(1735, '2016-07-01 19:54:04', NULL, NULL, 659, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 19:54:04', 'admin-1467367956-14673740439981549', 1, 0, '', NULL, NULL, '10.0'),
(1736, '2016-07-01 19:54:04', NULL, NULL, 659, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 19:54:04', 'admin-1467367956-14673740439981549', 1, 0, '', NULL, NULL, '10.0'),
(1737, '2016-07-01 19:54:04', NULL, NULL, 659, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 19:54:04', 'admin-1467367956-14673740439981549', 1, 0, '', NULL, NULL, '10.0'),
(1738, '2016-07-01 19:54:04', NULL, NULL, 659, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 19:54:04', 'admin-1467367956-14673740439981549', 1, 0, '', NULL, NULL, '10.0'),
(1739, '2016-07-01 18:13:01', NULL, NULL, 657, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 18:13:01', 'admin-1467367956-14673679808779740', 1, 1, 'SR', 1, NULL, NULL),
(1740, '2016-07-01 18:13:01', NULL, NULL, 657, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 18:13:01', 'admin-1467367956-14673679808779740', 1, 0, '', 1, NULL, NULL),
(1741, '2016-07-01 19:36:24', NULL, NULL, 658, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 19:36:24', 'admin-1467367956-14673729839232823', 1, 1, 'SR', NULL, NULL, NULL),
(1742, '2016-07-01 12:35:11', NULL, NULL, 642, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:35:11', 'admin-1467341003-1467347710950644', 1, 1, 'SR', NULL, NULL, NULL),
(1743, '2016-07-01 12:35:11', NULL, NULL, 642, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:35:11', 'admin-1467341003-1467347710950644', 1, 1, 'SR', NULL, NULL, NULL),
(1744, '2016-07-01 12:32:48', NULL, NULL, 643, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:32:48', 'admin-1467341003-1467347568496238', 1, 0, '', 1, NULL, NULL),
(1745, '2016-07-01 12:33:02', NULL, NULL, 643, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:33:02', 'admin-1467341003-14673475826996662', 1, 1, 'SR', 1, NULL, NULL),
(1746, '2016-07-01 18:13:01', NULL, NULL, 657, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 18:13:01', 'admin-1467367956-14673679808779740', 1, 1, 'SR', 1, NULL, NULL),
(1747, '2016-07-01 12:27:28', NULL, NULL, 641, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:27:28', 'admin-1467341003-14673472481662667', 1, 1, 'SR', NULL, NULL, NULL),
(1748, '2016-07-01 12:32:42', NULL, NULL, 642, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 12:32:42', 'admin-1467341003-14673475621182064', 1, 0, '', NULL, NULL, NULL),
(1749, '2016-07-01 11:52:58', NULL, NULL, 639, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 11:52:58', 'admin-1467341003-14673451780609995', 1, 1, 'SR', NULL, NULL, NULL),
(1750, '2016-07-01 11:54:00', NULL, NULL, 640, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 11:54:00', 'admin-1467341003-14673452399887495', 1, 1, 'SR', NULL, NULL, NULL),
(1751, '2016-07-01 11:54:00', NULL, NULL, 640, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 11:54:00', 'admin-1467341003-14673452399887495', 1, 1, 'SR', NULL, NULL, NULL),
(1752, '2016-07-01 15:47:42', NULL, NULL, 646, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 15:47:42', 'admin-1467348189-14673592621627527', 1, 1, 'SR', NULL, NULL, NULL),
(1753, '2016-07-01 11:52:58', NULL, NULL, 639, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 11:52:58', 'admin-1467341003-14673451780609995', 1, 1, 'SR', NULL, NULL, NULL),
(1754, '2016-07-01 11:44:07', NULL, NULL, 637, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 11:44:07', 'admin-1467341003-14673446476819561', 1, 0, '', NULL, NULL, NULL),
(1755, '2016-07-01 10:44:53', NULL, NULL, 634, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 10:44:53', 'admin-1467341003-14673410930417435', 1, 1, 'SR', NULL, NULL, NULL),
(1756, '2016-07-01 10:44:53', NULL, NULL, 634, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 10:44:53', 'admin-1467341003-14673410930417435', 1, 0, '', NULL, NULL, NULL),
(1757, '2016-07-01 10:57:25', NULL, NULL, 635, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 10:57:25', 'admin-1467341003-14673418450387898', 1, 1, 'SR', NULL, NULL, NULL),
(1758, '2016-07-01 10:57:25', NULL, NULL, 635, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 10:57:25', 'admin-1467341003-14673418450387898', 1, 1, 'SR', NULL, NULL, NULL),
(1759, '2016-07-01 10:57:25', NULL, NULL, 635, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 10:57:25', 'admin-1467341003-14673418450387898', 1, 0, '', NULL, NULL, NULL),
(1760, '2016-07-01 10:57:25', NULL, NULL, 635, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 10:57:25', 'admin-1467341003-14673418450387898', 1, 0, '', NULL, NULL, NULL),
(1761, '2016-07-01 10:57:25', NULL, NULL, 635, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 10:57:25', 'admin-1467341003-14673418450387898', 1, 1, 'SR', NULL, NULL, NULL),
(1762, '2016-07-01 09:28:33', NULL, NULL, 628, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467381702', 'Staff', '2016-07-01 09:28:33', 'Staff-1467333426-14673365128714220', 1, 1, 'SR', NULL, NULL, NULL),
(1763, '2016-07-01 09:50:29', NULL, NULL, 629, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467381702', 'Staff', '2016-07-01 09:50:29', 'Staff-1467333426-14673378297809165', 1, 1, 'SR', NULL, NULL, NULL),
(1764, '2016-07-01 10:09:17', NULL, NULL, 630, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467381702', 'Staff', '2016-07-01 10:09:17', 'Staff-1467333426-14673389578367034', 1, 0, '', NULL, NULL, NULL),
(1765, '2016-07-01 10:19:16', NULL, NULL, 631, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467381702', 'Staff', '2016-07-01 10:19:16', 'Staff-1467333426-14673395565796898', 1, 1, 'SR', NULL, NULL, NULL),
(1766, '2016-07-01 10:19:16', NULL, NULL, 631, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467381702', 'Staff', '2016-07-01 10:19:16', 'Staff-1467333426-14673395565796898', 1, 1, 'SR', NULL, NULL, NULL),
(1767, '2016-07-01 10:19:16', NULL, NULL, 631, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467381702', 'Staff', '2016-07-01 10:19:16', 'Staff-1467333426-14673395565796898', 1, 0, '', NULL, NULL, NULL),
(1768, '2016-07-01 10:37:24', NULL, NULL, 632, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467381702', 'Staff', '2016-07-01 10:37:24', 'Staff-1467333426-14673406443858651', 1, 0, '', NULL, NULL, NULL),
(1769, '2016-07-01 10:37:24', NULL, NULL, 632, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467381702', 'Staff', '2016-07-01 10:37:24', 'Staff-1467333426-14673406443858651', 1, 1, 'SR', NULL, NULL, NULL),
(1770, '2016-07-01 10:37:24', NULL, NULL, 632, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467381702', 'Staff', '2016-07-01 10:37:24', 'Staff-1467333426-14673406443858651', 1, 1, 'SR', NULL, NULL, NULL),
(1771, '2016-07-01 11:44:07', NULL, NULL, 637, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 11:44:07', 'admin-1467341003-14673446476819561', 1, 0, '', NULL, NULL, NULL),
(1772, '2016-07-01 11:19:10', NULL, NULL, 636, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 11:19:10', 'admin-1467341003-14673431499761827', 1, 1, 'SR', NULL, NULL, NULL),
(1773, '2016-07-01 10:44:53', NULL, NULL, 634, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 10:44:53', 'admin-1467341003-14673410930417435', 1, 0, '', NULL, NULL, NULL),
(1774, '2016-07-01 10:44:53', NULL, NULL, 634, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 10:44:53', 'admin-1467341003-14673410930417435', 1, 1, 'SR', NULL, NULL, NULL),
(1775, '2016-07-01 10:44:53', NULL, NULL, 634, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 10:44:53', 'admin-1467341003-14673410930417435', 1, 0, '', NULL, NULL, NULL),
(1776, '2016-07-01 10:44:53', NULL, NULL, 634, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467381702', 'admin', '2016-07-01 10:44:53', 'admin-1467341003-14673410930417435', 1, 0, '', NULL, NULL, NULL),
(1777, '2016-07-01 10:38:14', NULL, NULL, 633, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467381702', 'Staff', '2016-07-01 10:38:14', 'Staff-1467333426-14673406945918918', 1, 0, '', NULL, NULL, NULL),
(1778, '2016-07-01 09:27:20', NULL, NULL, 627, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467381702', 'Staff', '2016-07-01 09:27:20', 'Staff-1467333426-14673364399905411', 1, 1, 'SR', NULL, NULL, NULL),
(1779, '2016-07-01 09:26:00', NULL, NULL, 626, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467381702', 'Staff', '2016-07-01 09:26:00', 'Staff-1467333426-14673363605928695', 1, 1, 'SR', NULL, NULL, NULL),
(1780, '2016-07-02 14:05:26', NULL, NULL, 675, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 14:05:26', 'admin-1467431407-1467439525859757', 1, 1, 'SR', NULL, NULL, NULL),
(1781, '2016-07-02 14:05:26', NULL, NULL, 675, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 14:05:26', 'admin-1467431407-1467439525859757', 1, 0, '', NULL, NULL, NULL),
(1782, '2016-07-02 14:05:56', NULL, NULL, 679, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 14:05:56', 'admin-1467431407-1467439556016388', 1, 1, 'SR', NULL, NULL, NULL),
(1783, '2016-07-02 14:05:56', NULL, NULL, 679, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 14:05:56', 'admin-1467431407-1467439556016388', 1, 1, 'SR', NULL, NULL, NULL),
(1784, '2016-07-02 14:05:56', NULL, NULL, 679, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 14:05:56', 'admin-1467431407-1467439556016388', 1, 1, 'SR', NULL, NULL, NULL),
(1785, '2016-07-02 14:13:18', NULL, NULL, 680, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 14:13:18', 'admin-1467431407-14674399979455331', 1, 0, '', NULL, NULL, NULL),
(1786, '2016-07-02 14:13:18', NULL, NULL, 680, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 14:13:18', 'admin-1467431407-14674399979455331', 1, 1, 'SR', NULL, NULL, NULL),
(1787, '2016-07-02 14:13:18', NULL, NULL, 680, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 14:13:18', 'admin-1467431407-14674399979455331', 1, 0, '', NULL, NULL, NULL),
(1788, '2016-07-02 13:29:41', NULL, NULL, 666, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 13:29:41', 'admin-1467431407-14674373810207899', 1, 1, 'SR', NULL, NULL, NULL),
(1789, '2016-07-02 19:59:04', NULL, NULL, 693, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 19:59:04', 'admin-1467448347-146746074429728', 1, 1, 'SR', NULL, NULL, NULL),
(1790, '2016-07-02 19:59:04', NULL, NULL, 693, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 19:59:04', 'admin-1467448347-146746074429728', 1, 0, '', NULL, NULL, NULL),
(1791, '2016-07-02 20:15:59', NULL, NULL, 694, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 20:15:59', 'admin-1467461692-14674617589967513', 1, 1, 'SR', NULL, NULL, '10.0'),
(1792, '2016-07-02 20:15:59', NULL, NULL, 694, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 20:15:59', 'admin-1467461692-14674617589967513', 1, 0, '', NULL, NULL, '10.0'),
(1793, '2016-07-02 20:15:59', NULL, NULL, 694, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 20:15:59', 'admin-1467461692-14674617589967513', 1, 0, '', NULL, NULL, '10.0'),
(1794, '2016-07-02 20:32:20', NULL, NULL, 694, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 20:32:20', 'admin-1467461692-14674627399855493', 1, 0, '', NULL, NULL, '10.0'),
(1795, '2016-07-02 20:33:56', NULL, NULL, 695, 0, 189, '124', 'Stuffed Bitter Gourd', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 20:33:56', 'admin-1467461692-1467462836062587', 1, 0, '', NULL, NULL, NULL),
(1796, '2016-07-02 20:33:56', NULL, NULL, 695, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 20:33:56', 'admin-1467461692-1467462836062587', 1, 0, '', NULL, NULL, NULL),
(1797, '2016-07-02 20:33:56', NULL, NULL, 695, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 20:33:56', 'admin-1467461692-1467462836062587', 1, 1, 'SR', NULL, NULL, NULL),
(1798, '2016-07-02 20:33:56', NULL, NULL, 695, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 20:33:56', 'admin-1467461692-1467462836062587', 1, 1, 'SR', NULL, NULL, NULL),
(1799, '2016-07-02 20:33:56', NULL, NULL, 695, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 20:33:56', 'admin-1467461692-1467462836062587', 1, 1, 'SR', NULL, NULL, NULL),
(1800, '2016-07-02 20:53:14', NULL, NULL, 696, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 20:53:14', 'admin-1467461692-14674639947026187', 1, 1, 'SR', NULL, NULL, NULL),
(1801, '2016-07-02 20:53:14', NULL, NULL, 696, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 20:53:14', 'admin-1467461692-14674639947026187', 1, 1, 'SR', NULL, NULL, NULL),
(1802, '2016-07-02 20:53:14', NULL, NULL, 696, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 20:53:14', 'admin-1467461692-14674639947026187', 1, 1, 'SR', NULL, NULL, NULL),
(1803, '2016-07-02 20:53:14', NULL, NULL, 696, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 20:53:14', 'admin-1467461692-14674639947026187', 1, 0, '', NULL, NULL, NULL),
(1804, '2016-07-02 19:59:04', NULL, NULL, 693, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 19:59:04', 'admin-1467448347-146746074429728', 1, 1, 'SR', NULL, NULL, NULL),
(1805, '2016-07-02 19:35:15', NULL, NULL, 692, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 19:35:15', 'admin-1467448347-1467459315122259', 1, 1, 'SR', NULL, NULL, NULL),
(1806, '2016-07-02 19:35:15', NULL, NULL, 692, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 19:35:15', 'admin-1467448347-1467459315122259', 1, 0, '', NULL, NULL, NULL),
(1807, '2016-07-02 19:35:15', NULL, NULL, 692, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 19:35:15', 'admin-1467448347-1467459315122259', 1, 1, 'SR', NULL, NULL, NULL),
(1808, '2016-07-02 18:49:40', NULL, NULL, 691, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 18:49:40', 'admin-1467448347-14674565803889681', 1, 1, 'SR', NULL, NULL, NULL),
(1809, '2016-07-02 18:49:40', NULL, NULL, 691, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 18:49:40', 'admin-1467448347-14674565803889681', 1, 1, 'SR', NULL, NULL, NULL),
(1810, '2016-07-02 18:49:40', NULL, NULL, 691, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 18:49:40', 'admin-1467448347-14674565803889681', 1, 0, '', NULL, NULL, NULL),
(1811, '2016-07-02 18:49:40', NULL, NULL, 691, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 18:49:40', 'admin-1467448347-14674565803889681', 1, 0, '', NULL, NULL, NULL),
(1812, '2016-07-02 19:35:15', NULL, NULL, 692, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 19:35:15', 'admin-1467448347-1467459315122259', 1, 1, 'SR', NULL, NULL, NULL),
(1813, '2016-07-02 19:35:15', NULL, NULL, 692, 0, 76, '76', 'Pesto Pasta', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 19:35:15', 'admin-1467448347-1467459315122259', 1, 1, 'SR', NULL, NULL, NULL),
(1814, '2016-07-02 19:35:15', NULL, NULL, 692, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 19:35:15', 'admin-1467448347-1467459315122259', 1, 0, '', NULL, NULL, NULL),
(1815, '2016-07-02 17:20:48', NULL, NULL, 690, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 17:20:48', 'admin-1467448347-14674512483051647', 1, 1, 'SR', NULL, NULL, NULL),
(1816, '2016-07-02 16:49:40', NULL, NULL, 689, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 16:49:40', 'admin-1467448347-14674493802664830', 1, 1, 'SR', 1, NULL, NULL),
(1817, '2016-07-02 16:49:40', NULL, NULL, 689, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 16:49:40', 'admin-1467448347-14674493802664830', 1, 1, 'SR', 1, NULL, NULL),
(1818, '2016-07-02 16:49:40', NULL, NULL, 689, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 16:49:40', 'admin-1467448347-14674493802664830', 1, 1, 'SR', 1, NULL, NULL),
(1819, '2016-07-02 16:49:40', NULL, NULL, 689, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 16:49:40', 'admin-1467448347-14674493802664830', 1, 0, '', 1, NULL, NULL),
(1820, '2016-07-02 16:02:01', NULL, NULL, 685, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 16:02:01', 'admin-1467440005-1467446521397311', 1, 0, '', NULL, NULL, NULL),
(1821, '2016-07-02 16:02:01', NULL, NULL, 685, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 16:02:01', 'admin-1467440005-1467446521397311', 1, 1, 'SR', NULL, NULL, NULL),
(1822, '2016-07-02 15:58:01', NULL, NULL, 684, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 15:58:01', 'admin-1467440005-14674462815972120', 1, 1, 'SR', NULL, NULL, NULL),
(1823, '2016-07-02 16:43:28', NULL, NULL, 688, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 16:43:28', 'admin-1467448347-14674490079512390', 1, 1, 'SR', NULL, NULL, NULL),
(1824, '2016-07-02 16:34:10', NULL, NULL, 687, 0, 182, '117', 'Open Drinks ', 'shot', 'Desserts', '0', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 16:34:10', 'admin-1467448347-14674484503934341', 1, 0, '', NULL, NULL, NULL),
(1825, '2016-07-02 16:34:10', NULL, NULL, 687, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 16:34:10', 'admin-1467448347-14674484503934341', 1, 0, '', NULL, NULL, NULL),
(1826, '2016-07-02 16:34:10', NULL, NULL, 687, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 16:34:10', 'admin-1467448347-14674484503934341', 1, 1, 'SR', NULL, NULL, NULL),
(1827, '2016-07-02 16:34:10', NULL, NULL, 687, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 16:34:10', 'admin-1467448347-14674484503934341', 1, 1, 'SR', NULL, NULL, NULL),
(1828, '2016-07-02 16:15:27', NULL, NULL, 686, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 16:15:27', 'admin-1467440005-14674473277943770', 1, 0, '', NULL, NULL, NULL),
(1829, '2016-07-02 16:15:27', NULL, NULL, 686, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 16:15:27', 'admin-1467440005-14674473277943770', 1, 1, 'SR', NULL, NULL, NULL),
(1830, '2016-07-02 15:58:01', NULL, NULL, 684, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 15:58:01', 'admin-1467440005-14674462815972120', 1, 1, 'SR', NULL, NULL, NULL),
(1831, '2016-07-02 14:40:28', NULL, NULL, 681, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 14:40:28', 'admin-1467440005-14674416282526191', 1, 0, '', NULL, NULL, NULL),
(1832, '2016-07-02 15:03:18', NULL, NULL, 682, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 15:03:18', 'admin-1467440005-1467442998723499', 1, 0, '', NULL, NULL, NULL),
(1833, '2016-07-02 15:20:28', NULL, NULL, 676, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 15:20:28', 'admin-1467440005-14674440283521795', 1, 0, '', NULL, NULL, NULL),
(1834, '2016-07-02 15:42:56', NULL, NULL, 683, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 15:42:56', 'admin-1467440005-14674453767223011', 1, 1, 'SR', NULL, NULL, NULL),
(1835, '2016-07-02 14:33:20', NULL, NULL, 676, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 14:33:20', 'admin-1467440005-14674412006832943', 1, 1, 'SR', NULL, NULL, NULL),
(1836, '2016-07-02 15:42:56', NULL, NULL, 683, 0, 39, '39', 'Mango Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 15:42:56', 'admin-1467440005-14674453767223011', 1, 1, 'SR', NULL, NULL, NULL),
(1837, '2016-07-02 14:30:10', NULL, NULL, 676, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 14:30:10', 'admin-1467440005-14674410100359864', 1, 0, '', NULL, NULL, NULL),
(1838, '2016-07-02 13:58:40', NULL, NULL, 676, 0, 190, '125', 'Tiger Bucket ', '', 'Cold Drinks', 'Soda & Beer', 1, 48.00, 48.0000, 0.0000, 48.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 13:58:40', 'admin-1467431407-14674391207218999', 1, 0, '', NULL, NULL, NULL),
(1839, '2016-07-02 13:56:09', NULL, NULL, 676, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 13:56:09', 'admin-1467431407-1467438969510155', 1, 0, '', NULL, NULL, NULL),
(1840, '2016-07-02 14:33:03', NULL, NULL, 676, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 14:33:03', 'admin-1467440005-14674411831125139', 1, 0, '', NULL, NULL, NULL),
(1841, '2016-07-02 14:03:22', NULL, NULL, 677, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 14:03:22', 'admin-1467431407-14674394019795429', 1, 1, 'SR', NULL, NULL, NULL),
(1842, '2016-07-02 14:04:11', NULL, NULL, 678, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 14:04:11', 'admin-1467431407-14674394511871054', 1, 1, 'SR', NULL, NULL, NULL),
(1843, '2016-07-02 14:04:11', NULL, NULL, 678, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 14:04:11', 'admin-1467431407-14674394511871054', 1, 1, 'SR', NULL, NULL, NULL),
(1844, '2016-07-02 14:01:18', NULL, NULL, 676, 0, 181, '116', 'Open Food ', 'wings', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 14:01:18', 'admin-1467431407-14674392781534691', 1, 0, '', NULL, NULL, NULL),
(1845, '2016-07-02 11:30:19', NULL, NULL, 667, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467466190', 'Staff', '2016-07-02 11:30:19', 'Staff-1467422461-1467430219053557', 1, 0, '', NULL, NULL, NULL),
(1846, '2016-07-02 11:30:19', NULL, NULL, 667, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467466190', 'Staff', '2016-07-02 11:30:19', 'Staff-1467422461-1467430219053557', 1, 1, 'SR', NULL, NULL, NULL),
(1847, '2016-07-02 11:32:17', NULL, NULL, 667, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467466190', 'Staff', '2016-07-02 11:32:17', 'Staff-1467422461-14674303377667180', 1, 0, '', NULL, NULL, NULL),
(1848, '2016-07-02 11:32:17', NULL, NULL, 667, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467466190', 'Staff', '2016-07-02 11:32:17', 'Staff-1467422461-14674303377667180', 1, 1, 'SR', NULL, NULL, NULL),
(1849, '2016-07-02 11:37:07', NULL, NULL, 668, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467466190', 'Staff', '2016-07-02 11:37:07', 'Staff-1467422461-14674306273852342', 1, 0, '', NULL, NULL, NULL),
(1850, '2016-07-02 11:37:07', NULL, NULL, 668, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467466190', 'Staff', '2016-07-02 11:37:07', 'Staff-1467422461-14674306273852342', 1, 0, '', NULL, NULL, NULL),
(1851, '2016-07-02 11:37:07', NULL, NULL, 668, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1467466190', 'Staff', '2016-07-02 11:37:07', 'Staff-1467422461-14674306273852342', 1, 1, 'SR', NULL, NULL, NULL),
(1852, '2016-07-02 11:37:07', NULL, NULL, 668, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467466190', 'Staff', '2016-07-02 11:37:07', 'Staff-1467422461-14674306273852342', 1, 1, 'SR', NULL, NULL, NULL),
(1853, '2016-07-02 11:42:45', NULL, NULL, 669, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467466190', 'Staff', '2016-07-02 11:42:45', 'Staff-1467422461-14674309653687817', 1, 0, '', NULL, NULL, NULL),
(1854, '2016-07-02 11:49:59', NULL, NULL, 670, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467466190', 'Staff', '2016-07-02 11:49:59', 'Staff-1467422461-1467431399542423', 1, 0, '', NULL, NULL, NULL),
(1855, '2016-07-02 11:49:59', NULL, NULL, 670, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467466190', 'Staff', '2016-07-02 11:49:59', 'Staff-1467422461-1467431399542423', 1, 1, 'SR', NULL, NULL, NULL),
(1856, '2016-07-02 11:49:59', NULL, NULL, 670, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467466190', 'Staff', '2016-07-02 11:49:59', 'Staff-1467422461-1467431399542423', 1, 1, 'SR', NULL, NULL, NULL),
(1857, '2016-07-02 12:05:05', NULL, NULL, 671, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 12:05:05', 'admin-1467431407-14674323055029532', 1, 1, 'SR', NULL, NULL, NULL),
(1858, '2016-07-02 12:05:46', NULL, NULL, 672, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 12:05:46', 'admin-1467431407-14674323459663070', 1, 1, 'SR', NULL, NULL, NULL),
(1859, '2016-07-02 12:05:46', NULL, NULL, 672, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 12:05:46', 'admin-1467431407-14674323459663070', 1, 1, 'SR', NULL, NULL, NULL),
(1860, '2016-07-02 12:36:41', NULL, NULL, 674, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 12:36:41', 'admin-1467431407-1467434201736653', 1, 0, '', NULL, NULL, NULL),
(1861, '2016-07-02 13:02:19', NULL, NULL, 675, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 13:02:19', 'admin-1467431407-14674357397365437', 1, 1, 'SR', NULL, NULL, NULL),
(1862, '2016-07-02 13:29:25', NULL, NULL, 666, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467466190', 'admin', '2016-07-02 13:29:25', 'admin-1467431407-1467437365263524', 1, 1, 'SR', NULL, NULL, NULL),
(1863, '2016-07-02 11:29:11', NULL, NULL, 666, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467466190', 'Staff', '2016-07-02 11:29:11', 'Staff-1467422461-14674301512349176', 1, 1, 'SR', NULL, NULL, NULL),
(1864, '2016-07-02 11:29:11', NULL, NULL, 666, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467466190', 'Staff', '2016-07-02 11:29:11', 'Staff-1467422461-14674301512349176', 1, 1, 'SR', NULL, NULL, NULL),
(1865, '2016-07-02 10:38:43', NULL, NULL, 665, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467466190', 'Staff', '2016-07-02 10:38:43', 'Staff-1467422461-1467427123568186', 1, 1, 'SR', NULL, NULL, NULL),
(1866, '2016-07-02 10:37:32', NULL, NULL, 665, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467466190', 'Staff', '2016-07-02 10:37:32', 'Staff-1467422461-14674270520442787', 1, 0, '', NULL, NULL, NULL),
(1867, '2016-07-02 10:38:43', NULL, NULL, 665, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467466190', 'Staff', '2016-07-02 10:38:43', 'Staff-1467422461-1467427123568186', 1, 1, 'SR', NULL, NULL, NULL),
(1868, '2016-07-02 10:37:32', NULL, NULL, 665, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467466190', 'Staff', '2016-07-02 10:37:32', 'Staff-1467422461-14674270520442787', 1, 0, '', NULL, NULL, NULL),
(1869, '2016-07-02 10:24:38', NULL, NULL, 664, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467466190', 'Staff', '2016-07-02 10:24:38', 'Staff-1467422461-14674262784835948', 1, 1, 'SR', NULL, NULL, NULL),
(1870, '2016-07-03 19:53:26', NULL, NULL, 733, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 19:53:26', 'admin-1467530456-14675468066938996', 1, 1, 'SR', NULL, NULL, NULL),
(1871, '2016-07-03 19:51:28', NULL, NULL, 733, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 19:51:28', 'admin-1467530456-14675466887052740', 1, 1, 'SR', NULL, NULL, NULL),
(1872, '2016-07-03 19:53:06', NULL, NULL, 733, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 19:53:06', 'admin-1467530456-1467546786775681', 1, 1, 'SR', NULL, NULL, NULL),
(1873, '2016-07-03 19:51:28', NULL, NULL, 733, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 19:51:28', 'admin-1467530456-14675466887052740', 1, 1, 'SR', NULL, NULL, NULL),
(1874, '2016-07-03 18:24:35', NULL, NULL, 732, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 18:24:35', 'admin-1467530456-1467541475737216', 1, 1, 'SR', NULL, NULL, NULL),
(1875, '2016-07-03 18:24:35', NULL, NULL, 732, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 18:24:35', 'admin-1467530456-1467541475737216', 1, 1, 'SR', NULL, NULL, NULL),
(1876, '2016-07-03 18:24:36', NULL, NULL, 732, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 18:24:36', 'admin-1467530456-1467541475737216', 1, 1, 'SR', NULL, NULL, NULL),
(1877, '2016-07-03 19:51:28', NULL, NULL, 733, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 19:51:28', 'admin-1467530456-14675466887052740', 1, 0, '', NULL, NULL, NULL),
(1878, '2016-07-03 15:05:43', NULL, NULL, 728, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1467548174', 'sanni', '2016-07-03 15:05:43', 'sanni-1467529461-14675295434614671', 1, 1, 'SR', NULL, NULL, '10.0'),
(1879, '2016-07-03 15:26:37', NULL, NULL, 729, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 15:26:37', 'admin-1467530456-14675307974955830', 1, 0, '', NULL, NULL, NULL),
(1880, '2016-07-03 15:26:37', NULL, NULL, 729, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 15:26:37', 'admin-1467530456-14675307974955830', 1, 0, '', NULL, NULL, NULL),
(1881, '2016-07-03 15:26:56', NULL, NULL, 729, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 15:26:56', 'admin-1467530456-14675308162106362', 1, 1, 'SR', NULL, NULL, NULL),
(1882, '2016-07-03 17:24:03', NULL, NULL, 730, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 17:24:03', 'admin-1467530456-14675378428712889', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(1883, '2016-07-03 17:24:03', NULL, NULL, 730, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 17:24:03', 'admin-1467530456-14675378428712889', 1, 0, '', NULL, NULL, NULL),
(1884, '2016-07-03 17:53:17', NULL, NULL, 731, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 17:53:17', 'admin-1467530456-14675395974088919', 1, 1, 'SR', NULL, NULL, NULL),
(1885, '2016-07-03 18:24:35', NULL, NULL, 732, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 18:24:35', 'admin-1467530456-1467541475737216', 1, 1, 'SR', NULL, NULL, NULL),
(1886, '2016-07-03 14:49:29', NULL, NULL, 727, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467548174', 'Staff', '2016-07-03 14:49:29', 'Staff-1467527687-1467528569396343', 1, 0, '', NULL, NULL, NULL),
(1887, '2016-07-03 14:49:29', NULL, NULL, 727, 0, 181, '116', 'Open Food ', 'egg', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467548174', 'Staff', '2016-07-03 14:49:29', 'Staff-1467527687-1467528569396343', 1, 0, '', NULL, NULL, NULL),
(1888, '2016-07-03 14:56:54', NULL, NULL, 722, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467548174', 'Staff', '2016-07-03 14:56:54', 'Staff-1467527687-14675290138745460', 1, 0, '', NULL, NULL, '10.0'),
(1889, '2016-07-03 14:56:54', NULL, NULL, 722, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467548174', 'Staff', '2016-07-03 14:56:54', 'Staff-1467527687-14675290138745460', 1, 1, 'SR', NULL, NULL, '10.0'),
(1890, '2016-07-03 14:49:29', NULL, NULL, 727, 0, 181, '116', 'Open Food ', '', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1467548174', 'Staff', '2016-07-03 14:49:29', 'Staff-1467527687-1467528569396343', 1, 0, '', NULL, NULL, NULL),
(1891, '2016-07-03 14:43:48', NULL, NULL, 726, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467548174', 'Staff', '2016-07-03 14:43:48', 'Staff-1467527687-14675282286534833', 1, 1, 'SR', NULL, NULL, NULL),
(1892, '2016-07-03 14:43:48', NULL, NULL, 726, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467548174', 'Staff', '2016-07-03 14:43:48', 'Staff-1467527687-14675282286534833', 1, 1, 'SR', NULL, NULL, NULL),
(1893, '2016-07-03 14:43:48', NULL, NULL, 726, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467548174', 'Staff', '2016-07-03 14:43:48', 'Staff-1467527687-14675282286534833', 1, 0, '', NULL, NULL, NULL),
(1894, '2016-07-03 14:34:39', NULL, NULL, 725, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 14:34:39', 'admin-1467524695-14675276788855390', 1, 0, '', NULL, NULL, NULL),
(1895, '2016-07-03 14:21:49', NULL, NULL, 715, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 14:21:49', 'admin-1467524695-1467526909772656', 1, 1, 'SR', NULL, NULL, NULL),
(1896, '2016-07-03 14:21:50', NULL, NULL, 715, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 14:21:50', 'admin-1467524695-1467526909772656', 1, 1, 'SR', NULL, NULL, NULL),
(1897, '2016-07-03 14:21:50', NULL, NULL, 715, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 14:21:50', 'admin-1467524695-1467526909772656', 1, 1, 'SR', NULL, NULL, NULL),
(1898, '2016-07-03 14:21:50', NULL, NULL, 715, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 14:21:50', 'admin-1467524695-1467526909772656', 1, 1, 'SR', NULL, NULL, NULL),
(1899, '2016-07-03 14:24:36', NULL, NULL, 716, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 14:24:36', 'admin-1467524695-14675270766646580', 1, 1, 'SR', NULL, NULL, NULL),
(1900, '2016-07-03 14:32:49', NULL, NULL, 724, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 14:32:49', 'admin-1467524695-14675275694673324', 1, 1, 'SR', NULL, NULL, NULL),
(1901, '2016-07-03 14:34:39', NULL, NULL, 725, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 14:34:39', 'admin-1467524695-14675276788855390', 1, 1, 'SR', NULL, NULL, NULL),
(1902, '2016-07-03 14:34:39', NULL, NULL, 725, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 14:34:39', 'admin-1467524695-14675276788855390', 1, 0, '', NULL, NULL, NULL),
(1903, '2016-07-03 14:21:49', NULL, NULL, 715, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 14:21:49', 'admin-1467524695-1467526909772656', 1, 1, 'SR', NULL, NULL, NULL),
(1904, '2016-07-03 14:12:22', NULL, NULL, 715, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 14:12:22', 'admin-1467524695-14675263422564758', 1, 0, '', NULL, NULL, NULL),
(1905, '2016-07-03 14:21:49', NULL, NULL, 715, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 14:21:49', 'admin-1467524695-1467526909772656', 1, 1, 'SR', NULL, NULL, NULL),
(1906, '2016-07-03 14:12:22', NULL, NULL, 715, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 14:12:22', 'admin-1467524695-14675263422564758', 1, 1, 'SR', NULL, NULL, NULL),
(1907, '2016-07-03 14:09:33', NULL, NULL, 723, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 14:09:33', 'admin-1467524695-14675261736845466', 1, 1, 'SR', NULL, NULL, NULL),
(1908, '2016-07-03 14:07:46', NULL, NULL, 713, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 14:07:46', 'admin-1467524695-14675260667215259', 1, 1, 'SR', NULL, NULL, NULL),
(1909, '2016-07-03 14:07:46', NULL, NULL, 713, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 14:07:46', 'admin-1467524695-14675260667215259', 1, 1, 'SR', NULL, NULL, NULL),
(1910, '2016-07-03 14:07:46', NULL, NULL, 713, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 14:07:46', 'admin-1467524695-14675260667215259', 1, 1, 'SR', NULL, NULL, NULL),
(1911, '2016-07-03 13:59:31', NULL, NULL, 721, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:59:31', 'admin-1467524695-14675255709457767', 1, 1, 'SR', NULL, NULL, NULL),
(1912, '2016-07-03 13:59:31', NULL, NULL, 721, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:59:31', 'admin-1467524695-14675255709457767', 1, 1, 'SR', NULL, NULL, NULL),
(1913, '2016-07-03 13:59:31', NULL, NULL, 721, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:59:31', 'admin-1467524695-14675255709457767', 1, 1, 'SR', NULL, NULL, NULL),
(1914, '2016-07-03 13:59:31', NULL, NULL, 721, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:59:31', 'admin-1467524695-14675255709457767', 1, 1, 'SR', NULL, NULL, NULL),
(1915, '2016-07-03 13:41:47', NULL, NULL, 716, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:41:47', 'admin-1467523870-14675245076061938', 1, 1, 'SR', NULL, NULL, NULL),
(1916, '2016-07-03 13:43:42', NULL, NULL, 720, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:43:42', 'admin-1467523870-14675246222686922', 1, 1, 'SR', NULL, NULL, NULL),
(1917, '2016-07-03 13:44:42', NULL, NULL, 716, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:44:42', 'admin-1467523870-1467524682524697', 1, 0, '', NULL, NULL, NULL),
(1918, '2016-07-03 13:45:31', NULL, NULL, 716, 0, 182, '117', 'Open Drinks ', 'americano', 'Desserts', '0', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:45:31', 'admin-1467524695-14675247317514599', 1, 0, '', NULL, NULL, NULL),
(1919, '2016-07-03 13:59:31', NULL, NULL, 721, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:59:31', 'admin-1467524695-14675255709457767', 1, 1, 'SR', NULL, NULL, NULL),
(1920, '2016-07-03 13:41:47', NULL, NULL, 716, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:41:47', 'admin-1467523870-14675245076061938', 1, 1, 'SR', NULL, NULL, NULL),
(1921, '2016-07-03 13:40:45', NULL, NULL, 719, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:40:45', 'admin-1467523870-14675244454763678', 1, 1, 'SR', NULL, NULL, NULL),
(1922, '2016-07-03 13:40:11', NULL, NULL, 718, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:40:11', 'admin-1467523870-14675244116628158', 1, 1, 'SR', NULL, NULL, NULL),
(1923, '2016-07-03 13:39:19', NULL, NULL, 717, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:39:19', 'admin-1467523870-14675243588516925', 1, 0, '', NULL, NULL, NULL),
(1924, '2016-07-03 13:39:09', NULL, NULL, 716, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:39:09', 'admin-1467523870-1467524349674672', 1, 1, 'SR', NULL, NULL, NULL),
(1925, '2016-07-03 13:39:09', NULL, NULL, 716, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:39:09', 'admin-1467523870-1467524349674672', 1, 1, 'SR', NULL, NULL, NULL),
(1926, '2016-07-03 13:39:09', NULL, NULL, 716, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:39:09', 'admin-1467523870-1467524349674672', 1, 0, '', NULL, NULL, NULL),
(1927, '2016-07-03 13:39:09', NULL, NULL, 716, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:39:09', 'admin-1467523870-1467524349674672', 1, 0, '', NULL, NULL, NULL),
(1928, '2016-07-03 13:39:09', NULL, NULL, 716, 0, 81, '81', 'Pepper Pork', 'Pasta', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:39:09', 'admin-1467523870-1467524349674672', 1, 1, 'SR', NULL, NULL, NULL),
(1929, '2016-07-03 13:43:42', NULL, NULL, 720, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:43:42', 'admin-1467523870-14675246222686922', 1, 1, 'SR', NULL, NULL, NULL),
(1930, '2016-07-03 13:39:09', NULL, NULL, 716, NULL, 84, '84', 'Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:39:09', 'admin-1467523870-1467524349674672', 1, 1, 'SR', NULL, NULL, NULL),
(1931, '2016-07-03 13:33:03', NULL, NULL, 715, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:33:03', 'admin-1467523870-1467523983801694', 1, 1, 'SR', NULL, NULL, NULL),
(1932, '2016-07-03 13:31:28', NULL, NULL, 715, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:31:28', 'admin-1467523870-1467523888314582', 1, 0, '', NULL, NULL, NULL),
(1933, '2016-07-03 13:30:57', NULL, NULL, 715, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:30:57', 'admin-1467522176-14675238572262347', 1, 0, '', NULL, NULL, NULL),
(1934, '2016-07-03 13:25:45', NULL, NULL, 715, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:25:45', 'admin-1467522176-14675235450842368', 1, 0, '', NULL, NULL, NULL),
(1935, '2016-07-03 13:25:45', NULL, NULL, 715, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:25:45', 'admin-1467522176-14675235450842368', 1, 1, 'SR', NULL, NULL, NULL),
(1936, '2016-07-03 13:25:45', NULL, NULL, 715, 0, 189, '124', 'Stuffed Bitter Gourd', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:25:45', 'admin-1467522176-14675235450842368', 1, 0, '', NULL, NULL, NULL),
(1937, '2016-07-03 13:25:45', NULL, NULL, 715, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:25:45', 'admin-1467522176-14675235450842368', 1, 0, '', NULL, NULL, NULL),
(1938, '2016-07-03 13:28:22', NULL, NULL, 709, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:28:22', 'admin-1467522176-14675237021873071', 1, 1, 'SR', NULL, NULL, NULL),
(1939, '2016-07-03 13:18:54', NULL, NULL, 708, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:18:54', 'admin-1467522176-1467523133972497', 1, 0, '', NULL, NULL, NULL),
(1940, '2016-07-03 13:25:45', NULL, NULL, 715, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:25:45', 'admin-1467522176-14675235450842368', 1, 0, '', NULL, NULL, NULL),
(1941, '2016-07-03 13:18:54', NULL, NULL, 708, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:18:54', 'admin-1467522176-1467523133972497', 1, 0, '', NULL, NULL, NULL),
(1942, '2016-07-03 13:18:54', NULL, NULL, 708, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:18:54', 'admin-1467522176-1467523133972497', 1, 0, '', NULL, NULL, NULL),
(1943, '2016-07-03 13:18:54', NULL, NULL, 708, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:18:54', 'admin-1467522176-1467523133972497', 1, 0, '', NULL, NULL, NULL),
(1944, '2016-07-03 13:03:36', NULL, NULL, 712, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:03:36', 'admin-1467522176-14675222161816910', 1, 1, 'SR', NULL, NULL, NULL),
(1945, '2016-07-03 13:03:36', NULL, NULL, 712, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:03:36', 'admin-1467522176-14675222161816910', 1, 1, 'SR', NULL, NULL, NULL),
(1946, '2016-07-03 13:03:36', NULL, NULL, 712, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:03:36', 'admin-1467522176-14675222161816910', 1, 1, 'SR', NULL, NULL, NULL),
(1947, '2016-07-03 13:04:40', NULL, NULL, 712, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:04:40', 'admin-1467522176-14675222798333917', 1, 1, 'SR', NULL, NULL, NULL),
(1948, '2016-07-03 13:04:40', NULL, NULL, 712, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:04:40', 'admin-1467522176-14675222798333917', 1, 0, '', NULL, NULL, NULL),
(1949, '2016-07-03 14:09:33', NULL, NULL, 723, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 14:09:33', 'admin-1467524695-14675261736845466', 1, 1, 'SR', NULL, NULL, NULL),
(1950, '2016-07-03 13:17:32', NULL, NULL, 714, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:17:32', 'admin-1467522176-1467523052330925', 1, 0, '', NULL, NULL, NULL),
(1951, '2016-07-03 13:00:54', NULL, NULL, 707, 0, 189, '124', 'Stuffed Bitter Gourd', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:00:54', 'admin-1467520953-1467522054732745', 1, 0, '', NULL, NULL, NULL),
(1952, '2016-07-03 13:01:26', NULL, NULL, 711, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:01:26', 'admin-1467520953-1467522086543945', 1, 1, 'SR', NULL, NULL, NULL),
(1953, '2016-07-03 13:01:26', NULL, NULL, 711, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:01:26', 'admin-1467520953-1467522086543945', 1, 1, 'SR', NULL, NULL, NULL),
(1954, '2016-07-03 13:03:36', NULL, NULL, 712, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:03:36', 'admin-1467522176-14675222161816910', 1, 1, 'SR', NULL, NULL, NULL),
(1955, '2016-07-03 12:43:16', NULL, NULL, 710, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:43:16', 'admin-1467520953-14675209967998739', 1, 1, 'SR', NULL, NULL, NULL),
(1956, '2016-07-03 12:58:38', NULL, NULL, 707, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:58:38', 'admin-1467520953-14675219180112855', 1, 0, '', NULL, NULL, NULL),
(1957, '2016-07-03 12:31:58', NULL, NULL, 708, 0, 181, '116', 'Open Food ', 'spicy wings', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:31:58', 'admin-1467512007-14675203180999656', 1, 0, '', NULL, NULL, NULL),
(1958, '2016-07-03 13:00:24', NULL, NULL, 708, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 13:00:24', 'admin-1467520953-14675220243554382', 1, 1, 'SR', NULL, NULL, NULL),
(1959, '2016-07-03 12:58:38', NULL, NULL, 707, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:58:38', 'admin-1467520953-14675219180112855', 1, 1, 'SR', NULL, NULL, NULL),
(1960, '2016-07-03 12:43:16', NULL, NULL, 710, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:43:16', 'admin-1467520953-14675209967998739', 1, 1, 'SR', NULL, NULL, NULL),
(1961, '2016-07-03 12:43:16', NULL, NULL, 710, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:43:16', 'admin-1467520953-14675209967998739', 1, 0, '', NULL, NULL, NULL),
(1962, '2016-07-03 12:42:17', NULL, NULL, 709, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:42:17', 'admin-1467512007-14675209370234510', 1, 1, 'SR', NULL, NULL, NULL),
(1963, '2016-07-03 12:42:17', NULL, NULL, 709, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:42:17', 'admin-1467512007-14675209370234510', 1, 0, '', NULL, NULL, NULL),
(1964, '2016-07-03 12:33:46', NULL, NULL, 708, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:33:46', 'admin-1467512007-14675204264648592', 1, 0, '', NULL, NULL, NULL),
(1965, '2016-07-03 12:33:46', NULL, NULL, 708, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:33:46', 'admin-1467512007-14675204264648592', 1, 1, 'SR', NULL, NULL, NULL),
(1966, '2016-07-03 12:31:58', NULL, NULL, 708, 0, 181, '116', 'Open Food ', 'Soya paste pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:31:58', 'admin-1467512007-14675203180999656', 1, 0, '', NULL, NULL, NULL),
(1967, '2016-07-03 12:31:58', NULL, NULL, 708, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:31:58', 'admin-1467512007-14675203180999656', 1, 1, 'SR', NULL, NULL, NULL),
(1968, '2016-07-03 12:31:58', NULL, NULL, 708, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:31:58', 'admin-1467512007-14675203180999656', 1, 0, '', NULL, NULL, NULL),
(1969, '2016-07-03 12:31:58', NULL, NULL, 708, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:31:58', 'admin-1467512007-14675203180999656', 1, 0, '', NULL, NULL, NULL),
(1970, '2016-07-03 12:15:23', NULL, NULL, 707, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:15:23', 'admin-1467512007-14675193229502243', 1, 1, 'SR', NULL, NULL, NULL),
(1971, '2016-07-03 12:07:55', NULL, NULL, 706, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:07:55', 'admin-1467512007-14675188754992330', 1, 1, 'SR', NULL, NULL, NULL),
(1972, '2016-07-03 12:07:55', NULL, NULL, 706, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:07:55', 'admin-1467512007-14675188754992330', 1, 0, '', NULL, NULL, NULL),
(1973, '2016-07-03 12:31:58', NULL, NULL, 708, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:31:58', 'admin-1467512007-14675203180999656', 1, 1, 'SR', NULL, NULL, NULL),
(1974, '2016-07-03 12:31:58', NULL, NULL, 708, 0, 189, '124', 'Stuffed Bitter Gourd', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:31:58', 'admin-1467512007-14675203180999656', 1, 0, '', NULL, NULL, NULL),
(1975, '2016-07-03 12:15:23', NULL, NULL, 707, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:15:23', 'admin-1467512007-14675193229502243', 1, 1, 'SR', NULL, NULL, NULL),
(1976, '2016-07-03 12:15:23', NULL, NULL, 707, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:15:23', 'admin-1467512007-14675193229502243', 1, 1, 'SR', NULL, NULL, NULL),
(1977, '2016-07-03 12:07:55', NULL, NULL, 706, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:07:55', 'admin-1467512007-14675188754992330', 1, 0, '', NULL, NULL, NULL),
(1978, '2016-07-03 12:07:55', NULL, NULL, 706, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 12:07:55', 'admin-1467512007-14675188754992330', 1, 0, '', NULL, NULL, NULL),
(1979, '2016-07-03 14:07:46', NULL, NULL, 713, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 14:07:46', 'admin-1467524695-14675260667215259', 1, 1, 'SR', NULL, NULL, NULL),
(1980, '2016-07-03 11:42:17', NULL, NULL, 705, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 11:42:17', 'admin-1467512007-14675173376495416', 1, 1, 'SR', NULL, NULL, NULL),
(1981, '2016-07-03 11:42:17', NULL, NULL, 705, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 11:42:17', 'admin-1467512007-14675173376495416', 1, 1, 'SR', NULL, NULL, NULL),
(1982, '2016-07-03 09:51:48', NULL, NULL, 699, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 09:51:48', 'admin-1467507100-14675107081172948', 1, 0, '', NULL, NULL, NULL),
(1983, '2016-07-03 10:06:29', NULL, NULL, 701, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 10:06:29', 'admin-1467507100-14675115888604813', 1, 0, '', NULL, NULL, NULL),
(1984, '2016-07-03 10:06:29', NULL, NULL, 701, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 10:06:29', 'admin-1467507100-14675115888604813', 1, 1, 'SR', NULL, NULL, NULL),
(1985, '2016-07-03 10:10:28', NULL, NULL, 702, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 10:10:28', 'admin-1467507100-14675118287009936', 1, 0, '', NULL, NULL, NULL),
(1986, '2016-07-03 10:10:28', NULL, NULL, 702, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 10:10:28', 'admin-1467507100-14675118287009936', 1, 1, 'SR', NULL, NULL, NULL),
(1987, '2016-07-03 10:11:33', NULL, NULL, 703, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 10:11:33', 'admin-1467507100-14675118936999782', 1, 1, 'SR', NULL, NULL, NULL),
(1988, '2016-07-03 10:11:33', NULL, NULL, 703, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 10:11:33', 'admin-1467507100-14675118936999782', 1, 1, 'SR', NULL, NULL, NULL),
(1989, '2016-07-03 10:11:33', NULL, NULL, 703, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 10:11:33', 'admin-1467507100-14675118936999782', 1, 1, 'SR', NULL, NULL, NULL),
(1990, '2016-07-03 10:11:33', NULL, NULL, 703, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 10:11:33', 'admin-1467507100-14675118936999782', 1, 0, '', NULL, NULL, NULL),
(1991, '2016-07-03 10:11:33', NULL, NULL, 703, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 10:11:33', 'admin-1467507100-14675118936999782', 1, 0, '', NULL, NULL, NULL),
(1992, '2016-07-03 10:44:23', NULL, NULL, 700, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 3, 20.00, 60.0000, 0.0000, 60.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 10:44:23', 'admin-1467512007-14675138629855383', 1, 0, '', NULL, NULL, NULL),
(1993, '2016-07-03 10:44:23', NULL, NULL, 700, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 10:44:23', 'admin-1467512007-14675138629855383', 1, 0, '', NULL, NULL, NULL),
(1994, '2016-07-03 10:44:23', NULL, NULL, 700, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 10:44:23', 'admin-1467512007-14675138629855383', 1, 1, 'SR', NULL, NULL, NULL),
(1995, '2016-07-03 11:17:01', NULL, NULL, 704, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 11:17:01', 'admin-1467512007-14675158209352849', 1, 0, '', NULL, NULL, NULL),
(1996, '2016-07-03 11:17:01', NULL, NULL, 704, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 11:17:01', 'admin-1467512007-14675158209352849', 1, 0, '', NULL, NULL, NULL),
(1997, '2016-07-03 11:17:10', NULL, NULL, 704, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 11:17:10', 'admin-1467512007-14675158301724359', 1, 0, '', NULL, NULL, NULL),
(1998, '2016-07-03 11:42:17', NULL, NULL, 705, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 11:42:17', 'admin-1467512007-14675173376495416', 1, 0, '', NULL, NULL, NULL),
(1999, '2016-07-03 11:42:17', NULL, NULL, 705, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 11:42:17', 'admin-1467512007-14675173376495416', 1, 0, '', NULL, NULL, NULL),
(2000, '2016-07-03 09:51:48', NULL, NULL, 699, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 09:51:48', 'admin-1467507100-14675107081172948', 1, 0, '', NULL, NULL, NULL),
(2001, '2016-07-03 09:51:48', NULL, NULL, 699, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 09:51:48', 'admin-1467507100-14675107081172948', 1, 0, '', NULL, NULL, NULL),
(2002, '2016-07-03 09:31:36', NULL, NULL, 698, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 09:31:36', 'admin-1467507100-1467509495909983', 1, 0, '', NULL, NULL, NULL),
(2003, '2016-07-03 09:31:36', NULL, NULL, 698, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 09:31:36', 'admin-1467507100-1467509495909983', 1, 1, 'SR', NULL, NULL, NULL),
(2004, '2016-07-03 09:07:03', NULL, NULL, 697, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 09:07:03', 'admin-1467507100-14675080235314448', 1, 1, 'SR', NULL, NULL, NULL),
(2005, '2016-07-03 09:07:03', NULL, NULL, 697, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 09:07:03', 'admin-1467507100-14675080235314448', 1, 1, 'SR', NULL, NULL, NULL),
(2006, '2016-07-03 09:06:25', NULL, NULL, 697, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467548174', 'admin', '2016-07-03 09:06:25', 'admin-1467507100-14675079849863335', 1, 0, '', NULL, NULL, NULL),
(2007, '2016-07-05 14:06:30', NULL, NULL, 757, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 14:06:30', 'admin-1467695051-14676987905755164', 1, 1, 'SR', NULL, NULL, NULL),
(2008, '2016-07-05 14:19:14', NULL, NULL, 754, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 14:19:14', 'admin-1467695051-14676995547079261', 1, 1, 'SR', NULL, NULL, NULL),
(2009, '2016-07-05 10:58:49', NULL, NULL, 742, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:58:49', 'admin-1467687402-14676875288858520', 1, 1, 'SR', NULL, NULL, NULL),
(2010, '2016-07-05 10:58:49', NULL, NULL, 742, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:58:49', 'admin-1467687402-14676875288858520', 1, 1, 'SR', NULL, NULL, NULL),
(2011, '2016-07-05 11:10:27', NULL, NULL, 743, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 11:10:27', 'admin-1467687402-14676882272379753', 1, 1, 'SR', NULL, NULL, NULL),
(2012, '2016-07-05 11:17:27', NULL, NULL, 741, 0, 181, '116', 'Open Food ', 'Half Boiled Egg', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 11:17:27', 'admin-1467687402-14676886470836828', 1, 0, '', NULL, NULL, NULL),
(2013, '2016-07-05 11:20:09', NULL, NULL, 744, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 11:20:09', 'admin-1467687402-14676888089554096', 1, 1, 'SR', NULL, NULL, NULL),
(2014, '2016-07-05 11:36:59', NULL, NULL, 745, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 11:36:59', 'admin-1467687402-14676898190572345', 1, 1, 'SR', NULL, NULL, NULL),
(2015, '2016-07-05 11:36:59', NULL, NULL, 745, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 11:36:59', 'admin-1467687402-14676898190572345', 1, 1, 'SR', NULL, NULL, NULL),
(2016, '2016-07-05 11:48:54', NULL, NULL, 746, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 11:48:54', 'admin-1467687402-14676905338971980', 1, 1, 'SR', NULL, NULL, NULL),
(2017, '2016-07-05 11:58:57', NULL, NULL, 747, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 11:58:57', 'admin-1467687402-14676911377408145', 1, 1, 'SR', NULL, NULL, NULL),
(2018, '2016-07-05 11:58:57', NULL, NULL, 747, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 11:58:57', 'admin-1467687402-14676911377408145', 1, 1, 'SR', NULL, NULL, NULL),
(2019, '2016-07-05 12:03:48', NULL, NULL, 748, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 12:03:48', 'admin-1467687402-14676914281283993', 1, 0, '', NULL, NULL, NULL),
(2020, '2016-07-05 12:05:34', NULL, NULL, 749, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 12:05:34', 'admin-1467687402-14676915341352147', 1, 1, 'SR', NULL, NULL, NULL),
(2021, '2016-07-05 12:05:34', NULL, NULL, 749, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 12:05:34', 'admin-1467687402-14676915341352147', 1, 1, 'SR', NULL, NULL, NULL),
(2022, '2016-07-05 12:16:38', NULL, NULL, 750, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 12:16:38', 'admin-1467687402-1467692198165872', 1, 1, 'SR', NULL, NULL, NULL),
(2023, '2016-07-05 12:16:38', NULL, NULL, 750, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 12:16:38', 'admin-1467687402-1467692198165872', 1, 1, 'SR', NULL, NULL, NULL),
(2024, '2016-07-05 12:20:59', NULL, NULL, 751, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 12:20:59', 'admin-1467687402-14676924590344557', 1, 0, '', NULL, NULL, NULL),
(2025, '2016-07-05 12:20:59', NULL, NULL, 751, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 12:20:59', 'admin-1467687402-14676924590344557', 1, 1, 'SR', NULL, NULL, NULL),
(2026, '2016-07-05 12:29:30', NULL, NULL, 752, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 12:29:30', 'admin-1467687402-14676929703029499', 1, 1, 'SR', NULL, NULL, NULL),
(2027, '2016-07-05 12:29:30', NULL, NULL, 752, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 12:29:30', 'admin-1467687402-14676929703029499', 1, 1, 'SR', NULL, NULL, NULL),
(2028, '2016-07-05 12:29:30', NULL, NULL, 752, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 12:29:30', 'admin-1467687402-14676929703029499', 1, 0, '', NULL, NULL, NULL),
(2029, '2016-07-05 12:43:15', NULL, NULL, 753, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 12:43:15', 'admin-1467687402-14676937948689567', 1, 1, 'SR', NULL, NULL, NULL),
(2030, '2016-07-05 13:04:01', NULL, NULL, 754, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 13:04:01', 'admin-1467687402-14676950413089293', 1, 0, '', NULL, NULL, NULL),
(2031, '2016-07-05 13:04:01', NULL, NULL, 754, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 13:04:01', 'admin-1467687402-14676950413089293', 1, 0, '', NULL, NULL, NULL),
(2032, '2016-07-05 13:04:50', NULL, NULL, 754, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 13:04:50', 'admin-1467695051-14676950905763037', 1, 1, 'SR', NULL, NULL, NULL),
(2033, '2016-07-05 13:41:48', NULL, NULL, 755, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 13:41:48', 'admin-1467695051-14676973082011850', 1, 1, 'SR', NULL, NULL, NULL),
(2034, '2016-07-05 13:41:48', NULL, NULL, 755, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 13:41:48', 'admin-1467695051-14676973082011850', 1, 1, 'SR', NULL, NULL, NULL),
(2035, '2016-07-05 13:41:48', NULL, NULL, 755, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 13:41:48', 'admin-1467695051-14676973082011850', 1, 0, '', NULL, NULL, NULL),
(2036, '2016-07-05 13:43:54', NULL, NULL, 755, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 13:43:54', 'admin-1467695051-14676974342716197', 1, 1, 'SR', NULL, NULL, NULL),
(2037, '2016-07-05 13:43:54', NULL, NULL, 755, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 13:43:54', 'admin-1467695051-14676974342716197', 1, 1, 'SR', NULL, NULL, NULL),
(2038, '2016-07-05 13:55:04', NULL, NULL, 756, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 13:55:04', 'admin-1467695051-14676981043436156', 1, 0, '', NULL, NULL, NULL),
(2039, '2016-07-05 13:55:04', NULL, NULL, 756, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 13:55:04', 'admin-1467695051-14676981043436156', 1, 0, '', NULL, NULL, NULL),
(2040, '2016-07-05 13:55:04', NULL, NULL, 756, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 13:55:04', 'admin-1467695051-14676981043436156', 1, 1, 'SR', NULL, NULL, NULL),
(2041, '2016-07-05 13:55:04', NULL, NULL, 756, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 13:55:04', 'admin-1467695051-14676981043436156', 1, 0, '', NULL, NULL, NULL),
(2042, '2016-07-05 14:06:19', NULL, NULL, 757, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 14:06:19', 'admin-1467695051-14676987797321427', 1, 1, 'SR', NULL, NULL, NULL),
(2043, '2016-07-05 14:19:14', NULL, NULL, 754, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 14:19:14', 'admin-1467695051-14676995547079261', 1, 1, 'SR', NULL, NULL, NULL),
(2044, '2016-07-05 20:03:58', NULL, NULL, 766, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 20:03:58', 'admin-1467695051-14677202383471890', 1, 1, 'SR', NULL, NULL, NULL),
(2045, '2016-07-05 16:39:09', NULL, NULL, 768, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 16:39:10', 'admin-1467695051-14677079497741044', 1, 1, 'SR', NULL, NULL, NULL),
(2046, '2016-07-05 16:39:09', NULL, NULL, 768, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 16:39:09', 'admin-1467695051-14677079497741044', 1, 0, '', NULL, NULL, NULL),
(2047, '2016-07-05 16:38:08', NULL, NULL, 767, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 16:38:08', 'admin-1467695051-14677078886726926', 1, 1, 'SR', 1, NULL, NULL),
(2048, '2016-07-05 16:38:08', NULL, NULL, 767, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 16:38:08', 'admin-1467695051-14677078886726926', 1, 1, 'SR', 1, NULL, NULL),
(2049, '2016-07-05 15:41:38', NULL, NULL, 764, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 15:41:38', 'admin-1467695051-14677044979138087', 1, 0, '', NULL, NULL, NULL),
(2050, '2016-07-05 15:41:38', NULL, NULL, 764, 0, 187, '122', 'Iced Tea ', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 15:41:38', 'admin-1467695051-14677044979138087', 1, 0, '', NULL, NULL, NULL),
(2051, '2016-07-05 16:06:30', NULL, NULL, 765, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 16:06:30', 'admin-1467695051-14677059900992168', 1, 0, '', NULL, NULL, NULL),
(2052, '2016-07-05 15:28:20', NULL, NULL, 763, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 15:28:20', 'admin-1467695051-14677037001022739', 1, 1, 'SR', NULL, NULL, NULL),
(2053, '2016-07-05 15:28:20', NULL, NULL, 763, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 15:28:20', 'admin-1467695051-14677037001022739', 1, 0, '', NULL, NULL, NULL),
(2054, '2016-07-05 15:00:06', NULL, NULL, 754, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 15:00:06', 'admin-1467695051-14677020067155944', 1, 1, 'SR', NULL, NULL, NULL),
(2055, '2016-07-05 14:59:41', NULL, NULL, 761, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 14:59:41', 'admin-1467695051-14677019814435087', 1, 1, 'SR', NULL, NULL, NULL),
(2056, '2016-07-05 14:22:40', NULL, NULL, 758, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 14:22:40', 'admin-1467695051-14676997605985282', 1, 0, '', NULL, NULL, NULL),
(2057, '2016-07-05 15:06:35', NULL, NULL, 762, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 15:06:35', 'admin-1467695051-14677023955674821', 1, 0, '', NULL, NULL, NULL),
(2058, '2016-07-05 15:06:35', NULL, NULL, 762, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 15:06:35', 'admin-1467695051-14677023955674821', 1, 1, 'SR', NULL, NULL, NULL),
(2059, '2016-07-05 14:23:56', NULL, NULL, 759, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 14:23:56', 'admin-1467695051-14676998362119030', 1, 0, '', NULL, NULL, NULL),
(2060, '2016-07-05 14:25:05', NULL, NULL, 760, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 14:25:05', 'admin-1467695051-14676999056705155', 1, 1, 'SR', NULL, NULL, NULL),
(2061, '2016-07-05 14:22:48', NULL, NULL, 758, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 14:22:48', 'admin-1467695051-14676997685089853', 1, 0, '', NULL, NULL, NULL),
(2062, '2016-07-05 14:06:30', NULL, NULL, 757, 0, 187, '122', 'Iced Tea ', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 14:06:30', 'admin-1467695051-14676987905755164', 1, 0, '', NULL, NULL, NULL),
(2063, '2016-07-05 14:10:00', NULL, NULL, 757, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 14:10:00', 'admin-1467695051-14676989998739297', 1, 0, '', NULL, NULL, NULL),
(2064, '2016-07-05 14:06:19', NULL, NULL, 757, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 14:06:19', 'admin-1467695051-14676987797321427', 1, 0, '', NULL, NULL, NULL),
(2065, '2016-07-05 10:58:49', NULL, NULL, 742, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:58:49', 'admin-1467687402-14676875288858520', 1, 1, 'SR', NULL, NULL, NULL),
(2066, '2016-07-05 10:49:58', NULL, NULL, 740, 0, 153, '87', 'Big Breakfast ', 'Takeaway', 'Meals', 'Morning Bites ', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:49:58', 'admin-1467680725-14676869978779353', 1, 0, '', NULL, NULL, NULL),
(2067, '2016-07-05 10:15:30', NULL, NULL, 736, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:15:30', 'admin-1467680725-14676849302766259', 1, 0, '', NULL, NULL, NULL),
(2068, '2016-07-05 10:31:00', NULL, NULL, 737, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:31:00', 'admin-1467680725-14676858604883331', 1, 1, 'SR', NULL, NULL, NULL),
(2069, '2016-07-05 10:40:59', NULL, NULL, 738, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:40:59', 'admin-1467680725-14676864593176333', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(2070, '2016-07-05 10:40:59', NULL, NULL, 738, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:40:59', 'admin-1467680725-14676864593176333', 1, 1, 'SR', NULL, NULL, NULL),
(2071, '2016-07-05 10:40:59', NULL, NULL, 738, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:40:59', 'admin-1467680725-14676864593176333', 1, 1, 'SR', NULL, NULL, NULL),
(2072, '2016-07-05 10:40:59', NULL, NULL, 738, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:40:59', 'admin-1467680725-14676864593176333', 1, 1, 'SR', NULL, NULL, NULL),
(2073, '2016-07-05 10:40:59', NULL, NULL, 738, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:40:59', 'admin-1467680725-14676864593176333', 1, 0, '', NULL, NULL, NULL),
(2074, '2016-07-05 10:45:03', NULL, NULL, 739, 0, 39, '39', 'Mango Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:45:03', 'admin-1467680725-14676867032662258', 1, 1, 'SR', NULL, NULL, NULL),
(2075, '2016-07-05 10:45:03', NULL, NULL, 739, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:45:03', 'admin-1467680725-14676867032662258', 1, 1, 'SR', NULL, NULL, NULL),
(2076, '2016-07-05 10:45:03', NULL, NULL, 739, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:45:03', 'admin-1467680725-14676867032662258', 1, 1, 'SR', NULL, NULL, NULL),
(2077, '2016-07-05 09:09:36', NULL, NULL, 734, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 09:09:36', 'admin-1467680725-1467680976369312', 1, 0, '', NULL, NULL, NULL),
(2078, '2016-07-05 09:09:36', NULL, NULL, 734, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 09:09:36', 'admin-1467680725-1467680976369312', 1, 1, 'SR', NULL, NULL, NULL),
(2079, '2016-07-05 09:09:36', NULL, NULL, 734, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 09:09:36', 'admin-1467680725-1467680976369312', 1, 0, '', NULL, NULL, NULL),
(2080, '2016-07-05 10:58:49', NULL, NULL, 742, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:58:49', 'admin-1467687402-14676875288858520', 1, 0, '', NULL, NULL, NULL),
(2081, '2016-07-05 10:56:29', NULL, NULL, 741, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:56:29', 'admin-1467680725-1467687389376356', 1, 1, 'SR', NULL, NULL, NULL),
(2082, '2016-07-05 10:56:29', NULL, NULL, 741, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:56:29', 'admin-1467680725-1467687389376356', 1, 1, 'SR', NULL, NULL, NULL),
(2083, '2016-07-05 10:56:29', NULL, NULL, 741, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:56:29', 'admin-1467680725-1467687389376356', 1, 0, '', NULL, NULL, NULL),
(2084, '2016-07-05 10:49:58', NULL, NULL, 740, 0, 153, '87', 'Big Breakfast ', 'Takeaway', 'Meals', 'Morning Bites ', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:49:58', 'admin-1467680725-14676869978779353', 1, 0, '', NULL, NULL, NULL),
(2085, '2016-07-05 10:15:04', NULL, NULL, 736, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:15:04', 'admin-1467680725-14676849041761387', 1, 0, '', NULL, NULL, NULL),
(2086, '2016-07-05 10:15:04', NULL, NULL, 736, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:15:04', 'admin-1467680725-14676849041761387', 1, 0, '', NULL, NULL, NULL),
(2087, '2016-07-05 10:08:17', NULL, NULL, 735, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:08:17', 'admin-1467680725-14676844976128746', 1, 0, '', NULL, NULL, NULL),
(2088, '2016-07-05 10:08:27', NULL, NULL, 735, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:08:27', 'admin-1467680725-14676845073084563', 1, 1, 'SR', NULL, NULL, NULL),
(2089, '2016-07-05 10:08:27', NULL, NULL, 735, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 10:08:27', 'admin-1467680725-14676845073084563', 1, 1, 'SR', NULL, NULL, NULL),
(2090, '2016-07-05 09:09:36', NULL, NULL, 734, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 09:09:36', 'admin-1467680725-1467680976369312', 1, 1, 'SR', NULL, NULL, NULL),
(2091, '2016-07-05 09:09:36', NULL, NULL, 734, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467724146', 'admin', '2016-07-05 09:09:36', 'admin-1467680725-1467680976369312', 1, 0, '', NULL, NULL, NULL),
(2092, '2016-07-06 20:00:26', NULL, NULL, 803, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 20:00:26', 'Staff-1467789963-1467806426461130', 1, 1, 'SR', NULL, NULL, NULL),
(2093, '2016-07-06 20:06:55', NULL, NULL, 806, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 20:06:55', 'Staff-1467789963-14678068150055464', 1, 0, '', NULL, NULL, NULL),
(2094, '2016-07-06 20:06:55', NULL, NULL, 806, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 20:06:55', 'Staff-1467789963-14678068150055464', 1, 0, '', NULL, NULL, NULL),
(2095, '2016-07-06 20:08:42', NULL, NULL, 806, 0, 195, '130', 'Cucumber Lime Soda BOFO', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 20:08:42', 'Staff-1467789963-1467806922002877', 1, 0, '', NULL, NULL, NULL),
(2096, '2016-07-06 20:13:28', NULL, NULL, 806, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 20:13:28', 'Staff-1467789963-14678072083998156', 1, 0, '', NULL, NULL, NULL),
(2097, '2016-07-06 20:13:28', NULL, NULL, 806, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 20:13:28', 'Staff-1467789963-14678072083998156', 1, 0, '', NULL, NULL, NULL),
(2098, '2016-07-06 20:14:56', NULL, NULL, 806, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 20:14:56', 'Staff-1467789963-14678072963076312', 1, 0, '', NULL, NULL, NULL),
(2099, '2016-07-06 20:14:56', NULL, NULL, 806, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 20:14:56', 'Staff-1467789963-14678072963076312', 1, 0, '', NULL, NULL, NULL),
(2100, '2016-07-06 20:14:56', NULL, NULL, 806, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 20:14:56', 'Staff-1467789963-14678072963076312', 1, 0, '', NULL, NULL, NULL),
(2101, '2016-07-06 20:22:00', NULL, NULL, 806, 0, 181, '116', 'Open Food ', 'Pepper Pork', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 20:22:00', 'admin-1467807304-14678077204582656', 1, 0, '', NULL, NULL, NULL),
(2102, '2016-07-06 20:22:00', NULL, NULL, 806, 0, 181, '116', 'Open Food ', 'Mushroom Ginger Chicken', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 20:22:00', 'admin-1467807304-14678077204582656', 1, 0, '', NULL, NULL, NULL),
(2103, '2016-07-06 20:24:24', NULL, NULL, 806, 0, 195, '130', 'Cucumber Lime Soda BOFO', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 20:24:24', 'admin-1467807304-14678078643855569', 1, 0, '', NULL, NULL, NULL),
(2104, '2016-07-06 19:54:55', NULL, NULL, 807, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 19:54:55', 'Staff-1467789963-14678060955158322', 1, 1, 'SR', NULL, NULL, NULL),
(2105, '2016-07-06 19:54:55', NULL, NULL, 807, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 19:54:55', 'Staff-1467789963-14678060955158322', 1, 0, '', NULL, NULL, NULL),
(2106, '2016-07-06 19:53:56', NULL, NULL, 806, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 19:53:56', 'Staff-1467789963-14678060358138496', 1, 0, '', NULL, NULL, NULL),
(2107, '2016-07-06 19:53:56', NULL, NULL, 806, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 19:53:56', 'Staff-1467789963-14678060358138496', 1, 0, '', NULL, NULL, NULL),
(2108, '2016-07-06 19:54:55', NULL, NULL, 807, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 19:54:55', 'Staff-1467789963-14678060955158322', 1, 1, 'SR', NULL, NULL, NULL),
(2109, '2016-07-06 19:54:55', NULL, NULL, 807, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 19:54:55', 'Staff-1467789963-14678060955158322', 1, 1, 'SR', NULL, NULL, NULL),
(2110, '2016-07-06 19:19:41', NULL, NULL, 802, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 19:19:41', 'Staff-1467789963-14678039812983170', 1, 0, '', NULL, NULL, NULL),
(2111, '2016-07-06 19:19:41', NULL, NULL, 802, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 19:19:41', 'Staff-1467789963-14678039812983170', 1, 1, 'SR', NULL, NULL, NULL),
(2112, '2016-07-06 19:19:55', NULL, NULL, 803, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 19:19:55', 'Staff-1467789963-14678039957633158', 1, 1, 'SR', NULL, NULL, NULL),
(2113, '2016-07-06 19:19:55', NULL, NULL, 803, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 19:19:55', 'Staff-1467789963-14678039957633158', 1, 1, 'SR', NULL, NULL, NULL),
(2114, '2016-07-06 14:01:42', NULL, NULL, 785, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 14:01:42', 'Staff-1467784297-14677849026863457', 1, 1, 'SR', NULL, NULL, NULL),
(2115, '2016-07-06 14:01:42', NULL, NULL, 785, NULL, 26, '26', 'Tea By Cup', '', 'Hot Drinks', 'Non Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 14:01:42', 'Staff-1467784297-14677849026863457', 1, 1, 'SR', NULL, NULL, NULL),
(2116, '2016-07-06 14:09:54', NULL, NULL, 786, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 14:09:54', 'Staff-1467784297-14677853945816625', 1, 0, '', NULL, NULL, NULL),
(2117, '2016-07-06 14:10:59', NULL, NULL, 786, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 14:10:59', 'Staff-1467784297-14677854592141869', 1, 1, 'SR', NULL, NULL, NULL),
(2118, '2016-07-06 14:10:59', NULL, NULL, 786, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 14:10:59', 'Staff-1467784297-14677854592141869', 1, 1, 'SR', NULL, NULL, NULL),
(2119, '2016-07-06 14:10:59', NULL, NULL, 786, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 14:10:59', 'Staff-1467784297-14677854592141869', 1, 1, 'SR', NULL, NULL, NULL),
(2120, '2016-07-06 14:10:59', NULL, NULL, 786, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 14:10:59', 'Staff-1467784297-14677854592141869', 1, 1, 'SR', NULL, NULL, NULL),
(2121, '2016-07-06 14:10:59', NULL, NULL, 786, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 14:10:59', 'Staff-1467784297-14677854592141869', 1, 0, '', NULL, NULL, NULL),
(2122, '2016-07-06 14:10:59', NULL, NULL, 786, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 14:10:59', 'Staff-1467784297-14677854592141869', 1, 0, '', NULL, NULL, NULL),
(2123, '2016-07-06 15:02:47', NULL, NULL, 787, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 15:02:47', 'Staff-1467784297-14677885676089573', 1, 0, '', NULL, NULL, NULL),
(2124, '2016-07-06 19:53:15', NULL, NULL, 806, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 19:53:15', 'Staff-1467789963-14678059955865078', 1, 0, '', NULL, NULL, NULL),
(2125, '2016-07-06 19:53:03', NULL, NULL, 806, 0, 76, '76', 'Pesto Pasta', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 19:53:03', 'Staff-1467789963-14678059831974940', 1, 1, 'SR', NULL, NULL, NULL),
(2126, '2016-07-06 19:52:10', NULL, NULL, 806, 0, 195, '130', 'Cucumber Lime Soda BOFO', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 19:52:10', 'Staff-1467789963-14678059301722391', 1, 0, '', NULL, NULL, NULL),
(2127, '2016-07-06 19:52:10', NULL, NULL, 806, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 19:52:10', 'Staff-1467789963-14678059301722391', 1, 1, 'SR', NULL, NULL, NULL),
(2128, '2016-07-06 19:53:03', NULL, NULL, 806, 0, 193, '128', 'Salted Garlic Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 19:53:03', 'Staff-1467789963-14678059831974940', 1, 0, '', NULL, NULL, NULL),
(2129, '2016-07-06 19:53:03', NULL, NULL, 806, 0, 192, '127', 'Stir Fried Chili Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 19:53:03', 'Staff-1467789963-14678059831974940', 1, 0, '', NULL, NULL, NULL),
(2130, '2016-07-06 20:35:01', NULL, NULL, 806, 0, 181, '116', 'Open Food ', 'mushroom chicken', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 20:35:01', 'admin-1467807304-14678085011503513', 1, 0, '', NULL, NULL, NULL),
(2131, '2016-07-06 19:53:03', NULL, NULL, 806, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 19:53:03', 'Staff-1467789963-14678059831974940', 1, 1, 'SR', NULL, NULL, NULL),
(2132, '2016-07-06 20:35:38', NULL, NULL, 806, 0, 181, '116', 'Open Food ', 'pepper pork', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 20:35:38', 'admin-1467807304-14678085384513349', 1, 0, '', NULL, NULL, NULL),
(2133, '2016-07-06 19:52:10', NULL, NULL, 806, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 19:52:10', 'Staff-1467789963-14678059301722391', 1, 1, 'SR', NULL, NULL, NULL),
(2134, '2016-07-06 19:29:01', NULL, NULL, 805, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 19:29:01', 'Staff-1467789963-14678045413271447', 1, 1, 'SR', NULL, NULL, NULL),
(2135, '2016-07-06 19:29:01', NULL, NULL, 805, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 19:29:01', 'Staff-1467789963-14678045413271447', 1, 1, 'SR', NULL, NULL, NULL),
(2136, '2016-07-06 19:21:15', NULL, NULL, 804, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 19:21:15', 'Staff-1467789963-14678040751621498', 1, 0, '', 1, NULL, NULL),
(2137, '2016-07-06 12:19:24', NULL, NULL, 776, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 12:19:24', 'admin-1467764339-14677787639381977', 1, 1, 'SR', NULL, NULL, NULL),
(2138, '2016-07-06 12:19:24', NULL, NULL, 776, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 12:19:24', 'admin-1467764339-14677787639381977', 1, 1, 'SR', NULL, NULL, NULL),
(2139, '2016-07-06 12:19:33', NULL, NULL, 776, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 12:19:33', 'admin-1467764339-14677787728816992', 1, 0, '', NULL, NULL, NULL),
(2140, '2016-07-06 12:41:27', NULL, NULL, 776, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 12:41:27', 'admin-1467764339-14677800876552759', 1, 1, 'SR', NULL, NULL, NULL),
(2141, '2016-07-06 12:41:27', NULL, NULL, 776, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 12:41:27', 'admin-1467764339-14677800876552759', 1, 1, 'SR', NULL, NULL, NULL),
(2142, '2016-07-06 12:41:27', NULL, NULL, 776, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 12:41:27', 'admin-1467764339-14677800876552759', 1, 1, 'SR', NULL, NULL, NULL),
(2143, '2016-07-06 12:43:03', NULL, NULL, 776, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 12:43:03', 'admin-1467764339-14677801837358516', 1, 1, 'SR', NULL, NULL, NULL),
(2144, '2016-07-06 12:43:03', NULL, NULL, 776, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 12:43:03', 'admin-1467764339-14677801837358516', 1, 1, 'SR', NULL, NULL, NULL),
(2145, '2016-07-06 12:43:03', NULL, NULL, 776, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 12:43:04', 'admin-1467764339-14677801837358516', 1, 0, '', NULL, NULL, NULL),
(2146, '2016-07-06 12:44:40', NULL, NULL, 777, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 12:44:40', 'admin-1467764339-14677802803427378', 1, 1, 'SR', NULL, NULL, NULL),
(2147, '2016-07-06 12:44:40', NULL, NULL, 777, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 12:44:40', 'admin-1467764339-14677802803427378', 1, 0, '', NULL, NULL, NULL),
(2148, '2016-07-06 12:45:11', NULL, NULL, 776, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 12:45:11', 'admin-1467764339-14677803112063691', 1, 1, 'SR', NULL, NULL, NULL),
(2149, '2016-07-06 12:53:37', NULL, NULL, 776, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 12:53:37', 'admin-1467764339-1467780817110160', 1, 0, '', NULL, NULL, NULL),
(2150, '2016-07-06 13:01:30', NULL, NULL, 778, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 13:01:30', 'admin-1467764339-14677812899449891', 1, 0, '', NULL, NULL, NULL),
(2151, '2016-07-06 13:01:30', NULL, NULL, 778, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 13:01:30', 'admin-1467764339-14677812899449891', 1, 1, 'SR', NULL, NULL, NULL),
(2152, '2016-07-06 13:01:30', NULL, NULL, 778, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 13:01:30', 'admin-1467764339-14677812899449891', 1, 1, 'SR', NULL, NULL, NULL),
(2153, '2016-07-06 13:01:30', NULL, NULL, 778, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 13:01:30', 'admin-1467764339-14677812899449891', 1, 1, 'SR', NULL, NULL, NULL),
(2154, '2016-07-06 13:01:30', NULL, NULL, 778, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 13:01:30', 'admin-1467764339-14677812899449891', 1, 1, 'SR', NULL, NULL, NULL),
(2155, '2016-07-06 13:01:30', NULL, NULL, 778, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 13:01:30', 'admin-1467764339-14677812899449891', 1, 0, '', NULL, NULL, NULL),
(2156, '2016-07-06 13:02:29', NULL, NULL, 779, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 13:02:29', 'admin-1467764339-14677813496231569', 1, 1, 'SR', NULL, NULL, NULL),
(2157, '2016-07-06 13:02:29', NULL, NULL, 779, 0, 39, '39', 'Mango Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 13:02:29', 'admin-1467764339-14677813496231569', 1, 1, 'SR', NULL, NULL, NULL),
(2158, '2016-07-06 13:05:48', NULL, NULL, 781, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 13:05:48', 'admin-1467764339-1467781547981543', 1, 1, 'SR', NULL, NULL, NULL),
(2159, '2016-07-06 13:51:22', NULL, NULL, 783, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 13:51:22', 'admin-1467764339-14677842817974652', 1, 0, '', NULL, NULL, NULL),
(2160, '2016-07-06 13:06:50', NULL, NULL, 777, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 13:06:50', 'admin-1467764339-14677816105242673', 1, 1, 'SR', NULL, NULL, NULL),
(2161, '2016-07-06 13:06:50', NULL, NULL, 777, 0, 195, '130', 'Cucumber Lime Soda BOFO', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 13:06:50', 'admin-1467764339-14677816105242673', 1, 0, '', NULL, NULL, NULL),
(2162, '2016-07-06 13:18:49', NULL, NULL, 782, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 13:18:49', 'admin-1467764339-1467782329648458', 1, 0, '', NULL, NULL, NULL),
(2163, '2016-07-06 13:18:49', NULL, NULL, 782, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 13:18:49', 'admin-1467764339-1467782329648458', 1, 1, 'SR', NULL, NULL, NULL),
(2164, '2016-07-06 13:18:49', NULL, NULL, 782, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 13:18:49', 'admin-1467764339-1467782329648458', 1, 0, '', NULL, NULL, NULL),
(2165, '2016-07-06 13:18:49', NULL, NULL, 782, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 13:18:49', 'admin-1467764339-1467782329648458', 1, 1, 'SR', NULL, NULL, NULL),
(2166, '2016-07-06 13:18:49', NULL, NULL, 782, 0, 195, '130', 'Cucumber Lime Soda BOFO', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 13:18:49', 'admin-1467764339-1467782329648458', 1, 0, '', NULL, NULL, NULL),
(2167, '2016-07-06 13:30:40', NULL, NULL, 777, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 13:30:40', 'admin-1467764339-1467783040415759', 1, 1, 'SR', NULL, NULL, NULL),
(2168, '2016-07-06 13:30:40', NULL, NULL, 777, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 13:30:40', 'admin-1467764339-1467783040415759', 1, 0, '', NULL, NULL, NULL),
(2169, '2016-07-06 13:51:22', NULL, NULL, 783, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 13:51:22', 'admin-1467764339-14677842817974652', 1, 0, '', NULL, NULL, NULL),
(2170, '2016-07-06 13:51:22', NULL, NULL, 783, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 13:51:22', 'admin-1467764339-14677842817974652', 1, 1, 'SR', NULL, NULL, NULL),
(2171, '2016-07-06 13:59:10', NULL, NULL, 784, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 13:59:10', 'Staff-1467784297-14677847505316048', 1, 1, 'SR', NULL, NULL, NULL),
(2172, '2016-07-06 18:45:45', NULL, NULL, 801, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 18:45:45', 'Staff-1467789963-1467801945102485', 1, 1, 'SR', NULL, NULL, NULL),
(2173, '2016-07-06 18:11:40', NULL, NULL, 800, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 18:11:40', 'Staff-1467789963-1467799900419863', 1, 1, 'SR', 1, NULL, NULL),
(2174, '2016-07-06 18:19:12', NULL, NULL, 799, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 18:19:12', 'Staff-1467789963-14678003522654673', 1, 1, 'SR', NULL, NULL, NULL),
(2175, '2016-07-06 18:45:45', NULL, NULL, 801, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 18:45:45', 'Staff-1467789963-1467801945102485', 1, 0, '', NULL, NULL, NULL),
(2176, '2016-07-06 17:31:21', NULL, NULL, 798, 0, 195, '130', 'Cucumber Lime Soda BOFO', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 17:31:21', 'Staff-1467789963-14677974817834079', 1, 0, '', 1, NULL, NULL),
(2177, '2016-07-06 17:46:15', NULL, NULL, 799, NULL, 65, '65', 'Pineapple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 17:46:15', 'Staff-1467789963-14677983757821287', 1, 1, 'SR', NULL, NULL, NULL),
(2178, '2016-07-06 17:46:15', NULL, NULL, 799, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 17:46:15', 'Staff-1467789963-14677983757821287', 1, 1, 'SR', NULL, NULL, NULL),
(2179, '2016-07-06 17:46:15', NULL, NULL, 799, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 17:46:15', 'Staff-1467789963-14677983757821287', 1, 0, '', NULL, NULL, NULL),
(2180, '2016-07-06 17:46:15', NULL, NULL, 799, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 17:46:15', 'Staff-1467789963-14677983757821287', 1, 1, 'SR', NULL, NULL, NULL),
(2181, '2016-07-06 18:09:02', NULL, NULL, 799, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 18:09:02', 'Staff-1467789963-14677997423003130', 1, 0, '', NULL, NULL, NULL),
(2182, '2016-07-06 18:45:45', NULL, NULL, 801, 0, 195, '130', 'Cucumber Lime Soda BOFO', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 18:45:45', 'Staff-1467789963-1467801945102485', 1, 0, '', NULL, NULL, NULL),
(2183, '2016-07-06 16:27:55', NULL, NULL, 795, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 16:27:55', 'Staff-1467789963-14677936757189342', 1, 0, '', NULL, NULL, NULL),
(2184, '2016-07-06 16:28:36', NULL, NULL, 796, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 16:28:36', 'Staff-1467789963-1467793716603649', 1, 0, '', NULL, NULL, NULL),
(2185, '2016-07-06 16:29:26', NULL, NULL, 796, 0, 181, '116', 'Open Food ', 'take away', 'Meals', 'Perfect Meals', 1, 0.50, 0.5000, 0.0000, 0.50, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 16:29:26', 'Staff-1467789963-14677937666757335', 1, 0, '', NULL, NULL, NULL),
(2186, '2016-07-06 17:06:02', NULL, NULL, 797, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 17:06:02', 'Staff-1467789963-14677959624543911', 1, 1, 'SR', NULL, NULL, NULL),
(2187, '2016-07-06 17:06:02', NULL, NULL, 797, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 17:06:02', 'Staff-1467789963-14677959624543911', 1, 1, 'SR', NULL, NULL, NULL),
(2188, '2016-07-06 17:06:02', NULL, NULL, 797, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 17:06:02', 'Staff-1467789963-14677959624543911', 1, 0, '', NULL, NULL, NULL),
(2189, '2016-07-06 17:31:21', NULL, NULL, 798, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 17:31:21', 'Staff-1467789963-14677974817834079', 1, 0, '', 1, NULL, NULL),
(2190, '2016-07-06 17:31:21', NULL, NULL, 798, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 17:31:21', 'Staff-1467789963-14677974817834079', 1, 0, '', 1, NULL, NULL),
(2191, '2016-07-06 16:27:55', NULL, NULL, 795, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 16:27:55', 'Staff-1467789963-14677936757189342', 1, 0, '', NULL, NULL, NULL),
(2192, '2016-07-06 16:27:55', NULL, NULL, 795, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 16:27:55', 'Staff-1467789963-14677936757189342', 1, 1, 'SR', NULL, NULL, NULL),
(2193, '2016-07-06 16:27:55', NULL, NULL, 795, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 16:27:55', 'Staff-1467789963-14677936757189342', 1, 1, 'SR', NULL, NULL, NULL),
(2194, '2016-07-06 16:04:43', NULL, NULL, 794, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 16:04:43', 'Staff-1467789963-14677922828658577', 1, 1, 'SR', NULL, NULL, NULL),
(2195, '2016-07-06 16:04:06', NULL, NULL, 793, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 16:04:06', 'Staff-1467789963-14677922465652442', 1, 1, 'SR', NULL, NULL, NULL),
(2196, '2016-07-06 15:48:52', NULL, NULL, 792, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 15:48:52', 'Staff-1467789963-14677913326506016', 1, 1, 'SR', 1, NULL, NULL),
(2197, '2016-07-06 15:31:08', NULL, NULL, 791, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 15:31:08', 'Staff-1467789963-14677902686218415', 1, 0, '', NULL, NULL, NULL),
(2198, '2016-07-06 15:31:08', NULL, NULL, 791, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 15:31:08', 'Staff-1467789963-14677902686218415', 1, 0, '', NULL, NULL, NULL),
(2199, '2016-07-06 15:31:08', NULL, NULL, 791, 0, 195, '130', 'Cucumber Lime Soda BOFO', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 15:31:08', 'Staff-1467789963-14677902686218415', 1, 0, '', NULL, NULL, NULL),
(2200, '2016-07-06 15:27:56', NULL, NULL, 790, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 15:27:56', 'Staff-1467789963-14677900759169488', 1, 1, 'SR', NULL, NULL, NULL),
(2201, '2016-07-06 15:27:04', NULL, NULL, 789, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 15:27:04', 'Staff-1467789963-146779002418368', 1, 1, 'SR', NULL, NULL, NULL),
(2202, '2016-07-06 15:27:04', NULL, NULL, 789, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 15:27:04', 'Staff-1467789963-146779002418368', 1, 1, 'SR', NULL, NULL, NULL),
(2203, '2016-07-06 14:01:42', NULL, NULL, 785, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 14:01:42', 'Staff-1467784297-14677849026863457', 1, 0, '', NULL, NULL, NULL),
(2204, '2016-07-06 14:01:42', NULL, NULL, 785, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 14:01:42', 'Staff-1467784297-14677849026863457', 1, 0, '', NULL, NULL, NULL),
(2205, '2016-07-06 19:53:03', NULL, NULL, 806, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 19:53:03', 'Staff-1467789963-14678059831974940', 1, 0, '', NULL, NULL, NULL),
(2206, '2016-07-06 15:26:30', NULL, NULL, 788, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 15:26:30', 'Staff-1467789963-14677899900177061', 1, 1, 'SR', NULL, NULL, NULL),
(2207, '2016-07-06 15:02:47', NULL, NULL, 787, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 15:02:47', 'Staff-1467784297-14677885676089573', 1, 1, 'SR', NULL, NULL, NULL),
(2208, '2016-07-06 15:03:11', NULL, NULL, 787, 0, 195, '130', 'Cucumber Lime Soda BOFO', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 15:03:11', 'Staff-1467784297-14677885912162731', 1, 0, '', NULL, NULL, NULL),
(2209, '2016-07-06 13:59:10', NULL, NULL, 784, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 13:59:10', 'Staff-1467784297-14677847505316048', 1, 1, 'SR', NULL, NULL, NULL),
(2210, '2016-07-06 13:59:10', NULL, NULL, 784, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 13:59:10', 'Staff-1467784297-14677847505316048', 1, 0, '', NULL, NULL, NULL),
(2211, '2016-07-06 14:01:42', NULL, NULL, 785, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'Staff', '2016-07-06 14:01:42', 'Staff-1467784297-14677849026863457', 1, 0, '', NULL, NULL, NULL),
(2212, '2016-07-06 12:41:27', NULL, NULL, 776, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 12:41:27', 'admin-1467764339-14677800876552759', 1, 0, '', NULL, NULL, NULL),
(2213, '2016-07-06 12:19:04', NULL, NULL, 776, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 12:19:04', 'admin-1467764339-14677787443479043', 1, 0, '', NULL, NULL, NULL),
(2214, '2016-07-06 09:58:00', NULL, NULL, 770, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 09:58:00', 'admin-1467764339-14677702799778599', 1, 1, 'SR', NULL, NULL, NULL),
(2215, '2016-07-06 10:36:57', NULL, NULL, 771, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 10:36:57', 'admin-1467764339-14677726172977360', 1, 0, '', NULL, NULL, NULL),
(2216, '2016-07-06 10:36:57', NULL, NULL, 771, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 10:36:57', 'admin-1467764339-14677726172977360', 1, 1, 'SR', NULL, NULL, NULL),
(2217, '2016-07-06 11:03:06', NULL, NULL, 772, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 11:03:06', 'admin-1467764339-14677741862635538', 1, 0, '', NULL, NULL, NULL),
(2218, '2016-07-06 11:03:06', NULL, NULL, 772, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 11:03:06', 'admin-1467764339-14677741862635538', 1, 0, '', NULL, NULL, NULL),
(2219, '2016-07-06 11:03:06', NULL, NULL, 772, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 11:03:06', 'admin-1467764339-14677741862635538', 1, 1, 'SR', NULL, NULL, NULL),
(2220, '2016-07-06 11:03:06', NULL, NULL, 772, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 11:03:06', 'admin-1467764339-14677741862635538', 1, 1, 'SR', NULL, NULL, NULL),
(2221, '2016-07-06 11:20:12', NULL, NULL, 773, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 11:20:12', 'admin-1467764339-1467775211920847', 1, 0, '', NULL, NULL, NULL),
(2222, '2016-07-06 11:20:12', NULL, NULL, 773, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 11:20:12', 'admin-1467764339-1467775211920847', 1, 0, '', NULL, NULL, NULL),
(2223, '2016-07-06 11:21:23', NULL, NULL, 773, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 11:21:23', 'admin-1467764339-14677752829096549', 1, 0, '', NULL, NULL, NULL),
(2224, '2016-07-06 11:22:06', NULL, NULL, 773, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 11:22:06', 'admin-1467764339-14677753262814953', 1, 1, 'SR', NULL, NULL, NULL),
(2225, '2016-07-06 11:21:23', NULL, NULL, 773, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 11:21:23', 'admin-1467764339-14677752829096549', 1, 1, 'SR', NULL, NULL, NULL),
(2226, '2016-07-06 11:21:23', NULL, NULL, 773, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 11:21:23', 'admin-1467764339-14677752829096549', 1, 1, 'SR', NULL, NULL, NULL),
(2227, '2016-07-06 12:06:27', NULL, NULL, 775, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 12:06:27', 'admin-1467764339-146777798719295', 1, 0, '', NULL, NULL, NULL),
(2228, '2016-07-06 12:06:27', NULL, NULL, 775, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 12:06:27', 'admin-1467764339-146777798719295', 1, 0, '', NULL, NULL, NULL),
(2229, '2016-07-06 12:06:27', NULL, NULL, 775, 0, 195, '130', 'Cucumber Lime Soda BOFO', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 12:06:27', 'admin-1467764339-146777798719295', 1, 0, '', NULL, NULL, NULL),
(2230, '2016-07-06 12:19:04', NULL, NULL, 776, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 12:19:04', 'admin-1467764339-14677787443479043', 1, 0, '', NULL, NULL, NULL),
(2231, '2016-07-06 12:19:04', NULL, NULL, 776, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 12:19:04', 'admin-1467764339-14677787443479043', 1, 1, 'SR', NULL, NULL, NULL),
(2232, '2016-07-06 09:57:20', NULL, NULL, 770, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 09:57:20', 'admin-1467764339-14677702399967818', 1, 0, '', NULL, NULL, NULL),
(2233, '2016-07-06 09:57:20', NULL, NULL, 770, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 09:57:20', 'admin-1467764339-14677702399967818', 1, 0, '', NULL, NULL, NULL),
(2234, '2016-07-06 09:26:38', NULL, NULL, 769, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 09:26:38', 'admin-1467764339-14677683985639627', 1, 0, '', NULL, NULL, NULL),
(2235, '2016-07-06 09:26:38', NULL, NULL, 769, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 09:26:38', 'admin-1467764339-14677683985639627', 1, 1, 'SR', NULL, NULL, NULL),
(2236, '2016-07-06 09:58:00', NULL, NULL, 770, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 09:58:00', 'admin-1467764339-14677702799778599', 1, 1, 'SR', NULL, NULL, NULL),
(2237, '2016-07-06 09:26:47', NULL, NULL, 769, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 09:26:47', 'admin-1467764339-14677684068976669', 1, 1, 'SR', NULL, NULL, NULL),
(2238, '2016-07-06 09:26:38', NULL, NULL, 769, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467812168', 'admin', '2016-07-06 09:26:38', 'admin-1467764339-14677683985639627', 1, 0, '', NULL, NULL, NULL),
(2239, '2016-07-07 15:52:25', NULL, NULL, 849, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 15:52:25', 'admin-1467874067-14678779453291693', 1, 1, 'SR', 1, NULL, NULL),
(2240, '2016-07-07 15:33:42', NULL, NULL, 847, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 15:33:42', 'admin-1467874067-146787682232936', 1, 1, 'SR', NULL, NULL, NULL),
(2241, '2016-07-07 15:33:42', NULL, NULL, 847, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 15:33:42', 'admin-1467874067-146787682232936', 1, 1, 'SR', NULL, NULL, NULL),
(2242, '2016-07-07 14:46:25', NULL, NULL, 844, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:46:25', 'admin-1467870932-1467873985353578', 1, 1, 'SR', NULL, NULL, NULL),
(2243, '2016-07-07 14:46:25', NULL, NULL, 844, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:46:25', 'admin-1467870932-1467873985353578', 1, 1, 'SR', NULL, NULL, NULL),
(2244, '2016-07-07 14:46:58', NULL, NULL, 845, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:46:58', 'admin-1467870932-14678740181807626', 1, 1, 'SR', NULL, NULL, NULL),
(2245, '2016-07-07 14:46:58', NULL, NULL, 845, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:46:58', 'admin-1467870932-14678740181807626', 1, 1, 'SR', NULL, NULL, NULL),
(2246, '2016-07-07 14:46:58', NULL, NULL, 845, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:46:58', 'admin-1467870932-14678740181807626', 1, 1, 'SR', NULL, NULL, NULL),
(2247, '2016-07-07 14:47:04', NULL, NULL, 844, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:47:04', 'admin-1467870932-14678740241753475', 1, 0, '', NULL, NULL, NULL),
(2248, '2016-07-07 14:47:35', NULL, NULL, 845, 0, 75, '75', 'Aglio Olio ', 'Chicken', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:47:35', 'admin-1467870932-1467874055399717', 1, 0, '', NULL, NULL, NULL),
(2249, '2016-07-07 14:48:27', NULL, NULL, 844, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:48:27', 'admin-1467874067-14678741077387223', 1, 0, '', NULL, NULL, NULL),
(2250, '2016-07-07 14:48:27', NULL, NULL, 844, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:48:27', 'admin-1467874067-14678741077387223', 1, 0, '', NULL, NULL, NULL),
(2251, '2016-07-07 15:22:46', NULL, NULL, 846, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 15:22:46', 'admin-1467874067-14678761666886124', 1, 0, '', NULL, NULL, NULL),
(2252, '2016-07-07 15:22:46', NULL, NULL, 846, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 15:22:46', 'admin-1467874067-14678761666886124', 1, 0, '', NULL, NULL, NULL),
(2253, '2016-07-07 15:33:15', NULL, NULL, 847, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 15:33:15', 'admin-1467874067-14678767953616897', 1, 1, 'SR', NULL, NULL, NULL),
(2254, '2016-07-07 15:33:42', NULL, NULL, 847, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 15:33:42', 'admin-1467874067-146787682232936', 1, 0, '', NULL, NULL, NULL),
(2255, '2016-07-07 15:38:17', NULL, NULL, 848, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 15:38:17', 'admin-1467874067-14678770975205063', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(2256, '2016-07-07 15:38:17', NULL, NULL, 848, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 15:38:17', 'admin-1467874067-14678770975205063', 1, 1, 'SR', NULL, NULL, NULL),
(2257, '2016-07-07 15:38:17', NULL, NULL, 848, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 15:38:17', 'admin-1467874067-14678770975205063', 1, 1, 'SR', NULL, NULL, NULL),
(2258, '2016-07-07 15:38:17', NULL, NULL, 848, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 15:38:17', 'admin-1467874067-14678770975205063', 1, 1, 'SR', NULL, NULL, NULL),
(2259, '2016-07-07 15:38:17', NULL, NULL, 848, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 15:38:17', 'admin-1467874067-14678770975205063', 1, 0, '', NULL, NULL, NULL),
(2260, '2016-07-07 12:58:42', NULL, NULL, 827, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 12:58:42', 'admin-1467865379-14678675222466939', 1, 1, 'SR', NULL, NULL, NULL),
(2261, '2016-07-07 12:58:42', NULL, NULL, 827, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 12:58:42', 'admin-1467865379-14678675222466939', 1, 1, 'SR', NULL, NULL, NULL),
(2262, '2016-07-07 13:02:17', NULL, NULL, 828, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:02:17', 'admin-1467865379-1467867737100396', 1, 0, '', NULL, NULL, NULL),
(2263, '2016-07-07 13:02:17', NULL, NULL, 828, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:02:17', 'admin-1467865379-1467867737100396', 1, 0, '', NULL, NULL, NULL),
(2264, '2016-07-07 11:20:27', NULL, NULL, 816, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 11:20:27', 'Staff-1467860400-14678616269627923', 1, 1, 'SR', NULL, NULL, NULL),
(2265, '2016-07-07 11:22:57', NULL, NULL, 817, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 11:22:57', 'Staff-1467860400-14678617770023475', 1, 1, 'SR', NULL, NULL, NULL),
(2266, '2016-07-07 11:22:57', NULL, NULL, 817, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 11:22:57', 'Staff-1467860400-14678617770023475', 1, 1, 'SR', NULL, NULL, NULL),
(2267, '2016-07-07 11:36:51', NULL, NULL, 818, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 11:36:51', 'Staff-1467862578-14678626113179647', 1, 0, '', NULL, NULL, NULL),
(2268, '2016-07-07 11:36:51', NULL, NULL, 818, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 11:36:51', 'Staff-1467862578-14678626113179647', 1, 1, 'SR', NULL, NULL, NULL),
(2269, '2016-07-07 11:36:51', NULL, NULL, 818, 0, 39, '39', 'Mango Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 11:36:51', 'Staff-1467862578-14678626113179647', 1, 1, 'SR', NULL, NULL, NULL),
(2270, '2016-07-07 11:43:36', NULL, NULL, 819, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 11:43:36', 'Staff-1467862578-14678630166553775', 1, 0, '', 1, NULL, NULL),
(2271, '2016-07-07 11:43:36', NULL, NULL, 819, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 11:43:36', 'Staff-1467862578-14678630166553775', 1, 1, 'SR', 1, NULL, NULL),
(2272, '2016-07-07 11:43:36', NULL, NULL, 819, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 11:43:36', 'Staff-1467862578-14678630166553775', 1, 1, 'SR', 1, NULL, NULL),
(2273, '2016-07-07 11:52:45', NULL, NULL, 820, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 11:52:45', 'Staff-1467862578-14678635651682540', 1, 1, 'SR', NULL, NULL, NULL),
(2274, '2016-07-07 11:52:45', NULL, NULL, 820, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 11:52:45', 'Staff-1467862578-14678635651682540', 1, 1, 'SR', NULL, NULL, NULL),
(2275, '2016-06-19 18:37:20', NULL, NULL, 0, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'Staff', '2016-06-19 18:37:20', 'Staff-1466329881-14663326402605022', 1, 1, 'SR', NULL, NULL, NULL),
(2276, '2016-06-19 18:37:20', NULL, NULL, 0, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'Staff', '2016-06-19 18:37:20', 'Staff-1466329881-14663326402605022', 1, 1, 'SR', NULL, NULL, NULL),
(2277, '2016-07-07 14:28:34', NULL, NULL, 842, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:28:34', 'admin-1467870932-14678729142219710', 1, 1, 'SR', NULL, NULL, NULL),
(2278, '2016-07-07 14:35:13', NULL, NULL, 843, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:35:13', 'admin-1467870932-14678733137346595', 1, 1, 'SR', NULL, NULL, NULL),
(2279, '2016-07-07 14:35:57', NULL, NULL, 838, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:35:57', 'admin-1467870932-14678733574592941', 1, 1, 'SR', NULL, NULL, NULL),
(2280, '2016-07-07 14:35:57', NULL, NULL, 838, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:35:57', 'admin-1467870932-14678733574592941', 1, 1, 'SR', NULL, NULL, NULL),
(2281, '2016-07-07 14:35:57', NULL, NULL, 838, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:35:57', 'admin-1467870932-14678733574592941', 1, 0, '', NULL, NULL, NULL),
(2282, '2016-07-07 14:35:57', NULL, NULL, 838, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:35:57', 'admin-1467870932-14678733574592941', 1, 0, '', NULL, NULL, NULL),
(2283, '2016-07-07 14:46:25', NULL, NULL, 844, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:46:25', 'admin-1467870932-1467873985353578', 1, 0, '', NULL, NULL, NULL),
(2284, '2016-07-07 14:46:25', NULL, NULL, 844, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:46:25', 'admin-1467870932-1467873985353578', 1, 0, '', NULL, NULL, NULL),
(2285, '2016-07-07 14:28:22', NULL, NULL, 842, NULL, 84, '84', 'Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:28:22', 'admin-1467870932-14678729024989889', 1, 1, 'SR', NULL, NULL, NULL),
(2286, '2016-07-07 14:24:52', NULL, NULL, 841, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:24:52', 'admin-1467870932-14678726927267559', 1, 1, 'SR', NULL, NULL, NULL),
(2287, '2016-07-07 14:24:52', NULL, NULL, 841, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:24:52', 'admin-1467870932-14678726927267559', 1, 0, '', NULL, NULL, NULL),
(2288, '2016-07-07 14:24:52', NULL, NULL, 841, 0, 76, '76', 'Pesto Pasta', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:24:52', 'admin-1467870932-14678726927267559', 1, 1, 'SR', NULL, NULL, NULL),
(2289, '2016-07-07 14:11:32', NULL, NULL, 840, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:11:32', 'admin-1467870932-14678718921705934', 1, 1, 'SR', 1, NULL, NULL),
(2290, '2016-07-07 14:06:13', NULL, NULL, 839, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:06:13', 'admin-1467870932-1467871573427452', 1, 1, 'SR', NULL, NULL, NULL),
(2291, '2016-07-07 14:06:13', NULL, NULL, 839, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 14:06:13', 'admin-1467870932-1467871573427452', 1, 1, 'SR', NULL, NULL, NULL),
(2292, '2016-07-07 13:58:55', NULL, NULL, 835, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:58:55', 'admin-1467870932-14678711350499991', 1, 0, '', NULL, NULL, NULL),
(2293, '2016-07-07 13:58:55', NULL, NULL, 835, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:58:55', 'admin-1467870932-14678711350499991', 1, 1, 'SR', NULL, NULL, NULL),
(2294, '2016-07-07 13:55:12', NULL, NULL, 836, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:55:12', 'admin-1467865379-14678709124137286', 1, 0, '', NULL, NULL, NULL),
(2295, '2016-07-07 13:54:36', NULL, NULL, 837, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:54:36', 'admin-1467865379-14678708763743088', 1, 1, 'SR', 1, NULL, NULL),
(2296, '2016-07-07 13:54:30', NULL, NULL, 836, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:54:30', 'admin-1467865379-14678708701511961', 1, 1, 'SR', NULL, NULL, NULL),
(2297, '2016-07-07 13:53:35', NULL, NULL, 836, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:53:35', 'admin-1467865379-14678708151098867', 1, 0, '', NULL, NULL, NULL),
(2298, '2016-07-07 13:53:02', NULL, NULL, 835, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:53:02', 'admin-1467865379-1467870782185749', 1, 1, 'SR', NULL, NULL, NULL),
(2299, '2016-07-07 13:58:04', NULL, NULL, 838, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:58:04', 'admin-1467870932-14678710844288812', 1, 1, 'SR', NULL, NULL, NULL),
(2300, '2016-07-07 13:58:04', NULL, NULL, 838, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:58:04', 'admin-1467870932-14678710844288812', 1, 1, 'SR', NULL, NULL, NULL),
(2301, '2016-07-07 13:38:32', NULL, NULL, 834, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:38:32', 'admin-1467865379-14678699124175863', 1, 1, 'SR', NULL, NULL, NULL),
(2302, '2016-07-07 13:38:32', NULL, NULL, 834, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:38:32', 'admin-1467865379-14678699124175863', 1, 0, '', NULL, NULL, NULL),
(2303, '2016-07-07 13:38:32', NULL, NULL, 834, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:38:32', 'admin-1467865379-14678699124175863', 1, 1, 'SR', NULL, NULL, NULL),
(2304, '2016-07-07 13:38:32', NULL, NULL, 834, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:38:32', 'admin-1467865379-14678699124175863', 1, 1, 'SR', NULL, NULL, NULL),
(2305, '2016-07-07 13:38:32', NULL, NULL, 834, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:38:32', 'admin-1467865379-14678699124175863', 1, 1, 'SR', NULL, NULL, NULL),
(2306, '2016-07-07 13:38:32', NULL, NULL, 834, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:38:32', 'admin-1467865379-14678699124175863', 1, 0, '', NULL, NULL, NULL),
(2307, '2016-07-07 13:34:20', NULL, NULL, 833, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:34:20', 'admin-1467865379-14678696603663253', 1, 1, 'SR', NULL, NULL, NULL),
(2308, '2016-07-07 10:29:12', NULL, NULL, 814, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 10:29:12', 'admin-1467852793-1467858552283478', 1, 0, '', NULL, NULL, NULL),
(2309, '2016-07-07 13:34:20', NULL, NULL, 833, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:34:20', 'admin-1467865379-14678696603663253', 1, 1, 'SR', NULL, NULL, NULL),
(2310, '2016-07-07 13:34:20', NULL, NULL, 833, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:34:20', 'admin-1467865379-14678696603663253', 1, 1, 'SR', NULL, NULL, NULL),
(2311, '2016-07-07 13:27:56', NULL, NULL, 832, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:27:56', 'admin-1467865379-14678692762714579', 1, 0, '', NULL, NULL, NULL),
(2312, '2016-07-07 13:23:41', NULL, NULL, 831, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:23:41', 'admin-1467865379-1467869021304456', 1, 1, 'SR', NULL, NULL, NULL),
(2313, '2016-07-07 13:23:41', NULL, NULL, 831, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:23:41', 'admin-1467865379-1467869021304456', 1, 0, '', NULL, NULL, NULL),
(2314, '2016-07-07 13:22:44', NULL, NULL, 830, 0, 38, '38', 'Kiwi Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:22:44', 'admin-1467865379-14678689641831637', 1, 1, 'SR', NULL, NULL, NULL),
(2315, '2016-07-07 13:22:38', NULL, NULL, 830, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:22:38', 'admin-1467865379-14678689586678587', 1, 1, 'SR', NULL, NULL, NULL),
(2316, '2016-07-07 13:20:32', NULL, NULL, 829, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:20:32', 'admin-1467865379-14678688326396256', 1, 1, 'SR', NULL, NULL, NULL),
(2317, '2016-07-07 13:20:32', NULL, NULL, 829, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:20:32', 'admin-1467865379-14678688326396256', 1, 1, 'SR', NULL, NULL, NULL),
(2318, '2016-07-07 13:02:17', NULL, NULL, 828, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:02:17', 'admin-1467865379-1467867737100396', 1, 0, '', NULL, NULL, NULL),
(2319, '2016-07-07 13:02:17', NULL, NULL, 828, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:02:17', 'admin-1467865379-1467867737100396', 1, 0, '', NULL, NULL, NULL),
(2320, '2016-06-27 15:26:37', NULL, NULL, 0, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 2, 14.00, 28.0000, 0.0000, 28.00, 1, '27', 1, '1467900626', 'admin', '2016-06-27 15:26:37', 'admin-1467003573-14670123971848269', 1, 1, 'SR', NULL, NULL, NULL),
(2321, '2016-06-27 15:26:37', NULL, NULL, 0, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-06-27 15:26:37', 'admin-1467003573-14670123971848269', 1, 0, '', NULL, NULL, NULL),
(2322, '2016-07-07 13:02:17', NULL, NULL, 828, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:02:17', 'admin-1467865379-1467867737100396', 1, 0, '', NULL, NULL, NULL),
(2323, '2016-07-07 12:58:17', NULL, NULL, 827, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 12:58:17', 'admin-1467865379-14678674974175633', 1, 0, '', NULL, NULL, NULL),
(2324, '2016-07-07 12:58:17', NULL, NULL, 827, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 12:58:17', 'admin-1467865379-14678674974175633', 1, 0, '', NULL, NULL, NULL),
(2325, '2016-07-07 12:58:17', NULL, NULL, 827, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 12:58:17', 'admin-1467865379-14678674974175633', 1, 1, 'SR', NULL, NULL, NULL),
(2326, '2016-07-07 12:58:42', NULL, NULL, 827, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 12:58:42', 'admin-1467865379-14678675222466939', 1, 1, 'SR', NULL, NULL, NULL),
(2327, '2016-07-07 12:22:34', NULL, NULL, 818, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 12:22:34', 'Staff-1467862578-14678653547266493', 1, 0, '', NULL, NULL, NULL),
(2328, '2016-07-07 12:24:10', NULL, NULL, 825, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 12:24:10', 'admin-1467865379-14678654501085517', 1, 1, 'SR', NULL, NULL, NULL),
(2329, '2016-07-07 12:24:10', NULL, NULL, 825, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 12:24:10', 'admin-1467865379-14678654501085517', 1, 1, 'SR', NULL, NULL, NULL),
(2330, '2016-07-07 12:24:10', NULL, NULL, 825, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 12:24:10', 'admin-1467865379-14678654501085517', 1, 0, '', NULL, NULL, NULL),
(2331, '2016-07-07 12:51:26', NULL, NULL, 826, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 12:51:26', 'admin-1467865379-14678670866984521', 1, 1, 'SR', NULL, NULL, NULL),
(2332, '2016-07-07 12:58:17', NULL, NULL, 827, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 12:58:17', 'admin-1467865379-14678674974175633', 1, 0, '', NULL, NULL, NULL),
(2333, '2016-07-07 12:58:17', NULL, NULL, 827, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 12:58:17', 'admin-1467865379-14678674974175633', 1, 0, '', NULL, NULL, NULL),
(2334, '2016-07-07 12:09:18', NULL, NULL, 821, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 12:09:18', 'Staff-1467862578-14678645586459023', 1, 1, 'SR', NULL, NULL, NULL),
(2335, '2016-07-07 12:21:11', NULL, NULL, 823, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 12:21:11', 'Staff-1467862578-14678652713058934', 1, 0, '', NULL, NULL, NULL),
(2336, '2016-07-07 12:21:11', NULL, NULL, 823, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 12:21:11', 'Staff-1467862578-14678652713058934', 1, 1, 'SR', NULL, NULL, NULL),
(2337, '2016-07-07 12:21:44', NULL, NULL, 824, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 12:21:44', 'Staff-1467862578-1467865304618179', 1, 0, '', NULL, NULL, NULL),
(2338, '2016-07-07 12:21:44', NULL, NULL, 824, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 12:21:44', 'Staff-1467862578-1467865304618179', 1, 1, 'SR', NULL, NULL, NULL),
(2339, '2016-07-07 12:36:02', NULL, NULL, 818, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 12:36:02', 'admin-1467865379-1467866162103244', 1, 1, 'SR', NULL, NULL, NULL),
(2340, '2016-07-07 12:36:02', NULL, NULL, 818, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 12:36:02', 'admin-1467865379-1467866162103244', 1, 1, 'SR', NULL, NULL, NULL),
(2341, '2016-07-07 12:09:18', NULL, NULL, 821, NULL, 84, '84', 'Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 12:09:18', 'Staff-1467862578-14678645586459023', 1, 1, 'SR', NULL, NULL, NULL),
(2342, '2016-07-07 12:09:18', NULL, NULL, 821, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 12:09:18', 'Staff-1467862578-14678645586459023', 1, 0, '', NULL, NULL, NULL),
(2343, '2016-07-07 12:09:18', NULL, NULL, 821, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 12:09:18', 'Staff-1467862578-14678645586459023', 1, 1, 'SR', NULL, NULL, NULL),
(2344, '2016-07-07 12:09:18', NULL, NULL, 821, 0, 83, '83', 'Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 12:09:18', 'Staff-1467862578-14678645586459023', 1, 1, 'SR', NULL, NULL, NULL),
(2345, '2016-07-07 12:09:18', NULL, NULL, 821, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 12:09:18', 'Staff-1467862578-14678645586459023', 1, 1, 'SR', NULL, NULL, NULL),
(2346, '2016-07-07 12:06:50', NULL, NULL, 821, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 12:06:50', 'Staff-1467862578-1467864410098133', 1, 1, 'SR', NULL, NULL, NULL),
(2347, '2016-07-07 12:06:50', NULL, NULL, 821, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 12:06:50', 'Staff-1467862578-1467864410098133', 1, 1, 'SR', NULL, NULL, NULL),
(2348, '2016-07-07 12:06:50', NULL, NULL, 821, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 12:06:50', 'Staff-1467862578-1467864410098133', 1, 0, '', NULL, NULL, NULL),
(2349, '2016-07-07 12:06:50', NULL, NULL, 821, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 12:06:50', 'Staff-1467862578-1467864410098133', 1, 0, '', NULL, NULL, NULL),
(2350, '2016-07-07 12:06:50', NULL, NULL, 821, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 12:06:50', 'Staff-1467862578-1467864410098133', 1, 0, '', NULL, NULL, NULL),
(2351, '2016-07-07 11:52:45', NULL, NULL, 820, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 11:52:45', 'Staff-1467862578-14678635651682540', 1, 1, 'SR', NULL, NULL, NULL),
(2352, '2016-07-07 11:20:10', NULL, NULL, 816, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 11:20:10', 'Staff-1467860400-1467861610420684', 1, 0, '', NULL, NULL, NULL),
(2353, '2016-07-07 11:20:27', NULL, NULL, 816, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 11:20:27', 'Staff-1467860400-14678616269627923', 1, 1, 'SR', NULL, NULL, NULL),
(2354, '2016-07-07 11:19:18', NULL, NULL, 816, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 11:19:18', 'Staff-1467860400-14678615587192145', 1, 0, '', NULL, NULL, NULL),
(2355, '2016-07-07 11:01:11', NULL, NULL, 815, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 11:01:11', 'Staff-1467860400-14678604710047831', 1, 1, 'SR', NULL, NULL, NULL),
(2356, '2016-07-07 11:19:18', NULL, NULL, 816, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 11:19:18', 'Staff-1467860400-14678615587192145', 1, 0, '', NULL, NULL, NULL),
(2357, '2016-06-10 20:07:41', NULL, NULL, 0, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467900626', 'Staff', '2016-06-10 20:07:41', 'Staff-1465547217-14655604615031549', 1, 1, 'SR', NULL, NULL, NULL),
(2358, '2016-07-07 11:20:27', NULL, NULL, 816, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 11:20:27', 'Staff-1467860400-14678616269627923', 1, 1, 'SR', NULL, NULL, NULL),
(2359, '2016-06-21 15:55:57', NULL, NULL, 0, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467900626', 'admin', '2016-06-21 15:55:57', 'admin-1466487575-14664957570078328', 1, 1, 'SR', NULL, NULL, NULL),
(2360, '2016-07-07 10:38:21', NULL, NULL, 815, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 10:38:21', 'admin-1467852793-14678591010452515', 1, 0, '', NULL, NULL, NULL),
(2361, '2016-07-07 11:01:11', NULL, NULL, 815, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 11:01:11', 'Staff-1467860400-14678604710047831', 1, 1, 'SR', NULL, NULL, NULL),
(2362, '2016-07-07 13:02:17', NULL, NULL, 828, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 13:02:17', 'admin-1467865379-1467867737100396', 1, 1, 'SR', NULL, NULL, NULL),
(2363, '2016-07-07 11:19:18', NULL, NULL, 816, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-07 11:19:18', 'Staff-1467860400-14678615587192145', 1, 0, '', NULL, NULL, NULL),
(2364, '2016-07-07 10:38:21', NULL, NULL, 815, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 10:38:21', 'admin-1467852793-14678591010452515', 1, 0, '', NULL, NULL, NULL),
(2365, '2016-06-24 14:47:40', NULL, NULL, 0, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467900626', 'admin', '2016-06-24 14:47:40', 'admin-1466744311-14667508607355973', 1, 1, 'SR', NULL, NULL, NULL),
(2366, '2016-06-24 14:47:40', NULL, NULL, 0, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467900626', 'admin', '2016-06-24 14:47:40', 'admin-1466744311-14667508607355973', 1, 1, 'SR', NULL, NULL, NULL),
(2367, '2016-07-07 10:29:12', NULL, NULL, 814, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 10:29:12', 'admin-1467852793-1467858552283478', 1, 1, 'SR', NULL, NULL, NULL),
(2368, '2016-07-07 10:29:12', NULL, NULL, 814, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 10:29:12', 'admin-1467852793-1467858552283478', 1, 1, 'SR', NULL, NULL, NULL),
(2369, '2016-07-07 09:23:29', NULL, NULL, 808, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 09:23:29', 'admin-1467852793-14678546091281219', 1, 1, 'SR', NULL, NULL, NULL),
(2370, '2016-07-07 09:23:29', NULL, NULL, 808, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 09:23:29', 'admin-1467852793-14678546091281219', 1, 1, 'SR', NULL, NULL, NULL),
(2371, '2016-07-07 09:44:28', NULL, NULL, 809, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 09:44:28', 'admin-1467852793-14678558687027045', 1, 1, 'SR', NULL, NULL, NULL),
(2372, '2016-07-07 09:55:53', NULL, NULL, 810, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 3, 20.00, 60.0000, 0.0000, 60.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 09:55:53', 'admin-1467852793-14678565528637150', 1, 0, '', NULL, NULL, NULL),
(2373, '2016-07-07 09:55:53', NULL, NULL, 810, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 09:55:53', 'admin-1467852793-14678565528637150', 1, 0, '', NULL, NULL, NULL),
(2374, '2016-07-07 09:55:53', NULL, NULL, 810, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 09:55:53', 'admin-1467852793-14678565528637150', 1, 0, '', NULL, NULL, NULL),
(2375, '2016-07-07 09:57:05', NULL, NULL, 810, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 09:57:05', 'admin-1467852793-1467856625079303', 1, 1, 'SR', NULL, NULL, NULL),
(2376, '2016-07-07 09:56:17', NULL, NULL, 810, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 09:56:17', 'admin-1467852793-14678565771493728', 1, 1, 'SR', NULL, NULL, NULL),
(2377, '2016-07-07 10:15:41', NULL, NULL, 810, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 10:15:41', 'admin-1467852793-14678577416799878', 1, 1, 'SR', NULL, NULL, NULL),
(2378, '2016-07-07 09:56:48', NULL, NULL, 810, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 09:56:48', 'admin-1467852793-14678566082465518', 1, 1, 'SR', NULL, NULL, NULL),
(2379, '2016-07-07 10:05:23', NULL, NULL, 811, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 10:05:23', 'admin-1467852793-14678571233623254', 1, 1, 'SR', NULL, NULL, NULL),
(2380, '2016-07-07 10:05:23', NULL, NULL, 811, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 10:05:23', 'admin-1467852793-14678571233623254', 1, 1, 'SR', NULL, NULL, NULL),
(2381, '2016-07-07 10:05:29', NULL, NULL, 811, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 10:05:29', 'admin-1467852793-14678571297472222', 1, 0, '', NULL, NULL, NULL),
(2382, '2016-07-07 10:05:29', NULL, NULL, 811, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 10:05:29', 'admin-1467852793-14678571297472222', 1, 0, '', NULL, NULL, NULL),
(2383, '2016-07-07 10:16:00', NULL, NULL, 812, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 10:16:00', 'admin-1467852793-146785776021863', 1, 0, '', NULL, NULL, NULL),
(2384, '2016-07-07 10:16:00', NULL, NULL, 812, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 10:16:00', 'admin-1467852793-146785776021863', 1, 0, '', NULL, NULL, NULL),
(2385, '2016-07-07 10:16:00', NULL, NULL, 812, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 10:16:00', 'admin-1467852793-146785776021863', 1, 0, '', NULL, NULL, NULL),
(2386, '2016-07-07 10:16:14', NULL, NULL, 812, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 10:16:14', 'admin-1467852793-14678577745177675', 1, 1, 'SR', NULL, NULL, NULL),
(2387, '2016-07-07 10:26:06', NULL, NULL, 813, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 10:26:06', 'admin-1467852793-14678583658479556', 1, 1, 'SR', NULL, NULL, NULL),
(2388, '2016-07-07 10:26:06', NULL, NULL, 813, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 10:26:06', 'admin-1467852793-14678583658479556', 1, 1, 'SR', NULL, NULL, NULL),
(2389, '2016-07-07 10:26:06', NULL, NULL, 813, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 10:26:06', 'admin-1467852793-14678583658479556', 1, 1, 'SR', NULL, NULL, NULL),
(2390, '2016-07-07 10:26:06', NULL, NULL, 813, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 10:26:06', 'admin-1467852793-14678583658479556', 1, 1, 'SR', NULL, NULL, NULL),
(2391, '2016-07-07 10:29:12', NULL, NULL, 814, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 10:29:12', 'admin-1467852793-1467858552283478', 1, 0, '', NULL, NULL, NULL),
(2392, '2016-07-01 09:28:26', NULL, NULL, 0, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467900626', 'Staff', '2016-07-01 09:28:26', 'Staff-1467333426-14673365065221668', 1, 1, 'SR', NULL, NULL, NULL),
(2393, '2016-07-07 09:23:29', NULL, NULL, 808, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 09:23:29', 'admin-1467852793-14678546091281219', 1, 0, '', NULL, NULL, NULL),
(2394, '2016-07-07 09:23:29', NULL, NULL, 808, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 09:23:29', 'admin-1467852793-14678546091281219', 1, 0, '', NULL, NULL, NULL),
(2395, '2016-07-07 17:59:54', NULL, NULL, 850, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 17:59:54', 'admin-1467884827-1467885594086778', 1, 0, '', NULL, NULL, NULL),
(2396, '2016-07-07 17:59:54', NULL, NULL, 850, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 17:59:54', 'admin-1467884827-1467885594086778', 1, 0, '', NULL, NULL, NULL),
(2397, '2016-07-07 18:00:16', NULL, NULL, 850, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 18:00:16', 'admin-1467884827-14678856164985131', 1, 1, 'SR', NULL, NULL, NULL),
(2398, '2016-07-07 18:00:16', NULL, NULL, 850, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 18:00:16', 'admin-1467884827-14678856164985131', 1, 1, 'SR', NULL, NULL, NULL),
(2399, '2016-07-07 18:04:16', NULL, NULL, 851, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 18:04:16', 'admin-1467884827-1467885855980141', 1, 1, 'SR', NULL, NULL, NULL),
(2400, '2016-07-07 18:04:16', NULL, NULL, 851, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 18:04:16', 'admin-1467884827-1467885855980141', 1, 0, '', NULL, NULL, NULL),
(2401, '2016-07-07 18:04:16', NULL, NULL, 851, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 18:04:16', 'admin-1467884827-1467885855980141', 1, 0, '', NULL, NULL, NULL),
(2402, '2016-07-07 18:04:16', NULL, NULL, 851, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 18:04:16', 'admin-1467884827-1467885855980141', 1, 1, 'SR', NULL, NULL, NULL),
(2403, '2016-07-07 18:04:49', NULL, NULL, 852, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 18:04:49', 'admin-1467884827-14678858889313476', 1, 1, 'SR', NULL, NULL, NULL),
(2404, '2016-07-07 18:24:44', NULL, NULL, 853, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 18:24:44', 'admin-1467885914-14678870843462361', 1, 1, 'SR', NULL, NULL, NULL),
(2405, '2016-07-07 18:24:44', NULL, NULL, 853, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 18:24:44', 'admin-1467885914-14678870843462361', 1, 0, '', NULL, NULL, NULL),
(2406, '2016-07-07 18:29:45', NULL, NULL, 854, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 18:29:45', 'admin-1467885914-14678873851284679', 1, 1, 'SR', NULL, NULL, NULL),
(2407, '2016-07-07 18:29:45', NULL, NULL, 854, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 18:29:45', 'admin-1467885914-14678873851284679', 1, 1, 'SR', NULL, NULL, NULL),
(2408, '2016-07-07 18:30:42', NULL, NULL, 854, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 18:30:42', 'admin-1467885914-14678874422365638', 1, 1, 'SR', NULL, NULL, NULL),
(2409, '2016-07-07 18:54:13', NULL, NULL, 855, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 18:54:13', 'admin-1467885914-14678888535046444', 1, 1, 'SR', NULL, NULL, NULL),
(2410, '2016-07-07 18:54:13', NULL, NULL, 855, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 18:54:13', 'admin-1467885914-14678888535046444', 1, 1, 'SR', NULL, NULL, NULL),
(2411, '2016-07-07 18:54:13', NULL, NULL, 855, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 18:54:13', 'admin-1467885914-14678888535046444', 1, 1, 'SR', NULL, NULL, NULL),
(2412, '2016-07-07 18:54:13', NULL, NULL, 855, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 18:54:13', 'admin-1467885914-14678888535046444', 1, 1, 'SR', NULL, NULL, NULL),
(2413, '2016-07-07 19:16:13', NULL, NULL, 855, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 19:16:13', 'admin-1467885914-14678901730516578', 1, 1, 'SR', NULL, NULL, NULL),
(2414, '2016-07-07 19:16:13', NULL, NULL, 855, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 19:16:13', 'admin-1467885914-14678901730516578', 1, 1, 'SR', NULL, NULL, NULL),
(2415, '2016-07-07 19:16:13', NULL, NULL, 855, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 19:16:13', 'admin-1467885914-14678901730516578', 1, 1, 'SR', NULL, NULL, NULL),
(2416, '2016-07-07 19:20:31', NULL, NULL, 856, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 19:20:31', 'admin-1467885914-14678904317649956', 1, 0, '', NULL, NULL, NULL),
(2417, '2016-07-07 19:20:31', NULL, NULL, 856, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 19:20:31', 'admin-1467885914-14678904317649956', 1, 0, '', NULL, NULL, NULL),
(2418, '2016-07-07 19:20:31', NULL, NULL, 856, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 19:20:31', 'admin-1467885914-14678904317649956', 1, 0, '', NULL, NULL, NULL),
(2419, '2016-07-07 19:20:31', NULL, NULL, 856, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 19:20:31', 'admin-1467885914-14678904317649956', 1, 0, '', NULL, NULL, NULL),
(2420, '2016-07-07 19:20:31', NULL, NULL, 856, 0, 200, '135', 'Dinner - Spicy Wings', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 19:20:31', 'admin-1467885914-14678904317649956', 1, 0, '', NULL, NULL, NULL),
(2421, '2016-07-07 19:20:31', NULL, NULL, 856, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 19:20:31', 'admin-1467885914-14678904317649956', 1, 0, '', NULL, NULL, NULL),
(2422, '2016-07-07 19:20:51', NULL, NULL, 856, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 19:20:51', 'admin-1467885914-14678904515642014', 1, 1, 'SR', NULL, NULL, NULL),
(2423, '2016-07-07 19:20:51', NULL, NULL, 856, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 19:20:51', 'admin-1467885914-14678904515642014', 1, 0, '', NULL, NULL, NULL),
(2424, '2016-07-07 19:39:13', NULL, NULL, 855, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 19:39:13', 'admin-1467885914-14678915532724782', 1, 0, '', NULL, NULL, NULL),
(2425, '2016-07-07 19:41:17', NULL, NULL, 855, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 19:41:17', 'admin-1467885914-14678916776666847', 1, 0, '', NULL, NULL, NULL),
(2426, '2016-07-07 19:41:17', NULL, NULL, 855, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 19:41:17', 'admin-1467885914-14678916776666847', 1, 0, '', NULL, NULL, NULL),
(2427, '2016-07-07 19:43:15', NULL, NULL, 855, 0, 181, '116', 'Open Food ', 'Wine Corkage', 'Meals', 'Perfect Meals', 1, 100.00, 100.0000, 0.0000, 100.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 19:43:15', 'admin-1467891774-14678917948725036', 1, 0, '', NULL, NULL, NULL),
(2428, '2016-07-07 19:54:45', NULL, NULL, 855, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 19:54:45', 'admin-1467891774-1467892485686932', 1, 1, 'SR', NULL, NULL, NULL),
(2429, '2016-07-07 19:54:45', NULL, NULL, 855, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 19:54:45', 'admin-1467891774-1467892485686932', 1, 1, 'SR', NULL, NULL, NULL),
(2430, '2016-07-07 19:54:45', NULL, NULL, 855, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 19:54:45', 'admin-1467891774-1467892485686932', 1, 1, 'SR', NULL, NULL, NULL),
(2431, '2016-07-07 19:59:51', NULL, NULL, 855, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 19:59:51', 'admin-1467891774-14678927915425156', 1, 0, '', NULL, NULL, NULL),
(2432, '2016-07-07 19:59:51', NULL, NULL, 855, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 19:59:51', 'admin-1467891774-14678927915425156', 1, 0, '', NULL, NULL, NULL),
(2433, '2016-07-07 20:24:09', NULL, NULL, 855, 0, 201, '136', 'Dinner -  Chili Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 20:24:09', 'admin-1467891774-1467894249413301', 1, 0, '', NULL, NULL, NULL),
(2434, '2016-07-07 20:24:09', NULL, NULL, 855, 0, 199, '134', 'Dinner - Marmite Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 20:24:09', 'admin-1467891774-1467894249413301', 1, 0, '', NULL, NULL, NULL),
(2435, '2016-07-07 20:24:09', NULL, NULL, 855, 0, 198, '133', 'Dinner - Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 20:24:09', 'admin-1467891774-1467894249413301', 1, 0, '', NULL, NULL, NULL),
(2436, '2016-07-07 20:24:09', NULL, NULL, 855, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 20:24:09', 'admin-1467891774-1467894249413301', 1, 0, '', NULL, NULL, NULL),
(2437, '2016-07-07 20:24:09', NULL, NULL, 855, 0, 197, '132', 'Dinner - Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 20:24:09', 'admin-1467891774-1467894249413301', 1, 0, '', NULL, NULL, NULL),
(2438, '2016-07-07 20:24:09', NULL, NULL, 855, 0, 200, '135', 'Dinner - Spicy Wings', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 20:24:09', 'admin-1467891774-1467894249413301', 1, 0, '', NULL, NULL, NULL),
(2439, '2016-07-07 20:28:19', NULL, NULL, 855, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 20:28:19', 'admin-1467891774-14678944995318878', 1, 0, '', NULL, NULL, NULL),
(2440, '2016-07-07 20:28:19', NULL, NULL, 855, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 20:28:19', 'admin-1467891774-14678944995318878', 1, 0, '', NULL, NULL, NULL),
(2441, '2016-07-07 20:28:19', NULL, NULL, 855, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 20:28:19', 'admin-1467891774-14678944995318878', 1, 0, '', NULL, NULL, NULL),
(2442, '2016-07-07 20:28:19', NULL, NULL, 855, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 20:28:19', 'admin-1467891774-14678944995318878', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(2443, '2016-07-07 20:28:19', NULL, NULL, 855, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 20:28:19', 'admin-1467891774-14678944995318878', 1, 0, '', NULL, NULL, NULL),
(2444, '2016-07-07 20:28:19', NULL, NULL, 855, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 20:28:19', 'admin-1467891774-14678944995318878', 1, 0, '', NULL, NULL, NULL),
(2445, '2016-07-07 20:28:19', NULL, NULL, 855, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 20:28:19', 'admin-1467891774-14678944995318878', 1, 0, '', NULL, NULL, NULL),
(2446, '2016-07-07 20:40:32', NULL, NULL, 857, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 20:40:32', 'admin-1467891774-14678952321416235', 1, 1, 'SR', NULL, NULL, NULL),
(2447, '2016-07-07 20:40:32', NULL, NULL, 857, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 20:40:32', 'admin-1467891774-14678952321416235', 1, 1, 'SR', NULL, NULL, NULL),
(2448, '2016-07-07 20:40:32', NULL, NULL, 857, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 20:40:32', 'admin-1467891774-14678952321416235', 1, 1, 'SR', NULL, NULL, NULL),
(2449, '2016-07-07 20:42:26', NULL, NULL, 855, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 20:42:26', 'admin-1467891774-14678953458707974', 1, 0, '', NULL, NULL, NULL),
(2450, '2016-07-07 21:24:34', NULL, NULL, 855, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 21:24:34', 'admin-1467891774-1467897874148235', 1, 0, '', NULL, NULL, NULL),
(2451, '2016-07-07 21:24:34', NULL, NULL, 855, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 21:24:34', 'admin-1467891774-1467897874148235', 1, 0, '', NULL, NULL, NULL),
(2452, '2016-07-07 21:24:34', NULL, NULL, 855, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 21:24:34', 'admin-1467891774-1467897874148235', 1, 0, '', NULL, NULL, NULL),
(2453, '2016-07-07 21:24:34', NULL, NULL, 855, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 21:24:34', 'admin-1467891774-1467897874148235', 1, 0, '', NULL, NULL, NULL),
(2454, '2016-07-07 21:24:34', NULL, NULL, 855, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 21:24:34', 'admin-1467891774-1467897874148235', 1, 0, '', NULL, NULL, NULL),
(2455, '2016-07-07 21:24:34', NULL, NULL, 855, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 21:24:34', 'admin-1467891774-1467897874148235', 1, 0, '', NULL, NULL, NULL),
(2456, '2016-07-07 21:24:34', NULL, NULL, 855, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467900626', 'admin', '2016-07-07 21:24:34', 'admin-1467891774-1467897874148235', 1, 0, '', NULL, NULL, NULL),
(2457, '2016-07-08 13:22:12', NULL, NULL, 879, 0, 83, '83', 'Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 13:22:12', 'admin-1467952712-1467955332483298', 1, 1, 'SR', NULL, NULL, NULL),
(2458, '2016-07-08 13:26:21', NULL, NULL, 880, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 13:26:21', 'admin-1467952712-1467955580902887', 1, 1, 'SR', NULL, NULL, NULL),
(2459, '2016-07-08 13:26:21', NULL, NULL, 880, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 13:26:21', 'admin-1467952712-1467955580902887', 1, 1, 'SR', NULL, NULL, NULL),
(2460, '2016-07-08 13:26:21', NULL, NULL, 880, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 13:26:21', 'admin-1467952712-1467955580902887', 1, 0, '', NULL, NULL, NULL),
(2461, '2016-07-08 13:26:21', NULL, NULL, 880, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 13:26:21', 'admin-1467952712-1467955580902887', 1, 0, '', NULL, NULL, NULL),
(2462, '2016-07-08 13:26:21', NULL, NULL, 880, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 13:26:21', 'admin-1467952712-1467955580902887', 1, 1, 'SR', NULL, NULL, NULL),
(2463, '2016-07-08 13:26:21', NULL, NULL, 880, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 13:26:21', 'admin-1467952712-1467955580902887', 1, 1, 'SR', NULL, NULL, NULL),
(2464, '2016-07-08 14:25:51', NULL, NULL, 881, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 14:25:51', 'admin-1467952712-14679591511019078', 1, 1, 'SR', NULL, NULL, NULL),
(2465, '2016-07-08 14:34:53', NULL, NULL, 882, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 14:34:53', 'admin-1467952712-14679596931642491', 1, 1, 'SR', 1, NULL, NULL),
(2466, '2016-07-08 14:37:46', NULL, NULL, 883, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 14:37:46', 'admin-1467952712-14679598659802247', 1, 1, 'SR', 1, NULL, NULL),
(2467, '2016-07-08 14:51:03', NULL, NULL, 884, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 14:51:03', 'admin-1467952712-14679606629176393', 1, 0, '', NULL, NULL, NULL),
(2468, '2016-07-08 14:51:03', NULL, NULL, 884, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 14:51:03', 'admin-1467952712-14679606629176393', 1, 1, 'SR', NULL, NULL, NULL),
(2469, '2016-07-08 14:51:03', NULL, NULL, 884, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 14:51:03', 'admin-1467952712-14679606629176393', 1, 1, 'SR', NULL, NULL, NULL),
(2470, '2016-07-08 00:00:00', NULL, NULL, 886, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 14:56:38', 'admin-1467952712-14679609986824868', 1, 1, 'SR', NULL, NULL, NULL),
(2471, '2016-07-08 00:00:00', NULL, NULL, 887, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 14:56:38', 'admin-1467952712-14679609986824868', 1, 1, 'SR', NULL, NULL, NULL),
(2472, '2016-07-08 00:00:00', NULL, NULL, 887, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 14:56:38', 'admin-1467952712-14679609986824868', 1, 0, '', NULL, NULL, NULL),
(2473, '2016-07-08 00:00:00', NULL, NULL, 888, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 14:57:23', 'admin-1467952712-1467961043496756', 1, 1, 'SR', NULL, NULL, NULL),
(2474, '2016-07-08 00:00:00', NULL, NULL, 888, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 14:57:10', 'admin-1467952712-14679610299956555', 1, 1, 'SR', NULL, NULL, NULL),
(2475, '2016-07-08 00:00:00', NULL, NULL, 886, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 14:56:38', 'admin-1467952712-14679609986824868', 1, 0, '', NULL, NULL, NULL),
(2476, '2016-07-08 15:02:19', NULL, NULL, 889, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 15:02:19', 'admin-1467952712-14679613393614722', 1, 0, '', NULL, NULL, NULL),
(2477, '2016-07-08 15:15:57', NULL, NULL, 890, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 15:15:57', 'admin-1467952712-14679621574686770', 1, 0, '', NULL, NULL, NULL),
(2478, '2016-07-08 16:00:27', NULL, NULL, 891, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 16:00:27', 'admin-1467962166-14679648277613665', 1, 0, '', 1, NULL, NULL),
(2479, '2016-07-08 16:46:11', NULL, NULL, 892, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 16:46:11', 'admin-1467962166-14679675715751557', 1, 1, 'SR', 1, NULL, NULL),
(2480, '2016-07-08 13:22:12', NULL, NULL, 879, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 13:22:12', 'admin-1467952712-1467955332483298', 1, 1, 'SR', NULL, NULL, NULL),
(2481, '2016-07-08 13:22:12', NULL, NULL, 879, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 13:22:12', 'admin-1467952712-1467955332483298', 1, 1, 'SR', NULL, NULL, NULL),
(2482, '2016-07-08 12:58:55', NULL, NULL, 878, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 12:58:55', 'admin-1467952712-14679539353622095', 1, 1, 'SR', NULL, NULL, NULL),
(2483, '2016-07-08 12:58:55', NULL, NULL, 878, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 12:58:55', 'admin-1467952712-14679539353622095', 1, 1, 'SR', NULL, NULL, NULL),
(2484, '2016-07-08 12:39:31', NULL, NULL, 877, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 12:39:31', 'admin-1467952712-14679527711559053', 1, 1, 'SR', NULL, NULL, NULL),
(2485, '2016-07-08 12:39:31', NULL, NULL, 877, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 12:39:31', 'admin-1467952712-14679527711559053', 1, 1, 'SR', NULL, NULL, NULL),
(2486, '2016-07-08 12:39:04', NULL, NULL, 876, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 12:39:04', 'admin-1467952712-14679527447859589', 1, 1, 'SR', NULL, NULL, NULL),
(2487, '2016-07-08 12:39:04', NULL, NULL, 876, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 12:39:04', 'admin-1467952712-14679527447859589', 1, 1, 'SR', NULL, NULL, NULL),
(2488, '2016-07-08 12:25:46', NULL, NULL, 875, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 12:25:46', 'admin-1467945991-146795194611157', 1, 1, 'SR', NULL, NULL, NULL),
(2489, '2016-07-08 12:25:46', NULL, NULL, 875, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 12:25:46', 'admin-1467945991-146795194611157', 1, 1, 'SR', NULL, NULL, NULL),
(2490, '2016-07-08 12:19:42', NULL, NULL, 875, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 12:19:42', 'admin-1467945991-14679515825498697', 1, 1, 'SR', NULL, NULL, NULL),
(2491, '2016-07-08 12:04:04', NULL, NULL, 873, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 12:04:04', 'admin-1467945991-14679506441702793', 1, 0, '', NULL, NULL, NULL),
(2492, '2016-07-08 11:53:02', NULL, NULL, 874, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 11:53:02', 'admin-1467945991-1467949982122920', 1, 1, 'SR', NULL, NULL, NULL),
(2493, '2016-07-08 11:52:54', NULL, NULL, 874, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 11:52:54', 'admin-1467945991-14679499742405737', 1, 0, '', NULL, NULL, NULL),
(2494, '2016-07-08 11:52:54', NULL, NULL, 874, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 11:52:54', 'admin-1467945991-14679499742405737', 1, 0, '', NULL, NULL, NULL),
(2495, '2016-07-08 12:19:42', NULL, NULL, 875, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 12:19:42', 'admin-1467945991-14679515825498697', 1, 1, 'SR', NULL, NULL, NULL),
(2496, '2016-07-08 11:51:39', NULL, NULL, 873, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 11:51:39', 'admin-1467945991-14679498995339021', 1, 1, 'SR', NULL, NULL, NULL),
(2497, '2016-07-08 11:09:36', NULL, NULL, 872, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 11:09:36', 'admin-1467945991-1467947376039639', 1, 1, 'SR', NULL, NULL, NULL),
(2498, '2016-07-08 11:02:36', NULL, NULL, 871, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 11:02:36', 'admin-1467945991-14679469560574479', 1, 1, 'SR', NULL, NULL, NULL),
(2499, '2016-07-08 10:52:45', NULL, NULL, 870, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:52:45', 'admin-1467945991-14679463649487280', 1, 1, 'SR', NULL, NULL, NULL),
(2500, '2016-07-08 10:52:45', NULL, NULL, 870, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:52:45', 'admin-1467945991-14679463649487280', 1, 1, 'SR', NULL, NULL, NULL),
(2501, '2016-07-08 10:52:45', NULL, NULL, 870, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:52:45', 'admin-1467945991-14679463649487280', 1, 0, '', NULL, NULL, NULL),
(2502, '2016-07-08 10:52:45', NULL, NULL, 870, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:52:45', 'admin-1467945991-14679463649487280', 1, 0, '', NULL, NULL, NULL),
(2503, '2016-07-08 10:44:35', NULL, NULL, 868, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:44:35', 'admin-1467943171-1467945875297423', 1, 1, 'SR', NULL, NULL, NULL),
(2504, '2016-07-08 10:44:35', NULL, NULL, 868, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:44:35', 'admin-1467943171-1467945875297423', 1, 0, '', NULL, NULL, NULL),
(2505, '2016-07-08 10:31:57', NULL, NULL, 866, 0, 181, '116', 'Open Food ', 'bacon', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:31:57', 'admin-1467943171-14679451176871834', 1, 0, '', NULL, NULL, NULL),
(2506, '2016-07-08 10:31:57', NULL, NULL, 866, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:31:57', 'admin-1467943171-14679451176871834', 1, 0, '', NULL, NULL, NULL),
(2507, '2016-07-08 10:20:27', NULL, NULL, 858, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:20:27', 'admin-1467943171-1467944427317359', 1, 1, 'SR', NULL, NULL, NULL),
(2508, '2016-07-08 10:20:27', NULL, NULL, 858, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:20:27', 'admin-1467943171-1467944427317359', 1, 1, 'SR', NULL, NULL, NULL),
(2509, '2016-07-08 10:20:27', NULL, NULL, 858, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:20:27', 'admin-1467943171-1467944427317359', 1, 1, 'SR', NULL, NULL, NULL),
(2510, '2016-07-08 10:46:24', NULL, NULL, 869, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:46:24', 'admin-1467943171-14679459838863067', 1, 1, 'SR', NULL, NULL, NULL),
(2511, '2016-07-08 10:46:24', NULL, NULL, 869, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:46:24', 'admin-1467943171-14679459838863067', 1, 0, '', NULL, NULL, NULL),
(2512, '2016-07-08 10:44:35', NULL, NULL, 868, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:44:35', 'admin-1467943171-1467945875297423', 1, 1, 'SR', NULL, NULL, NULL),
(2513, '2016-07-08 10:44:35', NULL, NULL, 868, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:44:35', 'admin-1467943171-1467945875297423', 1, 0, '', NULL, NULL, NULL),
(2514, '2016-07-08 10:44:35', NULL, NULL, 868, NULL, 26, '26', 'Tea By Cup', '', 'Hot Drinks', 'Non Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:44:35', 'admin-1467943171-1467945875297423', 1, 1, 'SR', NULL, NULL, NULL),
(2515, '2016-07-08 10:18:59', NULL, NULL, 867, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:18:59', 'admin-1467943171-14679443392387079', 1, 0, '', NULL, NULL, NULL),
(2516, '2016-07-08 10:18:59', NULL, NULL, 867, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:18:59', 'admin-1467943171-14679443392387079', 1, 1, 'SR', NULL, NULL, NULL),
(2517, '2016-07-08 10:17:48', NULL, NULL, 866, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:17:48', 'admin-1467943171-14679442680603088', 1, 0, '', NULL, NULL, NULL),
(2518, '2016-07-08 10:17:48', NULL, NULL, 866, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:17:48', 'admin-1467943171-14679442680603088', 1, 0, '', NULL, NULL, NULL),
(2519, '2016-07-08 10:17:48', NULL, NULL, 866, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:17:48', 'admin-1467943171-14679442680603088', 1, 1, 'SR', NULL, NULL, NULL),
(2520, '2016-07-08 10:16:56', NULL, NULL, 865, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:16:56', 'admin-1467943171-14679442161054759', 1, 1, 'SR', NULL, NULL, NULL),
(2521, '2016-07-08 10:11:18', NULL, NULL, 864, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:11:18', 'admin-1467943171-14679438780582099', 1, 0, '', NULL, NULL, NULL),
(2522, '2016-07-08 10:11:18', NULL, NULL, 864, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:11:18', 'admin-1467943171-14679438780582099', 1, 0, '', NULL, NULL, NULL),
(2523, '2016-07-08 10:11:18', NULL, NULL, 864, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:11:18', 'admin-1467943171-14679438780582099', 1, 0, '', NULL, NULL, NULL),
(2524, '2016-07-08 10:00:20', NULL, NULL, 863, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:00:20', 'admin-1467943171-14679432198216738', 1, 0, '', 1, NULL, NULL),
(2525, '2016-07-08 09:58:16', NULL, NULL, 862, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 09:58:16', 'admin-1467940051-1467943096033455', 1, 0, '', 1, NULL, NULL),
(2526, '2016-07-08 09:37:26', NULL, NULL, 860, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 09:37:26', 'admin-1467940051-14679418459546945', 1, 1, 'SR', NULL, NULL, NULL),
(2527, '2016-07-08 09:37:26', NULL, NULL, 860, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 09:37:26', 'admin-1467940051-14679418459546945', 1, 1, 'SR', NULL, NULL, NULL),
(2528, '2016-07-08 09:37:11', NULL, NULL, 860, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 09:37:11', 'admin-1467940051-14679418312408699', 1, 0, '', NULL, NULL, NULL),
(2529, '2016-07-08 09:37:11', NULL, NULL, 860, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 09:37:11', 'admin-1467940051-14679418312408699', 1, 0, '', NULL, NULL, NULL),
(2530, '2016-07-08 10:31:57', NULL, NULL, 866, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:31:57', 'admin-1467943171-14679451176871834', 1, 0, '', NULL, NULL, NULL),
(2531, '2016-07-08 11:02:36', NULL, NULL, 871, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 11:02:36', 'admin-1467945991-14679469560574479', 1, 1, 'SR', NULL, NULL, NULL),
(2532, '2016-07-08 10:44:35', NULL, NULL, 868, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:44:35', 'admin-1467943171-1467945875297423', 1, 0, '', NULL, NULL, NULL),
(2533, '2016-07-08 10:11:18', NULL, NULL, 864, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 10:11:18', 'admin-1467943171-14679438780582099', 1, 1, 'SR', NULL, NULL, NULL),
(2534, '2016-07-08 09:37:26', NULL, NULL, 860, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 09:37:26', 'admin-1467940051-14679418459546945', 1, 1, 'SR', NULL, NULL, NULL),
(2535, '2016-07-08 09:37:11', NULL, NULL, 860, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 09:37:11', 'admin-1467940051-14679418312408699', 1, 0, '', NULL, NULL, NULL),
(2536, '2016-07-08 09:22:36', NULL, NULL, 859, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 09:22:36', 'admin-1467940051-1467940956649116', 1, 1, 'SR', NULL, NULL, NULL),
(2537, '2016-07-08 09:22:36', NULL, NULL, 859, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 09:22:36', 'admin-1467940051-1467940956649116', 1, 0, '', NULL, NULL, NULL),
(2538, '2016-07-08 09:22:36', NULL, NULL, 859, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 09:22:36', 'admin-1467940051-1467940956649116', 1, 0, '', NULL, NULL, NULL),
(2539, '2016-07-08 09:22:36', NULL, NULL, 859, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 09:22:36', 'admin-1467940051-1467940956649116', 1, 0, '', NULL, NULL, NULL),
(2540, '2016-07-08 09:17:08', NULL, NULL, 858, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1467977705', 'admin', '2016-07-08 09:17:08', 'admin-1467940051-14679406279429377', 1, 0, '', NULL, NULL, NULL),
(2541, '2016-07-09 20:52:36', NULL, NULL, 925, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 20:52:36', 'admin-1468068546-14680687565945340', 1, 1, 'SR', NULL, NULL, NULL),
(2542, '2016-07-09 20:52:36', NULL, NULL, 925, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 20:52:36', 'admin-1468068546-14680687565945340', 1, 1, 'SR', NULL, NULL, NULL),
(2543, '2016-07-09 20:52:36', NULL, NULL, 925, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 20:52:36', 'admin-1468068546-14680687565945340', 1, 1, 'SR', NULL, NULL, NULL),
(2544, '2016-07-09 21:04:44', NULL, NULL, 923, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 21:04:44', 'admin-1468068546-14680694841297311', 1, 1, 'SR', NULL, NULL, NULL),
(2545, '2016-07-09 20:26:41', NULL, NULL, 923, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 20:26:41', 'admin-1468065170-14680672008826814', 1, 0, '', NULL, NULL, NULL),
(2546, '2016-07-09 20:26:41', NULL, NULL, 923, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 20:26:41', 'admin-1468065170-14680672008826814', 1, 0, '', NULL, NULL, NULL),
(2547, '2016-07-09 20:26:41', NULL, NULL, 923, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 20:26:41', 'admin-1468065170-14680672008826814', 1, 0, '', NULL, NULL, NULL),
(2548, '2016-07-09 20:47:56', NULL, NULL, 921, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 20:47:56', 'admin-1468065170-14680684762757964', 1, 1, 'SR', NULL, NULL, NULL),
(2549, '2016-07-09 20:47:56', NULL, NULL, 921, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 20:47:56', 'admin-1468065170-14680684762757964', 1, 1, 'SR', NULL, NULL, NULL),
(2550, '2016-07-09 20:47:56', NULL, NULL, 921, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 20:47:56', 'admin-1468065170-14680684762757964', 1, 1, 'SR', NULL, NULL, NULL),
(2551, '2016-07-09 20:48:36', NULL, NULL, 924, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 20:48:36', 'admin-1468065170-14680685164367478', 1, 1, 'SR', NULL, NULL, NULL),
(2552, '2016-07-09 20:26:41', NULL, NULL, 923, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 20:26:41', 'admin-1468065170-14680672008826814', 1, 0, '', NULL, NULL, NULL),
(2553, '2016-07-09 20:26:41', NULL, NULL, 923, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1468073319', 'admin', '2016-07-09 20:26:41', 'admin-1468065170-14680672008826814', 1, 0, '', NULL, NULL, NULL),
(2554, '2016-07-09 20:48:36', NULL, NULL, 924, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 20:48:36', 'admin-1468065170-14680685164367478', 1, 1, 'SR', NULL, NULL, NULL),
(2555, '2016-07-09 20:26:41', NULL, NULL, 923, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 20:26:41', 'admin-1468065170-14680672008826814', 1, 0, '', NULL, NULL, NULL),
(2556, '2016-07-09 20:26:41', NULL, NULL, 923, 0, 201, '136', 'Dinner -  Chili Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 20:26:41', 'admin-1468065170-14680672008826814', 1, 0, '', NULL, NULL, NULL),
(2557, '2016-07-09 20:26:41', NULL, NULL, 923, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1468073319', 'admin', '2016-07-09 20:26:41', 'admin-1468065170-14680672008826814', 1, 0, '', NULL, NULL, NULL),
(2558, '2016-07-09 20:26:41', NULL, NULL, 923, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1468073319', 'admin', '2016-07-09 20:26:41', 'admin-1468065170-14680672008826814', 1, 0, '', NULL, NULL, NULL),
(2559, '2016-07-09 19:07:24', NULL, NULL, 919, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:07:24', 'admin-1468052698-1468062444589349', 1, 1, 'SR', NULL, NULL, '10.0'),
(2560, '2016-07-09 19:08:06', NULL, NULL, 919, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:08:06', 'admin-1468062462-14680624858622428', 1, 1, 'SR', NULL, NULL, '10.0'),
(2561, '2016-07-09 19:08:06', NULL, NULL, 919, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:08:06', 'admin-1468062462-14680624858622428', 1, 1, 'SR', NULL, NULL, '10.0'),
(2562, '2016-07-09 19:08:06', NULL, NULL, 919, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:08:06', 'admin-1468062462-14680624858622428', 1, 1, 'SR', NULL, NULL, '10.0'),
(2563, '2016-07-09 19:08:06', NULL, NULL, 919, 0, 199, '134', 'Dinner - Marmite Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:08:06', 'admin-1468062462-14680624858622428', 1, 0, '', NULL, NULL, '10.0'),
(2564, '2016-07-09 19:09:14', NULL, NULL, 919, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:09:14', 'admin-1468062462-14680625544387322', 1, 0, '', NULL, NULL, '10.0'),
(2565, '2016-07-09 19:09:29', NULL, NULL, 919, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:09:29', 'admin-1468062462-14680625694061763', 1, 1, 'SR', NULL, NULL, '10.0'),
(2566, '2016-07-09 19:09:29', NULL, NULL, 919, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:09:29', 'admin-1468062462-14680625694061763', 1, 1, 'SR', NULL, NULL, '10.0'),
(2567, '2016-07-09 19:11:30', NULL, NULL, 920, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:11:30', 'admin-1468062462-14680626906168267', 1, 1, 'SR', NULL, NULL, NULL),
(2568, '2016-07-09 19:23:20', NULL, NULL, 919, 0, 198, '133', 'Dinner - Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:23:20', 'admin-1468062462-14680634007246351', 1, 0, '', NULL, NULL, '10.0'),
(2569, '2016-07-09 19:40:27', NULL, NULL, 919, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:40:27', 'admin-1468062462-14680644273223897', 1, 0, '', NULL, NULL, '10.0'),
(2570, '2016-07-09 19:40:27', NULL, NULL, 919, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:40:27', 'admin-1468062462-14680644273223897', 1, 0, '', NULL, NULL, '10.0'),
(2571, '2016-07-09 19:40:27', NULL, NULL, 919, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:40:27', 'admin-1468062462-14680644273223897', 1, 0, '', NULL, NULL, '10.0'),
(2572, '2016-07-09 19:52:32', NULL, NULL, 921, 0, 201, '136', 'Dinner -  Chili Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:52:32', 'admin-1468062462-14680651520548093', 1, 0, '', NULL, NULL, NULL),
(2573, '2016-07-09 19:52:32', NULL, NULL, 921, 0, 199, '134', 'Dinner - Marmite Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:52:32', 'admin-1468062462-14680651520548093', 1, 0, '', NULL, NULL, NULL),
(2574, '2016-07-09 19:52:32', NULL, NULL, 921, 0, 198, '133', 'Dinner - Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:52:32', 'admin-1468062462-14680651520548093', 1, 0, '', NULL, NULL, NULL),
(2575, '2016-07-09 19:52:32', NULL, NULL, 921, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:52:32', 'admin-1468062462-14680651520548093', 1, 0, '', NULL, NULL, NULL),
(2576, '2016-07-09 19:52:32', NULL, NULL, 921, 0, 197, '132', 'Dinner - Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:52:32', 'admin-1468062462-14680651520548093', 1, 0, '', NULL, NULL, NULL),
(2577, '2016-07-09 19:52:32', NULL, NULL, 921, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:52:32', 'admin-1468062462-14680651520548093', 1, 1, 'SR', NULL, NULL, NULL),
(2578, '2016-07-09 19:52:32', NULL, NULL, 921, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:52:32', 'admin-1468062462-14680651520548093', 1, 1, 'SR', NULL, NULL, NULL),
(2579, '2016-07-09 19:52:32', NULL, NULL, 921, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:52:32', 'admin-1468062462-14680651520548093', 1, 0, '', NULL, NULL, NULL),
(2580, '2016-07-09 19:52:38', NULL, NULL, 921, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:52:38', 'admin-1468062462-14680651586608232', 1, 0, '', NULL, NULL, NULL),
(2581, '2016-07-09 19:52:38', NULL, NULL, 921, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:52:38', 'admin-1468062462-14680651586608232', 1, 0, '', NULL, NULL, NULL),
(2582, '2016-07-09 19:52:38', NULL, NULL, 921, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:52:38', 'admin-1468062462-14680651586608232', 1, 0, '', NULL, NULL, NULL),
(2583, '2016-07-09 19:52:38', NULL, NULL, 921, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:52:38', 'admin-1468062462-14680651586608232', 1, 0, '', NULL, NULL, NULL),
(2584, '2016-07-09 19:52:38', NULL, NULL, 921, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:52:38', 'admin-1468062462-14680651586608232', 1, 0, '', NULL, NULL, NULL),
(2585, '2016-07-09 19:52:38', NULL, NULL, 921, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 19:52:38', 'admin-1468062462-14680651586608232', 1, 0, '', NULL, NULL, NULL),
(2586, '2016-07-09 20:04:28', NULL, NULL, 922, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 20:04:28', 'admin-1468065170-14680658678886158', 1, 0, '', NULL, NULL, NULL),
(2587, '2016-07-09 20:04:28', NULL, NULL, 922, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 20:04:28', 'admin-1468065170-14680658678886158', 1, 1, 'SR', NULL, NULL, NULL),
(2588, '2016-07-09 18:39:12', NULL, NULL, 918, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 18:39:12', 'admin-1468052698-14680607519423685', 1, 1, 'SR', NULL, NULL, NULL),
(2589, '2016-07-09 17:28:35', NULL, NULL, 916, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 17:28:35', 'admin-1468052698-14680565157807926', 1, 1, 'SR', NULL, NULL, NULL),
(2590, '2016-07-09 17:29:34', NULL, NULL, 917, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 17:29:34', 'admin-1468052698-14680565746477867', 1, 0, '', NULL, NULL, NULL),
(2591, '2016-07-09 17:28:35', NULL, NULL, 916, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 17:28:35', 'admin-1468052698-14680565157807926', 1, 0, '', NULL, NULL, NULL),
(2592, '2016-07-09 16:50:50', NULL, NULL, 914, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 16:50:50', 'admin-1468052698-14680542502897531', 1, 1, 'SR', NULL, NULL, NULL),
(2593, '2016-07-09 17:28:35', NULL, NULL, 916, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 17:28:35', 'admin-1468052698-14680565157807926', 1, 1, 'SR', NULL, NULL, NULL),
(2594, '2016-07-09 17:05:50', NULL, NULL, 915, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 17:05:50', 'admin-1468052698-14680551504628178', 1, 0, '', NULL, NULL, NULL),
(2595, '2016-07-09 16:50:50', NULL, NULL, 914, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 16:50:50', 'admin-1468052698-14680542502897531', 1, 1, 'SR', NULL, NULL, NULL),
(2596, '2016-07-09 15:43:35', NULL, NULL, 908, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 15:43:35', 'admin-1468026127-14680502155251297', 1, 1, 'SR', NULL, NULL, NULL),
(2597, '2016-07-09 16:46:28', NULL, NULL, 913, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 16:46:28', 'admin-1468052698-1468053987866149', 1, 0, '', 1, NULL, NULL),
(2598, '2016-07-09 16:25:28', NULL, NULL, 909, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 16:25:28', 'admin-1468052698-14680527279589610', 1, 1, 'SR', NULL, NULL, NULL),
(2599, '2016-07-09 16:24:52', NULL, NULL, 909, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 16:24:52', 'admin-1468026127-14680526920083524', 1, 1, 'SR', NULL, NULL, NULL),
(2600, '2016-07-09 16:41:42', NULL, NULL, 912, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 16:41:42', 'admin-1468052698-14680537024086342', 1, 1, 'SR', 1, NULL, NULL),
(2601, '2016-07-09 16:31:52', NULL, NULL, 911, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 16:31:52', 'admin-1468052698-1468053112409245', 1, 0, '', 1, NULL, NULL),
(2602, '2016-07-09 15:21:31', NULL, NULL, 907, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 15:21:31', 'admin-1468026127-14680488917219220', 1, 1, 'SR', NULL, NULL, NULL),
(2603, '2016-07-09 15:43:35', NULL, NULL, 908, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 15:43:35', 'admin-1468026127-14680502155251297', 1, 0, '', NULL, NULL, NULL),
(2604, '2016-07-09 15:21:31', NULL, NULL, 907, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 15:21:31', 'admin-1468026127-14680488917219220', 1, 1, 'SR', NULL, NULL, NULL),
(2605, '2016-07-09 12:32:05', NULL, NULL, 899, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 12:32:05', 'admin-1468026127-14680387256868187', 1, 0, '', NULL, NULL, NULL),
(2606, '2016-07-09 12:32:32', NULL, NULL, 899, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 12:32:32', 'admin-1468026127-14680387526769016', 1, 1, 'SR', NULL, NULL, NULL),
(2607, '2016-07-09 14:07:23', NULL, NULL, 900, 0, 83, '83', 'Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 14:07:23', 'admin-1468026127-14680444437341273', 1, 1, 'SR', NULL, NULL, NULL),
(2608, '2016-07-09 14:08:11', NULL, NULL, 901, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 14:08:11', 'admin-1468026127-1468044491806728', 1, 1, 'SR', NULL, NULL, NULL),
(2609, '2016-07-09 14:08:11', NULL, NULL, 901, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 14:08:11', 'admin-1468026127-1468044491806728', 1, 1, 'SR', NULL, NULL, NULL),
(2610, '2016-07-09 14:08:41', NULL, NULL, 902, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 14:08:41', 'admin-1468026127-14680445210625624', 1, 1, 'SR', 1, NULL, NULL),
(2611, '2016-07-09 14:09:25', NULL, NULL, 903, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 14:09:25', 'admin-1468026127-14680445653421737', 1, 1, 'SR', 1, NULL, NULL),
(2612, '2016-07-09 14:10:12', NULL, NULL, 904, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 14:10:12', 'admin-1468026127-14680446122173592', 1, 1, 'SR', 1, NULL, NULL),
(2613, '2016-07-09 14:10:12', NULL, NULL, 904, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 14:10:12', 'admin-1468026127-14680446122173592', 1, 0, '', 1, NULL, NULL),
(2614, '2016-07-09 14:56:58', NULL, NULL, 905, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 14:56:58', 'admin-1468026127-14680474183197210', 1, 1, 'SR', NULL, NULL, NULL),
(2615, '2016-07-09 14:56:58', NULL, NULL, 905, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 14:56:58', 'admin-1468026127-14680474183197210', 1, 0, '', NULL, NULL, NULL),
(2616, '2016-07-09 11:14:06', NULL, NULL, 896, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 11:14:06', 'admin-1468026127-14680340467281365', 1, 1, 'SR', NULL, NULL, NULL),
(2617, '2016-07-09 11:14:06', NULL, NULL, 896, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 11:14:06', 'admin-1468026127-14680340467281365', 1, 0, '', NULL, NULL, NULL),
(2618, '2016-07-09 11:38:46', NULL, NULL, 897, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 11:38:46', 'admin-1468026127-14680355260721480', 1, 0, '', NULL, NULL, NULL),
(2619, '2016-07-09 11:38:46', NULL, NULL, 897, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 11:38:46', 'admin-1468026127-14680355260721480', 1, 0, '', NULL, NULL, NULL),
(2620, '2016-07-09 11:38:46', NULL, NULL, 897, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 11:38:46', 'admin-1468026127-14680355260721480', 1, 0, '', NULL, NULL, NULL),
(2621, '2016-07-09 11:38:46', NULL, NULL, 897, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 11:38:46', 'admin-1468026127-14680355260721480', 1, 0, '', NULL, NULL, NULL),
(2622, '2016-07-09 11:38:46', NULL, NULL, 897, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 11:38:46', 'admin-1468026127-14680355260721480', 1, 1, 'SR', NULL, NULL, NULL),
(2623, '2016-07-09 11:38:46', NULL, NULL, 897, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 11:38:46', 'admin-1468026127-14680355260721480', 1, 1, 'SR', NULL, NULL, NULL),
(2624, '2016-07-09 12:31:44', NULL, NULL, 898, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 12:31:44', 'admin-1468026127-14680387043394181', 1, 1, 'SR', NULL, NULL, NULL),
(2625, '2016-07-09 15:19:01', NULL, NULL, 907, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 15:19:01', 'admin-1468026127-14680487409438393', 1, 0, '', NULL, NULL, NULL),
(2626, '2016-07-09 14:56:58', NULL, NULL, 905, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 14:56:58', 'admin-1468026127-14680474183197210', 1, 0, '', NULL, NULL, NULL),
(2627, '2016-07-09 11:13:21', NULL, NULL, 896, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 11:13:21', 'admin-1468026127-14680340010169983', 1, 0, '', NULL, NULL, NULL),
(2628, '2016-07-09 11:13:21', NULL, NULL, 896, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 11:13:21', 'admin-1468026127-14680340010169983', 1, 0, '', NULL, NULL, NULL),
(2629, '2016-07-09 11:13:21', NULL, NULL, 896, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 11:13:21', 'admin-1468026127-14680340010169983', 1, 0, '', NULL, NULL, NULL),
(2630, '2016-07-09 11:13:21', NULL, NULL, 896, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 11:13:21', 'admin-1468026127-14680340010169983', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(2631, '2016-07-09 11:13:37', NULL, NULL, 896, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 11:13:37', 'admin-1468026127-1468034016933762', 1, 1, 'SR', NULL, NULL, NULL),
(2632, '2016-07-09 10:30:24', NULL, NULL, 895, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 10:30:24', 'admin-1468026127-14680314243453723', 1, 0, '', NULL, NULL, NULL),
(2633, '2016-07-09 10:30:24', NULL, NULL, 895, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 10:30:24', 'admin-1468026127-14680314243453723', 1, 0, '', NULL, NULL, NULL),
(2634, '2016-07-09 10:30:24', NULL, NULL, 895, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 10:30:24', 'admin-1468026127-14680314243453723', 1, 1, 'SR', NULL, NULL, NULL),
(2635, '2016-07-09 10:30:24', NULL, NULL, 895, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 10:30:24', 'admin-1468026127-14680314243453723', 1, 1, 'SR', NULL, NULL, NULL),
(2636, '2016-07-09 10:54:29', NULL, NULL, 895, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 10:54:29', 'admin-1468026127-1468032869116687', 1, 1, 'SR', NULL, NULL, NULL),
(2637, '2016-07-09 10:11:34', NULL, NULL, 894, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 10:11:34', 'admin-1468026127-14680302945967056', 1, 1, 'SR', NULL, NULL, NULL),
(2638, '2016-07-09 09:03:41', NULL, NULL, 893, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 09:03:41', 'admin-1468026127-1468026221108991', 1, 1, 'SR', NULL, NULL, '10.0'),
(2639, '2016-07-09 09:02:23', NULL, NULL, 893, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 09:02:23', 'admin-1468026127-14680261437435176', 1, 0, '', NULL, NULL, '10.0'),
(2640, '2016-07-09 10:11:34', NULL, NULL, 894, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 10:11:34', 'admin-1468026127-14680302945967056', 1, 1, 'SR', NULL, NULL, NULL),
(2641, '2016-07-09 09:02:23', NULL, NULL, 893, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 09:02:23', 'admin-1468026127-14680261437435176', 1, 0, '', NULL, NULL, '10.0'),
(2642, '2016-07-09 09:03:41', NULL, NULL, 893, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 09:03:41', 'admin-1468026127-1468026221108991', 1, 1, 'SR', NULL, NULL, '10.0'),
(2643, '2016-07-09 15:19:01', NULL, NULL, 907, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 15:19:01', 'admin-1468026127-14680487409438393', 1, 0, '', NULL, NULL, NULL),
(2644, '2016-07-09 15:19:01', NULL, NULL, 907, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 15:19:01', 'admin-1468026127-14680487409438393', 1, 0, '', NULL, NULL, NULL),
(2645, '2016-07-09 15:19:01', NULL, NULL, 907, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 15:19:01', 'admin-1468026127-14680487409438393', 1, 1, 'SR', NULL, NULL, NULL),
(2646, '2016-07-09 15:13:44', NULL, NULL, 906, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 15:13:44', 'admin-1468026127-14680484242904273', 1, 1, 'SR', NULL, NULL, NULL),
(2647, '2016-07-09 15:13:44', NULL, NULL, 906, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 15:13:44', 'admin-1468026127-14680484242904273', 1, 1, 'SR', NULL, NULL, NULL),
(2648, '2016-07-09 11:13:37', NULL, NULL, 896, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 11:13:37', 'admin-1468026127-1468034016933762', 1, 1, 'SR', NULL, NULL, NULL),
(2649, '2016-07-09 10:11:34', NULL, NULL, 894, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 10:11:34', 'admin-1468026127-14680302945967056', 1, 1, 'SR', NULL, NULL, NULL),
(2650, '2016-07-09 10:11:34', NULL, NULL, 894, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 10:11:34', 'admin-1468026127-14680302945967056', 1, 1, 'SR', NULL, NULL, NULL),
(2651, '2016-07-09 09:02:23', NULL, NULL, 893, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468073319', 'admin', '2016-07-09 09:02:23', 'admin-1468026127-14680261437435176', 1, 0, '', NULL, NULL, '10.0'),
(2652, '2016-07-10 20:39:38', NULL, NULL, 973, 0, 181, '116', 'Open Food ', 'tempus two', 'Meals', 'Perfect Meals', 1, 100.00, 100.0000, 0.0000, 100.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 20:39:38', 'admin-1468135169-14681543782732234', 1, 0, '', 1, NULL, NULL),
(2653, '2016-07-10 15:38:04', NULL, NULL, 959, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 15:38:04', 'admin-1468135169-14681362840532964', 1, 1, 'SR', NULL, NULL, NULL),
(2654, '2016-07-10 15:38:41', NULL, NULL, 960, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 15:38:41', 'admin-1468135169-14681363209018566', 1, 1, 'SR', NULL, NULL, NULL),
(2655, '2016-07-10 15:38:41', NULL, NULL, 960, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 15:38:41', 'admin-1468135169-14681363209018566', 1, 1, 'SR', NULL, NULL, NULL),
(2656, '2016-07-10 15:38:41', NULL, NULL, 960, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 15:38:41', 'admin-1468135169-14681363209018566', 1, 1, 'SR', NULL, NULL, NULL),
(2657, '2016-07-10 15:38:41', NULL, NULL, 960, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 15:38:41', 'admin-1468135169-14681363209018566', 1, 1, 'SR', NULL, NULL, NULL),
(2658, '2016-07-10 15:39:57', NULL, NULL, 956, 0, 187, '122', 'Iced Tea ', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 15:39:57', 'admin-1468135169-1468136397457437', 1, 0, '', NULL, NULL, NULL),
(2659, '2016-07-10 15:42:09', NULL, NULL, 961, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 15:42:09', 'admin-1468135169-14681365296339617', 1, 1, 'SR', NULL, NULL, NULL),
(2660, '2016-07-10 20:13:13', NULL, NULL, 972, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 20:13:13', 'admin-1468135169-14681527934487771', 1, 1, 'SR', NULL, NULL, NULL),
(2661, '2016-07-10 16:59:28', NULL, NULL, 963, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 12.60, 1, '27', 1, '1468157241', 'admin', '2016-07-10 16:59:28', 'admin-1468135169-14681411682925564', 1, 1, 'SR', NULL, '10.0', NULL),
(2662, '2016-07-10 16:59:28', NULL, NULL, 963, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 8.10, 1, '27', 1, '1468157241', 'admin', '2016-07-10 16:59:28', 'admin-1468135169-14681411682925564', 1, 1, 'SR', NULL, '10.0', NULL),
(2663, '2016-07-10 16:59:28', NULL, NULL, 963, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 8.10, 1, '27', 1, '1468157241', 'admin', '2016-07-10 16:59:28', 'admin-1468135169-14681411682925564', 1, 1, 'SR', NULL, '10.0', NULL),
(2664, '2016-07-10 17:27:37', NULL, NULL, 964, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 17:27:37', 'admin-1468135169-1468142857435442', 1, 0, '', NULL, NULL, NULL),
(2665, '2016-07-10 17:27:37', NULL, NULL, 964, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 17:27:37', 'admin-1468135169-1468142857435442', 1, 0, '', NULL, NULL, NULL),
(2666, '2016-07-10 17:27:37', NULL, NULL, 964, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 17:27:37', 'admin-1468135169-1468142857435442', 1, 1, 'SR', NULL, NULL, NULL),
(2667, '2016-07-10 17:27:37', NULL, NULL, 964, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 17:27:37', 'admin-1468135169-1468142857435442', 1, 1, 'SR', NULL, NULL, NULL),
(2668, '2016-07-10 17:58:42', NULL, NULL, 965, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 10.80, 1, '27', 1, '1468157241', 'admin', '2016-07-10 17:58:42', 'admin-1468135169-14681447220413487', 1, 0, '', NULL, '10.0', NULL),
(2669, '2016-07-10 18:08:37', NULL, NULL, 966, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 18:08:37', 'admin-1468135169-14681453175833637', 1, 1, 'SR', NULL, NULL, NULL),
(2670, '2016-07-10 18:08:37', NULL, NULL, 966, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 18:08:37', 'admin-1468135169-14681453175833637', 1, 1, 'SR', NULL, NULL, NULL),
(2671, '2016-07-10 18:08:37', NULL, NULL, 966, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 18:08:37', 'admin-1468135169-14681453175833637', 1, 1, 'SR', NULL, NULL, NULL),
(2672, '2016-07-10 18:08:37', NULL, NULL, 966, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 18:08:37', 'admin-1468135169-14681453175833637', 1, 1, 'SR', NULL, NULL, NULL),
(2673, '2016-07-10 18:20:08', NULL, NULL, 967, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 18:20:08', 'admin-1468135169-14681460086016039', 1, 1, 'SR', NULL, NULL, NULL),
(2674, '2016-07-10 18:32:57', NULL, NULL, 968, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 18:32:57', 'admin-1468135169-14681467768859284', 1, 1, 'SR', NULL, NULL, NULL),
(2675, '2016-07-10 18:32:57', NULL, NULL, 968, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 18:32:57', 'admin-1468135169-14681467768859284', 1, 1, 'SR', NULL, NULL, NULL),
(2676, '2016-07-10 19:05:19', NULL, NULL, 970, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 19:05:19', 'admin-1468135169-1468148719405629', 1, 1, 'SR', NULL, NULL, NULL),
(2677, '2016-07-10 19:05:19', NULL, NULL, 970, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 19:05:19', 'admin-1468135169-1468148719405629', 1, 1, 'SR', NULL, NULL, NULL),
(2678, '2016-07-10 19:06:04', NULL, NULL, 970, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 19:06:04', 'admin-1468135169-14681487638747034', 1, 0, '', NULL, NULL, NULL),
(2679, '2016-07-10 19:25:23', NULL, NULL, 971, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 19:25:23', 'admin-1468135169-14681499235351525', 1, 1, 'SR', NULL, NULL, NULL),
(2680, '2016-07-10 19:25:23', NULL, NULL, 971, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 19:25:23', 'admin-1468135169-14681499235351525', 1, 1, 'SR', NULL, NULL, NULL),
(2681, '2016-07-10 20:13:13', NULL, NULL, 972, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 20:13:13', 'admin-1468135169-14681527934487771', 1, 1, 'SR', NULL, NULL, NULL),
(2682, '2016-07-10 15:49:00', NULL, NULL, 962, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 15:49:00', 'admin-1468135169-1468136940573551', 1, 0, '', NULL, NULL, NULL),
(2683, '2016-07-10 15:21:38', NULL, NULL, 958, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 15:21:38', 'admin-1468135169-14681352981354678', 1, 1, 'SR', NULL, NULL, NULL),
(2684, '2016-07-10 15:21:38', NULL, NULL, 958, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 15:21:38', 'admin-1468135169-14681352981354678', 1, 1, 'SR', NULL, NULL, NULL),
(2685, '2016-07-10 15:38:04', NULL, NULL, 959, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 15:38:04', 'admin-1468135169-14681362840532964', 1, 1, 'SR', NULL, NULL, NULL),
(2686, '2016-07-10 15:49:00', NULL, NULL, 962, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 15:49:00', 'admin-1468135169-1468136940573551', 1, 1, 'SR', NULL, NULL, NULL),
(2687, '2016-07-10 14:03:52', NULL, NULL, 949, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:03:52', 'admin-1468124266-1468130632554224', 1, 0, '', NULL, NULL, NULL),
(2688, '2016-07-10 14:04:51', NULL, NULL, 950, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:04:51', 'admin-1468124266-14681306910585575', 1, 1, 'SR', NULL, NULL, NULL),
(2689, '2016-07-10 14:04:51', NULL, NULL, 950, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:04:51', 'admin-1468124266-14681306910585575', 1, 1, 'SR', NULL, NULL, NULL),
(2690, '2016-07-10 14:14:54', NULL, NULL, 951, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:14:54', 'admin-1468124266-14681312941177666', 1, 0, '', NULL, NULL, NULL),
(2691, '2016-07-10 14:14:54', NULL, NULL, 951, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:14:54', 'admin-1468124266-14681312941177666', 1, 1, 'SR', NULL, NULL, NULL),
(2692, '2016-07-10 14:14:54', NULL, NULL, 951, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:14:54', 'admin-1468124266-14681312941177666', 1, 1, 'SR', NULL, NULL, NULL),
(2693, '2016-07-10 14:26:19', NULL, NULL, 952, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:26:19', 'admin-1468124266-14681319794852258', 1, 1, 'SR', NULL, NULL, NULL),
(2694, '2016-07-10 14:26:19', NULL, NULL, 952, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:26:19', 'admin-1468124266-14681319794852258', 1, 1, 'SR', NULL, '0.0', NULL),
(2695, '2016-07-10 14:26:48', NULL, NULL, 952, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:26:48', 'admin-1468124266-1468132007841610', 1, 1, 'SR', NULL, NULL, NULL),
(2696, '2016-07-10 14:28:09', NULL, NULL, 953, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:28:09', 'admin-1468124266-1468132089152865', 1, 1, 'SR', NULL, NULL, NULL),
(2697, '2016-07-10 14:48:31', NULL, NULL, 954, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:48:31', 'admin-1468124266-1468133311277421', 1, 0, '', NULL, NULL, NULL),
(2698, '2016-07-10 14:48:31', NULL, NULL, 954, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:48:31', 'admin-1468124266-1468133311277421', 1, 1, 'SR', NULL, NULL, NULL),
(2699, '2016-07-10 14:48:31', NULL, NULL, 954, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:48:31', 'admin-1468124266-1468133311277421', 1, 1, 'SR', NULL, NULL, NULL),
(2700, '2016-07-10 14:55:22', NULL, NULL, 955, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:55:22', 'admin-1468124266-14681337224921524', 1, 0, '', NULL, NULL, NULL),
(2701, '2016-07-10 14:55:22', NULL, NULL, 955, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:55:22', 'admin-1468124266-14681337224921524', 1, 1, 'SR', NULL, NULL, NULL),
(2702, '2016-07-10 14:55:22', NULL, NULL, 955, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:55:22', 'admin-1468124266-14681337224921524', 1, 1, 'SR', NULL, NULL, NULL),
(2703, '2016-07-10 14:57:26', NULL, NULL, 955, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:57:26', 'admin-1468124266-14681338462058497', 1, 1, 'SR', NULL, NULL, NULL),
(2704, '2016-07-10 14:57:26', NULL, NULL, 955, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:57:26', 'admin-1468124266-14681338462058497', 1, 1, 'SR', NULL, NULL, NULL),
(2705, '2016-07-10 14:57:26', NULL, NULL, 955, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:57:26', 'admin-1468124266-14681338462058497', 1, 1, 'SR', NULL, NULL, NULL),
(2706, '2016-07-10 14:57:46', NULL, NULL, 955, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:57:46', 'admin-1468133856-14681338665983736', 1, 1, 'SR', NULL, NULL, NULL),
(2707, '2016-07-10 15:19:09', NULL, NULL, 956, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 15:19:09', 'admin-1468133856-14681351496492589', 1, 1, 'SR', NULL, NULL, NULL),
(2708, '2016-07-10 15:19:09', NULL, NULL, 956, 0, 187, '122', 'Iced Tea ', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 15:19:09', 'admin-1468133856-14681351496492589', 1, 0, '', NULL, NULL, NULL),
(2709, '2016-07-10 15:19:24', NULL, NULL, 957, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 15:19:24', 'admin-1468133856-14681351640529474', 1, 1, 'SR', NULL, NULL, '10.0'),
(2710, '2016-07-10 15:19:24', NULL, NULL, 957, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 15:19:24', 'admin-1468133856-14681351640529474', 1, 0, '', NULL, NULL, '10.0'),
(2711, '2016-07-10 15:21:38', NULL, NULL, 958, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 15:21:38', 'admin-1468135169-14681352981354678', 1, 0, '', NULL, NULL, NULL),
(2712, '2016-07-10 15:21:38', NULL, NULL, 958, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 15:21:38', 'admin-1468135169-14681352981354678', 1, 0, '', NULL, NULL, NULL),
(2713, '2016-07-10 15:21:38', NULL, NULL, 958, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 15:21:38', 'admin-1468135169-14681352981354678', 1, 1, 'SR', NULL, NULL, NULL),
(2714, '2016-07-10 15:21:38', NULL, NULL, 958, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 15:21:38', 'admin-1468135169-14681352981354678', 1, 1, 'SR', NULL, NULL, NULL),
(2715, '2016-07-10 13:33:49', NULL, NULL, 948, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 13:33:49', 'admin-1468124266-14681288293138664', 1, 0, '', NULL, NULL, NULL),
(2716, '2016-07-10 14:03:52', NULL, NULL, 949, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:03:52', 'admin-1468124266-1468130632554224', 1, 1, 'SR', NULL, NULL, NULL),
(2717, '2016-07-10 14:03:52', NULL, NULL, 949, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:03:52', 'admin-1468124266-1468130632554224', 1, 1, 'SR', NULL, NULL, NULL),
(2718, '2016-07-10 13:33:49', NULL, NULL, 948, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 13:33:49', 'admin-1468124266-14681288293138664', 1, 0, '', NULL, NULL, NULL),
(2719, '2016-07-10 13:33:49', NULL, NULL, 948, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 13:33:49', 'admin-1468124266-14681288293138664', 1, 1, 'SR', NULL, NULL, NULL),
(2720, '2016-07-10 13:28:04', NULL, NULL, 947, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 13:28:04', 'admin-1468124266-14681284838401062', 1, 1, 'SR', NULL, NULL, NULL),
(2721, '2016-07-10 13:30:51', NULL, NULL, 945, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 13:30:51', 'admin-1468124266-14681286516158153', 1, 0, '', NULL, NULL, NULL),
(2722, '2016-07-10 13:30:51', NULL, NULL, 945, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 13:30:51', 'admin-1468124266-14681286516158153', 1, 0, '', NULL, NULL, NULL),
(2723, '2016-07-10 14:45:58', NULL, NULL, 946, 0, 181, '116', 'Open Food ', 'dumpling 8pcs', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 14:45:58', 'admin-1468124266-14681331578246229', 1, 0, '', NULL, NULL, NULL),
(2724, '2016-07-10 12:38:44', NULL, NULL, 945, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 12:38:44', 'admin-1468124266-14681255245159635', 1, 0, '', NULL, NULL, NULL),
(2725, '2016-07-10 12:38:44', NULL, NULL, 945, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 12:38:44', 'admin-1468124266-14681255245159635', 1, 1, 'SR', NULL, NULL, NULL),
(2726, '2016-07-10 12:38:44', NULL, NULL, 945, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 12:38:44', 'admin-1468124266-14681255245159635', 1, 1, 'SR', NULL, NULL, NULL),
(2727, '2016-07-10 13:00:30', NULL, NULL, 946, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 13:00:30', 'admin-1468124266-14681268307206165', 1, 1, 'SR', NULL, NULL, NULL),
(2728, '2016-07-10 13:00:30', NULL, NULL, 946, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 13:00:30', 'admin-1468124266-14681268307206165', 1, 1, 'SR', NULL, NULL, NULL),
(2729, '2016-07-10 13:00:30', NULL, NULL, 946, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 13:00:30', 'admin-1468124266-14681268307206165', 1, 1, 'SR', NULL, NULL, NULL),
(2730, '2016-07-10 12:18:10', NULL, NULL, 944, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 12:18:11', 'admin-1468124266-14681242908039042', 1, 0, '', NULL, NULL, NULL),
(2731, '2016-07-10 11:41:33', NULL, NULL, 936, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'Staff', '2016-07-10 11:41:33', 'Staff-1468121744-1468122093753186', 1, 1, 'SR', NULL, NULL, NULL),
(2732, '2016-07-10 12:18:11', NULL, NULL, 944, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 12:18:11', 'admin-1468124266-14681242908039042', 1, 1, 'SR', NULL, NULL, NULL),
(2733, '2016-07-10 11:41:33', NULL, NULL, 936, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468157241', 'Staff', '2016-07-10 11:41:33', 'Staff-1468121744-1468122093753186', 1, 1, 'SR', NULL, NULL, NULL),
(2734, '2016-07-10 11:50:12', NULL, NULL, 937, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468157241', 'Staff', '2016-07-10 11:50:12', 'Staff-1468121744-14681226124178616', 1, 1, 'SR', NULL, NULL, NULL),
(2735, '2016-07-10 11:51:06', NULL, NULL, 938, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468157241', 'Staff', '2016-07-10 11:51:06', 'Staff-1468121744-14681226661786546', 1, 1, 'SR', 1, NULL, NULL),
(2736, '2016-07-10 11:52:10', NULL, NULL, 940, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468157241', 'Staff', '2016-07-10 11:52:10', 'Staff-1468121744-14681227304008926', 1, 1, 'SR', 1, NULL, NULL),
(2737, '2016-07-10 12:10:18', NULL, NULL, 941, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468157241', 'Staff', '2016-07-10 12:10:18', 'Staff-1468121744-14681238177771610', 1, 1, 'SR', NULL, NULL, NULL),
(2738, '2016-07-10 12:10:18', NULL, NULL, 941, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'Staff', '2016-07-10 12:10:18', 'Staff-1468121744-14681238177771610', 1, 1, 'SR', NULL, NULL, NULL),
(2739, '2016-07-10 12:10:18', NULL, NULL, 941, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468157241', 'Staff', '2016-07-10 12:10:18', 'Staff-1468121744-14681238177771610', 1, 1, 'SR', NULL, NULL, NULL),
(2740, '2016-07-10 12:10:46', NULL, NULL, 941, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'Staff', '2016-07-10 12:10:46', 'Staff-1468121744-14681238466971075', 1, 1, 'SR', NULL, NULL, NULL),
(2741, '2016-07-10 12:12:01', NULL, NULL, 942, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468157241', 'Staff', '2016-07-10 12:12:01', 'Staff-1468121744-1468123920795936', 1, 1, 'SR', NULL, NULL, NULL),
(2742, '2016-07-10 12:12:01', NULL, NULL, 942, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468157241', 'Staff', '2016-07-10 12:12:01', 'Staff-1468121744-1468123920795936', 1, 1, 'SR', NULL, NULL, NULL),
(2743, '2016-07-10 12:17:08', NULL, NULL, 943, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468157241', 'Staff', '2016-07-10 12:17:08', 'Staff-1468121744-14681242278839256', 1, 0, '', NULL, NULL, NULL),
(2744, '2016-07-10 12:17:08', NULL, NULL, 943, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468157241', 'Staff', '2016-07-10 12:17:08', 'Staff-1468121744-14681242278839256', 1, 1, 'SR', NULL, NULL, NULL),
(2745, '2016-07-10 10:44:48', NULL, NULL, 932, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 10:44:48', 'admin-1468110352-14681186884354152', 1, 0, '', NULL, NULL, NULL),
(2746, '2016-07-10 10:08:59', NULL, NULL, 929, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 10:08:59', 'admin-1468110352-14681165391195281', 1, 1, 'SR', NULL, NULL, NULL),
(2747, '2016-07-10 10:08:59', NULL, NULL, 929, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 10:08:59', 'admin-1468110352-14681165391195281', 1, 1, 'SR', NULL, NULL, NULL),
(2748, '2016-07-10 10:09:33', NULL, NULL, 930, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 10:09:33', 'admin-1468110352-14681165733047252', 1, 0, '', NULL, NULL, NULL),
(2749, '2016-07-10 10:09:33', NULL, NULL, 930, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 10:09:33', 'admin-1468110352-14681165733047252', 1, 0, '', NULL, NULL, NULL),
(2750, '2016-07-10 10:09:33', NULL, NULL, 930, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 10:09:33', 'admin-1468110352-14681165733047252', 1, 1, 'SR', NULL, NULL, NULL),
(2751, '2016-07-10 10:09:33', NULL, NULL, 930, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 10:09:33', 'admin-1468110352-14681165733047252', 1, 1, 'SR', NULL, NULL, NULL),
(2752, '2016-07-10 10:17:40', NULL, NULL, 931, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 10:17:40', 'admin-1468110352-14681170598647725', 1, 0, '', NULL, NULL, NULL),
(2753, '2016-07-10 10:17:40', NULL, NULL, 931, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 10:17:40', 'admin-1468110352-14681170598647725', 1, 0, '', NULL, NULL, NULL),
(2754, '2016-07-10 10:44:48', NULL, NULL, 932, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 10:44:48', 'admin-1468110352-14681186884354152', 1, 0, '', NULL, NULL, NULL),
(2755, '2016-07-10 10:44:48', NULL, NULL, 932, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 10:44:48', 'admin-1468110352-14681186884354152', 1, 1, 'SR', NULL, NULL, NULL),
(2756, '2016-07-10 10:44:48', NULL, NULL, 932, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 10:44:48', 'admin-1468110352-14681186884354152', 1, 1, 'SR', NULL, NULL, NULL),
(2757, '2016-07-10 10:57:17', NULL, NULL, 933, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 10:57:17', 'admin-1468110352-1468119437305289', 1, 1, 'SR', NULL, NULL, NULL),
(2758, '2016-07-10 10:57:17', NULL, NULL, 933, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 10:57:17', 'admin-1468110352-1468119437305289', 1, 1, 'SR', NULL, NULL, NULL),
(2759, '2016-07-10 11:02:33', NULL, NULL, 926, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 11:02:33', 'admin-1468110352-14681197534841120', 1, 0, '', NULL, NULL, NULL),
(2760, '2016-07-10 11:03:50', NULL, NULL, 934, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 11:03:50', 'admin-1468110352-14681198300919223', 1, 0, '', NULL, NULL, NULL),
(2761, '2016-07-10 11:03:50', NULL, NULL, 934, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 11:03:50', 'admin-1468110352-14681198300919223', 1, 0, '', NULL, NULL, NULL),
(2762, '2016-07-10 11:03:59', NULL, NULL, 934, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 11:03:59', 'admin-1468110352-14681198394599063', 1, 1, 'SR', NULL, NULL, NULL),
(2763, '2016-07-10 11:03:59', NULL, NULL, 934, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 11:03:59', 'admin-1468110352-14681198394599063', 1, 1, 'SR', NULL, NULL, NULL),
(2764, '2016-07-10 11:35:34', NULL, NULL, 935, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 11:35:34', 'admin-1468110352-14681217347103293', 1, 0, '', NULL, NULL, NULL),
(2765, '2016-07-10 11:35:34', NULL, NULL, 935, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 11:35:34', 'admin-1468110352-14681217347103293', 1, 0, '', NULL, NULL, NULL),
(2766, '2016-07-10 11:35:34', NULL, NULL, 935, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 11:35:34', 'admin-1468110352-14681217347103293', 1, 1, 'SR', NULL, NULL, NULL),
(2767, '2016-07-10 11:35:34', NULL, NULL, 935, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 11:35:34', 'admin-1468110352-14681217347103293', 1, 1, 'SR', NULL, NULL, NULL),
(2768, '2016-07-10 11:37:30', NULL, NULL, 936, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468157241', 'Staff', '2016-07-10 11:37:30', 'Staff-1468121744-14681218499783698', 1, 0, '', NULL, NULL, NULL),
(2769, '2016-07-10 11:37:41', NULL, NULL, 932, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468157241', 'Staff', '2016-07-10 11:37:41', 'Staff-1468121744-1468121861096443', 1, 0, '', NULL, NULL, NULL),
(2770, '2016-07-10 11:39:03', NULL, NULL, 936, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468157241', 'Staff', '2016-07-10 11:39:03', 'Staff-1468121744-14681219429274079', 1, 0, '', NULL, NULL, NULL),
(2771, '2016-07-10 10:05:51', NULL, NULL, 928, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 10:05:51', 'admin-1468110352-14681163514213849', 1, 0, '', NULL, NULL, NULL),
(2772, '2016-07-10 10:05:51', NULL, NULL, 928, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 10:05:51', 'admin-1468110352-14681163514213849', 1, 1, 'SR', NULL, NULL, NULL),
(2773, '2016-07-10 10:05:51', NULL, NULL, 928, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 10:05:51', 'admin-1468110352-14681163514213849', 1, 0, '', NULL, NULL, NULL),
(2774, '2016-07-10 09:24:25', NULL, NULL, 926, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 09:24:25', 'admin-1468110352-14681138650809526', 1, 1, 'SR', NULL, NULL, NULL),
(2775, '2016-07-10 09:32:02', NULL, NULL, 927, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 09:32:02', 'admin-1468110352-14681143223091290', 1, 0, '', NULL, NULL, NULL),
(2776, '2016-07-10 09:37:22', NULL, NULL, 927, 0, 154, '88', 'House BLT', 'bacon change to sausage', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 09:37:22', 'admin-1468110352-14681146420735753', 1, 0, '', NULL, NULL, NULL),
(2777, '2016-07-10 09:37:22', NULL, NULL, 927, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 09:37:22', 'admin-1468110352-14681146420735753', 1, 1, 'SR', NULL, NULL, NULL),
(2778, '2016-07-10 09:37:22', NULL, NULL, 927, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 09:37:22', 'admin-1468110352-14681146420735753', 1, 0, '', NULL, NULL, NULL),
(2779, '2016-07-10 09:37:50', NULL, NULL, 927, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 09:37:50', 'admin-1468110352-14681146701529181', 1, 0, '', NULL, NULL, NULL),
(2780, '2016-07-10 10:05:51', NULL, NULL, 928, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 10:05:51', 'admin-1468110352-14681163514213849', 1, 0, '', NULL, NULL, NULL),
(2781, '2016-07-10 10:05:51', NULL, NULL, 928, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 10:05:51', 'admin-1468110352-14681163514213849', 1, 1, 'SR', NULL, NULL, NULL),
(2782, '2016-07-10 09:24:25', NULL, NULL, 926, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468157241', 'admin', '2016-07-10 09:24:25', 'admin-1468110352-14681138650809526', 1, 1, 'SR', NULL, NULL, NULL),
(2783, '2016-07-11 19:43:56', NULL, NULL, 992, 0, 197, '132', 'Dinner - Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 19:43:56', 'admin-1468231244-14682374366464496', 1, 0, '', NULL, NULL, NULL),
(2784, '2016-07-11 19:40:12', NULL, NULL, 992, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 19:40:12', 'admin-1468231244-14682372126066485', 1, 0, '', NULL, NULL, NULL),
(2785, '2016-07-11 19:43:56', NULL, NULL, 992, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 19:43:56', 'admin-1468231244-14682374366464496', 1, 0, '', NULL, NULL, NULL),
(2786, '2016-07-11 19:40:12', NULL, NULL, 992, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 19:40:12', 'admin-1468231244-14682372126066485', 1, 0, '', NULL, NULL, NULL),
(2787, '2016-07-11 19:40:12', NULL, NULL, 992, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 19:40:12', 'admin-1468231244-14682372126066485', 1, 1, 'SR', NULL, NULL, NULL),
(2788, '2016-07-11 19:40:12', NULL, NULL, 992, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 19:40:12', 'admin-1468231244-14682372126066485', 1, 1, 'SR', NULL, NULL, NULL),
(2789, '2016-07-11 19:43:56', NULL, NULL, 992, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 19:43:56', 'admin-1468231244-14682374366464496', 1, 0, '', NULL, NULL, NULL),
(2790, '2016-07-11 14:40:57', NULL, NULL, 986, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 14:40:57', 'admin-1468198485-14682192568067771', 1, 0, '', 1, NULL, NULL),
(2791, '2016-07-11 14:43:56', NULL, NULL, 987, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 14:43:56', 'admin-1468198485-14682194368015699', 1, 1, 'SR', NULL, NULL, NULL),
(2792, '2016-07-11 14:44:18', NULL, NULL, 987, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 14:44:18', 'admin-1468198485-1468219458092587', 1, 1, 'SR', NULL, NULL, NULL),
(2793, '2016-07-11 15:01:59', NULL, NULL, 987, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 15:01:59', 'admin-1468198485-14682205195726096', 1, 1, 'SR', NULL, NULL, NULL),
(2794, '2016-07-11 15:06:32', NULL, NULL, 988, NULL, 84, '84', 'Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 15:06:32', 'admin-1468198485-14682207926563946', 1, 1, 'SR', NULL, NULL, NULL),
(2795, '2016-07-11 15:06:32', NULL, NULL, 988, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 15:06:32', 'admin-1468198485-14682207926563946', 1, 0, '', NULL, NULL, NULL),
(2796, '2016-07-11 15:39:46', NULL, NULL, 987, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 15:39:46', 'admin-1468198485-14682227862665283', 1, 1, 'SR', NULL, NULL, NULL),
(2797, '2016-07-11 15:40:11', NULL, NULL, 985, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 15:40:11', 'admin-1468198485-14682228113207295', 1, 1, 'SR', NULL, NULL, NULL),
(2798, '2016-07-11 15:40:11', NULL, NULL, 985, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 15:40:11', 'admin-1468198485-14682228113207295', 1, 1, 'SR', NULL, NULL, NULL),
(2799, '2016-07-11 15:40:21', NULL, NULL, 987, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 15:40:21', 'admin-1468198485-1468222821304134', 1, 1, 'SR', NULL, NULL, NULL),
(2800, '2016-07-11 17:44:39', NULL, NULL, 989, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 17:44:39', 'admin-1468230265-14682302797362239', 1, 0, '', 1, NULL, NULL),
(2801, '2016-07-11 18:00:59', NULL, NULL, 990, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 18:00:59', 'admin-1468231244-14682312594456312', 1, 1, 'SR', 1, NULL, NULL),
(2802, '2016-07-11 18:00:59', NULL, NULL, 990, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 18:00:59', 'admin-1468231244-14682312594456312', 1, 1, 'SR', 1, NULL, NULL),
(2803, '2016-07-11 18:40:10', NULL, NULL, 991, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 18:40:10', 'admin-1468231244-1468233610354898', 1, 1, 'SR', 1, NULL, NULL),
(2804, '2016-07-11 19:40:12', NULL, NULL, 992, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 19:40:12', 'admin-1468231244-14682372126066485', 1, 0, '', NULL, NULL, NULL),
(2805, '2016-07-11 14:40:57', NULL, NULL, 986, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 14:40:57', 'admin-1468198485-14682192568067771', 1, 0, '', 1, NULL, NULL),
(2806, '2016-07-11 14:40:57', NULL, NULL, 986, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 14:40:57', 'admin-1468198485-14682192568067771', 1, 0, '', 1, NULL, NULL),
(2807, '2016-07-11 14:20:30', NULL, NULL, 984, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 14:20:30', 'admin-1468198485-14682180302827189', 1, 0, '', NULL, NULL, NULL),
(2808, '2016-07-11 14:09:29', NULL, NULL, 984, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 2, 14.00, 28.0000, 0.0000, 28.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 14:09:29', 'admin-1468198485-14682173689584984', 1, 1, 'SR', NULL, NULL, NULL),
(2809, '2016-07-11 14:09:29', NULL, NULL, 984, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 14:09:29', 'admin-1468198485-14682173689584984', 1, 1, 'SR', NULL, NULL, NULL),
(2810, '2016-07-11 14:09:29', NULL, NULL, 984, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 14:09:29', 'admin-1468198485-14682173689584984', 1, 1, 'SR', NULL, NULL, NULL),
(2811, '2016-07-11 14:07:55', NULL, NULL, 984, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 14:07:55', 'admin-1468198485-14682172751633242', 1, 0, '', NULL, NULL, NULL),
(2812, '2016-07-11 11:17:03', NULL, NULL, 978, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 11:17:03', 'admin-1468198485-14682070233275126', 1, 1, 'SR', 1, NULL, NULL),
(2813, '2016-07-11 11:56:14', NULL, NULL, 979, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 11:56:14', 'admin-1468198485-14682093741508835', 1, 0, '', NULL, NULL, NULL),
(2814, '2016-07-11 11:59:04', NULL, NULL, 979, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 11:59:04', 'admin-1468198485-1468209543997505', 1, 0, '', NULL, '0.0', NULL),
(2815, '2016-07-11 12:48:51', NULL, NULL, 979, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 12:48:51', 'admin-1468198485-14682125310108491', 1, 1, 'SR', NULL, NULL, NULL),
(2816, '2016-07-11 12:20:58', NULL, NULL, 979, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 12:20:58', 'admin-1468198485-14682108585588737', 1, 1, 'SR', NULL, NULL, NULL),
(2817, '2016-07-11 12:48:51', NULL, NULL, 979, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 12:48:51', 'admin-1468198485-14682125310108491', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(2818, '2016-07-11 12:53:32', NULL, NULL, 983, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 12:53:32', 'admin-1468198485-14682128121476397', 1, 1, 'SR', NULL, NULL, NULL),
(2819, '2016-07-11 14:05:50', NULL, NULL, 984, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 14:05:50', 'admin-1468198485-14682171500826037', 1, 1, 'SR', NULL, NULL, NULL),
(2820, '2016-07-11 14:05:50', NULL, NULL, 984, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 14:05:50', 'admin-1468198485-14682171500826037', 1, 1, 'SR', NULL, NULL, NULL),
(2821, '2016-07-11 14:07:55', NULL, NULL, 984, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 14:07:55', 'admin-1468198485-14682172751633242', 1, 1, 'SR', NULL, NULL, NULL),
(2822, '2016-07-11 12:25:18', NULL, NULL, 982, 0, 191, '126', 'Smoothie BOFO', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 12:25:18', 'admin-1468198485-14682111179651790', 1, 0, '', NULL, NULL, NULL),
(2823, '2016-07-11 12:25:18', NULL, NULL, 982, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 12:25:18', 'admin-1468198485-14682111179651790', 1, 0, '', NULL, NULL, NULL),
(2824, '2016-07-11 12:24:10', NULL, NULL, 981, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 12:24:10', 'admin-1468198485-14682110503489138', 1, 1, 'SR', NULL, NULL, NULL),
(2825, '2016-07-11 12:24:10', NULL, NULL, 981, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 12:24:10', 'admin-1468198485-14682110503489138', 1, 1, 'SR', NULL, NULL, NULL),
(2826, '2016-07-11 12:24:10', NULL, NULL, 981, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 12:24:10', 'admin-1468198485-14682110503489138', 1, 0, '', NULL, NULL, NULL),
(2827, '2016-07-11 12:24:10', NULL, NULL, 981, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 12:24:10', 'admin-1468198485-14682110503489138', 1, 1, 'SR', NULL, NULL, NULL),
(2828, '2016-07-11 12:21:16', NULL, NULL, 980, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 12:21:16', 'admin-1468198485-14682108767416374', 1, 1, 'SR', NULL, NULL, NULL),
(2829, '2016-07-11 12:21:16', NULL, NULL, 980, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 12:21:16', 'admin-1468198485-14682108767416374', 1, 1, 'SR', NULL, NULL, NULL),
(2830, '2016-07-11 12:21:16', NULL, NULL, 980, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 12:21:16', 'admin-1468198485-14682108767416374', 1, 1, 'SR', NULL, NULL, NULL),
(2831, '2016-07-11 10:49:20', NULL, NULL, 977, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 10:49:20', 'admin-1468198485-14682053600974630', 1, 0, '', NULL, NULL, NULL),
(2832, '2016-07-11 10:13:19', NULL, NULL, 976, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 10:13:19', 'admin-1468198485-14682031990022321', 1, 1, 'SR', NULL, NULL, NULL),
(2833, '2016-07-11 10:13:19', NULL, NULL, 976, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 10:13:19', 'admin-1468198485-14682031990022321', 1, 1, 'SR', NULL, NULL, NULL),
(2834, '2016-07-11 10:12:04', NULL, NULL, 976, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 10:12:04', 'admin-1468198485-1468203124787774', 1, 0, '', NULL, NULL, NULL),
(2835, '2016-07-11 10:12:04', NULL, NULL, 976, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 10:12:04', 'admin-1468198485-1468203124787774', 1, 0, '', NULL, NULL, NULL),
(2836, '2016-07-11 10:06:57', NULL, NULL, 975, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 10:06:57', 'admin-1468198485-14682028177384886', 1, 1, 'SR', 1, NULL, NULL),
(2837, '2016-07-11 09:28:30', NULL, NULL, 974, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 09:28:30', 'admin-1468198485-14682005103432754', 1, 1, 'SR', NULL, NULL, NULL),
(2838, '2016-07-11 09:28:30', NULL, NULL, 974, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 09:28:30', 'admin-1468198485-14682005103432754', 1, 0, '', NULL, NULL, NULL),
(2839, '2016-07-11 09:28:30', NULL, NULL, 974, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 09:28:30', 'admin-1468198485-14682005103432754', 1, 1, 'SR', NULL, NULL, NULL),
(2840, '2016-07-11 09:28:11', NULL, NULL, 974, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468243137', 'admin', '2016-07-11 09:28:11', 'admin-1468198485-14682004909256759', 1, 0, '', NULL, NULL, NULL),
(2841, '2016-07-12 19:30:35', NULL, NULL, 1012, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 19:30:35', 'admin-1468320886-14683230348049071', 1, 1, 'SR', NULL, NULL, NULL),
(2842, '2016-07-12 19:48:44', NULL, NULL, 1013, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 19:48:44', 'admin-1468320886-14683241244373063', 1, 1, 'SR', 1, NULL, NULL),
(2843, '2016-07-12 19:30:35', NULL, NULL, 1012, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 19:30:35', 'admin-1468320886-14683230348049071', 1, 1, 'SR', NULL, NULL, NULL),
(2844, '2016-07-12 18:55:04', NULL, NULL, 1011, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 18:55:04', 'admin-1468320886-14683209044168331', 1, 1, 'SR', NULL, NULL, NULL),
(2845, '2016-07-12 18:04:24', NULL, NULL, 1010, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 18:04:24', 'admin-1468317803-14683178645484750', 1, 1, 'SR', NULL, NULL, NULL),
(2846, '2016-07-12 18:04:24', NULL, NULL, 1010, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 18:04:24', 'admin-1468317803-14683178645484750', 1, 1, 'SR', NULL, NULL, NULL),
(2847, '2016-07-12 18:04:24', NULL, NULL, 1010, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 18:04:24', 'admin-1468317803-14683178645484750', 1, 1, 'SR', NULL, NULL, NULL),
(2848, '2016-07-12 18:04:24', NULL, NULL, 1010, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 18:04:24', 'admin-1468317803-14683178645484750', 1, 1, 'SR', NULL, NULL, NULL),
(2849, '2016-07-12 18:04:24', NULL, NULL, 1010, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 18:04:24', 'admin-1468317803-14683178645484750', 1, 1, 'SR', NULL, NULL, NULL),
(2850, '2016-07-12 17:18:02', NULL, NULL, 1009, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 17:18:02', 'admin-1468315063-14683150823021599', 1, 1, 'SR', NULL, NULL, NULL),
(2851, '2016-07-12 15:52:30', NULL, NULL, 1007, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 15:52:30', 'admin-1468285631-1468309950027841', 1, 1, 'SR', 1, NULL, NULL),
(2852, '2016-07-12 15:33:16', NULL, NULL, 1006, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 15:33:16', 'admin-1468285631-14683087967139615', 1, 0, '', NULL, NULL, NULL),
(2853, '2016-07-12 15:14:06', NULL, NULL, 1005, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 15:14:06', 'admin-1468285631-14683076460149624', 1, 0, '', NULL, NULL, NULL),
(2854, '2016-07-12 15:14:06', NULL, NULL, 1005, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 15:14:06', 'admin-1468285631-14683076460149624', 1, 1, 'SR', NULL, NULL, NULL),
(2855, '2016-07-12 14:55:14', NULL, NULL, 1004, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 14:55:14', 'admin-1468285631-14683065140896242', 1, 1, 'SR', NULL, NULL, NULL),
(2856, '2016-07-12 14:55:14', NULL, NULL, 1004, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 14:55:14', 'admin-1468285631-14683065140896242', 1, 1, 'SR', NULL, NULL, NULL),
(2857, '2016-07-12 14:54:57', NULL, NULL, 1004, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 14:54:57', 'admin-1468285631-14683064975631737', 1, 0, '', NULL, NULL, NULL),
(2858, '2016-07-12 14:52:06', NULL, NULL, 1001, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 14:52:06', 'admin-1468285631-14683063267245793', 1, 1, 'SR', NULL, NULL, NULL),
(2859, '2016-07-12 14:47:00', NULL, NULL, 1001, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 14:47:00', 'admin-1468285631-14683060198341613', 1, 1, 'SR', NULL, NULL, NULL),
(2860, '2016-07-12 14:35:14', NULL, NULL, 1003, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 14:35:14', 'admin-1468285631-14683053147351261', 1, 0, '', NULL, NULL, NULL),
(2861, '2016-07-12 14:35:14', NULL, NULL, 1003, 0, 181, '116', 'Open Food ', 'EGG', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 14:35:14', 'admin-1468285631-14683053147351261', 1, 0, '', NULL, NULL, NULL),
(2862, '2016-07-12 13:35:11', NULL, NULL, 1000, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 13:35:11', 'admin-1468285631-14683017115235828', 1, 1, 'SR', NULL, NULL, NULL),
(2863, '2016-07-12 12:30:28', NULL, NULL, 997, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 12:30:28', 'admin-1468285631-14682978287625468', 1, 1, 'SR', NULL, NULL, NULL),
(2864, '2016-07-12 14:35:14', NULL, NULL, 1003, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 14:35:14', 'admin-1468285631-14683053147351261', 1, 1, 'SR', NULL, NULL, NULL),
(2865, '2016-07-12 14:32:46', NULL, NULL, 1002, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 14:32:46', 'admin-1468285631-14683051666832481', 1, 1, 'SR', NULL, NULL, NULL),
(2866, '2016-07-12 14:32:46', NULL, NULL, 1002, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 14:32:46', 'admin-1468285631-14683051666832481', 1, 1, 'SR', NULL, NULL, NULL),
(2867, '2016-07-12 14:32:46', NULL, NULL, 1002, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 14:32:46', 'admin-1468285631-14683051666832481', 1, 1, 'SR', NULL, NULL, NULL),
(2868, '2016-07-12 14:13:19', NULL, NULL, 1001, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 14:13:19', 'admin-1468285631-14683039992316113', 1, 1, 'SR', NULL, NULL, NULL),
(2869, '2016-07-12 12:40:59', NULL, NULL, 998, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 12:40:59', 'admin-1468285631-14682984594802717', 1, 1, 'SR', NULL, NULL, NULL),
(2870, '2016-07-12 12:40:59', NULL, NULL, 998, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 12:40:59', 'admin-1468285631-14682984594802717', 1, 1, 'SR', NULL, NULL, NULL),
(2871, '2016-07-12 12:40:59', NULL, NULL, 998, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 12:40:59', 'admin-1468285631-14682984594802717', 1, 1, 'SR', NULL, NULL, NULL),
(2872, '2016-07-12 13:34:08', NULL, NULL, 1000, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 13:34:08', 'admin-1468285631-14683016481324816', 1, 1, 'SR', NULL, NULL, NULL),
(2873, '2016-07-12 13:35:11', NULL, NULL, 1000, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 13:35:11', 'admin-1468285631-14683017115235828', 1, 1, 'SR', NULL, NULL, NULL),
(2874, '2016-07-12 13:15:47', NULL, NULL, 999, NULL, 65, '65', 'Pineapple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 13:15:47', 'admin-1468285631-14683005474938169', 1, 1, 'SR', NULL, NULL, NULL),
(2875, '2016-07-12 13:15:47', NULL, NULL, 999, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 13:15:47', 'admin-1468285631-14683005474938169', 1, 1, 'SR', NULL, NULL, NULL),
(2876, '2016-07-12 13:15:39', NULL, NULL, 999, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 13:15:39', 'admin-1468285631-14683005388034125', 1, 0, '', NULL, NULL, NULL),
(2877, '2016-07-12 13:34:08', NULL, NULL, 1000, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 13:34:08', 'admin-1468285631-14683016481324816', 1, 1, 'SR', NULL, NULL, NULL),
(2878, '2016-07-12 13:15:39', NULL, NULL, 999, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 13:15:39', 'admin-1468285631-14683005388034125', 1, 0, '', NULL, NULL, NULL),
(2879, '2016-07-12 13:13:48', NULL, NULL, 998, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 13:13:48', 'admin-1468285631-14683004282312075', 1, 0, '', NULL, NULL, NULL),
(2880, '2016-07-12 12:40:59', NULL, NULL, 998, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 12:40:59', 'admin-1468285631-14682984594802717', 1, 1, 'SR', NULL, NULL, NULL),
(2881, '2016-07-12 12:30:02', NULL, NULL, 996, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 12:30:02', 'admin-1468285631-14682978022751483', 1, 1, 'SR', NULL, NULL, NULL),
(2882, '2016-07-12 12:30:02', NULL, NULL, 996, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 12:30:02', 'admin-1468285631-14682978022751483', 1, 1, 'SR', NULL, NULL, NULL),
(2883, '2016-07-12 12:18:06', NULL, NULL, 995, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 12:18:06', 'admin-1468285631-14682970865494990', 1, 1, 'SR', NULL, NULL, NULL),
(2884, '2016-07-12 12:18:06', NULL, NULL, 995, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 12:18:06', 'admin-1468285631-14682970865494990', 1, 1, 'SR', NULL, NULL, NULL),
(2885, '2016-07-12 12:18:06', NULL, NULL, 995, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 12:18:06', 'admin-1468285631-14682970865494990', 1, 1, 'SR', NULL, NULL, NULL),
(2886, '2016-07-12 09:09:58', NULL, NULL, 993, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 09:09:58', 'admin-1468285631-14682857981603597', 1, 0, '', NULL, NULL, '10.0'),
(2887, '2016-07-12 09:09:58', NULL, NULL, 993, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 09:09:58', 'admin-1468285631-14682857981603597', 1, 1, 'SR', NULL, NULL, '10.0'),
(2888, '2016-07-12 11:11:51', NULL, NULL, 994, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 11:11:51', 'admin-1468285631-1468293111159915', 1, 1, 'SR', NULL, NULL, NULL),
(2889, '2016-07-12 11:11:51', NULL, NULL, 994, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 11:11:51', 'admin-1468285631-1468293111159915', 1, 1, 'SR', NULL, NULL, NULL),
(2890, '2016-07-12 09:09:58', NULL, NULL, 993, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468325176', 'admin', '2016-07-12 09:09:58', 'admin-1468285631-14682857981603597', 1, 1, 'SR', NULL, NULL, '10.0'),
(2891, '2016-07-14 16:56:40', NULL, NULL, 1040, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468498624', 'Staff', '2016-07-14 16:56:40', 'Staff-1468479427-14684866007821810', 1, 1, 'SR', NULL, NULL, NULL),
(2892, '2016-07-14 18:18:35', NULL, NULL, 1041, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 18:18:35', 'admin-1468491446-14684915152583975', 1, 0, '', NULL, NULL, NULL),
(2893, '2016-07-14 18:18:35', NULL, NULL, 1041, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 18:18:35', 'admin-1468491446-14684915152583975', 1, 0, '', NULL, NULL, NULL),
(2894, '2016-07-14 18:18:35', NULL, NULL, 1041, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 18:18:35', 'admin-1468491446-14684915152583975', 1, 0, '', NULL, NULL, NULL),
(2895, '2016-07-14 18:20:30', NULL, NULL, 1042, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 18:20:30', 'admin-1468491446-14684916305109568', 1, 1, 'SR', NULL, NULL, NULL),
(2896, '2016-07-14 18:20:30', NULL, NULL, 1042, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 18:20:30', 'admin-1468491446-14684916305109568', 1, 1, 'SR', NULL, NULL, NULL),
(2897, '2016-07-14 18:20:30', NULL, NULL, 1042, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 18:20:30', 'admin-1468491446-14684916305109568', 1, 1, 'SR', NULL, NULL, NULL),
(2898, '2016-07-14 18:20:30', NULL, NULL, 1042, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 18:20:30', 'admin-1468491446-14684916305109568', 1, 1, 'SR', NULL, NULL, NULL),
(2899, '2016-07-14 18:42:35', NULL, NULL, 1043, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 18:42:35', 'admin-1468491446-14684929550615465', 1, 0, '', NULL, NULL, NULL),
(2900, '2016-07-14 18:42:35', NULL, NULL, 1043, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 18:42:35', 'admin-1468491446-14684929550615465', 1, 1, 'SR', NULL, NULL, NULL),
(2901, '2016-07-14 18:49:11', NULL, NULL, 1042, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 18:49:11', 'admin-1468491446-14684933511107616', 1, 1, 'SR', NULL, NULL, NULL),
(2902, '2016-07-14 16:49:27', NULL, NULL, 1039, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1468498624', 'Staff', '2016-07-14 16:49:27', 'Staff-1468479427-14684861676174960', 1, 1, 'SR', NULL, NULL, NULL),
(2903, '2016-07-14 16:49:27', NULL, NULL, 1039, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1468498624', 'Staff', '2016-07-14 16:49:27', 'Staff-1468479427-14684861676174960', 1, 1, 'SR', NULL, NULL, NULL),
(2904, '2016-07-14 16:17:14', NULL, NULL, 1038, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468498624', 'Staff', '2016-07-14 16:17:14', 'Staff-1468479427-14684842343115866', 1, 0, '', NULL, NULL, NULL),
(2905, '2016-07-14 15:17:57', NULL, NULL, 1036, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468498624', 'Staff', '2016-07-14 15:17:57', 'Staff-1468479427-14684806777841228', 1, 1, 'SR', NULL, NULL, NULL),
(2906, '2016-07-14 15:41:01', NULL, NULL, 1037, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468498624', 'Staff', '2016-07-14 15:41:01', 'Staff-1468479427-14684820613832095', 1, 0, '', NULL, NULL, NULL),
(2907, '2016-07-14 15:41:01', NULL, NULL, 1037, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468498624', 'Staff', '2016-07-14 15:41:01', 'Staff-1468479427-14684820613832095', 1, 1, 'SR', NULL, NULL, NULL),
(2908, '2016-07-14 16:17:14', NULL, NULL, 1038, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468498624', 'Staff', '2016-07-14 16:17:14', 'Staff-1468479427-14684842343115866', 1, 1, 'SR', NULL, NULL, NULL),
(2909, '2016-07-14 15:17:57', NULL, NULL, 1036, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468498624', 'Staff', '2016-07-14 15:17:57', 'Staff-1468479427-14684806777841228', 1, 1, 'SR', NULL, NULL, NULL),
(2910, '2016-07-14 15:00:04', NULL, NULL, 1035, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468498624', 'Staff', '2016-07-14 15:00:04', 'Staff-1468479427-14684796046466425', 1, 0, '', 1, NULL, NULL),
(2911, '2016-07-14 14:16:16', NULL, NULL, 1032, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468498624', 'Staff', '2016-07-14 14:16:16', 'Staff-1468473779-1468476976718891', 1, 0, '', NULL, NULL, NULL),
(2912, '2016-07-14 14:17:00', NULL, NULL, 1032, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468498624', 'Staff', '2016-07-14 14:17:00', 'Staff-1468473779-1468477020359348', 1, 1, 'SR', NULL, NULL, NULL),
(2913, '2016-07-14 14:22:33', NULL, NULL, 1033, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468498624', 'Staff', '2016-07-14 14:22:33', 'Staff-1468473779-14684773532629197', 1, 1, 'SR', NULL, NULL, '15.0'),
(2914, '2016-07-14 14:22:33', NULL, NULL, 1033, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468498624', 'Staff', '2016-07-14 14:22:33', 'Staff-1468473779-14684773532629197', 1, 1, 'SR', NULL, NULL, '15.0'),
(2915, '2016-07-14 14:57:33', NULL, NULL, 1034, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468498624', 'Staff', '2016-07-14 14:57:33', 'Staff-1468479427-14684794531449354', 1, 1, 'SR', NULL, NULL, NULL),
(2916, '2016-07-14 14:57:33', NULL, NULL, 1034, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468498624', 'Staff', '2016-07-14 14:57:33', 'Staff-1468479427-14684794531449354', 1, 0, '', NULL, NULL, NULL),
(2917, '2016-07-14 13:42:26', NULL, NULL, 1031, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1468498624', 'Staff', '2016-07-14 13:42:26', 'Staff-1468473779-14684749460023929', 1, 1, 'SR', 1, NULL, NULL),
(2918, '2016-07-14 13:23:10', NULL, NULL, 1030, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 8.10, 1, '27', 1, '1468498624', 'Staff', '2016-07-14 13:23:10', 'Staff-1468473779-14684737899353652', 1, 1, 'SR', NULL, '10.0', NULL),
(2919, '2016-07-14 13:23:10', NULL, NULL, 1030, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 6.30, 1, '27', 1, '1468498624', 'Staff', '2016-07-14 13:23:10', 'Staff-1468473779-14684737899353652', 1, 1, 'SR', NULL, '10.0', NULL),
(2920, '2016-07-14 13:23:10', NULL, NULL, 1030, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 6.30, 1, '27', 1, '1468498624', 'Staff', '2016-07-14 13:23:10', 'Staff-1468473779-14684737899353652', 1, 1, 'SR', NULL, '10.0', NULL),
(2921, '2016-07-14 13:14:07', NULL, NULL, 1024, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 13:14:07', 'admin-1468457720-14684732478134326', 1, 0, '', NULL, NULL, NULL),
(2922, '2016-07-14 13:05:20', NULL, NULL, 1029, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 13:05:20', 'admin-1468457720-14684727205382442', 1, 1, 'SR', NULL, NULL, NULL),
(2923, '2016-07-14 13:04:28', NULL, NULL, 1028, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 13:04:28', 'admin-1468457720-1468472668033130', 1, 0, '', NULL, NULL, NULL),
(2924, '2016-07-14 12:22:43', NULL, NULL, 1024, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 12:22:43', 'admin-1468457720-14684701628626028', 1, 1, 'SR', NULL, NULL, NULL),
(2925, '2016-07-14 13:03:49', NULL, NULL, 1027, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 13:03:49', 'admin-1468457720-14684726296248924', 1, 1, 'SR', NULL, NULL, NULL),
(2926, '2016-07-14 12:48:17', NULL, NULL, 1026, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 12:48:17', 'admin-1468457720-14684716969527270', 1, 0, '', NULL, NULL, NULL),
(2927, '2016-07-14 12:48:17', NULL, NULL, 1026, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 12:48:17', 'admin-1468457720-14684716969527270', 1, 0, '', NULL, NULL, NULL),
(2928, '2016-07-14 12:36:48', NULL, NULL, 1025, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 12:36:48', 'admin-1468457720-14684710085634334', 1, 1, 'SR', NULL, NULL, NULL),
(2929, '2016-07-14 12:36:48', NULL, NULL, 1025, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 12:36:48', 'admin-1468457720-14684710085634334', 1, 1, 'SR', NULL, NULL, NULL),
(2930, '2016-07-14 12:37:02', NULL, NULL, 1025, 0, 181, '116', 'Open Food ', 'bacon add on', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 12:37:02', 'admin-1468457720-14684710223847186', 1, 0, '', NULL, NULL, NULL),
(2931, '2016-07-14 12:48:17', NULL, NULL, 1026, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 12:48:17', 'admin-1468457720-14684716969527270', 1, 1, 'SR', NULL, NULL, NULL),
(2932, '2016-07-14 12:22:43', NULL, NULL, 1024, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 12:22:43', 'admin-1468457720-14684701628626028', 1, 1, 'SR', NULL, NULL, NULL),
(2933, '2016-07-14 12:19:05', NULL, NULL, 1023, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 12:19:05', 'admin-1468457720-14684699454374148', 1, 1, 'SR', NULL, NULL, NULL),
(2934, '2016-07-14 12:19:05', NULL, NULL, 1023, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 12:19:05', 'admin-1468457720-14684699454374148', 1, 1, 'SR', NULL, NULL, NULL),
(2935, '2016-07-14 12:19:05', NULL, NULL, 1023, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 12:19:05', 'admin-1468457720-14684699454374148', 1, 0, '', NULL, NULL, NULL),
(2936, '2016-07-14 11:00:59', NULL, NULL, 1019, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 11:00:59', 'admin-1468457720-14684652594617062', 1, 0, '', NULL, NULL, NULL),
(2937, '2016-07-14 11:02:36', NULL, NULL, 1020, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 11:02:36', 'admin-1468457720-14684653560436757', 1, 0, '', NULL, NULL, NULL),
(2938, '2016-07-14 11:02:36', NULL, NULL, 1020, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 11:02:36', 'admin-1468457720-14684653560436757', 1, 1, 'SR', NULL, NULL, NULL),
(2939, '2016-07-14 11:15:53', NULL, NULL, 1021, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 11:15:53', 'admin-1468457720-14684661529642187', 1, 0, '', NULL, NULL, NULL),
(2940, '2016-07-14 11:19:53', NULL, NULL, 1022, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 11:19:53', 'admin-1468457720-14684663931943178', 1, 1, 'SR', NULL, NULL, NULL),
(2941, '2016-07-14 11:19:53', NULL, NULL, 1022, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 11:19:53', 'admin-1468457720-14684663931943178', 1, 0, '', NULL, NULL, NULL),
(2942, '2016-07-14 11:02:36', NULL, NULL, 1020, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 11:02:36', 'admin-1468457720-14684653560436757', 1, 0, '', NULL, NULL, NULL),
(2943, '2016-07-14 11:02:36', NULL, NULL, 1020, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 11:02:36', 'admin-1468457720-14684653560436757', 1, 1, 'SR', NULL, NULL, NULL),
(2944, '2016-07-14 11:00:59', NULL, NULL, 1019, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 11:00:59', 'admin-1468457720-14684652594617062', 1, 0, '', NULL, NULL, NULL),
(2945, '2016-07-14 09:46:41', NULL, NULL, 1016, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 09:46:41', 'admin-1468457720-1468460801712886', 1, 0, '', NULL, NULL, NULL),
(2946, '2016-07-14 09:46:41', NULL, NULL, 1016, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 09:46:41', 'admin-1468457720-1468460801712886', 1, 0, '', NULL, NULL, NULL),
(2947, '2016-07-14 09:46:41', NULL, NULL, 1016, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 09:46:41', 'admin-1468457720-1468460801712886', 1, 0, '', NULL, NULL, NULL),
(2948, '2016-07-14 09:46:41', NULL, NULL, 1016, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 09:46:41', 'admin-1468457720-1468460801712886', 1, 0, '', NULL, NULL, NULL),
(2949, '2016-07-14 09:46:41', NULL, NULL, 1016, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 09:46:41', 'admin-1468457720-1468460801712886', 1, 0, '', NULL, NULL, NULL),
(2950, '2016-07-14 10:04:53', NULL, NULL, 1017, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 10:04:53', 'admin-1468457720-1468461893448667', 1, 0, '', NULL, NULL, NULL),
(2951, '2016-07-14 10:04:53', NULL, NULL, 1017, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 10:04:53', 'admin-1468457720-1468461893448667', 1, 1, 'SR', NULL, NULL, NULL),
(2952, '2016-07-14 10:30:04', NULL, NULL, 1018, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 13.50, 1, '27', 1, '1468498624', 'admin', '2016-07-14 10:30:04', 'admin-1468457720-14684634044211854', 1, 1, 'SR', NULL, '10.0', NULL),
(2953, '2016-07-14 11:00:59', NULL, NULL, 1019, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 11:00:59', 'admin-1468457720-14684652594617062', 1, 1, 'SR', NULL, NULL, NULL),
(2954, '2016-07-14 11:00:59', NULL, NULL, 1019, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 11:00:59', 'admin-1468457720-14684652594617062', 1, 1, 'SR', NULL, NULL, NULL),
(2955, '2016-07-14 09:46:41', NULL, NULL, 1016, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 09:46:41', 'admin-1468457720-1468460801712886', 1, 1, 'SR', NULL, NULL, NULL),
(2956, '2016-07-14 09:41:37', NULL, NULL, 1015, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 09:41:37', 'admin-1468457720-1468460497230337', 1, 1, 'SR', NULL, NULL, NULL),
(2957, '2016-07-14 09:46:41', NULL, NULL, 1016, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 09:46:41', 'admin-1468457720-1468460801712886', 1, 1, 'SR', NULL, NULL, NULL),
(2958, '2016-07-14 09:46:41', NULL, NULL, 1016, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 09:46:41', 'admin-1468457720-1468460801712886', 1, 1, 'SR', NULL, NULL, NULL),
(2959, '2016-07-14 09:46:41', NULL, NULL, 1016, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 09:46:41', 'admin-1468457720-1468460801712886', 1, 1, 'SR', NULL, NULL, NULL),
(2960, '2016-07-14 09:41:37', NULL, NULL, 1015, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 09:41:37', 'admin-1468457720-1468460497230337', 1, 1, 'SR', NULL, NULL, NULL),
(2961, '2016-07-14 09:41:37', NULL, NULL, 1015, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 09:41:37', 'admin-1468457720-1468460497230337', 1, 0, '', NULL, NULL, NULL),
(2962, '2016-07-14 09:14:31', NULL, NULL, 1014, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 09:14:31', 'admin-1468457720-14684588716534034', 1, 0, '', NULL, NULL, NULL),
(2963, '2016-07-14 09:41:37', NULL, NULL, 1015, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 09:41:37', 'admin-1468457720-1468460497230337', 1, 0, '', NULL, NULL, NULL),
(2964, '2016-07-14 09:14:31', NULL, NULL, 1014, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 09:14:31', 'admin-1468457720-14684588716534034', 1, 1, 'SR', NULL, NULL, NULL),
(2965, '2016-07-14 09:14:31', NULL, NULL, 1014, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 09:14:31', 'admin-1468457720-14684588716534034', 1, 1, 'SR', NULL, NULL, NULL),
(2966, '2016-07-14 09:14:31', NULL, NULL, 1014, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468498624', 'admin', '2016-07-14 09:14:31', 'admin-1468457720-14684588716534034', 1, 0, '', NULL, NULL, NULL),
(2967, '2016-07-15 19:41:10', NULL, NULL, 1069, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 19:41:10', 'admin-1468578455-14685828704693836', 1, 1, 'SR', NULL, NULL, NULL),
(2968, '2016-07-15 19:41:10', NULL, NULL, 1069, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 19:41:10', 'admin-1468578455-14685828704693836', 1, 0, '', NULL, NULL, NULL),
(2969, '2016-07-15 00:00:00', NULL, NULL, 1070, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 19:40:42', 'admin-1468578455-1468582842428659', 1, 0, '', NULL, NULL, NULL),
(2970, '2016-07-15 19:43:20', NULL, NULL, 1071, 0, 181, '116', 'Open Food ', 'potato', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 19:43:20', 'admin-1468578455-14685830005174149', 1, 0, '', NULL, NULL, NULL),
(2971, '2016-07-15 19:43:20', NULL, NULL, 1071, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 19:43:20', 'admin-1468578455-14685830005174149', 1, 1, 'SR', NULL, NULL, NULL),
(2972, '2016-07-15 19:44:09', NULL, NULL, 1072, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 19:44:09', 'admin-1468578455-14685830491389251', 1, 0, '', NULL, NULL, NULL),
(2973, '2016-07-15 19:44:09', NULL, NULL, 1072, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 19:44:09', 'admin-1468578455-14685830491389251', 1, 1, 'SR', NULL, NULL, NULL),
(2974, '2016-07-15 20:38:53', NULL, NULL, 1078, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 20:38:53', 'admin-1468578455-14685863330013061', 1, 0, '', NULL, NULL, NULL),
(2975, '2016-07-15 19:55:07', NULL, NULL, 1073, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 19:55:07', 'admin-1468578455-14685837069201949', 1, 1, 'SR', NULL, NULL, NULL),
(2976, '2016-07-15 00:00:00', NULL, NULL, 1077, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 19:55:07', 'admin-1468578455-14685837069201949', 1, 1, 'SR', NULL, NULL, NULL),
(2977, '2016-07-15 20:09:19', NULL, NULL, 1074, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 20:09:19', 'admin-1468578455-14685845592458481', 1, 0, '', 1, NULL, NULL),
(2978, '2016-07-15 20:09:19', NULL, NULL, 1074, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 20:09:19', 'admin-1468578455-14685845592458481', 1, 1, 'SR', 1, NULL, NULL),
(2979, '2016-07-15 20:13:53', NULL, NULL, 1075, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 20:13:53', 'admin-1468578455-1468584833286476', 1, 0, '', NULL, NULL, NULL),
(2980, '2016-07-15 20:22:02', NULL, NULL, 1076, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 20:22:02', 'admin-1468578455-14685853219443512', 1, 0, '', 1, NULL, NULL),
(2981, '2016-07-15 00:00:00', NULL, NULL, 1077, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 19:55:07', 'admin-1468578455-14685837069201949', 1, 1, 'SR', NULL, NULL, NULL),
(2982, '2016-07-15 20:39:04', NULL, NULL, 1078, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 20:39:04', 'admin-1468578455-14685863446059298', 1, 1, 'SR', NULL, NULL, NULL),
(2983, '2016-07-15 20:39:04', NULL, NULL, 1078, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 20:39:04', 'admin-1468578455-14685863446059298', 1, 1, 'SR', NULL, NULL, NULL),
(2984, '2016-07-15 21:07:44', NULL, NULL, 1078, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 21:07:44', 'admin-1468588048-14685880641831358', 1, 1, 'SR', NULL, NULL, NULL),
(2985, '2016-07-15 21:07:44', NULL, NULL, 1078, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 21:07:44', 'admin-1468588048-14685880641831358', 1, 1, 'SR', NULL, NULL, NULL),
(2986, '2016-07-15 21:07:56', NULL, NULL, 1078, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 21:07:56', 'admin-1468588048-14685880762224287', 1, 1, 'SR', NULL, NULL, NULL),
(2987, '2016-07-15 21:07:56', NULL, NULL, 1078, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 21:07:56', 'admin-1468588048-14685880762224287', 1, 1, 'SR', NULL, NULL, NULL),
(2988, '2016-07-15 21:50:18', NULL, NULL, 1079, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 21:50:18', 'admin-1468590609-14685906184111318', 1, 0, '', NULL, NULL, NULL),
(2989, '2016-07-15 21:50:53', NULL, NULL, 1080, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 21:50:53', 'admin-1468590609-14685906531456388', 1, 1, 'SR', NULL, NULL, NULL),
(2990, '2016-07-15 19:43:20', NULL, NULL, 1071, 0, 181, '116', 'Open Food ', '', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 19:43:20', 'admin-1468578455-14685830005174149', 1, 0, '', NULL, NULL, NULL),
(2991, '2016-07-15 19:40:42', NULL, NULL, 1069, 0, 197, '132', 'Dinner - Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 19:40:42', 'admin-1468578455-1468582842428659', 1, 0, '', NULL, NULL, NULL),
(2992, '2016-07-15 19:18:58', NULL, NULL, 1068, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 19:18:58', 'admin-1468578455-14685815386753569', 1, 1, 'SR', NULL, NULL, NULL),
(2993, '2016-07-15 00:00:00', NULL, NULL, 1070, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 19:40:42', 'admin-1468578455-1468582842428659', 1, 0, '', NULL, NULL, NULL),
(2994, '2016-07-15 00:00:00', NULL, NULL, 1070, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 19:40:42', 'admin-1468578455-1468582842428659', 1, 1, 'SR', NULL, NULL, NULL),
(2995, '2016-07-15 00:00:00', NULL, NULL, 1070, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 19:40:42', 'admin-1468578455-1468582842428659', 1, 1, 'SR', NULL, NULL, NULL),
(2996, '2016-07-15 19:18:58', NULL, NULL, 1068, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 19:18:58', 'admin-1468578455-14685815386753569', 1, 1, 'SR', NULL, NULL, NULL),
(2997, '2016-07-15 19:18:58', NULL, NULL, 1068, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 19:18:58', 'admin-1468578455-14685815386753569', 1, 1, 'SR', NULL, NULL, NULL),
(2998, '2016-07-15 16:02:36', NULL, NULL, 1065, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 16:02:36', 'admin-1468558997-14685697567247692', 1, 1, 'SR', NULL, NULL, NULL),
(2999, '2016-07-15 16:02:36', NULL, NULL, 1065, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 16:02:36', 'admin-1468558997-14685697567247692', 1, 0, '', NULL, NULL, NULL),
(3000, '2016-07-15 16:42:52', NULL, NULL, 1066, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 16:42:52', 'admin-1468572157-14685721723175943', 1, 1, 'SR', NULL, NULL, NULL),
(3001, '2016-07-15 16:43:11', NULL, NULL, 1066, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 16:43:11', 'admin-1468572157-14685721915769295', 1, 0, '', NULL, NULL, NULL),
(3002, '2016-07-15 17:35:04', NULL, NULL, 1067, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 17:35:04', 'admin-1468575286-14685753040137781', 1, 1, 'SR', 1, NULL, NULL),
(3003, '2016-07-15 19:17:07', NULL, NULL, 1068, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 19:17:07', 'admin-1468578455-14685814278001170', 1, 1, 'SR', NULL, NULL, NULL),
(3004, '2016-07-15 14:43:07', NULL, NULL, 1063, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 14:43:07', 'admin-1468558997-1468564986869669', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(3005, '2016-07-15 14:43:07', NULL, NULL, 1063, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 14:43:07', 'admin-1468558997-1468564986869669', 1, 1, 'SR', NULL, NULL, NULL),
(3006, '2016-07-15 14:43:07', NULL, NULL, 1063, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 14:43:07', 'admin-1468558997-1468564986869669', 1, 1, 'SR', NULL, NULL, NULL),
(3007, '2016-07-15 14:43:07', NULL, NULL, 1063, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 14:43:07', 'admin-1468558997-1468564986869669', 1, 1, 'SR', NULL, NULL, NULL),
(3008, '2016-07-15 14:43:07', NULL, NULL, 1063, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 14:43:07', 'admin-1468558997-1468564986869669', 1, 0, '', NULL, NULL, NULL),
(3009, '2016-07-15 15:13:13', NULL, NULL, 1064, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 15:13:13', 'admin-1468558997-1468566793548919', 1, 0, '', NULL, NULL, NULL),
(3010, '2016-07-15 13:59:47', NULL, NULL, 1062, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 13:59:47', 'admin-1468558997-14685623872954455', 1, 1, 'SR', NULL, NULL, '10.0'),
(3011, '2016-07-15 15:13:13', NULL, NULL, 1064, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 15:13:13', 'admin-1468558997-1468566793548919', 1, 0, '', NULL, NULL, NULL),
(3012, '2016-07-15 13:39:35', NULL, NULL, 1061, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 13:39:35', 'admin-1468558997-14685611753032080', 1, 1, 'SR', NULL, NULL, NULL),
(3013, '2016-07-15 13:38:42', NULL, NULL, 1060, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 13:38:42', 'admin-1468558997-14685611219869630', 1, 1, 'SR', NULL, NULL, NULL),
(3014, '2016-07-15 13:18:40', NULL, NULL, 1058, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 13:18:40', 'admin-1468558997-1468559920159551', 1, 1, 'SR', NULL, NULL, NULL),
(3015, '2016-07-15 13:38:07', NULL, NULL, 1059, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 13:38:07', 'admin-1468558997-14685610876788174', 1, 1, 'SR', NULL, NULL, NULL),
(3016, '2016-07-15 13:06:04', NULL, NULL, 1057, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 13:06:04', 'admin-1468558997-14685591638309135', 1, 1, 'SR', NULL, NULL, NULL),
(3017, '2016-07-15 13:18:40', NULL, NULL, 1058, 0, 181, '116', 'Open Food ', 'potato', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 13:18:40', 'admin-1468558997-1468559920159551', 1, 0, '', NULL, NULL, NULL),
(3018, '2016-07-15 13:06:03', NULL, NULL, 1057, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 13:06:03', 'admin-1468558997-14685591638309135', 1, 1, 'SR', NULL, NULL, NULL),
(3019, '2016-07-15 13:06:04', NULL, NULL, 1057, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 13:06:04', 'admin-1468558997-14685591638309135', 1, 1, 'SR', NULL, NULL, NULL),
(3020, '2016-07-15 13:04:11', NULL, NULL, 1056, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 13:04:11', 'admin-1468558997-14685590510985896', 1, 0, '', NULL, NULL, NULL),
(3021, '2016-07-15 13:02:44', NULL, NULL, 1056, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 13:02:44', 'admin-1468544076-14685589641729697', 1, 0, '', NULL, NULL, NULL),
(3022, '2016-07-15 13:02:44', NULL, NULL, 1056, 0, 181, '116', 'Open Food ', 'potato chicken', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 13:02:44', 'admin-1468544076-14685589641729697', 1, 0, '', NULL, NULL, NULL),
(3023, '2016-07-15 12:21:20', NULL, NULL, 1053, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 12:21:20', 'admin-1468544076-14685564800577842', 1, 1, 'SR', NULL, NULL, NULL),
(3024, '2016-07-15 12:21:35', NULL, NULL, 1053, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 12:21:35', 'admin-1468544076-14685564955322260', 1, 0, '', NULL, NULL, NULL),
(3025, '2016-07-15 12:24:50', NULL, NULL, 1054, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 12:24:50', 'admin-1468544076-14685566904785495', 1, 1, 'SR', NULL, NULL, NULL),
(3026, '2016-07-15 12:24:50', NULL, NULL, 1054, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 12:24:50', 'admin-1468544076-14685566904785495', 1, 1, 'SR', NULL, NULL, NULL),
(3027, '2016-07-15 12:25:18', NULL, NULL, 1054, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 12:25:18', 'admin-1468544076-14685567182781628', 1, 1, 'SR', NULL, NULL, NULL),
(3028, '2016-07-15 12:25:18', NULL, NULL, 1054, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 12:25:18', 'admin-1468544076-14685567182781628', 1, 1, 'SR', NULL, NULL, NULL),
(3029, '2016-07-15 12:32:19', NULL, NULL, 1055, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 12:32:19', 'admin-1468544076-14685571389122170', 1, 1, 'SR', NULL, NULL, NULL),
(3030, '2016-07-15 12:32:19', NULL, NULL, 1055, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 12:32:19', 'admin-1468544076-14685571389122170', 1, 1, 'SR', NULL, NULL, NULL),
(3031, '2016-07-15 11:08:57', NULL, NULL, 1049, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 11:08:57', 'admin-1468544076-14685521371243289', 1, 0, '', NULL, NULL, NULL),
(3032, '2016-07-15 11:09:07', NULL, NULL, 1049, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 11:09:07', 'admin-1468544076-14685521471246478', 1, 1, 'SR', NULL, NULL, NULL),
(3033, '2016-07-15 11:09:07', NULL, NULL, 1049, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 11:09:07', 'admin-1468544076-14685521471246478', 1, 1, 'SR', NULL, NULL, NULL),
(3034, '2016-07-15 11:11:54', NULL, NULL, 1050, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 11:11:54', 'admin-1468544076-14685523141608995', 1, 1, 'SR', NULL, NULL, NULL),
(3035, '2016-07-15 11:11:54', NULL, NULL, 1050, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 11:11:54', 'admin-1468544076-14685523141608995', 1, 1, 'SR', NULL, NULL, NULL),
(3036, '2016-07-15 11:19:21', NULL, NULL, 1051, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 11:19:21', 'admin-1468544076-14685527618047054', 1, 1, 'SR', NULL, NULL, NULL),
(3037, '2016-07-15 12:05:07', NULL, NULL, 1052, 0, 76, '76', 'Pesto Pasta', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 12:05:07', 'admin-1468544076-14685555069826698', 1, 1, 'SR', NULL, NULL, NULL),
(3038, '2016-07-15 12:05:07', NULL, NULL, 1052, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 12:05:07', 'admin-1468544076-14685555069826698', 1, 1, 'SR', NULL, NULL, NULL),
(3039, '2016-07-15 12:06:03', NULL, NULL, 1052, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 12:06:03', 'admin-1468544076-14685555635876316', 1, 0, '', NULL, NULL, NULL),
(3040, '2016-07-15 12:06:03', NULL, NULL, 1052, 0, 181, '116', 'Open Food ', 'potato chicken', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 12:06:03', 'admin-1468544076-14685555635876316', 1, 0, '', NULL, NULL, NULL),
(3041, '2016-07-15 10:49:18', NULL, NULL, 1048, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 10:49:18', 'admin-1468544076-14685509579342316', 1, 1, 'SR', NULL, NULL, NULL),
(3042, '2016-07-15 11:08:57', NULL, NULL, 1049, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 11:08:57', 'admin-1468544076-14685521371243289', 1, 0, '', NULL, NULL, NULL),
(3043, '2016-07-15 10:49:18', NULL, NULL, 1048, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 10:49:18', 'admin-1468544076-14685509579342316', 1, 1, 'SR', NULL, NULL, NULL),
(3044, '2016-07-15 10:49:05', NULL, NULL, 1048, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 10:49:05', 'admin-1468544076-14685509457092382', 1, 0, '', NULL, NULL, NULL),
(3045, '2016-07-15 10:14:22', NULL, NULL, 1045, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 10:14:22', 'admin-1468544076-1468548862727829', 1, 0, '', NULL, NULL, NULL),
(3046, '2016-07-15 10:49:05', NULL, NULL, 1048, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 10:49:05', 'admin-1468544076-14685509457092382', 1, 0, '', NULL, NULL, NULL),
(3047, '2016-07-15 10:44:53', NULL, NULL, 1047, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 10:44:53', 'admin-1468544076-1468550693135766', 1, 1, 'SR', NULL, NULL, NULL),
(3048, '2016-07-15 10:44:53', NULL, NULL, 1047, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 10:44:53', 'admin-1468544076-1468550693135766', 1, 1, 'SR', NULL, NULL, NULL),
(3049, '2016-07-15 10:23:53', NULL, NULL, 1046, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 10:23:53', 'admin-1468544076-14685494333051497', 1, 0, '', 1, NULL, NULL),
(3050, '2016-07-15 10:14:22', NULL, NULL, 1045, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 10:14:22', 'admin-1468544076-1468548862727829', 1, 1, 'SR', NULL, NULL, NULL),
(3051, '2016-07-15 09:44:23', NULL, NULL, 1044, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 09:44:23', 'admin-1468544076-1468547063002507', 1, 1, 'SR', NULL, NULL, NULL),
(3052, '2016-07-15 09:44:23', NULL, NULL, 1044, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468590838', 'admin', '2016-07-15 09:44:23', 'admin-1468544076-1468547063002507', 1, 1, 'SR', NULL, NULL, NULL),
(3053, '2016-07-16 20:41:46', NULL, NULL, 1120, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 20:41:46', 'admin-1468639424-14686729061975286', 1, 0, '', NULL, NULL, '10.0'),
(3054, '2016-07-16 20:41:46', NULL, NULL, 1120, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 20:41:46', 'admin-1468639424-14686729061975286', 1, 0, '', NULL, NULL, '10.0'),
(3055, '2016-07-16 20:41:46', NULL, NULL, 1120, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 20:41:46', 'admin-1468639424-14686729061975286', 1, 1, 'SR', NULL, NULL, '10.0'),
(3056, '2016-07-16 20:41:46', NULL, NULL, 1120, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 20:41:46', 'admin-1468639424-14686729061975286', 1, 0, '', NULL, NULL, '10.0'),
(3057, '2016-07-16 20:41:46', NULL, NULL, 1120, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 20:41:46', 'admin-1468639424-14686729061975286', 1, 0, '', NULL, NULL, '10.0'),
(3058, '2016-07-16 20:39:01', NULL, NULL, 1119, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 20:39:01', 'admin-1468639424-14686727409249594', 1, 1, 'SR', NULL, NULL, NULL),
(3059, '2016-07-16 16:08:38', NULL, NULL, 1109, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 16:08:38', 'admin-1468639424-14686565184624098', 1, 1, 'SR', NULL, NULL, NULL),
(3060, '2016-07-16 16:08:38', NULL, NULL, 1109, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 16:08:38', 'admin-1468639424-14686565184624098', 1, 1, 'SR', NULL, NULL, NULL),
(3061, '2016-07-16 16:13:39', NULL, NULL, 1109, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 16:13:39', 'admin-1468639424-14686568196397794', 1, 1, 'SR', NULL, NULL, NULL),
(3062, '2016-07-16 16:13:39', NULL, NULL, 1109, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 16:13:39', 'admin-1468639424-14686568196397794', 1, 1, 'SR', NULL, NULL, NULL),
(3063, '2016-07-16 16:17:02', NULL, NULL, 1110, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 16:17:02', 'admin-1468639424-1468657022493349', 1, 1, 'SR', NULL, NULL, NULL),
(3064, '2016-07-16 16:17:02', NULL, NULL, 1110, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 16:17:02', 'admin-1468639424-1468657022493349', 1, 1, 'SR', NULL, NULL, NULL),
(3065, '2016-07-16 16:17:55', NULL, NULL, 1110, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 16:17:55', 'admin-1468639424-14686570757147011', 1, 1, 'SR', NULL, NULL, NULL),
(3066, '2016-07-16 17:07:29', NULL, NULL, 1111, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 17:07:29', 'admin-1468639424-14686600491013345', 1, 0, '', NULL, NULL, NULL),
(3067, '2016-07-16 17:43:14', NULL, NULL, 1109, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 17:43:14', 'admin-1468639424-14686621942889657', 1, 1, 'SR', NULL, NULL, NULL),
(3068, '2016-07-16 18:21:19', NULL, NULL, 1112, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 18:21:19', 'admin-1468639424-14686644797978144', 1, 0, '', NULL, NULL, NULL),
(3069, '2016-07-16 18:21:19', NULL, NULL, 1112, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 18:21:19', 'admin-1468639424-14686644797978144', 1, 0, '', NULL, NULL, NULL),
(3070, '2016-07-16 18:21:19', NULL, NULL, 1112, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 18:21:19', 'admin-1468639424-14686644797978144', 1, 0, '', NULL, NULL, NULL),
(3071, '2016-07-16 18:22:27', NULL, NULL, 1113, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 18:22:27', 'admin-1468639424-14686645472847491', 1, 1, 'SR', NULL, NULL, NULL),
(3072, '2016-07-16 18:22:59', NULL, NULL, 1114, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 18:22:59', 'admin-1468639424-1468664579306905', 1, 1, 'SR', NULL, NULL, NULL),
(3073, '2016-07-16 18:23:37', NULL, NULL, 1115, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 18:23:37', 'admin-1468639424-1468664617778321', 1, 1, 'SR', NULL, NULL, NULL),
(3074, '2016-07-16 18:27:14', NULL, NULL, 1116, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 18:27:14', 'admin-1468639424-14686648342758832', 1, 1, 'SR', NULL, NULL, NULL),
(3075, '2016-07-16 18:27:14', NULL, NULL, 1116, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 18:27:14', 'admin-1468639424-14686648342758832', 1, 1, 'SR', NULL, NULL, NULL),
(3076, '2016-07-16 18:27:14', NULL, NULL, 1116, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 18:27:14', 'admin-1468639424-14686648342758832', 1, 1, 'SR', NULL, NULL, NULL),
(3077, '2016-07-16 18:27:14', NULL, NULL, 1116, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 18:27:14', 'admin-1468639424-14686648342758832', 1, 1, 'SR', NULL, NULL, NULL),
(3078, '2016-07-16 18:55:34', NULL, NULL, 1117, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 18:55:34', 'admin-1468639424-1468666533941235', 1, 1, 'SR', NULL, NULL, NULL),
(3079, '2016-07-16 19:55:59', NULL, NULL, 1118, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 19:55:59', 'admin-1468639424-14686701594691297', 1, 1, 'SR', NULL, NULL, NULL),
(3080, '2016-07-16 19:55:59', NULL, NULL, 1118, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 19:55:59', 'admin-1468639424-14686701594691297', 1, 1, 'SR', NULL, NULL, NULL),
(3081, '2016-07-16 19:57:08', NULL, NULL, 1118, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 19:57:08', 'admin-1468639424-14686702286266986', 1, 0, '', NULL, NULL, NULL),
(3082, '2016-07-16 19:57:08', NULL, NULL, 1118, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 19:57:08', 'admin-1468639424-14686702286266986', 1, 0, '', NULL, NULL, NULL),
(3083, '2016-07-16 20:39:01', NULL, NULL, 1119, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 20:39:01', 'admin-1468639424-14686727409249594', 1, 0, '', NULL, NULL, NULL),
(3084, '2016-07-16 20:39:01', NULL, NULL, 1119, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 20:39:01', 'admin-1468639424-14686727409249594', 1, 1, 'SR', NULL, NULL, NULL),
(3085, '2016-07-16 15:48:41', NULL, NULL, 1108, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 15:48:41', 'admin-1468639424-14686553215751786', 1, 1, 'SR', NULL, NULL, NULL),
(3086, '2016-07-16 15:48:41', NULL, NULL, 1108, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 15:48:41', 'admin-1468639424-14686553215751786', 1, 1, 'SR', NULL, NULL, NULL),
(3087, '2016-07-16 14:55:46', NULL, NULL, 1106, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 14:55:46', 'admin-1468639424-1468652146442729', 1, 1, 'SR', NULL, NULL, NULL),
(3088, '2016-07-16 14:55:46', NULL, NULL, 1106, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 14:55:46', 'admin-1468639424-1468652146442729', 1, 1, 'SR', NULL, NULL, NULL),
(3089, '2016-07-16 15:31:48', NULL, NULL, 1107, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 15:31:48', 'admin-1468639424-14686543081281327', 1, 1, 'SR', NULL, NULL, NULL),
(3090, '2016-07-16 15:31:48', NULL, NULL, 1107, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 15:31:48', 'admin-1468639424-14686543081281327', 1, 1, 'SR', NULL, NULL, NULL),
(3091, '2016-07-16 14:55:46', NULL, NULL, 1106, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 14:55:46', 'admin-1468639424-1468652146442729', 1, 0, '', NULL, NULL, NULL),
(3092, '2016-07-16 13:25:19', NULL, NULL, 1102, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 13:25:19', 'admin-1468639424-14686467197479049', 1, 0, '', NULL, NULL, NULL),
(3093, '2016-07-16 12:41:27', NULL, NULL, 1100, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 12:41:27', 'admin-1468639424-14686440873982547', 1, 0, '', NULL, NULL, NULL),
(3094, '2016-07-16 13:08:19', NULL, NULL, 1101, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 13:08:19', 'admin-1468639424-14686456996015296', 1, 1, 'SR', NULL, NULL, NULL),
(3095, '2016-07-16 14:49:12', NULL, NULL, 1105, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 14:49:12', 'admin-1468639424-14686517524547946', 1, 1, 'SR', NULL, NULL, NULL),
(3096, '2016-07-16 14:49:12', NULL, NULL, 1105, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 14:49:12', 'admin-1468639424-14686517524547946', 1, 1, 'SR', NULL, NULL, NULL),
(3097, '2016-07-16 14:32:04', NULL, NULL, 1104, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 14:32:04', 'admin-1468639424-14686507239466914', 1, 1, 'SR', NULL, NULL, NULL),
(3098, '2016-07-16 13:55:51', NULL, NULL, 1103, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 13:55:51', 'admin-1468639424-14686485512654426', 1, 0, '', NULL, NULL, NULL),
(3099, '2016-07-16 13:25:19', NULL, NULL, 1102, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 13:25:19', 'admin-1468639424-14686467197479049', 1, 0, '', NULL, NULL, NULL),
(3100, '2016-07-16 13:25:19', NULL, NULL, 1102, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 13:25:19', 'admin-1468639424-14686467197479049', 1, 1, 'SR', NULL, NULL, NULL),
(3101, '2016-07-16 13:12:40', NULL, NULL, 1101, NULL, 58, '58', 'House White Bottle', '', 'Cold Drinks', 'Wine', 1, 88.00, 88.0000, 0.0000, 88.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 13:12:40', 'admin-1468639424-14686459599471285', 1, 1, 'SR', NULL, NULL, NULL),
(3102, '2016-07-16 13:12:07', NULL, NULL, 1101, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 13:12:07', 'admin-1468639424-14686459274267658', 1, 0, '', NULL, NULL, NULL),
(3103, '2016-07-16 13:14:39', NULL, NULL, 1101, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 13:14:39', 'admin-1468639424-14686460797278324', 1, 0, '', NULL, NULL, NULL),
(3104, '2016-07-16 12:23:30', NULL, NULL, 1099, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 12:23:30', 'admin-1468639424-14686430098445628', 1, 0, '', NULL, NULL, NULL),
(3105, '2016-07-16 13:14:39', NULL, NULL, 1101, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 13:14:39', 'admin-1468639424-14686460797278324', 1, 1, 'SR', NULL, NULL, NULL),
(3106, '2016-07-16 13:12:07', NULL, NULL, 1101, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 13:12:07', 'admin-1468639424-14686459274267658', 1, 1, 'SR', NULL, NULL, NULL),
(3107, '2016-07-16 12:23:03', NULL, NULL, 1098, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 12:23:03', 'admin-1468639424-14686429834192681', 1, 0, '', NULL, NULL, NULL),
(3108, '2016-07-16 12:23:30', NULL, NULL, 1099, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 12:23:30', 'admin-1468639424-14686430098445628', 1, 0, '', NULL, NULL, NULL),
(3109, '2016-07-16 11:39:58', NULL, NULL, 1096, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:39:58', 'admin-1468639424-14686403986765156', 1, 1, 'SR', NULL, NULL, NULL),
(3110, '2016-07-16 11:39:58', NULL, NULL, 1096, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:39:58', 'admin-1468639424-14686403986765156', 1, 0, '', NULL, NULL, NULL),
(3111, '2016-07-16 11:52:41', NULL, NULL, 1097, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:52:41', 'admin-1468639424-14686411609805247', 1, 0, '', NULL, NULL, NULL),
(3112, '2016-07-16 11:52:41', NULL, NULL, 1097, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:52:41', 'admin-1468639424-14686411609805247', 1, 0, '', NULL, NULL, NULL),
(3113, '2016-07-16 12:23:03', NULL, NULL, 1098, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 12:23:03', 'admin-1468639424-14686429834192681', 1, 0, '', NULL, NULL, NULL),
(3114, '2016-07-16 11:39:08', NULL, NULL, 1095, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:39:08', 'admin-1468639424-14686403481276818', 1, 1, 'SR', NULL, NULL, NULL),
(3115, '2016-07-16 11:39:58', NULL, NULL, 1096, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:39:58', 'admin-1468639424-14686403986765156', 1, 0, '', NULL, NULL, NULL),
(3116, '2016-07-16 11:38:42', NULL, NULL, 1094, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:38:42', 'admin-1468639424-14686403226665318', 1, 0, '', NULL, NULL, NULL),
(3117, '2016-07-16 11:38:16', NULL, NULL, 1093, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:38:16', 'admin-1468639424-14686402965102569', 1, 1, 'SR', NULL, NULL, NULL),
(3118, '2016-07-16 11:24:48', NULL, NULL, 1089, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:24:48', 'admin-1468639424-14686394886747684', 1, 0, '', NULL, NULL, NULL),
(3119, '2016-07-16 11:24:48', NULL, NULL, 1089, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:24:48', 'admin-1468639424-14686394886747684', 1, 0, '', NULL, NULL, NULL),
(3120, '2016-07-16 11:24:48', NULL, NULL, 1089, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:24:48', 'admin-1468639424-14686394886747684', 1, 1, 'SR', NULL, NULL, NULL),
(3121, '2016-07-16 11:24:48', NULL, NULL, 1089, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:24:48', 'admin-1468639424-14686394886747684', 1, 1, 'SR', NULL, NULL, NULL),
(3122, '2016-07-16 11:34:20', NULL, NULL, 1090, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:34:20', 'admin-1468639424-14686400607473296', 1, 1, 'SR', NULL, NULL, NULL),
(3123, '2016-07-16 11:34:20', NULL, NULL, 1090, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:34:20', 'admin-1468639424-14686400607473296', 1, 1, 'SR', NULL, NULL, NULL),
(3124, '2016-07-16 11:37:00', NULL, NULL, 1091, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:37:00', 'admin-1468639424-14686402205854622', 1, 1, 'SR', NULL, NULL, NULL),
(3125, '2016-07-16 11:37:34', NULL, NULL, 1092, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:37:34', 'admin-1468639424-14686402540195996', 1, 1, 'SR', NULL, NULL, NULL),
(3126, '2016-07-16 11:37:34', NULL, NULL, 1092, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:37:34', 'admin-1468639424-14686402540195996', 1, 1, 'SR', NULL, NULL, NULL),
(3127, '2016-07-16 10:35:47', NULL, NULL, 1085, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 10:35:47', 'admin-1468628611-14686365470469718', 1, 0, '', NULL, NULL, NULL),
(3128, '2016-07-16 11:02:52', NULL, NULL, 1086, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:02:52', 'admin-1468628611-14686381723421893', 1, 0, '', 1, NULL, NULL),
(3129, '2016-07-16 11:11:16', NULL, NULL, 1087, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:11:16', 'admin-1468628611-14686386761197791', 1, 0, '', NULL, NULL, '10.0'),
(3130, '2016-07-16 11:14:49', NULL, NULL, 1088, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:14:49', 'admin-1468628611-14686388889135522', 1, 0, '', NULL, NULL, NULL),
(3131, '2016-07-16 11:14:49', NULL, NULL, 1088, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:14:49', 'admin-1468628611-14686388889135522', 1, 1, 'SR', NULL, NULL, NULL),
(3132, '2016-07-16 11:14:49', NULL, NULL, 1088, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:14:49', 'admin-1468628611-14686388889135522', 1, 1, 'SR', NULL, NULL, NULL),
(3133, '2016-07-16 11:14:49', NULL, NULL, 1088, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:14:49', 'admin-1468628611-14686388889135522', 1, 1, 'SR', NULL, NULL, NULL),
(3134, '2016-07-16 11:14:49', NULL, NULL, 1088, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:14:49', 'admin-1468628611-14686388889135522', 1, 0, '', NULL, NULL, NULL),
(3135, '2016-07-16 11:14:49', NULL, NULL, 1088, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:14:49', 'admin-1468628611-14686388889135522', 1, 1, 'SR', NULL, NULL, NULL),
(3136, '2016-07-16 11:23:58', NULL, NULL, 1087, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 11:23:58', 'admin-1468639424-14686394378897353', 1, 1, 'SR', NULL, NULL, '10.0'),
(3137, '2016-07-16 10:21:52', NULL, NULL, 1084, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 10:21:52', 'admin-1468628611-14686357123932374', 1, 1, 'SR', NULL, NULL, NULL),
(3138, '2016-07-16 10:35:47', NULL, NULL, 1085, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 10:35:47', 'admin-1468628611-14686365470469718', 1, 0, '', NULL, NULL, NULL),
(3139, '2016-07-16 10:21:52', NULL, NULL, 1084, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 10:21:52', 'admin-1468628611-14686357123932374', 1, 1, 'SR', NULL, NULL, NULL),
(3140, '2016-07-16 10:12:35', NULL, NULL, 1083, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 10:12:35', 'admin-1468628611-14686351550238937', 1, 1, 'SR', NULL, NULL, '10.0'),
(3141, '2016-07-16 10:21:52', NULL, NULL, 1084, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 10:21:52', 'admin-1468628611-14686357123932374', 1, 1, 'SR', NULL, NULL, NULL),
(3142, '2016-07-16 10:12:35', NULL, NULL, 1083, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 10:12:35', 'admin-1468628611-14686351550238937', 1, 0, '', NULL, NULL, '10.0'),
(3143, '2016-07-16 10:12:35', NULL, NULL, 1083, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 10:12:35', 'admin-1468628611-14686351550238937', 1, 0, '', NULL, NULL, '10.0'),
(3144, '2016-07-16 10:11:34', NULL, NULL, 1082, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 10:11:34', 'admin-1468628611-14686350947218852', 1, 0, '', NULL, NULL, NULL),
(3145, '2016-07-16 10:11:34', NULL, NULL, 1082, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 10:11:34', 'admin-1468628611-14686350947218852', 1, 0, '', NULL, NULL, NULL),
(3146, '2016-07-16 08:24:15', NULL, NULL, 1081, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 08:24:15', 'admin-1468628611-14686286554412552', 1, 0, '', NULL, NULL, NULL),
(3147, '2016-07-16 10:11:34', NULL, NULL, 1082, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 10:11:34', 'admin-1468628611-14686350947218852', 1, 0, '', NULL, NULL, NULL),
(3148, '2016-07-16 08:24:15', NULL, NULL, 1081, 0, 181, '116', 'Open Food ', 'Riesling White', 'Meals', 'Perfect Meals', 1, 100.00, 100.0000, 0.0000, 100.00, 1, '27', 1, '1468675805', 'admin', '2016-07-16 08:24:15', 'admin-1468628611-14686286554412552', 1, 0, '', NULL, NULL, NULL),
(3149, '2016-07-17 21:05:19', NULL, NULL, 1183, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 21:05:19', 'admin-1468760400-14687607189645657', 1, 1, 'SR', NULL, NULL, NULL),
(3150, '2016-07-17 20:31:30', NULL, NULL, 1182, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:31:30', 'admin-1468743545-1468758690381169', 1, 0, '', NULL, NULL, NULL),
(3151, '2016-07-17 20:31:30', NULL, NULL, 1182, NULL, 65, '65', 'Pineapple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:31:30', 'admin-1468743545-1468758690381169', 1, 1, 'SR', NULL, NULL, NULL),
(3152, '2016-07-17 20:56:18', NULL, NULL, 1181, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:56:18', 'admin-1468743545-14687601787813859', 1, 0, '', NULL, NULL, NULL),
(3153, '2016-07-17 21:08:22', NULL, NULL, 1181, 0, 181, '116', 'Open Food ', 'wings', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 21:08:22', 'admin-1468760400-14687609020497725', 1, 0, '', NULL, NULL, NULL),
(3154, '2016-07-17 20:59:51', NULL, NULL, 1181, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:59:51', 'admin-1468743545-1468760391595186', 1, 0, '', NULL, NULL, NULL),
(3155, '2016-07-17 21:05:19', NULL, NULL, 1183, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 21:05:19', 'admin-1468760400-14687607189645657', 1, 1, 'SR', NULL, NULL, NULL),
(3156, '2016-07-17 20:14:12', NULL, NULL, 1181, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:14:12', 'admin-1468743545-14687576520539669', 1, 0, '', NULL, NULL, NULL),
(3157, '2016-07-17 20:14:12', NULL, NULL, 1181, 0, 181, '116', 'Open Food ', 'potato pork', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:14:12', 'admin-1468743545-14687576520539669', 1, 0, '', NULL, NULL, NULL),
(3158, '2016-07-17 20:14:12', NULL, NULL, 1181, 0, 181, '116', 'Open Food ', 'potato pork', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:14:12', 'admin-1468743545-14687576520539669', 1, 0, '', NULL, NULL, NULL),
(3159, '2016-07-17 20:14:12', NULL, NULL, 1181, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:14:12', 'admin-1468743545-14687576520539669', 1, 0, '', NULL, NULL, NULL),
(3160, '2016-07-17 20:14:12', NULL, NULL, 1181, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:14:12', 'admin-1468743545-14687576520539669', 1, 0, '', NULL, NULL, NULL),
(3161, '2016-07-17 20:14:12', NULL, NULL, 1181, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:14:12', 'admin-1468743545-14687576520539669', 1, 0, '', NULL, NULL, NULL),
(3162, '2016-07-17 20:14:12', NULL, NULL, 1181, 0, 181, '116', 'Open Food ', 'pork chop', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:14:12', 'admin-1468743545-14687576520539669', 1, 0, '', NULL, NULL, NULL),
(3163, '2016-07-17 20:14:12', NULL, NULL, 1181, 0, 181, '116', 'Open Food ', 'pork chop', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:14:12', 'admin-1468743545-14687576520539669', 1, 0, '', NULL, NULL, NULL),
(3164, '2016-07-17 20:14:12', NULL, NULL, 1181, 0, 181, '116', 'Open Food ', 'pork chop', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:14:12', 'admin-1468743545-14687576520539669', 1, 0, '', NULL, NULL, NULL),
(3165, '2016-07-17 20:14:12', NULL, NULL, 1181, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:14:12', 'admin-1468743545-14687576520539669', 1, 1, 'SR', NULL, NULL, NULL),
(3166, '2016-07-17 20:24:26', NULL, NULL, 1181, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:24:26', 'admin-1468743545-14687582666299789', 1, 0, '', NULL, NULL, NULL),
(3167, '2016-07-17 21:09:03', NULL, NULL, 1181, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 21:09:03', 'admin-1468760400-14687609435158898', 1, 1, 'SR', NULL, NULL, NULL),
(3168, '2016-07-17 21:09:03', NULL, NULL, 1181, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 21:09:03', 'admin-1468760400-14687609435158898', 1, 1, 'SR', NULL, NULL, NULL),
(3169, '2016-07-17 21:11:52', NULL, NULL, 1181, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 21:11:52', 'admin-1468760400-14687611118405333', 1, 1, 'SR', NULL, NULL, NULL),
(3170, '2016-07-17 21:11:52', NULL, NULL, 1181, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 21:11:52', 'admin-1468760400-14687611118405333', 1, 1, 'SR', NULL, NULL, NULL),
(3171, '2016-07-17 21:11:52', NULL, NULL, 1181, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 21:11:52', 'admin-1468760400-14687611118405333', 1, 1, 'SR', NULL, NULL, NULL),
(3172, '2016-07-17 21:11:52', NULL, NULL, 1181, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 21:11:52', 'admin-1468760400-14687611118405333', 1, 0, '', NULL, NULL, NULL),
(3173, '2016-07-17 21:22:48', NULL, NULL, 1181, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 21:22:48', 'admin-1468760400-14687617683974563', 1, 1, 'SR', NULL, NULL, NULL),
(3174, '2016-07-17 15:43:44', NULL, NULL, 1165, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 15:43:44', 'admin-1468735269-14687414244841489', 1, 1, 'SR', NULL, NULL, NULL),
(3175, '2016-07-17 15:44:31', NULL, NULL, 1166, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 15:44:31', 'admin-1468735269-14687414712407113', 1, 1, 'SR', NULL, NULL, NULL),
(3176, '2016-07-17 15:46:08', NULL, NULL, 1167, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 15:46:08', 'admin-1468735269-14687415679034763', 1, 1, 'SR', NULL, NULL, NULL),
(3177, '2016-07-17 15:46:08', NULL, NULL, 1167, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 15:46:08', 'admin-1468735269-14687415679034763', 1, 0, '', NULL, NULL, NULL),
(3178, '2016-07-17 15:46:08', NULL, NULL, 1167, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 15:46:08', 'admin-1468735269-14687415679034763', 1, 0, '', NULL, NULL, NULL),
(3179, '2016-07-17 16:19:31', NULL, NULL, 1168, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 16:19:31', 'admin-1468743545-14687435711056984', 1, 0, '', NULL, NULL, NULL),
(3180, '2016-07-17 16:19:31', NULL, NULL, 1168, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 16:19:31', 'admin-1468743545-14687435711056984', 1, 0, '', NULL, NULL, NULL),
(3181, '2016-07-17 16:19:31', NULL, NULL, 1168, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 16:19:31', 'admin-1468743545-14687435711056984', 1, 1, 'SR', NULL, NULL, NULL),
(3182, '2016-07-17 16:19:31', NULL, NULL, 1168, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 16:19:31', 'admin-1468743545-14687435711056984', 1, 1, 'SR', NULL, NULL, NULL),
(3183, '2016-07-17 16:19:31', NULL, NULL, 1168, 0, 203, '138', 'Fruitea ', '', 'Cold Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 16:19:31', 'admin-1468743545-14687435711056984', 1, 0, '', NULL, NULL, NULL),
(3184, '2016-07-17 16:31:42', NULL, NULL, 1168, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 16:31:42', 'admin-1468743545-14687443022225682', 1, 1, 'SR', NULL, NULL, NULL),
(3185, '2016-07-17 16:51:28', NULL, NULL, 1169, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 9.90, 1, '27', 1, '1468766326', 'admin', '2016-07-17 16:51:28', 'admin-1468743545-1468745487875736', 1, 1, 'SR', NULL, '10.0', NULL),
(3186, '2016-07-17 17:11:05', NULL, NULL, 1170, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 17:11:05', 'admin-1468743545-14687466650237454', 1, 1, 'SR', NULL, NULL, NULL),
(3187, '2016-07-17 17:11:05', NULL, NULL, 1170, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 17:11:05', 'admin-1468743545-14687466650237454', 1, 1, 'SR', NULL, NULL, NULL),
(3188, '2016-07-17 17:18:53', NULL, NULL, 1171, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 17:18:53', 'admin-1468743545-14687471331166472', 1, 0, '', NULL, NULL, NULL),
(3189, '2016-07-17 17:18:53', NULL, NULL, 1171, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 17:18:53', 'admin-1468743545-14687471331166472', 1, 0, '', NULL, NULL, NULL),
(3190, '2016-07-17 17:18:53', NULL, NULL, 1171, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 17:18:53', 'admin-1468743545-14687471331166472', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(3191, '2016-07-17 17:19:08', NULL, NULL, 1172, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 17:19:08', 'admin-1468743545-14687471479898885', 1, 1, 'SR', NULL, NULL, NULL),
(3192, '2016-07-17 17:30:46', NULL, NULL, 1173, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 17:30:46', 'admin-1468743545-14687478463454731', 1, 1, 'SR', NULL, NULL, NULL),
(3193, '2016-07-17 17:30:46', NULL, NULL, 1173, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 17:30:46', 'admin-1468743545-14687478463454731', 1, 1, 'SR', NULL, NULL, NULL),
(3194, '2016-07-17 17:30:46', NULL, NULL, 1173, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 17:30:46', 'admin-1468743545-14687478463454731', 1, 1, 'SR', NULL, NULL, NULL),
(3195, '2016-07-17 17:30:46', NULL, NULL, 1173, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 17:30:46', 'admin-1468743545-14687478463454731', 1, 0, '', NULL, NULL, NULL),
(3196, '2016-07-17 17:30:46', NULL, NULL, 1173, 0, 181, '116', 'Open Food ', 'potato pork', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 17:30:46', 'admin-1468743545-14687478463454731', 1, 0, '', NULL, NULL, NULL),
(3197, '2016-07-17 17:30:46', NULL, NULL, 1173, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 17:30:46', 'admin-1468743545-14687478463454731', 1, 0, '', NULL, NULL, NULL),
(3198, '2016-07-17 17:30:46', NULL, NULL, 1173, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 17:30:46', 'admin-1468743545-14687478463454731', 1, 0, '', NULL, NULL, NULL),
(3199, '2016-07-17 17:30:46', NULL, NULL, 1173, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 17:30:46', 'admin-1468743545-14687478463454731', 1, 0, '', NULL, NULL, NULL),
(3200, '2016-07-17 17:44:06', NULL, NULL, 1174, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 17:44:06', 'admin-1468743545-1468748646644174', 1, 1, 'SR', NULL, NULL, NULL),
(3201, '2016-07-17 17:44:06', NULL, NULL, 1174, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 17:44:06', 'admin-1468743545-1468748646644174', 1, 1, 'SR', NULL, NULL, NULL),
(3202, '2016-07-17 17:54:49', NULL, NULL, 1175, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 17:54:49', 'admin-1468743545-14687492895647819', 1, 1, 'SR', NULL, NULL, NULL),
(3203, '2016-07-17 18:03:02', NULL, NULL, 1173, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 18:03:02', 'admin-1468743545-14687497821073126', 1, 0, '', NULL, NULL, NULL),
(3204, '2016-07-17 18:03:02', NULL, NULL, 1173, 0, 181, '116', 'Open Food ', 'Dinner - Cucumber', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 18:03:02', 'admin-1468743545-14687497821073126', 1, 0, '', NULL, NULL, NULL),
(3205, '2016-07-17 19:04:51', NULL, NULL, 1176, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 19:04:51', 'admin-1468743545-14687534912664819', 1, 1, 'SR', NULL, NULL, NULL),
(3206, '2016-07-17 19:04:51', NULL, NULL, 1176, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 19:04:51', 'admin-1468743545-14687534912664819', 1, 1, 'SR', NULL, NULL, NULL),
(3207, '2016-07-17 19:04:51', NULL, NULL, 1176, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 19:04:51', 'admin-1468743545-14687534912664819', 1, 0, '', NULL, NULL, NULL),
(3208, '2016-07-17 19:24:03', NULL, NULL, 1177, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 19:24:03', 'admin-1468743545-14687546428137447', 1, 0, '', NULL, NULL, NULL),
(3209, '2016-07-17 19:24:03', NULL, NULL, 1177, 0, 198, '133', 'Dinner - Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 19:24:03', 'admin-1468743545-14687546428137447', 1, 0, '', NULL, NULL, NULL),
(3210, '2016-07-17 19:35:34', NULL, NULL, 1178, 0, 198, '133', 'Dinner - Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 19:35:34', 'admin-1468743545-14687553342929635', 1, 0, '', NULL, NULL, NULL),
(3211, '2016-07-17 19:35:34', NULL, NULL, 1178, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 19:35:34', 'admin-1468743545-14687553342929635', 1, 0, '', NULL, NULL, NULL),
(3212, '2016-07-17 19:35:34', NULL, NULL, 1178, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 19:35:34', 'admin-1468743545-14687553342929635', 1, 0, '', NULL, NULL, NULL),
(3213, '2016-07-17 19:35:38', NULL, NULL, 1177, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 19:35:38', 'admin-1468743545-14687553381761259', 1, 0, '', NULL, NULL, NULL),
(3214, '2016-07-17 19:35:38', NULL, NULL, 1177, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 19:35:38', 'admin-1468743545-14687553381761259', 1, 0, '', NULL, NULL, NULL),
(3215, '2016-07-17 19:48:48', NULL, NULL, 1177, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 19:48:48', 'admin-1468743545-1468756128200568', 1, 1, 'SR', NULL, NULL, NULL),
(3216, '2016-07-17 19:49:00', NULL, NULL, 1179, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 19:49:00', 'admin-1468743545-1468756140623637', 1, 0, '', NULL, NULL, NULL),
(3217, '2016-07-17 19:49:00', NULL, NULL, 1179, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 19:49:00', 'admin-1468743545-1468756140623637', 1, 0, '', NULL, NULL, NULL),
(3218, '2016-07-17 13:54:56', NULL, NULL, 1152, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 13:54:56', 'admin-1468731161-14687348961149775', 1, 0, '', NULL, NULL, NULL),
(3219, '2016-07-17 13:54:56', NULL, NULL, 1152, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 13:54:56', 'admin-1468731161-14687348961149775', 1, 1, 'SR', NULL, NULL, NULL),
(3220, '2016-07-17 14:01:43', NULL, NULL, 1153, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 14:01:43', 'admin-1468735269-14687353036677815', 1, 1, 'SR', NULL, NULL, NULL),
(3221, '2016-07-17 14:01:23', NULL, NULL, 1153, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 14:01:23', 'admin-1468735269-14687352835128961', 1, 0, '', NULL, NULL, NULL),
(3222, '2016-07-17 14:04:37', NULL, NULL, 1154, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 14:04:37', 'admin-1468735269-14687354769148938', 1, 0, '', NULL, NULL, NULL),
(3223, '2016-07-17 14:05:50', NULL, NULL, 1155, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 14:05:50', 'admin-1468735269-14687355501658323', 1, 1, 'SR', NULL, NULL, NULL),
(3224, '2016-07-17 14:05:50', NULL, NULL, 1155, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 14:05:50', 'admin-1468735269-14687355501658323', 1, 1, 'SR', NULL, NULL, NULL),
(3225, '2016-07-17 20:31:30', NULL, NULL, 1182, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:31:30', 'admin-1468743545-1468758690381169', 1, 1, 'SR', NULL, NULL, NULL),
(3226, '2016-07-17 20:27:26', NULL, NULL, 1181, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:27:26', 'admin-1468743545-14687584466777471', 1, 0, '', NULL, NULL, NULL),
(3227, '2016-07-17 20:14:12', NULL, NULL, 1181, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:14:12', 'admin-1468743545-14687576520539669', 1, 1, 'SR', NULL, NULL, NULL),
(3228, '2016-07-17 20:14:12', NULL, NULL, 1181, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:14:12', 'admin-1468743545-14687576520539669', 1, 1, 'SR', NULL, NULL, NULL),
(3229, '2016-07-17 20:14:12', NULL, NULL, 1181, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:14:12', 'admin-1468743545-14687576520539669', 1, 1, 'SR', NULL, NULL, NULL),
(3230, '2016-07-17 20:14:12', NULL, NULL, 1181, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:14:12', 'admin-1468743545-14687576520539669', 1, 0, '', NULL, NULL, NULL),
(3231, '2016-07-17 20:14:12', NULL, NULL, 1181, 0, 181, '116', 'Open Food ', 'pork chop', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:14:12', 'admin-1468743545-14687576520539669', 1, 0, '', NULL, NULL, NULL),
(3232, '2016-07-17 20:14:12', NULL, NULL, 1181, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:14:12', 'admin-1468743545-14687576520539669', 1, 1, 'SR', NULL, NULL, NULL),
(3233, '2016-07-17 20:14:12', NULL, NULL, 1181, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:14:12', 'admin-1468743545-14687576520539669', 1, 1, 'SR', NULL, NULL, NULL),
(3234, '2016-07-17 20:14:12', NULL, NULL, 1181, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 20:14:12', 'admin-1468743545-14687576520539669', 1, 1, 'SR', NULL, NULL, NULL),
(3235, '2016-07-17 19:53:41', NULL, NULL, 1180, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 19:53:41', 'admin-1468743545-1468756421390256', 1, 1, 'SR', NULL, NULL, NULL),
(3236, '2016-07-17 14:19:06', NULL, NULL, 1156, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 14:19:06', 'admin-1468735269-1468736345991921', 1, 1, 'SR', NULL, NULL, NULL),
(3237, '2016-07-17 14:19:06', NULL, NULL, 1156, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 14:19:06', 'admin-1468735269-1468736345991921', 1, 1, 'SR', NULL, NULL, NULL),
(3238, '2016-07-17 14:19:06', NULL, NULL, 1156, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 14:19:06', 'admin-1468735269-1468736345991921', 1, 1, 'SR', NULL, NULL, NULL),
(3239, '2016-07-17 14:19:06', NULL, NULL, 1156, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 14:19:06', 'admin-1468735269-1468736345991921', 1, 0, '', NULL, NULL, NULL),
(3240, '2016-07-17 15:51:28', NULL, NULL, 1157, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 15:51:28', 'admin-1468735269-14687418877733649', 1, 1, 'SR', NULL, NULL, NULL),
(3241, '2016-07-17 14:49:25', NULL, NULL, 1157, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 14:49:25', 'admin-1468735269-14687381648331377', 1, 1, 'SR', NULL, NULL, NULL),
(3242, '2016-07-17 14:54:46', NULL, NULL, 1158, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 14:54:46', 'admin-1468735269-14687384864045065', 1, 1, 'SR', NULL, NULL, NULL),
(3243, '2016-07-17 14:54:46', NULL, NULL, 1158, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 14:54:46', 'admin-1468735269-14687384864045065', 1, 1, 'SR', NULL, NULL, NULL),
(3244, '2016-07-17 14:54:46', NULL, NULL, 1158, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 14:54:46', 'admin-1468735269-14687384864045065', 1, 1, 'SR', NULL, NULL, NULL),
(3245, '2016-07-17 14:57:27', NULL, NULL, 1159, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 14:57:27', 'admin-1468735269-14687386472277542', 1, 1, 'SR', NULL, NULL, NULL),
(3246, '2016-07-17 15:03:50', NULL, NULL, 1159, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 15:03:50', 'admin-1468735269-14687390306238130', 1, 0, '', NULL, NULL, NULL),
(3247, '2016-07-17 15:20:42', NULL, NULL, 1160, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 15:20:42', 'admin-1468735269-146874004273495', 1, 0, '', NULL, NULL, NULL),
(3248, '2016-07-17 15:20:42', NULL, NULL, 1160, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 15:20:42', 'admin-1468735269-146874004273495', 1, 1, 'SR', NULL, NULL, NULL),
(3249, '2016-07-17 15:20:42', NULL, NULL, 1160, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 15:20:42', 'admin-1468735269-146874004273495', 1, 1, 'SR', NULL, NULL, NULL),
(3250, '2016-07-17 15:26:27', NULL, NULL, 1161, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 15:26:27', 'admin-1468735269-14687403874208823', 1, 1, 'SR', NULL, NULL, NULL),
(3251, '2016-07-17 15:26:27', NULL, NULL, 1161, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 15:26:27', 'admin-1468735269-14687403874208823', 1, 1, 'SR', NULL, NULL, NULL),
(3252, '2016-07-17 15:26:27', NULL, NULL, 1161, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 15:26:27', 'admin-1468735269-14687403874208823', 1, 0, '', NULL, NULL, NULL),
(3253, '2016-07-17 15:36:55', NULL, NULL, 1162, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 15:36:55', 'admin-1468735269-14687410148554248', 1, 1, 'SR', NULL, NULL, NULL),
(3254, '2016-07-17 15:36:55', NULL, NULL, 1162, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 15:36:55', 'admin-1468735269-14687410148554248', 1, 1, 'SR', NULL, NULL, NULL),
(3255, '2016-07-17 15:42:14', NULL, NULL, 1163, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 15:42:14', 'admin-1468735269-14687413338066443', 1, 0, '', NULL, NULL, NULL),
(3256, '2016-07-17 15:43:06', NULL, NULL, 1164, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 15:43:06', 'admin-1468735269-14687413863742535', 1, 1, 'SR', NULL, NULL, NULL),
(3257, '2016-07-17 15:43:06', NULL, NULL, 1164, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 15:43:06', 'admin-1468735269-14687413863742535', 1, 0, '', NULL, NULL, NULL),
(3258, '2016-07-17 19:53:49', NULL, NULL, 1180, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 19:53:49', 'admin-1468743545-1468756429633731', 1, 1, 'SR', NULL, NULL, NULL),
(3259, '2016-07-17 13:35:37', NULL, NULL, 1151, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 13:35:37', 'admin-1468731161-14687337370353419', 1, 1, 'SR', NULL, NULL, NULL),
(3260, '2016-07-17 13:35:37', NULL, NULL, 1151, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 13:35:37', 'admin-1468731161-14687337370353419', 1, 1, 'SR', NULL, NULL, NULL),
(3261, '2016-07-17 13:35:37', NULL, NULL, 1151, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 13:35:37', 'admin-1468731161-14687337370353419', 1, 1, 'SR', NULL, NULL, NULL),
(3262, '2016-07-17 13:35:37', NULL, NULL, 1151, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 13:35:37', 'admin-1468731161-14687337370353419', 1, 0, '', NULL, NULL, NULL),
(3263, '2016-07-17 13:25:51', NULL, NULL, 1150, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 13:25:51', 'admin-1468731161-1468733151313745', 1, 0, '', NULL, NULL, NULL),
(3264, '2016-07-17 13:17:40', NULL, NULL, 1149, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 13:17:40', 'admin-1468731161-14687326603017492', 1, 1, 'SR', NULL, NULL, NULL),
(3265, '2016-07-17 13:15:21', NULL, NULL, 1138, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 13:15:21', 'admin-1468731161-14687325213442022', 1, 0, '', NULL, NULL, NULL),
(3266, '2016-07-17 12:25:10', NULL, NULL, 1141, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:25:10', 'Staff-1468728065-14687295103568294', 1, 1, 'SR', NULL, NULL, NULL),
(3267, '2016-07-17 12:25:10', NULL, NULL, 1141, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:25:10', 'Staff-1468728065-14687295103568294', 1, 0, '', NULL, NULL, NULL),
(3268, '2016-07-17 12:25:10', NULL, NULL, 1141, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:25:10', 'Staff-1468728065-14687295103568294', 1, 0, '', NULL, NULL, NULL),
(3269, '2016-07-17 12:30:40', NULL, NULL, 1141, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:30:40', 'Staff-1468728065-14687298404755279', 1, 1, 'SR', NULL, NULL, NULL),
(3270, '2016-07-17 12:30:53', NULL, NULL, 1134, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:30:53', 'Staff-1468728065-14687298531068169', 1, 0, '', NULL, NULL, NULL),
(3271, '2016-07-17 12:32:59', NULL, NULL, 1142, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:32:59', 'Staff-1468728065-14687299795016570', 1, 0, '', NULL, NULL, NULL),
(3272, '2016-07-17 12:32:59', NULL, NULL, 1142, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:32:59', 'Staff-1468728065-14687299795016570', 1, 0, '', NULL, NULL, NULL),
(3273, '2016-07-17 12:33:54', NULL, NULL, 1143, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:33:54', 'Staff-1468728065-14687300347994566', 1, 0, '', NULL, NULL, NULL),
(3274, '2016-07-17 12:33:54', NULL, NULL, 1143, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:33:54', 'Staff-1468728065-14687300347994566', 1, 0, '', NULL, NULL, NULL),
(3275, '2016-07-17 12:33:54', NULL, NULL, 1143, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:33:54', 'Staff-1468728065-14687300347994566', 1, 1, 'SR', NULL, NULL, NULL),
(3276, '2016-07-17 12:33:54', NULL, NULL, 1143, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:33:54', 'Staff-1468728065-14687300347994566', 1, 1, 'SR', NULL, NULL, NULL),
(3277, '2016-07-17 12:35:03', NULL, NULL, 1144, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:35:03', 'Staff-1468728065-14687301033591299', 1, 1, 'SR', NULL, NULL, NULL),
(3278, '2016-07-17 12:35:03', NULL, NULL, 1144, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:35:03', 'Staff-1468728065-14687301033591299', 1, 1, 'SR', NULL, NULL, NULL),
(3279, '2016-07-17 12:45:48', NULL, NULL, 1145, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:45:48', 'Staff-1468728065-14687307482271972', 1, 1, 'SR', 1, NULL, NULL),
(3280, '2016-07-17 12:49:43', NULL, NULL, 1146, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:49:43', 'Staff-1468728065-14687309834081617', 1, 0, '', NULL, NULL, NULL),
(3281, '2016-07-17 12:52:00', NULL, NULL, 1146, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:52:00', 'Staff-1468728065-1468731120147518', 1, 1, 'SR', NULL, NULL, NULL),
(3282, '2016-07-17 12:52:00', NULL, NULL, 1146, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:52:00', 'Staff-1468728065-1468731120147518', 1, 1, 'SR', NULL, NULL, NULL),
(3283, '2016-07-17 12:52:00', NULL, NULL, 1146, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:52:00', 'Staff-1468728065-1468731120147518', 1, 1, 'SR', NULL, NULL, NULL),
(3284, '2016-07-17 12:53:02', NULL, NULL, 1146, 0, 72, '72', 'Mushroom Chicken', 'Takeaway', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 12:53:02', 'admin-1468731161-14687311827749783', 1, 1, 'SR', NULL, NULL, NULL),
(3285, '2016-07-17 13:08:36', NULL, NULL, 1147, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 13:08:36', 'admin-1468731161-14687321166871843', 1, 1, 'SR', NULL, NULL, NULL),
(3286, '2016-07-17 13:08:36', NULL, NULL, 1147, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 13:08:36', 'admin-1468731161-14687321166871843', 1, 0, '', NULL, NULL, NULL),
(3287, '2016-07-17 13:08:36', NULL, NULL, 1147, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 13:08:36', 'admin-1468731161-14687321166871843', 1, 1, 'SR', NULL, NULL, NULL),
(3288, '2016-07-17 13:08:36', NULL, NULL, 1147, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 13:08:36', 'admin-1468731161-14687321166871843', 1, 1, 'SR', NULL, NULL, NULL),
(3289, '2016-07-17 13:14:47', NULL, NULL, 1148, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 13:14:47', 'admin-1468731161-14687324876229219', 1, 1, 'SR', NULL, NULL, NULL),
(3290, '2016-07-17 13:14:47', NULL, NULL, 1148, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 13:14:47', 'admin-1468731161-14687324876229219', 1, 1, 'SR', NULL, NULL, NULL),
(3291, '2016-07-17 13:14:47', NULL, NULL, 1148, NULL, 84, '84', 'Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 13:14:47', 'admin-1468731161-14687324876229219', 1, 1, 'SR', NULL, NULL, NULL),
(3292, '2016-07-17 12:13:31', NULL, NULL, 1133, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:13:31', 'Staff-1468728065-1468728811508691', 1, 0, '', NULL, NULL, NULL),
(3293, '2016-07-17 12:25:10', NULL, NULL, 1141, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:25:10', 'Staff-1468728065-14687295103568294', 1, 1, 'SR', NULL, NULL, NULL),
(3294, '2016-07-17 13:17:40', NULL, NULL, 1149, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 13:17:40', 'admin-1468731161-14687326603017492', 1, 0, '', NULL, NULL, NULL),
(3295, '2016-07-17 12:00:56', NULL, NULL, 1139, 0, 76, '76', 'Pesto Pasta', 'x spicy', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:00:56', 'Staff-1468724310-14687280559562138', 1, 1, 'SR', NULL, NULL, NULL),
(3296, '2016-07-17 12:00:56', NULL, NULL, 1139, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:00:56', 'Staff-1468724310-14687280559562138', 1, 1, 'SR', NULL, NULL, NULL),
(3297, '2016-07-17 12:13:09', NULL, NULL, 1136, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:13:09', 'Staff-1468728065-14687287897156687', 1, 1, 'SR', NULL, NULL, NULL),
(3298, '2016-07-17 12:13:23', NULL, NULL, 1140, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:13:23', 'Staff-1468728065-14687288034224795', 1, 1, 'SR', NULL, NULL, NULL),
(3299, '2016-07-17 12:13:23', NULL, NULL, 1140, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:13:23', 'Staff-1468728065-14687288034224795', 1, 1, 'SR', NULL, NULL, NULL),
(3300, '2016-07-17 12:00:56', NULL, NULL, 1139, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:00:56', 'Staff-1468724310-14687280559562138', 1, 1, 'SR', NULL, NULL, NULL),
(3301, '2016-07-17 12:00:56', NULL, NULL, 1139, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:00:56', 'Staff-1468724310-14687280559562138', 1, 0, '', NULL, NULL, NULL),
(3302, '2016-07-17 11:53:04', NULL, NULL, 1135, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 11:53:04', 'Staff-1468724310-14687275845267061', 1, 1, 'SR', NULL, NULL, NULL),
(3303, '2016-07-17 11:53:04', NULL, NULL, 1135, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 11:53:04', 'Staff-1468724310-14687275845267061', 1, 0, '', NULL, NULL, NULL),
(3304, '2016-07-17 11:53:49', NULL, NULL, 1133, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 11:53:49', 'Staff-1468724310-14687276295155019', 1, 0, '', NULL, NULL, NULL),
(3305, '2016-07-17 11:57:13', NULL, NULL, 1137, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 11:57:13', 'Staff-1468724310-1468727833326158', 1, 1, 'SR', NULL, NULL, NULL),
(3306, '2016-07-17 11:57:13', NULL, NULL, 1137, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 11:57:13', 'Staff-1468724310-1468727833326158', 1, 1, 'SR', NULL, NULL, NULL),
(3307, '2016-07-17 12:00:56', NULL, NULL, 1139, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 12:00:56', 'Staff-1468724310-14687280559562138', 1, 1, 'SR', NULL, NULL, NULL),
(3308, '2016-07-17 11:53:04', NULL, NULL, 1135, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 11:53:04', 'Staff-1468724310-14687275845267061', 1, 1, 'SR', NULL, NULL, NULL),
(3309, '2016-07-17 11:51:31', NULL, NULL, 1134, 0, 203, '138', 'Fruitea ', '', 'Cold Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 11:51:31', 'Staff-1468724310-14687274907825778', 1, 0, '', NULL, NULL, NULL),
(3310, '2016-07-17 11:51:31', NULL, NULL, 1134, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 11:51:31', 'Staff-1468724310-14687274907825778', 1, 0, '', NULL, NULL, NULL),
(3311, '2016-07-17 11:41:06', NULL, NULL, 1133, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 11:41:06', 'Staff-1468724310-1468726866322719', 1, 1, 'SR', NULL, NULL, NULL),
(3312, '2016-07-17 11:31:00', NULL, NULL, 1132, NULL, 65, '65', 'Pineapple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 11:31:00', 'Staff-1468724310-14687262606651562', 1, 1, 'SR', NULL, NULL, NULL),
(3313, '2016-07-17 11:41:06', NULL, NULL, 1133, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 11:41:06', 'Staff-1468724310-1468726866322719', 1, 0, '', NULL, NULL, NULL),
(3314, '2016-07-17 11:41:06', NULL, NULL, 1133, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 11:41:06', 'Staff-1468724310-1468726866322719', 1, 0, '', NULL, NULL, NULL),
(3315, '2016-07-17 11:41:06', NULL, NULL, 1133, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 11:41:06', 'Staff-1468724310-1468726866322719', 1, 1, 'SR', NULL, NULL, NULL),
(3316, '2016-07-17 11:30:05', NULL, NULL, 1132, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 11:30:05', 'Staff-1468724310-14687262056468666', 1, 1, 'SR', NULL, NULL, NULL),
(3317, '2016-07-17 11:30:05', NULL, NULL, 1132, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 11:30:05', 'Staff-1468724310-14687262056468666', 1, 0, '', NULL, NULL, NULL),
(3318, '2016-07-17 11:08:03', NULL, NULL, 1131, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 11:08:03', 'Staff-1468724310-14687248835254496', 1, 0, '', NULL, NULL, NULL),
(3319, '2016-07-17 11:08:03', NULL, NULL, 1131, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 11:08:03', 'Staff-1468724310-14687248835254496', 1, 1, 'SR', NULL, NULL, NULL),
(3320, '2016-07-17 11:08:03', NULL, NULL, 1131, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 11:08:03', 'Staff-1468724310-14687248835254496', 1, 1, 'SR', NULL, NULL, NULL),
(3321, '2016-07-17 11:30:05', NULL, NULL, 1132, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 11:30:05', 'Staff-1468724310-14687262056468666', 1, 0, '', NULL, NULL, NULL),
(3322, '2016-07-17 10:43:17', NULL, NULL, 1127, 0, 203, '138', 'Fruitea ', '', 'Cold Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:43:17', 'admin-1468717848-14687233969421815', 1, 0, '', NULL, NULL, NULL),
(3323, '2016-07-17 10:46:10', NULL, NULL, 1128, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:46:10', 'admin-1468717848-14687235699395335', 1, 0, '', NULL, NULL, NULL),
(3324, '2016-07-17 10:46:10', NULL, NULL, 1128, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:46:10', 'admin-1468717848-14687235699395335', 1, 0, '', NULL, NULL, NULL),
(3325, '2016-07-17 10:46:10', NULL, NULL, 1128, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:46:10', 'admin-1468717848-14687235699395335', 1, 0, '', NULL, NULL, NULL),
(3326, '2016-07-17 10:46:10', NULL, NULL, 1128, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:46:10', 'admin-1468717848-14687235699395335', 1, 0, '', NULL, NULL, NULL),
(3327, '2016-07-17 10:46:10', NULL, NULL, 1128, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:46:10', 'admin-1468717848-14687235699395335', 1, 0, '', NULL, NULL, NULL),
(3328, '2016-07-17 10:46:25', NULL, NULL, 1128, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:46:25', 'admin-1468717848-1468723585424273', 1, 1, 'SR', NULL, NULL, NULL),
(3329, '2016-07-17 10:46:25', NULL, NULL, 1128, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:46:25', 'admin-1468717848-1468723585424273', 1, 1, 'SR', NULL, NULL, NULL),
(3330, '2016-07-17 10:46:25', NULL, NULL, 1128, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:46:25', 'admin-1468717848-1468723585424273', 1, 1, 'SR', NULL, NULL, NULL),
(3331, '2016-07-17 10:46:25', NULL, NULL, 1128, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:46:25', 'admin-1468717848-1468723585424273', 1, 1, 'SR', NULL, NULL, NULL),
(3332, '2016-07-17 10:58:20', NULL, NULL, 1129, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:58:20', 'admin-1468717848-14687243005318350', 1, 0, '', NULL, NULL, NULL),
(3333, '2016-07-17 10:58:20', NULL, NULL, 1129, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:58:20', 'admin-1468717848-14687243005318350', 1, 0, '', NULL, NULL, NULL),
(3334, '2016-07-17 11:04:08', NULL, NULL, 1130, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 11:04:08', 'Staff-1468724310-14687246487481736', 1, 1, 'SR', NULL, NULL, NULL),
(3335, '2016-07-17 11:04:08', NULL, NULL, 1130, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 11:04:08', 'Staff-1468724310-14687246487481736', 1, 1, 'SR', NULL, NULL, NULL),
(3336, '2016-07-17 11:08:03', NULL, NULL, 1131, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468766326', 'Staff', '2016-07-17 11:08:03', 'Staff-1468724310-14687248835254496', 1, 0, '', NULL, NULL, NULL),
(3337, '2016-07-17 10:06:32', NULL, NULL, 1124, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:06:32', 'admin-1468717848-14687211925383178', 1, 0, '', NULL, NULL, NULL),
(3338, '2016-07-17 10:06:49', NULL, NULL, 1125, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:06:49', 'admin-1468717848-14687212097358550', 1, 0, '', NULL, NULL, NULL),
(3339, '2016-07-17 10:06:49', NULL, NULL, 1125, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:06:49', 'admin-1468717848-14687212097358550', 1, 0, '', NULL, NULL, NULL),
(3340, '2016-07-17 10:06:49', NULL, NULL, 1125, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:06:49', 'admin-1468717848-14687212097358550', 1, 1, 'SR', NULL, NULL, NULL),
(3341, '2016-07-17 10:06:49', NULL, NULL, 1125, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:06:49', 'admin-1468717848-14687212097358550', 1, 1, 'SR', NULL, NULL, NULL),
(3342, '2016-07-17 10:23:20', NULL, NULL, 1126, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:23:20', 'admin-1468717848-14687222001186772', 1, 0, '', NULL, NULL, NULL),
(3343, '2016-07-17 10:23:20', NULL, NULL, 1126, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:23:20', 'admin-1468717848-14687222001186772', 1, 0, '', NULL, NULL, NULL),
(3344, '2016-07-17 10:23:20', NULL, NULL, 1126, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:23:20', 'admin-1468717848-14687222001186772', 1, 1, 'SR', NULL, NULL, NULL),
(3345, '2016-07-17 10:23:20', NULL, NULL, 1126, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:23:20', 'admin-1468717848-14687222001186772', 1, 1, 'SR', NULL, NULL, NULL),
(3346, '2016-07-17 10:41:44', NULL, NULL, 1127, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:41:44', 'admin-1468717848-14687233041566559', 1, 0, '', NULL, NULL, NULL),
(3347, '2016-07-17 10:41:44', NULL, NULL, 1127, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:41:44', 'admin-1468717848-14687233041566559', 1, 0, '', NULL, NULL, NULL),
(3348, '2016-07-17 10:06:32', NULL, NULL, 1124, 0, 153, '87', 'Big Breakfast ', 'x bacons', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:06:32', 'admin-1468717848-14687211925383178', 1, 0, '', NULL, NULL, NULL),
(3349, '2016-07-17 10:06:32', NULL, NULL, 1124, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:06:32', 'admin-1468717848-14687211925383178', 1, 1, 'SR', NULL, NULL, NULL),
(3350, '2016-07-17 10:06:32', NULL, NULL, 1124, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:06:32', 'admin-1468717848-14687211925383178', 1, 1, 'SR', NULL, NULL, NULL),
(3351, '2016-07-17 10:06:32', NULL, NULL, 1124, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:06:32', 'admin-1468717848-14687211925383178', 1, 1, 'SR', NULL, NULL, NULL),
(3352, '2016-07-17 10:06:32', NULL, NULL, 1124, 0, 153, '87', 'Big Breakfast ', 'x bacons', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:06:32', 'admin-1468717848-14687211925383178', 1, 0, '', NULL, NULL, NULL),
(3353, '2016-07-17 10:06:32', NULL, NULL, 1124, 0, 158, '92', 'Nutella Toast ', 'w/o banana', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 10:06:32', 'admin-1468717848-14687211925383178', 1, 0, '', NULL, NULL, NULL),
(3354, '2016-07-17 09:42:07', NULL, NULL, 1122, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 09:42:07', 'admin-1468717848-14687197275883688', 1, 1, 'SR', NULL, NULL, NULL),
(3355, '2016-07-17 09:51:53', NULL, NULL, 1123, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 09:51:53', 'admin-1468717848-14687203136323668', 1, 1, 'SR', NULL, NULL, NULL),
(3356, '2016-07-17 09:42:07', NULL, NULL, 1122, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 09:42:07', 'admin-1468717848-14687197275883688', 1, 1, 'SR', NULL, NULL, NULL),
(3357, '2016-07-17 09:42:07', NULL, NULL, 1122, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 09:42:07', 'admin-1468717848-14687197275883688', 1, 1, 'SR', NULL, NULL, NULL),
(3358, '2016-07-17 09:41:13', NULL, NULL, 1122, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468766326', 'admin', '2016-07-17 09:41:13', 'admin-1468717848-14687196733146372', 1, 1, 'SR', NULL, NULL, NULL),
(3359, '2016-07-18 15:56:23', NULL, NULL, 1203, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 15:56:23', 'admin-1468812919-14688285837043418', 1, 1, 'SR', NULL, NULL, NULL),
(3360, '2016-07-18 15:56:23', NULL, NULL, 1203, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 15:56:23', 'admin-1468812919-14688285837043418', 1, 1, 'SR', NULL, NULL, NULL),
(3361, '2016-07-18 16:44:23', NULL, NULL, 1202, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 16:44:23', 'admin-1468812919-14688314629837273', 1, 1, 'SR', NULL, NULL, NULL),
(3362, '2016-07-18 18:29:06', NULL, NULL, 1204, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 18:29:06', 'admin-1468837722-1468837746398731', 1, 1, 'SR', NULL, NULL, NULL),
(3363, '2016-07-18 18:29:06', NULL, NULL, 1204, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 18:29:06', 'admin-1468837722-1468837746398731', 1, 1, 'SR', NULL, NULL, NULL),
(3364, '2016-07-18 18:29:06', NULL, NULL, 1204, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 18:29:06', 'admin-1468837722-1468837746398731', 1, 0, '', NULL, NULL, NULL),
(3365, '2016-07-18 18:36:30', NULL, NULL, 1205, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 18:36:30', 'admin-1468837722-14688381901638917', 1, 1, 'SR', NULL, NULL, NULL),
(3366, '2016-07-18 18:43:56', NULL, NULL, 1206, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 18:43:56', 'admin-1468837722-1468838636811895', 1, 0, '', NULL, NULL, NULL),
(3367, '2016-07-18 18:43:57', NULL, NULL, 1206, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 18:43:57', 'admin-1468837722-1468838636811895', 1, 1, 'SR', NULL, NULL, NULL),
(3368, '2016-07-18 18:43:57', NULL, NULL, 1206, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 18:43:57', 'admin-1468837722-1468838636811895', 1, 1, 'SR', NULL, NULL, NULL),
(3369, '2016-07-18 19:13:40', NULL, NULL, 1207, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 19:13:40', 'admin-1468840398-14688404203843538', 1, 1, 'SR', NULL, NULL, NULL),
(3370, '2016-07-18 19:33:48', NULL, NULL, 1208, 0, 199, '134', 'Dinner - Marmite Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 19:33:48', 'admin-1468840398-14688416281641398', 1, 0, '', NULL, NULL, NULL),
(3371, '2016-07-18 19:33:48', NULL, NULL, 1208, 0, 181, '116', 'Open Food ', 'Dinner Braised Pork', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 19:33:48', 'admin-1468840398-14688416281641398', 1, 0, '', NULL, NULL, NULL),
(3372, '2016-07-18 19:33:48', NULL, NULL, 1208, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 19:33:48', 'admin-1468840398-14688416281641398', 1, 0, '', NULL, NULL, NULL),
(3373, '2016-07-18 19:33:48', NULL, NULL, 1208, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 19:33:48', 'admin-1468840398-14688416281641398', 1, 0, '', NULL, NULL, NULL),
(3374, '2016-07-18 20:14:54', NULL, NULL, 1212, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 20:14:54', 'admin-1468840398-14688440941842391', 1, 1, 'SR', NULL, NULL, NULL),
(3375, '2016-07-18 20:14:54', NULL, NULL, 1212, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 20:14:54', 'admin-1468840398-14688440941842391', 1, 1, 'SR', NULL, NULL, NULL),
(3376, '2016-07-18 19:39:30', NULL, NULL, 1209, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 19:39:30', 'admin-1468840398-14688419701121368', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(3377, '2016-07-18 19:39:30', NULL, NULL, 1209, 0, 181, '116', 'Open Food ', '', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 19:39:30', 'admin-1468840398-14688419701121368', 1, 0, '', NULL, NULL, NULL),
(3378, '2016-07-18 19:39:30', NULL, NULL, 1209, 0, 181, '116', 'Open Food ', 'Braised pork', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 19:39:30', 'admin-1468840398-14688419701121368', 1, 0, '', NULL, NULL, NULL),
(3379, '2016-07-18 19:49:45', NULL, NULL, 1210, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 19:49:45', 'admin-1468840398-14688425853941378', 1, 1, 'SR', NULL, NULL, NULL),
(3380, '2016-07-18 19:49:45', NULL, NULL, 1210, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 19:49:45', 'admin-1468840398-14688425853941378', 1, 1, 'SR', NULL, NULL, NULL),
(3381, '2016-07-18 19:59:05', NULL, NULL, 1211, 0, 197, '132', 'Dinner - Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 19:59:05', 'admin-1468840398-14688431456007182', 1, 0, '', NULL, NULL, NULL),
(3382, '2016-07-18 19:35:15', NULL, NULL, 1208, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 19:35:15', 'admin-1468840398-1468841715759138', 1, 1, 'SR', NULL, NULL, NULL),
(3383, '2016-07-18 19:33:48', NULL, NULL, 1208, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 19:33:48', 'admin-1468840398-14688416281641398', 1, 0, '', NULL, NULL, NULL),
(3384, '2016-07-18 14:51:31', NULL, NULL, 1201, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 14:51:31', 'admin-1468812919-14688246912318342', 1, 1, 'SR', NULL, NULL, NULL),
(3385, '2016-07-18 15:55:56', NULL, NULL, 1202, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 15:55:56', 'admin-1468812919-14688285561446157', 1, 0, '', NULL, NULL, NULL),
(3386, '2016-07-18 15:55:56', NULL, NULL, 1202, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 15:55:56', 'admin-1468812919-14688285561446157', 1, 0, '', NULL, NULL, NULL),
(3387, '2016-07-18 14:50:41', NULL, NULL, 1200, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 14:50:41', 'admin-1468812919-1468824641302566', 1, 1, 'SR', NULL, NULL, NULL),
(3388, '2016-07-18 14:50:41', NULL, NULL, 1200, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 14:50:41', 'admin-1468812919-1468824641302566', 1, 1, 'SR', NULL, NULL, NULL),
(3389, '2016-07-18 15:56:23', NULL, NULL, 1203, 0, 193, '128', 'Braised Potato with Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 15:56:23', 'admin-1468812919-14688285837043418', 1, 0, '', NULL, NULL, NULL),
(3390, '2016-07-18 14:51:31', NULL, NULL, 1201, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 14:51:31', 'admin-1468812919-14688246912318342', 1, 1, 'SR', NULL, NULL, NULL),
(3391, '2016-07-18 14:51:31', NULL, NULL, 1201, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 14:51:31', 'admin-1468812919-14688246912318342', 1, 1, 'SR', NULL, NULL, NULL),
(3392, '2016-07-18 11:28:40', NULL, NULL, 1191, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 11:28:40', 'admin-1468804386-14688125202138814', 1, 0, '', NULL, NULL, NULL),
(3393, '2016-07-18 11:29:37', NULL, NULL, 1192, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 11:29:37', 'admin-1468804386-14688125771453647', 1, 1, 'SR', NULL, NULL, NULL),
(3394, '2016-07-18 11:29:37', NULL, NULL, 1192, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 11:29:37', 'admin-1468804386-14688125771453647', 1, 1, 'SR', NULL, NULL, NULL),
(3395, '2016-07-18 11:32:38', NULL, NULL, 1193, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 11:32:38', 'admin-1468804386-14688127579409259', 1, 1, 'SR', NULL, NULL, NULL),
(3396, '2016-07-18 11:32:38', NULL, NULL, 1193, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 11:32:38', 'admin-1468804386-14688127579409259', 1, 1, 'SR', NULL, NULL, NULL),
(3397, '2016-07-18 14:07:00', NULL, NULL, 1199, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 14:07:00', 'admin-1468812919-14688220198528148', 1, 1, 'SR', NULL, NULL, NULL),
(3398, '2016-07-18 14:07:00', NULL, NULL, 1199, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 14:07:00', 'admin-1468812919-14688220198528148', 1, 1, 'SR', NULL, NULL, NULL),
(3399, '2016-07-18 13:16:38', NULL, NULL, 1198, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 13:16:38', 'admin-1468812919-14688189985425532', 1, 1, 'SR', NULL, NULL, NULL),
(3400, '2016-07-18 13:16:17', NULL, NULL, 1197, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 13:16:17', 'admin-1468812919-14688189770934514', 1, 0, '', NULL, NULL, NULL),
(3401, '2016-07-18 13:16:09', NULL, NULL, 1198, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 13:16:09', 'admin-1468812919-14688189693973542', 1, 0, '', NULL, NULL, NULL),
(3402, '2016-07-18 12:50:45', NULL, NULL, 1197, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 12:50:45', 'admin-1468812919-14688174456265435', 1, 1, 'SR', NULL, NULL, NULL),
(3403, '2016-07-18 12:50:45', NULL, NULL, 1197, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 12:50:45', 'admin-1468812919-14688174456265435', 1, 1, 'SR', NULL, NULL, NULL),
(3404, '2016-07-18 12:49:50', NULL, NULL, 1197, 0, 193, '128', 'Braised Potato with Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 12:49:50', 'admin-1468812919-14688173904657671', 1, 0, '', NULL, NULL, NULL),
(3405, '2016-07-18 12:49:50', NULL, NULL, 1197, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 12:49:50', 'admin-1468812919-14688173904657671', 1, 1, 'SR', NULL, NULL, NULL),
(3406, '2016-07-18 12:08:43', NULL, NULL, 1196, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 12:08:43', 'admin-1468812919-14688149231884211', 1, 1, 'SR', NULL, NULL, NULL),
(3407, '2016-07-18 12:08:43', NULL, NULL, 1196, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 12:08:43', 'admin-1468812919-14688149231884211', 1, 1, 'SR', NULL, NULL, NULL),
(3408, '2016-07-18 11:35:11', NULL, NULL, 1194, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 11:35:11', 'admin-1468804386-14688129117245632', 1, 0, '', NULL, NULL, NULL),
(3409, '2016-07-18 11:35:11', NULL, NULL, 1194, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 11:35:11', 'admin-1468804386-14688129117245632', 1, 0, '', NULL, NULL, NULL),
(3410, '2016-07-18 11:24:44', NULL, NULL, 1186, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 11:24:44', 'admin-1468804386-14688122847608861', 1, 1, 'SR', NULL, NULL, NULL),
(3411, '2016-07-18 11:24:44', NULL, NULL, 1186, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 11:24:44', 'admin-1468804386-14688122847608861', 1, 1, 'SR', NULL, NULL, NULL),
(3412, '2016-07-18 11:24:44', NULL, NULL, 1186, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 11:24:44', 'admin-1468804386-14688122847608861', 1, 1, 'SR', NULL, NULL, NULL),
(3413, '2016-07-18 11:26:46', NULL, NULL, 1189, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 11:26:46', 'admin-1468804386-14688124065264254', 1, 0, '', NULL, NULL, NULL),
(3414, '2016-07-18 11:26:46', NULL, NULL, 1189, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 11:26:46', 'admin-1468804386-14688124065264254', 1, 0, '', NULL, NULL, NULL),
(3415, '2016-07-18 11:26:46', NULL, NULL, 1189, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 11:26:46', 'admin-1468804386-14688124065264254', 1, 1, 'SR', NULL, NULL, NULL),
(3416, '2016-07-18 11:27:58', NULL, NULL, 1190, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 11:27:58', 'admin-1468804386-14688124785596197', 1, 0, '', NULL, NULL, NULL),
(3417, '2016-07-18 11:27:58', NULL, NULL, 1190, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 11:27:58', 'admin-1468804386-14688124785596197', 1, 1, 'SR', NULL, NULL, NULL),
(3418, '2016-07-18 11:27:58', NULL, NULL, 1190, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 11:27:58', 'admin-1468804386-14688124785596197', 1, 1, 'SR', NULL, NULL, NULL),
(3419, '2016-07-18 11:27:58', NULL, NULL, 1190, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 11:27:58', 'admin-1468804386-14688124785596197', 1, 0, '', NULL, NULL, NULL),
(3420, '2016-07-18 11:28:40', NULL, NULL, 1191, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 11:28:40', 'admin-1468804386-14688125202138814', 1, 0, '', NULL, NULL, NULL),
(3421, '2016-07-18 10:38:26', NULL, NULL, 1187, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 10:38:26', 'admin-1468804386-14688095065353662', 1, 0, '', NULL, NULL, NULL),
(3422, '2016-07-18 10:38:26', NULL, NULL, 1187, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 10:38:26', 'admin-1468804386-14688095065353662', 1, 0, '', NULL, NULL, NULL),
(3423, '2016-07-18 10:38:26', NULL, NULL, 1187, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 10:38:26', 'admin-1468804386-14688095065353662', 1, 1, 'SR', NULL, NULL, NULL),
(3424, '2016-07-18 11:03:15', NULL, NULL, 1188, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 11:03:15', 'admin-1468804386-14688109954675955', 1, 1, 'SR', NULL, NULL, NULL),
(3425, '2016-07-18 10:07:04', NULL, NULL, 1187, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 10:07:04', 'admin-1468804386-1468807623895626', 1, 1, 'SR', NULL, NULL, NULL),
(3426, '2016-07-18 09:55:43', NULL, NULL, 1186, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 09:55:43', 'admin-1468804386-14688069434312831', 1, 0, '', NULL, NULL, NULL),
(3427, '2016-07-18 09:55:43', NULL, NULL, 1186, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 09:55:43', 'admin-1468804386-14688069434312831', 1, 0, '', NULL, NULL, NULL),
(3428, '2016-07-18 09:55:43', NULL, NULL, 1186, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 09:55:43', 'admin-1468804386-14688069434312831', 1, 0, '', NULL, NULL, NULL),
(3429, '2016-07-18 09:55:13', NULL, NULL, 1186, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 09:55:13', 'admin-1468804386-14688069133463968', 1, 1, 'SR', NULL, NULL, NULL),
(3430, '2016-07-18 09:55:13', NULL, NULL, 1186, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 09:55:13', 'admin-1468804386-14688069133463968', 1, 1, 'SR', NULL, NULL, NULL),
(3431, '2016-07-18 09:16:00', NULL, NULL, 1184, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468848073', 'admin', '2016-07-18 09:16:00', 'admin-1468804386-14688045599526895', 1, 1, 'SR', NULL, NULL, NULL),
(3432, '2016-07-19 19:42:53', NULL, NULL, 1237, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 19:42:53', 'admin-1468925175-14689285731147961', 1, 1, 'SR', NULL, NULL, NULL),
(3433, '2016-07-19 19:44:02', NULL, NULL, 1237, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 19:44:02', 'admin-1468925175-14689286422268080', 1, 0, '', NULL, NULL, NULL),
(3434, '2016-07-19 19:44:02', NULL, NULL, 1237, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 19:44:02', 'admin-1468925175-14689286422268080', 1, 0, '', NULL, NULL, NULL),
(3435, '2016-07-19 19:53:33', NULL, NULL, 1241, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 19:53:33', 'admin-1468925175-1468929213542861', 1, 1, 'SR', NULL, NULL, NULL),
(3436, '2016-07-19 15:08:55', NULL, NULL, 1229, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 15:08:55', 'admin-1468911956-14689121353257135', 1, 0, '', NULL, NULL, NULL),
(3437, '2016-07-19 15:12:48', NULL, NULL, 1230, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 15:12:48', 'admin-1468911956-14689123678542737', 1, 1, 'SR', NULL, NULL, NULL),
(3438, '2016-07-19 15:12:48', NULL, NULL, 1230, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 15:12:48', 'admin-1468911956-14689123678542737', 1, 1, 'SR', NULL, NULL, NULL),
(3439, '2016-07-19 15:12:48', NULL, NULL, 1230, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 15:12:48', 'admin-1468911956-14689123678542737', 1, 1, 'SR', NULL, NULL, NULL),
(3440, '2016-07-19 15:23:36', NULL, NULL, 1221, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 15:23:36', 'admin-1468911956-14689130160858124', 1, 1, 'SR', NULL, NULL, NULL),
(3441, '2016-07-19 15:42:28', NULL, NULL, 1231, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 15:42:28', 'admin-1468911956-14689141478493352', 1, 0, '', NULL, NULL, NULL),
(3442, '2016-07-19 15:42:28', NULL, NULL, 1231, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 15:42:28', 'admin-1468911956-14689141478493352', 1, 1, 'SR', NULL, NULL, NULL),
(3443, '2016-07-19 00:00:00', NULL, NULL, 1232, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 12:49:41', 'Staff-1468889111-14689037816941886', 1, 1, 'SR', NULL, NULL, NULL),
(3444, '2016-07-19 16:33:00', NULL, NULL, 1234, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 16:33:00', 'admin-1468911956-1468917180711876', 1, 1, 'SR', 1, NULL, NULL),
(3445, '2016-07-19 16:33:00', NULL, NULL, 1234, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 16:33:00', 'admin-1468911956-1468917180711876', 1, 0, '', 1, NULL, NULL),
(3446, '2016-07-19 16:33:22', NULL, NULL, 1234, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 16:33:22', 'admin-1468911956-14689172026399966', 1, 0, '', 1, NULL, NULL),
(3447, '2016-07-19 16:44:53', NULL, NULL, 1231, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 16:44:53', 'admin-1468911956-14689178936666864', 1, 1, 'SR', NULL, NULL, NULL),
(3448, '2016-07-19 16:48:27', NULL, NULL, 1235, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 16:48:27', 'admin-1468911956-14689181076769253', 1, 1, 'SR', 1, NULL, NULL),
(3449, '2016-07-19 19:42:53', NULL, NULL, 1237, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 19:42:53', 'admin-1468925175-14689285731147961', 1, 0, '', NULL, NULL, NULL),
(3450, '2016-07-19 19:42:53', NULL, NULL, 1237, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 19:42:53', 'admin-1468925175-14689285731147961', 1, 0, '', NULL, NULL, NULL),
(3451, '2016-07-19 19:31:10', NULL, NULL, 1240, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 19:31:10', 'admin-1468925175-14689278699783468', 1, 1, 'SR', NULL, NULL, NULL),
(3452, '2016-07-19 19:31:10', NULL, NULL, 1240, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 19:31:10', 'admin-1468925175-14689278699783468', 1, 1, 'SR', NULL, NULL, NULL),
(3453, '2016-07-19 19:30:25', NULL, NULL, 1240, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 19:30:25', 'admin-1468925175-14689278257678282', 1, 1, 'SR', NULL, NULL, NULL),
(3454, '2016-07-19 19:30:15', NULL, NULL, 1240, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 19:30:15', 'admin-1468925175-14689278152775456', 1, 1, 'SR', NULL, NULL, NULL),
(3455, '2016-07-19 18:51:38', NULL, NULL, 1237, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 18:51:38', 'admin-1468925175-14689254987293333', 1, 0, '', NULL, NULL, NULL),
(3456, '2016-07-19 18:51:38', NULL, NULL, 1237, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 18:51:38', 'admin-1468925175-14689254987293333', 1, 0, '', NULL, NULL, NULL),
(3457, '2016-07-19 18:51:52', NULL, NULL, 1237, 0, 203, '138', 'Fruitea ', '', 'Cold Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 18:51:52', 'admin-1468925175-14689255122318848', 1, 0, '', NULL, NULL, NULL),
(3458, '2016-07-19 18:52:07', NULL, NULL, 1238, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 18:52:07', 'admin-1468925175-14689255272489414', 1, 1, 'SR', NULL, NULL, NULL),
(3459, '2016-07-19 18:52:07', NULL, NULL, 1238, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 18:52:07', 'admin-1468925175-14689255272489414', 1, 1, 'SR', NULL, NULL, NULL),
(3460, '2016-07-19 19:24:21', NULL, NULL, 1239, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 19:24:21', 'admin-1468925175-14689274612925756', 1, 1, 'SR', NULL, NULL, NULL),
(3461, '2016-07-19 18:51:38', NULL, NULL, 1237, 0, 198, '133', 'Dinner - Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 18:51:38', 'admin-1468925175-14689254987293333', 1, 0, '', NULL, NULL, NULL),
(3462, '2016-07-19 18:51:38', NULL, NULL, 1237, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 18:51:38', 'admin-1468925175-14689254987293333', 1, 0, '', NULL, NULL, NULL),
(3463, '2016-07-19 15:07:57', NULL, NULL, 1229, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 15:07:57', 'admin-1468911956-1468912077333619', 1, 1, 'SR', NULL, NULL, NULL),
(3464, '2016-07-19 15:07:57', NULL, NULL, 1229, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 15:07:57', 'admin-1468911956-1468912077333619', 1, 1, 'SR', NULL, NULL, NULL),
(3465, '2016-07-19 15:07:57', NULL, NULL, 1229, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 15:07:57', 'admin-1468911956-1468912077333619', 1, 0, '', NULL, NULL, NULL),
(3466, '2016-07-19 16:15:16', NULL, NULL, 1233, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 16:15:16', 'admin-1468911956-14689161166042168', 1, 1, 'SR', 1, NULL, NULL),
(3467, '2016-07-19 14:00:05', NULL, NULL, 1227, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 14:00:05', 'admin-1468903791-1468908005738632', 1, 1, 'SR', NULL, NULL, NULL),
(3468, '2016-07-19 18:47:45', NULL, NULL, 1236, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 18:47:45', 'admin-1468925175-1468925265633406', 1, 1, 'SR', NULL, NULL, NULL),
(3469, '2016-07-19 15:07:57', NULL, NULL, 1229, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 15:07:57', 'admin-1468911956-1468912077333619', 1, 1, 'SR', NULL, NULL, NULL),
(3470, '2016-07-19 15:07:57', NULL, NULL, 1229, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 15:07:57', 'admin-1468911956-1468912077333619', 1, 1, 'SR', NULL, NULL, NULL),
(3471, '2016-07-19 14:18:43', NULL, NULL, 1228, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 14:18:43', 'admin-1468903791-14689091231548070', 1, 1, 'SR', NULL, NULL, NULL),
(3472, '2016-07-19 14:18:43', NULL, NULL, 1228, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 14:18:43', 'admin-1468903791-14689091231548070', 1, 1, 'SR', NULL, NULL, NULL),
(3473, '2016-07-19 14:18:43', NULL, NULL, 1228, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 14:18:43', 'admin-1468903791-14689091231548070', 1, 1, 'SR', NULL, NULL, NULL),
(3474, '2016-07-19 14:00:05', NULL, NULL, 1227, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 14:00:05', 'admin-1468903791-1468908005738632', 1, 1, 'SR', NULL, NULL, NULL),
(3475, '2016-07-19 13:58:09', NULL, NULL, 1221, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 13:58:09', 'admin-1468903791-1468907889158276', 1, 1, 'SR', NULL, NULL, NULL),
(3476, '2016-07-19 13:33:56', NULL, NULL, 1225, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 13:33:56', 'admin-1468903791-14689064366376785', 1, 1, 'SR', 1, NULL, NULL),
(3477, '2016-07-19 13:33:56', NULL, NULL, 1225, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 13:33:56', 'admin-1468903791-14689064366376785', 1, 1, 'SR', 1, NULL, NULL),
(3478, '2016-07-19 13:28:05', NULL, NULL, 1224, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 13:28:05', 'admin-1468903791-1468906085683718', 1, 1, 'SR', 1, NULL, NULL),
(3479, '2016-07-19 13:28:05', NULL, NULL, 1224, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 13:28:05', 'admin-1468903791-1468906085683718', 1, 1, 'SR', 1, NULL, NULL),
(3480, '2016-07-19 13:28:05', NULL, NULL, 1224, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 13:28:05', 'admin-1468903791-1468906085683718', 1, 1, 'SR', 1, NULL, NULL),
(3481, '2016-07-19 13:27:07', NULL, NULL, 1223, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 13:27:07', 'admin-1468903791-14689060273522361', 1, 1, 'SR', 1, NULL, NULL),
(3482, '2016-07-19 13:27:07', NULL, NULL, 1223, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 13:27:07', 'admin-1468903791-14689060273522361', 1, 1, 'SR', 1, NULL, NULL),
(3483, '2016-07-19 13:27:07', NULL, NULL, 1223, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 13:27:07', 'admin-1468903791-14689060273522361', 1, 1, 'SR', 1, NULL, NULL),
(3484, '2016-07-19 13:23:53', NULL, NULL, 1222, 0, 83, '83', 'Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 13:23:53', 'admin-1468903791-14689058336476892', 1, 1, 'SR', NULL, NULL, NULL),
(3485, '2016-07-19 00:00:00', NULL, NULL, 1232, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 13:58:09', 'admin-1468903791-1468907889158276', 1, 1, 'SR', NULL, NULL, NULL),
(3486, '2016-07-19 13:23:53', NULL, NULL, 1222, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468930438', 'admin', '2016-07-19 13:23:53', 'admin-1468903791-14689058336476892', 1, 1, 'SR', NULL, NULL, NULL),
(3487, '2016-07-19 12:10:29', NULL, NULL, 1217, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 12:10:29', 'Staff-1468889111-1468901429101784', 1, 0, '', NULL, NULL, NULL),
(3488, '2016-07-19 12:11:18', NULL, NULL, 1217, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 12:11:18', 'Staff-1468889111-14689014781246428', 1, 1, 'SR', NULL, NULL, NULL),
(3489, '2016-07-19 12:11:18', NULL, NULL, 1217, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 12:11:18', 'Staff-1468889111-14689014781246428', 1, 1, 'SR', NULL, NULL, NULL),
(3490, '2016-07-19 12:22:13', NULL, NULL, 1218, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 12:22:13', 'Staff-1468889111-1468902133636584', 1, 0, '', NULL, NULL, NULL),
(3491, '2016-07-19 12:22:13', NULL, NULL, 1218, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 12:22:13', 'Staff-1468889111-1468902133636584', 1, 1, 'SR', NULL, NULL, NULL),
(3492, '2016-07-19 12:22:13', NULL, NULL, 1218, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 12:22:13', 'Staff-1468889111-1468902133636584', 1, 0, '', NULL, NULL, NULL),
(3493, '2016-07-19 12:39:23', NULL, NULL, 1219, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 12:39:23', 'Staff-1468889111-14689031638265889', 1, 1, 'SR', NULL, NULL, NULL),
(3494, '2016-07-19 12:39:23', NULL, NULL, 1219, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 12:39:23', 'Staff-1468889111-14689031638265889', 1, 1, 'SR', NULL, NULL, NULL),
(3495, '2016-07-19 12:39:24', NULL, NULL, 1219, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 12:39:24', 'Staff-1468889111-14689031638265889', 1, 1, 'SR', NULL, NULL, NULL),
(3496, '2016-07-19 12:43:36', NULL, NULL, 1220, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 12:43:36', 'Staff-1468889111-14689034165766516', 1, 0, '', NULL, NULL, NULL),
(3497, '2016-07-19 12:43:36', NULL, NULL, 1220, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 12:43:36', 'Staff-1468889111-14689034165766516', 1, 0, '', NULL, NULL, NULL),
(3498, '2016-07-19 12:43:36', NULL, NULL, 1220, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 12:43:36', 'Staff-1468889111-14689034165766516', 1, 0, '', NULL, NULL, NULL),
(3499, '2016-07-19 11:47:47', NULL, NULL, 1216, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 11:47:47', 'Staff-1468889111-14689000673889381', 1, 1, 'SR', 1, NULL, NULL),
(3500, '2016-07-19 12:06:38', NULL, NULL, 1215, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 12:06:38', 'Staff-1468889111-14689011978009765', 1, 1, 'SR', NULL, NULL, NULL),
(3501, '2016-07-19 12:10:29', NULL, NULL, 1217, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 12:10:29', 'Staff-1468889111-1468901429101784', 1, 0, '', NULL, NULL, NULL),
(3502, '2016-07-19 12:10:29', NULL, NULL, 1217, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 12:10:29', 'Staff-1468889111-1468901429101784', 1, 0, '', NULL, NULL, NULL),
(3503, '2016-07-19 10:54:43', NULL, NULL, 1215, 0, 181, '116', 'Open Food ', 'add on baked beans', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 10:54:43', 'Staff-1468889111-14688968836563656', 1, 0, '', NULL, NULL, NULL),
(3504, '2016-07-19 10:45:06', NULL, NULL, 1214, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 10:45:06', 'Staff-1468889111-14688963060082711', 1, 0, '', NULL, NULL, NULL),
(3505, '2016-07-19 10:45:06', NULL, NULL, 1214, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 10:45:06', 'Staff-1468889111-14688963060082711', 1, 1, 'SR', NULL, NULL, NULL),
(3506, '2016-07-19 10:54:27', NULL, NULL, 1215, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 10:54:27', 'Staff-1468889111-14688968671392199', 1, 0, '', NULL, NULL, NULL),
(3507, '2016-07-19 10:06:28', NULL, NULL, 1213, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 10:06:28', 'Staff-1468889111-14688939882467076', 1, 1, 'SR', 1, NULL, NULL),
(3508, '2016-07-19 10:45:06', NULL, NULL, 1214, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 10:45:06', 'Staff-1468889111-14688963060082711', 1, 1, 'SR', NULL, NULL, NULL),
(3509, '2016-07-19 10:06:28', NULL, NULL, 1213, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1468930438', 'Staff', '2016-07-19 10:06:28', 'Staff-1468889111-14688939882467076', 1, 0, '', 1, NULL, NULL),
(3510, '2016-07-21 19:25:45', NULL, NULL, 1262, 0, 198, '133', 'Dinner - Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 19:25:45', 'admin-1469075931-14691003456768634', 1, 0, '', NULL, NULL, NULL),
(3511, '2016-07-21 18:43:05', NULL, NULL, 1261, 0, 54, '54', 'Chai Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 18:43:05', 'admin-1469075931-1469097785434317', 1, 1, 'SR', NULL, NULL, NULL),
(3512, '2016-07-21 19:25:50', NULL, NULL, 1262, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 19:25:50', 'admin-1469075931-14691003500878492', 1, 0, '', NULL, NULL, NULL),
(3513, '2016-07-21 19:34:05', NULL, NULL, 1262, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 19:34:05', 'admin-1469075931-14691008453965723', 1, 0, '', NULL, NULL, NULL),
(3514, '2016-07-21 20:03:28', NULL, NULL, 1262, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 20:03:28', 'admin-1469075931-1469102608426779', 1, 1, 'SR', NULL, NULL, NULL),
(3515, '2016-07-21 20:17:36', NULL, NULL, 1263, NULL, 57, '57', 'House Red Bottle', '', 'Cold Drinks', 'Wine', 1, 88.00, 88.0000, 0.0000, 88.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 20:17:36', 'admin-1469075931-14691034559093045', 1, 1, 'SR', NULL, NULL, '10.0'),
(3516, '2016-07-21 20:21:43', NULL, NULL, 1264, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 20:21:43', 'admin-1469075931-1469103703722956', 1, 1, 'SR', NULL, NULL, NULL),
(3517, '2016-07-21 20:21:43', NULL, NULL, 1264, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 20:21:43', 'admin-1469075931-1469103703722956', 1, 0, '', NULL, NULL, NULL),
(3518, '2016-07-21 23:17:34', NULL, NULL, 1263, 0, 181, '116', 'Open Food ', 'Artero Red Wine', 'Meals', 'Perfect Meals', 1, 110.00, 110.0000, 0.0000, 110.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 23:17:34', 'admin-1469075931-14691142540859722', 1, 0, '', NULL, NULL, '10.0'),
(3519, '2016-07-21 18:43:05', NULL, NULL, 1261, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 18:43:05', 'admin-1469075931-1469097785434317', 1, 1, 'SR', NULL, NULL, NULL),
(3520, '2016-07-21 19:25:45', NULL, NULL, 1262, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 19:25:45', 'admin-1469075931-14691003456768634', 1, 0, '', NULL, NULL, NULL),
(3521, '2016-07-21 16:21:01', NULL, NULL, 1259, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 16:21:01', 'admin-1469075931-14690892616777916', 1, 1, 'SR', NULL, NULL, NULL),
(3522, '2016-07-21 17:10:46', NULL, NULL, 1255, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 17:10:46', 'admin-1469075931-14690922465106473', 1, 0, '', NULL, NULL, NULL),
(3523, '2016-07-21 17:51:42', NULL, NULL, 1260, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 17:51:42', 'admin-1469075931-14690947021324176', 1, 1, 'SR', NULL, NULL, NULL),
(3524, '2016-07-21 17:51:42', NULL, NULL, 1260, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 17:51:42', 'admin-1469075931-14690947021324176', 1, 1, 'SR', NULL, NULL, NULL),
(3525, '2016-07-21 17:51:42', NULL, NULL, 1260, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 17:51:42', 'admin-1469075931-14690947021324176', 1, 1, 'SR', NULL, NULL, NULL),
(3526, '2016-07-21 18:43:05', NULL, NULL, 1261, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 18:43:05', 'admin-1469075931-1469097785434317', 1, 1, 'SR', NULL, NULL, NULL),
(3527, '2016-07-21 18:43:05', NULL, NULL, 1261, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 18:43:05', 'admin-1469075931-1469097785434317', 1, 1, 'SR', NULL, NULL, NULL),
(3528, '2016-07-21 14:53:05', NULL, NULL, 1255, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 14:53:05', 'admin-1469075931-14690839850002953', 1, 0, '', NULL, NULL, NULL),
(3529, '2016-07-21 14:53:15', NULL, NULL, 1256, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 14:53:15', 'admin-1469075931-14690839950467883', 1, 1, 'SR', NULL, NULL, NULL),
(3530, '2016-07-21 16:04:00', NULL, NULL, 1257, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 16:04:00', 'admin-1469075931-14690882404121824', 1, 0, '', NULL, NULL, NULL),
(3531, '2016-07-21 16:20:03', NULL, NULL, 1258, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 16:20:03', 'admin-1469075931-14690892029938234', 1, 1, 'SR', NULL, NULL, NULL),
(3532, '2016-07-21 16:21:01', NULL, NULL, 1259, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 16:21:01', 'admin-1469075931-14690892616777916', 1, 1, 'SR', NULL, NULL, NULL),
(3533, '2016-07-21 12:48:13', NULL, NULL, 1251, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 12:48:13', 'admin-1469075931-14690764929412249', 1, 0, '', NULL, NULL, NULL),
(3534, '2016-07-21 12:48:13', NULL, NULL, 1251, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 12:48:13', 'admin-1469075931-14690764929412249', 1, 0, '', NULL, NULL, NULL),
(3535, '2016-07-21 14:25:19', NULL, NULL, 1253, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 14:25:19', 'admin-1469075931-14690823190037921', 1, 1, 'SR', NULL, NULL, '10.0'),
(3536, '2016-07-21 14:10:23', NULL, NULL, 1254, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 14:10:23', 'admin-1469075931-14690814232529364', 1, 1, 'SR', NULL, NULL, NULL),
(3537, '2016-07-21 14:10:23', NULL, NULL, 1254, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 14:10:23', 'admin-1469075931-14690814232529364', 1, 0, '', NULL, NULL, NULL),
(3538, '2016-07-21 13:22:40', NULL, NULL, 1253, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 13:22:40', 'admin-1469075931-14690785598986739', 1, 1, 'SR', NULL, NULL, '10.0'),
(3539, '2016-07-21 13:22:32', NULL, NULL, 1252, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 13:22:32', 'admin-1469075931-14690785523612137', 1, 1, 'SR', NULL, NULL, NULL),
(3540, '2016-07-21 12:48:13', NULL, NULL, 1251, NULL, 65, '65', 'Pineapple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 12:48:13', 'admin-1469075931-14690764929412249', 1, 1, 'SR', NULL, NULL, NULL),
(3541, '2016-07-21 13:04:41', NULL, NULL, 1252, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 13:04:41', 'admin-1469075931-1469077481399676', 1, 0, '', NULL, NULL, NULL),
(3542, '2016-07-21 12:22:50', NULL, NULL, 1251, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 12:22:50', 'admin-1469061861-14690749701819186', 1, 1, 'SR', NULL, NULL, NULL),
(3543, '2016-07-21 12:22:50', NULL, NULL, 1251, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 12:22:50', 'admin-1469061861-14690749701819186', 1, 1, 'SR', NULL, NULL, NULL),
(3544, '2016-07-21 12:22:50', NULL, NULL, 1251, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 12:22:50', 'admin-1469061861-14690749701819186', 1, 1, 'SR', NULL, NULL, NULL),
(3545, '2016-07-21 12:46:37', NULL, NULL, 1253, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 12:46:37', 'admin-1469075931-14690763970217341', 1, 1, 'SR', NULL, NULL, '10.0'),
(3546, '2016-07-21 12:46:18', NULL, NULL, 1253, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 12:46:18', 'admin-1469075931-14690763783643158', 1, 0, '', NULL, NULL, '10.0'),
(3547, '2016-07-21 12:46:18', NULL, NULL, 1253, NULL, 84, '84', 'Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 12:46:18', 'admin-1469075931-14690763783643158', 1, 1, 'SR', NULL, NULL, '10.0'),
(3548, '2016-07-21 12:24:59', NULL, NULL, 1252, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 12:24:59', 'admin-1469061861-14690750990031243', 1, 1, 'SR', NULL, NULL, NULL),
(3549, '2016-07-21 12:39:24', NULL, NULL, 1248, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 12:39:24', 'admin-1469075931-14690759644142454', 1, 1, 'SR', NULL, NULL, NULL),
(3550, '2016-07-21 12:39:24', NULL, NULL, 1248, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 12:39:24', 'admin-1469075931-14690759644142454', 1, 1, 'SR', NULL, NULL, NULL),
(3551, '2016-07-21 12:24:59', NULL, NULL, 1252, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 12:24:59', 'admin-1469061861-14690750990031243', 1, 1, 'SR', NULL, NULL, NULL),
(3552, '2016-07-21 12:22:50', NULL, NULL, 1251, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 12:22:50', 'admin-1469061861-14690749701819186', 1, 0, '', NULL, NULL, NULL),
(3553, '2016-07-21 12:22:50', NULL, NULL, 1251, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 12:22:50', 'admin-1469061861-14690749701819186', 1, 0, '', NULL, NULL, NULL),
(3554, '2016-07-21 12:22:50', NULL, NULL, 1251, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 12:22:50', 'admin-1469061861-14690749701819186', 1, 0, '', NULL, NULL, NULL),
(3555, '2016-07-21 11:08:47', NULL, NULL, 1245, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 11:08:47', 'admin-1469061861-14690705269795232', 1, 1, 'SR', NULL, NULL, NULL),
(3556, '2016-07-21 11:08:47', NULL, NULL, 1245, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 11:08:47', 'admin-1469061861-14690705269795232', 1, 1, 'SR', NULL, NULL, NULL),
(3557, '2016-07-21 11:29:15', NULL, NULL, 1246, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 11:29:15', 'admin-1469061861-14690717553421557', 1, 1, 'SR', 1, NULL, NULL),
(3558, '2016-07-21 11:29:50', NULL, NULL, 1247, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 11:29:50', 'admin-1469061861-14690717899615928', 1, 1, 'SR', 1, NULL, NULL),
(3559, '2016-07-21 11:29:50', NULL, NULL, 1247, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 11:29:50', 'admin-1469061861-14690717899615928', 1, 0, '', 1, NULL, NULL),
(3560, '2016-07-21 11:30:22', NULL, NULL, 1248, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 11:30:22', 'admin-1469061861-1469071822506282', 1, 1, 'SR', NULL, NULL, NULL),
(3561, '2016-07-21 11:30:22', NULL, NULL, 1248, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 11:30:22', 'admin-1469061861-1469071822506282', 1, 1, 'SR', NULL, NULL, NULL),
(3562, '2016-07-21 11:30:59', NULL, NULL, 1249, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 11:30:59', 'admin-1469061861-1469071859415852', 1, 0, '', 1, NULL, NULL),
(3563, '2016-07-21 12:01:30', NULL, NULL, 1250, 0, 83, '83', 'Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 12:01:30', 'admin-1469061861-14690736906603442', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(3564, '2016-07-21 12:01:30', NULL, NULL, 1250, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 12:01:30', 'admin-1469061861-14690736906603442', 1, 1, 'SR', NULL, NULL, NULL),
(3565, '2016-07-21 12:22:50', NULL, NULL, 1251, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 12:22:50', 'admin-1469061861-14690749701819186', 1, 1, 'SR', NULL, NULL, NULL),
(3566, '2016-07-21 10:55:09', NULL, NULL, 1244, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 10:55:09', 'admin-1469061861-14690697094847018', 1, 0, '', NULL, NULL, NULL),
(3567, '2016-07-21 10:55:09', NULL, NULL, 1244, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 10:55:09', 'admin-1469061861-14690697094847018', 1, 0, '', NULL, NULL, NULL),
(3568, '2016-07-21 10:55:09', NULL, NULL, 1244, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 10:55:09', 'admin-1469061861-14690697094847018', 1, 1, 'SR', NULL, NULL, NULL),
(3569, '2016-07-21 11:08:10', NULL, NULL, 1245, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 11:08:10', 'admin-1469061861-14690704906192615', 1, 0, '', NULL, NULL, NULL),
(3570, '2016-07-21 11:08:47', NULL, NULL, 1245, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 11:08:47', 'admin-1469061861-14690705269795232', 1, 1, 'SR', NULL, NULL, NULL),
(3571, '2016-07-21 10:46:56', NULL, NULL, 1243, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 10:46:56', 'admin-1469061861-14690692161706356', 1, 1, 'SR', NULL, NULL, NULL),
(3572, '2016-07-21 10:47:15', NULL, NULL, 1243, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 10:47:15', 'admin-1469061861-1469069235720663', 1, 0, '', NULL, NULL, NULL),
(3573, '2016-07-21 10:46:56', NULL, NULL, 1243, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 10:46:56', 'admin-1469061861-14690692161706356', 1, 1, 'SR', NULL, NULL, NULL),
(3574, '2016-07-21 09:58:36', NULL, NULL, 1242, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 09:58:36', 'admin-1469061861-14690663161443974', 1, 1, 'SR', NULL, NULL, NULL),
(3575, '2016-07-21 10:46:27', NULL, NULL, 1243, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 10:46:27', 'admin-1469061861-14690691870598746', 1, 0, '', NULL, NULL, NULL),
(3576, '2016-07-21 09:58:36', NULL, NULL, 1242, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469115065', 'admin', '2016-07-21 09:58:36', 'admin-1469061861-14690663161443974', 1, 0, '', NULL, NULL, NULL),
(3577, '2016-07-22 20:49:11', NULL, NULL, 1287, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 20:49:11', 'admin-1469191556-14691917516088716', 1, 1, 'SR', NULL, NULL, NULL),
(3578, '2016-07-22 21:19:04', NULL, NULL, 1288, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 21:19:04', 'admin-1469191556-14691935443263233', 1, 0, '', NULL, NULL, NULL),
(3579, '2016-07-22 21:47:42', NULL, NULL, 1287, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 21:47:42', 'admin-1469191556-1469195262643621', 1, 0, '', NULL, NULL, NULL),
(3580, '2016-07-22 20:47:23', NULL, NULL, 1286, NULL, 57, '57', 'House Red Bottle', '', 'Cold Drinks', 'Wine', 1, 88.00, 88.0000, 0.0000, 88.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 20:47:23', 'admin-1469191556-14691916431901474', 1, 1, 'SR', NULL, NULL, NULL),
(3581, '2016-07-22 20:46:58', NULL, NULL, 1286, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 20:46:58', 'admin-1469191556-14691916179062763', 1, 1, 'SR', NULL, NULL, NULL),
(3582, '2016-07-22 20:47:50', NULL, NULL, 1286, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 20:47:50', 'admin-1469191556-14691916701655495', 1, 0, '', NULL, NULL, NULL),
(3583, '2016-07-22 20:48:59', NULL, NULL, 1287, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 20:48:59', 'admin-1469191556-14691917389623775', 1, 0, '', NULL, NULL, NULL),
(3584, '2016-07-22 20:48:59', NULL, NULL, 1287, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 20:48:59', 'admin-1469191556-14691917389623775', 1, 0, '', NULL, NULL, NULL),
(3585, '2016-07-22 20:48:59', NULL, NULL, 1287, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 20:48:59', 'admin-1469191556-14691917389623775', 1, 0, '', NULL, NULL, NULL),
(3586, '2016-07-22 20:48:59', NULL, NULL, 1287, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 20:48:59', 'admin-1469191556-14691917389623775', 1, 1, 'SR', NULL, NULL, NULL),
(3587, '2016-07-22 20:13:09', NULL, NULL, 1285, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 20:13:09', 'admin-1469148115-14691895893644417', 1, 0, '', NULL, NULL, '10.0'),
(3588, '2016-07-22 20:12:41', NULL, NULL, 1285, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 20:12:41', 'admin-1469148115-14691895609808726', 1, 0, '', NULL, NULL, '10.0'),
(3589, '2016-07-22 20:12:41', NULL, NULL, 1285, 0, 203, '138', 'Fruitea ', '', 'Cold Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 20:12:41', 'admin-1469148115-14691895609808726', 1, 0, '', NULL, NULL, '10.0'),
(3590, '2016-07-22 20:33:10', NULL, NULL, 1285, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 20:33:10', 'admin-1469148115-14691907904321826', 1, 1, 'SR', NULL, NULL, '10.0'),
(3591, '2016-07-22 17:52:31', NULL, NULL, 1281, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 17:52:31', 'admin-1469148115-14691811510556596', 1, 0, '', NULL, NULL, NULL),
(3592, '2016-07-22 17:52:31', NULL, NULL, 1281, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 17:52:31', 'admin-1469148115-14691811510556596', 1, 0, '', NULL, NULL, NULL),
(3593, '2016-07-22 20:48:59', NULL, NULL, 1287, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 20:48:59', 'admin-1469191556-14691917389623775', 1, 1, 'SR', NULL, NULL, NULL),
(3594, '2016-07-22 20:11:36', NULL, NULL, 1285, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 20:11:36', 'admin-1469148115-14691894961266719', 1, 0, '', NULL, NULL, '10.0'),
(3595, '2016-07-22 18:19:24', NULL, NULL, 1284, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 18:19:24', 'admin-1469148115-14691827642128654', 1, 0, '', NULL, NULL, NULL),
(3596, '2016-07-22 18:19:24', NULL, NULL, 1284, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 18:19:24', 'admin-1469148115-14691827642128654', 1, 0, '', NULL, NULL, NULL),
(3597, '2016-07-22 18:19:24', NULL, NULL, 1284, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 18:19:24', 'admin-1469148115-14691827642128654', 1, 1, 'SR', NULL, NULL, NULL),
(3598, '2016-07-22 17:52:31', NULL, NULL, 1281, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 17:52:31', 'admin-1469148115-14691811510556596', 1, 0, '', NULL, NULL, NULL),
(3599, '2016-07-22 17:59:06', NULL, NULL, 1283, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 17:59:06', 'admin-1469148115-14691815462103073', 1, 1, 'SR', NULL, NULL, NULL),
(3600, '2016-07-22 18:19:24', NULL, NULL, 1284, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 18:19:24', 'admin-1469148115-14691827642128654', 1, 1, 'SR', NULL, NULL, NULL),
(3601, '2016-07-22 00:00:00', NULL, NULL, 1274, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 13:06:25', 'admin-1469148115-1469163985572370', 1, 0, '', NULL, NULL, NULL),
(3602, '2016-07-22 00:00:00', NULL, NULL, 1274, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 13:24:38', 'admin-1469148115-14691650783595164', 1, 0, '', NULL, NULL, NULL),
(3603, '2016-07-22 00:00:00', NULL, NULL, 1273, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 13:06:43', 'admin-1469148115-14691640037742675', 1, 1, 'SR', NULL, NULL, NULL),
(3604, '2016-07-22 15:19:18', NULL, NULL, 1276, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 15:19:18', 'admin-1469148115-14691719584709511', 1, 1, 'SR', 1, NULL, NULL),
(3605, '2016-07-22 15:19:18', NULL, NULL, 1276, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 15:19:18', 'admin-1469148115-14691719584709511', 1, 0, '', 1, NULL, NULL),
(3606, '2016-07-22 15:23:30', NULL, NULL, 1275, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 15:23:30', 'admin-1469148115-14691722100531348', 1, 1, 'SR', NULL, NULL, NULL),
(3607, '2016-07-22 17:45:45', NULL, NULL, 1280, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 17:45:45', 'admin-1469148115-14691807455123023', 1, 1, 'SR', NULL, NULL, NULL),
(3608, '2016-07-22 17:45:45', NULL, NULL, 1280, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 17:45:45', 'admin-1469148115-14691807455123023', 1, 0, '', NULL, NULL, NULL),
(3609, '2016-07-22 16:42:50', NULL, NULL, 1279, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 16:42:50', 'admin-1469148115-14691769700612841', 1, 1, 'SR', 1, NULL, NULL),
(3610, '2016-07-22 16:42:50', NULL, NULL, 1279, NULL, 65, '65', 'Pineapple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 16:42:50', 'admin-1469148115-14691769700612841', 1, 1, 'SR', 1, NULL, NULL),
(3611, '2016-07-22 15:26:12', NULL, NULL, 1278, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 15:26:12', 'admin-1469148115-1469172371882609', 1, 1, 'SR', NULL, NULL, NULL),
(3612, '2016-07-22 15:23:53', NULL, NULL, 1277, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 15:23:53', 'admin-1469148115-14691722334354842', 1, 0, '', NULL, NULL, NULL),
(3613, '2016-07-22 15:23:30', NULL, NULL, 1275, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 15:23:30', 'admin-1469148115-14691722100531348', 1, 1, 'SR', NULL, NULL, NULL),
(3614, '2016-07-22 10:46:40', NULL, NULL, 1267, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 10:46:40', 'admin-1469148115-14691555998705610', 1, 1, 'SR', NULL, NULL, NULL),
(3615, '2016-07-22 11:06:30', NULL, NULL, 1268, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 11:06:30', 'admin-1469148115-14691567907758612', 1, 1, 'SR', NULL, NULL, NULL),
(3616, '2016-07-22 11:06:30', NULL, NULL, 1268, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 11:06:30', 'admin-1469148115-14691567907758612', 1, 1, 'SR', NULL, NULL, NULL),
(3617, '2016-07-22 11:11:15', NULL, NULL, 1268, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 11:11:16', 'admin-1469148115-14691570758467335', 1, 0, '', NULL, NULL, NULL),
(3618, '2016-07-22 11:11:16', NULL, NULL, 1268, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 11:11:16', 'admin-1469148115-14691570758467335', 1, 1, 'SR', NULL, NULL, NULL),
(3619, '2016-07-22 11:30:46', NULL, NULL, 1269, 0, 203, '138', 'Fruitea ', '', 'Cold Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 11:30:46', 'admin-1469148115-14691582462606573', 1, 0, '', NULL, NULL, NULL),
(3620, '2016-07-22 11:30:46', NULL, NULL, 1269, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 11:30:46', 'admin-1469148115-14691582462606573', 1, 0, '', NULL, NULL, NULL),
(3621, '2016-07-22 11:40:49', NULL, NULL, 1270, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 11:40:49', 'admin-1469148115-14691588495913770', 1, 1, 'SR', NULL, NULL, NULL),
(3622, '2016-07-22 11:40:49', NULL, NULL, 1270, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 11:40:49', 'admin-1469148115-14691588495913770', 1, 1, 'SR', NULL, NULL, NULL),
(3623, '2016-07-22 12:22:56', NULL, NULL, 1268, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 12:22:56', 'admin-1469148115-14691613762229136', 1, 0, '', NULL, NULL, NULL),
(3624, '2016-07-22 14:44:11', NULL, NULL, 1275, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 14:44:11', 'admin-1469148115-14691698515103535', 1, 0, '', NULL, NULL, NULL),
(3625, '2016-07-22 10:46:40', NULL, NULL, 1267, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 10:46:40', 'admin-1469148115-14691555998705610', 1, 1, 'SR', NULL, NULL, NULL),
(3626, '2016-07-22 10:23:02', NULL, NULL, 1266, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 10:23:02', 'admin-1469148115-14691541823438296', 1, 1, 'SR', NULL, NULL, NULL),
(3627, '2016-07-22 20:11:36', NULL, NULL, 1285, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 20:11:36', 'admin-1469148115-14691894961266719', 1, 0, '', NULL, NULL, '10.0'),
(3628, '2016-07-22 00:00:00', NULL, NULL, 1273, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 13:06:43', 'admin-1469148115-14691640037742675', 1, 1, 'SR', NULL, NULL, NULL),
(3629, '2016-07-22 00:00:00', NULL, NULL, 1274, 0, 203, '138', 'Fruitea ', '', 'Cold Drinks', 'Non Coffee', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 13:24:38', 'admin-1469148115-14691650783595164', 1, 0, '', NULL, NULL, NULL),
(3630, '2016-07-22 00:00:00', NULL, NULL, 1274, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, NULL, NULL, 2.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 13:06:25', 'admin-1469148115-1469163985572370', 1, 0, '', NULL, NULL, NULL),
(3631, '2016-07-22 10:23:02', NULL, NULL, 1266, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 10:23:02', 'admin-1469148115-14691541823438296', 1, 0, '', NULL, NULL, NULL),
(3632, '2016-07-22 10:23:02', NULL, NULL, 1266, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 10:23:02', 'admin-1469148115-14691541823438296', 1, 1, 'SR', NULL, NULL, NULL),
(3633, '2016-07-22 09:45:17', NULL, NULL, 1265, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 09:45:17', 'admin-1469148115-14691519176849720', 1, 0, '', NULL, NULL, NULL),
(3634, '2016-07-22 10:23:02', NULL, NULL, 1266, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 10:23:02', 'admin-1469148115-14691541823438296', 1, 0, '', NULL, NULL, NULL),
(3635, '2016-07-22 09:45:17', NULL, NULL, 1265, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469196197', 'admin', '2016-07-22 09:45:17', 'admin-1469148115-14691519176849720', 1, 0, '', NULL, NULL, NULL),
(3636, '2016-07-23 16:00:00', NULL, NULL, 1318, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 16:00:00', 'admin-1469253261-14692608000034174', 1, 1, 'SR', NULL, NULL, NULL),
(3637, '2016-07-23 16:00:00', NULL, NULL, 1318, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 16:00:00', 'admin-1469253261-14692608000034174', 1, 1, 'SR', NULL, NULL, NULL),
(3638, '2016-07-23 16:26:34', NULL, NULL, 1319, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 16:26:34', 'admin-1469253261-14692623943866586', 1, 0, '', NULL, NULL, NULL),
(3639, '2016-07-23 16:31:57', NULL, NULL, 1320, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 16:31:57', 'admin-1469253261-14692627171143229', 1, 0, '', NULL, NULL, NULL),
(3640, '2016-07-23 16:31:57', NULL, NULL, 1320, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 16:31:57', 'admin-1469253261-14692627171143229', 1, 1, 'SR', NULL, NULL, NULL),
(3641, '2016-07-23 16:31:57', NULL, NULL, 1320, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 16:31:57', 'admin-1469253261-14692627171143229', 1, 1, 'SR', NULL, NULL, NULL),
(3642, '2016-07-23 17:05:03', NULL, NULL, 1321, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 17:05:03', 'admin-1469253261-1469264703582660', 1, 1, 'SR', NULL, NULL, NULL),
(3643, '2016-07-23 17:31:50', NULL, NULL, 1323, 0, 76, '76', 'Pesto Pasta', 'Chicken', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 17:31:50', 'admin-1469253261-14692663103367389', 1, 1, 'SR', NULL, NULL, NULL),
(3644, '2016-07-23 17:32:06', NULL, NULL, 1323, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 17:32:06', 'admin-1469253261-14692663260173958', 1, 1, 'SR', NULL, NULL, NULL),
(3645, '2016-07-23 17:36:31', NULL, NULL, 1324, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 17:36:31', 'admin-1469253261-14692665913665747', 1, 1, 'SR', NULL, NULL, NULL),
(3646, '2016-07-23 17:36:31', NULL, NULL, 1324, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 17:36:31', 'admin-1469253261-14692665913665747', 1, 1, 'SR', NULL, NULL, NULL),
(3647, '2016-07-23 17:50:34', NULL, NULL, 1325, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 17:50:34', 'admin-1469253261-14692674345235365', 1, 1, 'SR', NULL, NULL, NULL),
(3648, '2016-07-23 17:50:34', NULL, NULL, 1325, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 17:50:34', 'admin-1469253261-14692674345235365', 1, 1, 'SR', NULL, NULL, NULL),
(3649, '2016-07-23 17:50:34', NULL, NULL, 1325, 0, 181, '116', 'Open Food ', 'Scones', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 17:50:34', 'admin-1469253261-14692674345235365', 1, 0, '', NULL, NULL, NULL),
(3650, '2016-07-23 18:01:15', NULL, NULL, 1326, 0, 181, '116', 'Open Food ', '', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 18:01:15', 'admin-1469253261-14692680756626057', 1, 0, '', NULL, NULL, NULL),
(3651, '2016-07-23 18:01:15', NULL, NULL, 1326, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 18:01:15', 'admin-1469253261-14692680756626057', 1, 0, '', NULL, NULL, NULL),
(3652, '2016-07-23 18:01:15', NULL, NULL, 1326, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 18:01:15', 'admin-1469253261-14692680756626057', 1, 1, 'SR', NULL, NULL, NULL),
(3653, '2016-07-23 18:01:15', NULL, NULL, 1326, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 18:01:15', 'admin-1469253261-14692680756626057', 1, 1, 'SR', NULL, NULL, NULL),
(3654, '2016-07-23 19:54:32', NULL, NULL, 1327, 0, 190, '125', 'Tiger Bucket ', '', 'Cold Drinks', 'Soda & Beer', 1, 48.00, 48.0000, 0.0000, 48.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 19:54:32', 'admin-1469253261-14692748721287773', 1, 0, '', NULL, NULL, NULL),
(3655, '2016-07-23 21:42:45', NULL, NULL, 1327, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 21:42:45', 'admin-1469253261-1469281364878374', 1, 1, 'SR', NULL, NULL, NULL),
(3656, '2016-07-23 17:15:31', NULL, NULL, 1322, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 17:15:31', 'admin-1469253261-14692653313414465', 1, 1, 'SR', NULL, NULL, NULL),
(3657, '2016-07-23 17:15:31', NULL, NULL, 1322, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 17:15:31', 'admin-1469253261-14692653313414465', 1, 1, 'SR', NULL, NULL, NULL),
(3658, '2016-07-23 17:15:31', NULL, NULL, 1322, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 17:15:31', 'admin-1469253261-14692653313414465', 1, 1, 'SR', NULL, NULL, NULL),
(3659, '2016-07-23 16:00:00', NULL, NULL, 1318, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 16:00:00', 'admin-1469253261-14692608000034174', 1, 1, 'SR', NULL, NULL, NULL),
(3660, '2016-07-23 14:40:06', NULL, NULL, 1317, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 14:40:06', 'admin-1469253261-14692560067799939', 1, 0, '', NULL, NULL, NULL),
(3661, '2016-07-23 14:39:51', NULL, NULL, 1317, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 14:39:51', 'admin-1469253261-1469255990975233', 1, 1, 'SR', NULL, NULL, NULL),
(3662, '2016-07-23 14:39:51', NULL, NULL, 1317, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 14:39:51', 'admin-1469253261-1469255990975233', 1, 1, 'SR', NULL, NULL, NULL),
(3663, '2016-07-23 14:26:12', NULL, NULL, 1314, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 14:26:12', 'admin-1469253261-14692551720974625', 1, 1, 'SR', NULL, NULL, NULL),
(3664, '2016-07-23 14:26:12', NULL, NULL, 1314, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 14:26:12', 'admin-1469253261-14692551720974625', 1, 1, 'SR', NULL, NULL, NULL),
(3665, '2016-07-23 12:36:20', NULL, NULL, 1307, 0, 181, '116', 'Open Food ', '', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 12:36:20', 'admin-1469248158-14692485799205035', 1, 0, '', NULL, NULL, NULL),
(3666, '2016-07-23 12:31:02', NULL, NULL, 1307, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 12:31:02', 'admin-1469248158-1469248262044338', 1, 1, 'SR', NULL, NULL, NULL),
(3667, '2016-07-23 12:36:20', NULL, NULL, 1307, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 12:36:20', 'admin-1469248158-14692485799205035', 1, 0, '', NULL, NULL, NULL),
(3668, '2016-07-23 13:13:19', NULL, NULL, 1308, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 13:13:19', 'admin-1469248158-14692507995744254', 1, 0, '', NULL, NULL, NULL),
(3669, '2016-07-23 13:13:19', NULL, NULL, 1308, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 13:13:19', 'admin-1469248158-14692507995744254', 1, 0, '', NULL, NULL, NULL),
(3670, '2016-07-23 13:13:29', NULL, NULL, 1308, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 13:13:29', 'admin-1469248158-14692508089901872', 1, 1, 'SR', NULL, NULL, NULL),
(3671, '2016-07-23 13:21:35', NULL, NULL, 1309, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 13:21:35', 'admin-1469248158-14692512956403424', 1, 1, 'SR', NULL, NULL, NULL),
(3672, '2016-07-23 13:21:35', NULL, NULL, 1309, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 13:21:35', 'admin-1469248158-14692512956403424', 1, 1, 'SR', NULL, NULL, NULL),
(3673, '2016-07-23 13:22:08', NULL, NULL, 1310, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 13:22:08', 'admin-1469248158-14692513283792894', 1, 0, '', NULL, NULL, NULL),
(3674, '2016-07-23 13:22:08', NULL, NULL, 1310, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 13:22:08', 'admin-1469248158-14692513283792894', 1, 1, 'SR', NULL, NULL, NULL),
(3675, '2016-07-23 13:39:02', NULL, NULL, 1311, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 13:39:02', 'admin-1469248158-1469252341825512', 1, 1, 'SR', NULL, NULL, NULL),
(3676, '2016-07-23 13:39:02', NULL, NULL, 1311, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 13:39:02', 'admin-1469248158-1469252341825512', 1, 1, 'SR', NULL, NULL, NULL),
(3677, '2016-07-23 13:54:05', NULL, NULL, 1312, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 13:54:05', 'admin-1469248158-14692532457944682', 1, 1, 'SR', NULL, NULL, NULL),
(3678, '2016-07-23 13:39:02', NULL, NULL, 1311, 0, 181, '116', 'Open Food ', 'bacon fried rice', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 13:39:02', 'admin-1469248158-1469252341825512', 1, 0, '', NULL, NULL, NULL),
(3679, '2016-07-23 13:39:02', NULL, NULL, 1311, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 13:39:02', 'admin-1469248158-1469252341825512', 1, 0, '', NULL, NULL, NULL),
(3680, '2016-07-23 13:39:59', NULL, NULL, 1311, 0, 182, '117', 'Open Drinks ', 'americano', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 13:39:59', 'admin-1469248158-14692523993167313', 1, 0, '', NULL, NULL, NULL),
(3681, '2016-07-23 13:54:05', NULL, NULL, 1312, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 13:54:05', 'admin-1469248158-14692532457944682', 1, 1, 'SR', NULL, NULL, NULL),
(3682, '2016-07-23 13:54:05', NULL, NULL, 1312, 0, 182, '117', 'Open Drinks ', '', 'Desserts', '0', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 13:54:05', 'admin-1469248158-14692532457944682', 1, 0, '', NULL, NULL, NULL),
(3683, '2016-07-23 13:54:05', NULL, NULL, 1312, 0, 182, '117', 'Open Drinks ', 'americano', 'Desserts', '0', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 13:54:05', 'admin-1469248158-14692532457944682', 1, 0, '', NULL, NULL, NULL),
(3684, '2016-07-23 14:08:46', NULL, NULL, 1313, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 14:08:46', 'admin-1469253261-1469254126721474', 1, 1, 'SR', NULL, NULL, NULL),
(3685, '2016-07-23 14:09:00', NULL, NULL, 1313, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 14:09:00', 'admin-1469253261-14692541401606797', 1, 1, 'SR', NULL, NULL, NULL),
(3686, '2016-07-23 14:09:00', NULL, NULL, 1313, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 14:09:00', 'admin-1469253261-14692541401606797', 1, 0, '', NULL, NULL, NULL),
(3687, '2016-07-23 14:25:36', NULL, NULL, 1311, 0, 181, '116', 'Open Food ', '', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 14:25:36', 'admin-1469253261-14692551367027879', 1, 0, '', NULL, NULL, NULL),
(3688, '2016-07-23 14:25:36', NULL, NULL, 1311, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 14:25:36', 'admin-1469253261-14692551367027879', 1, 0, '', NULL, NULL, NULL),
(3689, '2016-07-23 14:29:41', NULL, NULL, 1316, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 14:29:41', 'admin-1469253261-14692553810328020', 1, 0, '', NULL, NULL, NULL),
(3690, '2016-07-23 14:29:41', NULL, NULL, 1316, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 14:29:41', 'admin-1469253261-14692553810328020', 1, 1, 'SR', NULL, NULL, NULL),
(3691, '2016-07-23 14:29:41', NULL, NULL, 1316, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 14:29:41', 'admin-1469253261-14692553810328020', 1, 1, 'SR', NULL, NULL, NULL),
(3692, '2016-07-23 14:27:10', NULL, NULL, 1315, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 14:27:10', 'admin-1469253261-1469255230427160', 1, 0, '', NULL, NULL, NULL),
(3693, '2016-07-23 11:35:03', NULL, NULL, 1305, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:35:03', 'admin-1469244729-14692449031207382', 1, 0, '', NULL, NULL, NULL),
(3694, '2016-07-23 11:35:03', NULL, NULL, 1305, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:35:03', 'admin-1469244729-14692449031207382', 1, 0, '', NULL, NULL, NULL),
(3695, '2016-07-23 10:21:32', NULL, NULL, 1292, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 10:21:32', 'admin-1469236076-14692404927002152', 1, 0, '', NULL, NULL, NULL),
(3696, '2016-07-23 10:21:32', NULL, NULL, 1292, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 10:21:32', 'admin-1469236076-14692404927002152', 1, 0, '', NULL, NULL, NULL),
(3697, '2016-07-23 10:25:02', NULL, NULL, 1292, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 10:25:02', 'admin-1469236076-14692407023785958', 1, 0, '', NULL, NULL, NULL),
(3698, '2016-07-23 12:12:56', NULL, NULL, 1306, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 12:12:56', 'admin-1469244729-14692471762148590', 1, 1, 'SR', NULL, NULL, NULL),
(3699, '2016-07-23 12:12:56', NULL, NULL, 1306, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 12:12:56', 'admin-1469244729-14692471762148590', 1, 1, 'SR', NULL, NULL, NULL),
(3700, '2016-07-23 11:58:05', NULL, NULL, 1292, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:58:05', 'admin-1469244729-14692462849346126', 1, 1, 'SR', NULL, NULL, NULL),
(3701, '2016-07-23 11:35:03', NULL, NULL, 1305, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:35:03', 'admin-1469244729-14692449031207382', 1, 1, 'SR', NULL, NULL, NULL),
(3702, '2016-07-23 11:35:03', NULL, NULL, 1305, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:35:03', 'admin-1469244729-14692449031207382', 1, 1, 'SR', NULL, NULL, NULL),
(3703, '2016-07-23 11:32:00', NULL, NULL, 1303, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:32:00', 'admin-1469242079-14692447206411120', 1, 1, 'SR', NULL, NULL, NULL),
(3704, '2016-07-23 11:32:55', NULL, NULL, 1304, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:32:55', 'admin-1469244729-1469244775460882', 1, 1, 'SR', NULL, NULL, NULL),
(3705, '2016-07-23 11:32:55', NULL, NULL, 1304, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:32:55', 'admin-1469244729-1469244775460882', 1, 1, 'SR', NULL, NULL, NULL),
(3706, '2016-07-23 11:32:55', NULL, NULL, 1304, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:32:55', 'admin-1469244729-1469244775460882', 1, 1, 'SR', NULL, NULL, NULL),
(3707, '2016-07-23 11:32:55', NULL, NULL, 1304, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:32:55', 'admin-1469244729-1469244775460882', 1, 1, 'SR', NULL, NULL, NULL),
(3708, '2016-07-23 11:02:21', NULL, NULL, 1298, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:02:21', 'admin-1469242079-14692429408469627', 1, 0, '', NULL, NULL, NULL),
(3709, '2016-07-23 11:02:21', NULL, NULL, 1298, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:02:21', 'admin-1469242079-14692429408469627', 1, 0, '', NULL, NULL, NULL),
(3710, '2016-07-23 11:09:17', NULL, NULL, 1300, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:09:17', 'admin-1469242079-14692433575888265', 1, 1, 'SR', NULL, NULL, NULL),
(3711, '2016-07-23 11:09:17', NULL, NULL, 1300, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:09:17', 'admin-1469242079-14692433575888265', 1, 1, 'SR', NULL, NULL, NULL),
(3712, '2016-07-23 11:30:43', NULL, NULL, 1301, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:30:43', 'admin-1469242079-14692446432474593', 1, 0, '', NULL, NULL, NULL),
(3713, '2016-07-23 11:30:43', NULL, NULL, 1301, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:30:43', 'admin-1469242079-14692446432474593', 1, 1, 'SR', NULL, NULL, NULL),
(3714, '2016-07-23 11:31:29', NULL, NULL, 1302, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:31:29', 'admin-1469242079-1469244689514525', 1, 0, '', NULL, NULL, NULL),
(3715, '2016-07-23 11:31:29', NULL, NULL, 1302, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:31:29', 'admin-1469242079-1469244689514525', 1, 1, 'SR', NULL, NULL, NULL),
(3716, '2016-07-23 11:32:00', NULL, NULL, 1303, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:32:00', 'admin-1469242079-14692447206411120', 1, 0, '', NULL, NULL, NULL),
(3717, '2016-07-23 11:03:52', NULL, NULL, 1299, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:03:52', 'admin-1469242079-1469243032744642', 1, 0, '', NULL, NULL, NULL),
(3718, '2016-07-23 11:03:52', NULL, NULL, 1299, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:03:52', 'admin-1469242079-1469243032744642', 1, 1, 'SR', NULL, NULL, NULL),
(3719, '2016-07-23 11:03:52', NULL, NULL, 1299, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:03:52', 'admin-1469242079-1469243032744642', 1, 0, '', NULL, NULL, NULL),
(3720, '2016-07-23 11:03:52', NULL, NULL, 1299, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:03:52', 'admin-1469242079-1469243032744642', 1, 0, '', NULL, NULL, NULL),
(3721, '2016-07-23 11:02:21', NULL, NULL, 1298, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:02:21', 'admin-1469242079-14692429408469627', 1, 1, 'SR', NULL, NULL, NULL),
(3722, '2016-07-23 10:47:47', NULL, NULL, 1297, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 10:47:47', 'admin-1469236076-14692420673039942', 1, 1, 'SR', NULL, NULL, NULL),
(3723, '2016-07-23 11:02:21', NULL, NULL, 1298, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:02:21', 'admin-1469242079-14692429408469627', 1, 0, '', NULL, NULL, NULL),
(3724, '2016-07-23 10:43:43', NULL, NULL, 1296, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 10:43:43', 'admin-1469236076-1469241822889821', 1, 1, 'SR', NULL, NULL, NULL),
(3725, '2016-07-23 10:47:47', NULL, NULL, 1297, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 10:47:47', 'admin-1469236076-14692420673039942', 1, 0, '', NULL, NULL, NULL),
(3726, '2016-07-23 10:47:47', NULL, NULL, 1297, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 10:47:47', 'admin-1469236076-14692420673039942', 1, 0, '', NULL, NULL, NULL),
(3727, '2016-07-23 10:43:43', NULL, NULL, 1296, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 10:43:43', 'admin-1469236076-1469241822889821', 1, 1, 'SR', NULL, NULL, NULL),
(3728, '2016-07-23 10:43:10', NULL, NULL, 1295, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 10:43:10', 'admin-1469236076-1469241790758506', 1, 1, 'SR', NULL, NULL, NULL),
(3729, '2016-07-23 10:43:10', NULL, NULL, 1295, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 10:43:10', 'admin-1469236076-1469241790758506', 1, 0, '', NULL, NULL, NULL),
(3730, '2016-07-23 10:38:52', NULL, NULL, 1294, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 10:38:52', 'admin-1469236076-1469241532205941', 1, 1, 'SR', NULL, NULL, NULL),
(3731, '2016-07-23 10:38:52', NULL, NULL, 1294, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 10:38:52', 'admin-1469236076-1469241532205941', 1, 1, 'SR', NULL, NULL, NULL),
(3732, '2016-07-23 11:16:01', NULL, NULL, 1292, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 11:16:01', 'admin-1469242079-14692437608954387', 1, 0, '', NULL, NULL, NULL),
(3733, '2016-07-23 10:27:17', NULL, NULL, 1292, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 10:27:17', 'admin-1469236076-14692408370634779', 1, 0, '', NULL, NULL, NULL),
(3734, '2016-07-23 10:26:08', NULL, NULL, 1293, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 10:26:08', 'admin-1469236076-14692407682326946', 1, 1, 'SR', NULL, NULL, NULL),
(3735, '2016-07-23 10:25:58', NULL, NULL, 1293, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 10:25:58', 'admin-1469236076-1469240758378747', 1, 1, 'SR', NULL, NULL, NULL),
(3736, '2016-07-23 10:25:58', NULL, NULL, 1293, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 10:25:58', 'admin-1469236076-1469240758378747', 1, 1, 'SR', NULL, NULL, NULL),
(3737, '2016-07-23 10:25:58', NULL, NULL, 1293, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 10:25:58', 'admin-1469236076-1469240758378747', 1, 0, '', NULL, NULL, NULL),
(3738, '2016-07-23 10:25:58', NULL, NULL, 1293, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 10:25:58', 'admin-1469236076-1469240758378747', 1, 0, '', NULL, NULL, NULL),
(3739, '2016-07-23 10:25:58', NULL, NULL, 1293, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 10:25:58', 'admin-1469236076-1469240758378747', 1, 0, '', NULL, NULL, NULL),
(3740, '2016-07-23 09:56:25', NULL, NULL, 1290, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 09:56:25', 'admin-1469236076-14692389855231290', 1, 0, '', NULL, NULL, NULL),
(3741, '2016-07-23 10:02:45', NULL, NULL, 1291, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 10:02:45', 'admin-1469236076-14692393657296062', 1, 0, '', NULL, NULL, NULL),
(3742, '2016-07-23 10:02:45', NULL, NULL, 1291, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 10:02:45', 'admin-1469236076-14692393657296062', 1, 0, '', NULL, NULL, NULL),
(3743, '2016-07-23 10:02:45', NULL, NULL, 1291, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 10:02:45', 'admin-1469236076-14692393657296062', 1, 0, '', NULL, NULL, NULL),
(3744, '2016-07-23 09:57:18', NULL, NULL, 1290, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 09:57:18', 'admin-1469236076-14692390378349028', 1, 1, 'SR', NULL, NULL, NULL),
(3745, '2016-07-23 09:57:18', NULL, NULL, 1290, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 09:57:18', 'admin-1469236076-14692390378349028', 1, 1, 'SR', NULL, NULL, NULL),
(3746, '2016-07-23 09:56:25', NULL, NULL, 1290, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 09:56:25', 'admin-1469236076-14692389855231290', 1, 1, 'SR', NULL, NULL, NULL),
(3747, '2016-07-23 09:56:25', NULL, NULL, 1290, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 09:56:25', 'admin-1469236076-14692389855231290', 1, 0, '', NULL, NULL, NULL),
(3748, '2016-07-23 09:08:09', NULL, NULL, 1289, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 09:08:09', 'admin-1469236076-14692360889854880', 1, 1, 'SR', NULL, NULL, NULL),
(3749, '2016-07-23 09:56:25', NULL, NULL, 1290, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 09:56:25', 'admin-1469236076-14692389855231290', 1, 0, '', NULL, NULL, NULL),
(3750, '2016-07-23 09:08:09', NULL, NULL, 1289, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469281396', 'admin', '2016-07-23 09:08:09', 'admin-1469236076-14692360889854880', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(3751, '2016-07-24 16:33:36', NULL, NULL, 1367, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 16:33:36', 'admin-1469344718-1469349215830236', 1, 1, 'SR', NULL, NULL, NULL),
(3752, '2016-07-24 16:33:36', NULL, NULL, 1367, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 16:33:36', 'admin-1469344718-1469349215830236', 1, 1, 'SR', NULL, NULL, NULL),
(3753, '2016-07-24 16:41:41', NULL, NULL, 1368, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 16:41:41', 'admin-1469344718-14693497016329928', 1, 1, 'SR', NULL, NULL, NULL),
(3754, '2016-07-24 16:41:41', NULL, NULL, 1368, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 16:41:41', 'admin-1469344718-14693497016329928', 1, 1, 'SR', NULL, NULL, NULL),
(3755, '2016-07-24 16:50:07', NULL, NULL, 1369, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 16:50:07', 'admin-1469344718-1469350207166314', 1, 1, 'SR', NULL, NULL, NULL),
(3756, '2016-07-24 16:50:07', NULL, NULL, 1369, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 16:50:07', 'admin-1469344718-1469350207166314', 1, 0, '', NULL, NULL, NULL),
(3757, '2016-07-24 16:50:07', NULL, NULL, 1369, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 16:50:07', 'admin-1469344718-1469350207166314', 1, 0, '', NULL, NULL, NULL),
(3758, '2016-07-24 18:06:09', NULL, NULL, 1370, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 18:06:09', 'admin-1469344718-14693547694744230', 1, 1, 'SR', NULL, NULL, '10.0'),
(3759, '2016-07-24 18:06:09', NULL, NULL, 1370, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 18:06:09', 'admin-1469344718-14693547694744230', 1, 1, 'SR', NULL, NULL, '10.0'),
(3760, '2016-07-24 18:06:09', NULL, NULL, 1370, 0, 181, '116', 'Open Food ', '', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 18:06:09', 'admin-1469344718-14693547694744230', 1, 0, '', NULL, NULL, '10.0'),
(3761, '2016-07-24 18:06:09', NULL, NULL, 1370, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 18:06:09', 'admin-1469344718-14693547694744230', 1, 0, '', NULL, NULL, '10.0'),
(3762, '2016-07-24 18:31:46', NULL, NULL, 1371, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 18:31:46', 'admin-1469344718-14693563058867177', 1, 0, '', NULL, NULL, NULL),
(3763, '2016-07-24 18:47:03', NULL, NULL, 1372, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 18:47:03', 'admin-1469344718-1469357223460681', 1, 1, 'SR', NULL, NULL, NULL),
(3764, '2016-07-24 18:54:55', NULL, NULL, 1373, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 18:54:55', 'admin-1469344718-1469357694925262', 1, 1, 'SR', NULL, NULL, NULL),
(3765, '2016-07-24 18:54:55', NULL, NULL, 1373, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 18:54:55', 'admin-1469344718-1469357694925262', 1, 1, 'SR', NULL, NULL, NULL),
(3766, '2016-07-24 14:04:51', NULL, NULL, 1355, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 14:04:51', 'admin-1469334508-14693402914675110', 1, 0, '', NULL, NULL, NULL),
(3767, '2016-07-24 14:04:51', NULL, NULL, 1355, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 14:04:51', 'admin-1469334508-14693402914675110', 1, 1, 'SR', NULL, NULL, NULL),
(3768, '2016-07-24 14:04:51', NULL, NULL, 1355, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 14:04:51', 'admin-1469334508-14693402914675110', 1, 1, 'SR', NULL, NULL, NULL),
(3769, '2016-07-24 14:05:46', NULL, NULL, 1356, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 14:05:46', 'admin-1469334508-14693403459342181', 1, 1, 'SR', NULL, NULL, NULL),
(3770, '2016-07-24 14:05:46', NULL, NULL, 1356, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 14:05:46', 'admin-1469334508-14693403459342181', 1, 1, 'SR', NULL, NULL, NULL),
(3771, '2016-07-24 14:36:56', NULL, NULL, 1357, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 14:36:56', 'admin-1469334508-14693422165567959', 1, 1, 'SR', NULL, NULL, NULL),
(3772, '2016-07-24 14:36:56', NULL, NULL, 1357, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 14:36:56', 'admin-1469334508-14693422165567959', 1, 1, 'SR', NULL, NULL, NULL),
(3773, '2016-07-24 16:33:36', NULL, NULL, 1367, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 16:33:36', 'admin-1469344718-1469349215830236', 1, 0, '', NULL, NULL, NULL),
(3774, '2016-07-24 16:01:31', NULL, NULL, 1366, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 16:01:31', 'admin-1469344718-14693472908351637', 1, 0, '', NULL, NULL, NULL),
(3775, '2016-07-24 15:49:41', NULL, NULL, 1365, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 15:49:41', 'admin-1469344718-1469346581272591', 1, 1, 'SR', NULL, NULL, NULL),
(3776, '2016-07-24 15:49:41', NULL, NULL, 1365, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 15:49:41', 'admin-1469344718-1469346581272591', 1, 0, '', NULL, NULL, NULL),
(3777, '2016-07-24 15:49:41', NULL, NULL, 1365, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 15:49:41', 'admin-1469344718-1469346581272591', 1, 0, '', NULL, NULL, NULL),
(3778, '2016-07-24 15:35:51', NULL, NULL, 1364, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 15:35:51', 'admin-1469344718-14693457516012227', 1, 1, 'SR', NULL, NULL, NULL),
(3779, '2016-07-24 15:25:21', NULL, NULL, 1363, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 15:25:21', 'admin-1469344718-14693451209433033', 1, 1, 'SR', NULL, NULL, NULL),
(3780, '2016-07-24 15:21:39', NULL, NULL, 1363, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 15:21:39', 'admin-1469344718-14693448991779019', 1, 1, 'SR', NULL, NULL, NULL),
(3781, '2016-07-24 15:21:39', NULL, NULL, 1363, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 15:21:39', 'admin-1469344718-14693448991779019', 1, 1, 'SR', NULL, NULL, NULL),
(3782, '2016-07-24 15:21:39', NULL, NULL, 1363, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 15:21:39', 'admin-1469344718-14693448991779019', 1, 1, 'SR', NULL, NULL, NULL),
(3783, '2016-07-24 15:35:51', NULL, NULL, 1364, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 15:35:51', 'admin-1469344718-14693457516012227', 1, 0, '', NULL, NULL, NULL),
(3784, '2016-07-24 15:18:47', NULL, NULL, 1362, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 15:18:47', 'admin-1469344718-14693447273307240', 1, 1, 'SR', NULL, NULL, NULL),
(3785, '2016-07-24 14:44:07', NULL, NULL, 1358, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 14:44:07', 'admin-1469342237-14693426472549273', 1, 1, 'SR', NULL, NULL, NULL),
(3786, '2016-07-24 14:55:03', NULL, NULL, 1359, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 14:55:03', 'admin-1469342237-14693433029435074', 1, 0, '', NULL, NULL, NULL),
(3787, '2016-07-24 14:55:03', NULL, NULL, 1359, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 14:55:03', 'admin-1469342237-14693433029435074', 1, 0, '', NULL, NULL, NULL),
(3788, '2016-07-24 14:55:03', NULL, NULL, 1359, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 14:55:03', 'admin-1469342237-14693433029435074', 1, 1, 'SR', NULL, NULL, NULL),
(3789, '2016-07-24 14:55:03', NULL, NULL, 1359, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 14:55:03', 'admin-1469342237-14693433029435074', 1, 0, '', NULL, NULL, NULL),
(3790, '2016-07-24 14:59:14', NULL, NULL, 1359, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 14:59:14', 'admin-1469342237-14693435541506287', 1, 1, 'SR', NULL, NULL, NULL),
(3791, '2016-07-24 15:03:32', NULL, NULL, 1360, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 15:03:32', 'admin-1469342237-14693438119486373', 1, 0, '', NULL, NULL, NULL),
(3792, '2016-07-24 15:03:32', NULL, NULL, 1360, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 15:03:32', 'admin-1469342237-14693438119486373', 1, 1, 'SR', NULL, NULL, NULL),
(3793, '2016-07-24 15:03:32', NULL, NULL, 1360, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 15:03:32', 'admin-1469342237-14693438119486373', 1, 1, 'SR', NULL, NULL, NULL),
(3794, '2016-07-24 15:05:34', NULL, NULL, 1361, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 15:05:34', 'admin-1469342237-14693439344966198', 1, 0, '', NULL, NULL, NULL),
(3795, '2016-07-24 15:15:57', NULL, NULL, 1361, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 15:15:57', 'admin-1469342237-14693445574359814', 1, 0, '', NULL, NULL, NULL),
(3796, '2016-07-24 15:05:34', NULL, NULL, 1361, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 15:05:34', 'admin-1469342237-14693439344966198', 1, 1, 'SR', NULL, NULL, NULL),
(3797, '2016-07-24 15:17:23', NULL, NULL, 1362, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 15:17:23', 'admin-1469342237-1469344642975676', 1, 0, '', NULL, NULL, NULL),
(3798, '2016-07-24 15:17:23', NULL, NULL, 1362, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 15:17:23', 'admin-1469342237-1469344642975676', 1, 0, '', NULL, NULL, NULL),
(3799, '2016-07-24 15:17:23', NULL, NULL, 1362, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 15:17:23', 'admin-1469342237-1469344642975676', 1, 0, '', NULL, NULL, NULL),
(3800, '2016-07-24 14:44:07', NULL, NULL, 1358, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 14:44:07', 'admin-1469342237-14693426472549273', 1, 1, 'SR', NULL, NULL, NULL),
(3801, '2016-07-24 14:36:56', NULL, NULL, 1357, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 14:36:56', 'admin-1469334508-14693422165567959', 1, 1, 'SR', NULL, NULL, NULL),
(3802, '2016-07-24 14:36:56', NULL, NULL, 1357, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 14:36:56', 'admin-1469334508-14693422165567959', 1, 1, 'SR', NULL, NULL, NULL),
(3803, '2016-07-24 14:04:51', NULL, NULL, 1355, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 14:04:51', 'admin-1469334508-14693402914675110', 1, 0, '', NULL, NULL, NULL),
(3804, '2016-07-24 14:04:51', NULL, NULL, 1355, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 14:04:51', 'admin-1469334508-14693402914675110', 1, 1, 'SR', NULL, NULL, NULL),
(3805, '2016-07-24 14:00:40', NULL, NULL, 1354, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 14:00:40', 'admin-1469334508-14693400401612257', 1, 1, 'SR', NULL, NULL, NULL),
(3806, '2016-07-24 11:46:56', NULL, NULL, 1345, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:46:56', 'admin-1469331880-14693320167141612', 1, 0, '', NULL, NULL, NULL),
(3807, '2016-07-24 11:46:56', NULL, NULL, 1345, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:46:56', 'admin-1469331880-14693320167141612', 1, 0, '', NULL, NULL, NULL),
(3808, '2016-07-24 11:46:56', NULL, NULL, 1345, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:46:56', 'admin-1469331880-14693320167141612', 1, 1, 'SR', NULL, NULL, NULL),
(3809, '2016-07-24 11:48:24', NULL, NULL, 1346, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:48:24', 'admin-1469331880-14693321047471726', 1, 1, 'SR', NULL, NULL, NULL),
(3810, '2016-07-24 11:48:24', NULL, NULL, 1346, 0, 181, '116', 'Open Food ', '', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:48:24', 'admin-1469331880-14693321047471726', 1, 0, '', NULL, NULL, NULL),
(3811, '2016-07-24 11:48:24', NULL, NULL, 1346, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:48:24', 'admin-1469331880-14693321047471726', 1, 0, '', NULL, NULL, NULL),
(3812, '2016-07-24 11:49:17', NULL, NULL, 1347, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:49:17', 'admin-1469331880-14693321571192331', 1, 1, 'SR', NULL, NULL, NULL),
(3813, '2016-07-24 11:49:17', NULL, NULL, 1347, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:49:17', 'admin-1469331880-14693321571192331', 1, 1, 'SR', NULL, NULL, NULL),
(3814, '2016-07-24 11:54:48', NULL, NULL, 1348, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:54:48', 'admin-1469331880-14693324881908759', 1, 0, '', NULL, NULL, NULL),
(3815, '2016-07-24 11:54:48', NULL, NULL, 1348, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:54:48', 'admin-1469331880-14693324881908759', 1, 0, '', NULL, NULL, NULL),
(3816, '2016-07-24 11:54:48', NULL, NULL, 1348, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:54:48', 'admin-1469331880-14693324881908759', 1, 1, 'SR', NULL, NULL, NULL),
(3817, '2016-07-24 11:54:48', NULL, NULL, 1348, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:54:48', 'admin-1469331880-14693324881908759', 1, 1, 'SR', NULL, NULL, NULL),
(3818, '2016-07-24 12:16:40', NULL, NULL, 1349, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 12:16:40', 'admin-1469331880-14693338007604216', 1, 1, 'SR', NULL, NULL, NULL),
(3819, '2016-07-24 12:28:10', NULL, NULL, 1350, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 12:28:10', 'admin-1469331880-14693344905165561', 1, 0, '', NULL, NULL, NULL),
(3820, '2016-07-24 12:46:51', NULL, NULL, 1351, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 12:46:51', 'admin-1469334508-14693356109446477', 1, 1, 'SR', NULL, NULL, NULL),
(3821, '2016-07-24 12:46:51', NULL, NULL, 1351, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 12:46:51', 'admin-1469334508-14693356109446477', 1, 1, 'SR', NULL, NULL, NULL),
(3822, '2016-07-24 13:02:07', NULL, NULL, 1352, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 13:02:07', 'admin-1469334508-14693365276555531', 1, 1, 'SR', NULL, NULL, NULL),
(3823, '2016-07-24 13:02:07', NULL, NULL, 1352, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 13:02:07', 'admin-1469334508-14693365276555531', 1, 1, 'SR', NULL, NULL, NULL),
(3824, '2016-07-24 13:08:30', NULL, NULL, 1337, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 13:08:31', 'admin-1469334508-14693369107531187', 1, 1, 'SR', NULL, NULL, NULL),
(3825, '2016-07-24 13:51:51', NULL, NULL, 1353, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 13:51:51', 'admin-1469334508-14693395111596937', 1, 1, 'SR', NULL, NULL, NULL),
(3826, '2016-07-24 13:51:51', NULL, NULL, 1353, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 13:51:51', 'admin-1469334508-14693395111596937', 1, 1, 'SR', NULL, NULL, NULL),
(3827, '2016-07-24 13:51:51', NULL, NULL, 1353, 0, 70, '70', 'Pepper Pork', 'Pasta', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 13:51:51', 'admin-1469334508-14693395111596937', 1, 1, 'SR', NULL, NULL, NULL),
(3828, '2016-07-24 13:51:51', NULL, NULL, 1353, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 13:51:51', 'admin-1469334508-14693395111596937', 1, 1, 'SR', NULL, NULL, NULL),
(3829, '2016-07-24 13:52:40', NULL, NULL, 1353, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 13:52:40', 'admin-1469334508-14693395599709750', 1, 0, '', NULL, NULL, NULL),
(3830, '2016-07-24 14:00:40', NULL, NULL, 1354, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 14:00:40', 'admin-1469334508-14693400401612257', 1, 1, 'SR', NULL, NULL, NULL),
(3831, '2016-07-24 11:48:24', NULL, NULL, 1346, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:48:24', 'admin-1469331880-14693321047471726', 1, 0, '', NULL, NULL, NULL),
(3832, '2016-07-24 11:45:35', NULL, NULL, 1344, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:45:35', 'admin-1469331880-14693319356371842', 1, 1, 'SR', NULL, NULL, NULL),
(3833, '2016-07-24 14:36:56', NULL, NULL, 1357, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 14:36:56', 'admin-1469334508-14693422165567959', 1, 0, '', NULL, NULL, NULL),
(3834, '2016-07-24 11:44:29', NULL, NULL, 1343, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:44:29', 'admin-1469329245-14693318695028218', 1, 0, '', NULL, NULL, NULL),
(3835, '2016-07-24 11:45:35', NULL, NULL, 1344, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:45:35', 'admin-1469331880-14693319356371842', 1, 0, '', NULL, NULL, NULL),
(3836, '2016-07-24 11:45:35', NULL, NULL, 1344, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:45:35', 'admin-1469331880-14693319356371842', 1, 0, '', NULL, NULL, NULL),
(3837, '2016-07-24 11:44:29', NULL, NULL, 1343, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:44:29', 'admin-1469329245-14693318695028218', 1, 0, '', NULL, NULL, NULL),
(3838, '2016-07-24 11:44:29', NULL, NULL, 1343, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:44:29', 'admin-1469329245-14693318695028218', 1, 0, '', NULL, NULL, NULL),
(3839, '2016-07-24 11:44:29', NULL, NULL, 1343, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:44:29', 'admin-1469329245-14693318695028218', 1, 0, '', NULL, NULL, NULL),
(3840, '2016-07-24 11:44:29', NULL, NULL, 1343, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:44:29', 'admin-1469329245-14693318695028218', 1, 1, 'SR', NULL, NULL, NULL),
(3841, '2016-07-24 10:21:23', NULL, NULL, 1332, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 10:21:23', 'admin-1469326411-14693268829632043', 1, 0, '', NULL, NULL, NULL),
(3842, '2016-07-24 10:13:03', NULL, NULL, 1332, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 10:13:03', 'admin-1469320347-14693263834689995', 1, 0, '', NULL, NULL, NULL),
(3843, '2016-07-24 10:13:03', NULL, NULL, 1332, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 10:13:03', 'admin-1469320347-14693263834689995', 1, 1, 'SR', NULL, NULL, NULL),
(3844, '2016-07-24 10:13:03', NULL, NULL, 1332, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 10:13:03', 'admin-1469320347-14693263834689995', 1, 1, 'SR', NULL, NULL, NULL),
(3845, '2016-07-24 10:24:46', NULL, NULL, 1333, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 10:24:46', 'admin-1469326411-14693270860256334', 1, 0, '', NULL, NULL, NULL),
(3846, '2016-07-24 10:24:46', NULL, NULL, 1333, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 10:24:46', 'admin-1469326411-14693270860256334', 1, 0, '', NULL, NULL, NULL),
(3847, '2016-07-24 10:25:39', NULL, NULL, 1333, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 10:25:39', 'admin-1469326411-14693271392988389', 1, 1, 'SR', NULL, NULL, NULL),
(3848, '2016-07-24 10:25:39', NULL, NULL, 1333, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 10:25:39', 'admin-1469326411-14693271392988389', 1, 1, 'SR', NULL, NULL, NULL),
(3849, '2016-07-24 10:27:22', NULL, NULL, 1334, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 10:27:22', 'admin-1469326411-14693272418782149', 1, 0, '', NULL, NULL, NULL),
(3850, '2016-07-24 10:27:22', NULL, NULL, 1334, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 10:27:22', 'admin-1469326411-14693272418782149', 1, 0, '', NULL, NULL, NULL),
(3851, '2016-07-24 10:27:22', NULL, NULL, 1334, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 10:27:22', 'admin-1469326411-14693272418782149', 1, 0, '', NULL, NULL, NULL),
(3852, '2016-07-24 10:29:43', NULL, NULL, 1334, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 10:29:43', 'admin-1469326411-14693273827575686', 1, 1, 'SR', NULL, NULL, NULL),
(3853, '2016-07-24 10:29:43', NULL, NULL, 1334, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 10:29:43', 'admin-1469326411-14693273827575686', 1, 1, 'SR', NULL, NULL, NULL),
(3854, '2016-07-24 10:43:06', NULL, NULL, 1335, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 10:43:06', 'admin-1469326411-14693281860521886', 1, 0, '', NULL, NULL, NULL),
(3855, '2016-07-24 11:44:29', NULL, NULL, 1343, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:44:29', 'admin-1469329245-14693318695028218', 1, 1, 'SR', NULL, NULL, NULL),
(3856, '2016-07-24 11:42:30', NULL, NULL, 1342, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:42:30', 'admin-1469329245-14693317505583876', 1, 1, 'SR', NULL, NULL, NULL),
(3857, '2016-07-24 11:02:55', NULL, NULL, 1337, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:02:55', 'admin-1469329245-14693293752478955', 1, 1, 'SR', NULL, NULL, NULL),
(3858, '2016-07-24 11:37:02', NULL, NULL, 1338, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:37:02', 'admin-1469329245-14693314224868447', 1, 0, '', NULL, NULL, NULL),
(3859, '2016-07-24 11:37:02', NULL, NULL, 1338, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:37:02', 'admin-1469329245-14693314224868447', 1, 0, '', NULL, NULL, NULL),
(3860, '2016-07-24 11:37:02', NULL, NULL, 1338, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:37:02', 'admin-1469329245-14693314224868447', 1, 1, 'SR', NULL, NULL, NULL),
(3861, '2016-07-24 11:37:46', NULL, NULL, 1339, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:37:46', 'admin-1469329245-14693314661755571', 1, 1, 'SR', NULL, NULL, NULL),
(3862, '2016-07-24 11:37:46', NULL, NULL, 1339, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:37:46', 'admin-1469329245-14693314661755571', 1, 0, '', NULL, NULL, NULL),
(3863, '2016-07-24 11:37:46', NULL, NULL, 1339, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:37:46', 'admin-1469329245-14693314661755571', 1, 0, '', NULL, NULL, NULL),
(3864, '2016-07-24 11:42:30', NULL, NULL, 1342, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:42:30', 'admin-1469329245-14693317505583876', 1, 1, 'SR', NULL, NULL, NULL),
(3865, '2016-07-24 11:42:30', NULL, NULL, 1342, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:42:30', 'admin-1469329245-14693317505583876', 1, 1, 'SR', NULL, NULL, NULL),
(3866, '2016-07-24 11:42:30', NULL, NULL, 1342, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:42:30', 'admin-1469329245-14693317505583876', 1, 1, 'SR', NULL, NULL, NULL),
(3867, '2016-07-24 11:39:43', NULL, NULL, 1341, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:39:43', 'admin-1469329245-14693315831976151', 1, 1, 'SR', NULL, NULL, NULL),
(3868, '2016-07-24 11:41:49', NULL, NULL, 1342, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:41:49', 'admin-1469329245-14693317093559794', 1, 0, '', NULL, NULL, NULL),
(3869, '2016-07-24 11:41:49', NULL, NULL, 1342, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:41:49', 'admin-1469329245-14693317093559794', 1, 0, '', NULL, NULL, NULL),
(3870, '2016-07-24 11:41:49', NULL, NULL, 1342, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:41:49', 'admin-1469329245-14693317093559794', 1, 0, '', NULL, NULL, NULL),
(3871, '2016-07-24 11:39:43', NULL, NULL, 1341, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:39:43', 'admin-1469329245-14693315831976151', 1, 0, '', NULL, NULL, NULL),
(3872, '2016-07-24 11:39:43', NULL, NULL, 1341, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:39:43', 'admin-1469329245-14693315831976151', 1, 0, '', NULL, NULL, NULL),
(3873, '2016-07-24 11:38:35', NULL, NULL, 1340, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:38:35', 'admin-1469329245-14693315150358695', 1, 1, 'SR', NULL, NULL, NULL),
(3874, '2016-07-24 11:38:35', NULL, NULL, 1340, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 11:38:35', 'admin-1469329245-14693315150358695', 1, 1, 'SR', NULL, NULL, NULL),
(3875, '2016-07-24 10:59:46', NULL, NULL, 1336, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 10:59:46', 'admin-1469326411-14693291867729846', 1, 1, 'SR', NULL, NULL, NULL),
(3876, '2016-07-24 10:59:46', NULL, NULL, 1336, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 10:59:46', 'admin-1469326411-14693291867729846', 1, 0, '', NULL, NULL, NULL),
(3877, '2016-07-24 10:58:39', NULL, NULL, 1336, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 10:58:39', 'admin-1469326411-14693291194353218', 1, 0, '', NULL, NULL, NULL),
(3878, '2016-07-24 10:11:16', NULL, NULL, 1331, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 10:11:16', 'admin-1469320347-14693262766068656', 1, 1, 'SR', NULL, NULL, NULL),
(3879, '2016-07-24 10:11:16', NULL, NULL, 1331, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 10:11:16', 'admin-1469320347-14693262766068656', 1, 0, '', NULL, NULL, NULL),
(3880, '2016-07-24 10:10:49', NULL, NULL, 1331, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 10:10:49', 'admin-1469320347-14693262493519940', 1, 0, '', NULL, NULL, NULL),
(3881, '2016-07-24 10:10:49', NULL, NULL, 1331, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 10:10:49', 'admin-1469320347-14693262493519940', 1, 0, '', NULL, NULL, NULL),
(3882, '2016-07-24 10:10:49', NULL, NULL, 1331, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 10:10:49', 'admin-1469320347-14693262493519940', 1, 0, '', NULL, NULL, NULL),
(3883, '2016-07-24 09:49:23', NULL, NULL, 1330, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 09:49:23', 'admin-1469320347-14693249629857593', 1, 1, 'SR', NULL, NULL, NULL),
(3884, '2016-07-24 09:49:16', NULL, NULL, 1330, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 09:49:16', 'admin-1469320347-14693249564239771', 1, 0, '', NULL, NULL, NULL),
(3885, '2016-07-24 09:49:23', NULL, NULL, 1330, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 09:49:23', 'admin-1469320347-14693249629857593', 1, 1, 'SR', NULL, NULL, NULL),
(3886, '2016-07-24 09:49:16', NULL, NULL, 1330, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 09:49:16', 'admin-1469320347-14693249564239771', 1, 0, '', NULL, NULL, NULL),
(3887, '2016-07-24 09:41:31', NULL, NULL, 1329, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 09:41:31', 'admin-1469320347-146932449167497', 1, 1, 'SR', NULL, NULL, '10.0'),
(3888, '2016-07-24 09:41:31', NULL, NULL, 1329, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 09:41:31', 'admin-1469320347-146932449167497', 1, 0, '', NULL, NULL, '10.0'),
(3889, '2016-07-24 09:36:45', NULL, NULL, 1329, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 09:36:45', 'admin-1469320347-1469324205374225', 1, 1, 'SR', NULL, NULL, '10.0'),
(3890, '2016-07-24 09:41:31', NULL, NULL, 1329, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 09:41:31', 'admin-1469320347-146932449167497', 1, 0, '', NULL, NULL, '10.0'),
(3891, '2016-07-24 09:41:31', NULL, NULL, 1329, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 09:41:31', 'admin-1469320347-146932449167497', 1, 1, 'SR', NULL, NULL, '10.0'),
(3892, '2016-07-24 09:33:36', NULL, NULL, 1329, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 09:33:36', 'admin-1469320347-14693240165996819', 1, 0, '', NULL, NULL, '10.0'),
(3893, '2016-07-24 09:23:51', NULL, NULL, 1328, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 09:23:51', 'admin-1469320347-14693234311483449', 1, 1, 'SR', NULL, NULL, NULL),
(3894, '2016-07-24 09:23:51', NULL, NULL, 1328, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 09:23:51', 'admin-1469320347-14693234311483449', 1, 0, '', NULL, NULL, NULL),
(3895, '2016-07-24 09:23:51', NULL, NULL, 1328, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 09:23:51', 'admin-1469320347-14693234311483449', 1, 1, 'SR', NULL, NULL, NULL),
(3896, '2016-07-24 09:23:51', NULL, NULL, 1328, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469359587', 'admin', '2016-07-24 09:23:51', 'admin-1469320347-14693234311483449', 1, 0, '', NULL, NULL, NULL),
(3897, '2016-07-25 17:29:16', NULL, NULL, 1391, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 17:29:16', 'admin-1469423653-14694389562727196', 1, 1, 'SR', NULL, NULL, NULL),
(3898, '2016-07-25 13:14:41', NULL, NULL, 1381, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 13:14:41', 'admin-1469423653-14694236810112979', 1, 1, 'SR', NULL, NULL, NULL),
(3899, '2016-07-25 13:14:41', NULL, NULL, 1381, 0, 181, '116', 'Open Food ', '', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 13:14:41', 'admin-1469423653-14694236810112979', 1, 0, '', NULL, NULL, NULL),
(3900, '2016-07-25 13:14:41', NULL, NULL, 1381, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 13:14:41', 'admin-1469423653-14694236810112979', 1, 0, '', NULL, NULL, NULL),
(3901, '2016-07-25 14:48:18', NULL, NULL, 1382, 0, 182, '117', 'Open Drinks ', 'Scones', 'Desserts', '0', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 14:48:18', 'admin-1469423653-14694292978755620', 1, 0, '', NULL, NULL, NULL),
(3902, '2016-07-25 14:48:18', NULL, NULL, 1382, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 14:48:18', 'admin-1469423653-14694292978755620', 1, 0, '', NULL, NULL, NULL),
(3903, '2016-07-25 14:48:42', NULL, NULL, 1382, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 14:48:42', 'admin-1469423653-14694293223118019', 1, 1, 'SR', NULL, NULL, NULL),
(3904, '2016-07-25 15:08:09', NULL, NULL, 1383, 0, 187, '122', 'Iced Tea ', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 15:08:09', 'admin-1469423653-1469430489691284', 1, 0, '', NULL, NULL, NULL),
(3905, '2016-07-25 15:08:09', NULL, NULL, 1383, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 15:08:09', 'admin-1469423653-1469430489691284', 1, 1, 'SR', NULL, NULL, NULL),
(3906, '2016-07-25 15:08:31', NULL, NULL, 1384, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 15:08:31', 'admin-1469423653-14694305116526736', 1, 1, 'SR', NULL, NULL, NULL),
(3907, '2016-07-25 15:43:39', NULL, NULL, 1385, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 15:43:39', 'admin-1469423653-14694326195769822', 1, 1, 'SR', NULL, NULL, NULL),
(3908, '2016-07-25 16:00:36', NULL, NULL, 1386, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 16:00:36', 'admin-1469423653-14694336365926521', 1, 1, 'SR', NULL, NULL, NULL),
(3909, '2016-07-25 16:04:38', NULL, NULL, 1387, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 16:04:38', 'admin-1469423653-14694338783427778', 1, 1, 'SR', NULL, NULL, NULL),
(3910, '2016-07-25 16:43:23', NULL, NULL, 1388, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 16:43:23', 'admin-1469423653-14694362032312746', 1, 1, 'SR', NULL, NULL, NULL),
(3911, '2016-07-25 16:43:23', NULL, NULL, 1388, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 16:43:23', 'admin-1469423653-14694362032312746', 1, 1, 'SR', NULL, NULL, NULL),
(3912, '2016-07-25 16:44:12', NULL, NULL, 1389, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 16:44:12', 'admin-1469423653-14694362523268332', 1, 1, 'SR', NULL, NULL, NULL),
(3913, '2016-07-25 16:52:25', NULL, NULL, 1389, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 16:52:25', 'admin-1469423653-1469436745377774', 1, 0, '', NULL, NULL, NULL),
(3914, '2016-07-25 17:06:49', NULL, NULL, 1390, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 17:06:49', 'admin-1469423653-1469437609019598', 1, 0, '', NULL, NULL, NULL),
(3915, '2016-07-25 17:29:16', NULL, NULL, 1391, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 17:29:16', 'admin-1469423653-14694389562727196', 1, 1, 'SR', NULL, NULL, NULL),
(3916, '2016-07-25 17:29:16', NULL, NULL, 1391, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 17:29:16', 'admin-1469423653-14694389562727196', 1, 0, '', NULL, NULL, NULL),
(3917, '2016-07-25 17:29:16', NULL, NULL, 1391, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 17:29:16', 'admin-1469423653-14694389562727196', 1, 1, 'SR', NULL, NULL, NULL),
(3918, '2016-07-25 17:06:49', NULL, NULL, 1390, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 17:06:49', 'admin-1469423653-1469437609019598', 1, 1, 'SR', NULL, NULL, NULL),
(3919, '2016-07-25 13:09:26', NULL, NULL, 1380, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 13:09:26', 'Staff-1469412109-14694233663358271', 1, 0, '', NULL, NULL, NULL),
(3920, '2016-07-25 13:09:26', NULL, NULL, 1380, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 13:09:26', 'Staff-1469412109-14694233663358271', 1, 1, 'SR', NULL, NULL, NULL),
(3921, '2016-07-25 13:09:26', NULL, NULL, 1380, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 13:09:26', 'Staff-1469412109-14694233663358271', 1, 1, 'SR', NULL, NULL, NULL),
(3922, '2016-07-25 13:14:41', NULL, NULL, 1381, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469445375', 'admin', '2016-07-25 13:14:41', 'admin-1469423653-14694236810112979', 1, 1, 'SR', NULL, NULL, NULL),
(3923, '2016-07-25 13:09:26', NULL, NULL, 1380, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 13:09:26', 'Staff-1469412109-14694233663358271', 1, 0, '', NULL, NULL, NULL),
(3924, '2016-07-25 12:40:49', NULL, NULL, 1379, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 12:40:49', 'Staff-1469412109-14694216497355097', 1, 1, 'SR', NULL, NULL, NULL),
(3925, '2016-07-25 12:40:30', NULL, NULL, 1379, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 12:40:30', 'Staff-1469412109-14694216300147956', 1, 1, 'SR', NULL, NULL, NULL),
(3926, '2016-07-25 12:40:49', NULL, NULL, 1379, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 12:40:49', 'Staff-1469412109-14694216497355097', 1, 1, 'SR', NULL, NULL, NULL),
(3927, '2016-07-25 12:40:30', NULL, NULL, 1379, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 12:40:30', 'Staff-1469412109-14694216300147956', 1, 0, '', NULL, NULL, NULL),
(3928, '2016-07-25 12:35:20', NULL, NULL, 1378, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 12:35:20', 'Staff-1469412109-1469421320189923', 1, 1, 'SR', NULL, NULL, NULL),
(3929, '2016-07-25 12:35:20', NULL, NULL, 1378, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 12:35:20', 'Staff-1469412109-1469421320189923', 1, 1, 'SR', NULL, NULL, NULL),
(3930, '2016-07-25 12:35:20', NULL, NULL, 1378, NULL, 65, '65', 'Pineapple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 12:35:20', 'Staff-1469412109-1469421320189923', 1, 1, 'SR', NULL, NULL, NULL),
(3931, '2016-07-25 12:35:20', NULL, NULL, 1378, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 12:35:20', 'Staff-1469412109-1469421320189923', 1, 1, 'SR', NULL, NULL, NULL),
(3932, '2016-07-25 11:07:32', NULL, NULL, 1377, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 11:07:32', 'Staff-1469412109-1469416052115766', 1, 1, 'SR', NULL, NULL, NULL),
(3933, '2016-07-25 11:05:32', NULL, NULL, 1377, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 11:05:32', 'Staff-1469412109-14694159326379210', 1, 1, 'SR', NULL, NULL, NULL),
(3934, '2016-07-25 11:04:51', NULL, NULL, 1377, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 11:04:51', 'Staff-1469412109-14694158917419516', 1, 0, '', NULL, NULL, NULL),
(3935, '2016-07-25 11:04:51', NULL, NULL, 1377, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 11:04:51', 'Staff-1469412109-14694158917419516', 1, 0, '', NULL, NULL, NULL),
(3936, '2016-07-25 11:04:51', NULL, NULL, 1377, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 11:04:51', 'Staff-1469412109-14694158917419516', 1, 0, '', NULL, NULL, NULL),
(3937, '2016-07-25 11:04:51', NULL, NULL, 1377, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 11:04:51', 'Staff-1469412109-14694158917419516', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(3938, '2016-07-25 10:37:19', NULL, NULL, 1376, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 10:37:19', 'Staff-1469412109-14694142393462555', 1, 1, 'SR', NULL, NULL, NULL),
(3939, '2016-07-25 10:36:25', NULL, NULL, 1376, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 10:36:25', 'Staff-1469412109-14694141855805170', 1, 0, '', NULL, NULL, NULL),
(3940, '2016-07-25 10:04:12', NULL, NULL, 1375, 0, 181, '116', 'Open Food ', 'added mint', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 10:04:12', 'Staff-1469412109-14694122527941635', 1, 0, '', NULL, NULL, NULL),
(3941, '2016-07-25 10:04:12', NULL, NULL, 1375, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 10:04:12', 'Staff-1469412109-14694122527941635', 1, 1, 'SR', NULL, NULL, NULL),
(3942, '2016-07-25 10:04:12', NULL, NULL, 1375, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 10:04:12', 'Staff-1469412109-14694122527941635', 1, 1, 'SR', NULL, NULL, NULL),
(3943, '2016-07-25 10:04:12', NULL, NULL, 1375, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 10:04:12', 'Staff-1469412109-14694122527941635', 1, 0, '', NULL, NULL, NULL),
(3944, '2016-07-25 10:04:12', NULL, NULL, 1375, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 10:04:12', 'Staff-1469412109-14694122527941635', 1, 0, '', NULL, NULL, NULL),
(3945, '2016-07-25 10:02:22', NULL, NULL, 1374, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 10:02:22', 'Staff-1469412109-14694121417942110', 1, 0, '', NULL, NULL, NULL),
(3946, '2016-07-25 10:02:22', NULL, NULL, 1374, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 10:02:22', 'Staff-1469412109-14694121417942110', 1, 1, 'SR', NULL, NULL, NULL),
(3947, '2016-07-25 10:02:21', NULL, NULL, 1374, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 10:02:21', 'Staff-1469412109-14694121417942110', 1, 0, '', NULL, NULL, NULL),
(3948, '2016-07-25 10:02:21', NULL, NULL, 1374, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 10:02:21', 'Staff-1469412109-14694121417942110', 1, 0, '', NULL, NULL, NULL),
(3949, '2016-07-25 10:02:21', NULL, NULL, 1374, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469445375', 'Staff', '2016-07-25 10:02:21', 'Staff-1469412109-14694121417942110', 1, 1, 'SR', NULL, NULL, NULL),
(3950, '2016-07-26 16:45:43', NULL, NULL, 1401, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 16:45:43', 'admin-1469506369-14695227434278431', 1, 1, 'SR', NULL, NULL, NULL),
(3951, '2016-07-26 16:45:43', NULL, NULL, 1401, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 16:45:43', 'admin-1469506369-14695227434278431', 1, 1, 'SR', NULL, NULL, NULL),
(3952, '2016-07-26 17:03:07', NULL, NULL, 1397, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 17:03:07', 'admin-1469506369-14695237870024151', 1, 0, '', NULL, NULL, NULL),
(3953, '2016-07-26 15:45:34', NULL, NULL, 1400, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 15:45:34', 'admin-1469506369-14695191339227827', 1, 1, 'SR', NULL, NULL, NULL),
(3954, '2016-07-26 17:18:13', NULL, NULL, 1403, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 17:18:13', 'admin-1469506369-14695246935987267', 1, 0, '', NULL, NULL, NULL),
(3955, '2016-07-26 17:18:13', NULL, NULL, 1403, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 17:18:13', 'admin-1469506369-14695246935987267', 1, 1, 'SR', NULL, NULL, NULL),
(3956, '2016-07-26 17:18:13', NULL, NULL, 1403, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 17:18:13', 'admin-1469506369-14695246935987267', 1, 0, '', NULL, NULL, NULL),
(3957, '2016-07-26 17:04:54', NULL, NULL, 1401, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 17:04:54', 'admin-1469506369-14695238938453042', 1, 0, '', NULL, NULL, NULL),
(3958, '2016-07-26 17:03:24', NULL, NULL, 1402, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 17:03:24', 'admin-1469506369-1469523804486941', 1, 1, 'SR', NULL, NULL, NULL),
(3959, '2016-07-26 14:34:23', NULL, NULL, 1398, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 14:34:23', 'admin-1469506369-14695148628036457', 1, 1, 'SR', NULL, NULL, NULL),
(3960, '2016-07-26 14:34:23', NULL, NULL, 1398, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 14:34:23', 'admin-1469506369-14695148628036457', 1, 1, 'SR', NULL, NULL, NULL),
(3961, '2016-07-26 14:43:33', NULL, NULL, 1399, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 14:43:33', 'admin-1469506369-14695154130323688', 1, 1, 'SR', 1, NULL, NULL),
(3962, '2016-07-26 15:45:34', NULL, NULL, 1400, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 15:45:34', 'admin-1469506369-14695191339227827', 1, 0, '', NULL, NULL, NULL),
(3963, '2016-07-26 14:31:33', NULL, NULL, 1397, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 14:31:33', 'admin-1469506369-1469514693228106', 1, 1, 'SR', NULL, NULL, NULL),
(3964, '2016-07-26 13:58:16', NULL, NULL, 1396, 0, 182, '117', 'Open Drinks ', 'tea', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 13:58:16', 'admin-1469506369-14695126967664533', 1, 0, '', NULL, NULL, NULL),
(3965, '2016-07-26 13:58:16', NULL, NULL, 1396, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 13:58:16', 'admin-1469506369-14695126967664533', 1, 1, 'SR', NULL, NULL, NULL),
(3966, '2016-07-26 13:58:16', NULL, NULL, 1396, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 13:58:16', 'admin-1469506369-14695126967664533', 1, 0, '', NULL, NULL, NULL),
(3967, '2016-07-26 12:37:28', NULL, NULL, 1395, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 12:37:28', 'admin-1469506369-146950784784848', 1, 1, 'SR', NULL, NULL, NULL),
(3968, '2016-07-26 13:58:16', NULL, NULL, 1396, 0, 182, '117', 'Open Drinks ', '', 'Desserts', '0', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 13:58:16', 'admin-1469506369-14695126967664533', 1, 0, '', NULL, NULL, NULL),
(3969, '2016-07-26 12:37:28', NULL, NULL, 1395, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 12:37:28', 'admin-1469506369-146950784784848', 1, 1, 'SR', NULL, NULL, NULL),
(3970, '2016-07-26 12:37:28', NULL, NULL, 1395, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 12:37:28', 'admin-1469506369-146950784784848', 1, 1, 'SR', NULL, NULL, NULL),
(3971, '2016-07-26 12:00:45', NULL, NULL, 1395, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 12:00:45', 'admin-1469445420-14695056452886694', 1, 0, '', NULL, NULL, NULL),
(3972, '2016-07-26 12:00:45', NULL, NULL, 1395, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 12:00:45', 'admin-1469445420-14695056452886694', 1, 0, '', NULL, NULL, NULL),
(3973, '2016-07-26 12:17:20', NULL, NULL, 1395, 0, 181, '116', 'Open Food ', 'toast', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 12:17:20', 'admin-1469506369-14695066397076583', 1, 0, '', NULL, NULL, NULL),
(3974, '2016-07-26 12:17:19', NULL, NULL, 1395, 0, 181, '116', 'Open Food ', '', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 12:17:19', 'admin-1469506369-14695066397076583', 1, 0, '', NULL, NULL, NULL),
(3975, '2016-07-26 12:00:45', NULL, NULL, 1395, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 12:00:45', 'admin-1469445420-14695056452886694', 1, 1, 'SR', NULL, NULL, NULL),
(3976, '2016-07-26 12:00:45', NULL, NULL, 1395, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 12:00:45', 'admin-1469445420-14695056452886694', 1, 1, 'SR', NULL, NULL, NULL),
(3977, '2016-07-26 12:00:45', NULL, NULL, 1395, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 12:00:45', 'admin-1469445420-14695056452886694', 1, 1, 'SR', NULL, NULL, NULL),
(3978, '2016-07-26 12:00:45', NULL, NULL, 1395, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 12:00:45', 'admin-1469445420-14695056452886694', 1, 1, 'SR', NULL, NULL, NULL),
(3979, '2016-07-26 12:00:45', NULL, NULL, 1395, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 12:00:45', 'admin-1469445420-14695056452886694', 1, 1, 'SR', NULL, NULL, NULL),
(3980, '2016-07-26 11:47:24', NULL, NULL, 1392, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 11:47:24', 'admin-1469445420-1469504843973415', 1, 0, '', NULL, NULL, NULL),
(3981, '2016-07-26 11:41:56', NULL, NULL, 1394, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 11:41:56', 'admin-1469445420-1469504516107321', 1, 1, 'SR', NULL, NULL, NULL),
(3982, '2016-07-26 11:28:56', NULL, NULL, 1393, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 11:28:56', 'admin-1469445420-14695037363567673', 1, 0, '', NULL, NULL, NULL),
(3983, '2016-07-26 11:37:27', NULL, NULL, 1393, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 11:37:27', 'admin-1469445420-14695042473167128', 1, 1, 'SR', NULL, NULL, NULL),
(3984, '2016-07-26 11:37:27', NULL, NULL, 1393, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 11:37:27', 'admin-1469445420-14695042473167128', 1, 1, 'SR', NULL, NULL, NULL),
(3985, '2016-07-26 11:37:46', NULL, NULL, 1394, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 11:37:46', 'admin-1469445420-14695042667653090', 1, 1, 'SR', NULL, NULL, NULL),
(3986, '2016-07-26 11:28:56', NULL, NULL, 1393, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 11:28:56', 'admin-1469445420-14695037363567673', 1, 0, '', NULL, NULL, NULL),
(3987, '2016-07-26 11:05:16', NULL, NULL, 1392, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 11:05:16', 'admin-1469445420-14695023161685890', 1, 0, '', NULL, NULL, NULL),
(3988, '2016-07-26 11:05:16', NULL, NULL, 1392, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 11:05:16', 'admin-1469445420-14695023161685890', 1, 1, 'SR', NULL, NULL, NULL),
(3989, '2016-07-26 11:03:34', NULL, NULL, 1392, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469528863', 'admin', '2016-07-26 11:03:34', 'admin-1469445420-14695022139871798', 1, 0, '', NULL, NULL, NULL),
(3990, '2016-07-28 18:55:21', NULL, NULL, 1434, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 18:55:21', 'admin-1469696146-14697033209104977', 1, 1, 'SR', 1, NULL, NULL),
(3991, '2016-07-28 13:29:48', NULL, NULL, 1420, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 13:29:48', 'Staff-1469676869-14696837887745787', 1, 1, 'SR', 1, NULL, NULL),
(3992, '2016-07-28 00:00:00', NULL, NULL, 1419, NULL, 84, '84', 'Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 13:19:42', 'Staff-1469676869-1469683182143619', 1, 1, 'SR', NULL, NULL, NULL),
(3993, '2016-07-28 00:00:00', NULL, NULL, 1419, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 13:19:42', 'Staff-1469676869-1469683182143619', 1, 1, 'SR', NULL, NULL, NULL),
(3994, '2016-07-28 00:00:00', NULL, NULL, 1418, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 13:19:42', 'Staff-1469676869-1469683182143619', 1, 0, '', NULL, NULL, NULL),
(3995, '2016-07-28 13:42:21', NULL, NULL, 1421, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 13:42:21', 'Staff-1469676869-14696845408755915', 1, 0, '', NULL, NULL, NULL),
(3996, '2016-07-28 13:42:21', NULL, NULL, 1421, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 13:42:21', 'Staff-1469676869-14696845408755915', 1, 1, 'SR', NULL, NULL, NULL),
(3997, '2016-07-28 13:43:49', NULL, NULL, 1421, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 13:43:49', 'Staff-1469676869-14696846290485340', 1, 1, 'SR', NULL, NULL, NULL),
(3998, '2016-07-28 13:48:57', NULL, NULL, 1422, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 13:48:57', 'Staff-1469676869-14696849370239983', 1, 1, 'SR', NULL, NULL, NULL),
(3999, '2016-07-28 13:48:57', NULL, NULL, 1422, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 13:48:57', 'Staff-1469676869-14696849370239983', 1, 0, '', NULL, NULL, NULL),
(4000, '2016-07-28 14:15:24', NULL, NULL, 1423, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 14:15:24', 'Staff-1469684952-14696865245819191', 1, 1, 'SR', NULL, NULL, NULL),
(4001, '2016-07-28 14:59:19', NULL, NULL, 1424, 0, 182, '117', 'Open Drinks ', 'tea by pot', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 14:59:19', 'Staff-1469684952-14696891595108722', 1, 0, '', NULL, NULL, NULL),
(4002, '2016-07-28 15:06:05', NULL, NULL, 1425, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 15:06:05', 'Staff-1469684952-14696895648603072', 1, 1, 'SR', 1, NULL, NULL),
(4003, '2016-07-28 16:11:04', NULL, NULL, 1426, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 16:11:04', 'admin-1469693333-14696934646325244', 1, 0, '', NULL, NULL, NULL),
(4004, '2016-07-28 16:11:04', NULL, NULL, 1426, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 16:11:04', 'admin-1469693333-14696934646325244', 1, 1, 'SR', NULL, NULL, NULL),
(4005, '2016-07-28 16:55:57', NULL, NULL, 1427, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 16:55:57', 'admin-1469696146-14696961575599260', 1, 1, 'SR', 1, NULL, NULL),
(4006, '2016-07-28 18:04:21', NULL, NULL, 1428, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 18:04:21', 'admin-1469696146-1469700261797131', 1, 1, 'SR', NULL, NULL, NULL),
(4007, '2016-07-28 18:04:53', NULL, NULL, 1429, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 18:04:53', 'admin-1469696146-14697002936574791', 1, 1, 'SR', NULL, NULL, NULL),
(4008, '2016-07-28 18:05:20', NULL, NULL, 1430, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 18:05:20', 'admin-1469696146-14697003204632663', 1, 1, 'SR', NULL, NULL, NULL),
(4009, '2016-07-28 18:16:07', NULL, NULL, 1432, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 18:16:07', 'admin-1469696146-14697009670342190', 1, 1, 'SR', NULL, NULL, NULL),
(4010, '2016-07-28 18:16:48', NULL, NULL, 1432, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 18:16:48', 'admin-1469696146-14697010081422027', 1, 1, 'SR', NULL, NULL, NULL),
(4011, '2016-07-28 18:16:48', NULL, NULL, 1432, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 18:16:48', 'admin-1469696146-14697010081422027', 1, 1, 'SR', NULL, NULL, NULL),
(4012, '2016-07-28 18:16:48', NULL, NULL, 1432, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 18:16:48', 'admin-1469696146-14697010081422027', 1, 0, '', NULL, NULL, NULL),
(4013, '2016-07-28 18:55:15', NULL, NULL, 1433, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 18:55:15', 'admin-1469696146-14697033158058043', 1, 0, '', NULL, NULL, NULL),
(4014, '2016-07-28 18:55:15', NULL, NULL, 1433, 0, 182, '117', 'Open Drinks ', 'PROMO TEA', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 18:55:15', 'admin-1469696146-14697033158058043', 1, 0, '', NULL, NULL, NULL),
(4015, '2016-07-28 18:15:41', NULL, NULL, 1431, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 18:15:41', 'admin-1469696146-14697009408661243', 1, 1, 'SR', NULL, NULL, NULL),
(4016, '2016-07-28 18:15:41', NULL, NULL, 1431, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 18:15:41', 'admin-1469696146-14697009408661243', 1, 1, 'SR', NULL, NULL, NULL),
(4017, '2016-07-28 18:15:31', NULL, NULL, 1432, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 18:15:31', 'admin-1469696146-14697009312598096', 1, 1, 'SR', NULL, NULL, NULL),
(4018, '2016-07-28 18:15:31', NULL, NULL, 1432, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 18:15:31', 'admin-1469696146-14697009312598096', 1, 1, 'SR', NULL, NULL, NULL),
(4019, '2016-07-28 13:10:10', NULL, NULL, 1416, 0, 76, '76', 'Pesto Pasta', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 13:10:10', 'Staff-1469676869-14696826098711175', 1, 1, 'SR', NULL, NULL, NULL),
(4020, '2016-07-28 13:10:10', NULL, NULL, 1416, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 13:10:10', 'Staff-1469676869-14696826098711175', 1, 0, '', NULL, NULL, NULL),
(4021, '2016-07-28 13:10:10', NULL, NULL, 1416, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 13:10:10', 'Staff-1469676869-14696826098711175', 1, 1, 'SR', NULL, NULL, NULL),
(4022, '2016-07-28 00:00:00', NULL, NULL, 1419, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 13:19:42', 'Staff-1469676869-1469683182143619', 1, 0, '', NULL, NULL, NULL),
(4023, '2016-07-28 13:10:10', NULL, NULL, 1416, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 13:10:10', 'Staff-1469676869-14696826098711175', 1, 0, '', NULL, NULL, NULL),
(4024, '2016-07-28 12:56:51', NULL, NULL, 1414, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 12:56:51', 'Staff-1469676869-1469681811219195', 1, 1, 'SR', NULL, NULL, NULL),
(4025, '2016-07-28 12:56:51', NULL, NULL, 1414, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 2, 14.00, 28.0000, 0.0000, 28.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 12:56:51', 'Staff-1469676869-1469681811219195', 1, 1, 'SR', NULL, NULL, NULL),
(4026, '2016-07-28 13:02:45', NULL, NULL, 1415, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 13:02:45', 'Staff-1469676869-14696821648771665', 1, 1, 'SR', 1, NULL, NULL),
(4027, '2016-07-28 13:10:10', NULL, NULL, 1416, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 13:10:10', 'Staff-1469676869-14696826098711175', 1, 0, '', NULL, NULL, NULL),
(4028, '2016-07-28 12:42:23', NULL, NULL, 1413, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 12:42:23', 'Staff-1469676869-14696809436507072', 1, 1, 'SR', NULL, NULL, NULL),
(4029, '2016-07-28 12:42:23', NULL, NULL, 1413, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 12:42:23', 'Staff-1469676869-14696809436507072', 1, 1, 'SR', NULL, NULL, NULL),
(4030, '2016-07-28 12:42:23', NULL, NULL, 1413, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 12:42:23', 'Staff-1469676869-14696809436507072', 1, 1, 'SR', NULL, NULL, NULL),
(4031, '2016-07-28 12:42:23', NULL, NULL, 1413, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 12:42:23', 'Staff-1469676869-14696809436507072', 1, 1, 'SR', NULL, NULL, NULL),
(4032, '2016-07-28 12:56:51', NULL, NULL, 1414, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 12:56:51', 'Staff-1469676869-1469681811219195', 1, 1, 'SR', NULL, NULL, NULL),
(4033, '2016-07-28 09:19:06', NULL, NULL, 1407, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 09:19:06', 'admin-1469666931-1469668746306340', 1, 0, '', NULL, NULL, NULL),
(4034, '2016-07-28 09:23:06', NULL, NULL, 1408, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 09:23:06', 'admin-1469666931-14696689866645913', 1, 0, '', NULL, NULL, NULL),
(4035, '2016-07-28 09:23:06', NULL, NULL, 1408, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 09:23:06', 'admin-1469666931-14696689866645913', 1, 1, 'SR', NULL, NULL, NULL),
(4036, '2016-07-28 09:28:01', NULL, NULL, 1409, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 09:28:01', 'admin-1469666931-1469669280934502', 1, 1, 'SR', NULL, NULL, NULL),
(4037, '2016-07-28 09:28:30', NULL, NULL, 1409, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 09:28:30', 'admin-1469666931-14696693105509092', 1, 0, '', NULL, NULL, NULL),
(4038, '2016-07-28 00:00:00', NULL, NULL, 1411, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 10:00:29', 'admin-1469666931-14696712287899435', 1, 1, 'SR', NULL, NULL, NULL),
(4039, '2016-07-28 10:00:10', NULL, NULL, 1410, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 10:00:10', 'admin-1469666931-14696712101228415', 1, 0, '', NULL, NULL, NULL),
(4040, '2016-07-28 10:01:30', NULL, NULL, 1410, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 10:01:30', 'admin-1469666931-14696712899369158', 1, 1, 'SR', NULL, NULL, NULL),
(4041, '2016-07-28 00:00:00', NULL, NULL, 1411, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 10:00:10', 'admin-1469666931-14696712101228415', 1, 0, '', NULL, NULL, NULL),
(4042, '2016-07-28 10:34:06', NULL, NULL, 1412, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 10:34:06', 'admin-1469666931-14696732461577015', 1, 0, '', NULL, NULL, NULL),
(4043, '2016-07-28 10:34:06', NULL, NULL, 1412, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 10:34:06', 'admin-1469666931-14696732461577015', 1, 0, '', NULL, NULL, NULL),
(4044, '2016-07-28 10:40:05', NULL, NULL, 1412, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 10:40:05', 'admin-1469673263-14696736048945472', 1, 1, 'SR', NULL, NULL, NULL),
(4045, '2016-07-28 12:42:23', NULL, NULL, 1413, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469709163', 'Staff', '2016-07-28 12:42:23', 'Staff-1469676869-14696809436507072', 1, 0, '', NULL, NULL, NULL),
(4046, '2016-07-28 09:19:06', NULL, NULL, 1407, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 09:19:06', 'admin-1469666931-1469668746306340', 1, 0, '', NULL, NULL, NULL),
(4047, '2016-07-28 09:08:08', NULL, NULL, 1406, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 09:08:08', 'admin-1469666931-14696680880686951', 1, 0, '', NULL, NULL, NULL),
(4048, '2016-07-28 09:05:13', NULL, NULL, 1405, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 09:05:13', 'admin-1469666931-14696679132135165', 1, 1, 'SR', NULL, NULL, NULL),
(4049, '2016-07-28 09:08:08', NULL, NULL, 1406, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 09:08:08', 'admin-1469666931-14696680880686951', 1, 0, '', NULL, NULL, NULL),
(4050, '2016-07-28 09:05:13', NULL, NULL, 1405, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469709163', 'admin', '2016-07-28 09:05:13', 'admin-1469666931-14696679132135165', 1, 0, '', NULL, NULL, NULL),
(4051, '2016-07-29 20:00:35', NULL, NULL, 1461, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 20:00:35', 'admin-1469783398-14697936350002798', 1, 0, '', NULL, NULL, NULL),
(4052, '2016-07-29 21:15:44', NULL, NULL, 1466, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 21:15:44', 'admin-1469797949-14697981447431736', 1, 0, '', NULL, NULL, NULL),
(4053, '2016-07-29 20:26:49', NULL, NULL, 1462, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 20:26:49', 'admin-1469783398-14697952097859999', 1, 1, 'SR', NULL, NULL, NULL),
(4054, '2016-07-29 20:50:13', NULL, NULL, 1463, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 20:50:13', 'admin-1469783398-14697966131101130', 1, 1, 'SR', NULL, NULL, NULL),
(4055, '2016-07-29 20:50:13', NULL, NULL, 1463, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 20:50:13', 'admin-1469783398-14697966131101130', 1, 0, '', NULL, NULL, NULL),
(4056, '2016-07-29 21:08:37', NULL, NULL, 1464, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 21:08:37', 'admin-1469783398-14697977169377729', 1, 0, '', NULL, NULL, NULL),
(4057, '2016-07-29 21:10:33', NULL, NULL, 1465, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 21:10:33', 'admin-1469783398-14697978337915156', 1, 1, 'SR', NULL, NULL, NULL),
(4058, '2016-07-29 21:10:49', NULL, NULL, 1465, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 21:10:49', 'admin-1469783398-14697978490767848', 1, 1, 'SR', NULL, NULL, NULL),
(4059, '2016-07-29 21:11:23', NULL, NULL, 1465, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 21:11:23', 'admin-1469783398-14697978831238290', 1, 0, '', NULL, NULL, NULL),
(4060, '2016-07-29 21:12:39', NULL, NULL, 1465, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 21:12:39', 'admin-1469797949-14697979594947535', 1, 0, '', NULL, NULL, NULL),
(4061, '2016-07-29 21:13:11', NULL, NULL, 1465, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 21:13:11', 'admin-1469797949-14697979908521437', 1, 1, 'SR', NULL, NULL, NULL),
(4062, '2016-07-29 21:52:57', NULL, NULL, 1469, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 21:52:57', 'admin-1469797949-1469800376989213', 1, 0, '', NULL, NULL, NULL),
(4063, '2016-07-29 21:32:53', NULL, NULL, 1469, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 21:32:53', 'admin-1469797949-14697991735451720', 1, 1, 'SR', NULL, NULL, NULL),
(4064, '2016-07-29 21:32:08', NULL, NULL, 1461, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 21:32:08', 'admin-1469797949-14697991287313384', 1, 0, '', NULL, NULL, NULL),
(4065, '2016-07-29 21:16:46', NULL, NULL, 1468, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 21:16:46', 'admin-1469797949-14697982066385415', 1, 1, 'SR', NULL, NULL, NULL),
(4066, '2016-07-29 21:16:46', NULL, NULL, 1468, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 21:16:46', 'admin-1469797949-14697982066385415', 1, 0, '', NULL, NULL, NULL),
(4067, '2016-07-29 21:16:46', NULL, NULL, 1468, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 21:16:46', 'admin-1469797949-14697982066385415', 1, 0, '', NULL, NULL, NULL),
(4068, '2016-07-29 21:16:18', NULL, NULL, 1467, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 21:16:18', 'admin-1469797949-14697981787372550', 1, 1, 'SR', NULL, NULL, NULL),
(4069, '2016-07-29 21:15:20', NULL, NULL, 1466, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 21:15:20', 'admin-1469797949-14697981202191798', 1, 0, '', NULL, NULL, NULL),
(4070, '2016-07-29 21:13:11', NULL, NULL, 1465, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 21:13:11', 'admin-1469797949-14697979908521437', 1, 1, 'SR', NULL, NULL, NULL),
(4071, '2016-07-29 20:00:35', NULL, NULL, 1461, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 20:00:35', 'admin-1469783398-14697936350002798', 1, 0, '', NULL, NULL, NULL),
(4072, '2016-07-29 20:00:35', NULL, NULL, 1461, 0, 182, '117', 'Open Drinks ', 'TEA BY POT', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 20:00:35', 'admin-1469783398-14697936350002798', 1, 0, '', NULL, NULL, NULL),
(4073, '2016-07-29 16:20:06', NULL, NULL, 1453, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 16:20:06', 'admin-1469752228-146978040581869', 1, 1, 'SR', 1, NULL, NULL),
(4074, '2016-07-29 16:25:38', NULL, NULL, 1454, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 16:25:38', 'admin-1469752228-1469780738259217', 1, 1, 'SR', NULL, NULL, NULL),
(4075, '2016-07-29 17:04:08', NULL, NULL, 1455, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 17:04:08', 'admin-1469752228-1469783048746728', 1, 1, 'SR', NULL, NULL, NULL),
(4076, '2016-07-29 17:04:08', NULL, NULL, 1455, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 17:04:08', 'admin-1469752228-1469783048746728', 1, 1, 'SR', NULL, NULL, NULL),
(4077, '2016-07-29 17:04:08', NULL, NULL, 1455, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 17:04:08', 'admin-1469752228-1469783048746728', 1, 1, 'SR', NULL, NULL, NULL),
(4078, '2016-07-29 17:04:08', NULL, NULL, 1455, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 17:04:08', 'admin-1469752228-1469783048746728', 1, 1, 'SR', NULL, NULL, NULL),
(4079, '2016-07-29 17:04:21', NULL, NULL, 1455, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 17:04:21', 'admin-1469752228-14697830617732525', 1, 0, '', NULL, NULL, NULL),
(4080, '2016-07-29 17:10:10', NULL, NULL, 1456, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 17:10:10', 'admin-1469783398-14697834099079166', 1, 1, 'SR', 1, NULL, NULL),
(4081, '2016-07-29 17:23:46', NULL, NULL, 1451, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 17:23:46', 'admin-1469783398-1469784226198173', 1, 0, '', NULL, NULL, NULL),
(4082, '2016-07-29 18:50:43', NULL, NULL, 1457, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 18:50:43', 'admin-1469783398-1469789443538249', 1, 1, 'SR', NULL, NULL, NULL),
(4083, '2016-07-29 18:50:43', NULL, NULL, 1457, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 18:50:43', 'admin-1469783398-1469789443538249', 1, 1, 'SR', NULL, NULL, NULL),
(4084, '2016-07-29 18:57:26', NULL, NULL, 1457, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 18:57:26', 'admin-1469783398-14697898468434743', 1, 1, 'SR', NULL, NULL, NULL),
(4085, '2016-07-29 18:57:27', NULL, NULL, 1457, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 18:57:27', 'admin-1469783398-14697898468434743', 1, 0, '', NULL, NULL, NULL),
(4086, '2016-07-29 19:03:43', NULL, NULL, 1458, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 19:03:43', 'admin-1469783398-14697902231076921', 1, 1, 'SR', NULL, NULL, NULL),
(4087, '2016-07-29 19:03:43', NULL, NULL, 1458, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 19:03:43', 'admin-1469783398-14697902231076921', 1, 1, 'SR', NULL, NULL, NULL),
(4088, '2016-07-29 19:05:48', NULL, NULL, 1457, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 19:05:48', 'admin-1469783398-14697903482163634', 1, 1, 'SR', NULL, NULL, NULL),
(4089, '2016-07-29 19:06:16', NULL, NULL, 1459, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 19:06:16', 'admin-1469783398-14697903763092636', 1, 1, 'SR', NULL, NULL, NULL),
(4090, '2016-07-29 19:06:16', NULL, NULL, 1459, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 19:06:16', 'admin-1469783398-14697903763092636', 1, 1, 'SR', NULL, NULL, NULL),
(4091, '2016-07-29 19:50:20', NULL, NULL, 1460, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 19:50:20', 'admin-1469783398-1469793020049724', 1, 1, 'SR', NULL, NULL, NULL),
(4092, '2016-07-29 15:59:06', NULL, NULL, 1451, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 15:59:06', 'admin-1469752228-14697791467003578', 1, 0, '', NULL, NULL, NULL),
(4093, '2016-07-29 15:59:06', NULL, NULL, 1451, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 15:59:06', 'admin-1469752228-14697791467003578', 1, 1, 'SR', NULL, NULL, NULL),
(4094, '2016-07-29 16:06:15', NULL, NULL, 1452, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 16:06:15', 'admin-1469752228-14697795749556833', 1, 0, '', NULL, NULL, NULL),
(4095, '2016-07-29 16:05:30', NULL, NULL, 1452, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 16:05:30', 'admin-1469752228-14697795299102344', 1, 1, 'SR', NULL, NULL, NULL),
(4096, '2016-07-29 16:15:35', NULL, NULL, 1452, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 16:15:35', 'admin-1469752228-14697801348021698', 1, 0, '', NULL, NULL, NULL),
(4097, '2016-07-29 16:06:15', NULL, NULL, 1452, 0, 181, '116', 'Open Food ', 'ice cream 1 scoop', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 16:06:15', 'admin-1469752228-14697795749556833', 1, 0, '', NULL, NULL, NULL),
(4098, '2016-07-29 15:49:48', NULL, NULL, 1442, 0, 182, '117', 'Open Drinks ', 'tea', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 15:49:48', 'admin-1469752228-14697785883692473', 1, 0, '', NULL, NULL, NULL),
(4099, '2016-07-29 15:59:06', NULL, NULL, 1451, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 15:59:06', 'admin-1469752228-14697791467003578', 1, 0, '', NULL, NULL, NULL),
(4100, '2016-07-29 15:59:06', NULL, NULL, 1451, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 15:59:06', 'admin-1469752228-14697791467003578', 1, 1, 'SR', NULL, NULL, NULL),
(4101, '2016-07-29 15:59:06', NULL, NULL, 1451, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 15:59:06', 'admin-1469752228-14697791467003578', 1, 0, '', NULL, NULL, NULL),
(4102, '2016-07-29 15:59:06', NULL, NULL, 1451, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 15:59:06', 'admin-1469752228-14697791467003578', 1, 1, 'SR', NULL, NULL, NULL),
(4103, '2016-07-29 14:50:04', NULL, NULL, 1448, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 14:50:04', 'admin-1469752228-14697750043557377', 1, 1, 'SR', NULL, NULL, '10.0'),
(4104, '2016-07-29 14:54:11', NULL, NULL, 1449, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 14:54:11', 'admin-1469752228-14697752516752440', 1, 1, 'SR', 1, NULL, NULL),
(4105, '2016-07-29 14:54:11', NULL, NULL, 1449, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 14:54:11', 'admin-1469752228-14697752516752440', 1, 1, 'SR', 1, NULL, NULL),
(4106, '2016-07-29 15:49:48', NULL, NULL, 1442, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 15:49:48', 'admin-1469752228-14697785883692473', 1, 0, '', NULL, NULL, NULL),
(4107, '2016-07-29 14:50:04', NULL, NULL, 1448, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 14:50:04', 'admin-1469752228-14697750043557377', 1, 1, 'SR', NULL, NULL, '10.0'),
(4108, '2016-07-29 15:24:43', NULL, NULL, 1450, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 15:24:43', 'admin-1469752228-1469777083266258', 1, 1, 'SR', NULL, NULL, '10.0'),
(4109, '2016-07-29 15:24:43', NULL, NULL, 1450, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 15:24:43', 'admin-1469752228-1469777083266258', 1, 1, 'SR', NULL, NULL, '10.0'),
(4110, '2016-07-29 14:15:51', NULL, NULL, 1446, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 14:15:51', 'admin-1469752228-14697729514887852', 1, 0, '', 1, NULL, NULL),
(4111, '2016-07-29 14:45:04', NULL, NULL, 1447, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 14:45:04', 'admin-1469752228-14697747045746659', 1, 1, 'SR', 1, NULL, NULL),
(4112, '2016-07-29 13:34:24', NULL, NULL, 1443, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 13:34:24', 'admin-1469752228-14697704645379487', 1, 0, '', NULL, NULL, NULL),
(4113, '2016-07-29 13:35:34', NULL, NULL, 1444, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 13:35:34', 'admin-1469752228-14697705345783119', 1, 1, 'SR', NULL, NULL, NULL),
(4114, '2016-07-29 13:35:34', NULL, NULL, 1444, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 13:35:34', 'admin-1469752228-14697705345783119', 1, 1, 'SR', NULL, NULL, NULL),
(4115, '2016-07-29 14:45:04', NULL, NULL, 1447, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 14:45:04', 'admin-1469752228-14697747045746659', 1, 1, 'SR', 1, NULL, NULL),
(4116, '2016-07-29 14:49:52', NULL, NULL, 1448, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 14:49:52', 'admin-1469752228-14697749927699820', 1, 0, '', NULL, NULL, '10.0'),
(4117, '2016-07-29 10:52:36', NULL, NULL, 1437, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 10:52:36', 'admin-1469752228-14697607567424290', 1, 0, '', 1, NULL, NULL),
(4118, '2016-07-29 10:54:52', NULL, NULL, 1438, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 10:54:52', 'admin-1469752228-14697608926645973', 1, 1, 'SR', NULL, NULL, NULL),
(4119, '2016-07-29 11:21:37', NULL, NULL, 1439, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 11:21:37', 'admin-1469752228-14697624970752696', 1, 1, 'SR', NULL, NULL, NULL),
(4120, '2016-07-29 11:21:37', NULL, NULL, 1439, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 11:21:37', 'admin-1469752228-14697624970752696', 1, 0, '', NULL, NULL, NULL),
(4121, '2016-07-29 13:12:01', NULL, NULL, 1440, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 13:12:01', 'admin-1469752228-14697691215452666', 1, 1, 'SR', NULL, NULL, NULL),
(4122, '2016-07-29 13:12:15', NULL, NULL, 1440, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 13:12:15', 'admin-1469752228-14697691352456829', 1, 1, 'SR', NULL, NULL, NULL),
(4123, '2016-07-29 13:12:26', NULL, NULL, 1441, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 13:12:26', 'admin-1469752228-14697691462347330', 1, 1, 'SR', NULL, NULL, NULL),
(4124, '2016-07-29 13:15:01', NULL, NULL, 1442, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 13:15:01', 'admin-1469752228-14697693015088088', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(4125, '2016-07-29 13:15:01', NULL, NULL, 1442, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 13:15:01', 'admin-1469752228-14697693015088088', 1, 0, '', NULL, NULL, NULL),
(4126, '2016-07-29 13:15:01', NULL, NULL, 1442, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 13:15:01', 'admin-1469752228-14697693015088088', 1, 1, 'SR', NULL, NULL, NULL),
(4127, '2016-07-29 13:15:42', NULL, NULL, 1442, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 13:15:42', 'admin-1469752228-14697693425651198', 1, 1, 'SR', NULL, NULL, NULL),
(4128, '2016-07-29 13:34:24', NULL, NULL, 1443, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 13:34:24', 'admin-1469752228-14697704645379487', 1, 1, 'SR', NULL, NULL, NULL),
(4129, '2016-07-29 13:34:24', NULL, NULL, 1443, 0, 182, '117', 'Open Drinks ', '', 'Desserts', '0', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 13:34:24', 'admin-1469752228-14697704645379487', 1, 0, '', NULL, NULL, NULL),
(4130, '2016-07-29 13:34:24', NULL, NULL, 1443, 0, 182, '117', 'Open Drinks ', 'tea', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 13:34:24', 'admin-1469752228-14697704645379487', 1, 0, '', NULL, NULL, NULL),
(4131, '2016-07-29 10:14:48', NULL, NULL, 1436, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 10:14:48', 'admin-1469752228-14697584878902670', 1, 1, 'SR', NULL, NULL, NULL),
(4132, '2016-07-29 09:26:59', NULL, NULL, 1435, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 09:26:59', 'admin-1469752228-14697556191695326', 1, 0, '', NULL, NULL, NULL),
(4133, '2016-07-29 10:14:48', NULL, NULL, 1436, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 10:14:48', 'admin-1469752228-14697584878902670', 1, 1, 'SR', NULL, NULL, NULL),
(4134, '2016-07-29 09:26:41', NULL, NULL, 1435, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469800747', 'admin', '2016-07-29 09:26:41', 'admin-1469752228-14697556012881567', 1, 1, 'SR', NULL, NULL, NULL),
(4135, '2016-07-30 20:07:47', NULL, NULL, 1519, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:07:47', 'admin-1469869414-14698804670181642', 1, 0, '', NULL, NULL, NULL),
(4136, '2016-07-30 20:07:47', NULL, NULL, 1519, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:07:47', 'admin-1469869414-14698804670181642', 1, 0, '', NULL, NULL, NULL),
(4137, '2016-07-30 20:07:47', NULL, NULL, 1519, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:07:47', 'admin-1469869414-14698804670181642', 1, 0, '', NULL, NULL, NULL),
(4138, '2016-07-30 20:07:47', NULL, NULL, 1519, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:07:47', 'admin-1469869414-14698804670181642', 1, 1, 'SR', NULL, NULL, NULL),
(4139, '2016-07-30 20:35:07', NULL, NULL, 1520, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 3, 12.00, 36.0000, 0.0000, 36.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:35:07', 'admin-1469869414-14698821072734472', 1, 1, 'SR', NULL, NULL, NULL),
(4140, '2016-07-30 20:38:35', NULL, NULL, 1521, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:38:35', 'admin-1469869414-14698823149463457', 1, 0, '', NULL, NULL, NULL),
(4141, '2016-07-30 20:38:35', NULL, NULL, 1521, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:38:35', 'admin-1469869414-14698823149463457', 1, 1, 'SR', NULL, NULL, NULL),
(4142, '2016-07-30 20:38:35', NULL, NULL, 1521, 0, 199, '134', 'Dinner - Marmite Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:38:35', 'admin-1469869414-14698823149463457', 1, 0, '', NULL, NULL, NULL),
(4143, '2016-07-30 20:38:35', NULL, NULL, 1521, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:38:35', 'admin-1469869414-14698823149463457', 1, 0, '', NULL, NULL, NULL),
(4144, '2016-07-30 20:39:49', NULL, NULL, 1522, 0, 199, '134', 'Dinner - Marmite Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:39:49', 'admin-1469869414-14698823890805921', 1, 0, '', NULL, NULL, NULL),
(4145, '2016-07-30 20:39:49', NULL, NULL, 1522, 0, 198, '133', 'Dinner - Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:39:49', 'admin-1469869414-14698823890805921', 1, 0, '', NULL, NULL, NULL),
(4146, '2016-07-30 20:39:49', NULL, NULL, 1522, 0, 197, '132', 'Dinner - Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:39:49', 'admin-1469869414-14698823890805921', 1, 0, '', NULL, NULL, NULL),
(4147, '2016-07-30 20:39:49', NULL, NULL, 1522, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:39:49', 'admin-1469869414-14698823890805921', 1, 0, '', NULL, NULL, NULL),
(4148, '2016-07-30 20:39:49', NULL, NULL, 1522, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:39:49', 'admin-1469869414-14698823890805921', 1, 0, '', NULL, NULL, NULL),
(4149, '2016-07-30 20:39:49', NULL, NULL, 1522, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:39:49', 'admin-1469869414-14698823890805921', 1, 0, '', NULL, NULL, NULL),
(4150, '2016-07-30 20:39:49', NULL, NULL, 1522, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:39:49', 'admin-1469869414-14698823890805921', 1, 0, '', NULL, NULL, NULL),
(4151, '2016-07-30 20:39:49', NULL, NULL, 1522, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:39:49', 'admin-1469869414-14698823890805921', 1, 0, '', NULL, NULL, NULL),
(4152, '2016-07-30 20:40:21', NULL, NULL, 1522, 0, 182, '117', 'Open Drinks ', 'tea', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:40:21', 'admin-1469869414-14698824214483661', 1, 0, '', NULL, NULL, NULL),
(4153, '2016-07-30 20:44:45', NULL, NULL, 1523, 0, 198, '133', 'Dinner - Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:44:45', 'admin-1469869414-14698826854022428', 1, 0, '', NULL, NULL, NULL),
(4154, '2016-07-30 20:44:45', NULL, NULL, 1523, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:44:45', 'admin-1469869414-14698826854022428', 1, 0, '', NULL, NULL, NULL),
(4155, '2016-07-30 20:44:45', NULL, NULL, 1523, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:44:45', 'admin-1469869414-14698826854022428', 1, 0, '', NULL, NULL, NULL),
(4156, '2016-07-30 20:44:45', NULL, NULL, 1523, 0, 197, '132', 'Dinner - Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:44:45', 'admin-1469869414-14698826854022428', 1, 0, '', NULL, NULL, NULL),
(4157, '2016-07-30 20:44:45', NULL, NULL, 1523, 0, 182, '117', 'Open Drinks ', 'tea', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:44:45', 'admin-1469869414-14698826854022428', 1, 0, '', NULL, NULL, NULL),
(4158, '2016-07-30 20:49:02', NULL, NULL, 1524, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:49:02', 'admin-1469882701-14698829426448063', 1, 0, '', NULL, NULL, NULL),
(4159, '2016-07-30 20:50:50', NULL, NULL, 1525, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 20:50:50', 'admin-1469882701-14698830499818448', 1, 0, '', NULL, NULL, NULL),
(4160, '2016-07-30 21:28:46', NULL, NULL, 1526, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 21:28:46', 'admin-1469882701-14698853264012584', 1, 0, '', NULL, NULL, NULL),
(4161, '2016-07-30 15:48:13', NULL, NULL, 1510, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 15:48:13', 'admin-1469862445-14698648933401779', 1, 1, 'SR', NULL, NULL, NULL),
(4162, '2016-07-30 15:48:13', NULL, NULL, 1510, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 15:48:13', 'admin-1469862445-14698648933401779', 1, 1, 'SR', NULL, NULL, NULL),
(4163, '2016-07-30 15:49:00', NULL, NULL, 1510, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 15:49:00', 'admin-1469862445-14698649402288054', 1, 1, 'SR', NULL, NULL, NULL),
(4164, '2016-07-30 15:49:00', NULL, NULL, 1510, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 15:49:00', 'admin-1469862445-14698649402288054', 1, 1, 'SR', NULL, NULL, NULL),
(4165, '2016-07-30 15:55:12', NULL, NULL, 1507, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 15:55:12', 'admin-1469862445-14698653126451317', 1, 1, 'SR', NULL, NULL, NULL),
(4166, '2016-07-30 15:57:25', NULL, NULL, 1511, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 15:57:25', 'admin-1469862445-14698654451653942', 1, 0, '', NULL, NULL, NULL),
(4167, '2016-07-30 15:57:25', NULL, NULL, 1511, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 15:57:25', 'admin-1469862445-14698654451653942', 1, 1, 'SR', NULL, NULL, NULL),
(4168, '2016-07-30 19:25:25', NULL, NULL, 1519, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 19:25:25', 'admin-1469869414-14698779253806629', 1, 0, '', NULL, NULL, NULL),
(4169, '2016-07-30 19:27:23', NULL, NULL, 1519, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 19:27:23', 'admin-1469869414-14698780437202686', 1, 1, 'SR', NULL, NULL, NULL),
(4170, '2016-07-30 19:27:23', NULL, NULL, 1519, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 19:27:23', 'admin-1469869414-14698780437202686', 1, 1, 'SR', NULL, NULL, NULL),
(4171, '2016-07-30 19:27:23', NULL, NULL, 1519, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 19:27:23', 'admin-1469869414-14698780437202686', 1, 0, '', NULL, NULL, NULL),
(4172, '2016-07-30 19:25:45', NULL, NULL, 1519, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 19:25:45', 'admin-1469869414-14698779454461977', 1, 1, 'SR', NULL, NULL, NULL),
(4173, '2016-07-30 19:25:25', NULL, NULL, 1519, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 19:25:25', 'admin-1469869414-14698779253806629', 1, 0, '', NULL, NULL, NULL),
(4174, '2016-07-30 19:25:25', NULL, NULL, 1519, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 19:25:25', 'admin-1469869414-14698779253806629', 1, 1, 'SR', NULL, NULL, NULL),
(4175, '2016-07-30 19:25:25', NULL, NULL, 1519, 0, 198, '133', 'Dinner - Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 19:25:25', 'admin-1469869414-14698779253806629', 1, 0, '', NULL, NULL, NULL),
(4176, '2016-07-30 19:25:25', NULL, NULL, 1519, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 19:25:25', 'admin-1469869414-14698779253806629', 1, 0, '', NULL, NULL, NULL),
(4177, '2016-07-30 19:25:25', NULL, NULL, 1519, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 19:25:25', 'admin-1469869414-14698779253806629', 1, 0, '', NULL, NULL, NULL),
(4178, '2016-07-30 17:00:20', NULL, NULL, 1512, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 17:00:20', 'admin-1469862445-1469869220263982', 1, 1, 'SR', NULL, NULL, '10.0'),
(4179, '2016-07-30 17:00:20', NULL, NULL, 1512, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 17:00:20', 'admin-1469862445-1469869220263982', 1, 0, '', NULL, NULL, '10.0'),
(4180, '2016-07-30 17:00:20', NULL, NULL, 1512, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 17:00:20', 'admin-1469862445-1469869220263982', 1, 0, '', NULL, NULL, '10.0'),
(4181, '2016-07-30 17:00:20', NULL, NULL, 1512, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 17:00:20', 'admin-1469862445-1469869220263982', 1, 0, '', NULL, NULL, '10.0'),
(4182, '2016-07-30 17:00:20', NULL, NULL, 1512, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 17:00:20', 'admin-1469862445-1469869220263982', 1, 0, '', NULL, NULL, '10.0'),
(4183, '2016-07-30 17:00:20', NULL, NULL, 1512, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 17:00:20', 'admin-1469862445-1469869220263982', 1, 0, '', NULL, NULL, '10.0'),
(4184, '2016-07-30 17:03:53', NULL, NULL, 1513, 0, 182, '117', 'Open Drinks ', 'tea', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 17:03:53', 'admin-1469869414-14698694328715167', 1, 0, '', NULL, NULL, NULL),
(4185, '2016-07-30 17:09:52', NULL, NULL, 1514, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 17:09:52', 'admin-1469869414-14698697922483938', 1, 1, 'SR', NULL, NULL, NULL),
(4186, '2016-07-30 17:09:52', NULL, NULL, 1514, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 17:09:52', 'admin-1469869414-14698697922483938', 1, 1, 'SR', NULL, NULL, NULL),
(4187, '2016-07-30 17:18:49', NULL, NULL, 1515, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 17:18:49', 'admin-1469869414-14698703288274433', 1, 1, 'SR', NULL, NULL, NULL),
(4188, '2016-07-30 17:19:48', NULL, NULL, 1515, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 17:19:48', 'admin-1469869414-14698703879602233', 1, 1, 'SR', NULL, NULL, NULL),
(4189, '2016-07-30 17:19:48', NULL, NULL, 1515, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 17:19:48', 'admin-1469869414-14698703879602233', 1, 1, 'SR', NULL, NULL, NULL),
(4190, '2016-07-30 17:19:48', NULL, NULL, 1515, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 17:19:48', 'admin-1469869414-14698703879602233', 1, 0, '', NULL, NULL, NULL),
(4191, '2016-07-30 18:21:29', NULL, NULL, 1517, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 18:21:29', 'admin-1469869414-14698740894914394', 1, 1, 'SR', NULL, NULL, NULL),
(4192, '2016-07-30 18:38:15', NULL, NULL, 1518, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 18:38:15', 'admin-1469869414-14698750953049098', 1, 1, 'SR', NULL, NULL, NULL),
(4193, '2016-07-30 15:57:25', NULL, NULL, 1511, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 15:57:25', 'admin-1469862445-14698654451653942', 1, 1, 'SR', NULL, NULL, NULL),
(4194, '2016-07-30 15:57:25', NULL, NULL, 1511, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 15:57:25', 'admin-1469862445-14698654451653942', 1, 0, '', NULL, NULL, NULL),
(4195, '2016-07-30 15:00:03', NULL, NULL, 1506, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'lois', '2016-07-30 15:00:03', 'lois-1469859643-14698620029634760', 1, 0, '', NULL, NULL, NULL),
(4196, '2016-07-30 15:07:56', NULL, NULL, 1507, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 15:07:56', 'admin-1469862445-14698624764956370', 1, 1, 'SR', NULL, NULL, NULL),
(4197, '2016-07-30 15:21:45', NULL, NULL, 1509, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 15:21:45', 'admin-1469862445-14698633056373084', 1, 1, 'SR', NULL, NULL, NULL),
(4198, '2016-07-30 15:17:37', NULL, NULL, 1508, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 15:17:37', 'admin-1469862445-14698630575758140', 1, 1, 'SR', NULL, NULL, NULL),
(4199, '2016-07-30 14:18:00', NULL, NULL, 1494, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1469886405', 'Staff', '2016-07-30 14:18:00', 'Staff-1469857554-146985948067571', 1, 0, '', NULL, NULL, NULL),
(4200, '2016-07-30 14:18:38', NULL, NULL, 1495, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'Staff', '2016-07-30 14:18:38', 'Staff-1469857554-1469859518176795', 1, 1, 'SR', NULL, NULL, NULL),
(4201, '2016-07-30 14:18:58', NULL, NULL, 1496, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469886405', 'Staff', '2016-07-30 14:18:58', 'Staff-1469857554-1469859538351710', 1, 1, 'SR', NULL, NULL, NULL),
(4202, '2016-07-30 14:18:58', NULL, NULL, 1496, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1469886405', 'Staff', '2016-07-30 14:18:58', 'Staff-1469857554-1469859538351710', 1, 0, '', NULL, NULL, NULL),
(4203, '2016-07-30 14:19:25', NULL, NULL, 1497, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1469886405', 'Staff', '2016-07-30 14:19:25', 'Staff-1469857554-1469859565273472', 1, 1, 'SR', NULL, NULL, NULL),
(4204, '2016-07-30 14:20:30', NULL, NULL, 1498, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469886405', 'Staff', '2016-07-30 14:20:30', 'Staff-1469857554-14698596298583274', 1, 1, 'SR', NULL, NULL, NULL),
(4205, '2016-07-30 14:21:34', NULL, NULL, 1499, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'lois', '2016-07-30 14:21:34', 'lois-1469859643-14698596940749075', 1, 0, '', NULL, NULL, NULL),
(4206, '2016-07-30 14:22:59', NULL, NULL, 1500, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'lois', '2016-07-30 14:22:59', 'lois-1469859643-14698597790031282', 1, 1, 'SR', NULL, NULL, NULL),
(4207, '2016-07-30 14:22:59', NULL, NULL, 1500, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1469886405', 'lois', '2016-07-30 14:22:59', 'lois-1469859643-14698597790031282', 1, 0, '', NULL, NULL, NULL),
(4208, '2016-07-30 14:33:11', NULL, NULL, 1501, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469886405', 'lois', '2016-07-30 14:33:11', 'lois-1469859643-14698603913978499', 1, 0, '', NULL, NULL, NULL),
(4209, '2016-07-30 14:33:11', NULL, NULL, 1501, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1469886405', 'lois', '2016-07-30 14:33:11', 'lois-1469859643-14698603913978499', 1, 1, 'SR', NULL, NULL, NULL),
(4210, '2016-07-30 14:33:28', NULL, NULL, 1501, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'lois', '2016-07-30 14:33:28', 'lois-1469859643-14698604082337477', 1, 1, 'SR', NULL, NULL, NULL),
(4211, '2016-07-30 14:34:58', NULL, NULL, 1502, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469886405', 'lois', '2016-07-30 14:34:58', 'lois-1469859643-1469860498672389', 1, 0, '', NULL, NULL, NULL),
(4212, '2016-07-30 14:36:11', NULL, NULL, 1502, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469886405', 'lois', '2016-07-30 14:36:11', 'lois-1469859643-14698605709213645', 1, 0, '', NULL, NULL, NULL),
(4213, '2016-07-30 14:41:54', NULL, NULL, 1503, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469886405', 'lois', '2016-07-30 14:41:54', 'lois-1469859643-14698609142786111', 1, 1, 'SR', NULL, NULL, NULL),
(4214, '2016-07-30 14:41:54', NULL, NULL, 1503, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469886405', 'lois', '2016-07-30 14:41:54', 'lois-1469859643-14698609142786111', 1, 1, 'SR', NULL, NULL, NULL),
(4215, '2016-07-30 14:54:41', NULL, NULL, 1504, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469886405', 'lois', '2016-07-30 14:54:41', 'lois-1469859643-14698616814511777', 1, 1, 'SR', NULL, NULL, NULL),
(4216, '2016-07-30 14:54:41', NULL, NULL, 1504, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469886405', 'lois', '2016-07-30 14:54:41', 'lois-1469859643-14698616814511777', 1, 1, 'SR', NULL, NULL, NULL),
(4217, '2016-07-30 14:54:41', NULL, NULL, 1504, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469886405', 'lois', '2016-07-30 14:54:41', 'lois-1469859643-14698616814511777', 1, 1, 'SR', NULL, NULL, NULL),
(4218, '2016-07-30 14:54:41', NULL, NULL, 1504, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'lois', '2016-07-30 14:54:41', 'lois-1469859643-14698616814511777', 1, 1, 'SR', NULL, NULL, NULL),
(4219, '2016-07-30 14:54:41', NULL, NULL, 1504, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469886405', 'lois', '2016-07-30 14:54:41', 'lois-1469859643-14698616814511777', 1, 1, 'SR', NULL, NULL, NULL),
(4220, '2016-07-30 14:54:41', NULL, NULL, 1504, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1469886405', 'lois', '2016-07-30 14:54:41', 'lois-1469859643-14698616814511777', 1, 1, 'SR', NULL, NULL, NULL),
(4221, '2016-07-30 14:54:41', NULL, NULL, 1504, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1469886405', 'lois', '2016-07-30 14:54:41', 'lois-1469859643-14698616814511777', 1, 1, 'SR', NULL, NULL, NULL),
(4222, '2016-07-30 14:54:41', NULL, NULL, 1504, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'lois', '2016-07-30 14:54:41', 'lois-1469859643-14698616814511777', 1, 0, '', NULL, NULL, NULL),
(4223, '2016-07-30 14:54:41', NULL, NULL, 1504, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'lois', '2016-07-30 14:54:41', 'lois-1469859643-14698616814511777', 1, 0, '', NULL, NULL, NULL),
(4224, '2016-07-30 14:57:34', NULL, NULL, 1505, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1469886405', 'lois', '2016-07-30 14:57:34', 'lois-1469859643-14698618538245155', 1, 1, 'SR', NULL, NULL, NULL),
(4225, '2016-07-30 15:17:37', NULL, NULL, 1508, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 15:17:37', 'admin-1469862445-14698630575758140', 1, 1, 'SR', NULL, NULL, NULL),
(4226, '2016-07-30 13:45:46', NULL, NULL, 1490, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 13:45:46', 'admin-1469850386-14698575461219096', 1, 1, 'SR', NULL, NULL, NULL),
(4227, '2016-07-30 12:38:22', NULL, NULL, 1486, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 12:38:22', 'admin-1469850386-14698535020958294', 1, 0, '', NULL, NULL, NULL),
(4228, '2016-07-30 12:38:22', NULL, NULL, 1486, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 12:38:22', 'admin-1469850386-14698535020958294', 1, 1, 'SR', NULL, NULL, NULL),
(4229, '2016-07-30 12:38:22', NULL, NULL, 1486, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 12:38:22', 'admin-1469850386-14698535020958294', 1, 1, 'SR', NULL, NULL, NULL),
(4230, '2016-07-30 12:38:22', NULL, NULL, 1486, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 12:38:22', 'admin-1469850386-14698535020958294', 1, 1, 'SR', NULL, NULL, NULL),
(4231, '2016-07-30 13:29:50', NULL, NULL, 1489, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 13:29:50', 'admin-1469850386-14698565903884967', 1, 0, '', NULL, NULL, NULL),
(4232, '2016-07-30 12:41:55', NULL, NULL, 1487, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 12:41:55', 'admin-1469850386-1469853715048398', 1, 0, '', NULL, NULL, NULL),
(4233, '2016-07-30 12:41:55', NULL, NULL, 1487, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 12:41:55', 'admin-1469850386-1469853715048398', 1, 0, '', NULL, NULL, NULL),
(4234, '2016-07-30 12:50:17', NULL, NULL, 1488, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 12:50:17', 'admin-1469850386-14698542175323632', 1, 0, '', NULL, NULL, NULL),
(4235, '2016-07-30 14:18:00', NULL, NULL, 1494, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469886405', 'Staff', '2016-07-30 14:18:00', 'Staff-1469857554-146985948067571', 1, 0, '', NULL, NULL, NULL),
(4236, '2016-07-30 14:18:00', NULL, NULL, 1494, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'Staff', '2016-07-30 14:18:00', 'Staff-1469857554-146985948067571', 1, 1, 'SR', NULL, NULL, NULL),
(4237, '2016-07-30 18:38:15', NULL, NULL, 1518, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 18:38:15', 'admin-1469869414-14698750953049098', 1, 1, 'SR', NULL, NULL, NULL),
(4238, '2016-07-30 14:13:18', NULL, NULL, 1492, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469886405', 'Staff', '2016-07-30 14:13:18', 'Staff-1469857554-14698591984571286', 1, 1, 'SR', NULL, NULL, NULL),
(4239, '2016-07-30 14:13:18', NULL, NULL, 1492, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469886405', 'Staff', '2016-07-30 14:13:18', 'Staff-1469857554-14698591984571286', 1, 1, 'SR', NULL, NULL, NULL),
(4240, '2016-07-30 14:03:17', NULL, NULL, 1491, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469886405', 'Staff', '2016-07-30 14:03:17', 'Staff-1469857554-14698585969957616', 1, 1, 'SR', NULL, NULL, NULL),
(4241, '2016-07-30 14:03:17', NULL, NULL, 1491, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'Staff', '2016-07-30 14:03:17', 'Staff-1469857554-14698585969957616', 1, 1, 'SR', NULL, NULL, NULL),
(4242, '2016-07-30 14:02:39', NULL, NULL, 1491, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'Staff', '2016-07-30 14:02:39', 'Staff-1469857554-1469858559444811', 1, 0, '', NULL, NULL, NULL),
(4243, '2016-07-30 14:02:39', NULL, NULL, 1491, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'Staff', '2016-07-30 14:02:39', 'Staff-1469857554-1469858559444811', 1, 1, 'SR', NULL, NULL, NULL),
(4244, '2016-07-30 13:45:46', NULL, NULL, 1490, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 13:45:46', 'admin-1469850386-14698575461219096', 1, 1, 'SR', NULL, NULL, NULL),
(4245, '2016-07-30 13:45:46', NULL, NULL, 1490, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 13:45:46', 'admin-1469850386-14698575461219096', 1, 0, '', NULL, NULL, NULL),
(4246, '2016-07-30 13:30:01', NULL, NULL, 1489, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 13:30:01', 'admin-1469850386-146985660173918', 1, 1, 'SR', NULL, NULL, NULL),
(4247, '2016-07-30 13:30:01', NULL, NULL, 1489, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 13:30:01', 'admin-1469850386-146985660173918', 1, 1, 'SR', NULL, NULL, NULL),
(4248, '2016-07-30 13:29:50', NULL, NULL, 1489, 0, 70, '70', 'Pepper Pork', 'Pasta', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 13:29:50', 'admin-1469850386-14698565903884967', 1, 1, 'SR', NULL, NULL, NULL),
(4249, '2016-07-30 12:52:33', NULL, NULL, 1488, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 12:52:33', 'admin-1469850386-14698543533695719', 1, 1, 'SR', NULL, NULL, NULL),
(4250, '2016-07-30 12:52:33', NULL, NULL, 1488, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 12:52:33', 'admin-1469850386-14698543533695719', 1, 0, '', NULL, NULL, NULL),
(4251, '2016-07-30 12:27:09', NULL, NULL, 1485, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 12:27:09', 'admin-1469850386-14698528290051486', 1, 0, '', NULL, NULL, NULL),
(4252, '2016-07-30 12:18:26', NULL, NULL, 1485, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 12:18:26', 'admin-1469850386-1469852305817727', 1, 1, 'SR', NULL, NULL, NULL),
(4253, '2016-07-30 12:18:26', NULL, NULL, 1485, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 12:18:26', 'admin-1469850386-1469852305817727', 1, 0, '', NULL, NULL, NULL),
(4254, '2016-07-30 12:16:16', NULL, NULL, 1484, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 12:16:16', 'admin-1469850386-14698521766406917', 1, 1, 'SR', NULL, NULL, NULL),
(4255, '2016-07-30 11:46:16', NULL, NULL, 1481, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:46:16', 'admin-1469839132-14698503763702368', 1, 1, 'SR', NULL, NULL, NULL),
(4256, '2016-07-30 11:46:58', NULL, NULL, 1482, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:46:58', 'admin-1469850386-14698504183629991', 1, 1, 'SR', NULL, NULL, NULL),
(4257, '2016-07-30 11:47:03', NULL, NULL, 1482, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:47:03', 'admin-1469850386-14698504233541073', 1, 0, '', NULL, NULL, NULL),
(4258, '2016-07-30 12:10:24', NULL, NULL, 1483, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 12:10:24', 'admin-1469850386-14698518243083381', 1, 0, '', NULL, NULL, NULL),
(4259, '2016-07-30 12:16:16', NULL, NULL, 1484, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 12:16:16', 'admin-1469850386-14698521766406917', 1, 0, '', NULL, NULL, NULL),
(4260, '2016-07-30 11:38:30', NULL, NULL, 1479, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:38:30', 'admin-1469839132-14698499104758565', 1, 1, 'SR', NULL, NULL, NULL),
(4261, '2016-07-30 11:42:58', NULL, NULL, 1480, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 4, 8.00, 32.0000, 0.0000, 32.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:42:58', 'admin-1469839132-14698501780059194', 1, 0, '', NULL, NULL, NULL),
(4262, '2016-07-30 11:46:16', NULL, NULL, 1481, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:46:16', 'admin-1469839132-14698503763702368', 1, 0, '', NULL, NULL, NULL),
(4263, '2016-07-30 11:46:16', NULL, NULL, 1481, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:46:16', 'admin-1469839132-14698503763702368', 1, 0, '', NULL, NULL, NULL),
(4264, '2016-07-30 11:46:16', NULL, NULL, 1481, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:46:16', 'admin-1469839132-14698503763702368', 1, 1, 'SR', NULL, NULL, NULL),
(4265, '2016-07-30 10:05:44', NULL, NULL, 1471, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 10:05:44', 'admin-1469839132-14698443446349223', 1, 1, 'SR', 1, NULL, NULL),
(4266, '2016-07-30 10:51:55', NULL, NULL, 1472, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 10:51:55', 'admin-1469839132-14698471149939818', 1, 0, '', NULL, NULL, NULL),
(4267, '2016-07-30 10:51:55', NULL, NULL, 1472, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 10:51:55', 'admin-1469839132-14698471149939818', 1, 0, '', NULL, NULL, NULL),
(4268, '2016-07-30 11:23:23', NULL, NULL, 1473, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:23:23', 'admin-1469839132-1469849003408434', 1, 0, '', NULL, NULL, NULL),
(4269, '2016-07-30 11:23:23', NULL, NULL, 1473, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:23:23', 'admin-1469839132-1469849003408434', 1, 0, '', NULL, NULL, NULL),
(4270, '2016-07-30 11:24:38', NULL, NULL, 1473, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:24:38', 'admin-1469839132-14698490784409032', 1, 1, 'SR', NULL, NULL, NULL),
(4271, '2016-07-30 11:24:38', NULL, NULL, 1473, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:24:38', 'admin-1469839132-14698490784409032', 1, 1, 'SR', NULL, NULL, NULL),
(4272, '2016-07-30 11:28:29', NULL, NULL, 1474, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:28:29', 'admin-1469839132-146984930972793', 1, 0, '', NULL, NULL, NULL),
(4273, '2016-07-30 11:28:29', NULL, NULL, 1474, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:28:29', 'admin-1469839132-146984930972793', 1, 0, '', NULL, NULL, NULL),
(4274, '2016-07-30 11:28:29', NULL, NULL, 1474, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:28:29', 'admin-1469839132-146984930972793', 1, 1, 'SR', NULL, NULL, NULL),
(4275, '2016-07-30 11:29:01', NULL, NULL, 1474, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:29:01', 'admin-1469839132-1469849341329219', 1, 1, 'SR', NULL, NULL, NULL),
(4276, '2016-07-30 11:34:25', NULL, NULL, 1475, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:34:25', 'admin-1469839132-14698496648958547', 1, 0, '', NULL, NULL, NULL),
(4277, '2016-07-30 11:34:25', NULL, NULL, 1475, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:34:25', 'admin-1469839132-14698496648958547', 1, 1, 'SR', NULL, NULL, NULL),
(4278, '2016-07-30 11:35:50', NULL, NULL, 1476, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:35:50', 'admin-1469839132-14698497499958386', 1, 0, '', NULL, NULL, NULL),
(4279, '2016-07-30 11:35:50', NULL, NULL, 1476, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:35:50', 'admin-1469839132-14698497499958386', 1, 1, 'SR', NULL, NULL, NULL),
(4280, '2016-07-30 11:36:47', NULL, NULL, 1477, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:36:47', 'admin-1469839132-14698498071405167', 1, 1, 'SR', NULL, NULL, NULL),
(4281, '2016-07-30 11:36:47', NULL, NULL, 1477, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:36:47', 'admin-1469839132-14698498071405167', 1, 0, '', NULL, NULL, NULL),
(4282, '2016-07-30 11:37:55', NULL, NULL, 1478, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 11:37:55', 'admin-1469839132-14698498750701379', 1, 1, 'SR', NULL, NULL, NULL),
(4283, '2016-07-30 09:14:24', NULL, NULL, 1470, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 09:14:24', 'admin-1469839132-14698412642218480', 1, 1, 'SR', NULL, NULL, NULL),
(4284, '2016-07-30 09:14:24', NULL, NULL, 1470, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 09:14:24', 'admin-1469839132-14698412642218480', 1, 1, 'SR', NULL, NULL, NULL),
(4285, '2016-07-30 09:14:24', NULL, NULL, 1470, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 09:14:24', 'admin-1469839132-14698412642218480', 1, 1, 'SR', NULL, NULL, NULL),
(4286, '2016-07-30 09:14:24', NULL, NULL, 1470, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 09:14:24', 'admin-1469839132-14698412642218480', 1, 0, '', NULL, NULL, NULL),
(4287, '2016-07-30 09:14:24', NULL, NULL, 1470, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469886405', 'admin', '2016-07-30 09:14:24', 'admin-1469839132-14698412642218480', 1, 0, '', NULL, NULL, NULL),
(4288, '2016-07-31 20:46:42', NULL, NULL, 1566, 0, 197, '132', 'Dinner - Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'lois', '2016-07-31 20:46:42', 'lois-1469968701-14699692019636565', 1, 0, '', NULL, NULL, NULL),
(4289, '2016-07-31 20:46:42', NULL, NULL, 1566, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1469973773', 'lois', '2016-07-31 20:46:42', 'lois-1469968701-14699692019636565', 1, 0, '', NULL, NULL, NULL),
(4290, '2016-07-31 20:46:50', NULL, NULL, 1566, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469973773', 'lois', '2016-07-31 20:46:50', 'lois-1469968701-14699692103775815', 1, 1, 'SR', NULL, NULL, NULL),
(4291, '2016-07-31 20:49:02', NULL, NULL, 1567, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1469973773', 'lois', '2016-07-31 20:49:02', 'lois-1469968701-14699693426818926', 1, 0, '', NULL, NULL, NULL),
(4292, '2016-07-31 20:49:02', NULL, NULL, 1567, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469973773', 'lois', '2016-07-31 20:49:02', 'lois-1469968701-14699693426818926', 1, 1, 'SR', NULL, NULL, NULL),
(4293, '2016-07-31 20:49:02', NULL, NULL, 1567, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469973773', 'lois', '2016-07-31 20:49:02', 'lois-1469968701-14699693426818926', 1, 0, '', NULL, NULL, NULL),
(4294, '2016-07-31 20:49:03', NULL, NULL, 1567, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469973773', 'lois', '2016-07-31 20:49:03', 'lois-1469968701-14699693426818926', 1, 0, '', NULL, NULL, NULL),
(4295, '2016-07-31 21:37:58', NULL, NULL, 1566, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'lois', '2016-07-31 21:37:58', 'lois-1469968701-14699722778032987', 1, 0, '', NULL, NULL, NULL),
(4296, '2016-07-31 21:37:58', NULL, NULL, 1566, 0, 201, '136', 'Dinner -  Chili Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'lois', '2016-07-31 21:37:58', 'lois-1469968701-14699722778032987', 1, 0, '', NULL, NULL, NULL),
(4297, '2016-07-31 21:37:58', NULL, NULL, 1566, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1469973773', 'lois', '2016-07-31 21:37:58', 'lois-1469968701-14699722778032987', 1, 0, '', NULL, NULL, NULL),
(4298, '2016-07-31 21:37:58', NULL, NULL, 1566, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1469973773', 'lois', '2016-07-31 21:37:58', 'lois-1469968701-14699722778032987', 1, 0, '', NULL, NULL, NULL),
(4299, '2016-07-31 21:37:58', NULL, NULL, 1566, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469973773', 'lois', '2016-07-31 21:37:58', 'lois-1469968701-14699722778032987', 1, 1, 'SR', NULL, NULL, NULL),
(4300, '2016-07-31 15:12:55', NULL, NULL, 1562, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 15:12:55', 'admin-1469948456-14699491754384516', 1, 0, '', NULL, NULL, NULL),
(4301, '2016-07-31 15:12:55', NULL, NULL, 1562, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 15:12:55', 'admin-1469948456-14699491754384516', 1, 0, '', NULL, NULL, NULL),
(4302, '2016-07-31 15:19:08', NULL, NULL, 1563, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 15:19:08', 'admin-1469948456-14699495481268371', 1, 1, 'SR', NULL, NULL, NULL),
(4303, '2016-07-31 15:21:03', NULL, NULL, 1564, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 15:21:03', 'admin-1469948456-14699496630847746', 1, 1, 'SR', NULL, NULL, NULL),
(4304, '2016-07-31 15:21:03', NULL, NULL, 1564, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 15:21:03', 'admin-1469948456-14699496630847746', 1, 0, '', NULL, NULL, NULL),
(4305, '2016-07-31 15:21:03', NULL, NULL, 1564, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 15:21:03', 'admin-1469948456-14699496630847746', 1, 0, '', NULL, NULL, NULL),
(4306, '2016-07-31 15:21:03', NULL, NULL, 1564, 0, 76, '76', 'Pesto Pasta', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 15:21:03', 'admin-1469948456-14699496630847746', 1, 1, 'SR', NULL, NULL, NULL),
(4307, '2016-07-31 20:06:03', NULL, NULL, 1566, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 20:06:03', 'admin-1469948456-14699667628022494', 1, 1, 'SR', NULL, NULL, NULL),
(4308, '2016-07-31 20:06:03', NULL, NULL, 1566, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 20:06:03', 'admin-1469948456-14699667628022494', 1, 1, 'SR', NULL, NULL, NULL),
(4309, '2016-07-31 20:06:03', NULL, NULL, 1566, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 20:06:03', 'admin-1469948456-14699667628022494', 1, 1, 'SR', NULL, NULL, NULL),
(4310, '2016-07-31 20:06:03', NULL, NULL, 1566, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 20:06:03', 'admin-1469948456-14699667628022494', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(4311, '2016-07-31 20:06:03', NULL, NULL, 1566, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 20:06:03', 'admin-1469948456-14699667628022494', 1, 1, 'SR', NULL, NULL, NULL),
(4312, '2016-07-31 20:06:03', NULL, NULL, 1566, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 20:06:03', 'admin-1469948456-14699667628022494', 1, 1, 'SR', NULL, NULL, NULL),
(4313, '2016-07-31 20:06:03', NULL, NULL, 1566, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 20:06:03', 'admin-1469948456-14699667628022494', 1, 0, '', NULL, NULL, NULL),
(4314, '2016-07-31 20:06:03', NULL, NULL, 1566, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 20:06:03', 'admin-1469948456-14699667628022494', 1, 0, '', NULL, NULL, NULL),
(4315, '2016-07-31 20:30:59', NULL, NULL, 1566, 0, 198, '133', 'Dinner - Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 20:30:59', 'admin-1469948456-14699682590638351', 1, 0, '', NULL, NULL, NULL),
(4316, '2016-07-31 20:39:13', NULL, NULL, 1566, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1469973773', 'lois', '2016-07-31 20:39:13', 'lois-1469968701-14699687532172725', 1, 0, '', NULL, NULL, NULL),
(4317, '2016-07-31 11:51:22', NULL, NULL, 1549, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:51:22', 'admin-1469924943-14699370824003790', 1, 1, 'SR', NULL, NULL, NULL),
(4318, '2016-07-31 11:51:22', NULL, NULL, 1549, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:51:22', 'admin-1469924943-14699370824003790', 1, 1, 'SR', NULL, NULL, NULL),
(4319, '2016-07-31 19:02:19', NULL, NULL, 1565, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 19:02:19', 'admin-1469948456-14699629388268849', 1, 0, '', NULL, NULL, NULL),
(4320, '2016-07-31 19:58:42', NULL, NULL, 1566, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 19:58:42', 'admin-1469948456-14699663220267427', 1, 0, '', NULL, NULL, NULL),
(4321, '2016-07-31 19:58:42', NULL, NULL, 1566, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 19:58:42', 'admin-1469948456-14699663220267427', 1, 0, '', NULL, NULL, NULL),
(4322, '2016-07-31 19:59:00', NULL, NULL, 1566, 0, 192, '127', 'Stir Fried Chili Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 19:59:00', 'admin-1469948456-14699663404109210', 1, 0, '', NULL, NULL, NULL),
(4323, '2016-07-31 19:59:00', NULL, NULL, 1566, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 19:59:00', 'admin-1469948456-14699663404109210', 1, 0, '', NULL, NULL, NULL),
(4324, '2016-07-31 20:02:39', NULL, NULL, 1566, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 20:02:39', 'admin-1469948456-14699665590707038', 1, 0, '', NULL, NULL, NULL),
(4325, '2016-07-31 20:06:03', NULL, NULL, 1566, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 20:06:03', 'admin-1469948456-14699667628022494', 1, 1, 'SR', NULL, NULL, NULL),
(4326, '2016-07-31 20:02:39', NULL, NULL, 1566, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 20:02:39', 'admin-1469948456-14699665590707038', 1, 0, '', NULL, NULL, NULL),
(4327, '2016-07-31 20:02:39', NULL, NULL, 1566, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 20:02:39', 'admin-1469948456-14699665590707038', 1, 0, '', NULL, NULL, NULL),
(4328, '2016-07-31 20:02:39', NULL, NULL, 1566, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 20:02:39', 'admin-1469948456-14699665590707038', 1, 0, '', NULL, NULL, NULL),
(4329, '2016-07-31 20:02:39', NULL, NULL, 1566, 0, 181, '116', 'Open Food ', 'spicy chicken', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 20:02:39', 'admin-1469948456-14699665590707038', 1, 0, '', NULL, NULL, NULL),
(4330, '2016-07-31 20:02:39', NULL, NULL, 1566, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 20:02:39', 'admin-1469948456-14699665590707038', 1, 0, '', NULL, NULL, NULL),
(4331, '2016-07-31 20:02:39', NULL, NULL, 1566, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 20:02:39', 'admin-1469948456-14699665590707038', 1, 0, '', NULL, NULL, NULL),
(4332, '2016-07-31 20:02:39', NULL, NULL, 1566, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 20:02:39', 'admin-1469948456-14699665590707038', 1, 0, '', NULL, NULL, NULL),
(4333, '2016-07-31 19:02:18', NULL, NULL, 1565, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 19:02:19', 'admin-1469948456-14699629388268849', 1, 0, '', NULL, NULL, NULL),
(4334, '2016-07-31 19:02:19', NULL, NULL, 1565, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 19:02:19', 'admin-1469948456-14699629388268849', 1, 1, 'SR', NULL, NULL, NULL),
(4335, '2016-07-31 11:41:52', NULL, NULL, 1547, 0, 178, '113', 'Brownies ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:41:52', 'admin-1469924943-14699365127212665', 1, 0, '', NULL, NULL, NULL),
(4336, '2016-07-31 15:12:55', NULL, NULL, 1562, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 15:12:55', 'admin-1469948456-14699491754384516', 1, 1, 'SR', NULL, NULL, NULL),
(4337, '2016-07-31 15:12:55', NULL, NULL, 1562, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 15:12:55', 'admin-1469948456-14699491754384516', 1, 0, '', NULL, NULL, NULL),
(4338, '2016-07-31 15:12:55', NULL, NULL, 1562, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 15:12:55', 'admin-1469948456-14699491754384516', 1, 1, 'SR', NULL, NULL, NULL),
(4339, '2016-07-31 11:51:22', NULL, NULL, 1549, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:51:22', 'admin-1469924943-14699370824003790', 1, 1, 'SR', NULL, NULL, NULL),
(4340, '2016-07-31 11:51:22', NULL, NULL, 1549, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:51:22', 'admin-1469924943-14699370824003790', 1, 1, 'SR', NULL, NULL, NULL),
(4341, '2016-07-31 11:51:22', NULL, NULL, 1549, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:51:22', 'admin-1469924943-14699370824003790', 1, 1, 'SR', NULL, NULL, NULL),
(4342, '2016-07-31 11:51:22', NULL, NULL, 1549, 0, 178, '113', 'Brownies ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:51:22', 'admin-1469924943-14699370824003790', 1, 0, '', NULL, NULL, NULL),
(4343, '2016-07-31 11:52:26', NULL, NULL, 1550, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:52:26', 'admin-1469924943-14699371461078418', 1, 1, 'SR', NULL, NULL, NULL),
(4344, '2016-07-31 12:10:22', NULL, NULL, 1548, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 12:10:22', 'admin-1469924943-14699382226153737', 1, 1, 'SR', NULL, NULL, NULL),
(4345, '2016-07-31 12:22:22', NULL, NULL, 1548, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 12:22:22', 'admin-1469924943-14699389422306054', 1, 1, 'SR', NULL, NULL, NULL),
(4346, '2016-07-31 12:30:00', NULL, NULL, 1551, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 12:30:00', 'admin-1469924943-1469939400331450', 1, 1, 'SR', NULL, NULL, NULL),
(4347, '2016-07-31 12:30:00', NULL, NULL, 1551, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 12:30:00', 'admin-1469924943-1469939400331450', 1, 1, 'SR', NULL, NULL, NULL),
(4348, '2016-07-31 12:31:33', NULL, NULL, 1552, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 12:31:33', 'admin-1469924943-14699394937515316', 1, 1, 'SR', NULL, NULL, NULL),
(4349, '2016-07-31 12:31:33', NULL, NULL, 1552, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 12:31:33', 'admin-1469924943-14699394937515316', 1, 0, '', NULL, NULL, NULL),
(4350, '2016-07-31 12:31:33', NULL, NULL, 1552, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 12:31:33', 'admin-1469924943-14699394937515316', 1, 0, '', NULL, NULL, NULL),
(4351, '2016-07-31 12:31:33', NULL, NULL, 1552, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 12:31:33', 'admin-1469924943-14699394937515316', 1, 0, '', NULL, NULL, NULL),
(4352, '2016-07-31 12:46:24', NULL, NULL, 1553, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 12:46:24', 'admin-1469924943-14699403839042260', 1, 1, 'SR', NULL, NULL, NULL),
(4353, '2016-07-31 12:46:24', NULL, NULL, 1553, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 12:46:24', 'admin-1469924943-14699403839042260', 1, 1, 'SR', NULL, NULL, NULL),
(4354, '2016-07-31 12:46:24', NULL, NULL, 1553, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 12:46:24', 'admin-1469924943-14699403839042260', 1, 1, 'SR', NULL, NULL, NULL),
(4355, '2016-07-31 12:46:24', NULL, NULL, 1553, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 12:46:24', 'admin-1469924943-14699403839042260', 1, 1, 'SR', NULL, NULL, NULL),
(4356, '2016-07-31 12:46:24', NULL, NULL, 1553, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 12:46:24', 'admin-1469924943-14699403839042260', 1, 0, '', NULL, NULL, NULL),
(4357, '2016-07-31 14:01:42', NULL, NULL, 1554, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 14:01:42', 'admin-1469924943-14699449026527071', 1, 1, 'SR', NULL, NULL, NULL),
(4358, '2016-07-31 14:01:42', NULL, NULL, 1554, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 14:01:42', 'admin-1469924943-14699449026527071', 1, 1, 'SR', NULL, NULL, NULL),
(4359, '2016-07-31 14:01:42', NULL, NULL, 1554, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 14:01:42', 'admin-1469924943-14699449026527071', 1, 1, 'SR', NULL, NULL, NULL),
(4360, '2016-07-31 14:01:42', NULL, NULL, 1554, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 14:01:42', 'admin-1469924943-14699449026527071', 1, 1, 'SR', NULL, NULL, NULL),
(4361, '2016-07-31 14:21:56', NULL, NULL, 1553, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 14:21:56', 'admin-1469924943-14699461160644648', 1, 1, 'SR', NULL, NULL, NULL),
(4362, '2016-07-31 14:38:36', NULL, NULL, 1554, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 14:38:36', 'admin-1469924943-14699471164432244', 1, 0, '', NULL, NULL, NULL),
(4363, '2016-07-31 14:38:36', NULL, NULL, 1554, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 14:38:36', 'admin-1469924943-14699471164432244', 1, 0, '', NULL, NULL, NULL),
(4364, '2016-07-31 19:00:26', NULL, NULL, 1565, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 19:00:26', 'admin-1469948456-14699628259613830', 1, 1, 'SR', NULL, NULL, NULL),
(4365, '2016-07-31 15:12:55', NULL, NULL, 1562, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 15:12:55', 'admin-1469948456-14699491754384516', 1, 0, '', NULL, NULL, NULL),
(4366, '2016-07-31 15:07:04', NULL, NULL, 1561, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 15:07:04', 'admin-1469948456-14699488240396814', 1, 1, 'SR', NULL, NULL, NULL),
(4367, '2016-07-31 11:41:52', NULL, NULL, 1547, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:41:52', 'admin-1469924943-14699365127212665', 1, 1, 'SR', NULL, NULL, NULL),
(4368, '2016-07-31 15:06:24', NULL, NULL, 1560, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 15:06:24', 'admin-1469948456-14699487841057653', 1, 0, '', NULL, NULL, NULL),
(4369, '2016-07-31 15:06:24', NULL, NULL, 1560, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 15:06:24', 'admin-1469948456-14699487841057653', 1, 1, 'SR', NULL, NULL, NULL),
(4370, '2016-07-31 15:03:47', NULL, NULL, 1559, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 15:03:47', 'admin-1469948456-1469948627665642', 1, 1, 'SR', 1, NULL, NULL),
(4371, '2016-07-31 15:03:35', NULL, NULL, 1558, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 15:03:35', 'admin-1469948456-14699486151924311', 1, 1, 'SR', 1, NULL, NULL),
(4372, '2016-07-31 15:03:15', NULL, NULL, 1557, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 15:03:15', 'admin-1469948456-14699485954955079', 1, 1, 'SR', 1, NULL, NULL),
(4373, '2016-07-31 15:02:52', NULL, NULL, 1556, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 15:02:52', 'admin-1469948456-14699485724458414', 1, 1, 'SR', NULL, NULL, NULL),
(4374, '2016-07-31 15:02:19', NULL, NULL, 1555, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 15:02:19', 'admin-1469948456-14699485389314412', 1, 0, '', NULL, NULL, NULL),
(4375, '2016-07-31 14:51:04', NULL, NULL, 1541, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 14:51:04', 'admin-1469924943-1469947864773269', 1, 0, '', NULL, NULL, NULL),
(4376, '2016-07-31 11:52:26', NULL, NULL, 1550, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:52:26', 'admin-1469924943-14699371461078418', 1, 0, '', NULL, NULL, NULL),
(4377, '2016-07-31 11:49:27', NULL, NULL, 1548, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:49:27', 'admin-1469924943-14699369677542951', 1, 0, '', NULL, NULL, NULL),
(4378, '2016-07-31 11:41:52', NULL, NULL, 1547, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:41:52', 'admin-1469924943-14699365127212665', 1, 1, 'SR', NULL, NULL, NULL),
(4379, '2016-07-31 11:31:07', NULL, NULL, 1546, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:31:07', 'admin-1469924943-14699358674169075', 1, 0, '', NULL, NULL, NULL),
(4380, '2016-07-31 11:31:07', NULL, NULL, 1546, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:31:07', 'admin-1469924943-14699358674169075', 1, 0, '', NULL, NULL, NULL),
(4381, '2016-07-31 11:31:07', NULL, NULL, 1546, 0, 204, '139', 'BLT & Latte Promo', '', 'Meals', 'Morning Bites ', 1, 26.00, 26.0000, 0.0000, 26.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:31:07', 'admin-1469924943-14699358674169075', 1, 0, '', NULL, NULL, NULL),
(4382, '2016-07-31 11:31:07', NULL, NULL, 1546, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:31:07', 'admin-1469924943-14699358674169075', 1, 0, '', NULL, NULL, NULL),
(4383, '2016-07-31 11:29:01', NULL, NULL, 1545, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:29:01', 'admin-1469924943-14699357414464164', 1, 1, 'SR', NULL, NULL, NULL),
(4384, '2016-07-31 11:27:30', NULL, NULL, 1543, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:27:30', 'admin-1469924943-14699356498162372', 1, 1, 'SR', NULL, NULL, NULL),
(4385, '2016-07-31 11:28:44', NULL, NULL, 1544, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:28:44', 'admin-1469924943-14699357243136076', 1, 1, 'SR', NULL, NULL, NULL),
(4386, '2016-07-31 11:27:30', NULL, NULL, 1543, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:27:30', 'admin-1469924943-14699356498162372', 1, 1, 'SR', NULL, NULL, NULL),
(4387, '2016-07-31 11:27:30', NULL, NULL, 1543, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:27:30', 'admin-1469924943-14699356498162372', 1, 0, '', NULL, NULL, NULL),
(4388, '2016-07-31 11:27:30', NULL, NULL, 1543, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:27:30', 'admin-1469924943-14699356498162372', 1, 0, '', NULL, NULL, NULL),
(4389, '2016-07-31 11:27:30', NULL, NULL, 1543, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:27:30', 'admin-1469924943-14699356498162372', 1, 0, '', NULL, NULL, NULL),
(4390, '2016-07-31 11:27:30', NULL, NULL, 1543, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:27:30', 'admin-1469924943-14699356498162372', 1, 1, 'SR', NULL, NULL, NULL),
(4391, '2016-07-31 11:25:35', NULL, NULL, 1542, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:25:35', 'admin-1469924943-1469935535071372', 1, 1, 'SR', NULL, NULL, NULL),
(4392, '2016-07-31 11:25:35', NULL, NULL, 1542, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:25:35', 'admin-1469924943-1469935535071372', 1, 1, 'SR', NULL, NULL, NULL),
(4393, '2016-07-31 11:25:35', NULL, NULL, 1542, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:25:35', 'admin-1469924943-1469935535071372', 1, 1, 'SR', NULL, NULL, NULL),
(4394, '2016-07-31 11:13:35', NULL, NULL, 1539, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:13:35', 'admin-1469924943-14699348148688223', 1, 1, 'SR', NULL, NULL, NULL),
(4395, '2016-07-31 11:14:49', NULL, NULL, 1540, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:14:49', 'admin-1469924943-14699348887798229', 1, 1, 'SR', NULL, NULL, NULL),
(4396, '2016-07-31 11:19:54', NULL, NULL, 1541, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:19:54', 'admin-1469924943-14699351947871824', 1, 1, 'SR', NULL, NULL, NULL),
(4397, '2016-07-31 11:25:35', NULL, NULL, 1542, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:25:35', 'admin-1469924943-1469935535071372', 1, 0, '', NULL, NULL, NULL),
(4398, '2016-07-31 11:25:35', NULL, NULL, 1542, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:25:35', 'admin-1469924943-1469935535071372', 1, 0, '', NULL, NULL, NULL),
(4399, '2016-07-31 11:25:35', NULL, NULL, 1542, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:25:35', 'admin-1469924943-1469935535071372', 1, 0, '', NULL, NULL, NULL),
(4400, '2016-07-31 11:10:23', NULL, NULL, 1538, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:10:23', 'admin-1469924943-14699346236512845', 1, 1, 'SR', NULL, NULL, NULL),
(4401, '2016-07-31 11:10:23', NULL, NULL, 1538, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:10:23', 'admin-1469924943-14699346236512845', 1, 1, 'SR', NULL, NULL, NULL),
(4402, '2016-07-31 11:10:23', NULL, NULL, 1538, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:10:23', 'admin-1469924943-14699346236512845', 1, 0, '', NULL, NULL, NULL),
(4403, '2016-07-31 11:10:23', NULL, NULL, 1538, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:10:23', 'admin-1469924943-14699346236512845', 1, 0, '', NULL, NULL, NULL),
(4404, '2016-07-31 11:07:19', NULL, NULL, 1537, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:07:19', 'admin-1469924943-14699344389977116', 1, 1, 'SR', NULL, NULL, NULL),
(4405, '2016-07-31 09:27:27', NULL, NULL, 1529, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 09:27:27', 'admin-1469924943-14699284477542289', 1, 1, 'SR', NULL, NULL, NULL),
(4406, '2016-07-31 09:27:27', NULL, NULL, 1529, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 09:27:27', 'admin-1469924943-14699284477542289', 1, 1, 'SR', NULL, NULL, NULL),
(4407, '2016-07-31 09:39:39', NULL, NULL, 1530, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 09:39:39', 'admin-1469924943-14699291795369664', 1, 0, '', NULL, NULL, NULL),
(4408, '2016-07-31 09:39:39', NULL, NULL, 1530, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 09:39:39', 'admin-1469924943-14699291795369664', 1, 1, 'SR', NULL, NULL, NULL),
(4409, '2016-07-31 09:44:13', NULL, NULL, 1531, 0, 204, '139', 'BLT & Latte Promo', '', 'Meals', 'Morning Bites ', 1, 26.00, 26.0000, 0.0000, 26.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 09:44:13', 'admin-1469924943-14699294534947867', 1, 0, '', NULL, NULL, NULL),
(4410, '2016-07-31 10:04:51', NULL, NULL, 1532, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 10:04:51', 'admin-1469924943-14699306914973862', 1, 0, '', NULL, NULL, NULL),
(4411, '2016-07-31 10:04:51', NULL, NULL, 1532, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 10:04:51', 'admin-1469924943-14699306914973862', 1, 1, 'SR', NULL, NULL, NULL),
(4412, '2016-07-31 10:05:53', NULL, NULL, 1533, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 10:05:53', 'admin-1469924943-14699307531286791', 1, 0, '', NULL, NULL, NULL),
(4413, '2016-07-31 10:05:53', NULL, NULL, 1533, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 10:05:53', 'admin-1469924943-14699307531286791', 1, 1, 'SR', NULL, NULL, NULL),
(4414, '2016-07-31 10:06:48', NULL, NULL, 1534, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 10:06:48', 'admin-1469924943-14699308079414847', 1, 0, '', NULL, NULL, NULL),
(4415, '2016-07-31 10:06:48', NULL, NULL, 1534, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 10:06:48', 'admin-1469924943-14699308079414847', 1, 1, 'SR', NULL, NULL, NULL),
(4416, '2016-07-31 10:32:25', NULL, NULL, 1535, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 10:32:25', 'admin-1469924943-14699323449582345', 1, 1, 'SR', NULL, NULL, NULL),
(4417, '2016-07-31 10:32:25', NULL, NULL, 1535, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 10:32:25', 'admin-1469924943-14699323449582345', 1, 1, 'SR', NULL, NULL, NULL),
(4418, '2016-07-31 10:51:50', NULL, NULL, 1536, 0, 204, '139', 'BLT & Latte Promo', '', 'Meals', 'Morning Bites ', 1, 26.00, 26.0000, 0.0000, 26.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 10:51:50', 'admin-1469924943-14699335098639347', 1, 0, '', NULL, NULL, NULL),
(4419, '2016-07-31 10:51:50', NULL, NULL, 1536, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 10:51:50', 'admin-1469924943-14699335098639347', 1, 0, '', NULL, NULL, NULL),
(4420, '2016-07-31 10:52:04', NULL, NULL, 1536, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 10:52:04', 'admin-1469924943-14699335248009131', 1, 1, 'SR', NULL, NULL, NULL),
(4421, '2016-07-31 11:07:06', NULL, NULL, 1537, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:07:06', 'admin-1469924943-14699344261666786', 1, 0, '', NULL, NULL, NULL),
(4422, '2016-07-31 11:07:06', NULL, NULL, 1537, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:07:06', 'admin-1469924943-14699344261666786', 1, 0, '', NULL, NULL, NULL),
(4423, '2016-07-31 11:07:19', NULL, NULL, 1537, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 11:07:19', 'admin-1469924943-14699344389977116', 1, 1, 'SR', NULL, NULL, NULL),
(4424, '2016-07-31 09:12:45', NULL, NULL, 1528, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 09:12:45', 'admin-1469924943-14699275649943195', 1, 0, '', NULL, NULL, NULL),
(4425, '2016-07-31 09:10:19', NULL, NULL, 1527, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 09:10:19', 'admin-1469924943-14699274197128261', 1, 1, 'SR', NULL, NULL, NULL),
(4426, '2016-07-31 09:12:45', NULL, NULL, 1528, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 09:12:45', 'admin-1469924943-14699275649943195', 1, 0, '', NULL, NULL, NULL),
(4427, '2016-07-31 09:10:19', NULL, NULL, 1527, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1469973773', 'admin', '2016-07-31 09:10:19', 'admin-1469924943-14699274197128261', 1, 1, 'SR', NULL, NULL, NULL),
(4428, '2016-08-01 16:02:35', NULL, NULL, 1593, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 16:02:35', 'Staff-1470021703-14700385549646119', 1, 1, 'SR', NULL, NULL, NULL),
(4429, '2016-08-01 16:25:46', NULL, NULL, 1594, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 16:25:46', 'Staff-1470021703-14700399463799332', 1, 1, 'SR', NULL, NULL, NULL),
(4430, '2016-08-01 17:23:49', NULL, NULL, 1595, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 17:23:49', 'Staff-1470021703-1470043429783764', 1, 0, '', NULL, NULL, NULL),
(4431, '2016-08-01 17:23:49', NULL, NULL, 1595, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 17:23:49', 'Staff-1470021703-1470043429783764', 1, 0, '', NULL, NULL, NULL),
(4432, '2016-08-01 17:23:49', NULL, NULL, 1595, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 17:23:49', 'Staff-1470021703-1470043429783764', 1, 1, 'SR', NULL, NULL, NULL),
(4433, '2016-08-01 17:23:49', NULL, NULL, 1595, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 17:23:49', 'Staff-1470021703-1470043429783764', 1, 1, 'SR', NULL, NULL, NULL),
(4434, '2016-08-01 18:15:12', NULL, NULL, 1596, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 18:15:12', 'Staff-1470021703-14700465119845386', 1, 1, 'SR', NULL, NULL, NULL),
(4435, '2016-08-01 18:15:12', NULL, NULL, 1596, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 18:15:12', 'Staff-1470021703-14700465119845386', 1, 0, '', NULL, NULL, NULL),
(4436, '2016-08-01 18:15:12', NULL, NULL, 1596, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 18:15:12', 'Staff-1470021703-14700465119845386', 1, 1, 'SR', NULL, NULL, NULL),
(4437, '2016-08-01 18:28:20', NULL, NULL, 1596, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 18:28:20', 'Staff-1470021703-1470047300079379', 1, 1, 'SR', NULL, NULL, NULL),
(4438, '2016-08-01 18:28:20', NULL, NULL, 1596, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 18:28:20', 'Staff-1470021703-1470047300079379', 1, 1, 'SR', NULL, NULL, NULL),
(4439, '2016-08-01 18:28:20', NULL, NULL, 1596, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 18:28:20', 'Staff-1470021703-1470047300079379', 1, 0, '', NULL, NULL, NULL),
(4440, '2016-08-01 19:05:49', NULL, NULL, 1596, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 19:05:49', 'Staff-1470021703-14700495494851721', 1, 1, 'SR', NULL, NULL, NULL),
(4441, '2016-08-01 00:00:00', NULL, NULL, 1597, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 15:43:53', 'Staff-1470021703-14700374332901460', 1, 1, 'SR', NULL, NULL, NULL),
(4442, '2016-08-01 19:50:32', NULL, NULL, 1599, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 19:50:32', 'Staff-1470021703-14700522318374666', 1, 0, '', NULL, NULL, NULL),
(4443, '2016-08-01 20:33:28', NULL, NULL, 1600, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 20:33:28', 'Staff-1470021703-14700548078389024', 1, 1, 'SR', NULL, NULL, NULL),
(4444, '2016-08-01 21:25:21', NULL, NULL, 1600, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 21:25:21', 'Staff-1470021703-14700579211075495', 1, 0, '', NULL, NULL, NULL),
(4445, '2016-08-01 16:25:46', NULL, NULL, 1594, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 16:25:46', 'Staff-1470021703-14700399463799332', 1, 1, 'SR', NULL, NULL, NULL),
(4446, '2016-08-01 16:25:46', NULL, NULL, 1594, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 16:25:46', 'Staff-1470021703-14700399463799332', 1, 1, 'SR', NULL, NULL, NULL),
(4447, '2016-08-01 16:02:35', NULL, NULL, 1593, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 16:02:35', 'Staff-1470021703-14700385549646119', 1, 0, '', NULL, NULL, NULL),
(4448, '2016-08-01 16:02:35', NULL, NULL, 1593, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 16:02:35', 'Staff-1470021703-14700385549646119', 1, 0, '', NULL, NULL, NULL),
(4449, '2016-08-01 00:00:00', NULL, NULL, 1598, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 14:02:20', 'Staff-1470021703-14700313399109690', 1, 1, 'SR', NULL, NULL, NULL),
(4450, '2016-08-01 16:02:35', NULL, NULL, 1593, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 16:02:35', 'Staff-1470021703-14700385549646119', 1, 1, 'SR', NULL, NULL, NULL),
(4451, '2016-08-01 15:27:08', NULL, NULL, 1591, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 15:27:08', 'Staff-1470021703-14700364285219220', 1, 0, '', NULL, NULL, NULL),
(4452, '2016-08-01 15:34:57', NULL, NULL, 1592, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 15:34:57', 'Staff-1470021703-14700368976176047', 1, 0, '', NULL, NULL, NULL),
(4453, '2016-08-01 15:34:57', NULL, NULL, 1592, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 15:34:57', 'Staff-1470021703-14700368976176047', 1, 0, '', NULL, NULL, NULL),
(4454, '2016-08-01 15:27:08', NULL, NULL, 1591, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 15:27:08', 'Staff-1470021703-14700364285219220', 1, 1, 'SR', NULL, NULL, NULL),
(4455, '2016-08-01 15:27:08', NULL, NULL, 1591, 0, 178, '113', 'Brownies ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 15:27:08', 'Staff-1470021703-14700364285219220', 1, 0, '', NULL, NULL, NULL),
(4456, '2016-08-01 15:03:04', NULL, NULL, 1590, 0, 54, '54', 'Chai Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 15:03:04', 'Staff-1470021703-14700349843486820', 1, 1, 'SR', 1, NULL, NULL),
(4457, '2016-08-01 15:02:08', NULL, NULL, 1589, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 15:02:08', 'Staff-1470021703-147003492868399', 1, 1, 'SR', NULL, NULL, NULL),
(4458, '2016-08-01 14:25:17', NULL, NULL, 1587, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 14:25:17', 'Staff-1470021703-14700327170218560', 1, 1, 'SR', NULL, NULL, NULL),
(4459, '2016-08-01 15:02:08', NULL, NULL, 1589, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 15:02:08', 'Staff-1470021703-147003492868399', 1, 0, '', NULL, NULL, NULL),
(4460, '2016-08-01 14:26:22', NULL, NULL, 1588, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 14:26:22', 'Staff-1470021703-14700327821099336', 1, 1, 'SR', 1, NULL, NULL),
(4461, '2016-08-01 14:25:17', NULL, NULL, 1587, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 14:25:17', 'Staff-1470021703-14700327170218560', 1, 1, 'SR', NULL, NULL, NULL),
(4462, '2016-08-01 14:16:15', NULL, NULL, 1586, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 14:16:15', 'Staff-1470021703-14700321757489622', 1, 0, '', NULL, NULL, NULL),
(4463, '2016-08-01 00:00:00', NULL, NULL, 1585, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 14:13:57', 'Staff-1470021703-1470032037526572', 1, 1, 'SR', NULL, NULL, NULL),
(4464, '2016-08-01 14:16:15', NULL, NULL, 1586, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 14:16:15', 'Staff-1470021703-14700321757489622', 1, 1, 'SR', NULL, NULL, NULL),
(4465, '2016-08-01 14:16:15', NULL, NULL, 1586, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 14:16:15', 'Staff-1470021703-14700321757489622', 1, 1, 'SR', NULL, NULL, NULL),
(4466, '2016-08-01 14:16:15', NULL, NULL, 1586, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 14:16:15', 'Staff-1470021703-14700321757489622', 1, 1, 'SR', NULL, NULL, NULL),
(4467, '2016-08-01 14:16:15', NULL, NULL, 1586, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 14:16:15', 'Staff-1470021703-14700321757489622', 1, 1, 'SR', NULL, NULL, NULL),
(4468, '2016-08-01 19:50:32', NULL, NULL, 1599, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 19:50:32', 'Staff-1470021703-14700522318374666', 1, 0, '', NULL, NULL, NULL),
(4469, '2016-08-01 13:37:15', NULL, NULL, 1583, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 13:37:15', 'Staff-1470021703-14700298354084785', 1, 0, '', NULL, NULL, NULL),
(4470, '2016-08-01 13:12:27', NULL, NULL, 1582, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 13:12:27', 'Staff-1470021703-14700283475307879', 1, 0, '', NULL, NULL, NULL),
(4471, '2016-08-01 10:00:50', NULL, NULL, 1570, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470021703', 'lois', '2016-08-01 10:00:50', 'lois-1470011762-14700168504134810', 1, 0, '', NULL, NULL, NULL),
(4472, '2016-08-01 10:10:16', NULL, NULL, 1571, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470021703', 'lois', '2016-08-01 10:10:16', 'lois-1470011762-1470017416795498', 1, 1, 'SR', NULL, NULL, NULL),
(4473, '2016-08-01 10:10:21', NULL, NULL, 1570, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470021703', 'lois', '2016-08-01 10:10:21', 'lois-1470011762-14700174213927747', 1, 1, 'SR', NULL, NULL, NULL),
(4474, '2016-08-01 10:18:36', NULL, NULL, 1568, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470021703', 'lois', '2016-08-01 10:18:36', 'lois-1470011762-1470017916476329', 1, 1, 'SR', NULL, NULL, NULL),
(4475, '2016-08-01 12:06:16', NULL, NULL, 1575, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 12:06:16', 'Staff-1470021703-14700243762419455', 1, 1, 'SR', NULL, NULL, NULL),
(4476, '2016-08-01 10:25:30', NULL, NULL, 1572, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470021703', 'lois', '2016-08-01 10:25:30', 'lois-1470011762-14700183307367251', 1, 0, '', NULL, NULL, NULL),
(4477, '2016-08-01 11:26:13', NULL, NULL, 1573, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 11:26:13', 'Staff-1470021703-14700219735482790', 1, 1, 'SR', NULL, NULL, NULL),
(4478, '2016-08-01 11:38:31', NULL, NULL, 1570, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 11:38:31', 'Staff-1470021703-14700227112655460', 1, 0, '', NULL, NULL, NULL),
(4479, '2016-08-01 00:00:00', NULL, NULL, 1574, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1470021703', 'lois', '2016-08-01 10:18:56', 'lois-1470011762-1470017936736311', 1, 1, 'SR', NULL, NULL, NULL),
(4480, '2016-08-01 12:06:16', NULL, NULL, 1575, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 12:06:16', 'Staff-1470021703-14700243762419455', 1, 1, 'SR', NULL, NULL, NULL),
(4481, '2016-08-01 12:06:16', NULL, NULL, 1575, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 12:06:16', 'Staff-1470021703-14700243762419455', 1, 1, 'SR', NULL, NULL, NULL),
(4482, '2016-08-01 12:15:20', NULL, NULL, 1576, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 12:15:20', 'Staff-1470021703-14700249198888158', 1, 1, 'SR', 1, NULL, NULL),
(4483, '2016-08-01 12:19:58', NULL, NULL, 1577, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 12:19:58', 'Staff-1470021703-14700251983147510', 1, 0, '', 1, NULL, NULL),
(4484, '2016-08-01 12:22:24', NULL, NULL, 1578, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 12:22:24', 'Staff-1470021703-14700253442613789', 1, 0, '', 1, NULL, NULL),
(4485, '2016-08-01 12:22:24', NULL, NULL, 1578, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 12:22:24', 'Staff-1470021703-14700253442613789', 1, 1, 'SR', 1, NULL, NULL),
(4486, '2016-08-01 12:44:27', NULL, NULL, 1579, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 12:44:27', 'Staff-1470021703-14700266673712936', 1, 0, '', 1, NULL, NULL),
(4487, '2016-08-01 12:46:07', NULL, NULL, 1580, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 12:46:07', 'Staff-1470021703-1470026767145758', 1, 0, '', 1, NULL, NULL),
(4488, '2016-08-01 12:48:00', NULL, NULL, 1581, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 12:48:00', 'Staff-1470021703-14700268805551463', 1, 0, '', 1, NULL, NULL),
(4489, '2016-08-01 12:48:08', NULL, NULL, 1581, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 12:48:08', 'Staff-1470021703-14700268887646996', 1, 0, '', 1, NULL, NULL),
(4490, '2016-08-01 13:12:27', NULL, NULL, 1582, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470021703', 'Staff', '2016-08-01 13:12:27', 'Staff-1470021703-14700283475307879', 1, 0, '', NULL, NULL, NULL),
(4491, '2016-08-01 09:54:52', NULL, NULL, 1570, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470021703', 'lois', '2016-08-01 09:54:52', 'lois-1470011762-14700164927475732', 1, 0, '', NULL, NULL, NULL),
(4492, '2016-08-01 09:54:09', NULL, NULL, 1569, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470021703', 'lois', '2016-08-01 09:54:09', 'lois-1470011762-14700164493362984', 1, 1, 'SR', NULL, NULL, NULL),
(4493, '2016-08-01 09:45:43', NULL, NULL, 1568, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470021703', 'lois', '2016-08-01 09:45:43', 'lois-1470011762-14700159435439513', 1, 1, 'SR', NULL, NULL, NULL),
(4494, '2016-08-01 09:54:09', NULL, NULL, 1569, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470021703', 'lois', '2016-08-01 09:54:09', 'lois-1470011762-14700164493362984', 1, 0, '', NULL, NULL, NULL),
(4495, '2016-08-01 09:45:43', NULL, NULL, 1568, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470021703', 'lois', '2016-08-01 09:45:43', 'lois-1470011762-14700159435439513', 1, 1, 'SR', NULL, NULL, NULL),
(4496, '2016-08-02 15:56:08', NULL, NULL, 1611, 0, 206, '141', 'Creme Brulee Cheese Cake', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 15:56:08', 'admin-1470120438-14701245687604676', 1, 0, '', NULL, NULL, NULL),
(4497, '2016-08-02 15:56:08', NULL, NULL, 1611, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 15:56:08', 'admin-1470120438-14701245687604676', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(4498, '2016-08-02 15:56:09', NULL, NULL, 1611, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 15:56:09', 'admin-1470120438-14701245687604676', 1, 1, 'SR', NULL, NULL, NULL),
(4499, '2016-08-02 15:56:23', NULL, NULL, 1611, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 15:56:23', 'admin-1470120438-14701245831496545', 1, 0, '', NULL, NULL, NULL),
(4500, '2016-08-02 19:12:47', NULL, NULL, 1613, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 19:12:47', 'admin-1470120438-14701363671615788', 1, 0, '', NULL, NULL, NULL),
(4501, '2016-08-02 18:14:39', NULL, NULL, 1615, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 18:14:39', 'admin-1470120438-14701328798376360', 1, 1, 'SR', NULL, NULL, NULL),
(4502, '2016-08-02 17:59:43', NULL, NULL, 1613, 0, 182, '117', 'Open Drinks ', 'Arteno Red', 'Desserts', '0', 1, 100.00, 100.0000, 0.0000, 100.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 17:59:43', 'admin-1470120438-14701319832483315', 1, 0, '', NULL, NULL, NULL),
(4503, '2016-08-02 18:14:39', NULL, NULL, 1615, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 18:14:39', 'admin-1470120438-14701328798376360', 1, 1, 'SR', NULL, NULL, NULL),
(4504, '2016-08-02 17:28:38', NULL, NULL, 1612, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 17:28:38', 'admin-1470120438-14701301186821574', 1, 0, '', NULL, NULL, NULL),
(4505, '2016-08-02 17:28:38', NULL, NULL, 1612, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 17:28:38', 'admin-1470120438-14701301186821574', 1, 1, 'SR', NULL, NULL, NULL),
(4506, '2016-08-02 17:28:38', NULL, NULL, 1612, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 17:28:38', 'admin-1470120438-14701301186821574', 1, 1, 'SR', NULL, NULL, NULL),
(4507, '2016-08-02 17:39:39', NULL, NULL, 1613, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 17:39:39', 'admin-1470120438-14701307798205782', 1, 1, 'SR', NULL, NULL, NULL),
(4508, '2016-08-02 17:39:39', NULL, NULL, 1613, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 17:39:39', 'admin-1470120438-14701307798205782', 1, 1, 'SR', NULL, NULL, NULL),
(4509, '2016-08-02 17:56:43', NULL, NULL, 1614, 0, 206, '141', 'Creme Brulee Cheese Cake', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 17:56:43', 'admin-1470120438-1470131802937776', 1, 0, '', NULL, NULL, NULL),
(4510, '2016-08-02 17:56:43', NULL, NULL, 1614, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 17:56:43', 'admin-1470120438-1470131802937776', 1, 0, '', NULL, NULL, NULL),
(4511, '2016-08-02 15:52:22', NULL, NULL, 1609, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 15:52:22', 'admin-1470120438-14701243426274569', 1, 1, 'SR', NULL, NULL, NULL),
(4512, '2016-08-02 15:52:38', NULL, NULL, 1610, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 15:52:38', 'admin-1470120438-14701243584015193', 1, 1, 'SR', NULL, NULL, NULL),
(4513, '2016-08-02 15:52:22', NULL, NULL, 1609, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 15:52:22', 'admin-1470120438-14701243426274569', 1, 1, 'SR', NULL, NULL, NULL),
(4514, '2016-08-02 13:58:57', NULL, NULL, 1608, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 13:58:57', 'admin-1470099502-14701175372315185', 1, 1, 'SR', NULL, NULL, NULL),
(4515, '2016-08-02 10:22:06', NULL, NULL, 1602, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 10:22:06', 'admin-1470099502-1470104526516199', 1, 1, 'SR', NULL, NULL, NULL),
(4516, '2016-08-02 10:22:06', NULL, NULL, 1602, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 10:22:06', 'admin-1470099502-1470104526516199', 1, 1, 'SR', NULL, NULL, NULL),
(4517, '2016-08-02 10:45:37', NULL, NULL, 1603, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 10:45:37', 'admin-1470099502-1470105937131885', 1, 1, 'SR', NULL, NULL, NULL),
(4518, '2016-08-02 10:45:37', NULL, NULL, 1603, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 10:45:37', 'admin-1470099502-1470105937131885', 1, 1, 'SR', NULL, NULL, NULL),
(4519, '2016-08-02 10:45:48', NULL, NULL, 1604, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 10:45:48', 'admin-1470099502-14701059479373760', 1, 1, 'SR', NULL, NULL, NULL),
(4520, '2016-08-02 12:24:48', NULL, NULL, 1605, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 12:24:48', 'admin-1470099502-14701118886775852', 1, 0, '', NULL, NULL, '10.0'),
(4521, '2016-08-02 12:24:48', NULL, NULL, 1605, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 12:24:48', 'admin-1470099502-14701118886775852', 1, 1, 'SR', NULL, NULL, '10.0'),
(4522, '2016-08-02 12:24:48', NULL, NULL, 1605, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 12:24:48', 'admin-1470099502-14701118886775852', 1, 0, '', NULL, NULL, '10.0'),
(4523, '2016-08-02 12:24:48', NULL, NULL, 1605, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 12:24:48', 'admin-1470099502-14701118886775852', 1, 0, '', NULL, NULL, '10.0'),
(4524, '2016-08-02 12:24:58', NULL, NULL, 1605, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 12:24:58', 'admin-1470099502-14701118981967449', 1, 1, 'SR', NULL, NULL, '10.0'),
(4525, '2016-08-02 12:24:58', NULL, NULL, 1605, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 12:24:58', 'admin-1470099502-14701118981967449', 1, 1, 'SR', NULL, NULL, '10.0'),
(4526, '2016-08-02 12:40:30', NULL, NULL, 1605, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 12:40:30', 'admin-1470099502-14701128300748852', 1, 1, 'SR', NULL, NULL, '10.0'),
(4527, '2016-08-02 13:02:20', NULL, NULL, 1605, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 13:02:20', 'admin-1470099502-1470114140126547', 1, 1, 'SR', NULL, NULL, '10.0'),
(4528, '2016-08-02 13:32:43', NULL, NULL, 1605, 0, 206, '141', 'Creme Brulee Cheese Cake', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 13:32:43', 'admin-1470099502-14701159636282542', 1, 0, '', NULL, NULL, '10.0'),
(4529, '2016-08-02 13:33:04', NULL, NULL, 1605, 0, 181, '116', 'Open Food ', 'CREME BRULLE CHEESE CAKE', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 13:33:04', 'admin-1470099502-1470115983965548', 1, 0, '', NULL, NULL, '10.0'),
(4530, '2016-08-02 13:40:20', NULL, NULL, 1606, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 13:40:20', 'admin-1470099502-14701164204287463', 1, 1, 'SR', NULL, NULL, NULL),
(4531, '2016-08-02 13:52:33', NULL, NULL, 1607, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 13:52:33', 'admin-1470099502-14701171533612221', 1, 1, 'SR', NULL, NULL, NULL),
(4532, '2016-08-02 13:52:33', NULL, NULL, 1607, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 13:52:33', 'admin-1470099502-14701171533612221', 1, 0, '', NULL, NULL, NULL),
(4533, '2016-08-02 13:52:46', NULL, NULL, 1607, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 13:52:46', 'admin-1470099502-14701171663252370', 1, 0, '', NULL, NULL, NULL),
(4534, '2016-08-02 13:58:57', NULL, NULL, 1608, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 13:58:57', 'admin-1470099502-14701175372315185', 1, 0, '', NULL, NULL, NULL),
(4535, '2016-08-02 10:21:14', NULL, NULL, 1602, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 10:21:14', 'admin-1470099502-14701044746816955', 1, 0, '', NULL, NULL, NULL),
(4536, '2016-08-02 09:49:19', NULL, NULL, 1601, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 09:49:19', 'admin-1470099502-14701025591183053', 1, 0, '', NULL, NULL, NULL),
(4537, '2016-08-02 10:21:14', NULL, NULL, 1602, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 10:21:14', 'admin-1470099502-14701044746816955', 1, 0, '', NULL, NULL, NULL),
(4538, '2016-08-02 09:49:19', NULL, NULL, 1601, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470120438', 'admin', '2016-08-02 09:49:19', 'admin-1470099502-14701025591183053', 1, 1, 'SR', NULL, NULL, NULL),
(4539, '2016-08-04 18:00:35', NULL, NULL, 1634, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 18:00:35', 'admin-1470285478-14703048352793097', 1, 1, 'SR', NULL, NULL, NULL),
(4540, '2016-08-04 12:29:35', NULL, NULL, 1625, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 12:29:35', 'admin-1470272375-14702849749069184', 1, 1, 'SR', NULL, NULL, NULL),
(4541, '2016-08-04 12:29:35', NULL, NULL, 1625, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 12:29:35', 'admin-1470272375-14702849749069184', 1, 0, '', NULL, NULL, NULL),
(4542, '2016-08-04 12:34:37', NULL, NULL, 1625, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 12:34:37', 'admin-1470272375-14702852769003333', 1, 0, '', NULL, NULL, NULL),
(4543, '2016-08-04 12:36:27', NULL, NULL, 1626, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 12:36:27', 'admin-1470272375-14702853868816786', 1, 1, 'SR', NULL, NULL, NULL),
(4544, '2016-08-04 12:36:27', NULL, NULL, 1626, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 12:36:27', 'admin-1470272375-14702853868816786', 1, 0, '', NULL, NULL, NULL),
(4545, '2016-08-04 18:59:44', NULL, NULL, 1635, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 18:59:44', 'admin-1470285478-14703083839149621', 1, 1, 'SR', NULL, NULL, NULL),
(4546, '2016-08-04 17:24:46', NULL, NULL, 1633, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 17:24:46', 'admin-1470285478-14703026866029514', 1, 1, 'SR', NULL, NULL, NULL),
(4547, '2016-08-04 17:24:46', NULL, NULL, 1633, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 17:24:46', 'admin-1470285478-14703026866029514', 1, 0, '', NULL, NULL, NULL),
(4548, '2016-08-04 16:45:08', NULL, NULL, 1632, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 16:45:08', 'admin-1470285478-14703003084593040', 1, 1, 'SR', NULL, NULL, NULL),
(4549, '2016-08-04 16:30:48', NULL, NULL, 1631, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 16:30:48', 'admin-1470285478-1470299447888533', 1, 1, 'SR', 1, NULL, NULL),
(4550, '2016-08-04 16:30:48', NULL, NULL, 1631, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 16:30:48', 'admin-1470285478-1470299447888533', 1, 0, '', 1, NULL, NULL),
(4551, '2016-08-04 16:45:08', NULL, NULL, 1632, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 16:45:08', 'admin-1470285478-14703003084593040', 1, 1, 'SR', NULL, NULL, NULL),
(4552, '2016-08-04 16:26:41', NULL, NULL, 1630, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 16:26:41', 'admin-1470285478-14702992009792964', 1, 1, 'SR', 1, NULL, NULL),
(4553, '2016-08-04 16:26:31', NULL, NULL, 1628, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 16:26:31', 'admin-1470285478-1470299191380193', 1, 1, 'SR', NULL, NULL, NULL),
(4554, '2016-08-04 16:26:41', NULL, NULL, 1630, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 16:26:41', 'admin-1470285478-14702992009792964', 1, 0, '', 1, NULL, NULL),
(4555, '2016-08-04 15:15:58', NULL, NULL, 1629, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 15:15:58', 'admin-1470285478-14702949582524383', 1, 0, '', NULL, NULL, NULL),
(4556, '2016-08-04 15:15:58', NULL, NULL, 1629, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 15:15:58', 'admin-1470285478-14702949582524383', 1, 1, 'SR', NULL, NULL, NULL),
(4557, '2016-08-04 15:15:32', NULL, NULL, 1628, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 15:15:32', 'admin-1470285478-14702949326183640', 1, 1, 'SR', NULL, NULL, NULL),
(4558, '2016-08-04 12:38:15', NULL, NULL, 1626, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 12:38:15', 'admin-1470285478-14702854954199198', 1, 0, '', NULL, NULL, NULL),
(4559, '2016-08-04 12:38:15', NULL, NULL, 1626, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 12:38:15', 'admin-1470285478-14702854954199198', 1, 1, 'SR', NULL, NULL, NULL),
(4560, '2016-08-04 14:39:26', NULL, NULL, 1628, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 14:39:26', 'admin-1470285478-14702927662194920', 1, 1, 'SR', NULL, NULL, NULL),
(4561, '2016-08-04 14:39:26', NULL, NULL, 1628, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 14:39:26', 'admin-1470285478-14702927662194920', 1, 0, '', NULL, NULL, NULL),
(4562, '2016-08-04 13:50:05', NULL, NULL, 1627, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 13:50:05', 'admin-1470285478-14702898051385017', 1, 0, '', NULL, NULL, NULL),
(4563, '2016-08-04 13:50:05', NULL, NULL, 1627, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 13:50:05', 'admin-1470285478-14702898051385017', 1, 1, 'SR', NULL, NULL, NULL),
(4564, '2016-08-04 13:25:10', NULL, NULL, 1624, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 13:25:10', 'admin-1470285478-14702883107012033', 1, 1, 'SR', NULL, NULL, NULL),
(4565, '2016-08-04 13:25:10', NULL, NULL, 1624, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 13:25:10', 'admin-1470285478-14702883107012033', 1, 1, 'SR', NULL, NULL, NULL),
(4566, '2016-08-04 12:28:18', NULL, NULL, 1624, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 12:28:18', 'admin-1470272375-1470284898723739', 1, 0, '', NULL, NULL, NULL),
(4567, '2016-08-04 12:29:35', NULL, NULL, 1625, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 12:29:35', 'admin-1470272375-14702849749069184', 1, 1, 'SR', NULL, NULL, NULL),
(4568, '2016-08-04 12:28:18', NULL, NULL, 1624, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 12:28:18', 'admin-1470272375-1470284898723739', 1, 0, '', NULL, NULL, NULL),
(4569, '2016-08-04 12:28:18', NULL, NULL, 1624, 0, 198, '133', 'Dinner - Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 12:28:18', 'admin-1470272375-1470284898723739', 1, 0, '', NULL, NULL, NULL),
(4570, '2016-08-04 12:28:18', NULL, NULL, 1624, 0, 201, '136', 'Dinner -  Chili Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 12:28:18', 'admin-1470272375-1470284898723739', 1, 0, '', NULL, NULL, NULL),
(4571, '2016-08-04 12:27:53', NULL, NULL, 1624, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 12:27:53', 'admin-1470272375-14702848732791372', 1, 0, '', NULL, NULL, NULL),
(4572, '2016-08-04 12:08:26', NULL, NULL, 1623, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 12:08:26', 'admin-1470272375-14702837067473719', 1, 1, 'SR', NULL, NULL, NULL),
(4573, '2016-08-04 11:47:33', NULL, NULL, 1622, NULL, 65, '65', 'Pineapple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 11:47:33', 'admin-1470272375-14702824537383794', 1, 1, 'SR', NULL, NULL, NULL),
(4574, '2016-08-04 11:47:33', NULL, NULL, 1622, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 11:47:33', 'admin-1470272375-14702824537383794', 1, 0, '', NULL, NULL, NULL),
(4575, '2016-08-04 11:47:33', NULL, NULL, 1622, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 11:47:33', 'admin-1470272375-14702824537383794', 1, 1, 'SR', NULL, NULL, NULL),
(4576, '2016-08-04 11:47:33', NULL, NULL, 1622, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 11:47:33', 'admin-1470272375-14702824537383794', 1, 1, 'SR', NULL, NULL, NULL),
(4577, '2016-08-04 11:47:33', NULL, NULL, 1622, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 11:47:33', 'admin-1470272375-14702824537383794', 1, 1, 'SR', NULL, NULL, NULL),
(4578, '2016-08-04 11:44:42', NULL, NULL, 1622, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 11:44:42', 'admin-1470272375-14702822820265331', 1, 0, '', NULL, NULL, NULL),
(4579, '2016-08-04 11:44:42', NULL, NULL, 1622, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 11:44:42', 'admin-1470272375-14702822820265331', 1, 0, '', NULL, NULL, NULL),
(4580, '2016-08-04 11:44:42', NULL, NULL, 1622, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 11:44:42', 'admin-1470272375-14702822820265331', 1, 0, '', NULL, NULL, NULL),
(4581, '2016-08-04 11:44:42', NULL, NULL, 1622, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 11:44:42', 'admin-1470272375-14702822820265331', 1, 0, '', NULL, NULL, NULL),
(4582, '2016-08-04 10:27:14', NULL, NULL, 1620, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 10:27:14', 'admin-1470272375-14702776346607282', 1, 1, 'SR', 1, NULL, NULL),
(4583, '2016-08-04 10:13:13', NULL, NULL, 1619, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 10:13:13', 'admin-1470272375-14702767928756832', 1, 1, 'SR', NULL, NULL, NULL),
(4584, '2016-08-04 10:13:13', NULL, NULL, 1619, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 10:13:13', 'admin-1470272375-14702767928756832', 1, 0, '', NULL, NULL, NULL),
(4585, '2016-08-04 09:46:02', NULL, NULL, 1618, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 09:46:02', 'admin-1470272375-14702751620299013', 1, 1, 'SR', NULL, NULL, NULL),
(4586, '2016-08-04 09:46:02', NULL, NULL, 1618, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 09:46:02', 'admin-1470272375-14702751620299013', 1, 1, 'SR', NULL, NULL, NULL),
(4587, '2016-08-04 09:42:19', NULL, NULL, 1617, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 09:42:19', 'admin-1470272375-14702749394688347', 1, 0, '', NULL, NULL, NULL),
(4588, '2016-08-04 09:40:21', NULL, NULL, 1617, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 09:40:21', 'admin-1470272375-14702748217245952', 1, 1, 'SR', NULL, NULL, NULL),
(4589, '2016-08-04 09:23:59', NULL, NULL, 1616, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 09:23:59', 'admin-1470272375-14702738392012532', 1, 0, '', NULL, NULL, NULL),
(4590, '2016-08-04 09:24:26', NULL, NULL, 1616, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 09:24:26', 'admin-1470272375-14702738660605797', 1, 1, 'SR', NULL, NULL, NULL),
(4591, '2016-08-04 09:23:59', NULL, NULL, 1616, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470285478', 'admin', '2016-08-04 09:23:59', 'admin-1470272375-14702738392012532', 1, 0, '', NULL, NULL, NULL),
(4592, '2016-08-05 19:31:08', NULL, NULL, 1667, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 19:31:08', 'admin-1470376059-14703966681935194', 1, 0, '', 1, NULL, NULL),
(4593, '2016-08-05 19:31:08', NULL, NULL, 1667, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 19:31:08', 'admin-1470376059-14703966681935194', 1, 0, '', 1, NULL, NULL),
(4594, '2016-08-05 19:40:35', NULL, NULL, 1665, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 19:40:35', 'admin-1470376059-14703972353981348', 1, 0, '', NULL, NULL, NULL),
(4595, '2016-08-05 19:47:15', NULL, NULL, 1668, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 19:47:15', 'admin-1470397619-1470397635269118', 1, 1, 'SR', NULL, NULL, NULL),
(4596, '2016-08-05 19:47:15', NULL, NULL, 1668, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 19:47:15', 'admin-1470397619-1470397635269118', 1, 1, 'SR', NULL, NULL, NULL),
(4597, '2016-08-05 20:20:52', NULL, NULL, 1669, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 20:20:52', 'admin-1470397619-14703996524597778', 1, 0, '', NULL, NULL, NULL),
(4598, '2016-08-05 20:20:52', NULL, NULL, 1669, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 20:20:52', 'admin-1470397619-14703996524597778', 1, 1, 'SR', NULL, NULL, NULL),
(4599, '2016-08-05 20:21:32', NULL, NULL, 1669, 0, 197, '132', 'Dinner - Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 20:21:32', 'admin-1470397619-14703996920892918', 1, 0, '', NULL, NULL, NULL),
(4600, '2016-08-05 20:21:32', NULL, NULL, 1669, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 20:21:32', 'admin-1470397619-14703996920892918', 1, 0, '', NULL, NULL, NULL),
(4601, '2016-08-05 20:21:40', NULL, NULL, 1669, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 20:21:40', 'admin-1470397619-14703997005796861', 1, 1, 'SR', NULL, NULL, NULL),
(4602, '2016-08-05 20:21:40', NULL, NULL, 1669, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 20:21:40', 'admin-1470397619-14703997005796861', 1, 1, 'SR', NULL, NULL, NULL),
(4603, '2016-08-05 20:32:04', NULL, NULL, 1670, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 20:32:04', 'admin-1470397619-14704003242872114', 1, 1, 'SR', NULL, NULL, NULL),
(4604, '2016-08-05 20:39:19', NULL, NULL, 1671, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 20:39:19', 'admin-1470397619-1470400758921913', 1, 1, 'SR', NULL, NULL, NULL),
(4605, '2016-08-05 20:54:36', NULL, NULL, 1672, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 20:54:36', 'admin-1470397619-14704016768024150', 1, 1, 'SR', NULL, NULL, NULL),
(4606, '2016-08-05 20:54:27', NULL, NULL, 1672, 0, 75, '75', 'Aglio Olio ', 'Chicken', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 20:54:27', 'admin-1470397619-14704016669387599', 1, 0, '', NULL, NULL, NULL),
(4607, '2016-08-05 20:54:27', NULL, NULL, 1672, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 20:54:27', 'admin-1470397619-14704016669387599', 1, 0, '', NULL, NULL, NULL),
(4608, '2016-08-05 20:43:27', NULL, NULL, 1669, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 20:43:27', 'admin-1470397619-14704010072619957', 1, 1, 'SR', NULL, NULL, NULL),
(4609, '2016-08-05 20:39:19', NULL, NULL, 1671, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 20:39:19', 'admin-1470397619-1470400758921913', 1, 1, 'SR', NULL, NULL, NULL),
(4610, '2016-08-05 19:10:04', NULL, NULL, 1666, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 19:10:04', 'admin-1470376059-14703954038235039', 1, 0, '', NULL, NULL, NULL),
(4611, '2016-08-05 19:10:04', NULL, NULL, 1666, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 19:10:04', 'admin-1470376059-14703954038235039', 1, 1, 'SR', NULL, NULL, NULL),
(4612, '2016-08-05 13:25:10', NULL, NULL, 1650, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 13:25:10', 'sanni-1470374356-1470374710259169', 1, 0, '', NULL, NULL, NULL),
(4613, '2016-08-05 13:25:10', NULL, NULL, 1650, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 13:25:10', 'sanni-1470374356-1470374710259169', 1, 1, 'SR', NULL, NULL, NULL),
(4614, '2016-08-05 19:31:08', NULL, NULL, 1667, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 19:31:08', 'admin-1470376059-14703966681935194', 1, 0, '', 1, NULL, NULL),
(4615, '2016-08-05 19:31:08', NULL, NULL, 1667, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 19:31:08', 'admin-1470376059-14703966681935194', 1, 0, '', 1, NULL, NULL),
(4616, '2016-08-05 19:11:30', NULL, NULL, 1665, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 19:11:30', 'admin-1470376059-14703954902794942', 1, 1, 'SR', NULL, NULL, NULL),
(4617, '2016-08-05 19:11:07', NULL, NULL, 1666, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 19:11:07', 'admin-1470376059-1470395467394341', 1, 1, 'SR', NULL, NULL, NULL),
(4618, '2016-08-05 19:10:37', NULL, NULL, 1665, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 19:10:37', 'admin-1470376059-14703954374568437', 1, 0, '', NULL, NULL, NULL),
(4619, '2016-08-05 19:10:37', NULL, NULL, 1665, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 19:10:37', 'admin-1470376059-14703954374568437', 1, 0, '', NULL, NULL, NULL),
(4620, '2016-08-05 13:31:59', NULL, NULL, 1652, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 13:31:59', 'sanni-1470374356-14703751193178610', 1, 1, 'SR', NULL, NULL, NULL),
(4621, '2016-08-05 13:38:46', NULL, NULL, 1653, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 13:38:46', 'sanni-1470374356-14703755263691428', 1, 0, '', NULL, NULL, NULL),
(4622, '2016-08-05 13:44:46', NULL, NULL, 1654, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 13:44:46', 'sanni-1470374356-14703758861088817', 1, 1, 'SR', NULL, NULL, NULL),
(4623, '2016-08-05 13:44:46', NULL, NULL, 1654, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 13:44:46', 'sanni-1470374356-14703758861088817', 1, 1, 'SR', NULL, NULL, NULL),
(4624, '2016-08-05 13:47:18', NULL, NULL, 1647, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 13:47:18', 'sanni-1470374356-14703760386564380', 1, 1, 'SR', NULL, NULL, NULL),
(4625, '2016-08-05 14:00:47', NULL, NULL, 1651, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 14:00:47', 'admin-1470376059-14703768476209748', 1, 0, '', NULL, NULL, NULL),
(4626, '2016-08-05 15:07:35', NULL, NULL, 1655, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 15:07:35', 'admin-1470376059-14703808551048076', 1, 1, 'SR', NULL, NULL, NULL),
(4627, '2016-08-05 15:11:01', NULL, NULL, 1656, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 15:11:01', 'admin-1470376059-14703810616239199', 1, 0, '', NULL, NULL, NULL),
(4628, '2016-08-05 15:11:01', NULL, NULL, 1656, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 15:11:01', 'admin-1470376059-14703810616239199', 1, 0, '', NULL, NULL, NULL),
(4629, '2016-08-05 15:29:59', NULL, NULL, 1657, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 15:29:59', 'admin-1470376059-147038219887369', 1, 1, 'SR', NULL, NULL, NULL),
(4630, '2016-08-05 15:30:51', NULL, NULL, 1658, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 15:30:51', 'admin-1470376059-14703822516216216', 1, 1, 'SR', NULL, NULL, NULL),
(4631, '2016-08-05 15:30:51', NULL, NULL, 1658, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 15:30:51', 'admin-1470376059-14703822516216216', 1, 1, 'SR', NULL, NULL, NULL),
(4632, '2016-08-05 15:55:50', NULL, NULL, 1659, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 15:55:50', 'admin-1470376059-14703837499598171', 1, 1, 'SR', NULL, NULL, NULL),
(4633, '2016-08-05 15:55:50', NULL, NULL, 1659, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 15:55:50', 'admin-1470376059-14703837499598171', 1, 1, 'SR', NULL, NULL, NULL),
(4634, '2016-08-05 13:31:59', NULL, NULL, 1652, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 13:31:59', 'sanni-1470374356-14703751193178610', 1, 0, '', NULL, NULL, NULL),
(4635, '2016-08-05 13:31:13', NULL, NULL, 1651, 0, 83, '83', 'Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 13:31:13', 'sanni-1470374356-14703750734117382', 1, 1, 'SR', NULL, NULL, NULL),
(4636, '2016-08-05 13:28:50', NULL, NULL, 1647, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 13:28:50', 'sanni-1470374356-147037493012596', 1, 0, '', NULL, NULL, NULL),
(4637, '2016-08-05 13:28:50', NULL, NULL, 1647, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 13:28:50', 'sanni-1470374356-147037493012596', 1, 1, 'SR', NULL, NULL, NULL),
(4638, '2016-08-05 19:09:20', NULL, NULL, 1665, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 19:09:20', 'admin-1470376059-14703953605423039', 1, 1, 'SR', NULL, NULL, NULL),
(4639, '2016-08-05 19:08:36', NULL, NULL, 1665, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 19:08:36', 'admin-1470376059-1470395315952120', 1, 0, '', NULL, NULL, NULL),
(4640, '2016-08-05 18:55:02', NULL, NULL, 1664, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 18:55:02', 'admin-1470376059-14703945020129571', 1, 0, '', NULL, NULL, NULL),
(4641, '2016-08-05 17:39:01', NULL, NULL, 1663, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 17:39:01', 'admin-1470376059-14703899417047189', 1, 1, 'SR', NULL, NULL, NULL),
(4642, '2016-08-05 17:37:43', NULL, NULL, 1662, 0, 178, '113', 'Brownies ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 17:37:43', 'admin-1470376059-14703898633875522', 1, 0, '', NULL, NULL, NULL),
(4643, '2016-08-05 17:37:43', NULL, NULL, 1662, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 17:37:43', 'admin-1470376059-14703898633875522', 1, 1, 'SR', NULL, NULL, NULL),
(4644, '2016-08-05 17:37:43', NULL, NULL, 1662, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 17:37:43', 'admin-1470376059-14703898633875522', 1, 1, 'SR', NULL, NULL, NULL),
(4645, '2016-08-05 17:32:11', NULL, NULL, 1661, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 17:32:11', 'admin-1470376059-14703895314849363', 1, 1, 'SR', NULL, NULL, NULL),
(4646, '2016-08-05 17:32:11', NULL, NULL, 1661, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 17:32:11', 'admin-1470376059-14703895314849363', 1, 1, 'SR', NULL, NULL, NULL),
(4647, '2016-08-05 17:32:11', NULL, NULL, 1661, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 17:32:11', 'admin-1470376059-14703895314849363', 1, 1, 'SR', NULL, NULL, NULL),
(4648, '2016-08-05 16:05:18', NULL, NULL, 1660, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 16:05:18', 'admin-1470376059-14703843184908940', 1, 0, '', NULL, NULL, NULL),
(4649, '2016-08-05 16:05:18', NULL, NULL, 1660, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 16:05:18', 'admin-1470376059-14703843184908940', 1, 1, 'SR', NULL, NULL, NULL),
(4650, '2016-08-05 13:25:10', NULL, NULL, 1650, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 13:25:10', 'sanni-1470374356-1470374710259169', 1, 1, 'SR', NULL, NULL, NULL),
(4651, '2016-08-05 13:28:23', NULL, NULL, 1647, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 13:28:23', 'sanni-1470374356-14703749036075644', 1, 0, '', NULL, NULL, NULL),
(4652, '2016-08-05 13:21:34', NULL, NULL, 1647, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 13:21:34', 'sanni-1470374356-14703744938243114', 1, 1, 'SR', NULL, NULL, NULL),
(4653, '2016-08-05 13:22:41', NULL, NULL, 1649, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 13:22:41', 'sanni-1470374356-14703745617331295', 1, 1, 'SR', NULL, NULL, NULL),
(4654, '2016-08-05 13:19:04', NULL, NULL, 1648, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 13:19:04', 'admin-1470364383-14703743441984143', 1, 0, '', NULL, NULL, NULL),
(4655, '2016-08-05 13:16:49', NULL, NULL, 1647, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 13:16:49', 'admin-1470364383-14703742091078832', 1, 0, '', NULL, NULL, NULL),
(4656, '2016-08-05 13:16:49', NULL, NULL, 1647, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 13:16:49', 'admin-1470364383-14703742091078832', 1, 1, 'SR', NULL, NULL, NULL),
(4657, '2016-08-05 13:25:10', NULL, NULL, 1650, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 13:25:10', 'sanni-1470374356-1470374710259169', 1, 0, '', NULL, NULL, NULL),
(4658, '2016-08-05 13:19:04', NULL, NULL, 1648, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 13:19:04', 'admin-1470364383-14703743441984143', 1, 1, 'SR', NULL, NULL, NULL),
(4659, '2016-08-05 13:19:04', NULL, NULL, 1648, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 13:19:04', 'admin-1470364383-14703743441984143', 1, 1, 'SR', NULL, NULL, NULL),
(4660, '2016-08-05 13:16:49', NULL, NULL, 1647, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 13:16:49', 'admin-1470364383-14703742091078832', 1, 1, 'SR', NULL, NULL, NULL),
(4661, '2016-08-05 13:06:48', NULL, NULL, 1646, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 13:06:48', 'admin-1470364383-14703736085959074', 1, 1, 'SR', NULL, NULL, NULL),
(4662, '2016-08-05 13:06:48', NULL, NULL, 1646, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 13:06:48', 'admin-1470364383-14703736085959074', 1, 1, 'SR', NULL, NULL, NULL),
(4663, '2016-08-05 12:56:01', NULL, NULL, 1645, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 12:56:01', 'admin-1470364383-14703729617143272', 1, 1, 'SR', NULL, NULL, NULL),
(4664, '2016-08-05 12:56:01', NULL, NULL, 1645, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 12:56:01', 'admin-1470364383-14703729617143272', 1, 0, '', NULL, NULL, NULL),
(4665, '2016-08-05 12:56:01', NULL, NULL, 1645, NULL, 84, '84', 'Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 12:56:01', 'admin-1470364383-14703729617143272', 1, 1, 'SR', NULL, NULL, NULL),
(4666, '2016-08-05 12:56:01', NULL, NULL, 1645, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 12:56:01', 'admin-1470364383-14703729617143272', 1, 1, 'SR', NULL, NULL, NULL),
(4667, '2016-08-05 12:56:01', NULL, NULL, 1645, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 12:56:01', 'admin-1470364383-14703729617143272', 1, 1, 'SR', NULL, NULL, NULL),
(4668, '2016-08-05 12:56:01', NULL, NULL, 1645, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 12:56:01', 'admin-1470364383-14703729617143272', 1, 1, 'SR', NULL, NULL, NULL),
(4669, '2016-08-05 12:56:01', NULL, NULL, 1645, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 12:56:01', 'admin-1470364383-14703729617143272', 1, 1, 'SR', NULL, NULL, NULL),
(4670, '2016-08-05 12:52:42', NULL, NULL, 1643, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 12:52:42', 'admin-1470364383-14703727621588039', 1, 1, 'SR', NULL, NULL, NULL),
(4671, '2016-08-05 12:56:01', NULL, NULL, 1645, NULL, 84, '84', 'Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 12:56:01', 'admin-1470364383-14703729617143272', 1, 1, 'SR', NULL, NULL, NULL),
(4672, '2016-08-05 12:52:42', NULL, NULL, 1643, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 12:52:42', 'admin-1470364383-14703727621588039', 1, 1, 'SR', NULL, NULL, NULL),
(4673, '2016-08-05 12:52:42', NULL, NULL, 1643, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 12:52:42', 'admin-1470364383-14703727621588039', 1, 0, '', NULL, NULL, NULL),
(4674, '2016-08-05 09:23:12', NULL, NULL, 1638, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 09:23:12', 'sanni-1470358966-14703601919214071', 1, 0, '', NULL, NULL, NULL),
(4675, '2016-08-05 09:23:12', NULL, NULL, 1638, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 09:23:12', 'sanni-1470358966-14703601919214071', 1, 0, '', NULL, NULL, NULL),
(4676, '2016-08-05 10:17:40', NULL, NULL, 1639, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 10:17:40', 'sanni-1470358966-14703634601676332', 1, 1, 'SR', NULL, NULL, NULL),
(4677, '2016-08-05 10:17:40', NULL, NULL, 1639, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 10:17:40', 'sanni-1470358966-14703634601676332', 1, 0, '', NULL, NULL, NULL),
(4678, '2016-08-05 10:17:40', NULL, NULL, 1639, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 10:17:40', 'sanni-1470358966-14703634601676332', 1, 0, '', NULL, NULL, NULL),
(4679, '2016-08-05 10:18:07', NULL, NULL, 1639, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 10:18:07', 'sanni-1470358966-14703634877579637', 1, 0, '', NULL, NULL, NULL),
(4680, '2016-08-05 10:32:33', NULL, NULL, 1640, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 10:32:33', 'sanni-1470358966-14703643537616622', 1, 0, '', NULL, NULL, NULL),
(4681, '2016-08-05 10:32:33', NULL, NULL, 1640, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 10:32:33', 'sanni-1470358966-14703643537616622', 1, 0, '', NULL, NULL, NULL),
(4682, '2016-08-05 10:33:12', NULL, NULL, 1640, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 10:33:12', 'admin-1470364383-14703643919112472', 1, 1, 'SR', NULL, NULL, NULL),
(4683, '2016-08-05 10:33:12', NULL, NULL, 1640, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 10:33:12', 'admin-1470364383-14703643919112472', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(4684, '2016-08-05 11:06:52', NULL, NULL, 1641, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 11:06:52', 'admin-1470364383-14703664121484970', 1, 1, 'SR', NULL, NULL, NULL),
(4685, '2016-08-05 11:06:52', NULL, NULL, 1641, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 11:06:52', 'admin-1470364383-14703664121484970', 1, 0, '', NULL, NULL, NULL),
(4686, '2016-08-05 11:47:12', NULL, NULL, 1641, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 11:47:12', 'admin-1470364383-14703688327138839', 1, 1, 'SR', NULL, NULL, NULL),
(4687, '2016-08-05 11:58:36', NULL, NULL, 1642, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 11:58:36', 'admin-1470364383-1470369515888342', 1, 1, 'SR', NULL, NULL, NULL),
(4688, '2016-08-05 12:08:05', NULL, NULL, 1643, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 12:08:05', 'admin-1470364383-14703700851775443', 1, 0, '', NULL, NULL, NULL),
(4689, '2016-08-05 12:08:05', NULL, NULL, 1643, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 12:08:05', 'admin-1470364383-14703700851775443', 1, 0, '', NULL, NULL, NULL),
(4690, '2016-08-05 12:39:21', NULL, NULL, 1644, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 12:39:21', 'admin-1470364383-14703719609428111', 1, 1, 'SR', NULL, NULL, NULL),
(4691, '2016-08-05 12:39:21', NULL, NULL, 1644, 0, 83, '83', 'Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 12:39:21', 'admin-1470364383-14703719609428111', 1, 1, 'SR', NULL, NULL, NULL),
(4692, '2016-08-05 12:39:57', NULL, NULL, 1644, 0, 182, '117', 'Open Drinks ', 'americano', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 12:39:57', 'admin-1470364383-14703719969048437', 1, 0, '', NULL, NULL, NULL),
(4693, '2016-08-05 12:52:42', NULL, NULL, 1643, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 12:52:42', 'admin-1470364383-14703727621588039', 1, 0, '', NULL, NULL, NULL),
(4694, '2016-08-05 12:52:42', NULL, NULL, 1643, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470397619', 'admin', '2016-08-05 12:52:42', 'admin-1470364383-14703727621588039', 1, 0, '', NULL, NULL, NULL),
(4695, '2016-08-05 09:17:28', NULL, NULL, 1637, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 09:17:28', 'sanni-1470358966-14703598481545460', 1, 1, 'SR', NULL, NULL, NULL),
(4696, '2016-08-05 09:03:05', NULL, NULL, 1636, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 09:03:05', 'sanni-1470358966-14703589854596080', 1, 1, 'SR', NULL, NULL, NULL),
(4697, '2016-08-05 09:17:18', NULL, NULL, 1637, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 09:17:18', 'sanni-1470358966-1470359838397914', 1, 0, '', NULL, NULL, NULL),
(4698, '2016-08-05 09:03:05', NULL, NULL, 1636, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 09:03:05', 'sanni-1470358966-14703589854596080', 1, 1, 'SR', NULL, NULL, NULL),
(4699, '2016-08-05 09:03:05', NULL, NULL, 1636, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470397619', 'sanni', '2016-08-05 09:03:05', 'sanni-1470358966-14703589854596080', 1, 0, '', NULL, NULL, NULL),
(4700, '2016-08-06 19:54:39', NULL, NULL, 1718, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 19:54:39', 'sanni-1470465155-14704844792849378', 1, 1, 'SR', NULL, NULL, NULL),
(4701, '2016-08-06 19:54:39', NULL, NULL, 1718, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 19:54:39', 'sanni-1470465155-14704844792849378', 1, 1, 'SR', NULL, NULL, NULL),
(4702, '2016-08-06 19:54:39', NULL, NULL, 1718, 0, 75, '75', 'Aglio Olio ', 'Chicken', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 19:54:39', 'sanni-1470465155-14704844792849378', 1, 0, '', NULL, NULL, NULL),
(4703, '2016-08-06 19:54:39', NULL, NULL, 1718, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 19:54:39', 'sanni-1470465155-14704844792849378', 1, 1, 'SR', NULL, NULL, NULL),
(4704, '2016-08-06 16:14:51', NULL, NULL, 1708, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 16:14:51', 'sanni-1470465155-1470471291353316', 1, 0, '', NULL, NULL, NULL),
(4705, '2016-08-06 16:14:51', NULL, NULL, 1708, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 16:14:51', 'sanni-1470465155-1470471291353316', 1, 1, 'SR', NULL, NULL, NULL),
(4706, '2016-08-06 16:14:51', NULL, NULL, 1708, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 16:14:51', 'sanni-1470465155-1470471291353316', 1, 0, '', NULL, NULL, NULL),
(4707, '2016-08-06 16:20:08', NULL, NULL, 1709, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 16:20:08', 'sanni-1470465155-14704716086066813', 1, 0, '', NULL, NULL, NULL),
(4708, '2016-08-06 16:20:08', NULL, NULL, 1709, 0, 182, '117', 'Open Drinks ', 'tea', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 16:20:08', 'sanni-1470465155-14704716086066813', 1, 0, '', NULL, NULL, NULL),
(4709, '2016-08-06 16:35:42', NULL, NULL, 1710, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 16:35:42', 'sanni-1470465155-14704725420649953', 1, 1, 'SR', NULL, NULL, NULL),
(4710, '2016-08-06 20:08:32', NULL, NULL, 1719, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 20:08:32', 'sanni-1470465155-1470485312801738', 1, 1, 'SR', NULL, NULL, NULL),
(4711, '2016-08-06 20:08:32', NULL, NULL, 1719, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 20:08:32', 'sanni-1470465155-1470485312801738', 1, 1, 'SR', NULL, NULL, NULL),
(4712, '2016-08-06 16:49:56', NULL, NULL, 1712, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 16:49:56', 'sanni-1470465155-14704733961012124', 1, 0, '', NULL, NULL, NULL),
(4713, '2016-08-06 16:49:56', NULL, NULL, 1712, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 16:49:56', 'sanni-1470465155-14704733961012124', 1, 0, '', NULL, NULL, NULL),
(4714, '2016-08-06 16:49:56', NULL, NULL, 1712, 0, 182, '117', 'Open Drinks ', 'tea', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 16:49:56', 'sanni-1470465155-14704733961012124', 1, 0, '', NULL, NULL, NULL),
(4715, '2016-08-06 17:13:54', NULL, NULL, 1713, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 17:13:54', 'sanni-1470465155-14704748339154858', 1, 1, 'SR', NULL, NULL, NULL),
(4716, '2016-08-06 17:46:32', NULL, NULL, 1714, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 3, 8.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 17:46:32', 'sanni-1470465155-14704767920224098', 1, 0, '', NULL, NULL, NULL),
(4717, '2016-08-06 17:46:57', NULL, NULL, 1715, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 17:46:57', 'sanni-1470465155-14704768168912446', 1, 1, 'SR', NULL, NULL, NULL),
(4718, '2016-08-06 17:48:14', NULL, NULL, 1716, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 17:48:14', 'sanni-1470465155-1470476894712576', 1, 1, 'SR', NULL, NULL, NULL),
(4719, '2016-08-06 17:55:26', NULL, NULL, 1717, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 17:55:26', 'sanni-1470465155-14704773257683778', 1, 0, '', NULL, NULL, NULL),
(4720, '2016-08-06 17:55:26', NULL, NULL, 1717, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 17:55:26', 'sanni-1470465155-14704773257683778', 1, 0, '', NULL, NULL, NULL),
(4721, '2016-08-06 17:55:26', NULL, NULL, 1717, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 17:55:26', 'sanni-1470465155-14704773257683778', 1, 0, '', NULL, NULL, NULL),
(4722, '2016-08-06 17:57:06', NULL, NULL, 1717, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 17:57:06', 'sanni-1470465155-1470477426463955', 1, 1, 'SR', NULL, NULL, NULL),
(4723, '2016-08-06 17:57:06', NULL, NULL, 1717, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 17:57:06', 'sanni-1470465155-1470477426463955', 1, 1, 'SR', NULL, NULL, NULL),
(4724, '2016-08-06 13:56:20', NULL, NULL, 1702, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 13:56:20', 'sanni-1470459027-14704629803667513', 1, 1, 'SR', NULL, NULL, NULL),
(4725, '2016-08-06 13:57:30', NULL, NULL, 1702, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 13:57:30', 'sanni-1470459027-14704630498192577', 1, 1, 'SR', NULL, NULL, NULL),
(4726, '2016-08-06 13:57:30', NULL, NULL, 1702, 0, 182, '117', 'Open Drinks ', 'americano', 'Desserts', '0', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 13:57:30', 'sanni-1470459027-14704630498192577', 1, 0, '', NULL, NULL, NULL),
(4727, '2016-08-06 14:10:58', NULL, NULL, 1703, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 14:10:58', 'sanni-1470459027-14704638587638977', 1, 1, 'SR', NULL, NULL, NULL),
(4728, '2016-08-06 14:09:38', NULL, NULL, 1703, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 14:09:38', 'sanni-1470459027-14704637779496551', 1, 0, '', NULL, NULL, NULL),
(4729, '2016-08-06 14:09:47', NULL, NULL, 1703, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 14:09:47', 'sanni-1470459027-14704637873953266', 1, 1, 'SR', NULL, NULL, NULL),
(4730, '2016-08-06 14:09:47', NULL, NULL, 1703, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 14:09:47', 'sanni-1470459027-14704637873953266', 1, 1, 'SR', NULL, NULL, NULL),
(4731, '2016-08-06 20:46:34', NULL, NULL, 1721, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 20:46:34', 'sanni-1470465155-14704875948367378', 1, 0, '', NULL, NULL, NULL),
(4732, '2016-08-06 20:14:21', NULL, NULL, 1720, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 20:14:21', 'sanni-1470465155-1470485661139815', 1, 1, 'SR', NULL, NULL, NULL),
(4733, '2016-08-06 20:14:11', NULL, NULL, 1720, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 20:14:11', 'sanni-1470465155-1470485651657972', 1, 1, 'SR', NULL, NULL, NULL),
(4734, '2016-08-06 20:08:33', NULL, NULL, 1719, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 20:08:33', 'sanni-1470465155-1470485312801738', 1, 1, 'SR', NULL, NULL, NULL),
(4735, '2016-08-06 20:08:33', NULL, NULL, 1719, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 20:08:33', 'sanni-1470465155-1470485312801738', 1, 1, 'SR', NULL, NULL, NULL),
(4736, '2016-08-06 20:08:32', NULL, NULL, 1719, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 20:08:33', 'sanni-1470465155-1470485312801738', 1, 1, 'SR', NULL, NULL, NULL),
(4737, '2016-08-06 19:54:39', NULL, NULL, 1718, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 19:54:39', 'sanni-1470465155-14704844792849378', 1, 0, '', NULL, NULL, NULL),
(4738, '2016-08-06 15:23:44', NULL, NULL, 1707, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 15:23:44', 'sanni-1470465155-14704682245593226', 1, 1, 'SR', NULL, NULL, NULL),
(4739, '2016-08-06 15:23:44', NULL, NULL, 1707, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 15:23:44', 'sanni-1470465155-14704682245593226', 1, 1, 'SR', NULL, NULL, NULL),
(4740, '2016-08-06 15:00:52', NULL, NULL, 1706, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 15:00:52', 'sanni-1470465155-14704668522725134', 1, 0, '', NULL, NULL, NULL),
(4741, '2016-08-06 15:00:52', NULL, NULL, 1706, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 15:00:52', 'sanni-1470465155-14704668522725134', 1, 0, '', NULL, NULL, NULL),
(4742, '2016-08-06 15:00:52', NULL, NULL, 1706, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 15:00:52', 'sanni-1470465155-14704668522725134', 1, 1, 'SR', NULL, NULL, NULL),
(4743, '2016-08-06 15:00:52', NULL, NULL, 1706, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 15:00:52', 'sanni-1470465155-14704668522725134', 1, 1, 'SR', NULL, NULL, NULL),
(4744, '2016-08-06 15:25:33', NULL, NULL, 1706, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 15:25:33', 'sanni-1470465155-14704683337389365', 1, 0, '', NULL, NULL, NULL),
(4745, '2016-08-06 15:00:52', NULL, NULL, 1706, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 15:00:52', 'sanni-1470465155-14704668522725134', 1, 0, '', NULL, NULL, NULL),
(4746, '2016-08-06 14:32:12', NULL, NULL, 1705, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 14:32:12', 'sanni-1470459027-1470465132302330', 1, 1, 'SR', NULL, NULL, NULL),
(4747, '2016-08-06 14:32:12', NULL, NULL, 1705, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 14:32:12', 'sanni-1470459027-1470465132302330', 1, 1, 'SR', NULL, NULL, NULL),
(4748, '2016-08-06 14:32:12', NULL, NULL, 1705, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 14:32:12', 'sanni-1470459027-1470465132302330', 1, 1, 'SR', NULL, NULL, NULL),
(4749, '2016-08-06 14:13:03', NULL, NULL, 1688, 0, 181, '116', 'Open Food ', 'Lotus Root', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 14:13:03', 'sanni-1470459027-14704639836884065', 1, 0, '', NULL, NULL, NULL),
(4750, '2016-08-06 14:25:10', NULL, NULL, 1704, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 14:25:10', 'sanni-1470459027-14704647101718092', 1, 1, 'SR', NULL, NULL, NULL),
(4751, '2016-08-06 13:16:35', NULL, NULL, 1700, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 13:16:35', 'sanni-1470459027-14704605957896277', 1, 0, '', 1, NULL, NULL),
(4752, '2016-08-06 13:16:35', NULL, NULL, 1700, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 13:16:35', 'sanni-1470459027-14704605957896277', 1, 0, '', 1, NULL, NULL),
(4753, '2016-08-06 14:13:03', NULL, NULL, 1688, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 14:13:03', 'sanni-1470459027-14704639836884065', 1, 1, 'SR', NULL, NULL, NULL),
(4754, '2016-08-06 13:22:37', NULL, NULL, 1688, 0, 182, '117', 'Open Drinks ', 'tea', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 13:22:37', 'sanni-1470459027-14704609576559637', 1, 0, '', NULL, NULL, NULL),
(4755, '2016-08-06 13:56:20', NULL, NULL, 1702, 0, 181, '116', 'Open Food ', 'Steam Fish', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 13:56:20', 'sanni-1470459027-14704629803667513', 1, 0, '', NULL, NULL, NULL),
(4756, '2016-08-06 12:44:17', NULL, NULL, 1696, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 12:44:17', 'admin-1470451466-14704586577276899', 1, 1, 'SR', NULL, NULL, NULL),
(4757, '2016-08-06 12:44:17', NULL, NULL, 1696, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 12:44:17', 'admin-1470451466-14704586577276899', 1, 0, '', NULL, NULL, NULL),
(4758, '2016-08-06 12:46:50', NULL, NULL, 1697, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 12:46:50', 'admin-1470451466-14704588104778393', 1, 1, 'SR', NULL, NULL, NULL),
(4759, '2016-08-06 12:50:17', NULL, NULL, 1698, 0, 83, '83', 'Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 12:50:17', 'admin-1470451466-14704590168855268', 1, 1, 'SR', NULL, NULL, NULL),
(4760, '2016-08-06 12:50:17', NULL, NULL, 1698, 0, 182, '117', 'Open Drinks ', 'americano', 'Desserts', '0', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 12:50:17', 'admin-1470451466-14704590168855268', 1, 0, '', NULL, NULL, NULL),
(4761, '2016-08-06 12:50:17', NULL, NULL, 1698, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 12:50:17', 'admin-1470451466-14704590168855268', 1, 1, 'SR', NULL, NULL, NULL),
(4762, '2016-08-06 13:07:34', NULL, NULL, 1699, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 13:07:34', 'sanni-1470459027-14704600540762318', 1, 0, '', NULL, NULL, NULL),
(4763, '2016-08-06 13:10:47', NULL, NULL, 1697, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 13:10:47', 'sanni-1470459027-1470460247322935', 1, 0, '', NULL, NULL, NULL),
(4764, '2016-08-06 13:10:47', NULL, NULL, 1697, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 13:10:47', 'sanni-1470459027-1470460247322935', 1, 1, 'SR', NULL, NULL, NULL),
(4765, '2016-08-06 10:28:52', NULL, NULL, 1682, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:28:52', 'sanni-1470450107-14704505323089412', 1, 1, 'SR', NULL, NULL, NULL),
(4766, '2016-08-06 10:40:18', NULL, NULL, 1683, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:40:18', 'sanni-1470450107-14704512182409857', 1, 0, '', NULL, NULL, NULL),
(4767, '2016-08-06 10:40:18', NULL, NULL, 1683, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:40:18', 'sanni-1470450107-14704512182409857', 1, 0, '', NULL, NULL, NULL),
(4768, '2016-08-06 10:40:18', NULL, NULL, 1683, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:40:18', 'sanni-1470450107-14704512182409857', 1, 0, '', NULL, NULL, NULL),
(4769, '2016-08-06 10:40:18', NULL, NULL, 1683, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:40:18', 'sanni-1470450107-14704512182409857', 1, 1, 'SR', NULL, NULL, NULL),
(4770, '2016-08-06 10:40:18', NULL, NULL, 1683, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:40:18', 'sanni-1470450107-14704512182409857', 1, 0, '', NULL, NULL, NULL),
(4771, '2016-08-06 10:40:18', NULL, NULL, 1683, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:40:18', 'sanni-1470450107-14704512182409857', 1, 1, 'SR', NULL, NULL, NULL),
(4772, '2016-08-06 10:40:18', NULL, NULL, 1683, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:40:18', 'sanni-1470450107-14704512182409857', 1, 0, '', NULL, NULL, NULL),
(4773, '2016-08-06 13:17:24', NULL, NULL, 1701, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 13:17:24', 'sanni-1470459027-14704606445992785', 1, 1, 'SR', NULL, NULL, NULL),
(4774, '2016-08-06 13:17:24', NULL, NULL, 1701, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 13:17:24', 'sanni-1470459027-14704606445992785', 1, 0, '', NULL, NULL, NULL),
(4775, '2016-08-06 13:17:24', NULL, NULL, 1701, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 13:17:24', 'sanni-1470459027-14704606445992785', 1, 0, '', NULL, NULL, NULL),
(4776, '2016-08-06 11:50:27', NULL, NULL, 1690, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 11:50:28', 'admin-1470451466-14704554278301597', 1, 1, 'SR', NULL, NULL, NULL),
(4777, '2016-08-06 14:13:03', NULL, NULL, 1688, 0, 181, '116', 'Open Food ', 'Steam Fish', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 14:13:03', 'sanni-1470459027-14704639836884065', 1, 0, '', NULL, NULL, NULL),
(4778, '2016-08-06 13:17:24', NULL, NULL, 1701, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 13:17:24', 'sanni-1470459027-14704606445992785', 1, 0, '', NULL, NULL, NULL),
(4779, '2016-08-06 12:44:17', NULL, NULL, 1696, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 12:44:17', 'admin-1470451466-14704586577276899', 1, 1, 'SR', NULL, NULL, NULL),
(4780, '2016-08-06 12:44:17', NULL, NULL, 1696, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 12:44:17', 'admin-1470451466-14704586577276899', 1, 0, '', NULL, NULL, NULL),
(4781, '2016-08-06 12:38:26', NULL, NULL, 1694, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 12:38:26', 'admin-1470451466-14704583061814295', 1, 1, 'SR', NULL, NULL, NULL),
(4782, '2016-08-06 12:38:26', NULL, NULL, 1694, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 12:38:26', 'admin-1470451466-14704583061814295', 1, 0, '', NULL, NULL, NULL),
(4783, '2016-08-06 12:39:15', NULL, NULL, 1695, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 12:39:15', 'admin-1470451466-14704583551449188', 1, 1, 'SR', NULL, NULL, NULL),
(4784, '2016-08-06 12:38:26', NULL, NULL, 1694, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 12:38:26', 'admin-1470451466-14704583061814295', 1, 1, 'SR', NULL, NULL, NULL),
(4785, '2016-08-06 12:34:52', NULL, NULL, 1693, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 12:34:52', 'admin-1470451466-14704580918617017', 1, 1, 'SR', NULL, NULL, NULL),
(4786, '2016-08-06 12:34:52', NULL, NULL, 1693, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 12:34:52', 'admin-1470451466-14704580918617017', 1, 0, '', NULL, NULL, NULL),
(4787, '2016-08-06 12:34:52', NULL, NULL, 1693, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 12:34:52', 'admin-1470451466-14704580918617017', 1, 0, '', NULL, NULL, NULL),
(4788, '2016-08-06 12:26:06', NULL, NULL, 1692, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 12:26:06', 'admin-1470451466-14704575662916759', 1, 0, '', NULL, NULL, NULL),
(4789, '2016-08-06 12:26:06', NULL, NULL, 1692, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 12:26:06', 'admin-1470451466-14704575662916759', 1, 0, '', NULL, NULL, NULL),
(4790, '2016-08-06 12:27:03', NULL, NULL, 1692, 0, 182, '117', 'Open Drinks ', 'tea', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 12:27:03', 'admin-1470451466-14704576235473391', 1, 0, '', NULL, NULL, NULL),
(4791, '2016-08-06 12:34:52', NULL, NULL, 1693, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 12:34:52', 'admin-1470451466-14704580918617017', 1, 1, 'SR', NULL, NULL, NULL),
(4792, '2016-08-06 11:59:09', NULL, NULL, 1691, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 11:59:09', 'admin-1470451466-1470455949119401', 1, 1, 'SR', NULL, NULL, NULL),
(4793, '2016-08-06 11:06:52', NULL, NULL, 1688, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 11:06:52', 'admin-1470451466-14704528126288698', 1, 1, 'SR', NULL, NULL, NULL),
(4794, '2016-08-06 11:06:52', NULL, NULL, 1688, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 11:06:52', 'admin-1470451466-14704528126288698', 1, 1, 'SR', NULL, NULL, NULL),
(4795, '2016-08-06 11:49:38', NULL, NULL, 1689, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 11:49:38', 'admin-1470451466-14704553780599266', 1, 1, 'SR', NULL, NULL, NULL),
(4796, '2016-08-06 11:50:27', NULL, NULL, 1690, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 11:50:27', 'admin-1470451466-14704554278301597', 1, 0, '', NULL, NULL, NULL),
(4797, '2016-08-06 11:06:52', NULL, NULL, 1688, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 11:06:52', 'admin-1470451466-14704528126288698', 1, 0, '', NULL, NULL, NULL),
(4798, '2016-08-06 10:44:20', NULL, NULL, 1686, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:44:20', 'sanni-1470450107-14704514605886075', 1, 1, 'SR', NULL, NULL, NULL),
(4799, '2016-08-06 10:44:20', NULL, NULL, 1686, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:44:20', 'sanni-1470450107-14704514605886075', 1, 1, 'SR', NULL, NULL, NULL),
(4800, '2016-08-06 10:45:30', NULL, NULL, 1687, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 10:45:30', 'admin-1470451466-14704515307095065', 1, 1, 'SR', NULL, NULL, NULL),
(4801, '2016-08-06 11:06:52', NULL, NULL, 1688, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470465155', 'admin', '2016-08-06 11:06:52', 'admin-1470451466-14704528126288698', 1, 0, '', NULL, NULL, NULL),
(4802, '2016-08-06 10:44:20', NULL, NULL, 1686, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:44:20', 'sanni-1470450107-14704514605886075', 1, 0, '', NULL, NULL, NULL),
(4803, '2016-08-06 10:40:18', NULL, NULL, 1683, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:40:18', 'sanni-1470450107-14704512182409857', 1, 1, 'SR', NULL, NULL, NULL),
(4804, '2016-08-06 10:41:05', NULL, NULL, 1684, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:41:05', 'sanni-1470450107-14704512655213877', 1, 1, 'SR', NULL, NULL, NULL),
(4805, '2016-08-06 10:44:20', NULL, NULL, 1686, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:44:20', 'sanni-1470450107-14704514605886075', 1, 0, '', NULL, NULL, NULL),
(4806, '2016-08-06 10:42:06', NULL, NULL, 1685, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:42:06', 'sanni-1470450107-14704513263292882', 1, 0, '', NULL, NULL, NULL),
(4807, '2016-08-06 10:41:05', NULL, NULL, 1684, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:41:05', 'sanni-1470450107-14704512655213877', 1, 1, 'SR', NULL, NULL, NULL),
(4808, '2016-08-06 10:40:18', NULL, NULL, 1683, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:40:18', 'sanni-1470450107-14704512182409857', 1, 1, 'SR', NULL, NULL, NULL),
(4809, '2016-08-06 10:40:18', NULL, NULL, 1683, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:40:18', 'sanni-1470450107-14704512182409857', 1, 1, 'SR', NULL, NULL, NULL),
(4810, '2016-08-06 10:40:18', NULL, NULL, 1683, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:40:18', 'sanni-1470450107-14704512182409857', 1, 0, '', NULL, NULL, NULL),
(4811, '2016-08-06 10:40:18', NULL, NULL, 1683, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:40:18', 'sanni-1470450107-14704512182409857', 1, 1, 'SR', NULL, NULL, NULL),
(4812, '2016-08-06 10:40:18', NULL, NULL, 1683, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:40:18', 'sanni-1470450107-14704512182409857', 1, 0, '', NULL, NULL, NULL),
(4813, '2016-08-06 10:40:18', NULL, NULL, 1683, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:40:18', 'sanni-1470450107-14704512182409857', 1, 1, 'SR', NULL, NULL, NULL),
(4814, '2016-08-06 10:40:18', NULL, NULL, 1683, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:40:18', 'sanni-1470450107-14704512182409857', 1, 0, '', NULL, NULL, NULL),
(4815, '2016-08-06 10:28:52', NULL, NULL, 1682, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:28:52', 'sanni-1470450107-14704505323089412', 1, 1, 'SR', NULL, NULL, NULL),
(4816, '2016-08-06 10:24:55', NULL, NULL, 1681, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:24:55', 'sanni-1470450107-14704502952364685', 1, 1, 'SR', NULL, NULL, NULL),
(4817, '2016-08-06 09:56:36', NULL, NULL, 1674, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 09:56:36', 'sanni-1470446228-14704485958825069', 1, 0, '', NULL, NULL, NULL),
(4818, '2016-08-06 10:14:45', NULL, NULL, 1675, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:14:45', 'sanni-1470446228-1470449685027552', 1, 1, 'SR', NULL, NULL, NULL),
(4819, '2016-08-06 10:14:45', NULL, NULL, 1675, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:14:45', 'sanni-1470446228-1470449685027552', 1, 0, '', NULL, NULL, NULL),
(4820, '2016-08-06 10:14:45', NULL, NULL, 1675, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:14:45', 'sanni-1470446228-1470449685027552', 1, 0, '', NULL, NULL, NULL),
(4821, '2016-08-06 10:14:45', NULL, NULL, 1675, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:14:45', 'sanni-1470446228-1470449685027552', 1, 0, '', NULL, NULL, NULL),
(4822, '2016-08-06 10:15:52', NULL, NULL, 1675, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:15:52', 'sanni-1470446228-1470449752599489', 1, 1, 'SR', NULL, NULL, NULL),
(4823, '2016-08-06 10:17:57', NULL, NULL, 1675, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:17:57', 'sanni-1470446228-14704498776983210', 1, 0, '', NULL, NULL, NULL),
(4824, '2016-08-06 10:20:48', NULL, NULL, 1676, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:20:48', 'sanni-1470446228-1470450048634157', 1, 0, '', NULL, NULL, NULL),
(4825, '2016-08-06 10:20:48', NULL, NULL, 1676, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:20:48', 'sanni-1470446228-1470450048634157', 1, 0, '', NULL, NULL, NULL),
(4826, '2016-08-06 10:21:36', NULL, NULL, 1677, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:21:36', 'sanni-1470446228-14704500959866080', 1, 0, '', NULL, NULL, NULL),
(4827, '2016-08-06 10:21:36', NULL, NULL, 1677, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:21:36', 'sanni-1470446228-14704500959866080', 1, 0, '', NULL, NULL, NULL),
(4828, '2016-08-06 10:21:36', NULL, NULL, 1677, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:21:36', 'sanni-1470446228-14704500959866080', 1, 0, '', NULL, NULL, NULL),
(4829, '2016-08-06 10:21:36', NULL, NULL, 1677, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:21:36', 'sanni-1470446228-14704500959866080', 1, 1, 'SR', NULL, NULL, NULL),
(4830, '2016-08-06 10:22:26', NULL, NULL, 1678, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:22:26', 'sanni-1470450107-14704501464209323', 1, 0, '', NULL, NULL, NULL),
(4831, '2016-08-06 10:22:26', NULL, NULL, 1678, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:22:26', 'sanni-1470450107-14704501464209323', 1, 1, 'SR', NULL, NULL, NULL),
(4832, '2016-08-06 10:23:01', NULL, NULL, 1679, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:23:01', 'sanni-1470450107-1470450181562868', 1, 0, '', NULL, NULL, NULL),
(4833, '2016-08-06 10:23:01', NULL, NULL, 1679, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:23:01', 'sanni-1470450107-1470450181562868', 1, 1, 'SR', NULL, NULL, NULL),
(4834, '2016-08-06 10:23:53', NULL, NULL, 1680, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:23:53', 'sanni-1470450107-14704502332873534', 1, 1, 'SR', NULL, NULL, NULL),
(4835, '2016-08-06 10:24:55', NULL, NULL, 1681, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:24:55', 'sanni-1470450107-14704502952364685', 1, 0, '', NULL, NULL, NULL),
(4836, '2016-08-06 10:24:55', NULL, NULL, 1681, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:24:55', 'sanni-1470450107-14704502952364685', 1, 0, '', NULL, NULL, NULL),
(4837, '2016-08-06 10:24:55', NULL, NULL, 1681, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 10:24:55', 'sanni-1470450107-14704502952364685', 1, 1, 'SR', NULL, NULL, NULL),
(4838, '2016-08-06 09:56:36', NULL, NULL, 1674, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 09:56:36', 'sanni-1470446228-14704485958825069', 1, 0, '', NULL, NULL, NULL),
(4839, '2016-08-06 09:56:36', NULL, NULL, 1674, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 09:56:36', 'sanni-1470446228-14704485958825069', 1, 0, '', NULL, NULL, NULL),
(4840, '2016-08-06 09:41:06', NULL, NULL, 1673, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 09:41:06', 'sanni-1470446228-14704476667795242', 1, 0, '', NULL, NULL, NULL),
(4841, '2016-08-06 09:41:06', NULL, NULL, 1673, 0, 182, '117', 'Open Drinks ', 'tea', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 09:41:06', 'sanni-1470446228-14704476667795242', 1, 0, '', NULL, NULL, NULL),
(4842, '2016-08-06 09:41:06', NULL, NULL, 1673, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470465155', 'sanni', '2016-08-06 09:41:06', 'sanni-1470446228-14704476667795242', 1, 0, '', NULL, NULL, NULL),
(4843, '2016-08-07 18:56:03', NULL, NULL, 1790, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 18:56:03', 'sanni-1470552213-1470567363422743', 1, 1, 'SR', NULL, NULL, NULL),
(4844, '2016-08-07 18:56:03', NULL, NULL, 1790, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 18:56:03', 'sanni-1470552213-1470567363422743', 1, 1, 'SR', NULL, NULL, NULL),
(4845, '2016-08-07 16:44:38', NULL, NULL, 1785, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 16:44:38', 'sanni-1470552213-14705594787412013', 1, 1, 'SR', NULL, NULL, NULL),
(4846, '2016-08-07 17:25:50', NULL, NULL, 1786, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 3, 12.00, 36.0000, 0.0000, 36.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 17:25:50', 'sanni-1470552213-1470561949796491', 1, 1, 'SR', NULL, NULL, NULL),
(4847, '2016-08-07 18:00:30', NULL, NULL, 1787, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 18:00:30', 'sanni-1470552213-1470564030652110', 1, 1, 'SR', NULL, NULL, NULL),
(4848, '2016-08-07 18:16:30', NULL, NULL, 1788, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 18:16:30', 'sanni-1470552213-14705649900915980', 1, 0, '', NULL, NULL, NULL),
(4849, '2016-08-07 18:16:30', NULL, NULL, 1788, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 18:16:30', 'sanni-1470552213-14705649900915980', 1, 1, 'SR', NULL, NULL, NULL),
(4850, '2016-08-07 18:16:30', NULL, NULL, 1788, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 18:16:30', 'sanni-1470552213-14705649900915980', 1, 1, 'SR', NULL, NULL, NULL),
(4851, '2016-08-07 18:46:26', NULL, NULL, 1789, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 18:46:26', 'sanni-1470552213-14705667862543532', 1, 0, '', NULL, NULL, NULL),
(4852, '2016-08-07 18:46:26', NULL, NULL, 1789, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 18:46:26', 'sanni-1470552213-14705667862543532', 1, 1, 'SR', NULL, NULL, NULL),
(4853, '2016-08-07 18:46:26', NULL, NULL, 1789, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 18:46:26', 'sanni-1470552213-14705667862543532', 1, 1, 'SR', NULL, NULL, NULL),
(4854, '2016-08-07 18:46:26', NULL, NULL, 1789, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 18:46:26', 'sanni-1470552213-14705667862543532', 1, 1, 'SR', NULL, NULL, NULL),
(4855, '2016-08-07 16:40:20', NULL, NULL, 1785, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 16:40:20', 'sanni-1470552213-14705592201887197', 1, 1, 'SR', NULL, NULL, NULL),
(4856, '2016-08-07 16:40:20', NULL, NULL, 1785, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 16:40:20', 'sanni-1470552213-14705592201887197', 1, 0, '', NULL, NULL, NULL),
(4857, '2016-08-07 16:39:00', NULL, NULL, 1785, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 16:39:00', 'sanni-1470552213-1470559140804704', 1, 0, '', NULL, NULL, NULL),
(4858, '2016-08-07 16:39:00', NULL, NULL, 1785, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 16:39:00', 'sanni-1470552213-1470559140804704', 1, 0, '', NULL, NULL, NULL),
(4859, '2016-08-07 15:57:25', NULL, NULL, 1784, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 15:57:25', 'sanni-1470552213-14705566453915238', 1, 1, 'SR', NULL, NULL, NULL),
(4860, '2016-08-07 15:54:14', NULL, NULL, 1783, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 15:54:14', 'sanni-1470552213-14705564546372344', 1, 0, '', NULL, NULL, '10.0'),
(4861, '2016-08-07 16:39:00', NULL, NULL, 1785, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 16:39:00', 'sanni-1470552213-1470559140804704', 1, 1, 'SR', NULL, NULL, NULL),
(4862, '2016-08-07 15:54:14', NULL, NULL, 1783, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 15:54:14', 'sanni-1470552213-14705564546372344', 1, 0, '', NULL, NULL, '10.0'),
(4863, '2016-08-07 15:54:14', NULL, NULL, 1783, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 15:54:14', 'sanni-1470552213-14705564546372344', 1, 0, '', NULL, NULL, '10.0'),
(4864, '2016-08-07 15:54:14', NULL, NULL, 1783, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 15:54:14', 'sanni-1470552213-14705564546372344', 1, 1, 'SR', NULL, NULL, '10.0'),
(4865, '2016-08-07 15:54:14', NULL, NULL, 1783, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 15:54:14', 'sanni-1470552213-14705564546372344', 1, 1, 'SR', NULL, NULL, '10.0'),
(4866, '2016-08-07 15:54:14', NULL, NULL, 1783, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 15:54:14', 'sanni-1470552213-14705564546372344', 1, 1, 'SR', NULL, NULL, '10.0'),
(4867, '2016-08-07 15:54:14', NULL, NULL, 1783, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 15:54:14', 'sanni-1470552213-14705564546372344', 1, 1, 'SR', NULL, NULL, '10.0'),
(4868, '2016-08-07 15:54:14', NULL, NULL, 1783, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 15:54:14', 'sanni-1470552213-14705564546372344', 1, 1, 'SR', NULL, NULL, '10.0'),
(4869, '2016-08-07 15:54:14', NULL, NULL, 1783, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 15:54:14', 'sanni-1470552213-14705564546372344', 1, 1, 'SR', NULL, NULL, '10.0'),
(4870, '2016-08-07 15:54:14', NULL, NULL, 1783, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 15:54:14', 'sanni-1470552213-14705564546372344', 1, 1, 'SR', NULL, NULL, '10.0');
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(4871, '2016-08-07 15:41:09', NULL, NULL, 1782, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 15:41:09', 'sanni-1470552213-14705556691296610', 1, 1, 'SR', NULL, NULL, NULL),
(4872, '2016-08-07 15:41:09', NULL, NULL, 1782, NULL, 65, '65', 'Pineapple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 15:41:09', 'sanni-1470552213-14705556691296610', 1, 1, 'SR', NULL, NULL, NULL),
(4873, '2016-08-07 15:40:46', NULL, NULL, 1782, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 15:40:46', 'sanni-1470552213-14705556466355080', 1, 0, '', NULL, NULL, NULL),
(4874, '2016-08-07 15:40:46', NULL, NULL, 1782, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 15:40:46', 'sanni-1470552213-14705556466355080', 1, 1, 'SR', NULL, NULL, NULL),
(4875, '2016-08-07 15:40:46', NULL, NULL, 1782, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 15:40:46', 'sanni-1470552213-14705556466355080', 1, 1, 'SR', NULL, NULL, NULL),
(4876, '2016-08-07 15:00:42', NULL, NULL, 1781, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 15:00:42', 'sanni-1470552213-1470553242120926', 1, 1, 'SR', NULL, NULL, NULL),
(4877, '2016-08-07 15:00:18', NULL, NULL, 1781, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 15:00:18', 'sanni-1470552213-14705532178928665', 1, 1, 'SR', NULL, NULL, NULL),
(4878, '2016-08-07 15:00:18', NULL, NULL, 1781, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 15:00:18', 'sanni-1470552213-14705532178928665', 1, 1, 'SR', NULL, NULL, NULL),
(4879, '2016-08-07 14:58:54', NULL, NULL, 1781, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 14:58:54', 'sanni-1470552213-14705531343769218', 1, 0, '', NULL, NULL, NULL),
(4880, '2016-08-07 14:58:54', NULL, NULL, 1781, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 14:58:54', 'sanni-1470552213-14705531343769218', 1, 0, '', NULL, NULL, NULL),
(4881, '2016-08-07 14:43:18', NULL, NULL, 1780, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 14:43:18', 'sanni-1470546490-14705521979491617', 1, 0, '', NULL, NULL, NULL),
(4882, '2016-08-07 13:07:56', NULL, NULL, 1774, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 13:07:56', 'sanni-1470541587-1470546475848883', 1, 1, 'SR', NULL, NULL, NULL),
(4883, '2016-08-07 13:07:56', NULL, NULL, 1774, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 13:07:56', 'sanni-1470541587-1470546475848883', 1, 0, '', NULL, NULL, NULL),
(4884, '2016-08-07 13:07:56', NULL, NULL, 1774, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 13:07:56', 'sanni-1470541587-1470546475848883', 1, 0, '', NULL, NULL, NULL),
(4885, '2016-08-07 13:24:15', NULL, NULL, 1775, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 13:24:15', 'sanni-1470546490-14705474547952135', 1, 1, 'SR', NULL, NULL, NULL),
(4886, '2016-08-07 13:24:15', NULL, NULL, 1775, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 13:24:15', 'sanni-1470546490-14705474547952135', 1, 1, 'SR', NULL, NULL, NULL),
(4887, '2016-08-07 13:57:08', NULL, NULL, 1776, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 13:57:08', 'sanni-1470546490-14705494280674376', 1, 0, '', NULL, NULL, NULL),
(4888, '2016-08-07 13:57:08', NULL, NULL, 1776, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 13:57:08', 'sanni-1470546490-14705494280674376', 1, 0, '', NULL, NULL, NULL),
(4889, '2016-08-07 13:07:56', NULL, NULL, 1774, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 13:07:56', 'sanni-1470541587-1470546475848883', 1, 0, '', NULL, NULL, NULL),
(4890, '2016-08-07 13:07:56', NULL, NULL, 1774, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 13:07:56', 'sanni-1470541587-1470546475848883', 1, 0, '', NULL, NULL, NULL),
(4891, '2016-08-07 13:07:56', NULL, NULL, 1774, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 13:07:56', 'sanni-1470541587-1470546475848883', 1, 1, 'SR', NULL, NULL, NULL),
(4892, '2016-08-07 13:07:56', NULL, NULL, 1774, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 13:07:56', 'sanni-1470541587-1470546475848883', 1, 1, 'SR', NULL, NULL, NULL),
(4893, '2016-08-07 12:59:47', NULL, NULL, 1773, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 12:59:47', 'sanni-1470541587-14705459869593912', 1, 1, 'SR', NULL, NULL, NULL),
(4894, '2016-08-07 12:50:36', NULL, NULL, 1772, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 12:50:36', 'sanni-1470541587-14705454359696669', 1, 1, 'SR', NULL, NULL, NULL),
(4895, '2016-08-07 12:36:29', NULL, NULL, 1771, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 12:36:29', 'sanni-1470541587-14705445894311970', 1, 0, '', NULL, NULL, NULL),
(4896, '2016-08-07 12:36:29', NULL, NULL, 1771, 0, 83, '83', 'Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 12:36:29', 'sanni-1470541587-14705445894311970', 1, 1, 'SR', NULL, NULL, NULL),
(4897, '2016-08-07 11:59:31', NULL, NULL, 1765, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:59:31', 'sanni-1470541587-14705423713919848', 1, 1, 'SR', NULL, NULL, NULL),
(4898, '2016-08-07 12:01:18', NULL, NULL, 1766, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 12:01:18', 'sanni-1470541587-14705424779577475', 1, 1, 'SR', NULL, NULL, NULL),
(4899, '2016-08-07 12:04:30', NULL, NULL, 1767, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 12:04:30', 'sanni-1470541587-1470542670620334', 1, 1, 'SR', NULL, NULL, NULL),
(4900, '2016-08-07 12:04:30', NULL, NULL, 1767, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 12:04:30', 'sanni-1470541587-1470542670620334', 1, 1, 'SR', NULL, NULL, NULL),
(4901, '2016-08-07 12:19:51', NULL, NULL, 1768, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 12:19:51', 'sanni-1470541587-14705435914697233', 1, 1, 'SR', NULL, NULL, NULL),
(4902, '2016-08-07 12:19:51', NULL, NULL, 1768, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 12:19:51', 'sanni-1470541587-14705435914697233', 1, 1, 'SR', NULL, NULL, NULL),
(4903, '2016-08-07 12:30:37', NULL, NULL, 1769, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 12:30:37', 'sanni-1470541587-14705442368584597', 1, 1, 'SR', NULL, NULL, NULL),
(4904, '2016-08-07 12:32:51', NULL, NULL, 1770, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 12:32:51', 'sanni-1470541587-14705443715297369', 1, 1, 'SR', NULL, NULL, NULL),
(4905, '2016-08-07 12:32:51', NULL, NULL, 1770, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 12:32:51', 'sanni-1470541587-14705443715297369', 1, 1, 'SR', NULL, NULL, NULL),
(4906, '2016-08-07 11:22:31', NULL, NULL, 1752, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:22:31', 'sanni-1470540083-14705401511903044', 1, 1, 'SR', NULL, NULL, NULL),
(4907, '2016-08-07 11:25:59', NULL, NULL, 1753, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:25:59', 'sanni-1470540083-14705403595108287', 1, 1, 'SR', NULL, NULL, NULL),
(4908, '2016-08-07 11:26:06', NULL, NULL, 1753, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:26:06', 'sanni-1470540083-14705403660068377', 1, 0, '', NULL, NULL, NULL),
(4909, '2016-08-07 11:26:50', NULL, NULL, 1754, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:26:50', 'sanni-1470540083-1470540410582450', 1, 1, 'SR', NULL, NULL, NULL),
(4910, '2016-08-07 11:26:50', NULL, NULL, 1754, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:26:50', 'sanni-1470540083-1470540410582450', 1, 1, 'SR', NULL, NULL, NULL),
(4911, '2016-08-07 11:26:50', NULL, NULL, 1754, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:26:50', 'sanni-1470540083-1470540410582450', 1, 0, '', NULL, NULL, NULL),
(4912, '2016-08-07 11:26:50', NULL, NULL, 1754, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:26:50', 'sanni-1470540083-1470540410582450', 1, 0, '', NULL, NULL, NULL),
(4913, '2016-08-07 11:27:24', NULL, NULL, 1755, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:27:24', 'sanni-1470540083-1470540444507209', 1, 0, '', NULL, NULL, NULL),
(4914, '2016-08-07 11:27:24', NULL, NULL, 1755, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:27:24', 'sanni-1470540083-1470540444507209', 1, 1, 'SR', NULL, NULL, NULL),
(4915, '2016-08-07 11:27:32', NULL, NULL, 1755, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:27:32', 'sanni-1470540083-14705404519469870', 1, 1, 'SR', NULL, NULL, NULL),
(4916, '2016-08-07 11:59:31', NULL, NULL, 1765, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:59:31', 'sanni-1470541587-14705423713919848', 1, 0, '', NULL, NULL, NULL),
(4917, '2016-08-07 11:57:56', NULL, NULL, 1764, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:57:56', 'sanni-1470541587-14705422762437675', 1, 0, '', NULL, NULL, NULL),
(4918, '2016-08-07 11:57:56', NULL, NULL, 1764, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:57:56', 'sanni-1470541587-14705422762437675', 1, 0, '', NULL, NULL, NULL),
(4919, '2016-08-07 11:51:44', NULL, NULL, 1763, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:51:44', 'sanni-1470541587-14705419044096093', 1, 1, 'SR', NULL, NULL, NULL),
(4920, '2016-08-07 11:49:10', NULL, NULL, 1762, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:49:10', 'sanni-1470541587-14705417499376727', 1, 1, 'SR', NULL, NULL, NULL),
(4921, '2016-08-07 11:49:10', NULL, NULL, 1762, 0, 156, '90', 'Cheese Omelet', 'add 2 eggs', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:49:10', 'sanni-1470541587-14705417499376727', 1, 0, '', NULL, NULL, NULL),
(4922, '2016-08-07 11:47:21', NULL, NULL, 1761, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:47:21', 'sanni-1470541587-1470541640819408', 1, 1, 'SR', NULL, NULL, NULL),
(4923, '2016-08-07 11:47:21', NULL, NULL, 1761, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:47:21', 'sanni-1470541587-1470541640819408', 1, 0, '', NULL, NULL, NULL),
(4924, '2016-08-07 11:45:41', NULL, NULL, 1760, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'admin', '2016-08-07 11:45:41', 'admin-1470541411-14705415413657846', 1, 1, 'SR', NULL, NULL, NULL),
(4925, '2016-08-07 11:02:51', NULL, NULL, 1747, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:02:51', 'sanni-1470536308-14705389717413829', 1, 1, 'SR', NULL, NULL, NULL),
(4926, '2016-08-07 11:02:51', NULL, NULL, 1747, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:02:51', 'sanni-1470536308-14705389717413829', 1, 1, 'SR', NULL, NULL, NULL),
(4927, '2016-08-07 11:02:51', NULL, NULL, 1747, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:02:51', 'sanni-1470536308-14705389717413829', 1, 1, 'SR', NULL, NULL, NULL),
(4928, '2016-08-07 11:06:59', NULL, NULL, 1748, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:06:59', 'sanni-1470536308-14705392189159618', 1, 1, 'SR', NULL, NULL, NULL),
(4929, '2016-08-07 11:14:30', NULL, NULL, 1749, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:14:30', 'sanni-1470536308-14705396705637710', 1, 0, '', NULL, NULL, NULL),
(4930, '2016-08-07 11:14:30', NULL, NULL, 1749, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:14:30', 'sanni-1470536308-14705396705637710', 1, 1, 'SR', NULL, NULL, NULL),
(4931, '2016-08-07 11:14:30', NULL, NULL, 1749, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:14:30', 'sanni-1470536308-14705396705637710', 1, 1, 'SR', NULL, NULL, NULL),
(4932, '2016-08-07 14:26:26', NULL, NULL, 1779, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 14:26:26', 'sanni-1470546490-14705511866627797', 1, 1, 'SR', NULL, NULL, NULL),
(4933, '2016-08-07 14:26:26', NULL, NULL, 1779, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 14:26:26', 'sanni-1470546490-14705511866627797', 1, 0, '', NULL, NULL, NULL),
(4934, '2016-08-07 14:26:26', NULL, NULL, 1779, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 14:26:26', 'sanni-1470546490-14705511866627797', 1, 1, 'SR', NULL, NULL, NULL),
(4935, '2016-08-07 13:57:08', NULL, NULL, 1776, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 13:57:08', 'sanni-1470546490-14705494280674376', 1, 1, 'SR', NULL, NULL, NULL),
(4936, '2016-08-07 14:06:46', NULL, NULL, 1777, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 14:06:46', 'sanni-1470546490-14705500062888710', 1, 1, 'SR', NULL, NULL, NULL),
(4937, '2016-08-07 14:06:46', NULL, NULL, 1777, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 14:06:46', 'sanni-1470546490-14705500062888710', 1, 1, 'SR', NULL, NULL, NULL),
(4938, '2016-08-07 14:17:03', NULL, NULL, 1778, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 14:17:03', 'sanni-1470546490-14705506229927687', 1, 1, 'SR', NULL, NULL, NULL),
(4939, '2016-08-07 12:59:47', NULL, NULL, 1773, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 12:59:47', 'sanni-1470541587-14705459869593912', 1, 1, 'SR', NULL, NULL, NULL),
(4940, '2016-08-07 12:59:47', NULL, NULL, 1773, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 12:59:47', 'sanni-1470541587-14705459869593912', 1, 0, '', NULL, NULL, NULL),
(4941, '2016-08-07 11:45:41', NULL, NULL, 1760, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'admin', '2016-08-07 11:45:41', 'admin-1470541411-14705415413657846', 1, 1, 'SR', NULL, NULL, NULL),
(4942, '2016-08-07 11:45:41', NULL, NULL, 1760, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470552213', 'admin', '2016-08-07 11:45:41', 'admin-1470541411-14705415413657846', 1, 0, '', NULL, NULL, NULL),
(4943, '2016-08-07 11:44:45', NULL, NULL, 1759, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470552213', 'admin', '2016-08-07 11:44:45', 'admin-1470541411-14705414853955143', 1, 1, 'SR', NULL, NULL, NULL),
(4944, '2016-08-07 11:45:41', NULL, NULL, 1760, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'admin', '2016-08-07 11:45:41', 'admin-1470541411-14705415413657846', 1, 0, '', NULL, NULL, NULL),
(4945, '2016-08-07 11:44:45', NULL, NULL, 1759, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'admin', '2016-08-07 11:44:45', 'admin-1470541411-14705414853955143', 1, 0, '', NULL, NULL, NULL),
(4946, '2016-08-07 11:44:45', NULL, NULL, 1759, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'admin', '2016-08-07 11:44:45', 'admin-1470541411-14705414853955143', 1, 0, '', NULL, NULL, NULL),
(4947, '2016-08-07 11:44:45', NULL, NULL, 1759, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'admin', '2016-08-07 11:44:45', 'admin-1470541411-14705414853955143', 1, 0, '', NULL, NULL, NULL),
(4948, '2016-08-07 11:43:22', NULL, NULL, 1758, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:43:22', 'sanni-1470540083-14705414026179531', 1, 0, '', NULL, NULL, NULL),
(4949, '2016-08-07 11:43:22', NULL, NULL, 1758, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:43:22', 'sanni-1470540083-14705414026179531', 1, 1, 'SR', NULL, NULL, NULL),
(4950, '2016-08-07 11:43:22', NULL, NULL, 1758, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:43:22', 'sanni-1470540083-14705414026179531', 1, 0, '', NULL, NULL, NULL),
(4951, '2016-08-07 11:43:22', NULL, NULL, 1758, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:43:22', 'sanni-1470540083-14705414026179531', 1, 1, 'SR', NULL, NULL, NULL),
(4952, '2016-08-07 11:42:44', NULL, NULL, 1758, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:42:44', 'sanni-1470540083-14705413645199866', 1, 1, 'SR', NULL, NULL, NULL),
(4953, '2016-08-07 11:42:44', NULL, NULL, 1758, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:42:44', 'sanni-1470540083-14705413645199866', 1, 0, '', NULL, NULL, NULL),
(4954, '2016-08-07 11:31:04', NULL, NULL, 1757, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:31:04', 'sanni-1470540083-14705406641894183', 1, 1, 'SR', NULL, NULL, NULL),
(4955, '2016-08-07 11:18:45', NULL, NULL, 1751, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:18:45', 'sanni-1470539688-14705399250103530', 1, 1, 'SR', NULL, NULL, NULL),
(4956, '2016-08-07 11:28:28', NULL, NULL, 1756, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:28:28', 'sanni-1470540083-14705405084841718', 1, 0, '', NULL, NULL, NULL),
(4957, '2016-08-07 11:31:04', NULL, NULL, 1757, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:31:04', 'sanni-1470540083-14705406641894183', 1, 0, '', NULL, NULL, NULL),
(4958, '2016-08-07 11:18:45', NULL, NULL, 1751, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:18:45', 'sanni-1470539688-14705399250103530', 1, 1, 'SR', NULL, NULL, NULL),
(4959, '2016-08-07 11:18:45', NULL, NULL, 1751, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:18:45', 'sanni-1470539688-14705399250103530', 1, 1, 'SR', NULL, NULL, NULL),
(4960, '2016-08-07 11:18:45', NULL, NULL, 1751, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:18:45', 'sanni-1470539688-14705399250103530', 1, 1, 'SR', NULL, NULL, NULL),
(4961, '2016-08-07 10:44:09', NULL, NULL, 1744, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:44:09', 'sanni-1470536308-14705378490875130', 1, 1, 'SR', NULL, NULL, NULL),
(4962, '2016-08-07 10:44:09', NULL, NULL, 1744, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:44:09', 'sanni-1470536308-14705378490875130', 1, 1, 'SR', NULL, NULL, NULL),
(4963, '2016-08-07 10:56:10', NULL, NULL, 1745, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:56:10', 'sanni-1470536308-1470538570157227', 1, 1, 'SR', NULL, NULL, NULL),
(4964, '2016-08-07 11:18:45', NULL, NULL, 1751, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:18:45', 'sanni-1470539688-14705399250103530', 1, 0, '', NULL, NULL, NULL),
(4965, '2016-08-07 11:18:45', NULL, NULL, 1751, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:18:45', 'sanni-1470539688-14705399250103530', 1, 0, '', NULL, NULL, NULL),
(4966, '2016-08-07 11:15:22', NULL, NULL, 1750, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:15:22', 'sanni-1470539688-14705397220333493', 1, 1, 'SR', NULL, NULL, NULL),
(4967, '2016-08-07 11:18:45', NULL, NULL, 1751, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:18:45', 'sanni-1470539688-14705399250103530', 1, 0, '', NULL, NULL, NULL),
(4968, '2016-08-07 12:59:47', NULL, NULL, 1773, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 12:59:47', 'sanni-1470541587-14705459869593912', 1, 1, 'SR', NULL, NULL, NULL),
(4969, '2016-08-07 10:56:10', NULL, NULL, 1745, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:56:10', 'sanni-1470536308-1470538570157227', 1, 1, 'SR', NULL, NULL, NULL),
(4970, '2016-08-07 11:02:00', NULL, NULL, 1746, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 11:02:00', 'sanni-1470536308-14705389206774568', 1, 1, 'SR', NULL, NULL, NULL),
(4971, '2016-08-07 10:32:30', NULL, NULL, 1742, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:32:30', 'sanni-1470536308-1470537150634351', 1, 1, 'SR', NULL, NULL, NULL),
(4972, '2016-08-07 10:34:13', NULL, NULL, 1743, 0, 156, '90', 'Cheese Omelet', 'bacon', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:34:13', 'sanni-1470536308-14705372530862980', 1, 0, '', NULL, NULL, NULL),
(4973, '2016-08-07 10:34:13', NULL, NULL, 1743, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:34:13', 'sanni-1470536308-14705372530862980', 1, 0, '', NULL, NULL, NULL),
(4974, '2016-08-07 10:34:13', NULL, NULL, 1743, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:34:13', 'sanni-1470536308-14705372530862980', 1, 1, 'SR', NULL, NULL, NULL),
(4975, '2016-08-07 10:34:13', NULL, NULL, 1743, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:34:13', 'sanni-1470536308-14705372530862980', 1, 1, 'SR', NULL, NULL, NULL),
(4976, '2016-08-07 10:44:09', NULL, NULL, 1744, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:44:09', 'sanni-1470536308-14705378490875130', 1, 0, '', NULL, NULL, NULL),
(4977, '2016-08-07 10:44:09', NULL, NULL, 1744, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:44:09', 'sanni-1470536308-14705378490875130', 1, 0, '', NULL, NULL, NULL),
(4978, '2016-08-07 10:44:09', NULL, NULL, 1744, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:44:09', 'sanni-1470536308-14705378490875130', 1, 0, '', NULL, NULL, NULL),
(4979, '2016-08-07 10:44:09', NULL, NULL, 1744, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:44:09', 'sanni-1470536308-14705378490875130', 1, 0, '', NULL, NULL, NULL),
(4980, '2016-08-07 10:44:09', NULL, NULL, 1744, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:44:09', 'sanni-1470536308-14705378490875130', 1, 1, 'SR', NULL, NULL, NULL),
(4981, '2016-08-07 09:25:12', NULL, NULL, 1731, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:25:12', 'sanni-1470532862-1470533111904805', 1, 1, 'SR', NULL, NULL, NULL),
(4982, '2016-08-07 09:25:12', NULL, NULL, 1731, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:25:12', 'sanni-1470532862-1470533111904805', 1, 1, 'SR', NULL, NULL, NULL),
(4983, '2016-08-07 09:25:12', NULL, NULL, 1731, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:25:12', 'sanni-1470532862-1470533111904805', 1, 1, 'SR', NULL, NULL, NULL),
(4984, '2016-08-07 09:25:12', NULL, NULL, 1731, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:25:12', 'sanni-1470532862-1470533111904805', 1, 1, 'SR', NULL, NULL, NULL),
(4985, '2016-08-07 09:25:12', NULL, NULL, 1731, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:25:12', 'sanni-1470532862-1470533111904805', 1, 1, 'SR', NULL, NULL, NULL),
(4986, '2016-08-07 09:42:48', NULL, NULL, 1732, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:42:48', 'sanni-1470532862-14705341688345885', 1, 0, '', NULL, NULL, NULL),
(4987, '2016-08-07 09:42:48', NULL, NULL, 1732, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:42:48', 'sanni-1470532862-14705341688345885', 1, 0, '', NULL, NULL, NULL),
(4988, '2016-08-07 09:43:20', NULL, NULL, 1732, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:43:20', 'sanni-1470532862-14705342005124038', 1, 0, '', NULL, NULL, NULL),
(4989, '2016-08-07 09:45:06', NULL, NULL, 1733, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:45:06', 'sanni-1470532862-14705343067157056', 1, 0, '', NULL, NULL, '10.0'),
(4990, '2016-08-07 09:45:06', NULL, NULL, 1733, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:45:06', 'sanni-1470532862-14705343067157056', 1, 0, '', NULL, NULL, '10.0'),
(4991, '2016-08-07 09:45:06', NULL, NULL, 1733, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:45:06', 'sanni-1470532862-14705343067157056', 1, 0, '', NULL, NULL, '10.0'),
(4992, '2016-08-07 09:45:06', NULL, NULL, 1733, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:45:06', 'sanni-1470532862-14705343067157056', 1, 0, '', NULL, NULL, '10.0'),
(4993, '2016-08-07 09:45:06', NULL, NULL, 1733, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:45:06', 'sanni-1470532862-14705343067157056', 1, 1, 'SR', NULL, NULL, '10.0'),
(4994, '2016-08-07 09:45:06', NULL, NULL, 1733, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:45:06', 'sanni-1470532862-14705343067157056', 1, 1, 'SR', NULL, NULL, '10.0'),
(4995, '2016-08-07 10:32:30', NULL, NULL, 1742, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:32:30', 'sanni-1470536308-1470537150634351', 1, 0, '', NULL, NULL, NULL),
(4996, '2016-08-07 13:57:08', NULL, NULL, 1776, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 13:57:08', 'sanni-1470546490-14705494280674376', 1, 1, 'SR', NULL, NULL, NULL),
(4997, '2016-08-07 10:23:01', NULL, NULL, 1739, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:23:01', 'sanni-1470536308-14705365814277237', 1, 1, 'SR', NULL, NULL, NULL),
(4998, '2016-08-07 10:26:45', NULL, NULL, 1740, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:26:45', 'sanni-1470536308-14705368054193899', 1, 0, '', NULL, NULL, NULL),
(4999, '2016-08-07 10:26:45', NULL, NULL, 1740, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:26:45', 'sanni-1470536308-14705368054193899', 1, 1, 'SR', NULL, NULL, NULL),
(5000, '2016-08-07 10:27:25', NULL, NULL, 1741, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:27:25', 'sanni-1470536308-1470536845556639', 1, 0, '', NULL, NULL, NULL),
(5001, '2016-08-07 10:27:25', NULL, NULL, 1741, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:27:25', 'sanni-1470536308-1470536845556639', 1, 1, 'SR', NULL, NULL, NULL),
(5002, '2016-08-07 10:22:08', NULL, NULL, 1738, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:22:08', 'sanni-1470536308-14705365285379311', 1, 1, 'SR', NULL, NULL, NULL),
(5003, '2016-08-07 10:23:01', NULL, NULL, 1739, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:23:01', 'sanni-1470536308-14705365814277237', 1, 1, 'SR', NULL, NULL, NULL),
(5004, '2016-08-07 10:23:01', NULL, NULL, 1739, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:23:01', 'sanni-1470536308-14705365814277237', 1, 1, 'SR', NULL, NULL, NULL),
(5005, '2016-08-07 10:18:15', NULL, NULL, 1737, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:18:15', 'sanni-1470535040-1470536295668820', 1, 1, 'SR', NULL, NULL, NULL),
(5006, '2016-08-07 10:18:15', NULL, NULL, 1737, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:18:15', 'sanni-1470535040-1470536295668820', 1, 1, 'SR', NULL, NULL, NULL),
(5007, '2016-08-07 10:22:08', NULL, NULL, 1738, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:22:08', 'sanni-1470536308-14705365285379311', 1, 0, '', NULL, NULL, NULL),
(5008, '2016-08-07 10:22:08', NULL, NULL, 1738, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:22:08', 'sanni-1470536308-14705365285379311', 1, 0, '', NULL, NULL, NULL),
(5009, '2016-08-07 10:22:08', NULL, NULL, 1738, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:22:08', 'sanni-1470536308-14705365285379311', 1, 1, 'SR', NULL, NULL, NULL),
(5010, '2016-08-07 10:18:15', NULL, NULL, 1737, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:18:15', 'sanni-1470535040-1470536295668820', 1, 0, '', NULL, NULL, NULL),
(5011, '2016-08-07 10:10:15', NULL, NULL, 1736, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:10:15', 'sanni-1470535040-14705358156949282', 1, 0, '', NULL, NULL, NULL),
(5012, '2016-08-07 10:10:15', NULL, NULL, 1736, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:10:15', 'sanni-1470535040-14705358156949282', 1, 1, 'SR', NULL, NULL, NULL),
(5013, '2016-08-07 10:10:15', NULL, NULL, 1736, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:10:15', 'sanni-1470535040-14705358156949282', 1, 1, 'SR', NULL, NULL, NULL),
(5014, '2016-08-07 10:09:05', NULL, NULL, 1735, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:09:05', 'sanni-1470535040-14705357455055924', 1, 1, 'SR', NULL, NULL, NULL),
(5015, '2016-08-07 10:08:31', NULL, NULL, 1735, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:08:31', 'sanni-1470535040-14705357107499655', 1, 0, '', NULL, NULL, NULL),
(5016, '2016-08-07 10:10:15', NULL, NULL, 1736, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:10:15', 'sanni-1470535040-14705358156949282', 1, 0, '', NULL, NULL, NULL),
(5017, '2016-08-07 10:08:46', NULL, NULL, 1735, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:08:46', 'sanni-1470535040-14705357262821715', 1, 0, '', NULL, NULL, NULL),
(5018, '2016-08-07 10:08:31', NULL, NULL, 1735, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:08:31', 'sanni-1470535040-14705357107499655', 1, 1, 'SR', NULL, NULL, NULL),
(5019, '2016-08-07 09:58:54', NULL, NULL, 1733, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:58:54', 'sanni-1470535040-1470535133909482', 1, 1, 'SR', NULL, NULL, '10.0'),
(5020, '2016-08-07 10:18:15', NULL, NULL, 1737, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:18:15', 'sanni-1470535040-1470536295668820', 1, 0, '', NULL, NULL, NULL),
(5021, '2016-08-07 10:07:11', NULL, NULL, 1735, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 10:07:11', 'sanni-1470535040-14705356310561568', 1, 0, '', NULL, NULL, NULL),
(5022, '2016-08-07 09:58:54', NULL, NULL, 1733, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:58:54', 'sanni-1470535040-1470535133909482', 1, 0, '', NULL, NULL, '10.0'),
(5023, '2016-08-07 09:58:54', NULL, NULL, 1733, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:58:54', 'sanni-1470535040-1470535133909482', 1, 0, '', NULL, NULL, '10.0'),
(5024, '2016-08-07 09:57:06', NULL, NULL, 1734, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:57:06', 'sanni-1470532862-14705350260037075', 1, 1, 'SR', NULL, NULL, NULL),
(5025, '2016-08-07 09:57:06', NULL, NULL, 1734, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:57:06', 'sanni-1470532862-14705350260037075', 1, 1, 'SR', NULL, NULL, NULL),
(5026, '2016-08-07 09:57:06', NULL, NULL, 1734, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:57:06', 'sanni-1470532862-14705350260037075', 1, 1, 'SR', NULL, NULL, NULL),
(5027, '2016-08-07 09:57:06', NULL, NULL, 1734, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:57:06', 'sanni-1470532862-14705350260037075', 1, 0, '', NULL, NULL, NULL),
(5028, '2016-08-07 09:57:06', NULL, NULL, 1734, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:57:06', 'sanni-1470532862-14705350260037075', 1, 0, '', NULL, NULL, NULL),
(5029, '2016-08-07 09:57:06', NULL, NULL, 1734, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:57:06', 'sanni-1470532862-14705350260037075', 1, 0, '', NULL, NULL, NULL),
(5030, '2016-08-07 09:45:19', NULL, NULL, 1733, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:45:19', 'sanni-1470532862-14705343188126565', 1, 1, 'SR', NULL, NULL, '10.0'),
(5031, '2016-08-07 09:25:12', NULL, NULL, 1731, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 4, 12.00, 48.0000, 0.0000, 48.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:25:12', 'sanni-1470532862-1470533111904805', 1, 1, 'SR', NULL, NULL, NULL),
(5032, '2016-08-07 09:17:26', NULL, NULL, 1722, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:17:26', 'sanni-1470529443-1470532646244820', 1, 1, 'SR', NULL, NULL, NULL),
(5033, '2016-08-07 09:17:57', NULL, NULL, 1723, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:17:57', 'sanni-1470529443-1470532677339236', 1, 0, '', NULL, NULL, NULL),
(5034, '2016-08-07 09:17:57', NULL, NULL, 1723, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:17:57', 'sanni-1470529443-1470532677339236', 1, 1, 'SR', NULL, NULL, NULL),
(5035, '2016-08-07 09:18:47', NULL, NULL, 1724, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:18:47', 'sanni-1470529443-14705327270498228', 1, 0, '', NULL, NULL, NULL),
(5036, '2016-08-07 09:19:23', NULL, NULL, 1725, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:19:23', 'sanni-1470529443-14705327635489273', 1, 0, '', NULL, NULL, NULL),
(5037, '2016-08-07 09:19:23', NULL, NULL, 1725, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:19:23', 'sanni-1470529443-14705327635489273', 1, 1, 'SR', NULL, NULL, NULL),
(5038, '2016-08-07 09:20:03', NULL, NULL, 1726, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:20:03', 'sanni-1470529443-14705328028634547', 1, 0, '', NULL, NULL, NULL),
(5039, '2016-08-07 09:20:03', NULL, NULL, 1726, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:20:03', 'sanni-1470529443-14705328028634547', 1, 1, 'SR', NULL, NULL, NULL),
(5040, '2016-08-07 09:20:47', NULL, NULL, 1727, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:20:47', 'sanni-1470529443-14705328473852729', 1, 0, '', NULL, NULL, NULL),
(5041, '2016-08-07 09:20:47', NULL, NULL, 1727, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:20:47', 'sanni-1470529443-14705328473852729', 1, 1, 'SR', NULL, NULL, NULL),
(5042, '2016-08-07 09:21:39', NULL, NULL, 1728, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:21:39', 'sanni-1470532862-14705328995141087', 1, 0, '', NULL, NULL, NULL),
(5043, '2016-08-07 09:21:39', NULL, NULL, 1728, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:21:39', 'sanni-1470532862-14705328995141087', 1, 1, 'SR', NULL, NULL, NULL),
(5044, '2016-08-07 09:22:12', NULL, NULL, 1729, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:22:12', 'sanni-1470532862-14705329317843962', 1, 0, '', NULL, NULL, NULL),
(5045, '2016-08-07 09:22:12', NULL, NULL, 1729, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:22:12', 'sanni-1470532862-14705329317843962', 1, 1, 'SR', NULL, NULL, NULL),
(5046, '2016-08-07 09:22:12', NULL, NULL, 1729, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:22:12', 'sanni-1470532862-14705329317843962', 1, 1, 'SR', NULL, NULL, NULL),
(5047, '2016-08-07 09:22:54', NULL, NULL, 1730, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:22:54', 'sanni-1470532862-14705329743619112', 1, 0, '', NULL, NULL, NULL),
(5048, '2016-08-07 09:25:12', NULL, NULL, 1731, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:25:12', 'sanni-1470532862-1470533111904805', 1, 0, '', NULL, NULL, NULL),
(5049, '2016-08-07 09:25:12', NULL, NULL, 1731, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:25:12', 'sanni-1470532862-1470533111904805', 1, 0, '', NULL, NULL, NULL),
(5050, '2016-08-07 09:25:12', NULL, NULL, 1731, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:25:12', 'sanni-1470532862-1470533111904805', 1, 0, '', NULL, NULL, NULL),
(5051, '2016-08-07 09:25:12', NULL, NULL, 1731, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:25:12', 'sanni-1470532862-1470533111904805', 1, 0, '', NULL, NULL, NULL),
(5052, '2016-08-07 09:25:12', NULL, NULL, 1731, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:25:12', 'sanni-1470532862-1470533111904805', 1, 0, '', NULL, NULL, NULL),
(5053, '2016-08-07 09:25:12', NULL, NULL, 1731, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:25:12', 'sanni-1470532862-1470533111904805', 1, 1, 'SR', NULL, NULL, NULL),
(5054, '2016-08-07 09:15:25', NULL, NULL, 1722, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:15:25', 'sanni-1470529443-14705325253766256', 1, 0, '', NULL, NULL, NULL),
(5055, '2016-08-07 09:15:25', NULL, NULL, 1722, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:15:25', 'sanni-1470529443-14705325253766256', 1, 0, '', NULL, NULL, NULL),
(5056, '2016-08-07 09:16:20', NULL, NULL, 1722, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:16:20', 'sanni-1470529443-14705325798012821', 1, 1, 'SR', NULL, NULL, NULL),
(5057, '2016-08-07 09:15:25', NULL, NULL, 1722, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 09:15:25', 'sanni-1470529443-14705325253766256', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(5058, '2016-08-07 18:56:03', NULL, NULL, 1790, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 18:56:03', 'sanni-1470552213-1470567363422743', 1, 1, 'SR', NULL, NULL, NULL),
(5059, '2016-08-07 18:56:03', NULL, NULL, 1790, 0, 197, '132', 'Dinner - Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 18:56:03', 'sanni-1470552213-1470567363422743', 1, 0, '', NULL, NULL, NULL),
(5060, '2016-08-07 18:56:03', NULL, NULL, 1790, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 18:56:03', 'sanni-1470552213-1470567363422743', 1, 0, '', NULL, NULL, NULL),
(5061, '2016-08-07 18:56:03', NULL, NULL, 1790, 0, 181, '116', 'Open Food ', 'Bean Sprout', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 18:56:03', 'sanni-1470552213-1470567363422743', 1, 0, '', NULL, NULL, NULL),
(5062, '2016-08-07 18:56:03', NULL, NULL, 1790, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 18:56:03', 'sanni-1470552213-1470567363422743', 1, 0, '', NULL, NULL, NULL),
(5063, '2016-08-07 18:56:03', NULL, NULL, 1790, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 18:56:03', 'sanni-1470552213-1470567363422743', 1, 0, '', NULL, NULL, NULL),
(5064, '2016-08-07 19:13:34', NULL, NULL, 1790, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 19:13:34', 'sanni-1470552213-14705684138338010', 1, 1, 'SR', NULL, NULL, NULL),
(5065, '2016-08-07 18:56:03', NULL, NULL, 1790, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 18:56:03', 'sanni-1470552213-1470567363422743', 1, 0, '', NULL, NULL, NULL),
(5066, '2016-08-07 18:59:18', NULL, NULL, 1790, 0, 198, '133', 'Dinner - Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 18:59:18', 'sanni-1470552213-14705675588014787', 1, 0, '', NULL, NULL, NULL),
(5067, '2016-08-07 19:29:46', NULL, NULL, 1790, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 19:29:46', 'sanni-1470552213-14705693864284840', 1, 0, '', NULL, NULL, NULL),
(5068, '2016-08-07 19:49:45', NULL, NULL, 1791, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 19:49:45', 'sanni-1470552213-14705705855756586', 1, 1, 'SR', NULL, NULL, NULL),
(5069, '2016-08-07 19:49:45', NULL, NULL, 1791, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 19:49:45', 'sanni-1470552213-14705705855756586', 1, 0, '', NULL, NULL, NULL),
(5070, '2016-08-07 19:50:46', NULL, NULL, 1792, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 19:50:46', 'sanni-1470552213-14705706467022860', 1, 1, 'SR', NULL, NULL, NULL),
(5071, '2016-08-07 20:22:12', NULL, NULL, 1793, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 20:22:12', 'sanni-1470552213-14705725327004612', 1, 1, 'SR', NULL, NULL, NULL),
(5072, '2016-08-07 20:22:12', NULL, NULL, 1793, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 20:22:12', 'sanni-1470552213-14705725327004612', 1, 0, '', NULL, NULL, NULL),
(5073, '2016-08-07 20:22:12', NULL, NULL, 1793, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 20:22:12', 'sanni-1470552213-14705725327004612', 1, 0, '', NULL, NULL, NULL),
(5074, '2016-08-07 20:27:47', NULL, NULL, 1794, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 20:27:47', 'sanni-1470552213-147057286706446', 1, 0, '', NULL, NULL, NULL),
(5075, '2016-08-07 20:28:25', NULL, NULL, 1794, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470552213', 'sanni', '2016-08-07 20:28:25', 'sanni-1470552213-1470572904971280', 1, 1, 'SR', NULL, NULL, NULL),
(5076, '2016-08-08 18:57:53', NULL, NULL, 1839, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 18:57:53', 'sanni-1470635017-14706538736031441', 1, 0, '', NULL, NULL, NULL),
(5077, '2016-08-08 18:57:53', NULL, NULL, 1839, 0, 201, '136', 'Dinner -  Chili Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 18:57:53', 'sanni-1470635017-14706538736031441', 1, 0, '', NULL, NULL, NULL),
(5078, '2016-08-08 18:57:53', NULL, NULL, 1839, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 18:57:53', 'sanni-1470635017-14706538736031441', 1, 0, '', NULL, NULL, NULL),
(5079, '2016-08-08 18:58:53', NULL, NULL, 1839, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 18:58:53', 'sanni-1470635017-1470653933767817', 1, 1, 'SR', NULL, NULL, NULL),
(5080, '2016-08-08 19:00:08', NULL, NULL, 1839, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 19:00:08', 'sanni-1470635017-14706540080493656', 1, 1, 'SR', NULL, NULL, NULL),
(5081, '2016-08-08 19:00:08', NULL, NULL, 1839, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 19:00:08', 'sanni-1470635017-14706540080493656', 1, 1, 'SR', NULL, NULL, NULL),
(5082, '2016-08-08 20:06:53', NULL, NULL, 1840, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 20:06:53', 'sanni-1470635017-14706580130184216', 1, 1, 'SR', NULL, NULL, NULL),
(5083, '2016-08-08 20:06:53', NULL, NULL, 1840, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 20:06:53', 'sanni-1470635017-14706580130184216', 1, 1, 'SR', NULL, NULL, NULL),
(5084, '2016-08-08 20:42:26', NULL, NULL, 1841, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 20:42:26', 'admin-1470660115-1470660145873844', 1, 1, 'SR', NULL, NULL, NULL),
(5085, '2016-08-08 20:42:26', NULL, NULL, 1841, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 20:42:26', 'admin-1470660115-1470660145873844', 1, 1, 'SR', NULL, NULL, NULL),
(5086, '2016-08-08 21:12:38', NULL, NULL, 1841, 0, 198, '133', 'Dinner - Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 21:12:38', 'admin-1470660115-14706619583605491', 1, 0, '', NULL, NULL, NULL),
(5087, '2016-08-08 21:12:38', NULL, NULL, 1841, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 21:12:38', 'admin-1470660115-14706619583605491', 1, 0, '', NULL, NULL, NULL),
(5088, '2016-08-08 17:31:12', NULL, NULL, 1836, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 17:31:12', 'sanni-1470635017-14706486726725397', 1, 1, 'SR', NULL, NULL, NULL),
(5089, '2016-08-08 17:34:03', NULL, NULL, 1837, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 17:34:03', 'sanni-1470635017-14706488433501810', 1, 0, '', NULL, NULL, NULL),
(5090, '2016-08-08 17:34:03', NULL, NULL, 1837, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 17:34:03', 'sanni-1470635017-14706488433501810', 1, 1, 'SR', NULL, NULL, NULL),
(5091, '2016-08-08 17:34:03', NULL, NULL, 1837, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 17:34:03', 'sanni-1470635017-14706488433501810', 1, 1, 'SR', NULL, NULL, NULL),
(5092, '2016-08-08 18:20:01', NULL, NULL, 1838, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 18:20:01', 'sanni-1470635017-14706516017578417', 1, 0, '', NULL, NULL, NULL),
(5093, '2016-08-08 18:20:01', NULL, NULL, 1838, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 18:20:01', 'sanni-1470635017-14706516017578417', 1, 1, 'SR', NULL, NULL, NULL),
(5094, '2016-08-08 17:11:52', NULL, NULL, 1834, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 17:11:52', 'sanni-1470635017-1470647512307461', 1, 0, '', NULL, NULL, NULL),
(5095, '2016-08-08 17:08:25', NULL, NULL, 1834, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 17:08:25', 'sanni-1470635017-14706473053733242', 1, 1, 'SR', NULL, NULL, NULL),
(5096, '2016-08-08 17:20:17', NULL, NULL, 1835, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 17:20:17', 'sanni-1470635017-14706480168461675', 1, 1, 'SR', NULL, NULL, NULL),
(5097, '2016-08-08 14:18:25', NULL, NULL, 1820, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 14:18:25', 'sanni-1470635017-14706371054306589', 1, 1, 'SR', NULL, NULL, NULL),
(5098, '2016-08-08 14:18:25', NULL, NULL, 1820, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 14:18:25', 'sanni-1470635017-14706371054306589', 1, 1, 'SR', NULL, NULL, NULL),
(5099, '2016-08-08 14:18:54', NULL, NULL, 1821, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 14:18:54', 'sanni-1470635017-14706371348067772', 1, 1, 'SR', NULL, NULL, NULL),
(5100, '2016-08-08 14:18:54', NULL, NULL, 1821, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 14:18:54', 'sanni-1470635017-14706371348067772', 1, 0, '', NULL, NULL, NULL),
(5101, '2016-08-08 14:19:53', NULL, NULL, 1822, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 14:19:53', 'sanni-1470635017-14706371932131389', 1, 1, 'SR', NULL, NULL, NULL),
(5102, '2016-08-08 14:34:44', NULL, NULL, 1823, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 14:34:44', 'sanni-1470635017-14706380844865068', 1, 1, 'SR', NULL, NULL, NULL),
(5103, '2016-08-08 14:34:58', NULL, NULL, 1824, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 14:34:58', 'sanni-1470635017-14706380986845854', 1, 1, 'SR', 1, NULL, NULL),
(5104, '2016-08-08 14:34:58', NULL, NULL, 1824, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 14:34:58', 'sanni-1470635017-14706380986845854', 1, 1, 'SR', 1, NULL, NULL),
(5105, '2016-08-08 14:46:47', NULL, NULL, 1825, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 14:46:47', 'sanni-1470635017-14706388072404688', 1, 1, 'SR', 1, NULL, NULL),
(5106, '2016-08-08 14:46:47', NULL, NULL, 1825, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 14:46:47', 'sanni-1470635017-14706388072404688', 1, 0, '', 1, NULL, NULL),
(5107, '2016-08-08 14:55:20', NULL, NULL, 1826, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 14:55:20', 'sanni-1470635017-14706393200293948', 1, 0, '', 1, NULL, NULL),
(5108, '2016-08-08 14:55:20', NULL, NULL, 1826, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 14:55:20', 'sanni-1470635017-14706393200293948', 1, 0, '', 1, NULL, NULL),
(5109, '2016-08-08 15:29:07', NULL, NULL, 1827, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 15:29:07', 'sanni-1470635017-14706413470531845', 1, 0, '', 1, NULL, NULL),
(5110, '2016-08-08 15:29:07', NULL, NULL, 1827, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 15:29:07', 'sanni-1470635017-14706413470531845', 1, 1, 'SR', 1, NULL, NULL),
(5111, '2016-08-08 16:56:01', NULL, NULL, 1833, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 16:56:01', 'sanni-1470635017-14706465611061055', 1, 0, '', NULL, NULL, NULL),
(5112, '2016-08-08 16:56:01', NULL, NULL, 1833, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 16:56:01', 'sanni-1470635017-14706465611061055', 1, 1, 'SR', NULL, NULL, NULL),
(5113, '2016-08-08 16:56:01', NULL, NULL, 1833, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 16:56:01', 'sanni-1470635017-14706465611061055', 1, 0, '', NULL, NULL, NULL),
(5114, '2016-08-08 16:50:00', NULL, NULL, 1832, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 16:50:00', 'sanni-1470635017-14706462001347376', 1, 1, 'SR', NULL, NULL, NULL),
(5115, '2016-08-08 16:16:36', NULL, NULL, 1831, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 16:16:36', 'sanni-1470635017-14706441959959270', 1, 1, 'SR', NULL, NULL, NULL),
(5116, '2016-08-08 16:13:57', NULL, NULL, 1830, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 16:13:57', 'sanni-1470635017-14706440369912863', 1, 1, 'SR', NULL, NULL, NULL),
(5117, '2016-08-08 16:09:18', NULL, NULL, 1829, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 16:09:18', 'sanni-1470635017-14706437580198475', 1, 1, 'SR', NULL, NULL, NULL),
(5118, '2016-08-08 16:09:18', NULL, NULL, 1829, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 16:09:18', 'sanni-1470635017-14706437580198475', 1, 1, 'SR', NULL, NULL, NULL),
(5119, '2016-08-08 15:49:48', NULL, NULL, 1828, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 15:49:48', 'sanni-1470635017-14706425884141046', 1, 0, '', 1, NULL, NULL),
(5120, '2016-08-08 15:49:48', NULL, NULL, 1828, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 15:49:48', 'sanni-1470635017-14706425884141046', 1, 0, '', 1, NULL, NULL),
(5121, '2016-08-08 17:20:17', NULL, NULL, 1835, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 17:20:17', 'sanni-1470635017-14706480168461675', 1, 1, 'SR', NULL, NULL, NULL),
(5122, '2016-08-08 14:17:31', NULL, NULL, 1819, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 14:17:31', 'sanni-1470635017-14706370514945477', 1, 1, 'SR', NULL, NULL, NULL),
(5123, '2016-08-08 15:49:48', NULL, NULL, 1828, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 15:49:48', 'sanni-1470635017-14706425884141046', 1, 0, '', 1, NULL, NULL),
(5124, '2016-08-08 14:18:25', NULL, NULL, 1820, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 14:18:25', 'sanni-1470635017-14706371054306589', 1, 1, 'SR', NULL, NULL, NULL),
(5125, '2016-08-08 13:58:50', NULL, NULL, 1810, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 13:58:50', 'sanni-1470635017-14706359303725825', 1, 1, 'SR', NULL, NULL, NULL),
(5126, '2016-08-08 13:58:50', NULL, NULL, 1810, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 13:58:50', 'sanni-1470635017-14706359303725825', 1, 1, 'SR', NULL, NULL, NULL),
(5127, '2016-08-08 14:05:22', NULL, NULL, 1815, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 14:05:22', 'sanni-1470635017-14706363228131722', 1, 0, '', NULL, NULL, NULL),
(5128, '2016-08-08 14:13:43', NULL, NULL, 1817, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 14:13:43', 'sanni-1470635017-14706368237356130', 1, 0, '', NULL, NULL, NULL),
(5129, '2016-08-08 14:14:17', NULL, NULL, 1818, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 14:14:17', 'sanni-1470635017-14706368575544455', 1, 1, 'SR', 1, NULL, NULL),
(5130, '2016-08-08 14:17:31', NULL, NULL, 1819, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 14:17:31', 'sanni-1470635017-14706370514945477', 1, 1, 'SR', NULL, NULL, NULL),
(5131, '2016-08-08 14:14:17', NULL, NULL, 1818, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 14:14:17', 'sanni-1470635017-14706368575544455', 1, 1, 'SR', 1, NULL, NULL),
(5132, '2016-08-08 13:58:50', NULL, NULL, 1810, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 13:58:50', 'sanni-1470635017-14706359303725825', 1, 0, '', NULL, NULL, NULL),
(5133, '2016-08-08 13:41:01', NULL, NULL, 1812, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 13:41:01', 'admin-1470618904-14706348616533281', 1, 1, 'SR', NULL, NULL, NULL),
(5134, '2016-08-08 13:43:16', NULL, NULL, 1813, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 13:43:16', 'admin-1470618904-14706349963614654', 1, 0, '', NULL, NULL, NULL),
(5135, '2016-08-08 13:47:39', NULL, NULL, 1814, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 13:47:39', 'sanni-1470635017-14706352591002471', 1, 1, 'SR', NULL, NULL, NULL),
(5136, '2016-08-08 13:47:48', NULL, NULL, 1814, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 13:47:48', 'sanni-1470635017-14706352684894988', 1, 1, 'SR', NULL, NULL, NULL),
(5137, '2016-08-08 13:09:38', NULL, NULL, 1810, 0, 187, '122', 'Iced Tea ', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 13:09:38', 'admin-1470618904-14706329779779685', 1, 0, '', NULL, NULL, NULL),
(5138, '2016-08-08 13:09:43', NULL, NULL, 1810, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 13:09:43', 'admin-1470618904-14706329836705848', 1, 1, 'SR', NULL, NULL, NULL),
(5139, '2016-08-08 13:40:06', NULL, NULL, 1811, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 13:40:06', 'admin-1470618904-14706348060638032', 1, 1, 'SR', NULL, NULL, NULL),
(5140, '2016-08-08 13:07:58', NULL, NULL, 1810, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 13:07:58', 'admin-1470618904-14706328782646518', 1, 1, 'SR', NULL, NULL, NULL),
(5141, '2016-08-08 13:09:28', NULL, NULL, 1810, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 13:09:28', 'admin-1470618904-14706329685016951', 1, 1, 'SR', NULL, NULL, NULL),
(5142, '2016-08-08 13:40:06', NULL, NULL, 1811, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 13:40:06', 'admin-1470618904-14706348060638032', 1, 1, 'SR', NULL, NULL, NULL),
(5143, '2016-08-08 13:09:38', NULL, NULL, 1810, 0, 187, '122', 'Iced Tea ', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 13:09:38', 'admin-1470618904-14706329779779685', 1, 0, '', NULL, NULL, NULL),
(5144, '2016-08-08 13:09:28', NULL, NULL, 1810, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 13:09:28', 'admin-1470618904-14706329685016951', 1, 1, 'SR', NULL, NULL, NULL),
(5145, '2016-08-08 13:09:38', NULL, NULL, 1810, 0, 187, '122', 'Iced Tea ', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 13:09:38', 'admin-1470618904-14706329779779685', 1, 0, '', NULL, NULL, NULL),
(5146, '2016-08-08 12:43:06', NULL, NULL, 1809, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 12:43:06', 'admin-1470618904-1470631386048415', 1, 1, 'SR', NULL, NULL, NULL),
(5147, '2016-08-08 12:43:06', NULL, NULL, 1809, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 12:43:06', 'admin-1470618904-1470631386048415', 1, 1, 'SR', NULL, NULL, NULL),
(5148, '2016-08-08 13:07:58', NULL, NULL, 1810, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 13:07:58', 'admin-1470618904-14706328782646518', 1, 1, 'SR', NULL, NULL, NULL),
(5149, '2016-08-08 11:47:16', NULL, NULL, 1808, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 11:47:16', 'admin-1470618904-14706280361093112', 1, 0, '', NULL, NULL, NULL),
(5150, '2016-08-08 11:47:33', NULL, NULL, 1808, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 11:47:33', 'admin-1470618904-14706280531989168', 1, 1, 'SR', NULL, NULL, NULL),
(5151, '2016-08-08 11:48:45', NULL, NULL, 1809, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 11:48:45', 'admin-1470618904-14706281257213693', 1, 0, '', NULL, NULL, NULL),
(5152, '2016-08-08 11:48:45', NULL, NULL, 1809, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 11:48:45', 'admin-1470618904-14706281257213693', 1, 0, '', NULL, NULL, NULL),
(5153, '2016-08-08 11:48:45', NULL, NULL, 1809, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 11:48:45', 'admin-1470618904-14706281257213693', 1, 0, '', NULL, NULL, NULL),
(5154, '2016-08-08 11:48:45', NULL, NULL, 1809, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 11:48:45', 'admin-1470618904-14706281257213693', 1, 0, '', NULL, NULL, NULL),
(5155, '2016-08-08 11:47:43', NULL, NULL, 1808, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 11:47:43', 'admin-1470618904-14706280637828670', 1, 1, 'SR', NULL, NULL, NULL),
(5156, '2016-08-08 11:24:26', NULL, NULL, 1806, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 11:24:26', 'admin-1470618904-14706266664466758', 1, 0, '', NULL, NULL, NULL),
(5157, '2016-08-08 11:32:19', NULL, NULL, 1806, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 11:32:19', 'admin-1470618904-14706271389268461', 1, 0, '', NULL, NULL, NULL),
(5158, '2016-08-08 11:24:26', NULL, NULL, 1806, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 11:24:26', 'admin-1470618904-14706266664466758', 1, 1, 'SR', NULL, NULL, NULL),
(5159, '2016-08-08 09:14:13', NULL, NULL, 1800, 0, 154, '88', 'House BLT', 'add bacon', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:14:13', 'sanni-1470618188-14706188533409994', 1, 0, '', NULL, NULL, NULL),
(5160, '2016-08-08 09:14:13', NULL, NULL, 1800, 0, 154, '88', 'House BLT', 'add bacon', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:14:13', 'sanni-1470618188-14706188533409994', 1, 0, '', NULL, NULL, NULL),
(5161, '2016-08-08 09:14:13', NULL, NULL, 1800, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:14:13', 'sanni-1470618188-14706188533409994', 1, 1, 'SR', NULL, NULL, NULL),
(5162, '2016-08-08 09:14:13', NULL, NULL, 1800, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:14:13', 'sanni-1470618188-14706188533409994', 1, 1, 'SR', NULL, NULL, NULL),
(5163, '2016-08-08 09:15:23', NULL, NULL, 1800, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 09:15:23', 'admin-1470618904-14706189237667634', 1, 1, 'SR', NULL, NULL, NULL),
(5164, '2016-08-08 09:15:23', NULL, NULL, 1800, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 09:15:23', 'admin-1470618904-14706189237667634', 1, 1, 'SR', NULL, NULL, NULL),
(5165, '2016-08-08 09:15:47', NULL, NULL, 1801, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 09:15:47', 'admin-1470618904-14706189471792473', 1, 1, 'SR', NULL, NULL, NULL),
(5166, '2016-08-08 09:15:47', NULL, NULL, 1801, 0, 154, '88', 'House BLT', 'add bacon', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 09:15:47', 'admin-1470618904-14706189471792473', 1, 0, '', NULL, NULL, NULL),
(5167, '2016-08-08 09:15:47', NULL, NULL, 1801, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 09:15:47', 'admin-1470618904-14706189471792473', 1, 1, 'SR', NULL, NULL, NULL),
(5168, '2016-08-08 09:36:23', NULL, NULL, 1802, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 09:36:23', 'admin-1470618904-14706201831018172', 1, 1, 'SR', NULL, NULL, NULL),
(5169, '2016-08-08 10:05:43', NULL, NULL, 1803, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 10:05:43', 'admin-1470618904-1470621943499732', 1, 0, '', NULL, NULL, NULL),
(5170, '2016-08-08 10:05:43', NULL, NULL, 1803, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 10:05:43', 'admin-1470618904-1470621943499732', 1, 0, '', NULL, NULL, NULL),
(5171, '2016-08-08 10:05:43', NULL, NULL, 1803, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 10:05:43', 'admin-1470618904-1470621943499732', 1, 1, 'SR', NULL, NULL, NULL),
(5172, '2016-08-08 10:05:43', NULL, NULL, 1803, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 10:05:43', 'admin-1470618904-1470621943499732', 1, 1, 'SR', NULL, NULL, NULL),
(5173, '2016-08-08 10:29:32', NULL, NULL, 1804, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 10:29:32', 'admin-1470618904-14706233723237816', 1, 1, 'SR', NULL, NULL, NULL),
(5174, '2016-08-08 10:29:32', NULL, NULL, 1804, 0, 156, '90', 'Cheese Omelet', 'with 2 extra egg', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 10:29:32', 'admin-1470618904-14706233723237816', 1, 0, '', NULL, NULL, NULL),
(5175, '2016-08-08 11:00:16', NULL, NULL, 1805, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 11:00:16', 'admin-1470618904-14706252163745290', 1, 1, 'SR', 1, NULL, NULL),
(5176, '2016-08-08 11:23:01', NULL, NULL, 1806, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 11:23:01', 'admin-1470618904-14706265813966445', 1, 0, '', NULL, NULL, NULL),
(5177, '2016-08-08 11:23:01', NULL, NULL, 1806, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 11:23:01', 'admin-1470618904-14706265813966445', 1, 1, 'SR', NULL, NULL, NULL),
(5178, '2016-08-08 11:23:34', NULL, NULL, 1807, NULL, 65, '65', 'Pineapple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 11:23:34', 'admin-1470618904-14706266147774543', 1, 1, 'SR', NULL, NULL, NULL),
(5179, '2016-08-08 11:23:34', NULL, NULL, 1807, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 11:23:34', 'admin-1470618904-14706266147774543', 1, 0, '', NULL, NULL, NULL),
(5180, '2016-08-08 11:23:34', NULL, NULL, 1807, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 11:23:34', 'admin-1470618904-14706266147774543', 1, 0, '', NULL, NULL, NULL),
(5181, '2016-08-08 11:23:34', NULL, NULL, 1807, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470663773', 'admin', '2016-08-08 11:23:34', 'admin-1470618904-14706266147774543', 1, 1, 'SR', NULL, NULL, NULL),
(5182, '2016-08-08 09:07:53', NULL, NULL, 1799, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:07:53', 'sanni-1470618188-1470618472776478', 1, 1, 'SR', NULL, NULL, NULL),
(5183, '2016-08-08 09:07:53', NULL, NULL, 1799, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:07:53', 'sanni-1470618188-1470618472776478', 1, 0, '', NULL, NULL, NULL),
(5184, '2016-08-08 09:06:56', NULL, NULL, 1798, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:06:56', 'sanni-1470618188-14706184167453229', 1, 0, '', NULL, NULL, NULL),
(5185, '2016-08-08 09:06:56', NULL, NULL, 1798, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:06:56', 'sanni-1470618188-14706184167453229', 1, 1, 'SR', NULL, NULL, NULL),
(5186, '2016-08-08 09:05:38', NULL, NULL, 1796, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:05:38', 'sanni-1470618188-14706183387088394', 1, 1, 'SR', NULL, NULL, NULL),
(5187, '2016-08-08 09:04:25', NULL, NULL, 1795, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:04:25', 'sanni-1470618188-14706182648565667', 1, 1, 'SR', NULL, NULL, NULL),
(5188, '2016-08-08 09:06:22', NULL, NULL, 1797, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:06:22', 'sanni-1470618188-14706183822712443', 1, 0, '', NULL, NULL, NULL),
(5189, '2016-08-08 09:04:25', NULL, NULL, 1795, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:04:25', 'sanni-1470618188-14706182648565667', 1, 1, 'SR', NULL, NULL, NULL),
(5190, '2016-08-08 09:04:25', NULL, NULL, 1795, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:04:25', 'sanni-1470618188-14706182648565667', 1, 1, 'SR', NULL, NULL, NULL),
(5191, '2016-08-08 09:04:25', NULL, NULL, 1795, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:04:25', 'sanni-1470618188-14706182648565667', 1, 1, 'SR', NULL, NULL, NULL),
(5192, '2016-08-08 09:04:25', NULL, NULL, 1795, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:04:25', 'sanni-1470618188-14706182648565667', 1, 1, 'SR', NULL, NULL, NULL),
(5193, '2016-08-08 09:04:25', NULL, NULL, 1795, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:04:25', 'sanni-1470618188-14706182648565667', 1, 1, 'SR', NULL, NULL, NULL),
(5194, '2016-08-08 09:04:25', NULL, NULL, 1795, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:04:25', 'sanni-1470618188-14706182648565667', 1, 1, 'SR', NULL, NULL, NULL),
(5195, '2016-08-08 09:04:25', NULL, NULL, 1795, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:04:25', 'sanni-1470618188-14706182648565667', 1, 1, 'SR', NULL, NULL, NULL),
(5196, '2016-08-08 09:04:25', NULL, NULL, 1795, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:04:25', 'sanni-1470618188-14706182648565667', 1, 1, 'SR', NULL, NULL, NULL),
(5197, '2016-08-08 09:04:25', NULL, NULL, 1795, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:04:25', 'sanni-1470618188-14706182648565667', 1, 1, 'SR', NULL, NULL, NULL),
(5198, '2016-08-08 09:04:25', NULL, NULL, 1795, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:04:25', 'sanni-1470618188-14706182648565667', 1, 0, '', NULL, NULL, NULL),
(5199, '2016-08-08 09:04:25', NULL, NULL, 1795, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:04:25', 'sanni-1470618188-14706182648565667', 1, 0, '', NULL, NULL, NULL),
(5200, '2016-08-08 09:04:25', NULL, NULL, 1795, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:04:25', 'sanni-1470618188-14706182648565667', 1, 0, '', NULL, NULL, NULL),
(5201, '2016-08-08 09:05:38', NULL, NULL, 1796, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:05:38', 'sanni-1470618188-14706183387088394', 1, 0, '', NULL, NULL, NULL),
(5202, '2016-08-08 09:04:25', NULL, NULL, 1795, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:04:25', 'sanni-1470618188-14706182648565667', 1, 0, '', NULL, NULL, NULL),
(5203, '2016-08-08 09:04:25', NULL, NULL, 1795, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470663773', 'sanni', '2016-08-08 09:04:25', 'sanni-1470618188-14706182648565667', 1, 0, '', NULL, NULL, NULL),
(5204, '2016-08-09 13:29:10', NULL, NULL, 1856, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470718649', 'sanni', '2016-08-09 13:29:10', 'sanni-1470718649-14707205501827717', 1, 1, 'SR', NULL, NULL, NULL),
(5205, '2016-08-09 12:37:59', NULL, NULL, 1854, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 12:37:59', 'admin-1470704366-14707174795827550', 1, 0, '', NULL, NULL, '10.0'),
(5206, '2016-08-09 12:37:59', NULL, NULL, 1854, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 12:37:59', 'admin-1470704366-14707174795827550', 1, 1, 'SR', NULL, NULL, '10.0'),
(5207, '2016-08-09 12:37:59', NULL, NULL, 1854, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 12:37:59', 'admin-1470704366-14707174795827550', 1, 1, 'SR', NULL, NULL, '10.0'),
(5208, '2016-08-09 12:39:39', NULL, NULL, 1855, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 12:39:39', 'admin-1470704366-1470717579162551', 1, 1, 'SR', NULL, NULL, NULL),
(5209, '2016-08-09 12:42:45', NULL, NULL, 1849, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 12:42:45', 'admin-1470704366-14707177655478756', 1, 0, '', NULL, NULL, NULL),
(5210, '2016-08-09 12:47:25', NULL, NULL, 1855, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 12:47:25', 'admin-1470704366-14707180454538638', 1, 1, 'SR', NULL, NULL, NULL),
(5211, '2016-08-09 13:29:10', NULL, NULL, 1856, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470718649', 'sanni', '2016-08-09 13:29:10', 'sanni-1470718649-14707205501827717', 1, 0, '', NULL, NULL, NULL),
(5212, '2016-08-09 13:30:43', NULL, NULL, 1857, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470718649', 'sanni', '2016-08-09 13:30:43', 'sanni-1470718649-14707206435089716', 1, 1, 'SR', NULL, NULL, NULL),
(5213, '2016-08-09 13:37:30', NULL, NULL, 1849, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470718649', 'sanni', '2016-08-09 13:37:30', 'sanni-1470718649-1470721049928309', 1, 1, 'SR', NULL, NULL, NULL),
(5214, '2016-08-09 13:38:36', NULL, NULL, 1858, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470718649', 'sanni', '2016-08-09 13:38:36', 'sanni-1470718649-14707211163405226', 1, 1, 'SR', NULL, NULL, NULL),
(5215, '2016-08-09 13:59:20', NULL, NULL, 1859, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470718649', 'sanni', '2016-08-09 13:59:20', 'sanni-1470718649-1470722360145666', 1, 1, 'SR', NULL, NULL, NULL),
(5216, '2016-08-09 15:05:47', NULL, NULL, 1861, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470718649', 'sanni', '2016-08-09 15:05:47', 'sanni-1470718649-14707263475726350', 1, 1, 'SR', NULL, NULL, NULL),
(5217, '2016-08-09 15:07:44', NULL, NULL, 1860, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1470718649', 'sanni', '2016-08-09 15:07:44', 'sanni-1470718649-14707264638689653', 1, 0, '', NULL, NULL, NULL),
(5218, '2016-08-09 15:07:44', NULL, NULL, 1860, 0, 181, '116', 'Open Food ', 'add pasta', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1470718649', 'sanni', '2016-08-09 15:07:44', 'sanni-1470718649-14707264638689653', 1, 0, '', NULL, NULL, NULL),
(5219, '2016-08-09 15:10:02', NULL, NULL, 1862, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470718649', 'sanni', '2016-08-09 15:10:02', 'sanni-1470718649-14707266019402396', 1, 1, 'SR', NULL, NULL, NULL),
(5220, '2016-08-09 15:55:10', NULL, NULL, 1860, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470718649', 'sanni', '2016-08-09 15:55:10', 'sanni-1470718649-14707293101684855', 1, 0, '', NULL, NULL, NULL),
(5221, '2016-08-09 15:55:10', NULL, NULL, 1860, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470718649', 'sanni', '2016-08-09 15:55:10', 'sanni-1470718649-14707293101684855', 1, 1, 'SR', NULL, NULL, NULL),
(5222, '2016-08-09 12:37:59', NULL, NULL, 1854, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 12:37:59', 'admin-1470704366-14707174795827550', 1, 0, '', NULL, NULL, '10.0'),
(5223, '2016-08-09 12:25:49', NULL, NULL, 1852, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 12:25:49', 'admin-1470704366-1470716749206543', 1, 1, 'SR', NULL, NULL, NULL),
(5224, '2016-08-09 12:39:00', NULL, NULL, 1854, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 12:39:00', 'admin-1470704366-14707175402326146', 1, 1, 'SR', NULL, NULL, '10.0'),
(5225, '2016-08-09 12:37:59', NULL, NULL, 1854, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 12:37:59', 'admin-1470704366-14707174795827550', 1, 1, 'SR', NULL, NULL, '10.0'),
(5226, '2016-08-09 12:26:53', NULL, NULL, 1853, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 12:26:53', 'admin-1470704366-14707168129436224', 1, 1, 'SR', NULL, NULL, NULL),
(5227, '2016-08-09 12:37:59', NULL, NULL, 1854, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 12:37:59', 'admin-1470704366-14707174795827550', 1, 1, 'SR', NULL, NULL, '10.0'),
(5228, '2016-08-09 09:05:57', NULL, NULL, 1842, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 09:05:57', 'admin-1470704366-14707047570854457', 1, 1, 'SR', NULL, NULL, NULL),
(5229, '2016-08-09 12:25:26', NULL, NULL, 1851, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 12:25:26', 'admin-1470704366-14707167259371724', 1, 1, 'SR', NULL, NULL, NULL),
(5230, '2016-08-09 12:25:18', NULL, NULL, 1850, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 12:25:18', 'admin-1470704366-14707167180245773', 1, 1, 'SR', NULL, NULL, NULL),
(5231, '2016-08-09 12:13:54', NULL, NULL, 1849, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 12:13:54', 'admin-1470704366-14707160343817267', 1, 1, 'SR', NULL, NULL, NULL),
(5232, '2016-08-09 12:13:54', NULL, NULL, 1849, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 12:13:54', 'admin-1470704366-14707160343817267', 1, 1, 'SR', NULL, NULL, NULL),
(5233, '2016-08-09 12:12:18', NULL, NULL, 1848, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 12:12:18', 'admin-1470704366-14707159384729121', 1, 0, '', NULL, NULL, NULL),
(5234, '2016-08-09 12:12:18', NULL, NULL, 1848, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 12:12:18', 'admin-1470704366-14707159384729121', 1, 1, 'SR', NULL, NULL, NULL),
(5235, '2016-08-09 12:12:18', NULL, NULL, 1848, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 12:12:18', 'admin-1470704366-14707159384729121', 1, 1, 'SR', NULL, NULL, NULL),
(5236, '2016-08-09 11:43:41', NULL, NULL, 1847, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 11:43:41', 'admin-1470704366-14707142209945820', 1, 1, 'SR', NULL, NULL, NULL),
(5237, '2016-08-09 11:43:41', NULL, NULL, 1847, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 11:43:41', 'admin-1470704366-14707142209945820', 1, 1, 'SR', NULL, NULL, NULL),
(5238, '2016-08-09 11:30:29', NULL, NULL, 1846, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 11:30:29', 'admin-1470704366-14707134290627637', 1, 0, '', NULL, NULL, NULL),
(5239, '2016-08-09 11:30:12', NULL, NULL, 1845, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 11:30:12', 'admin-1470704366-14707134120316519', 1, 0, '', NULL, NULL, NULL),
(5240, '2016-08-09 11:29:25', NULL, NULL, 1844, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 11:29:25', 'admin-1470704366-14707133652624265', 1, 0, '', NULL, NULL, NULL),
(5241, '2016-08-09 10:07:28', NULL, NULL, 1843, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 10:07:28', 'admin-1470704366-1470708448650265', 1, 1, 'SR', NULL, NULL, NULL),
(5242, '2016-08-09 09:05:57', NULL, NULL, 1842, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 09:05:57', 'admin-1470704366-14707047570854457', 1, 0, '', NULL, NULL, NULL),
(5243, '2016-08-09 09:05:57', NULL, NULL, 1842, 0, 187, '122', 'Iced Tea ', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 09:05:57', 'admin-1470704366-14707047570854457', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(5244, '2016-08-09 09:05:57', NULL, NULL, 1842, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470718649', 'admin', '2016-08-09 09:05:57', 'admin-1470704366-14707047570854457', 1, 0, '', NULL, NULL, NULL),
(5245, '2016-08-11 21:13:38', NULL, NULL, 1889, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 21:13:38', 'admin-1470876895-1470921218058277', 1, 1, 'SR', 1, NULL, NULL),
(5246, '2016-08-11 21:10:45', NULL, NULL, 1888, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 21:10:45', 'admin-1470876895-14709210456549360', 1, 1, 'SR', NULL, NULL, NULL),
(5247, '2016-08-11 20:44:16', NULL, NULL, 1887, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 20:44:16', 'admin-1470876895-14709194563529667', 1, 1, 'SR', NULL, NULL, NULL),
(5248, '2016-08-11 20:40:25', NULL, NULL, 1887, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 20:40:25', 'admin-1470876895-14709192253463882', 1, 0, '', NULL, NULL, NULL),
(5249, '2016-08-11 20:45:58', NULL, NULL, 1887, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 20:45:58', 'admin-1470876895-14709195579258411', 1, 1, 'SR', NULL, NULL, NULL),
(5250, '2016-08-11 20:44:11', NULL, NULL, 1887, 0, 192, '127', 'Stir Fried Chili Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 20:44:11', 'admin-1470876895-14709194515876336', 1, 0, '', NULL, NULL, NULL),
(5251, '2016-08-11 20:44:11', NULL, NULL, 1887, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 20:44:11', 'admin-1470876895-14709194515876336', 1, 0, '', NULL, NULL, NULL),
(5252, '2016-08-11 19:53:30', NULL, NULL, 1884, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 19:53:30', 'admin-1470876895-14709164103571814', 1, 1, 'SR', NULL, NULL, NULL),
(5253, '2016-08-11 19:53:30', NULL, NULL, 1884, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 19:53:30', 'admin-1470876895-14709164103571814', 1, 1, 'SR', NULL, NULL, NULL),
(5254, '2016-08-11 19:58:14', NULL, NULL, 1883, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 19:58:14', 'admin-1470876895-14709166939472067', 1, 0, '', NULL, NULL, NULL),
(5255, '2016-08-11 19:58:14', NULL, NULL, 1883, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 19:58:14', 'admin-1470876895-14709166939472067', 1, 0, '', NULL, NULL, NULL),
(5256, '2016-08-11 20:08:09', NULL, NULL, 1886, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 20:08:09', 'admin-1470876895-1470917289401563', 1, 1, 'SR', NULL, NULL, NULL),
(5257, '2016-08-11 20:08:09', NULL, NULL, 1886, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 20:08:09', 'admin-1470876895-1470917289401563', 1, 1, 'SR', NULL, NULL, NULL),
(5258, '2016-08-11 19:32:03', NULL, NULL, 1883, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 19:32:03', 'admin-1470876895-14709151235139356', 1, 1, 'SR', NULL, NULL, NULL),
(5259, '2016-08-11 19:42:04', NULL, NULL, 1883, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 19:42:04', 'admin-1470876895-1470915723903316', 1, 1, 'SR', NULL, NULL, NULL),
(5260, '2016-08-11 19:21:36', NULL, NULL, 1881, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 19:21:36', 'admin-1470876895-14709144961603235', 1, 0, '', NULL, NULL, '10.0'),
(5261, '2016-08-11 19:21:36', NULL, NULL, 1881, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 19:21:36', 'admin-1470876895-14709144961603235', 1, 1, 'SR', NULL, NULL, '10.0'),
(5262, '2016-08-11 19:25:50', NULL, NULL, 1882, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 19:25:50', 'admin-1470876895-14709147502477697', 1, 0, '', NULL, NULL, NULL),
(5263, '2016-08-11 19:25:50', NULL, NULL, 1882, 0, 197, '132', 'Dinner - Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 19:25:50', 'admin-1470876895-14709147502477697', 1, 0, '', NULL, NULL, NULL),
(5264, '2016-08-11 19:21:36', NULL, NULL, 1881, 0, 181, '116', 'Open Food ', 'vege', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 19:21:36', 'admin-1470876895-14709144961603235', 1, 0, '', NULL, NULL, '10.0'),
(5265, '2016-08-11 19:21:36', NULL, NULL, 1881, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 19:21:36', 'admin-1470876895-14709144961603235', 1, 1, 'SR', NULL, NULL, '10.0'),
(5266, '2016-08-11 19:21:36', NULL, NULL, 1881, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 19:21:36', 'admin-1470876895-14709144961603235', 1, 1, 'SR', NULL, NULL, '10.0'),
(5267, '2016-08-11 19:21:36', NULL, NULL, 1881, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 19:21:36', 'admin-1470876895-14709144961603235', 1, 1, 'SR', NULL, NULL, '10.0'),
(5268, '2016-08-11 19:21:36', NULL, NULL, 1881, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 19:21:36', 'admin-1470876895-14709144961603235', 1, 0, '', NULL, NULL, '10.0'),
(5269, '2016-08-11 19:21:36', NULL, NULL, 1881, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 19:21:36', 'admin-1470876895-14709144961603235', 1, 0, '', NULL, NULL, '10.0'),
(5270, '2016-08-11 19:21:36', NULL, NULL, 1881, 0, 197, '132', 'Dinner - Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 19:21:36', 'admin-1470876895-14709144961603235', 1, 0, '', NULL, NULL, '10.0'),
(5271, '2016-08-11 19:21:36', NULL, NULL, 1881, 0, 198, '133', 'Dinner - Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 19:21:36', 'admin-1470876895-14709144961603235', 1, 0, '', NULL, NULL, '10.0'),
(5272, '2016-08-11 19:21:36', NULL, NULL, 1881, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 19:21:36', 'admin-1470876895-14709144961603235', 1, 0, '', NULL, NULL, '10.0'),
(5273, '2016-08-11 19:21:36', NULL, NULL, 1881, 0, 199, '134', 'Dinner - Marmite Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 19:21:36', 'admin-1470876895-14709144961603235', 1, 0, '', NULL, NULL, '10.0'),
(5274, '2016-08-11 18:54:13', NULL, NULL, 1880, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 18:54:13', 'admin-1470876895-14709128531111018', 1, 1, 'SR', 1, NULL, NULL),
(5275, '2016-08-11 18:55:05', NULL, NULL, 1880, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 18:55:05', 'admin-1470876895-14709129048302456', 1, 0, '', 1, NULL, NULL),
(5276, '2016-08-11 18:53:01', NULL, NULL, 1880, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 18:53:01', 'admin-1470876895-14709127814218078', 1, 1, 'SR', 1, NULL, NULL),
(5277, '2016-08-11 16:28:33', NULL, NULL, 1879, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 16:28:33', 'admin-1470876895-14709041129231738', 1, 1, 'SR', NULL, NULL, NULL),
(5278, '2016-08-11 16:27:31', NULL, NULL, 1878, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 16:27:31', 'admin-1470876895-14709040517885814', 1, 1, 'SR', NULL, NULL, NULL),
(5279, '2016-08-11 16:22:32', NULL, NULL, 1877, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 16:22:32', 'admin-1470876895-14709037527546597', 1, 1, 'SR', 1, NULL, NULL),
(5280, '2016-08-11 15:59:09', NULL, NULL, 1876, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 15:59:09', 'admin-1470876895-14709023497838037', 1, 1, 'SR', NULL, NULL, NULL),
(5281, '2016-08-11 15:59:09', NULL, NULL, 1876, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 15:59:09', 'admin-1470876895-14709023497838037', 1, 1, 'SR', NULL, NULL, NULL),
(5282, '2016-08-11 15:31:20', NULL, NULL, 1875, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 15:31:20', 'admin-1470876895-1470900680581851', 1, 1, 'SR', NULL, NULL, NULL),
(5283, '2016-08-11 15:31:20', NULL, NULL, 1875, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 15:31:20', 'admin-1470876895-1470900680581851', 1, 0, '', NULL, NULL, NULL),
(5284, '2016-08-11 15:31:20', NULL, NULL, 1875, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 15:31:20', 'admin-1470876895-1470900680581851', 1, 0, '', NULL, NULL, NULL),
(5285, '2016-08-11 14:19:14', NULL, NULL, 1874, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 14:19:14', 'admin-1470876895-14708963541387584', 1, 1, 'SR', NULL, NULL, NULL),
(5286, '2016-08-11 14:19:14', NULL, NULL, 1874, 0, 83, '83', 'Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 14:19:14', 'admin-1470876895-14708963541387584', 1, 1, 'SR', NULL, NULL, NULL),
(5287, '2016-08-11 14:04:16', NULL, NULL, 1873, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 14:04:16', 'admin-1470876895-14708954562302143', 1, 1, 'SR', NULL, NULL, NULL),
(5288, '2016-08-11 13:27:18', NULL, NULL, 1871, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 13:27:18', 'admin-1470876895-14708932383408858', 1, 0, '', NULL, NULL, NULL),
(5289, '2016-08-11 13:27:18', NULL, NULL, 1871, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 13:27:18', 'admin-1470876895-14708932383408858', 1, 0, '', NULL, NULL, NULL),
(5290, '2016-08-11 13:32:41', NULL, NULL, 1872, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 13:32:41', 'admin-1470876895-14708935618118433', 1, 0, '', NULL, NULL, NULL),
(5291, '2016-08-11 13:32:41', NULL, NULL, 1872, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 13:32:41', 'admin-1470876895-14708935618118433', 1, 1, 'SR', NULL, NULL, NULL),
(5292, '2016-08-11 14:04:16', NULL, NULL, 1873, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 14:04:16', 'admin-1470876895-14708954562302143', 1, 0, '', NULL, NULL, NULL),
(5293, '2016-08-11 14:04:16', NULL, NULL, 1873, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 14:04:16', 'admin-1470876895-14708954562302143', 1, 1, 'SR', NULL, NULL, NULL),
(5294, '2016-08-11 13:26:56', NULL, NULL, 1871, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 13:26:56', 'admin-1470876895-14708932159048325', 1, 1, 'SR', NULL, NULL, NULL),
(5295, '2016-08-11 13:26:56', NULL, NULL, 1871, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 13:26:56', 'admin-1470876895-14708932159048325', 1, 1, 'SR', NULL, NULL, NULL),
(5296, '2016-08-11 11:09:56', NULL, NULL, 1868, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 11:09:56', 'admin-1470876895-14708849964078587', 1, 1, 'SR', NULL, NULL, NULL),
(5297, '2016-08-11 13:18:04', NULL, NULL, 1869, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 13:18:04', 'admin-1470876895-14708926842083943', 1, 1, 'SR', NULL, NULL, NULL),
(5298, '2016-08-11 13:18:04', NULL, NULL, 1869, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 13:18:04', 'admin-1470876895-14708926842083943', 1, 1, 'SR', NULL, NULL, NULL),
(5299, '2016-08-11 13:24:26', NULL, NULL, 1870, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 13:24:26', 'admin-1470876895-1470893065785482', 1, 0, '', 1, NULL, NULL),
(5300, '2016-08-11 11:09:56', NULL, NULL, 1868, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 11:09:56', 'admin-1470876895-14708849964078587', 1, 0, '', NULL, NULL, NULL),
(5301, '2016-08-11 09:02:35', NULL, NULL, 1863, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 09:02:35', 'admin-1470876895-14708773553741668', 1, 1, 'SR', NULL, NULL, NULL),
(5302, '2016-08-11 09:14:37', NULL, NULL, 1864, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 09:14:37', 'admin-1470876895-1470878077805481', 1, 0, '', NULL, NULL, NULL),
(5303, '2016-08-11 09:14:37', NULL, NULL, 1864, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 09:14:37', 'admin-1470876895-1470878077805481', 1, 0, '', NULL, NULL, NULL),
(5304, '2016-08-11 09:41:02', NULL, NULL, 1865, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 09:41:02', 'admin-1470876895-14708796626584837', 1, 0, '', NULL, NULL, NULL),
(5305, '2016-08-11 09:41:02', NULL, NULL, 1865, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 09:41:02', 'admin-1470876895-14708796626584837', 1, 0, '', NULL, NULL, NULL),
(5306, '2016-08-11 09:46:38', NULL, NULL, 1863, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 09:46:38', 'admin-1470876895-1470879998139360', 1, 0, '', NULL, NULL, NULL),
(5307, '2016-08-11 09:46:38', NULL, NULL, 1863, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 09:46:38', 'admin-1470876895-1470879998139360', 1, 1, 'SR', NULL, NULL, NULL),
(5308, '2016-08-11 09:50:24', NULL, NULL, 1866, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 09:50:24', 'admin-1470876895-1470880223925611', 1, 1, 'SR', NULL, NULL, NULL),
(5309, '2016-08-11 09:50:24', NULL, NULL, 1866, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 09:50:24', 'admin-1470876895-1470880223925611', 1, 0, '', NULL, NULL, NULL),
(5310, '2016-08-11 11:09:56', NULL, NULL, 1868, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 11:09:56', 'admin-1470876895-14708849964078587', 1, 0, '', NULL, NULL, NULL),
(5311, '2016-08-11 11:09:56', NULL, NULL, 1868, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 11:09:56', 'admin-1470876895-14708849964078587', 1, 1, 'SR', NULL, NULL, NULL),
(5312, '2016-08-11 10:05:01', NULL, NULL, 1863, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 10:05:01', 'admin-1470876895-14708811013834868', 1, 1, 'SR', NULL, NULL, NULL),
(5313, '2016-08-11 10:21:14', NULL, NULL, 1867, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 10:21:14', 'admin-1470876895-14708820746735095', 1, 1, 'SR', NULL, NULL, NULL),
(5314, '2016-08-11 09:41:02', NULL, NULL, 1865, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 09:41:02', 'admin-1470876895-14708796626584837', 1, 1, 'SR', NULL, NULL, NULL),
(5315, '2016-08-11 09:41:02', NULL, NULL, 1865, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 09:41:02', 'admin-1470876895-14708796626584837', 1, 1, 'SR', NULL, NULL, NULL),
(5316, '2016-08-11 09:02:35', NULL, NULL, 1863, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 09:02:35', 'admin-1470876895-14708773553741668', 1, 1, 'SR', NULL, NULL, NULL),
(5317, '2016-08-11 09:02:35', NULL, NULL, 1863, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 09:02:35', 'admin-1470876895-14708773553741668', 1, 0, '', NULL, NULL, NULL),
(5318, '2016-08-11 09:02:35', NULL, NULL, 1863, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1470876895', 'admin', '2016-08-11 09:02:35', 'admin-1470876895-14708773553741668', 1, 0, '', NULL, NULL, NULL),
(5319, '2016-08-12 21:18:48', NULL, NULL, 1920, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 21:18:48', 'sanni-1470976926-1471007928361893', 1, 1, 'SR', NULL, NULL, NULL),
(5320, '2016-08-12 21:19:34', NULL, NULL, 1921, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 21:19:34', 'sanni-1470976926-14710079746237542', 1, 0, '', 1, NULL, NULL),
(5321, '2016-08-12 21:20:46', NULL, NULL, 1912, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 21:20:46', 'sanni-1470976926-14710080465877041', 1, 1, 'SR', NULL, NULL, NULL),
(5322, '2016-08-12 21:20:46', NULL, NULL, 1912, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 21:20:46', 'sanni-1470976926-14710080465877041', 1, 0, '', NULL, NULL, NULL),
(5323, '2016-08-12 21:18:48', NULL, NULL, 1920, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 21:18:48', 'sanni-1470976926-1471007928361893', 1, 1, 'SR', NULL, NULL, NULL),
(5324, '2016-08-12 21:18:48', NULL, NULL, 1920, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 21:18:48', 'sanni-1470976926-1471007928361893', 1, 1, 'SR', NULL, NULL, NULL),
(5325, '2016-08-12 21:18:48', NULL, NULL, 1920, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 21:18:48', 'sanni-1470976926-1471007928361893', 1, 1, 'SR', NULL, NULL, NULL),
(5326, '2016-08-12 21:11:32', NULL, NULL, 1919, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 21:11:32', 'sanni-1470976926-14710074920786795', 1, 0, '', NULL, NULL, NULL),
(5327, '2016-08-12 21:18:48', NULL, NULL, 1920, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 21:18:48', 'sanni-1470976926-1471007928361893', 1, 0, '', NULL, NULL, NULL),
(5328, '2016-08-12 21:11:00', NULL, NULL, 1919, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 21:11:00', 'sanni-1470976926-14710074604194211', 1, 1, 'SR', NULL, NULL, NULL),
(5329, '2016-08-12 20:31:11', NULL, NULL, 1918, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 20:31:11', 'sanni-1470976926-14710050713955877', 1, 1, 'SR', NULL, NULL, NULL),
(5330, '2016-08-12 21:11:00', NULL, NULL, 1919, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 21:11:00', 'sanni-1470976926-14710074604194211', 1, 1, 'SR', NULL, NULL, NULL),
(5331, '2016-08-12 21:11:00', NULL, NULL, 1919, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 21:11:00', 'sanni-1470976926-14710074604194211', 1, 1, 'SR', NULL, NULL, NULL),
(5332, '2016-08-12 20:12:56', NULL, NULL, 1917, 0, 198, '133', 'Dinner - Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 20:12:56', 'sanni-1470976926-1471003975896791', 1, 0, '', NULL, NULL, NULL),
(5333, '2016-08-12 20:12:56', NULL, NULL, 1917, 0, 198, '133', 'Dinner - Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 20:12:56', 'sanni-1470976926-1471003975896791', 1, 0, '', NULL, NULL, NULL),
(5334, '2016-08-12 20:12:56', NULL, NULL, 1917, 0, 199, '134', 'Dinner - Marmite Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 20:12:56', 'sanni-1470976926-1471003975896791', 1, 0, '', NULL, NULL, NULL),
(5335, '2016-08-12 20:12:56', NULL, NULL, 1917, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 20:12:56', 'sanni-1470976926-1471003975896791', 1, 0, '', NULL, NULL, NULL),
(5336, '2016-08-12 20:13:53', NULL, NULL, 1917, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 20:13:53', 'sanni-1470976926-14710040337348490', 1, 1, 'SR', NULL, NULL, NULL),
(5337, '2016-08-12 20:13:53', NULL, NULL, 1917, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 20:13:53', 'sanni-1470976926-14710040337348490', 1, 1, 'SR', NULL, NULL, NULL),
(5338, '2016-08-12 20:13:53', NULL, NULL, 1917, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 20:13:53', 'sanni-1470976926-14710040337348490', 1, 1, 'SR', NULL, NULL, NULL),
(5339, '2016-08-12 20:12:56', NULL, NULL, 1917, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 20:12:56', 'sanni-1470976926-1471003975896791', 1, 0, '', NULL, NULL, NULL),
(5340, '2016-08-12 20:12:56', NULL, NULL, 1917, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 20:12:56', 'sanni-1470976926-1471003975896791', 1, 0, '', NULL, NULL, NULL),
(5341, '2016-08-12 19:47:26', NULL, NULL, 1915, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 19:47:26', 'sanni-1470976926-14710024467653427', 1, 1, 'SR', NULL, NULL, NULL),
(5342, '2016-08-12 19:47:26', NULL, NULL, 1915, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 19:47:26', 'sanni-1470976926-14710024467653427', 1, 1, 'SR', NULL, NULL, NULL),
(5343, '2016-08-12 20:03:00', NULL, NULL, 1916, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 20:03:00', 'sanni-1470976926-14710033799629599', 1, 1, 'SR', NULL, NULL, NULL),
(5344, '2016-08-12 20:08:26', NULL, NULL, 1916, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 20:08:26', 'sanni-1470976926-14710037059138021', 1, 1, 'SR', NULL, NULL, NULL),
(5345, '2016-08-12 19:21:51', NULL, NULL, 1914, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 19:21:51', 'sanni-1470976926-1471000911348551', 1, 1, 'SR', NULL, NULL, NULL),
(5346, '2016-08-12 19:21:51', NULL, NULL, 1914, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 19:21:51', 'sanni-1470976926-1471000911348551', 1, 1, 'SR', NULL, NULL, NULL),
(5347, '2016-08-12 19:21:51', NULL, NULL, 1914, 0, 72, '72', 'Mushroom Chicken', 'Pasta', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 19:21:51', 'sanni-1470976926-1471000911348551', 1, 1, 'SR', NULL, NULL, NULL),
(5348, '2016-08-12 19:44:37', NULL, NULL, 1914, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 19:44:37', 'sanni-1470976926-14710022774388013', 1, 0, '', NULL, NULL, NULL),
(5349, '2016-08-12 19:22:01', NULL, NULL, 1914, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 19:22:01', 'sanni-1470976926-14710009210324013', 1, 1, 'SR', NULL, NULL, NULL),
(5350, '2016-08-12 19:21:51', NULL, NULL, 1914, 0, 76, '76', 'Pesto Pasta', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 19:21:51', 'sanni-1470976926-1471000911348551', 1, 1, 'SR', NULL, NULL, NULL),
(5351, '2016-08-12 18:58:40', NULL, NULL, 1914, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 18:58:40', 'sanni-1470976926-14709995201373737', 1, 1, 'SR', NULL, NULL, NULL),
(5352, '2016-08-12 19:21:51', NULL, NULL, 1914, 0, 70, '70', 'Pepper Pork', 'Pasta', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 19:21:51', 'sanni-1470976926-1471000911348551', 1, 1, 'SR', NULL, NULL, NULL),
(5353, '2016-08-12 18:58:40', NULL, NULL, 1914, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 18:58:40', 'sanni-1470976926-14709995201373737', 1, 0, '', NULL, NULL, NULL),
(5354, '2016-08-12 18:58:40', NULL, NULL, 1914, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 18:58:40', 'sanni-1470976926-14709995201373737', 1, 0, '', NULL, NULL, NULL),
(5355, '2016-08-12 12:42:33', NULL, NULL, 1901, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 12:42:33', 'sanni-1470976926-14709769536025599', 1, 0, '', NULL, NULL, NULL),
(5356, '2016-08-12 12:59:03', NULL, NULL, 1902, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 12:59:03', 'sanni-1470976926-14709779437751135', 1, 1, 'SR', NULL, NULL, NULL),
(5357, '2016-08-12 12:59:56', NULL, NULL, 1903, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 12:59:56', 'sanni-1470976926-14709779967126190', 1, 1, 'SR', NULL, NULL, NULL),
(5358, '2016-08-12 13:01:48', NULL, NULL, 1904, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 13:01:48', 'sanni-1470976926-14709781080338286', 1, 1, 'SR', NULL, NULL, NULL),
(5359, '2016-08-12 13:08:54', NULL, NULL, 1905, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 13:08:54', 'sanni-1470976926-1470978534026836', 1, 1, 'SR', NULL, NULL, NULL),
(5360, '2016-08-12 13:08:54', NULL, NULL, 1905, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 13:08:54', 'sanni-1470976926-1470978534026836', 1, 1, 'SR', NULL, NULL, NULL),
(5361, '2016-08-12 13:21:08', NULL, NULL, 1906, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 13:21:08', 'sanni-1470976926-14709792681607098', 1, 0, '', NULL, NULL, NULL),
(5362, '2016-08-12 13:21:08', NULL, NULL, 1906, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 13:21:08', 'sanni-1470976926-14709792681607098', 1, 1, 'SR', NULL, NULL, NULL),
(5363, '2016-08-12 13:34:48', NULL, NULL, 1907, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 13:34:48', 'sanni-1470976926-14709800878769495', 1, 0, '', 1, NULL, NULL),
(5364, '2016-08-12 14:01:24', NULL, NULL, 1908, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 14:01:24', 'sanni-1470976926-14709816844019278', 1, 0, '', NULL, NULL, NULL),
(5365, '2016-08-12 14:01:24', NULL, NULL, 1908, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 14:01:24', 'sanni-1470976926-14709816844019278', 1, 1, 'SR', NULL, NULL, NULL),
(5366, '2016-08-12 14:01:24', NULL, NULL, 1908, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 14:01:24', 'sanni-1470976926-14709816844019278', 1, 1, 'SR', NULL, NULL, NULL),
(5367, '2016-08-12 14:01:24', NULL, NULL, 1908, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 14:01:24', 'sanni-1470976926-14709816844019278', 1, 1, 'SR', NULL, NULL, NULL),
(5368, '2016-08-12 14:01:24', NULL, NULL, 1908, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 14:01:24', 'sanni-1470976926-14709816844019278', 1, 1, 'SR', NULL, NULL, NULL),
(5369, '2016-08-12 15:32:32', NULL, NULL, 1909, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 15:32:32', 'sanni-1470976926-14709871520795640', 1, 1, 'SR', NULL, NULL, NULL),
(5370, '2016-08-12 15:32:32', NULL, NULL, 1909, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 15:32:32', 'sanni-1470976926-14709871520795640', 1, 1, 'SR', NULL, NULL, NULL),
(5371, '2016-08-12 15:50:06', NULL, NULL, 1910, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 15:50:06', 'sanni-1470976926-14709882068094934', 1, 0, '', NULL, NULL, NULL),
(5372, '2016-08-12 15:50:06', NULL, NULL, 1910, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 15:50:06', 'sanni-1470976926-14709882068094934', 1, 1, 'SR', NULL, NULL, NULL),
(5373, '2016-08-12 16:50:40', NULL, NULL, 1911, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 16:50:40', 'sanni-1470976926-14709918404347462', 1, 1, 'SR', NULL, NULL, NULL),
(5374, '2016-08-12 16:50:40', NULL, NULL, 1911, 0, 178, '113', 'Brownies ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 16:50:40', 'sanni-1470976926-14709918404347462', 1, 0, '', NULL, NULL, NULL),
(5375, '2016-08-12 17:20:18', NULL, NULL, 1912, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 17:20:18', 'sanni-1470976926-14709936181911496', 1, 0, '', NULL, NULL, NULL),
(5376, '2016-08-12 17:20:18', NULL, NULL, 1912, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 17:20:18', 'sanni-1470976926-14709936181911496', 1, 0, '', NULL, NULL, NULL),
(5377, '2016-08-12 18:55:12', NULL, NULL, 1913, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 18:55:12', 'sanni-1470976926-14709993124735459', 1, 1, 'SR', NULL, NULL, NULL),
(5378, '2016-08-12 18:55:12', NULL, NULL, 1913, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471008056', 'sanni', '2016-08-12 18:55:12', 'sanni-1470976926-14709993124735459', 1, 1, 'SR', NULL, NULL, NULL),
(5379, '2016-08-12 12:41:56', NULL, NULL, 1900, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 12:41:56', 'admin-1470963578-14709769161944251', 1, 1, 'SR', NULL, NULL, NULL),
(5380, '2016-08-12 12:40:22', NULL, NULL, 1899, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 12:40:22', 'admin-1470963578-14709768221063472', 1, 0, '', NULL, NULL, NULL),
(5381, '2016-08-12 12:40:22', NULL, NULL, 1899, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 12:40:22', 'admin-1470963578-14709768221063472', 1, 1, 'SR', NULL, NULL, NULL),
(5382, '2016-08-12 12:40:22', NULL, NULL, 1899, 0, 83, '83', 'Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 12:40:22', 'admin-1470963578-14709768221063472', 1, 1, 'SR', NULL, NULL, NULL),
(5383, '2016-08-12 12:41:56', NULL, NULL, 1900, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 12:41:56', 'admin-1470963578-14709769161944251', 1, 1, 'SR', NULL, NULL, NULL),
(5384, '2016-08-12 12:30:48', NULL, NULL, 1898, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 12:30:48', 'admin-1470963578-14709762485444220', 1, 1, 'SR', NULL, NULL, NULL),
(5385, '2016-08-12 11:42:36', NULL, NULL, 1892, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 11:42:36', 'admin-1470963578-14709733561345248', 1, 0, '', NULL, NULL, NULL),
(5386, '2016-08-12 11:42:36', NULL, NULL, 1892, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 11:42:36', 'admin-1470963578-14709733561345248', 1, 0, '', NULL, NULL, NULL),
(5387, '2016-08-12 11:46:16', NULL, NULL, 1893, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 11:46:16', 'admin-1470963578-14709735763543937', 1, 0, '', NULL, NULL, NULL),
(5388, '2016-08-12 11:46:16', NULL, NULL, 1893, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 11:46:16', 'admin-1470963578-14709735763543937', 1, 0, '', NULL, NULL, NULL),
(5389, '2016-08-12 11:46:16', NULL, NULL, 1893, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 11:46:16', 'admin-1470963578-14709735763543937', 1, 1, 'SR', NULL, NULL, NULL),
(5390, '2016-08-12 11:47:21', NULL, NULL, 1894, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 11:47:21', 'admin-1470963578-14709736415655559', 1, 0, '', NULL, NULL, NULL),
(5391, '2016-08-12 11:47:45', NULL, NULL, 1895, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 11:47:45', 'admin-1470963578-14709736656816292', 1, 0, '', NULL, NULL, NULL),
(5392, '2016-08-12 11:49:20', NULL, NULL, 1896, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 11:49:20', 'admin-1470963578-14709737601365124', 1, 1, 'SR', NULL, NULL, NULL),
(5393, '2016-08-12 12:30:48', NULL, NULL, 1898, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 12:30:48', 'admin-1470963578-14709762485444220', 1, 0, '', NULL, NULL, NULL),
(5394, '2016-08-12 12:08:47', NULL, NULL, 1897, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 12:08:47', 'admin-1470963578-14709749273186352', 1, 1, 'SR', NULL, NULL, NULL),
(5395, '2016-08-12 12:30:48', NULL, NULL, 1898, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 12:30:48', 'admin-1470963578-14709762485444220', 1, 0, '', NULL, NULL, NULL),
(5396, '2016-08-12 12:30:48', NULL, NULL, 1898, 0, 75, '75', 'Aglio Olio ', 'Chicken', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 12:30:48', 'admin-1470963578-14709762485444220', 1, 0, '', NULL, NULL, NULL),
(5397, '2016-08-12 10:56:12', NULL, NULL, 1891, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 10:56:12', 'admin-1470963578-147097057234465', 1, 0, '', NULL, NULL, NULL),
(5398, '2016-08-12 10:56:18', NULL, NULL, 1891, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 10:56:18', 'admin-1470963578-14709705780045013', 1, 1, 'SR', NULL, NULL, NULL),
(5399, '2016-08-12 10:56:18', NULL, NULL, 1891, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 10:56:18', 'admin-1470963578-14709705780045013', 1, 1, 'SR', NULL, NULL, NULL),
(5400, '2016-08-12 10:56:12', NULL, NULL, 1891, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 10:56:12', 'admin-1470963578-147097057234465', 1, 0, '', NULL, NULL, NULL),
(5401, '2016-08-12 10:40:30', NULL, NULL, 1890, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 10:40:30', 'admin-1470963578-14709696299265866', 1, 1, 'SR', NULL, NULL, NULL),
(5402, '2016-08-12 10:40:30', NULL, NULL, 1890, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471008056', 'admin', '2016-08-12 10:40:30', 'admin-1470963578-14709696299265866', 1, 1, 'SR', NULL, NULL, NULL),
(5403, '2016-08-13 16:43:19', NULL, NULL, 1952, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 16:43:19', 'admin-1471064222-14710777993638576', 1, 0, '', NULL, NULL, NULL),
(5404, '2016-08-13 16:47:53', NULL, NULL, 1953, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 16:47:53', 'admin-1471064222-14710780737263669', 1, 1, 'SR', NULL, NULL, NULL),
(5405, '2016-08-13 16:47:53', NULL, NULL, 1953, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 16:47:53', 'admin-1471064222-14710780737263669', 1, 1, 'SR', NULL, NULL, NULL),
(5406, '2016-08-13 17:49:39', NULL, NULL, 1954, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 17:49:39', 'admin-1471064222-14710817793272537', 1, 0, '', 1, NULL, NULL),
(5407, '2016-08-13 17:49:39', NULL, NULL, 1954, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 17:49:39', 'admin-1471064222-14710817793272537', 1, 1, 'SR', 1, NULL, NULL),
(5408, '2016-08-13 18:17:32', NULL, NULL, 1955, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 18:17:32', 'admin-1471064222-14710834524534665', 1, 1, 'SR', 1, NULL, NULL),
(5409, '2016-08-13 18:18:03', NULL, NULL, 1956, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 18:18:03', 'admin-1471064222-1471083483506779', 1, 1, 'SR', 1, NULL, NULL),
(5410, '2016-08-13 18:19:13', NULL, NULL, 1957, 0, 178, '113', 'Brownies ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 18:19:13', 'admin-1471064222-14710835531745895', 1, 0, '', 1, NULL, NULL),
(5411, '2016-08-13 18:19:13', NULL, NULL, 1957, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 18:19:13', 'admin-1471064222-14710835531745895', 1, 1, 'SR', 1, NULL, NULL),
(5412, '2016-08-13 18:31:23', NULL, NULL, 1958, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 18:31:23', 'admin-1471064222-14710842831187532', 1, 1, 'SR', NULL, NULL, NULL),
(5413, '2016-08-13 18:31:23', NULL, NULL, 1958, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 18:31:23', 'admin-1471064222-14710842831187532', 1, 1, 'SR', NULL, NULL, NULL),
(5414, '2016-08-13 18:31:23', NULL, NULL, 1958, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 18:31:23', 'admin-1471064222-14710842831187532', 1, 0, '', NULL, NULL, NULL),
(5415, '2016-08-13 19:14:00', NULL, NULL, 1959, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 19:14:00', 'admin-1471064222-14710868400519934', 1, 0, '', NULL, NULL, NULL),
(5416, '2016-08-13 19:14:00', NULL, NULL, 1959, 0, 54, '54', 'Chai Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 19:14:00', 'admin-1471064222-14710868400519934', 1, 1, 'SR', NULL, NULL, NULL),
(5417, '2016-08-13 19:14:00', NULL, NULL, 1959, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 19:14:00', 'admin-1471064222-14710868400519934', 1, 1, 'SR', NULL, NULL, NULL),
(5418, '2016-08-13 19:15:55', NULL, NULL, 1960, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 19:15:55', 'admin-1471064222-14710869552119179', 1, 1, 'SR', NULL, NULL, NULL),
(5419, '2016-08-13 19:15:55', NULL, NULL, 1960, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 19:15:55', 'admin-1471064222-14710869552119179', 1, 1, 'SR', NULL, NULL, NULL),
(5420, '2016-08-13 19:28:50', NULL, NULL, 1959, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 19:28:50', 'admin-1471064222-1471087730336761', 1, 1, 'SR', NULL, NULL, NULL),
(5421, '2016-08-13 19:40:36', NULL, NULL, 1961, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 19:40:36', 'admin-1471064222-14710884359806123', 1, 1, 'SR', NULL, NULL, NULL),
(5422, '2016-08-13 19:40:36', NULL, NULL, 1961, 0, 178, '113', 'Brownies ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 19:40:36', 'admin-1471064222-14710884359806123', 1, 0, '', NULL, NULL, NULL),
(5423, '2016-08-13 20:09:37', NULL, NULL, 1962, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 20:09:37', 'admin-1471064222-14710901776654258', 1, 0, '', NULL, NULL, NULL),
(5424, '2016-08-13 20:09:37', NULL, NULL, 1962, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 20:09:37', 'admin-1471064222-14710901776654258', 1, 0, '', NULL, NULL, NULL),
(5425, '2016-08-13 21:11:12', NULL, NULL, 1963, 0, 181, '116', 'Open Food ', 'birthday cake', 'Meals', 'Perfect Meals', 1, 45.00, 45.0000, 0.0000, 45.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 21:11:12', 'admin-1471064222-1471093872530952', 1, 0, '', NULL, NULL, NULL),
(5426, '2016-08-13 16:14:40', NULL, NULL, 1950, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 16:14:40', 'admin-1471064222-14710760802265421', 1, 0, '', NULL, NULL, NULL),
(5427, '2016-08-13 16:42:39', NULL, NULL, 1951, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 16:42:39', 'admin-1471064222-14710777590758856', 1, 1, 'SR', 1, NULL, NULL),
(5428, '2016-08-13 16:00:39', NULL, NULL, 1949, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 16:00:39', 'admin-1471064222-1471075238882871', 1, 1, 'SR', NULL, NULL, NULL),
(5429, '2016-08-13 14:50:43', NULL, NULL, 1947, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 14:50:43', 'admin-1471064222-14710710428438878', 1, 1, 'SR', NULL, NULL, NULL),
(5430, '2016-08-13 16:00:39', NULL, NULL, 1949, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 16:00:39', 'admin-1471064222-1471075238882871', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(5431, '2016-08-13 16:00:39', NULL, NULL, 1949, 0, 182, '117', 'Open Drinks ', 'tea', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 16:00:39', 'admin-1471064222-1471075238882871', 1, 0, '', NULL, NULL, NULL),
(5432, '2016-08-13 16:00:39', NULL, NULL, 1949, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 16:00:39', 'admin-1471064222-1471075238882871', 1, 0, '', NULL, NULL, NULL),
(5433, '2016-08-13 15:04:38', NULL, NULL, 1948, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 15:04:38', 'admin-1471064222-14710718783575896', 1, 0, '', NULL, NULL, NULL),
(5434, '2016-08-13 15:00:05', NULL, NULL, 1948, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 15:00:05', 'admin-1471064222-14710716052862455', 1, 1, 'SR', NULL, NULL, NULL),
(5435, '2016-08-13 15:00:05', NULL, NULL, 1948, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 15:00:05', 'admin-1471064222-14710716052862455', 1, 1, 'SR', NULL, NULL, NULL),
(5436, '2016-08-13 14:50:43', NULL, NULL, 1947, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 14:50:43', 'admin-1471064222-14710710428438878', 1, 1, 'SR', NULL, NULL, NULL),
(5437, '2016-08-13 14:50:26', NULL, NULL, 1946, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 14:50:26', 'admin-1471064222-14710710259859374', 1, 1, 'SR', NULL, NULL, NULL),
(5438, '2016-08-13 14:50:26', NULL, NULL, 1946, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 14:50:26', 'admin-1471064222-14710710259859374', 1, 1, 'SR', NULL, NULL, NULL),
(5439, '2016-08-13 14:50:26', NULL, NULL, 1946, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 14:50:26', 'admin-1471064222-14710710259859374', 1, 1, 'SR', NULL, NULL, NULL),
(5440, '2016-08-13 16:14:40', NULL, NULL, 1950, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 16:14:40', 'admin-1471064222-14710760802265421', 1, 0, '', NULL, NULL, NULL),
(5441, '2016-08-13 13:13:51', NULL, NULL, 1941, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 13:13:51', 'admin-1471064222-14710652315599879', 1, 1, 'SR', NULL, NULL, NULL),
(5442, '2016-08-13 13:24:48', NULL, NULL, 1943, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 13:24:48', 'admin-1471064222-1471065888351838', 1, 1, 'SR', NULL, NULL, NULL),
(5443, '2016-08-13 14:29:29', NULL, NULL, 1944, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 14:29:29', 'admin-1471064222-14710697689902116', 1, 0, '', NULL, NULL, NULL),
(5444, '2016-08-13 14:29:29', NULL, NULL, 1944, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 14:29:29', 'admin-1471064222-14710697689902116', 1, 1, 'SR', NULL, NULL, NULL),
(5445, '2016-08-13 14:29:29', NULL, NULL, 1944, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 14:29:29', 'admin-1471064222-14710697689902116', 1, 1, 'SR', NULL, NULL, NULL),
(5446, '2016-08-13 14:31:06', NULL, NULL, 1945, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 14:31:06', 'admin-1471064222-14710698661177649', 1, 1, 'SR', NULL, NULL, NULL),
(5447, '2016-08-13 14:31:06', NULL, NULL, 1945, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 14:31:06', 'admin-1471064222-14710698661177649', 1, 1, 'SR', NULL, NULL, NULL),
(5448, '2016-08-13 12:54:10', NULL, NULL, 1939, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 12:54:10', 'admin-1471059503-14710640502703338', 1, 1, 'SR', NULL, NULL, NULL),
(5449, '2016-08-13 12:56:37', NULL, NULL, 1940, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 12:56:37', 'admin-1471059503-14710641970983252', 1, 1, 'SR', NULL, NULL, NULL),
(5450, '2016-08-13 12:54:10', NULL, NULL, 1939, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 12:54:10', 'admin-1471059503-14710640502703338', 1, 1, 'SR', NULL, NULL, NULL),
(5451, '2016-08-13 12:56:37', NULL, NULL, 1940, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 12:56:37', 'admin-1471059503-14710641970983252', 1, 1, 'SR', NULL, NULL, NULL),
(5452, '2016-08-13 12:34:41', NULL, NULL, 1938, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 12:34:41', 'admin-1471059503-14710628815271611', 1, 1, 'SR', NULL, NULL, NULL),
(5453, '2016-08-13 12:34:41', NULL, NULL, 1938, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 12:34:41', 'admin-1471059503-14710628815271611', 1, 1, 'SR', NULL, NULL, NULL),
(5454, '2016-08-13 11:05:28', NULL, NULL, 1930, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 11:05:28', 'admin-1471056200-14710575280369374', 1, 1, 'SR', NULL, NULL, NULL),
(5455, '2016-08-13 11:05:28', NULL, NULL, 1930, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 11:05:28', 'admin-1471056200-14710575280369374', 1, 1, 'SR', NULL, NULL, NULL),
(5456, '2016-08-13 11:05:28', NULL, NULL, 1930, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 11:05:28', 'admin-1471056200-14710575280369374', 1, 0, '', NULL, NULL, NULL),
(5457, '2016-08-13 11:07:56', NULL, NULL, 1931, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 11:07:56', 'admin-1471056200-14710576758401429', 1, 0, '', NULL, NULL, NULL),
(5458, '2016-08-13 11:07:56', NULL, NULL, 1931, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 11:07:56', 'admin-1471056200-14710576758401429', 1, 0, '', NULL, NULL, NULL),
(5459, '2016-08-13 12:14:59', NULL, NULL, 1937, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 12:14:59', 'admin-1471059503-14710616992597485', 1, 1, 'SR', NULL, NULL, NULL),
(5460, '2016-08-13 12:14:59', NULL, NULL, 1937, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 12:14:59', 'admin-1471059503-14710616992597485', 1, 0, '', NULL, NULL, NULL),
(5461, '2016-08-13 12:01:04', NULL, NULL, 1936, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 12:01:04', 'admin-1471059503-1471060864127462', 1, 1, 'SR', NULL, NULL, NULL),
(5462, '2016-08-13 12:00:52', NULL, NULL, 1936, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 12:00:52', 'admin-1471059503-14710608524104955', 1, 1, 'SR', NULL, NULL, NULL),
(5463, '2016-08-13 12:00:52', NULL, NULL, 1936, 0, 79, '79', 'Summer Salad ', 'ADD 4 BACONS', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 12:00:52', 'admin-1471059503-14710608524104955', 1, 1, 'SR', NULL, NULL, NULL),
(5464, '2016-08-13 11:44:56', NULL, NULL, 1935, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 11:44:56', 'admin-1471059503-14710598965798336', 1, 0, '', NULL, NULL, NULL),
(5465, '2016-08-13 11:40:08', NULL, NULL, 1934, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 11:40:08', 'admin-1471059503-147105960852014', 1, 1, 'SR', NULL, NULL, NULL),
(5466, '2016-08-13 11:39:27', NULL, NULL, 1933, 0, 182, '117', 'Open Drinks ', 'tea', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 11:39:27', 'admin-1471059503-14710595669524864', 1, 0, '', NULL, NULL, NULL),
(5467, '2016-08-13 11:39:27', NULL, NULL, 1933, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 11:39:27', 'admin-1471059503-14710595669524864', 1, 1, 'SR', NULL, NULL, NULL),
(5468, '2016-08-13 11:39:27', NULL, NULL, 1933, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 11:39:27', 'admin-1471059503-14710595669524864', 1, 0, '', NULL, NULL, NULL),
(5469, '2016-08-13 11:38:16', NULL, NULL, 1932, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 11:38:16', 'admin-1471056200-14710594959605620', 1, 0, '', NULL, NULL, NULL),
(5470, '2016-08-13 11:38:16', NULL, NULL, 1932, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 11:38:16', 'admin-1471056200-14710594959605620', 1, 0, '', NULL, NULL, NULL),
(5471, '2016-08-13 11:15:44', NULL, NULL, 1926, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 11:15:44', 'admin-1471056200-14710581444816412', 1, 0, '', NULL, NULL, NULL),
(5472, '2016-08-13 11:15:44', NULL, NULL, 1926, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 11:15:44', 'admin-1471056200-14710581444816412', 1, 1, 'SR', NULL, NULL, NULL),
(5473, '2016-08-13 11:07:56', NULL, NULL, 1931, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 11:07:56', 'admin-1471056200-14710576758401429', 1, 1, 'SR', NULL, NULL, NULL),
(5474, '2016-08-13 11:07:56', NULL, NULL, 1931, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 11:07:56', 'admin-1471056200-14710576758401429', 1, 1, 'SR', NULL, NULL, NULL),
(5475, '2016-08-13 11:07:56', NULL, NULL, 1931, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 11:07:56', 'admin-1471056200-14710576758401429', 1, 1, 'SR', NULL, NULL, NULL),
(5476, '2016-08-13 11:07:56', NULL, NULL, 1931, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 11:07:56', 'admin-1471056200-14710576758401429', 1, 0, '', NULL, NULL, NULL),
(5477, '2016-08-13 11:07:56', NULL, NULL, 1931, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 11:07:56', 'admin-1471056200-14710576758401429', 1, 0, '', NULL, NULL, NULL),
(5478, '2016-08-13 11:04:32', NULL, NULL, 1930, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 11:04:32', 'admin-1471056200-14710574726702223', 1, 0, '', NULL, NULL, NULL),
(5479, '2016-08-13 10:37:38', NULL, NULL, 1926, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 10:37:38', 'admin-1471049773-14710558581383066', 1, 0, '', NULL, NULL, NULL),
(5480, '2016-08-13 10:41:35', NULL, NULL, 1927, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 10:41:35', 'admin-1471049773-1471056095502743', 1, 0, '', NULL, NULL, NULL),
(5481, '2016-08-13 10:41:35', NULL, NULL, 1927, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 10:41:35', 'admin-1471049773-1471056095502743', 1, 1, 'SR', NULL, NULL, NULL),
(5482, '2016-08-13 10:43:42', NULL, NULL, 1928, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 10:43:42', 'admin-1471056200-14710562219383458', 1, 0, '', NULL, NULL, NULL),
(5483, '2016-08-13 10:43:42', NULL, NULL, 1928, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 10:43:42', 'admin-1471056200-14710562219383458', 1, 1, 'SR', NULL, NULL, NULL),
(5484, '2016-08-13 09:25:30', NULL, NULL, 1923, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 09:25:30', 'admin-1471049773-14710515303885318', 1, 1, 'SR', NULL, NULL, NULL),
(5485, '2016-08-13 09:31:36', NULL, NULL, 1924, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 09:31:36', 'admin-1471049773-14710518960075957', 1, 0, '', NULL, NULL, NULL),
(5486, '2016-08-13 09:31:36', NULL, NULL, 1924, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 09:31:36', 'admin-1471049773-14710518960075957', 1, 0, '', NULL, NULL, NULL),
(5487, '2016-08-13 09:31:36', NULL, NULL, 1924, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 09:31:36', 'admin-1471049773-14710518960075957', 1, 1, 'SR', NULL, NULL, NULL),
(5488, '2016-08-13 09:31:36', NULL, NULL, 1924, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 09:31:36', 'admin-1471049773-14710518960075957', 1, 1, 'SR', NULL, NULL, NULL),
(5489, '2016-08-13 10:15:41', NULL, NULL, 1925, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 10:15:41', 'admin-1471049773-14710545413697521', 1, 0, '', NULL, NULL, NULL),
(5490, '2016-08-13 10:15:41', NULL, NULL, 1925, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 10:15:41', 'admin-1471049773-14710545413697521', 1, 0, '', NULL, NULL, NULL),
(5491, '2016-08-13 10:15:41', NULL, NULL, 1925, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 10:15:41', 'admin-1471049773-14710545413697521', 1, 0, '', NULL, NULL, NULL),
(5492, '2016-08-13 10:17:15', NULL, NULL, 1925, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 10:17:15', 'admin-1471049773-14710546357978323', 1, 0, '', NULL, NULL, NULL),
(5493, '2016-08-13 10:18:16', NULL, NULL, 1925, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 10:18:16', 'admin-1471049773-14710546959005233', 1, 1, 'SR', NULL, NULL, NULL),
(5494, '2016-08-13 10:17:15', NULL, NULL, 1925, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 10:17:15', 'admin-1471049773-14710546357978323', 1, 1, 'SR', NULL, NULL, NULL),
(5495, '2016-08-13 10:20:22', NULL, NULL, 1926, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 10:20:22', 'admin-1471049773-14710548219155558', 1, 0, '', NULL, NULL, NULL),
(5496, '2016-08-13 10:20:22', NULL, NULL, 1926, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 10:20:22', 'admin-1471049773-14710548219155558', 1, 0, '', NULL, NULL, NULL),
(5497, '2016-08-13 10:20:22', NULL, NULL, 1926, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 10:20:22', 'admin-1471049773-14710548219155558', 1, 0, '', NULL, NULL, NULL),
(5498, '2016-08-13 10:44:04', NULL, NULL, 1929, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 10:44:04', 'admin-1471056200-14710562441543127', 1, 1, 'SR', NULL, NULL, NULL),
(5499, '2016-08-13 09:25:30', NULL, NULL, 1923, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 09:25:30', 'admin-1471049773-14710515303885318', 1, 1, 'SR', NULL, NULL, NULL),
(5500, '2016-08-13 09:25:30', NULL, NULL, 1923, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 09:25:30', 'admin-1471049773-14710515303885318', 1, 0, '', NULL, NULL, NULL),
(5501, '2016-08-13 09:25:30', NULL, NULL, 1923, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471064222', 'admin', '2016-08-13 09:25:30', 'admin-1471049773-14710515303885318', 1, 0, '', NULL, NULL, NULL),
(5502, '2016-08-14 17:16:12', NULL, NULL, 2005, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 17:16:12', 'admin-1471145944-1471166172195131', 1, 0, '', NULL, NULL, NULL),
(5503, '2016-08-14 17:16:27', NULL, NULL, 2003, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 17:16:27', 'admin-1471145944-14711661871001422', 1, 0, '', NULL, NULL, NULL),
(5504, '2016-08-14 17:16:34', NULL, NULL, 2003, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 17:16:34', 'admin-1471145944-14711661945419830', 1, 1, 'SR', NULL, NULL, NULL),
(5505, '2016-08-14 17:16:34', NULL, NULL, 2003, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 17:16:34', 'admin-1471145944-14711661945419830', 1, 1, 'SR', NULL, NULL, NULL),
(5506, '2016-08-14 17:16:48', NULL, NULL, 2005, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 17:16:48', 'admin-1471145944-1471166208620256', 1, 0, '', NULL, NULL, NULL),
(5507, '2016-08-14 17:18:38', NULL, NULL, 2006, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 17:18:38', 'admin-1471145944-14711663178266633', 1, 1, 'SR', NULL, NULL, NULL),
(5508, '2016-08-14 17:18:38', NULL, NULL, 2006, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 17:18:38', 'admin-1471145944-14711663178266633', 1, 1, 'SR', NULL, NULL, NULL),
(5509, '2016-08-14 17:22:16', NULL, NULL, 2008, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 17:22:16', 'admin-1471145944-14711665362117629', 1, 1, 'SR', NULL, NULL, NULL),
(5510, '2016-08-14 17:22:16', NULL, NULL, 2008, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 17:22:16', 'admin-1471145944-14711665362117629', 1, 1, 'SR', NULL, NULL, NULL),
(5511, '2016-08-14 17:22:16', NULL, NULL, 2008, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 17:22:16', 'admin-1471145944-14711665362117629', 1, 1, 'SR', NULL, NULL, NULL),
(5512, '2016-08-14 17:35:29', NULL, NULL, 2007, 0, 182, '117', 'Open Drinks ', 'macchiato', 'Desserts', '0', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 17:35:29', 'admin-1471166545-14711673296148565', 1, 0, '', 1, NULL, NULL),
(5513, '2016-08-14 18:36:29', NULL, NULL, 2009, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 18:36:29', 'admin-1471166545-1471170989175361', 1, 1, 'SR', 1, NULL, NULL),
(5514, '2016-08-14 16:20:09', NULL, NULL, 2001, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 16:20:09', 'admin-1471145944-14711628096165767', 1, 0, '', NULL, NULL, NULL),
(5515, '2016-08-14 16:40:29', NULL, NULL, 2002, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 16:40:29', 'admin-1471145944-14711640294159432', 1, 0, '', NULL, NULL, NULL),
(5516, '2016-08-14 16:52:22', NULL, NULL, 2003, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 16:52:22', 'admin-1471145944-1471164742119143', 1, 0, '', NULL, NULL, NULL),
(5517, '2016-08-14 16:52:32', NULL, NULL, 2003, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 16:52:32', 'admin-1471145944-1471164752509471', 1, 1, 'SR', NULL, NULL, NULL),
(5518, '2016-08-14 16:52:32', NULL, NULL, 2003, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 16:52:32', 'admin-1471145944-1471164752509471', 1, 1, 'SR', NULL, NULL, NULL),
(5519, '2016-08-14 16:56:56', NULL, NULL, 2004, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 16:56:56', 'admin-1471145944-14711650158126425', 1, 1, 'SR', NULL, NULL, NULL),
(5520, '2016-08-14 17:16:12', NULL, NULL, 2005, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 17:16:12', 'admin-1471145944-1471166172195131', 1, 1, 'SR', NULL, NULL, NULL),
(5521, '2016-08-14 17:16:12', NULL, NULL, 2005, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 17:16:12', 'admin-1471145944-1471166172195131', 1, 1, 'SR', NULL, NULL, NULL),
(5522, '2016-08-14 17:16:12', NULL, NULL, 2005, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 17:16:12', 'admin-1471145944-1471166172195131', 1, 1, 'SR', NULL, NULL, NULL),
(5523, '2016-08-14 15:49:31', NULL, NULL, 2000, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 15:49:31', 'admin-1471145944-14711609713911059', 1, 1, 'SR', 1, NULL, NULL),
(5524, '2016-08-14 12:31:25', NULL, NULL, 1987, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 12:31:25', 'admin-1471145944-14711490857988242', 1, 1, 'SR', NULL, NULL, NULL),
(5525, '2016-08-14 12:59:35', NULL, NULL, 1989, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 12:59:35', 'admin-1471145944-14711507750033547', 1, 1, 'SR', NULL, NULL, NULL),
(5526, '2016-08-14 12:59:35', NULL, NULL, 1989, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 12:59:35', 'admin-1471145944-14711507750033547', 1, 1, 'SR', NULL, NULL, NULL),
(5527, '2016-08-14 13:15:18', NULL, NULL, 1990, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 13:15:18', 'admin-1471145944-14711517182289181', 1, 1, 'SR', NULL, NULL, NULL),
(5528, '2016-08-14 13:15:18', NULL, NULL, 1990, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 13:15:18', 'admin-1471145944-14711517182289181', 1, 1, 'SR', NULL, NULL, NULL),
(5529, '2016-08-14 13:18:29', NULL, NULL, 1991, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 13:18:29', 'admin-1471145944-14711519089395263', 1, 1, 'SR', NULL, NULL, NULL),
(5530, '2016-08-14 13:18:29', NULL, NULL, 1991, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 13:18:29', 'admin-1471145944-14711519089395263', 1, 1, 'SR', NULL, NULL, NULL),
(5531, '2016-08-14 13:18:29', NULL, NULL, 1991, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 13:18:29', 'admin-1471145944-14711519089395263', 1, 1, 'SR', NULL, NULL, NULL),
(5532, '2016-08-14 13:18:29', NULL, NULL, 1991, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 13:18:29', 'admin-1471145944-14711519089395263', 1, 1, 'SR', NULL, NULL, NULL),
(5533, '2016-08-14 13:27:39', NULL, NULL, 1992, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 13:27:39', 'admin-1471145944-14711524593835394', 1, 1, 'SR', NULL, NULL, NULL),
(5534, '2016-08-14 13:49:42', NULL, NULL, 1993, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 13:49:42', 'admin-1471145944-14711537827795881', 1, 1, 'SR', NULL, NULL, NULL),
(5535, '2016-08-14 13:49:42', NULL, NULL, 1993, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 13:49:42', 'admin-1471145944-14711537827795881', 1, 1, 'SR', NULL, NULL, NULL),
(5536, '2016-08-14 13:49:43', NULL, NULL, 1993, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 13:49:43', 'admin-1471145944-14711537827795881', 1, 0, '', NULL, NULL, NULL),
(5537, '2016-08-14 14:08:04', NULL, NULL, 1994, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 14:08:04', 'admin-1471145944-14711548840586175', 1, 1, 'SR', NULL, NULL, NULL),
(5538, '2016-08-14 14:08:04', NULL, NULL, 1994, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 14:08:04', 'admin-1471145944-14711548840586175', 1, 1, 'SR', NULL, NULL, NULL),
(5539, '2016-08-14 14:16:41', NULL, NULL, 1995, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 14:16:41', 'admin-1471145944-14711554011517164', 1, 0, '', 1, NULL, NULL),
(5540, '2016-08-14 14:16:41', NULL, NULL, 1995, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 14:16:41', 'admin-1471145944-14711554011517164', 1, 1, 'SR', 1, NULL, NULL),
(5541, '2016-08-14 14:37:41', NULL, NULL, 1996, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 14:37:41', 'admin-1471145944-14711566616017495', 1, 1, 'SR', 1, NULL, NULL),
(5542, '2016-08-14 14:40:43', NULL, NULL, 1997, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 14:40:43', 'admin-1471145944-14711568435968420', 1, 0, '', 1, NULL, NULL),
(5543, '2016-08-14 14:40:43', NULL, NULL, 1997, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 14:40:43', 'admin-1471145944-14711568435968420', 1, 1, 'SR', 1, NULL, NULL),
(5544, '2016-08-14 14:49:12', NULL, NULL, 1998, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 14:49:12', 'admin-1471145944-14711573525197075', 1, 0, '', NULL, NULL, NULL),
(5545, '2016-08-14 14:49:12', NULL, NULL, 1998, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 14:49:12', 'admin-1471145944-14711573525197075', 1, 0, '', NULL, NULL, NULL),
(5546, '2016-08-14 14:49:12', NULL, NULL, 1998, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 14:49:12', 'admin-1471145944-14711573525197075', 1, 1, 'SR', NULL, NULL, NULL),
(5547, '2016-08-14 15:20:28', NULL, NULL, 1999, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 15:20:28', 'admin-1471145944-14711592287378518', 1, 0, '', NULL, NULL, NULL),
(5548, '2016-08-14 15:20:28', NULL, NULL, 1999, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 15:20:28', 'admin-1471145944-14711592287378518', 1, 0, '', NULL, NULL, NULL),
(5549, '2016-08-14 17:16:12', NULL, NULL, 2005, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 17:16:12', 'admin-1471145944-1471166172195131', 1, 1, 'SR', NULL, NULL, NULL),
(5550, '2016-08-14 16:20:09', NULL, NULL, 2001, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 16:20:09', 'admin-1471145944-14711628096165767', 1, 1, 'SR', NULL, NULL, NULL),
(5551, '2016-08-14 15:49:31', NULL, NULL, 2000, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 15:49:31', 'admin-1471145944-14711609713911059', 1, 0, '', 1, NULL, NULL),
(5552, '2016-08-14 15:20:28', NULL, NULL, 1999, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 15:20:28', 'admin-1471145944-14711592287378518', 1, 1, 'SR', NULL, NULL, NULL),
(5553, '2016-08-14 15:20:28', NULL, NULL, 1999, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 15:20:28', 'admin-1471145944-14711592287378518', 1, 1, 'SR', NULL, NULL, NULL),
(5554, '2016-08-14 11:25:48', NULL, NULL, 1984, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 11:25:48', 'admin-1471143579-14711451487691556', 1, 0, '', NULL, NULL, NULL),
(5555, '2016-08-14 11:25:48', NULL, NULL, 1984, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 11:25:48', 'admin-1471143579-14711451487691556', 1, 1, 'SR', NULL, NULL, NULL),
(5556, '2016-08-14 11:25:48', NULL, NULL, 1984, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 11:25:48', 'admin-1471143579-14711451487691556', 1, 0, '', NULL, NULL, NULL),
(5557, '2016-08-14 11:38:05', NULL, NULL, 1985, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 11:38:05', 'admin-1471143579-14711458857534862', 1, 0, '', NULL, NULL, NULL),
(5558, '2016-08-14 12:20:13', NULL, NULL, 1987, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 12:20:13', 'admin-1471145944-14711484129134676', 1, 1, 'SR', NULL, NULL, NULL),
(5559, '2016-08-14 12:25:56', NULL, NULL, 1988, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 12:25:56', 'admin-1471145944-14711487561661243', 1, 0, '', NULL, NULL, NULL),
(5560, '2016-08-14 12:20:02', NULL, NULL, 1987, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 12:20:02', 'admin-1471145944-14711484019294784', 1, 1, 'SR', NULL, NULL, NULL),
(5561, '2016-08-14 12:09:35', NULL, NULL, 1986, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 12:09:35', 'admin-1471145944-14711477750329149', 1, 0, '', NULL, NULL, NULL),
(5562, '2016-08-14 12:20:02', NULL, NULL, 1987, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 12:20:02', 'admin-1471145944-14711484019294784', 1, 0, '', NULL, NULL, NULL),
(5563, '2016-08-14 11:38:21', NULL, NULL, 1985, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 11:38:21', 'admin-1471143579-14711459016379966', 1, 1, 'SR', NULL, NULL, NULL),
(5564, '2016-08-14 11:38:53', NULL, NULL, 1985, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 11:38:53', 'admin-1471143579-14711459327813641', 1, 0, '', NULL, NULL, NULL),
(5565, '2016-08-14 11:38:21', NULL, NULL, 1985, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 11:38:21', 'admin-1471143579-14711459016379966', 1, 1, 'SR', NULL, NULL, NULL),
(5566, '2016-08-14 11:38:05', NULL, NULL, 1985, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 11:38:05', 'admin-1471143579-14711458857534862', 1, 0, '', NULL, NULL, NULL),
(5567, '2016-08-14 11:18:02', NULL, NULL, 1983, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 11:18:02', 'admin-1471143579-1471144682178531', 1, 1, 'SR', NULL, NULL, NULL),
(5568, '2016-08-14 11:25:48', NULL, NULL, 1984, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 11:25:48', 'admin-1471143579-14711451487691556', 1, 0, '', NULL, NULL, NULL),
(5569, '2016-08-14 12:25:56', NULL, NULL, 1988, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 12:25:56', 'admin-1471145944-14711487561661243', 1, 0, '', NULL, NULL, NULL),
(5570, '2016-08-14 11:13:52', NULL, NULL, 1982, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 11:13:52', 'admin-1471143579-1471144431945263', 1, 0, '', NULL, NULL, NULL),
(5571, '2016-08-14 11:18:02', NULL, NULL, 1983, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 11:18:02', 'admin-1471143579-1471144682178531', 1, 0, '', NULL, NULL, NULL),
(5572, '2016-08-14 11:18:02', NULL, NULL, 1983, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 11:18:02', 'admin-1471143579-1471144682178531', 1, 0, '', NULL, NULL, NULL),
(5573, '2016-08-14 11:18:02', NULL, NULL, 1983, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 11:18:02', 'admin-1471143579-1471144682178531', 1, 0, '', NULL, NULL, NULL),
(5574, '2016-08-14 11:18:02', NULL, NULL, 1983, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 11:18:02', 'admin-1471143579-1471144682178531', 1, 1, 'SR', NULL, NULL, NULL),
(5575, '2016-08-14 11:18:02', NULL, NULL, 1983, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 11:18:02', 'admin-1471143579-1471144682178531', 1, 1, 'SR', NULL, NULL, NULL),
(5576, '2016-08-14 11:18:02', NULL, NULL, 1983, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 11:18:02', 'admin-1471143579-1471144682178531', 1, 1, 'SR', NULL, NULL, NULL),
(5577, '2016-08-14 10:54:48', NULL, NULL, 1981, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:54:48', 'admin-1471142633-14711432879982238', 1, 0, '', NULL, NULL, NULL),
(5578, '2016-08-14 10:55:18', NULL, NULL, 1981, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:55:18', 'admin-1471142633-14711433180993785', 1, 1, 'SR', NULL, NULL, NULL),
(5579, '2016-08-14 10:55:18', NULL, NULL, 1981, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:55:18', 'admin-1471142633-14711433180993785', 1, 1, 'SR', NULL, NULL, NULL),
(5580, '2016-08-14 11:07:55', NULL, NULL, 1982, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 11:07:55', 'admin-1471143579-1471144075067497', 1, 0, '', NULL, NULL, NULL),
(5581, '2016-08-14 10:43:07', NULL, NULL, 1979, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:43:07', 'admin-1471142546-14711425872285243', 1, 1, 'SR', NULL, NULL, NULL),
(5582, '2016-08-14 10:46:31', NULL, NULL, 1980, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:46:31', 'admin-1471142633-14711427913753753', 1, 0, '', NULL, NULL, NULL),
(5583, '2016-08-14 10:46:35', NULL, NULL, 1980, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:46:35', 'admin-1471142633-14711427956267521', 1, 1, 'SR', NULL, NULL, NULL),
(5584, '2016-08-14 10:54:48', NULL, NULL, 1981, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:54:48', 'admin-1471142633-14711432879982238', 1, 0, '', NULL, NULL, NULL),
(5585, '2016-08-14 10:54:48', NULL, NULL, 1981, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:54:48', 'admin-1471142633-14711432879982238', 1, 0, '', NULL, NULL, NULL),
(5586, '2016-08-14 09:45:40', NULL, NULL, 1973, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:45:40', 'admin-1471138765-14711391405356974', 1, 1, 'SR', NULL, NULL, NULL),
(5587, '2016-08-14 09:46:05', NULL, NULL, 1973, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:46:05', 'admin-1471138765-14711391649262812', 1, 1, 'SR', NULL, NULL, NULL),
(5588, '2016-08-14 09:46:05', NULL, NULL, 1973, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:46:05', 'admin-1471138765-14711391649262812', 1, 1, 'SR', NULL, NULL, NULL),
(5589, '2016-08-14 10:43:07', NULL, NULL, 1979, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:43:07', 'admin-1471142546-14711425872285243', 1, 0, '', NULL, NULL, NULL),
(5590, '2016-08-14 10:42:20', NULL, NULL, 1978, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:42:20', 'admin-1471138765-14711425400917477', 1, 1, 'SR', NULL, NULL, NULL),
(5591, '2016-08-14 10:42:20', NULL, NULL, 1978, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:42:20', 'admin-1471138765-14711425400917477', 1, 0, '', NULL, NULL, NULL),
(5592, '2016-08-14 10:42:20', NULL, NULL, 1978, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:42:20', 'admin-1471138765-14711425400917477', 1, 0, '', NULL, NULL, NULL),
(5593, '2016-08-14 10:40:59', NULL, NULL, 1977, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:40:59', 'admin-1471138765-14711424592449295', 1, 1, 'SR', NULL, NULL, NULL),
(5594, '2016-08-14 10:40:59', NULL, NULL, 1977, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:40:59', 'admin-1471138765-14711424592449295', 1, 1, 'SR', NULL, NULL, NULL),
(5595, '2016-08-14 10:40:59', NULL, NULL, 1977, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:40:59', 'admin-1471138765-14711424592449295', 1, 0, '', NULL, NULL, NULL),
(5596, '2016-08-14 10:40:00', NULL, NULL, 1976, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:40:00', 'admin-1471138765-14711424006235173', 1, 1, 'SR', NULL, NULL, NULL),
(5597, '2016-08-14 10:40:00', NULL, NULL, 1976, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:40:00', 'admin-1471138765-14711424006235173', 1, 1, 'SR', NULL, NULL, NULL),
(5598, '2016-08-14 10:40:00', NULL, NULL, 1976, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:40:00', 'admin-1471138765-14711424006235173', 1, 0, '', NULL, NULL, NULL),
(5599, '2016-08-14 10:38:48', NULL, NULL, 1975, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:38:48', 'admin-1471138765-14711423284212449', 1, 1, 'SR', NULL, NULL, NULL),
(5600, '2016-08-14 10:38:48', NULL, NULL, 1975, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:38:48', 'admin-1471138765-14711423284212449', 1, 1, 'SR', NULL, NULL, NULL),
(5601, '2016-08-14 10:38:48', NULL, NULL, 1975, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:38:48', 'admin-1471138765-14711423284212449', 1, 0, '', NULL, NULL, NULL),
(5602, '2016-08-14 10:08:35', NULL, NULL, 1974, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:08:35', 'admin-1471138765-14711405153138571', 1, 1, 'SR', NULL, NULL, NULL),
(5603, '2016-08-14 10:38:48', NULL, NULL, 1975, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:38:48', 'admin-1471138765-14711423284212449', 1, 0, '', NULL, NULL, NULL),
(5604, '2016-08-14 10:08:35', NULL, NULL, 1974, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:08:35', 'admin-1471138765-14711405153138571', 1, 1, 'SR', NULL, NULL, NULL),
(5605, '2016-08-14 10:08:35', NULL, NULL, 1974, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:08:35', 'admin-1471138765-14711405153138571', 1, 0, '', NULL, NULL, NULL),
(5606, '2016-08-14 10:08:35', NULL, NULL, 1974, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 10:08:35', 'admin-1471138765-14711405153138571', 1, 0, '', NULL, NULL, NULL),
(5607, '2016-08-14 09:39:16', NULL, NULL, 1970, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:39:16', 'admin-1471134284-14711387564821943', 1, 0, '', NULL, NULL, NULL),
(5608, '2016-08-14 09:39:16', NULL, NULL, 1970, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:39:16', 'admin-1471134284-14711387564821943', 1, 0, '', NULL, NULL, NULL),
(5609, '2016-08-14 09:40:56', NULL, NULL, 1971, 0, 182, '117', 'Open Drinks ', 'ice', 'Desserts', '0', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:40:56', 'admin-1471138765-1471138856448659', 1, 0, '', 1, NULL, NULL),
(5610, '2016-08-14 09:44:13', NULL, NULL, 1972, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:44:13', 'admin-1471138765-14711390535992618', 1, 1, 'SR', 1, NULL, NULL),
(5611, '2016-08-14 09:45:40', NULL, NULL, 1973, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:45:40', 'admin-1471138765-14711391405356974', 1, 0, '', NULL, NULL, NULL),
(5612, '2016-08-14 09:45:40', NULL, NULL, 1973, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:45:40', 'admin-1471138765-14711391405356974', 1, 0, '', NULL, NULL, NULL),
(5613, '2016-08-14 09:45:40', NULL, NULL, 1973, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:45:40', 'admin-1471138765-14711391405356974', 1, 0, '', NULL, NULL, NULL),
(5614, '2016-08-14 09:23:12', NULL, NULL, 1965, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:23:12', 'admin-1471134284-14711377918919123', 1, 0, '', NULL, NULL, NULL),
(5615, '2016-08-14 09:23:12', NULL, NULL, 1965, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:23:12', 'admin-1471134284-14711377918919123', 1, 0, '', NULL, NULL, NULL),
(5616, '2016-08-14 09:24:24', NULL, NULL, 1965, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:24:24', 'admin-1471134284-1471137864756998', 1, 1, 'SR', NULL, NULL, NULL),
(5617, '2016-08-14 09:24:24', NULL, NULL, 1965, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:24:24', 'admin-1471134284-1471137864756998', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(5618, '2016-08-14 09:25:55', NULL, NULL, 1966, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:25:55', 'admin-1471134284-14711379550975681', 1, 1, 'SR', NULL, NULL, NULL),
(5619, '2016-08-14 09:30:27', NULL, NULL, 1967, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:30:27', 'admin-1471134284-14711382274036719', 1, 0, '', NULL, NULL, NULL),
(5620, '2016-08-14 09:30:55', NULL, NULL, 1967, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:30:55', 'admin-1471134284-14711382554129227', 1, 0, '', NULL, NULL, NULL),
(5621, '2016-08-14 09:31:11', NULL, NULL, 1967, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:31:11', 'admin-1471134284-14711382708862046', 1, 1, 'SR', NULL, NULL, NULL),
(5622, '2016-08-14 09:31:11', NULL, NULL, 1967, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:31:11', 'admin-1471134284-14711382708862046', 1, 1, 'SR', NULL, NULL, NULL),
(5623, '2016-08-14 09:32:12', NULL, NULL, 1968, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:32:12', 'admin-1471134284-14711383325148093', 1, 0, '', NULL, NULL, NULL),
(5624, '2016-08-14 09:32:12', NULL, NULL, 1968, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:32:12', 'admin-1471134284-14711383325148093', 1, 0, '', NULL, NULL, NULL),
(5625, '2016-08-14 09:32:12', NULL, NULL, 1968, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:32:12', 'admin-1471134284-14711383325148093', 1, 1, 'SR', NULL, NULL, NULL),
(5626, '2016-08-14 09:33:06', NULL, NULL, 1969, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:33:06', 'admin-1471134284-14711383867114725', 1, 0, '', NULL, NULL, NULL),
(5627, '2016-08-14 09:33:06', NULL, NULL, 1969, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:33:06', 'admin-1471134284-14711383867114725', 1, 0, '', NULL, NULL, NULL),
(5628, '2016-08-14 09:33:06', NULL, NULL, 1969, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:33:06', 'admin-1471134284-14711383867114725', 1, 1, 'SR', NULL, NULL, NULL),
(5629, '2016-08-14 09:16:28', NULL, NULL, 1964, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:16:28', 'admin-1471134284-14711373886957856', 1, 1, 'SR', NULL, NULL, NULL),
(5630, '2016-08-14 09:16:28', NULL, NULL, 1964, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471166545', 'admin', '2016-08-14 09:16:28', 'admin-1471134284-14711373886957856', 1, 1, 'SR', NULL, NULL, NULL),
(5631, '2016-08-15 20:43:07', NULL, NULL, 2055, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 20:43:07', 'admin-1471248880-14712649873923545', 1, 0, '', NULL, NULL, '10.0'),
(5632, '2016-08-15 20:43:07', NULL, NULL, 2055, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 20:43:07', 'admin-1471248880-14712649873923545', 1, 0, '', NULL, NULL, '10.0'),
(5633, '2016-08-15 20:43:07', NULL, NULL, 2055, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 20:43:07', 'admin-1471248880-14712649873923545', 1, 0, '', NULL, NULL, '10.0'),
(5634, '2016-08-15 20:45:41', NULL, NULL, 2055, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 20:45:41', 'admin-1471248880-14712651408819337', 1, 1, 'SR', NULL, NULL, '10.0'),
(5635, '2016-08-15 20:45:41', NULL, NULL, 2055, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 20:45:41', 'admin-1471248880-14712651408819337', 1, 0, '', NULL, NULL, '10.0'),
(5636, '2016-08-15 20:45:41', NULL, NULL, 2055, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 20:45:41', 'admin-1471248880-14712651408819337', 1, 0, '', NULL, NULL, '10.0'),
(5637, '2016-08-15 20:45:41', NULL, NULL, 2055, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 20:45:41', 'admin-1471248880-14712651408819337', 1, 0, '', NULL, NULL, '10.0'),
(5638, '2016-08-15 20:47:39', NULL, NULL, 2055, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 20:47:39', 'admin-1471248880-14712652591994819', 1, 1, 'SR', NULL, NULL, '10.0'),
(5639, '2016-08-15 20:47:39', NULL, NULL, 2055, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 20:47:39', 'admin-1471248880-14712652591994819', 1, 1, 'SR', NULL, NULL, '10.0'),
(5640, '2016-08-15 21:42:33', NULL, NULL, 2056, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 21:42:33', 'admin-1471248880-14712685533504832', 1, 1, 'SR', NULL, NULL, NULL),
(5641, '2016-08-15 21:42:33', NULL, NULL, 2056, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 21:42:33', 'admin-1471248880-14712685533504832', 1, 1, 'SR', NULL, NULL, NULL),
(5642, '2016-08-15 21:42:33', NULL, NULL, 2056, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 21:42:33', 'admin-1471248880-14712685533504832', 1, 0, '', NULL, NULL, NULL),
(5643, '2016-08-15 20:43:07', NULL, NULL, 2055, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 20:43:07', 'admin-1471248880-14712649873923545', 1, 0, '', NULL, NULL, '10.0'),
(5644, '2016-08-15 20:19:49', NULL, NULL, 2054, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 20:19:49', 'admin-1471248880-14712635889577870', 1, 1, 'SR', NULL, NULL, NULL),
(5645, '2016-08-15 19:43:39', NULL, NULL, 2053, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 19:43:39', 'admin-1471248880-14712614195307866', 1, 0, '', NULL, NULL, NULL),
(5646, '2016-08-15 15:21:17', NULL, NULL, 2033, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 15:21:17', 'admin-1471234978-14712456775812026', 1, 1, 'SR', NULL, NULL, NULL),
(5647, '2016-08-15 15:21:17', NULL, NULL, 2033, NULL, 65, '65', 'Pineapple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 15:21:17', 'admin-1471234978-14712456775812026', 1, 1, 'SR', NULL, NULL, NULL),
(5648, '2016-08-15 15:21:17', NULL, NULL, 2033, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 15:21:17', 'admin-1471234978-14712456775812026', 1, 1, 'SR', NULL, NULL, NULL),
(5649, '2016-08-15 15:30:10', NULL, NULL, 2034, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 15:30:10', 'admin-1471234978-14712462100546684', 1, 1, 'SR', NULL, NULL, NULL),
(5650, '2016-08-15 15:48:51', NULL, NULL, 2035, NULL, 65, '65', 'Pineapple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 15:48:51', 'admin-1471234978-14712473312935165', 1, 1, 'SR', NULL, NULL, NULL),
(5651, '2016-08-15 15:49:01', NULL, NULL, 2035, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 15:49:01', 'admin-1471234978-14712473409932763', 1, 1, 'SR', NULL, NULL, NULL),
(5652, '2016-08-15 16:04:59', NULL, NULL, 2036, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 16:04:59', 'admin-1471234978-1471248299514417', 1, 1, 'SR', NULL, NULL, NULL),
(5653, '2016-08-15 16:04:59', NULL, NULL, 2036, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 16:04:59', 'admin-1471234978-1471248299514417', 1, 1, 'SR', NULL, NULL, NULL),
(5654, '2016-08-15 16:07:26', NULL, NULL, 2037, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 16:07:26', 'admin-1471234978-1471248446656514', 1, 1, 'SR', 1, NULL, NULL),
(5655, '2016-08-15 16:14:21', NULL, NULL, 2038, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 16:14:21', 'admin-1471234978-14712488609634916', 1, 0, '', NULL, NULL, NULL),
(5656, '2016-08-15 16:14:21', NULL, NULL, 2038, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 16:14:21', 'admin-1471234978-14712488609634916', 1, 1, 'SR', NULL, NULL, NULL),
(5657, '2016-08-15 16:14:21', NULL, NULL, 2038, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 16:14:21', 'admin-1471234978-14712488609634916', 1, 1, 'SR', NULL, NULL, NULL),
(5658, '2016-08-15 16:15:54', NULL, NULL, 2039, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 16:15:54', 'admin-1471248880-14712489546277791', 1, 1, 'SR', 1, NULL, NULL),
(5659, '2016-08-15 16:16:21', NULL, NULL, 2040, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 16:16:21', 'admin-1471248880-14712489812633139', 1, 1, 'SR', 1, NULL, NULL),
(5660, '2016-08-15 16:16:21', NULL, NULL, 2040, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 16:16:21', 'admin-1471248880-14712489812633139', 1, 1, 'SR', 1, NULL, NULL),
(5661, '2016-08-15 16:23:16', NULL, NULL, 2041, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 16:23:16', 'admin-1471248880-14712493963503680', 1, 1, 'SR', 1, NULL, NULL),
(5662, '2016-08-15 16:49:50', NULL, NULL, 2042, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 16:49:50', 'admin-1471248880-14712509901602577', 1, 0, '', NULL, NULL, NULL),
(5663, '2016-08-15 16:49:50', NULL, NULL, 2042, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 16:49:50', 'admin-1471248880-14712509901602577', 1, 0, '', NULL, NULL, NULL),
(5664, '2016-08-15 16:49:50', NULL, NULL, 2042, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 16:49:50', 'admin-1471248880-14712509901602577', 1, 0, '', NULL, NULL, NULL),
(5665, '2016-08-15 16:49:50', NULL, NULL, 2042, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 16:49:50', 'admin-1471248880-14712509901602577', 1, 1, 'SR', NULL, NULL, NULL),
(5666, '2016-08-15 16:49:50', NULL, NULL, 2042, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 16:49:50', 'admin-1471248880-14712509901602577', 1, 1, 'SR', NULL, NULL, NULL),
(5667, '2016-08-15 16:49:50', NULL, NULL, 2042, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 16:49:50', 'admin-1471248880-14712509901602577', 1, 1, 'SR', NULL, NULL, NULL),
(5668, '2016-08-15 16:49:50', NULL, NULL, 2042, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 16:49:50', 'admin-1471248880-14712509901602577', 1, 0, '', NULL, NULL, NULL),
(5669, '2016-08-15 16:49:50', NULL, NULL, 2042, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 16:49:50', 'admin-1471248880-14712509901602577', 1, 0, '', NULL, NULL, NULL),
(5670, '2016-08-15 16:49:50', NULL, NULL, 2042, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 16:49:50', 'admin-1471248880-14712509901602577', 1, 0, '', NULL, NULL, NULL),
(5671, '2016-08-15 19:43:39', NULL, NULL, 2053, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 19:43:39', 'admin-1471248880-14712614195307866', 1, 1, 'SR', NULL, NULL, NULL),
(5672, '2016-08-15 20:19:49', NULL, NULL, 2054, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 20:19:49', 'admin-1471248880-14712635889577870', 1, 1, 'SR', NULL, NULL, NULL),
(5673, '2016-08-15 19:30:28', NULL, NULL, 2052, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 19:30:28', 'admin-1471248880-1471260628483173', 1, 1, 'SR', NULL, NULL, NULL),
(5674, '2016-08-15 19:20:42', NULL, NULL, 2051, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 19:20:42', 'admin-1471248880-14712600427435745', 1, 1, 'SR', NULL, NULL, NULL),
(5675, '2016-08-15 19:30:21', NULL, NULL, 2052, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 19:30:21', 'admin-1471248880-14712606216441488', 1, 0, '', NULL, NULL, NULL),
(5676, '2016-08-15 16:49:50', NULL, NULL, 2042, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 16:49:50', 'admin-1471248880-14712509901602577', 1, 0, '', NULL, NULL, NULL),
(5677, '2016-08-15 16:59:11', NULL, NULL, 2043, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 16:59:11', 'admin-1471248880-14712515516858312', 1, 1, 'SR', NULL, NULL, NULL),
(5678, '2016-08-15 16:59:11', NULL, NULL, 2043, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 16:59:11', 'admin-1471248880-14712515516858312', 1, 1, 'SR', NULL, NULL, NULL),
(5679, '2016-08-15 17:02:46', NULL, NULL, 2044, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 17:02:46', 'admin-1471248880-1471251766515173', 1, 0, '', NULL, NULL, NULL),
(5680, '2016-08-15 17:03:43', NULL, NULL, 2042, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 17:03:43', 'admin-1471248880-14712518230587610', 1, 0, '', NULL, NULL, NULL),
(5681, '2016-08-15 19:20:42', NULL, NULL, 2051, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 19:20:42', 'admin-1471248880-14712600427435745', 1, 0, '', NULL, NULL, NULL),
(5682, '2016-08-15 19:18:11', NULL, NULL, 2051, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 19:18:11', 'admin-1471248880-14712598913966731', 1, 1, 'SR', NULL, NULL, NULL),
(5683, '2016-08-15 19:18:11', NULL, NULL, 2051, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 19:18:11', 'admin-1471248880-14712598913966731', 1, 1, 'SR', NULL, NULL, NULL),
(5684, '2016-08-15 18:52:09', NULL, NULL, 2050, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 18:52:09', 'admin-1471248880-14712583294963574', 1, 1, 'SR', 1, NULL, NULL),
(5685, '2016-08-15 18:17:18', NULL, NULL, 2048, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 18:17:18', 'admin-1471248880-14712562383201072', 1, 1, 'SR', NULL, NULL, NULL),
(5686, '2016-08-15 18:18:10', NULL, NULL, 2049, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 18:18:10', 'admin-1471248880-1471256290726999', 1, 1, 'SR', NULL, NULL, NULL),
(5687, '2016-08-15 17:35:51', NULL, NULL, 2047, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 17:35:51', 'admin-1471248880-14712537515587445', 1, 0, '', NULL, NULL, NULL),
(5688, '2016-08-15 17:35:51', NULL, NULL, 2047, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 17:35:51', 'admin-1471248880-14712537515587445', 1, 1, 'SR', NULL, NULL, NULL),
(5689, '2016-08-15 17:05:51', NULL, NULL, 2046, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 17:05:51', 'admin-1471248880-14712519514842227', 1, 1, 'SR', NULL, NULL, NULL),
(5690, '2016-08-15 17:04:50', NULL, NULL, 2045, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 17:04:50', 'admin-1471248880-14712518901634594', 1, 1, 'SR', NULL, NULL, NULL),
(5691, '2016-08-15 15:12:50', NULL, NULL, 2032, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 15:12:50', 'admin-1471234978-14712451706768849', 1, 1, 'SR', NULL, NULL, NULL),
(5692, '2016-08-15 15:12:50', NULL, NULL, 2032, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 15:12:50', 'admin-1471234978-14712451706768849', 1, 1, 'SR', NULL, NULL, NULL),
(5693, '2016-08-15 15:12:50', NULL, NULL, 2032, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 15:12:50', 'admin-1471234978-14712451706768849', 1, 0, '', NULL, NULL, NULL),
(5694, '2016-08-15 14:53:15', NULL, NULL, 2031, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 14:53:15', 'admin-1471234978-14712439950388056', 1, 0, '', 1, NULL, NULL),
(5695, '2016-08-15 14:42:40', NULL, NULL, 2030, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 14:42:40', 'admin-1471234978-14712433603471018', 1, 1, 'SR', 1, NULL, NULL),
(5696, '2016-08-15 14:42:40', NULL, NULL, 2030, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 14:42:40', 'admin-1471234978-14712433603471018', 1, 1, 'SR', 1, NULL, NULL),
(5697, '2016-08-15 14:42:40', NULL, NULL, 2030, 0, 178, '113', 'Brownies ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 14:42:40', 'admin-1471234978-14712433603471018', 1, 0, '', 1, NULL, NULL),
(5698, '2016-08-15 00:00:00', NULL, NULL, 2029, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 14:27:59', 'admin-1471234978-14712424791066384', 1, 1, 'SR', NULL, NULL, NULL),
(5699, '2016-08-15 00:00:00', NULL, NULL, 2029, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 14:27:59', 'admin-1471234978-14712424791066384', 1, 0, '', NULL, NULL, NULL),
(5700, '2016-08-15 00:00:00', NULL, NULL, 2029, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 14:27:59', 'admin-1471234978-14712424791066384', 1, 1, 'SR', NULL, NULL, NULL),
(5701, '2016-08-15 14:42:40', NULL, NULL, 2030, 0, 178, '113', 'Brownies ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 14:42:40', 'admin-1471234978-14712433603471018', 1, 0, '', 1, NULL, NULL),
(5702, '2016-08-15 12:38:08', NULL, NULL, 2026, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 12:38:08', 'admin-1471234978-14712358882137432', 1, 0, '', NULL, NULL, NULL),
(5703, '2016-08-15 12:38:08', NULL, NULL, 2026, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 12:38:08', 'admin-1471234978-14712358882137432', 1, 1, 'SR', NULL, NULL, NULL),
(5704, '2016-08-15 13:21:12', NULL, NULL, 2023, 0, 181, '116', 'Open Food ', 'pasta', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 13:21:12', 'admin-1471234978-1471238472117465', 1, 0, '', NULL, NULL, NULL),
(5705, '2016-08-15 13:21:47', NULL, NULL, 2027, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 13:21:47', 'admin-1471234978-14712385068782442', 1, 1, 'SR', NULL, NULL, NULL),
(5706, '2016-08-15 13:21:47', NULL, NULL, 2027, 0, 83, '83', 'Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 13:21:47', 'admin-1471234978-14712385068782442', 1, 1, 'SR', NULL, NULL, NULL),
(5707, '2016-08-15 13:46:56', NULL, NULL, 2028, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 13:46:56', 'admin-1471234978-14712400167473325', 1, 1, 'SR', NULL, NULL, NULL),
(5708, '2016-08-15 13:46:56', NULL, NULL, 2028, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 13:46:56', 'admin-1471234978-14712400167473325', 1, 1, 'SR', NULL, NULL, NULL),
(5709, '2016-08-15 12:34:04', NULL, NULL, 2025, 0, 81, '81', 'Pepper Pork', 'add on', 'Meals', 'Set Lunch', 1, 26.00, 26.0000, 0.0000, 26.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 12:34:04', 'admin-1471234978-1471235643923470', 1, 1, 'SR', NULL, NULL, NULL),
(5710, '2016-08-15 12:33:16', NULL, NULL, 2025, NULL, 84, '84', 'Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 12:33:16', 'admin-1471234978-14712355966974565', 1, 1, 'SR', NULL, NULL, NULL),
(5711, '2016-08-15 12:18:00', NULL, NULL, 2023, NULL, 84, '84', 'Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 12:18:00', 'admin-1471222368-1471234680371322', 1, 1, 'SR', NULL, NULL, NULL),
(5712, '2016-08-15 12:27:11', NULL, NULL, 2024, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 12:27:11', 'admin-1471234978-14712352312817335', 1, 1, 'SR', NULL, NULL, NULL),
(5713, '2016-08-15 12:17:23', NULL, NULL, 2023, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 12:17:23', 'admin-1471222368-14712346437563989', 1, 1, 'SR', NULL, NULL, NULL),
(5714, '2016-08-15 12:17:23', NULL, NULL, 2023, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 12:17:23', 'admin-1471222368-14712346437563989', 1, 1, 'SR', NULL, NULL, NULL),
(5715, '2016-08-15 12:06:19', NULL, NULL, 2022, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 12:06:19', 'admin-1471222368-14712339793408454', 1, 1, 'SR', NULL, NULL, NULL),
(5716, '2016-08-15 12:06:19', NULL, NULL, 2022, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 12:06:19', 'admin-1471222368-14712339793408454', 1, 1, 'SR', NULL, NULL, NULL),
(5717, '2016-08-15 12:06:19', NULL, NULL, 2022, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 12:06:19', 'admin-1471222368-14712339793408454', 1, 1, 'SR', NULL, NULL, NULL),
(5718, '2016-08-15 11:50:15', NULL, NULL, 2021, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 11:50:15', 'admin-1471222368-14712330155218153', 1, 1, 'SR', NULL, NULL, NULL),
(5719, '2016-08-15 11:50:15', NULL, NULL, 2021, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 11:50:15', 'admin-1471222368-14712330155218153', 1, 0, '', NULL, NULL, NULL),
(5720, '2016-08-15 11:45:08', NULL, NULL, 2020, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 11:45:08', 'admin-1471222368-1471232708281213', 1, 1, 'SR', NULL, NULL, NULL),
(5721, '2016-08-15 11:50:15', NULL, NULL, 2021, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 11:50:15', 'admin-1471222368-14712330155218153', 1, 0, '', NULL, NULL, NULL),
(5722, '2016-08-15 11:45:08', NULL, NULL, 2020, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 11:45:08', 'admin-1471222368-1471232708281213', 1, 0, '', NULL, NULL, NULL),
(5723, '2016-08-15 11:23:41', NULL, NULL, 2019, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 11:23:41', 'admin-1471222368-14712314208447113', 1, 0, '', NULL, NULL, NULL),
(5724, '2016-08-15 11:23:41', NULL, NULL, 2019, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 11:23:41', 'admin-1471222368-14712314208447113', 1, 0, '', NULL, NULL, NULL),
(5725, '2016-08-15 11:23:41', NULL, NULL, 2019, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 11:23:41', 'admin-1471222368-14712314208447113', 1, 1, 'SR', NULL, NULL, NULL),
(5726, '2016-08-15 11:23:41', NULL, NULL, 2019, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 11:23:41', 'admin-1471222368-14712314208447113', 1, 1, 'SR', NULL, NULL, NULL),
(5727, '2016-08-15 11:45:08', NULL, NULL, 2020, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 11:45:08', 'admin-1471222368-1471232708281213', 1, 1, 'SR', NULL, NULL, NULL),
(5728, '2016-08-15 10:39:11', NULL, NULL, 2016, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 10:39:11', 'admin-1471222368-14712287511269589', 1, 0, '', NULL, NULL, NULL),
(5729, '2016-08-15 10:27:53', NULL, NULL, 2015, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 10:27:53', 'admin-1471222368-14712280731569929', 1, 1, 'SR', NULL, NULL, NULL),
(5730, '2016-08-15 10:39:11', NULL, NULL, 2016, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 10:39:11', 'admin-1471222368-14712287511269589', 1, 1, 'SR', NULL, NULL, NULL),
(5731, '2016-08-15 10:39:11', NULL, NULL, 2016, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 10:39:11', 'admin-1471222368-14712287511269589', 1, 1, 'SR', NULL, NULL, NULL),
(5732, '2016-08-15 10:45:30', NULL, NULL, 2014, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 10:45:30', 'admin-1471222368-14712291299718548', 1, 0, '', NULL, NULL, NULL),
(5733, '2016-08-15 11:03:15', NULL, NULL, 2017, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 11:03:15', 'admin-1471222368-14712301955495025', 1, 1, 'SR', NULL, NULL, NULL),
(5734, '2016-08-15 11:07:37', NULL, NULL, 2018, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 11:07:37', 'admin-1471222368-14712304577156546', 1, 1, 'SR', NULL, NULL, NULL),
(5735, '2016-08-15 11:07:37', NULL, NULL, 2018, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 11:07:37', 'admin-1471222368-14712304577156546', 1, 1, 'SR', NULL, NULL, NULL),
(5736, '2016-08-15 09:05:49', NULL, NULL, 2010, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 09:05:49', 'admin-1471222368-14712231488746079', 1, 0, '', NULL, NULL, NULL),
(5737, '2016-08-15 09:05:49', NULL, NULL, 2010, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 09:05:49', 'admin-1471222368-14712231488746079', 1, 0, '', NULL, NULL, NULL),
(5738, '2016-08-15 09:05:49', NULL, NULL, 2010, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 09:05:49', 'admin-1471222368-14712231488746079', 1, 0, '', NULL, NULL, NULL),
(5739, '2016-08-15 10:06:49', NULL, NULL, 2011, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 10:06:49', 'admin-1471222368-14712268095387768', 1, 0, '', NULL, NULL, NULL),
(5740, '2016-08-15 10:06:49', NULL, NULL, 2011, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 10:06:49', 'admin-1471222368-14712268095387768', 1, 1, 'SR', NULL, NULL, NULL),
(5741, '2016-08-15 10:06:49', NULL, NULL, 2011, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 10:06:49', 'admin-1471222368-14712268095387768', 1, 0, '', NULL, NULL, NULL),
(5742, '2016-08-15 10:06:55', NULL, NULL, 2011, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 10:06:55', 'admin-1471222368-14712268149177140', 1, 1, 'SR', NULL, NULL, NULL),
(5743, '2016-08-15 10:13:52', NULL, NULL, 2012, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 10:13:52', 'admin-1471222368-14712272322443553', 1, 1, 'SR', 1, NULL, NULL),
(5744, '2016-08-15 10:18:30', NULL, NULL, 2013, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 10:18:30', 'admin-1471222368-14712275106001541', 1, 1, 'SR', NULL, NULL, NULL),
(5745, '2016-08-15 10:18:30', NULL, NULL, 2013, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 10:18:30', 'admin-1471222368-14712275106001541', 1, 1, 'SR', NULL, NULL, NULL),
(5746, '2016-08-15 10:18:30', NULL, NULL, 2013, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 10:18:30', 'admin-1471222368-14712275106001541', 1, 0, '', NULL, NULL, NULL),
(5747, '2016-08-15 10:19:34', NULL, NULL, 2013, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 10:19:34', 'admin-1471222368-14712275746252056', 1, 0, '', NULL, NULL, NULL),
(5748, '2016-08-15 11:03:15', NULL, NULL, 2017, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 11:03:15', 'admin-1471222368-14712301955495025', 1, 1, 'SR', NULL, NULL, NULL),
(5749, '2016-08-15 10:23:41', NULL, NULL, 2014, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 10:23:41', 'admin-1471222368-14712278216398236', 1, 1, 'SR', NULL, NULL, NULL),
(5750, '2016-08-15 10:23:41', NULL, NULL, 2014, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 10:23:41', 'admin-1471222368-14712278216398236', 1, 1, 'SR', NULL, NULL, NULL),
(5751, '2016-08-15 10:27:53', NULL, NULL, 2015, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 10:27:53', 'admin-1471222368-14712280731569929', 1, 0, '', NULL, NULL, NULL),
(5752, '2016-08-15 10:27:53', NULL, NULL, 2015, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 10:27:53', 'admin-1471222368-14712280731569929', 1, 0, '', NULL, NULL, NULL),
(5753, '2016-08-15 10:27:53', NULL, NULL, 2015, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471248880', 'admin', '2016-08-15 10:27:53', 'admin-1471222368-14712280731569929', 1, 1, 'SR', NULL, NULL, NULL),
(5754, '2016-08-16 17:02:46', NULL, NULL, 2080, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 17:02:46', 'admin-1471324027-14713381664136441', 1, 0, '', NULL, NULL, NULL),
(5755, '2016-08-16 17:02:46', NULL, NULL, 2080, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 17:02:46', 'admin-1471324027-14713381664136441', 1, 1, 'SR', NULL, NULL, NULL),
(5756, '2016-08-16 17:02:46', NULL, NULL, 2080, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 17:02:46', 'admin-1471324027-14713381664136441', 1, 1, 'SR', NULL, NULL, NULL),
(5757, '2016-08-16 17:02:46', NULL, NULL, 2080, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 17:02:46', 'admin-1471324027-14713381664136441', 1, 1, 'SR', NULL, NULL, NULL),
(5758, '2016-08-16 17:10:02', NULL, NULL, 2079, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 17:10:02', 'admin-1471324027-14713386027402895', 1, 0, '', NULL, NULL, NULL),
(5759, '2016-08-16 17:21:50', NULL, NULL, 2081, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 17:21:50', 'admin-1471324027-14713393102769330', 1, 0, '', NULL, NULL, NULL),
(5760, '2016-08-16 17:21:50', NULL, NULL, 2081, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 17:21:50', 'admin-1471324027-14713393102769330', 1, 1, 'SR', NULL, NULL, NULL),
(5761, '2016-08-16 17:21:50', NULL, NULL, 2081, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 17:21:50', 'admin-1471324027-14713393102769330', 1, 1, 'SR', NULL, NULL, NULL),
(5762, '2016-08-16 18:02:25', NULL, NULL, 2082, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 18:02:25', 'admin-1471324027-14713417453279192', 1, 1, 'SR', NULL, NULL, NULL),
(5763, '2016-08-16 18:02:25', NULL, NULL, 2082, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 18:02:25', 'admin-1471324027-14713417453279192', 1, 1, 'SR', NULL, NULL, NULL),
(5764, '2016-08-16 18:34:38', NULL, NULL, 2083, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 18:34:38', 'admin-1471324027-14713436786482873', 1, 0, '', NULL, NULL, NULL),
(5765, '2016-08-16 18:34:38', NULL, NULL, 2083, 0, 201, '136', 'Dinner -  Chili Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 18:34:38', 'admin-1471324027-14713436786482873', 1, 0, '', NULL, NULL, NULL),
(5766, '2016-08-16 18:34:38', NULL, NULL, 2083, 0, 181, '116', 'Open Food ', 'plain spaghetti', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 18:34:38', 'admin-1471324027-14713436786482873', 1, 0, '', NULL, NULL, NULL),
(5767, '2016-08-16 18:34:38', NULL, NULL, 2083, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 18:34:38', 'admin-1471324027-14713436786482873', 1, 1, 'SR', NULL, NULL, NULL),
(5768, '2016-08-16 19:11:49', NULL, NULL, 2084, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 19:11:49', 'admin-1471324027-14713459089555318', 1, 1, 'SR', NULL, NULL, NULL),
(5769, '2016-08-16 16:35:25', NULL, NULL, 2079, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 16:35:25', 'admin-1471324027-14713365249124124', 1, 1, 'SR', NULL, NULL, NULL),
(5770, '2016-08-16 16:35:02', NULL, NULL, 2079, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 16:35:02', 'admin-1471324027-14713365019104272', 1, 1, 'SR', NULL, NULL, NULL),
(5771, '2016-08-16 16:35:02', NULL, NULL, 2079, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 16:35:02', 'admin-1471324027-14713365019104272', 1, 0, '', NULL, NULL, NULL),
(5772, '2016-08-16 16:35:02', NULL, NULL, 2079, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 16:35:02', 'admin-1471324027-14713365019104272', 1, 1, 'SR', NULL, NULL, NULL),
(5773, '2016-08-16 16:22:41', NULL, NULL, 2078, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 16:22:41', 'admin-1471324027-14713357616749882', 1, 1, 'SR', NULL, NULL, NULL),
(5774, '2016-08-16 16:22:41', NULL, NULL, 2078, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 16:22:41', 'admin-1471324027-14713357616749882', 1, 1, 'SR', NULL, NULL, NULL),
(5775, '2016-08-16 14:49:48', NULL, NULL, 2077, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 14:49:48', 'admin-1471324027-14713301881074528', 1, 1, 'SR', NULL, NULL, NULL),
(5776, '2016-08-16 14:28:54', NULL, NULL, 2076, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 14:28:54', 'admin-1471324027-14713289346258780', 1, 0, '', NULL, NULL, NULL),
(5777, '2016-08-16 14:49:48', NULL, NULL, 2077, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 14:49:48', 'admin-1471324027-14713301881074528', 1, 1, 'SR', NULL, NULL, NULL),
(5778, '2016-08-16 14:49:48', NULL, NULL, 2077, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 14:49:48', 'admin-1471324027-14713301881074528', 1, 0, '', NULL, NULL, NULL),
(5779, '2016-08-16 14:49:48', NULL, NULL, 2077, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 14:49:48', 'admin-1471324027-14713301881074528', 1, 0, '', NULL, NULL, NULL),
(5780, '2016-08-16 14:28:54', NULL, NULL, 2076, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 14:28:54', 'admin-1471324027-14713289346258780', 1, 1, 'SR', NULL, NULL, NULL),
(5781, '2016-08-16 13:14:20', NULL, NULL, 2072, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 13:14:20', 'admin-1471324027-14713244598283431', 1, 0, '', NULL, NULL, NULL),
(5782, '2016-08-16 13:14:20', NULL, NULL, 2072, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 13:14:20', 'admin-1471324027-14713244598283431', 1, 1, 'SR', NULL, NULL, NULL),
(5783, '2016-08-16 13:24:43', NULL, NULL, 2073, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 13:24:43', 'admin-1471324027-14713250831864946', 1, 1, 'SR', NULL, NULL, NULL),
(5784, '2016-08-16 13:24:43', NULL, NULL, 2073, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 13:24:43', 'admin-1471324027-14713250831864946', 1, 1, 'SR', NULL, NULL, NULL),
(5785, '2016-08-16 13:55:34', NULL, NULL, 2074, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 13:55:34', 'admin-1471324027-14713269343348159', 1, 1, 'SR', NULL, NULL, NULL),
(5786, '2016-08-16 14:27:18', NULL, NULL, 2075, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 14:27:18', 'admin-1471324027-14713288387759269', 1, 1, 'SR', NULL, NULL, NULL),
(5787, '2016-08-16 14:27:18', NULL, NULL, 2075, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 14:27:18', 'admin-1471324027-14713288387759269', 1, 1, 'SR', NULL, NULL, NULL),
(5788, '2016-08-16 13:09:34', NULL, NULL, 2071, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 13:09:34', 'admin-1471324027-14713241738715752', 1, 1, 'SR', NULL, NULL, NULL),
(5789, '2016-08-16 13:09:34', NULL, NULL, 2071, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 13:09:34', 'admin-1471324027-14713241738715752', 1, 1, 'SR', NULL, NULL, NULL),
(5790, '2016-08-16 13:09:34', NULL, NULL, 2071, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 13:09:34', 'admin-1471324027-14713241738715752', 1, 0, '', NULL, NULL, NULL),
(5791, '2016-08-16 13:07:22', NULL, NULL, 2070, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 13:07:22', 'admin-1471324027-14713240427641344', 1, 1, 'SR', NULL, NULL, NULL),
(5792, '2016-08-16 12:48:17', NULL, NULL, 2067, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 12:48:17', 'admin-1471322882-14713228972221517', 1, 0, '', NULL, NULL, NULL),
(5793, '2016-08-16 13:07:22', NULL, NULL, 2070, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 13:07:22', 'admin-1471324027-14713240427641344', 1, 1, 'SR', NULL, NULL, NULL),
(5794, '2016-08-16 13:05:21', NULL, NULL, 2069, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 13:05:21', 'admin-1471322882-14713239207609667', 1, 0, '', NULL, NULL, NULL),
(5795, '2016-08-16 13:05:20', NULL, NULL, 2069, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 13:05:20', 'admin-1471322882-14713239207609667', 1, 1, 'SR', NULL, NULL, NULL),
(5796, '2016-08-16 13:05:20', NULL, NULL, 2069, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 13:05:20', 'admin-1471322882-14713239207609667', 1, 0, '', NULL, NULL, NULL),
(5797, '2016-08-16 12:49:26', NULL, NULL, 2068, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 12:49:26', 'admin-1471322882-14713229663453312', 1, 1, 'SR', NULL, NULL, NULL),
(5798, '2016-08-16 12:49:26', NULL, NULL, 2068, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 12:49:26', 'admin-1471322882-14713229663453312', 1, 0, '', NULL, NULL, NULL),
(5799, '2016-08-16 12:48:32', NULL, NULL, 2067, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 12:48:32', 'admin-1471322882-14713229120924434', 1, 1, 'SR', NULL, NULL, NULL),
(5800, '2016-08-16 11:53:16', NULL, NULL, 2064, 0, 181, '116', 'Open Food ', 'stir fried spicy pork', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 11:53:16', 'admin-1471319531-14713195958918975', 1, 0, '', NULL, NULL, NULL),
(5801, '2016-08-16 11:53:16', NULL, NULL, 2064, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 11:53:16', 'admin-1471319531-14713195958918975', 1, 1, 'SR', NULL, NULL, NULL),
(5802, '2016-08-16 11:53:47', NULL, NULL, 2065, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 11:53:47', 'admin-1471319531-14713196275654573', 1, 0, '', NULL, NULL, NULL),
(5803, '2016-08-16 12:03:59', NULL, NULL, 2066, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 12:03:59', 'admin-1471319531-14713202396052091', 1, 0, '', NULL, NULL, NULL),
(5804, '2016-08-16 12:03:59', NULL, NULL, 2066, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 12:03:59', 'admin-1471319531-14713202396052091', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(5805, '2016-08-16 12:03:59', NULL, NULL, 2066, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 12:03:59', 'admin-1471319531-14713202396052091', 1, 1, 'SR', NULL, NULL, NULL),
(5806, '2016-08-16 12:03:59', NULL, NULL, 2066, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 12:03:59', 'admin-1471319531-14713202396052091', 1, 1, 'SR', NULL, NULL, NULL),
(5807, '2016-08-16 12:48:17', NULL, NULL, 2067, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 12:48:17', 'admin-1471322882-14713228972221517', 1, 1, 'SR', NULL, NULL, NULL),
(5808, '2016-08-16 12:48:17', NULL, NULL, 2067, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 12:48:17', 'admin-1471322882-14713228972221517', 1, 1, 'SR', NULL, NULL, NULL),
(5809, '2016-08-16 12:48:17', NULL, NULL, 2067, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 12:48:17', 'admin-1471322882-14713228972221517', 1, 0, '', NULL, NULL, NULL),
(5810, '2016-08-16 10:20:04', NULL, NULL, 2061, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 10:20:04', 'admin-1471309259-1471314004528625', 1, 1, 'SR', NULL, NULL, NULL),
(5811, '2016-08-16 11:51:52', NULL, NULL, 2063, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 11:51:52', 'admin-1471309259-14713195127876683', 1, 1, 'SR', NULL, NULL, NULL),
(5812, '2016-08-16 11:51:52', NULL, NULL, 2063, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 11:51:52', 'admin-1471309259-14713195127876683', 1, 1, 'SR', NULL, NULL, NULL),
(5813, '2016-08-16 11:26:26', NULL, NULL, 2062, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 11:26:26', 'admin-1471309259-1471317986736454', 1, 1, 'SR', NULL, NULL, NULL),
(5814, '2016-08-16 11:26:26', NULL, NULL, 2062, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 11:26:26', 'admin-1471309259-1471317986736454', 1, 1, 'SR', NULL, NULL, NULL),
(5815, '2016-08-16 11:26:26', NULL, NULL, 2062, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 11:26:26', 'admin-1471309259-1471317986736454', 1, 1, 'SR', NULL, NULL, NULL),
(5816, '2016-08-16 11:25:58', NULL, NULL, 2062, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 11:25:58', 'admin-1471309259-14713179580381335', 1, 1, 'SR', NULL, NULL, NULL),
(5817, '2016-08-16 11:25:58', NULL, NULL, 2062, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 11:25:58', 'admin-1471309259-14713179580381335', 1, 1, 'SR', NULL, NULL, NULL),
(5818, '2016-08-16 11:25:58', NULL, NULL, 2062, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 11:25:58', 'admin-1471309259-14713179580381335', 1, 0, '', NULL, NULL, NULL),
(5819, '2016-08-16 11:25:58', NULL, NULL, 2062, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 11:25:58', 'admin-1471309259-14713179580381335', 1, 0, '', NULL, NULL, NULL),
(5820, '2016-08-16 11:25:58', NULL, NULL, 2062, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 11:25:58', 'admin-1471309259-14713179580381335', 1, 0, '', NULL, NULL, NULL),
(5821, '2016-08-16 11:25:58', NULL, NULL, 2062, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 11:25:58', 'admin-1471309259-14713179580381335', 1, 0, '', NULL, NULL, NULL),
(5822, '2016-08-16 11:25:58', NULL, NULL, 2062, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 11:25:58', 'admin-1471309259-14713179580381335', 1, 0, '', NULL, NULL, NULL),
(5823, '2016-08-16 10:17:33', NULL, NULL, 2060, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 10:17:33', 'admin-1471309259-14713138537259549', 1, 1, 'SR', NULL, NULL, NULL),
(5824, '2016-08-16 10:17:33', NULL, NULL, 2060, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 10:17:33', 'admin-1471309259-14713138537259549', 1, 1, 'SR', NULL, NULL, NULL),
(5825, '2016-08-16 09:21:18', NULL, NULL, 2058, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 09:21:18', 'admin-1471309259-1471310478732976', 1, 1, 'SR', 1, NULL, NULL),
(5826, '2016-08-16 09:21:18', NULL, NULL, 2058, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 09:21:18', 'admin-1471309259-1471310478732976', 1, 1, 'SR', 1, NULL, NULL),
(5827, '2016-08-16 09:18:01', NULL, NULL, 2057, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471324027', 'admin', '2016-08-16 09:18:01', 'admin-1471309259-14713102810198051', 1, 1, 'SR', NULL, NULL, NULL),
(5828, '2016-08-18 20:54:30', NULL, NULL, 2098, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 20:54:30', 'Staff-1471483771-14715248700228571', 1, 1, 'SR', NULL, NULL, NULL),
(5829, '2016-08-18 20:54:30', NULL, NULL, 2098, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 20:54:30', 'Staff-1471483771-14715248700228571', 1, 1, 'SR', NULL, NULL, NULL),
(5830, '2016-08-18 20:54:30', NULL, NULL, 2098, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 20:54:30', 'Staff-1471483771-14715248700228571', 1, 1, 'SR', NULL, NULL, NULL),
(5831, '2016-08-18 20:55:16', NULL, NULL, 2098, 0, 181, '116', 'Open Food ', 'B', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 20:55:16', 'Staff-1471483771-1471524916383658', 1, 0, '', NULL, NULL, NULL),
(5832, '2016-08-18 18:25:30', NULL, NULL, 2098, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 18:25:30', 'Staff-1471483771-1471515930440165', 1, 0, '', NULL, NULL, NULL),
(5833, '2016-08-18 18:25:56', NULL, NULL, 2098, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 18:25:56', 'Staff-1471483771-14715159563527015', 1, 1, 'SR', NULL, NULL, NULL),
(5834, '2016-08-18 19:54:36', NULL, NULL, 2099, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 19:54:36', 'Staff-1471483771-14715212767304621', 1, 0, '', NULL, NULL, NULL),
(5835, '2016-08-18 19:54:36', NULL, NULL, 2099, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 19:54:36', 'Staff-1471483771-14715212767304621', 1, 1, 'SR', NULL, NULL, NULL),
(5836, '2016-08-18 19:54:36', NULL, NULL, 2099, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 19:54:36', 'Staff-1471483771-14715212767304621', 1, 1, 'SR', NULL, NULL, NULL),
(5837, '2016-08-18 18:25:56', NULL, NULL, 2098, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 18:25:56', 'Staff-1471483771-14715159563527015', 1, 1, 'SR', NULL, NULL, NULL),
(5838, '2016-08-18 13:51:54', NULL, NULL, 2093, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 13:51:54', 'Staff-1471483771-14714995142416529', 1, 1, 'SR', NULL, NULL, NULL),
(5839, '2016-08-18 13:51:54', NULL, NULL, 2093, 0, 181, '116', 'Open Food ', 'Curry Pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 13:51:54', 'Staff-1471483771-14714995142416529', 1, 0, '', NULL, NULL, NULL),
(5840, '2016-08-18 14:38:07', NULL, NULL, 2094, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 14:38:07', 'Staff-1471483771-1471502287686627', 1, 0, '', NULL, NULL, NULL),
(5841, '2016-08-18 14:38:07', NULL, NULL, 2094, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 14:38:07', 'Staff-1471483771-1471502287686627', 1, 1, 'SR', NULL, NULL, NULL),
(5842, '2016-08-18 14:47:06', NULL, NULL, 2093, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 14:47:06', 'Staff-1471483771-14715028261834934', 1, 1, 'SR', NULL, NULL, NULL),
(5843, '2016-08-18 15:31:47', NULL, NULL, 2095, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 15:31:47', 'Staff-1471483771-14715055073261059', 1, 1, 'SR', NULL, NULL, NULL),
(5844, '2016-08-18 16:05:44', NULL, NULL, 2096, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 16:05:44', 'Staff-1471483771-1471507544117789', 1, 1, 'SR', NULL, NULL, NULL),
(5845, '2016-08-18 16:05:44', NULL, NULL, 2096, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 16:05:44', 'Staff-1471483771-1471507544117789', 1, 1, 'SR', NULL, NULL, NULL),
(5846, '2016-08-18 18:06:07', NULL, NULL, 2097, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 18:06:07', 'Staff-1471483771-14715147668608722', 1, 1, 'SR', NULL, NULL, NULL),
(5847, '2016-08-18 13:48:09', NULL, NULL, 2092, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 13:48:09', 'Staff-1471483771-14714992892225185', 1, 0, '', NULL, NULL, NULL),
(5848, '2016-08-18 13:48:09', NULL, NULL, 2092, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 13:48:09', 'Staff-1471483771-14714992892225185', 1, 0, '', NULL, NULL, NULL),
(5849, '2016-08-18 13:48:54', NULL, NULL, 2089, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 13:48:54', 'Staff-1471483771-14714993345403991', 1, 1, 'SR', NULL, NULL, NULL),
(5850, '2016-08-18 13:51:54', NULL, NULL, 2093, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 13:51:54', 'Staff-1471483771-14714995142416529', 1, 1, 'SR', NULL, NULL, NULL),
(5851, '2016-08-18 13:51:54', NULL, NULL, 2093, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 13:51:54', 'Staff-1471483771-14714995142416529', 1, 1, 'SR', NULL, NULL, NULL),
(5852, '2016-08-18 18:25:30', NULL, NULL, 2098, 0, 181, '116', 'Open Food ', 'Summer salad with bacon', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 18:25:30', 'Staff-1471483771-1471515930440165', 1, 0, '', NULL, NULL, NULL),
(5853, '2016-08-18 18:25:30', NULL, NULL, 2098, 0, 181, '116', 'Open Food ', 'Curry pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 18:25:30', 'Staff-1471483771-1471515930440165', 1, 0, '', NULL, NULL, NULL),
(5854, '2016-08-18 18:06:07', NULL, NULL, 2097, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 18:06:07', 'Staff-1471483771-14715147668608722', 1, 0, '', NULL, NULL, NULL),
(5855, '2016-08-18 18:06:07', NULL, NULL, 2097, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 18:06:07', 'Staff-1471483771-14715147668608722', 1, 1, 'SR', NULL, NULL, NULL),
(5856, '2016-08-18 11:08:32', NULL, NULL, 2087, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 11:08:32', 'Staff-1471483771-14714897126585422', 1, 1, 'SR', NULL, NULL, NULL),
(5857, '2016-08-18 11:08:32', NULL, NULL, 2087, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 11:08:32', 'Staff-1471483771-14714897126585422', 1, 1, 'SR', NULL, NULL, NULL),
(5858, '2016-08-18 12:51:26', NULL, NULL, 2088, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 12:51:26', 'Staff-1471483771-14714958863809237', 1, 1, 'SR', NULL, NULL, NULL),
(5859, '2016-08-18 13:10:45', NULL, NULL, 2089, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 13:10:45', 'Staff-1471483771-14714970457129879', 1, 1, 'SR', NULL, NULL, NULL),
(5860, '2016-08-18 13:48:09', NULL, NULL, 2092, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 13:48:09', 'Staff-1471483771-14714992892225185', 1, 1, 'SR', NULL, NULL, NULL),
(5861, '2016-08-18 13:48:09', NULL, NULL, 2092, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 13:48:09', 'Staff-1471483771-14714992892225185', 1, 1, 'SR', NULL, NULL, NULL),
(5862, '2016-08-18 13:28:41', NULL, NULL, 2091, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 13:28:41', 'Staff-1471483771-14714981217252536', 1, 1, 'SR', NULL, NULL, NULL),
(5863, '2016-08-18 13:28:41', NULL, NULL, 2091, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 13:28:41', 'Staff-1471483771-14714981217252536', 1, 0, '', NULL, NULL, NULL),
(5864, '2016-08-18 13:28:07', NULL, NULL, 2089, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 13:28:07', 'Staff-1471483771-1471498086900975', 1, 1, 'SR', NULL, NULL, NULL),
(5865, '2016-08-18 13:15:44', NULL, NULL, 2090, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 13:15:44', 'Staff-1471483771-14714973442222667', 1, 1, 'SR', NULL, NULL, NULL),
(5866, '2016-08-18 13:10:45', NULL, NULL, 2089, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 13:10:45', 'Staff-1471483771-14714970457129879', 1, 1, 'SR', NULL, NULL, NULL),
(5867, '2016-08-18 13:10:45', NULL, NULL, 2089, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 13:10:45', 'Staff-1471483771-14714970457129879', 1, 1, 'SR', NULL, NULL, NULL),
(5868, '2016-08-18 13:10:45', NULL, NULL, 2089, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 13:10:45', 'Staff-1471483771-14714970457129879', 1, 1, 'SR', NULL, NULL, NULL),
(5869, '2016-08-18 10:54:58', NULL, NULL, 2086, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 10:54:58', 'Staff-1471483771-14714888979783339', 1, 0, '', NULL, NULL, NULL),
(5870, '2016-08-18 10:13:17', NULL, NULL, 2085, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 10:13:17', 'Staff-1471483771-14714863973777440', 1, 1, 'SR', NULL, NULL, NULL),
(5871, '2016-08-18 10:26:33', NULL, NULL, 2086, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 10:26:33', 'Staff-1471483771-14714871931469728', 1, 0, '', NULL, NULL, NULL),
(5872, '2016-08-18 10:26:33', NULL, NULL, 2086, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 10:26:33', 'Staff-1471483771-14714871931469728', 1, 1, 'SR', NULL, NULL, NULL),
(5873, '2016-08-18 10:13:17', NULL, NULL, 2085, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471483771', 'Staff', '2016-08-18 10:13:17', 'Staff-1471483771-14714863973777440', 1, 1, 'SR', NULL, NULL, NULL),
(5874, '2016-08-19 19:05:11', NULL, NULL, 2124, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 19:05:11', 'admin-1471602109-14716047111067536', 1, 1, 'SR', NULL, NULL, NULL),
(5875, '2016-08-19 19:32:35', NULL, NULL, 2125, 0, 181, '116', 'Open Food ', 'curry fish', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 19:32:35', 'admin-1471602109-14716063554942094', 1, 0, '', NULL, NULL, NULL),
(5876, '2016-08-19 19:40:37', NULL, NULL, 2125, 0, 181, '116', 'Open Food ', 'potato', 'Meals', 'Perfect Meals', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 19:40:37', 'admin-1471602109-14716068375312165', 1, 0, '', NULL, NULL, NULL),
(5877, '2016-08-19 19:40:37', NULL, NULL, 2125, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 19:40:37', 'admin-1471602109-14716068375312165', 1, 0, '', NULL, NULL, NULL),
(5878, '2016-08-19 20:04:08', NULL, NULL, 2127, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 20:04:08', 'admin-1471602109-14716082479327643', 1, 0, '', NULL, NULL, NULL),
(5879, '2016-08-19 20:04:08', NULL, NULL, 2127, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 20:04:08', 'admin-1471602109-14716082479327643', 1, 1, 'SR', NULL, NULL, NULL),
(5880, '2016-08-19 20:04:08', NULL, NULL, 2127, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 20:04:08', 'admin-1471602109-14716082479327643', 1, 1, 'SR', NULL, NULL, NULL),
(5881, '2016-08-19 20:04:08', NULL, NULL, 2127, 0, 181, '116', 'Open Food ', 'apple', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 20:04:08', 'admin-1471602109-14716082479327643', 1, 0, '', NULL, NULL, NULL),
(5882, '2016-08-19 20:04:08', NULL, NULL, 2127, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 20:04:08', 'admin-1471602109-14716082479327643', 1, 0, '', NULL, NULL, NULL),
(5883, '2016-08-19 20:04:44', NULL, NULL, 2127, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 20:04:44', 'admin-1471602109-14716082844293366', 1, 0, '', NULL, NULL, NULL),
(5884, '2016-08-19 20:17:52', NULL, NULL, 2128, 0, 201, '136', 'Dinner -  Chili Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 20:17:52', 'admin-1471602109-14716090724986932', 1, 0, '', NULL, NULL, NULL),
(5885, '2016-08-19 20:17:52', NULL, NULL, 2128, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 20:17:52', 'admin-1471602109-14716090724986932', 1, 0, '', NULL, NULL, NULL),
(5886, '2016-08-19 20:17:52', NULL, NULL, 2128, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 20:17:52', 'admin-1471602109-14716090724986932', 1, 0, '', NULL, NULL, NULL),
(5887, '2016-08-19 20:17:52', NULL, NULL, 2128, 0, 181, '116', 'Open Food ', 'Dinner-Lemon chicken', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 20:17:52', 'admin-1471602109-14716090724986932', 1, 0, '', NULL, NULL, NULL),
(5888, '2016-08-19 20:17:52', NULL, NULL, 2128, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 20:17:52', 'admin-1471602109-14716090724986932', 1, 1, 'SR', NULL, NULL, NULL),
(5889, '2016-08-19 20:17:52', NULL, NULL, 2128, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 20:17:52', 'admin-1471602109-14716090724986932', 1, 1, 'SR', NULL, NULL, NULL),
(5890, '2016-08-19 20:35:40', NULL, NULL, 2129, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 20:35:40', 'admin-1471602109-14716101404966580', 1, 1, 'SR', NULL, NULL, NULL),
(5891, '2016-08-19 20:36:45', NULL, NULL, 2130, 0, 181, '116', 'Open Food ', 'curry pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 20:36:45', 'admin-1471602109-14716102058377158', 1, 0, '', NULL, NULL, NULL),
(5892, '2016-08-19 20:36:45', NULL, NULL, 2130, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 20:36:45', 'admin-1471602109-14716102058377158', 1, 1, 'SR', NULL, NULL, NULL),
(5893, '2016-08-19 21:12:48', NULL, NULL, 2125, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 21:12:48', 'admin-1471602109-14716123679092938', 1, 1, 'SR', NULL, NULL, NULL),
(5894, '2016-08-19 21:46:36', NULL, NULL, 2131, 0, 190, '125', 'Tiger Bucket ', '', 'Cold Drinks', 'Soda & Beer', 1, 48.00, 48.0000, 0.0000, 48.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 21:46:36', 'admin-1471612406-14716143961813548', 1, 0, '', NULL, NULL, NULL),
(5895, '2016-08-19 21:46:43', NULL, NULL, 2132, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 21:46:43', 'admin-1471612406-14716144037544457', 1, 1, 'SR', NULL, NULL, NULL),
(5896, '2016-08-19 21:46:43', NULL, NULL, 2132, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 21:46:43', 'admin-1471612406-14716144037544457', 1, 1, 'SR', NULL, NULL, NULL),
(5897, '2016-08-19 21:46:43', NULL, NULL, 2132, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 21:46:43', 'admin-1471612406-14716144037544457', 1, 1, 'SR', NULL, NULL, NULL),
(5898, '2016-08-19 18:44:06', NULL, NULL, 2123, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 18:44:06', 'admin-1471602109-1471603446447148', 1, 0, '', NULL, NULL, NULL),
(5899, '2016-08-19 19:05:11', NULL, NULL, 2124, 0, 181, '116', 'Open Food ', 'curry pork', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 19:05:11', 'admin-1471602109-14716047111067536', 1, 0, '', NULL, NULL, NULL),
(5900, '2016-08-19 18:44:06', NULL, NULL, 2123, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 18:44:06', 'admin-1471602109-1471603446447148', 1, 1, 'SR', NULL, NULL, NULL),
(5901, '2016-08-19 18:44:06', NULL, NULL, 2123, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 18:44:06', 'admin-1471602109-1471603446447148', 1, 1, 'SR', NULL, NULL, NULL),
(5902, '2016-08-19 18:44:06', NULL, NULL, 2123, 0, 76, '76', 'Pesto Pasta', 'Chicken', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 18:44:06', 'admin-1471602109-1471603446447148', 1, 1, 'SR', NULL, NULL, NULL),
(5903, '2016-08-19 18:21:56', NULL, NULL, 2122, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 18:21:56', 'admin-1471602109-14716021159375477', 1, 1, 'SR', 1, NULL, NULL),
(5904, '2016-08-19 18:44:06', NULL, NULL, 2123, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 18:44:06', 'admin-1471602109-1471603446447148', 1, 0, '', NULL, NULL, NULL),
(5905, '2016-08-19 18:03:57', NULL, NULL, 2121, 0, 181, '116', 'Open Food ', 'curry fish', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 18:03:57', 'admin-1471581015-14716010375296041', 1, 0, '', NULL, NULL, NULL),
(5906, '2016-08-19 18:03:57', NULL, NULL, 2121, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 18:03:57', 'admin-1471581015-14716010375296041', 1, 1, 'SR', NULL, NULL, NULL),
(5907, '2016-08-19 18:44:06', NULL, NULL, 2123, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 18:44:06', 'admin-1471602109-1471603446447148', 1, 0, '', NULL, NULL, NULL),
(5908, '2016-08-19 18:03:57', NULL, NULL, 2121, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 18:03:57', 'admin-1471581015-14716010375296041', 1, 1, 'SR', NULL, NULL, NULL),
(5909, '2016-08-19 12:27:36', NULL, NULL, 2106, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 12:27:36', 'admin-1471569290-14715808567177412', 1, 0, '', NULL, NULL, NULL),
(5910, '2016-08-19 12:31:36', NULL, NULL, 2108, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 12:31:36', 'admin-1471581015-14715810959788966', 1, 1, 'SR', NULL, NULL, NULL),
(5911, '2016-08-19 12:42:42', NULL, NULL, 2109, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 12:42:42', 'admin-1471581015-1471581762713883', 1, 1, 'SR', NULL, NULL, NULL),
(5912, '2016-08-19 12:42:42', NULL, NULL, 2109, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 12:42:42', 'admin-1471581015-1471581762713883', 1, 1, 'SR', NULL, NULL, NULL),
(5913, '2016-08-19 12:54:16', NULL, NULL, 2110, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 12:54:16', 'admin-1471581015-14715824561402288', 1, 0, '', NULL, NULL, '10.0'),
(5914, '2016-08-19 12:54:16', NULL, NULL, 2110, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 12:54:16', 'admin-1471581015-14715824561402288', 1, 0, '', NULL, NULL, '10.0'),
(5915, '2016-08-19 12:54:51', NULL, NULL, 2111, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 12:54:51', 'admin-1471581015-14715824908438856', 1, 0, '', NULL, NULL, NULL),
(5916, '2016-08-19 17:17:51', NULL, NULL, 2120, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 17:17:51', 'admin-1471581015-14715982709371665', 1, 0, '', NULL, NULL, NULL),
(5917, '2016-08-19 15:20:47', NULL, NULL, 2117, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 15:20:47', 'admin-1471581015-14715912469293728', 1, 0, '', NULL, NULL, NULL),
(5918, '2016-08-19 15:20:47', NULL, NULL, 2117, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 15:20:47', 'admin-1471581015-14715912469293728', 1, 0, '', NULL, NULL, NULL),
(5919, '2016-08-19 15:47:09', NULL, NULL, 2118, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 15:47:09', 'admin-1471581015-14715928287134796', 1, 1, 'SR', 1, NULL, NULL),
(5920, '2016-08-19 17:15:38', NULL, NULL, 2119, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 17:15:38', 'admin-1471581015-14715981380689038', 1, 1, 'SR', NULL, NULL, NULL),
(5921, '2016-08-19 15:20:47', NULL, NULL, 2117, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 15:20:47', 'admin-1471581015-14715912469293728', 1, 1, 'SR', NULL, NULL, NULL),
(5922, '2016-08-19 15:20:47', NULL, NULL, 2117, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 15:20:47', 'admin-1471581015-14715912469293728', 1, 1, 'SR', NULL, NULL, NULL),
(5923, '2016-08-19 15:09:45', NULL, NULL, 2116, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 15:09:45', 'admin-1471581015-1471590585659953', 1, 1, 'SR', NULL, NULL, NULL),
(5924, '2016-08-19 14:54:48', NULL, NULL, 2115, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 14:54:48', 'admin-1471581015-14715896887336863', 1, 0, '', 1, NULL, NULL),
(5925, '2016-08-19 14:54:48', NULL, NULL, 2115, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 14:54:48', 'admin-1471581015-14715896887336863', 1, 0, '', 1, NULL, NULL),
(5926, '2016-08-19 14:35:51', NULL, NULL, 2114, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 14:35:51', 'admin-1471581015-14715885516859869', 1, 0, '', NULL, NULL, NULL),
(5927, '2016-08-19 13:47:02', NULL, NULL, 2113, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 13:47:02', 'admin-1471581015-14715856226138996', 1, 0, '', NULL, NULL, NULL),
(5928, '2016-08-19 13:47:02', NULL, NULL, 2113, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 13:47:02', 'admin-1471581015-14715856226138996', 1, 1, 'SR', NULL, NULL, NULL),
(5929, '2016-08-19 13:47:02', NULL, NULL, 2113, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 13:47:02', 'admin-1471581015-14715856226138996', 1, 1, 'SR', NULL, NULL, NULL),
(5930, '2016-08-19 13:47:02', NULL, NULL, 2113, 0, 181, '116', 'Open Food ', 'curry fish', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 13:47:02', 'admin-1471581015-14715856226138996', 1, 0, '', NULL, NULL, NULL),
(5931, '2016-08-19 13:45:05', NULL, NULL, 2110, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 13:45:05', 'admin-1471581015-1471585505512684', 1, 0, '', NULL, NULL, '10.0'),
(5932, '2016-08-19 13:44:54', NULL, NULL, 2110, 0, 181, '116', 'Open Food ', 'ikan pari', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 13:44:54', 'admin-1471581015-14715854941151359', 1, 0, '', NULL, NULL, '10.0'),
(5933, '2016-08-19 13:34:47', NULL, NULL, 2112, 0, 181, '116', 'Open Food ', 'black', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 13:34:47', 'admin-1471581015-14715848874272440', 1, 0, '', NULL, NULL, NULL),
(5934, '2016-08-19 12:54:51', NULL, NULL, 2111, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 12:54:51', 'admin-1471581015-14715824908438856', 1, 1, 'SR', NULL, NULL, NULL),
(5935, '2016-08-19 12:30:03', NULL, NULL, 2107, 0, 181, '116', 'Open Food ', 'ikan pari', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 12:30:03', 'admin-1471569290-14715810037874814', 1, 0, '', NULL, NULL, NULL),
(5936, '2016-08-19 12:27:36', NULL, NULL, 2106, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 12:27:36', 'admin-1471569290-14715808567177412', 1, 1, 'SR', NULL, NULL, NULL),
(5937, '2016-08-19 12:27:36', NULL, NULL, 2106, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 12:27:36', 'admin-1471569290-14715808567177412', 1, 1, 'SR', NULL, NULL, NULL),
(5938, '2016-08-19 12:26:57', NULL, NULL, 2106, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 12:26:57', 'admin-1471569290-14715808170038454', 1, 1, 'SR', NULL, NULL, NULL),
(5939, '2016-08-19 12:27:36', NULL, NULL, 2106, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 12:27:36', 'admin-1471569290-14715808567177412', 1, 1, 'SR', NULL, NULL, NULL),
(5940, '2016-08-19 10:01:25', NULL, NULL, 2100, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 10:01:25', 'admin-1471569290-14715720848698226', 1, 1, 'SR', NULL, NULL, NULL),
(5941, '2016-08-19 10:01:25', NULL, NULL, 2100, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 10:01:25', 'admin-1471569290-14715720848698226', 1, 1, 'SR', NULL, NULL, NULL),
(5942, '2016-08-19 11:28:41', NULL, NULL, 2101, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 11:28:41', 'admin-1471569290-14715773211743979', 1, 0, '', NULL, NULL, NULL),
(5943, '2016-08-19 11:28:41', NULL, NULL, 2101, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 11:28:41', 'admin-1471569290-14715773211743979', 1, 1, 'SR', NULL, NULL, NULL),
(5944, '2016-08-19 12:04:57', NULL, NULL, 2102, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 12:04:57', 'admin-1471569290-14715794975718969', 1, 1, 'SR', NULL, NULL, NULL),
(5945, '2016-08-19 12:04:57', NULL, NULL, 2102, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 12:04:57', 'admin-1471569290-14715794975718969', 1, 1, 'SR', NULL, NULL, NULL),
(5946, '2016-08-19 12:05:45', NULL, NULL, 2103, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 12:05:45', 'admin-1471569290-14715795448426984', 1, 0, '', NULL, NULL, NULL),
(5947, '2016-08-19 12:05:50', NULL, NULL, 2103, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 12:05:50', 'admin-1471569290-14715795504902995', 1, 1, 'SR', NULL, NULL, NULL),
(5948, '2016-08-19 12:16:47', NULL, NULL, 2104, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 12:16:47', 'admin-1471569290-1471580206932471', 1, 0, '', NULL, NULL, NULL),
(5949, '2016-08-19 12:16:47', NULL, NULL, 2104, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 12:16:47', 'admin-1471569290-1471580206932471', 1, 0, '', NULL, NULL, NULL),
(5950, '2016-08-19 12:18:42', NULL, NULL, 2105, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 12:18:42', 'admin-1471569290-14715803220467271', 1, 1, 'SR', NULL, NULL, NULL),
(5951, '2016-08-19 12:18:42', NULL, NULL, 2105, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 12:18:42', 'admin-1471569290-14715803220467271', 1, 1, 'SR', NULL, NULL, NULL),
(5952, '2016-08-19 12:19:18', NULL, NULL, 2105, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 12:19:18', 'admin-1471569290-14715803586904954', 1, 0, '', NULL, NULL, NULL),
(5953, '2016-08-19 10:01:25', NULL, NULL, 2100, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 10:01:25', 'admin-1471569290-14715720848698226', 1, 1, 'SR', NULL, NULL, NULL),
(5954, '2016-08-19 10:00:40', NULL, NULL, 2100, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 10:00:40', 'admin-1471569290-14715720399589825', 1, 0, '', NULL, NULL, NULL),
(5955, '2016-08-19 10:00:40', NULL, NULL, 2100, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 10:00:40', 'admin-1471569290-14715720399589825', 1, 0, '', NULL, NULL, NULL),
(5956, '2016-08-19 10:00:40', NULL, NULL, 2100, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471612406', 'admin', '2016-08-19 10:00:40', 'admin-1471569290-14715720399589825', 1, 0, '', NULL, NULL, NULL),
(5957, '2016-08-20 15:39:29', NULL, NULL, 2159, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 15:39:29', 'admin-1471667429-14716787697087246', 1, 1, 'SR', NULL, NULL, NULL),
(5958, '2016-08-20 16:33:19', NULL, NULL, 2160, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 16:33:19', 'admin-1471667429-14716819991118059', 1, 1, 'SR', NULL, NULL, NULL),
(5959, '2016-08-20 16:33:19', NULL, NULL, 2160, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 16:33:19', 'admin-1471667429-14716819991118059', 1, 1, 'SR', NULL, NULL, NULL),
(5960, '2016-08-20 17:09:19', NULL, NULL, 2161, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 17:09:19', 'admin-1471667429-14716841592831084', 1, 0, '', NULL, NULL, NULL),
(5961, '2016-08-20 18:27:37', NULL, NULL, 2162, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 18:27:37', 'admin-1471667429-14716888576868586', 1, 1, 'SR', NULL, NULL, NULL),
(5962, '2016-08-20 19:31:19', NULL, NULL, 2160, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 19:31:19', 'admin-1471667429-14716926796738330', 1, 0, '', NULL, NULL, NULL),
(5963, '2016-08-20 19:31:19', NULL, NULL, 2160, 0, 201, '136', 'Dinner -  Chili Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 19:31:19', 'admin-1471667429-14716926796738330', 1, 0, '', NULL, NULL, NULL),
(5964, '2016-08-20 19:31:19', NULL, NULL, 2160, 0, 198, '133', 'Dinner - Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 19:31:19', 'admin-1471667429-14716926796738330', 1, 0, '', NULL, NULL, NULL),
(5965, '2016-08-20 19:31:19', NULL, NULL, 2160, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 19:31:19', 'admin-1471667429-14716926796738330', 1, 0, '', NULL, NULL, NULL),
(5966, '2016-08-20 19:31:19', NULL, NULL, 2160, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 19:31:19', 'admin-1471667429-14716926796738330', 1, 0, '', NULL, NULL, NULL),
(5967, '2016-08-20 19:31:24', NULL, NULL, 2160, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 19:31:24', 'admin-1471667429-14716926844866291', 1, 1, 'SR', NULL, NULL, NULL),
(5968, '2016-08-20 20:16:28', NULL, NULL, 2163, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 20:16:28', 'admin-1471667429-14716953882032030', 1, 1, 'SR', NULL, NULL, NULL),
(5969, '2016-08-20 20:16:28', NULL, NULL, 2163, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 20:16:28', 'admin-1471667429-14716953882032030', 1, 1, 'SR', NULL, NULL, NULL),
(5970, '2016-08-20 20:31:20', NULL, NULL, 2164, 0, 181, '116', 'Open Food ', 'Curry Prawn', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 20:31:20', 'admin-1471667429-14716962805321434', 1, 0, '', NULL, NULL, NULL),
(5971, '2016-08-20 20:32:36', NULL, NULL, 2164, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 20:32:36', 'admin-1471667429-14716963563901880', 1, 0, '', NULL, NULL, NULL),
(5972, '2016-08-20 20:31:25', NULL, NULL, 2164, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 20:31:25', 'admin-1471667429-14716962848568551', 1, 1, 'SR', NULL, NULL, NULL),
(5973, '2016-08-20 20:31:49', NULL, NULL, 2164, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 20:31:49', 'admin-1471667429-14716963097437180', 1, 1, 'SR', NULL, NULL, NULL),
(5974, '2016-08-20 20:31:49', NULL, NULL, 2164, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 20:31:49', 'admin-1471667429-14716963097437180', 1, 0, '', NULL, NULL, NULL),
(5975, '2016-08-20 14:16:15', NULL, NULL, 2158, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 14:16:15', 'admin-1471667429-1471673775235866', 1, 1, 'SR', NULL, NULL, NULL),
(5976, '2016-08-20 14:16:15', NULL, NULL, 2158, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 14:16:15', 'admin-1471667429-1471673775235866', 1, 1, 'SR', NULL, NULL, NULL),
(5977, '2016-08-20 15:39:29', NULL, NULL, 2159, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 15:39:29', 'admin-1471667429-14716787697087246', 1, 1, 'SR', NULL, NULL, NULL),
(5978, '2016-08-20 14:14:57', NULL, NULL, 2157, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 14:14:57', 'admin-1471667429-14716736972072858', 1, 1, 'SR', 1, NULL, NULL),
(5979, '2016-08-20 14:09:47', NULL, NULL, 2156, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 14:09:47', 'admin-1471667429-14716733873615418', 1, 1, 'SR', NULL, NULL, NULL),
(5980, '2016-08-20 13:56:52', NULL, NULL, 2153, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 13:56:52', 'admin-1471667429-14716726127482348', 1, 1, 'SR', NULL, NULL, NULL),
(5981, '2016-08-20 13:56:38', NULL, NULL, 2155, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 13:56:38', 'admin-1471667429-14716725981309073', 1, 1, 'SR', NULL, NULL, NULL),
(5982, '2016-08-20 13:38:00', NULL, NULL, 2153, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 13:38:00', 'admin-1471667429-1471671479923114', 1, 1, 'SR', NULL, NULL, NULL),
(5983, '2016-08-20 13:39:55', NULL, NULL, 2154, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 13:39:55', 'admin-1471667429-14716715950457640', 1, 1, 'SR', NULL, NULL, NULL),
(5984, '2016-08-20 13:39:55', NULL, NULL, 2154, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 13:39:55', 'admin-1471667429-14716715950457640', 1, 0, '', NULL, NULL, NULL),
(5985, '2016-08-20 13:39:55', NULL, NULL, 2154, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 13:39:55', 'admin-1471667429-14716715950457640', 1, 1, 'SR', NULL, NULL, NULL),
(5986, '2016-08-20 12:07:06', NULL, NULL, 2143, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:07:06', 'admin-1471655526-14716660266269490', 1, 0, '', NULL, NULL, NULL),
(5987, '2016-08-20 12:07:06', NULL, NULL, 2143, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:07:06', 'admin-1471655526-14716660266269490', 1, 1, 'SR', NULL, NULL, NULL),
(5988, '2016-08-20 12:07:06', NULL, NULL, 2143, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:07:06', 'admin-1471655526-14716660266269490', 1, 1, 'SR', NULL, NULL, NULL),
(5989, '2016-08-20 12:07:06', NULL, NULL, 2143, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:07:06', 'admin-1471655526-14716660266269490', 1, 1, 'SR', NULL, NULL, NULL),
(5990, '2016-08-20 12:09:02', NULL, NULL, 2144, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:09:02', 'admin-1471655526-14716661424848654', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(5991, '2016-08-20 12:09:02', NULL, NULL, 2144, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:09:02', 'admin-1471655526-14716661424848654', 1, 0, '', NULL, NULL, NULL),
(5992, '2016-08-20 14:09:21', NULL, NULL, 2155, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 14:09:21', 'admin-1471667429-14716733608358752', 1, 1, 'SR', NULL, NULL, NULL),
(5993, '2016-08-20 13:38:00', NULL, NULL, 2153, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 13:38:00', 'admin-1471667429-1471671479923114', 1, 0, '', NULL, NULL, NULL),
(5994, '2016-08-20 12:56:51', NULL, NULL, 2150, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:56:51', 'admin-1471667429-14716690115788811', 1, 1, 'SR', 1, NULL, NULL),
(5995, '2016-08-20 12:59:52', NULL, NULL, 2151, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:59:52', 'admin-1471667429-14716691923701824', 1, 1, 'SR', 1, NULL, NULL),
(5996, '2016-08-20 13:06:10', NULL, NULL, 2152, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 13:06:10', 'admin-1471667429-14716695707306177', 1, 1, 'SR', 1, NULL, NULL),
(5997, '2016-08-20 13:38:00', NULL, NULL, 2153, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 13:38:00', 'admin-1471667429-1471671479923114', 1, 0, '', NULL, NULL, NULL),
(5998, '2016-08-20 12:56:51', NULL, NULL, 2150, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:56:51', 'admin-1471667429-14716690115788811', 1, 1, 'SR', 1, NULL, NULL),
(5999, '2016-08-20 12:55:04', NULL, NULL, 2149, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:55:04', 'admin-1471667429-14716689045162984', 1, 1, 'SR', NULL, NULL, NULL),
(6000, '2016-08-20 12:55:04', NULL, NULL, 2149, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:55:04', 'admin-1471667429-14716689045162984', 1, 1, 'SR', NULL, NULL, NULL),
(6001, '2016-08-20 12:55:04', NULL, NULL, 2149, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:55:04', 'admin-1471667429-14716689045162984', 1, 1, 'SR', NULL, NULL, NULL),
(6002, '2016-08-20 12:31:43', NULL, NULL, 2148, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:31:43', 'admin-1471667429-14716675032327256', 1, 1, 'SR', NULL, NULL, NULL),
(6003, '2016-08-20 12:31:14', NULL, NULL, 2148, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:31:14', 'admin-1471667429-14716674738202348', 1, 0, '', NULL, NULL, NULL),
(6004, '2016-08-20 12:25:16', NULL, NULL, 2147, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:25:16', 'admin-1471655526-14716671165662280', 1, 1, 'SR', NULL, NULL, NULL),
(6005, '2016-08-20 12:25:16', NULL, NULL, 2147, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:25:16', 'admin-1471655526-14716671165662280', 1, 1, 'SR', NULL, NULL, NULL),
(6006, '2016-08-20 12:19:05', NULL, NULL, 2144, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:19:05', 'admin-1471655526-14716667455303563', 1, 1, 'SR', NULL, NULL, NULL),
(6007, '2016-08-20 12:10:37', NULL, NULL, 2146, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:10:37', 'admin-1471655526-14716662371362089', 1, 1, 'SR', NULL, NULL, NULL),
(6008, '2016-08-20 12:10:37', NULL, NULL, 2146, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:10:37', 'admin-1471655526-14716662371362089', 1, 0, '', NULL, NULL, NULL),
(6009, '2016-08-20 12:10:04', NULL, NULL, 2145, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:10:04', 'admin-1471655526-14716662042871639', 1, 1, 'SR', NULL, NULL, NULL),
(6010, '2016-08-20 12:09:02', NULL, NULL, 2144, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:09:02', 'admin-1471655526-14716661424848654', 1, 1, 'SR', NULL, NULL, NULL),
(6011, '2016-08-20 12:10:04', NULL, NULL, 2145, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:10:04', 'admin-1471655526-14716662042871639', 1, 1, 'SR', NULL, NULL, NULL),
(6012, '2016-08-20 12:07:06', NULL, NULL, 2143, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:07:06', 'admin-1471655526-14716660266269490', 1, 0, '', NULL, NULL, NULL),
(6013, '2016-08-20 12:07:06', NULL, NULL, 2143, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:07:06', 'admin-1471655526-14716660266269490', 1, 0, '', NULL, NULL, NULL),
(6014, '2016-08-20 11:58:26', NULL, NULL, 2142, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 11:58:26', 'admin-1471655526-1471665506467780', 1, 1, 'SR', NULL, NULL, NULL),
(6015, '2016-08-20 12:07:06', NULL, NULL, 2143, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 12:07:06', 'admin-1471655526-14716660266269490', 1, 0, '', NULL, NULL, NULL),
(6016, '2016-08-20 10:28:36', NULL, NULL, 2135, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 10:28:36', 'admin-1471655526-14716601161338679', 1, 1, 'SR', NULL, NULL, NULL),
(6017, '2016-08-20 10:28:36', NULL, NULL, 2135, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 10:28:36', 'admin-1471655526-14716601161338679', 1, 1, 'SR', NULL, NULL, NULL),
(6018, '2016-08-20 00:00:00', NULL, NULL, 2138, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 11:33:50', 'admin-1471655526-14716640299852427', 1, 1, 'SR', NULL, NULL, NULL),
(6019, '2016-08-20 11:43:39', NULL, NULL, 2139, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 11:43:39', 'admin-1471655526-14716646191771657', 1, 0, '', NULL, NULL, NULL),
(6020, '2016-08-20 00:00:00', NULL, NULL, 2138, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 11:33:50', 'admin-1471655526-14716640299852427', 1, 0, '', NULL, NULL, NULL),
(6021, '2016-08-20 00:00:00', NULL, NULL, 2137, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 11:33:50', 'admin-1471655526-14716640299852427', 1, 0, '', NULL, NULL, NULL),
(6022, '2016-08-20 00:00:00', NULL, NULL, 2137, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 11:33:50', 'admin-1471655526-14716640299852427', 1, 1, 'SR', NULL, NULL, NULL),
(6023, '2016-08-20 11:45:17', NULL, NULL, 2139, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 11:45:17', 'admin-1471655526-14716647173764739', 1, 0, '', NULL, NULL, NULL),
(6024, '2016-08-20 11:45:17', NULL, NULL, 2139, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 11:45:17', 'admin-1471655526-14716647173764739', 1, 1, 'SR', NULL, NULL, NULL),
(6025, '2016-08-20 11:50:20', NULL, NULL, 2140, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 11:50:20', 'admin-1471655526-1471665020517577', 1, 1, 'SR', NULL, NULL, NULL),
(6026, '2016-08-20 11:50:20', NULL, NULL, 2140, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 11:50:20', 'admin-1471655526-1471665020517577', 1, 1, 'SR', NULL, NULL, NULL),
(6027, '2016-08-20 11:58:26', NULL, NULL, 2142, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 11:58:26', 'admin-1471655526-1471665506467780', 1, 1, 'SR', NULL, NULL, NULL),
(6028, '2016-08-20 11:58:26', NULL, NULL, 2142, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 11:58:26', 'admin-1471655526-1471665506467780', 1, 1, 'SR', NULL, NULL, NULL),
(6029, '2016-08-20 11:58:26', NULL, NULL, 2142, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 11:58:26', 'admin-1471655526-1471665506467780', 1, 1, 'SR', NULL, NULL, NULL),
(6030, '2016-08-20 11:58:26', NULL, NULL, 2142, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 11:58:26', 'admin-1471655526-1471665506467780', 1, 1, 'SR', NULL, NULL, NULL),
(6031, '2016-08-20 10:16:57', NULL, NULL, 2134, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 10:16:57', 'admin-1471655526-14716594174715876', 1, 0, '', NULL, NULL, NULL),
(6032, '2016-08-20 10:16:57', NULL, NULL, 2134, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 10:16:57', 'admin-1471655526-14716594174715876', 1, 0, '', NULL, NULL, NULL),
(6033, '2016-08-20 10:16:57', NULL, NULL, 2134, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 10:16:57', 'admin-1471655526-14716594174715876', 1, 1, 'SR', NULL, NULL, NULL),
(6034, '2016-08-20 10:16:57', NULL, NULL, 2134, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1471667429', 'admin', '2016-08-20 10:16:57', 'admin-1471655526-14716594174715876', 1, 1, 'SR', NULL, NULL, NULL),
(6035, '2016-08-21 17:48:06', NULL, NULL, 2205, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:48:06', 'admin-1471770451-1471772886429867', 1, 1, 'SR', NULL, NULL, '10.0'),
(6036, '2016-08-21 17:33:53', NULL, NULL, 2210, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:33:53', 'admin-1471770451-14717720332099990', 1, 1, 'SR', NULL, NULL, NULL),
(6037, '2016-08-21 17:33:53', NULL, NULL, 2210, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:33:53', 'admin-1471770451-14717720332099990', 1, 1, 'SR', NULL, NULL, NULL),
(6038, '2016-08-21 17:33:53', NULL, NULL, 2210, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:33:53', 'admin-1471770451-14717720332099990', 1, 1, 'SR', NULL, NULL, NULL),
(6039, '2016-08-21 17:33:53', NULL, NULL, 2210, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:33:53', 'admin-1471770451-14717720332099990', 1, 1, 'SR', NULL, NULL, NULL),
(6040, '2016-08-21 17:33:53', NULL, NULL, 2210, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:33:53', 'admin-1471770451-14717720332099990', 1, 1, 'SR', NULL, NULL, NULL),
(6041, '2016-08-21 17:29:32', NULL, NULL, 2209, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:29:32', 'admin-1471770451-1471771771961311', 1, 1, 'SR', NULL, NULL, NULL),
(6042, '2016-08-21 17:29:32', NULL, NULL, 2209, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:29:32', 'admin-1471770451-1471771771961311', 1, 1, 'SR', NULL, NULL, NULL),
(6043, '2016-08-21 17:29:32', NULL, NULL, 2209, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:29:32', 'admin-1471770451-1471771771961311', 1, 0, '', NULL, NULL, NULL),
(6044, '2016-08-21 17:19:58', NULL, NULL, 2208, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:19:58', 'admin-1471770451-1471771198299864', 1, 1, 'SR', NULL, NULL, NULL),
(6045, '2016-08-21 13:23:01', NULL, NULL, 2195, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 13:23:01', 'admin-1471749979-14717569809055798', 1, 0, '', NULL, NULL, NULL),
(6046, '2016-08-21 14:23:47', NULL, NULL, 2196, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 14:23:47', 'admin-1471749979-14717606275264770', 1, 1, 'SR', NULL, NULL, NULL),
(6047, '2016-08-21 14:23:47', NULL, NULL, 2196, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 14:23:47', 'admin-1471749979-14717606275264770', 1, 1, 'SR', NULL, NULL, NULL),
(6048, '2016-08-21 14:23:47', NULL, NULL, 2196, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 14:23:47', 'admin-1471749979-14717606275264770', 1, 1, 'SR', NULL, NULL, NULL),
(6049, '2016-08-21 14:23:47', NULL, NULL, 2196, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 14:23:47', 'admin-1471749979-14717606275264770', 1, 1, 'SR', NULL, NULL, NULL),
(6050, '2016-08-21 14:25:26', NULL, NULL, 2197, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 14:25:26', 'admin-1471749979-14717607264599451', 1, 1, 'SR', NULL, NULL, NULL),
(6051, '2016-08-21 14:25:26', NULL, NULL, 2197, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 14:25:26', 'admin-1471749979-14717607264599451', 1, 1, 'SR', NULL, NULL, NULL),
(6052, '2016-08-21 17:19:58', NULL, NULL, 2208, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:19:58', 'admin-1471770451-1471771198299864', 1, 1, 'SR', NULL, NULL, NULL),
(6053, '2016-08-21 17:19:02', NULL, NULL, 2207, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:19:02', 'admin-1471770451-14717711422009021', 1, 1, 'SR', NULL, NULL, NULL),
(6054, '2016-08-21 17:19:02', NULL, NULL, 2207, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:19:02', 'admin-1471770451-14717711422009021', 1, 1, 'SR', NULL, NULL, NULL),
(6055, '2016-08-21 17:19:02', NULL, NULL, 2207, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:19:02', 'admin-1471770451-14717711422009021', 1, 1, 'SR', NULL, NULL, NULL),
(6056, '2016-08-21 14:26:03', NULL, NULL, 2198, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 14:26:03', 'admin-1471749979-14717607637404313', 1, 1, 'SR', NULL, NULL, NULL),
(6057, '2016-08-21 15:26:37', NULL, NULL, 2199, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 15:26:37', 'admin-1471749979-14717643974917096', 1, 0, '', NULL, NULL, NULL),
(6058, '2016-08-21 15:26:37', NULL, NULL, 2199, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 15:26:37', 'admin-1471749979-14717643974917096', 1, 1, 'SR', NULL, NULL, NULL),
(6059, '2016-08-21 15:49:17', NULL, NULL, 2200, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 15:49:17', 'admin-1471749979-14717657577649430', 1, 1, 'SR', NULL, NULL, NULL),
(6060, '2016-08-21 15:49:18', NULL, NULL, 2200, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 15:49:18', 'admin-1471749979-14717657577649430', 1, 1, 'SR', NULL, NULL, NULL),
(6061, '2016-08-21 16:00:57', NULL, NULL, 2201, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 16:00:57', 'admin-1471749979-14717664572776844', 1, 0, '', NULL, NULL, NULL),
(6062, '2016-08-21 16:00:57', NULL, NULL, 2201, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 16:00:57', 'admin-1471749979-14717664572776844', 1, 1, 'SR', NULL, NULL, NULL),
(6063, '2016-08-21 16:07:05', NULL, NULL, 2202, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 16:07:05', 'admin-1471749979-1471766825652466', 1, 0, '', NULL, NULL, NULL),
(6064, '2016-08-21 16:16:37', NULL, NULL, 2203, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 16:16:37', 'admin-1471749979-14717673971712521', 1, 0, '', NULL, NULL, NULL),
(6065, '2016-08-21 16:16:37', NULL, NULL, 2203, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 16:16:37', 'admin-1471749979-14717673971712521', 1, 0, '', NULL, NULL, NULL),
(6066, '2016-08-21 16:16:37', NULL, NULL, 2203, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 16:16:37', 'admin-1471749979-14717673971712521', 1, 1, 'SR', NULL, NULL, NULL),
(6067, '2016-08-21 16:53:13', NULL, NULL, 2204, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 16:53:13', 'admin-1471749979-14717695938107976', 1, 0, '', NULL, NULL, NULL),
(6068, '2016-08-21 16:53:13', NULL, NULL, 2204, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 16:53:13', 'admin-1471749979-14717695938107976', 1, 0, '', NULL, NULL, NULL),
(6069, '2016-08-21 17:06:41', NULL, NULL, 2206, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:06:41', 'admin-1471749979-14717704014151388', 1, 0, '', NULL, NULL, NULL),
(6070, '2016-08-21 17:06:41', NULL, NULL, 2206, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:06:41', 'admin-1471749979-14717704014151388', 1, 1, 'SR', NULL, NULL, NULL),
(6071, '2016-08-21 17:08:16', NULL, NULL, 2206, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:08:16', 'admin-1471770451-1471770495873171', 1, 1, 'SR', NULL, NULL, NULL),
(6072, '2016-08-21 17:08:16', NULL, NULL, 2206, 0, 79, '79', 'Summer Salad ', 'bacon', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:08:16', 'admin-1471770451-1471770495873171', 1, 1, 'SR', NULL, NULL, NULL),
(6073, '2016-08-21 17:19:02', NULL, NULL, 2207, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:19:02', 'admin-1471770451-14717711422009021', 1, 1, 'SR', NULL, NULL, NULL),
(6074, '2016-08-21 00:00:00', NULL, NULL, 2217, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 19:37:58', 'admin-1471770451-14717794785596695', 1, 1, 'SR', NULL, NULL, '10.0'),
(6075, '2016-08-21 20:22:34', NULL, NULL, 2216, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 20:22:34', 'admin-1471770451-14717821541296079', 1, 0, '', 1, NULL, NULL),
(6076, '2016-08-21 00:00:00', NULL, NULL, 2217, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:48:06', 'admin-1471770451-1471772886429867', 1, 0, '', NULL, NULL, '10.0'),
(6077, '2016-08-21 19:37:58', NULL, NULL, 2205, 0, 181, '116', 'Open Food ', 'Curry Prawn', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 19:37:58', 'admin-1471770451-14717794785596695', 1, 0, '', NULL, NULL, '10.0'),
(6078, '2016-08-21 18:19:02', NULL, NULL, 2214, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 18:19:02', 'admin-1471770451-14717747419139765', 1, 1, 'SR', NULL, NULL, NULL),
(6079, '2016-08-21 18:53:05', NULL, NULL, 2215, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 18:53:05', 'admin-1471770451-1471776785685155', 1, 0, '', NULL, NULL, NULL),
(6080, '2016-08-21 18:53:05', NULL, NULL, 2215, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 18:53:05', 'admin-1471770451-1471776785685155', 1, 1, 'SR', NULL, NULL, NULL),
(6081, '2016-08-21 17:51:18', NULL, NULL, 2212, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:51:18', 'admin-1471770451-14717730780394215', 1, 1, 'SR', NULL, NULL, NULL),
(6082, '2016-08-21 17:51:18', NULL, NULL, 2212, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:51:18', 'admin-1471770451-14717730780394215', 1, 1, 'SR', NULL, NULL, NULL),
(6083, '2016-08-21 18:08:30', NULL, NULL, 2213, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 18:08:30', 'admin-1471770451-14717741100533574', 1, 1, 'SR', NULL, NULL, NULL),
(6084, '2016-08-21 17:48:18', NULL, NULL, 2211, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:48:18', 'admin-1471770451-1471772898064865', 1, 1, 'SR', NULL, NULL, NULL),
(6085, '2016-08-21 13:23:01', NULL, NULL, 2195, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 13:23:01', 'admin-1471749979-14717569809055798', 1, 0, '', NULL, NULL, NULL),
(6086, '2016-08-21 13:17:12', NULL, NULL, 2194, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 13:17:12', 'admin-1471749979-14717566325792114', 1, 0, '', NULL, NULL, NULL),
(6087, '2016-08-21 17:48:18', NULL, NULL, 2211, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:48:18', 'admin-1471770451-1471772898064865', 1, 1, 'SR', NULL, NULL, NULL),
(6088, '2016-08-21 00:00:00', NULL, NULL, 2217, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 17:48:06', 'admin-1471770451-1471772886429867', 1, 0, '', NULL, NULL, '10.0'),
(6089, '2016-08-21 18:08:30', NULL, NULL, 2213, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 18:08:30', 'admin-1471770451-14717741100533574', 1, 0, '', NULL, NULL, NULL),
(6090, '2016-08-21 13:17:12', NULL, NULL, 2194, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 13:17:12', 'admin-1471749979-14717566325792114', 1, 1, 'SR', NULL, NULL, NULL),
(6091, '2016-08-21 10:33:13', NULL, NULL, 2180, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 10:33:13', 'admin-1471746322-14717467928559975', 1, 0, '', NULL, NULL, '10.0'),
(6092, '2016-08-21 10:33:13', NULL, NULL, 2180, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 10:33:13', 'admin-1471746322-14717467928559975', 1, 1, 'SR', NULL, NULL, '10.0'),
(6093, '2016-08-21 10:44:21', NULL, NULL, 2181, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 10:44:21', 'admin-1471746322-1471747461139226', 1, 1, 'SR', NULL, NULL, NULL),
(6094, '2016-08-21 10:44:21', NULL, NULL, 2181, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 10:44:21', 'admin-1471746322-1471747461139226', 1, 0, '', NULL, NULL, NULL),
(6095, '2016-08-21 10:44:21', NULL, NULL, 2181, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 10:44:21', 'admin-1471746322-1471747461139226', 1, 1, 'SR', NULL, NULL, NULL),
(6096, '2016-08-21 10:45:22', NULL, NULL, 2182, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 10:45:22', 'admin-1471746322-14717475225683677', 1, 1, 'SR', NULL, NULL, NULL),
(6097, '2016-08-21 10:45:22', NULL, NULL, 2182, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 10:45:22', 'admin-1471746322-14717475225683677', 1, 0, '', NULL, NULL, NULL),
(6098, '2016-08-21 10:45:22', NULL, NULL, 2182, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 10:45:22', 'admin-1471746322-14717475225683677', 1, 1, 'SR', NULL, NULL, NULL),
(6099, '2016-08-21 10:47:34', NULL, NULL, 2183, 0, 181, '116', 'Open Food ', 'Black', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 10:47:34', 'admin-1471746322-14717476545931999', 1, 0, '', NULL, NULL, NULL),
(6100, '2016-08-21 10:47:34', NULL, NULL, 2183, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 10:47:34', 'admin-1471746322-14717476545931999', 1, 0, '', NULL, NULL, NULL),
(6101, '2016-08-21 10:53:30', NULL, NULL, 2179, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 10:53:30', 'admin-1471746322-14717480104766491', 1, 0, '', NULL, NULL, NULL),
(6102, '2016-08-21 10:53:30', NULL, NULL, 2179, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 10:53:30', 'admin-1471746322-14717480104766491', 1, 0, '', NULL, NULL, NULL),
(6103, '2016-08-21 10:53:30', NULL, NULL, 2179, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 10:53:30', 'admin-1471746322-14717480104766491', 1, 0, '', NULL, NULL, NULL),
(6104, '2016-08-21 10:53:30', NULL, NULL, 2179, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 10:53:30', 'admin-1471746322-14717480104766491', 1, 1, 'SR', NULL, NULL, NULL),
(6105, '2016-08-21 10:53:30', NULL, NULL, 2179, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 10:53:30', 'admin-1471746322-14717480104766491', 1, 1, 'SR', NULL, NULL, NULL),
(6106, '2016-08-21 11:14:10', NULL, NULL, 2184, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 11:14:10', 'admin-1471746322-14717492506657467', 1, 0, '', NULL, NULL, NULL),
(6107, '2016-08-21 11:14:10', NULL, NULL, 2184, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 11:14:10', 'admin-1471746322-14717492506657467', 1, 0, '', NULL, NULL, NULL),
(6108, '2016-08-21 11:14:10', NULL, NULL, 2184, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 11:14:10', 'admin-1471746322-14717492506657467', 1, 0, '', NULL, NULL, NULL),
(6109, '2016-08-21 11:14:23', NULL, NULL, 2184, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 11:14:23', 'admin-1471746322-14717492636446347', 1, 1, 'SR', NULL, NULL, NULL),
(6110, '2016-08-21 11:14:23', NULL, NULL, 2184, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 11:14:23', 'admin-1471746322-14717492636446347', 1, 1, 'SR', NULL, NULL, NULL),
(6111, '2016-08-21 11:14:34', NULL, NULL, 2184, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 11:14:34', 'admin-1471746322-14717492746666013', 1, 1, 'SR', NULL, NULL, NULL),
(6112, '2016-08-21 11:17:18', NULL, NULL, 2185, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 11:17:18', 'admin-1471746322-14717494384464456', 1, 0, '', NULL, NULL, NULL),
(6113, '2016-08-21 11:17:18', NULL, NULL, 2185, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 11:17:18', 'admin-1471746322-14717494384464456', 1, 0, '', NULL, NULL, NULL),
(6114, '2016-08-21 11:17:18', NULL, NULL, 2185, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 11:17:18', 'admin-1471746322-14717494384464456', 1, 1, 'SR', NULL, NULL, NULL),
(6115, '2016-08-21 11:26:13', NULL, NULL, 2186, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 11:26:13', 'admin-1471746322-14717499737007464', 1, 0, '', NULL, NULL, NULL),
(6116, '2016-08-21 11:26:13', NULL, NULL, 2186, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 11:26:13', 'admin-1471746322-14717499737007464', 1, 0, '', NULL, NULL, NULL),
(6117, '2016-08-21 18:19:02', NULL, NULL, 2214, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 18:19:02', 'admin-1471770451-14717747419139765', 1, 1, 'SR', NULL, NULL, NULL),
(6118, '2016-08-21 13:17:12', NULL, NULL, 2194, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 13:17:12', 'admin-1471749979-14717566325792114', 1, 0, '', NULL, NULL, NULL),
(6119, '2016-08-21 12:41:33', NULL, NULL, 2193, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 12:41:33', 'admin-1471749979-14717544936311075', 1, 1, 'SR', NULL, NULL, NULL),
(6120, '2016-08-21 12:19:30', NULL, NULL, 2190, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 12:19:30', 'admin-1471749979-14717531701117524', 1, 1, 'SR', NULL, NULL, NULL),
(6121, '2016-08-21 12:26:10', NULL, NULL, 2191, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 12:26:10', 'admin-1471749979-14717535704746783', 1, 1, 'SR', 1, NULL, NULL),
(6122, '2016-08-21 12:26:10', NULL, NULL, 2191, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 12:26:10', 'admin-1471749979-14717535704746783', 1, 1, 'SR', 1, NULL, NULL),
(6123, '2016-08-21 12:34:21', NULL, NULL, 2192, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 12:34:21', 'admin-1471749979-14717540610915047', 1, 1, 'SR', NULL, NULL, NULL),
(6124, '2016-08-21 12:34:21', NULL, NULL, 2192, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 12:34:21', 'admin-1471749979-14717540610915047', 1, 1, 'SR', NULL, NULL, NULL),
(6125, '2016-08-21 12:41:33', NULL, NULL, 2193, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 12:41:33', 'admin-1471749979-14717544936311075', 1, 0, '', NULL, NULL, NULL),
(6126, '2016-08-21 12:18:29', NULL, NULL, 2189, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 12:18:29', 'admin-1471749979-14717531093394357', 1, 1, 'SR', NULL, NULL, NULL),
(6127, '2016-08-21 12:19:30', NULL, NULL, 2190, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 12:19:30', 'admin-1471749979-14717531701117524', 1, 1, 'SR', NULL, NULL, NULL),
(6128, '2016-08-21 12:18:29', NULL, NULL, 2189, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 12:18:29', 'admin-1471749979-14717531093394357', 1, 1, 'SR', NULL, NULL, NULL),
(6129, '2016-08-21 12:18:29', NULL, NULL, 2189, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 12:18:29', 'admin-1471749979-14717531093394357', 1, 0, '', NULL, NULL, NULL),
(6130, '2016-08-21 12:18:29', NULL, NULL, 2189, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 12:18:29', 'admin-1471749979-14717531093394357', 1, 0, '', NULL, NULL, NULL),
(6131, '2016-08-21 12:16:06', NULL, NULL, 2188, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 12:16:06', 'admin-1471749979-14717529664201618', 1, 1, 'SR', NULL, NULL, NULL),
(6132, '2016-08-21 12:16:06', NULL, NULL, 2188, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 12:16:06', 'admin-1471749979-14717529664201618', 1, 1, 'SR', NULL, NULL, NULL),
(6133, '2016-08-21 11:51:59', NULL, NULL, 2187, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 11:51:59', 'admin-1471749979-14717515196654383', 1, 1, 'SR', NULL, NULL, NULL),
(6134, '2016-08-21 11:26:13', NULL, NULL, 2186, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 11:26:13', 'admin-1471746322-14717499737007464', 1, 1, 'SR', NULL, NULL, NULL),
(6135, '2016-08-21 11:26:13', NULL, NULL, 2186, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 11:26:13', 'admin-1471746322-14717499737007464', 1, 1, 'SR', NULL, NULL, NULL),
(6136, '2016-08-21 11:51:59', NULL, NULL, 2187, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 11:51:59', 'admin-1471749979-14717515196654383', 1, 1, 'SR', NULL, NULL, NULL),
(6137, '2016-08-21 13:17:12', NULL, NULL, 2194, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 13:17:12', 'admin-1471749979-14717566325792114', 1, 1, 'SR', NULL, NULL, NULL),
(6138, '2016-08-21 10:25:16', NULL, NULL, 2178, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 10:25:16', 'admin-1471743730-14717463161596436', 1, 0, '', NULL, NULL, NULL),
(6139, '2016-08-21 10:33:13', NULL, NULL, 2180, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 10:33:13', 'admin-1471746322-14717467928559975', 1, 0, '', NULL, NULL, '10.0'),
(6140, '2016-08-21 10:25:16', NULL, NULL, 2178, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 10:25:16', 'admin-1471743730-14717463161596436', 1, 0, '', NULL, NULL, NULL),
(6141, '2016-08-21 10:25:16', NULL, NULL, 2178, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 10:25:16', 'admin-1471743730-14717463161596436', 1, 0, '', NULL, NULL, NULL),
(6142, '2016-08-21 10:25:16', NULL, NULL, 2178, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 10:25:16', 'admin-1471743730-14717463161596436', 1, 0, '', NULL, NULL, NULL),
(6143, '2016-08-21 09:58:53', NULL, NULL, 2176, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:58:53', 'admin-1471743730-14717447333416010', 1, 1, 'SR', NULL, NULL, NULL),
(6144, '2016-08-21 09:49:53', NULL, NULL, 2173, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:49:53', 'admin-1471743730-1471744193453975', 1, 0, '', NULL, NULL, NULL),
(6145, '2016-08-21 09:51:30', NULL, NULL, 2174, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:51:30', 'admin-1471743730-14717442898414638', 1, 0, '', NULL, NULL, NULL),
(6146, '2016-08-21 09:52:53', NULL, NULL, 2175, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:52:53', 'admin-1471743730-14717443731794843', 1, 0, '', NULL, NULL, NULL),
(6147, '2016-08-21 09:52:53', NULL, NULL, 2175, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:52:53', 'admin-1471743730-14717443731794843', 1, 0, '', NULL, NULL, NULL),
(6148, '2016-08-21 09:52:53', NULL, NULL, 2175, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:52:53', 'admin-1471743730-14717443731794843', 1, 1, 'SR', NULL, NULL, NULL),
(6149, '2016-08-21 09:27:08', NULL, NULL, 2169, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:27:08', 'admin-1471741108-14717428286028171', 1, 1, 'SR', NULL, NULL, NULL),
(6150, '2016-08-21 09:27:08', NULL, NULL, 2169, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:27:08', 'admin-1471741108-14717428286028171', 1, 1, 'SR', NULL, NULL, NULL),
(6151, '2016-08-21 09:27:08', NULL, NULL, 2169, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:27:08', 'admin-1471741108-14717428286028171', 1, 0, '', NULL, NULL, NULL),
(6152, '2016-08-21 09:27:08', NULL, NULL, 2169, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:27:08', 'admin-1471741108-14717428286028171', 1, 0, '', NULL, NULL, NULL),
(6153, '2016-08-21 10:19:39', NULL, NULL, 2177, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 10:19:39', 'admin-1471743730-14717459792159058', 1, 0, '', NULL, NULL, NULL),
(6154, '2016-08-21 09:31:32', NULL, NULL, 2170, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:31:32', 'admin-1471741108-1471743092346496', 1, 0, '', NULL, NULL, '10.0'),
(6155, '2016-08-21 09:52:53', NULL, NULL, 2175, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:52:53', 'admin-1471743730-14717443731794843', 1, 1, 'SR', NULL, NULL, NULL),
(6156, '2016-08-21 09:49:53', NULL, NULL, 2173, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:49:53', 'admin-1471743730-1471744193453975', 1, 1, 'SR', NULL, NULL, NULL),
(6157, '2016-08-21 09:49:53', NULL, NULL, 2173, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:49:53', 'admin-1471743730-1471744193453975', 1, 1, 'SR', NULL, NULL, NULL),
(6158, '2016-08-21 09:49:53', NULL, NULL, 2173, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:49:53', 'admin-1471743730-1471744193453975', 1, 1, 'SR', NULL, NULL, NULL),
(6159, '2016-08-21 09:42:36', NULL, NULL, 2171, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:42:36', 'admin-1471743730-14717437563327511', 1, 0, '', NULL, NULL, NULL),
(6160, '2016-08-21 09:41:44', NULL, NULL, 2171, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:41:44', 'admin-1471741108-14717437041714863', 1, 0, '', NULL, NULL, NULL),
(6161, '2016-08-21 09:41:44', NULL, NULL, 2171, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:41:44', 'admin-1471741108-14717437041714863', 1, 1, 'SR', NULL, NULL, NULL),
(6162, '2016-08-21 09:45:35', NULL, NULL, 2172, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:45:35', 'admin-1471743730-1471743934789791', 1, 1, 'SR', 1, NULL, NULL),
(6163, '2016-08-21 09:49:53', NULL, NULL, 2173, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:49:53', 'admin-1471743730-1471744193453975', 1, 0, '', NULL, NULL, NULL),
(6164, '2016-08-21 09:49:53', NULL, NULL, 2173, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:49:53', 'admin-1471743730-1471744193453975', 1, 0, '', NULL, NULL, NULL),
(6165, '2016-08-21 09:41:44', NULL, NULL, 2171, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:41:44', 'admin-1471741108-14717437041714863', 1, 1, 'SR', NULL, NULL, NULL),
(6166, '2016-08-21 09:41:44', NULL, NULL, 2171, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:41:44', 'admin-1471741108-14717437041714863', 1, 1, 'SR', NULL, NULL, NULL),
(6167, '2016-08-21 09:41:44', NULL, NULL, 2171, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:41:44', 'admin-1471741108-14717437041714863', 1, 0, '', NULL, NULL, NULL),
(6168, '2016-08-21 09:41:44', NULL, NULL, 2171, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:41:44', 'admin-1471741108-14717437041714863', 1, 1, 'SR', NULL, NULL, NULL),
(6169, '2016-08-21 09:31:32', NULL, NULL, 2170, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:31:32', 'admin-1471741108-1471743092346496', 1, 1, 'SR', NULL, NULL, '10.0'),
(6170, '2016-08-21 09:31:32', NULL, NULL, 2170, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:31:32', 'admin-1471741108-1471743092346496', 1, 1, 'SR', NULL, NULL, '10.0'),
(6171, '2016-08-21 09:31:32', NULL, NULL, 2170, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:31:32', 'admin-1471741108-1471743092346496', 1, 0, '', NULL, NULL, '10.0'),
(6172, '2016-08-21 09:31:32', NULL, NULL, 2170, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:31:32', 'admin-1471741108-1471743092346496', 1, 0, '', NULL, NULL, '10.0'),
(6173, '2016-08-21 09:31:32', NULL, NULL, 2170, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:31:32', 'admin-1471741108-1471743092346496', 1, 1, 'SR', NULL, NULL, '10.0'),
(6174, '2016-08-21 09:31:32', NULL, NULL, 2170, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:31:32', 'admin-1471741108-1471743092346496', 1, 1, 'SR', NULL, NULL, '10.0'),
(6175, '2016-08-21 09:31:32', NULL, NULL, 2170, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:31:32', 'admin-1471741108-1471743092346496', 1, 0, '', NULL, NULL, '10.0'),
(6176, '2016-08-21 09:27:08', NULL, NULL, 2169, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:27:08', 'admin-1471741108-14717428286028171', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(6177, '2016-08-21 09:31:32', NULL, NULL, 2170, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:31:32', 'admin-1471741108-1471743092346496', 1, 0, '', NULL, NULL, '10.0'),
(6178, '2016-08-21 09:27:08', NULL, NULL, 2169, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:27:08', 'admin-1471741108-14717428286028171', 1, 0, '', NULL, NULL, NULL),
(6179, '2016-08-21 09:27:08', NULL, NULL, 2169, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:27:08', 'admin-1471741108-14717428286028171', 1, 0, '', NULL, NULL, NULL),
(6180, '2016-08-21 09:25:19', NULL, NULL, 2169, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:25:19', 'admin-1471741108-1471742719124346', 1, 1, 'SR', NULL, NULL, NULL),
(6181, '2016-08-21 09:03:33', NULL, NULL, 2165, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:03:33', 'admin-1471741108-14717414129609681', 1, 1, 'SR', NULL, NULL, NULL),
(6182, '2016-08-21 09:03:33', NULL, NULL, 2165, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:03:33', 'admin-1471741108-14717414129609681', 1, 1, 'SR', NULL, NULL, NULL),
(6183, '2016-08-21 09:25:19', NULL, NULL, 2169, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:25:19', 'admin-1471741108-1471742719124346', 1, 0, '', NULL, NULL, NULL),
(6184, '2016-08-21 09:19:38', NULL, NULL, 2168, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:19:38', 'admin-1471741108-14717423781632788', 1, 1, 'SR', NULL, NULL, NULL),
(6185, '2016-08-21 09:25:19', NULL, NULL, 2169, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:25:19', 'admin-1471741108-1471742719124346', 1, 0, '', NULL, NULL, NULL),
(6186, '2016-08-21 09:16:29', NULL, NULL, 2167, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:16:29', 'admin-1471741108-14717421893819599', 1, 1, 'SR', NULL, NULL, NULL),
(6187, '2016-08-21 09:16:29', NULL, NULL, 2167, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:16:29', 'admin-1471741108-14717421893819599', 1, 0, '', NULL, NULL, NULL),
(6188, '2016-08-21 09:16:29', NULL, NULL, 2167, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:16:29', 'admin-1471741108-14717421893819599', 1, 0, '', NULL, NULL, NULL),
(6189, '2016-08-21 09:16:29', NULL, NULL, 2167, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:16:29', 'admin-1471741108-14717421893819599', 1, 1, 'SR', NULL, NULL, NULL),
(6190, '2016-08-21 09:14:01', NULL, NULL, 2166, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:14:01', 'admin-1471741108-14717420409059927', 1, 1, 'SR', NULL, NULL, NULL),
(6191, '2016-08-21 09:14:01', NULL, NULL, 2166, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:14:01', 'admin-1471741108-14717420409059927', 1, 1, 'SR', NULL, NULL, NULL),
(6192, '2016-08-21 09:12:53', NULL, NULL, 2166, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:12:53', 'admin-1471741108-14717419732812091', 1, 1, 'SR', NULL, NULL, NULL),
(6193, '2016-08-21 09:12:53', NULL, NULL, 2166, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:12:53', 'admin-1471741108-14717419732812091', 1, 0, '', NULL, NULL, NULL),
(6194, '2016-08-21 09:12:53', NULL, NULL, 2166, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:12:53', 'admin-1471741108-14717419732812091', 1, 0, '', NULL, NULL, NULL),
(6195, '2016-08-21 09:12:53', NULL, NULL, 2166, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:12:53', 'admin-1471741108-14717419732812091', 1, 0, '', NULL, NULL, NULL),
(6196, '2016-08-21 09:03:33', NULL, NULL, 2165, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471770451', 'admin', '2016-08-21 09:03:33', 'admin-1471741108-14717414129609681', 1, 1, 'SR', NULL, NULL, NULL),
(6197, '2016-08-22 16:36:40', NULL, NULL, 2231, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 16:36:40', 'admin-1471827960-1471855000505669', 1, 0, '', NULL, NULL, NULL),
(6198, '2016-08-22 16:26:25', NULL, NULL, 2236, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 16:26:25', 'admin-1471827960-1471854385189862', 1, 0, '', NULL, NULL, NULL),
(6199, '2016-08-22 16:26:25', NULL, NULL, 2236, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 16:26:25', 'admin-1471827960-1471854385189862', 1, 0, '', NULL, NULL, NULL),
(6200, '2016-08-22 20:46:39', NULL, NULL, 2239, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 20:46:39', 'admin-1471856101-14718699989053758', 1, 1, 'SR', NULL, NULL, NULL),
(6201, '2016-08-22 20:46:39', NULL, NULL, 2239, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 20:46:39', 'admin-1471856101-14718699989053758', 1, 1, 'SR', NULL, NULL, NULL),
(6202, '2016-08-22 20:46:39', NULL, NULL, 2239, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 20:46:39', 'admin-1471856101-14718699989053758', 1, 1, 'SR', NULL, NULL, NULL),
(6203, '2016-08-22 17:10:20', NULL, NULL, 2238, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 17:10:20', 'admin-1471856101-14718570199945981', 1, 1, 'SR', NULL, NULL, NULL),
(6204, '2016-08-22 16:55:07', NULL, NULL, 2237, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 16:55:07', 'admin-1471856101-14718561077092245', 1, 1, 'SR', NULL, NULL, NULL),
(6205, '2016-08-22 12:09:40', NULL, NULL, 2226, 0, 181, '116', 'Open Food ', 'Hot Lips Prawn', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 12:09:40', 'admin-1471827960-14718389808247751', 1, 0, '', NULL, NULL, NULL),
(6206, '2016-08-22 12:53:51', NULL, NULL, 2228, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 12:53:51', 'admin-1471827960-14718416308424194', 1, 1, 'SR', NULL, NULL, NULL),
(6207, '2016-08-22 12:09:40', NULL, NULL, 2226, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 12:09:40', 'admin-1471827960-14718389808247751', 1, 1, 'SR', NULL, NULL, NULL),
(6208, '2016-08-22 16:26:25', NULL, NULL, 2236, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 16:26:25', 'admin-1471827960-1471854385189862', 1, 0, '', NULL, NULL, NULL),
(6209, '2016-08-22 16:25:20', NULL, NULL, 2235, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 16:25:20', 'admin-1471827960-14718543205701626', 1, 1, 'SR', NULL, NULL, NULL),
(6210, '2016-08-22 16:25:20', NULL, NULL, 2235, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 16:25:20', 'admin-1471827960-14718543205701626', 1, 1, 'SR', NULL, NULL, NULL),
(6211, '2016-08-22 16:25:20', NULL, NULL, 2235, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 16:25:20', 'admin-1471827960-14718543205701626', 1, 1, 'SR', NULL, NULL, NULL),
(6212, '2016-08-22 17:36:27', NULL, NULL, 2235, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 17:36:27', 'admin-1471856101-14718585873606610', 1, 0, '', NULL, NULL, NULL),
(6213, '2016-08-22 16:26:25', NULL, NULL, 2236, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 16:26:25', 'admin-1471827960-1471854385189862', 1, 1, 'SR', NULL, NULL, NULL),
(6214, '2016-08-22 15:10:12', NULL, NULL, 2233, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 15:10:12', 'admin-1471827960-14718498126748520', 1, 1, 'SR', NULL, NULL, NULL),
(6215, '2016-08-22 15:10:12', NULL, NULL, 2233, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 15:10:12', 'admin-1471827960-14718498126748520', 1, 0, '', NULL, NULL, NULL),
(6216, '2016-08-22 15:10:12', NULL, NULL, 2233, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 15:10:12', 'admin-1471827960-14718498126748520', 1, 0, '', NULL, NULL, NULL),
(6217, '2016-08-22 14:50:37', NULL, NULL, 2232, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 14:50:37', 'admin-1471827960-14718486371265254', 1, 1, 'SR', NULL, NULL, NULL),
(6218, '2016-08-22 15:10:12', NULL, NULL, 2233, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 15:10:12', 'admin-1471827960-14718498126748520', 1, 1, 'SR', NULL, NULL, NULL),
(6219, '2016-08-22 15:10:12', NULL, NULL, 2233, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 15:10:12', 'admin-1471827960-14718498126748520', 1, 0, '', NULL, NULL, NULL),
(6220, '2016-08-22 14:57:39', NULL, NULL, 2231, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 14:57:39', 'admin-1471827960-14718490593939471', 1, 1, 'SR', NULL, NULL, NULL),
(6221, '2016-08-22 13:31:17', NULL, NULL, 2229, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 13:31:17', 'admin-1471827960-14718438769165940', 1, 1, 'SR', NULL, NULL, NULL),
(6222, '2016-08-22 13:46:41', NULL, NULL, 2230, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 13:46:41', 'admin-1471827960-14718448011939972', 1, 0, '', NULL, NULL, NULL),
(6223, '2016-08-22 13:46:41', NULL, NULL, 2230, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 13:46:41', 'admin-1471827960-14718448011939972', 1, 0, '', NULL, NULL, NULL),
(6224, '2016-08-22 13:46:41', NULL, NULL, 2230, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 13:46:41', 'admin-1471827960-14718448011939972', 1, 0, '', NULL, NULL, NULL),
(6225, '2016-08-22 13:46:41', NULL, NULL, 2230, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 13:46:41', 'admin-1471827960-14718448011939972', 1, 1, 'SR', NULL, NULL, NULL),
(6226, '2016-08-22 14:43:33', NULL, NULL, 2231, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 14:43:33', 'admin-1471827960-14718482129643445', 1, 1, 'SR', NULL, NULL, NULL),
(6227, '2016-08-22 14:43:33', NULL, NULL, 2231, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 14:43:33', 'admin-1471827960-14718482129643445', 1, 0, '', NULL, NULL, NULL),
(6228, '2016-08-22 14:43:33', NULL, NULL, 2231, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 14:43:33', 'admin-1471827960-14718482129643445', 1, 1, 'SR', NULL, NULL, NULL),
(6229, '2016-08-22 12:30:13', NULL, NULL, 2227, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 12:30:13', 'admin-1471827960-14718402134755195', 1, 1, 'SR', NULL, NULL, NULL),
(6230, '2016-08-22 12:53:51', NULL, NULL, 2228, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 12:53:51', 'admin-1471827960-14718416308424194', 1, 1, 'SR', NULL, NULL, NULL),
(6231, '2016-08-22 12:09:40', NULL, NULL, 2226, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 12:09:40', 'admin-1471827960-14718389808247751', 1, 1, 'SR', NULL, NULL, NULL),
(6232, '2016-08-22 12:03:30', NULL, NULL, 2225, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 12:03:30', 'admin-1471827960-1471838610012279', 1, 1, 'SR', NULL, NULL, NULL),
(6233, '2016-08-22 12:03:30', NULL, NULL, 2225, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 12:03:30', 'admin-1471827960-1471838610012279', 1, 1, 'SR', NULL, NULL, NULL),
(6234, '2016-08-22 11:47:50', NULL, NULL, 2224, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 11:47:50', 'admin-1471827960-14718376701911780', 1, 0, '', NULL, NULL, NULL),
(6235, '2016-08-22 11:47:38', NULL, NULL, 2224, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 11:47:38', 'admin-1471827960-14718376580607236', 1, 0, '', NULL, NULL, NULL),
(6236, '2016-08-22 11:47:50', NULL, NULL, 2224, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 11:47:50', 'admin-1471827960-14718376701911780', 1, 1, 'SR', NULL, NULL, NULL),
(6237, '2016-08-22 10:58:11', NULL, NULL, 2223, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 10:58:11', 'admin-1471827960-1471834691523591', 1, 1, 'SR', NULL, NULL, NULL),
(6238, '2016-08-22 10:58:11', NULL, NULL, 2223, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 10:58:11', 'admin-1471827960-1471834691523591', 1, 1, 'SR', NULL, NULL, NULL),
(6239, '2016-08-22 10:57:26', NULL, NULL, 2223, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 10:57:26', 'admin-1471827960-14718346462401792', 1, 0, '', NULL, NULL, NULL),
(6240, '2016-08-22 10:07:53', NULL, NULL, 2222, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 10:07:53', 'admin-1471827960-14718316737727926', 1, 1, 'SR', NULL, NULL, NULL),
(6241, '2016-08-22 10:08:24', NULL, NULL, 2222, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 10:08:24', 'admin-1471827960-14718317044536167', 1, 0, '', NULL, NULL, NULL),
(6242, '2016-08-22 10:57:26', NULL, NULL, 2223, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 10:57:26', 'admin-1471827960-14718346462401792', 1, 0, '', NULL, NULL, NULL),
(6243, '2016-08-22 09:28:34', NULL, NULL, 2220, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 09:28:34', 'admin-1471827960-14718293143915526', 1, 1, 'SR', NULL, NULL, NULL),
(6244, '2016-08-22 10:07:53', NULL, NULL, 2222, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 10:07:53', 'admin-1471827960-14718316737727926', 1, 1, 'SR', NULL, NULL, NULL),
(6245, '2016-08-22 10:07:46', NULL, NULL, 2222, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 10:07:46', 'admin-1471827960-14718316660765088', 1, 0, '', NULL, NULL, NULL),
(6246, '2016-08-22 09:29:03', NULL, NULL, 2221, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 09:29:03', 'admin-1471827960-14718293435217468', 1, 1, 'SR', NULL, NULL, NULL),
(6247, '2016-08-22 09:06:08', NULL, NULL, 2219, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1471856101', 'admin', '2016-08-22 09:06:08', 'admin-1471827960-14718279688045470', 1, 1, 'SR', 1, NULL, NULL),
(6248, '2016-08-23 13:00:45', NULL, NULL, 2246, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 13:00:45', 'admin-1471914353-14719284453909915', 1, 0, '', NULL, NULL, NULL),
(6249, '2016-08-23 14:39:31', NULL, NULL, 2251, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 14:39:31', 'admin-1471914353-1471934371645442', 1, 1, 'SR', NULL, NULL, NULL),
(6250, '2016-08-23 14:46:22', NULL, NULL, 2252, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 14:46:22', 'admin-1471914353-14719347823857738', 1, 1, 'SR', NULL, NULL, NULL),
(6251, '2016-08-23 14:46:49', NULL, NULL, 2252, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 14:46:49', 'admin-1471914353-1471934809363414', 1, 1, 'SR', NULL, NULL, NULL),
(6252, '2016-08-23 15:13:07', NULL, NULL, 2253, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 15:13:07', 'admin-1471914353-14719363875579040', 1, 1, 'SR', 1, NULL, '15.0'),
(6253, '2016-08-23 15:44:40', NULL, NULL, 2254, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 15:44:40', 'admin-1471914353-1471938280722687', 1, 1, 'SR', NULL, NULL, NULL),
(6254, '2016-08-23 14:24:13', NULL, NULL, 2247, 0, 181, '116', 'Open Food ', 'Chicken Bites', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 14:24:13', 'admin-1471914353-14719334532586412', 1, 0, '', NULL, NULL, NULL),
(6255, '2016-08-23 13:08:58', NULL, NULL, 2247, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 13:08:58', 'admin-1471914353-14719289377735437', 1, 1, 'SR', NULL, NULL, NULL),
(6256, '2016-08-23 13:12:06', NULL, NULL, 2244, 0, 181, '116', 'Open Food ', 'curry prawn', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 13:12:06', 'admin-1471914353-1471929126539935', 1, 0, '', NULL, NULL, NULL),
(6257, '2016-08-23 13:21:17', NULL, NULL, 2248, 0, 181, '116', 'Open Food ', 'curry prawn', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 13:21:17', 'admin-1471914353-14719296771516379', 1, 0, '', NULL, NULL, NULL),
(6258, '2016-08-23 13:24:06', NULL, NULL, 2249, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 13:24:06', 'admin-1471914353-14719298460152871', 1, 0, '', NULL, NULL, NULL),
(6259, '2016-08-23 14:19:39', NULL, NULL, 2250, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 14:19:39', 'admin-1471914353-14719331797408935', 1, 0, '', NULL, NULL, NULL),
(6260, '2016-08-23 14:19:39', NULL, NULL, 2250, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 14:19:39', 'admin-1471914353-14719331797408935', 1, 1, 'SR', NULL, NULL, NULL),
(6261, '2016-08-23 14:19:39', NULL, NULL, 2250, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 14:19:39', 'admin-1471914353-14719331797408935', 1, 1, 'SR', NULL, NULL, NULL),
(6262, '2016-08-23 14:39:01', NULL, NULL, 2251, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 14:39:01', 'admin-1471914353-14719343412666426', 1, 0, '', NULL, NULL, NULL),
(6263, '2016-08-23 14:39:01', NULL, NULL, 2251, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 14:39:01', 'admin-1471914353-14719343412666426', 1, 1, 'SR', NULL, NULL, NULL),
(6264, '2016-08-23 14:39:01', NULL, NULL, 2251, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 14:39:01', 'admin-1471914353-14719343412666426', 1, 0, '', NULL, NULL, NULL),
(6265, '2016-08-23 13:08:30', NULL, NULL, 2244, 0, 181, '116', 'Open Food ', 'Hot dog bun', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 13:08:30', 'admin-1471914353-14719289105863526', 1, 0, '', NULL, NULL, NULL),
(6266, '2016-08-23 12:59:53', NULL, NULL, 2245, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 12:59:53', 'admin-1471914353-14719283936958086', 1, 1, 'SR', NULL, NULL, NULL),
(6267, '2016-08-23 12:59:53', NULL, NULL, 2245, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 12:59:53', 'admin-1471914353-14719283936958086', 1, 1, 'SR', NULL, NULL, NULL),
(6268, '2016-08-23 12:59:53', NULL, NULL, 2245, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 12:59:53', 'admin-1471914353-14719283936958086', 1, 1, 'SR', NULL, NULL, NULL),
(6269, '2016-08-23 12:59:53', NULL, NULL, 2245, 0, 156, '90', 'Cheese Omelet', 'no cheese', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 12:59:53', 'admin-1471914353-14719283936958086', 1, 0, '', NULL, NULL, NULL),
(6270, '2016-08-23 12:41:10', NULL, NULL, 2244, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 12:41:10', 'admin-1471914353-147192726991654', 1, 1, 'SR', NULL, NULL, NULL),
(6271, '2016-08-23 12:41:10', NULL, NULL, 2244, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 12:41:10', 'admin-1471914353-147192726991654', 1, 1, 'SR', NULL, NULL, NULL),
(6272, '2016-08-23 11:08:47', NULL, NULL, 2243, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 11:08:47', 'admin-1471914353-1471921727318976', 1, 1, 'SR', NULL, NULL, NULL),
(6273, '2016-08-23 11:08:47', NULL, NULL, 2243, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 11:08:47', 'admin-1471914353-1471921727318976', 1, 0, '', NULL, NULL, NULL),
(6274, '2016-08-23 10:34:46', NULL, NULL, 2241, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 10:34:46', 'admin-1471914353-14719196863548365', 1, 1, 'SR', NULL, NULL, NULL),
(6275, '2016-08-23 10:34:46', NULL, NULL, 2241, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 10:34:46', 'admin-1471914353-14719196863548365', 1, 0, '', NULL, NULL, NULL),
(6276, '2016-08-23 10:34:46', NULL, NULL, 2241, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 10:34:46', 'admin-1471914353-14719196863548365', 1, 0, '', NULL, NULL, NULL),
(6277, '2016-08-23 10:43:53', NULL, NULL, 2242, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 10:43:53', 'admin-1471914353-14719202336196339', 1, 1, 'SR', NULL, NULL, NULL),
(6278, '2016-08-23 10:34:46', NULL, NULL, 2241, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 10:34:46', 'admin-1471914353-14719196863548365', 1, 1, 'SR', NULL, NULL, NULL),
(6279, '2016-08-23 09:06:33', NULL, NULL, 2240, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 09:06:33', 'admin-1471914353-14719143934703317', 1, 1, 'SR', NULL, NULL, NULL),
(6280, '2016-08-23 10:34:46', NULL, NULL, 2241, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 10:34:46', 'admin-1471914353-14719196863548365', 1, 0, '', NULL, NULL, NULL),
(6281, '2016-08-23 09:06:33', NULL, NULL, 2240, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1471914353', 'admin', '2016-08-23 09:06:33', 'admin-1471914353-14719143934703317', 1, 0, '', NULL, NULL, NULL),
(6282, '2016-08-25 17:14:42', NULL, NULL, 2285, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 17:14:42', 'admin-1472097619-1472116482375978', 1, 1, 'SR', 1, NULL, NULL),
(6283, '2016-08-25 18:56:42', NULL, NULL, 2286, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 18:56:42', 'admin-1472097619-14721226022873915', 1, 0, '', NULL, NULL, NULL),
(6284, '2016-08-25 18:56:42', NULL, NULL, 2286, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 18:56:42', 'admin-1472097619-14721226022873915', 1, 0, '', NULL, NULL, NULL),
(6285, '2016-08-25 18:56:42', NULL, NULL, 2286, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 18:56:42', 'admin-1472097619-14721226022873915', 1, 0, '', NULL, NULL, NULL),
(6286, '2016-08-25 18:56:42', NULL, NULL, 2286, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 18:56:42', 'admin-1472097619-14721226022873915', 1, 0, '', NULL, NULL, NULL),
(6287, '2016-08-25 18:57:31', NULL, NULL, 2286, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 18:57:31', 'admin-1472097619-1472122651718521', 1, 1, 'SR', NULL, NULL, NULL),
(6288, '2016-08-25 18:57:31', NULL, NULL, 2286, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 18:57:31', 'admin-1472097619-1472122651718521', 1, 1, 'SR', NULL, NULL, NULL),
(6289, '2016-08-25 19:32:24', NULL, NULL, 2287, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 19:32:24', 'admin-1472097619-14721247440723650', 1, 0, '', NULL, NULL, NULL),
(6290, '2016-08-25 19:32:24', NULL, NULL, 2287, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 19:32:24', 'admin-1472097619-14721247440723650', 1, 0, '', NULL, NULL, NULL),
(6291, '2016-08-25 19:32:24', NULL, NULL, 2287, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 19:32:24', 'admin-1472097619-14721247440723650', 1, 1, 'SR', NULL, NULL, NULL),
(6292, '2016-08-25 19:32:24', NULL, NULL, 2287, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 19:32:24', 'admin-1472097619-14721247440723650', 1, 1, 'SR', NULL, NULL, NULL),
(6293, '2016-08-25 13:49:09', NULL, NULL, 2274, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 13:49:09', 'admin-1472097619-1472104149452502', 1, 1, 'SR', NULL, NULL, NULL),
(6294, '2016-08-25 17:12:04', NULL, NULL, 2284, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 17:12:04', 'admin-1472097619-1472116324368586', 1, 0, '', 1, NULL, NULL),
(6295, '2016-08-25 17:14:42', NULL, NULL, 2285, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 17:14:42', 'admin-1472097619-1472116482375978', 1, 1, 'SR', 1, NULL, NULL),
(6296, '2016-08-25 17:06:33', NULL, NULL, 2283, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 17:06:33', 'admin-1472097619-14721159933079498', 1, 0, '', 1, NULL, NULL),
(6297, '2016-08-25 17:12:04', NULL, NULL, 2284, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 17:12:04', 'admin-1472097619-1472116324368586', 1, 1, 'SR', 1, NULL, NULL),
(6298, '2016-08-25 16:58:36', NULL, NULL, 2282, 0, 181, '116', 'Open Food ', 'Prudential Hi Tea Set', 'Meals', 'Perfect Meals', 1, 972.00, 972.0000, 0.0000, 972.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 16:58:36', 'admin-1472097619-1472115516250829', 1, 0, '', NULL, NULL, NULL),
(6299, '2016-08-25 14:35:59', NULL, NULL, 2279, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 14:35:59', 'admin-1472097619-14721069590733183', 1, 0, '', 1, NULL, NULL),
(6300, '2016-08-25 13:31:48', NULL, NULL, 2277, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 13:31:48', 'admin-1472097619-14721031088086866', 1, 1, 'SR', NULL, NULL, NULL),
(6301, '2016-08-25 16:14:11', NULL, NULL, 2281, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 16:14:11', 'admin-1472097619-14721128515101891', 1, 0, '', NULL, NULL, NULL),
(6302, '2016-08-25 13:49:09', NULL, NULL, 2274, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 13:49:09', 'admin-1472097619-1472104149452502', 1, 0, '', NULL, NULL, NULL),
(6303, '2016-08-25 13:40:35', NULL, NULL, 2278, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 13:40:35', 'admin-1472097619-14721036348902430', 1, 1, 'SR', NULL, NULL, NULL),
(6304, '2016-08-25 13:40:35', NULL, NULL, 2278, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 13:40:35', 'admin-1472097619-14721036348902430', 1, 0, '', NULL, NULL, NULL),
(6305, '2016-08-25 13:12:24', NULL, NULL, 2275, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 13:12:24', 'admin-1472097619-1472101944353537', 1, 1, 'SR', NULL, NULL, NULL),
(6306, '2016-08-25 13:12:24', NULL, NULL, 2275, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 13:12:24', 'admin-1472097619-1472101944353537', 1, 1, 'SR', NULL, NULL, NULL),
(6307, '2016-08-25 13:12:46', NULL, NULL, 2276, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 13:12:46', 'admin-1472097619-14721019664567642', 1, 1, 'SR', NULL, NULL, NULL),
(6308, '2016-08-25 13:23:44', NULL, NULL, 2275, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 13:23:44', 'admin-1472097619-14721026237677212', 1, 1, 'SR', NULL, NULL, NULL),
(6309, '2016-08-25 13:23:44', NULL, NULL, 2275, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 13:23:44', 'admin-1472097619-14721026237677212', 1, 1, 'SR', NULL, NULL, NULL),
(6310, '2016-08-25 10:36:52', NULL, NULL, 2264, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472097619', 'lois', '2016-08-25 10:36:52', 'lois-1472086456-14720926127759314', 1, 0, '', NULL, NULL, NULL),
(6311, '2016-08-25 13:12:24', NULL, NULL, 2275, 0, 70, '70', 'Pepper Pork', 'Pasta', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 13:12:24', 'admin-1472097619-1472101944353537', 1, 1, 'SR', NULL, NULL, NULL),
(6312, '2016-08-25 12:37:58', NULL, NULL, 2273, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 12:37:58', 'admin-1472097619-14720998783712643', 1, 1, 'SR', NULL, NULL, NULL),
(6313, '2016-08-25 12:46:10', NULL, NULL, 2274, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 12:46:10', 'admin-1472097619-1472100370434725', 1, 1, 'SR', NULL, NULL, NULL),
(6314, '2016-08-25 12:46:10', NULL, NULL, 2274, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 12:46:10', 'admin-1472097619-1472100370434725', 1, 1, 'SR', NULL, NULL, NULL),
(6315, '2016-08-25 13:12:24', NULL, NULL, 2275, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 13:12:24', 'admin-1472097619-1472101944353537', 1, 0, '', NULL, NULL, NULL),
(6316, '2016-08-25 12:02:03', NULL, NULL, 2272, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 12:02:03', 'admin-1472097619-14720977235959438', 1, 1, 'SR', NULL, NULL, NULL),
(6317, '2016-08-25 12:00:10', NULL, NULL, 2271, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 12:00:10', 'admin-1472092621-14720976102014427', 1, 1, 'SR', NULL, NULL, NULL),
(6318, '2016-08-25 12:00:10', NULL, NULL, 2271, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 12:00:10', 'admin-1472092621-14720976102014427', 1, 1, 'SR', NULL, NULL, NULL),
(6319, '2016-08-25 12:00:10', NULL, NULL, 2271, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 12:00:10', 'admin-1472092621-14720976102014427', 1, 0, '', NULL, NULL, NULL),
(6320, '2016-08-25 11:58:36', NULL, NULL, 2270, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 11:58:36', 'admin-1472092621-14720975159166427', 1, 0, '', NULL, NULL, NULL),
(6321, '2016-08-25 11:23:58', NULL, NULL, 2268, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 11:23:58', 'admin-1472092621-14720954383163791', 1, 0, '', NULL, NULL, NULL),
(6322, '2016-08-25 11:53:25', NULL, NULL, 2269, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 11:53:25', 'admin-1472092621-14720972052886615', 1, 0, '', NULL, NULL, NULL),
(6323, '2016-08-25 11:54:09', NULL, NULL, 2269, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 11:54:09', 'admin-1472092621-14720972497008838', 1, 1, 'SR', NULL, NULL, NULL),
(6324, '2016-08-25 10:48:52', NULL, NULL, 2265, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 10:48:52', 'admin-1472092621-14720933324078579', 1, 0, '', NULL, NULL, NULL),
(6325, '2016-08-25 10:48:52', NULL, NULL, 2265, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 10:48:52', 'admin-1472092621-14720933324078579', 1, 1, 'SR', NULL, NULL, NULL),
(6326, '2016-08-25 10:59:45', NULL, NULL, 2267, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 10:59:45', 'admin-1472092621-14720939849692797', 1, 0, '', NULL, NULL, NULL),
(6327, '2016-08-25 10:36:52', NULL, NULL, 2264, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472097619', 'lois', '2016-08-25 10:36:52', 'lois-1472086456-14720926127759314', 1, 0, '', NULL, NULL, NULL),
(6328, '2016-08-25 10:45:35', NULL, NULL, 2265, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 10:45:35', 'admin-1472092621-1472093135175535', 1, 1, 'SR', NULL, NULL, NULL),
(6329, '2016-08-25 10:45:35', NULL, NULL, 2265, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 10:45:35', 'admin-1472092621-1472093135175535', 1, 0, '', NULL, NULL, NULL),
(6330, '2016-08-25 10:48:06', NULL, NULL, 2266, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 10:48:06', 'admin-1472092621-14720932862289995', 1, 1, 'SR', NULL, NULL, NULL),
(6331, '2016-08-25 10:48:06', NULL, NULL, 2266, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 10:48:06', 'admin-1472092621-14720932862289995', 1, 1, 'SR', NULL, NULL, NULL),
(6332, '2016-08-25 10:48:06', NULL, NULL, 2266, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 10:48:06', 'admin-1472092621-14720932862289995', 1, 1, 'SR', NULL, NULL, NULL),
(6333, '2016-08-25 10:48:06', NULL, NULL, 2266, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 10:48:06', 'admin-1472092621-14720932862289995', 1, 1, 'SR', NULL, NULL, NULL),
(6334, '2016-08-25 10:48:06', NULL, NULL, 2266, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 10:48:06', 'admin-1472092621-14720932862289995', 1, 1, 'SR', NULL, NULL, NULL),
(6335, '2016-08-25 10:48:06', NULL, NULL, 2266, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472097619', 'admin', '2016-08-25 10:48:06', 'admin-1472092621-14720932862289995', 1, 1, 'SR', NULL, NULL, NULL),
(6336, '2016-08-25 10:36:52', NULL, NULL, 2264, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472097619', 'lois', '2016-08-25 10:36:52', 'lois-1472086456-14720926127759314', 1, 0, '', NULL, NULL, NULL),
(6337, '2016-08-25 10:36:52', NULL, NULL, 2264, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472097619', 'lois', '2016-08-25 10:36:52', 'lois-1472086456-14720926127759314', 1, 1, 'SR', NULL, NULL, NULL),
(6338, '2016-08-25 10:19:09', NULL, NULL, 2263, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472097619', 'lois', '2016-08-25 10:19:09', 'lois-1472086456-14720915495942044', 1, 1, 'SR', 1, NULL, NULL),
(6339, '2016-08-25 09:33:27', NULL, NULL, 2262, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1472097619', 'lois', '2016-08-25 09:33:27', 'lois-1472086456-14720888069818253', 1, 1, 'SR', 1, NULL, NULL),
(6340, '2016-08-25 09:24:47', NULL, NULL, 2260, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472097619', 'lois', '2016-08-25 09:24:47', 'lois-1472086456-14720882869474029', 1, 0, '', NULL, NULL, NULL),
(6341, '2016-08-25 09:24:47', NULL, NULL, 2260, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472097619', 'lois', '2016-08-25 09:24:47', 'lois-1472086456-14720882869474029', 1, 0, '', NULL, NULL, NULL),
(6342, '2016-08-25 09:24:09', NULL, NULL, 2259, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472097619', 'lois', '2016-08-25 09:24:09', 'lois-1472086456-14720882494302192', 1, 1, 'SR', NULL, NULL, NULL),
(6343, '2016-08-25 09:24:09', NULL, NULL, 2259, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472097619', 'lois', '2016-08-25 09:24:09', 'lois-1472086456-14720882494302192', 1, 0, '', NULL, NULL, NULL),
(6344, '2016-08-25 09:16:28', NULL, NULL, 2258, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1472097619', 'lois', '2016-08-25 09:16:28', 'lois-1472086456-14720877884325878', 1, 1, 'SR', NULL, NULL, NULL),
(6345, '2016-08-25 09:02:41', NULL, NULL, 2256, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472097619', 'lois', '2016-08-25 09:02:41', 'lois-1472086456-14720869610924993', 1, 1, 'SR', NULL, NULL, NULL),
(6346, '2016-08-25 09:11:25', NULL, NULL, 2257, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472097619', 'lois', '2016-08-25 09:11:25', 'lois-1472086456-14720874856533088', 1, 1, 'SR', 1, NULL, NULL),
(6347, '2016-08-25 09:16:28', NULL, NULL, 2258, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472097619', 'lois', '2016-08-25 09:16:28', 'lois-1472086456-14720877884325878', 1, 0, '', NULL, NULL, NULL),
(6348, '2016-08-25 09:02:41', NULL, NULL, 2256, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472097619', 'lois', '2016-08-25 09:02:41', 'lois-1472086456-14720869610924993', 1, 0, '', NULL, NULL, NULL),
(6349, '2016-08-25 08:59:45', NULL, NULL, 2255, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472097619', 'lois', '2016-08-25 08:59:45', 'lois-1472086456-14720867850066278', 1, 1, 'SR', NULL, NULL, NULL),
(6350, '2016-08-25 08:59:45', NULL, NULL, 2255, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472097619', 'lois', '2016-08-25 08:59:45', 'lois-1472086456-14720867850066278', 1, 0, '', NULL, NULL, NULL),
(6351, '2016-08-25 08:59:45', NULL, NULL, 2255, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472097619', 'lois', '2016-08-25 08:59:45', 'lois-1472086456-14720867850066278', 1, 0, '', NULL, NULL, NULL),
(6352, '2016-08-25 08:59:45', NULL, NULL, 2255, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472097619', 'lois', '2016-08-25 08:59:45', 'lois-1472086456-14720867850066278', 1, 1, 'SR', NULL, NULL, NULL),
(6353, '2016-08-26 19:19:31', NULL, NULL, 2317, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 19:19:31', 'admin-1472185694-14722103710426456', 1, 0, '', NULL, NULL, NULL),
(6354, '2016-08-26 19:19:31', NULL, NULL, 2317, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 19:19:31', 'admin-1472185694-14722103710426456', 1, 0, '', NULL, NULL, NULL),
(6355, '2016-08-26 19:19:31', NULL, NULL, 2317, 0, 181, '116', 'Open Food ', 'Braised pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 19:19:31', 'admin-1472185694-14722103710426456', 1, 0, '', NULL, NULL, NULL),
(6356, '2016-08-26 19:19:31', NULL, NULL, 2317, 0, 181, '116', 'Open Food ', 'Chicken', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 19:19:31', 'admin-1472185694-14722103710426456', 1, 0, '', NULL, NULL, NULL),
(6357, '2016-08-26 19:19:48', NULL, NULL, 2317, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 19:19:48', 'admin-1472185694-14722103887714441', 1, 1, 'SR', NULL, NULL, NULL),
(6358, '2016-08-26 19:19:48', NULL, NULL, 2317, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 19:19:48', 'admin-1472185694-14722103887714441', 1, 1, 'SR', NULL, NULL, NULL),
(6359, '2016-08-26 19:19:48', NULL, NULL, 2317, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 19:19:48', 'admin-1472185694-14722103887714441', 1, 1, 'SR', NULL, NULL, NULL),
(6360, '2016-08-26 19:31:09', NULL, NULL, 2318, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 19:31:09', 'admin-1472185694-1472211069071702', 1, 1, 'SR', NULL, NULL, NULL),
(6361, '2016-08-26 19:31:09', NULL, NULL, 2318, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 19:31:09', 'admin-1472185694-1472211069071702', 1, 1, 'SR', NULL, NULL, NULL),
(6362, '2016-08-26 20:08:32', NULL, NULL, 2319, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 20:08:32', 'admin-1472185694-14722133121939762', 1, 1, 'SR', NULL, NULL, NULL),
(6363, '2016-08-26 20:08:32', NULL, NULL, 2319, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 20:08:32', 'admin-1472185694-14722133121939762', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(6364, '2016-08-26 20:08:32', NULL, NULL, 2319, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 20:08:32', 'admin-1472185694-14722133121939762', 1, 0, '', NULL, NULL, NULL),
(6365, '2016-08-26 20:10:54', NULL, NULL, 2321, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 20:10:54', 'admin-1472185694-14722134547491636', 1, 0, '', NULL, NULL, NULL),
(6366, '2016-08-26 20:11:14', NULL, NULL, 2322, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 20:11:14', 'admin-1472185694-14722134739957731', 1, 1, 'SR', NULL, NULL, NULL),
(6367, '2016-08-26 20:18:32', NULL, NULL, 2323, 0, 181, '116', 'Open Food ', 'chicken', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 20:18:32', 'admin-1472185694-14722139125928654', 1, 0, '', NULL, NULL, NULL),
(6368, '2016-08-26 17:33:10', NULL, NULL, 2315, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 17:33:10', 'admin-1472185694-14722039902588630', 1, 1, 'SR', NULL, NULL, NULL),
(6369, '2016-08-26 18:28:06', NULL, NULL, 2316, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 18:28:06', 'admin-1472185694-14722072859014186', 1, 0, '', NULL, NULL, NULL),
(6370, '2016-08-26 17:33:01', NULL, NULL, 2315, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 17:33:01', 'admin-1472185694-1472203981413468', 1, 0, '', NULL, NULL, NULL),
(6371, '2016-08-26 17:33:01', NULL, NULL, 2315, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 17:33:01', 'admin-1472185694-1472203981413468', 1, 0, '', NULL, NULL, NULL),
(6372, '2016-08-26 16:34:11', NULL, NULL, 2312, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 16:34:11', 'admin-1472185694-14722004509093924', 1, 1, 'SR', NULL, NULL, NULL),
(6373, '2016-08-26 16:34:11', NULL, NULL, 2312, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 16:34:11', 'admin-1472185694-14722004509093924', 1, 1, 'SR', NULL, NULL, NULL),
(6374, '2016-08-26 16:09:14', NULL, NULL, 2311, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 16:09:14', 'admin-1472185694-14721989544959032', 1, 1, 'SR', NULL, NULL, NULL),
(6375, '2016-08-26 16:41:34', NULL, NULL, 2313, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 16:41:34', 'admin-1472185694-14722008942529942', 1, 1, 'SR', NULL, NULL, NULL),
(6376, '2016-08-26 16:34:11', NULL, NULL, 2312, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 16:34:11', 'admin-1472185694-14722004509093924', 1, 1, 'SR', NULL, NULL, NULL),
(6377, '2016-08-26 16:09:14', NULL, NULL, 2311, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 16:09:14', 'admin-1472185694-14721989544959032', 1, 1, 'SR', NULL, NULL, NULL),
(6378, '2016-08-26 16:09:14', NULL, NULL, 2311, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 16:09:14', 'admin-1472185694-14721989544959032', 1, 0, '', NULL, NULL, NULL),
(6379, '2016-08-26 15:49:48', NULL, NULL, 2309, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 15:49:48', 'admin-1472185694-14721977881066195', 1, 1, 'SR', NULL, NULL, NULL),
(6380, '2016-08-26 15:50:39', NULL, NULL, 2310, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 15:50:39', 'admin-1472185694-14721978389787077', 1, 1, 'SR', NULL, NULL, NULL),
(6381, '2016-08-26 15:50:39', NULL, NULL, 2310, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 15:50:39', 'admin-1472185694-14721978389787077', 1, 1, 'SR', NULL, NULL, NULL),
(6382, '2016-08-26 15:50:39', NULL, NULL, 2310, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 15:50:39', 'admin-1472185694-14721978389787077', 1, 1, 'SR', NULL, NULL, NULL),
(6383, '2016-08-26 16:09:14', NULL, NULL, 2311, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 16:09:14', 'admin-1472185694-14721989544959032', 1, 1, 'SR', NULL, NULL, NULL),
(6384, '2016-08-26 12:37:22', NULL, NULL, 2298, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 12:37:22', 'admin-1472185694-14721862420356243', 1, 1, 'SR', 1, NULL, NULL),
(6385, '2016-08-26 15:49:48', NULL, NULL, 2309, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 15:49:48', 'admin-1472185694-14721977881066195', 1, 1, 'SR', NULL, NULL, NULL),
(6386, '2016-08-26 14:51:24', NULL, NULL, 2307, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 14:51:24', 'admin-1472185694-14721942842719413', 1, 0, '', NULL, NULL, NULL),
(6387, '2016-08-26 15:22:39', NULL, NULL, 2308, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 15:22:39', 'admin-1472185694-14721961595485518', 1, 1, 'SR', NULL, NULL, NULL),
(6388, '2016-08-26 15:22:39', NULL, NULL, 2308, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 15:22:39', 'admin-1472185694-14721961595485518', 1, 1, 'SR', NULL, NULL, NULL),
(6389, '2016-08-26 15:22:39', NULL, NULL, 2308, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 15:22:39', 'admin-1472185694-14721961595485518', 1, 0, '', NULL, NULL, NULL),
(6390, '2016-08-26 14:51:24', NULL, NULL, 2307, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 14:51:24', 'admin-1472185694-14721942842719413', 1, 0, '', NULL, NULL, NULL),
(6391, '2016-08-26 14:51:24', NULL, NULL, 2307, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 14:51:24', 'admin-1472185694-14721942842719413', 1, 1, 'SR', NULL, NULL, NULL),
(6392, '2016-08-26 14:48:35', NULL, NULL, 2306, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 14:48:35', 'admin-1472185694-14721941149974728', 1, 1, 'SR', NULL, NULL, NULL),
(6393, '2016-08-26 14:48:35', NULL, NULL, 2306, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 14:48:35', 'admin-1472185694-14721941149974728', 1, 1, 'SR', NULL, NULL, NULL),
(6394, '2016-08-26 13:33:35', NULL, NULL, 2305, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 13:33:35', 'admin-1472185694-1472189615375511', 1, 0, '', NULL, NULL, NULL),
(6395, '2016-08-26 13:16:26', NULL, NULL, 2304, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 13:16:26', 'admin-1472185694-14721885867292954', 1, 1, 'SR', NULL, NULL, NULL),
(6396, '2016-08-26 13:16:26', NULL, NULL, 2304, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 13:16:26', 'admin-1472185694-14721885867292954', 1, 1, 'SR', NULL, NULL, NULL),
(6397, '2016-08-26 13:16:26', NULL, NULL, 2304, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 13:16:26', 'admin-1472185694-14721885867292954', 1, 1, 'SR', NULL, NULL, NULL),
(6398, '2016-08-26 13:15:07', NULL, NULL, 2303, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 13:15:07', 'admin-1472185694-1472188507604723', 1, 0, '', NULL, NULL, NULL),
(6399, '2016-08-26 13:15:07', NULL, NULL, 2303, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 13:15:07', 'admin-1472185694-1472188507604723', 1, 1, 'SR', NULL, NULL, NULL),
(6400, '2016-08-26 13:15:07', NULL, NULL, 2303, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 13:15:07', 'admin-1472185694-1472188507604723', 1, 0, '', NULL, NULL, NULL),
(6401, '2016-08-26 13:15:07', NULL, NULL, 2303, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 13:15:07', 'admin-1472185694-1472188507604723', 1, 1, 'SR', NULL, NULL, NULL),
(6402, '2016-08-26 13:16:26', NULL, NULL, 2304, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 13:16:26', 'admin-1472185694-14721885867292954', 1, 0, '', NULL, NULL, NULL),
(6403, '2016-08-26 13:01:00', NULL, NULL, 2299, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 13:01:00', 'admin-1472185694-14721876607072641', 1, 0, '', NULL, NULL, NULL),
(6404, '2016-08-26 13:01:00', NULL, NULL, 2299, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 13:01:00', 'admin-1472185694-14721876607072641', 1, 1, 'SR', NULL, NULL, NULL),
(6405, '2016-08-26 13:01:00', NULL, NULL, 2299, 0, 181, '116', 'Open Food ', 'Sesame Chicken', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 13:01:00', 'admin-1472185694-14721876607072641', 1, 0, '', NULL, NULL, NULL),
(6406, '2016-08-26 13:09:47', NULL, NULL, 2302, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 13:09:47', 'admin-1472185694-1472188187306137', 1, 1, 'SR', NULL, NULL, NULL),
(6407, '2016-08-26 13:04:19', NULL, NULL, 2300, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 13:04:19', 'admin-1472185694-14721878593936637', 1, 1, 'SR', NULL, NULL, NULL),
(6408, '2016-08-26 13:05:08', NULL, NULL, 2301, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 13:05:08', 'admin-1472185694-14721879082277283', 1, 1, 'SR', 1, NULL, NULL),
(6409, '2016-08-26 13:05:08', NULL, NULL, 2301, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 13:05:08', 'admin-1472185694-14721879082277283', 1, 1, 'SR', 1, NULL, NULL),
(6410, '2016-08-26 13:04:19', NULL, NULL, 2300, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 13:04:19', 'admin-1472185694-14721878593936637', 1, 0, '', NULL, NULL, NULL),
(6411, '2016-08-26 12:28:07', NULL, NULL, 2296, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 12:28:07', 'admin-1472173408-14721856873584948', 1, 0, '', NULL, NULL, NULL),
(6412, '2016-08-26 12:33:43', NULL, NULL, 2297, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 12:33:43', 'admin-1472185694-14721860230252870', 1, 1, 'SR', NULL, NULL, NULL),
(6413, '2016-08-26 12:12:30', NULL, NULL, 2295, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 12:12:30', 'admin-1472173408-1472184750551247', 1, 0, '', NULL, NULL, NULL),
(6414, '2016-08-26 12:12:20', NULL, NULL, 2295, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 12:12:20', 'admin-1472173408-1472184740825576', 1, 1, 'SR', NULL, NULL, NULL),
(6415, '2016-08-26 12:11:41', NULL, NULL, 2294, 0, 83, '83', 'Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 12:11:41', 'admin-1472173408-14721847012648787', 1, 1, 'SR', NULL, NULL, NULL),
(6416, '2016-08-26 12:10:45', NULL, NULL, 2292, 0, 156, '90', 'Cheese Omelet', ' more vege,No bread', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 12:10:45', 'admin-1472173408-14721846455402813', 1, 0, '', NULL, NULL, NULL),
(6417, '2016-08-26 12:09:07', NULL, NULL, 2292, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 12:09:07', 'admin-1472173408-1472184547273304', 1, 0, '', NULL, NULL, NULL),
(6418, '2016-08-26 12:08:12', NULL, NULL, 2291, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 12:08:12', 'admin-1472173408-14721844926198238', 1, 1, 'SR', NULL, NULL, NULL),
(6419, '2016-08-26 11:01:06', NULL, NULL, 2289, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 11:01:06', 'admin-1472173408-14721804659465486', 1, 1, 'SR', NULL, NULL, NULL),
(6420, '2016-08-26 11:01:06', NULL, NULL, 2289, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 11:01:06', 'admin-1472173408-14721804659465486', 1, 1, 'SR', NULL, NULL, NULL),
(6421, '2016-08-26 11:37:29', NULL, NULL, 2290, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 11:37:29', 'admin-1472173408-14721826492919368', 1, 0, '', NULL, NULL, NULL),
(6422, '2016-08-26 11:37:29', NULL, NULL, 2290, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 11:37:29', 'admin-1472173408-14721826492919368', 1, 0, '', NULL, NULL, NULL),
(6423, '2016-08-26 11:37:29', NULL, NULL, 2290, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 11:37:29', 'admin-1472173408-14721826492919368', 1, 1, 'SR', NULL, NULL, NULL),
(6424, '2016-08-26 11:37:48', NULL, NULL, 2290, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 11:37:48', 'admin-1472173408-14721826681065642', 1, 1, 'SR', NULL, NULL, NULL),
(6425, '2016-08-26 10:35:30', NULL, NULL, 2288, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 10:35:30', 'admin-1472173408-1472178930671659', 1, 1, 'SR', NULL, NULL, NULL),
(6426, '2016-08-26 10:35:30', NULL, NULL, 2288, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472185694', 'admin', '2016-08-26 10:35:30', 'admin-1472173408-1472178930671659', 1, 1, 'SR', NULL, NULL, NULL),
(6427, '2016-08-27 20:21:51', NULL, NULL, 2378, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 20:21:51', 'admin-1472287380-14723005114955977', 1, 1, 'SR', NULL, NULL, NULL),
(6428, '2016-08-27 20:27:01', NULL, NULL, 2379, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 20:27:01', 'admin-1472300810-14723008216005138', 1, 1, 'SR', NULL, NULL, NULL),
(6429, '2016-08-27 20:36:41', NULL, NULL, 2380, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 20:36:41', 'admin-1472300810-147230140143119', 1, 1, 'SR', NULL, NULL, NULL),
(6430, '2016-08-27 20:36:41', NULL, NULL, 2380, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 20:36:41', 'admin-1472300810-147230140143119', 1, 1, 'SR', NULL, NULL, NULL),
(6431, '2016-08-27 20:40:58', NULL, NULL, 2381, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 20:40:58', 'admin-1472300810-14723016583473633', 1, 1, 'SR', NULL, NULL, NULL),
(6432, '2016-08-27 21:48:12', NULL, NULL, 2360, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 21:48:12', 'admin-1472300810-14723056921368662', 1, 0, '', NULL, NULL, '10.0'),
(6433, '2016-08-27 20:21:51', NULL, NULL, 2378, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 20:21:51', 'admin-1472287380-14723005114955977', 1, 0, '', NULL, NULL, NULL),
(6434, '2016-08-27 20:06:30', NULL, NULL, 2377, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 20:06:30', 'admin-1472287380-1472299590055231', 1, 0, '', NULL, NULL, NULL),
(6435, '2016-08-27 20:06:30', NULL, NULL, 2377, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 20:06:30', 'admin-1472287380-1472299590055231', 1, 0, '', NULL, NULL, NULL),
(6436, '2016-08-27 16:42:45', NULL, NULL, 2368, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 16:42:45', 'admin-1472283451-14722873653605132', 1, 1, 'SR', NULL, NULL, NULL),
(6437, '2016-08-27 16:42:45', NULL, NULL, 2368, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 16:42:45', 'admin-1472283451-14722873653605132', 1, 1, 'SR', NULL, NULL, NULL),
(6438, '2016-08-27 16:44:37', NULL, NULL, 2369, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 16:44:37', 'admin-1472287380-14722874770586628', 1, 0, '', NULL, NULL, NULL),
(6439, '2016-08-27 16:44:37', NULL, NULL, 2369, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 16:44:37', 'admin-1472287380-14722874770586628', 1, 1, 'SR', NULL, NULL, NULL),
(6440, '2016-08-27 16:45:49', NULL, NULL, 2370, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 16:45:49', 'admin-1472287380-14722875491867214', 1, 0, '', NULL, NULL, NULL),
(6441, '2016-08-27 16:45:49', NULL, NULL, 2370, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 16:45:49', 'admin-1472287380-14722875491867214', 1, 1, 'SR', NULL, NULL, NULL),
(6442, '2016-08-27 16:47:32', NULL, NULL, 2372, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 16:47:32', 'admin-1472287380-14722876526722870', 1, 1, 'SR', NULL, NULL, NULL),
(6443, '2016-08-27 16:47:32', NULL, NULL, 2372, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 16:47:32', 'admin-1472287380-14722876526722870', 1, 1, 'SR', NULL, NULL, NULL),
(6444, '2016-08-27 17:09:23', NULL, NULL, 2373, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 17:09:23', 'admin-1472287380-14722889636546112', 1, 0, '', NULL, NULL, NULL),
(6445, '2016-08-27 17:09:23', NULL, NULL, 2373, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 17:09:23', 'admin-1472287380-14722889636546112', 1, 1, 'SR', NULL, NULL, NULL),
(6446, '2016-08-27 17:09:42', NULL, NULL, 2373, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 17:09:42', 'admin-1472287380-14722889819164793', 1, 1, 'SR', NULL, NULL, NULL),
(6447, '2016-08-27 17:35:56', NULL, NULL, 2374, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 17:35:56', 'admin-1472287380-14722905564094783', 1, 1, 'SR', NULL, NULL, NULL),
(6448, '2016-08-27 19:54:31', NULL, NULL, 2375, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 19:54:31', 'admin-1472287380-14722988714767891', 1, 0, '', NULL, NULL, NULL),
(6449, '2016-08-27 19:54:31', NULL, NULL, 2375, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 19:54:31', 'admin-1472287380-14722988714767891', 1, 0, '', NULL, NULL, NULL),
(6450, '2016-08-27 19:54:31', NULL, NULL, 2375, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 19:54:31', 'admin-1472287380-14722988714767891', 1, 1, 'SR', NULL, NULL, NULL),
(6451, '2016-08-27 20:00:03', NULL, NULL, 2377, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 20:00:03', 'admin-1472287380-14722992035226892', 1, 1, 'SR', NULL, NULL, NULL),
(6452, '2016-08-27 20:00:03', NULL, NULL, 2377, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 20:00:03', 'admin-1472287380-14722992035226892', 1, 0, '', NULL, NULL, NULL),
(6453, '2016-08-27 19:56:25', NULL, NULL, 2376, 0, 76, '76', 'Pesto Pasta', 'Bacon', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 19:56:25', 'admin-1472287380-14722989854182076', 1, 1, 'SR', NULL, NULL, NULL),
(6454, '2016-08-27 16:42:45', NULL, NULL, 2368, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 16:42:45', 'admin-1472283451-14722873653605132', 1, 0, '', NULL, NULL, NULL),
(6455, '2016-08-27 16:42:45', NULL, NULL, 2368, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 16:42:45', 'admin-1472283451-14722873653605132', 1, 0, '', NULL, NULL, NULL),
(6456, '2016-08-27 16:42:45', NULL, NULL, 2368, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 16:42:45', 'admin-1472283451-14722873653605132', 1, 1, 'SR', NULL, NULL, NULL),
(6457, '2016-08-27 16:28:32', NULL, NULL, 2367, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 16:28:32', 'admin-1472283451-14722865122994790', 1, 1, 'SR', NULL, NULL, NULL),
(6458, '2016-08-27 16:09:17', NULL, NULL, 2366, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 16:09:17', 'admin-1472283451-14722853577026597', 1, 1, 'SR', NULL, NULL, NULL),
(6459, '2016-08-27 16:09:17', NULL, NULL, 2366, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 16:09:17', 'admin-1472283451-14722853577026597', 1, 1, 'SR', NULL, NULL, NULL),
(6460, '2016-08-27 16:09:17', NULL, NULL, 2366, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 16:09:17', 'admin-1472283451-14722853577026597', 1, 1, 'SR', NULL, NULL, NULL),
(6461, '2016-08-27 15:49:18', NULL, NULL, 2362, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:49:18', 'admin-1472283451-14722841579989378', 1, 1, 'SR', NULL, NULL, NULL),
(6462, '2016-08-27 16:05:06', NULL, NULL, 2365, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 16:05:06', 'admin-1472283451-14722851062051290', 1, 0, '', NULL, NULL, NULL),
(6463, '2016-08-27 16:09:17', NULL, NULL, 2366, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 16:09:17', 'admin-1472283451-14722853577026597', 1, 0, '', NULL, NULL, NULL),
(6464, '2016-08-27 15:49:18', NULL, NULL, 2362, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:49:18', 'admin-1472283451-14722841579989378', 1, 1, 'SR', NULL, NULL, NULL),
(6465, '2016-08-27 15:52:05', NULL, NULL, 2363, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:52:05', 'admin-1472283451-14722843252655848', 1, 1, 'SR', NULL, NULL, NULL),
(6466, '2016-08-27 15:52:05', NULL, NULL, 2363, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:52:05', 'admin-1472283451-14722843252655848', 1, 0, '', NULL, NULL, NULL),
(6467, '2016-08-27 15:52:05', NULL, NULL, 2363, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:52:05', 'admin-1472283451-14722843252655848', 1, 0, '', NULL, NULL, NULL),
(6468, '2016-08-27 14:21:21', NULL, NULL, 2353, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 14:21:21', 'admin-1472274868-14722788812046349', 1, 1, 'SR', NULL, NULL, NULL),
(6469, '2016-08-27 15:56:47', NULL, NULL, 2364, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:56:47', 'admin-1472283451-14722846070906715', 1, 1, 'SR', NULL, NULL, NULL),
(6470, '2016-08-27 15:57:14', NULL, NULL, 2364, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:57:14', 'admin-1472283451-14722846347242195', 1, 0, '', NULL, NULL, NULL),
(6471, '2016-08-27 16:05:06', NULL, NULL, 2365, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 16:05:06', 'admin-1472283451-14722851062051290', 1, 1, 'SR', NULL, NULL, NULL),
(6472, '2016-08-27 15:57:14', NULL, NULL, 2364, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:57:14', 'admin-1472283451-14722846347242195', 1, 1, 'SR', NULL, NULL, NULL),
(6473, '2016-08-27 15:11:33', NULL, NULL, 2357, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:11:33', 'admin-1472281391-14722818932822130', 1, 1, 'SR', NULL, NULL, NULL),
(6474, '2016-08-27 14:21:21', NULL, NULL, 2353, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 14:21:21', 'admin-1472274868-14722788812046349', 1, 1, 'SR', NULL, NULL, NULL),
(6475, '2016-08-27 14:21:21', NULL, NULL, 2353, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 14:21:21', 'admin-1472274868-14722788812046349', 1, 1, 'SR', NULL, NULL, NULL),
(6476, '2016-08-27 14:14:34', NULL, NULL, 2352, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 14:14:34', 'admin-1472274868-14722784738459527', 1, 1, 'SR', NULL, NULL, NULL),
(6477, '2016-08-27 14:14:34', NULL, NULL, 2352, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 14:14:34', 'admin-1472274868-14722784738459527', 1, 1, 'SR', NULL, NULL, NULL),
(6478, '2016-08-27 14:13:57', NULL, NULL, 2352, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 14:13:57', 'admin-1472274868-14722784371804643', 1, 0, '', NULL, NULL, NULL),
(6479, '2016-08-27 14:13:57', NULL, NULL, 2352, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 14:13:57', 'admin-1472274868-14722784371804643', 1, 1, 'SR', NULL, NULL, NULL),
(6480, '2016-08-27 14:13:57', NULL, NULL, 2352, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 14:13:57', 'admin-1472274868-14722784371804643', 1, 0, '', NULL, NULL, NULL),
(6481, '2016-08-27 14:13:57', NULL, NULL, 2352, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 14:13:57', 'admin-1472274868-14722784371804643', 1, 0, '', NULL, NULL, NULL),
(6482, '2016-08-27 14:13:57', NULL, NULL, 2352, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 14:13:57', 'admin-1472274868-14722784371804643', 1, 1, 'SR', NULL, NULL, NULL),
(6483, '2016-08-27 14:13:57', NULL, NULL, 2352, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 14:13:57', 'admin-1472274868-14722784371804643', 1, 0, '', NULL, NULL, NULL),
(6484, '2016-08-27 14:12:13', NULL, NULL, 2352, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 14:12:13', 'admin-1472274868-14722783333742179', 1, 0, '', NULL, NULL, NULL),
(6485, '2016-08-27 13:56:48', NULL, NULL, 2351, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 13:56:48', 'admin-1472274868-14722774079359716', 1, 1, 'SR', NULL, NULL, NULL),
(6486, '2016-08-27 13:56:48', NULL, NULL, 2351, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 13:56:48', 'admin-1472274868-14722774079359716', 1, 1, 'SR', NULL, NULL, NULL),
(6487, '2016-08-27 13:15:48', NULL, NULL, 2348, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 13:15:48', 'admin-1472274868-14722749481516521', 1, 0, '', NULL, NULL, NULL),
(6488, '2016-08-27 13:48:26', NULL, NULL, 2348, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 13:48:26', 'admin-1472274868-14722769059508183', 1, 1, 'SR', NULL, NULL, NULL),
(6489, '2016-08-27 13:18:03', NULL, NULL, 2348, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 13:18:03', 'admin-1472274868-14722750837547717', 1, 1, 'SR', NULL, NULL, NULL),
(6490, '2016-08-27 13:18:03', NULL, NULL, 2348, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 13:18:03', 'admin-1472274868-14722750837547717', 1, 1, 'SR', NULL, NULL, NULL),
(6491, '2016-08-27 13:18:03', NULL, NULL, 2348, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 13:18:03', 'admin-1472274868-14722750837547717', 1, 1, 'SR', NULL, NULL, NULL),
(6492, '2016-08-27 13:40:45', NULL, NULL, 2349, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 13:40:45', 'admin-1472274868-14722764451869310', 1, 1, 'SR', NULL, NULL, NULL),
(6493, '2016-08-27 13:49:31', NULL, NULL, 2350, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 13:49:31', 'admin-1472274868-14722769716896047', 1, 1, 'SR', NULL, NULL, NULL),
(6494, '2016-08-27 13:49:31', NULL, NULL, 2350, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 13:49:31', 'admin-1472274868-14722769716896047', 1, 1, 'SR', NULL, NULL, NULL),
(6495, '2016-08-27 13:49:31', NULL, NULL, 2350, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 13:49:31', 'admin-1472274868-14722769716896047', 1, 0, '', NULL, NULL, NULL),
(6496, '2016-08-27 13:49:31', NULL, NULL, 2350, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 13:49:31', 'admin-1472274868-14722769716896047', 1, 0, '', NULL, NULL, NULL),
(6497, '2016-08-27 13:56:48', NULL, NULL, 2351, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 13:56:48', 'admin-1472274868-14722774079359716', 1, 0, '', NULL, NULL, NULL),
(6498, '2016-08-27 14:21:21', NULL, NULL, 2353, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 14:21:21', 'admin-1472274868-14722788812046349', 1, 1, 'SR', NULL, NULL, NULL),
(6499, '2016-08-27 16:05:06', NULL, NULL, 2365, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 16:05:06', 'admin-1472283451-14722851062051290', 1, 1, 'SR', NULL, NULL, NULL),
(6500, '2016-08-27 15:49:18', NULL, NULL, 2362, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:49:18', 'admin-1472283451-14722841579989378', 1, 1, 'SR', NULL, NULL, NULL),
(6501, '2016-08-27 15:49:18', NULL, NULL, 2362, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:49:18', 'admin-1472283451-14722841579989378', 1, 1, 'SR', NULL, NULL, NULL),
(6502, '2016-08-27 15:37:48', NULL, NULL, 2361, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:37:48', 'admin-1472283451-14722834682397034', 1, 1, 'SR', NULL, NULL, NULL),
(6503, '2016-08-27 15:26:59', NULL, NULL, 2358, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:26:59', 'admin-1472281391-1472282819565278', 1, 0, '', NULL, NULL, NULL),
(6504, '2016-08-27 15:36:09', NULL, NULL, 2359, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:36:09', 'admin-1472281391-1472283369361155', 1, 1, 'SR', NULL, NULL, NULL),
(6505, '2016-08-27 15:36:09', NULL, NULL, 2359, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:36:09', 'admin-1472281391-1472283369361155', 1, 1, 'SR', NULL, NULL, NULL),
(6506, '2016-08-27 15:36:30', NULL, NULL, 2360, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:36:30', 'admin-1472281391-14722833903932585', 1, 1, 'SR', NULL, NULL, '10.0'),
(6507, '2016-08-27 15:37:48', NULL, NULL, 2361, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:37:48', 'admin-1472283451-14722834682397034', 1, 0, '', NULL, NULL, NULL),
(6508, '2016-08-27 20:39:41', NULL, NULL, 2360, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 20:39:41', 'admin-1472300810-14723015816661520', 1, 1, 'SR', NULL, NULL, '10.0'),
(6509, '2016-08-27 15:37:48', NULL, NULL, 2361, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:37:48', 'admin-1472283451-14722834682397034', 1, 1, 'SR', NULL, NULL, NULL),
(6510, '2016-08-27 15:11:33', NULL, NULL, 2357, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:11:33', 'admin-1472281391-14722818932822130', 1, 1, 'SR', NULL, NULL, NULL),
(6511, '2016-08-27 15:11:33', NULL, NULL, 2357, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:11:33', 'admin-1472281391-14722818932822130', 1, 1, 'SR', NULL, NULL, NULL),
(6512, '2016-08-27 15:11:33', NULL, NULL, 2357, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:11:33', 'admin-1472281391-14722818932822130', 1, 0, '', NULL, NULL, NULL),
(6513, '2016-08-27 15:02:52', NULL, NULL, 2356, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:02:52', 'admin-1472279241-14722813724145339', 1, 1, 'SR', NULL, NULL, NULL),
(6514, '2016-08-27 14:27:13', NULL, NULL, 2355, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 14:27:13', 'admin-1472274868-14722792338273362', 1, 1, 'SR', NULL, NULL, NULL),
(6515, '2016-08-27 14:21:48', NULL, NULL, 2354, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 14:21:48', 'admin-1472274868-14722789080062741', 1, 0, '', NULL, NULL, NULL),
(6516, '2016-08-27 14:29:16', NULL, NULL, 2355, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 14:29:16', 'admin-1472279241-14722793559895997', 1, 1, 'SR', NULL, NULL, NULL),
(6517, '2016-08-27 14:29:16', NULL, NULL, 2355, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 14:29:16', 'admin-1472279241-14722793559895997', 1, 1, 'SR', NULL, NULL, NULL),
(6518, '2016-08-27 14:21:21', NULL, NULL, 2353, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 14:21:21', 'admin-1472274868-14722788812046349', 1, 0, '', NULL, NULL, NULL),
(6519, '2016-08-27 15:52:05', NULL, NULL, 2363, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 15:52:05', 'admin-1472283451-14722843252655848', 1, 0, '', NULL, NULL, NULL),
(6520, '2016-08-27 13:15:48', NULL, NULL, 2348, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 13:15:48', 'admin-1472274868-14722749481516521', 1, 0, '', NULL, NULL, NULL),
(6521, '2016-08-27 13:15:48', NULL, NULL, 2348, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 13:15:48', 'admin-1472274868-14722749481516521', 1, 1, 'SR', NULL, NULL, NULL),
(6522, '2016-08-27 13:15:48', NULL, NULL, 2348, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 13:15:48', 'admin-1472274868-14722749481516521', 1, 0, '', NULL, NULL, NULL),
(6523, '2016-08-27 13:01:40', NULL, NULL, 2347, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 13:01:40', 'admin-1472271633-14722741002208610', 1, 1, 'SR', NULL, NULL, NULL),
(6524, '2016-08-27 13:01:40', NULL, NULL, 2347, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 13:01:40', 'admin-1472271633-14722741002208610', 1, 1, 'SR', NULL, NULL, NULL),
(6525, '2016-08-27 12:28:38', NULL, NULL, 2345, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 12:28:38', 'admin-1472271633-14722721181765436', 1, 1, 'SR', NULL, NULL, NULL),
(6526, '2016-08-27 12:28:38', NULL, NULL, 2345, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 12:28:38', 'admin-1472271633-14722721181765436', 1, 0, '', NULL, NULL, NULL),
(6527, '2016-08-27 12:21:13', NULL, NULL, 2344, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 12:21:13', 'admin-1472271633-14722716732039525', 1, 0, '', NULL, NULL, NULL),
(6528, '2016-08-27 12:21:13', NULL, NULL, 2344, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 12:21:13', 'admin-1472271633-14722716732039525', 1, 1, 'SR', NULL, NULL, NULL),
(6529, '2016-08-27 13:15:48', NULL, NULL, 2348, 0, 193, '128', 'Braised Pork with Potato', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 13:15:48', 'admin-1472274868-14722749481516521', 1, 0, '', NULL, NULL, NULL),
(6530, '2016-08-27 12:28:38', NULL, NULL, 2345, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 12:28:38', 'admin-1472271633-14722721181765436', 1, 1, 'SR', NULL, NULL, NULL),
(6531, '2016-08-27 12:28:38', NULL, NULL, 2345, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 12:28:38', 'admin-1472271633-14722721181765436', 1, 1, 'SR', NULL, NULL, NULL),
(6532, '2016-08-27 12:28:38', NULL, NULL, 2345, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'admin', '2016-08-27 12:28:38', 'admin-1472271633-14722721181765436', 1, 1, 'SR', NULL, NULL, NULL),
(6533, '2016-08-27 12:18:50', NULL, NULL, 2343, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 12:18:50', 'lois-1472258939-14722715298238666', 1, 0, '', NULL, NULL, NULL),
(6534, '2016-08-27 12:19:34', NULL, NULL, 2344, 0, 153, '87', 'Big Breakfast ', 'all saussages', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 12:19:34', 'lois-1472258939-14722715745435961', 1, 0, '', NULL, NULL, NULL),
(6535, '2016-08-27 12:19:34', NULL, NULL, 2344, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 12:19:34', 'lois-1472258939-14722715745435961', 1, 0, '', NULL, NULL, NULL),
(6536, '2016-08-27 12:20:04', NULL, NULL, 2344, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 12:20:04', 'lois-1472258939-14722716045767540', 1, 0, '', NULL, NULL, NULL),
(6537, '2016-08-27 11:24:55', NULL, NULL, 2332, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 11:24:55', 'lois-1472258939-14722682953572045', 1, 0, '', NULL, NULL, NULL),
(6538, '2016-08-27 12:09:09', NULL, NULL, 2338, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 12:09:09', 'lois-1472258939-14722709493688646', 1, 1, 'SR', NULL, NULL, NULL),
(6539, '2016-08-27 00:00:00', NULL, NULL, 2340, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 12:01:14', 'lois-1472258939-14722704745982077', 1, 1, 'SR', NULL, NULL, NULL),
(6540, '2016-08-27 00:00:00', NULL, NULL, 2340, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 12:01:14', 'lois-1472258939-14722704745982077', 1, 0, '', NULL, NULL, NULL),
(6541, '2016-08-27 12:03:49', NULL, NULL, 2342, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 12:03:49', 'lois-1472258939-14722706287995817', 1, 1, 'SR', NULL, NULL, NULL),
(6542, '2016-08-27 12:03:49', NULL, NULL, 2342, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 12:03:49', 'lois-1472258939-14722706287995817', 1, 1, 'SR', NULL, NULL, NULL),
(6543, '2016-08-27 12:09:09', NULL, NULL, 2338, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 12:09:09', 'lois-1472258939-14722709493688646', 1, 1, 'SR', NULL, NULL, NULL),
(6544, '2016-08-27 00:00:00', NULL, NULL, 2341, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 12:01:14', 'lois-1472258939-14722704745982077', 1, 1, 'SR', NULL, NULL, NULL),
(6545, '2016-08-27 12:01:14', NULL, NULL, 2339, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 12:01:14', 'lois-1472258939-14722704745982077', 1, 0, '', NULL, NULL, NULL),
(6546, '2016-08-27 00:00:00', NULL, NULL, 2341, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 12:00:05', 'lois-1472258939-14722704056529852', 1, 0, '', NULL, NULL, NULL),
(6547, '2016-08-27 12:01:14', NULL, NULL, 2339, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 12:01:14', 'lois-1472258939-14722704745982077', 1, 1, 'SR', NULL, NULL, NULL),
(6548, '2016-08-27 12:03:49', NULL, NULL, 2342, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 12:03:49', 'lois-1472258939-14722706287995817', 1, 0, '', NULL, NULL, NULL),
(6549, '2016-08-27 11:59:41', NULL, NULL, 2339, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 11:59:41', 'lois-1472258939-14722703817804230', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(6550, '2016-08-27 00:00:00', NULL, NULL, 2341, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 11:59:41', 'lois-1472258939-14722703817804230', 1, 0, '', NULL, NULL, NULL),
(6551, '2016-08-27 11:26:11', NULL, NULL, 2333, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 11:26:11', 'lois-1472258939-14722683707629847', 1, 0, '', NULL, NULL, NULL),
(6552, '2016-08-27 11:27:11', NULL, NULL, 2334, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 11:27:11', 'lois-1472258939-14722684313244972', 1, 1, 'SR', 1, NULL, NULL),
(6553, '2016-08-27 11:27:11', NULL, NULL, 2334, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 11:27:11', 'lois-1472258939-14722684313244972', 1, 1, 'SR', 1, NULL, NULL),
(6554, '2016-08-27 11:30:29', NULL, NULL, 2335, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 11:30:29', 'lois-1472258939-14722686288782599', 1, 1, 'SR', NULL, NULL, NULL),
(6555, '2016-08-27 11:30:29', NULL, NULL, 2335, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 11:30:29', 'lois-1472258939-14722686288782599', 1, 1, 'SR', NULL, NULL, NULL),
(6556, '2016-08-27 11:35:41', NULL, NULL, 2336, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 11:35:41', 'lois-1472258939-14722689415793044', 1, 1, 'SR', 1, NULL, NULL),
(6557, '2016-08-27 11:46:31', NULL, NULL, 2337, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 11:46:31', 'lois-1472258939-14722695909104428', 1, 1, 'SR', 1, NULL, NULL),
(6558, '2016-08-27 11:46:31', NULL, NULL, 2337, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 11:46:31', 'lois-1472258939-14722695909104428', 1, 0, '', 1, NULL, NULL),
(6559, '2016-08-27 11:24:55', NULL, NULL, 2332, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 11:24:55', 'lois-1472258939-14722682953572045', 1, 1, 'SR', NULL, NULL, NULL),
(6560, '2016-08-27 11:26:10', NULL, NULL, 2333, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 11:26:10', 'lois-1472258939-14722683707629847', 1, 0, '', NULL, NULL, NULL),
(6561, '2016-08-27 11:26:10', NULL, NULL, 2333, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 11:26:10', 'lois-1472258939-14722683707629847', 1, 1, 'SR', NULL, NULL, NULL),
(6562, '2016-08-27 11:26:10', NULL, NULL, 2333, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 11:26:11', 'lois-1472258939-14722683707629847', 1, 1, 'SR', NULL, NULL, NULL),
(6563, '2016-08-27 11:26:11', NULL, NULL, 2333, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 11:26:11', 'lois-1472258939-14722683707629847', 1, 1, 'SR', NULL, NULL, NULL),
(6564, '2016-08-27 11:02:49', NULL, NULL, 2331, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 11:02:49', 'lois-1472258939-14722669693055916', 1, 0, '', NULL, NULL, NULL),
(6565, '2016-08-27 11:02:49', NULL, NULL, 2331, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 11:02:49', 'lois-1472258939-14722669693055916', 1, 1, 'SR', NULL, NULL, NULL),
(6566, '2016-08-27 11:02:49', NULL, NULL, 2331, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 11:02:49', 'lois-1472258939-14722669693055916', 1, 0, '', NULL, NULL, NULL),
(6567, '2016-08-27 10:50:57', NULL, NULL, 2330, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 10:50:57', 'lois-1472258939-14722662568549397', 1, 0, '', NULL, NULL, NULL),
(6568, '2016-08-27 10:47:22', NULL, NULL, 2329, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 10:47:22', 'lois-1472258939-14722660424647916', 1, 0, '', NULL, NULL, NULL),
(6569, '2016-08-27 10:47:01', NULL, NULL, 2328, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 10:47:01', 'lois-1472258939-14722660211255148', 1, 1, 'SR', NULL, NULL, NULL),
(6570, '2016-08-27 10:46:14', NULL, NULL, 2327, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 10:46:14', 'lois-1472258939-14722659738831517', 1, 1, 'SR', NULL, NULL, NULL),
(6571, '2016-08-27 10:45:13', NULL, NULL, 2326, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 10:45:13', 'lois-1472258939-1472265913781672', 1, 1, 'SR', NULL, NULL, NULL),
(6572, '2016-08-27 10:07:09', NULL, NULL, 2324, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 10:07:09', 'lois-1472258939-14722636292745526', 1, 1, 'SR', NULL, NULL, '10.0'),
(6573, '2016-08-27 10:06:45', NULL, NULL, 2324, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 10:06:45', 'lois-1472258939-14722636048361164', 1, 0, '', NULL, NULL, '10.0'),
(6574, '2016-08-27 10:06:45', NULL, NULL, 2324, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 10:06:45', 'lois-1472258939-14722636048361164', 1, 0, '', NULL, NULL, '10.0'),
(6575, '2016-08-27 10:46:14', NULL, NULL, 2327, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 10:46:14', 'lois-1472258939-14722659738831517', 1, 1, 'SR', NULL, NULL, NULL),
(6576, '2016-08-27 10:46:14', NULL, NULL, 2327, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 10:46:14', 'lois-1472258939-14722659738831517', 1, 0, '', NULL, NULL, NULL),
(6577, '2016-08-27 10:46:14', NULL, NULL, 2327, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 10:46:14', 'lois-1472258939-14722659738831517', 1, 0, '', NULL, NULL, NULL),
(6578, '2016-08-27 10:44:50', NULL, NULL, 2326, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 10:44:50', 'lois-1472258939-14722658903881943', 1, 0, '', NULL, NULL, NULL),
(6579, '2016-08-27 10:20:06', NULL, NULL, 2325, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472300810', 'lois', '2016-08-27 10:20:06', 'lois-1472258939-1472264406560254', 1, 1, 'SR', NULL, NULL, NULL),
(6580, '2016-08-28 21:01:52', NULL, NULL, 2453, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 21:01:52', 'admin-1472382011-14723893118543512', 1, 0, '', NULL, NULL, NULL),
(6581, '2016-08-28 21:01:52', NULL, NULL, 2453, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 21:01:52', 'admin-1472382011-14723893118543512', 1, 1, 'SR', NULL, NULL, NULL),
(6582, '2016-08-28 19:07:46', NULL, NULL, 2452, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 19:07:46', 'admin-1472382011-1472382466470166', 1, 1, 'SR', NULL, NULL, NULL),
(6583, '2016-08-28 19:07:46', NULL, NULL, 2452, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 19:07:46', 'admin-1472382011-1472382466470166', 1, 1, 'SR', NULL, NULL, NULL),
(6584, '2016-08-28 19:02:40', NULL, NULL, 2451, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 19:02:40', 'admin-1472382011-14723821600339495', 1, 0, '', NULL, NULL, NULL),
(6585, '2016-08-28 19:02:40', NULL, NULL, 2451, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 19:02:40', 'admin-1472382011-14723821600339495', 1, 0, '', NULL, NULL, NULL),
(6586, '2016-08-28 19:02:32', NULL, NULL, 2451, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 19:02:32', 'admin-1472382011-14723821524525634', 1, 0, '', NULL, NULL, NULL),
(6587, '2016-08-28 19:00:45', NULL, NULL, 2449, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 19:00:45', 'admin-1472382011-1472382044828286', 1, 0, '', NULL, NULL, NULL),
(6588, '2016-08-28 19:01:27', NULL, NULL, 2450, 0, 181, '116', 'Open Food ', 'black', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 19:01:27', 'admin-1472382011-14723820872005018', 1, 0, '', NULL, NULL, NULL),
(6589, '2016-08-28 19:01:27', NULL, NULL, 2450, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 19:01:27', 'admin-1472382011-14723820872005018', 1, 1, 'SR', NULL, NULL, NULL),
(6590, '2016-08-28 19:02:32', NULL, NULL, 2451, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 19:02:32', 'admin-1472382011-14723821524525634', 1, 0, '', NULL, NULL, NULL),
(6591, '2016-08-28 18:59:04', NULL, NULL, 2449, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:59:04', 'admin-1472360478-14723819446643924', 1, 0, '', NULL, NULL, NULL),
(6592, '2016-08-28 18:57:57', NULL, NULL, 2447, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:57:57', 'admin-1472360478-14723818768245220', 1, 0, '', NULL, NULL, NULL),
(6593, '2016-08-28 18:42:08', NULL, NULL, 2444, 0, 181, '116', 'Open Food ', 'Vege', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:42:08', 'admin-1472360478-14723809286985043', 1, 0, '', NULL, NULL, NULL),
(6594, '2016-08-28 18:37:34', NULL, NULL, 2447, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:37:34', 'admin-1472360478-14723806543436739', 1, 0, '', NULL, NULL, NULL),
(6595, '2016-08-28 18:31:53', NULL, NULL, 2448, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:31:53', 'admin-1472360478-14723803132313981', 1, 1, 'SR', NULL, NULL, NULL),
(6596, '2016-08-28 18:19:36', NULL, NULL, 2447, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:19:36', 'admin-1472360478-14723795761808948', 1, 1, 'SR', NULL, NULL, NULL),
(6597, '2016-08-28 18:19:36', NULL, NULL, 2447, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:19:36', 'admin-1472360478-14723795761808948', 1, 0, '', NULL, NULL, NULL),
(6598, '2016-08-28 18:38:40', NULL, NULL, 2447, 0, 198, '133', 'Dinner - Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:38:40', 'admin-1472360478-1472380720130474', 1, 0, '', NULL, NULL, NULL),
(6599, '2016-08-28 18:16:52', NULL, NULL, 2446, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:16:52', 'admin-1472360478-14723794126526021', 1, 1, 'SR', NULL, NULL, NULL),
(6600, '2016-08-28 18:16:24', NULL, NULL, 2445, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:16:24', 'admin-1472360478-14723793846487693', 1, 1, 'SR', NULL, NULL, NULL),
(6601, '2016-08-28 18:16:24', NULL, NULL, 2445, 0, 80, '80', 'Summer Salad With Chicken ', 'bacon', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:16:24', 'admin-1472360478-14723793846487693', 1, 1, 'SR', NULL, NULL, NULL),
(6602, '2016-08-28 18:12:42', NULL, NULL, 2444, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:12:42', 'admin-1472360478-14723791621688074', 1, 0, '', NULL, NULL, NULL),
(6603, '2016-08-28 18:12:42', NULL, NULL, 2444, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:12:42', 'admin-1472360478-14723791621688074', 1, 0, '', NULL, NULL, NULL),
(6604, '2016-08-28 18:12:42', NULL, NULL, 2444, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:12:42', 'admin-1472360478-14723791621688074', 1, 0, '', NULL, NULL, NULL),
(6605, '2016-08-28 18:12:42', NULL, NULL, 2444, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:12:42', 'admin-1472360478-14723791621688074', 1, 0, '', NULL, NULL, NULL),
(6606, '2016-08-28 18:12:42', NULL, NULL, 2444, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:12:42', 'admin-1472360478-14723791621688074', 1, 0, '', NULL, NULL, NULL),
(6607, '2016-08-28 18:11:35', NULL, NULL, 2444, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:11:35', 'admin-1472360478-14723790947974720', 1, 1, 'SR', NULL, NULL, NULL),
(6608, '2016-08-28 18:12:42', NULL, NULL, 2444, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:12:42', 'admin-1472360478-14723791621688074', 1, 0, '', NULL, NULL, NULL),
(6609, '2016-08-28 18:12:42', NULL, NULL, 2444, 0, 201, '136', 'Dinner -  Chili Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:12:42', 'admin-1472360478-14723791621688074', 1, 0, '', NULL, NULL, NULL),
(6610, '2016-08-28 18:12:42', NULL, NULL, 2444, 0, 199, '134', 'Dinner - Marmite Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:12:42', 'admin-1472360478-14723791621688074', 1, 0, '', NULL, NULL, NULL),
(6611, '2016-08-28 18:12:42', NULL, NULL, 2444, 0, 198, '133', 'Dinner - Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:12:42', 'admin-1472360478-14723791621688074', 1, 0, '', NULL, NULL, NULL),
(6612, '2016-08-28 18:12:42', NULL, NULL, 2444, 0, 197, '132', 'Dinner - Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:12:42', 'admin-1472360478-14723791621688074', 1, 0, '', NULL, NULL, NULL),
(6613, '2016-08-28 18:12:42', NULL, NULL, 2444, 0, 181, '116', 'Open Food ', 'lemony chicken', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:12:42', 'admin-1472360478-14723791621688074', 1, 0, '', NULL, NULL, NULL),
(6614, '2016-08-28 18:12:42', NULL, NULL, 2444, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:12:42', 'admin-1472360478-14723791621688074', 1, 0, '', NULL, NULL, NULL),
(6615, '2016-08-28 18:12:42', NULL, NULL, 2444, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:12:42', 'admin-1472360478-14723791621688074', 1, 0, '', NULL, NULL, NULL),
(6616, '2016-08-28 18:12:42', NULL, NULL, 2444, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:12:42', 'admin-1472360478-14723791621688074', 1, 0, '', NULL, NULL, NULL),
(6617, '2016-08-28 18:12:42', NULL, NULL, 2444, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:12:42', 'admin-1472360478-14723791621688074', 1, 0, '', NULL, NULL, NULL),
(6618, '2016-08-28 18:12:42', NULL, NULL, 2444, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:12:42', 'admin-1472360478-14723791621688074', 1, 0, '', NULL, NULL, NULL),
(6619, '2016-08-28 16:26:07', NULL, NULL, 2438, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 16:26:07', 'admin-1472360478-14723727676932891', 1, 0, '', NULL, NULL, NULL),
(6620, '2016-08-28 16:26:07', NULL, NULL, 2438, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 16:26:07', 'admin-1472360478-14723727676932891', 1, 1, 'SR', NULL, NULL, NULL),
(6621, '2016-08-28 16:15:12', NULL, NULL, 2437, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 16:15:12', 'admin-1472360478-14723721118442630', 1, 1, 'SR', NULL, NULL, NULL),
(6622, '2016-08-28 16:15:02', NULL, NULL, 2437, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 16:15:02', 'admin-1472360478-14723721027909423', 1, 0, '', NULL, NULL, NULL),
(6623, '2016-08-28 00:00:00', NULL, NULL, 2435, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 16:12:05', 'admin-1472360478-14723719250115698', 1, 1, 'SR', NULL, NULL, NULL),
(6624, '2016-08-28 16:14:47', NULL, NULL, 2436, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 16:14:47', 'admin-1472360478-14723720877995011', 1, 1, 'SR', NULL, NULL, NULL),
(6625, '2016-08-28 00:00:00', NULL, NULL, 2435, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 16:12:05', 'admin-1472360478-14723719250115698', 1, 0, '', NULL, NULL, NULL),
(6626, '2016-08-28 16:12:05', NULL, NULL, 2434, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 16:12:05', 'admin-1472360478-14723719250115698', 1, 0, '', NULL, NULL, NULL),
(6627, '2016-08-28 15:46:28', NULL, NULL, 2433, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 15:46:28', 'admin-1472360478-1472370388619215', 1, 1, 'SR', NULL, NULL, NULL),
(6628, '2016-08-28 15:46:28', NULL, NULL, 2433, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 15:46:28', 'admin-1472360478-1472370388619215', 1, 0, '', NULL, NULL, NULL),
(6629, '2016-08-28 15:43:14', NULL, NULL, 2433, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 15:43:14', 'admin-1472360478-14723701938891872', 1, 1, 'SR', NULL, NULL, NULL),
(6630, '2016-08-28 14:55:08', NULL, NULL, 2431, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 14:55:08', 'admin-1472360478-14723673077804123', 1, 0, '', NULL, NULL, NULL),
(6631, '2016-08-28 15:14:45', NULL, NULL, 2432, 0, 79, '79', 'Summer Salad ', 'bacon', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 15:14:45', 'admin-1472360478-1472368484894562', 1, 1, 'SR', NULL, NULL, NULL),
(6632, '2016-08-28 15:14:45', NULL, NULL, 2432, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 15:14:45', 'admin-1472360478-1472368484894562', 1, 0, '', NULL, NULL, NULL),
(6633, '2016-08-28 15:14:45', NULL, NULL, 2432, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 15:14:45', 'admin-1472360478-1472368484894562', 1, 0, '', NULL, NULL, NULL),
(6634, '2016-08-28 15:14:45', NULL, NULL, 2432, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 15:14:45', 'admin-1472360478-1472368484894562', 1, 1, 'SR', NULL, NULL, NULL),
(6635, '2016-08-28 15:14:45', NULL, NULL, 2432, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 15:14:45', 'admin-1472360478-1472368484894562', 1, 1, 'SR', NULL, NULL, NULL),
(6636, '2016-08-28 12:30:35', NULL, NULL, 2412, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:30:35', 'admin-1472357188-14723586354546877', 1, 0, '', NULL, NULL, NULL),
(6637, '2016-08-28 12:33:24', NULL, NULL, 2413, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:33:24', 'admin-1472357188-14723588039899710', 1, 1, 'SR', NULL, NULL, NULL),
(6638, '2016-08-28 12:39:37', NULL, NULL, 2414, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:39:37', 'admin-1472357188-1472359177654712', 1, 0, '', NULL, NULL, NULL),
(6639, '2016-08-28 12:40:46', NULL, NULL, 2415, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:40:46', 'admin-1472357188-14723592466727730', 1, 0, '', NULL, NULL, NULL),
(6640, '2016-08-28 12:40:46', NULL, NULL, 2415, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:40:46', 'admin-1472357188-14723592466727730', 1, 1, 'SR', NULL, NULL, NULL),
(6641, '2016-08-28 12:49:46', NULL, NULL, 2416, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:49:46', 'admin-1472357188-14723597863778968', 1, 0, '', NULL, NULL, NULL),
(6642, '2016-08-28 12:49:46', NULL, NULL, 2416, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:49:46', 'admin-1472357188-14723597863778968', 1, 0, '', NULL, NULL, NULL),
(6643, '2016-08-28 12:49:46', NULL, NULL, 2416, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:49:46', 'admin-1472357188-14723597863778968', 1, 1, 'SR', NULL, NULL, NULL),
(6644, '2016-08-28 12:52:46', NULL, NULL, 2417, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:52:46', 'admin-1472357188-14723599668223571', 1, 1, 'SR', NULL, NULL, NULL),
(6645, '2016-08-28 12:52:47', NULL, NULL, 2417, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:52:47', 'admin-1472357188-14723599668223571', 1, 1, 'SR', NULL, NULL, NULL),
(6646, '2016-08-28 12:55:55', NULL, NULL, 2418, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:55:55', 'admin-1472357188-1472360154879284', 1, 0, '', NULL, NULL, NULL),
(6647, '2016-08-28 12:55:55', NULL, NULL, 2418, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:55:55', 'admin-1472357188-1472360154879284', 1, 0, '', NULL, NULL, NULL),
(6648, '2016-08-28 12:55:55', NULL, NULL, 2418, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:55:55', 'admin-1472357188-1472360154879284', 1, 0, '', NULL, NULL, NULL),
(6649, '2016-08-28 12:55:55', NULL, NULL, 2418, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:55:55', 'admin-1472357188-1472360154879284', 1, 1, 'SR', NULL, NULL, NULL),
(6650, '2016-08-28 12:55:55', NULL, NULL, 2418, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:55:55', 'admin-1472357188-1472360154879284', 1, 0, '', NULL, NULL, NULL),
(6651, '2016-08-28 12:55:55', NULL, NULL, 2418, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:55:55', 'admin-1472357188-1472360154879284', 1, 1, 'SR', NULL, NULL, NULL),
(6652, '2016-08-28 12:59:47', NULL, NULL, 2419, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:59:47', 'admin-1472357188-14723603873587981', 1, 1, 'SR', NULL, NULL, NULL),
(6653, '2016-08-28 12:59:47', NULL, NULL, 2419, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:59:47', 'admin-1472357188-14723603873587981', 1, 1, 'SR', NULL, NULL, NULL),
(6654, '2016-08-28 12:59:47', NULL, NULL, 2419, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:59:47', 'admin-1472357188-14723603873587981', 1, 0, '', NULL, NULL, NULL),
(6655, '2016-08-28 13:01:12', NULL, NULL, 2420, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 13:01:12', 'admin-1472357188-14723604726833525', 1, 1, 'SR', NULL, NULL, NULL),
(6656, '2016-08-28 13:23:13', NULL, NULL, 2421, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 13:23:13', 'admin-1472360478-14723617928059531', 1, 0, '', NULL, NULL, NULL),
(6657, '2016-08-28 13:30:51', NULL, NULL, 2422, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 13:30:51', 'admin-1472360478-14723622517439855', 1, 0, '', NULL, NULL, NULL),
(6658, '2016-08-28 13:30:51', NULL, NULL, 2422, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 13:30:51', 'admin-1472360478-14723622517439855', 1, 0, '', NULL, NULL, NULL),
(6659, '2016-08-28 18:11:35', NULL, NULL, 2444, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:11:35', 'admin-1472360478-14723790947974720', 1, 1, 'SR', NULL, NULL, NULL),
(6660, '2016-08-28 18:11:35', NULL, NULL, 2444, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:11:35', 'admin-1472360478-14723790947974720', 1, 1, 'SR', NULL, NULL, NULL),
(6661, '2016-08-28 18:11:35', NULL, NULL, 2444, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:11:35', 'admin-1472360478-14723790947974720', 1, 1, 'SR', NULL, NULL, NULL),
(6662, '2016-08-28 18:11:35', NULL, NULL, 2444, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:11:35', 'admin-1472360478-14723790947974720', 1, 1, 'SR', NULL, NULL, NULL),
(6663, '2016-08-28 18:11:35', NULL, NULL, 2444, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:11:35', 'admin-1472360478-14723790947974720', 1, 1, 'SR', NULL, NULL, NULL),
(6664, '2016-08-28 18:11:35', NULL, NULL, 2444, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:11:35', 'admin-1472360478-14723790947974720', 1, 0, '', NULL, NULL, NULL),
(6665, '2016-08-28 18:11:35', NULL, NULL, 2444, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:11:35', 'admin-1472360478-14723790947974720', 1, 0, '', NULL, NULL, NULL),
(6666, '2016-08-28 17:59:26', NULL, NULL, 2443, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 17:59:26', 'admin-1472360478-14723783660649255', 1, 1, 'SR', 1, NULL, NULL),
(6667, '2016-08-28 18:11:35', NULL, NULL, 2444, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 18:11:35', 'admin-1472360478-14723790947974720', 1, 0, '', NULL, NULL, NULL),
(6668, '2016-08-28 17:23:35', NULL, NULL, 2442, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 17:23:35', 'admin-1472360478-1472376214972469', 1, 1, 'SR', 1, NULL, NULL),
(6669, '2016-08-28 16:49:52', NULL, NULL, 2441, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 16:49:52', 'admin-1472360478-14723741919984944', 1, 0, '', NULL, NULL, NULL),
(6670, '2016-08-28 16:49:52', NULL, NULL, 2441, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 16:49:52', 'admin-1472360478-14723741919984944', 1, 1, 'SR', NULL, NULL, NULL),
(6671, '2016-08-28 16:49:52', NULL, NULL, 2441, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 16:49:52', 'admin-1472360478-14723741919984944', 1, 0, '', NULL, NULL, NULL),
(6672, '2016-08-28 16:33:44', NULL, NULL, 2440, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 16:33:44', 'admin-1472360478-14723732240663167', 1, 0, '', NULL, NULL, NULL),
(6673, '2016-08-28 16:26:07', NULL, NULL, 2438, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 16:26:07', 'admin-1472360478-14723727676932891', 1, 1, 'SR', NULL, NULL, NULL),
(6674, '2016-08-28 16:32:39', NULL, NULL, 2439, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 16:32:39', 'admin-1472360478-14723731595761284', 1, 1, 'SR', 1, NULL, NULL),
(6675, '2016-08-28 14:45:59', NULL, NULL, 2429, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 14:45:59', 'admin-1472360478-14723667594127720', 1, 1, 'SR', NULL, NULL, NULL),
(6676, '2016-08-28 14:54:47', NULL, NULL, 2431, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 14:54:47', 'admin-1472360478-14723672875368473', 1, 1, 'SR', NULL, NULL, NULL),
(6677, '2016-08-28 14:54:47', NULL, NULL, 2431, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 14:54:47', 'admin-1472360478-14723672875368473', 1, 1, 'SR', NULL, NULL, NULL),
(6678, '2016-08-28 14:45:59', NULL, NULL, 2429, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 14:45:59', 'admin-1472360478-14723667594127720', 1, 1, 'SR', NULL, NULL, NULL),
(6679, '2016-08-28 14:40:34', NULL, NULL, 2428, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 14:40:34', 'admin-1472360478-14723664342899368', 1, 0, '', NULL, NULL, NULL),
(6680, '2016-08-28 14:40:34', NULL, NULL, 2428, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 14:40:34', 'admin-1472360478-14723664342899368', 1, 0, '', NULL, NULL, NULL),
(6681, '2016-08-28 14:39:36', NULL, NULL, 2427, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 14:39:36', 'admin-1472360478-14723663762663195', 1, 0, '', NULL, NULL, NULL),
(6682, '2016-08-28 13:45:15', NULL, NULL, 2423, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 13:45:15', 'admin-1472360478-1472363115121971', 1, 0, '', NULL, NULL, NULL),
(6683, '2016-08-28 13:45:15', NULL, NULL, 2423, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 13:45:15', 'admin-1472360478-1472363115121971', 1, 1, 'SR', NULL, NULL, NULL),
(6684, '2016-08-28 13:45:15', NULL, NULL, 2423, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 13:45:15', 'admin-1472360478-1472363115121971', 1, 1, 'SR', NULL, NULL, NULL),
(6685, '2016-08-28 13:45:15', NULL, NULL, 2423, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 13:45:15', 'admin-1472360478-1472363115121971', 1, 1, 'SR', NULL, NULL, NULL),
(6686, '2016-08-28 14:22:36', NULL, NULL, 2424, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 14:22:36', 'admin-1472360478-147236535625194', 1, 0, '', NULL, NULL, NULL),
(6687, '2016-08-28 14:22:43', NULL, NULL, 2424, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 14:22:43', 'admin-1472360478-14723653635877048', 1, 0, '', NULL, NULL, NULL),
(6688, '2016-08-28 14:22:43', NULL, NULL, 2424, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 14:22:43', 'admin-1472360478-14723653635877048', 1, 1, 'SR', NULL, NULL, NULL),
(6689, '2016-08-28 14:23:23', NULL, NULL, 2425, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 14:23:23', 'admin-1472360478-14723654034976449', 1, 1, 'SR', NULL, NULL, NULL),
(6690, '2016-08-28 14:23:23', NULL, NULL, 2425, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 14:23:23', 'admin-1472360478-14723654034976449', 1, 1, 'SR', NULL, NULL, NULL),
(6691, '2016-08-28 10:57:28', NULL, NULL, 2405, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:57:28', 'admin-1472350154-14723530478784190', 1, 1, 'SR', NULL, NULL, NULL),
(6692, '2016-08-28 14:39:36', NULL, NULL, 2427, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 14:39:36', 'admin-1472360478-14723663762663195', 1, 0, '', NULL, NULL, NULL),
(6693, '2016-08-28 14:32:19', NULL, NULL, 2426, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 14:32:19', 'admin-1472360478-1472365939656762', 1, 1, 'SR', NULL, NULL, NULL),
(6694, '2016-08-28 14:39:36', NULL, NULL, 2427, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 14:39:36', 'admin-1472360478-14723663762663195', 1, 1, 'SR', NULL, NULL, NULL),
(6695, '2016-08-28 14:39:36', NULL, NULL, 2427, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 14:39:36', 'admin-1472360478-14723663762663195', 1, 1, 'SR', NULL, NULL, NULL),
(6696, '2016-08-28 11:29:20', NULL, NULL, 2408, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 11:29:20', 'admin-1472350154-14723549607846985', 1, 1, 'SR', NULL, NULL, NULL),
(6697, '2016-08-28 11:29:20', NULL, NULL, 2408, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 11:29:20', 'admin-1472350154-14723549607846985', 1, 1, 'SR', NULL, NULL, NULL),
(6698, '2016-08-28 11:29:20', NULL, NULL, 2408, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 11:29:20', 'admin-1472350154-14723549607846985', 1, 0, '', NULL, NULL, NULL),
(6699, '2016-08-28 11:29:20', NULL, NULL, 2408, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 11:29:20', 'admin-1472350154-14723549607846985', 1, 0, '', NULL, NULL, NULL),
(6700, '2016-08-28 11:39:36', NULL, NULL, 2409, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 11:39:36', 'admin-1472350154-14723555761298248', 1, 1, 'SR', NULL, NULL, NULL),
(6701, '2016-08-28 11:47:53', NULL, NULL, 2410, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 11:47:53', 'admin-1472350154-14723560733917510', 1, 0, '', NULL, NULL, NULL),
(6702, '2016-08-28 11:47:53', NULL, NULL, 2410, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 11:47:53', 'admin-1472350154-14723560733917510', 1, 0, '', NULL, NULL, NULL),
(6703, '2016-08-28 11:47:53', NULL, NULL, 2410, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 11:47:53', 'admin-1472350154-14723560733917510', 1, 0, '', NULL, NULL, NULL),
(6704, '2016-08-28 11:47:53', NULL, NULL, 2410, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 11:47:53', 'admin-1472350154-14723560733917510', 1, 0, '', NULL, NULL, NULL),
(6705, '2016-08-28 11:47:53', NULL, NULL, 2410, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 11:47:53', 'admin-1472350154-14723560733917510', 1, 1, 'SR', NULL, NULL, NULL),
(6706, '2016-08-28 11:47:53', NULL, NULL, 2410, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 11:47:53', 'admin-1472350154-14723560733917510', 1, 1, 'SR', NULL, NULL, NULL),
(6707, '2016-08-28 11:47:53', NULL, NULL, 2410, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 11:47:53', 'admin-1472350154-14723560733917510', 1, 1, 'SR', NULL, NULL, NULL),
(6708, '2016-08-28 12:05:40', NULL, NULL, 2411, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:05:40', 'admin-1472350154-14723571398806164', 1, 0, '', NULL, NULL, NULL),
(6709, '2016-08-28 12:05:40', NULL, NULL, 2411, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:05:40', 'admin-1472350154-14723571398806164', 1, 0, '', NULL, NULL, NULL),
(6710, '2016-08-28 12:05:40', NULL, NULL, 2411, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:05:40', 'admin-1472350154-14723571398806164', 1, 0, '', NULL, NULL, NULL),
(6711, '2016-08-28 10:42:21', NULL, NULL, 2401, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:42:21', 'admin-1472350154-14723521407932147', 1, 1, 'SR', NULL, NULL, NULL),
(6712, '2016-08-28 10:42:21', NULL, NULL, 2401, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:42:21', 'admin-1472350154-14723521407932147', 1, 1, 'SR', NULL, NULL, NULL),
(6713, '2016-08-28 10:42:21', NULL, NULL, 2401, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:42:21', 'admin-1472350154-14723521407932147', 1, 1, 'SR', NULL, NULL, NULL),
(6714, '2016-08-28 10:45:02', NULL, NULL, 2402, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:45:02', 'admin-1472350154-14723523023157630', 1, 1, 'SR', NULL, NULL, NULL),
(6715, '2016-08-28 10:45:02', NULL, NULL, 2402, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:45:02', 'admin-1472350154-14723523023157630', 1, 1, 'SR', NULL, NULL, NULL),
(6716, '2016-08-28 10:49:48', NULL, NULL, 2403, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:49:48', 'admin-1472350154-14723525886655664', 1, 1, 'SR', NULL, NULL, NULL),
(6717, '2016-08-28 10:49:48', NULL, NULL, 2403, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:49:48', 'admin-1472350154-14723525886655664', 1, 1, 'SR', NULL, NULL, NULL),
(6718, '2016-08-28 10:49:48', NULL, NULL, 2403, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:49:48', 'admin-1472350154-14723525886655664', 1, 0, '', NULL, NULL, NULL),
(6719, '2016-08-28 10:49:48', NULL, NULL, 2403, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:49:48', 'admin-1472350154-14723525886655664', 1, 0, '', NULL, NULL, NULL),
(6720, '2016-08-28 10:53:18', NULL, NULL, 2404, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:53:18', 'admin-1472350154-14723527986623148', 1, 0, '', NULL, NULL, NULL),
(6721, '2016-08-28 10:57:28', NULL, NULL, 2405, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:57:28', 'admin-1472350154-14723530478784190', 1, 0, '', NULL, NULL, NULL),
(6722, '2016-08-28 10:57:28', NULL, NULL, 2405, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:57:28', 'admin-1472350154-14723530478784190', 1, 0, '', NULL, NULL, NULL),
(6723, '2016-08-28 14:23:23', NULL, NULL, 2425, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 14:23:23', 'admin-1472360478-14723654034976449', 1, 0, '', NULL, NULL, NULL),
(6724, '2016-08-28 14:32:19', NULL, NULL, 2426, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 14:32:19', 'admin-1472360478-1472365939656762', 1, 1, 'SR', NULL, NULL, NULL),
(6725, '2016-08-28 13:45:15', NULL, NULL, 2423, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 13:45:15', 'admin-1472360478-1472363115121971', 1, 0, '', NULL, NULL, NULL),
(6726, '2016-08-28 13:30:51', NULL, NULL, 2422, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 13:30:51', 'admin-1472360478-14723622517439855', 1, 1, 'SR', NULL, NULL, NULL),
(6727, '2016-08-28 13:30:51', NULL, NULL, 2422, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 13:30:51', 'admin-1472360478-14723622517439855', 1, 1, 'SR', NULL, NULL, NULL),
(6728, '2016-08-28 12:05:40', NULL, NULL, 2411, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:05:40', 'admin-1472350154-14723571398806164', 1, 1, 'SR', NULL, NULL, NULL),
(6729, '2016-08-28 12:05:40', NULL, NULL, 2411, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:05:40', 'admin-1472350154-14723571398806164', 1, 1, 'SR', NULL, NULL, NULL),
(6730, '2016-08-28 12:05:40', NULL, NULL, 2411, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:05:40', 'admin-1472350154-14723571398806164', 1, 0, '', NULL, NULL, NULL),
(6731, '2016-08-28 12:05:40', NULL, NULL, 2411, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:05:40', 'admin-1472350154-14723571398806164', 1, 0, '', NULL, NULL, NULL),
(6732, '2016-08-28 12:05:40', NULL, NULL, 2411, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:05:40', 'admin-1472350154-14723571398806164', 1, 1, 'SR', NULL, NULL, NULL),
(6733, '2016-08-28 12:05:40', NULL, NULL, 2411, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:05:40', 'admin-1472350154-14723571398806164', 1, 0, '', NULL, NULL, NULL),
(6734, '2016-08-28 12:05:40', NULL, NULL, 2411, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:05:40', 'admin-1472350154-14723571398806164', 1, 1, 'SR', NULL, NULL, NULL),
(6735, '2016-08-28 12:05:40', NULL, NULL, 2411, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 12:05:40', 'admin-1472350154-14723571398806164', 1, 1, 'SR', NULL, NULL, NULL),
(6736, '2016-08-28 11:29:20', NULL, NULL, 2408, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 11:29:20', 'admin-1472350154-14723549607846985', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(6737, '2016-08-28 11:15:51', NULL, NULL, 2407, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 11:15:51', 'admin-1472350154-14723541511729451', 1, 0, '', NULL, NULL, NULL),
(6738, '2016-08-28 11:15:32', NULL, NULL, 2407, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 11:15:32', 'admin-1472350154-1472354132542476', 1, 1, 'SR', NULL, NULL, NULL),
(6739, '2016-08-28 11:04:24', NULL, NULL, 2406, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 11:04:24', 'admin-1472350154-14723534641362293', 1, 1, 'SR', NULL, NULL, NULL),
(6740, '2016-08-28 10:57:28', NULL, NULL, 2405, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:57:28', 'admin-1472350154-14723530478784190', 1, 1, 'SR', NULL, NULL, NULL),
(6741, '2016-08-28 11:15:32', NULL, NULL, 2407, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 11:15:32', 'admin-1472350154-1472354132542476', 1, 1, 'SR', NULL, NULL, NULL),
(6742, '2016-08-28 11:15:32', NULL, NULL, 2407, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 11:15:32', 'admin-1472350154-1472354132542476', 1, 1, 'SR', NULL, NULL, NULL),
(6743, '2016-08-28 11:15:32', NULL, NULL, 2407, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 11:15:32', 'admin-1472350154-1472354132542476', 1, 0, '', NULL, NULL, NULL),
(6744, '2016-08-28 10:35:06', NULL, NULL, 2398, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:35:06', 'admin-1472350154-14723517065517765', 1, 0, '', NULL, NULL, NULL),
(6745, '2016-08-28 10:35:06', NULL, NULL, 2398, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:35:06', 'admin-1472350154-14723517065517765', 1, 1, 'SR', NULL, NULL, NULL),
(6746, '2016-08-28 10:35:06', NULL, NULL, 2398, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:35:06', 'admin-1472350154-14723517065517765', 1, 1, 'SR', NULL, NULL, NULL),
(6747, '2016-08-28 10:42:21', NULL, NULL, 2401, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:42:21', 'admin-1472350154-14723521407932147', 1, 0, '', NULL, NULL, NULL),
(6748, '2016-08-28 10:42:21', NULL, NULL, 2401, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:42:21', 'admin-1472350154-14723521407932147', 1, 0, '', NULL, NULL, NULL),
(6749, '2016-08-28 10:33:13', NULL, NULL, 2399, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:33:13', 'admin-1472350154-14723515934986716', 1, 1, 'SR', NULL, NULL, NULL),
(6750, '2016-08-28 10:33:13', NULL, NULL, 2399, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:33:13', 'admin-1472350154-14723515934986716', 1, 0, '', NULL, NULL, NULL),
(6751, '2016-08-28 10:33:48', NULL, NULL, 2400, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:33:48', 'admin-1472350154-1472351628410998', 1, 1, 'SR', NULL, NULL, NULL),
(6752, '2016-08-28 10:33:48', NULL, NULL, 2400, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:33:48', 'admin-1472350154-1472351628410998', 1, 1, 'SR', NULL, NULL, NULL),
(6753, '2016-08-28 10:42:21', NULL, NULL, 2401, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:42:21', 'admin-1472350154-14723521407932147', 1, 0, '', NULL, NULL, NULL),
(6754, '2016-08-28 10:35:06', NULL, NULL, 2398, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:35:06', 'admin-1472350154-14723517065517765', 1, 0, '', NULL, NULL, NULL),
(6755, '2016-08-28 10:33:48', NULL, NULL, 2400, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:33:48', 'admin-1472350154-1472351628410998', 1, 1, 'SR', NULL, NULL, NULL),
(6756, '2016-08-28 10:15:08', NULL, NULL, 2397, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:15:08', 'admin-1472350154-147235050878726', 1, 0, '', NULL, NULL, NULL),
(6757, '2016-08-28 10:15:08', NULL, NULL, 2397, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:15:08', 'admin-1472350154-147235050878726', 1, 1, 'SR', NULL, NULL, NULL),
(6758, '2016-08-28 10:15:09', NULL, NULL, 2397, 0, 182, '117', 'Open Drinks ', 'vanilla syrup', 'Desserts', '0', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:15:09', 'admin-1472350154-147235050878726', 1, 0, '', NULL, NULL, NULL),
(6759, '2016-08-28 10:32:58', NULL, NULL, 2398, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:32:58', 'admin-1472350154-14723515782361533', 1, 1, 'SR', NULL, NULL, NULL),
(6760, '2016-08-28 10:32:58', NULL, NULL, 2398, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:32:58', 'admin-1472350154-14723515782361533', 1, 1, 'SR', NULL, NULL, NULL),
(6761, '2016-08-28 09:19:40', NULL, NULL, 2384, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:19:40', 'admin-1472344579-14723471798037974', 1, 0, '', NULL, NULL, NULL),
(6762, '2016-08-28 10:12:09', NULL, NULL, 2396, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:12:09', 'admin-1472350154-14723503296594198', 1, 1, 'SR', NULL, NULL, NULL),
(6763, '2016-08-28 10:12:09', NULL, NULL, 2396, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:12:09', 'admin-1472350154-14723503296594198', 1, 0, '', NULL, NULL, NULL),
(6764, '2016-08-28 10:10:00', NULL, NULL, 2395, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:10:00', 'admin-1472350154-14723502003743396', 1, 0, '', NULL, NULL, NULL),
(6765, '2016-08-28 10:10:00', NULL, NULL, 2395, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:10:00', 'admin-1472350154-14723502003743396', 1, 1, 'SR', NULL, NULL, NULL),
(6766, '2016-08-28 09:41:04', NULL, NULL, 2392, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:41:04', 'admin-1472348446-14723484648024915', 1, 1, 'SR', NULL, NULL, NULL),
(6767, '2016-08-28 09:40:34', NULL, NULL, 2392, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:40:34', 'admin-1472344579-14723484345694678', 1, 0, '', NULL, NULL, NULL),
(6768, '2016-08-28 09:46:37', NULL, NULL, 2393, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:46:37', 'admin-1472348446-14723487970495362', 1, 1, 'SR', NULL, NULL, NULL),
(6769, '2016-08-28 09:46:37', NULL, NULL, 2393, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:46:37', 'admin-1472348446-14723487970495362', 1, 0, '', NULL, NULL, NULL),
(6770, '2016-08-28 09:46:37', NULL, NULL, 2393, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:46:37', 'admin-1472348446-14723487970495362', 1, 0, '', NULL, NULL, NULL),
(6771, '2016-08-28 10:09:05', NULL, NULL, 2394, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 10:09:05', 'admin-1472348446-1472350145636606', 1, 1, 'SR', NULL, NULL, NULL),
(6772, '2016-08-28 00:00:00', NULL, NULL, 2389, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:35:33', 'admin-1472344579-14723481330763536', 1, 1, 'SR', NULL, NULL, NULL),
(6773, '2016-08-28 09:40:34', NULL, NULL, 2392, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:40:34', 'admin-1472344579-14723484345694678', 1, 1, 'SR', NULL, NULL, NULL),
(6774, '2016-08-28 00:00:00', NULL, NULL, 2388, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:35:33', 'admin-1472344579-14723481330763536', 1, 1, 'SR', NULL, NULL, NULL),
(6775, '2016-08-28 09:19:40', NULL, NULL, 2384, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:19:40', 'admin-1472344579-14723471798037974', 1, 0, '', NULL, NULL, NULL),
(6776, '2016-08-28 09:19:40', NULL, NULL, 2384, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:19:40', 'admin-1472344579-14723471798037974', 1, 1, 'SR', NULL, NULL, NULL),
(6777, '2016-08-28 09:30:30', NULL, NULL, 2385, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:30:30', 'admin-1472344579-14723478301484286', 1, 0, '', NULL, NULL, NULL),
(6778, '2016-08-28 09:30:30', NULL, NULL, 2385, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:30:30', 'admin-1472344579-14723478301484286', 1, 0, '', NULL, NULL, NULL),
(6779, '2016-08-28 09:30:30', NULL, NULL, 2385, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:30:30', 'admin-1472344579-14723478301484286', 1, 1, 'SR', NULL, NULL, NULL),
(6780, '2016-08-28 09:30:30', NULL, NULL, 2385, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:30:30', 'admin-1472344579-14723478301484286', 1, 1, 'SR', NULL, NULL, NULL),
(6781, '2016-08-28 09:33:01', NULL, NULL, 2386, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:33:01', 'admin-1472344579-14723479815969687', 1, 0, '', NULL, NULL, NULL),
(6782, '2016-08-28 00:00:00', NULL, NULL, 2388, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:35:33', 'admin-1472344579-14723481330763536', 1, 0, '', NULL, NULL, NULL),
(6783, '2016-08-28 00:00:00', NULL, NULL, 2390, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:35:33', 'admin-1472344579-14723481330763536', 1, 1, 'SR', NULL, NULL, NULL),
(6784, '2016-08-28 00:00:00', NULL, NULL, 2390, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:35:33', 'admin-1472344579-14723481330763536', 1, 0, '', NULL, NULL, NULL),
(6785, '2016-08-28 00:00:00', NULL, NULL, 2389, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:35:33', 'admin-1472344579-14723481330763536', 1, 0, '', NULL, NULL, NULL),
(6786, '2016-08-28 00:00:00', NULL, NULL, 2390, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:35:33', 'admin-1472344579-14723481330763536', 1, 0, '', NULL, NULL, NULL),
(6787, '2016-08-28 09:37:56', NULL, NULL, 2391, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:37:56', 'admin-1472344579-14723482758492092', 1, 0, '', NULL, NULL, NULL),
(6788, '2016-08-28 09:19:40', NULL, NULL, 2384, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:19:40', 'admin-1472344579-14723471798037974', 1, 0, '', NULL, NULL, NULL),
(6789, '2016-08-28 09:19:40', NULL, NULL, 2384, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:19:40', 'admin-1472344579-14723471798037974', 1, 0, '', NULL, NULL, NULL),
(6790, '2016-08-28 09:19:40', NULL, NULL, 2384, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:19:40', 'admin-1472344579-14723471798037974', 1, 0, '', NULL, NULL, NULL),
(6791, '2016-08-28 09:07:20', NULL, NULL, 2383, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:07:20', 'admin-1472344579-14723464407344224', 1, 1, 'SR', NULL, NULL, NULL),
(6792, '2016-08-28 09:07:20', NULL, NULL, 2383, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:07:20', 'admin-1472344579-14723464407344224', 1, 1, 'SR', NULL, NULL, NULL),
(6793, '2016-08-28 09:07:20', NULL, NULL, 2383, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:07:20', 'admin-1472344579-14723464407344224', 1, 1, 'SR', NULL, NULL, NULL),
(6794, '2016-08-28 09:07:20', NULL, NULL, 2383, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:07:20', 'admin-1472344579-14723464407344224', 1, 0, '', NULL, NULL, NULL),
(6795, '2016-08-28 09:04:02', NULL, NULL, 2382, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:04:02', 'admin-1472344579-14723462419915655', 1, 0, '', NULL, NULL, NULL),
(6796, '2016-08-28 09:04:02', NULL, NULL, 2382, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:04:02', 'admin-1472344579-14723462419915655', 1, 0, '', NULL, NULL, NULL),
(6797, '2016-08-28 09:07:20', NULL, NULL, 2383, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:07:20', 'admin-1472344579-14723464407344224', 1, 0, '', NULL, NULL, NULL),
(6798, '2016-08-28 09:04:09', NULL, NULL, 2382, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:04:09', 'admin-1472344579-1472346248859880', 1, 1, 'SR', NULL, NULL, NULL),
(6799, '2016-08-28 09:07:20', NULL, NULL, 2383, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:07:20', 'admin-1472344579-14723464407344224', 1, 0, '', NULL, NULL, NULL),
(6800, '2016-08-28 09:04:02', NULL, NULL, 2382, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:04:02', 'admin-1472344579-14723462419915655', 1, 1, 'SR', NULL, NULL, NULL),
(6801, '2016-08-28 09:04:02', NULL, NULL, 2382, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:04:02', 'admin-1472344579-14723462419915655', 1, 1, 'SR', NULL, NULL, NULL),
(6802, '2016-08-28 09:04:02', NULL, NULL, 2382, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:04:02', 'admin-1472344579-14723462419915655', 1, 1, 'SR', NULL, NULL, NULL),
(6803, '2016-08-28 09:04:02', NULL, NULL, 2382, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472382011', 'admin', '2016-08-28 09:04:02', 'admin-1472344579-14723462419915655', 1, 0, '', NULL, NULL, NULL),
(6804, '2016-08-29 19:45:31', NULL, NULL, 2467, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 19:45:31', 'admin-1472471094-14724711309932137', 1, 0, '', NULL, NULL, NULL),
(6805, '2016-08-29 19:54:23', NULL, NULL, 2467, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 19:54:23', 'admin-1472471094-14724716628862390', 1, 0, '', NULL, NULL, NULL),
(6806, '2016-08-29 21:09:33', NULL, NULL, 2467, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 21:09:33', 'admin-1472471094-14724761738048159', 1, 0, '', NULL, NULL, NULL),
(6807, '2016-08-29 21:09:33', NULL, NULL, 2467, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 21:09:33', 'admin-1472471094-14724761738048159', 1, 0, '', NULL, NULL, NULL),
(6808, '2016-08-29 21:09:48', NULL, NULL, 2467, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 21:09:48', 'admin-1472471094-14724761881914688', 1, 1, 'SR', NULL, NULL, NULL),
(6809, '2016-08-29 12:17:06', NULL, NULL, 2459, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 12:17:06', 'admin-1472431662-14724442261616881', 1, 1, 'SR', NULL, NULL, NULL),
(6810, '2016-08-29 19:45:31', NULL, NULL, 2467, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 19:45:31', 'admin-1472471094-14724711309932137', 1, 1, 'SR', NULL, NULL, NULL),
(6811, '2016-08-29 19:45:31', NULL, NULL, 2467, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 19:45:31', 'admin-1472471094-14724711309932137', 1, 1, 'SR', NULL, NULL, NULL),
(6812, '2016-08-29 19:45:31', NULL, NULL, 2467, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 19:45:31', 'admin-1472471094-14724711309932137', 1, 0, '', NULL, NULL, NULL),
(6813, '2016-08-29 17:17:00', NULL, NULL, 2465, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 17:17:00', 'admin-1472431662-14724622198284176', 1, 1, 'SR', 1, NULL, NULL),
(6814, '2016-08-29 18:41:42', NULL, NULL, 2466, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 18:41:42', 'admin-1472431662-14724673026257930', 1, 0, '', NULL, NULL, '10.0'),
(6815, '2016-08-29 18:41:42', NULL, NULL, 2466, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 18:41:42', 'admin-1472431662-14724673026257930', 1, 0, '', NULL, NULL, '10.0'),
(6816, '2016-08-29 18:41:42', NULL, NULL, 2466, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 18:41:42', 'admin-1472431662-14724673026257930', 1, 0, '', NULL, NULL, '10.0'),
(6817, '2016-08-29 19:32:35', NULL, NULL, 2467, 0, 199, '134', 'Dinner - Marmite Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 19:32:35', 'admin-1472431662-14724703549173220', 1, 0, '', NULL, NULL, NULL),
(6818, '2016-08-29 12:28:10', NULL, NULL, 2459, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 12:28:10', 'admin-1472431662-14724448903995216', 1, 1, 'SR', NULL, NULL, NULL),
(6819, '2016-08-29 12:28:10', NULL, NULL, 2459, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 12:28:10', 'admin-1472431662-14724448903995216', 1, 1, 'SR', NULL, NULL, NULL),
(6820, '2016-08-29 13:12:16', NULL, NULL, 2461, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 13:12:16', 'admin-1472431662-14724475359513337', 1, 0, '', NULL, NULL, NULL),
(6821, '2016-08-29 13:12:16', NULL, NULL, 2461, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 13:12:16', 'admin-1472431662-14724475359513337', 1, 1, 'SR', NULL, NULL, NULL),
(6822, '2016-08-29 13:12:16', NULL, NULL, 2461, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 13:12:16', 'admin-1472431662-14724475359513337', 1, 1, 'SR', NULL, NULL, NULL),
(6823, '2016-08-29 13:12:16', NULL, NULL, 2461, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 13:12:16', 'admin-1472431662-14724475359513337', 1, 0, '', NULL, NULL, NULL),
(6824, '2016-08-29 13:16:24', NULL, NULL, 2462, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 13:16:24', 'admin-1472431662-1472447784784488', 1, 1, 'SR', NULL, NULL, NULL),
(6825, '2016-08-29 13:16:24', NULL, NULL, 2462, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 13:16:24', 'admin-1472431662-1472447784784488', 1, 1, 'SR', NULL, NULL, NULL),
(6826, '2016-08-29 13:28:09', NULL, NULL, 2462, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 13:28:09', 'admin-1472431662-14724484895261255', 1, 0, '', NULL, NULL, NULL),
(6827, '2016-08-29 14:16:27', NULL, NULL, 2463, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 14:16:27', 'admin-1472431662-14724513870937935', 1, 1, 'SR', 1, NULL, NULL),
(6828, '2016-08-29 14:16:27', NULL, NULL, 2463, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 14:16:27', 'admin-1472431662-14724513870937935', 1, 1, 'SR', 1, NULL, NULL),
(6829, '2016-08-29 19:45:31', NULL, NULL, 2467, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 19:45:31', 'admin-1472471094-14724711309932137', 1, 1, 'SR', NULL, NULL, NULL),
(6830, '2016-08-29 17:16:59', NULL, NULL, 2465, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 17:16:59', 'admin-1472431662-14724622198284176', 1, 1, 'SR', 1, NULL, NULL),
(6831, '2016-08-29 16:53:05', NULL, NULL, 2464, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 16:53:05', 'admin-1472431662-14724607852941610', 1, 1, 'SR', 1, NULL, NULL),
(6832, '2016-08-29 14:22:48', NULL, NULL, 2462, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 14:22:48', 'admin-1472431662-1472451768048638', 1, 1, 'SR', NULL, NULL, NULL),
(6833, '2016-08-29 14:22:48', NULL, NULL, 2462, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 14:22:48', 'admin-1472431662-1472451768048638', 1, 0, '', NULL, NULL, NULL),
(6834, '2016-08-29 12:26:10', NULL, NULL, 2459, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 12:26:10', 'admin-1472431662-14724447698321493', 1, 1, 'SR', NULL, NULL, NULL),
(6835, '2016-08-29 12:17:06', NULL, NULL, 2459, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 12:17:06', 'admin-1472431662-14724442261616881', 1, 1, 'SR', NULL, NULL, NULL),
(6836, '2016-08-29 12:17:06', NULL, NULL, 2459, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 12:17:06', 'admin-1472431662-14724442261616881', 1, 1, 'SR', NULL, NULL, NULL),
(6837, '2016-08-29 12:17:06', NULL, NULL, 2459, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 12:17:06', 'admin-1472431662-14724442261616881', 1, 0, '', NULL, NULL, NULL),
(6838, '2016-08-29 11:08:24', NULL, NULL, 2458, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 11:08:24', 'admin-1472431662-14724401040851766', 1, 0, '', NULL, NULL, NULL),
(6839, '2016-08-29 12:12:05', NULL, NULL, 2459, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 12:12:05', 'admin-1472431662-14724439258069998', 1, 1, 'SR', NULL, NULL, NULL),
(6840, '2016-08-29 12:12:05', NULL, NULL, 2459, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 12:12:05', 'admin-1472431662-14724439258069998', 1, 1, 'SR', NULL, NULL, NULL),
(6841, '2016-08-29 12:12:58', NULL, NULL, 2460, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 12:12:58', 'admin-1472431662-14724439778244686', 1, 1, 'SR', NULL, NULL, NULL),
(6842, '2016-08-29 12:12:58', NULL, NULL, 2460, 0, 82, '82', 'Rice Wine Ginger Pork', ',add more rice', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 12:12:58', 'admin-1472431662-14724439778244686', 1, 1, 'SR', NULL, NULL, NULL),
(6843, '2016-08-29 11:07:47', NULL, NULL, 2458, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 11:07:47', 'admin-1472431662-14724400674146547', 1, 0, '', NULL, NULL, NULL),
(6844, '2016-08-29 10:54:25', NULL, NULL, 2457, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 10:54:25', 'admin-1472431662-14724392652104211', 1, 0, '', NULL, NULL, NULL),
(6845, '2016-08-29 10:54:25', NULL, NULL, 2457, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 10:54:25', 'admin-1472431662-14724392652104211', 1, 0, '', NULL, NULL, NULL),
(6846, '2016-08-29 10:55:20', NULL, NULL, 2457, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 10:55:20', 'admin-1472431662-14724393200935656', 1, 0, '', NULL, NULL, NULL),
(6847, '2016-08-29 09:50:07', NULL, NULL, 2454, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 09:50:07', 'admin-1472431662-14724354070157657', 1, 1, 'SR', NULL, NULL, NULL),
(6848, '2016-08-29 09:52:47', NULL, NULL, 2455, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 09:52:47', 'admin-1472431662-14724355669519458', 1, 0, '', NULL, NULL, NULL),
(6849, '2016-08-29 10:06:46', NULL, NULL, 2456, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 10:06:46', 'admin-1472431662-1472436405881315', 1, 1, 'SR', NULL, NULL, NULL),
(6850, '2016-08-29 10:06:46', NULL, NULL, 2456, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 10:06:46', 'admin-1472431662-1472436405881315', 1, 0, '', NULL, NULL, NULL),
(6851, '2016-08-29 09:52:47', NULL, NULL, 2455, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472471094', 'admin', '2016-08-29 09:52:47', 'admin-1472431662-14724355669519458', 1, 0, '', NULL, NULL, NULL),
(6852, '2016-08-31 19:05:35', NULL, NULL, 2503, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 19:05:35', 'admin-1472624610-14726415349366852', 1, 1, 'SR', NULL, NULL, NULL),
(6853, '2016-08-31 19:13:48', NULL, NULL, 2504, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 19:13:48', 'admin-1472624610-14726420284276847', 1, 1, 'SR', NULL, NULL, NULL),
(6854, '2016-08-31 19:13:48', NULL, NULL, 2504, 0, 181, '116', 'Open Food ', 'Garlic Spicy Pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 19:13:48', 'admin-1472624610-14726420284276847', 1, 0, '', NULL, NULL, NULL),
(6855, '2016-08-31 19:14:20', NULL, NULL, 2505, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 19:14:20', 'admin-1472624610-14726420600817397', 1, 0, '', NULL, NULL, NULL),
(6856, '2016-08-31 19:14:20', NULL, NULL, 2505, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 19:14:20', 'admin-1472624610-14726420600817397', 1, 1, 'SR', NULL, NULL, NULL),
(6857, '2016-08-31 19:14:20', NULL, NULL, 2505, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 19:14:20', 'admin-1472624610-14726420600817397', 1, 1, 'SR', NULL, NULL, NULL),
(6858, '2016-08-31 19:16:06', NULL, NULL, 2506, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 19:16:06', 'admin-1472624610-14726421665843955', 1, 0, '', NULL, NULL, NULL),
(6859, '2016-08-31 19:16:06', NULL, NULL, 2506, 0, 181, '116', 'Open Food ', 'Garlic Spicy Pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 19:16:06', 'admin-1472624610-14726421665843955', 1, 0, '', NULL, NULL, NULL),
(6860, '2016-08-31 19:16:06', NULL, NULL, 2506, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 19:16:06', 'admin-1472624610-14726421665843955', 1, 0, '', NULL, NULL, NULL),
(6861, '2016-08-31 19:16:30', NULL, NULL, 2507, 0, 181, '116', 'Open Food ', 'Garlic Spicy Pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 19:16:30', 'admin-1472624610-1472642190584345', 1, 0, '', NULL, NULL, NULL),
(6862, '2016-08-31 19:17:16', NULL, NULL, 2508, 0, 181, '116', 'Open Food ', 'Carrot Pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 19:17:16', 'admin-1472624610-14726422360566492', 1, 0, '', NULL, NULL, NULL),
(6863, '2016-08-31 19:18:38', NULL, NULL, 2509, 0, 181, '116', 'Open Food ', 'Garlic Spicy Pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 19:18:38', 'admin-1472624610-14726423181425772', 1, 0, '', NULL, NULL, NULL),
(6864, '2016-08-31 19:20:16', NULL, NULL, 2510, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 19:20:16', 'admin-1472642327-14726424163666774', 1, 0, '', NULL, NULL, NULL),
(6865, '2016-08-31 19:20:16', NULL, NULL, 2510, 0, 181, '116', 'Open Food ', 'Garlic Spicy Pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 19:20:16', 'admin-1472642327-14726424163666774', 1, 0, '', NULL, NULL, NULL),
(6866, '2016-08-31 19:20:16', NULL, NULL, 2510, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 19:20:16', 'admin-1472642327-14726424163666774', 1, 1, 'SR', NULL, NULL, NULL),
(6867, '2016-08-31 19:20:16', NULL, NULL, 2510, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 19:20:16', 'admin-1472642327-14726424163666774', 1, 1, 'SR', NULL, NULL, NULL),
(6868, '2016-08-31 16:05:32', NULL, NULL, 2499, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 16:05:32', 'admin-1472624610-14726307325555675', 1, 0, '', NULL, NULL, NULL),
(6869, '2016-08-31 16:05:32', NULL, NULL, 2499, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 16:05:32', 'admin-1472624610-14726307325555675', 1, 1, 'SR', NULL, NULL, NULL),
(6870, '2016-08-31 16:05:32', NULL, NULL, 2499, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 16:05:32', 'admin-1472624610-14726307325555675', 1, 0, '', NULL, NULL, NULL),
(6871, '2016-08-31 16:05:32', NULL, NULL, 2499, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 16:05:32', 'admin-1472624610-14726307325555675', 1, 1, 'SR', NULL, NULL, NULL),
(6872, '2016-08-31 16:05:32', NULL, NULL, 2499, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 16:05:32', 'admin-1472624610-14726307325555675', 1, 1, 'SR', NULL, NULL, NULL),
(6873, '2016-08-31 16:05:32', NULL, NULL, 2499, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 16:05:32', 'admin-1472624610-14726307325555675', 1, 1, 'SR', NULL, NULL, NULL),
(6874, '2016-08-31 16:05:32', NULL, NULL, 2499, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 16:05:32', 'admin-1472624610-14726307325555675', 1, 0, '', NULL, NULL, NULL),
(6875, '2016-08-31 16:05:32', NULL, NULL, 2499, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 16:05:32', 'admin-1472624610-14726307325555675', 1, 0, '', NULL, NULL, NULL),
(6876, '2016-08-31 16:06:24', NULL, NULL, 2500, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 16:06:24', 'admin-1472624610-14726307842046269', 1, 0, '', NULL, NULL, NULL),
(6877, '2016-08-31 16:06:24', NULL, NULL, 2500, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 16:06:24', 'admin-1472624610-14726307842046269', 1, 0, '', NULL, NULL, NULL),
(6878, '2016-08-31 16:37:27', NULL, NULL, 2501, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 16:37:27', 'admin-1472624610-14726326470876965', 1, 1, 'SR', NULL, NULL, NULL),
(6879, '2016-08-31 18:26:39', NULL, NULL, 2502, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 18:26:39', 'admin-1472624610-14726391992375012', 1, 1, 'SR', 1, NULL, NULL),
(6880, '2016-08-31 18:26:39', NULL, NULL, 2502, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 18:26:39', 'admin-1472624610-14726391992375012', 1, 0, '', 1, NULL, NULL),
(6881, '2016-08-31 19:05:35', NULL, NULL, 2503, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 19:05:35', 'admin-1472624610-14726415349366852', 1, 1, 'SR', NULL, NULL, NULL),
(6882, '2016-08-31 12:54:30', NULL, NULL, 2488, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 12:54:30', 'admin-1472610645-14726192699099586', 1, 0, '', NULL, NULL, NULL),
(6883, '2016-08-31 12:54:30', NULL, NULL, 2488, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 12:54:30', 'admin-1472610645-14726192699099586', 1, 1, 'SR', NULL, NULL, NULL),
(6884, '2016-08-31 13:05:09', NULL, NULL, 2489, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 13:05:09', 'admin-1472610645-1472619909378137', 1, 0, '', NULL, NULL, NULL),
(6885, '2016-08-31 13:05:09', NULL, NULL, 2489, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 13:05:09', 'admin-1472610645-1472619909378137', 1, 1, 'SR', NULL, NULL, NULL),
(6886, '2016-08-31 13:06:19', NULL, NULL, 2490, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 13:06:19', 'admin-1472610645-14726199791857821', 1, 0, '', NULL, NULL, NULL),
(6887, '2016-08-31 13:06:46', NULL, NULL, 2490, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 13:06:46', 'admin-1472610645-14726200063027947', 1, 1, 'SR', NULL, NULL, NULL),
(6888, '2016-08-31 13:23:02', NULL, NULL, 2491, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 13:23:02', 'admin-1472610645-14726209821736616', 1, 1, 'SR', NULL, NULL, NULL),
(6889, '2016-08-31 14:04:21', NULL, NULL, 2493, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 14:04:21', 'admin-1472610645-14726234610008437', 1, 0, '', NULL, NULL, NULL),
(6890, '2016-08-31 14:04:21', NULL, NULL, 2493, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 14:04:21', 'admin-1472610645-14726234610008437', 1, 1, 'SR', NULL, NULL, NULL),
(6891, '2016-08-31 14:19:06', NULL, NULL, 2494, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 14:19:06', 'admin-1472623467-14726243465701967', 1, 0, '', NULL, NULL, NULL),
(6892, '2016-08-31 14:23:40', NULL, NULL, 2494, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 14:23:40', 'admin-1472624610-14726246201054394', 1, 0, '', NULL, NULL, NULL),
(6893, '2016-08-31 20:42:06', NULL, NULL, 2511, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 20:42:06', 'admin-1472642327-14726473263619341', 1, 0, '', NULL, NULL, NULL),
(6894, '2016-08-31 15:17:28', NULL, NULL, 2497, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 15:17:28', 'admin-1472624610-14726278485849673', 1, 0, '', NULL, NULL, NULL),
(6895, '2016-08-31 15:17:28', NULL, NULL, 2497, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 15:17:28', 'admin-1472624610-14726278485849673', 1, 0, '', NULL, NULL, NULL),
(6896, '2016-08-31 15:17:28', NULL, NULL, 2497, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 15:17:28', 'admin-1472624610-14726278485849673', 1, 0, '', NULL, NULL, NULL),
(6897, '2016-08-31 15:17:28', NULL, NULL, 2497, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 15:17:28', 'admin-1472624610-14726278485849673', 1, 0, '', NULL, NULL, NULL),
(6898, '2016-08-31 15:58:11', NULL, NULL, 2498, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 15:58:11', 'admin-1472624610-14726302913412916', 1, 1, 'SR', NULL, NULL, NULL),
(6899, '2016-08-31 15:58:11', NULL, NULL, 2498, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 15:58:11', 'admin-1472624610-14726302913412916', 1, 0, '', NULL, NULL, NULL),
(6900, '2016-08-31 14:50:55', NULL, NULL, 2496, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 14:50:55', 'admin-1472624610-14726262551558153', 1, 0, '', NULL, NULL, NULL),
(6901, '2016-08-31 14:50:55', NULL, NULL, 2496, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 14:50:55', 'admin-1472624610-14726262551558153', 1, 0, '', NULL, NULL, NULL),
(6902, '2016-08-31 14:49:30', NULL, NULL, 2496, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 14:49:30', 'admin-1472624610-14726261700894810', 1, 1, 'SR', NULL, NULL, NULL),
(6903, '2016-08-31 14:49:30', NULL, NULL, 2496, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 14:49:30', 'admin-1472624610-14726261700894810', 1, 1, 'SR', NULL, NULL, NULL),
(6904, '2016-08-31 14:49:30', NULL, NULL, 2496, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 14:49:30', 'admin-1472624610-14726261700894810', 1, 1, 'SR', NULL, NULL, NULL),
(6905, '2016-08-31 14:40:26', NULL, NULL, 2495, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 14:40:26', 'admin-1472624610-14726256265454751', 1, 1, 'SR', NULL, NULL, NULL),
(6906, '2016-08-31 12:07:45', NULL, NULL, 2486, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 12:07:45', 'admin-1472610645-14726164652551341', 1, 1, 'SR', NULL, NULL, NULL),
(6907, '2016-08-31 12:07:45', NULL, NULL, 2486, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 12:07:45', 'admin-1472610645-14726164652551341', 1, 0, '', NULL, NULL, NULL),
(6908, '2016-08-31 12:25:55', NULL, NULL, 2487, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 12:25:55', 'admin-1472610645-14726175549532125', 1, 1, 'SR', NULL, NULL, NULL),
(6909, '2016-08-31 12:33:49', NULL, NULL, 2487, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 12:33:49', 'admin-1472610645-14726180293722488', 1, 1, 'SR', NULL, NULL, NULL),
(6910, '2016-08-31 12:26:27', NULL, NULL, 2487, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 12:26:27', 'admin-1472610645-14726175876107447', 1, 1, 'SR', NULL, NULL, NULL),
(6911, '2016-08-31 12:26:23', NULL, NULL, 2487, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 12:26:23', 'admin-1472610645-14726175828803822', 1, 1, 'SR', NULL, NULL, NULL),
(6912, '2016-08-31 12:26:23', NULL, NULL, 2487, 0, 79, '79', 'Summer Salad ', 'with bacon', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 12:26:23', 'admin-1472610645-14726175828803822', 1, 1, 'SR', NULL, NULL, NULL),
(6913, '2016-08-31 11:14:03', NULL, NULL, 2482, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 11:14:03', 'admin-1472610645-14726132430636549', 1, 0, '', NULL, NULL, NULL),
(6914, '2016-08-31 11:15:59', NULL, NULL, 2483, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 11:15:59', 'admin-1472610645-14726133590719961', 1, 1, 'SR', NULL, NULL, NULL),
(6915, '2016-08-31 11:47:36', NULL, NULL, 2484, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 11:47:36', 'admin-1472610645-14726152560033371', 1, 1, 'SR', NULL, NULL, NULL),
(6916, '2016-08-31 12:06:01', NULL, NULL, 2485, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 12:06:01', 'admin-1472610645-1472616360847597', 1, 0, '', NULL, NULL, NULL),
(6917, '2016-08-31 12:06:01', NULL, NULL, 2485, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 12:06:01', 'admin-1472610645-1472616360847597', 1, 0, '', NULL, NULL, NULL),
(6918, '2016-08-31 12:07:45', NULL, NULL, 2486, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 12:07:45', 'admin-1472610645-14726164652551341', 1, 1, 'SR', NULL, NULL, NULL),
(6919, '2016-08-31 10:10:41', NULL, NULL, 2473, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:10:41', 'admin-1472606948-14726094409886614', 1, 1, 'SR', NULL, NULL, NULL),
(6920, '2016-08-31 14:40:26', NULL, NULL, 2495, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 14:40:26', 'admin-1472624610-14726256265454751', 1, 0, '', NULL, NULL, NULL),
(6921, '2016-08-31 10:30:20', NULL, NULL, 2481, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:30:20', 'admin-1472609459-14726106201538740', 1, 1, 'SR', NULL, NULL, NULL),
(6922, '2016-08-31 10:30:20', NULL, NULL, 2481, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:30:20', 'admin-1472609459-14726106201538740', 1, 1, 'SR', NULL, NULL, NULL),
(6923, '2016-08-31 11:14:03', NULL, NULL, 2482, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 11:14:03', 'admin-1472610645-14726132430636549', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(6924, '2016-08-31 10:21:41', NULL, NULL, 2478, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:21:41', 'admin-1472609459-1472610101430519', 1, 0, '', NULL, NULL, NULL),
(6925, '2016-08-31 10:21:41', NULL, NULL, 2478, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:21:41', 'admin-1472609459-1472610101430519', 1, 0, '', NULL, NULL, NULL),
(6926, '2016-08-31 10:22:07', NULL, NULL, 2479, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:22:07', 'admin-1472609459-14726101277891768', 1, 0, '', NULL, NULL, NULL),
(6927, '2016-08-31 10:22:07', NULL, NULL, 2479, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:22:07', 'admin-1472609459-14726101277891768', 1, 1, 'SR', NULL, NULL, NULL),
(6928, '2016-08-31 10:23:12', NULL, NULL, 2480, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:23:12', 'admin-1472609459-14726101921908011', 1, 0, '', NULL, NULL, NULL),
(6929, '2016-08-31 10:23:12', NULL, NULL, 2480, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:23:12', 'admin-1472609459-14726101921908011', 1, 0, '', NULL, NULL, NULL),
(6930, '2016-08-31 10:30:20', NULL, NULL, 2481, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:30:20', 'admin-1472609459-14726106201538740', 1, 0, '', NULL, NULL, NULL),
(6931, '2016-08-31 10:30:20', NULL, NULL, 2481, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:30:20', 'admin-1472609459-14726106201538740', 1, 0, '', NULL, NULL, NULL),
(6932, '2016-08-31 10:00:05', NULL, NULL, 2471, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:00:05', 'admin-1472606948-14726088050087865', 1, 0, '', NULL, NULL, NULL),
(6933, '2016-08-31 10:00:26', NULL, NULL, 2471, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:00:26', 'admin-1472606948-14726088268079896', 1, 0, '', NULL, NULL, NULL),
(6934, '2016-08-31 10:00:26', NULL, NULL, 2471, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:00:26', 'admin-1472606948-14726088268079896', 1, 1, 'SR', NULL, NULL, NULL),
(6935, '2016-08-31 10:43:38', NULL, NULL, 2471, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:43:38', 'admin-1472610645-14726114183441852', 1, 1, 'SR', NULL, NULL, NULL),
(6936, '2016-08-31 10:04:50', NULL, NULL, 2472, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:04:50', 'admin-1472606948-14726090900556413', 1, 0, '', NULL, NULL, NULL),
(6937, '2016-08-31 10:04:50', NULL, NULL, 2472, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:04:50', 'admin-1472606948-14726090900556413', 1, 0, '', NULL, NULL, NULL),
(6938, '2016-08-31 10:04:50', NULL, NULL, 2472, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:04:50', 'admin-1472606948-14726090900556413', 1, 0, '', NULL, NULL, NULL),
(6939, '2016-08-31 10:04:50', NULL, NULL, 2472, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:04:50', 'admin-1472606948-14726090900556413', 1, 1, 'SR', NULL, NULL, NULL),
(6940, '2016-08-31 10:04:50', NULL, NULL, 2472, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:04:50', 'admin-1472606948-14726090900556413', 1, 1, 'SR', NULL, NULL, NULL),
(6941, '2016-08-31 10:10:41', NULL, NULL, 2473, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:10:41', 'admin-1472606948-14726094409886614', 1, 0, '', NULL, NULL, NULL),
(6942, '2016-08-31 10:43:11', NULL, NULL, 2476, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:43:11', 'admin-1472610645-14726113909107989', 1, 0, '', NULL, NULL, NULL),
(6943, '2016-08-31 10:21:08', NULL, NULL, 2477, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:21:08', 'admin-1472609459-14726100686347896', 1, 1, 'SR', 1, NULL, NULL),
(6944, '2016-08-31 10:19:53', NULL, NULL, 2475, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:19:53', 'admin-1472609459-14726099928726589', 1, 0, '', 1, NULL, NULL),
(6945, '2016-08-31 10:19:53', NULL, NULL, 2475, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:19:53', 'admin-1472609459-14726099928726589', 1, 0, '', 1, NULL, NULL),
(6946, '2016-08-31 10:13:46', NULL, NULL, 2474, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:13:46', 'admin-1472609459-14726096263662229', 1, 1, 'SR', NULL, NULL, NULL),
(6947, '2016-08-31 10:13:46', NULL, NULL, 2474, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:13:46', 'admin-1472609459-14726096263662229', 1, 1, 'SR', NULL, NULL, NULL),
(6948, '2016-08-31 10:10:41', NULL, NULL, 2473, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 10:10:41', 'admin-1472606948-14726094409886614', 1, 1, 'SR', NULL, NULL, NULL),
(6949, '2016-08-31 09:29:45', NULL, NULL, 2468, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 09:29:45', 'admin-1472606948-1472606985136381', 1, 0, '', NULL, NULL, NULL),
(6950, '2016-08-31 09:29:45', NULL, NULL, 2468, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 09:29:45', 'admin-1472606948-1472606985136381', 1, 0, '', NULL, NULL, NULL),
(6951, '2016-08-31 09:29:45', NULL, NULL, 2468, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 09:29:45', 'admin-1472606948-1472606985136381', 1, 0, '', NULL, NULL, NULL),
(6952, '2016-08-31 09:29:45', NULL, NULL, 2468, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 09:29:45', 'admin-1472606948-1472606985136381', 1, 0, '', NULL, NULL, NULL),
(6953, '2016-08-31 09:29:45', NULL, NULL, 2468, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 09:29:45', 'admin-1472606948-1472606985136381', 1, 1, 'SR', NULL, NULL, NULL),
(6954, '2016-08-31 09:31:14', NULL, NULL, 2470, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 09:31:14', 'admin-1472606948-14726070746089013', 1, 0, '', NULL, NULL, NULL),
(6955, '2016-08-31 09:27:26', NULL, NULL, 2469, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 09:27:26', 'admin-1472605428-1472606846288999', 1, 0, '', NULL, NULL, NULL),
(6956, '2016-08-31 09:27:26', NULL, NULL, 2469, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 09:27:26', 'admin-1472605428-1472606846288999', 1, 1, 'SR', NULL, NULL, NULL),
(6957, '2016-08-31 09:27:17', NULL, NULL, 2469, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472642327', 'admin', '2016-08-31 09:27:17', 'admin-1472605428-14726068369893749', 1, 0, '', NULL, NULL, NULL),
(6958, '2016-09-01 17:28:31', NULL, NULL, 2528, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 17:28:31', 'admin-1472701175-14727221115752920', 1, 1, 'SR', NULL, NULL, NULL),
(6959, '2016-09-01 16:29:53', NULL, NULL, 2526, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 16:29:53', 'admin-1472701175-1472718593199366', 1, 0, '', 1, NULL, NULL),
(6960, '2016-09-01 10:57:05', NULL, NULL, 2518, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 10:57:05', 'admin-1472691069-14726986256666670', 1, 1, 'SR', NULL, NULL, NULL),
(6961, '2016-09-01 16:29:59', NULL, NULL, 2526, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 16:29:59', 'admin-1472701175-14727185993411065', 1, 1, 'SR', 1, NULL, NULL),
(6962, '2016-09-01 17:09:15', NULL, NULL, 2527, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 17:09:15', 'admin-1472701175-14727209555671882', 1, 1, 'SR', 1, NULL, NULL),
(6963, '2016-09-01 12:35:19', NULL, NULL, 2522, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 12:35:19', 'admin-1472701175-14727045196174668', 1, 1, 'SR', NULL, NULL, NULL),
(6964, '2016-09-01 12:47:59', NULL, NULL, 2521, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 12:47:59', 'admin-1472701175-14727052793649765', 1, 1, 'SR', NULL, NULL, NULL),
(6965, '2016-09-01 12:41:08', NULL, NULL, 2521, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 12:41:08', 'admin-1472701175-1472704868478434', 1, 1, 'SR', NULL, NULL, NULL),
(6966, '2016-09-01 12:41:08', NULL, NULL, 2521, 0, 181, '116', 'Open Food ', 'Garlic Spicy Pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 12:41:08', 'admin-1472701175-1472704868478434', 1, 0, '', NULL, NULL, NULL),
(6967, '2016-09-01 12:48:30', NULL, NULL, 2523, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 12:48:30', 'admin-1472701175-14727053102043966', 1, 1, 'SR', NULL, NULL, '10.0'),
(6968, '2016-09-01 12:48:30', NULL, NULL, 2523, 0, 181, '116', 'Open Food ', 'Spicy Pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 12:48:30', 'admin-1472701175-14727053102043966', 1, 0, '', NULL, NULL, '10.0'),
(6969, '2016-09-01 15:59:04', NULL, NULL, 2524, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 15:59:04', 'admin-1472701175-1472716744188688', 1, 1, 'SR', NULL, NULL, NULL),
(6970, '2016-09-01 09:21:19', NULL, NULL, 2513, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 09:21:19', 'admin-1472691069-14726928792483216', 1, 0, '', NULL, NULL, NULL),
(6971, '2016-09-01 09:51:52', NULL, NULL, 2514, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 09:51:52', 'admin-1472691069-14726947124256316', 1, 0, '', 1, NULL, NULL),
(6972, '2016-09-01 09:51:52', NULL, NULL, 2514, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 09:51:52', 'admin-1472691069-14726947124256316', 1, 0, '', 1, NULL, NULL),
(6973, '2016-09-01 09:59:20', NULL, NULL, 2515, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 09:59:20', 'admin-1472691069-14726951601046764', 1, 0, '', NULL, NULL, NULL),
(6974, '2016-09-01 09:59:20', NULL, NULL, 2515, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 09:59:20', 'admin-1472691069-14726951601046764', 1, 0, '', NULL, NULL, NULL),
(6975, '2016-09-01 09:59:20', NULL, NULL, 2515, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 09:59:20', 'admin-1472691069-14726951601046764', 1, 0, '', NULL, NULL, NULL),
(6976, '2016-09-01 09:59:20', NULL, NULL, 2515, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 09:59:20', 'admin-1472691069-14726951601046764', 1, 0, '', NULL, NULL, NULL),
(6977, '2016-09-01 10:00:44', NULL, NULL, 2515, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 10:00:44', 'admin-1472691069-14726952439648870', 1, 1, 'SR', NULL, NULL, NULL),
(6978, '2016-09-01 10:00:59', NULL, NULL, 2515, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 10:00:59', 'admin-1472691069-14726952590741826', 1, 0, '', NULL, NULL, NULL),
(6979, '2016-09-01 10:37:30', NULL, NULL, 2516, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 10:37:30', 'admin-1472691069-14726974498537324', 1, 1, 'SR', 1, NULL, NULL),
(6980, '2016-09-01 17:28:31', NULL, NULL, 2528, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 17:28:31', 'admin-1472701175-14727221115752920', 1, 1, 'SR', NULL, NULL, NULL),
(6981, '2016-09-01 16:21:39', NULL, NULL, 2525, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 16:21:39', 'admin-1472701175-14727180994554497', 1, 1, 'SR', 1, NULL, NULL),
(6982, '2016-09-01 15:59:04', NULL, NULL, 2524, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 15:59:04', 'admin-1472701175-1472716744188688', 1, 1, 'SR', NULL, NULL, NULL),
(6983, '2016-09-01 11:39:13', NULL, NULL, 2519, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 11:39:13', 'admin-1472691069-14727011538086771', 1, 0, '', NULL, NULL, NULL),
(6984, '2016-09-01 12:35:19', NULL, NULL, 2522, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 12:35:19', 'admin-1472701175-14727045196174668', 1, 1, 'SR', NULL, NULL, NULL),
(6985, '2016-09-01 11:51:42', NULL, NULL, 2520, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 11:51:42', 'admin-1472701175-14727019023025012', 1, 1, 'SR', 1, NULL, NULL),
(6986, '2016-09-01 12:15:46', NULL, NULL, 2521, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 12:15:46', 'admin-1472701175-14727033464068239', 1, 1, 'SR', NULL, NULL, NULL),
(6987, '2016-09-01 11:39:13', NULL, NULL, 2519, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 11:39:13', 'admin-1472691069-14727011538086771', 1, 1, 'SR', NULL, NULL, NULL),
(6988, '2016-09-01 11:39:13', NULL, NULL, 2519, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 11:39:13', 'admin-1472691069-14727011538086771', 1, 0, '', NULL, NULL, NULL),
(6989, '2016-09-01 10:57:05', NULL, NULL, 2518, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 10:57:05', 'admin-1472691069-14726986256666670', 1, 1, 'SR', NULL, NULL, NULL),
(6990, '2016-09-01 10:43:25', NULL, NULL, 2517, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 10:43:25', 'admin-1472691069-14726978055683710', 1, 0, '', NULL, NULL, NULL),
(6991, '2016-09-01 10:43:25', NULL, NULL, 2517, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 10:43:25', 'admin-1472691069-14726978055683710', 1, 0, '', NULL, NULL, NULL),
(6992, '2016-09-01 10:43:13', NULL, NULL, 2517, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 10:43:13', 'admin-1472691069-14726977936184048', 1, 0, '', NULL, NULL, NULL),
(6993, '2016-09-01 10:43:13', NULL, NULL, 2517, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 10:43:13', 'admin-1472691069-14726977936184048', 1, 0, '', NULL, NULL, NULL),
(6994, '2016-09-01 09:21:03', NULL, NULL, 2513, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 09:21:03', 'admin-1472691069-14726928634564353', 1, 1, 'SR', NULL, NULL, NULL),
(6995, '2016-09-01 09:02:08', NULL, NULL, 2512, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 09:02:08', 'admin-1472691069-14726917279845420', 1, 1, 'SR', NULL, NULL, NULL),
(6996, '2016-09-01 09:02:08', NULL, NULL, 2512, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472701175', 'admin', '2016-09-01 09:02:08', 'admin-1472691069-14726917279845420', 1, 0, '', NULL, NULL, NULL),
(6997, '2016-09-02 21:23:33', NULL, NULL, 2553, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 21:23:33', 'admin-1472820082-1472822613681102', 1, 0, '', NULL, NULL, NULL),
(6998, '2016-09-02 19:30:09', NULL, NULL, 2550, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 2, 15.00, 45.0000, 0.0000, 30.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 19:30:09', 'admin-1472804577-1472815809502783', 1, 0, '', NULL, NULL, '10.0'),
(6999, '2016-09-02 19:30:09', NULL, NULL, 2550, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 19:30:09', 'admin-1472804577-1472815809502783', 1, 0, '', NULL, NULL, '10.0'),
(7000, '2016-09-02 19:30:09', NULL, NULL, 2550, 0, 181, '116', 'Open Food ', 'Spicy Pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 19:30:09', 'admin-1472804577-1472815809502783', 1, 0, '', NULL, NULL, '10.0'),
(7001, '2016-09-02 19:30:09', NULL, NULL, 2550, NULL, 58, '58', 'House White Bottle', '', 'Cold Drinks', 'Wine', 1, 88.00, 88.0000, 0.0000, 88.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 19:30:09', 'admin-1472804577-1472815809502783', 1, 1, 'SR', NULL, NULL, '10.0'),
(7002, '2016-09-02 19:53:13', NULL, NULL, 2549, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 19:53:13', 'admin-1472804577-14728171932633066', 1, 1, 'SR', NULL, NULL, NULL),
(7003, '2016-09-02 19:53:34', NULL, NULL, 2549, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 19:53:34', 'admin-1472804577-14728172142088414', 1, 0, '', NULL, NULL, NULL),
(7004, '2016-09-02 20:32:17', NULL, NULL, 2550, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 20:32:17', 'admin-1472804577-14728195370718449', 1, 0, '', NULL, NULL, '10.0'),
(7005, '2016-09-02 20:32:38', NULL, NULL, 2550, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 20:32:38', 'admin-1472804577-14728195582094033', 1, 0, '', NULL, NULL, '10.0'),
(7006, '2016-09-02 20:32:38', NULL, NULL, 2550, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 20:32:38', 'admin-1472804577-14728195582094033', 1, 0, '', NULL, NULL, '10.0'),
(7007, '2016-09-02 00:00:00', NULL, NULL, 2552, 0, 182, '117', 'Open Drinks ', 'Riesling', 'Desserts', '0', 1, 100.00, NULL, NULL, 100.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 17:43:13', 'admin-1472804577-1472809393192438', 1, 0, '', NULL, NULL, NULL),
(7008, '2016-09-02 20:37:06', NULL, NULL, 2553, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 20:37:06', 'admin-1472804577-1472819826104978', 1, 0, '', NULL, NULL, NULL),
(7009, '2016-09-02 20:37:06', NULL, NULL, 2553, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 20:37:06', 'admin-1472804577-1472819826104978', 1, 1, 'SR', NULL, NULL, NULL),
(7010, '2016-09-02 20:37:06', NULL, NULL, 2553, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 20:37:06', 'admin-1472804577-1472819826104978', 1, 1, 'SR', NULL, NULL, NULL),
(7011, '2016-09-02 20:37:06', NULL, NULL, 2553, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 20:37:06', 'admin-1472804577-1472819826104978', 1, 1, 'SR', NULL, NULL, NULL),
(7012, '2016-09-02 20:40:52', NULL, NULL, 2554, 0, 198, '133', 'Dinner - Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 20:40:52', 'admin-1472804577-14728200526874259', 1, 0, '', NULL, NULL, NULL),
(7013, '2016-09-02 13:42:17', NULL, NULL, 2544, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 13:42:17', 'admin-1472786533-14727949376388328', 1, 0, '', NULL, NULL, NULL),
(7014, '2016-09-02 13:42:17', NULL, NULL, 2544, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 13:42:17', 'admin-1472786533-14727949376388328', 1, 0, '', NULL, NULL, NULL),
(7015, '2016-09-02 13:42:17', NULL, NULL, 2544, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 13:42:17', 'admin-1472786533-14727949376388328', 1, 0, '', NULL, NULL, NULL),
(7016, '2016-09-02 13:43:24', NULL, NULL, 2544, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 13:43:24', 'admin-1472794964-14727950046217753', 1, 1, 'SR', NULL, NULL, NULL),
(7017, '2016-09-02 14:08:42', NULL, NULL, 2545, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 14:08:42', 'admin-1472794964-14727965221003788', 1, 0, '', NULL, NULL, NULL),
(7018, '2016-09-02 14:08:42', NULL, NULL, 2545, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 14:08:42', 'admin-1472794964-14727965221003788', 1, 1, 'SR', NULL, NULL, NULL),
(7019, '2016-09-02 14:10:44', NULL, NULL, 2546, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 14:10:44', 'admin-1472794964-14727966441197229', 1, 1, 'SR', NULL, NULL, NULL),
(7020, '2016-09-02 14:10:54', NULL, NULL, 2546, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 14:10:54', 'admin-1472794964-14727966538736324', 1, 1, 'SR', NULL, NULL, NULL),
(7021, '2016-09-02 14:24:04', NULL, NULL, 2547, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 14:24:04', 'admin-1472794964-14727974440391714', 1, 0, '', NULL, NULL, NULL),
(7022, '2016-09-02 14:24:04', NULL, NULL, 2547, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 14:24:04', 'admin-1472794964-14727974440391714', 1, 1, 'SR', NULL, NULL, NULL),
(7023, '2016-09-02 14:24:04', NULL, NULL, 2547, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 14:24:04', 'admin-1472794964-14727974440391714', 1, 1, 'SR', NULL, NULL, NULL),
(7024, '2016-09-02 14:24:04', NULL, NULL, 2547, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 14:24:04', 'admin-1472794964-14727974440391714', 1, 1, 'SR', NULL, NULL, NULL),
(7025, '2016-09-02 20:40:52', NULL, NULL, 2554, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 20:40:52', 'admin-1472804577-14728200526874259', 1, 0, '', NULL, NULL, NULL),
(7026, '2016-09-02 20:59:10', NULL, NULL, 2555, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 20:59:10', 'admin-1472820082-1472821150588256', 1, 0, '', 1, NULL, NULL),
(7027, '2016-09-02 16:17:04', NULL, NULL, 2549, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 16:17:04', 'admin-1472794964-14728042242772792', 1, 1, 'SR', NULL, NULL, NULL),
(7028, '2016-09-02 20:37:06', NULL, NULL, 2553, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 20:37:06', 'admin-1472804577-1472819826104978', 1, 1, 'SR', NULL, NULL, NULL),
(7029, '2016-09-02 17:45:18', NULL, NULL, 2551, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 17:45:18', 'admin-1472804577-14728095184749294', 1, 0, '', NULL, NULL, NULL),
(7030, '2016-09-02 19:16:47', NULL, NULL, 2550, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 19:16:47', 'admin-1472804577-14728150072099579', 1, 0, '', NULL, NULL, '10.0'),
(7031, '2016-09-02 19:16:47', NULL, NULL, 2550, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 19:16:47', 'admin-1472804577-14728150072099579', 1, 0, '', NULL, NULL, '10.0'),
(7032, '2016-09-02 19:16:47', NULL, NULL, 2550, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 19:16:47', 'admin-1472804577-14728150072099579', 1, 1, 'SR', NULL, NULL, '10.0'),
(7033, '2016-09-02 16:17:04', NULL, NULL, 2549, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 16:17:04', 'admin-1472794964-14728042242772792', 1, 1, 'SR', NULL, NULL, NULL),
(7034, '2016-09-02 15:58:12', NULL, NULL, 2548, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 15:58:12', 'admin-1472794964-14728030918566758', 1, 0, '', NULL, NULL, NULL),
(7035, '2016-09-02 15:58:12', NULL, NULL, 2548, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 15:58:12', 'admin-1472794964-14728030918566758', 1, 1, 'SR', NULL, NULL, NULL),
(7036, '2016-09-02 14:52:44', NULL, NULL, 2545, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 14:52:44', 'admin-1472794964-14727991643537433', 1, 1, 'SR', NULL, NULL, NULL),
(7037, '2016-09-02 11:46:31', NULL, NULL, 2538, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 11:46:31', 'admin-1472786533-14727879915052875', 1, 1, 'SR', NULL, NULL, NULL),
(7038, '2016-09-02 11:46:31', NULL, NULL, 2538, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 11:46:31', 'admin-1472786533-14727879915052875', 1, 1, 'SR', NULL, NULL, NULL),
(7039, '2016-09-02 11:46:31', NULL, NULL, 2538, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 11:46:31', 'admin-1472786533-14727879915052875', 1, 1, 'SR', NULL, NULL, NULL),
(7040, '2016-09-02 11:46:31', NULL, NULL, 2538, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 11:46:31', 'admin-1472786533-14727879915052875', 1, 1, 'SR', NULL, NULL, NULL),
(7041, '2016-09-02 12:29:30', NULL, NULL, 2541, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 12:29:30', 'admin-1472786533-14727905701318048', 1, 1, 'SR', NULL, NULL, '10.0'),
(7042, '2016-09-02 11:43:23', NULL, NULL, 2540, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 11:43:23', 'admin-1472786533-14727878031766564', 1, 1, 'SR', NULL, NULL, NULL),
(7043, '2016-09-02 12:52:32', NULL, NULL, 2541, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 12:52:32', 'admin-1472786533-14727919523345788', 1, 0, '', NULL, NULL, '10.0'),
(7044, '2016-09-02 12:52:32', NULL, NULL, 2541, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 12:52:32', 'admin-1472786533-14727919523345788', 1, 1, 'SR', NULL, NULL, '10.0'),
(7045, '2016-09-02 13:05:02', NULL, NULL, 2542, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 13:05:02', 'admin-1472786533-14727927025045416', 1, 1, 'SR', NULL, NULL, NULL),
(7046, '2016-09-02 13:05:02', NULL, NULL, 2542, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 13:05:02', 'admin-1472786533-14727927025045416', 1, 1, 'SR', NULL, NULL, NULL),
(7047, '2016-09-02 13:06:51', NULL, NULL, 2542, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 13:06:51', 'admin-1472786533-14727928116913869', 1, 1, 'SR', NULL, NULL, NULL),
(7048, '2016-09-02 13:08:22', NULL, NULL, 2543, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 13:08:22', 'admin-1472786533-14727929020431754', 1, 0, '', NULL, NULL, NULL),
(7049, '2016-09-02 13:08:22', NULL, NULL, 2543, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 13:08:22', 'admin-1472786533-14727929020431754', 1, 1, 'SR', NULL, NULL, NULL),
(7050, '2016-09-02 13:31:47', NULL, NULL, 2542, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 13:31:47', 'admin-1472786533-14727943071477071', 1, 0, '', NULL, NULL, NULL),
(7051, '2016-09-02 13:42:17', NULL, NULL, 2544, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 13:42:17', 'admin-1472786533-14727949376388328', 1, 0, '', NULL, NULL, NULL),
(7052, '2016-09-02 12:29:30', NULL, NULL, 2541, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 12:29:30', 'admin-1472786533-14727905701318048', 1, 1, 'SR', NULL, NULL, '10.0'),
(7053, '2016-09-02 12:39:58', NULL, NULL, 2541, 0, 181, '116', 'Open Food ', 'carrot pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 12:39:58', 'admin-1472786533-14727911978516779', 1, 0, '', NULL, NULL, '10.0'),
(7054, '2016-09-02 12:29:30', NULL, NULL, 2541, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 12:29:30', 'admin-1472786533-14727905701318048', 1, 0, '', NULL, NULL, '10.0'),
(7055, '2016-09-02 11:43:23', NULL, NULL, 2540, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 11:43:23', 'admin-1472786533-14727878031766564', 1, 1, 'SR', NULL, NULL, NULL),
(7056, '2016-09-02 10:12:46', NULL, NULL, 2535, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 10:12:46', 'admin-1472777808-14727823665121951', 1, 1, 'SR', NULL, NULL, NULL),
(7057, '2016-09-02 10:30:44', NULL, NULL, 2536, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 10:30:44', 'admin-1472777808-14727834442554279', 1, 0, '', NULL, NULL, NULL),
(7058, '2016-09-02 10:30:44', NULL, NULL, 2536, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 10:30:44', 'admin-1472777808-14727834442554279', 1, 0, '', NULL, NULL, NULL),
(7059, '2016-09-02 10:30:44', NULL, NULL, 2536, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 10:30:44', 'admin-1472777808-14727834442554279', 1, 0, '', NULL, NULL, NULL),
(7060, '2016-09-02 10:30:44', NULL, NULL, 2536, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 10:30:44', 'admin-1472777808-14727834442554279', 1, 1, 'SR', NULL, NULL, NULL),
(7061, '2016-09-02 11:06:09', NULL, NULL, 2537, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 11:06:09', 'admin-1472777808-14727855693581098', 1, 1, 'SR', NULL, NULL, NULL),
(7062, '2016-09-02 11:06:09', NULL, NULL, 2537, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 11:06:09', 'admin-1472777808-14727855693581098', 1, 1, 'SR', NULL, NULL, NULL),
(7063, '2016-09-02 11:20:04', NULL, NULL, 2538, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 11:20:04', 'admin-1472777808-14727864045337198', 1, 0, '', NULL, NULL, NULL),
(7064, '2016-09-02 11:22:25', NULL, NULL, 2539, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 11:22:25', 'admin-1472786533-14727865456858529', 1, 1, 'SR', NULL, NULL, NULL),
(7065, '2016-09-02 09:04:45', NULL, NULL, 2529, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 09:04:45', 'admin-1472777808-14727782850449028', 1, 1, 'SR', NULL, NULL, NULL),
(7066, '2016-09-02 12:29:30', NULL, NULL, 2541, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 12:29:30', 'admin-1472786533-14727905701318048', 1, 0, '', NULL, NULL, '10.0'),
(7067, '2016-09-02 12:29:30', NULL, NULL, 2541, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 12:29:30', 'admin-1472786533-14727905701318048', 1, 1, 'SR', NULL, NULL, '10.0'),
(7068, '2016-09-02 12:29:30', NULL, NULL, 2541, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 12:29:30', 'admin-1472786533-14727905701318048', 1, 1, 'SR', NULL, NULL, '10.0'),
(7069, '2016-09-02 12:29:30', NULL, NULL, 2541, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 12:29:30', 'admin-1472786533-14727905701318048', 1, 1, 'SR', NULL, NULL, '10.0'),
(7070, '2016-09-02 12:29:30', NULL, NULL, 2541, 0, 181, '116', 'Open Food ', 'carrot pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 12:29:30', 'admin-1472786533-14727905701318048', 1, 0, '', NULL, NULL, '10.0'),
(7071, '2016-09-02 12:29:30', NULL, NULL, 2541, 0, 181, '116', 'Open Food ', 'spicy pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 12:29:30', 'admin-1472786533-14727905701318048', 1, 0, '', NULL, NULL, '10.0'),
(7072, '2016-09-02 12:29:30', NULL, NULL, 2541, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 12:29:30', 'admin-1472786533-14727905701318048', 1, 0, '', NULL, NULL, '10.0'),
(7073, '2016-09-02 11:22:25', NULL, NULL, 2539, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 11:22:25', 'admin-1472786533-14727865456858529', 1, 1, 'SR', NULL, NULL, NULL),
(7074, '2016-09-02 10:07:45', NULL, NULL, 2534, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 10:07:45', 'admin-1472777808-14727820651563579', 1, 0, '', NULL, NULL, NULL),
(7075, '2016-09-02 10:07:45', NULL, NULL, 2534, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 10:07:45', 'admin-1472777808-14727820651563579', 1, 0, '', NULL, NULL, NULL),
(7076, '2016-09-02 09:54:02', NULL, NULL, 2533, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 09:54:02', 'admin-1472777808-14727812420807533', 1, 1, 'SR', NULL, NULL, NULL),
(7077, '2016-09-02 09:54:02', NULL, NULL, 2533, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 09:54:02', 'admin-1472777808-14727812420807533', 1, 1, 'SR', NULL, NULL, NULL),
(7078, '2016-09-02 09:54:02', NULL, NULL, 2533, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 09:54:02', 'admin-1472777808-14727812420807533', 1, 0, '', NULL, NULL, NULL),
(7079, '2016-09-02 09:54:02', NULL, NULL, 2533, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 09:54:02', 'admin-1472777808-14727812420807533', 1, 0, '', NULL, NULL, NULL),
(7080, '2016-09-02 09:44:51', NULL, NULL, 2532, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 09:44:51', 'admin-1472777808-14727806915298958', 1, 1, 'SR', NULL, NULL, NULL),
(7081, '2016-09-02 09:27:51', NULL, NULL, 2531, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 09:27:51', 'admin-1472777808-14727796715783243', 1, 1, 'SR', 1, NULL, NULL),
(7082, '2016-09-02 09:11:43', NULL, NULL, 2530, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 09:11:43', 'admin-1472777808-14727787027952072', 1, 1, 'SR', NULL, NULL, NULL),
(7083, '2016-09-02 09:11:42', NULL, NULL, 2530, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 09:11:42', 'admin-1472777808-14727787027952072', 1, 0, '', NULL, NULL, NULL),
(7084, '2016-09-02 09:11:43', NULL, NULL, 2530, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 09:11:43', 'admin-1472777808-14727787027952072', 1, 1, 'SR', NULL, NULL, NULL),
(7085, '2016-09-02 09:04:45', NULL, NULL, 2529, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 09:04:45', 'admin-1472777808-14727782850449028', 1, 0, '', NULL, NULL, NULL),
(7086, '2016-09-02 09:03:57', NULL, NULL, 2529, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 09:03:57', 'admin-1472777808-14727782368927792', 1, 0, '', NULL, NULL, NULL),
(7087, '2016-09-02 09:03:57', NULL, NULL, 2529, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472820082', 'admin', '2016-09-02 09:03:57', 'admin-1472777808-14727782368927792', 1, 0, '', NULL, NULL, NULL),
(7088, '2016-09-03 20:22:33', NULL, NULL, 2597, 0, 181, '116', 'Open Food ', 'cockage', 'Meals', 'Perfect Meals', 1, 50.00, 50.0000, 0.0000, 50.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 20:22:33', 'admin-1472879469-1472905352991961', 1, 0, '', NULL, NULL, '10.0'),
(7089, '2016-09-03 19:53:38', NULL, NULL, 2596, NULL, 57, '57', 'House Red Bottle', '', 'Cold Drinks', 'Wine', 1, 88.00, 88.0000, 0.0000, 88.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 19:53:38', 'admin-1472879469-14729036187365396', 1, 1, 'SR', NULL, NULL, NULL),
(7090, '2016-09-03 19:52:18', NULL, NULL, 2596, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 19:52:18', 'admin-1472879469-1472903538346638', 1, 0, '', NULL, NULL, NULL),
(7091, '2016-09-03 19:52:18', NULL, NULL, 2596, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 19:52:18', 'admin-1472879469-1472903538346638', 1, 0, '', NULL, NULL, NULL),
(7092, '2016-09-03 19:52:18', NULL, NULL, 2596, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 19:52:18', 'admin-1472879469-1472903538346638', 1, 0, '', NULL, NULL, NULL),
(7093, '2016-09-03 17:48:52', NULL, NULL, 2595, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 17:48:52', 'admin-1472879469-14728961324127714', 1, 1, 'SR', NULL, NULL, NULL),
(7094, '2016-09-03 17:45:34', NULL, NULL, 2594, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 17:45:34', 'admin-1472879469-1472895934408723', 1, 1, 'SR', NULL, NULL, NULL),
(7095, '2016-09-03 17:05:50', NULL, NULL, 2593, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 17:05:50', 'admin-1472879469-14728935507227088', 1, 1, 'SR', NULL, NULL, NULL),
(7096, '2016-09-03 16:20:11', NULL, NULL, 2592, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 16:20:11', 'admin-1472879469-14728908108094854', 1, 1, 'SR', NULL, NULL, NULL),
(7097, '2016-09-03 16:20:11', NULL, NULL, 2592, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 16:20:11', 'admin-1472879469-14728908108094854', 1, 1, 'SR', NULL, NULL, NULL),
(7098, '2016-09-03 15:38:59', NULL, NULL, 2591, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 15:38:59', 'admin-1472879469-14728883397197668', 1, 0, '', NULL, NULL, NULL),
(7099, '2016-09-03 15:38:59', NULL, NULL, 2591, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 15:38:59', 'admin-1472879469-14728883397197668', 1, 1, 'SR', NULL, NULL, NULL),
(7100, '2016-09-03 15:32:55', NULL, NULL, 2590, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 15:32:55', 'admin-1472879469-14728879751933148', 1, 1, 'SR', NULL, NULL, NULL),
(7101, '2016-09-03 15:32:18', NULL, NULL, 2585, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 15:32:18', 'admin-1472879469-1472887937933372', 1, 1, 'SR', NULL, NULL, NULL),
(7102, '2016-09-03 14:58:05', NULL, NULL, 2587, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 14:58:05', 'admin-1472879469-14728858854769961', 1, 1, 'SR', NULL, NULL, NULL),
(7103, '2016-09-03 15:01:50', NULL, NULL, 2588, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 15:01:50', 'admin-1472879469-14728861100165423', 1, 0, '', NULL, NULL, NULL),
(7104, '2016-09-03 14:14:10', NULL, NULL, 2585, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 14:14:10', 'admin-1472879469-14728832505575393', 1, 0, '', NULL, NULL, NULL),
(7105, '2016-09-03 14:14:10', NULL, NULL, 2585, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 14:14:10', 'admin-1472879469-14728832505575393', 1, 1, 'SR', NULL, NULL, NULL),
(7106, '2016-09-03 14:14:26', NULL, NULL, 2585, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 14:14:26', 'admin-1472879469-14728832659031321', 1, 0, '', NULL, NULL, NULL),
(7107, '2016-09-03 14:42:25', NULL, NULL, 2586, 0, 181, '116', 'Open Food ', 'spicy pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 14:42:25', 'admin-1472879469-14728849451407284', 1, 0, '', NULL, NULL, NULL),
(7108, '2016-09-03 14:42:25', NULL, NULL, 2586, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 14:42:25', 'admin-1472879469-14728849451407284', 1, 1, 'SR', NULL, NULL, NULL),
(7109, '2016-09-03 14:57:49', NULL, NULL, 2587, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 14:57:49', 'admin-1472879469-14728858697668926', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(7110, '2016-09-03 14:57:49', NULL, NULL, 2587, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 14:57:49', 'admin-1472879469-14728858697668926', 1, 1, 'SR', NULL, NULL, NULL),
(7111, '2016-09-03 20:28:23', NULL, NULL, 2598, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 20:28:23', 'admin-1472879469-14729057033267237', 1, 0, '', NULL, NULL, NULL),
(7112, '2016-09-03 20:28:23', NULL, NULL, 2598, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 20:28:23', 'admin-1472879469-14729057033267237', 1, 1, 'SR', NULL, NULL, NULL),
(7113, '2016-09-03 21:00:21', NULL, NULL, 2599, NULL, 58, '58', 'House White Bottle', '', 'Cold Drinks', 'Wine', 1, 88.00, 88.0000, 0.0000, 88.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 21:00:21', 'admin-1472879469-14729076210487362', 1, 1, 'SR', NULL, NULL, NULL),
(7114, '2016-09-03 21:00:30', NULL, NULL, 2600, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 21:00:30', 'admin-1472879469-14729076304664882', 1, 1, 'SR', NULL, NULL, NULL),
(7115, '2016-09-03 13:12:39', NULL, NULL, 2576, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:12:39', 'admin-1472879469-14728795589484323', 1, 1, 'SR', NULL, NULL, NULL),
(7116, '2016-09-03 13:12:39', NULL, NULL, 2576, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:12:39', 'admin-1472879469-14728795589484323', 1, 1, 'SR', NULL, NULL, NULL),
(7117, '2016-09-03 13:13:24', NULL, NULL, 2577, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:13:24', 'admin-1472879469-14728796045706435', 1, 0, '', NULL, NULL, NULL),
(7118, '2016-09-03 13:13:24', NULL, NULL, 2577, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:13:24', 'admin-1472879469-14728796045706435', 1, 1, 'SR', NULL, NULL, NULL),
(7119, '2016-09-03 13:14:11', NULL, NULL, 2578, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:14:11', 'admin-1472879469-14728796512392252', 1, 0, '', NULL, NULL, NULL),
(7120, '2016-09-03 13:14:11', NULL, NULL, 2578, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:14:11', 'admin-1472879469-14728796512392252', 1, 0, '', NULL, NULL, NULL),
(7121, '2016-09-03 13:15:02', NULL, NULL, 2579, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:15:02', 'admin-1472879469-14728797023722314', 1, 1, 'SR', NULL, NULL, NULL),
(7122, '2016-09-03 13:15:02', NULL, NULL, 2579, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:15:02', 'admin-1472879469-14728797023722314', 1, 1, 'SR', NULL, NULL, NULL),
(7123, '2016-09-03 13:15:09', NULL, NULL, 2579, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:15:09', 'admin-1472879469-14728797091769510', 1, 0, '', NULL, NULL, NULL),
(7124, '2016-09-03 13:19:03', NULL, NULL, 2580, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:19:03', 'admin-1472879469-14728799437129268', 1, 0, '', NULL, NULL, NULL),
(7125, '2016-09-03 13:19:03', NULL, NULL, 2580, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:19:03', 'admin-1472879469-14728799437129268', 1, 1, 'SR', NULL, NULL, NULL),
(7126, '2016-09-03 13:19:03', NULL, NULL, 2580, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:19:03', 'admin-1472879469-14728799437129268', 1, 1, 'SR', NULL, NULL, NULL),
(7127, '2016-09-03 13:19:03', NULL, NULL, 2580, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:19:03', 'admin-1472879469-14728799437129268', 1, 0, '', NULL, NULL, NULL),
(7128, '2016-09-03 13:36:12', NULL, NULL, 2581, 0, 154, '88', 'House BLT', 'take away', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:36:12', 'admin-1472879469-14728809722396573', 1, 0, '', NULL, NULL, NULL),
(7129, '2016-09-03 13:36:12', NULL, NULL, 2581, 0, 154, '88', 'House BLT', 'take away', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:36:12', 'admin-1472879469-14728809722396573', 1, 0, '', NULL, NULL, NULL),
(7130, '2016-09-03 11:49:44', NULL, NULL, 2568, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:49:44', 'admin-1472866970-14728745838412458', 1, 0, '', NULL, NULL, NULL),
(7131, '2016-09-03 11:49:44', NULL, NULL, 2568, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:49:44', 'admin-1472866970-14728745838412458', 1, 0, '', NULL, NULL, NULL),
(7132, '2016-09-03 11:49:44', NULL, NULL, 2568, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:49:44', 'admin-1472866970-14728745838412458', 1, 0, '', NULL, NULL, NULL),
(7133, '2016-09-03 11:49:44', NULL, NULL, 2568, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:49:44', 'admin-1472866970-14728745838412458', 1, 1, 'SR', NULL, NULL, NULL),
(7134, '2016-09-03 11:50:03', NULL, NULL, 2568, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:50:03', 'admin-1472866970-14728746030141986', 1, 0, '', NULL, NULL, NULL),
(7135, '2016-09-03 11:50:03', NULL, NULL, 2568, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:50:03', 'admin-1472866970-14728746030141986', 1, 0, '', NULL, NULL, NULL),
(7136, '2016-09-03 11:50:58', NULL, NULL, 2568, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:50:58', 'admin-1472874616-1472874658168803', 1, 1, 'SR', NULL, NULL, NULL),
(7137, '2016-09-03 12:46:59', NULL, NULL, 2569, 0, 181, '116', 'Open Food ', 'spicy pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 12:46:59', 'admin-1472874616-1472878019220319', 1, 0, '', NULL, NULL, NULL),
(7138, '2016-09-03 12:46:59', NULL, NULL, 2569, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 12:46:59', 'admin-1472874616-1472878019220319', 1, 1, 'SR', NULL, NULL, NULL),
(7139, '2016-09-03 12:58:28', NULL, NULL, 2570, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 12:58:28', 'admin-1472874616-14728787083136953', 1, 1, 'SR', NULL, NULL, NULL),
(7140, '2016-09-03 13:07:53', NULL, NULL, 2571, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:07:53', 'admin-1472874616-14728792733854635', 1, 0, '', NULL, NULL, NULL),
(7141, '2016-09-03 21:56:12', NULL, NULL, 2599, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 21:56:12', 'admin-1472879469-14729109720521523', 1, 1, 'SR', NULL, NULL, NULL),
(7142, '2016-09-03 00:00:00', NULL, NULL, 2601, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 21:00:30', 'admin-1472879469-14729076304664882', 1, 1, 'SR', NULL, NULL, NULL),
(7143, '2016-09-03 21:56:12', NULL, NULL, 2599, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 21:56:12', 'admin-1472879469-14729109720521523', 1, 1, 'SR', NULL, NULL, NULL),
(7144, '2016-09-03 20:28:23', NULL, NULL, 2598, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 20:28:23', 'admin-1472879469-14729057033267237', 1, 0, '', NULL, NULL, NULL),
(7145, '2016-09-03 20:28:23', NULL, NULL, 2598, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 20:28:23', 'admin-1472879469-14729057033267237', 1, 0, '', NULL, NULL, NULL),
(7146, '2016-09-03 20:22:33', NULL, NULL, 2597, 0, 181, '116', 'Open Food ', 'Chicken In the Blanket', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 20:22:33', 'admin-1472879469-1472905352991961', 1, 0, '', NULL, NULL, '10.0'),
(7147, '2016-09-03 20:51:06', NULL, NULL, 2597, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 20:51:06', 'admin-1472879469-14729070663699745', 1, 0, '', NULL, NULL, '10.0'),
(7148, '2016-09-03 20:22:33', NULL, NULL, 2597, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 20:22:33', 'admin-1472879469-1472905352991961', 1, 0, '', NULL, NULL, '10.0'),
(7149, '2016-09-03 20:22:33', NULL, NULL, 2597, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 20:22:33', 'admin-1472879469-1472905352991961', 1, 0, '', NULL, NULL, '10.0'),
(7150, '2016-09-03 20:22:33', NULL, NULL, 2597, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 20:22:33', 'admin-1472879469-1472905352991961', 1, 0, '', NULL, NULL, '10.0'),
(7151, '2016-09-03 20:22:33', NULL, NULL, 2597, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 20:22:33', 'admin-1472879469-1472905352991961', 1, 0, '', NULL, NULL, '10.0'),
(7152, '2016-09-03 15:32:18', NULL, NULL, 2585, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 15:32:18', 'admin-1472879469-1472887937933372', 1, 1, 'SR', NULL, NULL, NULL),
(7153, '2016-09-03 15:27:30', NULL, NULL, 2589, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 15:27:30', 'admin-1472879469-14728876499597784', 1, 1, 'SR', 1, NULL, NULL),
(7154, '2016-09-03 14:58:43', NULL, NULL, 2587, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 14:58:43', 'admin-1472879469-1472885923783883', 1, 1, 'SR', NULL, NULL, NULL),
(7155, '2016-09-03 00:00:00', NULL, NULL, 2583, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:58:56', 'admin-1472879469-14728823361561136', 1, 1, 'SR', NULL, NULL, NULL),
(7156, '2016-09-03 00:00:00', NULL, NULL, 2584, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:58:56', 'admin-1472879469-14728823361561136', 1, 1, 'SR', NULL, NULL, NULL),
(7157, '2016-09-03 14:14:10', NULL, NULL, 2585, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 14:14:10', 'admin-1472879469-14728832505575393', 1, 0, '', NULL, NULL, NULL),
(7158, '2016-09-03 13:11:01', NULL, NULL, 2575, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:11:01', 'admin-1472874616-14728794616289144', 1, 0, '', NULL, NULL, NULL),
(7159, '2016-09-03 13:11:01', NULL, NULL, 2575, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:11:01', 'admin-1472874616-14728794616289144', 1, 1, 'SR', NULL, NULL, NULL),
(7160, '2016-09-03 20:28:56', NULL, NULL, 2597, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 20:28:56', 'admin-1472879469-14729057361825035', 1, 1, 'SR', NULL, NULL, '10.0'),
(7161, '2016-09-03 13:12:39', NULL, NULL, 2576, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:12:39', 'admin-1472879469-14728795589484323', 1, 0, '', NULL, NULL, NULL),
(7162, '2016-09-03 13:10:19', NULL, NULL, 2574, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:10:19', 'admin-1472874616-14728794195549330', 1, 1, 'SR', NULL, NULL, NULL),
(7163, '2016-09-03 13:10:19', NULL, NULL, 2574, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:10:19', 'admin-1472874616-14728794195549330', 1, 1, 'SR', NULL, NULL, NULL),
(7164, '2016-09-03 13:10:19', NULL, NULL, 2574, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:10:19', 'admin-1472874616-14728794195549330', 1, 1, 'SR', NULL, NULL, NULL),
(7165, '2016-09-03 13:09:25', NULL, NULL, 2574, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:09:25', 'admin-1472874616-14728793652387114', 1, 0, '', NULL, NULL, NULL),
(7166, '2016-09-03 13:09:03', NULL, NULL, 2573, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:09:03', 'admin-1472874616-14728793428567893', 1, 0, '', NULL, NULL, NULL),
(7167, '2016-09-03 13:08:32', NULL, NULL, 2572, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:08:32', 'admin-1472874616-1472879311881317', 1, 0, '', NULL, NULL, NULL),
(7168, '2016-09-03 11:28:55', NULL, NULL, 2565, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:28:55', 'admin-1472866970-14728733352857993', 1, 0, '', NULL, NULL, NULL),
(7169, '2016-09-03 11:29:30', NULL, NULL, 2565, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:29:30', 'admin-1472866970-14728733703245067', 1, 1, 'SR', NULL, NULL, NULL),
(7170, '2016-09-03 11:29:30', NULL, NULL, 2565, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:29:30', 'admin-1472866970-14728733703245067', 1, 1, 'SR', NULL, NULL, NULL),
(7171, '2016-09-03 11:30:45', NULL, NULL, 2566, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:30:45', 'admin-1472866970-1472873445146223', 1, 0, '', NULL, NULL, NULL),
(7172, '2016-09-03 11:30:45', NULL, NULL, 2566, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:30:45', 'admin-1472866970-1472873445146223', 1, 0, '', NULL, NULL, NULL),
(7173, '2016-09-03 11:30:45', NULL, NULL, 2566, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:30:45', 'admin-1472866970-1472873445146223', 1, 1, 'SR', NULL, NULL, NULL),
(7174, '2016-09-03 11:30:45', NULL, NULL, 2566, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:30:45', 'admin-1472866970-1472873445146223', 1, 1, 'SR', NULL, NULL, NULL),
(7175, '2016-09-03 11:44:53', NULL, NULL, 2567, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:44:53', 'admin-1472866970-1472874293425616', 1, 1, 'SR', NULL, NULL, NULL),
(7176, '2016-09-03 11:44:53', NULL, NULL, 2567, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:44:53', 'admin-1472866970-1472874293425616', 1, 1, 'SR', NULL, NULL, NULL),
(7177, '2016-09-03 11:49:44', NULL, NULL, 2568, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:49:44', 'admin-1472866970-14728745838412458', 1, 1, 'SR', NULL, NULL, NULL),
(7178, '2016-09-03 11:49:44', NULL, NULL, 2568, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:49:44', 'admin-1472866970-14728745838412458', 1, 0, '', NULL, NULL, NULL),
(7179, '2016-09-03 11:49:44', NULL, NULL, 2568, 0, 80, '80', 'Summer Salad With Chicken ', 'bacon', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:49:44', 'admin-1472866970-14728745838412458', 1, 1, 'SR', NULL, NULL, NULL),
(7180, '2016-09-03 11:28:55', NULL, NULL, 2565, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:28:55', 'admin-1472866970-14728733352857993', 1, 0, '', NULL, NULL, NULL),
(7181, '2016-09-03 11:25:19', NULL, NULL, 2564, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:25:19', 'admin-1472866970-14728731197178994', 1, 1, 'SR', NULL, NULL, NULL),
(7182, '2016-09-03 11:25:19', NULL, NULL, 2564, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:25:19', 'admin-1472866970-14728731197178994', 1, 1, 'SR', NULL, NULL, NULL),
(7183, '2016-09-03 09:26:11', NULL, NULL, 2559, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 09:26:11', 'admin-1472864448-1472865971343167', 1, 1, 'SR', NULL, NULL, NULL),
(7184, '2016-09-03 09:42:33', NULL, NULL, 2560, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 09:42:33', 'admin-1472864448-14728669537434379', 1, 0, '', NULL, NULL, NULL),
(7185, '2016-09-03 09:43:04', NULL, NULL, 2560, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 09:43:04', 'admin-1472866970-1472866983969946', 1, 0, '', NULL, NULL, NULL),
(7186, '2016-09-03 09:43:04', NULL, NULL, 2560, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 09:43:04', 'admin-1472866970-1472866983969946', 1, 0, '', NULL, NULL, NULL),
(7187, '2016-09-03 09:43:04', NULL, NULL, 2560, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 09:43:04', 'admin-1472866970-1472866983969946', 1, 0, '', NULL, NULL, NULL),
(7188, '2016-09-03 09:44:42', NULL, NULL, 2560, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 09:44:42', 'admin-1472866970-1472867081997955', 1, 1, 'SR', NULL, NULL, NULL),
(7189, '2016-09-03 09:44:42', NULL, NULL, 2560, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 09:44:42', 'admin-1472866970-1472867081997955', 1, 1, 'SR', NULL, NULL, NULL),
(7190, '2016-09-03 09:44:42', NULL, NULL, 2560, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 09:44:42', 'admin-1472866970-1472867081997955', 1, 1, 'SR', NULL, NULL, NULL),
(7191, '2016-09-03 09:44:42', NULL, NULL, 2560, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 09:44:42', 'admin-1472866970-1472867081997955', 1, 1, 'SR', NULL, NULL, NULL),
(7192, '2016-09-03 10:11:23', NULL, NULL, 2561, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 10:11:23', 'admin-1472866970-14728686829273544', 1, 0, '', NULL, NULL, NULL),
(7193, '2016-09-03 10:11:23', NULL, NULL, 2561, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 10:11:23', 'admin-1472866970-14728686829273544', 1, 0, '', NULL, NULL, NULL),
(7194, '2016-09-03 10:11:23', NULL, NULL, 2561, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 10:11:23', 'admin-1472866970-14728686829273544', 1, 1, 'SR', NULL, NULL, NULL),
(7195, '2016-09-03 11:02:58', NULL, NULL, 2562, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:02:58', 'admin-1472866970-14728717782132296', 1, 1, 'SR', NULL, NULL, NULL),
(7196, '2016-09-03 11:02:58', NULL, NULL, 2562, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:02:58', 'admin-1472866970-14728717782132296', 1, 1, 'SR', NULL, NULL, NULL),
(7197, '2016-09-03 11:15:37', NULL, NULL, 2563, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:15:37', 'admin-1472866970-14728725376223212', 1, 1, 'SR', NULL, NULL, NULL),
(7198, '2016-09-03 11:15:37', NULL, NULL, 2563, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:15:37', 'admin-1472866970-14728725376223212', 1, 1, 'SR', NULL, NULL, NULL),
(7199, '2016-09-03 11:15:37', NULL, NULL, 2563, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:15:37', 'admin-1472866970-14728725376223212', 1, 1, 'SR', NULL, NULL, NULL),
(7200, '2016-09-03 11:25:19', NULL, NULL, 2564, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:25:19', 'admin-1472866970-14728731197178994', 1, 1, 'SR', NULL, NULL, NULL),
(7201, '2016-09-03 13:07:53', NULL, NULL, 2571, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 13:07:53', 'admin-1472874616-14728792733854635', 1, 0, '', NULL, NULL, NULL),
(7202, '2016-09-03 11:28:55', NULL, NULL, 2565, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:28:55', 'admin-1472866970-14728733352857993', 1, 0, '', NULL, NULL, NULL),
(7203, '2016-09-03 11:25:19', NULL, NULL, 2564, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 11:25:19', 'admin-1472866970-14728731197178994', 1, 1, 'SR', NULL, NULL, NULL),
(7204, '2016-09-03 09:25:17', NULL, NULL, 2559, 0, 153, '87', 'Big Breakfast ', 'no bacon', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 09:25:17', 'admin-1472864448-14728659178082753', 1, 0, '', NULL, NULL, NULL),
(7205, '2016-09-03 09:25:38', NULL, NULL, 2559, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 09:25:38', 'admin-1472864448-1472865938461823', 1, 1, 'SR', NULL, NULL, NULL),
(7206, '2016-09-03 09:25:38', NULL, NULL, 2559, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 09:25:38', 'admin-1472864448-1472865938461823', 1, 0, '', NULL, NULL, NULL),
(7207, '2016-09-03 09:08:03', NULL, NULL, 2556, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 09:08:03', 'admin-1472864448-14728648834003385', 1, 0, '', NULL, NULL, NULL),
(7208, '2016-09-03 09:21:15', NULL, NULL, 2558, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 09:21:15', 'admin-1472864448-14728656756434195', 1, 1, 'SR', NULL, NULL, NULL),
(7209, '2016-09-03 09:21:15', NULL, NULL, 2558, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 09:21:15', 'admin-1472864448-14728656756434195', 1, 0, '', NULL, NULL, NULL),
(7210, '2016-09-03 09:12:47', NULL, NULL, 2557, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 09:12:47', 'admin-1472864448-14728651670361330', 1, 0, '', NULL, NULL, '10.0'),
(7211, '2016-09-03 09:12:47', NULL, NULL, 2557, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 09:12:47', 'admin-1472864448-14728651670361330', 1, 0, '', NULL, NULL, '10.0'),
(7212, '2016-09-03 09:21:15', NULL, NULL, 2558, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 09:21:15', 'admin-1472864448-14728656756434195', 1, 0, '', NULL, NULL, NULL),
(7213, '2016-09-03 09:08:03', NULL, NULL, 2556, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 09:08:03', 'admin-1472864448-14728648834003385', 1, 1, 'SR', NULL, NULL, NULL),
(7214, '2016-09-03 09:12:47', NULL, NULL, 2557, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 09:12:47', 'admin-1472864448-14728651670361330', 1, 0, '', NULL, NULL, '10.0'),
(7215, '2016-09-03 09:08:03', NULL, NULL, 2556, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 09:08:03', 'admin-1472864448-14728648834003385', 1, 1, 'SR', NULL, NULL, NULL),
(7216, '2016-09-03 09:08:03', NULL, NULL, 2556, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472879469', 'admin', '2016-09-03 09:08:03', 'admin-1472864448-14728648834003385', 1, 0, '', NULL, NULL, NULL),
(7217, '2016-09-04 17:10:33', NULL, NULL, 2649, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 17:10:33', 'admin-1472965852-14729802337046011', 1, 1, 'SR', NULL, NULL, NULL),
(7218, '2016-09-04 17:10:33', NULL, NULL, 2649, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 17:10:33', 'admin-1472965852-14729802337046011', 1, 1, 'SR', NULL, NULL, NULL),
(7219, '2016-09-04 17:50:42', NULL, NULL, 2649, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 17:50:42', 'admin-1472965852-14729826418448591', 1, 0, '', NULL, NULL, NULL),
(7220, '2016-09-04 18:11:58', NULL, NULL, 2650, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 18:11:58', 'admin-1472965852-14729839180058367', 1, 1, 'SR', 1, NULL, NULL),
(7221, '2016-09-04 18:23:56', NULL, NULL, 2651, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 18:23:56', 'admin-1472965852-14729846360289397', 1, 1, 'SR', 1, NULL, NULL),
(7222, '2016-09-04 18:23:56', NULL, NULL, 2651, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 18:23:56', 'admin-1472965852-14729846360289397', 1, 1, 'SR', 1, NULL, NULL),
(7223, '2016-09-04 15:23:42', NULL, NULL, 2642, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 15:23:42', 'admin-1472965852-14729738225451377', 1, 1, 'SR', 1, NULL, NULL),
(7224, '2016-09-04 15:23:42', NULL, NULL, 2642, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 15:23:42', 'admin-1472965852-14729738225451377', 1, 1, 'SR', 1, NULL, NULL),
(7225, '2016-09-04 15:10:57', NULL, NULL, 2641, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 15:10:57', 'admin-1472965852-14729730574104016', 1, 1, 'SR', NULL, NULL, NULL),
(7226, '2016-09-04 15:10:57', NULL, NULL, 2641, 0, 181, '116', 'Open Food ', 'chili pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 15:10:57', 'admin-1472965852-14729730574104016', 1, 0, '', NULL, NULL, NULL),
(7227, '2016-09-04 14:52:42', NULL, NULL, 2640, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 14:52:42', 'admin-1472965852-14729719622508394', 1, 1, 'SR', NULL, NULL, NULL),
(7228, '2016-09-04 14:52:37', NULL, NULL, 2640, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 14:52:37', 'admin-1472965852-14729719573111924', 1, 1, 'SR', NULL, NULL, NULL),
(7229, '2016-09-04 14:48:50', NULL, NULL, 2639, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 14:48:50', 'admin-1472965852-14729717299408918', 1, 0, '', NULL, NULL, NULL),
(7230, '2016-09-04 14:35:36', NULL, NULL, 2638, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 14:35:36', 'admin-1472965852-14729709360938127', 1, 0, '', NULL, NULL, NULL),
(7231, '2016-09-04 14:32:29', NULL, NULL, 2637, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 14:32:29', 'admin-1472965852-14729707491118040', 1, 1, 'SR', NULL, NULL, NULL),
(7232, '2016-09-04 14:32:29', NULL, NULL, 2637, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 14:32:29', 'admin-1472965852-14729707491118040', 1, 1, 'SR', NULL, NULL, NULL),
(7233, '2016-09-04 14:16:20', NULL, NULL, 2636, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 14:16:21', 'admin-1472965852-14729697807495310', 1, 1, 'SR', NULL, NULL, NULL),
(7234, '2016-09-04 14:16:20', NULL, NULL, 2636, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 14:16:20', 'admin-1472965852-14729697807495310', 1, 0, '', NULL, NULL, NULL),
(7235, '2016-09-04 14:16:20', NULL, NULL, 2636, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 14:16:20', 'admin-1472965852-14729697807495310', 1, 1, 'SR', NULL, NULL, NULL),
(7236, '2016-09-04 13:10:41', NULL, NULL, 2626, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:10:41', 'admin-1472963973-14729658409034283', 1, 1, 'SR', NULL, NULL, NULL),
(7237, '2016-09-04 13:10:41', NULL, NULL, 2626, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:10:41', 'admin-1472963973-14729658409034283', 1, 0, '', NULL, NULL, NULL),
(7238, '2016-09-04 13:11:25', NULL, NULL, 2626, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:11:25', 'admin-1472965852-1472965885743215', 1, 1, 'SR', NULL, NULL, NULL),
(7239, '2016-09-04 13:11:31', NULL, NULL, 2625, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:11:31', 'admin-1472965852-14729658915292125', 1, 1, 'SR', NULL, NULL, NULL),
(7240, '2016-09-04 13:30:59', NULL, NULL, 2628, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:30:59', 'admin-1472965852-14729670589284624', 1, 0, '', NULL, NULL, NULL),
(7241, '2016-09-04 13:30:59', NULL, NULL, 2628, 0, 153, '87', 'Big Breakfast ', 'no bacon', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:30:59', 'admin-1472965852-14729670589284624', 1, 0, '', NULL, NULL, NULL),
(7242, '2016-09-04 13:30:59', NULL, NULL, 2628, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:30:59', 'admin-1472965852-14729670589284624', 1, 1, 'SR', NULL, NULL, NULL),
(7243, '2016-09-04 13:30:59', NULL, NULL, 2628, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:30:59', 'admin-1472965852-14729670589284624', 1, 1, 'SR', NULL, NULL, NULL),
(7244, '2016-09-04 13:35:45', NULL, NULL, 2629, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:35:45', 'admin-1472965852-1472967345027963', 1, 1, 'SR', 1, NULL, NULL),
(7245, '2016-09-04 19:46:40', NULL, NULL, 2653, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 19:46:40', 'admin-1472989530-14729896003687693', 1, 0, '', NULL, NULL, NULL),
(7246, '2016-09-04 19:46:40', NULL, NULL, 2653, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 19:46:40', 'admin-1472989530-14729896003687693', 1, 1, 'SR', NULL, NULL, NULL),
(7247, '2016-09-04 19:45:50', NULL, NULL, 2653, 0, 181, '116', 'Open Food ', '', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 19:45:50', 'admin-1472989530-14729895506901613', 1, 0, '', NULL, NULL, NULL),
(7248, '2016-09-04 19:45:50', NULL, NULL, 2653, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 19:45:50', 'admin-1472989530-14729895506901613', 1, 0, '', NULL, NULL, NULL),
(7249, '2016-09-04 18:50:17', NULL, NULL, 2652, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 18:50:17', 'admin-1472965852-14729862177814651', 1, 1, 'SR', NULL, NULL, NULL),
(7250, '2016-09-04 18:49:38', NULL, NULL, 2652, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 18:49:38', 'admin-1472965852-1472986178085584', 1, 0, '', NULL, NULL, NULL),
(7251, '2016-09-04 18:49:38', NULL, NULL, 2652, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 18:49:38', 'admin-1472965852-1472986178085584', 1, 1, 'SR', NULL, NULL, NULL),
(7252, '2016-09-04 19:44:52', NULL, NULL, 2653, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 19:44:52', 'admin-1472965852-14729894925001859', 1, 0, '', NULL, NULL, NULL),
(7253, '2016-09-04 18:47:07', NULL, NULL, 2652, 0, 199, '134', 'Dinner - Marmite Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 18:47:07', 'admin-1472965852-14729860276543277', 1, 0, '', NULL, NULL, NULL),
(7254, '2016-09-04 18:47:07', NULL, NULL, 2652, 0, 199, '134', 'Dinner - Marmite Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 18:47:07', 'admin-1472965852-14729860276543277', 1, 0, '', NULL, NULL, NULL),
(7255, '2016-09-04 18:49:38', NULL, NULL, 2652, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 18:49:38', 'admin-1472965852-1472986178085584', 1, 0, '', NULL, NULL, NULL),
(7256, '2016-09-04 18:24:27', NULL, NULL, 2651, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 18:24:27', 'admin-1472965852-14729846672699836', 1, 1, 'SR', 1, NULL, NULL),
(7257, '2016-09-04 18:46:00', NULL, NULL, 2652, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 18:46:00', 'admin-1472965852-14729859599295416', 1, 0, '', NULL, NULL, NULL),
(7258, '2016-09-04 18:47:07', NULL, NULL, 2652, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 18:47:07', 'admin-1472965852-14729860276543277', 1, 1, 'SR', NULL, NULL, NULL),
(7259, '2016-09-04 17:10:18', NULL, NULL, 2649, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 17:10:18', 'admin-1472965852-14729802186519686', 1, 0, '', NULL, NULL, NULL),
(7260, '2016-09-04 17:10:18', NULL, NULL, 2649, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 17:10:18', 'admin-1472965852-14729802186519686', 1, 0, '', NULL, NULL, NULL),
(7261, '2016-09-04 17:10:33', NULL, NULL, 2649, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 17:10:33', 'admin-1472965852-14729802337046011', 1, 1, 'SR', NULL, NULL, NULL),
(7262, '2016-09-04 15:54:15', NULL, NULL, 2648, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 15:54:15', 'admin-1472965852-14729756549353180', 1, 1, 'SR', NULL, NULL, NULL),
(7263, '2016-09-04 15:49:59', NULL, NULL, 2646, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 15:49:59', 'admin-1472965852-14729753995578065', 1, 1, 'SR', NULL, NULL, NULL),
(7264, '2016-09-04 15:50:26', NULL, NULL, 2647, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 15:50:26', 'admin-1472965852-14729754259933436', 1, 1, 'SR', 1, NULL, NULL),
(7265, '2016-09-04 15:25:00', NULL, NULL, 2643, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 15:25:00', 'admin-1472965852-14729739002861943', 1, 0, '', 1, NULL, NULL),
(7266, '2016-09-04 15:25:00', NULL, NULL, 2643, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 15:25:00', 'admin-1472965852-14729739002861943', 1, 0, '', 1, NULL, NULL),
(7267, '2016-09-04 15:36:00', NULL, NULL, 2645, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 15:36:00', 'admin-1472965852-14729745604268230', 1, 0, '', NULL, NULL, NULL),
(7268, '2016-09-04 15:25:50', NULL, NULL, 2644, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 15:25:50', 'admin-1472965852-1472973950686711', 1, 1, 'SR', NULL, NULL, NULL),
(7269, '2016-09-04 15:25:00', NULL, NULL, 2643, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 15:25:00', 'admin-1472965852-14729739002861943', 1, 1, 'SR', 1, NULL, NULL),
(7270, '2016-09-04 14:07:11', NULL, NULL, 2635, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 14:07:11', 'admin-1472965852-14729692309423672', 1, 0, '', NULL, NULL, NULL),
(7271, '2016-09-04 14:05:37', NULL, NULL, 2634, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 14:05:37', 'admin-1472965852-14729691374317856', 1, 1, 'SR', NULL, NULL, NULL),
(7272, '2016-09-04 14:05:37', NULL, NULL, 2634, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 14:05:37', 'admin-1472965852-14729691374317856', 1, 1, 'SR', NULL, NULL, NULL),
(7273, '2016-09-04 14:07:11', NULL, NULL, 2635, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 14:07:11', 'admin-1472965852-14729692309423672', 1, 1, 'SR', NULL, NULL, NULL),
(7274, '2016-09-04 14:07:11', NULL, NULL, 2635, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 14:07:11', 'admin-1472965852-14729692309423672', 1, 1, 'SR', NULL, NULL, NULL),
(7275, '2016-09-04 13:35:45', NULL, NULL, 2629, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:35:45', 'admin-1472965852-1472967345027963', 1, 1, 'SR', 1, NULL, NULL),
(7276, '2016-09-04 13:00:16', NULL, NULL, 2625, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:00:16', 'admin-1472963973-14729652159931911', 1, 1, 'SR', NULL, NULL, NULL),
(7277, '2016-09-04 11:57:37', NULL, NULL, 2620, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:57:37', 'admin-1472960110-1472961457148244', 1, 0, '', NULL, NULL, NULL),
(7278, '2016-09-04 11:57:37', NULL, NULL, 2620, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:57:37', 'admin-1472960110-1472961457148244', 1, 1, 'SR', NULL, NULL, NULL),
(7279, '2016-09-04 11:57:37', NULL, NULL, 2620, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:57:37', 'admin-1472960110-1472961457148244', 1, 1, 'SR', NULL, NULL, NULL),
(7280, '2016-09-04 12:01:34', NULL, NULL, 2621, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 12:01:34', 'admin-1472960110-14729616941578527', 1, 0, '', NULL, NULL, NULL),
(7281, '2016-09-04 12:01:34', NULL, NULL, 2621, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 12:01:34', 'admin-1472960110-14729616941578527', 1, 1, 'SR', NULL, NULL, NULL),
(7282, '2016-09-04 12:01:34', NULL, NULL, 2621, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 12:01:34', 'admin-1472960110-14729616941578527', 1, 0, '', NULL, NULL, NULL),
(7283, '2016-09-04 12:01:34', NULL, NULL, 2621, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 12:01:34', 'admin-1472960110-14729616941578527', 1, 1, 'SR', NULL, NULL, NULL),
(7284, '2016-09-04 12:08:48', NULL, NULL, 2622, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 12:08:48', 'admin-1472960110-14729621285943652', 1, 1, 'SR', NULL, NULL, NULL),
(7285, '2016-09-04 12:16:19', NULL, NULL, 2623, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 12:16:19', 'admin-1472960110-14729625797072776', 1, 0, '', NULL, NULL, NULL),
(7286, '2016-09-04 12:39:26', NULL, NULL, 2624, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 12:39:26', 'admin-1472960110-14729639660039624', 1, 0, '', NULL, NULL, NULL),
(7287, '2016-09-04 12:58:29', NULL, NULL, 2625, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 12:58:29', 'admin-1472963973-14729651089511699', 1, 0, '', NULL, NULL, NULL),
(7288, '2016-09-04 12:58:29', NULL, NULL, 2625, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 12:58:29', 'admin-1472963973-14729651089511699', 1, 1, 'SR', NULL, NULL, NULL),
(7289, '2016-09-04 12:58:29', NULL, NULL, 2625, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 12:58:29', 'admin-1472963973-14729651089511699', 1, 1, 'SR', NULL, NULL, NULL),
(7290, '2016-09-04 12:59:24', NULL, NULL, 2625, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 12:59:24', 'admin-1472963973-1472965164312183', 1, 0, '', NULL, NULL, NULL),
(7291, '2016-09-04 12:59:02', NULL, NULL, 2625, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 12:59:02', 'admin-1472963973-1472965142316193', 1, 0, '', NULL, NULL, NULL),
(7292, '2016-09-04 11:27:05', NULL, NULL, 2613, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:27:05', 'admin-1472955853-14729596248302829', 1, 0, '', NULL, NULL, NULL),
(7293, '2016-09-04 11:27:05', NULL, NULL, 2613, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:27:05', 'admin-1472955853-14729596248302829', 1, 0, '', NULL, NULL, NULL),
(7294, '2016-09-04 11:27:05', NULL, NULL, 2613, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:27:05', 'admin-1472955853-14729596248302829', 1, 1, 'SR', NULL, NULL, NULL),
(7295, '2016-09-04 11:27:05', NULL, NULL, 2613, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:27:05', 'admin-1472955853-14729596248302829', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(7296, '2016-09-04 11:35:18', NULL, NULL, 2614, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:35:18', 'admin-1472960110-14729601185512418', 1, 0, '', NULL, NULL, NULL),
(7297, '2016-09-04 11:39:01', NULL, NULL, 2615, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:39:01', 'admin-1472960110-1472960341277783', 1, 0, '', 1, NULL, NULL),
(7298, '2016-09-04 11:39:38', NULL, NULL, 2616, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:39:38', 'admin-1472960110-14729603780322050', 1, 1, 'SR', 1, NULL, NULL),
(7299, '2016-09-04 11:39:51', NULL, NULL, 2617, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:39:51', 'admin-1472960110-14729603916418594', 1, 1, 'SR', 1, NULL, NULL),
(7300, '2016-09-04 11:47:39', NULL, NULL, 2619, NULL, 84, '84', 'Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:47:39', 'admin-1472960110-1472960859525202', 1, 1, 'SR', NULL, NULL, NULL),
(7301, '2016-09-04 11:42:31', NULL, NULL, 2618, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:42:31', 'admin-1472960110-14729605510155170', 1, 1, 'SR', NULL, NULL, NULL),
(7302, '2016-09-04 11:47:39', NULL, NULL, 2619, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:47:39', 'admin-1472960110-1472960859525202', 1, 0, '', NULL, NULL, NULL),
(7303, '2016-09-04 14:00:43', NULL, NULL, 2633, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 14:00:43', 'admin-1472965852-1472968843461746', 1, 1, 'SR', NULL, NULL, NULL),
(7304, '2016-09-04 14:05:37', NULL, NULL, 2634, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 14:05:37', 'admin-1472965852-14729691374317856', 1, 0, '', NULL, NULL, NULL),
(7305, '2016-09-04 14:05:37', NULL, NULL, 2634, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 14:05:37', 'admin-1472965852-14729691374317856', 1, 1, 'SR', NULL, NULL, NULL),
(7306, '2016-09-04 13:01:20', NULL, NULL, 2626, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 3, 15.00, 45.0000, 0.0000, 45.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:01:20', 'admin-1472963973-14729652801678869', 1, 0, '', NULL, NULL, NULL),
(7307, '2016-09-04 13:04:57', NULL, NULL, 2625, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:04:57', 'admin-1472963973-14729654970265291', 1, 0, '', NULL, NULL, NULL),
(7308, '2016-09-04 13:06:15', NULL, NULL, 2626, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:06:15', 'admin-1472963973-14729655755864091', 1, 1, 'SR', NULL, NULL, NULL),
(7309, '2016-09-04 14:00:43', NULL, NULL, 2633, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 14:00:43', 'admin-1472965852-1472968843461746', 1, 1, 'SR', NULL, NULL, NULL),
(7310, '2016-09-04 13:48:06', NULL, NULL, 2632, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:48:06', 'admin-1472965852-14729680860637692', 1, 1, 'SR', NULL, NULL, NULL),
(7311, '2016-09-04 13:46:56', NULL, NULL, 2631, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:46:56', 'admin-1472965852-14729680158522798', 1, 0, '', NULL, NULL, NULL),
(7312, '2016-09-04 13:45:58', NULL, NULL, 2630, 0, 71, '71', 'Rice Wine Ginger Pork', 'Takeaway', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:45:58', 'admin-1472965852-14729679582446074', 1, 1, 'SR', NULL, NULL, NULL),
(7313, '2016-09-04 15:23:42', NULL, NULL, 2642, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 15:23:42', 'admin-1472965852-14729738225451377', 1, 0, '', 1, NULL, NULL),
(7314, '2016-09-04 13:35:45', NULL, NULL, 2629, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:35:45', 'admin-1472965852-1472967345027963', 1, 1, 'SR', 1, NULL, NULL),
(7315, '2016-09-04 13:10:41', NULL, NULL, 2626, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:10:41', 'admin-1472963973-14729658409034283', 1, 1, 'SR', NULL, NULL, NULL),
(7316, '2016-09-04 13:10:41', NULL, NULL, 2626, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:10:41', 'admin-1472963973-14729658409034283', 1, 0, '', NULL, NULL, NULL),
(7317, '2016-09-04 13:10:41', NULL, NULL, 2626, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:10:41', 'admin-1472963973-14729658409034283', 1, 0, '', NULL, NULL, NULL),
(7318, '2016-09-04 13:10:41', NULL, NULL, 2626, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:10:41', 'admin-1472963973-14729658409034283', 1, 0, '', NULL, NULL, NULL),
(7319, '2016-09-04 13:10:41', NULL, NULL, 2626, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:10:41', 'admin-1472963973-14729658409034283', 1, 0, '', NULL, NULL, NULL),
(7320, '2016-09-04 13:10:41', NULL, NULL, 2626, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:10:41', 'admin-1472963973-14729658409034283', 1, 1, 'SR', NULL, NULL, NULL),
(7321, '2016-09-04 13:06:40', NULL, NULL, 2627, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:06:40', 'admin-1472963973-14729656005705694', 1, 1, 'SR', NULL, NULL, NULL),
(7322, '2016-09-04 11:47:39', NULL, NULL, 2619, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:47:39', 'admin-1472960110-1472960859525202', 1, 1, 'SR', NULL, NULL, NULL),
(7323, '2016-09-04 11:47:39', NULL, NULL, 2619, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:47:39', 'admin-1472960110-1472960859525202', 1, 0, '', NULL, NULL, NULL),
(7324, '2016-09-04 13:06:40', NULL, NULL, 2627, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 13:06:40', 'admin-1472963973-14729656005705694', 1, 1, 'SR', NULL, NULL, NULL),
(7325, '2016-09-04 15:25:00', NULL, NULL, 2643, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 15:25:00', 'admin-1472965852-14729739002861943', 1, 1, 'SR', 1, NULL, NULL),
(7326, '2016-09-04 11:47:39', NULL, NULL, 2619, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:47:39', 'admin-1472960110-1472960859525202', 1, 1, 'SR', NULL, NULL, NULL),
(7327, '2016-09-04 11:47:39', NULL, NULL, 2619, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:47:39', 'admin-1472960110-1472960859525202', 1, 1, 'SR', NULL, NULL, NULL),
(7328, '2016-09-04 11:47:39', NULL, NULL, 2619, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:47:39', 'admin-1472960110-1472960859525202', 1, 0, '', NULL, NULL, NULL),
(7329, '2016-09-04 11:47:39', NULL, NULL, 2619, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:47:39', 'admin-1472960110-1472960859525202', 1, 1, 'SR', NULL, NULL, NULL),
(7330, '2016-09-04 11:47:39', NULL, NULL, 2619, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:47:39', 'admin-1472960110-1472960859525202', 1, 0, '', NULL, NULL, NULL),
(7331, '2016-09-04 11:47:39', NULL, NULL, 2619, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:47:39', 'admin-1472960110-1472960859525202', 1, 0, '', NULL, NULL, NULL),
(7332, '2016-09-04 10:25:25', NULL, NULL, 2607, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 10:25:25', 'admin-1472955853-14729559250969717', 1, 1, 'SR', NULL, NULL, NULL),
(7333, '2016-09-04 10:23:34', NULL, NULL, 2607, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 10:23:34', 'sanni-1472951138-14729558142745171', 1, 0, '', NULL, NULL, NULL),
(7334, '2016-09-04 10:25:25', NULL, NULL, 2607, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 10:25:25', 'admin-1472955853-14729559250969717', 1, 1, 'SR', NULL, NULL, NULL),
(7335, '2016-09-04 10:33:18', NULL, NULL, 2608, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 10:33:18', 'admin-1472955853-14729563985219439', 1, 0, '', NULL, NULL, NULL),
(7336, '2016-09-04 10:33:18', NULL, NULL, 2608, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 10:33:18', 'admin-1472955853-14729563985219439', 1, 1, 'SR', NULL, NULL, NULL),
(7337, '2016-09-04 10:34:34', NULL, NULL, 2609, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 10:34:34', 'admin-1472955853-14729564742578611', 1, 1, 'SR', NULL, NULL, NULL),
(7338, '2016-09-04 10:34:34', NULL, NULL, 2609, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 10:34:34', 'admin-1472955853-14729564742578611', 1, 1, 'SR', NULL, NULL, NULL),
(7339, '2016-09-04 11:19:19', NULL, NULL, 2610, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:19:19', 'admin-1472955853-14729591591444771', 1, 0, '', NULL, NULL, NULL),
(7340, '2016-09-04 11:19:19', NULL, NULL, 2610, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:19:19', 'admin-1472955853-14729591591444771', 1, 0, '', NULL, NULL, NULL),
(7341, '2016-09-04 11:19:19', NULL, NULL, 2610, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:19:19', 'admin-1472955853-14729591591444771', 1, 1, 'SR', NULL, NULL, NULL),
(7342, '2016-09-04 11:19:19', NULL, NULL, 2610, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:19:19', 'admin-1472955853-14729591591444771', 1, 1, 'SR', NULL, NULL, NULL),
(7343, '2016-09-04 11:21:42', NULL, NULL, 2611, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:21:42', 'admin-1472955853-14729593018055718', 1, 1, 'SR', NULL, NULL, NULL),
(7344, '2016-09-04 09:28:42', NULL, NULL, 2604, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:28:42', 'sanni-1472951138-14729525223576958', 1, 0, '', NULL, NULL, NULL),
(7345, '2016-09-04 14:05:37', NULL, NULL, 2634, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 14:05:37', 'admin-1472965852-14729691374317856', 1, 0, '', NULL, NULL, NULL),
(7346, '2016-09-04 11:47:39', NULL, NULL, 2619, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:47:39', 'admin-1472960110-1472960859525202', 1, 0, '', NULL, NULL, NULL),
(7347, '2016-09-04 11:22:01', NULL, NULL, 2612, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 11:22:01', 'admin-1472955853-1472959321597432', 1, 1, 'SR', NULL, NULL, NULL),
(7348, '2016-09-04 10:25:25', NULL, NULL, 2607, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 10:25:25', 'admin-1472955853-14729559250969717', 1, 1, 'SR', NULL, NULL, NULL),
(7349, '2016-09-04 10:23:34', NULL, NULL, 2607, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 10:23:34', 'sanni-1472951138-14729558142745171', 1, 0, '', NULL, NULL, NULL),
(7350, '2016-09-04 09:28:42', NULL, NULL, 2604, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:28:42', 'sanni-1472951138-14729525223576958', 1, 0, '', NULL, NULL, NULL),
(7351, '2016-09-04 09:28:58', NULL, NULL, 2604, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:28:58', 'sanni-1472951138-14729525385467927', 1, 0, '', NULL, NULL, NULL),
(7352, '2016-09-04 09:32:51', NULL, NULL, 2605, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:32:51', 'sanni-1472951138-14729527711252445', 1, 0, '', NULL, NULL, NULL),
(7353, '2016-09-04 09:32:51', NULL, NULL, 2605, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:32:51', 'sanni-1472951138-14729527711252445', 1, 0, '', NULL, NULL, NULL),
(7354, '2016-09-04 09:32:51', NULL, NULL, 2605, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:32:51', 'sanni-1472951138-14729527711252445', 1, 0, '', NULL, NULL, NULL),
(7355, '2016-09-04 09:32:51', NULL, NULL, 2605, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:32:51', 'sanni-1472951138-14729527711252445', 1, 0, '', NULL, NULL, NULL),
(7356, '2016-09-04 09:32:51', NULL, NULL, 2605, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:32:51', 'sanni-1472951138-14729527711252445', 1, 1, 'SR', NULL, NULL, NULL),
(7357, '2016-09-04 09:32:51', NULL, NULL, 2605, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:32:51', 'sanni-1472951138-14729527711252445', 1, 1, 'SR', NULL, NULL, NULL),
(7358, '2016-09-04 09:32:51', NULL, NULL, 2605, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:32:51', 'sanni-1472951138-14729527711252445', 1, 1, 'SR', NULL, NULL, NULL),
(7359, '2016-09-04 09:32:51', NULL, NULL, 2605, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:32:51', 'sanni-1472951138-14729527711252445', 1, 0, '', NULL, NULL, NULL),
(7360, '2016-09-04 09:32:51', NULL, NULL, 2605, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:32:51', 'sanni-1472951138-14729527711252445', 1, 1, 'SR', NULL, NULL, NULL),
(7361, '2016-09-04 10:13:26', NULL, NULL, 2606, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 10:13:26', 'sanni-1472951138-14729552065071312', 1, 0, '', NULL, NULL, NULL),
(7362, '2016-09-04 10:13:26', NULL, NULL, 2606, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 10:13:26', 'sanni-1472951138-14729552065071312', 1, 0, '', NULL, NULL, NULL),
(7363, '2016-09-04 10:13:26', NULL, NULL, 2606, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 10:13:26', 'sanni-1472951138-14729552065071312', 1, 0, '', NULL, NULL, NULL),
(7364, '2016-09-04 10:13:41', NULL, NULL, 2606, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 10:13:41', 'sanni-1472951138-14729552210265590', 1, 1, 'SR', NULL, NULL, NULL),
(7365, '2016-09-04 10:13:41', NULL, NULL, 2606, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 10:13:41', 'sanni-1472951138-14729552210265590', 1, 0, '', NULL, NULL, NULL),
(7366, '2016-09-04 10:23:34', NULL, NULL, 2607, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 10:23:34', 'sanni-1472951138-14729558142745171', 1, 0, '', NULL, NULL, NULL),
(7367, '2016-09-04 10:23:34', NULL, NULL, 2607, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 10:23:34', 'sanni-1472951138-14729558142745171', 1, 0, '', NULL, NULL, NULL),
(7368, '2016-09-04 10:25:25', NULL, NULL, 2607, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 10:25:25', 'admin-1472955853-14729559250969717', 1, 1, 'SR', NULL, NULL, NULL),
(7369, '2016-09-04 10:25:25', NULL, NULL, 2607, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'admin', '2016-09-04 10:25:25', 'admin-1472955853-14729559250969717', 1, 1, 'SR', NULL, NULL, NULL),
(7370, '2016-09-04 10:23:34', NULL, NULL, 2607, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 10:23:34', 'sanni-1472951138-14729558142745171', 1, 0, '', NULL, NULL, NULL),
(7371, '2016-09-04 09:16:56', NULL, NULL, 2603, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:16:56', 'sanni-1472951138-14729518159093955', 1, 1, 'SR', NULL, NULL, NULL),
(7372, '2016-09-04 09:28:42', NULL, NULL, 2604, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:28:42', 'sanni-1472951138-14729525223576958', 1, 0, '', NULL, NULL, NULL),
(7373, '2016-09-04 09:28:42', NULL, NULL, 2604, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:28:42', 'sanni-1472951138-14729525223576958', 1, 0, '', NULL, NULL, NULL),
(7374, '2016-09-04 09:11:28', NULL, NULL, 2602, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:11:28', 'sanni-1472951138-1472951488584931', 1, 0, '', NULL, NULL, NULL),
(7375, '2016-09-04 09:16:56', NULL, NULL, 2603, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:16:56', 'sanni-1472951138-14729518159093955', 1, 1, 'SR', NULL, NULL, NULL),
(7376, '2016-09-04 09:16:56', NULL, NULL, 2603, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:16:56', 'sanni-1472951138-14729518159093955', 1, 1, 'SR', NULL, NULL, NULL),
(7377, '2016-09-04 09:11:28', NULL, NULL, 2602, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:11:28', 'sanni-1472951138-1472951488584931', 1, 1, 'SR', NULL, NULL, NULL),
(7378, '2016-09-04 09:16:56', NULL, NULL, 2603, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:16:56', 'sanni-1472951138-14729518159093955', 1, 0, '', NULL, NULL, NULL),
(7379, '2016-09-04 09:16:56', NULL, NULL, 2603, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:16:56', 'sanni-1472951138-14729518159093955', 1, 0, '', NULL, NULL, NULL),
(7380, '2016-09-04 09:11:03', NULL, NULL, 2602, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:11:03', 'sanni-1472951138-1472951463386622', 1, 0, '', NULL, NULL, NULL),
(7381, '2016-09-04 09:16:56', NULL, NULL, 2603, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:16:56', 'sanni-1472951138-14729518159093955', 1, 0, '', NULL, NULL, NULL),
(7382, '2016-09-04 09:11:03', NULL, NULL, 2602, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1472989530', 'sanni', '2016-09-04 09:11:03', 'sanni-1472951138-1472951463386622', 1, 0, '', NULL, NULL, NULL),
(7383, '2016-09-05 20:29:05', NULL, NULL, 2682, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 20:29:05', 'admin-1473057839-14730785450774869', 1, 1, 'SR', 1, NULL, NULL),
(7384, '2016-09-05 18:04:53', NULL, NULL, 2678, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 18:04:53', 'admin-1473057839-14730698931678932', 1, 0, '', NULL, NULL, NULL),
(7385, '2016-09-05 18:04:53', NULL, NULL, 2678, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 18:04:53', 'admin-1473057839-14730698931678932', 1, 0, '', NULL, NULL, NULL),
(7386, '2016-09-05 19:02:56', NULL, NULL, 2679, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 19:02:56', 'admin-1473057839-14730733767168854', 1, 0, '', NULL, NULL, NULL),
(7387, '2016-09-05 19:03:09', NULL, NULL, 2679, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 19:03:09', 'admin-1473057839-14730733892569360', 1, 1, 'SR', NULL, NULL, NULL),
(7388, '2016-09-05 19:03:09', NULL, NULL, 2679, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 19:03:09', 'admin-1473057839-14730733892569360', 1, 1, 'SR', NULL, NULL, NULL),
(7389, '2016-09-05 19:18:08', NULL, NULL, 2680, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 19:18:08', 'admin-1473057839-14730742887066849', 1, 1, 'SR', NULL, NULL, NULL),
(7390, '2016-09-05 19:18:08', NULL, NULL, 2680, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 19:18:08', 'admin-1473057839-14730742887066849', 1, 1, 'SR', NULL, NULL, NULL),
(7391, '2016-09-05 19:18:08', NULL, NULL, 2680, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 19:18:08', 'admin-1473057839-14730742887066849', 1, 0, '', NULL, NULL, NULL),
(7392, '2016-09-05 21:10:04', NULL, NULL, 2680, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 21:10:04', 'admin-1473057839-14730810044067972', 1, 0, '', NULL, NULL, NULL),
(7393, '2016-09-05 19:18:08', NULL, NULL, 2680, 0, 201, '136', 'Dinner -  Chili Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 19:18:08', 'admin-1473057839-14730742887066849', 1, 0, '', NULL, NULL, NULL),
(7394, '2016-09-05 19:18:08', NULL, NULL, 2680, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 19:18:08', 'admin-1473057839-14730742887066849', 1, 1, 'SR', NULL, NULL, NULL),
(7395, '2016-09-05 21:19:16', NULL, NULL, 2683, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 21:19:16', 'admin-1473057839-14730815563817660', 1, 1, 'SR', 1, NULL, NULL),
(7396, '2016-09-05 19:18:08', NULL, NULL, 2680, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 19:18:08', 'admin-1473057839-14730742887066849', 1, 0, '', NULL, NULL, NULL),
(7397, '2016-09-05 19:18:08', NULL, NULL, 2680, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 19:18:08', 'admin-1473057839-14730742887066849', 1, 0, '', NULL, NULL, NULL),
(7398, '2016-09-05 17:05:43', NULL, NULL, 2676, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 17:05:43', 'admin-1473057839-1473066342989844', 1, 0, '', 1, NULL, NULL),
(7399, '2016-09-05 17:29:45', NULL, NULL, 2675, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 17:29:45', 'admin-1473057839-1473067785801335', 1, 1, 'SR', NULL, NULL, NULL),
(7400, '2016-09-05 17:29:45', NULL, NULL, 2675, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 17:29:45', 'admin-1473057839-1473067785801335', 1, 1, 'SR', NULL, NULL, NULL),
(7401, '2016-09-05 17:29:45', NULL, NULL, 2675, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 17:29:45', 'admin-1473057839-1473067785801335', 1, 1, 'SR', NULL, NULL, NULL),
(7402, '2016-09-05 18:01:07', NULL, NULL, 2677, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 18:01:07', 'admin-1473057839-14730696668905997', 1, 0, '', NULL, NULL, NULL),
(7403, '2016-09-05 18:01:07', NULL, NULL, 2677, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 18:01:07', 'admin-1473057839-14730696668905997', 1, 1, 'SR', NULL, NULL, NULL),
(7404, '2016-09-05 18:01:07', NULL, NULL, 2677, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 18:01:07', 'admin-1473057839-14730696668905997', 1, 1, 'SR', NULL, NULL, NULL),
(7405, '2016-09-05 18:04:53', NULL, NULL, 2678, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 18:04:53', 'admin-1473057839-14730698931678932', 1, 0, '', NULL, NULL, NULL),
(7406, '2016-09-05 18:04:53', NULL, NULL, 2678, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 18:04:53', 'admin-1473057839-14730698931678932', 1, 0, '', NULL, NULL, NULL),
(7407, '2016-09-05 18:04:53', NULL, NULL, 2678, 0, 201, '136', 'Dinner -  Chili Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 18:04:53', 'admin-1473057839-14730698931678932', 1, 0, '', NULL, NULL, NULL),
(7408, '2016-09-05 18:04:53', NULL, NULL, 2678, 0, 197, '132', 'Dinner - Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 18:04:53', 'admin-1473057839-14730698931678932', 1, 0, '', NULL, NULL, NULL),
(7409, '2016-09-05 18:04:53', NULL, NULL, 2678, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 18:04:53', 'admin-1473057839-14730698931678932', 1, 0, '', NULL, NULL, NULL),
(7410, '2016-09-05 22:07:01', NULL, NULL, 2685, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 22:07:01', 'admin-1473057839-14730844215019752', 1, 0, '', NULL, NULL, NULL),
(7411, '2016-09-05 21:53:43', NULL, NULL, 2684, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 21:53:43', 'admin-1473057839-14730836229931249', 1, 0, '', NULL, NULL, NULL),
(7412, '2016-09-05 21:53:43', NULL, NULL, 2684, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 21:53:43', 'admin-1473057839-14730836229931249', 1, 0, '', NULL, NULL, NULL),
(7413, '2016-09-05 12:23:17', NULL, NULL, 2660, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 12:23:17', 'admin-1473037573-14730493974505419', 1, 0, '', NULL, NULL, NULL),
(7414, '2016-09-05 12:01:12', NULL, NULL, 2659, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 12:01:12', 'admin-1473037573-14730480725762780', 1, 1, 'SR', NULL, NULL, NULL),
(7415, '2016-09-05 14:58:46', NULL, NULL, 2670, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 14:58:46', 'admin-1473057839-14730587257992022', 1, 1, 'SR', NULL, NULL, NULL),
(7416, '2016-09-05 14:58:46', NULL, NULL, 2670, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 14:58:46', 'admin-1473057839-14730587257992022', 1, 1, 'SR', NULL, NULL, NULL),
(7417, '2016-09-05 14:58:46', NULL, NULL, 2670, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 14:58:46', 'admin-1473057839-14730587257992022', 1, 0, '', NULL, NULL, NULL),
(7418, '2016-09-05 14:59:47', NULL, NULL, 2671, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 14:59:47', 'admin-1473057839-14730587875081115', 1, 1, 'SR', NULL, NULL, '10.0'),
(7419, '2016-09-05 15:16:31', NULL, NULL, 2673, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 15:16:31', 'admin-1473057839-14730597908349568', 1, 1, 'SR', 1, NULL, NULL),
(7420, '2016-09-05 15:19:33', NULL, NULL, 2674, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 15:19:33', 'admin-1473057839-14730599733707527', 1, 1, 'SR', NULL, NULL, NULL),
(7421, '2016-09-05 15:19:33', NULL, NULL, 2674, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 15:19:33', 'admin-1473057839-14730599733707527', 1, 1, 'SR', NULL, NULL, NULL),
(7422, '2016-09-05 15:19:46', NULL, NULL, 2674, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 15:19:46', 'admin-1473057839-14730599864165446', 1, 0, '', NULL, NULL, NULL),
(7423, '2016-09-05 16:31:06', NULL, NULL, 2675, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 16:31:06', 'admin-1473057839-14730642664425311', 1, 1, 'SR', NULL, NULL, NULL),
(7424, '2016-09-05 16:31:06', NULL, NULL, 2675, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 16:31:06', 'admin-1473057839-14730642664425311', 1, 1, 'SR', NULL, NULL, NULL),
(7425, '2016-09-05 16:31:06', NULL, NULL, 2675, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 16:31:06', 'admin-1473057839-14730642664425311', 1, 1, 'SR', NULL, NULL, NULL),
(7426, '2016-09-05 19:18:08', NULL, NULL, 2680, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 19:18:08', 'admin-1473057839-14730742887066849', 1, 0, '', NULL, NULL, NULL),
(7427, '2016-09-05 19:48:41', NULL, NULL, 2681, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 19:48:41', 'admin-1473057839-14730761211492563', 1, 1, 'SR', 1, NULL, NULL),
(7428, '2016-09-05 12:28:03', NULL, NULL, 2661, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 12:28:03', 'admin-1473037573-14730496836249663', 1, 1, 'SR', NULL, NULL, NULL),
(7429, '2016-09-05 12:28:03', NULL, NULL, 2661, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 12:28:03', 'admin-1473037573-14730496836249663', 1, 1, 'SR', NULL, NULL, NULL),
(7430, '2016-09-05 12:28:03', NULL, NULL, 2661, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 12:28:03', 'admin-1473037573-14730496836249663', 1, 0, '', NULL, NULL, NULL),
(7431, '2016-09-05 12:28:03', NULL, NULL, 2661, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 12:28:03', 'admin-1473037573-14730496836249663', 1, 1, 'SR', NULL, NULL, NULL),
(7432, '2016-09-05 12:30:23', NULL, NULL, 2662, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 12:30:23', 'admin-1473037573-14730498236514137', 1, 0, '', NULL, NULL, NULL),
(7433, '2016-09-05 12:30:23', NULL, NULL, 2662, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 12:30:23', 'admin-1473037573-14730498236514137', 1, 1, 'SR', NULL, NULL, NULL),
(7434, '2016-09-05 13:20:10', NULL, NULL, 2663, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 13:20:10', 'admin-1473037573-14730528099117261', 1, 1, 'SR', NULL, NULL, NULL),
(7435, '2016-09-05 13:33:47', NULL, NULL, 2664, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 13:33:47', 'admin-1473037573-14730536272107325', 1, 1, 'SR', NULL, NULL, NULL),
(7436, '2016-09-05 13:33:47', NULL, NULL, 2664, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 13:33:47', 'admin-1473037573-14730536272107325', 1, 0, '', NULL, NULL, NULL),
(7437, '2016-09-05 13:45:28', NULL, NULL, 2665, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 13:45:28', 'admin-1473037573-14730543281984037', 1, 0, '', NULL, NULL, NULL),
(7438, '2016-09-05 13:55:49', NULL, NULL, 2666, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 13:55:49', 'admin-1473037573-14730549491252357', 1, 1, 'SR', NULL, NULL, NULL),
(7439, '2016-09-05 14:02:59', NULL, NULL, 2667, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 14:02:59', 'admin-1473037573-14730553788733926', 1, 1, 'SR', NULL, NULL, NULL),
(7440, '2016-09-05 14:02:59', NULL, NULL, 2667, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 14:02:59', 'admin-1473037573-14730553788733926', 1, 1, 'SR', NULL, NULL, NULL),
(7441, '2016-09-05 14:02:59', NULL, NULL, 2667, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 14:02:59', 'admin-1473037573-14730553788733926', 1, 0, '', NULL, NULL, NULL),
(7442, '2016-09-05 14:02:59', NULL, NULL, 2667, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 14:02:59', 'admin-1473037573-14730553788733926', 1, 0, '', NULL, NULL, NULL),
(7443, '2016-09-05 14:24:26', NULL, NULL, 2668, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 14:24:26', 'admin-1473037573-1473056666288543', 1, 1, 'SR', NULL, NULL, NULL),
(7444, '2016-09-05 14:24:26', NULL, NULL, 2668, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 14:24:26', 'admin-1473037573-1473056666288543', 1, 1, 'SR', NULL, NULL, NULL),
(7445, '2016-09-05 14:43:49', NULL, NULL, 2669, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 14:43:49', 'admin-1473037573-14730578291175145', 1, 1, 'SR', NULL, NULL, NULL),
(7446, '2016-09-05 14:42:24', NULL, NULL, 2669, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 14:42:24', 'admin-1473037573-1473057744351666', 1, 0, '', NULL, NULL, NULL),
(7447, '2016-09-05 14:44:05', NULL, NULL, 2669, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 14:44:05', 'admin-1473057839-14730578452726229', 1, 0, '', NULL, NULL, NULL),
(7448, '2016-09-05 17:05:43', NULL, NULL, 2676, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 17:05:43', 'admin-1473057839-1473066342989844', 1, 1, 'SR', 1, NULL, NULL),
(7449, '2016-09-05 12:23:17', NULL, NULL, 2660, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 12:23:17', 'admin-1473037573-14730493974505419', 1, 0, '', NULL, NULL, NULL),
(7450, '2016-09-05 12:01:12', NULL, NULL, 2659, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 12:01:12', 'admin-1473037573-14730480725762780', 1, 0, '', NULL, NULL, NULL),
(7451, '2016-09-05 12:01:12', NULL, NULL, 2659, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 12:01:12', 'admin-1473037573-14730480725762780', 1, 1, 'SR', NULL, NULL, NULL),
(7452, '2016-09-05 12:00:05', NULL, NULL, 2658, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 12:00:05', 'admin-1473037573-14730480051148949', 1, 1, 'SR', NULL, NULL, NULL),
(7453, '2016-09-05 11:48:35', NULL, NULL, 2657, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 11:48:35', 'admin-1473037573-14730473148706457', 1, 1, 'SR', NULL, NULL, NULL),
(7454, '2016-09-05 12:00:05', NULL, NULL, 2658, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 12:00:05', 'admin-1473037573-14730480051148949', 1, 1, 'SR', NULL, NULL, NULL),
(7455, '2016-09-05 11:48:35', NULL, NULL, 2657, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 11:48:35', 'admin-1473037573-14730473148706457', 1, 1, 'SR', NULL, NULL, NULL),
(7456, '2016-09-05 11:09:03', NULL, NULL, 2656, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 11:09:03', 'admin-1473037573-14730449433455121', 1, 1, 'SR', NULL, NULL, NULL),
(7457, '2016-09-05 11:09:03', NULL, NULL, 2656, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 11:09:03', 'admin-1473037573-14730449433455121', 1, 1, 'SR', NULL, NULL, NULL),
(7458, '2016-09-05 10:49:39', NULL, NULL, 2655, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 10:49:39', 'admin-1473037573-14730437791996987', 1, 1, 'SR', NULL, NULL, NULL),
(7459, '2016-09-05 11:09:03', NULL, NULL, 2656, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 11:09:03', 'admin-1473037573-14730449433455121', 1, 1, 'SR', NULL, NULL, NULL),
(7460, '2016-09-05 11:09:03', NULL, NULL, 2656, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 11:09:03', 'admin-1473037573-14730449433455121', 1, 0, '', NULL, NULL, NULL),
(7461, '2016-09-05 10:33:41', NULL, NULL, 2654, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 10:33:41', 'admin-1473037573-14730428217914689', 1, 0, '', NULL, NULL, NULL),
(7462, '2016-09-05 20:29:05', NULL, NULL, 2682, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 20:29:05', 'admin-1473057839-14730785450774869', 1, 1, 'SR', 1, NULL, NULL),
(7463, '2016-09-05 10:33:41', NULL, NULL, 2654, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1473057839', 'admin', '2016-09-05 10:33:41', 'admin-1473037573-14730428217914689', 1, 1, 'SR', NULL, NULL, NULL),
(7464, '2016-09-07 18:58:59', NULL, NULL, 2704, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 18:58:59', 'admin-1473226673-14732459395827971', 1, 0, '', NULL, NULL, NULL),
(7465, '2016-09-07 16:17:19', NULL, NULL, 2700, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 16:17:19', 'admin-1473226673-14732362391084424', 1, 1, 'SR', NULL, NULL, NULL),
(7466, '2016-09-07 16:17:19', NULL, NULL, 2700, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 16:17:19', 'admin-1473226673-14732362391084424', 1, 0, '', NULL, NULL, NULL),
(7467, '2016-09-07 16:17:26', NULL, NULL, 2701, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 16:17:26', 'admin-1473226673-14732362467718683', 1, 0, '', NULL, NULL, NULL),
(7468, '2016-09-07 17:39:52', NULL, NULL, 2700, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 17:39:52', 'admin-1473226673-14732411919634594', 1, 1, 'SR', NULL, NULL, NULL),
(7469, '2016-09-07 18:24:00', NULL, NULL, 2702, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 18:24:00', 'admin-1473226673-14732438404988286', 1, 0, '', NULL, NULL, NULL),
(7470, '2016-09-07 18:24:00', NULL, NULL, 2702, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 18:24:00', 'admin-1473226673-14732438404988286', 1, 0, '', NULL, NULL, NULL),
(7471, '2016-09-07 18:24:00', NULL, NULL, 2702, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 18:24:00', 'admin-1473226673-14732438404988286', 1, 0, '', NULL, NULL, NULL),
(7472, '2016-09-07 18:35:52', NULL, NULL, 2703, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 18:35:52', 'admin-1473226673-1473244552667812', 1, 0, '', NULL, NULL, NULL),
(7473, '2016-09-07 18:36:51', NULL, NULL, 2703, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 18:36:51', 'admin-1473226673-14732446110525176', 1, 1, 'SR', NULL, NULL, NULL),
(7474, '2016-09-07 18:36:51', NULL, NULL, 2703, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 18:36:51', 'admin-1473226673-14732446110525176', 1, 1, 'SR', NULL, NULL, NULL),
(7475, '2016-09-07 18:36:51', NULL, NULL, 2703, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 18:36:51', 'admin-1473226673-14732446110525176', 1, 1, 'SR', NULL, NULL, NULL),
(7476, '2016-09-07 18:58:59', NULL, NULL, 2704, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 18:58:59', 'admin-1473226673-14732459395827971', 1, 0, '', NULL, NULL, NULL),
(7477, '2016-09-07 09:35:21', NULL, NULL, 2686, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 09:35:21', 'admin-1473210396-14732121216833662', 1, 0, '', NULL, NULL, NULL),
(7478, '2016-09-07 11:08:19', NULL, NULL, 2690, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 11:08:19', 'admin-1473210396-14732176997511696', 1, 0, '', NULL, NULL, NULL),
(7479, '2016-09-07 11:57:10', NULL, NULL, 2691, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 11:57:10', 'admin-1473210396-14732206300811916', 1, 1, 'SR', NULL, NULL, NULL),
(7480, '2016-09-07 21:03:51', NULL, NULL, 2708, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 21:03:51', 'admin-1473251390-14732534314129342', 1, 1, 'SR', NULL, NULL, NULL),
(7481, '2016-09-07 21:03:51', NULL, NULL, 2708, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 21:03:51', 'admin-1473251390-14732534314129342', 1, 1, 'SR', NULL, NULL, NULL),
(7482, '2016-09-07 20:29:59', NULL, NULL, 2709, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 20:29:59', 'admin-1473251390-14732513988223327', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(7483, '2016-09-07 20:29:59', NULL, NULL, 2709, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 20:29:59', 'admin-1473251390-14732513988223327', 1, 1, 'SR', NULL, NULL, NULL),
(7484, '2016-09-07 20:15:06', NULL, NULL, 2708, 0, 201, '136', 'Dinner -  Chili Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 20:15:06', 'admin-1473226673-14732505058657131', 1, 0, '', NULL, NULL, NULL),
(7485, '2016-09-07 20:15:06', NULL, NULL, 2708, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 20:15:06', 'admin-1473226673-14732505058657131', 1, 0, '', NULL, NULL, NULL),
(7486, '2016-09-07 20:14:49', NULL, NULL, 2708, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 20:14:49', 'admin-1473226673-14732504893623478', 1, 0, '', NULL, NULL, NULL),
(7487, '2016-09-07 19:59:17', NULL, NULL, 2707, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 19:59:17', 'admin-1473226673-14732495572496445', 1, 1, 'SR', 1, NULL, NULL),
(7488, '2016-09-07 19:59:00', NULL, NULL, 2706, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 19:59:00', 'admin-1473226673-14732495397865910', 1, 1, 'SR', NULL, NULL, NULL),
(7489, '2016-09-07 19:59:00', NULL, NULL, 2706, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 19:59:00', 'admin-1473226673-14732495397865910', 1, 1, 'SR', NULL, NULL, NULL),
(7490, '2016-09-07 19:05:01', NULL, NULL, 2705, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 19:05:01', 'admin-1473226673-14732463018185190', 1, 0, '', NULL, NULL, NULL),
(7491, '2016-09-07 11:57:16', NULL, NULL, 2691, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 11:57:16', 'admin-1473210396-14732206362238415', 1, 1, 'SR', NULL, NULL, NULL),
(7492, '2016-09-07 11:58:24', NULL, NULL, 2691, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 11:58:24', 'admin-1473210396-14732207045986745', 1, 1, 'SR', NULL, NULL, NULL),
(7493, '2016-09-07 12:34:32', NULL, NULL, 2692, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 12:34:32', 'admin-1473210396-1473222872225824', 1, 1, 'SR', NULL, NULL, NULL),
(7494, '2016-09-07 12:54:08', NULL, NULL, 2693, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 12:54:08', 'admin-1473210396-14732240478663389', 1, 0, '', NULL, NULL, NULL),
(7495, '2016-09-07 12:57:12', NULL, NULL, 2694, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 12:57:12', 'admin-1473210396-1473224231799115', 1, 1, 'SR', NULL, NULL, NULL),
(7496, '2016-09-07 12:57:12', NULL, NULL, 2694, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 12:57:12', 'admin-1473210396-1473224231799115', 1, 0, '', NULL, NULL, NULL),
(7497, '2016-09-07 12:57:59', NULL, NULL, 2694, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 12:57:59', 'admin-1473210396-14732242791663076', 1, 0, '', NULL, NULL, NULL),
(7498, '2016-09-07 13:00:26', NULL, NULL, 2695, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 13:00:26', 'admin-1473210396-14732244267237464', 1, 1, 'SR', NULL, NULL, NULL),
(7499, '2016-09-07 13:14:20', NULL, NULL, 2695, 0, 198, '133', 'Dinner - Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 13:14:20', 'admin-1473210396-14732252599315036', 1, 0, '', NULL, NULL, NULL),
(7500, '2016-09-07 13:00:26', NULL, NULL, 2695, 0, 181, '116', 'Open Food ', 'Chili Pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 13:00:26', 'admin-1473210396-14732244267237464', 1, 0, '', NULL, NULL, NULL),
(7501, '2016-09-07 13:00:26', NULL, NULL, 2695, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 13:00:26', 'admin-1473210396-14732244267237464', 1, 1, 'SR', NULL, NULL, NULL),
(7502, '2016-09-07 13:00:26', NULL, NULL, 2695, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 13:00:26', 'admin-1473210396-14732244267237464', 1, 1, 'SR', NULL, NULL, NULL),
(7503, '2016-09-07 13:28:37', NULL, NULL, 2696, 0, 83, '83', 'Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 13:28:37', 'admin-1473210396-14732261169331462', 1, 1, 'SR', NULL, NULL, NULL),
(7504, '2016-09-07 13:38:04', NULL, NULL, 2697, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 13:38:04', 'admin-1473226673-14732266845795761', 1, 1, 'SR', NULL, NULL, NULL),
(7505, '2016-09-07 13:38:04', NULL, NULL, 2697, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 13:38:04', 'admin-1473226673-14732266845795761', 1, 1, 'SR', NULL, NULL, NULL),
(7506, '2016-09-07 13:39:07', NULL, NULL, 2690, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 13:39:07', 'admin-1473226673-14732267468782668', 1, 1, 'SR', NULL, NULL, NULL),
(7507, '2016-09-07 13:39:07', NULL, NULL, 2690, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 13:39:07', 'admin-1473226673-14732267468782668', 1, 1, 'SR', NULL, NULL, NULL),
(7508, '2016-09-07 13:52:11', NULL, NULL, 2698, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 13:52:11', 'admin-1473226673-14732275310977423', 1, 1, 'SR', NULL, NULL, NULL),
(7509, '2016-09-07 14:01:27', NULL, NULL, 2696, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 14:01:27', 'admin-1473226673-14732280870106623', 1, 0, '', NULL, NULL, NULL),
(7510, '2016-09-07 18:58:59', NULL, NULL, 2704, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 18:58:59', 'admin-1473226673-14732459395827971', 1, 0, '', NULL, NULL, NULL),
(7511, '2016-09-07 18:58:59', NULL, NULL, 2704, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 18:58:59', 'admin-1473226673-14732459395827971', 1, 0, '', NULL, NULL, NULL),
(7512, '2016-09-07 14:14:06', NULL, NULL, 2699, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 14:14:06', 'admin-1473226673-1473228846330264', 1, 0, '', NULL, NULL, NULL),
(7513, '2016-09-07 11:08:15', NULL, NULL, 2690, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 11:08:15', 'admin-1473210396-14732176956799039', 1, 0, '', NULL, NULL, NULL),
(7514, '2016-09-07 11:08:15', NULL, NULL, 2690, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 11:08:15', 'admin-1473210396-14732176956799039', 1, 1, 'SR', NULL, NULL, NULL),
(7515, '2016-09-07 09:59:40', NULL, NULL, 2688, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 09:59:40', 'admin-1473210396-1473213580666457', 1, 1, 'SR', NULL, NULL, NULL),
(7516, '2016-09-07 10:13:04', NULL, NULL, 2689, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 10:13:04', 'admin-1473210396-14732143840473884', 1, 1, 'SR', 1, NULL, NULL),
(7517, '2016-09-07 11:08:15', NULL, NULL, 2690, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 11:08:15', 'admin-1473210396-14732176956799039', 1, 1, 'SR', NULL, NULL, NULL),
(7518, '2016-09-07 09:59:40', NULL, NULL, 2688, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 09:59:40', 'admin-1473210396-1473213580666457', 1, 1, 'SR', NULL, NULL, NULL),
(7519, '2016-09-07 09:38:22', NULL, NULL, 2687, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 09:38:22', 'admin-1473210396-1473212302441785', 1, 1, 'SR', NULL, NULL, NULL),
(7520, '2016-09-07 09:59:40', NULL, NULL, 2688, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 09:59:40', 'admin-1473210396-1473213580666457', 1, 0, '', NULL, NULL, NULL),
(7521, '2016-09-07 09:59:40', NULL, NULL, 2688, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 09:59:40', 'admin-1473210396-1473213580666457', 1, 0, '', NULL, NULL, NULL),
(7522, '2016-09-07 09:59:40', NULL, NULL, 2688, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 09:59:40', 'admin-1473210396-1473213580666457', 1, 1, 'SR', NULL, NULL, NULL),
(7523, '2016-09-07 09:38:22', NULL, NULL, 2687, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 09:38:22', 'admin-1473210396-1473212302441785', 1, 0, '', NULL, NULL, NULL),
(7524, '2016-09-07 09:35:55', NULL, NULL, 2686, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 09:35:55', 'admin-1473210396-14732121556514815', 1, 1, 'SR', NULL, NULL, NULL),
(7525, '2016-09-07 09:35:21', NULL, NULL, 2686, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473251390', 'admin', '2016-09-07 09:35:21', 'admin-1473210396-14732121216833662', 1, 0, '', NULL, NULL, NULL),
(7526, '2016-09-08 11:51:32', NULL, NULL, 2719, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 11:51:32', 'admin-1473305372-14733066922166486', 1, 0, '', NULL, NULL, NULL),
(7527, '2016-09-08 16:20:27', NULL, NULL, 2733, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 16:20:27', 'admin-1473319150-14733228276941481', 1, 1, 'SR', NULL, NULL, NULL),
(7528, '2016-09-08 16:20:27', NULL, NULL, 2733, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 16:20:27', 'admin-1473319150-14733228276941481', 1, 1, 'SR', NULL, NULL, NULL),
(7529, '2016-09-08 16:34:26', NULL, NULL, 2734, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 16:34:26', 'admin-1473319150-14733236660213248', 1, 0, '', NULL, NULL, NULL),
(7530, '2016-09-08 16:34:26', NULL, NULL, 2734, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 16:34:26', 'admin-1473319150-14733236660213248', 1, 0, '', NULL, NULL, NULL),
(7531, '2016-09-08 16:44:01', NULL, NULL, 2735, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 16:44:01', 'admin-1473319150-14733242412093184', 1, 0, '', 1, NULL, NULL),
(7532, '2016-09-08 16:35:53', NULL, NULL, 2734, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 16:35:53', 'admin-1473319150-14733237533566892', 1, 0, '', NULL, NULL, NULL),
(7533, '2016-09-08 16:35:53', NULL, NULL, 2734, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 16:35:53', 'admin-1473319150-14733237533566892', 1, 1, 'SR', NULL, NULL, NULL),
(7534, '2016-09-08 16:44:01', NULL, NULL, 2735, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 16:44:01', 'admin-1473319150-14733242412093184', 1, 0, '', 1, NULL, NULL),
(7535, '2016-09-08 17:40:02', NULL, NULL, 2736, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 17:40:02', 'admin-1473319150-1473327602172256', 1, 0, '', 1, NULL, NULL),
(7536, '2016-09-08 17:57:28', NULL, NULL, 2737, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 17:57:28', 'admin-1473319150-14733286484211033', 1, 0, '', NULL, NULL, NULL),
(7537, '2016-09-08 17:58:29', NULL, NULL, 2738, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 17:58:29', 'admin-1473319150-14733287088808046', 1, 1, 'SR', NULL, NULL, NULL),
(7538, '2016-09-08 17:58:34', NULL, NULL, 2738, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 17:58:34', 'admin-1473319150-14733287140537572', 1, 1, 'SR', NULL, NULL, NULL),
(7539, '2016-09-08 18:02:42', NULL, NULL, 2739, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 18:02:42', 'admin-1473319150-14733289620064828', 1, 1, 'SR', NULL, NULL, NULL),
(7540, '2016-09-08 18:17:42', NULL, NULL, 2740, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 18:17:42', 'admin-1473319150-14733298620465413', 1, 1, 'SR', 1, NULL, NULL),
(7541, '2016-09-08 09:47:36', NULL, NULL, 2713, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 09:47:36', 'admin-1473296496-14732992557598615', 1, 0, '', NULL, NULL, NULL),
(7542, '2016-09-08 10:03:29', NULL, NULL, 2714, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 10:03:29', 'admin-1473296496-14733002088487987', 1, 1, 'SR', NULL, NULL, NULL),
(7543, '2016-09-08 10:03:51', NULL, NULL, 2714, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 10:03:51', 'admin-1473296496-14733002308266953', 1, 1, 'SR', NULL, NULL, NULL),
(7544, '2016-09-08 10:56:59', NULL, NULL, 2715, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 10:56:59', 'admin-1473296496-1473303419421975', 1, 1, 'SR', NULL, NULL, NULL),
(7545, '2016-09-08 10:57:07', NULL, NULL, 2716, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 10:57:07', 'admin-1473296496-14733034273436335', 1, 1, 'SR', NULL, NULL, NULL),
(7546, '2016-09-08 11:10:16', NULL, NULL, 2715, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 11:10:16', 'admin-1473296496-14733042166356777', 1, 1, 'SR', NULL, NULL, NULL),
(7547, '2016-09-08 11:10:16', NULL, NULL, 2715, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 11:10:16', 'admin-1473296496-14733042166356777', 1, 1, 'SR', NULL, NULL, NULL),
(7548, '2016-09-08 11:15:45', NULL, NULL, 2717, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 11:15:45', 'admin-1473296496-14733045455771852', 1, 0, '', NULL, NULL, NULL),
(7549, '2016-09-08 11:15:45', NULL, NULL, 2717, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 11:15:45', 'admin-1473296496-14733045455771852', 1, 0, '', NULL, NULL, NULL),
(7550, '2016-09-08 12:48:58', NULL, NULL, 2718, 0, 83, '83', 'Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 12:48:58', 'admin-1473309015-1473310138582672', 1, 1, 'SR', NULL, NULL, NULL),
(7551, '2016-09-08 12:48:58', NULL, NULL, 2718, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 12:48:58', 'admin-1473309015-1473310138582672', 1, 0, '', NULL, NULL, NULL),
(7552, '2016-09-08 11:38:08', NULL, NULL, 2719, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 11:38:08', 'admin-1473305372-14733058881799759', 1, 1, 'SR', NULL, NULL, NULL),
(7553, '2016-09-08 15:24:24', NULL, NULL, 2731, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 15:24:24', 'admin-1473319150-14733194638582352', 1, 1, 'SR', 1, NULL, NULL),
(7554, '2016-09-08 15:38:35', NULL, NULL, 2732, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 15:38:35', 'admin-1473319150-1473320315684196', 1, 1, 'SR', NULL, NULL, NULL),
(7555, '2016-09-08 15:18:35', NULL, NULL, 2725, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 15:18:35', 'admin-1473310160-14733191155511158', 1, 0, '', NULL, NULL, NULL),
(7556, '2016-09-08 15:01:19', NULL, NULL, 2730, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 15:01:19', 'admin-1473310160-14733180796062939', 1, 1, 'SR', NULL, NULL, NULL),
(7557, '2016-09-08 15:24:24', NULL, NULL, 2731, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 15:24:24', 'admin-1473319150-14733194638582352', 1, 1, 'SR', 1, NULL, NULL),
(7558, '2016-09-08 15:01:19', NULL, NULL, 2730, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 15:01:19', 'admin-1473310160-14733180796062939', 1, 0, '', NULL, NULL, NULL),
(7559, '2016-09-08 09:47:36', NULL, NULL, 2713, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 09:47:36', 'admin-1473296496-14732992557598615', 1, 0, '', NULL, NULL, NULL),
(7560, '2016-09-08 14:59:05', NULL, NULL, 2729, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 14:59:05', 'admin-1473310160-14733179456806419', 1, 0, '', NULL, NULL, NULL),
(7561, '2016-09-08 14:53:10', NULL, NULL, 2728, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 14:53:10', 'admin-1473310160-14733175901212233', 1, 1, 'SR', NULL, NULL, NULL),
(7562, '2016-09-08 14:14:20', NULL, NULL, 2727, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 14:14:20', 'admin-1473310160-14733152602193860', 1, 1, 'SR', NULL, NULL, NULL),
(7563, '2016-09-08 14:14:20', NULL, NULL, 2727, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 14:14:20', 'admin-1473310160-14733152602193860', 1, 1, 'SR', NULL, NULL, NULL),
(7564, '2016-09-08 14:14:20', NULL, NULL, 2727, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 14:14:20', 'admin-1473310160-14733152602193860', 1, 1, 'SR', NULL, NULL, NULL),
(7565, '2016-09-08 14:14:20', NULL, NULL, 2727, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 14:14:20', 'admin-1473310160-14733152602193860', 1, 1, 'SR', NULL, NULL, NULL),
(7566, '2016-09-08 13:34:04', NULL, NULL, 2726, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 13:34:04', 'admin-1473310160-14733128441169684', 1, 0, '', NULL, NULL, NULL),
(7567, '2016-09-08 13:34:04', NULL, NULL, 2726, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 13:34:04', 'admin-1473310160-14733128441169684', 1, 0, '', NULL, NULL, NULL),
(7568, '2016-09-08 13:34:04', NULL, NULL, 2726, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 13:34:04', 'admin-1473310160-14733128441169684', 1, 1, 'SR', NULL, NULL, NULL),
(7569, '2016-09-08 13:19:22', NULL, NULL, 2725, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 13:19:22', 'admin-1473310160-14733119626759830', 1, 1, 'SR', NULL, NULL, NULL),
(7570, '2016-09-08 13:19:22', NULL, NULL, 2725, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 13:19:22', 'admin-1473310160-14733119626759830', 1, 1, 'SR', NULL, NULL, NULL),
(7571, '2016-09-08 12:58:49', NULL, NULL, 2724, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 12:58:49', 'admin-1473310160-14733107289683211', 1, 1, 'SR', NULL, NULL, NULL),
(7572, '2016-09-08 12:56:47', NULL, NULL, 2723, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 12:56:47', 'admin-1473310160-14733106075757175', 1, 1, 'SR', NULL, NULL, NULL),
(7573, '2016-09-08 12:56:47', NULL, NULL, 2723, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 12:56:47', 'admin-1473310160-14733106075757175', 1, 0, '', NULL, NULL, NULL),
(7574, '2016-09-08 12:56:47', NULL, NULL, 2723, 0, 83, '83', 'Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 12:56:47', 'admin-1473310160-14733106075757175', 1, 1, 'SR', NULL, NULL, NULL),
(7575, '2016-09-08 12:53:38', NULL, NULL, 2720, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 12:53:38', 'admin-1473310160-14733104185497719', 1, 1, 'SR', NULL, NULL, NULL),
(7576, '2016-09-08 12:53:34', NULL, NULL, 2720, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 12:53:34', 'admin-1473310160-14733104143954719', 1, 0, '', NULL, NULL, NULL),
(7577, '2016-09-08 12:48:58', NULL, NULL, 2718, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 12:48:58', 'admin-1473309015-1473310138582672', 1, 0, '', NULL, NULL, NULL),
(7578, '2016-09-08 12:30:04', NULL, NULL, 2721, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 12:30:04', 'admin-1473305372-14733090045719822', 1, 0, '', NULL, NULL, NULL),
(7579, '2016-09-08 12:30:04', NULL, NULL, 2721, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 12:30:04', 'admin-1473305372-14733090045719822', 1, 1, 'SR', NULL, NULL, NULL),
(7580, '2016-09-08 12:08:23', NULL, NULL, 2720, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 12:08:23', 'admin-1473305372-14733077031154377', 1, 0, '', NULL, NULL, NULL),
(7581, '2016-09-08 12:08:23', NULL, NULL, 2720, 0, 181, '116', 'Open Food ', 'Lemony Chicken', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 12:08:23', 'admin-1473305372-14733077031154377', 1, 0, '', NULL, NULL, NULL),
(7582, '2016-09-08 12:08:23', NULL, NULL, 2720, 0, 181, '116', 'Open Food ', 'Spicy pork', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 12:08:23', 'admin-1473305372-14733077031154377', 1, 0, '', NULL, NULL, NULL),
(7583, '2016-09-08 12:02:08', NULL, NULL, 2715, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 12:02:08', 'admin-1473305372-14733073283915983', 1, 1, 'SR', NULL, NULL, NULL),
(7584, '2016-09-08 12:02:08', NULL, NULL, 2715, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 12:02:08', 'admin-1473305372-14733073283915983', 1, 0, '', NULL, NULL, NULL),
(7585, '2016-09-08 12:01:16', NULL, NULL, 2715, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 12:01:16', 'admin-1473305372-14733072757918345', 1, 1, 'SR', NULL, NULL, NULL),
(7586, '2016-09-08 11:55:24', NULL, NULL, 2716, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 11:55:24', 'admin-1473305372-14733069241316412', 1, 1, 'SR', NULL, NULL, NULL),
(7587, '2016-09-08 11:55:24', NULL, NULL, 2716, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 11:55:24', 'admin-1473305372-14733069241316412', 1, 1, 'SR', NULL, NULL, NULL),
(7588, '2016-09-08 13:34:04', NULL, NULL, 2726, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 13:34:04', 'admin-1473310160-14733128441169684', 1, 1, 'SR', NULL, NULL, NULL),
(7589, '2016-09-08 11:55:24', NULL, NULL, 2716, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 11:55:24', 'admin-1473305372-14733069241316412', 1, 1, 'SR', NULL, NULL, NULL),
(7590, '2016-09-08 11:51:32', NULL, NULL, 2719, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 11:51:32', 'admin-1473305372-14733066922166486', 1, 1, 'SR', NULL, NULL, NULL),
(7591, '2016-09-08 11:38:08', NULL, NULL, 2719, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 11:38:08', 'admin-1473305372-14733058881799759', 1, 1, 'SR', NULL, NULL, NULL),
(7592, '2016-09-08 09:47:36', NULL, NULL, 2713, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 09:47:36', 'admin-1473296496-14732992557598615', 1, 0, '', NULL, NULL, NULL),
(7593, '2016-09-08 09:33:06', NULL, NULL, 2712, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 09:33:06', 'admin-1473296496-1473298386336904', 1, 1, 'SR', NULL, NULL, NULL),
(7594, '2016-09-08 09:47:36', NULL, NULL, 2713, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 09:47:36', 'admin-1473296496-14732992557598615', 1, 1, 'SR', NULL, NULL, NULL),
(7595, '2016-09-08 09:47:35', NULL, NULL, 2713, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 09:47:35', 'admin-1473296496-14732992557598615', 1, 1, 'SR', NULL, NULL, NULL),
(7596, '2016-09-08 09:47:35', NULL, NULL, 2713, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 09:47:35', 'admin-1473296496-14732992557598615', 1, 1, 'SR', NULL, NULL, NULL),
(7597, '2016-09-08 09:33:06', NULL, NULL, 2712, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 09:33:06', 'admin-1473296496-1473298386336904', 1, 1, 'SR', NULL, NULL, NULL),
(7598, '2016-09-08 09:17:08', NULL, NULL, 2711, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 09:17:08', 'admin-1473296496-14732974278467360', 1, 0, '', NULL, NULL, NULL),
(7599, '2016-09-08 09:17:13', NULL, NULL, 2711, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 09:17:13', 'admin-1473296496-1473297433598314', 1, 0, '', NULL, NULL, NULL),
(7600, '2016-09-08 09:32:34', NULL, NULL, 2712, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 09:32:34', 'admin-1473296496-14732983541236351', 1, 0, '', NULL, NULL, NULL),
(7601, '2016-09-08 09:32:34', NULL, NULL, 2712, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 09:32:34', 'admin-1473296496-14732983541236351', 1, 0, '', NULL, NULL, NULL),
(7602, '2016-09-08 09:06:20', NULL, NULL, 2710, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 09:06:20', 'admin-1473296496-1473296780087745', 1, 1, 'SR', NULL, NULL, NULL),
(7603, '2016-09-08 09:06:20', NULL, NULL, 2710, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 09:06:20', 'admin-1473296496-1473296780087745', 1, 0, '', NULL, NULL, NULL),
(7604, '2016-09-08 09:06:20', NULL, NULL, 2710, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473319150', 'admin', '2016-09-08 09:06:20', 'admin-1473296496-1473296780087745', 1, 1, 'SR', NULL, NULL, NULL),
(7605, '2016-09-09 18:57:32', NULL, NULL, 2752, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 18:57:32', 'admin-1473382685-14734186527789334', 1, 1, 'SR', NULL, NULL, NULL),
(7606, '2016-09-09 12:54:57', NULL, NULL, 2743, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 12:54:57', 'admin-1473382685-14733968971391927', 1, 0, '', NULL, NULL, NULL),
(7607, '2016-09-09 12:55:39', NULL, NULL, 2743, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 12:55:39', 'admin-1473382685-14733969390865319', 1, 0, '', NULL, NULL, NULL),
(7608, '2016-09-09 12:56:03', NULL, NULL, 2743, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 12:56:03', 'admin-1473382685-14733969632285967', 1, 0, '', NULL, NULL, NULL),
(7609, '2016-09-09 12:56:50', NULL, NULL, 2743, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 12:56:50', 'admin-1473382685-14733970105477999', 1, 1, 'SR', NULL, NULL, NULL),
(7610, '2016-09-09 13:49:23', NULL, NULL, 2744, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 13:49:23', 'admin-1473382685-14734001636587878', 1, 0, '', NULL, NULL, NULL),
(7611, '2016-09-09 13:49:23', NULL, NULL, 2744, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 13:49:23', 'admin-1473382685-14734001636587878', 1, 1, 'SR', NULL, NULL, NULL),
(7612, '2016-09-09 13:49:23', NULL, NULL, 2744, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 13:49:23', 'admin-1473382685-14734001636587878', 1, 1, 'SR', NULL, NULL, NULL),
(7613, '2016-09-09 13:55:41', NULL, NULL, 2745, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 13:55:41', 'admin-1473382685-14734005410341544', 1, 0, '', NULL, NULL, NULL),
(7614, '2016-09-09 13:55:41', NULL, NULL, 2745, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 13:55:41', 'admin-1473382685-14734005410341544', 1, 0, '', NULL, NULL, NULL),
(7615, '2016-09-09 14:23:35', NULL, NULL, 2746, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 14:23:35', 'admin-1473382685-14734022156851134', 1, 1, 'SR', NULL, NULL, NULL),
(7616, '2016-09-09 14:23:35', NULL, NULL, 2746, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 14:23:35', 'admin-1473382685-14734022156851134', 1, 1, 'SR', NULL, NULL, NULL),
(7617, '2016-09-09 18:48:46', NULL, NULL, 2751, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 18:48:46', 'admin-1473382685-14734181260329515', 1, 1, 'SR', 1, NULL, NULL),
(7618, '2016-09-09 19:23:01', NULL, NULL, 2753, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 19:23:01', 'admin-1473382685-14734201809218989', 1, 0, '', 1, NULL, NULL),
(7619, '2016-09-09 17:35:26', NULL, NULL, 2749, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 17:35:26', 'admin-1473382685-14734137263807525', 1, 1, 'SR', NULL, NULL, NULL),
(7620, '2016-09-09 18:32:02', NULL, NULL, 2750, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 18:32:02', 'admin-1473382685-14734171225566487', 1, 1, 'SR', NULL, NULL, NULL),
(7621, '2016-09-09 17:03:25', NULL, NULL, 2748, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 17:03:25', 'admin-1473382685-14734118049432198', 1, 1, 'SR', NULL, NULL, NULL),
(7622, '2016-09-09 14:28:06', NULL, NULL, 2747, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 14:28:06', 'admin-1473382685-14734024862033822', 1, 1, 'SR', NULL, NULL, NULL),
(7623, '2016-09-09 09:25:01', NULL, NULL, 2741, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 09:25:01', 'admin-1473382685-14733843017754118', 1, 0, '', NULL, NULL, NULL),
(7624, '2016-09-09 09:25:21', NULL, NULL, 2741, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 09:25:21', 'admin-1473382685-14733843209911428', 1, 1, 'SR', NULL, NULL, NULL),
(7625, '2016-09-09 09:25:21', NULL, NULL, 2741, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 09:25:21', 'admin-1473382685-14733843209911428', 1, 1, 'SR', NULL, NULL, NULL),
(7626, '2016-09-09 09:36:15', NULL, NULL, 2742, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 09:36:15', 'admin-1473382685-14733849749731275', 1, 0, '', NULL, NULL, NULL),
(7627, '2016-09-09 09:36:15', NULL, NULL, 2742, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 09:36:15', 'admin-1473382685-14733849749731275', 1, 1, 'SR', NULL, NULL, NULL),
(7628, '2016-09-09 09:36:15', NULL, NULL, 2742, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 09:36:15', 'admin-1473382685-14733849749731275', 1, 1, 'SR', NULL, NULL, NULL),
(7629, '2016-09-09 12:54:57', NULL, NULL, 2743, 0, 181, '116', 'Open Food ', 'Stir Fried Lemony Chicken', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 12:54:57', 'admin-1473382685-14733968971391927', 1, 0, '', NULL, NULL, NULL),
(7630, '2016-09-09 09:25:01', NULL, NULL, 2741, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473382685', 'admin', '2016-09-09 09:25:01', 'admin-1473382685-14733843017754118', 1, 0, '', NULL, NULL, NULL),
(7631, '2016-09-10 11:37:46', NULL, NULL, 2760, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 11:37:46', 'admin-1473478617-14734786664159093', 1, 0, '', NULL, NULL, NULL),
(7632, '2016-09-10 11:37:46', NULL, NULL, 2760, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 11:37:46', 'admin-1473478617-14734786664159093', 1, 0, '', NULL, NULL, NULL),
(7633, '2016-09-10 20:04:47', NULL, NULL, 2774, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 20:04:47', 'admin-1473478617-14735090872217012', 1, 0, '', NULL, NULL, NULL),
(7634, '2016-09-10 12:44:37', NULL, NULL, 2762, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 12:44:37', 'admin-1473478617-14734826772748828', 1, 1, 'SR', NULL, NULL, NULL),
(7635, '2016-09-10 12:39:50', NULL, NULL, 2761, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 12:39:50', 'admin-1473478617-147348239009088', 1, 0, '', NULL, NULL, NULL),
(7636, '2016-09-10 12:39:50', NULL, NULL, 2761, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 12:39:50', 'admin-1473478617-147348239009088', 1, 0, '', NULL, NULL, NULL),
(7637, '2016-09-10 12:39:50', NULL, NULL, 2761, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 12:39:50', 'admin-1473478617-147348239009088', 1, 1, 'SR', NULL, NULL, NULL),
(7638, '2016-09-10 12:39:50', NULL, NULL, 2761, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 12:39:50', 'admin-1473478617-147348239009088', 1, 0, '', NULL, NULL, NULL),
(7639, '2016-09-10 12:01:36', NULL, NULL, 2760, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 12:01:36', 'admin-1473478617-14734800967319048', 1, 0, '', NULL, NULL, NULL),
(7640, '2016-09-10 11:56:03', NULL, NULL, 2759, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 11:56:03', 'admin-1473478617-14734797638242444', 1, 1, 'SR', NULL, NULL, '10.0'),
(7641, '2016-09-10 11:56:03', NULL, NULL, 2759, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 11:56:03', 'admin-1473478617-14734797638242444', 1, 1, 'SR', NULL, NULL, '10.0'),
(7642, '2016-09-10 11:37:46', NULL, NULL, 2760, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 11:37:46', 'admin-1473478617-14734786664159093', 1, 1, 'SR', NULL, NULL, NULL),
(7643, '2016-09-10 20:42:23', NULL, NULL, 2776, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 20:42:23', 'admin-1473478617-14735113433028156', 1, 0, '', 1, NULL, NULL),
(7644, '2016-09-10 20:04:47', NULL, NULL, 2774, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 20:04:47', 'admin-1473478617-14735090872217012', 1, 0, '', NULL, NULL, NULL),
(7645, '2016-09-10 19:09:25', NULL, NULL, 2775, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 19:09:25', 'admin-1473478617-1473505765402167', 1, 1, 'SR', NULL, NULL, NULL),
(7646, '2016-09-10 19:08:39', NULL, NULL, 2774, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 19:08:39', 'admin-1473478617-14735057189758920', 1, 0, '', NULL, NULL, NULL),
(7647, '2016-09-10 19:08:39', NULL, NULL, 2774, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 19:08:39', 'admin-1473478617-14735057189758920', 1, 0, '', NULL, NULL, NULL),
(7648, '2016-09-10 19:08:39', NULL, NULL, 2774, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 19:08:39', 'admin-1473478617-14735057189758920', 1, 1, 'SR', NULL, NULL, NULL),
(7649, '2016-09-10 19:08:39', NULL, NULL, 2774, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 19:08:39', 'admin-1473478617-14735057189758920', 1, 0, '', NULL, NULL, NULL),
(7650, '2016-09-10 19:06:34', NULL, NULL, 2774, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 19:06:34', 'admin-1473478617-14735055940759366', 1, 0, '', NULL, NULL, NULL),
(7651, '2016-09-10 16:23:00', NULL, NULL, 2772, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 16:23:00', 'admin-1473478617-14734957798923493', 1, 0, '', NULL, NULL, NULL),
(7652, '2016-09-10 16:23:30', NULL, NULL, 2772, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 16:23:30', 'admin-1473478617-14734958099468823', 1, 1, 'SR', NULL, NULL, NULL),
(7653, '2016-09-10 13:51:02', NULL, NULL, 2765, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 13:51:02', 'admin-1473478617-1473486661851543', 1, 1, 'SR', 1, NULL, NULL),
(7654, '2016-09-10 15:00:36', NULL, NULL, 2769, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 15:00:36', 'admin-1473478617-14734908358803545', 1, 1, 'SR', NULL, NULL, NULL),
(7655, '2016-09-10 15:00:36', NULL, NULL, 2769, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 15:00:36', 'admin-1473478617-14734908358803545', 1, 1, 'SR', NULL, NULL, NULL),
(7656, '2016-09-10 15:02:36', NULL, NULL, 2770, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 15:02:36', 'admin-1473478617-14734909558423457', 1, 0, '', NULL, NULL, NULL),
(7657, '2016-09-10 15:02:36', NULL, NULL, 2770, 0, 80, '80', 'Summer Salad With Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 15:02:36', 'admin-1473478617-14734909558423457', 1, 1, 'SR', NULL, NULL, NULL),
(7658, '2016-09-10 15:02:36', NULL, NULL, 2770, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 15:02:36', 'admin-1473478617-14734909558423457', 1, 1, 'SR', NULL, NULL, NULL),
(7659, '2016-09-10 15:34:03', NULL, NULL, 2771, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 15:34:03', 'admin-1473478617-14734928430683717', 1, 1, 'SR', NULL, NULL, NULL),
(7660, '2016-09-10 15:34:03', NULL, NULL, 2771, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 15:34:03', 'admin-1473478617-14734928430683717', 1, 1, 'SR', NULL, NULL, NULL),
(7661, '2016-09-10 16:23:00', NULL, NULL, 2772, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 16:23:00', 'admin-1473478617-14734957798923493', 1, 0, '', NULL, NULL, NULL),
(7662, '2016-09-10 13:53:25', NULL, NULL, 2764, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 13:53:25', 'admin-1473478617-14734868049878463', 1, 1, 'SR', NULL, NULL, NULL),
(7663, '2016-09-10 13:53:57', NULL, NULL, 2764, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 13:53:57', 'admin-1473478617-14734868378114387', 1, 0, '', NULL, NULL, NULL),
(7664, '2016-09-10 14:32:46', NULL, NULL, 2766, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 14:32:46', 'admin-1473478617-14734891661052475', 1, 1, 'SR', NULL, NULL, NULL),
(7665, '2016-09-10 14:32:46', NULL, NULL, 2766, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 14:32:46', 'admin-1473478617-14734891661052475', 1, 1, 'SR', NULL, NULL, NULL),
(7666, '2016-09-10 14:32:46', NULL, NULL, 2766, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 14:32:46', 'admin-1473478617-14734891661052475', 1, 0, '', NULL, NULL, NULL),
(7667, '2016-09-10 14:34:14', NULL, NULL, 2767, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 14:34:14', 'admin-1473478617-14734892545714242', 1, 1, 'SR', NULL, NULL, NULL),
(7668, '2016-09-10 14:55:39', NULL, NULL, 2768, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 14:55:39', 'admin-1473478617-14734905391785341', 1, 1, 'SR', NULL, NULL, NULL),
(7669, '2016-09-10 14:55:39', NULL, NULL, 2768, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 14:55:39', 'admin-1473478617-14734905391785341', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(7670, '2016-09-10 14:55:39', NULL, NULL, 2768, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 14:55:39', 'admin-1473478617-14734905391785341', 1, 1, 'SR', NULL, NULL, NULL),
(7671, '2016-09-10 13:53:25', NULL, NULL, 2764, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 13:53:25', 'admin-1473478617-14734868049878463', 1, 0, '', NULL, NULL, NULL),
(7672, '2016-09-10 13:53:25', NULL, NULL, 2764, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 13:53:25', 'admin-1473478617-14734868049878463', 1, 0, '', NULL, NULL, NULL),
(7673, '2016-09-10 13:20:49', NULL, NULL, 2763, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 13:20:49', 'admin-1473478617-14734848496591839', 1, 1, 'SR', NULL, NULL, NULL),
(7674, '2016-09-10 16:32:46', NULL, NULL, 2773, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 16:32:46', 'admin-1473478617-14734963661588942', 1, 0, '', NULL, NULL, NULL),
(7675, '2016-09-10 13:53:25', NULL, NULL, 2764, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 13:53:25', 'admin-1473478617-14734868049878463', 1, 0, '', NULL, NULL, NULL),
(7676, '2016-09-10 11:15:08', NULL, NULL, 2758, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 11:15:08', 'admin-1473468272-14734773085185051', 1, 1, 'SR', 1, NULL, NULL),
(7677, '2016-09-10 11:20:28', NULL, NULL, 2759, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 11:20:28', 'admin-1473468272-14734776285813873', 1, 0, '', NULL, NULL, '10.0'),
(7678, '2016-09-10 11:21:30', NULL, NULL, 2759, 0, 181, '116', 'Open Food ', 'Joyous Sunny', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 11:21:30', 'admin-1473468272-14734776903856065', 1, 0, '', NULL, NULL, '10.0'),
(7679, '2016-09-10 11:15:02', NULL, NULL, 2758, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 11:15:02', 'admin-1473468272-14734773020257747', 1, 1, 'SR', 1, NULL, NULL),
(7680, '2016-09-10 10:30:37', NULL, NULL, 2757, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 10:30:37', 'admin-1473468272-14734746375089756', 1, 1, 'SR', NULL, NULL, NULL),
(7681, '2016-09-10 11:37:46', NULL, NULL, 2760, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 11:37:46', 'admin-1473478617-14734786664159093', 1, 1, 'SR', NULL, NULL, NULL),
(7682, '2016-09-10 10:30:37', NULL, NULL, 2757, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 10:30:37', 'admin-1473468272-14734746375089756', 1, 1, 'SR', NULL, NULL, NULL),
(7683, '2016-09-10 09:20:32', NULL, NULL, 2754, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 09:20:32', 'admin-1473468272-14734704324802412', 1, 0, '', NULL, NULL, NULL),
(7684, '2016-09-10 09:37:25', NULL, NULL, 2755, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 09:37:25', 'admin-1473468272-14734714448751246', 1, 1, 'SR', NULL, NULL, NULL),
(7685, '2016-09-10 09:46:27', NULL, NULL, 2755, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 09:46:27', 'admin-1473468272-14734719876321362', 1, 0, '', NULL, NULL, NULL),
(7686, '2016-09-10 09:49:13', NULL, NULL, 2755, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 09:49:13', 'admin-1473468272-1473472153280330', 1, 0, '', NULL, NULL, NULL),
(7687, '2016-09-10 10:14:33', NULL, NULL, 2756, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 10:14:33', 'admin-1473468272-14734736737153784', 1, 0, '', NULL, NULL, NULL),
(7688, '2016-09-10 10:14:33', NULL, NULL, 2756, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 10:14:33', 'admin-1473468272-14734736737153784', 1, 0, '', NULL, NULL, NULL),
(7689, '2016-09-10 10:14:33', NULL, NULL, 2756, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 10:14:33', 'admin-1473468272-14734736737153784', 1, 1, 'SR', NULL, NULL, NULL),
(7690, '2016-09-10 10:15:12', NULL, NULL, 2756, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 10:15:12', 'admin-1473468272-14734737118199311', 1, 0, '', NULL, NULL, NULL),
(7691, '2016-09-10 09:20:32', NULL, NULL, 2754, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1473478617', 'admin', '2016-09-10 09:20:32', 'admin-1473468272-14734704324802412', 1, 1, 'SR', NULL, NULL, NULL),
(7692, '2016-09-11 20:14:03', NULL, NULL, 2829, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:14:03', 'admin-1473583045-1473596043482382', 1, 0, '', NULL, NULL, '15.0'),
(7693, '2016-09-11 20:14:03', NULL, NULL, 2829, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:14:03', 'admin-1473583045-1473596043482382', 1, 0, '', NULL, NULL, '15.0'),
(7694, '2016-09-11 20:14:03', NULL, NULL, 2829, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:14:03', 'admin-1473583045-1473596043482382', 1, 0, '', NULL, NULL, '15.0'),
(7695, '2016-09-11 20:14:03', NULL, NULL, 2829, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:14:03', 'admin-1473583045-1473596043482382', 1, 0, '', NULL, NULL, '15.0'),
(7696, '2016-09-11 20:14:03', NULL, NULL, 2829, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:14:03', 'admin-1473583045-1473596043482382', 1, 0, '', NULL, NULL, '15.0'),
(7697, '2016-09-11 20:14:03', NULL, NULL, 2829, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:14:03', 'admin-1473583045-1473596043482382', 1, 0, '', NULL, NULL, '15.0'),
(7698, '2016-09-11 20:14:03', NULL, NULL, 2829, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:14:03', 'admin-1473583045-1473596043482382', 1, 0, '', NULL, NULL, '15.0'),
(7699, '2016-09-11 20:14:03', NULL, NULL, 2829, 0, 192, '127', 'Stir Fried Chili Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:14:03', 'admin-1473583045-1473596043482382', 1, 0, '', NULL, NULL, '15.0'),
(7700, '2016-09-11 20:14:03', NULL, NULL, 2829, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:14:03', 'admin-1473583045-1473596043482382', 1, 0, '', NULL, NULL, '15.0'),
(7701, '2016-09-11 20:14:03', NULL, NULL, 2829, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:14:03', 'admin-1473583045-1473596043482382', 1, 0, '', NULL, NULL, '15.0'),
(7702, '2016-09-11 20:14:03', NULL, NULL, 2829, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:14:03', 'admin-1473583045-1473596043482382', 1, 1, 'SR', NULL, NULL, '15.0'),
(7703, '2016-09-11 20:14:13', NULL, NULL, 2829, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:14:13', 'admin-1473583045-14735960536631440', 1, 1, 'SR', NULL, NULL, '15.0'),
(7704, '2016-09-11 20:32:27', NULL, NULL, 2830, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:32:27', 'admin-1473597069-14735971468407396', 1, 1, 'SR', NULL, NULL, NULL),
(7705, '2016-09-11 20:45:52', NULL, NULL, 2829, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:45:52', 'admin-1473597069-14735979525984716', 1, 0, '', NULL, NULL, '15.0'),
(7706, '2016-09-11 20:45:52', NULL, NULL, 2829, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:45:52', 'admin-1473597069-14735979525984716', 1, 0, '', NULL, NULL, '15.0'),
(7707, '2016-09-11 20:48:22', NULL, NULL, 2831, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:48:22', 'admin-1473597069-14735981027131218', 1, 0, '', NULL, NULL, NULL),
(7708, '2016-09-11 20:48:22', NULL, NULL, 2831, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:48:22', 'admin-1473597069-14735981027131218', 1, 1, 'SR', NULL, NULL, NULL),
(7709, '2016-09-11 20:48:22', NULL, NULL, 2831, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:48:22', 'admin-1473597069-14735981027131218', 1, 1, 'SR', NULL, NULL, NULL),
(7710, '2016-09-11 20:50:56', NULL, NULL, 2829, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:50:56', 'admin-1473597069-14735982562437317', 1, 1, 'SR', NULL, NULL, '15.0'),
(7711, '2016-09-11 20:50:56', NULL, NULL, 2829, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:50:56', 'admin-1473597069-14735982562437317', 1, 1, 'SR', NULL, NULL, '15.0'),
(7712, '2016-09-11 21:17:10', NULL, NULL, 2832, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 21:17:10', 'admin-1473597069-14735998302855547', 1, 0, '', 1, NULL, NULL),
(7713, '2016-09-11 14:34:33', NULL, NULL, 2814, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 14:34:33', 'admin-1473569943-1473575673449735', 1, 0, '', NULL, NULL, NULL),
(7714, '2016-09-11 14:34:33', NULL, NULL, 2814, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 14:34:33', 'admin-1473569943-1473575673449735', 1, 0, '', NULL, NULL, NULL),
(7715, '2016-09-11 14:49:54', NULL, NULL, 2811, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 14:49:54', 'admin-1473569943-14735765943236999', 1, 0, '', NULL, NULL, NULL),
(7716, '2016-09-11 14:49:54', NULL, NULL, 2811, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 14:49:54', 'admin-1473569943-14735765943236999', 1, 0, '', NULL, NULL, NULL),
(7717, '2016-09-11 15:09:55', NULL, NULL, 2815, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 15:09:55', 'admin-1473569943-14735777951657685', 1, 1, 'SR', NULL, NULL, NULL),
(7718, '2016-09-11 15:09:55', NULL, NULL, 2815, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 15:09:55', 'admin-1473569943-14735777951657685', 1, 1, 'SR', NULL, NULL, NULL),
(7719, '2016-09-11 15:09:55', NULL, NULL, 2815, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 15:09:55', 'admin-1473569943-14735777951657685', 1, 1, 'SR', NULL, NULL, NULL),
(7720, '2016-09-11 19:58:07', NULL, NULL, 2827, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 19:58:07', 'admin-1473583045-14735950870304540', 1, 1, 'SR', NULL, NULL, NULL),
(7721, '2016-09-11 20:12:56', NULL, NULL, 2828, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:12:56', 'admin-1473583045-14735959760467562', 1, 0, '', NULL, NULL, NULL),
(7722, '2016-09-11 20:12:56', NULL, NULL, 2828, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:12:56', 'admin-1473583045-14735959760467562', 1, 0, '', NULL, NULL, NULL),
(7723, '2016-09-11 20:12:56', NULL, NULL, 2828, 0, 196, '131', 'Dinner - Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 20:12:56', 'admin-1473583045-14735959760467562', 1, 0, '', NULL, NULL, NULL),
(7724, '2016-09-11 19:58:07', NULL, NULL, 2827, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 19:58:07', 'admin-1473583045-14735950870304540', 1, 0, '', NULL, NULL, NULL),
(7725, '2016-09-11 19:58:07', NULL, NULL, 2827, 0, 192, '127', 'Stir Fried Chili Pork', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 19:58:07', 'admin-1473583045-14735950870304540', 1, 0, '', NULL, NULL, NULL),
(7726, '2016-09-11 19:52:36', NULL, NULL, 2826, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 19:52:36', 'admin-1473583045-14735947565681699', 1, 1, 'SR', NULL, NULL, NULL),
(7727, '2016-09-11 19:52:36', NULL, NULL, 2826, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 19:52:36', 'admin-1473583045-14735947565681699', 1, 1, 'SR', NULL, NULL, NULL),
(7728, '2016-09-11 19:52:36', NULL, NULL, 2826, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 19:52:36', 'admin-1473583045-14735947565681699', 1, 1, 'SR', NULL, NULL, NULL),
(7729, '2016-09-11 19:52:36', NULL, NULL, 2826, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 19:52:36', 'admin-1473583045-14735947565681699', 1, 0, '', NULL, NULL, NULL),
(7730, '2016-09-11 19:52:36', NULL, NULL, 2826, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 19:52:36', 'admin-1473583045-14735947565681699', 1, 0, '', NULL, NULL, NULL),
(7731, '2016-09-11 19:52:36', NULL, NULL, 2826, 0, 181, '116', 'Open Food ', 'Lemony Chicken', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 19:52:36', 'admin-1473583045-14735947565681699', 1, 0, '', NULL, NULL, NULL),
(7732, '2016-09-11 13:44:02', NULL, NULL, 2809, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 13:44:02', 'admin-1473569943-14735726422434159', 1, 1, 'SR', NULL, NULL, NULL),
(7733, '2016-09-11 12:41:48', NULL, NULL, 2804, 0, 85, '85', 'Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:41:48', 'admin-1473565886-1473568908170338', 1, 1, 'SR', NULL, NULL, NULL),
(7734, '2016-09-11 12:41:48', NULL, NULL, 2804, 0, 80, '80', 'Summer Salad With Chicken ', 'bacon not chicken', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:41:48', 'admin-1473565886-1473568908170338', 1, 1, 'SR', NULL, NULL, NULL),
(7735, '2016-09-11 19:51:12', NULL, NULL, 2826, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 19:51:12', 'admin-1473583045-1473594672636223', 1, 0, '', NULL, NULL, NULL),
(7736, '2016-09-11 19:07:39', NULL, NULL, 2825, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 19:07:39', 'admin-1473583045-14735920589139215', 1, 1, 'SR', NULL, NULL, NULL),
(7737, '2016-09-11 19:07:39', NULL, NULL, 2825, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 19:07:39', 'admin-1473583045-14735920589139215', 1, 0, '', NULL, NULL, NULL),
(7738, '2016-09-11 18:19:11', NULL, NULL, 2824, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 18:19:11', 'admin-1473583045-1473589151744468', 1, 1, 'SR', NULL, NULL, NULL),
(7739, '2016-09-11 16:45:10', NULL, NULL, 2823, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 16:45:10', 'admin-1473583045-14735835101536960', 1, 0, '', NULL, NULL, NULL),
(7740, '2016-09-11 16:45:10', NULL, NULL, 2823, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 16:45:10', 'admin-1473583045-14735835101536960', 1, 1, 'SR', NULL, NULL, NULL),
(7741, '2016-09-11 16:37:33', NULL, NULL, 2822, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 16:37:33', 'admin-1473583045-14735830531472447', 1, 0, '', NULL, NULL, NULL),
(7742, '2016-09-11 16:45:10', NULL, NULL, 2823, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 16:45:10', 'admin-1473583045-14735835101536960', 1, 0, '', NULL, NULL, NULL),
(7743, '2016-09-11 16:35:54', NULL, NULL, 2822, 0, 155, '89', 'Sunny Side Up ', '', 'Meals', 'Morning Bites ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 16:35:54', 'admin-1473569943-14735829539991033', 1, 0, '', NULL, NULL, NULL),
(7744, '2016-09-11 16:17:44', NULL, NULL, 2821, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 16:17:44', 'admin-1473569943-14735818641894355', 1, 0, '', NULL, NULL, NULL),
(7745, '2016-09-11 15:20:53', NULL, NULL, 2816, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 15:20:53', 'admin-1473569943-14735784529595829', 1, 0, '', 1, NULL, NULL),
(7746, '2016-09-11 15:23:46', NULL, NULL, 2817, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 15:23:46', 'admin-1473569943-14735786265397434', 1, 1, 'SR', NULL, NULL, NULL),
(7747, '2016-09-11 15:24:46', NULL, NULL, 2818, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 15:24:46', 'admin-1473569943-14735786863614086', 1, 1, 'SR', NULL, NULL, NULL),
(7748, '2016-09-11 15:24:46', NULL, NULL, 2818, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 15:24:46', 'admin-1473569943-14735786863614086', 1, 0, '', NULL, NULL, NULL),
(7749, '2016-09-11 15:44:30', NULL, NULL, 2820, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 15:44:30', 'admin-1473569943-14735798698427085', 1, 1, 'SR', NULL, NULL, NULL),
(7750, '2016-09-11 15:52:41', NULL, NULL, 2819, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 15:52:41', 'admin-1473569943-14735803608459919', 1, 0, '', NULL, NULL, NULL),
(7751, '2016-09-11 16:17:44', NULL, NULL, 2821, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 16:17:44', 'admin-1473569943-14735818641894355', 1, 0, '', NULL, NULL, NULL),
(7752, '2016-09-11 15:18:14', NULL, NULL, 2802, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 15:18:14', 'admin-1473569943-14735782943133111', 1, 1, 'SR', NULL, NULL, NULL),
(7753, '2016-09-11 15:42:44', NULL, NULL, 2819, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 15:42:44', 'admin-1473569943-14735797646258131', 1, 0, '', NULL, NULL, NULL),
(7754, '2016-09-11 15:42:44', NULL, NULL, 2819, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 15:42:44', 'admin-1473569943-14735797646258131', 1, 0, '', NULL, NULL, NULL),
(7755, '2016-09-11 15:44:30', NULL, NULL, 2820, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 15:44:30', 'admin-1473569943-14735798698427085', 1, 0, '', NULL, NULL, NULL),
(7756, '2016-09-11 15:18:14', NULL, NULL, 2802, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 15:18:14', 'admin-1473569943-14735782943133111', 1, 1, 'SR', NULL, NULL, NULL),
(7757, '2016-09-11 14:26:52', NULL, NULL, 2812, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 14:26:52', 'admin-1473569943-14735752119528962', 1, 1, 'SR', 1, NULL, NULL),
(7758, '2016-09-11 14:34:11', NULL, NULL, 2813, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 14:34:11', 'admin-1473569943-1473575651834756', 1, 1, 'SR', NULL, NULL, NULL),
(7759, '2016-09-11 14:12:21', NULL, NULL, 2811, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 14:12:21', 'admin-1473569943-1473574341723441', 1, 1, 'SR', NULL, NULL, NULL),
(7760, '2016-09-11 14:09:40', NULL, NULL, 2810, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 14:09:40', 'admin-1473569943-1473574180057910', 1, 1, 'SR', NULL, NULL, NULL),
(7761, '2016-09-11 14:12:21', NULL, NULL, 2811, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 14:12:21', 'admin-1473569943-1473574341723441', 1, 1, 'SR', NULL, NULL, NULL),
(7762, '2016-09-11 12:52:02', NULL, NULL, 2805, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:52:02', 'admin-1473568914-1473569522618717', 1, 0, '', NULL, NULL, NULL),
(7763, '2016-09-11 13:44:02', NULL, NULL, 2809, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 13:44:02', 'admin-1473569943-14735726422434159', 1, 0, '', NULL, NULL, NULL),
(7764, '2016-09-11 13:44:02', NULL, NULL, 2809, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 13:44:02', 'admin-1473569943-14735726422434159', 1, 0, '', NULL, NULL, NULL),
(7765, '2016-09-11 13:39:50', NULL, NULL, 2808, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 13:39:50', 'admin-1473569943-1473572390167256', 1, 0, '', NULL, NULL, NULL),
(7766, '2016-09-11 13:41:41', NULL, NULL, 2802, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 13:41:41', 'admin-1473569943-14735725016089553', 1, 1, 'SR', NULL, NULL, NULL),
(7767, '2016-09-11 13:41:41', NULL, NULL, 2802, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 13:41:41', 'admin-1473569943-14735725016089553', 1, 1, 'SR', NULL, NULL, NULL),
(7768, '2016-09-11 13:44:02', NULL, NULL, 2809, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 13:44:02', 'admin-1473569943-14735726422434159', 1, 1, 'SR', NULL, NULL, NULL),
(7769, '2016-09-11 13:44:02', NULL, NULL, 2809, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 13:44:02', 'admin-1473569943-14735726422434159', 1, 1, 'SR', NULL, NULL, NULL),
(7770, '2016-09-11 13:39:50', NULL, NULL, 2808, 0, 75, '75', 'Aglio Olio ', 'Chicken', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 13:39:50', 'admin-1473569943-1473572390167256', 1, 0, '', NULL, NULL, NULL),
(7771, '2016-09-11 13:39:50', NULL, NULL, 2808, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 13:39:50', 'admin-1473569943-1473572390167256', 1, 1, 'SR', NULL, NULL, NULL),
(7772, '2016-09-11 13:39:50', NULL, NULL, 2808, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 13:39:50', 'admin-1473569943-1473572390167256', 1, 1, 'SR', NULL, NULL, NULL),
(7773, '2016-09-11 11:52:37', NULL, NULL, 2792, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:52:37', 'admin-1473565886-14735659577115596', 1, 1, 'SR', NULL, NULL, NULL),
(7774, '2016-09-11 11:51:20', NULL, NULL, 2792, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:51:20', 'admin-1473562727-14735658799605677', 1, 0, '', NULL, '0.0', NULL),
(7775, '2016-09-11 14:12:21', NULL, NULL, 2811, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 14:12:21', 'admin-1473569943-1473574341723441', 1, 1, 'SR', NULL, NULL, NULL),
(7776, '2016-09-11 11:56:11', NULL, NULL, 2793, NULL, 84, '84', 'Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:56:11', 'admin-1473565886-14735661708822498', 1, 1, 'SR', NULL, NULL, '10.0'),
(7777, '2016-09-11 11:56:11', NULL, NULL, 2793, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:56:11', 'admin-1473565886-14735661708822498', 1, 1, 'SR', NULL, NULL, '10.0'),
(7778, '2016-09-11 12:02:28', NULL, NULL, 2794, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:02:28', 'admin-1473565886-14735665487694358', 1, 1, 'SR', NULL, NULL, '10.0'),
(7779, '2016-09-11 12:02:28', NULL, NULL, 2794, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:02:28', 'admin-1473565886-14735665487694358', 1, 1, 'SR', NULL, NULL, '10.0'),
(7780, '2016-09-11 12:02:28', NULL, NULL, 2794, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:02:28', 'admin-1473565886-14735665487694358', 1, 1, 'SR', NULL, NULL, '10.0'),
(7781, '2016-09-11 12:02:28', NULL, NULL, 2794, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:02:28', 'admin-1473565886-14735665487694358', 1, 1, 'SR', NULL, NULL, '10.0'),
(7782, '2016-09-11 12:02:28', NULL, NULL, 2794, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:02:28', 'admin-1473565886-14735665487694358', 1, 1, 'SR', NULL, NULL, '10.0'),
(7783, '2016-09-11 12:02:29', NULL, NULL, 2794, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:02:29', 'admin-1473565886-14735665487694358', 1, 1, 'SR', NULL, NULL, '10.0'),
(7784, '2016-09-11 12:03:21', NULL, NULL, 2795, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:03:21', 'admin-1473565886-1473566601215349', 1, 0, '', NULL, NULL, NULL),
(7785, '2016-09-11 12:11:41', NULL, NULL, 2796, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:11:41', 'admin-1473565886-14735671011556342', 1, 1, 'SR', NULL, NULL, NULL),
(7786, '2016-09-11 12:11:41', NULL, NULL, 2796, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:11:41', 'admin-1473565886-14735671011556342', 1, 1, 'SR', NULL, NULL, NULL),
(7787, '2016-09-11 12:20:03', NULL, NULL, 2797, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:20:03', 'admin-1473565886-14735676033012184', 1, 1, 'SR', NULL, NULL, NULL),
(7788, '2016-09-11 12:20:23', NULL, NULL, 2797, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:20:23', 'admin-1473565886-14735676234759828', 1, 1, 'SR', NULL, NULL, NULL),
(7789, '2016-09-11 12:23:13', NULL, NULL, 2798, NULL, 84, '84', 'Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:23:13', 'admin-1473565886-14735677930801629', 1, 1, 'SR', NULL, NULL, NULL),
(7790, '2016-09-11 11:51:20', NULL, NULL, 2792, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:51:20', 'admin-1473562727-14735658799605677', 1, 0, '', NULL, NULL, NULL),
(7791, '2016-09-11 10:25:15', NULL, NULL, 2781, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:25:15', 'admin-1473555747-14735607154322114', 1, 0, '', NULL, NULL, NULL),
(7792, '2016-09-11 10:37:56', NULL, NULL, 2782, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:37:56', 'admin-1473555747-14735614764114662', 1, 0, '', NULL, NULL, NULL),
(7793, '2016-09-11 10:37:56', NULL, NULL, 2782, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:37:56', 'admin-1473555747-14735614764114662', 1, 0, '', NULL, NULL, NULL),
(7794, '2016-09-11 10:37:56', NULL, NULL, 2782, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:37:56', 'admin-1473555747-14735614764114662', 1, 0, '', NULL, NULL, NULL),
(7795, '2016-09-11 10:37:56', NULL, NULL, 2782, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:37:56', 'admin-1473555747-14735614764114662', 1, 0, '', NULL, NULL, NULL),
(7796, '2016-09-11 10:37:56', NULL, NULL, 2782, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:37:56', 'admin-1473555747-14735614764114662', 1, 0, '', NULL, NULL, NULL),
(7797, '2016-09-11 10:37:56', NULL, NULL, 2782, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:37:56', 'admin-1473555747-14735614764114662', 1, 1, 'SR', NULL, NULL, NULL),
(7798, '2016-09-11 10:37:56', NULL, NULL, 2782, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:37:56', 'admin-1473555747-14735614764114662', 1, 1, 'SR', NULL, NULL, NULL),
(7799, '2016-09-11 10:37:56', NULL, NULL, 2782, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:37:56', 'admin-1473555747-14735614764114662', 1, 0, '', NULL, NULL, NULL),
(7800, '2016-09-11 12:23:13', NULL, NULL, 2798, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:23:13', 'admin-1473565886-14735677930801629', 1, 1, 'SR', NULL, NULL, NULL),
(7801, '2016-09-11 12:23:28', NULL, NULL, 2799, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:23:28', 'admin-1473565886-1473567808176503', 1, 1, 'SR', NULL, NULL, NULL),
(7802, '2016-09-11 13:33:55', NULL, NULL, 2807, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 13:33:55', 'admin-1473569943-1473572035583860', 1, 0, '', NULL, NULL, NULL),
(7803, '2016-09-11 13:31:39', NULL, NULL, 2806, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 13:31:39', 'admin-1473569943-14735718990893644', 1, 0, '', NULL, NULL, NULL),
(7804, '2016-09-11 13:31:39', NULL, NULL, 2806, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 13:31:39', 'admin-1473569943-14735718990893644', 1, 1, 'SR', NULL, NULL, NULL),
(7805, '2016-09-11 13:31:39', NULL, NULL, 2806, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 13:31:39', 'admin-1473569943-14735718990893644', 1, 0, '', NULL, NULL, NULL),
(7806, '2016-09-11 13:31:39', NULL, NULL, 2806, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 13:31:39', 'admin-1473569943-14735718990893644', 1, 1, 'SR', NULL, NULL, NULL),
(7807, '2016-09-11 13:31:39', NULL, NULL, 2806, 0, 86, '86', 'Pesto Pata ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 13:31:39', 'admin-1473569943-14735718990893644', 1, 1, 'SR', NULL, NULL, NULL),
(7808, '2016-09-11 12:41:48', NULL, NULL, 2804, 0, 181, '116', 'Open Food ', 'chili pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:41:48', 'admin-1473565886-1473568908170338', 1, 0, '', NULL, NULL, NULL),
(7809, '2016-09-11 12:52:02', NULL, NULL, 2805, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:52:02', 'admin-1473568914-1473569522618717', 1, 1, 'SR', NULL, NULL, NULL),
(7810, '2016-09-11 12:52:02', NULL, NULL, 2805, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:52:02', 'admin-1473568914-1473569522618717', 1, 0, '', NULL, NULL, NULL),
(7811, '2016-09-11 12:41:48', NULL, NULL, 2804, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:41:48', 'admin-1473565886-1473568908170338', 1, 1, 'SR', NULL, NULL, NULL),
(7812, '2016-09-11 12:36:05', NULL, NULL, 2802, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:36:05', 'admin-1473565886-14735685656167510', 1, 1, 'SR', NULL, NULL, NULL),
(7813, '2016-09-11 12:36:05', NULL, NULL, 2802, NULL, 84, '84', 'Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:36:05', 'admin-1473565886-14735685656167510', 1, 1, 'SR', NULL, NULL, NULL),
(7814, '2016-09-11 12:36:22', NULL, NULL, 2803, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:36:22', 'admin-1473565886-14735685822646199', 1, 1, 'SR', NULL, NULL, NULL),
(7815, '2016-09-11 12:36:05', NULL, NULL, 2802, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:36:05', 'admin-1473565886-14735685656167510', 1, 1, 'SR', NULL, NULL, NULL),
(7816, '2016-09-11 12:34:40', NULL, NULL, 2801, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:34:40', 'admin-1473565886-14735684798865477', 1, 0, '', NULL, NULL, NULL),
(7817, '2016-09-11 12:27:29', NULL, NULL, 2800, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:27:29', 'admin-1473565886-14735680494556324', 1, 0, '', NULL, NULL, NULL),
(7818, '2016-09-11 12:23:13', NULL, NULL, 2798, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:23:13', 'admin-1473565886-14735677930801629', 1, 1, 'SR', NULL, NULL, NULL),
(7819, '2016-09-11 12:23:13', NULL, NULL, 2798, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:23:13', 'admin-1473565886-14735677930801629', 1, 0, '', NULL, NULL, NULL),
(7820, '2016-09-11 12:34:40', NULL, NULL, 2801, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:34:40', 'admin-1473565886-14735684798865477', 1, 1, 'SR', NULL, NULL, NULL),
(7821, '2016-09-11 12:24:16', NULL, NULL, 2792, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:24:16', 'admin-1473565886-14735678559571453', 1, 1, 'SR', NULL, NULL, NULL),
(7822, '2016-09-11 12:23:28', NULL, NULL, 2799, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:23:28', 'admin-1473565886-1473567808176503', 1, 1, 'SR', NULL, NULL, NULL),
(7823, '2016-09-11 11:52:37', NULL, NULL, 2792, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:52:37', 'admin-1473565886-14735659577115596', 1, 0, '', NULL, NULL, NULL),
(7824, '2016-09-11 11:52:37', NULL, NULL, 2792, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:52:37', 'admin-1473565886-14735659577115596', 1, 1, 'SR', NULL, NULL, NULL),
(7825, '2016-09-11 11:52:37', NULL, NULL, 2792, 0, 181, '116', 'Open Food ', 'fried egg 2', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:52:37', 'admin-1473565886-14735659577115596', 1, 0, '', NULL, NULL, NULL),
(7826, '2016-09-11 11:33:11', NULL, NULL, 2791, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:33:11', 'admin-1473562727-14735647915529698', 1, 1, 'SR', NULL, NULL, NULL),
(7827, '2016-09-11 11:51:20', NULL, NULL, 2792, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:51:20', 'admin-1473562727-14735658799605677', 1, 0, '', NULL, NULL, NULL),
(7828, '2016-09-11 11:33:11', NULL, NULL, 2791, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:33:11', 'admin-1473562727-14735647915529698', 1, 1, 'SR', NULL, NULL, NULL),
(7829, '2016-09-11 11:33:11', NULL, NULL, 2791, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:33:11', 'admin-1473562727-14735647915529698', 1, 1, 'SR', NULL, NULL, NULL),
(7830, '2016-09-11 11:33:11', NULL, NULL, 2791, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:33:11', 'admin-1473562727-14735647915529698', 1, 1, 'SR', NULL, NULL, NULL),
(7831, '2016-09-11 11:31:48', NULL, NULL, 2791, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:31:48', 'admin-1473562727-14735647087008683', 1, 0, '', NULL, NULL, NULL),
(7832, '2016-09-11 11:31:48', NULL, NULL, 2791, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:31:48', 'admin-1473562727-14735647087008683', 1, 0, '', NULL, NULL, NULL),
(7833, '2016-09-11 11:31:48', NULL, NULL, 2791, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:31:48', 'admin-1473562727-14735647087008683', 1, 0, '', NULL, NULL, NULL),
(7834, '2016-09-11 11:31:48', NULL, NULL, 2791, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:31:48', 'admin-1473562727-14735647087008683', 1, 0, '', NULL, NULL, NULL),
(7835, '2016-09-11 10:42:32', NULL, NULL, 2785, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:42:32', 'admin-1473561482-14735617523958151', 1, 1, 'SR', NULL, NULL, NULL),
(7836, '2016-09-11 10:48:25', NULL, NULL, 2786, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:48:25', 'admin-1473561482-14735621050334714', 1, 1, 'SR', NULL, NULL, NULL),
(7837, '2016-09-11 10:49:29', NULL, NULL, 2787, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:49:29', 'admin-1473561482-14735621692363051', 1, 0, '', NULL, NULL, NULL),
(7838, '2016-09-11 10:49:29', NULL, NULL, 2787, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:49:29', 'admin-1473561482-14735621692363051', 1, 0, '', NULL, NULL, NULL),
(7839, '2016-09-11 10:49:29', NULL, NULL, 2787, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:49:29', 'admin-1473561482-14735621692363051', 1, 0, '', NULL, NULL, NULL),
(7840, '2016-09-11 12:23:13', NULL, NULL, 2798, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 12:23:13', 'admin-1473565886-14735677930801629', 1, 0, '', NULL, NULL, NULL),
(7841, '2016-09-11 11:23:42', NULL, NULL, 2790, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:23:42', 'admin-1473562727-14735642221256271', 1, 1, 'SR', NULL, NULL, NULL),
(7842, '2016-09-11 11:23:42', NULL, NULL, 2790, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:23:42', 'admin-1473562727-14735642221256271', 1, 1, 'SR', NULL, NULL, NULL),
(7843, '2016-09-11 11:23:16', NULL, NULL, 2790, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:23:16', 'admin-1473562727-14735641966294689', 1, 0, '', NULL, NULL, NULL),
(7844, '2016-09-11 11:22:59', NULL, NULL, 2790, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:22:59', 'admin-1473562727-14735641788713394', 1, 0, '', NULL, NULL, NULL),
(7845, '2016-09-11 11:22:53', NULL, NULL, 2790, 0, 157, '91', 'French Toast ', 'No banana', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:22:53', 'admin-1473562727-147356417371945', 1, 0, '', NULL, NULL, NULL),
(7846, '2016-09-11 11:22:53', NULL, NULL, 2790, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:22:53', 'admin-1473562727-147356417371945', 1, 0, '', NULL, NULL, NULL),
(7847, '2016-09-11 11:05:04', NULL, NULL, 2789, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:05:04', 'admin-1473562727-14735631047219397', 1, 1, 'SR', NULL, NULL, NULL),
(7848, '2016-09-11 11:00:46', NULL, NULL, 2788, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:00:46', 'admin-1473562727-14735628465491394', 1, 1, 'SR', NULL, NULL, NULL),
(7849, '2016-09-11 11:00:46', NULL, NULL, 2788, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:00:46', 'admin-1473562727-14735628465491394', 1, 1, 'SR', NULL, NULL, NULL),
(7850, '2016-09-11 10:49:29', NULL, NULL, 2787, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:49:29', 'admin-1473561482-14735621692363051', 1, 1, 'SR', NULL, NULL, NULL),
(7851, '2016-09-11 10:48:25', NULL, NULL, 2786, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:48:25', 'admin-1473561482-14735621050334714', 1, 0, '', NULL, NULL, NULL),
(7852, '2016-09-11 10:58:36', NULL, NULL, 2788, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:58:36', 'admin-1473561482-14735627162594044', 1, 1, 'SR', NULL, NULL, NULL),
(7853, '2016-09-11 10:58:36', NULL, NULL, 2788, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:58:36', 'admin-1473561482-14735627162594044', 1, 1, 'SR', NULL, NULL, NULL),
(7854, '2016-09-11 10:58:36', NULL, NULL, 2788, 0, 153, '87', 'Big Breakfast ', 'No baked beans', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:58:36', 'admin-1473561482-14735627162594044', 1, 0, '', NULL, NULL, NULL),
(7855, '2016-09-11 10:58:36', NULL, NULL, 2788, 0, 153, '87', 'Big Breakfast ', 'No baked beans', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:58:36', 'admin-1473561482-14735627162594044', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(7856, '2016-09-11 11:00:46', NULL, NULL, 2788, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:00:46', 'admin-1473562727-14735628465491394', 1, 0, '', NULL, NULL, NULL),
(7857, '2016-09-11 11:00:46', NULL, NULL, 2788, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:00:46', 'admin-1473562727-14735628465491394', 1, 1, 'SR', NULL, NULL, NULL),
(7858, '2016-09-11 10:41:36', NULL, NULL, 2784, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:41:36', 'admin-1473561482-14735616961253327', 1, 0, '', NULL, NULL, NULL),
(7859, '2016-09-11 10:41:36', NULL, NULL, 2784, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:41:36', 'admin-1473561482-14735616961253327', 1, 1, 'SR', NULL, NULL, NULL),
(7860, '2016-09-11 10:42:32', NULL, NULL, 2785, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:42:32', 'admin-1473561482-14735617523958151', 1, 0, '', NULL, NULL, NULL),
(7861, '2016-09-11 11:27:41', NULL, NULL, 2788, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 11:27:41', 'admin-1473562727-14735644614743639', 1, 1, 'SR', NULL, NULL, NULL),
(7862, '2016-09-11 10:40:19', NULL, NULL, 2783, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:40:19', 'admin-1473561482-14735616192759384', 1, 1, 'SR', NULL, NULL, NULL),
(7863, '2016-09-11 10:40:19', NULL, NULL, 2783, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:40:19', 'admin-1473561482-14735616192759384', 1, 0, '', NULL, NULL, NULL),
(7864, '2016-09-11 10:37:56', NULL, NULL, 2782, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:37:56', 'admin-1473555747-14735614764114662', 1, 1, 'SR', NULL, NULL, NULL),
(7865, '2016-09-11 10:25:15', NULL, NULL, 2781, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:25:15', 'admin-1473555747-14735607154322114', 1, 0, '', NULL, NULL, NULL),
(7866, '2016-09-11 10:22:26', NULL, NULL, 2780, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:22:26', 'admin-1473555747-14735605464486683', 1, 1, 'SR', NULL, NULL, NULL),
(7867, '2016-09-11 10:13:21', NULL, NULL, 2777, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:13:21', 'admin-1473555747-14735600010775830', 1, 0, '', NULL, NULL, NULL),
(7868, '2016-09-11 10:13:21', NULL, NULL, 2777, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:13:21', 'admin-1473555747-14735600010775830', 1, 0, '', NULL, NULL, NULL),
(7869, '2016-09-11 10:22:48', NULL, NULL, 2780, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:22:48', 'admin-1473555747-14735605685292390', 1, 1, 'SR', NULL, NULL, NULL),
(7870, '2016-09-11 10:22:26', NULL, NULL, 2780, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:22:26', 'admin-1473555747-14735605464486683', 1, 0, '', NULL, NULL, NULL),
(7871, '2016-09-11 10:22:26', NULL, NULL, 2780, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:22:26', 'admin-1473555747-14735605464486683', 1, 0, '', NULL, NULL, NULL),
(7872, '2016-09-11 10:22:26', NULL, NULL, 2780, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:22:26', 'admin-1473555747-14735605464486683', 1, 0, '', NULL, NULL, NULL),
(7873, '2016-09-11 10:19:14', NULL, NULL, 2779, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:19:14', 'admin-1473555747-14735603546455966', 1, 0, '', NULL, NULL, NULL),
(7874, '2016-09-11 10:17:35', NULL, NULL, 2778, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:17:35', 'admin-1473555747-14735602551356892', 1, 1, 'SR', NULL, NULL, NULL),
(7875, '2016-09-11 10:17:35', NULL, NULL, 2778, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:17:35', 'admin-1473555747-14735602551356892', 1, 0, '', NULL, NULL, NULL),
(7876, '2016-09-11 10:13:21', NULL, NULL, 2777, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:13:21', 'admin-1473555747-14735600010775830', 1, 1, 'SR', NULL, NULL, NULL),
(7877, '2016-09-11 10:13:21', NULL, NULL, 2777, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473597069', 'admin', '2016-09-11 10:13:21', 'admin-1473555747-14735600010775830', 1, 0, '', NULL, NULL, NULL),
(7878, '2016-09-12 19:26:02', NULL, NULL, 2873, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 19:26:02', 'admin-1473671172-14736795627075112', 1, 1, 'SR', NULL, NULL, '10.0'),
(7879, '2016-09-12 19:26:02', NULL, NULL, 2873, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 19:26:02', 'admin-1473671172-14736795627075112', 1, 0, '', NULL, NULL, '10.0'),
(7880, '2016-09-12 19:53:08', NULL, NULL, 2874, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 19:53:08', 'admin-1473671172-14736811884255590', 1, 0, '', NULL, NULL, NULL),
(7881, '2016-09-12 19:53:27', NULL, NULL, 2874, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 19:53:27', 'admin-1473671172-14736812074751599', 1, 0, '', NULL, NULL, NULL),
(7882, '2016-09-12 19:54:49', NULL, NULL, 2875, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 19:54:49', 'admin-1473671172-1473681289044655', 1, 1, 'SR', NULL, NULL, NULL),
(7883, '2016-09-12 19:54:49', NULL, NULL, 2875, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 19:54:49', 'admin-1473671172-1473681289044655', 1, 0, '', NULL, NULL, NULL),
(7884, '2016-09-12 20:09:28', NULL, NULL, 2875, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 20:09:28', 'admin-1473671172-1473682168662930', 1, 1, 'SR', NULL, NULL, NULL),
(7885, '2016-09-12 19:55:23', NULL, NULL, 2875, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 19:55:23', 'admin-1473671172-14736813228138977', 1, 1, 'SR', NULL, NULL, NULL),
(7886, '2016-09-12 20:58:02', NULL, NULL, 2876, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 20:58:02', 'admin-1473671172-1473685081873918', 1, 0, '', NULL, NULL, NULL),
(7887, '2016-09-12 20:58:02', NULL, NULL, 2876, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 20:58:02', 'admin-1473671172-1473685081873918', 1, 1, 'SR', NULL, NULL, NULL),
(7888, '2016-09-12 17:06:50', NULL, NULL, 2869, 0, 79, '79', 'Summer Salad ', 'bacon', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 17:06:50', 'admin-1473671172-14736712103759824', 1, 1, 'SR', NULL, NULL, NULL),
(7889, '2016-09-12 17:06:50', NULL, NULL, 2869, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 17:06:50', 'admin-1473671172-14736712103759824', 1, 1, 'SR', NULL, NULL, NULL),
(7890, '2016-09-12 17:06:50', NULL, NULL, 2869, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 17:06:50', 'admin-1473671172-14736712103759824', 1, 1, 'SR', NULL, NULL, NULL),
(7891, '2016-09-12 15:50:46', NULL, NULL, 2864, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 15:50:46', 'admin-1473656393-14736666464845716', 1, 0, '', NULL, NULL, NULL),
(7892, '2016-09-12 15:50:46', NULL, NULL, 2864, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 15:50:46', 'admin-1473656393-14736666464845716', 1, 0, '', NULL, NULL, NULL),
(7893, '2016-09-12 16:10:28', NULL, NULL, 2865, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 16:10:28', 'admin-1473656393-14736678279137766', 1, 0, '', NULL, NULL, '10.0'),
(7894, '2016-09-12 20:58:02', NULL, NULL, 2876, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 20:58:02', 'admin-1473671172-1473685081873918', 1, 1, 'SR', NULL, NULL, NULL),
(7895, '2016-09-12 17:20:55', NULL, NULL, 2871, 0, 75, '75', 'Aglio Olio ', 'Chicken', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 17:20:55', 'admin-1473671172-14736720553799667', 1, 0, '', NULL, NULL, NULL),
(7896, '2016-09-12 17:20:55', NULL, NULL, 2871, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 17:20:55', 'admin-1473671172-14736720553799667', 1, 1, 'SR', NULL, NULL, NULL),
(7897, '2016-09-12 16:38:29', NULL, NULL, 2868, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 16:38:29', 'admin-1473656393-1473669508843314', 1, 1, 'SR', NULL, NULL, NULL),
(7898, '2016-09-12 17:27:50', NULL, NULL, 2871, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 17:27:50', 'admin-1473671172-14736724706807815', 1, 1, 'SR', NULL, NULL, NULL),
(7899, '2016-09-12 17:27:50', NULL, NULL, 2871, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 17:27:50', 'admin-1473671172-14736724706807815', 1, 0, '', NULL, NULL, NULL),
(7900, '2016-09-12 17:18:47', NULL, NULL, 2870, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 17:18:47', 'admin-1473671172-14736719277535392', 1, 1, 'SR', NULL, NULL, NULL),
(7901, '2016-09-12 17:18:47', NULL, NULL, 2870, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 17:18:47', 'admin-1473671172-14736719277535392', 1, 1, 'SR', NULL, NULL, NULL),
(7902, '2016-09-12 15:48:03', NULL, NULL, 2863, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 15:48:03', 'admin-1473656393-14736664835527576', 1, 1, 'SR', NULL, NULL, NULL),
(7903, '2016-09-12 13:36:19', NULL, NULL, 2854, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 13:36:19', 'admin-1473656393-14736585796055556', 1, 0, '', NULL, NULL, NULL),
(7904, '2016-09-12 13:37:57', NULL, NULL, 2854, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 13:37:57', 'admin-1473656393-14736586773047345', 1, 0, '', NULL, NULL, NULL),
(7905, '2016-09-12 13:37:57', NULL, NULL, 2854, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 13:37:57', 'admin-1473656393-14736586773047345', 1, 1, 'SR', NULL, NULL, NULL),
(7906, '2016-09-12 13:37:57', NULL, NULL, 2854, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 13:37:57', 'admin-1473656393-14736586773047345', 1, 0, '', NULL, NULL, NULL),
(7907, '2016-09-12 13:50:33', NULL, NULL, 2855, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 13:50:33', 'admin-1473656393-14736594329126245', 1, 1, 'SR', NULL, NULL, NULL),
(7908, '2016-09-12 14:20:51', NULL, NULL, 2856, 0, 192, '127', 'Stir Fried Chili Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 14:20:51', 'admin-1473656393-14736612509962765', 1, 0, '', NULL, NULL, NULL),
(7909, '2016-09-12 14:20:51', NULL, NULL, 2856, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 14:20:51', 'admin-1473656393-14736612509962765', 1, 1, 'SR', NULL, NULL, NULL),
(7910, '2016-09-12 14:21:12', NULL, NULL, 2856, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 14:21:12', 'admin-1473656393-1473661272036665', 1, 0, '', NULL, NULL, NULL),
(7911, '2016-09-12 14:27:40', NULL, NULL, 2857, 0, 211, '145', 'Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 14:27:40', 'admin-1473656393-14736616603171719', 1, 0, '', NULL, NULL, NULL),
(7912, '2016-09-12 14:27:40', NULL, NULL, 2857, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 14:27:40', 'admin-1473656393-14736616603171719', 1, 1, 'SR', NULL, NULL, NULL),
(7913, '2016-09-12 14:33:49', NULL, NULL, 2858, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 14:33:49', 'admin-1473656393-14736620291539890', 1, 0, '', NULL, NULL, NULL),
(7914, '2016-09-12 14:33:49', NULL, NULL, 2858, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 14:33:49', 'admin-1473656393-14736620291539890', 1, 1, 'SR', NULL, NULL, NULL),
(7915, '2016-09-12 14:33:49', NULL, NULL, 2858, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 14:33:49', 'admin-1473656393-14736620291539890', 1, 1, 'SR', NULL, NULL, NULL),
(7916, '2016-09-12 14:34:41', NULL, NULL, 2859, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 14:34:41', 'admin-1473656393-14736620815396544', 1, 1, 'SR', 1, NULL, NULL),
(7917, '2016-09-12 14:42:34', NULL, NULL, 2860, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 14:42:34', 'admin-1473656393-14736625542735694', 1, 1, 'SR', NULL, NULL, NULL),
(7918, '2016-09-12 15:01:03', NULL, NULL, 2857, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 15:01:03', 'admin-1473656393-14736636629206992', 1, 1, 'SR', NULL, NULL, NULL),
(7919, '2016-09-12 10:13:08', NULL, NULL, 2837, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 10:13:08', 'admin-1473641025-14736463886982260', 1, 1, 'SR', NULL, NULL, NULL),
(7920, '2016-09-12 10:22:37', NULL, NULL, 2838, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 10:22:37', 'admin-1473641025-14736469576613150', 1, 0, '', 1, NULL, NULL),
(7921, '2016-09-12 10:26:41', NULL, NULL, 2839, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 10:26:41', 'admin-1473641025-14736472016804336', 1, 0, '', NULL, NULL, NULL),
(7922, '2016-09-12 10:27:35', NULL, NULL, 2839, 0, 181, '116', 'Open Food ', 'Sunny side up', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 10:27:35', 'admin-1473641025-14736472548651394', 1, 0, '', NULL, NULL, NULL),
(7923, '2016-09-12 10:27:35', NULL, NULL, 2839, 0, 181, '116', 'Open Food ', 'potato waffle', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 10:27:35', 'admin-1473641025-14736472548651394', 1, 0, '', NULL, NULL, NULL),
(7924, '2016-09-12 10:28:12', NULL, NULL, 2839, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 10:28:12', 'admin-1473641025-14736472928082731', 1, 1, 'SR', NULL, NULL, NULL),
(7925, '2016-09-12 10:28:26', NULL, NULL, 2839, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 10:28:26', 'admin-1473641025-14736473062059395', 1, 1, 'SR', NULL, NULL, NULL),
(7926, '2016-09-12 10:28:40', NULL, NULL, 2839, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 10:28:40', 'admin-1473641025-14736473208224237', 1, 1, 'SR', NULL, NULL, NULL),
(7927, '2016-09-12 10:49:57', NULL, NULL, 2840, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 10:49:57', 'admin-1473641025-14736485972036473', 1, 1, 'SR', NULL, NULL, NULL),
(7928, '2016-09-12 10:13:08', NULL, NULL, 2837, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 10:13:08', 'admin-1473641025-14736463886982260', 1, 1, 'SR', NULL, NULL, NULL),
(7929, '2016-09-12 16:38:29', NULL, NULL, 2868, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 16:38:29', 'admin-1473656393-1473669508843314', 1, 0, '', NULL, NULL, NULL),
(7930, '2016-09-12 16:38:29', NULL, NULL, 2868, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 16:38:29', 'admin-1473656393-1473669508843314', 1, 1, 'SR', NULL, NULL, NULL),
(7931, '2016-09-12 19:15:59', NULL, NULL, 2872, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 19:15:59', 'admin-1473671172-14736789588309584', 1, 1, 'SR', NULL, NULL, NULL),
(7932, '2016-09-12 16:23:43', NULL, NULL, 2867, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 16:23:43', 'admin-1473656393-14736686228212148', 1, 1, 'SR', NULL, NULL, NULL),
(7933, '2016-09-12 16:23:43', NULL, NULL, 2867, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 16:23:43', 'admin-1473656393-14736686228212148', 1, 1, 'SR', NULL, NULL, NULL),
(7934, '2016-09-12 16:23:43', NULL, NULL, 2867, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 16:23:43', 'admin-1473656393-14736686228212148', 1, 0, '', NULL, NULL, NULL),
(7935, '2016-09-12 16:22:14', NULL, NULL, 2867, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 16:22:14', 'admin-1473656393-14736685342419114', 1, 0, '', NULL, NULL, NULL),
(7936, '2016-09-12 17:28:44', NULL, NULL, 2870, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 17:28:44', 'admin-1473671172-14736725241812083', 1, 0, '', NULL, NULL, NULL),
(7937, '2016-09-12 16:10:28', NULL, NULL, 2865, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 16:10:28', 'admin-1473656393-14736678279137766', 1, 0, '', NULL, NULL, '10.0'),
(7938, '2016-09-12 19:15:59', NULL, NULL, 2872, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 19:15:59', 'admin-1473671172-14736789588309584', 1, 1, 'SR', NULL, NULL, NULL),
(7939, '2016-09-12 16:10:28', NULL, NULL, 2865, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 16:10:28', 'admin-1473656393-14736678279137766', 1, 1, 'SR', NULL, NULL, '10.0'),
(7940, '2016-09-12 15:48:03', NULL, NULL, 2863, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 15:48:03', 'admin-1473656393-14736664835527576', 1, 0, '', NULL, NULL, NULL),
(7941, '2016-09-12 15:48:13', NULL, NULL, 2857, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 15:48:13', 'admin-1473656393-14736664934641453', 1, 1, 'SR', NULL, NULL, NULL),
(7942, '2016-09-12 15:50:46', NULL, NULL, 2864, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 15:50:46', 'admin-1473656393-14736666464845716', 1, 1, 'SR', NULL, NULL, NULL),
(7943, '2016-09-12 15:48:03', NULL, NULL, 2863, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 15:48:03', 'admin-1473656393-14736664835527576', 1, 0, '', NULL, NULL, NULL),
(7944, '2016-09-12 15:48:03', NULL, NULL, 2863, 0, 192, '127', 'Stir Fried Chili Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 15:48:03', 'admin-1473656393-14736664835527576', 1, 0, '', NULL, NULL, NULL),
(7945, '2016-09-12 15:48:03', NULL, NULL, 2863, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 15:48:03', 'admin-1473656393-14736664835527576', 1, 1, 'SR', NULL, NULL, NULL),
(7946, '2016-09-12 12:59:38', NULL, NULL, 2850, 0, 192, '127', 'Stir Fried Chili Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 12:59:38', 'admin-1473651429-1473656377914985', 1, 0, '', NULL, NULL, NULL),
(7947, '2016-09-12 12:59:38', NULL, NULL, 2850, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 12:59:38', 'admin-1473651429-1473656377914985', 1, 0, '', NULL, NULL, NULL),
(7948, '2016-09-12 15:19:47', NULL, NULL, 2862, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 15:19:47', 'admin-1473656393-14736647877887823', 1, 1, 'SR', NULL, NULL, NULL),
(7949, '2016-09-12 15:48:03', NULL, NULL, 2863, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 15:48:03', 'admin-1473656393-14736664835527576', 1, 1, 'SR', NULL, NULL, NULL),
(7950, '2016-09-12 15:17:57', NULL, NULL, 2861, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 15:17:57', 'admin-1473656393-14736646768598184', 1, 1, 'SR', 1, NULL, NULL),
(7951, '2016-09-12 15:17:57', NULL, NULL, 2861, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 15:17:57', 'admin-1473656393-14736646768598184', 1, 0, '', 1, NULL, NULL),
(7952, '2016-09-12 13:36:19', NULL, NULL, 2854, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 13:36:19', 'admin-1473656393-14736585796055556', 1, 1, 'SR', NULL, NULL, NULL),
(7953, '2016-09-12 13:36:19', NULL, NULL, 2854, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 13:36:19', 'admin-1473656393-14736585796055556', 1, 1, 'SR', NULL, NULL, NULL),
(7954, '2016-09-12 13:25:57', NULL, NULL, 2852, 0, 181, '116', 'Open Food ', 'egg', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 13:25:57', 'admin-1473656393-14736579574056293', 1, 0, '', 1, NULL, NULL),
(7955, '2016-09-12 13:33:21', NULL, NULL, 2853, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 13:33:21', 'admin-1473656393-14736584010826312', 1, 1, 'SR', NULL, NULL, NULL),
(7956, '2016-09-12 13:12:38', NULL, NULL, 2851, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 13:12:38', 'admin-1473656393-14736571580293462', 1, 1, 'SR', NULL, NULL, NULL),
(7957, '2016-09-12 13:12:38', NULL, NULL, 2851, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 13:12:38', 'admin-1473656393-14736571580293462', 1, 1, 'SR', NULL, NULL, NULL),
(7958, '2016-09-12 12:59:38', NULL, NULL, 2850, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 12:59:38', 'admin-1473651429-1473656377914985', 1, 1, 'SR', NULL, NULL, NULL),
(7959, '2016-09-12 11:00:08', NULL, NULL, 2841, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 11:00:08', 'admin-1473641025-14736492080305179', 1, 0, '', NULL, NULL, NULL),
(7960, '2016-09-12 11:00:16', NULL, NULL, 2842, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 11:00:16', 'admin-1473641025-1473649215827805', 1, 0, '', NULL, NULL, NULL),
(7961, '2016-09-12 12:43:33', NULL, NULL, 2848, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 12:43:33', 'admin-1473651429-14736554134064980', 1, 1, 'SR', NULL, NULL, NULL),
(7962, '2016-09-12 12:43:55', NULL, NULL, 2848, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 12:43:55', 'admin-1473651429-1473655434981446', 1, 0, '', NULL, NULL, NULL),
(7963, '2016-09-12 12:43:33', NULL, NULL, 2848, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 12:43:33', 'admin-1473651429-14736554134064980', 1, 0, '', NULL, NULL, NULL),
(7964, '2016-09-12 12:44:43', NULL, NULL, 2847, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 12:44:43', 'admin-1473651429-14736554830802045', 1, 1, 'SR', NULL, NULL, NULL),
(7965, '2016-09-12 12:52:38', NULL, NULL, 2849, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 12:52:38', 'admin-1473651429-14736559585361243', 1, 1, 'SR', NULL, NULL, NULL),
(7966, '2016-09-12 11:37:01', NULL, NULL, 2843, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 11:37:01', 'admin-1473641025-14736514212237081', 1, 0, '', NULL, NULL, NULL),
(7967, '2016-09-12 11:37:01', NULL, NULL, 2843, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 11:37:01', 'admin-1473641025-14736514212237081', 1, 0, '', NULL, NULL, NULL),
(7968, '2016-09-12 11:37:01', NULL, NULL, 2843, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 11:37:01', 'admin-1473641025-14736514212237081', 1, 0, '', NULL, NULL, NULL),
(7969, '2016-09-12 11:37:01', NULL, NULL, 2843, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 11:37:01', 'admin-1473641025-14736514212237081', 1, 1, 'SR', NULL, NULL, NULL),
(7970, '2016-09-12 11:37:01', NULL, NULL, 2843, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 11:37:01', 'admin-1473641025-14736514212237081', 1, 1, 'SR', NULL, NULL, NULL),
(7971, '2016-09-12 11:54:48', NULL, NULL, 2844, 0, 82, '82', 'Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 11:54:48', 'admin-1473651429-14736524881652691', 1, 1, 'SR', NULL, NULL, NULL),
(7972, '2016-09-12 11:54:48', NULL, NULL, 2844, 0, 81, '81', 'Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 11:54:48', 'admin-1473651429-14736524881652691', 1, 1, 'SR', NULL, NULL, NULL),
(7973, '2016-09-12 12:25:56', NULL, NULL, 2845, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 12:25:56', 'admin-1473651429-14736543564892465', 1, 1, 'SR', NULL, NULL, NULL),
(7974, '2016-09-12 12:25:56', NULL, NULL, 2845, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 12:25:56', 'admin-1473651429-14736543564892465', 1, 1, 'SR', NULL, NULL, NULL),
(7975, '2016-09-12 12:30:14', NULL, NULL, 2845, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 12:30:14', 'admin-1473651429-14736546138611164', 1, 0, '', NULL, NULL, NULL),
(7976, '2016-09-12 12:30:14', NULL, NULL, 2845, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 12:30:14', 'admin-1473651429-14736546138611164', 1, 0, '', NULL, NULL, NULL),
(7977, '2016-09-12 12:30:57', NULL, NULL, 2846, NULL, 58, '58', 'House White Bottle', '', 'Cold Drinks', 'Wine', 1, 88.00, 88.0000, 0.0000, 88.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 12:30:57', 'admin-1473651429-14736546571741021', 1, 1, 'SR', NULL, NULL, NULL),
(7978, '2016-09-12 12:42:22', NULL, NULL, 2847, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 12:42:22', 'admin-1473651429-14736553424891017', 1, 1, 'SR', NULL, NULL, NULL),
(7979, '2016-09-12 12:42:22', NULL, NULL, 2847, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 12:42:22', 'admin-1473651429-14736553424891017', 1, 0, '', NULL, NULL, NULL),
(7980, '2016-09-12 12:42:22', NULL, NULL, 2847, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 12:42:22', 'admin-1473651429-14736553424891017', 1, 1, 'SR', NULL, NULL, NULL),
(7981, '2016-09-12 12:42:22', NULL, NULL, 2847, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 12:42:22', 'admin-1473651429-14736553424891017', 1, 0, '', NULL, NULL, NULL),
(7982, '2016-09-12 12:42:22', NULL, NULL, 2847, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 12:42:22', 'admin-1473651429-14736553424891017', 1, 0, '', NULL, NULL, NULL),
(7983, '2016-09-12 13:43:52', NULL, NULL, 2847, 0, 181, '116', 'Open Food ', 'toast', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 13:43:52', 'admin-1473656393-1473659031984958', 1, 0, '', NULL, NULL, NULL),
(7984, '2016-09-12 12:43:33', NULL, NULL, 2848, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 12:43:33', 'admin-1473651429-14736554134064980', 1, 1, 'SR', NULL, NULL, NULL),
(7985, '2016-09-12 11:00:08', NULL, NULL, 2841, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 11:00:08', 'admin-1473641025-14736492080305179', 1, 1, 'SR', NULL, NULL, NULL),
(7986, '2016-09-12 11:00:08', NULL, NULL, 2841, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 11:00:08', 'admin-1473641025-14736492080305179', 1, 0, '', NULL, NULL, NULL),
(7987, '2016-09-12 12:59:38', NULL, NULL, 2850, 0, 83, '83', 'Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 12:59:38', 'admin-1473651429-1473656377914985', 1, 1, 'SR', NULL, NULL, NULL),
(7988, '2016-09-12 11:00:08', NULL, NULL, 2841, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 11:00:08', 'admin-1473641025-14736492080305179', 1, 0, '', NULL, NULL, NULL),
(7989, '2016-09-12 10:49:57', NULL, NULL, 2840, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 10:49:57', 'admin-1473641025-14736485972036473', 1, 0, '', NULL, NULL, NULL),
(7990, '2016-09-12 10:50:05', NULL, NULL, 2840, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 10:50:05', 'admin-1473641025-14736486052777132', 1, 1, 'SR', NULL, NULL, NULL),
(7991, '2016-09-12 10:12:44', NULL, NULL, 2837, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 10:12:44', 'admin-1473641025-14736463639236264', 1, 0, '', NULL, NULL, NULL),
(7992, '2016-09-12 10:00:46', NULL, NULL, 2835, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 10:00:46', 'admin-1473641025-1473645646758799', 1, 0, '', NULL, NULL, '10.0'),
(7993, '2016-09-12 10:01:25', NULL, NULL, 2835, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 10:01:25', 'admin-1473641025-14736456855341697', 1, 1, 'SR', NULL, NULL, '10.0'),
(7994, '2016-09-12 10:03:13', NULL, NULL, 2836, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 10:03:13', 'admin-1473641025-14736457932192929', 1, 0, '', NULL, NULL, NULL),
(7995, '2016-09-12 10:12:44', NULL, NULL, 2837, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 10:12:44', 'admin-1473641025-14736463639236264', 1, 0, '', NULL, NULL, NULL),
(7996, '2016-09-12 09:59:58', NULL, NULL, 2835, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 09:59:58', 'admin-1473641025-14736455984151861', 1, 0, '', NULL, NULL, '10.0'),
(7997, '2016-09-12 09:59:58', NULL, NULL, 2835, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 09:59:58', 'admin-1473641025-14736455984151861', 1, 1, 'SR', NULL, NULL, '10.0'),
(7998, '2016-09-12 09:59:58', NULL, NULL, 2835, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 09:59:58', 'admin-1473641025-14736455984151861', 1, 0, '', NULL, NULL, '10.0'),
(7999, '2016-09-12 09:59:58', NULL, NULL, 2835, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 09:59:58', 'admin-1473641025-14736455984151861', 1, 1, 'SR', NULL, NULL, '10.0'),
(8000, '2016-09-12 09:59:58', NULL, NULL, 2835, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 09:59:58', 'admin-1473641025-14736455984151861', 1, 1, 'SR', NULL, NULL, '10.0'),
(8001, '2016-09-12 09:55:03', NULL, NULL, 2834, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 09:55:03', 'admin-1473641025-14736453031102578', 1, 1, 'SR', NULL, NULL, NULL),
(8002, '2016-09-12 09:59:58', NULL, NULL, 2835, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 09:59:58', 'admin-1473641025-14736455984151861', 1, 1, 'SR', NULL, NULL, '10.0'),
(8003, '2016-09-12 12:59:38', NULL, NULL, 2850, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 12:59:38', 'admin-1473651429-1473656377914985', 1, 0, '', NULL, NULL, NULL),
(8004, '2016-09-12 09:53:58', NULL, NULL, 2833, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473671172', 'admin', '2016-09-12 09:53:58', 'admin-1473641025-14736452383961682', 1, 1, 'SR', NULL, NULL, NULL),
(8005, '2016-09-14 20:07:52', NULL, NULL, 2892, 0, 192, '127', 'Stir Fried Chili Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 20:07:52', 'admin-1473829127-14738548725429999', 1, 0, '', NULL, NULL, NULL),
(8006, '2016-09-14 20:07:52', NULL, NULL, 2892, 0, 211, '145', 'Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 20:07:52', 'admin-1473829127-14738548725429999', 1, 0, '', NULL, NULL, NULL),
(8007, '2016-09-14 20:08:00', NULL, NULL, 2892, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 20:08:00', 'admin-1473829127-14738548806168533', 1, 1, 'SR', NULL, NULL, NULL),
(8008, '2016-09-14 20:08:00', NULL, NULL, 2892, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 20:08:00', 'admin-1473829127-14738548806168533', 1, 1, 'SR', NULL, NULL, NULL),
(8009, '2016-09-14 20:11:17', NULL, NULL, 2894, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 20:11:17', 'admin-1473829127-14738550768995155', 1, 1, 'SR', NULL, NULL, NULL),
(8010, '2016-09-14 20:11:17', NULL, NULL, 2894, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 20:11:17', 'admin-1473829127-14738550768995155', 1, 1, 'SR', NULL, NULL, NULL),
(8011, '2016-09-14 20:54:17', NULL, NULL, 2895, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 20:54:17', 'admin-1473829127-1473857657270969', 1, 1, 'SR', NULL, NULL, NULL),
(8012, '2016-09-14 20:54:17', NULL, NULL, 2895, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 20:54:17', 'admin-1473829127-1473857657270969', 1, 1, 'SR', NULL, NULL, NULL),
(8013, '2016-09-14 21:16:12', NULL, NULL, 2896, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 21:16:12', 'admin-1473829127-1473858972586839', 1, 1, 'SR', NULL, NULL, NULL),
(8014, '2016-09-14 21:16:12', NULL, NULL, 2896, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 21:16:12', 'admin-1473829127-1473858972586839', 1, 1, 'SR', NULL, NULL, NULL),
(8015, '2016-09-14 12:52:05', NULL, NULL, 2882, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 12:52:05', 'admin-1473816737-1473828725459607', 1, 0, '', NULL, NULL, NULL),
(8016, '2016-09-14 12:58:26', NULL, NULL, 2883, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 12:58:26', 'admin-1473816737-14738291067349787', 1, 0, '', NULL, NULL, NULL),
(8017, '2016-09-14 18:46:42', NULL, NULL, 2893, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 18:46:42', 'admin-1473829127-14738500021437786', 1, 1, 'SR', 1, NULL, NULL),
(8018, '2016-09-14 17:16:06', NULL, NULL, 2892, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 17:16:06', 'admin-1473829127-14738445660964497', 1, 1, 'SR', NULL, NULL, NULL),
(8019, '2016-09-14 17:16:17', NULL, NULL, 2892, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 17:16:17', 'admin-1473829127-14738445773384835', 1, 0, '', NULL, NULL, NULL),
(8020, '2016-09-14 17:16:06', NULL, NULL, 2892, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 17:16:06', 'admin-1473829127-14738445660964497', 1, 1, 'SR', NULL, NULL, NULL),
(8021, '2016-09-14 17:10:38', NULL, NULL, 2891, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 17:10:38', 'admin-1473829127-14738442382197142', 1, 1, 'SR', 1, NULL, NULL),
(8022, '2016-09-14 09:56:22', NULL, NULL, 2877, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 09:56:22', 'admin-1473816737-14738181826148811', 1, 0, '', NULL, NULL, NULL),
(8023, '2016-09-14 16:55:02', NULL, NULL, 2890, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 16:55:02', 'admin-1473829127-14738433024795033', 1, 1, 'SR', 1, NULL, NULL),
(8024, '2016-09-14 12:59:31', NULL, NULL, 2883, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 12:59:31', 'admin-1473829127-14738291715331391', 1, 0, '', NULL, NULL, NULL),
(8025, '2016-09-14 12:59:31', NULL, NULL, 2883, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 12:59:31', 'admin-1473829127-14738291715331391', 1, 1, 'SR', NULL, NULL, NULL),
(8026, '2016-09-14 13:01:05', NULL, NULL, 2883, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 13:01:05', 'admin-1473829127-14738292652464393', 1, 0, '', NULL, NULL, NULL),
(8027, '2016-09-14 13:01:05', NULL, NULL, 2883, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 13:01:05', 'admin-1473829127-14738292652464393', 1, 0, '', NULL, NULL, NULL),
(8028, '2016-09-14 13:01:05', NULL, NULL, 2883, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 13:01:05', 'admin-1473829127-14738292652464393', 1, 1, 'SR', NULL, NULL, NULL),
(8029, '2016-09-14 15:51:04', NULL, NULL, 2889, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 15:51:04', 'admin-1473829127-14738394647739382', 1, 0, '', NULL, NULL, NULL),
(8030, '2016-09-14 15:51:04', NULL, NULL, 2889, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 15:51:04', 'admin-1473829127-14738394647739382', 1, 1, 'SR', NULL, NULL, NULL),
(8031, '2016-09-14 15:51:04', NULL, NULL, 2889, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 15:51:04', 'admin-1473829127-14738394647739382', 1, 1, 'SR', NULL, NULL, NULL),
(8032, '2016-09-14 15:29:15', NULL, NULL, 2888, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 15:29:15', 'admin-1473829127-1473838154973692', 1, 1, 'SR', NULL, NULL, NULL),
(8033, '2016-09-14 15:23:57', NULL, NULL, 2888, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 15:23:57', 'admin-1473829127-1473837837324622', 1, 1, 'SR', NULL, NULL, NULL),
(8034, '2016-09-14 15:23:57', NULL, NULL, 2888, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 15:23:57', 'admin-1473829127-1473837837324622', 1, 1, 'SR', NULL, NULL, NULL),
(8035, '2016-09-14 14:44:11', NULL, NULL, 2887, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 14:44:11', 'admin-1473829127-14738354510116461', 1, 1, 'SR', NULL, NULL, NULL),
(8036, '2016-09-14 14:44:11', NULL, NULL, 2887, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 14:44:11', 'admin-1473829127-14738354510116461', 1, 1, 'SR', NULL, NULL, NULL),
(8037, '2016-09-14 14:44:11', NULL, NULL, 2887, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 14:44:11', 'admin-1473829127-14738354510116461', 1, 1, 'SR', NULL, NULL, NULL),
(8038, '2016-09-14 14:31:25', NULL, NULL, 2886, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 14:31:25', 'admin-1473829127-14738346850465382', 1, 0, '', NULL, NULL, NULL),
(8039, '2016-09-14 14:31:25', NULL, NULL, 2886, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 14:31:25', 'admin-1473829127-14738346850465382', 1, 1, 'SR', NULL, NULL, NULL),
(8040, '2016-09-14 14:31:25', NULL, NULL, 2886, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 14:31:25', 'admin-1473829127-14738346850465382', 1, 1, 'SR', NULL, NULL, NULL),
(8041, '2016-09-14 13:21:11', NULL, NULL, 2885, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 13:21:11', 'admin-1473829127-14738304712884074', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(8042, '2016-09-14 13:21:11', NULL, NULL, 2885, 0, 214, '148', 'Set Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 13:21:11', 'admin-1473829127-14738304712884074', 1, 0, '', NULL, NULL, NULL),
(8043, '2016-09-14 13:21:11', NULL, NULL, 2885, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 13:21:11', 'admin-1473829127-14738304712884074', 1, 0, '', NULL, NULL, NULL),
(8044, '2016-09-14 13:01:58', NULL, NULL, 2884, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 13:01:58', 'admin-1473829127-14738293187189785', 1, 1, 'SR', NULL, NULL, NULL),
(8045, '2016-09-14 13:01:58', NULL, NULL, 2884, 0, 192, '127', 'Stir Fried Chili Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 13:01:58', 'admin-1473829127-14738293187189785', 1, 0, '', NULL, NULL, NULL),
(8046, '2016-09-14 12:39:06', NULL, NULL, 2882, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 12:39:06', 'admin-1473816737-14738279465237387', 1, 0, '', NULL, NULL, NULL),
(8047, '2016-09-14 12:39:19', NULL, NULL, 2882, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 12:39:19', 'admin-1473816737-14738279594759033', 1, 1, 'SR', NULL, NULL, NULL),
(8048, '2016-09-14 12:39:19', NULL, NULL, 2882, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 12:39:19', 'admin-1473816737-14738279594759033', 1, 1, 'SR', NULL, NULL, NULL),
(8049, '2016-09-14 15:51:33', NULL, NULL, 2888, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 15:51:33', 'admin-1473829127-1473839493521470', 1, 1, 'SR', NULL, NULL, NULL),
(8050, '2016-09-14 12:58:26', NULL, NULL, 2883, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 12:58:26', 'admin-1473816737-14738291067349787', 1, 1, 'SR', NULL, NULL, NULL),
(8051, '2016-09-14 12:17:55', NULL, NULL, 2877, 0, 192, '127', 'Stir Fried Chili Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 12:17:55', 'admin-1473816737-14738266755531023', 1, 0, '', NULL, NULL, NULL),
(8052, '2016-09-14 12:39:06', NULL, NULL, 2882, 0, 211, '145', 'Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 12:39:06', 'admin-1473816737-14738279465237387', 1, 0, '', NULL, NULL, NULL),
(8053, '2016-09-14 12:39:06', NULL, NULL, 2882, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 12:39:06', 'admin-1473816737-14738279465237387', 1, 1, 'SR', NULL, NULL, NULL),
(8054, '2016-09-14 12:17:55', NULL, NULL, 2877, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 12:17:55', 'admin-1473816737-14738266755531023', 1, 1, 'SR', NULL, NULL, NULL),
(8055, '2016-09-14 12:17:55', NULL, NULL, 2877, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 12:17:55', 'admin-1473816737-14738266755531023', 1, 1, 'SR', NULL, NULL, NULL),
(8056, '2016-09-14 12:17:55', NULL, NULL, 2877, 0, 211, '145', 'Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 12:17:55', 'admin-1473816737-14738266755531023', 1, 0, '', NULL, NULL, NULL),
(8057, '2016-09-14 12:01:45', NULL, NULL, 2881, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 12:01:45', 'admin-1473816737-1473825705209276', 1, 1, 'SR', NULL, NULL, NULL),
(8058, '2016-09-14 11:27:27', NULL, NULL, 2877, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 11:27:27', 'admin-1473816737-14738236475322473', 1, 1, 'SR', NULL, NULL, NULL),
(8059, '2016-09-14 10:48:02', NULL, NULL, 2880, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 10:48:02', 'admin-1473816737-1473821281795897', 1, 1, 'SR', 1, NULL, NULL),
(8060, '2016-09-14 10:20:48', NULL, NULL, 2879, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 10:20:48', 'admin-1473816737-1473819648285114', 1, 1, 'SR', NULL, NULL, NULL),
(8061, '2016-09-14 10:20:48', NULL, NULL, 2879, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 10:20:48', 'admin-1473816737-1473819648285114', 1, 1, 'SR', NULL, NULL, NULL),
(8062, '2016-09-14 10:20:48', NULL, NULL, 2879, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 10:20:48', 'admin-1473816737-1473819648285114', 1, 0, '', NULL, NULL, NULL),
(8063, '2016-09-14 10:20:48', NULL, NULL, 2879, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 10:20:48', 'admin-1473816737-1473819648285114', 1, 0, '', NULL, NULL, NULL),
(8064, '2016-09-14 10:02:46', NULL, NULL, 2878, 0, 153, '87', 'Big Breakfast ', 'Takeaway', 'Meals', 'Morning Bites ', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 10:02:46', 'admin-1473816737-14738185667248287', 1, 0, '', NULL, NULL, NULL),
(8065, '2016-09-14 09:56:22', NULL, NULL, 2877, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 09:56:22', 'admin-1473816737-14738181826148811', 1, 1, 'SR', NULL, NULL, NULL),
(8066, '2016-09-14 09:56:22', NULL, NULL, 2877, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473829127', 'admin', '2016-09-14 09:56:22', 'admin-1473816737-14738181826148811', 1, 1, 'SR', NULL, NULL, NULL),
(8067, '2016-09-15 12:28:24', NULL, NULL, 2902, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 12:28:24', 'admin-1473900628-14739137047546745', 1, 1, 'SR', NULL, NULL, NULL),
(8068, '2016-09-15 13:50:38', NULL, NULL, 2903, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 13:50:38', 'admin-1473900628-14739186378155349', 1, 1, 'SR', NULL, NULL, NULL),
(8069, '2016-09-15 14:04:13', NULL, NULL, 2904, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 14:04:13', 'admin-1473900628-14739194537819145', 1, 0, '', NULL, NULL, NULL),
(8070, '2016-09-15 21:25:24', NULL, NULL, 2915, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1473919465', 'sanni', '2016-09-15 21:25:24', 'sanni-1473919465-14739459242095695', 1, 1, 'SR', NULL, NULL, NULL),
(8071, '2016-09-15 20:34:12', NULL, NULL, 2914, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473919465', 'sanni', '2016-09-15 20:34:12', 'sanni-1473919465-14739428518792480', 1, 0, '', NULL, NULL, NULL),
(8072, '2016-09-15 20:34:26', NULL, NULL, 2914, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1473919465', 'sanni', '2016-09-15 20:34:26', 'sanni-1473919465-1473942866273122', 1, 1, 'SR', NULL, NULL, NULL),
(8073, '2016-09-15 20:33:57', NULL, NULL, 2914, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1473919465', 'sanni', '2016-09-15 20:33:57', 'sanni-1473919465-1473942836988969', 1, 0, '', NULL, NULL, NULL),
(8074, '2016-09-15 20:03:23', NULL, NULL, 2913, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473919465', 'sanni', '2016-09-15 20:03:23', 'sanni-1473919465-14739410032444923', 1, 0, '', NULL, NULL, NULL),
(8075, '2016-09-15 20:33:57', NULL, NULL, 2914, 0, 75, '75', 'Aglio Olio ', 'Chicken', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1473919465', 'sanni', '2016-09-15 20:33:57', 'sanni-1473919465-1473942836988969', 1, 0, '', NULL, NULL, NULL),
(8076, '2016-09-15 19:59:59', NULL, NULL, 2912, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473919465', 'sanni', '2016-09-15 19:59:59', 'sanni-1473919465-14739407988435783', 1, 0, '', NULL, NULL, NULL),
(8077, '2016-09-15 13:50:38', NULL, NULL, 2903, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 13:50:38', 'admin-1473900628-14739186378155349', 1, 0, '', NULL, NULL, NULL),
(8078, '2016-09-15 12:45:07', NULL, NULL, 2902, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 12:45:07', 'admin-1473900628-14739147075895254', 1, 0, '', NULL, NULL, NULL),
(8079, '2016-09-15 12:45:16', NULL, NULL, 2901, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 12:45:16', 'admin-1473900628-14739147164376911', 1, 1, 'SR', NULL, NULL, NULL),
(8080, '2016-09-15 13:14:59', NULL, NULL, 2899, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 13:14:59', 'admin-1473900628-147391649886068', 1, 1, 'SR', NULL, NULL, NULL),
(8081, '2016-09-15 13:46:14', NULL, NULL, 2903, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 13:46:14', 'admin-1473900628-1473918374390210', 1, 1, 'SR', NULL, NULL, NULL),
(8082, '2016-09-15 13:46:14', NULL, NULL, 2903, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 13:46:14', 'admin-1473900628-1473918374390210', 1, 1, 'SR', NULL, NULL, NULL),
(8083, '2016-09-15 13:46:14', NULL, NULL, 2903, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 13:46:14', 'admin-1473900628-1473918374390210', 1, 1, 'SR', NULL, NULL, NULL),
(8084, '2016-09-15 20:03:23', NULL, NULL, 2913, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473919465', 'sanni', '2016-09-15 20:03:23', 'sanni-1473919465-14739410032444923', 1, 0, '', NULL, NULL, NULL),
(8085, '2016-09-15 19:59:59', NULL, NULL, 2912, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473919465', 'sanni', '2016-09-15 19:59:59', 'sanni-1473919465-14739407988435783', 1, 1, 'SR', NULL, NULL, NULL),
(8086, '2016-09-15 18:54:26', NULL, NULL, 2910, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473919465', 'sanni', '2016-09-15 18:54:26', 'sanni-1473919465-1473936865872987', 1, 1, 'SR', NULL, NULL, NULL),
(8087, '2016-09-15 18:54:26', NULL, NULL, 2910, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473919465', 'sanni', '2016-09-15 18:54:26', 'sanni-1473919465-1473936865872987', 1, 1, 'SR', NULL, NULL, NULL),
(8088, '2016-09-15 19:13:10', NULL, NULL, 2911, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1473919465', 'sanni', '2016-09-15 19:13:10', 'sanni-1473919465-14739379907336967', 1, 1, 'SR', NULL, NULL, NULL),
(8089, '2016-09-15 14:40:12', NULL, NULL, 2906, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473919465', 'sanni', '2016-09-15 14:40:12', 'sanni-1473919465-14739216125594178', 1, 0, '', NULL, NULL, NULL),
(8090, '2016-09-15 14:39:39', NULL, NULL, 2906, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473919465', 'sanni', '2016-09-15 14:39:39', 'sanni-1473919465-14739215797038037', 1, 1, 'SR', NULL, NULL, NULL),
(8091, '2016-09-15 14:50:04', NULL, NULL, 2907, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473919465', 'sanni', '2016-09-15 14:50:04', 'sanni-1473919465-14739222040459011', 1, 1, 'SR', 1, NULL, NULL),
(8092, '2016-09-15 14:50:04', NULL, NULL, 2907, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1473919465', 'sanni', '2016-09-15 14:50:04', 'sanni-1473919465-14739222040459011', 1, 1, 'SR', 1, NULL, NULL),
(8093, '2016-09-15 16:40:06', NULL, NULL, 2908, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473919465', 'sanni', '2016-09-15 16:40:06', 'sanni-1473919465-14739288062735338', 1, 0, '', 1, NULL, NULL),
(8094, '2016-09-15 17:44:37', NULL, NULL, 2909, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473919465', 'sanni', '2016-09-15 17:44:37', 'sanni-1473919465-14739326775104274', 1, 1, 'SR', 1, NULL, NULL),
(8095, '2016-09-15 18:54:26', NULL, NULL, 2910, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473919465', 'sanni', '2016-09-15 18:54:26', 'sanni-1473919465-1473936865872987', 1, 1, 'SR', NULL, NULL, NULL),
(8096, '2016-09-15 17:44:37', NULL, NULL, 2909, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473919465', 'sanni', '2016-09-15 17:44:37', 'sanni-1473919465-14739326775104274', 1, 1, 'SR', 1, NULL, NULL),
(8097, '2016-09-15 14:04:13', NULL, NULL, 2904, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 14:04:13', 'admin-1473900628-14739194537819145', 1, 1, 'SR', NULL, NULL, NULL),
(8098, '2016-09-15 14:04:13', NULL, NULL, 2904, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 14:04:13', 'admin-1473900628-14739194537819145', 1, 0, '', NULL, NULL, NULL),
(8099, '2016-09-15 09:20:20', NULL, NULL, 2897, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 09:20:20', 'admin-1473900628-14739024198391335', 1, 0, '', NULL, NULL, NULL),
(8100, '2016-09-15 10:29:43', NULL, NULL, 2898, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 10:29:43', 'admin-1473900628-14739065831992091', 1, 0, '', NULL, NULL, NULL),
(8101, '2016-09-15 10:29:43', NULL, NULL, 2898, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 10:29:43', 'admin-1473900628-14739065831992091', 1, 0, '', NULL, NULL, NULL),
(8102, '2016-09-15 10:30:20', NULL, NULL, 2898, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 10:30:20', 'admin-1473900628-14739066200148876', 1, 1, 'SR', NULL, NULL, NULL),
(8103, '2016-09-15 10:30:20', NULL, NULL, 2898, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 10:30:20', 'admin-1473900628-14739066200148876', 1, 1, 'SR', NULL, NULL, NULL),
(8104, '2016-09-15 10:43:25', NULL, NULL, 2899, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 10:43:25', 'admin-1473900628-14739074050838460', 1, 1, 'SR', NULL, NULL, NULL),
(8105, '2016-09-15 12:29:49', NULL, NULL, 2902, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 12:29:49', 'admin-1473900628-14739137892437488', 1, 0, '', NULL, NULL, NULL),
(8106, '2016-09-15 12:29:49', NULL, NULL, 2902, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 12:29:49', 'admin-1473900628-14739137892437488', 1, 1, 'SR', NULL, NULL, NULL),
(8107, '2016-09-15 12:29:49', NULL, NULL, 2902, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 12:29:49', 'admin-1473900628-14739137892437488', 1, 0, '', NULL, NULL, NULL),
(8108, '2016-09-15 12:28:24', NULL, NULL, 2902, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 12:28:24', 'admin-1473900628-14739137047546745', 1, 0, '', NULL, NULL, NULL),
(8109, '2016-09-15 12:28:24', NULL, NULL, 2902, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 12:28:24', 'admin-1473900628-14739137047546745', 1, 1, 'SR', NULL, NULL, NULL),
(8110, '2016-09-15 12:29:49', NULL, NULL, 2902, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 12:29:49', 'admin-1473900628-14739137892437488', 1, 0, '', NULL, NULL, NULL),
(8111, '2016-09-15 12:28:24', NULL, NULL, 2902, 0, 211, '145', 'Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 12:28:24', 'admin-1473900628-14739137047546745', 1, 0, '', NULL, NULL, NULL),
(8112, '2016-09-15 12:19:42', NULL, NULL, 2901, 0, 181, '116', 'Open Food ', 'garlic pork', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 12:19:42', 'admin-1473900628-14739131827173439', 1, 0, '', NULL, NULL, NULL),
(8113, '2016-09-15 12:19:13', NULL, NULL, 2899, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 12:19:13', 'admin-1473900628-1473913153296256', 1, 1, 'SR', NULL, NULL, NULL),
(8114, '2016-09-15 11:31:35', NULL, NULL, 2900, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 11:31:35', 'admin-1473900628-14739102952015550', 1, 1, 'SR', NULL, NULL, NULL),
(8115, '2016-09-15 11:31:35', NULL, NULL, 2900, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 11:31:35', 'admin-1473900628-14739102952015550', 1, 1, 'SR', NULL, NULL, NULL),
(8116, '2016-09-15 10:43:25', NULL, NULL, 2899, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 10:43:25', 'admin-1473900628-14739074050838460', 1, 1, 'SR', NULL, NULL, NULL),
(8117, '2016-09-15 09:20:26', NULL, NULL, 2897, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 09:20:26', 'admin-1473900628-14739024265874532', 1, 1, 'SR', NULL, NULL, NULL),
(8118, '2016-09-15 09:20:26', NULL, NULL, 2897, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 09:20:26', 'admin-1473900628-14739024265874532', 1, 1, 'SR', NULL, NULL, NULL),
(8119, '2016-09-15 09:20:20', NULL, NULL, 2897, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1473919465', 'admin', '2016-09-15 09:20:20', 'admin-1473900628-14739024198391335', 1, 0, '', NULL, NULL, NULL),
(8120, '2016-09-16 20:09:55', NULL, NULL, 2955, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 20:09:55', 'admin-1474026586-14740277949772798', 1, 0, '', NULL, NULL, NULL),
(8121, '2016-09-16 20:09:55', NULL, NULL, 2955, 0, 181, '116', 'Open Food ', '1 biji fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1474026586', 'admin', '2016-09-16 20:09:55', 'admin-1474026586-14740277949772798', 1, 0, '', NULL, NULL, NULL),
(8122, '2016-09-16 20:28:59', NULL, NULL, 2954, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 20:28:59', 'admin-1474026586-1474028939109795', 1, 1, 'SR', NULL, NULL, NULL),
(8123, '2016-09-16 20:33:47', NULL, NULL, 2956, 0, 181, '116', 'Open Food ', 'garlic pork', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 20:33:47', 'admin-1474026586-14740292268476452', 1, 0, '', 1, NULL, NULL),
(8124, '2016-09-16 20:33:47', NULL, NULL, 2956, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 20:33:47', 'admin-1474026586-14740292268476452', 1, 0, '', 1, NULL, NULL),
(8125, '2016-09-16 21:40:05', NULL, NULL, 2954, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 21:40:05', 'admin-1474026586-14740332055935699', 1, 0, '', NULL, NULL, NULL),
(8126, '2016-09-16 22:30:41', NULL, NULL, 2957, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 22:30:41', 'admin-1474026586-1474036240876636', 1, 1, 'SR', NULL, NULL, NULL),
(8127, '2016-09-16 22:30:41', NULL, NULL, 2957, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 22:30:41', 'admin-1474026586-1474036240876636', 1, 1, 'SR', NULL, NULL, NULL),
(8128, '2016-09-16 22:30:41', NULL, NULL, 2957, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 22:30:41', 'admin-1474026586-1474036240876636', 1, 0, '', NULL, NULL, NULL),
(8129, '2016-09-16 22:31:33', NULL, NULL, 2958, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 22:31:33', 'admin-1474026586-14740362933656671', 1, 1, 'SR', 1, NULL, NULL),
(8130, '2016-09-16 20:09:55', NULL, NULL, 2955, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 20:09:55', 'admin-1474026586-14740277949772798', 1, 1, 'SR', NULL, NULL, NULL),
(8131, '2016-09-16 15:39:44', NULL, NULL, 2941, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 15:39:44', 'admin-1474007121-14740115844194037', 1, 1, 'SR', NULL, NULL, NULL),
(8132, '2016-09-16 16:13:29', NULL, NULL, 2942, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 16:13:29', 'admin-1474007121-14740136098102530', 1, 1, 'SR', NULL, NULL, NULL),
(8133, '2016-09-16 16:13:29', NULL, NULL, 2942, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 16:13:29', 'admin-1474007121-14740136098102530', 1, 1, 'SR', NULL, NULL, NULL),
(8134, '2016-09-16 16:18:04', NULL, NULL, 2943, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 16:18:04', 'admin-1474007121-14740138843108628', 1, 0, '', NULL, NULL, NULL),
(8135, '2016-09-16 16:18:04', NULL, NULL, 2943, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 16:18:04', 'admin-1474007121-14740138843108628', 1, 0, '', NULL, NULL, NULL),
(8136, '2016-09-16 16:18:04', NULL, NULL, 2943, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 16:18:04', 'admin-1474007121-14740138843108628', 1, 1, 'SR', NULL, NULL, NULL),
(8137, '2016-09-16 16:28:04', NULL, NULL, 2944, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 16:28:04', 'admin-1474007121-14740144845792889', 1, 0, '', NULL, NULL, NULL),
(8138, '2016-09-16 16:29:40', NULL, NULL, 2944, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 16:29:40', 'admin-1474007121-14740145806436653', 1, 0, '', NULL, NULL, NULL),
(8139, '2016-09-16 16:29:40', NULL, NULL, 2944, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 16:29:40', 'admin-1474007121-14740145806436653', 1, 0, '', NULL, NULL, NULL),
(8140, '2016-09-16 16:32:52', NULL, NULL, 2944, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 16:32:52', 'admin-1474007121-14740147722772258', 1, 1, 'SR', NULL, NULL, NULL),
(8141, '2016-09-16 16:56:50', NULL, NULL, 2945, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 16:56:50', 'admin-1474007121-14740162102465756', 1, 0, '', NULL, NULL, NULL),
(8142, '2016-09-16 16:56:50', NULL, NULL, 2945, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 16:56:50', 'admin-1474007121-14740162102465756', 1, 0, '', NULL, NULL, NULL),
(8143, '2016-09-16 16:58:01', NULL, NULL, 2945, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 16:58:01', 'admin-1474007121-14740162815707170', 1, 1, 'SR', NULL, NULL, NULL),
(8144, '2016-09-16 16:58:01', NULL, NULL, 2945, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 16:58:01', 'admin-1474007121-14740162815707170', 1, 1, 'SR', NULL, NULL, NULL),
(8145, '2016-09-16 17:17:59', NULL, NULL, 2946, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 17:17:59', 'admin-1474007121-14740174789278890', 1, 1, 'SR', NULL, NULL, NULL),
(8146, '2016-09-16 15:21:24', NULL, NULL, 2939, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 15:21:24', 'admin-1474007121-14740104840189828', 1, 0, '', NULL, NULL, NULL),
(8147, '2016-09-16 15:21:24', NULL, NULL, 2939, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 15:21:24', 'admin-1474007121-14740104840189828', 1, 1, 'SR', NULL, NULL, NULL),
(8148, '2016-09-16 15:21:24', NULL, NULL, 2939, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 15:21:24', 'admin-1474007121-14740104840189828', 1, 0, '', NULL, NULL, NULL),
(8149, '2016-09-16 15:22:37', NULL, NULL, 2939, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 15:22:37', 'admin-1474007121-14740105574362414', 1, 1, 'SR', NULL, NULL, NULL),
(8150, '2016-09-16 15:22:37', NULL, NULL, 2939, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 15:22:37', 'admin-1474007121-14740105574362414', 1, 1, 'SR', NULL, NULL, NULL),
(8151, '2016-09-16 15:22:37', NULL, NULL, 2939, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 15:22:37', 'admin-1474007121-14740105574362414', 1, 1, 'SR', NULL, NULL, NULL),
(8152, '2016-09-16 15:22:37', NULL, NULL, 2939, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 15:22:37', 'admin-1474007121-14740105574362414', 1, 1, 'SR', NULL, NULL, NULL),
(8153, '2016-09-16 15:23:15', NULL, NULL, 2940, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 15:23:15', 'admin-1474007121-14740105951144213', 1, 1, 'SR', NULL, NULL, NULL),
(8154, '2016-09-16 15:23:15', NULL, NULL, 2940, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 15:23:15', 'admin-1474007121-14740105951144213', 1, 0, '', NULL, NULL, NULL),
(8155, '2016-09-16 15:23:15', NULL, NULL, 2940, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 15:23:15', 'admin-1474007121-14740105951144213', 1, 1, 'SR', NULL, NULL, NULL),
(8156, '2016-09-16 20:28:59', NULL, NULL, 2954, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 20:28:59', 'admin-1474026586-1474028939109795', 1, 0, '', NULL, NULL, NULL),
(8157, '2016-09-16 20:28:59', NULL, NULL, 2954, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 20:28:59', 'admin-1474026586-1474028939109795', 1, 1, 'SR', NULL, NULL, NULL),
(8158, '2016-09-16 19:49:33', NULL, NULL, 2954, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 19:49:33', 'admin-1474007121-14740265737145578', 1, 1, 'SR', NULL, NULL, NULL),
(8159, '2016-09-16 19:49:33', NULL, NULL, 2954, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 19:49:33', 'admin-1474007121-14740265737145578', 1, 0, '', NULL, NULL, NULL),
(8160, '2016-09-16 19:49:33', NULL, NULL, 2954, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 19:49:33', 'admin-1474007121-14740265737145578', 1, 0, '', NULL, NULL, NULL),
(8161, '2016-09-16 19:49:33', NULL, NULL, 2954, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 19:49:33', 'admin-1474007121-14740265737145578', 1, 0, '', NULL, NULL, NULL),
(8162, '2016-09-16 20:09:55', NULL, NULL, 2955, 0, 75, '75', 'Aglio Olio ', 'heah bi', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 20:09:55', 'admin-1474026586-14740277949772798', 1, 0, '', NULL, NULL, NULL),
(8163, '2016-09-16 19:49:33', NULL, NULL, 2954, 0, 75, '75', 'Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 19:49:33', 'admin-1474007121-14740265737145578', 1, 0, '', NULL, NULL, NULL),
(8164, '2016-09-16 19:49:33', NULL, NULL, 2954, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 19:49:33', 'admin-1474007121-14740265737145578', 1, 0, '', NULL, NULL, NULL),
(8165, '2016-09-16 17:25:25', NULL, NULL, 2952, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 17:25:25', 'admin-1474007121-14740179252721241', 1, 1, 'SR', NULL, NULL, NULL),
(8166, '2016-09-16 18:30:08', NULL, NULL, 2953, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 18:30:08', 'admin-1474007121-14740218078051243', 1, 0, '', NULL, NULL, NULL),
(8167, '2016-09-16 18:30:08', NULL, NULL, 2953, 0, 75, '75', 'Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 18:30:08', 'admin-1474007121-14740218078051243', 1, 0, '', NULL, NULL, NULL),
(8168, '2016-09-16 17:22:07', NULL, NULL, 2950, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 17:22:07', 'admin-1474007121-1474017727621379', 1, 1, 'SR', NULL, NULL, NULL),
(8169, '2016-09-16 17:23:10', NULL, NULL, 2951, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 17:23:10', 'admin-1474007121-14740177903319553', 1, 1, 'SR', NULL, NULL, NULL),
(8170, '2016-09-16 17:25:25', NULL, NULL, 2952, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 17:25:25', 'admin-1474007121-14740179252721241', 1, 0, '', NULL, NULL, NULL),
(8171, '2016-09-16 17:21:26', NULL, NULL, 2949, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 17:21:26', 'admin-1474007121-14740176858925947', 1, 1, 'SR', NULL, NULL, NULL),
(8172, '2016-09-16 17:22:07', NULL, NULL, 2950, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 17:22:07', 'admin-1474007121-1474017727621379', 1, 1, 'SR', NULL, NULL, NULL),
(8173, '2016-09-16 14:35:18', NULL, NULL, 2935, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 14:35:18', 'admin-1474007121-1474007718606444', 1, 1, 'SR', NULL, NULL, NULL),
(8174, '2016-09-16 14:36:36', NULL, NULL, 2936, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 14:36:36', 'admin-1474007121-14740077961344854', 1, 0, '', NULL, NULL, NULL),
(8175, '2016-09-16 14:40:58', NULL, NULL, 2937, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 14:40:58', 'admin-1474007121-14740080584743169', 1, 1, 'SR', NULL, NULL, NULL),
(8176, '2016-09-16 17:20:42', NULL, NULL, 2948, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 17:20:42', 'admin-1474007121-14740176421868778', 1, 1, 'SR', NULL, NULL, NULL),
(8177, '2016-09-16 17:17:59', NULL, NULL, 2946, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 17:17:59', 'admin-1474007121-14740174789278890', 1, 1, 'SR', NULL, NULL, NULL),
(8178, '2016-09-16 17:18:20', NULL, NULL, 2947, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 17:18:20', 'admin-1474007121-14740175005861071', 1, 1, 'SR', NULL, NULL, NULL),
(8179, '2016-09-16 17:20:42', NULL, NULL, 2948, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 17:20:42', 'admin-1474007121-14740176421868778', 1, 0, '', NULL, NULL, NULL),
(8180, '2016-09-16 15:27:02', NULL, NULL, 2939, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 15:27:02', 'admin-1474007121-1474010822070698', 1, 1, 'SR', NULL, NULL, NULL),
(8181, '2016-09-16 15:21:24', NULL, NULL, 2939, 0, 75, '75', 'Aglio Olio ', 'Chicken', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 15:21:24', 'admin-1474007121-14740104840189828', 1, 0, '', NULL, NULL, NULL),
(8182, '2016-09-16 14:42:12', NULL, NULL, 2938, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 14:42:12', 'admin-1474007121-14740081318471633', 1, 0, '', NULL, NULL, NULL),
(8183, '2016-09-16 14:42:12', NULL, NULL, 2938, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 14:42:12', 'admin-1474007121-14740081318471633', 1, 1, 'SR', NULL, NULL, NULL),
(8184, '2016-09-16 14:42:12', NULL, NULL, 2938, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 14:42:12', 'admin-1474007121-14740081318471633', 1, 1, 'SR', NULL, NULL, NULL),
(8185, '2016-09-16 13:57:22', NULL, NULL, 2932, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 13:57:22', 'admin-1473995493-14740054421413541', 1, 1, 'SR', NULL, NULL, NULL),
(8186, '2016-09-16 13:58:03', NULL, NULL, 2933, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 13:58:03', 'admin-1473995493-14740054829562887', 1, 1, 'SR', NULL, NULL, NULL),
(8187, '2016-09-16 13:44:26', NULL, NULL, 2930, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 13:44:26', 'admin-1473995493-14740046658115382', 1, 1, 'SR', NULL, NULL, NULL),
(8188, '2016-09-16 13:44:26', NULL, NULL, 2930, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 13:44:26', 'admin-1473995493-14740046658115382', 1, 1, 'SR', NULL, NULL, NULL),
(8189, '2016-09-16 13:44:26', NULL, NULL, 2930, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 13:44:26', 'admin-1473995493-14740046658115382', 1, 1, 'SR', NULL, NULL, NULL),
(8190, '2016-09-16 13:50:11', NULL, NULL, 2931, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 13:50:11', 'admin-1473995493-14740050109637950', 1, 0, '', NULL, NULL, NULL),
(8191, '2016-09-16 13:50:11', NULL, NULL, 2931, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 13:50:11', 'admin-1473995493-14740050109637950', 1, 1, 'SR', NULL, NULL, NULL),
(8192, '2016-09-16 10:34:51', NULL, NULL, 2921, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 10:34:51', 'admin-1473987292-1473993291509557', 1, 1, 'SR', NULL, NULL, NULL),
(8193, '2016-09-16 14:35:18', NULL, NULL, 2935, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 14:35:18', 'admin-1474007121-1474007718606444', 1, 1, 'SR', NULL, NULL, NULL),
(8194, '2016-09-16 13:50:11', NULL, NULL, 2931, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 13:50:11', 'admin-1473995493-14740050109637950', 1, 0, '', NULL, NULL, NULL),
(8195, '2016-09-16 11:44:50', NULL, NULL, 2924, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 11:44:50', 'admin-1473995493-1473997490110145', 1, 1, 'SR', NULL, NULL, NULL),
(8196, '2016-09-16 12:08:29', NULL, NULL, 2925, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 12:08:29', 'admin-1473995493-14739989089508432', 1, 1, 'SR', NULL, NULL, NULL),
(8197, '2016-09-16 12:08:29', NULL, NULL, 2925, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 12:08:29', 'admin-1473995493-14739989089508432', 1, 0, '', NULL, NULL, NULL),
(8198, '2016-09-16 12:16:03', NULL, NULL, 2926, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 12:16:03', 'admin-1473995493-14739993635324529', 1, 1, 'SR', NULL, NULL, NULL),
(8199, '2016-09-16 12:21:37', NULL, NULL, 2927, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 12:21:37', 'admin-1473995493-14739996970712427', 1, 1, 'SR', NULL, NULL, NULL),
(8200, '2016-09-16 12:21:37', NULL, NULL, 2927, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 12:21:37', 'admin-1473995493-14739996970712427', 1, 1, 'SR', NULL, NULL, NULL),
(8201, '2016-09-16 12:52:36', NULL, NULL, 2928, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 12:52:36', 'admin-1473995493-14740015565035095', 1, 1, 'SR', 1, NULL, NULL),
(8202, '2016-09-16 12:53:21', NULL, NULL, 2929, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 12:53:21', 'admin-1473995493-1474001601515723', 1, 1, 'SR', 1, NULL, NULL),
(8203, '2016-09-16 11:44:34', NULL, NULL, 2924, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 11:44:34', 'admin-1473995493-14739974738992892', 1, 1, 'SR', NULL, NULL, NULL),
(8204, '2016-09-16 11:44:19', NULL, NULL, 2924, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 11:44:19', 'admin-1473995493-14739974597625654', 1, 0, '', NULL, NULL, NULL),
(8205, '2016-09-16 11:44:19', NULL, NULL, 2924, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 11:44:19', 'admin-1473995493-14739974597625654', 1, 0, '', NULL, NULL, NULL),
(8206, '2016-09-16 11:42:12', NULL, NULL, 2923, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 11:42:12', 'admin-1473995493-14739973323035023', 1, 0, '', NULL, NULL, NULL),
(8207, '2016-09-16 11:42:25', NULL, NULL, 2923, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 11:42:25', 'admin-1473995493-14739973451795137', 1, 1, 'SR', NULL, NULL, NULL),
(8208, '2016-09-16 11:07:18', NULL, NULL, 2922, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 11:07:18', 'admin-1473987292-1473995237838439', 1, 1, 'SR', NULL, NULL, NULL),
(8209, '2016-09-16 11:07:18', NULL, NULL, 2922, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 11:07:18', 'admin-1473987292-1473995237838439', 1, 1, 'SR', NULL, NULL, NULL),
(8210, '2016-09-16 11:07:18', NULL, NULL, 2922, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 11:07:18', 'admin-1473987292-1473995237838439', 1, 1, 'SR', NULL, NULL, NULL),
(8211, '2016-09-16 11:07:18', NULL, NULL, 2922, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 11:07:18', 'admin-1473987292-1473995237838439', 1, 1, 'SR', NULL, NULL, NULL),
(8212, '2016-09-16 11:07:18', NULL, NULL, 2922, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 11:07:18', 'admin-1473987292-1473995237838439', 1, 0, '', NULL, NULL, NULL),
(8213, '2016-09-16 11:07:18', NULL, NULL, 2922, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 11:07:18', 'admin-1473987292-1473995237838439', 1, 0, '', NULL, NULL, NULL),
(8214, '2016-09-16 13:58:30', NULL, NULL, 2934, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 13:58:30', 'admin-1473995493-14740055106297858', 1, 1, 'SR', NULL, NULL, NULL),
(8215, '2016-09-16 11:07:18', NULL, NULL, 2922, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 11:07:18', 'admin-1473987292-1473995237838439', 1, 0, '', NULL, NULL, NULL),
(8216, '2016-09-16 10:34:51', NULL, NULL, 2921, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 10:34:51', 'admin-1473987292-1473993291509557', 1, 1, 'SR', NULL, NULL, NULL),
(8217, '2016-09-16 10:34:51', NULL, NULL, 2921, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 10:34:51', 'admin-1473987292-1473993291509557', 1, 0, '', NULL, NULL, NULL),
(8218, '2016-09-16 10:34:51', NULL, NULL, 2921, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 10:34:51', 'admin-1473987292-1473993291509557', 1, 0, '', NULL, NULL, NULL),
(8219, '2016-09-16 10:29:34', NULL, NULL, 2920, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 10:29:34', 'admin-1473987292-14739929741967940', 1, 0, '', NULL, NULL, NULL),
(8220, '2016-09-16 10:29:34', NULL, NULL, 2920, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 10:29:34', 'admin-1473987292-14739929741967940', 1, 0, '', NULL, NULL, NULL),
(8221, '2016-09-16 10:22:05', NULL, NULL, 2919, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 10:22:05', 'admin-1473987292-14739925253455653', 1, 1, 'SR', NULL, NULL, NULL),
(8222, '2016-09-16 10:22:05', NULL, NULL, 2919, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 10:22:05', 'admin-1473987292-14739925253455653', 1, 0, '', NULL, NULL, NULL),
(8223, '2016-09-16 10:21:43', NULL, NULL, 2919, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 10:21:43', 'admin-1473987292-14739925031257017', 1, 0, '', NULL, NULL, NULL),
(8224, '2016-09-16 10:21:38', NULL, NULL, 2919, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 10:21:38', 'admin-1473987292-14739924978402890', 1, 0, '', NULL, NULL, NULL),
(8225, '2016-09-16 10:10:37', NULL, NULL, 2918, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 10:10:37', 'admin-1473987292-14739918377596272', 1, 0, '', NULL, NULL, NULL),
(8226, '2016-09-16 10:10:29', NULL, NULL, 2918, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 10:10:29', 'admin-1473987292-14739918291333019', 1, 0, '', NULL, NULL, NULL),
(8227, '2016-09-16 09:45:15', NULL, NULL, 2916, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 09:45:15', 'admin-1473987292-14739903153609716', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(8228, '2016-09-16 10:10:29', NULL, NULL, 2918, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 10:10:29', 'admin-1473987292-14739918291333019', 1, 1, 'SR', NULL, NULL, NULL),
(8229, '2016-09-16 09:45:32', NULL, NULL, 2917, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 09:45:32', 'admin-1473987292-14739903323407023', 1, 0, '', NULL, NULL, NULL),
(8230, '2016-09-16 09:45:15', NULL, NULL, 2916, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474026586', 'admin', '2016-09-16 09:45:15', 'admin-1473987292-14739903153609716', 1, 0, '', NULL, NULL, NULL),
(8231, '2016-09-17 18:34:55', NULL, NULL, 3006, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 18:34:55', 'admin-1474104733-14741084950408016', 1, 1, 'SR', NULL, NULL, NULL),
(8232, '2016-09-17 18:34:55', NULL, NULL, 3006, 0, 211, '145', 'Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 18:34:55', 'admin-1474104733-14741084950408016', 1, 0, '', NULL, NULL, NULL),
(8233, '2016-09-17 18:34:55', NULL, NULL, 3006, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 18:34:55', 'admin-1474104733-14741084950408016', 1, 0, '', NULL, NULL, NULL),
(8234, '2016-09-17 18:37:40', NULL, NULL, 3005, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 18:37:40', 'admin-1474104733-14741086604607539', 1, 1, 'SR', NULL, NULL, NULL),
(8235, '2016-09-17 18:47:24', NULL, NULL, 3007, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 18:47:24', 'admin-1474104733-14741092447066952', 1, 1, 'SR', NULL, NULL, NULL),
(8236, '2016-09-17 18:47:24', NULL, NULL, 3007, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 18:47:24', 'admin-1474104733-14741092447066952', 1, 0, '', NULL, NULL, NULL),
(8237, '2016-09-17 19:15:15', NULL, NULL, 3006, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 19:15:15', 'admin-1474104733-14741109154018259', 1, 1, 'SR', NULL, NULL, NULL),
(8238, '2016-09-17 19:16:00', NULL, NULL, 3006, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 19:16:00', 'admin-1474104733-14741109601766316', 1, 0, '', NULL, NULL, NULL),
(8239, '2016-09-17 20:28:58', NULL, NULL, 3007, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 20:28:58', 'admin-1474104733-14741153382637452', 1, 0, '', NULL, NULL, NULL),
(8240, '2016-09-17 18:34:55', NULL, NULL, 3006, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 18:34:55', 'admin-1474104733-14741084950408016', 1, 1, 'SR', NULL, NULL, NULL),
(8241, '2016-09-17 18:34:55', NULL, NULL, 3006, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 18:34:55', 'admin-1474104733-14741084950408016', 1, 1, 'SR', NULL, NULL, NULL),
(8242, '2016-09-17 18:32:45', NULL, NULL, 3006, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 18:32:45', 'admin-1474104733-1474108365628902', 1, 0, '', NULL, NULL, NULL),
(8243, '2016-09-17 18:32:32', NULL, NULL, 3005, 0, 181, '116', 'Open Food ', 'Angel Hair', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 18:32:32', 'admin-1474104733-14741083522324756', 1, 0, '', NULL, NULL, NULL),
(8244, '2016-09-17 18:32:32', NULL, NULL, 3005, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 18:32:32', 'admin-1474104733-14741083522324756', 1, 1, 'SR', NULL, NULL, NULL),
(8245, '2016-09-17 18:32:32', NULL, NULL, 3005, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 18:32:32', 'admin-1474104733-14741083522324756', 1, 1, 'SR', NULL, NULL, NULL),
(8246, '2016-09-17 18:13:12', NULL, NULL, 3004, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 18:13:12', 'admin-1474104733-1474107192807332', 1, 1, 'SR', 1, NULL, NULL),
(8247, '2016-09-17 18:32:32', NULL, NULL, 3005, 0, 181, '116', 'Open Food ', 'Bacon Aglio Olio', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 18:32:32', 'admin-1474104733-14741083522324756', 1, 0, '', NULL, NULL, NULL),
(8248, '2016-09-17 13:43:32', NULL, NULL, 2990, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:43:32', 'admin-1474090057-1474091011833243', 1, 1, 'SR', NULL, NULL, NULL),
(8249, '2016-09-17 13:49:56', NULL, NULL, 2992, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:49:56', 'admin-1474090057-14740913967016540', 1, 1, 'SR', NULL, NULL, NULL),
(8250, '2016-09-17 13:49:56', NULL, NULL, 2992, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:49:56', 'admin-1474090057-14740913967016540', 1, 1, 'SR', NULL, NULL, NULL),
(8251, '2016-09-17 13:49:56', NULL, NULL, 2992, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:49:56', 'admin-1474090057-14740913967016540', 1, 1, 'SR', NULL, NULL, NULL),
(8252, '2016-09-17 13:49:56', NULL, NULL, 2992, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:49:56', 'admin-1474090057-14740913967016540', 1, 0, '', NULL, NULL, NULL),
(8253, '2016-09-17 13:49:56', NULL, NULL, 2992, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:49:56', 'admin-1474090057-14740913967016540', 1, 0, '', NULL, NULL, NULL),
(8254, '2016-09-17 13:54:08', NULL, NULL, 2991, 0, 214, '148', 'Set Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:54:08', 'admin-1474090057-14740916481764068', 1, 0, '', NULL, NULL, NULL),
(8255, '2016-09-17 13:54:08', NULL, NULL, 2991, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:54:08', 'admin-1474090057-14740916481764068', 1, 1, 'SR', NULL, NULL, NULL),
(8256, '2016-09-17 13:54:08', NULL, NULL, 2991, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:54:08', 'admin-1474090057-14740916481764068', 1, 1, 'SR', NULL, NULL, NULL),
(8257, '2016-09-17 13:54:08', NULL, NULL, 2991, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:54:08', 'admin-1474090057-14740916481764068', 1, 0, '', NULL, NULL, NULL),
(8258, '2016-09-17 17:41:57', NULL, NULL, 3001, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 17:41:57', 'admin-1474104733-1474105317787276', 1, 1, 'SR', NULL, NULL, NULL),
(8259, '2016-09-17 17:30:47', NULL, NULL, 3000, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 17:30:47', 'admin-1474091738-14741046472145282', 1, 0, '', NULL, NULL, NULL),
(8260, '2016-09-17 17:32:51', NULL, NULL, 3000, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 17:32:51', 'admin-1474104733-14741047714069071', 1, 0, '', NULL, NULL, NULL),
(8261, '2016-09-17 17:32:00', NULL, NULL, 3000, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 17:32:00', 'admin-1474091738-14741047206921898', 1, 1, 'SR', NULL, NULL, NULL),
(8262, '2016-09-17 17:28:27', NULL, NULL, 2997, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 17:28:27', 'admin-1474091738-14741045076233229', 1, 0, '', NULL, NULL, NULL),
(8263, '2016-09-17 17:28:27', NULL, NULL, 2997, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 17:28:27', 'admin-1474091738-14741045076233229', 1, 0, '', NULL, NULL, NULL),
(8264, '2016-09-17 16:35:21', NULL, NULL, 2998, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 16:35:21', 'admin-1474091738-14741013211109050', 1, 0, '', NULL, NULL, NULL),
(8265, '2016-09-17 16:35:21', NULL, NULL, 2998, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 16:35:21', 'admin-1474091738-14741013211109050', 1, 0, '', NULL, NULL, NULL),
(8266, '2016-09-17 16:35:32', NULL, NULL, 2998, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 16:35:32', 'admin-1474091738-14741013320263995', 1, 1, 'SR', NULL, NULL, NULL),
(8267, '2016-09-17 16:35:32', NULL, NULL, 2998, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 16:35:32', 'admin-1474091738-14741013320263995', 1, 1, 'SR', NULL, NULL, NULL),
(8268, '2016-09-17 16:58:26', NULL, NULL, 2996, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 16:58:26', 'admin-1474091738-1474102706755943', 1, 1, 'SR', NULL, NULL, NULL),
(8269, '2016-09-17 17:12:14', NULL, NULL, 2999, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 17:12:14', 'admin-1474091738-14741035340098156', 1, 1, 'SR', NULL, NULL, NULL),
(8270, '2016-09-17 17:12:14', NULL, NULL, 2999, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 17:12:14', 'admin-1474091738-14741035340098156', 1, 1, 'SR', NULL, NULL, NULL),
(8271, '2016-09-17 17:12:14', NULL, NULL, 2999, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 17:12:14', 'admin-1474091738-14741035340098156', 1, 1, 'SR', NULL, NULL, NULL),
(8272, '2016-09-17 17:12:14', NULL, NULL, 2999, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 17:12:14', 'admin-1474091738-14741035340098156', 1, 1, 'SR', NULL, NULL, NULL),
(8273, '2016-09-17 17:32:33', NULL, NULL, 3000, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 17:32:33', 'admin-1474104733-14741047534734573', 1, 1, 'SR', NULL, NULL, NULL),
(8274, '2016-09-17 16:16:35', NULL, NULL, 2997, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 16:16:35', 'admin-1474091738-14741001949429742', 1, 1, 'SR', NULL, NULL, NULL),
(8275, '2016-09-17 16:18:40', NULL, NULL, 2996, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 16:18:40', 'admin-1474091738-14741003203407294', 1, 1, 'SR', NULL, NULL, NULL),
(8276, '2016-09-17 14:24:29', NULL, NULL, 2994, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 14:24:29', 'admin-1474091738-14740934691451167', 1, 0, '', NULL, NULL, NULL),
(8277, '2016-09-17 14:28:04', NULL, NULL, 2985, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 14:28:04', 'admin-1474091738-14740936846581945', 1, 1, 'SR', NULL, NULL, NULL),
(8278, '2016-09-17 15:19:08', NULL, NULL, 2995, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 15:19:08', 'admin-1474091738-1474096748816148', 1, 1, 'SR', NULL, NULL, NULL),
(8279, '2016-09-17 15:19:08', NULL, NULL, 2995, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 15:19:08', 'admin-1474091738-1474096748816148', 1, 1, 'SR', NULL, NULL, NULL),
(8280, '2016-09-17 15:20:02', NULL, NULL, 2996, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 15:20:02', 'admin-1474091738-14740968018733864', 1, 1, 'SR', NULL, NULL, NULL),
(8281, '2016-09-17 13:34:55', NULL, NULL, 2987, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:34:55', 'admin-1474090057-1474090495416667', 1, 1, 'SR', NULL, NULL, NULL),
(8282, '2016-09-17 16:01:37', NULL, NULL, 2996, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 16:01:37', 'admin-1474091738-14740992971365089', 1, 1, 'SR', NULL, NULL, NULL),
(8283, '2016-09-17 15:21:42', NULL, NULL, 2997, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 15:21:42', 'admin-1474091738-14740969023847340', 1, 1, 'SR', NULL, NULL, NULL),
(8284, '2016-09-17 15:21:42', NULL, NULL, 2997, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 15:21:42', 'admin-1474091738-14740969023847340', 1, 1, 'SR', NULL, NULL, NULL),
(8285, '2016-09-17 15:24:06', NULL, NULL, 2997, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 15:24:06', 'admin-1474091738-14740970467022879', 1, 0, '', NULL, NULL, NULL),
(8286, '2016-09-17 13:55:23', NULL, NULL, 2993, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:55:23', 'admin-1474090057-1474091722986146', 1, 1, 'SR', NULL, NULL, NULL),
(8287, '2016-09-17 13:55:23', NULL, NULL, 2993, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:55:23', 'admin-1474090057-1474091722986146', 1, 1, 'SR', NULL, NULL, NULL),
(8288, '2016-09-17 13:55:23', NULL, NULL, 2993, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:55:23', 'admin-1474090057-1474091722986146', 1, 1, 'SR', NULL, NULL, NULL),
(8289, '2016-09-17 13:55:23', NULL, NULL, 2993, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:55:23', 'admin-1474090057-1474091722986146', 1, 0, '', NULL, NULL, NULL),
(8290, '2016-09-17 13:43:14', NULL, NULL, 2990, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:43:14', 'admin-1474090057-14740909941039924', 1, 0, '', NULL, NULL, NULL),
(8291, '2016-09-17 17:41:57', NULL, NULL, 3001, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 17:41:57', 'admin-1474104733-1474105317787276', 1, 1, 'SR', NULL, NULL, NULL),
(8292, '2016-09-17 16:01:37', NULL, NULL, 2996, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 16:01:37', 'admin-1474091738-14740992971365089', 1, 1, 'SR', NULL, NULL, NULL),
(8293, '2016-09-17 15:30:28', NULL, NULL, 2997, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 15:30:28', 'admin-1474091738-14740974279545781', 1, 1, 'SR', NULL, NULL, NULL),
(8294, '2016-09-17 15:21:42', NULL, NULL, 2997, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 15:21:42', 'admin-1474091738-14740969023847340', 1, 1, 'SR', NULL, NULL, NULL),
(8295, '2016-09-17 15:20:02', NULL, NULL, 2996, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 15:20:02', 'admin-1474091738-14740968018733864', 1, 1, 'SR', NULL, NULL, NULL),
(8296, '2016-09-17 12:37:48', NULL, NULL, 2978, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:37:48', 'admin-1474085850-14740870685559140', 1, 1, 'SR', NULL, NULL, NULL),
(8297, '2016-09-17 12:42:56', NULL, NULL, 2979, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:42:56', 'admin-1474085850-14740873759793047', 1, 0, '', NULL, NULL, NULL),
(8298, '2016-09-17 12:42:56', NULL, NULL, 2979, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:42:56', 'admin-1474085850-14740873759793047', 1, 0, '', NULL, NULL, NULL),
(8299, '2016-09-17 12:46:35', NULL, NULL, 2970, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:46:35', 'admin-1474085850-14740875953063351', 1, 1, 'SR', NULL, NULL, NULL),
(8300, '2016-09-17 12:46:35', NULL, NULL, 2970, 0, 72, '72', 'Mushroom Chicken', 'without rice', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:46:35', 'admin-1474085850-14740875953063351', 1, 1, 'SR', NULL, NULL, NULL),
(8301, '2016-09-17 12:46:35', NULL, NULL, 2970, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', 'Bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:46:35', 'admin-1474085850-14740875953063351', 1, 0, '', NULL, NULL, NULL),
(8302, '2016-09-17 12:50:34', NULL, NULL, 2980, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:50:34', 'admin-1474085850-14740878339657127', 1, 0, '', NULL, NULL, NULL),
(8303, '2016-09-17 12:50:34', NULL, NULL, 2980, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:50:34', 'admin-1474085850-14740878339657127', 1, 0, '', NULL, NULL, NULL),
(8304, '2016-09-17 12:50:34', NULL, NULL, 2980, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:50:34', 'admin-1474085850-14740878339657127', 1, 0, '', NULL, NULL, NULL),
(8305, '2016-09-17 12:52:25', NULL, NULL, 2980, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:52:25', 'admin-1474085850-14740879450183884', 1, 1, 'SR', NULL, NULL, NULL),
(8306, '2016-09-17 13:00:07', NULL, NULL, 2981, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:00:07', 'admin-1474085850-14740884071718015', 1, 1, 'SR', NULL, NULL, NULL),
(8307, '2016-09-17 13:00:07', NULL, NULL, 2981, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:00:07', 'admin-1474085850-14740884071718015', 1, 1, 'SR', NULL, NULL, NULL),
(8308, '2016-09-17 13:00:07', NULL, NULL, 2981, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:00:07', 'admin-1474085850-14740884071718015', 1, 1, 'SR', NULL, NULL, NULL),
(8309, '2016-09-17 13:00:14', NULL, NULL, 2981, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:00:14', 'admin-1474085850-14740884146066163', 1, 0, '', NULL, NULL, NULL),
(8310, '2016-09-17 13:04:57', NULL, NULL, 2982, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:04:57', 'admin-1474085850-14740886973569939', 1, 0, '', NULL, NULL, NULL),
(8311, '2016-09-17 12:16:57', NULL, NULL, 2975, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:16:57', 'admin-1474073436-14740858172366550', 1, 1, 'SR', NULL, NULL, NULL),
(8312, '2016-09-17 12:17:05', NULL, NULL, 2974, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:17:05', 'admin-1474073436-14740858256554259', 1, 0, '', NULL, NULL, NULL),
(8313, '2016-09-17 12:17:42', NULL, NULL, 2970, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:17:42', 'admin-1474085850-14740858626969431', 1, 1, 'SR', NULL, NULL, NULL),
(8314, '2016-09-17 12:21:42', NULL, NULL, 2976, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:21:42', 'admin-1474085850-14740861023549053', 1, 0, '', NULL, NULL, NULL),
(8315, '2016-09-17 12:21:42', NULL, NULL, 2976, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:21:42', 'admin-1474085850-14740861023549053', 1, 0, '', NULL, NULL, NULL),
(8316, '2016-09-17 12:21:42', NULL, NULL, 2976, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:21:42', 'admin-1474085850-14740861023549053', 1, 1, 'SR', NULL, NULL, NULL),
(8317, '2016-09-17 12:21:42', NULL, NULL, 2976, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:21:42', 'admin-1474085850-14740861023549053', 1, 0, '', NULL, NULL, NULL),
(8318, '2016-09-17 12:42:56', NULL, NULL, 2979, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:42:56', 'admin-1474085850-14740873759793047', 1, 0, '', NULL, NULL, NULL),
(8319, '2016-09-17 12:22:50', NULL, NULL, 2977, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:22:50', 'admin-1474085850-14740861699236927', 1, 1, 'SR', NULL, NULL, NULL),
(8320, '2016-09-17 12:23:45', NULL, NULL, 2969, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:23:45', 'admin-1474085850-14740862248629197', 1, 1, 'SR', NULL, NULL, '10.0'),
(8321, '2016-09-17 09:38:35', NULL, NULL, 2962, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 09:38:35', 'admin-1474073436-14740763148453447', 1, 0, '', NULL, NULL, NULL),
(8322, '2016-09-17 13:57:42', NULL, NULL, 2990, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:57:42', 'admin-1474091738-14740918627107212', 1, 0, '', NULL, NULL, NULL),
(8323, '2016-09-17 13:43:14', NULL, NULL, 2990, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:43:14', 'admin-1474090057-14740909941039924', 1, 0, '', NULL, NULL, NULL),
(8324, '2016-09-17 13:35:44', NULL, NULL, 2988, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:35:44', 'admin-1474090057-14740905444201994', 1, 0, '', NULL, NULL, NULL),
(8325, '2016-09-17 13:41:06', NULL, NULL, 2989, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:41:06', 'admin-1474090057-14740908661639345', 1, 1, 'SR', NULL, NULL, NULL),
(8326, '2016-09-17 13:41:06', NULL, NULL, 2989, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:41:06', 'admin-1474090057-14740908661639345', 1, 0, '', NULL, NULL, NULL),
(8327, '2016-09-17 13:41:06', NULL, NULL, 2989, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:41:06', 'admin-1474090057-14740908661639345', 1, 0, '', NULL, NULL, NULL),
(8328, '2016-09-17 13:41:06', NULL, NULL, 2989, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:41:06', 'admin-1474090057-14740908661639345', 1, 1, 'SR', NULL, NULL, NULL),
(8329, '2016-09-17 13:41:06', NULL, NULL, 2989, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:41:06', 'admin-1474090057-14740908661639345', 1, 1, 'SR', NULL, NULL, NULL),
(8330, '2016-09-17 13:34:55', NULL, NULL, 2987, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:34:55', 'admin-1474090057-1474090495416667', 1, 0, '', NULL, NULL, NULL),
(8331, '2016-09-17 13:43:14', NULL, NULL, 2990, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:43:14', 'admin-1474090057-14740909941039924', 1, 1, 'SR', NULL, NULL, NULL),
(8332, '2016-09-17 13:35:44', NULL, NULL, 2988, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:35:44', 'admin-1474090057-14740905444201994', 1, 0, '', NULL, NULL, NULL),
(8333, '2016-09-17 13:33:16', NULL, NULL, 2986, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:33:16', 'admin-1474090057-14740903960967020', 1, 0, '', NULL, NULL, NULL),
(8334, '2016-09-17 13:27:51', NULL, NULL, 2970, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:27:51', 'admin-1474090057-14740900707292441', 1, 1, 'SR', NULL, NULL, NULL),
(8335, '2016-09-17 13:33:16', NULL, NULL, 2986, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:33:16', 'admin-1474090057-14740903960967020', 1, 1, 'SR', NULL, NULL, NULL),
(8336, '2016-09-17 13:33:16', NULL, NULL, 2986, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:33:16', 'admin-1474090057-14740903960967020', 1, 1, 'SR', NULL, NULL, NULL),
(8337, '2016-09-17 13:21:45', NULL, NULL, 2985, 0, 82, '82', 'Set Rice Wine Ginger Pork', 'extra rice', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:21:46', 'admin-1474085850-14740897058136277', 1, 1, 'SR', NULL, NULL, NULL),
(8338, '2016-09-17 13:25:38', NULL, NULL, 2985, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:25:38', 'admin-1474085850-14740899382959345', 1, 0, '', NULL, NULL, NULL),
(8339, '2016-09-17 13:25:38', NULL, NULL, 2985, 0, 81, '81', 'Set Pepper Pork', 'extra rice', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:25:38', 'admin-1474085850-14740899382959345', 1, 1, 'SR', NULL, NULL, NULL),
(8340, '2016-09-17 13:06:11', NULL, NULL, 2983, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:06:11', 'admin-1474085850-14740887713787639', 1, 0, '', NULL, NULL, NULL),
(8341, '2016-09-17 13:06:11', NULL, NULL, 2983, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:06:11', 'admin-1474085850-14740887713787639', 1, 0, '', NULL, NULL, NULL),
(8342, '2016-09-17 13:06:11', NULL, NULL, 2983, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:06:11', 'admin-1474085850-14740887713787639', 1, 1, 'SR', NULL, NULL, NULL),
(8343, '2016-09-17 13:12:09', NULL, NULL, 2984, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:12:09', 'admin-1474085850-14740891293088064', 1, 0, '', NULL, NULL, NULL),
(8344, '2016-09-17 13:21:45', NULL, NULL, 2985, 0, 214, '148', 'Set Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:21:45', 'admin-1474085850-14740897058136277', 1, 0, '', NULL, NULL, NULL),
(8345, '2016-09-17 12:16:39', NULL, NULL, 2974, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:16:39', 'admin-1474073436-14740857990335097', 1, 0, '', NULL, NULL, NULL),
(8346, '2016-09-17 12:16:39', NULL, NULL, 2974, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:16:39', 'admin-1474073436-14740857990335097', 1, 1, 'SR', NULL, NULL, NULL),
(8347, '2016-09-17 12:16:39', NULL, NULL, 2974, 0, 211, '145', 'Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:16:39', 'admin-1474073436-14740857990335097', 1, 0, '', NULL, NULL, NULL),
(8348, '2016-09-17 13:21:46', NULL, NULL, 2985, 0, 82, '82', 'Set Rice Wine Ginger Pork', 'extra rice', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:21:46', 'admin-1474085850-14740897058136277', 1, 1, 'SR', NULL, NULL, NULL),
(8349, '2016-09-17 12:16:39', NULL, NULL, 2974, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:16:39', 'admin-1474073436-14740857990335097', 1, 1, 'SR', NULL, NULL, NULL),
(8350, '2016-09-17 12:16:39', NULL, NULL, 2974, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:16:39', 'admin-1474073436-14740857990335097', 1, 1, 'SR', NULL, NULL, NULL),
(8351, '2016-09-17 11:47:49', NULL, NULL, 2972, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 11:47:49', 'admin-1474073436-14740840697406749', 1, 1, 'SR', NULL, NULL, NULL),
(8352, '2016-09-17 11:49:53', NULL, NULL, 2969, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 11:49:53', 'admin-1474073436-14740841930908855', 1, 0, '', NULL, NULL, '10.0'),
(8353, '2016-09-17 11:57:34', NULL, NULL, 2973, 0, 76, '76', 'Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 11:57:34', 'admin-1474073436-1474084654765754', 1, 1, 'SR', NULL, NULL, NULL),
(8354, '2016-09-17 11:57:34', NULL, NULL, 2973, 0, 181, '116', 'Open Food ', 'Aglio Olio', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 11:57:34', 'admin-1474073436-1474084654765754', 1, 0, '', NULL, NULL, NULL),
(8355, '2016-09-17 11:57:34', NULL, NULL, 2973, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 11:57:34', 'admin-1474073436-1474084654765754', 1, 1, 'SR', NULL, NULL, NULL),
(8356, '2016-09-17 11:58:02', NULL, NULL, 2973, 0, 153, '87', 'Big Breakfast ', 'separate sausage and bacon', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 11:58:02', 'admin-1474073436-14740846819637219', 1, 0, '', NULL, NULL, NULL),
(8357, '2016-09-17 11:58:39', NULL, NULL, 2973, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 11:58:39', 'admin-1474073436-1474084719210529', 1, 1, 'SR', NULL, NULL, NULL),
(8358, '2016-09-17 13:33:16', NULL, NULL, 2986, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 13:33:16', 'admin-1474090057-14740903960967020', 1, 0, '', NULL, NULL, NULL),
(8359, '2016-09-17 12:16:39', NULL, NULL, 2974, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 12:16:39', 'admin-1474073436-14740857990335097', 1, 1, 'SR', NULL, NULL, NULL),
(8360, '2016-09-17 11:58:39', NULL, NULL, 2973, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 11:58:39', 'admin-1474073436-1474084719210529', 1, 1, 'SR', NULL, NULL, NULL),
(8361, '2016-09-17 11:44:06', NULL, NULL, 2971, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 11:44:06', 'admin-1474073436-14740838459114129', 1, 0, '', NULL, NULL, NULL),
(8362, '2016-09-17 11:47:49', NULL, NULL, 2972, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 11:47:49', 'admin-1474073436-14740840697406749', 1, 1, 'SR', NULL, NULL, NULL),
(8363, '2016-09-17 10:12:12', NULL, NULL, 2964, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 10:12:12', 'admin-1474073436-1474078332237417', 1, 0, '', NULL, NULL, NULL),
(8364, '2016-09-17 10:36:04', NULL, NULL, 2965, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 10:36:04', 'admin-1474073436-14740797639353964', 1, 0, '', NULL, NULL, NULL),
(8365, '2016-09-17 10:36:04', NULL, NULL, 2965, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 10:36:04', 'admin-1474073436-14740797639353964', 1, 0, '', NULL, NULL, NULL),
(8366, '2016-09-17 10:36:33', NULL, NULL, 2965, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 10:36:33', 'admin-1474073436-14740797936817795', 1, 1, 'SR', NULL, NULL, NULL),
(8367, '2016-09-17 10:36:33', NULL, NULL, 2965, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 10:36:33', 'admin-1474073436-14740797936817795', 1, 0, '', NULL, NULL, NULL),
(8368, '2016-09-17 10:47:35', NULL, NULL, 2966, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 10:47:35', 'admin-1474073436-1474080455075926', 1, 0, '', NULL, NULL, NULL),
(8369, '2016-09-17 10:47:35', NULL, NULL, 2966, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 10:47:35', 'admin-1474073436-1474080455075926', 1, 0, '', NULL, NULL, NULL),
(8370, '2016-09-17 10:48:19', NULL, NULL, 2966, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 10:48:19', 'admin-1474073436-14740804989062092', 1, 1, 'SR', NULL, NULL, NULL),
(8371, '2016-09-17 10:58:27', NULL, NULL, 2967, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 10:58:27', 'admin-1474073436-1474081107002144', 1, 0, '', NULL, NULL, NULL),
(8372, '2016-09-17 10:58:27', NULL, NULL, 2967, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 10:58:27', 'admin-1474073436-1474081107002144', 1, 0, '', NULL, NULL, NULL),
(8373, '2016-09-17 10:59:25', NULL, NULL, 2968, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 10:59:25', 'admin-1474073436-1474081165703731', 1, 0, '', NULL, NULL, NULL),
(8374, '2016-09-17 10:59:25', NULL, NULL, 2968, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 10:59:25', 'admin-1474073436-1474081165703731', 1, 1, 'SR', NULL, NULL, NULL),
(8375, '2016-09-17 11:22:49', NULL, NULL, 2969, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 11:22:49', 'admin-1474073436-14740825697031750', 1, 1, 'SR', NULL, NULL, '10.0'),
(8376, '2016-09-17 11:28:39', NULL, NULL, 2969, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 11:28:39', 'admin-1474073436-1474082919068452', 1, 0, '', NULL, NULL, '10.0'),
(8377, '2016-09-17 11:43:19', NULL, NULL, 2970, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 11:43:19', 'admin-1474073436-14740837996284892', 1, 1, 'SR', NULL, NULL, NULL),
(8378, '2016-09-17 11:43:19', NULL, NULL, 2970, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 11:43:19', 'admin-1474073436-14740837996284892', 1, 1, 'SR', NULL, NULL, NULL),
(8379, '2016-09-17 11:44:06', NULL, NULL, 2971, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 11:44:06', 'admin-1474073436-14740838459114129', 1, 0, '', NULL, NULL, NULL),
(8380, '2016-09-17 10:12:12', NULL, NULL, 2964, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 10:12:12', 'admin-1474073436-1474078332237417', 1, 0, '', NULL, NULL, NULL),
(8381, '2016-09-17 10:12:12', NULL, NULL, 2964, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 10:12:12', 'admin-1474073436-1474078332237417', 1, 1, 'SR', NULL, NULL, NULL),
(8382, '2016-09-17 10:12:12', NULL, NULL, 2964, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 10:12:12', 'admin-1474073436-1474078332237417', 1, 1, 'SR', NULL, NULL, NULL),
(8383, '2016-09-17 10:10:21', NULL, NULL, 2963, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 10:10:21', 'admin-1474073436-14740782214719296', 1, 0, '', NULL, NULL, NULL),
(8384, '2016-09-17 10:11:04', NULL, NULL, 2963, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 10:11:04', 'admin-1474073436-14740782644122384', 1, 1, 'SR', NULL, NULL, NULL),
(8385, '2016-09-17 10:10:21', NULL, NULL, 2963, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 10:10:21', 'admin-1474073436-14740782214719296', 1, 0, '', NULL, NULL, NULL),
(8386, '2016-09-17 09:38:35', NULL, NULL, 2962, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 09:38:35', 'admin-1474073436-14740763148453447', 1, 0, '', NULL, NULL, NULL),
(8387, '2016-09-17 09:38:35', NULL, NULL, 2962, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 09:38:35', 'admin-1474073436-14740763148453447', 1, 1, 'SR', NULL, NULL, NULL),
(8388, '2016-09-17 09:33:50', NULL, NULL, 2961, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 09:33:50', 'admin-1474073436-14740760305947533', 1, 1, 'SR', NULL, NULL, NULL),
(8389, '2016-09-17 09:33:50', NULL, NULL, 2961, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 09:33:50', 'admin-1474073436-14740760305947533', 1, 1, 'SR', NULL, NULL, NULL),
(8390, '2016-09-17 09:33:22', NULL, NULL, 2960, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 09:33:22', 'admin-1474073436-14740760027155754', 1, 0, '', NULL, NULL, NULL),
(8391, '2016-09-17 09:33:22', NULL, NULL, 2960, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 09:33:22', 'admin-1474073436-14740760027155754', 1, 1, 'SR', NULL, NULL, NULL),
(8392, '2016-09-17 09:23:31', NULL, NULL, 2959, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 09:23:31', 'admin-1474073436-14740754111791056', 1, 0, '', NULL, NULL, NULL),
(8393, '2016-09-17 09:23:31', NULL, NULL, 2959, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 09:23:31', 'admin-1474073436-14740754111791056', 1, 0, '', NULL, NULL, NULL),
(8394, '2016-09-17 09:23:31', NULL, NULL, 2959, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474104733', 'admin', '2016-09-17 09:23:31', 'admin-1474073436-14740754111791056', 1, 0, '', NULL, NULL, NULL),
(8395, '2016-09-18 19:27:35', NULL, NULL, 3051, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 19:27:35', 'admin-1474176495-14741980548227584', 1, 1, 'SR', NULL, NULL, '10.0'),
(8396, '2016-09-18 13:49:35', NULL, NULL, 3036, 0, 220, '154', 'Crispy Bacon Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:49:35', 'admin-1474176495-14741777754308228', 1, 0, '', NULL, NULL, NULL),
(8397, '2016-09-18 13:49:35', NULL, NULL, 3036, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:49:35', 'admin-1474176495-14741777754308228', 1, 1, 'SR', NULL, NULL, NULL),
(8398, '2016-09-18 13:49:35', NULL, NULL, 3036, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:49:35', 'admin-1474176495-14741777754308228', 1, 0, '', NULL, NULL, NULL),
(8399, '2016-09-18 13:49:35', NULL, NULL, 3036, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:49:35', 'admin-1474176495-14741777754308228', 1, 0, '', NULL, NULL, NULL),
(8400, '2016-09-18 13:49:35', NULL, NULL, 3036, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:49:35', 'admin-1474176495-14741777754308228', 1, 0, '', NULL, NULL, NULL),
(8401, '2016-09-18 13:49:35', NULL, NULL, 3036, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:49:35', 'admin-1474176495-14741777754308228', 1, 1, 'SR', NULL, NULL, NULL),
(8402, '2016-09-18 13:49:35', NULL, NULL, 3036, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:49:35', 'admin-1474176495-14741777754308228', 1, 1, 'SR', NULL, NULL, NULL),
(8403, '2016-09-18 13:49:35', NULL, NULL, 3036, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:49:35', 'admin-1474176495-14741777754308228', 1, 0, '', NULL, NULL, NULL),
(8404, '2016-09-18 13:49:55', NULL, NULL, 3036, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:49:55', 'admin-1474176495-14741777952408050', 1, 1, 'SR', NULL, NULL, NULL),
(8405, '2016-09-18 14:01:54', NULL, NULL, 3034, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 14:01:54', 'admin-1474176495-14741785141397037', 1, 1, 'SR', NULL, NULL, NULL),
(8406, '2016-09-18 12:26:08', NULL, NULL, 3025, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 12:26:08', 'admin-1474171822-14741727680549248', 1, 1, 'SR', 1, NULL, NULL),
(8407, '2016-09-18 12:26:08', NULL, NULL, 3025, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 12:26:08', 'admin-1474171822-14741727680549248', 1, 1, 'SR', 1, NULL, NULL),
(8408, '2016-09-18 12:37:21', NULL, NULL, 3026, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 12:37:21', 'admin-1474171822-14741734417554087', 1, 1, 'SR', NULL, NULL, NULL),
(8409, '2016-09-18 16:18:06', NULL, NULL, 3045, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 16:18:06', 'admin-1474176495-14741866866194693', 1, 0, '', 1, NULL, NULL),
(8410, '2016-09-18 16:19:53', NULL, NULL, 3046, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 16:19:53', 'admin-1474176495-1474186793272555', 1, 0, '', 1, NULL, NULL),
(8411, '2016-09-18 16:34:17', NULL, NULL, 3047, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 16:34:17', 'admin-1474176495-14741876568062910', 1, 0, '', 1, NULL, NULL),
(8412, '2016-09-18 16:34:17', NULL, NULL, 3047, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 16:34:17', 'admin-1474176495-14741876568062910', 1, 0, '', 1, NULL, NULL),
(8413, '2016-09-18 16:41:20', NULL, NULL, 3048, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 16:41:20', 'admin-1474176495-14741880804291825', 1, 1, 'SR', 1, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(8414, '2016-09-18 16:41:20', NULL, NULL, 3048, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 16:41:20', 'admin-1474176495-14741880804291825', 1, 1, 'SR', 1, NULL, NULL),
(8415, '2016-09-18 17:56:53', NULL, NULL, 3049, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 17:56:53', 'admin-1474176495-14741926129062648', 1, 0, '', 1, NULL, NULL),
(8416, '2016-09-18 18:42:12', NULL, NULL, 3050, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 18:42:12', 'admin-1474176495-14741953319554879', 1, 1, 'SR', 1, NULL, '10.0'),
(8417, '2016-09-18 19:27:35', NULL, NULL, 3051, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 19:27:35', 'admin-1474176495-14741980548227584', 1, 1, 'SR', NULL, NULL, '10.0'),
(8418, '2016-09-18 16:18:06', NULL, NULL, 3045, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 16:18:06', 'admin-1474176495-14741866866194693', 1, 1, 'SR', 1, NULL, NULL),
(8419, '2016-09-18 14:52:57', NULL, NULL, 3034, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 14:52:57', 'admin-1474176495-14741815773468074', 1, 1, 'SR', NULL, NULL, NULL),
(8420, '2016-09-18 15:16:46', NULL, NULL, 3038, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 15:16:46', 'admin-1474176495-1474183006786328', 1, 1, 'SR', 1, NULL, NULL),
(8421, '2016-09-18 15:30:58', NULL, NULL, 3039, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 15:30:58', 'admin-1474176495-14741838579273696', 1, 1, 'SR', NULL, NULL, NULL),
(8422, '2016-09-18 15:31:35', NULL, NULL, 3040, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 15:31:35', 'admin-1474176495-14741838948155343', 1, 1, 'SR', NULL, NULL, NULL),
(8423, '2016-09-18 15:39:38', NULL, NULL, 3041, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 15:39:38', 'admin-1474176495-14741843785529429', 1, 0, '', NULL, NULL, NULL),
(8424, '2016-09-18 16:00:57', NULL, NULL, 3042, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 16:00:57', 'admin-1474176495-14741856568711936', 1, 0, '', 1, NULL, NULL),
(8425, '2016-09-18 16:01:25', NULL, NULL, 3043, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 16:01:25', 'admin-1474176495-14741856848574973', 1, 0, '', 1, NULL, NULL),
(8426, '2016-09-18 12:37:21', NULL, NULL, 3026, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 12:37:21', 'admin-1474171822-14741734417554087', 1, 1, 'SR', NULL, NULL, NULL),
(8427, '2016-09-18 12:48:18', NULL, NULL, 3027, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 12:48:18', 'admin-1474171822-14741740985628674', 1, 1, 'SR', NULL, NULL, NULL),
(8428, '2016-09-18 12:48:18', NULL, NULL, 3027, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 12:48:18', 'admin-1474171822-14741740985628674', 1, 0, '', NULL, NULL, NULL),
(8429, '2016-09-18 12:55:11', NULL, NULL, 3028, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 12:55:11', 'admin-1474171822-14741745111961642', 1, 0, '', NULL, NULL, NULL),
(8430, '2016-09-18 12:55:18', NULL, NULL, 3028, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 12:55:18', 'admin-1474171822-14741745178719710', 1, 1, 'SR', NULL, NULL, NULL),
(8431, '2016-09-18 13:10:00', NULL, NULL, 3029, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:10:00', 'admin-1474171822-14741753999887774', 1, 1, 'SR', NULL, NULL, NULL),
(8432, '2016-09-18 13:10:00', NULL, NULL, 3029, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:10:00', 'admin-1474171822-14741753999887774', 1, 0, '', NULL, NULL, NULL),
(8433, '2016-09-18 13:10:00', NULL, NULL, 3029, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:10:00', 'admin-1474171822-14741753999887774', 1, 0, '', NULL, NULL, NULL),
(8434, '2016-09-18 13:11:06', NULL, NULL, 3029, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:11:06', 'admin-1474171822-14741754667013396', 1, 1, 'SR', NULL, NULL, NULL),
(8435, '2016-09-18 13:11:06', NULL, NULL, 3029, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:11:06', 'admin-1474171822-14741754667013396', 1, 1, 'SR', NULL, NULL, NULL),
(8436, '2016-09-18 13:11:06', NULL, NULL, 3029, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:11:06', 'admin-1474171822-14741754667013396', 1, 0, '', NULL, NULL, NULL),
(8437, '2016-09-18 13:13:55', NULL, NULL, 3030, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:13:55', 'admin-1474171822-14741756349023358', 1, 1, 'SR', NULL, NULL, NULL),
(8438, '2016-09-18 13:13:55', NULL, NULL, 3030, 0, 222, '156', 'Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:13:55', 'admin-1474171822-14741756349023358', 1, 0, '', NULL, NULL, NULL),
(8439, '2016-09-18 13:14:12', NULL, NULL, 3030, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:14:12', 'admin-1474171822-14741756524676544', 1, 1, 'SR', NULL, NULL, NULL),
(8440, '2016-09-18 13:14:40', NULL, NULL, 3030, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:14:40', 'admin-1474171822-14741756807399774', 1, 1, 'SR', NULL, NULL, NULL),
(8441, '2016-09-18 13:26:02', NULL, NULL, 3031, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:26:02', 'admin-1474171822-14741763627462427', 1, 0, '', NULL, NULL, NULL),
(8442, '2016-09-18 13:26:02', NULL, NULL, 3031, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:26:02', 'admin-1474171822-14741763627462427', 1, 0, '', NULL, NULL, NULL),
(8443, '2016-09-18 13:26:02', NULL, NULL, 3031, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:26:02', 'admin-1474171822-14741763627462427', 1, 1, 'SR', NULL, NULL, NULL),
(8444, '2016-09-18 13:26:02', NULL, NULL, 3031, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:26:02', 'admin-1474171822-14741763627462427', 1, 0, '', NULL, NULL, NULL),
(8445, '2016-09-18 19:27:35', NULL, NULL, 3051, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 19:27:35', 'admin-1474176495-14741980548227584', 1, 1, 'SR', NULL, NULL, '10.0'),
(8446, '2016-09-18 14:52:57', NULL, NULL, 3034, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 14:52:57', 'admin-1474176495-14741815773468074', 1, 0, '', NULL, NULL, NULL),
(8447, '2016-09-18 13:27:29', NULL, NULL, 3031, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:27:29', 'admin-1474171822-1474176449763681', 1, 0, '', NULL, NULL, NULL),
(8448, '2016-09-18 13:27:29', NULL, NULL, 3031, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:27:29', 'admin-1474171822-1474176449763681', 1, 1, 'SR', NULL, NULL, NULL),
(8449, '2016-09-18 13:29:00', NULL, NULL, 3033, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:29:00', 'admin-1474176495-14741765406849632', 1, 1, 'SR', NULL, NULL, NULL),
(8450, '2016-09-18 13:29:00', NULL, NULL, 3033, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:29:00', 'admin-1474176495-14741765406849632', 1, 1, 'SR', NULL, NULL, NULL),
(8451, '2016-09-18 13:34:02', NULL, NULL, 3034, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:34:02', 'admin-1474176495-1474176842537548', 1, 1, 'SR', NULL, NULL, NULL),
(8452, '2016-09-18 13:34:02', NULL, NULL, 3034, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:34:02', 'admin-1474176495-1474176842537548', 1, 1, 'SR', NULL, NULL, NULL),
(8453, '2016-09-18 13:45:14', NULL, NULL, 3035, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:45:14', 'admin-1474176495-1474177514632439', 1, 0, '', NULL, NULL, NULL),
(8454, '2016-09-18 13:45:14', NULL, NULL, 3035, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:45:14', 'admin-1474176495-1474177514632439', 1, 0, '', NULL, NULL, NULL),
(8455, '2016-09-18 13:45:56', NULL, NULL, 3035, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:45:56', 'admin-1474176495-14741775566854984', 1, 0, '', NULL, NULL, NULL),
(8456, '2016-09-18 13:45:56', NULL, NULL, 3035, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:45:56', 'admin-1474176495-14741775566854984', 1, 0, '', NULL, NULL, NULL),
(8457, '2016-09-18 11:51:55', NULL, NULL, 3020, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 11:51:55', 'admin-1474169438-14741707152055585', 1, 0, '', NULL, NULL, NULL),
(8458, '2016-09-18 11:51:55', NULL, NULL, 3020, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 11:51:55', 'admin-1474169438-14741707152055585', 1, 0, '', NULL, NULL, NULL),
(8459, '2016-09-18 11:51:55', NULL, NULL, 3020, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 11:51:55', 'admin-1474169438-14741707152055585', 1, 1, 'SR', NULL, NULL, NULL),
(8460, '2016-09-18 11:51:55', NULL, NULL, 3020, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 11:51:55', 'admin-1474169438-14741707152055585', 1, 1, 'SR', NULL, NULL, NULL),
(8461, '2016-09-18 11:57:46', NULL, NULL, 3021, 0, 181, '116', 'Open Food ', 'aglio olio bacon', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 11:57:46', 'admin-1474169438-14741710666033133', 1, 0, '', NULL, NULL, NULL),
(8462, '2016-09-18 12:02:53', NULL, NULL, 3022, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 12:02:53', 'admin-1474169438-14741713733861726', 1, 1, 'SR', NULL, NULL, NULL),
(8463, '2016-09-18 12:02:53', NULL, NULL, 3022, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 12:02:53', 'admin-1474169438-14741713733861726', 1, 1, 'SR', NULL, NULL, NULL),
(8464, '2016-09-18 12:03:14', NULL, NULL, 3023, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 12:03:14', 'admin-1474169438-14741713944229216', 1, 0, '', NULL, NULL, NULL),
(8465, '2016-09-18 19:27:35', NULL, NULL, 3051, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 19:27:35', 'admin-1474176495-14741980548227584', 1, 1, 'SR', NULL, NULL, '10.0'),
(8466, '2016-09-18 16:01:45', NULL, NULL, 3044, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 16:01:45', 'admin-1474176495-14741857057525414', 1, 1, 'SR', 1, NULL, NULL),
(8467, '2016-09-18 13:26:15', NULL, NULL, 3032, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:26:15', 'admin-1474171822-14741763757305945', 1, 0, '', NULL, NULL, NULL),
(8468, '2016-09-18 13:26:15', NULL, NULL, 3032, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:26:15', 'admin-1474171822-14741763757305945', 1, 1, 'SR', NULL, NULL, NULL),
(8469, '2016-09-18 13:26:02', NULL, NULL, 3031, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:26:02', 'admin-1474171822-14741763627462427', 1, 1, 'SR', NULL, NULL, NULL),
(8470, '2016-09-18 13:26:02', NULL, NULL, 3031, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 13:26:02', 'admin-1474171822-14741763627462427', 1, 1, 'SR', NULL, NULL, NULL),
(8471, '2016-09-18 12:03:29', NULL, NULL, 3023, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 12:03:29', 'admin-1474169438-1474171409452738', 1, 1, 'SR', NULL, NULL, NULL),
(8472, '2016-09-18 12:09:36', NULL, NULL, 3024, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 12:09:36', 'admin-1474169438-14741717767292621', 1, 1, 'SR', NULL, NULL, NULL),
(8473, '2016-09-18 12:09:36', NULL, NULL, 3024, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 12:09:36', 'admin-1474169438-14741717767292621', 1, 0, '', NULL, NULL, NULL),
(8474, '2016-09-18 12:37:21', NULL, NULL, 3026, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 12:37:21', 'admin-1474171822-14741734417554087', 1, 0, '', NULL, NULL, NULL),
(8475, '2016-09-18 12:03:14', NULL, NULL, 3023, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 12:03:14', 'admin-1474169438-14741713944229216', 1, 1, 'SR', NULL, NULL, NULL),
(8476, '2016-09-18 11:47:43', NULL, NULL, 3019, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 11:47:43', 'admin-1474169438-14741704627539334', 1, 1, 'SR', NULL, NULL, NULL),
(8477, '2016-09-18 10:45:11', NULL, NULL, 3015, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:45:11', 'admin-1474164620-14741667111124256', 1, 0, '', NULL, NULL, NULL),
(8478, '2016-09-18 10:45:11', NULL, NULL, 3015, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:45:11', 'admin-1474164620-14741667111124256', 1, 0, '', NULL, NULL, NULL),
(8479, '2016-09-18 10:52:33', NULL, NULL, 3016, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:52:33', 'admin-1474164620-14741671529565869', 1, 0, '', 1, NULL, NULL),
(8480, '2016-09-18 11:09:59', NULL, NULL, 3017, 0, 174, '109', 'Strawberry Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 11:09:59', 'admin-1474164620-14741681990313484', 1, 0, '', NULL, NULL, NULL),
(8481, '2016-09-18 11:09:59', NULL, NULL, 3017, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 11:09:59', 'admin-1474164620-14741681990313484', 1, 1, 'SR', NULL, NULL, NULL),
(8482, '2016-09-18 11:31:49', NULL, NULL, 3018, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 11:31:49', 'admin-1474169438-14741695094196218', 1, 0, '', NULL, NULL, NULL),
(8483, '2016-09-18 11:31:49', NULL, NULL, 3018, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 11:31:49', 'admin-1474169438-14741695094196218', 1, 0, '', NULL, NULL, NULL),
(8484, '2016-09-18 11:46:49', NULL, NULL, 3019, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 11:46:49', 'admin-1474169438-1474170409573298', 1, 0, '', NULL, NULL, NULL),
(8485, '2016-09-18 11:46:49', NULL, NULL, 3019, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 11:46:49', 'admin-1474169438-1474170409573298', 1, 0, '', NULL, NULL, NULL),
(8486, '2016-09-18 10:35:56', NULL, NULL, 3014, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:35:56', 'admin-1474164620-14741661558869994', 1, 1, 'SR', NULL, NULL, NULL),
(8487, '2016-09-18 10:29:46', NULL, NULL, 3013, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:29:46', 'admin-1474164620-14741657867583429', 1, 1, 'SR', NULL, NULL, NULL),
(8488, '2016-09-18 10:35:32', NULL, NULL, 3014, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:35:32', 'admin-1474164620-14741661321748979', 1, 0, '', NULL, NULL, NULL),
(8489, '2016-09-18 10:35:32', NULL, NULL, 3014, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:35:32', 'admin-1474164620-14741661321748979', 1, 0, '', NULL, NULL, NULL),
(8490, '2016-09-18 10:35:32', NULL, NULL, 3014, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:35:32', 'admin-1474164620-14741661321748979', 1, 0, '', NULL, NULL, NULL),
(8491, '2016-09-18 10:35:56', NULL, NULL, 3014, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:35:56', 'admin-1474164620-14741661558869994', 1, 1, 'SR', NULL, NULL, NULL),
(8492, '2016-09-18 10:35:56', NULL, NULL, 3014, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:35:56', 'admin-1474164620-14741661558869994', 1, 1, 'SR', NULL, NULL, NULL),
(8493, '2016-09-18 09:56:53', NULL, NULL, 3009, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 09:56:53', 'admin-1474160102-1474163813270844', 1, 0, '', NULL, NULL, NULL),
(8494, '2016-09-18 09:56:53', NULL, NULL, 3009, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 09:56:53', 'admin-1474160102-1474163813270844', 1, 0, '', NULL, NULL, NULL),
(8495, '2016-09-18 09:56:53', NULL, NULL, 3009, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 09:56:53', 'admin-1474160102-1474163813270844', 1, 0, '', NULL, NULL, NULL),
(8496, '2016-09-18 09:58:31', NULL, NULL, 3009, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 09:58:31', 'admin-1474160102-14741639117706476', 1, 1, 'SR', NULL, NULL, NULL),
(8497, '2016-09-18 09:58:31', NULL, NULL, 3009, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 09:58:31', 'admin-1474160102-14741639117706476', 1, 0, '', NULL, NULL, NULL),
(8498, '2016-09-18 10:09:02', NULL, NULL, 3010, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:09:02', 'admin-1474160102-14741645418102593', 1, 0, '', NULL, NULL, NULL),
(8499, '2016-09-18 10:09:47', NULL, NULL, 3010, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:09:47', 'admin-1474160102-1474164587699373', 1, 0, '', NULL, NULL, NULL),
(8500, '2016-09-18 10:09:47', NULL, NULL, 3010, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:09:47', 'admin-1474160102-1474164587699373', 1, 0, '', NULL, NULL, NULL),
(8501, '2016-09-18 10:10:31', NULL, NULL, 3010, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:10:31', 'admin-1474164620-1474164631733781', 1, 1, 'SR', NULL, NULL, NULL),
(8502, '2016-09-18 10:10:31', NULL, NULL, 3010, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:10:31', 'admin-1474164620-1474164631733781', 1, 1, 'SR', NULL, NULL, NULL),
(8503, '2016-09-18 10:22:58', NULL, NULL, 3011, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:22:58', 'admin-1474164620-14741653785522416', 1, 0, '', NULL, NULL, NULL),
(8504, '2016-09-18 11:49:05', NULL, NULL, 3019, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 11:49:05', 'admin-1474169438-14741705452888656', 1, 1, 'SR', NULL, NULL, NULL),
(8505, '2016-09-18 10:27:34', NULL, NULL, 3012, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:27:34', 'admin-1474164620-1474165653973757', 1, 1, 'SR', NULL, NULL, NULL),
(8506, '2016-09-18 10:27:34', NULL, NULL, 3012, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:27:34', 'admin-1474164620-1474165653973757', 1, 0, '', NULL, NULL, NULL),
(8507, '2016-09-18 10:26:18', NULL, NULL, 3011, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:26:18', 'admin-1474164620-14741655787832157', 1, 0, '', NULL, NULL, NULL),
(8508, '2016-09-18 10:26:18', NULL, NULL, 3011, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:26:18', 'admin-1474164620-14741655787832157', 1, 1, 'SR', NULL, NULL, NULL),
(8509, '2016-09-18 10:25:50', NULL, NULL, 3011, 0, 153, '87', 'Big Breakfast ', 'change to fried egg', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:25:50', 'admin-1474164620-1474165549971997', 1, 0, '', NULL, NULL, NULL),
(8510, '2016-09-18 10:25:50', NULL, NULL, 3011, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:25:50', 'admin-1474164620-1474165549971997', 1, 0, '', NULL, NULL, NULL),
(8511, '2016-09-18 10:23:18', NULL, NULL, 3011, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:23:18', 'admin-1474164620-1474165398685856', 1, 1, 'SR', NULL, NULL, NULL),
(8512, '2016-09-18 10:25:50', NULL, NULL, 3011, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 10:25:50', 'admin-1474164620-1474165549971997', 1, 1, 'SR', NULL, NULL, NULL),
(8513, '2016-09-18 09:47:54', NULL, NULL, 3008, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 09:47:54', 'admin-1474160102-1474163273948719', 1, 1, 'SR', NULL, NULL, NULL),
(8514, '2016-09-18 09:44:45', NULL, NULL, 3008, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 09:44:45', 'admin-1474160102-14741630850933375', 1, 0, '', NULL, NULL, NULL),
(8515, '2016-09-18 09:47:40', NULL, NULL, 3008, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 09:47:40', 'admin-1474160102-14741632599768146', 1, 1, 'SR', NULL, NULL, NULL),
(8516, '2016-09-18 09:44:01', NULL, NULL, 3008, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 09:44:01', 'admin-1474160102-14741630414543460', 1, 0, '', NULL, NULL, NULL),
(8517, '2016-09-18 09:47:40', NULL, NULL, 3008, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 09:47:40', 'admin-1474160102-14741632599768146', 1, 1, 'SR', NULL, NULL, NULL),
(8518, '2016-09-18 09:44:01', NULL, NULL, 3008, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 09:44:01', 'admin-1474160102-14741630414543460', 1, 0, '', NULL, NULL, NULL),
(8519, '2016-09-18 09:42:50', NULL, NULL, 3008, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474176495', 'admin', '2016-09-18 09:42:50', 'admin-1474160102-14741629699114014', 1, 0, '', NULL, NULL, NULL),
(8520, '2016-09-19 10:33:00', NULL, NULL, 3054, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 10:33:00', 'admin-1474246590-14742523801163964', 1, 0, '', NULL, NULL, NULL),
(8521, '2016-09-19 10:33:00', NULL, NULL, 3054, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 10:33:00', 'admin-1474246590-14742523801163964', 1, 0, '', NULL, NULL, NULL),
(8522, '2016-09-19 11:28:30', NULL, NULL, 3055, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 11:28:30', 'admin-1474246590-14742557105287526', 1, 0, '', 1, NULL, NULL),
(8523, '2016-09-19 11:29:38', NULL, NULL, 3055, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 11:29:38', 'admin-1474246590-14742557781878891', 1, 1, 'SR', 1, NULL, NULL),
(8524, '2016-09-19 11:35:41', NULL, NULL, 3056, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 11:35:41', 'admin-1474246590-14742561410331527', 1, 1, 'SR', NULL, NULL, NULL),
(8525, '2016-09-19 11:35:41', NULL, NULL, 3056, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 11:35:41', 'admin-1474246590-14742561410331527', 1, 0, '', NULL, NULL, NULL),
(8526, '2016-09-19 12:00:19', NULL, NULL, 3057, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 12:00:19', 'admin-1474246590-14742576193894359', 1, 1, 'SR', NULL, NULL, NULL),
(8527, '2016-09-19 12:05:38', NULL, NULL, 3058, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 12:05:38', 'admin-1474246590-1474257938016588', 1, 0, '', NULL, NULL, NULL),
(8528, '2016-09-19 12:06:15', NULL, NULL, 3058, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 12:06:15', 'admin-1474246590-14742579752429879', 1, 1, 'SR', NULL, NULL, NULL),
(8529, '2016-09-19 12:07:10', NULL, NULL, 3059, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 12:07:10', 'admin-1474246590-14742580306571533', 1, 0, '', NULL, NULL, NULL),
(8530, '2016-09-19 12:51:34', NULL, NULL, 3060, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 12:51:34', 'admin-1474246590-14742606942335723', 1, 1, 'SR', NULL, NULL, NULL),
(8531, '2016-09-19 13:10:00', NULL, NULL, 3061, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 13:10:00', 'admin-1474246590-14742618006176130', 1, 1, 'SR', 1, NULL, NULL),
(8532, '2016-09-19 13:10:18', NULL, NULL, 3061, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 13:10:18', 'admin-1474246590-1474261818624954', 1, 1, 'SR', 1, NULL, NULL),
(8533, '2016-09-19 13:34:15', NULL, NULL, 3062, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 13:34:15', 'admin-1474246590-14742632553923383', 1, 0, '', NULL, NULL, NULL),
(8534, '2016-09-19 13:34:21', NULL, NULL, 3062, 0, 222, '156', 'Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 13:34:21', 'admin-1474246590-14742632615209961', 1, 0, '', NULL, NULL, NULL),
(8535, '2016-09-19 13:35:43', NULL, NULL, 3062, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 13:35:43', 'admin-1474246590-1474263343361669', 1, 1, 'SR', NULL, NULL, NULL),
(8536, '2016-09-19 15:23:03', NULL, NULL, 3060, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 15:23:03', 'admin-1474246590-14742697824676340', 1, 1, 'SR', NULL, NULL, NULL),
(8537, '2016-09-19 14:38:07', NULL, NULL, 3065, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 14:38:07', 'admin-1474246590-1474267087116595', 1, 1, 'SR', NULL, NULL, NULL),
(8538, '2016-09-19 14:38:07', NULL, NULL, 3065, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 14:38:07', 'admin-1474246590-1474267087116595', 1, 1, 'SR', NULL, NULL, NULL),
(8539, '2016-09-19 14:28:16', NULL, NULL, 3063, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 14:28:16', 'admin-1474246590-14742664965706634', 1, 1, 'SR', NULL, NULL, NULL),
(8540, '2016-09-19 14:31:41', NULL, NULL, 3064, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 14:31:41', 'admin-1474246590-14742667017933761', 1, 1, 'SR', NULL, NULL, NULL),
(8541, '2016-09-19 13:47:12', NULL, NULL, 3062, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 13:47:12', 'admin-1474246590-14742640327002243', 1, 1, 'SR', NULL, NULL, NULL),
(8542, '2016-09-19 13:51:36', NULL, NULL, 3060, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 13:51:36', 'admin-1474246590-14742642964304871', 1, 1, 'SR', NULL, NULL, NULL),
(8543, '2016-09-19 14:28:16', NULL, NULL, 3063, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 14:28:16', 'admin-1474246590-14742664965706634', 1, 1, 'SR', NULL, NULL, NULL),
(8544, '2016-09-19 10:23:02', NULL, NULL, 3053, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 10:23:02', 'admin-1474246590-14742517827784376', 1, 0, '', NULL, NULL, NULL),
(8545, '2016-09-19 11:28:30', NULL, NULL, 3055, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 11:28:30', 'admin-1474246590-14742557105287526', 1, 1, 'SR', 1, NULL, NULL),
(8546, '2016-09-19 10:23:02', NULL, NULL, 3053, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 10:23:03', 'admin-1474246590-14742517827784376', 1, 1, 'SR', NULL, NULL, NULL),
(8547, '2016-09-19 10:23:02', NULL, NULL, 3053, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 10:23:02', 'admin-1474246590-14742517827784376', 1, 0, '', NULL, NULL, NULL),
(8548, '2016-09-19 09:48:49', NULL, NULL, 3052, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 09:48:49', 'admin-1474246590-14742497291638146', 1, 1, 'SR', 1, NULL, NULL),
(8549, '2016-09-19 10:23:02', NULL, NULL, 3053, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 10:23:02', 'admin-1474246590-14742517827784376', 1, 1, 'SR', NULL, NULL, NULL),
(8550, '2016-09-19 09:48:49', NULL, NULL, 3052, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474246590', 'admin', '2016-09-19 09:48:49', 'admin-1474246590-14742497291638146', 1, 1, 'SR', 1, NULL, NULL),
(8551, '2016-09-21 18:57:52', NULL, NULL, 3077, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 18:57:52', 'admin-1474439477-14744554725688564', 1, 0, '', NULL, NULL, NULL),
(8552, '2016-09-21 00:00:00', NULL, NULL, 3083, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 20:41:57', 'admin-1474439477-1474461717468181', 1, 1, 'SR', NULL, NULL, NULL),
(8553, '2016-09-21 00:00:00', NULL, NULL, 3085, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 18:51:23', 'admin-1474439477-14744550832941278', 1, 0, '', NULL, NULL, NULL),
(8554, '2016-09-21 00:00:00', NULL, NULL, 3084, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 18:51:23', 'admin-1474439477-14744550832941278', 1, 0, '', NULL, NULL, NULL),
(8555, '2016-09-21 19:15:34', NULL, NULL, 3079, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 19:15:34', 'admin-1474439477-14744565346689025', 1, 1, 'SR', NULL, NULL, NULL),
(8556, '2016-09-21 00:00:00', NULL, NULL, 3085, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 19:02:33', 'admin-1474439477-14744557532291314', 1, 1, 'SR', NULL, NULL, NULL),
(8557, '2016-09-21 19:40:18', NULL, NULL, 3080, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 19:40:18', 'admin-1474439477-14744580182708412', 1, 1, 'SR', NULL, NULL, NULL),
(8558, '2016-09-21 19:40:18', NULL, NULL, 3080, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 19:40:18', 'admin-1474439477-14744580182708412', 1, 0, '', NULL, NULL, NULL),
(8559, '2016-09-21 00:00:00', NULL, NULL, 3082, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 18:59:23', 'admin-1474439477-14744555629701367', 1, 1, 'SR', NULL, NULL, NULL),
(8560, '2016-09-21 00:00:00', NULL, NULL, 3082, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 20:42:22', 'admin-1474439477-14744617421792669', 1, 0, '', NULL, NULL, NULL),
(8561, '2016-09-21 00:00:00', NULL, NULL, 3084, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 19:02:33', 'admin-1474439477-14744557532291314', 1, 1, 'SR', NULL, NULL, NULL),
(8562, '2016-09-21 12:21:42', NULL, NULL, 3070, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 12:21:42', 'admin-1474419959-14744317025457324', 1, 0, '', NULL, NULL, NULL),
(8563, '2016-09-21 12:21:59', NULL, NULL, 3070, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 12:21:59', 'admin-1474419959-14744317190102774', 1, 0, '', NULL, NULL, NULL),
(8564, '2016-09-21 12:21:59', NULL, NULL, 3070, 0, 214, '148', 'Set Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 12:21:59', 'admin-1474419959-14744317190102774', 1, 0, '', NULL, NULL, NULL),
(8565, '2016-09-21 13:00:50', NULL, NULL, 3071, 0, 83, '83', 'Set Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 13:00:50', 'admin-1474419959-14744340502849367', 1, 1, 'SR', NULL, NULL, NULL),
(8566, '2016-09-21 13:15:37', NULL, NULL, 3071, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 13:15:37', 'admin-1474419959-1474434937460831', 1, 0, '', NULL, NULL, NULL),
(8567, '2016-09-21 20:00:15', NULL, NULL, 3081, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 20:00:15', 'admin-1474439477-14744592152706812', 1, 0, '', NULL, NULL, NULL),
(8568, '2016-09-21 20:00:15', NULL, NULL, 3081, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 20:00:15', 'admin-1474439477-14744592152706812', 1, 0, '', NULL, NULL, NULL),
(8569, '2016-09-21 18:57:32', NULL, NULL, 3077, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 18:57:32', 'admin-1474439477-14744554518943919', 1, 0, '', NULL, NULL, NULL),
(8570, '2016-09-21 14:43:57', NULL, NULL, 3073, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 14:43:57', 'admin-1474439477-14744402372884596', 1, 0, '', NULL, NULL, NULL),
(8571, '2016-09-21 14:44:52', NULL, NULL, 3073, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 14:44:52', 'admin-1474439477-14744402923989717', 1, 0, '', NULL, NULL, NULL),
(8572, '2016-09-21 14:56:45', NULL, NULL, 3074, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 14:56:45', 'admin-1474439477-14744410056799292', 1, 1, 'SR', NULL, NULL, NULL),
(8573, '2016-09-21 15:19:13', NULL, NULL, 3075, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 15:19:13', 'admin-1474439477-14744423536696969', 1, 0, '', NULL, NULL, NULL),
(8574, '2016-09-21 15:19:13', NULL, NULL, 3075, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 15:19:13', 'admin-1474439477-14744423536696969', 1, 1, 'SR', NULL, NULL, NULL),
(8575, '2016-09-21 15:55:08', NULL, NULL, 3076, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 15:55:08', 'admin-1474439477-14744445081375421', 1, 0, '', NULL, NULL, NULL),
(8576, '2016-09-21 15:55:14', NULL, NULL, 3076, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 15:55:14', 'admin-1474439477-14744445140357389', 1, 1, 'SR', NULL, NULL, NULL),
(8577, '2016-09-21 15:55:14', NULL, NULL, 3076, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 15:55:14', 'admin-1474439477-14744445140357389', 1, 1, 'SR', NULL, NULL, NULL),
(8578, '2016-09-21 18:48:30', NULL, NULL, 3077, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 18:48:30', 'admin-1474439477-14744549106482425', 1, 1, 'SR', NULL, NULL, NULL),
(8579, '2016-09-21 18:48:30', NULL, NULL, 3077, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 18:48:30', 'admin-1474439477-14744549106482425', 1, 1, 'SR', NULL, NULL, NULL),
(8580, '2016-09-21 18:48:30', NULL, NULL, 3077, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 18:48:30', 'admin-1474439477-14744549106482425', 1, 1, 'SR', NULL, NULL, NULL),
(8581, '2016-09-21 00:00:00', NULL, NULL, 3084, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 19:35:54', 'admin-1474439477-14744577546874820', 1, 1, 'SR', NULL, NULL, NULL),
(8582, '2016-09-21 18:57:32', NULL, NULL, 3077, 0, 211, '145', 'Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 18:57:32', 'admin-1474439477-14744554518943919', 1, 0, '', NULL, NULL, NULL),
(8583, '2016-09-21 18:57:32', NULL, NULL, 3077, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 18:57:32', 'admin-1474439477-14744554518943919', 1, 1, 'SR', NULL, NULL, NULL),
(8584, '2016-09-21 18:57:32', NULL, NULL, 3077, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 18:57:32', 'admin-1474439477-14744554518943919', 1, 1, 'SR', NULL, NULL, NULL),
(8585, '2016-09-21 19:40:18', NULL, NULL, 3080, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 19:40:18', 'admin-1474439477-14744580182708412', 1, 1, 'SR', NULL, NULL, NULL),
(8586, '2016-09-21 18:57:32', NULL, NULL, 3077, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 18:57:32', 'admin-1474439477-14744554518943919', 1, 1, 'SR', NULL, NULL, NULL),
(8587, '2016-09-21 18:57:32', NULL, NULL, 3077, 0, 76, '76', 'Sauted Mushroom Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 18:57:32', 'admin-1474439477-14744554518943919', 1, 1, 'SR', NULL, NULL, NULL),
(8588, '2016-09-21 18:57:32', NULL, NULL, 3077, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 18:57:32', 'admin-1474439477-14744554518943919', 1, 0, '', NULL, NULL, NULL),
(8589, '2016-09-21 13:56:07', NULL, NULL, 3071, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 13:56:07', 'admin-1474419959-1474437367756395', 1, 0, '', NULL, NULL, NULL),
(8590, '2016-09-21 13:56:17', NULL, NULL, 3071, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 13:56:17', 'admin-1474419959-14744373773371356', 1, 1, 'SR', NULL, NULL, NULL),
(8591, '2016-09-21 14:04:39', NULL, NULL, 3073, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 14:04:39', 'admin-1474419959-14744378791243471', 1, 1, 'SR', NULL, NULL, NULL),
(8592, '2016-09-21 14:15:01', NULL, NULL, 3074, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 14:15:01', 'admin-1474419959-14744385014624952', 1, 0, '', NULL, NULL, NULL),
(8593, '2016-09-21 14:43:57', NULL, NULL, 3073, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 14:43:57', 'admin-1474439477-14744402372884596', 1, 1, 'SR', NULL, NULL, NULL),
(8594, '2016-09-21 13:53:27', NULL, NULL, 3072, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 13:53:27', 'admin-1474419959-14744372076428199', 1, 1, 'SR', NULL, NULL, NULL),
(8595, '2016-09-21 13:16:05', NULL, NULL, 3071, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 13:16:05', 'admin-1474419959-14744349652479394', 1, 0, '', NULL, NULL, NULL),
(8596, '2016-09-21 09:24:03', NULL, NULL, 3067, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 09:24:03', 'admin-1474419959-14744210431236680', 1, 1, 'SR', NULL, NULL, NULL),
(8597, '2016-09-21 11:22:57', NULL, NULL, 3069, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 11:22:57', 'admin-1474419959-1474428177302332', 1, 1, 'SR', 1, NULL, NULL),
(8598, '2016-09-21 11:22:57', NULL, NULL, 3069, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 11:22:57', 'admin-1474419959-1474428177302332', 1, 1, 'SR', 1, NULL, NULL),
(8599, '2016-09-21 09:18:50', NULL, NULL, 3066, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474462385', 'admin', '2016-09-21 09:18:50', 'admin-1474419959-14744207307312319', 1, 1, 'SR', 1, NULL, NULL),
(8600, '2016-09-22 20:45:41', NULL, NULL, 3110, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 20:45:41', 'admin-1474519858-14745483412514065', 1, 1, 'SR', 1, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(8601, '2016-09-22 19:16:38', NULL, NULL, 3109, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 19:16:38', 'admin-1474519858-14745429982194074', 1, 0, '', NULL, NULL, NULL),
(8602, '2016-09-22 19:16:38', NULL, NULL, 3109, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 19:16:38', 'admin-1474519858-14745429982194074', 1, 0, '', NULL, NULL, NULL),
(8603, '2016-09-22 19:16:38', NULL, NULL, 3109, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 19:16:38', 'admin-1474519858-14745429982194074', 1, 0, '', NULL, NULL, NULL),
(8604, '2016-09-22 15:15:32', NULL, NULL, 3099, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 15:15:32', 'admin-1474519858-1474528532735241', 1, 1, 'SR', NULL, NULL, NULL),
(8605, '2016-09-22 15:15:32', NULL, NULL, 3099, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 15:15:32', 'admin-1474519858-1474528532735241', 1, 0, '', NULL, NULL, NULL),
(8606, '2016-09-22 15:21:45', NULL, NULL, 3100, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 15:21:45', 'admin-1474519858-14745289049043546', 1, 1, 'SR', 1, NULL, NULL),
(8607, '2016-09-22 15:24:31', NULL, NULL, 3101, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 15:24:31', 'admin-1474519858-14745290711264434', 1, 1, 'SR', NULL, NULL, NULL),
(8608, '2016-09-22 15:36:33', NULL, NULL, 3102, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 15:36:33', 'admin-1474519858-1474529793491305', 1, 1, 'SR', NULL, NULL, NULL),
(8609, '2016-09-22 15:36:33', NULL, NULL, 3102, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 15:36:33', 'admin-1474519858-1474529793491305', 1, 1, 'SR', NULL, NULL, NULL),
(8610, '2016-09-22 16:20:52', NULL, NULL, 3103, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 16:20:52', 'admin-1474519858-14745324518399970', 1, 1, 'SR', NULL, NULL, NULL),
(8611, '2016-09-22 16:36:50', NULL, NULL, 3104, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 16:36:50', 'admin-1474519858-14745334101634981', 1, 1, 'SR', NULL, NULL, NULL),
(8612, '2016-09-22 16:36:50', NULL, NULL, 3104, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 16:36:50', 'admin-1474519858-14745334101634981', 1, 0, '', NULL, NULL, NULL),
(8613, '2016-09-22 16:37:27', NULL, NULL, 3105, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 16:37:27', 'admin-1474519858-14745334472091775', 1, 0, '', 1, NULL, NULL),
(8614, '2016-09-22 16:37:27', NULL, NULL, 3105, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 16:37:27', 'admin-1474519858-14745334472091775', 1, 1, 'SR', 1, NULL, NULL),
(8615, '2016-09-22 18:23:08', NULL, NULL, 3108, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 18:23:08', 'admin-1474519858-14745397878631385', 1, 0, '', NULL, NULL, NULL),
(8616, '2016-09-22 17:19:56', NULL, NULL, 3106, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 17:19:56', 'admin-1474519858-14745359963571512', 1, 1, 'SR', NULL, NULL, NULL),
(8617, '2016-09-22 17:19:56', NULL, NULL, 3106, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 17:19:56', 'admin-1474519858-14745359963571512', 1, 0, '', NULL, NULL, NULL),
(8618, '2016-09-22 17:27:24', NULL, NULL, 3101, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 17:27:24', 'admin-1474519858-1474536444659677', 1, 0, '', NULL, NULL, NULL),
(8619, '2016-09-22 17:27:30', NULL, NULL, 3101, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 17:27:30', 'admin-1474519858-14745364506083463', 1, 1, 'SR', NULL, NULL, NULL),
(8620, '2016-09-22 17:28:32', NULL, NULL, 3107, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 17:28:32', 'admin-1474519858-14745365123097193', 1, 1, 'SR', NULL, NULL, NULL),
(8621, '2016-09-22 17:28:32', NULL, NULL, 3107, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 17:28:32', 'admin-1474519858-14745365123097193', 1, 1, 'SR', NULL, NULL, NULL),
(8622, '2016-09-22 18:23:48', NULL, NULL, 3108, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 18:23:48', 'admin-1474519858-14745398283442089', 1, 1, 'SR', NULL, NULL, NULL),
(8623, '2016-09-22 19:23:19', NULL, NULL, 3109, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 19:23:19', 'admin-1474519858-14745433993612045', 1, 1, 'SR', NULL, NULL, NULL),
(8624, '2016-09-22 19:16:38', NULL, NULL, 3109, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 19:16:38', 'admin-1474519858-14745429982194074', 1, 1, 'SR', NULL, NULL, NULL),
(8625, '2016-09-22 19:16:38', NULL, NULL, 3109, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 19:16:38', 'admin-1474519858-14745429982194074', 1, 1, 'SR', NULL, NULL, NULL),
(8626, '2016-09-22 19:16:38', NULL, NULL, 3109, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 19:16:38', 'admin-1474519858-14745429982194074', 1, 1, 'SR', NULL, NULL, NULL),
(8627, '2016-09-22 19:16:38', NULL, NULL, 3109, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 19:16:38', 'admin-1474519858-14745429982194074', 1, 1, 'SR', NULL, NULL, NULL),
(8628, '2016-09-22 19:23:08', NULL, NULL, 3109, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 19:23:08', 'admin-1474519858-14745433885757739', 1, 1, 'SR', NULL, NULL, NULL),
(8629, '2016-09-22 13:35:00', NULL, NULL, 3095, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 13:35:00', 'admin-1474519858-14745224999937077', 1, 1, 'SR', 1, NULL, NULL),
(8630, '2016-09-22 12:50:11', NULL, NULL, 3090, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 12:50:11', 'admin-1474506276-14745198109794967', 1, 0, '', NULL, NULL, NULL),
(8631, '2016-09-22 12:50:11', NULL, NULL, 3090, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 12:50:11', 'admin-1474506276-14745198109794967', 1, 0, '', NULL, NULL, NULL),
(8632, '2016-09-22 12:50:11', NULL, NULL, 3090, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 12:50:11', 'admin-1474506276-14745198109794967', 1, 0, '', NULL, NULL, NULL),
(8633, '2016-09-22 12:54:07', NULL, NULL, 3093, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 12:54:07', 'admin-1474519858-14745200470752684', 1, 1, 'SR', NULL, NULL, NULL),
(8634, '2016-09-22 12:54:07', NULL, NULL, 3093, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 12:54:07', 'admin-1474519858-14745200470752684', 1, 1, 'SR', NULL, NULL, NULL),
(8635, '2016-09-22 12:54:07', NULL, NULL, 3093, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 12:54:07', 'admin-1474519858-14745200470752684', 1, 1, 'SR', NULL, NULL, NULL),
(8636, '2016-09-22 12:54:07', NULL, NULL, 3093, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 12:54:07', 'admin-1474519858-14745200470752684', 1, 0, '', NULL, NULL, NULL),
(8637, '2016-09-22 19:23:19', NULL, NULL, 3109, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 19:23:19', 'admin-1474519858-14745433993612045', 1, 1, 'SR', NULL, NULL, NULL),
(8638, '2016-09-22 19:23:08', NULL, NULL, 3109, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 19:23:08', 'admin-1474519858-14745433885757739', 1, 0, '', NULL, NULL, NULL),
(8639, '2016-09-22 19:16:38', NULL, NULL, 3109, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 19:16:38', 'admin-1474519858-14745429982194074', 1, 1, 'SR', NULL, NULL, NULL),
(8640, '2016-09-22 19:16:38', NULL, NULL, 3109, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 19:16:38', 'admin-1474519858-14745429982194074', 1, 0, '', NULL, NULL, NULL),
(8641, '2016-09-22 19:16:38', NULL, NULL, 3109, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 19:16:38', 'admin-1474519858-14745429982194074', 1, 1, 'SR', NULL, NULL, NULL),
(8642, '2016-09-22 19:16:38', NULL, NULL, 3109, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 19:16:38', 'admin-1474519858-14745429982194074', 1, 0, '', NULL, NULL, NULL),
(8643, '2016-09-22 13:57:37', NULL, NULL, 3098, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 13:57:37', 'admin-1474519858-14745238567932038', 1, 0, '', NULL, NULL, NULL),
(8644, '2016-09-22 13:48:25', NULL, NULL, 3097, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 13:48:25', 'admin-1474519858-14745233055144086', 1, 0, '', NULL, NULL, NULL),
(8645, '2016-09-22 13:37:45', NULL, NULL, 3090, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 13:37:45', 'admin-1474519858-1474522665234442', 1, 0, '', NULL, NULL, NULL),
(8646, '2016-09-22 13:41:36', NULL, NULL, 3096, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 13:41:36', 'admin-1474519858-14745228966909349', 1, 1, 'SR', NULL, NULL, NULL),
(8647, '2016-09-22 13:41:36', NULL, NULL, 3096, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 13:41:36', 'admin-1474519858-14745228966909349', 1, 1, 'SR', NULL, NULL, NULL),
(8648, '2016-09-22 13:37:45', NULL, NULL, 3090, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 13:37:45', 'admin-1474519858-1474522665234442', 1, 0, '', NULL, NULL, NULL),
(8649, '2016-09-22 13:37:31', NULL, NULL, 3090, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 13:37:31', 'admin-1474519858-14745226508916637', 1, 1, 'SR', NULL, NULL, NULL),
(8650, '2016-09-22 13:37:31', NULL, NULL, 3090, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 13:37:31', 'admin-1474519858-14745226508916637', 1, 1, 'SR', NULL, NULL, NULL),
(8651, '2016-09-22 13:37:31', NULL, NULL, 3090, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 13:37:31', 'admin-1474519858-14745226508916637', 1, 1, 'SR', NULL, NULL, NULL),
(8652, '2016-09-22 13:35:00', NULL, NULL, 3095, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 13:35:00', 'admin-1474519858-14745224999937077', 1, 1, 'SR', 1, NULL, NULL),
(8653, '2016-09-22 13:37:23', NULL, NULL, 3090, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 13:37:23', 'admin-1474519858-14745226436461927', 1, 0, '', NULL, NULL, NULL),
(8654, '2016-09-22 13:25:39', NULL, NULL, 3094, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 13:25:39', 'admin-1474519858-14745219394135595', 1, 0, '', NULL, NULL, NULL),
(8655, '2016-09-22 13:26:45', NULL, NULL, 3094, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 13:26:45', 'admin-1474519858-14745220048736044', 1, 1, 'SR', NULL, NULL, NULL),
(8656, '2016-09-22 11:34:27', NULL, NULL, 3088, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 11:34:27', 'admin-1474506276-14745152672745156', 1, 0, '', NULL, NULL, NULL),
(8657, '2016-09-22 11:34:27', NULL, NULL, 3088, 0, 76, '76', 'Sauted Mushroom Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 11:34:27', 'admin-1474506276-14745152672745156', 1, 1, 'SR', NULL, NULL, NULL),
(8658, '2016-09-22 11:40:46', NULL, NULL, 3089, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 11:40:46', 'admin-1474506276-14745156460614143', 1, 0, '', NULL, NULL, NULL),
(8659, '2016-09-22 11:40:46', NULL, NULL, 3089, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 11:40:46', 'admin-1474506276-14745156460614143', 1, 1, 'SR', NULL, NULL, NULL),
(8660, '2016-09-22 11:40:46', NULL, NULL, 3089, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 11:40:46', 'admin-1474506276-14745156460614143', 1, 1, 'SR', NULL, NULL, NULL),
(8661, '2016-09-22 11:49:41', NULL, NULL, 3090, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 11:49:41', 'admin-1474506276-14745161812626068', 1, 1, 'SR', NULL, NULL, NULL),
(8662, '2016-09-22 11:49:41', NULL, NULL, 3090, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 11:49:41', 'admin-1474506276-14745161812626068', 1, 1, 'SR', NULL, NULL, NULL),
(8663, '2016-09-22 13:25:21', NULL, NULL, 3094, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 13:25:21', 'admin-1474519858-14745219210018944', 1, 0, '', NULL, NULL, NULL),
(8664, '2016-09-22 12:01:20', NULL, NULL, 3091, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 12:01:20', 'admin-1474506276-14745168804717177', 1, 0, '', NULL, NULL, NULL),
(8665, '2016-09-22 12:01:20', NULL, NULL, 3091, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 12:01:20', 'admin-1474506276-14745168804717177', 1, 1, 'SR', NULL, NULL, NULL),
(8666, '2016-09-22 12:03:27', NULL, NULL, 3092, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 12:03:27', 'admin-1474506276-14745170076764941', 1, 0, '', NULL, NULL, NULL),
(8667, '2016-09-22 12:03:27', NULL, NULL, 3092, 0, 76, '76', 'Sauted Mushroom Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 12:03:27', 'admin-1474506276-14745170076764941', 1, 1, 'SR', NULL, NULL, NULL),
(8668, '2016-09-22 12:03:27', NULL, NULL, 3092, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 12:03:27', 'admin-1474506276-14745170076764941', 1, 0, '', NULL, NULL, NULL),
(8669, '2016-09-22 12:03:27', NULL, NULL, 3092, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 12:03:27', 'admin-1474506276-14745170076764941', 1, 1, 'SR', NULL, NULL, NULL),
(8670, '2016-09-22 12:03:27', NULL, NULL, 3092, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 12:03:27', 'admin-1474506276-14745170076764941', 1, 1, 'SR', NULL, NULL, NULL),
(8671, '2016-09-22 12:50:11', NULL, NULL, 3090, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 12:50:11', 'admin-1474506276-14745198109794967', 1, 1, 'SR', NULL, NULL, NULL),
(8672, '2016-09-22 13:27:11', NULL, NULL, 3094, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 13:27:11', 'admin-1474519858-1474522031605857', 1, 1, 'SR', NULL, NULL, NULL),
(8673, '2016-09-22 13:25:21', NULL, NULL, 3094, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 13:25:21', 'admin-1474519858-14745219210018944', 1, 0, '', NULL, NULL, NULL),
(8674, '2016-09-22 13:25:21', NULL, NULL, 3094, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 13:25:21', 'admin-1474519858-14745219210018944', 1, 0, '', NULL, NULL, NULL),
(8675, '2016-09-22 12:54:07', NULL, NULL, 3093, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 12:54:07', 'admin-1474519858-14745200470752684', 1, 1, 'SR', NULL, NULL, NULL),
(8676, '2016-09-22 10:24:07', NULL, NULL, 3087, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 10:24:07', 'admin-1474506276-14745110477434965', 1, 0, '', NULL, NULL, NULL),
(8677, '2016-09-22 11:33:23', NULL, NULL, 3088, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 11:33:23', 'admin-1474506276-14745152030273686', 1, 1, 'SR', NULL, NULL, NULL),
(8678, '2016-09-22 11:33:23', NULL, NULL, 3088, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 11:33:23', 'admin-1474506276-14745152030273686', 1, 1, 'SR', NULL, NULL, NULL),
(8679, '2016-09-22 11:34:27', NULL, NULL, 3088, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 11:34:27', 'admin-1474506276-14745152672745156', 1, 1, 'SR', NULL, NULL, NULL),
(8680, '2016-09-22 11:34:27', NULL, NULL, 3088, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 11:34:27', 'admin-1474506276-14745152672745156', 1, 1, 'SR', NULL, NULL, NULL),
(8681, '2016-09-22 12:50:11', NULL, NULL, 3090, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 12:50:11', 'admin-1474506276-14745198109794967', 1, 1, 'SR', NULL, NULL, NULL),
(8682, '2016-09-22 10:23:32', NULL, NULL, 3087, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 10:23:32', 'admin-1474506276-14745110121588386', 1, 0, '', NULL, NULL, NULL),
(8683, '2016-09-22 10:23:56', NULL, NULL, 3087, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 10:23:56', 'admin-1474506276-14745110359808084', 1, 0, '', NULL, NULL, NULL),
(8684, '2016-09-22 10:23:16', NULL, NULL, 3087, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 10:23:16', 'admin-1474506276-14745109962117212', 1, 0, '', NULL, NULL, NULL),
(8685, '2016-09-22 10:23:16', NULL, NULL, 3087, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 10:23:16', 'admin-1474506276-14745109962117212', 1, 0, '', NULL, NULL, NULL),
(8686, '2016-09-22 10:23:32', NULL, NULL, 3087, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 10:23:32', 'admin-1474506276-14745110121588386', 1, 0, '', NULL, NULL, NULL),
(8687, '2016-09-22 09:45:13', NULL, NULL, 3086, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474519858', 'admin', '2016-09-22 09:45:13', 'admin-1474506276-14745087132495916', 1, 1, 'SR', 1, NULL, NULL),
(8688, '2016-09-23 14:53:07', NULL, NULL, 3132, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 14:53:07', 'admin-1474592419-14746135875655173', 1, 1, 'SR', NULL, NULL, NULL),
(8689, '2016-09-23 15:10:53', NULL, NULL, 3133, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 15:10:53', 'admin-1474592419-14746146532836571', 1, 1, 'SR', NULL, NULL, NULL),
(8690, '2016-09-23 15:29:30', NULL, NULL, 3134, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 15:29:30', 'admin-1474592419-14746157706508735', 1, 1, 'SR', NULL, NULL, NULL),
(8691, '2016-09-23 15:29:30', NULL, NULL, 3134, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 15:29:30', 'admin-1474592419-14746157706508735', 1, 1, 'SR', NULL, NULL, NULL),
(8692, '2016-09-23 15:41:02', NULL, NULL, 3136, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 15:41:02', 'admin-1474592419-14746164622104968', 1, 0, '', NULL, NULL, NULL),
(8693, '2016-09-23 15:42:04', NULL, NULL, 3135, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 15:42:04', 'admin-1474592419-14746165238657552', 1, 1, 'SR', NULL, NULL, NULL),
(8694, '2016-09-23 15:42:04', NULL, NULL, 3135, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 15:42:04', 'admin-1474592419-14746165238657552', 1, 1, 'SR', NULL, NULL, NULL),
(8695, '2016-09-23 15:42:04', NULL, NULL, 3135, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 15:42:04', 'admin-1474592419-14746165238657552', 1, 0, '', NULL, NULL, NULL),
(8696, '2016-09-23 15:42:04', NULL, NULL, 3135, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 15:42:04', 'admin-1474592419-14746165238657552', 1, 0, '', NULL, NULL, NULL),
(8697, '2016-09-23 15:42:04', NULL, NULL, 3135, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 15:42:04', 'admin-1474592419-14746165238657552', 1, 1, 'SR', NULL, NULL, NULL),
(8698, '2016-09-23 17:18:49', NULL, NULL, 3133, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 17:18:49', 'admin-1474592419-14746223296557975', 1, 1, 'SR', NULL, NULL, NULL),
(8699, '2016-09-23 19:03:04', NULL, NULL, 3137, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 19:03:04', 'admin-1474592419-14746285845857940', 1, 1, 'SR', NULL, NULL, NULL),
(8700, '2016-09-23 19:03:10', NULL, NULL, 3138, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 19:03:10', 'admin-1474592419-14746285906131037', 1, 1, 'SR', 1, NULL, NULL),
(8701, '2016-09-23 19:06:32', NULL, NULL, 3139, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 19:06:32', 'admin-1474592419-14746287926595768', 1, 0, '', NULL, NULL, NULL),
(8702, '2016-09-23 19:36:36', NULL, NULL, 3140, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 19:36:36', 'admin-1474592419-14746305962862151', 1, 1, 'SR', NULL, NULL, NULL),
(8703, '2016-09-23 19:36:36', NULL, NULL, 3140, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 19:36:36', 'admin-1474592419-14746305962862151', 1, 1, 'SR', NULL, NULL, NULL),
(8704, '2016-09-23 19:36:36', NULL, NULL, 3140, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 19:36:36', 'admin-1474592419-14746305962862151', 1, 0, '', NULL, NULL, NULL),
(8705, '2016-09-23 19:36:48', NULL, NULL, 3140, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 19:36:48', 'admin-1474592419-14746306082237519', 1, 0, '', NULL, NULL, NULL),
(8706, '2016-09-23 14:52:41', NULL, NULL, 3131, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 14:52:41', 'admin-1474592419-14746135615725753', 1, 1, 'SR', NULL, NULL, NULL),
(8707, '2016-09-23 00:00:00', NULL, NULL, 3113, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 10:30:36', 'admin-1474592419-14745978358734534', 1, 0, '', NULL, NULL, NULL),
(8708, '2016-09-23 10:32:01', NULL, NULL, 3112, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 10:32:01', 'admin-1474592419-14745979213713241', 1, 0, '', NULL, NULL, NULL),
(8709, '2016-09-23 00:00:00', NULL, NULL, 3114, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 10:30:36', 'admin-1474592419-14745978358734534', 1, 0, '', NULL, NULL, NULL),
(8710, '2016-09-23 00:00:00', NULL, NULL, 3113, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 10:30:36', 'admin-1474592419-14745978358734534', 1, 1, 'SR', NULL, NULL, NULL),
(8711, '2016-09-23 10:54:50', NULL, NULL, 3115, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 10:54:50', 'admin-1474592419-14745992900276518', 1, 0, '', NULL, NULL, NULL),
(8712, '2016-09-23 10:54:50', NULL, NULL, 3115, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 10:54:50', 'admin-1474592419-14745992900276518', 1, 0, '', NULL, NULL, NULL),
(8713, '2016-09-23 10:54:50', NULL, NULL, 3115, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 10:54:50', 'admin-1474592419-14745992900276518', 1, 1, 'SR', NULL, NULL, NULL),
(8714, '2016-09-23 21:26:21', NULL, NULL, 3143, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 21:26:21', 'admin-1474592419-14746371812848166', 1, 1, 'SR', NULL, NULL, '10.0'),
(8715, '2016-09-23 21:26:15', NULL, NULL, 3143, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 21:26:15', 'admin-1474592419-14746371756167020', 1, 1, 'SR', NULL, NULL, '10.0'),
(8716, '2016-09-23 21:26:15', NULL, NULL, 3143, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 21:26:15', 'admin-1474592419-14746371756167020', 1, 1, 'SR', NULL, NULL, '10.0'),
(8717, '2016-09-23 20:28:52', NULL, NULL, 3142, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 20:28:52', 'admin-1474592419-14746337324102996', 1, 0, '', 1, NULL, NULL),
(8718, '2016-09-23 14:49:29', NULL, NULL, 3129, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 14:49:29', 'admin-1474592419-14746133693898018', 1, 1, 'SR', NULL, NULL, NULL),
(8719, '2016-09-23 14:49:29', NULL, NULL, 3129, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 14:49:29', 'admin-1474592419-14746133693898018', 1, 1, 'SR', NULL, NULL, NULL),
(8720, '2016-09-23 14:51:45', NULL, NULL, 3130, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 14:51:45', 'admin-1474592419-14746135049595640', 1, 1, 'SR', NULL, NULL, NULL),
(8721, '2016-09-23 11:08:27', NULL, NULL, 3117, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 11:08:27', 'admin-1474592419-14746001075188885', 1, 1, 'SR', 1, NULL, NULL),
(8722, '2016-09-23 11:35:49', NULL, NULL, 3118, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 11:35:49', 'admin-1474592419-14746017490399936', 1, 0, '', NULL, NULL, NULL),
(8723, '2016-09-23 11:35:49', NULL, NULL, 3118, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 11:35:49', 'admin-1474592419-14746017490399936', 1, 0, '', NULL, NULL, NULL),
(8724, '2016-09-23 11:35:53', NULL, NULL, 3118, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 11:35:53', 'admin-1474592419-14746017531953363', 1, 1, 'SR', NULL, NULL, NULL),
(8725, '2016-09-23 11:35:53', NULL, NULL, 3118, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 11:35:53', 'admin-1474592419-14746017531953363', 1, 1, 'SR', NULL, NULL, NULL),
(8726, '2016-09-23 12:00:19', NULL, NULL, 3119, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 12:00:19', 'admin-1474592419-14746032189789760', 1, 1, 'SR', NULL, NULL, NULL),
(8727, '2016-09-23 12:00:19', NULL, NULL, 3119, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 12:00:19', 'admin-1474592419-14746032189789760', 1, 1, 'SR', NULL, NULL, NULL),
(8728, '2016-09-23 13:12:10', NULL, NULL, 3120, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 13:12:10', 'admin-1474592419-14746075298796671', 1, 1, 'SR', NULL, NULL, NULL),
(8729, '2016-09-23 13:12:10', NULL, NULL, 3120, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 13:12:10', 'admin-1474592419-14746075298796671', 1, 1, 'SR', NULL, NULL, NULL),
(8730, '2016-09-23 13:42:52', NULL, NULL, 3121, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 13:42:52', 'admin-1474592419-14746093719814198', 1, 0, '', NULL, NULL, NULL),
(8731, '2016-09-23 13:42:52', NULL, NULL, 3121, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 13:42:52', 'admin-1474592419-14746093719814198', 1, 0, '', NULL, NULL, NULL),
(8732, '2016-09-23 13:43:04', NULL, NULL, 3121, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 13:43:04', 'admin-1474592419-14746093844392872', 1, 1, 'SR', NULL, NULL, NULL),
(8733, '2016-09-23 14:02:58', NULL, NULL, 3122, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 14:02:58', 'admin-1474592419-14746105786608396', 1, 1, 'SR', NULL, NULL, NULL),
(8734, '2016-09-23 14:02:58', NULL, NULL, 3122, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 14:02:58', 'admin-1474592419-14746105786608396', 1, 0, '', NULL, NULL, NULL),
(8735, '2016-09-23 14:03:29', NULL, NULL, 3123, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 14:03:29', 'admin-1474592419-14746106091492385', 1, 1, 'SR', NULL, NULL, NULL),
(8736, '2016-09-23 14:03:29', NULL, NULL, 3123, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 14:03:29', 'admin-1474592419-14746106091492385', 1, 1, 'SR', NULL, NULL, NULL),
(8737, '2016-09-23 14:41:49', NULL, NULL, 3128, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 14:41:49', 'admin-1474592419-14746129091898754', 1, 1, 'SR', NULL, NULL, NULL),
(8738, '2016-09-23 14:28:19', NULL, NULL, 3127, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 14:28:19', 'admin-1474592419-14746120990668133', 1, 1, 'SR', NULL, NULL, NULL),
(8739, '2016-09-23 14:41:21', NULL, NULL, 3128, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 14:41:21', 'admin-1474592419-14746128809204756', 1, 1, 'SR', NULL, NULL, NULL),
(8740, '2016-09-23 14:28:19', NULL, NULL, 3127, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 14:28:19', 'admin-1474592419-14746120990668133', 1, 1, 'SR', NULL, NULL, NULL),
(8741, '2016-09-23 14:27:42', NULL, NULL, 3126, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 14:27:42', 'admin-1474592419-1474612062523514', 1, 1, 'SR', NULL, NULL, NULL),
(8742, '2016-09-23 14:27:03', NULL, NULL, 3125, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 14:27:03', 'admin-1474592419-14746120231659815', 1, 0, '', NULL, NULL, NULL),
(8743, '2016-09-23 14:05:10', NULL, NULL, 3124, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 14:05:10', 'admin-1474592419-1474610710527644', 1, 1, 'SR', NULL, NULL, NULL),
(8744, '2016-09-23 10:54:50', NULL, NULL, 3115, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 10:54:50', 'admin-1474592419-14745992900276518', 1, 1, 'SR', NULL, NULL, NULL),
(8745, '2016-09-23 10:30:36', NULL, NULL, 3112, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 10:30:36', 'admin-1474592419-14745978358734534', 1, 0, '', NULL, NULL, NULL),
(8746, '2016-09-23 00:00:00', NULL, NULL, 3114, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 10:30:36', 'admin-1474592419-14745978358734534', 1, 1, 'SR', NULL, NULL, NULL),
(8747, '2016-09-23 09:44:10', NULL, NULL, 3111, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 09:44:10', 'admin-1474592419-14745950502615312', 1, 0, '', NULL, NULL, NULL),
(8748, '2016-09-23 20:28:38', NULL, NULL, 3141, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', 'Takeaway', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 20:28:38', 'admin-1474592419-14746337181141958', 1, 0, '', NULL, NULL, NULL),
(8749, '2016-09-23 09:44:10', NULL, NULL, 3111, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 09:44:10', 'admin-1474592419-14745950502615312', 1, 1, 'SR', NULL, NULL, NULL),
(8750, '2016-09-23 09:44:10', NULL, NULL, 3111, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 09:44:10', 'admin-1474592419-14745950502615312', 1, 1, 'SR', NULL, NULL, NULL),
(8751, '2016-09-23 09:42:46', NULL, NULL, 3111, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474592419', 'admin', '2016-09-23 09:42:46', 'admin-1474592419-14745949662942444', 1, 0, '', NULL, NULL, NULL),
(8752, '2016-09-24 12:58:42', NULL, NULL, 3177, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 12:58:42', 'admin-1474692039-14746931223605097', 1, 0, '', NULL, NULL, NULL),
(8753, '2016-09-24 12:58:59', NULL, NULL, 3177, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 12:58:59', 'admin-1474692039-1474693138847695', 1, 0, '', NULL, NULL, NULL),
(8754, '2016-09-24 13:53:30', NULL, NULL, 3170, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 13:53:30', 'admin-1474692039-1474696410236561', 1, 1, 'SR', NULL, NULL, NULL),
(8755, '2016-09-24 14:10:47', NULL, NULL, 3180, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 14:10:47', 'admin-1474692039-14746974472158197', 1, 0, '', NULL, NULL, NULL),
(8756, '2016-09-24 14:10:47', NULL, NULL, 3180, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 14:10:47', 'admin-1474692039-14746974472158197', 1, 1, 'SR', NULL, NULL, NULL),
(8757, '2016-09-24 13:38:03', NULL, NULL, 3179, 0, 224, '158', 'Set Garlic Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 13:38:03', 'admin-1474692039-14746954832582177', 1, 0, '', NULL, NULL, NULL),
(8758, '2016-09-24 13:38:03', NULL, NULL, 3179, 0, 85, '85', 'Set Sauted Mushroom Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 13:38:03', 'admin-1474692039-14746954832582177', 1, 1, 'SR', NULL, NULL, NULL),
(8759, '2016-09-24 14:11:24', NULL, NULL, 3180, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 14:11:24', 'admin-1474692039-14746974846615316', 1, 1, 'SR', NULL, NULL, NULL),
(8760, '2016-09-24 14:22:26', NULL, NULL, 3181, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 14:22:26', 'admin-1474692039-14746981462607490', 1, 1, 'SR', 1, NULL, NULL),
(8761, '2016-09-24 14:48:56', NULL, NULL, 3182, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 14:48:56', 'admin-1474692039-14746997364605740', 1, 0, '', NULL, NULL, NULL),
(8762, '2016-09-24 15:21:16', NULL, NULL, 3183, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 15:21:16', 'admin-1474692039-14747016760098527', 1, 1, 'SR', NULL, NULL, NULL),
(8763, '2016-09-24 19:13:43', NULL, NULL, 3193, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 19:13:43', 'admin-1474715615-14747156234243320', 1, 1, 'SR', NULL, NULL, NULL),
(8764, '2016-09-24 19:39:17', NULL, NULL, 3194, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 19:39:17', 'admin-1474715615-14747171572862137', 1, 1, 'SR', NULL, NULL, NULL),
(8765, '2016-09-24 19:39:17', NULL, NULL, 3194, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 19:39:17', 'admin-1474715615-14747171572862137', 1, 1, 'SR', NULL, NULL, NULL),
(8766, '2016-09-24 19:52:46', NULL, NULL, 3195, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 19:52:46', 'admin-1474715615-14747179660598953', 1, 1, 'SR', NULL, NULL, NULL),
(8767, '2016-09-24 19:52:46', NULL, NULL, 3195, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 19:52:46', 'admin-1474715615-14747179660598953', 1, 0, '', NULL, NULL, NULL),
(8768, '2016-09-24 20:13:38', NULL, NULL, 3196, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 20:13:38', 'admin-1474715615-14747192187633041', 1, 1, 'SR', NULL, NULL, NULL),
(8769, '2016-09-24 20:27:14', NULL, NULL, 3197, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 20:27:14', 'admin-1474715615-1474720034750415', 1, 1, 'SR', NULL, NULL, NULL),
(8770, '2016-09-24 16:10:49', NULL, NULL, 3185, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 16:10:50', 'admin-1474692039-14747046497997363', 1, 1, 'SR', NULL, NULL, NULL),
(8771, '2016-09-24 16:10:50', NULL, NULL, 3185, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 16:10:50', 'admin-1474692039-14747046497997363', 1, 1, 'SR', NULL, NULL, NULL),
(8772, '2016-09-24 16:10:50', NULL, NULL, 3185, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 16:10:50', 'admin-1474692039-14747046497997363', 1, 0, '', NULL, NULL, NULL),
(8773, '2016-09-24 16:10:50', NULL, NULL, 3185, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 16:10:50', 'admin-1474692039-14747046497997363', 1, 0, '', NULL, NULL, NULL),
(8774, '2016-09-24 12:53:13', NULL, NULL, 3176, 0, 211, '145', 'Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 12:53:13', 'admin-1474692039-14746927930322490', 1, 0, '', NULL, NULL, NULL),
(8775, '2016-09-24 11:51:30', NULL, NULL, 3165, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:51:30', 'admin-1474687052-14746890906057678', 1, 1, 'SR', NULL, NULL, NULL),
(8776, '2016-09-24 12:28:49', NULL, NULL, 3171, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 12:28:49', 'admin-1474689107-14746913290374681', 1, 0, '', NULL, NULL, NULL),
(8777, '2016-09-24 12:31:38', NULL, NULL, 3172, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 12:31:38', 'admin-1474689107-14746914983803936', 1, 1, 'SR', NULL, NULL, NULL),
(8778, '2016-09-24 19:13:00', NULL, NULL, 3193, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 19:13:00', 'admin-1474692039-1474715580538186', 1, 0, '', NULL, NULL, NULL),
(8779, '2016-09-24 19:13:00', NULL, NULL, 3193, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 19:13:00', 'admin-1474692039-1474715580538186', 1, 0, '', NULL, NULL, NULL),
(8780, '2016-09-24 19:13:00', NULL, NULL, 3193, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 19:13:00', 'admin-1474692039-1474715580538186', 1, 1, 'SR', NULL, NULL, NULL),
(8781, '2016-09-24 19:13:00', NULL, NULL, 3193, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 19:13:00', 'admin-1474692039-1474715580538186', 1, 1, 'SR', NULL, NULL, NULL),
(8782, '2016-09-24 19:10:31', NULL, NULL, 3192, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 19:10:32', 'admin-1474692039-14747154317991971', 1, 0, '', NULL, NULL, NULL),
(8783, '2016-09-24 19:10:31', NULL, NULL, 3192, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 19:10:31', 'admin-1474692039-14747154317991971', 1, 1, 'SR', NULL, NULL, NULL),
(8784, '2016-09-24 18:43:46', NULL, NULL, 3191, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 18:43:46', 'admin-1474692039-14747138264197858', 1, 1, 'SR', NULL, NULL, NULL),
(8785, '2016-09-24 18:43:46', NULL, NULL, 3191, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 18:43:46', 'admin-1474692039-14747138264197858', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(8786, '2016-09-24 17:55:10', NULL, NULL, 3190, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 17:55:10', 'admin-1474692039-14747109100559876', 1, 1, 'SR', NULL, NULL, NULL),
(8787, '2016-09-24 12:58:42', NULL, NULL, 3177, 0, 222, '156', 'Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 12:58:42', 'admin-1474692039-14746931223605097', 1, 0, '', NULL, NULL, NULL),
(8788, '2016-09-24 17:48:45', NULL, NULL, 3189, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 17:48:45', 'admin-1474692039-14747105253729067', 1, 1, 'SR', NULL, NULL, '10.0'),
(8789, '2016-09-24 16:37:51', NULL, NULL, 3188, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 16:37:51', 'admin-1474692039-14747062709381197', 1, 1, 'SR', NULL, NULL, NULL),
(8790, '2016-09-24 16:37:51', NULL, NULL, 3188, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 16:37:51', 'admin-1474692039-14747062709381197', 1, 1, 'SR', NULL, NULL, NULL),
(8791, '2016-09-24 16:16:59', NULL, NULL, 3187, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 16:16:59', 'admin-1474692039-14747050194033576', 1, 0, '', NULL, NULL, NULL),
(8792, '2016-09-24 16:11:35', NULL, NULL, 3186, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 16:11:35', 'admin-1474692039-14747046953138877', 1, 0, '', NULL, NULL, NULL),
(8793, '2016-09-24 16:11:35', NULL, NULL, 3186, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 16:11:35', 'admin-1474692039-14747046953138877', 1, 1, 'SR', NULL, NULL, NULL),
(8794, '2016-09-24 16:11:35', NULL, NULL, 3186, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 16:11:35', 'admin-1474692039-14747046953138877', 1, 1, 'SR', NULL, NULL, NULL),
(8795, '2016-09-24 11:51:30', NULL, NULL, 3165, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:51:30', 'admin-1474687052-14746890906057678', 1, 0, '', NULL, NULL, NULL),
(8796, '2016-09-24 11:01:25', NULL, NULL, 3157, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:01:25', 'admin-1474683903-14746860856703827', 1, 1, 'SR', NULL, NULL, NULL),
(8797, '2016-09-24 11:01:25', NULL, NULL, 3157, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:01:25', 'admin-1474683903-14746860856703827', 1, 1, 'SR', NULL, NULL, NULL),
(8798, '2016-09-24 11:05:02', NULL, NULL, 3158, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:05:02', 'admin-1474683903-14746863026176562', 1, 0, '', NULL, NULL, NULL),
(8799, '2016-09-24 11:05:02', NULL, NULL, 3158, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:05:02', 'admin-1474683903-14746863026176562', 1, 0, '', NULL, NULL, NULL),
(8800, '2016-09-24 11:05:02', NULL, NULL, 3158, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:05:02', 'admin-1474683903-14746863026176562', 1, 0, '', NULL, NULL, NULL),
(8801, '2016-09-24 11:05:02', NULL, NULL, 3158, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:05:02', 'admin-1474683903-14746863026176562', 1, 1, 'SR', NULL, NULL, NULL),
(8802, '2016-09-24 11:12:51', NULL, NULL, 3159, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:12:51', 'admin-1474683903-14746867709734175', 1, 1, 'SR', NULL, NULL, NULL),
(8803, '2016-09-24 11:12:51', NULL, NULL, 3159, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:12:51', 'admin-1474683903-14746867709734175', 1, 1, 'SR', NULL, NULL, NULL),
(8804, '2016-09-24 11:12:51', NULL, NULL, 3159, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:12:51', 'admin-1474683903-14746867709734175', 1, 0, '', NULL, NULL, NULL),
(8805, '2016-09-24 11:16:43', NULL, NULL, 3160, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:16:43', 'admin-1474683903-14746870033597274', 1, 1, 'SR', NULL, NULL, NULL),
(8806, '2016-09-24 11:16:43', NULL, NULL, 3160, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:16:43', 'admin-1474683903-14746870033597274', 1, 1, 'SR', NULL, NULL, NULL),
(8807, '2016-09-24 11:17:43', NULL, NULL, 3160, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:17:43', 'admin-1474687052-14746870636095144', 1, 1, 'SR', NULL, NULL, NULL),
(8808, '2016-09-24 11:17:43', NULL, NULL, 3160, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:17:43', 'admin-1474687052-14746870636095144', 1, 0, '', NULL, NULL, NULL),
(8809, '2016-09-24 11:24:32', NULL, NULL, 3162, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:24:32', 'admin-1474687052-14746874723237170', 1, 0, '', NULL, NULL, NULL),
(8810, '2016-09-24 11:21:20', NULL, NULL, 3161, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:21:20', 'admin-1474687052-14746872799917914', 1, 0, '', NULL, NULL, NULL),
(8811, '2016-09-24 11:21:20', NULL, NULL, 3161, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:21:20', 'admin-1474687052-14746872799917914', 1, 0, '', NULL, NULL, NULL),
(8812, '2016-09-24 11:21:20', NULL, NULL, 3161, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:21:20', 'admin-1474687052-14746872799917914', 1, 1, 'SR', NULL, NULL, NULL),
(8813, '2016-09-24 11:24:32', NULL, NULL, 3162, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:24:32', 'admin-1474687052-14746874723237170', 1, 1, 'SR', NULL, NULL, NULL),
(8814, '2016-09-24 11:25:50', NULL, NULL, 3163, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:25:50', 'admin-1474687052-14746875499912089', 1, 0, '', NULL, NULL, NULL),
(8815, '2016-09-24 16:10:50', NULL, NULL, 3185, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 16:10:50', 'admin-1474692039-14747046497997363', 1, 1, 'SR', NULL, NULL, NULL),
(8816, '2016-09-24 16:02:14', NULL, NULL, 3170, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 16:02:14', 'admin-1474692039-14747041341056086', 1, 1, 'SR', NULL, NULL, NULL),
(8817, '2016-09-24 15:45:02', NULL, NULL, 3184, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 15:45:02', 'admin-1474692039-14747031022919949', 1, 1, 'SR', NULL, NULL, NULL),
(8818, '2016-09-24 15:21:16', NULL, NULL, 3183, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 15:21:16', 'admin-1474692039-14747016760098527', 1, 0, '', NULL, NULL, NULL),
(8819, '2016-09-24 12:01:33', NULL, NULL, 3168, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 12:01:33', 'admin-1474689107-14746896935389542', 1, 1, 'SR', NULL, NULL, NULL),
(8820, '2016-09-24 12:17:12', NULL, NULL, 3169, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 12:17:12', 'admin-1474689107-1474690632673879', 1, 0, '', NULL, NULL, NULL),
(8821, '2016-09-24 12:18:21', NULL, NULL, 3169, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 12:18:21', 'admin-1474689107-1474690701307317', 1, 0, '', NULL, NULL, NULL),
(8822, '2016-09-24 12:18:39', NULL, NULL, 3169, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 12:18:39', 'admin-1474689107-14746907196166925', 1, 1, 'SR', NULL, NULL, NULL),
(8823, '2016-09-24 12:18:39', NULL, NULL, 3169, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 12:18:39', 'admin-1474689107-14746907196166925', 1, 0, '', NULL, NULL, NULL),
(8824, '2016-09-24 19:13:00', NULL, NULL, 3193, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 19:13:00', 'admin-1474692039-1474715580538186', 1, 1, 'SR', NULL, NULL, NULL),
(8825, '2016-09-24 15:21:16', NULL, NULL, 3183, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 15:21:16', 'admin-1474692039-14747016760098527', 1, 1, 'SR', NULL, NULL, NULL),
(8826, '2016-09-24 15:21:16', NULL, NULL, 3183, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 15:21:16', 'admin-1474692039-14747016760098527', 1, 1, 'SR', NULL, NULL, NULL),
(8827, '2016-09-24 10:43:54', NULL, NULL, 3156, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 10:43:54', 'admin-1474683903-14746850338589483', 1, 0, '', NULL, NULL, NULL),
(8828, '2016-09-24 10:26:57', NULL, NULL, 3154, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 10:26:57', 'admin-1474683903-14746840175646775', 1, 1, 'SR', NULL, NULL, NULL),
(8829, '2016-09-24 10:26:57', NULL, NULL, 3154, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 10:26:57', 'admin-1474683903-14746840175646775', 1, 1, 'SR', NULL, NULL, NULL),
(8830, '2016-09-24 10:38:13', NULL, NULL, 3155, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 10:38:13', 'admin-1474683903-14746846937533727', 1, 0, '', NULL, NULL, NULL),
(8831, '2016-09-24 10:38:13', NULL, NULL, 3155, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 10:38:13', 'admin-1474683903-14746846937533727', 1, 0, '', NULL, NULL, NULL),
(8832, '2016-09-24 10:38:13', NULL, NULL, 3155, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 10:38:13', 'admin-1474683903-14746846937533727', 1, 1, 'SR', NULL, NULL, NULL),
(8833, '2016-09-24 10:38:22', NULL, NULL, 3155, 0, 205, '140', 'Promo Tea by Pot', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 10:38:22', 'admin-1474683903-14746847018768757', 1, 0, '', NULL, NULL, NULL),
(8834, '2016-09-24 10:43:54', NULL, NULL, 3156, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 10:43:54', 'admin-1474683903-14746850338589483', 1, 0, '', NULL, NULL, NULL),
(8835, '2016-09-24 10:43:54', NULL, NULL, 3156, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 10:43:54', 'admin-1474683903-14746850338589483', 1, 0, '', NULL, NULL, NULL),
(8836, '2016-09-24 19:13:00', NULL, NULL, 3193, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 19:13:00', 'admin-1474692039-1474715580538186', 1, 1, 'SR', NULL, NULL, NULL),
(8837, '2016-09-24 12:58:42', NULL, NULL, 3177, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 12:58:42', 'admin-1474692039-14746931223605097', 1, 1, 'SR', NULL, NULL, NULL),
(8838, '2016-09-24 12:41:29', NULL, NULL, 3175, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 12:41:29', 'admin-1474692039-1474692089405246', 1, 1, 'SR', NULL, NULL, NULL),
(8839, '2016-09-24 12:31:38', NULL, NULL, 3172, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 12:31:38', 'admin-1474689107-14746914983803936', 1, 1, 'SR', NULL, NULL, NULL),
(8840, '2016-09-24 12:36:00', NULL, NULL, 3173, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 12:36:00', 'admin-1474689107-1474691759972625', 1, 1, 'SR', NULL, NULL, NULL),
(8841, '2016-09-24 12:36:00', NULL, NULL, 3173, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 12:36:00', 'admin-1474689107-1474691759972625', 1, 1, 'SR', NULL, NULL, NULL),
(8842, '2016-09-24 12:24:56', NULL, NULL, 3170, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 12:24:56', 'admin-1474689107-14746910963014531', 1, 1, 'SR', NULL, NULL, NULL),
(8843, '2016-09-24 12:01:09', NULL, NULL, 3168, 0, 211, '145', 'Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 12:01:09', 'admin-1474689107-14746896691116021', 1, 0, '', NULL, NULL, NULL),
(8844, '2016-09-24 11:55:32', NULL, NULL, 3167, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:55:32', 'admin-1474689107-14746893318105584', 1, 1, 'SR', NULL, NULL, NULL),
(8845, '2016-09-24 11:55:32', NULL, NULL, 3167, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:55:32', 'admin-1474689107-14746893318105584', 1, 0, '', NULL, NULL, NULL),
(8846, '2016-09-24 11:32:28', NULL, NULL, 3159, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:32:28', 'admin-1474687052-147468794799863', 1, 0, '', NULL, NULL, NULL),
(8847, '2016-09-24 11:27:57', NULL, NULL, 3164, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:27:57', 'admin-1474687052-14746876769319059', 1, 1, 'SR', NULL, NULL, NULL),
(8848, '2016-09-24 11:27:39', NULL, NULL, 3164, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:27:39', 'admin-1474687052-1474687659332812', 1, 0, '', NULL, NULL, NULL),
(8849, '2016-09-24 11:25:50', NULL, NULL, 3163, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:25:50', 'admin-1474687052-14746875499912089', 1, 0, '', NULL, NULL, NULL),
(8850, '2016-09-24 11:00:31', NULL, NULL, 3157, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:00:31', 'admin-1474683903-14746860313956322', 1, 0, '', NULL, NULL, NULL),
(8851, '2016-09-24 11:00:31', NULL, NULL, 3157, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 11:00:31', 'admin-1474683903-14746860313956322', 1, 0, '', NULL, NULL, NULL),
(8852, '2016-09-24 10:43:54', NULL, NULL, 3156, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 10:43:54', 'admin-1474683903-14746850338589483', 1, 1, 'SR', NULL, NULL, NULL),
(8853, '2016-09-24 10:43:54', NULL, NULL, 3156, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 10:43:54', 'admin-1474683903-14746850338589483', 1, 1, 'SR', NULL, NULL, NULL),
(8854, '2016-09-24 12:40:22', NULL, NULL, 3174, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 12:40:22', 'admin-1474689107-14746920220547028', 1, 0, '', NULL, NULL, NULL),
(8855, '2016-09-24 09:10:22', NULL, NULL, 3144, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:10:22', 'admin-1474678577-1474679422116726', 1, 0, '', NULL, NULL, NULL),
(8856, '2016-09-24 09:23:29', NULL, NULL, 3145, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:23:29', 'admin-1474678577-14746802087895154', 1, 0, '', NULL, NULL, NULL),
(8857, '2016-09-24 09:23:29', NULL, NULL, 3145, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:23:29', 'admin-1474678577-14746802087895154', 1, 0, '', NULL, NULL, NULL),
(8858, '2016-09-24 09:23:29', NULL, NULL, 3145, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:23:29', 'admin-1474678577-14746802087895154', 1, 0, '', NULL, NULL, NULL),
(8859, '2016-09-24 09:27:15', NULL, NULL, 3146, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:27:15', 'admin-1474678577-14746804351048026', 1, 0, '', NULL, NULL, NULL),
(8860, '2016-09-24 09:27:15', NULL, NULL, 3146, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:27:15', 'admin-1474678577-14746804351048026', 1, 0, '', NULL, NULL, NULL),
(8861, '2016-09-24 09:27:15', NULL, NULL, 3146, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:27:15', 'admin-1474678577-14746804351048026', 1, 1, 'SR', NULL, NULL, NULL),
(8862, '2016-09-24 09:27:15', NULL, NULL, 3146, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:27:15', 'admin-1474678577-14746804351048026', 1, 1, 'SR', NULL, NULL, NULL),
(8863, '2016-09-24 09:27:15', NULL, NULL, 3146, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:27:15', 'admin-1474678577-14746804351048026', 1, 1, 'SR', NULL, NULL, NULL),
(8864, '2016-09-24 09:27:58', NULL, NULL, 3146, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:27:58', 'admin-1474678577-14746804786557784', 1, 0, '', NULL, NULL, NULL),
(8865, '2016-09-24 09:27:58', NULL, NULL, 3146, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:27:58', 'admin-1474678577-14746804786557784', 1, 1, 'SR', NULL, NULL, NULL),
(8866, '2016-09-24 09:34:29', NULL, NULL, 3147, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:34:29', 'admin-1474678577-14746808697134794', 1, 0, '', NULL, NULL, NULL),
(8867, '2016-09-24 09:35:04', NULL, NULL, 3147, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:35:04', 'admin-1474680879-1474680904612762', 1, 1, 'SR', NULL, NULL, NULL),
(8868, '2016-09-24 09:37:00', NULL, NULL, 3148, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:37:00', 'admin-1474680879-14746810202981351', 1, 0, '', NULL, NULL, NULL),
(8869, '2016-09-24 09:37:00', NULL, NULL, 3148, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:37:00', 'admin-1474680879-14746810202981351', 1, 1, 'SR', NULL, NULL, NULL),
(8870, '2016-09-24 09:38:50', NULL, NULL, 3149, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:38:50', 'admin-1474680879-14746811300132371', 1, 0, '', NULL, NULL, NULL),
(8871, '2016-09-24 09:38:50', NULL, NULL, 3149, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:38:50', 'admin-1474680879-14746811300132371', 1, 1, 'SR', NULL, NULL, NULL),
(8872, '2016-09-24 10:08:44', NULL, NULL, 3150, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 10:08:44', 'admin-1474680879-14746829240853611', 1, 0, '', NULL, NULL, NULL),
(8873, '2016-09-24 10:08:44', NULL, NULL, 3150, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 10:08:44', 'admin-1474680879-14746829240853611', 1, 0, '', NULL, NULL, NULL),
(8874, '2016-09-24 10:09:21', NULL, NULL, 3150, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 10:09:21', 'admin-1474680879-1474682961610381', 1, 1, 'SR', NULL, NULL, NULL),
(8875, '2016-09-24 10:24:52', NULL, NULL, 3153, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 10:24:52', 'admin-1474680879-14746838925433781', 1, 1, 'SR', NULL, NULL, NULL),
(8876, '2016-09-24 10:24:52', NULL, NULL, 3153, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 10:24:52', 'admin-1474680879-14746838925433781', 1, 0, '', NULL, NULL, NULL),
(8877, '2016-09-24 10:24:52', NULL, NULL, 3153, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 10:24:52', 'admin-1474680879-14746838925433781', 1, 1, 'SR', NULL, NULL, NULL),
(8878, '2016-09-24 10:24:24', NULL, NULL, 3153, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 10:24:24', 'admin-1474680879-14746838644092920', 1, 0, '', NULL, NULL, NULL),
(8879, '2016-09-24 10:11:05', NULL, NULL, 3152, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 10:11:05', 'admin-1474680879-14746830649678916', 1, 1, 'SR', NULL, NULL, NULL),
(8880, '2016-09-24 10:09:21', NULL, NULL, 3150, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 10:09:21', 'admin-1474680879-1474682961610381', 1, 1, 'SR', NULL, NULL, NULL),
(8881, '2016-09-24 10:10:05', NULL, NULL, 3151, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 10:10:05', 'admin-1474680879-14746830048206626', 1, 1, 'SR', NULL, NULL, NULL),
(8882, '2016-09-24 09:23:29', NULL, NULL, 3145, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:23:29', 'admin-1474678577-14746802087895154', 1, 1, 'SR', NULL, NULL, NULL),
(8883, '2016-09-24 09:23:29', NULL, NULL, 3145, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:23:29', 'admin-1474678577-14746802087895154', 1, 1, 'SR', NULL, NULL, NULL),
(8884, '2016-09-24 09:27:15', NULL, NULL, 3146, 0, 153, '87', 'Big Breakfast ', 'no baked beans', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:27:15', 'admin-1474678577-14746804351048026', 1, 0, '', NULL, NULL, NULL),
(8885, '2016-09-24 09:07:20', NULL, NULL, 3144, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:07:20', 'admin-1474678577-14746792401631739', 1, 1, 'SR', NULL, NULL, NULL),
(8886, '2016-09-24 09:07:20', NULL, NULL, 3144, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:07:20', 'admin-1474678577-14746792401631739', 1, 1, 'SR', NULL, NULL, NULL),
(8887, '2016-09-24 09:23:29', NULL, NULL, 3145, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:23:29', 'admin-1474678577-14746802087895154', 1, 1, 'SR', NULL, NULL, NULL),
(8888, '2016-09-24 09:05:18', NULL, NULL, 3144, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474715615', 'admin', '2016-09-24 09:05:18', 'admin-1474678577-14746791180639045', 1, 0, '', NULL, NULL, NULL),
(8889, '2016-09-25 20:43:14', NULL, NULL, 3252, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 20:43:14', 'admin-1474803087-14748073947111152', 1, 1, 'SR', NULL, NULL, NULL),
(8890, '2016-09-25 00:00:00', NULL, NULL, 3254, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 18:50:46', 'admin-1474781409-1474800645870855', 1, 0, '', NULL, NULL, NULL),
(8891, '2016-09-25 00:00:00', NULL, NULL, 3254, 0, 181, '116', 'Open Food ', 'egg', 'Meals', 'Perfect Meals', 1, 1.50, NULL, NULL, 1.50, 1, '27', 1, '1474803087', 'admin', '2016-09-25 21:19:37', 'admin-1474803087-14748095769309255', 1, 0, '', NULL, NULL, NULL),
(8892, '2016-09-25 20:52:48', NULL, NULL, 3243, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 20:52:48', 'admin-1474803087-14748079684013852', 1, 0, '', NULL, NULL, NULL),
(8893, '2016-09-25 21:14:13', NULL, NULL, 3253, 0, 182, '117', 'Open Drinks ', 'Artero Red Wine', 'Cold Drinks', 'Fresh Juice', 1, 100.00, 100.0000, 0.0000, 100.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 21:14:13', 'admin-1474803087-14748092529788194', 1, 0, '', NULL, NULL, NULL),
(8894, '2016-09-25 20:46:27', NULL, NULL, 3253, 0, 182, '117', 'Open Drinks ', 'barwang', 'Desserts', '0', 1, 100.00, 100.0000, 0.0000, 100.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 20:46:27', 'admin-1474803087-14748075875826298', 1, 0, '', NULL, NULL, NULL),
(8895, '2016-09-25 20:45:58', NULL, NULL, 3252, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 20:45:58', 'admin-1474803087-14748075586056711', 1, 1, 'SR', NULL, NULL, NULL),
(8896, '2016-09-25 20:45:58', NULL, NULL, 3252, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 20:45:58', 'admin-1474803087-14748075586056711', 1, 1, 'SR', NULL, NULL, NULL),
(8897, '2016-09-25 20:43:14', NULL, NULL, 3252, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 20:43:14', 'admin-1474803087-14748073947111152', 1, 1, 'SR', NULL, NULL, NULL),
(8898, '2016-09-25 20:29:54', NULL, NULL, 3251, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 20:29:54', 'admin-1474803087-14748065942056274', 1, 1, 'SR', NULL, NULL, NULL),
(8899, '2016-09-25 20:29:54', NULL, NULL, 3251, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 20:29:54', 'admin-1474803087-14748065942056274', 1, 0, '', NULL, NULL, NULL),
(8900, '2016-09-25 20:29:54', NULL, NULL, 3251, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 20:29:54', 'admin-1474803087-14748065942056274', 1, 0, '', NULL, NULL, NULL),
(8901, '2016-09-25 19:46:33', NULL, NULL, 3249, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 19:46:33', 'admin-1474803087-14748039932419682', 1, 0, '', NULL, NULL, NULL),
(8902, '2016-09-25 19:56:33', NULL, NULL, 3250, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 19:56:33', 'admin-1474803087-14748045932768235', 1, 0, '', NULL, NULL, NULL),
(8903, '2016-09-25 19:56:33', NULL, NULL, 3250, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 19:56:33', 'admin-1474803087-14748045932768235', 1, 0, '', NULL, NULL, NULL),
(8904, '2016-09-25 19:56:33', NULL, NULL, 3250, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 19:56:33', 'admin-1474803087-14748045932768235', 1, 1, 'SR', NULL, NULL, NULL),
(8905, '2016-09-25 19:46:01', NULL, NULL, 3249, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 19:46:01', 'admin-1474803087-14748039612629733', 1, 1, 'SR', NULL, NULL, NULL),
(8906, '2016-09-25 16:26:11', NULL, NULL, 3240, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 16:26:11', 'admin-1474781409-14747919712271050', 1, 1, 'SR', NULL, NULL, NULL),
(8907, '2016-09-25 16:32:13', NULL, NULL, 3241, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 16:32:13', 'admin-1474781409-14747923334815064', 1, 0, '', NULL, NULL, NULL),
(8908, '2016-09-25 16:32:13', NULL, NULL, 3241, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 16:32:13', 'admin-1474781409-14747923334815064', 1, 0, '', NULL, NULL, NULL),
(8909, '2016-09-25 16:32:13', NULL, NULL, 3241, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 16:32:13', 'admin-1474781409-14747923334815064', 1, 0, '', NULL, NULL, NULL),
(8910, '2016-09-25 16:32:55', NULL, NULL, 3241, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 16:32:55', 'admin-1474781409-14747923753125483', 1, 1, 'SR', NULL, NULL, NULL),
(8911, '2016-09-25 16:32:55', NULL, NULL, 3241, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 16:32:55', 'admin-1474781409-14747923753125483', 1, 1, 'SR', NULL, NULL, NULL),
(8912, '2016-09-25 16:32:55', NULL, NULL, 3241, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 16:32:55', 'admin-1474781409-14747923753125483', 1, 1, 'SR', NULL, NULL, NULL),
(8913, '2016-09-25 18:10:37', NULL, NULL, 3242, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 18:10:37', 'admin-1474781409-14747982369897796', 1, 1, 'SR', 1, NULL, NULL),
(8914, '2016-09-25 18:10:37', NULL, NULL, 3242, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 18:10:37', 'admin-1474781409-14747982369897796', 1, 1, 'SR', 1, NULL, NULL),
(8915, '2016-09-25 18:10:37', NULL, NULL, 3242, 0, 222, '156', 'Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 18:10:37', 'admin-1474781409-14747982369897796', 1, 0, '', 1, NULL, NULL),
(8916, '2016-09-25 18:10:37', NULL, NULL, 3242, 0, 222, '156', 'Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 18:10:37', 'admin-1474781409-14747982369897796', 1, 0, '', 1, NULL, NULL),
(8917, '2016-09-25 00:00:00', NULL, NULL, 3254, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 18:36:36', 'admin-1474781409-1474799796128721', 1, 1, 'SR', NULL, NULL, NULL),
(8918, '2016-09-25 18:36:36', NULL, NULL, 3243, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 18:36:36', 'admin-1474781409-1474799796128721', 1, 1, 'SR', NULL, NULL, NULL),
(8919, '2016-09-25 18:37:42', NULL, NULL, 3244, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 18:37:42', 'admin-1474781409-14747998621584991', 1, 0, '', NULL, NULL, NULL),
(8920, '2016-09-25 18:37:42', NULL, NULL, 3244, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 18:37:42', 'admin-1474781409-14747998621584991', 1, 1, 'SR', NULL, NULL, NULL),
(8921, '2016-09-25 18:37:42', NULL, NULL, 3244, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 18:37:42', 'admin-1474781409-14747998621584991', 1, 1, 'SR', NULL, NULL, NULL),
(8922, '2016-09-25 18:37:42', NULL, NULL, 3244, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 18:37:42', 'admin-1474781409-14747998621584991', 1, 0, '', NULL, NULL, NULL),
(8923, '2016-09-25 00:00:00', NULL, NULL, 3254, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 18:36:36', 'admin-1474781409-1474799796128721', 1, 1, 'SR', NULL, NULL, NULL),
(8924, '2016-09-25 00:00:00', NULL, NULL, 3254, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 18:38:49', 'admin-1474781409-1474799929117188', 1, 0, '', NULL, NULL, NULL),
(8925, '2016-09-25 19:11:34', NULL, NULL, 3245, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 19:11:34', 'admin-1474781409-1474801894361626', 1, 0, '', NULL, NULL, NULL),
(8926, '2016-09-25 19:11:34', NULL, NULL, 3245, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 19:11:34', 'admin-1474781409-1474801894361626', 1, 0, '', NULL, NULL, NULL),
(8927, '2016-09-25 19:11:34', NULL, NULL, 3245, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 19:11:34', 'admin-1474781409-1474801894361626', 1, 0, '', NULL, NULL, NULL),
(8928, '2016-09-25 19:11:34', NULL, NULL, 3245, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 19:11:34', 'admin-1474781409-1474801894361626', 1, 0, '', NULL, NULL, NULL),
(8929, '2016-09-25 19:11:45', NULL, NULL, 3245, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 19:11:45', 'admin-1474781409-14748019050718258', 1, 1, 'SR', NULL, NULL, NULL),
(8930, '2016-09-25 19:12:13', NULL, NULL, 3245, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 19:12:13', 'admin-1474781409-1474801932882492', 1, 0, '', NULL, NULL, NULL),
(8931, '2016-09-25 19:21:45', NULL, NULL, 3243, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 19:21:45', 'admin-1474781409-14748025048222449', 1, 0, '', NULL, NULL, NULL),
(8932, '2016-09-25 19:31:13', NULL, NULL, 3246, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 19:31:13', 'admin-1474781409-14748030730715873', 1, 0, '', NULL, NULL, NULL),
(8933, '2016-09-25 19:31:13', NULL, NULL, 3246, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 19:31:13', 'admin-1474781409-14748030730715873', 1, 1, 'SR', NULL, NULL, NULL),
(8934, '2016-09-25 19:31:13', NULL, NULL, 3246, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 19:31:13', 'admin-1474781409-14748030730715873', 1, 1, 'SR', NULL, NULL, NULL),
(8935, '2016-09-25 19:42:51', NULL, NULL, 3247, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 19:42:51', 'admin-1474803087-14748037716136225', 1, 0, '', NULL, NULL, NULL),
(8936, '2016-09-25 19:45:00', NULL, NULL, 3248, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 19:45:00', 'admin-1474803087-14748039003649163', 1, 1, 'SR', NULL, NULL, NULL),
(8937, '2016-09-25 19:45:53', NULL, NULL, 3249, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 19:45:53', 'admin-1474803087-14748039529556113', 1, 0, '', NULL, NULL, NULL),
(8938, '2016-09-25 19:45:53', NULL, NULL, 3249, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 19:45:53', 'admin-1474803087-14748039529556113', 1, 0, '', NULL, NULL, NULL),
(8939, '2016-09-25 16:26:11', NULL, NULL, 3240, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 16:26:11', 'admin-1474781409-14747919712271050', 1, 1, 'SR', NULL, NULL, NULL),
(8940, '2016-09-25 16:26:11', NULL, NULL, 3240, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 16:26:11', 'admin-1474781409-14747919712271050', 1, 0, '', NULL, NULL, NULL),
(8941, '2016-09-25 16:26:11', NULL, NULL, 3240, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 16:26:11', 'admin-1474781409-14747919712271050', 1, 0, '', NULL, NULL, NULL),
(8942, '2016-09-25 16:16:45', NULL, NULL, 3239, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 16:16:45', 'admin-1474781409-14747914050908882', 1, 1, 'SR', NULL, NULL, NULL),
(8943, '2016-09-25 16:16:45', NULL, NULL, 3239, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 16:16:45', 'admin-1474781409-14747914050908882', 1, 1, 'SR', NULL, NULL, NULL),
(8944, '2016-09-25 16:16:45', NULL, NULL, 3239, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 16:16:45', 'admin-1474781409-14747914050908882', 1, 0, '', NULL, NULL, NULL),
(8945, '2016-09-25 15:22:21', NULL, NULL, 3238, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 15:22:21', 'admin-1474781409-14747881415826619', 1, 1, 'SR', NULL, NULL, NULL),
(8946, '2016-09-25 15:22:21', NULL, NULL, 3238, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 15:22:21', 'admin-1474781409-14747881415826619', 1, 1, 'SR', NULL, NULL, NULL),
(8947, '2016-09-25 15:22:21', NULL, NULL, 3238, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 15:22:21', 'admin-1474781409-14747881415826619', 1, 1, 'SR', NULL, NULL, NULL),
(8948, '2016-09-25 12:30:13', NULL, NULL, 3218, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:30:13', 'admin-1474777649-14747778138087556', 1, 1, 'SR', NULL, NULL, NULL),
(8949, '2016-09-25 12:43:58', NULL, NULL, 3219, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:43:58', 'admin-1474777829-1474778638425828', 1, 1, 'SR', NULL, NULL, NULL),
(8950, '2016-09-25 12:43:58', NULL, NULL, 3219, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:43:58', 'admin-1474777829-1474778638425828', 1, 1, 'SR', NULL, NULL, NULL),
(8951, '2016-09-25 12:51:33', NULL, NULL, 3220, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:51:33', 'admin-1474777829-14747790930687493', 1, 1, 'SR', NULL, NULL, NULL),
(8952, '2016-09-25 12:51:33', NULL, NULL, 3220, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:51:33', 'admin-1474777829-14747790930687493', 1, 1, 'SR', NULL, NULL, NULL),
(8953, '2016-09-25 12:51:33', NULL, NULL, 3220, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:51:33', 'admin-1474777829-14747790930687493', 1, 1, 'SR', NULL, NULL, NULL),
(8954, '2016-09-25 12:51:33', NULL, NULL, 3220, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:51:33', 'admin-1474777829-14747790930687493', 1, 1, 'SR', NULL, NULL, NULL),
(8955, '2016-09-25 12:51:33', NULL, NULL, 3220, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:51:33', 'admin-1474777829-14747790930687493', 1, 1, 'SR', NULL, NULL, NULL),
(8956, '2016-09-25 12:51:33', NULL, NULL, 3220, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:51:33', 'admin-1474777829-14747790930687493', 1, 0, '', NULL, NULL, NULL),
(8957, '2016-09-25 12:51:33', NULL, NULL, 3220, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:51:33', 'admin-1474777829-14747790930687493', 1, 0, '', NULL, NULL, NULL),
(8958, '2016-09-25 19:46:01', NULL, NULL, 3249, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 19:46:01', 'admin-1474803087-14748039612629733', 1, 0, '', NULL, NULL, NULL),
(8959, '2016-09-25 12:56:22', NULL, NULL, 3221, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:56:22', 'admin-1474777829-14747793823688936', 1, 0, '', NULL, NULL, NULL),
(8960, '2016-09-25 12:56:22', NULL, NULL, 3221, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:56:22', 'admin-1474777829-14747793823688936', 1, 0, '', NULL, NULL, NULL),
(8961, '2016-09-25 12:56:22', NULL, NULL, 3221, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:56:22', 'admin-1474777829-14747793823688936', 1, 1, 'SR', NULL, NULL, NULL),
(8962, '2016-09-25 12:56:22', NULL, NULL, 3221, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:56:22', 'admin-1474777829-14747793823688936', 1, 1, 'SR', NULL, NULL, NULL),
(8963, '2016-09-25 13:01:49', NULL, NULL, 3222, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:01:49', 'admin-1474777829-14747797092741722', 1, 0, '', NULL, NULL, NULL),
(8964, '2016-09-25 13:01:49', NULL, NULL, 3222, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:01:49', 'admin-1474777829-14747797092741722', 1, 0, '', NULL, NULL, NULL),
(8965, '2016-09-25 13:01:49', NULL, NULL, 3222, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:01:49', 'admin-1474777829-14747797092741722', 1, 0, '', NULL, NULL, NULL),
(8966, '2016-09-25 13:03:36', NULL, NULL, 3222, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:03:36', 'admin-1474777829-14747798167345624', 1, 0, '', NULL, NULL, NULL),
(8967, '2016-09-25 13:03:36', NULL, NULL, 3222, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:03:36', 'admin-1474777829-14747798167345624', 1, 0, '', NULL, NULL, NULL),
(8968, '2016-09-25 13:04:57', NULL, NULL, 3223, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:04:57', 'admin-1474777829-1474779896961958', 1, 0, '', NULL, NULL, NULL),
(8969, '2016-09-25 13:04:57', NULL, NULL, 3223, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:04:57', 'admin-1474777829-1474779896961958', 1, 0, '', NULL, NULL, NULL),
(8970, '2016-09-25 13:04:57', NULL, NULL, 3223, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:04:57', 'admin-1474777829-1474779896961958', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(8971, '2016-09-25 13:04:57', NULL, NULL, 3223, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:04:57', 'admin-1474777829-1474779896961958', 1, 1, 'SR', NULL, NULL, NULL),
(8972, '2016-09-25 13:06:10', NULL, NULL, 3224, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:06:10', 'admin-1474777829-14747799698616081', 1, 0, '', NULL, NULL, NULL),
(8973, '2016-09-25 13:10:16', NULL, NULL, 3225, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:10:16', 'admin-1474777829-1474780216104396', 1, 0, '', NULL, NULL, NULL),
(8974, '2016-09-25 13:10:16', NULL, NULL, 3225, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:10:16', 'admin-1474777829-1474780216104396', 1, 0, '', NULL, NULL, NULL),
(8975, '2016-09-25 13:10:16', NULL, NULL, 3225, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:10:16', 'admin-1474777829-1474780216104396', 1, 1, 'SR', NULL, NULL, NULL),
(8976, '2016-09-25 13:15:21', NULL, NULL, 3222, 0, 82, '82', 'Set Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:15:21', 'admin-1474780224-1474780521317702', 1, 1, 'SR', NULL, NULL, NULL),
(8977, '2016-09-25 13:17:48', NULL, NULL, 3222, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:17:48', 'admin-1474780224-14747806685546281', 1, 0, '', NULL, NULL, NULL),
(8978, '2016-09-25 13:28:09', NULL, NULL, 3226, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:28:09', 'admin-1474780224-14747812895668313', 1, 0, '', NULL, NULL, NULL),
(8979, '2016-09-25 13:28:09', NULL, NULL, 3226, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:28:09', 'admin-1474780224-14747812895668313', 1, 1, 'SR', NULL, NULL, NULL),
(8980, '2016-09-25 13:28:09', NULL, NULL, 3226, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:28:09', 'admin-1474780224-14747812895668313', 1, 1, 'SR', NULL, NULL, NULL),
(8981, '2016-09-25 13:28:09', NULL, NULL, 3226, 0, 84, '84', 'Set Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:28:09', 'admin-1474780224-14747812895668313', 1, 1, 'SR', NULL, NULL, NULL),
(8982, '2016-09-25 13:28:09', NULL, NULL, 3226, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:28:09', 'admin-1474780224-14747812895668313', 1, 1, 'SR', NULL, NULL, NULL),
(8983, '2016-09-25 14:08:44', NULL, NULL, 3230, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 14:08:44', 'admin-1474781409-14747837238977830', 1, 1, 'SR', NULL, NULL, NULL),
(8984, '2016-09-25 14:27:26', NULL, NULL, 3231, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 14:27:26', 'admin-1474781409-14747848461569440', 1, 1, 'SR', NULL, NULL, NULL),
(8985, '2016-09-25 14:27:26', NULL, NULL, 3231, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 14:27:26', 'admin-1474781409-14747848461569440', 1, 1, 'SR', NULL, NULL, NULL),
(8986, '2016-09-25 14:27:26', NULL, NULL, 3231, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 14:27:26', 'admin-1474781409-14747848461569440', 1, 1, 'SR', NULL, NULL, NULL),
(8987, '2016-09-25 14:27:26', NULL, NULL, 3231, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 14:27:26', 'admin-1474781409-14747848461569440', 1, 0, '', NULL, NULL, NULL),
(8988, '2016-09-25 14:27:38', NULL, NULL, 3232, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 14:27:38', 'admin-1474781409-1474784858550408', 1, 0, '', NULL, NULL, NULL),
(8989, '2016-09-25 14:27:38', NULL, NULL, 3232, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 14:27:38', 'admin-1474781409-1474784858550408', 1, 0, '', NULL, NULL, NULL),
(8990, '2016-09-25 14:27:50', NULL, NULL, 3231, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 14:27:50', 'admin-1474781409-14747848701755757', 1, 1, 'SR', NULL, NULL, NULL),
(8991, '2016-09-25 15:18:51', NULL, NULL, 3237, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 15:18:51', 'admin-1474781409-14747879313198728', 1, 0, '', 1, NULL, NULL),
(8992, '2016-09-25 14:28:30', NULL, NULL, 3232, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 14:28:30', 'admin-1474781409-14747849104286398', 1, 1, 'SR', NULL, NULL, NULL),
(8993, '2016-09-25 14:56:04', NULL, NULL, 3233, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 14:56:04', 'admin-1474781409-14747865642612774', 1, 0, '', NULL, NULL, NULL),
(8994, '2016-09-25 14:56:04', NULL, NULL, 3233, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 14:56:04', 'admin-1474781409-14747865642612774', 1, 0, '', NULL, NULL, NULL),
(8995, '2016-09-25 14:28:30', NULL, NULL, 3232, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 14:28:30', 'admin-1474781409-14747849104286398', 1, 1, 'SR', NULL, NULL, NULL),
(8996, '2016-09-25 15:20:27', NULL, NULL, 3238, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 15:20:27', 'admin-1474781409-1474788027090625', 1, 0, '', NULL, NULL, NULL),
(8997, '2016-09-25 14:59:37', NULL, NULL, 3236, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 14:59:37', 'admin-1474781409-14747867775658413', 1, 0, '', NULL, NULL, NULL),
(8998, '2016-09-25 14:58:48', NULL, NULL, 3235, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 14:58:48', 'admin-1474781409-14747867283838129', 1, 0, '', 1, NULL, NULL),
(8999, '2016-09-25 14:58:48', NULL, NULL, 3235, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 14:58:48', 'admin-1474781409-14747867283838129', 1, 1, 'SR', 1, NULL, NULL),
(9000, '2016-09-25 14:57:24', NULL, NULL, 3234, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 14:57:24', 'admin-1474781409-14747866442958473', 1, 0, '', NULL, NULL, NULL),
(9001, '2016-09-25 12:11:44', NULL, NULL, 3215, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:11:44', 'admin-1474772709-14747767044052950', 1, 0, '', NULL, NULL, NULL),
(9002, '2016-09-25 10:25:25', NULL, NULL, 3206, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 10:25:25', 'admin-1474768312-14747703257674198', 1, 0, '', NULL, NULL, NULL),
(9003, '2016-09-25 10:48:07', NULL, NULL, 3207, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 10:48:07', 'admin-1474768312-14747716868742327', 1, 0, '', NULL, NULL, NULL),
(9004, '2016-09-25 10:48:07', NULL, NULL, 3207, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 10:48:07', 'admin-1474768312-14747716868742327', 1, 0, '', NULL, NULL, NULL),
(9005, '2016-09-25 10:48:07', NULL, NULL, 3207, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 10:48:07', 'admin-1474768312-14747716868742327', 1, 1, 'SR', NULL, NULL, NULL),
(9006, '2016-09-25 11:04:22', NULL, NULL, 3208, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 11:04:22', 'admin-1474768312-14747726626418614', 1, 1, 'SR', NULL, NULL, NULL),
(9007, '2016-09-25 11:04:22', NULL, NULL, 3208, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 11:04:22', 'admin-1474768312-14747726626418614', 1, 1, 'SR', NULL, NULL, NULL),
(9008, '2016-09-25 11:04:22', NULL, NULL, 3208, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 11:04:22', 'admin-1474768312-14747726626418614', 1, 0, '', NULL, NULL, NULL),
(9009, '2016-09-25 11:05:05', NULL, NULL, 3209, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 11:05:05', 'admin-1474768312-14747727052321197', 1, 0, '', NULL, NULL, NULL),
(9010, '2016-09-25 11:05:05', NULL, NULL, 3209, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 11:05:05', 'admin-1474768312-14747727052321197', 1, 0, '', NULL, NULL, NULL),
(9011, '2016-09-25 11:05:05', NULL, NULL, 3209, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 11:05:05', 'admin-1474768312-14747727052321197', 1, 0, '', NULL, NULL, NULL),
(9012, '2016-09-25 11:06:21', NULL, NULL, 3209, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 11:06:21', 'admin-1474772709-14747727816327287', 1, 1, 'SR', NULL, NULL, NULL),
(9013, '2016-09-25 11:06:21', NULL, NULL, 3209, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 11:06:21', 'admin-1474772709-14747727816327287', 1, 1, 'SR', NULL, NULL, NULL),
(9014, '2016-09-25 11:08:23', NULL, NULL, 3210, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 11:08:23', 'admin-1474772709-14747729034737659', 1, 1, 'SR', NULL, NULL, NULL),
(9015, '2016-09-25 11:08:23', NULL, NULL, 3210, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 11:08:23', 'admin-1474772709-14747729034737659', 1, 1, 'SR', NULL, NULL, NULL),
(9016, '2016-09-25 11:13:22', NULL, NULL, 3211, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 11:13:22', 'admin-1474772709-14747732025145797', 1, 0, '', 1, NULL, NULL),
(9017, '2016-09-25 11:27:06', NULL, NULL, 3212, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 11:27:06', 'admin-1474772709-14747740260833082', 1, 1, 'SR', NULL, NULL, NULL),
(9018, '2016-09-25 11:27:06', NULL, NULL, 3212, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 11:27:06', 'admin-1474772709-14747740260833082', 1, 1, 'SR', NULL, NULL, NULL),
(9019, '2016-09-25 11:27:06', NULL, NULL, 3212, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 11:27:06', 'admin-1474772709-14747740260833082', 1, 0, '', NULL, NULL, NULL),
(9020, '2016-09-25 11:51:26', NULL, NULL, 3213, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 11:51:26', 'admin-1474772709-14747754862046811', 1, 0, '', NULL, NULL, NULL),
(9021, '2016-09-25 14:58:48', NULL, NULL, 3235, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 14:58:48', 'admin-1474781409-14747867283838129', 1, 1, 'SR', 1, NULL, NULL),
(9022, '2016-09-25 14:56:38', NULL, NULL, 3233, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 14:56:38', 'admin-1474781409-1474786598656959', 1, 1, 'SR', NULL, NULL, NULL),
(9023, '2016-09-25 14:56:38', NULL, NULL, 3233, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 14:56:38', 'admin-1474781409-1474786598656959', 1, 1, 'SR', NULL, NULL, NULL),
(9024, '2016-09-25 13:42:47', NULL, NULL, 3222, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:42:47', 'admin-1474781409-14747821676171440', 1, 0, '', NULL, NULL, NULL),
(9025, '2016-09-25 14:08:44', NULL, NULL, 3230, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 14:08:44', 'admin-1474781409-14747837238977830', 1, 0, '', NULL, NULL, NULL),
(9026, '2016-09-25 10:02:00', NULL, NULL, 3202, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 10:02:00', 'admin-1474768312-14747689200395255', 1, 1, 'SR', NULL, NULL, NULL),
(9027, '2016-09-25 10:02:00', NULL, NULL, 3202, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 10:02:00', 'admin-1474768312-14747689200395255', 1, 1, 'SR', NULL, NULL, NULL),
(9028, '2016-09-25 10:10:57', NULL, NULL, 3203, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 10:10:57', 'admin-1474768312-14747694567993324', 1, 1, 'SR', NULL, NULL, NULL),
(9029, '2016-09-25 10:10:57', NULL, NULL, 3203, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 10:10:57', 'admin-1474768312-14747694567993324', 1, 1, 'SR', NULL, NULL, NULL),
(9030, '2016-09-25 10:20:40', NULL, NULL, 3204, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 10:20:40', 'admin-1474768312-14747700405233873', 1, 0, '', NULL, NULL, NULL),
(9031, '2016-09-25 10:20:40', NULL, NULL, 3204, 0, 153, '87', 'Big Breakfast ', 'change to fried egg', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 10:20:40', 'admin-1474768312-14747700405233873', 1, 0, '', NULL, NULL, NULL),
(9032, '2016-09-25 13:42:47', NULL, NULL, 3222, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:42:47', 'admin-1474781409-14747821676171440', 1, 0, '', NULL, NULL, NULL),
(9033, '2016-09-25 13:43:44', NULL, NULL, 3229, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:43:44', 'admin-1474781409-147478222434162', 1, 1, 'SR', NULL, NULL, NULL),
(9034, '2016-09-25 13:28:09', NULL, NULL, 3226, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:28:09', 'admin-1474780224-14747812895668313', 1, 0, '', NULL, NULL, NULL),
(9035, '2016-09-25 09:51:44', NULL, NULL, 3201, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:51:44', 'admin-1474764843-14747683046239253', 1, 0, '', NULL, NULL, NULL),
(9036, '2016-09-25 13:42:47', NULL, NULL, 3222, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:42:47', 'admin-1474781409-14747821676171440', 1, 0, '', NULL, NULL, NULL),
(9037, '2016-09-25 13:29:30', NULL, NULL, 3228, 0, 214, '148', 'Set Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:29:30', 'admin-1474780224-14747813706634595', 1, 0, '', NULL, NULL, NULL),
(9038, '2016-09-25 13:29:30', NULL, NULL, 3228, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:29:30', 'admin-1474780224-14747813706634595', 1, 0, '', NULL, NULL, NULL),
(9039, '2016-09-25 13:29:09', NULL, NULL, 3227, 0, 224, '158', 'Set Garlic Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:29:09', 'admin-1474780224-14747813495669468', 1, 0, '', NULL, NULL, NULL),
(9040, '2016-09-25 13:29:09', NULL, NULL, 3227, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:29:09', 'admin-1474780224-14747813495669468', 1, 0, '', NULL, NULL, NULL),
(9041, '2016-09-25 13:28:16', NULL, NULL, 3226, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 13:28:16', 'admin-1474780224-1474781296812402', 1, 0, '', NULL, NULL, NULL),
(9042, '2016-09-25 12:51:33', NULL, NULL, 3220, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:51:33', 'admin-1474777829-14747790930687493', 1, 1, 'SR', NULL, NULL, NULL),
(9043, '2016-09-25 12:27:20', NULL, NULL, 3217, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:27:20', 'admin-1474772709-14747776404534728', 1, 1, 'SR', NULL, NULL, NULL),
(9044, '2016-09-25 12:27:20', NULL, NULL, 3217, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:27:20', 'admin-1474772709-14747776404534728', 1, 0, '', NULL, NULL, NULL),
(9045, '2016-09-25 12:26:17', NULL, NULL, 3217, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:26:17', 'admin-1474772709-14747775770564845', 1, 0, '', NULL, NULL, NULL),
(9046, '2016-09-25 12:18:43', NULL, NULL, 3216, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:18:43', 'admin-1474772709-14747771233574496', 1, 1, 'SR', NULL, NULL, NULL),
(9047, '2016-09-25 12:18:43', NULL, NULL, 3216, 0, 82, '82', 'Set Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:18:43', 'admin-1474772709-14747771233574496', 1, 1, 'SR', NULL, NULL, NULL),
(9048, '2016-09-25 12:18:43', NULL, NULL, 3216, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:18:43', 'admin-1474772709-14747771233574496', 1, 1, 'SR', NULL, NULL, NULL),
(9049, '2016-09-25 10:02:00', NULL, NULL, 3202, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 10:02:00', 'admin-1474768312-14747689200395255', 1, 1, 'SR', NULL, NULL, NULL),
(9050, '2016-09-25 12:02:01', NULL, NULL, 3214, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:02:01', 'admin-1474772709-14747761208585423', 1, 1, 'SR', NULL, NULL, NULL),
(9051, '2016-09-25 12:11:44', NULL, NULL, 3215, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:11:44', 'admin-1474772709-14747767044052950', 1, 1, 'SR', NULL, NULL, NULL),
(9052, '2016-09-25 12:01:25', NULL, NULL, 3214, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:01:25', 'admin-1474772709-14747760852178843', 1, 0, '', NULL, NULL, NULL),
(9053, '2016-09-25 12:02:01', NULL, NULL, 3214, 0, 211, '145', 'Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:02:01', 'admin-1474772709-14747761208585423', 1, 0, '', NULL, NULL, NULL),
(9054, '2016-09-25 12:02:01', NULL, NULL, 3214, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:02:01', 'admin-1474772709-14747761208585423', 1, 1, 'SR', NULL, NULL, NULL),
(9055, '2016-09-25 10:20:40', NULL, NULL, 3204, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 10:20:40', 'admin-1474768312-14747700405233873', 1, 0, '', NULL, NULL, NULL),
(9056, '2016-09-25 10:20:40', NULL, NULL, 3204, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 10:20:40', 'admin-1474768312-14747700405233873', 1, 0, '', NULL, NULL, NULL),
(9057, '2016-09-25 10:25:10', NULL, NULL, 3205, 0, 181, '116', 'Open Food ', '2 fried egg', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 10:25:10', 'admin-1474768312-14747703104851514', 1, 0, '', NULL, NULL, NULL),
(9058, '2016-09-25 10:20:40', NULL, NULL, 3204, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 10:20:40', 'admin-1474768312-14747700405233873', 1, 1, 'SR', NULL, NULL, NULL),
(9059, '2016-09-25 12:26:17', NULL, NULL, 3217, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 12:26:17', 'admin-1474772709-14747775770564845', 1, 0, '', NULL, NULL, NULL),
(9060, '2016-09-25 10:02:00', NULL, NULL, 3202, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 10:02:00', 'admin-1474768312-14747689200395255', 1, 1, 'SR', NULL, NULL, NULL),
(9061, '2016-09-25 10:02:00', NULL, NULL, 3202, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 10:02:00', 'admin-1474768312-14747689200395255', 1, 0, '', NULL, NULL, NULL),
(9062, '2016-09-25 10:02:00', NULL, NULL, 3202, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 10:02:00', 'admin-1474768312-14747689200395255', 1, 0, '', NULL, NULL, NULL),
(9063, '2016-09-25 09:07:52', NULL, NULL, 3198, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:07:52', 'admin-1474764843-1474765671985918', 1, 0, '', NULL, NULL, NULL),
(9064, '2016-09-25 09:10:48', NULL, NULL, 3198, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:10:48', 'admin-1474764843-14747658481581853', 1, 1, 'SR', NULL, NULL, NULL),
(9065, '2016-09-25 09:10:48', NULL, NULL, 3198, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:10:48', 'admin-1474764843-14747658481581853', 1, 1, 'SR', NULL, NULL, NULL),
(9066, '2016-09-25 09:10:48', NULL, NULL, 3198, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:10:48', 'admin-1474764843-14747658481581853', 1, 1, 'SR', NULL, NULL, NULL),
(9067, '2016-09-25 09:10:48', NULL, NULL, 3198, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:10:48', 'admin-1474764843-14747658481581853', 1, 1, 'SR', NULL, NULL, NULL),
(9068, '2016-09-25 09:10:48', NULL, NULL, 3198, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:10:48', 'admin-1474764843-14747658481581853', 1, 1, 'SR', NULL, NULL, NULL),
(9069, '2016-09-25 09:10:48', NULL, NULL, 3198, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:10:48', 'admin-1474764843-14747658481581853', 1, 1, 'SR', NULL, NULL, NULL),
(9070, '2016-09-25 09:20:11', NULL, NULL, 3199, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:20:11', 'admin-1474764843-14747664109037480', 1, 1, 'SR', NULL, NULL, NULL),
(9071, '2016-09-25 09:20:11', NULL, NULL, 3199, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:20:11', 'admin-1474764843-14747664109037480', 1, 1, 'SR', NULL, NULL, NULL),
(9072, '2016-09-25 09:20:11', NULL, NULL, 3199, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:20:11', 'admin-1474764843-14747664109037480', 1, 0, '', NULL, NULL, NULL),
(9073, '2016-09-25 09:20:11', NULL, NULL, 3199, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:20:11', 'admin-1474764843-14747664109037480', 1, 0, '', NULL, NULL, NULL),
(9074, '2016-09-25 09:37:03', NULL, NULL, 3200, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:37:03', 'admin-1474764843-14747674229377693', 1, 0, '', NULL, NULL, NULL),
(9075, '2016-09-25 09:37:03', NULL, NULL, 3200, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:37:03', 'admin-1474764843-14747674229377693', 1, 0, '', NULL, NULL, NULL),
(9076, '2016-09-25 09:37:18', NULL, NULL, 3200, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:37:18', 'admin-1474764843-14747674386251347', 1, 0, '', NULL, NULL, NULL),
(9077, '2016-09-25 09:37:18', NULL, NULL, 3200, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:37:18', 'admin-1474764843-14747674386251347', 1, 1, 'SR', NULL, NULL, NULL),
(9078, '2016-09-25 09:37:23', NULL, NULL, 3200, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:37:23', 'admin-1474764843-14747674436327561', 1, 1, 'SR', NULL, NULL, NULL),
(9079, '2016-09-25 10:02:00', NULL, NULL, 3202, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 10:02:00', 'admin-1474768312-14747689200395255', 1, 0, '', NULL, NULL, NULL),
(9080, '2016-09-25 09:51:44', NULL, NULL, 3201, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:51:44', 'admin-1474764843-14747683046239253', 1, 1, 'SR', NULL, NULL, NULL),
(9081, '2016-09-25 09:51:44', NULL, NULL, 3201, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:51:44', 'admin-1474764843-14747683046239253', 1, 1, 'SR', NULL, NULL, NULL),
(9082, '2016-09-25 09:51:44', NULL, NULL, 3201, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:51:44', 'admin-1474764843-14747683046239253', 1, 0, '', NULL, NULL, NULL),
(9083, '2016-09-25 09:51:44', NULL, NULL, 3201, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:51:44', 'admin-1474764843-14747683046239253', 1, 0, '', NULL, NULL, NULL),
(9084, '2016-09-25 09:46:33', NULL, NULL, 3198, 0, 153, '87', 'Big Breakfast ', 'Takeaway', 'Meals', 'Morning Bites ', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:46:33', 'admin-1474764843-14747679934648120', 1, 0, '', NULL, NULL, NULL),
(9085, '2016-09-25 09:51:44', NULL, NULL, 3201, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:51:44', 'admin-1474764843-14747683046239253', 1, 0, '', NULL, NULL, NULL),
(9086, '2016-09-25 10:02:00', NULL, NULL, 3202, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 10:02:00', 'admin-1474768312-14747689200395255', 1, 0, '', NULL, NULL, NULL),
(9087, '2016-09-25 09:46:33', NULL, NULL, 3198, 0, 153, '87', 'Big Breakfast ', 'Takeaway', 'Meals', 'Morning Bites ', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:46:33', 'admin-1474764843-14747679934648120', 1, 0, '', NULL, NULL, NULL),
(9088, '2016-09-25 09:46:33', NULL, NULL, 3198, 0, 80, '80', 'Oriental Chicken Salad', 'Takeaway', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:46:33', 'admin-1474764843-14747679934648120', 1, 1, 'SR', NULL, NULL, NULL),
(9089, '2016-09-25 09:07:52', NULL, NULL, 3198, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:07:52', 'admin-1474764843-1474765671985918', 1, 0, '', NULL, NULL, NULL),
(9090, '2016-09-25 09:07:52', NULL, NULL, 3198, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:07:52', 'admin-1474764843-1474765671985918', 1, 0, '', NULL, NULL, NULL),
(9091, '2016-09-25 09:07:52', NULL, NULL, 3198, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:07:52', 'admin-1474764843-1474765671985918', 1, 0, '', NULL, NULL, NULL),
(9092, '2016-09-25 09:07:52', NULL, NULL, 3198, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:07:52', 'admin-1474764843-1474765671985918', 1, 0, '', NULL, NULL, NULL),
(9093, '2016-09-25 09:07:52', NULL, NULL, 3198, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474803087', 'admin', '2016-09-25 09:07:52', 'admin-1474764843-1474765671985918', 1, 0, '', NULL, NULL, NULL),
(9094, '2016-09-26 13:24:52', NULL, NULL, 3273, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 13:24:52', 'admin-1474859119-14748674923875425', 1, 1, 'SR', NULL, NULL, NULL),
(9095, '2016-09-26 14:10:37', NULL, NULL, 3274, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 14:10:37', 'admin-1474859119-1474870237482671', 1, 1, 'SR', 1, NULL, '10.0'),
(9096, '2016-09-26 14:47:23', NULL, NULL, 3275, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 14:47:23', 'admin-1474859119-14748724435878745', 1, 0, '', 1, NULL, NULL),
(9097, '2016-09-26 14:47:23', NULL, NULL, 3275, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 14:47:23', 'admin-1474859119-14748724435878745', 1, 1, 'SR', 1, NULL, NULL),
(9098, '2016-09-26 14:50:42', NULL, NULL, 3276, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 14:50:42', 'admin-1474859119-1474872642101251', 1, 1, 'SR', 1, NULL, NULL),
(9099, '2016-09-26 12:56:00', NULL, NULL, 3266, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 12:56:00', 'admin-1474859119-14748657598639589', 1, 1, 'SR', NULL, NULL, NULL),
(9100, '2016-09-26 12:56:00', NULL, NULL, 3266, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 12:56:00', 'admin-1474859119-14748657598639589', 1, 1, 'SR', NULL, NULL, NULL),
(9101, '2016-09-26 12:56:00', NULL, NULL, 3266, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 12:56:00', 'admin-1474859119-14748657598639589', 1, 1, 'SR', NULL, NULL, NULL),
(9102, '2016-09-26 12:57:15', NULL, NULL, 3267, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 12:57:15', 'admin-1474859119-1474865835282371', 1, 1, 'SR', NULL, NULL, NULL),
(9103, '2016-09-26 12:57:15', NULL, NULL, 3267, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 12:57:15', 'admin-1474859119-1474865835282371', 1, 1, 'SR', NULL, NULL, NULL),
(9104, '2016-09-26 13:07:22', NULL, NULL, 3272, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 13:07:22', 'admin-1474859119-14748664422074681', 1, 1, 'SR', NULL, NULL, NULL),
(9105, '2016-09-26 13:24:52', NULL, NULL, 3273, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 13:24:52', 'admin-1474859119-14748674923875425', 1, 0, '', NULL, NULL, NULL),
(9106, '2016-09-26 13:24:52', NULL, NULL, 3273, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 13:24:52', 'admin-1474859119-14748674923875425', 1, 1, 'SR', NULL, NULL, NULL),
(9107, '2016-09-26 13:24:52', NULL, NULL, 3273, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 13:24:52', 'admin-1474859119-14748674923875425', 1, 0, '', NULL, NULL, NULL),
(9108, '2016-09-26 13:07:22', NULL, NULL, 3272, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 13:07:22', 'admin-1474859119-14748664422074681', 1, 1, 'SR', NULL, NULL, NULL),
(9109, '2016-09-26 12:59:23', NULL, NULL, 3270, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 12:59:23', 'admin-1474859119-14748659636878261', 1, 1, 'SR', NULL, NULL, NULL),
(9110, '2016-09-26 12:59:23', NULL, NULL, 3270, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 12:59:23', 'admin-1474859119-14748659636878261', 1, 1, 'SR', NULL, NULL, NULL),
(9111, '2016-09-26 13:00:29', NULL, NULL, 3271, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 13:00:29', 'admin-1474859119-14748660292389319', 1, 1, 'SR', NULL, NULL, NULL),
(9112, '2016-09-26 12:58:42', NULL, NULL, 3269, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 12:58:42', 'admin-1474859119-14748659218474972', 1, 1, 'SR', NULL, NULL, NULL),
(9113, '2016-09-26 12:56:00', NULL, NULL, 3266, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 12:56:00', 'admin-1474859119-14748657598639589', 1, 1, 'SR', NULL, NULL, NULL),
(9114, '2016-09-26 12:56:00', NULL, NULL, 3266, 0, 195, '130', 'Cucumber Lime Soda BOFO', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 12:56:00', 'admin-1474859119-14748657598639589', 1, 0, '', NULL, NULL, NULL),
(9115, '2016-09-26 12:48:10', NULL, NULL, 3264, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 12:48:10', 'admin-1474859119-14748652897738998', 1, 1, 'SR', NULL, NULL, NULL),
(9116, '2016-09-26 09:11:46', NULL, NULL, 3256, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 09:11:46', 'admin-1474851543-14748523062337564', 1, 0, '', NULL, NULL, NULL),
(9117, '2016-09-26 09:30:27', NULL, NULL, 3257, 0, 156, '90', 'Cheese Omelet', 'add one more egg', 'Meals', 'Morning Bites ', 1, 13.50, 13.5000, 0.0000, 13.50, 1, '27', 1, '1474859119', 'admin', '2016-09-26 09:30:27', 'admin-1474851543-14748534274447566', 1, 0, '', NULL, NULL, NULL),
(9118, '2016-09-26 09:30:27', NULL, NULL, 3257, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 09:30:27', 'admin-1474851543-14748534274447566', 1, 0, '', NULL, NULL, NULL),
(9119, '2016-09-26 09:41:28', NULL, NULL, 3258, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 09:41:28', 'admin-1474851543-14748540887013161', 1, 1, 'SR', 1, NULL, NULL),
(9120, '2016-09-26 09:41:28', NULL, NULL, 3258, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 09:41:28', 'admin-1474851543-14748540887013161', 1, 1, 'SR', 1, NULL, NULL),
(9121, '2016-09-26 10:10:26', NULL, NULL, 3259, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 10:10:26', 'admin-1474851543-14748558257983067', 1, 0, '', NULL, NULL, NULL),
(9122, '2016-09-26 10:10:26', NULL, NULL, 3259, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 10:10:26', 'admin-1474851543-14748558257983067', 1, 0, '', NULL, NULL, NULL),
(9123, '2016-09-26 10:15:11', NULL, NULL, 3260, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 10:15:11', 'admin-1474851543-14748561112776734', 1, 1, 'SR', 1, NULL, NULL),
(9124, '2016-09-26 10:56:11', NULL, NULL, 3261, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 10:56:11', 'admin-1474851543-14748585717457794', 1, 0, '', NULL, NULL, NULL),
(9125, '2016-09-26 10:56:11', NULL, NULL, 3261, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 10:56:11', 'admin-1474851543-14748585717457794', 1, 0, '', NULL, NULL, NULL),
(9126, '2016-09-26 10:56:11', NULL, NULL, 3261, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 10:56:11', 'admin-1474851543-14748585717457794', 1, 1, 'SR', NULL, NULL, NULL),
(9127, '2016-09-26 10:56:11', NULL, NULL, 3261, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 10:56:11', 'admin-1474851543-14748585717457794', 1, 1, 'SR', NULL, NULL, NULL),
(9128, '2016-09-26 11:05:13', NULL, NULL, 3262, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 11:05:13', 'admin-1474851543-1474859112844819', 1, 1, 'SR', NULL, NULL, NULL),
(9129, '2016-09-26 11:05:13', NULL, NULL, 3262, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 11:05:13', 'admin-1474851543-1474859112844819', 1, 1, 'SR', NULL, NULL, NULL),
(9130, '2016-09-26 11:05:13', NULL, NULL, 3262, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 11:05:13', 'admin-1474851543-1474859112844819', 1, 0, '', NULL, NULL, NULL),
(9131, '2016-09-26 11:32:17', NULL, NULL, 3263, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 11:32:17', 'admin-1474859119-14748607375945373', 1, 0, '', NULL, NULL, NULL),
(9132, '2016-09-26 12:49:32', NULL, NULL, 3265, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 12:49:32', 'admin-1474859119-14748653720541383', 1, 0, '', NULL, NULL, NULL),
(9133, '2016-09-26 12:49:38', NULL, NULL, 3265, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 12:49:38', 'admin-1474859119-14748653785133973', 1, 1, 'SR', NULL, NULL, NULL),
(9134, '2016-09-26 12:49:32', NULL, NULL, 3265, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 12:49:32', 'admin-1474859119-14748653720541383', 1, 0, '', NULL, NULL, NULL),
(9135, '2016-09-26 12:49:32', NULL, NULL, 3265, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 12:49:32', 'admin-1474859119-14748653720541383', 1, 0, '', NULL, NULL, NULL),
(9136, '2016-09-26 11:32:35', NULL, NULL, 3263, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 11:32:35', 'admin-1474859119-1474860754803925', 1, 0, '', NULL, NULL, NULL),
(9137, '2016-09-26 12:48:10', NULL, NULL, 3264, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 12:48:10', 'admin-1474859119-14748652897738998', 1, 1, 'SR', NULL, NULL, NULL),
(9138, '2016-09-26 12:49:38', NULL, NULL, 3265, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 12:49:38', 'admin-1474859119-14748653785133973', 1, 1, 'SR', NULL, NULL, NULL),
(9139, '2016-09-26 12:48:10', NULL, NULL, 3264, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 12:48:10', 'admin-1474859119-14748652897738998', 1, 1, 'SR', NULL, NULL, NULL),
(9140, '2016-09-26 11:32:22', NULL, NULL, 3263, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 11:32:22', 'admin-1474859119-14748607423079674', 1, 1, 'SR', NULL, NULL, NULL),
(9141, '2016-09-26 11:32:22', NULL, NULL, 3263, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 11:32:22', 'admin-1474859119-14748607423079674', 1, 1, 'SR', NULL, NULL, NULL),
(9142, '2016-09-26 11:32:17', NULL, NULL, 3263, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 11:32:17', 'admin-1474859119-14748607375945373', 1, 0, '', NULL, NULL, NULL),
(9143, '2016-09-26 09:11:46', NULL, NULL, 3256, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 09:11:46', 'admin-1474851543-14748523062337564', 1, 1, 'SR', NULL, NULL, NULL),
(9144, '2016-09-26 09:09:29', NULL, NULL, 3255, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 09:09:29', 'admin-1474851543-14748521689116470', 1, 0, '', NULL, NULL, NULL),
(9145, '2016-09-26 09:11:46', NULL, NULL, 3256, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 09:11:46', 'admin-1474851543-14748523062337564', 1, 1, 'SR', NULL, NULL, NULL),
(9146, '2016-09-26 09:09:29', NULL, NULL, 3255, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1474859119', 'admin', '2016-09-26 09:09:29', 'admin-1474851543-14748521689116470', 1, 0, '', NULL, NULL, NULL),
(9147, '2016-09-28 11:57:10', NULL, NULL, 3279, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 11:57:10', 'admin-1475023641-14750350299691470', 1, 0, '', NULL, NULL, NULL),
(9148, '2016-09-28 11:57:10', NULL, NULL, 3279, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 11:57:10', 'admin-1475023641-14750350299691470', 1, 0, '', NULL, NULL, NULL),
(9149, '2016-09-28 11:58:39', NULL, NULL, 3279, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 11:58:39', 'admin-1475023641-1475035118907362', 1, 1, 'SR', NULL, NULL, NULL),
(9150, '2016-09-28 11:58:39', NULL, NULL, 3279, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 11:58:39', 'admin-1475023641-1475035118907362', 1, 1, 'SR', NULL, NULL, NULL),
(9151, '2016-09-28 12:26:04', NULL, NULL, 3280, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 12:26:04', 'admin-1475023641-14750367643751637', 1, 0, '', NULL, NULL, NULL),
(9152, '2016-09-28 12:26:04', NULL, NULL, 3280, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 12:26:04', 'admin-1475023641-14750367643751637', 1, 0, '', NULL, NULL, NULL),
(9153, '2016-09-28 12:27:23', NULL, NULL, 3280, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 12:27:23', 'admin-1475023641-1475036843485775', 1, 1, 'SR', NULL, NULL, NULL),
(9154, '2016-09-28 12:27:35', NULL, NULL, 3280, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 12:27:35', 'admin-1475023641-14750368552425147', 1, 1, 'SR', NULL, NULL, NULL),
(9155, '2016-09-28 12:39:36', NULL, NULL, 3281, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 12:39:36', 'admin-1475023641-14750375763146283', 1, 0, '', NULL, NULL, NULL),
(9156, '2016-09-28 12:39:36', NULL, NULL, 3281, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 12:39:36', 'admin-1475023641-14750375763146283', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(9157, '2016-09-28 13:37:44', NULL, NULL, 3282, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 13:37:44', 'admin-1475023641-14750410641751942', 1, 0, '', NULL, NULL, NULL),
(9158, '2016-09-28 13:37:44', NULL, NULL, 3282, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 13:37:44', 'admin-1475023641-14750410641751942', 1, 0, '', NULL, NULL, NULL),
(9159, '2016-09-28 13:37:44', NULL, NULL, 3282, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 13:37:44', 'admin-1475023641-14750410641751942', 1, 0, '', NULL, NULL, NULL),
(9160, '2016-09-28 13:48:29', NULL, NULL, 3280, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 13:48:29', 'admin-1475023641-14750417088438858', 1, 1, 'SR', NULL, NULL, NULL),
(9161, '2016-09-28 14:26:36', NULL, NULL, 3283, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 14:26:36', 'admin-1475023641-14750439963325527', 1, 1, 'SR', NULL, NULL, NULL),
(9162, '2016-09-28 15:09:44', NULL, NULL, 3284, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 15:09:44', 'admin-1475023641-14750465847726262', 1, 0, '', NULL, NULL, NULL),
(9163, '2016-09-28 16:27:04', NULL, NULL, 3286, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 16:27:04', 'admin-1475023641-1475051223910224', 1, 1, 'SR', NULL, NULL, NULL),
(9164, '2016-09-28 15:42:48', NULL, NULL, 3285, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 15:42:48', 'admin-1475023641-14750485684973583', 1, 1, 'SR', NULL, NULL, NULL),
(9165, '2016-09-28 15:43:50', NULL, NULL, 3285, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 15:43:50', 'admin-1475023641-14750486304905955', 1, 0, '', NULL, NULL, NULL),
(9166, '2016-09-28 16:26:57', NULL, NULL, 3286, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 16:26:57', 'admin-1475023641-14750512169171158', 1, 1, 'SR', NULL, NULL, NULL),
(9167, '2016-09-28 09:44:54', NULL, NULL, 3277, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 09:44:54', 'admin-1475023641-14750270945864956', 1, 1, 'SR', NULL, NULL, NULL),
(9168, '2016-09-28 11:57:10', NULL, NULL, 3279, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 11:57:10', 'admin-1475023641-14750350299691470', 1, 0, '', NULL, NULL, NULL),
(9169, '2016-09-28 11:50:31', NULL, NULL, 3278, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475053695', 'admin', '2016-09-28 11:50:31', 'admin-1475023641-14750346317816258', 1, 1, 'SR', NULL, NULL, NULL),
(9170, '2016-09-28 09:44:49', NULL, NULL, 3277, 0, 156, '90', 'Cheese Omelet', 'extra 1 egg', 'Meals', 'Morning Bites ', 1, 13.50, 13.5000, 0.0000, 13.50, 1, '27', 1, '1475053695', 'admin', '2016-09-28 09:44:49', 'admin-1475023641-14750270895038977', 1, 0, '', NULL, NULL, NULL),
(9171, '2016-09-29 17:06:25', NULL, NULL, 3322, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 17:06:25', 'admin-1475123385-14751399854895960', 1, 0, '', NULL, NULL, '10.0'),
(9172, '2016-09-29 17:12:19', NULL, NULL, 3323, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 17:12:19', 'admin-1475123385-14751403393446379', 1, 0, '', NULL, NULL, NULL),
(9173, '2016-09-29 17:12:19', NULL, NULL, 3323, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 17:12:19', 'admin-1475123385-14751403393446379', 1, 0, '', NULL, NULL, NULL),
(9174, '2016-09-29 17:12:34', NULL, NULL, 3323, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 17:12:34', 'admin-1475123385-14751403544306273', 1, 1, 'SR', NULL, NULL, NULL),
(9175, '2016-09-29 17:12:34', NULL, NULL, 3323, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 17:12:34', 'admin-1475123385-14751403544306273', 1, 1, 'SR', NULL, NULL, NULL),
(9176, '2016-09-29 18:23:21', NULL, NULL, 3324, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 18:23:21', 'admin-1475144581-14751446012397822', 1, 0, '', NULL, NULL, NULL),
(9177, '2016-09-29 19:41:48', NULL, NULL, 3325, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 19:41:48', 'admin-1475144581-14751493084038775', 1, 1, 'SR', NULL, NULL, NULL),
(9178, '2016-09-29 19:41:48', NULL, NULL, 3325, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 19:41:48', 'admin-1475144581-14751493084038775', 1, 0, '', NULL, NULL, NULL),
(9179, '2016-09-29 14:05:14', NULL, NULL, 3306, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 14:05:14', 'admin-1475123385-1475129114338170', 1, 0, '', NULL, NULL, NULL),
(9180, '2016-09-29 14:05:14', NULL, NULL, 3306, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 14:05:14', 'admin-1475123385-1475129114338170', 1, 0, '', NULL, NULL, NULL),
(9181, '2016-09-29 14:06:51', NULL, NULL, 3307, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 14:06:51', 'admin-1475123385-14751292110207774', 1, 1, 'SR', NULL, NULL, NULL),
(9182, '2016-09-29 14:13:43', NULL, NULL, 3308, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 14:13:43', 'admin-1475123385-14751296230796725', 1, 1, 'SR', 1, NULL, NULL),
(9183, '2016-09-29 14:29:32', NULL, NULL, 3309, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 14:29:32', 'admin-1475123385-14751305721832461', 1, 1, 'SR', 1, NULL, NULL),
(9184, '2016-09-29 14:29:32', NULL, NULL, 3309, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 14:29:32', 'admin-1475123385-14751305721832461', 1, 1, 'SR', 1, NULL, NULL),
(9185, '2016-09-29 14:29:32', NULL, NULL, 3309, 0, 182, '117', 'Open Drinks ', '2.50', 'Cold Drinks', 'Fresh Juice', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 14:29:32', 'admin-1475123385-14751305721832461', 1, 0, '', 1, NULL, NULL),
(9186, '2016-09-29 14:30:41', NULL, NULL, 3311, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 14:30:41', 'admin-1475123385-1475130641626398', 1, 1, 'SR', NULL, NULL, NULL),
(9187, '2016-09-29 14:39:02', NULL, NULL, 3312, 0, 182, '117', 'Open Drinks ', 'latte', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 14:39:02', 'admin-1475123385-14751311421715777', 1, 0, '', 1, NULL, NULL),
(9188, '2016-09-29 15:36:10', NULL, NULL, 3313, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 15:36:10', 'admin-1475123385-1475134570107390', 1, 1, 'SR', NULL, NULL, NULL),
(9189, '2016-09-29 15:36:10', NULL, NULL, 3313, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 15:36:10', 'admin-1475123385-1475134570107390', 1, 1, 'SR', NULL, NULL, NULL),
(9190, '2016-09-29 15:39:36', NULL, NULL, 3314, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 15:39:36', 'admin-1475123385-14751347766114187', 1, 1, 'SR', NULL, NULL, NULL),
(9191, '2016-09-29 16:00:04', NULL, NULL, 3315, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 16:00:04', 'admin-1475123385-14751360039872189', 1, 1, 'SR', NULL, NULL, NULL),
(9192, '2016-09-29 16:08:06', NULL, NULL, 3316, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 16:08:06', 'admin-1475123385-14751364868098132', 1, 1, 'SR', NULL, NULL, NULL),
(9193, '2016-09-29 16:08:06', NULL, NULL, 3316, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 16:08:06', 'admin-1475123385-14751364868098132', 1, 0, '', NULL, NULL, NULL),
(9194, '2016-09-29 16:08:07', NULL, NULL, 3316, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 16:08:07', 'admin-1475123385-14751364868098132', 1, 1, 'SR', NULL, NULL, NULL),
(9195, '2016-09-29 16:17:23', NULL, NULL, 3317, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 16:17:23', 'admin-1475123385-1475137043750444', 1, 1, 'SR', NULL, NULL, NULL),
(9196, '2016-09-29 16:17:57', NULL, NULL, 3318, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 16:17:57', 'admin-1475123385-14751370778163224', 1, 1, 'SR', NULL, NULL, NULL),
(9197, '2016-09-29 16:18:25', NULL, NULL, 3319, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 16:18:25', 'admin-1475123385-14751371057955482', 1, 1, 'SR', NULL, NULL, NULL),
(9198, '2016-09-29 16:19:28', NULL, NULL, 3320, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 16:19:28', 'admin-1475123385-14751371678281072', 1, 1, 'SR', NULL, NULL, NULL),
(9199, '2016-09-29 17:06:25', NULL, NULL, 3322, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 17:06:25', 'admin-1475123385-14751399854895960', 1, 1, 'SR', NULL, NULL, '10.0'),
(9200, '2016-09-29 17:06:25', NULL, NULL, 3322, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 17:06:25', 'admin-1475123385-14751399854895960', 1, 1, 'SR', NULL, NULL, '10.0'),
(9201, '2016-09-29 12:34:05', NULL, NULL, 3302, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 12:34:05', 'admin-1475123385-1475123645200932', 1, 1, 'SR', NULL, NULL, NULL),
(9202, '2016-09-29 12:34:05', NULL, NULL, 3302, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 12:34:05', 'admin-1475123385-1475123645200932', 1, 1, 'SR', NULL, NULL, NULL),
(9203, '2016-09-29 12:58:51', NULL, NULL, 3303, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 12:58:51', 'admin-1475123385-1475125130944606', 1, 0, '', NULL, NULL, NULL),
(9204, '2016-09-29 12:58:51', NULL, NULL, 3303, 0, 214, '148', 'Set Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 12:58:51', 'admin-1475123385-1475125130944606', 1, 0, '', NULL, NULL, NULL),
(9205, '2016-09-29 13:20:15', NULL, NULL, 3304, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 13:20:15', 'admin-1475123385-14751264152976419', 1, 1, 'SR', 1, NULL, NULL),
(9206, '2016-09-29 16:24:50', NULL, NULL, 3321, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 16:24:50', 'admin-1475123385-14751374903086370', 1, 0, '', NULL, NULL, NULL),
(9207, '2016-09-29 13:59:18', NULL, NULL, 3305, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 13:59:18', 'admin-1475123385-14751287581566282', 1, 1, 'SR', NULL, NULL, '10.0'),
(9208, '2016-09-29 14:03:50', NULL, NULL, 3305, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 14:03:50', 'admin-1475123385-14751290303843263', 1, 0, '', NULL, NULL, '10.0'),
(9209, '2016-09-29 14:05:06', NULL, NULL, 3306, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 14:05:06', 'admin-1475123385-14751291064208719', 1, 0, '', NULL, NULL, NULL),
(9210, '2016-09-29 14:05:06', NULL, NULL, 3306, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 14:05:06', 'admin-1475123385-14751291064208719', 1, 1, 'SR', NULL, NULL, NULL),
(9211, '2016-09-29 14:05:06', NULL, NULL, 3306, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 14:05:06', 'admin-1475123385-14751291064208719', 1, 1, 'SR', NULL, NULL, NULL),
(9212, '2016-09-29 13:59:18', NULL, NULL, 3305, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 13:59:18', 'admin-1475123385-14751287581566282', 1, 0, '', NULL, NULL, '10.0'),
(9213, '2016-09-29 13:59:18', NULL, NULL, 3305, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 13:59:18', 'admin-1475123385-14751287581566282', 1, 0, '', NULL, NULL, '10.0'),
(9214, '2016-09-29 13:59:18', NULL, NULL, 3305, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 13:59:18', 'admin-1475123385-14751287581566282', 1, 0, '', NULL, NULL, '10.0'),
(9215, '2016-09-29 13:59:18', NULL, NULL, 3305, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 13:59:18', 'admin-1475123385-14751287581566282', 1, 0, '', NULL, NULL, '10.0'),
(9216, '2016-09-29 12:34:05', NULL, NULL, 3302, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 12:34:05', 'admin-1475123385-1475123645200932', 1, 1, 'SR', NULL, NULL, NULL),
(9217, '2016-09-29 12:34:05', NULL, NULL, 3302, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 12:34:05', 'admin-1475123385-1475123645200932', 1, 0, '', NULL, NULL, NULL),
(9218, '2016-09-29 12:29:38', NULL, NULL, 3299, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 12:29:38', 'admin-1475117693-1475123378757512', 1, 1, 'SR', NULL, NULL, NULL),
(9219, '2016-09-29 12:30:22', NULL, NULL, 3300, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 12:30:22', 'admin-1475123385-1475123421916447', 1, 0, '', NULL, NULL, NULL),
(9220, '2016-09-29 09:43:43', NULL, NULL, 3287, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475144581', 'sanni', '2016-09-29 09:43:43', 'sanni-1475053798-14751134234594464', 1, 1, 'SR', NULL, NULL, NULL),
(9221, '2016-09-29 10:03:24', NULL, NULL, 3288, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475144581', 'sanni', '2016-09-29 10:03:24', 'sanni-1475053798-14751146038614623', 1, 0, '', NULL, NULL, NULL),
(9222, '2016-09-29 10:03:24', NULL, NULL, 3288, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475144581', 'sanni', '2016-09-29 10:03:24', 'sanni-1475053798-14751146038614623', 1, 0, '', NULL, NULL, NULL),
(9223, '2016-09-29 10:03:56', NULL, NULL, 3288, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475144581', 'sanni', '2016-09-29 10:03:56', 'sanni-1475053798-14751146361569151', 1, 1, 'SR', NULL, NULL, NULL),
(9224, '2016-09-29 10:51:40', NULL, NULL, 3289, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475144581', 'sanni', '2016-09-29 10:51:40', 'sanni-1475053798-14751175002224655', 1, 0, '', NULL, NULL, NULL),
(9225, '2016-09-29 10:51:40', NULL, NULL, 3289, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475144581', 'sanni', '2016-09-29 10:51:40', 'sanni-1475053798-14751175002224655', 1, 1, 'SR', NULL, NULL, NULL),
(9226, '2016-09-29 10:52:29', NULL, NULL, 3290, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475144581', 'sanni', '2016-09-29 10:52:29', 'sanni-1475053798-14751175491276635', 1, 0, '', NULL, NULL, NULL),
(9227, '2016-09-29 10:52:29', NULL, NULL, 3290, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475144581', 'sanni', '2016-09-29 10:52:29', 'sanni-1475053798-14751175491276635', 1, 0, '', NULL, NULL, NULL),
(9228, '2016-09-29 10:53:34', NULL, NULL, 3291, 0, 54, '54', 'Chai Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475144581', 'sanni', '2016-09-29 10:53:34', 'sanni-1475053798-14751176139298563', 1, 1, 'SR', NULL, NULL, NULL),
(9229, '2016-09-29 10:54:03', NULL, NULL, 3292, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475144581', 'sanni', '2016-09-29 10:54:03', 'sanni-1475053798-14751176428673517', 1, 0, '', NULL, NULL, NULL),
(9230, '2016-09-29 10:54:03', NULL, NULL, 3292, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475144581', 'sanni', '2016-09-29 10:54:03', 'sanni-1475053798-14751176428673517', 1, 0, '', NULL, NULL, NULL),
(9231, '2016-09-29 10:54:44', NULL, NULL, 3293, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475144581', 'sanni', '2016-09-29 10:54:44', 'sanni-1475053798-14751176845057088', 1, 0, '', NULL, NULL, NULL),
(9232, '2016-09-29 10:54:44', NULL, NULL, 3293, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475144581', 'sanni', '2016-09-29 10:54:44', 'sanni-1475053798-14751176845057088', 1, 0, '', NULL, NULL, NULL),
(9233, '2016-09-29 10:58:37', NULL, NULL, 3294, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 10:58:37', 'admin-1475117693-14751179170342116', 1, 0, '', NULL, NULL, NULL),
(9234, '2016-09-29 10:59:13', NULL, NULL, 3294, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 10:59:13', 'admin-1475117693-14751179534241352', 1, 1, 'SR', NULL, NULL, NULL),
(9235, '2016-09-29 11:09:11', NULL, NULL, 3295, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 11:09:11', 'admin-1475117693-14751185508157454', 1, 1, 'SR', 1, NULL, NULL),
(9236, '2016-09-29 12:30:54', NULL, NULL, 3301, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 12:30:54', 'admin-1475123385-14751234540746448', 1, 1, 'SR', NULL, NULL, NULL),
(9237, '2016-09-29 12:30:22', NULL, NULL, 3300, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 12:30:22', 'admin-1475123385-1475123421916447', 1, 1, 'SR', NULL, NULL, NULL),
(9238, '2016-09-29 12:30:54', NULL, NULL, 3301, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 12:30:54', 'admin-1475123385-14751234540746448', 1, 0, '', NULL, NULL, NULL),
(9239, '2016-09-29 12:24:10', NULL, NULL, 3298, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 12:24:10', 'admin-1475117693-14751230497938373', 1, 1, 'SR', 1, NULL, '10.0'),
(9240, '2016-09-29 12:29:38', NULL, NULL, 3299, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 12:29:38', 'admin-1475117693-1475123378757512', 1, 1, 'SR', NULL, NULL, NULL),
(9241, '2016-09-29 12:13:05', NULL, NULL, 3297, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 12:13:05', 'admin-1475117693-147512238506035', 1, 1, 'SR', NULL, NULL, NULL),
(9242, '2016-09-29 12:13:16', NULL, NULL, 3297, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 12:13:16', 'admin-1475117693-1475122396277865', 1, 1, 'SR', NULL, NULL, NULL),
(9243, '2016-09-29 12:13:40', NULL, NULL, 3297, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 12:13:40', 'admin-1475117693-14751224200618294', 1, 1, 'SR', NULL, NULL, NULL),
(9244, '2016-09-29 12:13:40', NULL, NULL, 3297, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 12:13:40', 'admin-1475117693-14751224200618294', 1, 0, '', NULL, NULL, NULL),
(9245, '2016-09-29 12:13:22', NULL, NULL, 3297, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 12:13:22', 'admin-1475117693-1475122402716372', 1, 0, '', NULL, NULL, NULL),
(9246, '2016-09-29 11:18:01', NULL, NULL, 3296, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475144581', 'admin', '2016-09-29 11:18:01', 'admin-1475117693-14751190811418514', 1, 0, '', NULL, NULL, NULL),
(9247, '2016-09-29 09:42:17', NULL, NULL, 3287, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475144581', 'sanni', '2016-09-29 09:42:17', 'sanni-1475053798-14751133374712045', 1, 0, '', NULL, NULL, NULL),
(9248, '2016-09-29 09:43:43', NULL, NULL, 3287, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475144581', 'sanni', '2016-09-29 09:43:43', 'sanni-1475053798-14751134234594464', 1, 1, 'SR', NULL, NULL, NULL),
(9249, '2016-09-29 09:42:17', NULL, NULL, 3287, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475144581', 'sanni', '2016-09-29 09:42:17', 'sanni-1475053798-14751133374712045', 1, 0, '', NULL, NULL, NULL),
(9250, '2016-09-30 13:47:59', NULL, NULL, 3340, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 13:47:59', 'admin-1475212742-14752144791744820', 1, 0, '', NULL, NULL, NULL),
(9251, '2016-09-30 13:48:38', NULL, NULL, 3332, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 13:48:38', 'admin-1475212742-14752145182138726', 1, 1, 'SR', NULL, NULL, NULL),
(9252, '2016-09-30 14:09:16', NULL, NULL, 3341, 0, 153, '87', 'Big Breakfast ', 'without salad', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 14:09:16', 'admin-1475212742-1475215755972189', 1, 0, '', NULL, NULL, NULL),
(9253, '2016-09-30 14:09:16', NULL, NULL, 3341, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 14:09:16', 'admin-1475212742-1475215755972189', 1, 1, 'SR', NULL, NULL, NULL),
(9254, '2016-09-30 14:11:01', NULL, NULL, 3342, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 14:11:01', 'admin-1475212742-14752158610097558', 1, 0, '', NULL, NULL, NULL),
(9255, '2016-09-30 14:11:01', NULL, NULL, 3342, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 14:11:01', 'admin-1475212742-14752158610097558', 1, 1, 'SR', NULL, NULL, NULL),
(9256, '2016-09-30 14:11:42', NULL, NULL, 3338, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 14:11:42', 'admin-1475215868-14752159024281713', 1, 1, 'SR', NULL, NULL, NULL),
(9257, '2016-09-30 14:55:45', NULL, NULL, 3343, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 14:55:45', 'admin-1475215868-14752185451213869', 1, 1, 'SR', NULL, NULL, NULL),
(9258, '2016-09-30 14:55:45', NULL, NULL, 3343, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 14:55:45', 'admin-1475215868-14752185451213869', 1, 1, 'SR', NULL, NULL, NULL),
(9259, '2016-09-30 14:55:45', NULL, NULL, 3343, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 14:55:45', 'admin-1475215868-14752185451213869', 1, 1, 'SR', NULL, NULL, NULL),
(9260, '2016-09-30 18:43:49', NULL, NULL, 3351, 0, 211, '145', 'Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 18:43:49', 'admin-1475215868-14752322291327471', 1, 0, '', NULL, NULL, NULL),
(9261, '2016-09-30 18:45:38', NULL, NULL, 3351, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 18:45:38', 'admin-1475215868-14752323385758880', 1, 1, 'SR', NULL, NULL, NULL),
(9262, '2016-09-30 18:45:38', NULL, NULL, 3351, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 18:45:38', 'admin-1475215868-14752323385758880', 1, 1, 'SR', NULL, NULL, NULL),
(9263, '2016-09-30 19:00:04', NULL, NULL, 3351, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 19:00:04', 'admin-1475215868-14752332042366593', 1, 0, '', NULL, NULL, NULL),
(9264, '2016-09-30 19:34:23', NULL, NULL, 3352, 0, 211, '145', 'Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 19:34:23', 'admin-1475215868-14752352630548087', 1, 0, '', NULL, NULL, NULL),
(9265, '2016-09-30 19:34:23', NULL, NULL, 3352, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 19:34:23', 'admin-1475215868-14752352630548087', 1, 1, 'SR', NULL, NULL, NULL),
(9266, '2016-09-30 19:36:54', NULL, NULL, 3353, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 19:36:54', 'admin-1475215868-14752354144007810', 1, 0, '', NULL, NULL, NULL),
(9267, '2016-09-30 20:14:07', NULL, NULL, 3354, 0, 220, '154', 'Crispy Bacon Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 20:14:07', 'admin-1475215868-14752376473965256', 1, 0, '', NULL, NULL, NULL),
(9268, '2016-09-30 20:14:47', NULL, NULL, 3354, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 20:14:47', 'admin-1475237666-14752376869306828', 1, 1, 'SR', NULL, NULL, NULL),
(9269, '2016-09-30 20:14:47', NULL, NULL, 3354, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 20:14:47', 'admin-1475237666-14752376869306828', 1, 1, 'SR', NULL, NULL, NULL),
(9270, '2016-09-30 20:21:30', NULL, NULL, 3355, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 20:21:30', 'admin-1475237666-14752380901449654', 1, 1, 'SR', NULL, NULL, NULL),
(9271, '2016-09-30 21:04:58', NULL, NULL, 3356, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 21:04:58', 'admin-1475237666-14752406982688082', 1, 1, 'SR', NULL, NULL, NULL),
(9272, '2016-09-30 18:14:37', NULL, NULL, 3350, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 18:14:37', 'admin-1475215868-14752304776049161', 1, 0, '', NULL, NULL, NULL),
(9273, '2016-09-30 18:14:37', NULL, NULL, 3350, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 18:14:37', 'admin-1475215868-14752304776049161', 1, 1, 'SR', NULL, NULL, NULL),
(9274, '2016-09-30 18:04:39', NULL, NULL, 3349, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 18:04:39', 'admin-1475215868-14752298788736941', 1, 0, '', NULL, NULL, NULL),
(9275, '2016-09-30 18:04:39', NULL, NULL, 3349, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 18:04:39', 'admin-1475215868-14752298788736941', 1, 1, 'SR', NULL, NULL, NULL),
(9276, '2016-09-30 18:00:44', NULL, NULL, 3348, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 18:00:44', 'admin-1475215868-14752296443301963', 1, 1, 'SR', NULL, NULL, NULL),
(9277, '2016-09-30 18:00:44', NULL, NULL, 3348, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 18:00:44', 'admin-1475215868-14752296443301963', 1, 1, 'SR', NULL, NULL, NULL),
(9278, '2016-09-30 18:00:44', NULL, NULL, 3348, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 18:00:44', 'admin-1475215868-14752296443301963', 1, 0, '', NULL, NULL, NULL),
(9279, '2016-09-30 17:46:03', NULL, NULL, 3347, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 17:46:03', 'admin-1475215868-14752287628027093', 1, 1, 'SR', NULL, NULL, NULL),
(9280, '2016-09-30 17:46:03', NULL, NULL, 3347, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 17:46:03', 'admin-1475215868-14752287628027093', 1, 1, 'SR', NULL, NULL, NULL),
(9281, '2016-09-30 16:53:45', NULL, NULL, 3346, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 16:53:45', 'admin-1475215868-14752256249693738', 1, 1, 'SR', NULL, NULL, NULL),
(9282, '2016-09-30 16:53:45', NULL, NULL, 3346, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 16:53:45', 'admin-1475215868-14752256249693738', 1, 0, '', NULL, NULL, NULL),
(9283, '2016-09-30 15:59:57', NULL, NULL, 3345, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 15:59:57', 'admin-1475215868-14752223976237769', 1, 1, 'SR', NULL, NULL, NULL),
(9284, '2016-09-30 15:59:57', NULL, NULL, 3345, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 15:59:57', 'admin-1475215868-14752223976237769', 1, 0, '', NULL, NULL, NULL),
(9285, '2016-09-30 15:17:25', NULL, NULL, 3344, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 15:17:25', 'admin-1475215868-14752198453883988', 1, 1, 'SR', NULL, NULL, NULL),
(9286, '2016-09-30 15:17:25', NULL, NULL, 3344, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 15:17:25', 'admin-1475215868-14752198453883988', 1, 1, 'SR', NULL, NULL, NULL),
(9287, '2016-09-30 14:55:45', NULL, NULL, 3343, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 14:55:45', 'admin-1475215868-14752185451213869', 1, 0, '', NULL, NULL, NULL),
(9288, '2016-09-30 14:55:45', NULL, NULL, 3343, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 14:55:45', 'admin-1475215868-14752185451213869', 1, 0, '', NULL, NULL, NULL),
(9289, '2016-09-30 14:55:45', NULL, NULL, 3343, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 14:55:45', 'admin-1475215868-14752185451213869', 1, 0, '', NULL, NULL, NULL),
(9290, '2016-09-30 18:43:10', NULL, NULL, 3351, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 18:43:10', 'admin-1475215868-1475232190396457', 1, 0, '', NULL, NULL, NULL),
(9291, '2016-09-30 13:47:59', NULL, NULL, 3340, 0, 221, '155', 'Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 13:47:59', 'admin-1475212742-14752144791744820', 1, 0, '', NULL, NULL, NULL),
(9292, '2016-09-30 13:47:59', NULL, NULL, 3340, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 13:47:59', 'admin-1475212742-14752144791744820', 1, 1, 'SR', NULL, NULL, NULL),
(9293, '2016-09-30 13:47:59', NULL, NULL, 3340, 0, 222, '156', 'Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 13:47:59', 'admin-1475212742-14752144791744820', 1, 0, '', NULL, NULL, NULL),
(9294, '2016-09-30 13:25:37', NULL, NULL, 3339, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 13:25:37', 'admin-1475212742-14752131370215473', 1, 1, 'SR', NULL, NULL, NULL),
(9295, '2016-09-30 13:25:37', NULL, NULL, 3339, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 13:25:37', 'admin-1475212742-14752131370215473', 1, 0, '', NULL, NULL, NULL),
(9296, '2016-09-30 13:25:37', NULL, NULL, 3339, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 13:25:37', 'admin-1475212742-14752131370215473', 1, 0, '', NULL, NULL, NULL),
(9297, '2016-09-30 13:21:26', NULL, NULL, 3338, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 13:21:26', 'admin-1475212742-14752128865457550', 1, 0, '', NULL, NULL, NULL),
(9298, '2016-09-30 13:19:23', NULL, NULL, 3338, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 13:19:23', 'admin-1475212742-14752127633438245', 1, 0, '', NULL, NULL, NULL),
(9299, '2016-09-30 13:12:59', NULL, NULL, 3338, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 13:12:59', 'admin-1475208266-14752123791802197', 1, 0, '', NULL, NULL, NULL),
(9300, '2016-09-30 13:10:51', NULL, NULL, 3338, 0, 211, '145', 'Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 13:10:51', 'admin-1475208266-14752122511197451', 1, 0, '', NULL, NULL, NULL),
(9301, '2016-09-30 12:58:28', NULL, NULL, 3337, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 12:58:28', 'admin-1475208266-14752115087325969', 1, 1, 'SR', NULL, NULL, NULL),
(9302, '2016-09-30 12:58:28', NULL, NULL, 3337, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 12:58:28', 'admin-1475208266-14752115087325969', 1, 1, 'SR', NULL, NULL, NULL),
(9303, '2016-09-30 12:31:00', NULL, NULL, 3334, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 12:31:00', 'admin-1475208266-14752098600703720', 1, 1, 'SR', NULL, NULL, NULL),
(9304, '2016-09-30 12:52:08', NULL, NULL, 3335, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 12:52:08', 'admin-1475208266-14752111282495762', 1, 1, 'SR', NULL, NULL, NULL),
(9305, '2016-09-30 12:52:08', NULL, NULL, 3335, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 12:52:08', 'admin-1475208266-14752111282495762', 1, 0, '', NULL, NULL, NULL),
(9306, '2016-09-30 12:52:59', NULL, NULL, 3336, 0, 222, '156', 'Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 12:52:59', 'admin-1475208266-1475211179473695', 1, 0, '', NULL, NULL, NULL),
(9307, '2016-09-30 12:29:49', NULL, NULL, 3333, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 12:29:49', 'admin-1475208266-14752097890125464', 1, 1, 'SR', NULL, NULL, NULL),
(9308, '2016-09-30 12:29:43', NULL, NULL, 3333, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 12:29:43', 'admin-1475208266-1475209783306628', 1, 0, '', NULL, NULL, NULL),
(9309, '2016-09-30 12:04:52', NULL, NULL, 3331, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 12:04:52', 'admin-1475208266-1475208292390885', 1, 0, '', NULL, NULL, NULL),
(9310, '2016-09-30 12:04:52', NULL, NULL, 3331, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 12:04:52', 'admin-1475208266-1475208292390885', 1, 0, '', NULL, NULL, NULL),
(9311, '2016-09-30 09:29:24', NULL, NULL, 3326, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 09:29:24', 'admin-1475198761-14751989645563394', 1, 1, 'SR', NULL, NULL, NULL),
(9312, '2016-09-30 09:29:24', NULL, NULL, 3326, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 09:29:24', 'admin-1475198761-14751989645563394', 1, 1, 'SR', NULL, NULL, NULL),
(9313, '2016-09-30 09:29:24', NULL, NULL, 3326, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 09:29:24', 'admin-1475198761-14751989645563394', 1, 0, '', NULL, NULL, NULL),
(9314, '2016-09-30 09:29:24', NULL, NULL, 3326, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 09:29:24', 'admin-1475198761-14751989645563394', 1, 0, '', NULL, NULL, NULL),
(9315, '2016-09-30 10:10:36', NULL, NULL, 3327, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 10:10:36', 'admin-1475198761-14752014364359143', 1, 0, '', NULL, NULL, '10.0'),
(9316, '2016-09-30 10:10:36', NULL, NULL, 3327, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 10:10:36', 'admin-1475198761-14752014364359143', 1, 1, 'SR', NULL, NULL, '10.0'),
(9317, '2016-09-30 10:11:13', NULL, NULL, 3327, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 10:11:13', 'admin-1475198761-14752014732014151', 1, 0, '', NULL, NULL, '10.0'),
(9318, '2016-09-30 10:11:13', NULL, NULL, 3327, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 10:11:13', 'admin-1475198761-14752014732014151', 1, 0, '', NULL, NULL, '10.0'),
(9319, '2016-09-30 10:11:13', NULL, NULL, 3327, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 10:11:13', 'admin-1475198761-14752014732014151', 1, 0, '', NULL, NULL, '10.0'),
(9320, '2016-09-30 10:16:58', NULL, NULL, 3328, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 10:16:58', 'admin-1475198761-14752018185888679', 1, 1, 'SR', NULL, NULL, NULL),
(9321, '2016-09-30 10:16:58', NULL, NULL, 3328, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 10:16:58', 'admin-1475198761-14752018185888679', 1, 0, '', NULL, NULL, NULL),
(9322, '2016-09-30 10:30:29', NULL, NULL, 3327, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 10:30:29', 'admin-1475198761-14752026290587538', 1, 0, '', NULL, NULL, '10.0'),
(9323, '2016-09-30 10:30:29', NULL, NULL, 3327, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 10:30:29', 'admin-1475198761-14752026290587538', 1, 0, '', NULL, NULL, '10.0'),
(9324, '2016-09-30 10:30:29', NULL, NULL, 3327, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 10:30:29', 'admin-1475198761-14752026290587538', 1, 0, '', NULL, NULL, '10.0'),
(9325, '2016-09-30 10:30:29', NULL, NULL, 3327, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 10:30:29', 'admin-1475198761-14752026290587538', 1, 0, '', NULL, NULL, '10.0'),
(9326, '2016-09-30 11:33:50', NULL, NULL, 3329, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 11:33:51', 'admin-1475198761-14752064307374513', 1, 1, 'SR', 1, NULL, NULL),
(9327, '2016-09-30 11:43:21', NULL, NULL, 3330, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 11:43:21', 'admin-1475198761-14752070013951971', 1, 0, '', NULL, NULL, NULL),
(9328, '2016-09-30 12:20:31', NULL, NULL, 3332, 0, 214, '148', 'Set Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 12:20:31', 'admin-1475208266-147520923172797', 1, 0, '', NULL, NULL, NULL),
(9329, '2016-09-30 12:20:31', NULL, NULL, 3332, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 12:20:31', 'admin-1475208266-147520923172797', 1, 1, 'SR', NULL, NULL, NULL),
(9330, '2016-09-30 12:29:43', NULL, NULL, 3333, 0, 224, '158', 'Set Garlic Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 12:29:43', 'admin-1475208266-1475209783306628', 1, 0, '', NULL, NULL, NULL),
(9331, '2016-09-30 12:04:19', NULL, NULL, 3331, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 12:04:19', 'admin-1475198761-1475208259145650', 1, 1, 'SR', NULL, NULL, NULL),
(9332, '2016-09-30 12:04:19', NULL, NULL, 3331, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 12:04:19', 'admin-1475198761-1475208259145650', 1, 1, 'SR', NULL, NULL, NULL),
(9333, '2016-09-30 11:43:31', NULL, NULL, 3330, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 11:43:31', 'admin-1475198761-1475207010826472', 1, 1, 'SR', NULL, NULL, NULL),
(9334, '2016-09-30 11:56:34', NULL, NULL, 3330, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 11:56:34', 'admin-1475198761-14752077944579442', 1, 1, 'SR', NULL, NULL, NULL),
(9335, '2016-09-30 11:56:34', NULL, NULL, 3330, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 11:56:34', 'admin-1475198761-14752077944579442', 1, 0, '', NULL, NULL, NULL),
(9336, '2016-09-30 12:29:43', NULL, NULL, 3333, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 12:29:43', 'admin-1475208266-1475209783306628', 1, 1, 'SR', NULL, NULL, NULL),
(9337, '2016-09-30 12:04:19', NULL, NULL, 3331, 0, 221, '155', 'Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 12:04:19', 'admin-1475198761-1475208259145650', 1, 0, '', NULL, NULL, NULL),
(9338, '2016-09-30 11:56:34', NULL, NULL, 3330, 0, 181, '116', 'Open Food ', 'egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1475237666', 'admin', '2016-09-30 11:56:34', 'admin-1475198761-14752077944579442', 1, 0, '', NULL, NULL, NULL),
(9339, '2016-09-30 12:04:19', NULL, NULL, 3331, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 12:04:19', 'admin-1475198761-1475208259145650', 1, 0, '', NULL, NULL, NULL),
(9340, '2016-09-30 11:43:31', NULL, NULL, 3330, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 11:43:31', 'admin-1475198761-1475207010826472', 1, 1, 'SR', NULL, NULL, NULL),
(9341, '2016-09-30 09:29:24', NULL, NULL, 3326, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475237666', 'admin', '2016-09-30 09:29:24', 'admin-1475198761-14751989645563394', 1, 1, 'SR', NULL, NULL, NULL),
(9342, '2016-10-01 21:15:38', NULL, NULL, 3398, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 21:15:38', 'admin-1475302551-14753277384101328', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(9343, '2016-10-01 11:44:58', NULL, NULL, 3375, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:44:58', 'admin-1475290683-14752934984113589', 1, 0, '', NULL, NULL, NULL),
(9344, '2016-10-01 11:44:58', NULL, NULL, 3375, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:44:58', 'admin-1475290683-14752934984113589', 1, 1, 'SR', NULL, NULL, NULL),
(9345, '2016-10-01 11:59:09', NULL, NULL, 3376, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:59:09', 'admin-1475293507-14752943496074951', 1, 1, 'SR', NULL, NULL, NULL),
(9346, '2016-10-01 11:59:09', NULL, NULL, 3376, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:59:09', 'admin-1475293507-14752943496074951', 1, 1, 'SR', NULL, NULL, NULL),
(9347, '2016-10-01 11:59:09', NULL, NULL, 3376, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:59:09', 'admin-1475293507-14752943496074951', 1, 1, 'SR', NULL, NULL, NULL),
(9348, '2016-10-01 11:59:09', NULL, NULL, 3376, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:59:09', 'admin-1475293507-14752943496074951', 1, 1, 'SR', NULL, NULL, NULL),
(9349, '2016-10-01 11:59:09', NULL, NULL, 3376, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:59:09', 'admin-1475293507-14752943496074951', 1, 1, 'SR', NULL, NULL, NULL),
(9350, '2016-10-01 12:02:15', NULL, NULL, 3376, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 12:02:15', 'admin-1475293507-14752945352408854', 1, 0, '', NULL, NULL, NULL),
(9351, '2016-10-01 12:02:15', NULL, NULL, 3376, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 12:02:15', 'admin-1475293507-14752945352408854', 1, 0, '', NULL, NULL, NULL),
(9352, '2016-10-01 12:02:15', NULL, NULL, 3376, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 12:02:15', 'admin-1475293507-14752945352408854', 1, 0, '', NULL, NULL, NULL),
(9353, '2016-10-01 12:02:15', NULL, NULL, 3376, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 12:02:15', 'admin-1475293507-14752945352408854', 1, 0, '', NULL, NULL, NULL),
(9354, '2016-10-01 12:04:53', NULL, NULL, 3377, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 12:04:53', 'admin-1475293507-14752946930848819', 1, 0, '', NULL, NULL, NULL),
(9355, '2016-10-01 12:04:53', NULL, NULL, 3377, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 12:04:53', 'admin-1475293507-14752946930848819', 1, 0, '', NULL, NULL, NULL),
(9356, '2016-10-01 12:04:53', NULL, NULL, 3377, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 12:04:53', 'admin-1475293507-14752946930848819', 1, 1, 'SR', NULL, NULL, NULL),
(9357, '2016-10-01 12:04:53', NULL, NULL, 3377, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 12:04:53', 'admin-1475293507-14752946930848819', 1, 1, 'SR', NULL, NULL, NULL),
(9358, '2016-10-01 12:30:26', NULL, NULL, 3378, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 12:30:26', 'admin-1475293507-14752962260543589', 1, 1, 'SR', NULL, NULL, NULL),
(9359, '2016-10-01 12:46:04', NULL, NULL, 3364, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 12:46:04', 'admin-1475293507-1475297164617247', 1, 1, 'SR', NULL, NULL, NULL),
(9360, '2016-10-01 12:46:04', NULL, NULL, 3364, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 12:46:04', 'admin-1475293507-1475297164617247', 1, 1, 'SR', NULL, NULL, NULL),
(9361, '2016-10-01 13:11:21', NULL, NULL, 3379, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 13:11:21', 'admin-1475293507-14752986815967029', 1, 0, '', NULL, NULL, NULL),
(9362, '2016-10-01 13:11:21', NULL, NULL, 3379, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 13:11:21', 'admin-1475293507-14752986815967029', 1, 0, '', NULL, NULL, NULL),
(9363, '2016-10-01 13:11:21', NULL, NULL, 3379, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 13:11:21', 'admin-1475293507-14752986815967029', 1, 0, '', NULL, NULL, NULL),
(9364, '2016-10-01 13:11:35', NULL, NULL, 3379, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 13:11:35', 'admin-1475293507-14752986948746694', 1, 1, 'SR', NULL, NULL, NULL),
(9365, '2016-10-01 13:11:35', NULL, NULL, 3379, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 13:11:35', 'admin-1475293507-14752986948746694', 1, 1, 'SR', NULL, NULL, NULL),
(9366, '2016-10-01 13:11:35', NULL, NULL, 3379, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 13:11:35', 'admin-1475293507-14752986948746694', 1, 1, 'SR', NULL, NULL, NULL),
(9367, '2016-10-01 13:24:00', NULL, NULL, 3380, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 13:24:00', 'admin-1475293507-14752994399067188', 1, 1, 'SR', NULL, NULL, NULL),
(9368, '2016-10-01 13:35:45', NULL, NULL, 3381, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 13:35:45', 'admin-1475293507-14753001457813345', 1, 1, 'SR', NULL, NULL, NULL),
(9369, '2016-10-01 13:47:16', NULL, NULL, 3382, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 13:47:16', 'admin-1475293507-14753008361145147', 1, 0, '', NULL, NULL, NULL),
(9370, '2016-10-01 13:47:16', NULL, NULL, 3382, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 13:47:16', 'admin-1475293507-14753008361145147', 1, 1, 'SR', NULL, NULL, NULL),
(9371, '2016-10-01 13:47:16', NULL, NULL, 3382, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 13:47:16', 'admin-1475293507-14753008361145147', 1, 1, 'SR', NULL, NULL, NULL),
(9372, '2016-10-01 13:57:48', NULL, NULL, 3383, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 13:57:48', 'admin-1475293507-14753014677459117', 1, 1, 'SR', NULL, NULL, NULL),
(9373, '2016-10-01 13:57:48', NULL, NULL, 3383, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 13:57:48', 'admin-1475293507-14753014677459117', 1, 1, 'SR', NULL, NULL, NULL),
(9374, '2016-10-01 13:57:48', NULL, NULL, 3383, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 13:57:48', 'admin-1475293507-14753014677459117', 1, 1, 'SR', NULL, NULL, NULL),
(9375, '2016-10-01 14:15:45', NULL, NULL, 3384, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 14:15:45', 'admin-1475293507-14753025450114713', 1, 0, '', NULL, NULL, NULL),
(9376, '2016-10-01 14:15:45', NULL, NULL, 3384, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 14:15:45', 'admin-1475293507-14753025450114713', 1, 1, 'SR', NULL, NULL, NULL),
(9377, '2016-10-01 20:42:44', NULL, NULL, 3395, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 20:42:44', 'admin-1475302551-14753257644258523', 1, 1, 'SR', NULL, NULL, NULL),
(9378, '2016-10-01 20:50:59', NULL, NULL, 3396, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 20:50:59', 'admin-1475302551-1475326259183238', 1, 0, '', NULL, NULL, NULL),
(9379, '2016-10-01 21:22:10', NULL, NULL, 3393, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 21:22:10', 'admin-1475302551-14753281303002774', 1, 0, '', NULL, NULL, NULL),
(9380, '2016-10-01 21:22:10', NULL, NULL, 3393, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 21:22:10', 'admin-1475302551-14753281303002774', 1, 0, '', NULL, NULL, NULL),
(9381, '2016-10-01 21:17:11', NULL, NULL, 3393, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 21:17:11', 'admin-1475302551-14753278315213982', 1, 1, 'SR', NULL, NULL, NULL),
(9382, '2016-10-01 21:17:11', NULL, NULL, 3393, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 21:17:11', 'admin-1475302551-14753278315213982', 1, 0, '', NULL, NULL, NULL),
(9383, '2016-10-01 19:43:41', NULL, NULL, 3392, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 19:43:41', 'admin-1475302551-14753222214693546', 1, 0, '', NULL, NULL, NULL),
(9384, '2016-10-01 21:17:11', NULL, NULL, 3393, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 21:17:11', 'admin-1475302551-14753278315213982', 1, 1, 'SR', NULL, NULL, NULL),
(9385, '2016-10-01 21:15:38', NULL, NULL, 3398, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 21:15:38', 'admin-1475302551-14753277384101328', 1, 0, '', NULL, NULL, NULL),
(9386, '2016-10-01 20:54:18', NULL, NULL, 3397, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 20:54:18', 'admin-1475302551-14753264577646414', 1, 0, '', NULL, NULL, NULL),
(9387, '2016-10-01 20:54:18', NULL, NULL, 3397, 0, 76, '76', 'Sauted Mushroom Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 20:54:18', 'admin-1475302551-14753264577646414', 1, 1, 'SR', NULL, NULL, NULL),
(9388, '2016-10-01 20:54:18', NULL, NULL, 3397, 0, 221, '155', 'Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 20:54:18', 'admin-1475302551-14753264577646414', 1, 0, '', NULL, NULL, NULL),
(9389, '2016-10-01 20:54:18', NULL, NULL, 3397, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 20:54:18', 'admin-1475302551-14753264577646414', 1, 1, 'SR', NULL, NULL, NULL),
(9390, '2016-10-01 20:54:17', NULL, NULL, 3397, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 20:54:17', 'admin-1475302551-14753264577646414', 1, 1, 'SR', NULL, NULL, NULL),
(9391, '2016-10-01 19:15:37', NULL, NULL, 3391, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 19:15:37', 'admin-1475302551-14753205368865166', 1, 0, '', NULL, NULL, NULL),
(9392, '2016-10-01 19:15:37', NULL, NULL, 3391, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 19:15:37', 'admin-1475302551-14753205368865166', 1, 1, 'SR', NULL, NULL, NULL),
(9393, '2016-10-01 18:42:57', NULL, NULL, 3390, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 18:42:57', 'admin-1475302551-14753185770437416', 1, 0, '', NULL, NULL, NULL),
(9394, '2016-10-01 18:42:57', NULL, NULL, 3390, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 18:42:57', 'admin-1475302551-14753185770437416', 1, 0, '', NULL, NULL, NULL),
(9395, '2016-10-01 16:31:36', NULL, NULL, 3389, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 16:31:36', 'admin-1475302551-14753106965401045', 1, 1, 'SR', 1, NULL, NULL),
(9396, '2016-10-01 16:09:47', NULL, NULL, 3388, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 16:09:47', 'admin-1475302551-1475309387611389', 1, 0, '', 1, NULL, NULL),
(9397, '2016-10-01 16:09:47', NULL, NULL, 3388, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 16:09:47', 'admin-1475302551-1475309387611389', 1, 1, 'SR', 1, NULL, NULL),
(9398, '2016-10-01 15:21:51', NULL, NULL, 3387, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 15:21:51', 'admin-1475302551-14753065109765020', 1, 1, 'SR', NULL, NULL, '10.0'),
(9399, '2016-10-01 15:21:46', NULL, NULL, 3387, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 15:21:46', 'admin-1475302551-14753065062499750', 1, 0, '', NULL, NULL, '10.0'),
(9400, '2016-10-01 14:59:25', NULL, NULL, 3384, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 14:59:25', 'admin-1475302551-14753051652723294', 1, 0, '', NULL, NULL, NULL),
(9401, '2016-10-01 14:59:25', NULL, NULL, 3384, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 14:59:25', 'admin-1475302551-14753051652723294', 1, 0, '', NULL, NULL, NULL),
(9402, '2016-10-01 14:59:25', NULL, NULL, 3384, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 14:59:25', 'admin-1475302551-14753051652723294', 1, 0, '', NULL, NULL, NULL),
(9403, '2016-10-01 14:59:25', NULL, NULL, 3384, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 14:59:25', 'admin-1475302551-14753051652723294', 1, 0, '', NULL, NULL, NULL),
(9404, '2016-10-01 14:58:58', NULL, NULL, 3386, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 14:58:58', 'admin-1475302551-14753051385151473', 1, 0, '', NULL, NULL, NULL),
(9405, '2016-10-01 14:58:58', NULL, NULL, 3386, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 14:58:58', 'admin-1475302551-14753051385151473', 1, 1, 'SR', NULL, NULL, NULL),
(9406, '2016-10-01 14:43:22', NULL, NULL, 3385, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 14:43:22', 'admin-1475302551-1475304202025263', 1, 0, '', NULL, NULL, NULL),
(9407, '2016-10-01 14:15:45', NULL, NULL, 3384, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 14:15:45', 'admin-1475293507-14753025450114713', 1, 0, '', NULL, NULL, NULL),
(9408, '2016-10-01 14:15:45', NULL, NULL, 3384, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 14:15:45', 'admin-1475293507-14753025450114713', 1, 0, '', NULL, NULL, NULL),
(9409, '2016-10-01 20:54:17', NULL, NULL, 3397, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 20:54:17', 'admin-1475302551-14753264577646414', 1, 1, 'SR', NULL, NULL, NULL),
(9410, '2016-10-01 20:50:59', NULL, NULL, 3396, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 20:50:59', 'admin-1475302551-1475326259183238', 1, 0, '', NULL, NULL, NULL),
(9411, '2016-10-01 20:17:54', NULL, NULL, 3393, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 20:17:54', 'admin-1475302551-14753242738397654', 1, 0, '', NULL, NULL, NULL),
(9412, '2016-10-01 20:42:44', NULL, NULL, 3395, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 20:42:44', 'admin-1475302551-14753257644258523', 1, 0, '', NULL, NULL, NULL),
(9413, '2016-10-01 20:42:34', NULL, NULL, 3394, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 20:42:34', 'admin-1475302551-14753257544418714', 1, 1, 'SR', NULL, NULL, NULL),
(9414, '2016-10-01 20:36:34', NULL, NULL, 3394, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 20:36:34', 'admin-1475302551-14753253946036720', 1, 0, '', NULL, NULL, NULL),
(9415, '2016-10-01 20:36:34', NULL, NULL, 3394, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 20:36:34', 'admin-1475302551-14753253946036720', 1, 0, '', NULL, NULL, NULL),
(9416, '2016-10-01 20:36:34', NULL, NULL, 3394, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 20:36:34', 'admin-1475302551-14753253946036720', 1, 1, 'SR', NULL, NULL, NULL),
(9417, '2016-10-01 21:17:11', NULL, NULL, 3393, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 3, 12.00, 36.0000, 0.0000, 36.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 21:17:11', 'admin-1475302551-14753278315213982', 1, 1, 'SR', NULL, NULL, NULL),
(9418, '2016-10-01 20:50:59', NULL, NULL, 3396, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 20:50:59', 'admin-1475302551-1475326259183238', 1, 0, '', NULL, NULL, NULL),
(9419, '2016-10-01 20:17:54', NULL, NULL, 3393, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 20:17:54', 'admin-1475302551-14753242738397654', 1, 0, '', NULL, NULL, NULL),
(9420, '2016-10-01 20:17:54', NULL, NULL, 3393, 0, 217, '151', 'Spicy Lemony Wings', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 20:17:54', 'admin-1475302551-14753242738397654', 1, 0, '', NULL, NULL, NULL),
(9421, '2016-10-01 19:43:41', NULL, NULL, 3392, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 19:43:41', 'admin-1475302551-14753222214693546', 1, 0, '', NULL, NULL, NULL),
(9422, '2016-10-01 20:17:54', NULL, NULL, 3393, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 20:17:54', 'admin-1475302551-14753242738397654', 1, 1, 'SR', NULL, NULL, NULL),
(9423, '2016-10-01 19:43:41', NULL, NULL, 3392, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 19:43:41', 'admin-1475302551-14753222214693546', 1, 1, 'SR', NULL, NULL, NULL),
(9424, '2016-10-01 19:43:41', NULL, NULL, 3392, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 19:43:41', 'admin-1475302551-14753222214693546', 1, 1, 'SR', NULL, NULL, NULL),
(9425, '2016-10-01 19:43:41', NULL, NULL, 3392, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 19:43:41', 'admin-1475302551-14753222214693546', 1, 1, 'SR', NULL, NULL, NULL),
(9426, '2016-10-01 19:16:01', NULL, NULL, 3391, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 19:16:01', 'admin-1475302551-14753205616801617', 1, 1, 'SR', NULL, NULL, NULL),
(9427, '2016-10-01 19:16:01', NULL, NULL, 3391, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 19:16:01', 'admin-1475302551-14753205616801617', 1, 1, 'SR', NULL, NULL, NULL),
(9428, '2016-10-01 19:15:37', NULL, NULL, 3391, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 19:15:37', 'admin-1475302551-14753205368865166', 1, 0, '', NULL, NULL, NULL),
(9429, '2016-10-01 14:15:45', NULL, NULL, 3384, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 14:15:45', 'admin-1475293507-14753025450114713', 1, 1, 'SR', NULL, NULL, NULL),
(9430, '2016-10-01 11:30:40', NULL, NULL, 3374, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:30:40', 'admin-1475290683-1475292640274647', 1, 1, 'SR', NULL, NULL, NULL),
(9431, '2016-10-01 11:30:40', NULL, NULL, 3374, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:30:40', 'admin-1475290683-1475292640274647', 1, 0, '', NULL, NULL, NULL),
(9432, '2016-10-01 11:30:40', NULL, NULL, 3374, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:30:40', 'admin-1475290683-1475292640274647', 1, 0, '', NULL, NULL, NULL),
(9433, '2016-10-01 11:30:25', NULL, NULL, 3373, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:30:25', 'admin-1475290683-14752926256978153', 1, 1, 'SR', NULL, NULL, '10.0'),
(9434, '2016-10-01 11:30:25', NULL, NULL, 3373, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:30:25', 'admin-1475290683-14752926256978153', 1, 1, 'SR', NULL, NULL, '10.0'),
(9435, '2016-10-01 11:30:08', NULL, NULL, 3373, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:30:08', 'admin-1475290683-14752926087182744', 1, 0, '', NULL, NULL, '10.0'),
(9436, '2016-10-01 11:30:08', NULL, NULL, 3373, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:30:08', 'admin-1475290683-14752926087182744', 1, 0, '', NULL, NULL, '10.0'),
(9437, '2016-10-01 11:07:07', NULL, NULL, 3372, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:07:07', 'admin-1475290683-14752912272934727', 1, 1, 'SR', NULL, NULL, NULL),
(9438, '2016-10-01 11:07:07', NULL, NULL, 3372, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:07:07', 'admin-1475290683-14752912272934727', 1, 1, 'SR', NULL, NULL, NULL),
(9439, '2016-10-01 11:07:00', NULL, NULL, 3372, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:07:00', 'admin-1475290683-14752912199884128', 1, 0, '', NULL, NULL, NULL),
(9440, '2016-10-01 11:07:00', NULL, NULL, 3372, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:07:00', 'admin-1475290683-14752912199884128', 1, 0, '', NULL, NULL, NULL),
(9441, '2016-10-01 11:05:56', NULL, NULL, 3371, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:05:56', 'admin-1475290683-14752911567682274', 1, 1, 'SR', NULL, NULL, NULL),
(9442, '2016-10-01 11:02:42', NULL, NULL, 3369, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:02:42', 'admin-1475290683-14752909625182081', 1, 1, 'SR', 1, NULL, NULL),
(9443, '2016-10-01 11:04:10', NULL, NULL, 3370, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:04:10', 'admin-1475290683-1475291050550252', 1, 1, 'SR', NULL, NULL, NULL),
(9444, '2016-10-01 11:04:10', NULL, NULL, 3370, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:04:10', 'admin-1475290683-1475291050550252', 1, 0, '', NULL, NULL, NULL),
(9445, '2016-10-01 11:05:56', NULL, NULL, 3371, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:05:56', 'admin-1475290683-14752911567682274', 1, 1, 'SR', NULL, NULL, NULL),
(9446, '2016-10-01 11:01:27', NULL, NULL, 3368, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:01:27', 'admin-1475290683-14752908874525262', 1, 1, 'SR', NULL, NULL, NULL),
(9447, '2016-10-01 10:26:49', NULL, NULL, 3361, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:26:49', 'admin-1475283098-14752888096006419', 1, 1, 'SR', NULL, NULL, NULL),
(9448, '2016-10-01 10:28:30', NULL, NULL, 3359, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:28:30', 'admin-1475283098-14752889106197680', 1, 0, '', NULL, NULL, NULL),
(9449, '2016-10-01 10:28:30', NULL, NULL, 3359, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:28:30', 'admin-1475283098-14752889106197680', 1, 0, '', NULL, NULL, NULL),
(9450, '2016-10-01 10:28:30', NULL, NULL, 3359, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:28:30', 'admin-1475283098-14752889106197680', 1, 0, '', NULL, NULL, NULL),
(9451, '2016-10-01 10:28:30', NULL, NULL, 3359, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:28:30', 'admin-1475283098-14752889106197680', 1, 0, '', NULL, NULL, NULL),
(9452, '2016-10-01 10:28:30', NULL, NULL, 3359, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:28:30', 'admin-1475283098-14752889106197680', 1, 0, '', NULL, NULL, NULL),
(9453, '2016-10-01 10:28:30', NULL, NULL, 3359, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:28:30', 'admin-1475283098-14752889106197680', 1, 1, 'SR', NULL, NULL, NULL),
(9454, '2016-10-01 10:28:30', NULL, NULL, 3359, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:28:30', 'admin-1475283098-14752889106197680', 1, 1, 'SR', NULL, NULL, NULL),
(9455, '2016-10-01 10:28:30', NULL, NULL, 3359, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:28:30', 'admin-1475283098-14752889106197680', 1, 1, 'SR', NULL, NULL, NULL),
(9456, '2016-10-01 10:28:30', NULL, NULL, 3359, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:28:30', 'admin-1475283098-14752889106197680', 1, 0, '', NULL, NULL, NULL),
(9457, '2016-10-01 10:50:03', NULL, NULL, 3362, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:50:03', 'admin-1475283098-14752902029797992', 1, 0, '', NULL, NULL, NULL),
(9458, '2016-10-01 10:50:03', NULL, NULL, 3362, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:50:03', 'admin-1475283098-14752902029797992', 1, 0, '', NULL, NULL, NULL),
(9459, '2016-10-01 10:50:03', NULL, NULL, 3362, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:50:03', 'admin-1475283098-14752902029797992', 1, 0, '', NULL, NULL, NULL),
(9460, '2016-10-01 10:50:03', NULL, NULL, 3362, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:50:03', 'admin-1475283098-14752902029797992', 1, 0, '', NULL, NULL, NULL),
(9461, '2016-10-01 10:50:03', NULL, NULL, 3362, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:50:03', 'admin-1475283098-14752902029797992', 1, 0, '', NULL, NULL, NULL),
(9462, '2016-10-01 10:50:03', NULL, NULL, 3362, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:50:03', 'admin-1475283098-14752902029797992', 1, 1, 'SR', NULL, NULL, NULL),
(9463, '2016-10-01 10:56:50', NULL, NULL, 3363, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:56:50', 'admin-1475283098-14752906105071886', 1, 1, 'SR', 1, NULL, NULL),
(9464, '2016-10-01 10:57:51', NULL, NULL, 3365, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:57:51', 'admin-1475283098-14752906717228738', 1, 0, '', NULL, NULL, NULL),
(9465, '2016-10-01 10:58:49', NULL, NULL, 3365, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:58:49', 'admin-1475290683-1475290729083666', 1, 1, 'SR', NULL, NULL, NULL),
(9466, '2016-10-01 20:54:18', NULL, NULL, 3397, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 20:54:18', 'admin-1475302551-14753264577646414', 1, 0, '', NULL, NULL, NULL),
(9467, '2016-10-01 11:01:27', NULL, NULL, 3368, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:01:27', 'admin-1475290683-14752908874525262', 1, 1, 'SR', NULL, NULL, NULL),
(9468, '2016-10-01 11:01:21', NULL, NULL, 3368, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:01:21', 'admin-1475290683-14752908811373822', 1, 1, 'SR', NULL, NULL, NULL),
(9469, '2016-10-01 11:00:33', NULL, NULL, 3367, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 11:00:33', 'admin-1475290683-1475290832840292', 1, 0, '', NULL, NULL, NULL),
(9470, '2016-10-01 10:26:01', NULL, NULL, 3360, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:26:01', 'admin-1475283098-14752887612591678', 1, 1, 'SR', NULL, NULL, NULL),
(9471, '2016-10-01 10:26:49', NULL, NULL, 3361, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:26:49', 'admin-1475283098-14752888096006419', 1, 1, 'SR', NULL, NULL, NULL),
(9472, '2016-10-01 09:30:14', NULL, NULL, 3357, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 09:30:14', 'admin-1475283098-1475285414069655', 1, 0, '', NULL, NULL, NULL),
(9473, '2016-10-01 10:07:24', NULL, NULL, 3358, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:07:24', 'admin-1475283098-14752876442997875', 1, 0, '', NULL, NULL, NULL),
(9474, '2016-10-01 10:07:24', NULL, NULL, 3358, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:07:24', 'admin-1475283098-14752876442997875', 1, 0, '', NULL, NULL, NULL),
(9475, '2016-10-01 10:59:38', NULL, NULL, 3366, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:59:38', 'admin-1475290683-14752907783568879', 1, 1, 'SR', NULL, NULL, NULL),
(9476, '2016-10-01 10:07:24', NULL, NULL, 3358, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:07:24', 'admin-1475283098-14752876442997875', 1, 1, 'SR', NULL, NULL, NULL),
(9477, '2016-10-01 10:26:01', NULL, NULL, 3360, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 3, 20.00, 60.0000, 0.0000, 60.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:26:01', 'admin-1475283098-14752887612591678', 1, 0, '', NULL, NULL, NULL),
(9478, '2016-10-01 10:26:01', NULL, NULL, 3360, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:26:01', 'admin-1475283098-14752887612591678', 1, 1, 'SR', NULL, NULL, NULL),
(9479, '2016-10-01 10:07:24', NULL, NULL, 3358, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:07:24', 'admin-1475283098-14752876442997875', 1, 1, 'SR', NULL, NULL, NULL),
(9480, '2016-10-01 10:59:38', NULL, NULL, 3366, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 10:59:38', 'admin-1475290683-14752907783568879', 1, 0, '', NULL, NULL, NULL),
(9481, '2016-10-01 09:30:14', NULL, NULL, 3357, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475328400', 'admin', '2016-10-01 09:30:14', 'admin-1475283098-1475285414069655', 1, 0, '', NULL, NULL, NULL),
(9482, '2016-10-02 20:06:46', NULL, NULL, 3445, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 20:06:46', 'admin-1475408080-14754100066724039', 1, 0, '', NULL, NULL, '10.0'),
(9483, '2016-10-02 20:11:13', NULL, NULL, 3446, 0, 211, '145', 'Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 20:11:13', 'admin-1475408080-14754102735952015', 1, 0, '', NULL, NULL, NULL),
(9484, '2016-10-02 20:11:13', NULL, NULL, 3446, 0, 78, '78', 'Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 20:11:13', 'admin-1475408080-14754102735952015', 1, 1, 'SR', NULL, NULL, NULL),
(9485, '2016-10-02 20:11:13', NULL, NULL, 3446, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 20:11:13', 'admin-1475408080-14754102735952015', 1, 0, '', NULL, NULL, NULL),
(9486, '2016-10-02 20:11:13', NULL, NULL, 3446, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 20:11:13', 'admin-1475408080-14754102735952015', 1, 1, 'SR', NULL, NULL, NULL),
(9487, '2016-10-02 20:11:13', NULL, NULL, 3446, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 20:11:13', 'admin-1475408080-14754102735952015', 1, 1, 'SR', NULL, NULL, NULL),
(9488, '2016-10-02 21:14:26', NULL, NULL, 3447, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 21:14:26', 'admin-1475408080-14754140664057080', 1, 1, 'SR', NULL, NULL, NULL),
(9489, '2016-10-02 21:14:26', NULL, NULL, 3447, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 21:14:26', 'admin-1475408080-14754140664057080', 1, 1, 'SR', NULL, NULL, NULL),
(9490, '2016-10-02 21:14:26', NULL, NULL, 3447, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 21:14:26', 'admin-1475408080-14754140664057080', 1, 1, 'SR', NULL, NULL, NULL),
(9491, '2016-10-02 21:15:24', NULL, NULL, 3447, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 21:15:24', 'admin-1475408080-14754141245753155', 1, 0, '', NULL, NULL, NULL),
(9492, '2016-10-02 15:00:45', NULL, NULL, 3423, 0, 217, '151', 'Spicy Lemony Wings', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 15:00:45', 'admin-1475388484-14753916448457249', 1, 0, '', NULL, NULL, NULL),
(9493, '2016-10-02 15:00:45', NULL, NULL, 3423, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 15:00:45', 'admin-1475388484-14753916448457249', 1, 0, '', NULL, NULL, NULL),
(9494, '2016-10-02 15:00:45', NULL, NULL, 3423, 0, 211, '145', 'Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 15:00:45', 'admin-1475388484-14753916448457249', 1, 0, '', NULL, NULL, NULL),
(9495, '2016-10-02 15:00:45', NULL, NULL, 3423, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 15:00:45', 'admin-1475388484-14753916448457249', 1, 0, '', NULL, NULL, NULL),
(9496, '2016-10-02 15:00:45', NULL, NULL, 3423, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 15:00:45', 'admin-1475388484-14753916448457249', 1, 1, 'SR', NULL, NULL, NULL),
(9497, '2016-10-02 15:01:08', NULL, NULL, 3423, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 15:01:08', 'admin-1475388484-14753916685818677', 1, 1, 'SR', NULL, NULL, NULL),
(9498, '2016-10-02 15:01:08', NULL, NULL, 3423, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 15:01:08', 'admin-1475388484-14753916685818677', 1, 1, 'SR', NULL, NULL, NULL),
(9499, '2016-10-02 15:01:08', NULL, NULL, 3423, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 15:01:08', 'admin-1475388484-14753916685818677', 1, 1, 'SR', NULL, NULL, NULL),
(9500, '2016-10-02 15:05:35', NULL, NULL, 3418, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 15:05:35', 'admin-1475388484-1475391935151638', 1, 0, '', NULL, NULL, NULL),
(9501, '2016-10-02 15:06:09', NULL, NULL, 3424, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 15:06:09', 'admin-1475388484-14753919693444482', 1, 0, '', NULL, NULL, NULL),
(9502, '2016-10-02 15:16:54', NULL, NULL, 3425, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 15:16:54', 'admin-1475388484-14753926147465756', 1, 1, 'SR', NULL, NULL, NULL),
(9503, '2016-10-02 15:16:54', NULL, NULL, 3425, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 15:16:54', 'admin-1475388484-14753926147465756', 1, 0, '', NULL, NULL, NULL),
(9504, '2016-10-02 15:18:36', NULL, NULL, 3426, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 15:18:36', 'admin-1475388484-1475392715962533', 1, 1, 'SR', NULL, NULL, NULL),
(9505, '2016-10-02 15:18:36', NULL, NULL, 3426, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 15:18:36', 'admin-1475388484-1475392715962533', 1, 1, 'SR', NULL, NULL, NULL),
(9506, '2016-10-02 15:31:53', NULL, NULL, 3427, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 15:31:53', 'admin-1475388484-1475393513249934', 1, 1, 'SR', NULL, NULL, NULL),
(9507, '2016-10-02 15:32:52', NULL, NULL, 3428, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 15:32:52', 'admin-1475388484-14753935726012550', 1, 0, '', NULL, NULL, NULL),
(9508, '2016-10-02 15:34:50', NULL, NULL, 3429, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 15:34:50', 'admin-1475388484-14753936899196163', 1, 0, '', NULL, NULL, NULL),
(9509, '2016-10-02 15:34:55', NULL, NULL, 3429, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 15:34:55', 'admin-1475388484-14753936948663741', 1, 1, 'SR', NULL, NULL, NULL),
(9510, '2016-10-02 15:43:05', NULL, NULL, 3430, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 15:43:05', 'admin-1475388484-14753941854979868', 1, 1, 'SR', NULL, NULL, NULL),
(9511, '2016-10-02 18:20:17', NULL, NULL, 3442, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 18:20:17', 'admin-1475395156-14754036172457825', 1, 1, 'SR', NULL, NULL, NULL),
(9512, '2016-10-02 18:02:11', NULL, NULL, 3441, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 18:02:11', 'admin-1475395156-14754025309573481', 1, 0, '', NULL, NULL, NULL),
(9513, '2016-10-02 18:02:11', NULL, NULL, 3441, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 18:02:11', 'admin-1475395156-14754025309573481', 1, 0, '', NULL, NULL, NULL),
(9514, '2016-10-02 17:59:30', NULL, NULL, 3439, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 17:59:30', 'admin-1475395156-14754023698778559', 1, 0, '', NULL, NULL, NULL),
(9515, '2016-10-02 18:01:11', NULL, NULL, 3440, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 18:01:11', 'admin-1475395156-1475402471139389', 1, 0, '', NULL, NULL, NULL),
(9516, '2016-10-02 16:25:41', NULL, NULL, 3435, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 16:25:41', 'admin-1475395156-1475396741664561', 1, 0, '', NULL, NULL, NULL),
(9517, '2016-10-02 20:06:46', NULL, NULL, 3445, 0, 220, '154', 'Crispy Bacon Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 20:06:46', 'admin-1475408080-14754100066724039', 1, 0, '', NULL, NULL, '10.0'),
(9518, '2016-10-02 20:06:46', NULL, NULL, 3445, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 20:06:46', 'admin-1475408080-14754100066724039', 1, 0, '', NULL, NULL, '10.0'),
(9519, '2016-10-02 20:03:09', NULL, NULL, 3444, 0, 190, '125', 'Tiger Bucket ', '', 'Cold Drinks', 'Soda & Beer', 1, 48.00, 48.0000, 0.0000, 48.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 20:03:09', 'admin-1475408080-1475409789438531', 1, 0, '', NULL, NULL, NULL),
(9520, '2016-10-02 10:58:53', NULL, NULL, 3407, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:58:53', 'admin-1475376918-14753771332814798', 1, 0, '', NULL, NULL, NULL),
(9521, '2016-10-02 11:00:28', NULL, NULL, 3407, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 11:00:28', 'admin-1475376918-14753772287285777', 1, 1, 'SR', NULL, NULL, NULL),
(9522, '2016-10-02 11:00:28', NULL, NULL, 3407, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 11:00:28', 'admin-1475376918-14753772287285777', 1, 1, 'SR', NULL, NULL, NULL),
(9523, '2016-10-02 11:19:36', NULL, NULL, 3408, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 11:19:36', 'admin-1475376918-14753783766886057', 1, 0, '', NULL, NULL, NULL),
(9524, '2016-10-02 11:22:14', NULL, NULL, 3409, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 11:22:14', 'admin-1475376918-14753785338465775', 1, 0, '', NULL, NULL, NULL),
(9525, '2016-10-02 11:22:14', NULL, NULL, 3409, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 11:22:14', 'admin-1475376918-14753785338465775', 1, 0, '', NULL, NULL, NULL),
(9526, '2016-10-02 11:22:14', NULL, NULL, 3409, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 11:22:14', 'admin-1475376918-14753785338465775', 1, 1, 'SR', NULL, NULL, NULL),
(9527, '2016-10-02 11:22:26', NULL, NULL, 3409, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 11:22:26', 'admin-1475376918-14753785460144833', 1, 0, '', NULL, NULL, NULL),
(9528, '2016-10-02 11:22:26', NULL, NULL, 3409, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 11:22:26', 'admin-1475376918-14753785460144833', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(9529, '2016-10-02 12:13:22', NULL, NULL, 3412, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 12:13:22', 'admin-1475376918-14753816020591398', 1, 0, '', NULL, NULL, NULL),
(9530, '2016-10-02 12:24:53', NULL, NULL, 3412, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 12:24:53', 'admin-1475376918-14753822936933753', 1, 0, '', NULL, NULL, NULL),
(9531, '2016-10-02 12:27:55', NULL, NULL, 3413, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 12:27:55', 'admin-1475376918-14753824755609684', 1, 0, '', NULL, NULL, '10.0'),
(9532, '2016-10-02 12:27:55', NULL, NULL, 3413, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 12:27:55', 'admin-1475376918-14753824755609684', 1, 1, 'SR', NULL, NULL, '10.0'),
(9533, '2016-10-02 13:18:32', NULL, NULL, 3414, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 13:18:32', 'admin-1475376918-14753855125396979', 1, 1, 'SR', 1, NULL, NULL),
(9534, '2016-10-02 13:18:52', NULL, NULL, 3415, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 13:18:52', 'admin-1475376918-14753855323379069', 1, 1, 'SR', 1, NULL, NULL),
(9535, '2016-10-02 13:36:46', NULL, NULL, 3416, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 13:36:46', 'admin-1475376918-14753866058768779', 1, 0, '', 1, NULL, NULL),
(9536, '2016-10-02 13:36:46', NULL, NULL, 3416, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 13:36:46', 'admin-1475376918-14753866058768779', 1, 0, '', 1, NULL, NULL),
(9537, '2016-10-02 13:41:50', NULL, NULL, 3417, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 13:41:50', 'admin-1475376918-1475386910573982', 1, 0, '', 1, NULL, NULL),
(9538, '2016-10-02 13:47:12', NULL, NULL, 3418, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 13:47:12', 'admin-1475376918-1475387232642232', 1, 1, 'SR', NULL, NULL, NULL),
(9539, '2016-10-02 14:07:55', NULL, NULL, 3419, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 14:07:55', 'admin-1475376918-14753884750529790', 1, 0, '', NULL, NULL, NULL),
(9540, '2016-10-02 14:07:55', NULL, NULL, 3419, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 14:07:55', 'admin-1475376918-14753884750529790', 1, 1, 'SR', NULL, NULL, NULL),
(9541, '2016-10-02 12:13:22', NULL, NULL, 3412, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 12:13:22', 'admin-1475376918-14753816020591398', 1, 1, 'SR', NULL, NULL, NULL),
(9542, '2016-10-02 11:22:26', NULL, NULL, 3409, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 11:22:26', 'admin-1475376918-14753785460144833', 1, 0, '', NULL, NULL, NULL),
(9543, '2016-10-02 12:01:48', NULL, NULL, 3410, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 12:01:48', 'admin-1475376918-14753809079113761', 1, 1, 'SR', NULL, NULL, NULL),
(9544, '2016-10-02 18:20:17', NULL, NULL, 3442, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 18:20:17', 'admin-1475395156-14754036172457825', 1, 1, 'SR', NULL, NULL, NULL),
(9545, '2016-10-02 18:13:27', NULL, NULL, 3439, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 18:13:27', 'admin-1475395156-14754032069786387', 1, 0, '', NULL, NULL, NULL),
(9546, '2016-10-02 18:02:11', NULL, NULL, 3441, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 18:02:11', 'admin-1475395156-14754025309573481', 1, 1, 'SR', NULL, NULL, NULL),
(9547, '2016-10-02 18:02:11', NULL, NULL, 3441, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 18:02:11', 'admin-1475395156-14754025309573481', 1, 1, 'SR', NULL, NULL, NULL),
(9548, '2016-10-02 18:02:11', NULL, NULL, 3441, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 18:02:11', 'admin-1475395156-14754025309573481', 1, 0, '', NULL, NULL, NULL),
(9549, '2016-10-02 18:01:11', NULL, NULL, 3440, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 18:01:11', 'admin-1475395156-1475402471139389', 1, 0, '', NULL, NULL, NULL),
(9550, '2016-10-02 18:01:11', NULL, NULL, 3440, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 18:01:11', 'admin-1475395156-1475402471139389', 1, 0, '', NULL, NULL, NULL),
(9551, '2016-10-02 17:35:51', NULL, NULL, 3438, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 17:35:51', 'admin-1475395156-14754009510396389', 1, 0, '', NULL, NULL, NULL),
(9552, '2016-10-02 17:55:24', NULL, NULL, 3432, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 17:55:24', 'admin-1475395156-14754021247982052', 1, 1, 'SR', NULL, NULL, NULL),
(9553, '2016-10-02 17:07:02', NULL, NULL, 3435, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 17:07:02', 'admin-1475395156-14753992223923628', 1, 0, '', NULL, NULL, NULL),
(9554, '2016-10-02 17:35:51', NULL, NULL, 3438, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 17:35:51', 'admin-1475395156-14754009510396389', 1, 1, 'SR', NULL, NULL, NULL),
(9555, '2016-10-02 16:57:19', NULL, NULL, 3437, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 16:57:19', 'admin-1475395156-1475398639699144', 1, 1, 'SR', NULL, NULL, NULL),
(9556, '2016-10-02 16:57:19', NULL, NULL, 3437, 0, 181, '116', 'Open Food ', 'Smoked duck salad', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 16:57:19', 'admin-1475395156-1475398639699144', 1, 0, '', NULL, NULL, NULL),
(9557, '2016-10-02 16:57:19', NULL, NULL, 3437, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 16:57:19', 'admin-1475395156-1475398639699144', 1, 1, 'SR', NULL, NULL, NULL),
(9558, '2016-10-02 16:25:41', NULL, NULL, 3435, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 16:25:41', 'admin-1475395156-1475396741664561', 1, 1, 'SR', NULL, NULL, NULL),
(9559, '2016-10-02 16:25:41', NULL, NULL, 3435, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 16:25:41', 'admin-1475395156-1475396741664561', 1, 1, 'SR', NULL, NULL, NULL),
(9560, '2016-10-02 16:12:26', NULL, NULL, 3434, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 2, 13.00, 26.0000, 0.0000, 26.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 16:12:26', 'admin-1475395156-14753959462385799', 1, 1, 'SR', NULL, NULL, NULL),
(9561, '2016-10-02 19:34:15', NULL, NULL, 3443, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 19:34:15', 'admin-1475395156-14754080555355912', 1, 0, '', NULL, NULL, NULL),
(9562, '2016-10-02 16:25:41', NULL, NULL, 3435, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 16:25:41', 'admin-1475395156-1475396741664561', 1, 1, 'SR', NULL, NULL, NULL),
(9563, '2016-10-02 16:12:26', NULL, NULL, 3434, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 16:12:26', 'admin-1475395156-14753959462385799', 1, 1, 'SR', NULL, NULL, NULL),
(9564, '2016-10-02 16:12:26', NULL, NULL, 3434, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 16:12:26', 'admin-1475395156-14753959462385799', 1, 0, '', NULL, NULL, NULL),
(9565, '2016-10-02 16:03:24', NULL, NULL, 3433, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 16:03:24', 'admin-1475395156-14753954038778233', 1, 1, 'SR', NULL, NULL, NULL),
(9566, '2016-10-02 15:51:47', NULL, NULL, 3432, 0, 194, '129', 'Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 15:51:47', 'admin-1475388484-14753947070331252', 1, 0, '', NULL, NULL, NULL),
(9567, '2016-10-02 15:49:01', NULL, NULL, 3431, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 15:49:01', 'admin-1475388484-14753945410783286', 1, 1, 'SR', 1, NULL, NULL),
(9568, '2016-10-02 15:43:05', NULL, NULL, 3430, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 15:43:05', 'admin-1475388484-14753941854979868', 1, 0, '', NULL, NULL, NULL),
(9569, '2016-10-02 14:51:11', NULL, NULL, 3422, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 14:51:11', 'admin-1475388484-14753910717185214', 1, 1, 'SR', NULL, NULL, NULL),
(9570, '2016-10-02 14:51:11', NULL, NULL, 3422, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 14:51:11', 'admin-1475388484-14753910717185214', 1, 1, 'SR', NULL, NULL, NULL),
(9571, '2016-10-02 14:33:05', NULL, NULL, 3421, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 14:33:05', 'admin-1475388484-1475389985240797', 1, 1, 'SR', NULL, NULL, NULL),
(9572, '2016-10-02 14:33:05', NULL, NULL, 3421, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 14:33:05', 'admin-1475388484-1475389985240797', 1, 1, 'SR', NULL, NULL, NULL),
(9573, '2016-10-02 14:33:05', NULL, NULL, 3421, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 14:33:05', 'admin-1475388484-1475389985240797', 1, 1, 'SR', NULL, NULL, NULL),
(9574, '2016-10-02 14:33:05', NULL, NULL, 3421, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 14:33:05', 'admin-1475388484-1475389985240797', 1, 0, '', NULL, NULL, NULL),
(9575, '2016-10-02 12:04:56', NULL, NULL, 3411, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 12:04:56', 'admin-1475376918-14753810967427256', 1, 1, 'SR', 1, NULL, NULL),
(9576, '2016-10-02 14:09:18', NULL, NULL, 3420, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 14:09:18', 'admin-1475388484-1475388558042166', 1, 1, 'SR', NULL, NULL, NULL),
(9577, '2016-10-02 14:09:18', NULL, NULL, 3420, 0, 76, '76', 'Sauted Mushroom Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 14:09:18', 'admin-1475388484-1475388558042166', 1, 1, 'SR', NULL, NULL, NULL),
(9578, '2016-10-02 14:33:05', NULL, NULL, 3421, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 14:33:05', 'admin-1475388484-1475389985240797', 1, 0, '', NULL, NULL, NULL),
(9579, '2016-10-02 10:58:53', NULL, NULL, 3407, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:58:53', 'admin-1475376918-14753771332814798', 1, 0, '', NULL, NULL, NULL),
(9580, '2016-10-02 10:06:50', NULL, NULL, 3403, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:06:50', 'admin-1475368873-147537401063122', 1, 0, '', NULL, NULL, NULL),
(9581, '2016-10-02 10:06:50', NULL, NULL, 3403, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:06:50', 'admin-1475368873-147537401063122', 1, 0, '', NULL, NULL, NULL),
(9582, '2016-10-02 10:06:50', NULL, NULL, 3403, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:06:50', 'admin-1475368873-147537401063122', 1, 0, '', NULL, NULL, NULL),
(9583, '2016-10-02 10:06:50', NULL, NULL, 3403, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:06:50', 'admin-1475368873-147537401063122', 1, 0, '', NULL, NULL, NULL),
(9584, '2016-10-02 10:06:50', NULL, NULL, 3403, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:06:50', 'admin-1475368873-147537401063122', 1, 1, 'SR', NULL, NULL, NULL),
(9585, '2016-10-02 10:06:50', NULL, NULL, 3403, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:06:50', 'admin-1475368873-147537401063122', 1, 1, 'SR', NULL, NULL, NULL),
(9586, '2016-10-02 10:30:46', NULL, NULL, 3404, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:30:46', 'admin-1475368873-1475375446620661', 1, 0, '', NULL, NULL, '10.0'),
(9587, '2016-10-02 10:30:46', NULL, NULL, 3404, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:30:46', 'admin-1475368873-1475375446620661', 1, 0, '', NULL, NULL, '10.0'),
(9588, '2016-10-02 10:30:46', NULL, NULL, 3404, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:30:46', 'admin-1475368873-1475375446620661', 1, 0, '', NULL, NULL, '10.0'),
(9589, '2016-10-02 10:30:46', NULL, NULL, 3404, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:30:46', 'admin-1475368873-1475375446620661', 1, 1, 'SR', NULL, NULL, '10.0'),
(9590, '2016-10-02 10:30:46', NULL, NULL, 3404, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:30:46', 'admin-1475368873-1475375446620661', 1, 1, 'SR', NULL, NULL, '10.0'),
(9591, '2016-10-02 10:30:46', NULL, NULL, 3404, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:30:46', 'admin-1475368873-1475375446620661', 1, 1, 'SR', NULL, NULL, '10.0'),
(9592, '2016-10-02 10:43:24', NULL, NULL, 3405, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:43:24', 'admin-1475368873-14753762040413477', 1, 1, 'SR', NULL, NULL, NULL),
(9593, '2016-10-02 10:45:53', NULL, NULL, 3406, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:45:53', 'admin-1475368873-1475376352975950', 1, 0, '', NULL, NULL, NULL),
(9594, '2016-10-02 10:45:53', NULL, NULL, 3406, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:45:53', 'admin-1475368873-1475376352975950', 1, 0, '', NULL, NULL, NULL),
(9595, '2016-10-02 10:45:53', NULL, NULL, 3406, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:45:53', 'admin-1475368873-1475376352975950', 1, 0, '', NULL, NULL, NULL),
(9596, '2016-10-02 10:45:53', NULL, NULL, 3406, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:45:53', 'admin-1475368873-1475376352975950', 1, 1, 'SR', NULL, NULL, NULL),
(9597, '2016-10-02 10:45:53', NULL, NULL, 3406, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:45:53', 'admin-1475368873-1475376352975950', 1, 1, 'SR', NULL, NULL, NULL),
(9598, '2016-10-02 10:45:53', NULL, NULL, 3406, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:45:53', 'admin-1475368873-1475376352975950', 1, 1, 'SR', NULL, NULL, NULL),
(9599, '2016-10-02 10:58:53', NULL, NULL, 3407, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:58:53', 'admin-1475376918-14753771332814798', 1, 0, '', NULL, NULL, NULL),
(9600, '2016-10-02 10:45:53', NULL, NULL, 3406, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:45:53', 'admin-1475368873-1475376352975950', 1, 1, 'SR', NULL, NULL, NULL),
(9601, '2016-10-02 09:52:52', NULL, NULL, 3399, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 09:52:52', 'admin-1475368873-1475373172009197', 1, 1, 'SR', NULL, NULL, NULL),
(9602, '2016-10-02 09:57:32', NULL, NULL, 3400, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 09:57:32', 'admin-1475368873-14753734518568452', 1, 1, 'SR', NULL, NULL, NULL),
(9603, '2016-10-02 09:59:05', NULL, NULL, 3401, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 09:59:05', 'admin-1475368873-14753735451815473', 1, 0, '', NULL, NULL, NULL),
(9604, '2016-10-02 09:59:05', NULL, NULL, 3401, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 09:59:05', 'admin-1475368873-14753735451815473', 1, 0, '', NULL, NULL, NULL),
(9605, '2016-10-02 10:00:01', NULL, NULL, 3402, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:00:01', 'admin-1475368873-14753736016893760', 1, 0, '', NULL, NULL, NULL),
(9606, '2016-10-02 10:00:01', NULL, NULL, 3402, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:00:01', 'admin-1475368873-14753736016893760', 1, 1, 'SR', NULL, NULL, NULL),
(9607, '2016-10-02 09:52:52', NULL, NULL, 3399, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 09:52:52', 'admin-1475368873-1475373172009197', 1, 0, '', NULL, NULL, NULL),
(9608, '2016-10-02 10:00:01', NULL, NULL, 3402, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:00:01', 'admin-1475368873-14753736016893760', 1, 0, '', NULL, NULL, NULL),
(9609, '2016-10-02 10:00:01', NULL, NULL, 3402, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:00:01', 'admin-1475368873-14753736016893760', 1, 0, '', NULL, NULL, NULL),
(9610, '2016-10-02 10:00:01', NULL, NULL, 3402, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 10:00:01', 'admin-1475368873-14753736016893760', 1, 0, '', NULL, NULL, NULL),
(9611, '2016-10-02 09:57:32', NULL, NULL, 3400, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 09:57:32', 'admin-1475368873-14753734518568452', 1, 0, '', NULL, NULL, NULL),
(9612, '2016-10-02 09:52:52', NULL, NULL, 3399, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 09:52:52', 'admin-1475368873-1475373172009197', 1, 1, 'SR', NULL, NULL, NULL),
(9613, '2016-10-02 09:52:52', NULL, NULL, 3399, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475408080', 'admin', '2016-10-02 09:52:52', 'admin-1475368873-1475373172009197', 1, 1, 'SR', NULL, NULL, NULL),
(9614, '2016-10-03 17:45:56', NULL, NULL, 3474, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 17:45:56', 'admin-1475465542-14754879557664748', 1, 0, '', NULL, NULL, NULL),
(9615, '2016-10-03 17:45:56', NULL, NULL, 3474, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 17:45:56', 'admin-1475465542-14754879557664748', 1, 1, 'SR', NULL, NULL, NULL),
(9616, '2016-10-03 12:13:18', NULL, NULL, 3460, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 12:13:18', 'admin-1475465542-1475467998348734', 1, 0, '', NULL, NULL, NULL),
(9617, '2016-10-03 12:22:44', NULL, NULL, 3460, 0, 82, '82', 'Set Rice Wine Ginger Pork', 'extra rice', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 12:22:44', 'admin-1475465542-14754685641018159', 1, 1, 'SR', NULL, NULL, NULL),
(9618, '2016-10-03 12:44:11', NULL, NULL, 3460, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 12:44:11', 'admin-1475465542-147546985181446', 1, 0, '', NULL, NULL, NULL),
(9619, '2016-10-03 13:14:46', NULL, NULL, 3461, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 13:14:46', 'admin-1475465542-1475471686666809', 1, 1, 'SR', NULL, NULL, NULL),
(9620, '2016-10-03 13:14:46', NULL, NULL, 3461, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 13:14:46', 'admin-1475465542-1475471686666809', 1, 1, 'SR', NULL, NULL, NULL),
(9621, '2016-10-03 13:20:01', NULL, NULL, 3462, 0, 220, '154', 'Crispy Bacon Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 13:20:01', 'admin-1475465542-14754720013928252', 1, 0, '', NULL, NULL, NULL),
(9622, '2016-10-03 13:20:01', NULL, NULL, 3462, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 13:20:01', 'admin-1475465542-14754720013928252', 1, 0, '', NULL, NULL, NULL),
(9623, '2016-10-03 13:20:01', NULL, NULL, 3462, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 13:20:01', 'admin-1475465542-14754720013928252', 1, 0, '', NULL, NULL, NULL),
(9624, '2016-10-03 13:20:01', NULL, NULL, 3462, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 13:20:01', 'admin-1475465542-14754720013928252', 1, 1, 'SR', NULL, NULL, NULL),
(9625, '2016-10-03 13:20:08', NULL, NULL, 3463, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 13:20:08', 'admin-1475465542-14754720084399275', 1, 1, 'SR', NULL, NULL, NULL),
(9626, '2016-10-03 13:24:46', NULL, NULL, 3462, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 13:24:46', 'admin-1475465542-14754722859245698', 1, 1, 'SR', NULL, NULL, NULL),
(9627, '2016-10-03 13:24:46', NULL, NULL, 3462, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 13:24:46', 'admin-1475465542-14754722859245698', 1, 0, '', NULL, NULL, NULL),
(9628, '2016-10-03 13:49:11', NULL, NULL, 3464, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 13:49:11', 'admin-1475465542-1475473751297394', 1, 1, 'SR', NULL, NULL, NULL),
(9629, '2016-10-03 13:49:11', NULL, NULL, 3464, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 13:49:11', 'admin-1475465542-1475473751297394', 1, 0, '', NULL, NULL, NULL),
(9630, '2016-10-03 13:50:20', NULL, NULL, 3464, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 13:50:20', 'admin-1475465542-14754738200235476', 1, 1, 'SR', NULL, NULL, NULL),
(9631, '2016-10-03 13:50:20', NULL, NULL, 3464, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 13:50:20', 'admin-1475465542-14754738200235476', 1, 1, 'SR', NULL, NULL, NULL),
(9632, '2016-10-03 13:55:25', NULL, NULL, 3460, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 13:55:25', 'admin-1475465542-14754741252547135', 1, 1, 'SR', NULL, NULL, NULL),
(9633, '2016-10-03 14:07:28', NULL, NULL, 3465, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 14:07:28', 'admin-1475465542-14754748479467144', 1, 1, 'SR', NULL, NULL, NULL),
(9634, '2016-10-03 14:26:10', NULL, NULL, 3466, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 14:26:10', 'admin-1475465542-14754759702056823', 1, 0, '', NULL, NULL, NULL),
(9635, '2016-10-03 14:26:10', NULL, NULL, 3466, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 14:26:10', 'admin-1475465542-14754759702056823', 1, 1, 'SR', NULL, NULL, NULL),
(9636, '2016-10-03 14:39:38', NULL, NULL, 3467, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 14:39:38', 'admin-1475465542-14754767786436197', 1, 1, 'SR', NULL, NULL, NULL),
(9637, '2016-10-03 18:19:39', NULL, NULL, 3475, 0, 162, '96', 'Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 18:19:39', 'admin-1475465542-14754899791921892', 1, 0, '', NULL, NULL, NULL),
(9638, '2016-10-03 18:19:05', NULL, NULL, 3475, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 18:19:05', 'admin-1475465542-14754899455517456', 1, 1, 'SR', NULL, NULL, NULL),
(9639, '2016-10-03 18:19:05', NULL, NULL, 3475, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 18:19:05', 'admin-1475465542-14754899455517456', 1, 1, 'SR', NULL, NULL, NULL),
(9640, '2016-10-03 18:19:05', NULL, NULL, 3475, 0, 222, '156', 'Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 18:19:05', 'admin-1475465542-14754899455517456', 1, 0, '', NULL, NULL, NULL),
(9641, '2016-10-03 18:19:05', NULL, NULL, 3475, 0, 75, '75', 'Sauted Mushroom Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 18:19:05', 'admin-1475465542-14754899455517456', 1, 0, '', NULL, NULL, NULL),
(9642, '2016-10-03 17:45:56', NULL, NULL, 3474, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 17:45:56', 'admin-1475465542-14754879557664748', 1, 1, 'SR', NULL, NULL, NULL),
(9643, '2016-10-03 17:26:30', NULL, NULL, 3473, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 17:26:30', 'admin-1475465542-1475486790294891', 1, 1, 'SR', NULL, NULL, NULL),
(9644, '2016-10-03 17:26:30', NULL, NULL, 3473, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 17:26:30', 'admin-1475465542-1475486790294891', 1, 1, 'SR', NULL, NULL, NULL),
(9645, '2016-10-03 17:45:56', NULL, NULL, 3474, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 17:45:56', 'admin-1475465542-14754879557664748', 1, 0, '', NULL, NULL, NULL),
(9646, '2016-10-03 17:13:44', NULL, NULL, 3472, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 17:13:44', 'admin-1475465542-14754860241085869', 1, 1, 'SR', NULL, NULL, NULL),
(9647, '2016-10-03 17:13:44', NULL, NULL, 3472, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 17:13:44', 'admin-1475465542-14754860241085869', 1, 1, 'SR', NULL, NULL, NULL),
(9648, '2016-10-03 16:21:15', NULL, NULL, 3471, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 16:21:15', 'admin-1475465542-14754828756901357', 1, 0, '', 1, NULL, NULL),
(9649, '2016-10-03 16:03:21', NULL, NULL, 3470, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 16:03:21', 'admin-1475465542-14754818013935389', 1, 1, 'SR', NULL, NULL, NULL),
(9650, '2016-10-03 14:39:38', NULL, NULL, 3467, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 14:39:38', 'admin-1475465542-14754767786436197', 1, 1, 'SR', NULL, NULL, NULL),
(9651, '2016-10-03 15:04:03', NULL, NULL, 3468, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 15:04:03', 'admin-1475465542-14754782437257779', 1, 0, '', NULL, NULL, NULL),
(9652, '2016-10-03 15:04:46', NULL, NULL, 3468, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 15:04:46', 'admin-1475465542-14754782864554624', 1, 0, '', NULL, NULL, NULL),
(9653, '2016-10-03 15:43:28', NULL, NULL, 3469, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 15:43:28', 'admin-1475465542-14754806079381472', 1, 1, 'SR', NULL, NULL, NULL),
(9654, '2016-10-03 15:43:28', NULL, NULL, 3469, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 15:43:28', 'admin-1475465542-14754806079381472', 1, 1, 'SR', NULL, NULL, NULL),
(9655, '2016-10-03 12:13:18', NULL, NULL, 3460, 0, 82, '82', 'Set Rice Wine Ginger Pork', 'extra rice', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 12:13:18', 'admin-1475465542-1475467998348734', 1, 1, 'SR', NULL, NULL, NULL),
(9656, '2016-10-03 09:31:08', NULL, NULL, 3450, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 09:31:08', 'admin-1475456291-14754582682274325', 1, 1, 'SR', NULL, NULL, NULL),
(9657, '2016-10-03 09:31:08', NULL, NULL, 3450, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 09:31:08', 'admin-1475456291-14754582682274325', 1, 1, 'SR', NULL, NULL, NULL),
(9658, '2016-10-03 09:31:08', NULL, NULL, 3450, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 09:31:08', 'admin-1475456291-14754582682274325', 1, 1, 'SR', NULL, NULL, NULL),
(9659, '2016-10-03 09:41:18', NULL, NULL, 3451, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 09:41:18', 'admin-1475456291-14754588782249610', 1, 0, '', NULL, NULL, NULL),
(9660, '2016-10-03 09:41:18', NULL, NULL, 3451, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 09:41:18', 'admin-1475456291-14754588782249610', 1, 1, 'SR', NULL, NULL, NULL),
(9661, '2016-10-03 09:43:02', NULL, NULL, 3452, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 09:43:02', 'admin-1475456291-1475458982401549', 1, 0, '', NULL, NULL, NULL),
(9662, '2016-10-03 09:43:02', NULL, NULL, 3452, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 09:43:02', 'admin-1475456291-1475458982401549', 1, 0, '', NULL, NULL, NULL),
(9663, '2016-10-03 09:43:02', NULL, NULL, 3452, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 09:43:02', 'admin-1475456291-1475458982401549', 1, 1, 'SR', NULL, NULL, NULL),
(9664, '2016-10-03 10:24:06', NULL, NULL, 3452, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 10:24:06', 'admin-1475459002-14754614465191096', 1, 1, 'SR', NULL, NULL, NULL),
(9665, '2016-10-03 10:09:50', NULL, NULL, 3453, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 10:09:50', 'admin-1475459002-14754605900756414', 1, 0, '', NULL, NULL, NULL),
(9666, '2016-10-03 10:10:35', NULL, NULL, 3454, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 10:10:35', 'admin-1475459002-14754606356744498', 1, 0, '', NULL, NULL, NULL),
(9667, '2016-10-03 10:18:12', NULL, NULL, 3455, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 10:18:12', 'admin-1475459002-14754610920326942', 1, 0, '', NULL, NULL, NULL),
(9668, '2016-10-03 10:18:12', NULL, NULL, 3455, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 10:18:12', 'admin-1475459002-14754610920326942', 1, 0, '', NULL, NULL, NULL),
(9669, '2016-10-03 10:18:12', NULL, NULL, 3455, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 10:18:12', 'admin-1475459002-14754610920326942', 1, 1, 'SR', NULL, NULL, NULL),
(9670, '2016-10-03 10:52:11', NULL, NULL, 3456, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 10:52:11', 'admin-1475459002-1475463131740879', 1, 0, '', NULL, NULL, NULL),
(9671, '2016-10-03 11:18:00', NULL, NULL, 3457, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 11:18:00', 'admin-1475459002-14754646800846329', 1, 0, '', NULL, NULL, NULL),
(9672, '2016-10-03 11:18:00', NULL, NULL, 3457, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 11:18:00', 'admin-1475459002-14754646800846329', 1, 0, '', NULL, NULL, NULL),
(9673, '2016-10-03 11:18:05', NULL, NULL, 3457, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 11:18:05', 'admin-1475459002-14754646854459937', 1, 1, 'SR', NULL, NULL, NULL),
(9674, '2016-10-03 11:32:15', NULL, NULL, 3458, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 11:32:15', 'admin-1475459002-14754655353156254', 1, 0, '', NULL, NULL, NULL),
(9675, '2016-10-03 14:39:38', NULL, NULL, 3467, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 14:39:38', 'admin-1475465542-14754767786436197', 1, 1, 'SR', NULL, NULL, NULL),
(9676, '2016-10-03 11:33:10', NULL, NULL, 3459, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 11:33:10', 'admin-1475465542-14754655907466333', 1, 0, '', NULL, NULL, NULL),
(9677, '2016-10-03 12:13:18', NULL, NULL, 3460, 0, 82, '82', 'Set Rice Wine Ginger Pork', 'extra rice', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 12:13:18', 'admin-1475465542-1475467998348734', 1, 1, 'SR', NULL, NULL, NULL),
(9678, '2016-10-03 11:32:15', NULL, NULL, 3458, 0, 153, '87', 'Big Breakfast ', 'no baked beans and salad', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 11:32:15', 'admin-1475459002-14754655353156254', 1, 0, '', NULL, NULL, NULL),
(9679, '2016-10-03 09:26:25', NULL, NULL, 3449, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 09:26:25', 'admin-1475456291-1475457984901452', 1, 0, '', NULL, NULL, NULL),
(9680, '2016-10-03 09:26:25', NULL, NULL, 3449, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 09:26:25', 'admin-1475456291-1475457984901452', 1, 0, '', NULL, NULL, NULL),
(9681, '2016-10-03 09:26:50', NULL, NULL, 3449, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 09:26:50', 'admin-1475456291-14754580102003749', 1, 1, 'SR', NULL, NULL, NULL),
(9682, '2016-10-03 09:26:50', NULL, NULL, 3449, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 09:26:50', 'admin-1475456291-14754580102003749', 1, 1, 'SR', NULL, NULL, NULL),
(9683, '2016-10-03 09:26:50', NULL, NULL, 3449, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 09:26:50', 'admin-1475456291-14754580102003749', 1, 1, 'SR', NULL, NULL, NULL),
(9684, '2016-10-03 09:05:29', NULL, NULL, 3448, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 09:05:29', 'admin-1475456291-14754567291713095', 1, 0, '', NULL, NULL, NULL),
(9685, '2016-10-03 09:05:29', NULL, NULL, 3448, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 09:05:29', 'admin-1475456291-14754567291713095', 1, 1, 'SR', NULL, NULL, NULL),
(9686, '2016-10-03 09:31:01', NULL, NULL, 3450, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 09:31:01', 'admin-1475456291-14754582614329766', 1, 0, '', NULL, NULL, NULL),
(9687, '2016-10-03 09:30:35', NULL, NULL, 3450, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 09:30:35', 'admin-1475456291-14754582357512475', 1, 0, '', NULL, NULL, NULL),
(9688, '2016-10-03 09:30:35', NULL, NULL, 3450, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 09:30:35', 'admin-1475456291-14754582357512475', 1, 0, '', NULL, NULL, NULL),
(9689, '2016-10-03 09:26:25', NULL, NULL, 3449, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 09:26:25', 'admin-1475456291-1475457984901452', 1, 0, '', NULL, NULL, NULL),
(9690, '2016-10-03 09:05:29', NULL, NULL, 3448, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475465542', 'admin', '2016-10-03 09:05:29', 'admin-1475456291-14754567291713095', 1, 0, '', NULL, NULL, NULL),
(9691, '2016-10-05 15:35:14', NULL, NULL, 3493, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 15:35:14', 'admin-1475642788-14756529140856158', 1, 0, '', NULL, NULL, NULL),
(9692, '2016-10-05 15:57:43', NULL, NULL, 3494, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 15:57:43', 'admin-1475642788-14756542629153739', 1, 0, '', NULL, NULL, NULL),
(9693, '2016-10-05 15:57:43', NULL, NULL, 3494, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 15:57:43', 'admin-1475642788-14756542629153739', 1, 1, 'SR', NULL, NULL, NULL),
(9694, '2016-10-05 16:01:08', NULL, NULL, 3495, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 16:01:08', 'admin-1475642788-14756544687419664', 1, 1, 'SR', NULL, NULL, NULL),
(9695, '2016-10-05 16:01:08', NULL, NULL, 3495, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 16:01:08', 'admin-1475642788-14756544687419664', 1, 1, 'SR', NULL, NULL, NULL),
(9696, '2016-10-05 16:55:38', NULL, NULL, 3496, 0, 54, '54', 'Chai Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 16:55:38', 'admin-1475642788-14756577380902728', 1, 1, 'SR', NULL, NULL, NULL),
(9697, '2016-10-05 16:55:38', NULL, NULL, 3496, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 16:55:38', 'admin-1475642788-14756577380902728', 1, 1, 'SR', NULL, NULL, NULL),
(9698, '2016-10-05 17:27:01', NULL, NULL, 3497, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 17:27:01', 'admin-1475642788-14756596212725723', 1, 1, 'SR', NULL, NULL, NULL),
(9699, '2016-10-05 18:14:46', NULL, NULL, 3498, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 18:14:46', 'admin-1475642788-14756624864203448', 1, 1, 'SR', NULL, NULL, NULL),
(9700, '2016-10-05 18:37:06', NULL, NULL, 3499, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 18:37:06', 'admin-1475642788-1475663826294183', 1, 1, 'SR', NULL, NULL, NULL),
(9701, '2016-10-05 18:37:06', NULL, NULL, 3499, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 18:37:06', 'admin-1475642788-1475663826294183', 1, 1, 'SR', NULL, NULL, NULL),
(9702, '2016-10-05 18:37:20', NULL, NULL, 3499, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 18:37:20', 'admin-1475642788-14756638401945634', 1, 0, '', NULL, NULL, NULL),
(9703, '2016-10-05 18:45:36', NULL, NULL, 3493, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 18:45:36', 'admin-1475642788-1475664336192737', 1, 0, '', NULL, NULL, NULL),
(9704, '2016-10-05 19:21:24', NULL, NULL, 3500, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 19:21:24', 'admin-1475642788-14756664847482173', 1, 1, 'SR', NULL, NULL, NULL),
(9705, '2016-10-05 19:21:32', NULL, NULL, 3500, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 19:21:32', 'admin-1475642788-14756664918545259', 1, 0, '', NULL, NULL, NULL),
(9706, '2016-10-05 20:02:35', NULL, NULL, 3501, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 20:02:35', 'admin-1475642788-14756689549646149', 1, 1, 'SR', NULL, NULL, NULL),
(9707, '2016-10-05 20:02:35', NULL, NULL, 3501, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 20:02:35', 'admin-1475642788-14756689549646149', 1, 0, '', NULL, NULL, NULL),
(9708, '2016-10-05 20:05:09', NULL, NULL, 3502, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 20:05:09', 'admin-1475642788-14756691091903688', 1, 0, '', NULL, NULL, NULL),
(9709, '2016-10-05 20:05:09', NULL, NULL, 3502, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 20:05:09', 'admin-1475642788-14756691091903688', 1, 0, '', NULL, NULL, NULL),
(9710, '2016-10-05 20:05:09', NULL, NULL, 3502, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 20:05:09', 'admin-1475642788-14756691091903688', 1, 0, '', NULL, NULL, NULL),
(9711, '2016-10-05 20:05:09', NULL, NULL, 3502, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 20:05:09', 'admin-1475642788-14756691091903688', 1, 1, 'SR', NULL, NULL, NULL),
(9712, '2016-10-05 20:15:16', NULL, NULL, 3500, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 20:15:16', 'admin-1475642788-14756697164608588', 1, 0, '', NULL, NULL, NULL),
(9713, '2016-10-05 20:27:55', NULL, NULL, 3503, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 20:27:55', 'admin-1475642788-14756704756589635', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(9714, '2016-10-05 20:27:55', NULL, NULL, 3503, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 20:27:55', 'admin-1475642788-14756704756589635', 1, 1, 'SR', NULL, NULL, NULL),
(9715, '2016-10-05 20:27:47', NULL, NULL, 3503, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 20:27:47', 'admin-1475642788-14756704669088877', 1, 0, '', NULL, NULL, NULL),
(9716, '2016-10-05 15:13:37', NULL, NULL, 3492, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 15:13:37', 'admin-1475642788-1475651617747771', 1, 1, 'SR', NULL, NULL, NULL),
(9717, '2016-10-05 15:13:37', NULL, NULL, 3492, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 15:13:37', 'admin-1475642788-1475651617747771', 1, 1, 'SR', NULL, NULL, NULL),
(9718, '2016-10-05 15:13:37', NULL, NULL, 3492, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 15:13:37', 'admin-1475642788-1475651617747771', 1, 0, '', NULL, NULL, NULL),
(9719, '2016-10-05 15:13:51', NULL, NULL, 3492, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 15:13:51', 'admin-1475642788-14756516309565039', 1, 1, 'SR', NULL, NULL, NULL),
(9720, '2016-10-05 15:31:17', NULL, NULL, 3493, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 15:31:17', 'admin-1475642788-14756526771971345', 1, 1, 'SR', NULL, NULL, NULL),
(9721, '2016-10-05 15:13:37', NULL, NULL, 3492, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 15:13:37', 'admin-1475642788-1475651617747771', 1, 0, '', NULL, NULL, NULL),
(9722, '2016-10-05 11:20:08', NULL, NULL, 3479, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 11:20:08', 'admin-1475631304-14756376083749624', 1, 1, 'SR', NULL, NULL, NULL),
(9723, '2016-10-05 12:02:05', NULL, NULL, 3482, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 12:02:05', 'admin-1475631304-14756401250315878', 1, 1, 'SR', NULL, NULL, NULL),
(9724, '2016-10-05 12:02:05', NULL, NULL, 3482, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 12:02:05', 'admin-1475631304-14756401250315878', 1, 0, '', NULL, NULL, NULL),
(9725, '2016-10-05 12:08:18', NULL, NULL, 3483, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 12:08:18', 'admin-1475631304-14756404978697849', 1, 0, '', NULL, NULL, NULL),
(9726, '2016-10-05 12:08:18', NULL, NULL, 3483, 0, 153, '87', 'Big Breakfast ', 'without salad', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 12:08:18', 'admin-1475631304-14756404978697849', 1, 0, '', NULL, NULL, NULL),
(9727, '2016-10-05 12:15:24', NULL, NULL, 3484, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 12:15:24', 'admin-1475631304-1475640923908299', 1, 0, '', NULL, NULL, NULL),
(9728, '2016-10-05 12:15:24', NULL, NULL, 3484, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 12:15:24', 'admin-1475631304-1475640923908299', 1, 0, '', NULL, NULL, NULL),
(9729, '2016-10-05 12:15:29', NULL, NULL, 3484, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 12:15:29', 'admin-1475631304-14756409291709796', 1, 1, 'SR', NULL, NULL, NULL),
(9730, '2016-10-05 12:40:32', NULL, NULL, 3485, 0, 83, '83', 'Set Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 12:40:32', 'admin-1475631304-14756424327742212', 1, 1, 'SR', NULL, NULL, NULL),
(9731, '2016-10-05 12:40:33', NULL, NULL, 3485, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 12:40:33', 'admin-1475631304-14756424327742212', 1, 0, '', NULL, NULL, NULL),
(9732, '2016-10-05 12:40:43', NULL, NULL, 3485, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 12:40:43', 'admin-1475631304-14756424434866543', 1, 1, 'SR', NULL, NULL, NULL),
(9733, '2016-10-05 12:41:46', NULL, NULL, 3486, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 12:41:46', 'admin-1475631304-1475642506034844', 1, 0, '', NULL, NULL, NULL),
(9734, '2016-10-05 12:41:46', NULL, NULL, 3486, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 12:41:46', 'admin-1475631304-1475642506034844', 1, 1, 'SR', NULL, NULL, NULL),
(9735, '2016-10-05 12:46:21', NULL, NULL, 3487, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 12:46:21', 'admin-1475631304-14756427813996067', 1, 1, 'SR', NULL, NULL, NULL),
(9736, '2016-10-05 12:46:21', NULL, NULL, 3487, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 12:46:21', 'admin-1475631304-14756427813996067', 1, 1, 'SR', NULL, NULL, NULL),
(9737, '2016-10-05 12:46:37', NULL, NULL, 3487, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 12:46:37', 'admin-1475642788-14756427977878211', 1, 1, 'SR', NULL, NULL, NULL),
(9738, '2016-10-05 12:52:33', NULL, NULL, 3485, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 12:52:33', 'admin-1475642788-14756431531667412', 1, 0, '', NULL, NULL, NULL),
(9739, '2016-10-05 12:57:03', NULL, NULL, 3488, 0, 214, '148', 'Set Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 12:57:03', 'admin-1475642788-14756434237576615', 1, 0, '', NULL, NULL, NULL),
(9740, '2016-10-05 12:57:03', NULL, NULL, 3488, 0, 83, '83', 'Set Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 12:57:03', 'admin-1475642788-14756434237576615', 1, 1, 'SR', NULL, NULL, NULL),
(9741, '2016-10-05 15:35:14', NULL, NULL, 3493, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 15:35:14', 'admin-1475642788-14756529140856158', 1, 1, 'SR', NULL, NULL, NULL),
(9742, '2016-10-05 13:55:46', NULL, NULL, 3490, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 13:55:46', 'admin-1475642788-1475646946618301', 1, 1, 'SR', NULL, NULL, NULL),
(9743, '2016-10-05 14:55:36', NULL, NULL, 3491, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 14:55:36', 'admin-1475642788-14756505359427430', 1, 1, 'SR', NULL, NULL, NULL),
(9744, '2016-10-05 14:55:36', NULL, NULL, 3491, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 14:55:36', 'admin-1475642788-14756505359427430', 1, 1, 'SR', NULL, NULL, NULL),
(9745, '2016-10-05 09:41:12', NULL, NULL, 3476, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 09:41:12', 'admin-1475631304-14756316725618697', 1, 1, 'SR', NULL, NULL, NULL),
(9746, '2016-10-05 10:07:34', NULL, NULL, 3477, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 10:07:34', 'admin-1475631304-14756332541814032', 1, 0, '', NULL, NULL, NULL),
(9747, '2016-10-05 10:07:38', NULL, NULL, 3477, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 10:07:38', 'admin-1475631304-14756332585324836', 1, 1, 'SR', NULL, NULL, NULL),
(9748, '2016-10-05 10:15:54', NULL, NULL, 3478, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 10:15:54', 'admin-1475631304-1475633753891367', 1, 0, '', NULL, NULL, NULL),
(9749, '2016-10-05 10:40:21', NULL, NULL, 3479, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 10:40:21', 'admin-1475631304-1475635221771208', 1, 0, '', NULL, NULL, NULL),
(9750, '2016-10-05 13:12:50', NULL, NULL, 3489, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 13:12:50', 'admin-1475642788-14756443697863587', 1, 1, 'SR', NULL, NULL, NULL),
(9751, '2016-10-05 13:12:50', NULL, NULL, 3489, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 13:12:50', 'admin-1475642788-14756443697863587', 1, 1, 'SR', NULL, NULL, NULL),
(9752, '2016-10-05 13:12:37', NULL, NULL, 3489, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 13:12:37', 'admin-1475642788-14756443575945824', 1, 0, '', NULL, NULL, NULL),
(9753, '2016-10-05 10:40:21', NULL, NULL, 3479, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 10:40:21', 'admin-1475631304-1475635221771208', 1, 1, 'SR', NULL, NULL, NULL),
(9754, '2016-10-05 11:08:41', NULL, NULL, 3480, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 11:08:41', 'admin-1475631304-14756369208615465', 1, 1, 'SR', NULL, NULL, NULL),
(9755, '2016-10-05 09:41:12', NULL, NULL, 3476, 0, 157, '91', 'French Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475642788', 'admin', '2016-10-05 09:41:12', 'admin-1475631304-14756316725618697', 1, 0, '', NULL, NULL, NULL),
(9756, '2016-10-06 16:05:40', NULL, NULL, 3518, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 16:05:40', 'admin-1475725961-14757411401068625', 1, 1, 'SR', NULL, NULL, NULL),
(9757, '2016-10-06 16:05:40', NULL, NULL, 3518, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 16:05:40', 'admin-1475725961-14757411401068625', 1, 1, 'SR', NULL, NULL, NULL),
(9758, '2016-10-06 16:05:40', NULL, NULL, 3518, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 16:05:40', 'admin-1475725961-14757411401068625', 1, 1, 'SR', NULL, NULL, NULL),
(9759, '2016-10-06 16:05:40', NULL, NULL, 3518, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 16:05:40', 'admin-1475725961-14757411401068625', 1, 0, '', NULL, NULL, NULL),
(9760, '2016-10-06 16:07:32', NULL, NULL, 3519, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 16:07:32', 'admin-1475725961-1475741252476887', 1, 1, 'SR', NULL, NULL, NULL),
(9761, '2016-10-06 16:07:32', NULL, NULL, 3519, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 16:07:32', 'admin-1475725961-1475741252476887', 1, 1, 'SR', NULL, NULL, NULL),
(9762, '2016-10-06 16:07:32', NULL, NULL, 3519, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 16:07:32', 'admin-1475725961-1475741252476887', 1, 1, 'SR', NULL, NULL, NULL),
(9763, '2016-10-06 16:07:32', NULL, NULL, 3519, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 16:07:32', 'admin-1475725961-1475741252476887', 1, 1, 'SR', NULL, NULL, NULL),
(9764, '2016-10-06 16:08:28', NULL, NULL, 3519, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 16:08:28', 'admin-1475725961-1475741308651122', 1, 1, 'SR', NULL, NULL, NULL),
(9765, '2016-10-06 16:16:45', NULL, NULL, 3520, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 16:16:45', 'admin-1475725961-14757418052647632', 1, 1, 'SR', NULL, NULL, NULL),
(9766, '2016-10-06 16:35:44', NULL, NULL, 3521, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 16:35:44', 'admin-1475725961-14757429443594132', 1, 0, '', NULL, NULL, NULL),
(9767, '2016-10-06 16:35:44', NULL, NULL, 3521, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 16:35:44', 'admin-1475725961-14757429443594132', 1, 0, '', NULL, NULL, NULL),
(9768, '2016-10-06 16:38:42', NULL, NULL, 3519, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 16:38:42', 'admin-1475725961-14757431225316285', 1, 0, '', NULL, NULL, NULL),
(9769, '2016-10-06 17:48:06', NULL, NULL, 3522, 0, 181, '116', 'Open Food ', 'orange', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 17:48:06', 'admin-1475725961-14757472858871595', 1, 0, '', NULL, NULL, NULL),
(9770, '2016-10-06 18:11:43', NULL, NULL, 3523, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 18:11:43', 'admin-1475725961-14757487033953145', 1, 1, 'SR', NULL, NULL, NULL),
(9771, '2016-10-06 18:11:43', NULL, NULL, 3523, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 18:11:43', 'admin-1475725961-14757487033953145', 1, 0, '', NULL, NULL, NULL),
(9772, '2016-10-06 18:43:12', NULL, NULL, 3524, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 18:43:12', 'admin-1475748709-14757505925288880', 1, 1, 'SR', NULL, NULL, NULL),
(9773, '2016-10-06 18:56:47', NULL, NULL, 3525, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 18:56:47', 'admin-1475748709-1475751407421755', 1, 1, 'SR', NULL, NULL, NULL),
(9774, '2016-10-06 18:56:47', NULL, NULL, 3525, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 18:56:47', 'admin-1475748709-1475751407421755', 1, 0, '', NULL, NULL, NULL),
(9775, '2016-10-06 18:56:47', NULL, NULL, 3525, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 18:56:47', 'admin-1475748709-1475751407421755', 1, 0, '', NULL, NULL, NULL),
(9776, '2016-10-06 19:37:06', NULL, NULL, 3526, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 19:37:06', 'admin-1475748709-14757538266268960', 1, 1, 'SR', NULL, NULL, NULL),
(9777, '2016-10-06 19:37:06', NULL, NULL, 3526, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 19:37:06', 'admin-1475748709-14757538266268960', 1, 0, '', NULL, NULL, NULL),
(9778, '2016-10-06 21:06:46', NULL, NULL, 3528, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 21:06:46', 'admin-1475748709-14757592067748552', 1, 0, '', NULL, NULL, NULL),
(9779, '2016-10-06 19:56:11', NULL, NULL, 3527, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 19:56:11', 'admin-1475748709-14757549712414166', 1, 1, 'SR', NULL, NULL, NULL),
(9780, '2016-10-06 19:55:21', NULL, NULL, 3527, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 19:55:21', 'admin-1475748709-14757549215656654', 1, 0, '', NULL, NULL, NULL),
(9781, '2016-10-06 19:56:11', NULL, NULL, 3527, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 19:56:11', 'admin-1475748709-14757549712414166', 1, 1, 'SR', NULL, NULL, NULL),
(9782, '2016-10-06 19:37:18', NULL, NULL, 3526, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 19:37:18', 'admin-1475748709-14757538383062644', 1, 1, 'SR', NULL, NULL, NULL),
(9783, '2016-10-06 19:54:25', NULL, NULL, 3527, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 19:54:25', 'admin-1475748709-14757548657882163', 1, 0, '', NULL, NULL, NULL),
(9784, '2016-10-06 19:54:26', NULL, NULL, 3527, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 19:54:26', 'admin-1475748709-14757548657882163', 1, 1, 'SR', NULL, NULL, NULL),
(9785, '2016-10-06 19:54:26', NULL, NULL, 3527, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 19:54:26', 'admin-1475748709-14757548657882163', 1, 0, '', NULL, NULL, NULL),
(9786, '2016-10-06 19:55:21', NULL, NULL, 3527, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 19:55:21', 'admin-1475748709-14757549215656654', 1, 0, '', NULL, NULL, NULL),
(9787, '2016-10-06 20:49:59', NULL, NULL, 3527, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 20:49:59', 'admin-1475748709-14757581996268936', 1, 1, 'SR', NULL, NULL, NULL),
(9788, '2016-10-06 11:40:19', NULL, NULL, 3510, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 11:40:19', 'admin-1475714739-1475725219387156', 1, 1, 'SR', NULL, NULL, NULL),
(9789, '2016-10-06 11:40:19', NULL, NULL, 3510, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 11:40:19', 'admin-1475714739-1475725219387156', 1, 1, 'SR', NULL, NULL, NULL),
(9790, '2016-10-06 12:23:27', NULL, NULL, 3512, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 12:23:27', 'admin-1475725961-14757278071573155', 1, 0, '', NULL, NULL, NULL),
(9791, '2016-10-06 11:53:38', NULL, NULL, 3511, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 11:53:38', 'admin-1475725961-14757260186044441', 1, 1, 'SR', NULL, NULL, NULL),
(9792, '2016-10-06 11:53:38', NULL, NULL, 3511, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 11:53:38', 'admin-1475725961-14757260186044441', 1, 1, 'SR', NULL, NULL, NULL),
(9793, '2016-10-06 11:53:38', NULL, NULL, 3511, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 11:53:38', 'admin-1475725961-14757260186044441', 1, 1, 'SR', NULL, NULL, NULL),
(9794, '2016-10-06 12:23:27', NULL, NULL, 3512, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 12:23:27', 'admin-1475725961-14757278071573155', 1, 0, '', NULL, NULL, NULL),
(9795, '2016-10-06 12:24:08', NULL, NULL, 3513, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 12:24:08', 'admin-1475725961-14757278479611179', 1, 1, 'SR', NULL, NULL, NULL),
(9796, '2016-10-06 13:09:13', NULL, NULL, 3514, 0, 224, '158', 'Set Garlic Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 13:09:13', 'admin-1475725961-14757305537023688', 1, 0, '', NULL, NULL, NULL),
(9797, '2016-10-06 13:09:13', NULL, NULL, 3514, 0, 85, '85', 'Set Sauted Mushroom Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 13:09:13', 'admin-1475725961-14757305537023688', 1, 1, 'SR', NULL, NULL, NULL),
(9798, '2016-10-06 13:55:37', NULL, NULL, 3515, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 13:55:37', 'admin-1475725961-14757333368311613', 1, 1, 'SR', NULL, NULL, NULL),
(9799, '2016-10-06 13:59:29', NULL, NULL, 3516, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 13:59:29', 'admin-1475725961-14757335689902622', 1, 0, '', NULL, NULL, NULL),
(9800, '2016-10-06 13:59:29', NULL, NULL, 3516, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 13:59:29', 'admin-1475725961-14757335689902622', 1, 0, '', NULL, NULL, NULL),
(9801, '2016-10-06 13:59:29', NULL, NULL, 3516, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 13:59:29', 'admin-1475725961-14757335689902622', 1, 1, 'SR', NULL, NULL, NULL),
(9802, '2016-10-06 13:59:29', NULL, NULL, 3516, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 13:59:29', 'admin-1475725961-14757335689902622', 1, 1, 'SR', NULL, NULL, NULL),
(9803, '2016-10-06 14:06:31', NULL, NULL, 3516, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 14:06:31', 'admin-1475725961-14757339908271815', 1, 0, '', NULL, NULL, NULL),
(9804, '2016-10-06 14:44:06', NULL, NULL, 3514, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 14:44:06', 'admin-1475725961-14757362466622049', 1, 1, 'SR', NULL, NULL, NULL),
(9805, '2016-10-06 15:32:23', NULL, NULL, 3517, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 15:32:23', 'admin-1475725961-14757391433466271', 1, 0, '', NULL, NULL, NULL),
(9806, '2016-10-06 15:32:23', NULL, NULL, 3517, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 15:32:23', 'admin-1475725961-14757391433466271', 1, 0, '', NULL, NULL, NULL),
(9807, '2016-10-06 15:32:23', NULL, NULL, 3517, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 15:32:23', 'admin-1475725961-14757391433466271', 1, 1, 'SR', NULL, NULL, NULL),
(9808, '2016-10-06 19:37:18', NULL, NULL, 3526, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 19:37:18', 'admin-1475748709-14757538383062644', 1, 1, 'SR', NULL, NULL, NULL),
(9809, '2016-10-06 09:25:00', NULL, NULL, 3506, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 09:25:00', 'admin-1475714739-14757171002401786', 1, 0, '', NULL, NULL, NULL),
(9810, '2016-10-06 10:31:19', NULL, NULL, 3507, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 10:31:19', 'admin-1475714739-14757210797304771', 1, 1, 'SR', NULL, NULL, NULL),
(9811, '2016-10-06 10:31:19', NULL, NULL, 3507, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 10:31:19', 'admin-1475714739-14757210797304771', 1, 1, 'SR', NULL, NULL, NULL),
(9812, '2016-10-06 10:31:19', NULL, NULL, 3507, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 10:31:19', 'admin-1475714739-14757210797304771', 1, 0, '', NULL, NULL, NULL),
(9813, '2016-10-06 11:02:28', NULL, NULL, 3508, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 11:02:28', 'admin-1475714739-1475722948411598', 1, 0, '', NULL, NULL, NULL),
(9814, '2016-10-06 11:02:28', NULL, NULL, 3508, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 11:02:28', 'admin-1475714739-1475722948411598', 1, 1, 'SR', NULL, NULL, NULL),
(9815, '2016-10-06 11:23:19', NULL, NULL, 3509, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 11:23:19', 'admin-1475714739-14757241992497236', 1, 1, 'SR', NULL, NULL, NULL),
(9816, '2016-10-06 09:25:00', NULL, NULL, 3506, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 09:25:00', 'admin-1475714739-14757171002401786', 1, 1, 'SR', NULL, NULL, NULL),
(9817, '2016-10-06 09:24:34', NULL, NULL, 3505, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 09:24:34', 'admin-1475714739-14757170741221892', 1, 1, 'SR', NULL, NULL, NULL),
(9818, '2016-10-06 09:24:34', NULL, NULL, 3505, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 09:24:34', 'admin-1475714739-14757170741221892', 1, 1, 'SR', NULL, NULL, NULL),
(9819, '2016-10-06 09:23:58', NULL, NULL, 3504, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 09:23:58', 'admin-1475714739-14757170386854858', 1, 0, '', NULL, NULL, NULL),
(9820, '2016-10-06 09:23:58', NULL, NULL, 3504, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 09:23:58', 'admin-1475714739-14757170386854858', 1, 0, '', NULL, NULL, NULL),
(9821, '2016-10-06 09:24:34', NULL, NULL, 3505, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 09:24:34', 'admin-1475714739-14757170741221892', 1, 0, '', NULL, NULL, NULL),
(9822, '2016-10-06 11:40:11', NULL, NULL, 3510, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 11:40:11', 'admin-1475714739-14757252112854579', 1, 0, '', NULL, NULL, NULL),
(9823, '2016-10-06 09:23:58', NULL, NULL, 3504, 0, 157, '91', 'French Toast with Fruits', 'add 2 bacon', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1475748709', 'admin', '2016-10-06 09:23:58', 'admin-1475714739-14757170386854858', 1, 0, '', NULL, NULL, NULL),
(9824, '2016-10-07 21:39:21', NULL, NULL, 3563, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 21:39:21', 'admin-1475843650-1475847561737141', 1, 1, 'SR', NULL, NULL, NULL),
(9825, '2016-10-07 21:39:21', NULL, NULL, 3563, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 21:39:21', 'admin-1475843650-1475847561737141', 1, 1, 'SR', NULL, NULL, NULL),
(9826, '2016-10-07 14:21:04', NULL, NULL, 3541, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 14:21:04', 'admin-1475816040-1475821264602639', 1, 0, '', NULL, NULL, NULL),
(9827, '2016-10-07 15:25:31', NULL, NULL, 3545, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 15:25:31', 'admin-1475816040-14758251315108520', 1, 0, '', NULL, NULL, NULL),
(9828, '2016-10-07 15:25:31', NULL, NULL, 3545, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 15:25:31', 'admin-1475816040-14758251315108520', 1, 1, 'SR', NULL, NULL, NULL),
(9829, '2016-10-07 15:25:31', NULL, NULL, 3545, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 15:25:31', 'admin-1475816040-14758251315108520', 1, 0, '', NULL, NULL, NULL),
(9830, '2016-10-07 15:36:55', NULL, NULL, 3545, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 15:36:55', 'admin-1475825142-147582581508038', 1, 1, 'SR', NULL, NULL, NULL),
(9831, '2016-10-07 15:52:30', NULL, NULL, 3546, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 15:52:30', 'admin-1475825142-14758267502354471', 1, 0, '', NULL, NULL, NULL),
(9832, '2016-10-07 15:52:30', NULL, NULL, 3546, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 15:52:30', 'admin-1475825142-14758267502354471', 1, 1, 'SR', NULL, NULL, NULL),
(9833, '2016-10-07 15:52:30', NULL, NULL, 3546, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 15:52:30', 'admin-1475825142-14758267502354471', 1, 0, '', NULL, NULL, NULL),
(9834, '2016-10-07 16:00:48', NULL, NULL, 3547, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 16:00:48', 'admin-1475825142-1475827248103684', 1, 0, '', NULL, NULL, NULL),
(9835, '2016-10-07 16:00:48', NULL, NULL, 3547, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 16:00:48', 'admin-1475825142-1475827248103684', 1, 1, 'SR', NULL, NULL, NULL),
(9836, '2016-10-07 16:00:48', NULL, NULL, 3547, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 16:00:48', 'admin-1475825142-1475827248103684', 1, 1, 'SR', NULL, NULL, NULL),
(9837, '2016-10-07 16:13:37', NULL, NULL, 3548, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 16:13:37', 'admin-1475825142-1475828017414652', 1, 1, 'SR', NULL, NULL, NULL),
(9838, '2016-10-07 16:13:37', NULL, NULL, 3548, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 16:13:37', 'admin-1475825142-1475828017414652', 1, 1, 'SR', NULL, NULL, NULL),
(9839, '2016-10-07 16:14:56', NULL, NULL, 3549, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 16:14:56', 'admin-1475825142-1475828096111288', 1, 0, '', NULL, NULL, NULL),
(9840, '2016-10-07 17:41:05', NULL, NULL, 3550, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 17:41:05', 'admin-1475825142-14758332653962743', 1, 1, 'SR', NULL, NULL, NULL),
(9841, '2016-10-07 17:41:05', NULL, NULL, 3550, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 17:41:05', 'admin-1475825142-14758332653962743', 1, 1, 'SR', NULL, NULL, NULL),
(9842, '2016-10-07 20:33:52', NULL, NULL, 3562, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 20:33:52', 'admin-1475825142-14758436320716749', 1, 0, '', NULL, NULL, NULL),
(9843, '2016-10-07 18:20:47', NULL, NULL, 3552, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 18:20:47', 'admin-1475825142-14758356469639265', 1, 1, 'SR', NULL, NULL, NULL),
(9844, '2016-10-07 18:22:19', NULL, NULL, 3553, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 18:22:19', 'admin-1475825142-14758357390084930', 1, 1, 'SR', NULL, NULL, NULL),
(9845, '2016-10-07 18:42:43', NULL, NULL, 3554, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 18:42:43', 'admin-1475825142-14758369635016036', 1, 0, '', NULL, NULL, NULL),
(9846, '2016-10-07 20:33:52', NULL, NULL, 3562, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 20:33:52', 'admin-1475825142-14758436320716749', 1, 1, 'SR', NULL, NULL, NULL),
(9847, '2016-10-07 20:31:36', NULL, NULL, 3555, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 20:31:36', 'admin-1475825142-14758434960426257', 1, 1, 'SR', NULL, NULL, NULL),
(9848, '2016-10-07 19:19:21', NULL, NULL, 3550, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 19:19:21', 'admin-1475825142-14758391610817265', 1, 0, '', NULL, NULL, NULL),
(9849, '2016-10-07 20:22:42', NULL, NULL, 3561, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 20:22:42', 'admin-1475825142-14758429623918680', 1, 1, 'SR', NULL, NULL, NULL),
(9850, '2016-10-07 20:22:42', NULL, NULL, 3561, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 20:22:42', 'admin-1475825142-14758429623918680', 1, 1, 'SR', NULL, NULL, NULL),
(9851, '2016-10-07 20:30:24', NULL, NULL, 3556, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 20:30:24', 'admin-1475825142-14758434242394419', 1, 1, 'SR', NULL, NULL, NULL),
(9852, '2016-10-07 20:34:20', NULL, NULL, 3562, 0, 222, '156', 'Seasoned Chicken Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 20:34:20', 'admin-1475843650-14758436601607641', 1, 0, '', NULL, NULL, NULL),
(9853, '2016-10-07 20:37:16', NULL, NULL, 3561, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 20:37:16', 'admin-1475843650-1475843835825609', 1, 1, 'SR', NULL, NULL, NULL),
(9854, '2016-10-07 20:44:46', NULL, NULL, 3562, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 20:44:46', 'admin-1475843650-14758442864665886', 1, 0, '', NULL, NULL, NULL),
(9855, '2016-10-07 20:21:40', NULL, NULL, 3560, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 20:21:40', 'admin-1475825142-14758428998763813', 1, 1, 'SR', NULL, NULL, NULL),
(9856, '2016-10-07 20:21:40', NULL, NULL, 3560, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 20:21:40', 'admin-1475825142-14758428998763813', 1, 1, 'SR', NULL, NULL, NULL),
(9857, '2016-10-07 20:18:31', NULL, NULL, 3559, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 20:18:31', 'admin-1475825142-14758427115044777', 1, 1, 'SR', NULL, NULL, NULL),
(9858, '2016-10-07 20:18:04', NULL, NULL, 3559, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 20:18:04', 'admin-1475825142-14758426843503583', 1, 0, '', NULL, NULL, NULL),
(9859, '2016-10-07 19:48:23', NULL, NULL, 3557, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 19:48:23', 'admin-1475825142-14758409028477361', 1, 1, 'SR', NULL, NULL, NULL),
(9860, '2016-10-07 20:09:16', NULL, NULL, 3558, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 20:09:16', 'admin-1475825142-14758421567001613', 1, 1, 'SR', NULL, NULL, NULL),
(9861, '2016-10-07 20:09:16', NULL, NULL, 3558, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 20:09:16', 'admin-1475825142-14758421567001613', 1, 1, 'SR', NULL, NULL, NULL),
(9862, '2016-10-07 19:34:34', NULL, NULL, 3555, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 19:34:34', 'admin-1475825142-14758400745738378', 1, 0, '', NULL, NULL, NULL),
(9863, '2016-10-07 19:48:12', NULL, NULL, 3556, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 19:48:12', 'admin-1475825142-14758408925177896', 1, 0, '', NULL, NULL, NULL),
(9864, '2016-10-07 19:48:12', NULL, NULL, 3556, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 19:48:12', 'admin-1475825142-14758408925177896', 1, 0, '', NULL, NULL, NULL),
(9865, '2016-10-07 19:48:23', NULL, NULL, 3557, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 19:48:23', 'admin-1475825142-14758409028477361', 1, 0, '', NULL, NULL, NULL),
(9866, '2016-10-07 19:48:23', NULL, NULL, 3557, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 19:48:23', 'admin-1475825142-14758409028477361', 1, 0, '', NULL, NULL, NULL),
(9867, '2016-10-07 13:33:32', NULL, NULL, 3543, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 13:33:32', 'admin-1475816040-14758184124763333', 1, 0, '', NULL, NULL, NULL),
(9868, '2016-10-07 13:33:32', NULL, NULL, 3543, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 13:33:32', 'admin-1475816040-14758184124763333', 1, 0, '', NULL, NULL, NULL),
(9869, '2016-10-07 13:34:05', NULL, NULL, 3543, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 13:34:05', 'admin-1475816040-14758184448396096', 1, 1, 'SR', NULL, NULL, NULL),
(9870, '2016-10-07 13:34:05', NULL, NULL, 3543, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 13:34:05', 'admin-1475816040-14758184448396096', 1, 1, 'SR', NULL, NULL, NULL),
(9871, '2016-10-07 13:52:36', NULL, NULL, 3544, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 13:52:36', 'admin-1475816040-14758195560227272', 1, 0, '', NULL, NULL, NULL),
(9872, '2016-10-07 09:16:48', NULL, NULL, 3529, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 09:16:48', 'admin-1475802181-14758030076441866', 1, 0, '', NULL, NULL, NULL),
(9873, '2016-10-07 10:08:53', NULL, NULL, 3530, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 10:08:53', 'admin-1475802181-14758061335519014', 1, 1, 'SR', NULL, NULL, NULL),
(9874, '2016-10-07 10:09:01', NULL, NULL, 3530, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 10:09:01', 'admin-1475802181-14758061412593296', 1, 1, 'SR', NULL, NULL, NULL),
(9875, '2016-10-07 10:09:01', NULL, NULL, 3530, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 10:09:01', 'admin-1475802181-14758061412593296', 1, 1, 'SR', NULL, NULL, NULL),
(9876, '2016-10-07 10:24:35', NULL, NULL, 3531, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 10:24:35', 'admin-1475802181-14758070751316088', 1, 0, '', NULL, NULL, '10.0'),
(9877, '2016-10-07 10:24:35', NULL, NULL, 3531, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 10:24:35', 'admin-1475802181-14758070751316088', 1, 0, '', NULL, NULL, '10.0'),
(9878, '2016-10-07 10:33:30', NULL, NULL, 3531, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 10:33:30', 'admin-1475802181-14758076104306521', 1, 0, '', NULL, NULL, '10.0'),
(9879, '2016-10-07 10:40:53', NULL, NULL, 3532, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 10:40:53', 'admin-1475802181-14758080532999244', 1, 1, 'SR', NULL, NULL, NULL),
(9880, '2016-10-07 10:40:53', NULL, NULL, 3532, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 10:40:53', 'admin-1475802181-14758080532999244', 1, 0, '', NULL, NULL, NULL),
(9881, '2016-10-07 11:14:18', NULL, NULL, 3533, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 11:14:18', 'admin-1475802181-14758100585647641', 1, 0, '', NULL, NULL, NULL),
(9882, '2016-10-07 11:14:18', NULL, NULL, 3533, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 11:14:18', 'admin-1475802181-14758100585647641', 1, 1, 'SR', NULL, NULL, NULL),
(9883, '2016-10-07 11:45:57', NULL, NULL, 3534, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 11:45:57', 'admin-1475802181-1475811956930475', 1, 1, 'SR', NULL, NULL, NULL),
(9884, '2016-10-07 11:47:18', NULL, NULL, 3535, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 11:47:18', 'admin-1475802181-14758120378595865', 1, 1, 'SR', NULL, NULL, NULL),
(9885, '2016-10-07 11:47:18', NULL, NULL, 3535, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 11:47:18', 'admin-1475802181-14758120378595865', 1, 1, 'SR', NULL, NULL, NULL),
(9886, '2016-10-07 12:15:24', NULL, NULL, 3536, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 12:15:24', 'admin-1475802181-14758137244277643', 1, 1, 'SR', NULL, NULL, NULL),
(9887, '2016-10-07 12:15:24', NULL, NULL, 3536, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 12:15:24', 'admin-1475802181-14758137244277643', 1, 0, '', NULL, NULL, NULL),
(9888, '2016-10-07 12:15:24', NULL, NULL, 3536, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 12:15:24', 'admin-1475802181-14758137244277643', 1, 1, 'SR', NULL, NULL, NULL),
(9889, '2016-10-07 12:15:24', NULL, NULL, 3536, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 12:15:24', 'admin-1475802181-14758137244277643', 1, 1, 'SR', NULL, NULL, NULL),
(9890, '2016-10-07 12:16:26', NULL, NULL, 3537, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 12:16:26', 'admin-1475802181-1475813786459690', 1, 0, '', NULL, NULL, NULL),
(9891, '2016-10-07 12:16:26', NULL, NULL, 3537, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 12:16:26', 'admin-1475802181-1475813786459690', 1, 1, 'SR', NULL, NULL, NULL),
(9892, '2016-10-07 12:42:56', NULL, NULL, 3538, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 12:42:56', 'admin-1475802181-14758153767579233', 1, 1, 'SR', NULL, NULL, NULL),
(9893, '2016-10-07 12:48:53', NULL, NULL, 3539, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 12:48:53', 'admin-1475802181-14758157330223634', 1, 1, 'SR', NULL, NULL, NULL),
(9894, '2016-10-07 12:54:19', NULL, NULL, 3540, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 12:54:19', 'admin-1475816040-14758160595809712', 1, 0, '', NULL, NULL, NULL),
(9895, '2016-10-07 12:53:08', NULL, NULL, 3540, 0, 214, '148', 'Set Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 12:53:08', 'admin-1475802181-14758159884822867', 1, 0, '', NULL, NULL, NULL),
(9896, '2016-10-07 12:54:27', NULL, NULL, 3540, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 12:54:27', 'admin-1475816040-14758160673142490', 1, 1, 'SR', NULL, NULL, NULL),
(9897, '2016-10-07 13:08:00', NULL, NULL, 3541, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 13:08:00', 'admin-1475816040-1475816880366683', 1, 0, '', NULL, NULL, NULL),
(9898, '2016-10-07 13:08:32', NULL, NULL, 3541, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 13:08:32', 'admin-1475816040-14758169122853533', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(9899, '2016-10-07 13:19:26', NULL, NULL, 3542, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 13:19:26', 'admin-1475816040-14758175657983438', 1, 1, 'SR', NULL, NULL, NULL),
(9900, '2016-10-07 13:19:32', NULL, NULL, 3542, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 13:19:32', 'admin-1475816040-14758175721097568', 1, 1, 'SR', NULL, NULL, NULL),
(9901, '2016-10-07 12:42:56', NULL, NULL, 3538, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 12:42:56', 'admin-1475802181-14758153767579233', 1, 0, '', NULL, NULL, NULL),
(9902, '2016-10-07 12:42:56', NULL, NULL, 3538, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 12:42:56', 'admin-1475802181-14758153767579233', 1, 0, '', NULL, NULL, NULL),
(9903, '2016-10-07 12:43:09', NULL, NULL, 3538, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 12:43:09', 'admin-1475802181-14758153890109675', 1, 0, '', NULL, NULL, NULL),
(9904, '2016-10-07 12:48:53', NULL, NULL, 3539, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 12:48:53', 'admin-1475802181-14758157330223634', 1, 1, 'SR', NULL, NULL, NULL),
(9905, '2016-10-07 12:43:09', NULL, NULL, 3538, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 12:43:09', 'admin-1475802181-14758153890109675', 1, 1, 'SR', NULL, NULL, NULL),
(9906, '2016-10-07 09:16:47', NULL, NULL, 3529, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475843650', 'admin', '2016-10-07 09:16:47', 'admin-1475802181-14758030076441866', 1, 0, '', NULL, NULL, NULL),
(9907, '2016-10-08 20:01:33', NULL, NULL, 3594, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 20:01:33', 'admin-1475914975-1475928093288529', 1, 1, 'SR', NULL, NULL, NULL),
(9908, '2016-10-08 13:57:22', NULL, NULL, 3578, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 13:57:22', 'admin-1475892707-14759062423122828', 1, 0, '', NULL, NULL, NULL),
(9909, '2016-10-08 13:57:38', NULL, NULL, 3578, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 13:57:38', 'admin-1475892707-14759062585338182', 1, 0, '', NULL, NULL, NULL),
(9910, '2016-10-08 14:06:36', NULL, NULL, 3579, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 14:06:36', 'admin-1475892707-14759067962593868', 1, 0, '', NULL, NULL, NULL),
(9911, '2016-10-08 14:06:36', NULL, NULL, 3579, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 14:06:36', 'admin-1475892707-14759067962593868', 1, 0, '', NULL, NULL, NULL),
(9912, '2016-10-08 14:27:22', NULL, NULL, 3580, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 14:27:22', 'admin-1475906803-14759080422723776', 1, 1, 'SR', NULL, NULL, NULL),
(9913, '2016-10-08 14:27:22', NULL, NULL, 3580, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 14:27:22', 'admin-1475906803-14759080422723776', 1, 1, 'SR', NULL, NULL, NULL),
(9914, '2016-10-08 14:27:22', NULL, NULL, 3580, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 14:27:22', 'admin-1475906803-14759080422723776', 1, 0, '', NULL, NULL, NULL),
(9915, '2016-10-08 14:27:55', NULL, NULL, 3580, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 14:27:55', 'admin-1475906803-14759080756784795', 1, 1, 'SR', NULL, NULL, NULL),
(9916, '2016-10-08 14:54:58', NULL, NULL, 3581, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 14:54:58', 'admin-1475906803-14759096987085784', 1, 0, '', NULL, NULL, NULL),
(9917, '2016-10-08 14:55:08', NULL, NULL, 3582, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 14:55:08', 'admin-1475906803-14759097084049864', 1, 1, 'SR', NULL, NULL, NULL),
(9918, '2016-10-08 15:00:56', NULL, NULL, 3583, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 15:00:56', 'admin-1475906803-14759100566332881', 1, 1, 'SR', NULL, NULL, NULL),
(9919, '2016-10-08 15:00:56', NULL, NULL, 3583, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 15:00:56', 'admin-1475906803-14759100566332881', 1, 1, 'SR', NULL, NULL, NULL),
(9920, '2016-10-08 15:01:48', NULL, NULL, 3584, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 15:01:48', 'admin-1475906803-14759101086522729', 1, 1, 'SR', NULL, NULL, NULL),
(9921, '2016-10-08 15:01:48', NULL, NULL, 3584, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 15:01:48', 'admin-1475906803-14759101086522729', 1, 1, 'SR', NULL, NULL, NULL),
(9922, '2016-10-08 15:36:39', NULL, NULL, 3585, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 15:36:39', 'admin-1475906803-14759121996731868', 1, 1, 'SR', NULL, NULL, NULL),
(9923, '2016-10-08 15:36:39', NULL, NULL, 3585, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 15:36:39', 'admin-1475906803-14759121996731868', 1, 1, 'SR', NULL, NULL, NULL),
(9924, '2016-10-08 16:15:10', NULL, NULL, 3586, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 16:15:10', 'admin-1475906803-14759145103994489', 1, 0, '', NULL, NULL, NULL),
(9925, '2016-10-08 16:23:20', NULL, NULL, 3587, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 16:23:20', 'admin-1475914975-14759150003054128', 1, 0, '', NULL, NULL, NULL),
(9926, '2016-10-08 20:56:37', NULL, NULL, 3599, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 20:56:37', 'admin-1475929383-14759313968116336', 1, 0, '', NULL, NULL, NULL),
(9927, '2016-10-08 20:50:13', NULL, NULL, 3598, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 20:50:13', 'admin-1475929383-14759310129468561', 1, 0, '', NULL, NULL, NULL),
(9928, '2016-10-08 20:50:13', NULL, NULL, 3598, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 20:50:13', 'admin-1475929383-14759310129468561', 1, 0, '', NULL, NULL, NULL),
(9929, '2016-10-08 20:01:33', NULL, NULL, 3594, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 20:01:33', 'admin-1475914975-1475928093288529', 1, 1, 'SR', NULL, NULL, NULL),
(9930, '2016-10-08 20:00:35', NULL, NULL, 3594, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 20:00:35', 'admin-1475914975-1475928034837605', 1, 1, 'SR', NULL, NULL, NULL),
(9931, '2016-10-08 20:00:35', NULL, NULL, 3594, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 20:00:35', 'admin-1475914975-1475928034837605', 1, 1, 'SR', NULL, NULL, NULL),
(9932, '2016-10-08 20:00:35', NULL, NULL, 3594, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 20:00:35', 'admin-1475914975-1475928034837605', 1, 0, '', NULL, NULL, NULL),
(9933, '2016-10-08 19:49:34', NULL, NULL, 3593, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 19:49:34', 'admin-1475914975-1475927374276788', 1, 1, 'SR', NULL, NULL, NULL),
(9934, '2016-10-08 19:49:34', NULL, NULL, 3593, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 19:49:34', 'admin-1475914975-1475927374276788', 1, 1, 'SR', NULL, NULL, NULL),
(9935, '2016-10-08 19:49:34', NULL, NULL, 3593, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 19:49:34', 'admin-1475914975-1475927374276788', 1, 1, 'SR', NULL, NULL, NULL),
(9936, '2016-10-08 19:49:34', NULL, NULL, 3593, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 19:49:34', 'admin-1475914975-1475927374276788', 1, 1, 'SR', NULL, NULL, NULL),
(9937, '2016-10-08 19:49:09', NULL, NULL, 3593, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 19:49:09', 'admin-1475914975-14759273496421162', 1, 0, '', NULL, NULL, NULL),
(9938, '2016-10-08 19:49:09', NULL, NULL, 3593, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 19:49:09', 'admin-1475914975-14759273496421162', 1, 1, 'SR', NULL, NULL, NULL),
(9939, '2016-10-08 19:49:09', NULL, NULL, 3593, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 19:49:09', 'admin-1475914975-14759273496421162', 1, 1, 'SR', NULL, NULL, NULL),
(9940, '2016-10-08 19:49:09', NULL, NULL, 3593, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 19:49:09', 'admin-1475914975-14759273496421162', 1, 0, '', NULL, NULL, NULL),
(9941, '2016-10-08 19:49:09', NULL, NULL, 3593, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 19:49:09', 'admin-1475914975-14759273496421162', 1, 0, '', NULL, NULL, NULL),
(9942, '2016-10-08 19:24:39', NULL, NULL, 3592, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 19:24:39', 'admin-1475914975-1475925878956474', 1, 1, 'SR', NULL, NULL, NULL),
(9943, '2016-10-08 19:20:34', NULL, NULL, 3592, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 19:20:34', 'admin-1475914975-14759256346417615', 1, 0, '', NULL, NULL, NULL),
(9944, '2016-10-08 18:47:01', NULL, NULL, 3591, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 18:47:01', 'admin-1475914975-14759236215876544', 1, 1, 'SR', NULL, NULL, NULL),
(9945, '2016-10-08 18:47:01', NULL, NULL, 3591, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 18:47:01', 'admin-1475914975-14759236215876544', 1, 0, '', NULL, NULL, NULL),
(9946, '2016-10-08 18:31:37', NULL, NULL, 3590, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 18:31:37', 'admin-1475914975-1475922696964758', 1, 1, 'SR', NULL, NULL, NULL),
(9947, '2016-10-08 18:31:37', NULL, NULL, 3590, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 18:31:37', 'admin-1475914975-1475922696964758', 1, 0, '', NULL, NULL, NULL),
(9948, '2016-10-08 18:26:18', NULL, NULL, 3589, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 18:26:18', 'admin-1475914975-14759223779771247', 1, 0, '', NULL, NULL, NULL),
(9949, '2016-10-08 18:26:03', NULL, NULL, 3589, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 18:26:03', 'admin-1475914975-14759223633449310', 1, 1, 'SR', NULL, NULL, NULL),
(9950, '2016-10-08 21:03:42', NULL, NULL, 3600, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 21:03:42', 'admin-1475929383-14759318219106171', 1, 1, 'SR', NULL, NULL, NULL),
(9951, '2016-10-08 21:02:49', NULL, NULL, 3600, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 21:02:49', 'admin-1475929383-14759317691525497', 1, 1, 'SR', NULL, NULL, NULL),
(9952, '2016-10-08 20:50:18', NULL, NULL, 3598, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 20:50:18', 'admin-1475929383-14759310183861861', 1, 1, 'SR', NULL, NULL, NULL),
(9953, '2016-10-08 20:50:18', NULL, NULL, 3598, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 20:50:18', 'admin-1475929383-14759310183861861', 1, 1, 'SR', NULL, NULL, NULL),
(9954, '2016-10-08 18:26:03', NULL, NULL, 3589, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 18:26:03', 'admin-1475914975-14759223633449310', 1, 1, 'SR', NULL, NULL, NULL),
(9955, '2016-10-08 18:26:03', NULL, NULL, 3589, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 18:26:03', 'admin-1475914975-14759223633449310', 1, 0, '', NULL, NULL, NULL),
(9956, '2016-10-08 16:32:44', NULL, NULL, 3588, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 16:32:44', 'admin-1475914975-1475915563994134', 1, 1, 'SR', NULL, NULL, NULL),
(9957, '2016-10-08 16:24:28', NULL, NULL, 3587, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 16:24:28', 'admin-1475914975-147591506827183', 1, 1, 'SR', NULL, NULL, NULL),
(9958, '2016-10-08 16:23:20', NULL, NULL, 3587, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 16:23:20', 'admin-1475914975-14759150003054128', 1, 1, 'SR', NULL, NULL, NULL),
(9959, '2016-10-08 20:50:13', NULL, NULL, 3598, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 20:50:13', 'admin-1475929383-14759310129468561', 1, 1, 'SR', NULL, NULL, NULL),
(9960, '2016-10-08 20:45:00', NULL, NULL, 3597, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 20:45:00', 'admin-1475929383-14759306998712892', 1, 1, 'SR', NULL, NULL, NULL),
(9961, '2016-10-08 20:45:00', NULL, NULL, 3597, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 20:45:00', 'admin-1475929383-14759306998712892', 1, 0, '', NULL, NULL, NULL),
(9962, '2016-10-08 20:16:34', NULL, NULL, 3596, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 20:16:34', 'admin-1475914975-14759289945971163', 1, 1, 'SR', NULL, NULL, NULL),
(9963, '2016-10-08 20:45:00', NULL, NULL, 3597, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 20:45:00', 'admin-1475929383-14759306998712892', 1, 1, 'SR', NULL, NULL, NULL),
(9964, '2016-10-08 20:10:24', NULL, NULL, 3596, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 20:10:24', 'admin-1475914975-14759286246609683', 1, 1, 'SR', NULL, NULL, NULL),
(9965, '2016-10-08 20:16:34', NULL, NULL, 3596, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 20:16:34', 'admin-1475914975-14759289945971163', 1, 1, 'SR', NULL, NULL, NULL),
(9966, '2016-10-08 20:10:24', NULL, NULL, 3596, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 20:10:24', 'admin-1475914975-14759286246609683', 1, 1, 'SR', NULL, NULL, NULL),
(9967, '2016-10-08 20:07:18', NULL, NULL, 3595, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 20:07:18', 'admin-1475914975-14759284382565524', 1, 0, '', NULL, NULL, NULL),
(9968, '2016-10-08 16:23:20', NULL, NULL, 3587, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 16:23:20', 'admin-1475914975-14759150003054128', 1, 0, '', NULL, NULL, NULL),
(9969, '2016-10-08 20:07:18', NULL, NULL, 3595, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 20:07:18', 'admin-1475914975-14759284382565524', 1, 0, '', NULL, NULL, NULL),
(9970, '2016-10-08 13:51:37', NULL, NULL, 3577, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 13:51:37', 'admin-1475892707-14759058974973936', 1, 0, '', NULL, NULL, NULL),
(9971, '2016-10-08 13:51:37', NULL, NULL, 3577, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 13:51:37', 'admin-1475892707-14759058974973936', 1, 1, 'SR', NULL, NULL, NULL),
(9972, '2016-10-08 13:57:22', NULL, NULL, 3578, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 13:57:22', 'admin-1475892707-14759062423122828', 1, 0, '', NULL, NULL, NULL),
(9973, '2016-10-08 13:57:22', NULL, NULL, 3578, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 13:57:22', 'admin-1475892707-14759062423122828', 1, 0, '', NULL, NULL, NULL),
(9974, '2016-10-08 12:58:24', NULL, NULL, 3574, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 12:58:24', 'admin-1475892707-14759027042828935', 1, 1, 'SR', NULL, NULL, NULL),
(9975, '2016-10-08 12:58:24', NULL, NULL, 3574, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 12:58:24', 'admin-1475892707-14759027042828935', 1, 0, '', NULL, NULL, NULL),
(9976, '2016-10-08 12:58:34', NULL, NULL, 3574, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 12:58:34', 'admin-1475892707-1475902714331149', 1, 0, '', NULL, NULL, NULL),
(9977, '2016-10-08 13:12:34', NULL, NULL, 3576, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 13:12:34', 'admin-1475892707-14759035545763949', 1, 0, '', NULL, NULL, NULL),
(9978, '2016-10-08 13:12:34', NULL, NULL, 3576, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 13:12:34', 'admin-1475892707-14759035545763949', 1, 1, 'SR', NULL, NULL, NULL),
(9979, '2016-10-08 13:06:44', NULL, NULL, 3575, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 13:06:44', 'admin-1475892707-14759032039189539', 1, 1, 'SR', NULL, NULL, NULL),
(9980, '2016-10-08 12:58:34', NULL, NULL, 3574, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 12:58:34', 'admin-1475892707-1475902714331149', 1, 0, '', NULL, NULL, NULL),
(9981, '2016-10-08 09:42:35', NULL, NULL, 3565, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 09:42:35', 'admin-1475888684-14758909557921334', 1, 1, 'SR', NULL, NULL, NULL),
(9982, '2016-10-08 09:42:35', NULL, NULL, 3565, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 09:42:35', 'admin-1475888684-14758909557921334', 1, 1, 'SR', NULL, NULL, NULL),
(9983, '2016-10-08 09:43:23', NULL, NULL, 3566, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 09:43:23', 'admin-1475888684-14758910037318353', 1, 0, '', NULL, NULL, NULL),
(9984, '2016-10-08 09:43:23', NULL, NULL, 3566, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 09:43:23', 'admin-1475888684-14758910037318353', 1, 0, '', NULL, NULL, NULL),
(9985, '2016-10-08 09:43:23', NULL, NULL, 3566, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 09:43:23', 'admin-1475888684-14758910037318353', 1, 0, '', NULL, NULL, NULL),
(9986, '2016-10-08 09:43:48', NULL, NULL, 3566, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 09:43:48', 'admin-1475888684-14758910283827620', 1, 1, 'SR', NULL, NULL, NULL),
(9987, '2016-10-08 12:58:24', NULL, NULL, 3574, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 12:58:24', 'admin-1475892707-14759027042828935', 1, 1, 'SR', NULL, NULL, NULL),
(9988, '2016-10-08 12:58:24', NULL, NULL, 3574, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 12:58:24', 'admin-1475892707-14759027042828935', 1, 1, 'SR', NULL, NULL, NULL),
(9989, '2016-10-08 12:58:24', NULL, NULL, 3574, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 12:58:24', 'admin-1475892707-14759027042828935', 1, 1, 'SR', NULL, NULL, NULL),
(9990, '2016-10-08 12:58:24', NULL, NULL, 3574, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 12:58:24', 'admin-1475892707-14759027042828935', 1, 1, 'SR', NULL, NULL, NULL),
(9991, '2016-10-08 12:15:23', NULL, NULL, 3573, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 12:15:23', 'admin-1475892707-1475900123655953', 1, 0, '', NULL, NULL, NULL),
(9992, '2016-10-08 11:38:21', NULL, NULL, 3573, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 11:38:21', 'admin-1475892707-14758979010111421', 1, 0, '', NULL, NULL, NULL),
(9993, '2016-10-08 11:37:45', NULL, NULL, 3573, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 11:37:45', 'admin-1475892707-14758978650655859', 1, 0, '', NULL, NULL, NULL),
(9994, '2016-10-08 11:14:16', NULL, NULL, 3572, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 11:14:16', 'admin-1475892707-14758964566357317', 1, 1, 'SR', NULL, NULL, NULL),
(9995, '2016-10-08 10:35:25', NULL, NULL, 3570, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 10:35:25', 'admin-1475892707-14758941255702443', 1, 1, 'SR', NULL, NULL, NULL),
(9996, '2016-10-08 10:35:15', NULL, NULL, 3570, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 10:35:15', 'admin-1475892707-1475894115756479', 1, 0, '', NULL, NULL, NULL),
(9997, '2016-10-08 10:30:26', NULL, NULL, 3571, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 10:30:26', 'admin-1475892707-14758938266056293', 1, 1, 'SR', NULL, NULL, '10.0'),
(9998, '2016-10-08 10:30:26', NULL, NULL, 3571, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 10:30:26', 'admin-1475892707-14758938266056293', 1, 1, 'SR', NULL, NULL, '10.0'),
(9999, '2016-10-08 10:30:26', NULL, NULL, 3571, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 10:30:26', 'admin-1475892707-14758938266056293', 1, 0, '', NULL, NULL, '10.0'),
(10000, '2016-10-08 10:30:26', NULL, NULL, 3571, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 10:30:26', 'admin-1475892707-14758938266056293', 1, 0, '', NULL, NULL, '10.0'),
(10001, '2016-10-08 10:28:51', NULL, NULL, 3570, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 10:28:51', 'admin-1475892707-1475893731468589', 1, 0, '', NULL, NULL, NULL),
(10002, '2016-10-08 10:28:51', NULL, NULL, 3570, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 10:28:51', 'admin-1475892707-1475893731468589', 1, 1, 'SR', NULL, NULL, NULL),
(10003, '2016-10-08 10:28:51', NULL, NULL, 3570, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 10:28:51', 'admin-1475892707-1475893731468589', 1, 0, '', NULL, NULL, NULL),
(10004, '2016-10-08 10:28:51', NULL, NULL, 3570, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 10:28:51', 'admin-1475892707-1475893731468589', 1, 0, '', NULL, NULL, NULL),
(10005, '2016-10-08 10:11:56', NULL, NULL, 3569, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 10:11:56', 'admin-1475892707-14758927164705550', 1, 1, 'SR', NULL, NULL, NULL),
(10006, '2016-10-08 12:58:24', NULL, NULL, 3574, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 12:58:24', 'admin-1475892707-14759027042828935', 1, 1, 'SR', NULL, NULL, NULL),
(10007, '2016-10-08 10:04:41', NULL, NULL, 3568, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 10:04:41', 'admin-1475888684-14758922808843772', 1, 1, 'SR', NULL, NULL, NULL),
(10008, '2016-10-08 10:04:41', NULL, NULL, 3568, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 10:04:41', 'admin-1475888684-14758922808843772', 1, 0, '', NULL, NULL, NULL),
(10009, '2016-10-08 10:04:41', NULL, NULL, 3568, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 10:04:41', 'admin-1475888684-14758922808843772', 1, 0, '', NULL, NULL, NULL),
(10010, '2016-10-08 09:59:20', NULL, NULL, 3567, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 09:59:20', 'admin-1475888684-1475891959859931', 1, 1, 'SR', NULL, NULL, NULL),
(10011, '2016-10-08 09:43:48', NULL, NULL, 3566, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 09:43:48', 'admin-1475888684-14758910283827620', 1, 1, 'SR', NULL, NULL, NULL),
(10012, '2016-10-08 09:43:48', NULL, NULL, 3566, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 09:43:48', 'admin-1475888684-14758910283827620', 1, 1, 'SR', NULL, NULL, NULL),
(10013, '2016-10-08 20:05:12', NULL, NULL, 3594, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 20:05:12', 'admin-1475914975-14759283123759722', 1, 0, '', NULL, NULL, NULL),
(10014, '2016-10-08 10:11:41', NULL, NULL, 3569, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 10:11:41', 'admin-1475888684-14758927011844580', 1, 0, '', NULL, NULL, NULL),
(10015, '2016-10-08 09:42:23', NULL, NULL, 3565, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 09:42:23', 'admin-1475888684-14758909432998933', 1, 0, '', NULL, NULL, NULL),
(10016, '2016-10-08 09:42:23', NULL, NULL, 3565, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 09:42:23', 'admin-1475888684-14758909432998933', 1, 0, '', NULL, NULL, NULL),
(10017, '2016-10-08 09:24:09', NULL, NULL, 3564, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 09:24:09', 'admin-1475888684-1475889848925648', 1, 1, 'SR', NULL, NULL, NULL),
(10018, '2016-10-08 09:23:48', NULL, NULL, 3564, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 09:23:48', 'admin-1475888684-14758898280553778', 1, 0, '', NULL, NULL, NULL),
(10019, '2016-10-08 09:23:48', NULL, NULL, 3564, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 09:23:48', 'admin-1475888684-14758898280553778', 1, 1, 'SR', NULL, NULL, NULL),
(10020, '2016-10-08 09:23:48', NULL, NULL, 3564, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1475929383', 'admin', '2016-10-08 09:23:48', 'admin-1475888684-14758898280553778', 1, 0, '', NULL, NULL, NULL),
(10021, '2016-10-09 18:44:09', NULL, NULL, 3639, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 18:44:09', 'admin-1475995191-14760098497365264', 1, 1, 'SR', NULL, NULL, NULL),
(10022, '2016-10-09 18:44:09', NULL, NULL, 3639, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 18:44:09', 'admin-1475995191-14760098497365264', 1, 1, 'SR', NULL, NULL, NULL),
(10023, '2016-10-09 18:44:09', NULL, NULL, 3639, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 18:44:09', 'admin-1475995191-14760098497365264', 1, 0, '', NULL, NULL, NULL),
(10024, '2016-10-09 18:44:53', NULL, NULL, 3639, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 18:44:53', 'admin-1476009857-1476009893764391', 1, 1, 'SR', NULL, NULL, NULL),
(10025, '2016-10-09 18:44:53', NULL, NULL, 3639, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 18:44:53', 'admin-1476009857-1476009893764391', 1, 1, 'SR', NULL, NULL, NULL),
(10026, '2016-10-09 18:44:53', NULL, NULL, 3639, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 18:44:53', 'admin-1476009857-1476009893764391', 1, 1, 'SR', NULL, NULL, NULL),
(10027, '2016-10-09 18:44:53', NULL, NULL, 3639, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 18:44:53', 'admin-1476009857-1476009893764391', 1, 1, 'SR', NULL, NULL, NULL),
(10028, '2016-10-09 18:44:53', NULL, NULL, 3639, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 18:44:53', 'admin-1476009857-1476009893764391', 1, 1, 'SR', NULL, NULL, NULL),
(10029, '2016-10-09 18:44:53', NULL, NULL, 3639, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 18:44:53', 'admin-1476009857-1476009893764391', 1, 1, 'SR', NULL, NULL, NULL),
(10030, '2016-10-09 18:46:06', NULL, NULL, 3640, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 18:46:06', 'admin-1476009857-14760099661222849', 1, 0, '', NULL, NULL, NULL),
(10031, '2016-10-09 18:15:33', NULL, NULL, 3638, 0, 222, '156', 'Seasoned Chicken Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 18:15:33', 'admin-1475995191-1476008133687364', 1, 0, '', NULL, NULL, NULL),
(10032, '2016-10-09 15:23:20', NULL, NULL, 3632, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:23:20', 'admin-1475995191-14759978004559232', 1, 0, '', NULL, NULL, NULL),
(10033, '2016-10-09 15:23:20', NULL, NULL, 3632, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:23:20', 'admin-1475995191-14759978004559232', 1, 1, 'SR', NULL, NULL, NULL),
(10034, '2016-10-09 15:23:20', NULL, NULL, 3632, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:23:20', 'admin-1475995191-14759978004559232', 1, 1, 'SR', NULL, NULL, NULL),
(10035, '2016-10-09 15:30:19', NULL, NULL, 3633, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:30:19', 'admin-1475995191-14759982193158999', 1, 1, 'SR', NULL, NULL, NULL),
(10036, '2016-10-09 15:32:45', NULL, NULL, 3634, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:32:45', 'admin-1475995191-14759983653903217', 1, 0, '', NULL, NULL, NULL),
(10037, '2016-10-09 15:32:45', NULL, NULL, 3634, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:32:45', 'admin-1475995191-14759983653903217', 1, 1, 'SR', NULL, NULL, NULL),
(10038, '2016-10-09 15:37:33', NULL, NULL, 3633, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:37:33', 'admin-1475995191-14759986531275956', 1, 1, 'SR', NULL, NULL, NULL),
(10039, '2016-10-09 15:41:59', NULL, NULL, 3635, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:41:59', 'admin-1475995191-14759989193906372', 1, 1, 'SR', NULL, NULL, NULL),
(10040, '2016-10-09 15:41:59', NULL, NULL, 3635, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:41:59', 'admin-1475995191-14759989193906372', 1, 1, 'SR', NULL, NULL, NULL),
(10041, '2016-10-09 15:41:59', NULL, NULL, 3635, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:41:59', 'admin-1475995191-14759989193906372', 1, 0, '', NULL, NULL, NULL),
(10042, '2016-10-09 15:55:55', NULL, NULL, 3636, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:55:55', 'admin-1475995191-14759997548735635', 1, 1, 'SR', NULL, NULL, NULL),
(10043, '2016-10-09 15:55:55', NULL, NULL, 3636, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:55:55', 'admin-1475995191-14759997548735635', 1, 1, 'SR', NULL, NULL, NULL),
(10044, '2016-10-09 15:57:44', NULL, NULL, 3637, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:57:44', 'admin-1475995191-1475999864456350', 1, 1, 'SR', NULL, NULL, NULL),
(10045, '2016-10-09 17:34:36', NULL, NULL, 3638, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 17:34:36', 'admin-1475995191-14760056763624920', 1, 1, 'SR', NULL, NULL, NULL),
(10046, '2016-10-09 18:15:33', NULL, NULL, 3638, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 18:15:33', 'admin-1475995191-1476008133687364', 1, 1, 'SR', NULL, NULL, NULL),
(10047, '2016-10-09 18:15:33', NULL, NULL, 3638, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 18:15:33', 'admin-1475995191-1476008133687364', 1, 1, 'SR', NULL, NULL, NULL),
(10048, '2016-10-09 18:15:33', NULL, NULL, 3638, 0, 222, '156', 'Seasoned Chicken Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 18:15:33', 'admin-1475995191-1476008133687364', 1, 0, '', NULL, NULL, NULL),
(10049, '2016-10-09 19:10:56', NULL, NULL, 3639, 0, 71, '71', 'Rice Wine Ginger Pork', 'without rice', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 19:10:56', 'admin-1476009857-14760114560055655', 1, 1, 'SR', NULL, NULL, NULL),
(10050, '2016-10-09 19:02:45', NULL, NULL, 3641, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 19:02:45', 'admin-1476009857-14760109651326037', 1, 1, 'SR', NULL, NULL, NULL),
(10051, '2016-10-09 19:02:45', NULL, NULL, 3641, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 19:02:45', 'admin-1476009857-14760109651326037', 1, 1, 'SR', NULL, NULL, NULL),
(10052, '2016-10-09 19:02:45', NULL, NULL, 3641, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 19:02:45', 'admin-1476009857-14760109651326037', 1, 1, 'SR', NULL, NULL, NULL),
(10053, '2016-10-09 18:58:40', NULL, NULL, 3639, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 18:58:40', 'admin-1476009857-14760107201567356', 1, 1, 'SR', NULL, NULL, NULL),
(10054, '2016-10-09 14:06:42', NULL, NULL, 3624, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 14:06:42', 'admin-1475991027-14759932021807579', 1, 1, 'SR', NULL, NULL, NULL),
(10055, '2016-10-09 14:06:42', NULL, NULL, 3624, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 14:06:42', 'admin-1475991027-14759932021807579', 1, 1, 'SR', NULL, NULL, NULL),
(10056, '2016-10-09 13:40:06', NULL, NULL, 3622, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:40:06', 'admin-1475991027-14759916062191611', 1, 1, 'SR', NULL, NULL, NULL),
(10057, '2016-10-09 13:40:06', NULL, NULL, 3622, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:40:06', 'admin-1475991027-14759916062191611', 1, 0, '', NULL, NULL, NULL),
(10058, '2016-10-09 19:02:45', NULL, NULL, 3641, 0, 195, '130', 'Cucumber Lime Soda BOFO', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 19:02:45', 'admin-1476009857-14760109651326037', 1, 0, '', NULL, NULL, NULL),
(10059, '2016-10-09 18:46:12', NULL, NULL, 3640, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 18:46:12', 'admin-1476009857-14760099721796897', 1, 1, 'SR', NULL, NULL, NULL),
(10060, '2016-10-09 18:46:06', NULL, NULL, 3640, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 18:46:06', 'admin-1476009857-14760099661222849', 1, 0, '', NULL, NULL, NULL),
(10061, '2016-10-09 18:58:40', NULL, NULL, 3639, 0, 222, '156', 'Seasoned Chicken Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 18:58:40', 'admin-1476009857-14760107201567356', 1, 0, '', NULL, NULL, NULL),
(10062, '2016-10-09 18:44:09', NULL, NULL, 3639, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 18:44:09', 'admin-1475995191-14760098497365264', 1, 0, '', NULL, NULL, NULL),
(10063, '2016-10-09 18:44:09', NULL, NULL, 3639, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 18:44:09', 'admin-1475995191-14760098497365264', 1, 1, 'SR', NULL, NULL, NULL),
(10064, '2016-10-09 14:06:42', NULL, NULL, 3624, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 14:06:42', 'admin-1475991027-14759932021807579', 1, 0, '', NULL, NULL, NULL),
(10065, '2016-10-09 14:07:32', NULL, NULL, 3624, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 14:07:32', 'admin-1475991027-14759932518098850', 1, 1, 'SR', NULL, NULL, NULL),
(10066, '2016-10-09 14:07:32', NULL, NULL, 3624, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 14:07:32', 'admin-1475991027-14759932518098850', 1, 1, 'SR', NULL, NULL, NULL),
(10067, '2016-10-09 14:10:56', NULL, NULL, 3625, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 14:10:56', 'admin-1475991027-14759934564089893', 1, 1, 'SR', NULL, NULL, NULL),
(10068, '2016-10-09 14:10:56', NULL, NULL, 3625, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 14:10:56', 'admin-1475991027-14759934564089893', 1, 0, '', NULL, NULL, NULL),
(10069, '2016-10-09 14:42:30', NULL, NULL, 3627, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 14:42:30', 'admin-1475995191-1475995350226870', 1, 1, 'SR', NULL, NULL, NULL),
(10070, '2016-10-09 14:37:41', NULL, NULL, 3623, 0, 153, '87', 'Big Breakfast ', 'takeaway', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 14:37:41', 'admin-1475991027-14759950613229628', 1, 0, '', NULL, NULL, NULL),
(10071, '2016-10-09 14:39:44', NULL, NULL, 3626, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 14:39:44', 'admin-1475991027-14759951841341639', 1, 1, 'SR', NULL, NULL, NULL),
(10072, '2016-10-09 14:39:44', NULL, NULL, 3626, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 14:39:44', 'admin-1475991027-14759951841341639', 1, 0, '', NULL, NULL, NULL),
(10073, '2016-10-09 14:42:30', NULL, NULL, 3627, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 14:42:30', 'admin-1475995191-1475995350226870', 1, 0, '', NULL, NULL, NULL),
(10074, '2016-10-09 14:51:44', NULL, NULL, 3628, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 14:51:44', 'admin-1475995191-14759959040671372', 1, 1, 'SR', NULL, NULL, NULL),
(10075, '2016-10-09 14:56:51', NULL, NULL, 3629, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 14:56:51', 'admin-1475995191-14759962111282531', 1, 0, '', NULL, NULL, NULL),
(10076, '2016-10-09 15:12:54', NULL, NULL, 3615, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:12:54', 'admin-1475995191-14759971744024040', 1, 1, 'SR', NULL, NULL, NULL),
(10077, '2016-10-09 15:22:03', NULL, NULL, 3630, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:22:03', 'admin-1475995191-1475997723684203', 1, 1, 'SR', NULL, NULL, NULL),
(10078, '2016-10-09 15:22:03', NULL, NULL, 3630, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:22:03', 'admin-1475995191-1475997723684203', 1, 1, 'SR', NULL, NULL, NULL),
(10079, '2016-10-09 15:22:03', NULL, NULL, 3630, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:22:03', 'admin-1475995191-1475997723684203', 1, 1, 'SR', NULL, NULL, NULL),
(10080, '2016-10-09 15:22:03', NULL, NULL, 3630, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:22:03', 'admin-1475995191-1475997723684203', 1, 1, 'SR', NULL, NULL, NULL),
(10081, '2016-10-09 15:22:33', NULL, NULL, 3631, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:22:34', 'admin-1475995191-14759977537928781', 1, 0, '', NULL, NULL, NULL),
(10082, '2016-10-09 15:23:20', NULL, NULL, 3632, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:23:20', 'admin-1475995191-14759978004559232', 1, 1, 'SR', NULL, NULL, NULL),
(10083, '2016-10-09 15:23:20', NULL, NULL, 3632, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:23:20', 'admin-1475995191-14759978004559232', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(10084, '2016-10-09 15:23:20', NULL, NULL, 3632, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:23:20', 'admin-1475995191-14759978004559232', 1, 0, '', NULL, NULL, NULL),
(10085, '2016-10-09 15:23:20', NULL, NULL, 3632, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:23:20', 'admin-1475995191-14759978004559232', 1, 0, '', NULL, NULL, NULL),
(10086, '2016-10-09 13:55:27', NULL, NULL, 3623, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:55:27', 'admin-1475991027-14759925268081312', 1, 0, '', NULL, NULL, NULL),
(10087, '2016-10-09 15:23:20', NULL, NULL, 3632, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 15:23:20', 'admin-1475995191-14759978004559232', 1, 0, '', NULL, NULL, NULL),
(10088, '2016-10-09 14:06:42', NULL, NULL, 3624, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 14:06:42', 'admin-1475991027-14759932021807579', 1, 0, '', NULL, NULL, NULL),
(10089, '2016-10-09 14:06:42', NULL, NULL, 3624, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 14:06:42', 'admin-1475991027-14759932021807579', 1, 1, 'SR', NULL, NULL, NULL),
(10090, '2016-10-09 14:00:19', NULL, NULL, 3619, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 14:00:19', 'admin-1475991027-1475992819484815', 1, 1, 'SR', NULL, NULL, NULL),
(10091, '2016-10-09 13:55:27', NULL, NULL, 3623, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:55:27', 'admin-1475991027-14759925268081312', 1, 0, '', NULL, NULL, NULL),
(10092, '2016-10-09 13:55:27', NULL, NULL, 3623, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:55:27', 'admin-1475991027-14759925268081312', 1, 1, 'SR', NULL, NULL, NULL),
(10093, '2016-10-09 13:40:06', NULL, NULL, 3622, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:40:06', 'admin-1475991027-14759916062191611', 1, 1, 'SR', NULL, NULL, NULL),
(10094, '2016-10-09 13:55:27', NULL, NULL, 3623, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:55:27', 'admin-1475991027-14759925268081312', 1, 1, 'SR', NULL, NULL, NULL),
(10095, '2016-10-09 13:38:43', NULL, NULL, 3621, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:38:43', 'admin-1475991027-14759915230158843', 1, 1, 'SR', NULL, NULL, NULL),
(10096, '2016-10-09 13:38:43', NULL, NULL, 3621, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:38:43', 'admin-1475991027-14759915230158843', 1, 1, 'SR', NULL, NULL, NULL),
(10097, '2016-10-09 13:38:43', NULL, NULL, 3621, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:38:43', 'admin-1475991027-14759915230158843', 1, 1, 'SR', NULL, NULL, NULL),
(10098, '2016-10-09 13:36:04', NULL, NULL, 3620, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:36:04', 'admin-1475991027-14759913643778754', 1, 1, 'SR', NULL, NULL, NULL),
(10099, '2016-10-09 13:36:04', NULL, NULL, 3620, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:36:04', 'admin-1475991027-14759913643778754', 1, 1, 'SR', NULL, NULL, NULL),
(10100, '2016-10-09 13:30:22', NULL, NULL, 3619, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:30:22', 'admin-1475987700-1475991021957898', 1, 0, '', NULL, NULL, NULL),
(10101, '2016-10-09 13:30:22', NULL, NULL, 3619, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:30:22', 'admin-1475987700-1475991021957898', 1, 1, 'SR', NULL, NULL, NULL),
(10102, '2016-10-09 13:30:22', NULL, NULL, 3619, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:30:22', 'admin-1475987700-1475991021957898', 1, 1, 'SR', NULL, NULL, NULL),
(10103, '2016-10-09 13:30:22', NULL, NULL, 3619, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:30:22', 'admin-1475987700-1475991021957898', 1, 0, '', NULL, NULL, NULL),
(10104, '2016-10-09 13:29:28', NULL, NULL, 3618, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:29:28', 'admin-1475987700-1475990968627315', 1, 1, 'SR', NULL, NULL, NULL),
(10105, '2016-10-09 13:29:28', NULL, NULL, 3618, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:29:28', 'admin-1475987700-1475990968627315', 1, 1, 'SR', NULL, NULL, NULL),
(10106, '2016-10-09 13:30:22', NULL, NULL, 3619, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:30:22', 'admin-1475987700-1475991021957898', 1, 0, '', NULL, NULL, NULL),
(10107, '2016-10-09 18:57:19', NULL, NULL, 3639, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 18:57:19', 'admin-1476009857-14760106397987248', 1, 1, 'SR', NULL, NULL, NULL),
(10108, '2016-10-09 13:29:28', NULL, NULL, 3618, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:29:28', 'admin-1475987700-1475990968627315', 1, 1, 'SR', NULL, NULL, NULL),
(10109, '2016-10-09 13:29:28', NULL, NULL, 3618, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:29:28', 'admin-1475987700-1475990968627315', 1, 1, 'SR', NULL, NULL, NULL),
(10110, '2016-10-09 13:29:28', NULL, NULL, 3618, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:29:28', 'admin-1475987700-1475990968627315', 1, 0, '', NULL, NULL, NULL),
(10111, '2016-10-09 12:17:56', NULL, NULL, 3611, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:17:56', 'admin-1475973475-14759866759268867', 1, 1, 'SR', NULL, NULL, NULL),
(10112, '2016-10-09 12:43:41', NULL, NULL, 3614, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:43:41', 'admin-1475987700-14759882209772637', 1, 1, 'SR', NULL, NULL, NULL),
(10113, '2016-10-09 12:43:41', NULL, NULL, 3614, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:43:41', 'admin-1475987700-14759882209772637', 1, 1, 'SR', NULL, NULL, NULL),
(10114, '2016-10-09 13:24:48', NULL, NULL, 3618, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:24:48', 'admin-1475987700-14759906886889359', 1, 1, 'SR', NULL, NULL, NULL),
(10115, '2016-10-09 13:24:48', NULL, NULL, 3618, 0, 71, '71', 'Rice Wine Ginger Pork', 'with mashed potato', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:24:48', 'admin-1475987700-14759906886889359', 1, 1, 'SR', NULL, NULL, NULL),
(10116, '2016-10-09 13:24:48', NULL, NULL, 3618, NULL, 58, '58', 'House White Bottle', '', 'Cold Drinks', 'Wine', 1, 88.00, 88.0000, 0.0000, 88.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:24:48', 'admin-1475987700-14759906886889359', 1, 1, 'SR', NULL, NULL, NULL),
(10117, '2016-10-09 13:24:48', NULL, NULL, 3618, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:24:48', 'admin-1475987700-14759906886889359', 1, 1, 'SR', NULL, NULL, NULL),
(10118, '2016-10-09 13:11:29', NULL, NULL, 3616, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:11:29', 'admin-1475987700-14759898888491029', 1, 1, 'SR', NULL, NULL, NULL),
(10119, '2016-10-09 13:21:07', NULL, NULL, 3617, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:21:07', 'admin-1475987700-14759904675663097', 1, 0, '', NULL, NULL, NULL),
(10120, '2016-10-09 10:22:34', NULL, NULL, 3603, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 10:22:34', 'admin-1475973475-14759797539745345', 1, 0, '', NULL, NULL, NULL),
(10121, '2016-10-09 10:22:34', NULL, NULL, 3603, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 10:22:34', 'admin-1475973475-14759797539745345', 1, 1, 'SR', NULL, NULL, NULL),
(10122, '2016-10-09 10:25:09', NULL, NULL, 3604, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 10:25:09', 'admin-1475973475-14759799096834615', 1, 1, 'SR', NULL, NULL, NULL),
(10123, '2016-10-09 11:43:28', NULL, NULL, 3607, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 11:43:28', 'admin-1475973475-14759846086163854', 1, 1, 'SR', NULL, NULL, NULL),
(10124, '2016-10-09 12:01:02', NULL, NULL, 3608, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:01:02', 'admin-1475973475-14759856627866532', 1, 1, 'SR', NULL, NULL, NULL),
(10125, '2016-10-09 12:01:02', NULL, NULL, 3608, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:01:02', 'admin-1475973475-14759856627866532', 1, 0, '', NULL, NULL, NULL),
(10126, '2016-10-09 12:01:19', NULL, NULL, 3608, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:01:19', 'admin-1475973475-1475985679450558', 1, 1, 'SR', NULL, NULL, NULL),
(10127, '2016-10-09 12:01:19', NULL, NULL, 3608, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:01:19', 'admin-1475973475-1475985679450558', 1, 1, 'SR', NULL, NULL, NULL),
(10128, '2016-10-09 12:03:50', NULL, NULL, 3609, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:03:50', 'admin-1475973475-14759858297415844', 1, 1, 'SR', NULL, NULL, NULL),
(10129, '2016-10-09 12:05:41', NULL, NULL, 3610, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:05:41', 'admin-1475973475-14759859417438637', 1, 0, '', NULL, NULL, NULL),
(10130, '2016-10-09 12:17:30', NULL, NULL, 3611, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:17:30', 'admin-1475973475-14759866497807430', 1, 1, 'SR', NULL, NULL, NULL),
(10131, '2016-10-09 12:17:30', NULL, NULL, 3611, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:17:30', 'admin-1475973475-14759866497807430', 1, 0, '', NULL, NULL, NULL),
(10132, '2016-10-09 12:17:30', NULL, NULL, 3611, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:17:30', 'admin-1475973475-14759866497807430', 1, 1, 'SR', NULL, NULL, NULL),
(10133, '2016-10-09 12:17:30', NULL, NULL, 3611, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:17:30', 'admin-1475973475-14759866497807430', 1, 0, '', NULL, NULL, NULL),
(10134, '2016-10-09 12:33:21', NULL, NULL, 3612, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:33:21', 'admin-1475973475-14759876008562082', 1, 1, 'SR', NULL, NULL, NULL),
(10135, '2016-10-09 12:33:21', NULL, NULL, 3612, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:33:21', 'admin-1475973475-14759876008562082', 1, 1, 'SR', NULL, NULL, NULL),
(10136, '2016-10-09 12:33:21', NULL, NULL, 3612, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:33:21', 'admin-1475973475-14759876008562082', 1, 0, '', NULL, NULL, NULL),
(10137, '2016-10-09 12:33:21', NULL, NULL, 3612, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:33:21', 'admin-1475973475-14759876008562082', 1, 0, '', NULL, NULL, NULL),
(10138, '2016-10-09 12:36:04', NULL, NULL, 3613, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:36:04', 'admin-1475987700-14759877643097680', 1, 0, '', NULL, NULL, NULL),
(10139, '2016-10-09 12:36:04', NULL, NULL, 3613, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:36:04', 'admin-1475987700-14759877643097680', 1, 0, '', NULL, NULL, NULL),
(10140, '2016-10-09 12:36:04', NULL, NULL, 3613, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:36:04', 'admin-1475987700-14759877643097680', 1, 1, 'SR', NULL, NULL, NULL),
(10141, '2016-10-09 12:43:41', NULL, NULL, 3614, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:43:41', 'admin-1475987700-14759882209772637', 1, 0, '', NULL, NULL, NULL),
(10142, '2016-10-09 12:43:41', NULL, NULL, 3614, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:43:41', 'admin-1475987700-14759882209772637', 1, 0, '', NULL, NULL, NULL),
(10143, '2016-10-09 12:17:56', NULL, NULL, 3611, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:17:56', 'admin-1475973475-14759866759268867', 1, 1, 'SR', NULL, NULL, NULL),
(10144, '2016-10-09 10:43:10', NULL, NULL, 3605, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 10:43:10', 'admin-1475973475-1475980989886122', 1, 0, '', NULL, NULL, NULL),
(10145, '2016-10-09 10:43:10', NULL, NULL, 3605, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 10:43:10', 'admin-1475973475-1475980989886122', 1, 0, '', NULL, NULL, NULL),
(10146, '2016-10-09 10:43:10', NULL, NULL, 3605, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 10:43:10', 'admin-1475973475-1475980989886122', 1, 0, '', NULL, NULL, NULL),
(10147, '2016-10-09 10:43:10', NULL, NULL, 3605, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 10:43:10', 'admin-1475973475-1475980989886122', 1, 0, '', NULL, NULL, NULL),
(10148, '2016-10-09 11:43:28', NULL, NULL, 3607, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 11:43:28', 'admin-1475973475-14759846086163854', 1, 1, 'SR', NULL, NULL, NULL),
(10149, '2016-10-09 11:43:28', NULL, NULL, 3607, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 11:43:28', 'admin-1475973475-14759846086163854', 1, 0, '', NULL, NULL, NULL),
(10150, '2016-10-09 12:33:21', NULL, NULL, 3612, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 12:33:21', 'admin-1475973475-14759876008562082', 1, 1, 'SR', NULL, NULL, NULL),
(10151, '2016-10-09 11:43:28', NULL, NULL, 3607, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 11:43:28', 'admin-1475973475-14759846086163854', 1, 1, 'SR', NULL, NULL, NULL),
(10152, '2016-10-09 10:37:17', NULL, NULL, 3606, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 10:37:17', 'admin-1475973475-14759806376578020', 1, 1, 'SR', NULL, NULL, NULL),
(10153, '2016-10-09 10:22:34', NULL, NULL, 3603, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 10:22:34', 'admin-1475973475-14759797539745345', 1, 1, 'SR', NULL, NULL, NULL),
(10154, '2016-10-09 09:24:43', NULL, NULL, 3601, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 09:24:43', 'admin-1475973475-14759762837709648', 1, 1, 'SR', NULL, NULL, NULL),
(10155, '2016-10-09 10:08:19', NULL, NULL, 3602, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 10:08:19', 'admin-1475973475-14759788992657851', 1, 1, 'SR', NULL, NULL, NULL),
(10156, '2016-10-09 10:08:19', NULL, NULL, 3602, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 10:08:19', 'admin-1475973475-14759788992657851', 1, 1, 'SR', NULL, NULL, NULL),
(10157, '2016-10-09 13:10:47', NULL, NULL, 3615, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 13:10:47', 'admin-1475987700-14759898475421327', 1, 1, 'SR', NULL, NULL, NULL),
(10158, '2016-10-09 10:22:34', NULL, NULL, 3603, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 10:22:34', 'admin-1475973475-14759797539745345', 1, 0, '', NULL, NULL, NULL),
(10159, '2016-10-09 09:24:43', NULL, NULL, 3601, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1476009857', 'admin', '2016-10-09 09:24:43', 'admin-1475973475-14759762837709648', 1, 1, 'SR', NULL, NULL, NULL),
(10160, '2016-10-10 17:13:16', NULL, NULL, 3660, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 17:13:16', 'admin-1476075805-14760907959729169', 1, 0, '', 1, NULL, NULL),
(10161, '2016-10-10 18:49:55', NULL, NULL, 3661, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 18:49:55', 'admin-1476075805-1476096595042459', 1, 1, 'SR', NULL, NULL, NULL),
(10162, '2016-10-10 18:49:55', NULL, NULL, 3661, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 18:49:55', 'admin-1476075805-1476096595042459', 1, 1, 'SR', NULL, NULL, NULL),
(10163, '2016-10-10 18:49:55', NULL, NULL, 3661, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 18:49:55', 'admin-1476075805-1476096595042459', 1, 0, '', NULL, NULL, NULL),
(10164, '2016-10-10 17:13:16', NULL, NULL, 3660, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 17:13:16', 'admin-1476075805-14760907959729169', 1, 0, '', 1, NULL, NULL),
(10165, '2016-10-10 16:51:37', NULL, NULL, 3659, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 16:51:37', 'admin-1476075805-14760894969129475', 1, 1, 'SR', NULL, NULL, NULL),
(10166, '2016-10-10 16:51:37', NULL, NULL, 3659, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 16:51:37', 'admin-1476075805-14760894969129475', 1, 0, '', NULL, NULL, NULL),
(10167, '2016-10-10 15:03:33', NULL, NULL, 3651, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 15:03:33', 'admin-1476075805-1476083013383627', 1, 1, 'SR', NULL, NULL, NULL),
(10168, '2016-10-10 15:03:33', NULL, NULL, 3651, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 15:03:33', 'admin-1476075805-1476083013383627', 1, 1, 'SR', NULL, NULL, NULL),
(10169, '2016-10-10 15:41:44', NULL, NULL, 3656, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 15:41:44', 'admin-1476075805-14760853045175773', 1, 1, 'SR', NULL, NULL, NULL),
(10170, '2016-10-10 15:41:44', NULL, NULL, 3656, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 15:41:44', 'admin-1476075805-14760853045175773', 1, 1, 'SR', NULL, NULL, NULL),
(10171, '2016-10-10 16:43:32', NULL, NULL, 3658, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 16:43:32', 'admin-1476075805-14760890126411018', 1, 0, '', NULL, NULL, NULL),
(10172, '2016-10-10 16:37:45', NULL, NULL, 3659, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 16:37:45', 'admin-1476075805-14760886655535820', 1, 1, 'SR', NULL, NULL, NULL),
(10173, '2016-10-10 16:37:45', NULL, NULL, 3659, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 16:37:45', 'admin-1476075805-14760886655535820', 1, 0, '', NULL, NULL, NULL),
(10174, '2016-10-10 16:18:06', NULL, NULL, 3657, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 16:18:06', 'admin-1476075805-14760874864582560', 1, 1, 'SR', NULL, NULL, NULL),
(10175, '2016-10-10 16:31:28', NULL, NULL, 3658, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 16:31:28', 'admin-1476075805-14760882885466385', 1, 1, 'SR', NULL, NULL, NULL),
(10176, '2016-10-10 16:37:45', NULL, NULL, 3659, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 16:37:45', 'admin-1476075805-14760886655535820', 1, 1, 'SR', NULL, NULL, NULL),
(10177, '2016-10-10 11:30:26', NULL, NULL, 3645, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 11:30:26', 'admin-1476064220-14760702258245971', 1, 1, 'SR', NULL, NULL, NULL),
(10178, '2016-10-10 12:09:44', NULL, NULL, 3646, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 12:09:44', 'admin-1476064220-147607258454796', 1, 1, 'SR', NULL, NULL, NULL),
(10179, '2016-10-10 12:22:09', NULL, NULL, 3647, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 12:22:09', 'admin-1476064220-14760733290898081', 1, 0, '', NULL, NULL, '10.0'),
(10180, '2016-10-10 13:03:34', NULL, NULL, 3647, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 13:03:34', 'admin-1476075805-14760758145403141', 1, 0, '', NULL, NULL, '10.0'),
(10181, '2016-10-10 12:59:49', NULL, NULL, 3650, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 12:59:49', 'admin-1476064220-147607558927188', 1, 1, 'SR', NULL, NULL, NULL),
(10182, '2016-10-10 12:59:49', NULL, NULL, 3650, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 12:59:49', 'admin-1476064220-147607558927188', 1, 1, 'SR', NULL, NULL, NULL),
(10183, '2016-10-10 13:14:46', NULL, NULL, 3651, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 13:14:46', 'admin-1476075805-14760764862273785', 1, 0, '', NULL, NULL, NULL),
(10184, '2016-10-10 13:15:39', NULL, NULL, 3651, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 13:15:39', 'admin-1476075805-14760765392071458', 1, 0, '', NULL, NULL, NULL),
(10185, '2016-10-10 13:21:33', NULL, NULL, 3652, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 13:21:33', 'admin-1476075805-1476076893757131', 1, 1, 'SR', NULL, NULL, NULL),
(10186, '2016-10-10 13:21:33', NULL, NULL, 3652, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 13:21:33', 'admin-1476075805-1476076893757131', 1, 1, 'SR', NULL, NULL, NULL),
(10187, '2016-10-10 13:21:33', NULL, NULL, 3652, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 13:21:33', 'admin-1476075805-1476076893757131', 1, 0, '', NULL, NULL, NULL),
(10188, '2016-10-10 13:21:33', NULL, NULL, 3652, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 13:21:33', 'admin-1476075805-1476076893757131', 1, 1, 'SR', NULL, NULL, NULL),
(10189, '2016-10-10 13:21:33', NULL, NULL, 3652, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 13:21:33', 'admin-1476075805-1476076893757131', 1, 0, '', NULL, NULL, NULL),
(10190, '2016-10-10 13:35:31', NULL, NULL, 3651, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 13:35:31', 'admin-1476075805-14760777315666870', 1, 1, 'SR', NULL, NULL, NULL),
(10191, '2016-10-10 13:38:07', NULL, NULL, 3653, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 13:38:07', 'admin-1476075805-14760778876781090', 1, 0, '', NULL, NULL, NULL),
(10192, '2016-10-10 13:40:49', NULL, NULL, 3651, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 13:40:49', 'admin-1476075805-1476078048934329', 1, 0, '', NULL, NULL, NULL),
(10193, '2016-10-10 13:40:49', NULL, NULL, 3651, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 13:40:49', 'admin-1476075805-1476078048934329', 1, 0, '', NULL, NULL, NULL),
(10194, '2016-10-10 13:40:49', NULL, NULL, 3651, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 13:40:49', 'admin-1476075805-1476078048934329', 1, 0, '', NULL, NULL, NULL),
(10195, '2016-10-10 13:40:49', NULL, NULL, 3651, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 13:40:49', 'admin-1476075805-1476078048934329', 1, 0, '', NULL, NULL, NULL),
(10196, '2016-10-10 13:41:08', NULL, NULL, 3651, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 13:41:08', 'admin-1476075805-14760780687764484', 1, 1, 'SR', NULL, NULL, NULL),
(10197, '2016-10-10 14:17:15', NULL, NULL, 3654, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 14:17:15', 'admin-1476075805-14760802348875071', 1, 0, '', NULL, NULL, NULL),
(10198, '2016-10-10 14:17:15', NULL, NULL, 3654, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 14:17:15', 'admin-1476075805-14760802348875071', 1, 0, '', NULL, NULL, NULL),
(10199, '2016-10-10 14:18:29', NULL, NULL, 3651, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 14:18:29', 'admin-1476075805-1476080309069294', 1, 1, 'SR', NULL, NULL, NULL),
(10200, '2016-10-10 14:26:17', NULL, NULL, 3655, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 14:26:17', 'admin-1476075805-14760807765516080', 1, 1, 'SR', NULL, NULL, NULL),
(10201, '2016-10-10 14:26:17', NULL, NULL, 3655, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 14:26:17', 'admin-1476075805-14760807765516080', 1, 1, 'SR', NULL, NULL, NULL),
(10202, '2016-10-10 12:28:59', NULL, NULL, 3646, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 12:28:59', 'admin-1476064220-14760737390221635', 1, 1, 'SR', NULL, NULL, NULL),
(10203, '2016-10-10 12:29:10', NULL, NULL, 3647, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 12:29:10', 'admin-1476064220-14760737499576177', 1, 1, 'SR', NULL, NULL, '10.0'),
(10204, '2016-10-10 12:32:04', NULL, NULL, 3647, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 12:32:04', 'admin-1476064220-14760739241121854', 1, 1, 'SR', NULL, NULL, '10.0'),
(10205, '2016-10-10 12:33:10', NULL, NULL, 3648, 0, 195, '130', 'Cucumber Lime Soda BOFO', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 12:33:10', 'admin-1476064220-14760739907291477', 1, 0, '', NULL, NULL, NULL),
(10206, '2016-10-10 10:48:13', NULL, NULL, 3643, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 10:48:13', 'admin-1476064220-14760676928277740', 1, 1, 'SR', NULL, NULL, NULL),
(10207, '2016-10-10 12:22:09', NULL, NULL, 3647, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 12:22:09', 'admin-1476064220-14760733290898081', 1, 0, '', NULL, NULL, '10.0'),
(10208, '2016-10-10 14:46:43', NULL, NULL, 3651, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 14:46:43', 'admin-1476075805-14760820035559089', 1, 0, '', NULL, NULL, NULL),
(10209, '2016-10-10 11:11:59', NULL, NULL, 3644, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 11:11:59', 'admin-1476064220-14760691192647654', 1, 0, '', NULL, NULL, NULL),
(10210, '2016-10-10 11:11:59', NULL, NULL, 3644, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 11:11:59', 'admin-1476064220-14760691192647654', 1, 1, 'SR', NULL, NULL, NULL),
(10211, '2016-10-10 12:28:48', NULL, NULL, 3646, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 12:28:48', 'admin-1476064220-14760737277644722', 1, 0, '', NULL, NULL, NULL),
(10212, '2016-10-10 12:22:09', NULL, NULL, 3647, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 12:22:09', 'admin-1476064220-14760733290898081', 1, 0, '', NULL, NULL, '10.0'),
(10213, '2016-10-10 10:47:24', NULL, NULL, 3643, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 10:47:24', 'admin-1476064220-1476067643998271', 1, 0, '', NULL, NULL, NULL),
(10214, '2016-10-10 10:47:24', NULL, NULL, 3643, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 10:47:24', 'admin-1476064220-1476067643998271', 1, 0, '', NULL, NULL, NULL),
(10215, '2016-10-10 10:40:06', NULL, NULL, 3642, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 10:40:06', 'admin-1476064220-14760672063675894', 1, 0, '', 1, NULL, NULL),
(10216, '2016-10-10 10:47:24', NULL, NULL, 3643, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476075805', 'admin', '2016-10-10 10:47:24', 'admin-1476064220-1476067643998271', 1, 0, '', NULL, NULL, NULL),
(10217, '2016-10-12 18:15:02', NULL, NULL, 3687, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 18:15:02', 'admin-1476251885-1476267302031773', 1, 1, 'SR', NULL, NULL, NULL),
(10218, '2016-10-12 20:23:04', NULL, NULL, 3691, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 20:23:04', 'admin-1476273339-14762749841931476', 1, 0, '', NULL, NULL, NULL),
(10219, '2016-10-12 19:08:46', NULL, NULL, 3688, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 19:08:46', 'admin-1476251885-14762705263604669', 1, 1, 'SR', NULL, NULL, NULL),
(10220, '2016-10-12 19:08:46', NULL, NULL, 3688, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 19:08:46', 'admin-1476251885-14762705263604669', 1, 1, 'SR', NULL, NULL, NULL),
(10221, '2016-10-12 19:08:46', NULL, NULL, 3688, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 19:08:46', 'admin-1476251885-14762705263604669', 1, 0, '', NULL, NULL, NULL),
(10222, '2016-10-12 19:56:16', NULL, NULL, 3682, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 19:56:16', 'admin-1476273339-14762733761929322', 1, 1, 'SR', NULL, NULL, '10.0'),
(10223, '2016-10-12 19:56:16', NULL, NULL, 3682, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 19:56:16', 'admin-1476273339-14762733761929322', 1, 1, 'SR', NULL, NULL, '10.0'),
(10224, '2016-10-12 19:55:03', NULL, NULL, 3682, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 19:55:03', 'admin-1476251885-1476273302847813', 1, 1, 'SR', NULL, NULL, '10.0'),
(10225, '2016-10-12 19:55:03', NULL, NULL, 3682, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 19:55:03', 'admin-1476251885-1476273302847813', 1, 0, '', NULL, NULL, '10.0'),
(10226, '2016-10-12 19:56:16', NULL, NULL, 3682, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 19:56:16', 'admin-1476273339-14762733761929322', 1, 0, '', NULL, NULL, '10.0'),
(10227, '2016-10-12 20:23:04', NULL, NULL, 3691, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 20:23:04', 'admin-1476273339-14762749841931476', 1, 0, '', NULL, NULL, NULL),
(10228, '2016-10-12 15:44:08', NULL, NULL, 3680, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 15:44:08', 'admin-1476251885-14762582482203230', 1, 1, 'SR', NULL, NULL, NULL),
(10229, '2016-10-12 15:44:08', NULL, NULL, 3680, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 15:44:08', 'admin-1476251885-14762582482203230', 1, 1, 'SR', NULL, NULL, NULL),
(10230, '2016-10-12 15:44:08', NULL, NULL, 3680, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 15:44:08', 'admin-1476251885-14762582482203230', 1, 1, 'SR', NULL, NULL, NULL),
(10231, '2016-10-12 15:44:49', NULL, NULL, 3680, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 15:44:49', 'admin-1476251885-1476258288919714', 1, 1, 'SR', NULL, NULL, NULL),
(10232, '2016-10-12 16:17:40', NULL, NULL, 3681, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 16:17:40', 'admin-1476251885-1476260259975405', 1, 1, 'SR', NULL, NULL, NULL),
(10233, '2016-10-12 16:17:40', NULL, NULL, 3681, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 16:17:40', 'admin-1476251885-1476260259975405', 1, 1, 'SR', NULL, NULL, NULL),
(10234, '2016-10-12 16:26:38', NULL, NULL, 3682, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 16:26:38', 'admin-1476251885-14762607981775484', 1, 1, 'SR', NULL, NULL, '10.0'),
(10235, '2016-10-12 16:29:22', NULL, NULL, 3683, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 16:29:22', 'admin-1476251885-14762609619889841', 1, 1, 'SR', NULL, NULL, NULL),
(10236, '2016-10-12 16:44:16', NULL, NULL, 3684, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 16:44:16', 'admin-1476251885-14762618558403649', 1, 0, '', NULL, NULL, NULL),
(10237, '2016-10-12 16:44:16', NULL, NULL, 3684, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 16:44:16', 'admin-1476251885-14762618558403649', 1, 1, 'SR', NULL, NULL, NULL),
(10238, '2016-10-12 16:56:08', NULL, NULL, 3682, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 16:56:08', 'admin-1476251885-14762625677367599', 1, 1, 'SR', NULL, NULL, '10.0'),
(10239, '2016-10-12 16:56:08', NULL, NULL, 3682, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 16:56:08', 'admin-1476251885-14762625677367599', 1, 0, '', NULL, NULL, '10.0'),
(10240, '2016-10-12 16:56:08', NULL, NULL, 3682, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 16:56:08', 'admin-1476251885-14762625677367599', 1, 0, '', NULL, NULL, '10.0'),
(10241, '2016-10-12 16:56:08', NULL, NULL, 3682, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 16:56:08', 'admin-1476251885-14762625677367599', 1, 0, '', NULL, NULL, '10.0'),
(10242, '2016-10-12 17:34:42', NULL, NULL, 3685, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 17:34:42', 'admin-1476251885-1476264882780538', 1, 1, 'SR', NULL, NULL, NULL),
(10243, '2016-10-12 20:23:04', NULL, NULL, 3691, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 20:23:04', 'admin-1476273339-14762749841931476', 1, 0, '', NULL, NULL, NULL),
(10244, '2016-10-12 18:15:02', NULL, NULL, 3687, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 18:15:02', 'admin-1476251885-1476267302031773', 1, 1, 'SR', NULL, NULL, NULL),
(10245, '2016-10-12 18:15:02', NULL, NULL, 3687, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 18:15:02', 'admin-1476251885-1476267302031773', 1, 0, '', NULL, NULL, NULL),
(10246, '2016-10-12 20:23:04', NULL, NULL, 3691, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 20:23:04', 'admin-1476273339-14762749841931476', 1, 0, '', NULL, NULL, NULL),
(10247, '2016-10-12 21:13:00', NULL, NULL, 3693, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 21:13:00', 'admin-1476273339-1476277980048986', 1, 0, '', NULL, NULL, NULL),
(10248, '2016-10-12 21:13:05', NULL, NULL, 3693, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 21:13:05', 'admin-1476273339-1476277984827768', 1, 1, 'SR', NULL, NULL, NULL),
(10249, '2016-10-12 21:27:28', NULL, NULL, 3694, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 21:27:28', 'admin-1476273339-14762788478265535', 1, 1, 'SR', NULL, NULL, NULL),
(10250, '2016-10-12 21:28:03', NULL, NULL, 3695, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 21:28:03', 'admin-1476273339-14762788834547255', 1, 1, 'SR', NULL, NULL, NULL),
(10251, '2016-10-12 21:29:24', NULL, NULL, 3697, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 21:29:24', 'admin-1476273339-14762789647237489', 1, 1, 'SR', NULL, NULL, NULL),
(10252, '2016-10-12 21:28:53', NULL, NULL, 3696, 0, 228, '162', 'Golden Brown', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 21:28:53', 'admin-1476273339-14762789328951958', 1, 0, '', NULL, NULL, NULL),
(10253, '2016-10-12 21:28:53', NULL, NULL, 3696, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 21:28:53', 'admin-1476273339-14762789328951958', 1, 0, '', NULL, NULL, NULL),
(10254, '2016-10-12 20:21:59', NULL, NULL, 3690, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 20:21:59', 'admin-1476273339-14762749190388515', 1, 1, 'SR', NULL, NULL, NULL),
(10255, '2016-10-12 15:44:08', NULL, NULL, 3680, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 15:44:08', 'admin-1476251885-14762582482203230', 1, 1, 'SR', NULL, NULL, NULL),
(10256, '2016-10-12 15:19:59', NULL, NULL, 3679, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 15:19:59', 'admin-1476251885-14762567992686082', 1, 0, '', 1, NULL, NULL),
(10257, '2016-10-12 15:19:59', NULL, NULL, 3679, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 15:19:59', 'admin-1476251885-14762567992686082', 1, 1, 'SR', 1, NULL, NULL),
(10258, '2016-10-12 12:21:19', NULL, NULL, 3670, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 12:21:19', 'admin-1476234655-14762460793299331', 1, 0, '', NULL, NULL, NULL),
(10259, '2016-10-12 12:22:49', NULL, NULL, 3670, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 12:22:49', 'admin-1476246091-1476246168880450', 1, 1, 'SR', NULL, NULL, NULL),
(10260, '2016-10-12 12:22:49', NULL, NULL, 3670, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 12:22:49', 'admin-1476246091-1476246168880450', 1, 0, '', NULL, NULL, NULL),
(10261, '2016-10-12 12:22:49', NULL, NULL, 3670, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 12:22:49', 'admin-1476246091-1476246168880450', 1, 1, 'SR', NULL, NULL, NULL),
(10262, '2016-10-12 15:19:59', NULL, NULL, 3679, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 15:19:59', 'admin-1476251885-14762567992686082', 1, 1, 'SR', 1, NULL, NULL),
(10263, '2016-10-12 14:54:47', NULL, NULL, 3677, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 14:54:47', 'admin-1476251885-1476255287667322', 1, 1, 'SR', NULL, NULL, NULL),
(10264, '2016-10-12 13:51:00', NULL, NULL, 3677, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 13:51:00', 'admin-1476246091-14762514603885592', 1, 0, '', NULL, NULL, NULL),
(10265, '2016-10-12 13:59:29', NULL, NULL, 3677, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 13:59:29', 'admin-1476251885-14762519697397124', 1, 1, 'SR', NULL, NULL, NULL),
(10266, '2016-10-12 14:44:31', NULL, NULL, 3678, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 14:44:31', 'admin-1476251885-14762546714057117', 1, 1, 'SR', NULL, NULL, NULL),
(10267, '2016-10-12 14:54:47', NULL, NULL, 3677, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 14:54:47', 'admin-1476251885-1476255287667322', 1, 0, '', NULL, NULL, NULL),
(10268, '2016-10-12 09:11:06', NULL, NULL, 3662, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 09:11:06', 'admin-1476234655-14762346667988341', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(10269, '2016-10-12 09:22:49', NULL, NULL, 3663, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 09:22:49', 'admin-1476234655-14762353689753215', 1, 0, '', NULL, NULL, NULL),
(10270, '2016-10-12 09:22:49', NULL, NULL, 3663, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 09:22:49', 'admin-1476234655-14762353689753215', 1, 1, 'SR', NULL, NULL, NULL),
(10271, '2016-10-12 09:23:33', NULL, NULL, 3664, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 09:23:33', 'admin-1476234655-14762354135724662', 1, 0, '', NULL, NULL, NULL),
(10272, '2016-10-12 09:23:33', NULL, NULL, 3664, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 09:23:33', 'admin-1476234655-14762354135724662', 1, 1, 'SR', NULL, NULL, NULL),
(10273, '2016-10-12 13:32:44', NULL, NULL, 3677, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 3, 12.00, 36.0000, 0.0000, 36.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 13:32:44', 'admin-1476246091-14762503640601862', 1, 1, 'SR', NULL, NULL, NULL),
(10274, '2016-10-12 13:11:06', NULL, NULL, 3676, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 13:11:06', 'admin-1476246091-14762490658499615', 1, 1, 'SR', NULL, NULL, NULL),
(10275, '2016-10-12 13:10:49', NULL, NULL, 3676, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 13:10:49', 'admin-1476246091-14762490491951583', 1, 0, '', NULL, NULL, NULL),
(10276, '2016-10-12 13:10:49', NULL, NULL, 3676, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 13:10:49', 'admin-1476246091-14762490491951583', 1, 1, 'SR', NULL, NULL, NULL),
(10277, '2016-10-12 13:02:09', NULL, NULL, 3675, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 13:02:09', 'admin-1476246091-1476248529017355', 1, 1, 'SR', NULL, NULL, NULL),
(10278, '2016-10-12 13:02:09', NULL, NULL, 3675, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 13:02:09', 'admin-1476246091-1476248529017355', 1, 1, 'SR', NULL, NULL, NULL),
(10279, '2016-10-12 13:01:14', NULL, NULL, 3674, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 13:01:14', 'admin-1476246091-14762484743949436', 1, 1, 'SR', NULL, NULL, NULL),
(10280, '2016-10-12 13:01:14', NULL, NULL, 3674, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 13:01:14', 'admin-1476246091-14762484743949436', 1, 1, 'SR', NULL, NULL, NULL),
(10281, '2016-10-12 09:30:41', NULL, NULL, 3665, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 09:30:41', 'admin-1476234655-14762358408499233', 1, 1, 'SR', NULL, NULL, NULL),
(10282, '2016-10-12 09:37:16', NULL, NULL, 3666, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 09:37:16', 'admin-1476234655-14762362366742279', 1, 0, '', NULL, NULL, NULL),
(10283, '2016-10-12 10:16:24', NULL, NULL, 3667, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 10:16:24', 'admin-1476234655-14762385843513926', 1, 1, 'SR', NULL, NULL, NULL),
(10284, '2016-10-12 10:34:59', NULL, NULL, 3667, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 10:34:59', 'admin-1476234655-14762396989278484', 1, 1, 'SR', NULL, NULL, NULL),
(10285, '2016-10-12 10:34:59', NULL, NULL, 3667, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 10:34:59', 'admin-1476234655-14762396989278484', 1, 1, 'SR', NULL, NULL, NULL),
(10286, '2016-10-12 10:34:59', NULL, NULL, 3667, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 10:34:59', 'admin-1476234655-14762396989278484', 1, 1, 'SR', NULL, NULL, NULL),
(10287, '2016-10-12 10:34:59', NULL, NULL, 3667, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 10:34:59', 'admin-1476234655-14762396989278484', 1, 1, 'SR', NULL, NULL, NULL),
(10288, '2016-10-12 11:38:17', NULL, NULL, 3668, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 11:38:17', 'admin-1476234655-14762434974468999', 1, 0, '', NULL, NULL, NULL),
(10289, '2016-10-12 11:38:17', NULL, NULL, 3668, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 11:38:17', 'admin-1476234655-14762434974468999', 1, 1, 'SR', NULL, NULL, NULL),
(10290, '2016-10-12 12:09:08', NULL, NULL, 3669, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 12:09:08', 'admin-1476234655-14762453485563932', 1, 0, '', NULL, NULL, NULL),
(10291, '2016-10-12 12:09:08', NULL, NULL, 3669, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 12:09:08', 'admin-1476234655-14762453485563932', 1, 1, 'SR', NULL, NULL, NULL),
(10292, '2016-10-12 12:33:53', NULL, NULL, 3673, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 12:33:53', 'admin-1476246091-1476246832948412', 1, 1, 'SR', NULL, NULL, NULL),
(10293, '2016-10-12 12:33:53', NULL, NULL, 3673, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 12:33:53', 'admin-1476246091-1476246832948412', 1, 1, 'SR', NULL, NULL, NULL),
(10294, '2016-10-12 12:27:34', NULL, NULL, 3672, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 12:27:34', 'admin-1476246091-14762464538464126', 1, 0, '', NULL, NULL, NULL),
(10295, '2016-10-12 12:27:34', NULL, NULL, 3672, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 12:27:34', 'admin-1476246091-14762464538464126', 1, 1, 'SR', NULL, NULL, NULL),
(10296, '2016-10-12 09:30:41', NULL, NULL, 3665, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 09:30:41', 'admin-1476234655-14762358408499233', 1, 0, '', NULL, NULL, NULL),
(10297, '2016-10-12 09:30:41', NULL, NULL, 3665, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 09:30:41', 'admin-1476234655-14762358408499233', 1, 0, '', NULL, NULL, NULL),
(10298, '2016-10-12 12:27:06', NULL, NULL, 3671, 0, 187, '122', 'Iced Tea ', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 12:27:06', 'admin-1476246091-14762464260548976', 1, 0, '', NULL, NULL, NULL),
(10299, '2016-10-12 12:27:34', NULL, NULL, 3672, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 12:27:34', 'admin-1476246091-14762464538464126', 1, 1, 'SR', NULL, NULL, NULL),
(10300, '2016-10-12 12:21:19', NULL, NULL, 3670, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 12:21:19', 'admin-1476234655-14762460793299331', 1, 0, '', NULL, NULL, NULL),
(10301, '2016-10-12 12:21:19', NULL, NULL, 3670, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 12:21:19', 'admin-1476234655-14762460793299331', 1, 0, '', NULL, NULL, NULL),
(10302, '2016-10-12 12:21:04', NULL, NULL, 3670, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 12:21:04', 'admin-1476234655-14762460643519270', 1, 1, 'SR', NULL, NULL, NULL),
(10303, '2016-10-12 12:21:04', NULL, NULL, 3670, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 12:21:04', 'admin-1476234655-14762460643519270', 1, 1, 'SR', NULL, NULL, NULL),
(10304, '2016-10-12 09:30:41', NULL, NULL, 3665, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 09:30:41', 'admin-1476234655-14762358408499233', 1, 1, 'SR', NULL, NULL, NULL),
(10305, '2016-10-12 09:11:06', NULL, NULL, 3662, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 09:11:06', 'admin-1476234655-14762346667988341', 1, 1, 'SR', NULL, NULL, NULL),
(10306, '2016-10-12 09:11:06', NULL, NULL, 3662, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476273339', 'admin', '2016-10-12 09:11:06', 'admin-1476234655-14762346667988341', 1, 0, '', NULL, NULL, NULL),
(10307, '2016-10-13 20:38:02', NULL, NULL, 3716, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 20:38:02', 'admin-1476357929-14763622821451267', 1, 1, 'SR', NULL, NULL, NULL),
(10308, '2016-10-13 20:38:02', NULL, NULL, 3716, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 20:38:02', 'admin-1476357929-14763622821451267', 1, 1, 'SR', NULL, NULL, NULL),
(10309, '2016-10-13 20:38:02', NULL, NULL, 3716, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 20:38:02', 'admin-1476357929-14763622821451267', 1, 1, 'SR', NULL, NULL, NULL),
(10310, '2016-10-13 20:40:53', NULL, NULL, 3717, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 20:40:53', 'admin-1476357929-14763624530725390', 1, 1, 'SR', NULL, NULL, NULL),
(10311, '2016-10-13 21:00:25', NULL, NULL, 3709, 0, 228, '162', 'Golden Brown', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 21:00:25', 'admin-1476357929-1476363625428454', 1, 0, '', NULL, NULL, NULL),
(10312, '2016-10-13 21:00:25', NULL, NULL, 3709, 0, 227, '161', 'Cranberry Velvet', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 21:00:25', 'admin-1476357929-1476363625428454', 1, 0, '', NULL, NULL, NULL),
(10313, '2016-10-13 21:33:33', NULL, NULL, 3718, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 21:33:33', 'admin-1476357929-14763656137769710', 1, 1, 'SR', NULL, NULL, NULL),
(10314, '2016-10-13 21:33:33', NULL, NULL, 3718, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 21:33:33', 'admin-1476357929-14763656137769710', 1, 1, 'SR', NULL, NULL, NULL),
(10315, '2016-10-13 19:25:15', NULL, NULL, 3709, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 19:25:15', 'admin-1476320667-14763579153199514', 1, 0, '', NULL, NULL, NULL),
(10316, '2016-10-13 20:12:42', NULL, NULL, 3710, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 20:12:42', 'admin-1476357929-147636076259926', 1, 1, 'SR', NULL, NULL, NULL),
(10317, '2016-10-13 20:19:19', NULL, NULL, 3715, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 20:19:19', 'admin-1476357929-14763611592558532', 1, 0, '', NULL, NULL, NULL),
(10318, '2016-10-13 20:11:56', NULL, NULL, 3714, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 20:11:56', 'admin-1476357929-14763607163499188', 1, 1, 'SR', NULL, NULL, NULL),
(10319, '2016-10-13 13:36:10', NULL, NULL, 3705, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 13:36:10', 'admin-1476320667-14763369701915632', 1, 1, 'SR', NULL, NULL, NULL),
(10320, '2016-10-13 13:36:10', NULL, NULL, 3705, 0, 227, '161', 'Cranberry Velvet', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 13:36:10', 'admin-1476320667-14763369701915632', 1, 0, '', NULL, NULL, NULL),
(10321, '2016-10-13 15:58:19', NULL, NULL, 3706, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 15:58:19', 'admin-1476320667-14763454991594119', 1, 1, 'SR', NULL, NULL, NULL),
(10322, '2016-10-13 15:58:19', NULL, NULL, 3706, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 15:58:19', 'admin-1476320667-14763454991594119', 1, 1, 'SR', NULL, NULL, NULL),
(10323, '2016-10-13 20:06:40', NULL, NULL, 3713, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 20:06:40', 'admin-1476357929-14763604007718274', 1, 1, 'SR', NULL, NULL, NULL),
(10324, '2016-10-13 20:06:40', NULL, NULL, 3713, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 20:06:40', 'admin-1476357929-14763604007718274', 1, 0, '', NULL, NULL, NULL),
(10325, '2016-10-13 19:41:32', NULL, NULL, 3711, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 19:41:32', 'admin-1476357929-14763588921826597', 1, 1, 'SR', NULL, NULL, NULL),
(10326, '2016-10-13 19:41:32', NULL, NULL, 3711, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 19:41:32', 'admin-1476357929-14763588921826597', 1, 1, 'SR', NULL, NULL, NULL),
(10327, '2016-10-13 19:57:50', NULL, NULL, 3712, 0, 227, '161', 'Cranberry Velvet', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 19:57:50', 'admin-1476357929-14763598701632960', 1, 0, '', NULL, NULL, NULL),
(10328, '2016-10-13 20:06:40', NULL, NULL, 3713, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 20:06:40', 'admin-1476357929-14763604007718274', 1, 0, '', NULL, NULL, NULL),
(10329, '2016-10-13 10:18:52', NULL, NULL, 3698, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 10:18:52', 'admin-1476320667-14763251322079892', 1, 1, 'SR', NULL, NULL, NULL),
(10330, '2016-10-13 10:24:46', NULL, NULL, 3698, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 10:24:46', 'admin-1476320667-1476325486674955', 1, 0, '', NULL, NULL, NULL),
(10331, '2016-10-13 11:21:23', NULL, NULL, 3699, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 11:21:23', 'admin-1476320667-1476328882895657', 1, 0, '', NULL, NULL, NULL),
(10332, '2016-10-13 20:06:40', NULL, NULL, 3713, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 20:06:40', 'admin-1476357929-14763604007718274', 1, 0, '', NULL, NULL, NULL),
(10333, '2016-10-13 19:30:21', NULL, NULL, 3709, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 19:30:21', 'admin-1476357929-14763582210702558', 1, 1, 'SR', NULL, NULL, NULL),
(10334, '2016-10-13 19:30:21', NULL, NULL, 3709, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 19:30:21', 'admin-1476357929-14763582210702558', 1, 1, 'SR', NULL, NULL, NULL),
(10335, '2016-10-13 19:30:21', NULL, NULL, 3709, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 19:30:21', 'admin-1476357929-14763582210702558', 1, 1, 'SR', NULL, NULL, NULL),
(10336, '2016-10-13 19:29:27', NULL, NULL, 3710, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 19:29:27', 'admin-1476357929-14763581670384921', 1, 1, 'SR', NULL, NULL, NULL),
(10337, '2016-10-13 19:29:27', NULL, NULL, 3710, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 19:29:27', 'admin-1476357929-14763581670384921', 1, 1, 'SR', NULL, NULL, NULL),
(10338, '2016-10-13 19:26:28', NULL, NULL, 3709, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 19:26:28', 'admin-1476357929-14763579879428743', 1, 0, '', NULL, NULL, NULL),
(10339, '2016-10-13 19:25:15', NULL, NULL, 3709, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 19:25:15', 'admin-1476320667-14763579153199514', 1, 0, '', NULL, NULL, NULL),
(10340, '2016-10-13 19:25:15', NULL, NULL, 3709, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 19:25:15', 'admin-1476320667-14763579153199514', 1, 1, 'SR', NULL, NULL, NULL),
(10341, '2016-10-13 11:50:41', NULL, NULL, 3700, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 11:50:41', 'admin-1476320667-14763306414029760', 1, 1, 'SR', NULL, NULL, NULL),
(10342, '2016-10-13 11:50:41', NULL, NULL, 3700, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 11:50:41', 'admin-1476320667-14763306414029760', 1, 1, 'SR', NULL, NULL, NULL),
(10343, '2016-10-13 11:56:28', NULL, NULL, 3701, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 11:56:28', 'admin-1476320667-1476330988525284', 1, 1, 'SR', NULL, NULL, NULL),
(10344, '2016-10-13 11:56:28', NULL, NULL, 3701, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 11:56:28', 'admin-1476320667-1476330988525284', 1, 1, 'SR', NULL, NULL, NULL),
(10345, '2016-10-13 11:56:58', NULL, NULL, 3701, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 11:56:58', 'admin-1476320667-14763310181052441', 1, 0, '', NULL, NULL, NULL),
(10346, '2016-10-13 11:56:58', NULL, NULL, 3701, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 11:56:58', 'admin-1476320667-14763310181052441', 1, 0, '', NULL, NULL, NULL),
(10347, '2016-10-13 12:06:33', NULL, NULL, 3702, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 12:06:33', 'admin-1476320667-14763315930589927', 1, 1, 'SR', NULL, NULL, NULL),
(10348, '2016-10-13 12:06:33', NULL, NULL, 3702, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 12:06:33', 'admin-1476320667-14763315930589927', 1, 1, 'SR', NULL, NULL, NULL),
(10349, '2016-10-13 12:06:33', NULL, NULL, 3702, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 12:06:33', 'admin-1476320667-14763315930589927', 1, 1, 'SR', NULL, NULL, NULL),
(10350, '2016-10-13 12:46:31', NULL, NULL, 3703, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 12:46:31', 'admin-1476320667-1476333991521321', 1, 1, 'SR', NULL, NULL, NULL),
(10351, '2016-10-13 13:33:30', NULL, NULL, 3704, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 13:33:30', 'admin-1476320667-1476336810787289', 1, 1, 'SR', NULL, NULL, NULL),
(10352, '2016-10-13 13:33:30', NULL, NULL, 3704, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 13:33:30', 'admin-1476320667-1476336810787289', 1, 0, '', NULL, NULL, NULL),
(10353, '2016-10-13 19:25:15', NULL, NULL, 3709, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 19:25:15', 'admin-1476320667-14763579153199514', 1, 1, 'SR', NULL, NULL, NULL),
(10354, '2016-10-13 19:25:15', NULL, NULL, 3709, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 19:25:15', 'admin-1476320667-14763579153199514', 1, 0, '', NULL, NULL, NULL),
(10355, '2016-10-13 15:58:19', NULL, NULL, 3706, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 15:58:19', 'admin-1476320667-14763454991594119', 1, 0, '', NULL, NULL, NULL),
(10356, '2016-10-13 15:58:19', NULL, NULL, 3706, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 15:58:19', 'admin-1476320667-14763454991594119', 1, 0, '', NULL, NULL, NULL),
(10357, '2016-10-13 16:08:38', NULL, NULL, 3707, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 16:08:38', 'admin-1476320667-14763461184596426', 1, 1, 'SR', NULL, NULL, NULL),
(10358, '2016-10-13 20:12:42', NULL, NULL, 3710, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 20:12:42', 'admin-1476357929-147636076259926', 1, 1, 'SR', NULL, NULL, NULL),
(10359, '2016-10-13 18:38:38', NULL, NULL, 3708, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 18:38:38', 'admin-1476320667-14763551180778361', 1, 0, '', NULL, NULL, NULL),
(10360, '2016-10-13 13:36:10', NULL, NULL, 3705, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 13:36:10', 'admin-1476320667-14763369701915632', 1, 1, 'SR', NULL, NULL, NULL),
(10361, '2016-10-13 13:33:30', NULL, NULL, 3704, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 13:33:30', 'admin-1476320667-1476336810787289', 1, 0, '', NULL, NULL, NULL),
(10362, '2016-10-13 13:33:30', NULL, NULL, 3704, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 13:33:30', 'admin-1476320667-1476336810787289', 1, 0, '', NULL, NULL, NULL),
(10363, '2016-10-13 13:33:30', NULL, NULL, 3704, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 13:33:30', 'admin-1476320667-1476336810787289', 1, 1, 'SR', NULL, NULL, NULL),
(10364, '2016-10-13 18:38:38', NULL, NULL, 3708, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 18:38:38', 'admin-1476320667-14763551180778361', 1, 0, '', NULL, NULL, NULL),
(10365, '2016-10-13 11:21:23', NULL, NULL, 3699, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 11:21:23', 'admin-1476320667-1476328882895657', 1, 1, 'SR', NULL, NULL, NULL),
(10366, '2016-10-13 10:18:52', NULL, NULL, 3698, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476357929', 'admin', '2016-10-13 10:18:52', 'admin-1476320667-14763251322079892', 1, 1, 'SR', NULL, NULL, NULL),
(10367, '2016-10-14 19:39:29', NULL, NULL, 3732, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 19:39:29', 'admin-1476435711-14764451697586993', 1, 0, '', NULL, NULL, NULL),
(10368, '2016-10-14 16:19:38', NULL, NULL, 3726, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 16:19:38', 'admin-1476424723-14764331778468498', 1, 1, 'SR', NULL, NULL, NULL),
(10369, '2016-10-14 16:45:17', NULL, NULL, 3727, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 16:45:17', 'admin-1476424723-14764347174448247', 1, 1, 'SR', NULL, NULL, NULL),
(10370, '2016-10-14 16:45:17', NULL, NULL, 3727, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 16:45:17', 'admin-1476424723-14764347174448247', 1, 1, 'SR', NULL, NULL, NULL),
(10371, '2016-10-14 16:48:07', NULL, NULL, 3726, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 16:48:07', 'admin-1476424723-14764348874437794', 1, 0, '', NULL, NULL, NULL),
(10372, '2016-10-14 16:52:38', NULL, NULL, 3728, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 16:52:38', 'admin-1476424723-1476435158464217', 1, 0, '', NULL, NULL, NULL),
(10373, '2016-10-14 16:52:52', NULL, NULL, 3728, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 16:52:52', 'admin-1476424723-14764351722819545', 1, 0, '', NULL, NULL, NULL),
(10374, '2016-10-14 17:01:34', NULL, NULL, 3728, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 17:01:34', 'admin-1476424723-14764356941738290', 1, 0, '', NULL, NULL, NULL),
(10375, '2016-10-14 17:01:34', NULL, NULL, 3728, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 17:01:34', 'admin-1476424723-14764356941738290', 1, 1, 'SR', NULL, NULL, NULL),
(10376, '2016-10-14 17:02:04', NULL, NULL, 3728, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 17:02:04', 'admin-1476435711-14764357247024915', 1, 0, '', NULL, NULL, NULL),
(10377, '2016-10-14 15:27:16', NULL, NULL, 3724, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 15:27:16', 'admin-1476424723-14764300363188665', 1, 0, '', NULL, NULL, NULL),
(10378, '2016-10-14 15:27:28', NULL, NULL, 3724, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 15:27:28', 'admin-1476424723-14764300483085554', 1, 0, '', NULL, NULL, NULL),
(10379, '2016-10-14 13:59:04', NULL, NULL, 3722, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 13:59:04', 'admin-1476424723-14764247441381166', 1, 0, '', NULL, NULL, NULL),
(10380, '2016-10-14 13:59:04', NULL, NULL, 3722, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 13:59:04', 'admin-1476424723-14764247441381166', 1, 1, 'SR', NULL, NULL, NULL),
(10381, '2016-10-14 13:59:04', NULL, NULL, 3722, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 13:59:04', 'admin-1476424723-14764247441381166', 1, 1, 'SR', NULL, NULL, NULL),
(10382, '2016-10-14 13:59:04', NULL, NULL, 3722, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 13:59:04', 'admin-1476424723-14764247441381166', 1, 1, 'SR', NULL, NULL, NULL),
(10383, '2016-10-14 13:59:15', NULL, NULL, 3722, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 13:59:15', 'admin-1476424723-14764247549193087', 1, 1, 'SR', NULL, NULL, NULL),
(10384, '2016-10-14 13:59:15', NULL, NULL, 3722, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 13:59:15', 'admin-1476424723-14764247549193087', 1, 1, 'SR', NULL, NULL, NULL),
(10385, '2016-10-14 13:59:15', NULL, NULL, 3722, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 13:59:15', 'admin-1476424723-14764247549193087', 1, 1, 'SR', NULL, NULL, NULL),
(10386, '2016-10-14 14:24:41', NULL, NULL, 3721, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 14:24:41', 'admin-1476424723-14764262814015283', 1, 1, 'SR', NULL, NULL, NULL),
(10387, '2016-10-14 14:49:24', NULL, NULL, 3722, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 14:49:24', 'admin-1476424723-14764277639274846', 1, 1, 'SR', NULL, NULL, NULL),
(10388, '2016-10-14 14:29:22', NULL, NULL, 3720, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 14:29:22', 'admin-1476424723-14764265627023821', 1, 1, 'SR', NULL, NULL, NULL),
(10389, '2016-10-14 14:29:58', NULL, NULL, 3723, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 14:29:58', 'admin-1476424723-14764265980504166', 1, 1, 'SR', NULL, NULL, NULL),
(10390, '2016-10-14 14:49:34', NULL, NULL, 3722, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 14:49:34', 'admin-1476424723-14764277738059770', 1, 1, 'SR', NULL, NULL, NULL),
(10391, '2016-10-14 20:00:26', NULL, NULL, 3732, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 20:00:26', 'admin-1476435711-14764464259234546', 1, 1, 'SR', NULL, NULL, NULL),
(10392, '2016-10-14 19:55:27', NULL, NULL, 3733, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 19:55:27', 'admin-1476435711-14764461272134234', 1, 0, '', NULL, NULL, NULL),
(10393, '2016-10-14 19:41:37', NULL, NULL, 3733, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 19:41:37', 'admin-1476435711-14764452973943367', 1, 1, 'SR', NULL, NULL, NULL),
(10394, '2016-10-14 19:41:37', NULL, NULL, 3733, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 19:41:37', 'admin-1476435711-14764452973943367', 1, 1, 'SR', NULL, NULL, NULL),
(10395, '2016-10-14 19:41:15', NULL, NULL, 3733, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 19:41:15', 'admin-1476435711-14764452749407472', 1, 1, 'SR', NULL, NULL, NULL),
(10396, '2016-10-14 19:41:15', NULL, NULL, 3733, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 19:41:15', 'admin-1476435711-14764452749407472', 1, 0, '', NULL, NULL, NULL),
(10397, '2016-10-14 12:54:27', NULL, NULL, 3720, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 12:54:27', 'admin-1476406799-14764208668275955', 1, 0, '', NULL, NULL, NULL),
(10398, '2016-10-14 12:54:27', NULL, NULL, 3720, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 12:54:27', 'admin-1476406799-14764208668275955', 1, 0, '', NULL, NULL, NULL),
(10399, '2016-10-14 19:39:29', NULL, NULL, 3732, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 19:39:29', 'admin-1476435711-14764451697586993', 1, 0, '', NULL, NULL, NULL),
(10400, '2016-10-14 19:39:29', NULL, NULL, 3732, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 19:39:29', 'admin-1476435711-14764451697586993', 1, 0, '', NULL, NULL, NULL),
(10401, '2016-10-14 19:22:48', NULL, NULL, 3731, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 19:22:48', 'admin-1476435711-14764441686656334', 1, 0, '', NULL, NULL, NULL),
(10402, '2016-10-14 19:22:48', NULL, NULL, 3731, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 19:22:48', 'admin-1476435711-14764441686656334', 1, 1, 'SR', NULL, NULL, NULL),
(10403, '2016-10-14 19:22:48', NULL, NULL, 3731, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 19:22:48', 'admin-1476435711-14764441686656334', 1, 1, 'SR', NULL, NULL, NULL),
(10404, '2016-10-14 19:22:48', NULL, NULL, 3731, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 19:22:48', 'admin-1476435711-14764441686656334', 1, 1, 'SR', NULL, NULL, NULL),
(10405, '2016-10-14 19:01:28', NULL, NULL, 3730, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 19:01:28', 'admin-1476435711-14764428879338515', 1, 1, 'SR', NULL, NULL, NULL),
(10406, '2016-10-14 19:01:28', NULL, NULL, 3730, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 19:01:28', 'admin-1476435711-14764428879338515', 1, 1, 'SR', NULL, NULL, NULL),
(10407, '2016-10-14 17:35:56', NULL, NULL, 3729, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 17:35:56', 'admin-1476435711-14764377561214889', 1, 0, '', NULL, NULL, NULL),
(10408, '2016-10-14 15:37:46', NULL, NULL, 3725, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 15:37:46', 'admin-1476424723-1476430666362123', 1, 1, 'SR', NULL, NULL, NULL),
(10409, '2016-10-14 12:58:26', NULL, NULL, 3720, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 12:58:26', 'admin-1476406799-14764211061268861', 1, 1, 'SR', NULL, NULL, NULL),
(10410, '2016-10-14 13:22:11', NULL, NULL, 3721, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 13:22:11', 'admin-1476406799-14764225312767993', 1, 1, 'SR', NULL, NULL, NULL),
(10411, '2016-10-14 13:22:11', NULL, NULL, 3721, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 13:22:11', 'admin-1476406799-14764225312767993', 1, 1, 'SR', NULL, NULL, NULL),
(10412, '2016-10-14 13:23:17', NULL, NULL, 3721, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 13:23:17', 'admin-1476406799-1476422597274963', 1, 1, 'SR', NULL, NULL, NULL),
(10413, '2016-10-14 15:37:46', NULL, NULL, 3725, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 15:37:46', 'admin-1476424723-1476430666362123', 1, 1, 'SR', NULL, NULL, NULL),
(10414, '2016-10-14 15:27:16', NULL, NULL, 3724, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 15:27:16', 'admin-1476424723-14764300363188665', 1, 0, '', NULL, NULL, NULL),
(10415, '2016-10-14 13:23:39', NULL, NULL, 3720, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 13:23:39', 'admin-1476406799-14764226190321636', 1, 0, '', NULL, NULL, NULL),
(10416, '2016-10-14 19:01:10', NULL, NULL, 3730, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 19:01:10', 'admin-1476435711-14764428706969047', 1, 0, '', NULL, NULL, NULL),
(10417, '2016-10-14 13:34:05', NULL, NULL, 3721, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 13:34:05', 'admin-1476406799-14764232452415413', 1, 1, 'SR', NULL, NULL, NULL),
(10418, '2016-10-14 13:33:55', NULL, NULL, 3721, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 13:33:55', 'admin-1476406799-14764232352684069', 1, 0, '', NULL, NULL, NULL),
(10419, '2016-10-14 13:23:17', NULL, NULL, 3721, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 13:23:17', 'admin-1476406799-1476422597274963', 1, 1, 'SR', NULL, NULL, NULL),
(10420, '2016-10-14 12:54:27', NULL, NULL, 3720, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 12:54:27', 'admin-1476406799-14764208668275955', 1, 1, 'SR', NULL, NULL, NULL),
(10421, '2016-10-14 12:12:09', NULL, NULL, 3719, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476435711', 'admin', '2016-10-14 12:12:09', 'admin-1476406799-14764183291752319', 1, 1, 'SR', NULL, NULL, NULL),
(10422, '2016-10-15 17:41:51', NULL, NULL, 3764, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 17:41:51', 'admin-1476505036-14765245108772210', 1, 1, 'SR', 1, NULL, NULL),
(10423, '2016-10-15 17:41:51', NULL, NULL, 3764, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 17:41:51', 'admin-1476505036-14765245108772210', 1, 0, '', 1, NULL, NULL),
(10424, '2016-10-15 18:57:50', NULL, NULL, 3765, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 18:57:50', 'admin-1476505036-14765290698205813', 1, 1, 'SR', NULL, NULL, NULL),
(10425, '2016-10-15 18:57:50', NULL, NULL, 3765, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 18:57:50', 'admin-1476505036-14765290698205813', 1, 1, 'SR', NULL, NULL, NULL),
(10426, '2016-10-15 18:57:50', NULL, NULL, 3765, 0, 227, '161', 'Cranberry Velvet', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 18:57:50', 'admin-1476505036-14765290698205813', 1, 0, '', NULL, NULL, NULL),
(10427, '2016-10-15 19:31:24', NULL, NULL, 3766, 0, 227, '161', 'Cranberry Velvet', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 19:31:24', 'admin-1476505036-1476531084818293', 1, 0, '', NULL, NULL, NULL),
(10428, '2016-10-15 20:01:25', NULL, NULL, 3767, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 20:01:25', 'admin-1476505036-14765328849957084', 1, 1, 'SR', NULL, NULL, NULL),
(10429, '2016-10-15 20:01:25', NULL, NULL, 3767, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 20:01:25', 'admin-1476505036-14765328849957084', 1, 1, 'SR', NULL, NULL, NULL),
(10430, '2016-10-15 20:11:28', NULL, NULL, 3768, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 20:11:28', 'admin-1476505036-14765334879796135', 1, 1, 'SR', NULL, NULL, NULL),
(10431, '2016-10-15 20:11:28', NULL, NULL, 3768, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 20:11:28', 'admin-1476505036-14765334879796135', 1, 0, '', NULL, NULL, NULL),
(10432, '2016-10-15 20:11:28', NULL, NULL, 3768, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 20:11:28', 'admin-1476505036-14765334879796135', 1, 0, '', NULL, NULL, NULL),
(10433, '2016-10-15 20:11:38', NULL, NULL, 3768, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 20:11:38', 'admin-1476505036-14765334983213811', 1, 1, 'SR', NULL, NULL, NULL),
(10434, '2016-10-15 20:11:38', NULL, NULL, 3768, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 20:11:38', 'admin-1476505036-14765334983213811', 1, 1, 'SR', NULL, NULL, NULL),
(10435, '2016-10-15 20:15:27', NULL, NULL, 3769, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 20:15:27', 'admin-1476505036-14765337270813712', 1, 0, '', NULL, NULL, NULL),
(10436, '2016-10-15 20:17:15', NULL, NULL, 3770, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 20:17:15', 'admin-1476505036-1476533835253140', 1, 1, 'SR', NULL, NULL, NULL),
(10437, '2016-10-15 20:17:15', NULL, NULL, 3770, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 20:17:15', 'admin-1476505036-1476533835253140', 1, 1, 'SR', NULL, NULL, NULL),
(10438, '2016-10-15 20:24:10', NULL, NULL, 3771, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 20:24:10', 'admin-1476505036-14765342503513330', 1, 1, 'SR', NULL, NULL, NULL),
(10439, '2016-10-15 20:24:10', NULL, NULL, 3771, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 20:24:10', 'admin-1476505036-14765342503513330', 1, 0, '', NULL, NULL, NULL),
(10440, '2016-10-15 17:24:17', NULL, NULL, 3763, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 17:24:17', 'admin-1476505036-14765234572499926', 1, 0, '', NULL, NULL, NULL),
(10441, '2016-10-15 17:33:29', NULL, NULL, 3761, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 17:33:29', 'admin-1476505036-14765240089897638', 1, 0, '', NULL, NULL, NULL),
(10442, '2016-10-15 17:33:29', NULL, NULL, 3761, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 17:33:29', 'admin-1476505036-14765240089897638', 1, 0, '', NULL, NULL, NULL),
(10443, '2016-10-15 16:59:28', NULL, NULL, 3762, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 16:59:28', 'admin-1476505036-14765219678711631', 1, 1, 'SR', NULL, NULL, NULL),
(10444, '2016-10-15 16:59:28', NULL, NULL, 3762, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 16:59:28', 'admin-1476505036-14765219678711631', 1, 1, 'SR', NULL, NULL, NULL),
(10445, '2016-10-15 16:59:28', NULL, NULL, 3762, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 16:59:28', 'admin-1476505036-14765219678711631', 1, 1, 'SR', NULL, NULL, NULL),
(10446, '2016-10-15 16:59:28', NULL, NULL, 3762, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 16:59:28', 'admin-1476505036-14765219678711631', 1, 0, '', NULL, NULL, NULL),
(10447, '2016-10-15 16:56:18', NULL, NULL, 3761, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 16:56:18', 'admin-1476505036-14765217783516450', 1, 1, 'SR', NULL, NULL, NULL),
(10448, '2016-10-15 16:56:05', NULL, NULL, 3760, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 16:56:05', 'admin-1476505036-1476521764859321', 1, 1, 'SR', NULL, NULL, NULL),
(10449, '2016-10-15 16:56:05', NULL, NULL, 3760, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 16:56:05', 'admin-1476505036-1476521764859321', 1, 0, '', NULL, NULL, NULL),
(10450, '2016-10-15 16:54:53', NULL, NULL, 3759, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 16:54:53', 'admin-1476505036-14765216931823571', 1, 1, 'SR', NULL, NULL, NULL),
(10451, '2016-10-15 16:48:32', NULL, NULL, 3758, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 16:48:32', 'admin-1476505036-14765213123226818', 1, 1, 'SR', NULL, NULL, NULL),
(10452, '2016-10-15 16:48:32', NULL, NULL, 3758, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 16:48:32', 'admin-1476505036-14765213123226818', 1, 1, 'SR', NULL, NULL, NULL),
(10453, '2016-10-15 16:48:32', NULL, NULL, 3758, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 16:48:32', 'admin-1476505036-14765213123226818', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(10454, '2016-10-15 00:00:00', NULL, NULL, 3756, 0, 75, '75', 'Meatless Aglio Olio ', 'no cheese', 'Meals', 'Perfect Meals', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 13:24:21', 'admin-1476505036-14765090610993137', 1, 0, '', NULL, NULL, NULL),
(10455, '2016-10-15 16:48:32', NULL, NULL, 3758, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 16:48:32', 'admin-1476505036-14765213123226818', 1, 1, 'SR', NULL, NULL, NULL),
(10456, '2016-10-15 13:13:29', NULL, NULL, 3752, 0, 82, '82', 'Set Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 13:13:29', 'admin-1476505036-14765084092119283', 1, 1, 'SR', NULL, NULL, NULL),
(10457, '2016-10-15 13:13:29', NULL, NULL, 3752, 0, 82, '82', 'Set Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 13:13:29', 'admin-1476505036-14765084092119283', 1, 1, 'SR', NULL, NULL, NULL),
(10458, '2016-10-15 13:13:29', NULL, NULL, 3752, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 13:13:29', 'admin-1476505036-14765084092119283', 1, 1, 'SR', NULL, NULL, NULL),
(10459, '2016-10-15 09:44:02', NULL, NULL, 3738, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:44:02', 'admin-1476493279-1476495842723781', 1, 1, 'SR', NULL, NULL, NULL),
(10460, '2016-10-15 09:44:02', NULL, NULL, 3738, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:44:02', 'admin-1476493279-1476495842723781', 1, 1, 'SR', NULL, NULL, NULL),
(10461, '2016-10-15 09:44:02', NULL, NULL, 3738, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:44:02', 'admin-1476493279-1476495842723781', 1, 0, '', NULL, NULL, NULL),
(10462, '2016-10-15 09:46:07', NULL, NULL, 3739, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:46:07', 'admin-1476493279-14764959672944987', 1, 0, '', NULL, NULL, NULL),
(10463, '2016-10-15 09:46:07', NULL, NULL, 3739, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:46:07', 'admin-1476493279-14764959672944987', 1, 0, '', NULL, NULL, NULL),
(10464, '2016-10-15 09:46:07', NULL, NULL, 3739, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:46:07', 'admin-1476493279-14764959672944987', 1, 0, '', NULL, NULL, NULL),
(10465, '2016-10-15 09:46:17', NULL, NULL, 3739, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:46:17', 'admin-1476493279-14764959775949446', 1, 1, 'SR', NULL, NULL, NULL),
(10466, '2016-10-15 09:46:17', NULL, NULL, 3739, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:46:17', 'admin-1476493279-14764959775949446', 1, 0, '', NULL, NULL, NULL),
(10467, '2016-10-15 09:49:40', NULL, NULL, 3740, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:49:40', 'admin-1476493279-14764961801036735', 1, 1, 'SR', NULL, NULL, NULL),
(10468, '2016-10-15 20:24:10', NULL, NULL, 3771, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 20:24:10', 'admin-1476505036-14765342503513330', 1, 1, 'SR', NULL, NULL, NULL),
(10469, '2016-10-15 16:48:32', NULL, NULL, 3758, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 16:48:32', 'admin-1476505036-14765213123226818', 1, 1, 'SR', NULL, NULL, NULL),
(10470, '2016-10-15 00:00:00', NULL, NULL, 3756, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 13:24:21', 'admin-1476505036-14765090610993137', 1, 0, '', NULL, NULL, NULL),
(10471, '2016-10-15 14:09:10', NULL, NULL, 3755, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 14:09:10', 'admin-1476505036-14765117505412112', 1, 0, '', NULL, NULL, NULL),
(10472, '2016-10-15 14:09:10', NULL, NULL, 3755, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 14:09:10', 'admin-1476505036-14765117505412112', 1, 1, 'SR', NULL, NULL, NULL),
(10473, '2016-10-15 14:09:10', NULL, NULL, 3755, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 14:09:10', 'admin-1476505036-14765117505412112', 1, 1, 'SR', NULL, NULL, NULL),
(10474, '2016-10-15 14:07:58', NULL, NULL, 3754, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 14:07:58', 'admin-1476505036-1476511678701520', 1, 1, 'SR', NULL, NULL, NULL),
(10475, '2016-10-15 17:24:17', NULL, NULL, 3763, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 17:24:17', 'admin-1476505036-14765234572499926', 1, 1, 'SR', NULL, NULL, NULL),
(10476, '2016-10-15 16:59:28', NULL, NULL, 3762, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 16:59:28', 'admin-1476505036-14765219678711631', 1, 1, 'SR', NULL, NULL, NULL),
(10477, '2016-10-15 17:24:17', NULL, NULL, 3763, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 17:24:17', 'admin-1476505036-14765234572499926', 1, 1, 'SR', NULL, NULL, NULL),
(10478, '2016-10-15 00:00:00', NULL, NULL, 3756, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 13:24:41', 'admin-1476505036-14765090812625166', 1, 1, 'SR', NULL, NULL, NULL),
(10479, '2016-10-15 00:00:00', NULL, NULL, 3757, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 13:24:21', 'admin-1476505036-14765090610993137', 1, 1, 'SR', NULL, NULL, NULL),
(10480, '2016-10-15 00:00:00', NULL, NULL, 3757, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 13:24:41', 'admin-1476505036-14765090812625166', 1, 1, 'SR', NULL, NULL, NULL),
(10481, '2016-10-15 00:00:00', NULL, NULL, 3757, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 13:24:41', 'admin-1476505036-14765090812625166', 1, 1, 'SR', NULL, NULL, NULL),
(10482, '2016-10-15 00:00:00', NULL, NULL, 3756, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 13:24:41', 'admin-1476505036-14765090812625166', 1, 1, 'SR', NULL, NULL, NULL),
(10483, '2016-10-15 00:00:00', NULL, NULL, 3757, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 13:24:21', 'admin-1476505036-14765090610993137', 1, 1, 'SR', NULL, NULL, NULL),
(10484, '2016-10-15 00:00:00', NULL, NULL, 3756, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 13:24:21', 'admin-1476505036-14765090610993137', 1, 1, 'SR', NULL, NULL, NULL),
(10485, '2016-10-15 00:00:00', NULL, NULL, 3757, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 13:24:41', 'admin-1476505036-14765090812625166', 1, 1, 'SR', NULL, NULL, NULL),
(10486, '2016-10-15 00:00:00', NULL, NULL, 3757, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 13:24:21', 'admin-1476505036-14765090610993137', 1, 0, '', NULL, NULL, NULL),
(10487, '2016-10-15 12:17:01', NULL, NULL, 3749, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 12:17:01', 'admin-1476496219-14765050210673675', 1, 0, '', NULL, NULL, NULL),
(10488, '2016-10-15 12:17:01', NULL, NULL, 3749, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 12:17:01', 'admin-1476496219-14765050210673675', 1, 0, '', NULL, NULL, NULL),
(10489, '2016-10-15 12:17:01', NULL, NULL, 3749, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 12:17:01', 'admin-1476496219-14765050210673675', 1, 1, 'SR', NULL, NULL, NULL),
(10490, '2016-10-15 11:56:15', NULL, NULL, 3748, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 11:56:15', 'admin-1476496219-14765037749505742', 1, 1, 'SR', NULL, NULL, NULL),
(10491, '2016-10-15 11:56:08', NULL, NULL, 3748, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 11:56:08', 'admin-1476496219-14765037687654879', 1, 0, '', NULL, NULL, NULL),
(10492, '2016-10-15 11:55:53', NULL, NULL, 3747, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 11:55:53', 'admin-1476496219-14765037534182564', 1, 1, 'SR', NULL, NULL, NULL),
(10493, '2016-10-15 20:27:10', NULL, NULL, 3769, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 20:27:10', 'admin-1476505036-14765344306718960', 1, 1, 'SR', NULL, NULL, NULL),
(10494, '2016-10-15 13:08:31', NULL, NULL, 3751, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 13:08:31', 'admin-1476505036-14765081114306040', 1, 0, '', NULL, NULL, NULL),
(10495, '2016-10-15 13:08:31', NULL, NULL, 3751, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 13:08:31', 'admin-1476505036-14765081114306040', 1, 1, 'SR', NULL, NULL, NULL),
(10496, '2016-10-15 11:55:53', NULL, NULL, 3747, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 11:55:53', 'admin-1476496219-14765037534182564', 1, 0, '', NULL, NULL, NULL),
(10497, '2016-10-15 11:55:42', NULL, NULL, 3747, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 11:55:42', 'admin-1476496219-1476503742777465', 1, 0, '', NULL, NULL, NULL),
(10498, '2016-10-15 11:09:23', NULL, NULL, 3746, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 11:09:23', 'admin-1476496219-14765009628666838', 1, 1, 'SR', NULL, NULL, NULL),
(10499, '2016-10-15 11:09:23', NULL, NULL, 3746, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 11:09:23', 'admin-1476496219-14765009628666838', 1, 1, 'SR', NULL, NULL, NULL),
(10500, '2016-10-15 09:15:52', NULL, NULL, 3736, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:15:52', 'admin-1476493279-14764941522534746', 1, 0, '', NULL, NULL, NULL),
(10501, '2016-10-15 09:15:52', NULL, NULL, 3736, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:15:52', 'admin-1476493279-14764941522534746', 1, 0, '', NULL, NULL, NULL),
(10502, '2016-10-15 09:36:23', NULL, NULL, 3737, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:36:23', 'admin-1476493279-14764953838179551', 1, 1, 'SR', NULL, NULL, NULL),
(10503, '2016-10-15 12:37:17', NULL, NULL, 3750, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 12:37:17', 'admin-1476505036-14765062376835322', 1, 1, 'SR', NULL, NULL, NULL),
(10504, '2016-10-15 12:37:03', NULL, NULL, 3750, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 12:37:03', 'admin-1476505036-14765062238026948', 1, 1, 'SR', NULL, NULL, NULL),
(10505, '2016-10-15 11:09:23', NULL, NULL, 3746, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 11:09:23', 'admin-1476496219-14765009628666838', 1, 1, 'SR', NULL, NULL, NULL),
(10506, '2016-10-15 09:55:01', NULL, NULL, 3741, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:55:01', 'admin-1476496219-14764965012434016', 1, 0, '', NULL, NULL, NULL),
(10507, '2016-10-15 09:55:01', NULL, NULL, 3741, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:55:01', 'admin-1476496219-14764965012434016', 1, 0, '', NULL, NULL, NULL),
(10508, '2016-10-15 10:01:30', NULL, NULL, 3742, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 10:01:30', 'admin-1476496219-14764968906751474', 1, 1, 'SR', NULL, NULL, NULL),
(10509, '2016-10-15 10:17:12', NULL, NULL, 3743, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 10:17:12', 'admin-1476496219-14764978324978319', 1, 1, 'SR', NULL, NULL, NULL),
(10510, '2016-10-15 10:17:12', NULL, NULL, 3743, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 10:17:12', 'admin-1476496219-14764978324978319', 1, 1, 'SR', NULL, NULL, NULL),
(10511, '2016-10-15 10:17:12', NULL, NULL, 3743, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 10:17:12', 'admin-1476496219-14764978324978319', 1, 1, 'SR', NULL, NULL, NULL),
(10512, '2016-10-15 10:30:41', NULL, NULL, 3744, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 10:30:41', 'admin-1476496219-14764986413887055', 1, 1, 'SR', NULL, NULL, NULL),
(10513, '2016-10-15 10:30:41', NULL, NULL, 3744, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 10:30:41', 'admin-1476496219-14764986413887055', 1, 1, 'SR', NULL, NULL, NULL),
(10514, '2016-10-15 10:30:41', NULL, NULL, 3744, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 10:30:41', 'admin-1476496219-14764986413887055', 1, 1, 'SR', NULL, NULL, NULL),
(10515, '2016-10-15 10:31:27', NULL, NULL, 3745, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 10:31:27', 'admin-1476496219-14764986873578117', 1, 0, '', NULL, NULL, NULL),
(10516, '2016-10-15 11:08:11', NULL, NULL, 3746, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 11:08:11', 'admin-1476496219-14765008909163692', 1, 0, '', NULL, NULL, NULL),
(10517, '2016-10-15 11:08:11', NULL, NULL, 3746, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 11:08:11', 'admin-1476496219-14765008909163692', 1, 0, '', NULL, NULL, NULL),
(10518, '2016-10-15 11:08:11', NULL, NULL, 3746, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 11:08:11', 'admin-1476496219-14765008909163692', 1, 0, '', NULL, NULL, NULL),
(10519, '2016-10-15 09:55:01', NULL, NULL, 3741, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:55:01', 'admin-1476496219-14764965012434016', 1, 1, 'SR', NULL, NULL, NULL),
(10520, '2016-10-15 09:54:12', NULL, NULL, 3741, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:54:12', 'admin-1476496219-14764964518654628', 1, 0, '', NULL, NULL, NULL),
(10521, '2016-10-15 09:54:12', NULL, NULL, 3741, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:54:12', 'admin-1476496219-14764964518654628', 1, 0, '', NULL, NULL, NULL),
(10522, '2016-10-15 09:54:12', NULL, NULL, 3741, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:54:12', 'admin-1476496219-14764964518654628', 1, 0, '', NULL, NULL, NULL),
(10523, '2016-10-15 09:42:44', NULL, NULL, 3738, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:42:44', 'admin-1476493279-14764957642207936', 1, 0, '', NULL, NULL, NULL),
(10524, '2016-10-15 13:13:29', NULL, NULL, 3752, 0, 214, '148', 'Set Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 13:13:29', 'admin-1476505036-14765084092119283', 1, 0, '', NULL, NULL, NULL),
(10525, '2016-10-15 09:49:40', NULL, NULL, 3740, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:49:40', 'admin-1476493279-14764961801036735', 1, 0, '', NULL, NULL, NULL),
(10526, '2016-10-15 09:04:45', NULL, NULL, 3734, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:04:45', 'admin-1476493279-14764934850956590', 1, 0, '', NULL, NULL, NULL),
(10527, '2016-10-15 09:04:45', NULL, NULL, 3734, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:04:45', 'admin-1476493279-14764934850956590', 1, 1, 'SR', NULL, NULL, NULL),
(10528, '2016-10-15 09:04:53', NULL, NULL, 3734, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:04:53', 'admin-1476493279-14764934928927763', 1, 1, 'SR', NULL, NULL, NULL),
(10529, '2016-10-15 09:11:44', NULL, NULL, 3735, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:11:44', 'admin-1476493279-14764939043565646', 1, 0, '', NULL, NULL, NULL),
(10530, '2016-10-15 09:11:44', NULL, NULL, 3735, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:11:44', 'admin-1476493279-14764939043565646', 1, 0, '', NULL, NULL, NULL),
(10531, '2016-10-15 09:49:40', NULL, NULL, 3740, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:49:40', 'admin-1476493279-14764961801036735', 1, 0, '', NULL, NULL, NULL),
(10532, '2016-10-15 09:44:02', NULL, NULL, 3738, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:44:02', 'admin-1476493279-1476495842723781', 1, 1, 'SR', NULL, NULL, NULL),
(10533, '2016-10-15 09:15:52', NULL, NULL, 3736, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:15:52', 'admin-1476493279-14764941522534746', 1, 1, 'SR', NULL, NULL, NULL),
(10534, '2016-10-15 09:49:40', NULL, NULL, 3740, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:49:40', 'admin-1476493279-14764961801036735', 1, 1, 'SR', NULL, NULL, NULL),
(10535, '2016-10-15 09:42:44', NULL, NULL, 3738, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:42:44', 'admin-1476493279-14764957642207936', 1, 0, '', NULL, NULL, NULL),
(10536, '2016-10-15 09:42:44', NULL, NULL, 3738, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:42:44', 'admin-1476493279-14764957642207936', 1, 0, '', NULL, NULL, NULL),
(10537, '2016-10-15 09:42:44', NULL, NULL, 3738, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:42:44', 'admin-1476493279-14764957642207936', 1, 0, '', NULL, NULL, NULL),
(10538, '2016-10-15 09:15:52', NULL, NULL, 3736, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:15:52', 'admin-1476493279-14764941522534746', 1, 1, 'SR', NULL, NULL, NULL),
(10539, '2016-10-15 09:11:54', NULL, NULL, 3735, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:11:54', 'admin-1476493279-14764939147249625', 1, 1, 'SR', NULL, NULL, NULL),
(10540, '2016-10-15 09:04:45', NULL, NULL, 3734, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476505036', 'admin', '2016-10-15 09:04:45', 'admin-1476493279-14764934850956590', 1, 0, '', NULL, NULL, NULL),
(10541, '2016-10-16 14:07:02', NULL, NULL, 3798, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 14:07:02', 'admin-1476592950-14765980220184039', 1, 1, 'SR', NULL, NULL, NULL),
(10542, '2016-10-16 12:30:51', NULL, NULL, 3789, 0, 153, '87', 'Big Breakfast ', 'fried egg', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:30:51', 'admin-1476591076-14765922511444158', 1, 0, '', NULL, NULL, NULL),
(10543, '2016-10-16 12:42:49', NULL, NULL, 3790, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:42:49', 'admin-1476592950-14765929690886542', 1, 1, 'SR', NULL, NULL, NULL),
(10544, '2016-10-16 12:42:49', NULL, NULL, 3790, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:42:49', 'admin-1476592950-14765929690886542', 1, 1, 'SR', NULL, NULL, NULL),
(10545, '2016-10-16 12:42:49', NULL, NULL, 3790, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:42:49', 'admin-1476592950-14765929690886542', 1, 1, 'SR', NULL, NULL, NULL),
(10546, '2016-10-16 12:50:29', NULL, NULL, 3791, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:50:29', 'admin-1476592950-14765934291031847', 1, 1, 'SR', NULL, NULL, NULL),
(10547, '2016-10-16 12:50:47', NULL, NULL, 3791, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:50:47', 'admin-1476592950-14765934475973931', 1, 1, 'SR', NULL, NULL, NULL),
(10548, '2016-10-16 12:52:03', NULL, NULL, 3791, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:52:03', 'admin-1476592950-14765935228738098', 1, 1, 'SR', NULL, NULL, NULL),
(10549, '2016-10-16 12:55:36', NULL, NULL, 3792, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:55:36', 'admin-1476592950-14765937363383188', 1, 1, 'SR', NULL, NULL, NULL),
(10550, '2016-10-16 13:05:49', NULL, NULL, 3793, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 13:05:49', 'admin-1476592950-14765943492115832', 1, 1, 'SR', NULL, NULL, NULL),
(10551, '2016-10-16 13:12:47', NULL, NULL, 3793, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 13:12:47', 'admin-1476592950-14765947671517476', 1, 1, 'SR', NULL, NULL, NULL),
(10552, '2016-10-16 13:55:16', NULL, NULL, 3795, 0, 228, '162', 'Golden Brown', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 13:55:16', 'admin-1476592950-14765973161309983', 1, 0, '', NULL, NULL, NULL),
(10553, '2016-10-16 13:55:16', NULL, NULL, 3795, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 13:55:16', 'admin-1476592950-14765973161309983', 1, 1, 'SR', NULL, NULL, NULL),
(10554, '2016-10-16 13:55:16', NULL, NULL, 3795, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 13:55:16', 'admin-1476592950-14765973161309983', 1, 1, 'SR', NULL, NULL, NULL),
(10555, '2016-10-16 13:56:12', NULL, NULL, 3794, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 13:56:12', 'admin-1476592950-14765973725661527', 1, 0, '', NULL, NULL, NULL),
(10556, '2016-10-16 13:56:12', NULL, NULL, 3794, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 13:56:12', 'admin-1476592950-14765973725661527', 1, 0, '', NULL, NULL, NULL),
(10557, '2016-10-16 13:56:12', NULL, NULL, 3794, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 13:56:12', 'admin-1476592950-14765973725661527', 1, 1, 'SR', NULL, NULL, NULL),
(10558, '2016-10-16 14:00:16', NULL, NULL, 3796, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 14:00:16', 'admin-1476592950-14765976160015687', 1, 1, 'SR', NULL, NULL, NULL),
(10559, '2016-10-16 14:05:19', NULL, NULL, 3797, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 14:05:19', 'admin-1476592950-14765979195362481', 1, 0, '', NULL, NULL, NULL),
(10560, '2016-10-16 14:05:33', NULL, NULL, 3797, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 14:05:33', 'admin-1476592950-1476597933394998', 1, 1, 'SR', NULL, NULL, NULL),
(10561, '2016-10-16 14:07:02', NULL, NULL, 3798, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 14:07:02', 'admin-1476592950-14765980220184039', 1, 1, 'SR', NULL, NULL, NULL),
(10562, '2016-10-16 16:03:43', NULL, NULL, 3803, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 16:03:43', 'admin-1476592950-14766050235362595', 1, 1, 'SR', NULL, NULL, NULL),
(10563, '2016-10-16 16:03:43', NULL, NULL, 3803, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 16:03:43', 'admin-1476592950-14766050235362595', 1, 0, '', NULL, NULL, NULL),
(10564, '2016-10-16 16:04:08', NULL, NULL, 3803, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 16:04:08', 'admin-1476592950-14766050479366655', 1, 1, 'SR', NULL, NULL, NULL),
(10565, '2016-10-16 18:35:19', NULL, NULL, 3806, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 18:35:19', 'admin-1476592950-14766141196029692', 1, 1, 'SR', NULL, NULL, NULL),
(10566, '2016-10-16 11:00:28', NULL, NULL, 3780, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 11:00:28', 'admin-1476585008-14765868287867963', 1, 1, 'SR', NULL, NULL, NULL),
(10567, '2016-10-16 11:17:27', NULL, NULL, 3782, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 11:17:27', 'admin-1476585008-14765878475953249', 1, 1, 'SR', 1, NULL, NULL),
(10568, '2016-10-16 11:31:13', NULL, NULL, 3783, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 11:31:13', 'admin-1476585008-14765886730796217', 1, 0, '', NULL, NULL, NULL),
(10569, '2016-10-16 11:31:13', NULL, NULL, 3783, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 11:31:13', 'admin-1476585008-14765886730796217', 1, 0, '', NULL, NULL, NULL),
(10570, '2016-10-16 11:00:28', NULL, NULL, 3780, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 11:00:28', 'admin-1476585008-14765868287867963', 1, 0, '', NULL, NULL, NULL),
(10571, '2016-10-16 10:25:43', NULL, NULL, 3776, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 10:25:43', 'admin-1476578134-14765847430891994', 1, 1, 'SR', NULL, NULL, NULL),
(10572, '2016-10-16 10:25:43', NULL, NULL, 3776, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 10:25:43', 'admin-1476578134-14765847430891994', 1, 1, 'SR', NULL, NULL, NULL),
(10573, '2016-10-16 10:29:48', NULL, NULL, 3777, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 10:29:48', 'admin-1476578134-14765849885956030', 1, 1, 'SR', NULL, NULL, NULL),
(10574, '2016-10-16 10:29:48', NULL, NULL, 3777, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 10:29:48', 'admin-1476578134-14765849885956030', 1, 1, 'SR', NULL, NULL, NULL),
(10575, '2016-10-16 10:29:48', NULL, NULL, 3777, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 10:29:48', 'admin-1476578134-14765849885956030', 1, 0, '', NULL, NULL, NULL),
(10576, '2016-10-16 10:29:48', NULL, NULL, 3777, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 10:29:48', 'admin-1476578134-14765849885956030', 1, 0, '', NULL, NULL, NULL),
(10577, '2016-10-16 10:30:43', NULL, NULL, 3778, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 10:30:43', 'admin-1476585008-14765850429475317', 1, 0, '', NULL, NULL, NULL),
(10578, '2016-10-16 10:30:50', NULL, NULL, 3778, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 10:30:50', 'admin-1476585008-14765850501126774', 1, 1, 'SR', NULL, NULL, NULL),
(10579, '2016-10-16 10:31:51', NULL, NULL, 3779, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 10:31:51', 'admin-1476585008-14765851110475592', 1, 1, 'SR', NULL, NULL, NULL),
(10580, '2016-10-16 16:56:17', NULL, NULL, 3802, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 16:56:17', 'admin-1476592950-1476608177771263', 1, 0, '', NULL, NULL, NULL),
(10581, '2016-10-16 18:14:32', NULL, NULL, 3805, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 18:14:32', 'admin-1476592950-14766128725386978', 1, 1, 'SR', NULL, NULL, NULL),
(10582, '2016-10-16 16:56:17', NULL, NULL, 3802, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 16:56:17', 'admin-1476592950-1476608177771263', 1, 0, '', NULL, NULL, NULL),
(10583, '2016-10-16 15:13:02', NULL, NULL, 3801, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 15:13:02', 'admin-1476592950-14766019818832787', 1, 1, 'SR', NULL, NULL, NULL),
(10584, '2016-10-16 15:13:45', NULL, NULL, 3801, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 15:13:45', 'admin-1476592950-14766020249237623', 1, 0, '', NULL, NULL, NULL),
(10585, '2016-10-16 15:14:27', NULL, NULL, 3801, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 15:14:27', 'admin-1476592950-14766020676447327', 1, 1, 'SR', NULL, NULL, NULL),
(10586, '2016-10-16 15:14:27', NULL, NULL, 3801, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 15:14:27', 'admin-1476592950-14766020676447327', 1, 1, 'SR', NULL, NULL, NULL),
(10587, '2016-10-16 15:14:27', NULL, NULL, 3801, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 15:14:27', 'admin-1476592950-14766020676447327', 1, 1, 'SR', NULL, NULL, NULL),
(10588, '2016-10-16 16:25:47', NULL, NULL, 3804, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 16:25:47', 'admin-1476592950-14766063468529495', 1, 0, '', NULL, NULL, NULL),
(10589, '2016-10-16 16:15:41', NULL, NULL, 3802, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 16:15:41', 'admin-1476592950-14766057412028524', 1, 0, '', NULL, NULL, NULL),
(10590, '2016-10-16 16:25:47', NULL, NULL, 3804, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 16:25:47', 'admin-1476592950-14766063468529495', 1, 0, '', NULL, NULL, NULL),
(10591, '2016-10-16 15:44:59', NULL, NULL, 3802, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 15:44:59', 'admin-1476592950-1476603899721474', 1, 0, '', NULL, NULL, NULL),
(10592, '2016-10-16 15:44:59', NULL, NULL, 3802, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 15:44:59', 'admin-1476592950-1476603899721474', 1, 0, '', NULL, NULL, NULL),
(10593, '2016-10-16 15:44:59', NULL, NULL, 3802, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 15:44:59', 'admin-1476592950-1476603899721474', 1, 1, 'SR', NULL, NULL, NULL),
(10594, '2016-10-16 15:44:59', NULL, NULL, 3802, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 15:44:59', 'admin-1476592950-1476603899721474', 1, 1, 'SR', NULL, NULL, NULL),
(10595, '2016-10-16 14:26:58', NULL, NULL, 3800, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 14:26:58', 'admin-1476592950-14765992187216047', 1, 1, 'SR', NULL, NULL, NULL),
(10596, '2016-10-16 14:26:58', NULL, NULL, 3800, 0, 228, '162', 'Golden Brown', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 14:26:58', 'admin-1476592950-14765992187216047', 1, 0, '', NULL, NULL, NULL),
(10597, '2016-10-16 14:26:58', NULL, NULL, 3800, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 14:26:58', 'admin-1476592950-14765992187216047', 1, 1, 'SR', NULL, NULL, NULL),
(10598, '2016-10-16 14:27:25', NULL, NULL, 3800, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 14:27:25', 'admin-1476592950-14765992456124353', 1, 0, '', NULL, NULL, NULL),
(10599, '2016-10-16 14:47:02', NULL, NULL, 3796, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 14:47:02', 'admin-1476592950-14766004218559599', 1, 1, 'SR', NULL, NULL, NULL),
(10600, '2016-10-16 14:16:08', NULL, NULL, 3799, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 14:16:08', 'admin-1476592950-14765985684921917', 1, 1, 'SR', NULL, NULL, NULL),
(10601, '2016-10-16 12:24:50', NULL, NULL, 3787, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:24:50', 'admin-1476591076-14765918908054924', 1, 0, '', NULL, NULL, NULL),
(10602, '2016-10-16 12:27:49', NULL, NULL, 3788, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:27:49', 'admin-1476591076-14765920692356648', 1, 0, '', NULL, NULL, NULL),
(10603, '2016-10-16 12:27:49', NULL, NULL, 3788, 0, 156, '90', 'Cheese Omelet', 'Omellet without Cheese', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:27:49', 'admin-1476591076-14765920692356648', 1, 0, '', NULL, NULL, NULL),
(10604, '2016-10-16 12:27:49', NULL, NULL, 3788, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:27:49', 'admin-1476591076-14765920692356648', 1, 1, 'SR', NULL, NULL, NULL),
(10605, '2016-10-16 12:27:49', NULL, NULL, 3788, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:27:49', 'admin-1476591076-14765920692356648', 1, 1, 'SR', NULL, NULL, NULL),
(10606, '2016-10-16 12:30:10', NULL, NULL, 3789, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:30:10', 'admin-1476591076-14765922104826184', 1, 0, '', NULL, NULL, NULL),
(10607, '2016-10-16 12:30:10', NULL, NULL, 3789, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:30:10', 'admin-1476591076-14765922104826184', 1, 0, '', NULL, NULL, NULL),
(10608, '2016-10-16 12:24:50', NULL, NULL, 3787, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:24:50', 'admin-1476591076-14765918908054924', 1, 1, 'SR', NULL, NULL, NULL),
(10609, '2016-10-16 12:30:10', NULL, NULL, 3789, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:30:10', 'admin-1476591076-14765922104826184', 1, 1, 'SR', NULL, NULL, NULL),
(10610, '2016-10-16 12:13:47', NULL, NULL, 3786, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:13:47', 'admin-1476591076-14765912275711679', 1, 1, 'SR', NULL, NULL, NULL),
(10611, '2016-10-16 12:30:10', NULL, NULL, 3789, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:30:10', 'admin-1476591076-14765922104826184', 1, 1, 'SR', NULL, NULL, NULL),
(10612, '2016-10-16 12:30:10', NULL, NULL, 3789, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:30:10', 'admin-1476591076-14765922104826184', 1, 0, '', NULL, NULL, NULL),
(10613, '2016-10-16 09:13:21', NULL, NULL, 3772, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 09:13:21', 'admin-1476578134-14765804010031347', 1, 0, '', NULL, NULL, NULL),
(10614, '2016-10-16 09:22:04', NULL, NULL, 3773, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 09:22:04', 'admin-1476578134-14765809243922561', 1, 0, '', NULL, NULL, NULL),
(10615, '2016-10-16 09:22:04', NULL, NULL, 3773, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 09:22:04', 'admin-1476578134-14765809243922561', 1, 0, '', NULL, NULL, NULL),
(10616, '2016-10-16 09:22:04', NULL, NULL, 3773, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 09:22:04', 'admin-1476578134-14765809243922561', 1, 0, '', NULL, NULL, NULL),
(10617, '2016-10-16 12:24:50', NULL, NULL, 3787, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:24:50', 'admin-1476591076-14765918908054924', 1, 0, '', NULL, NULL, NULL),
(10618, '2016-10-16 12:07:35', NULL, NULL, 3785, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:07:35', 'admin-1476585008-14765908552493310', 1, 0, '', NULL, NULL, NULL),
(10619, '2016-10-16 12:07:35', NULL, NULL, 3785, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:07:35', 'admin-1476585008-14765908552493310', 1, 0, '', NULL, NULL, NULL),
(10620, '2016-10-16 12:07:35', NULL, NULL, 3785, 0, 85, '85', 'Set Sauted Mushroom Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:07:35', 'admin-1476585008-14765908552493310', 1, 1, 'SR', NULL, NULL, NULL),
(10621, '2016-10-16 12:08:28', NULL, NULL, 3785, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:08:28', 'admin-1476585008-14765909081872315', 1, 1, 'SR', NULL, NULL, NULL),
(10622, '2016-10-16 12:08:28', NULL, NULL, 3785, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:08:28', 'admin-1476585008-14765909081872315', 1, 1, 'SR', NULL, NULL, NULL),
(10623, '2016-10-16 12:08:28', NULL, NULL, 3785, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:08:28', 'admin-1476585008-14765909081872315', 1, 1, 'SR', NULL, NULL, NULL),
(10624, '2016-10-16 12:08:42', NULL, NULL, 3785, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:08:42', 'admin-1476585008-14765909226483841', 1, 0, '', NULL, NULL, NULL),
(10625, '2016-10-16 12:10:37', NULL, NULL, 3786, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:10:37', 'admin-1476585008-14765910376737568', 1, 1, 'SR', NULL, NULL, NULL),
(10626, '2016-10-16 12:10:37', NULL, NULL, 3786, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:10:37', 'admin-1476585008-14765910376737568', 1, 0, '', NULL, NULL, NULL),
(10627, '2016-10-16 12:10:37', NULL, NULL, 3786, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:10:37', 'admin-1476585008-14765910376737568', 1, 0, '', NULL, NULL, NULL),
(10628, '2016-10-16 12:10:37', NULL, NULL, 3786, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:10:37', 'admin-1476585008-14765910376737568', 1, 0, '', NULL, NULL, NULL),
(10629, '2016-10-16 12:13:47', NULL, NULL, 3786, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:13:47', 'admin-1476591076-14765912275711679', 1, 1, 'SR', NULL, NULL, NULL),
(10630, '2016-10-16 12:13:47', NULL, NULL, 3786, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:13:47', 'admin-1476591076-14765912275711679', 1, 1, 'SR', NULL, NULL, NULL),
(10631, '2016-10-16 11:43:30', NULL, NULL, 3784, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 11:43:30', 'admin-1476585008-14765894098761626', 1, 1, 'SR', NULL, NULL, NULL),
(10632, '2016-10-16 11:43:30', NULL, NULL, 3784, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 11:43:30', 'admin-1476585008-14765894098761626', 1, 0, '', NULL, NULL, NULL),
(10633, '2016-10-16 11:31:13', NULL, NULL, 3783, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 11:31:13', 'admin-1476585008-14765886730796217', 1, 0, '', NULL, NULL, NULL),
(10634, '2016-10-16 11:00:28', NULL, NULL, 3780, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 11:00:28', 'admin-1476585008-14765868287867963', 1, 0, '', NULL, NULL, NULL),
(10635, '2016-10-16 09:22:04', NULL, NULL, 3773, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 09:22:04', 'admin-1476578134-14765809243922561', 1, 0, '', NULL, NULL, NULL),
(10636, '2016-10-16 11:17:06', NULL, NULL, 3781, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 11:17:06', 'admin-1476585008-14765878264334622', 1, 1, 'SR', NULL, NULL, NULL),
(10637, '2016-10-16 09:22:23', NULL, NULL, 3773, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 09:22:23', 'admin-1476578134-14765809430525850', 1, 1, 'SR', NULL, NULL, NULL),
(10638, '2016-10-16 09:22:23', NULL, NULL, 3773, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 09:22:23', 'admin-1476578134-14765809430525850', 1, 1, 'SR', NULL, NULL, NULL),
(10639, '2016-10-16 09:22:23', NULL, NULL, 3773, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 09:22:23', 'admin-1476578134-14765809430525850', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(10640, '2016-10-16 09:34:12', NULL, NULL, 3774, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 09:34:12', 'admin-1476578134-14765816524251032', 1, 0, '', NULL, NULL, NULL),
(10641, '2016-10-16 09:56:06', NULL, NULL, 3774, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 09:56:06', 'admin-1476578134-14765829667585734', 1, 0, '', NULL, NULL, NULL),
(10642, '2016-10-16 10:01:14', NULL, NULL, 3775, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 10:01:14', 'admin-1476578134-14765832739424147', 1, 0, '', NULL, NULL, NULL),
(10643, '2016-10-16 10:25:43', NULL, NULL, 3776, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 10:25:43', 'admin-1476578134-14765847430891994', 1, 0, '', NULL, NULL, NULL),
(10644, '2016-10-16 12:30:10', NULL, NULL, 3789, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:30:10', 'admin-1476591076-14765922104826184', 1, 1, 'SR', NULL, NULL, NULL),
(10645, '2016-10-16 09:22:23', NULL, NULL, 3773, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 09:22:23', 'admin-1476578134-14765809430525850', 1, 1, 'SR', NULL, NULL, NULL),
(10646, '2016-10-16 09:12:05', NULL, NULL, 3772, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 09:12:05', 'admin-1476578134-14765803248975458', 1, 1, 'SR', NULL, NULL, NULL),
(10647, '2016-10-16 09:12:05', NULL, NULL, 3772, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 09:12:05', 'admin-1476578134-14765803248975458', 1, 1, 'SR', NULL, NULL, NULL),
(10648, '2016-10-16 10:25:43', NULL, NULL, 3776, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 10:25:43', 'admin-1476578134-14765847430891994', 1, 0, '', NULL, NULL, NULL),
(10649, '2016-10-16 09:22:23', NULL, NULL, 3773, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 09:22:23', 'admin-1476578134-14765809430525850', 1, 1, 'SR', NULL, NULL, NULL),
(10650, '2016-10-16 09:22:23', NULL, NULL, 3773, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 09:22:23', 'admin-1476578134-14765809430525850', 1, 1, 'SR', NULL, NULL, NULL),
(10651, '2016-10-16 12:30:10', NULL, NULL, 3789, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 12:30:10', 'admin-1476591076-14765922104826184', 1, 0, '', NULL, NULL, NULL),
(10652, '2016-10-16 09:11:57', NULL, NULL, 3772, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476592950', 'admin', '2016-10-16 09:11:57', 'admin-1476578134-14765803173174249', 1, 0, '', NULL, NULL, NULL),
(10653, '2016-10-17 12:40:50', NULL, NULL, 3811, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 12:40:50', 'admin-1476666131-1476679250289274', 1, 1, 'SR', NULL, NULL, NULL),
(10654, '2016-10-17 13:03:19', NULL, NULL, 3812, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 13:03:19', 'admin-1476666131-14766805992482483', 1, 1, 'SR', NULL, NULL, NULL),
(10655, '2016-10-17 13:04:11', NULL, NULL, 3812, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 13:04:11', 'admin-1476680633-14766806509231318', 1, 1, 'SR', NULL, NULL, NULL),
(10656, '2016-10-17 13:09:52', NULL, NULL, 3813, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 13:09:52', 'admin-1476680633-14766809919056676', 1, 1, 'SR', NULL, NULL, NULL),
(10657, '2016-10-17 13:10:47', NULL, NULL, 3814, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 13:10:47', 'admin-1476680633-14766810474936439', 1, 1, 'SR', NULL, NULL, NULL),
(10658, '2016-10-17 13:10:47', NULL, NULL, 3814, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 13:10:47', 'admin-1476680633-14766810474936439', 1, 1, 'SR', NULL, NULL, NULL),
(10659, '2016-10-17 13:19:01', NULL, NULL, 3815, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 13:19:01', 'admin-1476680633-14766815414979723', 1, 1, 'SR', NULL, NULL, NULL),
(10660, '2016-10-17 13:19:01', NULL, NULL, 3815, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 13:19:01', 'admin-1476680633-14766815414979723', 1, 1, 'SR', NULL, NULL, NULL),
(10661, '2016-10-17 13:19:20', NULL, NULL, 3815, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 13:19:20', 'admin-1476680633-1476681560346397', 1, 1, 'SR', NULL, NULL, NULL),
(10662, '2016-10-17 13:25:36', NULL, NULL, 3812, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 13:25:36', 'admin-1476680633-1476681935920285', 1, 0, '', NULL, NULL, NULL),
(10663, '2016-10-17 13:25:36', NULL, NULL, 3812, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 13:25:36', 'admin-1476680633-1476681935920285', 1, 0, '', NULL, NULL, NULL),
(10664, '2016-10-17 13:43:29', NULL, NULL, 3816, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 13:43:29', 'admin-1476680633-14766830090347356', 1, 1, 'SR', NULL, NULL, NULL),
(10665, '2016-10-17 13:43:29', NULL, NULL, 3816, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 13:43:29', 'admin-1476680633-14766830090347356', 1, 1, 'SR', NULL, NULL, NULL),
(10666, '2016-10-17 13:44:29', NULL, NULL, 3816, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 13:44:29', 'admin-1476680633-1476683069768524', 1, 0, '', NULL, NULL, NULL),
(10667, '2016-10-17 13:48:58', NULL, NULL, 3817, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 13:48:58', 'admin-1476680633-14766833384561837', 1, 0, '', NULL, NULL, NULL),
(10668, '2016-10-17 13:48:58', NULL, NULL, 3817, 0, 227, '161', 'Cranberry Velvet', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 13:48:58', 'admin-1476680633-14766833384561837', 1, 0, '', NULL, NULL, NULL),
(10669, '2016-10-17 13:53:34', NULL, NULL, 3818, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 13:53:34', 'admin-1476680633-14766836144649151', 1, 1, 'SR', NULL, NULL, NULL),
(10670, '2016-10-17 13:54:06', NULL, NULL, 3818, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 13:54:06', 'admin-1476680633-14766836467446249', 1, 1, 'SR', NULL, NULL, NULL),
(10671, '2016-10-17 13:56:05', NULL, NULL, 3818, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 13:56:05', 'admin-1476680633-14766837652714822', 1, 0, '', NULL, NULL, NULL),
(10672, '2016-10-17 13:56:05', NULL, NULL, 3818, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 13:56:05', 'admin-1476680633-14766837652714822', 1, 0, '', NULL, NULL, NULL),
(10673, '2016-10-17 14:45:28', NULL, NULL, 3820, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 14:45:28', 'admin-1476680633-14766867285519731', 1, 1, 'SR', NULL, NULL, NULL),
(10674, '2016-10-17 14:45:43', NULL, NULL, 3820, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 14:45:43', 'admin-1476680633-14766867434912920', 1, 1, 'SR', NULL, NULL, NULL),
(10675, '2016-10-17 14:45:43', NULL, NULL, 3820, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 14:45:43', 'admin-1476680633-14766867434912920', 1, 1, 'SR', NULL, NULL, NULL),
(10676, '2016-10-17 12:35:48', NULL, NULL, 3810, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 12:35:48', 'admin-1476666131-1476678948535168', 1, 1, 'SR', NULL, NULL, NULL),
(10677, '2016-10-17 12:40:24', NULL, NULL, 3811, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 12:40:24', 'admin-1476666131-14766792242881356', 1, 0, '', NULL, NULL, NULL),
(10678, '2016-10-17 12:40:24', NULL, NULL, 3811, 0, 222, '156', 'Seasoned Chicken Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 12:40:24', 'admin-1476666131-14766792242881356', 1, 0, '', NULL, NULL, NULL),
(10679, '2016-10-17 12:40:24', NULL, NULL, 3811, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 12:40:24', 'admin-1476666131-14766792242881356', 1, 0, '', NULL, NULL, NULL),
(10680, '2016-10-17 12:40:24', NULL, NULL, 3811, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 12:40:24', 'admin-1476666131-14766792242881356', 1, 1, 'SR', NULL, NULL, NULL),
(10681, '2016-10-17 14:45:43', NULL, NULL, 3820, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 14:45:43', 'admin-1476680633-14766867434912920', 1, 1, 'SR', NULL, NULL, NULL),
(10682, '2016-10-17 19:26:53', NULL, NULL, 3828, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 19:26:53', 'admin-1476680633-14767036136141171', 1, 0, '', NULL, NULL, NULL),
(10683, '2016-10-17 19:28:59', NULL, NULL, 3828, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1476704001', 'admin', '2016-10-17 19:28:59', 'admin-1476680633-14767037393063471', 1, 0, '', NULL, NULL, NULL),
(10684, '2016-10-17 19:40:02', NULL, NULL, 3828, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 19:40:02', 'admin-1476704001-1476704401822397', 1, 0, '', NULL, NULL, NULL),
(10685, '2016-10-17 19:52:15', NULL, NULL, 3829, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 19:52:15', 'admin-1476704001-14767051357018588', 1, 0, '', NULL, NULL, NULL),
(10686, '2016-10-17 19:52:40', NULL, NULL, 3829, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 19:52:40', 'admin-1476704001-14767051599451627', 1, 1, 'SR', NULL, NULL, NULL),
(10687, '2016-10-17 19:26:53', NULL, NULL, 3828, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 19:26:53', 'admin-1476680633-14767036136141171', 1, 1, 'SR', NULL, NULL, NULL),
(10688, '2016-10-17 19:26:53', NULL, NULL, 3828, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 19:26:53', 'admin-1476680633-14767036136141171', 1, 1, 'SR', NULL, NULL, NULL),
(10689, '2016-10-17 10:20:23', NULL, NULL, 3807, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 10:20:23', 'admin-1476666131-14766708230275666', 1, 0, '', NULL, NULL, NULL),
(10690, '2016-10-17 16:31:49', NULL, NULL, 3822, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 16:31:49', 'admin-1476680633-14766931093585645', 1, 1, 'SR', NULL, NULL, NULL),
(10691, '2016-10-17 17:32:20', NULL, NULL, 3824, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 17:32:20', 'admin-1476680633-14766967399461622', 1, 1, 'SR', NULL, NULL, NULL),
(10692, '2016-10-17 17:32:36', NULL, NULL, 3824, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 17:32:36', 'admin-1476680633-14766967558165953', 1, 1, 'SR', NULL, NULL, NULL),
(10693, '2016-10-17 17:32:36', NULL, NULL, 3824, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 17:32:36', 'admin-1476680633-14766967558165953', 1, 1, 'SR', NULL, NULL, NULL),
(10694, '2016-10-17 17:40:20', NULL, NULL, 3825, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 17:40:20', 'admin-1476680633-1476697220159567', 1, 0, '', NULL, NULL, NULL),
(10695, '2016-10-17 17:40:20', NULL, NULL, 3825, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 17:40:20', 'admin-1476680633-1476697220159567', 1, 1, 'SR', NULL, NULL, NULL),
(10696, '2016-10-17 17:44:48', NULL, NULL, 3825, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 17:44:48', 'admin-1476680633-14766974881619845', 1, 1, 'SR', NULL, NULL, NULL),
(10697, '2016-10-17 17:59:25', NULL, NULL, 3826, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 17:59:25', 'admin-1476680633-1476698365074599', 1, 1, 'SR', NULL, NULL, NULL),
(10698, '2016-10-17 17:59:25', NULL, NULL, 3826, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 17:59:25', 'admin-1476680633-1476698365074599', 1, 0, '', NULL, NULL, NULL),
(10699, '2016-10-17 18:12:11', NULL, NULL, 3827, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 18:12:11', 'admin-1476680633-14766991313866047', 1, 0, '', NULL, NULL, NULL),
(10700, '2016-10-17 18:12:11', NULL, NULL, 3827, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 18:12:11', 'admin-1476680633-14766991313866047', 1, 1, 'SR', NULL, NULL, NULL),
(10701, '2016-10-17 18:12:11', NULL, NULL, 3827, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 18:12:11', 'admin-1476680633-14766991313866047', 1, 0, '', NULL, NULL, NULL),
(10702, '2016-10-17 18:12:11', NULL, NULL, 3827, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 18:12:11', 'admin-1476680633-14766991313866047', 1, 1, 'SR', NULL, NULL, NULL),
(10703, '2016-10-17 16:26:31', NULL, NULL, 3823, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 2, 15.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 16:26:31', 'admin-1476680633-14766927914342348', 1, 1, 'SR', NULL, NULL, NULL),
(10704, '2016-10-17 16:07:44', NULL, NULL, 3822, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 16:07:44', 'admin-1476680633-147669166456615', 1, 1, 'SR', NULL, NULL, NULL),
(10705, '2016-10-17 16:09:45', NULL, NULL, 3822, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 16:09:45', 'admin-1476680633-14766917851527991', 1, 0, '', NULL, NULL, NULL),
(10706, '2016-10-17 16:07:44', NULL, NULL, 3822, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 16:07:44', 'admin-1476680633-147669166456615', 1, 1, 'SR', NULL, NULL, NULL),
(10707, '2016-10-17 15:05:11', NULL, NULL, 3821, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 15:05:11', 'admin-1476680633-14766879115615948', 1, 1, 'SR', NULL, NULL, NULL),
(10708, '2016-10-17 14:45:28', NULL, NULL, 3820, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 14:45:28', 'admin-1476680633-14766867285519731', 1, 0, '', NULL, NULL, NULL),
(10709, '2016-10-17 14:45:28', NULL, NULL, 3820, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 14:45:28', 'admin-1476680633-14766867285519731', 1, 0, '', NULL, NULL, NULL),
(10710, '2016-10-17 14:37:23', NULL, NULL, 3819, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 14:37:23', 'admin-1476680633-14766862434761018', 1, 1, 'SR', NULL, NULL, NULL),
(10711, '2016-10-17 14:37:23', NULL, NULL, 3819, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 14:37:23', 'admin-1476680633-14766862434761018', 1, 1, 'SR', NULL, NULL, NULL),
(10712, '2016-10-17 14:37:23', NULL, NULL, 3819, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 14:37:23', 'admin-1476680633-14766862434761018', 1, 1, 'SR', NULL, NULL, NULL),
(10713, '2016-10-17 14:37:06', NULL, NULL, 3819, 0, 228, '162', 'Golden Brown', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 14:37:06', 'admin-1476680633-14766862257753459', 1, 0, '', NULL, NULL, NULL),
(10714, '2016-10-17 14:37:05', NULL, NULL, 3819, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 14:37:06', 'admin-1476680633-14766862257753459', 1, 0, '', NULL, NULL, NULL),
(10715, '2016-10-17 12:35:48', NULL, NULL, 3810, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 12:35:48', 'admin-1476666131-1476678948535168', 1, 0, '', NULL, NULL, NULL),
(10716, '2016-10-17 12:36:26', NULL, NULL, 3810, 0, 85, '85', 'Set Sauted Mushroom Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 12:36:26', 'admin-1476666131-14766789863531041', 1, 1, 'SR', NULL, NULL, NULL),
(10717, '2016-10-17 12:40:24', NULL, NULL, 3811, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 12:40:24', 'admin-1476666131-14766792242881356', 1, 0, '', NULL, NULL, NULL),
(10718, '2016-10-17 12:40:50', NULL, NULL, 3811, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 12:40:50', 'admin-1476666131-1476679250289274', 1, 1, 'SR', NULL, NULL, NULL),
(10719, '2016-10-17 12:14:26', NULL, NULL, 3809, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 12:14:26', 'admin-1476666131-14766776666224851', 1, 1, 'SR', NULL, NULL, NULL),
(10720, '2016-10-17 10:53:45', NULL, NULL, 3808, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 10:53:45', 'admin-1476666131-14766728249277614', 1, 0, '', NULL, NULL, NULL),
(10721, '2016-10-17 10:53:45', NULL, NULL, 3808, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 10:53:45', 'admin-1476666131-14766728249277614', 1, 0, '', NULL, NULL, NULL),
(10722, '2016-10-17 10:20:23', NULL, NULL, 3807, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476704001', 'admin', '2016-10-17 10:20:23', 'admin-1476666131-14766708230275666', 1, 0, '', NULL, NULL, NULL),
(10723, '2016-10-19 12:21:48', NULL, NULL, 3832, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 12:21:48', 'admin-1476843247-14768509087779567', 1, 1, 'SR', NULL, NULL, NULL),
(10724, '2016-10-19 12:47:35', NULL, NULL, 3833, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 12:47:35', 'admin-1476843247-14768524557405053', 1, 1, 'SR', NULL, NULL, NULL),
(10725, '2016-10-19 12:47:35', NULL, NULL, 3833, 0, 181, '116', 'Open Food ', 'Curry chicken', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 12:47:35', 'admin-1476843247-14768524557405053', 1, 0, '', NULL, NULL, NULL),
(10726, '2016-10-19 12:47:43', NULL, NULL, 3833, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 12:47:43', 'admin-1476843247-14768524632448784', 1, 1, 'SR', NULL, NULL, NULL),
(10727, '2016-10-19 12:47:43', NULL, NULL, 3833, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 12:47:43', 'admin-1476843247-14768524632448784', 1, 1, 'SR', NULL, NULL, NULL),
(10728, '2016-10-19 12:53:48', NULL, NULL, 3834, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 12:53:48', 'admin-1476843247-14768528288051865', 1, 1, 'SR', NULL, NULL, NULL),
(10729, '2016-10-19 12:58:57', NULL, NULL, 3835, 0, 181, '116', 'Open Food ', 'curry chicken', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 12:58:57', 'admin-1476843247-1476853137739467', 1, 0, '', NULL, NULL, NULL),
(10730, '2016-10-19 12:59:06', NULL, NULL, 3835, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 12:59:06', 'admin-1476843247-14768531461432469', 1, 1, 'SR', NULL, NULL, NULL),
(10731, '2016-10-19 12:59:17', NULL, NULL, 3836, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 12:59:17', 'admin-1476843247-14768531574736354', 1, 1, 'SR', NULL, NULL, NULL),
(10732, '2016-10-19 12:59:17', NULL, NULL, 3836, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 12:59:17', 'admin-1476843247-14768531574736354', 1, 1, 'SR', NULL, NULL, NULL),
(10733, '2016-10-19 13:08:14', NULL, NULL, 3837, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 13:08:14', 'admin-1476843247-14768536947245075', 1, 0, '', NULL, NULL, NULL),
(10734, '2016-10-19 13:08:14', NULL, NULL, 3837, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 13:08:14', 'admin-1476843247-14768536947245075', 1, 0, '', NULL, NULL, NULL),
(10735, '2016-10-19 13:08:40', NULL, NULL, 3837, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 13:08:40', 'admin-1476853703-14768537204166293', 1, 1, 'SR', NULL, NULL, NULL),
(10736, '2016-10-19 13:08:40', NULL, NULL, 3837, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 13:08:40', 'admin-1476853703-14768537204166293', 1, 1, 'SR', NULL, NULL, NULL),
(10737, '2016-10-19 13:08:40', NULL, NULL, 3837, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 13:08:40', 'admin-1476853703-14768537204166293', 1, 0, '', NULL, NULL, NULL),
(10738, '2016-10-19 13:08:55', NULL, NULL, 3833, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 13:08:55', 'admin-1476853703-14768537350458814', 1, 1, 'SR', NULL, NULL, NULL),
(10739, '2016-10-19 13:47:43', NULL, NULL, 3833, 0, 228, '162', 'Golden Brown', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 13:47:43', 'admin-1476853703-14768560635839592', 1, 0, '', NULL, NULL, NULL),
(10740, '2016-10-19 13:11:11', NULL, NULL, 3835, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 13:11:11', 'admin-1476853703-14768538715108047', 1, 0, '', NULL, NULL, NULL),
(10741, '2016-10-19 13:11:11', NULL, NULL, 3835, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 13:11:11', 'admin-1476853703-14768538715108047', 1, 0, '', NULL, NULL, NULL),
(10742, '2016-10-19 13:12:13', NULL, NULL, 3835, 0, 217, '151', 'Spicy Lemony Wings', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 13:12:13', 'admin-1476853703-14768539336812712', 1, 0, '', NULL, NULL, NULL),
(10743, '2016-10-19 14:37:51', NULL, NULL, 3841, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 14:37:51', 'admin-1476853703-1476859071718562', 1, 1, 'SR', NULL, NULL, NULL),
(10744, '2016-10-19 14:37:51', NULL, NULL, 3841, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 14:37:51', 'admin-1476853703-1476859071718562', 1, 0, '', NULL, NULL, NULL),
(10745, '2016-10-19 14:37:51', NULL, NULL, 3841, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 14:37:51', 'admin-1476853703-1476859071718562', 1, 1, 'SR', NULL, NULL, NULL),
(10746, '2016-10-19 15:05:25', NULL, NULL, 3842, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 15:05:25', 'admin-1476860642-1476860725136204', 1, 1, 'SR', 1, NULL, NULL),
(10747, '2016-10-19 15:27:46', NULL, NULL, 3843, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 15:27:46', 'admin-1476860642-14768620660493738', 1, 1, 'SR', NULL, NULL, NULL),
(10748, '2016-10-19 15:28:15', NULL, NULL, 3843, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 15:28:15', 'admin-1476860642-14768620950893892', 1, 0, '', NULL, NULL, NULL),
(10749, '2016-10-19 15:38:25', NULL, NULL, 3840, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 15:38:25', 'admin-1476860642-14768627056122082', 1, 0, '', NULL, NULL, '10.0'),
(10750, '2016-10-19 16:38:53', NULL, NULL, 3844, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 16:38:53', 'admin-1476860642-14768663336631696', 1, 1, 'SR', NULL, NULL, NULL),
(10751, '2016-10-19 18:23:10', NULL, NULL, 3845, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 18:23:10', 'admin-1476860642-14768725903084057', 1, 1, 'SR', NULL, NULL, NULL),
(10752, '2016-10-19 18:23:10', NULL, NULL, 3845, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 18:23:10', 'admin-1476860642-14768725903084057', 1, 1, 'SR', NULL, NULL, NULL),
(10753, '2016-10-19 18:31:22', NULL, NULL, 3846, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 18:31:22', 'admin-1476860642-1476873082056844', 1, 1, 'SR', NULL, NULL, '10.0'),
(10754, '2016-10-19 18:31:22', NULL, NULL, 3846, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 18:31:22', 'admin-1476860642-1476873082056844', 1, 1, 'SR', NULL, NULL, '10.0'),
(10755, '2016-10-19 18:31:22', NULL, NULL, 3846, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 18:31:22', 'admin-1476860642-1476873082056844', 1, 1, 'SR', NULL, NULL, '10.0'),
(10756, '2016-10-19 18:31:22', NULL, NULL, 3846, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 18:31:22', 'admin-1476860642-1476873082056844', 1, 1, 'SR', NULL, NULL, '10.0'),
(10757, '2016-10-19 18:31:22', NULL, NULL, 3846, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 18:31:22', 'admin-1476860642-1476873082056844', 1, 1, 'SR', NULL, NULL, '10.0'),
(10758, '2016-10-19 18:31:22', NULL, NULL, 3846, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 18:31:22', 'admin-1476860642-1476873082056844', 1, 0, '', NULL, NULL, '10.0'),
(10759, '2016-10-19 18:54:35', NULL, NULL, 3847, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 18:54:35', 'admin-1476860642-14768744756467690', 1, 1, 'SR', NULL, NULL, NULL),
(10760, '2016-10-19 18:55:33', NULL, NULL, 3848, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 18:55:33', 'admin-1476860642-14768745334036657', 1, 0, '', NULL, NULL, '50.0'),
(10761, '2016-10-19 18:31:22', NULL, NULL, 3846, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 18:31:22', 'admin-1476860642-1476873082056844', 1, 0, '', NULL, NULL, '10.0'),
(10762, '2016-10-19 18:31:22', NULL, NULL, 3846, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 18:31:22', 'admin-1476860642-1476873082056844', 1, 1, 'SR', NULL, NULL, '10.0'),
(10763, '2016-10-19 18:31:22', NULL, NULL, 3846, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 18:31:22', 'admin-1476860642-1476873082056844', 1, 1, 'SR', NULL, NULL, '10.0'),
(10764, '2016-10-19 18:31:22', NULL, NULL, 3846, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 18:31:22', 'admin-1476860642-1476873082056844', 1, 1, 'SR', NULL, NULL, '10.0'),
(10765, '2016-10-19 14:35:02', NULL, NULL, 3840, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 14:35:02', 'admin-1476853703-14768589024894129', 1, 1, 'SR', NULL, NULL, '10.0'),
(10766, '2016-10-19 14:35:02', NULL, NULL, 3840, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 14:35:02', 'admin-1476853703-14768589024894129', 1, 0, '', NULL, NULL, '10.0'),
(10767, '2016-10-19 14:35:02', NULL, NULL, 3840, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 14:35:02', 'admin-1476853703-14768589024894129', 1, 1, 'SR', NULL, NULL, '10.0'),
(10768, '2016-10-19 14:34:50', NULL, NULL, 3840, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 14:34:50', 'admin-1476853703-14768588899893120', 1, 0, '', NULL, NULL, '10.0'),
(10769, '2016-10-19 14:20:29', NULL, NULL, 3839, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 14:20:29', 'admin-1476853703-14768580291344520', 1, 1, 'SR', NULL, NULL, NULL),
(10770, '2016-10-19 14:20:29', NULL, NULL, 3839, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 14:20:29', 'admin-1476853703-14768580291344520', 1, 1, 'SR', NULL, NULL, NULL),
(10771, '2016-10-19 13:40:25', NULL, NULL, 3838, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 13:40:25', 'admin-1476853703-14768556252918550', 1, 0, '', NULL, NULL, NULL),
(10772, '2016-10-19 12:00:56', NULL, NULL, 3831, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 12:00:56', 'admin-1476843247-14768496560969171', 1, 1, 'SR', NULL, NULL, NULL),
(10773, '2016-10-19 12:00:56', NULL, NULL, 3831, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 12:00:56', 'admin-1476843247-14768496560969171', 1, 1, 'SR', NULL, NULL, NULL),
(10774, '2016-10-19 13:40:25', NULL, NULL, 3838, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 13:40:25', 'admin-1476853703-14768556252918550', 1, 1, 'SR', NULL, NULL, NULL),
(10775, '2016-10-19 12:21:48', NULL, NULL, 3832, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 12:21:48', 'admin-1476843247-14768509087779567', 1, 0, '', NULL, NULL, NULL),
(10776, '2016-10-19 12:00:43', NULL, NULL, 3831, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 12:00:43', 'admin-1476843247-14768496434128771', 1, 0, '', NULL, NULL, NULL),
(10777, '2016-10-19 10:14:17', NULL, NULL, 3830, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 10:14:17', 'admin-1476843247-1476843257566718', 1, 1, 'SR', NULL, NULL, NULL),
(10778, '2016-10-19 12:00:43', NULL, NULL, 3831, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 12:00:43', 'admin-1476843247-14768496434128771', 1, 0, '', NULL, NULL, NULL),
(10779, '2016-10-19 10:13:54', NULL, NULL, 3830, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476860642', 'admin', '2016-10-19 10:13:54', 'admin-1476839932-1476843233990431', 1, 0, '', NULL, NULL, NULL),
(10780, '2016-10-20 09:57:14', NULL, NULL, 3850, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 09:57:14', 'admin-1476925373-14769286346215590', 1, 0, '', NULL, NULL, NULL),
(10781, '2016-10-20 09:57:45', NULL, NULL, 3850, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 09:57:45', 'admin-1476925373-14769286656903680', 1, 0, '', NULL, NULL, NULL),
(10782, '2016-10-20 09:58:04', NULL, NULL, 3850, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 09:58:04', 'admin-1476925373-14769286847349113', 1, 1, 'SR', NULL, NULL, NULL),
(10783, '2016-10-20 09:59:03', NULL, NULL, 3850, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 09:59:03', 'admin-1476925373-1476928743089644', 1, 0, '', NULL, NULL, NULL),
(10784, '2016-10-20 10:12:23', NULL, NULL, 3851, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 10:12:23', 'admin-1476925373-14769295433605467', 1, 1, 'SR', NULL, NULL, NULL),
(10785, '2016-10-20 10:12:23', NULL, NULL, 3851, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 10:12:23', 'admin-1476925373-14769295433605467', 1, 1, 'SR', NULL, NULL, NULL),
(10786, '2016-10-20 10:12:31', NULL, NULL, 3850, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 10:12:31', 'admin-1476925373-14769295512673556', 1, 1, 'SR', NULL, NULL, NULL),
(10787, '2016-10-20 10:12:31', NULL, NULL, 3850, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 10:12:31', 'admin-1476925373-14769295512673556', 1, 1, 'SR', NULL, NULL, NULL),
(10788, '2016-10-20 10:12:41', NULL, NULL, 3852, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 10:12:41', 'admin-1476925373-1476929561667595', 1, 1, 'SR', NULL, NULL, NULL),
(10789, '2016-10-20 10:12:41', NULL, NULL, 3852, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 10:12:41', 'admin-1476925373-1476929561667595', 1, 1, 'SR', NULL, NULL, NULL),
(10790, '2016-10-20 10:12:41', NULL, NULL, 3852, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 10:12:41', 'admin-1476925373-1476929561667595', 1, 0, '', NULL, NULL, NULL),
(10791, '2016-10-20 10:20:24', NULL, NULL, 3853, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 10:20:24', 'admin-1476929641-14769300239713869', 1, 0, '', NULL, NULL, NULL),
(10792, '2016-10-20 10:20:24', NULL, NULL, 3853, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 10:20:24', 'admin-1476929641-14769300239713869', 1, 1, 'SR', NULL, NULL, NULL),
(10793, '2016-10-20 10:23:02', NULL, NULL, 3853, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 10:23:02', 'admin-1476929641-1476930182097994', 1, 0, '', NULL, NULL, NULL),
(10794, '2016-10-20 10:23:02', NULL, NULL, 3853, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 10:23:02', 'admin-1476929641-1476930182097994', 1, 0, '', NULL, NULL, NULL),
(10795, '2016-10-20 11:08:14', NULL, NULL, 3854, 0, 181, '116', 'Open Food ', 'green apple', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 11:08:14', 'admin-1476929641-14769328941956696', 1, 0, '', 1, NULL, NULL),
(10796, '2016-10-20 13:17:35', NULL, NULL, 3855, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 13:17:35', 'admin-1476929641-14769406551417883', 1, 0, '', NULL, NULL, NULL),
(10797, '2016-10-20 13:35:28', NULL, NULL, 3855, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 13:35:28', 'admin-1476929641-14769417283538457', 1, 0, '', NULL, NULL, NULL),
(10798, '2016-10-20 13:17:35', NULL, NULL, 3855, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 13:17:35', 'admin-1476929641-14769406551417883', 1, 0, '', NULL, NULL, NULL),
(10799, '2016-10-20 13:22:10', NULL, NULL, 3855, 0, 222, '156', 'Seasoned Chicken Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 13:22:10', 'admin-1476929641-14769409302828147', 1, 0, '', NULL, NULL, NULL),
(10800, '2016-10-20 13:37:26', NULL, NULL, 3856, 0, 85, '85', 'Set Sauted Mushroom Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 13:37:26', 'admin-1476929641-1476941845995658', 1, 1, 'SR', NULL, NULL, NULL),
(10801, '2016-10-20 14:50:06', NULL, NULL, 3861, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 14:50:06', 'admin-1476946160-14769462061259120', 1, 1, 'SR', NULL, NULL, NULL),
(10802, '2016-10-20 14:48:25', NULL, NULL, 3860, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 14:48:25', 'admin-1476941852-14769461056521236', 1, 1, 'SR', NULL, NULL, NULL),
(10803, '2016-10-20 14:50:44', NULL, NULL, 3862, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 14:50:44', 'admin-1476946160-14769462441123698', 1, 0, '', NULL, NULL, NULL),
(10804, '2016-10-20 14:50:44', NULL, NULL, 3862, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 14:50:44', 'admin-1476946160-14769462441123698', 1, 0, '', NULL, NULL, NULL),
(10805, '2016-10-20 14:50:44', NULL, NULL, 3862, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 14:50:44', 'admin-1476946160-14769462441123698', 1, 1, 'SR', NULL, NULL, NULL),
(10806, '2016-10-20 14:50:44', NULL, NULL, 3862, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 14:50:44', 'admin-1476946160-14769462441123698', 1, 1, 'SR', NULL, NULL, NULL),
(10807, '2016-10-20 15:21:48', NULL, NULL, 3863, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 15:21:48', 'admin-1476946160-1476948108521278', 1, 1, 'SR', NULL, NULL, NULL),
(10808, '2016-10-20 15:21:48', NULL, NULL, 3863, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 15:21:48', 'admin-1476946160-1476948108521278', 1, 1, 'SR', NULL, NULL, NULL),
(10809, '2016-10-20 15:21:48', NULL, NULL, 3863, 0, 227, '161', 'Cranberry Velvet', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 15:21:48', 'admin-1476946160-1476948108521278', 1, 0, '', NULL, NULL, NULL),
(10810, '2016-10-20 15:54:07', NULL, NULL, 3864, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 15:54:07', 'admin-1476950035-1476950047597453', 1, 1, 'SR', NULL, NULL, NULL),
(10811, '2016-10-20 16:21:07', NULL, NULL, 3865, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 16:21:07', 'admin-1476950035-14769516676467320', 1, 0, '', NULL, NULL, NULL),
(10812, '2016-10-20 16:21:07', NULL, NULL, 3865, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 16:21:07', 'admin-1476950035-14769516676467320', 1, 1, 'SR', NULL, NULL, NULL),
(10813, '2016-10-20 16:21:07', NULL, NULL, 3865, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 16:21:07', 'admin-1476950035-14769516676467320', 1, 0, '', NULL, NULL, NULL),
(10814, '2016-10-20 19:27:00', NULL, NULL, 3870, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 19:27:00', 'admin-1476950035-14769628204378880', 1, 1, 'SR', NULL, NULL, NULL),
(10815, '2016-10-20 17:17:29', NULL, NULL, 3867, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 17:17:29', 'admin-1476950035-1476955049715510', 1, 1, 'SR', NULL, NULL, NULL),
(10816, '2016-10-20 18:36:19', NULL, NULL, 3868, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 18:36:19', 'admin-1476950035-1476959779133246', 1, 0, '', NULL, NULL, NULL),
(10817, '2016-10-20 18:36:19', NULL, NULL, 3868, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 18:36:19', 'admin-1476950035-1476959779133246', 1, 1, 'SR', NULL, NULL, NULL),
(10818, '2016-10-20 18:36:19', NULL, NULL, 3868, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 18:36:19', 'admin-1476950035-1476959779133246', 1, 1, 'SR', NULL, NULL, NULL),
(10819, '2016-10-20 18:36:19', NULL, NULL, 3868, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 18:36:19', 'admin-1476950035-1476959779133246', 1, 0, '', NULL, NULL, NULL),
(10820, '2016-10-20 18:55:45', NULL, NULL, 3869, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 18:55:45', 'admin-1476950035-14769609454071446', 1, 1, 'SR', 1, NULL, NULL),
(10821, '2016-10-20 18:55:45', NULL, NULL, 3869, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 18:55:45', 'admin-1476950035-14769609454071446', 1, 1, 'SR', 1, NULL, NULL),
(10822, '2016-10-20 19:18:58', NULL, NULL, 3871, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 19:18:58', 'admin-1476950035-14769623381043371', 1, 1, 'SR', NULL, NULL, NULL),
(10823, '2016-10-20 19:27:00', NULL, NULL, 3870, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 19:27:00', 'admin-1476950035-14769628204378880', 1, 1, 'SR', NULL, NULL, NULL),
(10824, '2016-10-20 17:05:55', NULL, NULL, 3866, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 17:05:55', 'admin-1476950035-14769543556416543', 1, 1, 'SR', 1, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(10825, '2016-10-20 17:05:55', NULL, NULL, 3866, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 17:05:55', 'admin-1476950035-14769543556416543', 1, 1, 'SR', 1, NULL, NULL),
(10826, '2016-10-20 17:05:55', NULL, NULL, 3866, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 17:05:55', 'admin-1476950035-14769543556416543', 1, 1, 'SR', 1, NULL, NULL),
(10827, '2016-10-20 16:35:08', NULL, NULL, 3864, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 16:35:08', 'admin-1476950035-14769525084931823', 1, 0, '', NULL, NULL, NULL),
(10828, '2016-10-20 13:46:43', NULL, NULL, 3858, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 13:46:43', 'admin-1476941852-14769424030786138', 1, 0, '', NULL, NULL, NULL),
(10829, '2016-10-20 14:26:08', NULL, NULL, 3859, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 14:26:08', 'admin-1476941852-14769447678452879', 1, 1, 'SR', NULL, NULL, NULL),
(10830, '2016-10-20 13:43:48', NULL, NULL, 3857, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 13:43:48', 'admin-1476941852-14769422284922761', 1, 0, '', NULL, NULL, NULL),
(10831, '2016-10-20 13:43:48', NULL, NULL, 3857, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 13:43:48', 'admin-1476941852-14769422284922761', 1, 1, 'SR', NULL, NULL, NULL),
(10832, '2016-10-20 13:43:53', NULL, NULL, 3857, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 13:43:53', 'admin-1476941852-1476942233309553', 1, 1, 'SR', NULL, NULL, NULL),
(10833, '2016-10-20 13:37:26', NULL, NULL, 3856, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 13:37:26', 'admin-1476929641-1476941845995658', 1, 1, 'SR', NULL, NULL, NULL),
(10834, '2016-10-20 09:55:08', NULL, NULL, 3850, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 09:55:08', 'admin-1476925373-14769285087581633', 1, 0, '', NULL, NULL, NULL),
(10835, '2016-10-20 09:55:53', NULL, NULL, 3850, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 09:55:53', 'admin-1476925373-14769285528196822', 1, 1, 'SR', NULL, NULL, NULL),
(10836, '2016-10-20 13:43:48', NULL, NULL, 3857, 0, 82, '82', 'Set Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 13:43:48', 'admin-1476941852-14769422284922761', 1, 1, 'SR', NULL, NULL, NULL),
(10837, '2016-10-20 09:06:10', NULL, NULL, 3849, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 09:06:10', 'admin-1476925373-14769255707701849', 1, 0, '', NULL, NULL, NULL),
(10838, '2016-10-20 09:06:20', NULL, NULL, 3849, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 09:06:20', 'admin-1476925373-14769255803183711', 1, 0, '', NULL, NULL, NULL),
(10839, '2016-10-20 09:06:20', NULL, NULL, 3849, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 09:06:20', 'admin-1476925373-14769255803183711', 1, 1, 'SR', NULL, NULL, NULL),
(10840, '2016-10-20 09:06:10', NULL, NULL, 3849, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1476950035', 'admin', '2016-10-20 09:06:10', 'admin-1476925373-14769255707701849', 1, 0, '', NULL, NULL, NULL),
(10841, '2016-10-21 17:56:16', NULL, NULL, 3893, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 17:56:16', 'admin-1477032192-14770437759889619', 1, 1, 'SR', NULL, NULL, '10.0'),
(10842, '2016-10-21 17:56:16', NULL, NULL, 3893, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 17:56:16', 'admin-1477032192-14770437759889619', 1, 1, 'SR', NULL, NULL, '10.0'),
(10843, '2016-10-21 17:25:16', NULL, NULL, 3892, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 17:25:16', 'admin-1477032192-14770419159503432', 1, 1, 'SR', NULL, NULL, NULL),
(10844, '2016-10-21 17:25:16', NULL, NULL, 3892, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 17:25:16', 'admin-1477032192-14770419159503432', 1, 1, 'SR', NULL, NULL, NULL),
(10845, '2016-10-21 17:25:16', NULL, NULL, 3892, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 17:25:16', 'admin-1477032192-14770419159503432', 1, 0, '', NULL, NULL, NULL),
(10846, '2016-10-21 17:15:36', NULL, NULL, 3891, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 17:15:36', 'admin-1477032192-14770413360909697', 1, 0, '', NULL, NULL, NULL),
(10847, '2016-10-21 17:15:36', NULL, NULL, 3891, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 17:15:36', 'admin-1477032192-14770413360909697', 1, 1, 'SR', NULL, NULL, NULL),
(10848, '2016-10-21 16:47:03', NULL, NULL, 3890, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 16:47:03', 'admin-1477032192-14770396233839987', 1, 1, 'SR', NULL, NULL, NULL),
(10849, '2016-10-21 16:47:03', NULL, NULL, 3890, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 16:47:03', 'admin-1477032192-14770396233839987', 1, 1, 'SR', NULL, NULL, NULL),
(10850, '2016-10-21 14:43:29', NULL, NULL, 3889, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 14:43:29', 'admin-1477032192-1477032208941758', 1, 1, 'SR', NULL, NULL, NULL),
(10851, '2016-10-21 14:42:46', NULL, NULL, 3889, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 14:42:46', 'admin-1477022052-14770321662866434', 1, 0, '', NULL, NULL, NULL),
(10852, '2016-10-21 14:41:53', NULL, NULL, 3888, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 14:41:53', 'admin-1477022052-14770321129293293', 1, 1, 'SR', NULL, NULL, NULL),
(10853, '2016-10-21 14:41:37', NULL, NULL, 3888, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 14:41:37', 'admin-1477022052-14770320974447039', 1, 0, '', NULL, NULL, NULL),
(10854, '2016-10-21 10:14:46', NULL, NULL, 3875, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 10:14:46', 'admin-1477012120-14770160865898616', 1, 1, 'SR', NULL, NULL, NULL),
(10855, '2016-10-21 10:43:05', NULL, NULL, 3876, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 10:43:05', 'admin-1477012120-14770177856704171', 1, 0, '', NULL, NULL, NULL),
(10856, '2016-10-21 10:31:54', NULL, NULL, 3876, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 10:31:54', 'admin-1477012120-14770171146049811', 1, 0, '', NULL, NULL, NULL),
(10857, '2016-10-21 10:32:02', NULL, NULL, 3876, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 10:32:02', 'admin-1477012120-14770171228026113', 1, 1, 'SR', NULL, NULL, NULL),
(10858, '2016-10-21 10:32:02', NULL, NULL, 3876, 0, 54, '54', 'Chai Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 10:32:02', 'admin-1477012120-14770171228026113', 1, 1, 'SR', NULL, NULL, NULL),
(10859, '2016-10-21 10:47:59', NULL, NULL, 3877, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 10:47:59', 'admin-1477012120-14770180793334679', 1, 1, 'SR', NULL, NULL, NULL),
(10860, '2016-10-21 14:36:11', NULL, NULL, 3887, 0, 154, '88', 'House BLT', 'Takeaway', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 14:36:11', 'admin-1477022052-14770317715363585', 1, 0, '', NULL, NULL, NULL),
(10861, '2016-10-21 14:36:11', NULL, NULL, 3887, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 14:36:11', 'admin-1477022052-14770317715363585', 1, 0, '', NULL, NULL, NULL),
(10862, '2016-10-21 14:15:14', NULL, NULL, 3886, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 14:15:14', 'admin-1477022052-14770305147345555', 1, 1, 'SR', NULL, NULL, NULL),
(10863, '2016-10-21 14:15:14', NULL, NULL, 3886, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 14:15:14', 'admin-1477022052-14770305147345555', 1, 0, '', NULL, NULL, NULL),
(10864, '2016-10-21 13:46:36', NULL, NULL, 3885, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 13:46:36', 'admin-1477022052-14770287967151874', 1, 1, 'SR', NULL, NULL, NULL),
(10865, '2016-10-21 13:46:36', NULL, NULL, 3885, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 13:46:36', 'admin-1477022052-14770287967151874', 1, 0, '', NULL, NULL, NULL),
(10866, '2016-10-21 13:34:13', NULL, NULL, 3884, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 13:34:13', 'admin-1477022052-14770280534907438', 1, 0, '', NULL, NULL, NULL),
(10867, '2016-10-21 13:09:07', NULL, NULL, 3884, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 13:09:07', 'admin-1477022052-1477026546818524', 1, 0, '', NULL, NULL, NULL),
(10868, '2016-10-21 13:08:45', NULL, NULL, 3884, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 13:08:45', 'admin-1477022052-14770265253944965', 1, 1, 'SR', NULL, NULL, NULL),
(10869, '2016-10-21 13:08:45', NULL, NULL, 3884, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 13:08:45', 'admin-1477022052-14770265253944965', 1, 1, 'SR', NULL, NULL, NULL),
(10870, '2016-10-21 13:08:26', NULL, NULL, 3884, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 13:08:26', 'admin-1477022052-14770265057261364', 1, 0, '', NULL, NULL, NULL),
(10871, '2016-10-21 13:08:26', NULL, NULL, 3884, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 13:08:26', 'admin-1477022052-14770265057261364', 1, 0, '', NULL, NULL, NULL),
(10872, '2016-10-21 20:30:46', NULL, NULL, 3900, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 20:30:46', 'admin-1477050597-14770530458611787', 1, 1, 'SR', NULL, NULL, '10.0'),
(10873, '2016-10-21 20:32:19', NULL, NULL, 3898, 0, 227, '161', 'Cranberry Velvet', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 20:32:19', 'admin-1477050597-1477053138870104', 1, 0, '', NULL, NULL, NULL),
(10874, '2016-10-21 20:30:31', NULL, NULL, 3900, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 20:30:31', 'admin-1477050597-14770530308474531', 1, 1, 'SR', NULL, NULL, '10.0'),
(10875, '2016-10-21 18:56:58', NULL, NULL, 3896, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 18:56:58', 'admin-1477032192-1477047418756645', 1, 1, 'SR', NULL, NULL, NULL),
(10876, '2016-10-21 18:56:59', NULL, NULL, 3896, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 18:56:59', 'admin-1477032192-1477047418756645', 1, 1, 'SR', NULL, NULL, NULL),
(10877, '2016-10-21 18:59:04', NULL, NULL, 3895, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 18:59:04', 'admin-1477032192-14770475444151876', 1, 0, '', NULL, NULL, NULL),
(10878, '2016-10-21 19:09:41', NULL, NULL, 3897, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 19:09:41', 'admin-1477032192-1477048181423495', 1, 0, '', NULL, NULL, NULL),
(10879, '2016-10-21 19:12:06', NULL, NULL, 3897, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 19:12:06', 'admin-1477032192-14770483258776153', 1, 1, 'SR', NULL, NULL, NULL),
(10880, '2016-10-21 19:12:06', NULL, NULL, 3897, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 19:12:06', 'admin-1477032192-14770483258776153', 1, 1, 'SR', NULL, NULL, NULL),
(10881, '2016-10-21 20:29:49', NULL, NULL, 3900, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 20:29:49', 'admin-1477050597-14770529890059699', 1, 1, 'SR', NULL, NULL, '10.0'),
(10882, '2016-10-21 20:30:31', NULL, NULL, 3900, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 20:30:31', 'admin-1477050597-14770530308474531', 1, 0, '', NULL, NULL, '10.0'),
(10883, '2016-10-21 20:16:20', NULL, NULL, 3899, 0, 227, '161', 'Cranberry Velvet', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 20:16:20', 'admin-1477050597-1477052180492794', 1, 0, '', NULL, NULL, NULL),
(10884, '2016-10-21 18:45:26', NULL, NULL, 3894, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 18:45:26', 'admin-1477032192-14770467266123160', 1, 1, 'SR', NULL, NULL, NULL),
(10885, '2016-10-21 18:55:56', NULL, NULL, 3895, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 18:55:56', 'admin-1477032192-14770473567962361', 1, 1, 'SR', NULL, NULL, NULL),
(10886, '2016-10-21 18:55:56', NULL, NULL, 3895, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 18:55:56', 'admin-1477032192-14770473567962361', 1, 1, 'SR', NULL, NULL, NULL),
(10887, '2016-10-21 18:55:56', NULL, NULL, 3895, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 18:55:56', 'admin-1477032192-14770473567962361', 1, 1, 'SR', NULL, NULL, NULL),
(10888, '2016-10-21 18:56:30', NULL, NULL, 3896, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 18:56:30', 'admin-1477032192-14770473899292734', 1, 0, '', NULL, NULL, NULL),
(10889, '2016-10-21 18:56:30', NULL, NULL, 3896, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 18:56:30', 'admin-1477032192-14770473899292734', 1, 0, '', NULL, NULL, NULL),
(10890, '2016-10-21 19:50:24', NULL, NULL, 3898, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 19:50:24', 'admin-1477050597-14770506240659192', 1, 1, 'SR', NULL, NULL, NULL),
(10891, '2016-10-21 18:55:56', NULL, NULL, 3895, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 18:55:56', 'admin-1477032192-14770473567962361', 1, 1, 'SR', NULL, NULL, NULL),
(10892, '2016-10-21 18:45:26', NULL, NULL, 3894, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 18:45:26', 'admin-1477032192-14770467266123160', 1, 1, 'SR', NULL, NULL, NULL),
(10893, '2016-10-21 17:56:16', NULL, NULL, 3893, 0, 227, '161', 'Cranberry Velvet', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 17:56:16', 'admin-1477032192-14770437759889619', 1, 0, '', NULL, NULL, '10.0'),
(10894, '2016-10-21 13:08:25', NULL, NULL, 3884, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 13:08:25', 'admin-1477022052-14770265057261364', 1, 0, '', NULL, NULL, NULL),
(10895, '2016-10-21 13:08:25', NULL, NULL, 3884, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 13:08:25', 'admin-1477022052-14770265057261364', 1, 0, '', NULL, NULL, NULL),
(10896, '2016-10-21 10:59:34', NULL, NULL, 3879, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 10:59:34', 'admin-1477012120-14770187746936268', 1, 0, '', NULL, NULL, NULL),
(10897, '2016-10-21 10:59:57', NULL, NULL, 3880, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 10:59:57', 'admin-1477012120-14770187977442430', 1, 0, '', NULL, NULL, NULL),
(10898, '2016-10-21 10:47:59', NULL, NULL, 3877, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 10:47:59', 'admin-1477012120-14770180793334679', 1, 0, '', NULL, NULL, NULL),
(10899, '2016-10-21 11:54:04', NULL, NULL, 3883, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 11:54:04', 'admin-1477012120-14770220443401791', 1, 1, 'SR', NULL, NULL, NULL),
(10900, '2016-10-21 11:54:04', NULL, NULL, 3883, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 11:54:04', 'admin-1477012120-14770220443401791', 1, 0, '', NULL, NULL, NULL),
(10901, '2016-10-21 11:52:38', NULL, NULL, 3882, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 11:52:38', 'admin-1477012120-1477021958711368', 1, 0, '', NULL, NULL, NULL),
(10902, '2016-10-21 11:52:38', NULL, NULL, 3882, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 11:52:38', 'admin-1477012120-1477021958711368', 1, 1, 'SR', NULL, NULL, NULL),
(10903, '2016-10-21 11:25:28', NULL, NULL, 3881, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 11:25:28', 'admin-1477012120-14770203281963522', 1, 0, '', NULL, NULL, NULL),
(10904, '2016-10-21 11:21:47', NULL, NULL, 3877, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 11:21:47', 'admin-1477012120-14770201072234227', 1, 0, '', NULL, NULL, NULL),
(10905, '2016-10-21 11:18:17', NULL, NULL, 3877, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 11:18:17', 'admin-1477012120-14770198972038630', 1, 1, 'SR', NULL, NULL, NULL),
(10906, '2016-10-21 11:18:17', NULL, NULL, 3877, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 11:18:17', 'admin-1477012120-14770198972038630', 1, 1, 'SR', NULL, NULL, NULL),
(10907, '2016-10-21 10:59:06', NULL, NULL, 3878, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 10:59:06', 'admin-1477012120-14770187459623871', 1, 0, '', NULL, NULL, NULL),
(10908, '2016-10-21 10:47:59', NULL, NULL, 3877, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 10:47:59', 'admin-1477012120-14770180793334679', 1, 0, '', NULL, NULL, NULL),
(10909, '2016-10-21 19:43:24', NULL, NULL, 3898, 0, 181, '116', 'Open Food ', 'Curry Chicken', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 19:43:24', 'admin-1477032192-14770502043325634', 1, 0, '', NULL, NULL, NULL),
(10910, '2016-10-21 10:47:59', NULL, NULL, 3877, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 10:47:59', 'admin-1477012120-14770180793334679', 1, 0, '', NULL, NULL, NULL),
(10911, '2016-10-21 10:47:59', NULL, NULL, 3877, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 10:47:59', 'admin-1477012120-14770180793334679', 1, 0, '', NULL, NULL, NULL),
(10912, '2016-10-21 10:47:59', NULL, NULL, 3877, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 10:47:59', 'admin-1477012120-14770180793334679', 1, 0, '', NULL, NULL, NULL),
(10913, '2016-10-21 09:26:27', NULL, NULL, 3874, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 09:26:27', 'admin-1477012120-14770131875916080', 1, 0, '', NULL, NULL, NULL),
(10914, '2016-10-21 09:26:27', NULL, NULL, 3874, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 09:26:27', 'admin-1477012120-14770131875916080', 1, 0, '', NULL, NULL, NULL),
(10915, '2016-10-21 09:26:27', NULL, NULL, 3874, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 09:26:27', 'admin-1477012120-14770131875916080', 1, 0, '', NULL, NULL, NULL),
(10916, '2016-10-21 09:26:27', NULL, NULL, 3874, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 09:26:27', 'admin-1477012120-14770131875916080', 1, 0, '', NULL, NULL, NULL),
(10917, '2016-10-21 19:43:24', NULL, NULL, 3898, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 19:43:24', 'admin-1477032192-14770502043325634', 1, 1, 'SR', NULL, NULL, NULL),
(10918, '2016-10-21 09:13:26', NULL, NULL, 3873, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 09:13:26', 'admin-1477012120-14770124063539382', 1, 1, 'SR', NULL, NULL, NULL),
(10919, '2016-10-21 09:13:26', NULL, NULL, 3873, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 09:13:26', 'admin-1477012120-14770124063539382', 1, 1, 'SR', NULL, NULL, NULL),
(10920, '2016-10-21 09:26:27', NULL, NULL, 3874, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 09:26:27', 'admin-1477012120-14770131875916080', 1, 1, 'SR', NULL, NULL, NULL),
(10921, '2016-10-21 09:26:27', NULL, NULL, 3874, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 09:26:27', 'admin-1477012120-14770131875916080', 1, 0, '', NULL, NULL, NULL),
(10922, '2016-10-21 20:30:31', NULL, NULL, 3900, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 20:30:31', 'admin-1477050597-14770530308474531', 1, 0, '', NULL, NULL, '10.0'),
(10923, '2016-10-21 09:13:26', NULL, NULL, 3873, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 09:13:26', 'admin-1477012120-14770124063539382', 1, 0, '', NULL, NULL, NULL),
(10924, '2016-10-21 09:13:26', NULL, NULL, 3873, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 09:13:26', 'admin-1477012120-14770124063539382', 1, 0, '', NULL, NULL, NULL),
(10925, '2016-10-21 09:13:26', NULL, NULL, 3873, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477050597', 'admin', '2016-10-21 09:13:26', 'admin-1477012120-14770124063539382', 1, 0, '', NULL, NULL, NULL),
(10926, '2016-10-22 21:28:35', NULL, NULL, 3946, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 21:28:35', 'admin-1477129686-14771429155743570', 1, 0, '', NULL, NULL, NULL),
(10927, '2016-10-22 16:28:27', NULL, NULL, 3934, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 16:28:27', 'admin-1477115932-14771249068341736', 1, 1, 'SR', NULL, NULL, NULL),
(10928, '2016-10-22 16:02:58', NULL, NULL, 3933, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 16:02:58', 'admin-1477115932-14771233787159455', 1, 1, 'SR', NULL, NULL, NULL),
(10929, '2016-10-22 16:02:58', NULL, NULL, 3933, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 16:02:58', 'admin-1477115932-14771233787159455', 1, 1, 'SR', NULL, NULL, NULL),
(10930, '2016-10-22 15:23:45', NULL, NULL, 3931, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 15:23:45', 'admin-1477115932-14771210255203927', 1, 1, 'SR', NULL, NULL, NULL),
(10931, '2016-10-22 16:02:58', NULL, NULL, 3933, 0, 228, '162', 'Golden Brown', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 16:02:58', 'admin-1477115932-14771233787159455', 1, 0, '', NULL, NULL, NULL),
(10932, '2016-10-22 15:23:45', NULL, NULL, 3931, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 15:23:45', 'admin-1477115932-14771210255203927', 1, 1, 'SR', NULL, NULL, NULL),
(10933, '2016-10-22 15:41:23', NULL, NULL, 3932, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 15:41:23', 'admin-1477115932-14771220829912975', 1, 0, '', NULL, NULL, NULL),
(10934, '2016-10-22 15:23:34', NULL, NULL, 3930, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 15:23:34', 'admin-1477115932-14771210138908596', 1, 0, '', NULL, NULL, NULL),
(10935, '2016-10-22 15:39:15', NULL, NULL, 3914, 0, 70, '70', 'Pepper Pork', 'Takeaway', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 15:39:15', 'admin-1477115932-1477121955054891', 1, 1, 'SR', NULL, NULL, NULL),
(10936, '2016-10-22 15:23:34', NULL, NULL, 3930, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 15:23:34', 'admin-1477115932-14771210138908596', 1, 0, '', NULL, NULL, NULL),
(10937, '2016-10-22 15:14:52', NULL, NULL, 3929, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 15:14:52', 'admin-1477115932-14771204923942110', 1, 1, 'SR', NULL, NULL, NULL),
(10938, '2016-10-22 15:12:01', NULL, NULL, 3927, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 15:12:01', 'admin-1477115932-14771203210978222', 1, 0, '', NULL, NULL, NULL),
(10939, '2016-10-22 15:08:29', NULL, NULL, 3926, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 15:08:29', 'admin-1477115932-14771201091813028', 1, 1, 'SR', NULL, NULL, NULL),
(10940, '2016-10-22 09:10:59', NULL, NULL, 3903, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 09:10:59', 'admin-1477098312-14770986592401939', 1, 1, 'SR', NULL, NULL, NULL),
(10941, '2016-10-22 09:25:25', NULL, NULL, 3904, 0, 154, '88', 'House BLT', 'Takeaway', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 09:25:25', 'admin-1477098312-14770995252017874', 1, 0, '', NULL, NULL, NULL),
(10942, '2016-10-22 09:30:24', NULL, NULL, 3905, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 09:30:24', 'admin-1477098312-14770998247148764', 1, 1, 'SR', NULL, NULL, NULL),
(10943, '2016-10-22 10:48:58', NULL, NULL, 3906, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 10:48:58', 'admin-1477098312-14771045379056637', 1, 0, '', NULL, NULL, NULL),
(10944, '2016-10-22 10:48:58', NULL, NULL, 3906, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 10:48:58', 'admin-1477098312-14771045379056637', 1, 0, '', NULL, NULL, NULL),
(10945, '2016-10-22 10:49:08', NULL, NULL, 3906, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 10:49:08', 'admin-1477098312-14771045481005655', 1, 1, 'SR', NULL, NULL, NULL),
(10946, '2016-10-22 22:14:47', NULL, NULL, 3950, 0, 228, '162', 'Golden Brown', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 22:14:47', 'admin-1477129686-14771456876237722', 1, 0, '', NULL, NULL, '20.0'),
(10947, '2016-10-22 21:56:42', NULL, NULL, 3948, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 21:56:42', 'admin-1477129686-1477144602503372', 1, 0, '', NULL, NULL, NULL),
(10948, '2016-10-22 21:56:42', NULL, NULL, 3948, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 21:56:42', 'admin-1477129686-1477144602503372', 1, 1, 'SR', NULL, NULL, NULL),
(10949, '2016-10-22 22:00:41', NULL, NULL, 3948, 0, 228, '162', 'Golden Brown', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 22:00:41', 'admin-1477129686-14771448409466522', 1, 0, '', NULL, NULL, NULL),
(10950, '2016-10-22 22:14:47', NULL, NULL, 3950, 0, 228, '162', 'Golden Brown', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 22:14:47', 'admin-1477129686-14771456876237722', 1, 0, '', NULL, NULL, '20.0'),
(10951, '2016-10-22 22:06:40', NULL, NULL, 3949, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 22:06:40', 'admin-1477129686-14771452001661643', 1, 1, 'SR', NULL, NULL, NULL),
(10952, '2016-10-22 17:43:13', NULL, NULL, 3942, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 17:43:13', 'admin-1477115932-14771293928325594', 1, 1, 'SR', NULL, NULL, NULL),
(10953, '2016-10-22 17:38:30', NULL, NULL, 3941, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 17:38:30', 'admin-1477115932-14771291101104667', 1, 0, '', NULL, NULL, NULL),
(10954, '2016-10-22 17:38:08', NULL, NULL, 3941, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 17:38:08', 'admin-1477115932-14771290880896043', 1, 0, '', NULL, NULL, NULL),
(10955, '2016-10-22 22:06:40', NULL, NULL, 3949, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 22:06:40', 'admin-1477129686-14771452001661643', 1, 1, 'SR', NULL, NULL, NULL),
(10956, '2016-10-22 21:29:49', NULL, NULL, 3947, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 21:29:49', 'admin-1477129686-14771429894493830', 1, 1, 'SR', 1, NULL, NULL),
(10957, '2016-10-22 21:29:49', NULL, NULL, 3947, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 21:29:49', 'admin-1477129686-14771429894493830', 1, 1, 'SR', 1, NULL, NULL),
(10958, '2016-10-22 21:22:31', NULL, NULL, 3945, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 21:22:31', 'admin-1477129686-1477142551005212', 1, 1, 'SR', 1, NULL, NULL),
(10959, '2016-10-22 21:22:31', NULL, NULL, 3945, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 21:22:31', 'admin-1477129686-1477142551005212', 1, 1, 'SR', 1, NULL, NULL),
(10960, '2016-10-22 20:46:49', NULL, NULL, 3944, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 20:46:49', 'admin-1477129686-1477140409684679', 1, 0, '', NULL, NULL, NULL),
(10961, '2016-10-22 20:45:31', NULL, NULL, 3944, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 20:45:31', 'admin-1477129686-1477140330799583', 1, 1, 'SR', NULL, NULL, NULL),
(10962, '2016-10-22 20:44:36', NULL, NULL, 3944, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 20:44:36', 'admin-1477129686-14771402758764294', 1, 0, '', NULL, NULL, NULL),
(10963, '2016-10-22 19:03:23', NULL, NULL, 3943, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 19:03:23', 'admin-1477129686-14771342032452318', 1, 1, 'SR', NULL, NULL, NULL),
(10964, '2016-10-22 19:03:14', NULL, NULL, 3943, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 19:03:14', 'admin-1477129686-1477134194041486', 1, 1, 'SR', NULL, NULL, NULL),
(10965, '2016-10-22 17:48:19', NULL, NULL, 3942, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 17:48:19', 'admin-1477129686-1477129699289771', 1, 1, 'SR', NULL, NULL, NULL),
(10966, '2016-10-22 17:43:13', NULL, NULL, 3942, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 17:43:13', 'admin-1477115932-14771293928325594', 1, 0, '', NULL, NULL, NULL),
(10967, '2016-10-22 17:48:19', NULL, NULL, 3942, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 17:48:19', 'admin-1477129686-1477129699289771', 1, 1, 'SR', NULL, NULL, NULL),
(10968, '2016-10-22 17:38:01', NULL, NULL, 3941, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 17:38:01', 'admin-1477115932-14771290813269892', 1, 1, 'SR', NULL, NULL, NULL),
(10969, '2016-10-22 17:38:01', NULL, NULL, 3941, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 17:38:01', 'admin-1477115932-14771290813269892', 1, 1, 'SR', NULL, NULL, NULL),
(10970, '2016-10-22 17:38:01', NULL, NULL, 3941, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 17:38:01', 'admin-1477115932-14771290813269892', 1, 1, 'SR', NULL, NULL, NULL),
(10971, '2016-10-22 15:08:29', NULL, NULL, 3926, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 15:08:29', 'admin-1477115932-14771201091813028', 1, 1, 'SR', NULL, NULL, NULL),
(10972, '2016-10-22 15:08:29', NULL, NULL, 3926, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 15:08:29', 'admin-1477115932-14771201091813028', 1, 1, 'SR', NULL, NULL, NULL),
(10973, '2016-10-22 15:08:29', NULL, NULL, 3926, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 15:08:29', 'admin-1477115932-14771201091813028', 1, 1, 'SR', NULL, NULL, NULL),
(10974, '2016-10-22 12:24:32', NULL, NULL, 3915, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 12:24:32', 'admin-1477104610-14771102722502774', 1, 1, 'SR', NULL, NULL, NULL),
(10975, '2016-10-22 12:01:52', NULL, NULL, 3909, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 12:01:52', 'admin-1477104610-14771089117818270', 1, 1, 'SR', NULL, NULL, NULL),
(10976, '2016-10-22 12:55:34', NULL, NULL, 3918, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 12:55:34', 'admin-1477104610-1477112134391618', 1, 0, '', NULL, NULL, NULL),
(10977, '2016-10-22 12:55:34', NULL, NULL, 3918, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 12:55:34', 'admin-1477104610-1477112134391618', 1, 1, 'SR', NULL, NULL, NULL),
(10978, '2016-10-22 13:04:42', NULL, NULL, 3910, 0, 227, '161', 'Cranberry Velvet', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 13:04:42', 'admin-1477104610-14771126826975581', 1, 0, '', NULL, NULL, NULL),
(10979, '2016-10-22 12:01:52', NULL, NULL, 3909, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 12:01:52', 'admin-1477104610-14771089117818270', 1, 1, 'SR', NULL, NULL, NULL),
(10980, '2016-10-22 12:24:32', NULL, NULL, 3915, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 12:24:32', 'admin-1477104610-14771102722502774', 1, 0, '', NULL, NULL, NULL),
(10981, '2016-10-22 12:39:48', NULL, NULL, 3916, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 12:39:48', 'admin-1477104610-14771111887119793', 1, 1, 'SR', NULL, NULL, NULL),
(10982, '2016-10-22 12:54:59', NULL, NULL, 3917, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 12:54:59', 'admin-1477104610-1477112098906270', 1, 0, '', NULL, NULL, NULL),
(10983, '2016-10-22 12:54:59', NULL, NULL, 3917, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 12:54:59', 'admin-1477104610-1477112098906270', 1, 1, 'SR', NULL, NULL, NULL),
(10984, '2016-10-22 17:38:01', NULL, NULL, 3941, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 17:38:01', 'admin-1477115932-14771290813269892', 1, 1, 'SR', NULL, NULL, NULL),
(10985, '2016-10-22 17:08:02', NULL, NULL, 3939, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 17:08:02', 'admin-1477115932-14771272826008840', 1, 0, '', NULL, NULL, NULL),
(10986, '2016-10-22 17:28:31', NULL, NULL, 3940, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 17:28:31', 'admin-1477115932-14771285111245977', 1, 1, 'SR', NULL, NULL, NULL),
(10987, '2016-10-22 17:29:00', NULL, NULL, 3940, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 17:29:00', 'admin-1477115932-147712853989392', 1, 0, '', NULL, NULL, NULL),
(10988, '2016-10-22 16:55:15', NULL, NULL, 3935, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 16:55:15', 'admin-1477115932-14771265151159958', 1, 0, '', NULL, NULL, NULL),
(10989, '2016-10-22 16:55:15', NULL, NULL, 3935, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 16:55:15', 'admin-1477115932-14771265151159958', 1, 0, '', NULL, NULL, NULL),
(10990, '2016-10-22 16:55:24', NULL, NULL, 3935, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 16:55:24', 'admin-1477115932-1477126524575709', 1, 1, 'SR', NULL, NULL, NULL),
(10991, '2016-10-22 16:55:24', NULL, NULL, 3935, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 16:55:24', 'admin-1477115932-1477126524575709', 1, 1, 'SR', NULL, NULL, NULL),
(10992, '2016-10-22 17:00:28', NULL, NULL, 3936, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 17:00:28', 'admin-1477115932-14771268287142281', 1, 0, '', NULL, NULL, NULL),
(10993, '2016-10-22 17:00:35', NULL, NULL, 3937, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 17:00:35', 'admin-1477115932-1477126835390658', 1, 1, 'SR', NULL, NULL, NULL),
(10994, '2016-10-22 17:28:31', NULL, NULL, 3940, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 17:28:31', 'admin-1477115932-14771285111245977', 1, 0, '', NULL, NULL, NULL),
(10995, '2016-10-22 17:28:31', NULL, NULL, 3940, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 17:28:31', 'admin-1477115932-14771285111245977', 1, 1, 'SR', NULL, NULL, NULL),
(10996, '2016-10-22 17:08:02', NULL, NULL, 3939, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 17:08:02', 'admin-1477115932-14771272826008840', 1, 1, 'SR', NULL, NULL, NULL),
(10997, '2016-10-22 17:08:02', NULL, NULL, 3939, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 17:08:02', 'admin-1477115932-14771272826008840', 1, 1, 'SR', NULL, NULL, NULL),
(10998, '2016-10-22 17:00:35', NULL, NULL, 3937, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 17:00:35', 'admin-1477115932-1477126835390658', 1, 1, 'SR', NULL, NULL, NULL),
(10999, '2016-10-22 17:02:40', NULL, NULL, 3938, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 17:02:40', 'admin-1477115932-14771269601823382', 1, 1, 'SR', NULL, NULL, NULL),
(11000, '2016-10-22 09:05:48', NULL, NULL, 3901, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 09:05:48', 'admin-1477098312-1477098347795114', 1, 1, 'SR', NULL, NULL, NULL),
(11001, '2016-10-22 09:07:36', NULL, NULL, 3902, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 09:07:36', 'admin-1477098312-1477098456726466', 1, 0, '', NULL, NULL, NULL),
(11002, '2016-10-22 09:07:36', NULL, NULL, 3902, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 09:07:36', 'admin-1477098312-1477098456726466', 1, 1, 'SR', NULL, NULL, NULL),
(11003, '2016-10-22 09:10:53', NULL, NULL, 3903, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 09:10:53', 'admin-1477098312-14770986534442888', 1, 0, '', NULL, NULL, NULL),
(11004, '2016-10-22 09:10:53', NULL, NULL, 3903, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 09:10:53', 'admin-1477098312-14770986534442888', 1, 0, '', NULL, NULL, NULL),
(11005, '2016-10-22 12:01:38', NULL, NULL, 3914, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 12:01:38', 'admin-1477104610-14771088977737639', 1, 1, 'SR', NULL, NULL, NULL),
(11006, '2016-10-22 16:28:27', NULL, NULL, 3934, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 16:28:27', 'admin-1477115932-14771249068341736', 1, 1, 'SR', NULL, NULL, NULL),
(11007, '2016-10-22 14:59:13', NULL, NULL, 3922, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 14:59:13', 'admin-1477115932-14771195529584890', 1, 0, '', NULL, NULL, NULL),
(11008, '2016-10-22 14:31:36', NULL, NULL, 3925, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 14:31:36', 'admin-1477115932-14771178959202157', 1, 1, 'SR', NULL, NULL, NULL),
(11009, '2016-10-22 14:25:29', NULL, NULL, 3924, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 14:25:29', 'admin-1477115932-14771175293769748', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(11010, '2016-10-22 14:24:49', NULL, NULL, 3923, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 14:24:49', 'admin-1477115932-14771174896252051', 1, 1, 'SR', NULL, NULL, NULL),
(11011, '2016-10-22 14:24:29', NULL, NULL, 3923, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 14:24:29', 'admin-1477115932-14771174697173672', 1, 0, '', NULL, NULL, NULL),
(11012, '2016-10-22 14:24:29', NULL, NULL, 3923, 0, 86, '86', 'Pesto Pasta ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 14:24:29', 'admin-1477115932-14771174697173672', 1, 1, 'SR', NULL, NULL, NULL),
(11013, '2016-10-22 13:50:59', NULL, NULL, 3922, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 13:50:59', 'admin-1477104610-14771154593166943', 1, 1, 'SR', NULL, NULL, NULL),
(11014, '2016-10-22 13:50:59', NULL, NULL, 3922, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 13:50:59', 'admin-1477104610-14771154593166943', 1, 1, 'SR', NULL, NULL, NULL),
(11015, '2016-10-22 13:44:16', NULL, NULL, 3921, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 13:44:16', 'admin-1477104610-1477115056637243', 1, 1, 'SR', 1, NULL, NULL),
(11016, '2016-10-22 13:50:59', NULL, NULL, 3922, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 13:50:59', 'admin-1477104610-14771154593166943', 1, 0, '', NULL, NULL, NULL),
(11017, '2016-10-22 13:50:59', NULL, NULL, 3922, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 13:50:59', 'admin-1477104610-14771154593166943', 1, 1, 'SR', NULL, NULL, NULL),
(11018, '2016-10-22 13:34:42', NULL, NULL, 3919, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 13:34:42', 'admin-1477104610-1477114482530545', 1, 1, 'SR', 1, NULL, NULL),
(11019, '2016-10-22 13:43:55', NULL, NULL, 3914, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 13:43:55', 'admin-1477104610-14771150350861637', 1, 0, '', NULL, NULL, NULL),
(11020, '2016-10-22 13:43:55', NULL, NULL, 3914, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 13:43:55', 'admin-1477104610-14771150350861637', 1, 0, '', NULL, NULL, NULL),
(11021, '2016-10-22 13:43:55', NULL, NULL, 3914, 0, 181, '116', 'Open Food ', 'Fried Egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1477129686', 'admin', '2016-10-22 13:43:55', 'admin-1477104610-14771150350861637', 1, 0, '', NULL, NULL, NULL),
(11022, '2016-10-22 14:59:22', NULL, NULL, 3922, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 14:59:22', 'admin-1477115932-14771195619551175', 1, 1, 'SR', NULL, NULL, NULL),
(11023, '2016-10-22 10:49:08', NULL, NULL, 3906, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 10:49:08', 'admin-1477098312-14771045481005655', 1, 1, 'SR', NULL, NULL, NULL),
(11024, '2016-10-22 10:50:01', NULL, NULL, 3907, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 10:50:01', 'admin-1477098312-14771046014874292', 1, 0, '', NULL, NULL, NULL),
(11025, '2016-10-22 10:50:01', NULL, NULL, 3907, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 10:50:01', 'admin-1477098312-14771046014874292', 1, 1, 'SR', NULL, NULL, NULL),
(11026, '2016-10-22 10:50:01', NULL, NULL, 3907, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 10:50:01', 'admin-1477098312-14771046014874292', 1, 1, 'SR', NULL, NULL, NULL),
(11027, '2016-10-22 10:58:08', NULL, NULL, 3908, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 10:58:08', 'admin-1477104610-14771050885588838', 1, 1, 'SR', NULL, NULL, NULL),
(11028, '2016-10-22 11:26:30', NULL, NULL, 3909, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 11:26:30', 'admin-1477104610-14771067898477535', 1, 1, 'SR', NULL, NULL, NULL),
(11029, '2016-10-22 11:26:30', NULL, NULL, 3909, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 11:26:30', 'admin-1477104610-14771067898477535', 1, 1, 'SR', NULL, NULL, NULL),
(11030, '2016-10-22 11:26:30', NULL, NULL, 3909, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 11:26:30', 'admin-1477104610-14771067898477535', 1, 0, '', NULL, NULL, NULL),
(11031, '2016-10-22 11:36:47', NULL, NULL, 3910, 0, 82, '82', 'Set Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 11:36:47', 'admin-1477104610-1477107406941347', 1, 1, 'SR', NULL, NULL, NULL),
(11032, '2016-10-22 11:36:47', NULL, NULL, 3910, 0, 82, '82', 'Set Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 11:36:47', 'admin-1477104610-1477107406941347', 1, 1, 'SR', NULL, NULL, NULL),
(11033, '2016-10-22 11:37:06', NULL, NULL, 3910, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 11:37:06', 'admin-1477104610-14771074267087478', 1, 0, '', NULL, NULL, NULL),
(11034, '2016-10-22 11:37:55', NULL, NULL, 3911, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 11:37:55', 'admin-1477104610-14771074754439760', 1, 0, '', NULL, NULL, NULL),
(11035, '2016-10-22 11:37:55', NULL, NULL, 3911, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 11:37:55', 'admin-1477104610-14771074754439760', 1, 0, '', NULL, NULL, NULL),
(11036, '2016-10-22 11:38:07', NULL, NULL, 3911, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 11:38:07', 'admin-1477104610-14771074869289847', 1, 0, '', NULL, NULL, NULL),
(11037, '2016-10-22 11:38:14', NULL, NULL, 3911, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 11:38:14', 'admin-1477104610-14771074942043133', 1, 1, 'SR', NULL, NULL, NULL),
(11038, '2016-10-22 11:38:14', NULL, NULL, 3911, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 11:38:14', 'admin-1477104610-14771074942043133', 1, 1, 'SR', NULL, NULL, NULL),
(11039, '2016-10-22 11:38:46', NULL, NULL, 3910, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 11:38:46', 'admin-1477104610-14771075258089950', 1, 1, 'SR', NULL, NULL, NULL),
(11040, '2016-10-22 11:46:38', NULL, NULL, 3912, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 11:46:38', 'admin-1477104610-14771079983924618', 1, 1, 'SR', NULL, NULL, NULL),
(11041, '2016-10-22 11:46:38', NULL, NULL, 3912, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 11:46:38', 'admin-1477104610-14771079983924618', 1, 1, 'SR', NULL, NULL, NULL),
(11042, '2016-10-22 11:57:25', NULL, NULL, 3913, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 11:57:25', 'admin-1477104610-14771086453377710', 1, 0, '', NULL, NULL, NULL),
(11043, '2016-10-22 12:00:55', NULL, NULL, 3914, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 12:00:55', 'admin-1477104610-1477108854863768', 1, 1, 'SR', NULL, NULL, NULL),
(11044, '2016-10-22 12:00:55', NULL, NULL, 3914, 0, 222, '156', 'Seasoned Chicken Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 12:00:55', 'admin-1477104610-1477108854863768', 1, 0, '', NULL, NULL, NULL),
(11045, '2016-10-22 12:00:55', NULL, NULL, 3914, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 12:00:55', 'admin-1477104610-1477108854863768', 1, 1, 'SR', NULL, NULL, NULL),
(11046, '2016-10-22 11:57:25', NULL, NULL, 3913, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 11:57:25', 'admin-1477104610-14771086453377710', 1, 1, 'SR', NULL, NULL, NULL),
(11047, '2016-10-22 11:57:25', NULL, NULL, 3913, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 11:57:25', 'admin-1477104610-14771086453377710', 1, 0, '', NULL, NULL, NULL),
(11048, '2016-10-22 11:57:25', NULL, NULL, 3913, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 11:57:25', 'admin-1477104610-14771086453377710', 1, 1, 'SR', NULL, NULL, NULL),
(11049, '2016-10-22 11:57:25', NULL, NULL, 3913, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 11:57:25', 'admin-1477104610-14771086453377710', 1, 1, 'SR', NULL, NULL, NULL),
(11050, '2016-10-22 09:05:37', NULL, NULL, 3901, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 09:05:37', 'admin-1477098312-14770983377057966', 1, 0, '', NULL, NULL, NULL),
(11051, '2016-10-22 09:05:37', NULL, NULL, 3901, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 09:05:37', 'admin-1477098312-14770983377057966', 1, 0, '', NULL, NULL, NULL),
(11052, '2016-10-22 09:05:48', NULL, NULL, 3901, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 09:05:48', 'admin-1477098312-1477098347795114', 1, 1, 'SR', NULL, NULL, NULL),
(11053, '2016-10-22 13:34:42', NULL, NULL, 3919, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 13:34:42', 'admin-1477104610-1477114482530545', 1, 1, 'SR', 1, NULL, NULL),
(11054, '2016-10-22 09:10:59', NULL, NULL, 3903, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 09:10:59', 'admin-1477098312-14770986592401939', 1, 1, 'SR', NULL, NULL, NULL),
(11055, '2016-10-22 09:05:48', NULL, NULL, 3901, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 09:05:48', 'admin-1477098312-1477098347795114', 1, 1, 'SR', NULL, NULL, NULL),
(11056, '2016-10-22 09:05:37', NULL, NULL, 3901, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477129686', 'admin', '2016-10-22 09:05:37', 'admin-1477098312-14770983377057966', 1, 0, '', NULL, NULL, NULL),
(11057, '2016-10-23 20:36:04', NULL, NULL, 4003, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 20:36:04', 'admin-1477219527-1477226163825752', 1, 1, 'SR', NULL, NULL, NULL),
(11058, '2016-10-23 14:49:53', NULL, NULL, 3990, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 14:49:53', 'admin-1477200211-14772053930456352', 1, 0, '', NULL, NULL, NULL),
(11059, '2016-10-23 14:49:53', NULL, NULL, 3990, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 14:49:53', 'admin-1477200211-14772053930456352', 1, 0, '', NULL, NULL, NULL),
(11060, '2016-10-23 14:50:50', NULL, NULL, 3990, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 14:50:50', 'admin-1477200211-14772054499613665', 1, 0, '', NULL, NULL, NULL),
(11061, '2016-10-23 14:50:50', NULL, NULL, 3990, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 14:50:50', 'admin-1477200211-14772054499613665', 1, 1, 'SR', NULL, NULL, NULL),
(11062, '2016-10-23 14:50:50', NULL, NULL, 3990, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 14:50:50', 'admin-1477200211-14772054499613665', 1, 0, '', NULL, NULL, NULL),
(11063, '2016-10-23 15:02:00', NULL, NULL, 3991, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 15:02:00', 'admin-1477200211-1477206120827625', 1, 0, '', NULL, NULL, NULL),
(11064, '2016-10-23 15:02:00', NULL, NULL, 3991, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 15:02:00', 'admin-1477200211-1477206120827625', 1, 1, 'SR', NULL, NULL, NULL),
(11065, '2016-10-23 15:34:23', NULL, NULL, 3990, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 15:34:23', 'admin-1477200211-14772080630378744', 1, 0, '', NULL, NULL, NULL),
(11066, '2016-10-23 15:34:23', NULL, NULL, 3990, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 15:34:23', 'admin-1477200211-14772080630378744', 1, 0, '', NULL, NULL, NULL),
(11067, '2016-10-23 15:40:37', NULL, NULL, 3992, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 15:40:37', 'admin-1477200211-14772084374506996', 1, 1, 'SR', NULL, NULL, NULL),
(11068, '2016-10-23 15:40:37', NULL, NULL, 3992, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 15:40:37', 'admin-1477200211-14772084374506996', 1, 1, 'SR', NULL, NULL, NULL),
(11069, '2016-10-23 16:26:31', NULL, NULL, 3993, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 16:26:31', 'admin-1477200211-14772111915126741', 1, 1, 'SR', NULL, NULL, NULL),
(11070, '2016-10-23 20:26:55', NULL, NULL, 4002, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 20:26:55', 'admin-1477219527-14772256148155996', 1, 1, 'SR', NULL, NULL, NULL),
(11071, '2016-10-23 20:26:54', NULL, NULL, 4002, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 20:26:54', 'admin-1477219527-14772256148155996', 1, 1, 'SR', NULL, NULL, NULL),
(11072, '2016-10-23 20:26:45', NULL, NULL, 4002, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 20:26:45', 'admin-1477219527-14772256056198837', 1, 1, 'SR', NULL, NULL, NULL),
(11073, '2016-10-23 20:26:45', NULL, NULL, 4002, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 20:26:45', 'admin-1477219527-14772256056198837', 1, 0, '', NULL, NULL, NULL),
(11074, '2016-10-23 20:26:32', NULL, NULL, 4002, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 20:26:32', 'admin-1477219527-14772255922896215', 1, 0, '', NULL, NULL, NULL),
(11075, '2016-10-23 18:56:19', NULL, NULL, 4001, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 18:56:19', 'admin-1477219527-14772201791663180', 1, 0, '', NULL, NULL, NULL),
(11076, '2016-10-23 18:54:10', NULL, NULL, 4001, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 18:54:10', 'admin-1477219527-14772200499317788', 1, 1, 'SR', NULL, NULL, NULL),
(11077, '2016-10-23 18:45:18', NULL, NULL, 4000, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 18:45:18', 'admin-1477200211-14772195179386654', 1, 1, 'SR', NULL, NULL, NULL),
(11078, '2016-10-23 18:45:18', NULL, NULL, 4000, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 18:45:18', 'admin-1477200211-14772195179386654', 1, 0, '', NULL, NULL, NULL),
(11079, '2016-10-23 18:45:18', NULL, NULL, 4000, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 18:45:18', 'admin-1477200211-14772195179386654', 1, 0, '', NULL, NULL, NULL),
(11080, '2016-10-23 18:45:18', NULL, NULL, 4000, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 18:45:18', 'admin-1477200211-14772195179386654', 1, 1, 'SR', NULL, NULL, NULL),
(11081, '2016-10-23 18:42:08', NULL, NULL, 4000, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 18:42:08', 'admin-1477200211-14772193278499089', 1, 1, 'SR', NULL, NULL, NULL),
(11082, '2016-10-23 18:38:24', NULL, NULL, 3999, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 18:38:24', 'admin-1477200211-14772191038864349', 1, 0, '', NULL, NULL, NULL),
(11083, '2016-10-23 18:22:41', NULL, NULL, 3998, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 18:22:41', 'admin-1477200211-14772181614465816', 1, 1, 'SR', NULL, NULL, NULL),
(11084, '2016-10-23 18:22:41', NULL, NULL, 3998, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 18:22:41', 'admin-1477200211-14772181614465816', 1, 1, 'SR', NULL, NULL, NULL),
(11085, '2016-10-23 18:22:41', NULL, NULL, 3998, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 18:22:41', 'admin-1477200211-14772181614465816', 1, 1, 'SR', NULL, NULL, NULL),
(11086, '2016-10-23 18:22:25', NULL, NULL, 3998, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 18:22:25', 'admin-1477200211-14772181449845615', 1, 0, '', NULL, NULL, NULL),
(11087, '2016-10-23 18:16:17', NULL, NULL, 3995, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 18:16:17', 'admin-1477200211-1477217777741242', 1, 1, 'SR', NULL, NULL, NULL),
(11088, '2016-10-23 18:16:17', NULL, NULL, 3995, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 18:16:17', 'admin-1477200211-1477217777741242', 1, 1, 'SR', NULL, NULL, NULL),
(11089, '2016-10-23 18:10:51', NULL, NULL, 3997, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 18:10:51', 'admin-1477200211-14772174510127098', 1, 1, 'SR', NULL, NULL, NULL),
(11090, '2016-10-23 18:10:51', NULL, NULL, 3997, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 18:10:51', 'admin-1477200211-14772174510127098', 1, 1, 'SR', NULL, NULL, NULL),
(11091, '2016-10-23 18:08:10', NULL, NULL, 3996, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 18:08:10', 'admin-1477200211-14772172900417664', 1, 1, 'SR', 1, NULL, NULL),
(11092, '2016-10-23 18:08:10', NULL, NULL, 3996, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 18:08:10', 'admin-1477200211-14772172900417664', 1, 1, 'SR', 1, NULL, NULL),
(11093, '2016-10-23 17:16:47', NULL, NULL, 3995, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 17:16:47', 'admin-1477200211-14772142068937287', 1, 0, '', NULL, NULL, NULL),
(11094, '2016-10-23 17:16:18', NULL, NULL, 3995, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 17:16:18', 'admin-1477200211-14772141778832420', 1, 0, '', NULL, NULL, NULL),
(11095, '2016-10-23 17:16:18', NULL, NULL, 3995, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 17:16:18', 'admin-1477200211-14772141778832420', 1, 1, 'SR', NULL, NULL, NULL),
(11096, '2016-10-23 16:26:56', NULL, NULL, 3993, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 16:26:56', 'admin-1477200211-1477211215923215', 1, 0, '', NULL, NULL, NULL),
(11097, '2016-10-23 16:33:45', NULL, NULL, 3994, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 16:33:45', 'admin-1477200211-1477211625101348', 1, 1, 'SR', NULL, NULL, NULL),
(11098, '2016-10-23 17:16:18', NULL, NULL, 3995, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 17:16:18', 'admin-1477200211-14772141778832420', 1, 1, 'SR', NULL, NULL, NULL),
(11099, '2016-10-23 14:16:28', NULL, NULL, 3988, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 14:16:28', 'admin-1477200211-14772033887378948', 1, 1, 'SR', NULL, NULL, NULL),
(11100, '2016-10-23 14:04:40', NULL, NULL, 3987, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 14:04:40', 'admin-1477200211-14772026804783865', 1, 1, 'SR', 1, NULL, NULL),
(11101, '2016-10-23 14:03:04', NULL, NULL, 3986, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 14:03:04', 'admin-1477200211-14772025841684545', 1, 0, '', 1, NULL, NULL),
(11102, '2016-10-23 13:54:27', NULL, NULL, 3981, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:54:27', 'admin-1477200211-14772020670042519', 1, 0, '', NULL, NULL, NULL),
(11103, '2016-10-23 13:54:14', NULL, NULL, 3981, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:54:14', 'admin-1477200211-14772020546975987', 1, 0, '', NULL, NULL, NULL),
(11104, '2016-10-23 13:48:45', NULL, NULL, 3982, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:48:45', 'admin-1477200211-14772017256159733', 1, 0, '', NULL, NULL, NULL),
(11105, '2016-10-23 13:48:45', NULL, NULL, 3982, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:48:45', 'admin-1477200211-14772017256159733', 1, 0, '', NULL, NULL, NULL),
(11106, '2016-10-23 13:38:42', NULL, NULL, 3981, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:38:42', 'admin-1477200211-14772011217576746', 1, 1, 'SR', NULL, NULL, NULL),
(11107, '2016-10-23 13:12:12', NULL, NULL, 3979, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:12:12', 'admin-1477198892-14771995327518237', 1, 0, '', NULL, NULL, NULL),
(11108, '2016-10-23 16:26:31', NULL, NULL, 3993, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 16:26:31', 'admin-1477200211-14772111915126741', 1, 1, 'SR', NULL, NULL, NULL),
(11109, '2016-10-23 14:16:28', NULL, NULL, 3988, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 14:16:28', 'admin-1477200211-14772033887378948', 1, 1, 'SR', NULL, NULL, NULL),
(11110, '2016-10-23 14:16:28', NULL, NULL, 3988, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 14:16:28', 'admin-1477200211-14772033887378948', 1, 1, 'SR', NULL, NULL, NULL),
(11111, '2016-10-23 13:28:53', NULL, NULL, 3981, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:28:53', 'admin-1477200211-14772005336523742', 1, 1, 'SR', NULL, NULL, NULL),
(11112, '2016-10-23 13:23:21', NULL, NULL, 3982, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:23:21', 'admin-1477198892-14772002012536449', 1, 1, 'SR', NULL, NULL, NULL),
(11113, '2016-10-23 13:28:53', NULL, NULL, 3981, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:28:53', 'admin-1477200211-14772005336523742', 1, 1, 'SR', NULL, NULL, NULL),
(11114, '2016-10-23 13:22:37', NULL, NULL, 3985, 0, 79, '79', 'Summer Salad ', 'dressing aside', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:22:37', 'admin-1477198892-14772001575636642', 1, 1, 'SR', NULL, NULL, NULL),
(11115, '2016-10-23 13:23:21', NULL, NULL, 3982, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:23:21', 'admin-1477198892-14772002012536449', 1, 1, 'SR', NULL, NULL, NULL),
(11116, '2016-10-23 13:21:15', NULL, NULL, 3984, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:21:15', 'admin-1477198892-14772000753322150', 1, 1, 'SR', NULL, NULL, NULL),
(11117, '2016-10-23 00:00:00', NULL, NULL, 3972, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:02:29', 'admin-1477191161-1477191749491839', 1, 1, 'SR', NULL, NULL, NULL),
(11118, '2016-10-23 10:05:25', NULL, NULL, 3957, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:05:25', 'admin-1477187734-14771883257549862', 1, 0, '', NULL, NULL, NULL),
(11119, '2016-10-23 10:06:09', NULL, NULL, 3957, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:06:09', 'admin-1477187734-1477188369387335', 1, 1, 'SR', NULL, NULL, NULL),
(11120, '2016-10-23 10:06:09', NULL, NULL, 3957, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:06:09', 'admin-1477187734-1477188369387335', 1, 1, 'SR', NULL, NULL, NULL),
(11121, '2016-10-23 10:06:09', NULL, NULL, 3957, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:06:09', 'admin-1477187734-1477188369387335', 1, 1, 'SR', NULL, NULL, NULL),
(11122, '2016-10-23 10:06:09', NULL, NULL, 3957, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:06:09', 'admin-1477187734-1477188369387335', 1, 1, 'SR', NULL, NULL, NULL),
(11123, '2016-10-23 10:09:04', NULL, NULL, 3958, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:09:04', 'admin-1477187734-14771885440528785', 1, 1, 'SR', NULL, NULL, NULL),
(11124, '2016-10-23 09:07:41', NULL, NULL, 3951, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 09:07:41', 'admin-1477184354-14771848609282031', 1, 0, '', NULL, NULL, NULL),
(11125, '2016-10-23 09:07:41', NULL, NULL, 3951, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 09:07:41', 'admin-1477184354-14771848609282031', 1, 1, 'SR', NULL, NULL, NULL),
(11126, '2016-10-23 09:07:41', NULL, NULL, 3951, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 09:07:41', 'admin-1477184354-14771848609282031', 1, 1, 'SR', NULL, NULL, NULL),
(11127, '2016-10-23 09:07:41', NULL, NULL, 3951, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 09:07:41', 'admin-1477184354-14771848609282031', 1, 1, 'SR', NULL, NULL, NULL),
(11128, '2016-10-23 09:07:41', NULL, NULL, 3951, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 09:07:41', 'admin-1477184354-14771848609282031', 1, 1, 'SR', NULL, NULL, NULL),
(11129, '2016-10-23 09:10:05', NULL, NULL, 3952, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 09:10:05', 'admin-1477184354-1477185005022467', 1, 1, 'SR', NULL, NULL, NULL),
(11130, '2016-10-23 13:20:37', NULL, NULL, 3983, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:20:37', 'admin-1477198892-1477200036883167', 1, 0, '', NULL, NULL, NULL),
(11131, '2016-10-23 13:17:05', NULL, NULL, 3982, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:17:05', 'admin-1477198892-14771998257287191', 1, 1, 'SR', NULL, NULL, NULL),
(11132, '2016-10-23 13:08:59', NULL, NULL, 3982, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:08:59', 'admin-1477198892-14771993391297958', 1, 1, 'SR', NULL, NULL, NULL),
(11133, '2016-10-23 13:08:59', NULL, NULL, 3982, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:08:59', 'admin-1477198892-14771993391297958', 1, 1, 'SR', NULL, NULL, NULL),
(11134, '2016-10-23 13:08:59', NULL, NULL, 3982, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:08:59', 'admin-1477198892-14771993391297958', 1, 0, '', NULL, NULL, NULL),
(11135, '2016-10-23 13:08:59', NULL, NULL, 3982, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:08:59', 'admin-1477198892-14771993391297958', 1, 0, '', NULL, NULL, NULL),
(11136, '2016-10-23 13:10:12', NULL, NULL, 3982, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:10:12', 'admin-1477198892-1477199412644390', 1, 0, '', NULL, NULL, NULL),
(11137, '2016-10-23 13:07:37', NULL, NULL, 3981, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:07:37', 'admin-1477198892-14771992570933694', 1, 1, 'SR', NULL, NULL, NULL),
(11138, '2016-10-23 13:10:12', NULL, NULL, 3982, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:10:12', 'admin-1477198892-1477199412644390', 1, 1, 'SR', NULL, NULL, NULL),
(11139, '2016-10-23 13:10:12', NULL, NULL, 3982, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:10:12', 'admin-1477198892-1477199412644390', 1, 1, 'SR', NULL, NULL, NULL),
(11140, '2016-10-23 13:33:56', NULL, NULL, 3981, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:33:56', 'admin-1477200211-14772008360094825', 1, 1, 'SR', NULL, NULL, NULL),
(11141, '2016-10-23 13:08:59', NULL, NULL, 3982, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:08:59', 'admin-1477198892-14771993391297958', 1, 1, 'SR', NULL, NULL, NULL),
(11142, '2016-10-23 13:08:09', NULL, NULL, 3981, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:08:09', 'admin-1477198892-14771992892166422', 1, 1, 'SR', NULL, NULL, NULL),
(11143, '2016-10-23 13:08:09', NULL, NULL, 3981, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:08:09', 'admin-1477198892-14771992892166422', 1, 1, 'SR', NULL, NULL, NULL),
(11144, '2016-10-23 13:07:37', NULL, NULL, 3981, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:07:37', 'admin-1477198892-14771992570933694', 1, 1, 'SR', NULL, NULL, NULL),
(11145, '2016-10-23 13:07:37', NULL, NULL, 3981, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:07:37', 'admin-1477198892-14771992570933694', 1, 0, '', NULL, NULL, NULL),
(11146, '2016-10-23 13:07:37', NULL, NULL, 3981, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:07:37', 'admin-1477198892-14771992570933694', 1, 0, '', NULL, NULL, NULL),
(11147, '2016-10-23 12:21:12', NULL, NULL, 3975, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:21:12', 'admin-1477196420-14771964728022951', 1, 0, '', NULL, NULL, NULL),
(11148, '2016-10-23 12:23:21', NULL, NULL, 3976, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:23:21', 'admin-1477196420-1477196601522869', 1, 1, 'SR', NULL, NULL, NULL),
(11149, '2016-10-23 12:23:21', NULL, NULL, 3976, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:23:21', 'admin-1477196420-1477196601522869', 1, 0, '', NULL, NULL, NULL),
(11150, '2016-10-23 12:28:58', NULL, NULL, 3974, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:28:58', 'admin-1477196420-14771969385428965', 1, 0, '', NULL, NULL, NULL),
(11151, '2016-10-23 12:37:30', NULL, NULL, 3971, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:37:30', 'admin-1477196420-14771974500016562', 1, 0, '', NULL, NULL, NULL),
(11152, '2016-10-23 12:57:09', NULL, NULL, 3979, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:57:09', 'admin-1477196420-14771986288971956', 1, 1, 'SR', NULL, NULL, NULL),
(11153, '2016-10-23 13:07:37', NULL, NULL, 3981, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:07:37', 'admin-1477198892-14771992570933694', 1, 1, 'SR', NULL, NULL, NULL),
(11154, '2016-10-23 12:57:09', NULL, NULL, 3979, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:57:09', 'admin-1477196420-14771986288971956', 1, 0, '', NULL, NULL, NULL),
(11155, '2016-10-23 00:00:00', NULL, NULL, 3972, 0, 155, '89', 'Joyous Sunny ', 'add sausage', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:21:22', 'admin-1477191161-14771928821996044', 1, 0, '', NULL, NULL, NULL),
(11156, '2016-10-23 11:03:10', NULL, NULL, 3965, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:03:10', 'admin-1477191161-14771917898818852', 1, 0, '', NULL, NULL, NULL),
(11157, '2016-10-23 11:14:14', NULL, NULL, 3967, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:14:14', 'admin-1477191161-1477192453909253', 1, 1, 'SR', NULL, NULL, NULL),
(11158, '2016-10-23 11:14:14', NULL, NULL, 3967, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:14:14', 'admin-1477191161-1477192453909253', 1, 0, '', NULL, NULL, NULL),
(11159, '2016-10-23 11:18:09', NULL, NULL, 3968, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:18:09', 'admin-1477191161-14771926891762226', 1, 0, '', NULL, NULL, NULL),
(11160, '2016-10-23 11:18:09', NULL, NULL, 3968, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:18:09', 'admin-1477191161-14771926891762226', 1, 0, '', NULL, NULL, NULL),
(11161, '2016-10-23 11:18:09', NULL, NULL, 3968, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:18:09', 'admin-1477191161-14771926891762226', 1, 1, 'SR', NULL, NULL, NULL),
(11162, '2016-10-23 11:18:09', NULL, NULL, 3968, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:18:09', 'admin-1477191161-14771926891762226', 1, 1, 'SR', NULL, NULL, NULL),
(11163, '2016-10-23 00:00:00', NULL, NULL, 3972, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:07:53', 'admin-1477191161-14771920735225386', 1, 1, 'SR', NULL, NULL, NULL),
(11164, '2016-10-23 12:20:03', NULL, NULL, 3974, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:20:03', 'admin-1477191161-14771964037642923', 1, 1, 'SR', NULL, NULL, NULL),
(11165, '2016-10-23 13:01:44', NULL, NULL, 3980, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:01:44', 'admin-1477198892-14771989041639167', 1, 0, '', NULL, NULL, NULL),
(11166, '2016-10-23 12:57:09', NULL, NULL, 3979, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:57:09', 'admin-1477196420-14771986288971956', 1, 1, 'SR', NULL, NULL, NULL),
(11167, '2016-10-23 13:08:09', NULL, NULL, 3981, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 13:08:09', 'admin-1477198892-14771992892166422', 1, 1, 'SR', NULL, NULL, NULL),
(11168, '2016-10-23 12:57:09', NULL, NULL, 3979, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:57:09', 'admin-1477196420-14771986288971956', 1, 1, 'SR', NULL, NULL, NULL),
(11169, '2016-10-23 12:44:54', NULL, NULL, 3978, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:44:54', 'admin-1477196420-14771978945354161', 1, 1, 'SR', NULL, NULL, NULL),
(11170, '2016-10-23 11:42:45', NULL, NULL, 3970, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:42:45', 'admin-1477191161-14771941657211829', 1, 0, '', NULL, NULL, NULL),
(11171, '2016-10-23 11:42:45', NULL, NULL, 3970, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:42:45', 'admin-1477191161-14771941657211829', 1, 0, '', NULL, NULL, NULL),
(11172, '2016-10-23 12:28:41', NULL, NULL, 3977, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:28:41', 'admin-1477196420-14771969215503049', 1, 0, '', NULL, NULL, NULL),
(11173, '2016-10-23 11:43:56', NULL, NULL, 3971, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:43:56', 'admin-1477191161-14771942364631164', 1, 1, 'SR', NULL, NULL, NULL),
(11174, '2016-10-23 11:43:56', NULL, NULL, 3971, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:43:56', 'admin-1477191161-14771942364631164', 1, 0, '', NULL, NULL, NULL),
(11175, '2016-10-23 11:43:56', NULL, NULL, 3971, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:43:56', 'admin-1477191161-14771942364631164', 1, 1, 'SR', NULL, NULL, NULL),
(11176, '2016-10-23 12:20:55', NULL, NULL, 3974, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:20:55', 'admin-1477196420-14771964554781355', 1, 1, 'SR', NULL, NULL, NULL),
(11177, '2016-10-23 12:21:12', NULL, NULL, 3975, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:21:12', 'admin-1477196420-14771964728022951', 1, 1, 'SR', NULL, NULL, NULL),
(11178, '2016-10-23 12:21:12', NULL, NULL, 3975, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:21:12', 'admin-1477196420-14771964728022951', 1, 1, 'SR', NULL, NULL, NULL),
(11179, '2016-10-23 12:20:55', NULL, NULL, 3974, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:20:55', 'admin-1477196420-14771964554781355', 1, 1, 'SR', NULL, NULL, NULL),
(11180, '2016-10-23 12:20:55', NULL, NULL, 3974, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:20:55', 'admin-1477196420-14771964554781355', 1, 1, 'SR', NULL, NULL, NULL),
(11181, '2016-10-23 12:20:55', NULL, NULL, 3974, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:20:55', 'admin-1477196420-14771964554781355', 1, 1, 'SR', NULL, NULL, NULL),
(11182, '2016-10-23 12:20:55', NULL, NULL, 3974, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:20:55', 'admin-1477196420-14771964554781355', 1, 1, 'SR', NULL, NULL, NULL),
(11183, '2016-10-23 12:20:55', NULL, NULL, 3974, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:20:55', 'admin-1477196420-14771964554781355', 1, 1, 'SR', NULL, NULL, NULL),
(11184, '2016-10-23 12:20:04', NULL, NULL, 3974, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:20:04', 'admin-1477191161-14771964037642923', 1, 1, 'SR', NULL, NULL, NULL),
(11185, '2016-10-23 12:20:03', NULL, NULL, 3974, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:20:03', 'admin-1477191161-14771964037642923', 1, 1, 'SR', NULL, NULL, NULL),
(11186, '2016-10-23 12:20:03', NULL, NULL, 3974, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:20:03', 'admin-1477191161-14771964037642923', 1, 1, 'SR', NULL, NULL, NULL),
(11187, '2016-10-23 12:44:54', NULL, NULL, 3978, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:44:54', 'admin-1477196420-14771978945354161', 1, 1, 'SR', NULL, NULL, NULL),
(11188, '2016-10-23 12:44:54', NULL, NULL, 3978, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:44:54', 'admin-1477196420-14771978945354161', 1, 0, '', NULL, NULL, NULL),
(11189, '2016-10-23 11:06:56', NULL, NULL, 3966, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:06:56', 'admin-1477191161-14771920163943543', 1, 0, '', NULL, NULL, NULL),
(11190, '2016-10-23 11:06:56', NULL, NULL, 3966, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:06:56', 'admin-1477191161-14771920163943543', 1, 0, '', NULL, NULL, NULL),
(11191, '2016-10-23 11:06:56', NULL, NULL, 3966, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:06:56', 'admin-1477191161-14771920163943543', 1, 1, 'SR', NULL, NULL, NULL),
(11192, '2016-10-23 11:06:56', NULL, NULL, 3966, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:06:56', 'admin-1477191161-14771920163943543', 1, 1, 'SR', NULL, NULL, NULL),
(11193, '2016-10-23 12:20:03', NULL, NULL, 3974, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:20:03', 'admin-1477191161-14771964037642923', 1, 1, 'SR', NULL, NULL, NULL),
(11194, '2016-10-23 12:19:01', NULL, NULL, 3973, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:19:01', 'admin-1477191161-1477196341620149', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(11195, '2016-10-23 11:14:14', NULL, NULL, 3967, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:14:14', 'admin-1477191161-1477192453909253', 1, 1, 'SR', NULL, NULL, NULL),
(11196, '2016-10-23 11:40:12', NULL, NULL, 3969, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:40:12', 'admin-1477191161-14771940125253127', 1, 1, 'SR', NULL, NULL, NULL),
(11197, '2016-10-23 11:42:45', NULL, NULL, 3970, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:42:45', 'admin-1477191161-14771941657211829', 1, 0, '', NULL, NULL, NULL),
(11198, '2016-10-23 11:03:10', NULL, NULL, 3965, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:03:10', 'admin-1477191161-14771917898818852', 1, 1, 'SR', NULL, NULL, NULL),
(11199, '2016-10-23 12:19:01', NULL, NULL, 3973, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:19:01', 'admin-1477191161-1477196341620149', 1, 1, 'SR', NULL, NULL, NULL),
(11200, '2016-10-23 11:40:06', NULL, NULL, 3969, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:40:06', 'admin-1477191161-14771940061618056', 1, 0, '', NULL, NULL, NULL),
(11201, '2016-10-23 11:40:06', NULL, NULL, 3969, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:40:06', 'admin-1477191161-14771940061618056', 1, 0, '', NULL, NULL, NULL),
(11202, '2016-10-23 09:10:05', NULL, NULL, 3952, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 09:10:05', 'admin-1477184354-1477185005022467', 1, 0, '', NULL, NULL, NULL),
(11203, '2016-10-23 09:17:14', NULL, NULL, 3951, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 09:17:14', 'admin-1477184354-14771854340513191', 1, 1, 'SR', NULL, NULL, NULL),
(11204, '2016-10-23 09:17:24', NULL, NULL, 3953, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 09:17:24', 'admin-1477184354-1477185444242165', 1, 0, '', NULL, NULL, '10.0'),
(11205, '2016-10-23 09:17:24', NULL, NULL, 3953, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 09:17:24', 'admin-1477184354-1477185444242165', 1, 1, 'SR', NULL, NULL, '10.0'),
(11206, '2016-10-23 09:49:56', NULL, NULL, 3954, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 09:49:56', 'admin-1477184354-14771873967542967', 1, 1, 'SR', NULL, NULL, NULL),
(11207, '2016-10-23 12:19:01', NULL, NULL, 3973, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 12:19:01', 'admin-1477191161-1477196341620149', 1, 0, '', NULL, NULL, NULL),
(11208, '2016-10-23 10:55:55', NULL, NULL, 3963, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:55:55', 'admin-1477191161-14771913550225590', 1, 0, '', NULL, NULL, NULL),
(11209, '2016-10-23 10:55:55', NULL, NULL, 3963, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:55:55', 'admin-1477191161-14771913550225590', 1, 0, '', NULL, NULL, NULL),
(11210, '2016-10-23 10:55:55', NULL, NULL, 3963, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:55:55', 'admin-1477191161-14771913550225590', 1, 1, 'SR', NULL, NULL, NULL),
(11211, '2016-10-23 10:55:37', NULL, NULL, 3963, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:55:37', 'admin-1477191161-14771913369905062', 1, 1, 'SR', NULL, NULL, NULL),
(11212, '2016-10-23 10:55:37', NULL, NULL, 3963, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:55:37', 'admin-1477191161-14771913369905062', 1, 0, '', NULL, NULL, NULL),
(11213, '2016-10-23 10:53:48', NULL, NULL, 3953, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:53:48', 'admin-1477191161-14771912286156039', 1, 1, 'SR', NULL, NULL, '10.0'),
(11214, '2016-10-23 10:52:35', NULL, NULL, 3953, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:52:35', 'admin-1477187734-14771911552565376', 1, 0, '', NULL, NULL, '10.0'),
(11215, '2016-10-23 10:33:31', NULL, NULL, 3962, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:33:31', 'admin-1477187734-1477190011389718', 1, 1, 'SR', NULL, NULL, NULL),
(11216, '2016-10-23 10:33:31', NULL, NULL, 3962, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:33:31', 'admin-1477187734-1477190011389718', 1, 1, 'SR', NULL, NULL, NULL),
(11217, '2016-10-23 10:33:31', NULL, NULL, 3962, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:33:31', 'admin-1477187734-1477190011389718', 1, 0, '', NULL, NULL, NULL),
(11218, '2016-10-23 10:23:36', NULL, NULL, 3961, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:23:36', 'admin-1477187734-14771894162368873', 1, 1, 'SR', NULL, NULL, NULL),
(11219, '2016-10-23 10:20:52', NULL, NULL, 3960, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:20:52', 'admin-1477187734-14771892519194946', 1, 0, '', NULL, NULL, NULL),
(11220, '2016-10-23 10:19:38', NULL, NULL, 3959, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:19:38', 'admin-1477187734-1477189178202754', 1, 1, 'SR', NULL, NULL, NULL),
(11221, '2016-10-23 10:19:25', NULL, NULL, 3959, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:19:25', 'admin-1477187734-14771891654915236', 1, 0, '', NULL, NULL, NULL),
(11222, '2016-10-23 10:09:25', NULL, NULL, 3958, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:09:25', 'admin-1477187734-14771885651101830', 1, 0, '', NULL, NULL, NULL),
(11223, '2016-10-23 10:09:04', NULL, NULL, 3958, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:09:04', 'admin-1477187734-14771885440528785', 1, 0, '', NULL, NULL, NULL),
(11224, '2016-10-23 10:09:04', NULL, NULL, 3958, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:09:04', 'admin-1477187734-14771885440528785', 1, 1, 'SR', NULL, NULL, NULL),
(11225, '2016-10-23 10:09:04', NULL, NULL, 3958, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:09:04', 'admin-1477187734-14771885440528785', 1, 1, 'SR', NULL, NULL, NULL),
(11226, '2016-10-23 09:59:27', NULL, NULL, 3956, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 09:59:27', 'admin-1477187734-14771879676452415', 1, 1, 'SR', NULL, NULL, NULL),
(11227, '2016-10-23 10:05:25', NULL, NULL, 3957, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:05:25', 'admin-1477187734-14771883257549862', 1, 0, '', NULL, NULL, NULL),
(11228, '2016-10-23 10:05:25', NULL, NULL, 3957, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:05:25', 'admin-1477187734-14771883257549862', 1, 0, '', NULL, NULL, NULL),
(11229, '2016-10-23 10:05:25', NULL, NULL, 3957, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 10:05:25', 'admin-1477187734-14771883257549862', 1, 0, '', NULL, NULL, NULL),
(11230, '2016-10-23 09:59:18', NULL, NULL, 3956, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 09:59:18', 'admin-1477187734-14771879581044117', 1, 1, 'SR', NULL, NULL, NULL),
(11231, '2016-10-23 09:55:56', NULL, NULL, 3955, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 09:55:56', 'admin-1477187734-14771877557839454', 1, 0, '', NULL, NULL, NULL),
(11232, '2016-10-23 11:03:10', NULL, NULL, 3965, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 11:03:10', 'admin-1477191161-14771917898818852', 1, 0, '', NULL, NULL, NULL),
(11233, '2016-10-23 09:55:55', NULL, NULL, 3955, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 09:55:55', 'admin-1477187734-14771877557839454', 1, 0, '', NULL, NULL, NULL),
(11234, '2016-10-23 09:54:26', NULL, NULL, 3955, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 09:54:26', 'admin-1477187654-14771876658996673', 1, 1, 'SR', NULL, NULL, NULL),
(11235, '2016-10-23 09:54:26', NULL, NULL, 3955, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 09:54:26', 'admin-1477187654-14771876658996673', 1, 1, 'SR', NULL, NULL, NULL),
(11236, '2016-10-23 09:49:56', NULL, NULL, 3954, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 09:49:56', 'admin-1477184354-14771873967542967', 1, 0, '', NULL, NULL, NULL),
(11237, '2016-10-23 09:49:56', NULL, NULL, 3954, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 09:49:56', 'admin-1477184354-14771873967542967', 1, 0, '', NULL, NULL, NULL),
(11238, '2016-10-23 09:07:20', NULL, NULL, 3951, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 09:07:20', 'admin-1477184354-1477184840415878', 1, 0, '', NULL, NULL, NULL),
(11239, '2016-10-23 09:07:20', NULL, NULL, 3951, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 09:07:20', 'admin-1477184354-1477184840415878', 1, 0, '', NULL, NULL, NULL),
(11240, '2016-10-23 09:07:20', NULL, NULL, 3951, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477219527', 'admin', '2016-10-23 09:07:20', 'admin-1477184354-1477184840415878', 1, 0, '', NULL, NULL, NULL),
(11241, '2016-10-24 18:50:50', NULL, NULL, 4030, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 18:50:50', 'admin-1477287332-14773062506545283', 1, 0, '', NULL, NULL, '20.0'),
(11242, '2016-10-24 12:48:37', NULL, NULL, 4017, 0, 156, '90', 'Cheese Omelet', 'no bread', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 12:48:37', 'admin-1477284302-14772845168911412', 1, 0, '', NULL, NULL, NULL),
(11243, '2016-10-24 12:50:03', NULL, NULL, 4018, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 12:50:03', 'admin-1477284302-14772846029514057', 1, 0, '', NULL, NULL, NULL),
(11244, '2016-10-24 12:50:09', NULL, NULL, 4018, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 12:50:09', 'admin-1477284302-1477284608927158', 1, 1, 'SR', NULL, NULL, NULL),
(11245, '2016-10-24 12:52:40', NULL, NULL, 4018, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 12:52:40', 'admin-1477284302-14772847606808898', 1, 1, 'SR', NULL, NULL, NULL),
(11246, '2016-10-24 12:52:40', NULL, NULL, 4018, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 12:52:40', 'admin-1477284302-14772847606808898', 1, 0, '', NULL, NULL, NULL),
(11247, '2016-10-24 13:21:47', NULL, NULL, 4019, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 13:21:47', 'admin-1477284302-14772865071694035', 1, 0, '', NULL, NULL, NULL),
(11248, '2016-10-24 13:21:47', NULL, NULL, 4019, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 13:21:47', 'admin-1477284302-14772865071694035', 1, 1, 'SR', NULL, NULL, NULL),
(11249, '2016-10-24 09:18:45', NULL, NULL, 4004, 0, 156, '90', 'Cheese Omelet', 'Takeaway', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 09:18:45', 'admin-1477271840-14772719256866770', 1, 0, '', NULL, NULL, NULL),
(11250, '2016-10-24 09:47:06', NULL, NULL, 4005, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 09:47:06', 'admin-1477271840-14772736258363995', 1, 0, '', NULL, NULL, NULL),
(11251, '2016-10-24 09:47:06', NULL, NULL, 4005, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 09:47:06', 'admin-1477271840-14772736258363995', 1, 0, '', NULL, NULL, NULL),
(11252, '2016-10-24 09:47:18', NULL, NULL, 4005, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 09:47:18', 'admin-1477271840-14772736383441441', 1, 1, 'SR', NULL, NULL, NULL),
(11253, '2016-10-24 10:01:13', NULL, NULL, 4006, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 10:01:13', 'admin-1477271840-14772744728861169', 1, 1, 'SR', NULL, NULL, NULL),
(11254, '2016-10-24 10:01:13', NULL, NULL, 4006, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 10:01:13', 'admin-1477271840-14772744728861169', 1, 1, 'SR', NULL, NULL, NULL),
(11255, '2016-10-24 20:58:55', NULL, NULL, 4035, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 20:58:55', 'admin-1477310901-14773139354259099', 1, 1, 'SR', NULL, NULL, NULL),
(11256, '2016-10-24 20:58:55', NULL, NULL, 4035, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 20:58:55', 'admin-1477310901-14773139354259099', 1, 1, 'SR', NULL, NULL, NULL),
(11257, '2016-10-24 20:19:22', NULL, NULL, 4035, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 20:19:22', 'admin-1477310901-14773115627317228', 1, 0, '', NULL, NULL, NULL),
(11258, '2016-10-24 20:31:18', NULL, NULL, 4035, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 20:31:18', 'admin-1477310901-1477312278064734', 1, 1, 'SR', NULL, NULL, NULL),
(11259, '2016-10-24 20:58:55', NULL, NULL, 4035, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 20:58:55', 'admin-1477310901-14773139354259099', 1, 1, 'SR', NULL, NULL, NULL),
(11260, '2016-10-24 20:58:55', NULL, NULL, 4035, 0, 182, '117', 'Open Drinks ', 'LEGADO RED', 'Cold Drinks', 'Fresh Juice', 1, 100.00, 100.0000, 0.0000, 100.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 20:58:55', 'admin-1477310901-14773139354259099', 1, 0, '', NULL, NULL, NULL),
(11261, '2016-10-24 18:50:50', NULL, NULL, 4030, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 18:50:50', 'admin-1477287332-14773062506545283', 1, 0, '', NULL, NULL, '20.0'),
(11262, '2016-10-24 18:51:41', NULL, NULL, 4030, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 18:51:41', 'admin-1477287332-1477306301229137', 1, 1, 'SR', NULL, NULL, '20.0'),
(11263, '2016-10-24 19:10:40', NULL, NULL, 4031, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 19:10:40', 'admin-1477287332-1477307439918554', 1, 1, 'SR', NULL, NULL, NULL),
(11264, '2016-10-24 19:45:05', NULL, NULL, 4032, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 19:45:05', 'admin-1477287332-14773095051468976', 1, 1, 'SR', NULL, NULL, NULL),
(11265, '2016-10-24 20:02:34', NULL, NULL, 4033, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 20:02:34', 'admin-1477287332-14773105541151698', 1, 0, '', NULL, NULL, NULL),
(11266, '2016-10-24 20:02:34', NULL, NULL, 4033, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 20:02:34', 'admin-1477287332-14773105541151698', 1, 1, 'SR', NULL, NULL, NULL),
(11267, '2016-10-24 20:02:34', NULL, NULL, 4033, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 20:02:34', 'admin-1477287332-14773105541151698', 1, 1, 'SR', NULL, NULL, NULL),
(11268, '2016-10-24 15:18:46', NULL, NULL, 4019, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 15:18:46', 'admin-1477287332-1477293525864990', 1, 1, 'SR', NULL, NULL, NULL),
(11269, '2016-10-24 15:40:33', NULL, NULL, 4024, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 15:40:33', 'admin-1477287332-14772948331351166', 1, 1, 'SR', NULL, NULL, NULL),
(11270, '2016-10-24 15:40:33', NULL, NULL, 4024, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 15:40:33', 'admin-1477287332-14772948331351166', 1, 1, 'SR', NULL, NULL, NULL),
(11271, '2016-10-24 15:43:05', NULL, NULL, 4023, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 15:43:05', 'admin-1477287332-14772949852396118', 1, 0, '', NULL, NULL, NULL),
(11272, '2016-10-24 15:43:11', NULL, NULL, 4023, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 15:43:11', 'admin-1477287332-14772949915905213', 1, 1, 'SR', NULL, NULL, NULL),
(11273, '2016-10-24 13:35:41', NULL, NULL, 4018, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 13:35:41', 'admin-1477287332-147728734112377', 1, 1, 'SR', NULL, NULL, NULL),
(11274, '2016-10-24 14:32:35', NULL, NULL, 4021, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 14:32:35', 'admin-1477287332-14772907553431497', 1, 1, 'SR', 1, NULL, NULL),
(11275, '2016-10-24 14:42:20', NULL, NULL, 4022, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 14:42:20', 'admin-1477287332-14772913406245645', 1, 0, '', NULL, NULL, NULL),
(11276, '2016-10-24 14:42:20', NULL, NULL, 4022, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 14:42:20', 'admin-1477287332-14772913406245645', 1, 0, '', NULL, NULL, NULL),
(11277, '2016-10-24 14:42:20', NULL, NULL, 4022, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 14:42:20', 'admin-1477287332-14772913406245645', 1, 0, '', NULL, NULL, NULL),
(11278, '2016-10-24 14:42:20', NULL, NULL, 4022, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 14:42:20', 'admin-1477287332-14772913406245645', 1, 0, '', NULL, NULL, NULL),
(11279, '2016-10-24 14:42:20', NULL, NULL, 4022, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 14:42:20', 'admin-1477287332-14772913406245645', 1, 1, 'SR', NULL, NULL, NULL),
(11280, '2016-10-24 15:06:48', NULL, NULL, 4023, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 15:06:48', 'admin-1477287332-14772928083677079', 1, 0, '', NULL, NULL, NULL),
(11281, '2016-10-24 13:35:17', NULL, NULL, 4018, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 13:35:17', 'admin-1477284302-14772873174739132', 1, 0, '', NULL, NULL, NULL),
(11282, '2016-10-24 13:35:17', NULL, NULL, 4018, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 13:35:17', 'admin-1477284302-14772873174739132', 1, 0, '', NULL, NULL, NULL),
(11283, '2016-10-24 20:35:44', NULL, NULL, 4032, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 20:35:44', 'admin-1477310901-14773125437322051', 1, 0, '', NULL, NULL, NULL),
(11284, '2016-10-24 20:35:44', NULL, NULL, 4032, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 20:35:44', 'admin-1477310901-14773125437322051', 1, 0, '', NULL, NULL, NULL),
(11285, '2016-10-24 20:19:22', NULL, NULL, 4035, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 20:19:22', 'admin-1477310901-14773115627317228', 1, 0, '', NULL, NULL, NULL),
(11286, '2016-10-24 20:19:22', NULL, NULL, 4035, 0, 206, '141', 'Creme Brulee Cheese Cake', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 20:19:22', 'admin-1477310901-14773115627317228', 1, 0, '', NULL, NULL, NULL),
(11287, '2016-10-24 20:17:07', NULL, NULL, 4035, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 20:17:07', 'admin-1477310901-14773114274741354', 1, 1, 'SR', NULL, NULL, NULL),
(11288, '2016-10-24 20:17:07', NULL, NULL, 4035, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 20:17:07', 'admin-1477310901-14773114274741354', 1, 1, 'SR', NULL, NULL, NULL),
(11289, '2016-10-24 20:17:07', NULL, NULL, 4035, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 20:17:07', 'admin-1477310901-14773114274741354', 1, 1, 'SR', NULL, NULL, NULL),
(11290, '2016-10-24 20:15:44', NULL, NULL, 4030, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 20:15:44', 'admin-1477310901-14773113446999638', 1, 1, 'SR', NULL, NULL, '20.0'),
(11291, '2016-10-24 20:10:38', NULL, NULL, 4033, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 20:10:38', 'admin-1477310901-14773110382979152', 1, 0, '', NULL, NULL, NULL),
(11292, '2016-10-24 20:08:30', NULL, NULL, 4034, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 20:08:30', 'admin-1477310901-14773109098247192', 1, 1, 'SR', NULL, NULL, NULL),
(11293, '2016-10-24 20:07:54', NULL, NULL, 4034, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 20:07:54', 'admin-1477287332-14773108738712253', 1, 0, '', NULL, NULL, NULL),
(11294, '2016-10-24 17:52:44', NULL, NULL, 4029, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 17:52:44', 'admin-1477287332-14773027646053221', 1, 1, 'SR', 1, NULL, NULL),
(11295, '2016-10-24 17:52:44', NULL, NULL, 4029, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 17:52:44', 'admin-1477287332-14773027646053221', 1, 1, 'SR', 1, NULL, NULL),
(11296, '2016-10-24 17:52:44', NULL, NULL, 4029, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 17:52:44', 'admin-1477287332-14773027646053221', 1, 0, '', 1, NULL, NULL),
(11297, '2016-10-24 17:21:13', NULL, NULL, 4028, 0, 228, '162', 'Golden Brown', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 17:21:13', 'admin-1477287332-14773008737299421', 1, 0, '', 1, NULL, NULL),
(11298, '2016-10-24 17:21:13', NULL, NULL, 4028, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 17:21:13', 'admin-1477287332-14773008737299421', 1, 1, 'SR', 1, NULL, NULL),
(11299, '2016-10-24 16:31:23', NULL, NULL, 4027, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 16:31:23', 'admin-1477287332-14772978831043024', 1, 1, 'SR', NULL, NULL, NULL),
(11300, '2016-10-24 16:17:47', NULL, NULL, 4026, 0, 227, '161', 'Cranberry Velvet', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 16:17:47', 'admin-1477287332-14772970670416275', 1, 0, '', NULL, NULL, NULL),
(11301, '2016-10-24 15:06:48', NULL, NULL, 4023, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 15:06:48', 'admin-1477287332-14772928083677079', 1, 0, '', NULL, NULL, NULL),
(11302, '2016-10-24 16:17:47', NULL, NULL, 4026, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 16:17:47', 'admin-1477287332-14772970670416275', 1, 1, 'SR', NULL, NULL, NULL),
(11303, '2016-10-24 16:16:19', NULL, NULL, 4025, 0, 228, '162', 'Golden Brown', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 16:16:19', 'admin-1477287332-14772969797865961', 1, 0, '', 1, NULL, NULL),
(11304, '2016-10-24 15:18:28', NULL, NULL, 4023, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 15:18:28', 'admin-1477287332-14772935080794724', 1, 0, '', NULL, NULL, NULL),
(11305, '2016-10-24 15:18:28', NULL, NULL, 4023, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 15:18:28', 'admin-1477287332-14772935080794724', 1, 0, '', NULL, NULL, NULL),
(11306, '2016-10-24 16:31:23', NULL, NULL, 4027, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 16:31:23', 'admin-1477287332-14772978831043024', 1, 1, 'SR', NULL, NULL, NULL),
(11307, '2016-10-24 15:08:12', NULL, NULL, 4023, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 15:08:12', 'admin-1477287332-1477292891952116', 1, 1, 'SR', NULL, NULL, NULL),
(11308, '2016-10-24 15:07:53', NULL, NULL, 4023, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 15:07:53', 'admin-1477287332-14772928733082686', 1, 1, 'SR', NULL, NULL, NULL),
(11309, '2016-10-24 15:07:53', NULL, NULL, 4023, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 15:07:53', 'admin-1477287332-14772928733082686', 1, 1, 'SR', NULL, NULL, NULL),
(11310, '2016-10-24 15:06:48', NULL, NULL, 4023, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 15:06:48', 'admin-1477287332-14772928083677079', 1, 0, '', NULL, NULL, NULL),
(11311, '2016-10-24 13:25:37', NULL, NULL, 4020, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 13:25:37', 'admin-1477284302-14772867368725182', 1, 1, 'SR', NULL, NULL, NULL),
(11312, '2016-10-24 13:25:37', NULL, NULL, 4020, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 13:25:37', 'admin-1477284302-14772867368725182', 1, 1, 'SR', NULL, NULL, NULL),
(11313, '2016-10-24 10:11:03', NULL, NULL, 4007, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 10:11:03', 'admin-1477271840-14772750636038156', 1, 0, '', NULL, NULL, NULL),
(11314, '2016-10-24 10:11:27', NULL, NULL, 4007, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 10:11:27', 'admin-1477271840-1477275087099591', 1, 1, 'SR', NULL, NULL, NULL),
(11315, '2016-10-24 10:19:26', NULL, NULL, 4006, 0, 181, '116', 'Open Food ', 'apple', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 10:19:26', 'admin-1477271840-14772755660519226', 1, 0, '', NULL, NULL, NULL),
(11316, '2016-10-24 11:10:25', NULL, NULL, 4008, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 11:10:25', 'admin-1477271840-14772786253351323', 1, 1, 'SR', NULL, NULL, NULL),
(11317, '2016-10-24 11:10:25', NULL, NULL, 4008, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 11:10:25', 'admin-1477271840-14772786253351323', 1, 0, '', NULL, NULL, NULL),
(11318, '2016-10-24 11:21:57', NULL, NULL, 4009, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 11:21:57', 'admin-1477271840-14772793173106891', 1, 0, '', NULL, NULL, NULL),
(11319, '2016-10-24 11:21:57', NULL, NULL, 4009, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 11:21:57', 'admin-1477271840-14772793173106891', 1, 0, '', NULL, NULL, NULL),
(11320, '2016-10-24 11:21:57', NULL, NULL, 4009, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 11:21:57', 'admin-1477271840-14772793173106891', 1, 0, '', NULL, NULL, NULL),
(11321, '2016-10-24 11:21:57', NULL, NULL, 4009, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 11:21:57', 'admin-1477271840-14772793173106891', 1, 1, 'SR', NULL, NULL, NULL),
(11322, '2016-10-24 11:21:57', NULL, NULL, 4009, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 11:21:57', 'admin-1477271840-14772793173106891', 1, 0, '', NULL, NULL, NULL),
(11323, '2016-10-24 11:21:57', NULL, NULL, 4009, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 11:21:57', 'admin-1477271840-14772793173106891', 1, 1, 'SR', NULL, NULL, NULL),
(11324, '2016-10-24 11:21:57', NULL, NULL, 4009, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 11:21:57', 'admin-1477271840-14772793173106891', 1, 0, '', NULL, NULL, NULL),
(11325, '2016-10-24 11:23:04', NULL, NULL, 4009, 0, 182, '117', 'Open Drinks ', 'Extra Shot', 'Cold Drinks', 'Fresh Juice', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1477310901', 'admin', '2016-10-24 11:23:04', 'admin-1477279327-14772793840996913', 1, 0, '', NULL, NULL, NULL),
(11326, '2016-10-24 11:34:59', NULL, NULL, 4009, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 11:34:59', 'admin-1477279327-14772800993363095', 1, 1, 'SR', NULL, NULL, NULL),
(11327, '2016-10-24 11:38:03', NULL, NULL, 4010, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 11:38:03', 'admin-1477279327-14772802830557734', 1, 0, '', NULL, NULL, NULL),
(11328, '2016-10-24 11:39:58', NULL, NULL, 4010, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 11:39:58', 'admin-1477279327-1477280398504788', 1, 1, 'SR', NULL, NULL, NULL),
(11329, '2016-10-24 11:48:55', NULL, NULL, 4011, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 11:48:55', 'admin-1477279327-14772809352705619', 1, 0, '', NULL, NULL, NULL),
(11330, '2016-10-24 11:48:55', NULL, NULL, 4011, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 11:48:55', 'admin-1477279327-14772809352705619', 1, 1, 'SR', NULL, NULL, NULL),
(11331, '2016-10-24 11:54:03', NULL, NULL, 4012, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 11:54:03', 'admin-1477279327-14772812428294528', 1, 0, '', NULL, NULL, NULL),
(11332, '2016-10-24 11:54:03', NULL, NULL, 4012, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 11:54:03', 'admin-1477279327-14772812428294528', 1, 0, '', NULL, NULL, NULL),
(11333, '2016-10-24 11:56:37', NULL, NULL, 4012, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 11:56:37', 'admin-1477279327-14772813972714518', 1, 1, 'SR', NULL, NULL, NULL),
(11334, '2016-10-24 12:13:24', NULL, NULL, 4014, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 12:13:24', 'admin-1477279327-14772824041835066', 1, 1, 'SR', NULL, NULL, NULL),
(11335, '2016-10-24 12:13:24', NULL, NULL, 4014, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 12:13:24', 'admin-1477279327-14772824041835066', 1, 1, 'SR', NULL, NULL, NULL),
(11336, '2016-10-24 12:14:25', NULL, NULL, 4015, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 12:14:25', 'admin-1477279327-14772824650813424', 1, 1, 'SR', NULL, NULL, NULL),
(11337, '2016-10-24 12:14:25', NULL, NULL, 4015, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 12:14:25', 'admin-1477279327-14772824650813424', 1, 0, '', NULL, NULL, NULL),
(11338, '2016-10-24 12:14:43', NULL, NULL, 4015, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 12:14:43', 'admin-1477279327-14772824834779283', 1, 1, 'SR', NULL, NULL, NULL),
(11339, '2016-10-24 12:14:43', NULL, NULL, 4015, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 12:14:43', 'admin-1477279327-14772824834779283', 1, 1, 'SR', NULL, NULL, NULL),
(11340, '2016-10-24 20:31:18', NULL, NULL, 4035, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 20:31:18', 'admin-1477310901-1477312278064734', 1, 1, 'SR', NULL, NULL, NULL),
(11341, '2016-10-24 11:54:32', NULL, NULL, 4013, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 11:54:32', 'admin-1477279327-14772812721988654', 1, 1, 'SR', NULL, NULL, NULL),
(11342, '2016-10-24 12:44:38', NULL, NULL, 4016, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 12:44:38', 'admin-1477279327-14772842786718848', 1, 1, 'SR', NULL, NULL, NULL),
(11343, '2016-10-24 12:44:38', NULL, NULL, 4016, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 12:44:38', 'admin-1477279327-14772842786718848', 1, 0, '', NULL, NULL, NULL),
(11344, '2016-10-24 12:45:12', NULL, NULL, 4016, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 12:45:12', 'admin-1477284302-14772843126474121', 1, 1, 'SR', NULL, NULL, NULL),
(11345, '2016-10-24 10:11:03', NULL, NULL, 4007, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 10:11:03', 'admin-1477271840-14772750636038156', 1, 0, '', NULL, NULL, NULL),
(11346, '2016-10-24 11:54:32', NULL, NULL, 4013, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 11:54:32', 'admin-1477279327-14772812721988654', 1, 0, '', NULL, NULL, NULL),
(11347, '2016-10-24 10:11:03', NULL, NULL, 4007, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 10:11:03', 'admin-1477271840-14772750636038156', 1, 1, 'SR', NULL, NULL, NULL),
(11348, '2016-10-24 10:11:03', NULL, NULL, 4007, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 10:11:03', 'admin-1477271840-14772750636038156', 1, 0, '', NULL, NULL, NULL),
(11349, '2016-10-24 10:01:13', NULL, NULL, 4006, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 10:01:13', 'admin-1477271840-14772744728861169', 1, 1, 'SR', NULL, NULL, NULL),
(11350, '2016-10-24 13:25:37', NULL, NULL, 4020, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 13:25:37', 'admin-1477284302-14772867368725182', 1, 1, 'SR', NULL, NULL, NULL),
(11351, '2016-10-24 10:11:03', NULL, NULL, 4007, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 10:11:03', 'admin-1477271840-14772750636038156', 1, 0, '', NULL, NULL, NULL),
(11352, '2016-10-24 10:01:13', NULL, NULL, 4006, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 10:01:13', 'admin-1477271840-14772744728861169', 1, 1, 'SR', NULL, NULL, NULL),
(11353, '2016-10-24 10:01:13', NULL, NULL, 4006, 0, 54, '54', 'Chai Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 10:01:13', 'admin-1477271840-14772744728861169', 1, 1, 'SR', NULL, NULL, NULL),
(11354, '2016-10-24 10:01:13', NULL, NULL, 4006, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 10:01:13', 'admin-1477271840-14772744728861169', 1, 1, 'SR', NULL, NULL, NULL),
(11355, '2016-10-24 09:18:39', NULL, NULL, 4004, 0, 156, '90', 'Cheese Omelet', 'Takeaway', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477310901', 'admin', '2016-10-24 09:18:39', 'admin-1477271840-14772719189461018', 1, 0, '', NULL, NULL, NULL),
(11356, '2016-10-26 12:23:56', NULL, NULL, 4042, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 12:23:56', 'admin-1477444933-14774558366339193', 1, 1, 'SR', NULL, NULL, NULL),
(11357, '2016-10-26 17:39:40', NULL, NULL, 4054, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 17:39:40', 'admin-1477456053-14774747804003337', 1, 1, 'SR', 1, NULL, NULL),
(11358, '2016-10-26 17:40:17', NULL, NULL, 4055, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 17:40:17', 'admin-1477456053-14774748170173849', 1, 1, 'SR', 1, NULL, NULL),
(11359, '2016-10-26 17:40:24', NULL, NULL, 4055, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 17:40:24', 'admin-1477456053-1477474824529220', 1, 0, '', 1, NULL, NULL),
(11360, '2016-10-26 17:57:41', NULL, NULL, 4056, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 17:57:41', 'admin-1477456053-14774758613071714', 1, 1, 'SR', NULL, NULL, NULL),
(11361, '2016-10-26 19:14:00', NULL, NULL, 4057, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 19:14:00', 'admin-1477456053-14774804405594544', 1, 1, 'SR', NULL, NULL, NULL),
(11362, '2016-10-26 09:46:11', NULL, NULL, 4037, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 09:46:11', 'admin-1477444933-14774463713047157', 1, 0, '', NULL, NULL, NULL),
(11363, '2016-10-26 09:46:11', NULL, NULL, 4037, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 09:46:11', 'admin-1477444933-14774463713047157', 1, 1, 'SR', NULL, NULL, NULL),
(11364, '2016-10-26 11:05:31', NULL, NULL, 4038, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 11:05:31', 'admin-1477444933-14774511317267250', 1, 1, 'SR', 1, NULL, NULL),
(11365, '2016-10-26 11:18:09', NULL, NULL, 4039, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 11:18:09', 'admin-1477444933-1477451889000531', 1, 0, '', NULL, NULL, NULL),
(11366, '2016-10-26 11:18:09', NULL, NULL, 4039, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 11:18:09', 'admin-1477444933-1477451889000531', 1, 0, '', NULL, NULL, NULL),
(11367, '2016-10-26 11:18:13', NULL, NULL, 4039, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 11:18:13', 'admin-1477444933-14774518929305943', 1, 1, 'SR', NULL, NULL, NULL),
(11368, '2016-10-26 11:18:13', NULL, NULL, 4039, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 11:18:13', 'admin-1477444933-14774518929305943', 1, 1, 'SR', NULL, NULL, NULL),
(11369, '2016-10-26 11:46:38', NULL, NULL, 4040, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 11:46:38', 'admin-1477444933-14774535981704779', 1, 0, '', NULL, NULL, NULL),
(11370, '2016-10-26 11:46:38', NULL, NULL, 4040, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 11:46:38', 'admin-1477444933-14774535981704779', 1, 0, '', NULL, NULL, NULL),
(11371, '2016-10-26 11:46:38', NULL, NULL, 4040, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 11:46:38', 'admin-1477444933-14774535981704779', 1, 1, 'SR', NULL, NULL, NULL),
(11372, '2016-10-26 17:39:06', NULL, NULL, 4053, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 17:39:06', 'admin-1477456053-14774747458196785', 1, 1, 'SR', 1, NULL, NULL),
(11373, '2016-10-26 17:38:47', NULL, NULL, 4052, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 17:38:47', 'admin-1477456053-14774747276659569', 1, 1, 'SR', 1, NULL, NULL),
(11374, '2016-10-26 16:54:59', NULL, NULL, 4051, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 16:54:59', 'admin-1477456053-1477472099597120', 1, 1, 'SR', NULL, NULL, NULL),
(11375, '2016-10-26 16:54:54', NULL, NULL, 4051, 0, 181, '116', 'Open Food ', 'Dressing aside', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 16:54:54', 'admin-1477456053-14774720946105247', 1, 0, '', NULL, NULL, NULL),
(11376, '2016-10-26 16:54:54', NULL, NULL, 4051, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 16:54:54', 'admin-1477456053-14774720946105247', 1, 0, '', NULL, NULL, NULL),
(11377, '2016-10-26 15:46:58', NULL, NULL, 4050, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 15:46:58', 'admin-1477456053-14774680182331199', 1, 1, 'SR', NULL, NULL, NULL),
(11378, '2016-10-26 14:58:48', NULL, NULL, 4049, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 14:58:48', 'admin-1477456053-14774651281797525', 1, 1, 'SR', NULL, NULL, NULL),
(11379, '2016-10-26 14:50:40', NULL, NULL, 4048, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 14:50:40', 'admin-1477456053-1477464639985194', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(11380, '2016-10-26 14:50:40', NULL, NULL, 4048, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 14:50:40', 'admin-1477456053-1477464639985194', 1, 0, '', NULL, NULL, NULL),
(11381, '2016-10-26 14:50:40', NULL, NULL, 4048, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 14:50:40', 'admin-1477456053-1477464639985194', 1, 0, '', NULL, NULL, NULL),
(11382, '2016-10-26 14:50:40', NULL, NULL, 4048, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 14:50:40', 'admin-1477456053-1477464639985194', 1, 0, '', NULL, NULL, NULL),
(11383, '2016-10-26 14:24:01', NULL, NULL, 4047, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 14:24:01', 'admin-1477456053-14774630415295222', 1, 1, 'SR', NULL, NULL, '10.0'),
(11384, '2016-10-26 14:22:33', NULL, NULL, 4047, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 14:22:33', 'admin-1477456053-1477462953027754', 1, 1, 'SR', NULL, NULL, '10.0'),
(11385, '2016-10-26 14:21:30', NULL, NULL, 4047, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 14:21:30', 'admin-1477456053-14774628903317891', 1, 0, '', NULL, NULL, '10.0'),
(11386, '2016-10-26 14:21:08', NULL, NULL, 4047, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 14:21:08', 'admin-1477456053-14774628680435535', 1, 0, '', NULL, NULL, '10.0'),
(11387, '2016-10-26 14:20:17', NULL, NULL, 4047, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 14:20:17', 'admin-1477456053-14774628168614860', 1, 1, 'SR', NULL, NULL, '10.0'),
(11388, '2016-10-26 13:17:21', NULL, NULL, 4046, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 13:17:21', 'admin-1477456053-14774590413032598', 1, 0, '', 1, NULL, NULL),
(11389, '2016-10-26 13:16:27', NULL, NULL, 4045, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 13:16:27', 'admin-1477456053-14774589873963292', 1, 1, 'SR', 1, NULL, NULL),
(11390, '2016-10-26 12:28:03', NULL, NULL, 4044, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 12:28:03', 'admin-1477456053-14774560831576957', 1, 1, 'SR', NULL, NULL, NULL),
(11391, '2016-10-26 12:27:25', NULL, NULL, 4043, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 12:27:25', 'admin-1477444933-14774560454043335', 1, 0, '', NULL, NULL, NULL),
(11392, '2016-10-26 12:23:56', NULL, NULL, 4042, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 12:23:56', 'admin-1477444933-14774558366339193', 1, 0, '', NULL, NULL, NULL),
(11393, '2016-10-26 12:23:56', NULL, NULL, 4042, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 12:23:56', 'admin-1477444933-14774558366339193', 1, 0, '', NULL, NULL, NULL),
(11394, '2016-10-26 12:23:56', NULL, NULL, 4042, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 12:23:56', 'admin-1477444933-14774558366339193', 1, 1, 'SR', NULL, NULL, NULL),
(11395, '2016-10-26 12:23:56', NULL, NULL, 4042, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 12:23:56', 'admin-1477444933-14774558366339193', 1, 0, '', NULL, NULL, NULL),
(11396, '2016-10-26 12:23:56', NULL, NULL, 4042, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 12:23:56', 'admin-1477444933-14774558366339193', 1, 0, '', NULL, NULL, NULL),
(11397, '2016-10-26 12:23:56', NULL, NULL, 4042, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 12:23:56', 'admin-1477444933-14774558366339193', 1, 0, '', NULL, NULL, NULL),
(11398, '2016-10-26 11:55:02', NULL, NULL, 4041, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 11:55:02', 'admin-1477444933-14774541025418927', 1, 1, 'SR', NULL, NULL, NULL),
(11399, '2016-10-26 09:46:11', NULL, NULL, 4037, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 09:46:11', 'admin-1477444933-14774463713047157', 1, 0, '', NULL, NULL, NULL),
(11400, '2016-10-26 09:31:00', NULL, NULL, 4036, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 09:31:00', 'admin-1477444933-14774454602317225', 1, 1, 'SR', NULL, NULL, NULL),
(11401, '2016-10-26 09:31:00', NULL, NULL, 4036, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 09:31:00', 'admin-1477444933-14774454602317225', 1, 1, 'SR', NULL, NULL, NULL),
(11402, '2016-10-26 09:46:11', NULL, NULL, 4037, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 09:46:11', 'admin-1477444933-14774463713047157', 1, 0, '', NULL, NULL, NULL),
(11403, '2016-10-26 09:31:00', NULL, NULL, 4036, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 09:31:00', 'admin-1477444933-14774454602317225', 1, 0, '', NULL, NULL, NULL),
(11404, '2016-10-26 09:31:00', NULL, NULL, 4036, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 09:31:00', 'admin-1477444933-14774454602317225', 1, 0, '', NULL, NULL, NULL),
(11405, '2016-10-26 09:31:00', NULL, NULL, 4036, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477456053', 'admin', '2016-10-26 09:31:00', 'admin-1477444933-14774454602317225', 1, 0, '', NULL, NULL, NULL),
(11406, '2016-10-27 15:18:31', NULL, NULL, 4072, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 15:18:31', 'admin-1477542726-14775527115611587', 1, 1, 'SR', NULL, NULL, NULL),
(11407, '2016-10-27 15:18:31', NULL, NULL, 4072, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 15:18:31', 'admin-1477542726-14775527115611587', 1, 1, 'SR', NULL, NULL, NULL),
(11408, '2016-10-27 15:19:18', NULL, NULL, 4073, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 15:19:18', 'admin-1477542726-14775527582287289', 1, 0, '', NULL, NULL, NULL),
(11409, '2016-10-27 15:18:31', NULL, NULL, 4072, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 15:18:31', 'admin-1477542726-14775527115611587', 1, 0, '', NULL, NULL, NULL),
(11410, '2016-10-27 15:19:05', NULL, NULL, 4073, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 15:19:05', 'admin-1477542726-14775527453147612', 1, 1, 'SR', NULL, NULL, NULL),
(11411, '2016-10-27 15:24:25', NULL, NULL, 4073, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 15:24:25', 'admin-1477542726-14775530655197543', 1, 0, '', NULL, NULL, NULL),
(11412, '2016-10-27 10:46:58', NULL, NULL, 4061, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 10:46:58', 'admin-1477531714-14775364183354675', 1, 0, '', NULL, NULL, NULL),
(11413, '2016-10-27 10:47:07', NULL, NULL, 4061, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 10:47:07', 'admin-1477531714-1477536427618333', 1, 0, '', NULL, NULL, NULL),
(11414, '2016-10-27 10:47:36', NULL, NULL, 4061, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 10:47:36', 'admin-1477531714-1477536456065689', 1, 1, 'SR', NULL, NULL, NULL),
(11415, '2016-10-27 10:47:36', NULL, NULL, 4061, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 10:47:36', 'admin-1477531714-1477536456065689', 1, 1, 'SR', NULL, NULL, NULL),
(11416, '2016-10-27 11:24:20', NULL, NULL, 4062, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 11:24:20', 'admin-1477531714-14775386598648029', 1, 0, '', NULL, NULL, NULL),
(11417, '2016-10-27 11:24:20', NULL, NULL, 4062, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 11:24:20', 'admin-1477531714-14775386598648029', 1, 1, 'SR', NULL, NULL, NULL),
(11418, '2016-10-27 11:33:25', NULL, NULL, 4063, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 11:33:25', 'admin-1477531714-14775392055492033', 1, 1, 'SR', NULL, NULL, NULL),
(11419, '2016-10-27 11:33:25', NULL, NULL, 4063, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 11:33:25', 'admin-1477531714-14775392055492033', 1, 1, 'SR', NULL, NULL, NULL),
(11420, '2016-10-27 11:48:38', NULL, NULL, 4064, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 11:48:38', 'admin-1477531714-14775401185024435', 1, 1, 'SR', NULL, NULL, NULL),
(11421, '2016-10-27 11:48:38', NULL, NULL, 4064, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 11:48:38', 'admin-1477531714-14775401185024435', 1, 1, 'SR', NULL, NULL, NULL),
(11422, '2016-10-27 14:07:45', NULL, NULL, 4071, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 14:07:45', 'admin-1477542726-1477548465063525', 1, 1, 'SR', NULL, NULL, NULL),
(11423, '2016-10-27 14:07:37', NULL, NULL, 4071, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 14:07:37', 'admin-1477542726-14775484569513877', 1, 0, '', NULL, NULL, NULL),
(11424, '2016-10-27 14:03:29', NULL, NULL, 4068, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 14:03:29', 'admin-1477542726-1477548209691683', 1, 1, 'SR', NULL, NULL, NULL),
(11425, '2016-10-27 13:46:27', NULL, NULL, 4070, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 13:46:27', 'admin-1477542726-14775471876774483', 1, 1, 'SR', 1, NULL, NULL),
(11426, '2016-10-27 13:31:54', NULL, NULL, 4059, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 13:31:54', 'admin-1477542726-1477546314529632', 1, 1, 'SR', NULL, NULL, NULL),
(11427, '2016-10-27 13:31:54', NULL, NULL, 4059, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 13:31:54', 'admin-1477542726-1477546314529632', 1, 1, 'SR', NULL, NULL, NULL),
(11428, '2016-10-27 13:15:12', NULL, NULL, 4060, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 13:15:12', 'admin-1477542726-14775453122589287', 1, 0, '', NULL, NULL, NULL),
(11429, '2016-10-27 13:03:12', NULL, NULL, 4069, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 13:03:12', 'admin-1477542726-1477544592379833', 1, 0, '', NULL, NULL, NULL),
(11430, '2016-10-27 13:03:12', NULL, NULL, 4069, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 13:03:12', 'admin-1477542726-1477544592379833', 1, 0, '', NULL, NULL, NULL),
(11431, '2016-10-27 12:49:19', NULL, NULL, 4068, 0, 82, '82', 'Set Rice Wine Ginger Pork', 'add rice', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 12:49:19', 'admin-1477542726-14775437592166250', 1, 1, 'SR', NULL, NULL, NULL),
(11432, '2016-10-27 12:49:19', NULL, NULL, 4068, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 12:49:19', 'admin-1477542726-14775437592166250', 1, 0, '', NULL, NULL, NULL),
(11433, '2016-10-27 12:49:19', NULL, NULL, 4068, 0, 82, '82', 'Set Rice Wine Ginger Pork', 'add rice', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 12:49:19', 'admin-1477542726-14775437592166250', 1, 1, 'SR', NULL, NULL, NULL),
(11434, '2016-10-27 12:49:19', NULL, NULL, 4068, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 12:49:19', 'admin-1477542726-14775437592166250', 1, 0, '', NULL, NULL, NULL),
(11435, '2016-10-27 12:37:30', NULL, NULL, 4067, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 12:37:30', 'admin-1477542726-14775430500848941', 1, 1, 'SR', NULL, NULL, NULL),
(11436, '2016-10-27 12:37:30', NULL, NULL, 4067, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 12:37:30', 'admin-1477542726-14775430500848941', 1, 1, 'SR', NULL, NULL, NULL),
(11437, '2016-10-27 12:37:30', NULL, NULL, 4067, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 12:37:30', 'admin-1477542726-14775430500848941', 1, 0, '', NULL, NULL, NULL),
(11438, '2016-10-27 12:37:30', NULL, NULL, 4067, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 12:37:30', 'admin-1477542726-14775430500848941', 1, 1, 'SR', NULL, NULL, NULL),
(11439, '2016-10-27 12:11:22', NULL, NULL, 4065, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 12:11:22', 'admin-1477531714-14775414820092686', 1, 0, '', NULL, NULL, NULL),
(11440, '2016-10-27 12:11:22', NULL, NULL, 4065, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 12:11:22', 'admin-1477531714-14775414820092686', 1, 0, '', NULL, NULL, NULL),
(11441, '2016-10-27 19:11:26', NULL, NULL, 4077, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 19:11:26', 'admin-1477566367-1477566686394304', 1, 0, '', NULL, NULL, NULL),
(11442, '2016-10-27 19:11:26', NULL, NULL, 4077, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 19:11:26', 'admin-1477566367-1477566686394304', 1, 1, 'SR', NULL, NULL, NULL),
(11443, '2016-10-27 12:31:53', NULL, NULL, 4065, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 12:31:53', 'admin-1477531714-14775427130864336', 1, 0, '', NULL, NULL, NULL),
(11444, '2016-10-27 12:30:16', NULL, NULL, 4066, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 12:30:16', 'admin-1477531714-14775426159987014', 1, 1, 'SR', NULL, NULL, NULL),
(11445, '2016-10-27 12:30:16', NULL, NULL, 4066, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 12:30:16', 'admin-1477531714-14775426159987014', 1, 1, 'SR', NULL, NULL, NULL),
(11446, '2016-10-27 12:30:01', NULL, NULL, 4066, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 12:30:01', 'admin-1477531714-14775426016093789', 1, 0, '', NULL, NULL, NULL),
(11447, '2016-10-27 12:30:01', NULL, NULL, 4066, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 12:30:01', 'admin-1477531714-14775426016093789', 1, 1, 'SR', NULL, NULL, NULL),
(11448, '2016-10-27 12:11:22', NULL, NULL, 4065, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 12:11:22', 'admin-1477531714-14775414820092686', 1, 1, 'SR', NULL, NULL, NULL),
(11449, '2016-10-27 12:30:01', NULL, NULL, 4066, 0, 222, '156', 'Seasoned Chicken Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 12:30:01', 'admin-1477531714-14775426016093789', 1, 0, '', NULL, NULL, NULL),
(11450, '2016-10-27 19:06:32', NULL, NULL, 4077, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 19:06:32', 'admin-1477566367-14775663917317185', 1, 1, 'SR', NULL, NULL, NULL),
(11451, '2016-10-27 12:11:22', NULL, NULL, 4065, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 12:11:22', 'admin-1477531714-14775414820092686', 1, 1, 'SR', NULL, NULL, NULL),
(11452, '2016-10-27 10:34:21', NULL, NULL, 4060, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 10:34:21', 'admin-1477531714-14775356615499328', 1, 1, 'SR', NULL, NULL, NULL),
(11453, '2016-10-27 09:14:01', NULL, NULL, 4058, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 09:14:01', 'admin-1477530007-14775308411416510', 1, 1, 'SR', NULL, NULL, NULL),
(11454, '2016-10-27 09:14:01', NULL, NULL, 4058, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 09:14:01', 'admin-1477530007-14775308411416510', 1, 1, 'SR', NULL, NULL, NULL),
(11455, '2016-10-27 19:06:31', NULL, NULL, 4077, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 19:06:32', 'admin-1477566367-14775663917317185', 1, 0, '', NULL, NULL, NULL),
(11456, '2016-10-27 19:06:32', NULL, NULL, 4077, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 19:06:32', 'admin-1477566367-14775663917317185', 1, 0, '', NULL, NULL, NULL),
(11457, '2016-10-27 10:46:58', NULL, NULL, 4061, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 10:46:58', 'admin-1477531714-14775364183354675', 1, 0, '', NULL, NULL, NULL),
(11458, '2016-10-27 19:01:17', NULL, NULL, 4077, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 19:01:17', 'admin-1477542726-14775660777029842', 1, 1, 'SR', NULL, NULL, NULL),
(11459, '2016-10-27 18:29:22', NULL, NULL, 4076, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 18:29:22', 'admin-1477542726-14775641624431155', 1, 1, 'SR', NULL, NULL, NULL),
(11460, '2016-10-27 16:43:54', NULL, NULL, 4075, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 16:43:54', 'admin-1477542726-1477557834445454', 1, 1, 'SR', NULL, NULL, NULL),
(11461, '2016-10-27 16:37:41', NULL, NULL, 4075, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 16:37:41', 'admin-1477542726-14775574614963883', 1, 1, 'SR', NULL, NULL, NULL),
(11462, '2016-10-27 09:59:47', NULL, NULL, 4059, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 09:59:47', 'admin-1477531714-1477533587193522', 1, 0, '', NULL, NULL, NULL),
(11463, '2016-10-27 09:14:01', NULL, NULL, 4058, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477566367', 'admin', '2016-10-27 09:14:01', 'admin-1477530007-14775308411416510', 1, 0, '', NULL, NULL, NULL),
(11464, '2016-10-28 19:24:03', NULL, NULL, 4104, 0, 181, '116', 'Open Food ', 'Birthday Party', 'Meals', 'Perfect Meals', 1, 960.00, 960.0000, 0.0000, 960.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 19:24:03', 'admin-1477635614-14776538434654324', 1, 0, '', NULL, NULL, NULL),
(11465, '2016-10-28 19:40:17', NULL, NULL, 4106, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 19:40:17', 'admin-1477635614-147765481768745', 1, 0, '', NULL, NULL, NULL),
(11466, '2016-10-28 19:40:17', NULL, NULL, 4106, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 19:40:17', 'admin-1477635614-147765481768745', 1, 0, '', NULL, NULL, NULL),
(11467, '2016-10-28 20:08:36', NULL, NULL, 4108, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 20:08:36', 'admin-1477635614-14776565161396121', 1, 1, 'SR', NULL, NULL, NULL),
(11468, '2016-10-28 20:20:37', NULL, NULL, 4108, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 20:20:37', 'admin-1477656527-14776572372738080', 1, 1, 'SR', NULL, NULL, NULL),
(11469, '2016-10-28 20:08:36', NULL, NULL, 4108, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 20:08:36', 'admin-1477635614-14776565161396121', 1, 0, '', NULL, NULL, NULL),
(11470, '2016-10-28 20:08:36', NULL, NULL, 4108, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 20:08:36', 'admin-1477635614-14776565161396121', 1, 0, '', NULL, NULL, NULL),
(11471, '2016-10-28 20:08:36', NULL, NULL, 4108, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 20:08:36', 'admin-1477635614-14776565161396121', 1, 0, '', NULL, NULL, NULL),
(11472, '2016-10-28 20:08:55', NULL, NULL, 4106, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 20:08:55', 'admin-1477656527-14776565355651833', 1, 1, 'SR', NULL, NULL, NULL),
(11473, '2016-10-28 20:45:59', NULL, NULL, 4108, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 20:45:59', 'admin-1477656527-14776587590573353', 1, 1, 'SR', NULL, NULL, NULL),
(11474, '2016-10-28 20:45:59', NULL, NULL, 4108, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 20:45:59', 'admin-1477656527-14776587590573353', 1, 1, 'SR', NULL, NULL, NULL),
(11475, '2016-10-28 20:47:41', NULL, NULL, 4108, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 20:47:41', 'admin-1477656527-14776588608074587', 1, 0, '', NULL, NULL, NULL),
(11476, '2016-10-28 22:37:26', NULL, NULL, 4109, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 22:37:26', 'admin-1477656527-14776654466616019', 1, 1, 'SR', 1, NULL, NULL),
(11477, '2016-10-28 14:07:17', NULL, NULL, 4087, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 14:07:17', 'admin-1477615835-1477634837653892', 1, 1, 'SR', NULL, NULL, NULL),
(11478, '2016-10-28 14:08:59', NULL, NULL, 4095, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 14:08:59', 'admin-1477615835-1477634939351685', 1, 1, 'SR', NULL, NULL, NULL),
(11479, '2016-10-28 14:08:59', NULL, NULL, 4095, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 14:08:59', 'admin-1477615835-1477634939351685', 1, 1, 'SR', NULL, NULL, NULL),
(11480, '2016-10-28 14:08:59', NULL, NULL, 4095, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 14:08:59', 'admin-1477615835-1477634939351685', 1, 1, 'SR', NULL, NULL, NULL),
(11481, '2016-10-28 14:08:59', NULL, NULL, 4095, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 14:08:59', 'admin-1477615835-1477634939351685', 1, 1, 'SR', NULL, NULL, NULL),
(11482, '2016-10-28 14:08:59', NULL, NULL, 4095, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 14:08:59', 'admin-1477615835-1477634939351685', 1, 1, 'SR', NULL, NULL, NULL),
(11483, '2016-10-28 14:20:02', NULL, NULL, 4096, 0, 222, '156', 'Seasoned Chicken Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 14:20:02', 'admin-1477615835-14776356023743278', 1, 0, '', NULL, NULL, NULL),
(11484, '2016-10-28 15:30:37', NULL, NULL, 4099, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 15:30:37', 'admin-1477635614-1477639837645553', 1, 1, 'SR', NULL, NULL, NULL),
(11485, '2016-10-28 17:03:58', NULL, NULL, 4102, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 17:03:58', 'admin-1477635614-14776454388207834', 1, 0, '', NULL, NULL, NULL),
(11486, '2016-10-28 17:04:18', NULL, NULL, 4102, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 17:04:18', 'admin-1477635614-14776454582741038', 1, 1, 'SR', NULL, NULL, NULL),
(11487, '2016-10-28 17:04:18', NULL, NULL, 4102, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 17:04:18', 'admin-1477635614-14776454582741038', 1, 1, 'SR', NULL, NULL, NULL),
(11488, '2016-10-28 17:14:32', NULL, NULL, 4103, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 17:14:32', 'admin-1477635614-14776460723749683', 1, 1, 'SR', NULL, NULL, NULL),
(11489, '2016-10-28 17:33:04', NULL, NULL, 4102, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 17:33:04', 'admin-1477635614-14776471838657356', 1, 1, 'SR', NULL, NULL, NULL),
(11490, '2016-10-28 17:33:15', NULL, NULL, 4104, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 17:33:15', 'admin-1477635614-14776471951085293', 1, 0, '', NULL, NULL, NULL),
(11491, '2016-10-28 17:33:15', NULL, NULL, 4104, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 17:33:15', 'admin-1477635614-14776471951085293', 1, 1, 'SR', NULL, NULL, NULL),
(11492, '2016-10-28 17:48:36', NULL, NULL, 4103, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 17:48:36', 'admin-1477635614-14776481164468549', 1, 1, 'SR', NULL, NULL, NULL),
(11493, '2016-10-28 18:03:34', NULL, NULL, 4105, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 18:03:34', 'admin-1477635614-14776490141226655', 1, 1, 'SR', NULL, NULL, NULL),
(11494, '2016-10-28 18:06:54', NULL, NULL, 4103, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 18:06:54', 'admin-1477635614-14776492140409675', 1, 1, 'SR', NULL, NULL, NULL),
(11495, '2016-10-28 18:06:49', NULL, NULL, 4103, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 18:06:49', 'admin-1477635614-1477649208969915', 1, 0, '', NULL, NULL, NULL),
(11496, '2016-10-28 19:40:17', NULL, NULL, 4106, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 19:40:17', 'admin-1477635614-147765481768745', 1, 1, 'SR', NULL, NULL, NULL),
(11497, '2016-10-28 19:35:41', NULL, NULL, 4106, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 19:35:41', 'admin-1477635614-14776545407959311', 1, 1, 'SR', NULL, NULL, NULL),
(11498, '2016-10-28 19:35:41', NULL, NULL, 4106, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 19:35:41', 'admin-1477635614-14776545407959311', 1, 1, 'SR', NULL, NULL, NULL),
(11499, '2016-10-28 16:24:32', NULL, NULL, 4101, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 16:24:32', 'admin-1477635614-14776430726757711', 1, 1, 'SR', NULL, NULL, NULL),
(11500, '2016-10-28 16:23:46', NULL, NULL, 4100, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 16:23:46', 'admin-1477635614-14776430265594389', 1, 1, 'SR', NULL, NULL, NULL),
(11501, '2016-10-28 15:47:36', NULL, NULL, 4087, 0, 227, '161', 'Cranberry Velvet', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 15:47:36', 'admin-1477635614-14776408566589570', 1, 0, '', NULL, NULL, NULL),
(11502, '2016-10-28 15:30:37', NULL, NULL, 4099, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 15:30:37', 'admin-1477635614-1477639837645553', 1, 1, 'SR', NULL, NULL, NULL),
(11503, '2016-10-28 14:53:29', NULL, NULL, 4098, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 14:53:29', 'admin-1477635614-14776376095145498', 1, 1, 'SR', NULL, NULL, NULL),
(11504, '2016-10-28 14:53:29', NULL, NULL, 4098, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 14:53:29', 'admin-1477635614-14776376095145498', 1, 0, '', NULL, NULL, NULL),
(11505, '2016-10-28 14:53:29', NULL, NULL, 4098, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 14:53:29', 'admin-1477635614-14776376095145498', 1, 0, '', NULL, NULL, NULL),
(11506, '2016-10-28 14:35:49', NULL, NULL, 4097, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 14:35:49', 'admin-1477635614-14776365491955723', 1, 1, 'SR', NULL, NULL, NULL),
(11507, '2016-10-28 14:35:49', NULL, NULL, 4097, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 14:35:49', 'admin-1477635614-14776365491955723', 1, 1, 'SR', NULL, NULL, NULL),
(11508, '2016-10-28 14:35:49', NULL, NULL, 4097, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 14:35:49', 'admin-1477635614-14776365491955723', 1, 0, '', NULL, NULL, NULL),
(11509, '2016-10-28 15:30:37', NULL, NULL, 4099, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 15:30:37', 'admin-1477635614-1477639837645553', 1, 1, 'SR', NULL, NULL, NULL),
(11510, '2016-10-28 14:35:49', NULL, NULL, 4097, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 14:35:49', 'admin-1477635614-14776365491955723', 1, 1, 'SR', NULL, NULL, NULL),
(11511, '2016-10-28 14:20:02', NULL, NULL, 4096, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 14:20:02', 'admin-1477615835-14776356023743278', 1, 1, 'SR', NULL, NULL, NULL),
(11512, '2016-10-28 14:20:02', NULL, NULL, 4096, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 14:20:02', 'admin-1477615835-14776356023743278', 1, 1, 'SR', NULL, NULL, NULL),
(11513, '2016-10-28 10:45:13', NULL, NULL, 4082, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 10:45:13', 'admin-1477615835-14776227134824586', 1, 1, 'SR', NULL, NULL, NULL),
(11514, '2016-10-28 10:45:13', NULL, NULL, 4082, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 10:45:13', 'admin-1477615835-14776227134824586', 1, 1, 'SR', NULL, NULL, NULL),
(11515, '2016-10-28 11:07:13', NULL, NULL, 4083, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 11:07:13', 'admin-1477615835-1477624033428106', 1, 1, 'SR', NULL, NULL, NULL),
(11516, '2016-10-28 11:07:13', NULL, NULL, 4083, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 11:07:13', 'admin-1477615835-1477624033428106', 1, 0, '', NULL, NULL, NULL),
(11517, '2016-10-28 11:48:59', NULL, NULL, 4082, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 11:48:59', 'admin-1477615835-14776265394037657', 1, 0, '', NULL, NULL, NULL),
(11518, '2016-10-28 11:48:59', NULL, NULL, 4082, 0, 228, '162', 'Golden Brown', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 11:48:59', 'admin-1477615835-14776265394037657', 1, 0, '', NULL, NULL, NULL),
(11519, '2016-10-28 12:21:19', NULL, NULL, 4084, 0, 227, '161', 'Cranberry Velvet', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 12:21:19', 'admin-1477615835-14776284790289239', 1, 0, '', NULL, NULL, NULL),
(11520, '2016-10-28 12:21:19', NULL, NULL, 4084, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 12:21:19', 'admin-1477615835-14776284790289239', 1, 0, '', NULL, NULL, NULL),
(11521, '2016-10-28 12:21:19', NULL, NULL, 4084, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 12:21:19', 'admin-1477615835-14776284790289239', 1, 1, 'SR', NULL, NULL, NULL),
(11522, '2016-10-28 12:21:19', NULL, NULL, 4084, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 12:21:19', 'admin-1477615835-14776284790289239', 1, 1, 'SR', NULL, NULL, NULL),
(11523, '2016-10-28 12:21:19', NULL, NULL, 4084, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 12:21:19', 'admin-1477615835-14776284790289239', 1, 1, 'SR', NULL, NULL, NULL),
(11524, '2016-10-28 12:30:10', NULL, NULL, 4085, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 12:30:10', 'admin-1477615835-14776290101891462', 1, 1, 'SR', NULL, NULL, NULL),
(11525, '2016-10-28 12:41:01', NULL, NULL, 4086, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 12:41:01', 'admin-1477615835-14776296606989686', 1, 0, '', NULL, NULL, NULL),
(11526, '2016-10-28 12:41:01', NULL, NULL, 4086, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 12:41:01', 'admin-1477615835-14776296606989686', 1, 1, 'SR', NULL, NULL, NULL),
(11527, '2016-10-28 12:42:06', NULL, NULL, 4087, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 12:42:06', 'admin-1477615835-14776297265844718', 1, 1, 'SR', NULL, NULL, NULL),
(11528, '2016-10-28 12:56:14', NULL, NULL, 4088, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 12:56:14', 'admin-1477615835-14776305739438628', 1, 1, 'SR', NULL, NULL, NULL),
(11529, '2016-10-28 13:48:57', NULL, NULL, 4089, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 13:48:57', 'admin-1477615835-14776337374597710', 1, 1, 'SR', NULL, NULL, NULL),
(11530, '2016-10-28 13:48:57', NULL, NULL, 4089, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 13:48:57', 'admin-1477615835-14776337374597710', 1, 1, 'SR', NULL, NULL, NULL),
(11531, '2016-10-28 13:50:40', NULL, NULL, 4090, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 13:50:40', 'admin-1477615835-14776338399398521', 1, 1, 'SR', NULL, NULL, NULL),
(11532, '2016-10-28 13:50:40', NULL, NULL, 4090, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 13:50:40', 'admin-1477615835-14776338399398521', 1, 1, 'SR', NULL, NULL, NULL),
(11533, '2016-10-28 13:50:46', NULL, NULL, 4091, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 13:50:46', 'admin-1477615835-14776338466332477', 1, 1, 'SR', NULL, NULL, NULL),
(11534, '2016-10-28 13:50:46', NULL, NULL, 4091, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 13:50:46', 'admin-1477615835-14776338466332477', 1, 1, 'SR', NULL, NULL, NULL),
(11535, '2016-10-28 13:50:46', NULL, NULL, 4091, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 13:50:46', 'admin-1477615835-14776338466332477', 1, 1, 'SR', NULL, NULL, NULL),
(11536, '2016-10-28 13:53:57', NULL, NULL, 4092, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 13:53:57', 'admin-1477615835-1477634036828667', 1, 1, 'SR', NULL, NULL, NULL),
(11537, '2016-10-28 13:55:42', NULL, NULL, 4091, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 13:55:42', 'admin-1477615835-14776341426905361', 1, 1, 'SR', NULL, NULL, NULL),
(11538, '2016-10-28 13:55:42', NULL, NULL, 4091, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 13:55:42', 'admin-1477615835-14776341426905361', 1, 0, '', NULL, NULL, NULL),
(11539, '2016-10-28 13:55:42', NULL, NULL, 4091, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 13:55:42', 'admin-1477615835-14776341426905361', 1, 0, '', NULL, NULL, NULL),
(11540, '2016-10-28 13:56:12', NULL, NULL, 4093, 0, 227, '161', 'Cranberry Velvet', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 13:56:12', 'admin-1477615835-1477634171982225', 1, 0, '', NULL, NULL, NULL),
(11541, '2016-10-28 13:56:12', NULL, NULL, 4093, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 13:56:12', 'admin-1477615835-1477634171982225', 1, 1, 'SR', NULL, NULL, NULL),
(11542, '2016-10-28 13:56:12', NULL, NULL, 4093, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 13:56:12', 'admin-1477615835-1477634171982225', 1, 1, 'SR', NULL, NULL, NULL),
(11543, '2016-10-28 13:56:36', NULL, NULL, 4094, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 13:56:36', 'admin-1477615835-14776341963423114', 1, 1, 'SR', NULL, NULL, NULL),
(11544, '2016-10-28 10:45:13', NULL, NULL, 4082, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 10:45:13', 'admin-1477615835-14776227134824586', 1, 1, 'SR', NULL, NULL, NULL),
(11545, '2016-10-28 10:45:13', NULL, NULL, 4082, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 10:45:13', 'admin-1477615835-14776227134824586', 1, 1, 'SR', NULL, NULL, NULL),
(11546, '2016-10-28 09:49:57', NULL, NULL, 4078, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 09:49:57', 'admin-1477615835-1477619396792804', 1, 1, 'SR', NULL, NULL, NULL),
(11547, '2016-10-28 10:45:13', NULL, NULL, 4082, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 10:45:13', 'admin-1477615835-14776227134824586', 1, 1, 'SR', NULL, NULL, NULL),
(11548, '2016-10-28 10:45:13', NULL, NULL, 4082, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 10:45:13', 'admin-1477615835-14776227134824586', 1, 1, 'SR', NULL, NULL, NULL),
(11549, '2016-10-28 10:44:36', NULL, NULL, 4082, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 10:44:36', 'admin-1477615835-14776226766102297', 1, 0, '', NULL, NULL, NULL),
(11550, '2016-10-28 10:44:36', NULL, NULL, 4082, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 10:44:36', 'admin-1477615835-14776226766102297', 1, 0, '', NULL, NULL, NULL),
(11551, '2016-10-28 10:44:36', NULL, NULL, 4082, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 10:44:36', 'admin-1477615835-14776226766102297', 1, 0, '', NULL, NULL, NULL),
(11552, '2016-10-28 10:45:13', NULL, NULL, 4082, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 10:45:13', 'admin-1477615835-14776227134824586', 1, 1, 'SR', NULL, NULL, NULL),
(11553, '2016-10-28 10:44:36', NULL, NULL, 4082, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 10:44:36', 'admin-1477615835-14776226766102297', 1, 0, '', NULL, NULL, NULL),
(11554, '2016-10-28 10:44:36', NULL, NULL, 4082, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 10:44:36', 'admin-1477615835-14776226766102297', 1, 0, '', NULL, NULL, NULL),
(11555, '2016-10-28 10:37:49', NULL, NULL, 4081, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 10:37:49', 'admin-1477615835-14776222695671912', 1, 1, 'SR', 1, NULL, NULL),
(11556, '2016-10-28 10:11:22', NULL, NULL, 4080, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 10:11:22', 'admin-1477615835-14776206825941821', 1, 0, '', NULL, NULL, NULL),
(11557, '2016-10-28 10:10:14', NULL, NULL, 4079, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 10:10:14', 'admin-1477615835-14776206143163560', 1, 1, 'SR', NULL, NULL, NULL),
(11558, '2016-10-28 10:11:22', NULL, NULL, 4080, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 10:11:22', 'admin-1477615835-14776206825941821', 1, 0, '', NULL, NULL, NULL),
(11559, '2016-10-28 09:49:56', NULL, NULL, 4078, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477656527', 'admin', '2016-10-28 09:49:56', 'admin-1477615835-1477619396792804', 1, 0, '', NULL, NULL, NULL),
(11560, '2016-10-29 12:56:21', NULL, NULL, 4134, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:56:21', 'admin-1477716034-14777169810603724', 1, 1, 'SR', 1, NULL, NULL),
(11561, '2016-10-29 12:56:21', NULL, NULL, 4134, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:56:21', 'admin-1477716034-14777169810603724', 1, 1, 'SR', 1, NULL, NULL),
(11562, '2016-10-29 12:59:05', NULL, NULL, 4133, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:59:05', 'admin-1477716034-147771714541113', 1, 0, '', NULL, NULL, NULL),
(11563, '2016-10-29 12:59:05', NULL, NULL, 4133, 0, 222, '156', 'Seasoned Chicken Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:59:05', 'admin-1477716034-147771714541113', 1, 0, '', NULL, NULL, NULL),
(11564, '2016-10-29 12:59:05', NULL, NULL, 4133, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:59:05', 'admin-1477716034-147771714541113', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(11565, '2016-10-29 12:59:05', NULL, NULL, 4133, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:59:05', 'admin-1477716034-147771714541113', 1, 1, 'SR', NULL, NULL, NULL),
(11566, '2016-10-29 12:59:05', NULL, NULL, 4133, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:59:05', 'admin-1477716034-147771714541113', 1, 1, 'SR', NULL, NULL, NULL),
(11567, '2016-10-29 12:59:27', NULL, NULL, 4135, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:59:27', 'admin-1477716034-14777171676719721', 1, 1, 'SR', 1, NULL, NULL),
(11568, '2016-10-29 16:48:56', NULL, NULL, 4149, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 16:48:56', 'admin-1477719603-14777309359052258', 1, 0, '', NULL, NULL, NULL),
(11569, '2016-10-29 16:49:06', NULL, NULL, 4149, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 16:49:06', 'admin-1477719603-14777309458468761', 1, 1, 'SR', NULL, NULL, NULL),
(11570, '2016-10-29 18:23:37', NULL, NULL, 4149, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 18:23:37', 'admin-1477719603-14777366176339478', 1, 1, 'SR', NULL, NULL, NULL),
(11571, '2016-10-29 14:56:32', NULL, NULL, 4143, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 14:56:32', 'admin-1477719603-1477724192110714', 1, 0, '', 1, NULL, NULL),
(11572, '2016-10-29 14:49:44', NULL, NULL, 4142, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 14:49:44', 'admin-1477719603-14777237843673240', 1, 1, 'SR', NULL, NULL, NULL),
(11573, '2016-10-29 14:49:44', NULL, NULL, 4142, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 14:49:44', 'admin-1477719603-14777237843673240', 1, 1, 'SR', NULL, NULL, NULL),
(11574, '2016-10-29 14:49:44', NULL, NULL, 4142, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 14:49:44', 'admin-1477719603-14777237843673240', 1, 1, 'SR', NULL, NULL, NULL),
(11575, '2016-10-29 14:49:44', NULL, NULL, 4142, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 14:49:44', 'admin-1477719603-14777237843673240', 1, 0, '', NULL, NULL, NULL),
(11576, '2016-10-29 14:55:51', NULL, NULL, 4142, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 14:55:51', 'admin-1477719603-1477724151589473', 1, 0, '', NULL, NULL, NULL),
(11577, '2016-10-29 14:49:44', NULL, NULL, 4142, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 14:49:44', 'admin-1477719603-14777237843673240', 1, 0, '', NULL, NULL, NULL),
(11578, '2016-10-29 14:28:21', NULL, NULL, 4141, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 14:28:21', 'admin-1477719603-14777225012154979', 1, 1, 'SR', NULL, NULL, '10.0'),
(11579, '2016-10-29 14:28:21', NULL, NULL, 4141, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 14:28:21', 'admin-1477719603-14777225012154979', 1, 1, 'SR', NULL, NULL, '10.0'),
(11580, '2016-10-29 14:28:21', NULL, NULL, 4141, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 14:28:21', 'admin-1477719603-14777225012154979', 1, 0, '', NULL, NULL, '10.0'),
(11581, '2016-10-29 14:23:28', NULL, NULL, 4138, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 14:23:28', 'admin-1477719603-14777222082691860', 1, 1, 'SR', NULL, NULL, NULL),
(11582, '2016-10-29 14:15:39', NULL, NULL, 4140, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 14:15:39', 'admin-1477719603-14777217388549499', 1, 1, 'SR', NULL, NULL, NULL),
(11583, '2016-10-29 15:09:18', NULL, NULL, 4145, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 15:09:19', 'admin-1477719603-14777249588412685', 1, 1, 'SR', NULL, NULL, NULL),
(11584, '2016-10-29 15:14:24', NULL, NULL, 4145, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 15:14:24', 'admin-1477719603-14777252646312441', 1, 1, 'SR', NULL, NULL, NULL),
(11585, '2016-10-29 15:32:16', NULL, NULL, 4146, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 15:32:16', 'admin-1477719603-14777263364817810', 1, 1, 'SR', NULL, NULL, NULL),
(11586, '2016-10-29 15:32:16', NULL, NULL, 4146, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 15:32:16', 'admin-1477719603-14777263364817810', 1, 1, 'SR', NULL, NULL, NULL),
(11587, '2016-10-29 15:32:16', NULL, NULL, 4146, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 15:32:16', 'admin-1477719603-14777263364817810', 1, 1, 'SR', NULL, NULL, NULL),
(11588, '2016-10-29 16:10:10', NULL, NULL, 4147, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 16:10:10', 'admin-1477719603-1477728610532213', 1, 1, 'SR', NULL, NULL, NULL),
(11589, '2016-10-29 13:11:11', NULL, NULL, 4136, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 13:11:11', 'admin-1477716034-14777178716331068', 1, 0, '', NULL, NULL, NULL),
(11590, '2016-10-29 16:19:22', NULL, NULL, 4148, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 16:19:22', 'admin-1477719603-1477729161869256', 1, 1, 'SR', NULL, NULL, NULL),
(11591, '2016-10-29 13:14:24', NULL, NULL, 4131, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 13:14:24', 'admin-1477716034-14777180637806871', 1, 0, '', NULL, NULL, NULL),
(11592, '2016-10-29 13:25:38', NULL, NULL, 4137, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 13:25:38', 'admin-1477716034-14777187387711953', 1, 0, '', NULL, NULL, NULL),
(11593, '2016-10-29 15:03:03', NULL, NULL, 4144, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 15:03:03', 'admin-1477719603-14777245831063848', 1, 0, '', NULL, NULL, NULL),
(11594, '2016-10-29 15:03:03', NULL, NULL, 4144, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 15:03:03', 'admin-1477719603-14777245831063848', 1, 1, 'SR', NULL, NULL, NULL),
(11595, '2016-10-29 14:15:39', NULL, NULL, 4140, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 14:15:39', 'admin-1477719603-14777217388549499', 1, 1, 'SR', NULL, NULL, NULL),
(11596, '2016-10-29 14:15:32', NULL, NULL, 4139, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 14:15:32', 'admin-1477719603-1477721732777871', 1, 1, 'SR', NULL, NULL, NULL),
(11597, '2016-10-29 14:15:32', NULL, NULL, 4139, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 14:15:32', 'admin-1477719603-1477721732777871', 1, 1, 'SR', NULL, NULL, NULL),
(11598, '2016-10-29 13:49:46', NULL, NULL, 4138, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 13:49:46', 'admin-1477719603-14777201859158469', 1, 1, 'SR', NULL, NULL, NULL),
(11599, '2016-10-29 13:39:08', NULL, NULL, 4131, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 13:39:08', 'admin-1477716034-1477719548507837', 1, 0, '', NULL, NULL, NULL),
(11600, '2016-10-29 13:28:26', NULL, NULL, 4131, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 13:28:26', 'admin-1477716034-14777189062809228', 1, 1, 'SR', NULL, NULL, NULL),
(11601, '2016-10-29 13:25:38', NULL, NULL, 4137, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 13:25:38', 'admin-1477716034-14777187387711953', 1, 1, 'SR', NULL, NULL, NULL),
(11602, '2016-10-29 13:25:38', NULL, NULL, 4137, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 13:25:38', 'admin-1477716034-14777187387711953', 1, 1, 'SR', NULL, NULL, NULL),
(11603, '2016-10-29 13:25:38', NULL, NULL, 4137, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 13:25:38', 'admin-1477716034-14777187387711953', 1, 1, 'SR', NULL, NULL, NULL),
(11604, '2016-10-29 12:18:22', NULL, NULL, 4128, 0, 222, '156', 'Seasoned Chicken Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:18:22', 'admin-1477714307-14777147026542153', 1, 0, '', NULL, NULL, NULL),
(11605, '2016-10-29 12:18:22', NULL, NULL, 4128, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:18:22', 'admin-1477714307-14777147026542153', 1, 0, '', NULL, NULL, NULL),
(11606, '2016-10-29 12:18:22', NULL, NULL, 4128, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:18:22', 'admin-1477714307-14777147026542153', 1, 0, '', NULL, NULL, NULL),
(11607, '2016-10-29 12:18:22', NULL, NULL, 4128, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:18:22', 'admin-1477714307-14777147026542153', 1, 1, 'SR', NULL, NULL, NULL),
(11608, '2016-10-29 12:18:22', NULL, NULL, 4128, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:18:22', 'admin-1477714307-14777147026542153', 1, 0, '', NULL, NULL, NULL),
(11609, '2016-10-29 12:18:22', NULL, NULL, 4128, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:18:22', 'admin-1477714307-14777147026542153', 1, 0, '', NULL, NULL, NULL),
(11610, '2016-10-29 12:18:22', NULL, NULL, 4128, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:18:22', 'admin-1477714307-14777147026542153', 1, 1, 'SR', NULL, NULL, NULL),
(11611, '2016-10-29 12:18:22', NULL, NULL, 4128, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:18:22', 'admin-1477714307-14777147026542153', 1, 1, 'SR', NULL, NULL, NULL),
(11612, '2016-10-29 12:18:22', NULL, NULL, 4128, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:18:22', 'admin-1477714307-14777147026542153', 1, 1, 'SR', NULL, NULL, NULL),
(11613, '2016-10-29 12:18:22', NULL, NULL, 4128, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:18:22', 'admin-1477714307-14777147026542153', 1, 1, 'SR', NULL, NULL, NULL),
(11614, '2016-10-29 12:19:29', NULL, NULL, 4129, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:19:29', 'admin-1477714307-14777147696893661', 1, 1, 'SR', NULL, NULL, NULL),
(11615, '2016-10-29 12:19:29', NULL, NULL, 4129, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:19:29', 'admin-1477714307-14777147696893661', 1, 1, 'SR', NULL, NULL, NULL),
(11616, '2016-10-29 12:19:29', NULL, NULL, 4129, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:19:29', 'admin-1477714307-14777147696893661', 1, 1, 'SR', NULL, NULL, NULL),
(11617, '2016-10-29 12:22:47', NULL, NULL, 4126, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:22:47', 'admin-1477714307-14777149672744588', 1, 1, 'SR', NULL, NULL, NULL),
(11618, '2016-10-29 12:26:52', NULL, NULL, 4130, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:26:52', 'admin-1477714307-14777152122325691', 1, 1, 'SR', NULL, NULL, NULL),
(11619, '2016-10-29 12:31:44', NULL, NULL, 4131, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:31:44', 'admin-1477714307-14777155038893835', 1, 1, 'SR', NULL, NULL, NULL),
(11620, '2016-10-29 12:38:58', NULL, NULL, 4127, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:38:58', 'admin-1477714307-14777159381071671', 1, 0, '', NULL, NULL, NULL),
(11621, '2016-10-29 12:41:04', NULL, NULL, 4129, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:41:04', 'admin-1477716034-14777160644252024', 1, 0, '', NULL, NULL, NULL),
(11622, '2016-10-29 12:42:25', NULL, NULL, 4132, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:42:25', 'admin-1477716034-14777161455642992', 1, 1, 'SR', 1, NULL, NULL),
(11623, '2016-10-29 11:21:15', NULL, NULL, 4123, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:21:15', 'admin-1477708140-14777112756706072', 1, 1, 'SR', NULL, NULL, NULL),
(11624, '2016-10-29 13:25:38', NULL, NULL, 4137, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 13:25:38', 'admin-1477716034-14777187387711953', 1, 0, '', NULL, NULL, NULL),
(11625, '2016-10-29 13:12:36', NULL, NULL, 4136, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 13:12:36', 'admin-1477716034-14777179566256130', 1, 1, 'SR', NULL, NULL, NULL),
(11626, '2016-10-29 13:12:36', NULL, NULL, 4136, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 13:12:36', 'admin-1477716034-14777179566256130', 1, 1, 'SR', NULL, NULL, NULL),
(11627, '2016-10-29 13:12:36', NULL, NULL, 4136, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 13:12:36', 'admin-1477716034-14777179566256130', 1, 1, 'SR', NULL, NULL, NULL),
(11628, '2016-10-29 13:12:36', NULL, NULL, 4136, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 13:12:36', 'admin-1477716034-14777179566256130', 1, 1, 'SR', NULL, NULL, NULL),
(11629, '2016-10-29 13:12:36', NULL, NULL, 4136, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 13:12:36', 'admin-1477716034-14777179566256130', 1, 0, '', NULL, NULL, NULL),
(11630, '2016-10-29 13:11:11', NULL, NULL, 4136, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 13:11:11', 'admin-1477716034-14777178716331068', 1, 0, '', NULL, NULL, NULL),
(11631, '2016-10-29 13:11:11', NULL, NULL, 4136, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 13:11:11', 'admin-1477716034-14777178716331068', 1, 0, '', NULL, NULL, NULL),
(11632, '2016-10-29 11:51:06', NULL, NULL, 4125, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:51:06', 'admin-1477708140-14777130668057156', 1, 1, 'SR', NULL, NULL, NULL),
(11633, '2016-10-29 11:51:06', NULL, NULL, 4125, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:51:06', 'admin-1477708140-14777130668057156', 1, 1, 'SR', NULL, NULL, NULL),
(11634, '2016-10-29 11:51:07', NULL, NULL, 4125, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:51:07', 'admin-1477708140-14777130668057156', 1, 1, 'SR', NULL, NULL, NULL),
(11635, '2016-10-29 11:51:07', NULL, NULL, 4125, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:51:07', 'admin-1477708140-14777130668057156', 1, 0, '', NULL, NULL, NULL),
(11636, '2016-10-29 11:51:07', NULL, NULL, 4125, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:51:07', 'admin-1477708140-14777130668057156', 1, 0, '', NULL, NULL, NULL),
(11637, '2016-10-29 11:58:34', NULL, NULL, 4126, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:58:34', 'admin-1477708140-14777135140933350', 1, 1, 'SR', NULL, NULL, NULL),
(11638, '2016-10-29 11:58:34', NULL, NULL, 4126, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:58:34', 'admin-1477708140-14777135140933350', 1, 1, 'SR', NULL, NULL, NULL),
(11639, '2016-10-29 11:58:34', NULL, NULL, 4126, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:58:34', 'admin-1477708140-14777135140933350', 1, 0, '', NULL, NULL, NULL),
(11640, '2016-10-29 12:00:38', NULL, NULL, 4126, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:00:38', 'admin-1477708140-14777136382953419', 1, 1, 'SR', NULL, NULL, NULL),
(11641, '2016-10-29 12:08:29', NULL, NULL, 4123, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:08:29', 'admin-1477708140-14777141088497538', 1, 0, '', NULL, NULL, NULL),
(11642, '2016-10-29 12:12:48', NULL, NULL, 4127, 0, 222, '156', 'Seasoned Chicken Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:12:48', 'admin-1477714307-14777143684835521', 1, 0, '', NULL, NULL, NULL),
(11643, '2016-10-29 11:39:08', NULL, NULL, 4124, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:39:08', 'admin-1477708140-1477712348079768', 1, 1, 'SR', NULL, NULL, NULL),
(11644, '2016-10-29 11:39:08', NULL, NULL, 4124, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:39:08', 'admin-1477708140-1477712348079768', 1, 1, 'SR', NULL, NULL, NULL),
(11645, '2016-10-29 12:42:25', NULL, NULL, 4132, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:42:25', 'admin-1477716034-14777161455642992', 1, 0, '', 1, NULL, NULL),
(11646, '2016-10-29 12:59:27', NULL, NULL, 4135, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:59:27', 'admin-1477716034-14777171676719721', 1, 1, 'SR', 1, NULL, NULL),
(11647, '2016-10-29 13:11:11', NULL, NULL, 4136, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 13:11:11', 'admin-1477716034-14777178716331068', 1, 0, '', NULL, NULL, NULL),
(11648, '2016-10-29 12:12:48', NULL, NULL, 4127, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:12:48', 'admin-1477714307-14777143684835521', 1, 1, 'SR', NULL, NULL, NULL),
(11649, '2016-10-29 12:12:48', NULL, NULL, 4127, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:12:48', 'admin-1477714307-14777143684835521', 1, 0, '', NULL, NULL, NULL),
(11650, '2016-10-29 12:12:48', NULL, NULL, 4127, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 12:12:48', 'admin-1477714307-14777143684835521', 1, 1, 'SR', NULL, NULL, NULL),
(11651, '2016-10-29 11:39:08', NULL, NULL, 4124, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:39:08', 'admin-1477708140-1477712348079768', 1, 0, '', NULL, NULL, NULL),
(11652, '2016-10-29 11:39:08', NULL, NULL, 4124, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:39:08', 'admin-1477708140-1477712348079768', 1, 0, '', NULL, NULL, NULL),
(11653, '2016-10-29 11:39:08', NULL, NULL, 4124, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:39:08', 'admin-1477708140-1477712348079768', 1, 0, '', NULL, NULL, NULL),
(11654, '2016-10-29 11:39:08', NULL, NULL, 4124, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:39:08', 'admin-1477708140-1477712348079768', 1, 0, '', NULL, NULL, NULL),
(11655, '2016-10-29 11:39:08', NULL, NULL, 4124, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:39:08', 'admin-1477708140-1477712348079768', 1, 0, '', NULL, NULL, NULL),
(11656, '2016-10-29 11:39:08', NULL, NULL, 4124, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:39:08', 'admin-1477708140-1477712348079768', 1, 0, '', NULL, NULL, NULL),
(11657, '2016-10-29 11:39:08', NULL, NULL, 4124, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:39:08', 'admin-1477708140-1477712348079768', 1, 1, 'SR', NULL, NULL, NULL),
(11658, '2016-10-29 11:21:15', NULL, NULL, 4123, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:21:15', 'admin-1477708140-14777112756706072', 1, 1, 'SR', NULL, NULL, NULL),
(11659, '2016-10-29 11:21:15', NULL, NULL, 4123, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:21:15', 'admin-1477708140-14777112756706072', 1, 0, '', NULL, NULL, NULL),
(11660, '2016-10-29 11:21:15', NULL, NULL, 4123, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:21:15', 'admin-1477708140-14777112756706072', 1, 1, 'SR', NULL, NULL, NULL),
(11661, '2016-10-29 11:20:49', NULL, NULL, 4122, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:20:49', 'admin-1477708140-14777112492024041', 1, 0, '', NULL, NULL, NULL),
(11662, '2016-10-29 11:20:49', NULL, NULL, 4122, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:20:49', 'admin-1477708140-14777112492024041', 1, 0, '', NULL, NULL, NULL),
(11663, '2016-10-29 11:20:49', NULL, NULL, 4122, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:20:49', 'admin-1477708140-14777112492024041', 1, 0, '', NULL, NULL, NULL),
(11664, '2016-10-29 09:49:11', NULL, NULL, 4115, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:49:11', 'admin-1477702887-14777057508936813', 1, 0, '', NULL, NULL, NULL),
(11665, '2016-10-29 09:49:11', NULL, NULL, 4115, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:49:11', 'admin-1477702887-14777057508936813', 1, 0, '', NULL, NULL, NULL),
(11666, '2016-10-29 09:49:11', NULL, NULL, 4115, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:49:11', 'admin-1477702887-14777057508936813', 1, 0, '', NULL, NULL, NULL),
(11667, '2016-10-29 09:49:11', NULL, NULL, 4115, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:49:11', 'admin-1477702887-14777057508936813', 1, 0, '', NULL, NULL, NULL),
(11668, '2016-10-29 09:49:11', NULL, NULL, 4115, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:49:11', 'admin-1477702887-14777057508936813', 1, 1, 'SR', NULL, NULL, NULL),
(11669, '2016-10-29 09:49:11', NULL, NULL, 4115, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:49:11', 'admin-1477702887-14777057508936813', 1, 1, 'SR', NULL, NULL, NULL),
(11670, '2016-10-29 09:49:11', NULL, NULL, 4115, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:49:11', 'admin-1477702887-14777057508936813', 1, 1, 'SR', NULL, NULL, NULL),
(11671, '2016-10-29 09:50:51', NULL, NULL, 4115, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:50:51', 'admin-1477702887-14777058512818414', 1, 1, 'SR', NULL, NULL, NULL),
(11672, '2016-10-29 09:50:51', NULL, NULL, 4115, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:50:51', 'admin-1477702887-14777058512818414', 1, 1, 'SR', NULL, NULL, NULL),
(11673, '2016-10-29 10:04:46', NULL, NULL, 4115, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 10:04:46', 'admin-1477702887-14777066858977399', 1, 1, 'SR', NULL, NULL, NULL),
(11674, '2016-10-29 10:05:03', NULL, NULL, 4116, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 10:05:03', 'admin-1477702887-1477706703439736', 1, 1, 'SR', 1, NULL, NULL),
(11675, '2016-10-29 10:05:03', NULL, NULL, 4116, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 10:05:03', 'admin-1477702887-1477706703439736', 1, 1, 'SR', 1, NULL, NULL),
(11676, '2016-10-29 10:06:17', NULL, NULL, 4116, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 10:06:17', 'admin-1477702887-1477706777305659', 1, 0, '', 1, NULL, NULL),
(11677, '2016-10-29 10:10:34', NULL, NULL, 4117, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 10:10:34', 'admin-1477702887-14777070342901080', 1, 1, 'SR', NULL, NULL, NULL),
(11678, '2016-10-29 10:10:34', NULL, NULL, 4117, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 10:10:34', 'admin-1477702887-14777070342901080', 1, 1, 'SR', NULL, NULL, NULL),
(11679, '2016-10-29 10:10:39', NULL, NULL, 4118, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 10:10:39', 'admin-1477702887-14777070395496731', 1, 0, '', 1, NULL, NULL),
(11680, '2016-10-29 10:10:39', NULL, NULL, 4118, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 10:10:39', 'admin-1477702887-14777070395496731', 1, 0, '', 1, NULL, NULL),
(11681, '2016-10-29 10:27:01', NULL, NULL, 4112, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 10:27:01', 'admin-1477702887-1477708021345999', 1, 1, 'SR', NULL, NULL, NULL),
(11682, '2016-10-29 10:27:10', NULL, NULL, 4119, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 10:27:10', 'admin-1477702887-1477708030571523', 1, 1, 'SR', NULL, NULL, NULL),
(11683, '2016-10-29 10:27:10', NULL, NULL, 4119, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 10:27:10', 'admin-1477702887-1477708030571523', 1, 1, 'SR', NULL, NULL, NULL),
(11684, '2016-10-29 10:28:33', NULL, NULL, 4120, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 10:28:33', 'admin-1477702887-14777081128614166', 1, 0, '', NULL, NULL, NULL),
(11685, '2016-10-29 10:28:33', NULL, NULL, 4120, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 10:28:33', 'admin-1477702887-14777081128614166', 1, 0, '', NULL, NULL, NULL),
(11686, '2016-10-29 10:28:33', NULL, NULL, 4120, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 10:28:33', 'admin-1477702887-14777081128614166', 1, 0, '', NULL, NULL, NULL),
(11687, '2016-10-29 10:29:13', NULL, NULL, 4120, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 10:29:13', 'admin-1477708140-1477708153304583', 1, 1, 'SR', NULL, NULL, NULL),
(11688, '2016-10-29 10:29:13', NULL, NULL, 4120, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 10:29:13', 'admin-1477708140-1477708153304583', 1, 1, 'SR', NULL, NULL, NULL),
(11689, '2016-10-29 10:29:13', NULL, NULL, 4120, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 10:29:13', 'admin-1477708140-1477708153304583', 1, 1, 'SR', NULL, NULL, NULL),
(11690, '2016-10-29 10:29:13', NULL, NULL, 4120, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 10:29:13', 'admin-1477708140-1477708153304583', 1, 1, 'SR', NULL, NULL, NULL),
(11691, '2016-10-29 10:33:39', NULL, NULL, 4119, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 10:33:39', 'admin-1477708140-1477708419758103', 1, 1, 'SR', NULL, NULL, NULL),
(11692, '2016-10-29 10:48:24', NULL, NULL, 4121, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 10:48:24', 'admin-1477708140-14777093042995185', 1, 1, 'SR', NULL, NULL, NULL),
(11693, '2016-10-29 11:20:49', NULL, NULL, 4122, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:20:49', 'admin-1477708140-14777112492024041', 1, 1, 'SR', NULL, NULL, NULL),
(11694, '2016-10-29 11:20:49', NULL, NULL, 4122, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 11:20:49', 'admin-1477708140-14777112492024041', 1, 0, '', NULL, NULL, NULL),
(11695, '2016-10-29 09:33:49', NULL, NULL, 4114, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:33:49', 'admin-1477702887-1477704828794822', 1, 0, '', NULL, NULL, NULL),
(11696, '2016-10-29 09:33:49', NULL, NULL, 4114, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:33:49', 'admin-1477702887-1477704828794822', 1, 0, '', NULL, NULL, NULL),
(11697, '2016-10-29 09:33:49', NULL, NULL, 4114, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:33:49', 'admin-1477702887-1477704828794822', 1, 0, '', NULL, NULL, NULL),
(11698, '2016-10-29 09:25:14', NULL, NULL, 4113, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:25:14', 'admin-1477702887-14777043138825990', 1, 0, '', NULL, NULL, NULL),
(11699, '2016-10-29 09:33:49', NULL, NULL, 4114, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:33:49', 'admin-1477702887-1477704828794822', 1, 1, 'SR', NULL, NULL, NULL),
(11700, '2016-10-29 09:20:22', NULL, NULL, 4112, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:20:22', 'admin-1477702887-14777040226621173', 1, 1, 'SR', NULL, NULL, NULL),
(11701, '2016-10-29 09:16:45', NULL, NULL, 4111, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:16:45', 'admin-1477702887-14777038047991860', 1, 1, 'SR', NULL, NULL, NULL),
(11702, '2016-10-29 09:16:45', NULL, NULL, 4111, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:16:45', 'admin-1477702887-14777038047991860', 1, 1, 'SR', NULL, NULL, NULL),
(11703, '2016-10-29 09:20:09', NULL, NULL, 4112, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:20:09', 'admin-1477702887-14777040096263692', 1, 0, '', NULL, NULL, NULL),
(11704, '2016-10-29 09:16:45', NULL, NULL, 4111, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:16:45', 'admin-1477702887-14777038047991860', 1, 0, '', NULL, NULL, NULL),
(11705, '2016-10-29 09:16:45', NULL, NULL, 4111, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:16:45', 'admin-1477702887-14777038047991860', 1, 0, '', NULL, NULL, NULL),
(11706, '2016-10-29 09:16:44', NULL, NULL, 4111, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:16:44', 'admin-1477702887-14777038047991860', 1, 0, '', NULL, NULL, NULL),
(11707, '2016-10-29 09:16:44', NULL, NULL, 4111, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:16:44', 'admin-1477702887-14777038047991860', 1, 1, 'SR', NULL, NULL, NULL),
(11708, '2016-10-29 09:16:44', NULL, NULL, 4111, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:16:44', 'admin-1477702887-14777038047991860', 1, 1, 'SR', NULL, NULL, NULL),
(11709, '2016-10-29 09:16:44', NULL, NULL, 4111, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:16:44', 'admin-1477702887-14777038047991860', 1, 0, '', NULL, NULL, NULL),
(11710, '2016-10-29 09:08:24', NULL, NULL, 4110, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477719603', 'admin', '2016-10-29 09:08:24', 'admin-1477702887-14777033044043261', 1, 1, 'SR', 1, NULL, NULL),
(11711, '2016-10-30 18:38:43', NULL, NULL, 4190, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 18:38:43', 'admin-1477809200-14778239236794518', 1, 1, 'SR', NULL, NULL, NULL),
(11712, '2016-10-30 14:41:01', NULL, NULL, 4178, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 14:41:01', 'admin-1477809200-14778096609179818', 1, 1, 'SR', NULL, NULL, NULL),
(11713, '2016-10-30 11:07:27', NULL, NULL, 4157, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:07:27', 'admin-1477796581-14777968470368333', 1, 1, 'SR', NULL, NULL, NULL),
(11714, '2016-10-30 11:07:27', NULL, NULL, 4157, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:07:27', 'admin-1477796581-14777968470368333', 1, 1, 'SR', NULL, NULL, NULL),
(11715, '2016-10-30 11:11:47', NULL, NULL, 4163, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:11:47', 'admin-1477796581-14777971074796728', 1, 0, '', NULL, NULL, NULL),
(11716, '2016-10-30 11:11:47', NULL, NULL, 4163, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:11:47', 'admin-1477796581-14777971074796728', 1, 1, 'SR', NULL, NULL, NULL),
(11717, '2016-10-30 11:12:37', NULL, NULL, 4165, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:12:37', 'admin-1477796581-14777971571009645', 1, 0, '', NULL, NULL, NULL),
(11718, '2016-10-30 11:12:37', NULL, NULL, 4165, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:12:37', 'admin-1477796581-14777971571009645', 1, 1, 'SR', NULL, NULL, NULL),
(11719, '2016-10-30 11:13:50', NULL, NULL, 4166, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:13:50', 'admin-1477796581-14777972303041252', 1, 0, '', NULL, NULL, NULL),
(11720, '2016-10-30 11:13:50', NULL, NULL, 4166, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:13:50', 'admin-1477796581-14777972303041252', 1, 1, 'SR', NULL, NULL, NULL),
(11721, '2016-10-30 20:31:01', NULL, NULL, 4194, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 20:31:01', 'admin-1477809200-14778306613218154', 1, 1, 'SR', NULL, NULL, NULL),
(11722, '2016-10-30 20:31:01', NULL, NULL, 4194, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 20:31:01', 'admin-1477809200-14778306613218154', 1, 0, '', NULL, NULL, NULL),
(11723, '2016-10-30 20:31:51', NULL, NULL, 4195, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 20:31:51', 'admin-1477809200-14778307117059383', 1, 1, 'SR', NULL, NULL, NULL),
(11724, '2016-10-30 20:31:51', NULL, NULL, 4195, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 20:31:51', 'admin-1477809200-14778307117059383', 1, 1, 'SR', NULL, NULL, NULL),
(11725, '2016-10-30 20:31:51', NULL, NULL, 4195, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 20:31:51', 'admin-1477809200-14778307117059383', 1, 1, 'SR', NULL, NULL, NULL),
(11726, '2016-10-30 20:51:18', NULL, NULL, 4196, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 20:51:18', 'admin-1477809200-14778318778429713', 1, 0, '', NULL, NULL, NULL),
(11727, '2016-10-30 20:51:18', NULL, NULL, 4196, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 20:51:18', 'admin-1477809200-14778318778429713', 1, 0, '', NULL, NULL, NULL),
(11728, '2016-10-30 20:51:18', NULL, NULL, 4196, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 20:51:18', 'admin-1477809200-14778318778429713', 1, 0, '', NULL, NULL, NULL),
(11729, '2016-10-30 20:51:18', NULL, NULL, 4196, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 20:51:18', 'admin-1477809200-14778318778429713', 1, 0, '', NULL, NULL, NULL),
(11730, '2016-10-30 20:54:22', NULL, NULL, 4197, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 20:54:22', 'admin-1477831929-14778320619063596', 1, 1, 'SR', NULL, NULL, NULL),
(11731, '2016-10-30 20:54:22', NULL, NULL, 4197, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 20:54:22', 'admin-1477831929-14778320619063596', 1, 1, 'SR', NULL, NULL, NULL),
(11732, '2016-10-30 20:27:17', NULL, NULL, 4193, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 20:27:17', 'admin-1477809200-14778304375732561', 1, 1, 'SR', NULL, NULL, NULL),
(11733, '2016-10-30 20:27:17', NULL, NULL, 4193, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 20:27:17', 'admin-1477809200-14778304375732561', 1, 1, 'SR', NULL, NULL, NULL),
(11734, '2016-10-30 20:13:56', NULL, NULL, 4192, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 20:13:56', 'admin-1477809200-14778296367436884', 1, 0, '', NULL, NULL, NULL),
(11735, '2016-10-30 17:33:46', NULL, NULL, 4186, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 17:33:46', 'admin-1477809200-14778200260235688', 1, 1, 'SR', NULL, NULL, NULL),
(11736, '2016-10-30 17:48:01', NULL, NULL, 4187, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 17:48:01', 'admin-1477809200-14778208810431073', 1, 0, '', NULL, NULL, NULL),
(11737, '2016-10-30 17:54:51', NULL, NULL, 4184, 0, 222, '156', 'Seasoned Chicken Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 17:54:51', 'admin-1477809200-14778212917954565', 1, 0, '', NULL, NULL, NULL),
(11738, '2016-10-30 19:53:12', NULL, NULL, 4192, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 19:53:12', 'admin-1477809200-1477828392197225', 1, 1, 'SR', NULL, NULL, NULL),
(11739, '2016-10-30 18:08:02', NULL, NULL, 4188, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 18:08:02', 'admin-1477809200-14778220823268842', 1, 1, 'SR', NULL, NULL, NULL),
(11740, '2016-10-30 19:53:12', NULL, NULL, 4192, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 19:53:12', 'admin-1477809200-1477828392197225', 1, 0, '', NULL, NULL, NULL),
(11741, '2016-10-30 19:53:12', NULL, NULL, 4192, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 19:53:12', 'admin-1477809200-1477828392197225', 1, 0, '', NULL, NULL, NULL),
(11742, '2016-10-30 19:53:12', NULL, NULL, 4192, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 19:53:12', 'admin-1477809200-1477828392197225', 1, 1, 'SR', NULL, NULL, NULL),
(11743, '2016-10-30 19:23:25', NULL, NULL, 4191, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 19:23:25', 'admin-1477809200-1477826605753989', 1, 1, 'SR', 1, NULL, NULL),
(11744, '2016-10-30 16:53:31', NULL, NULL, 4184, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 16:53:31', 'admin-1477809200-14778176112914817', 1, 1, 'SR', NULL, NULL, NULL),
(11745, '2016-10-30 13:17:57', NULL, NULL, 4175, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 13:17:57', 'admin-1477804305-14778046768829097', 1, 1, 'SR', NULL, NULL, NULL),
(11746, '2016-10-30 18:43:36', NULL, NULL, 4189, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 18:43:36', 'admin-1477809200-14778242165697662', 1, 1, 'SR', NULL, NULL, NULL),
(11747, '2016-10-30 14:44:54', NULL, NULL, 4177, 0, 182, '117', 'Open Drinks ', 'banana', 'Cold Drinks', 'Fresh Juice', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 14:44:54', 'admin-1477809200-14778098941598141', 1, 0, '', NULL, NULL, NULL),
(11748, '2016-10-30 14:55:57', NULL, NULL, 4179, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 14:55:57', 'admin-1477809200-1477810557075480', 1, 0, '', NULL, NULL, '10.0'),
(11749, '2016-10-30 18:19:28', NULL, NULL, 4189, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 18:19:28', 'admin-1477809200-1477822768525807', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(11750, '2016-10-30 18:38:43', NULL, NULL, 4190, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 18:38:43', 'admin-1477809200-14778239236794518', 1, 1, 'SR', NULL, NULL, NULL),
(11751, '2016-10-30 18:38:43', NULL, NULL, 4190, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 18:38:43', 'admin-1477809200-14778239236794518', 1, 0, '', NULL, NULL, NULL),
(11752, '2016-10-30 18:19:28', NULL, NULL, 4189, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 18:19:28', 'admin-1477809200-1477822768525807', 1, 1, 'SR', NULL, NULL, NULL),
(11753, '2016-10-30 17:54:51', NULL, NULL, 4184, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 17:54:51', 'admin-1477809200-14778212917954565', 1, 0, '', NULL, NULL, NULL),
(11754, '2016-10-30 15:24:24', NULL, NULL, 4180, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 15:24:24', 'admin-1477809200-14778122645231874', 1, 1, 'SR', NULL, NULL, NULL),
(11755, '2016-10-30 15:24:24', NULL, NULL, 4180, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 15:24:24', 'admin-1477809200-14778122645231874', 1, 1, 'SR', NULL, NULL, NULL),
(11756, '2016-10-30 16:10:06', NULL, NULL, 4181, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 16:10:06', 'admin-1477809200-14778150064883799', 1, 0, '', NULL, NULL, '10.0'),
(11757, '2016-10-30 16:10:06', NULL, NULL, 4181, 0, 228, '162', 'Golden Brown', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 16:10:06', 'admin-1477809200-14778150064883799', 1, 0, '', NULL, NULL, '10.0'),
(11758, '2016-10-30 16:26:36', NULL, NULL, 4182, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 16:26:36', 'admin-1477809200-14778159958919696', 1, 1, 'SR', NULL, NULL, NULL),
(11759, '2016-10-30 16:26:36', NULL, NULL, 4182, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 16:26:36', 'admin-1477809200-14778159958919696', 1, 0, '', NULL, NULL, NULL),
(11760, '2016-10-30 16:35:47', NULL, NULL, 4183, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 16:35:47', 'admin-1477809200-14778165473588382', 1, 1, 'SR', NULL, NULL, NULL),
(11761, '2016-10-30 12:32:03', NULL, NULL, 4173, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 12:32:03', 'admin-1477797817-1477801923236999', 1, 0, '', 1, NULL, NULL),
(11762, '2016-10-30 12:32:03', NULL, NULL, 4173, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 12:32:03', 'admin-1477797817-1477801923236999', 1, 1, 'SR', 1, NULL, NULL),
(11763, '2016-10-30 12:34:03', NULL, NULL, 4171, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 12:34:03', 'admin-1477797817-14778020428065468', 1, 1, 'SR', NULL, NULL, '10.0'),
(11764, '2016-10-30 12:34:03', NULL, NULL, 4171, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 12:34:03', 'admin-1477797817-14778020428065468', 1, 1, 'SR', NULL, NULL, '10.0'),
(11765, '2016-10-30 12:34:03', NULL, NULL, 4171, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 12:34:03', 'admin-1477797817-14778020428065468', 1, 1, 'SR', NULL, NULL, '10.0'),
(11766, '2016-10-30 12:34:03', NULL, NULL, 4171, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 12:34:03', 'admin-1477797817-14778020428065468', 1, 0, '', NULL, NULL, '10.0'),
(11767, '2016-10-30 12:34:13', NULL, NULL, 4171, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 12:34:13', 'admin-1477797817-14778020532094518', 1, 0, '', NULL, NULL, '10.0'),
(11768, '2016-10-30 12:34:49', NULL, NULL, 4171, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 12:34:49', 'admin-1477797817-14778020891587178', 1, 1, 'SR', NULL, NULL, '10.0'),
(11769, '2016-10-30 12:52:56', NULL, NULL, 4174, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 12:52:56', 'admin-1477797817-14778031760297695', 1, 0, '', NULL, NULL, NULL),
(11770, '2016-10-30 12:52:56', NULL, NULL, 4174, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 12:52:56', 'admin-1477797817-14778031760297695', 1, 1, 'SR', NULL, NULL, NULL),
(11771, '2016-10-30 12:54:17', NULL, NULL, 4174, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 12:54:17', 'admin-1477797817-14778032568887032', 1, 1, 'SR', NULL, NULL, NULL),
(11772, '2016-10-30 13:00:45', NULL, NULL, 4171, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 13:00:45', 'admin-1477797817-14778036452008427', 1, 1, 'SR', NULL, NULL, '10.0'),
(11773, '2016-10-30 13:11:31', NULL, NULL, 4175, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 13:11:31', 'admin-1477797817-14778042913217255', 1, 0, '', NULL, NULL, NULL),
(11774, '2016-10-30 13:11:53', NULL, NULL, 4175, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 13:11:53', 'admin-1477804305-14778043129419791', 1, 1, 'SR', NULL, NULL, NULL),
(11775, '2016-10-30 11:54:33', NULL, NULL, 4168, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:54:33', 'admin-1477797817-14777996733342855', 1, 0, '', NULL, NULL, NULL),
(11776, '2016-10-30 11:54:33', NULL, NULL, 4168, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:54:33', 'admin-1477797817-14777996733342855', 1, 0, '', NULL, NULL, NULL),
(11777, '2016-10-30 09:40:40', NULL, NULL, 4152, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:40:40', 'admin-1477788162-14777916399975292', 1, 0, '', NULL, NULL, NULL),
(11778, '2016-10-30 17:33:46', NULL, NULL, 4186, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 17:33:46', 'admin-1477809200-14778200260235688', 1, 1, 'SR', NULL, NULL, NULL),
(11779, '2016-10-30 17:11:08', NULL, NULL, 4185, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 17:11:08', 'admin-1477809200-14778186678454752', 1, 0, '', NULL, NULL, NULL),
(11780, '2016-10-30 16:53:31', NULL, NULL, 4184, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 16:53:31', 'admin-1477809200-14778176112914817', 1, 0, '', NULL, NULL, NULL),
(11781, '2016-10-30 11:23:33', NULL, NULL, 4167, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:23:33', 'admin-1477796581-14777978136708215', 1, 0, '', NULL, NULL, NULL),
(11782, '2016-10-30 14:41:01', NULL, NULL, 4178, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 14:41:01', 'admin-1477809200-14778096609179818', 1, 1, 'SR', NULL, NULL, NULL),
(11783, '2016-10-30 14:41:01', NULL, NULL, 4178, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 14:41:01', 'admin-1477809200-14778096609179818', 1, 1, 'SR', NULL, NULL, NULL),
(11784, '2016-10-30 14:41:01', NULL, NULL, 4178, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 14:41:01', 'admin-1477809200-14778096609179818', 1, 1, 'SR', NULL, NULL, NULL),
(11785, '2016-10-30 14:41:01', NULL, NULL, 4178, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 14:41:01', 'admin-1477809200-14778096609179818', 1, 1, 'SR', NULL, NULL, NULL),
(11786, '2016-10-30 14:22:07', NULL, NULL, 4177, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 14:22:07', 'admin-1477804305-14778085268762221', 1, 1, 'SR', NULL, NULL, NULL),
(11787, '2016-10-30 14:22:07', NULL, NULL, 4177, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 14:22:07', 'admin-1477804305-14778085268762221', 1, 0, '', NULL, NULL, NULL),
(11788, '2016-10-30 14:22:07', NULL, NULL, 4177, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 14:22:07', 'admin-1477804305-14778085268762221', 1, 1, 'SR', NULL, NULL, NULL),
(11789, '2016-10-30 14:12:44', NULL, NULL, 4176, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 14:12:44', 'admin-1477804305-14778079641855082', 1, 1, 'SR', NULL, NULL, NULL),
(11790, '2016-10-30 13:57:14', NULL, NULL, 4175, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 13:57:14', 'admin-1477804305-14778070345801896', 1, 1, 'SR', NULL, NULL, NULL),
(11791, '2016-10-30 13:53:58', NULL, NULL, 4175, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 13:53:58', 'admin-1477804305-14778068382951789', 1, 0, '', NULL, NULL, NULL),
(11792, '2016-10-30 13:53:58', NULL, NULL, 4175, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 13:53:58', 'admin-1477804305-14778068382951789', 1, 1, 'SR', NULL, NULL, NULL),
(11793, '2016-10-30 13:46:23', NULL, NULL, 4171, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 13:46:23', 'admin-1477804305-14778063836686236', 1, 1, 'SR', NULL, NULL, '10.0'),
(11794, '2016-10-30 13:46:23', NULL, NULL, 4171, 0, 181, '116', 'Open Food ', 'BFF egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1477831929', 'admin', '2016-10-30 13:46:23', 'admin-1477804305-14778063836686236', 1, 0, '', NULL, NULL, '10.0'),
(11795, '2016-10-30 13:45:33', NULL, NULL, 4171, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 13:45:33', 'admin-1477804305-14778063332633610', 1, 1, 'SR', NULL, NULL, '10.0'),
(11796, '2016-10-30 13:35:12', NULL, NULL, 4175, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 13:35:12', 'admin-1477804305-14778057122709759', 1, 1, 'SR', NULL, NULL, NULL),
(11797, '2016-10-30 13:22:17', NULL, NULL, 4175, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 13:22:17', 'admin-1477804305-14778049374277911', 1, 1, 'SR', NULL, NULL, NULL),
(11798, '2016-10-30 13:22:17', NULL, NULL, 4175, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 13:22:17', 'admin-1477804305-14778049374277911', 1, 1, 'SR', NULL, NULL, NULL),
(11799, '2016-10-30 13:22:17', NULL, NULL, 4175, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 13:22:17', 'admin-1477804305-14778049374277911', 1, 1, 'SR', NULL, NULL, NULL),
(11800, '2016-10-30 13:20:19', NULL, NULL, 4175, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 13:20:19', 'admin-1477804305-14778048189788247', 1, 0, '', NULL, NULL, NULL),
(11801, '2016-10-30 13:19:54', NULL, NULL, 4175, 0, 158, '92', 'Nutella Toast ', 'no honey', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 13:19:54', 'admin-1477804305-14778047943605260', 1, 0, '', NULL, NULL, NULL),
(11802, '2016-10-30 12:29:05', NULL, NULL, 4172, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 12:29:05', 'admin-1477797817-1477801745565441', 1, 0, '', NULL, NULL, NULL),
(11803, '2016-10-30 12:29:05', NULL, NULL, 4172, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 12:29:05', 'admin-1477797817-1477801745565441', 1, 1, 'SR', NULL, NULL, NULL),
(11804, '2016-10-30 12:29:05', NULL, NULL, 4172, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 12:29:05', 'admin-1477797817-1477801745565441', 1, 1, 'SR', NULL, NULL, NULL),
(11805, '2016-10-30 12:20:17', NULL, NULL, 4171, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 12:20:17', 'admin-1477797817-14778012174079253', 1, 0, '', NULL, NULL, '10.0'),
(11806, '2016-10-30 12:09:48', NULL, NULL, 4169, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 12:09:48', 'admin-1477797817-1477800587814749', 1, 1, 'SR', NULL, NULL, NULL),
(11807, '2016-10-30 12:14:59', NULL, NULL, 4170, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 12:14:59', 'admin-1477797817-14778008992878693', 1, 1, 'SR', NULL, NULL, NULL),
(11808, '2016-10-30 12:14:59', NULL, NULL, 4170, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 12:14:59', 'admin-1477797817-14778008992878693', 1, 1, 'SR', NULL, NULL, NULL),
(11809, '2016-10-30 12:09:47', NULL, NULL, 4169, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 12:09:47', 'admin-1477797817-1477800587814749', 1, 0, '', NULL, NULL, NULL),
(11810, '2016-10-30 11:54:08', NULL, NULL, 4168, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:54:08', 'admin-1477797817-14777996478438778', 1, 1, 'SR', NULL, NULL, NULL),
(11811, '2016-10-30 11:54:07', NULL, NULL, 4168, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:54:07', 'admin-1477797817-14777996478438778', 1, 0, '', NULL, NULL, NULL),
(11812, '2016-10-30 11:54:07', NULL, NULL, 4168, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:54:08', 'admin-1477797817-14777996478438778', 1, 1, 'SR', NULL, NULL, NULL),
(11813, '2016-10-30 11:23:33', NULL, NULL, 4167, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:23:33', 'admin-1477796581-14777978136708215', 1, 1, 'SR', NULL, NULL, NULL),
(11814, '2016-10-30 11:23:33', NULL, NULL, 4167, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:23:33', 'admin-1477796581-14777978136708215', 1, 1, 'SR', NULL, NULL, NULL),
(11815, '2016-10-30 11:19:58', NULL, NULL, 4160, 0, 228, '162', 'Golden Brown', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:19:58', 'admin-1477796581-14777975986295313', 1, 0, '', NULL, NULL, NULL),
(11816, '2016-10-30 11:23:33', NULL, NULL, 4167, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:23:33', 'admin-1477796581-14777978136708215', 1, 0, '', NULL, NULL, NULL),
(11817, '2016-10-30 11:13:50', NULL, NULL, 4166, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:13:50', 'admin-1477796581-14777972303041252', 1, 0, '', NULL, NULL, NULL),
(11818, '2016-10-30 11:14:16', NULL, NULL, 4166, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:14:16', 'admin-1477796581-14777972561459889', 1, 1, 'SR', NULL, NULL, NULL),
(11819, '2016-10-30 09:51:22', NULL, NULL, 4153, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:51:22', 'admin-1477788162-14777922820589987', 1, 1, 'SR', NULL, NULL, NULL),
(11820, '2016-10-30 09:52:23', NULL, NULL, 4154, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:52:23', 'admin-1477788162-14777923430271230', 1, 0, '', NULL, NULL, NULL),
(11821, '2016-10-30 09:58:12', NULL, NULL, 4155, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:58:12', 'admin-1477792371-14777926925397172', 1, 0, '', NULL, NULL, NULL),
(11822, '2016-10-30 09:58:12', NULL, NULL, 4155, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:58:12', 'admin-1477792371-14777926925397172', 1, 0, '', NULL, NULL, NULL),
(11823, '2016-10-30 09:58:12', NULL, NULL, 4155, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:58:12', 'admin-1477792371-14777926925397172', 1, 0, '', NULL, NULL, NULL),
(11824, '2016-10-30 09:58:43', NULL, NULL, 4155, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:58:43', 'admin-1477792371-1477792723140379', 1, 1, 'SR', NULL, NULL, NULL),
(11825, '2016-10-30 09:58:43', NULL, NULL, 4155, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:58:43', 'admin-1477792371-1477792723140379', 1, 1, 'SR', NULL, NULL, NULL),
(11826, '2016-10-30 09:58:43', NULL, NULL, 4155, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:58:43', 'admin-1477792371-1477792723140379', 1, 1, 'SR', NULL, NULL, NULL),
(11827, '2016-10-30 10:03:45', NULL, NULL, 4156, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 10:03:45', 'admin-1477792371-14777930249023943', 1, 1, 'SR', NULL, NULL, NULL),
(11828, '2016-10-30 10:03:45', NULL, NULL, 4156, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 10:03:45', 'admin-1477792371-14777930249023943', 1, 1, 'SR', NULL, NULL, NULL),
(11829, '2016-10-30 10:03:45', NULL, NULL, 4156, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 10:03:45', 'admin-1477792371-14777930249023943', 1, 0, '', NULL, NULL, NULL),
(11830, '2016-10-30 10:09:44', NULL, NULL, 4157, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 10:09:44', 'admin-1477792371-14777933841771470', 1, 1, 'SR', NULL, NULL, NULL),
(11831, '2016-10-30 10:09:44', NULL, NULL, 4157, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 10:09:44', 'admin-1477792371-14777933841771470', 1, 1, 'SR', NULL, NULL, NULL),
(11832, '2016-10-30 10:09:44', NULL, NULL, 4157, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 10:09:44', 'admin-1477792371-14777933841771470', 1, 1, 'SR', NULL, NULL, NULL),
(11833, '2016-10-30 10:09:57', NULL, NULL, 4158, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 10:09:57', 'admin-1477792371-14777933973285326', 1, 0, '', NULL, NULL, NULL),
(11834, '2016-10-30 10:09:57', NULL, NULL, 4158, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 10:09:57', 'admin-1477792371-14777933973285326', 1, 0, '', NULL, NULL, NULL),
(11835, '2016-10-30 10:31:44', NULL, NULL, 4159, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 10:31:44', 'admin-1477792371-14777947045627187', 1, 0, '', NULL, NULL, NULL),
(11836, '2016-10-30 10:31:44', NULL, NULL, 4159, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 10:31:44', 'admin-1477792371-14777947045627187', 1, 0, '', NULL, NULL, NULL),
(11837, '2016-10-30 10:32:07', NULL, NULL, 4159, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 10:32:07', 'admin-1477792371-14777947269523942', 1, 1, 'SR', NULL, NULL, NULL),
(11838, '2016-10-30 10:32:07', NULL, NULL, 4159, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 10:32:07', 'admin-1477792371-14777947269523942', 1, 1, 'SR', NULL, NULL, NULL),
(11839, '2016-10-30 10:48:21', NULL, NULL, 4160, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 10:48:21', 'admin-1477792371-14777957015408731', 1, 0, '', NULL, NULL, NULL),
(11840, '2016-10-30 10:48:21', NULL, NULL, 4160, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 10:48:21', 'admin-1477792371-14777957015408731', 1, 0, '', NULL, NULL, NULL),
(11841, '2016-10-30 10:48:21', NULL, NULL, 4160, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 10:48:21', 'admin-1477792371-14777957015408731', 1, 1, 'SR', NULL, NULL, NULL),
(11842, '2016-10-30 10:48:21', NULL, NULL, 4160, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 10:48:21', 'admin-1477792371-14777957015408731', 1, 1, 'SR', NULL, NULL, NULL),
(11843, '2016-10-30 10:59:26', NULL, NULL, 4161, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 10:59:26', 'admin-1477792371-14777963659193480', 1, 0, '', NULL, NULL, NULL),
(11844, '2016-10-30 10:59:26', NULL, NULL, 4161, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 10:59:26', 'admin-1477792371-14777963659193480', 1, 1, 'SR', NULL, NULL, NULL),
(11845, '2016-10-30 10:59:26', NULL, NULL, 4161, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 10:59:26', 'admin-1477792371-14777963659193480', 1, 1, 'SR', NULL, NULL, NULL),
(11846, '2016-10-30 11:02:50', NULL, NULL, 4162, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:02:50', 'admin-1477792371-14777965702823799', 1, 0, '', NULL, NULL, NULL),
(11847, '2016-10-30 11:02:50', NULL, NULL, 4162, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:02:50', 'admin-1477792371-14777965702823799', 1, 0, '', NULL, NULL, NULL),
(11848, '2016-10-30 11:02:50', NULL, NULL, 4162, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:02:50', 'admin-1477792371-14777965702823799', 1, 1, 'SR', NULL, NULL, NULL),
(11849, '2016-10-30 11:07:27', NULL, NULL, 4157, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 11:07:27', 'admin-1477796581-14777968470368333', 1, 1, 'SR', NULL, NULL, NULL),
(11850, '2016-10-30 09:51:22', NULL, NULL, 4153, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:51:22', 'admin-1477788162-14777922820589987', 1, 1, 'SR', NULL, NULL, NULL),
(11851, '2016-10-30 09:41:07', NULL, NULL, 4152, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:41:07', 'admin-1477788162-1477791667310542', 1, 1, 'SR', NULL, NULL, NULL),
(11852, '2016-10-30 09:41:07', NULL, NULL, 4152, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:41:07', 'admin-1477788162-1477791667310542', 1, 1, 'SR', NULL, NULL, NULL),
(11853, '2016-10-30 09:51:03', NULL, NULL, 4153, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:51:03', 'admin-1477788162-14777922629816170', 1, 0, '', NULL, NULL, NULL),
(11854, '2016-10-30 09:51:03', NULL, NULL, 4153, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:51:03', 'admin-1477788162-14777922629816170', 1, 0, '', NULL, NULL, NULL),
(11855, '2016-10-30 09:40:40', NULL, NULL, 4152, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:40:40', 'admin-1477788162-14777916399975292', 1, 0, '', NULL, NULL, NULL),
(11856, '2016-10-30 09:31:10', NULL, NULL, 4151, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:31:10', 'admin-1477788162-14777910703514346', 1, 1, 'SR', NULL, NULL, NULL),
(11857, '2016-10-30 09:31:10', NULL, NULL, 4151, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:31:10', 'admin-1477788162-14777910703514346', 1, 0, '', NULL, NULL, NULL),
(11858, '2016-10-30 09:40:40', NULL, NULL, 4152, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:40:40', 'admin-1477788162-14777916399975292', 1, 0, '', NULL, NULL, NULL),
(11859, '2016-10-30 09:30:21', NULL, NULL, 4151, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:30:21', 'admin-1477788162-14777910213016758', 1, 0, '', NULL, NULL, NULL),
(11860, '2016-10-30 09:30:59', NULL, NULL, 4151, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:30:59', 'admin-1477788162-14777910588594325', 1, 0, '', NULL, NULL, NULL),
(11861, '2016-10-30 09:21:31', NULL, NULL, 4150, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:21:31', 'admin-1477788162-14777904909638642', 1, 0, '', NULL, NULL, NULL),
(11862, '2016-10-30 09:21:41', NULL, NULL, 4150, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:21:41', 'admin-1477788162-14777905014722891', 1, 0, '', NULL, NULL, NULL),
(11863, '2016-10-30 09:21:31', NULL, NULL, 4150, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:21:31', 'admin-1477788162-14777904909638642', 1, 0, '', NULL, NULL, NULL),
(11864, '2016-10-30 09:21:31', NULL, NULL, 4150, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:21:31', 'admin-1477788162-14777904909638642', 1, 0, '', NULL, NULL, NULL),
(11865, '2016-10-30 09:21:31', NULL, NULL, 4150, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477831929', 'admin', '2016-10-30 09:21:31', 'admin-1477788162-14777904909638642', 1, 0, '', NULL, NULL, NULL),
(11866, '2016-10-31 13:01:07', NULL, NULL, 4209, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:01:07', 'admin-1477884683-14778900672794088', 1, 1, 'SR', NULL, NULL, NULL),
(11867, '2016-10-31 13:01:07', NULL, NULL, 4209, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:01:07', 'admin-1477884683-14778900672794088', 1, 0, '', NULL, NULL, NULL),
(11868, '2016-10-31 13:01:07', NULL, NULL, 4209, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:01:07', 'admin-1477884683-14778900672794088', 1, 1, 'SR', NULL, NULL, NULL),
(11869, '2016-10-31 13:01:07', NULL, NULL, 4209, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:01:07', 'admin-1477884683-14778900672794088', 1, 1, 'SR', NULL, NULL, NULL),
(11870, '2016-10-31 13:10:45', NULL, NULL, 4210, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:10:45', 'admin-1477890078-14778906448593378', 1, 0, '', NULL, NULL, NULL),
(11871, '2016-10-31 13:10:45', NULL, NULL, 4210, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:10:45', 'admin-1477890078-14778906448593378', 1, 1, 'SR', NULL, NULL, NULL),
(11872, '2016-10-31 13:10:45', NULL, NULL, 4210, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:10:45', 'admin-1477890078-14778906448593378', 1, 0, '', NULL, NULL, NULL),
(11873, '2016-10-31 13:10:45', NULL, NULL, 4210, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:10:45', 'admin-1477890078-14778906448593378', 1, 0, '', NULL, NULL, NULL),
(11874, '2016-10-31 18:59:44', NULL, NULL, 4228, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 18:59:44', 'admin-1477907530-14779115847304449', 1, 0, '', NULL, NULL, NULL),
(11875, '2016-10-31 18:59:44', NULL, NULL, 4228, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 18:59:44', 'admin-1477907530-14779115847304449', 1, 0, '', NULL, NULL, NULL),
(11876, '2016-10-31 14:10:42', NULL, NULL, 4211, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 14:10:42', 'admin-1477892543-14778942423573120', 1, 1, 'SR', NULL, NULL, NULL),
(11877, '2016-10-31 14:10:42', NULL, NULL, 4211, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 14:10:42', 'admin-1477892543-14778942423573120', 1, 1, 'SR', NULL, NULL, NULL),
(11878, '2016-10-31 14:29:46', NULL, NULL, 4214, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 14:29:46', 'admin-1477892543-14778953859865420', 1, 1, 'SR', NULL, NULL, '10.0'),
(11879, '2016-10-31 15:05:42', NULL, NULL, 4215, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 15:05:42', 'admin-1477892543-14778975427456624', 1, 1, 'SR', NULL, NULL, NULL),
(11880, '2016-10-31 15:09:38', NULL, NULL, 4205, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 15:09:38', 'admin-1477892543-1477897778270191', 1, 0, '', NULL, NULL, NULL),
(11881, '2016-10-31 16:08:47', NULL, NULL, 4216, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 16:08:47', 'admin-1477892543-14779013275172416', 1, 1, 'SR', NULL, NULL, NULL),
(11882, '2016-10-31 16:08:57', NULL, NULL, 4217, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 16:08:57', 'admin-1477892543-1477901336887202', 1, 1, 'SR', NULL, NULL, '10.0'),
(11883, '2016-10-31 16:33:55', NULL, NULL, 4218, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 16:33:55', 'admin-1477892543-14779028350162896', 1, 1, 'SR', 1, NULL, NULL),
(11884, '2016-10-31 16:38:02', NULL, NULL, 4219, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 16:38:02', 'admin-1477892543-14779030820643182', 1, 0, '', 1, NULL, NULL),
(11885, '2016-10-31 16:51:43', NULL, NULL, 4220, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 16:51:43', 'admin-1477892543-1477903903439834', 1, 1, 'SR', NULL, NULL, NULL),
(11886, '2016-10-31 16:51:43', NULL, NULL, 4220, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 16:51:43', 'admin-1477892543-1477903903439834', 1, 1, 'SR', NULL, NULL, NULL),
(11887, '2016-10-31 16:55:50', NULL, NULL, 4221, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 16:55:50', 'admin-1477892543-14779041499231931', 1, 1, 'SR', NULL, NULL, NULL),
(11888, '2016-10-31 13:34:21', NULL, NULL, 4208, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:34:21', 'admin-1477890078-14778920614903682', 1, 0, '', NULL, NULL, NULL),
(11889, '2016-10-31 13:34:21', NULL, NULL, 4208, 0, 82, '82', 'Set Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:34:21', 'admin-1477890078-14778920614903682', 1, 1, 'SR', NULL, NULL, NULL),
(11890, '2016-10-31 18:52:01', NULL, NULL, 4227, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 18:52:01', 'admin-1477907530-14779111210198278', 1, 1, 'SR', NULL, NULL, NULL),
(11891, '2016-10-31 18:52:01', NULL, NULL, 4227, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 18:52:01', 'admin-1477907530-14779111210198278', 1, 1, 'SR', NULL, NULL, NULL),
(11892, '2016-10-31 17:59:07', NULL, NULL, 4226, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 17:59:07', 'admin-1477907530-14779079471077377', 1, 1, 'SR', 1, NULL, NULL),
(11893, '2016-10-31 18:52:01', NULL, NULL, 4227, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 18:52:01', 'admin-1477907530-14779111210198278', 1, 1, 'SR', NULL, NULL, NULL),
(11894, '2016-10-31 17:52:24', NULL, NULL, 4225, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 17:52:24', 'admin-1477907530-14779075442513519', 1, 1, 'SR', 1, NULL, NULL),
(11895, '2016-10-31 17:52:24', NULL, NULL, 4225, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 17:52:24', 'admin-1477907530-14779075442513519', 1, 1, 'SR', 1, NULL, NULL),
(11896, '2016-10-31 17:28:58', NULL, NULL, 4216, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 17:28:58', 'admin-1477892543-14779061381838445', 1, 0, '', NULL, NULL, NULL),
(11897, '2016-10-31 17:28:48', NULL, NULL, 4216, 0, 228, '162', 'Golden Brown', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 17:28:48', 'admin-1477892543-14779061283065166', 1, 0, '', NULL, NULL, NULL),
(11898, '2016-10-31 17:28:48', NULL, NULL, 4216, 0, 227, '161', 'Cranberry Velvet', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 17:28:48', 'admin-1477892543-14779061283065166', 1, 0, '', NULL, NULL, NULL),
(11899, '2016-10-31 17:28:48', NULL, NULL, 4216, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 17:28:48', 'admin-1477892543-14779061283065166', 1, 0, '', NULL, NULL, NULL),
(11900, '2016-10-31 17:28:00', NULL, NULL, 4216, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 17:28:00', 'admin-1477892543-14779060800963179', 1, 1, 'SR', NULL, NULL, NULL),
(11901, '2016-10-31 17:28:00', NULL, NULL, 4216, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 17:28:00', 'admin-1477892543-14779060800963179', 1, 1, 'SR', NULL, NULL, NULL),
(11902, '2016-10-31 17:28:00', NULL, NULL, 4216, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 17:28:00', 'admin-1477892543-14779060800963179', 1, 1, 'SR', NULL, NULL, NULL),
(11903, '2016-10-31 17:28:00', NULL, NULL, 4216, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 17:28:00', 'admin-1477892543-14779060800963179', 1, 0, '', NULL, NULL, NULL),
(11904, '2016-10-31 17:14:57', NULL, NULL, 4223, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 17:14:57', 'admin-1477892543-14779052968443444', 1, 1, 'SR', NULL, NULL, NULL),
(11905, '2016-10-31 16:57:58', NULL, NULL, 4222, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 16:57:58', 'admin-1477892543-1477904278719639', 1, 0, '', NULL, NULL, NULL),
(11906, '2016-10-31 16:57:58', NULL, NULL, 4222, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 16:57:58', 'admin-1477892543-1477904278719639', 1, 1, 'SR', NULL, NULL, NULL),
(11907, '2016-10-31 13:41:33', NULL, NULL, 4212, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:41:33', 'admin-1477890078-14778924931882144', 1, 0, '', NULL, NULL, NULL),
(11908, '2016-10-31 13:42:04', NULL, NULL, 4213, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:42:04', 'admin-1477890078-14778925245383497', 1, 1, 'SR', NULL, NULL, NULL),
(11909, '2016-10-31 13:42:04', NULL, NULL, 4213, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:42:04', 'admin-1477890078-14778925245383497', 1, 1, 'SR', NULL, NULL, NULL),
(11910, '2016-10-31 13:41:27', NULL, NULL, 4212, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:41:27', 'admin-1477890078-1477892487390834', 1, 1, 'SR', NULL, NULL, NULL),
(11911, '2016-10-31 13:41:33', NULL, NULL, 4212, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:41:33', 'admin-1477890078-14778924931882144', 1, 0, '', NULL, NULL, NULL),
(11912, '2016-10-31 13:34:30', NULL, NULL, 4208, 0, 214, '148', 'Set Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:34:30', 'admin-1477890078-14778920700624886', 1, 0, '', NULL, NULL, NULL),
(11913, '2016-10-31 13:41:27', NULL, NULL, 4212, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:41:27', 'admin-1477890078-1477892487390834', 1, 1, 'SR', NULL, NULL, NULL),
(11914, '2016-10-31 13:34:21', NULL, NULL, 4208, 0, 82, '82', 'Set Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:34:21', 'admin-1477890078-14778920614903682', 1, 1, 'SR', NULL, NULL, NULL),
(11915, '2016-10-31 13:31:23', NULL, NULL, 4211, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:31:23', 'admin-1477890078-14778918835742031', 1, 0, '', NULL, NULL, NULL),
(11916, '2016-10-31 13:23:39', NULL, NULL, 4208, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:23:39', 'admin-1477890078-14778914193152691', 1, 1, 'SR', NULL, NULL, NULL),
(11917, '2016-10-31 13:23:39', NULL, NULL, 4208, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:23:39', 'admin-1477890078-14778914193152691', 1, 1, 'SR', NULL, NULL, NULL),
(11918, '2016-10-31 13:31:23', NULL, NULL, 4211, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:31:23', 'admin-1477890078-14778918835742031', 1, 0, '', NULL, NULL, NULL),
(11919, '2016-10-31 13:23:39', NULL, NULL, 4208, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:23:39', 'admin-1477890078-14778914193152691', 1, 0, '', NULL, NULL, NULL),
(11920, '2016-10-31 13:11:47', NULL, NULL, 4207, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:11:47', 'admin-1477890078-14778907071397853', 1, 0, '', NULL, NULL, NULL),
(11921, '2016-10-31 13:11:47', NULL, NULL, 4207, 0, 228, '162', 'Golden Brown', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:11:47', 'admin-1477890078-14778907071397853', 1, 0, '', NULL, NULL, NULL),
(11922, '2016-10-31 13:23:39', NULL, NULL, 4208, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:23:39', 'admin-1477890078-14778914193152691', 1, 1, 'SR', NULL, NULL, NULL),
(11923, '2016-10-31 13:23:39', NULL, NULL, 4208, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 13:23:39', 'admin-1477890078-14778914193152691', 1, 1, 'SR', NULL, NULL, NULL),
(11924, '2016-10-31 12:59:02', NULL, NULL, 4207, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 12:59:02', 'admin-1477884683-14778899424667632', 1, 0, '', NULL, NULL, NULL),
(11925, '2016-10-31 12:41:25', NULL, NULL, 4207, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 12:41:25', 'admin-1477884683-14778888856784588', 1, 0, '', NULL, NULL, NULL),
(11926, '2016-10-31 12:48:45', NULL, NULL, 4205, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 12:48:45', 'admin-1477884683-14778893256039156', 1, 0, '', NULL, NULL, NULL),
(11927, '2016-10-31 10:53:09', NULL, NULL, 4199, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 10:53:09', 'admin-1477874906-14778823897166538', 1, 1, 'SR', NULL, NULL, NULL),
(11928, '2016-10-31 11:17:29', NULL, NULL, 4201, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 11:17:29', 'admin-1477874906-14778838495678530', 1, 0, '', NULL, NULL, NULL),
(11929, '2016-10-31 11:17:29', NULL, NULL, 4201, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 11:17:29', 'admin-1477874906-14778838495678530', 1, 0, '', NULL, NULL, NULL),
(11930, '2016-10-31 11:17:29', NULL, NULL, 4201, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 11:17:29', 'admin-1477874906-14778838495678530', 1, 1, 'SR', NULL, NULL, NULL),
(11931, '2016-10-31 11:17:56', NULL, NULL, 4202, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 11:17:56', 'admin-1477874906-14778838760614880', 1, 1, 'SR', 1, NULL, NULL),
(11932, '2016-10-31 11:19:16', NULL, NULL, 4203, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 11:19:16', 'admin-1477874906-14778839562208692', 1, 0, '', NULL, NULL, NULL),
(11933, '2016-10-31 11:19:16', NULL, NULL, 4203, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 11:19:16', 'admin-1477874906-14778839562208692', 1, 0, '', NULL, NULL, NULL),
(11934, '2016-10-31 11:19:16', NULL, NULL, 4203, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 11:19:16', 'admin-1477874906-14778839562208692', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(11935, '2016-10-31 11:19:16', NULL, NULL, 4203, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 11:19:16', 'admin-1477874906-14778839562208692', 1, 1, 'SR', NULL, NULL, NULL),
(11936, '2016-10-31 11:20:18', NULL, NULL, 4200, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 11:20:18', 'admin-1477874906-14778840180257274', 1, 0, '', NULL, NULL, NULL),
(11937, '2016-10-31 11:20:18', NULL, NULL, 4200, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 11:20:18', 'admin-1477874906-14778840180257274', 1, 0, '', NULL, NULL, NULL),
(11938, '2016-10-31 11:20:18', NULL, NULL, 4200, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 11:20:18', 'admin-1477874906-14778840180257274', 1, 0, '', NULL, NULL, NULL),
(11939, '2016-10-31 11:20:18', NULL, NULL, 4200, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 11:20:18', 'admin-1477874906-14778840180257274', 1, 1, 'SR', NULL, NULL, NULL),
(11940, '2016-10-31 11:20:18', NULL, NULL, 4200, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 11:20:18', 'admin-1477874906-14778840180257274', 1, 1, 'SR', NULL, NULL, NULL),
(11941, '2016-10-31 11:20:18', NULL, NULL, 4200, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 11:20:18', 'admin-1477874906-14778840180257274', 1, 1, 'SR', NULL, NULL, NULL),
(11942, '2016-10-31 11:49:05', NULL, NULL, 4204, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 11:49:05', 'admin-1477884683-1477885745195226', 1, 1, 'SR', NULL, NULL, NULL),
(11943, '2016-10-31 11:49:05', NULL, NULL, 4204, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 11:49:05', 'admin-1477884683-1477885745195226', 1, 0, '', NULL, NULL, NULL),
(11944, '2016-10-31 11:49:18', NULL, NULL, 4205, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 11:49:18', 'admin-1477884683-14778857587764381', 1, 1, 'SR', NULL, NULL, NULL),
(11945, '2016-10-31 14:29:46', NULL, NULL, 4214, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 14:29:46', 'admin-1477892543-14778953859865420', 1, 0, '', NULL, NULL, '10.0'),
(11946, '2016-10-31 14:29:46', NULL, NULL, 4214, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 14:29:46', 'admin-1477892543-14778953859865420', 1, 0, '', NULL, NULL, '10.0'),
(11947, '2016-10-31 14:29:46', NULL, NULL, 4214, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 14:29:46', 'admin-1477892543-14778953859865420', 1, 1, 'SR', NULL, NULL, '10.0'),
(11948, '2016-10-31 14:29:46', NULL, NULL, 4214, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 14:29:46', 'admin-1477892543-14778953859865420', 1, 1, 'SR', NULL, NULL, '10.0'),
(11949, '2016-10-31 12:31:08', NULL, NULL, 4207, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 12:31:08', 'admin-1477884683-14778882678726050', 1, 1, 'SR', NULL, NULL, NULL),
(11950, '2016-10-31 12:31:08', NULL, NULL, 4207, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 12:31:08', 'admin-1477884683-14778882678726050', 1, 1, 'SR', NULL, NULL, NULL),
(11951, '2016-10-31 12:31:08', NULL, NULL, 4207, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 12:31:08', 'admin-1477884683-14778882678726050', 1, 1, 'SR', NULL, NULL, NULL),
(11952, '2016-10-31 12:31:08', NULL, NULL, 4207, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 12:31:08', 'admin-1477884683-14778882678726050', 1, 1, 'SR', NULL, NULL, NULL),
(11953, '2016-10-31 12:31:39', NULL, NULL, 4207, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 12:31:39', 'admin-1477884683-14778882997487881', 1, 1, 'SR', NULL, NULL, NULL),
(11954, '2016-10-31 12:31:39', NULL, NULL, 4207, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 12:31:39', 'admin-1477884683-14778882997487881', 1, 0, '', NULL, NULL, NULL),
(11955, '2016-10-31 12:31:39', NULL, NULL, 4207, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 12:31:39', 'admin-1477884683-14778882997487881', 1, 1, 'SR', NULL, NULL, NULL),
(11956, '2016-10-31 12:31:39', NULL, NULL, 4207, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 12:31:39', 'admin-1477884683-14778882997487881', 1, 0, '', NULL, NULL, NULL),
(11957, '2016-10-31 12:34:43', NULL, NULL, 4208, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 12:34:43', 'admin-1477884683-14778884835536210', 1, 1, 'SR', NULL, NULL, NULL),
(11958, '2016-10-31 12:34:43', NULL, NULL, 4208, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 12:34:43', 'admin-1477884683-14778884835536210', 1, 0, '', NULL, NULL, NULL),
(11959, '2016-10-31 12:34:43', NULL, NULL, 4208, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 12:34:43', 'admin-1477884683-14778884835536210', 1, 0, '', NULL, NULL, NULL),
(11960, '2016-10-31 12:34:43', NULL, NULL, 4208, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 12:34:43', 'admin-1477884683-14778884835536210', 1, 1, 'SR', NULL, NULL, NULL),
(11961, '2016-10-31 12:34:43', NULL, NULL, 4208, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 12:34:43', 'admin-1477884683-14778884835536210', 1, 0, '', NULL, NULL, NULL),
(11962, '2016-10-31 12:41:25', NULL, NULL, 4207, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 12:41:25', 'admin-1477884683-14778888856784588', 1, 0, '', NULL, NULL, NULL),
(11963, '2016-10-31 12:41:25', NULL, NULL, 4207, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 12:41:25', 'admin-1477884683-14778888856784588', 1, 0, '', NULL, NULL, NULL),
(11964, '2016-10-31 10:53:02', NULL, NULL, 4199, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 10:53:02', 'admin-1477874906-1477882382123554', 1, 0, '', NULL, NULL, NULL),
(11965, '2016-10-31 10:53:02', NULL, NULL, 4199, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 10:53:02', 'admin-1477874906-1477882382123554', 1, 0, '', NULL, NULL, NULL),
(11966, '2016-10-31 10:53:09', NULL, NULL, 4199, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 10:53:09', 'admin-1477874906-14778823897166538', 1, 1, 'SR', NULL, NULL, NULL),
(11967, '2016-10-31 10:12:00', NULL, NULL, 4198, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 10:12:00', 'admin-1477874906-14778799198008413', 1, 1, 'SR', NULL, NULL, NULL),
(11968, '2016-10-31 10:12:00', NULL, NULL, 4198, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 10:12:00', 'admin-1477874906-14778799198008413', 1, 0, '', NULL, NULL, NULL),
(11969, '2016-10-31 10:12:00', NULL, NULL, 4198, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 10:12:00', 'admin-1477874906-14778799198008413', 1, 1, 'SR', NULL, NULL, NULL),
(11970, '2016-10-31 10:10:31', NULL, NULL, 4198, 0, 155, '89', 'Joyous Sunny ', 'change to scrambled egg', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1477907530', 'admin', '2016-10-31 10:10:31', 'admin-1477874906-1477879831614159', 1, 0, '', NULL, NULL, NULL),
(11971, '2016-11-02 16:27:58', NULL, NULL, 4246, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 16:27:58', 'admin-1478063098-1478075278120436', 1, 1, 'SR', NULL, NULL, NULL),
(11972, '2016-11-02 16:43:48', NULL, NULL, 4249, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 16:43:48', 'admin-1478063098-14780762282639217', 1, 1, 'SR', 1, NULL, NULL),
(11973, '2016-11-02 18:19:25', NULL, NULL, 4250, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 18:19:25', 'admin-1478063098-14780819651812647', 1, 1, 'SR', NULL, NULL, NULL),
(11974, '2016-11-02 18:43:38', NULL, NULL, 4251, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 18:43:38', 'admin-1478063098-14780834187131276', 1, 0, '', NULL, NULL, NULL),
(11975, '2016-11-02 18:43:38', NULL, NULL, 4251, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 18:43:38', 'admin-1478063098-14780834187131276', 1, 0, '', NULL, NULL, NULL),
(11976, '2016-11-02 18:43:50', NULL, NULL, 4251, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 18:43:50', 'admin-1478063098-14780834302484779', 1, 1, 'SR', NULL, NULL, NULL),
(11977, '2016-11-02 18:43:50', NULL, NULL, 4251, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 18:43:50', 'admin-1478063098-14780834302484779', 1, 1, 'SR', NULL, NULL, NULL),
(11978, '2016-11-02 18:45:30', NULL, NULL, 4251, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 18:45:30', 'admin-1478063098-14780835301442979', 1, 1, 'SR', NULL, NULL, NULL),
(11979, '2016-11-02 19:10:49', NULL, NULL, 4252, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 19:10:49', 'admin-1478063098-14780850492984155', 1, 0, '', NULL, NULL, NULL),
(11980, '2016-11-02 19:10:49', NULL, NULL, 4252, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 19:10:49', 'admin-1478063098-14780850492984155', 1, 1, 'SR', NULL, NULL, NULL),
(11981, '2016-11-02 19:11:41', NULL, NULL, 4253, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 19:11:41', 'admin-1478063098-14780851015255462', 1, 0, '', NULL, NULL, NULL),
(11982, '2016-11-02 19:11:41', NULL, NULL, 4253, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 19:11:41', 'admin-1478063098-14780851015255462', 1, 0, '', NULL, NULL, NULL),
(11983, '2016-11-02 20:20:32', NULL, NULL, 4254, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 20:20:32', 'admin-1478063098-14780892324418981', 1, 1, 'SR', NULL, NULL, NULL),
(11984, '2016-11-02 20:20:32', NULL, NULL, 4254, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 20:20:32', 'admin-1478063098-14780892324418981', 1, 1, 'SR', NULL, NULL, NULL),
(11985, '2016-11-02 16:14:57', NULL, NULL, 4247, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 16:14:57', 'admin-1478063098-14780744975107059', 1, 0, '', NULL, NULL, NULL),
(11986, '2016-11-02 16:26:23', NULL, NULL, 4248, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 16:26:23', 'admin-1478063098-14780751833581934', 1, 1, 'SR', NULL, NULL, NULL),
(11987, '2016-11-02 11:26:05', NULL, NULL, 4231, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 11:26:05', 'admin-1478050101-14780571654971338', 1, 0, '', NULL, NULL, NULL),
(11988, '2016-11-02 11:26:17', NULL, NULL, 4231, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 11:26:17', 'admin-1478050101-14780571771832448', 1, 0, '', NULL, NULL, NULL),
(11989, '2016-11-02 11:26:17', NULL, NULL, 4231, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 11:26:17', 'admin-1478050101-14780571771832448', 1, 1, 'SR', NULL, NULL, NULL),
(11990, '2016-11-02 11:45:07', NULL, NULL, 4232, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 11:45:07', 'admin-1478050101-14780583074415328', 1, 1, 'SR', NULL, NULL, NULL),
(11991, '2016-11-02 11:45:07', NULL, NULL, 4232, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 11:45:07', 'admin-1478050101-14780583074415328', 1, 0, '', NULL, NULL, NULL),
(11992, '2016-11-02 11:59:53', NULL, NULL, 4233, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 11:59:53', 'admin-1478050101-14780591929756551', 1, 1, 'SR', NULL, NULL, NULL),
(11993, '2016-11-02 11:59:53', NULL, NULL, 4233, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 11:59:53', 'admin-1478050101-14780591929756551', 1, 1, 'SR', NULL, NULL, NULL),
(11994, '2016-11-02 12:06:17', NULL, NULL, 4234, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 12:06:17', 'admin-1478050101-14780595769074047', 1, 0, '', NULL, NULL, NULL),
(11995, '2016-11-02 12:06:17', NULL, NULL, 4234, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 12:06:17', 'admin-1478050101-14780595769074047', 1, 1, 'SR', NULL, NULL, NULL),
(11996, '2016-11-02 12:28:04', NULL, NULL, 4234, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 12:28:04', 'admin-1478050101-14780608844975783', 1, 0, '', NULL, NULL, NULL),
(11997, '2016-11-02 12:32:46', NULL, NULL, 4235, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 12:32:46', 'admin-1478050101-14780611667023720', 1, 0, '', NULL, NULL, NULL),
(11998, '2016-11-02 12:32:46', NULL, NULL, 4235, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 12:32:46', 'admin-1478050101-14780611667023720', 1, 0, '', NULL, NULL, NULL),
(11999, '2016-11-02 12:32:46', NULL, NULL, 4235, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 12:32:46', 'admin-1478050101-14780611667023720', 1, 0, '', NULL, NULL, NULL),
(12000, '2016-11-02 12:32:46', NULL, NULL, 4235, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 12:32:46', 'admin-1478050101-14780611667023720', 1, 0, '', NULL, NULL, NULL),
(12001, '2016-11-02 12:49:51', NULL, NULL, 4234, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 12:49:51', 'admin-1478050101-14780621916349663', 1, 0, '', NULL, NULL, NULL),
(12002, '2016-11-02 12:56:52', NULL, NULL, 4236, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 12:56:52', 'admin-1478050101-14780626120305524', 1, 1, 'SR', NULL, NULL, NULL),
(12003, '2016-11-02 12:56:52', NULL, NULL, 4236, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 12:56:52', 'admin-1478050101-14780626120305524', 1, 1, 'SR', NULL, NULL, NULL),
(12004, '2016-11-02 13:02:42', NULL, NULL, 4236, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 13:02:42', 'admin-1478050101-14780629624331964', 1, 0, '', NULL, NULL, NULL),
(12005, '2016-11-02 13:02:42', NULL, NULL, 4236, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 13:02:42', 'admin-1478050101-14780629624331964', 1, 0, '', NULL, NULL, NULL),
(12006, '2016-11-02 13:02:42', NULL, NULL, 4236, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 13:02:42', 'admin-1478050101-14780629624331964', 1, 0, '', NULL, NULL, NULL),
(12007, '2016-11-02 13:54:21', NULL, NULL, 4237, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 13:54:21', 'admin-1478063098-14780660607478960', 1, 1, 'SR', NULL, NULL, NULL),
(12008, '2016-11-02 14:06:00', NULL, NULL, 4238, 0, 227, '161', 'Cranberry Velvet', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 14:06:00', 'admin-1478063098-1478066760717755', 1, 0, '', NULL, NULL, NULL),
(12009, '2016-11-02 14:06:17', NULL, NULL, 4239, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 14:06:17', 'admin-1478063098-14780667774625562', 1, 1, 'SR', NULL, NULL, NULL),
(12010, '2016-11-02 14:06:17', NULL, NULL, 4239, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 14:06:17', 'admin-1478063098-14780667774625562', 1, 1, 'SR', NULL, NULL, NULL),
(12011, '2016-11-02 14:06:17', NULL, NULL, 4239, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 14:06:17', 'admin-1478063098-14780667774625562', 1, 1, 'SR', NULL, NULL, NULL),
(12012, '2016-11-02 14:06:17', NULL, NULL, 4239, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 14:06:17', 'admin-1478063098-14780667774625562', 1, 1, 'SR', NULL, NULL, NULL),
(12013, '2016-11-02 14:10:37', NULL, NULL, 4240, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 14:10:37', 'admin-1478063098-14780670340013596', 1, 0, '', NULL, NULL, NULL),
(12014, '2016-11-02 14:10:37', NULL, NULL, 4240, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 14:10:37', 'admin-1478063098-14780670340013596', 1, 1, 'SR', NULL, NULL, NULL),
(12015, '2016-11-02 14:27:50', NULL, NULL, 4237, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 14:27:50', 'admin-1478063098-14780680701105514', 1, 1, 'SR', NULL, NULL, NULL),
(12016, '2016-11-02 14:27:50', NULL, NULL, 4237, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 14:27:50', 'admin-1478063098-14780680701105514', 1, 1, 'SR', NULL, NULL, NULL),
(12017, '2016-11-02 14:29:18', NULL, NULL, 4242, 0, 85, '85', 'Set Sauted Mushroom Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 14:29:18', 'admin-1478063098-1478068158269567', 1, 1, 'SR', NULL, NULL, NULL),
(12018, '2016-11-02 14:29:32', NULL, NULL, 4242, 0, 224, '158', 'Set Garlic Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 14:29:32', 'admin-1478063098-14780681720325162', 1, 0, '', NULL, NULL, NULL),
(12019, '2016-11-02 14:49:39', NULL, NULL, 4243, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 14:49:39', 'admin-1478063098-14780693792891524', 1, 1, 'SR', 1, NULL, NULL),
(12020, '2016-11-02 15:25:07', NULL, NULL, 4244, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 15:25:07', 'admin-1478063098-14780715069103111', 1, 0, '', NULL, NULL, NULL),
(12021, '2016-11-02 15:34:59', NULL, NULL, 4240, 0, 228, '162', 'Golden Brown', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 15:34:59', 'admin-1478063098-1478072099699179', 1, 0, '', NULL, NULL, NULL),
(12022, '2016-11-02 16:10:32', NULL, NULL, 4245, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 16:10:32', 'admin-1478063098-14780742319481772', 1, 1, 'SR', NULL, NULL, NULL),
(12023, '2016-11-02 16:10:32', NULL, NULL, 4245, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 16:10:32', 'admin-1478063098-14780742319481772', 1, 1, 'SR', NULL, NULL, NULL),
(12024, '2016-11-02 16:10:59', NULL, NULL, 4246, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 16:10:59', 'admin-1478063098-14780742596597713', 1, 1, 'SR', NULL, NULL, NULL),
(12025, '2016-11-02 16:14:57', NULL, NULL, 4247, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 16:14:57', 'admin-1478063098-14780744975107059', 1, 1, 'SR', NULL, NULL, NULL),
(12026, '2016-11-02 10:34:18', NULL, NULL, 4230, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 10:34:18', 'admin-1478050101-14780540580685768', 1, 1, 'SR', 1, NULL, NULL),
(12027, '2016-11-02 16:14:57', NULL, NULL, 4247, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 16:14:57', 'admin-1478063098-14780744975107059', 1, 1, 'SR', NULL, NULL, NULL),
(12028, '2016-11-02 11:26:05', NULL, NULL, 4231, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 11:26:05', 'admin-1478050101-14780571654971338', 1, 0, '', NULL, NULL, NULL),
(12029, '2016-11-02 09:50:27', NULL, NULL, 4229, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478063098', 'admin', '2016-11-02 09:50:27', 'admin-1478050101-14780514276184692', 1, 1, 'SR', 1, NULL, NULL),
(12030, '2016-11-03 10:31:34', NULL, NULL, 4257, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 10:31:34', 'admin-1478135267-14781402947373549', 1, 0, '', NULL, NULL, NULL),
(12031, '2016-11-03 10:31:34', NULL, NULL, 4257, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 10:31:34', 'admin-1478135267-14781402947373549', 1, 1, 'SR', NULL, NULL, NULL),
(12032, '2016-11-03 10:53:39', NULL, NULL, 4256, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 10:53:39', 'admin-1478135267-14781416194181296', 1, 0, '', NULL, NULL, NULL),
(12033, '2016-11-03 10:53:48', NULL, NULL, 4256, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 10:53:48', 'admin-1478135267-14781416283982626', 1, 1, 'SR', NULL, NULL, NULL),
(12034, '2016-11-03 12:34:20', NULL, NULL, 4258, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 12:34:20', 'admin-1478135267-14781476598835777', 1, 0, '', NULL, NULL, NULL),
(12035, '2016-11-03 12:34:20', NULL, NULL, 4258, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 12:34:20', 'admin-1478135267-14781476598835777', 1, 1, 'SR', NULL, NULL, NULL),
(12036, '2016-11-03 12:49:08', NULL, NULL, 4259, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 12:49:08', 'admin-1478135267-14781485484404311', 1, 0, '', NULL, NULL, NULL),
(12037, '2016-11-03 12:49:08', NULL, NULL, 4259, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 12:49:08', 'admin-1478135267-14781485484404311', 1, 0, '', NULL, NULL, NULL),
(12038, '2016-11-03 12:49:08', NULL, NULL, 4259, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 12:49:08', 'admin-1478135267-14781485484404311', 1, 0, '', NULL, NULL, NULL),
(12039, '2016-11-03 12:49:08', NULL, NULL, 4259, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 12:49:08', 'admin-1478135267-14781485484404311', 1, 1, 'SR', NULL, NULL, NULL),
(12040, '2016-11-03 12:49:26', NULL, NULL, 4259, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 12:49:26', 'admin-1478135267-14781485666479326', 1, 1, 'SR', NULL, NULL, NULL),
(12041, '2016-11-03 12:49:26', NULL, NULL, 4259, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 12:49:26', 'admin-1478135267-14781485666479326', 1, 1, 'SR', NULL, NULL, NULL),
(12042, '2016-11-03 13:29:46', NULL, NULL, 4260, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 13:29:46', 'admin-1478135267-1478150986143508', 1, 0, '', NULL, NULL, NULL),
(12043, '2016-11-03 13:29:46', NULL, NULL, 4260, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 13:29:46', 'admin-1478135267-1478150986143508', 1, 1, 'SR', NULL, NULL, NULL),
(12044, '2016-11-03 13:30:35', NULL, NULL, 4258, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 13:30:35', 'admin-1478135267-14781510356403468', 1, 1, 'SR', NULL, NULL, NULL),
(12045, '2016-11-03 14:40:23', NULL, NULL, 4261, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 14:40:23', 'admin-1478135267-14781552231903958', 1, 1, 'SR', NULL, NULL, NULL),
(12046, '2016-11-03 14:40:23', NULL, NULL, 4261, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 14:40:23', 'admin-1478135267-14781552231903958', 1, 1, 'SR', NULL, NULL, NULL),
(12047, '2016-11-03 09:10:19', NULL, NULL, 4255, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 09:10:19', 'admin-1478135267-14781354194938463', 1, 1, 'SR', 1, NULL, NULL),
(12048, '2016-11-03 18:15:52', NULL, NULL, 4266, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 18:15:52', 'admin-1478135267-14781681520718524', 1, 1, 'SR', NULL, NULL, NULL),
(12049, '2016-11-03 18:15:52', NULL, NULL, 4266, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 18:15:52', 'admin-1478135267-14781681520718524', 1, 1, 'SR', NULL, NULL, NULL),
(12050, '2016-11-03 18:15:52', NULL, NULL, 4266, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 18:15:52', 'admin-1478135267-14781681520718524', 1, 1, 'SR', NULL, NULL, NULL),
(12051, '2016-11-03 18:15:52', NULL, NULL, 4266, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 18:15:52', 'admin-1478135267-14781681520718524', 1, 1, 'SR', NULL, NULL, NULL),
(12052, '2016-11-03 17:27:44', NULL, NULL, 4264, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 17:27:44', 'admin-1478135267-1478165264036272', 1, 1, 'SR', NULL, NULL, '10.0'),
(12053, '2016-11-03 17:27:44', NULL, NULL, 4264, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 17:27:44', 'admin-1478135267-1478165264036272', 1, 1, 'SR', NULL, NULL, '10.0'),
(12054, '2016-11-03 17:27:44', NULL, NULL, 4264, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 17:27:44', 'admin-1478135267-1478165264036272', 1, 0, '', NULL, NULL, '10.0'),
(12055, '2016-11-03 17:27:44', NULL, NULL, 4264, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 17:27:44', 'admin-1478135267-1478165264036272', 1, 0, '', NULL, NULL, '10.0'),
(12056, '2016-11-03 17:25:42', NULL, NULL, 4265, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 17:25:42', 'admin-1478135267-1478165142609566', 1, 0, '', NULL, NULL, NULL),
(12057, '2016-11-03 17:20:12', NULL, NULL, 4265, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 17:20:12', 'admin-1478135267-1478164812319112', 1, 1, 'SR', NULL, NULL, NULL),
(12058, '2016-11-03 17:20:12', NULL, NULL, 4265, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 17:20:12', 'admin-1478135267-1478164812319112', 1, 1, 'SR', NULL, NULL, NULL),
(12059, '2016-11-03 17:04:51', NULL, NULL, 4264, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 17:04:51', 'admin-1478135267-14781638910803811', 1, 0, '', NULL, NULL, '10.0'),
(12060, '2016-11-03 17:04:51', NULL, NULL, 4264, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 17:04:51', 'admin-1478135267-14781638910803811', 1, 0, '', NULL, NULL, '10.0'),
(12061, '2016-11-03 17:04:51', NULL, NULL, 4264, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 17:04:51', 'admin-1478135267-14781638910803811', 1, 1, 'SR', NULL, NULL, '10.0'),
(12062, '2016-11-03 17:04:51', NULL, NULL, 4264, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 17:04:51', 'admin-1478135267-14781638910803811', 1, 1, 'SR', NULL, NULL, '10.0'),
(12063, '2016-11-03 17:04:51', NULL, NULL, 4264, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 17:04:51', 'admin-1478135267-14781638910803811', 1, 1, 'SR', NULL, NULL, '10.0'),
(12064, '2016-11-03 16:12:13', NULL, NULL, 4263, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 16:12:13', 'admin-1478135267-14781607334064314', 1, 1, 'SR', NULL, NULL, NULL),
(12065, '2016-11-03 15:18:09', NULL, NULL, 4262, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 15:18:09', 'admin-1478135267-14781574890259478', 1, 0, '', NULL, NULL, NULL),
(12066, '2016-11-03 15:18:09', NULL, NULL, 4262, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 15:18:09', 'admin-1478135267-14781574890259478', 1, 1, 'SR', NULL, NULL, NULL),
(12067, '2016-11-03 15:01:30', NULL, NULL, 4261, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 15:01:30', 'admin-1478135267-14781564899004055', 1, 1, 'SR', NULL, NULL, NULL),
(12068, '2016-11-03 14:40:23', NULL, NULL, 4261, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 14:40:23', 'admin-1478135267-14781552231903958', 1, 1, 'SR', NULL, NULL, NULL),
(12069, '2016-11-03 09:10:31', NULL, NULL, 4256, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 09:10:31', 'admin-1478135267-14781354314399886', 1, 1, 'SR', NULL, NULL, NULL),
(12070, '2016-11-03 09:10:19', NULL, NULL, 4255, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478135267', 'admin', '2016-11-03 09:10:19', 'admin-1478135267-14781354194938463', 1, 1, 'SR', 1, NULL, NULL),
(12071, '2016-11-04 15:54:32', NULL, NULL, 4287, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 15:54:32', 'admin-1478239163-14782460725118996', 1, 0, '', NULL, NULL, NULL),
(12072, '2016-11-04 00:00:00', NULL, NULL, 4285, 0, 156, '90', 'Cheese Omelet', 'Takeaway', 'Meals', 'Morning Bites ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 14:34:09', 'admin-1478239163-14782412490938687', 1, 0, '', NULL, NULL, NULL),
(12073, '2016-11-04 15:54:54', NULL, NULL, 4287, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 15:54:54', 'admin-1478239163-1478246094486160', 1, 1, 'SR', NULL, NULL, NULL),
(12074, '2016-11-04 16:03:38', NULL, NULL, 4288, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 16:03:38', 'admin-1478239163-14782466186953350', 1, 1, 'SR', NULL, NULL, NULL),
(12075, '2016-11-04 16:06:39', NULL, NULL, 4289, NULL, 57, '57', 'House Red Bottle', '', 'Cold Drinks', 'Wine', 1, 88.00, 88.0000, 0.0000, 88.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 16:06:39', 'admin-1478239163-14782467987909145', 1, 1, 'SR', NULL, NULL, NULL),
(12076, '2016-11-04 16:08:31', NULL, NULL, 4290, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 16:08:31', 'admin-1478239163-1478246911479435', 1, 1, 'SR', NULL, NULL, NULL),
(12077, '2016-11-04 16:20:34', NULL, NULL, 4291, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 16:20:34', 'admin-1478239163-14782476346065898', 1, 0, '', NULL, NULL, NULL),
(12078, '2016-11-04 16:20:34', NULL, NULL, 4291, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 16:20:34', 'admin-1478239163-14782476346065898', 1, 1, 'SR', NULL, NULL, NULL),
(12079, '2016-11-04 00:00:00', NULL, NULL, 4286, 0, 154, '88', 'House BLT', 'Takeaway', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 14:28:03', 'admin-1478239163-14782408832833164', 1, 0, '', NULL, NULL, NULL),
(12080, '2016-11-04 14:41:57', NULL, NULL, 4284, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 14:41:57', 'admin-1478239163-1478241716891714', 1, 1, 'SR', NULL, NULL, NULL),
(12081, '2016-11-04 09:37:52', NULL, NULL, 4267, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 09:37:52', 'admin-1478221054-14782234722928525', 1, 1, 'SR', NULL, NULL, NULL),
(12082, '2016-11-04 00:00:00', NULL, NULL, 4286, 0, 154, '88', 'House BLT', 'Takeaway', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 14:28:03', 'admin-1478239163-14782408832833164', 1, 0, '', NULL, NULL, NULL),
(12083, '2016-11-04 00:00:00', NULL, NULL, 4286, 0, 154, '88', 'House BLT', 'Takeaway', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 14:28:03', 'admin-1478239163-14782408832833164', 1, 0, '', NULL, NULL, NULL),
(12084, '2016-11-04 00:00:00', NULL, NULL, 4286, 0, 154, '88', 'House BLT', 'Takeaway', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 14:28:03', 'admin-1478239163-14782408832833164', 1, 0, '', NULL, NULL, NULL),
(12085, '2016-11-04 14:50:55', NULL, NULL, 4284, 0, 181, '116', 'Open Food ', 'take away', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 14:50:55', 'admin-1478239163-14782422556519532', 1, 0, '', NULL, NULL, NULL),
(12086, '2016-11-04 14:23:40', NULL, NULL, 4282, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 14:23:40', 'admin-1478239163-14782406198714499', 1, 0, '', NULL, NULL, NULL),
(12087, '2016-11-04 14:23:40', NULL, NULL, 4282, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 14:23:40', 'admin-1478239163-14782406198714499', 1, 0, '', NULL, NULL, NULL),
(12088, '2016-11-04 14:09:33', NULL, NULL, 4281, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 14:09:33', 'admin-1478239163-1478239773250557', 1, 1, 'SR', 1, NULL, NULL),
(12089, '2016-11-04 14:09:33', NULL, NULL, 4281, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 14:09:33', 'admin-1478239163-1478239773250557', 1, 1, 'SR', 1, NULL, NULL),
(12090, '2016-11-04 13:43:49', NULL, NULL, 4278, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 13:43:49', 'admin-1478229899-1478238229486783', 1, 0, '', NULL, NULL, NULL),
(12091, '2016-11-04 13:43:49', NULL, NULL, 4278, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 13:43:49', 'admin-1478229899-1478238229486783', 1, 0, '', NULL, NULL, NULL),
(12092, '2016-11-04 13:39:00', NULL, NULL, 4278, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 13:39:00', 'admin-1478229899-14782379406107678', 1, 0, '', NULL, NULL, NULL),
(12093, '2016-11-04 13:43:49', NULL, NULL, 4278, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 13:43:49', 'admin-1478229899-1478238229486783', 1, 0, '', NULL, NULL, NULL),
(12094, '2016-11-04 13:38:47', NULL, NULL, 4280, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 13:38:47', 'admin-1478229899-14782379274712949', 1, 1, 'SR', NULL, NULL, NULL),
(12095, '2016-11-04 13:32:11', NULL, NULL, 4268, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 13:32:11', 'admin-1478229899-14782375312305731', 1, 1, 'SR', NULL, NULL, NULL),
(12096, '2016-11-04 19:58:51', NULL, NULL, 4298, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 19:58:51', 'admin-1478256345-14782607310491825', 1, 1, 'SR', NULL, NULL, NULL),
(12097, '2016-11-04 18:29:53', NULL, NULL, 4294, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 18:29:53', 'admin-1478239163-1478255393121482', 1, 1, 'SR', NULL, NULL, NULL),
(12098, '2016-11-04 19:20:23', NULL, NULL, 4297, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 19:20:23', 'admin-1478256345-14782584229235817', 1, 1, 'SR', NULL, NULL, NULL),
(12099, '2016-11-04 19:58:51', NULL, NULL, 4298, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 19:58:51', 'admin-1478256345-14782607310491825', 1, 1, 'SR', NULL, NULL, NULL),
(12100, '2016-11-04 17:16:19', NULL, NULL, 4294, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 17:16:19', 'admin-1478239163-1478250979082655', 1, 0, '', NULL, NULL, NULL),
(12101, '2016-11-04 18:12:35', NULL, NULL, 4296, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 18:12:35', 'admin-1478239163-14782543549423713', 1, 1, 'SR', NULL, NULL, NULL),
(12102, '2016-11-04 18:12:35', NULL, NULL, 4296, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 18:12:35', 'admin-1478239163-14782543549423713', 1, 1, 'SR', NULL, NULL, NULL),
(12103, '2016-11-04 18:12:35', NULL, NULL, 4296, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 18:12:35', 'admin-1478239163-14782543549423713', 1, 1, 'SR', NULL, NULL, NULL),
(12104, '2016-11-04 18:12:35', NULL, NULL, 4296, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 18:12:35', 'admin-1478239163-14782543549423713', 1, 1, 'SR', NULL, NULL, NULL),
(12105, '2016-11-04 17:20:08', NULL, NULL, 4295, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 17:20:08', 'admin-1478239163-14782512085608470', 1, 1, 'SR', NULL, NULL, NULL),
(12106, '2016-11-04 17:20:08', NULL, NULL, 4295, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 17:20:08', 'admin-1478239163-14782512085608470', 1, 1, 'SR', NULL, NULL, NULL),
(12107, '2016-11-04 17:16:19', NULL, NULL, 4294, 0, 227, '161', 'Cranberry Velvet', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 17:16:19', 'admin-1478239163-1478250979082655', 1, 0, '', NULL, NULL, NULL),
(12108, '2016-11-04 17:15:33', NULL, NULL, 4294, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 17:15:33', 'admin-1478239163-14782509329781554', 1, 1, 'SR', NULL, NULL, NULL),
(12109, '2016-11-04 17:15:33', NULL, NULL, 4294, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 17:15:33', 'admin-1478239163-14782509329781554', 1, 1, 'SR', NULL, NULL, NULL),
(12110, '2016-11-04 17:06:58', NULL, NULL, 4293, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 17:06:58', 'admin-1478239163-1478250418296891', 1, 1, 'SR', NULL, NULL, NULL),
(12111, '2016-11-04 16:38:14', NULL, NULL, 4292, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 16:38:14', 'admin-1478239163-1478248694032534', 1, 1, 'SR', NULL, NULL, NULL),
(12112, '2016-11-04 16:38:14', NULL, NULL, 4292, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 16:38:14', 'admin-1478239163-1478248694032534', 1, 1, 'SR', NULL, NULL, NULL),
(12113, '2016-11-04 14:45:19', NULL, NULL, 4284, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 14:45:19', 'admin-1478239163-14782419190207081', 1, 0, '', NULL, NULL, NULL),
(12114, '2016-11-04 11:57:40', NULL, NULL, 4277, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 11:57:40', 'admin-1478229899-1478231860647335', 1, 1, 'SR', NULL, NULL, NULL),
(12115, '2016-11-04 11:57:40', NULL, NULL, 4277, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 11:57:40', 'admin-1478229899-1478231860647335', 1, 1, 'SR', NULL, NULL, NULL),
(12116, '2016-11-04 12:59:02', NULL, NULL, 4278, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 12:59:02', 'admin-1478229899-14782355424991880', 1, 0, '', NULL, NULL, NULL),
(12117, '2016-11-04 12:59:02', NULL, NULL, 4278, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 12:59:02', 'admin-1478229899-14782355424991880', 1, 0, '', NULL, NULL, NULL),
(12118, '2016-11-04 12:59:02', NULL, NULL, 4278, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 12:59:02', 'admin-1478229899-14782355424991880', 1, 0, '', NULL, NULL, NULL),
(12119, '2016-11-04 12:59:02', NULL, NULL, 4278, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 12:59:02', 'admin-1478229899-14782355424991880', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(12120, '2016-11-04 12:59:02', NULL, NULL, 4278, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 12:59:02', 'admin-1478229899-14782355424991880', 1, 0, '', NULL, NULL, NULL),
(12121, '2016-11-04 13:04:20', NULL, NULL, 4279, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 13:04:20', 'admin-1478229899-14782358607766341', 1, 1, 'SR', NULL, NULL, NULL),
(12122, '2016-11-04 13:04:21', NULL, NULL, 4279, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 13:04:21', 'admin-1478229899-14782358607766341', 1, 1, 'SR', NULL, NULL, NULL),
(12123, '2016-11-04 13:25:00', NULL, NULL, 4280, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 13:25:00', 'admin-1478229899-1478237099918985', 1, 0, '', NULL, NULL, NULL),
(12124, '2016-11-04 13:25:00', NULL, NULL, 4280, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 13:25:00', 'admin-1478229899-1478237099918985', 1, 0, '', NULL, NULL, NULL),
(12125, '2016-11-04 13:25:26', NULL, NULL, 4280, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 13:25:26', 'admin-1478229899-14782371262013410', 1, 1, 'SR', NULL, NULL, NULL),
(12126, '2016-11-04 13:25:26', NULL, NULL, 4280, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 13:25:26', 'admin-1478229899-14782371262013410', 1, 0, '', NULL, NULL, NULL),
(12127, '2016-11-04 13:25:26', NULL, NULL, 4280, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 13:25:26', 'admin-1478229899-14782371262013410', 1, 0, '', NULL, NULL, NULL),
(12128, '2016-11-04 13:25:26', NULL, NULL, 4280, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 13:25:26', 'admin-1478229899-14782371262013410', 1, 1, 'SR', NULL, NULL, NULL),
(12129, '2016-11-04 13:25:26', NULL, NULL, 4280, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 13:25:26', 'admin-1478229899-14782371262013410', 1, 1, 'SR', NULL, NULL, NULL),
(12130, '2016-11-04 13:32:11', NULL, NULL, 4268, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 13:32:11', 'admin-1478229899-14782375312305731', 1, 1, 'SR', NULL, NULL, NULL),
(12131, '2016-11-04 10:59:02', NULL, NULL, 4273, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 10:59:02', 'admin-1478221054-14782283421209362', 1, 1, 'SR', NULL, NULL, NULL),
(12132, '2016-11-04 11:08:03', NULL, NULL, 4274, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 11:08:03', 'admin-1478221054-14782288836487616', 1, 1, 'SR', 1, NULL, NULL),
(12133, '2016-11-04 11:24:52', NULL, NULL, 4275, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 11:24:52', 'admin-1478221054-1478229891936758', 1, 0, '', NULL, NULL, NULL),
(12134, '2016-11-04 11:24:52', NULL, NULL, 4275, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 11:24:52', 'admin-1478221054-1478229891936758', 1, 0, '', NULL, NULL, NULL),
(12135, '2016-11-04 11:25:14', NULL, NULL, 4275, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 11:25:14', 'admin-1478229899-14782299142679368', 1, 0, '', NULL, NULL, NULL),
(12136, '2016-11-04 11:31:06', NULL, NULL, 4276, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 11:31:06', 'admin-1478229899-1478230266584476', 1, 1, 'SR', NULL, NULL, NULL),
(12137, '2016-11-04 11:25:14', NULL, NULL, 4275, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 11:25:14', 'admin-1478229899-14782299142679368', 1, 1, 'SR', NULL, NULL, NULL),
(12138, '2016-11-04 10:59:02', NULL, NULL, 4273, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 10:59:02', 'admin-1478221054-14782283421209362', 1, 1, 'SR', NULL, NULL, NULL),
(12139, '2016-11-04 10:59:02', NULL, NULL, 4273, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 10:59:02', 'admin-1478221054-14782283421209362', 1, 0, '', NULL, NULL, NULL),
(12140, '2016-11-04 10:59:02', NULL, NULL, 4273, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 10:59:02', 'admin-1478221054-14782283421209362', 1, 0, '', NULL, NULL, NULL),
(12141, '2016-11-04 10:52:52', NULL, NULL, 4271, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 10:52:52', 'admin-1478221054-14782279725391232', 1, 1, 'SR', NULL, NULL, NULL),
(12142, '2016-11-04 10:42:35', NULL, NULL, 4272, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 10:42:35', 'admin-1478221054-14782273549587117', 1, 0, '', NULL, NULL, NULL),
(12143, '2016-11-04 10:42:35', NULL, NULL, 4272, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 10:42:35', 'admin-1478221054-14782273549587117', 1, 0, '', NULL, NULL, NULL),
(12144, '2016-11-04 10:42:35', NULL, NULL, 4272, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 10:42:35', 'admin-1478221054-14782273549587117', 1, 0, '', NULL, NULL, NULL),
(12145, '2016-11-04 10:42:35', NULL, NULL, 4272, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 10:42:35', 'admin-1478221054-14782273549587117', 1, 0, '', NULL, NULL, NULL),
(12146, '2016-11-04 10:42:35', NULL, NULL, 4272, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 10:42:35', 'admin-1478221054-14782273549587117', 1, 1, 'SR', NULL, NULL, NULL),
(12147, '2016-11-04 10:42:35', NULL, NULL, 4272, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 10:42:35', 'admin-1478221054-14782273549587117', 1, 1, 'SR', NULL, NULL, NULL),
(12148, '2016-11-04 10:35:20', NULL, NULL, 4271, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 10:35:20', 'admin-1478221054-14782269200166090', 1, 1, 'SR', NULL, NULL, NULL),
(12149, '2016-11-04 10:35:20', NULL, NULL, 4271, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 10:35:20', 'admin-1478221054-14782269200166090', 1, 0, '', NULL, NULL, NULL),
(12150, '2016-11-04 10:29:27', NULL, NULL, 4270, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 10:29:27', 'admin-1478221054-14782265669723443', 1, 1, 'SR', NULL, NULL, NULL),
(12151, '2016-11-04 10:21:51', NULL, NULL, 4269, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 10:21:51', 'admin-1478221054-1478226111772594', 1, 0, '', NULL, NULL, NULL),
(12152, '2016-11-04 09:40:22', NULL, NULL, 4268, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 09:40:22', 'admin-1478221054-14782236221554871', 1, 1, 'SR', NULL, NULL, NULL),
(12153, '2016-11-04 10:16:17', NULL, NULL, 4269, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 10:16:17', 'admin-1478221054-14782257769613194', 1, 1, 'SR', NULL, NULL, NULL),
(12154, '2016-11-04 09:39:32', NULL, NULL, 4268, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 09:39:32', 'admin-1478221054-1478223572510449', 1, 0, '', NULL, NULL, NULL),
(12155, '2016-11-04 09:37:52', NULL, NULL, 4267, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478256345', 'admin', '2016-11-04 09:37:52', 'admin-1478221054-14782234722928525', 1, 0, '', NULL, NULL, NULL),
(12156, '2016-11-05 20:36:31', NULL, NULL, 4338, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 20:36:31', 'admin-1478346242-1478349391486744', 1, 0, '', NULL, NULL, NULL),
(12157, '2016-11-05 15:08:02', NULL, NULL, 4329, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 15:08:02', 'admin-1478321270-14783296825537725', 1, 0, '', NULL, NULL, NULL),
(12158, '2016-11-05 14:47:26', NULL, NULL, 4328, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 14:47:26', 'admin-1478321270-14783284462536669', 1, 1, 'SR', NULL, NULL, NULL),
(12159, '2016-11-05 11:06:43', NULL, NULL, 4312, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 11:06:43', 'admin-1478312821-14783152034936282', 1, 1, 'SR', NULL, NULL, NULL),
(12160, '2016-11-05 11:15:24', NULL, NULL, 4313, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 11:15:24', 'admin-1478315211-14783157241303138', 1, 0, '', NULL, NULL, NULL),
(12161, '2016-11-05 11:15:24', NULL, NULL, 4313, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 11:15:24', 'admin-1478315211-14783157241303138', 1, 0, '', NULL, NULL, NULL),
(12162, '2016-11-05 11:15:24', NULL, NULL, 4313, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 11:15:24', 'admin-1478315211-14783157241303138', 1, 1, 'SR', NULL, NULL, NULL),
(12163, '2016-11-05 11:15:24', NULL, NULL, 4313, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 11:15:24', 'admin-1478315211-14783157241303138', 1, 1, 'SR', NULL, NULL, NULL),
(12164, '2016-11-05 11:17:31', NULL, NULL, 4314, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 11:17:31', 'admin-1478315211-14783158511511251', 1, 1, 'SR', NULL, NULL, NULL),
(12165, '2016-11-05 11:17:31', NULL, NULL, 4314, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 11:17:31', 'admin-1478315211-14783158511511251', 1, 1, 'SR', NULL, NULL, NULL),
(12166, '2016-11-05 11:17:31', NULL, NULL, 4314, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 11:17:31', 'admin-1478315211-14783158511511251', 1, 1, 'SR', NULL, NULL, NULL),
(12167, '2016-11-05 20:36:31', NULL, NULL, 4338, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 20:36:31', 'admin-1478346242-1478349391486744', 1, 1, 'SR', NULL, NULL, NULL),
(12168, '2016-11-05 20:26:18', NULL, NULL, 4337, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 20:26:18', 'admin-1478346242-14783487787196472', 1, 1, 'SR', NULL, NULL, NULL),
(12169, '2016-11-05 20:26:18', NULL, NULL, 4337, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 20:26:18', 'admin-1478346242-14783487787196472', 1, 1, 'SR', NULL, NULL, NULL),
(12170, '2016-11-05 20:26:18', NULL, NULL, 4337, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 20:26:18', 'admin-1478346242-14783487787196472', 1, 0, '', NULL, NULL, NULL),
(12171, '2016-11-05 19:30:46', NULL, NULL, 4335, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 19:30:46', 'admin-1478321270-14783454466532669', 1, 1, 'SR', NULL, NULL, NULL),
(12172, '2016-11-05 20:18:03', NULL, NULL, 4336, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 20:18:03', 'admin-1478346242-14783482832882567', 1, 1, 'SR', NULL, NULL, NULL),
(12173, '2016-11-05 20:30:47', NULL, NULL, 4337, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 20:30:47', 'admin-1478346242-14783490477063464', 1, 0, '', NULL, NULL, NULL),
(12174, '2016-11-05 20:29:20', NULL, NULL, 4337, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 20:29:20', 'admin-1478346242-14783489605478692', 1, 1, 'SR', NULL, NULL, NULL),
(12175, '2016-11-05 20:29:20', NULL, NULL, 4337, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 20:29:20', 'admin-1478346242-14783489605478692', 1, 1, 'SR', NULL, NULL, NULL),
(12176, '2016-11-05 20:29:20', NULL, NULL, 4337, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 20:29:20', 'admin-1478346242-14783489605478692', 1, 1, 'SR', NULL, NULL, NULL),
(12177, '2016-11-05 20:26:18', NULL, NULL, 4337, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 20:26:18', 'admin-1478346242-14783487787196472', 1, 0, '', NULL, NULL, NULL),
(12178, '2016-11-05 20:29:20', NULL, NULL, 4337, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 20:29:20', 'admin-1478346242-14783489605478692', 1, 0, '', NULL, NULL, NULL),
(12179, '2016-11-05 20:29:20', NULL, NULL, 4337, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 20:29:20', 'admin-1478346242-14783489605478692', 1, 0, '', NULL, NULL, NULL),
(12180, '2016-11-05 20:26:18', NULL, NULL, 4337, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 20:26:18', 'admin-1478346242-14783487787196472', 1, 1, 'SR', NULL, NULL, NULL),
(12181, '2016-11-05 19:08:35', NULL, NULL, 4334, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 19:08:35', 'admin-1478321270-14783441150931235', 1, 1, 'SR', NULL, NULL, NULL),
(12182, '2016-11-05 19:30:46', NULL, NULL, 4335, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 19:30:46', 'admin-1478321270-14783454466532669', 1, 0, '', NULL, NULL, NULL),
(12183, '2016-11-05 19:30:46', NULL, NULL, 4335, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 19:30:46', 'admin-1478321270-14783454466532669', 1, 1, 'SR', NULL, NULL, NULL),
(12184, '2016-11-05 13:39:05', NULL, NULL, 4325, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 13:39:05', 'admin-1478321270-14783243456677760', 1, 1, 'SR', NULL, NULL, NULL),
(12185, '2016-11-05 13:39:13', NULL, NULL, 4326, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 13:39:13', 'admin-1478321270-14783243532453778', 1, 1, 'SR', NULL, NULL, NULL),
(12186, '2016-11-05 13:41:09', NULL, NULL, 4327, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 13:41:09', 'admin-1478321270-1478324469201394', 1, 1, 'SR', NULL, NULL, NULL),
(12187, '2016-11-05 12:29:53', NULL, NULL, 4318, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 12:29:53', 'admin-1478315211-14783201932181320', 1, 0, '', NULL, NULL, NULL),
(12188, '2016-11-05 13:35:02', NULL, NULL, 4324, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 13:35:02', 'admin-1478321270-1478324102156299', 1, 0, '', NULL, NULL, NULL),
(12189, '2016-11-05 13:35:02', NULL, NULL, 4324, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 13:35:02', 'admin-1478321270-1478324102156299', 1, 1, 'SR', NULL, NULL, NULL),
(12190, '2016-11-05 13:12:16', NULL, NULL, 4323, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 13:12:16', 'admin-1478321270-14783227359197918', 1, 1, 'SR', NULL, NULL, NULL),
(12191, '2016-11-05 13:12:16', NULL, NULL, 4323, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 13:12:16', 'admin-1478321270-14783227359197918', 1, 0, '', NULL, NULL, NULL),
(12192, '2016-11-05 13:12:16', NULL, NULL, 4323, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 13:12:16', 'admin-1478321270-14783227359197918', 1, 1, 'SR', NULL, NULL, NULL),
(12193, '2016-11-05 13:12:16', NULL, NULL, 4323, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 13:12:16', 'admin-1478321270-14783227359197918', 1, 0, '', NULL, NULL, NULL),
(12194, '2016-11-05 13:12:16', NULL, NULL, 4323, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 13:12:16', 'admin-1478321270-14783227359197918', 1, 0, '', NULL, NULL, NULL),
(12195, '2016-11-05 13:12:16', NULL, NULL, 4323, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 13:12:16', 'admin-1478321270-14783227359197918', 1, 0, '', NULL, NULL, NULL),
(12196, '2016-11-05 13:05:14', NULL, NULL, 4322, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 13:05:14', 'admin-1478321270-14783223146236766', 1, 1, 'SR', NULL, NULL, NULL),
(12197, '2016-11-05 12:48:01', NULL, NULL, 4320, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 12:48:01', 'admin-1478321270-14783212811241684', 1, 1, 'SR', NULL, NULL, NULL),
(12198, '2016-11-05 13:00:05', NULL, NULL, 4320, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 13:00:05', 'admin-1478321270-14783220058219245', 1, 0, '', NULL, NULL, NULL),
(12199, '2016-11-05 12:59:27', NULL, NULL, 4317, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 12:59:27', 'admin-1478321270-1478321966976510', 1, 1, 'SR', NULL, NULL, NULL),
(12200, '2016-11-05 12:56:56', NULL, NULL, 4321, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 12:56:56', 'admin-1478321270-14783218164277976', 1, 0, '', NULL, NULL, NULL),
(12201, '2016-11-05 12:56:56', NULL, NULL, 4321, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 12:56:56', 'admin-1478321270-14783218164277976', 1, 0, '', NULL, NULL, NULL),
(12202, '2016-11-05 12:56:56', NULL, NULL, 4321, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 12:56:56', 'admin-1478321270-14783218164277976', 1, 1, 'SR', NULL, NULL, NULL),
(12203, '2016-11-05 20:36:31', NULL, NULL, 4338, 0, 228, '162', 'Golden Brown', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 20:36:31', 'admin-1478346242-1478349391486744', 1, 0, '', NULL, NULL, NULL),
(12204, '2016-11-05 20:18:03', NULL, NULL, 4336, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 20:18:03', 'admin-1478346242-14783482832882567', 1, 1, 'SR', NULL, NULL, NULL),
(12205, '2016-11-05 19:30:46', NULL, NULL, 4335, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 19:30:46', 'admin-1478321270-14783454466532669', 1, 1, 'SR', NULL, NULL, NULL),
(12206, '2016-11-05 18:33:09', NULL, NULL, 4333, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 18:33:09', 'admin-1478321270-14783419889152569', 1, 0, '', NULL, NULL, NULL),
(12207, '2016-11-05 19:08:35', NULL, NULL, 4334, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 19:08:35', 'admin-1478321270-14783441150931235', 1, 1, 'SR', NULL, NULL, NULL),
(12208, '2016-11-05 18:32:48', NULL, NULL, 4333, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 18:32:48', 'admin-1478321270-14783419679866234', 1, 0, '', NULL, NULL, NULL),
(12209, '2016-11-05 18:32:48', NULL, NULL, 4333, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 18:32:48', 'admin-1478321270-14783419679866234', 1, 0, '', NULL, NULL, NULL),
(12210, '2016-11-05 15:28:24', NULL, NULL, 4332, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 15:28:24', 'admin-1478321270-14783309045458690', 1, 1, 'SR', NULL, NULL, NULL),
(12211, '2016-11-05 18:32:48', NULL, NULL, 4333, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 18:32:48', 'admin-1478321270-14783419679866234', 1, 0, '', NULL, NULL, NULL),
(12212, '2016-11-05 15:28:24', NULL, NULL, 4332, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 15:28:24', 'admin-1478321270-14783309045458690', 1, 1, 'SR', NULL, NULL, NULL),
(12213, '2016-11-05 15:14:43', NULL, NULL, 4331, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 15:14:43', 'admin-1478321270-14783300838076344', 1, 1, 'SR', NULL, NULL, NULL),
(12214, '2016-11-05 15:10:34', NULL, NULL, 4330, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 15:10:34', 'admin-1478321270-14783298345244818', 1, 1, 'SR', NULL, NULL, NULL),
(12215, '2016-11-05 15:10:34', NULL, NULL, 4330, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 15:10:34', 'admin-1478321270-14783298345244818', 1, 0, '', NULL, NULL, NULL),
(12216, '2016-11-05 14:47:42', NULL, NULL, 4328, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 14:47:42', 'admin-1478321270-1478328462590377', 1, 1, 'SR', NULL, NULL, NULL),
(12217, '2016-11-05 15:08:02', NULL, NULL, 4329, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 15:08:02', 'admin-1478321270-14783296825537725', 1, 0, '', NULL, NULL, NULL),
(12218, '2016-11-05 14:47:10', NULL, NULL, 4328, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 14:47:10', 'admin-1478321270-14783284300758945', 1, 1, 'SR', NULL, NULL, NULL),
(12219, '2016-11-05 14:47:10', NULL, NULL, 4328, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 14:47:10', 'admin-1478321270-14783284300758945', 1, 1, 'SR', NULL, NULL, NULL),
(12220, '2016-11-05 12:39:42', NULL, NULL, 4319, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 12:39:42', 'admin-1478315211-14783207823167570', 1, 0, '', NULL, NULL, NULL),
(12221, '2016-11-05 12:47:44', NULL, NULL, 4320, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 12:47:44', 'admin-1478315211-14783212646434256', 1, 0, '', NULL, NULL, NULL),
(12222, '2016-11-05 12:48:01', NULL, NULL, 4320, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 12:48:01', 'admin-1478321270-14783212811241684', 1, 1, 'SR', NULL, NULL, NULL),
(12223, '2016-11-05 12:39:36', NULL, NULL, 4319, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 12:39:36', 'admin-1478315211-1478320776372240', 1, 0, '', NULL, NULL, NULL),
(12224, '2016-11-05 12:29:53', NULL, NULL, 4318, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 12:29:53', 'admin-1478315211-14783201932181320', 1, 1, 'SR', NULL, NULL, NULL),
(12225, '2016-11-05 11:47:49', NULL, NULL, 4315, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 11:47:49', 'admin-1478315211-14783176694454480', 1, 1, 'SR', NULL, NULL, NULL),
(12226, '2016-11-05 11:59:25', NULL, NULL, 4310, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 11:59:25', 'admin-1478315211-14783183656444746', 1, 1, 'SR', NULL, NULL, NULL),
(12227, '2016-11-05 11:59:25', NULL, NULL, 4310, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 11:59:25', 'admin-1478315211-14783183656444746', 1, 1, 'SR', NULL, NULL, NULL),
(12228, '2016-11-05 11:59:25', NULL, NULL, 4310, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 11:59:25', 'admin-1478315211-14783183656444746', 1, 1, 'SR', NULL, NULL, NULL),
(12229, '2016-11-05 12:12:03', NULL, NULL, 4317, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 12:12:03', 'admin-1478315211-1478319123438279', 1, 1, 'SR', NULL, NULL, NULL),
(12230, '2016-11-05 12:11:58', NULL, NULL, 4317, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 12:11:58', 'admin-1478315211-14783191186271563', 1, 0, '', NULL, NULL, NULL),
(12231, '2016-11-05 12:12:03', NULL, NULL, 4317, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 12:12:03', 'admin-1478315211-1478319123438279', 1, 1, 'SR', NULL, NULL, NULL),
(12232, '2016-11-05 12:11:58', NULL, NULL, 4317, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 12:11:58', 'admin-1478315211-14783191186271563', 1, 0, '', NULL, NULL, NULL),
(12233, '2016-11-05 12:10:48', NULL, NULL, 4316, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 12:10:48', 'admin-1478315211-14783190479079486', 1, 1, 'SR', NULL, NULL, NULL),
(12234, '2016-11-05 12:10:48', NULL, NULL, 4316, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 12:10:48', 'admin-1478315211-14783190479079486', 1, 1, 'SR', NULL, NULL, NULL),
(12235, '2016-11-05 11:59:25', NULL, NULL, 4310, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 11:59:25', 'admin-1478315211-14783183656444746', 1, 0, '', NULL, NULL, NULL),
(12236, '2016-11-05 11:59:25', NULL, NULL, 4310, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 11:59:25', 'admin-1478315211-14783183656444746', 1, 0, '', NULL, NULL, NULL),
(12237, '2016-11-05 11:47:12', NULL, NULL, 4315, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 11:47:12', 'admin-1478315211-14783176324404799', 1, 1, 'SR', NULL, NULL, NULL),
(12238, '2016-11-05 11:47:12', NULL, NULL, 4315, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 11:47:12', 'admin-1478315211-14783176324404799', 1, 1, 'SR', NULL, NULL, NULL),
(12239, '2016-11-05 11:44:48', NULL, NULL, 4314, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 11:44:48', 'admin-1478315211-1478317488537542', 1, 0, '', NULL, NULL, NULL),
(12240, '2016-11-05 11:47:12', NULL, NULL, 4315, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 11:47:12', 'admin-1478315211-14783176324404799', 1, 1, 'SR', NULL, NULL, NULL),
(12241, '2016-11-05 10:26:35', NULL, NULL, 4307, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 10:26:35', 'admin-1478307790-1478312795574654', 1, 0, '', NULL, NULL, NULL),
(12242, '2016-11-05 10:47:09', NULL, NULL, 4308, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 10:47:09', 'admin-1478312821-14783140296938347', 1, 0, '', NULL, NULL, NULL),
(12243, '2016-11-05 10:47:09', NULL, NULL, 4308, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 10:47:09', 'admin-1478312821-14783140296938347', 1, 0, '', NULL, NULL, NULL),
(12244, '2016-11-05 10:47:09', NULL, NULL, 4308, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 10:47:09', 'admin-1478312821-14783140296938347', 1, 0, '', NULL, NULL, NULL),
(12245, '2016-11-05 10:47:09', NULL, NULL, 4308, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 10:47:09', 'admin-1478312821-14783140296938347', 1, 0, '', NULL, NULL, NULL),
(12246, '2016-11-05 10:47:09', NULL, NULL, 4308, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 10:47:09', 'admin-1478312821-14783140296938347', 1, 0, '', NULL, NULL, NULL),
(12247, '2016-11-05 10:47:23', NULL, NULL, 4308, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 10:47:23', 'admin-1478312821-14783140431593122', 1, 1, 'SR', NULL, NULL, NULL),
(12248, '2016-11-05 10:47:23', NULL, NULL, 4308, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 10:47:23', 'admin-1478312821-14783140431593122', 1, 1, 'SR', NULL, NULL, NULL),
(12249, '2016-11-05 10:47:23', NULL, NULL, 4308, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 10:47:23', 'admin-1478312821-14783140431593122', 1, 1, 'SR', NULL, NULL, NULL),
(12250, '2016-11-05 10:47:23', NULL, NULL, 4308, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 10:47:23', 'admin-1478312821-14783140431593122', 1, 1, 'SR', NULL, NULL, NULL),
(12251, '2016-11-05 10:53:32', NULL, NULL, 4309, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 10:53:32', 'admin-1478312821-14783144120238382', 1, 1, 'SR', NULL, NULL, NULL),
(12252, '2016-11-05 10:54:45', NULL, NULL, 4310, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 10:54:45', 'admin-1478312821-1478314485228713', 1, 1, 'SR', NULL, NULL, NULL),
(12253, '2016-11-05 10:57:09', NULL, NULL, 4311, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 10:57:09', 'admin-1478312821-14783146289064852', 1, 0, '', NULL, NULL, NULL),
(12254, '2016-11-05 10:57:09', NULL, NULL, 4311, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 10:57:09', 'admin-1478312821-14783146289064852', 1, 1, 'SR', NULL, NULL, NULL),
(12255, '2016-11-05 11:06:38', NULL, NULL, 4312, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 11:06:38', 'admin-1478312821-14783151979284292', 1, 0, '', NULL, NULL, NULL),
(12256, '2016-11-05 11:06:38', NULL, NULL, 4312, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 11:06:38', 'admin-1478312821-14783151979284292', 1, 0, '', NULL, NULL, NULL),
(12257, '2016-11-05 11:06:43', NULL, NULL, 4312, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 11:06:43', 'admin-1478312821-14783152034936282', 1, 1, 'SR', NULL, NULL, NULL),
(12258, '2016-11-05 09:27:08', NULL, NULL, 4303, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 09:27:08', 'admin-1478307790-14783092278942429', 1, 1, 'SR', NULL, NULL, NULL),
(12259, '2016-11-05 10:08:02', NULL, NULL, 4304, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 10:08:02', 'admin-1478307790-14783116819073829', 1, 1, 'SR', NULL, NULL, NULL),
(12260, '2016-11-05 10:08:02', NULL, NULL, 4304, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 10:08:02', 'admin-1478307790-14783116819073829', 1, 1, 'SR', NULL, NULL, NULL),
(12261, '2016-11-05 10:26:35', NULL, NULL, 4307, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 10:26:35', 'admin-1478307790-1478312795574654', 1, 0, '', NULL, NULL, NULL),
(12262, '2016-11-05 10:17:43', NULL, NULL, 4306, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 10:17:43', 'admin-1478307790-14783122633887868', 1, 1, 'SR', 1, NULL, NULL),
(12263, '2016-11-05 09:27:08', NULL, NULL, 4303, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 09:27:08', 'admin-1478307790-14783092278942429', 1, 0, '', NULL, NULL, NULL),
(12264, '2016-11-05 09:27:08', NULL, NULL, 4303, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 09:27:08', 'admin-1478307790-14783092278942429', 1, 0, '', NULL, NULL, NULL),
(12265, '2016-11-05 09:27:08', NULL, NULL, 4303, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 09:27:08', 'admin-1478307790-14783092278942429', 1, 0, '', NULL, NULL, NULL),
(12266, '2016-11-05 09:27:08', NULL, NULL, 4303, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 09:27:08', 'admin-1478307790-14783092278942429', 1, 0, '', NULL, NULL, NULL),
(12267, '2016-11-05 09:27:08', NULL, NULL, 4303, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 09:27:08', 'admin-1478307790-14783092278942429', 1, 1, 'SR', NULL, NULL, NULL),
(12268, '2016-11-05 09:27:08', NULL, NULL, 4303, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 09:27:08', 'admin-1478307790-14783092278942429', 1, 1, 'SR', NULL, NULL, NULL),
(12269, '2016-11-05 09:22:49', NULL, NULL, 4302, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 09:22:49', 'admin-1478307790-14783089695972021', 1, 0, '', NULL, NULL, NULL),
(12270, '2016-11-05 09:22:49', NULL, NULL, 4302, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 09:22:49', 'admin-1478307790-14783089695972021', 1, 1, 'SR', NULL, NULL, NULL),
(12271, '2016-11-05 09:22:49', NULL, NULL, 4302, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 09:22:49', 'admin-1478307790-14783089695972021', 1, 0, '', NULL, NULL, NULL),
(12272, '2016-11-05 09:22:49', NULL, NULL, 4302, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 09:22:49', 'admin-1478307790-14783089695972021', 1, 0, '', NULL, NULL, NULL),
(12273, '2016-11-05 09:10:51', NULL, NULL, 4301, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 09:10:51', 'admin-1478307790-14783082516493111', 1, 1, 'SR', NULL, NULL, NULL),
(12274, '2016-11-05 09:10:51', NULL, NULL, 4301, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 09:10:51', 'admin-1478307790-14783082516493111', 1, 1, 'SR', NULL, NULL, NULL),
(12275, '2016-11-05 09:10:17', NULL, NULL, 4301, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 09:10:17', 'admin-1478307790-1478308217806329', 1, 0, '', NULL, NULL, NULL),
(12276, '2016-11-05 09:10:17', NULL, NULL, 4301, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 09:10:17', 'admin-1478307790-1478308217806329', 1, 0, '', NULL, NULL, NULL),
(12277, '2016-11-05 09:09:20', NULL, NULL, 4300, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 09:09:20', 'admin-1478307790-14783081605167753', 1, 1, 'SR', NULL, NULL, NULL),
(12278, '2016-11-05 09:09:08', NULL, NULL, 4300, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 09:09:08', 'admin-1478307790-14783081479017866', 1, 1, 'SR', NULL, NULL, NULL),
(12279, '2016-11-05 09:09:08', NULL, NULL, 4300, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 09:09:08', 'admin-1478307790-14783081479017866', 1, 0, '', NULL, NULL, NULL),
(12280, '2016-11-05 09:07:14', NULL, NULL, 4299, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 09:07:14', 'admin-1478307790-14783080339391776', 1, 0, '', NULL, NULL, NULL),
(12281, '2016-11-05 09:07:14', NULL, NULL, 4299, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 09:07:14', 'admin-1478307790-14783080339391776', 1, 0, '', NULL, NULL, NULL),
(12282, '2016-11-05 09:09:08', NULL, NULL, 4300, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 09:09:08', 'admin-1478307790-14783081479017866', 1, 0, '', NULL, NULL, NULL),
(12283, '2016-11-05 09:07:14', NULL, NULL, 4299, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478346242', 'admin', '2016-11-05 09:07:14', 'admin-1478307790-14783080339391776', 1, 0, '', NULL, NULL, NULL),
(12284, '2016-11-06 18:19:49', NULL, NULL, 4362, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 18:19:49', 'admin-1478407929-14784275892085430', 1, 1, 'SR', NULL, NULL, NULL),
(12285, '2016-11-06 18:55:27', NULL, NULL, 4364, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 18:55:27', 'admin-1478427999-14784297268429566', 1, 0, '', NULL, NULL, NULL),
(12286, '2016-11-06 18:57:06', NULL, NULL, 4364, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 18:57:06', 'admin-1478427999-14784298261635966', 1, 0, '', NULL, NULL, NULL),
(12287, '2016-11-06 18:57:16', NULL, NULL, 4364, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 18:57:16', 'admin-1478427999-14784298360051616', 1, 1, 'SR', NULL, NULL, NULL),
(12288, '2016-11-06 19:14:05', NULL, NULL, 4362, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 19:14:05', 'admin-1478427999-1478430845676118', 1, 1, 'SR', NULL, NULL, NULL),
(12289, '2016-11-06 16:48:40', NULL, NULL, 4361, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 16:48:40', 'admin-1478407929-14784221203135559', 1, 1, 'SR', NULL, NULL, NULL),
(12290, '2016-11-06 18:19:49', NULL, NULL, 4362, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 18:19:49', 'admin-1478407929-14784275892085430', 1, 1, 'SR', NULL, NULL, NULL),
(12291, '2016-11-06 18:19:49', NULL, NULL, 4362, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 18:19:49', 'admin-1478407929-14784275892085430', 1, 1, 'SR', NULL, NULL, NULL),
(12292, '2016-11-06 18:19:49', NULL, NULL, 4362, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 18:19:49', 'admin-1478407929-14784275892085430', 1, 1, 'SR', NULL, NULL, NULL),
(12293, '2016-11-06 18:22:33', NULL, NULL, 4362, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 18:22:33', 'admin-1478407929-14784277528635890', 1, 0, '', NULL, NULL, NULL),
(12294, '2016-11-06 18:22:33', NULL, NULL, 4362, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 18:22:33', 'admin-1478407929-14784277528635890', 1, 0, '', NULL, NULL, NULL),
(12295, '2016-11-06 18:22:45', NULL, NULL, 4363, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 18:22:45', 'admin-1478407929-1478427765240708', 1, 1, 'SR', NULL, NULL, NULL),
(12296, '2016-11-06 18:27:53', NULL, NULL, 4363, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 18:27:53', 'admin-1478427999-14784280735994825', 1, 1, 'SR', NULL, NULL, NULL),
(12297, '2016-11-06 18:55:27', NULL, NULL, 4364, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 18:55:27', 'admin-1478427999-14784297268429566', 1, 1, 'SR', NULL, NULL, NULL),
(12298, '2016-11-06 12:09:11', NULL, NULL, 4352, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:09:11', 'admin-1478404070-1478405351361589', 1, 1, 'SR', NULL, NULL, NULL),
(12299, '2016-11-06 12:44:25', NULL, NULL, 4351, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:44:25', 'admin-1478404070-14784074652234260', 1, 0, '', NULL, NULL, NULL),
(12300, '2016-11-06 14:04:38', NULL, NULL, 4354, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 14:04:38', 'admin-1478407929-14784122780607076', 1, 1, 'SR', NULL, NULL, NULL),
(12301, '2016-11-06 14:04:38', NULL, NULL, 4354, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 14:04:38', 'admin-1478407929-14784122780607076', 1, 1, 'SR', NULL, NULL, NULL),
(12302, '2016-11-06 14:04:50', NULL, NULL, 4354, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 14:04:50', 'admin-1478407929-14784122900086396', 1, 1, 'SR', NULL, NULL, NULL),
(12303, '2016-11-06 14:04:50', NULL, NULL, 4354, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 14:04:50', 'admin-1478407929-14784122900086396', 1, 1, 'SR', NULL, NULL, NULL),
(12304, '2016-11-06 14:09:54', NULL, NULL, 4355, 0, 222, '156', 'Seasoned Chicken Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 14:09:54', 'admin-1478407929-14784125942347665', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(12305, '2016-11-06 14:09:54', NULL, NULL, 4355, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 14:09:54', 'admin-1478407929-14784125942347665', 1, 1, 'SR', NULL, NULL, NULL),
(12306, '2016-11-06 14:09:54', NULL, NULL, 4355, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 14:09:54', 'admin-1478407929-14784125942347665', 1, 1, 'SR', NULL, NULL, NULL),
(12307, '2016-11-06 15:14:53', NULL, NULL, 4357, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 15:14:53', 'admin-1478407929-14784164931815661', 1, 1, 'SR', NULL, NULL, NULL),
(12308, '2016-11-06 15:14:53', NULL, NULL, 4357, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 15:14:53', 'admin-1478407929-14784164931815661', 1, 0, '', NULL, NULL, NULL),
(12309, '2016-11-06 15:14:53', NULL, NULL, 4357, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 15:14:53', 'admin-1478407929-14784164931815661', 1, 0, '', NULL, NULL, NULL),
(12310, '2016-11-06 12:50:08', NULL, NULL, 4353, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:50:08', 'admin-1478404070-14784078086748539', 1, 1, 'SR', NULL, NULL, NULL),
(12311, '2016-11-06 11:59:45', NULL, NULL, 4349, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:59:45', 'admin-1478404070-14784047850185829', 1, 1, 'SR', NULL, NULL, NULL),
(12312, '2016-11-06 18:57:06', NULL, NULL, 4364, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 18:57:06', 'admin-1478427999-14784298261635966', 1, 0, '', NULL, NULL, NULL),
(12313, '2016-11-06 16:48:26', NULL, NULL, 4360, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 16:48:26', 'admin-1478407929-14784221061314582', 1, 1, 'SR', NULL, NULL, NULL),
(12314, '2016-11-06 16:48:40', NULL, NULL, 4361, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 16:48:40', 'admin-1478407929-14784221203135559', 1, 1, 'SR', NULL, NULL, NULL),
(12315, '2016-11-06 15:15:57', NULL, NULL, 4358, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 15:15:57', 'admin-1478407929-14784165572546051', 1, 1, 'SR', NULL, NULL, NULL),
(12316, '2016-11-06 16:02:53', NULL, NULL, 4359, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 16:02:53', 'admin-1478407929-14784193734856678', 1, 0, '', NULL, NULL, NULL),
(12317, '2016-11-06 16:02:53', NULL, NULL, 4359, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 16:02:53', 'admin-1478407929-14784193734856678', 1, 1, 'SR', NULL, NULL, NULL),
(12318, '2016-11-06 16:02:53', NULL, NULL, 4359, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 16:02:53', 'admin-1478407929-14784193734856678', 1, 1, 'SR', NULL, NULL, NULL),
(12319, '2016-11-06 15:15:57', NULL, NULL, 4358, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 15:15:57', 'admin-1478407929-14784165572546051', 1, 1, 'SR', NULL, NULL, NULL),
(12320, '2016-11-06 15:15:57', NULL, NULL, 4358, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 15:15:57', 'admin-1478407929-14784165572546051', 1, 0, '', NULL, NULL, NULL),
(12321, '2016-11-06 15:15:01', NULL, NULL, 4357, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 15:15:01', 'admin-1478407929-1478416501718866', 1, 1, 'SR', NULL, NULL, NULL),
(12322, '2016-11-06 15:15:01', NULL, NULL, 4357, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 15:15:01', 'admin-1478407929-1478416501718866', 1, 1, 'SR', NULL, NULL, NULL),
(12323, '2016-11-06 14:22:53', NULL, NULL, 4356, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 14:22:53', 'admin-1478407929-14784133733791092', 1, 1, 'SR', NULL, NULL, NULL),
(12324, '2016-11-06 15:14:53', NULL, NULL, 4357, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 15:14:53', 'admin-1478407929-14784164931815661', 1, 0, '', NULL, NULL, NULL),
(12325, '2016-11-06 15:15:01', NULL, NULL, 4357, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 15:15:01', 'admin-1478407929-1478416501718866', 1, 1, 'SR', NULL, NULL, NULL),
(12326, '2016-11-06 15:14:53', NULL, NULL, 4357, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 15:14:53', 'admin-1478407929-14784164931815661', 1, 1, 'SR', NULL, NULL, NULL),
(12327, '2016-11-06 14:22:53', NULL, NULL, 4356, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 14:22:53', 'admin-1478407929-14784133733791092', 1, 0, '', NULL, NULL, NULL),
(12328, '2016-11-06 12:52:00', NULL, NULL, 4353, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:52:00', 'admin-1478404070-14784079200519183', 1, 0, '', NULL, NULL, NULL),
(12329, '2016-11-06 12:49:59', NULL, NULL, 4353, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:49:59', 'admin-1478404070-14784077993955273', 1, 1, 'SR', NULL, NULL, NULL),
(12330, '2016-11-06 12:49:59', NULL, NULL, 4353, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:49:59', 'admin-1478404070-14784077993955273', 1, 0, '', NULL, NULL, NULL),
(12331, '2016-11-06 12:49:59', NULL, NULL, 4353, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:49:59', 'admin-1478404070-14784077993955273', 1, 0, '', NULL, NULL, NULL),
(12332, '2016-11-06 12:50:08', NULL, NULL, 4353, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:50:08', 'admin-1478404070-14784078086748539', 1, 1, 'SR', NULL, NULL, NULL),
(12333, '2016-11-06 12:49:59', NULL, NULL, 4353, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:49:59', 'admin-1478404070-14784077993955273', 1, 1, 'SR', NULL, NULL, NULL),
(12334, '2016-11-06 12:05:29', NULL, NULL, 4351, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:05:29', 'admin-1478404070-14784051296628416', 1, 0, '', NULL, NULL, NULL),
(12335, '2016-11-06 12:05:29', NULL, NULL, 4351, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:05:29', 'admin-1478404070-14784051296628416', 1, 0, '', NULL, NULL, NULL),
(12336, '2016-11-06 12:05:29', NULL, NULL, 4351, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:05:29', 'admin-1478404070-14784051296628416', 1, 0, '', NULL, NULL, NULL),
(12337, '2016-11-06 12:05:29', NULL, NULL, 4351, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:05:29', 'admin-1478404070-14784051296628416', 1, 1, 'SR', NULL, NULL, NULL),
(12338, '2016-11-06 12:05:29', NULL, NULL, 4351, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:05:29', 'admin-1478404070-14784051296628416', 1, 0, '', NULL, NULL, NULL),
(12339, '2016-11-06 12:05:29', NULL, NULL, 4351, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:05:29', 'admin-1478404070-14784051296628416', 1, 1, 'SR', NULL, NULL, NULL),
(12340, '2016-11-06 12:05:29', NULL, NULL, 4351, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:05:29', 'admin-1478404070-14784051296628416', 1, 1, 'SR', NULL, NULL, NULL),
(12341, '2016-11-06 12:05:29', NULL, NULL, 4351, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:05:29', 'admin-1478404070-14784051296628416', 1, 1, 'SR', NULL, NULL, NULL),
(12342, '2016-11-06 12:05:29', NULL, NULL, 4351, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:05:29', 'admin-1478404070-14784051296628416', 1, 1, 'SR', NULL, NULL, NULL),
(12343, '2016-11-06 12:09:11', NULL, NULL, 4352, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:09:11', 'admin-1478404070-1478405351361589', 1, 1, 'SR', NULL, NULL, NULL),
(12344, '2016-11-06 12:02:55', NULL, NULL, 4350, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:02:55', 'admin-1478404070-14784049756924644', 1, 1, 'SR', NULL, NULL, NULL),
(12345, '2016-11-06 12:02:55', NULL, NULL, 4350, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:02:55', 'admin-1478404070-14784049756924644', 1, 1, 'SR', NULL, NULL, NULL),
(12346, '2016-11-06 12:02:30', NULL, NULL, 4350, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:02:30', 'admin-1478404070-14784049502418637', 1, 0, '', NULL, NULL, NULL),
(12347, '2016-11-06 12:02:30', NULL, NULL, 4350, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:02:30', 'admin-1478404070-14784049502418637', 1, 0, '', NULL, NULL, NULL),
(12348, '2016-11-06 12:02:30', NULL, NULL, 4350, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 12:02:30', 'admin-1478404070-14784049502418637', 1, 1, 'SR', NULL, NULL, NULL),
(12349, '2016-11-06 11:59:45', NULL, NULL, 4349, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:59:45', 'admin-1478404070-14784047850185829', 1, 1, 'SR', NULL, NULL, NULL),
(12350, '2016-11-06 11:19:19', NULL, NULL, 4344, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:19:19', 'admin-1478402088-14784023595065726', 1, 0, '', NULL, NULL, NULL),
(12351, '2016-11-06 11:42:06', NULL, NULL, 4345, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:42:06', 'admin-1478402088-14784037265397377', 1, 0, '', NULL, NULL, NULL),
(12352, '2016-11-06 11:42:06', NULL, NULL, 4345, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:42:06', 'admin-1478402088-14784037265397377', 1, 0, '', NULL, NULL, NULL),
(12353, '2016-11-06 11:42:06', NULL, NULL, 4345, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:42:06', 'admin-1478402088-14784037265397377', 1, 0, '', NULL, NULL, NULL),
(12354, '2016-11-06 11:42:06', NULL, NULL, 4345, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:42:06', 'admin-1478402088-14784037265397377', 1, 0, '', NULL, NULL, NULL),
(12355, '2016-11-06 11:42:11', NULL, NULL, 4345, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:42:11', 'admin-1478402088-14784037312875871', 1, 0, '', NULL, NULL, NULL),
(12356, '2016-11-06 11:42:11', NULL, NULL, 4345, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:42:11', 'admin-1478402088-14784037312875871', 1, 1, 'SR', NULL, NULL, NULL),
(12357, '2016-11-06 11:44:10', NULL, NULL, 4346, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:44:10', 'admin-1478402088-14784038500596458', 1, 1, 'SR', NULL, NULL, NULL),
(12358, '2016-11-06 11:44:10', NULL, NULL, 4346, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:44:10', 'admin-1478402088-14784038500596458', 1, 1, 'SR', NULL, NULL, NULL),
(12359, '2016-11-06 11:44:10', NULL, NULL, 4346, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:44:10', 'admin-1478402088-14784038500596458', 1, 0, '', NULL, NULL, NULL),
(12360, '2016-11-06 11:44:10', NULL, NULL, 4346, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:44:10', 'admin-1478402088-14784038500596458', 1, 0, '', NULL, NULL, NULL),
(12361, '2016-11-06 11:45:12', NULL, NULL, 4347, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:45:12', 'admin-1478402088-1478403912289281', 1, 0, '', NULL, NULL, NULL),
(12362, '2016-11-06 11:45:12', NULL, NULL, 4347, 0, 222, '156', 'Seasoned Chicken Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:45:12', 'admin-1478402088-1478403912289281', 1, 0, '', NULL, NULL, NULL),
(12363, '2016-11-06 11:45:12', NULL, NULL, 4347, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:45:12', 'admin-1478402088-1478403912289281', 1, 0, '', NULL, NULL, NULL),
(12364, '2016-11-06 11:47:30', NULL, NULL, 4348, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:47:30', 'admin-1478402088-14784040498348886', 1, 1, 'SR', NULL, NULL, NULL),
(12365, '2016-11-06 11:47:30', NULL, NULL, 4348, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:47:30', 'admin-1478402088-14784040498348886', 1, 0, '', NULL, NULL, NULL),
(12366, '2016-11-06 11:59:45', NULL, NULL, 4349, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:59:45', 'admin-1478404070-14784047850185829', 1, 0, '', NULL, NULL, NULL),
(12367, '2016-11-06 11:15:35', NULL, NULL, 4343, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:15:35', 'admin-1478402088-14784021354838172', 1, 1, 'SR', NULL, NULL, NULL),
(12368, '2016-11-06 11:15:35', NULL, NULL, 4343, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:15:35', 'admin-1478402088-14784021354838172', 1, 1, 'SR', NULL, NULL, NULL),
(12369, '2016-11-06 11:18:01', NULL, NULL, 4344, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:18:01', 'admin-1478402088-14784022811494363', 1, 0, '', NULL, NULL, NULL),
(12370, '2016-11-06 11:18:01', NULL, NULL, 4344, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:18:01', 'admin-1478402088-14784022811494363', 1, 1, 'SR', NULL, NULL, NULL),
(12371, '2016-11-06 11:18:01', NULL, NULL, 4344, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:18:01', 'admin-1478402088-14784022811494363', 1, 1, 'SR', NULL, NULL, NULL),
(12372, '2016-11-06 10:23:23', NULL, NULL, 4341, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 10:23:23', 'admin-1478396082-14783990035785652', 1, 1, 'SR', NULL, NULL, NULL),
(12373, '2016-11-06 10:39:16', NULL, NULL, 4342, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 10:39:16', 'admin-1478396082-14783999558714336', 1, 0, '', NULL, NULL, NULL),
(12374, '2016-11-06 11:46:34', NULL, NULL, 4342, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:46:34', 'admin-1478402088-14784039943639884', 1, 1, 'SR', NULL, NULL, NULL),
(12375, '2016-11-06 11:14:29', NULL, NULL, 4343, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:14:29', 'admin-1478396082-14784020690506132', 1, 0, '', NULL, NULL, NULL),
(12376, '2016-11-06 11:14:29', NULL, NULL, 4343, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:14:29', 'admin-1478396082-14784020690506132', 1, 0, '', NULL, NULL, NULL),
(12377, '2016-11-06 11:15:35', NULL, NULL, 4343, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 11:15:35', 'admin-1478402088-14784021354838172', 1, 0, '', NULL, NULL, NULL),
(12378, '2016-11-06 10:23:23', NULL, NULL, 4341, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 10:23:23', 'admin-1478396082-14783990035785652', 1, 1, 'SR', NULL, NULL, NULL),
(12379, '2016-11-06 10:23:23', NULL, NULL, 4341, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 10:23:23', 'admin-1478396082-14783990035785652', 1, 0, '', NULL, NULL, NULL),
(12380, '2016-11-06 10:19:52', NULL, NULL, 4341, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 10:19:52', 'admin-1478396082-14783987918258352', 1, 0, '', NULL, NULL, NULL),
(12381, '2016-11-06 10:19:52', NULL, NULL, 4341, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 10:19:52', 'admin-1478396082-14783987918258352', 1, 0, '', NULL, NULL, NULL),
(12382, '2016-11-06 10:19:51', NULL, NULL, 4341, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 10:19:51', 'admin-1478396082-14783987918258352', 1, 0, '', NULL, NULL, NULL),
(12383, '2016-11-06 10:19:08', NULL, NULL, 4340, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 10:19:08', 'admin-1478396082-14783987487661315', 1, 1, 'SR', NULL, NULL, NULL),
(12384, '2016-11-06 10:19:08', NULL, NULL, 4340, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 10:19:08', 'admin-1478396082-14783987487661315', 1, 1, 'SR', NULL, NULL, NULL),
(12385, '2016-11-06 10:18:58', NULL, NULL, 4340, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 10:18:58', 'admin-1478396082-1478398738168868', 1, 0, '', NULL, NULL, NULL),
(12386, '2016-11-06 10:18:58', NULL, NULL, 4340, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 10:18:58', 'admin-1478396082-1478398738168868', 1, 0, '', NULL, NULL, NULL),
(12387, '2016-11-06 10:18:58', NULL, NULL, 4340, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 10:18:58', 'admin-1478396082-1478398738168868', 1, 0, '', NULL, NULL, NULL),
(12388, '2016-11-06 09:45:51', NULL, NULL, 4339, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 09:45:51', 'admin-1478396082-1478396751025256', 1, 1, 'SR', NULL, NULL, NULL),
(12389, '2016-11-06 09:45:51', NULL, NULL, 4339, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 09:45:51', 'admin-1478396082-1478396751025256', 1, 1, 'SR', NULL, NULL, NULL),
(12390, '2016-11-06 09:54:10', NULL, NULL, 4339, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 09:54:10', 'admin-1478396082-1478397249836318', 1, 1, 'SR', NULL, NULL, NULL),
(12391, '2016-11-06 09:56:54', NULL, NULL, 4339, 0, 181, '116', 'Open Food ', '1 Toast', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 09:56:54', 'admin-1478396082-14783974146822376', 1, 0, '', NULL, NULL, NULL),
(12392, '2016-11-06 09:45:51', NULL, NULL, 4339, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478427999', 'admin', '2016-11-06 09:45:51', 'admin-1478396082-1478396751025256', 1, 0, '', NULL, NULL, NULL),
(12393, '2016-11-07 19:19:09', NULL, NULL, 4384, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 19:19:09', 'admin-1478491786-14785175489788677', 1, 0, '', NULL, NULL, NULL),
(12394, '2016-11-07 19:19:18', NULL, NULL, 4384, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 19:19:18', 'admin-1478491786-14785175580323439', 1, 1, 'SR', NULL, NULL, NULL),
(12395, '2016-11-07 19:20:44', NULL, NULL, 4384, 0, 181, '116', 'Open Food ', 'baked beans', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 19:20:44', 'admin-1478491786-14785176441259792', 1, 0, '', NULL, NULL, NULL),
(12396, '2016-11-07 19:20:44', NULL, NULL, 4384, 0, 181, '116', 'Open Food ', 'baked beans', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 19:20:44', 'admin-1478491786-14785176441259792', 1, 0, '', NULL, NULL, NULL),
(12397, '2016-11-07 19:22:13', NULL, NULL, 4384, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 19:22:13', 'admin-1478491786-14785177330115817', 1, 1, 'SR', NULL, NULL, NULL),
(12398, '2016-11-07 19:32:13', NULL, NULL, 4385, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 19:32:13', 'admin-1478491786-14785183331715065', 1, 1, 'SR', NULL, NULL, NULL),
(12399, '2016-11-07 19:55:24', NULL, NULL, 4384, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 19:55:24', 'admin-1478491786-14785197240142114', 1, 1, 'SR', NULL, NULL, NULL),
(12400, '2016-11-07 19:55:24', NULL, NULL, 4384, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 19:55:24', 'admin-1478491786-14785197240142114', 1, 0, '', NULL, NULL, NULL),
(12401, '2016-11-07 19:55:24', NULL, NULL, 4384, 0, 181, '116', 'Open Food ', 'ice cream', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 19:55:24', 'admin-1478491786-14785197240142114', 1, 0, '', NULL, NULL, NULL),
(12402, '2016-11-07 20:53:07', NULL, NULL, 4386, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 20:53:07', 'admin-1478520563-14785231878182413', 1, 1, 'SR', NULL, NULL, NULL),
(12403, '2016-11-07 20:53:08', NULL, NULL, 4386, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 20:53:08', 'admin-1478520563-14785231878182413', 1, 1, 'SR', NULL, NULL, NULL),
(12404, '2016-11-07 20:53:08', NULL, NULL, 4386, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 20:53:08', 'admin-1478520563-14785231878182413', 1, 1, 'SR', NULL, NULL, NULL),
(12405, '2016-11-07 18:14:48', NULL, NULL, 4383, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 18:14:48', 'admin-1478491786-14785136882039839', 1, 1, 'SR', NULL, NULL, NULL),
(12406, '2016-11-07 18:14:48', NULL, NULL, 4383, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 18:14:48', 'admin-1478491786-14785136882039839', 1, 1, 'SR', NULL, NULL, NULL),
(12407, '2016-11-07 19:14:15', NULL, NULL, 4384, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 19:14:15', 'admin-1478491786-14785172550724413', 1, 0, '', NULL, NULL, NULL),
(12408, '2016-11-07 19:14:15', NULL, NULL, 4384, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 19:14:15', 'admin-1478491786-14785172550724413', 1, 0, '', NULL, NULL, NULL),
(12409, '2016-11-07 19:14:15', NULL, NULL, 4384, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 19:14:15', 'admin-1478491786-14785172550724413', 1, 0, '', NULL, NULL, NULL),
(12410, '2016-11-07 19:15:28', NULL, NULL, 4384, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 19:15:28', 'admin-1478491786-14785173284938830', 1, 1, 'SR', NULL, NULL, NULL),
(12411, '2016-11-07 19:15:28', NULL, NULL, 4384, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 19:15:28', 'admin-1478491786-14785173284938830', 1, 1, 'SR', NULL, NULL, NULL),
(12412, '2016-11-07 19:19:09', NULL, NULL, 4384, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 19:19:09', 'admin-1478491786-14785175489788677', 1, 1, 'SR', NULL, NULL, NULL),
(12413, '2016-11-07 19:19:09', NULL, NULL, 4384, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 19:19:09', 'admin-1478491786-14785175489788677', 1, 1, 'SR', NULL, NULL, NULL),
(12414, '2016-11-07 19:19:09', NULL, NULL, 4384, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 19:19:09', 'admin-1478491786-14785175489788677', 1, 0, '', NULL, NULL, NULL),
(12415, '2016-11-07 18:14:38', NULL, NULL, 4383, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 18:14:38', 'admin-1478491786-1478513678621278', 1, 0, '', NULL, NULL, NULL),
(12416, '2016-11-07 18:14:38', NULL, NULL, 4383, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 18:14:38', 'admin-1478491786-1478513678621278', 1, 0, '', NULL, NULL, NULL),
(12417, '2016-11-07 16:31:06', NULL, NULL, 4381, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 16:31:06', 'admin-1478491786-14785074664323442', 1, 1, 'SR', NULL, NULL, NULL),
(12418, '2016-11-07 17:10:05', NULL, NULL, 4382, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 17:10:05', 'admin-1478491786-14785098051318759', 1, 1, 'SR', NULL, NULL, NULL),
(12419, '2016-11-07 18:14:38', NULL, NULL, 4383, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 18:14:38', 'admin-1478491786-1478513678621278', 1, 1, 'SR', NULL, NULL, NULL),
(12420, '2016-11-07 16:13:45', NULL, NULL, 4380, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 16:13:45', 'admin-1478491786-14785064255192228', 1, 0, '', NULL, NULL, NULL),
(12421, '2016-11-07 12:21:24', NULL, NULL, 4373, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 12:21:24', 'admin-1478491786-14784924847709083', 1, 1, 'SR', NULL, NULL, NULL),
(12422, '2016-11-07 12:40:36', NULL, NULL, 4374, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 12:40:36', 'admin-1478491786-14784936364424069', 1, 0, '', NULL, NULL, NULL),
(12423, '2016-11-07 12:40:36', NULL, NULL, 4374, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 12:40:36', 'admin-1478491786-14784936364424069', 1, 0, '', NULL, NULL, NULL),
(12424, '2016-11-07 12:41:13', NULL, NULL, 4374, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 12:41:13', 'admin-1478491786-14784936732637317', 1, 1, 'SR', NULL, NULL, NULL),
(12425, '2016-11-07 12:41:13', NULL, NULL, 4374, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 12:41:13', 'admin-1478491786-14784936732637317', 1, 0, '', NULL, NULL, NULL),
(12426, '2016-11-07 12:55:40', NULL, NULL, 4375, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 12:55:40', 'admin-1478491786-14784945405866656', 1, 1, 'SR', NULL, NULL, NULL),
(12427, '2016-11-07 12:55:40', NULL, NULL, 4375, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 12:55:40', 'admin-1478491786-14784945405866656', 1, 1, 'SR', NULL, NULL, NULL),
(12428, '2016-11-07 12:58:16', NULL, NULL, 4375, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 12:58:16', 'admin-1478491786-14784946959559897', 1, 0, '', NULL, NULL, NULL),
(12429, '2016-11-07 12:58:16', NULL, NULL, 4375, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 12:58:16', 'admin-1478491786-14784946959559897', 1, 0, '', NULL, NULL, NULL),
(12430, '2016-11-07 13:24:32', NULL, NULL, 4375, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 13:24:32', 'admin-1478491786-14784962721739687', 1, 0, '', NULL, NULL, NULL),
(12431, '2016-11-07 14:57:08', NULL, NULL, 4376, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 14:57:08', 'admin-1478491786-14785018280111383', 1, 1, 'SR', NULL, NULL, NULL),
(12432, '2016-11-07 14:57:08', NULL, NULL, 4376, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 14:57:08', 'admin-1478491786-14785018280111383', 1, 1, 'SR', NULL, NULL, NULL),
(12433, '2016-11-07 15:20:53', NULL, NULL, 4377, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 15:20:53', 'admin-1478491786-14785032532636320', 1, 1, 'SR', NULL, NULL, NULL),
(12434, '2016-11-07 15:33:53', NULL, NULL, 4378, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 15:33:53', 'admin-1478491786-14785040329265430', 1, 1, 'SR', 1, NULL, NULL),
(12435, '2016-11-07 16:09:32', NULL, NULL, 4379, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 16:09:32', 'admin-1478491786-1478506172360264', 1, 1, 'SR', NULL, NULL, NULL),
(12436, '2016-11-07 16:04:06', NULL, NULL, 4379, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 16:04:06', 'admin-1478491786-14785058458433264', 1, 1, 'SR', NULL, NULL, NULL),
(12437, '2016-11-07 16:13:45', NULL, NULL, 4380, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 16:13:45', 'admin-1478491786-14785064255192228', 1, 1, 'SR', NULL, NULL, NULL),
(12438, '2016-11-07 12:09:59', NULL, NULL, 4372, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 12:09:59', 'admin-1478491786-1478491798764486', 1, 1, 'SR', NULL, NULL, NULL),
(12439, '2016-11-07 12:09:59', NULL, NULL, 4372, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 12:09:59', 'admin-1478491786-1478491798764486', 1, 1, 'SR', NULL, NULL, NULL),
(12440, '2016-11-07 12:21:20', NULL, NULL, 4373, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 12:21:20', 'admin-1478491786-14784924804693241', 1, 1, 'SR', NULL, NULL, NULL),
(12441, '2016-11-07 12:21:20', NULL, NULL, 4373, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 12:21:20', 'admin-1478491786-14784924804693241', 1, 1, 'SR', NULL, NULL, NULL),
(12442, '2016-11-07 12:21:24', NULL, NULL, 4373, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 12:21:24', 'admin-1478491786-14784924847709083', 1, 1, 'SR', NULL, NULL, NULL),
(12443, '2016-11-07 11:54:50', NULL, NULL, 4371, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 11:54:50', 'admin-1478480336-14784908901901197', 1, 0, '', NULL, NULL, NULL),
(12444, '2016-11-07 11:54:58', NULL, NULL, 4371, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 11:54:58', 'admin-1478480336-14784908986162832', 1, 1, 'SR', NULL, NULL, NULL),
(12445, '2016-11-07 12:09:28', NULL, NULL, 4372, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 12:09:28', 'admin-1478480336-14784917679372737', 1, 0, '', NULL, NULL, NULL),
(12446, '2016-11-07 12:09:28', NULL, NULL, 4372, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 12:09:28', 'admin-1478480336-14784917679372737', 1, 0, '', NULL, NULL, NULL),
(12447, '2016-11-07 10:55:29', NULL, NULL, 4368, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 10:55:29', 'admin-1478480336-14784873289001635', 1, 1, 'SR', NULL, NULL, NULL),
(12448, '2016-11-07 10:55:29', NULL, NULL, 4368, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 10:55:29', 'admin-1478480336-14784873289001635', 1, 0, '', NULL, NULL, NULL),
(12449, '2016-11-07 10:55:29', NULL, NULL, 4368, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 10:55:29', 'admin-1478480336-14784873289001635', 1, 0, '', NULL, NULL, NULL),
(12450, '2016-11-07 11:06:12', NULL, NULL, 4369, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 11:06:12', 'admin-1478480336-14784879723675168', 1, 0, '', NULL, NULL, NULL),
(12451, '2016-11-07 11:06:16', NULL, NULL, 4369, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 11:06:16', 'admin-1478480336-14784879763697974', 1, 1, 'SR', NULL, NULL, NULL),
(12452, '2016-11-07 11:16:53', NULL, NULL, 4370, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 11:16:53', 'admin-1478480336-14784886133354046', 1, 0, '', NULL, NULL, NULL),
(12453, '2016-11-07 11:54:50', NULL, NULL, 4371, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 11:54:50', 'admin-1478480336-14784908901901197', 1, 0, '', NULL, NULL, NULL),
(12454, '2016-11-07 11:54:50', NULL, NULL, 4371, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 11:54:50', 'admin-1478480336-14784908901901197', 1, 0, '', NULL, NULL, NULL),
(12455, '2016-11-07 11:06:12', NULL, NULL, 4369, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 11:06:12', 'admin-1478480336-14784879723675168', 1, 0, '', NULL, NULL, NULL),
(12456, '2016-11-07 10:55:29', NULL, NULL, 4368, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 10:55:29', 'admin-1478480336-14784873289001635', 1, 1, 'SR', NULL, NULL, NULL),
(12457, '2016-11-07 10:52:00', NULL, NULL, 4367, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 10:52:00', 'admin-1478480336-14784871201335742', 1, 0, '', NULL, NULL, NULL),
(12458, '2016-11-07 09:58:23', NULL, NULL, 4367, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 09:58:23', 'admin-1478480336-14784839031974441', 1, 1, 'SR', NULL, NULL, NULL),
(12459, '2016-11-07 09:52:46', NULL, NULL, 4366, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 09:52:46', 'admin-1478480336-14784835667066650', 1, 1, 'SR', 1, NULL, NULL),
(12460, '2016-11-07 09:43:56', NULL, NULL, 4365, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 09:43:56', 'admin-1478480336-14784830358162136', 1, 0, '', NULL, NULL, NULL),
(12461, '2016-11-07 09:43:56', NULL, NULL, 4365, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 09:43:56', 'admin-1478480336-14784830358162136', 1, 0, '', NULL, NULL, NULL),
(12462, '2016-11-07 09:21:48', NULL, NULL, 4365, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 09:21:48', 'admin-1478480336-1478481708460367', 1, 1, 'SR', NULL, NULL, NULL),
(12463, '2016-11-07 09:21:48', NULL, NULL, 4365, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478520563', 'admin', '2016-11-07 09:21:48', 'admin-1478480336-1478481708460367', 1, 1, 'SR', NULL, NULL, NULL),
(12464, '2016-11-09 18:23:09', NULL, NULL, 4406, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 18:23:09', 'admin-1478667259-14786869897702379', 1, 1, 'SR', NULL, NULL, NULL),
(12465, '2016-11-09 18:23:09', NULL, NULL, 4406, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 18:23:09', 'admin-1478667259-14786869897702379', 1, 1, 'SR', NULL, NULL, NULL),
(12466, '2016-11-09 18:41:43', NULL, NULL, 4407, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 18:41:43', 'admin-1478667259-14786881034704976', 1, 1, 'SR', NULL, NULL, NULL),
(12467, '2016-11-09 18:41:43', NULL, NULL, 4407, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 18:41:43', 'admin-1478667259-14786881034704976', 1, 1, 'SR', NULL, NULL, NULL),
(12468, '2016-11-09 18:53:20', NULL, NULL, 4408, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 18:53:20', 'admin-1478667259-14786888000981667', 1, 1, 'SR', NULL, NULL, NULL),
(12469, '2016-11-09 18:53:20', NULL, NULL, 4408, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 18:53:20', 'admin-1478667259-14786888000981667', 1, 0, '', NULL, NULL, NULL),
(12470, '2016-11-09 18:53:20', NULL, NULL, 4408, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 18:53:20', 'admin-1478667259-14786888000981667', 1, 0, '', NULL, NULL, NULL),
(12471, '2016-11-09 18:53:20', NULL, NULL, 4408, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 18:53:20', 'admin-1478667259-14786888000981667', 1, 1, 'SR', NULL, NULL, NULL),
(12472, '2016-11-09 18:53:20', NULL, NULL, 4408, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 18:53:20', 'admin-1478667259-14786888000981667', 1, 1, 'SR', NULL, NULL, NULL),
(12473, '2016-11-09 20:03:44', NULL, NULL, 4409, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 20:03:44', 'admin-1478667259-14786930241646910', 1, 1, 'SR', NULL, NULL, NULL),
(12474, '2016-11-09 20:03:44', NULL, NULL, 4409, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 20:03:44', 'admin-1478667259-14786930241646910', 1, 1, 'SR', NULL, NULL, NULL),
(12475, '2016-11-09 20:03:44', NULL, NULL, 4409, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 20:03:44', 'admin-1478667259-14786930241646910', 1, 0, '', NULL, NULL, NULL),
(12476, '2016-11-09 20:03:44', NULL, NULL, 4409, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 20:03:44', 'admin-1478667259-14786930241646910', 1, 1, 'SR', NULL, NULL, NULL),
(12477, '2016-11-09 20:28:49', NULL, NULL, 4410, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 20:28:49', 'admin-1478667259-14786945291144070', 1, 0, '', NULL, NULL, NULL),
(12478, '2016-11-09 20:30:56', NULL, NULL, 4411, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 20:30:56', 'admin-1478667259-14786946566151732', 1, 1, 'SR', NULL, NULL, NULL),
(12479, '2016-11-09 20:30:56', NULL, NULL, 4411, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 20:30:56', 'admin-1478667259-14786946566151732', 1, 1, 'SR', NULL, NULL, NULL),
(12480, '2016-11-09 20:30:12', NULL, NULL, 4410, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 20:30:12', 'admin-1478667259-14786946121703481', 1, 1, 'SR', NULL, NULL, NULL),
(12481, '2016-11-09 20:29:24', NULL, NULL, 4410, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 20:29:24', 'admin-1478667259-14786945643193969', 1, 1, 'SR', NULL, NULL, NULL),
(12482, '2016-11-09 18:22:51', NULL, NULL, 4405, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 18:22:51', 'admin-1478667259-14786869710161556', 1, 1, 'SR', NULL, NULL, NULL),
(12483, '2016-11-09 18:22:51', NULL, NULL, 4405, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 18:22:51', 'admin-1478667259-14786869710161556', 1, 1, 'SR', NULL, NULL, NULL),
(12484, '2016-11-09 18:22:51', NULL, NULL, 4405, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 18:22:51', 'admin-1478667259-14786869710161556', 1, 0, '', NULL, NULL, NULL),
(12485, '2016-11-09 18:22:51', NULL, NULL, 4405, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 18:22:51', 'admin-1478667259-14786869710161556', 1, 0, '', NULL, NULL, NULL),
(12486, '2016-11-09 16:35:01', NULL, NULL, 4404, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 16:35:01', 'admin-1478667259-14786805014328989', 1, 1, 'SR', NULL, NULL, NULL),
(12487, '2016-11-09 18:22:51', NULL, NULL, 4405, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 18:22:51', 'admin-1478667259-14786869710161556', 1, 1, 'SR', NULL, NULL, NULL),
(12488, '2016-11-09 15:49:38', NULL, NULL, 4403, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 15:49:38', 'admin-1478667259-1478677777942679', 1, 1, 'SR', 1, NULL, NULL),
(12489, '2016-11-09 12:55:37', NULL, NULL, 4397, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 12:55:37', 'admin-1478667259-1478667337667783', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(12490, '2016-11-09 12:55:37', NULL, NULL, 4397, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 12:55:37', 'admin-1478667259-1478667337667783', 1, 1, 'SR', NULL, NULL, NULL),
(12491, '2016-11-09 13:18:18', NULL, NULL, 4398, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 13:18:18', 'admin-1478667259-1478668698596616', 1, 0, '', NULL, NULL, NULL),
(12492, '2016-11-09 13:18:18', NULL, NULL, 4398, 0, 82, '82', 'Set Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 13:18:18', 'admin-1478667259-1478668698596616', 1, 1, 'SR', NULL, NULL, NULL),
(12493, '2016-11-09 13:25:12', NULL, NULL, 4399, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 13:25:12', 'admin-1478667259-14786691119748553', 1, 0, '', NULL, NULL, NULL),
(12494, '2016-11-09 13:25:12', NULL, NULL, 4399, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 13:25:12', 'admin-1478667259-14786691119748553', 1, 0, '', NULL, NULL, NULL),
(12495, '2016-11-09 13:25:12', NULL, NULL, 4399, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 13:25:12', 'admin-1478667259-14786691119748553', 1, 1, 'SR', NULL, NULL, NULL),
(12496, '2016-11-09 13:25:12', NULL, NULL, 4399, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 13:25:12', 'admin-1478667259-14786691119748553', 1, 1, 'SR', NULL, NULL, NULL),
(12497, '2016-11-09 14:02:32', NULL, NULL, 4400, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 14:02:32', 'admin-1478667259-14786713522865617', 1, 0, '', NULL, NULL, NULL),
(12498, '2016-11-09 14:02:32', NULL, NULL, 4400, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 14:02:32', 'admin-1478667259-14786713522865617', 1, 0, '', NULL, NULL, NULL),
(12499, '2016-11-09 14:02:32', NULL, NULL, 4400, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 14:02:32', 'admin-1478667259-14786713522865617', 1, 1, 'SR', NULL, NULL, NULL),
(12500, '2016-11-09 14:02:32', NULL, NULL, 4400, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 14:02:32', 'admin-1478667259-14786713522865617', 1, 0, '', NULL, NULL, NULL),
(12501, '2016-11-09 14:27:23', NULL, NULL, 4401, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 14:27:23', 'admin-1478667259-14786728433503719', 1, 1, 'SR', NULL, NULL, NULL),
(12502, '2016-11-09 14:27:23', NULL, NULL, 4401, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 14:27:23', 'admin-1478667259-14786728433503719', 1, 1, 'SR', NULL, NULL, NULL),
(12503, '2016-11-09 14:27:23', NULL, NULL, 4401, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 14:27:23', 'admin-1478667259-14786728433503719', 1, 0, '', NULL, NULL, NULL),
(12504, '2016-11-09 14:27:58', NULL, NULL, 4401, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 14:27:58', 'admin-1478667259-14786728779686777', 1, 0, '', NULL, NULL, NULL),
(12505, '2016-11-09 14:32:26', NULL, NULL, 4402, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 14:32:26', 'admin-1478667259-14786731464701049', 1, 0, '', NULL, NULL, NULL),
(12506, '2016-11-09 12:20:37', NULL, NULL, 4394, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 12:20:37', 'admin-1478660244-14786652376155171', 1, 0, '', NULL, NULL, NULL),
(12507, '2016-11-09 12:25:05', NULL, NULL, 4395, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 12:25:05', 'admin-1478660244-14786655049837777', 1, 1, 'SR', NULL, NULL, NULL),
(12508, '2016-11-09 12:25:05', NULL, NULL, 4395, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 12:25:05', 'admin-1478660244-14786655049837777', 1, 0, '', NULL, NULL, NULL),
(12509, '2016-11-09 12:54:32', NULL, NULL, 4396, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 12:54:32', 'admin-1478667259-14786672718681746', 1, 0, '', NULL, NULL, NULL),
(12510, '2016-11-09 12:54:32', NULL, NULL, 4396, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 12:54:32', 'admin-1478667259-14786672718681746', 1, 1, 'SR', NULL, NULL, NULL),
(12511, '2016-11-09 11:28:58', NULL, NULL, 4392, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 11:28:58', 'admin-1478660244-14786621383673371', 1, 0, '', NULL, NULL, NULL),
(12512, '2016-11-09 11:29:15', NULL, NULL, 4392, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 11:29:15', 'admin-1478660244-14786621552302034', 1, 1, 'SR', NULL, NULL, NULL),
(12513, '2016-11-09 11:45:14', NULL, NULL, 4393, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 11:45:14', 'admin-1478660244-14786631147054060', 1, 0, '', NULL, NULL, NULL),
(12514, '2016-11-09 11:45:14', NULL, NULL, 4393, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 11:45:14', 'admin-1478660244-14786631147054060', 1, 0, '', NULL, NULL, NULL),
(12515, '2016-11-09 11:45:25', NULL, NULL, 4393, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 11:45:25', 'admin-1478660244-1478663124908426', 1, 0, '', NULL, NULL, NULL),
(12516, '2016-11-09 11:45:25', NULL, NULL, 4393, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 11:45:25', 'admin-1478660244-1478663124908426', 1, 1, 'SR', NULL, NULL, NULL),
(12517, '2016-11-09 11:45:25', NULL, NULL, 4393, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 11:45:25', 'admin-1478660244-1478663124908426', 1, 1, 'SR', NULL, NULL, NULL),
(12518, '2016-11-09 10:57:00', NULL, NULL, 4390, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 10:57:00', 'admin-1478653797-14786602207492317', 1, 0, '', NULL, NULL, NULL),
(12519, '2016-11-09 10:57:13', NULL, NULL, 4390, 0, 181, '116', 'Open Food ', 'take away', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 10:57:13', 'admin-1478653797-1478660232914411', 1, 0, '', NULL, NULL, NULL),
(12520, '2016-11-09 10:57:32', NULL, NULL, 4390, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 10:57:32', 'admin-1478660244-1478660252114321', 1, 1, 'SR', NULL, NULL, NULL),
(12521, '2016-11-09 09:24:35', NULL, NULL, 4388, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 09:24:35', 'admin-1478653797-14786546749584732', 1, 1, 'SR', NULL, NULL, NULL),
(12522, '2016-11-09 09:17:29', NULL, NULL, 4387, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 09:17:29', 'admin-1478653797-1478654249157998', 1, 1, 'SR', NULL, NULL, NULL),
(12523, '2016-11-09 09:24:29', NULL, NULL, 4388, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 09:24:29', 'admin-1478653797-14786546695152750', 1, 0, '', NULL, NULL, NULL),
(12524, '2016-11-09 12:20:37', NULL, NULL, 4394, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 12:20:37', 'admin-1478660244-14786652376155171', 1, 1, 'SR', NULL, NULL, NULL),
(12525, '2016-11-09 10:23:43', NULL, NULL, 4389, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 10:23:43', 'admin-1478653797-14786582231049133', 1, 0, '', NULL, NULL, NULL),
(12526, '2016-11-09 10:23:43', NULL, NULL, 4389, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 10:23:43', 'admin-1478653797-14786582231049133', 1, 1, 'SR', NULL, NULL, NULL),
(12527, '2016-11-09 10:19:24', NULL, NULL, 4387, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 10:19:24', 'admin-1478653797-1478657964267273', 1, 1, 'SR', NULL, NULL, NULL),
(12528, '2016-11-09 09:47:21', NULL, NULL, 4387, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 09:47:21', 'admin-1478653797-14786560416456161', 1, 0, '', NULL, NULL, NULL),
(12529, '2016-11-09 09:24:29', NULL, NULL, 4388, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 09:24:29', 'admin-1478653797-14786546695152750', 1, 0, '', NULL, NULL, NULL),
(12530, '2016-11-09 09:17:29', NULL, NULL, 4387, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 09:17:29', 'admin-1478653797-1478654249157998', 1, 1, 'SR', NULL, NULL, NULL),
(12531, '2016-11-09 09:17:25', NULL, NULL, 4387, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478667259', 'admin', '2016-11-09 09:17:25', 'admin-1478653797-14786542452504796', 1, 0, '', NULL, NULL, NULL),
(12532, '2016-11-10 19:45:07', NULL, NULL, 4428, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 19:45:07', 'admin-1478772270-14787783069735541', 1, 1, 'SR', NULL, NULL, NULL),
(12533, '2016-11-10 19:45:07', NULL, NULL, 4428, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 19:45:07', 'admin-1478772270-14787783069735541', 1, 1, 'SR', NULL, NULL, NULL),
(12534, '2016-11-10 19:49:52', NULL, NULL, 4429, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 19:49:52', 'admin-1478772270-14787785924446918', 1, 0, '', NULL, NULL, NULL),
(12535, '2016-11-10 19:52:13', NULL, NULL, 4429, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 19:52:13', 'admin-1478772270-14787787335517612', 1, 0, '', NULL, NULL, NULL),
(12536, '2016-11-10 19:52:13', NULL, NULL, 4429, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 19:52:13', 'admin-1478772270-14787787335517612', 1, 0, '', NULL, NULL, NULL),
(12537, '2016-11-10 20:16:46', NULL, NULL, 4429, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 20:16:46', 'admin-1478772270-14787802067608070', 1, 1, 'SR', NULL, NULL, NULL),
(12538, '2016-11-10 20:17:35', NULL, NULL, 4430, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 20:17:35', 'admin-1478772270-14787802553818787', 1, 0, '', NULL, NULL, NULL),
(12539, '2016-11-10 20:17:35', NULL, NULL, 4430, 0, 222, '156', 'Seasoned Chicken Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 20:17:35', 'admin-1478772270-14787802553818787', 1, 0, '', NULL, NULL, NULL),
(12540, '2016-11-10 20:17:35', NULL, NULL, 4430, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 20:17:35', 'admin-1478772270-14787802553818787', 1, 1, 'SR', NULL, NULL, NULL),
(12541, '2016-11-10 20:34:19', NULL, NULL, 4430, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 20:34:19', 'admin-1478772270-14787812595619856', 1, 0, '', NULL, NULL, NULL),
(12542, '2016-11-10 20:34:19', NULL, NULL, 4430, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 20:34:19', 'admin-1478772270-14787812595619856', 1, 1, 'SR', NULL, NULL, NULL),
(12543, '2016-11-10 20:54:13', NULL, NULL, 4431, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 20:54:13', 'admin-1478772270-1478782453732888', 1, 1, 'SR', NULL, NULL, NULL),
(12544, '2016-11-10 19:09:40', NULL, NULL, 4428, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 19:09:40', 'admin-1478772270-1478776180419487', 1, 1, 'SR', NULL, NULL, NULL),
(12545, '2016-11-10 19:09:40', NULL, NULL, 4428, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 19:09:40', 'admin-1478772270-1478776180419487', 1, 1, 'SR', NULL, NULL, NULL),
(12546, '2016-11-10 18:30:37', NULL, NULL, 4428, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 18:30:37', 'admin-1478772270-14787738375648186', 1, 1, 'SR', NULL, NULL, NULL),
(12547, '2016-11-10 18:30:37', NULL, NULL, 4428, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 18:30:37', 'admin-1478772270-14787738375648186', 1, 1, 'SR', NULL, NULL, NULL),
(12548, '2016-11-10 18:10:16', NULL, NULL, 4427, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 18:10:16', 'admin-1478772270-1478772616409393', 1, 1, 'SR', 1, NULL, NULL),
(12549, '2016-11-10 16:45:47', NULL, NULL, 4426, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 16:45:47', 'admin-1478739804-14787675468748063', 1, 1, 'SR', NULL, NULL, NULL),
(12550, '2016-11-10 17:08:33', NULL, NULL, 4426, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 17:08:33', 'admin-1478739804-14787689133096459', 1, 0, '', NULL, NULL, NULL),
(12551, '2016-11-10 13:41:42', NULL, NULL, 4419, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 13:41:42', 'admin-1478739804-14787565026902437', 1, 1, 'SR', NULL, NULL, NULL),
(12552, '2016-11-10 14:11:07', NULL, NULL, 4420, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 14:11:07', 'admin-1478739804-14787582677793497', 1, 1, 'SR', NULL, NULL, NULL),
(12553, '2016-11-10 14:11:07', NULL, NULL, 4420, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 14:11:07', 'admin-1478739804-14787582677793497', 1, 1, 'SR', NULL, NULL, NULL),
(12554, '2016-11-10 14:37:48', NULL, NULL, 4421, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 14:37:48', 'admin-1478739804-14787598685953764', 1, 1, 'SR', NULL, NULL, NULL),
(12555, '2016-11-10 14:37:48', NULL, NULL, 4421, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 14:37:48', 'admin-1478739804-14787598685953764', 1, 1, 'SR', NULL, NULL, NULL),
(12556, '2016-11-10 15:07:56', NULL, NULL, 4422, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 15:07:56', 'admin-1478739804-14787616766736766', 1, 1, 'SR', NULL, NULL, NULL),
(12557, '2016-11-10 15:07:56', NULL, NULL, 4422, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 15:07:56', 'admin-1478739804-14787616766736766', 1, 1, 'SR', NULL, NULL, NULL),
(12558, '2016-11-10 15:08:16', NULL, NULL, 4422, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 15:08:16', 'admin-1478739804-1478761696378296', 1, 0, '', NULL, NULL, NULL),
(12559, '2016-11-10 15:29:46', NULL, NULL, 4423, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 15:29:46', 'admin-1478739804-14787629858762875', 1, 0, '', NULL, NULL, NULL),
(12560, '2016-11-10 15:29:46', NULL, NULL, 4423, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 15:29:46', 'admin-1478739804-14787629858762875', 1, 1, 'SR', NULL, NULL, NULL),
(12561, '2016-11-10 15:55:16', NULL, NULL, 4425, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 15:55:16', 'admin-1478739804-14787645159532499', 1, 1, 'SR', NULL, NULL, NULL),
(12562, '2016-11-10 15:32:09', NULL, NULL, 4423, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 15:32:09', 'admin-1478739804-1478763129238668', 1, 1, 'SR', NULL, NULL, NULL),
(12563, '2016-11-10 15:51:23', NULL, NULL, 4425, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 15:51:23', 'admin-1478739804-14787642828761221', 1, 1, 'SR', NULL, NULL, NULL),
(12564, '2016-11-10 16:06:12', NULL, NULL, 4425, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 16:06:12', 'admin-1478739804-14787651727068915', 1, 1, 'SR', NULL, NULL, NULL),
(12565, '2016-11-10 15:55:16', NULL, NULL, 4425, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 15:55:16', 'admin-1478739804-14787645159532499', 1, 1, 'SR', NULL, NULL, NULL),
(12566, '2016-11-10 16:11:24', NULL, NULL, 4425, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 16:11:24', 'admin-1478739804-14787654843124487', 1, 1, 'SR', NULL, NULL, NULL),
(12567, '2016-11-10 16:41:10', NULL, NULL, 4426, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 16:41:10', 'admin-1478739804-14787672701776450', 1, 1, 'SR', NULL, NULL, NULL),
(12568, '2016-11-10 12:49:15', NULL, NULL, 4416, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 12:49:15', 'admin-1478739804-14787533550552158', 1, 0, '', NULL, NULL, NULL),
(12569, '2016-11-10 12:30:33', NULL, NULL, 4414, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 12:30:33', 'admin-1478739804-1478752233325432', 1, 1, 'SR', NULL, NULL, NULL),
(12570, '2016-11-10 12:30:44', NULL, NULL, 4415, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 12:30:44', 'admin-1478739804-14787522442645552', 1, 0, '', NULL, NULL, NULL),
(12571, '2016-11-10 12:30:44', NULL, NULL, 4415, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 12:30:44', 'admin-1478739804-14787522442645552', 1, 1, 'SR', NULL, NULL, NULL),
(12572, '2016-11-10 12:30:44', NULL, NULL, 4415, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 12:30:44', 'admin-1478739804-14787522442645552', 1, 0, '', NULL, NULL, NULL),
(12573, '2016-11-10 12:30:53', NULL, NULL, 4414, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 12:30:53', 'admin-1478739804-14787522533653118', 1, 1, 'SR', NULL, NULL, NULL),
(12574, '2016-11-10 12:31:01', NULL, NULL, 4414, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 12:31:01', 'admin-1478739804-14787522610847169', 1, 0, '', NULL, NULL, NULL),
(12575, '2016-11-10 12:31:16', NULL, NULL, 4415, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 12:31:16', 'admin-1478739804-14787522760212396', 1, 1, 'SR', NULL, NULL, NULL),
(12576, '2016-11-10 12:31:16', NULL, NULL, 4415, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 12:31:16', 'admin-1478739804-14787522760212396', 1, 1, 'SR', NULL, NULL, NULL),
(12577, '2016-11-10 13:06:08', NULL, NULL, 4417, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 13:06:08', 'admin-1478739804-14787543686612549', 1, 0, '', NULL, NULL, NULL),
(12578, '2016-11-10 13:33:01', NULL, NULL, 4418, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 13:33:01', 'admin-1478739804-14787559810546033', 1, 1, 'SR', NULL, NULL, NULL),
(12579, '2016-11-10 13:33:01', NULL, NULL, 4418, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 13:33:01', 'admin-1478739804-14787559810546033', 1, 1, 'SR', NULL, NULL, NULL),
(12580, '2016-11-10 12:30:33', NULL, NULL, 4414, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 12:30:33', 'admin-1478739804-1478752233325432', 1, 1, 'SR', NULL, NULL, NULL),
(12581, '2016-11-10 12:30:33', NULL, NULL, 4414, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 12:30:33', 'admin-1478739804-1478752233325432', 1, 0, '', NULL, NULL, NULL),
(12582, '2016-11-10 12:30:33', NULL, NULL, 4414, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 12:30:33', 'admin-1478739804-1478752233325432', 1, 1, 'SR', NULL, NULL, NULL),
(12583, '2016-11-10 12:49:15', NULL, NULL, 4416, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 12:49:15', 'admin-1478739804-14787533550552158', 1, 1, 'SR', NULL, NULL, NULL),
(12584, '2016-11-10 13:06:08', NULL, NULL, 4417, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 13:06:08', 'admin-1478739804-14787543686612549', 1, 1, 'SR', NULL, NULL, NULL),
(12585, '2016-11-10 12:30:33', NULL, NULL, 4414, 0, 153, '87', 'Big Breakfast ', 'egg put another plate', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 12:30:33', 'admin-1478739804-1478752233325432', 1, 0, '', NULL, NULL, NULL),
(12586, '2016-11-10 12:18:19', NULL, NULL, 4413, 0, 157, '91', 'French Toast with Fruits', 'without banana', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 12:18:19', 'admin-1478739804-14787514995317852', 1, 0, '', NULL, NULL, NULL),
(12587, '2016-11-10 12:30:33', NULL, NULL, 4414, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 12:30:33', 'admin-1478739804-1478752233325432', 1, 0, '', NULL, NULL, NULL),
(12588, '2016-11-10 12:18:19', NULL, NULL, 4413, 0, 156, '90', 'Cheese Omelet', 'less cheese', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 12:18:19', 'admin-1478739804-14787514995317852', 1, 0, '', NULL, NULL, NULL),
(12589, '2016-11-10 12:18:30', NULL, NULL, 4413, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 12:18:30', 'admin-1478739804-14787515101414078', 1, 1, 'SR', NULL, NULL, NULL),
(12590, '2016-11-10 12:11:43', NULL, NULL, 4413, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 12:11:43', 'admin-1478739804-14787511033297076', 1, 1, 'SR', NULL, NULL, NULL),
(12591, '2016-11-10 12:11:43', NULL, NULL, 4413, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 12:11:43', 'admin-1478739804-14787511033297076', 1, 1, 'SR', NULL, NULL, NULL),
(12592, '2016-11-10 11:26:58', NULL, NULL, 4412, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478786083', 'admin', '2016-11-10 11:26:58', 'admin-1478739804-14787484182041895', 1, 1, 'SR', NULL, NULL, NULL),
(12593, '2016-11-11 20:23:57', NULL, NULL, 4448, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 20:23:57', 'admin-1478859943-1478867037404389', 1, 1, 'SR', NULL, NULL, NULL),
(12594, '2016-11-11 20:06:38', NULL, NULL, 4447, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 20:06:38', 'admin-1478859943-1478865998170444', 1, 1, 'SR', NULL, NULL, NULL),
(12595, '2016-11-11 20:23:57', NULL, NULL, 4448, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 20:23:57', 'admin-1478859943-1478867037404389', 1, 0, '', NULL, NULL, NULL),
(12596, '2016-11-11 19:47:08', NULL, NULL, 4447, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 19:47:08', 'admin-1478859943-14788648284071421', 1, 0, '', NULL, NULL, NULL),
(12597, '2016-11-11 19:47:08', NULL, NULL, 4447, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 19:47:08', 'admin-1478859943-14788648284071421', 1, 0, '', NULL, NULL, NULL),
(12598, '2016-11-11 19:47:08', NULL, NULL, 4447, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 19:47:08', 'admin-1478859943-14788648284071421', 1, 1, 'SR', NULL, NULL, NULL),
(12599, '2016-11-11 19:42:26', NULL, NULL, 4446, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 19:42:26', 'admin-1478859943-14788645465049640', 1, 1, 'SR', NULL, NULL, NULL),
(12600, '2016-11-11 19:42:26', NULL, NULL, 4446, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 19:42:26', 'admin-1478859943-14788645465049640', 1, 1, 'SR', NULL, NULL, NULL),
(12601, '2016-11-11 18:25:33', NULL, NULL, 4445, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 18:25:33', 'admin-1478839571-14788599333156929', 1, 0, '', NULL, NULL, NULL),
(12602, '2016-11-11 18:25:33', NULL, NULL, 4445, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 18:25:33', 'admin-1478839571-14788599333156929', 1, 0, '', NULL, NULL, NULL),
(12603, '2016-11-11 18:25:33', NULL, NULL, 4445, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 18:25:33', 'admin-1478839571-14788599333156929', 1, 0, '', NULL, NULL, NULL),
(12604, '2016-11-11 18:20:22', NULL, NULL, 4444, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 18:20:22', 'admin-1478839571-14788596225677162', 1, 0, '', NULL, NULL, NULL),
(12605, '2016-11-11 18:20:22', NULL, NULL, 4444, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 18:20:22', 'admin-1478839571-14788596225677162', 1, 1, 'SR', NULL, NULL, NULL),
(12606, '2016-11-11 17:16:08', NULL, NULL, 4443, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 17:16:08', 'admin-1478839571-1478855768788762', 1, 1, 'SR', NULL, NULL, NULL),
(12607, '2016-11-11 15:51:17', NULL, NULL, 4442, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 15:51:17', 'admin-1478839571-14788506770778730', 1, 1, 'SR', NULL, NULL, NULL),
(12608, '2016-11-11 15:51:17', NULL, NULL, 4442, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 15:51:17', 'admin-1478839571-14788506770778730', 1, 1, 'SR', NULL, NULL, NULL),
(12609, '2016-11-11 15:51:17', NULL, NULL, 4442, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 15:51:17', 'admin-1478839571-14788506770778730', 1, 1, 'SR', NULL, NULL, NULL),
(12610, '2016-11-11 15:08:42', NULL, NULL, 4441, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 15:08:42', 'admin-1478839571-14788481222187223', 1, 1, 'SR', 1, NULL, NULL),
(12611, '2016-11-11 14:53:31', NULL, NULL, 4440, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 14:53:31', 'admin-1478839571-1478847210949538', 1, 1, 'SR', NULL, NULL, NULL),
(12612, '2016-11-11 14:46:22', NULL, NULL, 4438, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 14:46:22', 'admin-1478839571-14788467821839559', 1, 1, 'SR', NULL, NULL, NULL),
(12613, '2016-11-11 14:22:03', NULL, NULL, 4440, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 14:22:03', 'admin-1478839571-14788453228729766', 1, 0, '', NULL, NULL, NULL),
(12614, '2016-11-11 14:21:58', NULL, NULL, 4440, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 14:21:58', 'admin-1478839571-14788453178422615', 1, 0, '', NULL, NULL, NULL),
(12615, '2016-11-11 13:51:41', NULL, NULL, 4438, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 13:51:41', 'admin-1478839571-14788435014022460', 1, 0, '', NULL, NULL, NULL),
(12616, '2016-11-11 13:46:30', NULL, NULL, 4439, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 13:46:30', 'admin-1478839571-14788431899959548', 1, 1, 'SR', NULL, NULL, NULL),
(12617, '2016-11-11 13:46:30', NULL, NULL, 4439, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 13:46:30', 'admin-1478839571-14788431899959548', 1, 1, 'SR', NULL, NULL, NULL),
(12618, '2016-11-11 13:46:30', NULL, NULL, 4439, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 13:46:30', 'admin-1478839571-14788431899959548', 1, 1, 'SR', NULL, NULL, NULL),
(12619, '2016-11-11 13:46:30', NULL, NULL, 4439, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 13:46:30', 'admin-1478839571-14788431899959548', 1, 0, '', NULL, NULL, NULL),
(12620, '2016-11-11 13:46:17', NULL, NULL, 4439, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 13:46:17', 'admin-1478839571-14788431768878261', 1, 0, '', NULL, NULL, NULL),
(12621, '2016-11-11 13:30:56', NULL, NULL, 4438, 0, 214, '148', 'Set Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 13:30:56', 'admin-1478839571-14788422558271975', 1, 0, '', NULL, NULL, NULL),
(12622, '2016-11-11 13:30:56', NULL, NULL, 4438, 0, 214, '148', 'Set Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 13:30:56', 'admin-1478839571-14788422558271975', 1, 0, '', NULL, NULL, NULL),
(12623, '2016-11-11 12:14:52', NULL, NULL, 4437, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 12:14:52', 'admin-1478825502-14788376927031079', 1, 1, 'SR', NULL, NULL, NULL),
(12624, '2016-11-11 10:00:37', NULL, NULL, 4432, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 10:00:37', 'admin-1478825502-14788296368111358', 1, 1, 'SR', NULL, NULL, NULL),
(12625, '2016-11-11 10:00:37', NULL, NULL, 4432, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 10:00:37', 'admin-1478825502-14788296368111358', 1, 1, 'SR', NULL, NULL, NULL),
(12626, '2016-11-11 10:44:21', NULL, NULL, 4433, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 10:44:21', 'admin-1478825502-1478832260876843', 1, 0, '', NULL, NULL, NULL),
(12627, '2016-11-11 10:44:21', NULL, NULL, 4433, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 10:44:21', 'admin-1478825502-1478832260876843', 1, 0, '', NULL, NULL, NULL),
(12628, '2016-11-11 10:44:21', NULL, NULL, 4433, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 10:44:21', 'admin-1478825502-1478832260876843', 1, 0, '', NULL, NULL, NULL),
(12629, '2016-11-11 10:44:21', NULL, NULL, 4433, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 10:44:21', 'admin-1478825502-1478832260876843', 1, 1, 'SR', NULL, NULL, NULL),
(12630, '2016-11-11 10:44:21', NULL, NULL, 4433, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 10:44:21', 'admin-1478825502-1478832260876843', 1, 0, '', NULL, NULL, NULL),
(12631, '2016-11-11 10:44:21', NULL, NULL, 4433, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 10:44:21', 'admin-1478825502-1478832260876843', 1, 0, '', NULL, NULL, NULL),
(12632, '2016-11-11 10:55:58', NULL, NULL, 4434, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 10:55:58', 'admin-1478825502-14788329580215997', 1, 1, 'SR', NULL, NULL, NULL),
(12633, '2016-11-11 11:03:04', NULL, NULL, 4433, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 11:03:04', 'admin-1478825502-14788333847647358', 1, 0, '', NULL, NULL, NULL),
(12634, '2016-11-11 11:40:59', NULL, NULL, 4435, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 11:40:59', 'admin-1478825502-14788356590795276', 1, 0, '', NULL, NULL, NULL),
(12635, '2016-11-11 11:40:59', NULL, NULL, 4435, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 11:40:59', 'admin-1478825502-14788356590795276', 1, 1, 'SR', NULL, NULL, NULL),
(12636, '2016-11-11 11:44:00', NULL, NULL, 4436, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 11:44:00', 'admin-1478825502-1478835839849382', 1, 1, 'SR', NULL, NULL, NULL),
(12637, '2016-11-11 11:44:09', NULL, NULL, 4436, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 11:44:09', 'admin-1478825502-14788358489674476', 1, 1, 'SR', NULL, NULL, NULL),
(12638, '2016-11-11 12:14:52', NULL, NULL, 4437, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 12:14:52', 'admin-1478825502-14788376927031079', 1, 1, 'SR', NULL, NULL, NULL),
(12639, '2016-11-11 10:00:30', NULL, NULL, 4432, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 10:00:30', 'admin-1478825502-1478829630321655', 1, 0, '', NULL, NULL, NULL),
(12640, '2016-11-11 10:00:30', NULL, NULL, 4432, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478859943', 'admin', '2016-11-11 10:00:30', 'admin-1478825502-1478829630321655', 1, 0, '', NULL, NULL, NULL),
(12641, '2016-11-12 20:59:57', NULL, NULL, 4491, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 20:59:57', 'admin-1478936667-14789555971748565', 1, 0, '', NULL, NULL, NULL),
(12642, '2016-11-12 20:47:08', NULL, NULL, 4489, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 20:47:08', 'admin-1478936667-1478954828445591', 1, 1, 'SR', NULL, NULL, NULL),
(12643, '2016-11-12 20:30:32', NULL, NULL, 4488, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 20:30:32', 'admin-1478936667-14789538326098722', 1, 0, '', NULL, NULL, NULL),
(12644, '2016-11-12 20:30:32', NULL, NULL, 4488, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 20:30:32', 'admin-1478936667-14789538326098722', 1, 1, 'SR', NULL, NULL, NULL),
(12645, '2016-11-12 20:28:36', NULL, NULL, 4487, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 20:28:36', 'admin-1478936667-1478953716263674', 1, 1, 'SR', NULL, NULL, NULL),
(12646, '2016-11-12 20:28:36', NULL, NULL, 4487, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 20:28:36', 'admin-1478936667-1478953716263674', 1, 1, 'SR', NULL, NULL, NULL),
(12647, '2016-11-12 20:28:36', NULL, NULL, 4487, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 20:28:36', 'admin-1478936667-1478953716263674', 1, 0, '', NULL, NULL, NULL),
(12648, '2016-11-12 20:28:36', NULL, NULL, 4487, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 20:28:36', 'admin-1478936667-1478953716263674', 1, 1, 'SR', NULL, NULL, NULL),
(12649, '2016-11-12 20:28:36', NULL, NULL, 4487, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 20:28:36', 'admin-1478936667-1478953716263674', 1, 1, 'SR', NULL, NULL, NULL),
(12650, '2016-11-12 20:21:18', NULL, NULL, 4487, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 20:21:18', 'admin-1478936667-14789532784617075', 1, 0, '', NULL, NULL, NULL),
(12651, '2016-11-12 20:59:57', NULL, NULL, 4491, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 20:59:57', 'admin-1478936667-14789555971748565', 1, 1, 'SR', NULL, NULL, NULL),
(12652, '2016-11-12 21:00:42', NULL, NULL, 4490, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 21:00:42', 'admin-1478936667-14789556423589846', 1, 1, 'SR', NULL, NULL, NULL),
(12653, '2016-11-12 21:00:42', NULL, NULL, 4490, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 21:00:42', 'admin-1478936667-14789556423589846', 1, 0, '', NULL, NULL, NULL),
(12654, '2016-11-12 21:00:42', NULL, NULL, 4490, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 21:00:42', 'admin-1478936667-14789556423589846', 1, 1, 'SR', NULL, NULL, NULL),
(12655, '2016-11-12 21:01:19', NULL, NULL, 4490, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 21:01:19', 'admin-1478936667-14789556793479735', 1, 1, 'SR', NULL, NULL, NULL),
(12656, '2016-11-12 21:00:42', NULL, NULL, 4490, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 21:00:42', 'admin-1478936667-14789556423589846', 1, 1, 'SR', NULL, NULL, NULL),
(12657, '2016-11-12 21:05:00', NULL, NULL, 4490, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 21:05:00', 'admin-1478936667-14789559003839867', 1, 1, 'SR', NULL, NULL, NULL),
(12658, '2016-11-12 21:17:34', NULL, NULL, 4492, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 21:17:34', 'admin-1478936667-14789566543254927', 1, 1, 'SR', NULL, NULL, NULL),
(12659, '2016-11-12 21:17:34', NULL, NULL, 4492, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 21:17:34', 'admin-1478936667-14789566543254927', 1, 1, 'SR', NULL, NULL, NULL),
(12660, '2016-11-12 21:17:34', NULL, NULL, 4492, 0, 227, '161', 'Cranberry Velvet', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 21:17:34', 'admin-1478936667-14789566543254927', 1, 0, '', NULL, NULL, NULL),
(12661, '2016-11-12 21:17:56', NULL, NULL, 4487, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 21:17:56', 'admin-1478936667-14789566761624294', 1, 1, 'SR', NULL, NULL, NULL),
(12662, '2016-11-12 21:23:46', NULL, NULL, 4493, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 21:23:46', 'admin-1478936667-14789570265693414', 1, 0, '', NULL, NULL, NULL),
(12663, '2016-11-12 20:47:08', NULL, NULL, 4489, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 20:47:08', 'admin-1478936667-1478954828445591', 1, 1, 'SR', NULL, NULL, NULL),
(12664, '2016-11-12 20:21:18', NULL, NULL, 4487, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 20:21:18', 'admin-1478936667-14789532784617075', 1, 1, 'SR', NULL, NULL, NULL),
(12665, '2016-11-12 20:21:18', NULL, NULL, 4487, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 20:21:18', 'admin-1478936667-14789532784617075', 1, 0, '', NULL, NULL, NULL),
(12666, '2016-11-12 20:21:18', NULL, NULL, 4487, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 20:21:18', 'admin-1478936667-14789532784617075', 1, 0, '', NULL, NULL, NULL),
(12667, '2016-11-12 20:21:18', NULL, NULL, 4487, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 20:21:18', 'admin-1478936667-14789532784617075', 1, 0, '', NULL, NULL, NULL),
(12668, '2016-11-12 19:50:47', NULL, NULL, 4486, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 19:50:47', 'admin-1478936667-14789514474131077', 1, 0, '', NULL, NULL, NULL),
(12669, '2016-11-12 19:50:47', NULL, NULL, 4486, 0, 78, '78', 'Cheesy Baked Mashed Potato', 'without salad', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 19:50:47', 'admin-1478936667-14789514474131077', 1, 1, 'SR', NULL, NULL, NULL),
(12670, '2016-11-12 20:21:18', NULL, NULL, 4487, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 20:21:18', 'admin-1478936667-14789532784617075', 1, 0, '', NULL, NULL, NULL),
(12671, '2016-11-12 15:52:51', NULL, NULL, 4483, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 15:52:51', 'admin-1478936667-14789371713752097', 1, 1, 'SR', NULL, NULL, NULL),
(12672, '2016-11-12 15:52:51', NULL, NULL, 4483, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 15:52:51', 'admin-1478936667-14789371713752097', 1, 1, 'SR', NULL, NULL, NULL),
(12673, '2016-11-12 16:01:06', NULL, NULL, 4483, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 16:01:06', 'admin-1478936667-14789376667974865', 1, 0, '', NULL, NULL, NULL),
(12674, '2016-11-12 16:36:20', NULL, NULL, 4484, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 16:36:20', 'admin-1478936667-14789397804374786', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(12675, '2016-11-12 16:54:48', NULL, NULL, 4485, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 16:54:48', 'admin-1478936667-14789408884728665', 1, 1, 'SR', NULL, NULL, NULL),
(12676, '2016-11-12 16:54:48', NULL, NULL, 4485, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 16:54:48', 'admin-1478936667-14789408884728665', 1, 0, '', NULL, NULL, NULL),
(12677, '2016-11-12 16:54:48', NULL, NULL, 4485, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 16:54:48', 'admin-1478936667-14789408884728665', 1, 0, '', NULL, NULL, NULL),
(12678, '2016-11-12 19:50:47', NULL, NULL, 4486, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 19:50:47', 'admin-1478936667-14789514474131077', 1, 0, '', NULL, NULL, NULL),
(12679, '2016-11-12 15:30:25', NULL, NULL, 4479, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 15:30:25', 'admin-1478925130-14789358257272384', 1, 1, 'SR', NULL, NULL, NULL),
(12680, '2016-11-12 15:30:26', NULL, NULL, 4479, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 15:30:26', 'admin-1478925130-14789358257272384', 1, 1, 'SR', NULL, NULL, NULL),
(12681, '2016-11-12 15:30:26', NULL, NULL, 4479, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 15:30:26', 'admin-1478925130-14789358257272384', 1, 0, '', NULL, NULL, NULL),
(12682, '2016-11-12 15:30:26', NULL, NULL, 4479, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 15:30:26', 'admin-1478925130-14789358257272384', 1, 0, '', NULL, NULL, NULL),
(12683, '2016-11-12 15:39:03', NULL, NULL, 4480, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 15:39:03', 'admin-1478925130-1478936343304601', 1, 1, 'SR', NULL, NULL, NULL),
(12684, '2016-11-12 15:39:03', NULL, NULL, 4480, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 15:39:03', 'admin-1478925130-1478936343304601', 1, 1, 'SR', NULL, NULL, NULL),
(12685, '2016-11-12 15:43:49', NULL, NULL, 4480, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 15:43:49', 'admin-1478925130-14789366294633422', 1, 1, 'SR', NULL, NULL, NULL),
(12686, '2016-11-12 15:43:49', NULL, NULL, 4480, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 15:43:49', 'admin-1478925130-14789366294633422', 1, 1, 'SR', NULL, NULL, NULL),
(12687, '2016-11-12 15:44:37', NULL, NULL, 4481, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 15:44:37', 'admin-1478936667-14789366768622430', 1, 0, '', NULL, NULL, NULL),
(12688, '2016-11-12 11:49:21', NULL, NULL, 4464, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 11:49:21', 'admin-1478921809-1478922561563187', 1, 1, 'SR', NULL, NULL, NULL),
(12689, '2016-11-12 12:11:40', NULL, NULL, 4465, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 12:11:40', 'admin-1478921809-14789239001199240', 1, 0, '', NULL, NULL, NULL),
(12690, '2016-11-12 12:11:55', NULL, NULL, 4466, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 12:11:55', 'admin-1478921809-14789239153739719', 1, 0, '', NULL, NULL, NULL),
(12691, '2016-11-12 12:11:55', NULL, NULL, 4466, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 12:11:55', 'admin-1478921809-14789239153739719', 1, 0, '', NULL, NULL, NULL),
(12692, '2016-11-12 12:11:55', NULL, NULL, 4466, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 12:11:55', 'admin-1478921809-14789239153739719', 1, 1, 'SR', NULL, NULL, NULL),
(12693, '2016-11-12 12:12:04', NULL, NULL, 4466, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 12:12:04', 'admin-1478921809-14789239243505682', 1, 1, 'SR', NULL, NULL, NULL),
(12694, '2016-11-12 12:12:04', NULL, NULL, 4466, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 12:12:04', 'admin-1478921809-14789239243505682', 1, 1, 'SR', NULL, NULL, NULL),
(12695, '2016-11-12 12:12:29', NULL, NULL, 4465, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 12:12:29', 'admin-1478921809-14789239495831633', 1, 1, 'SR', NULL, NULL, NULL),
(12696, '2016-11-12 12:20:11', NULL, NULL, 4467, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 12:20:11', 'admin-1478921809-14789244114281628', 1, 1, 'SR', NULL, NULL, NULL),
(12697, '2016-11-12 12:20:11', NULL, NULL, 4467, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 12:20:11', 'admin-1478921809-14789244114281628', 1, 0, '', NULL, NULL, NULL),
(12698, '2016-11-12 12:23:35', NULL, NULL, 4468, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 12:23:35', 'admin-1478921809-1478924614865144', 1, 1, 'SR', NULL, NULL, NULL),
(12699, '2016-11-12 12:23:35', NULL, NULL, 4468, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 12:23:35', 'admin-1478921809-1478924614865144', 1, 1, 'SR', NULL, NULL, NULL),
(12700, '2016-11-12 12:23:35', NULL, NULL, 4468, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 12:23:35', 'admin-1478921809-1478924614865144', 1, 1, 'SR', NULL, NULL, NULL),
(12701, '2016-11-12 12:26:26', NULL, NULL, 4457, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 12:26:26', 'admin-1478921809-14789247866406352', 1, 1, 'SR', NULL, NULL, NULL),
(12702, '2016-11-12 12:40:36', NULL, NULL, 4469, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 12:40:36', 'admin-1478925130-14789256364643456', 1, 0, '', NULL, NULL, NULL),
(12703, '2016-11-12 20:21:18', NULL, NULL, 4487, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 20:21:18', 'admin-1478936667-14789532784617075', 1, 1, 'SR', NULL, NULL, NULL),
(12704, '2016-11-12 20:21:18', NULL, NULL, 4487, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 20:21:18', 'admin-1478936667-14789532784617075', 1, 0, '', NULL, NULL, NULL),
(12705, '2016-11-12 15:30:25', NULL, NULL, 4479, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 15:30:25', 'admin-1478925130-14789358257272384', 1, 1, 'SR', NULL, NULL, NULL),
(12706, '2016-11-12 15:30:25', NULL, NULL, 4479, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 15:30:25', 'admin-1478925130-14789358257272384', 1, 1, 'SR', NULL, NULL, NULL),
(12707, '2016-11-12 15:14:52', NULL, NULL, 4478, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 15:14:52', 'admin-1478925130-14789348919295948', 1, 1, 'SR', NULL, NULL, NULL),
(12708, '2016-11-12 15:14:52', NULL, NULL, 4478, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 15:14:52', 'admin-1478925130-14789348919295948', 1, 0, '', NULL, NULL, NULL),
(12709, '2016-11-12 15:15:15', NULL, NULL, 4478, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 15:15:15', 'admin-1478925130-14789349158044478', 1, 1, 'SR', NULL, NULL, NULL),
(12710, '2016-11-12 15:15:15', NULL, NULL, 4478, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 15:15:15', 'admin-1478925130-14789349158044478', 1, 1, 'SR', NULL, NULL, NULL),
(12711, '2016-11-12 15:07:18', NULL, NULL, 4473, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 15:07:18', 'admin-1478925130-14789344377905213', 1, 1, 'SR', NULL, NULL, NULL),
(12712, '2016-11-12 15:07:18', NULL, NULL, 4473, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 15:07:18', 'admin-1478925130-14789344377905213', 1, 1, 'SR', NULL, NULL, NULL),
(12713, '2016-11-12 14:58:31', NULL, NULL, 4477, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 14:58:31', 'admin-1478925130-14789339108529624', 1, 1, 'SR', NULL, NULL, NULL),
(12714, '2016-11-12 14:55:18', NULL, NULL, 4475, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 14:55:18', 'admin-1478925130-1478933717977774', 1, 1, 'SR', NULL, NULL, NULL),
(12715, '2016-11-12 14:57:49', NULL, NULL, 4476, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 14:57:49', 'admin-1478925130-14789338691246428', 1, 0, '', NULL, NULL, NULL),
(12716, '2016-11-12 14:57:49', NULL, NULL, 4476, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 14:57:49', 'admin-1478925130-14789338691246428', 1, 0, '', NULL, NULL, NULL),
(12717, '2016-11-12 14:57:49', NULL, NULL, 4476, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 14:57:49', 'admin-1478925130-14789338691246428', 1, 0, '', NULL, NULL, NULL),
(12718, '2016-11-12 14:42:53', NULL, NULL, 4474, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 14:42:53', 'admin-1478925130-14789329733377136', 1, 1, 'SR', 1, NULL, NULL),
(12719, '2016-11-12 19:50:47', NULL, NULL, 4486, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 19:50:47', 'admin-1478936667-14789514474131077', 1, 0, '', NULL, NULL, NULL),
(12720, '2016-11-12 14:55:18', NULL, NULL, 4475, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 14:55:18', 'admin-1478925130-1478933717977774', 1, 1, 'SR', NULL, NULL, NULL),
(12721, '2016-11-12 14:42:53', NULL, NULL, 4474, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 14:42:53', 'admin-1478925130-14789329733377136', 1, 1, 'SR', 1, NULL, NULL),
(12722, '2016-11-12 14:34:14', NULL, NULL, 4473, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 14:34:14', 'admin-1478925130-14789324543676928', 1, 0, '', NULL, NULL, NULL),
(12723, '2016-11-12 14:33:02', NULL, NULL, 4473, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 14:33:02', 'admin-1478925130-1478932382601474', 1, 1, 'SR', NULL, NULL, NULL),
(12724, '2016-11-12 14:33:02', NULL, NULL, 4473, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 14:33:02', 'admin-1478925130-1478932382601474', 1, 1, 'SR', NULL, NULL, NULL),
(12725, '2016-11-12 14:26:07', NULL, NULL, 4472, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 14:26:07', 'admin-1478925130-1478931967345891', 1, 1, 'SR', NULL, NULL, NULL),
(12726, '2016-11-12 14:26:07', NULL, NULL, 4472, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 14:26:07', 'admin-1478925130-1478931967345891', 1, 0, '', NULL, NULL, NULL),
(12727, '2016-11-12 14:26:07', NULL, NULL, 4472, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 14:26:07', 'admin-1478925130-1478931967345891', 1, 1, 'SR', NULL, NULL, NULL),
(12728, '2016-11-12 13:02:02', NULL, NULL, 4471, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 13:02:02', 'admin-1478925130-14789269225557377', 1, 1, 'SR', NULL, NULL, '10.0'),
(12729, '2016-11-12 12:55:53', NULL, NULL, 4470, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 12:55:53', 'admin-1478925130-14789265532786490', 1, 1, 'SR', NULL, NULL, NULL),
(12730, '2016-11-12 12:47:34', NULL, NULL, 4462, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 12:47:34', 'admin-1478925130-1478926054691776', 1, 1, 'SR', NULL, NULL, NULL),
(12731, '2016-11-12 12:41:12', NULL, NULL, 4469, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 12:41:12', 'admin-1478925130-14789256723965670', 1, 1, 'SR', NULL, NULL, NULL),
(12732, '2016-11-12 12:41:12', NULL, NULL, 4469, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 12:41:12', 'admin-1478925130-14789256723965670', 1, 1, 'SR', NULL, NULL, NULL),
(12733, '2016-11-12 12:47:28', NULL, NULL, 4462, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 12:47:28', 'admin-1478925130-14789260484172217', 1, 1, 'SR', NULL, NULL, NULL),
(12734, '2016-11-12 12:40:36', NULL, NULL, 4469, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 12:40:36', 'admin-1478925130-14789256364643456', 1, 0, '', NULL, NULL, NULL),
(12735, '2016-11-12 11:37:21', NULL, NULL, 4463, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 11:37:21', 'admin-1478921809-14789218415922683', 1, 1, 'SR', NULL, NULL, '10.0'),
(12736, '2016-11-12 11:49:06', NULL, NULL, 4464, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 11:49:06', 'admin-1478921809-14789225462295616', 1, 0, '', NULL, NULL, NULL),
(12737, '2016-11-12 11:37:10', NULL, NULL, 4463, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 11:37:10', 'admin-1478921809-14789218306046393', 1, 0, '', NULL, NULL, '10.0'),
(12738, '2016-11-12 11:37:10', NULL, NULL, 4463, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 11:37:10', 'admin-1478921809-14789218306046393', 1, 0, '', NULL, NULL, '10.0'),
(12739, '2016-11-12 11:37:21', NULL, NULL, 4463, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 11:37:21', 'admin-1478921809-14789218415922683', 1, 1, 'SR', NULL, NULL, '10.0'),
(12740, '2016-11-12 11:36:31', NULL, NULL, 4462, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 11:36:31', 'admin-1478911379-14789217916092259', 1, 1, 'SR', NULL, NULL, NULL),
(12741, '2016-11-12 11:06:41', NULL, NULL, 4459, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 11:06:41', 'admin-1478911379-14789200013579881', 1, 1, 'SR', 1, NULL, NULL),
(12742, '2016-11-12 11:08:42', NULL, NULL, 4460, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 11:08:42', 'admin-1478911379-1478920122170534', 1, 1, 'SR', 1, NULL, NULL),
(12743, '2016-11-12 11:13:01', NULL, NULL, 4461, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 11:13:01', 'admin-1478911379-14789203812743799', 1, 0, '', NULL, NULL, NULL),
(12744, '2016-11-12 11:36:31', NULL, NULL, 4462, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 11:36:31', 'admin-1478911379-14789217916092259', 1, 0, '', NULL, NULL, NULL),
(12745, '2016-11-12 11:36:31', NULL, NULL, 4462, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 11:36:31', 'admin-1478911379-14789217916092259', 1, 1, 'SR', NULL, NULL, NULL),
(12746, '2016-11-12 11:04:41', NULL, NULL, 4458, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 11:04:41', 'admin-1478911379-1478919880817354', 1, 1, 'SR', NULL, NULL, NULL),
(12747, '2016-11-12 11:04:08', NULL, NULL, 4458, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 11:04:08', 'admin-1478911379-147891984807332', 1, 0, '', NULL, NULL, NULL),
(12748, '2016-11-12 11:14:19', NULL, NULL, 4458, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 11:14:19', 'admin-1478911379-14789204588619671', 1, 1, 'SR', NULL, NULL, NULL),
(12749, '2016-11-12 11:04:08', NULL, NULL, 4458, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 11:04:08', 'admin-1478911379-147891984807332', 1, 1, 'SR', NULL, NULL, NULL),
(12750, '2016-11-12 10:58:43', NULL, NULL, 4457, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 10:58:43', 'admin-1478911379-1478919522839176', 1, 1, 'SR', NULL, NULL, NULL),
(12751, '2016-11-12 10:40:57', NULL, NULL, 4456, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 10:40:57', 'admin-1478911379-14789184577563232', 1, 1, 'SR', NULL, NULL, NULL),
(12752, '2016-11-12 10:39:45', NULL, NULL, 4455, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 10:39:45', 'admin-1478911379-14789183849482838', 1, 1, 'SR', NULL, NULL, NULL),
(12753, '2016-11-12 10:38:55', NULL, NULL, 4455, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 10:38:55', 'admin-1478911379-14789183354927629', 1, 0, '', NULL, NULL, NULL),
(12754, '2016-11-12 10:34:12', NULL, NULL, 4454, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 10:34:12', 'admin-1478911379-14789180518632245', 1, 1, 'SR', NULL, NULL, NULL),
(12755, '2016-11-12 10:34:12', NULL, NULL, 4454, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 2, 15.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 10:34:12', 'admin-1478911379-14789180518632245', 1, 0, '', NULL, NULL, NULL),
(12756, '2016-11-12 10:34:12', NULL, NULL, 4454, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 10:34:12', 'admin-1478911379-14789180518632245', 1, 1, 'SR', NULL, NULL, NULL),
(12757, '2016-11-12 10:24:02', NULL, NULL, 4451, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 10:24:02', 'admin-1478911379-14789174423184783', 1, 1, 'SR', NULL, NULL, NULL),
(12758, '2016-11-12 10:22:05', NULL, NULL, 4453, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 10:22:05', 'admin-1478911379-14789173254543484', 1, 1, 'SR', NULL, NULL, NULL),
(12759, '2016-11-12 10:22:05', NULL, NULL, 4453, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 10:22:05', 'admin-1478911379-14789173254543484', 1, 1, 'SR', NULL, NULL, NULL),
(12760, '2016-11-12 10:21:45', NULL, NULL, 4453, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 10:21:45', 'admin-1478911379-14789173049032179', 1, 0, '', NULL, NULL, NULL),
(12761, '2016-11-12 10:21:45', NULL, NULL, 4453, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 10:21:45', 'admin-1478911379-14789173049032179', 1, 0, '', NULL, NULL, NULL),
(12762, '2016-11-12 10:13:14', NULL, NULL, 4452, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 10:13:14', 'admin-1478911379-14789167947159066', 1, 1, 'SR', NULL, NULL, NULL),
(12763, '2016-11-12 09:07:42', NULL, NULL, 4449, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 09:07:42', 'admin-1478911379-14789128617716287', 1, 0, '', NULL, NULL, NULL),
(12764, '2016-11-12 10:13:14', NULL, NULL, 4452, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 10:13:14', 'admin-1478911379-14789167947159066', 1, 1, 'SR', NULL, NULL, NULL),
(12765, '2016-11-12 09:54:01', NULL, NULL, 4451, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 09:54:01', 'admin-1478911379-14789156416223411', 1, 1, 'SR', NULL, NULL, NULL),
(12766, '2016-11-12 09:53:56', NULL, NULL, 4451, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 09:53:56', 'admin-1478911379-14789156360242987', 1, 0, '', NULL, NULL, NULL),
(12767, '2016-11-12 09:38:19', NULL, NULL, 4450, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 09:38:19', 'admin-1478911379-14789146996972331', 1, 1, 'SR', NULL, NULL, NULL),
(12768, '2016-11-12 09:09:50', NULL, NULL, 4449, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 09:09:50', 'admin-1478911379-14789129901515460', 1, 1, 'SR', NULL, NULL, NULL),
(12769, '2016-11-12 09:09:50', NULL, NULL, 4449, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 09:09:50', 'admin-1478911379-14789129901515460', 1, 1, 'SR', NULL, NULL, NULL),
(12770, '2016-11-12 09:09:50', NULL, NULL, 4449, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 09:09:50', 'admin-1478911379-14789129901515460', 1, 1, 'SR', NULL, NULL, NULL),
(12771, '2016-11-12 09:09:50', NULL, NULL, 4449, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 09:09:50', 'admin-1478911379-14789129901515460', 1, 1, 'SR', NULL, NULL, NULL),
(12772, '2016-11-12 09:09:50', NULL, NULL, 4449, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 09:09:50', 'admin-1478911379-14789129901515460', 1, 1, 'SR', NULL, NULL, NULL),
(12773, '2016-11-12 09:09:50', NULL, NULL, 4449, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 09:09:50', 'admin-1478911379-14789129901515460', 1, 1, 'SR', NULL, NULL, NULL),
(12774, '2016-11-12 09:09:50', NULL, NULL, 4449, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 09:09:50', 'admin-1478911379-14789129901515460', 1, 1, 'SR', NULL, NULL, NULL),
(12775, '2016-11-12 09:09:50', NULL, NULL, 4449, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 09:09:50', 'admin-1478911379-14789129901515460', 1, 0, '', NULL, NULL, NULL),
(12776, '2016-11-12 09:09:50', NULL, NULL, 4449, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 09:09:50', 'admin-1478911379-14789129901515460', 1, 0, '', NULL, NULL, NULL),
(12777, '2016-11-12 09:07:42', NULL, NULL, 4449, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 09:07:42', 'admin-1478911379-14789128617716287', 1, 0, '', NULL, NULL, NULL),
(12778, '2016-11-12 09:07:42', NULL, NULL, 4449, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 09:07:42', 'admin-1478911379-14789128617716287', 1, 0, '', NULL, NULL, NULL),
(12779, '2016-11-12 09:07:41', NULL, NULL, 4449, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1478936667', 'admin', '2016-11-12 09:07:41', 'admin-1478911379-14789128617716287', 1, 0, '', NULL, NULL, NULL),
(12780, '2016-11-13 14:05:34', NULL, NULL, 4506, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 14:05:34', 'admin-1479010921-14790171345882436', 1, 1, 'SR', NULL, NULL, NULL),
(12781, '2016-11-13 14:24:55', NULL, NULL, 4517, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 14:24:55', 'admin-1479010921-14790182957212311', 1, 1, 'SR', NULL, NULL, NULL),
(12782, '2016-11-13 14:24:55', NULL, NULL, 4517, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 14:24:55', 'admin-1479010921-14790182957212311', 1, 1, 'SR', NULL, NULL, NULL),
(12783, '2016-11-13 14:24:55', NULL, NULL, 4517, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 14:24:55', 'admin-1479010921-14790182957212311', 1, 0, '', NULL, NULL, NULL),
(12784, '2016-11-13 14:24:55', NULL, NULL, 4517, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 14:24:55', 'admin-1479010921-14790182957212311', 1, 1, 'SR', NULL, NULL, NULL),
(12785, '2016-11-13 14:24:55', NULL, NULL, 4517, 0, 222, '156', 'Seasoned Chicken Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 14:24:55', 'admin-1479010921-14790182957212311', 1, 0, '', NULL, NULL, NULL),
(12786, '2016-11-13 14:27:40', NULL, NULL, 4518, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 14:27:40', 'admin-1479018307-14790184604662326', 1, 1, 'SR', NULL, NULL, NULL),
(12787, '2016-11-13 14:27:40', NULL, NULL, 4518, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 14:27:40', 'admin-1479018307-14790184604662326', 1, 1, 'SR', NULL, NULL, NULL),
(12788, '2016-11-13 14:41:18', NULL, NULL, 4519, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 14:41:18', 'admin-1479018307-14790192778794430', 1, 1, 'SR', NULL, NULL, NULL),
(12789, '2016-11-13 14:41:18', NULL, NULL, 4519, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 14:41:18', 'admin-1479018307-14790192778794430', 1, 1, 'SR', NULL, NULL, NULL),
(12790, '2016-11-13 14:41:18', NULL, NULL, 4519, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 14:41:18', 'admin-1479018307-14790192778794430', 1, 1, 'SR', NULL, NULL, NULL),
(12791, '2016-11-13 14:53:31', NULL, NULL, 4518, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 14:53:31', 'admin-1479018307-1479020011590137', 1, 1, 'SR', NULL, NULL, NULL),
(12792, '2016-11-13 14:53:31', NULL, NULL, 4518, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 14:53:31', 'admin-1479018307-1479020011590137', 1, 1, 'SR', NULL, NULL, NULL),
(12793, '2016-11-13 14:57:35', NULL, NULL, 4515, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 14:57:35', 'admin-1479018307-14790202556908672', 1, 1, 'SR', NULL, NULL, NULL),
(12794, '2016-11-13 15:07:17', NULL, NULL, 4520, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 15:07:17', 'admin-1479018307-14790208368901487', 1, 1, 'SR', NULL, NULL, NULL),
(12795, '2016-11-13 15:07:17', NULL, NULL, 4520, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 15:07:17', 'admin-1479018307-14790208368901487', 1, 1, 'SR', NULL, NULL, NULL),
(12796, '2016-11-13 15:07:17', NULL, NULL, 4520, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 15:07:17', 'admin-1479018307-14790208368901487', 1, 1, 'SR', NULL, NULL, NULL),
(12797, '2016-11-13 15:07:17', NULL, NULL, 4520, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 15:07:17', 'admin-1479018307-14790208368901487', 1, 1, 'SR', NULL, NULL, NULL),
(12798, '2016-11-13 15:35:21', NULL, NULL, 4521, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 15:35:21', 'admin-1479018307-1479022521403176', 1, 0, '', NULL, NULL, NULL),
(12799, '2016-11-13 15:35:21', NULL, NULL, 4521, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 15:35:21', 'admin-1479018307-1479022521403176', 1, 1, 'SR', NULL, NULL, NULL),
(12800, '2016-11-13 15:35:21', NULL, NULL, 4521, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 15:35:21', 'admin-1479018307-1479022521403176', 1, 1, 'SR', NULL, NULL, NULL),
(12801, '2016-11-13 15:36:21', NULL, NULL, 4522, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 15:36:21', 'admin-1479018307-14790225815978983', 1, 0, '', NULL, NULL, NULL),
(12802, '2016-11-13 16:23:38', NULL, NULL, 4523, 0, 54, '54', 'Chai Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 16:23:38', 'admin-1479018307-14790254183547082', 1, 1, 'SR', NULL, NULL, NULL),
(12803, '2016-11-13 17:35:12', NULL, NULL, 4524, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 17:35:12', 'admin-1479018307-1479029712026219', 1, 1, 'SR', NULL, NULL, NULL),
(12804, '2016-11-13 17:35:12', NULL, NULL, 4524, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 17:35:12', 'admin-1479018307-1479029712026219', 1, 1, 'SR', NULL, NULL, NULL),
(12805, '2016-11-13 13:09:24', NULL, NULL, 4510, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 13:09:24', 'admin-1479010921-1479013764158203', 1, 1, 'SR', NULL, NULL, '10.0'),
(12806, '2016-11-13 12:16:21', NULL, NULL, 4503, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:16:21', 'admin-1479006951-14790105809116848', 1, 1, 'SR', NULL, NULL, NULL),
(12807, '2016-11-13 13:50:16', NULL, NULL, 4514, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 13:50:16', 'admin-1479010921-14790162159268290', 1, 1, 'SR', NULL, NULL, NULL),
(12808, '2016-11-13 14:01:11', NULL, NULL, 4516, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 14:01:11', 'admin-1479010921-14790168713446855', 1, 1, 'SR', NULL, NULL, NULL),
(12809, '2016-11-13 13:48:41', NULL, NULL, 4515, 0, 214, '148', 'Set Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 13:48:41', 'admin-1479010921-14790161216504095', 1, 0, '', NULL, NULL, NULL),
(12810, '2016-11-13 13:48:41', NULL, NULL, 4515, 0, 82, '82', 'Set Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 13:48:41', 'admin-1479010921-14790161216504095', 1, 1, 'SR', NULL, NULL, NULL),
(12811, '2016-11-13 13:48:41', NULL, NULL, 4515, 0, 82, '82', 'Set Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 13:48:41', 'admin-1479010921-14790161216504095', 1, 1, 'SR', NULL, NULL, NULL),
(12812, '2016-11-13 13:48:41', NULL, NULL, 4515, 0, 181, '116', 'Open Food ', 'all add rice', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 13:48:41', 'admin-1479010921-14790161216504095', 1, 0, '', NULL, NULL, NULL),
(12813, '2016-11-13 13:48:41', NULL, NULL, 4515, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 13:48:41', 'admin-1479010921-14790161216504095', 1, 0, '', NULL, NULL, NULL),
(12814, '2016-11-13 13:43:06', NULL, NULL, 4514, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 13:43:06', 'admin-1479010921-14790157861831937', 1, 0, '', NULL, NULL, NULL),
(12815, '2016-11-13 13:43:06', NULL, NULL, 4514, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 13:43:06', 'admin-1479010921-14790157861831937', 1, 1, 'SR', NULL, NULL, NULL),
(12816, '2016-11-13 13:28:18', NULL, NULL, 4511, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 13:28:18', 'admin-1479010921-14790148978291931', 1, 1, 'SR', NULL, NULL, NULL),
(12817, '2016-11-13 13:28:18', NULL, NULL, 4511, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 13:28:18', 'admin-1479010921-14790148978291931', 1, 1, 'SR', NULL, NULL, NULL),
(12818, '2016-11-13 13:28:46', NULL, NULL, 4511, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 13:28:46', 'admin-1479010921-14790149265087761', 1, 1, 'SR', NULL, NULL, NULL),
(12819, '2016-11-13 13:41:51', NULL, NULL, 4513, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 13:41:51', 'admin-1479010921-14790157110062448', 1, 1, 'SR', NULL, NULL, NULL),
(12820, '2016-11-13 13:36:59', NULL, NULL, 4512, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 13:36:59', 'admin-1479010921-14790154188937334', 1, 0, '', NULL, NULL, NULL),
(12821, '2016-11-13 13:36:14', NULL, NULL, 4512, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 13:36:14', 'admin-1479010921-14790153741366427', 1, 1, 'SR', NULL, NULL, NULL),
(12822, '2016-11-13 13:28:46', NULL, NULL, 4511, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 13:28:46', 'admin-1479010921-14790149265087761', 1, 0, '', NULL, NULL, NULL),
(12823, '2016-11-13 13:09:24', NULL, NULL, 4510, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 13:09:24', 'admin-1479010921-1479013764158203', 1, 0, '', NULL, NULL, '10.0'),
(12824, '2016-11-13 13:09:24', NULL, NULL, 4510, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 13:09:24', 'admin-1479010921-1479013764158203', 1, 1, 'SR', NULL, NULL, '10.0'),
(12825, '2016-11-13 00:00:00', NULL, NULL, 4508, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:17:00', 'admin-1479006951-14790106202918331', 1, 1, 'SR', NULL, NULL, NULL),
(12826, '2016-11-13 13:00:59', NULL, NULL, 4507, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 13:00:59', 'admin-1479010921-14790132591433528', 1, 1, 'SR', NULL, NULL, NULL),
(12827, '2016-11-13 12:48:55', NULL, NULL, 4506, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:48:55', 'admin-1479010921-14790125349832186', 1, 0, '', NULL, NULL, NULL),
(12828, '2016-11-13 12:21:45', NULL, NULL, 4505, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:21:45', 'admin-1479006951-1479010905812343', 1, 1, 'SR', NULL, NULL, NULL),
(12829, '2016-11-13 12:21:45', NULL, NULL, 4505, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:21:45', 'admin-1479006951-1479010905812343', 1, 0, '', NULL, NULL, NULL),
(12830, '2016-11-13 12:21:45', NULL, NULL, 4505, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:21:45', 'admin-1479006951-1479010905812343', 1, 0, '', NULL, NULL, NULL),
(12831, '2016-11-13 12:21:45', NULL, NULL, 4505, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:21:45', 'admin-1479006951-1479010905812343', 1, 1, 'SR', NULL, NULL, NULL),
(12832, '2016-11-13 00:00:00', NULL, NULL, 4508, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:06:41', 'admin-1479006951-14790100008268692', 1, 1, 'SR', NULL, NULL, NULL),
(12833, '2016-11-13 12:21:45', NULL, NULL, 4505, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:21:45', 'admin-1479006951-1479010905812343', 1, 1, 'SR', NULL, NULL, NULL),
(12834, '2016-11-13 12:21:45', NULL, NULL, 4505, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:21:45', 'admin-1479006951-1479010905812343', 1, 1, 'SR', NULL, NULL, NULL),
(12835, '2016-11-13 12:17:00', NULL, NULL, 4503, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:17:00', 'admin-1479006951-14790106202918331', 1, 0, '', NULL, NULL, NULL),
(12836, '2016-11-13 12:17:27', NULL, NULL, 4503, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:17:27', 'admin-1479006951-14790106474886739', 1, 1, 'SR', NULL, NULL, NULL),
(12837, '2016-11-13 12:16:45', NULL, NULL, 4504, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:16:45', 'admin-1479006951-14790106057499286', 1, 1, 'SR', NULL, NULL, NULL),
(12838, '2016-11-13 12:16:45', NULL, NULL, 4504, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:16:45', 'admin-1479006951-14790106057499286', 1, 1, 'SR', NULL, NULL, NULL),
(12839, '2016-11-13 12:16:45', NULL, NULL, 4504, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:16:45', 'admin-1479006951-14790106057499286', 1, 0, '', NULL, NULL, NULL),
(12840, '2016-11-13 12:16:45', NULL, NULL, 4504, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:16:45', 'admin-1479006951-14790106057499286', 1, 0, '', NULL, NULL, NULL),
(12841, '2016-11-13 12:16:21', NULL, NULL, 4503, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:16:21', 'admin-1479006951-14790105809116848', 1, 0, '', NULL, NULL, NULL),
(12842, '2016-11-13 12:16:21', NULL, NULL, 4503, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:16:21', 'admin-1479006951-14790105809116848', 1, 0, '', NULL, NULL, NULL),
(12843, '2016-11-13 00:00:00', NULL, NULL, 4509, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:06:41', 'admin-1479006951-14790100008268692', 1, 0, '', NULL, NULL, NULL),
(12844, '2016-11-13 00:00:00', NULL, NULL, 4509, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:06:41', 'admin-1479006951-14790100008268692', 1, 1, 'SR', NULL, NULL, NULL),
(12845, '2016-11-13 00:00:00', NULL, NULL, 4509, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:06:41', 'admin-1479006951-14790100008268692', 1, 1, 'SR', NULL, NULL, NULL),
(12846, '2016-11-13 00:00:00', NULL, NULL, 4508, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:05:41', 'admin-1479006951-14790099415558378', 1, 0, '', NULL, NULL, NULL),
(12847, '2016-11-13 12:06:41', NULL, NULL, 4503, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:06:41', 'admin-1479006951-14790100008268692', 1, 1, 'SR', NULL, NULL, NULL),
(12848, '2016-11-13 11:01:10', NULL, NULL, 4499, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 11:01:10', 'admin-1478999196-14790060701931360', 1, 1, 'SR', NULL, NULL, NULL),
(12849, '2016-11-13 11:00:49', NULL, NULL, 4498, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 11:00:49', 'admin-1478999196-14790060495475684', 1, 1, 'SR', NULL, NULL, NULL),
(12850, '2016-11-13 11:00:39', NULL, NULL, 4498, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 11:00:39', 'admin-1478999196-14790060395144518', 1, 0, '', NULL, NULL, NULL),
(12851, '2016-11-13 11:00:39', NULL, NULL, 4498, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 11:00:39', 'admin-1478999196-14790060395144518', 1, 0, '', NULL, NULL, NULL),
(12852, '2016-11-13 00:00:00', NULL, NULL, 4508, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:05:41', 'admin-1479006951-14790099415558378', 1, 0, '', NULL, NULL, NULL),
(12853, '2016-11-13 00:00:00', NULL, NULL, 4509, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 12:05:41', 'admin-1479006951-14790099415558378', 1, 1, 'SR', NULL, NULL, NULL),
(12854, '2016-11-13 11:20:19', NULL, NULL, 4502, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 11:20:19', 'admin-1479006951-14790072196513169', 1, 1, 'SR', NULL, NULL, NULL),
(12855, '2016-11-13 11:20:19', NULL, NULL, 4502, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 11:20:19', 'admin-1479006951-14790072196513169', 1, 0, '', NULL, NULL, NULL),
(12856, '2016-11-13 11:20:19', NULL, NULL, 4502, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 11:20:19', 'admin-1479006951-14790072196513169', 1, 1, 'SR', NULL, NULL, NULL),
(12857, '2016-11-13 11:20:19', NULL, NULL, 4502, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 11:20:19', 'admin-1479006951-14790072196513169', 1, 0, '', NULL, NULL, NULL),
(12858, '2016-11-13 11:12:33', NULL, NULL, 4500, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 11:12:33', 'admin-1478999196-14790067537604571', 1, 0, '', 1, NULL, NULL),
(12859, '2016-11-13 11:15:39', NULL, NULL, 4501, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 11:15:39', 'admin-1478999196-1479006939520983', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(12860, '2016-11-13 11:15:39', NULL, NULL, 4501, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 11:15:39', 'admin-1478999196-1479006939520983', 1, 0, '', NULL, NULL, NULL),
(12861, '2016-11-13 11:12:33', NULL, NULL, 4500, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 11:12:33', 'admin-1478999196-14790067537604571', 1, 0, '', 1, NULL, NULL),
(12862, '2016-11-13 11:01:10', NULL, NULL, 4499, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 11:01:10', 'admin-1478999196-14790060701931360', 1, 1, 'SR', NULL, NULL, NULL),
(12863, '2016-11-13 11:00:49', NULL, NULL, 4498, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 11:00:49', 'admin-1478999196-14790060495475684', 1, 1, 'SR', NULL, NULL, NULL),
(12864, '2016-11-13 10:57:59', NULL, NULL, 4497, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 10:57:59', 'admin-1478999196-14790058788792793', 1, 0, '', NULL, NULL, NULL),
(12865, '2016-11-13 10:57:59', NULL, NULL, 4497, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 10:57:59', 'admin-1478999196-14790058788792793', 1, 1, 'SR', NULL, NULL, NULL),
(12866, '2016-11-13 10:57:27', NULL, NULL, 4497, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 10:57:27', 'admin-1478999196-14790058473854333', 1, 1, 'SR', NULL, NULL, NULL),
(12867, '2016-11-13 10:57:27', NULL, NULL, 4497, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 10:57:27', 'admin-1478999196-14790058473854333', 1, 0, '', NULL, NULL, NULL),
(12868, '2016-11-13 10:22:21', NULL, NULL, 4496, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 10:22:21', 'admin-1478999196-14790037409466067', 1, 0, '', NULL, NULL, NULL),
(12869, '2016-11-13 09:46:54', NULL, NULL, 4495, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 09:46:54', 'admin-1478999196-14790016147855089', 1, 1, 'SR', NULL, NULL, NULL),
(12870, '2016-11-13 10:22:21', NULL, NULL, 4496, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 10:22:21', 'admin-1478999196-14790037409466067', 1, 0, '', NULL, NULL, NULL),
(12871, '2016-11-13 10:22:38', NULL, NULL, 4496, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 10:22:38', 'admin-1478999196-14790037579525794', 1, 1, 'SR', NULL, NULL, NULL),
(12872, '2016-11-13 10:22:38', NULL, NULL, 4496, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 10:22:38', 'admin-1478999196-14790037579525794', 1, 0, '', NULL, NULL, NULL),
(12873, '2016-11-13 10:34:02', NULL, NULL, 4494, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 10:34:02', 'admin-1478999196-1479004442114844', 1, 1, 'SR', NULL, NULL, NULL),
(12874, '2016-11-13 10:56:50', NULL, NULL, 4497, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 10:56:50', 'admin-1478999196-14790058099324749', 1, 0, '', NULL, NULL, NULL),
(12875, '2016-11-13 10:56:50', NULL, NULL, 4497, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 10:56:50', 'admin-1478999196-14790058099324749', 1, 0, '', NULL, NULL, NULL),
(12876, '2016-11-13 10:57:27', NULL, NULL, 4497, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 10:57:27', 'admin-1478999196-14790058473854333', 1, 0, '', NULL, NULL, NULL),
(12877, '2016-11-13 10:22:21', NULL, NULL, 4496, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 10:22:21', 'admin-1478999196-14790037409466067', 1, 0, '', NULL, NULL, NULL),
(12878, '2016-11-13 10:22:21', NULL, NULL, 4496, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 10:22:21', 'admin-1478999196-14790037409466067', 1, 0, '', NULL, NULL, NULL),
(12879, '2016-11-13 09:53:45', NULL, NULL, 4494, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 09:53:45', 'admin-1478999196-14790020254149533', 1, 1, 'SR', NULL, NULL, NULL),
(12880, '2016-11-13 09:46:54', NULL, NULL, 4495, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 09:46:54', 'admin-1478999196-14790016147855089', 1, 1, 'SR', NULL, NULL, NULL),
(12881, '2016-11-13 09:20:21', NULL, NULL, 4494, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 09:20:21', 'admin-1478999196-1479000021233630', 1, 1, 'SR', NULL, NULL, NULL),
(12882, '2016-11-13 09:20:13', NULL, NULL, 4494, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479018307', 'admin', '2016-11-13 09:20:13', 'admin-1478999196-14790000131103780', 1, 0, '', NULL, NULL, NULL),
(12883, '2016-11-14 19:58:28', NULL, NULL, 4546, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:58:28', 'admin-1479124695-14791247080284111', 1, 0, '', NULL, NULL, NULL),
(12884, '2016-11-14 19:58:39', NULL, NULL, 4546, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:58:39', 'admin-1479124695-14791247191501997', 1, 0, '', NULL, NULL, NULL),
(12885, '2016-11-14 20:03:44', NULL, NULL, 4546, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 20:03:44', 'admin-1479124695-14791250242037036', 1, 1, 'SR', NULL, NULL, NULL),
(12886, '2016-11-14 20:16:12', NULL, NULL, 4546, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 20:16:12', 'admin-1479124695-1479125772269948', 1, 0, '', NULL, NULL, NULL),
(12887, '2016-11-14 19:42:59', NULL, NULL, 4546, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:42:59', 'admin-1479097840-14791237789237115', 1, 0, '', NULL, NULL, NULL),
(12888, '2016-11-14 19:42:59', NULL, NULL, 4546, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:42:59', 'admin-1479097840-14791237789237115', 1, 1, 'SR', NULL, NULL, NULL),
(12889, '2016-11-14 19:42:59', NULL, NULL, 4546, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:42:59', 'admin-1479097840-14791237789237115', 1, 0, '', NULL, NULL, NULL),
(12890, '2016-11-14 19:42:59', NULL, NULL, 4546, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:42:59', 'admin-1479097840-14791237789237115', 1, 0, '', NULL, NULL, NULL),
(12891, '2016-11-14 19:42:59', NULL, NULL, 4546, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:42:59', 'admin-1479097840-14791237789237115', 1, 1, 'SR', NULL, NULL, NULL),
(12892, '2016-11-14 19:58:39', NULL, NULL, 4546, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:58:39', 'admin-1479124695-14791247191501997', 1, 1, 'SR', NULL, NULL, NULL),
(12893, '2016-11-14 19:38:25', NULL, NULL, 4546, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:38:25', 'admin-1479097840-1479123505011177', 1, 1, 'SR', NULL, NULL, NULL),
(12894, '2016-11-14 19:38:25', NULL, NULL, 4546, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:38:25', 'admin-1479097840-1479123505011177', 1, 0, '', NULL, NULL, NULL),
(12895, '2016-11-14 19:38:25', NULL, NULL, 4546, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:38:25', 'admin-1479097840-1479123505011177', 1, 1, 'SR', NULL, NULL, NULL),
(12896, '2016-11-14 19:38:25', NULL, NULL, 4546, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:38:25', 'admin-1479097840-1479123505011177', 1, 0, '', NULL, NULL, NULL),
(12897, '2016-11-14 19:22:47', NULL, NULL, 4545, 0, 222, '156', 'Seasoned Chicken Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:22:47', 'admin-1479097840-14791225674188278', 1, 0, '', NULL, NULL, NULL),
(12898, '2016-11-14 19:38:05', NULL, NULL, 4546, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:38:05', 'admin-1479097840-14791234857975872', 1, 0, '', NULL, NULL, NULL),
(12899, '2016-11-14 19:23:52', NULL, NULL, 4545, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:23:52', 'admin-1479097840-14791226323284349', 1, 1, 'SR', NULL, NULL, NULL),
(12900, '2016-11-14 19:23:52', NULL, NULL, 4545, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:23:52', 'admin-1479097840-14791226323284349', 1, 1, 'SR', NULL, NULL, NULL),
(12901, '2016-11-14 14:48:57', NULL, NULL, 4537, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 14:48:57', 'admin-1479097840-14791061374847889', 1, 1, 'SR', NULL, NULL, '10.0'),
(12902, '2016-11-14 14:48:57', NULL, NULL, 4537, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 14:48:57', 'admin-1479097840-14791061374847889', 1, 1, 'SR', NULL, NULL, '10.0'),
(12903, '2016-11-14 14:50:39', NULL, NULL, 4538, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 14:50:39', 'admin-1479097840-14791062397276076', 1, 0, '', NULL, NULL, NULL),
(12904, '2016-11-14 14:50:45', NULL, NULL, 4538, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 14:50:45', 'admin-1479097840-1479106245305342', 1, 1, 'SR', NULL, NULL, NULL),
(12905, '2016-11-14 15:13:13', NULL, NULL, 4540, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 2, 13.00, 26.0000, 0.0000, 26.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 15:13:13', 'admin-1479097840-1479107593015165', 1, 1, 'SR', NULL, NULL, NULL),
(12906, '2016-11-14 15:40:17', NULL, NULL, 4541, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 15:40:17', 'admin-1479097840-1479109217240135', 1, 1, 'SR', NULL, NULL, NULL),
(12907, '2016-11-14 16:57:36', NULL, NULL, 4541, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 16:57:36', 'admin-1479097840-14791138563167974', 1, 0, '', NULL, NULL, NULL),
(12908, '2016-11-14 16:57:36', NULL, NULL, 4541, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 16:57:36', 'admin-1479097840-14791138563167974', 1, 0, '', NULL, NULL, NULL),
(12909, '2016-11-14 16:58:28', NULL, NULL, 4542, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 16:58:28', 'admin-1479097840-14791139080958261', 1, 1, 'SR', NULL, NULL, NULL),
(12910, '2016-11-14 16:58:28', NULL, NULL, 4542, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 16:58:28', 'admin-1479097840-14791139080958261', 1, 1, 'SR', NULL, NULL, NULL),
(12911, '2016-11-14 16:58:28', NULL, NULL, 4542, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 16:58:28', 'admin-1479097840-14791139080958261', 1, 0, '', NULL, NULL, NULL),
(12912, '2016-11-14 16:58:28', NULL, NULL, 4542, 0, 227, '161', 'Cranberry Velvet', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 16:58:28', 'admin-1479097840-14791139080958261', 1, 0, '', NULL, NULL, NULL),
(12913, '2016-11-14 17:10:14', NULL, NULL, 4543, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 17:10:14', 'admin-1479097840-14791146142809449', 1, 0, '', NULL, NULL, NULL),
(12914, '2016-11-14 19:18:52', NULL, NULL, 4544, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:18:52', 'admin-1479097840-14791223324791037', 1, 1, 'SR', 1, NULL, NULL),
(12915, '2016-11-14 19:20:45', NULL, NULL, 4545, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:20:45', 'admin-1479097840-14791224455082744', 1, 0, '', NULL, NULL, NULL),
(12916, '2016-11-14 19:20:45', NULL, NULL, 4545, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:20:45', 'admin-1479097840-14791224455082744', 1, 1, 'SR', NULL, NULL, NULL),
(12917, '2016-11-14 19:21:54', NULL, NULL, 4545, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:21:54', 'admin-1479097840-14791225145676699', 1, 1, 'SR', NULL, NULL, NULL),
(12918, '2016-11-14 19:22:16', NULL, NULL, 4545, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:22:16', 'admin-1479097840-1479122536320259', 1, 1, 'SR', NULL, NULL, NULL),
(12919, '2016-11-14 19:21:54', NULL, NULL, 4545, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:21:54', 'admin-1479097840-14791225145676699', 1, 1, 'SR', NULL, NULL, NULL),
(12920, '2016-11-14 19:21:54', NULL, NULL, 4545, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 19:21:54', 'admin-1479097840-14791225145676699', 1, 0, '', NULL, NULL, NULL),
(12921, '2016-11-14 15:39:56', NULL, NULL, 4538, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 15:39:56', 'admin-1479097840-14791091966015986', 1, 1, 'SR', NULL, NULL, NULL),
(12922, '2016-11-14 15:40:17', NULL, NULL, 4541, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 15:40:17', 'admin-1479097840-1479109217240135', 1, 1, 'SR', NULL, NULL, NULL),
(12923, '2016-11-14 14:48:57', NULL, NULL, 4537, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 14:48:57', 'admin-1479097840-14791061374847889', 1, 0, '', NULL, NULL, '10.0'),
(12924, '2016-11-14 14:10:56', NULL, NULL, 4536, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 14:10:56', 'admin-1479097840-14791038567499455', 1, 1, 'SR', NULL, NULL, NULL),
(12925, '2016-11-14 13:22:07', NULL, NULL, 4535, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 13:22:07', 'admin-1479097840-14791009277348726', 1, 1, 'SR', NULL, NULL, NULL),
(12926, '2016-11-14 13:22:07', NULL, NULL, 4535, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 13:22:07', 'admin-1479097840-14791009277348726', 1, 1, 'SR', NULL, NULL, NULL),
(12927, '2016-11-14 10:30:28', NULL, NULL, 4527, 0, 181, '116', 'Open Food ', 'no salad for omelet', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 10:30:28', 'admin-1479085240-14790906283507683', 1, 0, '', NULL, NULL, NULL),
(12928, '2016-11-14 12:21:36', NULL, NULL, 4531, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 12:21:36', 'admin-1479094199-1479097296143233', 1, 1, 'SR', NULL, NULL, NULL),
(12929, '2016-11-14 12:21:36', NULL, NULL, 4531, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 12:21:36', 'admin-1479094199-1479097296143233', 1, 1, 'SR', NULL, NULL, NULL),
(12930, '2016-11-14 12:26:15', NULL, NULL, 4531, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 12:26:15', 'admin-1479094199-1479097574968754', 1, 0, '', NULL, NULL, NULL),
(12931, '2016-11-14 12:29:28', NULL, NULL, 4532, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 12:29:28', 'admin-1479094199-14790977685296222', 1, 1, 'SR', NULL, NULL, NULL),
(12932, '2016-11-14 12:32:41', NULL, NULL, 4532, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 12:32:41', 'admin-1479097840-14790979615009288', 1, 0, '', NULL, NULL, NULL),
(12933, '2016-11-14 12:29:28', NULL, NULL, 4532, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 12:29:28', 'admin-1479094199-14790977685296222', 1, 1, 'SR', NULL, NULL, NULL),
(12934, '2016-11-14 12:29:28', NULL, NULL, 4532, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 12:29:28', 'admin-1479094199-14790977685296222', 1, 1, 'SR', NULL, NULL, NULL),
(12935, '2016-11-14 12:59:01', NULL, NULL, 4533, 0, 54, '54', 'Chai Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 12:59:01', 'admin-1479097840-1479099541522297', 1, 1, 'SR', NULL, NULL, NULL),
(12936, '2016-11-14 13:03:53', NULL, NULL, 4534, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 13:03:53', 'admin-1479097840-14790998328588086', 1, 0, '', NULL, NULL, NULL),
(12937, '2016-11-14 13:03:53', NULL, NULL, 4534, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 13:03:53', 'admin-1479097840-14790998328588086', 1, 1, 'SR', NULL, NULL, NULL),
(12938, '2016-11-14 13:20:41', NULL, NULL, 4535, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 13:20:41', 'admin-1479097840-14791008412191285', 1, 1, 'SR', NULL, NULL, NULL),
(12939, '2016-11-14 13:20:41', NULL, NULL, 4535, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 13:20:41', 'admin-1479097840-14791008412191285', 1, 0, '', NULL, NULL, NULL),
(12940, '2016-11-14 13:20:41', NULL, NULL, 4535, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 13:20:41', 'admin-1479097840-14791008412191285', 1, 0, '', NULL, NULL, NULL),
(12941, '2016-11-14 11:30:15', NULL, NULL, 4528, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 11:30:15', 'admin-1479094199-14790942153794121', 1, 0, '', NULL, NULL, NULL),
(12942, '2016-11-14 11:32:32', NULL, NULL, 4529, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 11:32:32', 'admin-1479094199-14790943523496080', 1, 0, '', NULL, NULL, NULL),
(12943, '2016-11-14 11:32:32', NULL, NULL, 4529, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 11:32:32', 'admin-1479094199-14790943523496080', 1, 0, '', NULL, NULL, NULL),
(12944, '2016-11-14 11:32:32', NULL, NULL, 4529, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 11:32:32', 'admin-1479094199-14790943523496080', 1, 1, 'SR', NULL, NULL, NULL),
(12945, '2016-11-14 12:09:52', NULL, NULL, 4530, 0, 222, '156', 'Seasoned Chicken Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 12:09:52', 'admin-1479094199-14790965927515231', 1, 0, '', NULL, NULL, '10.0'),
(12946, '2016-11-14 12:09:52', NULL, NULL, 4530, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 12:09:52', 'admin-1479094199-14790965927515231', 1, 0, '', NULL, NULL, '10.0'),
(12947, '2016-11-14 12:09:52', NULL, NULL, 4530, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 12:09:52', 'admin-1479094199-14790965927515231', 1, 0, '', NULL, NULL, '10.0'),
(12948, '2016-11-14 12:09:52', NULL, NULL, 4530, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 12:09:52', 'admin-1479094199-14790965927515231', 1, 1, 'SR', NULL, NULL, '10.0'),
(12949, '2016-11-14 12:21:36', NULL, NULL, 4531, 0, 217, '151', 'Spicy Lemony Wings', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 12:21:36', 'admin-1479094199-1479097296143233', 1, 0, '', NULL, NULL, NULL),
(12950, '2016-11-14 12:21:36', NULL, NULL, 4531, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 12:21:36', 'admin-1479094199-1479097296143233', 1, 0, '', NULL, NULL, NULL),
(12951, '2016-11-14 10:30:28', NULL, NULL, 4527, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 10:30:28', 'admin-1479085240-14790906283507683', 1, 0, '', NULL, NULL, NULL),
(12952, '2016-11-14 10:07:08', NULL, NULL, 4526, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 10:07:08', 'admin-1479085240-14790892284119025', 1, 1, 'SR', NULL, NULL, NULL),
(12953, '2016-11-14 10:30:28', NULL, NULL, 4527, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 10:30:28', 'admin-1479085240-14790906283507683', 1, 1, 'SR', NULL, NULL, NULL),
(12954, '2016-11-14 10:06:47', NULL, NULL, 4526, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 10:06:47', 'admin-1479085240-14790892071086990', 1, 0, '', NULL, NULL, NULL),
(12955, '2016-11-14 10:03:55', NULL, NULL, 4525, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479124695', 'admin', '2016-11-14 10:03:55', 'admin-1479085240-14790890350974997', 1, 1, 'SR', 1, NULL, NULL),
(12956, '2016-11-16 19:04:18', NULL, NULL, 4576, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 19:04:18', 'admin-1479282653-14792942582283188', 1, 1, 'SR', NULL, NULL, NULL),
(12957, '2016-11-16 15:51:16', NULL, NULL, 4574, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 15:51:16', 'admin-1479282653-14792826761079719', 1, 1, 'SR', NULL, NULL, '10.0'),
(12958, '2016-11-16 16:02:51', NULL, NULL, 4575, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 16:02:51', 'admin-1479282653-14792833710072945', 1, 1, 'SR', NULL, NULL, NULL),
(12959, '2016-11-16 19:04:18', NULL, NULL, 4576, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 19:04:18', 'admin-1479282653-14792942582283188', 1, 0, '', NULL, NULL, NULL),
(12960, '2016-11-16 19:04:47', NULL, NULL, 4576, 0, 181, '116', 'Open Food ', 'Soup', 'Meals', 'Perfect Meals', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 19:04:47', 'admin-1479282653-14792942871254393', 1, 0, '', NULL, NULL, NULL),
(12961, '2016-11-16 00:00:00', NULL, NULL, 4568, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 13:14:43', 'admin-1479273066-14792732829145455', 1, 0, '', NULL, NULL, NULL),
(12962, '2016-11-16 00:00:00', NULL, NULL, 4567, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 13:14:22', 'admin-1479273066-1479273262256690', 1, 0, '', NULL, NULL, NULL),
(12963, '2016-11-16 00:00:00', NULL, NULL, 4568, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, NULL, NULL, 6.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 13:14:43', 'admin-1479273066-14792732829145455', 1, 1, 'SR', NULL, NULL, NULL),
(12964, '2016-11-16 13:29:41', NULL, NULL, 4564, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 13:29:41', 'admin-1479273372-14792741810669954', 1, 1, 'SR', NULL, NULL, NULL),
(12965, '2016-11-16 13:29:55', NULL, NULL, 4564, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 13:29:55', 'admin-1479273372-14792741952624036', 1, 1, 'SR', NULL, NULL, NULL),
(12966, '2016-11-16 13:29:55', NULL, NULL, 4564, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 13:29:55', 'admin-1479273372-14792741952624036', 1, 1, 'SR', NULL, NULL, NULL),
(12967, '2016-11-16 13:29:55', NULL, NULL, 4564, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 13:29:55', 'admin-1479273372-14792741952624036', 1, 1, 'SR', NULL, NULL, NULL),
(12968, '2016-11-16 13:30:58', NULL, NULL, 4565, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 13:30:58', 'admin-1479273372-14792742582586738', 1, 1, 'SR', NULL, NULL, NULL),
(12969, '2016-11-16 13:30:58', NULL, NULL, 4565, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 13:30:58', 'admin-1479273372-14792742582586738', 1, 0, '', NULL, NULL, NULL),
(12970, '2016-11-16 13:32:52', NULL, NULL, 4566, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 13:32:52', 'admin-1479273372-14792743722505753', 1, 1, 'SR', NULL, NULL, NULL),
(12971, '2016-11-16 13:32:52', NULL, NULL, 4566, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 13:32:52', 'admin-1479273372-14792743722505753', 1, 1, 'SR', NULL, NULL, NULL),
(12972, '2016-11-16 00:00:00', NULL, NULL, 4567, NULL, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 13:14:43', 'admin-1479273066-14792732829145455', 1, 1, 'SR', NULL, NULL, NULL),
(12973, '2016-11-16 13:43:10', NULL, NULL, 4570, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 13:43:10', 'admin-1479273372-14792749905612995', 1, 0, '', NULL, NULL, NULL),
(12974, '2016-11-16 13:50:42', NULL, NULL, 4571, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 13:50:42', 'admin-1479273372-14792754426833323', 1, 1, 'SR', NULL, NULL, NULL),
(12975, '2016-11-16 13:50:42', NULL, NULL, 4571, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 13:50:42', 'admin-1479273372-14792754426833323', 1, 0, '', NULL, NULL, NULL),
(12976, '2016-11-16 13:50:55', NULL, NULL, 4571, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 13:50:55', 'admin-1479273372-14792754554544263', 1, 1, 'SR', NULL, NULL, NULL),
(12977, '2016-11-16 13:50:55', NULL, NULL, 4571, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 13:50:55', 'admin-1479273372-14792754554544263', 1, 1, 'SR', NULL, NULL, NULL),
(12978, '2016-11-16 14:18:20', NULL, NULL, 4572, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 14:18:20', 'admin-1479273372-14792771001865140', 1, 1, 'SR', NULL, NULL, NULL),
(12979, '2016-11-16 14:18:20', NULL, NULL, 4572, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 14:18:20', 'admin-1479273372-14792771001865140', 1, 1, 'SR', NULL, NULL, NULL),
(12980, '2016-11-16 14:36:58', NULL, NULL, 4573, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 14:36:58', 'admin-1479273372-14792782179318575', 1, 1, 'SR', NULL, NULL, NULL),
(12981, '2016-11-16 15:50:43', NULL, NULL, 4574, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 15:50:43', 'admin-1479273372-14792826433043041', 1, 1, 'SR', NULL, NULL, '10.0'),
(12982, '2016-11-16 15:50:43', NULL, NULL, 4574, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 15:50:43', 'admin-1479273372-14792826433043041', 1, 1, 'SR', NULL, NULL, '10.0'),
(12983, '2016-11-16 00:00:00', NULL, NULL, 4568, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 13:14:43', 'admin-1479273066-14792732829145455', 1, 1, 'SR', NULL, NULL, NULL),
(12984, '2016-11-16 13:12:00', NULL, NULL, 4562, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 13:12:00', 'admin-1479273066-14792731208162525', 1, 1, 'SR', NULL, NULL, NULL),
(12985, '2016-11-16 13:12:00', NULL, NULL, 4562, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 13:12:00', 'admin-1479273066-14792731208162525', 1, 1, 'SR', NULL, NULL, NULL),
(12986, '2016-11-16 13:39:41', NULL, NULL, 4569, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 13:39:41', 'admin-1479273372-14792747812944020', 1, 0, '', NULL, NULL, NULL),
(12987, '2016-11-16 12:46:03', NULL, NULL, 4560, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 12:46:03', 'admin-1479260187-14792715632244528', 1, 1, 'SR', NULL, NULL, NULL),
(12988, '2016-11-16 00:00:00', NULL, NULL, 4551, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 09:52:38', 'admin-1479260187-14792611582402968', 1, 0, '', NULL, NULL, NULL),
(12989, '2016-11-16 11:55:39', NULL, NULL, 4558, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 11:55:39', 'admin-1479260187-14792685397394922', 1, 1, 'SR', NULL, NULL, NULL),
(12990, '2016-11-16 11:55:39', NULL, NULL, 4558, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 11:55:39', 'admin-1479260187-14792685397394922', 1, 1, 'SR', NULL, NULL, NULL),
(12991, '2016-11-16 12:04:31', NULL, NULL, 4559, 0, 214, '148', 'Set Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 12:04:31', 'admin-1479260187-1479269071788542', 1, 0, '', NULL, NULL, NULL),
(12992, '2016-11-16 12:04:31', NULL, NULL, 4559, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 12:04:31', 'admin-1479260187-1479269071788542', 1, 1, 'SR', NULL, NULL, NULL),
(12993, '2016-11-16 12:44:33', NULL, NULL, 4560, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 12:44:33', 'admin-1479260187-1479271473309833', 1, 1, 'SR', NULL, NULL, NULL),
(12994, '2016-11-16 00:00:00', NULL, NULL, 4560, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 10:56:11', 'admin-1479260187-14792649707872471', 1, 1, 'SR', NULL, NULL, NULL),
(12995, '2016-11-16 00:00:00', NULL, NULL, 4560, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 12:39:30', 'admin-1479260187-14792711699472939', 1, 1, 'SR', NULL, NULL, NULL),
(12996, '2016-11-16 12:51:05', NULL, NULL, 4561, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 12:51:05', 'admin-1479260187-14792718650257362', 1, 1, 'SR', NULL, NULL, NULL),
(12997, '2016-11-16 12:51:05', NULL, NULL, 4561, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 12:51:05', 'admin-1479260187-14792718650257362', 1, 0, '', NULL, NULL, NULL),
(12998, '2016-11-16 12:51:05', NULL, NULL, 4561, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 12:51:05', 'admin-1479260187-14792718650257362', 1, 1, 'SR', NULL, NULL, NULL),
(12999, '2016-11-16 12:51:05', NULL, NULL, 4561, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 12:51:05', 'admin-1479260187-14792718650257362', 1, 1, 'SR', NULL, NULL, NULL),
(13000, '2016-11-16 13:11:15', NULL, NULL, 4559, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 13:11:15', 'admin-1479273066-14792730752123921', 1, 1, 'SR', NULL, NULL, NULL),
(13001, '2016-11-16 00:00:00', NULL, NULL, 4556, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 09:52:53', 'admin-1479260187-14792611728477222', 1, 1, 'SR', NULL, NULL, NULL),
(13002, '2016-11-16 00:00:00', NULL, NULL, 4554, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 09:52:38', 'admin-1479260187-14792611582402968', 1, 0, '', NULL, NULL, NULL),
(13003, '2016-11-16 00:00:00', NULL, NULL, 4553, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 09:52:38', 'admin-1479260187-14792611582402968', 1, 0, '', NULL, NULL, NULL),
(13004, '2016-11-16 00:00:00', NULL, NULL, 4552, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 09:52:53', 'admin-1479260187-14792611728477222', 1, 1, 'SR', NULL, NULL, NULL),
(13005, '2016-11-16 00:00:00', NULL, NULL, 4556, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 09:52:38', 'admin-1479260187-14792611582402968', 1, 0, '', NULL, NULL, NULL),
(13006, '2016-11-16 00:00:00', NULL, NULL, 4555, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 09:52:38', 'admin-1479260187-14792611582402968', 1, 0, '', NULL, NULL, NULL),
(13007, '2016-11-16 00:00:00', NULL, NULL, 4560, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 12:39:30', 'admin-1479260187-14792711699472939', 1, 1, 'SR', NULL, NULL, NULL),
(13008, '2016-11-16 00:00:00', NULL, NULL, 4552, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 09:52:38', 'admin-1479260187-14792611582402968', 1, 0, '', NULL, NULL, NULL),
(13009, '2016-11-16 00:00:00', NULL, NULL, 4557, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 09:52:53', 'admin-1479260187-14792611728477222', 1, 1, 'SR', NULL, NULL, NULL),
(13010, '2016-11-16 10:25:33', NULL, NULL, 4549, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 10:25:33', 'admin-1479260187-14792631336935286', 1, 1, 'SR', NULL, NULL, NULL),
(13011, '2016-11-16 00:00:00', NULL, NULL, 4557, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 09:52:53', 'admin-1479260187-14792611728477222', 1, 0, '', NULL, NULL, NULL),
(13012, '2016-11-16 10:25:33', NULL, NULL, 4549, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 10:25:33', 'admin-1479260187-14792631336935286', 1, 1, 'SR', NULL, NULL, NULL),
(13013, '2016-11-16 09:44:32', NULL, NULL, 4548, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 09:44:32', 'admin-1479260187-14792606723541257', 1, 1, 'SR', 1, NULL, NULL),
(13014, '2016-11-16 09:44:32', NULL, NULL, 4548, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479282653', 'admin', '2016-11-16 09:44:32', 'admin-1479260187-14792606723541257', 1, 1, 'SR', 1, NULL, NULL),
(13015, '2016-11-17 19:49:13', NULL, NULL, 4589, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 19:49:13', 'admin-1479383287-14793833536762947', 1, 1, 'SR', NULL, NULL, NULL),
(13016, '2016-11-17 19:50:38', NULL, NULL, 4589, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 19:50:38', 'admin-1479383287-14793834379273258', 1, 1, 'SR', NULL, NULL, NULL),
(13017, '2016-11-17 20:12:16', NULL, NULL, 4589, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 20:12:16', 'admin-1479383287-14793847361132698', 1, 0, '', NULL, NULL, NULL),
(13018, '2016-11-17 20:49:53', NULL, NULL, 4590, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 20:49:53', 'admin-1479383287-1479386993647116', 1, 1, 'SR', NULL, NULL, NULL),
(13019, '2016-11-17 20:49:53', NULL, NULL, 4590, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 20:49:53', 'admin-1479383287-1479386993647116', 1, 1, 'SR', NULL, NULL, NULL),
(13020, '2016-11-17 20:50:12', NULL, NULL, 4591, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 20:50:12', 'admin-1479383287-14793870120052213', 1, 1, 'SR', NULL, NULL, NULL),
(13021, '2016-11-17 20:50:12', NULL, NULL, 4591, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 20:50:12', 'admin-1479383287-14793870120052213', 1, 1, 'SR', NULL, NULL, NULL),
(13022, '2016-11-17 20:50:12', NULL, NULL, 4591, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 20:50:12', 'admin-1479383287-14793870120052213', 1, 1, 'SR', NULL, NULL, NULL),
(13023, '2016-11-17 20:50:12', NULL, NULL, 4591, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 20:50:12', 'admin-1479383287-14793870120052213', 1, 1, 'SR', NULL, NULL, NULL),
(13024, '2016-11-17 19:47:50', NULL, NULL, 4589, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 19:47:50', 'admin-1479353349-14793832705767059', 1, 1, 'SR', NULL, NULL, NULL),
(13025, '2016-11-17 19:47:50', NULL, NULL, 4589, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 19:47:50', 'admin-1479353349-14793832705767059', 1, 1, 'SR', NULL, NULL, NULL),
(13026, '2016-11-17 19:47:50', NULL, NULL, 4589, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 19:47:50', 'admin-1479353349-14793832705767059', 1, 0, '', NULL, NULL, NULL),
(13027, '2016-11-17 19:47:50', NULL, NULL, 4589, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 19:47:50', 'admin-1479353349-14793832705767059', 1, 0, '', NULL, NULL, NULL),
(13028, '2016-11-17 14:21:28', NULL, NULL, 4585, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 14:21:28', 'admin-1479353349-14793636880766192', 1, 1, 'SR', NULL, NULL, NULL),
(13029, '2016-11-17 13:45:53', NULL, NULL, 4583, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 13:45:53', 'admin-1479353349-14793615531755662', 1, 1, 'SR', 1, NULL, NULL),
(13030, '2016-11-17 13:45:53', NULL, NULL, 4583, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 13:45:53', 'admin-1479353349-14793615531755662', 1, 1, 'SR', 1, NULL, NULL),
(13031, '2016-11-17 13:45:53', NULL, NULL, 4583, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 13:45:53', 'admin-1479353349-14793615531755662', 1, 1, 'SR', 1, NULL, NULL),
(13032, '2016-11-17 13:58:17', NULL, NULL, 4584, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 13:58:17', 'admin-1479353349-1479362297538639', 1, 0, '', NULL, NULL, NULL),
(13033, '2016-11-17 13:58:17', NULL, NULL, 4584, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 13:58:17', 'admin-1479353349-1479362297538639', 1, 0, '', NULL, NULL, NULL),
(13034, '2016-11-17 13:58:17', NULL, NULL, 4584, 0, 223, '157', 'Crispy Bacon Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 13:58:17', 'admin-1479353349-1479362297538639', 1, 0, '', NULL, NULL, NULL),
(13035, '2016-11-17 13:58:17', NULL, NULL, 4584, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 13:58:17', 'admin-1479353349-1479362297538639', 1, 0, '', NULL, NULL, NULL),
(13036, '2016-11-17 15:39:23', NULL, NULL, 4586, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 15:39:23', 'admin-1479353349-14793683633009552', 1, 1, 'SR', NULL, NULL, NULL),
(13037, '2016-11-17 18:23:22', NULL, NULL, 4587, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 18:23:22', 'admin-1479353349-1479378202501479', 1, 1, 'SR', NULL, NULL, NULL),
(13038, '2016-11-17 18:23:22', NULL, NULL, 4587, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 18:23:22', 'admin-1479353349-1479378202501479', 1, 1, 'SR', NULL, NULL, NULL),
(13039, '2016-11-17 18:46:34', NULL, NULL, 4588, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 18:46:34', 'admin-1479353349-14793795944229158', 1, 1, 'SR', NULL, NULL, NULL),
(13040, '2016-11-17 19:25:17', NULL, NULL, 4588, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 19:25:17', 'admin-1479353349-14793819177697627', 1, 0, '', NULL, NULL, NULL),
(13041, '2016-11-17 12:12:43', NULL, NULL, 4580, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 12:12:43', 'admin-1479353349-14793559634279111', 1, 1, 'SR', NULL, NULL, NULL),
(13042, '2016-11-17 12:12:43', NULL, NULL, 4580, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 12:12:43', 'admin-1479353349-14793559634279111', 1, 1, 'SR', NULL, NULL, NULL),
(13043, '2016-11-17 12:43:38', NULL, NULL, 4581, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 12:43:38', 'admin-1479353349-14793578184836518', 1, 1, 'SR', NULL, NULL, NULL),
(13044, '2016-11-17 12:43:38', NULL, NULL, 4581, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 12:43:38', 'admin-1479353349-14793578184836518', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(13045, '2016-11-17 13:12:55', NULL, NULL, 4582, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 13:12:55', 'admin-1479353349-14793595749762338', 1, 1, 'SR', NULL, NULL, NULL),
(13046, '2016-11-17 13:10:24', NULL, NULL, 4582, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 13:10:24', 'admin-1479353349-14793594239923258', 1, 1, 'SR', NULL, NULL, NULL),
(13047, '2016-11-17 12:12:43', NULL, NULL, 4580, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 12:12:43', 'admin-1479353349-14793559634279111', 1, 0, '', NULL, NULL, NULL),
(13048, '2016-11-17 11:29:30', NULL, NULL, 4577, 0, 224, '158', 'Set Garlic Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 11:29:30', 'admin-1479353349-14793533707471528', 1, 0, '', NULL, NULL, NULL),
(13049, '2016-11-17 12:12:43', NULL, NULL, 4580, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 12:12:43', 'admin-1479353349-14793559634279111', 1, 1, 'SR', NULL, NULL, NULL),
(13050, '2016-11-17 10:36:46', NULL, NULL, 4579, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 10:36:46', 'admin-1479344553-1479350206624416', 1, 0, '', NULL, NULL, NULL),
(13051, '2016-11-17 10:36:46', NULL, NULL, 4579, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 10:36:46', 'admin-1479344553-1479350206624416', 1, 1, 'SR', NULL, NULL, NULL),
(13052, '2016-11-17 10:36:38', NULL, NULL, 4579, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 10:36:38', 'admin-1479344553-14793501984873848', 1, 0, '', NULL, NULL, NULL),
(13053, '2016-11-17 10:36:38', NULL, NULL, 4579, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479383287', 'admin', '2016-11-17 10:36:38', 'admin-1479344553-14793501984873848', 1, 0, '', NULL, NULL, NULL),
(13054, '2016-11-18 20:29:45', NULL, NULL, 4613, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 20:29:45', 'admin-1479439074-14794721848399041', 1, 0, '', NULL, NULL, '10.0'),
(13055, '2016-11-18 20:29:45', NULL, NULL, 4613, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 20:29:45', 'admin-1479439074-14794721848399041', 1, 0, '', NULL, NULL, '10.0'),
(13056, '2016-11-18 20:29:45', NULL, NULL, 4613, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 20:29:45', 'admin-1479439074-14794721848399041', 1, 0, '', NULL, NULL, '10.0'),
(13057, '2016-11-18 20:43:18', NULL, NULL, 4613, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 20:43:18', 'admin-1479439074-147947299866864', 1, 0, '', NULL, NULL, '10.0'),
(13058, '2016-11-18 20:43:18', NULL, NULL, 4613, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 20:43:18', 'admin-1479439074-147947299866864', 1, 0, '', NULL, NULL, '10.0'),
(13059, '2016-11-18 21:12:58', NULL, NULL, 4614, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 21:12:58', 'admin-1479439074-14794747787743414', 1, 1, 'SR', NULL, NULL, NULL),
(13060, '2016-11-18 19:36:10', NULL, NULL, 4613, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 19:36:10', 'admin-1479439074-14794689698812667', 1, 1, 'SR', NULL, NULL, '10.0'),
(13061, '2016-11-18 19:35:51', NULL, NULL, 4613, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 19:35:51', 'admin-1479439074-14794689517197833', 1, 0, '', NULL, NULL, '10.0'),
(13062, '2016-11-18 19:35:51', NULL, NULL, 4613, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 19:35:52', 'admin-1479439074-14794689517197833', 1, 0, '', NULL, NULL, '10.0'),
(13063, '2016-11-18 19:35:52', NULL, NULL, 4613, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 19:35:52', 'admin-1479439074-14794689517197833', 1, 1, 'SR', NULL, NULL, '10.0'),
(13064, '2016-11-18 19:35:52', NULL, NULL, 4613, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 19:35:52', 'admin-1479439074-14794689517197833', 1, 1, 'SR', NULL, NULL, '10.0'),
(13065, '2016-11-18 19:35:52', NULL, NULL, 4613, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 19:35:52', 'admin-1479439074-14794689517197833', 1, 1, 'SR', NULL, NULL, '10.0'),
(13066, '2016-11-18 19:35:52', NULL, NULL, 4613, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 19:35:52', 'admin-1479439074-14794689517197833', 1, 1, 'SR', NULL, NULL, '10.0'),
(13067, '2016-11-18 19:35:52', NULL, NULL, 4613, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 19:35:52', 'admin-1479439074-14794689517197833', 1, 0, '', NULL, NULL, '10.0'),
(13068, '2016-11-18 19:35:52', NULL, NULL, 4613, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 19:35:52', 'admin-1479439074-14794689517197833', 1, 0, '', NULL, NULL, '10.0'),
(13069, '2016-11-18 19:35:52', NULL, NULL, 4613, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 19:35:52', 'admin-1479439074-14794689517197833', 1, 0, '', NULL, NULL, '10.0'),
(13070, '2016-11-18 19:35:52', NULL, NULL, 4613, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 19:35:52', 'admin-1479439074-14794689517197833', 1, 1, 'SR', NULL, NULL, '10.0'),
(13071, '2016-11-18 19:49:19', NULL, NULL, 4613, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 19:49:19', 'admin-1479439074-14794697590306875', 1, 1, 'SR', NULL, NULL, '10.0'),
(13072, '2016-11-18 18:09:56', NULL, NULL, 4611, 0, 187, '122', 'Iced Tea ', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 18:09:56', 'admin-1479439074-14794637964522313', 1, 0, '', 1, NULL, NULL),
(13073, '2016-11-18 19:35:51', NULL, NULL, 4613, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 19:35:51', 'admin-1479439074-14794689517197833', 1, 1, 'SR', NULL, NULL, '10.0'),
(13074, '2016-11-18 19:35:51', NULL, NULL, 4613, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 19:35:51', 'admin-1479439074-14794689517197833', 1, 0, '', NULL, NULL, '10.0'),
(13075, '2016-11-18 19:35:51', NULL, NULL, 4613, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 19:35:51', 'admin-1479439074-14794689517197833', 1, 0, '', NULL, NULL, '10.0'),
(13076, '2016-11-18 19:35:51', NULL, NULL, 4613, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 19:35:51', 'admin-1479439074-14794689517197833', 1, 0, '', NULL, NULL, '10.0'),
(13077, '2016-11-18 19:35:51', NULL, NULL, 4613, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 19:35:51', 'admin-1479439074-14794689517197833', 1, 1, 'SR', NULL, NULL, '10.0'),
(13078, '2016-11-18 18:09:21', NULL, NULL, 4610, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 18:09:21', 'admin-1479439074-14794637614774079', 1, 1, 'SR', 1, NULL, NULL),
(13079, '2016-11-18 17:03:15', NULL, NULL, 4609, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 17:03:15', 'admin-1479439074-14794597955842910', 1, 1, 'SR', 1, NULL, NULL),
(13080, '2016-11-18 17:03:15', NULL, NULL, 4609, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 17:03:15', 'admin-1479439074-14794597955842910', 1, 1, 'SR', 1, NULL, NULL),
(13081, '2016-11-18 15:33:35', NULL, NULL, 4608, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 15:33:35', 'admin-1479439074-14794544150228341', 1, 0, '', 1, NULL, NULL),
(13082, '2016-11-18 13:57:48', NULL, NULL, 4607, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 13:57:48', 'admin-1479439074-14794486686139149', 1, 1, 'SR', NULL, NULL, NULL),
(13083, '2016-11-18 13:11:14', NULL, NULL, 4606, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 13:11:14', 'admin-1479439074-14794458744491760', 1, 1, 'SR', NULL, NULL, NULL),
(13084, '2016-11-18 13:06:26', NULL, NULL, 4605, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 13:06:26', 'admin-1479439074-1479445586679398', 1, 1, 'SR', NULL, NULL, NULL),
(13085, '2016-11-18 12:46:07', NULL, NULL, 4604, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 12:46:07', 'admin-1479439074-14794443676046914', 1, 1, 'SR', NULL, NULL, NULL),
(13086, '2016-11-18 12:46:07', NULL, NULL, 4604, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 12:46:07', 'admin-1479439074-14794443676046914', 1, 1, 'SR', NULL, NULL, NULL),
(13087, '2016-11-18 12:46:07', NULL, NULL, 4604, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 12:46:07', 'admin-1479439074-14794443676046914', 1, 0, '', NULL, NULL, NULL),
(13088, '2016-11-18 12:46:07', NULL, NULL, 4604, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 12:46:07', 'admin-1479439074-14794443676046914', 1, 0, '', NULL, NULL, NULL),
(13089, '2016-11-18 12:13:32', NULL, NULL, 4603, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 12:13:32', 'admin-1479439074-14794424120457052', 1, 1, 'SR', NULL, NULL, NULL),
(13090, '2016-11-18 12:13:32', NULL, NULL, 4603, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 12:13:32', 'admin-1479439074-14794424120457052', 1, 0, '', NULL, NULL, NULL),
(13091, '2016-11-18 12:13:32', NULL, NULL, 4603, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 12:13:32', 'admin-1479439074-14794424120457052', 1, 0, '', NULL, NULL, NULL),
(13092, '2016-11-18 11:26:47', NULL, NULL, 4600, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 11:26:47', 'admin-1479439074-14794396074474445', 1, 0, '', NULL, NULL, NULL),
(13093, '2016-11-18 11:44:03', NULL, NULL, 4601, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 11:44:03', 'admin-1479439074-14794406428316437', 1, 0, '', NULL, NULL, '10.0'),
(13094, '2016-11-18 11:44:03', NULL, NULL, 4601, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 11:44:03', 'admin-1479439074-14794406428316437', 1, 1, 'SR', NULL, NULL, '10.0'),
(13095, '2016-11-18 11:44:03', NULL, NULL, 4601, 0, 222, '156', 'Seasoned Chicken Angel Hair', '', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 11:44:03', 'admin-1479439074-14794406428316437', 1, 0, '', NULL, NULL, '10.0'),
(13096, '2016-11-18 11:44:03', NULL, NULL, 4601, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 11:44:03', 'admin-1479439074-14794406428316437', 1, 1, 'SR', NULL, NULL, '10.0'),
(13097, '2016-11-18 11:44:03', NULL, NULL, 4601, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 11:44:03', 'admin-1479439074-14794406428316437', 1, 0, '', NULL, NULL, '10.0'),
(13098, '2016-11-18 11:44:03', NULL, NULL, 4601, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 11:44:03', 'admin-1479439074-14794406428316437', 1, 0, '', NULL, NULL, '10.0'),
(13099, '2016-11-18 12:05:18', NULL, NULL, 4602, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 12:05:18', 'admin-1479439074-14794419180634654', 1, 0, '', NULL, NULL, NULL),
(13100, '2016-11-18 12:13:32', NULL, NULL, 4603, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 12:13:32', 'admin-1479439074-14794424120457052', 1, 0, '', NULL, NULL, NULL),
(13101, '2016-11-18 10:55:35', NULL, NULL, 4598, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 10:55:35', 'admin-1479430813-14794377351437150', 1, 1, 'SR', NULL, NULL, NULL),
(13102, '2016-11-18 10:55:35', NULL, NULL, 4598, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 10:55:35', 'admin-1479430813-14794377351437150', 1, 1, 'SR', NULL, NULL, NULL),
(13103, '2016-11-18 11:09:26', NULL, NULL, 4599, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 11:09:26', 'admin-1479430813-1479438565911418', 1, 0, '', NULL, NULL, NULL),
(13104, '2016-11-18 10:16:06', NULL, NULL, 4596, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 10:16:06', 'admin-1479430813-14794353659971332', 1, 0, '', NULL, NULL, NULL),
(13105, '2016-11-18 10:16:06', NULL, NULL, 4596, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 10:16:06', 'admin-1479430813-14794353659971332', 1, 0, '', NULL, NULL, NULL),
(13106, '2016-11-18 10:16:06', NULL, NULL, 4596, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 10:16:06', 'admin-1479430813-14794353659971332', 1, 1, 'SR', NULL, NULL, NULL),
(13107, '2016-11-18 11:26:47', NULL, NULL, 4600, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 11:26:47', 'admin-1479439074-14794396074474445', 1, 0, '', NULL, NULL, NULL),
(13108, '2016-11-18 11:24:55', NULL, NULL, 4599, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 11:24:55', 'admin-1479439074-14794394949503085', 1, 1, 'SR', NULL, NULL, NULL),
(13109, '2016-11-18 11:24:55', NULL, NULL, 4599, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 11:24:55', 'admin-1479439074-14794394949503085', 1, 0, '', NULL, NULL, NULL),
(13110, '2016-11-18 11:19:52', NULL, NULL, 4596, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 11:19:52', 'admin-1479439074-14794391923319623', 1, 1, 'SR', NULL, NULL, NULL),
(13111, '2016-11-18 11:09:26', NULL, NULL, 4599, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 11:09:26', 'admin-1479430813-1479438565911418', 1, 0, '', NULL, NULL, NULL),
(13112, '2016-11-18 11:09:26', NULL, NULL, 4599, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 11:09:26', 'admin-1479430813-1479438565911418', 1, 0, '', NULL, NULL, NULL),
(13113, '2016-11-18 11:09:26', NULL, NULL, 4599, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 11:09:26', 'admin-1479430813-1479438565911418', 1, 1, 'SR', NULL, NULL, NULL),
(13114, '2016-11-18 10:45:01', NULL, NULL, 4597, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 10:45:01', 'admin-1479430813-14794371015981126', 1, 1, 'SR', NULL, NULL, NULL),
(13115, '2016-11-18 10:45:01', NULL, NULL, 4597, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 10:45:01', 'admin-1479430813-14794371015981126', 1, 1, 'SR', NULL, NULL, NULL),
(13116, '2016-11-18 10:46:54', NULL, NULL, 4597, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 10:46:54', 'admin-1479430813-14794372139183324', 1, 0, '', NULL, NULL, NULL),
(13117, '2016-11-18 10:55:05', NULL, NULL, 4598, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 10:55:05', 'admin-1479430813-1479437705721489', 1, 0, '', NULL, NULL, NULL),
(13118, '2016-11-18 10:55:05', NULL, NULL, 4598, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 10:55:05', 'admin-1479430813-1479437705721489', 1, 0, '', NULL, NULL, NULL),
(13119, '2016-11-18 10:55:05', NULL, NULL, 4598, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 10:55:05', 'admin-1479430813-1479437705721489', 1, 0, '', NULL, NULL, NULL),
(13120, '2016-11-18 09:55:02', NULL, NULL, 4594, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 09:55:02', 'admin-1479430813-14794341019454839', 1, 0, '', NULL, NULL, NULL),
(13121, '2016-11-18 09:55:02', NULL, NULL, 4594, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 09:55:02', 'admin-1479430813-14794341019454839', 1, 0, '', NULL, NULL, NULL),
(13122, '2016-11-18 10:15:52', NULL, NULL, 4595, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 10:15:52', 'admin-1479430813-14794353518376536', 1, 1, 'SR', NULL, NULL, NULL),
(13123, '2016-11-18 10:15:52', NULL, NULL, 4595, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 10:15:52', 'admin-1479430813-14794353518376536', 1, 1, 'SR', NULL, NULL, NULL),
(13124, '2016-11-18 10:16:06', NULL, NULL, 4596, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 10:16:06', 'admin-1479430813-14794353659971332', 1, 0, '', NULL, NULL, NULL),
(13125, '2016-11-18 09:46:10', NULL, NULL, 4593, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 09:46:10', 'admin-1479430813-14794335703986968', 1, 1, 'SR', 1, NULL, NULL),
(13126, '2016-11-18 09:43:16', NULL, NULL, 4592, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 09:43:16', 'admin-1479430813-14794333964696361', 1, 0, '', NULL, NULL, NULL),
(13127, '2016-11-18 09:43:16', NULL, NULL, 4592, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 09:43:16', 'admin-1479430813-14794333964696361', 1, 1, 'SR', NULL, NULL, NULL),
(13128, '2016-11-18 09:43:16', NULL, NULL, 4592, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 09:43:16', 'admin-1479430813-14794333964696361', 1, 1, 'SR', NULL, NULL, NULL),
(13129, '2016-11-18 09:43:16', NULL, NULL, 4592, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 09:43:16', 'admin-1479430813-14794333964696361', 1, 1, 'SR', NULL, NULL, NULL),
(13130, '2016-11-18 09:43:16', NULL, NULL, 4592, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 09:43:16', 'admin-1479430813-14794333964696361', 1, 0, '', NULL, NULL, NULL),
(13131, '2016-11-18 09:43:16', NULL, NULL, 4592, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479439074', 'admin', '2016-11-18 09:43:16', 'admin-1479430813-14794333964696361', 1, 0, '', NULL, NULL, NULL),
(13132, '2016-11-19 21:25:10', NULL, NULL, 4638, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 21:25:10', 'admin-1479541288-14795619103084556', 1, 1, 'SR', NULL, NULL, NULL),
(13133, '2016-11-19 21:25:10', NULL, NULL, 4638, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 21:25:10', 'admin-1479541288-14795619103084556', 1, 1, 'SR', NULL, NULL, NULL),
(13134, '2016-11-19 21:01:29', NULL, NULL, 4639, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 21:01:29', 'admin-1479541288-14795604890373743', 1, 1, 'SR', NULL, NULL, NULL),
(13135, '2016-11-19 21:01:29', NULL, NULL, 4639, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 21:01:29', 'admin-1479541288-14795604890373743', 1, 1, 'SR', NULL, NULL, NULL),
(13136, '2016-11-19 20:23:31', NULL, NULL, 4638, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 20:23:31', 'admin-1479541288-1479558210982237', 1, 1, 'SR', NULL, NULL, NULL),
(13137, '2016-11-19 15:35:34', NULL, NULL, 4627, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 15:35:34', 'admin-1479535729-14795409339026329', 1, 1, 'SR', NULL, NULL, NULL),
(13138, '2016-11-19 15:41:20', NULL, NULL, 4632, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 15:41:20', 'admin-1479535729-14795412806581172', 1, 1, 'SR', NULL, NULL, NULL),
(13139, '2016-11-19 15:41:20', NULL, NULL, 4632, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 15:41:20', 'admin-1479535729-14795412806581172', 1, 1, 'SR', NULL, NULL, NULL),
(13140, '2016-11-19 15:41:42', NULL, NULL, 4632, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 15:41:42', 'admin-1479541288-14795413023152942', 1, 0, '', NULL, NULL, NULL),
(13141, '2016-11-19 15:41:42', NULL, NULL, 4632, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 15:41:42', 'admin-1479541288-14795413023152942', 1, 1, 'SR', NULL, NULL, NULL),
(13142, '2016-11-19 16:33:01', NULL, NULL, 4633, NULL, 58, '58', 'House White Bottle', '', 'Cold Drinks', 'Wine', 1, 88.00, 88.0000, 0.0000, 88.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 16:33:01', 'admin-1479541288-14795443810928198', 1, 1, 'SR', 1, NULL, NULL),
(13143, '2016-11-19 16:33:01', NULL, NULL, 4633, NULL, 57, '57', 'House Red Bottle', '', 'Cold Drinks', 'Wine', 1, 88.00, 88.0000, 0.0000, 88.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 16:33:01', 'admin-1479541288-14795443810928198', 1, 1, 'SR', 1, NULL, NULL),
(13144, '2016-11-19 17:08:12', NULL, NULL, 4634, 0, 187, '122', 'Iced Tea ', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 17:08:12', 'admin-1479541288-14795464922287467', 1, 0, '', NULL, NULL, NULL),
(13145, '2016-11-19 18:12:39', NULL, NULL, 4635, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 18:12:39', 'admin-1479541288-14795503590699729', 1, 1, 'SR', NULL, NULL, NULL),
(13146, '2016-11-19 18:12:39', NULL, NULL, 4635, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 18:12:39', 'admin-1479541288-14795503590699729', 1, 0, '', NULL, NULL, NULL),
(13147, '2016-11-19 19:52:22', NULL, NULL, 4636, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 19:52:22', 'admin-1479541288-14795563424516351', 1, 1, 'SR', NULL, NULL, NULL),
(13148, '2016-11-19 19:52:22', NULL, NULL, 4636, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 19:52:22', 'admin-1479541288-14795563424516351', 1, 1, 'SR', NULL, NULL, NULL),
(13149, '2016-11-19 19:52:22', NULL, NULL, 4636, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 19:52:22', 'admin-1479541288-14795563424516351', 1, 0, '', NULL, NULL, NULL),
(13150, '2016-11-19 19:56:39', NULL, NULL, 4637, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 19:56:39', 'admin-1479541288-14795565992304157', 1, 0, '', NULL, NULL, NULL),
(13151, '2016-11-19 19:56:39', NULL, NULL, 4637, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 19:56:39', 'admin-1479541288-14795565992304157', 1, 0, '', NULL, NULL, NULL),
(13152, '2016-11-19 19:56:39', NULL, NULL, 4637, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 19:56:39', 'admin-1479541288-14795565992304157', 1, 1, 'SR', NULL, NULL, NULL),
(13153, '2016-11-19 19:56:56', NULL, NULL, 4637, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 19:56:56', 'admin-1479541288-14795566163062764', 1, 1, 'SR', NULL, NULL, NULL),
(13154, '2016-11-19 14:53:02', NULL, NULL, 4630, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 14:53:02', 'admin-1479535729-14795383820041891', 1, 1, 'SR', NULL, NULL, NULL),
(13155, '2016-11-19 14:53:02', NULL, NULL, 4630, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 14:53:02', 'admin-1479535729-14795383820041891', 1, 1, 'SR', NULL, NULL, NULL),
(13156, '2016-11-19 14:53:02', NULL, NULL, 4630, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 14:53:02', 'admin-1479535729-14795383820041891', 1, 1, 'SR', NULL, NULL, NULL),
(13157, '2016-11-19 14:53:02', NULL, NULL, 4630, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 14:53:02', 'admin-1479535729-14795383820041891', 1, 1, 'SR', NULL, NULL, NULL),
(13158, '2016-11-19 14:53:02', NULL, NULL, 4630, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 14:53:02', 'admin-1479535729-14795383820041891', 1, 0, '', NULL, NULL, NULL),
(13159, '2016-11-19 15:30:12', NULL, NULL, 4630, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 15:30:12', 'admin-1479535729-14795406121301666', 1, 0, '', NULL, NULL, NULL),
(13160, '2016-11-19 15:32:49', NULL, NULL, 4631, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 15:32:49', 'admin-1479535729-14795407695821399', 1, 1, 'SR', NULL, NULL, NULL),
(13161, '2016-11-19 15:32:49', NULL, NULL, 4631, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 15:32:49', 'admin-1479535729-14795407695821399', 1, 0, '', NULL, NULL, NULL),
(13162, '2016-11-19 15:32:55', NULL, NULL, 4630, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 15:32:55', 'admin-1479535729-1479540775519827', 1, 1, 'SR', NULL, NULL, NULL),
(13163, '2016-11-19 15:32:55', NULL, NULL, 4630, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 15:32:55', 'admin-1479535729-1479540775519827', 1, 1, 'SR', NULL, NULL, NULL),
(13164, '2016-11-19 15:32:55', NULL, NULL, 4630, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 15:32:55', 'admin-1479535729-1479540775519827', 1, 1, 'SR', NULL, NULL, NULL),
(13165, '2016-11-19 20:23:16', NULL, NULL, 4638, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 20:23:16', 'admin-1479541288-1479558196661158', 1, 0, '', NULL, NULL, NULL),
(13166, '2016-11-19 20:23:31', NULL, NULL, 4638, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 20:23:31', 'admin-1479541288-1479558210982237', 1, 1, 'SR', NULL, NULL, NULL),
(13167, '2016-11-19 14:31:18', NULL, NULL, 4629, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 14:31:18', 'admin-1479535729-14795370778761960', 1, 1, 'SR', NULL, NULL, NULL),
(13168, '2016-11-19 14:33:18', NULL, NULL, 4627, 0, 154, '88', 'House BLT', 'without egg', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 14:33:18', 'admin-1479535729-1479537198109427', 1, 0, '', NULL, NULL, NULL),
(13169, '2016-11-19 14:33:35', NULL, NULL, 4627, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 14:33:35', 'admin-1479535729-14795372156555679', 1, 0, '', NULL, NULL, NULL),
(13170, '2016-11-19 14:35:06', NULL, NULL, 4627, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 14:35:06', 'admin-1479535729-1479537306747759', 1, 0, '', NULL, NULL, NULL),
(13171, '2016-11-19 14:35:06', NULL, NULL, 4627, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 14:35:06', 'admin-1479535729-1479537306747759', 1, 0, '', NULL, NULL, NULL),
(13172, '2016-11-19 14:53:02', NULL, NULL, 4630, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 14:53:02', 'admin-1479535729-14795383820041891', 1, 0, '', NULL, NULL, NULL),
(13173, '2016-11-19 14:13:30', NULL, NULL, 4629, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 14:13:30', 'admin-1479535729-14795360105867115', 1, 1, 'SR', NULL, NULL, NULL),
(13174, '2016-11-19 14:12:29', NULL, NULL, 4628, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 14:12:29', 'admin-1479535729-14795359495731010', 1, 1, 'SR', NULL, NULL, NULL),
(13175, '2016-11-19 14:12:29', NULL, NULL, 4628, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 14:12:29', 'admin-1479535729-14795359495731010', 1, 0, '', NULL, NULL, NULL),
(13176, '2016-11-19 14:08:38', NULL, NULL, 4628, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 14:08:38', 'admin-1479527473-14795357184837467', 1, 0, '', NULL, NULL, NULL),
(13177, '2016-11-19 14:08:38', NULL, NULL, 4628, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 14:08:38', 'admin-1479527473-14795357184837467', 1, 1, 'SR', NULL, NULL, NULL),
(13178, '2016-11-19 14:08:38', NULL, NULL, 4628, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 14:08:38', 'admin-1479527473-14795357184837467', 1, 0, '', NULL, NULL, NULL),
(13179, '2016-11-19 14:04:30', NULL, NULL, 4627, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 14:04:30', 'admin-1479527473-14795354703603937', 1, 1, 'SR', NULL, NULL, NULL),
(13180, '2016-11-19 14:04:04', NULL, NULL, 4627, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 14:04:04', 'admin-1479527473-14795354439111169', 1, 1, 'SR', NULL, NULL, NULL),
(13181, '2016-11-19 14:04:04', NULL, NULL, 4627, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 14:04:04', 'admin-1479527473-14795354439111169', 1, 1, 'SR', NULL, NULL, NULL),
(13182, '2016-11-19 13:46:09', NULL, NULL, 4627, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 13:46:09', 'admin-1479527473-14795343692854732', 1, 1, 'SR', NULL, NULL, NULL),
(13183, '2016-11-19 12:42:04', NULL, NULL, 4626, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 12:42:04', 'admin-1479527473-14795305244554652', 1, 1, 'SR', NULL, NULL, NULL),
(13184, '2016-11-19 12:42:04', NULL, NULL, 4626, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 12:42:04', 'admin-1479527473-14795305244554652', 1, 1, 'SR', NULL, NULL, NULL),
(13185, '2016-11-19 12:40:47', NULL, NULL, 4625, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 12:40:47', 'admin-1479527473-1479530446803604', 1, 1, 'SR', NULL, NULL, NULL),
(13186, '2016-11-19 12:40:46', NULL, NULL, 4625, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 12:40:47', 'admin-1479527473-1479530446803604', 1, 0, '', NULL, NULL, NULL),
(13187, '2016-11-19 11:42:34', NULL, NULL, 4623, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:42:34', 'admin-1479526181-14795269542479319', 1, 0, '', NULL, NULL, NULL),
(13188, '2016-11-19 11:42:53', NULL, NULL, 4623, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:42:53', 'admin-1479526181-14795269728294479', 1, 1, 'SR', NULL, NULL, NULL),
(13189, '2016-11-19 11:43:59', NULL, NULL, 4623, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:43:59', 'admin-1479526181-1479527039776414', 1, 1, 'SR', NULL, NULL, NULL),
(13190, '2016-11-19 11:51:28', NULL, NULL, 4624, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:51:28', 'admin-1479527473-14795274880433096', 1, 0, '', NULL, NULL, NULL),
(13191, '2016-11-19 11:51:41', NULL, NULL, 4624, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:51:41', 'admin-1479527473-14795275013159347', 1, 1, 'SR', NULL, NULL, NULL),
(13192, '2016-11-19 12:02:33', NULL, NULL, 4623, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 12:02:33', 'admin-1479527473-1479528153296580', 1, 0, '', NULL, NULL, NULL),
(13193, '2016-11-19 12:06:04', NULL, NULL, 4623, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 12:06:04', 'admin-1479527473-1479528364432773', 1, 1, 'SR', NULL, NULL, NULL),
(13194, '2016-11-19 12:06:04', NULL, NULL, 4623, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 12:06:04', 'admin-1479527473-1479528364432773', 1, 1, 'SR', NULL, NULL, NULL),
(13195, '2016-11-19 11:08:26', NULL, NULL, 4619, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:08:26', 'admin-1479517334-14795249064514353', 1, 1, 'SR', NULL, NULL, NULL),
(13196, '2016-11-19 11:12:55', NULL, NULL, 4620, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 2, 21.00, 42.0000, 0.0000, 42.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:12:55', 'admin-1479517334-14795251752436555', 1, 0, '', NULL, NULL, NULL),
(13197, '2016-11-19 11:12:55', NULL, NULL, 4620, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:12:55', 'admin-1479517334-14795251752436555', 1, 0, '', NULL, NULL, NULL),
(13198, '2016-11-19 12:39:31', NULL, NULL, 4623, 0, 73, '73', 'Marmite Chicken ', 'Takeaway', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 12:39:31', 'admin-1479527473-14795303710446640', 1, 1, 'SR', NULL, NULL, NULL),
(13199, '2016-11-19 12:39:31', NULL, NULL, 4623, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 12:39:31', 'admin-1479527473-14795303710446640', 1, 0, '', NULL, NULL, NULL),
(13200, '2016-11-19 12:39:31', NULL, NULL, 4623, 0, 181, '116', 'Open Food ', 'garlick pork take away', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 12:39:31', 'admin-1479527473-14795303710446640', 1, 0, '', NULL, NULL, NULL),
(13201, '2016-11-19 11:28:14', NULL, NULL, 4622, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:28:14', 'admin-1479517334-14795260938677170', 1, 1, 'SR', NULL, NULL, NULL),
(13202, '2016-11-19 11:28:14', NULL, NULL, 4622, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:28:14', 'admin-1479517334-14795260938677170', 1, 0, '', NULL, NULL, NULL),
(13203, '2016-11-19 11:28:14', NULL, NULL, 4622, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:28:14', 'admin-1479517334-14795260938677170', 1, 0, '', NULL, NULL, NULL),
(13204, '2016-11-19 11:28:14', NULL, NULL, 4622, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:28:14', 'admin-1479517334-14795260938677170', 1, 0, '', NULL, NULL, NULL),
(13205, '2016-11-19 11:19:25', NULL, NULL, 4621, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:19:25', 'admin-1479517334-14795255648518714', 1, 0, '', NULL, NULL, NULL),
(13206, '2016-11-19 11:14:21', NULL, NULL, 4620, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:14:21', 'admin-1479517334-14795252614471291', 1, 1, 'SR', NULL, NULL, NULL),
(13207, '2016-11-19 11:19:25', NULL, NULL, 4621, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 2, 21.00, 42.0000, 0.0000, 42.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:19:25', 'admin-1479517334-14795255648518714', 1, 0, '', NULL, NULL, NULL),
(13208, '2016-11-19 11:19:25', NULL, NULL, 4621, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:19:25', 'admin-1479517334-14795255648518714', 1, 0, '', NULL, NULL, NULL),
(13209, '2016-11-19 11:14:21', NULL, NULL, 4620, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:14:21', 'admin-1479517334-14795252614471291', 1, 1, 'SR', NULL, NULL, NULL),
(13210, '2016-11-19 11:14:21', NULL, NULL, 4620, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:14:21', 'admin-1479517334-14795252614471291', 1, 1, 'SR', NULL, NULL, NULL),
(13211, '2016-11-19 11:14:21', NULL, NULL, 4620, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:14:21', 'admin-1479517334-14795252614471291', 1, 1, 'SR', NULL, NULL, NULL),
(13212, '2016-11-19 11:12:55', NULL, NULL, 4620, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:12:55', 'admin-1479517334-14795251752436555', 1, 0, '', NULL, NULL, NULL),
(13213, '2016-11-19 11:12:55', NULL, NULL, 4620, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:12:55', 'admin-1479517334-14795251752436555', 1, 0, '', NULL, NULL, NULL),
(13214, '2016-11-19 10:36:57', NULL, NULL, 4618, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 10:36:57', 'admin-1479517334-1479523016984488', 1, 0, '', NULL, NULL, NULL),
(13215, '2016-11-19 10:36:57', NULL, NULL, 4618, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 10:36:57', 'admin-1479517334-1479523016984488', 1, 0, '', NULL, NULL, NULL),
(13216, '2016-11-19 10:37:12', NULL, NULL, 4618, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 10:37:12', 'admin-1479517334-14795230323282919', 1, 1, 'SR', NULL, NULL, NULL),
(13217, '2016-11-19 11:08:26', NULL, NULL, 4619, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:08:26', 'admin-1479517334-14795249064514353', 1, 0, '', NULL, NULL, NULL),
(13218, '2016-11-19 11:08:26', NULL, NULL, 4619, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 11:08:26', 'admin-1479517334-14795249064514353', 1, 1, 'SR', NULL, NULL, NULL),
(13219, '2016-11-19 09:29:10', NULL, NULL, 4616, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 09:29:10', 'admin-1479517334-14795189501366963', 1, 0, '', NULL, NULL, NULL),
(13220, '2016-11-19 09:43:51', NULL, NULL, 4617, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 09:43:51', 'admin-1479517334-14795198317773741', 1, 1, 'SR', NULL, NULL, NULL),
(13221, '2016-11-19 09:29:20', NULL, NULL, 4616, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 09:29:20', 'admin-1479517334-14795189601531554', 1, 0, '', NULL, NULL, NULL),
(13222, '2016-11-19 09:29:20', NULL, NULL, 4616, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 09:29:20', 'admin-1479517334-14795189601531554', 1, 1, 'SR', NULL, NULL, NULL),
(13223, '2016-11-19 09:29:10', NULL, NULL, 4616, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 09:29:10', 'admin-1479517334-14795189501366963', 1, 0, '', NULL, NULL, NULL),
(13224, '2016-11-19 09:24:49', NULL, NULL, 4615, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 09:24:49', 'admin-1479517334-14795186889429872', 1, 1, 'SR', NULL, NULL, NULL),
(13225, '2016-11-19 09:24:41', NULL, NULL, 4615, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479561929', 'admin', '2016-11-19 09:24:41', 'admin-1479517334-1479518681633985', 1, 0, '', NULL, NULL, NULL),
(13226, '2016-11-20 17:39:57', NULL, NULL, 4680, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 17:39:57', 'admin-1479631118-14796347974259158', 1, 0, '', NULL, NULL, NULL),
(13227, '2016-11-20 17:39:57', NULL, NULL, 4680, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 17:39:57', 'admin-1479631118-14796347974259158', 1, 1, 'SR', NULL, NULL, NULL),
(13228, '2016-11-20 16:38:53', NULL, NULL, 4677, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 16:38:53', 'admin-1479631118-14796311334344289', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(13229, '2016-11-20 16:53:58', NULL, NULL, 4678, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 16:53:58', 'admin-1479631118-1479632037990747', 1, 1, 'SR', NULL, NULL, NULL),
(13230, '2016-11-20 16:53:58', NULL, NULL, 4678, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 16:53:58', 'admin-1479631118-1479632037990747', 1, 0, '', NULL, NULL, NULL),
(13231, '2016-11-20 16:53:58', NULL, NULL, 4678, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 16:53:58', 'admin-1479631118-1479632037990747', 1, 0, '', NULL, NULL, NULL),
(13232, '2016-11-20 15:22:00', NULL, NULL, 4673, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 15:22:00', 'admin-1479619611-14796265201162738', 1, 0, '', NULL, NULL, NULL),
(13233, '2016-11-20 17:37:52', NULL, NULL, 4678, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 17:37:52', 'admin-1479631118-1479634672306245', 1, 1, 'SR', NULL, NULL, NULL),
(13234, '2016-11-20 17:26:13', NULL, NULL, 4679, 0, 190, '125', 'Tiger Bucket ', '', 'Cold Drinks', 'Soda & Beer', 1, 48.00, 48.0000, 0.0000, 48.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 17:26:13', 'admin-1479631118-14796339731127730', 1, 0, '', NULL, NULL, NULL),
(13235, '2016-11-20 15:55:07', NULL, NULL, 4675, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 15:55:07', 'admin-1479619611-1479628507120556', 1, 0, '', NULL, NULL, NULL),
(13236, '2016-11-20 16:21:52', NULL, NULL, 4676, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 16:21:52', 'admin-1479619611-14796301121297955', 1, 1, 'SR', NULL, NULL, NULL),
(13237, '2016-11-20 16:21:52', NULL, NULL, 4676, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 16:21:52', 'admin-1479619611-14796301121297955', 1, 1, 'SR', NULL, NULL, NULL),
(13238, '2016-11-20 16:22:52', NULL, NULL, 4676, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 16:22:52', 'admin-1479619611-14796301725881618', 1, 0, '', NULL, NULL, NULL),
(13239, '2016-11-20 16:22:52', NULL, NULL, 4676, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 16:22:52', 'admin-1479619611-14796301725881618', 1, 0, '', NULL, NULL, NULL),
(13240, '2016-11-20 16:37:09', NULL, NULL, 4674, 0, 181, '116', 'Open Food ', 'Penang International Dragon Boat', 'Meals', 'Perfect Meals', 1, 600.00, 600.0000, 0.0000, 600.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 16:37:09', 'admin-1479619611-14796310293121087', 1, 0, '', NULL, NULL, NULL),
(13241, '2016-11-20 16:38:53', NULL, NULL, 4677, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 16:38:53', 'admin-1479631118-14796311334344289', 1, 0, '', NULL, NULL, NULL),
(13242, '2016-11-20 16:38:53', NULL, NULL, 4677, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 16:38:53', 'admin-1479631118-14796311334344289', 1, 0, '', NULL, NULL, NULL),
(13243, '2016-11-20 14:45:33', NULL, NULL, 4671, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 14:45:33', 'admin-1479619611-14796243336924123', 1, 1, 'SR', NULL, NULL, NULL),
(13244, '2016-11-20 14:44:58', NULL, NULL, 4671, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 14:44:58', 'admin-1479619611-14796242981235046', 1, 1, 'SR', NULL, NULL, NULL),
(13245, '2016-11-20 14:40:58', NULL, NULL, 4670, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 14:40:58', 'admin-1479619611-14796240579227015', 1, 1, 'SR', NULL, NULL, NULL),
(13246, '2016-11-20 14:40:58', NULL, NULL, 4670, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 14:40:58', 'admin-1479619611-14796240579227015', 1, 1, 'SR', NULL, NULL, NULL),
(13247, '2016-11-20 13:51:45', NULL, NULL, 4662, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:51:45', 'admin-1479619611-14796211056167956', 1, 1, 'SR', NULL, NULL, NULL),
(13248, '2016-11-20 13:55:35', NULL, NULL, 4668, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:55:35', 'admin-1479619611-14796213357408612', 1, 0, '', NULL, NULL, NULL),
(13249, '2016-11-20 13:55:46', NULL, NULL, 4668, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:55:46', 'admin-1479619611-14796213464006898', 1, 1, 'SR', NULL, NULL, NULL),
(13250, '2016-11-20 14:07:36', NULL, NULL, 4662, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 14:07:36', 'admin-1479619611-14796220566433052', 1, 1, 'SR', NULL, NULL, NULL),
(13251, '2016-11-20 14:11:16', NULL, NULL, 4665, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 14:11:16', 'admin-1479619611-147962227643773', 1, 1, 'SR', NULL, NULL, NULL),
(13252, '2016-11-20 14:11:16', NULL, NULL, 4665, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 14:11:16', 'admin-1479619611-147962227643773', 1, 0, '', NULL, NULL, NULL),
(13253, '2016-11-20 14:39:17', NULL, NULL, 4669, 0, 85, '85', 'Set Sauted Mushroom Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 14:39:17', 'admin-1479619611-14796239575481273', 1, 1, 'SR', NULL, NULL, NULL),
(13254, '2016-11-20 14:39:17', NULL, NULL, 4669, 0, 82, '82', 'Set Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 14:39:17', 'admin-1479619611-14796239575481273', 1, 1, 'SR', NULL, NULL, NULL),
(13255, '2016-11-20 12:47:09', NULL, NULL, 4659, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 12:47:09', 'admin-1479613480-14796172295631311', 1, 0, '', NULL, NULL, NULL),
(13256, '2016-11-20 00:00:00', NULL, NULL, 4658, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 12:35:39', 'admin-1479613480-14796165392504289', 1, 0, '', NULL, NULL, NULL),
(13257, '2016-11-20 00:00:00', NULL, NULL, 4658, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 12:35:39', 'admin-1479613480-14796165392504289', 1, 1, 'SR', NULL, NULL, NULL),
(13258, '2016-11-20 12:47:09', NULL, NULL, 4659, 0, 153, '87', 'Big Breakfast ', 'without mashed potato add toast', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 12:47:09', 'admin-1479613480-14796172295631311', 1, 0, '', NULL, NULL, NULL),
(13259, '2016-11-20 12:47:09', NULL, NULL, 4659, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 12:47:09', 'admin-1479613480-14796172295631311', 1, 0, '', NULL, NULL, NULL),
(13260, '2016-11-20 12:47:09', NULL, NULL, 4659, 0, 181, '116', 'Open Food ', 'crispy bacon aglio no chili', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 12:47:09', 'admin-1479613480-14796172295631311', 1, 0, '', NULL, NULL, NULL),
(13261, '2016-11-20 12:49:08', NULL, NULL, 4660, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 12:49:08', 'admin-1479613480-14796173481195556', 1, 1, 'SR', NULL, NULL, NULL),
(13262, '2016-11-20 12:49:08', NULL, NULL, 4660, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 12:49:08', 'admin-1479613480-14796173481195556', 1, 1, 'SR', NULL, NULL, NULL),
(13263, '2016-11-20 13:20:38', NULL, NULL, 4659, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:20:38', 'admin-1479613480-14796192383748777', 1, 0, '', NULL, NULL, NULL),
(13264, '2016-11-20 17:26:13', NULL, NULL, 4679, 0, 190, '125', 'Tiger Bucket ', '', 'Cold Drinks', 'Soda & Beer', 1, 48.00, 48.0000, 0.0000, 48.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 17:26:13', 'admin-1479631118-14796339731127730', 1, 0, '', NULL, NULL, NULL),
(13265, '2016-11-20 17:15:23', NULL, NULL, 4678, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 17:15:23', 'admin-1479631118-14796333229032555', 1, 1, 'SR', NULL, NULL, NULL),
(13266, '2016-11-20 15:38:31', NULL, NULL, 4674, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 15:38:31', 'admin-1479619611-14796275115966242', 1, 0, '', NULL, NULL, NULL),
(13267, '2016-11-20 15:38:50', NULL, NULL, 4674, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 15:38:50', 'admin-1479619611-14796275304374836', 1, 0, '', NULL, NULL, NULL),
(13268, '2016-11-20 15:25:09', NULL, NULL, 4673, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 15:25:09', 'admin-1479619611-14796267096472656', 1, 0, '', NULL, NULL, NULL),
(13269, '2016-11-20 15:37:48', NULL, NULL, 4674, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 15:37:48', 'admin-1479619611-1479627468553916', 1, 1, 'SR', NULL, NULL, NULL),
(13270, '2016-11-20 15:37:48', NULL, NULL, 4674, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 15:37:48', 'admin-1479619611-1479627468553916', 1, 1, 'SR', NULL, NULL, NULL),
(13271, '2016-11-20 15:37:48', NULL, NULL, 4674, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 15:37:48', 'admin-1479619611-1479627468553916', 1, 1, 'SR', NULL, NULL, NULL),
(13272, '2016-11-20 13:23:22', NULL, NULL, 4662, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:23:22', 'admin-1479613480-14796194025315154', 1, 0, '', NULL, NULL, NULL),
(13273, '2016-11-20 13:24:39', NULL, NULL, 4663, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:24:39', 'admin-1479613480-14796194792201629', 1, 1, 'SR', NULL, NULL, NULL),
(13274, '2016-11-20 13:25:16', NULL, NULL, 4664, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:25:16', 'admin-1479613480-14796195160948097', 1, 1, 'SR', NULL, NULL, NULL),
(13275, '2016-11-20 13:25:16', NULL, NULL, 4664, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:25:16', 'admin-1479613480-14796195160948097', 1, 0, '', NULL, NULL, NULL),
(13276, '2016-11-20 13:26:20', NULL, NULL, 4665, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:26:20', 'admin-1479613480-14796195802508156', 1, 0, '', NULL, NULL, NULL),
(13277, '2016-11-20 13:26:20', NULL, NULL, 4665, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:26:20', 'admin-1479613480-14796195802508156', 1, 0, '', NULL, NULL, NULL),
(13278, '2016-11-20 13:27:06', NULL, NULL, 4665, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:27:06', 'admin-1479619611-14796196264247124', 1, 1, 'SR', NULL, NULL, NULL),
(13279, '2016-11-20 13:27:06', NULL, NULL, 4665, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:27:06', 'admin-1479619611-14796196264247124', 1, 0, '', NULL, NULL, NULL),
(13280, '2016-11-20 13:27:45', NULL, NULL, 4659, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:27:45', 'admin-1479619611-14796196648636294', 1, 1, 'SR', NULL, NULL, NULL),
(13281, '2016-11-20 13:39:29', NULL, NULL, 4662, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:39:29', 'admin-1479619611-14796203695219647', 1, 0, '', NULL, NULL, NULL),
(13282, '2016-11-20 13:49:19', NULL, NULL, 4662, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:49:19', 'admin-1479619611-14796209588852856', 1, 1, 'SR', NULL, NULL, NULL),
(13283, '2016-11-20 14:46:32', NULL, NULL, 4672, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 14:46:32', 'admin-1479619611-14796243919457935', 1, 0, '', NULL, NULL, NULL),
(13284, '2016-11-20 15:21:05', NULL, NULL, 4673, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 15:21:05', 'admin-1479619611-1479626465223183', 1, 0, '', NULL, NULL, NULL),
(13285, '2016-11-20 13:50:37', NULL, NULL, 4667, 0, 79, '79', 'Summer Salad ', 'add toast', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:50:37', 'admin-1479619611-14796210368489366', 1, 1, 'SR', NULL, NULL, NULL),
(13286, '2016-11-20 13:23:22', NULL, NULL, 4662, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:23:22', 'admin-1479613480-14796194025315154', 1, 1, 'SR', NULL, NULL, NULL),
(13287, '2016-11-20 13:23:22', NULL, NULL, 4662, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:23:22', 'admin-1479613480-14796194025315154', 1, 1, 'SR', NULL, NULL, NULL),
(13288, '2016-11-20 13:23:22', NULL, NULL, 4662, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:23:22', 'admin-1479613480-14796194025315154', 1, 0, '', NULL, NULL, NULL),
(13289, '2016-11-20 13:23:22', NULL, NULL, 4662, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:23:22', 'admin-1479613480-14796194025315154', 1, 0, '', NULL, NULL, NULL),
(13290, '2016-11-20 13:23:22', NULL, NULL, 4662, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:23:22', 'admin-1479613480-14796194025315154', 1, 1, 'SR', NULL, NULL, NULL),
(13291, '2016-11-20 13:23:22', NULL, NULL, 4662, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:23:22', 'admin-1479613480-14796194025315154', 1, 1, 'SR', NULL, NULL, NULL),
(13292, '2016-11-20 13:23:22', NULL, NULL, 4662, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:23:22', 'admin-1479613480-14796194025315154', 1, 1, 'SR', NULL, NULL, NULL),
(13293, '2016-11-20 13:23:22', NULL, NULL, 4662, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:23:22', 'admin-1479613480-14796194025315154', 1, 1, 'SR', NULL, NULL, NULL),
(13294, '2016-11-20 13:23:22', NULL, NULL, 4662, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:23:22', 'admin-1479613480-14796194025315154', 1, 1, 'SR', NULL, NULL, NULL),
(13295, '2016-11-20 13:23:22', NULL, NULL, 4662, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:23:22', 'admin-1479613480-14796194025315154', 1, 1, 'SR', NULL, NULL, NULL),
(13296, '2016-11-20 13:22:38', NULL, NULL, 4661, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 13:22:38', 'admin-1479613480-14796193584188738', 1, 0, '', 1, NULL, NULL),
(13297, '2016-11-20 11:49:11', NULL, NULL, 4655, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 11:49:11', 'admin-1479613480-14796137509636730', 1, 0, '', NULL, NULL, NULL),
(13298, '2016-11-20 00:00:00', NULL, NULL, 4656, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 11:26:13', 'admin-1479610064-14796123728262625', 1, 0, '', NULL, NULL, NULL),
(13299, '2016-11-20 11:49:11', NULL, NULL, 4655, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 11:49:11', 'admin-1479613480-14796137509636730', 1, 1, 'SR', NULL, NULL, NULL),
(13300, '2016-11-20 11:49:11', NULL, NULL, 4655, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 11:49:11', 'admin-1479613480-14796137509636730', 1, 1, 'SR', NULL, NULL, NULL),
(13301, '2016-11-20 11:45:53', NULL, NULL, 4649, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 11:45:53', 'admin-1479613480-14796135535873538', 1, 1, 'SR', NULL, NULL, NULL),
(13302, '2016-11-20 11:45:53', NULL, NULL, 4649, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 11:45:53', 'admin-1479613480-14796135535873538', 1, 0, '', NULL, NULL, NULL),
(13303, '2016-11-20 11:43:59', NULL, NULL, 4654, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 11:43:59', 'admin-1479610064-14796134393467269', 1, 0, '', NULL, NULL, NULL),
(13304, '2016-11-20 11:32:06', NULL, NULL, 4653, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 11:32:06', 'admin-1479610064-1479612725838907', 1, 0, '', NULL, NULL, NULL),
(13305, '2016-11-20 11:31:18', NULL, NULL, 4652, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 11:31:18', 'admin-1479610064-14796126778807333', 1, 1, 'SR', NULL, NULL, NULL),
(13306, '2016-11-20 10:47:35', NULL, NULL, 4647, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 10:47:35', 'admin-1479603519-14796100550462049', 1, 0, '', NULL, NULL, NULL),
(13307, '2016-11-20 10:47:56', NULL, NULL, 4647, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 10:47:56', 'admin-1479610064-1479610075954617', 1, 1, 'SR', NULL, NULL, NULL),
(13308, '2016-11-20 12:25:54', NULL, NULL, 4654, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 12:25:54', 'admin-1479613480-14796159542076025', 1, 1, 'SR', NULL, NULL, NULL),
(13309, '2016-11-20 00:00:00', NULL, NULL, 4657, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 10:55:42', 'admin-1479610064-14796105427119920', 1, 0, '', NULL, NULL, NULL),
(13310, '2016-11-20 00:00:00', NULL, NULL, 4657, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 10:55:42', 'admin-1479610064-14796105427119920', 1, 0, '', NULL, NULL, NULL),
(13311, '2016-11-20 00:00:00', NULL, NULL, 4657, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 10:56:09', 'admin-1479610064-14796105689533383', 1, 1, 'SR', NULL, NULL, NULL),
(13312, '2016-11-20 00:00:00', NULL, NULL, 4656, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 11:01:18', 'admin-1479610064-14796108786049093', 1, 0, '', NULL, NULL, NULL),
(13313, '2016-11-20 00:00:00', NULL, NULL, 4657, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 10:56:09', 'admin-1479610064-14796105689533383', 1, 1, 'SR', NULL, NULL, NULL),
(13314, '2016-11-20 11:20:27', NULL, NULL, 4649, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 11:20:27', 'admin-1479610064-14796120277395981', 1, 0, '', NULL, NULL, NULL),
(13315, '2016-11-20 11:20:37', NULL, NULL, 4649, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 11:20:37', 'admin-1479610064-14796120371135661', 1, 1, 'SR', NULL, NULL, NULL),
(13316, '2016-11-20 00:00:00', NULL, NULL, 4656, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 10:56:09', 'admin-1479610064-14796105689533383', 1, 0, '', NULL, NULL, NULL),
(13317, '2016-11-20 11:26:23', NULL, NULL, 4650, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 11:26:23', 'admin-1479610064-14796123831297484', 1, 1, 'SR', NULL, NULL, NULL),
(13318, '2016-11-20 11:26:23', NULL, NULL, 4650, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 11:26:23', 'admin-1479610064-14796123831297484', 1, 1, 'SR', NULL, NULL, NULL),
(13319, '2016-11-20 11:30:26', NULL, NULL, 4651, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 11:30:26', 'admin-1479610064-14796126268086782', 1, 0, '', NULL, NULL, NULL),
(13320, '2016-11-20 11:31:18', NULL, NULL, 4652, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 11:31:18', 'admin-1479610064-14796126778807333', 1, 1, 'SR', NULL, NULL, NULL),
(13321, '2016-11-20 11:31:18', NULL, NULL, 4652, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 11:31:18', 'admin-1479610064-14796126778807333', 1, 0, '', NULL, NULL, NULL),
(13322, '2016-11-20 10:47:35', NULL, NULL, 4647, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 10:47:35', 'admin-1479603519-14796100550462049', 1, 0, '', NULL, NULL, NULL),
(13323, '2016-11-20 10:41:48', NULL, NULL, 4646, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 10:41:48', 'admin-1479603519-14796097080664228', 1, 1, 'SR', NULL, NULL, NULL),
(13324, '2016-11-20 10:41:48', NULL, NULL, 4646, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 10:41:48', 'admin-1479603519-14796097080664228', 1, 1, 'SR', NULL, NULL, NULL),
(13325, '2016-11-20 10:40:28', NULL, NULL, 4646, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 10:40:28', 'admin-1479603519-1479609627861354', 1, 0, '', NULL, NULL, NULL),
(13326, '2016-11-20 10:40:28', NULL, NULL, 4646, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 10:40:28', 'admin-1479603519-1479609627861354', 1, 0, '', NULL, NULL, NULL),
(13327, '2016-11-20 10:40:54', NULL, NULL, 4646, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 10:40:54', 'admin-1479603519-14796096540456444', 1, 1, 'SR', NULL, NULL, NULL),
(13328, '2016-11-20 10:40:54', NULL, NULL, 4646, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 10:40:54', 'admin-1479603519-14796096540456444', 1, 0, '', NULL, NULL, NULL),
(13329, '2016-11-20 10:06:57', NULL, NULL, 4645, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 10:06:57', 'admin-1479603519-14796076170443378', 1, 1, 'SR', NULL, NULL, NULL),
(13330, '2016-11-20 10:06:57', NULL, NULL, 4645, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 10:06:57', 'admin-1479603519-14796076170443378', 1, 1, 'SR', NULL, NULL, NULL),
(13331, '2016-11-20 10:06:57', NULL, NULL, 4645, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 10:06:57', 'admin-1479603519-14796076170443378', 1, 0, '', NULL, NULL, NULL),
(13332, '2016-11-20 09:58:50', NULL, NULL, 4644, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 09:58:50', 'admin-1479603519-1479607130159548', 1, 1, 'SR', NULL, NULL, NULL),
(13333, '2016-11-20 10:06:57', NULL, NULL, 4645, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 10:06:57', 'admin-1479603519-14796076170443378', 1, 0, '', NULL, NULL, NULL),
(13334, '2016-11-20 09:15:02', NULL, NULL, 4641, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 09:15:02', 'admin-1479603519-14796045022546945', 1, 0, '', NULL, NULL, NULL),
(13335, '2016-11-20 09:15:02', NULL, NULL, 4641, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 09:15:02', 'admin-1479603519-14796045022546945', 1, 0, '', NULL, NULL, NULL),
(13336, '2016-11-20 09:15:02', NULL, NULL, 4641, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 09:15:02', 'admin-1479603519-14796045022546945', 1, 0, '', NULL, NULL, NULL),
(13337, '2016-11-20 09:15:02', NULL, NULL, 4641, 0, 156, '90', 'Cheese Omelet', 'without toast add sausage', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 09:15:02', 'admin-1479603519-14796045022546945', 1, 0, '', NULL, NULL, NULL),
(13338, '2016-11-20 09:58:03', NULL, NULL, 4643, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 09:58:03', 'admin-1479603519-14796070835774413', 1, 1, 'SR', NULL, NULL, NULL),
(13339, '2016-11-20 09:49:10', NULL, NULL, 4642, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 09:49:10', 'admin-1479603519-14796065501758392', 1, 0, '', NULL, NULL, NULL),
(13340, '2016-11-20 09:49:10', NULL, NULL, 4642, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 09:49:10', 'admin-1479603519-14796065501758392', 1, 1, 'SR', NULL, NULL, NULL),
(13341, '2016-11-20 09:49:10', NULL, NULL, 4642, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 09:49:10', 'admin-1479603519-14796065501758392', 1, 1, 'SR', NULL, NULL, NULL),
(13342, '2016-11-20 09:49:10', NULL, NULL, 4642, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 09:49:10', 'admin-1479603519-14796065501758392', 1, 1, 'SR', NULL, NULL, NULL),
(13343, '2016-11-20 09:49:10', NULL, NULL, 4642, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 09:49:10', 'admin-1479603519-14796065501758392', 1, 1, 'SR', NULL, NULL, NULL),
(13344, '2016-11-20 09:12:53', NULL, NULL, 4640, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 09:12:53', 'admin-1479603519-14796043733414133', 1, 1, 'SR', NULL, NULL, NULL),
(13345, '2016-11-20 09:07:03', NULL, NULL, 4640, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479631118', 'admin', '2016-11-20 09:07:03', 'admin-1479603519-1479604023436586', 1, 0, '', NULL, NULL, NULL),
(13346, '2016-11-21 20:12:16', NULL, NULL, 4720, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 20:12:16', 'admin-1479729787-14797303365558394', 1, 0, '', NULL, NULL, NULL),
(13347, '2016-11-21 20:03:24', NULL, NULL, 4719, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 20:03:24', 'admin-1479729787-14797298043373565', 1, 0, '', NULL, NULL, NULL),
(13348, '2016-11-21 19:59:00', NULL, NULL, 4720, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 19:59:00', 'admin-1479727483-1479729540632453', 1, 1, 'SR', NULL, NULL, NULL),
(13349, '2016-11-21 20:02:55', NULL, NULL, 4718, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 20:02:55', 'admin-1479727483-14797297754721777', 1, 0, '', NULL, NULL, NULL),
(13350, '2016-11-21 19:57:54', NULL, NULL, 4720, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 19:57:54', 'admin-1479727483-14797294743524543', 1, 0, '', NULL, NULL, NULL),
(13351, '2016-11-21 19:41:46', NULL, NULL, 4719, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 19:41:46', 'admin-1479727483-14797285058065011', 1, 1, 'SR', NULL, NULL, NULL),
(13352, '2016-11-21 19:41:46', NULL, NULL, 4719, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 19:41:46', 'admin-1479727483-14797285058065011', 1, 1, 'SR', NULL, NULL, NULL),
(13353, '2016-11-21 19:41:46', NULL, NULL, 4719, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 19:41:46', 'admin-1479727483-14797285058065011', 1, 1, 'SR', NULL, NULL, NULL),
(13354, '2016-11-21 19:41:45', NULL, NULL, 4719, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 19:41:46', 'admin-1479727483-14797285058065011', 1, 1, 'SR', NULL, NULL, NULL),
(13355, '2016-11-21 19:25:17', NULL, NULL, 4718, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 19:25:17', 'admin-1479727483-1479727517477787', 1, 1, 'SR', NULL, NULL, NULL),
(13356, '2016-11-21 19:25:17', NULL, NULL, 4718, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 19:25:17', 'admin-1479727483-1479727517477787', 1, 1, 'SR', NULL, NULL, NULL),
(13357, '2016-11-21 19:25:08', NULL, NULL, 4718, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 19:25:08', 'admin-1479727483-14797275080975876', 1, 0, '', NULL, NULL, NULL),
(13358, '2016-11-21 19:25:08', NULL, NULL, 4718, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 19:25:08', 'admin-1479727483-14797275080975876', 1, 0, '', NULL, NULL, NULL),
(13359, '2016-11-21 19:25:08', NULL, NULL, 4718, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 19:25:08', 'admin-1479727483-14797275080975876', 1, 0, '', NULL, NULL, NULL),
(13360, '2016-11-21 19:25:08', NULL, NULL, 4718, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 19:25:08', 'admin-1479727483-14797275080975876', 1, 1, 'SR', NULL, NULL, NULL),
(13361, '2016-11-21 19:14:34', NULL, NULL, 4717, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 19:14:34', 'admin-1479725238-14797268741007852', 1, 1, 'SR', NULL, NULL, NULL),
(13362, '2016-11-21 18:09:41', NULL, NULL, 4714, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 18:09:41', 'admin-1479706880-14797229811269812', 1, 1, 'SR', NULL, NULL, NULL),
(13363, '2016-11-21 18:09:48', NULL, NULL, 4714, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 18:09:48', 'admin-1479706880-147972298788643', 1, 1, 'SR', NULL, NULL, NULL),
(13364, '2016-11-21 18:44:51', NULL, NULL, 4706, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 18:44:51', 'admin-1479706880-14797250915393697', 1, 1, 'SR', NULL, NULL, '10.0'),
(13365, '2016-11-21 18:44:51', NULL, NULL, 4706, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 18:44:51', 'admin-1479706880-14797250915393697', 1, 1, 'SR', NULL, NULL, '10.0'),
(13366, '2016-11-21 18:44:51', NULL, NULL, 4706, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 18:44:51', 'admin-1479706880-14797250915393697', 1, 0, '', NULL, NULL, '10.0'),
(13367, '2016-11-21 18:44:51', NULL, NULL, 4706, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 18:44:51', 'admin-1479706880-14797250915393697', 1, 1, 'SR', NULL, NULL, '10.0'),
(13368, '2016-11-21 18:47:11', NULL, NULL, 4715, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 18:47:11', 'admin-1479706880-14797252317658090', 1, 1, 'SR', NULL, NULL, NULL),
(13369, '2016-11-21 19:06:31', NULL, NULL, 4715, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 19:06:31', 'admin-1479725238-14797263908728256', 1, 1, 'SR', NULL, NULL, NULL),
(13370, '2016-11-21 17:00:37', NULL, NULL, 4713, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 17:00:37', 'admin-1479706880-14797188373587226', 1, 1, 'SR', NULL, NULL, NULL),
(13371, '2016-11-21 17:00:37', NULL, NULL, 4713, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 17:00:37', 'admin-1479706880-14797188373587226', 1, 1, 'SR', NULL, NULL, NULL),
(13372, '2016-11-21 17:16:38', NULL, NULL, 4714, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 17:16:38', 'admin-1479706880-14797197985755648', 1, 1, 'SR', NULL, NULL, NULL),
(13373, '2016-11-21 18:47:47', NULL, NULL, 4715, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 18:47:47', 'admin-1479725238-14797252676444411', 1, 1, 'SR', NULL, NULL, NULL),
(13374, '2016-11-21 13:59:08', NULL, NULL, 4704, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:59:08', 'admin-1479706880-1479707948649112', 1, 1, 'SR', NULL, NULL, NULL),
(13375, '2016-11-21 17:45:42', NULL, NULL, 4714, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 17:45:42', 'admin-1479706880-1479721542531957', 1, 1, 'SR', NULL, NULL, NULL),
(13376, '2016-11-21 16:37:13', NULL, NULL, 4712, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 16:37:13', 'admin-1479706880-14797174330812526', 1, 1, 'SR', NULL, NULL, NULL),
(13377, '2016-11-21 14:59:48', NULL, NULL, 4707, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 14:59:49', 'admin-1479706880-1479711588778485', 1, 1, 'SR', NULL, NULL, NULL),
(13378, '2016-11-21 14:59:49', NULL, NULL, 4707, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 14:59:49', 'admin-1479706880-1479711588778485', 1, 1, 'SR', NULL, NULL, NULL),
(13379, '2016-11-21 14:59:49', NULL, NULL, 4707, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 14:59:49', 'admin-1479706880-1479711588778485', 1, 0, '', NULL, NULL, NULL),
(13380, '2016-11-21 15:36:20', NULL, NULL, 4708, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 15:36:20', 'admin-1479706880-14797137802165965', 1, 1, 'SR', NULL, NULL, NULL),
(13381, '2016-11-21 15:36:20', NULL, NULL, 4708, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 15:36:20', 'admin-1479706880-14797137802165965', 1, 1, 'SR', NULL, NULL, NULL),
(13382, '2016-11-21 15:36:20', NULL, NULL, 4708, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 15:36:20', 'admin-1479706880-14797137802165965', 1, 0, '', NULL, NULL, NULL),
(13383, '2016-11-21 15:46:10', NULL, NULL, 4709, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 15:46:10', 'admin-1479706880-1479714369905619', 1, 1, 'SR', NULL, NULL, NULL),
(13384, '2016-11-21 15:46:10', NULL, NULL, 4709, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 15:46:10', 'admin-1479706880-1479714369905619', 1, 0, '', NULL, NULL, NULL),
(13385, '2016-11-21 15:46:10', NULL, NULL, 4709, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 15:46:10', 'admin-1479706880-1479714369905619', 1, 0, '', NULL, NULL, NULL),
(13386, '2016-11-21 15:48:30', NULL, NULL, 4710, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 15:48:30', 'admin-1479706880-1479714510250366', 1, 1, 'SR', 1, NULL, NULL),
(13387, '2016-11-21 15:48:30', NULL, NULL, 4710, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 15:48:30', 'admin-1479706880-1479714510250366', 1, 1, 'SR', 1, NULL, NULL),
(13388, '2016-11-21 16:37:13', NULL, NULL, 4712, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 16:37:13', 'admin-1479706880-14797174330812526', 1, 1, 'SR', NULL, NULL, NULL),
(13389, '2016-11-21 16:37:13', NULL, NULL, 4712, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 16:37:13', 'admin-1479706880-14797174330812526', 1, 0, '', NULL, NULL, NULL),
(13390, '2016-11-21 13:54:49', NULL, NULL, 4702, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:54:49', 'admin-1479706880-14797076896653880', 1, 0, '', NULL, NULL, NULL),
(13391, '2016-11-21 13:54:49', NULL, NULL, 4702, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:54:49', 'admin-1479706880-14797076896653880', 1, 0, '', NULL, NULL, NULL),
(13392, '2016-11-21 14:14:24', NULL, NULL, 4701, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 14:14:24', 'admin-1479706880-14797088646678149', 1, 1, 'SR', NULL, NULL, NULL),
(13393, '2016-11-21 13:57:15', NULL, NULL, 4703, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:57:15', 'admin-1479706880-14797078352488217', 1, 0, '', NULL, NULL, NULL),
(13394, '2016-11-21 13:57:48', NULL, NULL, 4703, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:57:48', 'admin-1479706880-14797078682454665', 1, 0, '', NULL, NULL, NULL),
(13395, '2016-11-21 13:57:48', NULL, NULL, 4703, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:57:48', 'admin-1479706880-14797078682454665', 1, 1, 'SR', NULL, NULL, NULL),
(13396, '2016-11-21 13:57:48', NULL, NULL, 4703, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:57:48', 'admin-1479706880-14797078682454665', 1, 1, 'SR', NULL, NULL, NULL),
(13397, '2016-11-21 13:59:08', NULL, NULL, 4704, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:59:08', 'admin-1479706880-1479707948649112', 1, 0, '', NULL, NULL, NULL),
(13398, '2016-11-21 12:08:47', NULL, NULL, 4692, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:08:47', 'admin-1479700465-147970132697826', 1, 0, '', NULL, NULL, NULL),
(13399, '2016-11-21 12:09:39', NULL, NULL, 4692, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:09:39', 'admin-1479700465-14797013790732324', 1, 1, 'SR', NULL, NULL, NULL),
(13400, '2016-11-21 12:10:45', NULL, NULL, 4693, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:10:45', 'admin-1479700465-1479701445763349', 1, 0, '', NULL, NULL, NULL),
(13401, '2016-11-21 12:10:45', NULL, NULL, 4693, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:10:45', 'admin-1479700465-1479701445763349', 1, 1, 'SR', NULL, NULL, NULL),
(13402, '2016-11-21 12:10:45', NULL, NULL, 4693, 0, 187, '122', 'Iced Tea ', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:10:45', 'admin-1479700465-1479701445763349', 1, 0, '', NULL, NULL, NULL),
(13403, '2016-11-21 12:16:23', NULL, NULL, 4694, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:16:23', 'admin-1479700465-1479701783385442', 1, 1, 'SR', NULL, NULL, NULL),
(13404, '2016-11-21 12:16:23', NULL, NULL, 4694, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:16:23', 'admin-1479700465-1479701783385442', 1, 1, 'SR', NULL, NULL, NULL),
(13405, '2016-11-21 12:17:23', NULL, NULL, 4694, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:17:23', 'admin-1479700465-14797018437134255', 1, 1, 'SR', NULL, NULL, NULL),
(13406, '2016-11-21 12:17:23', NULL, NULL, 4694, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:17:23', 'admin-1479700465-14797018437134255', 1, 1, 'SR', NULL, NULL, NULL),
(13407, '2016-11-21 19:13:31', NULL, NULL, 4716, 0, 181, '116', 'Open Food ', 'apples', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 19:13:31', 'admin-1479725238-14797268112395874', 1, 0, '', NULL, NULL, NULL),
(13408, '2016-11-21 19:13:31', NULL, NULL, 4716, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 19:13:31', 'admin-1479725238-14797268112395874', 1, 0, '', NULL, NULL, NULL),
(13409, '2016-11-21 16:35:32', NULL, NULL, 4711, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 16:35:32', 'admin-1479706880-14797173323522758', 1, 1, 'SR', NULL, NULL, NULL),
(13410, '2016-11-21 16:35:50', NULL, NULL, 4711, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 16:35:50', 'admin-1479706880-14797173501644768', 1, 1, 'SR', NULL, NULL, NULL),
(13411, '2016-11-21 16:37:13', NULL, NULL, 4712, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 16:37:13', 'admin-1479706880-14797174330812526', 1, 1, 'SR', NULL, NULL, NULL),
(13412, '2016-11-21 14:03:20', NULL, NULL, 4705, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 14:03:20', 'admin-1479706880-14797082002396498', 1, 0, '', NULL, NULL, NULL),
(13413, '2016-11-21 14:15:56', NULL, NULL, 4698, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 14:15:56', 'admin-1479706880-14797089561671841', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(13414, '2016-11-21 14:47:58', NULL, NULL, 4700, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 14:47:58', 'admin-1479706880-14797108781114664', 1, 1, 'SR', NULL, NULL, '10.0'),
(13415, '2016-11-21 14:47:58', NULL, NULL, 4700, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 14:47:58', 'admin-1479706880-14797108781114664', 1, 1, 'SR', NULL, NULL, '10.0'),
(13416, '2016-11-21 14:59:21', NULL, NULL, 4706, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 14:59:21', 'admin-1479706880-14797115611652731', 1, 1, 'SR', NULL, NULL, '10.0'),
(13417, '2016-11-21 13:29:01', NULL, NULL, 4699, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:29:01', 'admin-1479704386-14797061414073998', 1, 1, 'SR', NULL, NULL, NULL),
(13418, '2016-11-21 13:29:01', NULL, NULL, 4699, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:29:01', 'admin-1479704386-14797061414073998', 1, 1, 'SR', NULL, NULL, NULL),
(13419, '2016-11-21 13:35:44', NULL, NULL, 4695, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:35:44', 'admin-1479704386-14797065438386876', 1, 0, '', NULL, NULL, NULL),
(13420, '2016-11-21 13:38:42', NULL, NULL, 4700, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:38:42', 'admin-1479704386-14797067222147392', 1, 0, '', NULL, NULL, '10.0'),
(13421, '2016-11-21 13:39:37', NULL, NULL, 4700, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:39:37', 'admin-1479704386-14797067771873577', 1, 1, 'SR', NULL, NULL, '10.0'),
(13422, '2016-11-21 13:47:45', NULL, NULL, 4701, 0, 187, '122', 'Iced Tea ', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:47:45', 'admin-1479706880-14797072653838423', 1, 0, '', NULL, NULL, NULL),
(13423, '2016-11-21 13:52:46', NULL, NULL, 4699, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:52:46', 'admin-1479706880-14797075658655762', 1, 1, 'SR', NULL, NULL, NULL),
(13424, '2016-11-21 13:52:46', NULL, NULL, 4699, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:52:46', 'admin-1479706880-14797075658655762', 1, 1, 'SR', NULL, NULL, NULL),
(13425, '2016-11-21 13:54:39', NULL, NULL, 4697, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:54:39', 'admin-1479706880-14797076790229996', 1, 0, '', NULL, NULL, NULL),
(13426, '2016-11-21 13:54:49', NULL, NULL, 4702, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:54:49', 'admin-1479706880-14797076896653880', 1, 1, 'SR', NULL, NULL, NULL),
(13427, '2016-11-21 13:54:49', NULL, NULL, 4702, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:54:49', 'admin-1479706880-14797076896653880', 1, 1, 'SR', NULL, NULL, NULL),
(13428, '2016-11-21 14:03:20', NULL, NULL, 4705, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 14:03:20', 'admin-1479706880-14797082002396498', 1, 1, 'SR', NULL, NULL, NULL),
(13429, '2016-11-21 13:59:08', NULL, NULL, 4704, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:59:08', 'admin-1479706880-1479707948649112', 1, 0, '', NULL, NULL, NULL),
(13430, '2016-11-21 13:59:08', NULL, NULL, 4704, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:59:08', 'admin-1479706880-1479707948649112', 1, 1, 'SR', NULL, NULL, NULL),
(13431, '2016-11-21 13:15:37', NULL, NULL, 4697, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:15:37', 'admin-1479704386-14797053369355080', 1, 0, '', NULL, NULL, NULL),
(13432, '2016-11-21 13:15:37', NULL, NULL, 4697, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:15:37', 'admin-1479704386-14797053369355080', 1, 1, 'SR', NULL, NULL, NULL),
(13433, '2016-11-21 13:15:37', NULL, NULL, 4697, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:15:37', 'admin-1479704386-14797053369355080', 1, 1, 'SR', NULL, NULL, NULL),
(13434, '2016-11-21 13:17:07', NULL, NULL, 4698, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:17:07', 'admin-1479704386-14797054270093981', 1, 1, 'SR', NULL, NULL, NULL),
(13435, '2016-11-21 13:17:07', NULL, NULL, 4698, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:17:07', 'admin-1479704386-14797054270093981', 1, 0, '', NULL, NULL, NULL),
(13436, '2016-11-21 13:17:39', NULL, NULL, 4698, 0, 181, '116', 'Open Food ', 'lemony chicken add rice', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:17:39', 'admin-1479704386-14797054595667778', 1, 0, '', NULL, NULL, NULL),
(13437, '2016-11-21 13:19:36', NULL, NULL, 4690, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:19:36', 'admin-1479704386-14797055758448950', 1, 1, 'SR', NULL, NULL, NULL),
(13438, '2016-11-21 13:15:37', NULL, NULL, 4697, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:15:37', 'admin-1479704386-14797053369355080', 1, 0, '', NULL, NULL, NULL),
(13439, '2016-11-21 13:05:12', NULL, NULL, 4697, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:05:12', 'admin-1479704386-14797047124136561', 1, 1, 'SR', NULL, NULL, NULL),
(13440, '2016-11-21 13:13:40', NULL, NULL, 4696, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:13:40', 'admin-1479704386-14797052207501963', 1, 0, '', NULL, NULL, NULL),
(13441, '2016-11-21 13:05:12', NULL, NULL, 4697, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:05:12', 'admin-1479704386-14797047124136561', 1, 1, 'SR', NULL, NULL, NULL),
(13442, '2016-11-21 13:00:18', NULL, NULL, 4696, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:00:18', 'admin-1479704386-14797044181961282', 1, 1, 'SR', NULL, NULL, NULL),
(13443, '2016-11-21 13:00:18', NULL, NULL, 4696, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 13:00:18', 'admin-1479704386-14797044181961282', 1, 0, '', NULL, NULL, NULL),
(13444, '2016-11-21 12:59:40', NULL, NULL, 4696, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:59:40', 'admin-1479700465-14797043801934655', 1, 0, '', NULL, NULL, NULL),
(13445, '2016-11-21 12:36:30', NULL, NULL, 4695, 0, 82, '82', 'Set Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:36:30', 'admin-1479700465-14797029905773857', 1, 1, 'SR', NULL, NULL, NULL),
(13446, '2016-11-21 12:36:30', NULL, NULL, 4695, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:36:30', 'admin-1479700465-14797029905773857', 1, 1, 'SR', NULL, NULL, NULL),
(13447, '2016-11-21 12:18:07', NULL, NULL, 4694, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:18:07', 'admin-1479700465-14797018869434945', 1, 1, 'SR', NULL, NULL, NULL),
(13448, '2016-11-21 12:18:44', NULL, NULL, 4694, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:18:44', 'admin-1479700465-1479701924497237', 1, 0, '', NULL, NULL, NULL),
(13449, '2016-11-21 12:36:30', NULL, NULL, 4695, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:36:30', 'admin-1479700465-14797029905773857', 1, 1, 'SR', NULL, NULL, NULL),
(13450, '2016-11-21 12:18:07', NULL, NULL, 4694, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:18:07', 'admin-1479700465-14797018869434945', 1, 1, 'SR', NULL, NULL, NULL),
(13451, '2016-11-21 11:06:44', NULL, NULL, 4688, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 11:06:44', 'admin-1479695078-1479697603981641', 1, 0, '', NULL, NULL, NULL),
(13452, '2016-11-21 11:06:44', NULL, NULL, 4688, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 11:06:44', 'admin-1479695078-1479697603981641', 1, 1, 'SR', NULL, NULL, NULL),
(13453, '2016-11-21 11:06:44', NULL, NULL, 4688, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 11:06:44', 'admin-1479695078-1479697603981641', 1, 1, 'SR', NULL, NULL, NULL),
(13454, '2016-11-21 11:17:23', NULL, NULL, 4689, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 11:17:23', 'admin-1479695078-14796982432332677', 1, 1, 'SR', NULL, NULL, NULL),
(13455, '2016-11-21 11:54:15', NULL, NULL, 4690, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 11:54:15', 'admin-1479695078-14797004552424011', 1, 0, '', NULL, NULL, NULL),
(13456, '2016-11-21 11:54:34', NULL, NULL, 4690, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 11:54:34', 'admin-1479700465-14797004739339122', 1, 1, 'SR', NULL, NULL, NULL),
(13457, '2016-11-21 12:07:37', NULL, NULL, 4691, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:07:37', 'admin-1479700465-14797012576875275', 1, 1, 'SR', NULL, NULL, NULL),
(13458, '2016-11-21 12:07:37', NULL, NULL, 4691, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:07:37', 'admin-1479700465-14797012576875275', 1, 1, 'SR', NULL, NULL, NULL),
(13459, '2016-11-21 12:07:37', NULL, NULL, 4691, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:07:37', 'admin-1479700465-14797012576875275', 1, 0, '', NULL, NULL, NULL),
(13460, '2016-11-21 12:07:37', NULL, NULL, 4691, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:07:37', 'admin-1479700465-14797012576875275', 1, 0, '', NULL, NULL, NULL),
(13461, '2016-11-21 12:07:37', NULL, NULL, 4691, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:07:37', 'admin-1479700465-14797012576875275', 1, 1, 'SR', NULL, NULL, NULL),
(13462, '2016-11-21 12:08:01', NULL, NULL, 4691, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:08:01', 'admin-1479700465-14797012816502416', 1, 1, 'SR', NULL, NULL, NULL),
(13463, '2016-11-21 12:08:47', NULL, NULL, 4692, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:08:47', 'admin-1479700465-147970132697826', 1, 1, 'SR', NULL, NULL, NULL),
(13464, '2016-11-21 12:08:47', NULL, NULL, 4692, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 12:08:47', 'admin-1479700465-147970132697826', 1, 1, 'SR', NULL, NULL, NULL),
(13465, '2016-11-21 11:06:44', NULL, NULL, 4688, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 11:06:44', 'admin-1479695078-1479697603981641', 1, 1, 'SR', NULL, NULL, NULL),
(13466, '2016-11-21 11:06:44', NULL, NULL, 4688, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 11:06:44', 'admin-1479695078-1479697603981641', 1, 0, '', NULL, NULL, NULL),
(13467, '2016-11-21 10:56:48', NULL, NULL, 4687, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 10:56:48', 'admin-1479695078-14796970081486451', 1, 1, 'SR', NULL, NULL, NULL),
(13468, '2016-11-21 10:56:48', NULL, NULL, 4687, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 10:56:48', 'admin-1479695078-14796970081486451', 1, 1, 'SR', NULL, NULL, NULL),
(13469, '2016-11-21 10:56:48', NULL, NULL, 4687, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 10:56:48', 'admin-1479695078-14796970081486451', 1, 0, '', NULL, NULL, NULL),
(13470, '2016-11-21 10:56:48', NULL, NULL, 4687, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 10:56:48', 'admin-1479695078-14796970081486451', 1, 0, '', NULL, NULL, NULL),
(13471, '2016-11-21 10:42:41', NULL, NULL, 4685, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 10:42:41', 'admin-1479695078-14796961613494722', 1, 0, '', NULL, NULL, NULL),
(13472, '2016-11-21 10:45:31', NULL, NULL, 4686, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 10:45:31', 'admin-1479695078-14796963309198135', 1, 0, '', NULL, NULL, NULL),
(13473, '2016-11-21 10:45:31', NULL, NULL, 4686, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 10:45:31', 'admin-1479695078-14796963309198135', 1, 0, '', NULL, NULL, NULL),
(13474, '2016-11-21 10:51:24', NULL, NULL, 4685, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 10:51:24', 'admin-1479695078-14796966843851133', 1, 0, '', NULL, NULL, NULL),
(13475, '2016-11-21 10:29:06', NULL, NULL, 4685, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 10:29:06', 'admin-1479695078-14796953465711428', 1, 1, 'SR', NULL, NULL, NULL),
(13476, '2016-11-21 10:29:06', NULL, NULL, 4685, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 10:29:06', 'admin-1479695078-14796953465711428', 1, 1, 'SR', NULL, NULL, NULL),
(13477, '2016-11-21 10:24:54', NULL, NULL, 4684, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 10:24:54', 'admin-1479695078-14796950937305631', 1, 1, 'SR', NULL, NULL, NULL),
(13478, '2016-11-21 10:24:22', NULL, NULL, 4684, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 10:24:22', 'admin-1479689017-14796950623133967', 1, 0, '', NULL, NULL, NULL),
(13479, '2016-11-21 10:24:54', NULL, NULL, 4684, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 10:24:54', 'admin-1479695078-14796950937305631', 1, 1, 'SR', NULL, NULL, NULL),
(13480, '2016-11-21 09:39:45', NULL, NULL, 4682, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 09:39:45', 'admin-1479689017-14796923851056155', 1, 0, '', NULL, NULL, NULL),
(13481, '2016-11-21 09:39:45', NULL, NULL, 4682, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 09:39:45', 'admin-1479689017-14796923851056155', 1, 1, 'SR', NULL, NULL, NULL),
(13482, '2016-11-21 10:08:14', NULL, NULL, 4683, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 10:08:14', 'admin-1479689017-14796940945188330', 1, 0, '', NULL, NULL, NULL),
(13483, '2016-11-21 10:08:25', NULL, NULL, 4683, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 10:08:25', 'admin-1479689017-14796941052978841', 1, 0, '', NULL, NULL, NULL),
(13484, '2016-11-21 10:09:29', NULL, NULL, 4683, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 10:09:29', 'admin-1479689017-14796941690407783', 1, 0, '', NULL, NULL, NULL),
(13485, '2016-11-21 09:39:19', NULL, NULL, 4682, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 09:39:19', 'admin-1479689017-14796923593799912', 1, 0, '', NULL, NULL, NULL),
(13486, '2016-11-21 09:19:28', NULL, NULL, 4681, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 09:19:28', 'admin-1479689017-1479691168593753', 1, 0, '', NULL, NULL, NULL),
(13487, '2016-11-21 10:24:22', NULL, NULL, 4684, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 10:24:22', 'admin-1479689017-14796950623133967', 1, 0, '', NULL, NULL, NULL),
(13488, '2016-11-21 10:09:29', NULL, NULL, 4683, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 10:09:29', 'admin-1479689017-14796941690407783', 1, 0, '', NULL, NULL, NULL),
(13489, '2016-11-21 09:19:28', NULL, NULL, 4681, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 09:19:28', 'admin-1479689017-1479691168593753', 1, 1, 'SR', NULL, NULL, NULL),
(13490, '2016-11-21 09:19:14', NULL, NULL, 4681, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 09:19:14', 'admin-1479689017-14796911546697946', 1, 0, '', NULL, NULL, NULL),
(13491, '2016-11-21 09:19:14', NULL, NULL, 4681, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1479729787', 'admin', '2016-11-21 09:19:14', 'admin-1479689017-14796911546697946', 1, 0, '', NULL, NULL, NULL),
(13492, '2016-11-23 13:36:23', NULL, NULL, 4733, 0, 214, '148', 'Set Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 13:36:23', 'admin-1479874118-14798793829834816', 1, 0, '', NULL, NULL, NULL),
(13493, '2016-11-23 14:11:23', NULL, NULL, 4734, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 14:11:23', 'admin-1479874118-14798814833473919', 1, 1, 'SR', NULL, NULL, NULL),
(13494, '2016-11-23 14:11:23', NULL, NULL, 4734, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 14:11:23', 'admin-1479874118-14798814833473919', 1, 0, '', NULL, NULL, NULL),
(13495, '2016-11-23 14:38:18', NULL, NULL, 4735, 0, 181, '116', 'Open Food ', 'Bff', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 14:38:18', 'admin-1479874118-14798830983339537', 1, 0, '', NULL, NULL, NULL),
(13496, '2016-11-23 14:38:18', NULL, NULL, 4735, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 14:38:18', 'admin-1479874118-14798830983339537', 1, 1, 'SR', NULL, NULL, NULL),
(13497, '2016-11-23 14:38:18', NULL, NULL, 4735, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 14:38:18', 'admin-1479874118-14798830983339537', 1, 1, 'SR', NULL, NULL, NULL),
(13498, '2016-11-23 14:38:18', NULL, NULL, 4735, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 14:38:18', 'admin-1479874118-14798830983339537', 1, 1, 'SR', NULL, NULL, NULL),
(13499, '2016-11-23 15:11:48', NULL, NULL, 4736, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 15:11:48', 'admin-1479874118-1479885107921321', 1, 1, 'SR', NULL, NULL, NULL),
(13500, '2016-11-23 15:11:48', NULL, NULL, 4736, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 15:11:48', 'admin-1479874118-1479885107921321', 1, 0, '', NULL, NULL, NULL),
(13501, '2016-11-23 16:41:04', NULL, NULL, 4737, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 16:41:04', 'admin-1479874118-14798904643498619', 1, 1, 'SR', NULL, NULL, NULL),
(13502, '2016-11-23 16:41:04', NULL, NULL, 4737, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 16:41:04', 'admin-1479874118-14798904643498619', 1, 1, 'SR', NULL, NULL, NULL),
(13503, '2016-11-23 18:21:36', NULL, NULL, 4738, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 18:21:36', 'admin-1479874118-14798964963885559', 1, 1, 'SR', NULL, NULL, NULL),
(13504, '2016-11-23 18:21:36', NULL, NULL, 4738, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 18:21:36', 'admin-1479874118-14798964963885559', 1, 1, 'SR', NULL, NULL, NULL),
(13505, '2016-11-23 15:11:48', NULL, NULL, 4736, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 15:11:48', 'admin-1479874118-1479885107921321', 1, 1, 'SR', NULL, NULL, NULL),
(13506, '2016-11-23 11:14:43', NULL, NULL, 4726, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 11:14:43', 'admin-1479862626-1479870883464315', 1, 1, 'SR', NULL, NULL, NULL),
(13507, '2016-11-23 11:15:40', NULL, NULL, 4727, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 11:15:40', 'admin-1479862626-147987094080458', 1, 0, '', 1, NULL, NULL),
(13508, '2016-11-23 12:02:12', NULL, NULL, 4728, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 12:02:12', 'admin-1479862626-14798737323126571', 1, 1, 'SR', NULL, NULL, NULL),
(13509, '2016-11-23 12:02:12', NULL, NULL, 4728, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 12:02:12', 'admin-1479862626-14798737323126571', 1, 1, 'SR', NULL, NULL, NULL),
(13510, '2016-11-23 12:02:20', NULL, NULL, 4728, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 12:02:20', 'admin-1479862626-1479873740596378', 1, 1, 'SR', NULL, NULL, NULL),
(13511, '2016-11-23 12:02:20', NULL, NULL, 4728, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 12:02:20', 'admin-1479862626-1479873740596378', 1, 1, 'SR', NULL, NULL, NULL),
(13512, '2016-11-23 12:08:31', NULL, NULL, 4729, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 12:08:31', 'admin-1479862626-14798741111037530', 1, 1, 'SR', NULL, NULL, NULL),
(13513, '2016-11-23 12:41:59', NULL, NULL, 4730, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 12:41:59', 'admin-1479874118-14798761198039567', 1, 1, 'SR', NULL, NULL, NULL),
(13514, '2016-11-23 12:41:59', NULL, NULL, 4730, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 12:41:59', 'admin-1479874118-14798761198039567', 1, 1, 'SR', NULL, NULL, NULL),
(13515, '2016-11-23 13:05:32', NULL, NULL, 4731, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 13:05:32', 'admin-1479874118-14798775321712562', 1, 0, '', NULL, NULL, NULL),
(13516, '2016-11-23 13:05:32', NULL, NULL, 4731, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 13:05:32', 'admin-1479874118-14798775321712562', 1, 1, 'SR', NULL, NULL, NULL),
(13517, '2016-11-23 13:05:32', NULL, NULL, 4731, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 13:05:32', 'admin-1479874118-14798775321712562', 1, 1, 'SR', NULL, NULL, NULL),
(13518, '2016-11-23 13:05:45', NULL, NULL, 4731, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 13:05:45', 'admin-1479874118-14798775447914170', 1, 1, 'SR', NULL, NULL, NULL),
(13519, '2016-11-23 13:13:56', NULL, NULL, 4732, 0, 84, '84', 'Set Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 13:13:56', 'admin-1479874118-14798780359289644', 1, 1, 'SR', NULL, NULL, NULL),
(13520, '2016-11-23 13:13:56', NULL, NULL, 4732, 0, 83, '83', 'Set Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 13:13:56', 'admin-1479874118-14798780359289644', 1, 1, 'SR', NULL, NULL, NULL),
(13521, '2016-11-23 13:36:23', NULL, NULL, 4733, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 13:36:23', 'admin-1479874118-14798793829834816', 1, 0, '', NULL, NULL, NULL),
(13522, '2016-11-23 11:14:43', NULL, NULL, 4726, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 11:14:43', 'admin-1479862626-1479870883464315', 1, 1, 'SR', NULL, NULL, NULL),
(13523, '2016-11-23 11:14:34', NULL, NULL, 4723, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 11:14:34', 'admin-1479862626-14798708743307780', 1, 1, 'SR', NULL, NULL, NULL),
(13524, '2016-11-23 11:00:24', NULL, NULL, 4725, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 11:00:24', 'admin-1479862626-1479870023839443', 1, 1, 'SR', NULL, NULL, NULL),
(13525, '2016-11-23 11:00:24', NULL, NULL, 4725, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 11:00:24', 'admin-1479862626-1479870023839443', 1, 0, '', NULL, NULL, NULL),
(13526, '2016-11-23 10:29:17', NULL, NULL, 4724, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 10:29:17', 'admin-1479862626-14798681576982734', 1, 1, 'SR', NULL, NULL, NULL),
(13527, '2016-11-23 10:30:46', NULL, NULL, 4724, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 10:30:46', 'admin-1479862626-14798682467818990', 1, 0, '', NULL, NULL, NULL),
(13528, '2016-11-23 10:29:02', NULL, NULL, 4724, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 10:29:02', 'admin-1479862626-14798681425199332', 1, 0, '', NULL, NULL, NULL),
(13529, '2016-11-23 10:29:02', NULL, NULL, 4724, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 10:29:02', 'admin-1479862626-14798681425199332', 1, 0, '', NULL, NULL, NULL),
(13530, '2016-11-23 10:29:17', NULL, NULL, 4724, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 10:29:17', 'admin-1479862626-14798681576982734', 1, 1, 'SR', NULL, NULL, NULL),
(13531, '2016-11-23 10:29:17', NULL, NULL, 4724, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 10:29:17', 'admin-1479862626-14798681576982734', 1, 1, 'SR', NULL, NULL, NULL),
(13532, '2016-11-23 10:29:17', NULL, NULL, 4724, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 10:29:17', 'admin-1479862626-14798681576982734', 1, 1, 'SR', NULL, NULL, NULL),
(13533, '2016-11-23 10:29:17', NULL, NULL, 4724, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 10:29:17', 'admin-1479862626-14798681576982734', 1, 0, '', NULL, NULL, NULL),
(13534, '2016-11-23 10:29:17', NULL, NULL, 4724, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 10:29:17', 'admin-1479862626-14798681576982734', 1, 1, 'SR', NULL, NULL, NULL),
(13535, '2016-11-23 10:29:17', NULL, NULL, 4724, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 10:29:17', 'admin-1479862626-14798681576982734', 1, 1, 'SR', NULL, NULL, NULL),
(13536, '2016-11-23 09:09:15', NULL, NULL, 4721, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 09:09:15', 'admin-1479862626-14798633549237121', 1, 0, '', NULL, NULL, NULL),
(13537, '2016-11-23 10:29:17', NULL, NULL, 4724, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 10:29:17', 'admin-1479862626-14798681576982734', 1, 1, 'SR', NULL, NULL, NULL),
(13538, '2016-11-23 10:29:17', NULL, NULL, 4724, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 10:29:17', 'admin-1479862626-14798681576982734', 1, 0, '', NULL, NULL, NULL),
(13539, '2016-11-23 10:29:02', NULL, NULL, 4724, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 10:29:02', 'admin-1479862626-14798681425199332', 1, 0, '', NULL, NULL, NULL),
(13540, '2016-11-23 10:26:10', NULL, NULL, 4724, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 10:26:10', 'admin-1479862626-14798679699701990', 1, 0, '', NULL, NULL, NULL),
(13541, '2016-11-23 09:49:38', NULL, NULL, 4722, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 09:49:38', 'admin-1479862626-1479865778238947', 1, 1, 'SR', NULL, NULL, NULL),
(13542, '2016-11-23 10:18:36', NULL, NULL, 4723, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 10:18:36', 'admin-1479862626-14798675161532073', 1, 1, 'SR', NULL, NULL, NULL),
(13543, '2016-11-23 10:18:36', NULL, NULL, 4723, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 10:18:36', 'admin-1479862626-14798675161532073', 1, 1, 'SR', NULL, NULL, NULL),
(13544, '2016-11-23 09:49:38', NULL, NULL, 4722, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 09:49:38', 'admin-1479862626-1479865778238947', 1, 0, '', NULL, NULL, NULL),
(13545, '2016-11-23 09:09:15', NULL, NULL, 4721, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 09:09:15', 'admin-1479862626-14798633549237121', 1, 1, 'SR', NULL, NULL, NULL),
(13546, '2016-11-23 09:09:15', NULL, NULL, 4721, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479874118', 'admin', '2016-11-23 09:09:15', 'admin-1479862626-14798633549237121', 1, 1, 'SR', NULL, NULL, NULL),
(13547, '2016-11-24 18:25:54', NULL, NULL, 4757, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 18:25:54', 'admin-1479962919-14799831545394950', 1, 1, 'SR', NULL, NULL, NULL),
(13548, '2016-11-24 18:25:54', NULL, NULL, 4757, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 18:25:54', 'admin-1479962919-14799831545394950', 1, 1, 'SR', NULL, NULL, NULL),
(13549, '2016-11-24 18:25:54', NULL, NULL, 4757, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 18:25:54', 'admin-1479962919-14799831545394950', 1, 1, 'SR', NULL, NULL, NULL),
(13550, '2016-11-24 18:26:21', NULL, NULL, 4757, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 18:26:21', 'admin-1479962919-14799831814922075', 1, 0, '', NULL, NULL, NULL),
(13551, '2016-11-24 18:26:21', NULL, NULL, 4757, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 18:26:21', 'admin-1479962919-14799831814922075', 1, 1, 'SR', NULL, NULL, NULL),
(13552, '2016-11-24 18:26:21', NULL, NULL, 4757, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 18:26:21', 'admin-1479962919-14799831814922075', 1, 1, 'SR', NULL, NULL, NULL),
(13553, '2016-11-24 18:26:21', NULL, NULL, 4757, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 18:26:21', 'admin-1479962919-14799831814922075', 1, 0, '', NULL, NULL, NULL),
(13554, '2016-11-24 18:26:21', NULL, NULL, 4757, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 18:26:21', 'admin-1479962919-14799831814922075', 1, 0, '', NULL, NULL, NULL),
(13555, '2016-11-24 18:26:21', NULL, NULL, 4757, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 18:26:21', 'admin-1479962919-14799831814922075', 1, 0, '', NULL, NULL, NULL),
(13556, '2016-11-24 18:56:40', NULL, NULL, 4758, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 18:56:40', 'admin-1479962919-14799849999841384', 1, 1, 'SR', NULL, NULL, NULL),
(13557, '2016-11-24 18:56:40', NULL, NULL, 4758, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 18:56:40', 'admin-1479962919-14799849999841384', 1, 1, 'SR', NULL, NULL, NULL),
(13558, '2016-11-24 20:25:39', NULL, NULL, 4760, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 20:25:39', 'admin-1479962919-14799903393519250', 1, 1, 'SR', NULL, NULL, '10.0'),
(13559, '2016-11-24 21:00:27', NULL, NULL, 4761, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 21:00:27', 'admin-1479962919-14799924274091257', 1, 1, 'SR', NULL, NULL, NULL),
(13560, '2016-11-24 18:25:54', NULL, NULL, 4757, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 18:25:54', 'admin-1479962919-14799831545394950', 1, 0, '', NULL, NULL, NULL),
(13561, '2016-11-24 18:25:54', NULL, NULL, 4757, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 18:25:54', 'admin-1479962919-14799831545394950', 1, 0, '', NULL, NULL, NULL),
(13562, '2016-11-24 14:52:03', NULL, NULL, 4748, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 14:52:03', 'admin-1479962919-14799703234023862', 1, 1, 'SR', NULL, NULL, NULL),
(13563, '2016-11-24 15:10:13', NULL, NULL, 4749, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 15:10:13', 'admin-1479962919-14799714131507938', 1, 1, 'SR', NULL, NULL, NULL),
(13564, '2016-11-24 15:10:13', NULL, NULL, 4749, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 15:10:13', 'admin-1479962919-14799714131507938', 1, 1, 'SR', NULL, NULL, NULL),
(13565, '2016-11-24 15:11:36', NULL, NULL, 4750, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 15:11:36', 'admin-1479962919-1479971496308704', 1, 1, 'SR', NULL, NULL, NULL),
(13566, '2016-11-24 15:11:36', NULL, NULL, 4750, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 15:11:36', 'admin-1479962919-1479971496308704', 1, 1, 'SR', NULL, NULL, NULL),
(13567, '2016-11-24 16:09:59', NULL, NULL, 4751, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 16:09:59', 'admin-1479962919-14799749989112985', 1, 1, 'SR', NULL, NULL, NULL),
(13568, '2016-11-24 16:09:59', NULL, NULL, 4751, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 16:09:59', 'admin-1479962919-14799749989112985', 1, 0, '', NULL, NULL, NULL),
(13569, '2016-11-24 16:09:59', NULL, NULL, 4751, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 16:09:59', 'admin-1479962919-14799749989112985', 1, 0, '', NULL, NULL, NULL),
(13570, '2016-11-24 16:10:46', NULL, NULL, 4752, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 16:10:46', 'admin-1479962919-14799750461066718', 1, 1, 'SR', NULL, NULL, NULL),
(13571, '2016-11-24 16:12:49', NULL, NULL, 4753, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 16:12:49', 'admin-1479962919-14799751692965437', 1, 1, 'SR', NULL, NULL, NULL),
(13572, '2016-11-24 16:12:49', NULL, NULL, 4753, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 16:12:49', 'admin-1479962919-14799751692965437', 1, 0, '', NULL, NULL, NULL),
(13573, '2016-11-24 16:12:49', NULL, NULL, 4753, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 16:12:49', 'admin-1479962919-14799751692965437', 1, 0, '', NULL, NULL, NULL),
(13574, '2016-11-24 16:19:55', NULL, NULL, 4754, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 16:19:55', 'admin-1479962919-1479975594915392', 1, 1, 'SR', NULL, NULL, NULL),
(13575, '2016-11-24 16:19:55', NULL, NULL, 4754, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 16:19:55', 'admin-1479962919-1479975594915392', 1, 1, 'SR', NULL, NULL, NULL),
(13576, '2016-11-24 16:44:27', NULL, NULL, 4755, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 16:44:27', 'admin-1479962919-14799770678062581', 1, 1, 'SR', NULL, NULL, NULL),
(13577, '2016-11-24 16:44:27', NULL, NULL, 4755, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 16:44:27', 'admin-1479962919-14799770678062581', 1, 0, '', NULL, NULL, NULL),
(13578, '2016-11-24 20:23:43', NULL, NULL, 4759, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 20:23:43', 'admin-1479962919-14799902228895112', 1, 1, 'SR', NULL, NULL, NULL),
(13579, '2016-11-24 18:00:37', NULL, NULL, 4756, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 18:00:37', 'admin-1479962919-1479981637537571', 1, 0, '', NULL, NULL, '20.0'),
(13580, '2016-11-24 18:01:19', NULL, NULL, 4756, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 18:01:19', 'admin-1479962919-14799816788154193', 1, 1, 'SR', NULL, NULL, '20.0'),
(13581, '2016-11-24 14:10:00', NULL, NULL, 4746, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 14:10:00', 'admin-1479962919-14799678007002078', 1, 1, 'SR', NULL, NULL, NULL),
(13582, '2016-11-24 14:51:31', NULL, NULL, 4747, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 14:51:31', 'admin-1479962919-14799702917663310', 1, 1, 'SR', NULL, NULL, NULL),
(13583, '2016-11-24 12:27:14', NULL, NULL, 4742, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 12:27:14', 'admin-1479948966-14799616343848068', 1, 1, 'SR', NULL, NULL, NULL),
(13584, '2016-11-24 12:32:00', NULL, NULL, 4740, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 12:32:00', 'admin-1479948966-14799619198967264', 1, 1, 'SR', NULL, NULL, NULL),
(13585, '2016-11-24 12:48:53', NULL, NULL, 4743, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 12:48:53', 'admin-1479962919-1479962933240422', 1, 0, '', NULL, NULL, NULL),
(13586, '2016-11-24 12:48:53', NULL, NULL, 4743, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 12:48:53', 'admin-1479962919-1479962933240422', 1, 1, 'SR', NULL, NULL, NULL),
(13587, '2016-11-24 13:22:00', NULL, NULL, 4744, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 13:22:00', 'admin-1479962919-1479964920293689', 1, 1, 'SR', 1, NULL, NULL),
(13588, '2016-11-24 13:22:00', NULL, NULL, 4744, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 13:22:00', 'admin-1479962919-1479964920293689', 1, 1, 'SR', 1, NULL, NULL),
(13589, '2016-11-24 13:45:52', NULL, NULL, 4745, 0, 83, '83', 'Set Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 13:45:52', 'admin-1479962919-14799663519021897', 1, 1, 'SR', NULL, NULL, NULL),
(13590, '2016-11-24 13:45:52', NULL, NULL, 4745, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 13:45:52', 'admin-1479962919-14799663519021897', 1, 0, '', NULL, NULL, NULL),
(13591, '2016-11-24 14:10:00', NULL, NULL, 4746, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 14:10:00', 'admin-1479962919-14799678007002078', 1, 1, 'SR', NULL, NULL, NULL),
(13592, '2016-11-24 12:24:32', NULL, NULL, 4742, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 12:24:32', 'admin-1479948966-14799614724009084', 1, 1, 'SR', NULL, NULL, NULL),
(13593, '2016-11-24 12:27:07', NULL, NULL, 4742, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 12:27:07', 'admin-1479948966-14799616273676883', 1, 1, 'SR', NULL, NULL, NULL),
(13594, '2016-11-24 12:24:32', NULL, NULL, 4742, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 12:24:32', 'admin-1479948966-14799614724009084', 1, 0, '', NULL, NULL, NULL),
(13595, '2016-11-24 12:19:44', NULL, NULL, 4741, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 12:19:44', 'admin-1479948966-14799611839256882', 1, 1, 'SR', NULL, NULL, '10.0'),
(13596, '2016-11-24 10:18:48', NULL, NULL, 4739, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 10:18:48', 'admin-1479948966-14799539278351872', 1, 1, 'SR', NULL, NULL, NULL),
(13597, '2016-11-24 10:18:48', NULL, NULL, 4739, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 10:18:48', 'admin-1479948966-14799539278351872', 1, 0, '', NULL, NULL, NULL),
(13598, '2016-11-24 12:19:57', NULL, NULL, 4741, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 12:19:57', 'admin-1479948966-14799611972668610', 1, 1, 'SR', NULL, NULL, '10.0');
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(13599, '2016-11-24 11:14:50', NULL, NULL, 4740, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 11:14:50', 'admin-1479948966-14799572905294270', 1, 1, 'SR', NULL, NULL, NULL),
(13600, '2016-11-24 10:18:48', NULL, NULL, 4739, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 10:18:48', 'admin-1479948966-14799539278351872', 1, 1, 'SR', NULL, NULL, NULL),
(13601, '2016-11-24 10:18:37', NULL, NULL, 4739, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1479962919', 'admin', '2016-11-24 10:18:37', 'admin-1479948966-14799539169555589', 1, 0, '', NULL, NULL, NULL),
(13602, '2016-11-25 14:48:16', NULL, NULL, 4778, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 14:48:16', 'admin-1480043915-14800564962007580', 1, 1, 'SR', NULL, NULL, NULL),
(13603, '2016-11-25 14:48:42', NULL, NULL, 4778, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 14:48:42', 'admin-1480043915-14800565226124322', 1, 1, 'SR', NULL, NULL, NULL),
(13604, '2016-11-25 14:48:42', NULL, NULL, 4778, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 14:48:42', 'admin-1480043915-14800565226124322', 1, 1, 'SR', NULL, NULL, NULL),
(13605, '2016-11-25 14:52:20', NULL, NULL, 4777, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 14:52:20', 'admin-1480043915-14800567401869242', 1, 1, 'SR', NULL, NULL, NULL),
(13606, '2016-11-25 15:19:19', NULL, NULL, 4777, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 15:19:19', 'admin-1480043915-1480058359125249', 1, 1, 'SR', NULL, NULL, NULL),
(13607, '2016-11-25 15:19:19', NULL, NULL, 4777, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 15:19:19', 'admin-1480043915-1480058359125249', 1, 1, 'SR', NULL, NULL, NULL),
(13608, '2016-11-25 15:19:19', NULL, NULL, 4777, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 15:19:19', 'admin-1480043915-1480058359125249', 1, 1, 'SR', NULL, NULL, NULL),
(13609, '2016-11-25 15:35:55', NULL, NULL, 4778, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 15:35:55', 'admin-1480043915-14800593554762784', 1, 0, '', NULL, NULL, NULL),
(13610, '2016-11-25 15:35:55', NULL, NULL, 4778, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 15:35:55', 'admin-1480043915-14800593554762784', 1, 0, '', NULL, NULL, NULL),
(13611, '2016-11-25 15:58:55', NULL, NULL, 4778, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 15:58:55', 'admin-1480043915-1480060735481105', 1, 1, 'SR', NULL, NULL, NULL),
(13612, '2016-11-25 18:55:15', NULL, NULL, 4784, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 18:55:15', 'admin-1480043915-14800713152618042', 1, 1, 'SR', NULL, NULL, NULL),
(13613, '2016-11-25 18:55:15', NULL, NULL, 4784, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 18:55:15', 'admin-1480043915-14800713152618042', 1, 1, 'SR', NULL, NULL, NULL),
(13614, '2016-11-25 19:50:00', NULL, NULL, 4784, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 19:50:00', 'admin-1480043915-14800746007142254', 1, 0, '', NULL, NULL, NULL),
(13615, '2016-11-25 16:09:19', NULL, NULL, 4779, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 16:09:19', 'admin-1480043915-14800613591661450', 1, 0, '', NULL, NULL, NULL),
(13616, '2016-11-25 16:09:19', NULL, NULL, 4779, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 16:09:19', 'admin-1480043915-14800613591661450', 1, 0, '', NULL, NULL, NULL),
(13617, '2016-11-25 14:37:32', NULL, NULL, 4777, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 14:37:32', 'admin-1480043915-14800558519741135', 1, 1, 'SR', NULL, NULL, NULL),
(13618, '2016-11-25 14:37:32', NULL, NULL, 4777, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 14:37:32', 'admin-1480043915-14800558519741135', 1, 1, 'SR', NULL, NULL, NULL),
(13619, '2016-11-25 14:37:32', NULL, NULL, 4777, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 14:37:32', 'admin-1480043915-14800558519741135', 1, 1, 'SR', NULL, NULL, NULL),
(13620, '2016-11-25 14:37:32', NULL, NULL, 4777, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 14:37:32', 'admin-1480043915-14800558519741135', 1, 1, 'SR', NULL, NULL, NULL),
(13621, '2016-11-25 14:48:16', NULL, NULL, 4778, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 14:48:16', 'admin-1480043915-14800564962007580', 1, 1, 'SR', NULL, NULL, NULL),
(13622, '2016-11-25 18:55:15', NULL, NULL, 4784, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 18:55:15', 'admin-1480043915-14800713152618042', 1, 0, '', NULL, NULL, NULL),
(13623, '2016-11-25 18:42:01', NULL, NULL, 4784, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 18:42:01', 'admin-1480043915-14800705217223694', 1, 1, 'SR', NULL, NULL, NULL),
(13624, '2016-11-25 18:29:37', NULL, NULL, 4784, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 18:29:37', 'admin-1480043915-14800697771928088', 1, 0, '', NULL, NULL, NULL),
(13625, '2016-11-25 18:25:55', NULL, NULL, 4784, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 18:25:55', 'admin-1480043915-14800695549096524', 1, 1, 'SR', NULL, NULL, NULL),
(13626, '2016-11-25 17:14:39', NULL, NULL, 4781, 0, 181, '116', 'Open Food ', 'lemon', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1480043915', 'admin', '2016-11-25 17:14:39', 'admin-1480043915-14800652793355275', 1, 0, '', NULL, NULL, NULL),
(13627, '2016-11-25 17:20:57', NULL, NULL, 4782, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 17:20:57', 'admin-1480043915-1480065657501581', 1, 1, 'SR', NULL, NULL, NULL),
(13628, '2016-11-25 18:16:28', NULL, NULL, 4783, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 18:16:28', 'admin-1480043915-14800689881592114', 1, 0, '', NULL, NULL, NULL),
(13629, '2016-11-25 16:30:36', NULL, NULL, 4780, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 16:30:36', 'admin-1480043915-14800626359096595', 1, 1, 'SR', NULL, NULL, NULL),
(13630, '2016-11-25 15:58:55', NULL, NULL, 4778, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 15:58:55', 'admin-1480043915-1480060735481105', 1, 1, 'SR', NULL, NULL, NULL),
(13631, '2016-11-25 11:11:18', NULL, NULL, 4767, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 11:11:18', 'admin-1480036054-14800434779922549', 1, 0, '', NULL, NULL, NULL),
(13632, '2016-11-25 11:21:41', NULL, NULL, 4768, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 11:21:41', 'admin-1480043915-14800441017813135', 1, 0, '', NULL, NULL, NULL),
(13633, '2016-11-25 11:21:46', NULL, NULL, 4768, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 11:21:46', 'admin-1480043915-14800441058873665', 1, 1, 'SR', NULL, NULL, NULL),
(13634, '2016-11-25 11:22:00', NULL, NULL, 4766, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 11:22:00', 'admin-1480043915-14800441203535059', 1, 1, 'SR', NULL, NULL, NULL),
(13635, '2016-11-25 11:32:21', NULL, NULL, 4769, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 11:32:21', 'admin-1480043915-14800447414048723', 1, 0, '', NULL, NULL, NULL),
(13636, '2016-11-25 11:32:27', NULL, NULL, 4769, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 11:32:27', 'admin-1480043915-14800447477223066', 1, 1, 'SR', NULL, NULL, NULL),
(13637, '2016-11-25 11:42:23', NULL, NULL, 4770, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 11:42:23', 'admin-1480043915-14800453437337565', 1, 1, 'SR', NULL, NULL, NULL),
(13638, '2016-11-25 11:42:23', NULL, NULL, 4770, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 11:42:23', 'admin-1480043915-14800453437337565', 1, 0, '', NULL, NULL, NULL),
(13639, '2016-11-25 11:42:23', NULL, NULL, 4770, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 11:42:23', 'admin-1480043915-14800453437337565', 1, 1, 'SR', NULL, NULL, NULL),
(13640, '2016-11-25 12:31:57', NULL, NULL, 4771, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 12:31:57', 'admin-1480043915-14800483175197968', 1, 0, '', NULL, NULL, NULL),
(13641, '2016-11-25 12:31:57', NULL, NULL, 4771, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 12:31:57', 'admin-1480043915-14800483175197968', 1, 1, 'SR', NULL, NULL, NULL),
(13642, '2016-11-25 12:36:53', NULL, NULL, 4772, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 12:36:53', 'admin-1480043915-14800486136664391', 1, 1, 'SR', NULL, NULL, NULL),
(13643, '2016-11-25 12:46:40', NULL, NULL, 4773, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 12:46:40', 'admin-1480043915-14800492001577341', 1, 1, 'SR', NULL, NULL, NULL),
(13644, '2016-11-25 12:53:19', NULL, NULL, 4769, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 12:53:19', 'admin-1480043915-14800495995352168', 1, 1, 'SR', NULL, NULL, NULL),
(13645, '2016-11-25 13:05:07', NULL, NULL, 4774, 0, 82, '82', 'Set Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 13:05:07', 'admin-1480043915-14800503074538041', 1, 1, 'SR', NULL, NULL, NULL),
(13646, '2016-11-25 13:05:07', NULL, NULL, 4774, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 13:05:07', 'admin-1480043915-14800503074538041', 1, 1, 'SR', NULL, NULL, NULL),
(13647, '2016-11-25 13:10:35', NULL, NULL, 4775, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 13:10:35', 'admin-1480043915-14800506352113319', 1, 1, 'SR', NULL, NULL, NULL),
(13648, '2016-11-25 13:10:35', NULL, NULL, 4775, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 13:10:35', 'admin-1480043915-14800506352113319', 1, 1, 'SR', NULL, NULL, NULL),
(13649, '2016-11-25 13:18:46', NULL, NULL, 4776, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 13:18:46', 'admin-1480043915-14800511267349310', 1, 1, 'SR', NULL, NULL, NULL),
(13650, '2016-11-25 13:28:45', NULL, NULL, 4776, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 13:28:45', 'admin-1480043915-14800517248641576', 1, 1, 'SR', NULL, NULL, NULL),
(13651, '2016-11-25 10:45:04', NULL, NULL, 4764, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 10:45:04', 'admin-1480036054-148004190433059', 1, 1, 'SR', NULL, NULL, NULL),
(13652, '2016-11-25 10:45:04', NULL, NULL, 4764, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 10:45:04', 'admin-1480036054-148004190433059', 1, 1, 'SR', NULL, NULL, NULL),
(13653, '2016-11-25 10:45:04', NULL, NULL, 4764, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 10:45:04', 'admin-1480036054-148004190433059', 1, 1, 'SR', NULL, NULL, NULL),
(13654, '2016-11-25 10:45:16', NULL, NULL, 4765, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 10:45:16', 'admin-1480036054-14800419166445888', 1, 0, '', NULL, NULL, NULL),
(13655, '2016-11-25 10:45:16', NULL, NULL, 4765, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 10:45:16', 'admin-1480036054-14800419166445888', 1, 0, '', NULL, NULL, NULL),
(13656, '2016-11-25 10:45:30', NULL, NULL, 4765, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 10:45:30', 'admin-1480036054-14800419304703049', 1, 1, 'SR', NULL, NULL, NULL),
(13657, '2016-11-25 10:45:30', NULL, NULL, 4765, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 10:45:30', 'admin-1480036054-14800419304703049', 1, 1, 'SR', NULL, NULL, NULL),
(13658, '2016-11-25 10:46:21', NULL, NULL, 4766, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 10:46:21', 'admin-1480036054-14800419813325565', 1, 1, 'SR', NULL, NULL, NULL),
(13659, '2016-11-25 10:46:21', NULL, NULL, 4766, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 10:46:21', 'admin-1480036054-14800419813325565', 1, 0, '', NULL, NULL, NULL),
(13660, '2016-11-25 10:42:23', NULL, NULL, 4763, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 10:42:23', 'admin-1480036054-14800417432857947', 1, 0, '', NULL, NULL, NULL),
(13661, '2016-11-25 10:42:23', NULL, NULL, 4763, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 10:42:23', 'admin-1480036054-14800417432857947', 1, 0, '', NULL, NULL, NULL),
(13662, '2016-11-25 10:45:04', NULL, NULL, 4764, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 10:45:04', 'admin-1480036054-148004190433059', 1, 1, 'SR', NULL, NULL, NULL),
(13663, '2016-11-25 10:42:23', NULL, NULL, 4763, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 10:42:23', 'admin-1480036054-14800417432857947', 1, 0, '', NULL, NULL, NULL),
(13664, '2016-11-25 10:17:01', NULL, NULL, 4762, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 10:17:01', 'admin-1480036054-14800402216787359', 1, 1, 'SR', NULL, NULL, NULL),
(13665, '2016-11-25 10:42:23', NULL, NULL, 4763, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 10:42:23', 'admin-1480036054-14800417432857947', 1, 0, '', NULL, NULL, NULL),
(13666, '2016-11-25 10:42:23', NULL, NULL, 4763, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 10:42:23', 'admin-1480036054-14800417432857947', 1, 1, 'SR', NULL, NULL, NULL),
(13667, '2016-11-25 10:42:23', NULL, NULL, 4763, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 10:42:23', 'admin-1480036054-14800417432857947', 1, 0, '', NULL, NULL, NULL),
(13668, '2016-11-25 10:17:01', NULL, NULL, 4762, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 10:17:01', 'admin-1480036054-14800402216787359', 1, 1, 'SR', NULL, NULL, NULL),
(13669, '2016-11-25 10:16:48', NULL, NULL, 4762, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 10:16:48', 'admin-1480036054-14800402079366672', 1, 0, '', NULL, NULL, NULL),
(13670, '2016-11-25 10:16:48', NULL, NULL, 4762, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480043915', 'admin', '2016-11-25 10:16:48', 'admin-1480036054-14800402079366672', 1, 0, '', NULL, NULL, NULL),
(13671, '2016-11-26 19:50:23', NULL, NULL, 4817, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 19:50:23', 'admin-1480147699-14801610229886517', 1, 0, '', NULL, NULL, NULL),
(13672, '2016-11-26 19:58:48', NULL, NULL, 4818, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 19:58:48', 'admin-1480147699-14801615286746462', 1, 0, '', NULL, NULL, NULL),
(13673, '2016-11-26 20:07:33', NULL, NULL, 4819, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 20:07:33', 'admin-1480147699-14801620535508979', 1, 1, 'SR', NULL, NULL, NULL),
(13674, '2016-11-26 13:28:05', NULL, NULL, 4802, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 13:28:05', 'admin-1480127143-14801380853527365', 1, 1, 'SR', NULL, NULL, NULL),
(13675, '2016-11-26 17:39:32', NULL, NULL, 4815, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 17:39:32', 'admin-1480147699-14801531724189596', 1, 1, 'SR', NULL, NULL, NULL),
(13676, '2016-11-26 16:05:03', NULL, NULL, 4808, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 16:05:03', 'admin-1480138359-1480147503207638', 1, 0, '', NULL, NULL, NULL),
(13677, '2016-11-26 16:05:31', NULL, NULL, 4809, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 16:05:31', 'admin-1480138359-14801475311349540', 1, 1, 'SR', NULL, NULL, NULL),
(13678, '2016-11-26 16:05:31', NULL, NULL, 4809, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 16:05:31', 'admin-1480138359-14801475311349540', 1, 1, 'SR', NULL, NULL, NULL),
(13679, '2016-11-26 16:08:09', NULL, NULL, 4809, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 16:08:09', 'admin-1480138359-14801476891387659', 1, 1, 'SR', NULL, NULL, NULL),
(13680, '2016-11-26 16:08:09', NULL, NULL, 4809, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 16:08:09', 'admin-1480138359-14801476891387659', 1, 0, '', NULL, NULL, NULL),
(13681, '2016-11-26 16:42:48', NULL, NULL, 4810, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 16:42:48', 'admin-1480147699-14801497683683830', 1, 1, 'SR', NULL, NULL, NULL),
(13682, '2016-11-26 16:42:48', NULL, NULL, 4810, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 16:42:48', 'admin-1480147699-14801497683683830', 1, 1, 'SR', NULL, NULL, NULL),
(13683, '2016-11-26 17:03:30', NULL, NULL, 4811, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 17:03:30', 'admin-1480147699-14801510098626730', 1, 1, 'SR', NULL, NULL, NULL),
(13684, '2016-11-26 17:27:24', NULL, NULL, 4812, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 17:27:24', 'admin-1480147699-14801524446588130', 1, 1, 'SR', NULL, NULL, NULL),
(13685, '2016-11-26 17:27:24', NULL, NULL, 4812, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 17:27:24', 'admin-1480147699-14801524446588130', 1, 1, 'SR', NULL, NULL, NULL),
(13686, '2016-11-26 17:27:24', NULL, NULL, 4812, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 17:27:24', 'admin-1480147699-14801524446588130', 1, 1, 'SR', NULL, NULL, NULL),
(13687, '2016-11-26 17:32:11', NULL, NULL, 4813, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 17:32:11', 'admin-1480147699-14801527313161239', 1, 0, '', NULL, NULL, NULL),
(13688, '2016-11-26 17:39:11', NULL, NULL, 4814, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 17:39:11', 'admin-1480147699-14801531510117481', 1, 1, 'SR', NULL, NULL, NULL),
(13689, '2016-11-26 13:51:57', NULL, NULL, 4805, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 13:51:57', 'admin-1480138359-14801395170466931', 1, 0, '', NULL, NULL, NULL),
(13690, '2016-11-26 14:27:15', NULL, NULL, 4806, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 14:27:15', 'admin-1480138359-14801416348334255', 1, 0, '', NULL, NULL, NULL),
(13691, '2016-11-26 14:27:48', NULL, NULL, 4806, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 14:27:48', 'admin-1480138359-14801416679924487', 1, 0, '', NULL, NULL, NULL),
(13692, '2016-11-26 14:27:48', NULL, NULL, 4806, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 14:27:48', 'admin-1480138359-14801416679924487', 1, 0, '', NULL, NULL, NULL),
(13693, '2016-11-26 14:27:48', NULL, NULL, 4806, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 14:27:48', 'admin-1480138359-14801416679924487', 1, 1, 'SR', NULL, NULL, NULL),
(13694, '2016-11-26 15:24:23', NULL, NULL, 4807, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 15:24:23', 'admin-1480138359-14801450630624344', 1, 1, 'SR', NULL, NULL, NULL),
(13695, '2016-11-26 15:24:23', NULL, NULL, 4807, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 15:24:23', 'admin-1480138359-14801450630624344', 1, 0, '', NULL, NULL, NULL),
(13696, '2016-11-26 16:05:03', NULL, NULL, 4808, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 16:05:03', 'admin-1480138359-1480147503207638', 1, 1, 'SR', NULL, NULL, NULL),
(13697, '2016-11-26 12:03:16', NULL, NULL, 4792, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 12:03:16', 'admin-1480127143-1480132996254634', 1, 0, '', NULL, NULL, NULL),
(13698, '2016-11-26 12:03:16', NULL, NULL, 4792, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 12:03:16', 'admin-1480127143-1480132996254634', 1, 0, '', NULL, NULL, NULL),
(13699, '2016-11-26 12:02:26', NULL, NULL, 4797, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 12:02:26', 'admin-1480127143-14801329464222680', 1, 0, '', NULL, NULL, NULL),
(13700, '2016-11-26 11:57:27', NULL, NULL, 4797, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 11:57:27', 'admin-1480127143-14801326475576693', 1, 1, 'SR', NULL, NULL, NULL),
(13701, '2016-11-26 11:56:01', NULL, NULL, 4799, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 11:56:01', 'admin-1480127143-14801325617198954', 1, 1, 'SR', NULL, NULL, NULL),
(13702, '2016-11-26 11:56:01', NULL, NULL, 4799, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 11:56:01', 'admin-1480127143-14801325617198954', 1, 1, 'SR', NULL, NULL, NULL),
(13703, '2016-11-26 11:55:30', NULL, NULL, 4799, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 11:55:30', 'admin-1480127143-1480132530144688', 1, 0, '', NULL, NULL, NULL),
(13704, '2016-11-26 11:55:30', NULL, NULL, 4799, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 11:55:30', 'admin-1480127143-1480132530144688', 1, 0, '', NULL, NULL, NULL),
(13705, '2016-11-26 11:55:30', NULL, NULL, 4799, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 11:55:30', 'admin-1480127143-1480132530144688', 1, 0, '', NULL, NULL, NULL),
(13706, '2016-11-26 18:06:56', NULL, NULL, 4814, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 18:06:56', 'admin-1480147699-14801548160747397', 1, 1, 'SR', NULL, NULL, NULL),
(13707, '2016-11-26 17:39:32', NULL, NULL, 4815, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 17:39:32', 'admin-1480147699-14801531724189596', 1, 1, 'SR', NULL, NULL, NULL),
(13708, '2016-11-26 13:42:15', NULL, NULL, 4804, 0, 86, '86', 'Set Pesto Pasta ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 13:42:15', 'admin-1480138359-14801389355589245', 1, 1, 'SR', NULL, NULL, NULL),
(13709, '2016-11-26 13:42:15', NULL, NULL, 4804, 0, 86, '86', 'Set Pesto Pasta ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 13:42:15', 'admin-1480138359-14801389355589245', 1, 1, 'SR', NULL, NULL, NULL),
(13710, '2016-11-26 13:42:15', NULL, NULL, 4804, 0, 181, '116', 'Open Food ', 'add chicken', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 13:42:15', 'admin-1480138359-14801389355589245', 1, 0, '', NULL, NULL, NULL),
(13711, '2016-11-26 13:43:08', NULL, NULL, 4802, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 13:43:08', 'admin-1480138359-14801389882045196', 1, 0, '', NULL, NULL, NULL),
(13712, '2016-11-26 13:51:48', NULL, NULL, 4805, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 13:51:48', 'admin-1480138359-14801395084383966', 1, 0, '', NULL, NULL, NULL),
(13713, '2016-11-26 11:21:54', NULL, NULL, 4797, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 11:21:54', 'admin-1480127143-14801305141126317', 1, 1, 'SR', NULL, NULL, NULL),
(13714, '2016-11-26 11:21:54', NULL, NULL, 4797, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 11:21:54', 'admin-1480127143-14801305141126317', 1, 1, 'SR', NULL, NULL, NULL),
(13715, '2016-11-26 11:21:54', NULL, NULL, 4797, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 11:21:54', 'admin-1480127143-14801305141126317', 1, 0, '', NULL, NULL, NULL),
(13716, '2016-11-26 11:16:11', NULL, NULL, 4795, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 11:16:11', 'admin-1480127143-14801301716414362', 1, 1, 'SR', 1, NULL, NULL),
(13717, '2016-11-26 10:40:01', NULL, NULL, 4792, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:40:01', 'admin-1480127143-14801280016988086', 1, 0, '', NULL, NULL, NULL),
(13718, '2016-11-26 10:40:01', NULL, NULL, 4792, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:40:01', 'admin-1480127143-14801280016988086', 1, 1, 'SR', NULL, NULL, NULL),
(13719, '2016-11-26 11:52:05', NULL, NULL, 4798, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 11:52:05', 'admin-1480127143-14801323248961133', 1, 0, '', NULL, NULL, NULL),
(13720, '2016-11-26 11:51:53', NULL, NULL, 4798, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 11:51:53', 'admin-1480127143-14801323133931073', 1, 0, '', NULL, NULL, NULL),
(13721, '2016-11-26 11:43:37', NULL, NULL, 4796, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 11:43:37', 'admin-1480127143-14801318169681466', 1, 1, 'SR', NULL, NULL, NULL),
(13722, '2016-11-26 11:21:54', NULL, NULL, 4797, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 11:21:54', 'admin-1480127143-14801305141126317', 1, 0, '', NULL, NULL, NULL),
(13723, '2016-11-26 13:28:05', NULL, NULL, 4802, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 13:28:05', 'admin-1480127143-14801380853527365', 1, 1, 'SR', NULL, NULL, NULL),
(13724, '2016-11-26 13:32:34', NULL, NULL, 4803, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 13:32:34', 'admin-1480127143-14801383539801274', 1, 0, '', NULL, NULL, NULL),
(13725, '2016-11-26 13:33:24', NULL, NULL, 4803, 0, 82, '82', 'Set Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 13:33:24', 'admin-1480138359-1480138404176136', 1, 1, 'SR', NULL, NULL, NULL),
(13726, '2016-11-26 13:28:05', NULL, NULL, 4802, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 13:28:05', 'admin-1480127143-14801380853527365', 1, 1, 'SR', NULL, NULL, NULL),
(13727, '2016-11-26 13:23:26', NULL, NULL, 4802, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 13:23:26', 'admin-1480127143-14801378059285010', 1, 1, 'SR', NULL, NULL, NULL),
(13728, '2016-11-26 12:38:32', NULL, NULL, 4801, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 12:38:32', 'admin-1480127143-1480135111991522', 1, 0, '', NULL, NULL, NULL),
(13729, '2016-11-26 12:38:32', NULL, NULL, 4801, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 12:38:32', 'admin-1480127143-1480135111991522', 1, 0, '', NULL, NULL, NULL),
(13730, '2016-11-26 12:13:08', NULL, NULL, 4800, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 12:13:08', 'admin-1480127143-1480133588635204', 1, 0, '', NULL, NULL, NULL),
(13731, '2016-11-26 12:13:08', NULL, NULL, 4800, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 12:13:08', 'admin-1480127143-1480133588635204', 1, 1, 'SR', NULL, NULL, NULL),
(13732, '2016-11-26 12:13:08', NULL, NULL, 4800, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 12:13:08', 'admin-1480127143-1480133588635204', 1, 1, 'SR', NULL, NULL, NULL),
(13733, '2016-11-26 12:13:08', NULL, NULL, 4800, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 12:13:08', 'admin-1480127143-1480133588635204', 1, 1, 'SR', NULL, NULL, NULL),
(13734, '2016-11-26 12:13:08', NULL, NULL, 4800, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 12:13:08', 'admin-1480127143-1480133588635204', 1, 0, '', NULL, NULL, NULL),
(13735, '2016-11-26 12:03:59', NULL, NULL, 4792, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 12:03:59', 'admin-1480127143-14801330394639529', 1, 0, '', NULL, NULL, NULL),
(13736, '2016-11-26 12:03:59', NULL, NULL, 4792, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 12:03:59', 'admin-1480127143-14801330394639529', 1, 0, '', NULL, NULL, NULL),
(13737, '2016-11-26 11:52:05', NULL, NULL, 4798, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 11:52:05', 'admin-1480127143-14801323248961133', 1, 1, 'SR', NULL, NULL, NULL),
(13738, '2016-11-26 11:17:55', NULL, NULL, 4796, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 11:17:55', 'admin-1480127143-14801302757384139', 1, 0, '', NULL, NULL, NULL),
(13739, '2016-11-26 11:51:53', NULL, NULL, 4798, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 11:51:53', 'admin-1480127143-14801323133931073', 1, 0, '', NULL, NULL, NULL),
(13740, '2016-11-26 11:16:11', NULL, NULL, 4795, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 11:16:11', 'admin-1480127143-14801301716414362', 1, 1, 'SR', 1, NULL, NULL),
(13741, '2016-11-26 11:15:09', NULL, NULL, 4794, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 11:15:09', 'admin-1480127143-1480130109684532', 1, 1, 'SR', 1, NULL, NULL),
(13742, '2016-11-26 10:46:44', NULL, NULL, 4793, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:46:44', 'admin-1480127143-14801284046418750', 1, 1, 'SR', NULL, NULL, NULL),
(13743, '2016-11-26 10:57:51', NULL, NULL, 4792, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:57:51', 'admin-1480127143-14801290712376258', 1, 0, '', NULL, NULL, NULL),
(13744, '2016-11-26 11:11:01', NULL, NULL, 4790, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 11:11:01', 'admin-1480127143-14801298612934971', 1, 1, 'SR', NULL, NULL, NULL),
(13745, '2016-11-26 11:15:09', NULL, NULL, 4794, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 11:15:09', 'admin-1480127143-1480130109684532', 1, 0, '', 1, NULL, NULL),
(13746, '2016-11-26 10:46:29', NULL, NULL, 4793, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:46:29', 'admin-1480127143-14801283895766754', 1, 0, '', NULL, NULL, NULL),
(13747, '2016-11-26 10:46:29', NULL, NULL, 4793, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:46:29', 'admin-1480127143-14801283895766754', 1, 0, '', NULL, NULL, NULL),
(13748, '2016-11-26 10:40:01', NULL, NULL, 4792, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:40:01', 'admin-1480127143-14801280016988086', 1, 1, 'SR', NULL, NULL, NULL),
(13749, '2016-11-26 09:33:12', NULL, NULL, 4786, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:33:12', 'admin-1480119748-14801239923339727', 1, 0, '', NULL, NULL, NULL),
(13750, '2016-11-26 09:32:06', NULL, NULL, 4785, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:32:06', 'admin-1480119748-14801239266701944', 1, 0, '', NULL, NULL, NULL),
(13751, '2016-11-26 09:32:06', NULL, NULL, 4785, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:32:06', 'admin-1480119748-14801239266701944', 1, 0, '', NULL, NULL, NULL),
(13752, '2016-11-26 09:33:12', NULL, NULL, 4786, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:33:12', 'admin-1480119748-14801239923339727', 1, 0, '', NULL, NULL, NULL),
(13753, '2016-11-26 09:33:12', NULL, NULL, 4786, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:33:12', 'admin-1480119748-14801239923339727', 1, 0, '', NULL, NULL, NULL),
(13754, '2016-11-26 09:33:12', NULL, NULL, 4786, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:33:12', 'admin-1480119748-14801239923339727', 1, 0, '', NULL, NULL, NULL),
(13755, '2016-11-26 09:33:12', NULL, NULL, 4786, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:33:12', 'admin-1480119748-14801239923339727', 1, 0, '', NULL, NULL, NULL),
(13756, '2016-11-26 09:33:24', NULL, NULL, 4786, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:33:24', 'admin-1480119748-14801240040691313', 1, 0, '', NULL, NULL, NULL),
(13757, '2016-11-26 09:33:24', NULL, NULL, 4786, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:33:24', 'admin-1480119748-14801240040691313', 1, 0, '', NULL, NULL, NULL),
(13758, '2016-11-26 09:33:24', NULL, NULL, 4786, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:33:24', 'admin-1480119748-14801240040691313', 1, 0, '', NULL, NULL, NULL),
(13759, '2016-11-26 09:33:24', NULL, NULL, 4786, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:33:24', 'admin-1480119748-14801240040691313', 1, 1, 'SR', NULL, NULL, NULL),
(13760, '2016-11-26 09:33:24', NULL, NULL, 4786, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:33:24', 'admin-1480119748-14801240040691313', 1, 1, 'SR', NULL, NULL, NULL),
(13761, '2016-11-26 09:35:40', NULL, NULL, 4785, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:35:40', 'admin-1480119748-14801241398567514', 1, 0, '', NULL, NULL, NULL),
(13762, '2016-11-26 09:43:07', NULL, NULL, 4787, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:43:07', 'admin-1480119748-14801245877559972', 1, 0, '', NULL, NULL, NULL),
(13763, '2016-11-26 09:43:07', NULL, NULL, 4787, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:43:07', 'admin-1480119748-14801245877559972', 1, 0, '', NULL, NULL, NULL),
(13764, '2016-11-26 09:43:22', NULL, NULL, 4787, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:43:22', 'admin-1480119748-14801246025493749', 1, 1, 'SR', NULL, NULL, NULL),
(13765, '2016-11-26 09:47:07', NULL, NULL, 4788, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:47:07', 'admin-1480119748-14801248268839893', 1, 0, '', NULL, NULL, NULL),
(13766, '2016-11-26 09:48:58', NULL, NULL, 4789, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:48:58', 'admin-1480119748-1480124937949865', 1, 0, '', NULL, NULL, NULL),
(13767, '2016-11-26 09:48:58', NULL, NULL, 4789, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:48:58', 'admin-1480119748-1480124937949865', 1, 0, '', NULL, NULL, NULL),
(13768, '2016-11-26 09:48:58', NULL, NULL, 4789, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:48:58', 'admin-1480119748-1480124937949865', 1, 1, 'SR', NULL, NULL, NULL),
(13769, '2016-11-26 09:48:58', NULL, NULL, 4789, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:48:58', 'admin-1480119748-1480124937949865', 1, 1, 'SR', NULL, NULL, NULL),
(13770, '2016-11-26 10:17:56', NULL, NULL, 4790, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:17:56', 'admin-1480119748-14801266757973928', 1, 1, 'SR', NULL, NULL, NULL),
(13771, '2016-11-26 10:17:56', NULL, NULL, 4790, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:17:56', 'admin-1480119748-14801266757973928', 1, 1, 'SR', NULL, NULL, NULL),
(13772, '2016-11-26 10:25:26', NULL, NULL, 4791, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:25:26', 'admin-1480119748-14801271260812123', 1, 0, '', NULL, NULL, NULL),
(13773, '2016-11-26 10:25:26', NULL, NULL, 4791, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:25:26', 'admin-1480119748-14801271260812123', 1, 0, '', NULL, NULL, NULL),
(13774, '2016-11-26 10:25:26', NULL, NULL, 4791, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:25:26', 'admin-1480119748-14801271260812123', 1, 0, '', NULL, NULL, NULL),
(13775, '2016-11-26 10:25:52', NULL, NULL, 4791, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:25:52', 'admin-1480127143-14801271526484875', 1, 1, 'SR', NULL, NULL, NULL),
(13776, '2016-11-26 10:25:52', NULL, NULL, 4791, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:25:52', 'admin-1480127143-14801271526484875', 1, 1, 'SR', NULL, NULL, NULL),
(13777, '2016-11-26 10:38:58', NULL, NULL, 4792, 0, 153, '87', 'Big Breakfast ', 'sunny side egg', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:38:58', 'admin-1480127143-14801279384146874', 1, 0, '', NULL, NULL, NULL),
(13778, '2016-11-26 10:38:58', NULL, NULL, 4792, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:38:58', 'admin-1480127143-14801279384146874', 1, 0, '', NULL, NULL, NULL),
(13779, '2016-11-26 10:38:58', NULL, NULL, 4792, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:38:58', 'admin-1480127143-14801279384146874', 1, 0, '', NULL, NULL, NULL),
(13780, '2016-11-26 10:39:20', NULL, NULL, 4792, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:39:20', 'admin-1480127143-14801279602814562', 1, 0, '', NULL, NULL, NULL),
(13781, '2016-11-26 10:39:20', NULL, NULL, 4792, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:39:20', 'admin-1480127143-14801279602814562', 1, 0, '', NULL, NULL, NULL),
(13782, '2016-11-26 10:39:20', NULL, NULL, 4792, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:39:20', 'admin-1480127143-14801279602814562', 1, 0, '', NULL, NULL, NULL),
(13783, '2016-11-26 10:40:01', NULL, NULL, 4792, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:40:01', 'admin-1480127143-14801280016988086', 1, 1, 'SR', NULL, NULL, NULL),
(13784, '2016-11-26 10:40:01', NULL, NULL, 4792, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:40:01', 'admin-1480127143-14801280016988086', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(13785, '2016-11-26 10:40:01', NULL, NULL, 4792, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:40:01', 'admin-1480127143-14801280016988086', 1, 1, 'SR', NULL, NULL, NULL),
(13786, '2016-11-26 10:40:01', NULL, NULL, 4792, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 10:40:01', 'admin-1480127143-14801280016988086', 1, 1, 'SR', NULL, NULL, NULL),
(13787, '2016-11-26 09:31:29', NULL, NULL, 4785, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:31:29', 'admin-1480119748-14801238895216614', 1, 0, '', NULL, NULL, NULL),
(13788, '2016-11-26 09:31:29', NULL, NULL, 4785, 0, 153, '87', 'Big Breakfast ', 'no salad dressing', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480147699', 'admin', '2016-11-26 09:31:29', 'admin-1480119748-14801238895216614', 1, 0, '', NULL, NULL, NULL),
(13789, '2016-11-27 16:04:48', NULL, NULL, 4837, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480237524', NULL, '2016-11-27 16:04:48', '--14802338886454062', NULL, 0, '', NULL, NULL, NULL),
(13790, '2016-11-27 16:04:48', NULL, NULL, 4837, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480237524', NULL, '2016-11-27 16:04:48', '--14802338886454062', NULL, 0, '', NULL, NULL, NULL),
(13791, '2016-11-27 16:29:35', NULL, NULL, 4838, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480237524', NULL, '2016-11-27 16:29:35', '--14802353748598650', NULL, 1, 'SR', NULL, NULL, NULL),
(13792, '2016-11-27 16:29:35', NULL, NULL, 4838, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480237524', NULL, '2016-11-27 16:29:35', '--14802353748598650', NULL, 1, 'SR', NULL, NULL, NULL),
(13793, '2016-11-27 16:31:58', NULL, NULL, 4839, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480237524', NULL, '2016-11-27 16:31:58', '--14802355182264114', NULL, 0, '', NULL, NULL, NULL),
(13794, '2016-11-27 15:53:58', NULL, NULL, 4836, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480237524', NULL, '2016-11-27 15:53:58', '--14802332381872866', NULL, 0, '', NULL, NULL, NULL),
(13795, '2016-11-27 15:02:19', NULL, NULL, 4835, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480237524', NULL, '2016-11-27 15:02:19', '--1480230139200201', NULL, 1, 'SR', NULL, NULL, NULL),
(13796, '2016-11-27 15:53:58', NULL, NULL, 4836, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480237524', NULL, '2016-11-27 15:53:58', '--14802332381872866', NULL, 0, '', NULL, NULL, NULL),
(13797, '2016-11-27 15:02:06', NULL, NULL, 4835, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1480237524', NULL, '2016-11-27 15:02:06', '--14802301262967048', NULL, 1, 'SR', NULL, NULL, NULL),
(13798, '2016-11-27 14:44:49', NULL, NULL, 4834, 0, 86, '86', 'Set Pesto Pasta ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480237524', NULL, '2016-11-27 14:44:49', '--14802290896863085', NULL, 1, 'SR', NULL, NULL, NULL),
(13799, '2016-11-27 14:15:17', NULL, NULL, 4832, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480237524', NULL, '2016-11-27 14:15:17', '--14802273173623245', NULL, 0, '', NULL, NULL, NULL),
(13800, '2016-11-27 14:15:25', NULL, NULL, 4832, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480237524', NULL, '2016-11-27 14:15:25', '--14802273249898435', NULL, 1, 'SR', NULL, NULL, NULL),
(13801, '2016-11-27 14:34:06', NULL, NULL, 4833, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480237524', NULL, '2016-11-27 14:34:06', '--1480228446742243', NULL, 0, '', NULL, NULL, NULL),
(13802, '2016-11-27 14:34:06', NULL, NULL, 4833, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480237524', NULL, '2016-11-27 14:34:06', '--1480228446742243', NULL, 0, '', NULL, NULL, NULL),
(13803, '2016-11-27 14:34:16', NULL, NULL, 4833, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480237524', NULL, '2016-11-27 14:34:16', '--14802284562684157', NULL, 1, 'SR', NULL, NULL, NULL),
(13804, '2016-11-27 14:44:49', NULL, NULL, 4834, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480237524', NULL, '2016-11-27 14:44:49', '--14802290896863085', NULL, 0, '', NULL, NULL, NULL),
(13805, '2016-11-27 10:09:25', NULL, NULL, 4820, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 10:09:25', 'admin-1480205232-148021256510636', 1, 1, 'SR', NULL, NULL, NULL),
(13806, '2016-11-27 11:01:09', NULL, NULL, 4821, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 11:01:09', 'admin-1480205232-1480215668852959', 1, 0, '', NULL, NULL, NULL),
(13807, '2016-11-27 11:01:09', NULL, NULL, 4821, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 11:01:09', 'admin-1480205232-1480215668852959', 1, 0, '', NULL, NULL, NULL),
(13808, '2016-11-27 11:01:20', NULL, NULL, 4821, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 11:01:20', 'admin-1480205232-14802156799324968', 1, 1, 'SR', NULL, NULL, NULL),
(13809, '2016-11-27 11:01:20', NULL, NULL, 4821, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 11:01:20', 'admin-1480205232-14802156799324968', 1, 1, 'SR', NULL, NULL, NULL),
(13810, '2016-11-27 11:05:12', NULL, NULL, 4822, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 11:05:12', 'admin-1480205232-14802159125725116', 1, 1, 'SR', NULL, NULL, NULL),
(13811, '2016-11-27 11:05:12', NULL, NULL, 4822, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 11:05:12', 'admin-1480205232-14802159125725116', 1, 1, 'SR', NULL, NULL, NULL),
(13812, '2016-11-27 11:06:16', NULL, NULL, 4822, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 11:06:16', 'admin-1480205232-148021597597345', 1, 1, 'SR', NULL, NULL, NULL),
(13813, '2016-11-27 11:06:16', NULL, NULL, 4822, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 11:06:16', 'admin-1480205232-148021597597345', 1, 1, 'SR', NULL, NULL, NULL),
(13814, '2016-11-27 11:10:36', NULL, NULL, 4823, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 11:10:36', 'admin-1480205232-14802162365526417', 1, 0, '', NULL, NULL, NULL),
(13815, '2016-11-27 11:10:36', NULL, NULL, 4823, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 11:10:36', 'admin-1480205232-14802162365526417', 1, 0, '', NULL, NULL, NULL),
(13816, '2016-11-27 11:10:47', NULL, NULL, 4823, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 11:10:47', 'admin-1480205232-14802162473189743', 1, 1, 'SR', NULL, NULL, NULL),
(13817, '2016-11-27 11:20:00', NULL, NULL, 4824, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 11:20:00', 'admin-1480205232-14802167999391768', 1, 0, '', NULL, NULL, NULL),
(13818, '2016-11-27 11:20:00', NULL, NULL, 4824, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 11:20:00', 'admin-1480205232-14802167999391768', 1, 0, '', NULL, NULL, NULL),
(13819, '2016-11-27 11:20:00', NULL, NULL, 4824, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 11:20:00', 'admin-1480205232-14802167999391768', 1, 1, 'SR', NULL, NULL, NULL),
(13820, '2016-11-27 11:20:00', NULL, NULL, 4824, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 11:20:00', 'admin-1480205232-14802167999391768', 1, 1, 'SR', NULL, NULL, NULL),
(13821, '2016-11-27 12:29:27', NULL, NULL, 4825, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 12:29:27', 'admin-1480205232-14802209677405866', 1, 0, '', NULL, NULL, NULL),
(13822, '2016-11-27 12:39:07', NULL, NULL, 4825, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 12:39:07', 'admin-1480205232-14802215473424435', 1, 1, 'SR', NULL, NULL, NULL),
(13823, '2016-11-27 12:42:50', NULL, NULL, 4826, 0, 224, '158', 'Set Garlic Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 12:42:50', 'admin-1480205232-14802217707204897', 1, 0, '', NULL, NULL, NULL),
(13824, '2016-11-27 12:43:57', NULL, NULL, 4826, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 12:43:57', 'admin-1480221795-1480221837395798', 1, 0, '', NULL, NULL, NULL),
(13825, '2016-11-27 12:44:26', NULL, NULL, 4826, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 12:44:26', 'admin-1480221795-14802218664742424', 1, 0, '', NULL, NULL, NULL),
(13826, '2016-11-27 12:44:46', NULL, NULL, 4826, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 12:44:46', 'admin-1480221795-14802218865736550', 1, 1, 'SR', NULL, NULL, NULL),
(13827, '2016-11-27 12:44:46', NULL, NULL, 4826, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 12:44:46', 'admin-1480221795-14802218865736550', 1, 0, '', NULL, NULL, NULL),
(13828, '2016-11-27 12:52:44', NULL, NULL, 4827, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 12:52:44', 'admin-1480221795-14802223645287980', 1, 1, 'SR', NULL, NULL, NULL),
(13829, '2016-11-27 13:10:26', NULL, NULL, 4828, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 13:10:26', 'admin-1480221795-14802234262248466', 1, 1, 'SR', NULL, NULL, NULL),
(13830, '2016-11-27 13:11:03', NULL, NULL, 4826, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 13:11:03', 'admin-1480221795-1480223463497424', 1, 1, 'SR', NULL, NULL, NULL),
(13831, '2016-11-27 13:14:45', NULL, NULL, 4829, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 13:14:45', 'admin-1480221795-14802236850578319', 1, 1, 'SR', NULL, NULL, NULL),
(13832, '2016-11-27 13:14:45', NULL, NULL, 4829, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 13:14:45', 'admin-1480221795-14802236850578319', 1, 1, 'SR', NULL, NULL, NULL),
(13833, '2016-11-27 14:15:17', NULL, NULL, 4832, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480237524', NULL, '2016-11-27 14:15:17', '--14802273173623245', NULL, 0, '', NULL, NULL, NULL),
(13834, '2016-11-27 14:15:17', NULL, NULL, 4832, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1480237524', NULL, '2016-11-27 14:15:17', '--14802273173623245', NULL, 0, '', NULL, NULL, NULL),
(13835, '2016-11-27 14:15:17', NULL, NULL, 4832, 0, 85, '85', 'Set Sauted Mushroom Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480237524', NULL, '2016-11-27 14:15:17', '--14802273173623245', NULL, 1, 'SR', NULL, NULL, NULL),
(13836, '2016-11-27 14:15:17', NULL, NULL, 4832, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480237524', NULL, '2016-11-27 14:15:17', '--14802273173623245', NULL, 0, '', NULL, NULL, NULL),
(13837, '2016-11-27 13:23:25', NULL, NULL, 4831, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 13:23:25', 'admin-1480221795-14802242049022181', 1, 1, 'SR', NULL, NULL, NULL),
(13838, '2016-11-27 13:22:24', NULL, NULL, 4831, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 13:22:24', 'admin-1480221795-14802241445391340', 1, 1, 'SR', NULL, NULL, NULL),
(13839, '2016-11-27 13:22:24', NULL, NULL, 4831, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 13:22:24', 'admin-1480221795-14802241445391340', 1, 1, 'SR', NULL, NULL, NULL),
(13840, '2016-11-27 13:18:03', NULL, NULL, 4830, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 13:18:03', 'admin-1480221795-14802238829098963', 1, 1, 'SR', NULL, NULL, NULL),
(13841, '2016-11-27 13:17:23', NULL, NULL, 4830, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 13:17:23', 'admin-1480221795-1480223843803682', 1, 0, '', NULL, NULL, NULL),
(13842, '2016-11-27 13:17:23', NULL, NULL, 4830, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 13:17:23', 'admin-1480221795-1480223843803682', 1, 1, 'SR', NULL, NULL, NULL),
(13843, '2016-11-27 13:14:45', NULL, NULL, 4829, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 13:14:45', 'admin-1480221795-14802236850578319', 1, 0, '', NULL, NULL, NULL),
(13844, '2016-11-27 10:08:57', NULL, NULL, 4820, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 10:08:57', 'admin-1480205232-14802125371927726', 1, 0, '', NULL, NULL, NULL),
(13845, '2016-11-27 10:08:57', NULL, NULL, 4820, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1480237524', 'admin', '2016-11-27 10:08:57', 'admin-1480205232-14802125371927726', 1, 0, '', NULL, NULL, NULL),
(13846, '2016-11-28 15:55:50', NULL, NULL, 4859, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 15:55:50', 'admin-1480307144-1480319750206565', 1, 1, 'SR', NULL, NULL, NULL),
(13847, '2016-11-28 15:55:50', NULL, NULL, 4859, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 15:55:50', 'admin-1480307144-1480319750206565', 1, 1, 'SR', NULL, NULL, NULL),
(13848, '2016-11-28 16:05:18', NULL, NULL, 4859, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 16:05:18', 'admin-1480307144-14803203177926321', 1, 0, '', NULL, NULL, NULL),
(13849, '2016-11-28 16:05:18', NULL, NULL, 4859, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 16:05:18', 'admin-1480307144-14803203177926321', 1, 1, 'SR', NULL, NULL, NULL),
(13850, '2016-11-28 16:05:18', NULL, NULL, 4859, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 16:05:18', 'admin-1480307144-14803203177926321', 1, 0, '', NULL, NULL, NULL),
(13851, '2016-11-28 14:37:50', NULL, NULL, 4857, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 14:37:50', 'admin-1480307144-14803150698381593', 1, 1, 'SR', NULL, NULL, NULL),
(13852, '2016-11-28 15:30:30', NULL, NULL, 4858, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 15:30:30', 'admin-1480307144-14803182299972340', 1, 1, 'SR', NULL, NULL, NULL),
(13853, '2016-11-28 14:48:59', NULL, NULL, 4857, 0, 182, '117', 'Open Drinks ', 'white wine', 'Cold Drinks', 'Fresh Juice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 14:48:59', 'admin-1480307144-14803157389251172', 1, 0, '', NULL, NULL, NULL),
(13854, '2016-11-28 14:37:39', NULL, NULL, 4857, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 14:37:39', 'admin-1480307144-14803150590946839', 1, 1, 'SR', NULL, NULL, NULL),
(13855, '2016-11-28 10:42:38', NULL, NULL, 4844, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 10:42:38', 'admin-1480294677-14803009582041434', 1, 1, 'SR', NULL, NULL, NULL),
(13856, '2016-11-28 12:06:40', NULL, NULL, 4845, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 12:06:40', 'admin-1480294677-14803060005865921', 1, 1, 'SR', NULL, NULL, NULL),
(13857, '2016-11-28 12:06:40', NULL, NULL, 4845, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 12:06:40', 'admin-1480294677-14803060005865921', 1, 0, '', NULL, NULL, NULL),
(13858, '2016-11-28 12:06:57', NULL, NULL, 4845, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 12:06:57', 'admin-1480294677-14803060168982490', 1, 0, '', NULL, NULL, NULL),
(13859, '2016-11-28 14:34:54', NULL, NULL, 4856, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 14:34:54', 'admin-1480307144-1480314894403538', 1, 1, 'SR', NULL, NULL, NULL),
(13860, '2016-11-28 14:11:34', NULL, NULL, 4855, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 14:11:34', 'admin-1480307144-14803134942706913', 1, 0, '', NULL, NULL, NULL),
(13861, '2016-11-28 14:11:34', NULL, NULL, 4855, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 14:11:34', 'admin-1480307144-14803134942706913', 1, 0, '', NULL, NULL, NULL),
(13862, '2016-11-28 14:11:34', NULL, NULL, 4855, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 14:11:34', 'admin-1480307144-14803134942706913', 1, 1, 'SR', NULL, NULL, NULL),
(13863, '2016-11-28 14:00:40', NULL, NULL, 4854, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 14:00:40', 'admin-1480307144-14803128404024660', 1, 0, '', NULL, NULL, NULL),
(13864, '2016-11-28 14:00:40', NULL, NULL, 4854, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 14:00:40', 'admin-1480307144-14803128404024660', 1, 1, 'SR', NULL, NULL, NULL),
(13865, '2016-11-28 13:49:29', NULL, NULL, 4848, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 13:49:29', 'admin-1480307144-14803121690289720', 1, 1, 'SR', NULL, NULL, NULL),
(13866, '2016-11-28 13:41:41', NULL, NULL, 4853, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 13:41:41', 'admin-1480307144-1480311700833602', 1, 0, '', NULL, NULL, NULL),
(13867, '2016-11-28 13:34:13', NULL, NULL, 4852, 0, 84, '84', 'Set Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 13:34:13', 'admin-1480307144-14803112534774410', 1, 1, 'SR', NULL, NULL, NULL),
(13868, '2016-11-28 13:01:26', NULL, NULL, 4851, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 13:01:26', 'admin-1480307144-14803092867354118', 1, 0, '', NULL, NULL, NULL),
(13869, '2016-11-28 13:01:26', NULL, NULL, 4851, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 13:01:26', 'admin-1480307144-14803092867354118', 1, 0, '', NULL, NULL, NULL),
(13870, '2016-11-28 13:01:26', NULL, NULL, 4851, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 13:01:26', 'admin-1480307144-14803092867354118', 1, 1, 'SR', NULL, NULL, NULL),
(13871, '2016-11-28 13:01:26', NULL, NULL, 4851, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 13:01:26', 'admin-1480307144-14803092867354118', 1, 1, 'SR', NULL, NULL, NULL),
(13872, '2016-11-28 12:52:58', NULL, NULL, 4850, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 12:52:58', 'admin-1480307144-14803087780714552', 1, 1, 'SR', NULL, NULL, NULL),
(13873, '2016-11-28 12:52:58', NULL, NULL, 4850, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 12:52:58', 'admin-1480307144-14803087780714552', 1, 1, 'SR', NULL, NULL, NULL),
(13874, '2016-11-28 12:52:50', NULL, NULL, 4850, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 12:52:50', 'admin-1480307144-14803087701514121', 1, 1, 'SR', NULL, NULL, NULL),
(13875, '2016-11-28 12:52:50', NULL, NULL, 4850, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 12:52:50', 'admin-1480307144-14803087701514121', 1, 1, 'SR', NULL, NULL, NULL),
(13876, '2016-11-28 12:50:27', NULL, NULL, 4849, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 12:50:27', 'admin-1480307144-14803086274339651', 1, 1, 'SR', NULL, NULL, NULL),
(13877, '2016-11-28 12:43:30', NULL, NULL, 4848, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 12:43:30', 'admin-1480307144-1480308210380571', 1, 1, 'SR', NULL, NULL, NULL),
(13878, '2016-11-28 12:25:36', NULL, NULL, 4847, 0, 83, '83', 'Set Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 12:25:36', 'admin-1480294677-14803071358898935', 1, 1, 'SR', NULL, NULL, NULL),
(13879, '2016-11-28 12:25:36', NULL, NULL, 4847, 0, 82, '82', 'Set Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 12:25:36', 'admin-1480294677-14803071358898935', 1, 1, 'SR', NULL, NULL, NULL),
(13880, '2016-11-28 12:25:36', NULL, NULL, 4847, 0, 86, '86', 'Set Pesto Pasta ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 12:25:36', 'admin-1480294677-14803071358898935', 1, 1, 'SR', NULL, NULL, NULL),
(13881, '2016-11-28 12:25:36', NULL, NULL, 4847, 0, 86, '86', 'Set Pesto Pasta ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 12:25:36', 'admin-1480294677-14803071358898935', 1, 1, 'SR', NULL, NULL, NULL),
(13882, '2016-11-28 12:25:36', NULL, NULL, 4847, 0, 224, '158', 'Set Garlic Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 12:25:36', 'admin-1480294677-14803071358898935', 1, 0, '', NULL, NULL, NULL),
(13883, '2016-11-28 12:07:44', NULL, NULL, 4846, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 12:07:44', 'admin-1480294677-14803060644366322', 1, 1, 'SR', NULL, NULL, NULL),
(13884, '2016-11-28 12:07:44', NULL, NULL, 4846, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 12:07:44', 'admin-1480294677-14803060644366322', 1, 1, 'SR', NULL, NULL, NULL),
(13885, '2016-11-28 10:37:26', NULL, NULL, 4843, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 10:37:26', 'admin-1480294677-14803006461709956', 1, 1, 'SR', NULL, NULL, NULL),
(13886, '2016-11-28 10:37:18', NULL, NULL, 4843, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 10:37:18', 'admin-1480294677-14803006388063332', 1, 0, '', NULL, NULL, NULL),
(13887, '2016-11-28 10:37:18', NULL, NULL, 4843, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 10:37:18', 'admin-1480294677-14803006388063332', 1, 0, '', NULL, NULL, NULL),
(13888, '2016-11-28 10:32:36', NULL, NULL, 4842, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 10:32:36', 'admin-1480294677-1480300356445907', 1, 0, '', NULL, NULL, NULL),
(13889, '2016-11-28 10:32:36', NULL, NULL, 4842, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 10:32:36', 'admin-1480294677-1480300356445907', 1, 1, 'SR', NULL, NULL, NULL),
(13890, '2016-11-28 10:14:08', NULL, NULL, 4841, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 10:14:08', 'admin-1480294677-14802992488045095', 1, 0, '', NULL, NULL, NULL),
(13891, '2016-11-28 10:14:00', NULL, NULL, 4841, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 10:14:00', 'admin-1480294677-14802992403564432', 1, 0, '', NULL, NULL, NULL),
(13892, '2016-11-28 09:21:18', NULL, NULL, 4840, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 09:21:18', 'admin-1480294677-14802960779057086', 1, 1, 'SR', NULL, NULL, NULL),
(13893, '2016-11-28 09:21:18', NULL, NULL, 4840, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 09:21:18', 'admin-1480294677-14802960779057086', 1, 1, 'SR', NULL, NULL, NULL),
(13894, '2016-11-28 09:21:18', NULL, NULL, 4840, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 09:21:18', 'admin-1480294677-14802960779057086', 1, 0, '', NULL, NULL, NULL),
(13895, '2016-11-28 09:21:18', NULL, NULL, 4840, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 09:21:18', 'admin-1480294677-14802960779057086', 1, 1, 'SR', NULL, NULL, NULL),
(13896, '2016-11-28 09:21:08', NULL, NULL, 4840, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 09:21:08', 'admin-1480294677-14802960684124568', 1, 0, '', NULL, NULL, NULL),
(13897, '2016-11-28 09:21:08', NULL, NULL, 4840, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480307144', 'admin', '2016-11-28 09:21:08', 'admin-1480294677-14802960684124568', 1, 0, '', NULL, NULL, NULL),
(13898, '2016-11-30 11:50:59', NULL, NULL, 4863, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 11:50:59', 'admin-1480467679-14804778594278832', 1, 1, 'SR', NULL, NULL, NULL),
(13899, '2016-11-30 12:06:00', NULL, NULL, 4863, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 12:06:00', 'admin-1480467679-14804787598603221', 1, 1, 'SR', NULL, NULL, NULL),
(13900, '2016-11-30 12:06:05', NULL, NULL, 4863, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 12:06:05', 'admin-1480467679-14804787653342844', 1, 0, '', NULL, NULL, NULL),
(13901, '2016-11-30 12:35:33', NULL, NULL, 4863, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 12:35:33', 'admin-1480467679-14804805338237539', 1, 1, 'SR', NULL, NULL, NULL),
(13902, '2016-11-30 12:38:29', NULL, NULL, 4863, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 12:38:29', 'admin-1480467679-14804807095061990', 1, 0, '', NULL, NULL, NULL),
(13903, '2016-11-30 13:18:24', NULL, NULL, 4863, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 13:18:24', 'admin-1480467679-14804831043006380', 1, 0, '', NULL, NULL, NULL),
(13904, '2016-11-30 14:31:12', NULL, NULL, 4864, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 14:31:12', 'admin-1480483116-1480487471884326', 1, 0, '', NULL, NULL, NULL),
(13905, '2016-11-30 14:31:12', NULL, NULL, 4864, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 14:31:12', 'admin-1480483116-1480487471884326', 1, 0, '', NULL, NULL, NULL),
(13906, '2016-11-30 15:46:03', NULL, NULL, 4865, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 15:46:03', 'admin-1480483116-14804919635686428', 1, 1, 'SR', 1, NULL, NULL),
(13907, '2016-11-30 15:46:03', NULL, NULL, 4865, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 15:46:03', 'admin-1480483116-14804919635686428', 1, 1, 'SR', 1, NULL, NULL),
(13908, '2016-11-30 17:21:42', NULL, NULL, 4866, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 17:21:42', 'admin-1480483116-14804977026801699', 1, 1, 'SR', NULL, NULL, NULL),
(13909, '2016-11-30 17:21:42', NULL, NULL, 4866, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 17:21:42', 'admin-1480483116-14804977026801699', 1, 1, 'SR', NULL, NULL, NULL),
(13910, '2016-11-30 17:25:39', NULL, NULL, 4866, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 17:25:39', 'admin-1480483116-14804979396226936', 1, 0, '', NULL, NULL, NULL),
(13911, '2016-11-30 11:50:47', NULL, NULL, 4863, 0, 217, '151', 'Spicy Lemony Wings', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 11:50:47', 'admin-1480467679-14804778473994042', 1, 0, '', NULL, NULL, NULL),
(13912, '2016-11-30 11:50:47', NULL, NULL, 4863, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 11:50:47', 'admin-1480467679-14804778473994042', 1, 0, '', NULL, NULL, NULL),
(13913, '2016-11-30 11:39:23', NULL, NULL, 4862, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 11:39:23', 'admin-1480467679-14804771634655389', 1, 1, 'SR', NULL, NULL, NULL),
(13914, '2016-11-30 11:39:23', NULL, NULL, 4862, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 11:39:23', 'admin-1480467679-14804771634655389', 1, 1, 'SR', NULL, NULL, NULL),
(13915, '2016-11-30 11:39:23', NULL, NULL, 4862, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 11:39:23', 'admin-1480467679-14804771634655389', 1, 0, '', NULL, NULL, NULL),
(13916, '2016-11-30 11:39:13', NULL, NULL, 4862, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 11:39:13', 'admin-1480467679-14804771535379419', 1, 1, 'SR', NULL, NULL, NULL),
(13917, '2016-11-30 11:23:34', NULL, NULL, 4861, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 11:23:34', 'admin-1480467679-14804762146334581', 1, 0, '', NULL, NULL, NULL),
(13918, '2016-11-30 10:32:34', NULL, NULL, 4860, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 10:32:34', 'admin-1480467679-14804731543122786', 1, 0, '', NULL, NULL, NULL),
(13919, '2016-11-30 11:23:34', NULL, NULL, 4861, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 11:23:34', 'admin-1480467679-14804762146334581', 1, 1, 'SR', NULL, NULL, NULL),
(13920, '2016-11-30 10:32:34', NULL, NULL, 4860, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 10:32:34', 'admin-1480467679-14804731543122786', 1, 0, '', NULL, NULL, NULL),
(13921, '2016-11-30 10:32:34', NULL, NULL, 4860, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 10:32:34', 'admin-1480467679-14804731543122786', 1, 0, '', NULL, NULL, NULL),
(13922, '2016-11-30 10:32:34', NULL, NULL, 4860, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1480483116', 'admin', '2016-11-30 10:32:34', 'admin-1480467679-14804731543122786', 1, 1, 'SR', NULL, NULL, NULL),
(13923, '2016-12-01 18:57:36', NULL, NULL, 4888, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 18:57:36', 'admin-1480570745-14805898564305353', 1, 1, 'SR', NULL, NULL, NULL),
(13924, '2016-12-01 18:55:00', NULL, NULL, 4887, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 18:55:00', 'admin-1480570745-14805897001755311', 1, 1, 'SR', NULL, NULL, NULL),
(13925, '2016-12-01 18:57:36', NULL, NULL, 4888, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 18:57:36', 'admin-1480570745-14805898564305353', 1, 1, 'SR', NULL, NULL, NULL),
(13926, '2016-12-01 19:33:33', NULL, NULL, 4887, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 19:33:33', 'admin-1480570745-14805920130354742', 1, 1, 'SR', NULL, NULL, NULL),
(13927, '2016-12-01 19:33:33', NULL, NULL, 4887, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 19:33:33', 'admin-1480570745-14805920130354742', 1, 1, 'SR', NULL, NULL, NULL),
(13928, '2016-12-01 18:11:48', NULL, NULL, 4885, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 18:11:48', 'admin-1480570745-14805871087852674', 1, 1, 'SR', NULL, NULL, NULL),
(13929, '2016-12-01 18:16:37', NULL, NULL, 4885, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 18:16:37', 'admin-1480570745-14805873968427498', 1, 0, '', NULL, NULL, NULL),
(13930, '2016-12-01 18:40:17', NULL, NULL, 4886, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 18:40:17', 'admin-1480570745-14805888170034235', 1, 1, 'SR', NULL, NULL, NULL),
(13931, '2016-12-01 18:40:17', NULL, NULL, 4886, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 18:40:17', 'admin-1480570745-14805888170034235', 1, 1, 'SR', NULL, NULL, NULL),
(13932, '2016-12-01 18:44:50', NULL, NULL, 4886, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 18:44:50', 'admin-1480570745-14805890902364647', 1, 0, '', NULL, NULL, NULL),
(13933, '2016-12-01 18:11:48', NULL, NULL, 4885, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 18:11:48', 'admin-1480570745-14805871087852674', 1, 1, 'SR', NULL, NULL, NULL),
(13934, '2016-12-01 17:34:16', NULL, NULL, 4884, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 17:34:16', 'admin-1480570745-1480584856218828', 1, 1, 'SR', NULL, NULL, NULL),
(13935, '2016-12-01 17:34:16', NULL, NULL, 4884, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 17:34:16', 'admin-1480570745-1480584856218828', 1, 1, 'SR', NULL, NULL, NULL),
(13936, '2016-12-01 16:15:44', NULL, NULL, 4882, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 16:15:44', 'admin-1480570745-14805801447726245', 1, 1, 'SR', NULL, NULL, NULL),
(13937, '2016-12-01 16:46:20', NULL, NULL, 4883, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 16:46:20', 'admin-1480570745-14805819805746999', 1, 1, 'SR', 1, NULL, NULL),
(13938, '2016-12-01 16:46:20', NULL, NULL, 4883, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 16:46:20', 'admin-1480570745-14805819805746999', 1, 1, 'SR', 1, NULL, NULL),
(13939, '2016-12-01 18:55:00', NULL, NULL, 4887, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 18:55:00', 'admin-1480570745-14805897001755311', 1, 0, '', NULL, NULL, NULL),
(13940, '2016-12-01 18:55:00', NULL, NULL, 4887, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 18:55:00', 'admin-1480570745-14805897001755311', 1, 1, 'SR', NULL, NULL, NULL),
(13941, '2016-12-01 13:57:30', NULL, NULL, 4878, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 13:57:30', 'admin-1480570745-14805718501359181', 1, 1, 'SR', NULL, NULL, NULL),
(13942, '2016-12-01 13:57:36', NULL, NULL, 4878, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 13:57:36', 'admin-1480570745-14805718558396983', 1, 1, 'SR', NULL, NULL, NULL),
(13943, '2016-12-01 13:57:36', NULL, NULL, 4878, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 13:57:36', 'admin-1480570745-14805718558396983', 1, 0, '', NULL, NULL, NULL),
(13944, '2016-12-01 14:08:37', NULL, NULL, 4875, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 14:08:37', 'admin-1480570745-14805725175697575', 1, 0, '', NULL, NULL, NULL),
(13945, '2016-12-01 14:17:20', NULL, NULL, 4875, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 14:17:20', 'admin-1480570745-14805730404705395', 1, 1, 'SR', NULL, NULL, NULL),
(13946, '2016-12-01 14:17:20', NULL, NULL, 4875, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 14:17:20', 'admin-1480570745-14805730404705395', 1, 1, 'SR', NULL, NULL, NULL),
(13947, '2016-12-01 15:39:21', NULL, NULL, 4880, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 15:39:21', 'admin-1480570745-14805779617031545', 1, 0, '', 1, NULL, NULL),
(13948, '2016-12-01 15:39:21', NULL, NULL, 4880, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 15:39:21', 'admin-1480570745-14805779617031545', 1, 1, 'SR', 1, NULL, NULL),
(13949, '2016-12-01 15:39:21', NULL, NULL, 4880, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 15:39:21', 'admin-1480570745-14805779617031545', 1, 0, '', 1, NULL, NULL),
(13950, '2016-12-01 15:40:13', NULL, NULL, 4881, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 15:40:13', 'admin-1480570745-14805780129222458', 1, 1, 'SR', 1, NULL, NULL),
(13951, '2016-12-01 15:40:13', NULL, NULL, 4881, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 15:40:13', 'admin-1480570745-14805780129222458', 1, 1, 'SR', 1, NULL, NULL),
(13952, '2016-12-01 13:41:28', NULL, NULL, 4877, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 13:41:28', 'admin-1480570745-14805708884685825', 1, 1, 'SR', NULL, NULL, NULL),
(13953, '2016-12-01 13:53:51', NULL, NULL, 4879, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 13:53:51', 'admin-1480570745-1480571630893957', 1, 1, 'SR', NULL, NULL, NULL),
(13954, '2016-12-01 13:53:41', NULL, NULL, 4878, 0, 74, '74', 'Sunrice', 'without egg', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 13:53:41', 'admin-1480570745-14805716213022450', 1, 1, 'SR', NULL, NULL, NULL),
(13955, '2016-12-01 13:41:28', NULL, NULL, 4877, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 13:41:28', 'admin-1480570745-14805708884685825', 1, 1, 'SR', NULL, NULL, NULL),
(13956, '2016-12-01 13:41:20', NULL, NULL, 4877, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 13:41:20', 'admin-1480570745-14805708798755812', 1, 1, 'SR', NULL, NULL, NULL),
(13957, '2016-12-01 13:39:00', NULL, NULL, 4876, 0, 214, '148', 'Set Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 13:39:00', 'admin-1480559541-14805707402544271', 1, 0, '', NULL, NULL, NULL),
(13958, '2016-12-01 13:39:00', NULL, NULL, 4876, 0, 84, '84', 'Set Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 13:39:00', 'admin-1480559541-14805707402544271', 1, 1, 'SR', NULL, NULL, NULL),
(13959, '2016-12-01 13:31:29', NULL, NULL, 4875, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 13:31:29', 'admin-1480559541-14805702890851260', 1, 1, 'SR', NULL, NULL, NULL),
(13960, '2016-12-01 13:31:29', NULL, NULL, 4875, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 13:31:29', 'admin-1480559541-14805702890851260', 1, 0, '', NULL, NULL, NULL),
(13961, '2016-12-01 13:31:23', NULL, NULL, 4875, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 13:31:23', 'admin-1480559541-14805702833858214', 1, 1, 'SR', NULL, NULL, NULL),
(13962, '2016-12-01 10:16:23', NULL, NULL, 4869, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 10:16:23', 'admin-1480553288-14805585833654336', 1, 0, '', NULL, NULL, NULL),
(13963, '2016-12-01 10:16:23', NULL, NULL, 4869, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 10:16:23', 'admin-1480553288-14805585833654336', 1, 0, '', NULL, NULL, NULL),
(13964, '2016-12-01 10:17:13', NULL, NULL, 4869, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 10:17:13', 'admin-1480553288-14805586334191685', 1, 0, '', NULL, NULL, NULL),
(13965, '2016-12-01 10:17:13', NULL, NULL, 4869, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 10:17:13', 'admin-1480553288-14805586334191685', 1, 0, '', NULL, NULL, NULL),
(13966, '2016-12-01 10:22:36', NULL, NULL, 4869, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 10:22:36', 'admin-1480553288-14805589558551587', 1, 0, '', NULL, NULL, NULL),
(13967, '2016-12-01 10:22:36', NULL, NULL, 4869, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 10:22:36', 'admin-1480553288-14805589558551587', 1, 0, '', NULL, NULL, NULL),
(13968, '2016-12-01 10:22:36', NULL, NULL, 4869, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 10:22:36', 'admin-1480553288-14805589558551587', 1, 0, '', NULL, NULL, NULL),
(13969, '2016-12-01 10:32:15', NULL, NULL, 4870, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 10:32:15', 'admin-1480553288-1480559535176239', 1, 0, '', NULL, NULL, NULL),
(13970, '2016-12-01 10:32:15', NULL, NULL, 4870, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 10:32:15', 'admin-1480553288-1480559535176239', 1, 1, 'SR', NULL, NULL, NULL),
(13971, '2016-12-01 10:32:32', NULL, NULL, 4870, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 10:32:32', 'admin-1480559541-14805595521236814', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(13972, '2016-12-01 10:32:32', NULL, NULL, 4870, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 10:32:32', 'admin-1480559541-14805595521236814', 1, 1, 'SR', NULL, NULL, NULL),
(13973, '2016-12-01 10:51:36', NULL, NULL, 4871, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 10:51:36', 'admin-1480559541-14805606968458449', 1, 0, '', NULL, NULL, NULL),
(13974, '2016-12-01 10:51:37', NULL, NULL, 4871, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 10:51:37', 'admin-1480559541-14805606968458449', 1, 1, 'SR', NULL, NULL, NULL),
(13975, '2016-12-01 11:28:20', NULL, NULL, 4872, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 11:28:20', 'admin-1480559541-14805629000498328', 1, 1, 'SR', NULL, NULL, NULL),
(13976, '2016-12-01 10:51:37', NULL, NULL, 4871, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 10:51:37', 'admin-1480559541-14805606968458449', 1, 1, 'SR', NULL, NULL, NULL),
(13977, '2016-12-01 10:51:54', NULL, NULL, 4871, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 10:51:54', 'admin-1480559541-14805607141169292', 1, 0, '', NULL, NULL, NULL),
(13978, '2016-12-01 11:28:20', NULL, NULL, 4872, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 11:28:20', 'admin-1480559541-14805629000498328', 1, 1, 'SR', NULL, NULL, NULL),
(13979, '2016-12-01 11:59:56', NULL, NULL, 4873, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 11:59:56', 'admin-1480559541-14805647961302261', 1, 1, 'SR', NULL, NULL, NULL),
(13980, '2016-12-01 11:59:56', NULL, NULL, 4873, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 11:59:56', 'admin-1480559541-14805647961302261', 1, 1, 'SR', NULL, NULL, NULL),
(13981, '2016-12-01 13:03:02', NULL, NULL, 4874, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 13:03:02', 'admin-1480559541-1480568582094710', 1, 1, 'SR', NULL, NULL, NULL),
(13982, '2016-12-01 13:03:02', NULL, NULL, 4874, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 13:03:02', 'admin-1480559541-1480568582094710', 1, 0, '', NULL, NULL, NULL),
(13983, '2016-12-01 13:03:02', NULL, NULL, 4874, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 13:03:02', 'admin-1480559541-1480568582094710', 1, 0, '', NULL, NULL, NULL),
(13984, '2016-12-01 13:03:02', NULL, NULL, 4874, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 13:03:02', 'admin-1480559541-1480568582094710', 1, 0, '', NULL, NULL, NULL),
(13985, '2016-12-01 13:03:02', NULL, NULL, 4874, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 13:03:02', 'admin-1480559541-1480568582094710', 1, 0, '', NULL, NULL, NULL),
(13986, '2016-12-01 13:29:56', NULL, NULL, 4875, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 13:29:56', 'admin-1480559541-1480570196030383', 1, 0, '', NULL, NULL, NULL),
(13987, '2016-12-01 13:29:56', NULL, NULL, 4875, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 13:29:56', 'admin-1480559541-1480570196030383', 1, 1, 'SR', NULL, NULL, NULL),
(13988, '2016-12-01 10:16:16', NULL, NULL, 4869, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 10:16:16', 'admin-1480553288-14805585764364797', 1, 1, 'SR', NULL, NULL, NULL),
(13989, '2016-12-01 10:16:16', NULL, NULL, 4869, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 10:16:16', 'admin-1480553288-14805585764364797', 1, 1, 'SR', NULL, NULL, NULL),
(13990, '2016-12-01 10:16:16', NULL, NULL, 4869, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 10:16:16', 'admin-1480553288-14805585764364797', 1, 1, 'SR', NULL, NULL, NULL),
(13991, '2016-12-01 09:59:36', NULL, NULL, 4868, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 09:59:36', 'admin-1480553288-148055757665276', 1, 1, 'SR', NULL, NULL, NULL),
(13992, '2016-12-01 09:59:36', NULL, NULL, 4868, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 09:59:36', 'admin-1480553288-148055757665276', 1, 1, 'SR', NULL, NULL, NULL),
(13993, '2016-12-01 09:59:36', NULL, NULL, 4868, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 09:59:36', 'admin-1480553288-148055757665276', 1, 1, 'SR', NULL, NULL, NULL),
(13994, '2016-12-01 09:59:36', NULL, NULL, 4868, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 09:59:36', 'admin-1480553288-148055757665276', 1, 1, 'SR', NULL, NULL, NULL),
(13995, '2016-12-01 09:46:09', NULL, NULL, 4867, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 09:46:09', 'admin-1480553288-14805567696928268', 1, 1, 'SR', NULL, NULL, '10.0'),
(13996, '2016-12-01 09:46:19', NULL, NULL, 4868, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 09:46:19', 'admin-1480553288-14805567791958785', 1, 0, '', NULL, NULL, NULL),
(13997, '2016-12-01 09:46:09', NULL, NULL, 4867, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 09:46:09', 'admin-1480553288-14805567696928268', 1, 1, 'SR', NULL, NULL, '10.0'),
(13998, '2016-12-01 09:42:05', NULL, NULL, 4867, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 09:42:05', 'admin-1480553288-14805565249977980', 1, 0, '', NULL, NULL, '10.0'),
(13999, '2016-12-01 09:42:05', NULL, NULL, 4867, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480570745', 'admin', '2016-12-01 09:42:05', 'admin-1480553288-14805565249977980', 1, 0, '', NULL, NULL, '10.0'),
(14000, '2016-12-02 20:35:55', NULL, NULL, 4917, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 20:35:55', 'admin-1480656735-14806821551949350', 1, 1, 'SR', NULL, NULL, NULL),
(14001, '2016-12-02 20:58:31', NULL, NULL, 4917, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 20:58:31', 'admin-1480656735-14806835113191010', 1, 1, 'SR', NULL, NULL, NULL),
(14002, '2016-12-02 20:58:31', NULL, NULL, 4917, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 20:58:31', 'admin-1480656735-14806835113191010', 1, 1, 'SR', NULL, NULL, NULL),
(14003, '2016-12-02 20:58:31', NULL, NULL, 4917, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 20:58:31', 'admin-1480656735-14806835113191010', 1, 1, 'SR', NULL, NULL, NULL),
(14004, '2016-12-02 20:58:31', NULL, NULL, 4917, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 20:58:31', 'admin-1480656735-14806835113191010', 1, 0, '', NULL, NULL, NULL),
(14005, '2016-12-02 21:10:12', NULL, NULL, 4918, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 21:10:12', 'admin-1480656735-14806842127868210', 1, 0, '', NULL, NULL, NULL),
(14006, '2016-12-02 21:24:44', NULL, NULL, 4919, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 21:24:44', 'admin-1480684220-14806850843212417', 1, 1, 'SR', 1, NULL, NULL),
(14007, '2016-12-02 21:25:07', NULL, NULL, 4920, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 21:25:07', 'admin-1480684220-14806851072269777', 1, 1, 'SR', 1, NULL, NULL),
(14008, '2016-12-02 15:40:46', NULL, NULL, 4912, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 15:40:46', 'admin-1480656735-14806644458504047', 1, 1, 'SR', NULL, NULL, NULL),
(14009, '2016-12-02 20:05:58', NULL, NULL, 4917, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 20:05:58', 'admin-1480656735-14806803580349247', 1, 0, '', NULL, NULL, NULL),
(14010, '2016-12-02 20:05:58', NULL, NULL, 4917, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 20:05:58', 'admin-1480656735-14806803580349247', 1, 0, '', NULL, NULL, NULL),
(14011, '2016-12-02 20:05:58', NULL, NULL, 4917, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 20:05:58', 'admin-1480656735-14806803580349247', 1, 0, '', NULL, NULL, NULL),
(14012, '2016-12-02 20:31:26', NULL, NULL, 4917, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 20:31:26', 'admin-1480656735-14806818865442499', 1, 0, '', NULL, NULL, NULL),
(14013, '2016-12-02 21:31:57', NULL, NULL, 4918, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 21:31:57', 'admin-1480684220-14806855171101164', 1, 0, '', NULL, NULL, NULL),
(14014, '2016-12-02 21:26:52', NULL, NULL, 4921, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 21:26:52', 'admin-1480684220-14806852122146091', 1, 0, '', NULL, NULL, NULL),
(14015, '2016-12-02 21:26:52', NULL, NULL, 4921, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 21:26:52', 'admin-1480684220-14806852122146091', 1, 1, 'SR', NULL, NULL, NULL),
(14016, '2016-12-02 21:26:10', NULL, NULL, 4921, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 21:26:10', 'admin-1480684220-1480685170259489', 1, 0, '', NULL, NULL, NULL),
(14017, '2016-12-02 17:47:37', NULL, NULL, 4914, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 17:47:37', 'admin-1480656735-14806720577498138', 1, 1, 'SR', NULL, NULL, NULL),
(14018, '2016-12-02 20:31:26', NULL, NULL, 4917, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 20:31:26', 'admin-1480656735-14806818865442499', 1, 0, '', NULL, NULL, NULL),
(14019, '2016-12-02 20:35:51', NULL, NULL, 4917, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 20:35:51', 'admin-1480656735-14806821509074354', 1, 0, '', NULL, NULL, NULL),
(14020, '2016-12-02 20:35:51', NULL, NULL, 4917, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 20:35:51', 'admin-1480656735-14806821509074354', 1, 0, '', NULL, NULL, NULL),
(14021, '2016-12-02 19:24:27', NULL, NULL, 4916, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 19:24:27', 'admin-1480656735-14806778668492461', 1, 0, '', NULL, NULL, NULL),
(14022, '2016-12-02 19:24:27', NULL, NULL, 4916, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 19:24:27', 'admin-1480656735-14806778668492461', 1, 0, '', NULL, NULL, NULL),
(14023, '2016-12-02 19:24:27', NULL, NULL, 4916, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 19:24:27', 'admin-1480656735-14806778668492461', 1, 0, '', NULL, NULL, NULL),
(14024, '2016-12-02 18:46:07', NULL, NULL, 4915, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 18:46:07', 'admin-1480656735-148067556756428', 1, 1, 'SR', NULL, NULL, NULL),
(14025, '2016-12-02 19:24:27', NULL, NULL, 4916, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 19:24:27', 'admin-1480656735-14806778668492461', 1, 0, '', NULL, NULL, NULL),
(14026, '2016-12-02 19:24:27', NULL, NULL, 4916, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 19:24:27', 'admin-1480656735-14806778668492461', 1, 0, '', NULL, NULL, NULL),
(14027, '2016-12-02 18:46:07', NULL, NULL, 4915, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 18:46:07', 'admin-1480656735-148067556756428', 1, 1, 'SR', NULL, NULL, NULL),
(14028, '2016-12-02 18:46:07', NULL, NULL, 4915, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 18:46:07', 'admin-1480656735-148067556756428', 1, 1, 'SR', NULL, NULL, NULL),
(14029, '2016-12-02 18:46:07', NULL, NULL, 4915, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 18:46:07', 'admin-1480656735-148067556756428', 1, 1, 'SR', NULL, NULL, NULL),
(14030, '2016-12-02 17:47:37', NULL, NULL, 4914, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 17:47:37', 'admin-1480656735-14806720577498138', 1, 1, 'SR', NULL, NULL, NULL),
(14031, '2016-12-02 16:25:07', NULL, NULL, 4913, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 16:25:07', 'admin-1480656735-14806671073155913', 1, 0, '', NULL, NULL, NULL),
(14032, '2016-12-02 16:25:07', NULL, NULL, 4913, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 16:25:07', 'admin-1480656735-14806671073155913', 1, 0, '', NULL, NULL, NULL),
(14033, '2016-12-02 16:25:07', NULL, NULL, 4913, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 16:25:07', 'admin-1480656735-14806671073155913', 1, 1, 'SR', NULL, NULL, NULL),
(14034, '2016-12-02 15:45:59', NULL, NULL, 4906, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 15:45:59', 'admin-1480656735-14806647594515334', 1, 1, 'SR', NULL, NULL, NULL),
(14035, '2016-12-02 14:49:00', NULL, NULL, 4910, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 14:49:01', 'admin-1480656735-14806613407481754', 1, 1, 'SR', NULL, NULL, NULL),
(14036, '2016-12-02 14:49:01', NULL, NULL, 4910, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 14:49:01', 'admin-1480656735-14806613407481754', 1, 1, 'SR', NULL, NULL, NULL),
(14037, '2016-12-02 14:54:49', NULL, NULL, 4911, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 14:54:49', 'admin-1480656735-14806616889497187', 1, 1, 'SR', NULL, NULL, NULL),
(14038, '2016-12-02 19:24:34', NULL, NULL, 4916, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 19:24:34', 'admin-1480656735-14806778738821563', 1, 0, '', NULL, NULL, NULL),
(14039, '2016-12-02 19:24:34', NULL, NULL, 4916, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 19:24:34', 'admin-1480656735-14806778738821563', 1, 0, '', NULL, NULL, NULL),
(14040, '2016-12-02 15:40:46', NULL, NULL, 4912, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 15:40:46', 'admin-1480656735-14806644458504047', 1, 0, '', NULL, NULL, NULL),
(14041, '2016-12-02 14:01:54', NULL, NULL, 4908, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 14:01:54', 'admin-1480656735-14806585144174124', 1, 1, 'SR', NULL, NULL, NULL),
(14042, '2016-12-02 14:35:10', NULL, NULL, 4909, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 14:35:10', 'admin-1480656735-1480660510150123', 1, 0, '', NULL, NULL, NULL),
(14043, '2016-12-02 14:35:27', NULL, NULL, 4909, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 14:35:27', 'admin-1480656735-14806605276084354', 1, 1, 'SR', NULL, NULL, NULL),
(14044, '2016-12-02 14:35:10', NULL, NULL, 4909, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 14:35:10', 'admin-1480656735-1480660510150123', 1, 0, '', NULL, NULL, NULL),
(14045, '2016-12-02 14:48:10', NULL, NULL, 4910, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 14:48:10', 'admin-1480656735-14806612906988740', 1, 0, '', NULL, NULL, NULL),
(14046, '2016-12-02 14:48:10', NULL, NULL, 4910, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 14:48:10', 'admin-1480656735-14806612906988740', 1, 1, 'SR', NULL, NULL, NULL),
(14047, '2016-12-02 14:01:54', NULL, NULL, 4908, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 14:01:54', 'admin-1480656735-14806585144174124', 1, 0, '', NULL, NULL, NULL),
(14048, '2016-12-02 13:21:01', NULL, NULL, 4902, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 13:21:01', 'admin-1480654444-14806560613843071', 1, 0, '', NULL, NULL, NULL),
(14049, '2016-12-02 13:21:01', NULL, NULL, 4902, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 13:21:01', 'admin-1480654444-14806560613843071', 1, 1, 'SR', NULL, NULL, NULL),
(14050, '2016-12-02 13:21:20', NULL, NULL, 4902, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 13:21:20', 'admin-1480654444-14806560805527513', 1, 1, 'SR', NULL, NULL, NULL),
(14051, '2016-12-02 13:21:20', NULL, NULL, 4902, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 13:21:20', 'admin-1480654444-14806560805527513', 1, 1, 'SR', NULL, NULL, NULL),
(14052, '2016-12-02 13:25:56', NULL, NULL, 4903, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 13:25:56', 'admin-1480654444-14806563564415069', 1, 0, '', NULL, NULL, NULL),
(14053, '2016-12-02 13:25:56', NULL, NULL, 4903, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 13:25:56', 'admin-1480654444-14806563564415069', 1, 1, 'SR', NULL, NULL, NULL),
(14054, '2016-12-02 13:27:02', NULL, NULL, 4904, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 13:27:02', 'admin-1480654444-14806564220185797', 1, 1, 'SR', NULL, NULL, NULL),
(14055, '2016-12-02 13:30:35', NULL, NULL, 4902, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 13:30:35', 'admin-1480654444-14806566356654082', 1, 0, '', NULL, NULL, NULL),
(14056, '2016-12-02 13:32:06', NULL, NULL, 4905, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 13:32:06', 'admin-1480654444-14806567264987796', 1, 0, '', NULL, NULL, NULL),
(14057, '2016-12-02 13:34:09', NULL, NULL, 4906, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 13:34:09', 'admin-1480656735-14806568496857386', 1, 0, '', NULL, NULL, NULL),
(14058, '2016-12-02 13:43:10', NULL, NULL, 4907, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 13:43:10', 'admin-1480656735-14806573901682373', 1, 0, '', NULL, NULL, NULL),
(14059, '2016-12-02 14:01:47', NULL, NULL, 4908, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 14:01:47', 'admin-1480656735-14806585069009418', 1, 1, 'SR', NULL, NULL, NULL),
(14060, '2016-12-02 14:01:47', NULL, NULL, 4908, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 14:01:47', 'admin-1480656735-14806585069009418', 1, 0, '', NULL, NULL, NULL),
(14061, '2016-12-02 13:20:08', NULL, NULL, 4902, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 13:20:08', 'admin-1480654444-14806560084107874', 1, 0, '', NULL, NULL, NULL),
(14062, '2016-12-02 12:53:46', NULL, NULL, 4901, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 12:53:46', 'admin-1480641434-14806544267029075', 1, 1, 'SR', NULL, NULL, NULL),
(14063, '2016-12-02 10:39:59', NULL, NULL, 4892, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:39:59', 'admin-1480641434-14806463997278787', 1, 1, 'SR', NULL, NULL, NULL),
(14064, '2016-12-02 10:39:59', NULL, NULL, 4892, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:39:59', 'admin-1480641434-14806463997278787', 1, 0, '', NULL, NULL, NULL),
(14065, '2016-12-02 10:39:59', NULL, NULL, 4892, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:39:59', 'admin-1480641434-14806463997278787', 1, 0, '', NULL, NULL, NULL),
(14066, '2016-12-02 10:40:06', NULL, NULL, 4893, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:40:06', 'admin-1480641434-14806464058918469', 1, 1, 'SR', NULL, NULL, NULL),
(14067, '2016-12-02 10:43:09', NULL, NULL, 4894, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:43:09', 'admin-1480641434-1480646589021395', 1, 1, 'SR', 1, NULL, NULL),
(14068, '2016-12-02 10:43:09', NULL, NULL, 4894, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:43:09', 'admin-1480641434-1480646589021395', 1, 1, 'SR', 1, NULL, NULL),
(14069, '2016-12-02 10:43:31', NULL, NULL, 4895, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:43:31', 'admin-1480641434-14806466109076953', 1, 1, 'SR', 1, NULL, NULL),
(14070, '2016-12-02 10:44:38', NULL, NULL, 4892, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:44:38', 'admin-1480641434-14806466787116457', 1, 0, '', NULL, NULL, NULL),
(14071, '2016-12-02 10:44:38', NULL, NULL, 4892, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:44:38', 'admin-1480641434-14806466787116457', 1, 0, '', NULL, NULL, NULL),
(14072, '2016-12-02 10:44:38', NULL, NULL, 4892, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:44:38', 'admin-1480641434-14806466787116457', 1, 0, '', NULL, NULL, NULL),
(14073, '2016-12-02 10:51:05', NULL, NULL, 4896, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:51:05', 'admin-1480641434-1480647064854209', 1, 0, '', NULL, NULL, NULL),
(14074, '2016-12-02 10:51:05', NULL, NULL, 4896, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:51:05', 'admin-1480641434-1480647064854209', 1, 0, '', NULL, NULL, NULL),
(14075, '2016-12-02 10:51:05', NULL, NULL, 4896, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:51:05', 'admin-1480641434-1480647064854209', 1, 1, 'SR', NULL, NULL, NULL),
(14076, '2016-12-02 10:51:16', NULL, NULL, 4897, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:51:16', 'admin-1480641434-14806470759956411', 1, 1, 'SR', NULL, NULL, NULL),
(14077, '2016-12-02 10:51:29', NULL, NULL, 4896, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:51:29', 'admin-1480641434-1480647089493563', 1, 1, 'SR', NULL, NULL, NULL),
(14078, '2016-12-02 10:52:06', NULL, NULL, 4897, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:52:06', 'admin-1480641434-14806471262091072', 1, 1, 'SR', NULL, NULL, NULL),
(14079, '2016-12-02 11:28:02', NULL, NULL, 4898, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 11:28:02', 'admin-1480641434-1480649282620525', 1, 1, 'SR', NULL, NULL, NULL),
(14080, '2016-12-02 11:29:14', NULL, NULL, 4899, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 11:29:14', 'admin-1480641434-14806493538996358', 1, 1, 'SR', NULL, NULL, NULL),
(14081, '2016-12-02 11:29:14', NULL, NULL, 4899, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 11:29:14', 'admin-1480641434-14806493538996358', 1, 1, 'SR', NULL, NULL, NULL),
(14082, '2016-12-02 11:29:14', NULL, NULL, 4899, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 11:29:14', 'admin-1480641434-14806493538996358', 1, 1, 'SR', NULL, NULL, NULL),
(14083, '2016-12-02 12:37:53', NULL, NULL, 4900, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 12:37:53', 'admin-1480641434-14806534730823282', 1, 1, 'SR', NULL, NULL, NULL),
(14084, '2016-12-02 12:37:53', NULL, NULL, 4900, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 12:37:53', 'admin-1480641434-14806534730823282', 1, 1, 'SR', NULL, NULL, NULL),
(14085, '2016-12-02 12:53:25', NULL, NULL, 4901, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 12:53:25', 'admin-1480641434-14806544053777346', 1, 0, '', NULL, NULL, NULL),
(14086, '2016-12-02 12:53:25', NULL, NULL, 4901, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 12:53:25', 'admin-1480641434-14806544053777346', 1, 0, '', NULL, NULL, NULL),
(14087, '2016-12-02 12:53:46', NULL, NULL, 4901, 0, 85, '85', 'Set Sauted Mushroom Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 12:53:46', 'admin-1480641434-14806544267029075', 1, 1, 'SR', NULL, NULL, NULL),
(14088, '2016-12-02 12:53:46', NULL, NULL, 4901, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 12:53:46', 'admin-1480641434-14806544267029075', 1, 1, 'SR', NULL, NULL, NULL),
(14089, '2016-12-02 10:03:12', NULL, NULL, 4891, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:03:12', 'admin-1480641434-14806441919972552', 1, 1, 'SR', NULL, NULL, NULL),
(14090, '2016-12-02 10:03:12', NULL, NULL, 4891, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:03:12', 'admin-1480641434-14806441919972552', 1, 1, 'SR', NULL, NULL, NULL),
(14091, '2016-12-02 10:03:12', NULL, NULL, 4891, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:03:12', 'admin-1480641434-14806441919972552', 1, 1, 'SR', NULL, NULL, NULL),
(14092, '2016-12-02 10:03:00', NULL, NULL, 4891, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:03:00', 'admin-1480641434-14806441802866233', 1, 0, '', NULL, NULL, NULL),
(14093, '2016-12-02 10:03:00', NULL, NULL, 4891, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:03:00', 'admin-1480641434-14806441802866233', 1, 0, '', NULL, NULL, NULL),
(14094, '2016-12-02 10:03:00', NULL, NULL, 4891, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:03:00', 'admin-1480641434-14806441802866233', 1, 0, '', NULL, NULL, NULL),
(14095, '2016-12-02 09:19:11', NULL, NULL, 4890, 0, 154, '88', 'House BLT', 'Sesame dressing put aside', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 09:19:11', 'admin-1480641434-14806415517468373', 1, 0, '', NULL, NULL, NULL),
(14096, '2016-12-02 09:19:11', NULL, NULL, 4890, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 09:19:11', 'admin-1480641434-14806415517468373', 1, 1, 'SR', NULL, NULL, NULL),
(14097, '2016-12-02 09:19:11', NULL, NULL, 4890, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 09:19:11', 'admin-1480641434-14806415517468373', 1, 1, 'SR', NULL, NULL, NULL),
(14098, '2016-12-02 10:03:00', NULL, NULL, 4891, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 10:03:00', 'admin-1480641434-14806441802866233', 1, 0, '', NULL, NULL, NULL),
(14099, '2016-12-02 09:19:11', NULL, NULL, 4890, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 09:19:11', 'admin-1480641434-14806415517468373', 1, 0, '', NULL, NULL, NULL),
(14100, '2016-12-02 09:17:21', NULL, NULL, 4889, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480684220', 'admin', '2016-12-02 09:17:21', 'admin-1480641434-1480641440927753', 1, 1, 'SR', 1, NULL, NULL),
(14101, '2016-12-03 00:00:00', NULL, NULL, 4953, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 21:39:15', 'admin-1480759619-1480772355003992', 1, 1, 'SR', NULL, NULL, NULL),
(14102, '2016-12-03 00:00:00', NULL, NULL, 4952, 0, 190, '125', 'Tiger Bucket ', '', 'Cold Drinks', 'Soda & Beer', 1, 48.00, NULL, NULL, 48.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 21:39:15', 'admin-1480759619-1480772355003992', 1, 0, '', NULL, NULL, NULL),
(14103, '2016-12-03 20:56:11', NULL, NULL, 4949, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 20:56:11', 'admin-1480759619-14807697712914165', 1, 0, '', NULL, NULL, NULL),
(14104, '2016-12-03 20:56:11', NULL, NULL, 4949, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 20:56:11', 'admin-1480759619-14807697712914165', 1, 1, 'SR', NULL, NULL, NULL),
(14105, '2016-12-03 20:56:51', NULL, NULL, 4950, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 20:56:51', 'admin-1480759619-14807698112736156', 1, 1, 'SR', NULL, NULL, NULL),
(14106, '2016-12-03 20:56:51', NULL, NULL, 4950, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 20:56:51', 'admin-1480759619-14807698112736156', 1, 1, 'SR', NULL, NULL, NULL),
(14107, '2016-12-03 20:56:51', NULL, NULL, 4950, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 20:56:51', 'admin-1480759619-14807698112736156', 1, 1, 'SR', NULL, NULL, NULL),
(14108, '2016-12-03 18:55:51', NULL, NULL, 4945, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 18:55:51', 'admin-1480759619-14807625513202478', 1, 1, 'SR', NULL, NULL, NULL),
(14109, '2016-12-03 00:00:00', NULL, NULL, 4954, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 21:39:15', 'admin-1480759619-1480772355003992', 1, 1, 'SR', NULL, NULL, NULL),
(14110, '2016-12-03 00:00:00', NULL, NULL, 4955, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 21:39:15', 'admin-1480759619-1480772355003992', 1, 1, 'SR', NULL, NULL, NULL),
(14111, '2016-12-03 00:00:00', NULL, NULL, 4953, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 21:49:02', 'admin-1480759619-14807729424941538', 1, 1, 'SR', NULL, NULL, NULL),
(14112, '2016-12-03 19:10:34', NULL, NULL, 4947, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 19:10:34', 'admin-1480759619-14807634338955323', 1, 1, 'SR', NULL, NULL, NULL),
(14113, '2016-12-03 19:32:32', NULL, NULL, 4948, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 19:32:32', 'admin-1480759619-14807647527038874', 1, 1, 'SR', NULL, NULL, NULL),
(14114, '2016-12-03 19:32:32', NULL, NULL, 4948, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 19:32:32', 'admin-1480759619-14807647527038874', 1, 1, 'SR', NULL, NULL, NULL),
(14115, '2016-12-03 19:08:41', NULL, NULL, 4946, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 19:08:41', 'admin-1480759619-14807633207564867', 1, 0, '', NULL, NULL, NULL),
(14116, '2016-12-03 19:09:01', NULL, NULL, 4946, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 19:09:01', 'admin-1480759619-14807633410347422', 1, 1, 'SR', NULL, NULL, NULL),
(14117, '2016-12-03 18:55:51', NULL, NULL, 4945, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 18:55:51', 'admin-1480759619-14807625513202478', 1, 1, 'SR', NULL, NULL, NULL),
(14118, '2016-12-03 18:56:40', NULL, NULL, 4945, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 18:56:40', 'admin-1480759619-14807626001378598', 1, 0, '', NULL, NULL, NULL),
(14119, '2016-12-03 18:27:02', NULL, NULL, 4944, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 18:27:02', 'admin-1480759619-14807608225115851', 1, 0, '', NULL, NULL, NULL),
(14120, '2016-12-03 18:27:02', NULL, NULL, 4944, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 18:27:02', 'admin-1480759619-14807608225115851', 1, 1, 'SR', NULL, NULL, NULL),
(14121, '2016-12-03 18:27:02', NULL, NULL, 4944, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 18:27:02', 'admin-1480759619-14807608225115851', 1, 0, '', NULL, NULL, NULL),
(14122, '2016-12-03 16:48:05', NULL, NULL, 4941, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 16:48:05', 'admin-1480726512-1480754885473606', 1, 1, 'SR', NULL, NULL, NULL),
(14123, '2016-12-03 16:48:05', NULL, NULL, 4941, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 16:48:05', 'admin-1480726512-1480754885473606', 1, 1, 'SR', NULL, NULL, NULL),
(14124, '2016-12-03 16:48:05', NULL, NULL, 4941, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 16:48:05', 'admin-1480726512-1480754885473606', 1, 0, '', NULL, NULL, NULL),
(14125, '2016-12-03 17:56:09', NULL, NULL, 4942, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 17:56:09', 'admin-1480726512-14807589688041515', 1, 0, '', NULL, NULL, NULL),
(14126, '2016-12-03 17:42:56', NULL, NULL, 4943, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 17:42:56', 'admin-1480726512-1480758176715923', 1, 1, 'SR', NULL, NULL, NULL),
(14127, '2016-12-03 17:42:56', NULL, NULL, 4943, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 17:42:56', 'admin-1480726512-1480758176715923', 1, 1, 'SR', NULL, NULL, NULL),
(14128, '2016-12-03 17:42:56', NULL, NULL, 4943, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 17:42:56', 'admin-1480726512-1480758176715923', 1, 0, '', NULL, NULL, NULL),
(14129, '2016-12-03 17:37:20', NULL, NULL, 4942, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 17:37:20', 'admin-1480726512-14807578407469138', 1, 1, 'SR', NULL, NULL, NULL),
(14130, '2016-12-03 16:33:09', NULL, NULL, 4940, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 16:33:09', 'admin-1480726512-14807539893313433', 1, 1, 'SR', NULL, NULL, NULL),
(14131, '2016-12-03 16:33:09', NULL, NULL, 4940, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 16:33:09', 'admin-1480726512-14807539893313433', 1, 1, 'SR', NULL, NULL, NULL),
(14132, '2016-12-03 16:33:09', NULL, NULL, 4940, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 16:33:09', 'admin-1480726512-14807539893313433', 1, 1, 'SR', NULL, NULL, NULL),
(14133, '2016-12-03 16:33:09', NULL, NULL, 4940, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 16:33:09', 'admin-1480726512-14807539893313433', 1, 0, '', NULL, NULL, NULL),
(14134, '2016-12-03 16:33:09', NULL, NULL, 4940, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 16:33:09', 'admin-1480726512-14807539893313433', 1, 0, '', NULL, NULL, NULL),
(14135, '2016-12-03 16:48:05', NULL, NULL, 4941, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 16:48:05', 'admin-1480726512-1480754885473606', 1, 1, 'SR', NULL, NULL, NULL),
(14136, '2016-12-03 14:48:21', NULL, NULL, 4936, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 14:48:21', 'admin-1480726512-14807477015314073', 1, 1, 'SR', NULL, NULL, NULL),
(14137, '2016-12-03 14:48:21', NULL, NULL, 4936, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 14:48:21', 'admin-1480726512-14807477015314073', 1, 1, 'SR', NULL, NULL, NULL),
(14138, '2016-12-03 14:48:21', NULL, NULL, 4936, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 14:48:21', 'admin-1480726512-14807477015314073', 1, 0, '', NULL, NULL, NULL),
(14139, '2016-12-03 15:22:10', NULL, NULL, 4937, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 15:22:10', 'admin-1480726512-14807497302398667', 1, 1, 'SR', NULL, NULL, NULL),
(14140, '2016-12-03 15:22:17', NULL, NULL, 4935, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 15:22:17', 'admin-1480726512-14807497374826633', 1, 1, 'SR', NULL, NULL, NULL),
(14141, '2016-12-03 15:46:12', NULL, NULL, 4938, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 15:46:12', 'admin-1480726512-14807511723345620', 1, 1, 'SR', NULL, NULL, NULL),
(14142, '2016-12-03 15:46:12', NULL, NULL, 4938, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 15:46:12', 'admin-1480726512-14807511723345620', 1, 1, 'SR', NULL, NULL, NULL),
(14143, '2016-12-03 15:46:50', NULL, NULL, 4938, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 15:46:50', 'admin-1480726512-14807512105351884', 1, 0, '', NULL, NULL, NULL),
(14144, '2016-12-03 16:12:14', NULL, NULL, 4939, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 16:12:14', 'admin-1480726512-14807527347769384', 1, 1, 'SR', NULL, NULL, NULL),
(14145, '2016-12-03 16:12:14', NULL, NULL, 4939, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 16:12:14', 'admin-1480726512-14807527347769384', 1, 1, 'SR', NULL, NULL, NULL),
(14146, '2016-12-03 16:12:14', NULL, NULL, 4939, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 16:12:14', 'admin-1480726512-14807527347769384', 1, 0, '', NULL, NULL, NULL),
(14147, '2016-12-03 16:12:14', NULL, NULL, 4939, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 16:12:14', 'admin-1480726512-14807527347769384', 1, 0, '', NULL, NULL, NULL),
(14148, '2016-12-03 16:33:09', NULL, NULL, 4940, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 16:33:09', 'admin-1480726512-14807539893313433', 1, 0, '', NULL, NULL, NULL),
(14149, '2016-12-03 16:33:09', NULL, NULL, 4940, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 16:33:09', 'admin-1480726512-14807539893313433', 1, 0, '', NULL, NULL, NULL),
(14150, '2016-12-03 14:33:16', NULL, NULL, 4935, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 14:33:16', 'admin-1480726512-14807467959138521', 1, 1, 'SR', NULL, NULL, NULL),
(14151, '2016-12-03 14:29:07', NULL, NULL, 4934, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 14:29:07', 'admin-1480726512-14807465473358867', 1, 0, '', NULL, NULL, NULL),
(14152, '2016-12-03 10:39:45', NULL, NULL, 4926, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 10:39:45', 'admin-1480726512-14807327852329215', 1, 1, 'SR', NULL, NULL, NULL),
(14153, '2016-12-03 10:39:45', NULL, NULL, 4926, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 10:39:45', 'admin-1480726512-14807327852329215', 1, 1, 'SR', NULL, NULL, NULL),
(14154, '2016-12-03 10:45:36', NULL, NULL, 4925, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 10:45:36', 'admin-1480726512-14807331366412452', 1, 0, '', NULL, NULL, NULL),
(14155, '2016-12-03 10:45:36', NULL, NULL, 4925, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 10:45:36', 'admin-1480726512-14807331366412452', 1, 0, '', NULL, NULL, NULL),
(14156, '2016-12-03 10:59:55', NULL, NULL, 4927, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 10:59:55', 'admin-1480726512-14807339951401581', 1, 0, '', NULL, NULL, NULL),
(14157, '2016-12-03 10:59:55', NULL, NULL, 4927, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 10:59:55', 'admin-1480726512-14807339951401581', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(14158, '2016-12-03 10:59:55', NULL, NULL, 4927, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 10:59:55', 'admin-1480726512-14807339951401581', 1, 1, 'SR', NULL, NULL, NULL),
(14159, '2016-12-03 11:40:46', NULL, NULL, 4928, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 11:40:46', 'admin-1480726512-14807364464571610', 1, 0, '', NULL, NULL, NULL),
(14160, '2016-12-03 11:40:46', NULL, NULL, 4928, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 11:40:46', 'admin-1480726512-14807364464571610', 1, 0, '', NULL, NULL, NULL),
(14161, '2016-12-03 11:40:46', NULL, NULL, 4928, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 11:40:46', 'admin-1480726512-14807364464571610', 1, 0, '', NULL, NULL, NULL),
(14162, '2016-12-03 11:40:56', NULL, NULL, 4928, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 11:40:56', 'admin-1480726512-14807364563917841', 1, 1, 'SR', NULL, NULL, NULL),
(14163, '2016-12-03 11:40:56', NULL, NULL, 4928, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 11:40:56', 'admin-1480726512-14807364563917841', 1, 1, 'SR', NULL, NULL, NULL),
(14164, '2016-12-03 11:44:54', NULL, NULL, 4928, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 11:44:54', 'admin-1480726512-14807366941769297', 1, 1, 'SR', NULL, NULL, NULL),
(14165, '2016-12-03 12:05:14', NULL, NULL, 4929, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 12:05:14', 'admin-1480726512-14807379139159771', 1, 0, '', NULL, NULL, NULL),
(14166, '2016-12-03 12:05:14', NULL, NULL, 4929, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 12:05:14', 'admin-1480726512-14807379139159771', 1, 1, 'SR', NULL, NULL, NULL),
(14167, '2016-12-03 12:12:22', NULL, NULL, 4930, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 12:12:22', 'admin-1480726512-14807383422131279', 1, 1, 'SR', NULL, NULL, NULL),
(14168, '2016-12-03 12:31:20', NULL, NULL, 4931, 0, 85, '85', 'Set Sauted Mushroom Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 12:31:20', 'admin-1480726512-14807394800635460', 1, 1, 'SR', NULL, NULL, NULL),
(14169, '2016-12-03 12:31:20', NULL, NULL, 4931, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 12:31:20', 'admin-1480726512-14807394800635460', 1, 0, '', NULL, NULL, NULL),
(14170, '2016-12-03 12:31:20', NULL, NULL, 4931, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 12:31:20', 'admin-1480726512-14807394800635460', 1, 0, '', NULL, NULL, NULL),
(14171, '2016-12-03 12:31:26', NULL, NULL, 4931, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 12:31:26', 'admin-1480726512-14807394859505839', 1, 0, '', NULL, NULL, NULL),
(14172, '2016-12-03 13:13:31', NULL, NULL, 4932, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 13:13:31', 'admin-1480726512-14807420110214312', 1, 0, '', NULL, NULL, NULL),
(14173, '2016-12-03 13:13:31', NULL, NULL, 4932, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 13:13:31', 'admin-1480726512-14807420110214312', 1, 1, 'SR', NULL, NULL, NULL),
(14174, '2016-12-03 14:27:28', NULL, NULL, 4933, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 14:27:28', 'admin-1480726512-14807464478019140', 1, 1, 'SR', NULL, NULL, NULL),
(14175, '2016-12-03 14:27:28', NULL, NULL, 4933, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 14:27:28', 'admin-1480726512-14807464478019140', 1, 1, 'SR', NULL, NULL, NULL),
(14176, '2016-12-03 14:29:07', NULL, NULL, 4934, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 14:29:07', 'admin-1480726512-14807465473358867', 1, 0, '', NULL, NULL, NULL),
(14177, '2016-12-03 14:29:07', NULL, NULL, 4934, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 14:29:07', 'admin-1480726512-14807465473358867', 1, 0, '', NULL, NULL, NULL),
(14178, '2016-12-03 10:39:16', NULL, NULL, 4925, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 10:39:16', 'admin-1480726512-14807327567266777', 1, 1, 'SR', NULL, NULL, NULL),
(14179, '2016-12-03 10:30:12', NULL, NULL, 4924, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 10:30:12', 'admin-1480726512-1480732212554377', 1, 1, 'SR', NULL, NULL, NULL),
(14180, '2016-12-03 10:30:12', NULL, NULL, 4924, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 10:30:12', 'admin-1480726512-1480732212554377', 1, 0, '', NULL, NULL, NULL),
(14181, '2016-12-03 10:30:12', NULL, NULL, 4924, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 10:30:12', 'admin-1480726512-1480732212554377', 1, 0, '', NULL, NULL, NULL),
(14182, '2016-12-03 10:30:12', NULL, NULL, 4924, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 10:30:12', 'admin-1480726512-1480732212554377', 1, 0, '', NULL, NULL, NULL),
(14183, '2016-12-03 09:50:06', NULL, NULL, 4922, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 09:50:06', 'admin-1480726512-14807298060692259', 1, 1, 'SR', NULL, NULL, NULL),
(14184, '2016-12-03 10:24:33', NULL, NULL, 4923, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 10:24:33', 'admin-1480726512-14807318737267575', 1, 1, 'SR', NULL, NULL, NULL),
(14185, '2016-12-03 10:24:33', NULL, NULL, 4923, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 10:24:33', 'admin-1480726512-14807318737267575', 1, 0, '', NULL, NULL, NULL),
(14186, '2016-12-03 10:24:33', NULL, NULL, 4923, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 10:24:33', 'admin-1480726512-14807318737267575', 1, 0, '', NULL, NULL, NULL),
(14187, '2016-12-03 09:50:06', NULL, NULL, 4922, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 09:50:06', 'admin-1480726512-14807298060692259', 1, 1, 'SR', NULL, NULL, NULL),
(14188, '2016-12-03 09:50:06', NULL, NULL, 4922, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 09:50:06', 'admin-1480726512-14807298060692259', 1, 1, 'SR', NULL, NULL, NULL),
(14189, '2016-12-03 09:50:06', NULL, NULL, 4922, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480759619', 'admin', '2016-12-03 09:50:06', 'admin-1480726512-14807298060692259', 1, 0, '', NULL, NULL, NULL),
(14190, '2016-12-04 19:58:15', NULL, NULL, 4991, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 19:58:15', 'admin-1480847042-14808526957308177', 1, 1, 'SR', NULL, NULL, NULL),
(14191, '2016-12-04 19:58:15', NULL, NULL, 4991, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 19:58:15', 'admin-1480847042-14808526957308177', 1, 0, '', NULL, NULL, NULL),
(14192, '2016-12-04 18:24:41', NULL, NULL, 4989, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 18:24:41', 'admin-1480847042-14808470815287085', 1, 0, '', NULL, NULL, NULL),
(14193, '2016-12-04 14:24:44', NULL, NULL, 4977, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 14:24:44', 'admin-1480826222-14808326839585242', 1, 1, 'SR', NULL, NULL, NULL),
(14194, '2016-12-04 14:24:44', NULL, NULL, 4977, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 14:24:44', 'admin-1480826222-14808326839585242', 1, 1, 'SR', NULL, NULL, NULL),
(14195, '2016-12-04 13:53:39', NULL, NULL, 4974, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 13:53:39', 'admin-1480826222-14808308187544120', 1, 0, '', NULL, NULL, NULL),
(14196, '2016-12-04 13:53:39', NULL, NULL, 4974, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 13:53:39', 'admin-1480826222-14808308187544120', 1, 1, 'SR', NULL, NULL, NULL),
(14197, '2016-12-04 13:53:49', NULL, NULL, 4975, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 13:53:49', 'admin-1480826222-14808308294015676', 1, 0, '', 1, NULL, NULL),
(14198, '2016-12-04 00:00:00', NULL, NULL, 4981, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 13:12:33', 'admin-1480826222-14808283529922338', 1, 0, '', NULL, NULL, NULL),
(14199, '2016-12-04 14:12:53', NULL, NULL, 4976, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 14:12:53', 'admin-1480826222-1480831973498231', 1, 1, 'SR', NULL, NULL, NULL),
(14200, '2016-12-04 00:00:00', NULL, NULL, 4981, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 14:07:38', 'admin-1480826222-14808316579083411', 1, 0, '', NULL, NULL, NULL),
(14201, '2016-12-04 17:53:06', NULL, NULL, 4984, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 17:53:06', 'admin-1480826222-14808451865354563', 1, 1, 'SR', NULL, NULL, NULL),
(14202, '2016-12-04 00:00:00', NULL, NULL, 4985, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 17:19:34', 'admin-1480826222-14808431738853858', 1, 1, 'SR', NULL, NULL, NULL),
(14203, '2016-12-04 18:22:58', NULL, NULL, 4988, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 18:22:58', 'admin-1480826222-14808469782375573', 1, 1, 'SR', NULL, NULL, NULL),
(14204, '2016-12-04 18:22:58', NULL, NULL, 4988, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 18:22:58', 'admin-1480826222-14808469782375573', 1, 0, '', NULL, NULL, NULL),
(14205, '2016-12-04 19:24:15', NULL, NULL, 4990, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 19:24:15', 'admin-1480847042-14808506555342915', 1, 1, 'SR', 1, NULL, NULL),
(14206, '2016-12-04 14:48:21', NULL, NULL, 4979, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 14:48:21', 'admin-1480826222-14808341012155119', 1, 1, 'SR', NULL, NULL, NULL),
(14207, '2016-12-04 18:24:41', NULL, NULL, 4989, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 18:24:41', 'admin-1480847042-14808470815287085', 1, 0, '', NULL, NULL, NULL),
(14208, '2016-12-04 18:30:16', NULL, NULL, 4989, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 18:30:16', 'admin-1480847042-1480847416151135', 1, 1, 'SR', NULL, NULL, NULL),
(14209, '2016-12-04 00:00:00', NULL, NULL, 4986, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 17:19:34', 'admin-1480826222-14808431738853858', 1, 1, 'SR', NULL, NULL, NULL),
(14210, '2016-12-04 14:48:25', NULL, NULL, 4979, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 14:48:25', 'admin-1480826222-14808341050338760', 1, 0, '', NULL, NULL, NULL),
(14211, '2016-12-04 00:00:00', NULL, NULL, 4980, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 13:12:33', 'admin-1480826222-14808283529922338', 1, 0, '', NULL, NULL, NULL),
(14212, '2016-12-04 15:46:49', NULL, NULL, 4982, 0, 181, '116', 'Open Food ', 'vanilla ice cream', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 15:46:49', 'admin-1480826222-148083760906336', 1, 0, '', NULL, NULL, NULL),
(14213, '2016-12-04 15:45:50', NULL, NULL, 4982, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 15:45:50', 'admin-1480826222-14808375503117113', 1, 0, '', NULL, NULL, NULL),
(14214, '2016-12-04 15:47:01', NULL, NULL, 4982, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 15:47:01', 'admin-1480826222-14808376214919291', 1, 0, '', NULL, NULL, NULL),
(14215, '2016-12-04 15:47:01', NULL, NULL, 4982, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 15:47:01', 'admin-1480826222-14808376214919291', 1, 1, 'SR', NULL, NULL, NULL),
(14216, '2016-12-04 15:47:01', NULL, NULL, 4982, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 15:47:01', 'admin-1480826222-14808376214919291', 1, 1, 'SR', NULL, NULL, NULL),
(14217, '2016-12-04 15:47:57', NULL, NULL, 4982, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 15:47:57', 'admin-1480826222-14808376774431773', 1, 0, '', NULL, NULL, NULL),
(14218, '2016-12-04 15:47:57', NULL, NULL, 4982, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 15:47:57', 'admin-1480826222-14808376774431773', 1, 1, 'SR', NULL, NULL, NULL),
(14219, '2016-12-04 15:57:19', NULL, NULL, 4982, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 15:57:19', 'admin-1480826222-14808382396535464', 1, 0, '', NULL, NULL, NULL),
(14220, '2016-12-04 00:00:00', NULL, NULL, 4987, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 17:19:34', 'admin-1480826222-14808431738853858', 1, 1, 'SR', NULL, NULL, NULL),
(14221, '2016-12-04 14:40:45', NULL, NULL, 4974, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 14:40:45', 'admin-1480826222-14808336454443143', 1, 1, 'SR', NULL, NULL, NULL),
(14222, '2016-12-04 14:40:45', NULL, NULL, 4974, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 14:40:45', 'admin-1480826222-14808336454443143', 1, 0, '', NULL, NULL, NULL),
(14223, '2016-12-04 14:40:45', NULL, NULL, 4974, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 14:40:45', 'admin-1480826222-14808336454443143', 1, 1, 'SR', NULL, NULL, NULL),
(14224, '2016-12-04 14:37:01', NULL, NULL, 4978, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 14:37:01', 'admin-1480826222-14808334210101088', 1, 1, 'SR', NULL, NULL, NULL),
(14225, '2016-12-04 14:37:01', NULL, NULL, 4978, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 14:37:01', 'admin-1480826222-14808334210101088', 1, 0, '', NULL, NULL, NULL),
(14226, '2016-12-04 14:37:01', NULL, NULL, 4978, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 14:37:01', 'admin-1480826222-14808334210101088', 1, 0, '', NULL, NULL, NULL),
(14227, '2016-12-04 14:37:01', NULL, NULL, 4978, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 14:37:01', 'admin-1480826222-14808334210101088', 1, 0, '', NULL, NULL, NULL),
(14228, '2016-12-04 14:38:40', NULL, NULL, 4974, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 14:38:40', 'admin-1480826222-14808335198001173', 1, 1, 'SR', NULL, NULL, NULL),
(14229, '2016-12-04 14:38:40', NULL, NULL, 4974, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 14:38:40', 'admin-1480826222-14808335198001173', 1, 1, 'SR', NULL, NULL, NULL),
(14230, '2016-12-04 14:38:40', NULL, NULL, 4974, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 14:38:40', 'admin-1480826222-14808335198001173', 1, 0, '', NULL, NULL, NULL),
(14231, '2016-12-04 13:53:39', NULL, NULL, 4974, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 13:53:39', 'admin-1480826222-14808308187544120', 1, 0, '', NULL, NULL, NULL),
(14232, '2016-12-04 12:27:57', NULL, NULL, 4969, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:27:57', 'admin-1480813323-14808256773743247', 1, 0, '', NULL, NULL, NULL),
(14233, '2016-12-04 12:27:57', NULL, NULL, 4969, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:27:57', 'admin-1480813323-14808256773743247', 1, 1, 'SR', NULL, NULL, NULL),
(14234, '2016-12-04 12:35:01', NULL, NULL, 4966, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:35:01', 'admin-1480813323-148082610078464', 1, 0, '', NULL, NULL, NULL),
(14235, '2016-12-04 12:40:44', NULL, NULL, 4970, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:40:44', 'admin-1480826222-14808264440574349', 1, 0, '', NULL, NULL, NULL),
(14236, '2016-12-04 12:41:03', NULL, NULL, 4970, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:41:03', 'admin-1480826222-1480826462857242', 1, 1, 'SR', NULL, NULL, NULL),
(14237, '2016-12-04 00:00:00', NULL, NULL, 4980, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 14:19:42', 'admin-1480826222-1480832382365529', 1, 1, 'SR', NULL, NULL, NULL),
(14238, '2016-12-04 14:24:44', NULL, NULL, 4977, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 14:24:44', 'admin-1480826222-14808326839585242', 1, 1, 'SR', NULL, NULL, NULL),
(14239, '2016-12-04 14:24:44', NULL, NULL, 4977, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 14:24:44', 'admin-1480826222-14808326839585242', 1, 1, 'SR', NULL, NULL, NULL),
(14240, '2016-12-04 13:53:39', NULL, NULL, 4974, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 13:53:39', 'admin-1480826222-14808308187544120', 1, 0, '', NULL, NULL, NULL),
(14241, '2016-12-04 13:53:39', NULL, NULL, 4974, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 13:53:39', 'admin-1480826222-14808308187544120', 1, 0, '', NULL, NULL, NULL),
(14242, '2016-12-04 13:44:39', NULL, NULL, 4973, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 13:44:39', 'admin-1480826222-14808302793281663', 1, 1, 'SR', NULL, NULL, NULL),
(14243, '2016-12-04 13:44:39', NULL, NULL, 4973, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 13:44:39', 'admin-1480826222-14808302793281663', 1, 1, 'SR', NULL, NULL, NULL),
(14244, '2016-12-04 13:44:39', NULL, NULL, 4973, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 13:44:39', 'admin-1480826222-14808302793281663', 1, 0, '', NULL, NULL, NULL),
(14245, '2016-12-04 13:53:38', NULL, NULL, 4974, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 13:53:38', 'admin-1480826222-14808308187544120', 1, 0, '', NULL, NULL, NULL),
(14246, '2016-12-04 13:53:39', NULL, NULL, 4974, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 13:53:39', 'admin-1480826222-14808308187544120', 1, 0, '', NULL, NULL, NULL),
(14247, '2016-12-04 13:31:30', NULL, NULL, 4972, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 13:31:30', 'admin-1480826222-14808294900517226', 1, 1, 'SR', NULL, NULL, NULL),
(14248, '2016-12-04 13:44:39', NULL, NULL, 4973, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 13:44:39', 'admin-1480826222-14808302793281663', 1, 1, 'SR', NULL, NULL, NULL),
(14249, '2016-12-04 13:31:08', NULL, NULL, 4972, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 13:31:08', 'admin-1480826222-1480829468455647', 1, 1, 'SR', NULL, NULL, NULL),
(14250, '2016-12-04 13:31:08', NULL, NULL, 4972, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 13:31:08', 'admin-1480826222-1480829468455647', 1, 0, '', NULL, NULL, NULL),
(14251, '2016-12-04 12:18:06', NULL, NULL, 4967, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:18:06', 'admin-1480813323-14808250863091770', 1, 1, 'SR', NULL, NULL, NULL),
(14252, '2016-12-04 12:20:19', NULL, NULL, 4968, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:20:19', 'admin-1480813323-14808252193855444', 1, 1, 'SR', NULL, NULL, NULL),
(14253, '2016-12-04 12:20:19', NULL, NULL, 4968, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:20:19', 'admin-1480813323-14808252193855444', 1, 1, 'SR', NULL, NULL, NULL),
(14254, '2016-12-04 00:00:00', NULL, NULL, 4980, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:55:28', 'admin-1480826222-14808273284144720', 1, 1, 'SR', NULL, NULL, NULL),
(14255, '2016-12-04 18:24:41', NULL, NULL, 4989, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 18:24:41', 'admin-1480847042-14808470815287085', 1, 1, 'SR', NULL, NULL, NULL),
(14256, '2016-12-04 18:22:58', NULL, NULL, 4988, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 18:22:58', 'admin-1480826222-14808469782375573', 1, 1, 'SR', NULL, NULL, NULL),
(14257, '2016-12-04 12:41:03', NULL, NULL, 4970, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:41:03', 'admin-1480826222-1480826462857242', 1, 1, 'SR', NULL, NULL, NULL),
(14258, '2016-12-04 15:45:50', NULL, NULL, 4982, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 15:45:50', 'admin-1480826222-14808375503117113', 1, 1, 'SR', NULL, NULL, NULL),
(14259, '2016-12-04 00:00:00', NULL, NULL, 4981, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 13:12:33', 'admin-1480826222-14808283529922338', 1, 1, 'SR', NULL, NULL, NULL),
(14260, '2016-12-04 13:12:33', NULL, NULL, 4971, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 13:12:33', 'admin-1480826222-14808283529922338', 1, 0, '', NULL, NULL, NULL),
(14261, '2016-12-04 12:41:25', NULL, NULL, 4970, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:41:25', 'admin-1480826222-14808264854605033', 1, 1, 'SR', NULL, NULL, NULL),
(14262, '2016-12-04 12:41:03', NULL, NULL, 4970, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:41:03', 'admin-1480826222-1480826462857242', 1, 1, 'SR', NULL, NULL, NULL),
(14263, '2016-12-04 12:16:59', NULL, NULL, 4967, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:16:59', 'admin-1480813323-14808250193922281', 1, 0, '', NULL, NULL, NULL),
(14264, '2016-12-04 12:16:59', NULL, NULL, 4967, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:16:59', 'admin-1480813323-14808250193922281', 1, 1, 'SR', NULL, NULL, NULL),
(14265, '2016-12-04 12:16:59', NULL, NULL, 4967, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:16:59', 'admin-1480813323-14808250193922281', 1, 1, 'SR', NULL, NULL, NULL),
(14266, '2016-12-04 12:16:59', NULL, NULL, 4967, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:16:59', 'admin-1480813323-14808250193922281', 1, 1, 'SR', NULL, NULL, NULL),
(14267, '2016-12-04 12:18:06', NULL, NULL, 4967, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:18:06', 'admin-1480813323-14808250863091770', 1, 1, 'SR', NULL, NULL, NULL),
(14268, '2016-12-04 12:18:06', NULL, NULL, 4967, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:18:06', 'admin-1480813323-14808250863091770', 1, 1, 'SR', NULL, NULL, NULL),
(14269, '2016-12-04 11:51:21', NULL, NULL, 4965, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 11:51:21', 'admin-1480813323-14808234813343089', 1, 0, '', NULL, NULL, NULL),
(14270, '2016-12-04 11:51:21', NULL, NULL, 4965, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 11:51:21', 'admin-1480813323-14808234813343089', 1, 1, 'SR', NULL, NULL, NULL),
(14271, '2016-12-04 11:51:21', NULL, NULL, 4965, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 11:51:21', 'admin-1480813323-14808234813343089', 1, 1, 'SR', NULL, NULL, NULL),
(14272, '2016-12-04 12:09:57', NULL, NULL, 4966, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:09:57', 'admin-1480813323-14808245971713749', 1, 0, '', NULL, NULL, NULL),
(14273, '2016-12-04 12:09:57', NULL, NULL, 4966, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:09:57', 'admin-1480813323-14808245971713749', 1, 0, '', NULL, NULL, NULL),
(14274, '2016-12-04 12:09:57', NULL, NULL, 4966, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:09:57', 'admin-1480813323-14808245971713749', 1, 0, '', NULL, NULL, NULL),
(14275, '2016-12-04 12:09:57', NULL, NULL, 4966, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:09:57', 'admin-1480813323-14808245971713749', 1, 0, '', NULL, NULL, NULL),
(14276, '2016-12-04 12:09:57', NULL, NULL, 4966, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:09:57', 'admin-1480813323-14808245971713749', 1, 0, '', NULL, NULL, NULL),
(14277, '2016-12-04 12:09:57', NULL, NULL, 4966, 0, 217, '151', 'Spicy Lemony Wings', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:09:57', 'admin-1480813323-14808245971713749', 1, 0, '', NULL, NULL, NULL),
(14278, '2016-12-04 12:09:57', NULL, NULL, 4966, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:09:57', 'admin-1480813323-14808245971713749', 1, 0, '', NULL, NULL, NULL),
(14279, '2016-12-04 12:10:07', NULL, NULL, 4966, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:10:07', 'admin-1480813323-14808246075225517', 1, 1, 'SR', NULL, NULL, NULL),
(14280, '2016-12-04 12:10:07', NULL, NULL, 4966, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:10:07', 'admin-1480813323-14808246075225517', 1, 1, 'SR', NULL, NULL, NULL),
(14281, '2016-12-04 12:10:07', NULL, NULL, 4966, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:10:07', 'admin-1480813323-14808246075225517', 1, 1, 'SR', NULL, NULL, NULL),
(14282, '2016-12-04 12:16:59', NULL, NULL, 4967, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 12:16:59', 'admin-1480813323-14808250193922281', 1, 0, '', NULL, NULL, NULL),
(14283, '2016-12-04 11:51:03', NULL, NULL, 4965, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 11:51:03', 'admin-1480813323-14808234632186674', 1, 0, '', NULL, NULL, NULL),
(14284, '2016-12-04 11:51:03', NULL, NULL, 4965, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 11:51:03', 'admin-1480813323-14808234632186674', 1, 0, '', NULL, NULL, NULL),
(14285, '2016-12-04 10:17:23', NULL, NULL, 4961, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:17:23', 'admin-1480813323-14808178432667679', 1, 0, '', NULL, NULL, NULL),
(14286, '2016-12-04 10:25:13', NULL, NULL, 4962, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:25:13', 'admin-1480813323-14808183129957785', 1, 0, '', NULL, NULL, NULL),
(14287, '2016-12-04 10:25:13', NULL, NULL, 4962, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:25:13', 'admin-1480813323-14808183129957785', 1, 0, '', NULL, NULL, NULL),
(14288, '2016-12-04 10:25:13', NULL, NULL, 4962, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:25:13', 'admin-1480813323-14808183129957785', 1, 0, '', NULL, NULL, NULL),
(14289, '2016-12-04 10:25:13', NULL, NULL, 4962, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:25:13', 'admin-1480813323-14808183129957785', 1, 0, '', NULL, NULL, NULL),
(14290, '2016-12-04 10:25:24', NULL, NULL, 4962, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:25:24', 'admin-1480813323-14808183246385317', 1, 1, 'SR', NULL, NULL, NULL),
(14291, '2016-12-04 10:25:24', NULL, NULL, 4962, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:25:24', 'admin-1480813323-14808183246385317', 1, 1, 'SR', NULL, NULL, NULL),
(14292, '2016-12-04 10:25:24', NULL, NULL, 4962, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:25:24', 'admin-1480813323-14808183246385317', 1, 1, 'SR', NULL, NULL, NULL),
(14293, '2016-12-04 10:25:24', NULL, NULL, 4962, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:25:24', 'admin-1480813323-14808183246385317', 1, 1, 'SR', NULL, NULL, NULL),
(14294, '2016-12-04 10:25:33', NULL, NULL, 4962, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:25:33', 'admin-1480813323-14808183334271929', 1, 1, 'SR', NULL, NULL, NULL),
(14295, '2016-12-04 10:25:33', NULL, NULL, 4962, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:25:33', 'admin-1480813323-14808183334271929', 1, 0, '', NULL, NULL, NULL),
(14296, '2016-12-04 10:36:31', NULL, NULL, 4963, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:36:31', 'admin-1480813323-14808189914654415', 1, 1, 'SR', NULL, NULL, NULL),
(14297, '2016-12-04 10:36:31', NULL, NULL, 4963, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:36:31', 'admin-1480813323-14808189914654415', 1, 1, 'SR', NULL, NULL, NULL),
(14298, '2016-12-04 10:43:18', NULL, NULL, 4963, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:43:18', 'admin-1480813323-14808193978718161', 1, 0, '', NULL, NULL, NULL),
(14299, '2016-12-04 10:43:46', NULL, NULL, 4962, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:43:46', 'admin-1480813323-14808194257864064', 1, 1, 'SR', NULL, NULL, NULL),
(14300, '2016-12-04 10:42:29', NULL, NULL, 4962, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:42:29', 'admin-1480813323-1480819349485550', 1, 0, '', NULL, NULL, NULL),
(14301, '2016-12-04 10:42:29', NULL, NULL, 4962, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:42:29', 'admin-1480813323-1480819349485550', 1, 0, '', NULL, NULL, NULL),
(14302, '2016-12-04 10:45:31', NULL, NULL, 4963, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:45:31', 'admin-1480813323-1480819530907266', 1, 0, '', NULL, NULL, NULL),
(14303, '2016-12-04 10:47:03', NULL, NULL, 4962, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:47:03', 'admin-1480813323-14808196227359912', 1, 1, 'SR', NULL, NULL, NULL),
(14304, '2016-12-04 11:13:41', NULL, NULL, 4964, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 11:13:41', 'admin-1480813323-1480821221786559', 1, 0, '', NULL, NULL, NULL),
(14305, '2016-12-04 11:13:41', NULL, NULL, 4964, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 11:13:41', 'admin-1480813323-1480821221786559', 1, 0, '', NULL, NULL, NULL),
(14306, '2016-12-04 11:13:41', NULL, NULL, 4964, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 11:13:41', 'admin-1480813323-1480821221786559', 1, 0, '', NULL, NULL, NULL),
(14307, '2016-12-04 11:13:51', NULL, NULL, 4964, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 11:13:51', 'admin-1480813323-14808212308375891', 1, 1, 'SR', NULL, NULL, NULL),
(14308, '2016-12-04 11:13:51', NULL, NULL, 4964, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 11:13:51', 'admin-1480813323-14808212308375891', 1, 1, 'SR', NULL, NULL, NULL),
(14309, '2016-12-04 11:13:51', NULL, NULL, 4964, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 11:13:51', 'admin-1480813323-14808212308375891', 1, 1, 'SR', NULL, NULL, NULL),
(14310, '2016-12-04 11:16:45', NULL, NULL, 4964, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 11:16:45', 'admin-1480813323-14808214052917621', 1, 0, '', NULL, NULL, NULL),
(14311, '2016-12-04 10:17:23', NULL, NULL, 4961, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:17:23', 'admin-1480813323-14808178432667679', 1, 0, '', NULL, NULL, NULL),
(14312, '2016-12-04 10:17:23', NULL, NULL, 4961, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:17:23', 'admin-1480813323-14808178432667679', 1, 1, 'SR', NULL, NULL, NULL),
(14313, '2016-12-04 10:17:23', NULL, NULL, 4961, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:17:23', 'admin-1480813323-14808178432667679', 1, 1, 'SR', NULL, NULL, NULL),
(14314, '2016-12-04 10:10:00', NULL, NULL, 4960, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 10:10:00', 'admin-1480813323-14808174003863870', 1, 1, 'SR', NULL, NULL, NULL),
(14315, '2016-12-04 09:17:45', NULL, NULL, 4958, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 09:17:45', 'admin-1480813323-14808142653498687', 1, 1, 'SR', NULL, NULL, NULL),
(14316, '2016-12-04 09:39:25', NULL, NULL, 4959, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 09:39:25', 'admin-1480813323-14808155654857726', 1, 0, '', NULL, NULL, NULL),
(14317, '2016-12-04 09:17:45', NULL, NULL, 4958, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 09:17:45', 'admin-1480813323-14808142653498687', 1, 0, '', NULL, NULL, NULL),
(14318, '2016-12-04 09:12:35', NULL, NULL, 4957, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 09:12:35', 'admin-1480813323-14808139553876714', 1, 1, 'SR', NULL, NULL, NULL),
(14319, '2016-12-04 09:07:24', NULL, NULL, 4956, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 09:07:24', 'admin-1480813323-14808136440913447', 1, 1, 'SR', NULL, NULL, NULL),
(14320, '2016-12-04 09:07:24', NULL, NULL, 4956, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 09:07:24', 'admin-1480813323-14808136440913447', 1, 1, 'SR', NULL, NULL, NULL),
(14321, '2016-12-04 09:07:17', NULL, NULL, 4956, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 09:07:17', 'admin-1480813323-14808136374146215', 1, 0, '', NULL, NULL, NULL),
(14322, '2016-12-04 09:07:17', NULL, NULL, 4956, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480847042', 'admin', '2016-12-04 09:07:17', 'admin-1480813323-14808136374146215', 1, 0, '', NULL, NULL, NULL),
(14323, '2016-12-05 18:58:27', NULL, NULL, 5012, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 18:58:27', 'admin-1480920160-14809355070536476', 1, 1, 'SR', NULL, NULL, NULL),
(14324, '2016-12-05 19:38:05', NULL, NULL, 5013, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 19:38:05', 'admin-1480920160-14809378854213043', 1, 1, 'SR', 1, NULL, NULL),
(14325, '2016-12-05 19:38:05', NULL, NULL, 5013, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 19:38:05', 'admin-1480920160-14809378854213043', 1, 1, 'SR', 1, NULL, NULL),
(14326, '2016-12-05 20:33:53', NULL, NULL, 5014, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 20:33:53', 'admin-1480920160-14809412337578164', 1, 1, 'SR', NULL, NULL, NULL),
(14327, '2016-12-05 20:33:53', NULL, NULL, 5014, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 20:33:53', 'admin-1480920160-14809412337578164', 1, 1, 'SR', NULL, NULL, NULL),
(14328, '2016-12-05 20:33:53', NULL, NULL, 5014, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 20:33:53', 'admin-1480920160-14809412337578164', 1, 0, '', NULL, NULL, NULL),
(14329, '2016-12-05 15:09:41', NULL, NULL, 5001, 0, 181, '116', 'Open Food ', 'Ice cream', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 15:09:41', 'admin-1480920160-14809217810047991', 1, 0, '', NULL, NULL, NULL),
(14330, '2016-12-05 13:51:21', NULL, NULL, 5004, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 13:51:21', 'admin-1480899050-1480917080975187', 1, 0, '', NULL, NULL, NULL),
(14331, '2016-12-05 13:51:21', NULL, NULL, 5004, 0, 214, '148', 'Set Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 13:51:21', 'admin-1480899050-1480917080975187', 1, 0, '', NULL, NULL, NULL),
(14332, '2016-12-05 13:55:17', NULL, NULL, 5002, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 13:55:17', 'admin-1480899050-1480917317068111', 1, 1, 'SR', NULL, NULL, NULL),
(14333, '2016-12-05 13:55:17', NULL, NULL, 5002, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 13:55:17', 'admin-1480899050-1480917317068111', 1, 1, 'SR', NULL, NULL, NULL),
(14334, '2016-12-05 13:55:23', NULL, NULL, 4998, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 13:55:23', 'admin-1480899050-14809173238056720', 1, 1, 'SR', NULL, NULL, NULL),
(14335, '2016-12-05 13:57:22', NULL, NULL, 5005, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 13:57:22', 'admin-1480899050-14809174423338415', 1, 1, 'SR', NULL, NULL, NULL),
(14336, '2016-12-05 13:59:16', NULL, NULL, 5006, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 13:59:16', 'admin-1480899050-14809175561412990', 1, 1, 'SR', NULL, NULL, NULL),
(14337, '2016-12-05 14:00:18', NULL, NULL, 5007, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 14:00:18', 'admin-1480899050-1480917618493544', 1, 0, '', NULL, NULL, NULL),
(14338, '2016-12-05 14:32:39', NULL, NULL, 5008, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 14:32:39', 'admin-1480899050-14809195588373846', 1, 0, '', NULL, NULL, NULL),
(14339, '2016-12-05 16:25:41', NULL, NULL, 5009, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 16:25:41', 'admin-1480920160-14809263411356243', 1, 1, 'SR', NULL, NULL, NULL),
(14340, '2016-12-05 16:29:42', NULL, NULL, 5010, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 16:29:42', 'admin-1480920160-14809265825394490', 1, 1, 'SR', NULL, NULL, '10.0'),
(14341, '2016-12-05 17:50:57', NULL, NULL, 5011, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 17:50:57', 'admin-1480920160-1480931457221963', 1, 1, 'SR', NULL, NULL, NULL),
(14342, '2016-12-05 18:58:27', NULL, NULL, 5012, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 18:58:27', 'admin-1480920160-14809355070536476', 1, 0, '', NULL, NULL, NULL),
(14343, '2016-12-05 18:58:27', NULL, NULL, 5012, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 18:58:27', 'admin-1480920160-14809355070536476', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(14344, '2016-12-05 13:10:19', NULL, NULL, 5000, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 13:10:19', 'admin-1480899050-14809146188101248', 1, 1, 'SR', NULL, NULL, NULL),
(14345, '2016-12-05 12:23:16', NULL, NULL, 4996, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 12:23:16', 'admin-1480899050-14809117963742913', 1, 1, 'SR', NULL, NULL, NULL),
(14346, '2016-12-05 12:23:16', NULL, NULL, 4996, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 12:23:16', 'admin-1480899050-14809117963742913', 1, 1, 'SR', NULL, NULL, NULL),
(14347, '2016-12-05 12:27:29', NULL, NULL, 4997, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 12:27:29', 'admin-1480899050-14809120497597743', 1, 1, 'SR', NULL, NULL, NULL),
(14348, '2016-12-05 12:27:29', NULL, NULL, 4997, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 12:27:29', 'admin-1480899050-14809120497597743', 1, 1, 'SR', NULL, NULL, NULL),
(14349, '2016-12-05 12:44:21', NULL, NULL, 4998, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 12:44:21', 'admin-1480899050-14809130617822310', 1, 1, 'SR', NULL, NULL, NULL),
(14350, '2016-12-05 12:44:21', NULL, NULL, 4998, 0, 181, '116', 'Open Food ', 'Fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1480920160', 'admin', '2016-12-05 12:44:21', 'admin-1480899050-14809130617822310', 1, 0, '', NULL, NULL, NULL),
(14351, '2016-12-05 12:46:38', NULL, NULL, 4999, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 12:46:38', 'admin-1480899050-14809131984519342', 1, 1, 'SR', NULL, NULL, NULL),
(14352, '2016-12-05 12:46:38', NULL, NULL, 4999, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 12:46:38', 'admin-1480899050-14809131984519342', 1, 1, 'SR', NULL, NULL, NULL),
(14353, '2016-12-05 12:46:38', NULL, NULL, 4999, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 12:46:38', 'admin-1480899050-14809131984519342', 1, 1, 'SR', NULL, NULL, NULL),
(14354, '2016-12-05 12:46:38', NULL, NULL, 4999, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 12:46:38', 'admin-1480899050-14809131984519342', 1, 0, '', NULL, NULL, NULL),
(14355, '2016-12-05 12:51:29', NULL, NULL, 5000, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 12:51:29', 'admin-1480899050-14809134893325369', 1, 0, '', NULL, NULL, NULL),
(14356, '2016-12-05 12:51:29', NULL, NULL, 5000, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 12:51:29', 'admin-1480899050-14809134893325369', 1, 1, 'SR', NULL, NULL, NULL),
(14357, '2016-12-05 12:51:29', NULL, NULL, 5000, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 12:51:29', 'admin-1480899050-14809134893325369', 1, 0, '', NULL, NULL, NULL),
(14358, '2016-12-05 13:10:09', NULL, NULL, 4998, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 13:10:09', 'admin-1480899050-14809146093689439', 1, 1, 'SR', NULL, NULL, NULL),
(14359, '2016-12-05 13:49:19', NULL, NULL, 5001, 0, 86, '86', 'Set Pesto Pasta ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 13:49:19', 'admin-1480899050-1480916958857110', 1, 1, 'SR', NULL, NULL, NULL),
(14360, '2016-12-05 13:35:34', NULL, NULL, 5003, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 13:35:34', 'admin-1480899050-14809161340233838', 1, 0, '', NULL, NULL, NULL),
(14361, '2016-12-05 13:35:34', NULL, NULL, 5003, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 13:35:34', 'admin-1480899050-14809161340233838', 1, 1, 'SR', NULL, NULL, NULL),
(14362, '2016-12-05 13:35:34', NULL, NULL, 5003, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 13:35:34', 'admin-1480899050-14809161340233838', 1, 1, 'SR', NULL, NULL, NULL),
(14363, '2016-12-05 13:35:34', NULL, NULL, 5003, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 13:35:34', 'admin-1480899050-14809161340233838', 1, 1, 'SR', NULL, NULL, NULL),
(14364, '2016-12-05 13:27:15', NULL, NULL, 5001, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 13:27:15', 'admin-1480899050-14809156353717296', 1, 0, '', NULL, NULL, NULL),
(14365, '2016-12-05 13:24:52', NULL, NULL, 5002, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 13:24:52', 'admin-1480899050-14809154925402699', 1, 0, '', NULL, NULL, NULL),
(14366, '2016-12-05 13:24:52', NULL, NULL, 5002, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 13:24:52', 'admin-1480899050-14809154925402699', 1, 0, '', NULL, NULL, NULL),
(14367, '2016-12-05 13:24:52', NULL, NULL, 5002, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 13:24:52', 'admin-1480899050-14809154925402699', 1, 0, '', NULL, NULL, NULL),
(14368, '2016-12-05 13:24:14', NULL, NULL, 5001, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 13:24:14', 'admin-1480899050-14809154545826320', 1, 1, 'SR', NULL, NULL, NULL),
(14369, '2016-12-05 13:24:14', NULL, NULL, 5001, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 13:24:14', 'admin-1480899050-14809154545826320', 1, 0, '', NULL, NULL, NULL),
(14370, '2016-12-05 12:17:51', NULL, NULL, 4994, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 12:17:51', 'admin-1480899050-14809114708489693', 1, 0, '', NULL, NULL, NULL),
(14371, '2016-12-05 12:17:51', NULL, NULL, 4994, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 12:17:51', 'admin-1480899050-14809114708489693', 1, 1, 'SR', NULL, NULL, NULL),
(14372, '2016-12-05 12:17:51', NULL, NULL, 4994, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 12:17:51', 'admin-1480899050-14809114708489693', 1, 1, 'SR', NULL, NULL, NULL),
(14373, '2016-12-05 12:16:12', NULL, NULL, 4995, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 12:16:12', 'admin-1480899050-1480911372431139', 1, 0, '', NULL, NULL, NULL),
(14374, '2016-12-05 09:42:04', NULL, NULL, 4993, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 09:42:04', 'admin-1480899050-14809021240445186', 1, 1, 'SR', NULL, NULL, NULL),
(14375, '2016-12-05 09:42:04', NULL, NULL, 4993, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 09:42:04', 'admin-1480899050-14809021240445186', 1, 1, 'SR', NULL, NULL, NULL),
(14376, '2016-12-05 09:42:04', NULL, NULL, 4993, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 09:42:04', 'admin-1480899050-14809021240445186', 1, 0, '', NULL, NULL, NULL),
(14377, '2016-12-05 09:12:52', NULL, NULL, 4992, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 09:12:52', 'admin-1480899050-14809003725208831', 1, 1, 'SR', NULL, NULL, NULL),
(14378, '2016-12-05 09:42:04', NULL, NULL, 4993, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 09:42:04', 'admin-1480899050-14809021240445186', 1, 0, '', NULL, NULL, NULL),
(14379, '2016-12-05 09:12:52', NULL, NULL, 4992, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 09:12:52', 'admin-1480899050-14809003725208831', 1, 1, 'SR', NULL, NULL, NULL),
(14380, '2016-12-05 09:12:47', NULL, NULL, 4992, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 09:12:47', 'admin-1480899050-1480900367167426', 1, 0, '', NULL, NULL, NULL),
(14381, '2016-12-05 09:12:47', NULL, NULL, 4992, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1480920160', 'admin', '2016-12-05 09:12:47', 'admin-1480899050-1480900367167426', 1, 0, '', NULL, NULL, NULL),
(14382, '2016-12-07 16:35:37', NULL, NULL, 5030, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 16:35:37', 'admin-1481093949-1481099737556419', 1, 0, '', NULL, NULL, NULL),
(14383, '2016-12-07 16:35:37', NULL, NULL, 5030, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 16:35:37', 'admin-1481093949-1481099737556419', 1, 0, '', NULL, NULL, NULL),
(14384, '2016-12-07 16:35:37', NULL, NULL, 5030, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 16:35:37', 'admin-1481093949-1481099737556419', 1, 1, 'SR', NULL, NULL, NULL),
(14385, '2016-12-07 17:29:27', NULL, NULL, 5031, 0, 195, '130', 'Cucumber Lime Soda BOFO', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 17:29:27', 'admin-1481093949-14811029674325114', 1, 0, '', NULL, NULL, NULL),
(14386, '2016-12-07 17:29:27', NULL, NULL, 5031, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 17:29:27', 'admin-1481093949-14811029674325114', 1, 1, 'SR', NULL, NULL, NULL),
(14387, '2016-12-07 17:36:17', NULL, NULL, 5031, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 17:36:17', 'admin-1481093949-14811033777108857', 1, 0, '', NULL, NULL, NULL),
(14388, '2016-12-07 17:37:10', NULL, NULL, 5031, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 17:37:10', 'admin-1481093949-14811034302841687', 1, 0, '', NULL, NULL, NULL),
(14389, '2016-12-07 19:59:34', NULL, NULL, 5034, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 19:59:34', 'admin-1481093949-1481111974043136', 1, 1, 'SR', NULL, NULL, NULL),
(14390, '2016-12-07 19:59:34', NULL, NULL, 5034, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 19:59:34', 'admin-1481093949-1481111974043136', 1, 0, '', NULL, NULL, NULL),
(14391, '2016-12-07 19:58:46', NULL, NULL, 5034, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 19:58:46', 'admin-1481093949-14811119267761164', 1, 0, '', NULL, NULL, NULL),
(14392, '2016-12-07 19:54:43', NULL, NULL, 5033, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 19:54:43', 'admin-1481093949-14811116832185460', 1, 0, '', NULL, NULL, NULL),
(14393, '2016-12-07 19:16:43', NULL, NULL, 5032, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 19:16:43', 'admin-1481093949-1481109403509374', 1, 1, 'SR', NULL, NULL, NULL),
(14394, '2016-12-07 19:16:43', NULL, NULL, 5032, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 19:16:43', 'admin-1481093949-1481109403509374', 1, 1, 'SR', NULL, NULL, NULL),
(14395, '2016-12-07 15:41:51', NULL, NULL, 5029, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 15:41:51', 'admin-1481093949-14810965117348050', 1, 0, '', NULL, NULL, NULL),
(14396, '2016-12-07 16:35:37', NULL, NULL, 5030, 0, 195, '130', 'Cucumber Lime Soda BOFO', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 16:35:37', 'admin-1481093949-1481099737556419', 1, 0, '', NULL, NULL, NULL),
(14397, '2016-12-07 11:16:13', NULL, NULL, 5019, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 11:16:13', 'admin-1481072407-14810805737476686', 1, 0, '', NULL, NULL, NULL),
(14398, '2016-12-07 11:16:13', NULL, NULL, 5019, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 11:16:13', 'admin-1481072407-14810805737476686', 1, 0, '', NULL, NULL, NULL),
(14399, '2016-12-07 11:25:10', NULL, NULL, 5020, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 11:25:10', 'admin-1481072407-1481081110634578', 1, 1, 'SR', NULL, NULL, NULL),
(14400, '2016-12-07 11:25:10', NULL, NULL, 5020, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 11:25:10', 'admin-1481072407-1481081110634578', 1, 0, '', NULL, NULL, NULL),
(14401, '2016-12-07 11:33:34', NULL, NULL, 5021, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 11:33:34', 'admin-1481072407-14810816144685156', 1, 0, '', NULL, NULL, NULL),
(14402, '2016-12-07 11:33:34', NULL, NULL, 5021, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 11:33:34', 'admin-1481072407-14810816144685156', 1, 1, 'SR', NULL, NULL, NULL),
(14403, '2016-12-07 11:33:34', NULL, NULL, 5021, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 11:33:34', 'admin-1481072407-14810816144685156', 1, 1, 'SR', NULL, NULL, NULL),
(14404, '2016-12-07 12:12:40', NULL, NULL, 5022, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 12:12:40', 'admin-1481072407-1481083960129530', 1, 1, 'SR', NULL, NULL, NULL),
(14405, '2016-12-07 12:12:40', NULL, NULL, 5022, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 12:12:40', 'admin-1481072407-1481083960129530', 1, 0, '', NULL, NULL, NULL),
(14406, '2016-12-07 12:46:31', NULL, NULL, 5023, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 12:46:31', 'admin-1481072407-14810859914311195', 1, 0, '', NULL, NULL, NULL),
(14407, '2016-12-07 13:06:49', NULL, NULL, 5024, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 13:06:49', 'admin-1481072407-1481087209037267', 1, 0, '', NULL, NULL, NULL),
(14408, '2016-12-07 13:06:49', NULL, NULL, 5024, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 13:06:49', 'admin-1481072407-1481087209037267', 1, 1, 'SR', NULL, NULL, NULL),
(14409, '2016-12-07 13:56:00', NULL, NULL, 5025, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 13:56:00', 'admin-1481072407-14810901601063032', 1, 1, 'SR', NULL, NULL, NULL),
(14410, '2016-12-07 13:56:00', NULL, NULL, 5025, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 13:56:00', 'admin-1481072407-14810901601063032', 1, 1, 'SR', NULL, NULL, NULL),
(14411, '2016-12-07 14:11:46', NULL, NULL, 5026, 0, 86, '86', 'Set Pesto Pasta ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 14:11:46', 'admin-1481072407-14810911062416712', 1, 1, 'SR', NULL, NULL, NULL),
(14412, '2016-12-07 14:11:46', NULL, NULL, 5026, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 14:11:46', 'admin-1481072407-14810911062416712', 1, 0, '', NULL, NULL, NULL),
(14413, '2016-12-07 14:15:03', NULL, NULL, 5027, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 14:15:03', 'admin-1481072407-14810913038166179', 1, 1, 'SR', NULL, NULL, '10.0'),
(14414, '2016-12-07 14:15:03', NULL, NULL, 5027, 0, 181, '116', 'Open Food ', 'Homemade Fish cake Noodle Soup', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 14:15:03', 'admin-1481072407-14810913038166179', 1, 0, '', NULL, NULL, '10.0'),
(14415, '2016-12-07 14:18:57', NULL, NULL, 5027, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 14:18:57', 'admin-1481072407-14810915371376185', 1, 1, 'SR', NULL, NULL, '10.0'),
(14416, '2016-12-07 14:18:57', NULL, NULL, 5027, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 14:18:57', 'admin-1481072407-14810915371376185', 1, 1, 'SR', NULL, NULL, '10.0'),
(14417, '2016-12-07 14:20:04', NULL, NULL, 5028, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 14:20:04', 'admin-1481072407-1481091604262667', 1, 1, 'SR', NULL, NULL, NULL),
(14418, '2016-12-07 14:20:04', NULL, NULL, 5028, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 14:20:04', 'admin-1481072407-1481091604262667', 1, 1, 'SR', NULL, NULL, NULL),
(14419, '2016-12-07 14:58:54', NULL, NULL, 5029, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 14:58:54', 'admin-1481072407-14810939345517414', 1, 0, '', NULL, NULL, NULL),
(14420, '2016-12-07 14:58:54', NULL, NULL, 5029, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 14:58:54', 'admin-1481072407-14810939345517414', 1, 0, '', NULL, NULL, NULL),
(14421, '2016-12-07 14:59:49', NULL, NULL, 5029, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 14:59:49', 'admin-1481093949-14810939888355678', 1, 1, 'SR', NULL, NULL, NULL),
(14422, '2016-12-07 14:59:49', NULL, NULL, 5029, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 14:59:49', 'admin-1481093949-14810939888355678', 1, 0, '', NULL, NULL, NULL),
(14423, '2016-12-07 10:27:12', NULL, NULL, 5018, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 10:27:12', 'admin-1481072407-14810776324824892', 1, 0, '', NULL, NULL, NULL),
(14424, '2016-12-07 10:26:15', NULL, NULL, 5018, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 10:26:15', 'admin-1481072407-14810775752264092', 1, 0, '', NULL, NULL, NULL),
(14425, '2016-12-07 10:26:08', NULL, NULL, 5018, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 10:26:08', 'admin-1481072407-14810775687463243', 1, 1, 'SR', NULL, NULL, NULL),
(14426, '2016-12-07 10:26:08', NULL, NULL, 5018, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 10:26:08', 'admin-1481072407-14810775687463243', 1, 1, 'SR', NULL, NULL, NULL),
(14427, '2016-12-07 10:07:31', NULL, NULL, 5017, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 10:07:31', 'admin-1481072407-14810764516065874', 1, 1, 'SR', NULL, NULL, NULL),
(14428, '2016-12-07 10:07:31', NULL, NULL, 5017, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 10:07:31', 'admin-1481072407-14810764516065874', 1, 1, 'SR', NULL, NULL, NULL),
(14429, '2016-12-07 09:38:05', NULL, NULL, 5016, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 09:38:05', 'admin-1481072407-14810746849616331', 1, 1, 'SR', NULL, NULL, '10.0'),
(14430, '2016-12-07 10:07:31', NULL, NULL, 5017, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 10:07:31', 'admin-1481072407-14810764516065874', 1, 0, '', NULL, NULL, NULL),
(14431, '2016-12-07 09:10:07', NULL, NULL, 5015, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 09:10:07', 'admin-1481072407-1481073007701418', 1, 1, 'SR', NULL, NULL, NULL),
(14432, '2016-12-07 09:19:34', NULL, NULL, 5015, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 09:19:34', 'admin-1481072407-14810735744916130', 1, 0, '', NULL, NULL, NULL),
(14433, '2016-12-07 09:10:07', NULL, NULL, 5015, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 09:10:07', 'admin-1481072407-1481073007701418', 1, 1, 'SR', NULL, NULL, NULL),
(14434, '2016-12-07 09:10:07', NULL, NULL, 5015, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481093949', 'admin', '2016-12-07 09:10:07', 'admin-1481072407-1481073007701418', 1, 1, 'SR', NULL, NULL, NULL),
(14435, '2016-12-08 19:03:21', NULL, NULL, 5050, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 19:03:21', 'admin-1481177360-14811950016081152', 1, 1, 'SR', NULL, NULL, NULL),
(14436, '2016-12-08 19:27:51', NULL, NULL, 5050, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 19:27:51', 'admin-1481177360-14811964710311267', 1, 0, '', NULL, NULL, NULL),
(14437, '2016-12-08 11:54:30', NULL, NULL, 5039, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 11:54:30', 'admin-1481158508-1481169270549431', 1, 1, 'SR', NULL, NULL, NULL),
(14438, '2016-12-08 11:58:13', NULL, NULL, 5040, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 11:58:13', 'admin-1481158508-14811694930575354', 1, 1, 'SR', NULL, NULL, NULL),
(14439, '2016-12-08 11:58:13', NULL, NULL, 5040, 0, 85, '85', 'Set Sauted Mushroom Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 11:58:13', 'admin-1481158508-14811694930575354', 1, 1, 'SR', NULL, NULL, NULL),
(14440, '2016-12-08 12:43:25', NULL, NULL, 5041, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 12:43:25', 'admin-1481158508-14811722050037616', 1, 1, 'SR', NULL, NULL, NULL),
(14441, '2016-12-08 12:43:25', NULL, NULL, 5041, 0, 214, '148', 'Set Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 12:43:25', 'admin-1481158508-14811722050037616', 1, 0, '', NULL, NULL, NULL),
(14442, '2016-12-08 12:51:00', NULL, NULL, 5042, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 12:51:00', 'admin-1481158508-14811726603221048', 1, 1, 'SR', NULL, NULL, NULL),
(14443, '2016-12-08 12:51:00', NULL, NULL, 5042, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 12:51:00', 'admin-1481158508-14811726603221048', 1, 1, 'SR', NULL, NULL, NULL),
(14444, '2016-12-08 13:16:29', NULL, NULL, 5043, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 13:16:29', 'admin-1481158508-14811741891095470', 1, 1, 'SR', NULL, NULL, NULL),
(14445, '2016-12-08 13:16:29', NULL, NULL, 5043, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 13:16:29', 'admin-1481158508-14811741891095470', 1, 1, 'SR', NULL, NULL, NULL),
(14446, '2016-12-08 13:16:29', NULL, NULL, 5043, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 13:16:29', 'admin-1481158508-14811741891095470', 1, 1, 'SR', NULL, NULL, NULL),
(14447, '2016-12-08 13:16:29', NULL, NULL, 5043, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 13:16:29', 'admin-1481158508-14811741891095470', 1, 0, '', NULL, NULL, NULL),
(14448, '2016-12-08 14:07:53', NULL, NULL, 5044, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 14:07:53', 'admin-1481158508-14811772737603420', 1, 1, 'SR', NULL, NULL, NULL),
(14449, '2016-12-08 14:09:11', NULL, NULL, 5044, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 14:09:11', 'admin-1481158508-14811773516613477', 1, 0, '', NULL, NULL, NULL),
(14450, '2016-12-08 14:56:40', NULL, NULL, 5045, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 14:56:40', 'admin-1481177360-14811802003237717', 1, 1, 'SR', NULL, NULL, NULL),
(14451, '2016-12-08 14:56:40', NULL, NULL, 5045, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 14:56:40', 'admin-1481177360-14811802003237717', 1, 0, '', NULL, NULL, NULL),
(14452, '2016-12-08 14:56:40', NULL, NULL, 5045, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 14:56:40', 'admin-1481177360-14811802003237717', 1, 0, '', NULL, NULL, NULL),
(14453, '2016-12-08 15:44:50', NULL, NULL, 5046, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 15:44:50', 'admin-1481177360-14811830906558826', 1, 1, 'SR', NULL, NULL, NULL),
(14454, '2016-12-08 16:24:50', NULL, NULL, 5047, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 16:24:50', 'admin-1481177360-14811854907953873', 1, 0, '', 1, NULL, NULL),
(14455, '2016-12-08 17:37:45', NULL, NULL, 5048, 0, 72, '72', 'Mushroom Chicken', 'Add 4 pcs sausage', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 17:37:45', 'admin-1481177360-14811898656685599', 1, 1, 'SR', NULL, NULL, NULL),
(14456, '2016-12-08 17:37:45', NULL, NULL, 5048, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 17:37:45', 'admin-1481177360-14811898656685599', 1, 0, '', NULL, NULL, NULL),
(14457, '2016-12-08 17:52:28', NULL, NULL, 5048, 0, 244, '178', 'Macadamia Scones', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 17:52:28', 'admin-1481177360-1481190748375482', 1, 0, '', NULL, NULL, NULL),
(14458, '2016-12-08 18:06:34', NULL, NULL, 5048, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 18:06:34', 'admin-1481177360-1481191594416221', 1, 1, 'SR', NULL, NULL, NULL),
(14459, '2016-12-08 18:06:34', NULL, NULL, 5048, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 18:06:34', 'admin-1481177360-1481191594416221', 1, 1, 'SR', NULL, NULL, NULL),
(14460, '2016-12-08 18:06:43', NULL, NULL, 5049, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 18:06:43', 'admin-1481177360-14811916035514745', 1, 1, 'SR', NULL, NULL, NULL),
(14461, '2016-12-08 19:02:31', NULL, NULL, 5050, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 19:02:31', 'admin-1481177360-14811949510643724', 1, 0, '', NULL, NULL, NULL),
(14462, '2016-12-08 19:03:21', NULL, NULL, 5050, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 19:03:21', 'admin-1481177360-14811950016081152', 1, 0, '', NULL, NULL, NULL),
(14463, '2016-12-08 10:39:28', NULL, NULL, 5038, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 10:39:28', 'admin-1481158508-14811647686823847', 1, 1, 'SR', NULL, NULL, NULL),
(14464, '2016-12-08 10:39:28', NULL, NULL, 5038, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 10:39:28', 'admin-1481158508-14811647686823847', 1, 0, '', NULL, NULL, NULL),
(14465, '2016-12-08 10:13:57', NULL, NULL, 5037, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 10:13:57', 'admin-1481158508-1481163237072244', 1, 1, 'SR', NULL, NULL, NULL),
(14466, '2016-12-08 10:09:30', NULL, NULL, 5035, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 10:09:30', 'admin-1481158508-14811629698143086', 1, 1, 'SR', NULL, NULL, NULL),
(14467, '2016-12-08 10:09:30', NULL, NULL, 5035, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 10:09:30', 'admin-1481158508-14811629698143086', 1, 0, '', NULL, NULL, NULL),
(14468, '2016-12-08 10:09:30', NULL, NULL, 5035, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 10:09:30', 'admin-1481158508-14811629698143086', 1, 1, 'SR', NULL, NULL, NULL),
(14469, '2016-12-08 09:47:17', NULL, NULL, 5037, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 09:47:17', 'admin-1481158508-14811616377682814', 1, 0, '', NULL, NULL, NULL),
(14470, '2016-12-08 09:47:17', NULL, NULL, 5037, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 09:47:17', 'admin-1481158508-14811616377682814', 1, 0, '', NULL, NULL, NULL),
(14471, '2016-12-08 09:47:17', NULL, NULL, 5037, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 09:47:17', 'admin-1481158508-14811616377682814', 1, 1, 'SR', NULL, NULL, NULL),
(14472, '2016-12-08 09:47:17', NULL, NULL, 5037, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 09:47:17', 'admin-1481158508-14811616377682814', 1, 0, '', NULL, NULL, NULL),
(14473, '2016-12-08 09:34:54', NULL, NULL, 5036, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 09:34:54', 'admin-1481158508-14811608940248196', 1, 1, 'SR', NULL, NULL, NULL),
(14474, '2016-12-08 09:30:27', NULL, NULL, 5035, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481177360', 'admin', '2016-12-08 09:30:27', 'admin-1481158508-14811606277914591', 1, 0, '', NULL, NULL, NULL),
(14475, '2016-12-09 17:36:43', NULL, NULL, 5066, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 17:36:43', 'admin-1481245064-14812762029654943', 1, 0, '', NULL, NULL, NULL),
(14476, '2016-12-09 17:37:39', NULL, NULL, 5066, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 17:37:39', 'admin-1481245064-14812762590171184', 1, 0, '', NULL, NULL, NULL),
(14477, '2016-12-09 17:37:39', NULL, NULL, 5066, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 17:37:39', 'admin-1481245064-14812762590171184', 1, 0, '', NULL, NULL, NULL),
(14478, '2016-12-09 18:18:48', NULL, NULL, 5067, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 18:18:48', 'admin-1481245064-14812787279411219', 1, 1, 'SR', NULL, NULL, NULL),
(14479, '2016-12-09 18:20:08', NULL, NULL, 5067, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 18:20:08', 'admin-1481245064-14812788084677978', 1, 1, 'SR', NULL, NULL, NULL),
(14480, '2016-12-09 20:08:20', NULL, NULL, 5068, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 20:08:20', 'admin-1481245064-148128530054977', 1, 1, 'SR', NULL, NULL, NULL),
(14481, '2016-12-09 20:08:20', NULL, NULL, 5068, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 20:08:20', 'admin-1481245064-148128530054977', 1, 0, '', NULL, NULL, NULL),
(14482, '2016-12-09 20:36:26', NULL, NULL, 5070, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 20:36:26', 'admin-1481245064-14812869864924449', 1, 0, '', NULL, NULL, NULL),
(14483, '2016-12-09 20:36:26', NULL, NULL, 5070, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 20:36:26', 'admin-1481245064-14812869864924449', 1, 0, '', NULL, NULL, NULL),
(14484, '2016-12-09 20:35:33', NULL, NULL, 5069, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 20:35:33', 'admin-1481245064-14812869328466810', 1, 1, 'SR', NULL, NULL, '10.0'),
(14485, '2016-12-09 11:46:26', NULL, NULL, 5054, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 11:46:26', 'admin-1481245064-14812551866416464', 1, 1, 'SR', NULL, NULL, NULL),
(14486, '2016-12-09 12:10:53', NULL, NULL, 5056, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 12:10:53', 'admin-1481245064-1481256653038866', 1, 1, 'SR', NULL, NULL, NULL),
(14487, '2016-12-09 12:10:53', NULL, NULL, 5056, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 12:10:53', 'admin-1481245064-1481256653038866', 1, 1, 'SR', NULL, NULL, NULL),
(14488, '2016-12-09 12:10:53', NULL, NULL, 5056, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 12:10:53', 'admin-1481245064-1481256653038866', 1, 1, 'SR', NULL, NULL, NULL),
(14489, '2016-12-09 12:25:44', NULL, NULL, 5057, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 12:25:44', 'admin-1481245064-1481257543920438', 1, 1, 'SR', NULL, NULL, NULL),
(14490, '2016-12-09 12:25:44', NULL, NULL, 5057, 0, 85, '85', 'Set Sauted Mushroom Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 12:25:44', 'admin-1481245064-1481257543920438', 1, 1, 'SR', NULL, NULL, NULL),
(14491, '2016-12-09 13:33:43', NULL, NULL, 5057, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 13:33:43', 'admin-1481245064-14812616237163323', 1, 1, 'SR', NULL, NULL, NULL),
(14492, '2016-12-09 13:47:13', NULL, NULL, 5058, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 13:47:13', 'admin-1481245064-14812624333319625', 1, 0, '', NULL, NULL, NULL),
(14493, '2016-12-09 13:47:13', NULL, NULL, 5058, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 13:47:13', 'admin-1481245064-14812624333319625', 1, 1, 'SR', NULL, NULL, NULL),
(14494, '2016-12-09 14:09:30', NULL, NULL, 5059, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 14:09:30', 'admin-1481245064-14812637699701936', 1, 0, '', NULL, NULL, NULL),
(14495, '2016-12-09 14:09:49', NULL, NULL, 5059, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 14:09:49', 'admin-1481245064-14812637893685877', 1, 1, 'SR', NULL, NULL, NULL),
(14496, '2016-12-09 14:22:45', NULL, NULL, 5060, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 14:22:45', 'admin-1481245064-14812645654338211', 1, 1, 'SR', NULL, NULL, NULL),
(14497, '2016-12-09 14:22:45', NULL, NULL, 5060, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 14:22:45', 'admin-1481245064-14812645654338211', 1, 0, '', NULL, NULL, NULL),
(14498, '2016-12-09 15:02:31', NULL, NULL, 5061, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 15:02:31', 'admin-1481245064-1481266951166269', 1, 1, 'SR', NULL, NULL, '10.0'),
(14499, '2016-12-09 15:02:31', NULL, NULL, 5061, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 15:02:31', 'admin-1481245064-1481266951166269', 1, 0, '', NULL, NULL, '10.0'),
(14500, '2016-12-09 15:02:31', NULL, NULL, 5061, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 15:02:31', 'admin-1481245064-1481266951166269', 1, 0, '', NULL, NULL, '10.0'),
(14501, '2016-12-09 15:02:31', NULL, NULL, 5061, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 15:02:31', 'admin-1481245064-1481266951166269', 1, 0, '', NULL, NULL, '10.0'),
(14502, '2016-12-09 15:38:01', NULL, NULL, 5062, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 15:38:01', 'admin-1481245064-14812690809461380', 1, 1, 'SR', 1, NULL, NULL),
(14503, '2016-12-09 16:20:37', NULL, NULL, 5063, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 16:20:37', 'admin-1481245064-1481271637648477', 1, 1, 'SR', NULL, NULL, NULL),
(14504, '2016-12-09 16:20:37', NULL, NULL, 5063, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 16:20:37', 'admin-1481245064-1481271637648477', 1, 1, 'SR', NULL, NULL, NULL),
(14505, '2016-12-09 16:21:14', NULL, NULL, 5064, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 16:21:14', 'admin-1481245064-14812716739756269', 1, 0, '', NULL, NULL, NULL),
(14506, '2016-12-09 16:21:14', NULL, NULL, 5064, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 16:21:14', 'admin-1481245064-14812716739756269', 1, 0, '', NULL, NULL, NULL),
(14507, '2016-12-09 16:21:14', NULL, NULL, 5064, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 16:21:14', 'admin-1481245064-14812716739756269', 1, 0, '', NULL, NULL, NULL),
(14508, '2016-12-09 16:21:14', NULL, NULL, 5064, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 16:21:14', 'admin-1481245064-14812716739756269', 1, 1, 'SR', NULL, NULL, NULL),
(14509, '2016-12-09 16:21:58', NULL, NULL, 5063, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 16:21:58', 'admin-1481245064-14812717178837494', 1, 0, '', NULL, NULL, NULL),
(14510, '2016-12-09 17:05:43', NULL, NULL, 5065, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 17:05:43', 'admin-1481245064-14812743431558468', 1, 1, 'SR', NULL, NULL, NULL),
(14511, '2016-12-09 11:19:53', NULL, NULL, 5055, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 11:19:53', 'admin-1481245064-14812535932386761', 1, 1, 'SR', NULL, NULL, NULL),
(14512, '2016-12-09 11:19:53', NULL, NULL, 5055, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 11:19:53', 'admin-1481245064-14812535932386761', 1, 1, 'SR', NULL, NULL, NULL),
(14513, '2016-12-09 11:05:05', NULL, NULL, 5054, 0, 244, '178', 'Macadamia Scones', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 11:05:05', 'admin-1481245064-14812527054176695', 1, 0, '', NULL, NULL, NULL),
(14514, '2016-12-09 11:05:05', NULL, NULL, 5054, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 11:05:05', 'admin-1481245064-14812527054176695', 1, 1, 'SR', NULL, NULL, NULL),
(14515, '2016-12-09 10:24:03', NULL, NULL, 5052, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 10:24:03', 'admin-1481245064-14812502431384166', 1, 0, '', NULL, NULL, NULL),
(14516, '2016-12-09 10:32:17', NULL, NULL, 5053, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 10:32:17', 'admin-1481245064-14812507376995499', 1, 0, '', NULL, NULL, NULL),
(14517, '2016-12-09 10:32:17', NULL, NULL, 5053, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 10:32:17', 'admin-1481245064-14812507376995499', 1, 1, 'SR', NULL, NULL, NULL),
(14518, '2016-12-09 10:32:17', NULL, NULL, 5053, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 10:32:17', 'admin-1481245064-14812507376995499', 1, 1, 'SR', NULL, NULL, NULL),
(14519, '2016-12-09 10:22:06', NULL, NULL, 5052, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 10:22:06', 'admin-1481245064-1481250126491566', 1, 1, 'SR', NULL, NULL, NULL),
(14520, '2016-12-09 10:24:03', NULL, NULL, 5052, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 10:24:03', 'admin-1481245064-14812502431384166', 1, 0, '', NULL, NULL, NULL),
(14521, '2016-12-09 10:22:02', NULL, NULL, 5052, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 10:22:02', 'admin-1481245064-14812501227687819', 1, 0, '', NULL, NULL, NULL),
(14522, '2016-12-09 08:59:28', NULL, NULL, 5051, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481245064', 'admin', '2016-12-09 08:59:28', 'admin-1481245064-14812451682011693', 1, 0, '', NULL, NULL, NULL),
(14523, '2016-12-10 17:34:09', NULL, NULL, 5098, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 17:34:09', 'admin-1481358514-14813624494158330', 1, 1, 'SR', NULL, NULL, NULL),
(14524, '2016-12-10 18:48:59', NULL, NULL, 5099, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 18:48:59', 'admin-1481358514-14813669391815664', 1, 0, '', NULL, NULL, NULL),
(14525, '2016-12-10 18:48:59', NULL, NULL, 5099, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 18:48:59', 'admin-1481358514-14813669391815664', 1, 0, '', NULL, NULL, NULL),
(14526, '2016-12-10 18:48:59', NULL, NULL, 5099, 0, 181, '116', 'Open Food ', 'markerel Fish', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 18:48:59', 'admin-1481358514-14813669391815664', 1, 0, '', NULL, NULL, NULL),
(14527, '2016-12-10 18:48:59', NULL, NULL, 5099, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 18:48:59', 'admin-1481358514-14813669391815664', 1, 1, 'SR', NULL, NULL, NULL),
(14528, '2016-12-10 18:48:59', NULL, NULL, 5099, 0, 181, '116', 'Open Food ', 'Lotus Root,Lotus Root ', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 18:48:59', 'admin-1481358514-14813669391815664', 1, 0, '', NULL, NULL, NULL),
(14529, '2016-12-10 14:15:37', NULL, NULL, 5092, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 14:15:37', 'admin-1481349068-14813505377756013', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(14530, '2016-12-10 14:20:06', NULL, NULL, 5092, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 14:20:06', 'admin-1481349068-14813508060739857', 1, 1, 'SR', NULL, NULL, NULL),
(14531, '2016-12-10 14:57:50', NULL, NULL, 5094, 0, 82, '82', 'Set Rice Wine Ginger Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 14:57:50', 'admin-1481349068-14813530698685433', 1, 1, 'SR', NULL, NULL, NULL),
(14532, '2016-12-10 14:57:50', NULL, NULL, 5094, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 14:57:50', 'admin-1481349068-14813530698685433', 1, 0, '', NULL, NULL, NULL),
(14533, '2016-12-10 15:21:12', NULL, NULL, 5095, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 15:21:12', 'admin-1481349068-14813544721768266', 1, 1, 'SR', 1, NULL, NULL),
(14534, '2016-12-10 15:21:12', NULL, NULL, 5095, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 15:21:12', 'admin-1481349068-14813544721768266', 1, 1, 'SR', 1, NULL, NULL),
(14535, '2016-12-10 11:35:49', NULL, NULL, 5087, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 11:35:49', 'admin-1481340735-14813409493407540', 1, 0, '', NULL, NULL, NULL),
(14536, '2016-12-10 11:35:49', NULL, NULL, 5087, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 11:35:49', 'admin-1481340735-14813409493407540', 1, 0, '', NULL, NULL, NULL),
(14537, '2016-12-10 12:23:39', NULL, NULL, 5088, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 12:23:39', 'admin-1481340735-14813438188831212', 1, 1, 'SR', NULL, NULL, NULL),
(14538, '2016-12-10 12:23:39', NULL, NULL, 5088, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 12:23:39', 'admin-1481340735-14813438188831212', 1, 1, 'SR', NULL, NULL, NULL),
(14539, '2016-12-10 13:27:17', NULL, NULL, 5089, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 13:27:17', 'admin-1481340735-14813476367836678', 1, 1, 'SR', NULL, NULL, NULL),
(14540, '2016-12-10 13:27:17', NULL, NULL, 5089, 0, 83, '83', 'Set Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 13:27:17', 'admin-1481340735-14813476367836678', 1, 1, 'SR', NULL, NULL, NULL),
(14541, '2016-12-10 13:38:24', NULL, NULL, 5090, 0, 85, '85', 'Set Sauted Mushroom Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 13:38:24', 'admin-1481340735-14813483044829131', 1, 1, 'SR', NULL, NULL, NULL),
(14542, '2016-12-10 13:40:59', NULL, NULL, 5089, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 13:40:59', 'admin-1481340735-14813484590404563', 1, 0, '', NULL, NULL, NULL),
(14543, '2016-12-10 13:49:45', NULL, NULL, 5091, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 13:49:45', 'admin-1481340735-1481348985494253', 1, 1, 'SR', NULL, NULL, NULL),
(14544, '2016-12-10 13:49:45', NULL, NULL, 5091, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 13:49:45', 'admin-1481340735-1481348985494253', 1, 0, '', NULL, NULL, NULL),
(14545, '2016-12-10 13:49:45', NULL, NULL, 5091, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 13:49:45', 'admin-1481340735-1481348985494253', 1, 1, 'SR', NULL, NULL, NULL),
(14546, '2016-12-10 14:01:39', NULL, NULL, 5089, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 14:01:39', 'admin-1481349068-14813496990181035', 1, 0, '', NULL, NULL, NULL),
(14547, '2016-12-10 14:01:39', NULL, NULL, 5089, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 14:01:39', 'admin-1481349068-14813496990181035', 1, 0, '', NULL, NULL, NULL),
(14548, '2016-12-10 14:01:39', NULL, NULL, 5089, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 14:01:39', 'admin-1481349068-14813496990181035', 1, 1, 'SR', NULL, NULL, NULL),
(14549, '2016-12-10 14:01:44', NULL, NULL, 5089, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 14:01:44', 'admin-1481349068-14813497046263673', 1, 1, 'SR', NULL, NULL, NULL),
(14550, '2016-12-10 14:01:44', NULL, NULL, 5089, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 14:01:44', 'admin-1481349068-14813497046263673', 1, 1, 'SR', NULL, NULL, NULL),
(14551, '2016-12-10 14:05:07', NULL, NULL, 5089, 0, 85, '85', 'Set Sauted Mushroom Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 14:05:07', 'admin-1481349068-14813499068865947', 1, 1, 'SR', NULL, NULL, NULL),
(14552, '2016-12-10 14:15:37', NULL, NULL, 5092, 0, 181, '116', 'Open Food ', 'Ginger Fish Cake', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 14:15:37', 'admin-1481349068-14813505377756013', 1, 0, '', NULL, NULL, NULL),
(14553, '2016-12-10 14:30:25', NULL, NULL, 5092, 0, 181, '116', 'Open Food ', 'French Beans', 'Meals', 'Perfect Meals', 1, 3.50, 3.5000, 0.0000, 3.50, 1, '27', 1, '1481358514', 'admin', '2016-12-10 14:30:25', 'admin-1481349068-14813514251679094', 1, 0, '', NULL, NULL, NULL),
(14554, '2016-12-10 14:55:04', NULL, NULL, 5093, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 14:55:04', 'admin-1481349068-14813529047037353', 1, 1, 'SR', NULL, NULL, NULL),
(14555, '2016-12-10 14:55:04', NULL, NULL, 5093, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 14:55:04', 'admin-1481349068-14813529047037353', 1, 1, 'SR', NULL, NULL, NULL),
(14556, '2016-12-10 11:35:42', NULL, NULL, 5087, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 11:35:42', 'admin-1481340735-14813409418939852', 1, 1, 'SR', NULL, NULL, NULL),
(14557, '2016-12-10 11:35:42', NULL, NULL, 5087, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 11:35:42', 'admin-1481340735-14813409418939852', 1, 1, 'SR', NULL, NULL, NULL),
(14558, '2016-12-10 18:48:59', NULL, NULL, 5099, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 18:48:59', 'admin-1481358514-14813669391815664', 1, 0, '', NULL, NULL, NULL),
(14559, '2016-12-10 19:10:16', NULL, NULL, 5100, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 19:10:16', 'admin-1481358514-14813682167033297', 1, 0, '', NULL, NULL, NULL),
(14560, '2016-12-10 15:44:30', NULL, NULL, 5097, 0, 244, '178', 'Macadamia Scones', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 15:44:30', 'admin-1481349068-14813558698526134', 1, 0, '', 1, NULL, NULL),
(14561, '2016-12-10 16:13:14', NULL, NULL, 5094, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 16:13:14', 'admin-1481349068-14813575945985912', 1, 0, '', NULL, NULL, NULL),
(14562, '2016-12-10 18:48:59', NULL, NULL, 5099, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 18:48:59', 'admin-1481358514-14813669391815664', 1, 0, '', NULL, NULL, NULL),
(14563, '2016-12-10 16:37:16', NULL, NULL, 5090, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 16:37:16', 'admin-1481358514-14813590364713543', 1, 1, 'SR', NULL, NULL, NULL),
(14564, '2016-12-10 16:37:16', NULL, NULL, 5090, 0, 224, '158', 'Set Garlic Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 16:37:16', 'admin-1481358514-14813590364713543', 1, 0, '', NULL, NULL, NULL),
(14565, '2016-12-10 17:34:09', NULL, NULL, 5098, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 17:34:09', 'admin-1481358514-14813624494158330', 1, 0, '', NULL, NULL, NULL),
(14566, '2016-12-10 15:23:47', NULL, NULL, 5096, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 15:23:47', 'admin-1481349068-14813546268991972', 1, 0, '', 1, NULL, NULL),
(14567, '2016-12-10 10:09:30', NULL, NULL, 5081, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 10:09:30', 'admin-1481333796-14813357706422489', 1, 0, '', NULL, NULL, NULL),
(14568, '2016-12-10 10:09:30', NULL, NULL, 5081, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 10:09:30', 'admin-1481333796-14813357706422489', 1, 0, '', NULL, NULL, NULL),
(14569, '2016-12-10 10:09:30', NULL, NULL, 5081, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 10:09:30', 'admin-1481333796-14813357706422489', 1, 0, '', NULL, NULL, NULL),
(14570, '2016-12-10 10:09:30', NULL, NULL, 5081, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 10:09:30', 'admin-1481333796-14813357706422489', 1, 0, '', NULL, NULL, NULL),
(14571, '2016-12-10 09:56:00', NULL, NULL, 5080, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:56:00', 'admin-1481333796-14813349603667256', 1, 1, 'SR', NULL, NULL, NULL),
(14572, '2016-12-10 09:56:00', NULL, NULL, 5080, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:56:00', 'admin-1481333796-14813349603667256', 1, 1, 'SR', NULL, NULL, NULL),
(14573, '2016-12-10 09:56:00', NULL, NULL, 5080, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:56:00', 'admin-1481333796-14813349603667256', 1, 0, '', NULL, NULL, NULL),
(14574, '2016-12-10 15:35:22', NULL, NULL, 5094, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 15:35:22', 'admin-1481349068-14813553220537283', 1, 0, '', NULL, NULL, NULL),
(14575, '2016-12-10 15:23:47', NULL, NULL, 5096, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 15:23:47', 'admin-1481349068-14813546268991972', 1, 0, '', 1, NULL, NULL),
(14576, '2016-12-10 15:23:47', NULL, NULL, 5096, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 15:23:47', 'admin-1481349068-14813546268991972', 1, 0, '', 1, NULL, NULL),
(14577, '2016-12-10 11:19:53', NULL, NULL, 5086, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 11:19:53', 'admin-1481333796-1481339993463262', 1, 0, '', NULL, NULL, NULL),
(14578, '2016-12-10 11:32:10', NULL, NULL, 5086, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 11:32:10', 'admin-1481333796-14813407300446973', 1, 0, '', NULL, NULL, NULL),
(14579, '2016-12-10 11:35:42', NULL, NULL, 5087, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 11:35:42', 'admin-1481340735-14813409418939852', 1, 0, '', NULL, NULL, NULL),
(14580, '2016-12-10 11:35:42', NULL, NULL, 5087, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 11:35:42', 'admin-1481340735-14813409418939852', 1, 1, 'SR', NULL, NULL, NULL),
(14581, '2016-12-10 11:15:28', NULL, NULL, 5086, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 11:15:28', 'admin-1481333796-1481339728390684', 1, 1, 'SR', NULL, NULL, NULL),
(14582, '2016-12-10 11:15:28', NULL, NULL, 5086, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 11:15:28', 'admin-1481333796-1481339728390684', 1, 0, '', NULL, NULL, NULL),
(14583, '2016-12-10 11:15:28', NULL, NULL, 5086, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 11:15:28', 'admin-1481333796-1481339728390684', 1, 0, '', NULL, NULL, NULL),
(14584, '2016-12-10 11:15:28', NULL, NULL, 5086, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 11:15:28', 'admin-1481333796-1481339728390684', 1, 0, '', NULL, NULL, NULL),
(14585, '2016-12-10 11:07:02', NULL, NULL, 5085, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 11:07:02', 'admin-1481333796-14813392223622556', 1, 1, 'SR', NULL, NULL, NULL),
(14586, '2016-12-10 11:06:25', NULL, NULL, 5085, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 11:06:25', 'admin-1481333796-14813391856848996', 1, 0, '', NULL, NULL, NULL),
(14587, '2016-12-10 11:07:02', NULL, NULL, 5085, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 11:07:02', 'admin-1481333796-14813392223622556', 1, 0, '', NULL, NULL, NULL),
(14588, '2016-12-10 11:06:25', NULL, NULL, 5085, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 11:06:25', 'admin-1481333796-14813391856848996', 1, 0, '', NULL, NULL, NULL),
(14589, '2016-12-10 11:01:09', NULL, NULL, 5084, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 11:01:09', 'admin-1481333796-1481338868990381', 1, 0, '', NULL, NULL, NULL),
(14590, '2016-12-10 10:24:06', NULL, NULL, 5083, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 10:24:06', 'admin-1481333796-14813366465024958', 1, 1, 'SR', NULL, NULL, NULL),
(14591, '2016-12-10 10:22:58', NULL, NULL, 5083, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 10:22:58', 'admin-1481333796-1481336578391825', 1, 1, 'SR', NULL, NULL, NULL),
(14592, '2016-12-10 10:21:49', NULL, NULL, 5083, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 10:21:49', 'admin-1481333796-14813365093095645', 1, 0, '', NULL, NULL, NULL),
(14593, '2016-12-10 10:21:49', NULL, NULL, 5083, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 10:21:49', 'admin-1481333796-14813365093095645', 1, 0, '', NULL, NULL, NULL),
(14594, '2016-12-10 10:12:47', NULL, NULL, 5082, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 10:12:47', 'admin-1481333796-14813359668871892', 1, 1, 'SR', NULL, NULL, NULL),
(14595, '2016-12-10 10:12:47', NULL, NULL, 5082, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 10:12:47', 'admin-1481333796-14813359668871892', 1, 1, 'SR', NULL, NULL, NULL),
(14596, '2016-12-10 10:12:47', NULL, NULL, 5082, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 10:12:47', 'admin-1481333796-14813359668871892', 1, 0, '', NULL, NULL, NULL),
(14597, '2016-12-10 10:12:47', NULL, NULL, 5082, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 10:12:47', 'admin-1481333796-14813359668871892', 1, 0, '', NULL, NULL, NULL),
(14598, '2016-12-10 10:09:30', NULL, NULL, 5081, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 10:09:30', 'admin-1481333796-14813357706422489', 1, 1, 'SR', NULL, NULL, NULL),
(14599, '2016-12-10 09:56:00', NULL, NULL, 5080, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:56:00', 'admin-1481333796-14813349603667256', 1, 0, '', NULL, NULL, NULL),
(14600, '2016-12-10 09:51:39', NULL, NULL, 5078, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:51:39', 'admin-1481333796-14813346993533449', 1, 1, 'SR', NULL, NULL, NULL),
(14601, '2016-12-10 09:52:48', NULL, NULL, 5078, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:52:48', 'admin-1481333796-14813347685823650', 1, 0, '', NULL, NULL, NULL),
(14602, '2016-12-10 09:30:42', NULL, NULL, 5073, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:30:42', 'admin-1481330698-14813334423825728', 1, 0, '', NULL, NULL, NULL),
(14603, '2016-12-10 09:30:51', NULL, NULL, 5073, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:30:51', 'admin-1481330698-14813334513979650', 1, 1, 'SR', NULL, NULL, NULL),
(14604, '2016-12-10 09:30:51', NULL, NULL, 5073, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:30:51', 'admin-1481330698-14813334513979650', 1, 1, 'SR', NULL, NULL, NULL),
(14605, '2016-12-10 09:33:49', NULL, NULL, 5074, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:33:49', 'admin-1481330698-14813336289703522', 1, 0, '', NULL, NULL, NULL),
(14606, '2016-12-10 09:33:49', NULL, NULL, 5074, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:33:49', 'admin-1481330698-14813336289703522', 1, 0, '', NULL, NULL, NULL),
(14607, '2016-12-10 09:33:49', NULL, NULL, 5074, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:33:49', 'admin-1481330698-14813336289703522', 1, 0, '', NULL, NULL, NULL),
(14608, '2016-12-10 09:33:49', NULL, NULL, 5074, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:33:49', 'admin-1481330698-14813336289703522', 1, 0, '', NULL, NULL, NULL),
(14609, '2016-12-10 09:34:06', NULL, NULL, 5074, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:34:06', 'admin-1481330698-1481333646122584', 1, 1, 'SR', NULL, NULL, NULL),
(14610, '2016-12-10 09:34:06', NULL, NULL, 5074, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:34:06', 'admin-1481330698-1481333646122584', 1, 1, 'SR', NULL, NULL, NULL),
(14611, '2016-12-10 09:34:06', NULL, NULL, 5074, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:34:06', 'admin-1481330698-1481333646122584', 1, 0, '', NULL, NULL, NULL),
(14612, '2016-12-10 09:35:43', NULL, NULL, 5075, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:35:43', 'admin-1481330698-14813337436684519', 1, 0, '', NULL, NULL, NULL),
(14613, '2016-12-10 09:35:43', NULL, NULL, 5075, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:35:43', 'admin-1481330698-14813337436684519', 1, 0, '', NULL, NULL, NULL),
(14614, '2016-12-10 09:35:43', NULL, NULL, 5075, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:35:43', 'admin-1481330698-14813337436684519', 1, 0, '', NULL, NULL, NULL),
(14615, '2016-12-10 09:36:29', NULL, NULL, 5076, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:36:29', 'admin-1481330698-1481333789408649', 1, 0, '', NULL, NULL, NULL),
(14616, '2016-12-10 09:36:29', NULL, NULL, 5076, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:36:29', 'admin-1481330698-1481333789408649', 1, 1, 'SR', NULL, NULL, NULL),
(14617, '2016-12-10 09:38:09', NULL, NULL, 5077, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:38:09', 'admin-1481333796-14813338893596223', 1, 0, '', NULL, NULL, NULL),
(14618, '2016-12-10 09:38:30', NULL, NULL, 5077, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:38:30', 'admin-1481333796-14813339107296436', 1, 1, 'SR', NULL, NULL, NULL),
(14619, '2016-12-10 09:51:39', NULL, NULL, 5078, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:51:39', 'admin-1481333796-14813346993533449', 1, 0, '', NULL, NULL, NULL),
(14620, '2016-12-10 09:51:39', NULL, NULL, 5078, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:51:39', 'admin-1481333796-14813346993533449', 1, 1, 'SR', NULL, NULL, NULL),
(14621, '2016-12-10 09:51:39', NULL, NULL, 5078, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:51:39', 'admin-1481333796-14813346993533449', 1, 0, '', NULL, NULL, NULL),
(14622, '2016-12-10 09:51:39', NULL, NULL, 5078, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:51:39', 'admin-1481333796-14813346993533449', 1, 0, '', NULL, NULL, NULL),
(14623, '2016-12-10 09:49:07', NULL, NULL, 5079, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:49:07', 'admin-1481333796-14813345474432875', 1, 0, '', NULL, NULL, NULL),
(14624, '2016-12-10 09:49:07', NULL, NULL, 5079, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:49:07', 'admin-1481333796-14813345474432875', 1, 1, 'SR', NULL, NULL, NULL),
(14625, '2016-12-10 09:49:07', NULL, NULL, 5079, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:49:07', 'admin-1481333796-14813345474432875', 1, 0, '', NULL, NULL, NULL),
(14626, '2016-12-10 09:49:07', NULL, NULL, 5079, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:49:07', 'admin-1481333796-14813345474432875', 1, 0, '', NULL, NULL, NULL),
(14627, '2016-12-10 09:30:42', NULL, NULL, 5073, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:30:42', 'admin-1481330698-14813334423825728', 1, 0, '', NULL, NULL, NULL),
(14628, '2016-12-10 09:11:43', NULL, NULL, 5072, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:11:43', 'admin-1481330698-14813323030178493', 1, 1, 'SR', NULL, NULL, NULL),
(14629, '2016-12-10 09:11:43', NULL, NULL, 5072, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:11:43', 'admin-1481330698-14813323030178493', 1, 1, 'SR', NULL, NULL, NULL),
(14630, '2016-12-10 09:11:43', NULL, NULL, 5072, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:11:43', 'admin-1481330698-14813323030178493', 1, 1, 'SR', NULL, NULL, NULL),
(14631, '2016-12-10 09:05:21', NULL, NULL, 5071, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:05:21', 'admin-1481330698-14813319210931150', 1, 0, '', NULL, NULL, NULL),
(14632, '2016-12-10 09:06:15', NULL, NULL, 5071, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:06:15', 'admin-1481330698-14813319747719878', 1, 1, 'SR', NULL, NULL, NULL),
(14633, '2016-12-10 09:06:15', NULL, NULL, 5071, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:06:15', 'admin-1481330698-14813319747719878', 1, 1, 'SR', NULL, NULL, NULL),
(14634, '2016-12-10 09:06:15', NULL, NULL, 5071, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:06:15', 'admin-1481330698-14813319747719878', 1, 1, 'SR', NULL, NULL, NULL),
(14635, '2016-12-10 09:11:29', NULL, NULL, 5072, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:11:29', 'admin-1481330698-14813322897073149', 1, 0, '', NULL, NULL, NULL),
(14636, '2016-12-10 09:06:15', NULL, NULL, 5071, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:06:15', 'admin-1481330698-14813319747719878', 1, 0, '', NULL, NULL, NULL),
(14637, '2016-12-10 09:05:21', NULL, NULL, 5071, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:05:21', 'admin-1481330698-14813319210931150', 1, 0, '', NULL, NULL, NULL),
(14638, '2016-12-10 09:05:21', NULL, NULL, 5071, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481358514', 'admin', '2016-12-10 09:05:21', 'admin-1481330698-14813319210931150', 1, 0, '', NULL, NULL, NULL),
(14639, '2016-12-11 19:18:11', NULL, NULL, 5130, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 19:18:11', 'admin-1481442972-1481455091247918', 1, 1, 'SR', NULL, NULL, NULL),
(14640, '2016-12-11 19:26:39', NULL, NULL, 5130, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 19:26:39', 'admin-1481442972-14814555990962440', 1, 1, 'SR', NULL, NULL, NULL),
(14641, '2016-12-11 20:07:04', NULL, NULL, 5131, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 20:07:04', 'admin-1481442972-14814580242253333', 1, 1, 'SR', NULL, NULL, NULL),
(14642, '2016-12-11 20:09:19', NULL, NULL, 5131, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 20:09:19', 'admin-1481442972-1481458159551838', 1, 0, '', NULL, NULL, NULL),
(14643, '2016-12-11 20:10:59', NULL, NULL, 5132, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 20:10:59', 'admin-1481442972-1481458259584106', 1, 1, 'SR', NULL, NULL, NULL),
(14644, '2016-12-11 15:02:00', NULL, NULL, 5120, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 15:02:00', 'admin-1481433864-14814397207072178', 1, 0, '', NULL, NULL, NULL),
(14645, '2016-12-11 15:02:00', NULL, NULL, 5120, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 15:02:00', 'admin-1481433864-14814397207072178', 1, 1, 'SR', NULL, NULL, NULL),
(14646, '2016-12-11 15:02:00', NULL, NULL, 5120, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 15:02:00', 'admin-1481433864-14814397207072178', 1, 1, 'SR', NULL, NULL, NULL),
(14647, '2016-12-11 15:07:04', NULL, NULL, 5121, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 15:07:04', 'admin-1481433864-14814400240125695', 1, 1, 'SR', NULL, NULL, NULL),
(14648, '2016-12-11 15:07:04', NULL, NULL, 5121, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 15:07:04', 'admin-1481433864-14814400240125695', 1, 1, 'SR', NULL, NULL, NULL),
(14649, '2016-12-11 15:13:25', NULL, NULL, 5122, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 15:13:25', 'admin-1481433864-14814404053759331', 1, 1, 'SR', NULL, NULL, NULL),
(14650, '2016-12-11 15:15:02', NULL, NULL, 5123, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 15:15:02', 'admin-1481433864-14814405020574027', 1, 1, 'SR', NULL, NULL, NULL),
(14651, '2016-12-11 15:15:02', NULL, NULL, 5123, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 15:15:02', 'admin-1481433864-14814405020574027', 1, 1, 'SR', NULL, NULL, NULL),
(14652, '2016-12-11 15:35:06', NULL, NULL, 5124, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 15:35:06', 'admin-1481433864-14814417063311184', 1, 1, 'SR', NULL, NULL, NULL),
(14653, '2016-12-11 15:35:06', NULL, NULL, 5124, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 15:35:06', 'admin-1481433864-14814417063311184', 1, 0, '', NULL, NULL, NULL),
(14654, '2016-12-11 15:55:33', NULL, NULL, 5125, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 15:55:33', 'admin-1481433864-14814429329492017', 1, 0, '', NULL, NULL, NULL),
(14655, '2016-12-11 16:20:59', NULL, NULL, 5126, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 16:20:59', 'admin-1481442972-1481444459579776', 1, 1, 'SR', 1, NULL, NULL),
(14656, '2016-12-11 16:20:59', NULL, NULL, 5126, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 16:20:59', 'admin-1481442972-1481444459579776', 1, 1, 'SR', 1, NULL, NULL),
(14657, '2016-12-11 16:28:04', NULL, NULL, 5127, 0, 244, '178', 'Macadamia Scones', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 16:28:04', 'admin-1481442972-14814448842661513', 1, 0, '', NULL, NULL, NULL),
(14658, '2016-12-11 16:28:04', NULL, NULL, 5127, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 16:28:04', 'admin-1481442972-14814448842661513', 1, 0, '', NULL, NULL, NULL),
(14659, '2016-12-11 16:28:04', NULL, NULL, 5127, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 16:28:04', 'admin-1481442972-14814448842661513', 1, 1, 'SR', NULL, NULL, NULL),
(14660, '2016-12-11 16:28:04', NULL, NULL, 5127, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 16:28:04', 'admin-1481442972-14814448842661513', 1, 1, 'SR', NULL, NULL, NULL),
(14661, '2016-12-11 18:28:50', NULL, NULL, 5128, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 18:28:50', 'admin-1481442972-14814521298765988', 1, 1, 'SR', 1, NULL, NULL),
(14662, '2016-12-11 18:29:43', NULL, NULL, 5129, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 18:29:43', 'admin-1481442972-14814521833676548', 1, 1, 'SR', NULL, NULL, NULL),
(14663, '2016-12-11 19:04:06', NULL, NULL, 5130, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 19:04:06', 'admin-1481442972-14814542460834818', 1, 0, '', NULL, NULL, NULL),
(14664, '2016-12-11 19:04:06', NULL, NULL, 5130, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 19:04:06', 'admin-1481442972-14814542460834818', 1, 1, 'SR', NULL, NULL, NULL),
(14665, '2016-12-11 19:04:06', NULL, NULL, 5130, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 19:04:06', 'admin-1481442972-14814542460834818', 1, 1, 'SR', NULL, NULL, NULL),
(14666, '2016-12-11 19:04:06', NULL, NULL, 5130, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 19:04:06', 'admin-1481442972-14814542460834818', 1, 1, 'SR', NULL, NULL, NULL),
(14667, '2016-12-11 19:04:06', NULL, NULL, 5130, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 19:04:06', 'admin-1481442972-14814542460834818', 1, 1, 'SR', NULL, NULL, NULL),
(14668, '2016-12-11 14:34:12', NULL, NULL, 5119, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 14:34:12', 'admin-1481433864-14814380524735539', 1, 1, 'SR', NULL, NULL, NULL),
(14669, '2016-12-11 15:02:00', NULL, NULL, 5120, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 15:02:00', 'admin-1481433864-14814397207072178', 1, 0, '', NULL, NULL, NULL),
(14670, '2016-12-11 15:02:00', NULL, NULL, 5120, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 15:02:00', 'admin-1481433864-14814397207072178', 1, 1, 'SR', NULL, NULL, NULL),
(14671, '2016-12-11 20:10:59', NULL, NULL, 5132, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 20:10:59', 'admin-1481442972-1481458259584106', 1, 1, 'SR', NULL, NULL, NULL),
(14672, '2016-12-11 20:10:59', NULL, NULL, 5132, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 20:10:59', 'admin-1481442972-1481458259584106', 1, 1, 'SR', NULL, NULL, NULL),
(14673, '2016-12-11 20:36:49', NULL, NULL, 5131, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 20:36:49', 'admin-1481442972-1481459808975231', 1, 1, 'SR', NULL, NULL, NULL),
(14674, '2016-12-11 14:19:57', NULL, NULL, 5118, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 14:19:57', 'admin-1481433864-14814371970796773', 1, 1, 'SR', NULL, NULL, NULL),
(14675, '2016-12-11 14:19:57', NULL, NULL, 5118, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 14:19:57', 'admin-1481433864-14814371970796773', 1, 1, 'SR', NULL, NULL, NULL),
(14676, '2016-12-11 14:33:46', NULL, NULL, 5119, 0, 85, '85', 'Set Sauted Mushroom Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 14:33:46', 'admin-1481433864-14814380266172830', 1, 1, 'SR', NULL, NULL, NULL),
(14677, '2016-12-11 14:33:46', NULL, NULL, 5119, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 14:33:46', 'admin-1481433864-14814380266172830', 1, 1, 'SR', NULL, NULL, NULL),
(14678, '2016-12-11 14:19:57', NULL, NULL, 5118, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 14:19:57', 'admin-1481433864-14814371970796773', 1, 0, '', NULL, NULL, NULL),
(14679, '2016-12-11 14:19:57', NULL, NULL, 5118, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 14:19:57', 'admin-1481433864-14814371970796773', 1, 0, '', NULL, NULL, NULL),
(14680, '2016-12-11 14:19:57', NULL, NULL, 5118, 0, 83, '83', 'Set Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 14:19:57', 'admin-1481433864-14814371970796773', 1, 1, 'SR', NULL, NULL, NULL),
(14681, '2016-12-11 14:15:19', NULL, NULL, 5116, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 14:15:19', 'admin-1481433864-14814369188555055', 1, 1, 'SR', NULL, NULL, NULL),
(14682, '2016-12-11 13:47:11', NULL, NULL, 5117, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:47:11', 'admin-1481433864-14814352309849321', 1, 1, 'SR', NULL, NULL, NULL),
(14683, '2016-12-11 14:15:19', NULL, NULL, 5116, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 14:15:19', 'admin-1481433864-14814369188555055', 1, 1, 'SR', NULL, NULL, NULL),
(14684, '2016-12-11 13:47:11', NULL, NULL, 5117, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:47:11', 'admin-1481433864-14814352309849321', 1, 1, 'SR', NULL, NULL, NULL),
(14685, '2016-12-11 13:41:59', NULL, NULL, 5116, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:41:59', 'admin-1481433864-14814349192934142', 1, 0, '', NULL, NULL, NULL),
(14686, '2016-12-11 13:41:59', NULL, NULL, 5116, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:41:59', 'admin-1481433864-14814349192934142', 1, 1, 'SR', NULL, NULL, NULL),
(14687, '2016-12-11 13:41:27', NULL, NULL, 5111, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:41:27', 'admin-1481433864-14814348868102330', 1, 0, '', NULL, NULL, NULL),
(14688, '2016-12-11 13:41:11', NULL, NULL, 5111, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:41:11', 'admin-1481433864-14814348713503678', 1, 0, '', NULL, NULL, NULL),
(14689, '2016-12-11 13:41:11', NULL, NULL, 5111, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:41:11', 'admin-1481433864-14814348713503678', 1, 1, 'SR', NULL, NULL, NULL),
(14690, '2016-12-11 13:30:16', NULL, NULL, 5115, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:30:16', 'admin-1481433864-14814342165359680', 1, 1, 'SR', NULL, NULL, NULL),
(14691, '2016-12-11 13:30:16', NULL, NULL, 5115, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:30:16', 'admin-1481433864-14814342165359680', 1, 1, 'SR', NULL, NULL, NULL),
(14692, '2016-12-11 13:37:43', NULL, NULL, 5116, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:37:43', 'admin-1481433864-14814346636969687', 1, 0, '', NULL, NULL, NULL),
(14693, '2016-12-11 13:37:53', NULL, NULL, 5116, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:37:53', 'admin-1481433864-14814346733461739', 1, 1, 'SR', NULL, NULL, NULL),
(14694, '2016-12-11 13:24:15', NULL, NULL, 5111, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:24:15', 'admin-1481431060-14814338557234933', 1, 0, '', NULL, NULL, NULL),
(14695, '2016-12-11 13:26:07', NULL, NULL, 5111, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:26:07', 'admin-1481433864-14814339674141825', 1, 1, 'SR', NULL, NULL, NULL),
(14696, '2016-12-11 13:19:07', NULL, NULL, 5114, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:19:07', 'admin-1481431060-1481433547302233', 1, 1, 'SR', NULL, NULL, NULL),
(14697, '2016-12-11 13:19:07', NULL, NULL, 5114, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:19:07', 'admin-1481431060-1481433547302233', 1, 1, 'SR', NULL, NULL, NULL),
(14698, '2016-12-11 13:19:07', NULL, NULL, 5114, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:19:07', 'admin-1481431060-1481433547302233', 1, 1, 'SR', NULL, NULL, NULL),
(14699, '2016-12-11 11:05:48', NULL, NULL, 5105, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 11:05:48', 'admin-1481417882-1481425548623116', 1, 1, 'SR', NULL, NULL, NULL),
(14700, '2016-12-11 11:47:24', NULL, NULL, 5106, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 11:47:24', 'admin-1481417882-14814280438667354', 1, 1, 'SR', 1, NULL, NULL),
(14701, '2016-12-11 12:28:38', NULL, NULL, 5107, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 12:28:38', 'admin-1481417882-1481430517933396', 1, 0, '', NULL, NULL, NULL),
(14702, '2016-12-11 12:50:32', NULL, NULL, 5110, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 12:50:32', 'admin-1481431060-14814318319317062', 1, 1, 'SR', NULL, NULL, NULL),
(14703, '2016-12-11 12:30:57', NULL, NULL, 5108, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 12:30:57', 'admin-1481417882-14814306570613140', 1, 0, '', NULL, NULL, '10.0'),
(14704, '2016-12-11 12:30:57', NULL, NULL, 5108, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 12:30:57', 'admin-1481417882-14814306570613140', 1, 0, '', NULL, NULL, '10.0'),
(14705, '2016-12-11 12:30:57', NULL, NULL, 5108, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 12:30:57', 'admin-1481417882-14814306570613140', 1, 0, '', NULL, NULL, '10.0'),
(14706, '2016-12-11 12:31:49', NULL, NULL, 5108, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 12:31:49', 'admin-1481417882-14814307090054771', 1, 1, 'SR', NULL, NULL, '10.0'),
(14707, '2016-12-11 12:31:49', NULL, NULL, 5108, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 12:31:49', 'admin-1481417882-14814307090054771', 1, 0, '', NULL, NULL, '10.0'),
(14708, '2016-12-11 12:31:49', NULL, NULL, 5108, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 12:31:49', 'admin-1481417882-14814307090054771', 1, 1, 'SR', NULL, NULL, '10.0'),
(14709, '2016-12-11 12:34:23', NULL, NULL, 5108, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 12:34:23', 'admin-1481417882-14814308633736136', 1, 0, '', NULL, NULL, '10.0'),
(14710, '2016-12-11 12:38:03', NULL, NULL, 5109, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 12:38:03', 'admin-1481431060-14814310832898392', 1, 1, 'SR', NULL, NULL, NULL),
(14711, '2016-12-11 12:58:24', NULL, NULL, 5108, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 12:58:24', 'admin-1481431060-14814323040712782', 1, 1, 'SR', NULL, NULL, '10.0'),
(14712, '2016-12-11 13:33:15', NULL, NULL, 5108, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:33:15', 'admin-1481433864-14814343957273841', 1, 0, '', NULL, NULL, '10.0'),
(14713, '2016-12-11 13:14:57', NULL, NULL, 5111, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:14:57', 'admin-1481431060-14814332973347626', 1, 0, '', NULL, NULL, NULL),
(14714, '2016-12-11 13:14:57', NULL, NULL, 5111, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:14:57', 'admin-1481431060-14814332973347626', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(14715, '2016-12-11 13:14:57', NULL, NULL, 5111, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:14:57', 'admin-1481431060-14814332973347626', 1, 0, '', NULL, NULL, NULL),
(14716, '2016-12-11 13:14:57', NULL, NULL, 5111, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:14:57', 'admin-1481431060-14814332973347626', 1, 1, 'SR', NULL, NULL, NULL),
(14717, '2016-12-11 13:14:57', NULL, NULL, 5111, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:14:57', 'admin-1481431060-14814332973347626', 1, 0, '', NULL, NULL, NULL),
(14718, '2016-12-11 13:15:44', NULL, NULL, 5112, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:15:44', 'admin-1481431060-14814333441162859', 1, 1, 'SR', NULL, NULL, NULL),
(14719, '2016-12-11 13:15:44', NULL, NULL, 5112, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:15:44', 'admin-1481431060-14814333441162859', 1, 1, 'SR', NULL, NULL, NULL),
(14720, '2016-12-11 13:17:42', NULL, NULL, 5113, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:17:42', 'admin-1481431060-14814334618251221', 1, 0, '', NULL, NULL, NULL),
(14721, '2016-12-11 13:17:42', NULL, NULL, 5113, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:17:42', 'admin-1481431060-14814334618251221', 1, 1, 'SR', NULL, NULL, NULL),
(14722, '2016-12-11 13:17:42', NULL, NULL, 5113, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:17:42', 'admin-1481431060-14814334618251221', 1, 1, 'SR', NULL, NULL, NULL),
(14723, '2016-12-11 13:18:45', NULL, NULL, 5114, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:18:45', 'admin-1481431060-1481433524960496', 1, 1, 'SR', NULL, NULL, NULL),
(14724, '2016-12-11 13:18:45', NULL, NULL, 5114, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 13:18:45', 'admin-1481431060-1481433524960496', 1, 0, '', NULL, NULL, NULL),
(14725, '2016-12-11 11:05:48', NULL, NULL, 5105, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 11:05:48', 'admin-1481417882-1481425548623116', 1, 1, 'SR', NULL, NULL, NULL),
(14726, '2016-12-11 10:57:01', NULL, NULL, 5104, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 10:57:01', 'admin-1481417882-14814250207989491', 1, 0, '', NULL, NULL, NULL),
(14727, '2016-12-11 10:57:01', NULL, NULL, 5104, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 10:57:01', 'admin-1481417882-14814250207989491', 1, 0, '', NULL, NULL, NULL),
(14728, '2016-12-11 09:40:34', NULL, NULL, 5102, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 09:40:34', 'admin-1481417882-14814204341996081', 1, 1, 'SR', NULL, NULL, NULL),
(14729, '2016-12-11 09:40:34', NULL, NULL, 5102, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 09:40:34', 'admin-1481417882-14814204341996081', 1, 1, 'SR', NULL, NULL, NULL),
(14730, '2016-12-11 10:16:18', NULL, NULL, 5103, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 10:16:18', 'admin-1481417882-14814225784832546', 1, 0, '', NULL, NULL, NULL),
(14731, '2016-12-11 10:16:18', NULL, NULL, 5103, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 10:16:18', 'admin-1481417882-14814225784832546', 1, 1, 'SR', NULL, NULL, NULL),
(14732, '2016-12-11 10:57:01', NULL, NULL, 5104, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 10:57:01', 'admin-1481417882-14814250207989491', 1, 0, '', NULL, NULL, NULL),
(14733, '2016-12-11 09:39:23', NULL, NULL, 5102, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 09:39:23', 'admin-1481417882-14814203633956738', 1, 0, '', NULL, NULL, NULL),
(14734, '2016-12-11 09:40:34', NULL, NULL, 5102, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 09:40:34', 'admin-1481417882-14814204341996081', 1, 1, 'SR', NULL, NULL, NULL),
(14735, '2016-12-11 09:39:01', NULL, NULL, 5102, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 09:39:01', 'admin-1481417882-14814203408415871', 1, 0, '', NULL, NULL, NULL),
(14736, '2016-12-11 09:22:03', NULL, NULL, 5101, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481442972', 'admin', '2016-12-11 09:22:03', 'admin-1481417882-14814193232233161', 1, 1, 'SR', NULL, NULL, NULL),
(14737, '2016-12-12 20:03:43', NULL, NULL, 5179, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 20:03:43', 'admin-1481517910-14815442237998342', 1, 1, 'SR', NULL, NULL, NULL),
(14738, '2016-12-12 20:03:34', NULL, NULL, 5179, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 20:03:34', 'admin-1481517910-14815442141918473', 1, 0, '', NULL, NULL, NULL),
(14739, '2016-12-12 20:03:43', NULL, NULL, 5179, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 20:03:43', 'admin-1481517910-14815442237998342', 1, 1, 'SR', NULL, NULL, NULL),
(14740, '2016-12-12 20:03:34', NULL, NULL, 5179, 0, 181, '116', 'Open Food ', 'Fried Egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1481549280', 'admin', '2016-12-12 20:03:34', 'admin-1481517910-14815442141918473', 1, 0, '', NULL, NULL, NULL),
(14741, '2016-12-12 20:03:34', NULL, NULL, 5179, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 20:03:34', 'admin-1481517910-14815442141918473', 1, 0, '', NULL, NULL, NULL),
(14742, '2016-12-12 19:33:53', NULL, NULL, 5178, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 19:33:53', 'admin-1481517910-14815424336724365', 1, 1, 'SR', NULL, NULL, NULL),
(14743, '2016-12-12 17:39:31', NULL, NULL, 5177, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 17:39:31', 'admin-1481517910-14815355708475236', 1, 0, '', NULL, NULL, NULL),
(14744, '2016-12-12 17:20:25', NULL, NULL, 5174, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 17:20:25', 'admin-1481517910-14815344257148021', 1, 0, '', NULL, NULL, NULL),
(14745, '2016-12-12 16:50:11', NULL, NULL, 5174, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 16:50:11', 'admin-1481517910-1481532610885358', 1, 1, 'SR', NULL, NULL, NULL),
(14746, '2016-12-12 16:47:56', NULL, NULL, 5176, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 16:47:56', 'admin-1481517910-14815324764682381', 1, 1, 'SR', NULL, NULL, NULL),
(14747, '2016-12-12 16:47:28', NULL, NULL, 5176, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 16:47:28', 'admin-1481517910-14815324481452571', 1, 0, '', NULL, NULL, NULL),
(14748, '2016-12-12 16:47:28', NULL, NULL, 5176, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 16:47:28', 'admin-1481517910-14815324481452571', 1, 0, '', NULL, NULL, NULL),
(14749, '2016-12-12 16:47:56', NULL, NULL, 5176, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 16:47:56', 'admin-1481517910-14815324764682381', 1, 0, '', NULL, NULL, NULL),
(14750, '2016-12-12 16:47:28', NULL, NULL, 5176, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 16:47:28', 'admin-1481517910-14815324481452571', 1, 1, 'SR', NULL, NULL, NULL),
(14751, '2016-12-12 13:09:50', NULL, NULL, 5165, 0, 158, '92', 'Nutella Toast ', 'No Strawberry', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 13:09:50', 'admin-1481517910-14815193902045618', 1, 0, '', NULL, NULL, NULL),
(14752, '2016-12-12 13:26:22', NULL, NULL, 5166, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 13:26:22', 'admin-1481517910-14815203823598479', 1, 1, 'SR', NULL, NULL, NULL),
(14753, '2016-12-12 13:26:22', NULL, NULL, 5166, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 13:26:22', 'admin-1481517910-14815203823598479', 1, 1, 'SR', NULL, NULL, NULL),
(14754, '2016-12-12 13:26:22', NULL, NULL, 5166, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 13:26:22', 'admin-1481517910-14815203823598479', 1, 1, 'SR', NULL, NULL, NULL),
(14755, '2016-12-12 13:27:42', NULL, NULL, 5167, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 13:27:42', 'admin-1481517910-14815204621758739', 1, 0, '', NULL, NULL, NULL),
(14756, '2016-12-12 13:27:42', NULL, NULL, 5167, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 13:27:42', 'admin-1481517910-14815204621758739', 1, 0, '', NULL, NULL, NULL),
(14757, '2016-12-12 13:27:42', NULL, NULL, 5167, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 13:27:42', 'admin-1481517910-14815204621758739', 1, 1, 'SR', NULL, NULL, NULL),
(14758, '2016-12-12 13:27:42', NULL, NULL, 5167, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 13:27:42', 'admin-1481517910-14815204621758739', 1, 1, 'SR', NULL, NULL, NULL),
(14759, '2016-12-12 13:46:11', NULL, NULL, 5168, 0, 85, '85', 'Set Sauted Mushroom Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 13:46:11', 'admin-1481517910-14815215717474241', 1, 1, 'SR', NULL, NULL, NULL),
(14760, '2016-12-12 19:34:52', NULL, NULL, 5178, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 19:34:52', 'admin-1481517910-14815424917453770', 1, 1, 'SR', NULL, NULL, NULL),
(14761, '2016-12-12 16:37:32', NULL, NULL, 5174, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 16:37:32', 'admin-1481517910-14815318520084225', 1, 1, 'SR', NULL, NULL, NULL),
(14762, '2016-12-12 16:37:32', NULL, NULL, 5174, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 16:37:32', 'admin-1481517910-14815318520084225', 1, 1, 'SR', NULL, NULL, NULL),
(14763, '2016-12-12 16:09:34', NULL, NULL, 5172, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 16:09:34', 'admin-1481517910-14815301743536012', 1, 0, '', NULL, NULL, NULL),
(14764, '2016-12-12 16:24:44', NULL, NULL, 5173, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 16:24:44', 'admin-1481517910-14815310842074763', 1, 1, 'SR', NULL, NULL, NULL),
(14765, '2016-12-12 15:41:07', NULL, NULL, 5172, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 15:41:07', 'admin-1481517910-14815284674952724', 1, 1, 'SR', NULL, NULL, NULL),
(14766, '2016-12-12 15:23:15', NULL, NULL, 5171, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 15:23:15', 'admin-1481517910-14815273953195454', 1, 1, 'SR', NULL, NULL, NULL),
(14767, '2016-12-12 15:02:15', NULL, NULL, 5170, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 15:02:15', 'admin-1481517910-14815261350166354', 1, 1, 'SR', NULL, NULL, NULL),
(14768, '2016-12-12 15:02:15', NULL, NULL, 5170, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 15:02:15', 'admin-1481517910-14815261350166354', 1, 1, 'SR', NULL, NULL, NULL),
(14769, '2016-12-12 15:00:28', NULL, NULL, 5147, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 15:00:28', 'admin-1481517910-14815260282251851', 1, 1, 'SR', NULL, NULL, NULL),
(14770, '2016-12-12 14:40:46', NULL, NULL, 5169, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 14:40:46', 'admin-1481517910-14815248468292463', 1, 0, '', NULL, NULL, NULL),
(14771, '2016-12-12 14:21:52', NULL, NULL, 5169, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 14:21:52', 'admin-1481517910-14815237121902374', 1, 1, 'SR', NULL, NULL, NULL),
(14772, '2016-12-12 14:21:43', NULL, NULL, 5169, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 14:21:43', 'admin-1481517910-14815237037995344', 1, 0, '', NULL, NULL, NULL),
(14773, '2016-12-12 13:54:01', NULL, NULL, 5158, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 13:54:01', 'admin-1481517910-14815220411358292', 1, 1, 'SR', NULL, NULL, NULL),
(14774, '2016-12-12 13:49:53', NULL, NULL, 5168, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 13:49:53', 'admin-1481517910-1481521793290298', 1, 0, '', NULL, NULL, NULL),
(14775, '2016-12-12 13:07:17', NULL, NULL, 5165, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 13:07:17', 'admin-1481517910-14815192377621079', 1, 1, 'SR', NULL, NULL, NULL),
(14776, '2016-12-12 12:57:26', NULL, NULL, 5164, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:57:26', 'admin-1481517910-14815186467272693', 1, 1, 'SR', NULL, NULL, NULL),
(14777, '2016-12-12 12:37:51', NULL, NULL, 5158, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:37:51', 'admin-1481511523-14815174710734323', 1, 0, '', NULL, NULL, NULL),
(14778, '2016-12-12 12:27:16', NULL, NULL, 5142, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:27:16', 'admin-1481511523-14815168363002681', 1, 0, '', NULL, NULL, NULL),
(14779, '2016-12-12 12:27:16', NULL, NULL, 5142, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:27:16', 'admin-1481511523-14815168363002681', 1, 1, 'SR', NULL, NULL, NULL),
(14780, '2016-12-12 12:27:16', NULL, NULL, 5142, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:27:16', 'admin-1481511523-14815168363002681', 1, 1, 'SR', NULL, NULL, NULL),
(14781, '2016-12-12 12:27:02', NULL, NULL, 5147, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:27:02', 'admin-1481511523-1481516822014535', 1, 1, 'SR', NULL, NULL, NULL),
(14782, '2016-12-12 12:26:44', NULL, NULL, 5157, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:26:44', 'admin-1481511523-1481516804776264', 1, 1, 'SR', NULL, NULL, NULL),
(14783, '2016-12-12 12:26:44', NULL, NULL, 5157, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:26:44', 'admin-1481511523-1481516804776264', 1, 1, 'SR', NULL, NULL, NULL),
(14784, '2016-12-12 15:41:07', NULL, NULL, 5172, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 15:41:07', 'admin-1481517910-14815284674952724', 1, 1, 'SR', NULL, NULL, NULL),
(14785, '2016-12-12 15:41:07', NULL, NULL, 5172, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 15:41:07', 'admin-1481517910-14815284674952724', 1, 0, '', NULL, NULL, NULL),
(14786, '2016-12-12 12:37:51', NULL, NULL, 5158, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:37:51', 'admin-1481511523-14815174710734323', 1, 0, '', NULL, NULL, NULL),
(14787, '2016-12-12 00:00:00', NULL, NULL, 5159, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:33:47', 'admin-1481511523-14815136268951771', 1, 0, '', NULL, NULL, NULL),
(14788, '2016-12-12 12:54:22', NULL, NULL, 5164, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:54:22', 'admin-1481517910-14815184622218214', 1, 0, '', NULL, NULL, NULL),
(14789, '2016-12-12 12:54:22', NULL, NULL, 5164, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:54:22', 'admin-1481517910-14815184622218214', 1, 1, 'SR', NULL, NULL, NULL),
(14790, '2016-12-12 15:41:07', NULL, NULL, 5172, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 15:41:07', 'admin-1481517910-14815284674952724', 1, 1, 'SR', NULL, NULL, NULL),
(14791, '2016-12-12 12:26:44', NULL, NULL, 5157, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:26:44', 'admin-1481511523-1481516804776264', 1, 0, '', NULL, NULL, NULL),
(14792, '2016-12-12 12:19:33', NULL, NULL, 5156, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:19:33', 'admin-1481511523-14815163730404798', 1, 1, 'SR', NULL, NULL, NULL),
(14793, '2016-12-12 12:37:51', NULL, NULL, 5158, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:37:51', 'admin-1481511523-14815174710734323', 1, 1, 'SR', NULL, NULL, NULL),
(14794, '2016-12-12 11:48:38', NULL, NULL, 5152, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:48:38', 'admin-1481511523-14815145178112635', 1, 0, '', NULL, NULL, NULL),
(14795, '2016-12-12 11:48:38', NULL, NULL, 5152, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:48:38', 'admin-1481511523-14815145178112635', 1, 0, '', NULL, NULL, NULL),
(14796, '2016-12-12 11:46:53', NULL, NULL, 5151, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:46:53', 'admin-1481511523-14815144132364644', 1, 1, 'SR', 1, NULL, NULL),
(14797, '2016-12-12 11:48:38', NULL, NULL, 5152, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:48:38', 'admin-1481511523-14815145178112635', 1, 0, '', NULL, NULL, NULL),
(14798, '2016-12-12 11:48:38', NULL, NULL, 5152, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:48:38', 'admin-1481511523-14815145178112635', 1, 1, 'SR', NULL, NULL, NULL),
(14799, '2016-12-12 11:45:44', NULL, NULL, 5150, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:45:44', 'admin-1481511523-14815143437497077', 1, 0, '', NULL, NULL, NULL),
(14800, '2016-12-12 11:45:44', NULL, NULL, 5150, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:45:44', 'admin-1481511523-14815143437497077', 1, 1, 'SR', NULL, NULL, NULL),
(14801, '2016-12-12 11:45:44', NULL, NULL, 5150, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:45:44', 'admin-1481511523-14815143437497077', 1, 0, '', NULL, NULL, NULL),
(14802, '2016-12-12 11:45:44', NULL, NULL, 5150, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:45:44', 'admin-1481511523-14815143437497077', 1, 0, '', NULL, NULL, NULL),
(14803, '2016-12-12 11:45:44', NULL, NULL, 5150, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:45:44', 'admin-1481511523-14815143437497077', 1, 0, '', NULL, NULL, NULL),
(14804, '2016-12-12 11:46:02', NULL, NULL, 5150, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:46:02', 'admin-1481511523-1481514362436445', 1, 1, 'SR', NULL, NULL, NULL),
(14805, '2016-12-12 11:46:02', NULL, NULL, 5150, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:46:02', 'admin-1481511523-1481514362436445', 1, 0, '', NULL, NULL, NULL),
(14806, '2016-12-12 11:46:02', NULL, NULL, 5150, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:46:02', 'admin-1481511523-1481514362436445', 1, 0, '', NULL, NULL, NULL),
(14807, '2016-12-12 11:46:53', NULL, NULL, 5151, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:46:53', 'admin-1481511523-14815144132364644', 1, 0, '', 1, NULL, NULL),
(14808, '2016-12-12 11:24:18', NULL, NULL, 5145, 0, 153, '87', 'Big Breakfast ', 'no beans', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:24:18', 'admin-1481511523-14815130585776522', 1, 0, '', NULL, NULL, NULL),
(14809, '2016-12-12 11:24:18', NULL, NULL, 5145, 0, 153, '87', 'Big Breakfast ', 'no beans', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:24:18', 'admin-1481511523-14815130585776522', 1, 0, '', NULL, NULL, NULL),
(14810, '2016-12-12 11:24:18', NULL, NULL, 5145, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:24:18', 'admin-1481511523-14815130585776522', 1, 1, 'SR', NULL, NULL, NULL),
(14811, '2016-12-12 11:41:00', NULL, NULL, 5145, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:41:00', 'admin-1481511523-14815140605605776', 1, 0, '', NULL, NULL, NULL),
(14812, '2016-12-12 11:45:43', NULL, NULL, 5150, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:45:44', 'admin-1481511523-14815143437497077', 1, 0, '', NULL, NULL, NULL),
(14813, '2016-12-12 11:24:18', NULL, NULL, 5145, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:24:18', 'admin-1481511523-14815130585776522', 1, 0, '', NULL, NULL, NULL),
(14814, '2016-12-12 11:24:33', NULL, NULL, 5145, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:24:33', 'admin-1481511523-14815130736424959', 1, 1, 'SR', NULL, NULL, NULL),
(14815, '2016-12-12 11:24:33', NULL, NULL, 5145, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:24:33', 'admin-1481511523-14815130736424959', 1, 1, 'SR', NULL, NULL, NULL),
(14816, '2016-12-12 11:24:33', NULL, NULL, 5145, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:24:33', 'admin-1481511523-14815130736424959', 1, 1, 'SR', NULL, NULL, NULL),
(14817, '2016-12-12 11:24:33', NULL, NULL, 5145, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:24:33', 'admin-1481511523-14815130736424959', 1, 1, 'SR', NULL, NULL, NULL),
(14818, '2016-12-12 11:26:25', NULL, NULL, 5146, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:26:25', 'admin-1481511523-14815131849456335', 1, 0, '', NULL, NULL, NULL),
(14819, '2016-12-12 11:26:25', NULL, NULL, 5146, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:26:25', 'admin-1481511523-14815131849456335', 1, 0, '', NULL, NULL, NULL),
(14820, '2016-12-12 11:26:25', NULL, NULL, 5146, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:26:25', 'admin-1481511523-14815131849456335', 1, 1, 'SR', NULL, NULL, NULL),
(14821, '2016-12-12 11:26:25', NULL, NULL, 5146, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:26:25', 'admin-1481511523-14815131849456335', 1, 1, 'SR', NULL, NULL, NULL),
(14822, '2016-12-12 11:32:51', NULL, NULL, 5147, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:32:51', 'admin-1481511523-14815135711016624', 1, 1, 'SR', NULL, NULL, NULL),
(14823, '2016-12-12 11:32:51', NULL, NULL, 5147, 0, 156, '90', 'Cheese Omelet', 'salad no dressing', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:32:51', 'admin-1481511523-14815135711016624', 1, 0, '', NULL, NULL, NULL),
(14824, '2016-12-12 00:00:00', NULL, NULL, 5163, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:33:47', 'admin-1481511523-14815136268951771', 1, 1, 'SR', NULL, NULL, NULL),
(14825, '2016-12-12 00:00:00', NULL, NULL, 5161, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:33:47', 'admin-1481511523-14815136268951771', 1, 0, '', NULL, NULL, NULL),
(14826, '2016-12-12 12:37:51', NULL, NULL, 5158, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:37:51', 'admin-1481511523-14815174710734323', 1, 0, '', NULL, NULL, NULL),
(14827, '2016-12-12 12:19:33', NULL, NULL, 5156, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:19:33', 'admin-1481511523-14815163730404798', 1, 0, '', NULL, NULL, NULL),
(14828, '2016-12-12 12:19:33', NULL, NULL, 5156, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:19:33', 'admin-1481511523-14815163730404798', 1, 0, '', NULL, NULL, NULL),
(14829, '2016-12-12 12:19:33', NULL, NULL, 5156, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:19:33', 'admin-1481511523-14815163730404798', 1, 1, 'SR', NULL, NULL, NULL),
(14830, '2016-12-12 11:53:54', NULL, NULL, 5153, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:53:54', 'admin-1481511523-14815148339779918', 1, 1, 'SR', NULL, NULL, NULL),
(14831, '2016-12-12 11:54:08', NULL, NULL, 5154, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:54:08', 'admin-1481511523-14815148485261498', 1, 1, 'SR', NULL, NULL, NULL),
(14832, '2016-12-12 12:08:43', NULL, NULL, 5155, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:08:43', 'admin-1481511523-14815157235733665', 1, 1, 'SR', NULL, NULL, NULL),
(14833, '2016-12-12 12:08:43', NULL, NULL, 5155, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:08:43', 'admin-1481511523-14815157235733665', 1, 1, 'SR', NULL, NULL, NULL),
(14834, '2016-12-12 12:08:43', NULL, NULL, 5155, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:08:43', 'admin-1481511523-14815157235733665', 1, 0, '', NULL, NULL, NULL),
(14835, '2016-12-12 12:08:43', NULL, NULL, 5155, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:08:43', 'admin-1481511523-14815157235733665', 1, 0, '', NULL, NULL, NULL),
(14836, '2016-12-12 11:40:02', NULL, NULL, 5149, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:40:02', 'admin-1481511523-14815140025695786', 1, 1, 'SR', NULL, NULL, NULL),
(14837, '2016-12-12 12:54:22', NULL, NULL, 5164, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 12:54:22', 'admin-1481517910-14815184622218214', 1, 0, '', NULL, NULL, NULL),
(14838, '2016-12-12 00:00:00', NULL, NULL, 5160, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:33:47', 'admin-1481511523-14815136268951771', 1, 0, '', NULL, NULL, NULL),
(14839, '2016-12-12 00:00:00', NULL, NULL, 5162, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:33:47', 'admin-1481511523-14815136268951771', 1, 0, '', NULL, NULL, NULL),
(14840, '2016-12-12 00:00:00', NULL, NULL, 5163, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:33:47', 'admin-1481511523-14815136268951771', 1, 0, '', NULL, NULL, NULL),
(14841, '2016-12-12 00:00:00', NULL, NULL, 5160, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:33:47', 'admin-1481511523-14815136268951771', 1, 1, 'SR', NULL, NULL, NULL),
(14842, '2016-12-12 00:00:00', NULL, NULL, 5162, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:33:47', 'admin-1481511523-14815136268951771', 1, 0, '', NULL, NULL, NULL),
(14843, '2016-12-12 11:40:02', NULL, NULL, 5149, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:40:02', 'admin-1481511523-14815140025695786', 1, 1, 'SR', NULL, NULL, NULL),
(14844, '2016-12-12 13:07:17', NULL, NULL, 5165, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 13:07:17', 'admin-1481517910-14815192377621079', 1, 1, 'SR', NULL, NULL, NULL),
(14845, '2016-12-12 15:41:07', NULL, NULL, 5172, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 15:41:07', 'admin-1481517910-14815284674952724', 1, 0, '', NULL, NULL, NULL),
(14846, '2016-12-12 11:53:54', NULL, NULL, 5153, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:53:54', 'admin-1481511523-14815148339779918', 1, 1, 'SR', NULL, NULL, NULL),
(14847, '2016-12-12 00:00:00', NULL, NULL, 5161, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:33:47', 'admin-1481511523-14815136268951771', 1, 1, 'SR', NULL, NULL, NULL),
(14848, '2016-12-12 00:00:00', NULL, NULL, 5159, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:33:47', 'admin-1481511523-14815136268951771', 1, 1, 'SR', NULL, NULL, NULL),
(14849, '2016-12-12 10:58:29', NULL, NULL, 5135, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:58:29', 'admin-1481508872-14815115096485618', 1, 0, '', NULL, NULL, NULL),
(14850, '2016-12-12 10:58:29', NULL, NULL, 5135, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:58:29', 'admin-1481508872-14815115096485618', 1, 0, '', NULL, NULL, NULL),
(14851, '2016-12-12 10:58:29', NULL, NULL, 5135, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:58:29', 'admin-1481508872-14815115096485618', 1, 1, 'SR', NULL, NULL, NULL),
(14852, '2016-12-12 11:14:54', NULL, NULL, 5144, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:14:54', 'admin-1481511523-14815124945371716', 1, 0, '', NULL, NULL, NULL),
(14853, '2016-12-12 11:14:54', NULL, NULL, 5144, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:14:54', 'admin-1481511523-14815124945371716', 1, 1, 'SR', NULL, NULL, NULL),
(14854, '2016-12-12 11:14:54', NULL, NULL, 5144, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:14:54', 'admin-1481511523-14815124945371716', 1, 1, 'SR', NULL, NULL, NULL),
(14855, '2016-12-12 11:14:54', NULL, NULL, 5144, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:14:54', 'admin-1481511523-14815124945371716', 1, 0, '', NULL, NULL, NULL),
(14856, '2016-12-12 11:14:54', NULL, NULL, 5144, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:14:54', 'admin-1481511523-14815124945371716', 1, 0, '', NULL, NULL, NULL),
(14857, '2016-12-12 11:24:18', NULL, NULL, 5145, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 11:24:18', 'admin-1481511523-14815130585776522', 1, 0, '', NULL, NULL, NULL),
(14858, '2016-12-12 10:57:50', NULL, NULL, 5143, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:57:50', 'admin-1481508872-1481511470479194', 1, 1, 'SR', NULL, NULL, NULL),
(14859, '2016-12-12 10:57:50', NULL, NULL, 5143, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:57:50', 'admin-1481508872-1481511470479194', 1, 1, 'SR', NULL, NULL, NULL),
(14860, '2016-12-12 10:57:50', NULL, NULL, 5143, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:57:50', 'admin-1481508872-1481511470479194', 1, 1, 'SR', NULL, NULL, NULL),
(14861, '2016-12-12 10:57:50', NULL, NULL, 5143, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:57:50', 'admin-1481508872-1481511470479194', 1, 0, '', NULL, NULL, NULL),
(14862, '2016-12-12 10:57:50', NULL, NULL, 5143, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:57:50', 'admin-1481508872-1481511470479194', 1, 0, '', NULL, NULL, NULL),
(14863, '2016-12-12 10:57:50', NULL, NULL, 5143, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:57:50', 'admin-1481508872-1481511470479194', 1, 0, '', NULL, NULL, NULL),
(14864, '2016-12-12 10:44:07', NULL, NULL, 5142, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:44:07', 'admin-1481508872-14815106470288465', 1, 0, '', NULL, NULL, NULL),
(14865, '2016-12-12 10:44:07', NULL, NULL, 5142, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:44:07', 'admin-1481508872-14815106470288465', 1, 0, '', NULL, NULL, NULL),
(14866, '2016-12-12 10:44:16', NULL, NULL, 5142, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:44:16', 'admin-1481508872-14815106558336631', 1, 1, 'SR', NULL, NULL, NULL),
(14867, '2016-12-12 10:44:16', NULL, NULL, 5142, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:44:16', 'admin-1481508872-14815106558336631', 1, 0, '', NULL, NULL, NULL),
(14868, '2016-12-12 10:34:41', NULL, NULL, 5140, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:34:41', 'admin-1481508872-14815100814487918', 1, 0, '', NULL, NULL, NULL),
(14869, '2016-12-12 10:35:29', NULL, NULL, 5141, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:35:29', 'admin-1481508872-14815101292227015', 1, 1, 'SR', NULL, NULL, NULL),
(14870, '2016-12-12 10:34:41', NULL, NULL, 5140, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:34:41', 'admin-1481508872-14815100814487918', 1, 0, '', NULL, NULL, NULL),
(14871, '2016-12-12 10:34:41', NULL, NULL, 5140, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:34:41', 'admin-1481508872-14815100814487918', 1, 0, '', NULL, NULL, NULL),
(14872, '2016-12-12 10:29:53', NULL, NULL, 5139, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:29:53', 'admin-1481508872-14815097932922791', 1, 1, 'SR', NULL, NULL, NULL),
(14873, '2016-12-12 10:29:53', NULL, NULL, 5139, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:29:53', 'admin-1481508872-14815097932922791', 1, 0, '', NULL, NULL, NULL),
(14874, '2016-12-12 09:21:21', NULL, NULL, 5135, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:21:21', 'admin-1481504268-14815056808732133', 1, 0, '', NULL, NULL, NULL),
(14875, '2016-12-12 09:21:21', NULL, NULL, 5135, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:21:21', 'admin-1481504268-14815056808732133', 1, 0, '', NULL, NULL, NULL),
(14876, '2016-12-12 09:22:09', NULL, NULL, 5135, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:22:09', 'admin-1481504268-14815057290136185', 1, 1, 'SR', NULL, NULL, NULL),
(14877, '2016-12-12 09:22:09', NULL, NULL, 5135, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:22:09', 'admin-1481504268-14815057290136185', 1, 1, 'SR', NULL, NULL, NULL),
(14878, '2016-12-12 09:22:09', NULL, NULL, 5135, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:22:09', 'admin-1481504268-14815057290136185', 1, 1, 'SR', NULL, NULL, NULL),
(14879, '2016-12-12 09:23:13', NULL, NULL, 5135, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:23:13', 'admin-1481504268-14815057929985633', 1, 1, 'SR', NULL, NULL, NULL),
(14880, '2016-12-12 09:23:13', NULL, NULL, 5135, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:23:13', 'admin-1481504268-14815057929985633', 1, 1, 'SR', NULL, NULL, NULL),
(14881, '2016-12-12 09:23:13', NULL, NULL, 5135, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:23:13', 'admin-1481504268-14815057929985633', 1, 1, 'SR', NULL, NULL, NULL),
(14882, '2016-12-12 09:38:30', NULL, NULL, 5136, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:38:30', 'admin-1481504268-14815067106609245', 1, 0, '', NULL, NULL, NULL),
(14883, '2016-12-12 09:38:30', NULL, NULL, 5136, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:38:30', 'admin-1481504268-14815067106609245', 1, 0, '', NULL, NULL, NULL),
(14884, '2016-12-12 09:38:38', NULL, NULL, 5136, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:38:38', 'admin-1481504268-14815067182993636', 1, 1, 'SR', NULL, NULL, NULL),
(14885, '2016-12-12 09:38:38', NULL, NULL, 5136, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:38:38', 'admin-1481504268-14815067182993636', 1, 1, 'SR', NULL, NULL, NULL),
(14886, '2016-12-12 10:05:09', NULL, NULL, 5137, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:05:09', 'admin-1481504268-14815083089437314', 1, 0, '', NULL, NULL, NULL),
(14887, '2016-12-12 10:05:09', NULL, NULL, 5137, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:05:09', 'admin-1481504268-14815083089437314', 1, 0, '', NULL, NULL, NULL),
(14888, '2016-12-12 10:05:09', NULL, NULL, 5137, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:05:09', 'admin-1481504268-14815083089437314', 1, 1, 'SR', NULL, NULL, NULL),
(14889, '2016-12-12 10:14:25', NULL, NULL, 5137, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:14:25', 'admin-1481504268-1481508865587322', 1, 0, '', NULL, NULL, NULL),
(14890, '2016-12-12 10:14:48', NULL, NULL, 5137, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:14:48', 'admin-1481508872-14815088884313687', 1, 1, 'SR', NULL, NULL, NULL),
(14891, '2016-12-12 10:24:54', NULL, NULL, 5138, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:24:54', 'admin-1481508872-14815094943209825', 1, 0, '', NULL, NULL, NULL),
(14892, '2016-12-12 10:24:54', NULL, NULL, 5138, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:24:54', 'admin-1481508872-14815094943209825', 1, 0, '', NULL, NULL, NULL),
(14893, '2016-12-12 10:24:54', NULL, NULL, 5138, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:24:54', 'admin-1481508872-14815094943209825', 1, 0, '', NULL, NULL, NULL),
(14894, '2016-12-12 10:24:54', NULL, NULL, 5138, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:24:54', 'admin-1481508872-14815094943209825', 1, 0, '', NULL, NULL, NULL),
(14895, '2016-12-12 10:24:54', NULL, NULL, 5138, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:24:54', 'admin-1481508872-14815094943209825', 1, 0, '', NULL, NULL, NULL),
(14896, '2016-12-12 10:24:54', NULL, NULL, 5138, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:24:54', 'admin-1481508872-14815094943209825', 1, 0, '', NULL, NULL, NULL),
(14897, '2016-12-12 10:29:35', NULL, NULL, 5138, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:29:35', 'admin-1481508872-1481509775698365', 1, 1, 'SR', NULL, NULL, NULL),
(14898, '2016-12-12 10:29:53', NULL, NULL, 5139, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:29:53', 'admin-1481508872-14815097932922791', 1, 0, '', NULL, NULL, NULL),
(14899, '2016-12-12 10:29:53', NULL, NULL, 5139, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 10:29:53', 'admin-1481508872-14815097932922791', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(14900, '2016-12-12 09:21:21', NULL, NULL, 5135, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:21:21', 'admin-1481504268-14815056808732133', 1, 0, '', NULL, NULL, NULL),
(14901, '2016-12-12 09:21:21', NULL, NULL, 5135, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:21:21', 'admin-1481504268-14815056808732133', 1, 0, '', NULL, NULL, NULL),
(14902, '2016-12-12 09:17:01', NULL, NULL, 5134, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:17:01', 'admin-1481504268-1481505420929679', 1, 1, 'SR', NULL, NULL, NULL),
(14903, '2016-12-12 09:10:58', NULL, NULL, 5133, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:10:58', 'admin-1481504268-14815050583322743', 1, 1, 'SR', NULL, NULL, '10.0'),
(14904, '2016-12-12 09:10:58', NULL, NULL, 5133, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:10:58', 'admin-1481504268-14815050583322743', 1, 0, '', NULL, NULL, '10.0'),
(14905, '2016-12-12 09:17:01', NULL, NULL, 5134, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:17:01', 'admin-1481504268-1481505420929679', 1, 0, '', NULL, NULL, NULL),
(14906, '2016-12-12 09:17:01', NULL, NULL, 5134, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:17:01', 'admin-1481504268-1481505420929679', 1, 0, '', NULL, NULL, NULL),
(14907, '2016-12-12 09:17:01', NULL, NULL, 5134, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:17:01', 'admin-1481504268-1481505420929679', 1, 0, '', NULL, NULL, NULL),
(14908, '2016-12-12 09:17:01', NULL, NULL, 5134, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:17:01', 'admin-1481504268-1481505420929679', 1, 0, '', NULL, NULL, NULL),
(14909, '2016-12-12 09:17:01', NULL, NULL, 5134, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:17:01', 'admin-1481504268-1481505420929679', 1, 1, 'SR', NULL, NULL, NULL),
(14910, '2016-12-12 09:10:45', NULL, NULL, 5133, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:10:45', 'admin-1481504268-14815050454461325', 1, 0, '', NULL, NULL, '10.0'),
(14911, '2016-12-12 09:10:45', NULL, NULL, 5133, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481549280', 'admin', '2016-12-12 09:10:45', 'admin-1481504268-14815050454461325', 1, 0, '', NULL, NULL, '10.0'),
(14912, '2016-12-14 20:42:34', NULL, NULL, 5197, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 20:42:34', 'admin-1481675417-14817193547404136', 1, 1, 'SR', NULL, NULL, NULL),
(14913, '2016-12-14 20:43:27', NULL, NULL, 5197, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 20:43:27', 'admin-1481675417-14817194077411125', 1, 1, 'SR', NULL, NULL, NULL),
(14914, '2016-12-14 20:43:27', NULL, NULL, 5197, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 20:43:27', 'admin-1481675417-14817194077411125', 1, 0, '', NULL, NULL, NULL),
(14915, '2016-12-14 20:52:47', NULL, NULL, 5198, 0, 181, '116', 'Open Food ', 'lemon', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 20:52:47', 'admin-1481675417-14817199673699868', 1, 0, '', NULL, NULL, NULL),
(14916, '2016-12-14 17:51:55', NULL, NULL, 5195, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 17:51:55', 'admin-1481675417-14817091149073612', 1, 0, '', 1, NULL, NULL),
(14917, '2016-12-14 19:39:49', NULL, NULL, 5196, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 19:39:49', 'admin-1481675417-14817155892187229', 1, 1, 'SR', NULL, NULL, NULL),
(14918, '2016-12-14 20:42:16', NULL, NULL, 5197, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 20:42:16', 'admin-1481675417-14817193363427356', 1, 1, 'SR', NULL, NULL, NULL),
(14919, '2016-12-14 20:42:16', NULL, NULL, 5197, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 20:42:16', 'admin-1481675417-14817193363427356', 1, 0, '', NULL, NULL, NULL),
(14920, '2016-12-14 12:16:10', NULL, NULL, 5188, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 12:16:10', 'admin-1481675417-148168897061925', 1, 0, '', NULL, NULL, NULL),
(14921, '2016-12-14 12:53:37', NULL, NULL, 5189, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 12:53:37', 'admin-1481675417-14816912172469731', 1, 0, '', NULL, NULL, NULL),
(14922, '2016-12-14 17:48:51', NULL, NULL, 5194, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 17:48:51', 'admin-1481675417-14817089307706722', 1, 1, 'SR', 1, NULL, NULL),
(14923, '2016-12-14 17:48:51', NULL, NULL, 5194, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 17:48:51', 'admin-1481675417-14817089307706722', 1, 1, 'SR', 1, NULL, NULL),
(14924, '2016-12-14 17:48:51', NULL, NULL, 5194, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 17:48:51', 'admin-1481675417-14817089307706722', 1, 1, 'SR', 1, NULL, NULL),
(14925, '2016-12-14 16:52:29', NULL, NULL, 5193, 0, 84, '84', 'Set Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 16:52:29', 'admin-1481675417-1481705549771497', 1, 1, 'SR', NULL, NULL, NULL),
(14926, '2016-12-14 14:26:43', NULL, NULL, 5191, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 14:26:43', 'admin-1481675417-14816968033705285', 1, 1, 'SR', NULL, NULL, NULL),
(14927, '2016-12-14 13:40:11', NULL, NULL, 5191, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 13:40:11', 'admin-1481675417-1481694011205992', 1, 1, 'SR', NULL, NULL, NULL),
(14928, '2016-12-14 14:08:54', NULL, NULL, 5192, 0, 86, '86', 'Set Pesto Pasta ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 14:08:54', 'admin-1481675417-14816957341577817', 1, 1, 'SR', NULL, NULL, NULL),
(14929, '2016-12-14 14:08:54', NULL, NULL, 5192, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 14:08:54', 'admin-1481675417-14816957341577817', 1, 0, '', NULL, NULL, NULL),
(14930, '2016-12-14 14:09:02', NULL, NULL, 5192, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 14:09:02', 'admin-1481675417-14816957427847447', 1, 0, '', NULL, NULL, NULL),
(14931, '2016-12-14 13:40:11', NULL, NULL, 5191, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 13:40:11', 'admin-1481675417-1481694011205992', 1, 0, '', NULL, NULL, NULL),
(14932, '2016-12-14 13:40:11', NULL, NULL, 5191, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 13:40:11', 'admin-1481675417-1481694011205992', 1, 0, '', NULL, NULL, NULL),
(14933, '2016-12-14 12:53:37', NULL, NULL, 5189, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 12:53:37', 'admin-1481675417-14816912172469731', 1, 0, '', NULL, NULL, NULL),
(14934, '2016-12-14 12:53:37', NULL, NULL, 5189, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 12:53:37', 'admin-1481675417-14816912172469731', 1, 0, '', NULL, NULL, NULL),
(14935, '2016-12-14 13:34:35', NULL, NULL, 5190, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 13:34:35', 'admin-1481675417-148169367519353', 1, 0, '', NULL, NULL, NULL),
(14936, '2016-12-14 12:53:37', NULL, NULL, 5189, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 12:53:37', 'admin-1481675417-14816912172469731', 1, 0, '', NULL, NULL, NULL),
(14937, '2016-12-14 10:14:30', NULL, NULL, 5183, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 10:14:30', 'admin-1481675417-14816816698597894', 1, 1, 'SR', 1, NULL, NULL),
(14938, '2016-12-14 10:41:33', NULL, NULL, 5181, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 10:41:33', 'admin-1481675417-14816832934239910', 1, 1, 'SR', NULL, NULL, NULL),
(14939, '2016-12-14 10:44:08', NULL, NULL, 5184, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 10:44:08', 'admin-1481675417-14816834484836687', 1, 1, 'SR', NULL, NULL, NULL),
(14940, '2016-12-14 10:45:24', NULL, NULL, 5184, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 10:45:24', 'admin-1481675417-14816835241739571', 1, 0, '', NULL, NULL, NULL),
(14941, '2016-12-14 10:45:24', NULL, NULL, 5184, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 10:45:24', 'admin-1481675417-14816835241739571', 1, 0, '', NULL, NULL, NULL),
(14942, '2016-12-14 10:45:24', NULL, NULL, 5184, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 10:45:24', 'admin-1481675417-14816835241739571', 1, 0, '', NULL, NULL, NULL),
(14943, '2016-12-14 10:45:24', NULL, NULL, 5184, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 10:45:24', 'admin-1481675417-14816835241739571', 1, 1, 'SR', NULL, NULL, NULL),
(14944, '2016-12-14 10:45:24', NULL, NULL, 5184, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 10:45:24', 'admin-1481675417-14816835241739571', 1, 0, '', NULL, NULL, NULL),
(14945, '2016-12-14 10:54:57', NULL, NULL, 5185, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 10:54:57', 'admin-1481675417-14816840971269186', 1, 0, '', 1, NULL, NULL),
(14946, '2016-12-14 11:14:43', NULL, NULL, 5186, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 11:14:43', 'admin-1481675417-1481685283593813', 1, 1, 'SR', NULL, NULL, NULL),
(14947, '2016-12-14 11:14:43', NULL, NULL, 5186, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 11:14:43', 'admin-1481675417-1481685283593813', 1, 1, 'SR', NULL, NULL, NULL),
(14948, '2016-12-14 11:21:49', NULL, NULL, 5187, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 11:21:49', 'admin-1481675417-14816857090746558', 1, 0, '', NULL, NULL, NULL),
(14949, '2016-12-14 11:43:52', NULL, NULL, 5188, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 11:43:52', 'admin-1481675417-14816870317877841', 1, 0, '', NULL, NULL, NULL),
(14950, '2016-12-14 11:46:03', NULL, NULL, 5188, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 11:46:03', 'admin-1481675417-14816871636702461', 1, 0, '', NULL, NULL, NULL),
(14951, '2016-12-14 11:46:03', NULL, NULL, 5188, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 11:46:03', 'admin-1481675417-14816871636702461', 1, 0, '', NULL, NULL, NULL),
(14952, '2016-12-14 11:46:03', NULL, NULL, 5188, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 11:46:03', 'admin-1481675417-14816871636702461', 1, 1, 'SR', NULL, NULL, NULL),
(14953, '2016-12-14 11:46:03', NULL, NULL, 5188, 0, 83, '83', 'Set Mushroom Chicken ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 11:46:03', 'admin-1481675417-14816871636702461', 1, 1, 'SR', NULL, NULL, NULL),
(14954, '2016-12-14 11:46:03', NULL, NULL, 5188, 0, 85, '85', 'Set Sauted Mushroom Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 11:46:03', 'admin-1481675417-14816871636702461', 1, 1, 'SR', NULL, NULL, NULL),
(14955, '2016-12-14 11:46:03', NULL, NULL, 5188, 0, 85, '85', 'Set Sauted Mushroom Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 11:46:03', 'admin-1481675417-14816871636702461', 1, 1, 'SR', NULL, NULL, NULL),
(14956, '2016-12-14 11:46:03', NULL, NULL, 5188, 0, 86, '86', 'Set Pesto Pasta ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 11:46:03', 'admin-1481675417-14816871636702461', 1, 1, 'SR', NULL, NULL, NULL),
(14957, '2016-12-14 11:46:03', NULL, NULL, 5188, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 11:46:03', 'admin-1481675417-14816871636702461', 1, 1, 'SR', NULL, NULL, NULL),
(14958, '2016-12-14 11:46:03', NULL, NULL, 5188, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 11:46:03', 'admin-1481675417-14816871636702461', 1, 0, '', NULL, NULL, NULL),
(14959, '2016-12-14 11:46:03', NULL, NULL, 5188, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 11:46:03', 'admin-1481675417-14816871636702461', 1, 0, '', NULL, NULL, NULL),
(14960, '2016-12-14 11:46:03', NULL, NULL, 5188, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 11:46:03', 'admin-1481675417-14816871636702461', 1, 0, '', NULL, NULL, NULL),
(14961, '2016-12-14 11:46:29', NULL, NULL, 5188, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 11:46:29', 'admin-1481675417-14816871890431020', 1, 1, 'SR', NULL, NULL, NULL),
(14962, '2016-12-14 12:16:10', NULL, NULL, 5188, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 12:16:10', 'admin-1481675417-148168897061925', 1, 0, '', NULL, NULL, NULL),
(14963, '2016-12-14 10:14:30', NULL, NULL, 5183, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 10:14:30', 'admin-1481675417-14816816698597894', 1, 1, 'SR', 1, NULL, NULL),
(14964, '2016-12-14 10:08:55', NULL, NULL, 5182, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 10:08:55', 'admin-1481675417-14816813348458526', 1, 0, '', NULL, NULL, NULL),
(14965, '2016-12-14 09:01:23', NULL, NULL, 5180, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 09:01:23', 'admin-1481675417-14816772835318039', 1, 1, 'SR', NULL, NULL, NULL),
(14966, '2016-12-14 10:08:55', NULL, NULL, 5182, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 10:08:55', 'admin-1481675417-14816813348458526', 1, 0, '', NULL, NULL, NULL),
(14967, '2016-12-14 10:04:40', NULL, NULL, 5182, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 10:04:40', 'admin-1481675417-14816810804254513', 1, 1, 'SR', NULL, NULL, NULL),
(14968, '2016-12-14 10:04:34', NULL, NULL, 5182, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 10:04:34', 'admin-1481675417-14816810738756859', 1, 0, '', NULL, NULL, NULL),
(14969, '2016-12-14 09:37:47', NULL, NULL, 5181, 0, 156, '90', 'Cheese Omelet', 'salad no dressing', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 09:37:47', 'admin-1481675417-14816794674508677', 1, 0, '', NULL, NULL, NULL),
(14970, '2016-12-14 09:37:47', NULL, NULL, 5181, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 09:37:47', 'admin-1481675417-14816794674508677', 1, 1, 'SR', NULL, NULL, NULL),
(14971, '2016-12-14 09:01:23', NULL, NULL, 5180, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 09:01:23', 'admin-1481675417-14816772835318039', 1, 1, 'SR', NULL, NULL, NULL),
(14972, '2016-12-14 09:01:23', NULL, NULL, 5180, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 09:01:23', 'admin-1481675417-14816772835318039', 1, 1, 'SR', NULL, NULL, NULL),
(14973, '2016-12-14 09:01:23', NULL, NULL, 5180, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481675417', 'admin', '2016-12-14 09:01:23', 'admin-1481675417-14816772835318039', 1, 0, '', NULL, NULL, NULL),
(14974, '2016-12-15 21:53:35', NULL, NULL, 5216, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 21:53:35', 'admin-1481780716-14818100149345497', 1, 0, '', NULL, NULL, NULL),
(14975, '2016-12-15 21:01:27', NULL, NULL, 5213, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 21:01:27', 'admin-1481780716-14818068874938586', 1, 1, 'SR', NULL, NULL, NULL),
(14976, '2016-12-15 21:01:27', NULL, NULL, 5213, 0, 244, '178', 'Macadamia Scones', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 21:01:27', 'admin-1481780716-14818068874938586', 1, 0, '', NULL, NULL, NULL),
(14977, '2016-12-15 21:31:26', NULL, NULL, 5213, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 21:31:26', 'admin-1481780716-1481808686435517', 1, 1, 'SR', NULL, NULL, NULL),
(14978, '2016-12-15 21:53:35', NULL, NULL, 5216, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 21:53:35', 'admin-1481780716-14818100149345497', 1, 1, 'SR', NULL, NULL, NULL),
(14979, '2016-12-15 21:53:35', NULL, NULL, 5216, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 21:53:35', 'admin-1481780716-14818100149345497', 1, 1, 'SR', NULL, NULL, NULL),
(14980, '2016-12-15 21:31:26', NULL, NULL, 5213, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 21:31:26', 'admin-1481780716-1481808686435517', 1, 1, 'SR', NULL, NULL, NULL),
(14981, '2016-12-15 20:56:44', NULL, NULL, 5214, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 20:56:44', 'admin-1481780716-14818066043112234', 1, 0, '', NULL, NULL, NULL),
(14982, '2016-12-15 20:45:07', NULL, NULL, 5214, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 20:45:07', 'admin-1481780716-14818059076487794', 1, 0, '', NULL, NULL, NULL),
(14983, '2016-12-15 20:28:06', NULL, NULL, 5215, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 20:28:06', 'admin-1481780716-14818048867088879', 1, 1, 'SR', NULL, NULL, NULL),
(14984, '2016-12-15 20:28:06', NULL, NULL, 5215, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 20:28:06', 'admin-1481780716-14818048867088879', 1, 1, 'SR', NULL, NULL, NULL),
(14985, '2016-12-15 20:25:42', NULL, NULL, 5213, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 20:25:42', 'admin-1481780716-14818047421054041', 1, 1, 'SR', NULL, NULL, NULL),
(14986, '2016-12-15 20:26:59', NULL, NULL, 5214, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 20:26:59', 'admin-1481780716-1481804819022230', 1, 0, '', NULL, NULL, NULL),
(14987, '2016-12-15 20:27:28', NULL, NULL, 5213, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 20:27:28', 'admin-1481780716-14818048481567567', 1, 1, 'SR', NULL, NULL, NULL),
(14988, '2016-12-15 20:27:28', NULL, NULL, 5213, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 20:27:28', 'admin-1481780716-14818048481567567', 1, 1, 'SR', NULL, NULL, NULL),
(14989, '2016-12-15 19:34:01', NULL, NULL, 5212, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 19:34:01', 'admin-1481780716-1481801641623312', 1, 1, 'SR', NULL, NULL, NULL),
(14990, '2016-12-15 19:34:01', NULL, NULL, 5212, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 19:34:01', 'admin-1481780716-1481801641623312', 1, 1, 'SR', NULL, NULL, NULL),
(14991, '2016-12-15 20:25:04', NULL, NULL, 5213, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 20:25:04', 'admin-1481780716-1481804703928635', 1, 1, 'SR', NULL, NULL, NULL),
(14992, '2016-12-15 19:13:33', NULL, NULL, 5211, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 19:13:33', 'admin-1481780716-14818004131569126', 1, 0, '', NULL, NULL, NULL),
(14993, '2016-12-15 19:33:51', NULL, NULL, 5212, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 19:33:51', 'admin-1481780716-14818016314341699', 1, 1, 'SR', NULL, NULL, NULL),
(14994, '2016-12-15 19:13:33', NULL, NULL, 5211, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 19:13:33', 'admin-1481780716-14818004131569126', 1, 0, '', NULL, NULL, NULL),
(14995, '2016-12-15 19:12:43', NULL, NULL, 5211, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 19:12:43', 'admin-1481780716-14818003633428956', 1, 0, '', NULL, NULL, NULL),
(14996, '2016-12-15 16:27:46', NULL, NULL, 5210, 0, 244, '178', 'Macadamia Scones', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 16:27:46', 'admin-1481780716-14817904663106178', 1, 0, '', 1, NULL, NULL),
(14997, '2016-12-15 16:27:46', NULL, NULL, 5210, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 16:27:46', 'admin-1481780716-14817904663106178', 1, 0, '', 1, NULL, NULL),
(14998, '2016-12-15 16:19:54', NULL, NULL, 5209, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 16:19:54', 'admin-1481780716-14817899943638732', 1, 0, '', NULL, NULL, NULL),
(14999, '2016-12-15 14:47:36', NULL, NULL, 5208, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 14:47:36', 'admin-1481780716-1481784455960122', 1, 1, 'SR', NULL, NULL, NULL),
(15000, '2016-12-15 14:47:36', NULL, NULL, 5208, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 14:47:36', 'admin-1481780716-1481784455960122', 1, 0, '', NULL, NULL, NULL),
(15001, '2016-12-15 14:38:44', NULL, NULL, 5207, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 14:38:44', 'admin-1481780716-1481783924581426', 1, 1, 'SR', 1, NULL, NULL),
(15002, '2016-12-15 14:38:44', NULL, NULL, 5207, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 14:38:44', 'admin-1481780716-1481783924581426', 1, 1, 'SR', 1, NULL, NULL),
(15003, '2016-12-15 14:38:44', NULL, NULL, 5207, 0, 244, '178', 'Macadamia Scones', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 14:38:44', 'admin-1481780716-1481783924581426', 1, 0, '', 1, NULL, NULL),
(15004, '2016-12-15 14:30:24', NULL, NULL, 5206, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 14:30:24', 'admin-1481780716-14817834242038887', 1, 1, 'SR', NULL, NULL, NULL),
(15005, '2016-12-15 14:26:16', NULL, NULL, 5205, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 14:26:16', 'admin-1481780716-14817831764142271', 1, 1, 'SR', NULL, NULL, NULL),
(15006, '2016-12-15 13:45:48', NULL, NULL, 5204, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 13:45:48', 'admin-1481780716-14817807482548955', 1, 0, '', NULL, NULL, NULL),
(15007, '2016-12-15 13:45:48', NULL, NULL, 5204, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 13:45:48', 'admin-1481780716-14817807482548955', 1, 0, '', NULL, NULL, NULL),
(15008, '2016-12-15 13:45:48', NULL, NULL, 5204, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 13:45:48', 'admin-1481780716-14817807482548955', 1, 1, 'SR', NULL, NULL, NULL),
(15009, '2016-12-15 13:45:07', NULL, NULL, 5204, 0, 84, '84', 'Set Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 13:45:08', 'admin-1481765847-14817807078216993', 1, 1, 'SR', NULL, NULL, NULL),
(15010, '2016-12-15 12:36:05', NULL, NULL, 5203, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 12:36:05', 'admin-1481765847-14817765655163488', 1, 1, 'SR', NULL, NULL, NULL),
(15011, '2016-12-15 12:36:05', NULL, NULL, 5203, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 12:36:05', 'admin-1481765847-14817765655163488', 1, 0, '', NULL, NULL, NULL),
(15012, '2016-12-15 12:36:05', NULL, NULL, 5203, 0, 85, '85', 'Set Sauted Mushroom Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 12:36:05', 'admin-1481765847-14817765655163488', 1, 1, 'SR', NULL, NULL, NULL),
(15013, '2016-12-15 12:36:05', NULL, NULL, 5203, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 12:36:05', 'admin-1481765847-14817765655163488', 1, 0, '', NULL, NULL, NULL),
(15014, '2016-12-15 12:20:27', NULL, NULL, 5202, 0, 213, '147', 'Set Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 12:20:27', 'admin-1481765847-14817756273229743', 1, 0, '', NULL, NULL, NULL),
(15015, '2016-12-15 12:18:26', NULL, NULL, 5202, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 12:18:26', 'admin-1481765847-14817755059134342', 1, 0, '', NULL, NULL, NULL),
(15016, '2016-12-15 12:18:26', NULL, NULL, 5202, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 12:18:26', 'admin-1481765847-14817755059134342', 1, 0, '', NULL, NULL, NULL),
(15017, '2016-12-15 12:18:26', NULL, NULL, 5202, 0, 86, '86', 'Set Pesto Pasta ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 12:18:26', 'admin-1481765847-14817755059134342', 1, 1, 'SR', NULL, NULL, NULL),
(15018, '2016-12-15 11:47:41', NULL, NULL, 5201, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 11:47:41', 'admin-1481765847-14817736611997520', 1, 1, 'SR', 1, NULL, NULL),
(15019, '2016-12-15 11:47:41', NULL, NULL, 5201, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 11:47:41', 'admin-1481765847-14817736611997520', 1, 1, 'SR', 1, NULL, NULL),
(15020, '2016-12-15 11:47:41', NULL, NULL, 5201, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 11:47:41', 'admin-1481765847-14817736611997520', 1, 1, 'SR', 1, NULL, NULL),
(15021, '2016-12-15 11:47:41', NULL, NULL, 5201, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 11:47:41', 'admin-1481765847-14817736611997520', 1, 1, 'SR', 1, NULL, NULL),
(15022, '2016-12-15 11:47:41', NULL, NULL, 5201, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 11:47:41', 'admin-1481765847-14817736611997520', 1, 1, 'SR', 1, NULL, NULL),
(15023, '2016-12-15 11:00:13', NULL, NULL, 5200, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 11:00:13', 'admin-1481765847-14817708133678921', 1, 1, 'SR', NULL, NULL, NULL),
(15024, '2016-12-15 11:00:13', NULL, NULL, 5200, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 11:00:13', 'admin-1481765847-14817708133678921', 1, 1, 'SR', NULL, NULL, NULL),
(15025, '2016-12-15 11:00:03', NULL, NULL, 5200, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 11:00:03', 'admin-1481765847-1481770803673328', 1, 0, '', NULL, NULL, NULL),
(15026, '2016-12-15 10:32:29', NULL, NULL, 5199, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 10:32:29', 'admin-1481765847-14817691492224455', 1, 0, '', NULL, NULL, NULL),
(15027, '2016-12-15 11:00:03', NULL, NULL, 5200, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 11:00:03', 'admin-1481765847-1481770803673328', 1, 0, '', NULL, NULL, NULL),
(15028, '2016-12-15 10:32:29', NULL, NULL, 5199, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 10:32:29', 'admin-1481765847-14817691492224455', 1, 1, 'SR', NULL, NULL, NULL),
(15029, '2016-12-15 09:55:42', NULL, NULL, 5199, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481780716', 'admin', '2016-12-15 09:55:42', 'admin-1481765847-14817669419769755', 1, 1, 'SR', NULL, NULL, NULL),
(15030, '2016-12-16 16:34:44', NULL, NULL, 5233, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 16:34:44', 'admin-1481870880-14818772841352274', 1, 0, '', NULL, NULL, NULL),
(15031, '2016-12-16 16:34:44', NULL, NULL, 5233, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 16:34:44', 'admin-1481870880-14818772841352274', 1, 0, '', NULL, NULL, NULL),
(15032, '2016-12-16 16:34:55', NULL, NULL, 5233, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 16:34:55', 'admin-1481870880-14818772950511489', 1, 1, 'SR', NULL, NULL, NULL),
(15033, '2016-12-16 16:34:55', NULL, NULL, 5233, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 16:34:55', 'admin-1481870880-14818772950511489', 1, 0, '', NULL, NULL, NULL),
(15034, '2016-12-16 17:33:47', NULL, NULL, 5233, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 17:33:47', 'admin-1481870880-14818808270874624', 1, 0, '', NULL, NULL, NULL),
(15035, '2016-12-16 17:33:47', NULL, NULL, 5233, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 17:33:47', 'admin-1481870880-14818808270874624', 1, 0, '', NULL, NULL, NULL),
(15036, '2016-12-16 17:33:47', NULL, NULL, 5233, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 17:33:47', 'admin-1481870880-14818808270874624', 1, 1, 'SR', NULL, NULL, NULL),
(15037, '2016-12-16 18:00:39', NULL, NULL, 5234, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 18:00:39', 'admin-1481870880-14818824392294615', 1, 0, '', NULL, NULL, NULL),
(15038, '2016-12-16 18:00:46', NULL, NULL, 5234, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 18:00:46', 'admin-1481870880-14818824465626568', 1, 1, 'SR', NULL, NULL, NULL),
(15039, '2016-12-16 18:09:04', NULL, NULL, 5235, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 18:09:04', 'admin-1481870880-14818829444136468', 1, 1, 'SR', NULL, NULL, NULL),
(15040, '2016-12-16 18:09:04', NULL, NULL, 5235, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 18:09:04', 'admin-1481870880-14818829444136468', 1, 1, 'SR', NULL, NULL, NULL),
(15041, '2016-12-16 18:36:37', NULL, NULL, 5236, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 18:36:37', 'admin-1481870880-14818845971276723', 1, 1, 'SR', NULL, NULL, NULL),
(15042, '2016-12-16 18:36:37', NULL, NULL, 5236, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 18:36:37', 'admin-1481870880-14818845971276723', 1, 1, 'SR', NULL, NULL, NULL),
(15043, '2016-12-16 21:17:35', NULL, NULL, 5237, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 21:17:35', 'admin-1481870880-14818942551662080', 1, 0, '', NULL, NULL, NULL),
(15044, '2016-12-16 21:17:35', NULL, NULL, 5237, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 21:17:35', 'admin-1481870880-14818942551662080', 1, 1, 'SR', NULL, NULL, NULL),
(15045, '2016-12-16 21:17:35', NULL, NULL, 5237, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 21:17:35', 'admin-1481870880-14818942551662080', 1, 1, 'SR', NULL, NULL, NULL),
(15046, '2016-12-16 21:17:35', NULL, NULL, 5237, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 21:17:35', 'admin-1481870880-14818942551662080', 1, 1, 'SR', NULL, NULL, NULL),
(15047, '2016-12-16 14:14:58', NULL, NULL, 5229, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 14:14:58', 'admin-1481865247-14818688980343260', 1, 1, 'SR', NULL, NULL, NULL),
(15048, '2016-12-16 14:29:46', NULL, NULL, 5228, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 14:29:46', 'admin-1481865247-1481869786158835', 1, 1, 'SR', NULL, NULL, NULL),
(15049, '2016-12-16 14:29:58', NULL, NULL, 5230, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 14:29:58', 'admin-1481865247-14818697987568426', 1, 0, '', NULL, NULL, NULL),
(15050, '2016-12-16 14:29:58', NULL, NULL, 5230, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 14:29:58', 'admin-1481865247-14818697987568426', 1, 1, 'SR', NULL, NULL, NULL),
(15051, '2016-12-16 14:47:40', NULL, NULL, 5231, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 14:47:40', 'admin-1481865247-14818708600509927', 1, 0, '', NULL, NULL, NULL),
(15052, '2016-12-16 14:47:55', NULL, NULL, 5231, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 14:47:55', 'admin-1481865247-14818708752551814', 1, 0, '', NULL, NULL, NULL),
(15053, '2016-12-16 14:47:55', NULL, NULL, 5231, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 14:47:55', 'admin-1481865247-14818708752551814', 1, 1, 'SR', NULL, NULL, NULL),
(15054, '2016-12-16 14:47:55', NULL, NULL, 5231, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 14:47:55', 'admin-1481865247-14818708752551814', 1, 1, 'SR', NULL, NULL, NULL),
(15055, '2016-12-16 14:55:31', NULL, NULL, 5229, 0, 246, '180', 'Noodle Soup', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 14:55:31', 'admin-1481870880-1481871330948117', 1, 0, '', NULL, NULL, NULL),
(15056, '2016-12-16 15:22:06', NULL, NULL, 5232, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 15:22:06', 'admin-1481870880-14818729266897737', 1, 1, 'SR', NULL, NULL, NULL),
(15057, '2016-12-16 15:32:38', NULL, NULL, 5232, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 15:32:38', 'admin-1481870880-14818735585568559', 1, 1, 'SR', NULL, NULL, NULL),
(15058, '2016-12-16 14:08:06', NULL, NULL, 5229, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 14:08:06', 'admin-1481865247-14818684859318215', 1, 1, 'SR', NULL, NULL, NULL),
(15059, '2016-12-16 14:05:18', NULL, NULL, 5229, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 14:05:18', 'admin-1481865247-14818683185594894', 1, 1, 'SR', NULL, NULL, NULL),
(15060, '2016-12-16 14:04:16', NULL, NULL, 5228, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 14:04:16', 'admin-1481865247-14818682566868487', 1, 0, '', NULL, NULL, NULL),
(15061, '2016-12-16 13:46:10', NULL, NULL, 5227, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 13:46:10', 'admin-1481865247-14818671699068728', 1, 0, '', NULL, NULL, '10.0'),
(15062, '2016-12-16 13:19:28', NULL, NULL, 5226, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 13:19:28', 'admin-1481865247-14818655682117728', 1, 1, 'SR', NULL, NULL, NULL),
(15063, '2016-12-16 13:29:26', NULL, NULL, 5226, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 13:29:26', 'admin-1481865247-14818661659151495', 1, 1, 'SR', NULL, NULL, NULL),
(15064, '2016-12-16 13:45:54', NULL, NULL, 5227, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 13:45:54', 'admin-1481865247-14818671539644597', 1, 0, '', NULL, NULL, '10.0'),
(15065, '2016-12-16 13:46:10', NULL, NULL, 5227, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 13:46:10', 'admin-1481865247-14818671699068728', 1, 1, 'SR', NULL, NULL, '10.0'),
(15066, '2016-12-16 13:19:28', NULL, NULL, 5226, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 13:19:28', 'admin-1481865247-14818655682117728', 1, 1, 'SR', NULL, NULL, NULL),
(15067, '2016-12-16 13:19:28', NULL, NULL, 5226, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 13:19:28', 'admin-1481865247-14818655682117728', 1, 0, '', NULL, NULL, NULL),
(15068, '2016-12-16 13:19:28', NULL, NULL, 5226, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 13:19:28', 'admin-1481865247-14818655682117728', 1, 1, 'SR', NULL, NULL, NULL),
(15069, '2016-12-16 13:18:38', NULL, NULL, 5225, 0, 83, '83', 'Set Stir Fried Chicken with Mushroom ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 13:18:38', 'admin-1481865247-14818655178836977', 1, 1, 'SR', NULL, NULL, NULL),
(15070, '2016-12-16 13:19:28', NULL, NULL, 5226, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 13:19:28', 'admin-1481865247-14818655682117728', 1, 1, 'SR', NULL, NULL, NULL),
(15071, '2016-12-16 13:18:38', NULL, NULL, 5225, 0, 84, '84', 'Set Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 13:18:38', 'admin-1481865247-14818655178836977', 1, 1, 'SR', NULL, NULL, NULL),
(15072, '2016-12-16 11:58:34', NULL, NULL, 5223, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 11:58:34', 'admin-1481860706-1481860714208212', 1, 1, 'SR', NULL, NULL, NULL),
(15073, '2016-12-16 12:30:48', NULL, NULL, 5224, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 12:30:48', 'admin-1481860706-1481862648170868', 1, 1, 'SR', NULL, NULL, NULL),
(15074, '2016-12-16 11:29:56', NULL, NULL, 5222, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 11:29:56', 'admin-1481849558-14818589964547437', 1, 1, 'SR', NULL, NULL, NULL),
(15075, '2016-12-16 11:58:20', NULL, NULL, 5223, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 11:58:20', 'admin-1481849558-14818607001993655', 1, 0, '', NULL, NULL, NULL),
(15076, '2016-12-16 11:29:56', NULL, NULL, 5222, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 11:29:56', 'admin-1481849558-14818589964547437', 1, 0, '', NULL, NULL, NULL),
(15077, '2016-12-16 11:29:56', NULL, NULL, 5222, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 11:29:56', 'admin-1481849558-14818589964547437', 1, 0, '', NULL, NULL, NULL),
(15078, '2016-12-16 11:29:56', NULL, NULL, 5222, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 11:29:56', 'admin-1481849558-14818589964547437', 1, 0, '', NULL, NULL, NULL),
(15079, '2016-12-16 10:23:56', NULL, NULL, 5218, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 10:23:56', 'admin-1481849558-14818550362277498', 1, 0, '', NULL, NULL, NULL),
(15080, '2016-12-16 10:16:54', NULL, NULL, 5221, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 10:16:54', 'admin-1481849558-14818546141013854', 1, 1, 'SR', NULL, NULL, NULL),
(15081, '2016-12-16 10:16:54', NULL, NULL, 5221, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 10:16:54', 'admin-1481849558-14818546141013854', 1, 1, 'SR', NULL, NULL, NULL),
(15082, '2016-12-16 09:36:18', NULL, NULL, 5220, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:36:18', 'admin-1481849558-14818521783274985', 1, 1, 'SR', NULL, NULL, NULL),
(15083, '2016-12-16 09:36:18', NULL, NULL, 5220, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:36:18', 'admin-1481849558-14818521783274985', 1, 1, 'SR', NULL, NULL, NULL),
(15084, '2016-12-16 09:31:04', NULL, NULL, 5219, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:31:04', 'admin-1481849558-1481851863889923', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(15085, '2016-12-16 09:31:04', NULL, NULL, 5219, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:31:04', 'admin-1481849558-1481851863889923', 1, 1, 'SR', NULL, NULL, NULL),
(15086, '2016-12-16 09:31:04', NULL, NULL, 5219, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:31:04', 'admin-1481849558-1481851863889923', 1, 0, '', NULL, NULL, NULL),
(15087, '2016-12-16 09:31:04', NULL, NULL, 5219, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:31:04', 'admin-1481849558-1481851863889923', 1, 1, 'SR', NULL, NULL, NULL),
(15088, '2016-12-16 09:31:04', NULL, NULL, 5219, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:31:04', 'admin-1481849558-1481851863889923', 1, 1, 'SR', NULL, NULL, NULL),
(15089, '2016-12-16 09:31:04', NULL, NULL, 5219, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:31:04', 'admin-1481849558-1481851863889923', 1, 0, '', NULL, NULL, NULL),
(15090, '2016-12-16 09:31:04', NULL, NULL, 5219, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:31:04', 'admin-1481849558-1481851863889923', 1, 0, '', NULL, NULL, NULL),
(15091, '2016-12-16 09:31:04', NULL, NULL, 5219, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:31:04', 'admin-1481849558-1481851863889923', 1, 0, '', NULL, NULL, NULL),
(15092, '2016-12-16 09:30:34', NULL, NULL, 5218, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:30:34', 'admin-1481849558-14818518339901221', 1, 1, 'SR', NULL, NULL, NULL),
(15093, '2016-12-16 09:30:34', NULL, NULL, 5218, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:30:34', 'admin-1481849558-14818518339901221', 1, 1, 'SR', NULL, NULL, NULL),
(15094, '2016-12-16 09:28:37', NULL, NULL, 5218, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:28:37', 'admin-1481849558-14818517178501268', 1, 0, '', NULL, NULL, NULL),
(15095, '2016-12-16 09:27:56', NULL, NULL, 5218, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:27:56', 'admin-1481849558-14818516763769843', 1, 0, '', NULL, NULL, NULL),
(15096, '2016-12-16 09:27:56', NULL, NULL, 5218, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:27:56', 'admin-1481849558-14818516763769843', 1, 1, 'SR', NULL, NULL, NULL),
(15097, '2016-12-16 09:27:56', NULL, NULL, 5218, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:27:56', 'admin-1481849558-14818516763769843', 1, 1, 'SR', NULL, NULL, NULL),
(15098, '2016-12-16 09:27:56', NULL, NULL, 5218, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:27:56', 'admin-1481849558-14818516763769843', 1, 0, '', NULL, NULL, NULL),
(15099, '2016-12-16 09:13:36', NULL, NULL, 5217, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:13:36', 'admin-1481849558-14818508162768994', 1, 1, 'SR', NULL, NULL, NULL),
(15100, '2016-12-16 09:13:36', NULL, NULL, 5217, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:13:36', 'admin-1481849558-14818508162768994', 1, 1, 'SR', NULL, NULL, NULL),
(15101, '2016-12-16 09:13:36', NULL, NULL, 5217, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:13:36', 'admin-1481849558-14818508162768994', 1, 1, 'SR', NULL, NULL, NULL),
(15102, '2016-12-16 09:13:36', NULL, NULL, 5217, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:13:36', 'admin-1481849558-14818508162768994', 1, 0, '', NULL, NULL, NULL),
(15103, '2016-12-16 09:13:36', NULL, NULL, 5217, 0, 230, '164', 'Coffee Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:13:36', 'admin-1481849558-14818508162768994', 1, 0, '', NULL, NULL, NULL),
(15104, '2016-12-16 09:13:36', NULL, NULL, 5217, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:13:36', 'admin-1481849558-14818508162768994', 1, 0, '', NULL, NULL, NULL),
(15105, '2016-12-16 09:13:36', NULL, NULL, 5217, 0, 181, '116', 'Open Food ', 'CScone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:13:36', 'admin-1481849558-14818508162768994', 1, 0, '', NULL, NULL, NULL),
(15106, '2016-12-16 09:13:36', NULL, NULL, 5217, 0, 181, '116', 'Open Food ', 'MWC Scone', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1481870880', 'admin', '2016-12-16 09:13:36', 'admin-1481849558-14818508162768994', 1, 0, '', NULL, NULL, NULL),
(15107, '2016-12-17 18:18:33', NULL, NULL, 5266, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 18:18:33', 'admin-1481969579-14819699138349294', 1, 1, 'SR', NULL, NULL, NULL),
(15108, '2016-12-17 19:27:16', NULL, NULL, 5269, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:27:16', 'admin-1481969579-14819740366616894', 1, 1, 'SR', NULL, NULL, '10.0'),
(15109, '2016-12-17 19:27:16', NULL, NULL, 5269, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:27:16', 'admin-1481969579-14819740366616894', 1, 1, 'SR', NULL, NULL, '10.0'),
(15110, '2016-12-17 19:27:16', NULL, NULL, 5269, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:27:16', 'admin-1481969579-14819740366616894', 1, 0, '', NULL, NULL, '10.0'),
(15111, '2016-12-17 19:27:16', NULL, NULL, 5269, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:27:16', 'admin-1481969579-14819740366616894', 1, 0, '', NULL, NULL, '10.0'),
(15112, '2016-12-17 19:27:16', NULL, NULL, 5269, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:27:16', 'admin-1481969579-14819740366616894', 1, 1, 'SR', NULL, NULL, '10.0'),
(15113, '2016-12-17 19:27:16', NULL, NULL, 5269, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:27:16', 'admin-1481969579-14819740366616894', 1, 0, '', NULL, NULL, '10.0'),
(15114, '2016-12-17 19:27:16', NULL, NULL, 5269, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:27:16', 'admin-1481969579-14819740366616894', 1, 0, '', NULL, NULL, '10.0'),
(15115, '2016-12-17 21:24:57', NULL, NULL, 5271, 0, 182, '117', 'Open Drinks ', '50.00 per pax', 'Cold Drinks', 'Fresh Juice', 1, 550.00, 550.0000, 0.0000, 550.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 21:24:57', 'admin-1481980912-1481981097618953', 1, 0, '', NULL, NULL, NULL),
(15116, '2016-12-17 20:12:39', NULL, NULL, 5271, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 20:12:39', 'admin-1481976364-14819767594597320', 1, 1, 'SR', NULL, NULL, NULL),
(15117, '2016-12-17 20:25:26', NULL, NULL, 5271, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 20:25:26', 'admin-1481976364-14819775267995767', 1, 1, 'SR', NULL, NULL, NULL),
(15118, '2016-12-17 20:32:10', NULL, NULL, 5271, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 20:32:10', 'admin-1481976364-14819779299267168', 1, 1, 'SR', NULL, NULL, NULL),
(15119, '2016-12-17 19:09:51', NULL, NULL, 5267, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:09:51', 'admin-1481969579-14819729917621192', 1, 0, '', NULL, NULL, NULL),
(15120, '2016-12-17 19:09:51', NULL, NULL, 5267, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:09:51', 'admin-1481969579-14819729917621192', 1, 0, '', NULL, NULL, NULL),
(15121, '2016-12-17 19:09:51', NULL, NULL, 5267, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:09:51', 'admin-1481969579-14819729917621192', 1, 1, 'SR', NULL, NULL, NULL),
(15122, '2016-12-17 19:10:21', NULL, NULL, 5267, 0, 181, '116', 'Open Food ', 'Fried vege', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:10:21', 'admin-1481969579-1481973021563565', 1, 0, '', NULL, NULL, NULL),
(15123, '2016-12-17 19:10:21', NULL, NULL, 5267, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:10:21', 'admin-1481969579-1481973021563565', 1, 1, 'SR', NULL, NULL, NULL),
(15124, '2016-12-17 19:19:44', NULL, NULL, 5268, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:19:44', 'admin-1481969579-1481973584799976', 1, 1, 'SR', NULL, NULL, NULL),
(15125, '2016-12-17 19:19:44', NULL, NULL, 5268, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:19:44', 'admin-1481969579-1481973584799976', 1, 1, 'SR', NULL, NULL, NULL),
(15126, '2016-12-17 19:24:47', NULL, NULL, 5269, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:24:47', 'admin-1481969579-14819738869349642', 1, 1, 'SR', NULL, NULL, '10.0'),
(15127, '2016-12-17 19:27:16', NULL, NULL, 5269, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:27:16', 'admin-1481969579-14819740366616894', 1, 1, 'SR', NULL, NULL, '10.0'),
(15128, '2016-12-17 21:22:30', NULL, NULL, 5269, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 21:22:30', 'admin-1481980912-14819809498577246', 1, 0, '', NULL, NULL, '10.0'),
(15129, '2016-12-17 21:22:30', NULL, NULL, 5269, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 21:22:30', 'admin-1481980912-14819809498577246', 1, 0, '', NULL, NULL, '10.0'),
(15130, '2016-12-17 21:13:45', NULL, NULL, 5271, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 21:13:45', 'admin-1481976364-1481980425191311', 1, 0, '', NULL, NULL, NULL),
(15131, '2016-12-17 21:13:45', NULL, NULL, 5271, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 21:13:45', 'admin-1481976364-1481980425191311', 1, 0, '', NULL, NULL, NULL),
(15132, '2016-12-17 20:55:36', NULL, NULL, 5271, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 20:55:36', 'admin-1481976364-14819793365201766', 1, 0, '', NULL, NULL, NULL),
(15133, '2016-12-17 20:57:10', NULL, NULL, 5271, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 20:57:10', 'admin-1481976364-14819794302683156', 1, 1, 'SR', NULL, NULL, NULL),
(15134, '2016-12-17 20:39:56', NULL, NULL, 5271, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 20:39:56', 'admin-1481976364-14819783967703486', 1, 1, 'SR', NULL, NULL, NULL),
(15135, '2016-12-17 18:00:32', NULL, NULL, 5263, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 18:00:32', 'admin-1481955926-14819688326467352', 1, 0, '', NULL, NULL, NULL),
(15136, '2016-12-17 18:00:32', NULL, NULL, 5263, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 18:00:32', 'admin-1481955926-14819688326467352', 1, 0, '', NULL, NULL, NULL),
(15137, '2016-12-17 18:00:32', NULL, NULL, 5263, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 18:00:32', 'admin-1481955926-14819688326467352', 1, 0, '', NULL, NULL, NULL),
(15138, '2016-12-17 18:00:32', NULL, NULL, 5263, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 18:00:32', 'admin-1481955926-14819688326467352', 1, 1, 'SR', NULL, NULL, NULL),
(15139, '2016-12-17 18:00:46', NULL, NULL, 5264, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 18:00:46', 'admin-1481955926-14819688467391164', 1, 1, 'SR', NULL, NULL, NULL),
(15140, '2016-12-17 18:00:46', NULL, NULL, 5264, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 18:00:46', 'admin-1481955926-14819688467391164', 1, 0, '', NULL, NULL, NULL),
(15141, '2016-12-17 18:00:46', NULL, NULL, 5264, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 18:00:46', 'admin-1481955926-14819688467391164', 1, 1, 'SR', NULL, NULL, NULL),
(15142, '2016-12-17 18:11:26', NULL, NULL, 5265, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 18:11:26', 'admin-1481955926-14819694863303349', 1, 1, 'SR', NULL, NULL, NULL),
(15143, '2016-12-17 18:12:52', NULL, NULL, 5266, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 18:12:52', 'admin-1481955926-14819695722881946', 1, 0, '', NULL, NULL, NULL),
(15144, '2016-12-17 18:12:52', NULL, NULL, 5266, 0, 74, '74', 'Sunrice', 'without egg', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 18:12:52', 'admin-1481955926-14819695722881946', 1, 1, 'SR', NULL, NULL, NULL),
(15145, '2016-12-17 18:12:52', NULL, NULL, 5266, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 18:12:52', 'admin-1481955926-14819695722881946', 1, 1, 'SR', NULL, NULL, NULL),
(15146, '2016-12-17 20:39:56', NULL, NULL, 5271, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 20:39:56', 'admin-1481976364-14819783967703486', 1, 1, 'SR', NULL, NULL, NULL),
(15147, '2016-12-17 19:42:59', NULL, NULL, 5269, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:42:59', 'admin-1481969579-14819749792312544', 1, 1, 'SR', NULL, NULL, '10.0'),
(15148, '2016-12-17 19:42:59', NULL, NULL, 5269, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:42:59', 'admin-1481969579-14819749792312544', 1, 0, '', NULL, NULL, '10.0'),
(15149, '2016-12-17 20:06:16', NULL, NULL, 5272, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 20:06:16', 'admin-1481976364-14819763763182250', 1, 1, 'SR', NULL, NULL, NULL),
(15150, '2016-12-17 20:06:16', NULL, NULL, 5272, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 20:06:16', 'admin-1481976364-14819763763182250', 1, 1, 'SR', NULL, NULL, NULL),
(15151, '2016-12-17 20:06:57', NULL, NULL, 5271, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 20:06:57', 'admin-1481976364-14819764175829880', 1, 1, 'SR', NULL, NULL, NULL),
(15152, '2016-12-17 19:54:17', NULL, NULL, 5270, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:54:17', 'admin-1481975059-14819756574969355', 1, 0, '', NULL, NULL, NULL),
(15153, '2016-12-17 19:56:31', NULL, NULL, 5271, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:56:31', 'admin-1481975059-14819757913827729', 1, 1, 'SR', NULL, NULL, NULL),
(15154, '2016-12-17 19:56:31', NULL, NULL, 5271, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:56:31', 'admin-1481975059-14819757913827729', 1, 1, 'SR', NULL, NULL, NULL),
(15155, '2016-12-17 19:57:01', NULL, NULL, 5271, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:57:01', 'admin-1481975059-14819758211478337', 1, 1, 'SR', NULL, NULL, NULL),
(15156, '2016-12-17 19:57:43', NULL, NULL, 5269, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:57:43', 'admin-1481975059-14819758630279219', 1, 1, 'SR', NULL, NULL, '10.0'),
(15157, '2016-12-17 20:00:47', NULL, NULL, 5269, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 20:00:47', 'admin-1481975059-14819760470744065', 1, 0, '', NULL, NULL, '10.0'),
(15158, '2016-12-17 20:05:14', NULL, NULL, 5268, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 20:05:14', 'admin-1481975059-14819763146897264', 1, 1, 'SR', NULL, NULL, NULL),
(15159, '2016-12-17 20:05:14', NULL, NULL, 5268, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 20:05:14', 'admin-1481975059-14819763146897264', 1, 1, 'SR', NULL, NULL, NULL),
(15160, '2016-12-17 20:05:49', NULL, NULL, 5269, 0, 181, '116', 'Open Food ', 'curry chicken', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 20:05:49', 'admin-1481975059-1481976349356235', 1, 0, '', NULL, NULL, '10.0'),
(15161, '2016-12-17 15:29:29', NULL, NULL, 5256, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 15:29:29', 'admin-1481955926-14819597694207445', 1, 0, '', NULL, NULL, NULL),
(15162, '2016-12-17 15:21:16', NULL, NULL, 5255, 0, 244, '178', 'Macadamia Scones', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 15:21:16', 'admin-1481955926-14819592759247738', 1, 0, '', NULL, NULL, NULL),
(15163, '2016-12-17 15:20:16', NULL, NULL, 5255, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 15:20:16', 'admin-1481955926-14819592161434073', 1, 1, 'SR', NULL, NULL, NULL),
(15164, '2016-12-17 15:20:16', NULL, NULL, 5255, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 15:20:16', 'admin-1481955926-14819592161434073', 1, 1, 'SR', NULL, NULL, NULL),
(15165, '2016-12-17 15:14:38', NULL, NULL, 5254, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 15:14:38', 'admin-1481955926-1481958878187784', 1, 0, '', NULL, NULL, NULL),
(15166, '2016-12-17 15:14:38', NULL, NULL, 5254, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 15:14:38', 'admin-1481955926-1481958878187784', 1, 1, 'SR', NULL, NULL, NULL),
(15167, '2016-12-17 15:14:38', NULL, NULL, 5254, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 15:14:38', 'admin-1481955926-1481958878187784', 1, 1, 'SR', NULL, NULL, NULL),
(15168, '2016-12-17 13:06:05', NULL, NULL, 5250, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 13:06:05', 'admin-1481947331-14819511654683755', 1, 1, 'SR', NULL, NULL, NULL),
(15169, '2016-12-17 15:00:12', NULL, NULL, 5253, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 15:00:12', 'admin-1481955926-14819580124728863', 1, 0, '', NULL, NULL, NULL),
(15170, '2016-12-17 14:25:47', NULL, NULL, 5253, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 14:25:47', 'admin-1481955926-14819559471788345', 1, 1, 'SR', NULL, NULL, NULL),
(15171, '2016-12-17 14:25:20', NULL, NULL, 5253, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 14:25:20', 'admin-1481947331-14819559201848689', 1, 0, '', NULL, NULL, NULL),
(15172, '2016-12-17 14:25:20', NULL, NULL, 5253, 0, 224, '158', 'Set Stir Fried  Garlic Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 14:25:20', 'admin-1481947331-14819559201848689', 1, 0, '', NULL, NULL, NULL),
(15173, '2016-12-17 14:25:20', NULL, NULL, 5253, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 14:25:20', 'admin-1481947331-14819559201848689', 1, 0, '', NULL, NULL, NULL),
(15174, '2016-12-17 13:28:45', NULL, NULL, 5252, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 13:28:45', 'admin-1481947331-14819525256873779', 1, 1, 'SR', NULL, NULL, NULL),
(15175, '2016-12-17 13:28:45', NULL, NULL, 5252, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 13:28:45', 'admin-1481947331-14819525256873779', 1, 1, 'SR', NULL, NULL, NULL),
(15176, '2016-12-17 13:28:23', NULL, NULL, 5252, 0, 181, '116', 'Open Food ', 'Simmered Pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 13:28:23', 'admin-1481947331-148195250354614', 1, 0, '', NULL, NULL, NULL),
(15177, '2016-12-17 13:28:23', NULL, NULL, 5252, 0, 181, '116', 'Open Food ', 'Simmered Pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 13:28:23', 'admin-1481947331-148195250354614', 1, 0, '', NULL, NULL, NULL),
(15178, '2016-12-17 19:48:19', NULL, NULL, 5269, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:48:19', 'admin-1481975059-14819752996212627', 1, 0, '', NULL, NULL, '10.0'),
(15179, '2016-12-17 19:27:16', NULL, NULL, 5269, 0, 181, '116', 'Open Food ', 'Scone', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:27:16', 'admin-1481969579-14819740366616894', 1, 0, '', NULL, NULL, '10.0'),
(15180, '2016-12-17 19:30:04', NULL, NULL, 5269, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:30:04', 'admin-1481969579-14819742045761074', 1, 0, '', NULL, NULL, '10.0'),
(15181, '2016-12-17 19:34:32', NULL, NULL, 5269, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:34:32', 'admin-1481969579-14819744723317553', 1, 1, 'SR', NULL, NULL, '10.0'),
(15182, '2016-12-17 15:29:56', NULL, NULL, 5256, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 15:29:56', 'admin-1481955926-14819597963094856', 1, 1, 'SR', NULL, NULL, NULL),
(15183, '2016-12-17 15:44:27', NULL, NULL, 5257, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 15:44:27', 'admin-1481955926-14819606674606512', 1, 1, 'SR', NULL, NULL, NULL),
(15184, '2016-12-17 15:56:08', NULL, NULL, 5258, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 15:56:08', 'admin-1481955926-1481961368134284', 1, 0, '', NULL, NULL, NULL),
(15185, '2016-12-17 16:05:51', NULL, NULL, 5259, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 16:05:51', 'admin-1481955926-14819619517511259', 1, 1, 'SR', NULL, NULL, NULL),
(15186, '2016-12-17 17:01:48', NULL, NULL, 5259, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 17:01:48', 'admin-1481955926-14819653083496993', 1, 1, 'SR', NULL, NULL, NULL),
(15187, '2016-12-17 17:01:48', NULL, NULL, 5259, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 17:01:48', 'admin-1481955926-14819653083496993', 1, 1, 'SR', NULL, NULL, NULL),
(15188, '2016-12-17 17:01:48', NULL, NULL, 5259, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 17:01:48', 'admin-1481955926-14819653083496993', 1, 0, '', NULL, NULL, NULL),
(15189, '2016-12-17 17:02:26', NULL, NULL, 5260, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 17:02:26', 'admin-1481955926-148196534579792', 1, 1, 'SR', NULL, NULL, NULL),
(15190, '2016-12-17 17:02:26', NULL, NULL, 5260, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 17:02:26', 'admin-1481955926-148196534579792', 1, 1, 'SR', NULL, NULL, NULL),
(15191, '2016-12-17 17:02:26', NULL, NULL, 5260, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 17:02:26', 'admin-1481955926-148196534579792', 1, 0, '', NULL, NULL, NULL),
(15192, '2016-12-17 17:02:26', NULL, NULL, 5260, 0, 181, '116', 'Open Food ', 'macadamia', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 17:02:26', 'admin-1481955926-148196534579792', 1, 0, '', NULL, NULL, NULL),
(15193, '2016-12-17 17:34:33', NULL, NULL, 5261, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 17:34:33', 'admin-1481955926-14819672730482071', 1, 1, 'SR', NULL, NULL, NULL),
(15194, '2016-12-17 17:41:24', NULL, NULL, 5262, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 17:41:24', 'admin-1481955926-1481967683904428', 1, 0, '', 1, NULL, NULL),
(15195, '2016-12-17 17:41:24', NULL, NULL, 5262, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 17:41:24', 'admin-1481955926-1481967683904428', 1, 1, 'SR', 1, NULL, NULL),
(15196, '2016-12-17 17:41:24', NULL, NULL, 5262, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 17:41:24', 'admin-1481955926-1481967683904428', 1, 0, '', 1, NULL, NULL),
(15197, '2016-12-17 19:27:16', NULL, NULL, 5269, 0, 181, '116', 'Open Food ', 'Braised Pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:27:16', 'admin-1481969579-14819740366616894', 1, 0, '', NULL, NULL, '10.0'),
(15198, '2016-12-17 19:03:21', NULL, NULL, 5267, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 19:03:21', 'admin-1481969579-14819726008451723', 1, 0, '', NULL, NULL, NULL),
(15199, '2016-12-17 17:41:24', NULL, NULL, 5262, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 17:41:24', 'admin-1481955926-1481967683904428', 1, 1, 'SR', 1, NULL, NULL),
(15200, '2016-12-17 15:29:29', NULL, NULL, 5256, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 15:29:29', 'admin-1481955926-14819597694207445', 1, 0, '', NULL, NULL, NULL),
(15201, '2016-12-17 13:17:21', NULL, NULL, 5247, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 13:17:21', 'admin-1481947331-14819518410002022', 1, 1, 'SR', NULL, NULL, NULL),
(15202, '2016-12-17 13:20:46', NULL, NULL, 5251, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 13:20:46', 'admin-1481947331-14819520463068284', 1, 1, 'SR', NULL, NULL, NULL),
(15203, '2016-12-17 13:20:46', NULL, NULL, 5251, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 13:20:46', 'admin-1481947331-14819520463068284', 1, 1, 'SR', NULL, NULL, NULL),
(15204, '2016-12-17 13:20:46', NULL, NULL, 5251, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 13:20:46', 'admin-1481947331-14819520463068284', 1, 0, '', NULL, NULL, NULL),
(15205, '2016-12-17 12:02:58', NULL, NULL, 5247, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 12:02:58', 'admin-1481947331-14819473786408260', 1, 1, 'SR', NULL, NULL, NULL),
(15206, '2016-12-17 12:02:58', NULL, NULL, 5247, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 12:02:58', 'admin-1481947331-14819473786408260', 1, 0, '', NULL, NULL, NULL),
(15207, '2016-12-17 12:23:17', NULL, NULL, 5248, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 12:23:17', 'admin-1481947331-14819485969456820', 1, 0, '', NULL, NULL, NULL),
(15208, '2016-12-17 12:23:17', NULL, NULL, 5248, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 12:23:17', 'admin-1481947331-14819485969456820', 1, 1, 'SR', NULL, NULL, NULL),
(15209, '2016-12-17 12:53:31', NULL, NULL, 5249, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 12:53:31', 'admin-1481947331-14819504112653554', 1, 0, '', NULL, NULL, NULL),
(15210, '2016-12-17 12:53:31', NULL, NULL, 5249, 0, 85, '85', 'Set Meatless Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 12:53:31', 'admin-1481947331-14819504112653554', 1, 1, 'SR', NULL, NULL, NULL),
(15211, '2016-12-17 13:20:46', NULL, NULL, 5251, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 13:20:46', 'admin-1481947331-14819520463068284', 1, 0, '', NULL, NULL, NULL),
(15212, '2016-12-17 13:06:05', NULL, NULL, 5250, 0, 85, '85', 'Set Meatless Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 13:06:05', 'admin-1481947331-14819511654683755', 1, 1, 'SR', NULL, NULL, NULL),
(15213, '2016-12-17 13:06:05', NULL, NULL, 5250, 0, 85, '85', 'Set Meatless Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 13:06:05', 'admin-1481947331-14819511654683755', 1, 1, 'SR', NULL, NULL, NULL),
(15214, '2016-12-17 12:53:31', NULL, NULL, 5249, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 12:53:31', 'admin-1481947331-14819504112653554', 1, 1, 'SR', NULL, NULL, NULL),
(15215, '2016-12-17 12:02:58', NULL, NULL, 5247, 0, 85, '85', 'Set Meatless Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 12:02:58', 'admin-1481947331-14819473786408260', 1, 1, 'SR', NULL, NULL, NULL),
(15216, '2016-12-17 12:01:51', NULL, NULL, 5247, 0, 181, '116', 'Open Food ', 'Simmered Pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 12:01:51', 'admin-1481937517-14819473114134599', 1, 0, '', NULL, NULL, NULL),
(15217, '2016-12-17 12:01:51', NULL, NULL, 5247, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 12:01:51', 'admin-1481937517-14819473114134599', 1, 1, 'SR', NULL, NULL, NULL),
(15218, '2016-12-17 11:59:28', NULL, NULL, 5247, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 11:59:28', 'admin-1481937517-14819471685186862', 1, 0, '', NULL, NULL, NULL),
(15219, '2016-12-17 10:54:22', NULL, NULL, 5246, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:54:22', 'admin-1481937517-14819432626823947', 1, 0, '', NULL, NULL, '10.0'),
(15220, '2016-12-17 10:54:22', NULL, NULL, 5246, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:54:22', 'admin-1481937517-14819432626823947', 1, 0, '', NULL, NULL, '10.0'),
(15221, '2016-12-17 10:54:31', NULL, NULL, 5246, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:54:31', 'admin-1481937517-14819432708891850', 1, 1, 'SR', NULL, NULL, '10.0'),
(15222, '2016-12-17 10:54:31', NULL, NULL, 5246, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:54:31', 'admin-1481937517-14819432708891850', 1, 1, 'SR', NULL, NULL, '10.0'),
(15223, '2016-12-17 10:15:21', NULL, NULL, 5244, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:15:21', 'admin-1481937517-14819409217044841', 1, 1, 'SR', NULL, NULL, NULL),
(15224, '2016-12-17 10:28:29', NULL, NULL, 5245, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:28:29', 'admin-1481937517-14819417091645659', 1, 0, '', NULL, NULL, NULL),
(15225, '2016-12-17 10:15:21', NULL, NULL, 5244, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:15:21', 'admin-1481937517-14819409217044841', 1, 1, 'SR', NULL, NULL, NULL),
(15226, '2016-12-17 10:15:21', NULL, NULL, 5244, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:15:21', 'admin-1481937517-14819409217044841', 1, 1, 'SR', NULL, NULL, NULL),
(15227, '2016-12-17 10:15:21', NULL, NULL, 5244, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:15:21', 'admin-1481937517-14819409217044841', 1, 1, 'SR', NULL, NULL, NULL),
(15228, '2016-12-17 10:15:10', NULL, NULL, 5244, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:15:10', 'admin-1481937517-14819409100563174', 1, 0, '', NULL, NULL, NULL),
(15229, '2016-12-17 10:15:10', NULL, NULL, 5244, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:15:10', 'admin-1481937517-14819409100563174', 1, 0, '', NULL, NULL, NULL),
(15230, '2016-12-17 10:15:10', NULL, NULL, 5244, 0, 154, '88', 'House BLT', 'egg aside', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:15:10', 'admin-1481937517-14819409100563174', 1, 0, '', NULL, NULL, NULL),
(15231, '2016-12-17 10:15:10', NULL, NULL, 5244, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:15:10', 'admin-1481937517-14819409100563174', 1, 0, '', NULL, NULL, NULL),
(15232, '2016-12-17 10:10:08', NULL, NULL, 5240, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:10:08', 'admin-1481937517-14819406084302398', 1, 1, 'SR', NULL, NULL, NULL),
(15233, '2016-12-17 10:08:19', NULL, NULL, 5243, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:08:19', 'admin-1481937517-14819404989782416', 1, 0, '', NULL, NULL, NULL),
(15234, '2016-12-17 10:09:00', NULL, NULL, 5243, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:09:00', 'admin-1481937517-14819405403088131', 1, 0, '', NULL, NULL, NULL),
(15235, '2016-12-17 10:08:39', NULL, NULL, 5243, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:08:39', 'admin-1481937517-14819405189607475', 1, 1, 'SR', NULL, NULL, NULL),
(15236, '2016-12-17 10:08:39', NULL, NULL, 5243, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:08:39', 'admin-1481937517-14819405189607475', 1, 1, 'SR', NULL, NULL, NULL),
(15237, '2016-12-17 10:08:39', NULL, NULL, 5243, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:08:39', 'admin-1481937517-14819405189607475', 1, 1, 'SR', NULL, NULL, NULL),
(15238, '2016-12-17 10:08:19', NULL, NULL, 5243, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:08:19', 'admin-1481937517-14819404989782416', 1, 0, '', NULL, NULL, NULL),
(15239, '2016-12-17 10:08:19', NULL, NULL, 5243, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:08:19', 'admin-1481937517-14819404989782416', 1, 0, '', NULL, NULL, NULL),
(15240, '2016-12-17 10:08:19', NULL, NULL, 5243, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:08:19', 'admin-1481937517-14819404989782416', 1, 0, '', NULL, NULL, NULL),
(15241, '2016-12-17 10:08:19', NULL, NULL, 5243, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:08:19', 'admin-1481937517-14819404989782416', 1, 0, '', NULL, NULL, NULL),
(15242, '2016-12-17 10:01:04', NULL, NULL, 5242, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:01:04', 'admin-1481937517-14819400640572188', 1, 1, 'SR', NULL, NULL, NULL),
(15243, '2016-12-17 10:01:04', NULL, NULL, 5242, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:01:04', 'admin-1481937517-14819400640572188', 1, 1, 'SR', NULL, NULL, NULL),
(15244, '2016-12-17 10:00:54', NULL, NULL, 5242, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:00:54', 'admin-1481937517-14819400543121612', 1, 0, '', NULL, NULL, NULL),
(15245, '2016-12-17 10:00:54', NULL, NULL, 5242, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 10:00:54', 'admin-1481937517-14819400543121612', 1, 0, '', NULL, NULL, NULL),
(15246, '2016-12-17 09:50:31', NULL, NULL, 5241, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 09:50:31', 'admin-1481937517-14819394312357971', 1, 1, 'SR', NULL, NULL, NULL),
(15247, '2016-12-17 09:50:31', NULL, NULL, 5241, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 09:50:31', 'admin-1481937517-14819394312357971', 1, 1, 'SR', NULL, NULL, NULL),
(15248, '2016-12-17 09:50:14', NULL, NULL, 5241, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 09:50:14', 'admin-1481937517-14819394145989427', 1, 0, '', NULL, NULL, NULL),
(15249, '2016-12-17 09:50:14', NULL, NULL, 5241, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 09:50:14', 'admin-1481937517-14819394145989427', 1, 0, '', NULL, NULL, NULL),
(15250, '2016-12-17 09:30:18', NULL, NULL, 5240, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 09:30:18', 'admin-1481937517-1481938218000807', 1, 1, 'SR', NULL, NULL, NULL),
(15251, '2016-12-17 09:25:21', NULL, NULL, 5240, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 09:25:21', 'admin-1481937517-14819379213548116', 1, 1, 'SR', NULL, NULL, NULL),
(15252, '2016-12-17 09:25:21', NULL, NULL, 5240, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 09:25:21', 'admin-1481937517-14819379213548116', 1, 1, 'SR', NULL, NULL, NULL),
(15253, '2016-12-17 09:25:08', NULL, NULL, 5240, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 09:25:08', 'admin-1481937517-14819379078195645', 1, 0, '', NULL, NULL, NULL),
(15254, '2016-12-17 09:25:08', NULL, NULL, 5240, 0, 153, '87', 'Big Breakfast ', 'sunny side egg', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 09:25:08', 'admin-1481937517-14819379078195645', 1, 0, '', NULL, NULL, NULL),
(15255, '2016-12-17 09:25:08', NULL, NULL, 5240, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 09:25:08', 'admin-1481937517-14819379078195645', 1, 0, '', NULL, NULL, NULL),
(15256, '2016-12-17 09:25:08', NULL, NULL, 5240, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 09:25:08', 'admin-1481937517-14819379078195645', 1, 0, '', NULL, NULL, NULL),
(15257, '2016-12-17 09:20:56', NULL, NULL, 5239, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 09:20:56', 'admin-1481937517-14819376560771578', 1, 0, '', NULL, NULL, NULL),
(15258, '2016-12-17 09:21:32', NULL, NULL, 5239, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 09:21:32', 'admin-1481937517-1481937692761868', 1, 1, 'SR', NULL, NULL, NULL),
(15259, '2016-12-17 09:18:55', NULL, NULL, 5238, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 09:18:55', 'admin-1481937517-14819375357703092', 1, 1, 'SR', NULL, NULL, NULL),
(15260, '2016-12-17 09:18:55', NULL, NULL, 5238, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1481980912', 'admin', '2016-12-17 09:18:55', 'admin-1481937517-14819375357703092', 1, 1, 'SR', NULL, NULL, NULL),
(15261, '2016-12-18 20:17:47', NULL, NULL, 5311, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 20:17:47', 'admin-1482047063-14820634671736664', 1, 1, 'SR', NULL, NULL, NULL),
(15262, '2016-12-18 20:17:47', NULL, NULL, 5311, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 20:17:47', 'admin-1482047063-14820634671736664', 1, 1, 'SR', NULL, NULL, NULL),
(15263, '2016-12-18 20:25:18', NULL, NULL, 5311, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 20:25:18', 'admin-1482047063-14820639182509782', 1, 1, 'SR', NULL, NULL, NULL),
(15264, '2016-12-18 20:28:37', NULL, NULL, 5312, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 20:28:37', 'admin-1482047063-14820641168113779', 1, 1, 'SR', 1, NULL, NULL),
(15265, '2016-12-18 20:28:37', NULL, NULL, 5312, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 20:28:37', 'admin-1482047063-14820641168113779', 1, 1, 'SR', 1, NULL, NULL),
(15266, '2016-12-18 19:09:04', NULL, NULL, 5308, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 19:09:04', 'admin-1482047063-14820593439478719', 1, 0, '', NULL, NULL, NULL),
(15267, '2016-12-18 19:09:04', NULL, NULL, 5308, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 19:09:04', 'admin-1482047063-14820593439478719', 1, 1, 'SR', NULL, NULL, NULL),
(15268, '2016-12-18 19:35:02', NULL, NULL, 5309, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 19:35:02', 'admin-1482047063-14820609019296358', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(15269, '2016-12-18 19:35:02', NULL, NULL, 5309, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 19:35:02', 'admin-1482047063-14820609019296358', 1, 0, '', NULL, NULL, NULL),
(15270, '2016-12-18 11:57:50', NULL, NULL, 5290, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:57:50', 'admin-1482031800-14820334700477696', 1, 0, '', NULL, NULL, NULL),
(15271, '2016-12-18 12:51:06', NULL, NULL, 5291, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 12:51:06', 'admin-1482031800-14820366665925952', 1, 1, 'SR', NULL, NULL, NULL),
(15272, '2016-12-18 12:51:06', NULL, NULL, 5291, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 12:51:06', 'admin-1482031800-14820366665925952', 1, 1, 'SR', NULL, NULL, NULL),
(15273, '2016-12-18 13:15:22', NULL, NULL, 5292, 0, 245, '179', 'Set Spicy Lemony Chicken Wing', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 13:15:22', 'admin-1482038105-14820381218321797', 1, 0, '', NULL, NULL, NULL),
(15274, '2016-12-18 13:15:22', NULL, NULL, 5292, 0, 214, '148', 'Set Fried Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 13:15:22', 'admin-1482038105-14820381218321797', 1, 0, '', NULL, NULL, NULL),
(15275, '2016-12-18 13:15:22', NULL, NULL, 5292, 0, 82, '82', 'Set Stir Fried Rice Wine Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 13:15:22', 'admin-1482038105-14820381218321797', 1, 1, 'SR', NULL, NULL, NULL),
(15276, '2016-12-18 13:15:22', NULL, NULL, 5292, 0, 82, '82', 'Set Stir Fried Rice Wine Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 13:15:22', 'admin-1482038105-14820381218321797', 1, 1, 'SR', NULL, NULL, NULL),
(15277, '2016-12-18 20:17:47', NULL, NULL, 5311, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 20:17:47', 'admin-1482047063-14820634671736664', 1, 1, 'SR', NULL, NULL, NULL),
(15278, '2016-12-18 20:17:47', NULL, NULL, 5311, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 20:17:47', 'admin-1482047063-14820634671736664', 1, 0, '', NULL, NULL, NULL),
(15279, '2016-12-18 15:54:34', NULL, NULL, 5304, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:54:34', 'admin-1482047063-14820476743028887', 1, 1, 'SR', NULL, NULL, NULL),
(15280, '2016-12-18 17:41:22', NULL, NULL, 5305, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 17:41:22', 'admin-1482047063-14820540827507384', 1, 1, 'SR', NULL, NULL, NULL),
(15281, '2016-12-18 17:41:22', NULL, NULL, 5305, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 17:41:22', 'admin-1482047063-14820540827507384', 1, 1, 'SR', NULL, NULL, NULL),
(15282, '2016-12-18 17:46:24', NULL, NULL, 5306, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 17:46:24', 'admin-1482047063-1482054384396901', 1, 1, 'SR', NULL, NULL, NULL),
(15283, '2016-12-18 17:46:24', NULL, NULL, 5306, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 17:46:24', 'admin-1482047063-1482054384396901', 1, 1, 'SR', NULL, NULL, NULL),
(15284, '2016-12-18 17:53:20', NULL, NULL, 5307, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 17:53:20', 'admin-1482047063-14820548007818198', 1, 1, 'SR', NULL, NULL, NULL),
(15285, '2016-12-18 17:53:20', NULL, NULL, 5307, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 17:53:20', 'admin-1482047063-14820548007818198', 1, 1, 'SR', NULL, NULL, NULL),
(15286, '2016-12-18 13:19:46', NULL, NULL, 5294, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 13:19:46', 'admin-1482038105-1482038386549610', 1, 1, 'SR', NULL, NULL, NULL),
(15287, '2016-12-18 13:24:59', NULL, NULL, 5293, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 13:24:59', 'admin-1482038105-14820386990641783', 1, 0, '', NULL, NULL, NULL),
(15288, '2016-12-18 13:33:35', NULL, NULL, 5295, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 13:33:35', 'admin-1482038105-14820392149396268', 1, 0, '', NULL, NULL, NULL),
(15289, '2016-12-18 14:47:41', NULL, NULL, 5296, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 14:47:41', 'admin-1482043163-14820436614366010', 1, 1, 'SR', NULL, NULL, NULL),
(15290, '2016-12-18 14:53:45', NULL, NULL, 5299, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 14:53:45', 'admin-1482043163-14820440249756913', 1, 0, '', NULL, NULL, NULL),
(15291, '2016-12-18 14:53:45', NULL, NULL, 5299, 0, 85, '85', 'Set Meatless Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 14:53:45', 'admin-1482043163-14820440249756913', 1, 1, 'SR', NULL, NULL, NULL),
(15292, '2016-12-18 14:53:45', NULL, NULL, 5299, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 14:53:45', 'admin-1482043163-14820440249756913', 1, 1, 'SR', NULL, NULL, NULL),
(15293, '2016-12-18 19:53:22', NULL, NULL, 5310, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 19:53:22', 'admin-1482047063-14820620023074919', 1, 1, 'SR', NULL, NULL, NULL),
(15294, '2016-12-18 19:53:22', NULL, NULL, 5310, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 19:53:22', 'admin-1482047063-14820620023074919', 1, 0, '', NULL, NULL, NULL),
(15295, '2016-12-18 19:51:00', NULL, NULL, 5309, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 19:51:00', 'admin-1482047063-1482061859973164', 1, 1, 'SR', NULL, NULL, NULL),
(15296, '2016-12-18 19:35:02', NULL, NULL, 5309, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 19:35:02', 'admin-1482047063-14820609019296358', 1, 1, 'SR', NULL, NULL, NULL),
(15297, '2016-12-18 15:02:13', NULL, NULL, 5300, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:02:13', 'admin-1482043163-14820445333883934', 1, 0, '', NULL, NULL, NULL),
(15298, '2016-12-18 15:02:13', NULL, NULL, 5300, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:02:13', 'admin-1482043163-14820445333883934', 1, 0, '', NULL, NULL, NULL),
(15299, '2016-12-18 15:04:56', NULL, NULL, 5300, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:04:56', 'admin-1482043163-14820446964511929', 1, 1, 'SR', NULL, NULL, NULL),
(15300, '2016-12-18 15:04:56', NULL, NULL, 5300, 0, 181, '116', 'Open Food ', 'esp shot', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:04:56', 'admin-1482043163-14820446964511929', 1, 0, '', NULL, NULL, NULL),
(15301, '2016-12-18 15:07:30', NULL, NULL, 5298, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:07:30', 'admin-1482043163-14820448503552497', 1, 0, '', NULL, NULL, NULL),
(15302, '2016-12-18 15:18:21', NULL, NULL, 5301, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:18:21', 'admin-1482043163-14820455009139566', 1, 1, 'SR', NULL, NULL, NULL),
(15303, '2016-12-18 15:18:21', NULL, NULL, 5301, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:18:21', 'admin-1482043163-14820455009139566', 1, 0, '', NULL, NULL, NULL),
(15304, '2016-12-18 15:24:41', NULL, NULL, 5302, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:24:41', 'admin-1482043163-14820458809013913', 1, 0, '', NULL, NULL, NULL),
(15305, '2016-12-18 15:24:41', NULL, NULL, 5302, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:24:41', 'admin-1482043163-14820458809013913', 1, 1, 'SR', NULL, NULL, NULL),
(15306, '2016-12-18 15:24:55', NULL, NULL, 5302, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:24:55', 'admin-1482043163-14820458956213259', 1, 1, 'SR', NULL, NULL, NULL),
(15307, '2016-12-18 15:24:55', NULL, NULL, 5302, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:24:55', 'admin-1482043163-14820458956213259', 1, 1, 'SR', NULL, NULL, NULL),
(15308, '2016-12-18 15:31:52', NULL, NULL, 5303, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:31:52', 'admin-1482043163-1482046311936535', 1, 1, 'SR', NULL, NULL, NULL),
(15309, '2016-12-18 15:31:52', NULL, NULL, 5303, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:31:52', 'admin-1482043163-1482046311936535', 1, 1, 'SR', NULL, NULL, NULL),
(15310, '2016-12-18 15:31:52', NULL, NULL, 5303, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:31:52', 'admin-1482043163-1482046311936535', 1, 1, 'SR', NULL, NULL, NULL),
(15311, '2016-12-18 15:31:52', NULL, NULL, 5303, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:31:52', 'admin-1482043163-1482046311936535', 1, 1, 'SR', NULL, NULL, NULL),
(15312, '2016-12-18 15:31:52', NULL, NULL, 5303, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:31:52', 'admin-1482043163-1482046311936535', 1, 1, 'SR', NULL, NULL, NULL),
(15313, '2016-12-18 15:31:52', NULL, NULL, 5303, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:31:52', 'admin-1482043163-1482046311936535', 1, 0, '', NULL, NULL, NULL),
(15314, '2016-12-18 15:44:14', NULL, NULL, 5302, 0, 181, '116', 'Open Food ', '1 macadamia scone', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:44:14', 'admin-1482043163-14820470547869654', 1, 0, '', NULL, NULL, NULL),
(15315, '2016-12-18 15:44:41', NULL, NULL, 5300, 0, 177, '112', 'Scones Set ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:44:41', 'admin-1482047063-14820470809771635', 1, 0, '', NULL, NULL, NULL),
(15316, '2016-12-18 15:50:38', NULL, NULL, 5302, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:50:38', 'admin-1482047063-14820474383522163', 1, 0, '', NULL, NULL, NULL),
(15317, '2016-12-18 15:52:28', NULL, NULL, 5302, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:52:28', 'admin-1482047063-14820475487211527', 1, 1, 'SR', NULL, NULL, NULL),
(15318, '2016-12-18 15:52:28', NULL, NULL, 5302, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:52:28', 'admin-1482047063-14820475487211527', 1, 1, 'SR', NULL, NULL, NULL),
(15319, '2016-12-18 11:29:47', NULL, NULL, 5286, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:29:47', 'admin-1482027003-14820317869064682', 1, 0, '', NULL, NULL, NULL),
(15320, '2016-12-18 11:29:47', NULL, NULL, 5286, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:29:47', 'admin-1482027003-14820317869064682', 1, 0, '', NULL, NULL, NULL),
(15321, '2016-12-18 11:30:13', NULL, NULL, 5286, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:30:13', 'admin-1482031800-14820318136762227', 1, 1, 'SR', NULL, NULL, NULL),
(15322, '2016-12-18 11:30:13', NULL, NULL, 5286, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:30:13', 'admin-1482031800-14820318136762227', 1, 0, '', NULL, NULL, NULL),
(15323, '2016-12-18 11:30:13', NULL, NULL, 5286, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:30:13', 'admin-1482031800-14820318136762227', 1, 1, 'SR', NULL, NULL, NULL),
(15324, '2016-12-18 11:19:18', NULL, NULL, 5285, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:19:18', 'admin-1482027003-14820311584192950', 1, 0, '', NULL, NULL, NULL),
(15325, '2016-12-18 11:19:18', NULL, NULL, 5285, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:19:18', 'admin-1482027003-14820311584192950', 1, 0, '', NULL, NULL, NULL),
(15326, '2016-12-18 11:19:18', NULL, NULL, 5285, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:19:18', 'admin-1482027003-14820311584192950', 1, 0, '', NULL, NULL, NULL),
(15327, '2016-12-18 11:19:35', NULL, NULL, 5285, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:19:35', 'admin-1482027003-148203117536538', 1, 1, 'SR', NULL, NULL, NULL),
(15328, '2016-12-18 19:09:04', NULL, NULL, 5308, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 19:09:04', 'admin-1482047063-14820593439478719', 1, 1, 'SR', NULL, NULL, NULL),
(15329, '2016-12-18 13:16:16', NULL, NULL, 5293, 0, 82, '82', 'Set Stir Fried Rice Wine Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 13:16:16', 'admin-1482038105-14820381759156426', 1, 1, 'SR', NULL, NULL, NULL),
(15330, '2016-12-18 13:16:16', NULL, NULL, 5293, 0, 85, '85', 'Set Meatless Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 13:16:16', 'admin-1482038105-14820381759156426', 1, 1, 'SR', NULL, NULL, NULL),
(15331, '2016-12-18 13:16:16', NULL, NULL, 5293, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 13:16:16', 'admin-1482038105-14820381759156426', 1, 0, '', NULL, NULL, NULL),
(15332, '2016-12-18 14:06:40', NULL, NULL, 5296, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 14:06:40', 'admin-1482038105-14820412003508365', 1, 0, '', NULL, NULL, NULL),
(15333, '2016-12-18 14:27:06', NULL, NULL, 5297, 0, 214, '148', 'Set Fried Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 14:27:06', 'admin-1482038105-14820424261602061', 1, 0, '', NULL, NULL, NULL),
(15334, '2016-12-18 14:27:06', NULL, NULL, 5297, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 14:27:06', 'admin-1482038105-14820424261602061', 1, 1, 'SR', NULL, NULL, NULL),
(15335, '2016-12-18 14:27:06', NULL, NULL, 5297, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 14:27:06', 'admin-1482038105-14820424261602061', 1, 0, '', NULL, NULL, NULL),
(15336, '2016-12-18 14:39:10', NULL, NULL, 5298, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 14:39:10', 'admin-1482038105-1482043150593233', 1, 1, 'SR', NULL, NULL, NULL),
(15337, '2016-12-18 14:39:10', NULL, NULL, 5298, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 14:39:10', 'admin-1482038105-1482043150593233', 1, 0, '', NULL, NULL, NULL),
(15338, '2016-12-18 14:40:33', NULL, NULL, 5298, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 14:40:33', 'admin-1482043163-14820432333481789', 1, 1, 'SR', NULL, NULL, NULL),
(15339, '2016-12-18 14:40:33', NULL, NULL, 5298, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 14:40:33', 'admin-1482043163-14820432333481789', 1, 1, 'SR', NULL, NULL, NULL),
(15340, '2016-12-18 14:40:33', NULL, NULL, 5298, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 14:40:33', 'admin-1482043163-14820432333481789', 1, 1, 'SR', NULL, NULL, NULL),
(15341, '2016-12-18 14:46:37', NULL, NULL, 5296, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 14:46:37', 'admin-1482043163-14820435974727138', 1, 1, 'SR', NULL, NULL, NULL),
(15342, '2016-12-18 14:46:37', NULL, NULL, 5296, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 14:46:37', 'admin-1482043163-14820435974727138', 1, 1, 'SR', NULL, NULL, NULL),
(15343, '2016-12-18 15:02:13', NULL, NULL, 5300, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:02:13', 'admin-1482043163-14820445333883934', 1, 0, '', NULL, NULL, NULL),
(15344, '2016-12-18 15:02:13', NULL, NULL, 5300, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:02:13', 'admin-1482043163-14820445333883934', 1, 1, 'SR', NULL, NULL, NULL),
(15345, '2016-12-18 15:02:13', NULL, NULL, 5300, 0, 85, '85', 'Set Meatless Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 15:02:13', 'admin-1482043163-14820445333883934', 1, 1, 'SR', NULL, NULL, NULL),
(15346, '2016-12-18 14:06:40', NULL, NULL, 5296, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 14:06:40', 'admin-1482038105-14820412003508365', 1, 1, 'SR', NULL, NULL, NULL),
(15347, '2016-12-18 13:19:46', NULL, NULL, 5294, 0, 82, '82', 'Set Stir Fried Rice Wine Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 13:19:46', 'admin-1482038105-1482038386549610', 1, 1, 'SR', NULL, NULL, NULL),
(15348, '2016-12-18 11:54:31', NULL, NULL, 5289, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:54:31', 'admin-1482031800-1482033271518183', 1, 1, 'SR', NULL, NULL, NULL),
(15349, '2016-12-18 11:54:31', NULL, NULL, 5289, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:54:31', 'admin-1482031800-1482033271518183', 1, 1, 'SR', NULL, NULL, NULL),
(15350, '2016-12-18 11:54:31', NULL, NULL, 5289, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:54:31', 'admin-1482031800-1482033271518183', 1, 1, 'SR', NULL, NULL, NULL),
(15351, '2016-12-18 11:47:58', NULL, NULL, 5288, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:47:58', 'admin-1482031800-14820328779235633', 1, 0, '', NULL, NULL, NULL),
(15352, '2016-12-18 11:47:58', NULL, NULL, 5288, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:47:58', 'admin-1482031800-14820328779235633', 1, 1, 'SR', NULL, NULL, NULL),
(15353, '2016-12-18 11:47:58', NULL, NULL, 5288, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:47:58', 'admin-1482031800-14820328779235633', 1, 0, '', NULL, NULL, NULL),
(15354, '2016-12-18 11:47:58', NULL, NULL, 5288, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:47:58', 'admin-1482031800-14820328779235633', 1, 1, 'SR', NULL, NULL, NULL),
(15355, '2016-12-18 11:47:58', NULL, NULL, 5288, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:47:58', 'admin-1482031800-14820328779235633', 1, 1, 'SR', NULL, NULL, NULL),
(15356, '2016-12-18 11:47:40', NULL, NULL, 5288, 0, 153, '87', 'Big Breakfast ', 'no bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:47:40', 'admin-1482031800-1482032860303857', 1, 0, '', NULL, NULL, NULL),
(15357, '2016-12-18 11:47:40', NULL, NULL, 5288, 0, 153, '87', 'Big Breakfast ', 'no bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:47:40', 'admin-1482031800-1482032860303857', 1, 0, '', NULL, NULL, NULL),
(15358, '2016-12-18 11:47:40', NULL, NULL, 5288, 0, 153, '87', 'Big Breakfast ', 'no bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:47:40', 'admin-1482031800-1482032860303857', 1, 0, '', NULL, NULL, NULL),
(15359, '2016-12-18 11:47:40', NULL, NULL, 5288, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:47:40', 'admin-1482031800-1482032860303857', 1, 0, '', NULL, NULL, NULL),
(15360, '2016-12-18 11:47:40', NULL, NULL, 5288, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:47:40', 'admin-1482031800-1482032860303857', 1, 0, '', NULL, NULL, NULL),
(15361, '2016-12-18 11:40:17', NULL, NULL, 5287, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:40:17', 'admin-1482031800-14820324168476171', 1, 1, 'SR', NULL, NULL, NULL),
(15362, '2016-12-18 11:40:17', NULL, NULL, 5287, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:40:17', 'admin-1482031800-14820324168476171', 1, 1, 'SR', NULL, NULL, NULL),
(15363, '2016-12-18 11:31:06', NULL, NULL, 5286, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:31:06', 'admin-1482031800-14820318667419226', 1, 0, '', NULL, NULL, NULL),
(15364, '2016-12-18 11:19:35', NULL, NULL, 5285, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:19:35', 'admin-1482027003-148203117536538', 1, 1, 'SR', NULL, NULL, NULL),
(15365, '2016-12-18 11:19:35', NULL, NULL, 5285, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:19:35', 'admin-1482027003-148203117536538', 1, 0, '', NULL, NULL, NULL),
(15366, '2016-12-18 11:09:57', NULL, NULL, 5284, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:09:57', 'admin-1482027003-14820305969404999', 1, 1, 'SR', NULL, NULL, NULL),
(15367, '2016-12-18 11:02:55', NULL, NULL, 5282, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 11:02:55', 'admin-1482027003-14820301753957919', 1, 1, 'SR', NULL, NULL, NULL),
(15368, '2016-12-18 10:41:33', NULL, NULL, 5283, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:41:33', 'admin-1482027003-14820288934791518', 1, 0, '', NULL, NULL, NULL),
(15369, '2016-12-18 10:41:33', NULL, NULL, 5283, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:41:33', 'admin-1482027003-14820288934791518', 1, 1, 'SR', NULL, NULL, NULL),
(15370, '2016-12-18 10:31:28', NULL, NULL, 5282, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:31:28', 'admin-1482027003-14820282885144294', 1, 0, '', NULL, NULL, NULL),
(15371, '2016-12-18 10:31:39', NULL, NULL, 5282, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:31:39', 'admin-1482027003-14820282994649872', 1, 1, 'SR', NULL, NULL, NULL),
(15372, '2016-12-18 10:41:11', NULL, NULL, 5283, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:41:11', 'admin-1482027003-14820288712347399', 1, 0, '', NULL, NULL, NULL),
(15373, '2016-12-18 10:41:11', NULL, NULL, 5283, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:41:11', 'admin-1482027003-14820288712347399', 1, 0, '', NULL, NULL, NULL),
(15374, '2016-12-18 10:10:32', NULL, NULL, 5280, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:10:32', 'admin-1482027003-14820270327259876', 1, 1, 'SR', NULL, NULL, NULL),
(15375, '2016-12-18 10:31:28', NULL, NULL, 5282, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:31:28', 'admin-1482027003-14820282885144294', 1, 0, '', NULL, NULL, NULL),
(15376, '2016-12-18 10:23:56', NULL, NULL, 5278, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:23:56', 'admin-1482027003-14820278366851211', 1, 1, 'SR', NULL, NULL, NULL),
(15377, '2016-12-18 10:23:56', NULL, NULL, 5278, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:23:56', 'admin-1482027003-14820278366851211', 1, 1, 'SR', NULL, NULL, NULL),
(15378, '2016-12-18 10:23:38', NULL, NULL, 5278, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:23:38', 'admin-1482027003-14820278182046665', 1, 0, '', NULL, NULL, NULL),
(15379, '2016-12-18 10:15:01', NULL, NULL, 5281, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:15:01', 'admin-1482027003-14820273015219453', 1, 1, 'SR', NULL, NULL, NULL),
(15380, '2016-12-18 10:14:52', NULL, NULL, 5281, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:14:52', 'admin-1482027003-14820272926341562', 1, 0, '', NULL, NULL, NULL),
(15381, '2016-12-18 10:14:52', NULL, NULL, 5281, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:14:52', 'admin-1482027003-14820272926341562', 1, 0, '', NULL, NULL, NULL),
(15382, '2016-12-18 10:10:32', NULL, NULL, 5280, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:10:32', 'admin-1482027003-14820270327259876', 1, 1, 'SR', NULL, NULL, NULL),
(15383, '2016-12-18 10:04:35', NULL, NULL, 5279, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:04:35', 'admin-1482023117-14820266752587825', 1, 1, 'SR', NULL, NULL, NULL),
(15384, '2016-12-18 10:09:26', NULL, NULL, 5280, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:09:26', 'admin-1482023117-14820269664311357', 1, 0, '', NULL, NULL, NULL),
(15385, '2016-12-18 10:09:26', NULL, NULL, 5280, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:09:26', 'admin-1482023117-14820269664311357', 1, 0, '', NULL, NULL, NULL),
(15386, '2016-12-18 10:09:26', NULL, NULL, 5280, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:09:26', 'admin-1482023117-14820269664311357', 1, 0, '', NULL, NULL, NULL),
(15387, '2016-12-18 10:04:35', NULL, NULL, 5279, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:04:35', 'admin-1482023117-14820266752587825', 1, 0, '', NULL, NULL, NULL),
(15388, '2016-12-18 10:04:35', NULL, NULL, 5279, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:04:35', 'admin-1482023117-14820266752587825', 1, 1, 'SR', NULL, NULL, NULL),
(15389, '2016-12-18 10:04:27', NULL, NULL, 5279, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:04:27', 'admin-1482023117-14820266677922571', 1, 0, '', NULL, NULL, NULL),
(15390, '2016-12-18 10:04:27', NULL, NULL, 5279, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:04:27', 'admin-1482023117-14820266677922571', 1, 0, '', NULL, NULL, NULL),
(15391, '2016-12-18 09:58:50', NULL, NULL, 5278, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 09:58:50', 'admin-1482023117-14820263304729987', 1, 0, '', NULL, NULL, NULL),
(15392, '2016-12-18 10:04:27', NULL, NULL, 5279, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 10:04:27', 'admin-1482023117-14820266677922571', 1, 0, '', NULL, NULL, NULL),
(15393, '2016-12-18 09:58:50', NULL, NULL, 5278, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 09:58:50', 'admin-1482023117-14820263304729987', 1, 1, 'SR', NULL, NULL, NULL),
(15394, '2016-12-18 09:54:41', NULL, NULL, 5277, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 09:54:41', 'admin-1482023117-14820260817683737', 1, 1, 'SR', NULL, NULL, NULL),
(15395, '2016-12-18 09:49:16', NULL, NULL, 5277, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 09:49:16', 'admin-1482023117-14820257558489677', 1, 0, '', NULL, NULL, NULL),
(15396, '2016-12-18 09:49:16', NULL, NULL, 5277, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 09:49:16', 'admin-1482023117-14820257558489677', 1, 0, '', NULL, NULL, NULL),
(15397, '2016-12-18 09:43:56', NULL, NULL, 5276, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 09:43:56', 'admin-1482023117-14820254364433147', 1, 0, '', NULL, NULL, NULL),
(15398, '2016-12-18 09:41:50', NULL, NULL, 5276, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 09:41:50', 'admin-1482023117-14820253101146410', 1, 0, '', NULL, NULL, NULL),
(15399, '2016-12-18 09:29:56', NULL, NULL, 5275, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 09:29:56', 'admin-1482023117-14820245960976030', 1, 1, 'SR', NULL, NULL, NULL),
(15400, '2016-12-18 09:29:56', NULL, NULL, 5275, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 09:29:56', 'admin-1482023117-14820245960976030', 1, 1, 'SR', NULL, NULL, NULL),
(15401, '2016-12-18 09:29:56', NULL, NULL, 5275, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 09:29:56', 'admin-1482023117-14820245960976030', 1, 1, 'SR', NULL, NULL, NULL),
(15402, '2016-12-18 09:29:20', NULL, NULL, 5275, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 09:29:20', 'admin-1482023117-14820245604082456', 1, 1, 'SR', NULL, NULL, NULL),
(15403, '2016-12-18 09:29:20', NULL, NULL, 5275, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 09:29:20', 'admin-1482023117-14820245604082456', 1, 0, '', NULL, NULL, NULL),
(15404, '2016-12-18 09:29:20', NULL, NULL, 5275, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 09:29:20', 'admin-1482023117-14820245604082456', 1, 0, '', NULL, NULL, NULL),
(15405, '2016-12-18 09:29:20', NULL, NULL, 5275, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 09:29:20', 'admin-1482023117-14820245604082456', 1, 0, '', NULL, NULL, NULL),
(15406, '2016-12-18 09:14:21', NULL, NULL, 5274, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 09:14:21', 'admin-1482023117-14820236612219963', 1, 0, '', NULL, NULL, NULL),
(15407, '2016-12-18 09:14:21', NULL, NULL, 5274, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 09:14:21', 'admin-1482023117-14820236612219963', 1, 0, '', NULL, NULL, NULL),
(15408, '2016-12-18 09:24:30', NULL, NULL, 5274, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 09:24:30', 'admin-1482023117-1482024269937969', 1, 1, 'SR', NULL, NULL, NULL),
(15409, '2016-12-18 09:24:30', NULL, NULL, 5274, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 09:24:30', 'admin-1482023117-1482024269937969', 1, 1, 'SR', NULL, NULL, NULL),
(15410, '2016-12-18 09:05:37', NULL, NULL, 5273, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 09:05:37', 'admin-1482023117-14820231371864443', 1, 1, 'SR', NULL, NULL, NULL),
(15411, '2016-12-18 09:05:37', NULL, NULL, 5273, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482047063', 'admin', '2016-12-18 09:05:37', 'admin-1482023117-14820231371864443', 1, 1, 'SR', NULL, NULL, NULL),
(15412, '2016-12-19 19:20:59', NULL, NULL, 5340, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 19:20:59', 'admin-1482143290-14821464597549173', 1, 0, '', NULL, NULL, NULL),
(15413, '2016-12-19 15:15:32', NULL, NULL, 5334, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 15:15:32', 'admin-1482123243-14821317318821364', 1, 1, 'SR', NULL, NULL, NULL),
(15414, '2016-12-19 15:18:50', NULL, NULL, 5335, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 15:18:50', 'admin-1482123243-14821319308323420', 1, 1, 'SR', NULL, NULL, NULL),
(15415, '2016-12-19 16:02:22', NULL, NULL, 5336, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 16:02:22', 'admin-1482123243-14821345425742435', 1, 1, 'SR', NULL, NULL, NULL),
(15416, '2016-12-19 16:57:55', NULL, NULL, 5337, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 16:57:55', 'admin-1482123243-14821378757597325', 1, 0, '', NULL, NULL, NULL),
(15417, '2016-12-19 16:57:56', NULL, NULL, 5337, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 16:57:56', 'admin-1482123243-14821378757597325', 1, 1, 'SR', NULL, NULL, NULL),
(15418, '2016-12-19 16:57:56', NULL, NULL, 5337, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 16:57:56', 'admin-1482123243-14821378757597325', 1, 1, 'SR', NULL, NULL, NULL),
(15419, '2016-12-19 18:02:04', NULL, NULL, 5338, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 18:02:04', 'admin-1482123243-1482141724302658', 1, 1, 'SR', 1, NULL, NULL),
(15420, '2016-12-19 18:02:04', NULL, NULL, 5338, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 18:02:04', 'admin-1482123243-1482141724302658', 1, 1, 'SR', 1, NULL, NULL),
(15421, '2016-12-19 18:02:04', NULL, NULL, 5338, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 18:02:04', 'admin-1482123243-1482141724302658', 1, 1, 'SR', 1, NULL, NULL),
(15422, '2016-12-19 18:02:04', NULL, NULL, 5338, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 18:02:04', 'admin-1482123243-1482141724302658', 1, 1, 'SR', 1, NULL, NULL),
(15423, '2016-12-19 18:57:02', NULL, NULL, 5340, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 18:57:02', 'admin-1482143290-14821450221226725', 1, 0, '', NULL, NULL, NULL),
(15424, '2016-12-19 18:28:24', NULL, NULL, 5339, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 18:28:24', 'admin-1482143290-1482143303868156', 1, 1, 'SR', 1, NULL, NULL),
(15425, '2016-12-19 13:21:51', NULL, NULL, 5327, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 13:21:51', 'admin-1482123243-14821249111674465', 1, 0, '', NULL, NULL, NULL),
(15426, '2016-12-19 13:56:21', NULL, NULL, 5329, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 13:56:21', 'admin-1482123243-14821269811077586', 1, 0, '', NULL, NULL, NULL),
(15427, '2016-12-19 00:00:00', NULL, NULL, 5330, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 13:19:18', 'admin-1482123243-14821247580537672', 1, 0, '', NULL, NULL, NULL),
(15428, '2016-12-19 14:50:17', NULL, NULL, 5333, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 14:50:17', 'admin-1482123243-14821302172518566', 1, 1, 'SR', NULL, NULL, NULL),
(15429, '2016-12-19 14:51:51', NULL, NULL, 5329, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 14:51:51', 'admin-1482123243-14821303110431016', 1, 1, 'SR', NULL, NULL, NULL),
(15430, '2016-12-19 15:15:32', NULL, NULL, 5334, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 15:15:32', 'admin-1482123243-14821317318821364', 1, 1, 'SR', NULL, NULL, NULL),
(15431, '2016-12-19 13:15:33', NULL, NULL, 5327, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 13:15:33', 'admin-1482123243-14821245328433920', 1, 0, '', NULL, NULL, NULL),
(15432, '2016-12-19 13:15:33', NULL, NULL, 5327, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 13:15:33', 'admin-1482123243-14821245328433920', 1, 1, 'SR', NULL, NULL, NULL),
(15433, '2016-12-19 14:15:39', NULL, NULL, 5332, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 14:15:39', 'admin-1482123243-14821281392829384', 1, 1, 'SR', NULL, NULL, NULL),
(15434, '2016-12-19 00:00:00', NULL, NULL, 5331, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 13:19:18', 'admin-1482123243-14821247580537672', 1, 0, '', NULL, NULL, NULL),
(15435, '2016-12-19 13:21:51', NULL, NULL, 5327, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 13:21:51', 'admin-1482123243-14821249111674465', 1, 0, '', NULL, NULL, NULL),
(15436, '2016-12-19 13:21:51', NULL, NULL, 5327, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 13:21:51', 'admin-1482123243-14821249111674465', 1, 0, '', NULL, NULL, NULL),
(15437, '2016-12-19 13:15:33', NULL, NULL, 5327, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 13:15:33', 'admin-1482123243-14821245328433920', 1, 1, 'SR', NULL, NULL, NULL),
(15438, '2016-12-19 13:13:26', NULL, NULL, 5326, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 13:13:26', 'admin-1482123243-14821244061895742', 1, 1, 'SR', NULL, NULL, NULL),
(15439, '2016-12-19 12:54:30', NULL, NULL, 5325, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 12:54:30', 'admin-1482123243-14821232698714124', 1, 1, 'SR', NULL, NULL, NULL),
(15440, '2016-12-19 12:54:19', NULL, NULL, 5324, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 12:54:19', 'admin-1482123243-148212325957527', 1, 1, 'SR', NULL, NULL, NULL),
(15441, '2016-12-19 12:54:19', NULL, NULL, 5324, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 12:54:19', 'admin-1482123243-148212325957527', 1, 1, 'SR', NULL, NULL, NULL),
(15442, '2016-12-19 12:54:19', NULL, NULL, 5324, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 12:54:19', 'admin-1482123243-148212325957527', 1, 1, 'SR', NULL, NULL, NULL),
(15443, '2016-12-19 12:53:35', NULL, NULL, 5324, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 12:53:35', 'admin-1482108039-14821232152331313', 1, 1, 'SR', NULL, NULL, NULL),
(15444, '2016-12-19 12:53:35', NULL, NULL, 5324, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 12:53:35', 'admin-1482108039-14821232152331313', 1, 0, '', NULL, NULL, NULL),
(15445, '2016-12-19 12:53:35', NULL, NULL, 5324, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 12:53:35', 'admin-1482108039-14821232152331313', 1, 0, '', NULL, NULL, NULL),
(15446, '2016-12-19 12:44:27', NULL, NULL, 5318, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 12:44:27', 'admin-1482108039-14821226672333122', 1, 1, 'SR', NULL, NULL, NULL),
(15447, '2016-12-19 12:24:23', NULL, NULL, 5323, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 12:24:23', 'admin-1482108039-14821214633013141', 1, 1, 'SR', NULL, NULL, NULL),
(15448, '2016-12-19 12:24:23', NULL, NULL, 5323, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 12:24:23', 'admin-1482108039-14821214633013141', 1, 1, 'SR', NULL, NULL, NULL),
(15449, '2016-12-19 12:24:23', NULL, NULL, 5323, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 12:24:23', 'admin-1482108039-14821214633013141', 1, 0, '', NULL, NULL, NULL),
(15450, '2016-12-19 12:24:23', NULL, NULL, 5323, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 12:24:23', 'admin-1482108039-14821214633013141', 1, 0, '', NULL, NULL, NULL),
(15451, '2016-12-19 12:24:23', NULL, NULL, 5323, 0, 224, '158', 'Set Stir Fried  Garlic Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 12:24:23', 'admin-1482108039-14821214633013141', 1, 0, '', NULL, NULL, NULL),
(15452, '2016-12-19 11:46:48', NULL, NULL, 5321, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 11:46:48', 'admin-1482108039-14821192086872680', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(15453, '2016-12-19 12:02:48', NULL, NULL, 5322, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 12:02:48', 'admin-1482108039-14821201681605123', 1, 1, 'SR', 1, NULL, NULL),
(15454, '2016-12-19 11:44:13', NULL, NULL, 5320, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 11:44:13', 'admin-1482108039-14821190532109586', 1, 1, 'SR', NULL, NULL, NULL),
(15455, '2016-12-19 11:36:54', NULL, NULL, 5319, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 11:36:54', 'admin-1482108039-14821186141333227', 1, 0, '', 1, NULL, NULL),
(15456, '2016-12-19 11:36:54', NULL, NULL, 5319, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 11:36:54', 'admin-1482108039-14821186141333227', 1, 1, 'SR', 1, NULL, NULL),
(15457, '2016-12-19 11:36:54', NULL, NULL, 5319, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 11:36:54', 'admin-1482108039-14821186141333227', 1, 1, 'SR', 1, NULL, NULL),
(15458, '2016-12-19 11:28:26', NULL, NULL, 5318, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 11:28:26', 'admin-1482108039-14821181060647356', 1, 0, '', NULL, NULL, NULL),
(15459, '2016-12-19 10:07:58', NULL, NULL, 5316, 0, 181, '116', 'Open Food ', 'sunny side up', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 10:07:58', 'admin-1482108039-14821132778809292', 1, 0, '', NULL, NULL, NULL),
(15460, '2016-12-19 10:24:30', NULL, NULL, 5313, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 10:24:30', 'admin-1482108039-14821142698998466', 1, 0, '', NULL, NULL, NULL),
(15461, '2016-12-19 10:24:30', NULL, NULL, 5313, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 10:24:30', 'admin-1482108039-14821142698998466', 1, 0, '', NULL, NULL, NULL),
(15462, '2016-12-19 10:24:30', NULL, NULL, 5313, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 10:24:30', 'admin-1482108039-14821142698998466', 1, 1, 'SR', NULL, NULL, NULL),
(15463, '2016-12-19 11:19:15', NULL, NULL, 5317, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 11:19:15', 'admin-1482108039-14821175548188868', 1, 0, '', NULL, NULL, NULL),
(15464, '2016-12-19 11:19:15', NULL, NULL, 5317, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 11:19:15', 'admin-1482108039-14821175548188868', 1, 0, '', NULL, NULL, NULL),
(15465, '2016-12-19 11:19:15', NULL, NULL, 5317, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 11:19:15', 'admin-1482108039-14821175548188868', 1, 0, '', NULL, NULL, NULL),
(15466, '2016-12-19 11:19:24', NULL, NULL, 5317, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 11:19:24', 'admin-1482108039-14821175647985139', 1, 1, 'SR', NULL, NULL, NULL),
(15467, '2016-12-19 09:58:56', NULL, NULL, 5315, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 09:58:56', 'admin-1482108039-14821127358522152', 1, 1, 'SR', NULL, NULL, NULL),
(15468, '2016-12-19 11:19:24', NULL, NULL, 5317, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 11:19:24', 'admin-1482108039-14821175647985139', 1, 0, '', NULL, NULL, NULL),
(15469, '2016-12-19 11:19:24', NULL, NULL, 5317, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 11:19:24', 'admin-1482108039-14821175647985139', 1, 1, 'SR', NULL, NULL, NULL),
(15470, '2016-12-19 09:56:32', NULL, NULL, 5314, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 09:56:32', 'admin-1482108039-14821125928002619', 1, 1, 'SR', NULL, NULL, NULL),
(15471, '2016-12-19 09:58:56', NULL, NULL, 5315, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 09:58:56', 'admin-1482108039-14821127358522152', 1, 0, '', NULL, NULL, NULL),
(15472, '2016-12-19 09:56:32', NULL, NULL, 5314, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 09:56:32', 'admin-1482108039-14821125928002619', 1, 1, 'SR', NULL, NULL, NULL),
(15473, '2016-12-19 09:54:30', NULL, NULL, 5313, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482143290', 'admin', '2016-12-19 09:54:30', 'admin-1482108039-14821124703624019', 1, 1, 'SR', NULL, NULL, NULL),
(15474, '2016-12-21 14:14:23', NULL, NULL, 5356, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 14:14:23', 'admin-1482289636-14823008630384068', 1, 1, 'SR', NULL, NULL, NULL),
(15475, '2016-12-21 14:14:23', NULL, NULL, 5356, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 14:14:23', 'admin-1482289636-14823008630384068', 1, 1, 'SR', NULL, NULL, NULL),
(15476, '2016-12-21 14:15:04', NULL, NULL, 5358, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 14:15:04', 'admin-1482289636-14823009043529933', 1, 1, 'SR', NULL, NULL, NULL),
(15477, '2016-12-21 14:15:04', NULL, NULL, 5358, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 14:15:04', 'admin-1482289636-14823009043529933', 1, 1, 'SR', NULL, NULL, NULL),
(15478, '2016-12-21 14:34:21', NULL, NULL, 5356, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 14:34:21', 'admin-1482289636-14823020616882459', 1, 0, '', NULL, NULL, NULL),
(15479, '2016-12-21 14:35:11', NULL, NULL, 5356, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 14:35:11', 'admin-1482289636-1482302110878338', 1, 0, '', NULL, NULL, NULL),
(15480, '2016-12-21 14:35:51', NULL, NULL, 5356, 0, 181, '116', 'Open Food ', 'Mixed Sconed', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 14:35:51', 'admin-1482289636-14823021508063374', 1, 0, '', NULL, NULL, NULL),
(15481, '2016-12-21 15:24:39', NULL, NULL, 5359, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 15:24:39', 'admin-1482289636-14823050797439478', 1, 1, 'SR', NULL, NULL, NULL),
(15482, '2016-12-21 15:24:39', NULL, NULL, 5359, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 15:24:39', 'admin-1482289636-14823050797439478', 1, 1, 'SR', NULL, NULL, NULL),
(15483, '2016-12-21 17:33:49', NULL, NULL, 5360, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 17:33:49', 'admin-1482289636-14823128296501023', 1, 1, 'SR', NULL, NULL, NULL),
(15484, '2016-12-21 12:28:14', NULL, NULL, 5355, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 12:28:14', 'admin-1482289636-1482294494664368', 1, 1, 'SR', NULL, NULL, NULL),
(15485, '2016-12-21 12:28:14', NULL, NULL, 5355, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 12:28:14', 'admin-1482289636-1482294494664368', 1, 1, 'SR', NULL, NULL, NULL),
(15486, '2016-12-21 13:12:30', NULL, NULL, 5356, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 13:12:30', 'admin-1482289636-14822971504611414', 1, 0, '', NULL, NULL, NULL),
(15487, '2016-12-21 13:12:30', NULL, NULL, 5356, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 13:12:30', 'admin-1482289636-14822971504611414', 1, 0, '', NULL, NULL, NULL),
(15488, '2016-12-21 13:12:30', NULL, NULL, 5356, 0, 214, '148', 'Set Fried Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 13:12:30', 'admin-1482289636-14822971504611414', 1, 0, '', NULL, NULL, NULL),
(15489, '2016-12-21 10:49:08', NULL, NULL, 5347, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 10:49:08', 'admin-1482282399-1482288547967792', 1, 0, '', NULL, NULL, NULL),
(15490, '2016-12-21 10:49:08', NULL, NULL, 5347, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 10:49:08', 'admin-1482282399-1482288547967792', 1, 1, 'SR', NULL, NULL, NULL),
(15491, '2016-12-21 17:33:49', NULL, NULL, 5360, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 17:33:49', 'admin-1482289636-14823128296501023', 1, 1, 'SR', NULL, NULL, NULL),
(15492, '2016-12-21 13:24:05', NULL, NULL, 5357, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 13:24:05', 'admin-1482289636-14822978449239598', 1, 1, 'SR', NULL, NULL, NULL),
(15493, '2016-12-21 13:24:01', NULL, NULL, 5357, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 13:24:01', 'admin-1482289636-14822978411986485', 1, 0, '', NULL, NULL, NULL),
(15494, '2016-12-21 13:24:01', NULL, NULL, 5357, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 13:24:01', 'admin-1482289636-14822978411986485', 1, 0, '', NULL, NULL, NULL),
(15495, '2016-12-21 13:24:01', NULL, NULL, 5357, 0, 85, '85', 'Set Meatless Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 13:24:01', 'admin-1482289636-14822978411986485', 1, 1, 'SR', NULL, NULL, NULL),
(15496, '2016-12-21 13:12:30', NULL, NULL, 5356, 0, 85, '85', 'Set Meatless Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 13:12:30', 'admin-1482289636-14822971504611414', 1, 1, 'SR', NULL, NULL, NULL),
(15497, '2016-12-21 12:24:24', NULL, NULL, 5354, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 12:24:24', 'admin-1482289636-14822942645196994', 1, 0, '', NULL, NULL, NULL),
(15498, '2016-12-21 12:23:56', NULL, NULL, 5354, 0, 84, '84', 'Set Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 12:23:56', 'admin-1482289636-14822942362004719', 1, 1, 'SR', NULL, NULL, NULL),
(15499, '2016-12-21 11:55:49', NULL, NULL, 5353, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 11:55:49', 'admin-1482289636-14822925489308361', 1, 0, '', NULL, NULL, NULL),
(15500, '2016-12-21 11:26:22', NULL, NULL, 5350, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 11:26:22', 'admin-1482289636-14822907820169849', 1, 1, 'SR', 1, NULL, NULL),
(15501, '2016-12-21 11:40:02', NULL, NULL, 5351, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 11:40:02', 'admin-1482289636-14822916024184826', 1, 0, '', NULL, NULL, NULL),
(15502, '2016-12-21 11:40:02', NULL, NULL, 5351, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 11:40:02', 'admin-1482289636-14822916024184826', 1, 1, 'SR', NULL, NULL, NULL),
(15503, '2016-12-21 11:55:23', NULL, NULL, 5352, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 11:55:23', 'admin-1482289636-14822925235375599', 1, 0, '', NULL, NULL, NULL),
(15504, '2016-12-21 11:14:52', NULL, NULL, 5349, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 11:14:52', 'admin-1482289636-14822900920663017', 1, 1, 'SR', NULL, NULL, NULL),
(15505, '2016-12-21 11:14:52', NULL, NULL, 5349, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 11:14:52', 'admin-1482289636-14822900920663017', 1, 1, 'SR', NULL, NULL, NULL),
(15506, '2016-12-21 11:07:34', NULL, NULL, 5348, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 11:07:34', 'admin-1482289636-14822896544764287', 1, 1, 'SR', NULL, NULL, NULL),
(15507, '2016-12-21 11:07:34', NULL, NULL, 5348, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 11:07:34', 'admin-1482289636-14822896544764287', 1, 1, 'SR', NULL, NULL, NULL),
(15508, '2016-12-21 11:07:07', NULL, NULL, 5348, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 11:07:07', 'admin-1482282399-14822896271566580', 1, 1, 'SR', NULL, NULL, NULL),
(15509, '2016-12-21 11:07:07', NULL, NULL, 5348, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 11:07:07', 'admin-1482282399-14822896271566580', 1, 0, '', NULL, NULL, NULL),
(15510, '2016-12-21 11:07:07', NULL, NULL, 5348, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 11:07:07', 'admin-1482282399-14822896271566580', 1, 0, '', NULL, NULL, NULL),
(15511, '2016-12-21 10:49:08', NULL, NULL, 5347, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 10:49:08', 'admin-1482282399-1482288547967792', 1, 1, 'SR', NULL, NULL, NULL),
(15512, '2016-12-21 10:41:01', NULL, NULL, 5346, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 10:41:01', 'admin-1482282399-14822880611928740', 1, 1, 'SR', NULL, NULL, NULL),
(15513, '2016-12-21 10:40:53', NULL, NULL, 5346, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 10:40:53', 'admin-1482282399-14822880534044192', 1, 0, '', NULL, NULL, NULL),
(15514, '2016-12-21 10:39:27', NULL, NULL, 5346, 0, 181, '116', 'Open Food ', 'Fruits', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 10:39:27', 'admin-1482282399-14822879668942430', 1, 0, '', NULL, NULL, NULL),
(15515, '2016-12-21 10:39:27', NULL, NULL, 5346, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 10:39:27', 'admin-1482282399-14822879668942430', 1, 1, 'SR', NULL, NULL, NULL),
(15516, '2016-12-21 10:24:32', NULL, NULL, 5344, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 10:24:33', 'admin-1482282399-14822870727715375', 1, 0, '', NULL, NULL, NULL),
(15517, '2016-12-21 10:25:57', NULL, NULL, 5345, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 10:25:57', 'admin-1482282399-14822871572805938', 1, 1, 'SR', NULL, NULL, NULL),
(15518, '2016-12-21 09:07:04', NULL, NULL, 5341, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 09:07:04', 'admin-1482282399-14822824245371286', 1, 1, 'SR', NULL, NULL, NULL),
(15519, '2016-12-21 09:07:16', NULL, NULL, 5341, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 09:07:16', 'admin-1482282399-14822824365733573', 1, 0, '', NULL, NULL, NULL),
(15520, '2016-12-21 09:07:16', NULL, NULL, 5341, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 09:07:16', 'admin-1482282399-14822824365733573', 1, 0, '', NULL, NULL, NULL),
(15521, '2016-12-21 10:19:00', NULL, NULL, 5342, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 10:19:00', 'admin-1482282399-1482286740676871', 1, 0, '', NULL, NULL, NULL),
(15522, '2016-12-21 10:19:00', NULL, NULL, 5342, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 10:19:00', 'admin-1482282399-1482286740676871', 1, 1, 'SR', NULL, NULL, NULL),
(15523, '2016-12-21 10:23:47', NULL, NULL, 5343, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 10:23:47', 'admin-1482282399-14822870276956018', 1, 0, '', NULL, NULL, NULL),
(15524, '2016-12-21 10:23:47', NULL, NULL, 5343, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 10:23:47', 'admin-1482282399-14822870276956018', 1, 0, '', NULL, NULL, NULL),
(15525, '2016-12-21 10:23:47', NULL, NULL, 5343, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 10:23:47', 'admin-1482282399-14822870276956018', 1, 0, '', NULL, NULL, NULL),
(15526, '2016-12-21 10:23:58', NULL, NULL, 5343, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 10:23:58', 'admin-1482282399-14822870381533556', 1, 1, 'SR', NULL, NULL, NULL),
(15527, '2016-12-21 10:23:58', NULL, NULL, 5343, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 10:23:58', 'admin-1482282399-14822870381533556', 1, 1, 'SR', NULL, NULL, NULL),
(15528, '2016-12-21 10:23:58', NULL, NULL, 5343, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 10:23:58', 'admin-1482282399-14822870381533556', 1, 1, 'SR', NULL, NULL, NULL),
(15529, '2016-12-21 10:23:58', NULL, NULL, 5343, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 10:23:58', 'admin-1482282399-14822870381533556', 1, 1, 'SR', NULL, NULL, NULL),
(15530, '2016-12-21 10:24:32', NULL, NULL, 5344, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 10:24:32', 'admin-1482282399-14822870727715375', 1, 1, 'SR', NULL, NULL, NULL),
(15531, '2016-12-21 10:24:32', NULL, NULL, 5344, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 10:24:32', 'admin-1482282399-14822870727715375', 1, 1, 'SR', NULL, NULL, NULL),
(15532, '2016-12-21 09:07:04', NULL, NULL, 5341, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 09:07:04', 'admin-1482282399-14822824245371286', 1, 0, '', NULL, NULL, NULL),
(15533, '2016-12-21 09:07:04', NULL, NULL, 5341, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482289636', 'admin', '2016-12-21 09:07:04', 'admin-1482282399-14822824245371286', 1, 1, 'SR', NULL, NULL, NULL),
(15534, '2016-12-22 19:37:12', NULL, NULL, 5375, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 19:37:12', 'admin-1482377945-1482406632697293', 1, 0, '', NULL, NULL, NULL),
(15535, '2016-12-22 19:43:41', NULL, NULL, 5375, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 19:43:41', 'admin-1482406639-1482407021143738', 1, 0, '', NULL, NULL, NULL),
(15536, '2016-12-22 19:46:48', NULL, NULL, 5379, 0, 71, '71', 'Rice Wine Ginger Pork', 'Takeaway', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 19:46:48', 'admin-1482406639-14824072082754937', 1, 1, 'SR', NULL, NULL, NULL),
(15537, '2016-12-22 19:49:10', NULL, NULL, 5380, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 19:49:10', 'admin-1482406639-14824073499162118', 1, 0, '', NULL, NULL, NULL),
(15538, '2016-12-22 19:49:10', NULL, NULL, 5380, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 19:49:10', 'admin-1482406639-14824073499162118', 1, 1, 'SR', NULL, NULL, NULL),
(15539, '2016-12-22 19:10:03', NULL, NULL, 5375, 0, 251, '184', 'Dinner Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 26.90, 26.9000, 0.0000, 26.90, 1, '27', 1, '1482406639', 'admin', '2016-12-22 19:10:03', 'admin-1482377945-14824050029447499', 1, 0, '', NULL, NULL, NULL),
(15540, '2016-12-22 19:10:03', NULL, NULL, 5375, 0, 249, '183', 'Pan Roasted Pork Loin Chop', '', 'Meals', 'Perfect Meals', 1, 31.90, 31.9000, 0.0000, 31.90, 1, '27', 1, '1482406639', 'admin', '2016-12-22 19:10:03', 'admin-1482377945-14824050029447499', 1, 0, '', NULL, NULL, NULL),
(15541, '2016-12-22 19:10:03', NULL, NULL, 5375, 0, 249, '183', 'Pan Roasted Pork Loin Chop', '', 'Meals', 'Perfect Meals', 1, 31.90, 31.9000, 0.0000, 31.90, 1, '27', 1, '1482406639', 'admin', '2016-12-22 19:10:03', 'admin-1482377945-14824050029447499', 1, 0, '', NULL, NULL, NULL),
(15542, '2016-12-22 19:10:03', NULL, NULL, 5375, 0, 249, '183', 'Pan Roasted Pork Loin Chop', '', 'Meals', 'Perfect Meals', 1, 31.90, 31.9000, 0.0000, 31.90, 1, '27', 1, '1482406639', 'admin', '2016-12-22 19:10:03', 'admin-1482377945-14824050029447499', 1, 0, '', NULL, NULL, NULL),
(15543, '2016-12-22 19:10:03', NULL, NULL, 5375, 0, 248, '182', 'The Cod Squad', '', 'Meals', 'Perfect Meals', 1, 28.90, 28.9000, 0.0000, 28.90, 1, '27', 1, '1482406639', 'admin', '2016-12-22 19:10:03', 'admin-1482377945-14824050029447499', 1, 0, '', NULL, NULL, NULL),
(15544, '2016-12-22 19:10:03', NULL, NULL, 5375, 0, 248, '182', 'The Cod Squad', '', 'Meals', 'Perfect Meals', 1, 28.90, 28.9000, 0.0000, 28.90, 1, '27', 1, '1482406639', 'admin', '2016-12-22 19:10:03', 'admin-1482377945-14824050029447499', 1, 0, '', NULL, NULL, NULL),
(15545, '2016-12-22 19:10:03', NULL, NULL, 5375, 0, 250, '185', 'Double Trouble Burger', '', 'Meals', 'Perfect Meals', 1, 28.90, 28.9000, 0.0000, 28.90, 1, '27', 1, '1482406639', 'admin', '2016-12-22 19:10:03', 'admin-1482377945-14824050029447499', 1, 0, '', NULL, NULL, NULL),
(15546, '2016-12-22 16:45:44', NULL, NULL, 5374, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 16:45:44', 'admin-1482377945-14823963442849136', 1, 1, 'SR', NULL, NULL, NULL),
(15547, '2016-12-22 16:45:44', NULL, NULL, 5374, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 16:45:44', 'admin-1482377945-14823963442849136', 1, 1, 'SR', NULL, NULL, NULL),
(15548, '2016-12-22 19:10:57', NULL, NULL, 5378, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 19:10:57', 'admin-1482377945-14824050576137554', 1, 0, '', NULL, NULL, NULL),
(15549, '2016-12-22 19:14:54', NULL, NULL, 5378, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 19:14:54', 'admin-1482377945-14824052938831059', 1, 1, 'SR', NULL, NULL, NULL),
(15550, '2016-12-22 16:20:06', NULL, NULL, 5372, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 16:20:06', 'admin-1482377945-14823948060673860', 1, 1, 'SR', NULL, NULL, NULL),
(15551, '2016-12-22 16:20:06', NULL, NULL, 5372, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 16:20:06', 'admin-1482377945-14823948060673860', 1, 1, 'SR', NULL, NULL, NULL),
(15552, '2016-12-22 16:20:06', NULL, NULL, 5372, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 16:20:06', 'admin-1482377945-14823948060673860', 1, 1, 'SR', NULL, NULL, NULL),
(15553, '2016-12-22 16:34:16', NULL, NULL, 5373, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 16:34:16', 'admin-1482377945-14823956559372159', 1, 0, '', NULL, NULL, NULL),
(15554, '2016-12-22 16:45:44', NULL, NULL, 5374, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 16:45:44', 'admin-1482377945-14823963442849136', 1, 1, 'SR', NULL, NULL, NULL),
(15555, '2016-12-22 19:10:57', NULL, NULL, 5378, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 19:10:57', 'admin-1482377945-14824050576137554', 1, 0, '', NULL, NULL, NULL),
(15556, '2016-12-22 18:50:02', NULL, NULL, 5375, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 18:50:02', 'admin-1482377945-14824038026581447', 1, 1, 'SR', NULL, NULL, NULL),
(15557, '2016-12-22 18:46:22', NULL, NULL, 5377, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 18:46:22', 'admin-1482377945-1482403582508345', 1, 1, 'SR', NULL, NULL, NULL),
(15558, '2016-12-22 18:42:01', NULL, NULL, 5377, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 18:42:01', 'admin-1482377945-14824033211924363', 1, 1, 'SR', NULL, NULL, NULL),
(15559, '2016-12-22 17:45:40', NULL, NULL, 5376, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 17:45:40', 'admin-1482377945-14823999407147167', 1, 1, 'SR', NULL, NULL, NULL),
(15560, '2016-12-22 17:45:40', NULL, NULL, 5376, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 17:45:40', 'admin-1482377945-14823999407147167', 1, 1, 'SR', NULL, NULL, NULL),
(15561, '2016-12-22 17:45:40', NULL, NULL, 5376, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 17:45:40', 'admin-1482377945-14823999407147167', 1, 0, '', NULL, NULL, NULL),
(15562, '2016-12-22 16:45:44', NULL, NULL, 5374, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 16:45:44', 'admin-1482377945-14823963442849136', 1, 1, 'SR', NULL, NULL, NULL),
(15563, '2016-12-22 16:20:06', NULL, NULL, 5372, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 16:20:06', 'admin-1482377945-14823948060673860', 1, 0, '', NULL, NULL, NULL),
(15564, '2016-12-22 16:18:46', NULL, NULL, 5371, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 16:18:46', 'admin-1482377945-14823947262943550', 1, 1, 'SR', NULL, NULL, NULL),
(15565, '2016-12-22 12:53:02', NULL, NULL, 5368, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 12:53:02', 'admin-1482377945-14823823827852511', 1, 1, 'SR', NULL, NULL, NULL),
(15566, '2016-12-22 12:54:13', NULL, NULL, 5368, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 12:54:13', 'admin-1482377945-1482382453756929', 1, 0, '', NULL, NULL, NULL),
(15567, '2016-12-22 12:55:19', NULL, NULL, 5368, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 12:55:19', 'admin-1482377945-14823825195606279', 1, 0, '', NULL, NULL, NULL),
(15568, '2016-12-22 12:59:12', NULL, NULL, 5368, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 12:59:12', 'admin-1482377945-14823827521417226', 1, 1, 'SR', NULL, NULL, NULL),
(15569, '2016-12-22 13:40:15', NULL, NULL, 5369, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 13:40:15', 'admin-1482377945-14823852155068079', 1, 0, '', NULL, NULL, NULL),
(15570, '2016-12-22 13:40:15', NULL, NULL, 5369, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 13:40:15', 'admin-1482377945-14823852155068079', 1, 1, 'SR', NULL, NULL, NULL),
(15571, '2016-12-22 15:22:51', NULL, NULL, 5370, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 15:22:51', 'admin-1482377945-14823913713092022', 1, 1, 'SR', NULL, NULL, NULL),
(15572, '2016-12-22 15:22:51', NULL, NULL, 5370, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 15:22:51', 'admin-1482377945-14823913713092022', 1, 1, 'SR', NULL, NULL, NULL),
(15573, '2016-12-22 16:18:46', NULL, NULL, 5371, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 16:18:46', 'admin-1482377945-14823947262943550', 1, 1, 'SR', NULL, NULL, NULL),
(15574, '2016-12-22 16:18:46', NULL, NULL, 5371, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 16:18:46', 'admin-1482377945-14823947262943550', 1, 1, 'SR', NULL, NULL, NULL),
(15575, '2016-12-22 16:18:46', NULL, NULL, 5371, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 16:18:46', 'admin-1482377945-14823947262943550', 1, 1, 'SR', NULL, NULL, NULL),
(15576, '2016-12-22 16:18:46', NULL, NULL, 5371, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 16:18:46', 'admin-1482377945-14823947262943550', 1, 0, '', NULL, NULL, NULL),
(15577, '2016-12-22 12:52:22', NULL, NULL, 5368, 0, 84, '84', 'Set Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 12:52:22', 'admin-1482377945-14823823421676186', 1, 1, 'SR', NULL, NULL, NULL),
(15578, '2016-12-22 11:07:47', NULL, NULL, 5366, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 11:07:47', 'admin-1482374420-14823760669844593', 1, 1, 'SR', NULL, NULL, NULL),
(15579, '2016-12-22 10:09:11', NULL, NULL, 5362, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 10:09:11', 'admin-1482368000-14823725516238876', 1, 0, '', NULL, NULL, NULL),
(15580, '2016-12-22 10:10:14', NULL, NULL, 5362, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 10:10:14', 'admin-1482368000-14823726143847447', 1, 1, 'SR', NULL, NULL, NULL),
(15581, '2016-12-22 10:10:14', NULL, NULL, 5362, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 10:10:14', 'admin-1482368000-14823726143847447', 1, 0, '', NULL, NULL, NULL),
(15582, '2016-12-22 10:10:37', NULL, NULL, 5362, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 10:10:37', 'admin-1482368000-14823726371497227', 1, 0, '', NULL, NULL, NULL),
(15583, '2016-12-22 10:06:00', NULL, NULL, 5361, 0, 181, '116', 'Open Food ', 'Macadamia Scone', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 10:06:00', 'admin-1482368000-14823723604371081', 1, 0, '', NULL, NULL, NULL),
(15584, '2016-12-22 11:07:47', NULL, NULL, 5366, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 11:07:47', 'admin-1482374420-14823760669844593', 1, 1, 'SR', NULL, NULL, NULL),
(15585, '2016-12-22 11:07:40', NULL, NULL, 5366, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 11:07:40', 'admin-1482374420-14823760604405146', 1, 0, '', NULL, NULL, NULL),
(15586, '2016-12-22 11:07:40', NULL, NULL, 5366, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 11:07:40', 'admin-1482374420-14823760604405146', 1, 0, '', NULL, NULL, NULL),
(15587, '2016-12-22 10:52:05', NULL, NULL, 5365, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 10:52:05', 'admin-1482374420-14823751249996054', 1, 0, '', NULL, NULL, NULL),
(15588, '2016-12-22 10:52:05', NULL, NULL, 5365, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 10:52:05', 'admin-1482374420-14823751249996054', 1, 1, 'SR', NULL, NULL, NULL),
(15589, '2016-12-22 10:51:55', NULL, NULL, 5365, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 10:51:55', 'admin-1482374420-14823751154689847', 1, 0, '', NULL, NULL, NULL),
(15590, '2016-12-22 10:51:55', NULL, NULL, 5365, 0, 156, '90', 'Cheese Omelet', 'add sausage', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 10:51:55', 'admin-1482374420-14823751154689847', 1, 0, '', NULL, NULL, NULL),
(15591, '2016-12-22 10:27:50', NULL, NULL, 5362, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 10:27:50', 'admin-1482368000-14823736704708531', 1, 0, '', NULL, NULL, NULL),
(15592, '2016-12-22 10:15:50', NULL, NULL, 5364, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 10:15:50', 'admin-1482368000-14823729501512833', 1, 1, 'SR', NULL, NULL, NULL),
(15593, '2016-12-22 10:15:50', NULL, NULL, 5364, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 10:15:50', 'admin-1482368000-14823729501512833', 1, 0, '', NULL, NULL, NULL),
(15594, '2016-12-22 10:15:50', NULL, NULL, 5364, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 10:15:50', 'admin-1482368000-14823729501512833', 1, 0, '', NULL, NULL, NULL),
(15595, '2016-12-22 10:13:44', NULL, NULL, 5363, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 10:13:44', 'admin-1482368000-14823728243991124', 1, 0, '', NULL, NULL, NULL),
(15596, '2016-12-22 10:13:44', NULL, NULL, 5363, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 10:13:44', 'admin-1482368000-14823728243991124', 1, 0, '', NULL, NULL, NULL),
(15597, '2016-12-22 10:06:00', NULL, NULL, 5361, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 10:06:00', 'admin-1482368000-14823723604371081', 1, 1, 'SR', NULL, NULL, NULL),
(15598, '2016-12-22 10:06:00', NULL, NULL, 5361, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482406639', 'admin', '2016-12-22 10:06:00', 'admin-1482368000-14823723604371081', 1, 1, 'SR', NULL, NULL, NULL),
(15599, '2016-12-23 16:15:54', NULL, NULL, 5415, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 16:15:54', 'admin-1482471260-1482480954316387', 1, 1, 'SR', 1, NULL, NULL),
(15600, '2016-12-23 15:32:01', NULL, NULL, 5413, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 15:32:01', 'admin-1482471260-14824783216519778', 1, 1, 'SR', NULL, NULL, NULL),
(15601, '2016-12-23 15:19:43', NULL, NULL, 5412, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 15:19:43', 'admin-1482471260-14824775836817010', 1, 1, 'SR', NULL, NULL, NULL),
(15602, '2016-12-23 14:03:38', NULL, NULL, 5405, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 14:03:38', 'admin-1482471260-14824730177465255', 1, 0, '', NULL, NULL, NULL),
(15603, '2016-12-23 14:03:38', NULL, NULL, 5405, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 14:03:38', 'admin-1482471260-14824730177465255', 1, 1, 'SR', NULL, NULL, NULL),
(15604, '2016-12-23 14:13:02', NULL, NULL, 5408, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 14:13:02', 'admin-1482471260-14824735821276951', 1, 0, '', NULL, NULL, NULL),
(15605, '2016-12-23 14:25:53', NULL, NULL, 5409, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 14:25:53', 'admin-1482471260-14824743531702850', 1, 1, 'SR', NULL, NULL, NULL),
(15606, '2016-12-23 14:25:53', NULL, NULL, 5409, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 14:25:53', 'admin-1482471260-14824743531702850', 1, 0, '', NULL, NULL, NULL),
(15607, '2016-12-23 14:33:08', NULL, NULL, 5410, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 14:33:08', 'admin-1482471260-1482474788630323', 1, 1, 'SR', NULL, NULL, NULL),
(15608, '2016-12-23 17:11:01', NULL, NULL, 5418, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 17:11:01', 'admin-1482471260-14824842612999849', 1, 1, 'SR', NULL, NULL, NULL),
(15609, '2016-12-23 17:11:01', NULL, NULL, 5418, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 17:11:01', 'admin-1482471260-14824842612999849', 1, 1, 'SR', NULL, NULL, NULL),
(15610, '2016-12-23 17:11:01', NULL, NULL, 5418, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 17:11:01', 'admin-1482471260-14824842612999849', 1, 1, 'SR', NULL, NULL, NULL),
(15611, '2016-12-23 17:11:01', NULL, NULL, 5418, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 17:11:01', 'admin-1482471260-14824842612999849', 1, 1, 'SR', NULL, NULL, NULL),
(15612, '2016-12-23 17:16:51', NULL, NULL, 5419, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 17:16:51', 'admin-1482471260-14824846114206247', 1, 1, 'SR', NULL, NULL, NULL),
(15613, '2016-12-23 17:16:51', NULL, NULL, 5419, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 17:16:51', 'admin-1482471260-14824846114206247', 1, 1, 'SR', NULL, NULL, NULL),
(15614, '2016-12-23 17:32:25', NULL, NULL, 5420, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 17:32:25', 'admin-1482471260-1482485545082827', 1, 1, 'SR', NULL, NULL, NULL),
(15615, '2016-12-23 18:05:24', NULL, NULL, 5421, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 18:05:24', 'admin-1482471260-14824875240022695', 1, 0, '', NULL, NULL, NULL),
(15616, '2016-12-23 18:44:53', NULL, NULL, 5422, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 18:44:53', 'admin-1482489687-14824898934222492', 1, 1, 'SR', NULL, NULL, NULL),
(15617, '2016-12-23 18:46:57', NULL, NULL, 5420, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 18:46:57', 'admin-1482489687-14824900170963076', 1, 1, 'SR', NULL, NULL, NULL),
(15618, '2016-12-23 18:41:07', NULL, NULL, 5422, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 18:41:07', 'admin-1482471260-14824896675689980', 1, 0, '', NULL, NULL, NULL),
(15619, '2016-12-23 18:41:18', NULL, NULL, 5422, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 18:41:18', 'admin-1482471260-1482489678707784', 1, 0, '', NULL, NULL, NULL),
(15620, '2016-12-23 18:53:15', NULL, NULL, 5423, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 18:53:15', 'admin-1482489687-14824903956495514', 1, 0, '', NULL, NULL, NULL),
(15621, '2016-12-23 19:00:06', NULL, NULL, 5422, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 19:00:06', 'admin-1482489687-14824908066737717', 1, 1, 'SR', NULL, NULL, NULL),
(15622, '2016-12-23 19:00:06', NULL, NULL, 5422, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 19:00:06', 'admin-1482489687-14824908066737717', 1, 1, 'SR', NULL, NULL, NULL),
(15623, '2016-12-23 19:00:06', NULL, NULL, 5422, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 19:00:06', 'admin-1482489687-14824908066737717', 1, 1, 'SR', NULL, NULL, NULL),
(15624, '2016-12-23 19:00:46', NULL, NULL, 5422, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 19:00:46', 'admin-1482489687-14824908459598341', 1, 1, 'SR', NULL, NULL, NULL),
(15625, '2016-12-23 19:00:46', NULL, NULL, 5422, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 19:00:46', 'admin-1482489687-14824908459598341', 1, 1, 'SR', NULL, NULL, NULL),
(15626, '2016-12-23 19:00:46', NULL, NULL, 5422, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 19:00:46', 'admin-1482489687-14824908459598341', 1, 1, 'SR', NULL, NULL, NULL),
(15627, '2016-12-23 19:08:17', NULL, NULL, 5422, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 19:08:17', 'admin-1482489687-14824912972214530', 1, 0, '', NULL, NULL, NULL),
(15628, '2016-12-23 13:34:07', NULL, NULL, 5392, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:34:07', 'admin-1482469715-1482471247069854', 1, 0, '', NULL, NULL, NULL),
(15629, '2016-12-23 13:34:30', NULL, NULL, 5392, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:34:30', 'admin-1482471260-14824712706063161', 1, 1, 'SR', NULL, NULL, NULL),
(15630, '2016-12-23 13:45:30', NULL, NULL, 5403, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:45:30', 'admin-1482471260-14824719306594840', 1, 0, '', NULL, NULL, NULL),
(15631, '2016-12-23 13:46:56', NULL, NULL, 5404, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:46:56', 'admin-1482471260-1482472016163778', 1, 1, 'SR', NULL, NULL, NULL),
(15632, '2016-12-23 13:46:56', NULL, NULL, 5404, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:46:56', 'admin-1482471260-1482472016163778', 1, 1, 'SR', NULL, NULL, NULL),
(15633, '2016-12-23 13:46:56', NULL, NULL, 5404, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:46:56', 'admin-1482471260-1482472016163778', 1, 1, 'SR', NULL, NULL, NULL),
(15634, '2016-12-23 13:46:56', NULL, NULL, 5404, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:46:56', 'admin-1482471260-1482472016163778', 1, 1, 'SR', NULL, NULL, NULL),
(15635, '2016-12-23 13:09:06', NULL, NULL, 5398, 0, 214, '148', 'Set Fried Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:09:06', 'admin-1482469715-14824697462815023', 1, 0, '', NULL, NULL, NULL),
(15636, '2016-12-23 13:10:04', NULL, NULL, 5399, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:10:04', 'admin-1482469715-14824698039665941', 1, 0, '', NULL, NULL, NULL),
(15637, '2016-12-23 17:32:25', NULL, NULL, 5420, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 17:32:25', 'admin-1482471260-1482485545082827', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(15638, '2016-12-23 17:32:25', NULL, NULL, 5420, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 17:32:25', 'admin-1482471260-1482485545082827', 1, 1, 'SR', NULL, NULL, NULL),
(15639, '2016-12-23 18:05:24', NULL, NULL, 5421, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 18:05:24', 'admin-1482471260-14824875240022695', 1, 0, '', NULL, NULL, NULL),
(15640, '2016-12-23 19:16:00', NULL, NULL, 5424, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 19:16:00', 'admin-1482491589-14824917599278353', 1, 1, 'SR', NULL, NULL, NULL),
(15641, '2016-12-23 19:16:00', NULL, NULL, 5424, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 19:16:00', 'admin-1482491589-14824917599278353', 1, 0, '', NULL, NULL, NULL),
(15642, '2016-12-23 17:39:27', NULL, NULL, 5421, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 17:39:27', 'admin-1482471260-14824859673271595', 1, 1, 'SR', NULL, NULL, NULL),
(15643, '2016-12-23 17:39:27', NULL, NULL, 5421, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 17:39:27', 'admin-1482471260-14824859673271595', 1, 0, '', NULL, NULL, NULL),
(15644, '2016-12-23 17:39:27', NULL, NULL, 5421, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 17:39:27', 'admin-1482471260-14824859673271595', 1, 0, '', NULL, NULL, NULL),
(15645, '2016-12-23 20:06:05', NULL, NULL, 5425, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 20:06:05', 'admin-1482491589-14824947653898065', 1, 0, '', NULL, NULL, NULL),
(15646, '2016-12-23 17:52:55', NULL, NULL, 5421, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 17:52:55', 'admin-1482471260-14824867754237964', 1, 1, 'SR', NULL, NULL, NULL),
(15647, '2016-12-23 18:05:24', NULL, NULL, 5421, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 18:05:24', 'admin-1482471260-14824875240022695', 1, 0, '', NULL, NULL, NULL),
(15648, '2016-12-23 18:05:24', NULL, NULL, 5421, 0, 250, '185', 'Double Trouble Burger', '', 'Meals', 'Perfect Meals', 1, 28.90, 28.9000, 0.0000, 28.90, 1, '27', 1, '1482491589', 'admin', '2016-12-23 18:05:24', 'admin-1482471260-14824875240022695', 1, 0, '', NULL, NULL, NULL),
(15649, '2016-12-23 18:05:24', NULL, NULL, 5421, 0, 250, '185', 'Double Trouble Burger', '', 'Meals', 'Perfect Meals', 1, 28.90, 28.9000, 0.0000, 28.90, 1, '27', 1, '1482491589', 'admin', '2016-12-23 18:05:24', 'admin-1482471260-14824875240022695', 1, 0, '', NULL, NULL, NULL),
(15650, '2016-12-23 18:05:24', NULL, NULL, 5421, 0, 249, '183', 'Pan Roasted Pork Loin Chop', '', 'Meals', 'Perfect Meals', 1, 31.90, 31.9000, 0.0000, 31.90, 1, '27', 1, '1482491589', 'admin', '2016-12-23 18:05:24', 'admin-1482471260-14824875240022695', 1, 0, '', NULL, NULL, NULL),
(15651, '2016-12-23 18:05:24', NULL, NULL, 5421, 0, 249, '183', 'Pan Roasted Pork Loin Chop', '', 'Meals', 'Perfect Meals', 1, 31.90, 31.9000, 0.0000, 31.90, 1, '27', 1, '1482491589', 'admin', '2016-12-23 18:05:24', 'admin-1482471260-14824875240022695', 1, 0, '', NULL, NULL, NULL),
(15652, '2016-12-23 17:32:25', NULL, NULL, 5420, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 17:32:25', 'admin-1482471260-1482485545082827', 1, 1, 'SR', NULL, NULL, NULL),
(15653, '2016-12-23 16:33:44', NULL, NULL, 5417, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 16:33:44', 'admin-1482471260-1482482024801829', 1, 0, '', 1, NULL, NULL),
(15654, '2016-12-23 16:20:02', NULL, NULL, 5416, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 16:20:02', 'admin-1482471260-14824812025245019', 1, 1, 'SR', NULL, NULL, NULL),
(15655, '2016-12-23 16:15:54', NULL, NULL, 5415, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 16:15:54', 'admin-1482471260-1482480954316387', 1, 1, 'SR', 1, NULL, NULL),
(15656, '2016-12-23 15:35:25', NULL, NULL, 5414, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 15:35:25', 'admin-1482471260-14824785248918136', 1, 1, 'SR', NULL, NULL, NULL),
(15657, '2016-12-23 15:35:25', NULL, NULL, 5414, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 15:35:25', 'admin-1482471260-14824785248918136', 1, 0, '', NULL, NULL, NULL),
(15658, '2016-12-23 15:14:00', NULL, NULL, 5411, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 15:14:00', 'admin-1482471260-14824772408261184', 1, 1, 'SR', NULL, NULL, NULL),
(15659, '2016-12-23 15:13:53', NULL, NULL, 5411, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 15:13:53', 'admin-1482471260-14824772336528442', 1, 0, '', NULL, NULL, NULL),
(15660, '2016-12-23 15:13:53', NULL, NULL, 5411, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 15:13:53', 'admin-1482471260-14824772336528442', 1, 1, 'SR', NULL, NULL, NULL),
(15661, '2016-12-23 14:33:44', NULL, NULL, 5410, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 14:33:44', 'admin-1482471260-14824748242396682', 1, 0, '', NULL, NULL, NULL),
(15662, '2016-12-23 13:56:17', NULL, NULL, 5405, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:56:17', 'admin-1482471260-14824725776279350', 1, 0, '', NULL, NULL, NULL),
(15663, '2016-12-23 14:13:02', NULL, NULL, 5408, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 14:13:02', 'admin-1482471260-14824735821276951', 1, 1, 'SR', NULL, NULL, NULL),
(15664, '2016-12-23 14:03:37', NULL, NULL, 5405, 0, 224, '158', 'Set Stir Fried  Garlic Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 14:03:37', 'admin-1482471260-14824730177465255', 1, 0, '', NULL, NULL, NULL),
(15665, '2016-12-23 14:03:37', NULL, NULL, 5405, 0, 245, '179', 'Set Spicy Lemony Chicken Wing', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 14:03:37', 'admin-1482471260-14824730177465255', 1, 0, '', NULL, NULL, NULL),
(15666, '2016-12-23 14:03:37', NULL, NULL, 5405, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 14:03:37', 'admin-1482471260-14824730177465255', 1, 1, 'SR', NULL, NULL, NULL),
(15667, '2016-12-23 13:58:55', NULL, NULL, 5407, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:58:55', 'admin-1482471260-14824727350483377', 1, 0, '', NULL, NULL, NULL),
(15668, '2016-12-23 14:03:37', NULL, NULL, 5405, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 14:03:37', 'admin-1482471260-14824730177465255', 1, 1, 'SR', NULL, NULL, NULL),
(15669, '2016-12-23 13:56:22', NULL, NULL, 5405, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:56:22', 'admin-1482471260-14824725826208972', 1, 1, 'SR', NULL, NULL, NULL),
(15670, '2016-12-23 13:32:21', NULL, NULL, 5402, 0, 244, '178', 'Macadamia Scones', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:32:21', 'admin-1482469715-14824711416077868', 1, 0, '', NULL, NULL, NULL),
(15671, '2016-12-23 13:32:21', NULL, NULL, 5402, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:32:21', 'admin-1482469715-14824711416077868', 1, 0, '', NULL, NULL, NULL),
(15672, '2016-12-23 13:29:43', NULL, NULL, 5392, 0, 85, '85', 'Set Meatless Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:29:43', 'admin-1482469715-148247098329595', 1, 1, 'SR', NULL, NULL, NULL),
(15673, '2016-12-23 13:10:04', NULL, NULL, 5399, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:10:04', 'admin-1482469715-14824698039665941', 1, 1, 'SR', NULL, NULL, NULL),
(15674, '2016-12-23 13:10:44', NULL, NULL, 5400, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:10:44', 'admin-1482469715-14824698446689666', 1, 0, '', NULL, NULL, NULL),
(15675, '2016-12-23 13:11:11', NULL, NULL, 5401, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:11:11', 'admin-1482469715-14824698711081423', 1, 1, 'SR', NULL, NULL, NULL),
(15676, '2016-12-23 13:08:24', NULL, NULL, 5397, 0, 83, '83', 'Set Stir Fried Chicken with Mushroom ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:08:24', 'admin-1482454049-14824697038824910', 1, 1, 'SR', NULL, NULL, NULL),
(15677, '2016-12-23 13:08:24', NULL, NULL, 5397, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:08:24', 'admin-1482454049-14824697038824910', 1, 0, '', NULL, NULL, NULL),
(15678, '2016-12-23 12:54:51', NULL, NULL, 5392, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 12:54:51', 'admin-1482454049-14824688913732383', 1, 1, 'SR', NULL, NULL, NULL),
(15679, '2016-12-23 13:04:08', NULL, NULL, 5392, 0, 214, '148', 'Set Fried Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:04:08', 'admin-1482454049-14824694487233629', 1, 0, '', NULL, NULL, NULL),
(15680, '2016-12-23 12:20:17', NULL, NULL, 5390, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 12:20:17', 'admin-1482454049-14824668169225912', 1, 1, 'SR', NULL, NULL, NULL),
(15681, '2016-12-23 12:38:37', NULL, NULL, 5391, 0, 83, '83', 'Set Stir Fried Chicken with Mushroom ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 12:38:37', 'admin-1482454049-14824679168993969', 1, 1, 'SR', NULL, NULL, NULL),
(15682, '2016-12-23 13:08:24', NULL, NULL, 5397, 0, 84, '84', 'Set Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:08:24', 'admin-1482454049-14824697038824910', 1, 1, 'SR', NULL, NULL, NULL),
(15683, '2016-12-23 13:07:15', NULL, NULL, 5396, 0, 82, '82', 'Set Stir Fried Rice Wine Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:07:15', 'admin-1482454049-14824696354889564', 1, 1, 'SR', NULL, NULL, NULL),
(15684, '2016-12-23 13:06:44', NULL, NULL, 5395, 0, 84, '84', 'Set Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:06:44', 'admin-1482454049-14824696039018716', 1, 1, 'SR', NULL, NULL, NULL),
(15685, '2016-12-23 13:05:50', NULL, NULL, 5394, 0, 82, '82', 'Set Stir Fried Rice Wine Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:05:50', 'admin-1482454049-1482469550063990', 1, 1, 'SR', NULL, NULL, NULL),
(15686, '2016-12-23 13:05:13', NULL, NULL, 5393, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:05:13', 'admin-1482454049-14824695137265087', 1, 0, '', NULL, NULL, NULL),
(15687, '2016-12-23 13:05:13', NULL, NULL, 5393, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:05:13', 'admin-1482454049-14824695137265087', 1, 1, 'SR', NULL, NULL, NULL),
(15688, '2016-12-23 13:04:08', NULL, NULL, 5392, 0, 245, '179', 'Set Spicy Lemony Chicken Wing', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 13:04:08', 'admin-1482454049-14824694487233629', 1, 0, '', NULL, NULL, NULL),
(15689, '2016-12-23 12:38:46', NULL, NULL, 5391, 0, 213, '147', 'Set Stir Fried Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 12:38:46', 'admin-1482454049-1482467926424180', 1, 0, '', NULL, NULL, NULL),
(15690, '2016-12-23 11:55:33', NULL, NULL, 5385, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 11:55:33', 'admin-1482454049-14824653336711429', 1, 1, 'SR', NULL, NULL, NULL),
(15691, '2016-12-23 11:55:33', NULL, NULL, 5385, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 11:55:33', 'admin-1482454049-14824653336711429', 1, 1, 'SR', NULL, NULL, NULL),
(15692, '2016-12-23 11:59:39', NULL, NULL, 5386, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 11:59:39', 'admin-1482454049-14824655796696788', 1, 0, '', NULL, NULL, NULL),
(15693, '2016-12-23 11:59:39', NULL, NULL, 5386, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 11:59:39', 'admin-1482454049-14824655796696788', 1, 0, '', NULL, NULL, NULL),
(15694, '2016-12-23 12:03:25', NULL, NULL, 5387, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 12:03:25', 'admin-1482454049-14824658058112591', 1, 1, 'SR', NULL, NULL, NULL),
(15695, '2016-12-23 12:10:24', NULL, NULL, 5388, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 12:10:24', 'admin-1482454049-14824662238498020', 1, 1, 'SR', NULL, NULL, NULL),
(15696, '2016-12-23 12:19:22', NULL, NULL, 5389, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 12:19:22', 'admin-1482454049-14824667619513944', 1, 0, '', NULL, NULL, NULL),
(15697, '2016-12-23 11:55:33', NULL, NULL, 5385, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 11:55:33', 'admin-1482454049-14824653336711429', 1, 0, '', NULL, NULL, NULL),
(15698, '2016-12-23 11:55:33', NULL, NULL, 5385, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 11:55:33', 'admin-1482454049-14824653336711429', 1, 0, '', NULL, NULL, NULL),
(15699, '2016-12-23 11:48:41', NULL, NULL, 5385, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 11:48:41', 'admin-1482454049-14824649209908418', 1, 1, 'SR', NULL, NULL, NULL),
(15700, '2016-12-23 11:48:41', NULL, NULL, 5385, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 11:48:41', 'admin-1482454049-14824649209908418', 1, 0, '', NULL, NULL, NULL),
(15701, '2016-12-23 11:48:41', NULL, NULL, 5385, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 11:48:41', 'admin-1482454049-14824649209908418', 1, 0, '', NULL, NULL, NULL),
(15702, '2016-12-23 11:48:41', NULL, NULL, 5385, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 11:48:41', 'admin-1482454049-14824649209908418', 1, 1, 'SR', NULL, NULL, NULL),
(15703, '2016-12-23 10:52:22', NULL, NULL, 5384, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 10:52:22', 'admin-1482454049-14824615417893315', 1, 1, 'SR', NULL, NULL, NULL),
(15704, '2016-12-23 11:10:34', NULL, NULL, 5384, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 11:10:34', 'admin-1482454049-14824626341599511', 1, 1, 'SR', NULL, NULL, NULL),
(15705, '2016-12-23 10:52:22', NULL, NULL, 5384, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 10:52:22', 'admin-1482454049-14824615417893315', 1, 1, 'SR', NULL, NULL, NULL),
(15706, '2016-12-23 09:25:42', NULL, NULL, 5381, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 09:25:42', 'admin-1482454049-14824563425701589', 1, 1, 'SR', NULL, NULL, NULL),
(15707, '2016-12-23 10:42:59', NULL, NULL, 5383, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 10:42:59', 'admin-1482454049-14824609790335085', 1, 1, 'SR', NULL, NULL, NULL),
(15708, '2016-12-23 09:25:42', NULL, NULL, 5381, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 09:25:42', 'admin-1482454049-14824563425701589', 1, 0, '', NULL, NULL, NULL),
(15709, '2016-12-23 09:25:42', NULL, NULL, 5381, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 09:25:42', 'admin-1482454049-14824563425701589', 1, 0, '', NULL, NULL, NULL),
(15710, '2016-12-23 09:25:42', NULL, NULL, 5381, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 09:25:42', 'admin-1482454049-14824563425701589', 1, 1, 'SR', NULL, NULL, NULL),
(15711, '2016-12-23 09:25:42', NULL, NULL, 5381, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482491589', 'admin', '2016-12-23 09:25:42', 'admin-1482454049-14824563425701589', 1, 1, 'SR', NULL, NULL, NULL),
(15712, '2016-12-24 21:02:12', NULL, NULL, 5477, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 21:02:12', 'admin-1482580080-14825845321831121', 1, 0, '', NULL, NULL, NULL),
(15713, '2016-12-24 21:02:12', NULL, NULL, 5477, 0, 252, '186', 'Dinner Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 26.90, 26.9000, 0.0000, 26.90, 1, '27', 1, '1482580080', 'admin', '2016-12-24 21:02:12', 'admin-1482580080-14825845321831121', 1, 0, '', NULL, NULL, NULL),
(15714, '2016-12-24 21:02:19', NULL, NULL, 5477, 0, 248, '182', 'The Cod Squad', '', 'Meals', 'Perfect Meals', 1, 28.90, 28.9000, 0.0000, 28.90, 1, '27', 1, '1482580080', 'admin', '2016-12-24 21:02:19', 'admin-1482580080-14825845394241066', 1, 0, '', NULL, NULL, NULL),
(15715, '2016-12-24 20:24:16', NULL, NULL, 5475, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 20:24:16', 'admin-1482580080-14825822563943772', 1, 1, 'SR', NULL, NULL, NULL),
(15716, '2016-12-24 20:24:16', NULL, NULL, 5475, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 20:24:16', 'admin-1482580080-14825822563943772', 1, 1, 'SR', NULL, NULL, NULL),
(15717, '2016-12-24 20:35:59', NULL, NULL, 5476, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 20:35:59', 'admin-1482580080-14825829590618275', 1, 1, 'SR', NULL, NULL, NULL),
(15718, '2016-12-24 19:58:24', NULL, NULL, 5473, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 19:58:24', 'admin-1482580080-14825807040245465', 1, 1, 'SR', NULL, NULL, NULL),
(15719, '2016-12-24 19:58:24', NULL, NULL, 5473, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 19:58:24', 'admin-1482580080-14825807040245465', 1, 1, 'SR', NULL, NULL, NULL),
(15720, '2016-12-24 19:25:50', NULL, NULL, 5470, 0, 248, '182', 'The Cod Squad', '', 'Meals', 'Perfect Meals', 1, 28.90, 28.9000, 0.0000, 28.90, 1, '27', 1, '1482580080', 'admin', '2016-12-24 19:25:50', 'admin-1482577544-14825787500667575', 1, 0, '', NULL, NULL, NULL),
(15721, '2016-12-24 20:22:01', NULL, NULL, 5474, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 20:22:01', 'admin-1482580080-14825821209959366', 1, 1, 'SR', NULL, NULL, NULL),
(15722, '2016-12-24 20:21:46', NULL, NULL, 5473, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 20:21:46', 'admin-1482580080-148258210632248', 1, 0, '', NULL, NULL, NULL),
(15723, '2016-12-24 19:58:24', NULL, NULL, 5473, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 19:58:24', 'admin-1482580080-14825807040245465', 1, 1, 'SR', NULL, NULL, NULL),
(15724, '2016-12-24 21:02:12', NULL, NULL, 5477, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 21:02:12', 'admin-1482580080-14825845321831121', 1, 0, '', NULL, NULL, NULL),
(15725, '2016-12-24 18:51:01', NULL, NULL, 5462, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 18:51:01', 'admin-1482558814-14825766613978682', 1, 1, 'SR', NULL, NULL, NULL),
(15726, '2016-12-24 18:51:01', NULL, NULL, 5462, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 18:51:01', 'admin-1482558814-14825766613978682', 1, 1, 'SR', NULL, NULL, NULL),
(15727, '2016-12-24 19:05:39', NULL, NULL, 5468, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 19:05:39', 'admin-1482558814-1482577538925144', 1, 0, '', NULL, NULL, NULL),
(15728, '2016-12-24 19:05:39', NULL, NULL, 5468, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 19:05:39', 'admin-1482558814-1482577538925144', 1, 0, '', NULL, NULL, NULL),
(15729, '2016-12-24 18:41:11', NULL, NULL, 5467, 0, 250, '185', 'Double Trouble Burger', '', 'Meals', 'Perfect Meals', 1, 28.90, 28.9000, 0.0000, 28.90, 1, '27', 1, '1482580080', 'admin', '2016-12-24 18:41:11', 'admin-1482558814-14825760710055725', 1, 0, '', NULL, NULL, '10.0'),
(15730, '2016-12-24 18:41:11', NULL, NULL, 5467, 0, 251, '184', 'Dinner Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 26.90, 26.9000, 0.0000, 26.90, 1, '27', 1, '1482580080', 'admin', '2016-12-24 18:41:11', 'admin-1482558814-14825760710055725', 1, 0, '', NULL, NULL, '10.0'),
(15731, '2016-12-24 12:36:00', NULL, NULL, 5443, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 12:36:00', 'admin-1482550694-14825541600233537', 1, 1, 'SR', NULL, NULL, NULL),
(15732, '2016-12-24 11:38:09', NULL, NULL, 5439, 0, 156, '90', 'Cheese Omelet', 'dont put cheese powder and cheddar cheese', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 11:38:09', 'admin-1482545207-14825506893974465', 1, 0, '', NULL, NULL, NULL),
(15733, '2016-12-24 13:07:03', NULL, NULL, 5445, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 13:07:03', 'admin-1482550694-1482556023319167', 1, 1, 'SR', NULL, NULL, NULL),
(15734, '2016-12-24 11:45:37', NULL, NULL, 5432, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 11:45:37', 'admin-1482550694-14825511373663139', 1, 0, '', NULL, NULL, NULL),
(15735, '2016-12-24 11:45:37', NULL, NULL, 5432, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 11:45:37', 'admin-1482550694-14825511373663139', 1, 1, 'SR', NULL, NULL, NULL),
(15736, '2016-12-24 11:56:25', NULL, NULL, 5440, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 11:56:25', 'admin-1482550694-14825517854373175', 1, 0, '', NULL, NULL, NULL),
(15737, '2016-12-24 11:56:25', NULL, NULL, 5440, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 11:56:25', 'admin-1482550694-14825517854373175', 1, 1, 'SR', NULL, NULL, NULL),
(15738, '2016-12-24 19:48:40', NULL, NULL, 5472, 0, 252, '186', 'Dinner Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 26.90, 26.9000, 0.0000, 26.90, 1, '27', 1, '1482580080', 'admin', '2016-12-24 19:48:40', 'admin-1482580080-14825801201049335', 1, 0, '', NULL, NULL, NULL),
(15739, '2016-12-24 19:58:24', NULL, NULL, 5473, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 19:58:24', 'admin-1482580080-14825807040245465', 1, 1, 'SR', NULL, NULL, NULL),
(15740, '2016-12-24 19:06:31', NULL, NULL, 5469, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 19:06:31', 'admin-1482577544-14825775915788840', 1, 1, 'SR', NULL, NULL, NULL),
(15741, '2016-12-24 19:06:31', NULL, NULL, 5469, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 19:06:31', 'admin-1482577544-14825775915788840', 1, 1, 'SR', NULL, NULL, NULL),
(15742, '2016-12-24 19:06:40', NULL, NULL, 5468, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 19:06:40', 'admin-1482577544-14825776001108664', 1, 0, '', NULL, NULL, NULL),
(15743, '2016-12-24 19:06:40', NULL, NULL, 5468, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 19:06:40', 'admin-1482577544-14825776001108664', 1, 1, 'SR', NULL, NULL, NULL),
(15744, '2016-12-24 19:19:25', NULL, NULL, 5470, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 19:19:25', 'admin-1482577544-14825783655029317', 1, 1, 'SR', NULL, NULL, NULL),
(15745, '2016-12-24 19:19:25', NULL, NULL, 5470, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 19:19:25', 'admin-1482577544-14825783655029317', 1, 1, 'SR', NULL, NULL, NULL),
(15746, '2016-12-24 19:48:40', NULL, NULL, 5472, 0, 248, '182', 'The Cod Squad', '', 'Meals', 'Perfect Meals', 1, 28.90, 28.9000, 0.0000, 28.90, 1, '27', 1, '1482580080', 'admin', '2016-12-24 19:48:40', 'admin-1482580080-14825801201049335', 1, 0, '', NULL, NULL, NULL),
(15747, '2016-12-24 13:27:07', NULL, NULL, 5446, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 13:27:07', 'admin-1482550694-14825572270487712', 1, 0, '', NULL, NULL, NULL),
(15748, '2016-12-24 13:31:00', NULL, NULL, 5447, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 13:31:00', 'admin-1482550694-14825574598294263', 1, 1, 'SR', NULL, NULL, NULL),
(15749, '2016-12-24 13:31:00', NULL, NULL, 5447, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 13:31:00', 'admin-1482550694-14825574598294263', 1, 1, 'SR', NULL, NULL, NULL),
(15750, '2016-12-24 13:39:04', NULL, NULL, 5448, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 13:39:04', 'admin-1482550694-14825579445023774', 1, 0, '', NULL, NULL, NULL),
(15751, '2016-12-24 13:39:04', NULL, NULL, 5448, 0, 213, '147', 'Set Stir Fried Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 13:39:04', 'admin-1482550694-14825579445023774', 1, 0, '', NULL, NULL, NULL),
(15752, '2016-12-24 13:39:04', NULL, NULL, 5448, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 13:39:04', 'admin-1482550694-14825579445023774', 1, 1, 'SR', NULL, NULL, NULL),
(15753, '2016-12-24 13:53:19', NULL, NULL, 5449, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 13:53:19', 'admin-1482550694-1482558799395375', 1, 1, 'SR', NULL, NULL, NULL),
(15754, '2016-12-24 19:40:17', NULL, NULL, 5467, 0, 249, '183', 'Pan Roasted Pork Loin Chop', '', 'Meals', 'Perfect Meals', 1, 31.90, 31.9000, 0.0000, 31.90, 1, '27', 1, '1482580080', 'admin', '2016-12-24 19:40:17', 'admin-1482577544-14825796174742218', 1, 0, '', NULL, NULL, '10.0'),
(15755, '2016-12-24 19:24:33', NULL, NULL, 5462, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 19:24:33', 'admin-1482577544-14825786732701476', 1, 1, 'SR', NULL, NULL, NULL),
(15756, '2016-12-24 19:25:50', NULL, NULL, 5470, 0, 249, '183', 'Pan Roasted Pork Loin Chop', '', 'Meals', 'Perfect Meals', 1, 31.90, 31.9000, 0.0000, 31.90, 1, '27', 1, '1482580080', 'admin', '2016-12-24 19:25:50', 'admin-1482577544-14825787500667575', 1, 0, '', NULL, NULL, NULL),
(15757, '2016-12-24 19:58:24', NULL, NULL, 5473, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 19:58:24', 'admin-1482580080-14825807040245465', 1, 1, 'SR', NULL, NULL, NULL),
(15758, '2016-12-24 16:22:15', NULL, NULL, 5456, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 16:22:15', 'admin-1482558814-14825677355003311', 1, 1, 'SR', NULL, NULL, NULL),
(15759, '2016-12-24 16:23:35', NULL, NULL, 5457, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 16:23:35', 'admin-1482558814-14825678153169275', 1, 1, 'SR', NULL, NULL, NULL),
(15760, '2016-12-24 16:29:09', NULL, NULL, 5458, 0, 244, '178', 'Macadamia Scones', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 16:29:09', 'admin-1482558814-14825681490662738', 1, 0, '', NULL, NULL, NULL),
(15761, '2016-12-24 16:41:37', NULL, NULL, 5459, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 16:41:37', 'admin-1482558814-14825688976907777', 1, 1, 'SR', NULL, NULL, NULL),
(15762, '2016-12-24 16:57:12', NULL, NULL, 5460, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 16:57:12', 'admin-1482558814-14825698322885062', 1, 1, 'SR', NULL, NULL, NULL),
(15763, '2016-12-24 16:57:12', NULL, NULL, 5460, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 16:57:12', 'admin-1482558814-14825698322885062', 1, 1, 'SR', NULL, NULL, NULL),
(15764, '2016-12-24 16:57:12', NULL, NULL, 5460, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 16:57:12', 'admin-1482558814-14825698322885062', 1, 1, 'SR', NULL, NULL, NULL),
(15765, '2016-12-24 16:57:12', NULL, NULL, 5460, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 16:57:12', 'admin-1482558814-14825698322885062', 1, 0, '', NULL, NULL, NULL),
(15766, '2016-12-24 17:04:59', NULL, NULL, 5461, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 17:04:59', 'admin-1482558814-1482570299476848', 1, 1, 'SR', NULL, NULL, NULL),
(15767, '2016-12-24 17:04:59', NULL, NULL, 5461, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 17:04:59', 'admin-1482558814-1482570299476848', 1, 1, 'SR', NULL, NULL, NULL),
(15768, '2016-12-24 17:42:09', NULL, NULL, 5462, 0, 248, '182', 'The Cod Squad', '', 'Meals', 'Perfect Meals', 1, 28.90, 28.9000, 0.0000, 28.90, 1, '27', 1, '1482580080', 'admin', '2016-12-24 17:42:09', 'admin-1482558814-1482572529284241', 1, 0, '', NULL, NULL, NULL),
(15769, '2016-12-24 17:42:09', NULL, NULL, 5462, 0, 248, '182', 'The Cod Squad', '', 'Meals', 'Perfect Meals', 1, 28.90, 28.9000, 0.0000, 28.90, 1, '27', 1, '1482580080', 'admin', '2016-12-24 17:42:09', 'admin-1482558814-1482572529284241', 1, 0, '', NULL, NULL, NULL),
(15770, '2016-12-24 17:42:09', NULL, NULL, 5462, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 17:42:09', 'admin-1482558814-1482572529284241', 1, 0, '', NULL, NULL, NULL),
(15771, '2016-12-24 17:42:09', NULL, NULL, 5462, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 17:42:09', 'admin-1482558814-1482572529284241', 1, 0, '', NULL, NULL, NULL),
(15772, '2016-12-24 17:42:26', NULL, NULL, 5462, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 17:42:26', 'admin-1482558814-14825725467258862', 1, 0, '', NULL, NULL, NULL),
(15773, '2016-12-24 17:46:54', NULL, NULL, 5463, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 17:46:54', 'admin-1482558814-14825728147201929', 1, 1, 'SR', NULL, NULL, NULL),
(15774, '2016-12-24 17:48:58', NULL, NULL, 5462, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 17:48:58', 'admin-1482558814-14825729381543017', 1, 1, 'SR', NULL, NULL, NULL),
(15775, '2016-12-24 18:10:20', NULL, NULL, 5464, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 18:10:20', 'admin-1482558814-1482574220804571', 1, 0, '', NULL, NULL, NULL),
(15776, '2016-12-24 18:26:14', NULL, NULL, 5465, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 18:26:14', 'admin-1482558814-148257517390322', 1, 1, 'SR', NULL, NULL, NULL),
(15777, '2016-12-24 18:32:14', NULL, NULL, 5466, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 18:32:14', 'admin-1482558814-14825755340675460', 1, 0, '', NULL, NULL, NULL),
(15778, '2016-12-24 18:32:14', NULL, NULL, 5466, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 18:32:14', 'admin-1482558814-14825755340675460', 1, 0, '', NULL, NULL, NULL),
(15779, '2016-12-24 18:40:51', NULL, NULL, 5467, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 18:40:51', 'admin-1482558814-14825760513104654', 1, 0, '', NULL, NULL, '10.0'),
(15780, '2016-12-24 10:43:18', NULL, NULL, 5437, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:43:18', 'admin-1482545207-14825473981832734', 1, 0, '', NULL, NULL, NULL),
(15781, '2016-12-24 10:43:18', NULL, NULL, 5437, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:43:18', 'admin-1482545207-14825473981832734', 1, 1, 'SR', NULL, NULL, NULL),
(15782, '2016-12-24 10:46:20', NULL, NULL, 5434, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:46:20', 'admin-1482545207-14825475802051137', 1, 0, '', NULL, NULL, NULL),
(15783, '2016-12-24 10:46:20', NULL, NULL, 5434, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:46:20', 'admin-1482545207-14825475802051137', 1, 0, '', NULL, NULL, NULL),
(15784, '2016-12-24 11:04:50', NULL, NULL, 5438, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 11:04:50', 'admin-1482545207-1482548689877507', 1, 1, 'SR', NULL, NULL, NULL),
(15785, '2016-12-24 11:04:50', NULL, NULL, 5438, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 11:04:50', 'admin-1482545207-1482548689877507', 1, 1, 'SR', NULL, NULL, NULL),
(15786, '2016-12-24 11:04:50', NULL, NULL, 5438, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 11:04:50', 'admin-1482545207-1482548689877507', 1, 0, '', NULL, NULL, NULL),
(15787, '2016-12-24 11:04:50', NULL, NULL, 5438, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 11:04:50', 'admin-1482545207-1482548689877507', 1, 0, '', NULL, NULL, NULL),
(15788, '2016-12-24 10:31:18', NULL, NULL, 5436, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:31:18', 'admin-1482545207-1482546677751382', 1, 0, '', NULL, NULL, NULL),
(15789, '2016-12-24 10:31:18', NULL, NULL, 5436, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:31:18', 'admin-1482545207-1482546677751382', 1, 0, '', NULL, NULL, NULL),
(15790, '2016-12-24 19:19:52', NULL, NULL, 5471, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 19:19:52', 'admin-1482577544-14825783926978450', 1, 1, 'SR', NULL, NULL, NULL),
(15791, '2016-12-24 18:49:34', NULL, NULL, 5462, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 18:49:34', 'admin-1482558814-1482576574677416', 1, 0, '', NULL, NULL, NULL),
(15792, '2016-12-24 18:41:11', NULL, NULL, 5467, 0, 249, '183', 'Pan Roasted Pork Loin Chop', '', 'Meals', 'Perfect Meals', 1, 31.90, 31.9000, 0.0000, 31.90, 1, '27', 1, '1482580080', 'admin', '2016-12-24 18:41:11', 'admin-1482558814-14825760710055725', 1, 0, '', NULL, NULL, '10.0'),
(15793, '2016-12-24 18:41:11', NULL, NULL, 5467, 0, 248, '182', 'The Cod Squad', '', 'Meals', 'Perfect Meals', 1, 28.90, 28.9000, 0.0000, 28.90, 1, '27', 1, '1482580080', 'admin', '2016-12-24 18:41:11', 'admin-1482558814-14825760710055725', 1, 0, '', NULL, NULL, '10.0'),
(15794, '2016-12-24 13:53:19', NULL, NULL, 5449, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 13:53:19', 'admin-1482550694-1482558799395375', 1, 0, '', NULL, NULL, NULL),
(15795, '2016-12-24 13:53:19', NULL, NULL, 5449, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 13:53:19', 'admin-1482550694-1482558799395375', 1, 1, 'SR', NULL, NULL, NULL),
(15796, '2016-12-24 13:53:19', NULL, NULL, 5449, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 13:53:19', 'admin-1482550694-1482558799395375', 1, 0, '', NULL, NULL, NULL),
(15797, '2016-12-24 14:01:27', NULL, NULL, 5444, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 14:01:27', 'admin-1482558814-1482559287574324', 1, 1, 'SR', NULL, NULL, NULL),
(15798, '2016-12-24 14:13:13', NULL, NULL, 5444, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 14:13:13', 'admin-1482558814-14825599935423535', 1, 0, '', NULL, NULL, NULL),
(15799, '2016-12-24 14:27:36', NULL, NULL, 5450, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 14:27:36', 'admin-1482558814-1482560855864189', 1, 0, '', NULL, NULL, NULL),
(15800, '2016-12-24 14:27:36', NULL, NULL, 5450, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 14:27:36', 'admin-1482558814-1482560855864189', 1, 0, '', NULL, NULL, NULL),
(15801, '2016-12-24 14:38:22', NULL, NULL, 5452, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 14:38:22', 'admin-1482558814-14825615021803085', 1, 1, 'SR', NULL, NULL, NULL),
(15802, '2016-12-24 14:48:43', NULL, NULL, 5453, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 14:48:43', 'admin-1482558814-14825621229693230', 1, 1, 'SR', NULL, NULL, NULL),
(15803, '2016-12-24 14:48:43', NULL, NULL, 5453, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 14:48:43', 'admin-1482558814-14825621229693230', 1, 1, 'SR', NULL, NULL, NULL),
(15804, '2016-12-24 15:34:54', NULL, NULL, 5454, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 15:34:54', 'admin-1482558814-14825648943708277', 1, 1, 'SR', NULL, NULL, NULL),
(15805, '2016-12-24 15:53:05', NULL, NULL, 5455, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 15:53:05', 'admin-1482558814-14825659850634091', 1, 0, '', NULL, NULL, NULL),
(15806, '2016-12-24 15:53:05', NULL, NULL, 5455, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 15:53:05', 'admin-1482558814-14825659850634091', 1, 1, 'SR', NULL, NULL, NULL),
(15807, '2016-12-24 15:53:05', NULL, NULL, 5455, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 15:53:05', 'admin-1482558814-14825659850634091', 1, 1, 'SR', NULL, NULL, NULL),
(15808, '2016-12-24 16:22:15', NULL, NULL, 5456, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 16:22:15', 'admin-1482558814-14825677355003311', 1, 1, 'SR', NULL, NULL, NULL),
(15809, '2016-12-24 14:51:38', NULL, NULL, 5453, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 14:51:38', 'admin-1482558814-14825622981075911', 1, 1, 'SR', NULL, NULL, NULL),
(15810, '2016-12-24 19:58:24', NULL, NULL, 5473, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 19:58:24', 'admin-1482580080-14825807040245465', 1, 1, 'SR', NULL, NULL, NULL),
(15811, '2016-12-24 13:27:07', NULL, NULL, 5446, 0, 82, '82', 'Set Stir Fried Rice Wine Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 13:27:07', 'admin-1482550694-14825572270487712', 1, 1, 'SR', NULL, NULL, NULL),
(15812, '2016-12-24 13:23:14', NULL, NULL, 5446, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 13:23:14', 'admin-1482550694-14825569946968256', 1, 1, 'SR', NULL, NULL, NULL),
(15813, '2016-12-24 12:46:09', NULL, NULL, 5432, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 12:46:09', 'admin-1482550694-1482554769042934', 1, 1, 'SR', NULL, NULL, NULL),
(15814, '2016-12-24 12:45:32', NULL, NULL, 5444, 0, 214, '148', 'Set Fried Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 12:45:32', 'admin-1482550694-14825547320811921', 1, 0, '', NULL, NULL, NULL),
(15815, '2016-12-24 12:45:32', NULL, NULL, 5444, 0, 82, '82', 'Set Stir Fried Rice Wine Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 12:45:32', 'admin-1482550694-14825547320811921', 1, 1, 'SR', NULL, NULL, NULL),
(15816, '2016-12-24 12:45:32', NULL, NULL, 5444, 0, 82, '82', 'Set Stir Fried Rice Wine Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 12:45:32', 'admin-1482550694-14825547320811921', 1, 1, 'SR', NULL, NULL, NULL),
(15817, '2016-12-24 12:45:32', NULL, NULL, 5444, 0, 214, '148', 'Set Fried Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 12:45:32', 'admin-1482550694-14825547320811921', 1, 0, '', NULL, NULL, NULL),
(15818, '2016-12-24 12:14:04', NULL, NULL, 5442, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 12:14:04', 'admin-1482550694-1482552844444180', 1, 1, 'SR', NULL, NULL, NULL),
(15819, '2016-12-24 12:32:53', NULL, NULL, 5439, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 12:32:53', 'admin-1482550694-14825539736136785', 1, 0, '', NULL, NULL, NULL),
(15820, '2016-12-24 12:35:53', NULL, NULL, 5443, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 12:35:53', 'admin-1482550694-14825541529381755', 1, 1, 'SR', NULL, NULL, NULL),
(15821, '2016-12-24 00:00:00', NULL, NULL, 5441, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:43:18', 'admin-1482545207-14825473981832734', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(15822, '2016-12-24 11:45:37', NULL, NULL, 5432, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 11:45:37', 'admin-1482550694-14825511373663139', 1, 0, '', NULL, NULL, NULL),
(15823, '2016-12-24 11:35:49', NULL, NULL, 5439, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 11:35:49', 'admin-1482545207-14825505488416172', 1, 0, '', NULL, NULL, NULL),
(15824, '2016-12-24 11:35:49', NULL, NULL, 5439, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 11:35:49', 'admin-1482545207-14825505488416172', 1, 1, 'SR', NULL, NULL, NULL),
(15825, '2016-12-24 11:18:54', NULL, NULL, 5434, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 11:18:54', 'admin-1482545207-1482549533875455', 1, 1, 'SR', NULL, NULL, NULL),
(15826, '2016-12-24 11:35:49', NULL, NULL, 5439, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 11:35:49', 'admin-1482545207-14825505488416172', 1, 1, 'SR', NULL, NULL, NULL),
(15827, '2016-12-24 10:31:17', NULL, NULL, 5436, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:31:18', 'admin-1482545207-1482546677751382', 1, 0, '', NULL, NULL, NULL),
(15828, '2016-12-24 11:04:50', NULL, NULL, 5438, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 11:04:50', 'admin-1482545207-1482548689877507', 1, 0, '', NULL, NULL, NULL),
(15829, '2016-12-24 00:00:00', NULL, NULL, 5441, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:43:18', 'admin-1482545207-14825473981832734', 1, 0, '', NULL, NULL, NULL),
(15830, '2016-12-24 12:14:04', NULL, NULL, 5442, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 12:14:04', 'admin-1482550694-1482552844444180', 1, 0, '', NULL, NULL, NULL),
(15831, '2016-12-24 10:31:18', NULL, NULL, 5436, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:31:18', 'admin-1482545207-1482546677751382', 1, 0, '', NULL, NULL, NULL),
(15832, '2016-12-24 10:31:18', NULL, NULL, 5436, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:31:18', 'admin-1482545207-1482546677751382', 1, 1, 'SR', NULL, NULL, NULL),
(15833, '2016-12-24 10:36:23', NULL, NULL, 5436, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:36:23', 'admin-1482545207-14825469834891023', 1, 0, '', NULL, NULL, NULL),
(15834, '2016-12-24 10:31:17', NULL, NULL, 5436, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:31:17', 'admin-1482545207-1482546677751382', 1, 0, '', NULL, NULL, NULL),
(15835, '2016-12-24 10:31:18', NULL, NULL, 5436, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:31:18', 'admin-1482545207-1482546677751382', 1, 0, '', NULL, NULL, NULL),
(15836, '2016-12-24 10:30:52', NULL, NULL, 5435, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:30:52', 'admin-1482545207-14825466526715852', 1, 0, '', NULL, NULL, NULL),
(15837, '2016-12-24 10:31:17', NULL, NULL, 5436, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:31:17', 'admin-1482545207-1482546677751382', 1, 0, '', NULL, NULL, NULL),
(15838, '2016-12-24 10:21:55', NULL, NULL, 5434, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:21:55', 'admin-1482545207-14825461157393478', 1, 1, 'SR', NULL, NULL, NULL),
(15839, '2016-12-24 10:21:55', NULL, NULL, 5434, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:21:55', 'admin-1482545207-14825461157393478', 1, 1, 'SR', NULL, NULL, NULL),
(15840, '2016-12-24 10:21:55', NULL, NULL, 5434, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:21:55', 'admin-1482545207-14825461157393478', 1, 1, 'SR', NULL, NULL, NULL),
(15841, '2016-12-24 10:21:55', NULL, NULL, 5434, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:21:55', 'admin-1482545207-14825461157393478', 1, 1, 'SR', NULL, NULL, NULL),
(15842, '2016-12-24 10:21:55', NULL, NULL, 5434, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:21:55', 'admin-1482545207-14825461157393478', 1, 1, 'SR', NULL, NULL, NULL),
(15843, '2016-12-24 10:30:11', NULL, NULL, 5434, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:30:11', 'admin-1482545207-14825466113782384', 1, 0, '', NULL, NULL, NULL),
(15844, '2016-12-24 10:30:11', NULL, NULL, 5434, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:30:11', 'admin-1482545207-14825466113782384', 1, 0, '', NULL, NULL, NULL),
(15845, '2016-12-24 10:30:11', NULL, NULL, 5434, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:30:11', 'admin-1482545207-14825466113782384', 1, 0, '', NULL, NULL, NULL),
(15846, '2016-12-24 10:30:11', NULL, NULL, 5434, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:30:11', 'admin-1482545207-14825466113782384', 1, 0, '', NULL, NULL, NULL),
(15847, '2016-12-24 10:30:11', NULL, NULL, 5434, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:30:11', 'admin-1482545207-14825466113782384', 1, 0, '', NULL, NULL, NULL),
(15848, '2016-12-24 10:30:52', NULL, NULL, 5435, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:30:52', 'admin-1482545207-14825466526715852', 1, 0, '', NULL, NULL, NULL),
(15849, '2016-12-24 10:30:52', NULL, NULL, 5435, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:30:52', 'admin-1482545207-14825466526715852', 1, 0, '', NULL, NULL, NULL),
(15850, '2016-12-24 10:06:41', NULL, NULL, 5433, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:06:41', 'admin-1482539999-14825452017483948', 1, 0, '', NULL, NULL, NULL),
(15851, '2016-12-24 10:06:57', NULL, NULL, 5432, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:06:57', 'admin-1482545207-14825452176351819', 1, 1, 'SR', NULL, NULL, NULL),
(15852, '2016-12-24 10:06:57', NULL, NULL, 5432, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:06:57', 'admin-1482545207-14825452176351819', 1, 0, '', NULL, NULL, NULL),
(15853, '2016-12-24 10:07:11', NULL, NULL, 5433, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:07:11', 'admin-1482545207-1482545230972831', 1, 1, 'SR', NULL, NULL, NULL),
(15854, '2016-12-24 10:07:11', NULL, NULL, 5433, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:07:11', 'admin-1482545207-1482545230972831', 1, 1, 'SR', NULL, NULL, NULL),
(15855, '2016-12-24 10:21:55', NULL, NULL, 5434, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:21:55', 'admin-1482545207-14825461157393478', 1, 1, 'SR', NULL, NULL, NULL),
(15856, '2016-12-24 10:21:55', NULL, NULL, 5434, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:21:55', 'admin-1482545207-14825461157393478', 1, 1, 'SR', NULL, NULL, NULL),
(15857, '2016-12-24 10:06:41', NULL, NULL, 5433, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 10:06:41', 'admin-1482539999-14825452017483948', 1, 0, '', NULL, NULL, NULL),
(15858, '2016-12-24 09:55:03', NULL, NULL, 5432, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 09:55:03', 'admin-1482539999-14825445037087582', 1, 0, '', NULL, NULL, NULL),
(15859, '2016-12-24 09:55:03', NULL, NULL, 5432, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 09:55:03', 'admin-1482539999-14825445037087582', 1, 0, '', NULL, NULL, NULL),
(15860, '2016-12-24 09:18:04', NULL, NULL, 5431, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 09:18:04', 'admin-1482539999-14825422845563378', 1, 1, 'SR', NULL, NULL, NULL),
(15861, '2016-12-24 09:12:46', NULL, NULL, 5430, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 09:12:46', 'admin-1482539999-14825419667482032', 1, 1, 'SR', NULL, NULL, NULL),
(15862, '2016-12-24 09:10:06', NULL, NULL, 5429, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 09:10:06', 'admin-1482539999-14825418068195812', 1, 0, '', NULL, NULL, NULL),
(15863, '2016-12-24 09:12:46', NULL, NULL, 5430, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 09:12:46', 'admin-1482539999-14825419667482032', 1, 0, '', NULL, NULL, NULL),
(15864, '2016-12-24 09:12:46', NULL, NULL, 5430, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 09:12:46', 'admin-1482539999-14825419667482032', 1, 0, '', NULL, NULL, NULL),
(15865, '2016-12-24 09:10:06', NULL, NULL, 5429, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 09:10:06', 'admin-1482539999-14825418068195812', 1, 1, 'SR', NULL, NULL, NULL),
(15866, '2016-12-24 09:09:30', NULL, NULL, 5428, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 09:09:30', 'admin-1482539999-14825417702413013', 1, 1, 'SR', NULL, NULL, NULL),
(15867, '2016-12-24 09:08:20', NULL, NULL, 5427, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 09:08:20', 'admin-1482539999-14825417002044186', 1, 1, 'SR', NULL, NULL, NULL),
(15868, '2016-12-24 09:09:30', NULL, NULL, 5428, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 09:09:30', 'admin-1482539999-14825417702413013', 1, 1, 'SR', NULL, NULL, NULL),
(15869, '2016-12-24 09:08:20', NULL, NULL, 5427, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 09:08:20', 'admin-1482539999-14825417002044186', 1, 1, 'SR', NULL, NULL, NULL),
(15870, '2016-12-24 09:08:20', NULL, NULL, 5427, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 09:08:20', 'admin-1482539999-14825417002044186', 1, 0, '', NULL, NULL, NULL),
(15871, '2016-12-24 09:05:28', NULL, NULL, 5426, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482580080', 'admin', '2016-12-24 09:05:28', 'admin-1482539999-148254152876194', 1, 1, 'SR', NULL, NULL, NULL),
(15872, '2016-12-25 19:27:20', NULL, NULL, 5538, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 19:27:20', 'admin-1482651451-14826652404543754', 1, 0, '', NULL, NULL, NULL),
(15873, '2016-12-25 19:36:25', NULL, NULL, 5539, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 19:36:25', 'admin-1482665607-14826657848653843', 1, 1, 'SR', NULL, NULL, NULL),
(15874, '2016-12-25 20:27:20', NULL, NULL, 5538, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 20:27:20', 'admin-1482665607-148266883999739', 1, 0, '', NULL, NULL, NULL),
(15875, '2016-12-25 20:57:10', NULL, NULL, 5540, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 20:57:10', 'admin-1482665607-1482670629857857', 1, 0, '', NULL, NULL, NULL),
(15876, '2016-12-25 19:27:20', NULL, NULL, 5538, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 19:27:20', 'admin-1482651451-14826652404543754', 1, 1, 'SR', NULL, NULL, NULL),
(15877, '2016-12-25 19:27:20', NULL, NULL, 5538, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 19:27:20', 'admin-1482651451-14826652404543754', 1, 0, '', NULL, NULL, NULL),
(15878, '2016-12-25 19:27:20', NULL, NULL, 5538, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 19:27:20', 'admin-1482651451-14826652404543754', 1, 0, '', NULL, NULL, NULL),
(15879, '2016-12-25 19:26:33', NULL, NULL, 5538, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 19:26:33', 'admin-1482651451-1482665193475358', 1, 0, '', NULL, NULL, NULL),
(15880, '2016-12-25 19:26:49', NULL, NULL, 5538, 0, 250, '185', 'Double Trouble Burger', '', 'Meals', 'Perfect Meals', 1, 28.90, 28.9000, 0.0000, 28.90, 1, '27', 1, '1482665607', 'admin', '2016-12-25 19:26:49', 'admin-1482651451-14826652092827349', 1, 0, '', NULL, NULL, NULL),
(15881, '2016-12-25 19:26:49', NULL, NULL, 5538, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 19:26:49', 'admin-1482651451-14826652092827349', 1, 0, '', NULL, NULL, NULL),
(15882, '2016-12-25 19:01:10', NULL, NULL, 5537, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 19:01:10', 'admin-1482651451-14826636707115192', 1, 1, 'SR', NULL, NULL, NULL),
(15883, '2016-12-25 19:00:40', NULL, NULL, 5536, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 19:00:40', 'admin-1482651451-14826636407798219', 1, 1, 'SR', NULL, NULL, NULL),
(15884, '2016-12-25 18:59:48', NULL, NULL, 5535, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 18:59:48', 'admin-1482651451-1482663588207393', 1, 0, '', NULL, NULL, NULL),
(15885, '2016-12-25 18:59:48', NULL, NULL, 5535, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 18:59:48', 'admin-1482651451-1482663588207393', 1, 1, 'SR', NULL, NULL, NULL),
(15886, '2016-12-25 18:51:30', NULL, NULL, 5534, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 18:51:30', 'admin-1482651451-14826630905214512', 1, 1, 'SR', NULL, NULL, NULL),
(15887, '2016-12-25 18:51:30', NULL, NULL, 5534, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 18:51:30', 'admin-1482651451-14826630905214512', 1, 1, 'SR', NULL, NULL, NULL),
(15888, '2016-12-25 18:51:17', NULL, NULL, 5534, 0, 252, '186', 'Dinner Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 26.90, 26.9000, 0.0000, 26.90, 1, '27', 1, '1482665607', 'admin', '2016-12-25 18:51:17', 'admin-1482651451-14826630768394343', 1, 0, '', NULL, NULL, NULL),
(15889, '2016-12-25 18:51:17', NULL, NULL, 5534, 0, 251, '184', 'Dinner Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 26.90, 26.9000, 0.0000, 26.90, 1, '27', 1, '1482665607', 'admin', '2016-12-25 18:51:17', 'admin-1482651451-14826630768394343', 1, 0, '', NULL, NULL, NULL),
(15890, '2016-12-25 18:51:17', NULL, NULL, 5534, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 18:51:17', 'admin-1482651451-14826630768394343', 1, 0, '', NULL, NULL, NULL),
(15891, '2016-12-25 18:51:17', NULL, NULL, 5534, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 18:51:17', 'admin-1482651451-14826630768394343', 1, 0, '', NULL, NULL, NULL),
(15892, '2016-12-25 18:51:17', NULL, NULL, 5534, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 18:51:17', 'admin-1482651451-14826630768394343', 1, 0, '', NULL, NULL, NULL),
(15893, '2016-12-25 18:45:28', NULL, NULL, 5528, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 18:45:28', 'admin-1482651451-14826627279109375', 1, 0, '', NULL, NULL, NULL),
(15894, '2016-12-25 18:36:07', NULL, NULL, 5532, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 18:36:07', 'admin-1482651451-14826621677604586', 1, 1, 'SR', NULL, NULL, NULL),
(15895, '2016-12-25 18:36:07', NULL, NULL, 5532, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 18:36:07', 'admin-1482651451-14826621677604586', 1, 1, 'SR', NULL, NULL, NULL),
(15896, '2016-12-25 18:17:59', NULL, NULL, 5531, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 18:17:59', 'admin-1482651451-1482661079151652', 1, 1, 'SR', NULL, NULL, NULL),
(15897, '2016-12-25 17:39:38', NULL, NULL, 5528, 0, 250, '185', 'Double Trouble Burger', '', 'Meals', 'Perfect Meals', 1, 28.90, 28.9000, 0.0000, 28.90, 1, '27', 1, '1482665607', 'admin', '2016-12-25 17:39:38', 'admin-1482651451-14826587778879257', 1, 0, '', NULL, NULL, NULL),
(15898, '2016-12-25 17:39:38', NULL, NULL, 5528, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 17:39:38', 'admin-1482651451-14826587778879257', 1, 1, 'SR', NULL, NULL, NULL),
(15899, '2016-12-25 17:40:05', NULL, NULL, 5529, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 17:40:05', 'admin-1482651451-14826588054943124', 1, 1, 'SR', NULL, NULL, NULL),
(15900, '2016-12-25 17:40:05', NULL, NULL, 5529, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 17:40:05', 'admin-1482651451-14826588054943124', 1, 1, 'SR', NULL, NULL, NULL),
(15901, '2016-12-25 17:40:05', NULL, NULL, 5529, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 17:40:05', 'admin-1482651451-14826588054943124', 1, 1, 'SR', NULL, NULL, NULL),
(15902, '2016-12-25 18:12:13', NULL, NULL, 5530, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 18:12:13', 'admin-1482651451-14826607328248589', 1, 1, 'SR', NULL, NULL, NULL),
(15903, '2016-12-25 17:37:44', NULL, NULL, 5527, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 17:37:44', 'admin-1482651451-14826586639347442', 1, 0, '', NULL, NULL, NULL),
(15904, '2016-12-25 17:38:09', NULL, NULL, 5527, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 17:38:09', 'admin-1482651451-14826586891686316', 1, 0, '', NULL, NULL, NULL),
(15905, '2016-12-25 17:39:38', NULL, NULL, 5528, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 17:39:38', 'admin-1482651451-14826587778879257', 1, 0, '', NULL, NULL, NULL),
(15906, '2016-12-25 16:57:34', NULL, NULL, 5517, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 16:57:34', 'admin-1482651451-14826562544093359', 1, 1, 'SR', NULL, NULL, NULL),
(15907, '2016-12-25 17:10:06', NULL, NULL, 5525, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 17:10:06', 'admin-1482651451-14826570065359569', 1, 1, 'SR', NULL, NULL, NULL),
(15908, '2016-12-25 17:10:06', NULL, NULL, 5525, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 17:10:06', 'admin-1482651451-14826570065359569', 1, 0, '', NULL, NULL, NULL),
(15909, '2016-12-25 17:10:06', NULL, NULL, 5525, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 17:10:06', 'admin-1482651451-14826570065359569', 1, 0, '', NULL, NULL, NULL),
(15910, '2016-12-25 17:10:54', NULL, NULL, 5526, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 17:10:54', 'admin-1482651451-1482657054529187', 1, 1, 'SR', NULL, NULL, NULL),
(15911, '2016-12-25 16:02:51', NULL, NULL, 5520, 0, 244, '178', 'Macadamia Scones', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 16:02:51', 'admin-1482651451-14826529715877652', 1, 0, '', NULL, NULL, NULL),
(15912, '2016-12-25 13:36:32', NULL, NULL, 5510, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:36:32', 'admin-1482643824-14826441921953281', 1, 0, '', NULL, NULL, NULL),
(15913, '2016-12-25 13:36:32', NULL, NULL, 5510, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:36:32', 'admin-1482643824-14826441921953281', 1, 0, '', NULL, NULL, NULL),
(15914, '2016-12-25 17:36:36', NULL, NULL, 5527, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 17:36:36', 'admin-1482651451-14826585963434919', 1, 1, 'SR', NULL, NULL, NULL),
(15915, '2016-12-25 15:40:02', NULL, NULL, 5517, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 15:40:02', 'admin-1482651451-14826516025744091', 1, 1, 'SR', NULL, NULL, NULL),
(15916, '2016-12-25 15:50:25', NULL, NULL, 5518, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 15:50:25', 'admin-1482651451-14826522250549755', 1, 0, '', NULL, NULL, NULL),
(15917, '2016-12-25 15:51:51', NULL, NULL, 5518, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 15:51:51', 'admin-1482651451-14826523108882132', 1, 0, '', NULL, NULL, NULL),
(15918, '2016-12-25 15:51:51', NULL, NULL, 5518, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 15:51:51', 'admin-1482651451-14826523108882132', 1, 1, 'SR', NULL, NULL, NULL),
(15919, '2016-12-25 15:51:51', NULL, NULL, 5518, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 15:51:51', 'admin-1482651451-14826523108882132', 1, 1, 'SR', NULL, NULL, NULL),
(15920, '2016-12-25 12:12:29', NULL, NULL, 5495, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 12:12:29', 'admin-1482633309-1482639148909740', 1, 1, 'SR', NULL, NULL, NULL),
(15921, '2016-12-25 12:32:20', NULL, NULL, 5503, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 12:32:20', 'admin-1482633309-14826403400265814', 1, 1, 'SR', NULL, NULL, NULL),
(15922, '2016-12-25 12:32:20', NULL, NULL, 5503, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 12:32:20', 'admin-1482633309-14826403400265814', 1, 1, 'SR', NULL, NULL, NULL),
(15923, '2016-12-25 12:32:20', NULL, NULL, 5503, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 12:32:20', 'admin-1482633309-14826403400265814', 1, 0, '', NULL, NULL, NULL),
(15924, '2016-12-25 12:32:20', NULL, NULL, 5503, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 12:32:20', 'admin-1482633309-14826403400265814', 1, 0, '', NULL, NULL, NULL),
(15925, '2016-12-25 12:33:03', NULL, NULL, 5504, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 12:33:03', 'admin-1482633309-14826403836303435', 1, 0, '', NULL, NULL, NULL),
(15926, '2016-12-25 12:36:59', NULL, NULL, 5505, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 12:36:59', 'admin-1482633309-14826406195539049', 1, 1, 'SR', NULL, NULL, NULL),
(15927, '2016-12-25 17:36:36', NULL, NULL, 5527, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 17:36:36', 'admin-1482651451-14826585963434919', 1, 1, 'SR', NULL, NULL, NULL),
(15928, '2016-12-25 17:10:54', NULL, NULL, 5526, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 17:10:54', 'admin-1482651451-1482657054529187', 1, 0, '', NULL, NULL, NULL),
(15929, '2016-12-25 16:56:17', NULL, NULL, 5524, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 16:56:17', 'admin-1482651451-1482656176989339', 1, 1, 'SR', NULL, NULL, NULL),
(15930, '2016-12-25 16:40:20', NULL, NULL, 5523, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 16:40:20', 'admin-1482651451-14826552206258524', 1, 0, '', NULL, NULL, NULL),
(15931, '2016-12-25 16:40:20', NULL, NULL, 5523, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 16:40:20', 'admin-1482651451-14826552206258524', 1, 1, 'SR', NULL, NULL, NULL),
(15932, '2016-12-25 16:40:20', NULL, NULL, 5523, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 16:40:20', 'admin-1482651451-14826552206258524', 1, 0, '', NULL, NULL, NULL),
(15933, '2016-12-25 16:23:02', NULL, NULL, 5522, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 16:23:02', 'admin-1482651451-14826541822702534', 1, 0, '', NULL, NULL, NULL),
(15934, '2016-12-25 16:23:02', NULL, NULL, 5522, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 16:23:02', 'admin-1482651451-14826541822702534', 1, 0, '', NULL, NULL, NULL),
(15935, '2016-12-25 16:14:06', NULL, NULL, 5515, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 16:14:06', 'admin-1482651451-14826536458826280', 1, 0, '', NULL, NULL, NULL),
(15936, '2016-12-25 13:27:55', NULL, NULL, 5509, 0, 85, '85', 'Set Meatless Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:27:55', 'admin-1482633309-14826436754931780', 1, 1, 'SR', NULL, NULL, NULL),
(15937, '2016-12-25 13:27:55', NULL, NULL, 5509, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:27:55', 'admin-1482633309-14826436754931780', 1, 1, 'SR', NULL, NULL, NULL),
(15938, '2016-12-25 13:31:30', NULL, NULL, 5503, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:31:30', 'admin-1482643824-14826438900849026', 1, 0, '', NULL, NULL, NULL),
(15939, '2016-12-25 13:35:23', NULL, NULL, 5510, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:35:23', 'admin-1482643824-14826441235124753', 1, 1, 'SR', NULL, NULL, NULL),
(15940, '2016-12-25 13:35:23', NULL, NULL, 5510, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:35:23', 'admin-1482643824-14826441235124753', 1, 1, 'SR', NULL, NULL, NULL),
(15941, '2016-12-25 13:36:04', NULL, NULL, 5510, 0, 213, '147', 'Set Stir Fried Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:36:04', 'admin-1482643824-14826441643593487', 1, 0, '', NULL, NULL, NULL),
(15942, '2016-12-25 13:36:04', NULL, NULL, 5510, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:36:04', 'admin-1482643824-14826441643593487', 1, 1, 'SR', NULL, NULL, NULL),
(15943, '2016-12-25 16:09:25', NULL, NULL, 5521, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 16:09:25', 'admin-1482651451-14826533656404419', 1, 1, 'SR', NULL, NULL, NULL),
(15944, '2016-12-25 16:00:36', NULL, NULL, 5519, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 16:00:36', 'admin-1482651451-1482652836650906', 1, 1, 'SR', NULL, NULL, NULL),
(15945, '2016-12-25 10:52:45', NULL, NULL, 5491, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:52:45', 'admin-1482633309-14826343650657370', 1, 0, '', NULL, NULL, NULL),
(15946, '2016-12-25 10:52:45', NULL, NULL, 5491, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:52:45', 'admin-1482633309-14826343650657370', 1, 0, '', NULL, NULL, NULL),
(15947, '2016-12-25 10:52:45', NULL, NULL, 5491, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:52:45', 'admin-1482633309-14826343650657370', 1, 0, '', NULL, NULL, NULL),
(15948, '2016-12-25 10:52:45', NULL, NULL, 5491, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:52:45', 'admin-1482633309-14826343650657370', 1, 0, '', NULL, NULL, NULL),
(15949, '2016-12-25 10:52:51', NULL, NULL, 5491, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:52:51', 'admin-1482633309-14826343712718074', 1, 1, 'SR', NULL, NULL, NULL),
(15950, '2016-12-25 10:52:51', NULL, NULL, 5491, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:52:51', 'admin-1482633309-14826343712718074', 1, 1, 'SR', NULL, NULL, NULL),
(15951, '2016-12-25 10:57:25', NULL, NULL, 5492, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:57:25', 'admin-1482633309-14826346450934722', 1, 0, '', NULL, NULL, NULL),
(15952, '2016-12-25 11:18:58', NULL, NULL, 5493, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 11:18:58', 'admin-1482633309-14826359379673965', 1, 0, '', NULL, NULL, NULL),
(15953, '2016-12-25 11:18:58', NULL, NULL, 5493, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 11:18:58', 'admin-1482633309-14826359379673965', 1, 1, 'SR', NULL, NULL, NULL),
(15954, '2016-12-25 11:18:58', NULL, NULL, 5493, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 11:18:58', 'admin-1482633309-14826359379673965', 1, 1, 'SR', NULL, NULL, NULL),
(15955, '2016-12-25 11:19:36', NULL, NULL, 5494, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 11:19:36', 'admin-1482633309-14826359763052352', 1, 1, 'SR', NULL, NULL, NULL),
(15956, '2016-12-25 11:26:50', NULL, NULL, 5495, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 11:26:50', 'admin-1482633309-14826364098998484', 1, 1, 'SR', NULL, NULL, NULL),
(15957, '2016-12-25 11:26:50', NULL, NULL, 5495, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 11:26:50', 'admin-1482633309-14826364098998484', 1, 0, '', NULL, NULL, NULL),
(15958, '2016-12-25 11:27:37', NULL, NULL, 5494, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 11:27:37', 'admin-1482633309-14826364577321172', 1, 1, 'SR', NULL, NULL, NULL),
(15959, '2016-12-25 11:34:33', NULL, NULL, 5481, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 11:34:33', 'admin-1482633309-14826368728834149', 1, 0, '', NULL, NULL, NULL),
(15960, '2016-12-25 11:35:20', NULL, NULL, 5496, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 11:35:20', 'admin-1482633309-14826369201466235', 1, 1, 'SR', NULL, NULL, NULL),
(15961, '2016-12-25 11:35:34', NULL, NULL, 5496, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 11:35:34', 'admin-1482633309-14826369341977996', 1, 0, '', NULL, NULL, NULL),
(15962, '2016-12-25 11:40:07', NULL, NULL, 5497, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 11:40:07', 'admin-1482633309-14826372073869598', 1, 0, '', NULL, NULL, NULL),
(15963, '2016-12-25 11:40:07', NULL, NULL, 5497, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 11:40:07', 'admin-1482633309-14826372073869598', 1, 0, '', NULL, NULL, NULL),
(15964, '2016-12-25 11:40:21', NULL, NULL, 5497, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 11:40:21', 'admin-1482633309-14826372211382452', 1, 0, '', NULL, NULL, NULL),
(15965, '2016-12-25 11:40:21', NULL, NULL, 5497, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 11:40:21', 'admin-1482633309-14826372211382452', 1, 1, 'SR', NULL, NULL, NULL),
(15966, '2016-12-25 11:41:38', NULL, NULL, 5498, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 11:41:38', 'admin-1482633309-14826372979045183', 1, 0, '', NULL, NULL, NULL),
(15967, '2016-12-25 11:41:38', NULL, NULL, 5498, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 11:41:38', 'admin-1482633309-14826372979045183', 1, 0, '', NULL, NULL, NULL),
(15968, '2016-12-25 11:41:38', NULL, NULL, 5498, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 11:41:38', 'admin-1482633309-14826372979045183', 1, 1, 'SR', NULL, NULL, NULL),
(15969, '2016-12-25 11:41:38', NULL, NULL, 5498, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 11:41:38', 'admin-1482633309-14826372979045183', 1, 0, '', NULL, NULL, NULL),
(15970, '2016-12-25 11:41:38', NULL, NULL, 5498, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 11:41:38', 'admin-1482633309-14826372979045183', 1, 0, '', NULL, NULL, NULL),
(15971, '2016-12-25 00:00:00', NULL, NULL, 5499, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:35:33', 'admin-1482633309-14826333331041064', 1, 1, 'SR', NULL, NULL, NULL),
(15972, '2016-12-25 12:11:29', NULL, NULL, 5502, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 12:11:29', 'admin-1482633309-14826390897588522', 1, 0, '', NULL, NULL, NULL),
(15973, '2016-12-25 12:12:13', NULL, NULL, 5502, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 12:12:13', 'admin-1482633309-1482639133376421', 1, 1, 'SR', NULL, NULL, NULL),
(15974, '2016-12-25 10:37:05', NULL, NULL, 5488, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:37:05', 'admin-1482633309-14826334254823234', 1, 0, '', NULL, NULL, NULL),
(15975, '2016-12-25 10:37:05', NULL, NULL, 5488, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:37:05', 'admin-1482633309-14826334254823234', 1, 0, '', NULL, NULL, NULL),
(15976, '2016-12-25 10:37:05', NULL, NULL, 5488, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:37:05', 'admin-1482633309-14826334254823234', 1, 0, '', NULL, NULL, NULL),
(15977, '2016-12-25 18:36:45', NULL, NULL, 5533, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 18:36:46', 'admin-1482651451-1482662205807422', 1, 0, '', NULL, NULL, NULL),
(15978, '2016-12-25 16:14:06', NULL, NULL, 5515, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 16:14:06', 'admin-1482651451-14826536458826280', 1, 1, 'SR', NULL, NULL, NULL),
(15979, '2016-12-25 16:02:51', NULL, NULL, 5520, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 16:02:51', 'admin-1482651451-14826529715877652', 1, 1, 'SR', NULL, NULL, NULL),
(15980, '2016-12-25 15:21:36', NULL, NULL, 5516, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 15:21:36', 'admin-1482643824-14826504959607881', 1, 1, 'SR', NULL, NULL, NULL),
(15981, '2016-12-25 15:09:15', NULL, NULL, 5514, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 15:09:15', 'admin-1482643824-14826497553726327', 1, 1, 'SR', NULL, NULL, NULL),
(15982, '2016-12-25 15:17:16', NULL, NULL, 5515, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 15:17:16', 'admin-1482643824-14826502362522572', 1, 1, 'SR', NULL, NULL, NULL),
(15983, '2016-12-25 15:17:16', NULL, NULL, 5515, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 15:17:16', 'admin-1482643824-14826502362522572', 1, 0, '', NULL, NULL, NULL),
(15984, '2016-12-25 15:06:00', NULL, NULL, 5514, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 15:06:00', 'admin-1482643824-14826495598504937', 1, 1, 'SR', NULL, NULL, NULL),
(15985, '2016-12-25 14:44:43', NULL, NULL, 5514, 0, 214, '148', 'Set Fried Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 14:44:43', 'admin-1482643824-14826482835691290', 1, 0, '', NULL, NULL, NULL),
(15986, '2016-12-25 14:44:43', NULL, NULL, 5514, 0, 213, '147', 'Set Stir Fried Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 14:44:43', 'admin-1482643824-14826482835691290', 1, 0, '', NULL, NULL, NULL),
(15987, '2016-12-25 15:37:24', NULL, NULL, 5507, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 15:37:24', 'admin-1482643824-14826514445149143', 1, 0, '', NULL, NULL, NULL),
(15988, '2016-12-25 14:18:41', NULL, NULL, 5507, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 14:18:41', 'admin-1482643824-14826467208451667', 1, 0, '', NULL, NULL, NULL),
(15989, '2016-12-25 14:16:49', NULL, NULL, 5510, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 14:16:49', 'admin-1482643824-14826466092797061', 1, 0, '', NULL, NULL, NULL),
(15990, '2016-12-25 14:06:01', NULL, NULL, 5512, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 14:06:01', 'admin-1482643824-14826459610882239', 1, 1, 'SR', NULL, NULL, NULL),
(15991, '2016-12-25 13:52:13', NULL, NULL, 5513, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:52:13', 'admin-1482643824-14826451330432115', 1, 0, '', NULL, NULL, NULL),
(15992, '2016-12-25 13:52:13', NULL, NULL, 5513, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:52:13', 'admin-1482643824-14826451330432115', 1, 0, '', NULL, NULL, NULL),
(15993, '2016-12-25 13:52:13', NULL, NULL, 5513, 0, 213, '147', 'Set Stir Fried Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:52:13', 'admin-1482643824-14826451330432115', 1, 0, '', NULL, NULL, NULL),
(15994, '2016-12-25 13:40:03', NULL, NULL, 5512, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:40:03', 'admin-1482643824-14826444034762699', 1, 1, 'SR', NULL, NULL, NULL),
(15995, '2016-12-25 13:37:06', NULL, NULL, 5511, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:37:06', 'admin-1482643824-14826442260257526', 1, 1, 'SR', NULL, NULL, NULL),
(15996, '2016-12-25 13:40:03', NULL, NULL, 5512, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:40:03', 'admin-1482643824-14826444034762699', 1, 0, '', NULL, NULL, NULL),
(15997, '2016-12-25 13:36:32', NULL, NULL, 5510, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:36:32', 'admin-1482643824-14826441921953281', 1, 1, 'SR', NULL, NULL, NULL),
(15998, '2016-12-25 17:39:38', NULL, NULL, 5528, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 17:39:38', 'admin-1482651451-14826587778879257', 1, 0, '', NULL, NULL, NULL),
(15999, '2016-12-25 13:36:32', NULL, NULL, 5510, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:36:32', 'admin-1482643824-14826441921953281', 1, 1, 'SR', NULL, NULL, NULL),
(16000, '2016-12-25 13:27:55', NULL, NULL, 5509, 0, 85, '85', 'Set Meatless Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:27:55', 'admin-1482633309-14826436754931780', 1, 1, 'SR', NULL, NULL, NULL),
(16001, '2016-12-25 12:12:29', NULL, NULL, 5495, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 12:12:29', 'admin-1482633309-1482639148909740', 1, 0, '', NULL, NULL, NULL),
(16002, '2016-12-25 13:10:35', NULL, NULL, 5508, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:10:35', 'admin-1482633309-14826426348644414', 1, 1, 'SR', NULL, NULL, NULL),
(16003, '2016-12-25 13:10:35', NULL, NULL, 5508, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:10:35', 'admin-1482633309-14826426348644414', 1, 1, 'SR', NULL, NULL, NULL),
(16004, '2016-12-25 13:11:19', NULL, NULL, 5508, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:11:19', 'admin-1482633309-14826426791987262', 1, 0, '', NULL, NULL, NULL),
(16005, '2016-12-25 13:27:55', NULL, NULL, 5509, 0, 85, '85', 'Set Meatless Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:27:55', 'admin-1482633309-14826436754931780', 1, 1, 'SR', NULL, NULL, NULL),
(16006, '2016-12-25 13:04:10', NULL, NULL, 5507, 0, 214, '148', 'Set Fried Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:04:10', 'admin-1482633309-14826422501036271', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(16007, '2016-12-25 13:04:10', NULL, NULL, 5507, 0, 82, '82', 'Set Stir Fried Rice Wine Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 13:04:10', 'admin-1482633309-14826422501036271', 1, 1, 'SR', NULL, NULL, NULL),
(16008, '2016-12-25 12:46:46', NULL, NULL, 5506, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 12:46:46', 'admin-1482633309-14826412059652430', 1, 1, 'SR', NULL, NULL, NULL),
(16009, '2016-12-25 12:46:46', NULL, NULL, 5506, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 12:46:46', 'admin-1482633309-14826412059652430', 1, 1, 'SR', NULL, NULL, NULL),
(16010, '2016-12-25 12:12:13', NULL, NULL, 5502, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 12:12:13', 'admin-1482633309-1482639133376421', 1, 0, '', NULL, NULL, NULL),
(16011, '2016-12-25 10:51:32', NULL, NULL, 5490, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:51:32', 'admin-1482633309-14826342925393218', 1, 1, 'SR', NULL, NULL, NULL),
(16012, '2016-12-25 16:02:51', NULL, NULL, 5520, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 16:02:51', 'admin-1482651451-14826529715877652', 1, 0, '', NULL, NULL, NULL),
(16013, '2016-12-25 12:12:13', NULL, NULL, 5502, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 12:12:13', 'admin-1482633309-1482639133376421', 1, 1, 'SR', NULL, NULL, NULL),
(16014, '2016-12-25 10:51:32', NULL, NULL, 5490, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:51:32', 'admin-1482633309-14826342925393218', 1, 1, 'SR', NULL, NULL, NULL),
(16015, '2016-12-25 10:37:05', NULL, NULL, 5488, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:37:05', 'admin-1482633309-14826334254823234', 1, 1, 'SR', NULL, NULL, NULL),
(16016, '2016-12-25 10:36:20', NULL, NULL, 5487, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:36:20', 'admin-1482633309-14826333800594534', 1, 0, '', NULL, NULL, NULL),
(16017, '2016-12-25 10:36:26', NULL, NULL, 5487, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:36:26', 'admin-1482633309-14826333865411276', 1, 1, 'SR', NULL, NULL, NULL),
(16018, '2016-12-25 00:00:00', NULL, NULL, 5499, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:34:34', 'admin-1482626290-14826332738242139', 1, 0, '', NULL, NULL, NULL),
(16019, '2016-12-25 10:02:18', NULL, NULL, 5481, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:02:18', 'admin-1482626290-14826313387235952', 1, 0, '', NULL, NULL, NULL),
(16020, '2016-12-25 10:02:18', NULL, NULL, 5481, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:02:18', 'admin-1482626290-14826313387235952', 1, 0, '', NULL, NULL, NULL),
(16021, '2016-12-25 10:36:20', NULL, NULL, 5487, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:36:20', 'admin-1482633309-14826333800594534', 1, 0, '', NULL, NULL, NULL),
(16022, '2016-12-25 00:00:00', NULL, NULL, 5499, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:35:33', 'admin-1482633309-14826333331041064', 1, 1, 'SR', NULL, NULL, NULL),
(16023, '2016-12-25 00:00:00', NULL, NULL, 5500, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:34:34', 'admin-1482626290-14826332738242139', 1, 0, '', NULL, NULL, NULL),
(16024, '2016-12-25 00:00:00', NULL, NULL, 5499, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:34:34', 'admin-1482626290-14826332738242139', 1, 0, '', NULL, NULL, NULL),
(16025, '2016-12-25 00:00:00', NULL, NULL, 5500, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:34:34', 'admin-1482626290-14826332738242139', 1, 0, '', NULL, NULL, NULL),
(16026, '2016-12-25 10:28:50', NULL, NULL, 5486, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:28:50', 'admin-1482626290-14826329303875972', 1, 1, 'SR', NULL, NULL, NULL),
(16027, '2016-12-25 00:00:00', NULL, NULL, 5500, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:23:00', 'admin-1482626290-14826325803605255', 1, 1, 'SR', NULL, NULL, NULL),
(16028, '2016-12-25 10:28:50', NULL, NULL, 5486, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:28:50', 'admin-1482626290-14826329303875972', 1, 1, 'SR', NULL, NULL, NULL),
(16029, '2016-12-25 10:11:53', NULL, NULL, 5483, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:11:53', 'admin-1482626290-14826319136999923', 1, 1, 'SR', NULL, NULL, NULL),
(16030, '2016-12-25 10:11:53', NULL, NULL, 5483, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:11:53', 'admin-1482626290-14826319136999923', 1, 1, 'SR', NULL, NULL, NULL),
(16031, '2016-12-25 10:14:17', NULL, NULL, 5484, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:14:17', 'admin-1482626290-1482632057233661', 1, 0, '', NULL, NULL, NULL),
(16032, '2016-12-25 10:14:17', NULL, NULL, 5484, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:14:17', 'admin-1482626290-1482632057233661', 1, 0, '', NULL, NULL, NULL),
(16033, '2016-12-25 10:14:37', NULL, NULL, 5484, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:14:37', 'admin-1482626290-14826320775932595', 1, 1, 'SR', NULL, NULL, NULL),
(16034, '2016-12-25 10:14:37', NULL, NULL, 5484, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:14:37', 'admin-1482626290-14826320775932595', 1, 1, 'SR', NULL, NULL, NULL),
(16035, '2016-12-25 10:16:17', NULL, NULL, 5480, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:16:17', 'admin-1482626290-1482632176908764', 1, 1, 'SR', NULL, NULL, NULL),
(16036, '2016-12-25 10:44:15', NULL, NULL, 5489, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:44:15', 'admin-1482633309-14826338554918469', 1, 0, '', NULL, NULL, NULL),
(16037, '2016-12-25 11:45:07', NULL, NULL, 5501, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 11:45:07', 'admin-1482633309-14826375072955989', 1, 0, '', NULL, NULL, NULL),
(16038, '2016-12-25 00:00:00', NULL, NULL, 5500, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:23:00', 'admin-1482626290-14826325803605255', 1, 1, 'SR', NULL, NULL, NULL),
(16039, '2016-12-25 10:28:50', NULL, NULL, 5486, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:28:50', 'admin-1482626290-14826329303875972', 1, 0, '', NULL, NULL, NULL),
(16040, '2016-12-25 10:28:50', NULL, NULL, 5486, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:28:50', 'admin-1482626290-14826329303875972', 1, 0, '', NULL, NULL, NULL),
(16041, '2016-12-25 10:02:36', NULL, NULL, 5481, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:02:36', 'admin-1482626290-14826313559859266', 1, 1, 'SR', NULL, NULL, NULL),
(16042, '2016-12-25 10:02:36', NULL, NULL, 5481, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:02:36', 'admin-1482626290-14826313559859266', 1, 1, 'SR', NULL, NULL, NULL),
(16043, '2016-12-25 10:10:12', NULL, NULL, 5482, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:10:12', 'admin-1482626290-14826318121529124', 1, 1, 'SR', NULL, NULL, NULL),
(16044, '2016-12-25 10:10:12', NULL, NULL, 5482, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:10:12', 'admin-1482626290-14826318121529124', 1, 1, 'SR', NULL, NULL, NULL),
(16045, '2016-12-25 10:10:12', NULL, NULL, 5482, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:10:12', 'admin-1482626290-14826318121529124', 1, 0, '', NULL, NULL, NULL),
(16046, '2016-12-25 10:10:53', NULL, NULL, 5483, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:10:53', 'admin-1482626290-14826318531844485', 1, 0, '', NULL, NULL, NULL),
(16047, '2016-12-25 10:10:53', NULL, NULL, 5483, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:10:53', 'admin-1482626290-14826318531844485', 1, 0, '', NULL, NULL, NULL),
(16048, '2016-12-25 10:02:18', NULL, NULL, 5481, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 10:02:18', 'admin-1482626290-14826313387235952', 1, 0, '', NULL, NULL, NULL),
(16049, '2016-12-25 09:55:41', NULL, NULL, 5480, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 09:55:41', 'admin-1482626290-14826309414304238', 1, 0, '', NULL, NULL, NULL),
(16050, '2016-12-25 09:55:41', NULL, NULL, 5480, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 09:55:41', 'admin-1482626290-14826309414304238', 1, 0, '', NULL, NULL, NULL),
(16051, '2016-12-25 09:55:41', NULL, NULL, 5480, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 09:55:41', 'admin-1482626290-14826309414304238', 1, 1, 'SR', NULL, NULL, NULL),
(16052, '2016-12-25 09:55:31', NULL, NULL, 5480, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 09:55:31', 'admin-1482626290-14826309312447029', 1, 0, '', NULL, NULL, NULL),
(16053, '2016-12-25 09:55:31', NULL, NULL, 5480, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 09:55:31', 'admin-1482626290-14826309312447029', 1, 0, '', NULL, NULL, NULL),
(16054, '2016-12-25 09:55:31', NULL, NULL, 5480, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 09:55:31', 'admin-1482626290-14826309312447029', 1, 0, '', NULL, NULL, NULL),
(16055, '2016-12-25 09:52:20', NULL, NULL, 5479, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 09:52:20', 'admin-1482626290-14826307399815779', 1, 0, '', NULL, NULL, NULL),
(16056, '2016-12-25 09:52:20', NULL, NULL, 5479, 0, 244, '178', 'Macadamia Scones', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 09:52:20', 'admin-1482626290-14826307399815779', 1, 0, '', NULL, NULL, NULL),
(16057, '2016-12-25 09:55:31', NULL, NULL, 5480, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 09:55:31', 'admin-1482626290-14826309312447029', 1, 0, '', NULL, NULL, NULL),
(16058, '2016-12-25 09:51:32', NULL, NULL, 5479, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 09:51:32', 'admin-1482626290-14826306927133859', 1, 1, 'SR', NULL, NULL, NULL),
(16059, '2016-12-25 09:51:32', NULL, NULL, 5479, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 09:51:32', 'admin-1482626290-14826306927133859', 1, 1, 'SR', NULL, NULL, NULL),
(16060, '2016-12-25 09:51:18', NULL, NULL, 5478, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 09:51:18', 'admin-1482626290-14826306782211616', 1, 1, 'SR', NULL, NULL, NULL),
(16061, '2016-12-25 09:51:18', NULL, NULL, 5478, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482665607', 'admin', '2016-12-25 09:51:18', 'admin-1482626290-14826306782211616', 1, 1, 'SR', NULL, NULL, NULL),
(16062, '2016-12-26 20:32:29', NULL, NULL, 5591, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 20:32:29', 'admin-1482732853-1482755549713436', 1, 0, '', NULL, NULL, NULL),
(16063, '2016-12-26 20:02:11', NULL, NULL, 5591, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 20:02:11', 'admin-1482732853-1482753731162552', 1, 0, '', NULL, NULL, NULL),
(16064, '2016-12-26 19:57:39', NULL, NULL, 5591, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 19:57:39', 'admin-1482732853-14827534592176188', 1, 1, 'SR', NULL, NULL, NULL),
(16065, '2016-12-26 19:31:37', NULL, NULL, 5590, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 19:31:37', 'admin-1482732853-14827518975617321', 1, 1, 'SR', NULL, NULL, NULL),
(16066, '2016-12-26 18:22:58', NULL, NULL, 5588, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 18:22:58', 'admin-1482732853-14827477778247019', 1, 1, 'SR', NULL, NULL, NULL),
(16067, '2016-12-26 19:57:39', NULL, NULL, 5591, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 19:57:39', 'admin-1482732853-14827534592176188', 1, 1, 'SR', NULL, NULL, NULL),
(16068, '2016-12-26 19:57:39', NULL, NULL, 5591, 0, 249, '183', 'Pan Roasted Pork Loin Chop', '', 'Meals', 'Perfect Meals', 1, 31.90, 31.9000, 0.0000, 31.90, 1, '27', 1, '1482732853', 'admin', '2016-12-26 19:57:39', 'admin-1482732853-14827534592176188', 1, 0, '', NULL, NULL, NULL),
(16069, '2016-12-26 18:22:58', NULL, NULL, 5588, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 18:22:58', 'admin-1482732853-14827477778247019', 1, 1, 'SR', NULL, NULL, NULL),
(16070, '2016-12-26 18:39:11', NULL, NULL, 5589, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 18:39:11', 'admin-1482732853-14827487517532211', 1, 0, '', NULL, NULL, NULL),
(16071, '2016-12-26 18:22:58', NULL, NULL, 5588, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 18:22:58', 'admin-1482732853-14827477778247019', 1, 1, 'SR', NULL, NULL, NULL),
(16072, '2016-12-26 18:22:58', NULL, NULL, 5588, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 18:22:58', 'admin-1482732853-14827477778247019', 1, 0, '', NULL, NULL, NULL),
(16073, '2016-12-26 18:22:58', NULL, NULL, 5588, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 18:22:58', 'admin-1482732853-14827477778247019', 1, 1, 'SR', NULL, NULL, NULL),
(16074, '2016-12-26 16:17:09', NULL, NULL, 5587, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 16:17:09', 'admin-1482732853-14827402297078785', 1, 0, '', NULL, NULL, NULL),
(16075, '2016-12-26 16:17:09', NULL, NULL, 5587, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 16:17:09', 'admin-1482732853-14827402297078785', 1, 1, 'SR', NULL, NULL, NULL),
(16076, '2016-12-26 15:49:15', NULL, NULL, 5586, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 15:49:15', 'admin-1482732853-14827385552298542', 1, 0, '', NULL, NULL, NULL),
(16077, '2016-12-26 15:37:35', NULL, NULL, 5585, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 15:37:35', 'admin-1482732853-14827378556291819', 1, 1, 'SR', NULL, NULL, NULL),
(16078, '2016-12-26 15:49:15', NULL, NULL, 5586, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 15:49:15', 'admin-1482732853-14827385552298542', 1, 1, 'SR', NULL, NULL, NULL),
(16079, '2016-12-26 14:31:27', NULL, NULL, 5577, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:31:27', 'admin-1482732853-1482733886928894', 1, 1, 'SR', NULL, NULL, NULL),
(16080, '2016-12-26 15:36:41', NULL, NULL, 5584, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 15:36:41', 'admin-1482732853-1482737801233361', 1, 1, 'SR', NULL, NULL, NULL),
(16081, '2016-12-26 15:36:18', NULL, NULL, 5583, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 15:36:18', 'admin-1482732853-14827377786374477', 1, 1, 'SR', NULL, NULL, NULL),
(16082, '2016-12-26 15:26:14', NULL, NULL, 5582, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 15:26:14', 'admin-1482732853-14827371739553731', 1, 1, 'SR', NULL, NULL, NULL),
(16083, '2016-12-26 13:14:08', NULL, NULL, 5564, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:14:08', 'admin-1482726139-14827292480598586', 1, 1, 'SR', NULL, NULL, NULL),
(16084, '2016-12-26 13:20:24', NULL, NULL, 5565, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:20:24', 'admin-1482726139-14827296239386248', 1, 0, '', NULL, NULL, NULL),
(16085, '2016-12-26 13:20:24', NULL, NULL, 5565, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:20:24', 'admin-1482726139-14827296239386248', 1, 0, '', NULL, NULL, NULL),
(16086, '2016-12-26 13:20:24', NULL, NULL, 5565, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:20:24', 'admin-1482726139-14827296239386248', 1, 0, '', NULL, NULL, NULL),
(16087, '2016-12-26 13:20:40', NULL, NULL, 5565, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:20:40', 'admin-1482726139-14827296404871752', 1, 1, 'SR', NULL, NULL, NULL),
(16088, '2016-12-26 13:20:40', NULL, NULL, 5565, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:20:40', 'admin-1482726139-14827296404871752', 1, 1, 'SR', NULL, NULL, NULL),
(16089, '2016-12-26 13:21:15', NULL, NULL, 5565, 0, 181, '116', 'Open Food ', 'toast', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:21:15', 'admin-1482726139-14827296748006589', 1, 0, '', NULL, NULL, NULL),
(16090, '2016-12-26 13:21:34', NULL, NULL, 5565, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:21:34', 'admin-1482726139-14827296938951059', 1, 1, 'SR', NULL, NULL, NULL),
(16091, '2016-12-26 13:30:05', NULL, NULL, 5566, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:30:05', 'admin-1482726139-14827302056971376', 1, 1, 'SR', NULL, NULL, NULL),
(16092, '2016-12-26 13:34:41', NULL, NULL, 5567, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:34:41', 'admin-1482726139-14827304812996515', 1, 0, '', NULL, NULL, NULL),
(16093, '2016-12-26 13:34:41', NULL, NULL, 5567, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:34:41', 'admin-1482726139-14827304812996515', 1, 1, 'SR', NULL, NULL, NULL),
(16094, '2016-12-26 13:34:41', NULL, NULL, 5567, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:34:41', 'admin-1482726139-14827304812996515', 1, 1, 'SR', NULL, NULL, NULL),
(16095, '2016-12-26 13:35:36', NULL, NULL, 5566, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:35:36', 'admin-1482726139-14827305366134431', 1, 0, '', NULL, NULL, NULL),
(16096, '2016-12-26 13:35:36', NULL, NULL, 5566, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:35:36', 'admin-1482726139-14827305366134431', 1, 0, '', NULL, NULL, NULL),
(16097, '2016-12-26 13:35:36', NULL, NULL, 5566, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:35:36', 'admin-1482726139-14827305366134431', 1, 0, '', NULL, NULL, NULL),
(16098, '2016-12-26 13:35:36', NULL, NULL, 5566, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:35:36', 'admin-1482726139-14827305366134431', 1, 0, '', NULL, NULL, NULL),
(16099, '2016-12-26 12:22:12', NULL, NULL, 5563, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:22:12', 'admin-1482723982-14827261327327188', 1, 0, '', NULL, NULL, NULL),
(16100, '2016-12-26 15:16:41', NULL, NULL, 5578, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 15:16:41', 'admin-1482732853-14827366009062317', 1, 0, '', NULL, NULL, NULL),
(16101, '2016-12-26 14:52:25', NULL, NULL, 5577, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:52:25', 'admin-1482732853-1482735144874683', 1, 0, '', NULL, NULL, NULL),
(16102, '2016-12-26 14:14:02', NULL, NULL, 5574, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:14:02', 'admin-1482726139-14827328422908814', 1, 1, 'SR', NULL, NULL, NULL),
(16103, '2016-12-26 15:13:20', NULL, NULL, 5581, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 15:13:20', 'admin-1482732853-14827364000019750', 1, 1, 'SR', NULL, NULL, NULL),
(16104, '2016-12-26 13:50:46', NULL, NULL, 5569, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:50:46', 'admin-1482726139-14827314459963415', 1, 1, 'SR', NULL, NULL, NULL),
(16105, '2016-12-26 13:50:46', NULL, NULL, 5569, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:50:46', 'admin-1482726139-14827314459963415', 1, 0, '', NULL, NULL, NULL),
(16106, '2016-12-26 13:51:02', NULL, NULL, 5569, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:51:02', 'admin-1482726139-14827314624012993', 1, 1, 'SR', NULL, NULL, NULL),
(16107, '2016-12-26 13:51:02', NULL, NULL, 5569, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:51:02', 'admin-1482726139-14827314624012993', 1, 1, 'SR', NULL, NULL, NULL),
(16108, '2016-12-26 00:00:00', NULL, NULL, 5580, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:08:27', 'admin-1482726139-14827325068603480', 1, 1, 'SR', NULL, NULL, NULL),
(16109, '2016-12-26 12:53:55', NULL, NULL, 5564, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:53:55', 'admin-1482726139-14827280350878763', 1, 1, 'SR', NULL, NULL, NULL),
(16110, '2016-12-26 12:53:55', NULL, NULL, 5564, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:53:55', 'admin-1482726139-14827280350878763', 1, 1, 'SR', NULL, NULL, NULL),
(16111, '2016-12-26 12:53:55', NULL, NULL, 5564, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:53:55', 'admin-1482726139-14827280350878763', 1, 0, '', NULL, NULL, NULL),
(16112, '2016-12-26 12:53:55', NULL, NULL, 5564, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:53:55', 'admin-1482726139-14827280350878763', 1, 1, 'SR', NULL, NULL, NULL),
(16113, '2016-12-26 13:13:54', NULL, NULL, 5564, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:13:54', 'admin-1482726139-14827292341338175', 1, 1, 'SR', NULL, NULL, NULL),
(16114, '2016-12-26 14:41:11', NULL, NULL, 5579, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:41:11', 'admin-1482732853-14827344714837752', 1, 0, '', NULL, NULL, NULL),
(16115, '2016-12-26 14:14:02', NULL, NULL, 5574, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:14:02', 'admin-1482726139-14827328422908814', 1, 1, 'SR', NULL, NULL, NULL),
(16116, '2016-12-26 14:41:11', NULL, NULL, 5579, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:41:11', 'admin-1482732853-14827344714837752', 1, 1, 'SR', NULL, NULL, NULL),
(16117, '2016-12-26 14:34:50', NULL, NULL, 5578, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:34:50', 'admin-1482732853-14827340907665419', 1, 1, 'SR', NULL, NULL, NULL),
(16118, '2016-12-26 14:34:50', NULL, NULL, 5578, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:34:50', 'admin-1482732853-14827340907665419', 1, 1, 'SR', NULL, NULL, NULL),
(16119, '2016-12-26 14:34:50', NULL, NULL, 5578, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:34:50', 'admin-1482732853-14827340907665419', 1, 1, 'SR', NULL, NULL, NULL),
(16120, '2016-12-26 14:34:10', NULL, NULL, 5578, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:34:10', 'admin-1482732853-14827340506495756', 1, 0, '', NULL, NULL, NULL),
(16121, '2016-12-26 14:21:18', NULL, NULL, 5573, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:21:18', 'admin-1482732853-14827332786502714', 1, 0, '', NULL, NULL, NULL),
(16122, '2016-12-26 13:13:54', NULL, NULL, 5564, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:13:54', 'admin-1482726139-14827292341338175', 1, 1, 'SR', NULL, NULL, NULL),
(16123, '2016-12-26 13:13:54', NULL, NULL, 5564, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:13:54', 'admin-1482726139-14827292341338175', 1, 1, 'SR', NULL, NULL, NULL),
(16124, '2016-12-26 13:13:54', NULL, NULL, 5564, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:13:54', 'admin-1482726139-14827292341338175', 1, 1, 'SR', NULL, NULL, NULL),
(16125, '2016-12-26 13:13:54', NULL, NULL, 5564, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:13:54', 'admin-1482726139-14827292341338175', 1, 0, '', NULL, NULL, NULL),
(16126, '2016-12-26 13:13:54', NULL, NULL, 5564, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:13:54', 'admin-1482726139-14827292341338175', 1, 0, '', NULL, NULL, NULL),
(16127, '2016-12-26 13:13:54', NULL, NULL, 5564, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:13:54', 'admin-1482726139-14827292341338175', 1, 0, '', NULL, NULL, NULL),
(16128, '2016-12-26 13:13:54', NULL, NULL, 5564, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:13:54', 'admin-1482726139-14827292341338175', 1, 0, '', NULL, NULL, NULL),
(16129, '2016-12-26 14:21:18', NULL, NULL, 5573, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:21:18', 'admin-1482732853-14827332786502714', 1, 1, 'SR', NULL, NULL, NULL),
(16130, '2016-12-26 14:21:23', NULL, NULL, 5573, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:21:23', 'admin-1482732853-14827332835323345', 1, 1, 'SR', NULL, NULL, NULL),
(16131, '2016-12-26 14:22:32', NULL, NULL, 5576, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:22:32', 'admin-1482732853-14827333521897020', 1, 0, '', NULL, NULL, NULL),
(16132, '2016-12-26 14:22:32', NULL, NULL, 5576, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:22:32', 'admin-1482732853-14827333521897020', 1, 1, 'SR', NULL, NULL, NULL),
(16133, '2016-12-26 15:26:14', NULL, NULL, 5582, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 15:26:14', 'admin-1482732853-14827371739553731', 1, 1, 'SR', NULL, NULL, NULL),
(16134, '2016-12-26 13:14:08', NULL, NULL, 5564, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:14:08', 'admin-1482726139-14827292480598586', 1, 1, 'SR', NULL, NULL, NULL),
(16135, '2016-12-26 11:52:40', NULL, NULL, 5556, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:52:40', 'admin-1482723982-14827243600376445', 1, 0, '', NULL, NULL, NULL),
(16136, '2016-12-26 11:52:40', NULL, NULL, 5556, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:52:40', 'admin-1482723982-14827243600376445', 1, 1, 'SR', NULL, NULL, NULL),
(16137, '2016-12-26 11:52:40', NULL, NULL, 5556, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:52:40', 'admin-1482723982-14827243600376445', 1, 1, 'SR', NULL, NULL, NULL),
(16138, '2016-12-26 00:00:00', NULL, NULL, 5557, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:24:19', 'admin-1482720017-14827226588158595', 1, 0, '', NULL, NULL, NULL),
(16139, '2016-12-26 12:16:41', NULL, NULL, 5562, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:16:41', 'admin-1482723982-14827258009731366', 1, 1, 'SR', NULL, NULL, NULL),
(16140, '2016-12-26 12:16:41', NULL, NULL, 5562, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:16:41', 'admin-1482723982-14827258009731366', 1, 1, 'SR', NULL, NULL, NULL),
(16141, '2016-12-26 12:16:41', NULL, NULL, 5562, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:16:41', 'admin-1482723982-14827258009731366', 1, 0, '', NULL, NULL, NULL),
(16142, '2016-12-26 11:46:09', NULL, NULL, 5553, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:46:09', 'admin-1482720017-14827239696612318', 1, 1, 'SR', NULL, NULL, NULL),
(16143, '2016-12-26 11:46:09', NULL, NULL, 5553, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:46:09', 'admin-1482720017-14827239696612318', 1, 0, '', NULL, NULL, NULL),
(16144, '2016-12-26 11:47:07', NULL, NULL, 5554, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:47:07', 'admin-1482723982-14827240272346376', 1, 0, '', NULL, NULL, NULL),
(16145, '2016-12-26 11:47:24', NULL, NULL, 5554, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:47:24', 'admin-1482723982-14827240444914063', 1, 0, '', NULL, NULL, NULL),
(16146, '2016-12-26 11:50:02', NULL, NULL, 5555, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:50:02', 'admin-1482723982-14827242025504371', 1, 0, '', NULL, NULL, NULL),
(16147, '2016-12-26 11:50:17', NULL, NULL, 5555, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:50:17', 'admin-1482723982-14827242176168722', 1, 1, 'SR', NULL, NULL, NULL),
(16148, '2016-12-26 11:50:17', NULL, NULL, 5555, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:50:17', 'admin-1482723982-14827242176168722', 1, 1, 'SR', NULL, NULL, NULL),
(16149, '2016-12-26 11:51:54', NULL, NULL, 5556, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:51:54', 'admin-1482723982-14827243144112241', 1, 0, '', NULL, NULL, NULL),
(16150, '2016-12-26 10:53:23', NULL, NULL, 5546, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:53:23', 'admin-1482720017-1482720802965956', 1, 0, '', NULL, NULL, NULL),
(16151, '2016-12-26 10:43:14', NULL, NULL, 5545, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:43:14', 'admin-1482720017-14827201944056339', 1, 1, 'SR', NULL, NULL, NULL),
(16152, '2016-12-26 10:43:14', NULL, NULL, 5545, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:43:14', 'admin-1482720017-14827201944056339', 1, 1, 'SR', NULL, NULL, NULL),
(16153, '2016-12-26 10:57:15', NULL, NULL, 5544, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:57:15', 'admin-1482720017-1482721035451311', 1, 1, 'SR', NULL, NULL, NULL),
(16154, '2016-12-26 11:04:22', NULL, NULL, 5547, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:04:22', 'admin-1482720017-14827214627917389', 1, 0, '', NULL, NULL, NULL),
(16155, '2016-12-26 11:04:22', NULL, NULL, 5547, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:04:22', 'admin-1482720017-14827214627917389', 1, 0, '', NULL, NULL, NULL),
(16156, '2016-12-26 11:04:22', NULL, NULL, 5547, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:04:22', 'admin-1482720017-14827214627917389', 1, 0, '', NULL, NULL, NULL),
(16157, '2016-12-26 11:04:22', NULL, NULL, 5547, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:04:22', 'admin-1482720017-14827214627917389', 1, 1, 'SR', NULL, NULL, NULL),
(16158, '2016-12-26 11:04:22', NULL, NULL, 5547, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:04:22', 'admin-1482720017-14827214627917389', 1, 1, 'SR', NULL, NULL, NULL),
(16159, '2016-12-26 00:00:00', NULL, NULL, 5559, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:18:20', 'admin-1482720017-1482722300547651', 1, 0, '', NULL, NULL, NULL),
(16160, '2016-12-26 00:00:00', NULL, NULL, 5560, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:19:13', 'admin-1482720017-14827223535779068', 1, 1, 'SR', NULL, NULL, NULL),
(16161, '2016-12-26 00:00:00', NULL, NULL, 5559, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:19:13', 'admin-1482720017-14827223535779068', 1, 0, '', NULL, NULL, NULL),
(16162, '2016-12-26 00:00:00', NULL, NULL, 5560, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:24:19', 'admin-1482720017-14827226588158595', 1, 0, '', NULL, NULL, NULL),
(16163, '2016-12-26 00:00:00', NULL, NULL, 5558, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:19:13', 'admin-1482720017-14827223535779068', 1, 1, 'SR', NULL, NULL, NULL),
(16164, '2016-12-26 00:00:00', NULL, NULL, 5558, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:18:20', 'admin-1482720017-1482722300547651', 1, 0, '', NULL, NULL, NULL),
(16165, '2016-12-26 00:00:00', NULL, NULL, 5559, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:25:59', 'admin-1482720017-14827227595526125', 1, 1, 'SR', NULL, NULL, NULL),
(16166, '2016-12-26 12:11:45', NULL, NULL, 5556, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:11:45', 'admin-1482723982-14827255054763476', 1, 0, '', NULL, NULL, NULL),
(16167, '2016-12-26 14:34:10', NULL, NULL, 5578, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:34:10', 'admin-1482732853-14827340506495756', 1, 0, '', NULL, NULL, NULL),
(16168, '2016-12-26 14:34:10', NULL, NULL, 5578, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:34:10', 'admin-1482732853-14827340506495756', 1, 0, '', NULL, NULL, NULL),
(16169, '2016-12-26 00:00:00', NULL, NULL, 5580, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:06:38', 'admin-1482726139-14827323985887634', 1, 1, 'SR', NULL, NULL, NULL),
(16170, '2016-12-26 14:11:38', NULL, NULL, 5570, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:11:38', 'admin-1482726139-14827326981915764', 1, 0, '', NULL, NULL, NULL),
(16171, '2016-12-26 14:14:02', NULL, NULL, 5574, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:14:02', 'admin-1482726139-14827328422908814', 1, 0, '', NULL, NULL, NULL),
(16172, '2016-12-26 14:14:02', NULL, NULL, 5574, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:14:02', 'admin-1482726139-14827328422908814', 1, 0, '', NULL, NULL, NULL),
(16173, '2016-12-26 14:07:02', NULL, NULL, 5572, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:07:02', 'admin-1482726139-14827324218639653', 1, 1, 'SR', NULL, NULL, NULL),
(16174, '2016-12-26 14:06:38', NULL, NULL, 5571, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:06:38', 'admin-1482726139-14827323985887634', 1, 1, 'SR', NULL, NULL, NULL),
(16175, '2016-12-26 14:05:22', NULL, NULL, 5570, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:05:22', 'admin-1482726139-14827323220567195', 1, 1, 'SR', NULL, NULL, NULL),
(16176, '2016-12-26 13:44:25', NULL, NULL, 5566, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:44:25', 'admin-1482726139-14827310648702859', 1, 0, '', NULL, NULL, NULL),
(16177, '2016-12-26 13:38:27', NULL, NULL, 5568, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:38:27', 'admin-1482726139-14827307069996413', 1, 0, '', NULL, NULL, NULL),
(16178, '2016-12-26 13:44:25', NULL, NULL, 5566, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:44:25', 'admin-1482726139-14827310648702859', 1, 1, 'SR', NULL, NULL, NULL),
(16179, '2016-12-26 13:38:27', NULL, NULL, 5568, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:38:27', 'admin-1482726139-14827307069996413', 1, 0, '', NULL, NULL, NULL),
(16180, '2016-12-26 13:38:27', NULL, NULL, 5568, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:38:27', 'admin-1482726139-14827307069996413', 1, 1, 'SR', NULL, NULL, NULL),
(16181, '2016-12-26 13:38:27', NULL, NULL, 5568, 0, 153, '87', 'Big Breakfast ', 'sunny side', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:38:27', 'admin-1482726139-14827307069996413', 1, 0, '', NULL, NULL, NULL),
(16182, '2016-12-26 13:35:36', NULL, NULL, 5566, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:35:36', 'admin-1482726139-14827305366134431', 1, 0, '', NULL, NULL, NULL),
(16183, '2016-12-26 13:38:27', NULL, NULL, 5568, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:38:27', 'admin-1482726139-14827307069996413', 1, 0, '', NULL, NULL, NULL),
(16184, '2016-12-26 13:35:36', NULL, NULL, 5566, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 13:35:36', 'admin-1482726139-14827305366134431', 1, 0, '', NULL, NULL, NULL),
(16185, '2016-12-26 12:22:12', NULL, NULL, 5563, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:22:12', 'admin-1482723982-14827261327327188', 1, 0, '', NULL, NULL, NULL),
(16186, '2016-12-26 12:23:00', NULL, NULL, 5563, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:23:00', 'admin-1482726139-14827261801166361', 1, 1, 'SR', NULL, NULL, NULL),
(16187, '2016-12-26 12:23:34', NULL, NULL, 5563, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:23:34', 'admin-1482726139-1482726214702329', 1, 0, '', NULL, NULL, NULL),
(16188, '2016-12-26 12:53:55', NULL, NULL, 5564, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:53:55', 'admin-1482726139-14827280350878763', 1, 1, 'SR', NULL, NULL, NULL),
(16189, '2016-12-26 12:23:00', NULL, NULL, 5563, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:23:00', 'admin-1482726139-14827261801166361', 1, 0, '', NULL, NULL, NULL),
(16190, '2016-12-26 12:23:00', NULL, NULL, 5563, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:23:00', 'admin-1482726139-14827261801166361', 1, 0, '', NULL, NULL, NULL),
(16191, '2016-12-26 12:23:00', NULL, NULL, 5563, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:23:00', 'admin-1482726139-14827261801166361', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(16192, '2016-12-26 12:23:00', NULL, NULL, 5563, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:23:00', 'admin-1482726139-14827261801166361', 1, 1, 'SR', NULL, NULL, NULL),
(16193, '2016-12-26 12:23:00', NULL, NULL, 5563, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:23:00', 'admin-1482726139-14827261801166361', 1, 1, 'SR', NULL, NULL, NULL),
(16194, '2016-12-26 12:23:00', NULL, NULL, 5563, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:23:00', 'admin-1482726139-14827261801166361', 1, 0, '', NULL, NULL, NULL),
(16195, '2016-12-26 12:23:00', NULL, NULL, 5563, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:23:00', 'admin-1482726139-14827261801166361', 1, 0, '', NULL, NULL, NULL),
(16196, '2016-12-26 12:23:00', NULL, NULL, 5563, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:23:00', 'admin-1482726139-14827261801166361', 1, 1, 'SR', NULL, NULL, NULL),
(16197, '2016-12-26 12:16:41', NULL, NULL, 5562, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:16:41', 'admin-1482723982-14827258009731366', 1, 0, '', NULL, NULL, NULL),
(16198, '2016-12-26 00:00:00', NULL, NULL, 5561, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:35:21', 'admin-1482720017-14827233216753817', 1, 1, 'SR', NULL, NULL, NULL),
(16199, '2016-12-26 12:22:12', NULL, NULL, 5563, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:22:12', 'admin-1482723982-14827261327327188', 1, 0, '', NULL, NULL, NULL),
(16200, '2016-12-26 12:22:12', NULL, NULL, 5563, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 12:22:12', 'admin-1482723982-14827261327327188', 1, 0, '', NULL, NULL, NULL),
(16201, '2016-12-26 11:52:17', NULL, NULL, 5556, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:52:17', 'admin-1482723982-14827243369368630', 1, 1, 'SR', NULL, NULL, NULL),
(16202, '2016-12-26 11:52:17', NULL, NULL, 5556, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:52:17', 'admin-1482723982-14827243369368630', 1, 0, '', NULL, NULL, NULL),
(16203, '2016-12-26 14:20:33', NULL, NULL, 5575, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 14:20:33', 'admin-1482732853-14827332331862679', 1, 1, 'SR', NULL, NULL, NULL),
(16204, '2016-12-26 11:52:17', NULL, NULL, 5556, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:52:17', 'admin-1482723982-14827243369368630', 1, 0, '', NULL, NULL, NULL),
(16205, '2016-12-26 11:46:09', NULL, NULL, 5553, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:46:09', 'admin-1482720017-14827239696612318', 1, 0, '', NULL, NULL, NULL),
(16206, '2016-12-26 11:46:09', NULL, NULL, 5553, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:46:09', 'admin-1482720017-14827239696612318', 1, 0, '', NULL, NULL, NULL),
(16207, '2016-12-26 11:45:54', NULL, NULL, 5552, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:45:54', 'admin-1482720017-14827239541132747', 1, 0, '', NULL, NULL, NULL),
(16208, '2016-12-26 11:45:54', NULL, NULL, 5552, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:45:54', 'admin-1482720017-14827239541132747', 1, 0, '', NULL, NULL, NULL),
(16209, '2016-12-26 11:36:46', NULL, NULL, 5551, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:36:46', 'admin-1482720017-14827234066864551', 1, 0, '', NULL, NULL, NULL),
(16210, '2016-12-26 11:45:54', NULL, NULL, 5552, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:45:54', 'admin-1482720017-14827239541132747', 1, 1, 'SR', NULL, NULL, NULL),
(16211, '2016-12-26 00:00:00', NULL, NULL, 5561, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:27:51', 'admin-1482720017-14827228711848165', 1, 0, '', NULL, NULL, NULL),
(16212, '2016-12-26 00:00:00', NULL, NULL, 5561, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:19:13', 'admin-1482720017-14827223535779068', 1, 0, '', NULL, NULL, NULL),
(16213, '2016-12-26 00:00:00', NULL, NULL, 5559, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:19:13', 'admin-1482720017-14827223535779068', 1, 1, 'SR', NULL, NULL, NULL),
(16214, '2016-12-26 00:00:00', NULL, NULL, 5558, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, NULL, NULL, 6.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:19:13', 'admin-1482720017-14827223535779068', 1, 1, 'SR', NULL, NULL, NULL),
(16215, '2016-12-26 00:00:00', NULL, NULL, 5559, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:18:20', 'admin-1482720017-1482722300547651', 1, 0, '', NULL, NULL, NULL),
(16216, '2016-12-26 11:20:02', NULL, NULL, 5549, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:20:02', 'admin-1482720017-14827224027402239', 1, 1, 'SR', NULL, NULL, NULL),
(16217, '2016-12-26 11:23:37', NULL, NULL, 5550, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:23:37', 'admin-1482720017-14827226170696978', 1, 1, 'SR', NULL, NULL, NULL),
(16218, '2016-12-26 00:00:00', NULL, NULL, 5560, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:25:59', 'admin-1482720017-14827227595526125', 1, 0, '', NULL, NULL, NULL),
(16219, '2016-12-26 00:00:00', NULL, NULL, 5557, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:25:59', 'admin-1482720017-14827227595526125', 1, 1, 'SR', NULL, NULL, NULL),
(16220, '2016-12-26 00:00:00', NULL, NULL, 5560, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:24:19', 'admin-1482720017-14827226588158595', 1, 0, '', NULL, NULL, NULL),
(16221, '2016-12-26 00:00:00', NULL, NULL, 5557, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 11:24:19', 'admin-1482720017-14827226588158595', 1, 0, '', NULL, NULL, NULL),
(16222, '2016-12-26 10:38:34', NULL, NULL, 5544, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:38:34', 'admin-1482714671-14827199143189527', 1, 0, '', NULL, NULL, NULL),
(16223, '2016-12-26 10:38:57', NULL, NULL, 5544, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:38:57', 'admin-1482714671-14827199369035314', 1, 0, '', NULL, NULL, NULL),
(16224, '2016-12-26 10:38:34', NULL, NULL, 5544, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:38:34', 'admin-1482714671-14827199143189527', 1, 0, '', NULL, NULL, NULL),
(16225, '2016-12-26 10:38:34', NULL, NULL, 5544, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:38:34', 'admin-1482714671-14827199143189527', 1, 0, '', NULL, NULL, NULL),
(16226, '2016-12-26 10:38:34', NULL, NULL, 5544, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:38:34', 'admin-1482714671-14827199143189527', 1, 0, '', NULL, NULL, NULL),
(16227, '2016-12-26 10:39:59', NULL, NULL, 5544, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:39:59', 'admin-1482714671-1482719999740335', 1, 0, '', NULL, NULL, NULL),
(16228, '2016-12-26 10:41:42', NULL, NULL, 5544, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:41:42', 'admin-1482720017-14827201027001994', 1, 1, 'SR', NULL, NULL, NULL),
(16229, '2016-12-26 10:41:42', NULL, NULL, 5544, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:41:42', 'admin-1482720017-14827201027001994', 1, 1, 'SR', NULL, NULL, NULL),
(16230, '2016-12-26 10:41:42', NULL, NULL, 5544, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:41:42', 'admin-1482720017-14827201027001994', 1, 1, 'SR', NULL, NULL, NULL),
(16231, '2016-12-26 10:41:42', NULL, NULL, 5544, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:41:42', 'admin-1482720017-14827201027001994', 1, 1, 'SR', NULL, NULL, NULL),
(16232, '2016-12-26 10:41:42', NULL, NULL, 5544, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:41:42', 'admin-1482720017-14827201027001994', 1, 1, 'SR', NULL, NULL, NULL),
(16233, '2016-12-26 10:41:42', NULL, NULL, 5544, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:41:42', 'admin-1482720017-14827201027001994', 1, 0, '', NULL, NULL, NULL),
(16234, '2016-12-26 10:41:42', NULL, NULL, 5544, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:41:43', 'admin-1482720017-14827201027001994', 1, 0, '', NULL, NULL, NULL),
(16235, '2016-12-26 10:43:14', NULL, NULL, 5545, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:43:14', 'admin-1482720017-14827201944056339', 1, 0, '', NULL, NULL, NULL),
(16236, '2016-12-26 10:37:51', NULL, NULL, 5544, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:37:51', 'admin-1482714671-14827198711793118', 1, 0, '', NULL, NULL, NULL),
(16237, '2016-12-26 10:38:34', NULL, NULL, 5544, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:38:34', 'admin-1482714671-14827199143189527', 1, 0, '', NULL, NULL, NULL),
(16238, '2016-12-26 10:38:34', NULL, NULL, 5544, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:38:34', 'admin-1482714671-14827199143189527', 1, 0, '', NULL, NULL, NULL),
(16239, '2016-12-26 10:38:34', NULL, NULL, 5544, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:38:34', 'admin-1482714671-14827199143189527', 1, 0, '', NULL, NULL, NULL),
(16240, '2016-12-26 10:37:51', NULL, NULL, 5544, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:37:51', 'admin-1482714671-14827198711793118', 1, 1, 'SR', NULL, NULL, NULL),
(16241, '2016-12-26 10:04:44', NULL, NULL, 5541, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:04:44', 'admin-1482714671-14827178842164318', 1, 0, '', NULL, NULL, NULL),
(16242, '2016-12-26 10:06:07', NULL, NULL, 5541, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:06:07', 'admin-1482714671-14827179672996913', 1, 1, 'SR', NULL, NULL, NULL),
(16243, '2016-12-26 10:06:07', NULL, NULL, 5541, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:06:07', 'admin-1482714671-14827179672996913', 1, 1, 'SR', NULL, NULL, NULL),
(16244, '2016-12-26 10:32:05', NULL, NULL, 5543, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:32:05', 'admin-1482714671-1482719525334511', 1, 1, 'SR', NULL, NULL, NULL),
(16245, '2016-12-26 10:27:05', NULL, NULL, 5542, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:27:05', 'admin-1482714671-14827192252113661', 1, 0, '', NULL, NULL, NULL),
(16246, '2016-12-26 10:03:50', NULL, NULL, 5541, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:03:50', 'admin-1482714671-14827178300185128', 1, 0, '', NULL, NULL, NULL),
(16247, '2016-12-26 10:03:50', NULL, NULL, 5541, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482732853', 'admin', '2016-12-26 10:03:50', 'admin-1482714671-14827178300185128', 1, 0, '', NULL, NULL, NULL),
(16248, '2016-12-28 17:26:41', NULL, NULL, 5619, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 17:26:41', 'admin-1482904042-1482917201108779', 1, 0, '', NULL, NULL, NULL),
(16249, '2016-12-28 17:26:41', NULL, NULL, 5619, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 17:26:41', 'admin-1482904042-1482917201108779', 1, 1, 'SR', NULL, NULL, NULL),
(16250, '2016-12-28 15:34:37', NULL, NULL, 5616, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 15:34:37', 'admin-1482904042-1482910477811538', 1, 1, 'SR', NULL, NULL, NULL),
(16251, '2016-12-28 16:12:47', NULL, NULL, 5617, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 16:12:47', 'admin-1482904042-14829127670967031', 1, 0, '', NULL, NULL, NULL),
(16252, '2016-12-28 16:12:47', NULL, NULL, 5617, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 16:12:47', 'admin-1482904042-14829127670967031', 1, 1, 'SR', NULL, NULL, NULL),
(16253, '2016-12-28 16:12:47', NULL, NULL, 5617, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 16:12:47', 'admin-1482904042-14829127670967031', 1, 1, 'SR', NULL, NULL, NULL),
(16254, '2016-12-28 16:12:47', NULL, NULL, 5617, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 16:12:47', 'admin-1482904042-14829127670967031', 1, 0, '', NULL, NULL, NULL),
(16255, '2016-12-28 14:53:08', NULL, NULL, 5610, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 14:53:08', 'admin-1482904042-14829079879479291', 1, 0, '', NULL, NULL, NULL),
(16256, '2016-12-28 14:53:49', NULL, NULL, 5611, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 14:53:49', 'admin-1482904042-14829080288657341', 1, 1, 'SR', NULL, NULL, NULL),
(16257, '2016-12-28 14:59:04', NULL, NULL, 5612, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 14:59:04', 'admin-1482904042-14829083440283343', 1, 1, 'SR', NULL, NULL, NULL),
(16258, '2016-12-28 15:15:02', NULL, NULL, 5613, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 15:15:02', 'admin-1482904042-14829093022151147', 1, 1, 'SR', 1, NULL, NULL),
(16259, '2016-12-28 15:15:02', NULL, NULL, 5613, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 15:15:02', 'admin-1482904042-14829093022151147', 1, 0, '', 1, NULL, NULL),
(16260, '2016-12-28 13:23:49', NULL, NULL, 5601, 0, 181, '116', 'Open Food ', 'Burger', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 13:23:49', 'admin-1482898671-14829026289992226', 1, 0, '', NULL, NULL, NULL),
(16261, '2016-12-28 18:20:39', NULL, NULL, 5623, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 18:20:39', 'admin-1482904042-14829204392846936', 1, 1, 'SR', NULL, NULL, NULL),
(16262, '2016-12-28 18:20:39', NULL, NULL, 5623, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 18:20:39', 'admin-1482904042-14829204392846936', 1, 1, 'SR', NULL, NULL, NULL),
(16263, '2016-12-28 18:20:39', NULL, NULL, 5623, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 18:20:39', 'admin-1482904042-14829204392846936', 1, 1, 'SR', NULL, NULL, NULL),
(16264, '2016-12-28 18:24:05', NULL, NULL, 5624, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 18:24:05', 'admin-1482904042-14829206454096940', 1, 1, 'SR', NULL, NULL, NULL),
(16265, '2016-12-28 18:24:05', NULL, NULL, 5624, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 18:24:05', 'admin-1482904042-14829206454096940', 1, 0, '', NULL, NULL, NULL),
(16266, '2016-12-28 18:24:05', NULL, NULL, 5624, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 18:24:05', 'admin-1482904042-14829206454096940', 1, 1, 'SR', NULL, NULL, NULL),
(16267, '2016-12-28 18:24:05', NULL, NULL, 5624, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 18:24:05', 'admin-1482904042-14829206454096940', 1, 0, '', NULL, NULL, NULL),
(16268, '2016-12-28 18:24:48', NULL, NULL, 5624, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1482920800', 'admin', '2016-12-28 18:24:48', 'admin-1482904042-14829206887061666', 1, 0, '', NULL, NULL, NULL),
(16269, '2016-12-28 19:35:40', NULL, NULL, 5624, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 19:35:40', 'admin-1482920800-14829249397876644', 1, 0, '', NULL, NULL, NULL),
(16270, '2016-12-28 12:39:56', NULL, NULL, 5600, 0, 84, '84', 'Set Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 12:39:56', 'admin-1482898671-14828999963248551', 1, 1, 'SR', NULL, NULL, NULL),
(16271, '2016-12-28 12:39:56', NULL, NULL, 5600, 0, 82, '82', 'Set Stir Fried Rice Wine Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 12:39:56', 'admin-1482898671-14828999963248551', 1, 1, 'SR', NULL, NULL, NULL),
(16272, '2016-12-28 12:39:56', NULL, NULL, 5600, 0, 213, '147', 'Set Stir Fried Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 12:39:56', 'admin-1482898671-14828999963248551', 1, 0, '', NULL, NULL, NULL),
(16273, '2016-12-28 12:44:19', NULL, NULL, 5601, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 12:44:19', 'admin-1482898671-14829002589807032', 1, 0, '', NULL, NULL, NULL),
(16274, '2016-12-28 13:47:13', NULL, NULL, 5607, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 13:47:13', 'admin-1482898671-14829040337507525', 1, 1, 'SR', NULL, NULL, NULL),
(16275, '2016-12-28 13:47:13', NULL, NULL, 5607, 0, 214, '148', 'Set Fried Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 13:47:13', 'admin-1482898671-14829040337507525', 1, 0, '', NULL, NULL, NULL),
(16276, '2016-12-28 13:47:13', NULL, NULL, 5607, 0, 83, '83', 'Set Stir Fried Chicken with Mushroom ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 13:47:13', 'admin-1482898671-14829040337507525', 1, 1, 'SR', NULL, NULL, NULL),
(16277, '2016-12-28 13:48:13', NULL, NULL, 5607, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 13:48:13', 'admin-1482904042-14829040935497126', 1, 1, 'SR', NULL, NULL, NULL),
(16278, '2016-12-28 13:54:25', NULL, NULL, 5608, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 13:54:25', 'admin-1482904042-1482904465223267', 1, 0, '', NULL, NULL, NULL),
(16279, '2016-12-28 18:20:39', NULL, NULL, 5623, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 18:20:39', 'admin-1482904042-14829204392846936', 1, 0, '', NULL, NULL, NULL),
(16280, '2016-12-28 18:03:47', NULL, NULL, 5622, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 18:03:47', 'admin-1482904042-14829194269398413', 1, 1, 'SR', NULL, NULL, NULL),
(16281, '2016-12-28 17:26:41', NULL, NULL, 5619, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 17:26:41', 'admin-1482904042-1482917201108779', 1, 1, 'SR', NULL, NULL, NULL),
(16282, '2016-12-28 00:00:00', NULL, NULL, 5620, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 17:14:29', 'admin-1482904042-14829164688913158', 1, 0, '', NULL, NULL, NULL),
(16283, '2016-12-28 00:00:00', NULL, NULL, 5621, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 17:14:29', 'admin-1482904042-14829164688913158', 1, 1, 'SR', NULL, NULL, NULL),
(16284, '2016-12-28 18:03:47', NULL, NULL, 5622, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 18:03:47', 'admin-1482904042-14829194269398413', 1, 1, 'SR', NULL, NULL, NULL),
(16285, '2016-12-28 16:28:14', NULL, NULL, 5615, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 16:28:14', 'admin-1482904042-1482913694562445', 1, 0, '', NULL, NULL, NULL),
(16286, '2016-12-28 15:30:16', NULL, NULL, 5615, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 15:30:16', 'admin-1482904042-14829102158953872', 1, 0, '', NULL, NULL, NULL),
(16287, '2016-12-28 15:30:16', NULL, NULL, 5615, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 15:30:16', 'admin-1482904042-14829102158953872', 1, 1, 'SR', NULL, NULL, NULL),
(16288, '2016-12-28 15:30:16', NULL, NULL, 5615, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 15:30:16', 'admin-1482904042-14829102158953872', 1, 1, 'SR', NULL, NULL, NULL),
(16289, '2016-12-28 15:30:16', NULL, NULL, 5615, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 15:30:16', 'admin-1482904042-14829102158953872', 1, 1, 'SR', NULL, NULL, NULL),
(16290, '2016-12-28 15:34:37', NULL, NULL, 5616, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 15:34:37', 'admin-1482904042-1482910477811538', 1, 1, 'SR', NULL, NULL, NULL),
(16291, '2016-12-28 15:17:01', NULL, NULL, 5613, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 15:17:01', 'admin-1482904042-14829094216892781', 1, 0, '', 1, NULL, NULL),
(16292, '2016-12-28 15:21:53', NULL, NULL, 5614, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 15:21:53', 'admin-1482904042-1482909713198196', 1, 1, 'SR', NULL, NULL, NULL),
(16293, '2016-12-28 15:30:16', NULL, NULL, 5615, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 15:30:16', 'admin-1482904042-14829102158953872', 1, 0, '', NULL, NULL, NULL),
(16294, '2016-12-28 15:17:01', NULL, NULL, 5613, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 15:17:01', 'admin-1482904042-14829094216892781', 1, 0, '', 1, NULL, NULL),
(16295, '2016-12-28 15:16:20', NULL, NULL, 5613, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 15:16:20', 'admin-1482904042-14829093801432178', 1, 1, 'SR', 1, NULL, NULL),
(16296, '2016-12-28 15:15:02', NULL, NULL, 5613, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 15:15:02', 'admin-1482904042-14829093022151147', 1, 1, 'SR', 1, NULL, NULL),
(16297, '2016-12-28 13:25:36', NULL, NULL, 5606, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 13:25:36', 'admin-1482898671-14829027361662462', 1, 1, 'SR', NULL, NULL, NULL),
(16298, '2016-12-28 13:28:54', NULL, NULL, 5600, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 13:28:54', 'admin-1482898671-14829029340216859', 1, 1, 'SR', NULL, NULL, NULL),
(16299, '2016-12-28 13:28:54', NULL, NULL, 5600, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 13:28:54', 'admin-1482898671-14829029340216859', 1, 0, '', NULL, NULL, NULL),
(16300, '2016-12-28 13:30:35', NULL, NULL, 5601, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 13:30:35', 'admin-1482898671-14829030348562878', 1, 0, '', NULL, NULL, NULL),
(16301, '2016-12-28 13:54:25', NULL, NULL, 5608, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 13:54:25', 'admin-1482904042-1482904465223267', 1, 0, '', NULL, NULL, NULL),
(16302, '2016-12-28 14:08:00', NULL, NULL, 5609, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 14:08:00', 'admin-1482904042-14829052802353815', 1, 0, '', NULL, NULL, NULL),
(16303, '2016-12-28 14:08:00', NULL, NULL, 5609, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 14:08:00', 'admin-1482904042-14829052802353815', 1, 1, 'SR', NULL, NULL, NULL),
(16304, '2016-12-28 14:51:58', NULL, NULL, 5610, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 14:51:58', 'admin-1482904042-14829079182835990', 1, 0, '', NULL, NULL, NULL),
(16305, '2016-12-28 14:51:58', NULL, NULL, 5610, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 14:51:58', 'admin-1482904042-14829079182835990', 1, 0, '', NULL, NULL, NULL),
(16306, '2016-12-28 12:39:56', NULL, NULL, 5600, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 12:39:56', 'admin-1482898671-14828999963248551', 1, 0, '', NULL, NULL, NULL),
(16307, '2016-12-28 14:53:08', NULL, NULL, 5610, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 14:53:08', 'admin-1482904042-14829079879479291', 1, 0, '', NULL, NULL, NULL),
(16308, '2016-12-28 13:25:36', NULL, NULL, 5606, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 13:25:36', 'admin-1482898671-14829027361662462', 1, 1, 'SR', NULL, NULL, NULL),
(16309, '2016-12-28 13:25:29', NULL, NULL, 5606, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 13:25:29', 'admin-1482898671-14829027290823275', 1, 0, '', NULL, NULL, NULL),
(16310, '2016-12-28 13:25:29', NULL, NULL, 5606, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 13:25:29', 'admin-1482898671-14829027290823275', 1, 0, '', NULL, NULL, NULL),
(16311, '2016-12-28 13:20:53', NULL, NULL, 5605, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 13:20:53', 'admin-1482898671-14829024528949347', 1, 1, 'SR', NULL, NULL, NULL),
(16312, '2016-12-28 13:47:13', NULL, NULL, 5607, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 13:47:13', 'admin-1482898671-14829040337507525', 1, 0, '', NULL, NULL, NULL),
(16313, '2016-12-28 12:44:19', NULL, NULL, 5601, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 12:44:19', 'admin-1482898671-14829002589807032', 1, 1, 'SR', NULL, NULL, NULL),
(16314, '2016-12-28 13:23:49', NULL, NULL, 5601, 0, 181, '116', 'Open Food ', 'Burger', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 13:23:49', 'admin-1482898671-14829026289992226', 1, 0, '', NULL, NULL, NULL),
(16315, '2016-12-28 13:20:53', NULL, NULL, 5605, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 13:20:53', 'admin-1482898671-14829024528949347', 1, 1, 'SR', NULL, NULL, NULL),
(16316, '2016-12-28 13:19:54', NULL, NULL, 5600, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 13:19:54', 'admin-1482898671-14829023941702924', 1, 0, '', NULL, NULL, NULL),
(16317, '2016-12-28 12:59:10', NULL, NULL, 5604, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 12:59:10', 'admin-1482898671-14829011498545879', 1, 0, '', NULL, NULL, NULL),
(16318, '2016-12-28 12:58:50', NULL, NULL, 5603, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 12:58:50', 'admin-1482898671-14829011305192614', 1, 1, 'SR', NULL, NULL, NULL),
(16319, '2016-12-28 12:56:17', NULL, NULL, 5602, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 12:56:17', 'admin-1482898671-1482900977073132', 1, 0, '', NULL, NULL, NULL),
(16320, '2016-12-28 12:58:50', NULL, NULL, 5603, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 12:58:50', 'admin-1482898671-14829011305192614', 1, 1, 'SR', NULL, NULL, NULL),
(16321, '2016-12-28 12:44:19', NULL, NULL, 5601, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 12:44:19', 'admin-1482898671-14829002589807032', 1, 0, '', NULL, NULL, NULL),
(16322, '2016-12-28 12:44:19', NULL, NULL, 5601, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 12:44:19', 'admin-1482898671-14829002589807032', 1, 1, 'SR', NULL, NULL, NULL),
(16323, '2016-12-28 12:19:32', NULL, NULL, 5597, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 12:19:32', 'admin-1482898671-14828987722177779', 1, 1, 'SR', NULL, NULL, NULL),
(16324, '2016-12-28 12:19:32', NULL, NULL, 5597, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 12:19:32', 'admin-1482898671-14828987722177779', 1, 1, 'SR', NULL, NULL, NULL),
(16325, '2016-12-28 12:19:44', NULL, NULL, 5598, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 12:19:44', 'admin-1482898671-14828987842392595', 1, 1, 'SR', NULL, NULL, '10.0'),
(16326, '2016-12-28 12:23:02', NULL, NULL, 5599, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 12:23:02', 'admin-1482898671-14828989823635198', 1, 1, 'SR', NULL, NULL, NULL),
(16327, '2016-12-28 12:23:02', NULL, NULL, 5599, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 12:23:02', 'admin-1482898671-14828989823635198', 1, 1, 'SR', NULL, NULL, NULL),
(16328, '2016-12-28 12:39:56', NULL, NULL, 5600, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 12:39:56', 'admin-1482898671-14828999963248551', 1, 0, '', NULL, NULL, NULL),
(16329, '2016-12-28 12:17:29', NULL, NULL, 5597, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 12:17:29', 'admin-1482886119-14828986493625413', 1, 0, '', NULL, NULL, NULL),
(16330, '2016-12-28 11:30:02', NULL, NULL, 5596, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 11:30:02', 'admin-1482886119-14828958023738395', 1, 0, '', NULL, NULL, NULL),
(16331, '2016-12-28 09:32:04', NULL, NULL, 5593, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 09:32:04', 'admin-1482886119-14828887241017677', 1, 0, '', NULL, NULL, NULL),
(16332, '2016-12-28 09:32:04', NULL, NULL, 5593, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 09:32:04', 'admin-1482886119-14828887241017677', 1, 1, 'SR', NULL, NULL, NULL),
(16333, '2016-12-28 09:32:04', NULL, NULL, 5593, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 09:32:04', 'admin-1482886119-14828887241017677', 1, 1, 'SR', NULL, NULL, NULL),
(16334, '2016-12-28 09:59:53', NULL, NULL, 5594, 0, 154, '88', 'House BLT', 'no egg,with cheese', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 09:59:53', 'admin-1482886119-14828903929343979', 1, 0, '', NULL, NULL, NULL),
(16335, '2016-12-28 09:52:02', NULL, NULL, 5594, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 09:52:02', 'admin-1482886119-14828899225705985', 1, 0, '', NULL, NULL, NULL),
(16336, '2016-12-28 09:52:12', NULL, NULL, 5594, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 09:52:12', 'admin-1482886119-14828899320543573', 1, 1, 'SR', NULL, NULL, NULL),
(16337, '2016-12-28 09:52:12', NULL, NULL, 5594, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 09:52:12', 'admin-1482886119-14828899320543573', 1, 1, 'SR', NULL, NULL, NULL),
(16338, '2016-12-28 10:28:06', NULL, NULL, 5595, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 10:28:06', 'admin-1482886119-14828920863391935', 1, 0, '', NULL, NULL, NULL),
(16339, '2016-12-28 10:28:06', NULL, NULL, 5595, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 10:28:06', 'admin-1482886119-14828920863391935', 1, 0, '', NULL, NULL, NULL),
(16340, '2016-12-28 10:28:06', NULL, NULL, 5595, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 10:28:06', 'admin-1482886119-14828920863391935', 1, 0, '', NULL, NULL, NULL),
(16341, '2016-12-28 10:28:21', NULL, NULL, 5595, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 10:28:21', 'admin-1482886119-14828921010435050', 1, 1, 'SR', NULL, NULL, NULL),
(16342, '2016-12-28 10:28:21', NULL, NULL, 5595, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 10:28:21', 'admin-1482886119-14828921010435050', 1, 0, '', NULL, NULL, NULL),
(16343, '2016-12-28 10:28:21', NULL, NULL, 5595, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 10:28:21', 'admin-1482886119-14828921010435050', 1, 1, 'SR', NULL, NULL, NULL),
(16344, '2016-12-28 10:46:16', NULL, NULL, 5594, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 10:46:16', 'admin-1482886119-14828931764902988', 1, 1, 'SR', NULL, NULL, NULL),
(16345, '2016-12-28 11:30:02', NULL, NULL, 5596, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 11:30:02', 'admin-1482886119-14828958023738395', 1, 1, 'SR', NULL, NULL, NULL),
(16346, '2016-12-28 11:30:02', NULL, NULL, 5596, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 11:30:02', 'admin-1482886119-14828958023738395', 1, 1, 'SR', NULL, NULL, NULL),
(16347, '2016-12-28 11:30:02', NULL, NULL, 5596, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 11:30:02', 'admin-1482886119-14828958023738395', 1, 1, 'SR', NULL, NULL, NULL),
(16348, '2016-12-28 11:30:02', NULL, NULL, 5596, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 11:30:02', 'admin-1482886119-14828958023738395', 1, 0, '', NULL, NULL, NULL),
(16349, '2016-12-28 09:32:04', NULL, NULL, 5593, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 09:32:04', 'admin-1482886119-14828887241017677', 1, 0, '', NULL, NULL, NULL),
(16350, '2016-12-28 09:10:49', NULL, NULL, 5592, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 09:10:49', 'admin-1482886119-14828874497791279', 1, 1, 'SR', NULL, NULL, NULL),
(16351, '2016-12-28 09:10:49', NULL, NULL, 5592, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 09:10:49', 'admin-1482886119-14828874497791279', 1, 1, 'SR', NULL, NULL, NULL),
(16352, '2016-12-28 09:10:49', NULL, NULL, 5592, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 09:10:49', 'admin-1482886119-14828874497791279', 1, 0, '', NULL, NULL, NULL),
(16353, '2016-12-28 09:10:49', NULL, NULL, 5592, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 09:10:49', 'admin-1482886119-14828874497791279', 1, 1, 'SR', NULL, NULL, NULL),
(16354, '2016-12-28 09:10:35', NULL, NULL, 5592, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 09:10:35', 'admin-1482886119-14828874355375229', 1, 0, '', NULL, NULL, NULL),
(16355, '2016-12-28 09:10:35', NULL, NULL, 5592, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 09:10:35', 'admin-1482886119-14828874355375229', 1, 0, '', NULL, NULL, NULL),
(16356, '2016-12-28 09:10:35', NULL, NULL, 5592, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 09:10:35', 'admin-1482886119-14828874355375229', 1, 0, '', NULL, NULL, NULL),
(16357, '2016-12-28 09:10:35', NULL, NULL, 5592, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482920800', 'admin', '2016-12-28 09:10:35', 'admin-1482886119-14828874355375229', 1, 0, '', NULL, NULL, NULL),
(16358, '2016-12-29 14:43:08', NULL, NULL, 5643, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 14:43:08', 'admin-1482980530-14829937885498397', 1, 1, 'SR', NULL, NULL, NULL),
(16359, '2016-12-29 18:36:25', NULL, NULL, 5645, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 18:36:25', 'admin-1482980530-14830077854001391', 1, 0, '', NULL, NULL, NULL),
(16360, '2016-12-29 18:36:25', NULL, NULL, 5645, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 18:36:25', 'admin-1482980530-14830077854001391', 1, 0, '', NULL, NULL, NULL),
(16361, '2016-12-29 12:51:59', NULL, NULL, 5638, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 12:51:59', 'admin-1482980530-1482987119156532', 1, 0, '', NULL, NULL, NULL),
(16362, '2016-12-29 12:51:59', NULL, NULL, 5638, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 12:51:59', 'admin-1482980530-1482987119156532', 1, 1, 'SR', NULL, NULL, NULL),
(16363, '2016-12-29 14:43:08', NULL, NULL, 5643, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 14:43:08', 'admin-1482980530-14829937885498397', 1, 1, 'SR', NULL, NULL, NULL),
(16364, '2016-12-29 18:29:57', NULL, NULL, 5645, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 18:29:57', 'admin-1482980530-14830073976123764', 1, 1, 'SR', NULL, NULL, NULL),
(16365, '2016-12-29 17:17:01', NULL, NULL, 5644, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 17:17:01', 'admin-1482980530-14830030209841311', 1, 1, 'SR', 1, NULL, NULL),
(16366, '2016-12-29 13:45:29', NULL, NULL, 5642, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 13:45:29', 'admin-1482980530-1482990329028584', 1, 1, 'SR', NULL, NULL, NULL),
(16367, '2016-12-29 14:43:08', NULL, NULL, 5643, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 14:43:08', 'admin-1482980530-14829937885498397', 1, 1, 'SR', NULL, NULL, NULL),
(16368, '2016-12-29 14:01:26', NULL, NULL, 5636, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 14:01:26', 'admin-1482980530-14829912859788731', 1, 1, 'SR', NULL, NULL, NULL),
(16369, '2016-12-29 13:29:12', NULL, NULL, 5641, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 13:29:12', 'admin-1482980530-14829893523307846', 1, 1, 'SR', NULL, NULL, NULL),
(16370, '2016-12-29 13:29:12', NULL, NULL, 5641, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 13:29:12', 'admin-1482980530-14829893523307846', 1, 1, 'SR', NULL, NULL, NULL),
(16371, '2016-12-29 13:15:46', NULL, NULL, 5639, 0, 213, '147', 'Set Stir Fried Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 13:15:46', 'admin-1482980530-14829885463419493', 1, 0, '', NULL, NULL, NULL),
(16372, '2016-12-29 13:23:14', NULL, NULL, 5640, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 13:23:14', 'admin-1482980530-1482988994697389', 1, 0, '', NULL, NULL, NULL),
(16373, '2016-12-29 11:27:36', NULL, NULL, 5634, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 11:27:36', 'admin-1482980530-14829820562974987', 1, 1, 'SR', NULL, NULL, NULL),
(16374, '2016-12-29 12:11:09', NULL, NULL, 5635, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 12:11:09', 'admin-1482980530-14829846694096356', 1, 0, '', NULL, NULL, NULL),
(16375, '2016-12-29 12:11:09', NULL, NULL, 5635, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 12:11:09', 'admin-1482980530-14829846694096356', 1, 1, 'SR', NULL, NULL, NULL),
(16376, '2016-12-29 12:11:22', NULL, NULL, 5636, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 12:11:22', 'admin-1482980530-14829846819576921', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(16377, '2016-12-29 12:21:15', NULL, NULL, 5637, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 12:21:15', 'admin-1482980530-14829852755332432', 1, 1, 'SR', NULL, NULL, NULL),
(16378, '2016-12-29 12:21:15', NULL, NULL, 5637, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 12:21:15', 'admin-1482980530-14829852755332432', 1, 0, '', NULL, NULL, NULL),
(16379, '2016-12-29 11:27:36', NULL, NULL, 5634, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 11:27:36', 'admin-1482980530-14829820562974987', 1, 1, 'SR', NULL, NULL, NULL),
(16380, '2016-12-29 11:27:36', NULL, NULL, 5634, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 11:27:36', 'admin-1482980530-14829820562974987', 1, 1, 'SR', NULL, NULL, NULL),
(16381, '2016-12-29 11:27:07', NULL, NULL, 5633, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 11:27:07', 'admin-1482980530-1482982027132863', 1, 1, 'SR', NULL, NULL, NULL),
(16382, '2016-12-29 11:26:51', NULL, NULL, 5631, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 11:26:51', 'admin-1482980530-14829820115774780', 1, 1, 'SR', NULL, NULL, NULL),
(16383, '2016-12-29 11:26:51', NULL, NULL, 5631, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 11:26:51', 'admin-1482980530-14829820115774780', 1, 1, 'SR', NULL, NULL, NULL),
(16384, '2016-12-29 11:27:01', NULL, NULL, 5632, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 11:27:01', 'admin-1482980530-14829820214566463', 1, 1, 'SR', NULL, NULL, NULL),
(16385, '2016-12-29 10:18:59', NULL, NULL, 5626, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 10:18:59', 'admin-1482972161-14829779397668764', 1, 1, 'SR', NULL, NULL, NULL),
(16386, '2016-12-29 10:18:59', NULL, NULL, 5626, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 10:18:59', 'admin-1482972161-14829779397668764', 1, 0, '', NULL, NULL, NULL),
(16387, '2016-12-29 10:18:59', NULL, NULL, 5626, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 10:18:59', 'admin-1482972161-14829779397668764', 1, 1, 'SR', NULL, NULL, NULL),
(16388, '2016-12-29 10:18:59', NULL, NULL, 5626, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 10:19:00', 'admin-1482972161-14829779397668764', 1, 1, 'SR', NULL, NULL, NULL),
(16389, '2016-12-29 10:36:40', NULL, NULL, 5627, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 10:36:40', 'admin-1482972161-14829790001899030', 1, 0, '', NULL, NULL, NULL),
(16390, '2016-12-29 10:36:40', NULL, NULL, 5627, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 10:36:40', 'admin-1482972161-14829790001899030', 1, 0, '', NULL, NULL, NULL),
(16391, '2016-12-29 10:36:40', NULL, NULL, 5627, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 10:36:40', 'admin-1482972161-14829790001899030', 1, 1, 'SR', NULL, NULL, NULL),
(16392, '2016-12-29 10:36:40', NULL, NULL, 5627, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 10:36:40', 'admin-1482972161-14829790001899030', 1, 1, 'SR', NULL, NULL, NULL),
(16393, '2016-12-29 10:37:22', NULL, NULL, 5628, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 10:37:22', 'admin-1482972161-14829790424258315', 1, 0, '', NULL, NULL, NULL),
(16394, '2016-12-29 10:37:22', NULL, NULL, 5628, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 10:37:22', 'admin-1482972161-14829790424258315', 1, 1, 'SR', NULL, NULL, NULL),
(16395, '2016-12-29 10:39:33', NULL, NULL, 5626, 0, 181, '116', 'Open Food ', 'toast', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 10:39:33', 'admin-1482972161-14829791728514155', 1, 0, '', NULL, NULL, NULL),
(16396, '2016-12-29 10:53:39', NULL, NULL, 5628, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 10:53:39', 'admin-1482972161-14829800193836338', 1, 1, 'SR', NULL, NULL, NULL),
(16397, '2016-12-29 10:55:35', NULL, NULL, 5628, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 10:55:35', 'admin-1482972161-14829801351178724', 1, 1, 'SR', NULL, NULL, NULL),
(16398, '2016-12-29 11:02:01', NULL, NULL, 5629, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 11:02:01', 'admin-1482972161-14829805216914193', 1, 0, '', NULL, NULL, NULL),
(16399, '2016-12-29 11:02:17', NULL, NULL, 5629, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 11:02:17', 'admin-1482980530-14829805377679686', 1, 1, 'SR', NULL, NULL, NULL),
(16400, '2016-12-29 11:09:30', NULL, NULL, 5630, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 11:09:30', 'admin-1482980530-1482980970138953', 1, 1, 'SR', NULL, NULL, NULL),
(16401, '2016-12-29 09:53:26', NULL, NULL, 5625, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 09:53:26', 'admin-1482972161-14829764068086471', 1, 0, '', NULL, NULL, NULL),
(16402, '2016-12-29 10:18:49', NULL, NULL, 5626, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 10:18:49', 'admin-1482972161-14829779293168182', 1, 0, '', NULL, NULL, NULL),
(16403, '2016-12-29 10:18:49', NULL, NULL, 5626, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 10:18:49', 'admin-1482972161-14829779293168182', 1, 0, '', NULL, NULL, NULL),
(16404, '2016-12-29 10:18:49', NULL, NULL, 5626, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 10:18:49', 'admin-1482972161-14829779293168182', 1, 0, '', NULL, NULL, NULL),
(16405, '2016-12-29 11:09:30', NULL, NULL, 5630, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 11:09:30', 'admin-1482980530-1482980970138953', 1, 1, 'SR', NULL, NULL, NULL),
(16406, '2016-12-29 10:18:49', NULL, NULL, 5626, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 10:18:49', 'admin-1482972161-14829779293168182', 1, 0, '', NULL, NULL, NULL),
(16407, '2016-12-29 09:47:29', NULL, NULL, 5625, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 09:47:29', 'admin-1482972161-1482976049547216', 1, 0, '', NULL, NULL, NULL),
(16408, '2016-12-29 09:47:23', NULL, NULL, 5625, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1482980530', 'admin', '2016-12-29 09:47:23', 'admin-1482972161-14829760430292778', 1, 0, '', NULL, NULL, NULL),
(16409, '2016-12-30 20:34:12', NULL, NULL, 5685, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 20:34:12', 'admin-1483066124-14831012520285090', 1, 0, '', NULL, NULL, NULL),
(16410, '2016-12-30 21:10:24', NULL, NULL, 5685, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 21:10:24', 'admin-1483066124-1483103424018250', 1, 1, 'SR', NULL, NULL, NULL),
(16411, '2016-12-30 21:10:33', NULL, NULL, 5686, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 21:10:33', 'admin-1483066124-1483103433435364', 1, 1, 'SR', NULL, NULL, NULL),
(16412, '2016-12-30 16:29:34', NULL, NULL, 5667, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:29:34', 'admin-1483066124-14830865742094045', 1, 1, 'SR', NULL, NULL, NULL),
(16413, '2016-12-30 16:39:27', NULL, NULL, 5671, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:39:27', 'admin-1483066124-1483087167347949', 1, 1, 'SR', NULL, NULL, NULL),
(16414, '2016-12-30 16:39:27', NULL, NULL, 5671, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:39:27', 'admin-1483066124-1483087167347949', 1, 0, '', NULL, NULL, NULL),
(16415, '2016-12-30 16:40:03', NULL, NULL, 5672, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:40:03', 'admin-1483066124-14830872031582597', 1, 1, 'SR', NULL, NULL, NULL),
(16416, '2016-12-30 16:40:03', NULL, NULL, 5672, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:40:03', 'admin-1483066124-14830872031582597', 1, 1, 'SR', NULL, NULL, NULL),
(16417, '2016-12-30 15:17:54', NULL, NULL, 5664, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 15:17:54', 'admin-1483066124-14830822743513694', 1, 1, 'SR', NULL, NULL, NULL),
(16418, '2016-12-30 16:40:03', NULL, NULL, 5672, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:40:03', 'admin-1483066124-14830872031582597', 1, 1, 'SR', NULL, NULL, NULL),
(16419, '2016-12-30 16:40:03', NULL, NULL, 5672, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:40:03', 'admin-1483066124-14830872031582597', 1, 1, 'SR', NULL, NULL, NULL),
(16420, '2016-12-30 16:47:00', NULL, NULL, 5673, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:47:00', 'admin-1483066124-1483087620710869', 1, 1, 'SR', NULL, NULL, NULL),
(16421, '2016-12-30 16:47:00', NULL, NULL, 5673, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:47:00', 'admin-1483066124-1483087620710869', 1, 1, 'SR', NULL, NULL, NULL),
(16422, '2016-12-30 16:47:55', NULL, NULL, 5674, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:47:55', 'admin-1483066124-14830876749343455', 1, 1, 'SR', NULL, NULL, NULL),
(16423, '2016-12-30 16:47:55', NULL, NULL, 5674, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:47:55', 'admin-1483066124-14830876749343455', 1, 1, 'SR', NULL, NULL, NULL),
(16424, '2016-12-30 16:47:55', NULL, NULL, 5674, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:47:55', 'admin-1483066124-14830876749343455', 1, 1, 'SR', NULL, NULL, NULL),
(16425, '2016-12-30 16:47:55', NULL, NULL, 5674, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:47:55', 'admin-1483066124-14830876749343455', 1, 1, 'SR', NULL, NULL, NULL),
(16426, '2016-12-30 16:49:15', NULL, NULL, 5675, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:49:15', 'admin-1483066124-1483087755540902', 1, 1, 'SR', NULL, NULL, NULL),
(16427, '2016-12-30 16:49:15', NULL, NULL, 5675, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:49:15', 'admin-1483066124-1483087755540902', 1, 1, 'SR', NULL, NULL, NULL),
(16428, '2016-12-30 16:51:18', NULL, NULL, 5676, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:51:18', 'admin-1483066124-14830878781755996', 1, 1, 'SR', NULL, NULL, NULL),
(16429, '2016-12-30 16:51:18', NULL, NULL, 5676, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:51:18', 'admin-1483066124-14830878781755996', 1, 1, 'SR', NULL, NULL, NULL),
(16430, '2016-12-30 16:52:26', NULL, NULL, 5677, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:52:26', 'admin-1483066124-14830879465845627', 1, 1, 'SR', NULL, NULL, NULL),
(16431, '2016-12-30 16:52:26', NULL, NULL, 5677, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:52:26', 'admin-1483066124-14830879465845627', 1, 1, 'SR', NULL, NULL, NULL),
(16432, '2016-12-30 16:52:26', NULL, NULL, 5677, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:52:26', 'admin-1483066124-14830879465845627', 1, 0, '', NULL, NULL, NULL),
(16433, '2016-12-30 16:52:36', NULL, NULL, 5677, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:52:36', 'admin-1483066124-14830879567255026', 1, 0, '', NULL, NULL, NULL),
(16434, '2016-12-30 16:59:41', NULL, NULL, 5678, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:59:41', 'admin-1483066124-14830883808601699', 1, 1, 'SR', NULL, NULL, NULL),
(16435, '2016-12-30 16:59:41', NULL, NULL, 5678, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:59:41', 'admin-1483066124-14830883808601699', 1, 1, 'SR', NULL, NULL, NULL),
(16436, '2016-12-30 17:07:51', NULL, NULL, 5679, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 17:07:51', 'admin-1483066124-14830888715066716', 1, 1, 'SR', NULL, NULL, NULL),
(16437, '2016-12-30 17:08:12', NULL, NULL, 5679, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 17:08:12', 'admin-1483066124-1483088892809551', 1, 0, '', NULL, NULL, NULL),
(16438, '2016-12-30 17:25:16', NULL, NULL, 5680, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 17:25:16', 'admin-1483066124-14830899158828234', 1, 1, 'SR', 1, NULL, NULL),
(16439, '2016-12-30 17:54:30', NULL, NULL, 5681, 0, 75, '75', 'Meatless Aglio Olio ', 'Takeaway', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 17:54:31', 'admin-1483066124-1483091670749595', 1, 0, '', NULL, NULL, NULL),
(16440, '2016-12-30 15:50:07', NULL, NULL, 5667, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 15:50:07', 'admin-1483066124-14830842074388531', 1, 0, '', NULL, NULL, NULL),
(16441, '2016-12-30 15:40:44', NULL, NULL, 5666, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 15:40:44', 'admin-1483066124-14830836439396146', 1, 1, 'SR', NULL, NULL, NULL),
(16442, '2016-12-30 15:39:55', NULL, NULL, 5665, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 15:39:55', 'admin-1483066124-14830835952256840', 1, 1, 'SR', NULL, NULL, NULL),
(16443, '2016-12-30 11:58:50', NULL, NULL, 5659, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 11:58:50', 'admin-1483066124-14830703301747162', 1, 1, 'SR', NULL, NULL, NULL),
(16444, '2016-12-30 11:58:50', NULL, NULL, 5659, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 11:58:50', 'admin-1483066124-14830703301747162', 1, 1, 'SR', NULL, NULL, NULL),
(16445, '2016-12-30 20:41:54', NULL, NULL, 5684, 0, 259, '193', 'Coronado Beer Set', '', 'Cold Drinks', 'Soda & Beer', 1, 40.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 20:41:54', 'admin-1483066124-14831017140755068', 1, 0, '', NULL, NULL, NULL),
(16446, '2016-12-30 20:30:24', NULL, NULL, 5685, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 20:30:24', 'admin-1483066124-14831010239737087', 1, 0, '', NULL, NULL, NULL),
(16447, '2016-12-30 20:30:24', NULL, NULL, 5685, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 20:30:24', 'admin-1483066124-14831010239737087', 1, 0, '', NULL, NULL, NULL),
(16448, '2016-12-30 20:30:24', NULL, NULL, 5685, 0, 259, '193', 'Coronado Beer Set', '', 'Cold Drinks', 'Soda & Beer', 1, 40.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 20:30:24', 'admin-1483066124-14831010239737087', 1, 0, '', NULL, NULL, NULL),
(16449, '2016-12-30 20:34:04', NULL, NULL, 5685, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 20:34:04', 'admin-1483066124-14831012447714240', 1, 1, 'SR', NULL, NULL, NULL),
(16450, '2016-12-30 19:41:35', NULL, NULL, 5684, 0, 259, '193', 'Coronado Beer Set', '', 'Cold Drinks', 'Soda & Beer', 1, 40.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 19:41:35', 'admin-1483066124-14830980953244649', 1, 0, '', NULL, NULL, NULL),
(16451, '2016-12-30 19:08:07', NULL, NULL, 5683, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 19:08:07', 'admin-1483066124-14830960869539372', 1, 1, 'SR', NULL, NULL, NULL),
(16452, '2016-12-30 19:41:35', NULL, NULL, 5684, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 19:41:35', 'admin-1483066124-14830980953244649', 1, 1, 'SR', NULL, NULL, NULL),
(16453, '2016-12-30 17:56:41', NULL, NULL, 5682, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 17:56:41', 'admin-1483066124-14830918013683877', 1, 1, 'SR', NULL, NULL, NULL),
(16454, '2016-12-30 17:56:41', NULL, NULL, 5682, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 17:56:41', 'admin-1483066124-14830918013683877', 1, 1, 'SR', NULL, NULL, NULL),
(16455, '2016-12-30 16:11:13', NULL, NULL, 5668, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:11:13', 'admin-1483066124-14830854736405990', 1, 0, '', NULL, NULL, NULL),
(16456, '2016-12-30 16:11:13', NULL, NULL, 5668, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:11:13', 'admin-1483066124-14830854736405990', 1, 1, 'SR', NULL, NULL, NULL),
(16457, '2016-12-30 16:11:13', NULL, NULL, 5668, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:11:13', 'admin-1483066124-14830854736405990', 1, 1, 'SR', NULL, NULL, NULL),
(16458, '2016-12-30 16:11:13', NULL, NULL, 5668, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:11:13', 'admin-1483066124-14830854736405990', 1, 0, '', NULL, NULL, NULL),
(16459, '2016-12-30 16:15:08', NULL, NULL, 5666, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:15:08', 'admin-1483066124-14830857087203478', 1, 0, '', NULL, NULL, NULL),
(16460, '2016-12-30 16:15:08', NULL, NULL, 5666, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:15:08', 'admin-1483066124-14830857087203478', 1, 1, 'SR', NULL, NULL, NULL),
(16461, '2016-12-30 16:15:54', NULL, NULL, 5669, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:15:54', 'admin-1483066124-14830857542754472', 1, 1, 'SR', NULL, NULL, NULL),
(16462, '2016-12-30 16:15:54', NULL, NULL, 5669, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:15:54', 'admin-1483066124-14830857542754472', 1, 1, 'SR', NULL, NULL, NULL),
(16463, '2016-12-30 16:22:25', NULL, NULL, 5670, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:22:25', 'admin-1483066124-14830861451939656', 1, 1, 'SR', 1, NULL, NULL),
(16464, '2016-12-30 16:27:26', NULL, NULL, 5668, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:27:26', 'admin-1483066124-14830864464475525', 1, 0, '', NULL, NULL, NULL),
(16465, '2016-12-30 16:29:34', NULL, NULL, 5667, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:29:34', 'admin-1483066124-14830865742094045', 1, 1, 'SR', NULL, NULL, NULL),
(16466, '2016-12-30 19:08:07', NULL, NULL, 5683, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 19:08:07', 'admin-1483066124-14830960869539372', 1, 1, 'SR', NULL, NULL, NULL),
(16467, '2016-12-30 16:11:13', NULL, NULL, 5668, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 16:11:13', 'admin-1483066124-14830854736405990', 1, 1, 'SR', NULL, NULL, NULL),
(16468, '2016-12-30 15:50:07', NULL, NULL, 5667, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 15:50:07', 'admin-1483066124-14830842074388531', 1, 1, 'SR', NULL, NULL, NULL),
(16469, '2016-12-30 12:26:23', NULL, NULL, 5660, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 12:26:23', 'admin-1483066124-14830719831767429', 1, 0, '', NULL, NULL, NULL),
(16470, '2016-12-30 15:39:55', NULL, NULL, 5665, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 15:39:55', 'admin-1483066124-14830835952256840', 1, 1, 'SR', NULL, NULL, NULL),
(16471, '2016-12-30 15:39:55', NULL, NULL, 5665, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 15:39:55', 'admin-1483066124-14830835952256840', 1, 1, 'SR', NULL, NULL, NULL),
(16472, '2016-12-30 13:20:05', NULL, NULL, 5663, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 13:20:05', 'admin-1483066124-14830752048925421', 1, 0, '', NULL, NULL, NULL),
(16473, '2016-12-30 12:06:27', NULL, NULL, 5661, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 12:06:27', 'admin-1483066124-14830707870146126', 1, 1, 'SR', NULL, NULL, NULL),
(16474, '2016-12-30 12:01:53', NULL, NULL, 5660, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 12:01:53', 'admin-1483066124-1483070513319553', 1, 1, 'SR', NULL, NULL, NULL),
(16475, '2016-12-30 12:01:53', NULL, NULL, 5660, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 12:01:53', 'admin-1483066124-1483070513319553', 1, 1, 'SR', NULL, NULL, NULL),
(16476, '2016-12-30 11:58:50', NULL, NULL, 5659, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 11:58:50', 'admin-1483066124-14830703301747162', 1, 1, 'SR', NULL, NULL, NULL),
(16477, '2016-12-30 11:58:50', NULL, NULL, 5659, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 11:58:50', 'admin-1483066124-14830703301747162', 1, 1, 'SR', NULL, NULL, NULL),
(16478, '2016-12-30 12:01:44', NULL, NULL, 5660, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 12:01:44', 'admin-1483066124-14830705047149266', 1, 0, '', NULL, NULL, NULL),
(16479, '2016-12-30 12:01:44', NULL, NULL, 5660, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 12:01:44', 'admin-1483066124-14830705047149266', 1, 0, '', NULL, NULL, NULL),
(16480, '2016-12-30 12:01:44', NULL, NULL, 5660, 0, 85, '85', 'Set Meatless Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 12:01:44', 'admin-1483066124-14830705047149266', 1, 1, 'SR', NULL, NULL, NULL),
(16481, '2016-12-30 11:18:18', NULL, NULL, 5656, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 11:18:19', 'admin-1483066124-1483067898809867', 1, 0, '', NULL, NULL, NULL),
(16482, '2016-12-30 11:18:19', NULL, NULL, 5656, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 11:18:19', 'admin-1483066124-1483067898809867', 1, 0, '', NULL, NULL, NULL),
(16483, '2016-12-30 11:49:16', NULL, NULL, 5657, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 11:49:16', 'admin-1483066124-14830697559081136', 1, 1, 'SR', NULL, NULL, NULL),
(16484, '2016-12-30 11:50:34', NULL, NULL, 5658, 0, 158, '92', 'Nutella Toast ', 'no honey', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 11:50:34', 'admin-1483066124-14830698344523716', 1, 0, '', NULL, NULL, NULL),
(16485, '2016-12-30 11:50:56', NULL, NULL, 5658, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 11:50:56', 'admin-1483066124-14830698559609633', 1, 1, 'SR', NULL, NULL, NULL),
(16486, '2016-12-30 11:58:50', NULL, NULL, 5659, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 11:58:50', 'admin-1483066124-14830703301747162', 1, 1, 'SR', NULL, NULL, NULL),
(16487, '2016-12-30 11:18:18', NULL, NULL, 5656, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 11:18:18', 'admin-1483066124-1483067898809867', 1, 1, 'SR', NULL, NULL, NULL),
(16488, '2016-12-30 11:18:18', NULL, NULL, 5656, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 11:18:18', 'admin-1483066124-1483067898809867', 1, 1, 'SR', NULL, NULL, NULL),
(16489, '2016-12-30 10:48:36', NULL, NULL, 5653, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 10:48:36', 'admin-1483059938-14830661163402537', 1, 0, '', NULL, NULL, NULL),
(16490, '2016-12-30 10:59:38', NULL, NULL, 5654, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 10:59:38', 'admin-1483066124-14830667779773921', 1, 0, '', NULL, NULL, NULL),
(16491, '2016-12-30 10:59:38', NULL, NULL, 5654, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 10:59:38', 'admin-1483066124-14830667779773921', 1, 0, '', NULL, NULL, NULL),
(16492, '2016-12-30 09:36:08', NULL, NULL, 5646, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 09:36:08', 'admin-1483059938-1483061768708129', 1, 0, '', NULL, NULL, NULL),
(16493, '2016-12-30 09:36:08', NULL, NULL, 5646, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 09:36:08', 'admin-1483059938-1483061768708129', 1, 0, '', NULL, NULL, NULL),
(16494, '2016-12-30 09:36:17', NULL, NULL, 5646, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 09:36:17', 'admin-1483059938-1483061777676669', 1, 1, 'SR', NULL, NULL, NULL),
(16495, '2016-12-30 09:37:54', NULL, NULL, 5648, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 09:37:54', 'admin-1483059938-14830618747679853', 1, 1, 'SR', NULL, NULL, NULL),
(16496, '2016-12-30 09:37:54', NULL, NULL, 5648, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 09:37:54', 'admin-1483059938-14830618747679853', 1, 1, 'SR', NULL, NULL, NULL),
(16497, '2016-12-30 09:48:15', NULL, NULL, 5648, 0, 181, '116', 'Open Food ', 'banana', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1483066124', 'admin', '2016-12-30 09:48:15', 'admin-1483059938-14830624950662634', 1, 0, '', NULL, NULL, NULL),
(16498, '2016-12-30 10:03:17', NULL, NULL, 5649, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 10:03:17', 'admin-1483059938-14830633971196151', 1, 1, 'SR', 1, NULL, NULL),
(16499, '2016-12-30 10:03:33', NULL, NULL, 5650, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 10:03:33', 'admin-1483059938-14830634133761610', 1, 0, '', NULL, NULL, NULL),
(16500, '2016-12-30 10:03:41', NULL, NULL, 5650, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 10:03:41', 'admin-1483059938-148306342115037', 1, 1, 'SR', NULL, NULL, NULL),
(16501, '2016-12-30 10:03:41', NULL, NULL, 5650, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 10:03:41', 'admin-1483059938-148306342115037', 1, 0, '', NULL, NULL, NULL),
(16502, '2016-12-30 10:21:42', NULL, NULL, 5651, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 10:21:42', 'admin-1483059938-1483064502279108', 1, 1, 'SR', NULL, NULL, NULL),
(16503, '2016-12-30 10:21:42', NULL, NULL, 5651, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 10:21:42', 'admin-1483059938-1483064502279108', 1, 1, 'SR', NULL, NULL, NULL),
(16504, '2016-12-30 10:41:01', NULL, NULL, 5652, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 10:41:01', 'admin-1483059938-14830656616614025', 1, 0, '', NULL, NULL, NULL),
(16505, '2016-12-30 10:41:08', NULL, NULL, 5652, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 10:41:08', 'admin-1483059938-14830656687491586', 1, 1, 'SR', NULL, NULL, NULL),
(16506, '2016-12-30 10:41:08', NULL, NULL, 5652, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 10:41:08', 'admin-1483059938-14830656687491586', 1, 1, 'SR', NULL, NULL, NULL),
(16507, '2016-12-30 10:41:25', NULL, NULL, 5652, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 10:41:25', 'admin-1483059938-14830656848776463', 1, 1, 'SR', NULL, NULL, NULL),
(16508, '2016-12-30 11:00:32', NULL, NULL, 5655, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 11:00:32', 'admin-1483066124-14830668326841792', 1, 1, 'SR', NULL, NULL, NULL),
(16509, '2016-12-30 10:59:54', NULL, NULL, 5655, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 10:59:54', 'admin-1483066124-14830667945856768', 1, 0, '', NULL, NULL, NULL),
(16510, '2016-12-30 10:59:54', NULL, NULL, 5655, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 10:59:54', 'admin-1483066124-14830667945856768', 1, 0, '', NULL, NULL, NULL),
(16511, '2016-12-30 10:59:38', NULL, NULL, 5654, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 10:59:38', 'admin-1483066124-14830667779773921', 1, 1, 'SR', NULL, NULL, NULL),
(16512, '2016-12-30 10:59:38', NULL, NULL, 5654, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 10:59:38', 'admin-1483066124-14830667779773921', 1, 1, 'SR', NULL, NULL, NULL),
(16513, '2016-12-30 10:48:36', NULL, NULL, 5653, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 10:48:36', 'admin-1483059938-14830661163402537', 1, 1, 'SR', NULL, NULL, NULL),
(16514, '2016-12-30 09:34:22', NULL, NULL, 5647, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 09:34:22', 'admin-1483059938-14830616624368887', 1, 1, 'SR', NULL, NULL, NULL),
(16515, '2016-12-30 09:10:48', NULL, NULL, 5646, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483066124', 'admin', '2016-12-30 09:10:48', 'admin-1483059938-1483060248500678', 1, 1, 'SR', NULL, NULL, NULL),
(16516, '2016-12-31 22:09:31', NULL, NULL, 5741, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 22:09:31', 'admin-1483188930-14831933715209812', 1, 1, 'SR', NULL, NULL, NULL),
(16517, '2016-12-31 22:06:14', NULL, NULL, 5745, 0, 258, '192', 'NYE Beer Promo', '', 'DISCOUNT ', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 22:06:14', 'admin-1483188930-14831931744025287', 1, 0, '', NULL, NULL, NULL),
(16518, '2016-12-31 22:06:14', NULL, NULL, 5745, 0, 258, '192', 'NYE Beer Promo', '', 'DISCOUNT ', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 22:06:14', 'admin-1483188930-14831931744025287', 1, 0, '', NULL, NULL, NULL),
(16519, '2016-12-31 21:52:58', NULL, NULL, 5744, 0, 254, '188', 'Adult NYE', '', 'DISCOUNT ', '0', 1, 49.90, 49.9000, 0.0000, 49.90, 1, '27', 1, '1483188930', 'admin', '2016-12-31 21:52:58', 'admin-1483188930-14831923787461880', 1, 0, '', NULL, NULL, NULL),
(16520, '2016-12-31 21:28:58', NULL, NULL, 5742, 0, 258, '192', 'NYE Beer Promo', '', 'DISCOUNT ', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 21:28:58', 'admin-1483188930-14831909382075387', 1, 0, '', NULL, NULL, NULL),
(16521, '2016-12-31 19:47:33', NULL, NULL, 5732, 0, 255, '189', 'Ault NYE Beer', '', 'DISCOUNT ', '0', 1, 59.90, 59.9000, 0.0000, 59.90, 1, '27', 1, '1483188930', 'admin', '2016-12-31 19:47:33', 'admin-1483164662-14831848537311492', 1, 0, '', NULL, NULL, NULL),
(16522, '2016-12-31 19:47:12', NULL, NULL, 5731, 0, 254, '188', 'Adult NYE', '', 'DISCOUNT ', '0', 1, 49.90, 49.9000, 0.0000, 49.90, 1, '27', 1, '1483188930', 'admin', '2016-12-31 19:47:12', 'admin-1483164662-14831848326007365', 1, 0, '', NULL, NULL, NULL),
(16523, '2016-12-31 19:43:33', NULL, NULL, 5730, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 13.50, 1, '27', 1, '1483188930', 'admin', '2016-12-31 19:43:33', 'admin-1483164662-14831846129818864', 1, 1, 'SR', NULL, '10.0', NULL),
(16524, '2016-12-31 19:43:24', NULL, NULL, 5730, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 19:43:24', 'admin-1483164662-14831846038295986', 1, 0, '', NULL, NULL, NULL),
(16525, '2016-12-31 19:20:16', NULL, NULL, 5729, 0, 254, '188', 'Adult NYE', '', 'DISCOUNT ', '0', 1, 49.90, 49.9000, 0.0000, 49.90, 1, '27', 1, '1483188930', 'admin', '2016-12-31 19:20:16', 'admin-1483164662-1483183216822503', 1, 0, '', NULL, NULL, NULL),
(16526, '2016-12-31 19:19:32', NULL, NULL, 5728, 0, 254, '188', 'Adult NYE', '', 'DISCOUNT ', '0', 1, 49.90, 49.9000, 0.0000, 49.90, 1, '27', 1, '1483188930', 'admin', '2016-12-31 19:19:32', 'admin-1483164662-14831831719871091', 1, 0, '', NULL, NULL, NULL),
(16527, '2016-12-31 18:30:22', NULL, NULL, 5726, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 18:30:22', 'admin-1483164662-1483180222445277', 1, 1, 'SR', NULL, NULL, NULL),
(16528, '2016-12-31 19:18:29', NULL, NULL, 5727, 0, 254, '188', 'Adult NYE', '', 'DISCOUNT ', '0', 1, 49.90, 49.9000, 0.0000, 49.90, 1, '27', 1, '1483188930', 'admin', '2016-12-31 19:18:29', 'admin-1483164662-14831831096716877', 1, 0, '', NULL, NULL, NULL),
(16529, '2016-12-31 20:32:35', NULL, NULL, 5733, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 13.50, 1, '27', 1, '1483188930', 'admin', '2016-12-31 20:32:35', 'admin-1483164662-14831875554052838', 1, 1, 'SR', NULL, '10.0', NULL),
(16530, '2016-12-31 21:28:58', NULL, NULL, 5742, 0, 258, '192', 'NYE Beer Promo', '', 'DISCOUNT ', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 21:28:58', 'admin-1483188930-14831909382075387', 1, 0, '', NULL, NULL, NULL),
(16531, '2016-12-31 21:28:58', NULL, NULL, 5742, 0, 258, '192', 'NYE Beer Promo', '', 'DISCOUNT ', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 21:28:58', 'admin-1483188930-14831909382075387', 1, 0, '', NULL, NULL, NULL),
(16532, '2016-12-31 20:51:39', NULL, NULL, 5735, 0, 258, '192', 'NYE Beer Promo', '', 'DISCOUNT ', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 20:51:39', 'admin-1483188687-14831886994726016', 1, 0, '', NULL, NULL, NULL),
(16533, '2016-12-31 20:52:02', NULL, NULL, 5736, 0, 258, '192', 'NYE Beer Promo', '', 'DISCOUNT ', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 20:52:02', 'admin-1483188687-14831887218463854', 1, 0, '', NULL, NULL, NULL),
(16534, '2016-12-31 20:52:14', NULL, NULL, 5737, 0, 258, '192', 'NYE Beer Promo', '', 'DISCOUNT ', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 20:52:14', 'admin-1483188687-14831887339645690', 1, 0, '', NULL, NULL, NULL),
(16535, '2016-12-31 20:54:10', NULL, NULL, 5738, 0, 254, '188', 'Adult NYE', '', 'DISCOUNT ', '0', 1, 49.90, 49.9000, 0.0000, 49.90, 1, '27', 1, '1483188930', 'admin', '2016-12-31 20:54:10', 'admin-1483188687-14831888498859370', 1, 0, '', NULL, NULL, NULL),
(16536, '2016-12-31 21:03:32', NULL, NULL, 5739, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 6.30, 1, '27', 1, '1483188930', 'admin', '2016-12-31 21:03:32', 'admin-1483188930-14831894118129895', 1, 1, 'SR', NULL, '10.0', NULL),
(16537, '2016-12-31 21:16:23', NULL, NULL, 5740, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 21:16:23', 'admin-1483188930-14831901836578895', 1, 0, '', NULL, NULL, '10.0'),
(16538, '2016-12-31 21:25:52', NULL, NULL, 5741, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 21:25:52', 'admin-1483188930-14831907520739880', 1, 1, 'SR', NULL, NULL, NULL),
(16539, '2016-12-31 21:25:52', NULL, NULL, 5741, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 21:25:52', 'admin-1483188930-14831907520739880', 1, 1, 'SR', NULL, NULL, NULL),
(16540, '2016-12-31 21:28:58', NULL, NULL, 5742, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 21:28:58', 'admin-1483188930-14831909382075387', 1, 1, 'SR', NULL, NULL, NULL),
(16541, '2016-12-31 14:15:27', NULL, NULL, 5722, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:15:27', 'admin-1483164662-14831649274567669', 1, 0, '', NULL, NULL, NULL),
(16542, '2016-12-31 14:14:45', NULL, NULL, 5722, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:14:45', 'admin-1483164662-14831648854572895', 1, 1, 'SR', NULL, NULL, NULL),
(16543, '2016-12-31 14:14:45', NULL, NULL, 5722, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:14:45', 'admin-1483164662-14831648854572895', 1, 0, '', NULL, NULL, NULL),
(16544, '2016-12-31 14:14:45', NULL, NULL, 5722, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:14:45', 'admin-1483164662-14831648854572895', 1, 0, '', NULL, NULL, NULL),
(16545, '2016-12-31 12:53:26', NULL, NULL, 5708, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 12:53:26', 'admin-1483152735-148316000665274', 1, 1, 'SR', NULL, NULL, NULL),
(16546, '2016-12-31 13:03:21', NULL, NULL, 5709, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 13:03:21', 'admin-1483152735-14831606016008949', 1, 0, '', NULL, NULL, NULL),
(16547, '2016-12-31 13:06:03', NULL, NULL, 5710, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 3, 15.00, 45.0000, 0.0000, 45.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 13:06:03', 'admin-1483152735-1483160763475155', 1, 1, 'SR', NULL, NULL, NULL),
(16548, '2016-12-31 13:06:03', NULL, NULL, 5710, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 13:06:03', 'admin-1483152735-1483160763475155', 1, 0, '', NULL, NULL, NULL),
(16549, '2016-12-31 13:07:13', NULL, NULL, 5710, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 3, 9.00, 27.0000, 0.0000, 27.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 13:07:13', 'admin-1483160790-14831608337158461', 1, 1, 'SR', NULL, NULL, NULL),
(16550, '2016-12-31 14:11:50', NULL, NULL, 5721, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:11:50', 'admin-1483164662-1483164710451289', 1, 0, '', NULL, NULL, NULL),
(16551, '2016-12-31 23:50:03', NULL, NULL, 5747, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 23:50:03', 'admin-1483188930-14831994038046727', 1, 1, 'SR', NULL, NULL, NULL),
(16552, '2016-12-31 23:05:11', NULL, NULL, 5747, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 23:05:11', 'admin-1483188930-14831967117731430', 1, 1, 'SR', NULL, NULL, NULL),
(16553, '2016-12-31 22:34:08', NULL, NULL, 5746, 0, 258, '192', 'NYE Beer Promo', '', 'DISCOUNT ', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 22:34:08', 'admin-1483188930-14831948480164530', 1, 0, '', NULL, NULL, NULL),
(16554, '2016-12-31 14:11:22', NULL, NULL, 5720, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:11:22', 'admin-1483164662-1483164681830503', 1, 1, 'SR', NULL, NULL, NULL),
(16555, '2016-12-31 14:11:22', NULL, NULL, 5720, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:11:22', 'admin-1483164662-1483164681830503', 1, 1, 'SR', NULL, NULL, NULL),
(16556, '2016-12-31 14:10:52', NULL, NULL, 5720, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:10:52', 'admin-1483162069-14831646528016295', 1, 0, '', NULL, NULL, NULL),
(16557, '2016-12-31 14:10:52', NULL, NULL, 5720, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:10:52', 'admin-1483162069-14831646528016295', 1, 0, '', NULL, NULL, NULL),
(16558, '2016-12-31 14:08:42', NULL, NULL, 5719, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:08:42', 'admin-1483162069-14831645222962970', 1, 1, 'SR', NULL, NULL, NULL),
(16559, '2016-12-31 14:08:18', NULL, NULL, 5717, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:08:18', 'admin-1483162069-14831644980194473', 1, 1, 'SR', NULL, NULL, NULL),
(16560, '2016-12-31 14:07:48', NULL, NULL, 5718, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:07:48', 'admin-1483162069-14831644678569514', 1, 1, 'SR', NULL, NULL, NULL),
(16561, '2016-12-31 14:07:39', NULL, NULL, 5717, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:07:39', 'admin-1483162069-14831644589484767', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(16562, '2016-12-31 14:06:49', NULL, NULL, 5717, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:06:49', 'admin-1483162069-14831644092262148', 1, 1, 'SR', NULL, NULL, NULL),
(16563, '2016-12-31 14:04:23', NULL, NULL, 5716, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:04:23', 'admin-1483162069-14831642628597451', 1, 1, 'SR', NULL, NULL, NULL),
(16564, '2016-12-31 14:04:23', NULL, NULL, 5716, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:04:23', 'admin-1483162069-14831642628597451', 1, 0, '', NULL, NULL, NULL),
(16565, '2016-12-31 14:04:23', NULL, NULL, 5716, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:04:23', 'admin-1483162069-14831642628597451', 1, 1, 'SR', NULL, NULL, NULL),
(16566, '2016-12-31 13:57:29', NULL, NULL, 5715, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 13:57:29', 'admin-1483162069-1483163849189316', 1, 1, 'SR', NULL, NULL, NULL),
(16567, '2016-12-31 13:57:14', NULL, NULL, 5715, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 13:57:14', 'admin-1483162069-1483163833810384', 1, 1, 'SR', NULL, NULL, NULL),
(16568, '2016-12-31 13:57:14', NULL, NULL, 5715, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 13:57:14', 'admin-1483162069-1483163833810384', 1, 1, 'SR', NULL, NULL, NULL),
(16569, '2016-12-31 13:57:14', NULL, NULL, 5715, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 13:57:14', 'admin-1483162069-1483163833810384', 1, 1, 'SR', NULL, NULL, NULL),
(16570, '2016-12-31 13:57:14', NULL, NULL, 5715, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 13:57:14', 'admin-1483162069-1483163833810384', 1, 1, 'SR', NULL, NULL, NULL),
(16571, '2016-12-31 13:51:18', NULL, NULL, 5710, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 13:51:18', 'admin-1483162069-14831634787927344', 1, 1, 'SR', NULL, NULL, NULL),
(16572, '2016-12-31 13:51:04', NULL, NULL, 5713, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 13:51:04', 'admin-1483162069-14831634646104052', 1, 1, 'SR', NULL, NULL, NULL),
(16573, '2016-12-31 13:50:49', NULL, NULL, 5714, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 13:50:49', 'admin-1483162069-1483163449204253', 1, 1, 'SR', NULL, NULL, NULL),
(16574, '2016-12-31 13:50:38', NULL, NULL, 5714, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 13:50:38', 'admin-1483162069-14831634387474267', 1, 0, '', NULL, NULL, NULL),
(16575, '2016-12-31 10:56:21', NULL, NULL, 5700, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:56:21', 'admin-1483152735-14831529812805055', 1, 1, 'SR', NULL, NULL, NULL),
(16576, '2016-12-31 10:56:21', NULL, NULL, 5700, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:56:21', 'admin-1483152735-14831529812805055', 1, 0, '', NULL, NULL, NULL),
(16577, '2016-12-31 10:56:21', NULL, NULL, 5700, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:56:21', 'admin-1483152735-14831529812805055', 1, 0, '', NULL, NULL, NULL),
(16578, '2016-12-31 10:56:21', NULL, NULL, 5700, 0, 154, '88', 'House BLT', 'egg well done', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:56:21', 'admin-1483152735-14831529812805055', 1, 0, '', NULL, NULL, NULL),
(16579, '2016-12-31 10:58:21', NULL, NULL, 5698, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:58:21', 'admin-1483152735-14831531008159556', 1, 1, 'SR', NULL, NULL, NULL),
(16580, '2016-12-31 11:05:38', NULL, NULL, 5697, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 11:05:38', 'admin-1483152735-14831535386098149', 1, 0, '', NULL, NULL, NULL),
(16581, '2016-12-31 22:09:31', NULL, NULL, 5741, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 22:09:31', 'admin-1483188930-14831933715209812', 1, 1, 'SR', NULL, NULL, NULL),
(16582, '2016-12-31 14:15:27', NULL, NULL, 5722, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:15:27', 'admin-1483164662-14831649274567669', 1, 1, 'SR', NULL, NULL, NULL),
(16583, '2016-12-31 14:25:10', NULL, NULL, 5711, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:25:10', 'admin-1483164662-14831655104317820', 1, 1, 'SR', NULL, NULL, NULL),
(16584, '2016-12-31 14:25:10', NULL, NULL, 5711, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:25:10', 'admin-1483164662-14831655104317820', 1, 0, '', NULL, NULL, NULL),
(16585, '2016-12-31 14:30:43', NULL, NULL, 5716, 0, 165, '99', 'Ice-Cream', '', 'Desserts', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:30:43', 'admin-1483164662-14831658433708495', 1, 0, '', NULL, NULL, NULL),
(16586, '2016-12-31 14:32:50', NULL, NULL, 5723, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:32:50', 'admin-1483164662-1483165970693876', 1, 0, '', NULL, NULL, NULL),
(16587, '2016-12-31 14:37:32', NULL, NULL, 5717, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:37:32', 'admin-1483164662-14831662518518215', 1, 0, '', NULL, NULL, NULL),
(16588, '2016-12-31 14:35:28', NULL, NULL, 5720, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:35:28', 'admin-1483164662-14831661287461487', 1, 1, 'SR', NULL, NULL, NULL),
(16589, '2016-12-31 14:35:28', NULL, NULL, 5720, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:35:28', 'admin-1483164662-14831661287461487', 1, 1, 'SR', NULL, NULL, NULL),
(16590, '2016-12-31 14:18:21', NULL, NULL, 5717, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 14:18:21', 'admin-1483164662-1483165100955434', 1, 0, '', NULL, NULL, NULL),
(16591, '2016-12-31 13:12:58', NULL, NULL, 5711, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 13:12:58', 'admin-1483160790-14831611782621889', 1, 1, 'SR', NULL, NULL, NULL),
(16592, '2016-12-31 13:12:58', NULL, NULL, 5711, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 13:12:58', 'admin-1483160790-14831611782621889', 1, 1, 'SR', NULL, NULL, NULL),
(16593, '2016-12-31 13:27:02', NULL, NULL, 5712, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 13:27:02', 'admin-1483160790-1483162021877731', 1, 0, '', NULL, NULL, NULL),
(16594, '2016-12-31 13:27:02', NULL, NULL, 5712, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 13:27:02', 'admin-1483160790-1483162021877731', 1, 1, 'SR', NULL, NULL, NULL),
(16595, '2016-12-31 13:35:19', NULL, NULL, 5713, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 13:35:19', 'admin-1483162069-14831625193691346', 1, 1, 'SR', NULL, NULL, NULL),
(16596, '2016-12-31 12:01:22', NULL, NULL, 5706, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 12:01:22', 'admin-1483152735-1483156882146611', 1, 1, 'SR', 1, NULL, NULL),
(16597, '2016-12-31 12:02:59', NULL, NULL, 5707, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 12:02:59', 'admin-1483152735-14831569795661041', 1, 1, 'SR', NULL, NULL, NULL),
(16598, '2016-12-31 12:02:59', NULL, NULL, 5707, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 12:02:59', 'admin-1483152735-14831569795661041', 1, 1, 'SR', NULL, NULL, NULL),
(16599, '2016-12-31 13:37:36', NULL, NULL, 5711, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 13:37:36', 'admin-1483162069-1483162656429584', 1, 0, '', NULL, NULL, NULL),
(16600, '2016-12-31 13:12:58', NULL, NULL, 5711, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 13:12:58', 'admin-1483160790-14831611782621889', 1, 1, 'SR', NULL, NULL, NULL),
(16601, '2016-12-31 13:30:32', NULL, NULL, 5711, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 13:30:32', 'admin-1483162069-14831622325727940', 1, 0, '', NULL, NULL, NULL),
(16602, '2016-12-31 13:11:57', NULL, NULL, 5711, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 13:11:57', 'admin-1483160790-14831611171486376', 1, 0, '', NULL, NULL, NULL),
(16603, '2016-12-31 11:36:54', NULL, NULL, 5702, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 11:36:54', 'admin-1483152735-14831554146924053', 1, 0, '', NULL, NULL, NULL),
(16604, '2016-12-31 11:36:54', NULL, NULL, 5702, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 2, 21.00, 42.0000, 0.0000, 42.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 11:36:54', 'admin-1483152735-14831554146924053', 1, 0, '', NULL, NULL, NULL),
(16605, '2016-12-31 11:44:23', NULL, NULL, 5703, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 11:44:23', 'admin-1483152735-14831558631978346', 1, 0, '', NULL, NULL, NULL),
(16606, '2016-12-31 11:45:40', NULL, NULL, 5703, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 11:45:40', 'admin-1483152735-14831559407849455', 1, 1, 'SR', NULL, NULL, NULL),
(16607, '2016-12-31 11:45:40', NULL, NULL, 5703, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 11:45:40', 'admin-1483152735-14831559407849455', 1, 0, '', NULL, NULL, NULL),
(16608, '2016-12-31 11:49:19', NULL, NULL, 5704, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 11:49:19', 'admin-1483152735-14831561588879823', 1, 1, 'SR', NULL, NULL, NULL),
(16609, '2016-12-31 11:49:19', NULL, NULL, 5704, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 11:49:19', 'admin-1483152735-14831561588879823', 1, 1, 'SR', NULL, NULL, NULL),
(16610, '2016-12-31 11:49:19', NULL, NULL, 5704, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 11:49:19', 'admin-1483152735-14831561588879823', 1, 1, 'SR', NULL, NULL, NULL),
(16611, '2016-12-31 11:49:19', NULL, NULL, 5704, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 11:49:19', 'admin-1483152735-14831561588879823', 1, 1, 'SR', NULL, NULL, NULL),
(16612, '2016-12-31 11:49:19', NULL, NULL, 5704, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 11:49:19', 'admin-1483152735-14831561588879823', 1, 0, '', NULL, NULL, NULL),
(16613, '2016-12-31 11:59:04', NULL, NULL, 5705, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 11:59:04', 'admin-1483152735-1483156744521166', 1, 1, 'SR', NULL, NULL, NULL),
(16614, '2016-12-31 11:32:15', NULL, NULL, 5701, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 11:32:15', 'admin-1483152735-14831551355662668', 1, 1, 'SR', NULL, NULL, NULL),
(16615, '2016-12-31 11:34:50', NULL, NULL, 5700, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 11:34:50', 'admin-1483152735-14831552899297477', 1, 1, 'SR', NULL, NULL, NULL),
(16616, '2016-12-31 10:54:02', NULL, NULL, 5699, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:54:02', 'admin-1483152735-14831528427104621', 1, 1, 'SR', NULL, NULL, NULL),
(16617, '2016-12-31 10:54:02', NULL, NULL, 5699, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:54:02', 'admin-1483152735-14831528427104621', 1, 1, 'SR', NULL, NULL, NULL),
(16618, '2016-12-31 11:32:15', NULL, NULL, 5701, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 11:32:15', 'admin-1483152735-14831551355662668', 1, 1, 'SR', NULL, NULL, NULL),
(16619, '2016-12-31 10:54:02', NULL, NULL, 5699, 0, 153, '87', 'Big Breakfast ', 'no bacon change sausage', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:54:02', 'admin-1483152735-14831528427104621', 1, 0, '', NULL, NULL, NULL),
(16620, '2016-12-31 10:54:02', NULL, NULL, 5699, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:54:02', 'admin-1483152735-14831528427104621', 1, 0, '', NULL, NULL, NULL),
(16621, '2016-12-31 10:48:17', NULL, NULL, 5697, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:48:17', 'admin-1483150102-14831524968257561', 1, 0, '', NULL, NULL, NULL),
(16622, '2016-12-31 10:51:51', NULL, NULL, 5698, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:51:51', 'admin-1483150102-14831527109846978', 1, 0, '', NULL, NULL, NULL),
(16623, '2016-12-31 10:51:51', NULL, NULL, 5698, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:51:51', 'admin-1483150102-14831527109846978', 1, 0, '', NULL, NULL, NULL),
(16624, '2016-12-31 10:51:51', NULL, NULL, 5698, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:51:51', 'admin-1483150102-14831527109846978', 1, 0, '', NULL, NULL, NULL),
(16625, '2016-12-31 10:53:03', NULL, NULL, 5698, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:53:03', 'admin-1483152735-14831527831193462', 1, 0, '', NULL, NULL, NULL),
(16626, '2016-12-31 10:53:03', NULL, NULL, 5698, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:53:03', 'admin-1483152735-14831527831193462', 1, 1, 'SR', NULL, NULL, NULL),
(16627, '2016-12-31 10:48:16', NULL, NULL, 5697, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:48:17', 'admin-1483150102-14831524968257561', 1, 0, '', NULL, NULL, NULL),
(16628, '2016-12-31 10:42:36', NULL, NULL, 5696, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:42:36', 'admin-1483150102-14831521567035877', 1, 1, 'SR', NULL, NULL, NULL),
(16629, '2016-12-31 10:24:58', NULL, NULL, 5695, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:24:58', 'admin-1483150102-14831510984966030', 1, 1, 'SR', NULL, NULL, NULL),
(16630, '2016-12-31 10:42:25', NULL, NULL, 5696, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:42:25', 'admin-1483150102-14831521456111486', 1, 0, '', NULL, NULL, NULL),
(16631, '2016-12-31 10:42:25', NULL, NULL, 5696, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:42:25', 'admin-1483150102-14831521456111486', 1, 0, '', NULL, NULL, NULL),
(16632, '2016-12-31 10:42:36', NULL, NULL, 5696, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:42:36', 'admin-1483150102-14831521567035877', 1, 1, 'SR', NULL, NULL, NULL),
(16633, '2016-12-31 10:24:58', NULL, NULL, 5695, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:24:58', 'admin-1483150102-14831510984966030', 1, 1, 'SR', NULL, NULL, NULL),
(16634, '2016-12-31 10:24:58', NULL, NULL, 5695, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:24:58', 'admin-1483150102-14831510984966030', 1, 0, '', NULL, NULL, NULL),
(16635, '2016-12-31 10:42:36', NULL, NULL, 5696, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:42:36', 'admin-1483150102-14831521567035877', 1, 0, '', NULL, NULL, NULL),
(16636, '2016-12-31 09:14:29', NULL, NULL, 5688, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 09:14:29', 'admin-1483145031-14831468693934597', 1, 0, '', NULL, NULL, NULL),
(16637, '2016-12-31 09:14:29', NULL, NULL, 5688, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 09:14:29', 'admin-1483145031-14831468693934597', 1, 0, '', NULL, NULL, NULL),
(16638, '2016-12-31 09:14:46', NULL, NULL, 5688, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 09:14:46', 'admin-1483145031-14831468863519892', 1, 1, 'SR', NULL, NULL, NULL),
(16639, '2016-12-31 09:20:43', NULL, NULL, 5689, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 09:20:43', 'admin-1483145031-14831472438331153', 1, 1, 'SR', NULL, NULL, NULL),
(16640, '2016-12-31 09:20:43', NULL, NULL, 5689, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 09:20:43', 'admin-1483145031-14831472438331153', 1, 1, 'SR', NULL, NULL, NULL),
(16641, '2016-12-31 09:44:53', NULL, NULL, 5690, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 09:44:53', 'admin-1483145031-14831486933445015', 1, 0, '', NULL, NULL, NULL),
(16642, '2016-12-31 09:44:53', NULL, NULL, 5690, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 09:44:53', 'admin-1483145031-14831486933445015', 1, 0, '', NULL, NULL, NULL),
(16643, '2016-12-31 09:44:53', NULL, NULL, 5690, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 09:44:53', 'admin-1483145031-14831486933445015', 1, 1, 'SR', NULL, NULL, NULL),
(16644, '2016-12-31 09:59:22', NULL, NULL, 5691, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 09:59:22', 'admin-1483145031-14831495625592236', 1, 0, '', NULL, NULL, NULL),
(16645, '2016-12-31 09:59:22', NULL, NULL, 5691, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 09:59:22', 'admin-1483145031-14831495625592236', 1, 0, '', NULL, NULL, NULL),
(16646, '2016-12-31 09:59:53', NULL, NULL, 5691, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 09:59:53', 'admin-1483145031-148314959333615', 1, 0, '', NULL, NULL, NULL),
(16647, '2016-12-31 09:59:53', NULL, NULL, 5691, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 09:59:53', 'admin-1483145031-148314959333615', 1, 1, 'SR', NULL, NULL, NULL),
(16648, '2016-12-31 10:00:26', NULL, NULL, 5691, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:00:26', 'admin-1483145031-14831496262193361', 1, 0, '', NULL, NULL, NULL),
(16649, '2016-12-31 10:07:47', NULL, NULL, 5692, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:07:47', 'admin-1483145031-14831500676712953', 1, 0, '', NULL, NULL, NULL),
(16650, '2016-12-31 10:07:47', NULL, NULL, 5692, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:07:47', 'admin-1483145031-14831500676712953', 1, 0, '', NULL, NULL, NULL),
(16651, '2016-12-31 10:08:03', NULL, NULL, 5692, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 18.0000, 0.0000, 9.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:08:03', 'admin-1483145031-14831500834617039', 1, 0, '', NULL, NULL, NULL),
(16652, '2016-12-31 10:08:54', NULL, NULL, 5692, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:08:54', 'admin-1483150102-14831501348042233', 1, 0, '', NULL, NULL, NULL),
(16653, '2016-12-31 10:08:54', NULL, NULL, 5692, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:08:54', 'admin-1483150102-14831501348042233', 1, 1, 'SR', NULL, NULL, NULL),
(16654, '2016-12-31 10:08:54', NULL, NULL, 5692, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:08:54', 'admin-1483150102-14831501348042233', 1, 1, 'SR', NULL, NULL, NULL),
(16655, '2016-12-31 10:16:26', NULL, NULL, 5693, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:16:26', 'admin-1483150102-14831505866074482', 1, 0, '', NULL, NULL, NULL),
(16656, '2016-12-31 10:16:31', NULL, NULL, 5693, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:16:31', 'admin-1483150102-14831505913147485', 1, 1, 'SR', NULL, NULL, NULL),
(16657, '2016-12-31 10:20:36', NULL, NULL, 5694, 0, 158, '92', 'Nutella Toast ', 'Takeaway', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:20:36', 'admin-1483150102-14831508366824287', 1, 0, '', NULL, NULL, NULL),
(16658, '2016-12-31 10:20:49', NULL, NULL, 5694, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:20:49', 'admin-1483150102-14831508491769382', 1, 1, 'SR', NULL, NULL, NULL),
(16659, '2016-12-31 10:24:58', NULL, NULL, 5695, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:24:58', 'admin-1483150102-14831510984966030', 1, 0, '', NULL, NULL, NULL),
(16660, '2016-12-31 10:24:58', NULL, NULL, 5695, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 10:24:58', 'admin-1483150102-14831510984966030', 1, 0, '', NULL, NULL, NULL),
(16661, '2016-12-31 09:03:41', NULL, NULL, 5687, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 09:03:41', 'admin-1483145031-14831462212812783', 1, 1, 'SR', NULL, NULL, NULL),
(16662, '2016-12-31 09:03:41', NULL, NULL, 5687, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483188930', 'admin', '2016-12-31 09:03:41', 'admin-1483145031-14831462212812783', 1, 1, 'SR', NULL, NULL, NULL),
(16663, '2017-01-01 14:07:43', NULL, NULL, 5764, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:07:43', 'admin-1483249653-14832508630112350', 1, 0, '', NULL, NULL, NULL),
(16664, '2017-01-01 14:09:07', NULL, NULL, 5765, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:09:07', 'admin-1483249653-14832509473898017', 1, 1, 'SR', NULL, NULL, NULL),
(16665, '2017-01-01 14:09:49', NULL, NULL, 5765, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:09:49', 'admin-1483249653-1483250989409615', 1, 0, '', NULL, NULL, NULL),
(16666, '2017-01-01 14:11:07', NULL, NULL, 5765, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:11:07', 'admin-1483249653-14832510671085112', 1, 1, 'SR', NULL, NULL, NULL),
(16667, '2017-01-01 14:11:26', NULL, NULL, 5767, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:11:26', 'admin-1483249653-14832510858401497', 1, 0, '', NULL, NULL, NULL),
(16668, '2017-01-01 14:11:26', NULL, NULL, 5767, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:11:26', 'admin-1483249653-14832510858401497', 1, 0, '', NULL, NULL, NULL),
(16669, '2017-01-01 14:14:01', NULL, NULL, 5765, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:14:01', 'admin-1483251145-14832512412311322', 1, 1, 'SR', NULL, NULL, NULL),
(16670, '2017-01-01 15:13:19', NULL, NULL, 5773, 0, 259, '193', 'Coronado Beer Set', '', 'Cold Drinks', 'Soda & Beer', 1, 40.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 15:13:19', 'admin-1483251145-1483254799505353', 1, 0, '', NULL, NULL, NULL),
(16671, '2017-01-01 15:18:27', NULL, NULL, 5774, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 15:18:27', 'admin-1483251145-14832551069572575', 1, 1, 'SR', NULL, NULL, NULL),
(16672, '2017-01-01 15:18:27', NULL, NULL, 5774, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 15:18:27', 'admin-1483251145-14832551069572575', 1, 1, 'SR', NULL, NULL, NULL),
(16673, '2017-01-01 15:18:40', NULL, NULL, 5775, 0, 259, '193', 'Coronado Beer Set', '', 'Cold Drinks', 'Soda & Beer', 1, 40.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 15:18:40', 'admin-1483251145-14832551206226486', 1, 0, '', 1, NULL, NULL),
(16674, '2017-01-01 15:22:35', NULL, NULL, 5776, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 15:22:35', 'admin-1483251145-1483255355375870', 1, 1, 'SR', NULL, NULL, NULL),
(16675, '2017-01-01 15:22:35', NULL, NULL, 5776, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 15:22:35', 'admin-1483251145-1483255355375870', 1, 1, 'SR', NULL, NULL, NULL),
(16676, '2017-01-01 15:22:35', NULL, NULL, 5776, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 15:22:35', 'admin-1483251145-1483255355375870', 1, 1, 'SR', NULL, NULL, NULL),
(16677, '2017-01-01 15:26:29', NULL, NULL, 5777, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 15:26:29', 'admin-1483251145-14832555897982030', 1, 1, 'SR', NULL, NULL, NULL),
(16678, '2017-01-01 15:28:03', NULL, NULL, 5774, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 15:28:03', 'admin-1483251145-14832556835212899', 1, 0, '', NULL, NULL, NULL),
(16679, '2017-01-01 15:30:51', NULL, NULL, 5778, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 15:30:51', 'admin-1483255690-14832558516635189', 1, 1, 'SR', NULL, NULL, NULL),
(16680, '2017-01-01 19:17:56', NULL, NULL, 5784, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 19:17:56', 'admin-1483255690-14832694764749277', 1, 0, '', NULL, NULL, NULL),
(16681, '2017-01-01 17:41:33', NULL, NULL, 5783, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 17:41:33', 'admin-1483255690-1483263693490716', 1, 1, 'SR', NULL, NULL, NULL),
(16682, '2017-01-01 17:41:33', NULL, NULL, 5783, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 17:41:33', 'admin-1483255690-1483263693490716', 1, 1, 'SR', NULL, NULL, NULL),
(16683, '2017-01-01 16:13:19', NULL, NULL, 5782, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 16:13:19', 'admin-1483255690-1483258398883682', 1, 0, '', NULL, NULL, NULL),
(16684, '2017-01-01 16:13:19', NULL, NULL, 5782, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 16:13:19', 'admin-1483255690-1483258398883682', 1, 0, '', NULL, NULL, NULL),
(16685, '2017-01-01 16:08:06', NULL, NULL, 5781, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 16:08:06', 'admin-1483255690-14832580860562748', 1, 0, '', NULL, NULL, NULL),
(16686, '2017-01-01 16:08:06', NULL, NULL, 5781, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 16:08:06', 'admin-1483255690-14832580860562748', 1, 0, '', NULL, NULL, NULL),
(16687, '2017-01-01 20:52:08', NULL, NULL, 5789, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 20:52:08', 'admin-1483255690-14832751280879723', 1, 0, '', 1, NULL, NULL),
(16688, '2017-01-01 19:43:33', NULL, NULL, 5786, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 19:43:33', 'admin-1483255690-14832710133504566', 1, 1, 'SR', NULL, NULL, NULL),
(16689, '2017-01-01 16:07:10', NULL, NULL, 5781, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 16:07:10', 'admin-1483255690-14832580302895788', 1, 0, '', NULL, NULL, NULL),
(16690, '2017-01-01 15:36:47', NULL, NULL, 5780, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 15:36:47', 'admin-1483255690-1483256206908856', 1, 0, '', NULL, NULL, NULL),
(16691, '2017-01-01 15:36:57', NULL, NULL, 5780, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 15:36:57', 'admin-1483255690-14832562171324914', 1, 1, 'SR', NULL, NULL, NULL),
(16692, '2017-01-01 15:36:47', NULL, NULL, 5780, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 15:36:47', 'admin-1483255690-1483256206908856', 1, 0, '', NULL, NULL, NULL),
(16693, '2017-01-01 15:33:36', NULL, NULL, 5779, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 15:33:36', 'admin-1483255690-14832560163301581', 1, 1, 'SR', NULL, NULL, NULL),
(16694, '2017-01-01 15:31:15', NULL, NULL, 5778, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 15:31:15', 'admin-1483255690-1483255875357542', 1, 1, 'SR', NULL, NULL, NULL),
(16695, '2017-01-01 15:31:15', NULL, NULL, 5778, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 15:31:15', 'admin-1483255690-1483255875357542', 1, 1, 'SR', NULL, NULL, NULL),
(16696, '2017-01-01 15:31:15', NULL, NULL, 5778, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 15:31:15', 'admin-1483255690-1483255875357542', 1, 1, 'SR', NULL, NULL, NULL),
(16697, '2017-01-01 20:52:08', NULL, NULL, 5789, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 20:52:08', 'admin-1483255690-14832751280879723', 1, 0, '', 1, NULL, NULL),
(16698, '2017-01-01 14:53:22', NULL, NULL, 5770, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:53:22', 'admin-1483251145-1483253602006712', 1, 0, '', NULL, NULL, NULL),
(16699, '2017-01-01 19:43:33', NULL, NULL, 5786, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 19:43:33', 'admin-1483255690-14832710133504566', 1, 1, 'SR', NULL, NULL, NULL),
(16700, '2017-01-01 19:41:51', NULL, NULL, 5785, NULL, 57, '57', 'House Red Bottle', '', 'Cold Drinks', 'Wine', 1, 88.00, 88.0000, 0.0000, 88.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 19:41:51', 'admin-1483255690-1483270911394343', 1, 1, 'SR', NULL, NULL, NULL),
(16701, '2017-01-01 19:18:05', NULL, NULL, 5784, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 19:18:05', 'admin-1483255690-14832694850595235', 1, 0, '', NULL, NULL, NULL),
(16702, '2017-01-01 19:17:56', NULL, NULL, 5784, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 19:17:56', 'admin-1483255690-14832694764749277', 1, 0, '', NULL, NULL, NULL),
(16703, '2017-01-01 15:30:51', NULL, NULL, 5778, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 15:30:51', 'admin-1483255690-14832558516635189', 1, 0, '', NULL, NULL, NULL),
(16704, '2017-01-01 15:30:51', NULL, NULL, 5778, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 15:30:51', 'admin-1483255690-14832558516635189', 1, 0, '', NULL, NULL, NULL),
(16705, '2017-01-01 14:58:40', NULL, NULL, 5772, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:58:40', 'admin-1483251145-14832539205352497', 1, 1, 'SR', NULL, NULL, NULL),
(16706, '2017-01-01 20:52:08', NULL, NULL, 5789, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 20:52:08', 'admin-1483255690-14832751280879723', 1, 0, '', 1, NULL, NULL),
(16707, '2017-01-01 20:12:47', NULL, NULL, 5786, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 20:12:47', 'admin-1483255690-14832727673256767', 1, 1, 'SR', NULL, NULL, NULL),
(16708, '2017-01-01 20:12:47', NULL, NULL, 5786, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 20:12:47', 'admin-1483255690-14832727673256767', 1, 1, 'SR', NULL, NULL, NULL),
(16709, '2017-01-01 20:08:30', NULL, NULL, 5788, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 20:08:30', 'admin-1483255690-14832725102445866', 1, 0, '', NULL, NULL, NULL),
(16710, '2017-01-01 19:53:45', NULL, NULL, 5787, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 19:53:45', 'admin-1483255690-14832716253078352', 1, 1, 'SR', NULL, NULL, NULL),
(16711, '2017-01-01 19:53:45', NULL, NULL, 5787, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 19:53:45', 'admin-1483255690-14832716253078352', 1, 1, 'SR', NULL, NULL, NULL),
(16712, '2017-01-01 19:53:45', NULL, NULL, 5787, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1483255690', 'admin', '2017-01-01 19:53:45', 'admin-1483255690-14832716253078352', 1, 0, '', NULL, NULL, NULL),
(16713, '2017-01-01 19:53:45', NULL, NULL, 5787, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 19:53:45', 'admin-1483255690-14832716253078352', 1, 1, 'SR', NULL, NULL, NULL),
(16714, '2017-01-01 15:30:51', NULL, NULL, 5778, 0, 181, '116', 'Open Food ', 'snack platter', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 15:30:51', 'admin-1483255690-14832558516635189', 1, 0, '', NULL, NULL, NULL),
(16715, '2017-01-01 14:30:10', NULL, NULL, 5771, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:30:10', 'admin-1483251145-1483252210790237', 1, 1, 'SR', NULL, NULL, NULL),
(16716, '2017-01-01 14:46:47', NULL, NULL, 5770, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:46:47', 'admin-1483251145-14832532068754939', 1, 0, '', NULL, NULL, NULL),
(16717, '2017-01-01 14:29:30', NULL, NULL, 5770, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:29:30', 'admin-1483251145-1483252170640739', 1, 0, '', NULL, NULL, NULL),
(16718, '2017-01-01 14:29:30', NULL, NULL, 5770, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:29:30', 'admin-1483251145-1483252170640739', 1, 1, 'SR', NULL, NULL, NULL),
(16719, '2017-01-01 14:29:30', NULL, NULL, 5770, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:29:30', 'admin-1483251145-1483252170640739', 1, 1, 'SR', NULL, NULL, NULL),
(16720, '2017-01-01 14:29:30', NULL, NULL, 5770, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:29:30', 'admin-1483251145-1483252170640739', 1, 1, 'SR', NULL, NULL, NULL),
(16721, '2017-01-01 14:29:30', NULL, NULL, 5770, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:29:30', 'admin-1483251145-1483252170640739', 1, 1, 'SR', NULL, NULL, NULL),
(16722, '2017-01-01 14:40:03', NULL, NULL, 5770, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:40:03', 'admin-1483251145-14832528032875493', 1, 1, 'SR', NULL, NULL, NULL),
(16723, '2017-01-01 14:28:50', NULL, NULL, 5770, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:28:50', 'admin-1483251145-14832521298333763', 1, 0, '', NULL, NULL, NULL),
(16724, '2017-01-01 14:28:50', NULL, NULL, 5770, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:28:50', 'admin-1483251145-14832521298333763', 1, 0, '', NULL, NULL, NULL),
(16725, '2017-01-01 14:28:50', NULL, NULL, 5770, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:28:50', 'admin-1483251145-14832521298333763', 1, 0, '', NULL, NULL, NULL),
(16726, '2017-01-01 14:25:20', NULL, NULL, 5765, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:25:20', 'admin-1483251145-14832519200757154', 1, 1, 'SR', NULL, NULL, NULL),
(16727, '2017-01-01 14:19:00', NULL, NULL, 5769, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:19:00', 'admin-1483251145-14832515401285280', 1, 1, 'SR', NULL, NULL, NULL),
(16728, '2017-01-01 14:19:00', NULL, NULL, 5769, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:19:00', 'admin-1483251145-14832515401285280', 1, 1, 'SR', NULL, NULL, NULL),
(16729, '2017-01-01 14:19:00', NULL, NULL, 5769, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:19:00', 'admin-1483251145-14832515401285280', 1, 0, '', NULL, NULL, NULL),
(16730, '2017-01-01 14:19:00', NULL, NULL, 5769, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:19:00', 'admin-1483251145-14832515401285280', 1, 0, '', NULL, NULL, NULL),
(16731, '2017-01-01 14:18:12', NULL, NULL, 5767, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:18:12', 'admin-1483251145-14832514927763386', 1, 1, 'SR', NULL, NULL, NULL),
(16732, '2017-01-01 14:15:47', NULL, NULL, 5768, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:15:47', 'admin-1483251145-14832513468444259', 1, 1, 'SR', NULL, NULL, NULL),
(16733, '2017-01-01 14:15:47', NULL, NULL, 5768, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:15:47', 'admin-1483251145-14832513468444259', 1, 1, 'SR', NULL, NULL, NULL),
(16734, '2017-01-01 14:14:01', NULL, NULL, 5765, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:14:01', 'admin-1483251145-14832512412311322', 1, 1, 'SR', NULL, NULL, NULL),
(16735, '2017-01-01 13:53:23', NULL, NULL, 5766, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:53:23', 'admin-1483249653-14832500028084821', 1, 1, 'SR', NULL, NULL, NULL),
(16736, '2017-01-01 12:09:42', NULL, NULL, 5760, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 12:09:42', 'admin-1483241065-1483243781867757', 1, 1, 'SR', NULL, NULL, NULL),
(16737, '2017-01-01 12:55:10', NULL, NULL, 5761, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 12:55:10', 'admin-1483241065-14832465100411424', 1, 1, 'SR', NULL, NULL, NULL),
(16738, '2017-01-01 12:58:48', NULL, NULL, 5761, 0, 181, '116', 'Open Food ', 'French Fries', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 12:58:48', 'admin-1483241065-14832467285093582', 1, 0, '', NULL, NULL, NULL),
(16739, '2017-01-01 12:56:25', NULL, NULL, 5757, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 12:56:25', 'admin-1483241065-1483246585103851', 1, 0, '', NULL, NULL, NULL),
(16740, '2017-01-01 13:05:41', NULL, NULL, 5762, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:05:41', 'admin-1483241065-1483247141031737', 1, 0, '', NULL, NULL, NULL),
(16741, '2017-01-01 19:53:45', NULL, NULL, 5787, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 19:53:45', 'admin-1483255690-14832716253078352', 1, 0, '', NULL, NULL, NULL),
(16742, '2017-01-01 14:14:01', NULL, NULL, 5765, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:14:01', 'admin-1483251145-14832512412311322', 1, 1, 'SR', NULL, NULL, NULL),
(16743, '2017-01-01 14:14:01', NULL, NULL, 5765, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:14:01', 'admin-1483251145-14832512412311322', 1, 1, 'SR', NULL, NULL, NULL),
(16744, '2017-01-01 13:58:02', NULL, NULL, 5765, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:58:02', 'admin-1483249653-14832502826742218', 1, 0, '', NULL, NULL, NULL),
(16745, '2017-01-01 13:58:02', NULL, NULL, 5765, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:58:02', 'admin-1483249653-14832502826742218', 1, 0, '', NULL, NULL, NULL),
(16746, '2017-01-01 13:58:02', NULL, NULL, 5765, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:58:02', 'admin-1483249653-14832502826742218', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(16747, '2017-01-01 13:58:02', NULL, NULL, 5765, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:58:02', 'admin-1483249653-14832502826742218', 1, 0, '', NULL, NULL, NULL),
(16748, '2017-01-01 13:58:02', NULL, NULL, 5765, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:58:02', 'admin-1483249653-14832502826742218', 1, 1, 'SR', NULL, NULL, NULL),
(16749, '2017-01-01 14:05:20', NULL, NULL, 5763, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:05:20', 'admin-1483249653-14832507201074949', 1, 0, '', NULL, NULL, NULL),
(16750, '2017-01-01 14:07:29', NULL, NULL, 5765, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:07:29', 'admin-1483249653-1483250849521957', 1, 0, '', NULL, NULL, NULL),
(16751, '2017-01-01 14:07:29', NULL, NULL, 5765, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 14:07:29', 'admin-1483249653-1483250849521957', 1, 0, '', NULL, NULL, NULL),
(16752, '2017-01-01 13:58:02', NULL, NULL, 5765, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:58:02', 'admin-1483249653-14832502826742218', 1, 0, '', NULL, NULL, NULL),
(16753, '2017-01-01 13:53:09', NULL, NULL, 5766, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:53:09', 'admin-1483249653-1483249989730582', 1, 0, '', NULL, NULL, NULL),
(16754, '2017-01-01 13:53:09', NULL, NULL, 5766, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:53:09', 'admin-1483249653-1483249989730582', 1, 0, '', NULL, NULL, NULL),
(16755, '2017-01-01 13:53:09', NULL, NULL, 5766, 0, 75, '75', 'Meatless Aglio Olio ', 'no mushroom less spicy', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:53:09', 'admin-1483249653-1483249989730582', 1, 0, '', NULL, NULL, NULL),
(16756, '2017-01-01 13:53:09', NULL, NULL, 5766, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:53:09', 'admin-1483249653-1483249989730582', 1, 0, '', NULL, NULL, NULL),
(16757, '2017-01-01 13:53:23', NULL, NULL, 5766, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:53:23', 'admin-1483249653-14832500028084821', 1, 0, '', NULL, NULL, NULL),
(16758, '2017-01-01 13:53:23', NULL, NULL, 5766, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:53:23', 'admin-1483249653-14832500028084821', 1, 1, 'SR', NULL, NULL, NULL),
(16759, '2017-01-01 13:30:16', NULL, NULL, 5764, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:30:16', 'admin-1483241065-14832486161893216', 1, 1, 'SR', NULL, NULL, NULL),
(16760, '2017-01-01 13:30:16', NULL, NULL, 5764, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:30:16', 'admin-1483241065-14832486161893216', 1, 1, 'SR', NULL, NULL, NULL),
(16761, '2017-01-01 13:41:21', NULL, NULL, 5764, 0, 72, '72', 'Mushroom Chicken', 'Takeaway', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:41:21', 'admin-1483241065-1483249281015992', 1, 1, 'SR', NULL, NULL, NULL),
(16762, '2017-01-01 13:47:27', NULL, NULL, 5765, 0, 181, '116', 'Open Food ', 'snack platter', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:47:27', 'admin-1483241065-14832496476545474', 1, 0, '', NULL, NULL, NULL),
(16763, '2017-01-01 13:53:09', NULL, NULL, 5766, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:53:09', 'admin-1483249653-1483249989730582', 1, 0, '', NULL, NULL, NULL),
(16764, '2017-01-01 13:05:41', NULL, NULL, 5762, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:05:41', 'admin-1483241065-1483247141031737', 1, 0, '', NULL, NULL, NULL),
(16765, '2017-01-01 13:05:47', NULL, NULL, 5762, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:05:47', 'admin-1483241065-1483247147711532', 1, 1, 'SR', NULL, NULL, NULL),
(16766, '2017-01-01 13:05:47', NULL, NULL, 5762, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:05:47', 'admin-1483241065-1483247147711532', 1, 1, 'SR', NULL, NULL, NULL),
(16767, '2017-01-01 13:11:43', NULL, NULL, 5763, 0, 181, '116', 'Open Food ', 'snack platter', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:11:43', 'admin-1483241065-148324750312989', 1, 0, '', NULL, NULL, NULL),
(16768, '2017-01-01 13:12:39', NULL, NULL, 5763, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:12:39', 'admin-1483241065-14832475595522538', 1, 0, '', NULL, NULL, NULL),
(16769, '2017-01-01 13:12:39', NULL, NULL, 5763, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:12:39', 'admin-1483241065-14832475595522538', 1, 1, 'SR', NULL, NULL, NULL),
(16770, '2017-01-01 13:12:39', NULL, NULL, 5763, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:12:39', 'admin-1483241065-14832475595522538', 1, 1, 'SR', NULL, NULL, NULL),
(16771, '2017-01-01 13:13:20', NULL, NULL, 5763, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:13:20', 'admin-1483241065-14832475999051513', 1, 0, '', NULL, NULL, NULL),
(16772, '2017-01-01 13:13:28', NULL, NULL, 5763, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:13:28', 'admin-1483241065-14832476082384076', 1, 0, '', NULL, NULL, NULL),
(16773, '2017-01-01 13:30:16', NULL, NULL, 5764, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:30:16', 'admin-1483241065-14832486161893216', 1, 1, 'SR', NULL, NULL, NULL),
(16774, '2017-01-01 13:30:16', NULL, NULL, 5764, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:30:16', 'admin-1483241065-14832486161893216', 1, 1, 'SR', NULL, NULL, NULL),
(16775, '2017-01-01 13:53:23', NULL, NULL, 5766, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 13:53:23', 'admin-1483249653-14832500028084821', 1, 1, 'SR', NULL, NULL, NULL),
(16776, '2017-01-01 12:09:42', NULL, NULL, 5760, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 12:09:42', 'admin-1483241065-1483243781867757', 1, 0, '', NULL, NULL, NULL),
(16777, '2017-01-01 12:09:42', NULL, NULL, 5760, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 12:09:42', 'admin-1483241065-1483243781867757', 1, 0, '', NULL, NULL, NULL),
(16778, '2017-01-01 12:01:28', NULL, NULL, 5759, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 12:01:28', 'admin-1483241065-14832432887153078', 1, 0, '', NULL, NULL, NULL),
(16779, '2017-01-01 12:07:59', NULL, NULL, 5752, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 12:07:59', 'admin-1483241065-14832436787956923', 1, 0, '', NULL, NULL, NULL),
(16780, '2017-01-01 12:09:15', NULL, NULL, 5760, 0, 181, '116', 'Open Food ', 'platter', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 12:09:15', 'admin-1483241065-14832437548989446', 1, 0, '', NULL, NULL, NULL),
(16781, '2017-01-01 12:09:42', NULL, NULL, 5760, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 12:09:42', 'admin-1483241065-1483243781867757', 1, 1, 'SR', NULL, NULL, NULL),
(16782, '2017-01-01 11:56:39', NULL, NULL, 5758, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 11:56:39', 'admin-1483241065-14832429993342080', 1, 1, 'SR', NULL, NULL, NULL),
(16783, '2017-01-01 11:56:39', NULL, NULL, 5758, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 11:56:39', 'admin-1483241065-14832429993342080', 1, 0, '', NULL, NULL, NULL),
(16784, '2017-01-01 11:50:57', NULL, NULL, 5757, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 11:50:57', 'admin-1483241065-14832426572869189', 1, 0, '', NULL, NULL, NULL),
(16785, '2017-01-01 11:50:57', NULL, NULL, 5757, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 11:50:57', 'admin-1483241065-14832426572869189', 1, 0, '', NULL, NULL, NULL),
(16786, '2017-01-01 11:50:57', NULL, NULL, 5757, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 11:50:57', 'admin-1483241065-14832426572869189', 1, 1, 'SR', NULL, NULL, NULL),
(16787, '2017-01-01 11:50:57', NULL, NULL, 5757, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 11:50:57', 'admin-1483241065-14832426572869189', 1, 1, 'SR', NULL, NULL, NULL),
(16788, '2017-01-01 11:50:57', NULL, NULL, 5757, 0, 181, '116', 'Open Food ', 'snack platter', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 11:50:57', 'admin-1483241065-14832426572869189', 1, 0, '', NULL, NULL, NULL),
(16789, '2017-01-01 11:56:39', NULL, NULL, 5758, 0, 181, '116', 'Open Food ', 'Platter', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 11:56:39', 'admin-1483241065-14832429993342080', 1, 0, '', NULL, NULL, NULL),
(16790, '2017-01-01 11:48:31', NULL, NULL, 5754, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 11:48:31', 'admin-1483241065-14832425109322985', 1, 1, 'SR', NULL, NULL, NULL),
(16791, '2017-01-01 11:39:44', NULL, NULL, 5756, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 11:39:44', 'admin-1483241065-14832419843682938', 1, 0, '', NULL, NULL, NULL),
(16792, '2017-01-01 11:39:44', NULL, NULL, 5756, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 11:39:44', 'admin-1483241065-14832419843682938', 1, 0, '', NULL, NULL, NULL),
(16793, '2017-01-01 11:39:44', NULL, NULL, 5756, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 11:39:44', 'admin-1483241065-14832419843682938', 1, 0, '', NULL, NULL, NULL),
(16794, '2017-01-01 11:39:44', NULL, NULL, 5756, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 11:39:44', 'admin-1483241065-14832419843682938', 1, 1, 'SR', NULL, NULL, NULL),
(16795, '2017-01-01 11:39:44', NULL, NULL, 5756, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 11:39:44', 'admin-1483241065-14832419843682938', 1, 1, 'SR', NULL, NULL, NULL),
(16796, '2017-01-01 11:39:44', NULL, NULL, 5756, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 11:39:44', 'admin-1483241065-14832419843682938', 1, 1, 'SR', NULL, NULL, NULL),
(16797, '2017-01-01 11:33:06', NULL, NULL, 5755, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 11:33:06', 'admin-1483241065-14832415865148221', 1, 1, 'SR', NULL, NULL, NULL),
(16798, '2017-01-01 11:24:39', NULL, NULL, 5754, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 11:24:39', 'admin-1483241065-14832410791175434', 1, 1, 'SR', NULL, NULL, NULL),
(16799, '2017-01-01 11:23:02', NULL, NULL, 5754, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 11:23:02', 'admin-1483235175-14832409827541729', 1, 0, '', NULL, NULL, NULL),
(16800, '2017-01-01 11:22:35', NULL, NULL, 5754, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 11:22:35', 'admin-1483235175-14832409554291692', 1, 0, '', NULL, NULL, NULL),
(16801, '2017-01-01 11:22:35', NULL, NULL, 5754, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 11:22:35', 'admin-1483235175-14832409554291692', 1, 0, '', NULL, NULL, NULL),
(16802, '2017-01-01 11:22:35', NULL, NULL, 5754, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 11:22:35', 'admin-1483235175-14832409554291692', 1, 0, '', NULL, NULL, NULL),
(16803, '2017-01-01 10:57:40', NULL, NULL, 5753, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 10:57:40', 'admin-1483235175-14832394600181911', 1, 1, 'SR', NULL, NULL, NULL),
(16804, '2017-01-01 10:57:40', NULL, NULL, 5753, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 10:57:40', 'admin-1483235175-14832394600181911', 1, 1, 'SR', NULL, NULL, NULL),
(16805, '2017-01-01 10:57:40', NULL, NULL, 5753, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 10:57:40', 'admin-1483235175-14832394600181911', 1, 1, 'SR', NULL, NULL, NULL),
(16806, '2017-01-01 10:57:40', NULL, NULL, 5753, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 10:57:40', 'admin-1483235175-14832394600181911', 1, 0, '', NULL, NULL, NULL),
(16807, '2017-01-01 10:57:40', NULL, NULL, 5753, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 10:57:40', 'admin-1483235175-14832394600181911', 1, 0, '', NULL, NULL, NULL),
(16808, '2017-01-01 10:57:40', NULL, NULL, 5753, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 10:57:40', 'admin-1483235175-14832394600181911', 1, 0, '', NULL, NULL, NULL),
(16809, '2017-01-01 10:51:31', NULL, NULL, 5752, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 10:51:31', 'admin-1483235175-14832390910542041', 1, 1, 'SR', NULL, NULL, NULL),
(16810, '2017-01-01 10:51:31', NULL, NULL, 5752, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 10:51:31', 'admin-1483235175-14832390910542041', 1, 1, 'SR', NULL, NULL, NULL),
(16811, '2017-01-01 10:51:18', NULL, NULL, 5752, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 10:51:18', 'admin-1483235175-14832390784124268', 1, 0, '', NULL, NULL, NULL),
(16812, '2017-01-01 10:51:18', NULL, NULL, 5752, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 10:51:18', 'admin-1483235175-14832390784124268', 1, 0, '', NULL, NULL, NULL),
(16813, '2017-01-01 10:37:57', NULL, NULL, 5750, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 10:37:57', 'admin-1483235175-14832382768925712', 1, 1, 'SR', NULL, NULL, NULL),
(16814, '2017-01-01 10:37:57', NULL, NULL, 5750, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 10:37:57', 'admin-1483235175-14832382768925712', 1, 1, 'SR', NULL, NULL, NULL),
(16815, '2017-01-01 10:37:57', NULL, NULL, 5750, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 10:37:57', 'admin-1483235175-14832382768925712', 1, 1, 'SR', NULL, NULL, NULL),
(16816, '2017-01-01 10:37:57', NULL, NULL, 5750, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 10:37:57', 'admin-1483235175-14832382768925712', 1, 1, 'SR', NULL, NULL, NULL),
(16817, '2017-01-01 10:37:38', NULL, NULL, 5750, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 10:37:38', 'admin-1483235175-14832382583005070', 1, 0, '', NULL, NULL, NULL),
(16818, '2017-01-01 10:37:38', NULL, NULL, 5750, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 10:37:38', 'admin-1483235175-14832382583005070', 1, 0, '', NULL, NULL, NULL),
(16819, '2017-01-01 10:12:19', NULL, NULL, 5749, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 10:12:19', 'admin-1483235175-14832367393455456', 1, 1, 'SR', NULL, NULL, NULL),
(16820, '2017-01-01 10:09:05', NULL, NULL, 5748, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 10:09:05', 'admin-1483235175-14832365457401923', 1, 1, 'SR', NULL, NULL, NULL),
(16821, '2017-01-01 10:09:05', NULL, NULL, 5748, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 10:09:05', 'admin-1483235175-14832365457401923', 1, 1, 'SR', NULL, NULL, NULL),
(16822, '2017-01-01 10:08:57', NULL, NULL, 5748, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 10:08:57', 'admin-1483235175-1483236537286596', 1, 0, '', NULL, NULL, NULL),
(16823, '2017-01-01 10:08:57', NULL, NULL, 5748, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483255690', 'admin', '2017-01-01 10:08:57', 'admin-1483235175-1483236537286596', 1, 0, '', NULL, NULL, NULL),
(16824, '2017-01-02 13:21:33', NULL, NULL, 5818, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 13:21:33', 'admin-1483328805-14833344934347587', 1, 0, '', NULL, NULL, NULL),
(16825, '2017-01-02 13:44:15', NULL, NULL, 5819, 0, 259, '193', 'Coronado Beer Set', '', 'Cold Drinks', 'Soda & Beer', 1, 40.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 13:44:15', 'admin-1483328805-14833358548959426', 1, 0, '', NULL, NULL, NULL),
(16826, '2017-01-02 13:56:15', NULL, NULL, 5820, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 13:56:15', 'admin-1483328805-14833365748609533', 1, 1, 'SR', NULL, NULL, NULL),
(16827, '2017-01-02 13:56:15', NULL, NULL, 5820, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 13:56:15', 'admin-1483328805-14833365748609533', 1, 1, 'SR', NULL, NULL, NULL),
(16828, '2017-01-02 13:56:36', NULL, NULL, 5820, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 13:56:36', 'admin-1483328805-14833365965172397', 1, 0, '', NULL, NULL, NULL),
(16829, '2017-01-02 14:11:03', NULL, NULL, 5821, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 14:11:03', 'admin-1483328805-14833374632712291', 1, 0, '', NULL, NULL, NULL),
(16830, '2017-01-02 14:11:03', NULL, NULL, 5821, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 14:11:03', 'admin-1483328805-14833374632712291', 1, 1, 'SR', NULL, NULL, NULL),
(16831, '2017-01-02 14:11:03', NULL, NULL, 5821, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 14:11:03', 'admin-1483328805-14833374632712291', 1, 0, '', NULL, NULL, NULL),
(16832, '2017-01-02 14:11:03', NULL, NULL, 5821, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 14:11:03', 'admin-1483328805-14833374632712291', 1, 0, '', NULL, NULL, NULL),
(16833, '2017-01-02 14:27:30', NULL, NULL, 5820, 0, 181, '116', 'Open Food ', 'snack platter', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 14:27:30', 'admin-1483337473-14833384501574054', 1, 0, '', NULL, NULL, NULL),
(16834, '2017-01-02 14:33:35', NULL, NULL, 5822, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 14:33:35', 'admin-1483337473-14833388151415873', 1, 1, 'SR', NULL, NULL, NULL),
(16835, '2017-01-02 14:33:35', NULL, NULL, 5822, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 14:33:35', 'admin-1483337473-14833388151415873', 1, 0, '', NULL, NULL, NULL),
(16836, '2017-01-02 14:49:47', NULL, NULL, 5823, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 14:49:47', 'admin-1483337473-14833397874014371', 1, 0, '', NULL, NULL, NULL),
(16837, '2017-01-02 14:49:47', NULL, NULL, 5823, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 14:49:47', 'admin-1483337473-14833397874014371', 1, 1, 'SR', NULL, NULL, NULL),
(16838, '2017-01-02 14:49:47', NULL, NULL, 5823, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 14:49:47', 'admin-1483337473-14833397874014371', 1, 1, 'SR', NULL, NULL, NULL),
(16839, '2017-01-02 15:40:39', NULL, NULL, 5824, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 15:40:39', 'admin-1483337473-14833428388881968', 1, 1, 'SR', NULL, NULL, NULL),
(16840, '2017-01-02 15:40:39', NULL, NULL, 5824, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 15:40:39', 'admin-1483337473-14833428388881968', 1, 0, '', NULL, NULL, NULL),
(16841, '2017-01-02 16:05:53', NULL, NULL, 5825, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 16:05:53', 'admin-1483337473-14833443533652591', 1, 0, '', NULL, NULL, NULL),
(16842, '2017-01-02 16:58:43', NULL, NULL, 5828, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 16:58:43', 'admin-1483337473-14833475232153561', 1, 0, '', NULL, NULL, NULL),
(16843, '2017-01-02 16:59:42', NULL, NULL, 5829, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 16:59:42', 'admin-1483337473-14833475823973263', 1, 1, 'SR', NULL, NULL, NULL),
(16844, '2017-01-02 17:12:29', NULL, NULL, 5830, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 17:12:29', 'admin-1483337473-14833483492312649', 1, 1, 'SR', NULL, NULL, NULL),
(16845, '2017-01-02 17:24:57', NULL, NULL, 5831, 0, 259, '193', 'Coronado Beer Set', '', 'Cold Drinks', 'Soda & Beer', 1, 40.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 17:24:57', 'admin-1483337473-14833490972471271', 1, 0, '', NULL, NULL, NULL),
(16846, '2017-01-02 20:24:02', NULL, NULL, 5841, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 20:24:02', 'admin-1483337473-14833598421291967', 1, 0, '', NULL, NULL, NULL),
(16847, '2017-01-02 12:02:32', NULL, NULL, 5814, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 12:02:32', 'admin-1483328805-14833297525738739', 1, 1, 'SR', 1, NULL, NULL),
(16848, '2017-01-02 19:48:35', NULL, NULL, 5840, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 19:48:35', 'admin-1483337473-14833577150982026', 1, 0, '', NULL, NULL, NULL),
(16849, '2017-01-02 16:47:20', NULL, NULL, 5827, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 16:47:20', 'admin-1483337473-14833468403824380', 1, 1, 'SR', 1, NULL, NULL),
(16850, '2017-01-02 17:31:44', NULL, NULL, 5832, 0, 259, '193', 'Coronado Beer Set', '', 'Cold Drinks', 'Soda & Beer', 1, 40.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 17:31:44', 'admin-1483337473-14833495042299480', 1, 0, '', 1, NULL, NULL),
(16851, '2017-01-02 17:38:13', NULL, NULL, 5833, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 17:38:13', 'admin-1483337473-14833498936152182', 1, 1, 'SR', NULL, NULL, NULL),
(16852, '2017-01-02 17:38:13', NULL, NULL, 5833, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 17:38:13', 'admin-1483337473-14833498936152182', 1, 1, 'SR', NULL, NULL, NULL),
(16853, '2017-01-02 17:38:13', NULL, NULL, 5833, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 17:38:13', 'admin-1483337473-14833498936152182', 1, 1, 'SR', NULL, NULL, NULL),
(16854, '2017-01-02 18:09:26', NULL, NULL, 5834, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 18:09:26', 'admin-1483337473-14833517660284012', 1, 0, '', NULL, NULL, NULL),
(16855, '2017-01-02 18:23:16', NULL, NULL, 5835, 0, 259, '193', 'Coronado Beer Set', '', 'Cold Drinks', 'Soda & Beer', 1, 40.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 18:23:16', 'admin-1483337473-14833525959209078', 1, 0, '', NULL, NULL, NULL),
(16856, '2017-01-02 18:27:49', NULL, NULL, 5836, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 18:27:49', 'admin-1483337473-14833528688949327', 1, 1, 'SR', NULL, NULL, NULL),
(16857, '2017-01-02 18:27:49', NULL, NULL, 5836, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 18:27:49', 'admin-1483337473-14833528688949327', 1, 1, 'SR', NULL, NULL, NULL),
(16858, '2017-01-02 18:31:41', NULL, NULL, 5837, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 18:31:41', 'admin-1483337473-14833531016484969', 1, 1, 'SR', NULL, NULL, NULL),
(16859, '2017-01-02 18:31:41', NULL, NULL, 5837, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 18:31:41', 'admin-1483337473-14833531016484969', 1, 1, 'SR', NULL, NULL, NULL),
(16860, '2017-01-02 18:32:39', NULL, NULL, 5833, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 18:32:39', 'admin-1483337473-14833531592625728', 1, 0, '', NULL, NULL, NULL),
(16861, '2017-01-02 18:32:39', NULL, NULL, 5833, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 18:32:39', 'admin-1483337473-14833531592625728', 1, 0, '', NULL, NULL, NULL),
(16862, '2017-01-02 18:32:39', NULL, NULL, 5833, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 18:32:39', 'admin-1483337473-14833531592625728', 1, 1, 'SR', NULL, NULL, NULL),
(16863, '2017-01-02 18:54:01', NULL, NULL, 5838, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 18:54:01', 'admin-1483337473-14833544411495226', 1, 0, '', NULL, NULL, NULL),
(16864, '2017-01-02 18:54:01', NULL, NULL, 5838, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 18:54:01', 'admin-1483337473-14833544411495226', 1, 0, '', NULL, NULL, NULL),
(16865, '2017-01-02 18:54:01', NULL, NULL, 5838, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 18:54:01', 'admin-1483337473-14833544411495226', 1, 1, 'SR', NULL, NULL, NULL),
(16866, '2017-01-02 18:57:08', NULL, NULL, 5839, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 18:57:08', 'admin-1483337473-14833546282567237', 1, 1, 'SR', NULL, NULL, NULL),
(16867, '2017-01-02 18:57:08', NULL, NULL, 5839, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 18:57:08', 'admin-1483337473-14833546282567237', 1, 0, '', NULL, NULL, NULL),
(16868, '2017-01-02 18:57:08', NULL, NULL, 5839, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 18:57:08', 'admin-1483337473-14833546282567237', 1, 1, 'SR', NULL, NULL, NULL),
(16869, '2017-01-02 16:47:20', NULL, NULL, 5827, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 16:47:20', 'admin-1483337473-14833468403824380', 1, 1, 'SR', 1, NULL, NULL),
(16870, '2017-01-02 12:03:47', NULL, NULL, 5815, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 12:03:47', 'admin-1483328805-14833298269073315', 1, 1, 'SR', NULL, NULL, NULL),
(16871, '2017-01-02 10:43:22', NULL, NULL, 5799, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:43:22', 'admin-1483323276-14833250027387714', 1, 1, 'SR', NULL, NULL, NULL),
(16872, '2017-01-02 10:44:30', NULL, NULL, 5800, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:44:30', 'admin-1483323276-1483325070480199', 1, 1, 'SR', NULL, NULL, NULL),
(16873, '2017-01-02 10:44:30', NULL, NULL, 5800, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:44:30', 'admin-1483323276-1483325070480199', 1, 1, 'SR', NULL, NULL, NULL),
(16874, '2017-01-02 10:45:06', NULL, NULL, 5801, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:45:06', 'admin-1483323276-14833251065772090', 1, 1, 'SR', 1, NULL, NULL),
(16875, '2017-01-02 10:48:00', NULL, NULL, 5802, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:48:00', 'admin-1483325183-14833252801368964', 1, 0, '', NULL, NULL, NULL),
(16876, '2017-01-02 10:48:00', NULL, NULL, 5802, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:48:00', 'admin-1483325183-14833252801368964', 1, 1, 'SR', NULL, NULL, NULL),
(16877, '2017-01-02 16:47:20', NULL, NULL, 5827, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 16:47:20', 'admin-1483337473-14833468403824380', 1, 1, 'SR', 1, NULL, NULL),
(16878, '2017-01-02 16:44:40', NULL, NULL, 5826, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 16:44:40', 'admin-1483337473-14833466802403734', 1, 1, 'SR', NULL, NULL, NULL),
(16879, '2017-01-02 16:44:40', NULL, NULL, 5826, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 16:44:40', 'admin-1483337473-14833466802403734', 1, 1, 'SR', NULL, NULL, NULL),
(16880, '2017-01-02 12:26:47', NULL, NULL, 5816, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 12:26:47', 'admin-1483328805-14833312070604787', 1, 0, '', NULL, NULL, NULL),
(16881, '2017-01-02 12:26:47', NULL, NULL, 5816, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 12:26:47', 'admin-1483328805-14833312070604787', 1, 1, 'SR', NULL, NULL, NULL),
(16882, '2017-01-02 12:26:47', NULL, NULL, 5816, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 12:26:47', 'admin-1483328805-14833312070604787', 1, 0, '', NULL, NULL, NULL),
(16883, '2017-01-02 12:26:47', NULL, NULL, 5816, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 12:26:47', 'admin-1483328805-14833312070604787', 1, 1, 'SR', NULL, NULL, NULL),
(16884, '2017-01-02 13:05:12', NULL, NULL, 5817, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 13:05:12', 'admin-1483328805-1483333512322427', 1, 1, 'SR', NULL, NULL, NULL),
(16885, '2017-01-02 13:05:19', NULL, NULL, 5817, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 13:05:19', 'admin-1483328805-14833335188941338', 1, 1, 'SR', NULL, NULL, NULL),
(16886, '2017-01-02 13:21:33', NULL, NULL, 5818, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 13:21:33', 'admin-1483328805-14833344934347587', 1, 0, '', NULL, NULL, NULL),
(16887, '2017-01-02 10:49:18', NULL, NULL, 5804, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:49:18', 'admin-1483325183-14833253581698859', 1, 1, 'SR', NULL, NULL, NULL),
(16888, '2017-01-02 10:58:48', NULL, NULL, 5805, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:58:48', 'admin-1483325183-14833259279917665', 1, 1, 'SR', NULL, NULL, NULL),
(16889, '2017-01-02 10:58:48', NULL, NULL, 5805, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:58:48', 'admin-1483325183-14833259279917665', 1, 1, 'SR', NULL, NULL, NULL),
(16890, '2017-01-02 10:58:48', NULL, NULL, 5805, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:58:48', 'admin-1483325183-14833259279917665', 1, 0, '', NULL, NULL, NULL),
(16891, '2017-01-02 10:58:57', NULL, NULL, 5805, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:58:57', 'admin-1483325183-14833259372804434', 1, 0, '', NULL, NULL, NULL),
(16892, '2017-01-02 11:01:48', NULL, NULL, 5806, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 11:01:48', 'admin-1483325183-14833261085938612', 1, 0, '', NULL, NULL, NULL),
(16893, '2017-01-02 11:01:48', NULL, NULL, 5806, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 11:01:48', 'admin-1483325183-14833261085938612', 1, 0, '', NULL, NULL, NULL),
(16894, '2017-01-02 11:02:21', NULL, NULL, 5806, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 11:02:21', 'admin-1483325183-14833261412221136', 1, 1, 'SR', NULL, NULL, NULL),
(16895, '2017-01-02 11:23:33', NULL, NULL, 5807, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 11:23:33', 'admin-1483325183-1483327412969741', 1, 1, 'SR', NULL, NULL, NULL),
(16896, '2017-01-02 11:30:43', NULL, NULL, 5808, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 11:30:43', 'admin-1483325183-14833278436998188', 1, 0, '', NULL, NULL, NULL),
(16897, '2017-01-02 16:58:43', NULL, NULL, 5828, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 16:58:43', 'admin-1483337473-14833475232153561', 1, 0, '', NULL, NULL, NULL),
(16898, '2017-01-02 16:47:42', NULL, NULL, 5827, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 16:47:42', 'admin-1483337473-1483346862218437', 1, 0, '', 1, NULL, NULL),
(16899, '2017-01-02 12:03:47', NULL, NULL, 5815, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 12:03:47', 'admin-1483328805-14833298269073315', 1, 1, 'SR', NULL, NULL, NULL),
(16900, '2017-01-02 12:03:47', NULL, NULL, 5815, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 12:03:47', 'admin-1483328805-14833298269073315', 1, 1, 'SR', NULL, NULL, NULL),
(16901, '2017-01-02 11:57:13', NULL, NULL, 5813, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 11:57:13', 'admin-1483328805-14833294332093497', 1, 1, 'SR', NULL, NULL, NULL),
(16902, '2017-01-02 11:57:13', NULL, NULL, 5813, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 11:57:13', 'admin-1483328805-14833294332093497', 1, 0, '', NULL, NULL, NULL),
(16903, '2017-01-02 11:46:56', NULL, NULL, 5812, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 11:46:56', 'admin-1483328805-14833288161346218', 1, 0, '', NULL, NULL, NULL),
(16904, '2017-01-02 11:46:56', NULL, NULL, 5812, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 11:46:56', 'admin-1483328805-14833288161346218', 1, 1, 'SR', NULL, NULL, NULL),
(16905, '2017-01-02 11:46:20', NULL, NULL, 5812, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 11:46:20', 'admin-1483325183-14833287806053944', 1, 0, '', NULL, NULL, NULL),
(16906, '2017-01-02 11:34:35', NULL, NULL, 5808, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 11:34:35', 'admin-1483325183-14833280748829099', 1, 1, 'SR', NULL, NULL, NULL),
(16907, '2017-01-02 11:34:35', NULL, NULL, 5808, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 11:34:35', 'admin-1483325183-14833280748829099', 1, 1, 'SR', NULL, NULL, NULL),
(16908, '2017-01-02 11:32:34', NULL, NULL, 5811, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 11:32:34', 'admin-1483325183-14833279540751235', 1, 0, '', 1, NULL, NULL),
(16909, '2017-01-02 00:00:00', NULL, NULL, 5809, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:19:47', 'admin-1483323276-14833235870977973', 1, 1, 'SR', NULL, NULL, NULL),
(16910, '2017-01-02 11:30:43', NULL, NULL, 5808, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 11:30:43', 'admin-1483325183-14833278436998188', 1, 0, '', NULL, NULL, NULL),
(16911, '2017-01-02 10:48:42', NULL, NULL, 5803, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:48:42', 'admin-1483325183-14833253222778562', 1, 1, 'SR', NULL, NULL, NULL),
(16912, '2017-01-02 10:48:42', NULL, NULL, 5803, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:48:42', 'admin-1483325183-14833253222778562', 1, 0, '', NULL, NULL, NULL),
(16913, '2017-01-02 10:36:28', NULL, NULL, 5798, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:36:28', 'admin-1483323276-14833245879769916', 1, 1, 'SR', NULL, NULL, NULL),
(16914, '2017-01-02 10:43:10', NULL, NULL, 5799, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:43:10', 'admin-1483323276-14833249902742228', 1, 0, '', NULL, NULL, NULL),
(16915, '2017-01-02 10:43:10', NULL, NULL, 5799, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:43:10', 'admin-1483323276-14833249902742228', 1, 0, '', NULL, NULL, NULL),
(16916, '2017-01-02 10:49:18', NULL, NULL, 5804, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:49:18', 'admin-1483325183-14833253581698859', 1, 0, '', NULL, NULL, NULL),
(16917, '2017-01-02 10:36:28', NULL, NULL, 5798, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:36:28', 'admin-1483323276-14833245879769916', 1, 1, 'SR', NULL, NULL, NULL),
(16918, '2017-01-02 00:00:00', NULL, NULL, 5810, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:19:31', 'admin-1483323276-148332357145153', 1, 0, '', NULL, NULL, NULL),
(16919, '2017-01-02 00:00:00', NULL, NULL, 5809, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:19:31', 'admin-1483323276-148332357145153', 1, 0, '', NULL, NULL, NULL),
(16920, '2017-01-02 11:32:34', NULL, NULL, 5811, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 11:32:34', 'admin-1483325183-14833279540751235', 1, 1, 'SR', 1, NULL, NULL),
(16921, '2017-01-02 00:00:00', NULL, NULL, 5809, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:19:31', 'admin-1483323276-148332357145153', 1, 0, '', NULL, NULL, NULL),
(16922, '2017-01-02 00:00:00', NULL, NULL, 5809, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:19:31', 'admin-1483323276-148332357145153', 1, 0, '', NULL, NULL, NULL),
(16923, '2017-01-02 00:00:00', NULL, NULL, 5809, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:19:47', 'admin-1483323276-14833235870977973', 1, 1, 'SR', NULL, NULL, NULL),
(16924, '2017-01-02 00:00:00', NULL, NULL, 5809, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:19:47', 'admin-1483323276-14833235870977973', 1, 0, '', NULL, NULL, NULL),
(16925, '2017-01-02 00:00:00', NULL, NULL, 5810, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:19:47', 'admin-1483323276-14833235870977973', 1, 0, '', NULL, NULL, NULL),
(16926, '2017-01-02 10:13:27', NULL, NULL, 5795, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:13:27', 'admin-1483318311-1483323207563521', 1, 0, '', NULL, NULL, NULL),
(16927, '2017-01-02 10:13:27', NULL, NULL, 5795, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:13:27', 'admin-1483318311-1483323207563521', 1, 1, 'SR', NULL, NULL, NULL),
(16928, '2017-01-02 10:13:27', NULL, NULL, 5795, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:13:27', 'admin-1483318311-1483323207563521', 1, 1, 'SR', NULL, NULL, NULL),
(16929, '2017-01-02 10:14:46', NULL, NULL, 5795, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:14:46', 'admin-1483323276-1483323286314885', 1, 0, '', NULL, NULL, NULL),
(16930, '2017-01-02 10:15:17', NULL, NULL, 5796, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:15:17', 'admin-1483323276-14833233169082666', 1, 0, '', NULL, NULL, NULL),
(16931, '2017-01-02 10:15:17', NULL, NULL, 5796, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:15:17', 'admin-1483323276-14833233169082666', 1, 0, '', NULL, NULL, NULL),
(16932, '2017-01-02 10:15:17', NULL, NULL, 5796, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:15:17', 'admin-1483323276-14833233169082666', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(16933, '2017-01-02 10:15:17', NULL, NULL, 5796, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:15:17', 'admin-1483323276-14833233169082666', 1, 1, 'SR', NULL, NULL, NULL),
(16934, '2017-01-02 10:13:16', NULL, NULL, 5793, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 10:13:16', 'admin-1483318311-14833231961576781', 1, 0, '', NULL, NULL, NULL),
(16935, '2017-01-02 09:57:57', NULL, NULL, 5794, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:57:57', 'admin-1483318311-14833222775882650', 1, 1, 'SR', NULL, NULL, NULL),
(16936, '2017-01-02 09:57:57', NULL, NULL, 5794, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:57:57', 'admin-1483318311-14833222775882650', 1, 1, 'SR', NULL, NULL, NULL),
(16937, '2017-01-02 09:10:56', NULL, NULL, 5790, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:10:56', 'admin-1483318311-14833194562273167', 1, 1, 'SR', NULL, NULL, NULL),
(16938, '2017-01-02 09:57:57', NULL, NULL, 5794, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:57:57', 'admin-1483318311-14833222775882650', 1, 1, 'SR', NULL, NULL, NULL),
(16939, '2017-01-02 09:19:20', NULL, NULL, 5792, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:19:20', 'admin-1483318311-1483319960810817', 1, 0, '', NULL, NULL, NULL),
(16940, '2017-01-02 09:19:26', NULL, NULL, 5792, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:19:26', 'admin-1483318311-14833199661181941', 1, 0, '', NULL, NULL, NULL),
(16941, '2017-01-02 09:19:39', NULL, NULL, 5792, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:19:39', 'admin-1483318311-1483319979361108', 1, 1, 'SR', NULL, NULL, NULL),
(16942, '2017-01-02 09:19:39', NULL, NULL, 5792, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:19:39', 'admin-1483318311-1483319979361108', 1, 1, 'SR', NULL, NULL, NULL),
(16943, '2017-01-02 09:35:29', NULL, NULL, 5793, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:35:29', 'admin-1483318311-14833209294128116', 1, 0, '', NULL, NULL, NULL),
(16944, '2017-01-02 09:35:29', NULL, NULL, 5793, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:35:29', 'admin-1483318311-14833209294128116', 1, 0, '', NULL, NULL, NULL),
(16945, '2017-01-02 09:35:29', NULL, NULL, 5793, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:35:29', 'admin-1483318311-14833209294128116', 1, 1, 'SR', NULL, NULL, NULL),
(16946, '2017-01-02 09:35:29', NULL, NULL, 5793, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:35:29', 'admin-1483318311-14833209294128116', 1, 1, 'SR', NULL, NULL, NULL),
(16947, '2017-01-02 09:35:29', NULL, NULL, 5793, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:35:29', 'admin-1483318311-14833209294128116', 1, 1, 'SR', NULL, NULL, NULL),
(16948, '2017-01-02 09:48:13', NULL, NULL, 5792, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:48:13', 'admin-1483318311-14833216930663139', 1, 0, '', NULL, NULL, NULL),
(16949, '2017-01-02 09:57:42', NULL, NULL, 5794, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:57:42', 'admin-1483318311-14833222627088856', 1, 0, '', NULL, NULL, NULL),
(16950, '2017-01-02 09:57:42', NULL, NULL, 5794, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:57:42', 'admin-1483318311-14833222627088856', 1, 0, '', NULL, NULL, NULL),
(16951, '2017-01-02 09:19:20', NULL, NULL, 5792, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:19:20', 'admin-1483318311-1483319960810817', 1, 0, '', NULL, NULL, NULL),
(16952, '2017-01-02 09:19:20', NULL, NULL, 5792, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:19:20', 'admin-1483318311-1483319960810817', 1, 0, '', NULL, NULL, NULL),
(16953, '2017-01-02 09:19:20', NULL, NULL, 5792, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:19:20', 'admin-1483318311-1483319960810817', 1, 0, '', NULL, NULL, NULL),
(16954, '2017-01-02 09:19:20', NULL, NULL, 5792, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:19:20', 'admin-1483318311-1483319960810817', 1, 0, '', NULL, NULL, NULL),
(16955, '2017-01-02 09:19:20', NULL, NULL, 5792, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:19:20', 'admin-1483318311-1483319960810817', 1, 0, '', NULL, NULL, NULL),
(16956, '2017-01-02 09:11:03', NULL, NULL, 5791, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:11:03', 'admin-1483318311-14833194636676776', 1, 1, 'SR', 1, NULL, NULL),
(16957, '2017-01-02 09:10:56', NULL, NULL, 5790, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:10:56', 'admin-1483318311-14833194562273167', 1, 1, 'SR', NULL, NULL, NULL),
(16958, '2017-01-02 09:10:50', NULL, NULL, 5790, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:10:50', 'admin-1483318311-14833194498154927', 1, 0, '', NULL, NULL, NULL),
(16959, '2017-01-02 09:10:49', NULL, NULL, 5790, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483337473', 'admin', '2017-01-02 09:10:49', 'admin-1483318311-14833194498154927', 1, 0, '', NULL, NULL, NULL),
(16960, '2017-01-04 15:18:55', NULL, NULL, 5869, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 15:18:55', 'admin-1483509082-14835143355654936', 1, 1, 'SR', 1, NULL, NULL),
(16961, '2017-01-04 12:58:41', NULL, NULL, 5865, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 12:58:41', 'admin-1483498550-14835059215239720', 1, 0, '', NULL, NULL, NULL),
(16962, '2017-01-04 13:11:43', NULL, NULL, 5866, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 13:11:43', 'admin-1483498550-14835067033163497', 1, 0, '', NULL, NULL, NULL),
(16963, '2017-01-04 13:11:54', NULL, NULL, 5866, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 2, 9.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 13:11:54', 'admin-1483498550-14835067138792661', 1, 1, 'SR', NULL, NULL, NULL),
(16964, '2017-01-04 13:12:05', NULL, NULL, 5864, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 13:12:05', 'admin-1483498550-14835067252609973', 1, 1, 'SR', NULL, NULL, NULL),
(16965, '2017-01-04 19:44:37', NULL, NULL, 5877, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 19:44:37', 'admin-1483509082-14835302769433416', 1, 0, '', NULL, NULL, NULL),
(16966, '2017-01-04 14:35:22', NULL, NULL, 5868, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 14:35:22', 'admin-1483509082-1483511722679878', 1, 1, 'SR', NULL, NULL, NULL),
(16967, '2017-01-04 15:46:44', NULL, NULL, 5870, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 15:46:44', 'admin-1483509082-14835160037675152', 1, 0, '', 1, NULL, NULL),
(16968, '2017-01-04 15:46:44', NULL, NULL, 5870, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 15:46:44', 'admin-1483509082-14835160037675152', 1, 1, 'SR', 1, NULL, NULL),
(16969, '2017-01-04 16:34:52', NULL, NULL, 5871, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 16:34:52', 'admin-1483509082-14835188923396566', 1, 1, 'SR', NULL, NULL, NULL),
(16970, '2017-01-04 16:34:52', NULL, NULL, 5871, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 16:34:52', 'admin-1483509082-14835188923396566', 1, 1, 'SR', NULL, NULL, NULL),
(16971, '2017-01-04 16:34:52', NULL, NULL, 5871, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 16:34:52', 'admin-1483509082-14835188923396566', 1, 1, 'SR', NULL, NULL, NULL),
(16972, '2017-01-04 16:34:52', NULL, NULL, 5871, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 16:34:52', 'admin-1483509082-14835188923396566', 1, 1, 'SR', NULL, NULL, NULL),
(16973, '2017-01-04 16:44:52', NULL, NULL, 5872, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 16:44:52', 'admin-1483509082-14835194918074766', 1, 1, 'SR', 1, NULL, NULL),
(16974, '2017-01-04 16:44:52', NULL, NULL, 5872, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 16:44:52', 'admin-1483509082-14835194918074766', 1, 1, 'SR', 1, NULL, NULL),
(16975, '2017-01-04 16:57:27', NULL, NULL, 5864, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 16:57:27', 'admin-1483509082-14835202467963992', 1, 0, '', NULL, NULL, NULL),
(16976, '2017-01-04 17:20:42', NULL, NULL, 5873, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 17:20:42', 'admin-1483509082-14835216423383343', 1, 0, '', 1, NULL, NULL),
(16977, '2017-01-04 17:20:42', NULL, NULL, 5873, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 17:20:42', 'admin-1483509082-14835216423383343', 1, 0, '', 1, NULL, NULL),
(16978, '2017-01-04 17:20:42', NULL, NULL, 5873, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 17:20:42', 'admin-1483509082-14835216423383343', 1, 1, 'SR', 1, NULL, NULL),
(16979, '2017-01-04 17:20:42', NULL, NULL, 5873, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 17:20:42', 'admin-1483509082-14835216423383343', 1, 1, 'SR', 1, NULL, NULL),
(16980, '2017-01-04 17:22:32', NULL, NULL, 5874, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 17:22:32', 'admin-1483509082-14835217520027367', 1, 0, '', 1, NULL, NULL),
(16981, '2017-01-04 17:22:32', NULL, NULL, 5874, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 17:22:32', 'admin-1483509082-14835217520027367', 1, 0, '', 1, NULL, NULL),
(16982, '2017-01-04 17:26:32', NULL, NULL, 5875, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 17:26:32', 'admin-1483509082-14835219919171097', 1, 1, 'SR', NULL, NULL, NULL),
(16983, '2017-01-04 17:26:32', NULL, NULL, 5875, 0, 259, '193', 'Coronado Beer Set', '', 'Cold Drinks', 'Soda & Beer', 1, 40.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 17:26:32', 'admin-1483509082-14835219919171097', 1, 0, '', NULL, NULL, NULL),
(16984, '2017-01-04 18:09:58', NULL, NULL, 5876, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 18:09:58', 'admin-1483509082-14835245983623182', 1, 1, 'SR', NULL, NULL, NULL),
(16985, '2017-01-04 18:09:58', NULL, NULL, 5876, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 18:09:58', 'admin-1483509082-14835245983623182', 1, 1, 'SR', NULL, NULL, NULL),
(16986, '2017-01-04 19:44:37', NULL, NULL, 5877, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 19:44:37', 'admin-1483509082-14835302769433416', 1, 1, 'SR', NULL, NULL, NULL),
(16987, '2017-01-04 12:58:41', NULL, NULL, 5865, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 12:58:41', 'admin-1483498550-14835059215239720', 1, 1, 'SR', NULL, NULL, NULL),
(16988, '2017-01-04 10:56:25', NULL, NULL, 5859, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:56:25', 'admin-1483498550-14834985849804152', 1, 1, 'SR', NULL, NULL, NULL),
(16989, '2017-01-04 10:56:25', NULL, NULL, 5859, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:56:25', 'admin-1483498550-14834985849804152', 1, 1, 'SR', NULL, NULL, NULL),
(16990, '2017-01-04 10:56:25', NULL, NULL, 5859, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:56:25', 'admin-1483498550-14834985849804152', 1, 1, 'SR', NULL, NULL, NULL),
(16991, '2017-01-04 11:34:58', NULL, NULL, 5860, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 11:34:58', 'admin-1483498550-14835008981682534', 1, 1, 'SR', NULL, NULL, NULL),
(16992, '2017-01-04 10:48:04', NULL, NULL, 5858, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:48:04', 'admin-1483495692-1483498084159484', 1, 0, '', NULL, NULL, NULL),
(16993, '2017-01-04 10:48:04', NULL, NULL, 5858, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:48:04', 'admin-1483495692-1483498084159484', 1, 1, 'SR', NULL, NULL, NULL),
(16994, '2017-01-04 15:25:04', NULL, NULL, 5868, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 15:25:04', 'admin-1483509082-14835147044913098', 1, 0, '', NULL, NULL, NULL),
(16995, '2017-01-04 14:35:22', NULL, NULL, 5868, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 14:35:22', 'admin-1483509082-1483511722679878', 1, 1, 'SR', NULL, NULL, NULL),
(16996, '2017-01-04 13:59:39', NULL, NULL, 5867, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 13:59:39', 'admin-1483509082-14835095791027441', 1, 1, 'SR', NULL, NULL, NULL),
(16997, '2017-01-04 13:59:39', NULL, NULL, 5867, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 13:59:39', 'admin-1483509082-14835095791027441', 1, 1, 'SR', NULL, NULL, NULL),
(16998, '2017-01-04 13:50:55', NULL, NULL, 5864, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1483509082', 'admin', '2017-01-04 13:50:55', 'admin-1483498550-14835090548544818', 1, 0, '', NULL, NULL, NULL),
(16999, '2017-01-04 13:24:39', NULL, NULL, 5866, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 13:24:39', 'admin-1483498550-1483507479374641', 1, 0, '', NULL, NULL, NULL),
(17000, '2017-01-04 12:19:31', NULL, NULL, 5862, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 12:19:31', 'admin-1483498550-14835035715042660', 1, 1, 'SR', NULL, NULL, NULL),
(17001, '2017-01-04 12:45:51', NULL, NULL, 5863, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 12:45:51', 'admin-1483498550-1483505151172874', 1, 0, '', NULL, NULL, NULL),
(17002, '2017-01-04 12:45:51', NULL, NULL, 5863, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 12:45:51', 'admin-1483498550-1483505151172874', 1, 0, '', NULL, NULL, NULL),
(17003, '2017-01-04 12:57:52', NULL, NULL, 5864, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 12:57:52', 'admin-1483498550-14835058724346338', 1, 1, 'SR', NULL, NULL, NULL),
(17004, '2017-01-04 10:48:04', NULL, NULL, 5858, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:48:04', 'admin-1483495692-1483498084159484', 1, 1, 'SR', NULL, NULL, NULL),
(17005, '2017-01-04 10:55:41', NULL, NULL, 5859, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:55:41', 'admin-1483495692-1483498541601423', 1, 0, '', NULL, NULL, NULL),
(17006, '2017-01-04 10:55:41', NULL, NULL, 5859, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:55:41', 'admin-1483495692-1483498541601423', 1, 0, '', NULL, NULL, NULL),
(17007, '2017-01-04 10:55:41', NULL, NULL, 5859, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:55:41', 'admin-1483495692-1483498541601423', 1, 0, '', NULL, NULL, NULL),
(17008, '2017-01-04 10:55:41', NULL, NULL, 5859, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:55:41', 'admin-1483495692-1483498541601423', 1, 0, '', NULL, NULL, NULL),
(17009, '2017-01-04 10:55:41', NULL, NULL, 5859, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:55:41', 'admin-1483495692-1483498541601423', 1, 0, '', NULL, NULL, NULL),
(17010, '2017-01-04 10:56:25', NULL, NULL, 5859, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:56:25', 'admin-1483498550-14834985849804152', 1, 1, 'SR', NULL, NULL, NULL),
(17011, '2017-01-04 10:56:25', NULL, NULL, 5859, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:56:25', 'admin-1483498550-14834985849804152', 1, 1, 'SR', NULL, NULL, NULL),
(17012, '2017-01-04 10:56:25', NULL, NULL, 5859, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:56:25', 'admin-1483498550-14834985849804152', 1, 1, 'SR', NULL, NULL, NULL),
(17013, '2017-01-04 10:56:25', NULL, NULL, 5859, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:56:25', 'admin-1483498550-14834985849804152', 1, 0, '', NULL, NULL, NULL),
(17014, '2017-01-04 12:58:41', NULL, NULL, 5865, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 12:58:41', 'admin-1483498550-14835059215239720', 1, 0, '', NULL, NULL, NULL),
(17015, '2017-01-04 12:58:41', NULL, NULL, 5865, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 12:58:41', 'admin-1483498550-14835059215239720', 1, 1, 'SR', NULL, NULL, NULL),
(17016, '2017-01-04 12:58:16', NULL, NULL, 5864, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 12:58:16', 'admin-1483498550-14835058963066746', 1, 1, 'SR', NULL, NULL, NULL),
(17017, '2017-01-04 12:57:52', NULL, NULL, 5864, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 12:57:52', 'admin-1483498550-14835058724346338', 1, 1, 'SR', NULL, NULL, NULL),
(17018, '2017-01-04 12:19:31', NULL, NULL, 5862, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 12:19:31', 'admin-1483498550-14835035715042660', 1, 1, 'SR', NULL, NULL, NULL),
(17019, '2017-01-04 12:19:31', NULL, NULL, 5862, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 12:19:31', 'admin-1483498550-14835035715042660', 1, 1, 'SR', NULL, NULL, NULL),
(17020, '2017-01-04 12:19:31', NULL, NULL, 5862, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 12:19:31', 'admin-1483498550-14835035715042660', 1, 1, 'SR', NULL, NULL, NULL),
(17021, '2017-01-04 12:19:31', NULL, NULL, 5862, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 12:19:31', 'admin-1483498550-14835035715042660', 1, 0, '', NULL, NULL, NULL),
(17022, '2017-01-04 12:19:31', NULL, NULL, 5862, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 12:19:31', 'admin-1483498550-14835035715042660', 1, 0, '', NULL, NULL, NULL),
(17023, '2017-01-04 12:19:31', NULL, NULL, 5862, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 12:19:31', 'admin-1483498550-14835035715042660', 1, 0, '', NULL, NULL, NULL),
(17024, '2017-01-04 12:19:31', NULL, NULL, 5862, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 12:19:31', 'admin-1483498550-14835035715042660', 1, 0, '', NULL, NULL, NULL),
(17025, '2017-01-04 12:03:39', NULL, NULL, 5861, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 12:03:39', 'admin-1483498550-14835026195839650', 1, 1, 'SR', NULL, NULL, NULL),
(17026, '2017-01-04 12:03:39', NULL, NULL, 5861, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 12:03:39', 'admin-1483498550-14835026195839650', 1, 1, 'SR', NULL, NULL, NULL),
(17027, '2017-01-04 13:15:35', NULL, NULL, 5866, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1483509082', 'admin', '2017-01-04 13:15:35', 'admin-1483498550-14835069348525828', 1, 0, '', NULL, NULL, NULL),
(17028, '2017-01-04 11:34:58', NULL, NULL, 5860, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 11:34:58', 'admin-1483498550-14835008981682534', 1, 1, 'SR', NULL, NULL, NULL),
(17029, '2017-01-04 11:34:58', NULL, NULL, 5860, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 11:34:58', 'admin-1483498550-14835008981682534', 1, 1, 'SR', NULL, NULL, NULL),
(17030, '2017-01-04 11:34:58', NULL, NULL, 5860, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 11:34:58', 'admin-1483498550-14835008981682534', 1, 1, 'SR', NULL, NULL, NULL),
(17031, '2017-01-04 11:34:58', NULL, NULL, 5860, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 11:34:58', 'admin-1483498550-14835008981682534', 1, 1, 'SR', NULL, NULL, NULL),
(17032, '2017-01-04 10:48:04', NULL, NULL, 5858, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:48:04', 'admin-1483495692-1483498084159484', 1, 1, 'SR', NULL, NULL, NULL),
(17033, '2017-01-04 10:47:47', NULL, NULL, 5858, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:47:47', 'admin-1483495692-14834980674487485', 1, 0, '', NULL, NULL, NULL),
(17034, '2017-01-04 10:47:47', NULL, NULL, 5858, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:47:47', 'admin-1483495692-14834980674487485', 1, 0, '', NULL, NULL, NULL),
(17035, '2017-01-04 10:47:47', NULL, NULL, 5858, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:47:47', 'admin-1483495692-14834980674487485', 1, 0, '', NULL, NULL, NULL),
(17036, '2017-01-04 10:47:47', NULL, NULL, 5858, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:47:47', 'admin-1483495692-14834980674487485', 1, 0, '', NULL, NULL, NULL),
(17037, '2017-01-04 10:43:21', NULL, NULL, 5857, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:43:21', 'admin-1483495692-14834978010201991', 1, 1, 'SR', NULL, NULL, NULL),
(17038, '2017-01-04 10:43:21', NULL, NULL, 5857, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:43:21', 'admin-1483495692-14834978010201991', 1, 1, 'SR', NULL, NULL, NULL),
(17039, '2017-01-04 10:42:31', NULL, NULL, 5856, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:42:31', 'admin-1483495692-14834977517079375', 1, 0, '', NULL, NULL, NULL),
(17040, '2017-01-04 10:42:31', NULL, NULL, 5856, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:42:31', 'admin-1483495692-14834977517079375', 1, 0, '', NULL, NULL, NULL),
(17041, '2017-01-04 10:42:31', NULL, NULL, 5856, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:42:31', 'admin-1483495692-14834977517079375', 1, 1, 'SR', NULL, NULL, NULL),
(17042, '2017-01-04 10:42:31', NULL, NULL, 5856, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:42:31', 'admin-1483495692-14834977517079375', 1, 1, 'SR', NULL, NULL, NULL),
(17043, '2017-01-04 10:41:00', NULL, NULL, 5855, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:41:00', 'admin-1483495692-14834976602622180', 1, 1, 'SR', NULL, NULL, NULL),
(17044, '2017-01-04 10:39:40', NULL, NULL, 5854, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:39:40', 'admin-1483495692-1483497579855218', 1, 1, 'SR', NULL, NULL, NULL),
(17045, '2017-01-04 10:39:40', NULL, NULL, 5854, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:39:40', 'admin-1483495692-1483497579855218', 1, 1, 'SR', NULL, NULL, NULL),
(17046, '2017-01-04 10:37:45', NULL, NULL, 5853, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:37:46', 'admin-1483495692-14834974658183918', 1, 1, 'SR', NULL, NULL, NULL),
(17047, '2017-01-04 00:00:00', NULL, NULL, 5851, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:08:06', 'admin-1483490976-14834956862099848', 1, 1, 'SR', NULL, NULL, NULL),
(17048, '2017-01-04 10:33:46', NULL, NULL, 5850, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:33:46', 'admin-1483495692-14834972263316264', 1, 0, '', NULL, NULL, NULL),
(17049, '2017-01-04 10:23:01', NULL, NULL, 5849, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:23:01', 'admin-1483495692-1483496580930629', 1, 1, 'SR', NULL, NULL, NULL),
(17050, '2017-01-04 10:23:01', NULL, NULL, 5849, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:23:01', 'admin-1483495692-1483496580930629', 1, 1, 'SR', NULL, NULL, NULL),
(17051, '2017-01-04 09:38:00', NULL, NULL, 5845, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 09:38:00', 'admin-1483490976-14834938798961079', 1, 0, '', NULL, NULL, NULL),
(17052, '2017-01-04 10:22:56', NULL, NULL, 5849, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:22:56', 'admin-1483495692-14834965762304571', 1, 0, '', NULL, NULL, NULL),
(17053, '2017-01-04 09:41:10', NULL, NULL, 5846, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 09:41:10', 'admin-1483490976-14834940703781622', 1, 1, 'SR', NULL, NULL, NULL),
(17054, '2017-01-04 09:41:10', NULL, NULL, 5846, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 09:41:10', 'admin-1483490976-14834940703781622', 1, 0, '', NULL, NULL, NULL),
(17055, '2017-01-04 00:00:00', NULL, NULL, 5852, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:06:16', 'admin-1483490976-14834955760472228', 1, 1, 'SR', NULL, NULL, NULL),
(17056, '2017-01-04 10:37:45', NULL, NULL, 5853, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:37:45', 'admin-1483495692-14834974658183918', 1, 0, '', NULL, NULL, NULL),
(17057, '2017-01-04 00:00:00', NULL, NULL, 5852, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:06:06', 'admin-1483490976-14834955661468292', 1, 1, 'SR', NULL, NULL, NULL),
(17058, '2017-01-04 00:00:00', NULL, NULL, 5851, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:03:03', 'admin-1483490976-14834953833295182', 1, 1, 'SR', NULL, NULL, NULL),
(17059, '2017-01-04 10:14:21', NULL, NULL, 5848, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:14:21', 'admin-1483495692-14834960616035291', 1, 0, '', NULL, NULL, NULL),
(17060, '2017-01-04 10:14:21', NULL, NULL, 5848, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:14:21', 'admin-1483495692-14834960616035291', 1, 0, '', NULL, NULL, NULL),
(17061, '2017-01-04 10:14:21', NULL, NULL, 5848, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:14:21', 'admin-1483495692-14834960616035291', 1, 0, '', NULL, NULL, NULL),
(17062, '2017-01-04 10:14:30', NULL, NULL, 5848, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:14:30', 'admin-1483495692-14834960700045436', 1, 1, 'SR', NULL, NULL, NULL),
(17063, '2017-01-04 10:14:30', NULL, NULL, 5848, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:14:30', 'admin-1483495692-14834960700045436', 1, 1, 'SR', NULL, NULL, NULL),
(17064, '2017-01-04 10:22:56', NULL, NULL, 5849, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 10:22:56', 'admin-1483495692-14834965762304571', 1, 0, '', NULL, NULL, NULL),
(17065, '2017-01-04 09:38:00', NULL, NULL, 5845, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 09:38:00', 'admin-1483490976-14834938798961079', 1, 0, '', NULL, NULL, NULL),
(17066, '2017-01-04 09:24:43', NULL, NULL, 5844, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 09:24:43', 'admin-1483490976-14834930829139151', 1, 1, 'SR', NULL, NULL, NULL),
(17067, '2017-01-04 09:24:43', NULL, NULL, 5844, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 09:24:43', 'admin-1483490976-14834930829139151', 1, 1, 'SR', NULL, NULL, NULL),
(17068, '2017-01-04 09:24:43', NULL, NULL, 5844, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 09:24:43', 'admin-1483490976-14834930829139151', 1, 1, 'SR', NULL, NULL, NULL),
(17069, '2017-01-04 09:24:34', NULL, NULL, 5844, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 09:24:34', 'admin-1483490976-14834930744834776', 1, 0, '', NULL, NULL, NULL),
(17070, '2017-01-04 09:24:34', NULL, NULL, 5844, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 09:24:34', 'admin-1483490976-14834930744834776', 1, 0, '', NULL, NULL, NULL),
(17071, '2017-01-04 09:16:17', NULL, NULL, 5843, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 09:16:17', 'admin-1483490976-14834925768782579', 1, 0, '', 1, NULL, NULL),
(17072, '2017-01-04 09:11:03', NULL, NULL, 5842, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 09:11:03', 'admin-1483490976-148349226341127', 1, 1, 'SR', NULL, NULL, NULL),
(17073, '2017-01-04 09:11:03', NULL, NULL, 5842, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483509082', 'admin', '2017-01-04 09:11:03', 'admin-1483490976-148349226341127', 1, 0, '', NULL, NULL, NULL),
(17074, '2017-01-05 18:30:26', NULL, NULL, 5905, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 18:30:26', 'admin-1483592351-1483612226339767', 1, 1, 'SR', NULL, NULL, NULL),
(17075, '2017-01-05 13:47:00', NULL, NULL, 5895, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 13:47:00', 'admin-1483592351-1483595219906217', 1, 1, 'SR', NULL, NULL, NULL),
(17076, '2017-01-05 14:33:58', NULL, NULL, 5895, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 14:33:58', 'admin-1483592351-14835980382353794', 1, 1, 'SR', NULL, NULL, NULL),
(17077, '2017-01-05 14:35:36', NULL, NULL, 5896, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 14:35:36', 'admin-1483592351-14835981364687469', 1, 0, '', NULL, NULL, NULL),
(17078, '2017-01-05 14:35:36', NULL, NULL, 5896, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 14:35:36', 'admin-1483592351-14835981364687469', 1, 0, '', NULL, NULL, NULL),
(17079, '2017-01-05 14:41:25', NULL, NULL, 5897, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 14:41:25', 'admin-1483592351-148359848530577', 1, 1, 'SR', NULL, NULL, NULL),
(17080, '2017-01-05 14:41:25', NULL, NULL, 5897, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 14:41:25', 'admin-1483592351-148359848530577', 1, 1, 'SR', NULL, NULL, NULL),
(17081, '2017-01-05 15:11:15', NULL, NULL, 5898, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 15:11:15', 'admin-1483592351-14836002754766614', 1, 1, 'SR', NULL, NULL, NULL),
(17082, '2017-01-05 16:00:09', NULL, NULL, 5899, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 16:00:09', 'admin-1483592351-14836032097975210', 1, 1, 'SR', NULL, NULL, NULL),
(17083, '2017-01-05 13:35:20', NULL, NULL, 5894, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 13:35:20', 'admin-1483592351-148359452063846', 1, 1, 'SR', NULL, NULL, NULL),
(17084, '2017-01-05 13:35:40', NULL, NULL, 5889, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 13:35:40', 'admin-1483592351-14835945399656961', 1, 0, '', NULL, NULL, NULL),
(17085, '2017-01-05 13:35:40', NULL, NULL, 5889, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 13:35:40', 'admin-1483592351-14835945399656961', 1, 0, '', NULL, NULL, NULL),
(17086, '2017-01-05 13:35:56', NULL, NULL, 5894, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 13:35:56', 'admin-1483592351-1483594556281764', 1, 1, 'SR', NULL, NULL, NULL),
(17087, '2017-01-05 13:46:45', NULL, NULL, 5895, 0, 245, '179', 'Set Spicy Lemony Chicken Wing', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 13:46:45', 'admin-1483592351-14835952049425837', 1, 0, '', NULL, NULL, NULL),
(17088, '2017-01-05 13:46:45', NULL, NULL, 5895, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 13:46:45', 'admin-1483592351-14835952049425837', 1, 1, 'SR', NULL, NULL, NULL),
(17089, '2017-01-05 13:46:45', NULL, NULL, 5895, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 13:46:45', 'admin-1483592351-14835952049425837', 1, 0, '', NULL, NULL, NULL),
(17090, '2017-01-05 13:47:00', NULL, NULL, 5895, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 13:47:00', 'admin-1483592351-1483595219906217', 1, 1, 'SR', NULL, NULL, NULL),
(17091, '2017-01-05 13:47:00', NULL, NULL, 5895, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 13:47:00', 'admin-1483592351-1483595219906217', 1, 1, 'SR', NULL, NULL, NULL),
(17092, '2017-01-05 18:00:44', NULL, NULL, 5904, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 18:00:44', 'admin-1483592351-14836104441926625', 1, 1, 'SR', NULL, NULL, NULL),
(17093, '2017-01-05 18:00:44', NULL, NULL, 5904, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 18:00:44', 'admin-1483592351-14836104441926625', 1, 1, 'SR', NULL, NULL, NULL),
(17094, '2017-01-05 17:47:56', NULL, NULL, 5903, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 17:47:56', 'admin-1483592351-1483609675886123', 1, 0, '', NULL, NULL, NULL),
(17095, '2017-01-05 17:47:56', NULL, NULL, 5903, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 17:47:56', 'admin-1483592351-1483609675886123', 1, 0, '', NULL, NULL, NULL),
(17096, '2017-01-05 17:10:30', NULL, NULL, 5902, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 17:10:30', 'admin-1483592351-1483607429934716', 1, 1, 'SR', NULL, NULL, NULL),
(17097, '2017-01-05 17:10:30', NULL, NULL, 5902, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 17:10:30', 'admin-1483592351-1483607429934716', 1, 1, 'SR', NULL, NULL, NULL),
(17098, '2017-01-05 16:57:05', NULL, NULL, 5901, 0, 259, '193', 'Coronado Beer Set', '', 'Cold Drinks', 'Soda & Beer', 1, 40.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 16:57:05', 'admin-1483592351-14836066254014644', 1, 0, '', NULL, NULL, NULL),
(17099, '2017-01-05 16:32:02', NULL, NULL, 5900, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 16:32:02', 'admin-1483592351-14836051226785270', 1, 1, 'SR', 1, NULL, NULL),
(17100, '2017-01-05 12:44:02', NULL, NULL, 5890, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 12:44:02', 'admin-1483585789-14835914420391419', 1, 1, 'SR', NULL, NULL, NULL),
(17101, '2017-01-05 12:59:05', NULL, NULL, 5891, 0, 214, '148', 'Set Fried Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 12:59:05', 'admin-1483585789-14835923449601836', 1, 0, '', NULL, NULL, NULL),
(17102, '2017-01-05 12:59:05', NULL, NULL, 5891, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 12:59:05', 'admin-1483585789-14835923449601836', 1, 0, '', NULL, NULL, NULL),
(17103, '2017-01-05 14:35:36', NULL, NULL, 5896, 0, 224, '158', 'Set Stir Fried  Garlic Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 14:35:36', 'admin-1483592351-14835981364687469', 1, 0, '', NULL, NULL, NULL),
(17104, '2017-01-05 12:59:20', NULL, NULL, 5889, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 12:59:20', 'admin-1483592351-14835923607411891', 1, 0, '', NULL, NULL, NULL),
(17105, '2017-01-05 13:04:06', NULL, NULL, 5892, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 13:04:06', 'admin-1483592351-14835926458606396', 1, 1, 'SR', NULL, NULL, NULL),
(17106, '2017-01-05 13:04:06', NULL, NULL, 5892, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 13:04:06', 'admin-1483592351-14835926458606396', 1, 1, 'SR', NULL, NULL, NULL),
(17107, '2017-01-05 13:19:02', NULL, NULL, 5889, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 13:19:02', 'admin-1483592351-14835935422891516', 1, 0, '', NULL, NULL, NULL),
(17108, '2017-01-05 13:47:00', NULL, NULL, 5895, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 13:47:00', 'admin-1483592351-1483595219906217', 1, 1, 'SR', NULL, NULL, NULL),
(17109, '2017-01-05 13:20:44', NULL, NULL, 5893, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 13:20:44', 'admin-1483592351-1483593644350907', 1, 1, 'SR', NULL, NULL, NULL),
(17110, '2017-01-05 13:20:44', NULL, NULL, 5893, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 13:20:44', 'admin-1483592351-1483593644350907', 1, 0, '', NULL, NULL, NULL),
(17111, '2017-01-05 13:19:02', NULL, NULL, 5889, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 13:19:02', 'admin-1483592351-14835935422891516', 1, 0, '', NULL, NULL, NULL),
(17112, '2017-01-05 12:44:02', NULL, NULL, 5890, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 12:44:02', 'admin-1483585789-14835914420391419', 1, 0, '', NULL, NULL, NULL),
(17113, '2017-01-05 12:42:24', NULL, NULL, 5889, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 12:42:24', 'admin-1483585789-1483591344025179', 1, 1, 'SR', NULL, NULL, NULL),
(17114, '2017-01-05 12:42:24', NULL, NULL, 5889, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 3, 20.00, 60.0000, 0.0000, 60.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 12:42:24', 'admin-1483585789-1483591344025179', 1, 1, 'SR', NULL, NULL, NULL),
(17115, '2017-01-05 12:42:24', NULL, NULL, 5889, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 12:42:24', 'admin-1483585789-1483591344025179', 1, 1, 'SR', NULL, NULL, NULL),
(17116, '2017-01-05 12:33:09', NULL, NULL, 5889, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 12:33:09', 'admin-1483585789-14835907887483668', 1, 0, '', NULL, NULL, NULL),
(17117, '2017-01-05 12:33:09', NULL, NULL, 5889, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 12:33:09', 'admin-1483585789-14835907887483668', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(17118, '2017-01-05 12:33:08', NULL, NULL, 5889, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 12:33:08', 'admin-1483585789-14835907887483668', 1, 0, '', NULL, NULL, NULL),
(17119, '2017-01-05 12:33:08', NULL, NULL, 5889, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 12:33:08', 'admin-1483585789-14835907887483668', 1, 0, '', NULL, NULL, NULL),
(17120, '2017-01-05 12:33:08', NULL, NULL, 5889, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 12:33:08', 'admin-1483585789-14835907887483668', 1, 1, 'SR', NULL, NULL, NULL),
(17121, '2017-01-05 12:33:08', NULL, NULL, 5889, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 12:33:08', 'admin-1483585789-14835907887483668', 1, 0, '', NULL, NULL, NULL),
(17122, '2017-01-05 11:48:21', NULL, NULL, 5888, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 11:48:21', 'admin-1483585789-14835881014863093', 1, 1, 'SR', NULL, NULL, NULL),
(17123, '2017-01-05 11:25:14', NULL, NULL, 5887, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 11:25:14', 'admin-1483585789-14835867140269443', 1, 1, 'SR', NULL, NULL, NULL),
(17124, '2017-01-05 11:25:14', NULL, NULL, 5887, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 11:25:14', 'admin-1483585789-14835867140269443', 1, 1, 'SR', NULL, NULL, NULL),
(17125, '2017-01-05 11:25:03', NULL, NULL, 5887, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 11:25:03', 'admin-1483585789-14835867036709033', 1, 0, '', NULL, NULL, NULL),
(17126, '2017-01-05 11:25:03', NULL, NULL, 5887, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 11:25:03', 'admin-1483585789-14835867036709033', 1, 0, '', NULL, NULL, NULL),
(17127, '2017-01-05 11:26:12', NULL, NULL, 5885, 0, 157, '91', 'French Toast with Fruits', 'bacon', 'Meals', 'Morning Bites ', 3, 16.00, 48.0000, 0.0000, 48.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 11:26:12', 'admin-1483585789-14835867722675957', 1, 0, '', NULL, NULL, NULL),
(17128, '2017-01-05 11:48:21', NULL, NULL, 5888, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 11:48:21', 'admin-1483585789-14835881014863093', 1, 1, 'SR', NULL, NULL, NULL),
(17129, '2017-01-05 11:10:02', NULL, NULL, 5886, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 11:10:02', 'admin-1483585789-1483585802644939', 1, 1, 'SR', NULL, NULL, NULL),
(17130, '2017-01-05 11:10:02', NULL, NULL, 5886, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 11:10:02', 'admin-1483585789-1483585802644939', 1, 0, '', NULL, NULL, NULL),
(17131, '2017-01-05 09:03:43', NULL, NULL, 5878, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 09:03:43', 'admin-1483577547-14835782231277193', 1, 1, 'SR', NULL, NULL, NULL),
(17132, '2017-01-05 09:49:13', NULL, NULL, 5879, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 09:49:13', 'admin-1483577547-14835809536293855', 1, 1, 'SR', NULL, NULL, NULL),
(17133, '2017-01-05 09:49:13', NULL, NULL, 5879, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 09:49:13', 'admin-1483577547-14835809536293855', 1, 1, 'SR', NULL, NULL, NULL),
(17134, '2017-01-05 09:54:00', NULL, NULL, 5880, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 09:54:00', 'admin-1483577547-14835812404432213', 1, 0, '', NULL, NULL, NULL),
(17135, '2017-01-05 09:54:00', NULL, NULL, 5880, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 09:54:00', 'admin-1483577547-14835812404432213', 1, 0, '', NULL, NULL, NULL),
(17136, '2017-01-05 09:57:45', NULL, NULL, 5881, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 09:57:45', 'admin-1483577547-14835814657083349', 1, 1, 'SR', NULL, NULL, NULL),
(17137, '2017-01-05 10:09:08', NULL, NULL, 5882, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 10:09:08', 'admin-1483577547-14835821478292672', 1, 0, '', NULL, NULL, NULL),
(17138, '2017-01-05 10:10:01', NULL, NULL, 5883, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 10:10:01', 'admin-1483577547-14835822012243799', 1, 0, '', NULL, NULL, NULL),
(17139, '2017-01-05 10:41:19', NULL, NULL, 5884, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 10:41:19', 'admin-1483577547-1483584079282308', 1, 0, '', NULL, NULL, NULL),
(17140, '2017-01-05 10:41:19', NULL, NULL, 5884, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 10:41:19', 'admin-1483577547-1483584079282308', 1, 0, '', NULL, NULL, NULL),
(17141, '2017-01-05 10:41:19', NULL, NULL, 5884, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 10:41:19', 'admin-1483577547-1483584079282308', 1, 1, 'SR', NULL, NULL, NULL),
(17142, '2017-01-05 10:41:19', NULL, NULL, 5884, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 10:41:19', 'admin-1483577547-1483584079282308', 1, 1, 'SR', NULL, NULL, NULL),
(17143, '2017-01-05 10:59:26', NULL, NULL, 5885, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 10:59:26', 'admin-1483577547-14835851664107981', 1, 1, 'SR', NULL, NULL, NULL),
(17144, '2017-01-05 10:59:26', NULL, NULL, 5885, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 10:59:26', 'admin-1483577547-14835851664107981', 1, 1, 'SR', NULL, NULL, NULL),
(17145, '2017-01-05 10:59:26', NULL, NULL, 5885, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 10:59:26', 'admin-1483577547-14835851664107981', 1, 1, 'SR', NULL, NULL, NULL),
(17146, '2017-01-05 11:09:42', NULL, NULL, 5886, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 11:09:42', 'admin-1483577547-14835857823754116', 1, 0, '', NULL, NULL, NULL),
(17147, '2017-01-05 11:09:42', NULL, NULL, 5886, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 11:09:42', 'admin-1483577547-14835857823754116', 1, 0, '', NULL, NULL, NULL),
(17148, '2017-01-05 09:03:43', NULL, NULL, 5878, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 09:03:43', 'admin-1483577547-14835782231277193', 1, 1, 'SR', NULL, NULL, NULL),
(17149, '2017-01-05 09:03:43', NULL, NULL, 5878, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 09:03:43', 'admin-1483577547-14835782231277193', 1, 0, '', NULL, NULL, NULL),
(17150, '2017-01-05 09:03:32', NULL, NULL, 5878, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483592351', 'admin', '2017-01-05 09:03:32', 'admin-1483577547-14835782121131679', 1, 0, '', NULL, NULL, NULL),
(17151, '2017-01-06 15:57:36', NULL, NULL, 5930, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 15:57:36', 'admin-1483677214-148368945594595', 1, 0, '', NULL, NULL, NULL),
(17152, '2017-01-06 15:57:36', NULL, NULL, 5930, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 15:57:36', 'admin-1483677214-148368945594595', 1, 0, '', NULL, NULL, NULL),
(17153, '2017-01-06 15:57:36', NULL, NULL, 5930, 0, 181, '116', 'Open Food ', 'house platter', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 15:57:36', 'admin-1483677214-148368945594595', 1, 0, '', NULL, NULL, NULL),
(17154, '2017-01-06 15:58:17', NULL, NULL, 5930, 0, 259, '193', 'Coronado Beer Set', '', 'Cold Drinks', 'Soda & Beer', 1, 40.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 15:58:17', 'admin-1483677214-14836894976311167', 1, 0, '', NULL, NULL, NULL),
(17155, '2017-01-06 15:59:10', NULL, NULL, 5931, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 15:59:10', 'admin-1483677214-14836895499504181', 1, 0, '', NULL, NULL, NULL),
(17156, '2017-01-06 15:59:10', NULL, NULL, 5931, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 15:59:10', 'admin-1483677214-14836895499504181', 1, 1, 'SR', NULL, NULL, NULL),
(17157, '2017-01-06 16:09:25', NULL, NULL, 5932, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 16:09:25', 'admin-1483677214-1483690165147649', 1, 1, 'SR', NULL, NULL, NULL),
(17158, '2017-01-06 16:43:15', NULL, NULL, 5928, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 16:43:15', 'admin-1483677214-14836921952555292', 1, 0, '', NULL, NULL, NULL),
(17159, '2017-01-06 18:00:57', NULL, NULL, 5933, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 18:00:57', 'admin-1483677214-1483696856808742', 1, 1, 'SR', 1, NULL, NULL),
(17160, '2017-01-06 18:00:57', NULL, NULL, 5933, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 18:00:57', 'admin-1483677214-1483696856808742', 1, 1, 'SR', 1, NULL, NULL),
(17161, '2017-01-06 18:16:00', NULL, NULL, 5934, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 18:16:00', 'admin-1483677214-14836977599995699', 1, 1, 'SR', NULL, NULL, NULL),
(17162, '2017-01-06 18:18:38', NULL, NULL, 5935, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 18:18:38', 'admin-1483677214-14836979183112586', 1, 0, '', NULL, NULL, NULL),
(17163, '2017-01-06 18:19:20', NULL, NULL, 5935, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 18:19:20', 'admin-1483677214-14836979603131511', 1, 0, '', NULL, NULL, NULL),
(17164, '2017-01-06 14:28:42', NULL, NULL, 5925, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 14:28:42', 'admin-1483677214-14836841226273726', 1, 1, 'SR', NULL, NULL, NULL),
(17165, '2017-01-06 14:28:42', NULL, NULL, 5925, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 14:28:42', 'admin-1483677214-14836841226273726', 1, 1, 'SR', NULL, NULL, NULL),
(17166, '2017-01-06 10:35:04', NULL, NULL, 5912, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 10:35:04', 'admin-1483669204-14836701044403119', 1, 1, 'SR', NULL, NULL, NULL),
(17167, '2017-01-06 10:44:30', NULL, NULL, 5907, 0, 182, '117', 'Open Drinks ', 'drinking', 'Cold Drinks', 'Fresh Juice', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1483677214', 'admin', '2017-01-06 10:44:30', 'admin-1483669204-1483670670667146', 1, 0, '', NULL, NULL, NULL),
(17168, '2017-01-06 10:44:38', NULL, NULL, 5913, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 10:44:38', 'admin-1483669204-14836706783637190', 1, 1, 'SR', NULL, NULL, NULL),
(17169, '2017-01-06 10:54:18', NULL, NULL, 5914, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 10:54:18', 'admin-1483669204-1483671258717539', 1, 0, '', NULL, NULL, NULL),
(17170, '2017-01-06 10:57:04', NULL, NULL, 5914, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 10:57:04', 'admin-1483669204-14836714241665276', 1, 0, '', NULL, NULL, NULL),
(17171, '2017-01-06 10:54:24', NULL, NULL, 5914, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 10:54:24', 'admin-1483669204-14836712641519646', 1, 1, 'SR', NULL, NULL, NULL),
(17172, '2017-01-06 11:31:22', NULL, NULL, 5915, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 11:31:22', 'admin-1483669204-14836734822268461', 1, 1, 'SR', NULL, NULL, NULL),
(17173, '2017-01-06 11:31:22', NULL, NULL, 5915, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 11:31:22', 'admin-1483669204-14836734822268461', 1, 1, 'SR', NULL, NULL, NULL),
(17174, '2017-01-06 11:31:22', NULL, NULL, 5915, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 11:31:22', 'admin-1483669204-14836734822268461', 1, 0, '', NULL, NULL, NULL),
(17175, '2017-01-06 11:31:22', NULL, NULL, 5915, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 11:31:22', 'admin-1483669204-14836734822268461', 1, 0, '', NULL, NULL, NULL),
(17176, '2017-01-06 11:31:22', NULL, NULL, 5915, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 11:31:22', 'admin-1483669204-14836734822268461', 1, 0, '', NULL, NULL, NULL),
(17177, '2017-01-06 11:31:22', NULL, NULL, 5915, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 11:31:22', 'admin-1483669204-14836734822268461', 1, 0, '', NULL, NULL, NULL),
(17178, '2017-01-06 12:05:53', NULL, NULL, 5916, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 12:05:53', 'admin-1483669204-14836755536886042', 1, 0, '', NULL, NULL, NULL),
(17179, '2017-01-06 12:05:53', NULL, NULL, 5916, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 12:05:53', 'admin-1483669204-14836755536886042', 1, 0, '', NULL, NULL, NULL),
(17180, '2017-01-06 12:05:53', NULL, NULL, 5916, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 12:05:53', 'admin-1483669204-14836755536886042', 1, 0, '', NULL, NULL, NULL),
(17181, '2017-01-06 12:06:17', NULL, NULL, 5916, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 12:06:17', 'admin-1483669204-14836755773334326', 1, 0, '', NULL, NULL, NULL),
(17182, '2017-01-06 15:23:35', NULL, NULL, 5928, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 15:23:35', 'admin-1483677214-14836874152579377', 1, 1, 'SR', NULL, NULL, NULL),
(17183, '2017-01-06 15:25:29', NULL, NULL, 5928, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 15:25:29', 'admin-1483677214-1483687529585615', 1, 0, '', NULL, NULL, NULL),
(17184, '2017-01-06 15:23:47', NULL, NULL, 5928, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 15:23:47', 'admin-1483677214-14836874270412512', 1, 1, 'SR', NULL, NULL, NULL),
(17185, '2017-01-06 15:13:18', NULL, NULL, 5929, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 15:13:18', 'admin-1483677214-14836867982851435', 1, 1, 'SR', NULL, NULL, NULL),
(17186, '2017-01-06 15:13:18', NULL, NULL, 5929, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 15:13:18', 'admin-1483677214-14836867982851435', 1, 0, '', NULL, NULL, NULL),
(17187, '2017-01-06 15:13:18', NULL, NULL, 5929, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 15:13:18', 'admin-1483677214-14836867982851435', 1, 0, '', NULL, NULL, NULL),
(17188, '2017-01-06 15:06:34', NULL, NULL, 5928, 0, 259, '193', 'Coronado Beer Set', '', 'Cold Drinks', 'Soda & Beer', 1, 40.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 15:06:34', 'admin-1483677214-14836863941112562', 1, 0, '', NULL, NULL, NULL),
(17189, '2017-01-06 14:51:44', NULL, NULL, 5927, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 14:51:44', 'admin-1483677214-14836855040373218', 1, 1, 'SR', NULL, NULL, NULL),
(17190, '2017-01-06 14:51:44', NULL, NULL, 5927, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 14:51:44', 'admin-1483677214-14836855040373218', 1, 1, 'SR', NULL, NULL, NULL),
(17191, '2017-01-06 12:28:26', NULL, NULL, 5920, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 12:28:26', 'admin-1483669204-14836769066602234', 1, 0, '', NULL, NULL, NULL),
(17192, '2017-01-06 12:46:34', NULL, NULL, 5920, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 12:46:34', 'admin-1483677214-14836779939653377', 1, 1, 'SR', NULL, NULL, NULL),
(17193, '2017-01-06 12:50:49', NULL, NULL, 5921, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 12:50:49', 'admin-1483677214-14836782496982629', 1, 1, 'SR', NULL, NULL, NULL),
(17194, '2017-01-06 14:47:10', NULL, NULL, 5926, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 14:47:10', 'admin-1483677214-14836852303399643', 1, 1, 'SR', 1, NULL, NULL),
(17195, '2017-01-06 13:29:01', NULL, NULL, 5922, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 13:29:01', 'admin-1483677214-1483680541741421', 1, 1, 'SR', 1, NULL, NULL),
(17196, '2017-01-06 13:29:01', NULL, NULL, 5922, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 13:29:01', 'admin-1483677214-1483680541741421', 1, 1, 'SR', 1, NULL, NULL),
(17197, '2017-01-06 13:35:01', NULL, NULL, 5923, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 13:35:01', 'admin-1483677214-14836809010489717', 1, 0, '', NULL, NULL, NULL),
(17198, '2017-01-06 13:39:10', NULL, NULL, 5920, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 13:39:10', 'admin-1483677214-14836811500725259', 1, 0, '', NULL, NULL, NULL),
(17199, '2017-01-06 14:15:47', NULL, NULL, 5924, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 14:15:47', 'admin-1483677214-14836833468183998', 1, 1, 'SR', NULL, NULL, NULL),
(17200, '2017-01-06 12:54:09', NULL, NULL, 5915, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 12:54:09', 'admin-1483677214-14836784494698467', 1, 0, '', NULL, NULL, NULL),
(17201, '2017-01-06 12:28:26', NULL, NULL, 5920, 0, 214, '148', 'Set Fried Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 12:28:26', 'admin-1483669204-14836769066602234', 1, 0, '', NULL, NULL, NULL),
(17202, '2017-01-06 12:28:26', NULL, NULL, 5920, 0, 82, '82', 'Set Stir Fried Rice Wine Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 12:28:26', 'admin-1483669204-14836769066602234', 1, 1, 'SR', NULL, NULL, NULL),
(17203, '2017-01-06 12:18:44', NULL, NULL, 5919, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 12:18:44', 'admin-1483669204-14836763239389185', 1, 0, '', 1, NULL, NULL),
(17204, '2017-01-06 12:10:14', NULL, NULL, 5918, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 12:10:14', 'admin-1483669204-14836758143613383', 1, 1, 'SR', NULL, NULL, NULL),
(17205, '2017-01-06 12:10:14', NULL, NULL, 5918, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 12:10:14', 'admin-1483669204-14836758143613383', 1, 1, 'SR', NULL, NULL, NULL),
(17206, '2017-01-06 12:09:58', NULL, NULL, 5917, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 12:09:58', 'admin-1483669204-14836757980456460', 1, 1, 'SR', NULL, NULL, NULL),
(17207, '2017-01-06 12:06:28', NULL, NULL, 5916, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 12:06:28', 'admin-1483669204-14836755878153487', 1, 0, '', NULL, NULL, NULL),
(17208, '2017-01-06 12:06:28', NULL, NULL, 5916, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 12:06:28', 'admin-1483669204-14836755878153487', 1, 1, 'SR', NULL, NULL, NULL),
(17209, '2017-01-06 12:06:17', NULL, NULL, 5916, 0, 181, '116', 'Open Food ', 'House pLATTER', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 12:06:17', 'admin-1483669204-14836755773334326', 1, 0, '', NULL, NULL, NULL),
(17210, '2017-01-06 09:42:49', NULL, NULL, 5909, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:42:49', 'admin-1483663548-14836669694072035', 1, 0, '', NULL, NULL, NULL),
(17211, '2017-01-06 09:42:49', NULL, NULL, 5909, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:42:49', 'admin-1483663548-14836669694072035', 1, 1, 'SR', NULL, NULL, NULL),
(17212, '2017-01-06 09:42:49', NULL, NULL, 5909, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:42:49', 'admin-1483663548-14836669694072035', 1, 0, '', NULL, NULL, NULL),
(17213, '2017-01-06 09:45:56', NULL, NULL, 5906, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:45:56', 'admin-1483663548-14836671561366760', 1, 1, 'SR', NULL, NULL, NULL),
(17214, '2017-01-06 09:47:26', NULL, NULL, 5910, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:47:26', 'admin-1483663548-14836672466697930', 1, 0, '', NULL, NULL, NULL),
(17215, '2017-01-06 09:47:26', NULL, NULL, 5910, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:47:26', 'admin-1483663548-14836672466697930', 1, 1, 'SR', NULL, NULL, NULL),
(17216, '2017-01-06 10:18:11', NULL, NULL, 5908, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 10:18:11', 'admin-1483667834-14836690912707434', 1, 0, '', NULL, NULL, NULL),
(17217, '2017-01-06 10:21:23', NULL, NULL, 5911, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 10:21:23', 'admin-1483669204-14836692832705694', 1, 1, 'SR', NULL, NULL, NULL),
(17218, '2017-01-06 09:42:49', NULL, NULL, 5909, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:42:49', 'admin-1483663548-14836669694072035', 1, 0, '', NULL, NULL, NULL),
(17219, '2017-01-06 09:30:02', NULL, NULL, 5907, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:30:02', 'admin-1483663548-14836662028066586', 1, 0, '', NULL, NULL, NULL),
(17220, '2017-01-06 09:30:02', NULL, NULL, 5907, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:30:02', 'admin-1483663548-14836662028066586', 1, 0, '', NULL, NULL, NULL),
(17221, '2017-01-06 09:38:46', NULL, NULL, 5907, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:38:46', 'admin-1483663548-14836667260337768', 1, 0, '', NULL, NULL, NULL),
(17222, '2017-01-06 09:38:46', NULL, NULL, 5907, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:38:46', 'admin-1483663548-14836667260337768', 1, 0, '', NULL, NULL, NULL),
(17223, '2017-01-06 09:38:46', NULL, NULL, 5907, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:38:46', 'admin-1483663548-14836667260337768', 1, 0, '', NULL, NULL, NULL),
(17224, '2017-01-06 09:38:46', NULL, NULL, 5907, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:38:46', 'admin-1483663548-14836667260337768', 1, 0, '', NULL, NULL, NULL),
(17225, '2017-01-06 09:38:46', NULL, NULL, 5907, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:38:46', 'admin-1483663548-14836667260337768', 1, 0, '', NULL, NULL, NULL),
(17226, '2017-01-06 09:38:46', NULL, NULL, 5907, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:38:46', 'admin-1483663548-14836667260337768', 1, 1, 'SR', NULL, NULL, NULL),
(17227, '2017-01-06 09:38:46', NULL, NULL, 5907, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:38:46', 'admin-1483663548-14836667260337768', 1, 1, 'SR', NULL, NULL, NULL),
(17228, '2017-01-06 09:38:27', NULL, NULL, 5908, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:38:27', 'admin-1483663548-14836667071915167', 1, 1, 'SR', NULL, NULL, NULL),
(17229, '2017-01-06 09:38:27', NULL, NULL, 5908, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:38:27', 'admin-1483663548-14836667071915167', 1, 0, '', NULL, NULL, NULL),
(17230, '2017-01-06 09:38:27', NULL, NULL, 5908, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:38:27', 'admin-1483663548-14836667071915167', 1, 0, '', NULL, NULL, NULL),
(17231, '2017-01-06 09:30:16', NULL, NULL, 5907, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:30:16', 'admin-1483663548-14836662159478724', 1, 1, 'SR', NULL, NULL, NULL),
(17232, '2017-01-06 09:30:16', NULL, NULL, 5907, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:30:16', 'admin-1483663548-14836662159478724', 1, 1, 'SR', NULL, NULL, NULL),
(17233, '2017-01-06 09:30:16', NULL, NULL, 5907, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:30:16', 'admin-1483663548-14836662159478724', 1, 1, 'SR', NULL, NULL, NULL),
(17234, '2017-01-06 09:30:16', NULL, NULL, 5907, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:30:16', 'admin-1483663548-14836662159478724', 1, 1, 'SR', NULL, NULL, NULL),
(17235, '2017-01-06 09:30:02', NULL, NULL, 5907, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:30:02', 'admin-1483663548-14836662028066586', 1, 0, '', NULL, NULL, NULL),
(17236, '2017-01-06 09:30:02', NULL, NULL, 5907, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:30:02', 'admin-1483663548-14836662028066586', 1, 0, '', NULL, NULL, NULL),
(17237, '2017-01-06 09:20:08', NULL, NULL, 5906, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:20:08', 'admin-1483663548-14836656086348979', 1, 1, 'SR', NULL, NULL, NULL),
(17238, '2017-01-06 09:20:08', NULL, NULL, 5906, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:20:08', 'admin-1483663548-14836656086348979', 1, 0, '', NULL, NULL, NULL),
(17239, '2017-01-06 09:20:08', NULL, NULL, 5906, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483677214', 'admin', '2017-01-06 09:20:08', 'admin-1483663548-14836656086348979', 1, 0, '', NULL, NULL, NULL),
(17240, '2017-01-07 19:58:01', NULL, NULL, 5964, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 19:58:01', 'admin-1483757539-14837902812193774', 1, 0, '', NULL, NULL, NULL),
(17241, '2017-01-07 19:58:01', NULL, NULL, 5964, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1483792488', 'admin', '2017-01-07 19:58:01', 'admin-1483757539-14837902812193774', 1, 0, '', NULL, NULL, NULL),
(17242, '2017-01-07 20:43:14', NULL, NULL, 5964, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 20:43:14', 'admin-1483792488-14837929945331137', 1, 1, 'SR', NULL, NULL, NULL),
(17243, '2017-01-07 20:43:14', NULL, NULL, 5964, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 20:43:14', 'admin-1483792488-14837929945331137', 1, 1, 'SR', NULL, NULL, NULL),
(17244, '2017-01-07 21:22:07', NULL, NULL, 5965, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 21:22:07', 'admin-1483792488-14837953273785858', 1, 1, 'SR', 1, NULL, NULL),
(17245, '2017-01-07 16:33:05', NULL, NULL, 5958, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 16:33:05', 'admin-1483757539-14837779853286721', 1, 1, 'SR', NULL, NULL, NULL),
(17246, '2017-01-07 16:34:04', NULL, NULL, 5959, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 16:34:04', 'admin-1483757539-14837780445512818', 1, 1, 'SR', NULL, NULL, NULL),
(17247, '2017-01-07 16:34:04', NULL, NULL, 5959, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 16:34:04', 'admin-1483757539-14837780445512818', 1, 0, '', NULL, NULL, NULL),
(17248, '2017-01-07 16:58:09', NULL, NULL, 5960, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 16:58:09', 'admin-1483757539-1483779488952945', 1, 1, 'SR', NULL, NULL, NULL),
(17249, '2017-01-07 16:58:09', NULL, NULL, 5960, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 16:58:09', 'admin-1483757539-1483779488952945', 1, 1, 'SR', NULL, NULL, NULL),
(17250, '2017-01-07 16:58:24', NULL, NULL, 5957, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 16:58:24', 'admin-1483757539-14837795043545696', 1, 0, '', NULL, NULL, NULL),
(17251, '2017-01-07 17:18:48', NULL, NULL, 5962, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 17:18:48', 'admin-1483757539-1483780728053719', 1, 0, '', 1, NULL, NULL),
(17252, '2017-01-07 18:37:12', NULL, NULL, 5963, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 18:37:12', 'admin-1483757539-14837854319918222', 1, 0, '', NULL, NULL, '10.0'),
(17253, '2017-01-07 18:37:12', NULL, NULL, 5963, 0, 261, '195', 'Marble Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 18:37:12', 'admin-1483757539-14837854319918222', 1, 0, '', NULL, NULL, '10.0'),
(17254, '2017-01-07 14:21:34', NULL, NULL, 5952, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 14:21:34', 'admin-1483757539-14837700947337477', 1, 0, '', NULL, NULL, NULL),
(17255, '2017-01-07 14:21:34', NULL, NULL, 5952, 0, 181, '116', 'Open Food ', 'house platter', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 14:21:35', 'admin-1483757539-14837700947337477', 1, 0, '', NULL, NULL, NULL),
(17256, '2017-01-07 14:50:45', NULL, NULL, 5952, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 14:50:45', 'admin-1483757539-14837718455262226', 1, 1, 'SR', NULL, NULL, NULL),
(17257, '2017-01-07 14:56:26', NULL, NULL, 5953, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 14:56:26', 'admin-1483757539-14837721858285954', 1, 1, 'SR', NULL, NULL, NULL),
(17258, '2017-01-07 14:56:26', NULL, NULL, 5953, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 14:56:26', 'admin-1483757539-14837721858285954', 1, 1, 'SR', NULL, NULL, NULL),
(17259, '2017-01-07 14:56:26', NULL, NULL, 5953, 0, 261, '195', 'Marble Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 14:56:26', 'admin-1483757539-14837721858285954', 1, 0, '', NULL, NULL, NULL),
(17260, '2017-01-07 15:11:09', NULL, NULL, 5952, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 15:11:09', 'admin-1483757539-14837730692672740', 1, 0, '', NULL, NULL, NULL),
(17261, '2017-01-07 15:44:13', NULL, NULL, 5954, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 15:44:13', 'admin-1483757539-14837750532845059', 1, 1, 'SR', NULL, NULL, NULL),
(17262, '2017-01-07 15:44:13', NULL, NULL, 5954, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 15:44:13', 'admin-1483757539-14837750532845059', 1, 1, 'SR', NULL, NULL, NULL),
(17263, '2017-01-07 15:44:13', NULL, NULL, 5954, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 15:44:13', 'admin-1483757539-14837750532845059', 1, 0, '', NULL, NULL, NULL),
(17264, '2017-01-07 15:44:13', NULL, NULL, 5954, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 15:44:13', 'admin-1483757539-14837750532845059', 1, 1, 'SR', NULL, NULL, NULL),
(17265, '2017-01-07 19:58:01', NULL, NULL, 5964, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 19:58:01', 'admin-1483757539-14837902812193774', 1, 0, '', NULL, NULL, NULL),
(17266, '2017-01-07 10:56:57', NULL, NULL, 5941, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:56:57', 'admin-1483757539-14837578170563712', 1, 1, 'SR', NULL, NULL, NULL),
(17267, '2017-01-07 10:59:57', NULL, NULL, 5943, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:59:57', 'admin-1483757539-14837579969121264', 1, 0, '', NULL, NULL, NULL),
(17268, '2017-01-07 10:59:57', NULL, NULL, 5943, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:59:57', 'admin-1483757539-14837579969121264', 1, 0, '', NULL, NULL, NULL),
(17269, '2017-01-07 10:59:57', NULL, NULL, 5943, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:59:57', 'admin-1483757539-14837579969121264', 1, 0, '', NULL, NULL, NULL),
(17270, '2017-01-07 11:00:20', NULL, NULL, 5943, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 11:00:20', 'admin-1483757539-14837580202422787', 1, 1, 'SR', NULL, NULL, NULL),
(17271, '2017-01-07 11:00:20', NULL, NULL, 5943, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 11:00:20', 'admin-1483757539-14837580202422787', 1, 1, 'SR', NULL, NULL, NULL),
(17272, '2017-01-07 11:12:53', NULL, NULL, 5944, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 11:12:53', 'admin-1483757539-14837587733693322', 1, 1, 'SR', NULL, NULL, NULL),
(17273, '2017-01-07 11:12:53', NULL, NULL, 5944, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 11:12:53', 'admin-1483757539-14837587733693322', 1, 1, 'SR', NULL, NULL, NULL),
(17274, '2017-01-07 11:59:34', NULL, NULL, 5945, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 11:59:34', 'admin-1483757539-14837615742103314', 1, 1, 'SR', NULL, NULL, NULL),
(17275, '2017-01-07 11:59:34', NULL, NULL, 5945, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 11:59:34', 'admin-1483757539-14837615742103314', 1, 1, 'SR', NULL, NULL, NULL),
(17276, '2017-01-07 12:01:06', NULL, NULL, 5945, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 12:01:06', 'admin-1483757539-14837616667368065', 1, 1, 'SR', NULL, NULL, NULL),
(17277, '2017-01-07 12:07:22', NULL, NULL, 5946, 0, 154, '88', 'House BLT', 'egg well done', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 12:07:22', 'admin-1483757539-14837620421015448', 1, 0, '', NULL, NULL, NULL),
(17278, '2017-01-07 12:07:41', NULL, NULL, 5946, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 12:07:41', 'admin-1483757539-14837620610862175', 1, 1, 'SR', NULL, NULL, NULL),
(17279, '2017-01-07 12:07:41', NULL, NULL, 5946, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 12:07:41', 'admin-1483757539-14837620610862175', 1, 0, '', NULL, NULL, NULL),
(17280, '2017-01-07 12:49:38', NULL, NULL, 5946, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 12:49:39', 'admin-1483757539-14837645787784816', 1, 1, 'SR', NULL, NULL, NULL),
(17281, '2017-01-07 13:15:13', NULL, NULL, 5947, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 13:15:13', 'admin-1483757539-14837661135152543', 1, 1, 'SR', NULL, NULL, NULL),
(17282, '2017-01-07 13:15:13', NULL, NULL, 5947, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 13:15:13', 'admin-1483757539-14837661135152543', 1, 1, 'SR', NULL, NULL, NULL),
(17283, '2017-01-07 19:58:01', NULL, NULL, 5964, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 19:58:01', 'admin-1483757539-14837902812193774', 1, 0, '', NULL, NULL, NULL),
(17284, '2017-01-07 16:09:29', NULL, NULL, 5956, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 16:09:29', 'admin-1483757539-1483776569513484', 1, 1, 'SR', NULL, NULL, NULL),
(17285, '2017-01-07 16:09:29', NULL, NULL, 5956, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 16:09:29', 'admin-1483757539-1483776569513484', 1, 1, 'SR', NULL, NULL, NULL),
(17286, '2017-01-07 16:33:05', NULL, NULL, 5958, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 16:33:05', 'admin-1483757539-14837779853286721', 1, 1, 'SR', NULL, NULL, NULL),
(17287, '2017-01-07 16:33:05', NULL, NULL, 5958, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 16:33:05', 'admin-1483757539-14837779853286721', 1, 1, 'SR', NULL, NULL, NULL),
(17288, '2017-01-07 16:05:56', NULL, NULL, 5955, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 16:05:56', 'admin-1483757539-14837763566089168', 1, 0, '', NULL, NULL, NULL),
(17289, '2017-01-07 15:46:34', NULL, NULL, 5954, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 15:46:34', 'admin-1483757539-14837751939136526', 1, 0, '', NULL, NULL, NULL),
(17290, '2017-01-07 14:07:00', NULL, NULL, 5951, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 14:07:00', 'admin-1483757539-14837692201378697', 1, 1, 'SR', NULL, NULL, NULL),
(17291, '2017-01-07 14:13:30', NULL, NULL, 5951, 0, 261, '195', 'Marble Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 14:13:30', 'admin-1483757539-14837696106318416', 1, 0, '', NULL, NULL, NULL),
(17292, '2017-01-07 14:20:17', NULL, NULL, 5952, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 14:20:18', 'admin-1483757539-1483770017812248', 1, 0, '', NULL, NULL, NULL),
(17293, '2017-01-07 13:46:25', NULL, NULL, 5950, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 13:46:25', 'admin-1483757539-14837679848741098', 1, 0, '', NULL, NULL, NULL),
(17294, '2017-01-07 13:46:25', NULL, NULL, 5950, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 13:46:25', 'admin-1483757539-14837679848741098', 1, 0, '', NULL, NULL, NULL),
(17295, '2017-01-07 13:46:25', NULL, NULL, 5950, 0, 217, '151', 'Spicy Lemony Wings', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 13:46:25', 'admin-1483757539-14837679848741098', 1, 0, '', NULL, NULL, NULL),
(17296, '2017-01-07 14:20:18', NULL, NULL, 5952, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 14:20:18', 'admin-1483757539-1483770017812248', 1, 1, 'SR', NULL, NULL, NULL),
(17297, '2017-01-07 13:47:29', NULL, NULL, 5950, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 13:47:29', 'admin-1483757539-1483768049155494', 1, 1, 'SR', NULL, NULL, NULL),
(17298, '2017-01-07 13:47:29', NULL, NULL, 5950, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 13:47:29', 'admin-1483757539-1483768049155494', 1, 1, 'SR', NULL, NULL, NULL),
(17299, '2017-01-07 13:48:27', NULL, NULL, 5949, 0, 181, '116', 'Open Food ', 'house platter', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 13:48:27', 'admin-1483757539-14837681070434076', 1, 0, '', NULL, NULL, NULL),
(17300, '2017-01-07 13:48:44', NULL, NULL, 5949, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 13:48:44', 'admin-1483757539-14837681247198457', 1, 0, '', NULL, NULL, NULL),
(17301, '2017-01-07 20:59:18', NULL, NULL, 5964, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 20:59:18', 'admin-1483792488-14837939577833051', 1, 0, '', NULL, NULL, NULL),
(17302, '2017-01-07 21:22:07', NULL, NULL, 5965, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 21:22:07', 'admin-1483792488-14837953273785858', 1, 1, 'SR', 1, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(17303, '2017-01-07 14:06:49', NULL, NULL, 5951, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 14:06:49', 'admin-1483757539-14837692095582776', 1, 1, 'SR', NULL, NULL, NULL),
(17304, '2017-01-07 13:45:16', NULL, NULL, 5949, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 13:45:16', 'admin-1483757539-14837679158675531', 1, 0, '', NULL, NULL, NULL),
(17305, '2017-01-07 13:20:56', NULL, NULL, 5948, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 13:20:56', 'admin-1483757539-14837664559435729', 1, 0, '', NULL, NULL, NULL),
(17306, '2017-01-07 13:20:56', NULL, NULL, 5948, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 13:20:56', 'admin-1483757539-14837664559435729', 1, 0, '', NULL, NULL, NULL),
(17307, '2017-01-07 09:37:36', NULL, NULL, 5938, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 09:37:36', 'admin-1483749998-14837530565031150', 1, 1, 'SR', NULL, NULL, NULL),
(17308, '2017-01-07 09:37:36', NULL, NULL, 5938, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 09:37:36', 'admin-1483749998-14837530565031150', 1, 0, '', NULL, NULL, NULL),
(17309, '2017-01-07 09:37:36', NULL, NULL, 5938, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 09:37:36', 'admin-1483749998-14837530565031150', 1, 0, '', NULL, NULL, NULL),
(17310, '2017-01-07 09:42:18', NULL, NULL, 5939, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 09:42:18', 'admin-1483749998-14837533383453925', 1, 1, 'SR', NULL, NULL, NULL),
(17311, '2017-01-07 09:45:24', NULL, NULL, 5939, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 09:45:24', 'admin-1483749998-14837535239285826', 1, 0, '', NULL, NULL, NULL),
(17312, '2017-01-07 09:53:43', NULL, NULL, 5937, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 09:53:43', 'admin-1483749998-14837540231459594', 1, 1, 'SR', NULL, NULL, NULL),
(17313, '2017-01-07 09:53:43', NULL, NULL, 5937, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 09:53:43', 'admin-1483749998-14837540231459594', 1, 1, 'SR', NULL, NULL, NULL),
(17314, '2017-01-07 09:53:43', NULL, NULL, 5937, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 09:53:43', 'admin-1483749998-14837540231459594', 1, 1, 'SR', NULL, NULL, NULL),
(17315, '2017-01-07 10:51:04', NULL, NULL, 5941, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:51:04', 'admin-1483749998-14837574642498426', 1, 1, 'SR', NULL, NULL, NULL),
(17316, '2017-01-07 10:16:25', NULL, NULL, 5940, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:16:25', 'admin-1483749998-14837553855477840', 1, 0, '', NULL, NULL, NULL),
(17317, '2017-01-07 10:16:25', NULL, NULL, 5940, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:16:25', 'admin-1483749998-14837553855477840', 1, 0, '', NULL, NULL, NULL),
(17318, '2017-01-07 10:17:11', NULL, NULL, 5940, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:17:11', 'admin-1483749998-14837554312251996', 1, 1, 'SR', NULL, NULL, NULL),
(17319, '2017-01-07 10:17:11', NULL, NULL, 5940, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:17:11', 'admin-1483749998-14837554312251996', 1, 1, 'SR', NULL, NULL, NULL),
(17320, '2017-01-07 10:17:11', NULL, NULL, 5940, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:17:11', 'admin-1483749998-14837554312251996', 1, 1, 'SR', NULL, NULL, NULL),
(17321, '2017-01-07 10:51:04', NULL, NULL, 5941, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:51:04', 'admin-1483749998-14837574642498426', 1, 1, 'SR', NULL, NULL, NULL),
(17322, '2017-01-07 10:51:04', NULL, NULL, 5941, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:51:04', 'admin-1483749998-14837574642498426', 1, 1, 'SR', NULL, NULL, NULL),
(17323, '2017-01-07 10:51:48', NULL, NULL, 5942, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:51:48', 'admin-1483749998-14837575085523448', 1, 0, '', NULL, NULL, NULL),
(17324, '2017-01-07 10:51:48', NULL, NULL, 5942, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:51:48', 'admin-1483749998-14837575085523448', 1, 0, '', NULL, NULL, NULL),
(17325, '2017-01-07 10:51:48', NULL, NULL, 5942, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:51:48', 'admin-1483749998-14837575085523448', 1, 0, '', NULL, NULL, NULL),
(17326, '2017-01-07 10:53:28', NULL, NULL, 5942, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:53:28', 'admin-1483757539-14837576077804455', 1, 0, '', NULL, NULL, NULL),
(17327, '2017-01-07 10:53:28', NULL, NULL, 5942, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:53:28', 'admin-1483757539-14837576077804455', 1, 1, 'SR', NULL, NULL, NULL),
(17328, '2017-01-07 10:53:28', NULL, NULL, 5942, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:53:28', 'admin-1483757539-14837576077804455', 1, 1, 'SR', NULL, NULL, NULL),
(17329, '2017-01-07 10:53:28', NULL, NULL, 5942, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:53:28', 'admin-1483757539-14837576077804455', 1, 1, 'SR', NULL, NULL, NULL),
(17330, '2017-01-07 10:53:28', NULL, NULL, 5942, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:53:28', 'admin-1483757539-14837576077804455', 1, 1, 'SR', NULL, NULL, NULL),
(17331, '2017-01-07 10:56:57', NULL, NULL, 5941, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:56:57', 'admin-1483757539-14837578170563712', 1, 0, '', NULL, NULL, NULL),
(17332, '2017-01-07 10:56:57', NULL, NULL, 5941, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:56:57', 'admin-1483757539-14837578170563712', 1, 0, '', NULL, NULL, NULL),
(17333, '2017-01-07 10:56:57', NULL, NULL, 5941, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:56:57', 'admin-1483757539-14837578170563712', 1, 0, '', NULL, NULL, NULL),
(17334, '2017-01-07 10:56:57', NULL, NULL, 5941, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:56:57', 'admin-1483757539-14837578170563712', 1, 0, '', NULL, NULL, NULL),
(17335, '2017-01-07 10:16:25', NULL, NULL, 5940, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 10:16:25', 'admin-1483749998-14837553855477840', 1, 0, '', NULL, NULL, NULL),
(17336, '2017-01-07 09:37:36', NULL, NULL, 5938, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 09:37:36', 'admin-1483749998-14837530565031150', 1, 1, 'SR', NULL, NULL, NULL),
(17337, '2017-01-07 09:15:37', NULL, NULL, 5937, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 09:15:37', 'admin-1483749998-1483751736906428', 1, 1, 'SR', NULL, NULL, NULL),
(17338, '2017-01-07 09:15:37', NULL, NULL, 5937, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 09:15:37', 'admin-1483749998-1483751736906428', 1, 1, 'SR', NULL, NULL, NULL),
(17339, '2017-01-07 09:15:37', NULL, NULL, 5937, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 09:15:37', 'admin-1483749998-1483751736906428', 1, 1, 'SR', NULL, NULL, NULL),
(17340, '2017-01-07 09:15:11', NULL, NULL, 5937, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 09:15:11', 'admin-1483749998-148375171158117', 1, 0, '', NULL, NULL, NULL),
(17341, '2017-01-07 09:15:37', NULL, NULL, 5937, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 09:15:37', 'admin-1483749998-1483751736906428', 1, 1, 'SR', NULL, NULL, NULL),
(17342, '2017-01-07 09:15:11', NULL, NULL, 5937, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 09:15:11', 'admin-1483749998-148375171158117', 1, 0, '', NULL, NULL, NULL),
(17343, '2017-01-07 09:15:11', NULL, NULL, 5937, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 09:15:11', 'admin-1483749998-148375171158117', 1, 0, '', NULL, NULL, NULL),
(17344, '2017-01-07 09:15:11', NULL, NULL, 5937, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483792488', 'admin', '2017-01-07 09:15:11', 'admin-1483749998-148375171158117', 1, 0, '', NULL, NULL, NULL),
(17345, '2017-01-08 20:04:00', NULL, NULL, 6017, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 20:04:00', 'admin-1483861285-14838770405702776', 1, 0, '', NULL, NULL, NULL),
(17346, '2017-01-08 20:04:00', NULL, NULL, 6017, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 20:04:00', 'admin-1483861285-14838770405702776', 1, 0, '', NULL, NULL, NULL),
(17347, '2017-01-08 20:04:00', NULL, NULL, 6017, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 20:04:00', 'admin-1483861285-14838770405702776', 1, 1, 'SR', NULL, NULL, NULL),
(17348, '2017-01-08 20:11:02', NULL, NULL, 6018, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 20:11:02', 'admin-1483861285-1483877461931797', 1, 0, '', NULL, NULL, NULL),
(17349, '2017-01-08 20:11:02', NULL, NULL, 6018, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 20:11:02', 'admin-1483861285-1483877461931797', 1, 0, '', NULL, NULL, NULL),
(17350, '2017-01-08 20:11:02', NULL, NULL, 6018, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 20:11:02', 'admin-1483861285-1483877461931797', 1, 0, '', NULL, NULL, NULL),
(17351, '2017-01-08 20:11:02', NULL, NULL, 6018, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 20:11:02', 'admin-1483861285-1483877461931797', 1, 0, '', NULL, NULL, NULL),
(17352, '2017-01-08 20:44:22', NULL, NULL, 6019, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 20:44:22', 'admin-1483877732-1483879462432778', 1, 1, 'SR', NULL, NULL, NULL),
(17353, '2017-01-08 20:44:22', NULL, NULL, 6019, 0, 181, '116', 'Open Food ', 'FRIED EGG', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1483877732', 'admin', '2017-01-08 20:44:22', 'admin-1483877732-1483879462432778', 1, 0, '', NULL, NULL, NULL),
(17354, '2017-01-08 20:44:22', NULL, NULL, 6019, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 20:44:22', 'admin-1483877732-1483879462432778', 1, 0, '', NULL, NULL, NULL),
(17355, '2017-01-08 20:49:39', NULL, NULL, 6020, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 20:49:39', 'admin-1483877732-148387977944867', 1, 1, 'SR', NULL, NULL, NULL),
(17356, '2017-01-08 21:07:20', NULL, NULL, 6020, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 21:07:20', 'admin-1483877732-14838808405174486', 1, 0, '', NULL, NULL, NULL),
(17357, '2017-01-08 20:50:36', NULL, NULL, 6020, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 20:50:36', 'admin-1483877732-14838798363801228', 1, 1, 'SR', NULL, NULL, NULL),
(17358, '2017-01-08 20:04:00', NULL, NULL, 6017, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 20:04:00', 'admin-1483861285-14838770405702776', 1, 1, 'SR', NULL, NULL, NULL),
(17359, '2017-01-08 19:49:22', NULL, NULL, 6016, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 19:49:22', 'admin-1483861285-14838761621703471', 1, 0, '', NULL, NULL, NULL),
(17360, '2017-01-08 18:40:19', NULL, NULL, 6014, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 18:40:19', 'admin-1483861285-14838720196975285', 1, 1, 'SR', NULL, NULL, NULL),
(17361, '2017-01-08 19:13:21', NULL, NULL, 6015, 0, 261, '195', 'Marble Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 19:13:21', 'admin-1483861285-14838740008069949', 1, 0, '', NULL, NULL, NULL),
(17362, '2017-01-08 19:13:21', NULL, NULL, 6015, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 19:13:21', 'admin-1483861285-14838740008069949', 1, 1, 'SR', NULL, NULL, NULL),
(17363, '2017-01-08 19:32:16', NULL, NULL, 6013, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 19:32:16', 'admin-1483861285-1483875136240420', 1, 0, '', NULL, NULL, NULL),
(17364, '2017-01-08 19:49:22', NULL, NULL, 6016, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 19:49:22', 'admin-1483861285-14838761621703471', 1, 0, '', NULL, NULL, NULL),
(17365, '2017-01-08 18:20:57', NULL, NULL, 6013, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 18:20:57', 'admin-1483861285-1483870857571626', 1, 0, '', NULL, NULL, NULL),
(17366, '2017-01-08 18:35:48', NULL, NULL, 6013, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 18:35:48', 'admin-1483861285-14838717483163169', 1, 0, '', NULL, NULL, NULL),
(17367, '2017-01-08 18:40:19', NULL, NULL, 6014, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 18:40:19', 'admin-1483861285-14838720196975285', 1, 1, 'SR', NULL, NULL, NULL),
(17368, '2017-01-08 18:40:19', NULL, NULL, 6014, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 18:40:19', 'admin-1483861285-14838720196975285', 1, 0, '', NULL, NULL, NULL),
(17369, '2017-01-08 18:20:57', NULL, NULL, 6013, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 18:20:57', 'admin-1483861285-1483870857571626', 1, 0, '', NULL, NULL, NULL),
(17370, '2017-01-08 18:20:57', NULL, NULL, 6013, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 18:20:57', 'admin-1483861285-1483870857571626', 1, 0, '', NULL, NULL, NULL),
(17371, '2017-01-08 13:33:00', NULL, NULL, 5997, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 13:33:00', 'admin-1483850176-14838535801545663', 1, 1, 'SR', NULL, NULL, NULL),
(17372, '2017-01-08 13:17:16', NULL, NULL, 5996, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 13:17:16', 'admin-1483850176-1483852636604865', 1, 1, 'SR', NULL, NULL, NULL),
(17373, '2017-01-08 13:17:16', NULL, NULL, 5996, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 13:17:16', 'admin-1483850176-1483852636604865', 1, 1, 'SR', NULL, NULL, NULL),
(17374, '2017-01-08 13:16:46', NULL, NULL, 5996, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 13:16:46', 'admin-1483850176-14838526062331172', 1, 0, '', NULL, NULL, NULL),
(17375, '2017-01-08 13:16:46', NULL, NULL, 5996, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 13:16:46', 'admin-1483850176-14838526062331172', 1, 0, '', NULL, NULL, NULL),
(17376, '2017-01-08 13:16:46', NULL, NULL, 5996, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 13:16:46', 'admin-1483850176-14838526062331172', 1, 1, 'SR', NULL, NULL, NULL),
(17377, '2017-01-08 13:16:46', NULL, NULL, 5996, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 13:16:46', 'admin-1483850176-14838526062331172', 1, 0, '', NULL, NULL, NULL),
(17378, '2017-01-08 13:11:12', NULL, NULL, 5995, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 13:11:12', 'admin-1483850176-1483852272018509', 1, 1, 'SR', NULL, NULL, NULL),
(17379, '2017-01-08 13:11:12', NULL, NULL, 5995, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 13:11:12', 'admin-1483850176-1483852272018509', 1, 1, 'SR', NULL, NULL, NULL),
(17380, '2017-01-08 00:00:00', NULL, NULL, 5993, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 11:51:09', 'admin-1483846564-14838474692447610', 1, 1, 'SR', NULL, NULL, NULL),
(17381, '2017-01-08 13:06:26', NULL, NULL, 5989, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 13:06:26', 'admin-1483850176-14838519866822383', 1, 0, '', NULL, NULL, NULL),
(17382, '2017-01-08 12:51:16', NULL, NULL, 5992, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:51:16', 'admin-1483850176-14838510765293557', 1, 0, '', NULL, NULL, NULL),
(17383, '2017-01-08 12:51:16', NULL, NULL, 5992, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:51:16', 'admin-1483850176-14838510765293557', 1, 1, 'SR', NULL, NULL, NULL),
(17384, '2017-01-08 12:51:16', NULL, NULL, 5992, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:51:16', 'admin-1483850176-14838510765293557', 1, 1, 'SR', NULL, NULL, NULL),
(17385, '2017-01-08 12:51:16', NULL, NULL, 5992, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:51:16', 'admin-1483850176-14838510765293557', 1, 1, 'SR', NULL, NULL, NULL),
(17386, '2017-01-08 17:36:03', NULL, NULL, 6010, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 17:36:03', 'admin-1483861285-14838681627994754', 1, 0, '', NULL, NULL, NULL),
(17387, '2017-01-08 17:36:03', NULL, NULL, 6010, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 17:36:03', 'admin-1483861285-14838681627994754', 1, 1, 'SR', NULL, NULL, NULL),
(17388, '2017-01-08 17:36:03', NULL, NULL, 6010, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 17:36:03', 'admin-1483861285-14838681627994754', 1, 1, 'SR', NULL, NULL, NULL),
(17389, '2017-01-08 12:36:35', NULL, NULL, 5991, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:36:35', 'admin-1483850176-14838501951011785', 1, 1, 'SR', NULL, NULL, NULL),
(17390, '2017-01-08 12:11:41', NULL, NULL, 5990, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:11:41', 'admin-1483846564-1483848701595891', 1, 1, 'SR', NULL, NULL, NULL),
(17391, '2017-01-08 12:11:41', NULL, NULL, 5990, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:11:41', 'admin-1483846564-1483848701595891', 1, 0, '', NULL, NULL, NULL),
(17392, '2017-01-08 12:11:41', NULL, NULL, 5990, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:11:41', 'admin-1483846564-1483848701595891', 1, 0, '', NULL, NULL, NULL),
(17393, '2017-01-08 12:26:12', NULL, NULL, 5972, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:26:12', 'admin-1483846564-14838495724161218', 1, 0, '', NULL, NULL, NULL),
(17394, '2017-01-08 17:31:40', NULL, NULL, 6009, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 17:31:40', 'admin-1483861285-1483867900262319', 1, 1, 'SR', NULL, NULL, NULL),
(17395, '2017-01-08 17:36:03', NULL, NULL, 6010, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 17:36:03', 'admin-1483861285-14838681627994754', 1, 0, '', NULL, NULL, NULL),
(17396, '2017-01-08 14:58:13', NULL, NULL, 6001, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 14:58:13', 'admin-1483854060-14838586929656470', 1, 1, 'SR', NULL, NULL, NULL),
(17397, '2017-01-08 14:59:13', NULL, NULL, 6001, 0, 261, '195', 'Marble Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 14:59:13', 'admin-1483854060-14838587531192685', 1, 0, '', NULL, NULL, NULL),
(17398, '2017-01-08 15:41:18', NULL, NULL, 6003, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 15:41:18', 'admin-1483854060-1483861278767944', 1, 1, 'SR', NULL, NULL, NULL),
(17399, '2017-01-08 15:41:18', NULL, NULL, 6003, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 15:41:18', 'admin-1483854060-1483861278767944', 1, 0, '', NULL, NULL, NULL),
(17400, '2017-01-08 16:16:11', NULL, NULL, 6004, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 16:16:11', 'admin-1483861285-14838633714253994', 1, 1, 'SR', NULL, NULL, NULL),
(17401, '2017-01-08 16:30:14', NULL, NULL, 6005, 0, 259, '193', 'Coronado Beer Set', '', 'Cold Drinks', 'Soda & Beer', 1, 40.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 16:30:14', 'admin-1483861285-1483864214789260', 1, 0, '', NULL, NULL, NULL),
(17402, '2017-01-08 16:35:24', NULL, NULL, 6006, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 16:35:24', 'admin-1483861285-14838645238747667', 1, 1, 'SR', 1, NULL, NULL),
(17403, '2017-01-08 16:53:47', NULL, NULL, 6007, 0, 259, '193', 'Coronado Beer Set', '', 'Cold Drinks', 'Soda & Beer', 1, 40.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 16:53:47', 'admin-1483861285-14838656272254158', 1, 0, '', 1, NULL, NULL),
(17404, '2017-01-08 17:26:10', NULL, NULL, 6008, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 17:26:10', 'admin-1483861285-14838675701394051', 1, 1, 'SR', NULL, NULL, NULL),
(17405, '2017-01-08 12:36:35', NULL, NULL, 5991, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:36:35', 'admin-1483850176-14838501951011785', 1, 1, 'SR', NULL, NULL, NULL),
(17406, '2017-01-08 12:36:35', NULL, NULL, 5991, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:36:35', 'admin-1483850176-14838501951011785', 1, 0, '', NULL, NULL, NULL),
(17407, '2017-01-08 18:20:57', NULL, NULL, 6013, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 18:20:57', 'admin-1483861285-1483870857571626', 1, 1, 'SR', NULL, NULL, NULL),
(17408, '2017-01-08 17:57:34', NULL, NULL, 6012, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 17:57:34', 'admin-1483861285-14838694539545084', 1, 0, '', NULL, NULL, NULL),
(17409, '2017-01-08 18:20:57', NULL, NULL, 6013, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 18:20:57', 'admin-1483861285-1483870857571626', 1, 1, 'SR', NULL, NULL, NULL),
(17410, '2017-01-08 17:57:34', NULL, NULL, 6012, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 17:57:34', 'admin-1483861285-14838694539545084', 1, 1, 'SR', NULL, NULL, NULL),
(17411, '2017-01-08 17:48:22', NULL, NULL, 6011, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 17:48:22', 'admin-1483861285-14838689024773374', 1, 1, 'SR', NULL, NULL, NULL),
(17412, '2017-01-08 17:36:35', NULL, NULL, 6010, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 17:36:35', 'admin-1483861285-14838681952854867', 1, 0, '', NULL, NULL, NULL),
(17413, '2017-01-08 17:36:03', NULL, NULL, 6010, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 17:36:03', 'admin-1483861285-14838681627994754', 1, 0, '', NULL, NULL, NULL),
(17414, '2017-01-08 17:31:40', NULL, NULL, 6009, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 17:31:40', 'admin-1483861285-1483867900262319', 1, 0, '', NULL, NULL, NULL),
(17415, '2017-01-08 12:36:35', NULL, NULL, 5991, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:36:35', 'admin-1483850176-14838501951011785', 1, 1, 'SR', NULL, NULL, NULL),
(17416, '2017-01-08 15:31:26', NULL, NULL, 6002, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 15:31:26', 'admin-1483854060-14838606858765931', 1, 1, 'SR', 1, NULL, NULL),
(17417, '2017-01-08 14:47:49', NULL, NULL, 6000, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 14:47:49', 'admin-1483854060-14838580689253457', 1, 1, 'SR', NULL, NULL, NULL),
(17418, '2017-01-08 13:57:46', NULL, NULL, 5992, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 13:57:46', 'admin-1483854060-14838550659608611', 1, 0, '', NULL, NULL, NULL),
(17419, '2017-01-08 14:47:49', NULL, NULL, 6000, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 14:47:49', 'admin-1483854060-14838580689253457', 1, 0, '', NULL, NULL, NULL),
(17420, '2017-01-08 14:47:49', NULL, NULL, 6000, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 14:47:49', 'admin-1483854060-14838580689253457', 1, 0, '', NULL, NULL, NULL),
(17421, '2017-01-08 13:50:02', NULL, NULL, 5999, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 13:50:02', 'admin-1483854060-14838546020117458', 1, 1, 'SR', NULL, NULL, NULL),
(17422, '2017-01-08 13:50:02', NULL, NULL, 5999, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 13:50:02', 'admin-1483854060-14838546020117458', 1, 1, 'SR', NULL, NULL, NULL),
(17423, '2017-01-08 13:49:52', NULL, NULL, 5998, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 13:49:52', 'admin-1483854060-14838545923597351', 1, 1, 'SR', NULL, NULL, NULL),
(17424, '2017-01-08 13:49:52', NULL, NULL, 5998, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 13:49:52', 'admin-1483854060-14838545923597351', 1, 1, 'SR', NULL, NULL, NULL),
(17425, '2017-01-08 13:48:58', NULL, NULL, 5996, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 13:48:58', 'admin-1483854060-14838545385035486', 1, 0, '', NULL, NULL, NULL),
(17426, '2017-01-08 13:41:43', NULL, NULL, 5997, 0, 75, '75', 'Meatless Aglio Olio ', 'no spicy for children', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 13:41:43', 'admin-1483854060-14838541037559115', 1, 0, '', NULL, NULL, NULL),
(17427, '2017-01-08 13:33:00', NULL, NULL, 5997, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 13:33:00', 'admin-1483850176-14838535801545663', 1, 1, 'SR', NULL, NULL, NULL),
(17428, '2017-01-08 13:33:00', NULL, NULL, 5997, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 13:33:00', 'admin-1483850176-14838535801545663', 1, 0, '', NULL, NULL, NULL),
(17429, '2017-01-08 13:33:00', NULL, NULL, 5997, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 13:33:00', 'admin-1483850176-14838535801545663', 1, 1, 'SR', NULL, NULL, NULL),
(17430, '2017-01-08 12:42:28', NULL, NULL, 5990, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:42:28', 'admin-1483850176-14838505488019424', 1, 1, 'SR', NULL, NULL, NULL),
(17431, '2017-01-08 12:36:05', NULL, NULL, 5991, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:36:05', 'admin-1483846564-14838501654459390', 1, 0, '', NULL, NULL, NULL),
(17432, '2017-01-08 10:40:37', NULL, NULL, 5981, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:40:37', 'admin-1483843180-14838432370426329', 1, 1, 'SR', NULL, NULL, NULL),
(17433, '2017-01-08 10:40:37', NULL, NULL, 5981, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:40:37', 'admin-1483843180-14838432370426329', 1, 1, 'SR', NULL, NULL, NULL),
(17434, '2017-01-08 10:41:59', NULL, NULL, 5980, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:41:59', 'admin-1483843180-1483843319571526', 1, 0, '', NULL, NULL, NULL),
(17435, '2017-01-08 10:47:22', NULL, NULL, 5982, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:47:22', 'admin-1483843180-1483843642330283', 1, 0, '', NULL, NULL, NULL),
(17436, '2017-01-08 10:47:22', NULL, NULL, 5982, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:47:22', 'admin-1483843180-1483843642330283', 1, 0, '', NULL, NULL, NULL),
(17437, '2017-01-08 10:47:22', NULL, NULL, 5982, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:47:22', 'admin-1483843180-1483843642330283', 1, 0, '', NULL, NULL, NULL),
(17438, '2017-01-08 10:47:22', NULL, NULL, 5982, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:47:22', 'admin-1483843180-1483843642330283', 1, 0, '', NULL, NULL, NULL),
(17439, '2017-01-08 10:47:53', NULL, NULL, 5982, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:47:53', 'admin-1483843180-14838436727686071', 1, 1, 'SR', NULL, NULL, NULL),
(17440, '2017-01-08 10:47:53', NULL, NULL, 5982, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:47:53', 'admin-1483843180-14838436727686071', 1, 1, 'SR', NULL, NULL, NULL),
(17441, '2017-01-08 10:47:53', NULL, NULL, 5982, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:47:53', 'admin-1483843180-14838436727686071', 1, 1, 'SR', NULL, NULL, NULL),
(17442, '2017-01-08 10:48:38', NULL, NULL, 5982, 0, 15, '15', 'Iced Latte ', 'no sugar', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:48:38', 'admin-1483843180-1483843718255299', 1, 1, 'SR', NULL, NULL, NULL),
(17443, '2017-01-08 10:55:59', NULL, NULL, 5982, 0, 181, '116', 'Open Food ', 'sunny side up with toast', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:55:59', 'admin-1483843180-14838441596541867', 1, 0, '', NULL, NULL, NULL),
(17444, '2017-01-08 11:05:29', NULL, NULL, 5983, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 11:05:29', 'admin-1483843180-14838447288574977', 1, 1, 'SR', NULL, NULL, NULL),
(17445, '2017-01-08 11:05:29', NULL, NULL, 5983, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 11:05:29', 'admin-1483843180-14838447288574977', 1, 0, '', NULL, NULL, NULL),
(17446, '2017-01-08 11:05:29', NULL, NULL, 5983, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 11:05:29', 'admin-1483843180-14838447288574977', 1, 0, '', NULL, NULL, NULL),
(17447, '2017-01-08 11:05:29', NULL, NULL, 5983, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 11:05:29', 'admin-1483843180-14838447288574977', 1, 0, '', NULL, NULL, NULL),
(17448, '2017-01-08 11:05:49', NULL, NULL, 5983, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 11:05:49', 'admin-1483843180-1483844749757436', 1, 0, '', NULL, NULL, NULL),
(17449, '2017-01-08 11:15:42', NULL, NULL, 5984, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 11:15:42', 'admin-1483843180-14838453419754548', 1, 0, '', NULL, NULL, NULL),
(17450, '2017-01-08 11:15:42', NULL, NULL, 5984, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 11:15:42', 'admin-1483843180-14838453419754548', 1, 0, '', NULL, NULL, NULL),
(17451, '2017-01-08 11:15:42', NULL, NULL, 5984, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 11:15:42', 'admin-1483843180-14838453419754548', 1, 1, 'SR', NULL, NULL, NULL),
(17452, '2017-01-08 11:35:39', NULL, NULL, 5985, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 11:35:39', 'admin-1483843180-14838465396693097', 1, 0, '', NULL, NULL, NULL),
(17453, '2017-01-08 11:35:39', NULL, NULL, 5985, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 11:35:39', 'admin-1483843180-14838465396693097', 1, 1, 'SR', NULL, NULL, NULL),
(17454, '2017-01-08 11:37:21', NULL, NULL, 5986, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 11:37:21', 'admin-1483846564-1483846641489654', 1, 0, '', NULL, NULL, NULL),
(17455, '2017-01-08 11:37:21', NULL, NULL, 5986, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 11:37:21', 'admin-1483846564-1483846641489654', 1, 0, '', NULL, NULL, NULL),
(17456, '2017-01-08 11:37:21', NULL, NULL, 5986, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 11:37:21', 'admin-1483846564-1483846641489654', 1, 1, 'SR', NULL, NULL, NULL),
(17457, '2017-01-08 11:37:21', NULL, NULL, 5986, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 11:37:21', 'admin-1483846564-1483846641489654', 1, 0, '', NULL, NULL, NULL),
(17458, '2017-01-08 11:41:07', NULL, NULL, 5987, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 11:41:07', 'admin-1483846564-14838468670653151', 1, 0, '', NULL, NULL, NULL),
(17459, '2017-01-08 11:41:07', NULL, NULL, 5987, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 11:41:07', 'admin-1483846564-14838468670653151', 1, 0, '', NULL, NULL, NULL),
(17460, '2017-01-08 12:42:11', NULL, NULL, 5990, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:42:11', 'admin-1483850176-1483850531494595', 1, 1, 'SR', NULL, NULL, NULL),
(17461, '2017-01-08 12:36:05', NULL, NULL, 5991, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:36:05', 'admin-1483846564-14838501654459390', 1, 1, 'SR', NULL, NULL, NULL),
(17462, '2017-01-08 12:36:05', NULL, NULL, 5991, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:36:05', 'admin-1483846564-14838501654459390', 1, 1, 'SR', NULL, NULL, NULL),
(17463, '2017-01-08 10:17:01', NULL, NULL, 5975, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:17:01', 'admin-1483841634-14838418213587080', 1, 0, '', NULL, NULL, NULL),
(17464, '2017-01-08 10:17:01', NULL, NULL, 5975, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:17:01', 'admin-1483841634-14838418213587080', 1, 0, '', NULL, NULL, NULL),
(17465, '2017-01-08 10:17:07', NULL, NULL, 5975, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:17:07', 'admin-1483841634-14838418276796481', 1, 1, 'SR', NULL, NULL, NULL),
(17466, '2017-01-08 10:17:07', NULL, NULL, 5975, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:17:07', 'admin-1483841634-14838418276796481', 1, 1, 'SR', NULL, NULL, NULL),
(17467, '2017-01-08 10:19:32', NULL, NULL, 5976, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:19:32', 'admin-1483841634-14838419725524935', 1, 0, '', NULL, NULL, NULL),
(17468, '2017-01-08 10:19:32', NULL, NULL, 5976, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:19:32', 'admin-1483841634-14838419725524935', 1, 0, '', NULL, NULL, NULL),
(17469, '2017-01-08 10:21:52', NULL, NULL, 5976, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:21:52', 'admin-1483841634-14838421120808440', 1, 1, 'SR', NULL, NULL, NULL),
(17470, '2017-01-08 10:21:52', NULL, NULL, 5976, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:21:52', 'admin-1483841634-14838421120808440', 1, 1, 'SR', NULL, NULL, NULL),
(17471, '2017-01-08 10:22:35', NULL, NULL, 5977, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:22:35', 'admin-1483841634-14838421553427872', 1, 0, '', NULL, NULL, NULL),
(17472, '2017-01-08 10:22:35', NULL, NULL, 5977, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:22:35', 'admin-1483841634-14838421553427872', 1, 0, '', NULL, NULL, NULL),
(17473, '2017-01-08 10:22:35', NULL, NULL, 5977, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:22:35', 'admin-1483841634-14838421553427872', 1, 0, '', NULL, NULL, NULL),
(17474, '2017-01-08 10:22:35', NULL, NULL, 5977, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:22:35', 'admin-1483841634-14838421553427872', 1, 1, 'SR', NULL, NULL, NULL),
(17475, '2017-01-08 10:22:35', NULL, NULL, 5977, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:22:35', 'admin-1483841634-14838421553427872', 1, 1, 'SR', NULL, NULL, NULL),
(17476, '2017-01-08 10:25:14', NULL, NULL, 5978, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:25:14', 'admin-1483841634-14838423143884635', 1, 0, '', NULL, NULL, NULL),
(17477, '2017-01-08 10:25:14', NULL, NULL, 5978, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:25:14', 'admin-1483841634-14838423143884635', 1, 0, '', NULL, NULL, NULL),
(17478, '2017-01-08 10:25:14', NULL, NULL, 5978, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:25:14', 'admin-1483841634-14838423143884635', 1, 0, '', NULL, NULL, NULL),
(17479, '2017-01-08 10:25:42', NULL, NULL, 5978, 0, 19, '19', 'Iced Vanilla Latte', 'less ice', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:25:42', 'admin-1483841634-14838423419661189', 1, 1, 'SR', NULL, NULL, NULL),
(17480, '2017-01-08 12:05:24', NULL, NULL, 5989, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:05:24', 'admin-1483846564-14838483246022052', 1, 0, '', NULL, NULL, NULL),
(17481, '2017-01-08 12:06:59', NULL, NULL, 5989, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:06:59', 'admin-1483846564-14838484194297920', 1, 0, '', NULL, NULL, NULL),
(17482, '2017-01-08 12:06:59', NULL, NULL, 5989, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:06:59', 'admin-1483846564-14838484194297920', 1, 0, '', NULL, NULL, NULL),
(17483, '2017-01-08 12:06:59', NULL, NULL, 5989, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:06:59', 'admin-1483846564-14838484194297920', 1, 0, '', NULL, NULL, NULL),
(17484, '2017-01-08 12:11:41', NULL, NULL, 5990, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:11:41', 'admin-1483846564-1483848701595891', 1, 1, 'SR', NULL, NULL, NULL),
(17485, '2017-01-08 12:03:41', NULL, NULL, 5989, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:03:41', 'admin-1483846564-14838482209723177', 1, 1, 'SR', NULL, NULL, NULL),
(17486, '2017-01-08 12:05:24', NULL, NULL, 5989, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:05:24', 'admin-1483846564-14838483246022052', 1, 0, '', NULL, NULL, NULL),
(17487, '2017-01-08 12:03:41', NULL, NULL, 5989, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:03:41', 'admin-1483846564-14838482209723177', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(17488, '2017-01-08 12:03:41', NULL, NULL, 5989, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:03:41', 'admin-1483846564-14838482209723177', 1, 1, 'SR', NULL, NULL, NULL),
(17489, '2017-01-08 10:26:42', NULL, NULL, 5979, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:26:42', 'admin-1483841634-14838424021974534', 1, 1, 'SR', NULL, NULL, NULL),
(17490, '2017-01-08 10:39:30', NULL, NULL, 5981, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:39:30', 'admin-1483841634-1483843169907393', 1, 0, '', NULL, NULL, NULL),
(17491, '2017-01-08 10:36:48', NULL, NULL, 5980, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:36:48', 'admin-1483841634-14838430084201015', 1, 1, 'SR', NULL, NULL, NULL),
(17492, '2017-01-08 10:36:48', NULL, NULL, 5980, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:36:48', 'admin-1483841634-14838430084201015', 1, 1, 'SR', NULL, NULL, NULL),
(17493, '2017-01-08 12:36:05', NULL, NULL, 5991, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:36:05', 'admin-1483846564-14838501654459390', 1, 0, '', NULL, NULL, NULL),
(17494, '2017-01-08 00:00:00', NULL, NULL, 5993, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 11:50:39', 'admin-1483846564-1483847439676762', 1, 1, 'SR', NULL, NULL, NULL),
(17495, '2017-01-08 12:03:41', NULL, NULL, 5989, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 12:03:41', 'admin-1483846564-14838482209723177', 1, 1, 'SR', NULL, NULL, NULL),
(17496, '2017-01-08 00:00:00', NULL, NULL, 5994, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 11:50:39', 'admin-1483846564-1483847439676762', 1, 1, 'SR', NULL, NULL, NULL),
(17497, '2017-01-08 00:00:00', NULL, NULL, 5994, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 11:50:20', 'admin-1483846564-14838474203139275', 1, 0, '', NULL, NULL, NULL),
(17498, '2017-01-08 13:11:12', NULL, NULL, 5995, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 13:11:12', 'admin-1483850176-1483852272018509', 1, 0, '', NULL, NULL, NULL),
(17499, '2017-01-08 13:11:12', NULL, NULL, 5995, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 13:11:12', 'admin-1483850176-1483852272018509', 1, 0, '', NULL, NULL, NULL),
(17500, '2017-01-08 11:41:07', NULL, NULL, 5987, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 11:41:07', 'admin-1483846564-14838468670653151', 1, 0, '', NULL, NULL, NULL),
(17501, '2017-01-08 11:41:07', NULL, NULL, 5987, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 11:41:07', 'admin-1483846564-14838468670653151', 1, 0, '', NULL, NULL, NULL),
(17502, '2017-01-08 10:40:37', NULL, NULL, 5981, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:40:37', 'admin-1483843180-14838432370426329', 1, 0, '', NULL, NULL, NULL),
(17503, '2017-01-08 10:39:30', NULL, NULL, 5981, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:39:30', 'admin-1483841634-1483843169907393', 1, 0, '', NULL, NULL, NULL),
(17504, '2017-01-08 10:26:42', NULL, NULL, 5979, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:26:42', 'admin-1483841634-14838424021974534', 1, 0, '', NULL, NULL, NULL),
(17505, '2017-01-08 10:26:42', NULL, NULL, 5979, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:26:42', 'admin-1483841634-14838424021974534', 1, 0, '', NULL, NULL, NULL),
(17506, '2017-01-08 10:26:42', NULL, NULL, 5979, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:26:42', 'admin-1483841634-14838424021974534', 1, 0, '', NULL, NULL, NULL),
(17507, '2017-01-08 09:40:27', NULL, NULL, 5970, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:40:27', 'admin-1483837180-14838396275752554', 1, 0, '', NULL, NULL, NULL),
(17508, '2017-01-08 09:40:27', NULL, NULL, 5970, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:40:27', 'admin-1483837180-14838396275752554', 1, 1, 'SR', NULL, NULL, NULL),
(17509, '2017-01-08 09:40:27', NULL, NULL, 5970, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:40:27', 'admin-1483837180-14838396275752554', 1, 1, 'SR', NULL, NULL, NULL),
(17510, '2017-01-08 09:54:04', NULL, NULL, 5971, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:54:04', 'admin-1483837180-14838404440366818', 1, 0, '', NULL, NULL, NULL),
(17511, '2017-01-08 09:54:04', NULL, NULL, 5971, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:54:04', 'admin-1483837180-14838404440366818', 1, 0, '', NULL, NULL, NULL),
(17512, '2017-01-08 09:54:04', NULL, NULL, 5971, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:54:04', 'admin-1483837180-14838404440366818', 1, 0, '', NULL, NULL, NULL),
(17513, '2017-01-08 09:54:04', NULL, NULL, 5971, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:54:04', 'admin-1483837180-14838404440366818', 1, 1, 'SR', NULL, NULL, NULL),
(17514, '2017-01-08 09:54:04', NULL, NULL, 5971, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:54:04', 'admin-1483837180-14838404440366818', 1, 1, 'SR', NULL, NULL, NULL),
(17515, '2017-01-08 09:54:04', NULL, NULL, 5971, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:54:04', 'admin-1483837180-14838404440366818', 1, 0, '', NULL, NULL, NULL),
(17516, '2017-01-08 09:58:38', NULL, NULL, 5972, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:58:38', 'admin-1483837180-14838407181798958', 1, 0, '', NULL, NULL, NULL),
(17517, '2017-01-08 09:58:38', NULL, NULL, 5972, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:58:38', 'admin-1483837180-14838407181798958', 1, 0, '', NULL, NULL, NULL),
(17518, '2017-01-08 09:58:38', NULL, NULL, 5972, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:58:38', 'admin-1483837180-14838407181798958', 1, 1, 'SR', NULL, NULL, NULL),
(17519, '2017-01-08 09:59:12', NULL, NULL, 5972, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:59:12', 'admin-1483837180-1483840752152142', 1, 0, '', NULL, NULL, NULL),
(17520, '2017-01-08 09:59:12', NULL, NULL, 5972, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:59:12', 'admin-1483837180-1483840752152142', 1, 0, '', NULL, NULL, NULL),
(17521, '2017-01-08 09:59:12', NULL, NULL, 5972, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:59:12', 'admin-1483837180-1483840752152142', 1, 0, '', NULL, NULL, NULL),
(17522, '2017-01-08 09:59:12', NULL, NULL, 5972, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:59:12', 'admin-1483837180-1483840752152142', 1, 0, '', NULL, NULL, NULL),
(17523, '2017-01-08 10:12:45', NULL, NULL, 5973, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:12:45', 'admin-1483837180-14838415649242855', 1, 0, '', NULL, NULL, NULL),
(17524, '2017-01-08 10:12:45', NULL, NULL, 5973, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:12:45', 'admin-1483837180-14838415649242855', 1, 1, 'SR', NULL, NULL, NULL),
(17525, '2017-01-08 10:12:45', NULL, NULL, 5973, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:12:45', 'admin-1483837180-14838415649242855', 1, 1, 'SR', NULL, NULL, NULL),
(17526, '2017-01-08 10:12:45', NULL, NULL, 5973, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:12:45', 'admin-1483837180-14838415649242855', 1, 0, '', NULL, NULL, NULL),
(17527, '2017-01-08 10:13:49', NULL, NULL, 5974, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:13:49', 'admin-1483837180-14838416289607134', 1, 0, '', NULL, NULL, NULL),
(17528, '2017-01-08 10:13:49', NULL, NULL, 5974, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:13:49', 'admin-1483837180-14838416289607134', 1, 0, '', NULL, NULL, NULL),
(17529, '2017-01-08 10:13:49', NULL, NULL, 5974, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:13:49', 'admin-1483837180-14838416289607134', 1, 0, '', NULL, NULL, NULL),
(17530, '2017-01-08 10:14:08', NULL, NULL, 5974, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:14:08', 'admin-1483841634-1483841648201432', 1, 1, 'SR', NULL, NULL, NULL),
(17531, '2017-01-08 10:14:08', NULL, NULL, 5974, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:14:08', 'admin-1483841634-1483841648201432', 1, 1, 'SR', NULL, NULL, NULL),
(17532, '2017-01-08 10:14:08', NULL, NULL, 5974, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:14:08', 'admin-1483841634-1483841648201432', 1, 1, 'SR', NULL, NULL, NULL),
(17533, '2017-01-08 10:14:08', NULL, NULL, 5974, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:14:08', 'admin-1483841634-1483841648201432', 1, 1, 'SR', NULL, NULL, NULL),
(17534, '2017-01-08 10:14:08', NULL, NULL, 5974, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:14:08', 'admin-1483841634-1483841648201432', 1, 1, 'SR', NULL, NULL, NULL),
(17535, '2017-01-08 10:14:08', NULL, NULL, 5974, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 10:14:08', 'admin-1483841634-1483841648201432', 1, 1, 'SR', NULL, NULL, NULL),
(17536, '2017-01-08 09:35:04', NULL, NULL, 5969, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:35:04', 'admin-1483837180-14838393041065565', 1, 1, 'SR', NULL, NULL, NULL),
(17537, '2017-01-08 09:35:04', NULL, NULL, 5969, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:35:04', 'admin-1483837180-14838393041065565', 1, 1, 'SR', NULL, NULL, NULL),
(17538, '2017-01-08 09:20:32', NULL, NULL, 5968, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:20:32', 'admin-1483837180-14838384327505676', 1, 1, 'SR', NULL, NULL, NULL),
(17539, '2017-01-08 09:33:06', NULL, NULL, 5969, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:33:07', 'admin-1483837180-1483839186768989', 1, 0, '', NULL, NULL, NULL),
(17540, '2017-01-08 09:33:06', NULL, NULL, 5969, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:33:06', 'admin-1483837180-1483839186768989', 1, 0, '', NULL, NULL, NULL),
(17541, '2017-01-08 09:20:27', NULL, NULL, 5968, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:20:27', 'admin-1483837180-14838384273115852', 1, 0, '', NULL, NULL, NULL),
(17542, '2017-01-08 09:17:47', NULL, NULL, 5967, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:17:47', 'admin-1483837180-14838382669747323', 1, 1, 'SR', NULL, NULL, NULL),
(17543, '2017-01-08 09:09:39', NULL, NULL, 5966, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483877732', 'admin', '2017-01-08 09:09:39', 'admin-1483837180-14838377797152479', 1, 1, 'SR', NULL, NULL, NULL),
(17544, '2017-01-09 15:25:11', NULL, NULL, 6045, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 15:25:11', 'admin-1483933558-14839467113231820', 1, 1, 'SR', NULL, NULL, NULL),
(17545, '2017-01-09 15:25:11', NULL, NULL, 6045, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 15:25:11', 'admin-1483933558-14839467113231820', 1, 1, 'SR', NULL, NULL, NULL),
(17546, '2017-01-09 15:25:37', NULL, NULL, 6046, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 15:25:37', 'admin-1483933558-14839467370781587', 1, 1, 'SR', NULL, NULL, NULL),
(17547, '2017-01-09 15:25:37', NULL, NULL, 6046, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 15:25:37', 'admin-1483933558-14839467370781587', 1, 1, 'SR', NULL, NULL, NULL),
(17548, '2017-01-09 15:58:02', NULL, NULL, 6047, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 15:58:02', 'admin-1483933558-14839486825125653', 1, 0, '', NULL, NULL, NULL),
(17549, '2017-01-09 16:35:09', NULL, NULL, 6048, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 16:35:09', 'admin-1483933558-14839509092955547', 1, 1, 'SR', NULL, NULL, NULL),
(17550, '2017-01-09 16:35:09', NULL, NULL, 6048, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 16:35:09', 'admin-1483933558-14839509092955547', 1, 1, 'SR', NULL, NULL, NULL),
(17551, '2017-01-09 17:06:49', NULL, NULL, 6049, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 17:06:49', 'admin-1483933558-1483952809447429', 1, 1, 'SR', 1, NULL, NULL),
(17552, '2017-01-09 17:06:49', NULL, NULL, 6049, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 17:06:49', 'admin-1483933558-1483952809447429', 1, 0, '', 1, NULL, NULL),
(17553, '2017-01-09 13:47:40', NULL, NULL, 6041, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 13:47:40', 'admin-1483933558-14839408604578916', 1, 1, 'SR', NULL, NULL, NULL),
(17554, '2017-01-09 13:47:40', NULL, NULL, 6041, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 13:47:40', 'admin-1483933558-14839408604578916', 1, 1, 'SR', NULL, NULL, NULL),
(17555, '2017-01-09 12:41:20', NULL, NULL, 6032, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 12:41:20', 'admin-1483933558-14839368804602390', 1, 1, 'SR', NULL, NULL, NULL),
(17556, '2017-01-09 12:41:20', NULL, NULL, 6032, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 12:41:20', 'admin-1483933558-14839368804602390', 1, 1, 'SR', NULL, NULL, NULL),
(17557, '2017-01-09 12:44:32', NULL, NULL, 6033, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 12:44:32', 'admin-1483933558-14839370720585047', 1, 1, 'SR', NULL, NULL, NULL),
(17558, '2017-01-09 12:49:27', NULL, NULL, 6034, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 12:49:27', 'admin-1483933558-14839373675861167', 1, 1, 'SR', NULL, NULL, NULL),
(17559, '2017-01-09 12:49:27', NULL, NULL, 6034, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 12:49:27', 'admin-1483933558-14839373675861167', 1, 1, 'SR', NULL, NULL, NULL),
(17560, '2017-01-09 13:21:49', NULL, NULL, 6035, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 13:21:49', 'admin-1483933558-1483939309560418', 1, 1, 'SR', NULL, NULL, NULL),
(17561, '2017-01-09 13:21:49', NULL, NULL, 6035, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 13:21:49', 'admin-1483933558-1483939309560418', 1, 1, 'SR', NULL, NULL, NULL),
(17562, '2017-01-09 13:27:07', NULL, NULL, 6036, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 13:27:07', 'admin-1483933558-14839396274333450', 1, 1, 'SR', NULL, NULL, NULL),
(17563, '2017-01-09 13:27:07', NULL, NULL, 6036, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 13:27:07', 'admin-1483933558-14839396274333450', 1, 0, '', NULL, NULL, NULL),
(17564, '2017-01-09 13:27:28', NULL, NULL, 6035, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 13:27:28', 'admin-1483933558-14839396485865548', 1, 0, '', NULL, NULL, NULL),
(17565, '2017-01-09 13:27:28', NULL, NULL, 6035, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 13:27:28', 'admin-1483933558-14839396485865548', 1, 0, '', NULL, NULL, NULL),
(17566, '2017-01-09 13:27:46', NULL, NULL, 6037, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 13:27:46', 'admin-1483933558-14839396666689261', 1, 0, '', NULL, NULL, NULL),
(17567, '2017-01-09 13:27:46', NULL, NULL, 6037, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 13:27:46', 'admin-1483933558-14839396666689261', 1, 0, '', NULL, NULL, NULL),
(17568, '2017-01-09 13:29:02', NULL, NULL, 6038, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 13:29:02', 'admin-1483933558-14839397427431323', 1, 1, 'SR', NULL, NULL, NULL),
(17569, '2017-01-09 13:29:02', NULL, NULL, 6038, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 13:29:02', 'admin-1483933558-14839397427431323', 1, 1, 'SR', NULL, NULL, NULL),
(17570, '2017-01-09 13:34:09', NULL, NULL, 6039, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 13:34:09', 'admin-1483933558-14839400496556893', 1, 1, 'SR', NULL, NULL, NULL),
(17571, '2017-01-09 13:34:09', NULL, NULL, 6039, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 13:34:09', 'admin-1483933558-14839400496556893', 1, 1, 'SR', NULL, NULL, NULL),
(17572, '2017-01-09 15:25:11', NULL, NULL, 6045, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 15:25:11', 'admin-1483933558-14839467113231820', 1, 1, 'SR', NULL, NULL, NULL),
(17573, '2017-01-09 15:25:11', NULL, NULL, 6045, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 15:25:11', 'admin-1483933558-14839467113231820', 1, 1, 'SR', NULL, NULL, NULL),
(17574, '2017-01-09 15:25:11', NULL, NULL, 6045, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 15:25:11', 'admin-1483933558-14839467113231820', 1, 0, '', NULL, NULL, NULL),
(17575, '2017-01-09 14:50:30', NULL, NULL, 6044, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 14:50:30', 'admin-1483933558-14839446299088736', 1, 1, 'SR', 1, NULL, NULL),
(17576, '2017-01-09 15:12:43', NULL, NULL, 6043, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 15:12:43', 'admin-1483933558-14839459634701387', 1, 1, 'SR', NULL, NULL, NULL),
(17577, '2017-01-09 14:05:15', NULL, NULL, 6042, 0, 259, '193', 'Coronado Beer Set', '', 'Cold Drinks', 'Soda & Beer', 1, 40.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 14:05:15', 'admin-1483933558-14839419155892933', 1, 0, '', NULL, NULL, NULL),
(17578, '2017-01-09 13:47:29', NULL, NULL, 6040, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 13:47:29', 'admin-1483933558-1483940849537310', 1, 0, '', NULL, NULL, NULL),
(17579, '2017-01-09 13:47:29', NULL, NULL, 6040, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 13:47:29', 'admin-1483933558-1483940849537310', 1, 0, '', NULL, NULL, NULL),
(17580, '2017-01-09 09:52:59', NULL, NULL, 6022, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 09:52:59', 'admin-1483924068-14839267794049657', 1, 0, '', NULL, NULL, NULL),
(17581, '2017-01-09 09:52:59', NULL, NULL, 6022, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 09:52:59', 'admin-1483924068-14839267794049657', 1, 0, '', NULL, NULL, NULL),
(17582, '2017-01-09 09:52:59', NULL, NULL, 6022, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 09:52:59', 'admin-1483924068-14839267794049657', 1, 0, '', NULL, NULL, NULL),
(17583, '2017-01-09 09:52:59', NULL, NULL, 6022, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 09:52:59', 'admin-1483924068-14839267794049657', 1, 0, '', NULL, NULL, NULL),
(17584, '2017-01-09 09:53:08', NULL, NULL, 6022, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 09:53:08', 'admin-1483924068-14839267878282390', 1, 1, 'SR', NULL, NULL, NULL),
(17585, '2017-01-09 09:53:08', NULL, NULL, 6022, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 09:53:08', 'admin-1483924068-14839267878282390', 1, 1, 'SR', NULL, NULL, NULL),
(17586, '2017-01-09 09:53:08', NULL, NULL, 6022, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 09:53:08', 'admin-1483924068-14839267878282390', 1, 1, 'SR', NULL, NULL, NULL),
(17587, '2017-01-09 09:53:08', NULL, NULL, 6022, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 09:53:08', 'admin-1483924068-14839267878282390', 1, 1, 'SR', NULL, NULL, NULL),
(17588, '2017-01-09 10:07:49', NULL, NULL, 6021, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 10:07:49', 'admin-1483924068-14839276696821461', 1, 1, 'SR', NULL, NULL, NULL),
(17589, '2017-01-09 10:07:49', NULL, NULL, 6021, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 10:07:49', 'admin-1483924068-14839276696821461', 1, 1, 'SR', NULL, NULL, NULL),
(17590, '2017-01-09 10:30:00', NULL, NULL, 6021, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 10:30:00', 'admin-1483924068-14839290003415212', 1, 0, '', NULL, NULL, NULL),
(17591, '2017-01-09 10:46:09', NULL, NULL, 6023, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 10:46:09', 'admin-1483924068-1483929969707974', 1, 0, '', NULL, NULL, NULL),
(17592, '2017-01-09 11:19:33', NULL, NULL, 6024, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 11:19:33', 'admin-1483924068-14839319729352363', 1, 0, '', NULL, NULL, NULL),
(17593, '2017-01-09 11:19:37', NULL, NULL, 6024, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 11:19:37', 'admin-1483924068-14839319775688820', 1, 1, 'SR', NULL, NULL, NULL),
(17594, '2017-01-09 11:41:53', NULL, NULL, 6025, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 11:41:53', 'admin-1483924068-14839333130511843', 1, 1, 'SR', NULL, NULL, NULL),
(17595, '2017-01-09 11:41:53', NULL, NULL, 6025, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 11:41:53', 'admin-1483924068-14839333130511843', 1, 0, '', NULL, NULL, NULL),
(17596, '2017-01-09 11:48:18', NULL, NULL, 6026, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 11:48:18', 'admin-1483933558-14839336984706841', 1, 1, 'SR', 1, NULL, NULL),
(17597, '2017-01-09 11:48:18', NULL, NULL, 6026, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 11:48:18', 'admin-1483933558-14839336984706841', 1, 1, 'SR', 1, NULL, NULL),
(17598, '2017-01-09 12:03:09', NULL, NULL, 6029, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 12:03:09', 'admin-1483933558-14839345893361489', 1, 0, '', NULL, NULL, NULL),
(17599, '2017-01-09 12:03:09', NULL, NULL, 6029, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 12:03:09', 'admin-1483933558-14839345893361489', 1, 0, '', NULL, NULL, NULL),
(17600, '2017-01-09 12:03:24', NULL, NULL, 6029, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 12:03:24', 'admin-1483933558-14839346041533028', 1, 1, 'SR', NULL, NULL, NULL),
(17601, '2017-01-09 12:03:24', NULL, NULL, 6029, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 12:03:24', 'admin-1483933558-14839346041533028', 1, 1, 'SR', NULL, NULL, NULL),
(17602, '2017-01-09 12:06:04', NULL, NULL, 6023, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 12:06:04', 'admin-1483933558-14839347638903823', 1, 1, 'SR', NULL, NULL, NULL),
(17603, '2017-01-09 12:15:14', NULL, NULL, 6030, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 12:15:14', 'admin-1483933558-1483935314538441', 1, 0, '', NULL, NULL, NULL),
(17604, '2017-01-09 12:15:14', NULL, NULL, 6030, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 12:15:14', 'admin-1483933558-1483935314538441', 1, 1, 'SR', NULL, NULL, NULL),
(17605, '2017-01-09 12:15:34', NULL, NULL, 6031, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 12:15:34', 'admin-1483933558-14839353342755769', 1, 1, 'SR', NULL, NULL, NULL),
(17606, '2017-01-09 12:19:42', NULL, NULL, 6031, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 12:19:42', 'admin-1483933558-14839355821794743', 1, 1, 'SR', NULL, NULL, NULL),
(17607, '2017-01-09 09:36:38', NULL, NULL, 6021, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 09:36:38', 'admin-1483924068-14839257987564140', 1, 1, 'SR', NULL, NULL, NULL),
(17608, '2017-01-09 09:36:38', NULL, NULL, 6021, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 09:36:38', 'admin-1483924068-14839257987564140', 1, 0, '', NULL, NULL, NULL),
(17609, '2017-01-09 09:31:30', NULL, NULL, 6021, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 09:31:30', 'admin-1483924068-14839254906423365', 1, 1, 'SR', NULL, NULL, NULL),
(17610, '2017-01-09 09:31:30', NULL, NULL, 6021, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 09:31:30', 'admin-1483924068-14839254906423365', 1, 1, 'SR', NULL, NULL, NULL),
(17611, '2017-01-09 09:31:17', NULL, NULL, 6021, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 09:31:17', 'admin-1483924068-14839254770526480', 1, 0, '', NULL, NULL, NULL),
(17612, '2017-01-09 09:31:17', NULL, NULL, 6021, 0, 153, '87', 'Big Breakfast ', 'no sausage', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 09:31:17', 'admin-1483924068-14839254770526480', 1, 0, '', NULL, NULL, NULL),
(17613, '2017-01-09 09:31:17', NULL, NULL, 6021, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1483933558', 'admin', '2017-01-09 09:31:17', 'admin-1483924068-14839254770526480', 1, 0, '', NULL, NULL, NULL),
(17614, '2017-01-11 14:30:54', NULL, NULL, 6061, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 14:30:54', 'admin-1484111829-14841162543984741', 1, 0, '', NULL, NULL, NULL),
(17615, '2017-01-11 14:31:16', NULL, NULL, 6061, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 14:31:16', 'admin-1484116267-1484116276019712', 1, 1, 'SR', NULL, NULL, NULL),
(17616, '2017-01-11 14:31:16', NULL, NULL, 6061, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 14:31:16', 'admin-1484116267-1484116276019712', 1, 1, 'SR', NULL, NULL, NULL),
(17617, '2017-01-11 00:00:00', NULL, NULL, 6062, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 12:47:37', 'admin-1484096007-14841100571946520', 1, 1, 'SR', NULL, NULL, NULL),
(17618, '2017-01-11 14:55:04', NULL, NULL, 6065, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 14:55:04', 'admin-1484116267-14841177039618350', 1, 0, '', NULL, NULL, NULL),
(17619, '2017-01-11 14:55:04', NULL, NULL, 6065, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 14:55:04', 'admin-1484116267-14841177039618350', 1, 0, '', NULL, NULL, NULL),
(17620, '2017-01-11 15:02:23', NULL, NULL, 6065, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 15:02:23', 'admin-1484116267-1484118143152710', 1, 0, '', NULL, NULL, NULL),
(17621, '2017-01-11 15:02:23', NULL, NULL, 6065, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 15:02:23', 'admin-1484116267-1484118143152710', 1, 1, 'SR', NULL, NULL, NULL),
(17622, '2017-01-11 15:35:17', NULL, NULL, 6066, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 15:35:17', 'admin-1484116267-14841201177768736', 1, 1, 'SR', NULL, NULL, NULL),
(17623, '2017-01-11 15:36:20', NULL, NULL, 6066, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 15:36:20', 'admin-1484116267-1484120180623506', 1, 1, 'SR', NULL, NULL, NULL),
(17624, '2017-01-11 16:07:09', NULL, NULL, 6066, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 16:07:09', 'admin-1484116267-14841220291914387', 1, 1, 'SR', NULL, NULL, NULL),
(17625, '2017-01-11 17:09:59', NULL, NULL, 6067, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 17:09:59', 'admin-1484116267-14841257989901922', 1, 0, '', NULL, NULL, NULL),
(17626, '2017-01-11 17:15:56', NULL, NULL, 6067, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 17:15:56', 'admin-1484116267-14841261565558392', 1, 1, 'SR', NULL, NULL, NULL),
(17627, '2017-01-11 17:15:56', NULL, NULL, 6067, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 17:15:56', 'admin-1484116267-14841261565558392', 1, 1, 'SR', NULL, NULL, NULL),
(17628, '2017-01-11 18:56:54', NULL, NULL, 6068, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 18:56:54', 'admin-1484116267-1484132214037244', 1, 1, 'SR', NULL, NULL, '10.0'),
(17629, '2017-01-11 18:56:54', NULL, NULL, 6068, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 18:56:54', 'admin-1484116267-1484132214037244', 1, 0, '', NULL, NULL, '10.0'),
(17630, '2017-01-11 18:56:54', NULL, NULL, 6068, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 18:56:54', 'admin-1484116267-1484132214037244', 1, 0, '', NULL, NULL, '10.0'),
(17631, '2017-01-11 19:50:52', NULL, NULL, 6068, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 19:50:52', 'admin-1484116267-14841354524817199', 1, 1, 'SR', NULL, NULL, '10.0'),
(17632, '2017-01-11 20:00:20', NULL, NULL, 6070, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 20:00:20', 'admin-1484116267-14841360205992424', 1, 1, 'SR', NULL, NULL, NULL),
(17633, '2017-01-11 20:00:20', NULL, NULL, 6070, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 20:00:20', 'admin-1484116267-14841360205992424', 1, 0, '', NULL, NULL, NULL),
(17634, '2017-01-11 19:39:33', NULL, NULL, 6069, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1484116267', 'admin', '2017-01-11 19:39:33', 'admin-1484116267-1484134773379411', 1, 0, '', 1, NULL, NULL),
(17635, '2017-01-11 19:39:33', NULL, NULL, 6069, 0, 71, '71', 'Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 19:39:33', 'admin-1484116267-1484134773379411', 1, 1, 'SR', 1, NULL, NULL),
(17636, '2017-01-11 13:23:04', NULL, NULL, 6055, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 13:23:04', 'admin-1484111829-14841121843208473', 1, 0, '', NULL, NULL, NULL),
(17637, '2017-01-11 13:24:06', NULL, NULL, 6055, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 13:24:06', 'admin-1484111829-14841122461785190', 1, 0, '', NULL, NULL, NULL),
(17638, '2017-01-11 13:26:12', NULL, NULL, 6057, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 13:26:12', 'admin-1484111829-14841123727268697', 1, 0, '', NULL, NULL, NULL),
(17639, '2017-01-11 13:26:12', NULL, NULL, 6057, 0, 82, '82', 'Set Stir Fried Rice Wine Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 13:26:12', 'admin-1484111829-14841123727268697', 1, 1, 'SR', NULL, NULL, NULL),
(17640, '2017-01-11 13:36:12', NULL, NULL, 6058, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 13:36:12', 'admin-1484111829-1484112972456341', 1, 1, 'SR', NULL, NULL, NULL),
(17641, '2017-01-11 13:51:53', NULL, NULL, 6059, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 13:51:53', 'admin-1484111829-14841139134501580', 1, 0, '', 1, NULL, NULL),
(17642, '2017-01-11 13:51:53', NULL, NULL, 6059, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 13:51:53', 'admin-1484111829-14841139134501580', 1, 0, '', 1, NULL, NULL),
(17643, '2017-01-11 13:52:38', NULL, NULL, 6059, 0, 181, '116', 'Open Food ', 'SCONE', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 13:52:38', 'admin-1484111829-14841139579289037', 1, 0, '', 1, NULL, NULL),
(17644, '2017-01-11 13:58:17', NULL, NULL, 6060, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 13:58:17', 'admin-1484111829-14841142977888179', 1, 1, 'SR', NULL, NULL, NULL),
(17645, '2017-01-11 13:59:15', NULL, NULL, 6060, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 13:59:15', 'admin-1484111829-14841143550504446', 1, 1, 'SR', NULL, NULL, NULL),
(17646, '2017-01-11 14:20:16', NULL, NULL, 6055, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 14:20:16', 'admin-1484111829-1484115616194372', 1, 0, '', NULL, NULL, NULL),
(17647, '2017-01-11 00:00:00', NULL, NULL, 6063, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 13:05:32', 'admin-1484096007-14841111319598440', 1, 0, '', NULL, NULL, NULL),
(17648, '2017-01-11 00:00:00', NULL, NULL, 6062, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 12:47:37', 'admin-1484096007-14841100571946520', 1, 0, '', NULL, NULL, NULL),
(17649, '2017-01-11 14:41:12', NULL, NULL, 6064, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 14:41:12', 'admin-1484116267-14841168727082352', 1, 1, 'SR', 1, NULL, NULL),
(17650, '2017-01-11 12:48:32', NULL, NULL, 6053, 0, 82, '82', 'Set Stir Fried Rice Wine Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 12:48:32', 'admin-1484096007-14841101118809742', 1, 1, 'SR', NULL, NULL, NULL),
(17651, '2017-01-11 12:48:32', NULL, NULL, 6053, 0, 213, '147', 'Set Stir Fried Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 12:48:32', 'admin-1484096007-14841101118809742', 1, 0, '', NULL, NULL, NULL),
(17652, '2017-01-11 12:48:32', NULL, NULL, 6053, 0, 83, '83', 'Set Stir Fried Chicken with Mushroom ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 12:48:32', 'admin-1484096007-14841101118809742', 1, 1, 'SR', NULL, NULL, NULL),
(17653, '2017-01-11 12:51:39', NULL, NULL, 6054, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 12:51:39', 'admin-1484096007-1484110298845673', 1, 1, 'SR', NULL, NULL, NULL),
(17654, '2017-01-11 12:58:25', NULL, NULL, 6055, 0, 84, '84', 'Set Marmite Chicken', 'egg well done', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 12:58:25', 'admin-1484096007-14841107053787478', 1, 1, 'SR', NULL, NULL, NULL),
(17655, '2017-01-11 12:58:25', NULL, NULL, 6055, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 12:58:25', 'admin-1484096007-14841107053787478', 1, 0, '', NULL, NULL, NULL),
(17656, '2017-01-11 12:58:25', NULL, NULL, 6055, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 12:58:25', 'admin-1484096007-14841107053787478', 1, 1, 'SR', NULL, NULL, NULL),
(17657, '2017-01-11 00:00:00', NULL, NULL, 6063, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 12:47:37', 'admin-1484096007-14841100571946520', 1, 1, 'SR', NULL, NULL, NULL),
(17658, '2017-01-11 13:16:58', NULL, NULL, 6056, 0, 85, '85', 'Set Meatless Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 13:16:58', 'admin-1484096007-14841118186868538', 1, 1, 'SR', NULL, NULL, NULL),
(17659, '2017-01-11 13:16:58', NULL, NULL, 6056, 0, 85, '85', 'Set Meatless Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 13:16:58', 'admin-1484096007-14841118186868538', 1, 1, 'SR', NULL, NULL, NULL),
(17660, '2017-01-11 13:16:58', NULL, NULL, 6056, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 13:16:58', 'admin-1484096007-14841118186868538', 1, 0, '', NULL, NULL, NULL),
(17661, '2017-01-11 13:18:16', NULL, NULL, 6056, 0, 86, '86', 'Set Meatless Pesto Pasta ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 13:18:16', 'admin-1484111829-14841118957739686', 1, 1, 'SR', NULL, NULL, NULL),
(17662, '2017-01-11 13:18:16', NULL, NULL, 6056, 0, 86, '86', 'Set Meatless Pesto Pasta ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 13:18:16', 'admin-1484111829-14841118957739686', 1, 1, 'SR', NULL, NULL, NULL),
(17663, '2017-01-11 11:30:05', NULL, NULL, 6051, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 11:30:05', 'admin-1484096007-14841054052388972', 1, 0, '', NULL, NULL, NULL),
(17664, '2017-01-11 11:30:17', NULL, NULL, 6051, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 11:30:17', 'admin-1484096007-14841054169189348', 1, 1, 'SR', NULL, NULL, NULL),
(17665, '2017-01-11 11:30:17', NULL, NULL, 6051, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 11:30:17', 'admin-1484096007-14841054169189348', 1, 0, '', NULL, NULL, NULL),
(17666, '2017-01-11 11:30:05', NULL, NULL, 6051, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 11:30:05', 'admin-1484096007-14841054052388972', 1, 0, '', NULL, NULL, NULL),
(17667, '2017-01-11 09:23:09', NULL, NULL, 6050, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 09:23:09', 'admin-1484096007-14840977892658731', 1, 1, 'SR', NULL, NULL, NULL),
(17668, '2017-01-11 09:23:09', NULL, NULL, 6050, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484116267', 'admin', '2017-01-11 09:23:09', 'admin-1484096007-14840977892658731', 1, 1, 'SR', NULL, NULL, NULL),
(17669, '2017-01-12 11:40:38', NULL, NULL, 6074, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 11:40:38', 'admin-1484183322-14841924378954234', 1, 0, '', NULL, NULL, NULL),
(17670, '2017-01-12 11:40:38', NULL, NULL, 6074, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 11:40:38', 'admin-1484183322-14841924378954234', 1, 0, '', NULL, NULL, NULL),
(17671, '2017-01-12 11:40:38', NULL, NULL, 6074, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 11:40:38', 'admin-1484183322-14841924378954234', 1, 0, '', NULL, NULL, NULL),
(17672, '2017-01-12 12:05:01', NULL, NULL, 6075, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 12:05:01', 'admin-1484183322-14841939015104064', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(17673, '2017-01-12 12:05:01', NULL, NULL, 6075, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 12:05:01', 'admin-1484183322-14841939015104064', 1, 1, 'SR', NULL, NULL, NULL),
(17674, '2017-01-12 12:13:06', NULL, NULL, 6076, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 12:13:06', 'admin-1484183322-14841943857728245', 1, 0, '', NULL, NULL, NULL),
(17675, '2017-01-12 12:13:16', NULL, NULL, 6076, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 12:13:16', 'admin-1484183322-14841943963114814', 1, 1, 'SR', NULL, NULL, NULL),
(17676, '2017-01-12 18:48:17', NULL, NULL, 6086, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 18:48:17', 'admin-1484195308-14842180974563788', 1, 0, '', NULL, NULL, NULL),
(17677, '2017-01-12 18:49:24', NULL, NULL, 6087, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 18:49:24', 'admin-1484195308-14842181642753427', 1, 1, 'SR', NULL, NULL, NULL),
(17678, '2017-01-12 18:50:04', NULL, NULL, 6088, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 18:50:04', 'admin-1484195308-14842182045546435', 1, 1, 'SR', NULL, NULL, NULL),
(17679, '2017-01-12 19:22:22', NULL, NULL, 6089, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 19:22:22', 'admin-1484195308-1484220142211129', 1, 1, 'SR', NULL, NULL, NULL),
(17680, '2017-01-12 11:40:24', NULL, NULL, 6073, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 11:40:24', 'admin-1484183322-148419242456247', 1, 0, '', NULL, NULL, NULL),
(17681, '2017-01-12 12:20:50', NULL, NULL, 6077, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 12:20:50', 'admin-1484183322-14841948505051799', 1, 1, 'SR', NULL, NULL, NULL),
(17682, '2017-01-12 12:26:46', NULL, NULL, 6078, 0, 82, '82', 'Set Stir Fried Rice Wine Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 12:26:46', 'admin-1484183322-14841952058558223', 1, 1, 'SR', NULL, NULL, NULL),
(17683, '2017-01-12 12:26:46', NULL, NULL, 6078, 0, 84, '84', 'Set Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 12:26:46', 'admin-1484183322-14841952058558223', 1, 1, 'SR', NULL, NULL, NULL),
(17684, '2017-01-12 12:28:20', NULL, NULL, 6079, 0, 84, '84', 'Set Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 12:28:20', 'admin-1484183322-1484195300666975', 1, 1, 'SR', NULL, NULL, NULL),
(17685, '2017-01-12 12:30:11', NULL, NULL, 6079, 0, 245, '179', 'Set Spicy Lemony Chicken Wing', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 12:30:11', 'admin-1484195308-14841954110568629', 1, 0, '', NULL, NULL, NULL),
(17686, '2017-01-12 12:49:17', NULL, NULL, 6080, 0, 259, '193', 'Coronado Beer Set', '', 'Cold Drinks', 'Soda & Beer', 1, 40.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 12:49:17', 'admin-1484195308-14841965577492774', 1, 0, '', NULL, NULL, NULL),
(17687, '2017-01-12 13:08:12', NULL, NULL, 6081, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 13:08:12', 'admin-1484195308-1484197691942612', 1, 1, 'SR', 1, NULL, NULL),
(17688, '2017-01-12 14:01:40', NULL, NULL, 6083, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 14:01:40', 'admin-1484195308-14842008999925781', 1, 1, 'SR', 1, NULL, NULL),
(17689, '2017-01-12 17:26:15', NULL, NULL, 6084, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 17:26:15', 'admin-1484195308-14842131757541783', 1, 1, 'SR', 1, NULL, NULL),
(17690, '2017-01-12 17:26:15', NULL, NULL, 6084, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 17:26:15', 'admin-1484195308-14842131757541783', 1, 1, 'SR', 1, NULL, NULL),
(17691, '2017-01-12 17:26:37', NULL, NULL, 6084, 0, 181, '116', 'Open Food ', 'cheesy sticks', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 17:26:37', 'admin-1484195308-14842131968685573', 1, 0, '', 1, NULL, NULL),
(17692, '2017-01-12 18:36:45', NULL, NULL, 6085, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 18:36:45', 'admin-1484195308-14842174052915375', 1, 1, 'SR', NULL, NULL, NULL),
(17693, '2017-01-12 18:36:45', NULL, NULL, 6085, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 18:36:45', 'admin-1484195308-14842174052915375', 1, 1, 'SR', NULL, NULL, NULL),
(17694, '2017-01-12 18:36:45', NULL, NULL, 6085, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 18:36:45', 'admin-1484195308-14842174052915375', 1, 1, 'SR', NULL, NULL, NULL),
(17695, '2017-01-12 11:40:24', NULL, NULL, 6073, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 11:40:24', 'admin-1484183322-148419242456247', 1, 0, '', NULL, NULL, NULL),
(17696, '2017-01-12 11:40:24', NULL, NULL, 6073, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 11:40:24', 'admin-1484183322-148419242456247', 1, 1, 'SR', NULL, NULL, NULL),
(17697, '2017-01-12 12:20:50', NULL, NULL, 6077, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 12:20:50', 'admin-1484183322-14841948505051799', 1, 0, '', NULL, NULL, NULL),
(17698, '2017-01-12 11:40:24', NULL, NULL, 6073, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 11:40:24', 'admin-1484183322-148419242456247', 1, 0, '', NULL, NULL, NULL),
(17699, '2017-01-12 09:17:30', NULL, NULL, 6072, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 09:17:30', 'admin-1484183322-14841838508175948', 1, 1, 'SR', NULL, NULL, NULL),
(17700, '2017-01-12 09:08:56', NULL, NULL, 6071, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 09:08:56', 'admin-1484183322-14841833361101251', 1, 1, 'SR', NULL, NULL, NULL),
(17701, '2017-01-12 09:08:56', NULL, NULL, 6071, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484195308', 'admin', '2017-01-12 09:08:56', 'admin-1484183322-14841833361101251', 1, 1, 'SR', NULL, NULL, NULL),
(17702, '2017-01-13 12:16:35', NULL, NULL, 6099, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 12:16:35', 'admin-1484279630-1484280995113555', 1, 1, 'SR', NULL, NULL, NULL),
(17703, '2017-01-13 12:50:54', NULL, NULL, 6100, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 12:50:54', 'admin-1484279630-14842830542062352', 1, 1, 'SR', NULL, NULL, NULL),
(17704, '2017-01-13 12:50:54', NULL, NULL, 6100, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 12:50:54', 'admin-1484279630-14842830542062352', 1, 1, 'SR', NULL, NULL, NULL),
(17705, '2017-01-13 12:58:08', NULL, NULL, 6101, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 12:58:08', 'admin-1484279630-14842834882588963', 1, 0, '', 1, NULL, NULL),
(17706, '2017-01-13 13:21:27', NULL, NULL, 6102, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 13:21:27', 'admin-1484279630-14842848873814420', 1, 1, 'SR', NULL, NULL, NULL),
(17707, '2017-01-13 13:21:27', NULL, NULL, 6102, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 13:21:27', 'admin-1484279630-14842848873814420', 1, 0, '', NULL, NULL, NULL),
(17708, '2017-01-13 13:21:27', NULL, NULL, 6102, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 13:21:27', 'admin-1484279630-14842848873814420', 1, 0, '', NULL, NULL, NULL),
(17709, '2017-01-13 13:23:27', NULL, NULL, 6103, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 13:23:27', 'admin-1484279630-14842850072464538', 1, 1, 'SR', NULL, NULL, NULL),
(17710, '2017-01-13 13:23:27', NULL, NULL, 6103, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 13:23:27', 'admin-1484279630-14842850072464538', 1, 1, 'SR', NULL, NULL, NULL),
(17711, '2017-01-13 13:47:18', NULL, NULL, 6104, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 13:47:18', 'admin-1484279630-14842864386084049', 1, 0, '', 1, NULL, NULL),
(17712, '2017-01-13 15:17:01', NULL, NULL, 6105, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 15:17:01', 'admin-1484279630-14842918214966255', 1, 0, '', 1, NULL, NULL),
(17713, '2017-01-13 15:17:01', NULL, NULL, 6105, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 15:17:01', 'admin-1484279630-14842918214966255', 1, 0, '', 1, NULL, NULL),
(17714, '2017-01-13 15:17:01', NULL, NULL, 6105, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 15:17:01', 'admin-1484279630-14842918214966255', 1, 0, '', 1, NULL, NULL),
(17715, '2017-01-13 15:31:37', NULL, NULL, 6106, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 15:31:37', 'admin-1484279630-14842926968469881', 1, 0, '', 1, NULL, NULL),
(17716, '2017-01-13 15:31:37', NULL, NULL, 6106, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 15:31:37', 'admin-1484279630-14842926968469881', 1, 1, 'SR', 1, NULL, NULL),
(17717, '2017-01-13 15:54:11', NULL, NULL, 6107, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 15:54:11', 'admin-1484279630-14842940514582640', 1, 1, 'SR', 1, NULL, NULL),
(17718, '2017-01-13 16:01:57', NULL, NULL, 6108, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 16:01:57', 'admin-1484279630-14842945174133820', 1, 1, 'SR', NULL, NULL, NULL),
(17719, '2017-01-13 11:41:16', NULL, NULL, 6096, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 11:41:16', 'admin-1484269647-14842788759382160', 1, 1, 'SR', NULL, NULL, NULL),
(17720, '2017-01-13 11:52:34', NULL, NULL, 6097, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 11:52:34', 'admin-1484269647-14842795541603911', 1, 0, '', NULL, NULL, NULL),
(17721, '2017-01-13 11:47:20', NULL, NULL, 6096, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 11:47:20', 'admin-1484269647-14842792405997549', 1, 1, 'SR', NULL, NULL, NULL),
(17722, '2017-01-13 11:54:00', NULL, NULL, 6096, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 11:54:00', 'admin-1484279630-1484279640071745', 1, 1, 'SR', NULL, NULL, NULL),
(17723, '2017-01-13 12:10:29', NULL, NULL, 6098, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 12:10:29', 'admin-1484279630-14842806297523671', 1, 1, 'SR', NULL, NULL, NULL),
(17724, '2017-01-13 12:10:29', NULL, NULL, 6098, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 12:10:29', 'admin-1484279630-14842806297523671', 1, 1, 'SR', NULL, NULL, NULL),
(17725, '2017-01-13 10:21:24', NULL, NULL, 6092, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 10:21:24', 'admin-1484269647-14842740841091796', 1, 1, 'SR', NULL, NULL, NULL),
(17726, '2017-01-13 10:21:24', NULL, NULL, 6092, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 10:21:24', 'admin-1484269647-14842740841091796', 1, 1, 'SR', NULL, NULL, NULL),
(17727, '2017-01-13 10:24:14', NULL, NULL, 6092, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 10:24:14', 'admin-1484269647-14842742546889566', 1, 0, '', NULL, NULL, NULL),
(17728, '2017-01-13 10:24:51', NULL, NULL, 6092, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 10:24:51', 'admin-1484269647-14842742912533121', 1, 0, '', NULL, NULL, NULL),
(17729, '2017-01-13 10:25:57', NULL, NULL, 6092, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 10:25:57', 'admin-1484269647-14842743570687393', 1, 0, '', NULL, NULL, NULL),
(17730, '2017-01-13 10:30:26', NULL, NULL, 6092, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 10:30:26', 'admin-1484269647-1484274626667977', 1, 1, 'SR', NULL, NULL, NULL),
(17731, '2017-01-13 10:33:07', NULL, NULL, 6093, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 10:33:07', 'admin-1484269647-14842747872597162', 1, 0, '', NULL, NULL, NULL),
(17732, '2017-01-13 10:33:07', NULL, NULL, 6093, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 10:33:07', 'admin-1484269647-14842747872597162', 1, 1, 'SR', NULL, NULL, NULL),
(17733, '2017-01-13 10:33:07', NULL, NULL, 6093, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 10:33:07', 'admin-1484269647-14842747872597162', 1, 1, 'SR', NULL, NULL, NULL),
(17734, '2017-01-13 10:33:07', NULL, NULL, 6093, 0, 182, '117', 'Open Drinks ', 'drinking water', 'Cold Drinks', 'Fresh Juice', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 10:33:07', 'admin-1484269647-14842747872597162', 1, 0, '', NULL, NULL, NULL),
(17735, '2017-01-13 11:01:00', NULL, NULL, 6094, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 11:01:00', 'admin-1484269647-14842764602382961', 1, 1, 'SR', NULL, NULL, NULL),
(17736, '2017-01-13 11:01:00', NULL, NULL, 6094, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 11:01:00', 'admin-1484269647-14842764602382961', 1, 1, 'SR', NULL, NULL, NULL),
(17737, '2017-01-13 11:03:14', NULL, NULL, 6093, 0, 182, '117', 'Open Drinks ', 'drinking water', 'Cold Drinks', 'Fresh Juice', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 11:03:14', 'admin-1484269647-14842765946115372', 1, 0, '', NULL, NULL, NULL),
(17738, '2017-01-13 11:07:33', NULL, NULL, 6095, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 11:07:33', 'admin-1484269647-14842768530532037', 1, 0, '', NULL, NULL, NULL),
(17739, '2017-01-13 11:34:01', NULL, NULL, 6092, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 11:34:01', 'admin-1484269647-1484278441370911', 1, 0, '', NULL, NULL, NULL),
(17740, '2017-01-13 10:10:57', NULL, NULL, 6091, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 10:10:57', 'admin-1484269647-14842734574438343', 1, 0, '', NULL, NULL, NULL),
(17741, '2017-01-13 10:10:57', NULL, NULL, 6091, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 10:10:57', 'admin-1484269647-14842734574438343', 1, 1, 'SR', NULL, NULL, NULL),
(17742, '2017-01-13 10:10:57', NULL, NULL, 6091, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 10:10:57', 'admin-1484269647-14842734574438343', 1, 1, 'SR', NULL, NULL, NULL),
(17743, '2017-01-13 10:10:57', NULL, NULL, 6091, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 10:10:57', 'admin-1484269647-14842734574438343', 1, 0, '', NULL, NULL, NULL),
(17744, '2017-01-13 09:35:08', NULL, NULL, 6090, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 09:35:08', 'admin-1484269647-14842713082402512', 1, 1, 'SR', NULL, NULL, NULL),
(17745, '2017-01-13 09:34:32', NULL, NULL, 6090, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484279630', 'admin', '2017-01-13 09:34:32', 'admin-1484269647-14842712722013046', 1, 0, '', NULL, NULL, NULL),
(17746, '2017-01-14 13:36:38', NULL, NULL, 6129, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 13:36:38', 'admin-1484363814-14843721984264680', 1, 1, 'SR', NULL, NULL, NULL),
(17747, '2017-01-14 13:41:29', NULL, NULL, 6130, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 13:41:29', 'admin-1484363814-14843724894015910', 1, 0, '', NULL, NULL, NULL),
(17748, '2017-01-14 13:44:40', NULL, NULL, 6128, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 13:44:40', 'admin-1484363814-14843726800926689', 1, 1, 'SR', NULL, NULL, NULL),
(17749, '2017-01-14 14:05:40', NULL, NULL, 6128, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 14:05:40', 'admin-1484363814-1484373940558561', 1, 0, '', NULL, NULL, NULL),
(17750, '2017-01-14 14:05:40', NULL, NULL, 6128, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 14:05:40', 'admin-1484363814-1484373940558561', 1, 0, '', NULL, NULL, NULL),
(17751, '2017-01-14 14:22:35', NULL, NULL, 6131, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 14:22:35', 'admin-1484363814-14843749556285375', 1, 1, 'SR', NULL, NULL, NULL),
(17752, '2017-01-14 14:28:44', NULL, NULL, 6129, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 14:28:44', 'admin-1484363814-14843753238834871', 1, 1, 'SR', NULL, NULL, NULL),
(17753, '2017-01-14 14:32:42', NULL, NULL, 6132, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 14:32:42', 'admin-1484363814-14843755618319378', 1, 1, 'SR', NULL, NULL, NULL),
(17754, '2017-01-14 14:32:42', NULL, NULL, 6132, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 14:32:42', 'admin-1484363814-14843755618319378', 1, 1, 'SR', NULL, NULL, NULL),
(17755, '2017-01-14 15:18:28', NULL, NULL, 6121, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 15:18:28', 'admin-1484375582-1484378307850716', 1, 0, '', NULL, NULL, NULL),
(17756, '2017-01-14 15:27:34', NULL, NULL, 6133, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 15:27:34', 'admin-1484375582-14843788541267873', 1, 1, 'SR', NULL, NULL, NULL),
(17757, '2017-01-14 15:30:20', NULL, NULL, 6133, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 15:30:20', 'admin-1484375582-14843790201044561', 1, 0, '', NULL, NULL, NULL),
(17758, '2017-01-14 13:12:08', NULL, NULL, 6128, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 13:12:08', 'admin-1484363814-14843707283925755', 1, 0, '', NULL, NULL, NULL),
(17759, '2017-01-14 13:12:08', NULL, NULL, 6128, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 13:12:08', 'admin-1484363814-14843707283925755', 1, 0, '', NULL, NULL, NULL),
(17760, '2017-01-14 13:12:08', NULL, NULL, 6128, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 13:12:08', 'admin-1484363814-14843707283925755', 1, 1, 'SR', NULL, NULL, NULL),
(17761, '2017-01-14 13:12:08', NULL, NULL, 6128, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 13:12:08', 'admin-1484363814-14843707283925755', 1, 1, 'SR', NULL, NULL, NULL),
(17762, '2017-01-14 13:12:55', NULL, NULL, 6128, 0, 190, '125', 'Tiger Bucket ', '', 'Cold Drinks', 'Soda & Beer', 1, 48.00, 48.0000, 0.0000, 48.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 13:12:55', 'admin-1484363814-14843707756779071', 1, 0, '', NULL, NULL, NULL),
(17763, '2017-01-14 13:12:55', NULL, NULL, 6128, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 13:12:55', 'admin-1484363814-14843707756779071', 1, 1, 'SR', NULL, NULL, NULL),
(17764, '2017-01-14 13:12:55', NULL, NULL, 6128, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 13:12:55', 'admin-1484363814-14843707756779071', 1, 1, 'SR', NULL, NULL, NULL),
(17765, '2017-01-14 10:42:30', NULL, NULL, 6117, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 10:42:30', 'admin-1484360491-14843617497348486', 1, 0, '', NULL, NULL, NULL),
(17766, '2017-01-14 10:51:22', NULL, NULL, 6118, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 10:51:22', 'admin-1484360491-14843622827455371', 1, 0, '', NULL, NULL, NULL),
(17767, '2017-01-14 10:51:22', NULL, NULL, 6118, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 10:51:22', 'admin-1484360491-14843622827455371', 1, 0, '', NULL, NULL, NULL),
(17768, '2017-01-14 10:51:32', NULL, NULL, 6118, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 10:51:32', 'admin-1484360491-14843622927149489', 1, 0, '', NULL, NULL, NULL),
(17769, '2017-01-14 11:07:38', NULL, NULL, 6119, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 11:07:38', 'admin-1484360491-1484363258452685', 1, 0, '', NULL, NULL, NULL),
(17770, '2017-01-14 10:59:36', NULL, NULL, 6119, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 10:59:36', 'admin-1484360491-14843627765511355', 1, 0, '', NULL, NULL, NULL),
(17771, '2017-01-14 10:59:36', NULL, NULL, 6119, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 10:59:36', 'admin-1484360491-14843627765511355', 1, 1, 'SR', NULL, NULL, NULL),
(17772, '2017-01-14 10:59:36', NULL, NULL, 6119, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 10:59:36', 'admin-1484360491-14843627765511355', 1, 0, '', NULL, NULL, NULL),
(17773, '2017-01-14 11:06:16', NULL, NULL, 6119, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 11:06:16', 'admin-1484360491-14843631759602067', 1, 0, '', NULL, NULL, NULL),
(17774, '2017-01-14 11:01:11', NULL, NULL, 6120, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 11:01:11', 'admin-1484360491-14843628708271922', 1, 0, '', NULL, NULL, NULL),
(17775, '2017-01-14 11:01:11', NULL, NULL, 6120, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 11:01:11', 'admin-1484360491-14843628708271922', 1, 1, 'SR', NULL, NULL, NULL),
(17776, '2017-01-14 11:08:54', NULL, NULL, 6121, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 11:08:54', 'admin-1484360491-14843633343779429', 1, 0, '', NULL, NULL, NULL),
(17777, '2017-01-14 11:08:54', NULL, NULL, 6121, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 11:08:54', 'admin-1484360491-14843633343779429', 1, 1, 'SR', NULL, NULL, NULL),
(17778, '2017-01-14 11:35:18', NULL, NULL, 6122, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 11:35:18', 'admin-1484363814-14843649185893855', 1, 1, 'SR', 1, NULL, NULL),
(17779, '2017-01-14 11:35:18', NULL, NULL, 6122, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 11:35:18', 'admin-1484363814-14843649185893855', 1, 1, 'SR', 1, NULL, NULL),
(17780, '2017-01-14 11:36:38', NULL, NULL, 6123, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 11:36:38', 'admin-1484363814-14843649980801016', 1, 1, 'SR', NULL, NULL, NULL),
(17781, '2017-01-14 11:36:38', NULL, NULL, 6123, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 11:36:38', 'admin-1484363814-14843649980801016', 1, 1, 'SR', NULL, NULL, NULL),
(17782, '2017-01-14 13:23:11', NULL, NULL, 6120, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 13:23:11', 'admin-1484363814-14843713910821064', 1, 1, 'SR', NULL, NULL, NULL),
(17783, '2017-01-14 13:36:38', NULL, NULL, 6129, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 13:36:38', 'admin-1484363814-14843721984264680', 1, 0, '', NULL, NULL, NULL),
(17784, '2017-01-14 12:50:14', NULL, NULL, 6127, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 12:50:14', 'admin-1484363814-14843694139813887', 1, 1, 'SR', 1, NULL, NULL),
(17785, '2017-01-14 11:58:14', NULL, NULL, 6126, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 11:58:14', 'admin-1484363814-14843662938744335', 1, 0, '', NULL, NULL, NULL),
(17786, '2017-01-14 12:14:04', NULL, NULL, 6120, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 12:14:04', 'admin-1484363814-14843672447884882', 1, 1, 'SR', NULL, NULL, NULL),
(17787, '2017-01-14 12:42:25', NULL, NULL, 6124, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 12:42:25', 'admin-1484363814-1484368945431344', 1, 1, 'SR', NULL, NULL, NULL),
(17788, '2017-01-14 12:50:14', NULL, NULL, 6127, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 12:50:14', 'admin-1484363814-14843694139813887', 1, 1, 'SR', 1, NULL, NULL),
(17789, '2017-01-14 11:58:04', NULL, NULL, 6126, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 11:58:04', 'admin-1484363814-14843662845254980', 1, 0, '', NULL, NULL, NULL),
(17790, '2017-01-14 11:58:04', NULL, NULL, 6126, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 11:58:04', 'admin-1484363814-14843662845254980', 1, 0, '', NULL, NULL, NULL),
(17791, '2017-01-14 11:55:00', NULL, NULL, 6126, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 11:55:00', 'admin-1484363814-14843661006864422', 1, 1, 'SR', NULL, NULL, NULL),
(17792, '2017-01-14 11:42:57', NULL, NULL, 6124, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 11:42:57', 'admin-1484363814-14843653772479710', 1, 0, '', NULL, NULL, NULL),
(17793, '2017-01-14 11:42:57', NULL, NULL, 6124, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 11:42:57', 'admin-1484363814-14843653772479710', 1, 1, 'SR', NULL, NULL, NULL),
(17794, '2017-01-14 11:42:11', NULL, NULL, 6120, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 11:42:11', 'admin-1484363814-14843653314988927', 1, 1, 'SR', NULL, NULL, NULL),
(17795, '2017-01-14 11:42:00', NULL, NULL, 6120, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 11:42:00', 'admin-1484363814-14843653207484175', 1, 0, '', NULL, NULL, NULL),
(17796, '2017-01-14 11:42:00', NULL, NULL, 6120, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 11:42:00', 'admin-1484363814-14843653207484175', 1, 0, '', NULL, NULL, NULL),
(17797, '2017-01-14 10:22:14', NULL, NULL, 6115, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 10:22:14', 'admin-1484360491-14843605342132794', 1, 1, 'SR', NULL, NULL, NULL),
(17798, '2017-01-14 10:22:14', NULL, NULL, 6115, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 10:22:14', 'admin-1484360491-14843605342132794', 1, 1, 'SR', NULL, NULL, NULL),
(17799, '2017-01-14 10:33:28', NULL, NULL, 6116, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 10:33:28', 'admin-1484360491-1484361208680951', 1, 0, '', NULL, NULL, NULL),
(17800, '2017-01-14 10:33:28', NULL, NULL, 6116, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 10:33:28', 'admin-1484360491-1484361208680951', 1, 1, 'SR', NULL, NULL, NULL),
(17801, '2017-01-14 10:42:15', NULL, NULL, 6117, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 10:42:15', 'admin-1484360491-1484361735216659', 1, 1, 'SR', NULL, NULL, NULL),
(17802, '2017-01-14 09:06:50', NULL, NULL, 6109, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 09:06:50', 'admin-1484354338-1484356010380416', 1, 1, 'SR', NULL, NULL, NULL),
(17803, '2017-01-14 09:20:53', NULL, NULL, 6110, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 09:20:53', 'admin-1484354338-14843568530389038', 1, 1, 'SR', NULL, NULL, NULL),
(17804, '2017-01-14 09:20:53', NULL, NULL, 6110, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 09:20:53', 'admin-1484354338-14843568530389038', 1, 0, '', NULL, NULL, NULL),
(17805, '2017-01-14 09:30:46', NULL, NULL, 6111, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 09:30:46', 'admin-1484354338-14843574460726168', 1, 0, '', NULL, NULL, NULL),
(17806, '2017-01-14 09:30:46', NULL, NULL, 6111, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 09:30:46', 'admin-1484354338-14843574460726168', 1, 0, '', NULL, NULL, NULL),
(17807, '2017-01-14 09:30:46', NULL, NULL, 6111, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 09:30:46', 'admin-1484354338-14843574460726168', 1, 0, '', NULL, NULL, NULL),
(17808, '2017-01-14 09:31:05', NULL, NULL, 6112, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 09:31:05', 'admin-1484354338-14843574652681811', 1, 0, '', NULL, NULL, NULL),
(17809, '2017-01-14 09:31:05', NULL, NULL, 6112, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 09:31:05', 'admin-1484354338-14843574652681811', 1, 1, 'SR', NULL, NULL, NULL),
(17810, '2017-01-14 09:39:06', NULL, NULL, 6111, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 09:39:06', 'admin-1484354338-14843579464547970', 1, 0, '', NULL, NULL, NULL),
(17811, '2017-01-14 10:03:47', NULL, NULL, 6111, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 10:03:47', 'admin-1484354338-14843594266942535', 1, 0, '', NULL, NULL, NULL),
(17812, '2017-01-14 10:20:52', NULL, NULL, 6113, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 10:20:52', 'admin-1484354338-1484360452158846', 1, 1, 'SR', NULL, NULL, NULL),
(17813, '2017-01-14 10:20:52', NULL, NULL, 6113, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 10:20:52', 'admin-1484354338-1484360452158846', 1, 0, '', NULL, NULL, NULL),
(17814, '2017-01-14 10:20:52', NULL, NULL, 6113, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 10:20:52', 'admin-1484354338-1484360452158846', 1, 0, '', NULL, NULL, NULL),
(17815, '2017-01-14 10:21:18', NULL, NULL, 6114, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 10:21:18', 'admin-1484354338-1484360478196533', 1, 0, '', NULL, NULL, NULL),
(17816, '2017-01-14 10:21:18', NULL, NULL, 6114, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 10:21:18', 'admin-1484354338-1484360478196533', 1, 0, '', NULL, NULL, NULL),
(17817, '2017-01-14 10:21:18', NULL, NULL, 6114, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 10:21:18', 'admin-1484354338-1484360478196533', 1, 0, '', NULL, NULL, NULL),
(17818, '2017-01-14 10:21:18', NULL, NULL, 6114, 0, 159, '93', 'Granola ', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 10:21:18', 'admin-1484354338-1484360478196533', 1, 0, '', NULL, NULL, NULL),
(17819, '2017-01-14 10:21:18', NULL, NULL, 6114, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 10:21:18', 'admin-1484354338-1484360478196533', 1, 1, 'SR', NULL, NULL, NULL),
(17820, '2017-01-14 10:21:18', NULL, NULL, 6114, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 10:21:18', 'admin-1484354338-1484360478196533', 1, 1, 'SR', NULL, NULL, NULL),
(17821, '2017-01-14 09:06:50', NULL, NULL, 6109, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 09:06:50', 'admin-1484354338-1484356010380416', 1, 1, 'SR', NULL, NULL, NULL),
(17822, '2017-01-14 09:06:40', NULL, NULL, 6109, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 09:06:40', 'admin-1484354338-14843560007198642', 1, 0, '', NULL, NULL, NULL),
(17823, '2017-01-14 09:06:40', NULL, NULL, 6109, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484375582', 'admin', '2017-01-14 09:06:40', 'admin-1484354338-14843560007198642', 1, 0, '', NULL, NULL, NULL),
(17824, '2017-01-15 16:54:44', NULL, NULL, 6166, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 16:54:44', 'admin-1484454419-14844704844355927', 1, 1, 'SR', 1, NULL, NULL),
(17825, '2017-01-15 15:49:06', NULL, NULL, 6165, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 15:49:06', 'admin-1484454419-14844665467366286', 1, 1, 'SR', NULL, NULL, NULL),
(17826, '2017-01-15 15:49:06', NULL, NULL, 6165, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 15:49:06', 'admin-1484454419-14844665467366286', 1, 1, 'SR', NULL, NULL, NULL),
(17827, '2017-01-15 15:49:06', NULL, NULL, 6165, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 15:49:06', 'admin-1484454419-14844665467366286', 1, 1, 'SR', NULL, NULL, NULL),
(17828, '2017-01-15 15:43:04', NULL, NULL, 6164, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 15:43:04', 'admin-1484454419-14844661845069227', 1, 0, '', NULL, NULL, NULL),
(17829, '2017-01-15 14:33:17', NULL, NULL, 6163, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 14:33:17', 'admin-1484454419-14844619971356943', 1, 1, 'SR', 1, NULL, NULL),
(17830, '2017-01-15 13:42:36', NULL, NULL, 6162, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 13:42:36', 'admin-1484454419-14844589558294444', 1, 1, 'SR', NULL, NULL, NULL),
(17831, '2017-01-15 13:42:30', NULL, NULL, 6162, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 13:42:30', 'admin-1484454419-1484458949932734', 1, 0, '', NULL, NULL, NULL),
(17832, '2017-01-15 13:20:20', NULL, NULL, 6161, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 13:20:20', 'admin-1484454419-14844576203937878', 1, 1, 'SR', NULL, NULL, NULL),
(17833, '2017-01-15 13:03:45', NULL, NULL, 6160, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 13:03:45', 'admin-1484454419-14844566253076129', 1, 0, '', NULL, NULL, NULL),
(17834, '2017-01-15 12:45:28', NULL, NULL, 6159, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 12:45:28', 'admin-1484454419-14844555279461918', 1, 1, 'SR', NULL, NULL, NULL),
(17835, '2017-01-15 12:45:28', NULL, NULL, 6159, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 12:45:28', 'admin-1484454419-14844555279461918', 1, 0, '', NULL, NULL, NULL),
(17836, '2017-01-15 12:45:28', NULL, NULL, 6159, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 12:45:28', 'admin-1484454419-14844555279461918', 1, 0, '', NULL, NULL, NULL),
(17837, '2017-01-15 12:45:49', NULL, NULL, 6159, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 12:45:49', 'admin-1484454419-1484455548961313', 1, 0, '', NULL, NULL, NULL),
(17838, '2017-01-15 12:45:49', NULL, NULL, 6159, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 12:45:49', 'admin-1484454419-1484455548961313', 1, 1, 'SR', NULL, NULL, NULL),
(17839, '2017-01-15 13:03:45', NULL, NULL, 6160, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 13:03:45', 'admin-1484454419-14844566253076129', 1, 1, 'SR', NULL, NULL, NULL),
(17840, '2017-01-15 13:03:45', NULL, NULL, 6160, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 13:03:45', 'admin-1484454419-14844566253076129', 1, 1, 'SR', NULL, NULL, NULL),
(17841, '2017-01-15 13:03:45', NULL, NULL, 6160, 0, 244, '178', 'Macadamia Scones', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 13:03:45', 'admin-1484454419-14844566253076129', 1, 0, '', NULL, NULL, NULL),
(17842, '2017-01-15 13:03:45', NULL, NULL, 6160, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 13:03:45', 'admin-1484454419-14844566253076129', 1, 0, '', NULL, NULL, NULL),
(17843, '2017-01-15 00:00:00', NULL, NULL, 6149, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 11:11:39', 'admin-1484448920-14844498997507989', 1, 0, '', NULL, NULL, NULL),
(17844, '2017-01-15 00:00:00', NULL, NULL, 6144, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:56:10', 'admin-1484448920-14844489700592334', 1, 0, '', NULL, NULL, NULL),
(17845, '2017-01-15 12:13:30', NULL, NULL, 6157, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 12:13:30', 'admin-1484452819-14844536101242131', 1, 1, 'SR', NULL, NULL, NULL),
(17846, '2017-01-15 12:16:50', NULL, NULL, 6156, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 12:16:50', 'admin-1484452819-14844538100686726', 1, 1, 'SR', NULL, NULL, NULL),
(17847, '2017-01-15 12:42:07', NULL, NULL, 6158, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 12:42:07', 'admin-1484454419-14844553268315310', 1, 0, '', NULL, NULL, NULL),
(17848, '2017-01-15 12:42:07', NULL, NULL, 6158, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 12:42:07', 'admin-1484454419-14844553268315310', 1, 0, '', NULL, NULL, NULL),
(17849, '2017-01-15 12:42:07', NULL, NULL, 6158, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1484454419', 'admin', '2017-01-15 12:42:07', 'admin-1484454419-14844553268315310', 1, 0, '', NULL, NULL, NULL),
(17850, '2017-01-15 12:42:07', NULL, NULL, 6158, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 12:42:07', 'admin-1484454419-14844553268315310', 1, 1, 'SR', NULL, NULL, NULL),
(17851, '2017-01-15 00:00:00', NULL, NULL, 6146, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:56:10', 'admin-1484448920-14844489700592334', 1, 1, 'SR', NULL, NULL, NULL),
(17852, '2017-01-15 11:37:26', NULL, NULL, 6148, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 11:37:26', 'admin-1484448920-1484451446543534', 1, 1, 'SR', NULL, NULL, NULL),
(17853, '2017-01-15 00:00:00', NULL, NULL, 6149, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 11:12:01', 'admin-1484448920-14844499216507628', 1, 1, 'SR', NULL, NULL, NULL),
(17854, '2017-01-15 00:00:00', NULL, NULL, 6150, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 11:51:47', 'admin-1484448920-14844523077085738', 1, 0, '', NULL, NULL, NULL),
(17855, '2017-01-15 00:00:00', NULL, NULL, 6150, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 11:51:47', 'admin-1484448920-14844523077085738', 1, 1, 'SR', NULL, NULL, NULL),
(17856, '2017-01-15 00:00:00', NULL, NULL, 6152, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 11:12:01', 'admin-1484448920-14844499216507628', 1, 1, 'SR', NULL, NULL, NULL),
(17857, '2017-01-15 00:00:00', NULL, NULL, 6151, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 11:52:36', 'admin-1484448920-1484452355927396', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(17858, '2017-01-15 00:00:00', NULL, NULL, 6151, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 11:52:36', 'admin-1484448920-1484452355927396', 1, 0, '', NULL, NULL, NULL),
(17859, '2017-01-15 11:56:57', NULL, NULL, 6154, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 11:56:57', 'admin-1484448920-1484452617004391', 1, 0, '', NULL, NULL, NULL),
(17860, '2017-01-15 11:56:57', NULL, NULL, 6154, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 11:56:57', 'admin-1484448920-1484452617004391', 1, 0, '', NULL, NULL, NULL),
(17861, '2017-01-15 11:56:57', NULL, NULL, 6154, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 11:56:57', 'admin-1484448920-1484452617004391', 1, 0, '', NULL, NULL, NULL),
(17862, '2017-01-15 11:57:19', NULL, NULL, 6154, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 11:57:19', 'admin-1484448920-14844526393641521', 1, 1, 'SR', NULL, NULL, NULL),
(17863, '2017-01-15 11:57:19', NULL, NULL, 6154, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 11:57:19', 'admin-1484448920-14844526393641521', 1, 0, '', NULL, NULL, NULL),
(17864, '2017-01-15 11:57:19', NULL, NULL, 6154, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 11:57:19', 'admin-1484448920-14844526393641521', 1, 1, 'SR', NULL, NULL, NULL),
(17865, '2017-01-15 11:57:48', NULL, NULL, 6155, 0, 182, '117', 'Open Drinks ', 'Wallmug', 'Cold Drinks', 'Fresh Juice', 1, 79.00, 79.0000, 0.0000, 79.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 11:57:48', 'admin-1484448920-1484452667953104', 1, 0, '', 1, NULL, NULL),
(17866, '2017-01-15 12:00:12', NULL, NULL, 6156, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 12:00:12', 'admin-1484448920-1484452812594169', 1, 1, 'SR', NULL, NULL, NULL),
(17867, '2017-01-15 12:13:30', NULL, NULL, 6157, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 12:13:30', 'admin-1484452819-14844536101242131', 1, 1, 'SR', NULL, NULL, NULL),
(17868, '2017-01-15 17:23:13', NULL, NULL, 6167, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 17:23:13', 'admin-1484454419-1484472193220661', 1, 0, '', NULL, NULL, NULL),
(17869, '2017-01-15 16:54:44', NULL, NULL, 6166, 0, 181, '116', 'Open Food ', 'Scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 16:54:44', 'admin-1484454419-14844704844355927', 1, 0, '', 1, NULL, NULL),
(17870, '2017-01-15 17:23:13', NULL, NULL, 6167, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 17:23:13', 'admin-1484454419-1484472193220661', 1, 1, 'SR', NULL, NULL, NULL),
(17871, '2017-01-15 12:44:03', NULL, NULL, 6158, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 12:44:03', 'admin-1484454419-14844554432633348', 1, 0, '', NULL, NULL, NULL),
(17872, '2017-01-15 12:42:07', NULL, NULL, 6158, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 12:42:07', 'admin-1484454419-14844553268315310', 1, 1, 'SR', NULL, NULL, NULL),
(17873, '2017-01-15 00:00:00', NULL, NULL, 6152, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 11:11:39', 'admin-1484448920-14844498997507989', 1, 0, '', NULL, NULL, NULL),
(17874, '2017-01-15 00:00:00', NULL, NULL, 6147, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:56:10', 'admin-1484448920-14844489700592334', 1, 0, '', NULL, NULL, NULL),
(17875, '2017-01-15 12:00:12', NULL, NULL, 6156, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 12:00:12', 'admin-1484448920-1484452812594169', 1, 0, '', NULL, NULL, NULL),
(17876, '2017-01-15 00:00:00', NULL, NULL, 6153, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 11:12:01', 'admin-1484448920-14844499216507628', 1, 1, 'SR', NULL, NULL, NULL),
(17877, '2017-01-15 00:00:00', NULL, NULL, 6153, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 11:11:39', 'admin-1484448920-14844498997507989', 1, 0, '', NULL, NULL, NULL),
(17878, '2017-01-15 00:00:00', NULL, NULL, 6151, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 11:52:36', 'admin-1484448920-1484452355927396', 1, 1, 'SR', NULL, NULL, NULL),
(17879, '2017-01-15 00:00:00', NULL, NULL, 6145, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:56:10', 'admin-1484448920-14844489700592334', 1, 0, '', NULL, NULL, NULL),
(17880, '2017-01-15 00:00:00', NULL, NULL, 6145, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:56:10', 'admin-1484448920-14844489700592334', 1, 1, 'SR', NULL, NULL, NULL),
(17881, '2017-01-15 00:00:00', NULL, NULL, 6144, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:56:10', 'admin-1484448920-14844489700592334', 1, 1, 'SR', NULL, NULL, NULL),
(17882, '2017-01-15 00:00:00', NULL, NULL, 6147, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:56:10', 'admin-1484448920-14844489700592334', 1, 0, '', NULL, NULL, NULL),
(17883, '2017-01-15 00:00:00', NULL, NULL, 6147, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:57:35', 'admin-1484448920-14844490551277878', 1, 1, 'SR', NULL, NULL, NULL),
(17884, '2017-01-15 00:00:00', NULL, NULL, 6147, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:56:10', 'admin-1484448920-14844489700592334', 1, 0, '', NULL, NULL, NULL),
(17885, '2017-01-15 00:00:00', NULL, NULL, 6144, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:56:10', 'admin-1484448920-14844489700592334', 1, 0, '', NULL, NULL, NULL),
(17886, '2017-01-15 09:54:51', NULL, NULL, 6135, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 09:54:51', 'admin-1484440961-14844452914316990', 1, 0, '', NULL, NULL, NULL),
(17887, '2017-01-15 09:54:51', NULL, NULL, 6135, 0, 161, '95', 'Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 09:54:51', 'admin-1484440961-14844452914316990', 1, 0, '', NULL, NULL, NULL),
(17888, '2017-01-15 09:55:07', NULL, NULL, 6135, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 09:55:07', 'admin-1484440961-14844453072547388', 1, 1, 'SR', NULL, NULL, NULL),
(17889, '2017-01-15 09:55:07', NULL, NULL, 6135, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 09:55:07', 'admin-1484440961-14844453072547388', 1, 1, 'SR', NULL, NULL, NULL),
(17890, '2017-01-15 09:55:07', NULL, NULL, 6135, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 09:55:07', 'admin-1484440961-14844453072547388', 1, 1, 'SR', NULL, NULL, NULL),
(17891, '2017-01-15 10:01:23', NULL, NULL, 6136, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:01:23', 'admin-1484440961-1484445682850687', 1, 0, '', NULL, NULL, NULL),
(17892, '2017-01-15 10:01:23', NULL, NULL, 6136, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:01:23', 'admin-1484440961-1484445682850687', 1, 0, '', NULL, NULL, NULL),
(17893, '2017-01-15 10:01:36', NULL, NULL, 6136, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:01:36', 'admin-1484440961-14844456966746596', 1, 1, 'SR', NULL, NULL, NULL),
(17894, '2017-01-15 10:01:36', NULL, NULL, 6136, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:01:36', 'admin-1484440961-14844456966746596', 1, 1, 'SR', NULL, NULL, NULL),
(17895, '2017-01-15 10:01:36', NULL, NULL, 6136, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:01:36', 'admin-1484440961-14844456966746596', 1, 0, '', NULL, NULL, NULL),
(17896, '2017-01-15 10:06:03', NULL, NULL, 6137, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:06:03', 'admin-1484440961-14844459630992217', 1, 1, 'SR', NULL, NULL, NULL),
(17897, '2017-01-15 10:19:43', NULL, NULL, 6138, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:19:43', 'admin-1484440961-14844467837866516', 1, 1, 'SR', NULL, NULL, NULL),
(17898, '2017-01-15 10:21:37', NULL, NULL, 6138, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:21:37', 'admin-1484440961-14844468969297297', 1, 1, 'SR', NULL, NULL, NULL),
(17899, '2017-01-15 10:29:13', NULL, NULL, 6139, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:29:13', 'admin-1484440961-14844473534789721', 1, 0, '', NULL, NULL, NULL),
(17900, '2017-01-15 10:29:13', NULL, NULL, 6139, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:29:13', 'admin-1484440961-14844473534789721', 1, 0, '', NULL, NULL, NULL),
(17901, '2017-01-15 10:45:23', NULL, NULL, 6140, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:45:23', 'admin-1484440961-14844483231494018', 1, 1, 'SR', NULL, NULL, NULL),
(17902, '2017-01-15 10:45:23', NULL, NULL, 6140, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:45:23', 'admin-1484440961-14844483231494018', 1, 0, '', NULL, NULL, NULL),
(17903, '2017-01-15 10:48:29', NULL, NULL, 6141, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:48:29', 'admin-1484440961-14844485095912762', 1, 0, '', NULL, NULL, NULL),
(17904, '2017-01-15 10:48:29', NULL, NULL, 6141, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:48:29', 'admin-1484440961-14844485095912762', 1, 0, '', NULL, NULL, NULL),
(17905, '2017-01-15 10:48:29', NULL, NULL, 6141, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:48:29', 'admin-1484440961-14844485095912762', 1, 1, 'SR', NULL, NULL, NULL),
(17906, '2017-01-15 10:48:29', NULL, NULL, 6141, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:48:29', 'admin-1484440961-14844485095912762', 1, 1, 'SR', NULL, NULL, NULL),
(17907, '2017-01-15 10:52:48', NULL, NULL, 6141, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:52:48', 'admin-1484440961-14844487681008041', 1, 0, '', NULL, NULL, NULL),
(17908, '2017-01-15 11:37:26', NULL, NULL, 6148, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 11:37:26', 'admin-1484448920-1484451446543534', 1, 1, 'SR', NULL, NULL, NULL),
(17909, '2017-01-15 00:00:00', NULL, NULL, 6146, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 10:56:10', 'admin-1484448920-14844489700592334', 1, 0, '', NULL, NULL, NULL),
(17910, '2017-01-15 09:54:51', NULL, NULL, 6135, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 09:54:51', 'admin-1484440961-14844452914316990', 1, 0, '', NULL, NULL, NULL),
(17911, '2017-01-15 09:39:55', NULL, NULL, 6134, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 09:39:55', 'admin-1484440961-1484444395035197', 1, 1, 'SR', NULL, NULL, NULL),
(17912, '2017-01-15 09:39:55', NULL, NULL, 6134, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484454419', 'admin', '2017-01-15 09:39:55', 'admin-1484440961-1484444395035197', 1, 1, 'SR', NULL, NULL, NULL),
(17913, '2017-01-16 18:30:15', NULL, NULL, 6193, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 18:30:15', 'admin-1484555618-1484562615103781', 1, 0, '', NULL, NULL, NULL),
(17914, '2017-01-16 17:14:35', NULL, NULL, 6189, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 17:14:35', 'admin-1484555618-14845580756447244', 1, 0, '', NULL, NULL, NULL),
(17915, '2017-01-16 18:20:32', NULL, NULL, 6192, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 18:20:32', 'admin-1484555618-14845620324171824', 1, 0, '', NULL, NULL, NULL),
(17916, '2017-01-16 18:20:32', NULL, NULL, 6192, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 18:20:32', 'admin-1484555618-14845620324171824', 1, 0, '', NULL, NULL, NULL),
(17917, '2017-01-16 18:20:32', NULL, NULL, 6192, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 18:20:32', 'admin-1484555618-14845620324171824', 1, 0, '', NULL, NULL, NULL),
(17918, '2017-01-16 18:20:32', NULL, NULL, 6192, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 18:20:32', 'admin-1484555618-14845620324171824', 1, 0, '', NULL, NULL, NULL),
(17919, '2017-01-16 18:20:32', NULL, NULL, 6192, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 18:20:32', 'admin-1484555618-14845620324171824', 1, 0, '', NULL, NULL, NULL),
(17920, '2017-01-16 18:20:39', NULL, NULL, 6192, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 18:20:39', 'admin-1484555618-14845620389517322', 1, 1, 'SR', NULL, NULL, NULL),
(17921, '2017-01-16 21:14:26', NULL, NULL, 6199, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 21:14:26', 'admin-1484568062-14845724660618990', 1, 1, 'SR', NULL, NULL, NULL),
(17922, '2017-01-16 20:42:18', NULL, NULL, 6199, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 20:42:18', 'admin-1484568062-14845705384411034', 1, 0, '', NULL, NULL, NULL),
(17923, '2017-01-16 20:32:49', NULL, NULL, 6199, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 20:32:49', 'admin-1484568062-14845699693818850', 1, 0, '', NULL, NULL, NULL),
(17924, '2017-01-16 20:23:59', NULL, NULL, 6198, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 20:23:59', 'admin-1484568062-14845694392485371', 1, 1, 'SR', NULL, NULL, NULL),
(17925, '2017-01-16 20:23:59', NULL, NULL, 6198, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 20:23:59', 'admin-1484568062-14845694392485371', 1, 1, 'SR', NULL, NULL, NULL),
(17926, '2017-01-16 20:22:29', NULL, NULL, 6197, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 20:22:29', 'admin-1484568062-14845693488641698', 1, 0, '', NULL, NULL, NULL),
(17927, '2017-01-16 20:01:11', NULL, NULL, 6196, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 20:01:11', 'admin-1484568062-14845680716843367', 1, 1, 'SR', NULL, NULL, NULL),
(17928, '2017-01-16 14:13:58', NULL, NULL, 6184, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 14:13:58', 'admin-1484528783-14845472385143031', 1, 0, '', NULL, NULL, NULL),
(17929, '2017-01-16 14:48:48', NULL, NULL, 6186, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 14:48:48', 'admin-1484528783-14845493283168630', 1, 0, '', NULL, NULL, NULL),
(17930, '2017-01-16 16:32:41', NULL, NULL, 6188, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 16:32:41', 'admin-1484528783-14845555613598543', 1, 1, 'SR', NULL, NULL, NULL),
(17931, '2017-01-16 16:32:41', NULL, NULL, 6188, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 16:32:41', 'admin-1484528783-14845555613598543', 1, 0, '', NULL, NULL, NULL),
(17932, '2017-01-16 16:33:27', NULL, NULL, 6189, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 16:33:27', 'admin-1484528783-14845556073029478', 1, 1, 'SR', NULL, NULL, NULL),
(17933, '2017-01-16 16:33:27', NULL, NULL, 6189, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 16:33:27', 'admin-1484528783-14845556073029478', 1, 0, '', NULL, NULL, NULL),
(17934, '2017-01-16 16:33:27', NULL, NULL, 6189, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 16:33:27', 'admin-1484528783-14845556073029478', 1, 0, '', NULL, NULL, NULL),
(17935, '2017-01-16 16:34:44', NULL, NULL, 6190, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 16:34:44', 'admin-1484555618-14845556839432223', 1, 1, 'SR', 1, NULL, NULL),
(17936, '2017-01-16 16:34:44', NULL, NULL, 6190, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 16:34:44', 'admin-1484555618-14845556839432223', 1, 1, 'SR', 1, NULL, NULL),
(17937, '2017-01-16 16:55:34', NULL, NULL, 6189, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 16:55:34', 'admin-1484555618-14845569339133261', 1, 0, '', NULL, NULL, NULL),
(17938, '2017-01-16 10:07:13', NULL, NULL, 6169, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 10:07:13', 'admin-1484528783-14845324335961717', 1, 1, 'SR', NULL, NULL, NULL),
(17939, '2017-01-16 10:07:13', NULL, NULL, 6169, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 10:07:13', 'admin-1484528783-14845324335961717', 1, 1, 'SR', NULL, NULL, NULL),
(17940, '2017-01-16 10:10:27', NULL, NULL, 6169, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 10:10:27', 'admin-1484528783-14845326273821037', 1, 0, '', NULL, NULL, NULL),
(17941, '2017-01-16 10:10:27', NULL, NULL, 6169, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 10:10:27', 'admin-1484528783-14845326273821037', 1, 1, 'SR', NULL, NULL, NULL),
(17942, '2017-01-16 10:15:12', NULL, NULL, 6170, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 10:15:12', 'admin-1484528783-14845329119925685', 1, 0, '', NULL, NULL, NULL),
(17943, '2017-01-16 10:15:12', NULL, NULL, 6170, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 10:15:12', 'admin-1484528783-14845329119925685', 1, 0, '', NULL, NULL, NULL),
(17944, '2017-01-16 10:15:12', NULL, NULL, 6170, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 10:15:12', 'admin-1484528783-14845329119925685', 1, 0, '', NULL, NULL, NULL),
(17945, '2017-01-16 20:01:11', NULL, NULL, 6196, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 20:01:11', 'admin-1484568062-14845680716843367', 1, 1, 'SR', NULL, NULL, NULL),
(17946, '2017-01-16 10:15:12', NULL, NULL, 6170, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 10:15:12', 'admin-1484528783-14845329119925685', 1, 0, '', NULL, NULL, NULL),
(17947, '2017-01-16 10:15:12', NULL, NULL, 6170, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 10:15:12', 'admin-1484528783-14845329119925685', 1, 0, '', NULL, NULL, NULL),
(17948, '2017-01-16 10:15:12', NULL, NULL, 6170, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 10:15:12', 'admin-1484528783-14845329119925685', 1, 0, '', NULL, NULL, NULL),
(17949, '2017-01-16 10:15:12', NULL, NULL, 6170, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 10:15:12', 'admin-1484528783-14845329119925685', 1, 1, 'SR', NULL, NULL, NULL),
(17950, '2017-01-16 10:15:12', NULL, NULL, 6170, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 10:15:12', 'admin-1484528783-14845329119925685', 1, 1, 'SR', NULL, NULL, NULL),
(17951, '2017-01-16 19:54:30', NULL, NULL, 6196, 0, 246, '180', 'Noodle Soup', '', 'Meals', 'Perfect Meals', 1, 15.90, 15.9000, 0.0000, 15.90, 1, '27', 1, '1484568062', 'admin', '2017-01-16 19:54:30', 'admin-1484555618-1484567670168738', 1, 0, '', NULL, NULL, NULL),
(17952, '2017-01-16 19:53:25', NULL, NULL, 6196, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1484568062', 'admin', '2017-01-16 19:53:25', 'admin-1484555618-14845676051679827', 1, 0, '', NULL, NULL, NULL),
(17953, '2017-01-16 13:12:03', NULL, NULL, 6186, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 13:12:03', 'admin-1484528783-14845435228808557', 1, 0, '', NULL, NULL, NULL),
(17954, '2017-01-16 19:53:25', NULL, NULL, 6196, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 19:53:25', 'admin-1484555618-14845676051679827', 1, 1, 'SR', NULL, NULL, NULL),
(17955, '2017-01-16 18:51:28', NULL, NULL, 6195, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 18:51:28', 'admin-1484555618-1484563887921136', 1, 0, '', NULL, NULL, NULL),
(17956, '2017-01-16 18:41:20', NULL, NULL, 6194, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 18:41:20', 'admin-1484555618-1484563280298234', 1, 1, 'SR', NULL, NULL, NULL),
(17957, '2017-01-16 18:41:20', NULL, NULL, 6194, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 18:41:20', 'admin-1484555618-1484563280298234', 1, 1, 'SR', NULL, NULL, NULL),
(17958, '2017-01-16 18:41:20', NULL, NULL, 6194, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 18:41:20', 'admin-1484555618-1484563280298234', 1, 1, 'SR', NULL, NULL, NULL),
(17959, '2017-01-16 18:41:20', NULL, NULL, 6194, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 18:41:20', 'admin-1484555618-1484563280298234', 1, 1, 'SR', NULL, NULL, NULL),
(17960, '2017-01-16 18:30:15', NULL, NULL, 6193, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 18:30:15', 'admin-1484555618-1484562615103781', 1, 1, 'SR', NULL, NULL, NULL),
(17961, '2017-01-16 18:20:39', NULL, NULL, 6192, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 18:20:39', 'admin-1484555618-14845620389517322', 1, 1, 'SR', NULL, NULL, NULL),
(17962, '2017-01-16 16:56:08', NULL, NULL, 6191, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 16:56:08', 'admin-1484555618-14845569682155755', 1, 1, 'SR', NULL, NULL, NULL),
(17963, '2017-01-16 13:51:13', NULL, NULL, 6184, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 13:51:13', 'admin-1484528783-14845458734339598', 1, 1, 'SR', NULL, NULL, NULL),
(17964, '2017-01-16 13:51:13', NULL, NULL, 6184, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 13:51:13', 'admin-1484528783-14845458734339598', 1, 1, 'SR', NULL, NULL, NULL),
(17965, '2017-01-16 13:32:03', NULL, NULL, 6187, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 13:32:03', 'admin-1484528783-14845447237831183', 1, 1, 'SR', 1, NULL, NULL),
(17966, '2017-01-16 13:27:50', NULL, NULL, 6182, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 13:27:50', 'admin-1484528783-14845444702835431', 1, 1, 'SR', NULL, NULL, NULL),
(17967, '2017-01-16 13:18:55', NULL, NULL, 6178, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 13:18:55', 'admin-1484528783-14845439352317736', 1, 0, '', NULL, NULL, NULL),
(17968, '2017-01-16 13:12:36', NULL, NULL, 6182, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 13:12:36', 'admin-1484528783-14845435563806196', 1, 1, 'SR', NULL, NULL, NULL),
(17969, '2017-01-16 13:12:03', NULL, NULL, 6186, 0, 213, '147', 'Set Stir Fried Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 13:12:03', 'admin-1484528783-14845435228808557', 1, 0, '', NULL, NULL, NULL),
(17970, '2017-01-16 13:12:03', NULL, NULL, 6186, 0, 214, '148', 'Set Fried Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 13:12:03', 'admin-1484528783-14845435228808557', 1, 0, '', NULL, NULL, NULL),
(17971, '2017-01-16 13:10:40', NULL, NULL, 6185, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 13:10:40', 'admin-1484528783-14845434406698912', 1, 1, 'SR', 1, NULL, NULL),
(17972, '2017-01-16 13:06:14', NULL, NULL, 6184, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 13:06:14', 'admin-1484528783-14845431746649817', 1, 0, '', NULL, NULL, NULL),
(17973, '2017-01-16 13:06:14', NULL, NULL, 6184, 0, 213, '147', 'Set Stir Fried Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 13:06:14', 'admin-1484528783-14845431746649817', 1, 0, '', NULL, NULL, NULL),
(17974, '2017-01-16 13:03:56', NULL, NULL, 6183, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 13:03:56', 'admin-1484528783-14845430358278817', 1, 1, 'SR', NULL, NULL, NULL),
(17975, '2017-01-16 13:03:56', NULL, NULL, 6183, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 13:03:56', 'admin-1484528783-14845430358278817', 1, 1, 'SR', NULL, NULL, NULL),
(17976, '2017-01-16 13:03:56', NULL, NULL, 6183, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 13:03:56', 'admin-1484528783-14845430358278817', 1, 0, '', NULL, NULL, NULL),
(17977, '2017-01-16 13:02:01', NULL, NULL, 6182, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 13:02:01', 'admin-1484528783-14845429212981197', 1, 1, 'SR', NULL, NULL, NULL),
(17978, '2017-01-16 13:00:49', NULL, NULL, 6181, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 13:00:49', 'admin-1484528783-14845428493918237', 1, 1, 'SR', NULL, NULL, NULL),
(17979, '2017-01-16 13:00:49', NULL, NULL, 6181, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 13:00:49', 'admin-1484528783-14845428493918237', 1, 1, 'SR', NULL, NULL, NULL),
(17980, '2017-01-16 12:39:02', NULL, NULL, 6180, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 12:39:02', 'admin-1484528783-14845415418354243', 1, 1, 'SR', NULL, NULL, NULL),
(17981, '2017-01-16 12:19:53', NULL, NULL, 6170, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 12:19:53', 'admin-1484528783-14845403937635857', 1, 0, '', NULL, NULL, NULL),
(17982, '2017-01-16 12:06:03', NULL, NULL, 6177, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 12:06:03', 'admin-1484528783-14845395631819211', 1, 1, 'SR', NULL, NULL, NULL),
(17983, '2017-01-16 12:03:10', NULL, NULL, 6179, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 12:03:10', 'admin-1484528783-14845393905216684', 1, 0, '', NULL, NULL, NULL),
(17984, '2017-01-16 12:03:10', NULL, NULL, 6179, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 12:03:10', 'admin-1484528783-14845393905216684', 1, 1, 'SR', NULL, NULL, NULL),
(17985, '2017-01-16 11:56:30', NULL, NULL, 6178, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 11:56:30', 'admin-1484528783-14845389904939292', 1, 0, '', NULL, NULL, NULL),
(17986, '2017-01-16 11:51:52', NULL, NULL, 6178, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 11:51:52', 'admin-1484528783-14845387122469340', 1, 1, 'SR', NULL, NULL, NULL),
(17987, '2017-01-16 11:51:52', NULL, NULL, 6178, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 11:51:52', 'admin-1484528783-14845387122469340', 1, 1, 'SR', NULL, NULL, NULL),
(17988, '2017-01-16 11:51:52', NULL, NULL, 6178, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 11:51:52', 'admin-1484528783-14845387122469340', 1, 0, '', NULL, NULL, NULL),
(17989, '2017-01-16 11:45:30', NULL, NULL, 6177, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 11:45:30', 'admin-1484528783-1484538330240210', 1, 1, 'SR', NULL, NULL, NULL),
(17990, '2017-01-16 11:41:04', NULL, NULL, 6176, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 11:41:04', 'admin-1484528783-14845380643404554', 1, 1, 'SR', 1, NULL, NULL),
(17991, '2017-01-16 11:40:18', NULL, NULL, 6175, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 11:40:18', 'admin-1484528783-14845380183369796', 1, 1, 'SR', 1, NULL, NULL),
(17992, '2017-01-16 10:54:52', NULL, NULL, 6174, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 10:54:52', 'admin-1484528783-14845352918294595', 1, 1, 'SR', NULL, NULL, NULL),
(17993, '2017-01-16 10:54:52', NULL, NULL, 6174, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 10:54:52', 'admin-1484528783-14845352918294595', 1, 0, '', NULL, NULL, NULL),
(17994, '2017-01-16 10:25:19', NULL, NULL, 6173, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 10:25:19', 'admin-1484528783-14845335190367875', 1, 1, 'SR', NULL, NULL, NULL),
(17995, '2017-01-16 10:25:19', NULL, NULL, 6173, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 10:25:19', 'admin-1484528783-14845335190367875', 1, 1, 'SR', NULL, NULL, NULL),
(17996, '2017-01-16 10:24:40', NULL, NULL, 6172, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 10:24:40', 'admin-1484528783-1484533480325161', 1, 0, '', NULL, NULL, NULL),
(17997, '2017-01-16 10:23:55', NULL, NULL, 6171, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 10:23:55', 'admin-1484528783-14845334356399589', 1, 1, 'SR', NULL, NULL, NULL),
(17998, '2017-01-16 10:24:40', NULL, NULL, 6172, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 10:24:40', 'admin-1484528783-1484533480325161', 1, 1, 'SR', NULL, NULL, NULL),
(17999, '2017-01-16 10:23:55', NULL, NULL, 6171, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 10:23:55', 'admin-1484528783-14845334356399589', 1, 1, 'SR', NULL, NULL, NULL),
(18000, '2017-01-16 10:07:04', NULL, NULL, 6169, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 10:07:04', 'admin-1484528783-1484532424760447', 1, 0, '', NULL, NULL, NULL),
(18001, '2017-01-16 09:10:41', NULL, NULL, 6168, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 09:10:41', 'admin-1484528783-14845290408188347', 1, 0, '', NULL, NULL, NULL),
(18002, '2017-01-16 09:10:40', NULL, NULL, 6168, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484568062', 'admin', '2017-01-16 09:10:40', 'admin-1484528783-14845290408188347', 1, 0, '', NULL, NULL, NULL),
(18003, '2017-01-18 13:10:37', NULL, NULL, 6217, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 13:10:37', 'admin-1484712158-1484716237015728', 1, 0, '', NULL, NULL, NULL),
(18004, '2017-01-18 13:10:45', NULL, NULL, 6217, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 13:10:45', 'admin-1484712158-14847162457249936', 1, 1, 'SR', NULL, NULL, NULL),
(18005, '2017-01-18 13:10:45', NULL, NULL, 6217, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 13:10:45', 'admin-1484712158-14847162457249936', 1, 1, 'SR', NULL, NULL, NULL),
(18006, '2017-01-18 13:17:06', NULL, NULL, 6216, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 13:17:06', 'admin-1484712158-14847166259146891', 1, 1, 'SR', NULL, NULL, NULL),
(18007, '2017-01-18 13:17:06', NULL, NULL, 6216, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 13:17:06', 'admin-1484712158-14847166259146891', 1, 1, 'SR', NULL, NULL, NULL),
(18008, '2017-01-18 13:17:06', NULL, NULL, 6216, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 13:17:06', 'admin-1484712158-14847166259146891', 1, 1, 'SR', NULL, NULL, NULL),
(18009, '2017-01-18 13:23:23', NULL, NULL, 6216, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 13:23:23', 'admin-1484716636-14847170034903384', 1, 1, 'SR', NULL, NULL, NULL),
(18010, '2017-01-18 13:31:01', NULL, NULL, 6215, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 13:31:01', 'admin-1484716636-14847174612733641', 1, 1, 'SR', NULL, NULL, NULL),
(18011, '2017-01-18 13:32:38', NULL, NULL, 6215, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 13:32:38', 'admin-1484716636-14847175579794149', 1, 0, '', NULL, NULL, NULL),
(18012, '2017-01-18 19:10:19', NULL, NULL, 6225, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 19:10:19', 'admin-1484716636-14847378197164142', 1, 1, 'SR', NULL, NULL, NULL),
(18013, '2017-01-18 16:43:54', NULL, NULL, 6223, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 16:43:54', 'admin-1484716636-14847290346433979', 1, 1, 'SR', NULL, NULL, NULL),
(18014, '2017-01-18 13:10:37', NULL, NULL, 6217, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 13:10:37', 'admin-1484712158-1484716237015728', 1, 0, '', NULL, NULL, NULL),
(18015, '2017-01-18 12:01:39', NULL, NULL, 6213, 0, 214, '148', 'Set Fried Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 12:01:39', 'admin-1484699744-14847120995611257', 1, 0, '', NULL, NULL, NULL),
(18016, '2017-01-18 19:10:09', NULL, NULL, 6225, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 19:10:09', 'admin-1484716636-14847378093575352', 1, 0, '', NULL, NULL, NULL),
(18017, '2017-01-18 19:10:09', NULL, NULL, 6225, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 19:10:09', 'admin-1484716636-14847378093575352', 1, 0, '', NULL, NULL, NULL),
(18018, '2017-01-18 19:10:09', NULL, NULL, 6225, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 19:10:09', 'admin-1484716636-14847378093575352', 1, 1, 'SR', NULL, NULL, NULL),
(18019, '2017-01-18 18:29:29', NULL, NULL, 6225, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 18:29:29', 'admin-1484716636-14847353695471016', 1, 1, 'SR', NULL, NULL, NULL),
(18020, '2017-01-18 18:29:29', NULL, NULL, 6225, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 18:29:29', 'admin-1484716636-14847353695471016', 1, 0, '', NULL, NULL, NULL),
(18021, '2017-01-18 18:28:52', NULL, NULL, 6226, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 18:28:52', 'admin-1484716636-14847353327005893', 1, 1, 'SR', NULL, NULL, NULL),
(18022, '2017-01-18 18:22:21', NULL, NULL, 6225, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 18:22:21', 'admin-1484716636-14847349409395877', 1, 0, '', NULL, NULL, NULL),
(18023, '2017-01-18 18:22:21', NULL, NULL, 6225, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 18:22:21', 'admin-1484716636-14847349409395877', 1, 1, 'SR', NULL, NULL, NULL),
(18024, '2017-01-18 18:08:40', NULL, NULL, 6225, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 18:08:40', 'admin-1484716636-14847341200144836', 1, 0, '', NULL, NULL, NULL),
(18025, '2017-01-18 18:08:40', NULL, NULL, 6225, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 18:08:40', 'admin-1484716636-14847341200144836', 1, 0, '', NULL, NULL, NULL),
(18026, '2017-01-18 18:08:40', NULL, NULL, 6225, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 18:08:40', 'admin-1484716636-14847341200144836', 1, 0, '', NULL, NULL, NULL),
(18027, '2017-01-18 16:45:04', NULL, NULL, 6224, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 16:45:04', 'admin-1484716636-14847291045253323', 1, 1, 'SR', 1, NULL, NULL),
(18028, '2017-01-18 16:45:04', NULL, NULL, 6224, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 16:45:04', 'admin-1484716636-14847291045253323', 1, 0, '', 1, NULL, NULL),
(18029, '2017-01-18 15:14:37', NULL, NULL, 6220, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 15:14:37', 'admin-1484716636-14847236771204666', 1, 1, 'SR', NULL, NULL, NULL),
(18030, '2017-01-18 15:43:13', NULL, NULL, 6221, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 15:43:13', 'admin-1484716636-14847253935564042', 1, 1, 'SR', 1, NULL, NULL),
(18031, '2017-01-18 15:43:13', NULL, NULL, 6221, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 15:43:13', 'admin-1484716636-14847253935564042', 1, 1, 'SR', 1, NULL, NULL),
(18032, '2017-01-18 16:16:35', NULL, NULL, 6222, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 16:16:35', 'admin-1484716636-14847273950937244', 1, 1, 'SR', 1, NULL, NULL),
(18033, '2017-01-18 16:43:54', NULL, NULL, 6223, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 16:43:54', 'admin-1484716636-14847290346433979', 1, 1, 'SR', NULL, NULL, NULL),
(18034, '2017-01-18 15:14:37', NULL, NULL, 6220, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 15:14:37', 'admin-1484716636-14847236771204666', 1, 1, 'SR', NULL, NULL, NULL),
(18035, '2017-01-18 14:24:32', NULL, NULL, 6219, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 14:24:32', 'admin-1484716636-14847206722987218', 1, 1, 'SR', NULL, NULL, NULL),
(18036, '2017-01-18 14:24:32', NULL, NULL, 6219, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 14:24:32', 'admin-1484716636-14847206722987218', 1, 1, 'SR', NULL, NULL, NULL),
(18037, '2017-01-18 12:01:59', NULL, NULL, 6213, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 12:01:59', 'admin-1484712110-14847121188579556', 1, 0, '', NULL, NULL, NULL),
(18038, '2017-01-18 12:02:30', NULL, NULL, 6214, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 12:02:30', 'admin-1484712110-14847121498596280', 1, 1, 'SR', NULL, NULL, NULL),
(18039, '2017-01-18 12:02:30', NULL, NULL, 6214, 0, 181, '116', 'Open Food ', 'vege rice', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 12:02:30', 'admin-1484712110-14847121498596280', 1, 0, '', NULL, NULL, NULL),
(18040, '2017-01-18 12:02:30', NULL, NULL, 6214, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 12:02:30', 'admin-1484712110-14847121498596280', 1, 1, 'SR', NULL, NULL, NULL),
(18041, '2017-01-18 12:02:30', NULL, NULL, 6214, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 12:02:30', 'admin-1484712110-14847121498596280', 1, 1, 'SR', NULL, NULL, NULL),
(18042, '2017-01-18 12:02:55', NULL, NULL, 6213, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 12:02:55', 'admin-1484712158-14847121753064762', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(18043, '2017-01-18 12:21:15', NULL, NULL, 6215, 0, 213, '147', 'Set Stir Fried Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 12:21:15', 'admin-1484712158-14847132749912941', 1, 0, '', NULL, NULL, NULL),
(18044, '2017-01-18 12:21:15', NULL, NULL, 6215, 0, 214, '148', 'Set Fried Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 12:21:15', 'admin-1484712158-14847132749912941', 1, 0, '', NULL, NULL, NULL),
(18045, '2017-01-18 12:23:20', NULL, NULL, 6213, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 12:23:20', 'admin-1484712158-1484713400268326', 1, 1, 'SR', NULL, NULL, NULL),
(18046, '2017-01-18 13:58:38', NULL, NULL, 6216, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 13:58:38', 'admin-1484716636-14847191179601524', 1, 0, '', NULL, NULL, NULL),
(18047, '2017-01-18 12:23:36', NULL, NULL, 6216, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 12:23:36', 'admin-1484712158-1484713416560759', 1, 0, '', NULL, NULL, NULL),
(18048, '2017-01-18 12:40:43', NULL, NULL, 6216, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 12:40:43', 'admin-1484712158-14847144430788380', 1, 1, 'SR', NULL, NULL, NULL),
(18049, '2017-01-18 12:23:36', NULL, NULL, 6216, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 12:23:36', 'admin-1484712158-1484713416560759', 1, 1, 'SR', NULL, NULL, NULL),
(18050, '2017-01-18 10:20:15', NULL, NULL, 6204, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 10:20:15', 'admin-1484699744-14847060150644758', 1, 1, 'SR', NULL, NULL, NULL),
(18051, '2017-01-18 10:20:15', NULL, NULL, 6204, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 10:20:15', 'admin-1484699744-14847060150644758', 1, 1, 'SR', NULL, NULL, NULL),
(18052, '2017-01-18 10:20:15', NULL, NULL, 6204, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 10:20:15', 'admin-1484699744-14847060150644758', 1, 1, 'SR', NULL, NULL, NULL),
(18053, '2017-01-18 10:20:15', NULL, NULL, 6204, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 10:20:15', 'admin-1484699744-14847060150644758', 1, 0, '', NULL, NULL, NULL),
(18054, '2017-01-18 10:36:28', NULL, NULL, 6206, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 10:36:28', 'admin-1484699744-14847069883564420', 1, 1, 'SR', NULL, NULL, NULL),
(18055, '2017-01-18 10:36:28', NULL, NULL, 6206, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 10:36:28', 'admin-1484699744-14847069883564420', 1, 1, 'SR', NULL, NULL, NULL),
(18056, '2017-01-18 10:36:28', NULL, NULL, 6206, 0, 182, '117', 'Open Drinks ', 'drinking water', 'Cold Drinks', 'Fresh Juice', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 10:36:28', 'admin-1484699744-14847069883564420', 1, 0, '', NULL, NULL, NULL),
(18057, '2017-01-18 10:43:58', NULL, NULL, 6207, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 10:43:58', 'admin-1484699744-14847074378605526', 1, 0, '', NULL, NULL, NULL),
(18058, '2017-01-18 11:02:03', NULL, NULL, 6208, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 11:02:03', 'admin-1484699744-14847085237473228', 1, 0, '', NULL, NULL, NULL),
(18059, '2017-01-18 11:02:03', NULL, NULL, 6208, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 11:02:03', 'admin-1484699744-14847085237473228', 1, 0, '', NULL, NULL, NULL),
(18060, '2017-01-18 11:02:12', NULL, NULL, 6208, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 11:02:12', 'admin-1484699744-1484708532350881', 1, 1, 'SR', NULL, NULL, NULL),
(18061, '2017-01-18 11:02:12', NULL, NULL, 6208, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 11:02:12', 'admin-1484699744-1484708532350881', 1, 0, '', NULL, NULL, NULL),
(18062, '2017-01-18 11:08:50', NULL, NULL, 6209, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 11:08:50', 'admin-1484699744-14847089300151541', 1, 0, '', NULL, NULL, NULL),
(18063, '2017-01-18 11:11:49', NULL, NULL, 6210, 0, 182, '117', 'Open Drinks ', 'drinking water', 'Cold Drinks', 'Fresh Juice', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 11:11:49', 'admin-1484699744-14847091092376489', 1, 0, '', 1, NULL, NULL),
(18064, '2017-01-18 11:12:53', NULL, NULL, 6211, 0, 182, '117', 'Open Drinks ', 'drinking water', 'Cold Drinks', 'Fresh Juice', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 11:12:53', 'admin-1484699744-14847091728643826', 1, 0, '', 1, NULL, NULL),
(18065, '2017-01-18 10:19:37', NULL, NULL, 6205, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 10:19:37', 'admin-1484699744-14847059770162838', 1, 1, 'SR', NULL, NULL, NULL),
(18066, '2017-01-18 12:01:39', NULL, NULL, 6213, 0, 224, '158', 'Set Stir Fried  Garlic Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 12:01:39', 'admin-1484699744-14847120995611257', 1, 0, '', NULL, NULL, NULL),
(18067, '2017-01-18 11:39:58', NULL, NULL, 6212, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 11:39:58', 'admin-1484699744-14847107979495734', 1, 1, 'SR', NULL, NULL, NULL),
(18068, '2017-01-18 10:19:37', NULL, NULL, 6205, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 10:19:37', 'admin-1484699744-14847059770162838', 1, 0, '', NULL, NULL, NULL),
(18069, '2017-01-18 10:19:37', NULL, NULL, 6205, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 10:19:37', 'admin-1484699744-14847059770162838', 1, 0, '', NULL, NULL, NULL),
(18070, '2017-01-18 10:19:37', NULL, NULL, 6205, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 10:19:37', 'admin-1484699744-14847059770162838', 1, 0, '', NULL, NULL, NULL),
(18071, '2017-01-18 10:19:14', NULL, NULL, 6203, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 10:19:14', 'admin-1484699744-14847059546807950', 1, 0, '', NULL, NULL, NULL),
(18072, '2017-01-18 10:19:07', NULL, NULL, 6204, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 10:19:07', 'admin-1484699744-14847059474297195', 1, 1, 'SR', NULL, NULL, NULL),
(18073, '2017-01-18 10:09:51', NULL, NULL, 6203, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 10:09:51', 'admin-1484699744-14847053913401186', 1, 0, '', NULL, NULL, NULL),
(18074, '2017-01-18 10:18:43', NULL, NULL, 6204, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 10:18:43', 'admin-1484699744-14847059235646495', 1, 0, '', NULL, NULL, NULL),
(18075, '2017-01-18 09:54:58', NULL, NULL, 6203, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 09:54:58', 'admin-1484699744-14847044979501433', 1, 0, '', NULL, NULL, NULL),
(18076, '2017-01-18 10:18:43', NULL, NULL, 6204, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 10:18:43', 'admin-1484699744-14847059235646495', 1, 0, '', NULL, NULL, NULL),
(18077, '2017-01-18 10:18:43', NULL, NULL, 6204, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 10:18:43', 'admin-1484699744-14847059235646495', 1, 0, '', NULL, NULL, NULL),
(18078, '2017-01-18 09:55:02', NULL, NULL, 6203, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 09:55:02', 'admin-1484699744-14847045025763975', 1, 1, 'SR', NULL, NULL, NULL),
(18079, '2017-01-18 09:55:02', NULL, NULL, 6203, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 09:55:02', 'admin-1484699744-14847045025763975', 1, 1, 'SR', NULL, NULL, NULL),
(18080, '2017-01-18 09:54:58', NULL, NULL, 6203, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 09:54:58', 'admin-1484699744-14847044979501433', 1, 0, '', NULL, NULL, NULL),
(18081, '2017-01-18 09:07:57', NULL, NULL, 6202, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 09:07:57', 'admin-1484699744-14847016769676398', 1, 1, 'SR', NULL, NULL, NULL),
(18082, '2017-01-18 09:54:58', NULL, NULL, 6203, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 09:54:58', 'admin-1484699744-14847044979501433', 1, 0, '', NULL, NULL, NULL),
(18083, '2017-01-18 09:06:59', NULL, NULL, 6201, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 09:06:59', 'admin-1484699744-14847016192621732', 1, 1, 'SR', NULL, NULL, NULL),
(18084, '2017-01-18 09:07:57', NULL, NULL, 6202, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 09:07:57', 'admin-1484699744-14847016769676398', 1, 0, '', NULL, NULL, NULL),
(18085, '2017-01-18 09:06:59', NULL, NULL, 6201, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 09:06:59', 'admin-1484699744-14847016192621732', 1, 0, '', NULL, NULL, NULL),
(18086, '2017-01-18 09:03:07', NULL, NULL, 6200, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 09:03:07', 'admin-1484699744-14847013870059829', 1, 0, '', NULL, NULL, NULL),
(18087, '2017-01-18 09:03:07', NULL, NULL, 6200, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484716636', 'admin', '2017-01-18 09:03:07', 'admin-1484699744-14847013870059829', 1, 1, 'SR', NULL, NULL, NULL),
(18088, '2017-01-19 19:06:06', NULL, NULL, 6257, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 19:06:06', 'admin-1484822774-1484823966321172', 1, 0, '', NULL, NULL, NULL),
(18089, '2017-01-19 18:46:06', NULL, NULL, 6255, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 18:46:06', 'admin-1484804348-14848227664293046', 1, 0, '', NULL, NULL, NULL),
(18090, '2017-01-19 18:35:23', NULL, NULL, 6256, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 18:35:23', 'admin-1484804348-14848221233714896', 1, 1, 'SR', NULL, NULL, NULL),
(18091, '2017-01-19 18:01:39', NULL, NULL, 6255, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 18:01:39', 'admin-1484804348-1484820099362894', 1, 0, '', NULL, NULL, NULL),
(18092, '2017-01-19 18:01:39', NULL, NULL, 6255, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 18:01:39', 'admin-1484804348-1484820099362894', 1, 1, 'SR', NULL, NULL, NULL),
(18093, '2017-01-19 17:52:21', NULL, NULL, 6254, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 17:52:21', 'admin-1484804348-14848195412441371', 1, 1, 'SR', NULL, NULL, NULL),
(18094, '2017-01-19 17:52:21', NULL, NULL, 6254, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 17:52:21', 'admin-1484804348-14848195412441371', 1, 0, '', NULL, NULL, NULL),
(18095, '2017-01-19 19:57:29', NULL, NULL, 6261, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 19:57:29', 'admin-1484822774-14848270488494764', 1, 1, 'SR', NULL, NULL, NULL),
(18096, '2017-01-19 19:57:11', NULL, NULL, 6261, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 19:57:11', 'admin-1484822774-14848270314976851', 1, 1, 'SR', NULL, NULL, NULL),
(18097, '2017-01-19 19:54:52', NULL, NULL, 6260, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 19:54:52', 'admin-1484822774-14848268923133296', 1, 1, 'SR', NULL, NULL, NULL),
(18098, '2017-01-19 19:12:54', NULL, NULL, 6258, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 19:12:54', 'admin-1484822774-1484824374084788', 1, 0, '', NULL, NULL, NULL),
(18099, '2017-01-19 19:12:54', NULL, NULL, 6258, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 19:12:54', 'admin-1484822774-1484824374084788', 1, 1, 'SR', NULL, NULL, NULL),
(18100, '2017-01-19 19:18:11', NULL, NULL, 6259, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 19:18:11', 'admin-1484822774-14848246913311923', 1, 0, '', NULL, NULL, NULL),
(18101, '2017-01-19 19:20:32', NULL, NULL, 6259, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 19:20:32', 'admin-1484822774-14848248326586482', 1, 0, '', NULL, NULL, NULL),
(18102, '2017-01-19 19:45:15', NULL, NULL, 6260, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 19:45:15', 'admin-1484822774-14848263155297333', 1, 1, 'SR', NULL, NULL, NULL),
(18103, '2017-01-19 19:12:54', NULL, NULL, 6258, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 19:12:54', 'admin-1484822774-1484824374084788', 1, 1, 'SR', NULL, NULL, NULL),
(18104, '2017-01-19 17:47:16', NULL, NULL, 6253, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 17:47:16', 'admin-1484804348-14848192366171891', 1, 1, 'SR', NULL, NULL, NULL),
(18105, '2017-01-19 17:47:16', NULL, NULL, 6253, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 17:47:16', 'admin-1484804348-14848192366171891', 1, 0, '', NULL, NULL, NULL),
(18106, '2017-01-19 14:05:51', NULL, NULL, 6243, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 14:05:51', 'admin-1484804348-14848059516631946', 1, 0, '', NULL, NULL, NULL),
(18107, '2017-01-19 13:07:02', NULL, NULL, 6240, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:07:02', 'admin-1484802394-14848024221232132', 1, 1, 'SR', NULL, NULL, NULL),
(18108, '2017-01-19 13:07:02', NULL, NULL, 6240, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:07:02', 'admin-1484802394-14848024221232132', 1, 1, 'SR', NULL, NULL, NULL),
(18109, '2017-01-19 13:12:07', NULL, NULL, 6241, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:12:07', 'admin-1484802394-14848027274742073', 1, 1, 'SR', NULL, NULL, NULL),
(18110, '2017-01-19 13:12:07', NULL, NULL, 6241, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:12:07', 'admin-1484802394-14848027274742073', 1, 1, 'SR', NULL, NULL, NULL),
(18111, '2017-01-19 13:12:07', NULL, NULL, 6241, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:12:07', 'admin-1484802394-14848027274742073', 1, 0, '', NULL, NULL, NULL),
(18112, '2017-01-19 13:19:39', NULL, NULL, 6242, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:19:39', 'admin-1484802394-14848031789259224', 1, 1, 'SR', NULL, NULL, NULL),
(18113, '2017-01-19 13:19:39', NULL, NULL, 6242, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:19:39', 'admin-1484802394-14848031789259224', 1, 1, 'SR', NULL, NULL, NULL),
(18114, '2017-01-19 13:19:39', NULL, NULL, 6242, 0, 181, '116', 'Open Food ', 'vege   egg', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:19:39', 'admin-1484802394-14848031789259224', 1, 0, '', NULL, NULL, NULL),
(18115, '2017-01-19 13:27:48', NULL, NULL, 6243, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:27:48', 'admin-1484802394-14848036685156553', 1, 1, 'SR', NULL, NULL, NULL),
(18116, '2017-01-19 13:27:48', NULL, NULL, 6243, 0, 84, '84', 'Set Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:27:48', 'admin-1484802394-14848036685156553', 1, 1, 'SR', NULL, NULL, NULL),
(18117, '2017-01-19 13:27:55', NULL, NULL, 6239, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:27:55', 'admin-1484802394-14848036748252122', 1, 0, '', NULL, NULL, NULL),
(18118, '2017-01-19 13:38:53', NULL, NULL, 6244, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:38:53', 'admin-1484802394-14848043335459462', 1, 1, 'SR', NULL, NULL, NULL),
(18119, '2017-01-19 13:38:53', NULL, NULL, 6244, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:38:53', 'admin-1484802394-14848043335459462', 1, 0, '', NULL, NULL, NULL),
(18120, '2017-01-19 13:38:53', NULL, NULL, 6244, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:38:53', 'admin-1484802394-14848043335459462', 1, 0, '', NULL, NULL, NULL),
(18121, '2017-01-19 13:39:02', NULL, NULL, 6244, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:39:02', 'admin-1484802394-14848043426203565', 1, 1, 'SR', NULL, NULL, NULL),
(18122, '2017-01-19 13:39:02', NULL, NULL, 6244, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:39:02', 'admin-1484802394-14848043426203565', 1, 1, 'SR', NULL, NULL, NULL),
(18123, '2017-01-19 13:39:02', NULL, NULL, 6244, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:39:02', 'admin-1484802394-14848043426203565', 1, 1, 'SR', NULL, NULL, NULL),
(18124, '2017-01-19 13:42:38', NULL, NULL, 6241, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:42:38', 'admin-1484804348-14848045582792597', 1, 0, '', NULL, NULL, NULL),
(18125, '2017-01-19 17:47:16', NULL, NULL, 6253, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 17:47:16', 'admin-1484804348-14848192366171891', 1, 1, 'SR', NULL, NULL, NULL),
(18126, '2017-01-19 15:09:03', NULL, NULL, 6251, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 15:09:03', 'admin-1484804348-14848097435359554', 1, 1, 'SR', NULL, NULL, NULL),
(18127, '2017-01-19 16:01:05', NULL, NULL, 6251, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 16:01:05', 'admin-1484804348-14848128650302419', 1, 1, 'SR', NULL, NULL, NULL),
(18128, '2017-01-19 16:01:05', NULL, NULL, 6251, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 16:01:05', 'admin-1484804348-14848128650302419', 1, 1, 'SR', NULL, NULL, NULL),
(18129, '2017-01-19 16:23:43', NULL, NULL, 6252, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 16:23:43', 'admin-1484804348-14848142227228436', 1, 1, 'SR', 1, NULL, NULL),
(18130, '2017-01-19 15:09:03', NULL, NULL, 6251, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 15:09:03', 'admin-1484804348-14848097435359554', 1, 1, 'SR', NULL, NULL, NULL),
(18131, '2017-01-19 15:06:40', NULL, NULL, 6251, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 15:06:40', 'admin-1484804348-14848096006563182', 1, 0, '', NULL, NULL, NULL),
(18132, '2017-01-19 15:06:40', NULL, NULL, 6251, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 15:06:40', 'admin-1484804348-14848096006563182', 1, 1, 'SR', NULL, NULL, NULL),
(18133, '2017-01-19 14:30:03', NULL, NULL, 6250, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 14:30:03', 'admin-1484804348-1484807403429621', 1, 1, 'SR', NULL, NULL, NULL),
(18134, '2017-01-19 14:30:03', NULL, NULL, 6250, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 14:30:03', 'admin-1484804348-1484807403429621', 1, 1, 'SR', NULL, NULL, NULL),
(18135, '2017-01-19 14:30:03', NULL, NULL, 6250, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 14:30:03', 'admin-1484804348-1484807403429621', 1, 1, 'SR', NULL, NULL, NULL),
(18136, '2017-01-19 14:23:06', NULL, NULL, 6249, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 14:23:06', 'admin-1484804348-14848069858037028', 1, 1, 'SR', NULL, NULL, NULL),
(18137, '2017-01-19 14:23:06', NULL, NULL, 6249, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 14:23:06', 'admin-1484804348-14848069858037028', 1, 1, 'SR', NULL, NULL, NULL),
(18138, '2017-01-19 14:22:50', NULL, NULL, 6244, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 14:22:50', 'admin-1484804348-14848069699958238', 1, 1, 'SR', NULL, NULL, NULL),
(18139, '2017-01-19 14:18:42', NULL, NULL, 6249, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 14:18:42', 'admin-1484804348-14848067223236258', 1, 1, 'SR', NULL, NULL, NULL),
(18140, '2017-01-19 20:35:13', NULL, NULL, 6260, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1484829296', 'admin', '2017-01-19 20:35:13', 'admin-1484829296-1484829313065111', 1, 0, '', NULL, NULL, NULL),
(18141, '2017-01-19 20:01:23', NULL, NULL, 6260, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 20:01:23', 'admin-1484822774-14848272832823657', 1, 1, 'SR', NULL, NULL, NULL),
(18142, '2017-01-19 20:01:12', NULL, NULL, 6260, 0, 72, '72', 'Mushroom Chicken', 'fried egg', 'Meals', 'Perfect Meals', 1, 17.50, 17.5000, 0.0000, 17.50, 1, '27', 1, '1484829296', 'admin', '2017-01-19 20:01:12', 'admin-1484822774-14848272723148797', 1, 1, 'SR', NULL, NULL, NULL),
(18143, '2017-01-19 19:57:29', NULL, NULL, 6261, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 19:57:29', 'admin-1484822774-14848270488494764', 1, 0, '', NULL, NULL, NULL),
(18144, '2017-01-19 19:57:11', NULL, NULL, 6261, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 19:57:11', 'admin-1484822774-14848270314976851', 1, 0, '', NULL, NULL, NULL),
(18145, '2017-01-19 14:18:42', NULL, NULL, 6249, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 14:18:42', 'admin-1484804348-14848067223236258', 1, 0, '', NULL, NULL, NULL),
(18146, '2017-01-19 14:18:42', NULL, NULL, 6249, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 14:18:42', 'admin-1484804348-14848067223236258', 1, 1, 'SR', NULL, NULL, NULL),
(18147, '2017-01-19 14:00:26', NULL, NULL, 6247, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 14:00:26', 'admin-1484804348-14848056261138573', 1, 1, 'SR', NULL, NULL, NULL),
(18148, '2017-01-19 14:00:48', NULL, NULL, 6248, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 14:00:48', 'admin-1484804348-14848056486659353', 1, 1, 'SR', NULL, NULL, NULL),
(18149, '2017-01-19 14:04:44', NULL, NULL, 6245, 0, 214, '148', 'Set Fried Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 14:04:44', 'admin-1484804348-14848058842906646', 1, 0, '', NULL, NULL, NULL),
(18150, '2017-01-19 12:32:42', NULL, NULL, 6237, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 12:32:42', 'admin-1484788176-1484800362069874', 1, 1, 'SR', NULL, NULL, NULL),
(18151, '2017-01-19 12:44:50', NULL, NULL, 6238, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 12:44:50', 'admin-1484788176-14848010899806991', 1, 0, '', NULL, NULL, NULL),
(18152, '2017-01-19 12:44:50', NULL, NULL, 6238, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 12:44:50', 'admin-1484788176-14848010899806991', 1, 0, '', NULL, NULL, NULL),
(18153, '2017-01-19 12:44:50', NULL, NULL, 6238, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 12:44:50', 'admin-1484788176-14848010899806991', 1, 0, '', NULL, NULL, NULL),
(18154, '2017-01-19 12:44:50', NULL, NULL, 6238, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 12:44:50', 'admin-1484788176-14848010899806991', 1, 0, '', NULL, NULL, NULL),
(18155, '2017-01-19 13:06:22', NULL, NULL, 6239, 0, 85, '85', 'Set Meatless Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:06:22', 'admin-1484788176-14848023827057279', 1, 1, 'SR', NULL, NULL, NULL),
(18156, '2017-01-19 13:06:22', NULL, NULL, 6239, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:06:22', 'admin-1484788176-14848023827057279', 1, 1, 'SR', NULL, NULL, NULL),
(18157, '2017-01-19 10:57:50', NULL, NULL, 6232, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 10:57:50', 'admin-1484788176-14847946699606867', 1, 0, '', NULL, NULL, NULL),
(18158, '2017-01-19 13:59:43', NULL, NULL, 6246, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:59:43', 'admin-1484804348-14848055835147278', 1, 1, 'SR', NULL, NULL, NULL),
(18159, '2017-01-19 13:57:26', NULL, NULL, 6242, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:57:26', 'admin-1484804348-14848054466067495', 1, 0, '', NULL, NULL, NULL),
(18160, '2017-01-19 13:57:19', NULL, NULL, 6242, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:57:19', 'admin-1484804348-14848054388537092', 1, 1, 'SR', NULL, NULL, NULL),
(18161, '2017-01-19 13:57:19', NULL, NULL, 6242, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:57:19', 'admin-1484804348-14848054388537092', 1, 1, 'SR', NULL, NULL, NULL),
(18162, '2017-01-19 13:48:01', NULL, NULL, 6245, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:48:01', 'admin-1484804348-1484804880921540', 1, 0, '', NULL, NULL, NULL),
(18163, '2017-01-19 13:48:10', NULL, NULL, 6245, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:48:10', 'admin-1484804348-14848048906912120', 1, 1, 'SR', NULL, NULL, NULL),
(18164, '2017-01-19 13:50:24', NULL, NULL, 6245, 0, 214, '148', 'Set Fried Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:50:24', 'admin-1484804348-14848050238905914', 1, 0, '', NULL, NULL, NULL),
(18165, '2017-01-19 13:51:28', NULL, NULL, 6239, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:51:28', 'admin-1484804348-14848050887818035', 1, 0, '', NULL, NULL, NULL),
(18166, '2017-01-19 13:06:22', NULL, NULL, 6239, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:06:22', 'admin-1484788176-14848023827057279', 1, 0, '', NULL, NULL, NULL),
(18167, '2017-01-19 13:06:22', NULL, NULL, 6239, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 13:06:22', 'admin-1484788176-14848023827057279', 1, 1, 'SR', NULL, NULL, NULL),
(18168, '2017-01-19 12:22:54', NULL, NULL, 6237, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 12:22:54', 'admin-1484788176-1484799774102836', 1, 1, 'SR', NULL, NULL, NULL),
(18169, '2017-01-19 12:22:54', NULL, NULL, 6237, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 12:22:54', 'admin-1484788176-1484799774102836', 1, 0, '', NULL, NULL, NULL),
(18170, '2017-01-19 12:21:07', NULL, NULL, 6236, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 12:21:07', 'admin-1484788176-14847996672633915', 1, 1, 'SR', NULL, NULL, NULL),
(18171, '2017-01-19 12:21:07', NULL, NULL, 6236, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 12:21:07', 'admin-1484788176-14847996672633915', 1, 0, '', NULL, NULL, NULL),
(18172, '2017-01-19 12:21:07', NULL, NULL, 6236, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 12:21:07', 'admin-1484788176-14847996672633915', 1, 1, 'SR', NULL, NULL, NULL),
(18173, '2017-01-19 11:56:03', NULL, NULL, 6234, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 11:56:03', 'admin-1484788176-1484798163811138', 1, 1, 'SR', NULL, NULL, NULL),
(18174, '2017-01-19 11:56:11', NULL, NULL, 6235, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 11:56:11', 'admin-1484788176-14847981716491842', 1, 1, 'SR', NULL, NULL, NULL),
(18175, '2017-01-19 11:55:56', NULL, NULL, 6233, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 11:55:56', 'admin-1484788176-14847981567558154', 1, 1, 'SR', NULL, NULL, NULL),
(18176, '2017-01-19 11:55:56', NULL, NULL, 6233, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 11:55:56', 'admin-1484788176-14847981567558154', 1, 0, '', NULL, NULL, NULL),
(18177, '2017-01-19 10:57:55', NULL, NULL, 6232, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 10:57:55', 'admin-1484788176-14847946750997934', 1, 1, 'SR', NULL, NULL, NULL),
(18178, '2017-01-19 10:57:55', NULL, NULL, 6232, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 10:57:55', 'admin-1484788176-14847946750997934', 1, 1, 'SR', NULL, NULL, NULL),
(18179, '2017-01-19 10:57:50', NULL, NULL, 6232, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 10:57:50', 'admin-1484788176-14847946699606867', 1, 0, '', NULL, NULL, NULL),
(18180, '2017-01-19 10:37:20', NULL, NULL, 6229, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 10:37:20', 'admin-1484788176-14847934404581284', 1, 0, '', NULL, NULL, NULL),
(18181, '2017-01-19 10:37:45', NULL, NULL, 6230, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 10:37:45', 'admin-1484788176-14847934654206532', 1, 0, '', NULL, NULL, NULL),
(18182, '2017-01-19 10:37:45', NULL, NULL, 6230, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 10:37:45', 'admin-1484788176-14847934654206532', 1, 1, 'SR', NULL, NULL, NULL),
(18183, '2017-01-19 10:38:53', NULL, NULL, 6231, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 10:38:53', 'admin-1484788176-14847935330402641', 1, 0, '', NULL, NULL, NULL),
(18184, '2017-01-19 09:09:54', NULL, NULL, 6228, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 09:09:54', 'admin-1484788176-148478819406282', 1, 1, 'SR', NULL, NULL, NULL),
(18185, '2017-01-19 09:09:54', NULL, NULL, 6228, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 09:09:54', 'admin-1484788176-148478819406282', 1, 0, '', NULL, NULL, NULL),
(18186, '2017-01-19 09:09:54', NULL, NULL, 6228, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484829296', 'admin', '2017-01-19 09:09:54', 'admin-1484788176-148478819406282', 1, 0, '', NULL, NULL, NULL),
(18187, '2017-01-20 13:01:29', NULL, NULL, 6275, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 13:01:29', 'admin-1484883241-14848884891381267', 1, 0, '', NULL, NULL, NULL),
(18188, '2017-01-20 13:00:33', NULL, NULL, 6274, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 13:00:33', 'admin-1484883241-1484888433470646', 1, 1, 'SR', NULL, NULL, NULL),
(18189, '2017-01-20 13:36:05', NULL, NULL, 6276, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 13:36:05', 'admin-1484890125-14848905657072670', 1, 0, '', NULL, NULL, NULL),
(18190, '2017-01-20 13:36:05', NULL, NULL, 6276, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 13:36:05', 'admin-1484890125-14848905657072670', 1, 0, '', NULL, NULL, NULL),
(18191, '2017-01-20 13:36:15', NULL, NULL, 6276, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 13:36:15', 'admin-1484890125-14848905757643542', 1, 1, 'SR', NULL, NULL, NULL),
(18192, '2017-01-20 13:36:16', NULL, NULL, 6276, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 13:36:16', 'admin-1484890125-14848905757643542', 1, 1, 'SR', NULL, NULL, NULL),
(18193, '2017-01-20 14:02:19', NULL, NULL, 6277, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 14:02:19', 'admin-1484890125-14848921389709049', 1, 1, 'SR', NULL, NULL, NULL),
(18194, '2017-01-20 14:10:54', NULL, NULL, 6276, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 14:10:54', 'admin-1484890125-14848926544608742', 1, 0, '', NULL, NULL, NULL),
(18195, '2017-01-20 15:05:33', NULL, NULL, 6278, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 15:05:33', 'admin-1484890125-1484895933471181', 1, 0, '', NULL, NULL, NULL),
(18196, '2017-01-20 15:48:09', NULL, NULL, 6279, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 15:48:09', 'admin-1484890125-14848984894958221', 1, 1, 'SR', 1, NULL, NULL),
(18197, '2017-01-20 16:07:11', NULL, NULL, 6280, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 16:07:11', 'admin-1484890125-14848996312749167', 1, 1, 'SR', NULL, NULL, NULL),
(18198, '2017-01-20 16:07:11', NULL, NULL, 6280, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 16:07:11', 'admin-1484890125-14848996312749167', 1, 1, 'SR', NULL, NULL, NULL),
(18199, '2017-01-20 16:07:11', NULL, NULL, 6280, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 16:07:11', 'admin-1484890125-14848996312749167', 1, 0, '', NULL, NULL, NULL),
(18200, '2017-01-20 16:07:11', NULL, NULL, 6280, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 16:07:11', 'admin-1484890125-14848996312749167', 1, 0, '', NULL, NULL, NULL),
(18201, '2017-01-20 16:13:15', NULL, NULL, 6281, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 16:13:15', 'admin-1484890125-14848999953511268', 1, 1, 'SR', 1, NULL, NULL),
(18202, '2017-01-20 16:30:16', NULL, NULL, 6282, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 16:30:16', 'admin-1484890125-14849010167107887', 1, 1, 'SR', NULL, NULL, NULL),
(18203, '2017-01-20 16:30:16', NULL, NULL, 6282, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 16:30:16', 'admin-1484890125-14849010167107887', 1, 1, 'SR', NULL, NULL, NULL),
(18204, '2017-01-20 13:00:33', NULL, NULL, 6274, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 13:00:33', 'admin-1484883241-1484888433470646', 1, 1, 'SR', NULL, NULL, NULL),
(18205, '2017-01-20 12:29:32', NULL, NULL, 6272, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 12:29:32', 'admin-1484883241-14848865718186633', 1, 1, 'SR', NULL, NULL, NULL),
(18206, '2017-01-20 13:00:33', NULL, NULL, 6274, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 13:00:33', 'admin-1484883241-1484888433470646', 1, 1, 'SR', NULL, NULL, NULL),
(18207, '2017-01-20 13:02:11', NULL, NULL, 6275, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 13:02:11', 'admin-1484883241-14848885313038956', 1, 1, 'SR', NULL, NULL, NULL),
(18208, '2017-01-20 13:00:33', NULL, NULL, 6274, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 13:00:33', 'admin-1484883241-1484888433470646', 1, 1, 'SR', NULL, NULL, NULL),
(18209, '2017-01-20 12:44:50', NULL, NULL, 6270, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 12:44:50', 'admin-1484883241-14848874904059585', 1, 1, 'SR', NULL, NULL, NULL),
(18210, '2017-01-20 12:35:55', NULL, NULL, 6271, 0, 181, '116', 'Open Food ', 'Scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 12:35:55', 'admin-1484883241-1484886955396434', 1, 0, '', NULL, NULL, NULL),
(18211, '2017-01-20 12:30:05', NULL, NULL, 6273, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 12:30:05', 'admin-1484883241-14848866048178766', 1, 1, 'SR', NULL, NULL, NULL),
(18212, '2017-01-20 10:56:44', NULL, NULL, 6266, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 10:56:44', 'admin-1484872968-14848810048024732', 1, 0, '', NULL, NULL, NULL),
(18213, '2017-01-20 10:57:58', NULL, NULL, 6267, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 10:57:58', 'admin-1484872968-14848810778532896', 1, 0, '', NULL, NULL, NULL),
(18214, '2017-01-20 10:57:58', NULL, NULL, 6267, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 10:57:58', 'admin-1484872968-14848810778532896', 1, 0, '', NULL, NULL, NULL),
(18215, '2017-01-20 10:58:04', NULL, NULL, 6267, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 10:58:04', 'admin-1484872968-14848810840103020', 1, 1, 'SR', NULL, NULL, NULL),
(18216, '2017-01-20 10:58:04', NULL, NULL, 6267, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 10:58:04', 'admin-1484872968-14848810840103020', 1, 1, 'SR', NULL, NULL, NULL),
(18217, '2017-01-20 11:26:15', NULL, NULL, 6267, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 11:26:15', 'admin-1484872968-14848827752442336', 1, 1, 'SR', NULL, NULL, NULL),
(18218, '2017-01-20 11:33:45', NULL, NULL, 6268, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 11:33:45', 'admin-1484872968-1484883225699793', 1, 0, '', NULL, NULL, NULL),
(18219, '2017-01-20 11:33:45', NULL, NULL, 6268, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 11:33:45', 'admin-1484872968-1484883225699793', 1, 0, '', NULL, NULL, NULL),
(18220, '2017-01-20 11:33:45', NULL, NULL, 6268, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 11:33:45', 'admin-1484872968-1484883225699793', 1, 1, 'SR', NULL, NULL, NULL),
(18221, '2017-01-20 11:33:45', NULL, NULL, 6268, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 11:33:45', 'admin-1484872968-1484883225699793', 1, 1, 'SR', NULL, NULL, NULL),
(18222, '2017-01-20 12:10:32', NULL, NULL, 6269, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 12:10:32', 'admin-1484883241-14848854323992782', 1, 0, '', NULL, NULL, NULL),
(18223, '2017-01-20 12:10:59', NULL, NULL, 6269, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 12:10:59', 'admin-1484883241-14848854587406894', 1, 0, '', NULL, NULL, NULL),
(18224, '2017-01-20 12:10:59', NULL, NULL, 6269, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 12:10:59', 'admin-1484883241-14848854587406894', 1, 1, 'SR', NULL, NULL, NULL),
(18225, '2017-01-20 12:20:46', NULL, NULL, 6270, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 12:20:46', 'admin-1484883241-1484886045849287', 1, 1, 'SR', NULL, NULL, NULL),
(18226, '2017-01-20 12:20:54', NULL, NULL, 6270, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 12:20:54', 'admin-1484883241-14848860539636676', 1, 1, 'SR', NULL, NULL, NULL),
(18227, '2017-01-20 12:25:58', NULL, NULL, 6271, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 12:25:58', 'admin-1484883241-14848863586215498', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(18228, '2017-01-20 12:29:19', NULL, NULL, 6272, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 12:29:19', 'admin-1484883241-1484886559583488', 1, 0, '', NULL, NULL, NULL),
(18229, '2017-01-20 12:29:32', NULL, NULL, 6272, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 12:29:32', 'admin-1484883241-14848865718186633', 1, 1, 'SR', NULL, NULL, NULL),
(18230, '2017-01-20 12:29:32', NULL, NULL, 6272, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 12:29:32', 'admin-1484883241-14848865718186633', 1, 1, 'SR', NULL, NULL, NULL),
(18231, '2017-01-20 12:34:54', NULL, NULL, 6272, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 12:34:54', 'admin-1484883241-14848868945777658', 1, 0, '', NULL, NULL, NULL),
(18232, '2017-01-20 10:56:44', NULL, NULL, 6266, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 10:56:44', 'admin-1484872968-14848810048024732', 1, 1, 'SR', NULL, NULL, NULL),
(18233, '2017-01-20 09:57:19', NULL, NULL, 6265, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 09:57:19', 'admin-1484872968-14848774394597610', 1, 1, 'SR', NULL, NULL, NULL),
(18234, '2017-01-20 09:57:19', NULL, NULL, 6265, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 09:57:19', 'admin-1484872968-14848774394597610', 1, 0, '', NULL, NULL, NULL),
(18235, '2017-01-20 09:57:19', NULL, NULL, 6265, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 09:57:19', 'admin-1484872968-14848774394597610', 1, 0, '', NULL, NULL, NULL),
(18236, '2017-01-20 09:50:26', NULL, NULL, 6264, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 09:50:26', 'admin-1484872968-14848770259953392', 1, 1, 'SR', NULL, NULL, NULL),
(18237, '2017-01-20 09:57:19', NULL, NULL, 6265, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 09:57:19', 'admin-1484872968-14848774394597610', 1, 0, '', NULL, NULL, NULL),
(18238, '2017-01-20 09:49:59', NULL, NULL, 6264, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 09:49:59', 'admin-1484872968-14848769997734184', 1, 0, '', NULL, NULL, NULL),
(18239, '2017-01-20 09:50:26', NULL, NULL, 6264, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 09:50:26', 'admin-1484872968-14848770259953392', 1, 1, 'SR', NULL, NULL, NULL),
(18240, '2017-01-20 09:50:26', NULL, NULL, 6264, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 09:50:26', 'admin-1484872968-14848770259953392', 1, 1, 'SR', NULL, NULL, NULL),
(18241, '2017-01-20 09:50:26', NULL, NULL, 6264, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 09:50:26', 'admin-1484872968-14848770259953392', 1, 1, 'SR', NULL, NULL, NULL),
(18242, '2017-01-20 09:49:59', NULL, NULL, 6264, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 09:49:59', 'admin-1484872968-14848769997734184', 1, 0, '', NULL, NULL, NULL),
(18243, '2017-01-20 09:49:59', NULL, NULL, 6264, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 09:49:59', 'admin-1484872968-14848769997734184', 1, 0, '', NULL, NULL, NULL),
(18244, '2017-01-20 09:49:59', NULL, NULL, 6264, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 09:49:59', 'admin-1484872968-14848769997734184', 1, 0, '', NULL, NULL, NULL),
(18245, '2017-01-20 09:35:48', NULL, NULL, 6263, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 09:35:48', 'admin-1484872968-14848761487393559', 1, 1, 'SR', 1, NULL, NULL),
(18246, '2017-01-20 09:02:29', NULL, NULL, 6262, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 09:02:29', 'admin-1484872968-14848741491055335', 1, 1, 'SR', NULL, NULL, NULL),
(18247, '2017-01-20 09:02:29', NULL, NULL, 6262, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 09:02:29', 'admin-1484872968-14848741491055335', 1, 1, 'SR', NULL, NULL, NULL),
(18248, '2017-01-20 09:02:29', NULL, NULL, 6262, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 09:02:29', 'admin-1484872968-14848741491055335', 1, 0, '', NULL, NULL, NULL),
(18249, '2017-01-20 09:02:29', NULL, NULL, 6262, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484890125', 'admin', '2017-01-20 09:02:29', 'admin-1484872968-14848741491055335', 1, 0, '', NULL, NULL, NULL),
(18250, '2017-01-21 13:13:27', NULL, NULL, 6307, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 13:13:27', 'admin-1484969658-14849756070558152', 1, 1, 'SR', NULL, NULL, NULL),
(18251, '2017-01-21 13:18:06', NULL, NULL, 6300, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 13:18:06', 'admin-1484969658-14849758861955580', 1, 0, '', NULL, NULL, NULL),
(18252, '2017-01-21 13:30:38', NULL, NULL, 6308, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 13:30:38', 'admin-1484969658-14849766387522062', 1, 1, 'SR', NULL, NULL, NULL),
(18253, '2017-01-21 13:33:27', NULL, NULL, 6309, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 13:33:27', 'admin-1484969658-14849768072523051', 1, 1, 'SR', NULL, NULL, NULL),
(18254, '2017-01-21 13:33:27', NULL, NULL, 6309, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 13:33:27', 'admin-1484969658-14849768072523051', 1, 1, 'SR', NULL, NULL, NULL),
(18255, '2017-01-21 13:33:27', NULL, NULL, 6309, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 13:33:27', 'admin-1484969658-14849768072523051', 1, 1, 'SR', NULL, NULL, NULL),
(18256, '2017-01-21 13:41:08', NULL, NULL, 6291, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 13:41:08', 'admin-1484969658-14849772680864074', 1, 1, 'SR', NULL, NULL, NULL),
(18257, '2017-01-21 13:41:08', NULL, NULL, 6291, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 13:41:08', 'admin-1484969658-14849772680864074', 1, 0, '', NULL, NULL, NULL),
(18258, '2017-01-21 17:08:50', NULL, NULL, 6320, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 17:08:50', 'admin-1484978263-14849897298632324', 1, 0, '', NULL, NULL, NULL),
(18259, '2017-01-21 17:09:28', NULL, NULL, 6321, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 17:09:28', 'admin-1484978263-1484989768359376', 1, 1, 'SR', NULL, NULL, NULL),
(18260, '2017-01-21 17:05:56', NULL, NULL, 6318, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 17:05:56', 'admin-1484978263-14849895561539093', 1, 0, '', NULL, NULL, NULL),
(18261, '2017-01-21 17:06:47', NULL, NULL, 6319, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 17:06:47', 'admin-1484978263-14849896070417970', 1, 1, 'SR', NULL, NULL, NULL),
(18262, '2017-01-21 17:05:56', NULL, NULL, 6318, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 17:05:56', 'admin-1484978263-14849895561539093', 1, 1, 'SR', NULL, NULL, NULL),
(18263, '2017-01-21 13:13:27', NULL, NULL, 6307, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 13:13:27', 'admin-1484969658-14849756070558152', 1, 1, 'SR', NULL, NULL, NULL),
(18264, '2017-01-21 13:13:27', NULL, NULL, 6307, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 13:13:27', 'admin-1484969658-14849756070558152', 1, 1, 'SR', NULL, NULL, NULL),
(18265, '2017-01-21 15:37:07', NULL, NULL, 6316, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 15:37:07', 'admin-1484978263-14849842277782498', 1, 1, 'SR', NULL, NULL, NULL),
(18266, '2017-01-21 15:43:33', NULL, NULL, 6316, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 15:43:33', 'admin-1484978263-14849846128034860', 1, 1, 'SR', NULL, NULL, NULL),
(18267, '2017-01-21 15:43:33', NULL, NULL, 6316, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 15:43:33', 'admin-1484978263-14849846128034860', 1, 0, '', NULL, NULL, NULL),
(18268, '2017-01-21 15:55:12', NULL, NULL, 6317, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 15:55:12', 'admin-1484978263-1484985312640344', 1, 1, 'SR', NULL, NULL, NULL),
(18269, '2017-01-21 15:55:12', NULL, NULL, 6317, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 15:55:12', 'admin-1484978263-1484985312640344', 1, 1, 'SR', NULL, NULL, NULL),
(18270, '2017-01-21 15:55:12', NULL, NULL, 6317, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 15:55:12', 'admin-1484978263-1484985312640344', 1, 1, 'SR', NULL, NULL, NULL),
(18271, '2017-01-21 15:25:15', NULL, NULL, 6315, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 15:25:15', 'admin-1484978263-14849835156778410', 1, 1, 'SR', NULL, NULL, NULL),
(18272, '2017-01-21 15:25:15', NULL, NULL, 6315, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 15:25:15', 'admin-1484978263-14849835156778410', 1, 0, '', NULL, NULL, NULL),
(18273, '2017-01-21 11:55:32', NULL, NULL, 6301, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 11:55:32', 'admin-1484969658-14849709320441342', 1, 1, 'SR', NULL, NULL, NULL),
(18274, '2017-01-21 12:02:26', NULL, NULL, 6302, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 12:02:26', 'admin-1484969658-1484971346489343', 1, 1, 'SR', NULL, NULL, NULL),
(18275, '2017-01-21 12:02:26', NULL, NULL, 6302, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 12:02:26', 'admin-1484969658-1484971346489343', 1, 1, 'SR', NULL, NULL, NULL),
(18276, '2017-01-21 12:02:26', NULL, NULL, 6302, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 12:02:26', 'admin-1484969658-1484971346489343', 1, 1, 'SR', NULL, NULL, NULL),
(18277, '2017-01-21 12:02:26', NULL, NULL, 6302, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 12:02:26', 'admin-1484969658-1484971346489343', 1, 1, 'SR', NULL, NULL, NULL),
(18278, '2017-01-21 12:11:50', NULL, NULL, 6303, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 12:11:50', 'admin-1484969658-14849719103259118', 1, 1, 'SR', NULL, NULL, NULL),
(18279, '2017-01-21 12:11:50', NULL, NULL, 6303, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 12:11:50', 'admin-1484969658-14849719103259118', 1, 1, 'SR', NULL, NULL, NULL),
(18280, '2017-01-21 12:16:54', NULL, NULL, 6304, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 12:16:54', 'admin-1484969658-1484972214057763', 1, 1, 'SR', NULL, NULL, NULL),
(18281, '2017-01-21 12:20:14', NULL, NULL, 6305, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 12:20:14', 'admin-1484969658-14849724145211232', 1, 1, 'SR', NULL, NULL, NULL),
(18282, '2017-01-21 12:20:14', NULL, NULL, 6305, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 12:20:14', 'admin-1484969658-14849724145211232', 1, 1, 'SR', NULL, NULL, NULL),
(18283, '2017-01-21 12:20:14', NULL, NULL, 6305, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 12:20:14', 'admin-1484969658-14849724145211232', 1, 0, '', NULL, NULL, NULL),
(18284, '2017-01-21 12:20:14', NULL, NULL, 6305, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 12:20:14', 'admin-1484969658-14849724145211232', 1, 0, '', NULL, NULL, NULL),
(18285, '2017-01-21 12:43:41', NULL, NULL, 6302, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 12:43:41', 'admin-1484969658-14849738217344339', 1, 1, 'SR', NULL, NULL, NULL),
(18286, '2017-01-21 12:46:11', NULL, NULL, 6306, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 12:46:11', 'admin-1484969658-14849739714192037', 1, 1, 'SR', NULL, NULL, NULL),
(18287, '2017-01-21 12:46:11', NULL, NULL, 6306, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 12:46:11', 'admin-1484969658-14849739714192037', 1, 1, 'SR', NULL, NULL, NULL),
(18288, '2017-01-21 12:52:49', NULL, NULL, 6300, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 12:52:49', 'admin-1484969658-1484974369654660', 1, 1, 'SR', NULL, NULL, NULL),
(18289, '2017-01-21 13:13:27', NULL, NULL, 6307, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 13:13:27', 'admin-1484969658-14849756070558152', 1, 1, 'SR', NULL, NULL, NULL),
(18290, '2017-01-21 14:36:26', NULL, NULL, 6313, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 14:36:26', 'admin-1484978263-14849805864416066', 1, 1, 'SR', NULL, NULL, NULL),
(18291, '2017-01-21 14:43:34', NULL, NULL, 6314, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 14:43:34', 'admin-1484978263-1484981013930944', 1, 1, 'SR', NULL, NULL, NULL),
(18292, '2017-01-21 14:43:34', NULL, NULL, 6314, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 14:43:34', 'admin-1484978263-1484981013930944', 1, 1, 'SR', NULL, NULL, NULL),
(18293, '2017-01-21 15:01:44', NULL, NULL, 6314, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 15:01:44', 'admin-1484978263-14849821042799079', 1, 1, 'SR', NULL, NULL, NULL),
(18294, '2017-01-21 14:29:44', NULL, NULL, 6312, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 14:29:44', 'admin-1484978263-14849801839961356', 1, 1, 'SR', 1, NULL, NULL),
(18295, '2017-01-21 11:16:29', NULL, NULL, 6298, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 11:16:29', 'admin-1484964617-14849685894477152', 1, 0, '', NULL, NULL, NULL),
(18296, '2017-01-21 11:16:29', NULL, NULL, 6298, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 11:16:29', 'admin-1484964617-14849685894477152', 1, 0, '', NULL, NULL, NULL),
(18297, '2017-01-21 11:16:29', NULL, NULL, 6298, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 11:16:29', 'admin-1484964617-14849685894477152', 1, 0, '', NULL, NULL, NULL),
(18298, '2017-01-21 11:16:29', NULL, NULL, 6298, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 11:16:29', 'admin-1484964617-14849685894477152', 1, 0, '', NULL, NULL, NULL),
(18299, '2017-01-21 11:16:46', NULL, NULL, 6298, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 11:16:46', 'admin-1484964617-1484968606342265', 1, 1, 'SR', NULL, NULL, NULL),
(18300, '2017-01-21 11:16:46', NULL, NULL, 6298, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 11:16:46', 'admin-1484964617-1484968606342265', 1, 1, 'SR', NULL, NULL, NULL),
(18301, '2017-01-21 11:28:23', NULL, NULL, 6299, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 11:28:23', 'admin-1484964617-14849693035663475', 1, 0, '', NULL, NULL, NULL),
(18302, '2017-01-21 11:28:23', NULL, NULL, 6299, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 11:28:23', 'admin-1484964617-14849693035663475', 1, 0, '', NULL, NULL, NULL),
(18303, '2017-01-21 11:28:23', NULL, NULL, 6299, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 11:28:23', 'admin-1484964617-14849693035663475', 1, 1, 'SR', NULL, NULL, NULL),
(18304, '2017-01-21 11:34:13', NULL, NULL, 6300, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 11:34:13', 'admin-1484964617-14849696531844879', 1, 0, '', NULL, NULL, NULL),
(18305, '2017-01-21 17:10:10', NULL, NULL, 6322, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 17:10:10', 'admin-1484978263-14849898107629871', 1, 1, 'SR', NULL, NULL, NULL),
(18306, '2017-01-21 17:10:10', NULL, NULL, 6322, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 17:10:10', 'admin-1484978263-14849898107629871', 1, 1, 'SR', NULL, NULL, NULL),
(18307, '2017-01-21 17:49:08', NULL, NULL, 6324, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 17:49:08', 'admin-1484978263-14849921484454057', 1, 1, 'SR', NULL, NULL, NULL),
(18308, '2017-01-21 17:49:51', NULL, NULL, 6325, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 17:49:51', 'admin-1484978263-1484992191169897', 1, 0, '', NULL, NULL, NULL),
(18309, '2017-01-21 17:49:51', NULL, NULL, 6325, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 17:49:51', 'admin-1484978263-1484992191169897', 1, 0, '', NULL, NULL, NULL),
(18310, '2017-01-21 18:03:35', NULL, NULL, 6326, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 18:03:35', 'admin-1484978263-148499301482735', 1, 1, 'SR', 1, NULL, NULL),
(18311, '2017-01-21 18:32:29', NULL, NULL, 6327, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 18:32:29', 'admin-1484978263-14849947494881283', 1, 1, 'SR', NULL, NULL, NULL),
(18312, '2017-01-21 18:32:29', NULL, NULL, 6327, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 18:32:29', 'admin-1484978263-14849947494881283', 1, 0, '', NULL, NULL, NULL),
(18313, '2017-01-21 17:13:36', NULL, NULL, 6323, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 17:13:36', 'admin-1484978263-14849900162791810', 1, 1, 'SR', 1, NULL, NULL),
(18314, '2017-01-21 11:53:46', NULL, NULL, 6300, 0, 82, '82', 'Set Stir Fried Rice Wine Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 11:53:46', 'admin-1484969658-1484970826124951', 1, 1, 'SR', NULL, NULL, NULL),
(18315, '2017-01-21 11:53:46', NULL, NULL, 6300, 0, 213, '147', 'Set Stir Fried Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 11:53:46', 'admin-1484969658-1484970826124951', 1, 0, '', NULL, NULL, NULL),
(18316, '2017-01-21 11:55:32', NULL, NULL, 6301, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 11:55:32', 'admin-1484969658-14849709320441342', 1, 1, 'SR', NULL, NULL, NULL),
(18317, '2017-01-21 17:08:50', NULL, NULL, 6320, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 17:08:50', 'admin-1484978263-14849897298632324', 1, 1, 'SR', NULL, NULL, NULL),
(18318, '2017-01-21 14:28:56', NULL, NULL, 6311, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 14:28:56', 'admin-1484978263-1484980136740838', 1, 1, 'SR', 1, NULL, NULL),
(18319, '2017-01-21 14:28:56', NULL, NULL, 6311, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 14:28:56', 'admin-1484978263-1484980136740838', 1, 1, 'SR', 1, NULL, NULL),
(18320, '2017-01-21 13:58:02', NULL, NULL, 6310, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 13:58:02', 'admin-1484978263-14849782820143540', 1, 1, 'SR', NULL, NULL, NULL),
(18321, '2017-01-21 15:37:07', NULL, NULL, 6316, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 15:37:07', 'admin-1484978263-14849842277782498', 1, 1, 'SR', NULL, NULL, NULL),
(18322, '2017-01-21 11:53:46', NULL, NULL, 6300, 0, 181, '116', 'Open Food ', 'spicy pepper pork', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 11:53:46', 'admin-1484969658-1484970826124951', 1, 0, '', NULL, NULL, NULL),
(18323, '2017-01-21 11:53:46', NULL, NULL, 6300, 0, 82, '82', 'Set Stir Fried Rice Wine Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 11:53:46', 'admin-1484969658-1484970826124951', 1, 1, 'SR', NULL, NULL, NULL),
(18324, '2017-01-21 00:00:00', NULL, NULL, 6294, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:55:12', 'admin-1484964617-14849673116917948', 1, 0, '', NULL, NULL, NULL),
(18325, '2017-01-21 00:00:00', NULL, NULL, 6294, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:55:12', 'admin-1484964617-14849673116917948', 1, 1, 'SR', NULL, NULL, NULL),
(18326, '2017-01-21 00:00:00', NULL, NULL, 6295, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:55:12', 'admin-1484964617-14849673116917948', 1, 0, '', NULL, NULL, NULL),
(18327, '2017-01-21 10:00:34', NULL, NULL, 6287, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:00:34', 'admin-1484961232-14849640341755633', 1, 1, 'SR', NULL, NULL, NULL),
(18328, '2017-01-21 00:00:00', NULL, NULL, 6292, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:00:34', 'admin-1484961232-14849640341755633', 1, 0, '', NULL, NULL, NULL),
(18329, '2017-01-21 10:01:28', NULL, NULL, 6288, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:01:28', 'admin-1484961232-14849640881474624', 1, 0, '', NULL, NULL, NULL),
(18330, '2017-01-21 10:01:28', NULL, NULL, 6288, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:01:28', 'admin-1484961232-14849640881474624', 1, 1, 'SR', NULL, NULL, NULL),
(18331, '2017-01-21 10:08:45', NULL, NULL, 6289, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:08:45', 'admin-1484961232-14849645254068528', 1, 0, '', NULL, NULL, NULL),
(18332, '2017-01-21 10:08:45', NULL, NULL, 6289, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:08:45', 'admin-1484961232-14849645254068528', 1, 0, '', NULL, NULL, NULL),
(18333, '2017-01-21 00:00:00', NULL, NULL, 6296, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:55:12', 'admin-1484964617-14849673116917948', 1, 0, '', NULL, NULL, NULL),
(18334, '2017-01-21 00:00:00', NULL, NULL, 6295, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:55:12', 'admin-1484964617-14849673116917948', 1, 1, 'SR', NULL, NULL, NULL),
(18335, '2017-01-21 00:00:00', NULL, NULL, 6296, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:55:12', 'admin-1484964617-14849673116917948', 1, 1, 'SR', NULL, NULL, NULL),
(18336, '2017-01-21 11:09:22', NULL, NULL, 6297, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 11:09:22', 'admin-1484964617-14849681619382193', 1, 1, 'SR', NULL, NULL, NULL),
(18337, '2017-01-21 00:00:00', NULL, NULL, 6292, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:00:34', 'admin-1484961232-14849640341755633', 1, 1, 'SR', NULL, NULL, NULL),
(18338, '2017-01-21 10:37:53', NULL, NULL, 6291, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:37:53', 'admin-1484964617-14849662735799992', 1, 1, 'SR', NULL, NULL, NULL),
(18339, '2017-01-21 10:37:53', NULL, NULL, 6291, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:37:53', 'admin-1484964617-14849662735799992', 1, 1, 'SR', NULL, NULL, NULL),
(18340, '2017-01-21 10:37:46', NULL, NULL, 6291, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:37:46', 'admin-1484964617-1484966266532384', 1, 0, '', NULL, NULL, NULL),
(18341, '2017-01-21 10:37:46', NULL, NULL, 6291, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:37:46', 'admin-1484964617-1484966266532384', 1, 0, '', NULL, NULL, NULL),
(18342, '2017-01-21 10:34:07', NULL, NULL, 6290, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:34:07', 'admin-1484964617-14849660470931424', 1, 0, '', NULL, NULL, NULL),
(18343, '2017-01-21 10:08:45', NULL, NULL, 6289, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:08:45', 'admin-1484961232-14849645254068528', 1, 0, '', NULL, NULL, NULL),
(18344, '2017-01-21 10:34:07', NULL, NULL, 6290, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:34:07', 'admin-1484964617-14849660470931424', 1, 0, '', NULL, NULL, NULL),
(18345, '2017-01-21 10:08:45', NULL, NULL, 6289, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:08:45', 'admin-1484961232-14849645254068528', 1, 1, 'SR', NULL, NULL, NULL),
(18346, '2017-01-21 10:08:45', NULL, NULL, 6289, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:08:45', 'admin-1484961232-14849645254068528', 1, 0, '', NULL, NULL, NULL),
(18347, '2017-01-21 10:00:34', NULL, NULL, 6287, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 10:00:34', 'admin-1484961232-14849640341755633', 1, 0, '', NULL, NULL, NULL),
(18348, '2017-01-21 09:53:41', NULL, NULL, 6286, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 09:53:41', 'admin-1484961232-14849636215298111', 1, 1, 'SR', NULL, NULL, NULL),
(18349, '2017-01-21 09:53:41', NULL, NULL, 6286, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 09:53:41', 'admin-1484961232-14849636215298111', 1, 0, '', NULL, NULL, NULL),
(18350, '2017-01-21 09:53:41', NULL, NULL, 6286, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 09:53:41', 'admin-1484961232-14849636215298111', 1, 1, 'SR', NULL, NULL, NULL),
(18351, '2017-01-21 09:49:47', NULL, NULL, 6286, 0, 181, '116', 'Open Food ', 'Cranberries Scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 09:49:47', 'admin-1484961232-1484963387460161', 1, 0, '', NULL, NULL, NULL),
(18352, '2017-01-21 09:53:41', NULL, NULL, 6286, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 09:53:41', 'admin-1484961232-14849636215298111', 1, 0, '', NULL, NULL, NULL),
(18353, '2017-01-21 09:46:13', NULL, NULL, 6285, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 09:46:13', 'admin-1484961232-14849631733134941', 1, 1, 'SR', NULL, NULL, NULL),
(18354, '2017-01-21 09:46:13', NULL, NULL, 6285, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 09:46:13', 'admin-1484961232-14849631733134941', 1, 0, '', NULL, NULL, NULL),
(18355, '2017-01-21 09:46:13', NULL, NULL, 6285, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 09:46:13', 'admin-1484961232-14849631733134941', 1, 1, 'SR', NULL, NULL, NULL),
(18356, '2017-01-21 09:49:47', NULL, NULL, 6286, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 09:49:47', 'admin-1484961232-1484963387460161', 1, 1, 'SR', NULL, NULL, NULL),
(18357, '2017-01-21 09:45:56', NULL, NULL, 6285, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 09:45:56', 'admin-1484961232-14849631564484758', 1, 0, '', NULL, NULL, NULL),
(18358, '2017-01-21 09:45:56', NULL, NULL, 6285, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 09:45:56', 'admin-1484961232-14849631564484758', 1, 0, '', NULL, NULL, NULL),
(18359, '2017-01-21 09:36:22', NULL, NULL, 6284, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 09:36:22', 'admin-1484961232-1484962582501199', 1, 1, 'SR', NULL, NULL, NULL),
(18360, '2017-01-21 09:45:56', NULL, NULL, 6285, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 09:45:56', 'admin-1484961232-14849631564484758', 1, 0, '', NULL, NULL, NULL),
(18361, '2017-01-21 09:33:02', NULL, NULL, 6284, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 09:33:02', 'admin-1484961232-14849623823976844', 1, 1, 'SR', NULL, NULL, NULL),
(18362, '2017-01-21 09:32:56', NULL, NULL, 6284, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 09:32:56', 'admin-1484961232-14849623764503162', 1, 0, '', NULL, NULL, NULL),
(18363, '2017-01-21 09:32:56', NULL, NULL, 6284, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 09:32:56', 'admin-1484961232-14849623764503162', 1, 0, '', NULL, NULL, NULL),
(18364, '2017-01-21 09:25:06', NULL, NULL, 6283, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1484978263', 'admin', '2017-01-21 09:25:06', 'admin-1484961232-14849619060822299', 1, 1, 'SR', NULL, NULL, NULL),
(18365, '2017-01-22 16:39:54', NULL, NULL, 6368, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 16:39:54', 'admin-1485066722-1485074394656321', 1, 1, 'SR', NULL, NULL, NULL),
(18366, '2017-01-22 16:35:11', NULL, NULL, 6367, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 16:35:11', 'admin-1485066722-14850741109227197', 1, 1, 'SR', 1, NULL, NULL),
(18367, '2017-01-22 16:35:11', NULL, NULL, 6367, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 16:35:11', 'admin-1485066722-14850741109227197', 1, 1, 'SR', 1, NULL, NULL),
(18368, '2017-01-22 16:22:10', NULL, NULL, 6366, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 16:22:10', 'admin-1485066722-14850733303884034', 1, 1, 'SR', 1, NULL, NULL),
(18369, '2017-01-22 16:22:10', NULL, NULL, 6366, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 16:22:10', 'admin-1485066722-14850733303884034', 1, 0, '', 1, NULL, NULL),
(18370, '2017-01-22 16:05:46', NULL, NULL, 6364, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 16:05:46', 'admin-1485066722-14850723464555154', 1, 1, 'SR', 1, NULL, NULL),
(18371, '2017-01-22 16:05:02', NULL, NULL, 6363, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 16:05:02', 'admin-1485066722-1485072302688413', 1, 1, 'SR', 1, NULL, NULL),
(18372, '2017-01-22 16:05:02', NULL, NULL, 6363, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 16:05:02', 'admin-1485066722-1485072302688413', 1, 1, 'SR', 1, NULL, NULL),
(18373, '2017-01-22 16:39:54', NULL, NULL, 6368, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 16:39:54', 'admin-1485066722-1485074394656321', 1, 1, 'SR', NULL, NULL, NULL),
(18374, '2017-01-22 16:39:54', NULL, NULL, 6368, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 16:39:54', 'admin-1485066722-1485074394656321', 1, 1, 'SR', NULL, NULL, NULL),
(18375, '2017-01-22 16:40:19', NULL, NULL, 6368, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 16:40:19', 'admin-1485066722-14850744193753542', 1, 1, 'SR', NULL, NULL, NULL),
(18376, '2017-01-22 17:03:07', NULL, NULL, 6369, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 17:03:07', 'admin-1485066722-1485075787089611', 1, 1, 'SR', NULL, NULL, NULL),
(18377, '2017-01-22 17:13:24', NULL, NULL, 6369, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 17:13:24', 'admin-1485066722-14850764039263075', 1, 1, 'SR', NULL, NULL, NULL),
(18378, '2017-01-22 16:05:02', NULL, NULL, 6363, 0, 244, '178', 'Macadamia Scones', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 16:05:02', 'admin-1485066722-1485072302688413', 1, 0, '', 1, NULL, NULL),
(18379, '2017-01-22 15:30:18', NULL, NULL, 6362, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 15:30:18', 'admin-1485066722-14850702183004051', 1, 0, '', NULL, NULL, NULL),
(18380, '2017-01-22 19:13:06', NULL, NULL, 6372, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 19:13:06', 'admin-1485066722-14850835863109819', 1, 1, 'SR', NULL, NULL, NULL),
(18381, '2017-01-22 18:10:03', NULL, NULL, 6371, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 18:10:03', 'admin-1485066722-1485079802873419', 1, 1, 'SR', NULL, NULL, NULL),
(18382, '2017-01-22 19:06:53', NULL, NULL, 6372, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 19:06:53', 'admin-1485066722-1485083213659718', 1, 0, '', NULL, NULL, NULL),
(18383, '2017-01-22 17:46:15', NULL, NULL, 6370, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 17:46:15', 'admin-1485066722-14850783750968488', 1, 1, 'SR', NULL, NULL, NULL),
(18384, '2017-01-22 15:20:20', NULL, NULL, 6361, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 15:20:20', 'admin-1485066722-14850696204121738', 1, 0, '', NULL, NULL, NULL),
(18385, '2017-01-22 15:20:20', NULL, NULL, 6361, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 15:20:20', 'admin-1485066722-14850696204121738', 1, 1, 'SR', NULL, NULL, NULL),
(18386, '2017-01-22 15:03:13', NULL, NULL, 6360, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 15:03:13', 'admin-1485066722-14850685936536860', 1, 1, 'SR', NULL, NULL, NULL),
(18387, '2017-01-22 15:03:13', NULL, NULL, 6360, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 15:03:13', 'admin-1485066722-14850685936536860', 1, 1, 'SR', NULL, NULL, NULL),
(18388, '2017-01-22 15:03:00', NULL, NULL, 6355, 0, 181, '116', 'Open Food ', 'Scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 15:03:00', 'admin-1485066722-14850685798461026', 1, 0, '', NULL, NULL, NULL),
(18389, '2017-01-22 14:58:43', NULL, NULL, 6355, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 14:58:43', 'admin-1485066722-14850683231079530', 1, 1, 'SR', NULL, NULL, NULL),
(18390, '2017-01-22 14:41:05', NULL, NULL, 6359, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 14:41:05', 'admin-1485066722-1485067264877773', 1, 1, 'SR', NULL, NULL, NULL),
(18391, '2017-01-22 00:00:00', NULL, NULL, 6358, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 13:21:46', 'admin-1485059698-1485062505831237', 1, 1, 'SR', NULL, NULL, NULL),
(18392, '2017-01-22 14:31:11', NULL, NULL, 6356, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 14:31:11', 'admin-1485059698-14850666713292354', 1, 0, '', NULL, NULL, NULL),
(18393, '2017-01-22 14:31:11', NULL, NULL, 6356, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 14:31:11', 'admin-1485059698-14850666713292354', 1, 1, 'SR', NULL, NULL, NULL),
(18394, '2017-01-22 00:00:00', NULL, NULL, 6345, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:48:48', 'admin-1485053010-14850569286079938', 1, 1, 'SR', NULL, NULL, NULL),
(18395, '2017-01-22 00:00:00', NULL, NULL, 6343, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:48:22', 'admin-1485053010-14850569020807457', 1, 1, 'SR', NULL, NULL, NULL),
(18396, '2017-01-22 12:34:33', NULL, NULL, 6348, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 12:34:33', 'admin-1485053010-14850596735031651', 1, 1, 'SR', NULL, NULL, NULL),
(18397, '2017-01-22 00:00:00', NULL, NULL, 6346, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:48:22', 'admin-1485053010-14850569020807457', 1, 0, '', NULL, NULL, NULL),
(18398, '2017-01-22 00:00:00', NULL, NULL, 6344, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 12:02:57', 'admin-1485053010-14850577776107518', 1, 1, 'SR', NULL, NULL, NULL),
(18399, '2017-01-22 00:00:00', NULL, NULL, 6345, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:47:15', 'admin-1485053010-1485056835600795', 1, 0, '', NULL, NULL, NULL),
(18400, '2017-01-22 00:00:00', NULL, NULL, 6344, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:48:22', 'admin-1485053010-14850569020807457', 1, 0, '', NULL, NULL, NULL),
(18401, '2017-01-22 00:00:00', NULL, NULL, 6343, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:48:22', 'admin-1485053010-14850569020807457', 1, 0, '', NULL, NULL, NULL),
(18402, '2017-01-22 12:34:33', NULL, NULL, 6348, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 12:34:33', 'admin-1485053010-14850596735031651', 1, 0, '', NULL, NULL, NULL),
(18403, '2017-01-22 12:35:17', NULL, NULL, 6348, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 12:35:17', 'admin-1485059698-14850597168382897', 1, 0, '', NULL, NULL, NULL),
(18404, '2017-01-22 12:35:51', NULL, NULL, 6348, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 12:35:51', 'admin-1485059698-14850597512039883', 1, 1, 'SR', NULL, NULL, NULL),
(18405, '2017-01-22 12:35:51', NULL, NULL, 6348, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 12:35:51', 'admin-1485059698-14850597512039883', 1, 1, 'SR', NULL, NULL, NULL),
(18406, '2017-01-22 12:39:36', NULL, NULL, 6349, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 12:39:36', 'admin-1485059698-1485059975993709', 1, 0, '', NULL, NULL, NULL),
(18407, '2017-01-22 13:20:19', NULL, NULL, 6350, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 13:20:19', 'admin-1485059698-14850624188526757', 1, 1, 'SR', NULL, NULL, NULL),
(18408, '2017-01-22 13:20:30', NULL, NULL, 6350, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 13:20:30', 'admin-1485059698-14850624306885835', 1, 1, 'SR', NULL, NULL, NULL),
(18409, '2017-01-22 14:41:05', NULL, NULL, 6359, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 14:41:05', 'admin-1485066722-1485067264877773', 1, 0, '', NULL, NULL, NULL),
(18410, '2017-01-22 13:21:46', NULL, NULL, 6351, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 13:21:46', 'admin-1485059698-1485062505831237', 1, 0, '', NULL, NULL, NULL),
(18411, '2017-01-22 17:46:15', NULL, NULL, 6370, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 17:46:15', 'admin-1485066722-14850783750968488', 1, 1, 'SR', NULL, NULL, NULL),
(18412, '2017-01-22 17:26:57', NULL, NULL, 6369, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 17:26:57', 'admin-1485066722-14850772175867730', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(18413, '2017-01-22 15:30:18', NULL, NULL, 6362, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 15:30:18', 'admin-1485066722-14850702183004051', 1, 1, 'SR', NULL, NULL, NULL),
(18414, '2017-01-22 14:25:22', NULL, NULL, 6355, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 14:25:22', 'admin-1485059698-14850663219699382', 1, 0, '', NULL, NULL, NULL),
(18415, '2017-01-22 11:38:27', NULL, NULL, 6340, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:38:27', 'admin-1485053010-14850563073818526', 1, 1, 'SR', NULL, NULL, NULL),
(18416, '2017-01-22 11:41:45', NULL, NULL, 6341, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:41:45', 'admin-1485053010-14850565057784262', 1, 0, '', NULL, NULL, NULL),
(18417, '2017-01-22 11:41:45', NULL, NULL, 6341, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:41:45', 'admin-1485053010-14850565057784262', 1, 0, '', NULL, NULL, NULL),
(18418, '2017-01-22 11:41:51', NULL, NULL, 6341, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:41:51', 'admin-1485053010-14850565112352554', 1, 1, 'SR', NULL, NULL, NULL),
(18419, '2017-01-22 00:00:00', NULL, NULL, 6346, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:48:22', 'admin-1485053010-14850569020807457', 1, 1, 'SR', NULL, NULL, NULL),
(18420, '2017-01-22 11:23:40', NULL, NULL, 6338, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:23:40', 'admin-1485053010-14850554204229262', 1, 0, '', NULL, NULL, NULL),
(18421, '2017-01-22 10:44:39', NULL, NULL, 6336, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:44:39', 'admin-1485053010-14850530789378970', 1, 1, 'SR', NULL, NULL, NULL),
(18422, '2017-01-22 11:18:00', NULL, NULL, 6337, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:18:00', 'admin-1485053010-14850550802606346', 1, 0, '', NULL, NULL, NULL),
(18423, '2017-01-22 11:18:00', NULL, NULL, 6337, 0, 154, '88', 'House BLT', 'with scrambled egg', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:18:00', 'admin-1485053010-14850550802606346', 1, 0, '', NULL, NULL, NULL),
(18424, '2017-01-22 11:18:00', NULL, NULL, 6337, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:18:00', 'admin-1485053010-14850550802606346', 1, 0, '', NULL, NULL, NULL),
(18425, '2017-01-22 11:18:00', NULL, NULL, 6337, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:18:00', 'admin-1485053010-14850550802606346', 1, 0, '', NULL, NULL, NULL),
(18426, '2017-01-22 11:18:23', NULL, NULL, 6337, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:18:23', 'admin-1485053010-14850551032285416', 1, 1, 'SR', NULL, NULL, NULL),
(18427, '2017-01-22 11:18:23', NULL, NULL, 6337, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:18:23', 'admin-1485053010-14850551032285416', 1, 1, 'SR', NULL, NULL, NULL),
(18428, '2017-01-22 11:18:23', NULL, NULL, 6337, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:18:23', 'admin-1485053010-14850551032285416', 1, 1, 'SR', NULL, NULL, NULL),
(18429, '2017-01-22 11:18:23', NULL, NULL, 6337, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:18:23', 'admin-1485053010-14850551032285416', 1, 1, 'SR', NULL, NULL, NULL),
(18430, '2017-01-22 14:25:22', NULL, NULL, 6355, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 14:25:22', 'admin-1485059698-14850663219699382', 1, 1, 'SR', NULL, NULL, NULL),
(18431, '2017-01-22 13:48:44', NULL, NULL, 6354, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 13:48:44', 'admin-1485059698-14850641244132463', 1, 1, 'SR', NULL, NULL, NULL),
(18432, '2017-01-22 13:48:44', NULL, NULL, 6354, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 13:48:44', 'admin-1485059698-14850641244132463', 1, 1, 'SR', NULL, NULL, NULL),
(18433, '2017-01-22 13:43:56', NULL, NULL, 6354, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 13:43:56', 'admin-1485059698-14850638365753228', 1, 0, '', NULL, NULL, NULL),
(18434, '2017-01-22 13:37:30', NULL, NULL, 6353, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 13:37:30', 'admin-1485059698-1485063450043982', 1, 1, 'SR', NULL, NULL, NULL),
(18435, '2017-01-22 13:29:52', NULL, NULL, 6352, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 13:29:52', 'admin-1485059698-14850629921751624', 1, 1, 'SR', NULL, NULL, NULL),
(18436, '2017-01-22 13:37:30', NULL, NULL, 6353, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 13:37:30', 'admin-1485059698-1485063450043982', 1, 1, 'SR', NULL, NULL, NULL),
(18437, '2017-01-22 13:37:30', NULL, NULL, 6353, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 13:37:30', 'admin-1485059698-1485063450043982', 1, 0, '', NULL, NULL, NULL),
(18438, '2017-01-22 00:00:00', NULL, NULL, 6358, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 13:21:45', 'admin-1485059698-1485062505831237', 1, 0, '', NULL, NULL, NULL),
(18439, '2017-01-22 13:21:46', NULL, NULL, 6351, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 13:21:46', 'admin-1485059698-1485062505831237', 1, 0, '', NULL, NULL, NULL),
(18440, '2017-01-22 00:00:00', NULL, NULL, 6345, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:47:15', 'admin-1485053010-1485056835600795', 1, 0, '', NULL, NULL, NULL),
(18441, '2017-01-22 11:24:35', NULL, NULL, 6339, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:24:35', 'admin-1485053010-14850554749894754', 1, 1, 'SR', NULL, NULL, NULL),
(18442, '2017-01-22 11:24:35', NULL, NULL, 6339, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:24:35', 'admin-1485053010-14850554749894754', 1, 1, 'SR', NULL, NULL, NULL),
(18443, '2017-01-22 11:24:35', NULL, NULL, 6339, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:24:35', 'admin-1485053010-14850554749894754', 1, 1, 'SR', NULL, NULL, NULL),
(18444, '2017-01-22 11:30:51', NULL, NULL, 6333, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:30:51', 'admin-1485053010-14850558517317559', 1, 1, 'SR', NULL, NULL, NULL),
(18445, '2017-01-22 00:00:00', NULL, NULL, 6347, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:48:22', 'admin-1485053010-14850569020807457', 1, 0, '', NULL, NULL, NULL),
(18446, '2017-01-22 00:00:00', NULL, NULL, 6345, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:47:15', 'admin-1485053010-1485056835600795', 1, 1, 'SR', NULL, NULL, NULL),
(18447, '2017-01-22 00:00:00', NULL, NULL, 6345, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:47:15', 'admin-1485053010-1485056835600795', 1, 1, 'SR', NULL, NULL, NULL),
(18448, '2017-01-22 10:43:07', NULL, NULL, 6335, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:43:07', 'admin-1485049904-14850529874313476', 1, 0, '', NULL, NULL, NULL),
(18449, '2017-01-22 10:44:39', NULL, NULL, 6336, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:44:39', 'admin-1485053010-14850530789378970', 1, 0, '', NULL, NULL, NULL),
(18450, '2017-01-22 14:31:55', NULL, NULL, 6357, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 14:31:55', 'admin-1485059698-14850667149799773', 1, 0, '', NULL, NULL, NULL),
(18451, '2017-01-22 11:31:37', NULL, NULL, 6340, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:31:37', 'admin-1485053010-14850558969957088', 1, 0, '', NULL, NULL, NULL),
(18452, '2017-01-22 11:23:40', NULL, NULL, 6338, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:23:40', 'admin-1485053010-14850554204229262', 1, 1, 'SR', NULL, NULL, NULL),
(18453, '2017-01-22 11:23:40', NULL, NULL, 6338, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 11:23:40', 'admin-1485053010-14850554204229262', 1, 0, '', NULL, NULL, NULL),
(18454, '2017-01-22 10:15:29', NULL, NULL, 6332, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:15:29', 'admin-1485049904-14850513293655461', 1, 1, 'SR', NULL, NULL, NULL),
(18455, '2017-01-22 10:15:29', NULL, NULL, 6332, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:15:29', 'admin-1485049904-14850513293655461', 1, 1, 'SR', NULL, NULL, NULL),
(18456, '2017-01-22 10:15:29', NULL, NULL, 6332, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:15:29', 'admin-1485049904-14850513293655461', 1, 1, 'SR', NULL, NULL, NULL),
(18457, '2017-01-22 10:15:29', NULL, NULL, 6332, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:15:29', 'admin-1485049904-14850513293655461', 1, 1, 'SR', NULL, NULL, NULL),
(18458, '2017-01-22 10:17:30', NULL, NULL, 6333, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:17:30', 'admin-1485049904-14850514498741863', 1, 0, '', NULL, NULL, NULL),
(18459, '2017-01-22 10:17:30', NULL, NULL, 6333, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:17:30', 'admin-1485049904-14850514498741863', 1, 0, '', NULL, NULL, NULL),
(18460, '2017-01-22 10:17:30', NULL, NULL, 6333, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:17:30', 'admin-1485049904-14850514498741863', 1, 0, '', NULL, NULL, NULL),
(18461, '2017-01-22 10:17:30', NULL, NULL, 6333, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:17:30', 'admin-1485049904-14850514498741863', 1, 1, 'SR', NULL, NULL, NULL),
(18462, '2017-01-22 10:17:47', NULL, NULL, 6333, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:17:47', 'admin-1485049904-14850514669897896', 1, 0, '', NULL, NULL, NULL),
(18463, '2017-01-22 10:17:47', NULL, NULL, 6333, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:17:47', 'admin-1485049904-14850514669897896', 1, 0, '', NULL, NULL, NULL),
(18464, '2017-01-22 10:18:16', NULL, NULL, 6333, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:18:16', 'admin-1485049904-14850514963663013', 1, 1, 'SR', NULL, NULL, NULL),
(18465, '2017-01-22 10:18:16', NULL, NULL, 6333, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:18:16', 'admin-1485049904-14850514963663013', 1, 1, 'SR', NULL, NULL, NULL),
(18466, '2017-01-22 10:18:16', NULL, NULL, 6333, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:18:16', 'admin-1485049904-14850514963663013', 1, 1, 'SR', NULL, NULL, NULL),
(18467, '2017-01-22 10:22:53', NULL, NULL, 6334, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:22:53', 'admin-1485049904-14850517735405223', 1, 0, '', NULL, NULL, NULL),
(18468, '2017-01-22 10:22:53', NULL, NULL, 6334, 0, 155, '89', 'Joyous Sunny ', 'egg well done', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:22:53', 'admin-1485049904-14850517735405223', 1, 0, '', NULL, NULL, NULL),
(18469, '2017-01-22 10:22:53', NULL, NULL, 6334, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:22:53', 'admin-1485049904-14850517735405223', 1, 1, 'SR', NULL, NULL, NULL),
(18470, '2017-01-22 10:22:53', NULL, NULL, 6334, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:22:53', 'admin-1485049904-14850517735405223', 1, 1, 'SR', NULL, NULL, NULL),
(18471, '2017-01-22 10:41:28', NULL, NULL, 6335, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:41:28', 'admin-1485049904-14850528879128444', 1, 0, '', NULL, NULL, NULL),
(18472, '2017-01-22 10:41:33', NULL, NULL, 6335, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:41:33', 'admin-1485049904-14850528935213719', 1, 1, 'SR', NULL, NULL, NULL),
(18473, '2017-01-22 10:42:29', NULL, NULL, 6332, 0, 181, '116', 'Open Food ', 'toast', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:42:29', 'admin-1485049904-1485052948935688', 1, 0, '', NULL, NULL, NULL),
(18474, '2017-01-22 10:43:07', NULL, NULL, 6335, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:43:07', 'admin-1485049904-14850529874313476', 1, 1, 'SR', NULL, NULL, NULL),
(18475, '2017-01-22 09:17:50', NULL, NULL, 6329, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 09:17:50', 'admin-1485046061-14850478706492792', 1, 1, 'SR', NULL, NULL, NULL),
(18476, '2017-01-22 10:15:12', NULL, NULL, 6332, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:15:12', 'admin-1485049904-14850513120675987', 1, 0, '', NULL, NULL, NULL),
(18477, '2017-01-22 10:15:12', NULL, NULL, 6332, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:15:12', 'admin-1485049904-14850513120675987', 1, 0, '', NULL, NULL, NULL),
(18478, '2017-01-22 10:15:12', NULL, NULL, 6332, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:15:12', 'admin-1485049904-14850513120675987', 1, 0, '', NULL, NULL, NULL),
(18479, '2017-01-22 10:15:12', NULL, NULL, 6332, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:15:12', 'admin-1485049904-14850513120675987', 1, 0, '', NULL, NULL, NULL),
(18480, '2017-01-22 10:07:06', NULL, NULL, 6329, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 10:07:06', 'admin-1485049904-14850508267943129', 1, 0, '', NULL, NULL, NULL),
(18481, '2017-01-22 09:51:26', NULL, NULL, 6331, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 09:51:26', 'admin-1485046061-14850498862034217', 1, 0, '', NULL, NULL, NULL),
(18482, '2017-01-22 09:51:32', NULL, NULL, 6331, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 09:51:32', 'admin-1485046061-14850498924175759', 1, 0, '', NULL, NULL, NULL),
(18483, '2017-01-22 09:51:57', NULL, NULL, 6331, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 09:51:57', 'admin-1485049904-14850499168541577', 1, 1, 'SR', NULL, NULL, NULL),
(18484, '2017-01-22 09:53:47', NULL, NULL, 6330, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 09:53:47', 'admin-1485049904-14850500271202281', 1, 1, 'SR', NULL, NULL, NULL),
(18485, '2017-01-22 09:41:12', NULL, NULL, 6330, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 09:41:12', 'admin-1485046061-14850492724729155', 1, 0, '', NULL, NULL, NULL),
(18486, '2017-01-22 09:41:12', NULL, NULL, 6330, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 09:41:12', 'admin-1485046061-14850492724729155', 1, 0, '', NULL, NULL, NULL),
(18487, '2017-01-22 09:41:05', NULL, NULL, 6330, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 09:41:05', 'admin-1485046061-1485049265207618', 1, 1, 'SR', NULL, NULL, NULL),
(18488, '2017-01-22 09:17:50', NULL, NULL, 6329, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 09:17:50', 'admin-1485046061-14850478706492792', 1, 1, 'SR', NULL, NULL, NULL),
(18489, '2017-01-22 09:17:45', NULL, NULL, 6329, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 09:17:45', 'admin-1485046061-14850478657197848', 1, 0, '', NULL, NULL, NULL),
(18490, '2017-01-22 09:17:45', NULL, NULL, 6329, 0, 156, '90', 'Cheese Omelet', 'add baked beans', 'Meals', 'Morning Bites ', 1, 14.50, 14.5000, 0.0000, 14.50, 1, '27', 1, '1485066722', 'admin', '2017-01-22 09:17:45', 'admin-1485046061-14850478657197848', 1, 0, '', NULL, NULL, NULL),
(18491, '2017-01-22 09:11:06', NULL, NULL, 6328, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 09:11:06', 'admin-1485046061-14850474660937226', 1, 1, 'SR', NULL, NULL, NULL),
(18492, '2017-01-22 09:10:58', NULL, NULL, 6328, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485066722', 'admin', '2017-01-22 09:10:58', 'admin-1485046061-14850474585895831', 1, 0, '', NULL, NULL, NULL),
(18493, '2017-01-23 16:51:53', NULL, NULL, 6390, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 16:51:53', 'admin-1485145022-1485161513028387', 1, 1, 'SR', 1, NULL, NULL),
(18494, '2017-01-23 17:01:59', NULL, NULL, 6391, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 17:01:59', 'admin-1485145022-14851621190624729', 1, 1, 'SR', 1, NULL, NULL),
(18495, '2017-01-23 15:10:41', NULL, NULL, 6387, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1485145022', 'admin', '2017-01-23 15:10:41', 'admin-1485145022-14851554413844919', 1, 0, '', 1, NULL, NULL),
(18496, '2017-01-23 15:10:41', NULL, NULL, 6387, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1485145022', 'admin', '2017-01-23 15:10:41', 'admin-1485145022-14851554413844919', 1, 0, '', 1, NULL, NULL),
(18497, '2017-01-23 15:10:41', NULL, NULL, 6387, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1485145022', 'admin', '2017-01-23 15:10:41', 'admin-1485145022-14851554413844919', 1, 0, '', 1, NULL, NULL),
(18498, '2017-01-23 15:55:48', NULL, NULL, 6388, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 15:55:48', 'admin-1485145022-14851581478796185', 1, 1, 'SR', NULL, NULL, NULL),
(18499, '2017-01-23 15:55:48', NULL, NULL, 6388, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 15:55:48', 'admin-1485145022-14851581478796185', 1, 1, 'SR', NULL, NULL, NULL),
(18500, '2017-01-23 16:20:48', NULL, NULL, 6389, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 16:20:48', 'admin-1485145022-14851596479651915', 1, 1, 'SR', NULL, NULL, '10.0'),
(18501, '2017-01-23 15:10:41', NULL, NULL, 6387, 0, 265, '199', 'Old Penang PostCard', '', 'DISCOUNT ', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 15:10:41', 'admin-1485145022-14851554413844919', 1, 0, '', 1, NULL, NULL),
(18502, '2017-01-23 15:10:41', NULL, NULL, 6387, 0, 265, '199', 'Old Penang PostCard', '', 'DISCOUNT ', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 15:10:41', 'admin-1485145022-14851554413844919', 1, 0, '', 1, NULL, NULL),
(18503, '2017-01-23 11:33:09', NULL, NULL, 6379, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 11:33:09', 'admin-1485133228-14851423887741878', 1, 0, '', NULL, NULL, NULL),
(18504, '2017-01-23 11:33:22', NULL, NULL, 6379, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 11:33:22', 'admin-1485142394-14851424027527432', 1, 1, 'SR', NULL, NULL, NULL),
(18505, '2017-01-23 11:33:22', NULL, NULL, 6379, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 11:33:22', 'admin-1485142394-14851424027527432', 1, 1, 'SR', NULL, NULL, NULL),
(18506, '2017-01-23 11:35:02', NULL, NULL, 6380, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 11:35:02', 'admin-1485142394-14851425021606473', 1, 0, '', NULL, NULL, NULL),
(18507, '2017-01-23 11:36:26', NULL, NULL, 6380, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 11:36:26', 'admin-1485142394-14851425865849748', 1, 0, '', NULL, NULL, NULL),
(18508, '2017-01-23 11:35:02', NULL, NULL, 6380, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 11:35:02', 'admin-1485142394-14851425021606473', 1, 0, '', NULL, NULL, NULL),
(18509, '2017-01-23 11:35:02', NULL, NULL, 6380, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 11:35:02', 'admin-1485142394-14851425021606473', 1, 0, '', NULL, NULL, NULL),
(18510, '2017-01-23 11:35:02', NULL, NULL, 6380, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 11:35:02', 'admin-1485142394-14851425021606473', 1, 0, '', NULL, NULL, NULL),
(18511, '2017-01-23 12:07:15', NULL, NULL, 6381, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 12:07:15', 'admin-1485142394-14851444357004542', 1, 0, '', NULL, NULL, NULL),
(18512, '2017-01-23 12:09:08', NULL, NULL, 6381, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 12:09:08', 'admin-1485142394-148514454846768', 1, 0, '', NULL, NULL, NULL),
(18513, '2017-01-23 15:10:41', NULL, NULL, 6387, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1485145022', 'admin', '2017-01-23 15:10:41', 'admin-1485145022-14851554413844919', 1, 0, '', 1, NULL, NULL),
(18514, '2017-01-23 15:10:41', NULL, NULL, 6387, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1485145022', 'admin', '2017-01-23 15:10:41', 'admin-1485145022-14851554413844919', 1, 0, '', 1, NULL, NULL),
(18515, '2017-01-23 15:10:41', NULL, NULL, 6387, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1485145022', 'admin', '2017-01-23 15:10:41', 'admin-1485145022-14851554413844919', 1, 0, '', 1, NULL, NULL),
(18516, '2017-01-23 14:16:11', NULL, NULL, 6386, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 14:16:11', 'admin-1485145022-1485152170843263', 1, 1, 'SR', NULL, NULL, NULL),
(18517, '2017-01-23 13:57:18', NULL, NULL, 6378, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 13:57:18', 'admin-1485145022-14851510378873644', 1, 0, '', NULL, NULL, NULL),
(18518, '2017-01-23 13:40:14', NULL, NULL, 6385, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 13:40:14', 'admin-1485145022-14851500144635377', 1, 0, '', NULL, NULL, NULL),
(18519, '2017-01-23 12:31:05', NULL, NULL, 6378, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 12:31:05', 'admin-1485145022-14851458651138954', 1, 1, 'SR', NULL, NULL, NULL),
(18520, '2017-01-23 12:31:05', NULL, NULL, 6378, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 12:31:05', 'admin-1485145022-14851458651138954', 1, 1, 'SR', NULL, NULL, NULL),
(18521, '2017-01-23 12:31:05', NULL, NULL, 6378, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 12:31:05', 'admin-1485145022-14851458651138954', 1, 0, '', NULL, NULL, NULL),
(18522, '2017-01-23 12:27:03', NULL, NULL, 6378, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 12:27:03', 'admin-1485145022-1485145622858959', 1, 0, '', NULL, NULL, NULL),
(18523, '2017-01-23 12:27:03', NULL, NULL, 6378, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 12:27:03', 'admin-1485145022-1485145622858959', 1, 0, '', NULL, NULL, NULL),
(18524, '2017-01-23 12:16:56', NULL, NULL, 6384, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 12:16:56', 'admin-1485142394-1485145016473312', 1, 1, 'SR', NULL, NULL, NULL),
(18525, '2017-01-23 12:16:56', NULL, NULL, 6384, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 12:16:56', 'admin-1485142394-1485145016473312', 1, 0, '', NULL, NULL, NULL),
(18526, '2017-01-23 12:16:56', NULL, NULL, 6384, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 12:16:56', 'admin-1485142394-1485145016473312', 1, 1, 'SR', NULL, NULL, NULL),
(18527, '2017-01-23 12:16:56', NULL, NULL, 6384, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 12:16:56', 'admin-1485142394-1485145016473312', 1, 0, '', NULL, NULL, NULL),
(18528, '2017-01-23 12:16:56', NULL, NULL, 6384, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 12:16:56', 'admin-1485142394-1485145016473312', 1, 0, '', NULL, NULL, NULL),
(18529, '2017-01-23 12:13:48', NULL, NULL, 6383, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 12:13:48', 'admin-1485142394-14851448282746179', 1, 1, 'SR', NULL, NULL, NULL),
(18530, '2017-01-23 12:11:35', NULL, NULL, 6382, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 12:11:35', 'admin-1485142394-14851446953743415', 1, 1, 'SR', NULL, NULL, NULL),
(18531, '2017-01-23 12:11:35', NULL, NULL, 6382, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 12:11:35', 'admin-1485142394-14851446953743415', 1, 1, 'SR', NULL, NULL, NULL),
(18532, '2017-01-23 12:11:35', NULL, NULL, 6382, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 12:11:35', 'admin-1485142394-14851446953743415', 1, 1, 'SR', NULL, NULL, NULL),
(18533, '2017-01-23 12:09:18', NULL, NULL, 6381, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 12:09:18', 'admin-1485142394-14851445583247561', 1, 1, 'SR', NULL, NULL, NULL),
(18534, '2017-01-23 12:09:18', NULL, NULL, 6381, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 12:09:18', 'admin-1485142394-14851445583247561', 1, 1, 'SR', NULL, NULL, NULL),
(18535, '2017-01-23 09:52:24', NULL, NULL, 6374, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 09:52:24', 'admin-1485133228-14851363446646233', 1, 1, 'SR', NULL, NULL, NULL),
(18536, '2017-01-23 10:51:20', NULL, NULL, 6375, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 10:51:20', 'admin-1485133228-14851398801554868', 1, 0, '', NULL, NULL, NULL),
(18537, '2017-01-23 10:51:20', NULL, NULL, 6375, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 10:51:20', 'admin-1485133228-14851398801554868', 1, 1, 'SR', NULL, NULL, NULL),
(18538, '2017-01-23 10:55:06', NULL, NULL, 6375, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 10:55:06', 'admin-1485133228-14851401061601891', 1, 0, '', NULL, NULL, NULL),
(18539, '2017-01-23 10:52:50', NULL, NULL, 6376, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 10:52:50', 'admin-1485133228-14851399701724329', 1, 1, 'SR', NULL, NULL, NULL),
(18540, '2017-01-23 10:52:50', NULL, NULL, 6376, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 10:52:50', 'admin-1485133228-14851399701724329', 1, 1, 'SR', NULL, NULL, NULL),
(18541, '2017-01-23 11:18:00', NULL, NULL, 6377, 0, 155, '89', 'Joyous Sunny ', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 11:18:00', 'admin-1485133228-14851414805237362', 1, 0, '', NULL, NULL, NULL),
(18542, '2017-01-23 11:18:05', NULL, NULL, 6377, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 11:18:05', 'admin-1485133228-14851414856377678', 1, 0, '', NULL, NULL, NULL),
(18543, '2017-01-23 11:31:32', NULL, NULL, 6376, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 11:31:32', 'admin-1485133228-1485142291794276', 1, 1, 'SR', NULL, NULL, NULL),
(18544, '2017-01-23 11:31:42', NULL, NULL, 6378, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 11:31:42', 'admin-1485133228-14851423027451989', 1, 0, '', NULL, NULL, NULL),
(18545, '2017-01-23 11:33:09', NULL, NULL, 6379, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 11:33:09', 'admin-1485133228-14851423887741878', 1, 0, '', NULL, NULL, NULL),
(18546, '2017-01-23 09:57:29', NULL, NULL, 6373, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 09:57:29', 'admin-1485133228-14851366488867053', 1, 0, '', NULL, NULL, NULL),
(18547, '2017-01-23 09:52:24', NULL, NULL, 6374, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 09:52:24', 'admin-1485133228-14851363446646233', 1, 1, 'SR', NULL, NULL, NULL),
(18548, '2017-01-23 09:52:24', NULL, NULL, 6374, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 09:52:24', 'admin-1485133228-14851363446646233', 1, 0, '', NULL, NULL, NULL),
(18549, '2017-01-23 09:05:36', NULL, NULL, 6373, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 09:05:36', 'admin-1485133228-14851335357949917', 1, 0, '', NULL, NULL, NULL),
(18550, '2017-01-23 09:52:24', NULL, NULL, 6374, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 09:52:24', 'admin-1485133228-14851363446646233', 1, 0, '', NULL, NULL, NULL),
(18551, '2017-01-23 09:05:36', NULL, NULL, 6373, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 09:05:36', 'admin-1485133228-14851335357949917', 1, 1, 'SR', NULL, NULL, NULL),
(18552, '2017-01-23 09:05:21', NULL, NULL, 6373, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 09:05:21', 'admin-1485133228-14851335216025948', 1, 0, '', NULL, NULL, NULL),
(18553, '2017-01-23 09:05:21', NULL, NULL, 6373, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485145022', 'admin', '2017-01-23 09:05:21', 'admin-1485133228-14851335216025948', 1, 0, '', NULL, NULL, NULL),
(18554, '2017-01-25 17:49:26', NULL, NULL, 6415, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 17:49:26', 'admin-1485316211-14853377666021623', 1, 1, 'SR', NULL, NULL, NULL),
(18555, '2017-01-25 18:36:40', NULL, NULL, 6416, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 18:36:40', 'admin-1485316211-14853405999887492', 1, 0, '', NULL, NULL, NULL),
(18556, '2017-01-25 15:41:57', NULL, NULL, 6412, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 15:41:57', 'admin-1485316211-14853301174114950', 1, 1, 'SR', NULL, NULL, NULL),
(18557, '2017-01-25 15:42:30', NULL, NULL, 6413, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 15:42:30', 'admin-1485316211-14853301506301624', 1, 1, 'SR', NULL, NULL, NULL),
(18558, '2017-01-25 11:26:04', NULL, NULL, 6398, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 11:26:04', 'admin-1485312624-14853147642493650', 1, 0, '', NULL, NULL, NULL),
(18559, '2017-01-25 11:26:04', NULL, NULL, 6398, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 11:26:04', 'admin-1485312624-14853147642493650', 1, 0, '', NULL, NULL, NULL),
(18560, '2017-01-25 11:29:17', NULL, NULL, 6395, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 11:29:17', 'admin-1485312624-14853149569761918', 1, 1, 'SR', NULL, NULL, NULL),
(18561, '2017-01-25 11:37:59', NULL, NULL, 6399, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 11:37:59', 'admin-1485312624-14853154789344752', 1, 1, 'SR', NULL, NULL, NULL),
(18562, '2017-01-25 11:50:05', NULL, NULL, 6400, 0, 157, '91', 'French Toast with Fruits', 'no honey', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 11:50:05', 'admin-1485312624-14853162047868473', 1, 0, '', NULL, NULL, NULL),
(18563, '2017-01-25 11:50:05', NULL, NULL, 6400, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 11:50:05', 'admin-1485312624-14853162047868473', 1, 0, '', NULL, NULL, NULL),
(18564, '2017-01-25 11:50:23', NULL, NULL, 6400, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 11:50:23', 'admin-1485316211-14853162236931287', 1, 1, 'SR', NULL, NULL, NULL),
(18565, '2017-01-25 11:50:23', NULL, NULL, 6400, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 11:50:23', 'admin-1485316211-14853162236931287', 1, 1, 'SR', NULL, NULL, NULL),
(18566, '2017-01-25 15:47:16', NULL, NULL, 6412, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 15:47:16', 'admin-1485316211-148533043661813', 1, 0, '', NULL, NULL, NULL),
(18567, '2017-01-25 15:57:04', NULL, NULL, 6414, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 15:57:04', 'admin-1485316211-14853310245351235', 1, 1, 'SR', 1, NULL, '10.0'),
(18568, '2017-01-25 15:40:47', NULL, NULL, 6411, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 15:40:47', 'admin-1485316211-1485330047558798', 1, 1, 'SR', 1, NULL, NULL),
(18569, '2017-01-25 15:28:55', NULL, NULL, 6410, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 15:28:55', 'admin-1485316211-14853293350351477', 1, 0, '', NULL, NULL, NULL),
(18570, '2017-01-25 12:14:39', NULL, NULL, 6401, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 12:14:39', 'admin-1485316211-14853176793683510', 1, 1, 'SR', NULL, NULL, NULL),
(18571, '2017-01-25 12:16:06', NULL, NULL, 6402, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 12:16:06', 'admin-1485316211-14853177662662898', 1, 1, 'SR', 1, NULL, NULL),
(18572, '2017-01-25 12:28:21', NULL, NULL, 6403, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 12:28:21', 'admin-1485316211-14853185014507978', 1, 0, '', NULL, NULL, NULL),
(18573, '2017-01-25 12:28:21', NULL, NULL, 6403, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 12:28:21', 'admin-1485316211-14853185014507978', 1, 1, 'SR', NULL, NULL, NULL),
(18574, '2017-01-25 12:28:27', NULL, NULL, 6403, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 12:28:27', 'admin-1485316211-14853185073995555', 1, 1, 'SR', NULL, NULL, NULL),
(18575, '2017-01-25 12:28:54', NULL, NULL, 6403, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 12:28:54', 'admin-1485316211-14853185342339839', 1, 1, 'SR', NULL, NULL, NULL),
(18576, '2017-01-25 13:07:59', NULL, NULL, 6404, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 13:07:59', 'admin-1485316211-14853208791205593', 1, 1, 'SR', NULL, NULL, NULL),
(18577, '2017-01-25 13:11:56', NULL, NULL, 6405, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 13:11:56', 'admin-1485316211-1485321116603938', 1, 1, 'SR', NULL, NULL, NULL),
(18578, '2017-01-25 13:44:16', NULL, NULL, 6406, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 13:44:16', 'admin-1485316211-14853230559385618', 1, 0, '', NULL, NULL, NULL),
(18579, '2017-01-25 14:15:52', NULL, NULL, 6407, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 14:15:52', 'admin-1485316211-1485324951929639', 1, 0, '', NULL, NULL, NULL),
(18580, '2017-01-25 14:15:52', NULL, NULL, 6407, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 14:15:52', 'admin-1485316211-1485324951929639', 1, 0, '', NULL, NULL, NULL),
(18581, '2017-01-25 14:57:08', NULL, NULL, 6408, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 14:57:08', 'admin-1485316211-14853274281921844', 1, 1, 'SR', NULL, NULL, NULL),
(18582, '2017-01-25 14:57:14', NULL, NULL, 6409, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 14:57:14', 'admin-1485316211-1485327434163287', 1, 1, 'SR', NULL, NULL, NULL),
(18583, '2017-01-25 14:57:14', NULL, NULL, 6409, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 14:57:14', 'admin-1485316211-1485327434163287', 1, 1, 'SR', NULL, NULL, NULL),
(18584, '2017-01-25 15:20:29', NULL, NULL, 6408, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 15:20:29', 'admin-1485316211-14853288295108819', 1, 1, 'SR', NULL, NULL, NULL),
(18585, '2017-01-25 15:28:55', NULL, NULL, 6410, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 15:28:55', 'admin-1485316211-14853293350351477', 1, 1, 'SR', NULL, NULL, NULL),
(18586, '2017-01-25 13:11:52', NULL, NULL, 6405, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 13:11:52', 'admin-1485316211-14853211125857292', 1, 0, '', NULL, NULL, NULL),
(18587, '2017-01-25 11:51:43', NULL, NULL, 6398, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 11:51:43', 'admin-1485316211-1485316302928143', 1, 1, 'SR', NULL, NULL, NULL),
(18588, '2017-01-25 12:08:42', NULL, NULL, 6401, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 12:08:42', 'admin-1485316211-14853173218747071', 1, 1, 'SR', NULL, NULL, NULL),
(18589, '2017-01-25 11:51:43', NULL, NULL, 6398, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 11:51:43', 'admin-1485316211-1485316302928143', 1, 1, 'SR', NULL, NULL, NULL),
(18590, '2017-01-25 09:43:12', NULL, NULL, 6393, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 09:43:12', 'admin-1485305093-14853085922775548', 1, 1, 'SR', NULL, NULL, NULL),
(18591, '2017-01-25 09:57:11', NULL, NULL, 6393, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 09:57:11', 'admin-1485305093-14853094312551751', 1, 1, 'SR', NULL, NULL, NULL),
(18592, '2017-01-25 10:12:17', NULL, NULL, 6393, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 10:12:17', 'admin-1485305093-14853103374895547', 1, 0, '', NULL, NULL, NULL),
(18593, '2017-01-25 10:26:34', NULL, NULL, 6394, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 10:26:34', 'admin-1485305093-14853111938172615', 1, 0, '', NULL, NULL, NULL),
(18594, '2017-01-25 10:26:34', NULL, NULL, 6394, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 10:26:34', 'admin-1485305093-14853111938172615', 1, 1, 'SR', NULL, NULL, NULL),
(18595, '2017-01-25 10:26:34', NULL, NULL, 6394, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 10:26:34', 'admin-1485305093-14853111938172615', 1, 1, 'SR', NULL, NULL, NULL),
(18596, '2017-01-25 10:50:17', NULL, NULL, 6395, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 10:50:17', 'admin-1485305093-14853126170515580', 1, 0, '', NULL, NULL, NULL),
(18597, '2017-01-25 10:28:38', NULL, NULL, 6395, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 10:28:38', 'admin-1485305093-1485311318637342', 1, 0, '', NULL, NULL, NULL),
(18598, '2017-01-25 10:39:41', NULL, NULL, 6396, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 10:39:41', 'admin-1485305093-14853119817248439', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(18599, '2017-01-25 10:58:40', NULL, NULL, 6397, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 10:58:40', 'admin-1485312624-14853131202977255', 1, 1, 'SR', NULL, NULL, NULL),
(18600, '2017-01-25 11:22:45', NULL, NULL, 6398, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 11:22:45', 'admin-1485312624-14853145652687616', 1, 0, '', NULL, NULL, NULL),
(18601, '2017-01-25 11:01:57', NULL, NULL, 6397, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 11:01:57', 'admin-1485312624-14853133171125169', 1, 1, 'SR', NULL, NULL, NULL),
(18602, '2017-01-25 09:42:48', NULL, NULL, 6393, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 09:42:48', 'admin-1485305093-14853085679308314', 1, 0, '', NULL, NULL, NULL),
(18603, '2017-01-25 09:43:12', NULL, NULL, 6393, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 09:43:12', 'admin-1485305093-14853085922775548', 1, 0, '', NULL, NULL, NULL),
(18604, '2017-01-25 09:42:48', NULL, NULL, 6393, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 09:42:48', 'admin-1485305093-14853085679308314', 1, 0, '', NULL, NULL, NULL),
(18605, '2017-01-25 09:42:48', NULL, NULL, 6393, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 09:42:48', 'admin-1485305093-14853085679308314', 1, 0, '', NULL, NULL, NULL),
(18606, '2017-01-25 09:14:56', NULL, NULL, 6392, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 09:14:56', 'admin-1485305093-14853068961448574', 1, 1, 'SR', NULL, NULL, NULL),
(18607, '2017-01-25 09:14:51', NULL, NULL, 6392, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485316211', 'admin', '2017-01-25 09:14:51', 'admin-1485305093-14853068909852173', 1, 0, '', NULL, NULL, NULL),
(18608, '2017-01-31 13:42:27', NULL, NULL, 6418, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1485839089', 'admin', '2017-01-31 13:42:27', 'admin-1485839089-14858413469062413', 1, 1, 'SR', NULL, NULL, NULL),
(18609, '2017-01-31 13:12:14', NULL, NULL, 6417, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485839089', 'admin', '2017-01-31 13:12:14', 'admin-1485839089-1485839534176304', 1, 1, 'SR', NULL, NULL, NULL),
(18610, '2017-02-01 21:11:28', NULL, NULL, 6464, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 21:11:28', 'admin-1485929099-14859546887509329', 1, 1, 'SR', NULL, NULL, NULL),
(18611, '2017-02-01 19:51:56', NULL, NULL, 6456, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 19:51:56', 'admin-1485929099-14859499157739074', 1, 1, 'SR', NULL, NULL, NULL),
(18612, '2017-02-01 20:19:40', NULL, NULL, 6461, 0, 259, '193', 'Coronado Beer Set', '', 'Cold Drinks', 'Soda & Beer', 1, 40.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 20:19:40', 'admin-1485929099-14859515799444459', 1, 0, '', NULL, NULL, NULL),
(18613, '2017-02-01 20:37:29', NULL, NULL, 6462, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 20:37:29', 'admin-1485929099-1485952649772283', 1, 0, '', NULL, NULL, NULL),
(18614, '2017-02-01 20:51:13', NULL, NULL, 6463, 0, 266, '200', 'Tiger Beer Bucket', '', 'Cold Drinks', 'Soda & Beer', 1, 48.00, 48.0000, 0.0000, 48.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 20:51:13', 'admin-1485929099-14859534728816357', 1, 0, '', NULL, NULL, NULL),
(18615, '2017-02-01 19:51:56', NULL, NULL, 6456, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 19:51:56', 'admin-1485929099-14859499157739074', 1, 1, 'SR', NULL, NULL, NULL),
(18616, '2017-02-01 16:25:52', NULL, NULL, 6451, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 16:25:52', 'admin-1485929099-14859375519654151', 1, 1, 'SR', NULL, NULL, NULL),
(18617, '2017-02-01 14:04:45', NULL, NULL, 6439, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 14:04:45', 'admin-1485922837-14859290849261213', 1, 1, 'SR', NULL, NULL, NULL),
(18618, '2017-02-01 14:04:45', NULL, NULL, 6439, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 14:04:45', 'admin-1485922837-14859290849261213', 1, 0, '', NULL, NULL, NULL),
(18619, '2017-02-01 14:04:45', NULL, NULL, 6439, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 14:04:45', 'admin-1485922837-14859290849261213', 1, 1, 'SR', NULL, NULL, NULL),
(18620, '2017-02-01 14:05:08', NULL, NULL, 6438, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 14:05:08', 'admin-1485929099-14859291086262656', 1, 0, '', NULL, NULL, NULL),
(18621, '2017-02-01 14:11:02', NULL, NULL, 6440, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 14:11:02', 'admin-1485929099-14859294619274584', 1, 0, '', NULL, NULL, NULL),
(18622, '2017-02-01 14:11:02', NULL, NULL, 6440, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 14:11:02', 'admin-1485929099-14859294619274584', 1, 0, '', NULL, NULL, NULL),
(18623, '2017-02-01 14:11:02', NULL, NULL, 6440, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 14:11:02', 'admin-1485929099-14859294619274584', 1, 0, '', NULL, NULL, NULL),
(18624, '2017-02-01 14:11:02', NULL, NULL, 6440, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 14:11:02', 'admin-1485929099-14859294619274584', 1, 0, '', NULL, NULL, NULL),
(18625, '2017-02-01 14:11:02', NULL, NULL, 6440, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 14:11:02', 'admin-1485929099-14859294619274584', 1, 1, 'SR', NULL, NULL, NULL),
(18626, '2017-02-01 00:00:00', NULL, NULL, 6444, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 13:45:19', 'admin-1485922837-14859279197299270', 1, 1, 'SR', NULL, NULL, NULL),
(18627, '2017-02-01 00:00:00', NULL, NULL, 6444, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 14:25:45', 'admin-1485929099-14859303455978730', 1, 0, '', NULL, NULL, NULL),
(18628, '2017-02-01 14:36:38', NULL, NULL, 6441, 0, 224, '158', 'Set Stir Fried  Garlic Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 14:36:38', 'admin-1485929099-1485930997908239', 1, 0, '', NULL, NULL, NULL),
(18629, '2017-02-01 14:36:38', NULL, NULL, 6441, 0, 214, '148', 'Set Fried Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 14:36:38', 'admin-1485929099-1485930997908239', 1, 0, '', NULL, NULL, NULL),
(18630, '2017-02-01 14:46:42', NULL, NULL, 6442, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 14:46:42', 'admin-1485929099-1485931602095637', 1, 1, 'SR', 1, NULL, NULL),
(18631, '2017-02-01 15:04:13', NULL, NULL, 6439, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 15:04:13', 'admin-1485929099-14859326537689034', 1, 0, '', NULL, NULL, NULL),
(18632, '2017-02-01 15:04:13', NULL, NULL, 6439, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 15:04:13', 'admin-1485929099-14859326537689034', 1, 0, '', NULL, NULL, NULL),
(18633, '2017-02-01 15:05:14', NULL, NULL, 6443, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 15:05:14', 'admin-1485929099-14859327144862758', 1, 0, '', NULL, NULL, NULL),
(18634, '2017-02-01 00:00:00', NULL, NULL, 6444, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 14:25:45', 'admin-1485929099-14859303455978730', 1, 1, 'SR', NULL, NULL, NULL),
(18635, '2017-02-01 15:18:44', NULL, NULL, 6437, 0, 156, '90', 'Cheese Omelet', 'More vege to replace the bread', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 15:18:44', 'admin-1485929099-14859335239047732', 1, 0, '', NULL, NULL, '10.0'),
(18636, '2017-02-01 15:24:41', NULL, NULL, 6445, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 15:24:41', 'admin-1485929099-14859338808296119', 1, 1, 'SR', 1, NULL, NULL),
(18637, '2017-02-01 15:31:07', NULL, NULL, 6446, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 15:31:07', 'admin-1485929099-1485934267676332', 1, 1, 'SR', 1, NULL, NULL),
(18638, '2017-02-01 15:34:42', NULL, NULL, 6447, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 15:34:42', 'admin-1485929099-14859344821401661', 1, 1, 'SR', NULL, NULL, NULL),
(18639, '2017-02-01 15:50:04', NULL, NULL, 6448, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 15:50:04', 'admin-1485929099-14859354046947797', 1, 1, 'SR', 1, NULL, NULL),
(18640, '2017-02-01 16:01:05', NULL, NULL, 6449, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 16:01:05', 'admin-1485929099-14859360651614764', 1, 1, 'SR', NULL, NULL, NULL),
(18641, '2017-02-01 16:01:05', NULL, NULL, 6449, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 16:01:05', 'admin-1485929099-14859360651614764', 1, 1, 'SR', NULL, NULL, NULL),
(18642, '2017-02-01 16:14:18', NULL, NULL, 6450, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 16:14:18', 'admin-1485929099-14859368587542976', 1, 1, 'SR', NULL, NULL, NULL),
(18643, '2017-02-01 20:19:02', NULL, NULL, 6461, 0, 181, '116', 'Open Food ', 'Fries', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 20:19:02', 'admin-1485929099-1485951541898742', 1, 0, '', NULL, NULL, NULL),
(18644, '2017-02-01 20:19:02', NULL, NULL, 6461, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 20:19:02', 'admin-1485929099-1485951541898742', 1, 0, '', NULL, NULL, NULL),
(18645, '2017-02-01 13:02:24', NULL, NULL, 6436, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 13:02:24', 'admin-1485922837-14859253440714455', 1, 1, 'SR', NULL, NULL, NULL),
(18646, '2017-02-01 13:19:03', NULL, NULL, 6437, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 13:19:03', 'admin-1485922837-14859263431762156', 1, 1, 'SR', NULL, NULL, '10.0'),
(18647, '2017-02-01 13:19:03', NULL, NULL, 6437, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 13:19:03', 'admin-1485922837-14859263431762156', 1, 1, 'SR', NULL, NULL, '10.0'),
(18648, '2017-02-01 13:37:34', NULL, NULL, 6438, 0, 224, '158', 'Set Stir Fried  Garlic Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 13:37:34', 'admin-1485922837-14859274537956724', 1, 0, '', NULL, NULL, NULL),
(18649, '2017-02-01 13:37:34', NULL, NULL, 6438, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 13:37:34', 'admin-1485922837-14859274537956724', 1, 1, 'SR', NULL, NULL, NULL),
(18650, '2017-02-01 12:46:43', NULL, NULL, 6433, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 12:46:43', 'admin-1485922837-14859244032392835', 1, 1, 'SR', NULL, NULL, NULL),
(18651, '2017-02-01 12:49:05', NULL, NULL, 6434, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 12:49:05', 'admin-1485922837-14859245455859041', 1, 0, '', NULL, NULL, NULL),
(18652, '2017-02-01 12:50:21', NULL, NULL, 6435, 0, 85, '85', 'Set Meatless Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 12:50:21', 'admin-1485922837-1485924620913358', 1, 1, 'SR', NULL, NULL, NULL),
(18653, '2017-02-01 10:57:12', NULL, NULL, 6422, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 10:57:12', 'admin-1485910955-14859178321404099', 1, 1, 'SR', NULL, NULL, NULL),
(18654, '2017-02-01 10:57:12', NULL, NULL, 6422, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 10:57:12', 'admin-1485910955-14859178321404099', 1, 0, '', NULL, NULL, NULL),
(18655, '2017-02-01 10:57:12', NULL, NULL, 6422, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 10:57:12', 'admin-1485910955-14859178321404099', 1, 1, 'SR', NULL, NULL, NULL),
(18656, '2017-02-01 10:58:30', NULL, NULL, 6423, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 10:58:30', 'admin-1485910955-14859179103135716', 1, 1, 'SR', NULL, NULL, NULL),
(18657, '2017-02-01 11:16:50', NULL, NULL, 6424, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 11:16:50', 'admin-1485910955-14859190103441919', 1, 0, '', NULL, NULL, NULL),
(18658, '2017-02-01 11:16:50', NULL, NULL, 6424, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 11:16:50', 'admin-1485910955-14859190103441919', 1, 0, '', NULL, NULL, NULL),
(18659, '2017-02-01 11:16:50', NULL, NULL, 6424, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 11:16:50', 'admin-1485910955-14859190103441919', 1, 1, 'SR', NULL, NULL, NULL),
(18660, '2017-02-01 11:31:01', NULL, NULL, 6425, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 11:31:01', 'admin-1485910955-1485919861787175', 1, 1, 'SR', NULL, NULL, NULL),
(18661, '2017-02-01 11:35:39', NULL, NULL, 6426, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 11:35:39', 'admin-1485910955-14859201392568889', 1, 1, 'SR', NULL, NULL, NULL),
(18662, '2017-02-01 19:19:04', NULL, NULL, 6459, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 19:19:04', 'admin-1485929099-14859479439085321', 1, 1, 'SR', NULL, NULL, NULL),
(18663, '2017-02-01 19:06:40', NULL, NULL, 6458, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 19:06:40', 'admin-1485929099-1485947200251958', 1, 0, '', NULL, NULL, NULL),
(18664, '2017-02-01 19:06:40', NULL, NULL, 6458, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 19:06:40', 'admin-1485929099-1485947200251958', 1, 1, 'SR', NULL, NULL, NULL),
(18665, '2017-02-01 19:06:40', NULL, NULL, 6458, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 19:06:40', 'admin-1485929099-1485947200251958', 1, 1, 'SR', NULL, NULL, NULL),
(18666, '2017-02-01 19:06:40', NULL, NULL, 6458, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 19:06:40', 'admin-1485929099-1485947200251958', 1, 1, 'SR', NULL, NULL, NULL),
(18667, '2017-02-01 19:01:37', NULL, NULL, 6457, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 19:01:37', 'admin-1485929099-14859468968206633', 1, 0, '', NULL, NULL, NULL),
(18668, '2017-02-01 18:29:33', NULL, NULL, 6457, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 18:29:33', 'admin-1485929099-1485944973151269', 1, 1, 'SR', NULL, NULL, NULL),
(18669, '2017-02-01 17:47:42', NULL, NULL, 6455, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 17:47:42', 'admin-1485929099-14859424618988038', 1, 1, 'SR', NULL, NULL, NULL),
(18670, '2017-02-01 18:29:21', NULL, NULL, 6456, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 18:29:21', 'admin-1485929099-14859449613609713', 1, 1, 'SR', NULL, NULL, NULL),
(18671, '2017-02-01 18:29:21', NULL, NULL, 6456, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 18:29:21', 'admin-1485929099-14859449613609713', 1, 1, 'SR', NULL, NULL, NULL),
(18672, '2017-02-01 17:47:42', NULL, NULL, 6455, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 17:47:42', 'admin-1485929099-14859424618988038', 1, 1, 'SR', NULL, NULL, NULL),
(18673, '2017-02-01 17:29:04', NULL, NULL, 6455, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 17:29:04', 'admin-1485929099-14859413437709493', 1, 1, 'SR', NULL, NULL, NULL),
(18674, '2017-02-01 17:29:04', NULL, NULL, 6455, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 17:29:04', 'admin-1485929099-14859413437709493', 1, 1, 'SR', NULL, NULL, NULL),
(18675, '2017-02-01 18:29:33', NULL, NULL, 6457, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 18:29:33', 'admin-1485929099-1485944973151269', 1, 1, 'SR', NULL, NULL, NULL),
(18676, '2017-02-01 17:15:10', NULL, NULL, 6454, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 17:15:10', 'admin-1485929099-14859405097904969', 1, 1, 'SR', 1, NULL, NULL),
(18677, '2017-02-01 17:15:05', NULL, NULL, 6453, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 17:15:05', 'admin-1485929099-14859405049589957', 1, 1, 'SR', NULL, NULL, NULL),
(18678, '2017-02-01 16:38:28', NULL, NULL, 6452, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 16:38:28', 'admin-1485929099-14859383084085533', 1, 1, 'SR', 1, NULL, NULL),
(18679, '2017-02-01 15:18:44', NULL, NULL, 6437, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 15:18:44', 'admin-1485929099-14859335239047732', 1, 0, '', NULL, NULL, '10.0'),
(18680, '2017-02-01 16:25:52', NULL, NULL, 6451, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 16:25:52', 'admin-1485929099-14859375519654151', 1, 1, 'SR', NULL, NULL, NULL),
(18681, '2017-02-01 00:00:00', NULL, NULL, 6444, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 13:45:19', 'admin-1485922837-14859279197299270', 1, 1, 'SR', NULL, NULL, NULL),
(18682, '2017-02-01 14:04:45', NULL, NULL, 6439, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 14:04:45', 'admin-1485922837-14859290849261213', 1, 1, 'SR', NULL, NULL, NULL),
(18683, '2017-02-01 12:50:21', NULL, NULL, 6435, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 12:50:21', 'admin-1485922837-1485924620913358', 1, 0, '', NULL, NULL, NULL),
(18684, '2017-02-01 12:46:43', NULL, NULL, 6433, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 12:46:43', 'admin-1485922837-14859244032392835', 1, 1, 'SR', NULL, NULL, NULL),
(18685, '2017-02-01 12:46:38', NULL, NULL, 6433, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 12:46:38', 'admin-1485922837-14859243984016723', 1, 0, '', NULL, NULL, NULL),
(18686, '2017-02-01 11:54:11', NULL, NULL, 6428, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 11:54:11', 'admin-1485910955-14859212509994987', 1, 1, 'SR', NULL, NULL, '10.0'),
(18687, '2017-02-01 11:54:11', NULL, NULL, 6428, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 11:54:11', 'admin-1485910955-14859212509994987', 1, 1, 'SR', NULL, NULL, '10.0'),
(18688, '2017-02-01 11:54:11', NULL, NULL, 6428, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 11:54:11', 'admin-1485910955-14859212509994987', 1, 1, 'SR', NULL, NULL, '10.0'),
(18689, '2017-02-01 11:54:11', NULL, NULL, 6428, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 11:54:11', 'admin-1485910955-14859212509994987', 1, 0, '', NULL, NULL, '10.0'),
(18690, '2017-02-01 12:06:31', NULL, NULL, 6428, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 12:06:31', 'admin-1485910955-14859219910694796', 1, 1, 'SR', NULL, NULL, '10.0'),
(18691, '2017-02-01 00:00:00', NULL, NULL, 6432, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 11:39:29', 'admin-1485910955-14859203688754663', 1, 0, '', NULL, NULL, NULL),
(18692, '2017-02-01 00:00:00', NULL, NULL, 6432, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 12:14:03', 'admin-1485910955-14859224431514926', 1, 0, '', NULL, NULL, NULL),
(18693, '2017-02-01 00:00:00', NULL, NULL, 6432, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 12:14:03', 'admin-1485910955-14859224431514926', 1, 0, '', NULL, NULL, NULL),
(18694, '2017-02-01 00:00:00', NULL, NULL, 6432, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 12:14:03', 'admin-1485910955-14859224431514926', 1, 0, '', NULL, NULL, NULL),
(18695, '2017-02-01 12:14:27', NULL, NULL, 6429, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 12:14:27', 'admin-1485910955-14859224673888110', 1, 1, 'SR', NULL, NULL, NULL),
(18696, '2017-02-01 12:14:27', NULL, NULL, 6429, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 12:14:27', 'admin-1485910955-14859224673888110', 1, 1, 'SR', NULL, NULL, NULL),
(18697, '2017-02-01 12:18:21', NULL, NULL, 6428, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 12:18:21', 'admin-1485910955-14859227017143013', 1, 0, '', NULL, NULL, '10.0'),
(18698, '2017-02-01 12:20:25', NULL, NULL, 6430, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 12:20:25', 'admin-1485910955-14859228251487069', 1, 0, '', NULL, NULL, NULL),
(18699, '2017-02-01 12:20:46', NULL, NULL, 6430, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 12:20:46', 'admin-1485922837-1485922845988781', 1, 0, '', NULL, NULL, NULL),
(18700, '2017-02-01 12:20:59', NULL, NULL, 6430, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 12:20:59', 'admin-1485922837-14859228592737444', 1, 1, 'SR', NULL, NULL, NULL),
(18701, '2017-02-01 12:20:59', NULL, NULL, 6430, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 12:20:59', 'admin-1485922837-14859228592737444', 1, 1, 'SR', NULL, NULL, NULL),
(18702, '2017-02-01 00:00:00', NULL, NULL, 6431, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 11:39:29', 'admin-1485910955-14859203688754663', 1, 1, 'SR', NULL, NULL, NULL),
(18703, '2017-02-01 12:20:59', NULL, NULL, 6430, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 12:20:59', 'admin-1485922837-14859228592737444', 1, 1, 'SR', NULL, NULL, NULL),
(18704, '2017-02-01 00:00:00', NULL, NULL, 6432, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 11:39:29', 'admin-1485910955-14859203688754663', 1, 0, '', NULL, NULL, NULL),
(18705, '2017-02-01 11:54:11', NULL, NULL, 6428, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 11:54:11', 'admin-1485910955-14859212509994987', 1, 1, 'SR', NULL, NULL, '10.0'),
(18706, '2017-02-01 11:54:11', NULL, NULL, 6428, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 11:54:11', 'admin-1485910955-14859212509994987', 1, 0, '', NULL, NULL, '10.0'),
(18707, '2017-02-01 11:54:11', NULL, NULL, 6428, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 11:54:11', 'admin-1485910955-14859212509994987', 1, 0, '', NULL, NULL, '10.0'),
(18708, '2017-02-01 11:53:04', NULL, NULL, 6428, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 11:53:04', 'admin-1485910955-14859211845822223', 1, 0, '', NULL, NULL, '10.0'),
(18709, '2017-02-01 00:00:00', NULL, NULL, 6432, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 12:14:03', 'admin-1485910955-14859224431514926', 1, 0, '', NULL, NULL, NULL),
(18710, '2017-02-01 00:00:00', NULL, NULL, 6431, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 11:39:29', 'admin-1485910955-14859203688754663', 1, 1, 'SR', NULL, NULL, NULL),
(18711, '2017-02-01 00:00:00', NULL, NULL, 6431, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 11:39:29', 'admin-1485910955-14859203688754663', 1, 1, 'SR', NULL, NULL, NULL),
(18712, '2017-02-01 00:00:00', NULL, NULL, 6431, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 11:39:29', 'admin-1485910955-14859203688754663', 1, 1, 'SR', NULL, NULL, NULL),
(18713, '2017-02-01 12:46:38', NULL, NULL, 6433, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 12:46:38', 'admin-1485922837-14859243984016723', 1, 0, '', NULL, NULL, NULL),
(18714, '2017-02-01 11:35:39', NULL, NULL, 6426, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 11:35:39', 'admin-1485910955-14859201392568889', 1, 1, 'SR', NULL, NULL, NULL),
(18715, '2017-02-01 10:57:04', NULL, NULL, 6422, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 10:57:04', 'admin-1485910955-14859178243976535', 1, 0, '', NULL, NULL, NULL),
(18716, '2017-02-01 10:57:04', NULL, NULL, 6422, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 10:57:04', 'admin-1485910955-14859178243976535', 1, 0, '', NULL, NULL, NULL),
(18717, '2017-02-01 10:57:04', NULL, NULL, 6422, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 10:57:04', 'admin-1485910955-14859178243976535', 1, 0, '', NULL, NULL, NULL),
(18718, '2017-02-01 10:57:04', NULL, NULL, 6422, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 10:57:04', 'admin-1485910955-14859178243976535', 1, 0, '', NULL, NULL, NULL),
(18719, '2017-02-01 09:40:36', NULL, NULL, 6419, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 09:40:36', 'admin-1485910955-14859132360717321', 1, 1, 'SR', NULL, NULL, NULL),
(18720, '2017-02-01 10:01:15', NULL, NULL, 6420, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 10:01:15', 'admin-1485910955-14859144753614114', 1, 1, 'SR', NULL, NULL, NULL),
(18721, '2017-02-01 10:25:38', NULL, NULL, 6421, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 10:25:38', 'admin-1485910955-14859159387758852', 1, 1, 'SR', NULL, NULL, NULL),
(18722, '2017-02-01 09:40:36', NULL, NULL, 6419, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1485929099', 'admin', '2017-02-01 09:40:36', 'admin-1485910955-14859132360717321', 1, 1, 'SR', NULL, NULL, NULL),
(18723, '2017-02-02 20:20:21', NULL, NULL, 6508, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 20:20:21', 'admin-1486018292-14860380217122230', 1, 1, 'SR', NULL, NULL, NULL),
(18724, '2017-02-02 20:20:21', NULL, NULL, 6508, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 20:20:21', 'admin-1486018292-14860380217122230', 1, 1, 'SR', NULL, NULL, NULL),
(18725, '2017-02-02 20:20:21', NULL, NULL, 6508, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 20:20:21', 'admin-1486018292-14860380217122230', 1, 1, 'SR', NULL, NULL, NULL),
(18726, '2017-02-02 20:20:21', NULL, NULL, 6508, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 20:20:21', 'admin-1486018292-14860380217122230', 1, 0, '', NULL, NULL, NULL),
(18727, '2017-02-02 20:20:21', NULL, NULL, 6508, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 20:20:21', 'admin-1486018292-14860380217122230', 1, 1, 'SR', NULL, NULL, NULL),
(18728, '2017-02-02 20:20:21', NULL, NULL, 6508, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 20:20:21', 'admin-1486018292-14860380217122230', 1, 1, 'SR', NULL, NULL, NULL),
(18729, '2017-02-02 20:20:21', NULL, NULL, 6508, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 20:20:21', 'admin-1486018292-14860380217122230', 1, 1, 'SR', NULL, NULL, NULL),
(18730, '2017-02-02 19:58:03', NULL, NULL, 6507, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 19:58:03', 'admin-1486018292-14860366829247614', 1, 1, 'SR', NULL, NULL, NULL),
(18731, '2017-02-02 19:58:03', NULL, NULL, 6507, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 19:58:03', 'admin-1486018292-14860366829247614', 1, 1, 'SR', NULL, NULL, NULL),
(18732, '2017-02-02 19:58:03', NULL, NULL, 6507, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 19:58:03', 'admin-1486018292-14860366829247614', 1, 1, 'SR', NULL, NULL, NULL),
(18733, '2017-02-02 18:30:50', NULL, NULL, 6505, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 18:30:50', 'admin-1486018292-14860314500219927', 1, 1, 'SR', NULL, NULL, NULL),
(18734, '2017-02-02 20:20:21', NULL, NULL, 6508, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 20:20:21', 'admin-1486018292-14860380217122230', 1, 1, 'SR', NULL, NULL, NULL),
(18735, '2017-02-02 18:52:45', NULL, NULL, 6506, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 18:52:45', 'admin-1486018292-14860327651138626', 1, 0, '', NULL, NULL, NULL),
(18736, '2017-02-02 18:31:35', NULL, NULL, 6503, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 18:31:35', 'admin-1486018292-14860314957219821', 1, 0, '', NULL, NULL, NULL),
(18737, '2017-02-02 18:31:18', NULL, NULL, 6506, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 18:31:18', 'admin-1486018292-14860314780488396', 1, 1, 'SR', NULL, NULL, NULL),
(18738, '2017-02-02 18:31:18', NULL, NULL, 6506, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 18:31:18', 'admin-1486018292-14860314780488396', 1, 0, '', NULL, NULL, NULL),
(18739, '2017-02-02 20:30:47', NULL, NULL, 6510, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 20:30:47', 'admin-1486018292-14860386469117759', 1, 1, 'SR', 1, NULL, NULL),
(18740, '2017-02-02 21:02:11', NULL, NULL, 6511, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 21:02:11', 'admin-1486018292-14860405315372253', 1, 1, 'SR', NULL, NULL, NULL),
(18741, '2017-02-02 21:02:11', NULL, NULL, 6511, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 21:02:11', 'admin-1486018292-14860405315372253', 1, 1, 'SR', NULL, NULL, NULL),
(18742, '2017-02-02 20:30:16', NULL, NULL, 6510, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 20:30:16', 'admin-1486018292-14860386164469357', 1, 1, 'SR', 1, NULL, NULL),
(18743, '2017-02-02 20:30:16', NULL, NULL, 6510, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 20:30:16', 'admin-1486018292-14860386164469357', 1, 1, 'SR', 1, NULL, NULL),
(18744, '2017-02-02 18:26:31', NULL, NULL, 6503, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 18:26:31', 'admin-1486018292-14860311908561074', 1, 1, 'SR', NULL, NULL, NULL),
(18745, '2017-02-02 20:28:24', NULL, NULL, 6509, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 20:28:24', 'admin-1486018292-14860385047695258', 1, 1, 'SR', 1, NULL, NULL),
(18746, '2017-02-02 20:20:21', NULL, NULL, 6508, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 20:20:21', 'admin-1486018292-14860380217122230', 1, 1, 'SR', NULL, NULL, NULL),
(18747, '2017-02-02 18:26:31', NULL, NULL, 6503, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 18:26:31', 'admin-1486018292-14860311908561074', 1, 1, 'SR', NULL, NULL, NULL),
(18748, '2017-02-02 18:30:41', NULL, NULL, 6504, 0, 266, '200', 'Tiger Beer Bucket', '', 'Cold Drinks', 'Soda & Beer', 1, 48.00, 48.0000, 0.0000, 48.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 18:30:41', 'admin-1486018292-14860314409823073', 1, 0, '', NULL, NULL, NULL),
(18749, '2017-02-02 18:11:40', NULL, NULL, 6502, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 18:11:40', 'admin-1486018292-14860303004382996', 1, 1, 'SR', NULL, NULL, NULL),
(18750, '2017-02-02 18:26:31', NULL, NULL, 6503, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 18:26:31', 'admin-1486018292-14860311908561074', 1, 0, '', NULL, NULL, NULL),
(18751, '2017-02-02 18:02:57', NULL, NULL, 6501, 0, 259, '193', 'Coronado Beer Set', '', 'Cold Drinks', 'Soda & Beer', 1, 40.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 18:02:57', 'admin-1486018292-14860297771138244', 1, 0, '', NULL, NULL, NULL),
(18752, '2017-02-02 18:02:57', NULL, NULL, 6501, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 18:02:57', 'admin-1486018292-14860297771138244', 1, 0, '', NULL, NULL, NULL),
(18753, '2017-02-02 13:58:51', NULL, NULL, 6479, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 13:58:51', 'admin-1486011162-1486015131553259', 1, 0, '', NULL, NULL, NULL),
(18754, '2017-02-02 14:00:12', NULL, NULL, 6484, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 14:00:12', 'admin-1486011162-14860152124188290', 1, 1, 'SR', NULL, NULL, NULL),
(18755, '2017-02-02 14:02:54', NULL, NULL, 6484, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 14:02:54', 'admin-1486011162-14860153740451081', 1, 1, 'SR', NULL, NULL, NULL),
(18756, '2017-02-02 14:18:07', NULL, NULL, 6486, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 14:18:07', 'admin-1486011162-14860162870408039', 1, 1, 'SR', NULL, NULL, NULL),
(18757, '2017-02-02 14:18:07', NULL, NULL, 6486, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 14:18:07', 'admin-1486011162-14860162870408039', 1, 1, 'SR', NULL, NULL, NULL),
(18758, '2017-02-02 14:18:07', NULL, NULL, 6486, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 14:18:07', 'admin-1486011162-14860162870408039', 1, 1, 'SR', NULL, NULL, NULL),
(18759, '2017-02-02 14:18:07', NULL, NULL, 6486, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 14:18:07', 'admin-1486011162-14860162870408039', 1, 1, 'SR', NULL, NULL, NULL),
(18760, '2017-02-02 14:18:07', NULL, NULL, 6486, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 2, 14.00, 42.0000, 0.0000, 28.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 14:18:07', 'admin-1486011162-14860162870408039', 1, 1, 'SR', NULL, NULL, NULL),
(18761, '2017-02-02 14:25:15', NULL, NULL, 6487, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 14:25:15', 'admin-1486011162-14860167152049995', 1, 0, '', NULL, NULL, NULL),
(18762, '2017-02-02 14:25:15', NULL, NULL, 6487, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 14:25:15', 'admin-1486011162-14860167152049995', 1, 1, 'SR', NULL, NULL, NULL),
(18763, '2017-02-02 14:40:41', NULL, NULL, 6486, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 14:40:41', 'admin-1486011162-148601764175463', 1, 1, 'SR', NULL, NULL, NULL),
(18764, '2017-02-02 14:57:09', NULL, NULL, 6486, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 14:57:09', 'admin-1486018292-14860186296954575', 1, 1, 'SR', NULL, NULL, NULL),
(18765, '2017-02-02 14:40:00', NULL, NULL, 6488, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 14:40:00', 'admin-1486011162-14860175999723157', 1, 1, 'SR', 1, NULL, NULL),
(18766, '2017-02-02 14:41:34', NULL, NULL, 6489, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 14:41:34', 'admin-1486011162-14860176941531237', 1, 1, 'SR', NULL, NULL, NULL),
(18767, '2017-02-02 14:49:35', NULL, NULL, 6490, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 14:49:35', 'admin-1486011162-14860181752797399', 1, 1, 'SR', NULL, NULL, NULL),
(18768, '2017-02-02 14:49:35', NULL, NULL, 6490, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 14:49:35', 'admin-1486011162-14860181752797399', 1, 1, 'SR', NULL, NULL, NULL),
(18769, '2017-02-02 14:52:23', NULL, NULL, 6491, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 14:52:23', 'admin-1486018292-14860183431641174', 1, 0, '', NULL, NULL, NULL),
(18770, '2017-02-02 14:52:23', NULL, NULL, 6491, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 14:52:23', 'admin-1486018292-14860183431641174', 1, 0, '', NULL, NULL, NULL),
(18771, '2017-02-02 14:52:23', NULL, NULL, 6491, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 14:52:23', 'admin-1486018292-14860183431641174', 1, 0, '', NULL, NULL, NULL),
(18772, '2017-02-02 14:51:24', NULL, NULL, 6491, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 14:51:24', 'admin-1486011162-1486018284683323', 1, 1, 'SR', NULL, NULL, NULL),
(18773, '2017-02-02 14:51:24', NULL, NULL, 6491, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 14:51:24', 'admin-1486011162-1486018284683323', 1, 1, 'SR', NULL, NULL, NULL),
(18774, '2017-02-02 14:51:24', NULL, NULL, 6491, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 14:51:24', 'admin-1486011162-1486018284683323', 1, 0, '', NULL, NULL, NULL),
(18775, '2017-02-02 14:52:23', NULL, NULL, 6491, 0, 246, '180', 'Noodle Soup', '', 'Meals', 'Perfect Meals', 1, 15.90, 15.9000, 0.0000, 15.90, 1, '27', 1, '1486018292', 'admin', '2017-02-02 14:52:23', 'admin-1486018292-14860183431641174', 1, 0, '', NULL, NULL, NULL),
(18776, '2017-02-02 15:03:02', NULL, NULL, 6491, 0, 181, '116', 'Open Food ', 'French Fries', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 15:03:02', 'admin-1486018292-1486018982527668', 1, 0, '', NULL, NULL, NULL),
(18777, '2017-02-02 15:11:46', NULL, NULL, 6492, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 15:11:46', 'admin-1486018292-14860195063219787', 1, 1, 'SR', NULL, NULL, NULL),
(18778, '2017-02-02 15:13:56', NULL, NULL, 6492, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 15:13:56', 'admin-1486018292-1486019635996192', 1, 1, 'SR', NULL, NULL, NULL),
(18779, '2017-02-02 15:13:56', NULL, NULL, 6492, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 15:13:56', 'admin-1486018292-1486019635996192', 1, 1, 'SR', NULL, NULL, NULL),
(18780, '2017-02-02 17:39:58', NULL, NULL, 6500, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 17:39:58', 'admin-1486018292-14860283980087887', 1, 0, '', 1, NULL, NULL),
(18781, '2017-02-02 18:02:57', NULL, NULL, 6501, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 18:02:57', 'admin-1486018292-14860297771138244', 1, 0, '', NULL, NULL, NULL),
(18782, '2017-02-02 17:11:33', NULL, NULL, 6497, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 17:11:33', 'admin-1486018292-14860266919028812', 1, 0, '', 1, NULL, NULL),
(18783, '2017-02-02 17:14:04', NULL, NULL, 6498, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 17:14:04', 'admin-1486018292-14860268439772639', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(18784, '2017-02-02 11:33:43', NULL, NULL, 6473, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 11:33:43', 'admin-1486003081-14860064238128079', 1, 1, 'SR', NULL, NULL, NULL),
(18785, '2017-02-02 11:33:33', NULL, NULL, 6473, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 11:33:33', 'admin-1486003081-14860064129952750', 1, 0, '', NULL, NULL, NULL),
(18786, '2017-02-02 11:33:43', NULL, NULL, 6473, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 11:33:43', 'admin-1486003081-14860064238128079', 1, 1, 'SR', NULL, NULL, NULL),
(18787, '2017-02-02 17:22:58', NULL, NULL, 6499, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 17:22:58', 'admin-1486018292-1486027378210167', 1, 0, '', NULL, NULL, NULL),
(18788, '2017-02-02 12:15:37', NULL, NULL, 6479, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 12:15:37', 'admin-1486003081-14860089371914693', 1, 1, 'SR', NULL, NULL, NULL),
(18789, '2017-02-02 12:23:41', NULL, NULL, 6480, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 12:23:41', 'admin-1486003081-14860094212202844', 1, 1, 'SR', NULL, NULL, NULL),
(18790, '2017-02-02 12:50:56', NULL, NULL, 6481, 0, 213, '147', 'Set Stir Fried Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 12:50:56', 'admin-1486003081-14860110562375994', 1, 0, '', NULL, NULL, NULL),
(18791, '2017-02-02 13:05:55', NULL, NULL, 6482, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 13:05:55', 'admin-1486011162-14860119549125783', 1, 0, '', NULL, NULL, NULL),
(18792, '2017-02-02 13:09:35', NULL, NULL, 6479, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 13:09:35', 'admin-1486011162-1486012174808310', 1, 1, 'SR', NULL, NULL, NULL),
(18793, '2017-02-02 13:09:58', NULL, NULL, 6483, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 13:09:58', 'admin-1486011162-14860121987494426', 1, 1, 'SR', NULL, NULL, NULL),
(18794, '2017-02-02 13:18:33', NULL, NULL, 6484, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 13:18:33', 'admin-1486011162-1486012713250192', 1, 0, '', NULL, NULL, NULL),
(18795, '2017-02-02 13:18:33', NULL, NULL, 6484, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 13:18:33', 'admin-1486011162-1486012713250192', 1, 0, '', NULL, NULL, NULL),
(18796, '2017-02-02 13:18:33', NULL, NULL, 6484, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 13:18:33', 'admin-1486011162-1486012713250192', 1, 0, '', NULL, NULL, NULL),
(18797, '2017-02-02 13:30:13', NULL, NULL, 6485, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 13:30:13', 'admin-1486011162-14860134131702589', 1, 1, 'SR', NULL, NULL, NULL),
(18798, '2017-02-02 13:30:13', NULL, NULL, 6485, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 13:30:13', 'admin-1486011162-14860134131702589', 1, 1, 'SR', NULL, NULL, NULL),
(18799, '2017-02-02 17:16:15', NULL, NULL, 6498, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 17:16:15', 'admin-1486018292-14860269751377998', 1, 0, '', NULL, NULL, NULL),
(18800, '2017-02-02 17:16:15', NULL, NULL, 6498, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 17:16:15', 'admin-1486018292-14860269751377998', 1, 1, 'SR', NULL, NULL, NULL),
(18801, '2017-02-02 17:15:56', NULL, NULL, 6499, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 17:15:56', 'admin-1486018292-14860269562594633', 1, 1, 'SR', NULL, NULL, NULL),
(18802, '2017-02-02 17:14:19', NULL, NULL, 6499, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 17:14:19', 'admin-1486018292-14860268592968080', 1, 1, 'SR', NULL, NULL, NULL),
(18803, '2017-02-02 16:14:46', NULL, NULL, 6496, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 16:14:46', 'admin-1486018292-14860232865286691', 1, 1, 'SR', NULL, NULL, NULL),
(18804, '2017-02-02 16:00:15', NULL, NULL, 6493, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 16:00:15', 'admin-1486018292-14860224154755825', 1, 1, 'SR', NULL, NULL, NULL),
(18805, '2017-02-02 15:44:34', NULL, NULL, 6494, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 15:44:34', 'admin-1486018292-1486021474092297', 1, 0, '', NULL, NULL, NULL),
(18806, '2017-02-02 15:44:50', NULL, NULL, 6495, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 15:44:50', 'admin-1486018292-14860214908239398', 1, 1, 'SR', NULL, NULL, NULL),
(18807, '2017-02-02 15:46:03', NULL, NULL, 6494, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 15:46:03', 'admin-1486018292-14860215633429281', 1, 0, '', NULL, NULL, NULL),
(18808, '2017-02-02 15:32:07', NULL, NULL, 6492, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 15:32:07', 'admin-1486018292-1486020726944748', 1, 1, 'SR', NULL, NULL, NULL),
(18809, '2017-02-02 15:32:07', NULL, NULL, 6492, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 15:32:07', 'admin-1486018292-1486020726944748', 1, 1, 'SR', NULL, NULL, NULL),
(18810, '2017-02-02 15:27:28', NULL, NULL, 6493, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 15:27:28', 'admin-1486018292-14860204484781389', 1, 1, 'SR', NULL, NULL, NULL),
(18811, '2017-02-02 15:27:28', NULL, NULL, 6493, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 15:27:28', 'admin-1486018292-14860204484781389', 1, 1, 'SR', NULL, NULL, NULL),
(18812, '2017-02-02 18:26:31', NULL, NULL, 6503, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 18:26:31', 'admin-1486018292-14860311908561074', 1, 1, 'SR', NULL, NULL, NULL),
(18813, '2017-02-02 15:27:28', NULL, NULL, 6493, 0, 182, '117', 'Open Drinks ', 'extra shot', 'Cold Drinks', 'Fresh Juice', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 15:27:28', 'admin-1486018292-14860204484781389', 1, 0, '', NULL, NULL, NULL),
(18814, '2017-02-02 15:27:28', NULL, NULL, 6493, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 15:27:28', 'admin-1486018292-14860204484781389', 1, 0, '', NULL, NULL, NULL),
(18815, '2017-02-02 15:27:28', NULL, NULL, 6493, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 15:27:28', 'admin-1486018292-14860204484781389', 1, 1, 'SR', NULL, NULL, NULL),
(18816, '2017-02-02 15:27:28', NULL, NULL, 6493, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 15:27:28', 'admin-1486018292-14860204484781389', 1, 1, 'SR', NULL, NULL, NULL),
(18817, '2017-02-02 15:21:39', NULL, NULL, 6490, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 15:21:39', 'admin-1486018292-14860200992049578', 1, 0, '', NULL, NULL, NULL),
(18818, '2017-02-02 15:21:39', NULL, NULL, 6490, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 15:21:39', 'admin-1486018292-14860200992049578', 1, 0, '', NULL, NULL, NULL),
(18819, '2017-02-02 15:13:56', NULL, NULL, 6492, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 15:13:56', 'admin-1486018292-1486019635996192', 1, 1, 'SR', NULL, NULL, NULL),
(18820, '2017-02-02 13:30:13', NULL, NULL, 6485, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 13:30:13', 'admin-1486011162-14860134131702589', 1, 1, 'SR', NULL, NULL, NULL),
(18821, '2017-02-02 13:36:49', NULL, NULL, 6485, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 13:36:49', 'admin-1486011162-14860138096341868', 1, 0, '', NULL, NULL, NULL),
(18822, '2017-02-02 12:15:37', NULL, NULL, 6479, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 12:15:37', 'admin-1486003081-14860089371914693', 1, 1, 'SR', NULL, NULL, NULL),
(18823, '2017-02-02 11:33:43', NULL, NULL, 6473, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 11:33:43', 'admin-1486003081-14860064238128079', 1, 1, 'SR', NULL, NULL, NULL),
(18824, '2017-02-02 12:15:37', NULL, NULL, 6479, 0, 83, '83', 'Set Stir Fried Chicken with Mushroom ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 12:15:37', 'admin-1486003081-14860089371914693', 1, 1, 'SR', NULL, NULL, NULL),
(18825, '2017-02-02 12:15:37', NULL, NULL, 6479, 0, 83, '83', 'Set Stir Fried Chicken with Mushroom ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 12:15:37', 'admin-1486003081-14860089371914693', 1, 1, 'SR', NULL, NULL, NULL),
(18826, '2017-02-02 12:13:42', NULL, NULL, 6478, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 12:13:42', 'admin-1486003081-1486008821964881', 1, 1, 'SR', NULL, NULL, NULL),
(18827, '2017-02-02 12:08:16', NULL, NULL, 6477, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 12:08:16', 'admin-1486003081-14860084966903955', 1, 1, 'SR', NULL, NULL, NULL),
(18828, '2017-02-02 11:58:54', NULL, NULL, 6476, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 11:58:54', 'admin-1486003081-14860079346089190', 1, 1, 'SR', 1, NULL, NULL),
(18829, '2017-02-02 11:49:49', NULL, NULL, 6475, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 11:49:49', 'admin-1486003081-14860073888514395', 1, 0, '', NULL, NULL, NULL),
(18830, '2017-02-02 11:49:49', NULL, NULL, 6475, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 11:49:49', 'admin-1486003081-14860073888514395', 1, 0, '', NULL, NULL, NULL),
(18831, '2017-02-02 11:49:32', NULL, NULL, 6475, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 11:49:32', 'admin-1486003081-14860073721315927', 1, 1, 'SR', NULL, NULL, NULL),
(18832, '2017-02-02 11:49:32', NULL, NULL, 6475, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 11:49:32', 'admin-1486003081-14860073721315927', 1, 0, '', NULL, NULL, NULL),
(18833, '2017-02-02 11:49:32', NULL, NULL, 6475, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 11:49:32', 'admin-1486003081-14860073721315927', 1, 1, 'SR', NULL, NULL, NULL),
(18834, '2017-02-02 11:49:32', NULL, NULL, 6475, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 11:49:32', 'admin-1486003081-14860073721315927', 1, 1, 'SR', NULL, NULL, NULL),
(18835, '2017-02-02 11:43:12', NULL, NULL, 6474, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 11:43:12', 'admin-1486003081-14860069919439733', 1, 1, 'SR', NULL, NULL, NULL),
(18836, '2017-02-02 11:43:12', NULL, NULL, 6474, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 11:43:12', 'admin-1486003081-14860069919439733', 1, 1, 'SR', NULL, NULL, NULL),
(18837, '2017-02-02 11:43:12', NULL, NULL, 6474, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 11:43:12', 'admin-1486003081-14860069919439733', 1, 1, 'SR', NULL, NULL, NULL),
(18838, '2017-02-02 09:28:42', NULL, NULL, 6466, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 09:28:42', 'admin-1485996940-14859989220521373', 1, 0, '', NULL, NULL, NULL),
(18839, '2017-02-02 09:37:31', NULL, NULL, 6467, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 09:37:31', 'admin-1485996940-14859994510351148', 1, 0, '', NULL, NULL, NULL),
(18840, '2017-02-02 09:37:31', NULL, NULL, 6467, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 09:37:31', 'admin-1485996940-14859994510351148', 1, 1, 'SR', NULL, NULL, NULL),
(18841, '2017-02-02 09:37:31', NULL, NULL, 6467, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 09:37:31', 'admin-1485996940-14859994510351148', 1, 1, 'SR', NULL, NULL, NULL),
(18842, '2017-02-02 09:45:20', NULL, NULL, 6468, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 09:45:20', 'admin-1485996940-1485999920746244', 1, 1, 'SR', NULL, NULL, NULL),
(18843, '2017-02-02 09:48:58', NULL, NULL, 6469, 0, 157, '91', 'French Toast with Fruits', 'no blueberry', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 09:48:58', 'admin-1485996940-14860001380358533', 1, 0, '', NULL, NULL, NULL),
(18844, '2017-02-02 09:48:58', NULL, NULL, 6469, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 09:48:58', 'admin-1485996940-14860001380358533', 1, 0, '', NULL, NULL, NULL),
(18845, '2017-02-02 10:37:56', NULL, NULL, 6470, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 10:37:56', 'admin-1485996940-14860030761846197', 1, 0, '', NULL, NULL, NULL),
(18846, '2017-02-02 10:37:56', NULL, NULL, 6470, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 10:37:56', 'admin-1485996940-14860030761846197', 1, 0, '', NULL, NULL, NULL),
(18847, '2017-02-02 10:39:37', NULL, NULL, 6470, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 10:39:37', 'admin-1486003081-1486003177064507', 1, 0, '', NULL, NULL, NULL),
(18848, '2017-02-02 11:05:23', NULL, NULL, 6471, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 11:05:23', 'admin-1486003081-14860047229636265', 1, 1, 'SR', NULL, NULL, NULL),
(18849, '2017-02-02 11:05:23', NULL, NULL, 6471, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 11:05:23', 'admin-1486003081-14860047229636265', 1, 1, 'SR', NULL, NULL, NULL),
(18850, '2017-02-02 11:13:17', NULL, NULL, 6472, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 11:13:17', 'admin-1486003081-14860051977766299', 1, 1, 'SR', NULL, NULL, NULL),
(18851, '2017-02-02 11:13:18', NULL, NULL, 6472, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 11:13:18', 'admin-1486003081-14860051977766299', 1, 0, '', NULL, NULL, NULL),
(18852, '2017-02-02 11:33:33', NULL, NULL, 6473, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 11:33:33', 'admin-1486003081-14860064129952750', 1, 0, '', NULL, NULL, NULL),
(18853, '2017-02-02 11:33:33', NULL, NULL, 6473, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 11:33:33', 'admin-1486003081-14860064129952750', 1, 0, '', NULL, NULL, NULL),
(18854, '2017-02-02 09:37:31', NULL, NULL, 6467, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 09:37:31', 'admin-1485996940-14859994510351148', 1, 0, '', NULL, NULL, NULL),
(18855, '2017-02-02 09:28:23', NULL, NULL, 6466, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 09:28:23', 'admin-1485996940-14859989029584096', 1, 0, '', NULL, NULL, NULL),
(18856, '2017-02-02 09:20:34', NULL, NULL, 6466, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 09:20:34', 'admin-1485996940-14859984343871158', 1, 0, '', NULL, NULL, NULL),
(18857, '2017-02-02 09:28:23', NULL, NULL, 6466, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 09:28:23', 'admin-1485996940-14859989029584096', 1, 1, 'SR', NULL, NULL, NULL),
(18858, '2017-02-02 09:20:40', NULL, NULL, 6466, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 09:20:40', 'admin-1485996940-148599843996861', 1, 0, '', NULL, NULL, NULL),
(18859, '2017-02-02 09:04:24', NULL, NULL, 6465, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486018292', 'admin', '2017-02-02 09:04:24', 'admin-1485996940-14859974639413933', 1, 1, 'SR', NULL, NULL, NULL),
(18860, '2017-02-03 21:51:03', NULL, NULL, 6559, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 21:51:03', 'admin-1486117870-14861298629181621', 1, 0, '', NULL, NULL, NULL),
(18861, '2017-02-03 21:26:52', NULL, NULL, 6552, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 21:26:52', 'admin-1486117870-14861284122964820', 1, 1, 'SR', NULL, NULL, NULL),
(18862, '2017-02-03 21:18:10', NULL, NULL, 6552, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 21:18:10', 'admin-1486117870-14861278904838537', 1, 0, '', NULL, NULL, NULL),
(18863, '2017-02-03 21:21:04', NULL, NULL, 6558, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 21:21:04', 'admin-1486117870-14861280642752284', 1, 1, 'SR', NULL, NULL, NULL),
(18864, '2017-02-03 21:21:04', NULL, NULL, 6558, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 21:21:04', 'admin-1486117870-14861280642752284', 1, 1, 'SR', NULL, NULL, NULL),
(18865, '2017-02-03 21:21:04', NULL, NULL, 6558, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 21:21:04', 'admin-1486117870-14861280642752284', 1, 1, 'SR', NULL, NULL, NULL),
(18866, '2017-02-03 20:52:59', NULL, NULL, 6557, 0, 259, '193', 'Coronado Beer Set', '', 'Cold Drinks', 'Soda & Beer', 1, 40.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:52:59', 'admin-1486117870-14861263792636956', 1, 0, '', NULL, NULL, NULL),
(18867, '2017-02-03 20:10:30', NULL, NULL, 6555, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:10:30', 'admin-1486117870-14861238300406593', 1, 1, 'SR', NULL, NULL, NULL),
(18868, '2017-02-03 20:19:21', NULL, NULL, 6555, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:19:21', 'admin-1486117870-14861243613986466', 1, 0, '', NULL, NULL, NULL),
(18869, '2017-02-03 20:49:58', NULL, NULL, 6556, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:49:58', 'admin-1486117870-14861261983373895', 1, 1, 'SR', NULL, NULL, NULL),
(18870, '2017-02-03 20:49:58', NULL, NULL, 6556, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:49:58', 'admin-1486117870-14861261983373895', 1, 1, 'SR', NULL, NULL, NULL),
(18871, '2017-02-03 20:03:57', NULL, NULL, 6553, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:03:57', 'admin-1486117870-14861234369497078', 1, 0, '', NULL, NULL, NULL),
(18872, '2017-02-03 20:06:38', NULL, NULL, 6554, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:06:38', 'admin-1486117870-14861235986785427', 1, 0, '', NULL, NULL, NULL),
(18873, '2017-02-03 20:06:38', NULL, NULL, 6554, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:06:38', 'admin-1486117870-14861235986785427', 1, 1, 'SR', NULL, NULL, NULL),
(18874, '2017-02-03 19:58:17', NULL, NULL, 6553, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 19:58:17', 'admin-1486117870-14861230977258269', 1, 1, 'SR', NULL, NULL, NULL),
(18875, '2017-02-03 20:03:57', NULL, NULL, 6553, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:03:57', 'admin-1486117870-14861234369497078', 1, 1, 'SR', NULL, NULL, NULL),
(18876, '2017-02-03 20:03:57', NULL, NULL, 6553, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:03:57', 'admin-1486117870-14861234369497078', 1, 0, '', NULL, NULL, NULL),
(18877, '2017-02-03 20:03:57', NULL, NULL, 6553, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:03:57', 'admin-1486117870-14861234369497078', 1, 0, '', NULL, NULL, NULL),
(18878, '2017-02-03 20:10:30', NULL, NULL, 6555, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:10:30', 'admin-1486117870-14861238300406593', 1, 1, 'SR', NULL, NULL, NULL),
(18879, '2017-02-03 19:58:17', NULL, NULL, 6553, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 19:58:17', 'admin-1486117870-14861230977258269', 1, 1, 'SR', NULL, NULL, NULL),
(18880, '2017-02-03 19:58:17', NULL, NULL, 6553, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 19:58:17', 'admin-1486117870-14861230977258269', 1, 1, 'SR', NULL, NULL, NULL),
(18881, '2017-02-03 19:56:12', NULL, NULL, 6552, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 19:56:12', 'admin-1486117870-14861229718366396', 1, 1, 'SR', NULL, NULL, NULL),
(18882, '2017-02-03 19:56:12', NULL, NULL, 6552, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 19:56:12', 'admin-1486117870-14861229718366396', 1, 1, 'SR', NULL, NULL, NULL),
(18883, '2017-02-03 19:56:12', NULL, NULL, 6552, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 19:56:12', 'admin-1486117870-14861229718366396', 1, 1, 'SR', NULL, NULL, NULL),
(18884, '2017-02-03 19:35:38', NULL, NULL, 6549, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 19:35:38', 'admin-1486117870-14861217381997228', 1, 0, '', NULL, NULL, NULL),
(18885, '2017-02-03 16:19:50', NULL, NULL, 6545, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 16:19:50', 'admin-1486103352-14861099906346839', 1, 1, 'SR', NULL, NULL, NULL),
(18886, '2017-02-03 15:26:15', NULL, NULL, 6541, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 15:26:15', 'admin-1486103352-14861067756869725', 1, 1, 'SR', NULL, NULL, NULL),
(18887, '2017-02-03 20:48:46', NULL, NULL, 6552, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:48:46', 'admin-1486117870-14861261261755829', 1, 0, '', NULL, NULL, NULL),
(18888, '2017-02-03 20:48:46', NULL, NULL, 6552, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:48:46', 'admin-1486117870-14861261261755829', 1, 1, 'SR', NULL, NULL, NULL),
(18889, '2017-02-03 20:48:46', NULL, NULL, 6552, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:48:46', 'admin-1486117870-14861261261755829', 1, 0, '', NULL, NULL, NULL),
(18890, '2017-02-03 20:48:46', NULL, NULL, 6552, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:48:46', 'admin-1486117870-14861261261755829', 1, 0, '', NULL, NULL, NULL),
(18891, '2017-02-03 19:34:22', NULL, NULL, 6550, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 19:34:22', 'admin-1486117870-14861216620903182', 1, 0, '', NULL, NULL, NULL),
(18892, '2017-02-03 19:21:38', NULL, NULL, 6550, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 19:21:38', 'admin-1486117870-14861208987102937', 1, 0, '', NULL, NULL, NULL),
(18893, '2017-02-03 18:50:41', NULL, NULL, 6549, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 18:50:41', 'admin-1486117870-14861190410758718', 1, 1, 'SR', NULL, NULL, NULL),
(18894, '2017-02-03 18:44:37', NULL, NULL, 6551, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 18:44:37', 'admin-1486117870-14861186777231040', 1, 1, 'SR', NULL, NULL, NULL),
(18895, '2017-02-03 20:03:57', NULL, NULL, 6553, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:03:57', 'admin-1486117870-14861234369497078', 1, 0, '', NULL, NULL, NULL),
(18896, '2017-02-03 20:03:57', NULL, NULL, 6553, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:03:57', 'admin-1486117870-14861234369497078', 1, 1, 'SR', NULL, NULL, NULL),
(18897, '2017-02-03 18:30:35', NULL, NULL, 6549, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 18:30:35', 'admin-1486103352-14861178354428174', 1, 0, '', NULL, NULL, NULL),
(18898, '2017-02-03 18:30:35', NULL, NULL, 6549, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 18:30:35', 'admin-1486103352-14861178354428174', 1, 1, 'SR', NULL, NULL, NULL),
(18899, '2017-02-03 18:31:58', NULL, NULL, 6550, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 18:31:58', 'admin-1486117870-1486117918764574', 1, 1, 'SR', NULL, NULL, NULL),
(18900, '2017-02-03 18:31:58', NULL, NULL, 6550, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 18:31:58', 'admin-1486117870-1486117918764574', 1, 0, '', NULL, NULL, NULL),
(18901, '2017-02-03 18:31:58', NULL, NULL, 6550, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 18:31:58', 'admin-1486117870-1486117918764574', 1, 1, 'SR', NULL, NULL, NULL),
(18902, '2017-02-03 18:31:58', NULL, NULL, 6550, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 18:31:58', 'admin-1486117870-1486117918764574', 1, 0, '', NULL, NULL, NULL),
(18903, '2017-02-03 18:31:58', NULL, NULL, 6550, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 18:31:58', 'admin-1486117870-1486117918764574', 1, 0, '', NULL, NULL, NULL),
(18904, '2017-02-03 18:31:58', NULL, NULL, 6550, 0, 181, '116', 'Open Food ', 'Gyoza', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 18:31:58', 'admin-1486117870-1486117918764574', 1, 0, '', NULL, NULL, NULL),
(18905, '2017-02-03 18:34:12', NULL, NULL, 6549, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 18:34:12', 'admin-1486117870-14861180526667856', 1, 1, 'SR', NULL, NULL, NULL),
(18906, '2017-02-03 18:34:12', NULL, NULL, 6549, 0, 181, '116', 'Open Food ', 'Gyoza', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 18:34:12', 'admin-1486117870-14861180526667856', 1, 0, '', NULL, NULL, NULL),
(18907, '2017-02-03 20:43:32', NULL, NULL, 6553, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:43:32', 'admin-1486117870-1486125812526821', 1, 1, 'SR', NULL, NULL, NULL),
(18908, '2017-02-03 20:48:46', NULL, NULL, 6552, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:48:46', 'admin-1486117870-14861261261755829', 1, 0, '', NULL, NULL, NULL),
(18909, '2017-02-03 20:48:46', NULL, NULL, 6552, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:48:46', 'admin-1486117870-14861261261755829', 1, 1, 'SR', NULL, NULL, NULL),
(18910, '2017-02-03 20:10:30', NULL, NULL, 6555, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:10:30', 'admin-1486117870-14861238300406593', 1, 0, '', NULL, NULL, NULL),
(18911, '2017-02-03 20:10:30', NULL, NULL, 6555, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:10:30', 'admin-1486117870-14861238300406593', 1, 0, '', NULL, NULL, NULL),
(18912, '2017-02-03 20:10:30', NULL, NULL, 6555, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:10:30', 'admin-1486117870-14861238300406593', 1, 1, 'SR', NULL, NULL, NULL),
(18913, '2017-02-03 20:03:57', NULL, NULL, 6553, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:03:57', 'admin-1486117870-14861234369497078', 1, 1, 'SR', NULL, NULL, NULL),
(18914, '2017-02-03 20:03:57', NULL, NULL, 6553, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:03:57', 'admin-1486117870-14861234369497078', 1, 1, 'SR', NULL, NULL, NULL),
(18915, '2017-02-03 18:44:37', NULL, NULL, 6551, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 18:44:37', 'admin-1486117870-14861186777231040', 1, 1, 'SR', NULL, NULL, NULL),
(18916, '2017-02-03 20:03:57', NULL, NULL, 6553, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:03:57', 'admin-1486117870-14861234369497078', 1, 0, '', NULL, NULL, NULL),
(18917, '2017-02-03 17:37:35', NULL, NULL, 6547, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 17:37:35', 'admin-1486103352-14861146550605638', 1, 1, 'SR', NULL, NULL, NULL),
(18918, '2017-02-03 17:37:35', NULL, NULL, 6547, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 17:37:35', 'admin-1486103352-14861146550605638', 1, 1, 'SR', NULL, NULL, NULL),
(18919, '2017-02-03 17:50:07', NULL, NULL, 6546, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 17:50:07', 'admin-1486103352-14861154071122413', 1, 1, 'SR', NULL, NULL, NULL),
(18920, '2017-02-03 18:09:46', NULL, NULL, 6548, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 18:09:46', 'admin-1486103352-14861165864388450', 1, 0, '', 1, NULL, '10.0'),
(18921, '2017-02-03 17:35:38', NULL, NULL, 6547, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 17:35:38', 'admin-1486103352-14861145378232812', 1, 1, 'SR', NULL, NULL, NULL),
(18922, '2017-02-03 17:37:21', NULL, NULL, 6547, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 17:37:21', 'admin-1486103352-1486114641476810', 1, 0, '', NULL, NULL, NULL),
(18923, '2017-02-03 14:22:51', NULL, NULL, 6539, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 14:22:51', 'admin-1486100235-14861029710549623', 1, 0, '', NULL, NULL, NULL),
(18924, '2017-02-03 17:01:39', NULL, NULL, 6546, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 17:01:39', 'admin-1486103352-14861124994224752', 1, 0, '', NULL, NULL, NULL),
(18925, '2017-02-03 16:56:49', NULL, NULL, 6546, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 16:56:49', 'admin-1486103352-1486112209382445', 1, 1, 'SR', NULL, NULL, NULL),
(18926, '2017-02-03 16:25:10', NULL, NULL, 6545, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 16:25:10', 'admin-1486103352-1486110310608471', 1, 0, '', NULL, NULL, NULL),
(18927, '2017-02-03 16:25:10', NULL, NULL, 6545, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 16:25:10', 'admin-1486103352-1486110310608471', 1, 0, '', NULL, NULL, NULL),
(18928, '2017-02-03 16:19:50', NULL, NULL, 6545, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 16:19:50', 'admin-1486103352-14861099906346839', 1, 0, '', NULL, NULL, NULL),
(18929, '2017-02-03 16:19:50', NULL, NULL, 6545, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 16:19:50', 'admin-1486103352-14861099906346839', 1, 1, 'SR', NULL, NULL, NULL),
(18930, '2017-02-03 16:19:03', NULL, NULL, 6545, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 16:19:03', 'admin-1486103352-14861099434525811', 1, 1, 'SR', NULL, NULL, NULL),
(18931, '2017-02-03 16:18:09', NULL, NULL, 6545, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 16:18:09', 'admin-1486103352-14861098896648923', 1, 0, '', NULL, NULL, NULL),
(18932, '2017-02-03 12:57:13', NULL, NULL, 6526, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 12:57:13', 'admin-1486090908-14860978336378233', 1, 0, '', NULL, NULL, NULL),
(18933, '2017-02-03 12:57:13', NULL, NULL, 6526, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 12:57:13', 'admin-1486090908-14860978336378233', 1, 1, 'SR', NULL, NULL, NULL),
(18934, '2017-02-03 13:11:50', NULL, NULL, 6527, 0, 85, '85', 'Set Meatless Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:11:50', 'admin-1486090908-14860987106913638', 1, 1, 'SR', NULL, NULL, NULL),
(18935, '2017-02-03 13:11:50', NULL, NULL, 6527, 0, 245, '179', 'Set Spicy Lemony Chicken Wing', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:11:50', 'admin-1486090908-14860987106913638', 1, 0, '', NULL, NULL, NULL),
(18936, '2017-02-03 13:20:51', NULL, NULL, 6528, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:20:51', 'admin-1486090908-14860992510059138', 1, 1, 'SR', NULL, NULL, NULL),
(18937, '2017-02-03 13:20:51', NULL, NULL, 6528, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:20:51', 'admin-1486090908-14860992510059138', 1, 1, 'SR', NULL, NULL, NULL),
(18938, '2017-02-03 13:31:21', NULL, NULL, 6529, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:31:21', 'admin-1486090908-14860998815958142', 1, 0, '', NULL, NULL, NULL),
(18939, '2017-02-03 13:31:21', NULL, NULL, 6529, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:31:21', 'admin-1486090908-14860998815958142', 1, 0, '', NULL, NULL, NULL),
(18940, '2017-02-03 13:31:21', NULL, NULL, 6529, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:31:21', 'admin-1486090908-14860998815958142', 1, 1, 'SR', NULL, NULL, NULL),
(18941, '2017-02-03 13:33:26', NULL, NULL, 6530, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:33:26', 'admin-1486090908-14861000068187062', 1, 1, 'SR', NULL, NULL, NULL),
(18942, '2017-02-03 13:33:26', NULL, NULL, 6530, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:33:26', 'admin-1486090908-14861000068187062', 1, 1, 'SR', NULL, NULL, NULL),
(18943, '2017-02-03 13:33:26', NULL, NULL, 6530, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:33:26', 'admin-1486090908-14861000068187062', 1, 1, 'SR', NULL, NULL, NULL),
(18944, '2017-02-03 13:33:27', NULL, NULL, 6530, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:33:27', 'admin-1486090908-14861000068187062', 1, 1, 'SR', NULL, NULL, NULL),
(18945, '2017-02-03 13:37:23', NULL, NULL, 6527, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:37:23', 'admin-1486100235-1486100243738910', 1, 0, '', NULL, NULL, NULL),
(18946, '2017-02-03 13:39:08', NULL, NULL, 6527, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:39:08', 'admin-1486100235-14861003485823772', 1, 0, '', NULL, NULL, NULL),
(18947, '2017-02-03 13:40:05', NULL, NULL, 6531, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:40:05', 'admin-1486100235-14861004057278137', 1, 1, 'SR', NULL, NULL, NULL),
(18948, '2017-02-03 13:42:27', NULL, NULL, 6532, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:42:27', 'admin-1486100235-14861005474353980', 1, 0, '', NULL, NULL, NULL),
(18949, '2017-02-03 13:42:27', NULL, NULL, 6532, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:42:27', 'admin-1486100235-14861005474353980', 1, 0, '', NULL, NULL, NULL),
(18950, '2017-02-03 13:44:44', NULL, NULL, 6532, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:44:44', 'admin-1486100235-14861006846983049', 1, 1, 'SR', NULL, NULL, NULL),
(18951, '2017-02-03 13:44:44', NULL, NULL, 6532, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:44:44', 'admin-1486100235-14861006846983049', 1, 0, '', NULL, NULL, NULL),
(18952, '2017-02-03 13:44:44', NULL, NULL, 6532, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:44:44', 'admin-1486100235-14861006846983049', 1, 1, 'SR', NULL, NULL, NULL),
(18953, '2017-02-03 13:44:44', NULL, NULL, 6532, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:44:44', 'admin-1486100235-14861006846983049', 1, 0, '', NULL, NULL, NULL),
(18954, '2017-02-03 13:50:57', NULL, NULL, 6532, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:50:57', 'admin-1486100235-14861010575176487', 1, 0, '', NULL, NULL, NULL),
(18955, '2017-02-03 13:50:57', NULL, NULL, 6532, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:50:57', 'admin-1486100235-14861010575176487', 1, 1, 'SR', NULL, NULL, NULL),
(18956, '2017-02-03 13:55:12', NULL, NULL, 6533, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:55:12', 'admin-1486100235-14861013124951947', 1, 0, '', NULL, NULL, NULL),
(18957, '2017-02-03 13:55:12', NULL, NULL, 6533, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:55:12', 'admin-1486100235-14861013124951947', 1, 1, 'SR', NULL, NULL, NULL),
(18958, '2017-02-03 13:55:20', NULL, NULL, 6530, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:55:20', 'admin-1486100235-14861013200775845', 1, 1, 'SR', NULL, NULL, NULL),
(18959, '2017-02-03 15:35:56', NULL, NULL, 6542, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 15:35:56', 'admin-1486103352-1486107355872645', 1, 1, 'SR', NULL, NULL, NULL),
(18960, '2017-02-03 16:14:07', NULL, NULL, 6544, 0, 259, '193', 'Coronado Beer Set', '', 'Cold Drinks', 'Soda & Beer', 1, 40.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 16:14:07', 'admin-1486103352-14861096468386340', 1, 0, '', 1, NULL, NULL),
(18961, '2017-02-03 15:28:50', NULL, NULL, 6542, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 15:28:50', 'admin-1486103352-14861069305095812', 1, 1, 'SR', NULL, NULL, NULL),
(18962, '2017-02-03 15:33:17', NULL, NULL, 6543, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 15:33:17', 'admin-1486103352-14861071978461658', 1, 1, 'SR', NULL, NULL, NULL),
(18963, '2017-02-03 16:18:09', NULL, NULL, 6545, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 16:18:09', 'admin-1486103352-14861098896648923', 1, 1, 'SR', NULL, NULL, NULL),
(18964, '2017-02-03 16:18:09', NULL, NULL, 6545, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 16:18:09', 'admin-1486103352-14861098896648923', 1, 1, 'SR', NULL, NULL, NULL),
(18965, '2017-02-03 16:17:55', NULL, NULL, 6543, 0, 259, '193', 'Coronado Beer Set', '', 'Cold Drinks', 'Soda & Beer', 1, 40.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 16:17:55', 'admin-1486103352-14861098754377985', 1, 0, '', NULL, NULL, NULL),
(18966, '2017-02-03 15:33:18', NULL, NULL, 6543, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 15:33:18', 'admin-1486103352-14861071978461658', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(18967, '2017-02-03 15:35:56', NULL, NULL, 6542, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 15:35:56', 'admin-1486103352-1486107355872645', 1, 0, '', NULL, NULL, NULL),
(18968, '2017-02-03 12:32:14', NULL, NULL, 6525, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 12:32:14', 'admin-1486090908-14860963343087798', 1, 1, 'SR', NULL, NULL, NULL),
(18969, '2017-02-03 11:22:24', NULL, NULL, 6522, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 11:22:24', 'admin-1486090908-14860921439161677', 1, 0, '', NULL, NULL, NULL),
(18970, '2017-02-03 11:29:06', NULL, NULL, 6523, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 11:29:06', 'admin-1486090908-1486092546113871', 1, 0, '', NULL, NULL, NULL),
(18971, '2017-02-03 11:29:06', NULL, NULL, 6523, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 11:29:06', 'admin-1486090908-1486092546113871', 1, 0, '', NULL, NULL, NULL),
(18972, '2017-02-03 11:29:06', NULL, NULL, 6523, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 11:29:06', 'admin-1486090908-1486092546113871', 1, 0, '', NULL, NULL, NULL),
(18973, '2017-02-03 11:29:06', NULL, NULL, 6523, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 11:29:06', 'admin-1486090908-1486092546113871', 1, 1, 'SR', NULL, NULL, NULL),
(18974, '2017-02-03 11:29:06', NULL, NULL, 6523, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 11:29:06', 'admin-1486090908-1486092546113871', 1, 1, 'SR', NULL, NULL, NULL),
(18975, '2017-02-03 11:29:06', NULL, NULL, 6523, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 11:29:06', 'admin-1486090908-1486092546113871', 1, 1, 'SR', NULL, NULL, NULL),
(18976, '2017-02-03 11:39:21', NULL, NULL, 6524, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 11:39:21', 'admin-1486090908-14860931614427697', 1, 1, 'SR', NULL, NULL, NULL),
(18977, '2017-02-03 11:39:21', NULL, NULL, 6524, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 11:39:21', 'admin-1486090908-14860931614427697', 1, 0, '', NULL, NULL, NULL),
(18978, '2017-02-03 20:48:46', NULL, NULL, 6552, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:48:46', 'admin-1486117870-14861261261755829', 1, 0, '', NULL, NULL, NULL),
(18979, '2017-02-03 14:17:15', NULL, NULL, 6537, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 14:17:15', 'admin-1486100235-14861026351534784', 1, 1, 'SR', NULL, NULL, NULL),
(18980, '2017-02-03 14:17:15', NULL, NULL, 6537, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 14:17:15', 'admin-1486100235-14861026351534784', 1, 0, '', NULL, NULL, NULL),
(18981, '2017-02-03 14:17:25', NULL, NULL, 6538, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 14:17:25', 'admin-1486100235-1486102645411744', 1, 0, '', NULL, NULL, NULL),
(18982, '2017-02-03 14:20:20', NULL, NULL, 6539, 0, 213, '147', 'Set Stir Fried Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 14:20:20', 'admin-1486100235-1486102819984225', 1, 0, '', NULL, NULL, NULL),
(18983, '2017-02-03 14:20:29', NULL, NULL, 6539, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 14:20:29', 'admin-1486100235-14861028290715062', 1, 1, 'SR', NULL, NULL, NULL),
(18984, '2017-02-03 14:21:51', NULL, NULL, 6536, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 14:21:51', 'admin-1486100235-1486102910862927', 1, 1, 'SR', NULL, NULL, NULL),
(18985, '2017-02-03 15:26:41', NULL, NULL, 6541, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 15:26:41', 'admin-1486103352-14861068011805183', 1, 1, 'SR', NULL, NULL, NULL),
(18986, '2017-02-03 15:27:47', NULL, NULL, 6542, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 15:27:47', 'admin-1486103352-14861068673845844', 1, 0, '', NULL, NULL, NULL),
(18987, '2017-02-03 15:27:47', NULL, NULL, 6542, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 15:27:47', 'admin-1486103352-14861068673845844', 1, 1, 'SR', NULL, NULL, NULL),
(18988, '2017-02-03 15:28:50', NULL, NULL, 6542, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 15:28:50', 'admin-1486103352-14861069305095812', 1, 0, '', NULL, NULL, NULL),
(18989, '2017-02-03 14:32:10', NULL, NULL, 6540, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 14:32:10', 'admin-1486103352-14861035303228858', 1, 1, 'SR', NULL, NULL, NULL),
(18990, '2017-02-03 14:32:10', NULL, NULL, 6540, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 14:32:10', 'admin-1486103352-14861035303228858', 1, 1, 'SR', NULL, NULL, NULL),
(18991, '2017-02-03 14:31:15', NULL, NULL, 6536, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 14:31:15', 'admin-1486103352-14861034753166599', 1, 0, '', NULL, NULL, NULL),
(18992, '2017-02-03 14:17:15', NULL, NULL, 6537, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 14:17:15', 'admin-1486100235-14861026351534784', 1, 0, '', NULL, NULL, NULL),
(18993, '2017-02-03 14:17:15', NULL, NULL, 6537, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 14:17:15', 'admin-1486100235-14861026351534784', 1, 0, '', NULL, NULL, NULL),
(18994, '2017-02-03 14:13:49', NULL, NULL, 6535, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 14:13:49', 'admin-1486100235-14861024293889950', 1, 1, 'SR', NULL, NULL, NULL),
(18995, '2017-02-03 14:13:49', NULL, NULL, 6535, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 14:13:49', 'admin-1486100235-14861024293889950', 1, 0, '', NULL, NULL, NULL),
(18996, '2017-02-03 14:09:34', NULL, NULL, 6536, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 14:09:34', 'admin-1486100235-14861021739701342', 1, 1, 'SR', NULL, NULL, NULL),
(18997, '2017-02-03 20:03:57', NULL, NULL, 6553, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 20:03:57', 'admin-1486117870-14861234369497078', 1, 0, '', NULL, NULL, NULL),
(18998, '2017-02-03 14:05:17', NULL, NULL, 6535, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 14:05:17', 'admin-1486100235-14861019170238485', 1, 1, 'SR', NULL, NULL, NULL),
(18999, '2017-02-03 14:10:16', NULL, NULL, 6527, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 14:10:16', 'admin-1486100235-14861022160992553', 1, 1, 'SR', NULL, NULL, NULL),
(19000, '2017-02-03 14:05:17', NULL, NULL, 6535, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 14:05:17', 'admin-1486100235-14861019170238485', 1, 1, 'SR', NULL, NULL, NULL),
(19001, '2017-02-03 14:03:57', NULL, NULL, 6534, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 14:03:57', 'admin-1486100235-1486101837230676', 1, 1, 'SR', NULL, NULL, NULL),
(19002, '2017-02-03 13:55:20', NULL, NULL, 6530, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 13:55:20', 'admin-1486100235-14861013200775845', 1, 1, 'SR', NULL, NULL, NULL),
(19003, '2017-02-03 11:57:54', NULL, NULL, 6520, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 11:57:54', 'admin-1486090908-14860942738361468', 1, 0, '', NULL, NULL, NULL),
(19004, '2017-02-03 12:06:46', NULL, NULL, 6518, 0, 85, '85', 'Set Meatless Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 12:06:46', 'admin-1486090908-14860948065582987', 1, 1, 'SR', NULL, NULL, NULL),
(19005, '2017-02-03 10:15:57', NULL, NULL, 6518, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 10:15:57', 'admin-1486083430-14860881572195148', 1, 0, '', NULL, NULL, NULL),
(19006, '2017-02-03 10:16:04', NULL, NULL, 6518, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 10:16:04', 'admin-1486083430-14860881640079223', 1, 1, 'SR', NULL, NULL, NULL),
(19007, '2017-02-03 10:35:01', NULL, NULL, 6519, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 10:35:01', 'admin-1486083430-14860893016675928', 1, 1, 'SR', NULL, NULL, NULL),
(19008, '2017-02-03 10:35:01', NULL, NULL, 6519, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 10:35:01', 'admin-1486083430-14860893016675928', 1, 1, 'SR', NULL, NULL, NULL),
(19009, '2017-02-03 10:35:01', NULL, NULL, 6519, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 10:35:01', 'admin-1486083430-14860893016675928', 1, 1, 'SR', NULL, NULL, NULL),
(19010, '2017-02-03 10:35:01', NULL, NULL, 6519, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 10:35:01', 'admin-1486083430-14860893016675928', 1, 1, 'SR', NULL, NULL, NULL),
(19011, '2017-02-03 10:35:01', NULL, NULL, 6519, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 10:35:01', 'admin-1486083430-14860893016675928', 1, 1, 'SR', NULL, NULL, NULL),
(19012, '2017-02-03 10:35:01', NULL, NULL, 6519, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 10:35:01', 'admin-1486083430-14860893016675928', 1, 0, '', NULL, NULL, NULL),
(19013, '2017-02-03 10:53:48', NULL, NULL, 6518, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 10:53:48', 'admin-1486083430-14860904280375769', 1, 0, '', NULL, NULL, NULL),
(19014, '2017-02-03 10:58:18', NULL, NULL, 6520, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 10:58:18', 'admin-1486083430-14860906982088498', 1, 0, '', NULL, NULL, NULL),
(19015, '2017-02-03 10:59:48', NULL, NULL, 6520, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 10:59:48', 'admin-1486083430-14860907878513435', 1, 0, '', NULL, NULL, NULL),
(19016, '2017-02-03 10:58:18', NULL, NULL, 6520, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 10:58:18', 'admin-1486083430-14860906982088498', 1, 0, '', NULL, NULL, NULL),
(19017, '2017-02-03 10:58:18', NULL, NULL, 6520, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 10:58:18', 'admin-1486083430-14860906982088498', 1, 1, 'SR', NULL, NULL, NULL),
(19018, '2017-02-03 10:58:18', NULL, NULL, 6520, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 10:58:18', 'admin-1486083430-14860906982088498', 1, 1, 'SR', NULL, NULL, NULL),
(19019, '2017-02-03 11:02:09', NULL, NULL, 6520, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 11:02:09', 'admin-1486090908-1486090929498585', 1, 1, 'SR', NULL, NULL, NULL),
(19020, '2017-02-03 11:17:51', NULL, NULL, 6518, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 11:17:51', 'admin-1486090908-14860918715686759', 1, 1, 'SR', NULL, NULL, NULL),
(19021, '2017-02-03 11:17:51', NULL, NULL, 6518, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 11:17:51', 'admin-1486090908-14860918715686759', 1, 1, 'SR', NULL, NULL, NULL),
(19022, '2017-02-03 11:21:49', NULL, NULL, 6521, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 11:21:49', 'admin-1486090908-14860921090102489', 1, 1, 'SR', NULL, NULL, NULL),
(19023, '2017-02-03 11:21:49', NULL, NULL, 6521, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 11:21:49', 'admin-1486090908-14860921090102489', 1, 1, 'SR', NULL, NULL, NULL),
(19024, '2017-02-03 11:21:49', NULL, NULL, 6521, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 11:21:49', 'admin-1486090908-14860921090102489', 1, 0, '', NULL, NULL, NULL),
(19025, '2017-02-03 11:21:49', NULL, NULL, 6521, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 11:21:49', 'admin-1486090908-14860921090102489', 1, 0, '', NULL, NULL, NULL),
(19026, '2017-02-03 11:22:05', NULL, NULL, 6522, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 11:22:05', 'admin-1486090908-14860921250817887', 1, 1, 'SR', NULL, NULL, NULL),
(19027, '2017-02-03 11:22:05', NULL, NULL, 6522, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 11:22:05', 'admin-1486090908-14860921250817887', 1, 1, 'SR', NULL, NULL, NULL),
(19028, '2017-02-03 11:22:24', NULL, NULL, 6522, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 11:22:24', 'admin-1486090908-14860921439161677', 1, 0, '', NULL, NULL, NULL),
(19029, '2017-02-03 09:31:45', NULL, NULL, 6513, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 09:31:45', 'admin-1486083430-14860855050978220', 1, 1, 'SR', NULL, NULL, NULL),
(19030, '2017-02-03 09:31:45', NULL, NULL, 6513, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 09:31:45', 'admin-1486083430-14860855050978220', 1, 1, 'SR', NULL, NULL, NULL),
(19031, '2017-02-03 09:31:45', NULL, NULL, 6513, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 09:31:45', 'admin-1486083430-14860855050978220', 1, 1, 'SR', NULL, NULL, NULL),
(19032, '2017-02-03 09:31:45', NULL, NULL, 6513, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 09:31:45', 'admin-1486083430-14860855050978220', 1, 0, '', NULL, NULL, NULL),
(19033, '2017-02-03 09:51:25', NULL, NULL, 6514, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 09:51:25', 'admin-1486083430-1486086685357145', 1, 0, '', NULL, NULL, NULL),
(19034, '2017-02-03 09:51:25', NULL, NULL, 6514, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 09:51:25', 'admin-1486083430-1486086685357145', 1, 1, 'SR', NULL, NULL, NULL),
(19035, '2017-02-03 09:59:30', NULL, NULL, 6515, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 09:59:30', 'admin-1486083430-14860871698203482', 1, 1, 'SR', NULL, NULL, NULL),
(19036, '2017-02-03 09:59:55', NULL, NULL, 6516, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 09:59:55', 'admin-1486083430-14860871953391085', 1, 1, 'SR', NULL, NULL, NULL),
(19037, '2017-02-03 10:03:38', NULL, NULL, 6517, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 10:03:38', 'admin-1486083430-14860874186196440', 1, 1, 'SR', NULL, NULL, NULL),
(19038, '2017-02-03 10:15:57', NULL, NULL, 6518, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 10:15:57', 'admin-1486083430-14860881572195148', 1, 0, '', NULL, NULL, NULL),
(19039, '2017-02-03 09:13:15', NULL, NULL, 6512, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 09:13:15', 'admin-1486083430-14860843953417575', 1, 1, 'SR', NULL, NULL, NULL),
(19040, '2017-02-03 09:13:15', NULL, NULL, 6512, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 09:13:15', 'admin-1486083430-14860843953417575', 1, 0, '', NULL, NULL, NULL),
(19041, '2017-02-03 09:13:09', NULL, NULL, 6512, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 09:13:09', 'admin-1486083430-1486084389624817', 1, 0, '', NULL, NULL, NULL),
(19042, '2017-02-03 09:13:09', NULL, NULL, 6512, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 09:13:09', 'admin-1486083430-1486084389624817', 1, 0, '', NULL, NULL, NULL),
(19043, '2017-02-03 09:13:09', NULL, NULL, 6512, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486117870', 'admin', '2017-02-03 09:13:09', 'admin-1486083430-1486084389624817', 1, 0, '', NULL, NULL, NULL),
(19044, '2017-02-04 13:08:08', NULL, NULL, 6580, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:08:08', 'admin-1486182430-14861848880178025', 1, 0, '', NULL, NULL, NULL),
(19045, '2017-02-04 13:08:13', NULL, NULL, 6580, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:08:13', 'admin-1486182430-14861848936823853', 1, 1, 'SR', NULL, NULL, NULL),
(19046, '2017-02-04 13:42:27', NULL, NULL, 6585, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:42:27', 'admin-1486185769-1486186947505105', 1, 1, 'SR', NULL, NULL, NULL),
(19047, '2017-02-04 13:42:27', NULL, NULL, 6585, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:42:27', 'admin-1486185769-1486186947505105', 1, 1, 'SR', NULL, NULL, NULL),
(19048, '2017-02-04 13:50:48', NULL, NULL, 6586, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:50:48', 'admin-1486185769-14861874482396095', 1, 0, '', NULL, NULL, '10.0'),
(19049, '2017-02-04 13:56:54', NULL, NULL, 6586, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:56:54', 'admin-1486185769-14861878146326541', 1, 1, 'SR', NULL, NULL, '10.0'),
(19050, '2017-02-04 14:00:35', NULL, NULL, 6587, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 14:00:35', 'admin-1486185769-14861880355174656', 1, 0, '', NULL, NULL, NULL),
(19051, '2017-02-04 14:00:35', NULL, NULL, 6587, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 14:00:35', 'admin-1486185769-14861880355174656', 1, 0, '', NULL, NULL, NULL),
(19052, '2017-02-04 14:00:35', NULL, NULL, 6587, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 14:00:35', 'admin-1486185769-14861880355174656', 1, 0, '', NULL, NULL, NULL),
(19053, '2017-02-04 14:00:35', NULL, NULL, 6587, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', 'fried egg', 'Meals', 'Perfect Meals', 1, 17.50, 17.5000, 0.0000, 17.50, 1, '27', 1, '1486190504', 'admin', '2017-02-04 14:00:35', 'admin-1486185769-14861880355174656', 1, 1, 'SR', NULL, NULL, NULL),
(19054, '2017-02-04 12:31:26', NULL, NULL, 6570, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:31:26', 'admin-1486182430-14861826867924995', 1, 1, 'SR', NULL, NULL, NULL),
(19055, '2017-02-04 12:33:27', NULL, NULL, 6576, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:33:27', 'admin-1486182430-14861828071742748', 1, 1, 'SR', NULL, NULL, NULL),
(19056, '2017-02-04 12:33:34', NULL, NULL, 6576, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:33:34', 'admin-1486182430-14861828140647769', 1, 1, 'SR', NULL, NULL, NULL),
(19057, '2017-02-04 12:33:49', NULL, NULL, 6576, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:33:49', 'admin-1486182430-14861828293421343', 1, 0, '', NULL, NULL, NULL),
(19058, '2017-02-04 12:33:49', NULL, NULL, 6576, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:33:49', 'admin-1486182430-14861828293421343', 1, 1, 'SR', NULL, NULL, NULL),
(19059, '2017-02-04 12:45:56', NULL, NULL, 6577, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:45:56', 'admin-1486182430-14861835567677472', 1, 0, '', NULL, NULL, NULL),
(19060, '2017-02-04 12:45:56', NULL, NULL, 6577, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:45:56', 'admin-1486182430-14861835567677472', 1, 0, '', NULL, NULL, NULL),
(19061, '2017-02-04 12:45:56', NULL, NULL, 6577, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:45:56', 'admin-1486182430-14861835567677472', 1, 0, '', NULL, NULL, NULL),
(19062, '2017-02-04 12:45:56', NULL, NULL, 6577, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:45:56', 'admin-1486182430-14861835567677472', 1, 0, '', NULL, NULL, NULL),
(19063, '2017-02-04 12:45:56', NULL, NULL, 6577, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:45:57', 'admin-1486182430-14861835567677472', 1, 1, 'SR', NULL, NULL, NULL),
(19064, '2017-02-04 12:45:57', NULL, NULL, 6577, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:45:57', 'admin-1486182430-14861835567677472', 1, 0, '', NULL, NULL, NULL),
(19065, '2017-02-04 00:00:00', NULL, NULL, 6594, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:55:45', 'admin-1486182430-14861841456812941', 1, 1, 'SR', NULL, NULL, NULL),
(19066, '2017-02-04 12:04:31', NULL, NULL, 6574, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:04:31', 'admin-1486179464-14861810714357083', 1, 1, 'SR', NULL, NULL, NULL),
(19067, '2017-02-04 12:16:11', NULL, NULL, 6574, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:16:11', 'admin-1486179464-14861817718263493', 1, 1, 'SR', NULL, NULL, NULL),
(19068, '2017-02-04 19:09:26', NULL, NULL, 6602, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 19:09:26', 'admin-1486190504-14862065663463992', 1, 1, 'SR', NULL, NULL, NULL),
(19069, '2017-02-04 19:08:33', NULL, NULL, 6601, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 19:08:33', 'admin-1486190504-14862065130234025', 1, 0, '', NULL, NULL, NULL),
(19070, '2017-02-04 19:08:05', NULL, NULL, 6600, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 19:08:05', 'admin-1486190504-14862064850333433', 1, 0, '', NULL, NULL, NULL),
(19071, '2017-02-04 14:01:03', NULL, NULL, 6587, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 14:01:03', 'admin-1486185769-14861880628965389', 1, 1, 'SR', NULL, NULL, NULL),
(19072, '2017-02-04 14:01:03', NULL, NULL, 6587, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 14:01:03', 'admin-1486185769-14861880628965389', 1, 1, 'SR', NULL, NULL, NULL),
(19073, '2017-02-04 14:27:35', NULL, NULL, 6588, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 14:27:35', 'admin-1486185769-1486189655147872', 1, 1, 'SR', NULL, NULL, NULL),
(19074, '2017-02-04 14:27:35', NULL, NULL, 6588, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 14:27:35', 'admin-1486185769-1486189655147872', 1, 0, '', NULL, NULL, NULL),
(19075, '2017-02-04 14:27:35', NULL, NULL, 6588, 0, 217, '151', 'Spicy Lemony Wings', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 14:27:35', 'admin-1486185769-1486189655147872', 1, 0, '', NULL, NULL, NULL),
(19076, '2017-02-04 14:27:35', NULL, NULL, 6588, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 14:27:35', 'admin-1486185769-1486189655147872', 1, 1, 'SR', NULL, NULL, NULL),
(19077, '2017-02-04 14:27:35', NULL, NULL, 6588, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 14:27:35', 'admin-1486185769-1486189655147872', 1, 0, '', NULL, NULL, NULL),
(19078, '2017-02-04 14:28:01', NULL, NULL, 6588, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 14:28:01', 'admin-1486185769-14861896812898665', 1, 1, 'SR', NULL, NULL, NULL),
(19079, '2017-02-04 15:25:26', NULL, NULL, 6589, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 15:25:26', 'admin-1486190504-14861931267478584', 1, 1, 'SR', NULL, NULL, NULL),
(19080, '2017-02-04 15:25:26', NULL, NULL, 6589, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 15:25:26', 'admin-1486190504-14861931267478584', 1, 1, 'SR', NULL, NULL, NULL),
(19081, '2017-02-04 15:28:03', NULL, NULL, 6590, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 15:28:03', 'admin-1486190504-14861932837215783', 1, 0, '', 1, NULL, NULL),
(19082, '2017-02-04 15:30:20', NULL, NULL, 6591, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 15:30:20', 'admin-1486190504-14861934207839814', 1, 1, 'SR', NULL, NULL, NULL),
(19083, '2017-02-04 15:30:20', NULL, NULL, 6591, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 15:30:20', 'admin-1486190504-14861934207839814', 1, 1, 'SR', NULL, NULL, NULL),
(19084, '2017-02-04 15:32:14', NULL, NULL, 6592, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 15:32:14', 'admin-1486190504-14861935341471093', 1, 0, '', NULL, NULL, NULL),
(19085, '2017-02-04 15:32:14', NULL, NULL, 6592, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 15:32:14', 'admin-1486190504-14861935341471093', 1, 1, 'SR', NULL, NULL, NULL),
(19086, '2017-02-04 00:00:00', NULL, NULL, 6593, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:52:59', 'admin-1486182430-1486183979701689', 1, 1, 'SR', NULL, NULL, NULL),
(19087, '2017-02-04 00:00:00', NULL, NULL, 6593, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 15:35:11', 'admin-1486190504-14861937116001273', 1, 1, 'SR', NULL, NULL, NULL),
(19088, '2017-02-04 16:13:05', NULL, NULL, 6587, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 16:13:05', 'admin-1486190504-14861959852654976', 1, 0, '', NULL, NULL, NULL),
(19089, '2017-02-04 16:35:13', NULL, NULL, 6595, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 16:35:13', 'admin-1486190504-14861973137766094', 1, 0, '', NULL, NULL, NULL),
(19090, '2017-02-04 16:35:13', NULL, NULL, 6595, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 16:35:13', 'admin-1486190504-14861973137766094', 1, 0, '', NULL, NULL, NULL),
(19091, '2017-02-04 16:35:13', NULL, NULL, 6595, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 16:35:13', 'admin-1486190504-14861973137766094', 1, 1, 'SR', NULL, NULL, NULL),
(19092, '2017-02-04 17:26:44', NULL, NULL, 6596, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 17:26:44', 'admin-1486190504-14862004045756410', 1, 0, '', NULL, NULL, '10.0'),
(19093, '2017-02-04 17:26:44', NULL, NULL, 6596, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 17:26:44', 'admin-1486190504-14862004045756410', 1, 1, 'SR', NULL, NULL, '10.0'),
(19094, '2017-02-04 17:28:21', NULL, NULL, 6597, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 17:28:21', 'admin-1486190504-14862005008856498', 1, 0, '', NULL, NULL, '10.0'),
(19095, '2017-02-04 17:38:16', NULL, NULL, 6598, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 17:38:16', 'admin-1486190504-14862010960318958', 1, 1, 'SR', NULL, NULL, NULL),
(19096, '2017-02-04 17:38:16', NULL, NULL, 6598, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 17:38:16', 'admin-1486190504-14862010960318958', 1, 1, 'SR', NULL, NULL, NULL),
(19097, '2017-02-04 17:38:16', NULL, NULL, 6598, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 17:38:16', 'admin-1486190504-14862010960318958', 1, 0, '', NULL, NULL, NULL),
(19098, '2017-02-04 17:38:16', NULL, NULL, 6598, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 17:38:16', 'admin-1486190504-14862010960318958', 1, 0, '', NULL, NULL, NULL),
(19099, '2017-02-04 19:07:31', NULL, NULL, 6599, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 19:07:31', 'admin-1486190504-14862064516733034', 1, 0, '', NULL, NULL, NULL),
(19100, '2017-02-04 13:19:36', NULL, NULL, 6582, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:19:36', 'admin-1486182430-14861855759494560', 1, 0, '', NULL, NULL, NULL),
(19101, '2017-02-04 13:19:36', NULL, NULL, 6582, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:19:36', 'admin-1486182430-14861855759494560', 1, 0, '', NULL, NULL, NULL),
(19102, '2017-02-04 13:23:55', NULL, NULL, 6580, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:23:55', 'admin-1486185769-14861858352299324', 1, 0, '', NULL, NULL, NULL),
(19103, '2017-02-04 13:23:55', NULL, NULL, 6580, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:23:55', 'admin-1486185769-14861858352299324', 1, 1, 'SR', NULL, NULL, NULL),
(19104, '2017-02-04 13:34:53', NULL, NULL, 6577, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:34:53', 'admin-1486185769-14861864929758310', 1, 0, '', NULL, NULL, NULL),
(19105, '2017-02-04 13:36:02', NULL, NULL, 6583, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:36:02', 'admin-1486185769-14861865622956684', 1, 1, 'SR', NULL, NULL, NULL),
(19106, '2017-02-04 13:36:02', NULL, NULL, 6583, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:36:02', 'admin-1486185769-14861865622956684', 1, 1, 'SR', NULL, NULL, NULL),
(19107, '2017-02-04 11:49:43', NULL, NULL, 6573, 0, 156, '90', 'Cheese Omelet', 'add bacon', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 11:49:43', 'admin-1486179464-14861801830537462', 1, 0, '', NULL, NULL, NULL),
(19108, '2017-02-04 11:50:46', NULL, NULL, 6573, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 11:50:46', 'admin-1486179464-14861802459605855', 1, 1, 'SR', NULL, NULL, NULL),
(19109, '2017-02-04 11:33:11', NULL, NULL, 6571, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 11:33:11', 'admin-1486173135-14861791916164737', 1, 0, '', NULL, NULL, NULL),
(19110, '2017-02-04 11:33:11', NULL, NULL, 6571, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 11:33:11', 'admin-1486173135-14861791916164737', 1, 0, '', NULL, NULL, NULL),
(19111, '2017-02-04 11:33:11', NULL, NULL, 6571, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 11:33:11', 'admin-1486173135-14861791916164737', 1, 0, '', NULL, NULL, NULL),
(19112, '2017-02-04 11:37:30', NULL, NULL, 6570, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 11:37:30', 'admin-1486173135-1486179450230117', 1, 1, 'SR', NULL, NULL, NULL),
(19113, '2017-02-04 11:37:30', NULL, NULL, 6570, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 11:37:30', 'admin-1486173135-1486179450230117', 1, 1, 'SR', NULL, NULL, NULL),
(19114, '2017-02-04 11:37:30', NULL, NULL, 6570, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 11:37:30', 'admin-1486173135-1486179450230117', 1, 1, 'SR', NULL, NULL, NULL),
(19115, '2017-02-04 11:38:12', NULL, NULL, 6570, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 11:38:12', 'admin-1486179464-14861794918448764', 1, 1, 'SR', NULL, NULL, NULL),
(19116, '2017-02-04 11:38:50', NULL, NULL, 6570, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 11:38:50', 'admin-1486179464-14861795305022454', 1, 0, '', NULL, NULL, NULL),
(19117, '2017-02-04 11:49:43', NULL, NULL, 6573, 0, 157, '91', 'French Toast with Fruits', 'without fruits', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 11:49:43', 'admin-1486179464-14861801830537462', 1, 0, '', NULL, NULL, NULL),
(19118, '2017-02-04 13:42:27', NULL, NULL, 6585, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:42:27', 'admin-1486185769-1486186947505105', 1, 0, '', NULL, NULL, NULL),
(19119, '2017-02-04 13:42:27', NULL, NULL, 6585, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:42:27', 'admin-1486185769-1486186947505105', 1, 0, '', NULL, NULL, NULL),
(19120, '2017-02-04 13:42:27', NULL, NULL, 6585, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:42:27', 'admin-1486185769-1486186947505105', 1, 0, '', NULL, NULL, NULL),
(19121, '2017-02-04 13:39:27', NULL, NULL, 6584, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:39:27', 'admin-1486185769-14861867676861333', 1, 1, 'SR', NULL, NULL, NULL),
(19122, '2017-02-04 13:39:27', NULL, NULL, 6584, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:39:27', 'admin-1486185769-14861867676861333', 1, 1, 'SR', NULL, NULL, NULL),
(19123, '2017-02-04 13:39:27', NULL, NULL, 6584, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:39:27', 'admin-1486185769-14861867676861333', 1, 0, '', NULL, NULL, NULL),
(19124, '2017-02-04 13:13:55', NULL, NULL, 6581, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:13:55', 'admin-1486182430-14861852357873292', 1, 1, 'SR', NULL, NULL, NULL),
(19125, '2017-02-04 13:13:55', NULL, NULL, 6581, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:13:55', 'admin-1486182430-14861852357873292', 1, 0, '', NULL, NULL, NULL),
(19126, '2017-02-04 13:14:09', NULL, NULL, 6581, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:14:09', 'admin-1486182430-14861852492796112', 1, 1, 'SR', NULL, NULL, NULL),
(19127, '2017-02-04 13:14:09', NULL, NULL, 6581, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:14:09', 'admin-1486182430-14861852492796112', 1, 1, 'SR', NULL, NULL, NULL),
(19128, '2017-02-04 13:01:17', NULL, NULL, 6579, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:01:17', 'admin-1486182430-14861844773604732', 1, 1, 'SR', NULL, NULL, NULL),
(19129, '2017-02-04 13:06:18', NULL, NULL, 6575, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:06:18', 'admin-1486182430-14861847787232199', 1, 0, '', NULL, NULL, NULL),
(19130, '2017-02-04 13:51:34', NULL, NULL, 6586, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:51:34', 'admin-1486185769-14861874947968066', 1, 0, '', NULL, NULL, '10.0'),
(19131, '2017-02-04 13:13:55', NULL, NULL, 6581, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:13:55', 'admin-1486182430-14861852357873292', 1, 1, 'SR', NULL, NULL, NULL),
(19132, '2017-02-04 13:01:17', NULL, NULL, 6579, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 13:01:17', 'admin-1486182430-14861844773604732', 1, 1, 'SR', NULL, NULL, NULL),
(19133, '2017-02-04 16:04:59', NULL, NULL, 6589, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 16:04:59', 'admin-1486190504-14861954987884479', 1, 1, 'SR', NULL, NULL, NULL),
(19134, '2017-02-04 12:59:53', NULL, NULL, 6570, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:59:53', 'admin-1486182430-1486184393583462', 1, 0, '', NULL, NULL, NULL),
(19135, '2017-02-04 12:26:48', NULL, NULL, 6575, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:26:48', 'admin-1486179464-14861824078393356', 1, 0, '', NULL, NULL, NULL),
(19136, '2017-02-04 12:04:31', NULL, NULL, 6574, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:04:31', 'admin-1486179464-14861810714357083', 1, 1, 'SR', NULL, NULL, NULL),
(19137, '2017-02-04 12:26:48', NULL, NULL, 6575, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:26:48', 'admin-1486179464-14861824078393356', 1, 1, 'SR', NULL, NULL, NULL),
(19138, '2017-02-04 12:26:48', NULL, NULL, 6575, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:26:48', 'admin-1486179464-14861824078393356', 1, 0, '', NULL, NULL, NULL),
(19139, '2017-02-04 12:26:48', NULL, NULL, 6575, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:26:48', 'admin-1486179464-14861824078393356', 1, 0, '', NULL, NULL, NULL),
(19140, '2017-02-04 12:00:56', NULL, NULL, 6574, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:00:56', 'admin-1486179464-14861808563506343', 1, 1, 'SR', NULL, NULL, NULL),
(19141, '2017-02-04 12:00:56', NULL, NULL, 6574, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 12:00:56', 'admin-1486179464-14861808563506343', 1, 1, 'SR', NULL, NULL, NULL),
(19142, '2017-02-04 11:49:16', NULL, NULL, 6572, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 11:49:16', 'admin-1486179464-14861801564046387', 1, 1, 'SR', NULL, NULL, NULL),
(19143, '2017-02-04 11:33:11', NULL, NULL, 6571, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 11:33:11', 'admin-1486173135-14861791916164737', 1, 0, '', NULL, NULL, NULL),
(19144, '2017-02-04 11:33:11', NULL, NULL, 6571, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 11:33:11', 'admin-1486173135-14861791916164737', 1, 0, '', NULL, NULL, NULL),
(19145, '2017-02-04 09:13:01', NULL, NULL, 6560, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 09:13:01', 'admin-1486169067-14861707816644735', 1, 0, '', NULL, NULL, NULL),
(19146, '2017-02-04 09:27:48', NULL, NULL, 6561, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 09:27:48', 'admin-1486169067-14861716681103193', 1, 1, 'SR', NULL, NULL, NULL),
(19147, '2017-02-04 09:34:31', NULL, NULL, 6562, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 09:34:31', 'admin-1486169067-14861720708868631', 1, 0, '', NULL, NULL, NULL),
(19148, '2017-02-04 09:34:53', NULL, NULL, 6562, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 09:34:53', 'admin-1486169067-14861720929127434', 1, 1, 'SR', NULL, NULL, NULL),
(19149, '2017-02-04 09:34:53', NULL, NULL, 6562, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 09:34:53', 'admin-1486169067-14861720929127434', 1, 1, 'SR', NULL, NULL, NULL),
(19150, '2017-02-04 09:34:53', NULL, NULL, 6562, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 09:34:53', 'admin-1486169067-14861720929127434', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(19151, '2017-02-04 09:35:17', NULL, NULL, 6562, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 09:35:17', 'admin-1486169067-14861721171041070', 1, 0, '', NULL, NULL, NULL),
(19152, '2017-02-04 09:37:16', NULL, NULL, 6563, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 09:37:16', 'admin-1486169067-1486172236068141', 1, 0, '', NULL, NULL, NULL),
(19153, '2017-02-04 09:37:16', NULL, NULL, 6563, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 09:37:16', 'admin-1486169067-1486172236068141', 1, 0, '', NULL, NULL, NULL),
(19154, '2017-02-04 09:37:16', NULL, NULL, 6563, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 09:37:16', 'admin-1486169067-1486172236068141', 1, 0, '', NULL, NULL, NULL),
(19155, '2017-02-04 09:37:26', NULL, NULL, 6562, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 09:37:26', 'admin-1486169067-14861722468287735', 1, 1, 'SR', NULL, NULL, NULL),
(19156, '2017-02-04 09:37:41', NULL, NULL, 6563, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 09:37:41', 'admin-1486169067-14861722609842327', 1, 1, 'SR', NULL, NULL, NULL),
(19157, '2017-02-04 09:50:44', NULL, NULL, 6564, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 09:50:44', 'admin-1486169067-1486173044286870', 1, 0, '', NULL, NULL, NULL),
(19158, '2017-02-04 09:50:44', NULL, NULL, 6564, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 09:50:44', 'admin-1486169067-1486173044286870', 1, 0, '', NULL, NULL, NULL),
(19159, '2017-02-04 09:50:44', NULL, NULL, 6564, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 09:50:44', 'admin-1486169067-1486173044286870', 1, 0, '', NULL, NULL, NULL),
(19160, '2017-02-04 09:50:55', NULL, NULL, 6564, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 09:50:55', 'admin-1486169067-14861730556614929', 1, 1, 'SR', NULL, NULL, NULL),
(19161, '2017-02-04 09:50:55', NULL, NULL, 6564, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 09:50:55', 'admin-1486169067-14861730556614929', 1, 1, 'SR', NULL, NULL, NULL),
(19162, '2017-02-04 10:04:16', NULL, NULL, 6565, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 10:04:16', 'admin-1486173135-14861738568378077', 1, 0, '', NULL, NULL, NULL),
(19163, '2017-02-04 10:04:17', NULL, NULL, 6565, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 10:04:17', 'admin-1486173135-14861738568378077', 1, 0, '', NULL, NULL, NULL),
(19164, '2017-02-04 10:18:59', NULL, NULL, 6566, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 10:18:59', 'admin-1486173135-14861747395932026', 1, 0, '', NULL, NULL, NULL),
(19165, '2017-02-04 10:18:59', NULL, NULL, 6566, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 10:18:59', 'admin-1486173135-14861747395932026', 1, 0, '', NULL, NULL, NULL),
(19166, '2017-02-04 10:18:59', NULL, NULL, 6566, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 10:18:59', 'admin-1486173135-14861747395932026', 1, 0, '', NULL, NULL, NULL),
(19167, '2017-02-04 10:19:11', NULL, NULL, 6566, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 10:19:11', 'admin-1486173135-14861747513255346', 1, 1, 'SR', NULL, NULL, NULL),
(19168, '2017-02-04 10:19:11', NULL, NULL, 6566, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 10:19:11', 'admin-1486173135-14861747513255346', 1, 1, 'SR', NULL, NULL, NULL),
(19169, '2017-02-04 10:33:35', NULL, NULL, 6568, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 10:33:35', 'admin-1486173135-14861756148641752', 1, 1, 'SR', NULL, NULL, NULL),
(19170, '2017-02-04 10:26:49', NULL, NULL, 6567, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 10:26:49', 'admin-1486173135-14861752092356772', 1, 1, 'SR', NULL, NULL, NULL),
(19171, '2017-02-04 10:33:35', NULL, NULL, 6568, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 10:33:35', 'admin-1486173135-14861756148641752', 1, 1, 'SR', NULL, NULL, NULL),
(19172, '2017-02-04 10:33:35', NULL, NULL, 6568, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 10:33:35', 'admin-1486173135-14861756148641752', 1, 1, 'SR', NULL, NULL, NULL),
(19173, '2017-02-04 10:44:50', NULL, NULL, 6569, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 10:44:50', 'admin-1486173135-14861762898392587', 1, 1, 'SR', NULL, NULL, NULL),
(19174, '2017-02-04 10:44:50', NULL, NULL, 6569, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 10:44:50', 'admin-1486173135-14861762898392587', 1, 0, '', NULL, NULL, NULL),
(19175, '2017-02-04 10:45:02', NULL, NULL, 6569, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 10:45:02', 'admin-1486173135-14861763020409185', 1, 0, '', NULL, NULL, NULL),
(19176, '2017-02-04 10:45:02', NULL, NULL, 6569, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 10:45:02', 'admin-1486173135-14861763020409185', 1, 0, '', NULL, NULL, NULL),
(19177, '2017-02-04 11:07:09', NULL, NULL, 6569, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 11:07:09', 'admin-1486173135-14861776290291543', 1, 0, '', NULL, NULL, NULL),
(19178, '2017-02-04 09:13:01', NULL, NULL, 6560, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 09:13:01', 'admin-1486169067-14861707816644735', 1, 1, 'SR', NULL, NULL, NULL),
(19179, '2017-02-04 09:13:01', NULL, NULL, 6560, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 09:13:01', 'admin-1486169067-14861707816644735', 1, 0, '', NULL, NULL, NULL),
(19180, '2017-02-04 09:13:01', NULL, NULL, 6560, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486190504', 'admin', '2017-02-04 09:13:01', 'admin-1486169067-14861707816644735', 1, 0, '', NULL, NULL, NULL),
(19181, '2017-02-05 20:57:22', NULL, NULL, 6641, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 20:57:22', 'admin-1486277816-14862994426966517', 1, 1, 'SR', NULL, NULL, NULL),
(19182, '2017-02-05 19:52:27', NULL, NULL, 6643, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 19:52:27', 'admin-1486277816-14862955475206691', 1, 0, '', NULL, NULL, NULL),
(19183, '2017-02-05 21:18:30', NULL, NULL, 6641, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 21:18:30', 'admin-1486277816-14863007103296598', 1, 0, '', NULL, NULL, NULL),
(19184, '2017-02-05 21:18:30', NULL, NULL, 6641, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 21:18:30', 'admin-1486277816-14863007103296598', 1, 0, '', NULL, NULL, NULL),
(19185, '2017-02-05 21:16:39', NULL, NULL, 6641, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 21:16:39', 'admin-1486277816-14863005993687420', 1, 1, 'SR', NULL, NULL, NULL),
(19186, '2017-02-05 19:55:34', NULL, NULL, 6644, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 19:55:34', 'admin-1486277816-14862957341277337', 1, 0, '', NULL, NULL, NULL),
(19187, '2017-02-05 19:55:34', NULL, NULL, 6644, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 19:55:34', 'admin-1486277816-14862957341277337', 1, 1, 'SR', NULL, NULL, NULL),
(19188, '2017-02-05 20:36:41', NULL, NULL, 6644, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 20:36:41', 'admin-1486277816-14862982013192067', 1, 0, '', NULL, NULL, NULL),
(19189, '2017-02-05 19:55:34', NULL, NULL, 6644, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 19:55:34', 'admin-1486277816-14862957341277337', 1, 1, 'SR', NULL, NULL, NULL),
(19190, '2017-02-05 18:49:09', NULL, NULL, 6641, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 18:49:09', 'admin-1486277816-14862917489444169', 1, 0, '', NULL, NULL, NULL),
(19191, '2017-02-05 19:17:43', NULL, NULL, 6643, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 19:17:43', 'admin-1486277816-14862934635565619', 1, 0, '', NULL, NULL, NULL),
(19192, '2017-02-05 19:17:43', NULL, NULL, 6643, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 19:17:43', 'admin-1486277816-14862934635565619', 1, 1, 'SR', NULL, NULL, NULL),
(19193, '2017-02-05 19:17:43', NULL, NULL, 6643, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 19:17:43', 'admin-1486277816-14862934635565619', 1, 1, 'SR', NULL, NULL, NULL),
(19194, '2017-02-05 19:17:43', NULL, NULL, 6643, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 19:17:43', 'admin-1486277816-14862934635565619', 1, 0, '', NULL, NULL, NULL),
(19195, '2017-02-05 19:00:58', NULL, NULL, 6642, 0, 181, '116', 'Open Food ', 'pistachios scone', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 19:00:58', 'admin-1486277816-14862924581665422', 1, 0, '', NULL, NULL, NULL),
(19196, '2017-02-05 19:00:58', NULL, NULL, 6642, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 19:00:58', 'admin-1486277816-14862924581665422', 1, 1, 'SR', NULL, NULL, NULL),
(19197, '2017-02-05 18:49:09', NULL, NULL, 6641, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 18:49:09', 'admin-1486277816-14862917489444169', 1, 0, '', NULL, NULL, NULL),
(19198, '2017-02-05 18:49:09', NULL, NULL, 6641, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 18:49:09', 'admin-1486277816-14862917489444169', 1, 0, '', NULL, NULL, NULL),
(19199, '2017-02-05 18:49:09', NULL, NULL, 6641, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 18:49:09', 'admin-1486277816-14862917489444169', 1, 0, '', NULL, NULL, NULL),
(19200, '2017-02-05 18:49:09', NULL, NULL, 6641, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 18:49:09', 'admin-1486277816-14862917489444169', 1, 1, 'SR', NULL, NULL, NULL),
(19201, '2017-02-05 18:49:09', NULL, NULL, 6641, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 18:49:09', 'admin-1486277816-14862917489444169', 1, 0, '', NULL, NULL, NULL),
(19202, '2017-02-05 18:49:09', NULL, NULL, 6641, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 18:49:09', 'admin-1486277816-14862917489444169', 1, 1, 'SR', NULL, NULL, NULL),
(19203, '2017-02-05 18:49:09', NULL, NULL, 6641, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 18:49:09', 'admin-1486277816-14862917489444169', 1, 1, 'SR', NULL, NULL, NULL),
(19204, '2017-02-05 18:49:09', NULL, NULL, 6641, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 18:49:09', 'admin-1486277816-14862917489444169', 1, 0, '', NULL, NULL, NULL),
(19205, '2017-02-05 18:33:50', NULL, NULL, 6640, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 18:33:50', 'admin-1486277816-14862908300128357', 1, 0, '', NULL, NULL, NULL),
(19206, '2017-02-05 18:16:24', NULL, NULL, 6640, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 18:16:24', 'admin-1486277816-14862897842915533', 1, 1, 'SR', NULL, NULL, NULL),
(19207, '2017-02-05 18:16:24', NULL, NULL, 6640, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 18:16:24', 'admin-1486277816-14862897842915533', 1, 1, 'SR', NULL, NULL, NULL),
(19208, '2017-02-05 18:16:24', NULL, NULL, 6640, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 18:16:24', 'admin-1486277816-14862897842915533', 1, 0, '', NULL, NULL, NULL),
(19209, '2017-02-05 18:16:24', NULL, NULL, 6640, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 18:16:24', 'admin-1486277816-14862897842915533', 1, 1, 'SR', NULL, NULL, NULL),
(19210, '2017-02-05 17:37:44', NULL, NULL, 6639, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 17:37:44', 'admin-1486277816-14862874639393231', 1, 0, '', NULL, NULL, NULL),
(19211, '2017-02-05 17:37:44', NULL, NULL, 6639, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 17:37:44', 'admin-1486277816-14862874639393231', 1, 0, '', NULL, NULL, NULL),
(19212, '2017-02-05 17:37:44', NULL, NULL, 6639, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 17:37:44', 'admin-1486277816-14862874639393231', 1, 1, 'SR', NULL, NULL, NULL),
(19213, '2017-02-05 17:37:44', NULL, NULL, 6639, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 17:37:44', 'admin-1486277816-14862874639393231', 1, 1, 'SR', NULL, NULL, NULL),
(19214, '2017-02-05 17:34:17', NULL, NULL, 6638, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 17:34:17', 'admin-1486277816-1486287257070562', 1, 0, '', NULL, NULL, '10.0'),
(19215, '2017-02-05 17:34:27', NULL, NULL, 6638, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 17:34:27', 'admin-1486277816-14862872674805413', 1, 0, '', NULL, NULL, '10.0'),
(19216, '2017-02-05 17:34:27', NULL, NULL, 6638, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 17:34:27', 'admin-1486277816-14862872674805413', 1, 0, '', NULL, NULL, '10.0'),
(19217, '2017-02-05 17:34:17', NULL, NULL, 6638, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 17:34:17', 'admin-1486277816-1486287257070562', 1, 1, 'SR', NULL, NULL, '10.0'),
(19218, '2017-02-05 17:34:17', NULL, NULL, 6638, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 17:34:17', 'admin-1486277816-1486287257070562', 1, 1, 'SR', NULL, NULL, '10.0'),
(19219, '2017-02-05 17:17:20', NULL, NULL, 6638, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 17:17:20', 'admin-1486277816-14862862399333281', 1, 1, 'SR', NULL, NULL, '10.0'),
(19220, '2017-02-05 14:45:43', NULL, NULL, 6628, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:45:43', 'admin-1486274323-14862771433228422', 1, 0, '', NULL, NULL, NULL),
(19221, '2017-02-05 14:45:43', NULL, NULL, 6628, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:45:43', 'admin-1486274323-14862771433228422', 1, 1, 'SR', NULL, NULL, NULL),
(19222, '2017-02-05 14:45:43', NULL, NULL, 6628, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:45:43', 'admin-1486274323-14862771433228422', 1, 1, 'SR', NULL, NULL, NULL),
(19223, '2017-02-05 14:56:49', NULL, NULL, 6629, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:56:49', 'admin-1486274323-1486277808875319', 1, 1, 'SR', NULL, NULL, '10.0'),
(19224, '2017-02-05 14:56:49', NULL, NULL, 6629, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:56:49', 'admin-1486274323-1486277808875319', 1, 0, '', NULL, NULL, '10.0'),
(19225, '2017-02-05 14:56:49', NULL, NULL, 6629, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:56:49', 'admin-1486274323-1486277808875319', 1, 1, 'SR', NULL, NULL, '10.0'),
(19226, '2017-02-05 14:56:49', NULL, NULL, 6629, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:56:49', 'admin-1486274323-1486277808875319', 1, 1, 'SR', NULL, NULL, '10.0'),
(19227, '2017-02-05 14:57:23', NULL, NULL, 6629, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:57:23', 'admin-1486277816-14862778432351660', 1, 1, 'SR', NULL, NULL, '10.0'),
(19228, '2017-02-05 15:16:46', NULL, NULL, 6630, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 15:16:46', 'admin-1486277816-148627900612035', 1, 0, '', NULL, NULL, NULL),
(19229, '2017-02-05 15:16:46', NULL, NULL, 6630, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 15:16:46', 'admin-1486277816-148627900612035', 1, 0, '', NULL, NULL, NULL),
(19230, '2017-02-05 15:16:46', NULL, NULL, 6630, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 15:16:46', 'admin-1486277816-148627900612035', 1, 1, 'SR', NULL, NULL, NULL),
(19231, '2017-02-05 15:16:46', NULL, NULL, 6630, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 15:16:46', 'admin-1486277816-148627900612035', 1, 1, 'SR', NULL, NULL, NULL),
(19232, '2017-02-05 15:41:37', NULL, NULL, 6631, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 15:41:37', 'admin-1486277816-14862804971533053', 1, 0, '', NULL, NULL, NULL),
(19233, '2017-02-05 15:45:13', NULL, NULL, 6632, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 15:45:13', 'admin-1486277816-1486280713519796', 1, 1, 'SR', NULL, NULL, NULL),
(19234, '2017-02-05 15:45:13', NULL, NULL, 6632, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 15:45:13', 'admin-1486277816-1486280713519796', 1, 1, 'SR', NULL, NULL, NULL),
(19235, '2017-02-05 15:45:13', NULL, NULL, 6632, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 15:45:13', 'admin-1486277816-1486280713519796', 1, 1, 'SR', NULL, NULL, NULL),
(19236, '2017-02-05 15:45:55', NULL, NULL, 6632, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 15:45:55', 'admin-1486277816-14862807548665061', 1, 0, '', NULL, NULL, NULL),
(19237, '2017-02-05 15:45:55', NULL, NULL, 6632, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 15:45:55', 'admin-1486277816-14862807548665061', 1, 1, 'SR', NULL, NULL, NULL),
(19238, '2017-02-05 15:50:44', NULL, NULL, 6633, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 15:50:44', 'admin-1486277816-14862810444215782', 1, 0, '', NULL, NULL, NULL),
(19239, '2017-02-05 15:56:55', NULL, NULL, 6634, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 15:56:55', 'admin-1486277816-14862814149275264', 1, 1, 'SR', NULL, NULL, NULL),
(19240, '2017-02-05 15:56:55', NULL, NULL, 6634, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 15:56:55', 'admin-1486277816-14862814149275264', 1, 1, 'SR', NULL, NULL, NULL),
(19241, '2017-02-05 15:56:55', NULL, NULL, 6634, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 15:56:55', 'admin-1486277816-14862814149275264', 1, 1, 'SR', NULL, NULL, NULL),
(19242, '2017-02-05 15:56:55', NULL, NULL, 6634, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 15:56:55', 'admin-1486277816-14862814149275264', 1, 1, 'SR', NULL, NULL, NULL),
(19243, '2017-02-05 15:56:55', NULL, NULL, 6634, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 15:56:55', 'admin-1486277816-14862814149275264', 1, 1, 'SR', NULL, NULL, NULL),
(19244, '2017-02-05 16:09:28', NULL, NULL, 6635, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 16:09:28', 'admin-1486277816-14862821683846667', 1, 0, '', NULL, NULL, NULL),
(19245, '2017-02-05 13:24:04', NULL, NULL, 6621, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:24:04', 'admin-1486271966-14862722444899612', 1, 0, '', NULL, NULL, NULL),
(19246, '2017-02-05 13:27:11', NULL, NULL, 6617, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:27:11', 'admin-1486271966-14862724313621237', 1, 0, '', NULL, NULL, '10.0'),
(19247, '2017-02-05 14:27:32', NULL, NULL, 6617, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:27:32', 'admin-1486274323-14862760519083688', 1, 0, '', NULL, NULL, '10.0'),
(19248, '2017-02-05 14:27:19', NULL, NULL, 6617, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:27:19', 'admin-1486274323-1486276038953873', 1, 0, '', NULL, NULL, '10.0'),
(19249, '2017-02-05 14:23:01', NULL, NULL, 6626, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:23:01', 'admin-1486274323-1486275781145318', 1, 1, 'SR', NULL, NULL, NULL),
(19250, '2017-02-05 14:23:01', NULL, NULL, 6626, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:23:01', 'admin-1486274323-1486275781145318', 1, 0, '', NULL, NULL, NULL),
(19251, '2017-02-05 14:19:20', NULL, NULL, 6617, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:19:20', 'admin-1486274323-14862755605227831', 1, 0, '', NULL, NULL, '10.0'),
(19252, '2017-02-05 14:04:47', NULL, NULL, 6625, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:04:47', 'admin-1486274323-14862746870325669', 1, 1, 'SR', NULL, NULL, NULL),
(19253, '2017-02-05 14:04:47', NULL, NULL, 6625, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:04:47', 'admin-1486274323-14862746870325669', 1, 0, '', NULL, NULL, NULL),
(19254, '2017-02-05 12:27:32', NULL, NULL, 6611, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:27:32', 'admin-1486255314-1486268851825346', 1, 1, 'SR', NULL, NULL, NULL),
(19255, '2017-02-05 12:28:44', NULL, NULL, 6612, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:28:44', 'admin-1486268857-14862689247349929', 1, 0, '', NULL, NULL, NULL),
(19256, '2017-02-05 12:28:56', NULL, NULL, 6612, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:28:56', 'admin-1486268857-14862689364481434', 1, 0, '', NULL, NULL, NULL),
(19257, '2017-02-05 12:28:56', NULL, NULL, 6612, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:28:56', 'admin-1486268857-14862689364481434', 1, 1, 'SR', NULL, NULL, NULL),
(19258, '2017-02-05 12:29:55', NULL, NULL, 6612, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:29:55', 'admin-1486268857-14862689957555785', 1, 0, '', NULL, NULL, NULL),
(19259, '2017-02-05 12:35:07', NULL, NULL, 6613, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:35:07', 'admin-1486268857-14862693077514929', 1, 0, '', NULL, NULL, NULL),
(19260, '2017-02-05 12:35:07', NULL, NULL, 6613, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:35:07', 'admin-1486268857-14862693077514929', 1, 0, '', NULL, NULL, NULL),
(19261, '2017-02-05 12:42:34', NULL, NULL, 6611, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:42:34', 'admin-1486268857-14862697539399629', 1, 0, '', NULL, NULL, NULL),
(19262, '2017-02-05 12:47:35', NULL, NULL, 6614, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:47:35', 'admin-1486268857-1486270055480312', 1, 0, '', NULL, NULL, NULL),
(19263, '2017-02-05 12:47:35', NULL, NULL, 6614, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:47:35', 'admin-1486268857-1486270055480312', 1, 1, 'SR', NULL, NULL, NULL),
(19264, '2017-02-05 12:53:42', NULL, NULL, 6615, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:53:42', 'admin-1486268857-14862704227031349', 1, 1, 'SR', NULL, NULL, NULL),
(19265, '2017-02-05 12:53:42', NULL, NULL, 6615, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:53:42', 'admin-1486268857-14862704227031349', 1, 0, '', NULL, NULL, NULL),
(19266, '2017-02-05 12:53:42', NULL, NULL, 6615, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:53:42', 'admin-1486268857-14862704227031349', 1, 1, 'SR', NULL, NULL, NULL),
(19267, '2017-02-05 17:03:43', NULL, NULL, 6638, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 17:03:43', 'admin-1486277816-14862854231721070', 1, 1, 'SR', NULL, NULL, '10.0'),
(19268, '2017-02-05 17:03:43', NULL, NULL, 6638, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 17:03:43', 'admin-1486277816-14862854231721070', 1, 1, 'SR', NULL, NULL, '10.0'),
(19269, '2017-02-05 17:03:43', NULL, NULL, 6638, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 17:03:43', 'admin-1486277816-14862854231721070', 1, 1, 'SR', NULL, NULL, '10.0'),
(19270, '2017-02-05 17:02:46', NULL, NULL, 6637, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 17:02:46', 'admin-1486277816-14862853664702393', 1, 0, '', NULL, NULL, NULL),
(19271, '2017-02-05 17:03:43', NULL, NULL, 6638, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 17:03:43', 'admin-1486277816-14862854231721070', 1, 0, '', NULL, NULL, '10.0'),
(19272, '2017-02-05 16:30:13', NULL, NULL, 6636, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 16:30:13', 'admin-1486277816-14862834132357387', 1, 1, 'SR', NULL, NULL, NULL),
(19273, '2017-02-05 16:30:13', NULL, NULL, 6636, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 16:30:13', 'admin-1486277816-14862834132357387', 1, 1, 'SR', NULL, NULL, NULL),
(19274, '2017-02-05 17:02:30', NULL, NULL, 6637, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 17:02:30', 'admin-1486277816-14862853500998896', 1, 1, 'SR', NULL, NULL, NULL),
(19275, '2017-02-05 16:09:38', NULL, NULL, 6635, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 16:09:38', 'admin-1486277816-14862821781873469', 1, 1, 'SR', NULL, NULL, NULL),
(19276, '2017-02-05 16:09:38', NULL, NULL, 6635, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 16:09:38', 'admin-1486277816-14862821781873469', 1, 1, 'SR', NULL, NULL, NULL),
(19277, '2017-02-05 14:45:43', NULL, NULL, 6628, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:45:43', 'admin-1486274323-14862771433228422', 1, 0, '', NULL, NULL, NULL),
(19278, '2017-02-05 14:37:45', NULL, NULL, 6617, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:37:45', 'admin-1486274323-14862766654823767', 1, 1, 'SR', NULL, NULL, '10.0'),
(19279, '2017-02-05 14:32:39', NULL, NULL, 6627, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:32:39', 'admin-1486274323-14862763590008579', 1, 1, 'SR', NULL, NULL, NULL),
(19280, '2017-02-05 14:37:45', NULL, NULL, 6617, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:37:45', 'admin-1486274323-14862766654823767', 1, 0, '', NULL, NULL, '10.0'),
(19281, '2017-02-05 14:32:39', NULL, NULL, 6627, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:32:39', 'admin-1486274323-14862763590008579', 1, 1, 'SR', NULL, NULL, NULL),
(19282, '2017-02-05 14:33:53', NULL, NULL, 6627, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:33:53', 'admin-1486274323-14862764334132981', 1, 0, '', NULL, NULL, NULL),
(19283, '2017-02-05 14:32:39', NULL, NULL, 6627, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:32:39', 'admin-1486274323-14862763590008579', 1, 1, 'SR', NULL, NULL, NULL),
(19284, '2017-02-05 12:55:17', NULL, NULL, 6616, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:55:17', 'admin-1486270446-14862705168532528', 1, 1, 'SR', NULL, NULL, NULL),
(19285, '2017-02-05 13:53:45', NULL, NULL, 6617, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:53:45', 'admin-1486271966-14862740247553522', 1, 1, 'SR', NULL, NULL, '10.0'),
(19286, '2017-02-05 13:58:24', NULL, NULL, 6623, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:58:24', 'admin-1486271966-14862743040718273', 1, 1, 'SR', NULL, NULL, NULL),
(19287, '2017-02-05 13:58:38', NULL, NULL, 6624, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:58:38', 'admin-1486271966-1486274318574591', 1, 0, '', NULL, NULL, NULL),
(19288, '2017-02-05 17:09:49', NULL, NULL, 6637, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 17:09:49', 'admin-1486277816-1486285789412324', 1, 0, '', NULL, NULL, NULL),
(19289, '2017-02-05 13:58:38', NULL, NULL, 6624, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:58:38', 'admin-1486271966-1486274318574591', 1, 0, '', NULL, NULL, NULL),
(19290, '2017-02-05 13:53:45', NULL, NULL, 6617, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:53:45', 'admin-1486271966-14862740247553522', 1, 0, '', NULL, NULL, '10.0'),
(19291, '2017-02-05 13:52:54', NULL, NULL, 6617, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:52:54', 'admin-1486271966-1486273973988113', 1, 0, '', NULL, NULL, '10.0'),
(19292, '2017-02-05 13:17:52', NULL, NULL, 6617, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:17:52', 'admin-1486270446-14862718725387444', 1, 1, 'SR', NULL, NULL, '10.0'),
(19293, '2017-02-05 13:17:52', NULL, NULL, 6617, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:17:52', 'admin-1486270446-14862718725387444', 1, 0, '', NULL, NULL, '10.0'),
(19294, '2017-02-05 13:18:25', NULL, NULL, 6619, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:18:25', 'admin-1486270446-14862719049363699', 1, 0, '', NULL, NULL, NULL),
(19295, '2017-02-05 13:18:25', NULL, NULL, 6619, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:18:25', 'admin-1486270446-14862719049363699', 1, 1, 'SR', NULL, NULL, NULL),
(19296, '2017-02-05 13:18:53', NULL, NULL, 6620, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:18:53', 'admin-1486270446-14862719335719753', 1, 0, '', NULL, NULL, NULL),
(19297, '2017-02-05 13:18:53', NULL, NULL, 6620, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:18:53', 'admin-1486270446-14862719335719753', 1, 0, '', NULL, NULL, NULL),
(19298, '2017-02-05 13:18:53', NULL, NULL, 6620, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:18:53', 'admin-1486270446-14862719335719753', 1, 1, 'SR', NULL, NULL, NULL),
(19299, '2017-02-05 13:19:59', NULL, NULL, 6620, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:19:59', 'admin-1486271966-14862719995123086', 1, 0, '', NULL, NULL, NULL),
(19300, '2017-02-05 13:19:59', NULL, NULL, 6620, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:19:59', 'admin-1486271966-14862719995123086', 1, 0, '', NULL, NULL, NULL),
(19301, '2017-02-05 13:20:23', NULL, NULL, 6617, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:20:23', 'admin-1486271966-14862720230663146', 1, 0, '', NULL, NULL, '10.0'),
(19302, '2017-02-05 13:20:23', NULL, NULL, 6617, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:20:23', 'admin-1486271966-14862720230663146', 1, 1, 'SR', NULL, NULL, '10.0'),
(19303, '2017-02-05 13:22:50', NULL, NULL, 6617, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:22:50', 'admin-1486271966-14862721698179916', 1, 1, 'SR', NULL, NULL, '10.0'),
(19304, '2017-02-05 13:22:50', NULL, NULL, 6617, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:22:50', 'admin-1486271966-14862721698179916', 1, 1, 'SR', NULL, NULL, '10.0'),
(19305, '2017-02-05 13:22:50', NULL, NULL, 6617, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:22:50', 'admin-1486271966-14862721698179916', 1, 1, 'SR', NULL, NULL, '10.0'),
(19306, '2017-02-05 13:22:50', NULL, NULL, 6617, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:22:50', 'admin-1486271966-14862721698179916', 1, 1, 'SR', NULL, NULL, '10.0'),
(19307, '2017-02-05 13:22:50', NULL, NULL, 6617, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:22:50', 'admin-1486271966-14862721698179916', 1, 1, 'SR', NULL, NULL, '10.0'),
(19308, '2017-02-05 13:22:50', NULL, NULL, 6617, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:22:50', 'admin-1486271966-14862721698179916', 1, 0, '', NULL, NULL, '10.0'),
(19309, '2017-02-05 13:22:50', NULL, NULL, 6617, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:22:50', 'admin-1486271966-14862721698179916', 1, 0, '', NULL, NULL, '10.0'),
(19310, '2017-02-05 13:07:47', NULL, NULL, 6618, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:07:47', 'admin-1486270446-14862712671236689', 1, 0, '', NULL, NULL, NULL),
(19311, '2017-02-05 13:07:47', NULL, NULL, 6618, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:07:47', 'admin-1486270446-14862712671236689', 1, 1, 'SR', NULL, NULL, NULL),
(19312, '2017-02-05 13:07:47', NULL, NULL, 6618, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:07:47', 'admin-1486270446-14862712671236689', 1, 1, 'SR', NULL, NULL, NULL),
(19313, '2017-02-05 13:07:53', NULL, NULL, 6618, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:07:53', 'admin-1486270446-14862712729026257', 1, 0, '', NULL, NULL, NULL),
(19314, '2017-02-05 13:07:59', NULL, NULL, 6618, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:07:59', 'admin-1486270446-14862712797074956', 1, 1, 'SR', NULL, NULL, NULL),
(19315, '2017-02-05 13:10:10', NULL, NULL, 6611, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:10:10', 'admin-1486270446-14862714102734481', 1, 1, 'SR', NULL, NULL, NULL),
(19316, '2017-02-05 13:10:10', NULL, NULL, 6611, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:10:10', 'admin-1486270446-14862714102734481', 1, 1, 'SR', NULL, NULL, NULL),
(19317, '2017-02-05 13:17:52', NULL, NULL, 6617, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:17:52', 'admin-1486270446-14862718725387444', 1, 0, '', NULL, NULL, '10.0'),
(19318, '2017-02-05 13:17:52', NULL, NULL, 6617, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:17:52', 'admin-1486270446-14862718725387444', 1, 0, '', NULL, NULL, '10.0'),
(19319, '2017-02-05 13:53:45', NULL, NULL, 6617, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:53:45', 'admin-1486271966-14862740247553522', 1, 1, 'SR', NULL, NULL, '10.0'),
(19320, '2017-02-05 13:52:54', NULL, NULL, 6617, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:52:54', 'admin-1486271966-1486273973988113', 1, 0, '', NULL, NULL, '10.0'),
(19321, '2017-02-05 13:52:54', NULL, NULL, 6617, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:52:54', 'admin-1486271966-1486273973988113', 1, 0, '', NULL, NULL, '10.0'),
(19322, '2017-02-05 14:23:41', NULL, NULL, 6617, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:23:41', 'admin-1486274323-1486275820814126', 1, 0, '', NULL, NULL, '10.0'),
(19323, '2017-02-05 13:38:46', NULL, NULL, 6618, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:38:46', 'admin-1486271966-14862731266801311', 1, 0, '', NULL, NULL, NULL),
(19324, '2017-02-05 13:34:19', NULL, NULL, 6617, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:34:19', 'admin-1486271966-1486272859533982', 1, 1, 'SR', NULL, NULL, '10.0'),
(19325, '2017-02-05 13:34:19', NULL, NULL, 6617, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:34:19', 'admin-1486271966-1486272859533982', 1, 1, 'SR', NULL, NULL, '10.0'),
(19326, '2017-02-05 13:32:04', NULL, NULL, 6617, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:32:04', 'admin-1486271966-14862727244432640', 1, 1, 'SR', NULL, NULL, '10.0'),
(19327, '2017-02-05 13:31:55', NULL, NULL, 6618, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:31:55', 'admin-1486271966-14862727152238973', 1, 0, '', NULL, NULL, NULL),
(19328, '2017-02-05 13:28:43', NULL, NULL, 6622, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:28:43', 'admin-1486271966-14862725232573260', 1, 0, '', NULL, NULL, NULL),
(19329, '2017-02-05 11:44:17', NULL, NULL, 6609, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 11:44:17', 'admin-1486255314-14862662568759323', 1, 1, 'SR', NULL, NULL, NULL),
(19330, '2017-02-05 11:44:17', NULL, NULL, 6609, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 11:44:17', 'admin-1486255314-14862662568759323', 1, 1, 'SR', NULL, NULL, NULL),
(19331, '2017-02-05 11:49:46', NULL, NULL, 6609, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 11:49:46', 'admin-1486255314-1486266585934621', 1, 0, '', NULL, NULL, NULL),
(19332, '2017-02-05 11:49:46', NULL, NULL, 6609, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 11:49:46', 'admin-1486255314-1486266585934621', 1, 0, '', NULL, NULL, NULL),
(19333, '2017-02-05 10:25:31', NULL, NULL, 6608, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 10:25:31', 'admin-1486255314-14862615314106495', 1, 1, 'SR', NULL, NULL, NULL),
(19334, '2017-02-05 10:25:31', NULL, NULL, 6608, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 10:25:31', 'admin-1486255314-14862615314106495', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(19335, '2017-02-05 10:25:31', NULL, NULL, 6608, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 10:25:31', 'admin-1486255314-14862615314106495', 1, 1, 'SR', NULL, NULL, NULL),
(19336, '2017-02-05 10:55:05', NULL, NULL, 6608, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 10:55:05', 'admin-1486255314-14862633057396930', 1, 0, '', NULL, NULL, NULL),
(19337, '2017-02-05 11:43:48', NULL, NULL, 6609, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 11:43:48', 'admin-1486255314-14862662281914330', 1, 0, '', NULL, NULL, NULL),
(19338, '2017-02-05 11:43:48', NULL, NULL, 6609, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 11:43:48', 'admin-1486255314-14862662281914330', 1, 0, '', NULL, NULL, NULL),
(19339, '2017-02-05 11:43:48', NULL, NULL, 6609, 0, 156, '90', 'Cheese Omelet', 'no cheese', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 11:43:48', 'admin-1486255314-14862662281914330', 1, 0, '', NULL, NULL, NULL),
(19340, '2017-02-05 13:24:04', NULL, NULL, 6621, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:24:04', 'admin-1486271966-14862722444899612', 1, 0, '', NULL, NULL, NULL),
(19341, '2017-02-05 17:03:43', NULL, NULL, 6638, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 17:03:43', 'admin-1486277816-14862854231721070', 1, 1, 'SR', NULL, NULL, '10.0'),
(19342, '2017-02-05 13:28:43', NULL, NULL, 6622, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:28:43', 'admin-1486271966-14862725232573260', 1, 0, '', NULL, NULL, NULL),
(19343, '2017-02-05 13:28:43', NULL, NULL, 6622, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:28:43', 'admin-1486271966-14862725232573260', 1, 1, 'SR', NULL, NULL, NULL),
(19344, '2017-02-05 13:28:43', NULL, NULL, 6622, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:28:43', 'admin-1486271966-14862725232573260', 1, 1, 'SR', NULL, NULL, NULL),
(19345, '2017-02-05 13:28:43', NULL, NULL, 6622, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:28:43', 'admin-1486271966-14862725232573260', 1, 1, 'SR', NULL, NULL, NULL),
(19346, '2017-02-05 13:28:43', NULL, NULL, 6622, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:28:43', 'admin-1486271966-14862725232573260', 1, 1, 'SR', NULL, NULL, NULL),
(19347, '2017-02-05 13:27:38', NULL, NULL, 6618, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:27:38', 'admin-1486271966-14862724581528925', 1, 0, '', NULL, NULL, NULL),
(19348, '2017-02-05 13:17:52', NULL, NULL, 6617, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:17:52', 'admin-1486270446-14862718725387444', 1, 0, '', NULL, NULL, '10.0'),
(19349, '2017-02-05 13:17:52', NULL, NULL, 6617, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:17:52', 'admin-1486270446-14862718725387444', 1, 0, '', NULL, NULL, '10.0'),
(19350, '2017-02-05 14:27:19', NULL, NULL, 6617, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 14:27:19', 'admin-1486274323-1486276038953873', 1, 0, '', NULL, NULL, '10.0'),
(19351, '2017-02-05 13:17:52', NULL, NULL, 6617, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:17:52', 'admin-1486270446-14862718725387444', 1, 0, '', NULL, NULL, '10.0'),
(19352, '2017-02-05 13:17:52', NULL, NULL, 6617, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:17:52', 'admin-1486270446-14862718725387444', 1, 0, '', NULL, NULL, '10.0'),
(19353, '2017-02-05 13:17:52', NULL, NULL, 6617, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:17:52', 'admin-1486270446-14862718725387444', 1, 0, '', NULL, NULL, '10.0'),
(19354, '2017-02-05 13:17:52', NULL, NULL, 6617, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:17:52', 'admin-1486270446-14862718725387444', 1, 0, '', NULL, NULL, '10.0'),
(19355, '2017-02-05 13:02:12', NULL, NULL, 6617, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:02:12', 'admin-1486270446-14862709319695599', 1, 0, '', NULL, NULL, '10.0'),
(19356, '2017-02-05 13:07:47', NULL, NULL, 6618, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:07:47', 'admin-1486270446-14862712671236689', 1, 0, '', NULL, NULL, NULL),
(19357, '2017-02-05 12:26:03', NULL, NULL, 6611, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:26:03', 'admin-1486255314-14862687628707353', 1, 0, '', NULL, NULL, NULL),
(19358, '2017-02-05 12:27:31', NULL, NULL, 6611, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:27:31', 'admin-1486255314-1486268851825346', 1, 1, 'SR', NULL, NULL, NULL),
(19359, '2017-02-05 13:17:52', NULL, NULL, 6617, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 13:17:52', 'admin-1486270446-14862718725387444', 1, 0, '', NULL, NULL, '10.0'),
(19360, '2017-02-05 12:53:56', NULL, NULL, 6614, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:53:56', 'admin-1486268857-14862704365268032', 1, 0, '', NULL, NULL, NULL),
(19361, '2017-02-05 12:53:56', NULL, NULL, 6614, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:53:56', 'admin-1486268857-14862704365268032', 1, 1, 'SR', NULL, NULL, NULL),
(19362, '2017-02-05 12:27:31', NULL, NULL, 6611, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:27:32', 'admin-1486255314-1486268851825346', 1, 1, 'SR', NULL, NULL, NULL),
(19363, '2017-02-05 12:15:14', NULL, NULL, 6610, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:15:14', 'admin-1486255314-14862681144218974', 1, 0, '', NULL, NULL, NULL),
(19364, '2017-02-05 12:15:32', NULL, NULL, 6610, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:15:32', 'admin-1486255314-14862681322195627', 1, 0, '', NULL, NULL, NULL),
(19365, '2017-02-05 12:15:44', NULL, NULL, 6610, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:15:44', 'admin-1486255314-14862681437911893', 1, 1, 'SR', NULL, NULL, NULL),
(19366, '2017-02-05 12:14:59', NULL, NULL, 6610, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 12:14:59', 'admin-1486255314-14862680989579056', 1, 0, '', NULL, NULL, NULL),
(19367, '2017-02-05 11:49:46', NULL, NULL, 6609, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 11:49:46', 'admin-1486255314-1486266585934621', 1, 0, '', NULL, NULL, NULL),
(19368, '2017-02-05 09:11:49', NULL, NULL, 6603, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:11:49', 'admin-1486255314-14862571087699816', 1, 1, 'SR', NULL, NULL, NULL),
(19369, '2017-02-05 09:11:49', NULL, NULL, 6603, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:11:49', 'admin-1486255314-14862571087699816', 1, 1, 'SR', NULL, NULL, NULL),
(19370, '2017-02-05 09:11:49', NULL, NULL, 6603, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:11:49', 'admin-1486255314-14862571087699816', 1, 1, 'SR', NULL, NULL, NULL),
(19371, '2017-02-05 09:11:49', NULL, NULL, 6603, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:11:49', 'admin-1486255314-14862571087699816', 1, 1, 'SR', NULL, NULL, NULL),
(19372, '2017-02-05 09:28:20', NULL, NULL, 6604, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:28:20', 'admin-1486255314-14862581004562758', 1, 0, '', NULL, NULL, NULL),
(19373, '2017-02-05 09:28:20', NULL, NULL, 6604, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:28:20', 'admin-1486255314-14862581004562758', 1, 0, '', NULL, NULL, NULL),
(19374, '2017-02-05 09:28:20', NULL, NULL, 6604, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:28:20', 'admin-1486255314-14862581004562758', 1, 0, '', NULL, NULL, NULL),
(19375, '2017-02-05 09:28:20', NULL, NULL, 6604, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:28:20', 'admin-1486255314-14862581004562758', 1, 0, '', NULL, NULL, NULL),
(19376, '2017-02-05 09:28:20', NULL, NULL, 6604, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:28:20', 'admin-1486255314-14862581004562758', 1, 0, '', NULL, NULL, NULL),
(19377, '2017-02-05 09:28:20', NULL, NULL, 6604, 0, 157, '91', 'French Toast with Fruits', 'add bacon', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:28:20', 'admin-1486255314-14862581004562758', 1, 0, '', NULL, NULL, NULL),
(19378, '2017-02-05 09:28:20', NULL, NULL, 6604, 0, 157, '91', 'French Toast with Fruits', 'add bacon', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:28:20', 'admin-1486255314-14862581004562758', 1, 0, '', NULL, NULL, NULL),
(19379, '2017-02-05 09:28:31', NULL, NULL, 6604, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:28:31', 'admin-1486255314-14862581116156296', 1, 1, 'SR', NULL, NULL, NULL),
(19380, '2017-02-05 09:28:31', NULL, NULL, 6604, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:28:31', 'admin-1486255314-14862581116156296', 1, 1, 'SR', NULL, NULL, NULL),
(19381, '2017-02-05 09:28:31', NULL, NULL, 6604, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:28:31', 'admin-1486255314-14862581116156296', 1, 1, 'SR', NULL, NULL, NULL),
(19382, '2017-02-05 09:28:31', NULL, NULL, 6604, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:28:31', 'admin-1486255314-14862581116156296', 1, 1, 'SR', NULL, NULL, NULL),
(19383, '2017-02-05 09:28:31', NULL, NULL, 6604, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:28:31', 'admin-1486255314-14862581116156296', 1, 1, 'SR', NULL, NULL, NULL),
(19384, '2017-02-05 09:38:21', NULL, NULL, 6605, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:38:21', 'admin-1486255314-1486258701358238', 1, 0, '', NULL, NULL, NULL),
(19385, '2017-02-05 09:48:53', NULL, NULL, 6605, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:48:53', 'admin-1486255314-14862593329747375', 1, 0, '', NULL, NULL, NULL),
(19386, '2017-02-05 09:48:53', NULL, NULL, 6605, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:48:53', 'admin-1486255314-14862593329747375', 1, 1, 'SR', NULL, NULL, NULL),
(19387, '2017-02-05 09:48:53', NULL, NULL, 6605, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:48:53', 'admin-1486255314-14862593329747375', 1, 1, 'SR', NULL, NULL, NULL),
(19388, '2017-02-05 09:49:17', NULL, NULL, 6606, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:49:17', 'admin-1486255314-14862593570364647', 1, 1, 'SR', NULL, NULL, NULL),
(19389, '2017-02-05 09:49:17', NULL, NULL, 6606, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:49:17', 'admin-1486255314-14862593570364647', 1, 0, '', NULL, NULL, NULL),
(19390, '2017-02-05 09:49:17', NULL, NULL, 6606, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:49:17', 'admin-1486255314-14862593570364647', 1, 0, '', NULL, NULL, NULL),
(19391, '2017-02-05 09:49:35', NULL, NULL, 6606, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:49:35', 'admin-1486255314-14862593756532966', 1, 1, 'SR', NULL, NULL, NULL),
(19392, '2017-02-05 09:49:35', NULL, NULL, 6606, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:49:35', 'admin-1486255314-14862593756532966', 1, 0, '', NULL, NULL, NULL),
(19393, '2017-02-05 09:49:35', NULL, NULL, 6606, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:49:35', 'admin-1486255314-14862593756532966', 1, 1, 'SR', NULL, NULL, NULL),
(19394, '2017-02-05 09:54:05', NULL, NULL, 6607, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:54:05', 'admin-1486255314-14862596455945895', 1, 1, 'SR', NULL, NULL, NULL),
(19395, '2017-02-05 10:09:30', NULL, NULL, 6604, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 10:09:30', 'admin-1486255314-14862605702532964', 1, 1, 'SR', NULL, NULL, NULL),
(19396, '2017-02-05 10:09:30', NULL, NULL, 6604, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 10:09:30', 'admin-1486255314-14862605702532964', 1, 1, 'SR', NULL, NULL, NULL),
(19397, '2017-02-05 10:14:26', NULL, NULL, 6604, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 10:14:27', 'admin-1486255314-14862608667943495', 1, 1, 'SR', NULL, NULL, NULL),
(19398, '2017-02-05 10:25:19', NULL, NULL, 6608, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 10:25:19', 'admin-1486255314-1486261519143314', 1, 0, '', NULL, NULL, NULL),
(19399, '2017-02-05 10:25:19', NULL, NULL, 6608, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 10:25:19', 'admin-1486255314-1486261519143314', 1, 0, '', NULL, NULL, NULL),
(19400, '2017-02-05 10:25:19', NULL, NULL, 6608, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 10:25:19', 'admin-1486255314-1486261519143314', 1, 0, '', NULL, NULL, NULL),
(19401, '2017-02-05 11:44:17', NULL, NULL, 6609, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 11:44:17', 'admin-1486255314-14862662568759323', 1, 1, 'SR', NULL, NULL, NULL),
(19402, '2017-02-05 09:11:49', NULL, NULL, 6603, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486301152', 'admin', '2017-02-05 09:11:49', 'admin-1486255314-14862571087699816', 1, 1, 'SR', NULL, NULL, NULL),
(19403, '2017-02-06 17:41:46', NULL, NULL, 6661, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 17:41:46', 'admin-1486362600-14863741059115655', 1, 1, 'SR', NULL, NULL, NULL),
(19404, '2017-02-06 17:57:36', NULL, NULL, 6662, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 17:57:36', 'admin-1486362600-14863750563747976', 1, 1, 'SR', 1, NULL, NULL),
(19405, '2017-02-06 18:18:15', NULL, NULL, 6663, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 18:18:15', 'admin-1486362600-14863762956844899', 1, 1, 'SR', NULL, NULL, NULL),
(19406, '2017-02-06 09:42:01', NULL, NULL, 6646, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 09:42:01', 'admin-1486344182-14863453208295538', 1, 1, 'SR', 1, NULL, NULL),
(19407, '2017-02-06 10:11:50', NULL, NULL, 6647, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 10:11:50', 'admin-1486344182-14863471102689261', 1, 0, '', NULL, NULL, NULL),
(19408, '2017-02-06 10:11:50', NULL, NULL, 6647, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 10:11:50', 'admin-1486344182-14863471102689261', 1, 0, '', NULL, NULL, NULL),
(19409, '2017-02-06 10:11:50', NULL, NULL, 6647, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 10:11:50', 'admin-1486344182-14863471102689261', 1, 0, '', NULL, NULL, NULL),
(19410, '2017-02-06 10:11:50', NULL, NULL, 6647, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 10:11:50', 'admin-1486344182-14863471102689261', 1, 0, '', NULL, NULL, NULL),
(19411, '2017-02-06 10:12:12', NULL, NULL, 6647, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 10:12:12', 'admin-1486344182-14863471322152623', 1, 1, 'SR', NULL, NULL, NULL),
(19412, '2017-02-06 14:35:12', NULL, NULL, 6651, 0, 181, '116', 'Open Food ', 'Soya Sauce Chicken Drumstick', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 14:35:12', 'admin-1486362600-14863629123756195', 1, 0, '', NULL, NULL, NULL),
(19413, '2017-02-06 17:13:23', NULL, NULL, 6660, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 17:13:23', 'admin-1486362600-14863724035103671', 1, 1, 'SR', NULL, NULL, NULL),
(19414, '2017-02-06 18:18:15', NULL, NULL, 6663, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 18:18:15', 'admin-1486362600-14863762956844899', 1, 0, '', NULL, NULL, NULL),
(19415, '2017-02-06 14:35:12', NULL, NULL, 6651, 0, 181, '116', 'Open Food ', 'Soya Sauce Chicken Drumstick', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 14:35:12', 'admin-1486362600-14863629123756195', 1, 0, '', NULL, NULL, NULL),
(19416, '2017-02-06 14:09:14', NULL, NULL, 6657, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 14:09:14', 'admin-1486357499-14863613539135241', 1, 1, 'SR', NULL, NULL, NULL),
(19417, '2017-02-06 14:09:14', NULL, NULL, 6657, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 14:09:14', 'admin-1486357499-14863613539135241', 1, 0, '', NULL, NULL, NULL),
(19418, '2017-02-06 14:19:22', NULL, NULL, 6654, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 14:19:22', 'admin-1486357499-14863619622931824', 1, 0, '', NULL, NULL, NULL),
(19419, '2017-02-06 14:09:14', NULL, NULL, 6657, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 14:09:14', 'admin-1486357499-14863613539135241', 1, 0, '', NULL, NULL, NULL),
(19420, '2017-02-06 13:53:08', NULL, NULL, 6656, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 13:53:08', 'admin-1486357499-1486360388002862', 1, 0, '', NULL, NULL, NULL),
(19421, '2017-02-06 13:53:08', NULL, NULL, 6656, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 13:53:08', 'admin-1486357499-1486360388002862', 1, 1, 'SR', NULL, NULL, NULL),
(19422, '2017-02-06 13:40:58', NULL, NULL, 6655, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 13:40:58', 'admin-1486357499-14863596585549090', 1, 1, 'SR', NULL, NULL, NULL),
(19423, '2017-02-06 13:40:58', NULL, NULL, 6655, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 13:40:58', 'admin-1486357499-14863596585549090', 1, 0, '', NULL, NULL, NULL),
(19424, '2017-02-06 13:31:55', NULL, NULL, 6654, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 13:31:55', 'admin-1486357499-14863591155995972', 1, 1, 'SR', NULL, NULL, NULL),
(19425, '2017-02-06 13:31:55', NULL, NULL, 6654, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 13:31:55', 'admin-1486357499-14863591155995972', 1, 1, 'SR', NULL, NULL, NULL),
(19426, '2017-02-06 13:31:42', NULL, NULL, 6654, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 13:31:42', 'admin-1486357499-148635910209331', 1, 0, '', NULL, NULL, NULL),
(19427, '2017-02-06 13:31:42', NULL, NULL, 6654, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 13:31:42', 'admin-1486357499-148635910209331', 1, 0, '', NULL, NULL, NULL),
(19428, '2017-02-06 13:31:42', NULL, NULL, 6654, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 13:31:42', 'admin-1486357499-148635910209331', 1, 0, '', NULL, NULL, NULL),
(19429, '2017-02-06 13:29:02', NULL, NULL, 6653, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 13:29:02', 'admin-1486357499-14863589427366651', 1, 1, 'SR', NULL, NULL, NULL),
(19430, '2017-02-06 13:10:40', NULL, NULL, 6652, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 13:10:40', 'admin-1486357499-1486357840465813', 1, 0, '', NULL, NULL, NULL),
(19431, '2017-02-06 13:05:20', NULL, NULL, 6652, 0, 181, '116', 'Open Food ', '3 fried eggs', 'Meals', 'Perfect Meals', 1, 4.50, 4.5000, 0.0000, 4.50, 1, '27', 1, '1486362600', 'admin', '2017-02-06 13:05:20', 'admin-1486357499-14863575207563468', 1, 0, '', NULL, NULL, NULL),
(19432, '2017-02-06 12:50:11', NULL, NULL, 6652, 0, 181, '116', 'Open Food ', 'stew pork', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 12:50:11', 'admin-1486344182-14863566110004667', 1, 0, '', NULL, NULL, NULL),
(19433, '2017-02-06 12:48:39', NULL, NULL, 6652, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 12:48:39', 'admin-1486344182-1486356519126482', 1, 1, 'SR', NULL, NULL, NULL),
(19434, '2017-02-06 12:48:39', NULL, NULL, 6652, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 12:48:39', 'admin-1486344182-1486356519126482', 1, 1, 'SR', NULL, NULL, NULL),
(19435, '2017-02-06 12:48:39', NULL, NULL, 6652, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 12:48:39', 'admin-1486344182-1486356519126482', 1, 1, 'SR', NULL, NULL, NULL),
(19436, '2017-02-06 12:48:39', NULL, NULL, 6652, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 12:48:39', 'admin-1486344182-1486356519126482', 1, 1, 'SR', NULL, NULL, NULL),
(19437, '2017-02-06 12:48:39', NULL, NULL, 6652, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 12:48:39', 'admin-1486344182-1486356519126482', 1, 0, '', NULL, NULL, NULL),
(19438, '2017-02-06 12:47:40', NULL, NULL, 6651, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 12:47:40', 'admin-1486344182-1486356459910568', 1, 1, 'SR', NULL, NULL, NULL),
(19439, '2017-02-06 12:47:40', NULL, NULL, 6651, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 12:47:40', 'admin-1486344182-1486356459910568', 1, 1, 'SR', NULL, NULL, NULL),
(19440, '2017-02-06 11:59:29', NULL, NULL, 6648, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 11:59:29', 'admin-1486344182-14863535688168612', 1, 1, 'SR', NULL, NULL, NULL),
(19441, '2017-02-06 11:59:29', NULL, NULL, 6648, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1486362600', 'admin', '2017-02-06 11:59:29', 'admin-1486344182-14863535688168612', 1, 0, '', NULL, NULL, NULL),
(19442, '2017-02-06 11:52:53', NULL, NULL, 6650, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 11:52:53', 'admin-1486344182-14863531730566283', 1, 0, '', NULL, NULL, NULL),
(19443, '2017-02-06 11:52:53', NULL, NULL, 6650, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 11:52:53', 'admin-1486344182-14863531730566283', 1, 1, 'SR', NULL, NULL, NULL),
(19444, '2017-02-06 11:52:53', NULL, NULL, 6650, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 11:52:53', 'admin-1486344182-14863531730566283', 1, 1, 'SR', NULL, NULL, NULL),
(19445, '2017-02-06 11:23:45', NULL, NULL, 6649, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 11:23:45', 'admin-1486344182-14863514255842869', 1, 1, 'SR', NULL, NULL, NULL),
(19446, '2017-02-06 11:20:37', NULL, NULL, 6648, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 11:20:37', 'admin-1486344182-1486351236956777', 1, 1, 'SR', NULL, NULL, NULL),
(19447, '2017-02-06 10:53:49', NULL, NULL, 6647, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 10:53:49', 'admin-1486344182-14863496287565136', 1, 0, '', NULL, NULL, NULL),
(19448, '2017-02-06 10:12:12', NULL, NULL, 6647, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 10:12:12', 'admin-1486344182-14863471322152623', 1, 1, 'SR', NULL, NULL, NULL),
(19449, '2017-02-06 10:12:12', NULL, NULL, 6647, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 10:12:12', 'admin-1486344182-14863471322152623', 1, 1, 'SR', NULL, NULL, NULL),
(19450, '2017-02-06 09:31:20', NULL, NULL, 6645, 0, 181, '116', 'Open Food ', 'cheese', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 09:31:20', 'admin-1486344182-14863446801803147', 1, 0, '', NULL, NULL, NULL),
(19451, '2017-02-06 09:31:20', NULL, NULL, 6645, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 09:31:20', 'admin-1486344182-14863446801803147', 1, 1, 'SR', NULL, NULL, NULL),
(19452, '2017-02-06 09:31:20', NULL, NULL, 6645, 0, 156, '90', 'Cheese Omelet', 'Add bacon', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486362600', 'admin', '2017-02-06 09:31:20', 'admin-1486344182-14863446801803147', 1, 0, '', NULL, NULL, NULL),
(19453, '2017-02-08 10:20:25', NULL, NULL, 6664, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 10:20:25', 'admin-1486515364-14865204249791114', 1, 1, 'SR', NULL, NULL, NULL),
(19454, '2017-02-08 10:21:53', NULL, NULL, 6665, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 10:21:53', 'admin-1486515364-14865205135351330', 1, 0, '', NULL, NULL, NULL),
(19455, '2017-02-08 10:21:53', NULL, NULL, 6665, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 10:21:53', 'admin-1486515364-14865205135351330', 1, 0, '', NULL, NULL, NULL),
(19456, '2017-02-08 10:21:53', NULL, NULL, 6665, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 10:21:53', 'admin-1486515364-14865205135351330', 1, 1, 'SR', NULL, NULL, NULL),
(19457, '2017-02-08 10:55:53', NULL, NULL, 6666, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 10:55:53', 'admin-1486515364-14865225532377873', 1, 0, '', NULL, NULL, NULL),
(19458, '2017-02-08 10:55:53', NULL, NULL, 6666, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 10:55:53', 'admin-1486515364-14865225532377873', 1, 1, 'SR', NULL, NULL, NULL),
(19459, '2017-02-08 12:07:21', NULL, NULL, 6667, 0, 181, '116', 'Open Food ', 'apple', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 12:07:21', 'admin-1486515364-14865268417318112', 1, 0, '', NULL, NULL, NULL),
(19460, '2017-02-08 15:50:36', NULL, NULL, 6674, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 15:50:36', 'admin-1486529137-14865402360599245', 1, 0, '', NULL, NULL, NULL),
(19461, '2017-02-08 16:03:07', NULL, NULL, 6675, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 16:03:07', 'admin-1486529137-14865409871972579', 1, 1, 'SR', NULL, NULL, NULL),
(19462, '2017-02-08 15:43:45', NULL, NULL, 6673, 0, 181, '116', 'Open Food ', 'pistachio', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 15:43:45', 'admin-1486529137-14865398255488444', 1, 0, '', NULL, NULL, NULL),
(19463, '2017-02-08 15:43:45', NULL, NULL, 6673, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 15:43:45', 'admin-1486529137-14865398255488444', 1, 0, '', NULL, NULL, NULL),
(19464, '2017-02-08 15:43:45', NULL, NULL, 6673, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 15:43:45', 'admin-1486529137-14865398255488444', 1, 1, 'SR', NULL, NULL, NULL),
(19465, '2017-02-08 15:43:45', NULL, NULL, 6673, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 15:43:45', 'admin-1486529137-14865398255488444', 1, 1, 'SR', NULL, NULL, NULL),
(19466, '2017-02-08 00:00:00', NULL, NULL, 6671, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 12:45:51', 'admin-1486529137-14865291517186582', 1, 1, 'SR', NULL, NULL, NULL),
(19467, '2017-02-08 00:00:00', NULL, NULL, 6670, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 12:45:51', 'admin-1486529137-14865291517186582', 1, 1, 'SR', NULL, NULL, NULL),
(19468, '2017-02-08 00:00:00', NULL, NULL, 6670, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 13:44:08', 'admin-1486529137-14865326480636184', 1, 1, 'SR', NULL, NULL, NULL),
(19469, '2017-02-08 00:00:00', NULL, NULL, 6670, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 12:45:30', 'admin-1486515364-14865291306005287', 1, 1, 'SR', NULL, NULL, NULL),
(19470, '2017-02-08 00:00:00', NULL, NULL, 6671, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 12:41:56', 'admin-1486515364-14865289165329919', 1, 1, 'SR', NULL, NULL, NULL),
(19471, '2017-02-08 12:45:51', NULL, NULL, 6669, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 12:45:51', 'admin-1486529137-14865291517186582', 1, 1, 'SR', NULL, NULL, NULL),
(19472, '2017-02-08 13:55:24', NULL, NULL, 6669, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 13:55:24', 'admin-1486529137-14865333243481158', 1, 0, '', NULL, NULL, NULL),
(19473, '2017-02-08 12:45:30', NULL, NULL, 6669, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 12:45:30', 'admin-1486515364-14865291306005287', 1, 1, 'SR', NULL, NULL, NULL),
(19474, '2017-02-08 14:57:15', NULL, NULL, 6672, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 14:57:15', 'admin-1486529137-1486537034861485', 1, 0, '', NULL, NULL, NULL),
(19475, '2017-02-08 12:14:08', NULL, NULL, 6668, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 12:14:08', 'admin-1486515364-14865272484611393', 1, 1, 'SR', NULL, NULL, NULL),
(19476, '2017-02-08 12:14:08', NULL, NULL, 6668, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 12:14:08', 'admin-1486515364-14865272484611393', 1, 1, 'SR', NULL, NULL, NULL),
(19477, '2017-02-08 14:57:15', NULL, NULL, 6672, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 14:57:15', 'admin-1486529137-1486537034861485', 1, 1, 'SR', NULL, NULL, NULL),
(19478, '2017-02-08 12:14:08', NULL, NULL, 6668, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 12:14:08', 'admin-1486515364-14865272484611393', 1, 0, '', NULL, NULL, NULL),
(19479, '2017-02-08 10:20:25', NULL, NULL, 6664, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486529137', 'admin', '2017-02-08 10:20:25', 'admin-1486515364-14865204249791114', 1, 0, '', NULL, NULL, NULL),
(19480, '2017-02-09 14:57:40', NULL, NULL, 6691, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 14:57:40', 'admin-1486608082-14866234605041369', 1, 0, '', NULL, NULL, NULL),
(19481, '2017-02-09 13:29:40', NULL, NULL, 6688, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 13:29:40', 'admin-1486608082-14866181805798758', 1, 1, 'SR', NULL, NULL, NULL),
(19482, '2017-02-09 13:29:40', NULL, NULL, 6688, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 13:29:40', 'admin-1486608082-14866181805798758', 1, 1, 'SR', NULL, NULL, NULL),
(19483, '2017-02-09 13:40:02', NULL, NULL, 6689, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 13:40:02', 'admin-1486608082-14866188025739450', 1, 0, '', NULL, NULL, NULL),
(19484, '2017-02-09 13:40:02', NULL, NULL, 6689, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 13:40:02', 'admin-1486608082-14866188025739450', 1, 1, 'SR', NULL, NULL, NULL),
(19485, '2017-02-09 13:40:27', NULL, NULL, 6689, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 13:40:27', 'admin-1486608082-14866188275874920', 1, 0, '', NULL, NULL, NULL),
(19486, '2017-02-09 14:32:44', NULL, NULL, 6690, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 14:32:44', 'admin-1486608082-14866219642107665', 1, 0, '', NULL, NULL, '10.0'),
(19487, '2017-02-09 14:33:00', NULL, NULL, 6690, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 14:33:00', 'admin-1486608082-14866219804768239', 1, 0, '', NULL, NULL, '10.0'),
(19488, '2017-02-09 14:39:53', NULL, NULL, 6690, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 14:39:53', 'admin-1486608082-1486622393252556', 1, 0, '', NULL, NULL, '10.0'),
(19489, '2017-02-09 14:39:53', NULL, NULL, 6690, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 14:39:53', 'admin-1486608082-1486622393252556', 1, 1, 'SR', NULL, NULL, '10.0'),
(19490, '2017-02-09 14:57:40', NULL, NULL, 6691, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 14:57:40', 'admin-1486608082-14866234605041369', 1, 0, '', NULL, NULL, NULL),
(19491, '2017-02-09 14:57:40', NULL, NULL, 6691, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 14:57:40', 'admin-1486608082-14866234605041369', 1, 0, '', NULL, NULL, NULL),
(19492, '2017-02-09 15:12:50', NULL, NULL, 6693, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 15:12:50', 'admin-1486608082-14866243703972563', 1, 1, 'SR', NULL, NULL, NULL),
(19493, '2017-02-09 15:13:59', NULL, NULL, 6694, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 15:13:59', 'admin-1486608082-1486624439711985', 1, 0, '', NULL, NULL, '10.0'),
(19494, '2017-02-09 16:43:19', NULL, NULL, 6696, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 16:43:19', 'admin-1486625682-14866297992372950', 1, 1, 'SR', 1, NULL, NULL),
(19495, '2017-02-09 16:43:19', NULL, NULL, 6696, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 16:43:19', 'admin-1486625682-14866297992372950', 1, 1, 'SR', 1, NULL, NULL),
(19496, '2017-02-09 16:43:19', NULL, NULL, 6696, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 16:43:19', 'admin-1486625682-14866297992372950', 1, 0, '', 1, NULL, NULL),
(19497, '2017-02-09 16:43:19', NULL, NULL, 6696, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 16:43:19', 'admin-1486625682-14866297992372950', 1, 0, '', 1, NULL, NULL),
(19498, '2017-02-09 18:46:12', NULL, NULL, 6697, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 18:46:12', 'admin-1486625682-1486637172791378', 1, 1, 'SR', NULL, NULL, NULL),
(19499, '2017-02-09 18:46:12', NULL, NULL, 6697, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 18:46:12', 'admin-1486625682-1486637172791378', 1, 0, '', NULL, NULL, NULL),
(19500, '2017-02-09 11:14:53', NULL, NULL, 6680, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 11:14:53', 'admin-1486608082-1486610092948298', 1, 1, 'SR', NULL, NULL, NULL),
(19501, '2017-02-09 10:41:55', NULL, NULL, 6681, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 10:41:55', 'admin-1486608082-14866081153022588', 1, 0, '', NULL, NULL, NULL),
(19502, '2017-02-09 10:41:55', NULL, NULL, 6681, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 10:41:55', 'admin-1486608082-14866081153022588', 1, 0, '', NULL, NULL, NULL),
(19503, '2017-02-09 10:41:33', NULL, NULL, 6682, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 10:41:33', 'admin-1486608082-14866080930046031', 1, 1, 'SR', NULL, NULL, NULL),
(19504, '2017-02-09 10:41:33', NULL, NULL, 6682, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 10:41:33', 'admin-1486608082-14866080930046031', 1, 1, 'SR', NULL, NULL, NULL),
(19505, '2017-02-09 15:24:10', NULL, NULL, 6695, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 15:24:10', 'admin-1486608082-14866250502313073', 1, 1, 'SR', NULL, NULL, NULL),
(19506, '2017-02-09 15:24:10', NULL, NULL, 6695, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 15:24:10', 'admin-1486608082-14866250502313073', 1, 0, '', NULL, NULL, NULL),
(19507, '2017-02-09 13:29:40', NULL, NULL, 6688, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 13:29:40', 'admin-1486608082-14866181805798758', 1, 1, 'SR', NULL, NULL, NULL),
(19508, '2017-02-09 13:07:30', NULL, NULL, 6686, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 13:07:30', 'admin-1486608082-1486616850064819', 1, 0, '', 1, NULL, NULL),
(19509, '2017-02-09 15:04:50', NULL, NULL, 6692, 0, 181, '116', 'Open Food ', 'cookies', 'Meals', 'Perfect Meals', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 15:04:50', 'admin-1486608082-1486623890272672', 1, 0, '', 1, NULL, NULL),
(19510, '2017-02-09 15:12:50', NULL, NULL, 6693, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 15:12:50', 'admin-1486608082-14866243703972563', 1, 0, '', NULL, NULL, NULL),
(19511, '2017-02-09 14:57:40', NULL, NULL, 6691, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 14:57:40', 'admin-1486608082-14866234605041369', 1, 1, 'SR', NULL, NULL, NULL),
(19512, '2017-02-09 13:24:27', NULL, NULL, 6687, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 13:24:27', 'admin-1486608082-14866178676092578', 1, 1, 'SR', NULL, NULL, NULL),
(19513, '2017-02-09 12:02:43', NULL, NULL, 6685, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 12:02:43', 'admin-1486608082-1486612963210899', 1, 0, '', NULL, NULL, NULL),
(19514, '2017-02-09 13:24:58', NULL, NULL, 6688, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 13:24:58', 'admin-1486608082-14866178983545847', 1, 0, '', NULL, NULL, NULL),
(19515, '2017-02-09 13:26:15', NULL, NULL, 6688, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 13:26:15', 'admin-1486608082-14866179752181044', 1, 1, 'SR', NULL, NULL, NULL),
(19516, '2017-02-09 13:24:27', NULL, NULL, 6687, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 13:24:27', 'admin-1486608082-14866178676092578', 1, 1, 'SR', NULL, NULL, NULL),
(19517, '2017-02-09 13:24:27', NULL, NULL, 6687, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 13:24:27', 'admin-1486608082-14866178676092578', 1, 1, 'SR', NULL, NULL, NULL),
(19518, '2017-02-09 13:24:27', NULL, NULL, 6687, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 13:24:27', 'admin-1486608082-14866178676092578', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(19519, '2017-02-09 13:07:30', NULL, NULL, 6686, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 13:07:30', 'admin-1486608082-1486616850064819', 1, 1, 'SR', 1, NULL, NULL),
(19520, '2017-02-09 12:30:19', NULL, NULL, 6685, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 12:30:19', 'admin-1486608082-14866146188179159', 1, 0, '', NULL, NULL, NULL),
(19521, '2017-02-09 12:18:55', NULL, NULL, 6683, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 12:18:55', 'admin-1486608082-1486613935654390', 1, 1, 'SR', NULL, NULL, NULL),
(19522, '2017-02-09 12:02:43', NULL, NULL, 6685, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 12:02:43', 'admin-1486608082-1486612963210899', 1, 1, 'SR', NULL, NULL, NULL),
(19523, '2017-02-09 12:02:43', NULL, NULL, 6685, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 12:02:43', 'admin-1486608082-1486612963210899', 1, 1, 'SR', NULL, NULL, NULL),
(19524, '2017-02-09 12:02:43', NULL, NULL, 6685, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 12:02:43', 'admin-1486608082-1486612963210899', 1, 0, '', NULL, NULL, NULL),
(19525, '2017-02-09 11:53:20', NULL, NULL, 6684, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 11:53:20', 'admin-1486608082-14866124007105454', 1, 1, 'SR', NULL, NULL, NULL),
(19526, '2017-02-09 11:51:30', NULL, NULL, 6683, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 11:51:30', 'admin-1486608082-1486612290035857', 1, 0, '', NULL, NULL, NULL),
(19527, '2017-02-09 11:46:16', NULL, NULL, 6683, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 11:46:16', 'admin-1486608082-14866119765906245', 1, 1, 'SR', NULL, NULL, NULL),
(19528, '2017-02-09 11:46:16', NULL, NULL, 6683, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 11:46:16', 'admin-1486608082-14866119765906245', 1, 1, 'SR', NULL, NULL, NULL),
(19529, '2017-02-09 10:41:00', NULL, NULL, 6682, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 10:41:00', 'admin-1486602045-14866080600809591', 1, 0, '', NULL, NULL, NULL),
(19530, '2017-02-09 10:38:55', NULL, NULL, 6680, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 10:38:55', 'admin-1486602045-14866079348849749', 1, 1, 'SR', NULL, NULL, NULL),
(19531, '2017-02-09 10:39:43', NULL, NULL, 6681, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 10:39:43', 'admin-1486602045-14866079830899522', 1, 0, '', NULL, NULL, NULL),
(19532, '2017-02-09 10:39:43', NULL, NULL, 6681, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 10:39:43', 'admin-1486602045-14866079830899522', 1, 0, '', NULL, NULL, NULL),
(19533, '2017-02-09 10:41:00', NULL, NULL, 6682, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 10:41:00', 'admin-1486602045-14866080600809591', 1, 0, '', NULL, NULL, NULL),
(19534, '2017-02-09 10:38:55', NULL, NULL, 6680, NULL, 2, '2', 'Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 10:38:55', 'admin-1486602045-14866079348849749', 1, 1, 'SR', NULL, NULL, NULL),
(19535, '2017-02-09 10:38:43', NULL, NULL, 6680, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 10:38:43', 'admin-1486602045-1486607923557529', 1, 0, '', NULL, NULL, NULL),
(19536, '2017-02-09 09:55:05', NULL, NULL, 6678, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 09:55:05', 'admin-1486602045-14866053051456719', 1, 1, 'SR', NULL, NULL, NULL),
(19537, '2017-02-09 09:05:38', NULL, NULL, 6676, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 09:05:38', 'admin-1486602045-1486602338049625', 1, 0, '', NULL, NULL, NULL),
(19538, '2017-02-09 09:11:38', NULL, NULL, 6677, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 09:11:38', 'admin-1486602045-14866026979725349', 1, 1, 'SR', NULL, NULL, NULL),
(19539, '2017-02-09 09:11:38', NULL, NULL, 6677, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 09:11:38', 'admin-1486602045-14866026979725349', 1, 1, 'SR', NULL, NULL, NULL),
(19540, '2017-02-09 09:18:31', NULL, NULL, 6677, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 09:18:31', 'admin-1486602045-14866031115365387', 1, 1, 'SR', NULL, NULL, NULL),
(19541, '2017-02-09 09:55:05', NULL, NULL, 6678, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 09:55:05', 'admin-1486602045-14866053051456719', 1, 1, 'SR', NULL, NULL, NULL),
(19542, '2017-02-09 09:54:49', NULL, NULL, 6678, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 09:54:49', 'admin-1486602045-14866052894671778', 1, 0, '', NULL, NULL, NULL),
(19543, '2017-02-09 10:38:43', NULL, NULL, 6680, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 10:38:43', 'admin-1486602045-1486607923557529', 1, 0, '', NULL, NULL, NULL),
(19544, '2017-02-09 10:00:55', NULL, NULL, 6677, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 10:00:55', 'admin-1486602045-14866056552512350', 1, 0, '', NULL, NULL, NULL),
(19545, '2017-02-09 09:54:49', NULL, NULL, 6678, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 09:54:49', 'admin-1486602045-14866052894671778', 1, 0, '', NULL, NULL, NULL),
(19546, '2017-02-09 09:18:31', NULL, NULL, 6677, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 09:18:31', 'admin-1486602045-14866031115365387', 1, 0, '', NULL, NULL, NULL),
(19547, '2017-02-09 09:05:28', NULL, NULL, 6676, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 09:05:28', 'admin-1486602045-14866023282978959', 1, 0, '', NULL, NULL, NULL),
(19548, '2017-02-09 09:18:31', NULL, NULL, 6677, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 09:18:31', 'admin-1486602045-14866031115365387', 1, 0, '', NULL, NULL, NULL),
(19549, '2017-02-09 09:18:31', NULL, NULL, 6677, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 09:18:31', 'admin-1486602045-14866031115365387', 1, 0, '', NULL, NULL, NULL),
(19550, '2017-02-09 09:05:38', NULL, NULL, 6676, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 09:05:38', 'admin-1486602045-1486602338049625', 1, 1, 'SR', NULL, NULL, NULL),
(19551, '2017-02-09 09:05:38', NULL, NULL, 6676, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 09:05:38', 'admin-1486602045-1486602338049625', 1, 1, 'SR', NULL, NULL, NULL),
(19552, '2017-02-09 09:05:28', NULL, NULL, 6676, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486625682', 'admin', '2017-02-09 09:05:28', 'admin-1486602045-14866023282978959', 1, 0, '', NULL, NULL, NULL),
(19553, '2017-02-10 14:25:01', NULL, NULL, 6711, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 14:25:01', 'admin-1486705713-14867079014012865', 1, 1, 'SR', NULL, NULL, NULL),
(19554, '2017-02-10 14:25:01', NULL, NULL, 6711, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 14:25:01', 'admin-1486705713-14867079014012865', 1, 1, 'SR', NULL, NULL, NULL),
(19555, '2017-02-10 14:25:01', NULL, NULL, 6711, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 14:25:01', 'admin-1486705713-14867079014012865', 1, 0, '', NULL, NULL, NULL),
(19556, '2017-02-10 15:09:21', NULL, NULL, 6712, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 15:09:21', 'admin-1486705713-14867105613323837', 1, 0, '', 1, NULL, '10.0'),
(19557, '2017-02-10 16:21:43', NULL, NULL, 6713, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 16:21:43', 'admin-1486705713-14867149029084196', 1, 1, 'SR', NULL, NULL, NULL),
(19558, '2017-02-10 16:21:43', NULL, NULL, 6713, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 16:21:43', 'admin-1486705713-14867149029084196', 1, 0, '', NULL, NULL, NULL),
(19559, '2017-02-10 16:49:46', NULL, NULL, 6714, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 16:49:46', 'admin-1486705713-14867165859255357', 1, 1, 'SR', NULL, NULL, NULL),
(19560, '2017-02-10 16:49:46', NULL, NULL, 6714, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 16:49:46', 'admin-1486705713-14867165859255357', 1, 0, '', NULL, NULL, NULL),
(19561, '2017-02-10 16:49:46', NULL, NULL, 6714, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 16:49:46', 'admin-1486705713-14867165859255357', 1, 0, '', NULL, NULL, NULL),
(19562, '2017-02-10 17:27:09', NULL, NULL, 6715, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 17:27:09', 'admin-1486705713-14867188293108756', 1, 0, '', NULL, NULL, NULL),
(19563, '2017-02-10 13:48:28', NULL, NULL, 6710, 0, 82, '82', 'Set Stir Fried Rice Wine Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 13:48:28', 'admin-1486694545-14867057085845281', 1, 1, 'SR', NULL, NULL, NULL),
(19564, '2017-02-10 14:25:01', NULL, NULL, 6711, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 14:25:01', 'admin-1486705713-14867079014012865', 1, 1, 'SR', NULL, NULL, NULL),
(19565, '2017-02-10 17:27:09', NULL, NULL, 6715, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 17:27:09', 'admin-1486705713-14867188293108756', 1, 1, 'SR', NULL, NULL, NULL),
(19566, '2017-02-10 10:16:23', NULL, NULL, 6701, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 10:16:23', 'admin-1486688167-14866929833867261', 1, 0, '', NULL, NULL, NULL),
(19567, '2017-02-10 10:16:42', NULL, NULL, 6701, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 10:16:42', 'admin-1486688167-14866930020969295', 1, 1, 'SR', NULL, NULL, NULL),
(19568, '2017-02-10 10:16:42', NULL, NULL, 6701, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 10:16:42', 'admin-1486688167-14866930020969295', 1, 1, 'SR', NULL, NULL, NULL),
(19569, '2017-02-10 10:16:42', NULL, NULL, 6701, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 10:16:42', 'admin-1486688167-14866930020969295', 1, 0, '', NULL, NULL, NULL),
(19570, '2017-02-10 12:53:53', NULL, NULL, 6706, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 12:53:53', 'admin-1486694545-14867024336649931', 1, 0, '', NULL, NULL, NULL),
(19571, '2017-02-10 11:43:01', NULL, NULL, 6704, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 11:43:01', 'admin-1486694545-14866981815995184', 1, 0, '', NULL, NULL, NULL),
(19572, '2017-02-10 13:28:53', NULL, NULL, 6709, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 13:28:53', 'admin-1486694545-14867045336791124', 1, 0, '', NULL, NULL, NULL),
(19573, '2017-02-10 13:48:28', NULL, NULL, 6710, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 13:48:28', 'admin-1486694545-14867057085845281', 1, 0, '', NULL, NULL, NULL),
(19574, '2017-02-10 12:02:07', NULL, NULL, 6707, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 12:02:07', 'admin-1486694545-14866993268832823', 1, 1, 'SR', NULL, NULL, NULL),
(19575, '2017-02-10 12:03:21', NULL, NULL, 6708, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 12:03:21', 'admin-1486694545-1486699401603183', 1, 1, 'SR', NULL, NULL, NULL),
(19576, '2017-02-10 12:25:32', NULL, NULL, 6706, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 12:25:32', 'admin-1486694545-14867007327197557', 1, 1, 'SR', NULL, NULL, NULL),
(19577, '2017-02-10 12:33:45', NULL, NULL, 6707, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 12:33:45', 'admin-1486694545-1486701224921735', 1, 1, 'SR', NULL, NULL, NULL),
(19578, '2017-02-10 12:52:03', NULL, NULL, 6704, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 12:52:03', 'admin-1486694545-14867023233058744', 1, 1, 'SR', NULL, NULL, NULL),
(19579, '2017-02-10 11:52:20', NULL, NULL, 6705, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 11:52:20', 'admin-1486694545-14866987400171277', 1, 1, 'SR', NULL, NULL, NULL),
(19580, '2017-02-10 11:59:13', NULL, NULL, 6706, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 11:59:13', 'admin-1486694545-14866991531056391', 1, 1, 'SR', NULL, NULL, NULL),
(19581, '2017-02-10 12:02:07', NULL, NULL, 6707, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 12:02:07', 'admin-1486694545-14866993268832823', 1, 0, '', NULL, NULL, NULL),
(19582, '2017-02-10 11:52:20', NULL, NULL, 6705, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 11:52:20', 'admin-1486694545-14866987400171277', 1, 1, 'SR', NULL, NULL, NULL),
(19583, '2017-02-10 11:52:20', NULL, NULL, 6705, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 11:52:20', 'admin-1486694545-14866987400171277', 1, 1, 'SR', NULL, NULL, NULL),
(19584, '2017-02-10 11:52:20', NULL, NULL, 6705, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 11:52:20', 'admin-1486694545-14866987400171277', 1, 0, '', NULL, NULL, NULL),
(19585, '2017-02-10 11:43:31', NULL, NULL, 6704, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 11:43:31', 'admin-1486694545-14866982112943036', 1, 1, 'SR', NULL, NULL, NULL),
(19586, '2017-02-10 11:43:31', NULL, NULL, 6704, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 11:43:31', 'admin-1486694545-14866982112943036', 1, 1, 'SR', NULL, NULL, NULL),
(19587, '2017-02-10 11:43:01', NULL, NULL, 6704, 0, 158, '92', 'Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 11:43:01', 'admin-1486694545-14866981815995184', 1, 0, '', NULL, NULL, NULL),
(19588, '2017-02-10 11:30:00', NULL, NULL, 6703, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 11:30:00', 'admin-1486694545-14866974001332390', 1, 1, 'SR', NULL, NULL, NULL),
(19589, '2017-02-10 11:30:00', NULL, NULL, 6703, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 11:30:00', 'admin-1486694545-14866974001332390', 1, 1, 'SR', NULL, NULL, NULL),
(19590, '2017-02-10 11:30:00', NULL, NULL, 6703, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 11:30:00', 'admin-1486694545-14866974001332390', 1, 1, 'SR', NULL, NULL, NULL),
(19591, '2017-02-10 09:25:11', NULL, NULL, 6699, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 09:25:11', 'admin-1486688167-14866899117468388', 1, 0, '', NULL, NULL, NULL),
(19592, '2017-02-10 10:20:45', NULL, NULL, 6702, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 10:20:45', 'admin-1486688167-14866932455215529', 1, 0, '', NULL, NULL, NULL),
(19593, '2017-02-10 10:20:45', NULL, NULL, 6702, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 10:20:45', 'admin-1486688167-14866932455215529', 1, 0, '', NULL, NULL, NULL),
(19594, '2017-02-10 10:20:58', NULL, NULL, 6702, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 10:20:58', 'admin-1486688167-14866932585507944', 1, 1, 'SR', NULL, NULL, NULL),
(19595, '2017-02-10 10:20:58', NULL, NULL, 6702, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 10:20:58', 'admin-1486688167-14866932585507944', 1, 1, 'SR', NULL, NULL, NULL),
(19596, '2017-02-10 10:20:58', NULL, NULL, 6702, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 10:20:58', 'admin-1486688167-14866932585507944', 1, 1, 'SR', NULL, NULL, NULL),
(19597, '2017-02-10 10:24:58', NULL, NULL, 6702, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 10:24:58', 'admin-1486688167-1486693498627190', 1, 0, '', NULL, NULL, NULL),
(19598, '2017-02-10 10:24:58', NULL, NULL, 6702, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 10:24:58', 'admin-1486688167-1486693498627190', 1, 1, 'SR', NULL, NULL, NULL),
(19599, '2017-02-10 09:21:51', NULL, NULL, 6698, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 09:21:51', 'admin-1486688167-14866897111351533', 1, 0, '', NULL, NULL, NULL),
(19600, '2017-02-10 09:22:03', NULL, NULL, 6698, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 09:22:03', 'admin-1486688167-14866897237172725', 1, 1, 'SR', NULL, NULL, NULL),
(19601, '2017-02-10 09:22:03', NULL, NULL, 6698, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 09:22:03', 'admin-1486688167-14866897237172725', 1, 1, 'SR', NULL, NULL, NULL),
(19602, '2017-02-10 09:23:00', NULL, NULL, 6699, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 09:23:00', 'admin-1486688167-1486689779894172', 1, 1, 'SR', NULL, NULL, NULL),
(19603, '2017-02-10 09:23:00', NULL, NULL, 6699, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 09:23:00', 'admin-1486688167-1486689779894172', 1, 1, 'SR', NULL, NULL, NULL),
(19604, '2017-02-10 11:30:00', NULL, NULL, 6703, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 11:30:00', 'admin-1486694545-14866974001332390', 1, 0, '', NULL, NULL, NULL),
(19605, '2017-02-10 11:30:00', NULL, NULL, 6703, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 11:30:00', 'admin-1486694545-14866974001332390', 1, 0, '', NULL, NULL, NULL),
(19606, '2017-02-10 09:25:11', NULL, NULL, 6699, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 09:25:11', 'admin-1486688167-14866899117468388', 1, 0, '', NULL, NULL, NULL),
(19607, '2017-02-10 10:16:23', NULL, NULL, 6701, 0, 153, '87', 'Big Breakfast ', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 10:16:23', 'admin-1486688167-14866929833867261', 1, 0, '', NULL, NULL, NULL),
(19608, '2017-02-10 09:25:11', NULL, NULL, 6699, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 09:25:11', 'admin-1486688167-14866899117468388', 1, 0, '', NULL, NULL, NULL),
(19609, '2017-02-10 09:25:11', NULL, NULL, 6699, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 09:25:11', 'admin-1486688167-14866899117468388', 1, 0, '', NULL, NULL, NULL),
(19610, '2017-02-10 09:24:13', NULL, NULL, 6700, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 09:24:13', 'admin-1486688167-14866898535981421', 1, 1, 'SR', NULL, NULL, NULL),
(19611, '2017-02-10 09:24:13', NULL, NULL, 6700, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 09:24:13', 'admin-1486688167-14866898535981421', 1, 1, 'SR', NULL, NULL, NULL),
(19612, '2017-02-10 09:24:13', NULL, NULL, 6700, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 09:24:13', 'admin-1486688167-14866898535981421', 1, 0, '', NULL, NULL, NULL),
(19613, '2017-02-10 09:24:13', NULL, NULL, 6700, 0, 154, '88', 'House BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 09:24:13', 'admin-1486688167-14866898535981421', 1, 0, '', NULL, NULL, NULL),
(19614, '2017-02-10 09:23:22', NULL, NULL, 6699, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 09:23:22', 'admin-1486688167-14866898024916752', 1, 1, 'SR', NULL, NULL, NULL),
(19615, '2017-02-10 09:21:51', NULL, NULL, 6698, 0, 156, '90', 'Cheese Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486705713', 'admin', '2017-02-10 09:21:51', 'admin-1486688167-14866897111351533', 1, 0, '', NULL, NULL, NULL),
(19616, '2017-02-11 20:50:50', NULL, NULL, 6769, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 20:50:50', 'admin-1486807745-14868174500628526', 1, 0, '', NULL, NULL, NULL),
(19617, '2017-02-11 20:36:25', NULL, NULL, 6763, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 20:36:25', 'admin-1486807745-14868165848079078', 1, 1, 'SR', NULL, NULL, NULL),
(19618, '2017-02-11 20:08:45', NULL, NULL, 6765, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 20:08:45', 'admin-1486807745-14868149249905167', 1, 1, 'SR', NULL, NULL, '10.0'),
(19619, '2017-02-11 19:44:27', NULL, NULL, 6769, 0, 181, '116', 'Open Food ', 'Tomyam fried rice', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 19:44:27', 'admin-1486807745-1486813467143363', 1, 0, '', NULL, NULL, NULL),
(19620, '2017-02-11 20:03:00', NULL, NULL, 6770, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1486807745', 'admin', '2017-02-11 20:03:00', 'admin-1486807745-14868145803407170', 1, 0, '', 1, NULL, NULL),
(19621, '2017-02-11 00:00:00', NULL, NULL, 6757, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 17:00:24', 'admin-1486791391-14868036245342615', 1, 0, '', NULL, NULL, NULL),
(19622, '2017-02-11 17:39:15', NULL, NULL, 6758, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1486807745', 'admin', '2017-02-11 17:39:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19623, '2017-02-11 17:39:21', NULL, NULL, 6758, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 17:39:21', 'admin-1486791391-14868059608588796', 1, 0, '', NULL, NULL, NULL),
(19624, '2017-02-11 17:47:51', NULL, NULL, 6759, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1486807745', 'admin', '2017-02-11 17:47:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19625, '2017-02-11 17:48:03', NULL, NULL, 6759, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 17:48:03', 'admin-1486791391-14868064829541999', 1, 1, 'SR', NULL, NULL, NULL),
(19626, '2017-02-11 17:51:31', NULL, NULL, 6760, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1486807745', 'admin', '2017-02-11 17:51:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19627, '2017-02-11 17:53:17', NULL, NULL, 6760, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 17:53:17', 'admin-1486791391-14868067977692483', 1, 1, 'SR', NULL, NULL, NULL),
(19628, '2017-02-11 17:53:17', NULL, NULL, 6760, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 17:53:17', 'admin-1486791391-14868067977692483', 1, 0, '', NULL, NULL, NULL),
(19629, '2017-02-11 17:53:17', NULL, NULL, 6760, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 17:53:17', 'admin-1486791391-14868067977692483', 1, 1, 'SR', NULL, NULL, NULL),
(19630, '2017-02-11 17:53:17', NULL, NULL, 6760, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 17:53:17', 'admin-1486791391-14868067977692483', 1, 1, 'SR', NULL, NULL, NULL),
(19631, '2017-02-11 18:05:30', NULL, NULL, 6761, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1486807745', 'admin', '2017-02-11 18:05:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19632, '2017-02-11 18:05:46', NULL, NULL, 6761, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 18:05:46', 'admin-1486791391-14868075463045114', 1, 1, 'SR', NULL, NULL, NULL),
(19633, '2017-02-11 18:05:56', NULL, NULL, 6761, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 18:05:56', 'admin-1486791391-14868075560594960', 1, 1, 'SR', NULL, NULL, NULL),
(19634, '2017-02-11 18:07:16', NULL, NULL, 6760, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 18:07:16', 'admin-1486791391-14868076365034784', 1, 0, '', NULL, NULL, NULL),
(19635, '2017-02-11 18:09:39', NULL, NULL, 6748, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 18:09:39', 'admin-1486807745-14868077797172518', 1, 0, '', NULL, NULL, NULL),
(19636, '2017-02-11 18:19:20', NULL, NULL, 6762, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1486807745', 'admin', '2017-02-11 18:19:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19637, '2017-02-11 18:19:29', NULL, NULL, 6762, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 18:19:29', 'admin-1486807745-14868083695294121', 1, 1, 'SR', NULL, NULL, NULL),
(19638, '2017-02-11 18:41:06', NULL, NULL, 6763, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1486807745', 'admin', '2017-02-11 18:41:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19639, '2017-02-11 16:30:03', NULL, NULL, 6745, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:30:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19640, '2017-02-11 16:30:09', NULL, NULL, 6745, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:30:09', 'admin-1486791391-14868018090519453', 1, 1, 'SR', NULL, NULL, NULL),
(19641, '2017-02-11 16:31:06', NULL, NULL, 6748, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:31:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19642, '2017-02-11 16:31:28', NULL, NULL, 6748, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:31:28', 'admin-1486791391-14868018887395857', 1, 1, 'SR', NULL, NULL, NULL),
(19643, '2017-02-11 16:31:29', NULL, NULL, 6748, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:31:29', 'admin-1486791391-14868018887395857', 1, 0, '', NULL, NULL, NULL),
(19644, '2017-02-11 16:31:29', NULL, NULL, 6748, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:31:29', 'admin-1486791391-14868018887395857', 1, 0, '', NULL, NULL, NULL),
(19645, '2017-02-11 16:31:29', NULL, NULL, 6748, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:31:29', 'admin-1486791391-14868018887395857', 1, 1, 'SR', NULL, NULL, NULL),
(19646, '2017-02-11 16:31:29', NULL, NULL, 6748, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:31:29', 'admin-1486791391-14868018887395857', 1, 1, 'SR', NULL, NULL, NULL),
(19647, '2017-02-11 16:32:25', NULL, NULL, 6750, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:32:25', 'admin-1486791391-14868019456191884', 1, 0, '', 1, NULL, NULL),
(19648, '2017-02-11 16:35:18', NULL, NULL, 6751, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:35:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19649, '2017-02-11 16:35:32', NULL, NULL, 6751, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:35:32', 'admin-1486791391-14868021325958488', 1, 1, 'SR', NULL, NULL, NULL),
(19650, '2017-02-11 16:35:32', NULL, NULL, 6751, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:35:32', 'admin-1486791391-14868021325958488', 1, 1, 'SR', NULL, NULL, NULL),
(19651, '2017-02-11 16:35:32', NULL, NULL, 6751, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:35:32', 'admin-1486791391-14868021325958488', 1, 1, 'SR', NULL, NULL, NULL),
(19652, '2017-02-11 16:35:32', NULL, NULL, 6751, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:35:32', 'admin-1486791391-14868021325958488', 1, 0, '', NULL, NULL, NULL),
(19653, '2017-02-11 16:35:32', NULL, NULL, 6751, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:35:32', 'admin-1486791391-14868021325958488', 1, 1, 'SR', NULL, NULL, NULL),
(19654, '2017-02-11 16:45:55', NULL, NULL, 6752, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:45:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19655, '2017-02-11 16:46:16', NULL, NULL, 6752, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:46:16', 'admin-1486791391-14868027764293280', 1, 0, '', NULL, NULL, NULL),
(19656, '2017-02-11 16:52:15', NULL, NULL, 6738, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:52:15', 'admin-1486791391-14868031351473782', 1, 1, 'SR', NULL, NULL, NULL),
(19657, '2017-02-11 00:00:00', NULL, NULL, 6757, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, NULL, NULL, 1.60, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:59:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19658, '2017-02-11 00:00:00', NULL, NULL, 6757, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 17:00:24', 'admin-1486791391-14868036245342615', 1, 0, '', NULL, NULL, NULL),
(19659, '2017-02-11 14:22:42', NULL, NULL, 6736, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1486807745', 'admin', '2017-02-11 14:22:42', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(19660, '2017-02-11 14:22:50', NULL, NULL, 6736, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 14:22:50', 'admin-1486791391-14867941702094340', 1, 0, '', NULL, NULL, '10.0'),
(19661, '2017-02-11 18:55:39', NULL, NULL, 6764, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 18:55:39', 'admin-1486807745-14868105392933196', 1, 0, '', NULL, NULL, NULL),
(19662, '2017-02-11 18:55:39', NULL, NULL, 6764, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 18:55:39', 'admin-1486807745-14868105392933196', 1, 0, '', NULL, NULL, NULL),
(19663, '2017-02-11 18:55:39', NULL, NULL, 6764, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 18:55:39', 'admin-1486807745-14868105392933196', 1, 0, '', NULL, NULL, NULL),
(19664, '2017-02-11 18:55:59', NULL, NULL, 6764, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 18:55:59', 'admin-1486807745-14868105592982384', 1, 0, '', NULL, NULL, NULL),
(19665, '2017-02-11 18:57:08', NULL, NULL, 6765, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 18:57:08', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(19666, '2017-02-11 18:57:19', NULL, NULL, 6765, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 18:57:19', 'admin-1486807745-14868106395087547', 1, 0, '', NULL, NULL, '10.0'),
(19667, '2017-02-11 17:17:37', NULL, NULL, 6755, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1486807745', 'admin', '2017-02-11 17:17:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19668, '2017-02-11 14:04:19', NULL, NULL, 6733, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 14:04:19', 'admin-1486791391-1486793059327221', 1, 1, 'SR', NULL, NULL, NULL),
(19669, '2017-02-11 13:33:23', NULL, NULL, 6732, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:33:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19670, '2017-02-11 13:30:24', NULL, NULL, 6729, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:30:24', 'admin-1486781920-14867910243742788', 1, 0, '', NULL, NULL, NULL),
(19671, '2017-02-11 12:31:29', NULL, NULL, 6729, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:31:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19672, '2017-02-11 12:32:01', NULL, NULL, 6729, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:32:01', 'admin-1486781920-14867875215278115', 1, 1, 'SR', NULL, NULL, NULL),
(19673, '2017-02-11 12:32:01', NULL, NULL, 6729, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:32:01', 'admin-1486781920-14867875215278115', 1, 0, '', NULL, NULL, NULL),
(19674, '2017-02-11 12:32:18', NULL, NULL, 6729, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:32:18', 'admin-1486781920-14867875384917747', 1, 1, 'SR', NULL, NULL, NULL),
(19675, '2017-02-11 12:32:18', NULL, NULL, 6729, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:32:18', 'admin-1486781920-14867875384917747', 1, 0, '', NULL, NULL, NULL),
(19676, '2017-02-11 12:41:03', NULL, NULL, 6729, 0, 156, '90', 'House Cheddar Omelet', ' extra vege,no bread', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:41:03', 'admin-1486781920-14867880628886491', 1, 0, '', NULL, NULL, NULL),
(19677, '2017-02-11 12:48:53', NULL, NULL, 6730, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:48:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19678, '2017-02-11 12:49:03', NULL, NULL, 6730, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:49:03', 'admin-1486781920-14867885434802295', 1, 0, '', NULL, NULL, NULL),
(19679, '2017-02-11 12:49:03', NULL, NULL, 6730, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:49:03', 'admin-1486781920-14867885434802295', 1, 1, 'SR', NULL, NULL, NULL),
(19680, '2017-02-11 12:49:03', NULL, NULL, 6730, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:49:03', 'admin-1486781920-14867885434802295', 1, 0, '', NULL, NULL, NULL),
(19681, '2017-02-11 12:57:49', NULL, NULL, 6729, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:57:49', 'admin-1486781920-14867890692336746', 1, 0, '', NULL, NULL, NULL),
(19682, '2017-02-11 19:45:49', NULL, NULL, 6769, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 19:45:49', 'admin-1486807745-14868135489817185', 1, 1, 'SR', NULL, NULL, NULL),
(19683, '2017-02-11 19:44:27', NULL, NULL, 6769, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 19:44:27', 'admin-1486807745-1486813467143363', 1, 0, '', NULL, NULL, NULL),
(19684, '2017-02-11 19:44:06', NULL, NULL, 6769, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1486807745', 'admin', '2017-02-11 19:44:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19685, '2017-02-11 19:44:27', NULL, NULL, 6769, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 19:44:27', 'admin-1486807745-1486813467143363', 1, 1, 'SR', NULL, NULL, NULL),
(19686, '2017-02-11 19:16:23', NULL, NULL, 6767, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 19:16:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19687, '2017-02-11 19:16:30', NULL, NULL, 6767, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 19:16:30', 'admin-1486807745-14868117904624759', 1, 1, 'SR', NULL, NULL, NULL),
(19688, '2017-02-11 19:37:34', NULL, NULL, 6768, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1486807745', 'admin', '2017-02-11 19:37:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19689, '2017-02-11 19:37:42', NULL, NULL, 6768, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 19:37:42', 'admin-1486807745-1486813061864557', 1, 1, 'SR', NULL, NULL, NULL),
(19690, '2017-02-11 19:45:49', NULL, NULL, 6769, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 19:45:49', 'admin-1486807745-14868135489817185', 1, 0, '', NULL, NULL, NULL),
(19691, '2017-02-11 18:58:47', NULL, NULL, 6766, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 18:58:47', 'admin-1486807745-14868107270743592', 1, 1, 'SR', NULL, NULL, NULL),
(19692, '2017-02-11 18:58:47', NULL, NULL, 6766, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 18:58:47', 'admin-1486807745-14868107270743592', 1, 1, 'SR', NULL, NULL, NULL),
(19693, '2017-02-11 17:18:37', NULL, NULL, 6755, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 17:18:37', 'admin-1486791391-14868047173928679', 1, 1, 'SR', NULL, NULL, NULL),
(19694, '2017-02-11 18:55:13', NULL, NULL, 6764, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1486807745', 'admin', '2017-02-11 18:55:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19695, '2017-02-11 18:41:11', NULL, NULL, 6763, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 18:41:11', 'admin-1486807745-14868096715976319', 1, 1, 'SR', NULL, NULL, NULL),
(19696, '2017-02-11 12:06:21', NULL, NULL, 6728, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:06:21', 'admin-1486781920-14867859808222626', 1, 0, '', NULL, NULL, NULL),
(19697, '2017-02-11 18:58:28', NULL, NULL, 6766, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1486807745', 'admin', '2017-02-11 18:58:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19698, '2017-02-11 17:37:56', NULL, NULL, 6756, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1486807745', 'admin', '2017-02-11 17:37:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19699, '2017-02-11 00:00:00', NULL, NULL, 6756, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 17:00:24', 'admin-1486791391-14868036245342615', 1, 1, 'SR', NULL, NULL, NULL),
(19700, '2017-02-11 17:13:02', NULL, NULL, 6754, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1486807745', 'admin', '2017-02-11 17:13:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19701, '2017-02-11 17:13:07', NULL, NULL, 6754, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 17:13:07', 'admin-1486791391-14868043871578783', 1, 1, 'SR', NULL, NULL, NULL),
(19702, '2017-02-11 00:00:00', NULL, NULL, 6756, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 4.00, NULL, NULL, 4.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 17:09:22', 'admin-1486791391-14868041621012072', 1, 0, '', NULL, NULL, NULL),
(19703, '2017-02-11 17:18:37', NULL, NULL, 6755, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 17:18:37', 'admin-1486791391-14868047173928679', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(19704, '2017-02-11 17:13:07', NULL, NULL, 6754, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 17:13:07', 'admin-1486791391-14868043871578783', 1, 1, 'SR', NULL, NULL, NULL),
(19705, '2017-02-11 17:18:37', NULL, NULL, 6755, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 17:18:37', 'admin-1486791391-14868047173928679', 1, 1, 'SR', NULL, NULL, NULL),
(19706, '2017-02-11 14:50:55', NULL, NULL, 6738, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 14:50:55', 'admin-1486791391-14867958548905218', 1, 0, '', NULL, NULL, NULL),
(19707, '2017-02-11 15:22:59', NULL, NULL, 6740, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1486807745', 'admin', '2017-02-11 15:22:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19708, '2017-02-11 15:23:21', NULL, NULL, 6740, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 15:23:21', 'admin-1486791391-14867978009842986', 1, 1, 'SR', NULL, NULL, NULL),
(19709, '2017-02-11 15:23:21', NULL, NULL, 6740, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 15:23:21', 'admin-1486791391-14867978009842986', 1, 1, 'SR', NULL, NULL, NULL),
(19710, '2017-02-11 15:23:40', NULL, NULL, 6740, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 15:23:40', 'admin-1486791391-14867978200818250', 1, 1, 'SR', NULL, NULL, NULL),
(19711, '2017-02-11 15:30:01', NULL, NULL, 6741, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 15:30:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19712, '2017-02-11 15:30:10', NULL, NULL, 6741, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 15:30:10', 'admin-1486791391-14867982102108045', 1, 0, '', NULL, NULL, NULL),
(19713, '2017-02-11 15:30:10', NULL, NULL, 6741, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 15:30:10', 'admin-1486791391-14867982102108045', 1, 1, 'SR', NULL, NULL, NULL),
(19714, '2017-02-11 15:30:10', NULL, NULL, 6741, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 15:30:10', 'admin-1486791391-14867982102108045', 1, 1, 'SR', NULL, NULL, NULL),
(19715, '2017-02-11 15:51:06', NULL, NULL, 6742, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1486807745', 'admin', '2017-02-11 15:51:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19716, '2017-02-11 15:51:16', NULL, NULL, 6742, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 15:51:16', 'admin-1486791391-1486799476194986', 1, 1, 'SR', NULL, NULL, NULL),
(19717, '2017-02-11 15:51:16', NULL, NULL, 6742, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 15:51:16', 'admin-1486791391-1486799476194986', 1, 1, 'SR', NULL, NULL, NULL),
(19718, '2017-02-11 16:14:58', NULL, NULL, 6743, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.35, 0.0000, 0.0000, 3.35, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:14:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19719, '2017-02-11 16:17:15', NULL, NULL, 6743, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:17:15', 'admin-1486791391-1486801035323498', 1, 0, '', NULL, NULL, NULL),
(19720, '2017-02-11 16:17:15', NULL, NULL, 6743, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:17:15', 'admin-1486791391-1486801035323498', 1, 1, 'SR', NULL, NULL, NULL),
(19721, '2017-02-11 16:17:15', NULL, NULL, 6743, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:17:15', 'admin-1486791391-1486801035323498', 1, 0, '', NULL, NULL, NULL),
(19722, '2017-02-11 16:25:19', NULL, NULL, 6744, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:25:19', 'admin-1486791391-14868015188534335', 1, 0, '', 1, NULL, '10.0'),
(19723, '2017-02-11 16:26:44', NULL, NULL, 6742, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 16:26:44', 'admin-1486791391-1486801604400832', 1, 0, '', NULL, NULL, NULL),
(19724, '2017-02-11 13:12:17', NULL, NULL, 6731, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:12:17', 'admin-1486781920-14867899378132634', 1, 0, '', NULL, NULL, NULL),
(19725, '2017-02-11 13:04:58', NULL, NULL, 6731, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:04:58', 'admin-1486781920-14867894984974557', 1, 1, 'SR', NULL, NULL, NULL),
(19726, '2017-02-11 13:04:41', NULL, NULL, 6731, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:04:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19727, '2017-02-11 13:04:58', NULL, NULL, 6731, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:04:58', 'admin-1486781920-14867894984974557', 1, 1, 'SR', NULL, NULL, NULL),
(19728, '2017-02-11 12:10:29', NULL, NULL, 6728, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:10:29', 'admin-1486781920-14867862290118456', 1, 1, 'SR', NULL, NULL, NULL),
(19729, '2017-02-11 12:10:29', NULL, NULL, 6728, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:10:29', 'admin-1486781920-14867862290118456', 1, 1, 'SR', NULL, NULL, NULL),
(19730, '2017-02-11 12:14:18', NULL, NULL, 6726, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:14:18', 'admin-1486781920-1486786458633155', 1, 0, '', NULL, NULL, NULL),
(19731, '2017-02-11 12:14:18', NULL, NULL, 6726, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:14:18', 'admin-1486781920-1486786458633155', 1, 0, '', NULL, NULL, NULL),
(19732, '2017-02-11 14:27:56', NULL, NULL, 6739, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 14:27:56', 'admin-1486791391-14867944765164267', 1, 1, 'SR', NULL, NULL, NULL),
(19733, '2017-02-11 14:27:42', NULL, NULL, 6739, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1486807745', 'admin', '2017-02-11 14:27:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19734, '2017-02-11 14:25:54', NULL, NULL, 6738, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1486807745', 'admin', '2017-02-11 14:25:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19735, '2017-02-11 14:25:57', NULL, NULL, 6738, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 14:25:57', 'admin-1486791391-14867943576921694', 1, 1, 'SR', NULL, NULL, NULL),
(19736, '2017-02-11 14:23:57', NULL, NULL, 6737, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 14:23:57', 'admin-1486791391-14867942370821627', 1, 1, 'SR', NULL, NULL, NULL),
(19737, '2017-02-11 14:23:57', NULL, NULL, 6737, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 14:23:57', 'admin-1486791391-14867942370821627', 1, 1, 'SR', NULL, NULL, NULL),
(19738, '2017-02-11 14:23:22', NULL, NULL, 6737, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1486807745', 'admin', '2017-02-11 14:23:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19739, '2017-02-11 14:22:58', NULL, NULL, 6736, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 14:22:58', 'admin-1486791391-14867941786832941', 1, 1, 'SR', NULL, NULL, '10.0'),
(19740, '2017-02-11 14:22:58', NULL, NULL, 6736, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 14:22:58', 'admin-1486791391-14867941786832941', 1, 0, '', NULL, NULL, '10.0'),
(19741, '2017-02-11 13:50:49', NULL, NULL, 6735, 0, 268, '202', 'ICED COCOA CAPPUCINO', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:50:49', 'admin-1486791391-14867922492552085', 1, 0, '', NULL, NULL, NULL),
(19742, '2017-02-11 13:50:49', NULL, NULL, 6735, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:50:49', 'admin-1486791391-14867922492552085', 1, 1, 'SR', NULL, NULL, NULL),
(19743, '2017-02-11 13:50:49', NULL, NULL, 6735, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:50:49', 'admin-1486791391-14867922492552085', 1, 0, '', NULL, NULL, NULL),
(19744, '2017-02-11 13:53:47', NULL, NULL, 6734, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:53:47', 'admin-1486791391-14867924270188674', 1, 0, '', NULL, NULL, NULL),
(19745, '2017-02-11 12:59:30', NULL, NULL, 6730, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:59:30', 'admin-1486781920-1486789169814434', 1, 0, '', NULL, NULL, NULL),
(19746, '2017-02-11 09:10:53', NULL, NULL, 6718, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 09:10:53', 'admin-1486774660-14867754527864449', 1, 0, '', NULL, NULL, NULL),
(19747, '2017-02-11 09:10:53', NULL, NULL, 6718, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 09:10:53', 'admin-1486774660-14867754527864449', 1, 0, '', NULL, NULL, NULL),
(19748, '2017-02-11 09:44:42', NULL, NULL, 6719, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1486807745', 'admin', '2017-02-11 09:44:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19749, '2017-02-11 09:49:25', NULL, NULL, 6719, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 09:49:25', 'admin-1486774660-1486777765348109', 1, 0, '', NULL, NULL, NULL),
(19750, '2017-02-11 09:49:25', NULL, NULL, 6719, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 09:49:25', 'admin-1486774660-1486777765348109', 1, 0, '', NULL, NULL, NULL),
(19751, '2017-02-11 14:22:50', NULL, NULL, 6736, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 14:22:50', 'admin-1486791391-14867941702094340', 1, 0, '', NULL, NULL, '10.0'),
(19752, '2017-02-11 13:50:34', NULL, NULL, 6735, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:50:34', 'admin-1486791391-1486792234523513', 1, 0, '', NULL, NULL, NULL),
(19753, '2017-02-11 13:50:29', NULL, NULL, 6735, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:50:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19754, '2017-02-11 13:48:00', NULL, NULL, 6734, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:48:00', 'admin-1486791391-14867920806473370', 1, 1, 'SR', NULL, NULL, NULL),
(19755, '2017-02-11 13:48:00', NULL, NULL, 6734, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:48:00', 'admin-1486791391-14867920806473370', 1, 0, '', NULL, NULL, NULL),
(19756, '2017-02-11 13:45:56', NULL, NULL, 6726, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:45:56', 'admin-1486791391-14867919560436825', 1, 0, '', NULL, NULL, NULL),
(19757, '2017-02-11 13:48:00', NULL, NULL, 6734, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:48:00', 'admin-1486791391-14867920806473370', 1, 0, '', NULL, NULL, NULL),
(19758, '2017-02-11 13:36:42', NULL, NULL, 6732, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:36:42', 'admin-1486791391-14867914021419339', 1, 0, '', NULL, NULL, NULL),
(19759, '2017-02-11 13:36:23', NULL, NULL, 6732, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:36:23', 'admin-1486781920-14867913832677237', 1, 1, 'SR', NULL, NULL, NULL),
(19760, '2017-02-11 13:34:42', NULL, NULL, 6733, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:34:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19761, '2017-02-11 14:46:32', NULL, NULL, 6734, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 14:46:32', 'admin-1486791391-1486795591961576', 1, 0, '', NULL, NULL, NULL),
(19762, '2017-02-11 13:44:17', NULL, NULL, 6734, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:44:17', 'admin-1486791391-14867918576468268', 1, 1, 'SR', NULL, NULL, NULL),
(19763, '2017-02-11 13:12:18', NULL, NULL, 6731, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:12:18', 'admin-1486781920-14867899378132634', 1, 1, 'SR', NULL, NULL, NULL),
(19764, '2017-02-11 12:59:30', NULL, NULL, 6730, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:59:30', 'admin-1486781920-1486789169814434', 1, 1, 'SR', NULL, NULL, NULL),
(19765, '2017-02-11 12:59:15', NULL, NULL, 6730, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:59:15', 'admin-1486781920-14867891549342515', 1, 0, '', NULL, NULL, NULL),
(19766, '2017-02-11 13:44:17', NULL, NULL, 6734, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:44:17', 'admin-1486791391-14867918576468268', 1, 1, 'SR', NULL, NULL, NULL),
(19767, '2017-02-11 13:36:23', NULL, NULL, 6732, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 13:36:23', 'admin-1486781920-14867913832677237', 1, 1, 'SR', NULL, NULL, NULL),
(19768, '2017-02-11 12:06:21', NULL, NULL, 6728, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:06:21', 'admin-1486781920-14867859808222626', 1, 0, '', NULL, NULL, NULL),
(19769, '2017-02-11 10:58:35', NULL, NULL, 6725, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:58:35', 'admin-1486774660-14867819152134676', 1, 0, '', NULL, NULL, NULL),
(19770, '2017-02-11 10:58:35', NULL, NULL, 6725, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:58:35', 'admin-1486774660-14867819152134676', 1, 0, '', NULL, NULL, NULL),
(19771, '2017-02-11 12:06:21', NULL, NULL, 6728, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:06:21', 'admin-1486781920-14867859808222626', 1, 0, '', NULL, NULL, NULL),
(19772, '2017-02-11 10:58:35', NULL, NULL, 6725, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:58:35', 'admin-1486774660-14867819152134676', 1, 0, '', NULL, NULL, NULL),
(19773, '2017-02-11 10:58:35', NULL, NULL, 6725, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:58:35', 'admin-1486774660-14867819152134676', 1, 0, '', NULL, NULL, NULL),
(19774, '2017-02-11 10:59:50', NULL, NULL, 6725, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:59:50', 'admin-1486781920-14867819907671070', 1, 1, 'SR', NULL, NULL, NULL),
(19775, '2017-02-11 10:59:50', NULL, NULL, 6725, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:59:50', 'admin-1486781920-14867819907671070', 1, 1, 'SR', NULL, NULL, NULL),
(19776, '2017-02-11 10:59:50', NULL, NULL, 6725, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:59:50', 'admin-1486781920-14867819907671070', 1, 1, 'SR', NULL, NULL, NULL),
(19777, '2017-02-11 10:59:50', NULL, NULL, 6725, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:59:50', 'admin-1486781920-14867819907671070', 1, 1, 'SR', NULL, NULL, NULL),
(19778, '2017-02-11 10:59:50', NULL, NULL, 6725, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:59:50', 'admin-1486781920-14867819907671070', 1, 1, 'SR', NULL, NULL, NULL),
(19779, '2017-02-11 11:19:58', NULL, NULL, 6726, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 11:19:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19780, '2017-02-11 11:20:34', NULL, NULL, 6727, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 11:20:34', 'admin-1486781920-14867832342056479', 1, 1, 'SR', 1, NULL, NULL),
(19781, '2017-02-11 11:41:10', NULL, NULL, 6726, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 11:41:10', 'admin-1486781920-14867844699423329', 1, 1, 'SR', NULL, NULL, NULL),
(19782, '2017-02-11 11:41:10', NULL, NULL, 6726, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 11:41:10', 'admin-1486781920-14867844699423329', 1, 1, 'SR', NULL, NULL, NULL),
(19783, '2017-02-11 12:02:58', NULL, NULL, 6728, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:02:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19784, '2017-02-11 12:03:02', NULL, NULL, 6728, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:03:02', 'admin-1486781920-14867857826461077', 1, 1, 'SR', NULL, NULL, NULL),
(19785, '2017-02-11 12:03:02', NULL, NULL, 6728, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:03:02', 'admin-1486781920-14867857826461077', 1, 1, 'SR', NULL, NULL, NULL),
(19786, '2017-02-11 10:58:35', NULL, NULL, 6725, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:58:35', 'admin-1486774660-14867819152134676', 1, 0, '', NULL, NULL, NULL),
(19787, '2017-02-11 10:58:35', NULL, NULL, 6725, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:58:35', 'admin-1486774660-14867819152134676', 1, 0, '', NULL, NULL, NULL),
(19788, '2017-02-11 10:56:22', NULL, NULL, 6725, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.90, 0.0000, 0.0000, 14.90, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:56:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19789, '2017-02-11 10:39:23', NULL, NULL, 6724, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:39:23', 'admin-1486774660-14867807634532459', 1, 1, 'SR', NULL, NULL, NULL),
(19790, '2017-02-11 09:59:58', NULL, NULL, 6720, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1486807745', 'admin', '2017-02-11 09:59:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19791, '2017-02-11 10:00:24', NULL, NULL, 6720, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:00:24', 'admin-1486774660-14867784244215464', 1, 0, '', NULL, NULL, NULL),
(19792, '2017-02-11 10:00:24', NULL, NULL, 6720, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:00:24', 'admin-1486774660-14867784244215464', 1, 0, '', NULL, NULL, NULL),
(19793, '2017-02-11 10:00:24', NULL, NULL, 6720, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:00:24', 'admin-1486774660-14867784244215464', 1, 1, 'SR', NULL, NULL, NULL),
(19794, '2017-02-11 10:12:47', NULL, NULL, 6721, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:12:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19795, '2017-02-11 10:13:19', NULL, NULL, 6721, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:13:19', 'admin-1486774660-14867791991248364', 1, 0, '', NULL, NULL, NULL),
(19796, '2017-02-11 10:13:19', NULL, NULL, 6721, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:13:19', 'admin-1486774660-14867791991248364', 1, 0, '', NULL, NULL, NULL),
(19797, '2017-02-11 10:13:19', NULL, NULL, 6721, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:13:19', 'admin-1486774660-14867791991248364', 1, 1, 'SR', NULL, NULL, NULL),
(19798, '2017-02-11 10:19:45', NULL, NULL, 6722, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:19:45', 'admin-1486774660-14867795852769128', 1, 0, '', 1, NULL, NULL),
(19799, '2017-02-11 10:39:10', NULL, NULL, 6723, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:39:10', 'admin-1486774660-14867807501572832', 1, 0, '', 1, NULL, NULL),
(19800, '2017-02-11 10:39:10', NULL, NULL, 6723, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:39:10', 'admin-1486774660-14867807501572832', 1, 0, '', 1, NULL, NULL),
(19801, '2017-02-11 10:39:10', NULL, NULL, 6723, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:39:10', 'admin-1486774660-14867807501572832', 1, 0, '', 1, NULL, NULL),
(19802, '2017-02-11 10:39:10', NULL, NULL, 6723, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:39:10', 'admin-1486774660-14867807501572832', 1, 0, '', 1, NULL, NULL),
(19803, '2017-02-11 10:39:10', NULL, NULL, 6723, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:39:10', 'admin-1486774660-14867807501572832', 1, 0, '', 1, NULL, NULL),
(19804, '2017-02-11 10:39:15', NULL, NULL, 6724, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:39:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19805, '2017-02-11 10:39:23', NULL, NULL, 6724, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 10:39:23', 'admin-1486774660-14867807634532459', 1, 0, '', NULL, NULL, NULL),
(19806, '2017-02-11 09:49:46', NULL, NULL, 6719, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 09:49:46', 'admin-1486774660-14867777864054128', 1, 1, 'SR', NULL, NULL, NULL),
(19807, '2017-02-11 09:49:46', NULL, NULL, 6719, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 09:49:46', 'admin-1486774660-14867777864054128', 1, 1, 'SR', NULL, NULL, NULL),
(19808, '2017-02-11 09:10:53', NULL, NULL, 6718, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 09:10:53', 'admin-1486774660-14867754527864449', 1, 0, '', NULL, NULL, NULL),
(19809, '2017-02-11 09:10:53', NULL, NULL, 6718, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 09:10:53', 'admin-1486774660-14867754527864449', 1, 1, 'SR', NULL, NULL, NULL),
(19810, '2017-02-11 09:10:53', NULL, NULL, 6718, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 09:10:53', 'admin-1486774660-14867754527864449', 1, 1, 'SR', NULL, NULL, NULL),
(19811, '2017-02-11 09:10:34', NULL, NULL, 6718, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1486807745', 'admin', '2017-02-11 09:10:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19812, '2017-02-11 12:14:18', NULL, NULL, 6726, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 12:14:18', 'admin-1486781920-1486786458633155', 1, 0, '', NULL, NULL, NULL),
(19813, '2017-02-11 09:09:57', NULL, NULL, 6717, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 09:09:57', 'admin-1486774660-14867753971956874', 1, 0, '', NULL, NULL, NULL),
(19814, '2017-02-11 09:09:46', NULL, NULL, 6717, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 09:09:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19815, '2017-02-11 09:09:57', NULL, NULL, 6717, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486807745', 'admin', '2017-02-11 09:09:57', 'admin-1486774660-14867753971956874', 1, 1, 'SR', NULL, NULL, NULL),
(19816, '2017-02-12 15:39:28', NULL, NULL, 6815, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1486880131', 'admin', '2017-02-12 15:39:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19817, '2017-02-12 15:39:57', NULL, NULL, 6815, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 15:39:57', 'admin-1486880131-14868851974348367', 1, 0, '', NULL, NULL, NULL),
(19818, '2017-02-12 15:39:57', NULL, NULL, 6815, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 15:39:57', 'admin-1486880131-14868851974348367', 1, 0, '', NULL, NULL, NULL),
(19819, '2017-02-12 15:39:57', NULL, NULL, 6815, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 15:39:57', 'admin-1486880131-14868851974348367', 1, 1, 'SR', NULL, NULL, NULL),
(19820, '2017-02-12 15:46:26', NULL, NULL, 6816, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1486880131', 'admin', '2017-02-12 15:46:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19821, '2017-02-12 15:46:37', NULL, NULL, 6816, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 15:46:37', 'admin-1486880131-14868855969368193', 1, 1, 'SR', NULL, NULL, NULL),
(19822, '2017-02-12 15:46:37', NULL, NULL, 6816, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 15:46:37', 'admin-1486880131-14868855969368193', 1, 1, 'SR', NULL, NULL, NULL),
(19823, '2017-02-12 15:54:09', NULL, NULL, 6817, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 15:54:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19824, '2017-02-12 15:54:21', NULL, NULL, 6817, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 15:54:21', 'admin-1486880131-14868860617229412', 1, 1, 'SR', NULL, NULL, NULL),
(19825, '2017-02-12 15:54:21', NULL, NULL, 6817, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 15:54:21', 'admin-1486880131-14868860617229412', 1, 1, 'SR', NULL, NULL, NULL),
(19826, '2017-02-12 17:15:08', NULL, NULL, 6820, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1486880131', 'admin', '2017-02-12 17:15:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19827, '2017-02-12 16:00:44', NULL, NULL, 6819, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 16:00:44', 'admin-1486880131-14868864445793099', 1, 1, 'SR', 1, NULL, '10.0'),
(19828, '2017-02-12 16:00:44', NULL, NULL, 6819, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 16:00:44', 'admin-1486880131-14868864445793099', 1, 0, '', 1, NULL, '10.0'),
(19829, '2017-02-12 16:10:22', NULL, NULL, 6805, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 16:10:22', 'admin-1486880131-14868870223714924', 1, 0, '', NULL, NULL, NULL),
(19830, '2017-02-12 16:10:22', NULL, NULL, 6805, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 16:10:22', 'admin-1486880131-14868870223714924', 1, 0, '', NULL, NULL, NULL),
(19831, '2017-02-12 17:15:39', NULL, NULL, 6820, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 17:15:39', 'admin-1486880131-14868909388771022', 1, 1, 'SR', NULL, NULL, NULL),
(19832, '2017-02-12 17:35:46', NULL, NULL, 6821, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1486880131', 'admin', '2017-02-12 17:35:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19833, '2017-02-12 15:13:34', NULL, NULL, 6814, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 15:13:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19834, '2017-02-12 14:24:56', NULL, NULL, 6807, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:24:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19835, '2017-02-12 14:25:23', NULL, NULL, 6807, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:25:23', 'admin-1486880131-1486880723095165', 1, 1, 'SR', NULL, NULL, NULL),
(19836, '2017-02-12 14:25:23', NULL, NULL, 6807, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:25:23', 'admin-1486880131-1486880723095165', 1, 1, 'SR', NULL, NULL, NULL),
(19837, '2017-02-12 14:25:23', NULL, NULL, 6807, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:25:23', 'admin-1486880131-1486880723095165', 1, 1, 'SR', NULL, NULL, NULL),
(19838, '2017-02-12 14:26:05', NULL, NULL, 6808, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:26:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19839, '2017-02-12 14:26:27', NULL, NULL, 6808, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:26:27', 'admin-1486880131-14868807873387188', 1, 0, '', NULL, NULL, NULL),
(19840, '2017-02-12 14:30:25', NULL, NULL, 6809, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:30:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19841, '2017-02-12 14:30:34', NULL, NULL, 6809, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:30:34', 'admin-1486880131-14868810339537428', 1, 0, '', NULL, NULL, NULL),
(19842, '2017-02-12 14:30:34', NULL, NULL, 6809, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:30:34', 'admin-1486880131-14868810339537428', 1, 0, '', NULL, NULL, NULL),
(19843, '2017-02-12 14:30:56', NULL, NULL, 6809, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:30:56', 'admin-1486880131-14868810567157480', 1, 1, 'SR', NULL, NULL, NULL),
(19844, '2017-02-12 14:30:57', NULL, NULL, 6809, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:30:57', 'admin-1486880131-14868810567157480', 1, 0, '', NULL, NULL, NULL),
(19845, '2017-02-12 14:31:40', NULL, NULL, 6810, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:31:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19846, '2017-02-12 00:00:00', NULL, NULL, 6799, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:42:24', 'admin-1486873925-14868745439927156', 1, 0, '', NULL, NULL, NULL),
(19847, '2017-02-12 13:37:47', NULL, NULL, 6800, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1486880131', 'admin', '2017-02-12 13:37:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19848, '2017-02-12 13:37:57', NULL, NULL, 6800, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 13:37:57', 'admin-1486873925-14868778769703613', 1, 1, 'SR', NULL, NULL, NULL),
(19849, '2017-02-12 13:37:57', NULL, NULL, 6800, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 13:37:57', 'admin-1486873925-14868778769703613', 1, 0, '', NULL, NULL, NULL),
(19850, '2017-02-12 13:38:02', NULL, NULL, 6801, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1486880131', 'admin', '2017-02-12 13:38:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19851, '2017-02-12 13:38:22', NULL, NULL, 6801, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 13:38:22', 'admin-1486873925-148687790258092', 1, 1, 'SR', NULL, NULL, NULL),
(19852, '2017-02-12 13:38:22', NULL, NULL, 6801, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 13:38:22', 'admin-1486873925-148687790258092', 1, 0, '', NULL, NULL, NULL),
(19853, '2017-02-12 13:39:22', NULL, NULL, 6802, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 13:39:22', 'admin-1486873925-14868779619786672', 1, 0, '', 1, NULL, '10.0'),
(19854, '2017-02-12 13:48:53', NULL, NULL, 6803, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1486880131', 'admin', '2017-02-12 13:48:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19855, '2017-02-12 13:48:59', NULL, NULL, 6803, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 13:48:59', 'admin-1486873925-14868785394034058', 1, 1, 'SR', NULL, NULL, NULL),
(19856, '2017-02-12 14:09:11', NULL, NULL, 6804, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:09:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19857, '2017-02-12 14:09:25', NULL, NULL, 6804, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:09:25', 'admin-1486873925-14868797652159848', 1, 1, 'SR', NULL, NULL, NULL),
(19858, '2017-02-12 14:10:01', NULL, NULL, 6804, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:10:01', 'admin-1486873925-14868798011123345', 1, 0, '', NULL, NULL, NULL),
(19859, '2017-02-12 14:10:01', NULL, NULL, 6804, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:10:01', 'admin-1486873925-14868798011123345', 1, 0, '', NULL, NULL, NULL),
(19860, '2017-02-12 14:10:01', NULL, NULL, 6804, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:10:01', 'admin-1486873925-14868798011123345', 1, 0, '', NULL, NULL, NULL),
(19861, '2017-02-12 14:10:57', NULL, NULL, 6805, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:10:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19862, '2017-02-12 18:33:21', NULL, NULL, 6822, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1486880131', 'admin', '2017-02-12 18:33:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19863, '2017-02-12 18:33:37', NULL, NULL, 6822, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 18:33:37', 'admin-1486880131-14868956171309432', 1, 1, 'SR', NULL, NULL, NULL),
(19864, '2017-02-12 17:35:53', NULL, NULL, 6821, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 17:35:53', 'admin-1486880131-1486892153510654', 1, 1, 'SR', NULL, NULL, NULL),
(19865, '2017-02-12 17:24:47', NULL, NULL, 6820, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 17:24:47', 'admin-1486880131-1486891486998674', 1, 1, 'SR', NULL, NULL, NULL),
(19866, '2017-02-12 14:15:18', NULL, NULL, 6805, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:15:18', 'admin-1486873925-14868801183137842', 1, 1, 'SR', NULL, NULL, NULL),
(19867, '2017-02-12 14:15:18', NULL, NULL, 6805, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:15:18', 'admin-1486873925-14868801183137842', 1, 1, 'SR', NULL, NULL, NULL),
(19868, '2017-02-12 14:16:58', NULL, NULL, 6804, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:16:58', 'admin-1486880131-14868802179501714', 1, 1, 'SR', NULL, NULL, NULL),
(19869, '2017-02-12 14:18:52', NULL, NULL, 6806, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:18:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19870, '2017-02-12 14:19:07', NULL, NULL, 6806, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:19:07', 'admin-1486880131-1486880346988289', 1, 1, 'SR', NULL, NULL, NULL),
(19871, '2017-02-12 12:32:37', NULL, NULL, 6790, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:32:37', 'admin-1486873925-14868739569724943', 1, 1, 'SR', NULL, NULL, NULL),
(19872, '2017-02-12 17:15:39', NULL, NULL, 6820, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 17:15:39', 'admin-1486880131-14868909388771022', 1, 1, 'SR', NULL, NULL, NULL),
(19873, '2017-02-12 14:51:19', NULL, NULL, 6812, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:51:19', 'admin-1486880131-14868822797182321', 1, 1, 'SR', NULL, NULL, NULL),
(19874, '2017-02-12 14:51:19', NULL, NULL, 6812, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:51:19', 'admin-1486880131-14868822797182321', 1, 0, '', NULL, NULL, NULL),
(19875, '2017-02-12 15:00:21', NULL, NULL, 6790, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 15:00:21', 'admin-1486880131-1486882820819777', 1, 1, 'SR', NULL, NULL, NULL),
(19876, '2017-02-12 14:50:41', NULL, NULL, 6812, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:50:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19877, '2017-02-12 14:51:19', NULL, NULL, 6812, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:51:19', 'admin-1486880131-14868822797182321', 1, 0, '', NULL, NULL, NULL),
(19878, '2017-02-12 14:32:05', NULL, NULL, 6810, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:32:05', 'admin-1486880131-14868811248712357', 1, 0, '', NULL, NULL, NULL),
(19879, '2017-02-12 17:15:39', NULL, NULL, 6820, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 17:15:39', 'admin-1486880131-14868909388771022', 1, 1, 'SR', NULL, NULL, NULL),
(19880, '2017-02-12 17:15:39', NULL, NULL, 6820, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 17:15:39', 'admin-1486880131-14868909388771022', 1, 1, 'SR', NULL, NULL, NULL),
(19881, '2017-02-12 12:17:23', NULL, NULL, 6789, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.90, 0.0000, 0.0000, 13.90, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:17:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19882, '2017-02-12 12:17:58', NULL, NULL, 6789, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:17:58', 'admin-1486869507-14868730777976122', 1, 0, '', NULL, NULL, NULL),
(19883, '2017-02-12 12:17:58', NULL, NULL, 6789, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:17:58', 'admin-1486869507-14868730777976122', 1, 1, 'SR', NULL, NULL, NULL),
(19884, '2017-02-12 12:17:58', NULL, NULL, 6789, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:17:58', 'admin-1486869507-14868730777976122', 1, 1, 'SR', NULL, NULL, NULL),
(19885, '2017-02-12 12:17:58', NULL, NULL, 6789, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:17:58', 'admin-1486869507-14868730777976122', 1, 1, 'SR', NULL, NULL, NULL),
(19886, '2017-02-12 12:18:06', NULL, NULL, 6789, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:18:06', 'admin-1486869507-14868730862257178', 1, 1, 'SR', NULL, NULL, NULL),
(19887, '2017-02-12 12:26:42', NULL, NULL, 6789, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:26:42', 'admin-1486869507-1486873602469868', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(19888, '2017-02-12 12:26:42', NULL, NULL, 6789, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:26:42', 'admin-1486869507-1486873602469868', 1, 0, '', NULL, NULL, NULL),
(19889, '2017-02-12 12:26:42', NULL, NULL, 6789, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:26:42', 'admin-1486869507-1486873602469868', 1, 0, '', NULL, NULL, NULL),
(19890, '2017-02-12 12:26:57', NULL, NULL, 6789, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:26:57', 'admin-1486869507-14868736175101989', 1, 0, '', NULL, NULL, NULL),
(19891, '2017-02-12 12:26:57', NULL, NULL, 6789, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:26:57', 'admin-1486869507-14868736175101989', 1, 0, '', NULL, NULL, NULL),
(19892, '2017-02-12 11:09:57', NULL, NULL, 6781, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:09:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19893, '2017-02-12 17:35:53', NULL, NULL, 6821, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 17:35:53', 'admin-1486880131-1486892153510654', 1, 1, 'SR', NULL, NULL, NULL),
(19894, '2017-02-12 15:13:49', NULL, NULL, 6814, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 15:13:49', 'admin-1486880131-14868836289928928', 1, 1, 'SR', NULL, NULL, NULL),
(19895, '2017-02-12 15:13:49', NULL, NULL, 6814, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 15:13:49', 'admin-1486880131-14868836289928928', 1, 1, 'SR', NULL, NULL, NULL),
(19896, '2017-02-12 15:13:49', NULL, NULL, 6814, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 15:13:49', 'admin-1486880131-14868836289928928', 1, 0, '', NULL, NULL, NULL),
(19897, '2017-02-12 15:13:49', NULL, NULL, 6814, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 15:13:49', 'admin-1486880131-14868836289928928', 1, 0, '', NULL, NULL, NULL),
(19898, '2017-02-12 15:16:21', NULL, NULL, 6811, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 15:16:21', 'admin-1486880131-14868837807947968', 1, 0, '', NULL, NULL, NULL),
(19899, '2017-02-12 15:25:01', NULL, NULL, 6803, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 15:25:01', 'admin-1486880131-14868843010764545', 1, 1, 'SR', NULL, NULL, NULL),
(19900, '2017-02-12 17:35:53', NULL, NULL, 6821, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 17:35:53', 'admin-1486880131-1486892153510654', 1, 1, 'SR', NULL, NULL, NULL),
(19901, '2017-02-12 14:45:09', NULL, NULL, 6811, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:45:09', 'admin-1486880131-14868819094641365', 1, 1, 'SR', NULL, NULL, NULL),
(19902, '2017-02-12 14:45:09', NULL, NULL, 6811, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:45:09', 'admin-1486880131-14868819094641365', 1, 0, '', NULL, NULL, NULL),
(19903, '2017-02-12 14:32:05', NULL, NULL, 6810, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:32:05', 'admin-1486880131-14868811248712357', 1, 1, 'SR', NULL, NULL, NULL),
(19904, '2017-02-12 14:32:05', NULL, NULL, 6810, 0, 268, '202', 'ICED COCOA CAPPUCINO', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:32:05', 'admin-1486880131-14868811248712357', 1, 0, '', NULL, NULL, NULL),
(19905, '2017-02-12 14:32:33', NULL, NULL, 6809, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:32:33', 'admin-1486880131-14868811532628564', 1, 0, '', NULL, NULL, NULL),
(19906, '2017-02-12 14:33:21', NULL, NULL, 6804, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:33:21', 'admin-1486880131-1486881201263197', 1, 0, '', NULL, NULL, NULL),
(19907, '2017-02-12 12:02:28', NULL, NULL, 6776, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:02:28', 'admin-1486869507-14868721480428213', 1, 1, 'SR', NULL, NULL, NULL),
(19908, '2017-02-12 14:44:42', NULL, NULL, 6811, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:44:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19909, '2017-02-12 14:19:27', NULL, NULL, 6806, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:19:27', 'admin-1486880131-14868803675015513', 1, 1, 'SR', NULL, NULL, NULL),
(19910, '2017-02-12 14:33:21', NULL, NULL, 6804, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:33:21', 'admin-1486880131-1486881201263197', 1, 0, '', NULL, NULL, NULL),
(19911, '2017-02-12 14:33:21', NULL, NULL, 6804, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:33:21', 'admin-1486880131-1486881201263197', 1, 0, '', NULL, NULL, NULL),
(19912, '2017-02-12 14:11:05', NULL, NULL, 6805, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:11:05', 'admin-1486873925-14868798655588211', 1, 1, 'SR', NULL, NULL, NULL),
(19913, '2017-02-12 14:11:05', NULL, NULL, 6805, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:11:05', 'admin-1486873925-14868798655588211', 1, 1, 'SR', NULL, NULL, NULL),
(19914, '2017-02-12 11:18:34', NULL, NULL, 6782, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:18:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19915, '2017-02-12 11:18:48', NULL, NULL, 6782, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:18:48', 'admin-1486869507-14868695284381536', 1, 0, '', NULL, NULL, NULL),
(19916, '2017-02-12 11:18:48', NULL, NULL, 6782, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:18:48', 'admin-1486869507-14868695284381536', 1, 0, '', NULL, NULL, NULL),
(19917, '2017-02-12 11:19:02', NULL, NULL, 6782, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:19:02', 'admin-1486869507-1486869542443970', 1, 1, 'SR', NULL, NULL, NULL),
(19918, '2017-02-12 11:19:02', NULL, NULL, 6782, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:19:02', 'admin-1486869507-1486869542443970', 1, 1, 'SR', NULL, NULL, NULL),
(19919, '2017-02-12 11:27:32', NULL, NULL, 6783, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:27:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19920, '2017-02-12 11:27:42', NULL, NULL, 6783, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:27:42', 'admin-1486869507-14868700626801220', 1, 1, 'SR', NULL, NULL, NULL),
(19921, '2017-02-12 11:27:42', NULL, NULL, 6783, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:27:42', 'admin-1486869507-14868700626801220', 1, 1, 'SR', NULL, NULL, NULL),
(19922, '2017-02-12 11:29:40', NULL, NULL, 6784, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:29:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19923, '2017-02-12 11:30:59', NULL, NULL, 6785, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:30:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19924, '2017-02-12 11:31:23', NULL, NULL, 6785, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:31:23', 'admin-1486869507-1486870283407302', 1, 0, '', NULL, NULL, NULL),
(19925, '2017-02-12 11:31:23', NULL, NULL, 6785, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:31:23', 'admin-1486869507-1486870283407302', 1, 1, 'SR', NULL, NULL, NULL),
(19926, '2017-02-12 11:32:07', NULL, NULL, 6784, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:32:07', 'admin-1486869507-1486870326972157', 1, 0, '', NULL, NULL, NULL),
(19927, '2017-02-12 11:32:07', NULL, NULL, 6784, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:32:07', 'admin-1486869507-1486870326972157', 1, 0, '', NULL, NULL, NULL),
(19928, '2017-02-12 11:32:14', NULL, NULL, 6784, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:32:14', 'admin-1486869507-14868703346302159', 1, 1, 'SR', NULL, NULL, NULL),
(19929, '2017-02-12 11:44:13', NULL, NULL, 6786, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:44:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19930, '2017-02-12 11:44:20', NULL, NULL, 6786, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:44:20', 'admin-1486869507-1486871060819753', 1, 1, 'SR', NULL, NULL, NULL),
(19931, '2017-02-12 11:44:21', NULL, NULL, 6786, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:44:21', 'admin-1486869507-1486871060819753', 1, 1, 'SR', NULL, NULL, NULL),
(19932, '2017-02-12 11:58:54', NULL, NULL, 6787, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:58:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19933, '2017-02-12 11:59:25', NULL, NULL, 6787, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:59:25', 'admin-1486869507-14868719650547525', 1, 1, 'SR', NULL, NULL, NULL),
(19934, '2017-02-12 00:00:00', NULL, NULL, 6799, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:59:25', 'admin-1486869507-14868719650547525', 1, 1, 'SR', NULL, NULL, NULL),
(19935, '2017-02-12 00:00:00', NULL, NULL, 6798, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:28:39', 'admin-1486869507-14868737189625978', 1, 1, 'SR', NULL, NULL, NULL),
(19936, '2017-02-12 11:59:25', NULL, NULL, 6787, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:59:25', 'admin-1486869507-14868719650547525', 1, 1, 'SR', NULL, NULL, NULL),
(19937, '2017-02-12 00:00:00', NULL, NULL, 6799, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:31:53', 'admin-1486869507-14868739130508317', 1, 0, '', NULL, NULL, NULL),
(19938, '2017-02-12 11:59:25', NULL, NULL, 6787, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:59:25', 'admin-1486869507-14868719650547525', 1, 1, 'SR', NULL, NULL, NULL),
(19939, '2017-02-12 09:15:53', NULL, NULL, 6771, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 09:15:53', 'admin-1486861609-1486862152999917', 1, 0, '', NULL, NULL, NULL),
(19940, '2017-02-12 09:15:53', NULL, NULL, 6771, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 09:15:53', 'admin-1486861609-1486862152999917', 1, 0, '', NULL, NULL, NULL),
(19941, '2017-02-12 09:16:01', NULL, NULL, 6771, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 09:16:01', 'admin-1486861609-14868621615991071', 1, 0, '', NULL, NULL, NULL),
(19942, '2017-02-12 00:00:00', NULL, NULL, 6798, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:41:24', 'admin-1486873925-14868744841226784', 1, 0, '', NULL, NULL, NULL),
(19943, '2017-02-12 13:16:42', NULL, NULL, 6797, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 13:16:42', 'admin-1486873925-14868766026305539', 1, 0, '', 1, NULL, NULL),
(19944, '2017-02-12 13:12:27', NULL, NULL, 6795, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 13:12:27', 'admin-1486873925-1486876347133129', 1, 1, 'SR', NULL, NULL, NULL),
(19945, '2017-02-12 13:12:05', NULL, NULL, 6795, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1486880131', 'admin', '2017-02-12 13:12:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19946, '2017-02-12 13:12:18', NULL, NULL, 6795, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 13:12:18', 'admin-1486873925-14868763378483740', 1, 1, 'SR', NULL, NULL, NULL),
(19947, '2017-02-12 13:02:56', NULL, NULL, 6794, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 13:02:56', 'admin-1486873925-14868757761801797', 1, 1, 'SR', NULL, NULL, NULL),
(19948, '2017-02-12 13:02:56', NULL, NULL, 6794, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 13:02:56', 'admin-1486873925-14868757761801797', 1, 1, 'SR', NULL, NULL, NULL),
(19949, '2017-02-12 12:59:35', NULL, NULL, 6792, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:59:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19950, '2017-02-12 12:59:51', NULL, NULL, 6792, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:59:51', 'admin-1486873925-14868755908539360', 1, 0, '', NULL, NULL, NULL),
(19951, '2017-02-12 12:59:51', NULL, NULL, 6792, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:59:51', 'admin-1486873925-14868755908539360', 1, 0, '', NULL, NULL, NULL),
(19952, '2017-02-12 12:59:51', NULL, NULL, 6792, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:59:51', 'admin-1486873925-14868755908539360', 1, 0, '', NULL, NULL, NULL),
(19953, '2017-02-12 12:59:51', NULL, NULL, 6792, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:59:51', 'admin-1486873925-14868755908539360', 1, 0, '', NULL, NULL, NULL),
(19954, '2017-02-12 13:00:06', NULL, NULL, 6793, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 13:00:06', 'admin-1486873925-14868756065411295', 1, 0, '', 1, NULL, NULL),
(19955, '2017-02-12 12:14:31', NULL, NULL, 6788, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:14:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19956, '2017-02-12 12:14:45', NULL, NULL, 6788, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:14:45', 'admin-1486869507-14868728851639198', 1, 1, 'SR', NULL, NULL, NULL),
(19957, '2017-02-12 12:14:45', NULL, NULL, 6788, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:14:45', 'admin-1486869507-14868728851639198', 1, 1, 'SR', NULL, NULL, NULL),
(19958, '2017-02-12 13:02:56', NULL, NULL, 6794, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 13:02:56', 'admin-1486873925-14868757761801797', 1, 0, '', NULL, NULL, NULL),
(19959, '2017-02-12 14:44:49', NULL, NULL, 6811, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 14:44:49', 'admin-1486880131-1486881889681822', 1, 1, 'SR', NULL, NULL, NULL),
(19960, '2017-02-12 13:02:34', NULL, NULL, 6794, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1486880131', 'admin', '2017-02-12 13:02:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19961, '2017-02-12 12:49:34', NULL, NULL, 6791, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:49:34', 'admin-1486873925-14868749742826046', 1, 0, '', NULL, NULL, NULL),
(19962, '2017-02-12 13:02:56', NULL, NULL, 6794, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 13:02:56', 'admin-1486873925-14868757761801797', 1, 0, '', NULL, NULL, NULL),
(19963, '2017-02-12 12:52:52', NULL, NULL, 6789, 0, 181, '116', 'Open Food ', 'cookies', 'Meals', 'Perfect Meals', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:52:52', 'admin-1486873925-14868751725433799', 1, 0, '', NULL, NULL, NULL),
(19964, '2017-02-12 12:49:34', NULL, NULL, 6791, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:49:34', 'admin-1486873925-14868749742826046', 1, 1, 'SR', NULL, NULL, NULL),
(19965, '2017-02-12 12:49:20', NULL, NULL, 6791, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:49:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19966, '2017-02-12 12:49:34', NULL, NULL, 6791, 0, 260, '194', 'Coronado Beer Single', '', 'Cold Drinks', 'Soda & Beer', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:49:34', 'admin-1486873925-14868749742826046', 1, 0, '', NULL, NULL, NULL),
(19967, '2017-02-12 00:00:00', NULL, NULL, 6799, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:59:25', 'admin-1486869507-14868719650547525', 1, 1, 'SR', NULL, NULL, NULL),
(19968, '2017-02-12 12:42:24', NULL, NULL, 6787, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:42:24', 'admin-1486873925-14868745439927156', 1, 0, '', NULL, NULL, NULL),
(19969, '2017-02-12 00:00:00', NULL, NULL, 6798, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:10:51', 'admin-1486869507-14868726514688415', 1, 0, '', NULL, NULL, NULL),
(19970, '2017-02-12 00:00:00', NULL, NULL, 6799, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:10:51', 'admin-1486869507-14868726514688415', 1, 0, '', NULL, NULL, NULL),
(19971, '2017-02-12 12:32:32', NULL, NULL, 6790, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:32:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19972, '2017-02-12 13:22:11', NULL, NULL, 6798, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1486880131', 'admin', '2017-02-12 13:22:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19973, '2017-02-12 00:00:00', NULL, NULL, 6799, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:10:51', 'admin-1486869507-14868726514688415', 1, 0, '', NULL, NULL, NULL),
(19974, '2017-02-12 12:10:51', NULL, NULL, 6787, 0, 153, '87', 'Wake Me Up!', 'no sausage', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:10:51', 'admin-1486869507-14868726514688415', 1, 0, '', NULL, NULL, NULL),
(19975, '2017-02-12 12:10:51', NULL, NULL, 6787, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 12:10:51', 'admin-1486869507-14868726514688415', 1, 0, '', NULL, NULL, NULL),
(19976, '2017-02-12 13:25:32', NULL, NULL, 6799, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1486880131', 'admin', '2017-02-12 13:25:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19977, '2017-02-12 00:00:00', NULL, NULL, 6798, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:59:25', 'admin-1486869507-14868719650547525', 1, 1, 'SR', NULL, NULL, NULL),
(19978, '2017-02-12 10:55:05', NULL, NULL, 6779, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 10:55:05', 'admin-1486861609-14868681052548534', 1, 0, '', NULL, NULL, NULL),
(19979, '2017-02-12 10:59:58', NULL, NULL, 6780, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.80, 0.0000, 0.0000, 11.80, 1, '27', 1, '1486880131', 'admin', '2017-02-12 10:59:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19980, '2017-02-12 11:00:15', NULL, NULL, 6780, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:00:15', 'admin-1486861609-14868684157561482', 1, 1, 'SR', NULL, NULL, NULL),
(19981, '2017-02-12 11:00:15', NULL, NULL, 6780, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:00:15', 'admin-1486861609-14868684157561482', 1, 1, 'SR', NULL, NULL, NULL),
(19982, '2017-02-12 11:00:37', NULL, NULL, 6780, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:00:37', 'admin-1486861609-14868684370823946', 1, 1, 'SR', NULL, NULL, NULL),
(19983, '2017-02-12 11:00:37', NULL, NULL, 6780, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:00:37', 'admin-1486861609-14868684370823946', 1, 0, '', NULL, NULL, NULL),
(19984, '2017-02-12 11:00:37', NULL, NULL, 6780, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:00:37', 'admin-1486861609-14868684370823946', 1, 0, '', NULL, NULL, NULL),
(19985, '2017-02-12 11:01:16', NULL, NULL, 6780, 0, 61, '61', 'Slim Fit', 'no ice', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:01:16', 'admin-1486861609-1486868476475774', 1, 1, 'SR', NULL, NULL, NULL),
(19986, '2017-02-12 11:01:16', NULL, NULL, 6780, 0, 59, '59', 'Sunshine', 'less ice', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:01:16', 'admin-1486861609-1486868476475774', 1, 1, 'SR', NULL, NULL, NULL),
(19987, '2017-02-12 11:01:16', NULL, NULL, 6780, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:01:16', 'admin-1486861609-1486868476475774', 1, 0, '', NULL, NULL, NULL),
(19988, '2017-02-12 11:01:16', NULL, NULL, 6780, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:01:16', 'admin-1486861609-1486868476475774', 1, 0, '', NULL, NULL, NULL),
(19989, '2017-02-12 10:50:19', NULL, NULL, 6778, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 10:50:19', 'admin-1486861609-14868678192993834', 1, 0, '', NULL, NULL, NULL),
(19990, '2017-02-12 11:10:26', NULL, NULL, 6781, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:10:26', 'admin-1486861609-14868690266962484', 1, 0, '', NULL, NULL, NULL),
(19991, '2017-02-12 11:10:26', NULL, NULL, 6781, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:10:26', 'admin-1486861609-14868690266962484', 1, 1, 'SR', NULL, NULL, NULL),
(19992, '2017-02-12 11:10:26', NULL, NULL, 6781, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:10:26', 'admin-1486861609-14868690266962484', 1, 0, '', NULL, NULL, NULL),
(19993, '2017-02-12 11:10:26', NULL, NULL, 6781, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:10:26', 'admin-1486861609-14868690266962484', 1, 0, '', NULL, NULL, NULL),
(19994, '2017-02-12 11:01:16', NULL, NULL, 6780, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 11:01:16', 'admin-1486861609-1486868476475774', 1, 0, '', NULL, NULL, NULL),
(19995, '2017-02-12 10:55:05', NULL, NULL, 6779, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 10:55:05', 'admin-1486861609-14868681052548534', 1, 1, 'SR', NULL, NULL, NULL),
(19996, '2017-02-12 10:55:05', NULL, NULL, 6779, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 10:55:05', 'admin-1486861609-14868681052548534', 1, 0, '', NULL, NULL, NULL),
(19997, '2017-02-12 10:54:40', NULL, NULL, 6779, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 10:54:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(19998, '2017-02-12 10:50:19', NULL, NULL, 6778, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 10:50:19', 'admin-1486861609-14868678192993834', 1, 1, 'SR', NULL, NULL, NULL),
(19999, '2017-02-12 10:50:19', NULL, NULL, 6778, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 10:50:19', 'admin-1486861609-14868678192993834', 1, 1, 'SR', NULL, NULL, NULL),
(20000, '2017-02-12 09:57:33', NULL, NULL, 6773, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 09:57:33', 'admin-1486861609-14868646537898486', 1, 1, 'SR', NULL, NULL, NULL),
(20001, '2017-02-12 09:57:56', NULL, NULL, 6772, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 09:57:56', 'admin-1486861609-148686467673054', 1, 1, 'SR', NULL, NULL, NULL),
(20002, '2017-02-12 09:57:56', NULL, NULL, 6772, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 09:57:56', 'admin-1486861609-148686467673054', 1, 0, '', NULL, NULL, NULL),
(20003, '2017-02-12 09:58:00', NULL, NULL, 6774, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1486880131', 'admin', '2017-02-12 09:58:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20004, '2017-02-12 09:58:04', NULL, NULL, 6774, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 09:58:04', 'admin-1486861609-14868646839374823', 1, 0, '', NULL, NULL, NULL),
(20005, '2017-02-12 09:58:48', NULL, NULL, 6772, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 09:58:48', 'admin-1486861609-14868647287566037', 1, 1, 'SR', NULL, NULL, NULL),
(20006, '2017-02-12 10:14:11', NULL, NULL, 6775, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1486880131', 'admin', '2017-02-12 10:14:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20007, '2017-02-12 10:14:34', NULL, NULL, 6775, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 10:14:34', 'admin-1486861609-14868656745456936', 1, 0, '', NULL, NULL, NULL),
(20008, '2017-02-12 10:14:41', NULL, NULL, 6775, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 10:14:41', 'admin-1486861609-1486865680837343', 1, 1, 'SR', NULL, NULL, NULL),
(20009, '2017-02-12 10:20:17', NULL, NULL, 6776, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 10:20:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20010, '2017-02-12 10:20:20', NULL, NULL, 6776, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 10:20:20', 'admin-1486861609-14868660201969288', 1, 1, 'SR', NULL, NULL, NULL),
(20011, '2017-02-12 10:31:41', NULL, NULL, 6777, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1486880131', 'admin', '2017-02-12 10:31:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20012, '2017-02-12 10:32:06', NULL, NULL, 6777, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 10:32:06', 'admin-1486861609-14868667264666338', 1, 1, 'SR', NULL, NULL, NULL),
(20013, '2017-02-12 10:34:08', NULL, NULL, 6777, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 10:34:08', 'admin-1486861609-14868668483927451', 1, 0, '', NULL, NULL, NULL),
(20014, '2017-02-12 10:32:06', NULL, NULL, 6777, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 10:32:06', 'admin-1486861609-14868667264666338', 1, 0, '', NULL, NULL, NULL),
(20015, '2017-02-12 10:49:45', NULL, NULL, 6778, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1486880131', 'admin', '2017-02-12 10:49:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20016, '2017-02-12 10:50:19', NULL, NULL, 6778, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 10:50:19', 'admin-1486861609-14868678192993834', 1, 0, '', NULL, NULL, NULL),
(20017, '2017-02-12 09:57:33', NULL, NULL, 6773, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 09:57:33', 'admin-1486861609-14868646537898486', 1, 0, '', NULL, NULL, NULL),
(20018, '2017-02-12 09:57:17', NULL, NULL, 6773, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1486880131', 'admin', '2017-02-12 09:57:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20019, '2017-02-12 09:57:24', NULL, NULL, 6773, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 09:57:24', 'admin-1486861609-14868646444364998', 1, 0, '', NULL, NULL, NULL),
(20020, '2017-02-12 09:57:24', NULL, NULL, 6773, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 09:57:24', 'admin-1486861609-14868646444364998', 1, 0, '', NULL, NULL, NULL),
(20021, '2017-02-12 09:16:01', NULL, NULL, 6771, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 09:16:01', 'admin-1486861609-14868621615991071', 1, 1, 'SR', NULL, NULL, NULL),
(20022, '2017-02-12 09:56:06', NULL, NULL, 6772, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1486880131', 'admin', '2017-02-12 09:56:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20023, '2017-02-12 09:57:13', NULL, NULL, 6772, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 09:57:13', 'admin-1486861609-14868646331216335', 1, 0, '', NULL, NULL, NULL),
(20024, '2017-02-12 09:16:01', NULL, NULL, 6771, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486880131', 'admin', '2017-02-12 09:16:01', 'admin-1486861609-14868621615991071', 1, 1, 'SR', NULL, NULL, NULL),
(20025, '2017-02-12 09:15:47', NULL, NULL, 6771, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1486880131', 'admin', '2017-02-12 09:15:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20026, '2017-02-13 13:51:26', NULL, NULL, 6848, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1486962836', 'admin', '2017-02-13 13:51:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20027, '2017-02-13 13:23:03', NULL, NULL, 6844, 0, 214, '148', 'Set Fried Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 13:23:03', 'admin-1486962836-14869633832918241', 1, 0, '', NULL, NULL, NULL),
(20028, '2017-02-13 13:51:38', NULL, NULL, 6848, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 13:51:38', 'admin-1486962836-14869650983584176', 1, 1, 'SR', NULL, NULL, NULL),
(20029, '2017-02-13 13:51:38', NULL, NULL, 6848, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 13:51:38', 'admin-1486962836-14869650983584176', 1, 1, 'SR', NULL, NULL, NULL),
(20030, '2017-02-13 14:45:38', NULL, NULL, 6851, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1486962836', 'admin', '2017-02-13 14:45:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20031, '2017-02-13 14:01:08', NULL, NULL, 6850, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1486962836', 'admin', '2017-02-13 14:01:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20032, '2017-02-13 14:01:11', NULL, NULL, 6850, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 14:01:11', 'admin-1486962836-14869656716298738', 1, 1, 'SR', NULL, NULL, NULL),
(20033, '2017-02-13 15:00:58', NULL, NULL, 6852, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 15:00:58', 'admin-1486962836-14869692584306786', 1, 1, 'SR', NULL, NULL, NULL),
(20034, '2017-02-13 15:04:51', NULL, NULL, 6852, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1486962836', 'admin', '2017-02-13 15:04:51', 'admin-1486962836-14869694918358638', 1, 0, '', NULL, NULL, NULL),
(20035, '2017-02-13 15:04:52', NULL, NULL, 6852, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 15:04:52', 'admin-1486962836-14869694918358638', 1, 0, '', NULL, NULL, NULL),
(20036, '2017-02-13 15:34:30', NULL, NULL, 6852, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 15:34:30', 'admin-1486962836-1486971270579314', 1, 1, 'SR', NULL, NULL, NULL),
(20037, '2017-02-13 15:34:30', NULL, NULL, 6852, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 15:34:30', 'admin-1486962836-1486971270579314', 1, 1, 'SR', NULL, NULL, NULL),
(20038, '2017-02-13 16:31:25', NULL, NULL, 6853, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1486962836', 'admin', '2017-02-13 16:31:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20039, '2017-02-13 16:31:36', NULL, NULL, 6853, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 16:31:36', 'admin-1486962836-14869746958656346', 1, 1, 'SR', NULL, NULL, NULL),
(20040, '2017-02-13 16:31:36', NULL, NULL, 6853, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 16:31:36', 'admin-1486962836-14869746958656346', 1, 1, 'SR', NULL, NULL, NULL),
(20041, '2017-02-13 16:31:36', NULL, NULL, 6853, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 16:31:36', 'admin-1486962836-14869746958656346', 1, 1, 'SR', NULL, NULL, NULL),
(20042, '2017-02-13 13:34:59', NULL, NULL, 6846, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 13:34:59', 'admin-1486962836-14869640995544361', 1, 1, 'SR', NULL, NULL, '10.0'),
(20043, '2017-02-13 14:29:46', NULL, NULL, 6844, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 14:29:46', 'admin-1486962836-14869673860905755', 1, 0, '', NULL, NULL, NULL),
(20044, '2017-02-13 14:30:54', NULL, NULL, 6847, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 14:30:54', 'admin-1486962836-14869674544821292', 1, 1, 'SR', NULL, NULL, NULL),
(20045, '2017-02-13 14:30:54', NULL, NULL, 6847, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 14:30:54', 'admin-1486962836-14869674544821292', 1, 1, 'SR', NULL, NULL, NULL),
(20046, '2017-02-13 14:31:56', NULL, NULL, 6848, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 14:31:56', 'admin-1486962836-14869675162989329', 1, 0, '', NULL, NULL, NULL),
(20047, '2017-02-13 14:45:49', NULL, NULL, 6851, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 14:45:49', 'admin-1486962836-14869683489144032', 1, 1, 'SR', NULL, NULL, NULL),
(20048, '2017-02-13 14:46:24', NULL, NULL, 6852, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.45, 0.0000, 0.0000, 5.45, 1, '27', 1, '1486962836', 'admin', '2017-02-13 14:46:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20049, '2017-02-13 14:46:28', NULL, NULL, 6852, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 14:46:28', 'admin-1486962836-14869683885267311', 1, 0, '', NULL, NULL, NULL),
(20050, '2017-02-13 14:29:36', NULL, NULL, 6844, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 14:29:36', 'admin-1486962836-14869673761676376', 1, 1, 'SR', NULL, NULL, NULL),
(20051, '2017-02-13 13:35:40', NULL, NULL, 6847, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1486962836', 'admin', '2017-02-13 13:35:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20052, '2017-02-13 13:35:44', NULL, NULL, 6847, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 13:35:44', 'admin-1486962836-14869641444318951', 1, 1, 'SR', NULL, NULL, NULL),
(20053, '2017-02-13 11:17:18', NULL, NULL, 6831, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:17:18', 'admin-1486945644-14869558378832411', 1, 0, '', NULL, NULL, NULL),
(20054, '2017-02-13 13:25:41', NULL, NULL, 6845, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1486962836', 'admin', '2017-02-13 13:25:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20055, '2017-02-13 13:13:44', NULL, NULL, 6841, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 13:13:44', 'admin-1486956031-14869628239115269', 1, 0, '', NULL, NULL, NULL),
(20056, '2017-02-13 12:06:24', NULL, NULL, 6836, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:06:24', 'admin-1486956031-14869587845132416', 1, 0, '', NULL, NULL, NULL),
(20057, '2017-02-13 12:06:24', NULL, NULL, 6836, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:06:24', 'admin-1486956031-14869587845132416', 1, 0, '', NULL, NULL, NULL),
(20058, '2017-02-13 12:06:50', NULL, NULL, 6828, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:06:50', 'admin-1486956031-14869588105351184', 1, 1, 'SR', NULL, NULL, NULL),
(20059, '2017-02-13 12:14:45', NULL, NULL, 6838, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:14:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20060, '2017-02-13 12:14:52', NULL, NULL, 6838, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:14:52', 'admin-1486956031-1486959292385638', 1, 1, 'SR', NULL, NULL, NULL),
(20061, '2017-02-13 12:14:52', NULL, NULL, 6838, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:14:52', 'admin-1486956031-1486959292385638', 1, 1, 'SR', NULL, NULL, NULL),
(20062, '2017-02-13 14:31:56', NULL, NULL, 6848, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 14:31:56', 'admin-1486962836-14869675162989329', 1, 0, '', NULL, NULL, NULL),
(20063, '2017-02-13 14:31:56', NULL, NULL, 6848, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 14:31:56', 'admin-1486962836-14869675162989329', 1, 1, 'SR', NULL, NULL, NULL),
(20064, '2017-02-13 14:31:56', NULL, NULL, 6848, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 14:31:56', 'admin-1486962836-14869675162989329', 1, 1, 'SR', NULL, NULL, NULL),
(20065, '2017-02-13 12:28:28', NULL, NULL, 6840, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:28:28', 'admin-1486956031-1486960108471149', 1, 0, '', NULL, NULL, NULL),
(20066, '2017-02-13 12:38:44', NULL, NULL, 6841, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:38:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20067, '2017-02-13 12:39:07', NULL, NULL, 6841, 0, 82, '82', 'Set Stir Fried Rice Wine Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:39:07', 'admin-1486956031-14869607477077493', 1, 1, 'SR', NULL, NULL, NULL),
(20068, '2017-02-13 10:55:25', NULL, NULL, 6830, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 10:55:25', 'admin-1486945644-14869545255443785', 1, 1, 'SR', NULL, NULL, NULL),
(20069, '2017-02-13 10:55:25', NULL, NULL, 6830, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 10:55:25', 'admin-1486945644-14869545255443785', 1, 0, '', NULL, NULL, NULL),
(20070, '2017-02-13 11:17:06', NULL, NULL, 6831, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:17:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20071, '2017-02-13 11:17:18', NULL, NULL, 6831, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:17:18', 'admin-1486945644-14869558378832411', 1, 0, '', NULL, NULL, NULL),
(20072, '2017-02-13 11:46:24', NULL, NULL, 6834, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:46:24', 'admin-1486956031-1486957584123189', 1, 0, '', NULL, NULL, NULL),
(20073, '2017-02-13 11:46:05', NULL, NULL, 6834, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:46:05', 'admin-1486956031-14869575651416568', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(20074, '2017-02-13 11:50:05', NULL, NULL, 6835, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:50:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20075, '2017-02-13 11:50:18', NULL, NULL, 6835, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:50:18', 'admin-1486956031-14869578179772269', 1, 1, 'SR', NULL, NULL, NULL),
(20076, '2017-02-13 12:28:06', NULL, NULL, 6840, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:28:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20077, '2017-02-13 12:00:50', NULL, NULL, 6836, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:00:50', 'admin-1486956031-14869584506534817', 1, 0, '', NULL, NULL, NULL),
(20078, '2017-02-13 12:02:27', NULL, NULL, 6837, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:02:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20079, '2017-02-13 12:52:40', NULL, NULL, 6843, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:52:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20080, '2017-02-13 12:53:20', NULL, NULL, 6843, 0, 84, '84', 'Set Marmite Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:53:20', 'admin-1486956031-14869616003329332', 1, 1, 'SR', NULL, NULL, NULL),
(20081, '2017-02-13 12:02:59', NULL, NULL, 6837, 0, 213, '147', 'Set Stir Fried Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:02:59', 'admin-1486956031-14869585797511733', 1, 0, '', NULL, NULL, NULL),
(20082, '2017-02-13 12:02:59', NULL, NULL, 6837, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:02:59', 'admin-1486956031-14869585797511733', 1, 0, '', NULL, NULL, NULL),
(20083, '2017-02-13 09:26:02', NULL, NULL, 6825, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 09:26:02', 'admin-1486945644-14869491617955429', 1, 1, 'SR', 1, NULL, NULL),
(20084, '2017-02-13 09:09:03', NULL, NULL, 6824, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 09:09:03', 'admin-1486945644-14869481436531356', 1, 0, '', NULL, NULL, NULL),
(20085, '2017-02-13 09:09:03', NULL, NULL, 6824, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 09:09:03', 'admin-1486945644-14869481436531356', 1, 0, '', NULL, NULL, NULL),
(20086, '2017-02-13 16:56:55', NULL, NULL, 6852, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 16:56:55', 'admin-1486962836-14869762148458281', 1, 0, '', NULL, NULL, NULL),
(20087, '2017-02-13 11:17:30', NULL, NULL, 6831, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:17:30', 'admin-1486945644-14869558506253046', 1, 0, '', NULL, NULL, NULL),
(20088, '2017-02-13 11:53:23', NULL, NULL, 6835, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:53:23', 'admin-1486956031-1486958003299598', 1, 1, 'SR', NULL, NULL, NULL),
(20089, '2017-02-13 11:58:52', NULL, NULL, 6836, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:58:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20090, '2017-02-13 11:59:21', NULL, NULL, 6836, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:59:21', 'admin-1486956031-14869583613578711', 1, 0, '', NULL, NULL, NULL),
(20091, '2017-02-13 11:59:21', NULL, NULL, 6836, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:59:21', 'admin-1486956031-14869583613578711', 1, 1, 'SR', NULL, NULL, NULL),
(20092, '2017-02-13 12:28:12', NULL, NULL, 6840, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:28:12', 'admin-1486956031-14869600921823027', 1, 0, '', NULL, NULL, NULL),
(20093, '2017-02-13 12:28:12', NULL, NULL, 6840, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:28:12', 'admin-1486956031-14869600921823027', 1, 0, '', NULL, NULL, NULL),
(20094, '2017-02-13 12:28:12', NULL, NULL, 6840, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:28:12', 'admin-1486956031-14869600921823027', 1, 1, 'SR', NULL, NULL, NULL),
(20095, '2017-02-13 13:34:59', NULL, NULL, 6846, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 13:34:59', 'admin-1486962836-14869640995544361', 1, 0, '', NULL, NULL, '10.0'),
(20096, '2017-02-13 13:34:59', NULL, NULL, 6846, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 13:34:59', 'admin-1486962836-14869640995544361', 1, 0, '', NULL, NULL, '10.0'),
(20097, '2017-02-13 13:34:46', NULL, NULL, 6846, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1486962836', 'admin', '2017-02-13 13:34:46', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(20098, '2017-02-13 13:25:53', NULL, NULL, 6845, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 13:25:53', 'admin-1486962836-14869635537968185', 1, 1, 'SR', NULL, NULL, NULL),
(20099, '2017-02-13 13:23:03', NULL, NULL, 6844, 0, 214, '148', 'Set Fried Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 13:23:03', 'admin-1486962836-14869633832918241', 1, 0, '', NULL, NULL, NULL),
(20100, '2017-02-13 13:22:58', NULL, NULL, 6844, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 13:22:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20101, '2017-02-13 13:21:25', NULL, NULL, 6841, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 13:21:25', 'admin-1486962836-14869632854592660', 1, 0, '', NULL, NULL, NULL),
(20102, '2017-02-13 13:13:44', NULL, NULL, 6841, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 13:13:44', 'admin-1486956031-14869628239115269', 1, 0, '', NULL, NULL, NULL),
(20103, '2017-02-13 12:45:45', NULL, NULL, 6842, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:45:45', 'admin-1486956031-1486961145380231', 1, 0, '', NULL, NULL, NULL),
(20104, '2017-02-13 12:45:45', NULL, NULL, 6842, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:45:45', 'admin-1486956031-1486961145380231', 1, 1, 'SR', NULL, NULL, NULL),
(20105, '2017-02-13 12:45:33', NULL, NULL, 6842, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:45:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20106, '2017-02-13 14:31:56', NULL, NULL, 6848, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 14:31:56', 'admin-1486962836-14869675162989329', 1, 1, 'SR', NULL, NULL, NULL),
(20107, '2017-02-13 14:31:56', NULL, NULL, 6848, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 14:31:56', 'admin-1486962836-14869675162989329', 1, 1, 'SR', NULL, NULL, NULL),
(20108, '2017-02-13 12:39:07', NULL, NULL, 6841, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 12:39:07', 'admin-1486956031-14869607477077493', 1, 1, 'SR', NULL, NULL, NULL),
(20109, '2017-02-13 11:21:15', NULL, NULL, 6832, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:21:15', 'admin-1486956031-14869560753111178', 1, 0, '', NULL, NULL, NULL),
(20110, '2017-02-13 11:21:33', NULL, NULL, 6832, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:21:33', 'admin-1486956031-14869560934278449', 1, 0, '', NULL, NULL, NULL),
(20111, '2017-02-13 11:21:33', NULL, NULL, 6832, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:21:33', 'admin-1486956031-14869560934278449', 1, 1, 'SR', NULL, NULL, NULL),
(20112, '2017-02-13 11:21:33', NULL, NULL, 6832, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:21:33', 'admin-1486956031-14869560934278449', 1, 1, 'SR', NULL, NULL, NULL),
(20113, '2017-02-13 11:21:45', NULL, NULL, 6832, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:21:45', 'admin-1486956031-148695610497711', 1, 1, 'SR', NULL, NULL, NULL),
(20114, '2017-02-13 11:35:25', NULL, NULL, 6833, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:35:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20115, '2017-02-13 11:35:34', NULL, NULL, 6833, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:35:34', 'admin-1486956031-14869569342154160', 1, 1, 'SR', NULL, NULL, NULL),
(20116, '2017-02-13 11:35:34', NULL, NULL, 6833, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:35:34', 'admin-1486956031-14869569342154160', 1, 1, 'SR', NULL, NULL, NULL),
(20117, '2017-02-13 11:46:01', NULL, NULL, 6834, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:46:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20118, '2017-02-13 11:53:23', NULL, NULL, 6835, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:53:23', 'admin-1486956031-1486958003299598', 1, 0, '', NULL, NULL, NULL),
(20119, '2017-02-13 11:19:03', NULL, NULL, 6832, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:19:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20120, '2017-02-13 11:20:25', NULL, NULL, 6832, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 11:20:25', 'admin-1486945644-1486956025798594', 1, 0, '', NULL, NULL, NULL),
(20121, '2017-02-13 09:40:27', NULL, NULL, 6826, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 09:40:27', 'admin-1486945644-14869500268181813', 1, 0, '', NULL, NULL, NULL),
(20122, '2017-02-13 09:41:50', NULL, NULL, 6826, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 09:41:50', 'admin-1486945644-14869501098402382', 1, 1, 'SR', NULL, NULL, NULL),
(20123, '2017-02-13 09:50:26', NULL, NULL, 6827, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1486962836', 'admin', '2017-02-13 09:50:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20124, '2017-02-13 09:50:34', NULL, NULL, 6827, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 09:50:34', 'admin-1486945644-1486950634696560', 1, 1, 'SR', NULL, NULL, NULL),
(20125, '2017-02-13 09:50:34', NULL, NULL, 6827, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 09:50:34', 'admin-1486945644-1486950634696560', 1, 1, 'SR', NULL, NULL, NULL),
(20126, '2017-02-13 09:50:34', NULL, NULL, 6827, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 09:50:34', 'admin-1486945644-1486950634696560', 1, 1, 'SR', NULL, NULL, NULL),
(20127, '2017-02-13 09:50:34', NULL, NULL, 6827, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 09:50:34', 'admin-1486945644-1486950634696560', 1, 1, 'SR', NULL, NULL, NULL),
(20128, '2017-02-13 09:50:34', NULL, NULL, 6827, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 09:50:34', 'admin-1486945644-1486950634696560', 1, 0, '', NULL, NULL, NULL),
(20129, '2017-02-13 10:19:08', NULL, NULL, 6828, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1486962836', 'admin', '2017-02-13 10:19:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20130, '2017-02-13 10:19:11', NULL, NULL, 6828, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 10:19:11', 'admin-1486945644-1486952351538353', 1, 0, '', NULL, NULL, NULL),
(20131, '2017-02-13 10:31:13', NULL, NULL, 6829, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1486962836', 'admin', '2017-02-13 10:31:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20132, '2017-02-13 10:31:37', NULL, NULL, 6829, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 10:31:37', 'admin-1486945644-14869530970586820', 1, 0, '', NULL, NULL, NULL),
(20133, '2017-02-13 10:31:37', NULL, NULL, 6829, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 10:31:37', 'admin-1486945644-14869530970586820', 1, 1, 'SR', NULL, NULL, NULL),
(20134, '2017-02-13 10:55:04', NULL, NULL, 6830, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 10:55:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20135, '2017-02-13 10:55:14', NULL, NULL, 6830, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 10:55:14', 'admin-1486945644-14869545147252955', 1, 0, '', NULL, NULL, NULL),
(20136, '2017-02-13 09:40:27', NULL, NULL, 6826, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 09:40:27', 'admin-1486945644-14869500268181813', 1, 0, '', NULL, NULL, NULL),
(20137, '2017-02-13 09:09:03', NULL, NULL, 6824, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 09:09:03', 'admin-1486945644-14869481436531356', 1, 0, '', NULL, NULL, NULL),
(20138, '2017-02-13 10:55:14', NULL, NULL, 6830, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 10:55:14', 'admin-1486945644-14869545147252955', 1, 0, '', NULL, NULL, NULL),
(20139, '2017-02-13 09:09:03', NULL, NULL, 6824, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 09:09:03', 'admin-1486945644-14869481436531356', 1, 1, 'SR', NULL, NULL, NULL),
(20140, '2017-02-13 09:40:21', NULL, NULL, 6826, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1486962836', 'admin', '2017-02-13 09:40:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20141, '2017-02-13 09:03:56', NULL, NULL, 6823, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 09:03:56', 'admin-1486945644-14869478359055893', 1, 0, '', NULL, NULL, NULL),
(20142, '2017-02-13 09:03:56', NULL, NULL, 6823, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 09:03:56', 'admin-1486945644-14869478359055893', 1, 1, 'SR', NULL, NULL, NULL),
(20143, '2017-02-13 09:08:43', NULL, NULL, 6824, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1486962836', 'admin', '2017-02-13 09:08:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20144, '2017-02-13 09:09:03', NULL, NULL, 6824, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1486962836', 'admin', '2017-02-13 09:09:03', 'admin-1486945644-14869481436531356', 1, 1, 'SR', NULL, NULL, NULL),
(20145, '2017-02-13 09:03:50', NULL, NULL, 6823, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1486962836', 'admin', '2017-02-13 09:03:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20146, '2017-02-15 18:05:42', NULL, NULL, 6886, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 18:05:42', 'admin-1487134777-14871531426071459', 1, 1, 'SR', NULL, NULL, NULL),
(20147, '2017-02-15 14:49:15', NULL, NULL, 6870, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:49:15', 'admin-1487134777-14871413554016120', 1, 0, '', 1, NULL, NULL),
(20148, '2017-02-15 14:50:51', NULL, NULL, 6871, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:50:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20149, '2017-02-15 14:51:06', NULL, NULL, 6871, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:51:06', 'admin-1487134777-1487141466556855', 1, 0, '', NULL, NULL, NULL),
(20150, '2017-02-15 14:51:06', NULL, NULL, 6871, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:51:06', 'admin-1487134777-1487141466556855', 1, 0, '', NULL, NULL, NULL),
(20151, '2017-02-15 14:55:57', NULL, NULL, 6869, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:55:57', 'admin-1487134777-14871417573526298', 1, 0, '', NULL, NULL, NULL),
(20152, '2017-02-15 00:00:00', NULL, NULL, 6872, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:06:02', 'admin-1487134777-14871387625197583', 1, 0, '', NULL, NULL, NULL),
(20153, '2017-02-15 00:00:00', NULL, NULL, 6872, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:59:42', 'admin-1487134777-14871419826351087', 1, 1, 'SR', NULL, NULL, NULL),
(20154, '2017-02-15 00:00:00', NULL, NULL, 6872, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:59:42', 'admin-1487134777-14871419826351087', 1, 1, 'SR', NULL, NULL, NULL),
(20155, '2017-02-15 15:03:30', NULL, NULL, 6873, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:03:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20156, '2017-02-15 15:03:34', NULL, NULL, 6873, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:03:34', 'admin-1487134777-1487142214457390', 1, 0, '', NULL, NULL, NULL),
(20157, '2017-02-15 15:09:49', NULL, NULL, 6874, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:09:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20158, '2017-02-15 15:10:01', NULL, NULL, 6874, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:10:01', 'admin-1487134777-14871426012909668', 1, 1, 'SR', NULL, NULL, NULL),
(20159, '2017-02-15 15:12:02', NULL, NULL, 6875, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:12:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20160, '2017-02-15 15:12:13', NULL, NULL, 6875, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:12:13', 'admin-1487134777-1487142733025822', 1, 0, '', NULL, NULL, NULL),
(20161, '2017-02-15 15:12:21', NULL, NULL, 6875, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:12:21', 'admin-1487134777-14871427412663197', 1, 1, 'SR', NULL, NULL, NULL),
(20162, '2017-02-15 15:12:21', NULL, NULL, 6875, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:12:21', 'admin-1487134777-14871427412663197', 1, 1, 'SR', NULL, NULL, NULL),
(20163, '2017-02-15 17:51:46', NULL, NULL, 6884, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 17:51:46', 'admin-1487134777-14871523068043774', 1, 1, 'SR', 1, NULL, NULL),
(20164, '2017-02-15 17:51:46', NULL, NULL, 6884, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 17:51:46', 'admin-1487134777-14871523068043774', 1, 1, 'SR', 1, NULL, NULL),
(20165, '2017-02-15 17:51:47', NULL, NULL, 6884, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 17:51:47', 'admin-1487134777-14871523068043774', 1, 0, '', 1, NULL, NULL),
(20166, '2017-02-15 17:28:49', NULL, NULL, 6883, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1487134777', 'admin', '2017-02-15 17:28:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20167, '2017-02-15 17:29:22', NULL, NULL, 6883, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 17:29:22', 'admin-1487134777-14871509619454529', 1, 0, '', NULL, NULL, NULL),
(20168, '2017-02-15 17:29:22', NULL, NULL, 6883, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 17:29:22', 'admin-1487134777-14871509619454529', 1, 0, '', NULL, NULL, NULL),
(20169, '2017-02-15 17:29:22', NULL, NULL, 6883, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 17:29:22', 'admin-1487134777-14871509619454529', 1, 0, '', NULL, NULL, NULL),
(20170, '2017-02-15 14:06:02', NULL, NULL, 6864, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:06:02', 'admin-1487134777-14871387625197583', 1, 0, '', NULL, NULL, NULL),
(20171, '2017-02-15 17:29:22', NULL, NULL, 6883, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 17:29:22', 'admin-1487134777-14871509619454529', 1, 1, 'SR', NULL, NULL, NULL),
(20172, '2017-02-15 18:05:42', NULL, NULL, 6886, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 18:05:42', 'admin-1487134777-14871531426071459', 1, 1, 'SR', NULL, NULL, NULL),
(20173, '2017-02-15 19:14:58', NULL, NULL, 6887, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 19:14:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20174, '2017-02-15 19:38:55', NULL, NULL, 6888, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1487134777', 'admin', '2017-02-15 19:38:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20175, '2017-02-15 19:15:04', NULL, NULL, 6887, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 19:15:04', 'admin-1487134777-14871573039055659', 1, 1, 'SR', NULL, NULL, NULL),
(20176, '2017-02-15 00:00:00', NULL, NULL, 6888, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 19:15:04', 'admin-1487134777-14871573039055659', 1, 1, 'SR', NULL, NULL, NULL),
(20177, '2017-02-15 19:40:26', NULL, NULL, 6889, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1487134777', 'admin', '2017-02-15 19:40:26', 'admin-1487134777-14871588258906575', 1, 0, '', 1, NULL, NULL),
(20178, '2017-02-15 17:29:22', NULL, NULL, 6883, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 17:29:22', 'admin-1487134777-14871509619454529', 1, 1, 'SR', NULL, NULL, NULL),
(20179, '2017-02-15 19:40:26', NULL, NULL, 6889, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1487134777', 'admin', '2017-02-15 19:40:26', 'admin-1487134777-14871588258906575', 1, 0, '', 1, NULL, NULL),
(20180, '2017-02-15 15:56:10', NULL, NULL, 6878, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:56:10', 'admin-1487134777-14871453698799778', 1, 1, 'SR', NULL, NULL, NULL),
(20181, '2017-02-15 15:56:10', NULL, NULL, 6878, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:56:10', 'admin-1487134777-14871453698799778', 1, 1, 'SR', NULL, NULL, NULL),
(20182, '2017-02-15 12:09:12', NULL, NULL, 6859, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 12:09:12', 'admin-1487130775-14871317521068375', 1, 0, '', 1, NULL, '10.0'),
(20183, '2017-02-15 12:09:12', NULL, NULL, 6859, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 12:09:12', 'admin-1487130775-14871317521068375', 1, 1, 'SR', 1, NULL, '10.0'),
(20184, '2017-02-15 14:06:02', NULL, NULL, 6864, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:06:02', 'admin-1487134777-14871387625197583', 1, 0, '', NULL, NULL, NULL),
(20185, '2017-02-15 17:29:22', NULL, NULL, 6883, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 17:29:22', 'admin-1487134777-14871509619454529', 1, 1, 'SR', NULL, NULL, NULL),
(20186, '2017-02-15 17:29:22', NULL, NULL, 6883, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 17:29:22', 'admin-1487134777-14871509619454529', 1, 1, 'SR', NULL, NULL, NULL),
(20187, '2017-02-15 17:29:22', NULL, NULL, 6883, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 17:29:22', 'admin-1487134777-14871509619454529', 1, 0, '', NULL, NULL, NULL),
(20188, '2017-02-15 16:18:38', NULL, NULL, 6867, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 16:18:38', 'admin-1487134777-1487146718063847', 1, 1, 'SR', NULL, NULL, NULL),
(20189, '2017-02-15 15:13:46', NULL, NULL, 6873, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:13:46', 'admin-1487134777-14871428265064535', 1, 0, '', NULL, NULL, NULL),
(20190, '2017-02-15 15:24:43', NULL, NULL, 6875, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:24:43', 'admin-1487134777-14871434836028142', 1, 1, 'SR', NULL, NULL, NULL),
(20191, '2017-02-15 14:59:56', NULL, NULL, 6872, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:59:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20192, '2017-02-15 13:17:58', NULL, NULL, 6864, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 13:17:58', 'admin-1487134777-14871358780068180', 1, 1, 'SR', NULL, NULL, NULL),
(20193, '2017-02-15 10:58:48', NULL, NULL, 6856, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 10:58:48', 'admin-1487120746-1487127528444131', 1, 0, '', NULL, NULL, NULL),
(20194, '2017-02-15 16:18:28', NULL, NULL, 6881, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 16:18:28', 'admin-1487134777-14871467081639810', 1, 1, 'SR', NULL, NULL, NULL),
(20195, '2017-02-15 16:14:11', NULL, NULL, 6881, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1487134777', 'admin', '2017-02-15 16:14:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20196, '2017-02-15 16:09:18', NULL, NULL, 6880, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 16:09:18', 'admin-1487134777-1487146158128383', 1, 0, '', NULL, NULL, NULL),
(20197, '2017-02-15 13:17:58', NULL, NULL, 6864, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 13:17:58', 'admin-1487134777-14871358780068180', 1, 1, 'SR', NULL, NULL, NULL),
(20198, '2017-02-15 00:00:00', NULL, NULL, 6872, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 13:17:58', 'admin-1487134777-14871358780068180', 1, 1, 'SR', NULL, NULL, NULL),
(20199, '2017-02-15 13:20:44', NULL, NULL, 6864, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 13:20:44', 'admin-1487134777-14871360445846324', 1, 1, 'SR', NULL, NULL, NULL),
(20200, '2017-02-15 13:20:44', NULL, NULL, 6864, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 13:20:44', 'admin-1487134777-14871360445846324', 1, 1, 'SR', NULL, NULL, NULL),
(20201, '2017-02-15 16:09:13', NULL, NULL, 6880, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1487134777', 'admin', '2017-02-15 16:09:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20202, '2017-02-15 16:01:03', NULL, NULL, 6879, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 16:01:03', 'admin-1487134777-1487145663240547', 1, 1, 'SR', NULL, NULL, NULL),
(20203, '2017-02-15 16:00:55', NULL, NULL, 6879, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 16:00:55', 'admin-1487134777-14871456555224366', 1, 1, 'SR', NULL, NULL, NULL),
(20204, '2017-02-15 16:00:42', NULL, NULL, 6879, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1487134777', 'admin', '2017-02-15 16:00:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20205, '2017-02-15 15:15:11', NULL, NULL, 6873, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:15:11', 'admin-1487134777-14871429112915642', 1, 0, '', NULL, NULL, NULL),
(20206, '2017-02-15 15:25:27', NULL, NULL, 6877, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:25:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20207, '2017-02-15 15:26:00', NULL, NULL, 6877, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:26:00', 'admin-1487134777-14871435604898679', 1, 0, '', NULL, NULL, NULL),
(20208, '2017-02-15 15:26:00', NULL, NULL, 6877, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:26:00', 'admin-1487134777-14871435604898679', 1, 1, 'SR', NULL, NULL, NULL),
(20209, '2017-02-15 15:26:00', NULL, NULL, 6877, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:26:00', 'admin-1487134777-14871435604898679', 1, 1, 'SR', NULL, NULL, NULL),
(20210, '2017-02-15 15:26:00', NULL, NULL, 6877, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:26:00', 'admin-1487134777-14871435604898679', 1, 0, '', NULL, NULL, NULL),
(20211, '2017-02-15 15:52:16', NULL, NULL, 6869, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:52:16', 'admin-1487134777-14871451361133197', 1, 1, 'SR', NULL, NULL, NULL),
(20212, '2017-02-15 15:55:35', NULL, NULL, 6878, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:55:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20213, '2017-02-15 15:55:47', NULL, NULL, 6878, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:55:47', 'admin-1487134777-14871453475926518', 1, 0, '', NULL, NULL, NULL),
(20214, '2017-02-15 15:56:10', NULL, NULL, 6878, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:56:10', 'admin-1487134777-14871453698799778', 1, 0, '', NULL, NULL, NULL),
(20215, '2017-02-15 09:29:06', NULL, NULL, 6854, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 09:29:06', 'admin-1487120746-14871221463895034', 1, 0, '', NULL, NULL, NULL),
(20216, '2017-02-15 09:29:06', NULL, NULL, 6854, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 09:29:06', 'admin-1487120746-14871221463895034', 1, 0, '', NULL, NULL, NULL),
(20217, '2017-02-15 09:29:26', NULL, NULL, 6854, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 09:29:26', 'admin-1487120746-14871221664238664', 1, 0, '', NULL, NULL, NULL),
(20218, '2017-02-15 18:05:34', NULL, NULL, 6886, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1487134777', 'admin', '2017-02-15 18:05:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20219, '2017-02-15 17:53:25', NULL, NULL, 6885, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 17:53:25', 'admin-1487134777-14871524049342115', 1, 1, 'SR', 1, NULL, NULL),
(20220, '2017-02-15 15:13:53', NULL, NULL, 6873, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 15:13:53', 'admin-1487134777-14871428334702230', 1, 1, 'SR', NULL, NULL, NULL),
(20221, '2017-02-15 12:29:51', NULL, NULL, 6860, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 12:29:51', 'admin-1487130775-14871329910214874', 1, 1, 'SR', NULL, NULL, NULL),
(20222, '2017-02-15 12:30:23', NULL, NULL, 6860, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 12:30:23', 'admin-1487130775-14871330237013044', 1, 0, '', NULL, NULL, NULL),
(20223, '2017-02-15 12:35:59', NULL, NULL, 6861, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1487134777', 'admin', '2017-02-15 12:35:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20224, '2017-02-15 12:36:12', NULL, NULL, 6861, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 12:36:12', 'admin-1487130775-14871333727306731', 1, 0, '', NULL, NULL, NULL),
(20225, '2017-02-15 12:36:12', NULL, NULL, 6861, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 12:36:12', 'admin-1487130775-14871333727306731', 1, 0, '', NULL, NULL, NULL),
(20226, '2017-02-15 12:36:20', NULL, NULL, 6861, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 12:36:20', 'admin-1487130775-1487133380366756', 1, 1, 'SR', NULL, NULL, NULL),
(20227, '2017-02-15 12:42:20', NULL, NULL, 6862, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 12:42:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20228, '2017-02-15 12:47:13', NULL, NULL, 6862, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 12:47:13', 'admin-1487130775-14871340336855346', 1, 0, '', NULL, NULL, NULL),
(20229, '2017-02-15 12:50:16', NULL, NULL, 6862, 0, 213, '147', 'Set Stir Fried Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 12:50:16', 'admin-1487130775-1487134215900567', 1, 0, '', NULL, NULL, NULL),
(20230, '2017-02-15 12:59:27', NULL, NULL, 6863, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1487134777', 'admin', '2017-02-15 12:59:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20231, '2017-02-15 12:59:32', NULL, NULL, 6863, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 12:59:32', 'admin-1487130775-1487134772095906', 1, 1, 'SR', NULL, NULL, NULL),
(20232, '2017-02-15 13:16:34', NULL, NULL, 6864, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1487134777', 'admin', '2017-02-15 13:16:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20233, '2017-02-15 14:49:04', NULL, NULL, 6870, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:49:04', 'admin-1487134777-1487141344268373', 1, 0, '', 1, NULL, NULL),
(20234, '2017-02-15 14:49:04', NULL, NULL, 6870, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:49:04', 'admin-1487134777-1487141344268373', 1, 0, '', 1, NULL, NULL),
(20235, '2017-02-15 14:49:04', NULL, NULL, 6870, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:49:04', 'admin-1487134777-1487141344268373', 1, 0, '', 1, NULL, NULL),
(20236, '2017-02-15 14:40:00', NULL, NULL, 6869, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:40:00', 'admin-1487134777-1487140800448222', 1, 0, '', NULL, NULL, NULL),
(20237, '2017-02-15 14:39:55', NULL, NULL, 6869, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:39:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20238, '2017-02-15 14:40:00', NULL, NULL, 6869, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:40:00', 'admin-1487134777-1487140800448222', 1, 0, '', NULL, NULL, NULL),
(20239, '2017-02-15 14:35:02', NULL, NULL, 6867, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:35:02', 'admin-1487134777-1487140502219956', 1, 1, 'SR', NULL, NULL, NULL),
(20240, '2017-02-15 14:35:02', NULL, NULL, 6867, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:35:02', 'admin-1487134777-1487140502219956', 1, 1, 'SR', NULL, NULL, NULL),
(20241, '2017-02-15 14:33:03', NULL, NULL, 6868, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:33:03', 'admin-1487134777-14871403835706042', 1, 0, '', 1, NULL, NULL),
(20242, '2017-02-15 14:32:18', NULL, NULL, 6864, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:32:18', 'admin-1487134777-14871403381697134', 1, 1, 'SR', NULL, NULL, NULL),
(20243, '2017-02-15 14:33:03', NULL, NULL, 6868, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:33:03', 'admin-1487134777-14871403835706042', 1, 0, '', 1, NULL, NULL),
(20244, '2017-02-15 14:21:16', NULL, NULL, 6867, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:21:16', 'admin-1487134777-14871396765198694', 1, 0, '', NULL, NULL, NULL),
(20245, '2017-02-15 14:21:27', NULL, NULL, 6867, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:21:27', 'admin-1487134777-14871396872489987', 1, 0, '', NULL, NULL, NULL),
(20246, '2017-02-15 14:21:16', NULL, NULL, 6867, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:21:16', 'admin-1487134777-14871396765198694', 1, 1, 'SR', NULL, NULL, NULL),
(20247, '2017-02-15 14:20:55', NULL, NULL, 6867, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1487134777', 'admin', '2017-02-15 14:20:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20248, '2017-02-15 00:00:00', NULL, NULL, 6872, 0, 83, '83', 'Set Stir Fried Chicken with Mushroom ', '', 'Meals', 'Set Lunch', 1, 22.00, NULL, NULL, 22.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 13:17:58', 'admin-1487134777-14871358780068180', 1, 1, 'SR', NULL, NULL, NULL),
(20249, '2017-02-15 13:56:24', NULL, NULL, 6866, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 13:56:24', 'admin-1487134777-14871381844191493', 1, 0, '', NULL, NULL, NULL),
(20250, '2017-02-15 13:56:24', NULL, NULL, 6866, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 13:56:24', 'admin-1487134777-14871381844191493', 1, 1, 'SR', NULL, NULL, NULL),
(20251, '2017-02-15 13:20:44', NULL, NULL, 6864, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 13:20:44', 'admin-1487134777-14871360445846324', 1, 1, 'SR', NULL, NULL, NULL),
(20252, '2017-02-15 13:20:44', NULL, NULL, 6864, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 13:20:44', 'admin-1487134777-14871360445846324', 1, 1, 'SR', NULL, NULL, NULL),
(20253, '2017-02-15 12:29:40', NULL, NULL, 6860, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 12:29:40', 'admin-1487130775-14871329798928078', 1, 0, '', NULL, NULL, NULL),
(20254, '2017-02-15 12:29:17', NULL, NULL, 6860, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1487134777', 'admin', '2017-02-15 12:29:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20255, '2017-02-15 12:29:40', NULL, NULL, 6860, 0, 224, '158', 'Set Stir Fried  Garlic Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 12:29:40', 'admin-1487130775-14871329798928078', 1, 0, '', NULL, NULL, NULL),
(20256, '2017-02-15 13:56:15', NULL, NULL, 6866, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1487134777', 'admin', '2017-02-15 13:56:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20257, '2017-02-15 13:41:59', NULL, NULL, 6862, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 13:41:59', 'admin-1487134777-14871373195667734', 1, 0, '', NULL, NULL, NULL),
(20258, '2017-02-15 13:22:08', NULL, NULL, 6865, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 13:22:08', 'admin-1487134777-14871361281082459', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(20259, '2017-02-15 13:21:46', NULL, NULL, 6865, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 13:21:46', 'admin-1487134777-14871361059006897', 1, 1, 'SR', NULL, NULL, NULL),
(20260, '2017-02-15 13:21:42', NULL, NULL, 6865, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1487134777', 'admin', '2017-02-15 13:21:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20261, '2017-02-15 11:50:31', NULL, NULL, 6858, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.30, 0.0000, 0.0000, 15.30, 1, '27', 1, '1487134777', 'admin', '2017-02-15 11:50:31', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(20262, '2017-02-15 11:50:48', NULL, NULL, 6858, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 11:50:48', 'admin-1487120746-14871306484037558', 1, 0, '', NULL, NULL, '10.0'),
(20263, '2017-02-15 11:50:48', NULL, NULL, 6858, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 11:50:48', 'admin-1487120746-14871306484037558', 1, 1, 'SR', NULL, NULL, '10.0'),
(20264, '2017-02-15 11:50:48', NULL, NULL, 6858, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 11:50:48', 'admin-1487120746-14871306484037558', 1, 1, 'SR', NULL, NULL, '10.0'),
(20265, '2017-02-15 11:52:16', NULL, NULL, 6858, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 11:52:16', 'admin-1487120746-14871307363695195', 1, 0, '', NULL, NULL, '10.0'),
(20266, '2017-02-15 11:52:48', NULL, NULL, 6858, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 11:52:48', 'admin-1487120746-14871307686456777', 1, 1, 'SR', NULL, NULL, '10.0'),
(20267, '2017-02-15 11:52:48', NULL, NULL, 6858, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 11:52:48', 'admin-1487120746-14871307686456777', 1, 1, 'SR', NULL, NULL, '10.0'),
(20268, '2017-02-15 11:53:27', NULL, NULL, 6858, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 11:53:27', 'admin-1487130775-14871308077615221', 1, 0, '', NULL, NULL, '10.0'),
(20269, '2017-02-15 11:54:28', NULL, NULL, 6858, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 11:54:28', 'admin-1487130775-14871308678754779', 1, 0, '', NULL, NULL, '10.0'),
(20270, '2017-02-15 11:54:43', NULL, NULL, 6858, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 11:54:43', 'admin-1487130775-14871308835035131', 1, 1, 'SR', NULL, NULL, '10.0'),
(20271, '2017-02-15 11:54:43', NULL, NULL, 6858, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 3, 11.00, 33.0000, 0.0000, 33.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 11:54:43', 'admin-1487130775-14871308835035131', 1, 0, '', NULL, NULL, '10.0'),
(20272, '2017-02-15 10:59:06', NULL, NULL, 6856, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 10:59:06', 'admin-1487120746-14871275463198311', 1, 1, 'SR', NULL, NULL, NULL),
(20273, '2017-02-15 10:59:06', NULL, NULL, 6856, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 10:59:06', 'admin-1487120746-14871275463198311', 1, 0, '', NULL, NULL, NULL),
(20274, '2017-02-15 10:58:48', NULL, NULL, 6856, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 10:58:48', 'admin-1487120746-1487127528444131', 1, 0, '', NULL, NULL, NULL),
(20275, '2017-02-15 10:58:35', NULL, NULL, 6856, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1487134777', 'admin', '2017-02-15 10:58:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20276, '2017-02-15 09:30:47', NULL, NULL, 6855, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 09:30:47', 'admin-1487120746-14871222477139788', 1, 1, 'SR', NULL, NULL, NULL),
(20277, '2017-02-15 09:30:47', NULL, NULL, 6855, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 09:30:47', 'admin-1487120746-14871222477139788', 1, 0, '', NULL, NULL, NULL),
(20278, '2017-02-15 09:30:37', NULL, NULL, 6855, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 09:30:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20279, '2017-02-15 09:29:26', NULL, NULL, 6854, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487134777', 'admin', '2017-02-15 09:29:26', 'admin-1487120746-14871221664238664', 1, 1, 'SR', NULL, NULL, NULL),
(20280, '2017-02-15 09:28:56', NULL, NULL, 6854, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1487134777', 'admin', '2017-02-15 09:28:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20281, '2017-02-16 15:42:53', NULL, NULL, 6909, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 15:42:53', 'admin-1487215491-14872309737425315', 1, 1, 'SR', NULL, NULL, NULL),
(20282, '2017-02-16 16:08:31', NULL, NULL, 6910, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 16:08:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20283, '2017-02-16 16:08:48', NULL, NULL, 6910, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 16:08:48', 'admin-1487215491-1487232528725822', 1, 1, 'SR', NULL, NULL, NULL),
(20284, '2017-02-16 16:30:16', NULL, NULL, 6911, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1487215491', 'admin', '2017-02-16 16:30:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20285, '2017-02-16 16:30:19', NULL, NULL, 6911, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 16:30:19', 'admin-1487215491-14872338195328848', 1, 1, 'SR', NULL, NULL, NULL),
(20286, '2017-02-16 16:35:38', NULL, NULL, 6912, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1487215491', 'admin', '2017-02-16 16:35:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20287, '2017-02-16 16:35:50', NULL, NULL, 6912, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 16:35:50', 'admin-1487215491-14872341505945118', 1, 0, '', NULL, NULL, NULL),
(20288, '2017-02-16 16:35:50', NULL, NULL, 6912, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 16:35:50', 'admin-1487215491-14872341505945118', 1, 1, 'SR', NULL, NULL, NULL),
(20289, '2017-02-16 15:42:40', NULL, NULL, 6909, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1487215491', 'admin', '2017-02-16 15:42:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20290, '2017-02-16 10:23:17', NULL, NULL, 6893, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1487215491', 'admin', '2017-02-16 10:23:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20291, '2017-02-16 10:23:24', NULL, NULL, 6893, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 10:23:24', 'admin-1487206907-14872118041206865', 1, 0, '', NULL, NULL, NULL),
(20292, '2017-02-16 10:23:24', NULL, NULL, 6893, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 10:23:24', 'admin-1487206907-14872118041206865', 1, 1, 'SR', NULL, NULL, NULL),
(20293, '2017-02-16 10:25:17', NULL, NULL, 6893, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 10:25:17', 'admin-1487206907-14872119168755222', 1, 1, 'SR', NULL, NULL, NULL),
(20294, '2017-02-16 10:25:17', NULL, NULL, 6893, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 10:25:17', 'admin-1487206907-14872119168755222', 1, 0, '', NULL, NULL, NULL),
(20295, '2017-02-16 10:27:47', NULL, NULL, 6894, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1487215491', 'admin', '2017-02-16 10:27:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20296, '2017-02-16 10:27:51', NULL, NULL, 6894, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 10:27:51', 'admin-1487206907-1487212071722927', 1, 1, 'SR', NULL, NULL, NULL),
(20297, '2017-02-16 10:27:51', NULL, NULL, 6894, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 10:27:51', 'admin-1487206907-1487212071722927', 1, 1, 'SR', NULL, NULL, NULL),
(20298, '2017-02-16 10:33:29', NULL, NULL, 6891, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 10:33:29', 'admin-1487206907-1487212409249351', 1, 0, '', NULL, NULL, NULL),
(20299, '2017-02-16 10:33:29', NULL, NULL, 6891, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 10:33:29', 'admin-1487206907-1487212409249351', 1, 0, '', NULL, NULL, NULL),
(20300, '2017-02-16 10:33:34', NULL, NULL, 6891, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 10:33:34', 'admin-1487206907-14872124143939076', 1, 1, 'SR', NULL, NULL, NULL),
(20301, '2017-02-16 12:49:31', NULL, NULL, 6901, 0, 85, '85', 'Set Meatless Aglio Olio ', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 12:49:31', 'admin-1487215491-14872205710933354', 1, 1, 'SR', NULL, NULL, NULL),
(20302, '2017-02-16 12:49:38', NULL, NULL, 6901, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 12:49:38', 'admin-1487215491-1487220578029933', 1, 0, '', NULL, NULL, NULL),
(20303, '2017-02-16 12:49:38', NULL, NULL, 6901, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 12:49:38', 'admin-1487215491-1487220578029933', 1, 0, '', NULL, NULL, NULL),
(20304, '2017-02-16 12:55:53', NULL, NULL, 6902, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1487215491', 'admin', '2017-02-16 12:55:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20305, '2017-02-16 12:56:27', NULL, NULL, 6902, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 12:56:27', 'admin-1487215491-1487220987749551', 1, 0, '', NULL, NULL, NULL),
(20306, '2017-02-16 12:56:27', NULL, NULL, 6902, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 12:56:27', 'admin-1487215491-1487220987749551', 1, 0, '', NULL, NULL, NULL),
(20307, '2017-02-16 12:56:27', NULL, NULL, 6902, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 12:56:27', 'admin-1487215491-1487220987749551', 1, 0, '', NULL, NULL, NULL),
(20308, '2017-02-16 13:20:16', NULL, NULL, 6901, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 13:20:16', 'admin-1487215491-14872224164062816', 1, 0, '', NULL, NULL, NULL),
(20309, '2017-02-16 13:37:58', NULL, NULL, 6903, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1487215491', 'admin', '2017-02-16 13:37:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20310, '2017-02-16 13:38:03', NULL, NULL, 6903, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 13:38:03', 'admin-1487215491-14872234831604725', 1, 0, '', NULL, NULL, NULL),
(20311, '2017-02-16 13:38:03', NULL, NULL, 6903, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 13:38:03', 'admin-1487215491-14872234831604725', 1, 0, '', NULL, NULL, NULL),
(20312, '2017-02-16 13:47:24', NULL, NULL, 6904, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 13:47:24', 'admin-1487215491-1487224044553355', 1, 1, 'SR', NULL, NULL, NULL),
(20313, '2017-02-16 13:47:24', NULL, NULL, 6904, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 13:47:24', 'admin-1487215491-1487224044553355', 1, 1, 'SR', NULL, NULL, NULL),
(20314, '2017-02-16 14:11:19', NULL, NULL, 6905, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1487215491', 'admin', '2017-02-16 14:11:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20315, '2017-02-16 14:11:37', NULL, NULL, 6905, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 14:11:37', 'admin-1487215491-14872254974164522', 1, 1, 'SR', NULL, NULL, NULL),
(20316, '2017-02-16 14:44:18', NULL, NULL, 6907, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 14:44:18', 'admin-1487215491-14872274587852887', 1, 0, '', NULL, NULL, NULL),
(20317, '2017-02-16 14:44:18', NULL, NULL, 6907, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 14:44:18', 'admin-1487215491-14872274587852887', 1, 1, 'SR', NULL, NULL, NULL),
(20318, '2017-02-16 14:44:31', NULL, NULL, 6907, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 14:44:31', 'admin-1487215491-14872274715263574', 1, 1, 'SR', NULL, NULL, NULL),
(20319, '2017-02-16 14:16:44', NULL, NULL, 6906, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 14:16:44', 'admin-1487215491-14872258039318138', 1, 1, 'SR', 1, NULL, NULL),
(20320, '2017-02-16 19:22:20', NULL, NULL, 6917, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 19:22:20', 'admin-1487215491-14872441401989188', 1, 1, 'SR', NULL, NULL, NULL),
(20321, '2017-02-16 19:22:20', NULL, NULL, 6917, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 19:22:20', 'admin-1487215491-14872441401989188', 1, 1, 'SR', NULL, NULL, NULL),
(20322, '2017-02-16 19:33:36', NULL, NULL, 6917, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 19:33:36', 'admin-1487215491-14872448163919116', 1, 0, '', NULL, NULL, NULL),
(20323, '2017-02-16 19:22:08', NULL, NULL, 6917, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1487215491', 'admin', '2017-02-16 19:22:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20324, '2017-02-16 19:10:55', NULL, NULL, 6916, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 19:10:55', 'admin-1487215491-14872434557956482', 1, 1, 'SR', NULL, NULL, NULL),
(20325, '2017-02-16 19:10:55', NULL, NULL, 6916, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 19:10:55', 'admin-1487215491-14872434557956482', 1, 1, 'SR', NULL, NULL, NULL),
(20326, '2017-02-16 18:43:57', NULL, NULL, 6915, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 18:43:57', 'admin-1487215491-14872418375243757', 1, 1, 'SR', 1, NULL, NULL),
(20327, '2017-02-16 19:10:43', NULL, NULL, 6916, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1487215491', 'admin', '2017-02-16 19:10:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20328, '2017-02-16 16:39:42', NULL, NULL, 6914, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1487215491', 'admin', '2017-02-16 16:39:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20329, '2017-02-16 16:40:16', NULL, NULL, 6914, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 16:40:16', 'admin-1487215491-14872344166334233', 1, 1, 'SR', NULL, NULL, NULL),
(20330, '2017-02-16 16:36:24', NULL, NULL, 6913, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 16:36:24', 'admin-1487215491-14872341841833424', 1, 1, 'SR', NULL, NULL, NULL),
(20331, '2017-02-16 16:36:24', NULL, NULL, 6913, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 16:36:24', 'admin-1487215491-14872341841833424', 1, 0, '', NULL, NULL, NULL),
(20332, '2017-02-16 16:36:15', NULL, NULL, 6913, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1487215491', 'admin', '2017-02-16 16:36:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20333, '2017-02-16 15:19:43', NULL, NULL, 6908, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 15:19:43', 'admin-1487215491-14872295829354099', 1, 1, 'SR', NULL, NULL, NULL),
(20334, '2017-02-16 14:29:03', NULL, NULL, 6905, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 14:29:03', 'admin-1487215491-14872265430588761', 1, 1, 'SR', NULL, NULL, NULL),
(20335, '2017-02-16 14:44:31', NULL, NULL, 6907, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 14:44:31', 'admin-1487215491-14872274715263574', 1, 0, '', NULL, NULL, NULL),
(20336, '2017-02-16 15:19:43', NULL, NULL, 6908, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 15:19:43', 'admin-1487215491-14872295829354099', 1, 1, 'SR', NULL, NULL, NULL),
(20337, '2017-02-16 14:44:09', NULL, NULL, 6907, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1487215491', 'admin', '2017-02-16 14:44:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20338, '2017-02-16 15:18:01', NULL, NULL, 6908, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1487215491', 'admin', '2017-02-16 15:18:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20339, '2017-02-16 10:19:32', NULL, NULL, 6892, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 10:19:32', 'admin-1487206907-14872115718896560', 1, 0, '', NULL, NULL, NULL),
(20340, '2017-02-16 11:15:34', NULL, NULL, 6896, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1487215491', 'admin', '2017-02-16 11:15:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20341, '2017-02-16 11:15:38', NULL, NULL, 6896, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 11:15:38', 'admin-1487206907-14872149386228872', 1, 1, 'SR', NULL, NULL, NULL),
(20342, '2017-02-16 11:17:46', NULL, NULL, 6895, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 11:17:46', 'admin-1487206907-14872150662502664', 1, 1, 'SR', NULL, NULL, NULL),
(20343, '2017-02-16 11:24:45', NULL, NULL, 6897, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 11:24:45', 'admin-1487206907-1487215485528857', 1, 1, 'SR', 1, NULL, NULL),
(20344, '2017-02-16 11:45:51', NULL, NULL, 6898, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1487215491', 'admin', '2017-02-16 11:45:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20345, '2017-02-16 11:45:55', NULL, NULL, 6898, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 11:45:55', 'admin-1487215491-14872167551956698', 1, 1, 'SR', NULL, NULL, NULL),
(20346, '2017-02-16 11:49:49', NULL, NULL, 6899, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1487215491', 'admin', '2017-02-16 11:49:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20347, '2017-02-16 11:49:57', NULL, NULL, 6899, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 11:49:57', 'admin-1487215491-14872169969396625', 1, 1, 'SR', NULL, NULL, NULL),
(20348, '2017-02-16 11:53:54', NULL, NULL, 6900, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1487215491', 'admin', '2017-02-16 11:53:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20349, '2017-02-16 11:54:00', NULL, NULL, 6900, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 11:54:00', 'admin-1487215491-1487217239884542', 1, 1, 'SR', NULL, NULL, NULL),
(20350, '2017-02-16 12:49:17', NULL, NULL, 6901, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1487215491', 'admin', '2017-02-16 12:49:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20351, '2017-02-16 12:49:31', NULL, NULL, 6901, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 12:49:31', 'admin-1487215491-14872205710933354', 1, 1, 'SR', NULL, NULL, NULL),
(20352, '2017-02-16 12:49:31', NULL, NULL, 6901, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 12:49:31', 'admin-1487215491-14872205710933354', 1, 1, 'SR', NULL, NULL, NULL),
(20353, '2017-02-16 10:19:32', NULL, NULL, 6892, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 10:19:32', 'admin-1487206907-14872115718896560', 1, 1, 'SR', NULL, NULL, NULL),
(20354, '2017-02-16 10:19:32', NULL, NULL, 6892, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 10:19:32', 'admin-1487206907-14872115718896560', 1, 0, '', NULL, NULL, NULL),
(20355, '2017-02-16 11:15:29', NULL, NULL, 6895, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1487215491', 'admin', '2017-02-16 11:15:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20356, '2017-02-16 10:19:32', NULL, NULL, 6892, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 10:19:32', 'admin-1487206907-14872115718896560', 1, 0, '', NULL, NULL, NULL),
(20357, '2017-02-16 09:18:11', NULL, NULL, 6890, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 09:18:11', 'admin-1487206907-14872078912082859', 1, 0, '', NULL, NULL, NULL),
(20358, '2017-02-16 10:19:21', NULL, NULL, 6892, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1487215491', 'admin', '2017-02-16 10:19:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20359, '2017-02-16 09:49:38', NULL, NULL, 6891, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 09:49:38', 'admin-1487206907-1487209778740632', 1, 1, 'SR', NULL, NULL, NULL),
(20360, '2017-02-16 09:49:35', NULL, NULL, 6891, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1487215491', 'admin', '2017-02-16 09:49:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20361, '2017-02-16 09:18:11', NULL, NULL, 6890, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 09:18:11', 'admin-1487206907-14872078912082859', 1, 0, '', NULL, NULL, NULL),
(20362, '2017-02-16 09:18:17', NULL, NULL, 6890, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487215491', 'admin', '2017-02-16 09:18:17', 'admin-1487206907-14872078972034115', 1, 1, 'SR', NULL, NULL, NULL),
(20363, '2017-02-16 09:18:03', NULL, NULL, 6890, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1487215491', 'admin', '2017-02-16 09:18:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20364, '2017-02-17 17:30:07', NULL, NULL, 6943, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 17:30:07', 'admin-1487308134-1487323807457395', 1, 1, 'SR', NULL, NULL, NULL),
(20365, '2017-02-17 13:48:59', NULL, NULL, 6937, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:48:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20366, '2017-02-17 13:29:35', NULL, NULL, 6933, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:29:35', 'admin-1487308134-14873093757709281', 1, 1, 'SR', NULL, NULL, '10.0'),
(20367, '2017-02-17 13:30:27', NULL, NULL, 6935, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:30:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20368, '2017-02-17 13:30:32', NULL, NULL, 6935, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:30:32', 'admin-1487308134-1487309432660583', 1, 0, '', NULL, NULL, NULL),
(20369, '2017-02-17 13:34:11', NULL, NULL, 6934, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:34:11', 'admin-1487308134-14873096512267116', 1, 1, 'SR', NULL, NULL, NULL),
(20370, '2017-02-17 13:34:31', NULL, NULL, 6935, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:34:31', 'admin-1487308134-14873096711427821', 1, 1, 'SR', NULL, NULL, NULL),
(20371, '2017-02-17 13:34:36', NULL, NULL, 6935, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:34:36', 'admin-1487308134-14873096765785026', 1, 1, 'SR', NULL, NULL, NULL),
(20372, '2017-02-17 13:41:34', NULL, NULL, 6933, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:41:34', 'admin-1487308134-14873100941081374', 1, 1, 'SR', NULL, NULL, '10.0'),
(20373, '2017-02-17 13:44:16', NULL, NULL, 6932, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:44:16', 'admin-1487308134-14873102558073116', 1, 1, 'SR', NULL, NULL, NULL),
(20374, '2017-02-17 13:08:43', NULL, NULL, 6933, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:08:43', 'admin-1487305904-1487308123007136', 1, 0, '', NULL, NULL, '10.0'),
(20375, '2017-02-17 13:08:43', NULL, NULL, 6933, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:08:43', 'admin-1487305904-1487308123007136', 1, 0, '', NULL, NULL, '10.0'),
(20376, '2017-02-17 13:08:43', NULL, NULL, 6933, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:08:43', 'admin-1487305904-1487308123007136', 1, 0, '', NULL, NULL, '10.0'),
(20377, '2017-02-17 13:16:30', NULL, NULL, 6925, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:16:30', 'admin-1487308134-14873085903178069', 1, 1, 'SR', NULL, NULL, NULL),
(20378, '2017-02-17 13:16:30', NULL, NULL, 6925, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:16:30', 'admin-1487308134-14873085903178069', 1, 1, 'SR', NULL, NULL, NULL),
(20379, '2017-02-17 13:16:30', NULL, NULL, 6925, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:16:30', 'admin-1487308134-14873085903178069', 1, 0, '', NULL, NULL, NULL),
(20380, '2017-02-17 13:16:30', NULL, NULL, 6925, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:16:30', 'admin-1487308134-14873085903178069', 1, 1, 'SR', NULL, NULL, NULL),
(20381, '2017-02-17 16:15:01', NULL, NULL, 6940, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 16:15:01', 'admin-1487308134-14873193016064475', 1, 0, '', NULL, NULL, NULL),
(20382, '2017-02-17 16:15:01', NULL, NULL, 6940, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 16:15:01', 'admin-1487308134-14873193016064475', 1, 1, 'SR', NULL, NULL, NULL),
(20383, '2017-02-17 16:23:22', NULL, NULL, 6941, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1487308134', 'admin', '2017-02-17 16:23:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20384, '2017-02-17 16:23:26', NULL, NULL, 6941, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 16:23:26', 'admin-1487308134-14873198061005620', 1, 1, 'SR', NULL, NULL, NULL),
(20385, '2017-02-17 16:23:44', NULL, NULL, 6941, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 16:23:44', 'admin-1487308134-14873198241683386', 1, 1, 'SR', NULL, NULL, NULL),
(20386, '2017-02-17 16:23:44', NULL, NULL, 6941, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 16:23:44', 'admin-1487308134-14873198241683386', 1, 1, 'SR', NULL, NULL, NULL),
(20387, '2017-02-17 18:28:15', NULL, NULL, 6944, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1487308134', 'admin', '2017-02-17 18:28:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20388, '2017-02-17 16:50:01', NULL, NULL, 6942, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1487308134', 'admin', '2017-02-17 16:50:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20389, '2017-02-17 16:50:08', NULL, NULL, 6942, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 16:50:08', 'admin-1487308134-14873214079241040', 1, 1, 'SR', NULL, NULL, NULL),
(20390, '2017-02-17 12:25:54', NULL, NULL, 6928, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:25:54', 'admin-1487300076-14873055541024319', 1, 0, '', NULL, NULL, NULL),
(20391, '2017-02-17 12:25:54', NULL, NULL, 6928, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:25:54', 'admin-1487300076-14873055541024319', 1, 0, '', NULL, NULL, NULL),
(20392, '2017-02-17 17:30:07', NULL, NULL, 6943, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 17:30:07', 'admin-1487308134-1487323807457395', 1, 1, 'SR', NULL, NULL, NULL),
(20393, '2017-02-17 18:28:28', NULL, NULL, 6944, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 18:28:28', 'admin-1487308134-14873273079811960', 1, 0, '', NULL, NULL, NULL),
(20394, '2017-02-17 18:30:31', NULL, NULL, 6944, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 18:30:31', 'admin-1487308134-14873274312838282', 1, 1, 'SR', NULL, NULL, NULL),
(20395, '2017-02-17 18:57:06', NULL, NULL, 6945, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 18:57:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20396, '2017-02-17 18:57:12', NULL, NULL, 6945, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 18:57:12', 'admin-1487308134-14873290322829466', 1, 1, 'SR', NULL, NULL, NULL),
(20397, '2017-02-17 18:57:12', NULL, NULL, 6945, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 18:57:12', 'admin-1487308134-14873290322829466', 1, 1, 'SR', NULL, NULL, NULL),
(20398, '2017-02-17 19:09:59', NULL, NULL, 6946, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1487308134', 'admin', '2017-02-17 19:09:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20399, '2017-02-17 19:10:04', NULL, NULL, 6946, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 19:10:04', 'admin-1487308134-14873298041149519', 1, 0, '', NULL, NULL, NULL),
(20400, '2017-02-17 17:30:07', NULL, NULL, 6943, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 17:30:07', 'admin-1487308134-1487323807457395', 1, 0, '', NULL, NULL, NULL),
(20401, '2017-02-17 17:34:24', NULL, NULL, 6941, 0, 70, '70', 'Pepper Pork', 'fried egg', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 17:34:24', 'admin-1487308134-1487324064411632', 1, 1, 'SR', NULL, NULL, NULL),
(20402, '2017-02-17 09:52:53', NULL, NULL, 6919, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 09:52:53', 'admin-1487293216-14872963729073163', 1, 1, 'SR', NULL, NULL, NULL),
(20403, '2017-02-17 10:54:58', NULL, NULL, 6921, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 10:54:58', 'admin-1487300076-14873000982421435', 1, 1, 'SR', NULL, NULL, NULL),
(20404, '2017-02-17 10:54:58', NULL, NULL, 6921, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 10:54:58', 'admin-1487300076-14873000982421435', 1, 1, 'SR', NULL, NULL, NULL),
(20405, '2017-02-17 11:29:13', NULL, NULL, 6922, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1487308134', 'admin', '2017-02-17 11:29:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20406, '2017-02-17 11:29:21', NULL, NULL, 6922, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 11:29:21', 'admin-1487300076-14873021614441888', 1, 0, '', NULL, NULL, NULL),
(20407, '2017-02-17 11:29:21', NULL, NULL, 6922, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 11:29:21', 'admin-1487300076-14873021614441888', 1, 0, '', NULL, NULL, NULL),
(20408, '2017-02-17 11:29:30', NULL, NULL, 6922, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 11:29:30', 'admin-1487300076-1487302169913936', 1, 1, 'SR', NULL, NULL, NULL),
(20409, '2017-02-17 11:29:30', NULL, NULL, 6922, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 11:29:30', 'admin-1487300076-1487302169913936', 1, 1, 'SR', NULL, NULL, NULL),
(20410, '2017-02-17 11:48:59', NULL, NULL, 6923, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1487308134', 'admin', '2017-02-17 11:48:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20411, '2017-02-17 11:49:09', NULL, NULL, 6923, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 11:49:09', 'admin-1487300076-1487303349145229', 1, 1, 'SR', NULL, NULL, NULL),
(20412, '2017-02-17 11:49:09', NULL, NULL, 6923, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 11:49:09', 'admin-1487300076-1487303349145229', 1, 1, 'SR', NULL, NULL, NULL),
(20413, '2017-02-17 11:52:16', NULL, NULL, 6924, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1487308134', 'admin', '2017-02-17 11:52:16', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(20414, '2017-02-17 11:52:20', NULL, NULL, 6924, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 11:52:20', 'admin-1487300076-14873035399936718', 1, 0, '', NULL, NULL, '10.0'),
(20415, '2017-02-17 11:52:24', NULL, NULL, 6924, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 11:52:24', 'admin-1487300076-14873035444446984', 1, 1, 'SR', NULL, NULL, '10.0'),
(20416, '2017-02-17 11:52:24', NULL, NULL, 6924, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 11:52:24', 'admin-1487300076-14873035444446984', 1, 1, 'SR', NULL, NULL, '10.0'),
(20417, '2017-02-17 11:54:38', NULL, NULL, 6925, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 11:54:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20418, '2017-02-17 11:54:43', NULL, NULL, 6925, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 11:54:43', 'admin-1487300076-1487303683367165', 1, 1, 'SR', NULL, NULL, NULL),
(20419, '2017-02-17 11:54:43', NULL, NULL, 6925, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 11:54:43', 'admin-1487300076-1487303683367165', 1, 1, 'SR', NULL, NULL, NULL),
(20420, '2017-02-17 12:14:20', NULL, NULL, 6924, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:14:20', 'admin-1487300076-14873048602552870', 1, 0, '', NULL, NULL, '10.0'),
(20421, '2017-02-17 12:14:38', NULL, NULL, 6926, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:14:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20422, '2017-02-17 12:15:06', NULL, NULL, 6926, 0, 82, '82', 'Set Stir Fried Rice Wine Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:15:06', 'admin-1487300076-14873049066468275', 1, 1, 'SR', NULL, NULL, NULL),
(20423, '2017-02-17 12:15:06', NULL, NULL, 6926, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:15:06', 'admin-1487300076-14873049066468275', 1, 0, '', NULL, NULL, NULL),
(20424, '2017-02-17 12:15:06', NULL, NULL, 6926, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:15:06', 'admin-1487300076-14873049066468275', 1, 0, '', NULL, NULL, NULL),
(20425, '2017-02-17 12:16:09', NULL, NULL, 6926, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:16:09', 'admin-1487300076-14873049693366236', 1, 1, 'SR', NULL, NULL, NULL),
(20426, '2017-02-17 12:23:03', NULL, NULL, 6927, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:23:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20427, '2017-02-17 12:24:57', NULL, NULL, 6927, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:24:57', 'admin-1487300076-14873054968905622', 1, 1, 'SR', NULL, NULL, NULL),
(20428, '2017-02-17 13:44:42', NULL, NULL, 6932, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:44:42', 'admin-1487308134-1487310282538593', 1, 0, '', NULL, NULL, NULL),
(20429, '2017-02-17 13:46:06', NULL, NULL, 6936, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:46:06', 'admin-1487308134-14873103660576771', 1, 0, '', 1, NULL, NULL),
(20430, '2017-02-17 13:46:06', NULL, NULL, 6936, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:46:06', 'admin-1487308134-14873103660576771', 1, 0, '', 1, NULL, NULL),
(20431, '2017-02-17 13:48:10', NULL, NULL, 6930, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:48:10', 'admin-1487308134-14873104902232061', 1, 0, '', NULL, NULL, NULL),
(20432, '2017-02-17 00:00:00', NULL, NULL, 6937, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:28:58', 'admin-1487308134-14873093384337732', 1, 1, 'SR', NULL, NULL, NULL),
(20433, '2017-02-17 14:00:41', NULL, NULL, 6925, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 14:00:41', 'admin-1487308134-14873112408485075', 1, 0, '', NULL, NULL, NULL),
(20434, '2017-02-17 14:00:41', NULL, NULL, 6925, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 14:00:41', 'admin-1487308134-14873112408485075', 1, 0, '', NULL, NULL, NULL),
(20435, '2017-02-17 14:05:01', NULL, NULL, 6938, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1487308134', 'admin', '2017-02-17 14:05:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20436, '2017-02-17 14:05:08', NULL, NULL, 6938, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 14:05:08', 'admin-1487308134-14873115080057015', 1, 1, 'SR', NULL, NULL, NULL),
(20437, '2017-02-17 15:54:47', NULL, NULL, 6939, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1487308134', 'admin', '2017-02-17 15:54:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20438, '2017-02-17 15:55:03', NULL, NULL, 6939, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 15:55:03', 'admin-1487308134-1487318103345756', 1, 1, 'SR', NULL, NULL, NULL),
(20439, '2017-02-17 15:55:03', NULL, NULL, 6939, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 15:55:03', 'admin-1487308134-1487318103345756', 1, 0, '', NULL, NULL, NULL),
(20440, '2017-02-17 16:14:51', NULL, NULL, 6940, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1487308134', 'admin', '2017-02-17 16:14:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20441, '2017-02-17 17:29:41', NULL, NULL, 6943, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1487308134', 'admin', '2017-02-17 17:29:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20442, '2017-02-17 13:08:43', NULL, NULL, 6933, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:08:43', 'admin-1487305904-1487308123007136', 1, 1, 'SR', NULL, NULL, '10.0'),
(20443, '2017-02-17 13:08:43', NULL, NULL, 6933, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:08:43', 'admin-1487305904-1487308123007136', 1, 0, '', NULL, NULL, '10.0'),
(20444, '2017-02-17 12:53:01', NULL, NULL, 6932, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:53:01', 'admin-1487305904-14873071816632479', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(20445, '2017-02-17 12:53:01', NULL, NULL, 6932, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:53:01', 'admin-1487305904-14873071816632479', 1, 0, '', NULL, NULL, NULL),
(20446, '2017-02-17 12:53:01', NULL, NULL, 6932, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:53:01', 'admin-1487305904-14873071816632479', 1, 0, '', NULL, NULL, NULL),
(20447, '2017-02-17 12:53:01', NULL, NULL, 6932, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:53:01', 'admin-1487305904-14873071816632479', 1, 0, '', NULL, NULL, NULL),
(20448, '2017-02-17 13:03:55', NULL, NULL, 6933, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:03:55', 'admin-1487305904-14873078348385214', 1, 0, '', NULL, NULL, '10.0'),
(20449, '2017-02-17 13:03:55', NULL, NULL, 6933, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:03:55', 'admin-1487305904-14873078348385214', 1, 0, '', NULL, NULL, '10.0'),
(20450, '2017-02-17 13:06:38', NULL, NULL, 6928, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:06:38', 'admin-1487305904-14873079978049572', 1, 0, '', NULL, NULL, NULL),
(20451, '2017-02-17 13:06:38', NULL, NULL, 6928, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:06:38', 'admin-1487305904-14873079978049572', 1, 0, '', NULL, NULL, NULL),
(20452, '2017-02-17 13:07:01', NULL, NULL, 6932, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:07:01', 'admin-1487305904-14873080213506570', 1, 1, 'SR', NULL, NULL, NULL),
(20453, '2017-02-17 12:51:23', NULL, NULL, 6931, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:51:23', 'admin-1487305904-14873070831699816', 1, 0, '', NULL, NULL, NULL),
(20454, '2017-02-17 12:51:38', NULL, NULL, 6931, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:51:38', 'admin-1487305904-14873070986511232', 1, 1, 'SR', NULL, NULL, NULL),
(20455, '2017-02-17 12:51:38', NULL, NULL, 6931, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:51:38', 'admin-1487305904-14873070986511232', 1, 1, 'SR', NULL, NULL, NULL),
(20456, '2017-02-17 12:52:27', NULL, NULL, 6932, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:52:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20457, '2017-02-17 12:47:18', NULL, NULL, 6930, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:47:18', 'admin-1487305904-14873068379939496', 1, 1, 'SR', NULL, NULL, NULL),
(20458, '2017-02-17 12:47:18', NULL, NULL, 6930, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:47:18', 'admin-1487305904-14873068379939496', 1, 1, 'SR', NULL, NULL, NULL),
(20459, '2017-02-17 12:47:18', NULL, NULL, 6930, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:47:18', 'admin-1487305904-14873068379939496', 1, 1, 'SR', NULL, NULL, NULL),
(20460, '2017-02-17 12:51:17', NULL, NULL, 6931, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:51:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20461, '2017-02-17 12:43:28', NULL, NULL, 6928, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:43:28', 'admin-1487305904-1487306608599528', 1, 0, '', NULL, NULL, NULL),
(20462, '2017-02-17 13:28:37', NULL, NULL, 6934, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:28:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20463, '2017-02-17 12:47:02', NULL, NULL, 6930, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:47:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20464, '2017-02-17 12:47:18', NULL, NULL, 6930, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:47:18', 'admin-1487305904-14873068379939496', 1, 1, 'SR', NULL, NULL, NULL),
(20465, '2017-02-17 12:47:18', NULL, NULL, 6930, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:47:18', 'admin-1487305904-14873068379939496', 1, 0, '', NULL, NULL, NULL),
(20466, '2017-02-17 12:37:50', NULL, NULL, 6929, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:37:50', 'admin-1487305904-14873062698707681', 1, 0, '', NULL, NULL, NULL),
(20467, '2017-02-17 12:37:35', NULL, NULL, 6929, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:37:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20468, '2017-02-17 12:37:50', NULL, NULL, 6929, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:37:50', 'admin-1487305904-14873062698707681', 1, 1, 'SR', NULL, NULL, NULL),
(20469, '2017-02-17 12:25:54', NULL, NULL, 6928, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:25:54', 'admin-1487300076-14873055541024319', 1, 0, '', NULL, NULL, NULL),
(20470, '2017-02-17 13:03:41', NULL, NULL, 6933, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.10, 0.0000, 0.0000, 12.10, 1, '27', 1, '1487308134', 'admin', '2017-02-17 13:03:41', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(20471, '2017-02-17 12:25:21', NULL, NULL, 6928, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.60, 0.0000, 0.0000, 12.60, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:25:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20472, '2017-02-17 12:25:54', NULL, NULL, 6928, 0, 81, '81', 'Set Pepper Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:25:54', 'admin-1487300076-14873055541024319', 1, 1, 'SR', NULL, NULL, NULL),
(20473, '2017-02-17 12:25:54', NULL, NULL, 6928, 0, 213, '147', 'Set Stir Fried Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:25:54', 'admin-1487300076-14873055541024319', 1, 0, '', NULL, NULL, NULL),
(20474, '2017-02-17 12:25:54', NULL, NULL, 6928, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:25:54', 'admin-1487300076-14873055541024319', 1, 0, '', NULL, NULL, NULL),
(20475, '2017-02-17 12:25:54', NULL, NULL, 6928, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:25:54', 'admin-1487300076-14873055541024319', 1, 1, 'SR', NULL, NULL, NULL),
(20476, '2017-02-17 12:24:57', NULL, NULL, 6927, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:24:57', 'admin-1487300076-14873054968905622', 1, 1, 'SR', NULL, NULL, NULL),
(20477, '2017-02-17 12:24:57', NULL, NULL, 6927, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:24:57', 'admin-1487300076-14873054968905622', 1, 1, 'SR', NULL, NULL, NULL),
(20478, '2017-02-17 12:24:57', NULL, NULL, 6927, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:24:57', 'admin-1487300076-14873054968905622', 1, 0, '', NULL, NULL, NULL),
(20479, '2017-02-17 12:24:57', NULL, NULL, 6927, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:24:57', 'admin-1487300076-14873054968905622', 1, 0, '', NULL, NULL, NULL),
(20480, '2017-02-17 12:24:57', NULL, NULL, 6927, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 12:24:57', 'admin-1487300076-14873054968905622', 1, 0, '', NULL, NULL, NULL),
(20481, '2017-02-17 10:10:18', NULL, NULL, 6920, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 10:10:18', 'admin-1487293216-14872974186423818', 1, 1, 'SR', NULL, NULL, NULL),
(20482, '2017-02-17 10:10:18', NULL, NULL, 6920, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 10:10:18', 'admin-1487293216-14872974186423818', 1, 0, '', NULL, NULL, NULL),
(20483, '2017-02-17 10:18:46', NULL, NULL, 6920, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 10:18:46', 'admin-1487293216-14872979260489914', 1, 0, '', NULL, NULL, NULL),
(20484, '2017-02-17 10:18:51', NULL, NULL, 6920, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 10:18:51', 'admin-1487293216-14872979315131579', 1, 1, 'SR', NULL, NULL, NULL),
(20485, '2017-02-17 10:20:28', NULL, NULL, 6920, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 10:20:28', 'admin-1487293216-14872980281135990', 1, 0, '', NULL, NULL, NULL),
(20486, '2017-02-17 10:20:32', NULL, NULL, 6920, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 10:20:32', 'admin-1487293216-14872980322527942', 1, 1, 'SR', NULL, NULL, NULL),
(20487, '2017-02-17 10:45:54', NULL, NULL, 6920, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 10:45:54', 'admin-1487293216-1487299553809323', 1, 0, '', NULL, NULL, NULL),
(20488, '2017-02-17 10:46:00', NULL, NULL, 6920, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 10:46:00', 'admin-1487293216-14872995603573567', 1, 1, 'SR', NULL, NULL, NULL),
(20489, '2017-02-17 10:48:33', NULL, NULL, 6920, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 10:48:33', 'admin-1487293216-14872997130828460', 1, 0, '', NULL, NULL, NULL),
(20490, '2017-02-17 10:48:33', NULL, NULL, 6920, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 10:48:33', 'admin-1487293216-14872997130828460', 1, 1, 'SR', NULL, NULL, NULL),
(20491, '2017-02-17 10:54:45', NULL, NULL, 6919, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 10:54:45', 'admin-1487300076-14873000857591068', 1, 0, '', NULL, NULL, NULL),
(20492, '2017-02-17 10:54:50', NULL, NULL, 6921, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1487308134', 'admin', '2017-02-17 10:54:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20493, '2017-02-17 09:52:53', NULL, NULL, 6919, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 09:52:53', 'admin-1487293216-14872963729073163', 1, 1, 'SR', NULL, NULL, NULL),
(20494, '2017-02-17 09:39:49', NULL, NULL, 6919, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 09:39:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20495, '2017-02-17 10:10:09', NULL, NULL, 6920, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.20, 0.0000, 0.0000, 13.20, 1, '27', 1, '1487308134', 'admin', '2017-02-17 10:10:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20496, '2017-02-17 09:34:29', NULL, NULL, 6918, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 09:34:29', 'admin-1487293216-14872952690361246', 1, 1, 'SR', NULL, NULL, NULL),
(20497, '2017-02-17 09:34:23', NULL, NULL, 6918, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 09:34:23', 'admin-1487293216-14872952631034317', 1, 0, '', NULL, NULL, NULL),
(20498, '2017-02-17 09:34:29', NULL, NULL, 6918, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 09:34:29', 'admin-1487293216-14872952690361246', 1, 1, 'SR', NULL, NULL, NULL),
(20499, '2017-02-17 09:34:23', NULL, NULL, 6918, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487308134', 'admin', '2017-02-17 09:34:23', 'admin-1487293216-14872952631034317', 1, 0, '', NULL, NULL, NULL),
(20500, '2017-02-17 09:34:15', NULL, NULL, 6918, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1487308134', 'admin', '2017-02-17 09:34:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20501, '2017-02-18 16:20:58', NULL, NULL, 6982, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1487418467', 'admin', '2017-02-18 16:20:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20502, '2017-02-18 00:00:00', NULL, NULL, 6981, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, NULL, NULL, 6.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 16:15:35', 'admin-1487397442-14874057354363256', 1, 1, 'SR', NULL, NULL, NULL),
(20503, '2017-02-18 16:25:27', NULL, NULL, 6983, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 16:25:27', 'admin-1487397442-14874063277335971', 1, 0, '', NULL, NULL, NULL),
(20504, '2017-02-18 16:33:50', NULL, NULL, 6984, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 16:33:50', 'admin-1487397442-14874068299051583', 1, 1, 'SR', 1, NULL, NULL),
(20505, '2017-02-18 16:48:38', NULL, NULL, 6985, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1487418467', 'admin', '2017-02-18 16:48:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20506, '2017-02-18 16:48:46', NULL, NULL, 6985, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 16:48:46', 'admin-1487397442-14874077256677214', 1, 0, '', NULL, NULL, NULL),
(20507, '2017-02-18 15:22:29', NULL, NULL, 6977, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 15:22:29', 'admin-1487397442-14874025488051496', 1, 1, 'SR', NULL, NULL, NULL),
(20508, '2017-02-18 15:57:33', NULL, NULL, 6978, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 15:57:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20509, '2017-02-18 13:24:19', NULL, NULL, 6972, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:24:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20510, '2017-02-18 13:24:29', NULL, NULL, 6972, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:24:29', 'admin-1487392068-14873954689583124', 1, 0, '', NULL, NULL, NULL),
(20511, '2017-02-18 13:27:45', NULL, NULL, 6973, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:27:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20512, '2017-02-18 13:28:23', NULL, NULL, 6973, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:28:23', 'admin-1487392068-14873957032922334', 1, 0, '', NULL, NULL, NULL),
(20513, '2017-02-18 11:19:05', NULL, NULL, 6959, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:19:05', 'admin-1487386808-1487387945679460', 1, 0, '', NULL, NULL, NULL),
(20514, '2017-02-18 11:19:05', NULL, NULL, 6959, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:19:05', 'admin-1487386808-1487387945679460', 1, 0, '', NULL, NULL, NULL),
(20515, '2017-02-18 11:19:05', NULL, NULL, 6959, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:19:05', 'admin-1487386808-1487387945679460', 1, 1, 'SR', NULL, NULL, NULL),
(20516, '2017-02-18 11:19:05', NULL, NULL, 6959, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:19:05', 'admin-1487386808-1487387945679460', 1, 1, 'SR', NULL, NULL, NULL),
(20517, '2017-02-18 13:31:25', NULL, NULL, 6974, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:31:25', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(20518, '2017-02-18 13:31:36', NULL, NULL, 6974, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:31:36', 'admin-1487392068-14873958963792329', 1, 0, '', NULL, NULL, '10.0'),
(20519, '2017-02-18 13:32:49', NULL, NULL, 6974, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:32:49', 'admin-1487395910-14873959692393984', 1, 1, 'SR', NULL, NULL, '10.0'),
(20520, '2017-02-18 13:51:52', NULL, NULL, 6975, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:51:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20521, '2017-02-18 13:52:13', NULL, NULL, 6975, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:52:13', 'admin-1487395910-14873971329871566', 1, 1, 'SR', NULL, NULL, NULL),
(20522, '2017-02-18 13:52:13', NULL, NULL, 6975, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:52:13', 'admin-1487395910-14873971329871566', 1, 1, 'SR', NULL, NULL, NULL),
(20523, '2017-02-18 13:52:13', NULL, NULL, 6975, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:52:13', 'admin-1487395910-14873971329871566', 1, 1, 'SR', NULL, NULL, NULL),
(20524, '2017-02-18 13:52:13', NULL, NULL, 6975, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:52:13', 'admin-1487395910-14873971329871566', 1, 1, 'SR', NULL, NULL, NULL),
(20525, '2017-02-18 13:57:05', NULL, NULL, 6976, 0, 265, '199', 'Old Penang PostCard', '', 'DISCOUNT ', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:57:05', 'admin-1487395910-14873974248288779', 1, 0, '', 1, NULL, NULL),
(20526, '2017-02-18 13:57:05', NULL, NULL, 6976, 0, 265, '199', 'Old Penang PostCard', '', 'DISCOUNT ', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:57:05', 'admin-1487395910-14873974248288779', 1, 0, '', 1, NULL, NULL),
(20527, '2017-02-18 16:54:16', NULL, NULL, 6986, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 16:54:16', 'admin-1487397442-14874080565204837', 1, 1, 'SR', NULL, NULL, '10.0'),
(20528, '2017-02-18 16:54:16', NULL, NULL, 6986, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 16:54:16', 'admin-1487397442-14874080565204837', 1, 1, 'SR', NULL, NULL, '10.0'),
(20529, '2017-02-18 17:44:18', NULL, NULL, 6987, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 17:44:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20530, '2017-02-18 17:44:31', NULL, NULL, 6987, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 17:44:31', 'admin-1487397442-14874110712144561', 1, 0, '', NULL, NULL, NULL),
(20531, '2017-02-18 17:44:31', NULL, NULL, 6987, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 17:44:31', 'admin-1487397442-14874110712144561', 1, 0, '', NULL, NULL, NULL),
(20532, '2017-02-18 17:44:31', NULL, NULL, 6987, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 17:44:31', 'admin-1487397442-14874110712144561', 1, 1, 'SR', NULL, NULL, NULL),
(20533, '2017-02-18 17:44:31', NULL, NULL, 6987, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 17:44:31', 'admin-1487397442-14874110712144561', 1, 1, 'SR', NULL, NULL, NULL),
(20534, '2017-02-18 17:52:13', NULL, NULL, 6986, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 17:52:13', 'admin-1487397442-14874115336237284', 1, 1, 'SR', NULL, NULL, '10.0'),
(20535, '2017-02-18 17:53:30', NULL, NULL, 6987, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 17:53:30', 'admin-1487397442-14874116104173050', 1, 0, '', NULL, NULL, NULL),
(20536, '2017-02-18 17:54:37', NULL, NULL, 6986, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 17:54:37', 'admin-1487397442-14874116771796925', 1, 1, 'SR', NULL, NULL, '10.0'),
(20537, '2017-02-18 17:54:37', NULL, NULL, 6986, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 17:54:37', 'admin-1487397442-14874116771796925', 1, 1, 'SR', NULL, NULL, '10.0'),
(20538, '2017-02-18 16:54:02', NULL, NULL, 6986, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 16:54:02', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(20539, '2017-02-18 16:54:16', NULL, NULL, 6986, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 16:54:16', 'admin-1487397442-14874080565204837', 1, 1, 'SR', NULL, NULL, '10.0'),
(20540, '2017-02-18 16:54:16', NULL, NULL, 6986, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 16:54:16', 'admin-1487397442-14874080565204837', 1, 0, '', NULL, NULL, '10.0'),
(20541, '2017-02-18 15:57:42', NULL, NULL, 6978, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 15:57:42', 'admin-1487397442-14874046624057522', 1, 1, 'SR', NULL, NULL, NULL),
(20542, '2017-02-18 15:57:51', NULL, NULL, 6978, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 15:57:51', 'admin-1487397442-14874046713516585', 1, 0, '', NULL, NULL, NULL),
(20543, '2017-02-18 13:28:23', NULL, NULL, 6973, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:28:23', 'admin-1487392068-14873957032922334', 1, 0, '', NULL, NULL, NULL),
(20544, '2017-02-18 13:28:23', NULL, NULL, 6973, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:28:23', 'admin-1487392068-14873957032922334', 1, 0, '', NULL, NULL, NULL),
(20545, '2017-02-18 13:28:23', NULL, NULL, 6973, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:28:23', 'admin-1487392068-14873957032922334', 1, 1, 'SR', NULL, NULL, NULL),
(20546, '2017-02-18 13:28:23', NULL, NULL, 6973, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:28:23', 'admin-1487392068-14873957032922334', 1, 1, 'SR', NULL, NULL, NULL),
(20547, '2017-02-18 16:17:50', NULL, NULL, 6981, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1487418467', 'admin', '2017-02-18 16:17:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20548, '2017-02-18 16:14:05', NULL, NULL, 6979, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 16:14:05', 'admin-1487397442-14874056448744918', 1, 1, 'SR', 1, NULL, '10.0'),
(20549, '2017-02-18 16:25:16', NULL, NULL, 6983, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1487418467', 'admin', '2017-02-18 16:25:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20550, '2017-02-18 16:25:27', NULL, NULL, 6983, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 16:25:27', 'admin-1487397442-14874063277335971', 1, 1, 'SR', NULL, NULL, NULL),
(20551, '2017-02-18 19:47:39', NULL, NULL, 6988, 0, 181, '116', 'Open Food ', 'cookie', 'Meals', 'Perfect Meals', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1487418467', 'admin', '2017-02-18 19:47:39', 'admin-1487397442-14874184597026630', 1, 0, '', NULL, NULL, NULL),
(20552, '2017-02-18 13:28:23', NULL, NULL, 6973, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:28:23', 'admin-1487392068-14873957032922334', 1, 1, 'SR', NULL, NULL, NULL),
(20553, '2017-02-18 11:00:24', NULL, NULL, 6956, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:00:24', 'admin-1487386808-14873868240142168', 1, 0, '', NULL, NULL, NULL),
(20554, '2017-02-18 10:01:47', NULL, NULL, 6950, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:01:47', 'admin-1487379229-14873833075775396', 1, 0, '', NULL, NULL, NULL),
(20555, '2017-02-18 10:01:47', NULL, NULL, 6950, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:01:47', 'admin-1487379229-14873833075775396', 1, 0, '', NULL, NULL, NULL),
(20556, '2017-02-18 10:12:29', NULL, NULL, 6951, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:12:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20557, '2017-02-18 10:12:37', NULL, NULL, 6951, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:12:37', 'admin-1487379229-14873839573281997', 1, 0, '', NULL, NULL, NULL),
(20558, '2017-02-18 10:12:37', NULL, NULL, 6951, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:12:37', 'admin-1487379229-14873839573281997', 1, 0, '', NULL, NULL, NULL),
(20559, '2017-02-18 10:12:37', NULL, NULL, 6951, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:12:37', 'admin-1487379229-14873839573281997', 1, 0, '', NULL, NULL, NULL),
(20560, '2017-02-18 10:12:49', NULL, NULL, 6951, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:12:49', 'admin-1487379229-14873839691825684', 1, 1, 'SR', NULL, NULL, NULL),
(20561, '2017-02-18 10:12:49', NULL, NULL, 6951, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:12:49', 'admin-1487379229-14873839691825684', 1, 1, 'SR', NULL, NULL, NULL),
(20562, '2017-02-18 10:12:49', NULL, NULL, 6951, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:12:49', 'admin-1487379229-14873839691825684', 1, 0, '', NULL, NULL, NULL),
(20563, '2017-02-18 10:12:49', NULL, NULL, 6951, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:12:49', 'admin-1487379229-14873839691825684', 1, 0, '', NULL, NULL, NULL),
(20564, '2017-02-18 10:12:57', NULL, NULL, 6951, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:12:57', 'admin-1487379229-1487383977593716', 1, 1, 'SR', NULL, NULL, NULL),
(20565, '2017-02-18 10:33:55', NULL, NULL, 6948, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:33:55', 'admin-1487379229-14873852356149916', 1, 0, '', NULL, NULL, NULL),
(20566, '2017-02-18 10:33:55', NULL, NULL, 6948, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:33:55', 'admin-1487379229-14873852356149916', 1, 1, 'SR', NULL, NULL, NULL),
(20567, '2017-02-18 10:42:49', NULL, NULL, 6952, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:42:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20568, '2017-02-18 10:43:03', NULL, NULL, 6952, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:43:03', 'admin-1487379229-14873857828357755', 1, 0, '', NULL, NULL, NULL),
(20569, '2017-02-18 10:43:03', NULL, NULL, 6952, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:43:03', 'admin-1487379229-14873857828357755', 1, 0, '', NULL, NULL, NULL),
(20570, '2017-02-18 10:43:03', NULL, NULL, 6952, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:43:03', 'admin-1487379229-14873857828357755', 1, 1, 'SR', NULL, NULL, NULL),
(20571, '2017-02-18 10:43:03', NULL, NULL, 6952, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:43:03', 'admin-1487379229-14873857828357755', 1, 1, 'SR', NULL, NULL, NULL),
(20572, '2017-02-18 10:48:26', NULL, NULL, 6950, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:48:26', 'admin-1487379229-1487386106250854', 1, 0, '', NULL, NULL, NULL),
(20573, '2017-02-18 10:45:56', NULL, NULL, 6953, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:45:56', 'admin-1487379229-14873859560809970', 1, 1, 'SR', NULL, NULL, NULL),
(20574, '2017-02-18 10:55:29', NULL, NULL, 6955, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:55:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20575, '2017-02-18 10:55:37', NULL, NULL, 6955, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:55:37', 'admin-1487379229-14873865373751427', 1, 0, '', NULL, NULL, NULL),
(20576, '2017-02-18 10:55:37', NULL, NULL, 6955, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 10:55:37', 'admin-1487379229-14873865373751427', 1, 1, 'SR', NULL, NULL, NULL),
(20577, '2017-02-18 11:00:17', NULL, NULL, 6956, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:00:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20578, '2017-02-18 11:00:24', NULL, NULL, 6956, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:00:24', 'admin-1487386808-14873868240142168', 1, 1, 'SR', NULL, NULL, NULL),
(20579, '2017-02-18 19:35:35', NULL, NULL, 6988, 0, 181, '116', 'Open Food ', 'sunny side up', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 19:35:35', 'admin-1487397442-14874177356552051', 1, 0, '', NULL, NULL, NULL),
(20580, '2017-02-18 19:29:10', NULL, NULL, 6988, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 19:29:10', 'admin-1487397442-14874173507103399', 1, 0, '', NULL, NULL, NULL),
(20581, '2017-02-18 19:30:13', NULL, NULL, 6988, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 19:30:13', 'admin-1487397442-14874174132575950', 1, 0, '', NULL, NULL, NULL),
(20582, '2017-02-18 19:30:22', NULL, NULL, 6988, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 19:30:22', 'admin-1487397442-14874174220917627', 1, 1, 'SR', NULL, NULL, NULL),
(20583, '2017-02-18 19:27:59', NULL, NULL, 6988, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.59, 0.0000, 0.0000, 8.59, 1, '27', 1, '1487418467', 'admin', '2017-02-18 19:27:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20584, '2017-02-18 19:29:10', NULL, NULL, 6988, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 19:29:10', 'admin-1487397442-14874173507103399', 1, 0, '', NULL, NULL, NULL),
(20585, '2017-02-18 18:55:23', NULL, NULL, 6987, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 18:55:23', 'admin-1487397442-14874153227951698', 1, 0, '', NULL, NULL, NULL),
(20586, '2017-02-18 16:48:46', NULL, NULL, 6985, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 16:48:46', 'admin-1487397442-14874077256677214', 1, 1, 'SR', NULL, NULL, NULL),
(20587, '2017-02-18 15:22:13', NULL, NULL, 6977, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 15:22:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20588, '2017-02-18 13:10:43', NULL, NULL, 6970, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:10:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20589, '2017-02-18 13:10:54', NULL, NULL, 6970, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:10:54', 'admin-1487392068-14873946540603335', 1, 0, '', NULL, NULL, NULL),
(20590, '2017-02-18 11:54:40', NULL, NULL, 6962, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:54:40', 'admin-1487389486-14873900803647365', 1, 0, '', NULL, NULL, NULL),
(20591, '2017-02-18 11:54:50', NULL, NULL, 6962, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:54:50', 'admin-1487389486-14873900907059021', 1, 1, 'SR', NULL, NULL, NULL),
(20592, '2017-02-18 12:27:38', NULL, NULL, 6963, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 12:27:38', 'admin-1487389486-14873920578662886', 1, 0, '', NULL, NULL, NULL),
(20593, '2017-02-18 12:27:38', NULL, NULL, 6963, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 12:27:38', 'admin-1487389486-14873920578662886', 1, 1, 'SR', NULL, NULL, NULL),
(20594, '2017-02-18 12:28:18', NULL, NULL, 6964, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1487418467', 'admin', '2017-02-18 12:28:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20595, '2017-02-18 11:19:05', NULL, NULL, 6959, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:19:05', 'admin-1487386808-1487387945679460', 1, 0, '', NULL, NULL, NULL),
(20596, '2017-02-18 14:13:39', NULL, NULL, 6970, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 14:13:39', 'admin-1487397442-14873984192767917', 1, 0, '', NULL, NULL, NULL),
(20597, '2017-02-18 00:00:00', NULL, NULL, 6982, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 16:15:35', 'admin-1487397442-14874057354363256', 1, 1, 'SR', NULL, NULL, NULL),
(20598, '2017-02-18 13:28:23', NULL, NULL, 6973, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:28:23', 'admin-1487392068-14873957032922334', 1, 1, 'SR', NULL, NULL, NULL),
(20599, '2017-02-18 13:16:16', NULL, NULL, 6971, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:16:16', 'admin-1487392068-14873949759587795', 1, 1, 'SR', 1, NULL, NULL),
(20600, '2017-02-18 13:11:20', NULL, NULL, 6970, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:11:20', 'admin-1487392068-14873946800809884', 1, 0, '', NULL, NULL, NULL),
(20601, '2017-02-18 13:02:47', NULL, NULL, 6968, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:02:47', 'admin-1487392068-14873941671515024', 1, 1, 'SR', 1, NULL, '10.0'),
(20602, '2017-02-18 13:05:43', NULL, NULL, 6969, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:05:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20603, '2017-02-18 13:06:03', NULL, NULL, 6969, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:06:03', 'admin-1487392068-14873943631228141', 1, 1, 'SR', NULL, NULL, NULL),
(20604, '2017-02-18 13:06:03', NULL, NULL, 6969, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:06:03', 'admin-1487392068-14873943631228141', 1, 1, 'SR', NULL, NULL, NULL),
(20605, '2017-02-18 13:06:03', NULL, NULL, 6969, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:06:03', 'admin-1487392068-14873943631228141', 1, 0, '', NULL, NULL, NULL),
(20606, '2017-02-18 11:20:26', NULL, NULL, 6960, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:20:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20607, '2017-02-18 11:20:36', NULL, NULL, 6960, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:20:36', 'admin-1487386808-14873880366238192', 1, 0, '', NULL, NULL, NULL),
(20608, '2017-02-18 11:29:01', NULL, NULL, 6955, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:29:01', 'admin-1487386808-14873885408244444', 1, 1, 'SR', NULL, NULL, NULL),
(20609, '2017-02-18 11:37:50', NULL, NULL, 6961, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:37:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20610, '2017-02-18 12:28:30', NULL, NULL, 6964, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 12:28:30', 'admin-1487392068-14873921098623241', 1, 0, '', NULL, NULL, NULL),
(20611, '2017-02-18 12:30:44', NULL, NULL, 6964, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 12:30:44', 'admin-1487392068-1487392244555887', 1, 0, '', NULL, NULL, NULL),
(20612, '2017-02-18 12:30:44', NULL, NULL, 6964, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 12:30:44', 'admin-1487392068-1487392244555887', 1, 1, 'SR', NULL, NULL, NULL),
(20613, '2017-02-18 12:56:14', NULL, NULL, 6965, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1487418467', 'admin', '2017-02-18 12:56:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20614, '2017-02-18 12:56:26', NULL, NULL, 6965, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 12:56:26', 'admin-1487392068-14873937866472031', 1, 0, '', NULL, NULL, NULL),
(20615, '2017-02-18 19:30:22', NULL, NULL, 6988, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 19:30:22', 'admin-1487397442-14874174220917627', 1, 1, 'SR', NULL, NULL, NULL),
(20616, '2017-02-18 13:11:20', NULL, NULL, 6970, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 13:11:20', 'admin-1487392068-14873946800809884', 1, 1, 'SR', NULL, NULL, NULL),
(20617, '2017-02-18 11:46:06', NULL, NULL, 6959, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:46:06', 'admin-1487389486-14873895666414515', 1, 1, 'SR', NULL, NULL, NULL),
(20618, '2017-02-18 11:46:06', NULL, NULL, 6959, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:46:06', 'admin-1487389486-14873895666414515', 1, 0, '', NULL, NULL, NULL),
(20619, '2017-02-18 11:47:44', NULL, NULL, 6959, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:47:44', 'admin-1487389486-1487389664447313', 1, 0, '', NULL, NULL, NULL),
(20620, '2017-02-18 11:53:31', NULL, NULL, 6962, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:53:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20621, '2017-02-18 11:39:32', NULL, NULL, 6952, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:39:32', 'admin-1487386808-148738917181099', 1, 1, 'SR', NULL, NULL, NULL),
(20622, '2017-02-18 11:38:15', NULL, NULL, 6961, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:38:15', 'admin-1487386808-14873890948905754', 1, 0, '', NULL, NULL, NULL),
(20623, '2017-02-18 12:27:21', NULL, NULL, 6963, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1487418467', 'admin', '2017-02-18 12:27:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20624, '2017-02-18 11:53:41', NULL, NULL, 6962, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:53:41', 'admin-1487389486-14873900209536042', 1, 0, '', NULL, NULL, NULL),
(20625, '2017-02-18 11:38:45', NULL, NULL, 6961, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:38:45', 'admin-1487386808-1487389125183334', 1, 0, '', NULL, NULL, NULL),
(20626, '2017-02-18 11:38:03', NULL, NULL, 6961, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:38:03', 'admin-1487386808-14873890832365085', 1, 0, '', NULL, NULL, NULL),
(20627, '2017-02-18 11:38:15', NULL, NULL, 6961, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:38:15', 'admin-1487386808-14873890948905754', 1, 0, '', NULL, NULL, NULL),
(20628, '2017-02-18 11:38:15', NULL, NULL, 6961, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:38:15', 'admin-1487386808-14873890948905754', 1, 0, '', NULL, NULL, NULL),
(20629, '2017-02-18 11:10:13', NULL, NULL, 6957, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:10:13', 'admin-1487386808-14873874130706886', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(20630, '2017-02-18 11:10:13', NULL, NULL, 6957, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:10:13', 'admin-1487386808-14873874130706886', 1, 1, 'SR', NULL, NULL, NULL),
(20631, '2017-02-18 11:10:13', NULL, NULL, 6957, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:10:13', 'admin-1487386808-14873874130706886', 1, 1, 'SR', NULL, NULL, NULL),
(20632, '2017-02-18 11:10:13', NULL, NULL, 6957, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:10:13', 'admin-1487386808-14873874130706886', 1, 1, 'SR', NULL, NULL, NULL),
(20633, '2017-02-18 11:17:30', NULL, NULL, 6958, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:17:30', 'admin-1487386808-14873878504922416', 1, 0, '', 1, NULL, NULL),
(20634, '2017-02-18 11:17:30', NULL, NULL, 6958, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:17:30', 'admin-1487386808-14873878504922416', 1, 0, '', 1, NULL, NULL),
(20635, '2017-02-18 11:18:39', NULL, NULL, 6959, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.60, 0.0000, 0.0000, 12.60, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:18:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20636, '2017-02-18 11:19:05', NULL, NULL, 6959, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:19:05', 'admin-1487386808-1487387945679460', 1, 0, '', NULL, NULL, NULL),
(20637, '2017-02-18 11:10:13', NULL, NULL, 6957, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:10:13', 'admin-1487386808-14873874130706886', 1, 1, 'SR', NULL, NULL, NULL),
(20638, '2017-02-18 11:09:51', NULL, NULL, 6957, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:09:51', 'admin-1487386808-14873873910059591', 1, 0, '', NULL, NULL, NULL),
(20639, '2017-02-18 11:09:51', NULL, NULL, 6957, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:09:51', 'admin-1487386808-14873873910059591', 1, 0, '', NULL, NULL, NULL),
(20640, '2017-02-18 11:09:51', NULL, NULL, 6957, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:09:51', 'admin-1487386808-14873873910059591', 1, 0, '', NULL, NULL, NULL),
(20641, '2017-02-18 11:09:35', NULL, NULL, 6957, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1487418467', 'admin', '2017-02-18 11:09:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20642, '2017-02-18 09:03:06', NULL, NULL, 6947, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 09:03:06', 'admin-1487379229-14873797860462335', 1, 0, '', NULL, NULL, NULL),
(20643, '2017-02-18 09:35:49', NULL, NULL, 6948, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.50, 0.0000, 0.0000, 11.50, 1, '27', 1, '1487418467', 'admin', '2017-02-18 09:35:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20644, '2017-02-18 09:36:00', NULL, NULL, 6948, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 09:36:00', 'admin-1487379229-14873817601561846', 1, 0, '', NULL, NULL, NULL),
(20645, '2017-02-18 09:36:00', NULL, NULL, 6948, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 09:36:00', 'admin-1487379229-14873817601561846', 1, 0, '', NULL, NULL, NULL),
(20646, '2017-02-18 09:38:12', NULL, NULL, 6948, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 09:38:12', 'admin-1487379229-148738189197317', 1, 0, '', NULL, NULL, NULL),
(20647, '2017-02-18 09:38:28', NULL, NULL, 6948, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 09:38:28', 'admin-1487379229-14873819085071584', 1, 1, 'SR', NULL, NULL, NULL),
(20648, '2017-02-18 09:38:28', NULL, NULL, 6948, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 09:38:28', 'admin-1487379229-14873819085071584', 1, 1, 'SR', NULL, NULL, NULL),
(20649, '2017-02-18 09:38:28', NULL, NULL, 6948, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 09:38:28', 'admin-1487379229-14873819085071584', 1, 1, 'SR', NULL, NULL, NULL),
(20650, '2017-02-18 09:40:18', NULL, NULL, 6949, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1487418467', 'admin', '2017-02-18 09:40:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20651, '2017-02-18 09:40:26', NULL, NULL, 6949, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 09:40:26', 'admin-1487379229-14873820263438924', 1, 0, '', NULL, NULL, NULL),
(20652, '2017-02-18 09:40:26', NULL, NULL, 6949, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 09:40:26', 'admin-1487379229-14873820263438924', 1, 0, '', NULL, NULL, NULL),
(20653, '2017-02-18 09:40:36', NULL, NULL, 6949, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 09:40:36', 'admin-1487379229-14873820358942710', 1, 1, 'SR', NULL, NULL, NULL),
(20654, '2017-02-18 09:40:36', NULL, NULL, 6949, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 09:40:36', 'admin-1487379229-14873820358942710', 1, 1, 'SR', NULL, NULL, NULL),
(20655, '2017-02-18 09:56:25', NULL, NULL, 6950, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1487418467', 'admin', '2017-02-18 09:56:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20656, '2017-02-18 09:56:42', NULL, NULL, 6950, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 09:56:42', 'admin-1487379229-1487383001913946', 1, 0, '', NULL, NULL, NULL),
(20657, '2017-02-18 09:56:42', NULL, NULL, 6950, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 09:56:42', 'admin-1487379229-1487383001913946', 1, 1, 'SR', NULL, NULL, NULL),
(20658, '2017-02-18 09:56:42', NULL, NULL, 6950, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 09:56:42', 'admin-1487379229-1487383001913946', 1, 1, 'SR', NULL, NULL, NULL),
(20659, '2017-02-18 09:02:56', NULL, NULL, 6947, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 09:02:56', 'admin-1487379229-14873797762987654', 1, 1, 'SR', NULL, NULL, NULL),
(20660, '2017-02-18 09:03:06', NULL, NULL, 6947, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487418467', 'admin', '2017-02-18 09:03:06', 'admin-1487379229-14873797860462335', 1, 0, '', NULL, NULL, NULL),
(20661, '2017-02-18 09:02:49', NULL, NULL, 6947, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1487418467', 'admin', '2017-02-18 09:02:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20662, '2017-02-19 15:06:41', NULL, NULL, 7024, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1487495165', 'admin', '2017-02-19 15:06:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20663, '2017-02-19 15:06:46', NULL, NULL, 7024, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 15:06:46', 'admin-1487486050-1487488006660687', 1, 0, '', NULL, NULL, NULL),
(20664, '2017-02-19 15:13:29', NULL, NULL, 7025, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1487495165', 'admin', '2017-02-19 15:13:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20665, '2017-02-19 15:13:40', NULL, NULL, 7025, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 15:13:40', 'admin-1487486050-14874884201789269', 1, 0, '', NULL, NULL, NULL),
(20666, '2017-02-19 15:13:40', NULL, NULL, 7025, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 15:13:40', 'admin-1487486050-14874884201789269', 1, 1, 'SR', NULL, NULL, NULL),
(20667, '2017-02-19 15:23:50', NULL, NULL, 7026, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 15:23:50', 'admin-1487486050-14874890298463270', 1, 1, 'SR', 1, NULL, NULL),
(20668, '2017-02-19 15:41:26', NULL, NULL, 7027, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1487495165', 'admin', '2017-02-19 15:41:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20669, '2017-02-19 15:41:46', NULL, NULL, 7027, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 15:41:46', 'admin-1487486050-14874901067275646', 1, 0, '', NULL, NULL, NULL),
(20670, '2017-02-19 15:41:46', NULL, NULL, 7027, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 15:41:46', 'admin-1487486050-14874901067275646', 1, 1, 'SR', NULL, NULL, NULL),
(20671, '2017-02-19 15:41:46', NULL, NULL, 7027, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 15:41:46', 'admin-1487486050-14874901067275646', 1, 1, 'SR', NULL, NULL, NULL),
(20672, '2017-02-19 15:41:46', NULL, NULL, 7027, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 15:41:46', 'admin-1487486050-14874901067275646', 1, 1, 'SR', NULL, NULL, NULL),
(20673, '2017-02-19 00:00:00', NULL, NULL, 7034, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, NULL, NULL, 1.10, 1, '27', 1, '1487495165', 'admin', '2017-02-19 16:03:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20674, '2017-02-19 17:06:13', NULL, NULL, 7021, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 17:06:13', 'admin-1487495165-14874951736174028', 1, 1, 'SR', NULL, NULL, NULL),
(20675, '2017-02-19 12:18:03', NULL, NULL, 7004, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:18:03', 'admin-1487477240-14874778831439640', 1, 1, 'SR', NULL, NULL, NULL),
(20676, '2017-02-19 12:18:45', NULL, NULL, 6998, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:18:45', 'admin-1487477240-14874779254498551', 1, 0, '', NULL, NULL, NULL),
(20677, '2017-02-19 00:00:00', NULL, NULL, 7034, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 16:03:46', 'admin-1487486050-14874914264929922', 1, 1, 'SR', NULL, NULL, NULL),
(20678, '2017-02-19 00:00:00', NULL, NULL, 7033, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 16:03:46', 'admin-1487486050-14874914264929922', 1, 1, 'SR', NULL, NULL, NULL),
(20679, '2017-02-19 00:00:00', NULL, NULL, 7032, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 16:03:46', 'admin-1487486050-14874914264929922', 1, 0, '', NULL, NULL, NULL),
(20680, '2017-02-19 16:45:06', NULL, NULL, 7031, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 16:45:06', 'admin-1487486050-14874939067459597', 1, 1, 'SR', NULL, NULL, NULL),
(20681, '2017-02-19 16:45:06', NULL, NULL, 7031, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 16:45:06', 'admin-1487486050-14874939067459597', 1, 1, 'SR', NULL, NULL, NULL),
(20682, '2017-02-19 16:45:03', NULL, NULL, 7031, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 16:45:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20683, '2017-02-19 16:43:43', NULL, NULL, 7030, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 16:43:43', 'admin-1487486050-14874938227639866', 1, 0, '', 1, NULL, NULL),
(20684, '2017-02-19 14:02:51', NULL, NULL, 7015, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:02:51', 'admin-1487478945-14874841707852970', 1, 1, 'SR', NULL, NULL, NULL),
(20685, '2017-02-19 14:12:05', NULL, NULL, 7015, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:12:05', 'admin-1487478945-14874847247943535', 1, 1, 'SR', NULL, NULL, NULL),
(20686, '2017-02-19 12:45:38', NULL, NULL, 7004, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:45:38', 'admin-1487478945-14874795385758248', 1, 0, '', NULL, NULL, NULL),
(20687, '2017-02-19 12:48:52', NULL, NULL, 7010, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:48:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20688, '2017-02-19 12:49:05', NULL, NULL, 7010, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:49:05', 'admin-1487478945-14874797450314526', 1, 1, 'SR', NULL, NULL, NULL),
(20689, '2017-02-19 12:49:05', NULL, NULL, 7010, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:49:05', 'admin-1487478945-14874797450314526', 1, 1, 'SR', NULL, NULL, NULL),
(20690, '2017-02-19 13:03:12', NULL, NULL, 7001, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 13:03:12', 'admin-1487478945-14874805924223591', 1, 0, '', NULL, NULL, NULL),
(20691, '2017-02-19 13:33:28', NULL, NULL, 7012, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1487495165', 'admin', '2017-02-19 13:33:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20692, '2017-02-19 13:33:33', NULL, NULL, 7012, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 13:33:33', 'admin-1487478945-14874824128171467', 1, 1, 'SR', NULL, NULL, NULL),
(20693, '2017-02-19 12:32:49', NULL, NULL, 7009, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:32:49', 'admin-1487477240-14874787693744154', 1, 1, 'SR', NULL, NULL, NULL),
(20694, '2017-02-19 12:34:01', NULL, NULL, 7004, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:34:01', 'admin-1487477240-14874788417008873', 1, 0, '', NULL, NULL, NULL),
(20695, '2017-02-19 12:34:34', NULL, NULL, 7006, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:34:34', 'admin-1487477240-14874788744017939', 1, 1, 'SR', NULL, NULL, NULL),
(20696, '2017-02-19 11:57:48', NULL, NULL, 7001, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.60, 0.0000, 0.0000, 12.60, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:57:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20697, '2017-02-19 11:58:09', NULL, NULL, 7001, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:58:09', 'admin-1487474314-14874766891261343', 1, 0, '', NULL, NULL, NULL),
(20698, '2017-02-19 11:58:09', NULL, NULL, 7001, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:58:09', 'admin-1487474314-14874766891261343', 1, 0, '', NULL, NULL, NULL),
(20699, '2017-02-19 11:58:09', NULL, NULL, 7001, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:58:09', 'admin-1487474314-14874766891261343', 1, 0, '', NULL, NULL, NULL),
(20700, '2017-02-19 16:43:43', NULL, NULL, 7030, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 16:43:43', 'admin-1487486050-14874938227639866', 1, 0, '', 1, NULL, NULL),
(20701, '2017-02-19 16:43:43', NULL, NULL, 7030, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1487495165', 'admin', '2017-02-19 16:43:43', 'admin-1487486050-14874938227639866', 1, 0, '', 1, NULL, NULL),
(20702, '2017-02-19 16:43:43', NULL, NULL, 7030, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1487495165', 'admin', '2017-02-19 16:43:43', 'admin-1487486050-14874938227639866', 1, 0, '', 1, NULL, NULL),
(20703, '2017-02-19 12:27:39', NULL, NULL, 7008, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:27:39', 'admin-1487477240-1487478458825859', 1, 1, 'SR', NULL, NULL, NULL),
(20704, '2017-02-19 12:27:39', NULL, NULL, 7008, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:27:39', 'admin-1487477240-1487478458825859', 1, 1, 'SR', NULL, NULL, NULL),
(20705, '2017-02-19 12:31:45', NULL, NULL, 7009, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.30, 0.0000, 0.0000, 15.30, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:31:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20706, '2017-02-19 12:32:49', NULL, NULL, 7009, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:32:49', 'admin-1487477240-14874787693744154', 1, 1, 'SR', NULL, NULL, NULL),
(20707, '2017-02-19 12:32:49', NULL, NULL, 7009, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:32:49', 'admin-1487477240-14874787693744154', 1, 0, '', NULL, NULL, NULL),
(20708, '2017-02-19 13:21:58', NULL, NULL, 7009, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 13:21:58', 'admin-1487478945-14874817181325962', 1, 0, '', NULL, NULL, NULL),
(20709, '2017-02-19 13:27:45', NULL, NULL, 7011, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 13:27:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20710, '2017-02-19 12:32:49', NULL, NULL, 7009, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:32:49', 'admin-1487477240-14874787693744154', 1, 0, '', NULL, NULL, NULL),
(20711, '2017-02-19 12:32:49', NULL, NULL, 7009, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:32:49', 'admin-1487477240-14874787693744154', 1, 0, '', NULL, NULL, NULL),
(20712, '2017-02-19 16:43:43', NULL, NULL, 7030, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1487495165', 'admin', '2017-02-19 16:43:43', 'admin-1487486050-14874938227639866', 1, 0, '', 1, NULL, NULL),
(20713, '2017-02-19 17:03:15', NULL, NULL, 7033, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1487495165', 'admin', '2017-02-19 17:03:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20714, '2017-02-19 17:02:17', NULL, NULL, 7032, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 17:02:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20715, '2017-02-19 16:41:07', NULL, NULL, 7029, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 16:41:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20716, '2017-02-19 16:41:12', NULL, NULL, 7029, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 16:41:12', 'admin-1487486050-14874936720885297', 1, 1, 'SR', NULL, NULL, NULL),
(20717, '2017-02-19 14:30:08', NULL, NULL, 7020, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:30:08', 'admin-1487478945-14874858084039594', 1, 0, '', NULL, NULL, NULL),
(20718, '2017-02-19 14:30:08', NULL, NULL, 7020, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:30:08', 'admin-1487478945-14874858084039594', 1, 0, '', NULL, NULL, NULL),
(20719, '2017-02-19 14:33:52', NULL, NULL, 7021, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:33:52', 'admin-1487478945-1487486032096418', 1, 0, '', NULL, NULL, NULL),
(20720, '2017-02-19 14:49:25', NULL, NULL, 7023, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:49:25', 'admin-1487486050-14874869653988759', 1, 1, 'SR', NULL, NULL, NULL),
(20721, '2017-02-19 15:05:20', NULL, NULL, 7016, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 15:05:20', 'admin-1487486050-1487487919860842', 1, 0, '', NULL, NULL, NULL),
(20722, '2017-02-19 14:18:30', NULL, NULL, 7017, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:18:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20723, '2017-02-19 14:18:34', NULL, NULL, 7017, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:18:34', 'admin-1487478945-14874851142098916', 1, 1, 'SR', NULL, NULL, NULL),
(20724, '2017-02-19 14:18:34', NULL, NULL, 7017, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:18:34', 'admin-1487478945-14874851142098916', 1, 1, 'SR', NULL, NULL, NULL),
(20725, '2017-02-19 14:15:28', NULL, NULL, 7016, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:15:28', 'admin-1487478945-1487484927983711', 1, 0, '', NULL, NULL, NULL),
(20726, '2017-02-19 14:26:47', NULL, NULL, 7019, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:26:47', 'admin-1487478945-14874856071264790', 1, 1, 'SR', NULL, NULL, NULL),
(20727, '2017-02-19 14:25:04', NULL, NULL, 7019, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:25:04', 'admin-1487478945-14874855038334628', 1, 0, '', NULL, NULL, NULL),
(20728, '2017-02-19 14:24:31', NULL, NULL, 7019, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:24:31', 'admin-1487478945-14874854715071785', 1, 0, '', NULL, NULL, NULL),
(20729, '2017-02-19 14:24:31', NULL, NULL, 7019, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:24:31', 'admin-1487478945-14874854715071785', 1, 0, '', NULL, NULL, NULL),
(20730, '2017-02-19 14:24:11', NULL, NULL, 7019, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:24:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20731, '2017-02-19 14:23:17', NULL, NULL, 7018, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:23:17', 'admin-1487478945-14874853972475915', 1, 1, 'SR', NULL, NULL, NULL),
(20732, '2017-02-19 14:23:17', NULL, NULL, 7018, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:23:17', 'admin-1487478945-14874853972475915', 1, 1, 'SR', NULL, NULL, NULL),
(20733, '2016-11-21 19:22:24', NULL, NULL, 0, 0, 160, '94', 'Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487495165', 'admin', '2016-11-21 19:22:24', 'admin-1479725238-1479727344433220', 1, 0, '', NULL, NULL, NULL),
(20734, '2016-11-21 19:22:24', NULL, NULL, 0, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487495165', 'admin', '2016-11-21 19:22:24', 'admin-1479725238-1479727344433220', 1, 0, '', NULL, NULL, NULL),
(20735, '2016-11-21 19:22:24', NULL, NULL, 0, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487495165', 'admin', '2016-11-21 19:22:24', 'admin-1479725238-1479727344433220', 1, 1, 'SR', NULL, NULL, NULL),
(20736, '2017-02-19 14:38:00', NULL, NULL, 7022, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:38:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20737, '2017-02-19 14:49:25', NULL, NULL, 7023, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:49:25', 'admin-1487486050-14874869653988759', 1, 0, '', NULL, NULL, NULL),
(20738, '2017-02-19 14:49:07', NULL, NULL, 7023, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:49:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20739, '2017-02-19 14:38:13', NULL, NULL, 7022, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:38:13', 'admin-1487486050-1487486293115649', 1, 1, 'SR', NULL, NULL, NULL),
(20740, '2017-02-19 14:38:13', NULL, NULL, 7022, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:38:13', 'admin-1487486050-1487486293115649', 1, 1, 'SR', NULL, NULL, NULL),
(20741, '2017-02-19 14:38:13', NULL, NULL, 7022, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:38:13', 'admin-1487486050-1487486293115649', 1, 0, '', NULL, NULL, NULL),
(20742, '2017-02-19 14:38:13', NULL, NULL, 7022, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:38:13', 'admin-1487486050-1487486293115649', 1, 0, '', NULL, NULL, NULL),
(20743, '2017-02-19 14:34:24', NULL, NULL, 7021, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:34:24', 'admin-1487486050-1487486064666276', 1, 0, '', NULL, NULL, NULL),
(20744, '2017-02-19 14:23:10', NULL, NULL, 7018, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:23:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20745, '2017-02-19 13:46:05', NULL, NULL, 7013, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1487495165', 'admin', '2017-02-19 13:46:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20746, '2017-02-19 13:46:29', NULL, NULL, 7013, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 13:46:29', 'admin-1487478945-14874831890553643', 1, 0, '', NULL, NULL, NULL),
(20747, '2017-02-19 12:34:34', NULL, NULL, 7006, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:34:34', 'admin-1487477240-14874788744017939', 1, 1, 'SR', NULL, NULL, NULL),
(20748, '2017-02-19 12:40:45', NULL, NULL, 7009, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:40:45', 'admin-1487478945-14874792456673654', 1, 0, '', NULL, NULL, NULL),
(20749, '2017-02-19 12:40:45', NULL, NULL, 7009, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:40:45', 'admin-1487478945-14874792456673654', 1, 1, 'SR', NULL, NULL, NULL),
(20750, '2017-02-19 12:40:45', NULL, NULL, 7009, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:40:45', 'admin-1487478945-14874792456673654', 1, 0, '', NULL, NULL, NULL),
(20751, '2017-02-19 14:15:28', NULL, NULL, 7016, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:15:28', 'admin-1487478945-1487484927983711', 1, 0, '', NULL, NULL, NULL),
(20752, '2017-02-19 13:46:29', NULL, NULL, 7013, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 13:46:29', 'admin-1487478945-14874831890553643', 1, 0, '', NULL, NULL, NULL),
(20753, '2017-02-19 13:55:58', NULL, NULL, 7014, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1487495165', 'admin', '2017-02-19 13:55:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20754, '2017-02-19 13:56:12', NULL, NULL, 7014, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 13:56:12', 'admin-1487478945-1487483771991764', 1, 1, 'SR', NULL, NULL, NULL),
(20755, '2017-02-19 14:30:02', NULL, NULL, 7020, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:30:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20756, '2017-02-19 14:15:12', NULL, NULL, 7016, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:15:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20757, '2017-02-19 14:02:51', NULL, NULL, 7015, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:02:51', 'admin-1487478945-14874841707852970', 1, 1, 'SR', NULL, NULL, NULL),
(20758, '2017-02-04 19:09:17', NULL, NULL, 0, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487495165', 'admin', '2017-02-04 19:09:17', 'admin-1486190504-1486206557152265', 1, 1, 'SR', NULL, NULL, NULL),
(20759, '2017-02-19 14:26:47', NULL, NULL, 7019, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:26:47', 'admin-1487478945-14874856071264790', 1, 1, 'SR', NULL, NULL, NULL),
(20760, '2017-02-19 14:12:05', NULL, NULL, 7015, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:12:05', 'admin-1487478945-14874847247943535', 1, 1, 'SR', NULL, NULL, NULL),
(20761, '2017-02-19 14:02:33', NULL, NULL, 7015, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:02:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20762, '2017-02-19 14:02:41', NULL, NULL, 7015, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:02:41', 'admin-1487478945-14874841609926792', 1, 0, '', NULL, NULL, NULL),
(20763, '2017-02-19 14:02:41', NULL, NULL, 7015, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 14:02:41', 'admin-1487478945-14874841609926792', 1, 0, '', NULL, NULL, NULL),
(20764, '2017-02-19 10:55:46', NULL, NULL, 6993, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 10:55:46', 'admin-1487465265-1487472946150324', 1, 0, '', NULL, NULL, NULL),
(20765, '2017-02-19 10:55:46', NULL, NULL, 6993, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 10:55:46', 'admin-1487465265-1487472946150324', 1, 1, 'SR', NULL, NULL, NULL),
(20766, '2017-02-19 10:55:46', NULL, NULL, 6993, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 10:55:46', 'admin-1487465265-1487472946150324', 1, 1, 'SR', NULL, NULL, NULL),
(20767, '2017-02-19 10:55:46', NULL, NULL, 6993, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 10:55:46', 'admin-1487465265-1487472946150324', 1, 1, 'SR', NULL, NULL, NULL),
(20768, '2017-02-19 10:55:54', NULL, NULL, 6994, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1487495165', 'admin', '2017-02-19 10:55:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20769, '2017-02-19 10:56:11', NULL, NULL, 6994, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 10:56:11', 'admin-1487465265-14874729717129311', 1, 1, 'SR', NULL, NULL, NULL),
(20770, '2017-02-19 10:56:11', NULL, NULL, 6994, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 10:56:11', 'admin-1487465265-14874729717129311', 1, 0, '', NULL, NULL, NULL),
(20771, '2017-02-19 10:56:11', NULL, NULL, 6994, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 10:56:11', 'admin-1487465265-14874729717129311', 1, 0, '', NULL, NULL, NULL),
(20772, '2017-02-19 10:56:11', NULL, NULL, 6994, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 10:56:11', 'admin-1487465265-14874729717129311', 1, 0, '', NULL, NULL, NULL),
(20773, '2017-02-19 11:04:30', NULL, NULL, 6995, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:04:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20774, '2017-02-19 11:04:44', NULL, NULL, 6995, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:04:44', 'admin-1487465265-14874734844942258', 1, 0, '', NULL, NULL, NULL),
(20775, '2017-02-19 11:04:44', NULL, NULL, 6995, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:04:44', 'admin-1487465265-14874734844942258', 1, 0, '', NULL, NULL, NULL),
(20776, '2017-02-19 11:04:58', NULL, NULL, 6995, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:04:58', 'admin-1487465265-14874734979813015', 1, 1, 'SR', NULL, NULL, NULL),
(20777, '2017-02-19 11:04:58', NULL, NULL, 6995, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:04:58', 'admin-1487465265-14874734979813015', 1, 0, '', NULL, NULL, NULL),
(20778, '2017-02-19 11:06:14', NULL, NULL, 6996, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 20.60, 0.0000, 0.0000, 20.60, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:06:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20779, '2017-02-19 11:06:30', NULL, NULL, 6996, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:06:30', 'admin-1487465265-14874735902511761', 1, 0, '', NULL, NULL, NULL),
(20780, '2017-02-19 11:06:30', NULL, NULL, 6996, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:06:30', 'admin-1487465265-14874735902511761', 1, 0, '', NULL, NULL, NULL),
(20781, '2017-02-19 11:12:16', NULL, NULL, 6996, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:12:16', 'admin-1487465265-14874739358233377', 1, 1, 'SR', NULL, NULL, NULL),
(20782, '2017-02-19 11:12:16', NULL, NULL, 6996, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:12:16', 'admin-1487465265-14874739358233377', 1, 0, '', NULL, NULL, NULL),
(20783, '2017-02-19 11:12:16', NULL, NULL, 6996, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:12:16', 'admin-1487465265-14874739358233377', 1, 1, 'SR', NULL, NULL, NULL),
(20784, '2017-02-19 11:12:16', NULL, NULL, 6996, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:12:16', 'admin-1487465265-14874739358233377', 1, 0, '', NULL, NULL, NULL),
(20785, '2017-02-19 11:12:16', NULL, NULL, 6996, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:12:16', 'admin-1487465265-14874739358233377', 1, 1, 'SR', NULL, NULL, NULL),
(20786, '2017-02-19 11:12:16', NULL, NULL, 6996, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:12:16', 'admin-1487465265-14874739358233377', 1, 1, 'SR', NULL, NULL, NULL),
(20787, '2017-02-19 11:12:16', NULL, NULL, 6996, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:12:16', 'admin-1487465265-14874739358233377', 1, 0, '', NULL, NULL, NULL),
(20788, '2017-02-19 11:12:16', NULL, NULL, 6996, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:12:16', 'admin-1487465265-14874739358233377', 1, 0, '', NULL, NULL, NULL),
(20789, '2017-02-19 12:00:39', NULL, NULL, 7002, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:00:39', 'admin-1487474314-14874768395622873', 1, 0, '', NULL, NULL, NULL),
(20790, '2017-02-19 12:06:55', NULL, NULL, 7003, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:06:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20791, '2017-02-19 12:07:12', NULL, NULL, 7003, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:07:12', 'admin-1487474314-14874772322122421', 1, 0, '', NULL, NULL, NULL),
(20792, '2017-02-19 12:07:12', NULL, NULL, 7003, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:07:12', 'admin-1487474314-14874772322122421', 1, 0, '', NULL, NULL, NULL),
(20793, '2017-02-19 12:07:12', NULL, NULL, 7003, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:07:12', 'admin-1487474314-14874772322122421', 1, 0, '', NULL, NULL, NULL),
(20794, '2017-02-19 12:07:12', NULL, NULL, 7003, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:07:12', 'admin-1487474314-14874772322122421', 1, 1, 'SR', NULL, NULL, NULL),
(20795, '2017-02-19 12:17:04', NULL, NULL, 7004, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.00, 0.0000, 0.0000, 11.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:17:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20796, '2017-02-19 12:18:03', NULL, NULL, 7004, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:18:03', 'admin-1487477240-14874778831439640', 1, 0, '', NULL, NULL, NULL),
(20797, '2017-02-19 12:18:03', NULL, NULL, 7004, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:18:03', 'admin-1487477240-14874778831439640', 1, 0, '', NULL, NULL, NULL),
(20798, '2017-02-19 12:18:03', NULL, NULL, 7004, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:18:03', 'admin-1487477240-14874778831439640', 1, 1, 'SR', NULL, NULL, NULL),
(20799, '2017-02-19 12:32:49', NULL, NULL, 7009, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:32:49', 'admin-1487477240-14874787693744154', 1, 1, 'SR', NULL, NULL, NULL),
(20800, '2017-02-19 12:24:56', NULL, NULL, 6998, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:24:56', 'admin-1487477240-14874782962143049', 1, 0, '', NULL, NULL, NULL),
(20801, '2017-02-19 12:22:44', NULL, NULL, 6998, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:22:44', 'admin-1487477240-14874781638537115', 1, 1, 'SR', NULL, NULL, NULL),
(20802, '2017-02-19 12:19:10', NULL, NULL, 7004, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:19:10', 'admin-1487477240-14874779501555056', 1, 0, '', NULL, NULL, NULL),
(20803, '2017-02-19 12:19:10', NULL, NULL, 7004, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:19:10', 'admin-1487477240-14874779501555056', 1, 0, '', NULL, NULL, NULL),
(20804, '2017-02-19 11:56:59', NULL, NULL, 7000, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:56:59', 'admin-1487474314-1487476619558496', 1, 1, 'SR', NULL, NULL, NULL),
(20805, '2017-02-19 11:58:29', NULL, NULL, 7001, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:58:29', 'admin-1487474314-14874767096274927', 1, 0, '', NULL, NULL, NULL),
(20806, '2017-02-19 11:58:44', NULL, NULL, 7001, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:58:44', 'admin-1487474314-14874767242523620', 1, 1, 'SR', NULL, NULL, NULL),
(20807, '2017-02-19 11:58:44', NULL, NULL, 7001, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:58:44', 'admin-1487474314-14874767242523620', 1, 1, 'SR', NULL, NULL, NULL),
(20808, '2017-02-19 13:28:07', NULL, NULL, 7011, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 13:28:07', 'admin-1487478945-14874820878003146', 1, 1, 'SR', NULL, NULL, NULL),
(20809, '2017-02-19 13:28:07', NULL, NULL, 7011, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 13:28:07', 'admin-1487478945-14874820878003146', 1, 1, 'SR', NULL, NULL, NULL),
(20810, '2017-02-19 13:56:12', NULL, NULL, 7014, 0, 268, '202', 'ICED COCOA CAPPUCINO', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 13:56:12', 'admin-1487478945-1487483771991764', 1, 0, '', NULL, NULL, NULL),
(20811, '2017-02-19 13:46:29', NULL, NULL, 7013, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 13:46:29', 'admin-1487478945-14874831890553643', 1, 0, '', NULL, NULL, NULL),
(20812, '2017-02-19 12:32:49', NULL, NULL, 7009, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:32:49', 'admin-1487477240-14874787693744154', 1, 1, 'SR', NULL, NULL, NULL),
(20813, '2017-02-19 12:00:39', NULL, NULL, 7002, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:00:39', 'admin-1487474314-14874768395622873', 1, 0, '', NULL, NULL, NULL),
(20814, '2017-02-19 12:00:39', NULL, NULL, 7002, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:00:39', 'admin-1487474314-14874768395622873', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(20815, '2017-02-19 12:27:28', NULL, NULL, 7008, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:27:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20816, '2017-02-19 12:26:26', NULL, NULL, 7007, 0, 181, '116', 'Open Food ', 'oranges', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:26:26', 'admin-1487477240-14874783861363681', 1, 0, '', 1, NULL, NULL),
(20817, '2017-02-19 12:25:57', NULL, NULL, 7006, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:25:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20818, '2017-02-19 12:21:55', NULL, NULL, 7005, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:21:55', 'admin-1487477240-14874781153958752', 1, 1, 'SR', NULL, NULL, NULL),
(20819, '2017-02-19 12:21:55', NULL, NULL, 7005, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:21:55', 'admin-1487477240-14874781153958752', 1, 0, '', NULL, NULL, NULL),
(20820, '2017-02-19 12:21:55', NULL, NULL, 7005, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:21:55', 'admin-1487477240-14874781153958752', 1, 1, 'SR', NULL, NULL, NULL),
(20821, '2017-02-19 11:58:09', NULL, NULL, 7001, 0, 155, '89', 'Cheesy Chicken Gratin', ' replace more salad,no bread', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:58:09', 'admin-1487474314-14874766891261343', 1, 0, '', NULL, NULL, NULL),
(20822, '2017-02-19 13:20:58', NULL, NULL, 7009, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 13:20:58', 'admin-1487478945-14874816581709395', 1, 0, '', NULL, NULL, NULL),
(20823, '2017-02-19 12:21:27', NULL, NULL, 7005, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:21:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20824, '2017-02-19 12:21:55', NULL, NULL, 7005, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:21:55', 'admin-1487477240-14874781153958752', 1, 1, 'SR', NULL, NULL, NULL),
(20825, '2017-02-19 12:19:10', NULL, NULL, 7004, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:19:10', 'admin-1487477240-14874779501555056', 1, 1, 'SR', NULL, NULL, NULL),
(20826, '2017-02-19 12:19:10', NULL, NULL, 7004, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:19:10', 'admin-1487477240-14874779501555056', 1, 0, '', NULL, NULL, NULL),
(20827, '2016-12-22 11:38:49', NULL, NULL, 0, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1487495165', 'admin', '2016-12-22 11:38:49', 'admin-1482374420-14823779288814964', 1, 0, '', NULL, NULL, NULL),
(20828, '2016-12-19 18:27:59', NULL, NULL, 0, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487495165', 'admin', '2016-12-19 18:27:59', 'admin-1482123243-1482143279738717', 1, 1, 'SR', NULL, NULL, NULL),
(20829, '2017-02-19 12:18:45', NULL, NULL, 6998, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:18:45', 'admin-1487477240-14874779254498551', 1, 0, '', NULL, NULL, NULL),
(20830, '2017-02-19 11:58:44', NULL, NULL, 7001, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:58:44', 'admin-1487474314-14874767242523620', 1, 1, 'SR', NULL, NULL, NULL),
(20831, '2017-02-19 12:00:39', NULL, NULL, 7002, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:00:39', 'admin-1487474314-14874768395622873', 1, 0, '', NULL, NULL, NULL),
(20832, '2017-02-19 12:00:39', NULL, NULL, 7002, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:00:39', 'admin-1487474314-14874768395622873', 1, 0, '', NULL, NULL, NULL),
(20833, '2017-02-19 12:00:01', NULL, NULL, 7002, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1487495165', 'admin', '2017-02-19 12:00:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20834, '2017-02-19 11:12:16', NULL, NULL, 6996, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:12:16', 'admin-1487465265-14874739358233377', 1, 0, '', NULL, NULL, NULL),
(20835, '2017-02-19 11:12:16', NULL, NULL, 6996, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:12:16', 'admin-1487465265-14874739358233377', 1, 0, '', NULL, NULL, NULL),
(20836, '2017-02-19 11:12:16', NULL, NULL, 6996, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:12:16', 'admin-1487465265-14874739358233377', 1, 0, '', NULL, NULL, NULL),
(20837, '2017-02-19 11:12:16', NULL, NULL, 6996, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:12:16', 'admin-1487465265-14874739358233377', 1, 0, '', NULL, NULL, NULL),
(20838, '2017-02-19 11:12:16', NULL, NULL, 6996, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:12:16', 'admin-1487465265-14874739358233377', 1, 0, '', NULL, NULL, NULL),
(20839, '2017-02-19 11:12:16', NULL, NULL, 6996, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:12:16', 'admin-1487465265-14874739358233377', 1, 0, '', NULL, NULL, NULL),
(20840, '2017-02-19 11:26:56', NULL, NULL, 6997, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:26:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20841, '2017-02-19 11:27:20', NULL, NULL, 6997, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:27:20', 'admin-1487474314-14874748398165673', 1, 1, 'SR', NULL, NULL, NULL),
(20842, '2017-02-19 11:27:20', NULL, NULL, 6997, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:27:20', 'admin-1487474314-14874748398165673', 1, 1, 'SR', NULL, NULL, NULL),
(20843, '2017-02-19 11:35:29', NULL, NULL, 6996, 0, 181, '116', 'Open Food ', 'fried eggs', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:35:29', 'admin-1487474314-1487475329306634', 1, 0, '', NULL, NULL, NULL),
(20844, '2017-02-19 11:35:49', NULL, NULL, 6998, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:35:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20845, '2017-02-19 11:36:04', NULL, NULL, 6998, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:36:04', 'admin-1487474314-1487475364401978', 1, 1, 'SR', NULL, NULL, NULL),
(20846, '2017-02-19 11:36:33', NULL, NULL, 6998, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:36:33', 'admin-1487474314-14874753935296847', 1, 0, '', NULL, NULL, NULL),
(20847, '2017-02-19 11:43:17', NULL, NULL, 6999, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:43:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20848, '2017-02-19 11:43:36', NULL, NULL, 6999, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:43:36', 'admin-1487474314-14874758158842138', 1, 0, '', NULL, NULL, NULL),
(20849, '2017-02-19 11:43:36', NULL, NULL, 6999, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:43:36', 'admin-1487474314-14874758158842138', 1, 0, '', NULL, NULL, NULL),
(20850, '2017-02-19 11:43:36', NULL, NULL, 6999, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:43:36', 'admin-1487474314-14874758158842138', 1, 0, '', NULL, NULL, NULL),
(20851, '2017-02-19 11:43:36', NULL, NULL, 6999, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:43:36', 'admin-1487474314-14874758158842138', 1, 1, 'SR', NULL, NULL, NULL),
(20852, '2017-02-19 11:43:36', NULL, NULL, 6999, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:43:36', 'admin-1487474314-14874758158842138', 1, 1, 'SR', NULL, NULL, NULL),
(20853, '2017-02-19 11:56:54', NULL, NULL, 7000, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:56:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20854, '2017-02-19 11:56:59', NULL, NULL, 7000, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:56:59', 'admin-1487474314-1487476619558496', 1, 1, 'SR', NULL, NULL, NULL),
(20855, '2017-02-19 09:10:25', NULL, NULL, 6989, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 09:10:25', 'admin-1487465265-1487466625149649', 1, 0, '', NULL, NULL, NULL),
(20856, '2017-02-19 09:24:01', NULL, NULL, 6990, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1487495165', 'admin', '2017-02-19 09:24:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20857, '2017-02-19 09:24:19', NULL, NULL, 6990, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 09:24:19', 'admin-1487465265-1487467459140313', 1, 0, '', NULL, NULL, NULL),
(20858, '2017-02-19 09:24:19', NULL, NULL, 6990, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 09:24:19', 'admin-1487465265-1487467459140313', 1, 0, '', NULL, NULL, NULL),
(20859, '2017-02-19 09:24:19', NULL, NULL, 6990, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 09:24:19', 'admin-1487465265-1487467459140313', 1, 0, '', NULL, NULL, NULL),
(20860, '2017-02-19 09:25:05', NULL, NULL, 6990, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 09:25:05', 'admin-1487465265-14874675050269621', 1, 1, 'SR', NULL, NULL, NULL),
(20861, '2017-02-19 09:25:05', NULL, NULL, 6990, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 09:25:05', 'admin-1487465265-14874675050269621', 1, 1, 'SR', NULL, NULL, NULL),
(20862, '2017-02-19 09:25:05', NULL, NULL, 6990, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 09:25:05', 'admin-1487465265-14874675050269621', 1, 1, 'SR', NULL, NULL, NULL),
(20863, '2017-02-19 10:41:33', NULL, NULL, 6991, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1487495165', 'admin', '2017-02-19 10:41:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20864, '2017-02-19 10:41:46', NULL, NULL, 6991, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 10:41:46', 'admin-1487465265-14874721060924943', 1, 0, '', NULL, NULL, NULL),
(20865, '2017-02-19 10:41:46', NULL, NULL, 6991, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 10:41:46', 'admin-1487465265-14874721060924943', 1, 0, '', NULL, NULL, NULL),
(20866, '2017-02-19 10:41:54', NULL, NULL, 6991, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 10:41:54', 'admin-1487465265-14874721145776414', 1, 1, 'SR', NULL, NULL, NULL),
(20867, '2017-02-19 10:41:54', NULL, NULL, 6991, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 10:41:54', 'admin-1487465265-14874721145776414', 1, 1, 'SR', NULL, NULL, NULL),
(20868, '2017-02-19 11:31:19', NULL, NULL, 6997, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 11:31:19', 'admin-1487474314-14874750795997154', 1, 0, '', NULL, NULL, NULL),
(20869, '2017-02-19 10:55:00', NULL, NULL, 6993, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.10, 0.0000, 0.0000, 12.10, 1, '27', 1, '1487495165', 'admin', '2017-02-19 10:55:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20870, '2017-02-19 10:55:16', NULL, NULL, 6993, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 10:55:16', 'admin-1487465265-14874729163859638', 1, 0, '', NULL, NULL, NULL),
(20871, '2017-02-19 10:55:16', NULL, NULL, 6993, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 10:55:16', 'admin-1487465265-14874729163859638', 1, 0, '', NULL, NULL, NULL),
(20872, '2017-02-19 10:55:16', NULL, NULL, 6993, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 10:55:16', 'admin-1487465265-14874729163859638', 1, 0, '', NULL, NULL, NULL),
(20873, '2017-02-19 10:55:16', NULL, NULL, 6993, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1487495165', 'admin', '2017-02-19 10:55:16', 'admin-1487465265-14874729163859638', 1, 0, '', NULL, NULL, NULL),
(20874, '2017-02-19 09:10:21', NULL, NULL, 6989, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1487495165', 'admin', '2017-02-19 09:10:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20875, '2017-02-20 13:07:56', NULL, NULL, 7047, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 13:07:56', 'admin-1487564551-1487567276127715', 1, 0, '', NULL, NULL, NULL),
(20876, '2017-02-20 00:00:00', NULL, NULL, 7053, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 13:35:03', 'admin-1487564551-14875689030733019', 1, 1, 'SR', NULL, NULL, NULL),
(20877, '2017-02-20 14:53:22', NULL, NULL, 7051, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 14:53:22', 'admin-1487564551-14875736026609971', 1, 0, '', NULL, NULL, NULL),
(20878, '2017-02-20 14:56:00', NULL, NULL, 7055, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1487589252', 'admin', '2017-02-20 14:56:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20879, '2017-02-20 14:56:48', NULL, NULL, 7055, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 14:56:48', 'admin-1487564551-14875738081966513', 1, 0, '', NULL, NULL, NULL),
(20880, '2017-02-20 14:56:48', NULL, NULL, 7055, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 14:56:48', 'admin-1487564551-14875738081966513', 1, 1, 'SR', NULL, NULL, NULL),
(20881, '2017-02-20 14:56:48', NULL, NULL, 7055, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 14:56:48', 'admin-1487564551-14875738081966513', 1, 0, '', NULL, NULL, NULL),
(20882, '2017-02-20 15:13:54', NULL, NULL, 7056, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1487589252', 'admin', '2017-02-20 15:13:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20883, '2017-02-20 15:14:06', NULL, NULL, 7056, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 15:14:06', 'admin-1487564551-14875748461166479', 1, 1, 'SR', NULL, NULL, NULL),
(20884, '2017-02-20 17:13:45', NULL, NULL, 7060, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 17:13:45', 'admin-1487564551-14875820256293514', 1, 1, 'SR', NULL, NULL, NULL),
(20885, '2017-02-20 00:00:00', NULL, NULL, 7061, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 16:25:20', 'admin-1487564551-1487579120299213', 1, 1, 'SR', NULL, NULL, NULL),
(20886, '2017-02-20 12:04:05', NULL, NULL, 7044, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1487589252', 'admin', '2017-02-20 12:04:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20887, '2017-02-20 11:38:46', NULL, NULL, 7043, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 11:38:46', 'admin-1487550909-14875619264706476', 1, 1, 'SR', 1, NULL, NULL),
(20888, '2017-02-20 18:33:52', NULL, NULL, 7064, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1487589252', 'admin', '2017-02-20 18:33:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20889, '2017-02-20 18:33:55', NULL, NULL, 7064, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 18:33:55', 'admin-1487564551-1487586835509239', 1, 1, 'SR', NULL, NULL, NULL),
(20890, '2017-02-20 18:39:55', NULL, NULL, 7065, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.50, 0.0000, 0.0000, 9.50, 1, '27', 1, '1487589252', 'admin', '2017-02-20 18:39:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20891, '2017-02-20 09:12:58', NULL, NULL, 7035, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 09:12:58', 'admin-1487550909-14875531782982715', 1, 0, '', NULL, NULL, NULL),
(20892, '2017-02-20 09:12:58', NULL, NULL, 7035, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 09:12:58', 'admin-1487550909-14875531782982715', 1, 0, '', NULL, NULL, NULL),
(20893, '2017-02-20 09:12:58', NULL, NULL, 7035, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 09:12:58', 'admin-1487550909-14875531782982715', 1, 0, '', NULL, NULL, NULL),
(20894, '2017-02-20 09:13:20', NULL, NULL, 7035, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 09:13:20', 'admin-1487550909-14875532006126225', 1, 1, 'SR', NULL, NULL, NULL),
(20895, '2017-02-20 09:13:20', NULL, NULL, 7035, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 09:13:20', 'admin-1487550909-14875532006126225', 1, 1, 'SR', NULL, NULL, NULL),
(20896, '2017-02-20 09:13:20', NULL, NULL, 7035, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 09:13:20', 'admin-1487550909-14875532006126225', 1, 0, '', NULL, NULL, NULL),
(20897, '2017-02-20 00:00:00', NULL, NULL, 7062, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 16:25:20', 'admin-1487564551-1487579120299213', 1, 0, '', NULL, NULL, NULL),
(20898, '2017-02-20 12:17:05', NULL, NULL, 7045, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 12:17:05', 'admin-1487550909-14875642251263596', 1, 1, 'SR', NULL, NULL, NULL),
(20899, '2017-02-20 19:06:55', NULL, NULL, 7065, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 19:06:55', 'admin-1487564551-14875888152703627', 1, 1, 'SR', NULL, NULL, NULL),
(20900, '2017-02-20 19:06:36', NULL, NULL, 7065, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 19:06:36', 'admin-1487564551-14875887959655197', 1, 0, '', NULL, NULL, NULL),
(20901, '2017-02-20 18:58:56', NULL, NULL, 7066, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 18:58:56', 'admin-1487564551-14875883363258468', 1, 1, 'SR', 1, NULL, NULL),
(20902, '2017-02-20 18:40:25', NULL, NULL, 7065, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 18:40:25', 'admin-1487564551-14875872255001197', 1, 1, 'SR', NULL, NULL, NULL),
(20903, '2017-02-20 18:40:14', NULL, NULL, 7065, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 18:40:14', 'admin-1487564551-14875872138214767', 1, 0, '', NULL, NULL, NULL),
(20904, '2017-02-20 18:40:14', NULL, NULL, 7065, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 18:40:14', 'admin-1487564551-14875872138214767', 1, 1, 'SR', NULL, NULL, NULL),
(20905, '2017-02-20 17:13:40', NULL, NULL, 7060, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1487589252', 'admin', '2017-02-20 17:13:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20906, '2017-02-20 18:40:14', NULL, NULL, 7065, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 18:40:14', 'admin-1487564551-14875872138214767', 1, 0, '', NULL, NULL, NULL),
(20907, '2017-02-20 18:40:14', NULL, NULL, 7065, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 18:40:14', 'admin-1487564551-14875872138214767', 1, 0, '', NULL, NULL, NULL),
(20908, '2017-02-20 18:40:14', NULL, NULL, 7065, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 18:40:14', 'admin-1487564551-14875872138214767', 1, 1, 'SR', NULL, NULL, NULL),
(20909, '2017-02-20 17:42:59', NULL, NULL, 7063, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 17:42:59', 'admin-1487564551-14875837796365310', 1, 0, '', NULL, NULL, NULL),
(20910, '2017-02-20 17:42:59', NULL, NULL, 7063, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 17:42:59', 'admin-1487564551-14875837796365310', 1, 1, 'SR', NULL, NULL, NULL),
(20911, '2017-02-20 00:00:00', NULL, NULL, 7053, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, NULL, NULL, 0.90, 1, '27', 1, '1487589252', 'admin', '2017-02-20 13:34:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20912, '2017-02-20 14:37:39', NULL, NULL, 7054, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 14:37:39', 'admin-1487564551-14875726596525927', 1, 1, 'SR', 1, NULL, NULL),
(20913, '2017-02-20 14:24:17', NULL, NULL, 7052, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1487589252', 'admin', '2017-02-20 14:24:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20914, '2017-02-20 13:43:12', NULL, NULL, 7047, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 13:43:12', 'admin-1487564551-14875693925042941', 1, 0, '', NULL, NULL, NULL),
(20915, '2017-02-20 13:45:12', NULL, NULL, 7050, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1487589252', 'admin', '2017-02-20 13:45:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20916, '2017-02-20 13:45:16', NULL, NULL, 7050, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 13:45:16', 'admin-1487564551-14875695168048446', 1, 0, '', NULL, NULL, NULL),
(20917, '2017-02-20 13:59:36', NULL, NULL, 7051, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1487589252', 'admin', '2017-02-20 13:59:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20918, '2017-02-20 13:59:40', NULL, NULL, 7051, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 13:59:41', 'admin-1487564551-1487570380808253', 1, 0, '', NULL, NULL, NULL),
(20919, '2017-02-20 13:59:51', NULL, NULL, 7051, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 13:59:51', 'admin-1487564551-14875703916971199', 1, 0, '', NULL, NULL, NULL),
(20920, '2017-02-20 13:59:51', NULL, NULL, 7051, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 13:59:51', 'admin-1487564551-14875703916971199', 1, 1, 'SR', NULL, NULL, NULL),
(20921, '2017-02-20 14:18:50', NULL, NULL, 7047, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 14:18:50', 'admin-1487564551-14875715301258115', 1, 0, '', NULL, NULL, NULL),
(20922, '2017-02-20 15:14:06', NULL, NULL, 7056, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 15:14:06', 'admin-1487564551-14875748461166479', 1, 0, '', NULL, NULL, NULL),
(20923, '2017-02-20 16:02:27', NULL, NULL, 7057, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 16:02:27', 'admin-1487564551-14875777471952444', 1, 1, 'SR', 1, NULL, NULL),
(20924, '2017-02-20 00:00:00', NULL, NULL, 7062, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, NULL, NULL, 1.50, 1, '27', 1, '1487589252', 'admin', '2017-02-20 16:24:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20925, '2017-02-20 17:38:48', NULL, NULL, 7063, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1487589252', 'admin', '2017-02-20 17:38:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20926, '2017-02-20 17:21:07', NULL, NULL, 7061, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1487589252', 'admin', '2017-02-20 17:21:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20927, '2017-02-20 16:29:38', NULL, NULL, 7059, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1487589252', 'admin', '2017-02-20 16:29:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20928, '2017-02-20 16:32:10', NULL, NULL, 7059, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 16:32:10', 'admin-1487564551-14875795300726966', 1, 1, 'SR', NULL, NULL, NULL),
(20929, '2017-02-20 16:32:10', NULL, NULL, 7059, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 16:32:10', 'admin-1487564551-14875795300726966', 1, 1, 'SR', NULL, NULL, NULL),
(20930, '2017-02-20 16:32:10', NULL, NULL, 7059, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 16:32:10', 'admin-1487564551-14875795300726966', 1, 1, 'SR', NULL, NULL, NULL),
(20931, '2017-02-20 13:32:48', NULL, NULL, 7048, 0, 181, '116', 'Open Food ', 'cookies', 'Meals', 'Perfect Meals', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 13:32:48', 'admin-1487564551-14875687683637462', 1, 0, '', 1, NULL, NULL),
(20932, '2017-02-20 00:00:00', NULL, NULL, 7052, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 13:35:03', 'admin-1487564551-14875689030733019', 1, 1, 'SR', NULL, NULL, NULL),
(20933, '2017-02-20 13:07:56', NULL, NULL, 7047, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 13:07:56', 'admin-1487564551-1487567276127715', 1, 0, '', NULL, NULL, NULL),
(20934, '2017-02-20 13:32:48', NULL, NULL, 7048, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 13:32:48', 'admin-1487564551-14875687683637462', 1, 0, '', 1, NULL, NULL),
(20935, '2017-02-20 13:07:56', NULL, NULL, 7047, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1487589252', 'admin', '2017-02-20 13:07:56', 'admin-1487564551-1487567276127715', 1, 0, '', NULL, NULL, NULL),
(20936, '2017-02-20 13:07:56', NULL, NULL, 7047, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 13:07:56', 'admin-1487564551-1487567276127715', 1, 1, 'SR', NULL, NULL, NULL),
(20937, '2017-02-20 13:07:08', NULL, NULL, 7047, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.15, 0.0000, 0.0000, 4.15, 1, '27', 1, '1487589252', 'admin', '2017-02-20 13:07:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20938, '2017-02-20 12:22:56', NULL, NULL, 7046, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 12:22:56', 'admin-1487564551-14875645758088188', 1, 1, 'SR', NULL, NULL, NULL),
(20939, '2017-02-20 12:22:25', NULL, NULL, 7046, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 12:22:25', 'admin-1487550909-14875645453088638', 1, 0, '', NULL, NULL, NULL),
(20940, '2017-02-20 12:22:25', NULL, NULL, 7046, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 12:22:25', 'admin-1487550909-14875645453088638', 1, 1, 'SR', NULL, NULL, NULL),
(20941, '2017-02-20 12:22:16', NULL, NULL, 7046, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1487589252', 'admin', '2017-02-20 12:22:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20942, '2017-02-20 12:17:00', NULL, NULL, 7045, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1487589252', 'admin', '2017-02-20 12:17:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20943, '2017-02-20 12:04:08', NULL, NULL, 7044, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 12:04:08', 'admin-1487550909-14875634485057356', 1, 1, 'SR', NULL, NULL, NULL),
(20944, '2017-02-20 10:22:16', NULL, NULL, 7038, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1487589252', 'admin', '2017-02-20 10:22:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20945, '2017-02-20 10:22:24', NULL, NULL, 7038, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 10:22:24', 'admin-1487550909-14875573444072426', 1, 0, '', NULL, NULL, NULL),
(20946, '2017-02-20 10:22:24', NULL, NULL, 7038, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 10:22:24', 'admin-1487550909-14875573444072426', 1, 1, 'SR', NULL, NULL, NULL),
(20947, '2017-02-20 10:58:00', NULL, NULL, 7039, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1487589252', 'admin', '2017-02-20 10:58:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20948, '2017-02-20 10:58:10', NULL, NULL, 7039, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 10:58:10', 'admin-1487550909-14875594903095554', 1, 1, 'SR', NULL, NULL, NULL),
(20949, '2017-02-20 09:29:14', NULL, NULL, 7036, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 09:29:14', 'admin-1487550909-14875541542519163', 1, 1, 'SR', NULL, NULL, NULL),
(20950, '2017-02-20 10:05:14', NULL, NULL, 7037, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1487589252', 'admin', '2017-02-20 10:05:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20951, '2017-02-20 10:05:41', NULL, NULL, 7037, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 10:05:41', 'admin-1487550909-14875563416913627', 1, 0, '', NULL, NULL, NULL),
(20952, '2017-02-20 10:05:41', NULL, NULL, 7037, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 10:05:41', 'admin-1487550909-14875563416913627', 1, 0, '', NULL, NULL, NULL),
(20953, '2017-02-20 10:05:41', NULL, NULL, 7037, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 10:05:41', 'admin-1487550909-14875563416913627', 1, 0, '', NULL, NULL, NULL),
(20954, '2017-02-20 10:05:41', NULL, NULL, 7037, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 10:05:41', 'admin-1487550909-14875563416913627', 1, 0, '', NULL, NULL, NULL),
(20955, '2017-02-20 10:05:41', NULL, NULL, 7037, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 10:05:41', 'admin-1487550909-14875563416913627', 1, 0, '', NULL, NULL, NULL),
(20956, '2017-02-20 11:38:46', NULL, NULL, 7043, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 11:38:46', 'admin-1487550909-14875619264706476', 1, 0, '', 1, NULL, NULL),
(20957, '2017-02-20 11:38:46', NULL, NULL, 7043, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 11:38:46', 'admin-1487550909-14875619264706476', 1, 0, '', 1, NULL, NULL),
(20958, '2017-02-20 11:38:29', NULL, NULL, 7042, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 11:38:29', 'admin-1487550909-1487561909015119', 1, 1, 'SR', NULL, NULL, NULL),
(20959, '2017-02-20 11:38:20', NULL, NULL, 7042, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 11:38:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20960, '2017-02-20 11:19:18', NULL, NULL, 7040, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 11:19:18', 'admin-1487550909-14875607578547289', 1, 1, 'SR', NULL, NULL, NULL),
(20961, '2017-02-20 11:19:17', NULL, NULL, 7040, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 11:19:17', 'admin-1487550909-14875607578547289', 1, 1, 'SR', NULL, NULL, NULL),
(20962, '2017-02-20 11:19:12', NULL, NULL, 7041, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 11:19:12', 'admin-1487550909-1487560752291186', 1, 1, 'SR', NULL, NULL, NULL),
(20963, '2017-02-20 11:19:12', NULL, NULL, 7041, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 11:19:12', 'admin-1487550909-1487560752291186', 1, 1, 'SR', NULL, NULL, NULL),
(20964, '2017-02-20 11:19:09', NULL, NULL, 7041, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1487589252', 'admin', '2017-02-20 11:19:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20965, '2017-02-20 10:59:25', NULL, NULL, 7040, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 10:59:25', 'admin-1487550909-14875595654204526', 1, 0, '', NULL, NULL, NULL),
(20966, '2017-02-20 10:59:25', NULL, NULL, 7040, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 10:59:25', 'admin-1487550909-14875595654204526', 1, 0, '', NULL, NULL, NULL),
(20967, '2017-02-20 10:58:10', NULL, NULL, 7039, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 10:58:10', 'admin-1487550909-14875594903095554', 1, 1, 'SR', NULL, NULL, NULL),
(20968, '2017-02-20 10:59:16', NULL, NULL, 7040, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 10:59:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20969, '2017-02-20 09:29:14', NULL, NULL, 7036, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 09:29:14', 'admin-1487550909-14875541542519163', 1, 1, 'SR', NULL, NULL, NULL),
(20970, '2017-02-20 09:29:06', NULL, NULL, 7036, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 09:29:06', 'admin-1487550909-14875541464094839', 1, 0, '', NULL, NULL, NULL),
(20971, '2017-02-20 09:29:06', NULL, NULL, 7036, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1487589252', 'admin', '2017-02-20 09:29:06', 'admin-1487550909-14875541464094839', 1, 0, '', NULL, NULL, NULL),
(20972, '2017-02-20 09:28:58', NULL, NULL, 7036, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1487589252', 'admin', '2017-02-20 09:28:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20973, '2017-02-20 09:09:44', NULL, NULL, 7035, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1487589252', 'admin', '2017-02-20 09:09:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20974, '2017-02-22 11:40:23', NULL, NULL, 7076, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 11:40:23', 'admin-1487726054-14877348236897290', 1, 1, 'SR', NULL, NULL, NULL),
(20975, '2017-02-22 11:58:19', NULL, NULL, 7078, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1487726054', 'admin', '2017-02-22 11:58:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20976, '2017-02-22 11:58:25', NULL, NULL, 7078, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 11:58:25', 'admin-1487726054-14877359056299446', 1, 1, 'SR', NULL, NULL, NULL),
(20977, '2017-02-22 12:09:10', NULL, NULL, 7076, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 12:09:10', 'admin-1487726054-14877365503637078', 1, 0, '', NULL, NULL, NULL),
(20978, '2017-02-22 12:09:40', NULL, NULL, 7079, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1487726054', 'admin', '2017-02-22 12:09:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20979, '2017-02-22 12:09:44', NULL, NULL, 7079, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 12:09:44', 'admin-1487726054-14877365839306991', 1, 1, 'SR', NULL, NULL, NULL),
(20980, '2017-02-22 12:09:44', NULL, NULL, 7079, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 12:09:44', 'admin-1487726054-14877365839306991', 1, 1, 'SR', NULL, NULL, NULL),
(20981, '2017-02-22 12:29:13', NULL, NULL, 7080, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.90, 0.0000, 0.0000, 11.90, 1, '27', 1, '1487726054', 'admin', '2017-02-22 12:29:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20982, '2017-02-22 12:29:43', NULL, NULL, 7080, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 12:29:43', 'admin-1487726054-1487737783749458', 1, 1, 'SR', NULL, NULL, NULL),
(20983, '2017-02-22 12:29:43', NULL, NULL, 7080, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 12:29:43', 'admin-1487726054-1487737783749458', 1, 1, 'SR', NULL, NULL, NULL),
(20984, '2017-02-22 12:29:43', NULL, NULL, 7080, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 12:29:43', 'admin-1487726054-1487737783749458', 1, 1, 'SR', NULL, NULL, NULL),
(20985, '2017-02-22 11:09:28', NULL, NULL, 7075, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1487726054', 'admin', '2017-02-22 11:09:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20986, '2017-02-22 11:06:37', NULL, NULL, 7074, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 11:06:37', 'admin-1487726054-14877327974606948', 1, 1, 'SR', NULL, NULL, NULL),
(20987, '2017-02-22 15:00:11', NULL, NULL, 7090, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1487726054', 'admin', '2017-02-22 15:00:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20988, '2017-02-22 12:29:43', NULL, NULL, 7080, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 12:29:43', 'admin-1487726054-1487737783749458', 1, 0, '', NULL, NULL, NULL),
(20989, '2017-02-22 12:29:43', NULL, NULL, 7080, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 12:29:43', 'admin-1487726054-1487737783749458', 1, 0, '', NULL, NULL, NULL),
(20990, '2017-02-22 12:40:37', NULL, NULL, 7081, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1487726054', 'admin', '2017-02-22 12:40:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20991, '2017-02-22 12:40:45', NULL, NULL, 7081, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 12:40:45', 'admin-1487726054-14877384453588618', 1, 1, 'SR', NULL, NULL, NULL),
(20992, '2017-02-22 12:40:45', NULL, NULL, 7081, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 12:40:45', 'admin-1487726054-14877384453588618', 1, 1, 'SR', NULL, NULL, NULL),
(20993, '2017-02-22 12:55:17', NULL, NULL, 7082, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1487726054', 'admin', '2017-02-22 12:55:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20994, '2017-02-22 12:55:21', NULL, NULL, 7082, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 12:55:21', 'admin-1487726054-14877393212865178', 1, 1, 'SR', NULL, NULL, NULL),
(20995, '2017-02-22 12:55:21', NULL, NULL, 7082, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 12:55:21', 'admin-1487726054-14877393212865178', 1, 1, 'SR', NULL, NULL, NULL),
(20996, '2017-02-22 13:03:29', NULL, NULL, 7083, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1487726054', 'admin', '2017-02-22 13:03:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(20997, '2017-02-22 13:03:36', NULL, NULL, 7083, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 13:03:36', 'admin-1487726054-14877398164479849', 1, 1, 'SR', NULL, NULL, NULL),
(20998, '2017-02-22 13:03:36', NULL, NULL, 7083, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 13:03:36', 'admin-1487726054-14877398164479849', 1, 1, 'SR', NULL, NULL, NULL),
(20999, '2017-02-22 13:03:36', NULL, NULL, 7083, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 13:03:36', 'admin-1487726054-14877398164479849', 1, 0, '', NULL, NULL, NULL),
(21000, '2017-02-22 13:06:06', NULL, NULL, 7080, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 13:06:06', 'admin-1487726054-1487739965849722', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(21001, '2017-02-22 13:07:39', NULL, NULL, 7084, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 13:07:39', 'admin-1487726054-148774005934475', 1, 1, 'SR', 1, NULL, NULL),
(21002, '2017-02-22 13:10:19', NULL, NULL, 7080, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 13:10:19', 'admin-1487726054-14877402189549292', 1, 1, 'SR', NULL, NULL, NULL),
(21003, '2017-02-22 13:30:51', NULL, NULL, 7080, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 13:30:51', 'admin-1487726054-14877414514879590', 1, 0, '', NULL, NULL, NULL),
(21004, '2017-02-22 13:30:51', NULL, NULL, 7080, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 13:30:51', 'admin-1487726054-14877414514879590', 1, 0, '', NULL, NULL, NULL),
(21005, '2017-02-22 13:47:59', NULL, NULL, 7085, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1487726054', 'admin', '2017-02-22 13:47:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21006, '2017-02-22 13:48:06', NULL, NULL, 7085, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 13:48:06', 'admin-1487726054-148774248600397', 1, 1, 'SR', NULL, NULL, NULL),
(21007, '2017-02-22 13:56:45', NULL, NULL, 7086, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1487726054', 'admin', '2017-02-22 13:56:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21008, '2017-02-22 13:57:31', NULL, NULL, 7086, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 13:57:31', 'admin-1487726054-14877430508531871', 1, 0, '', NULL, NULL, NULL),
(21009, '2017-02-22 13:57:31', NULL, NULL, 7086, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 13:57:31', 'admin-1487726054-14877430508531871', 1, 1, 'SR', NULL, NULL, NULL),
(21010, '2017-02-22 13:57:31', NULL, NULL, 7086, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 13:57:31', 'admin-1487726054-14877430508531871', 1, 1, 'SR', NULL, NULL, NULL),
(21011, '2017-02-22 13:57:31', NULL, NULL, 7086, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 13:57:31', 'admin-1487726054-14877430508531871', 1, 1, 'SR', NULL, NULL, NULL),
(21012, '2017-02-22 14:16:45', NULL, NULL, 7088, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1487726054', 'admin', '2017-02-22 14:16:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21013, '2017-02-22 14:15:48', NULL, NULL, 7087, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 14:15:48', 'admin-1487726054-14877441483425633', 1, 1, 'SR', NULL, NULL, NULL),
(21014, '2017-02-22 14:16:52', NULL, NULL, 7088, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 14:16:52', 'admin-1487726054-14877442126143745', 1, 1, 'SR', NULL, NULL, NULL),
(21015, '2017-02-22 14:16:52', NULL, NULL, 7088, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 14:16:52', 'admin-1487726054-14877442126143745', 1, 1, 'SR', NULL, NULL, NULL),
(21016, '2017-02-22 15:00:54', NULL, NULL, 7091, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 15:00:54', 'admin-1487726054-14877468545947655', 1, 0, '', 1, NULL, NULL),
(21017, '2017-02-22 15:33:57', NULL, NULL, 7092, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1487726054', 'admin', '2017-02-22 15:33:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21018, '2017-02-22 15:34:22', NULL, NULL, 7092, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 15:34:22', 'admin-1487726054-14877488625023876', 1, 0, '', NULL, NULL, NULL),
(21019, '2017-02-22 15:34:22', NULL, NULL, 7092, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 15:34:22', 'admin-1487726054-14877488625023876', 1, 0, '', NULL, NULL, NULL),
(21020, '2017-02-22 15:34:22', NULL, NULL, 7092, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 15:34:22', 'admin-1487726054-14877488625023876', 1, 1, 'SR', NULL, NULL, NULL),
(21021, '2017-02-22 15:34:22', NULL, NULL, 7092, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 15:34:22', 'admin-1487726054-14877488625023876', 1, 1, 'SR', NULL, NULL, NULL),
(21022, '2017-02-22 15:34:29', NULL, NULL, 7092, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 15:34:29', 'admin-1487726054-14877488689994322', 1, 0, '', NULL, NULL, NULL),
(21023, '2017-02-22 16:50:10', NULL, NULL, 7093, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1487726054', 'admin', '2017-02-22 16:50:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21024, '2017-02-22 16:50:19', NULL, NULL, 7093, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 16:50:19', 'admin-1487726054-1487753419375237', 1, 0, '', NULL, NULL, NULL),
(21025, '2017-02-22 16:50:24', NULL, NULL, 7093, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 16:50:24', 'admin-1487726054-1487753424615528', 1, 1, 'SR', NULL, NULL, NULL),
(21026, '2017-02-22 17:15:36', NULL, NULL, 7094, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 17:15:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21027, '2017-02-22 17:15:59', NULL, NULL, 7094, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 17:15:59', 'admin-1487726054-14877549597391924', 1, 1, 'SR', NULL, NULL, NULL),
(21028, '2017-02-22 17:30:54', NULL, NULL, 7095, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 17:30:54', 'admin-1487726054-14877558545445154', 1, 1, 'SR', 1, NULL, NULL),
(21029, '2017-02-22 17:48:20', NULL, NULL, 7096, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1487726054', 'admin', '2017-02-22 17:48:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21030, '2017-02-22 17:48:24', NULL, NULL, 7096, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 17:48:24', 'admin-1487726054-14877569039983612', 1, 1, 'SR', NULL, NULL, NULL),
(21031, '2017-02-22 17:48:24', NULL, NULL, 7096, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 17:48:24', 'admin-1487726054-14877569039983612', 1, 1, 'SR', NULL, NULL, NULL),
(21032, '2017-02-22 14:16:52', NULL, NULL, 7088, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 14:16:52', 'admin-1487726054-14877442126143745', 1, 0, '', NULL, NULL, NULL),
(21033, '2017-02-22 14:16:52', NULL, NULL, 7088, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 14:16:52', 'admin-1487726054-14877442126143745', 1, 0, '', NULL, NULL, NULL),
(21034, '2017-02-22 15:00:18', NULL, NULL, 7090, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 15:00:18', 'admin-1487726054-14877468185963398', 1, 1, 'SR', NULL, NULL, NULL),
(21035, '2017-02-22 15:00:54', NULL, NULL, 7091, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 15:00:54', 'admin-1487726054-14877468545947655', 1, 0, '', 1, NULL, NULL),
(21036, '2017-02-22 19:51:29', NULL, NULL, 7077, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 19:51:29', 'admin-1487726054-14877642894594571', 1, 0, '', NULL, NULL, NULL),
(21037, '2017-02-22 19:50:46', NULL, NULL, 7077, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 19:50:46', 'admin-1487726054-14877642466901928', 1, 1, 'SR', NULL, NULL, NULL),
(21038, '2017-02-22 19:26:18', NULL, NULL, 7098, 0, 181, '116', 'Open Food ', 'rice', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 19:26:18', 'admin-1487726054-14877627784831622', 1, 0, '', NULL, NULL, NULL),
(21039, '2017-02-22 19:26:00', NULL, NULL, 7098, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1487726054', 'admin', '2017-02-22 19:26:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21040, '2017-02-22 19:26:18', NULL, NULL, 7098, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 19:26:18', 'admin-1487726054-14877627784831622', 1, 1, 'SR', NULL, NULL, NULL),
(21041, '2017-02-22 19:10:30', NULL, NULL, 7097, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 19:10:30', 'admin-1487726054-14877618300832276', 1, 1, 'SR', NULL, NULL, NULL),
(21042, '2017-02-22 19:10:24', NULL, NULL, 7097, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1487726054', 'admin', '2017-02-22 19:10:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21043, '2017-02-22 14:43:32', NULL, NULL, 7089, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 14:43:32', 'admin-1487726054-1487745812528355', 1, 1, 'SR', NULL, NULL, NULL),
(21044, '2017-02-22 14:42:49', NULL, NULL, 7089, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1487726054', 'admin', '2017-02-22 14:42:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21045, '2017-02-22 14:43:32', NULL, NULL, 7089, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 14:43:32', 'admin-1487726054-1487745812528355', 1, 1, 'SR', NULL, NULL, NULL),
(21046, '2017-02-22 14:21:30', NULL, NULL, 7088, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 14:21:30', 'admin-1487726054-14877444897874550', 1, 0, '', NULL, NULL, NULL),
(21047, '2017-02-22 12:29:43', NULL, NULL, 7080, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 12:29:43', 'admin-1487726054-1487737783749458', 1, 1, 'SR', NULL, NULL, NULL),
(21048, '2017-02-22 19:50:46', NULL, NULL, 7077, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 19:50:46', 'admin-1487726054-14877642466901928', 1, 1, 'SR', NULL, NULL, NULL),
(21049, '2017-02-22 12:29:43', NULL, NULL, 7080, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 12:29:43', 'admin-1487726054-1487737783749458', 1, 1, 'SR', NULL, NULL, NULL),
(21050, '2017-02-22 12:29:43', NULL, NULL, 7080, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 12:29:43', 'admin-1487726054-1487737783749458', 1, 0, '', NULL, NULL, NULL),
(21051, '2017-02-22 11:40:23', NULL, NULL, 7076, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 11:40:23', 'admin-1487726054-14877348236897290', 1, 1, 'SR', NULL, NULL, NULL),
(21052, '2017-02-22 19:50:46', NULL, NULL, 7077, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 19:50:46', 'admin-1487726054-14877642466901928', 1, 1, 'SR', NULL, NULL, NULL),
(21053, '2017-02-22 11:38:01', NULL, NULL, 7077, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1487726054', 'admin', '2017-02-22 11:38:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21054, '2017-02-22 11:36:51', NULL, NULL, 7073, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 11:36:51', 'admin-1487726054-14877346112369098', 1, 1, 'SR', NULL, NULL, '10.0'),
(21055, '2017-02-22 11:36:35', NULL, NULL, 7076, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 11:36:35', 'admin-1487726054-14877345953059035', 1, 0, '', NULL, NULL, NULL),
(21056, '2017-02-22 11:36:35', NULL, NULL, 7076, 0, 73, '73', 'Marmite Chicken ', 'fried egg', 'Meals', 'Perfect Meals', 1, 17.50, 17.5000, 0.0000, 17.50, 1, '27', 1, '1487726054', 'admin', '2017-02-22 11:36:35', 'admin-1487726054-14877345953059035', 1, 1, 'SR', NULL, NULL, NULL),
(21057, '2017-02-22 11:36:13', NULL, NULL, 7076, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.55, 0.0000, 0.0000, 4.55, 1, '27', 1, '1487726054', 'admin', '2017-02-22 11:36:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21058, '2017-02-22 09:14:29', NULL, NULL, 7067, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 09:14:29', 'admin-1487726054-14877260697242684', 1, 0, '', NULL, NULL, NULL),
(21059, '2017-02-22 11:09:46', NULL, NULL, 7075, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 11:09:46', 'admin-1487726054-14877329866954454', 1, 1, 'SR', NULL, NULL, NULL),
(21060, '2017-02-22 11:09:42', NULL, NULL, 7075, 0, 153, '87', 'Wake Me Up!', 'sunny side up', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 11:09:42', 'admin-1487726054-1487732982182948', 1, 0, '', NULL, NULL, NULL),
(21061, '2017-02-22 11:09:42', NULL, NULL, 7075, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 11:09:42', 'admin-1487726054-1487732982182948', 1, 0, '', NULL, NULL, NULL),
(21062, '2017-02-22 09:57:30', NULL, NULL, 7068, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 09:57:30', 'admin-1487726054-14877286507201286', 1, 0, '', NULL, NULL, NULL),
(21063, '2017-02-22 09:31:51', NULL, NULL, 7068, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 09:31:51', 'admin-1487726054-14877271114973112', 1, 1, 'SR', NULL, NULL, NULL),
(21064, '2017-02-22 09:31:59', NULL, NULL, 7068, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 09:31:59', 'admin-1487726054-14877271193811758', 1, 0, '', NULL, NULL, NULL),
(21065, '2017-02-22 09:35:39', NULL, NULL, 7069, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 09:35:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21066, '2017-02-22 09:35:43', NULL, NULL, 7069, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 09:35:43', 'admin-1487726054-14877273429866272', 1, 1, 'SR', NULL, NULL, NULL),
(21067, '2017-02-22 10:04:16', NULL, NULL, 7070, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1487726054', 'admin', '2017-02-22 10:04:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21068, '2017-02-22 10:04:43', NULL, NULL, 7070, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 10:04:43', 'admin-1487726054-14877290834146496', 1, 1, 'SR', NULL, NULL, NULL),
(21069, '2017-02-22 10:04:43', NULL, NULL, 7070, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 10:04:43', 'admin-1487726054-14877290834146496', 1, 0, '', NULL, NULL, NULL),
(21070, '2017-02-22 10:28:01', NULL, NULL, 7071, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1487726054', 'admin', '2017-02-22 10:28:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21071, '2017-02-22 10:28:10', NULL, NULL, 7071, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 10:28:10', 'admin-1487726054-14877304903042466', 1, 1, 'SR', NULL, NULL, NULL),
(21072, '2017-02-22 10:28:10', NULL, NULL, 7071, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 10:28:10', 'admin-1487726054-14877304903042466', 1, 1, 'SR', NULL, NULL, NULL),
(21073, '2017-02-22 10:28:10', NULL, NULL, 7071, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 10:28:10', 'admin-1487726054-14877304903042466', 1, 0, '', NULL, NULL, NULL),
(21074, '2017-02-22 10:29:29', NULL, NULL, 7069, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 10:29:29', 'admin-1487726054-14877305696903448', 1, 1, 'SR', NULL, NULL, NULL),
(21075, '2017-02-22 10:39:19', NULL, NULL, 7072, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1487726054', 'admin', '2017-02-22 10:39:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21076, '2017-02-22 10:39:31', NULL, NULL, 7072, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 10:39:31', 'admin-1487726054-14877311708955483', 1, 1, 'SR', NULL, NULL, NULL),
(21077, '2017-02-22 10:39:31', NULL, NULL, 7072, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 10:39:31', 'admin-1487726054-14877311708955483', 1, 1, 'SR', NULL, NULL, NULL),
(21078, '2017-02-22 10:39:54', NULL, NULL, 7072, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 10:39:54', 'admin-1487726054-14877311941977967', 1, 1, 'SR', NULL, NULL, NULL),
(21079, '2017-02-22 10:59:19', NULL, NULL, 7073, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1487726054', 'admin', '2017-02-22 10:59:19', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(21080, '2017-02-22 10:59:27', NULL, NULL, 7073, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 10:59:27', 'admin-1487726054-1487732367018947', 1, 1, 'SR', NULL, NULL, '10.0'),
(21081, '2017-02-22 10:59:27', NULL, NULL, 7073, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 10:59:27', 'admin-1487726054-1487732367018947', 1, 1, 'SR', NULL, NULL, '10.0'),
(21082, '2017-02-22 11:06:25', NULL, NULL, 7074, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1487726054', 'admin', '2017-02-22 11:06:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21083, '2017-02-22 11:06:37', NULL, NULL, 7074, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 11:06:37', 'admin-1487726054-14877327974606948', 1, 1, 'SR', NULL, NULL, NULL),
(21084, '2017-02-22 11:06:37', NULL, NULL, 7074, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 11:06:37', 'admin-1487726054-14877327974606948', 1, 0, '', NULL, NULL, NULL),
(21085, '2017-02-22 09:31:24', NULL, NULL, 7068, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 09:31:24', 'admin-1487726054-14877270840974842', 1, 0, '', NULL, NULL, NULL),
(21086, '2017-02-22 09:31:24', NULL, NULL, 7068, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 09:31:24', 'admin-1487726054-14877270840974842', 1, 0, '', NULL, NULL, NULL),
(21087, '2017-02-22 09:14:34', NULL, NULL, 7067, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487726054', 'admin', '2017-02-22 09:14:34', 'admin-1487726054-14877260745007484', 1, 0, '', NULL, NULL, NULL),
(21088, '2017-02-22 09:31:16', NULL, NULL, 7068, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1487726054', 'admin', '2017-02-22 09:31:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21089, '2017-02-22 09:14:25', NULL, NULL, 7067, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1487726054', 'admin', '2017-02-22 09:14:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21090, '2017-02-23 12:46:56', NULL, NULL, 7109, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:46:56', 'admin-1487810252-14878252160626590', 1, 1, 'SR', NULL, NULL, NULL),
(21091, '2017-02-23 12:46:56', NULL, NULL, 7109, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:46:56', 'admin-1487810252-14878252160626590', 1, 1, 'SR', NULL, NULL, NULL),
(21092, '2017-02-23 12:46:56', NULL, NULL, 7109, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:46:56', 'admin-1487810252-14878252160626590', 1, 0, '', NULL, NULL, NULL),
(21093, '2017-02-23 12:46:56', NULL, NULL, 7109, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:46:56', 'admin-1487810252-14878252160626590', 1, 1, 'SR', NULL, NULL, NULL),
(21094, '2017-02-23 12:47:25', NULL, NULL, 7104, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:47:25', 'admin-1487810252-14878252456577134', 1, 0, '', NULL, NULL, NULL),
(21095, '2017-02-23 20:30:14', NULL, NULL, 7126, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1487852013', 'admin', '2017-02-23 20:30:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21096, '2017-02-23 12:47:54', NULL, NULL, 7110, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:47:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21097, '2017-02-23 12:47:59', NULL, NULL, 7110, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:47:59', 'admin-1487810252-14878252796973883', 1, 1, 'SR', NULL, NULL, NULL),
(21098, '2017-02-23 12:47:59', NULL, NULL, 7110, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:47:59', 'admin-1487810252-14878252796973883', 1, 0, '', NULL, NULL, NULL),
(21099, '2017-02-23 12:49:03', NULL, NULL, 7109, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:49:03', 'admin-1487810252-148782534365447', 1, 1, 'SR', NULL, NULL, NULL),
(21100, '2017-02-23 20:44:47', NULL, NULL, 7128, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 20:44:47', 'admin-1487852013-14878538876204939', 1, 0, '', NULL, NULL, NULL),
(21101, '2017-02-23 20:44:58', NULL, NULL, 7128, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 20:44:58', 'admin-1487852013-1487853898256359', 1, 1, 'SR', NULL, NULL, NULL),
(21102, '2017-02-23 20:44:58', NULL, NULL, 7128, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 20:44:58', 'admin-1487852013-1487853898256359', 1, 1, 'SR', NULL, NULL, NULL),
(21103, '2017-02-23 20:13:20', NULL, NULL, 7125, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 20:13:20', 'admin-1487830626-14878519998304267', 1, 1, 'SR', NULL, NULL, NULL),
(21104, '2017-02-23 20:44:47', NULL, NULL, 7128, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 20:44:47', 'admin-1487852013-14878538876204939', 1, 0, '', NULL, NULL, NULL),
(21105, '2017-02-23 14:03:07', NULL, NULL, 7111, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:03:07', 'admin-1487810252-1487829787041114', 1, 1, 'SR', NULL, NULL, NULL),
(21106, '2017-02-23 14:03:07', NULL, NULL, 7111, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:03:07', 'admin-1487810252-1487829787041114', 1, 1, 'SR', NULL, NULL, NULL),
(21107, '2017-02-23 14:03:07', NULL, NULL, 7111, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:03:07', 'admin-1487810252-1487829787041114', 1, 1, 'SR', NULL, NULL, NULL),
(21108, '2017-02-23 14:16:29', NULL, NULL, 7112, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.50, 0.0000, 0.0000, 16.50, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:16:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21109, '2017-02-23 14:17:00', NULL, NULL, 7112, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:17:00', 'admin-1487810252-14878306201832418', 1, 0, '', NULL, NULL, NULL),
(21110, '2017-02-23 14:17:00', NULL, NULL, 7112, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:17:00', 'admin-1487810252-14878306201832418', 1, 0, '', NULL, NULL, NULL),
(21111, '2017-02-23 14:17:00', NULL, NULL, 7112, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:17:00', 'admin-1487810252-14878306201832418', 1, 0, '', NULL, NULL, NULL),
(21112, '2017-02-23 14:17:00', NULL, NULL, 7112, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:17:00', 'admin-1487810252-14878306201832418', 1, 0, '', NULL, NULL, NULL),
(21113, '2017-02-23 14:17:00', NULL, NULL, 7112, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:17:00', 'admin-1487810252-14878306201832418', 1, 0, '', NULL, NULL, NULL),
(21114, '2017-02-23 14:17:00', NULL, NULL, 7112, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:17:00', 'admin-1487810252-14878306201832418', 1, 0, '', NULL, NULL, NULL),
(21115, '2017-02-23 14:17:28', NULL, NULL, 7112, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:17:28', 'admin-1487830626-14878306480717564', 1, 1, 'SR', NULL, NULL, NULL),
(21116, '2017-02-23 14:17:28', NULL, NULL, 7112, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:17:28', 'admin-1487830626-14878306480717564', 1, 1, 'SR', NULL, NULL, NULL),
(21117, '2017-02-23 14:17:28', NULL, NULL, 7112, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:17:28', 'admin-1487830626-14878306480717564', 1, 1, 'SR', NULL, NULL, NULL),
(21118, '2017-02-23 14:17:28', NULL, NULL, 7112, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 3, 12.00, 36.0000, 0.0000, 36.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:17:28', 'admin-1487830626-14878306480717564', 1, 1, 'SR', NULL, NULL, NULL),
(21119, '2017-02-23 14:17:32', NULL, NULL, 7113, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:17:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21120, '2017-02-23 14:17:44', NULL, NULL, 7113, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:17:44', 'admin-1487830626-14878306647575171', 1, 0, '', NULL, NULL, NULL),
(21121, '2017-02-23 14:17:44', NULL, NULL, 7113, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:17:44', 'admin-1487830626-14878306647575171', 1, 1, 'SR', NULL, NULL, NULL),
(21122, '2017-02-23 14:17:44', NULL, NULL, 7113, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:17:44', 'admin-1487830626-14878306647575171', 1, 1, 'SR', NULL, NULL, NULL),
(21123, '2017-02-23 11:48:35', NULL, NULL, 7103, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1487852013', 'admin', '2017-02-23 11:48:35', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(21124, '2017-02-23 11:48:40', NULL, NULL, 7103, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 11:48:40', 'admin-1487810252-14878217205644183', 1, 1, 'SR', NULL, NULL, '10.0'),
(21125, '2017-02-23 11:51:12', NULL, NULL, 7104, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1487852013', 'admin', '2017-02-23 11:51:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21126, '2017-02-23 11:51:17', NULL, NULL, 7104, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 11:51:17', 'admin-1487810252-14878218775401666', 1, 1, 'SR', NULL, NULL, NULL),
(21127, '2017-02-23 11:55:00', NULL, NULL, 7103, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 11:55:00', 'admin-1487810252-14878221002092163', 1, 0, '', NULL, NULL, '10.0'),
(21128, '2017-02-23 11:55:00', NULL, NULL, 7103, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 11:55:00', 'admin-1487810252-14878221002092163', 1, 1, 'SR', NULL, NULL, '10.0'),
(21129, '2017-02-23 20:13:20', NULL, NULL, 7125, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 20:13:20', 'admin-1487830626-14878519998304267', 1, 0, '', NULL, NULL, NULL),
(21130, '2017-02-23 20:13:20', NULL, NULL, 7125, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 20:13:20', 'admin-1487830626-14878519998304267', 1, 0, '', NULL, NULL, NULL),
(21131, '2017-02-23 20:13:20', NULL, NULL, 7125, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 20:13:20', 'admin-1487830626-14878519998304267', 1, 1, 'SR', NULL, NULL, NULL),
(21132, '2017-02-23 20:13:06', NULL, NULL, 7125, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1487852013', 'admin', '2017-02-23 20:13:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21133, '2017-02-23 14:59:02', NULL, NULL, 7117, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:59:02', 'admin-1487830626-14878331420529171', 1, 1, 'SR', NULL, NULL, NULL),
(21134, '2017-02-23 14:59:02', NULL, NULL, 7117, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:59:02', 'admin-1487830626-14878331420529171', 1, 1, 'SR', NULL, NULL, NULL),
(21135, '2017-02-23 14:48:57', NULL, NULL, 7115, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:48:57', 'admin-1487830626-148783253703125', 1, 1, 'SR', NULL, NULL, NULL),
(21136, '2017-02-23 19:24:27', NULL, NULL, 7123, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 19:24:27', 'admin-1487830626-14878490670384680', 1, 0, '', NULL, NULL, NULL),
(21137, '2017-02-23 19:13:44', NULL, NULL, 7124, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 19:13:44', 'admin-1487830626-14878484246345115', 1, 1, 'SR', 1, NULL, NULL),
(21138, '2017-02-23 19:13:44', NULL, NULL, 7124, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 19:13:44', 'admin-1487830626-14878484246345115', 1, 1, 'SR', 1, NULL, NULL),
(21139, '2017-02-23 19:10:43', NULL, NULL, 7123, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 19:10:43', 'admin-1487830626-14878482432498957', 1, 1, 'SR', NULL, NULL, NULL),
(21140, '2017-02-23 18:59:35', NULL, NULL, 7123, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 18:59:35', 'admin-1487830626-14878475753825045', 1, 0, '', NULL, NULL, NULL),
(21141, '2017-02-23 18:57:58', NULL, NULL, 7123, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 18:57:58', 'admin-1487830626-1487847477864712', 1, 1, 'SR', NULL, NULL, NULL),
(21142, '2017-02-23 18:57:58', NULL, NULL, 7123, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 18:57:58', 'admin-1487830626-1487847477864712', 1, 0, '', NULL, NULL, NULL),
(21143, '2017-02-23 18:57:58', NULL, NULL, 7123, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 18:57:58', 'admin-1487830626-1487847477864712', 1, 0, '', NULL, NULL, NULL),
(21144, '2017-02-23 18:51:59', NULL, NULL, 7123, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1487852013', 'admin', '2017-02-23 18:51:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21145, '2017-02-23 17:29:27', NULL, NULL, 7122, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 17:29:27', 'admin-1487830626-14878421677662952', 1, 1, 'SR', 1, NULL, NULL),
(21146, '2017-02-23 17:26:01', NULL, NULL, 7120, 0, 181, '116', 'Open Food ', 'cookies', 'Meals', 'Perfect Meals', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1487852013', 'admin', '2017-02-23 17:26:01', 'admin-1487830626-14878419614548884', 1, 0, '', NULL, NULL, NULL),
(21147, '2017-02-23 16:38:49', NULL, NULL, 7120, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 16:38:49', 'admin-1487830626-14878391293982016', 1, 1, 'SR', NULL, NULL, NULL),
(21148, '2017-02-23 16:38:43', NULL, NULL, 7120, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.59, 0.0000, 0.0000, 1.59, 1, '27', 1, '1487852013', 'admin', '2017-02-23 16:38:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21149, '2017-02-23 16:01:31', NULL, NULL, 7119, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 16:01:31', 'admin-1487830626-14878368910912650', 1, 1, 'SR', NULL, NULL, NULL),
(21150, '2017-02-23 16:01:31', NULL, NULL, 7119, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 16:01:31', 'admin-1487830626-14878368910912650', 1, 1, 'SR', NULL, NULL, NULL),
(21151, '2017-02-23 16:01:26', NULL, NULL, 7119, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1487852013', 'admin', '2017-02-23 16:01:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21152, '2017-02-23 20:13:20', NULL, NULL, 7125, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 20:13:20', 'admin-1487830626-14878519998304267', 1, 1, 'SR', NULL, NULL, NULL),
(21153, '2017-02-23 14:59:02', NULL, NULL, 7117, NULL, 58, '58', 'House White Bottle', '', 'Cold Drinks', 'Wine', 1, 88.00, 88.0000, 0.0000, 88.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:59:02', 'admin-1487830626-14878331420529171', 1, 1, 'SR', NULL, NULL, NULL),
(21154, '2017-02-23 14:17:44', NULL, NULL, 7113, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:17:44', 'admin-1487830626-14878306647575171', 1, 0, '', NULL, NULL, NULL),
(21155, '2017-02-23 20:43:00', NULL, NULL, 7128, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1487852013', 'admin', '2017-02-23 20:43:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21156, '2017-02-23 20:39:42', NULL, NULL, 7127, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 20:39:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21157, '2017-02-23 20:39:48', NULL, NULL, 7127, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 20:39:48', 'admin-1487852013-14878535884935656', 1, 1, 'SR', NULL, NULL, NULL),
(21158, '2017-02-23 20:30:20', NULL, NULL, 7126, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 20:30:20', 'admin-1487852013-14878530206395870', 1, 1, 'SR', NULL, NULL, NULL),
(21159, '2017-02-23 14:59:02', NULL, NULL, 7117, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:59:02', 'admin-1487830626-14878331420529171', 1, 0, '', NULL, NULL, NULL),
(21160, '2017-02-23 14:55:19', NULL, NULL, 7116, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:55:19', 'admin-1487830626-148783291937634', 1, 1, 'SR', NULL, NULL, NULL),
(21161, '2017-02-23 14:55:25', NULL, NULL, 7117, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.10, 0.0000, 0.0000, 13.10, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:55:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21162, '2017-02-23 14:55:19', NULL, NULL, 7116, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:55:19', 'admin-1487830626-148783291937634', 1, 1, 'SR', NULL, NULL, NULL),
(21163, '2017-02-23 14:55:00', NULL, NULL, 7116, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:55:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21164, '2017-02-23 14:55:19', NULL, NULL, 7116, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:55:19', 'admin-1487830626-148783291937634', 1, 0, '', NULL, NULL, NULL),
(21165, '2017-02-23 14:55:19', NULL, NULL, 7116, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:55:19', 'admin-1487830626-148783291937634', 1, 0, '', NULL, NULL, NULL),
(21166, '2017-02-23 14:48:57', NULL, NULL, 7115, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:48:57', 'admin-1487830626-148783253703125', 1, 1, 'SR', NULL, NULL, NULL),
(21167, '2017-02-23 14:48:43', NULL, NULL, 7115, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:48:43', 'admin-1487830626-14878325237212913', 1, 0, '', NULL, NULL, NULL),
(21168, '2017-02-23 14:48:57', NULL, NULL, 7115, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:48:57', 'admin-1487830626-148783253703125', 1, 0, '', NULL, NULL, NULL),
(21169, '2017-02-23 14:48:43', NULL, NULL, 7115, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:48:43', 'admin-1487830626-14878325237212913', 1, 0, '', NULL, NULL, NULL),
(21170, '2017-02-23 14:48:31', NULL, NULL, 7115, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:48:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21171, '2017-02-23 14:32:21', NULL, NULL, 7114, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:32:21', 'admin-1487830626-14878315411956253', 1, 1, 'SR', 1, NULL, NULL),
(21172, '2017-02-23 14:17:44', NULL, NULL, 7113, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:17:44', 'admin-1487830626-14878306647575171', 1, 0, '', NULL, NULL, NULL),
(21173, '2017-02-23 14:01:42', NULL, NULL, 7111, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1487852013', 'admin', '2017-02-23 14:01:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21174, '2017-02-23 13:28:16', NULL, NULL, 7109, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 13:28:16', 'admin-1487810252-1487827696601122', 1, 0, '', NULL, NULL, NULL),
(21175, '2017-02-23 13:00:26', NULL, NULL, 7109, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 13:00:26', 'admin-1487810252-148782602617759', 1, 1, 'SR', NULL, NULL, NULL),
(21176, '2017-02-23 13:28:16', NULL, NULL, 7109, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 13:28:16', 'admin-1487810252-1487827696601122', 1, 0, '', NULL, NULL, NULL),
(21177, '2017-02-23 11:57:28', NULL, NULL, 7105, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 11:57:28', 'admin-1487810252-1487822248431712', 1, 1, 'SR', NULL, NULL, NULL),
(21178, '2017-02-23 11:57:28', NULL, NULL, 7105, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 11:57:28', 'admin-1487810252-1487822248431712', 1, 0, '', NULL, NULL, NULL),
(21179, '2017-02-23 12:17:24', NULL, NULL, 7106, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:17:24', 'admin-1487810252-14878234442204562', 1, 1, 'SR', 1, NULL, NULL),
(21180, '2017-02-23 12:24:05', NULL, NULL, 7107, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:24:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21181, '2017-02-23 12:24:09', NULL, NULL, 7107, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:24:09', 'admin-1487810252-14878238495664178', 1, 0, '', NULL, NULL, NULL),
(21182, '2017-02-23 12:29:45', NULL, NULL, 7108, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.45, 0.0000, 0.0000, 4.45, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:29:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21183, '2017-02-23 12:30:14', NULL, NULL, 7108, 0, 73, '73', 'Marmite Chicken ', 'fried egg', 'Meals', 'Perfect Meals', 1, 17.50, 17.5000, 0.0000, 17.50, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:30:14', 'admin-1487810252-14878242141815220', 1, 1, 'SR', NULL, NULL, NULL),
(21184, '2017-02-23 12:30:14', NULL, NULL, 7108, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:30:14', 'admin-1487810252-14878242141815220', 1, 1, 'SR', NULL, NULL, NULL),
(21185, '2017-02-23 12:30:14', NULL, NULL, 7108, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:30:14', 'admin-1487810252-14878242141815220', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(21186, '2017-02-23 10:36:09', NULL, NULL, 7100, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1487852013', 'admin', '2017-02-23 10:36:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21187, '2017-02-23 10:36:22', NULL, NULL, 7100, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 10:36:22', 'admin-1487810252-14878173819922181', 1, 1, 'SR', NULL, NULL, NULL),
(21188, '2017-02-23 10:36:22', NULL, NULL, 7100, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 10:36:22', 'admin-1487810252-14878173819922181', 1, 1, 'SR', NULL, NULL, NULL),
(21189, '2017-02-23 10:36:22', NULL, NULL, 7100, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 10:36:22', 'admin-1487810252-14878173819922181', 1, 1, 'SR', NULL, NULL, NULL),
(21190, '2017-02-23 10:41:58', NULL, NULL, 7099, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 10:41:58', 'admin-1487810252-14878177180815259', 1, 1, 'SR', NULL, NULL, NULL),
(21191, '2017-02-23 10:42:04', NULL, NULL, 7101, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1487852013', 'admin', '2017-02-23 10:42:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21192, '2017-02-23 10:42:08', NULL, NULL, 7101, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 10:42:08', 'admin-1487810252-1487817727986341', 1, 1, 'SR', NULL, NULL, NULL),
(21193, '2017-02-23 10:58:03', NULL, NULL, 7102, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 10:58:03', 'admin-1487810252-14878186835692637', 1, 1, 'SR', 1, NULL, NULL),
(21194, '2017-02-23 10:22:23', NULL, NULL, 7099, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 10:22:23', 'admin-1487810252-14878165429778778', 1, 0, '', NULL, NULL, NULL),
(21195, '2017-02-23 12:46:27', NULL, NULL, 7109, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:46:27', 'admin-1487810252-1487825187380324', 1, 0, '', NULL, NULL, NULL),
(21196, '2017-02-23 12:46:27', NULL, NULL, 7109, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:46:27', 'admin-1487810252-1487825187380324', 1, 0, '', NULL, NULL, NULL),
(21197, '2017-02-23 12:46:27', NULL, NULL, 7109, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:46:27', 'admin-1487810252-1487825187380324', 1, 0, '', NULL, NULL, NULL),
(21198, '2017-02-23 12:46:27', NULL, NULL, 7109, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:46:27', 'admin-1487810252-1487825187380324', 1, 0, '', NULL, NULL, NULL),
(21199, '2017-02-23 12:46:27', NULL, NULL, 7109, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:46:27', 'admin-1487810252-1487825187380324', 1, 0, '', NULL, NULL, NULL),
(21200, '2017-02-23 12:46:27', NULL, NULL, 7109, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:46:27', 'admin-1487810252-1487825187380324', 1, 0, '', NULL, NULL, NULL),
(21201, '2017-02-23 12:45:44', NULL, NULL, 7109, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.50, 0.0000, 0.0000, 14.50, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:45:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21202, '2017-02-23 12:30:14', NULL, NULL, 7108, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 12:30:14', 'admin-1487810252-14878242141815220', 1, 1, 'SR', NULL, NULL, NULL),
(21203, '2017-02-23 11:57:15', NULL, NULL, 7105, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1487852013', 'admin', '2017-02-23 11:57:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21204, '2017-02-23 11:55:48', NULL, NULL, 7103, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 11:55:48', 'admin-1487810252-14878221478719281', 1, 1, 'SR', NULL, NULL, '10.0'),
(21205, '2017-02-23 11:55:38', NULL, NULL, 7103, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 11:55:38', 'admin-1487810252-14878221382519860', 1, 0, '', NULL, NULL, '10.0'),
(21206, '2017-02-23 10:58:03', NULL, NULL, 7102, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 10:58:03', 'admin-1487810252-14878186835692637', 1, 1, 'SR', 1, NULL, NULL),
(21207, '2017-02-23 10:22:31', NULL, NULL, 7099, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 10:22:31', 'admin-1487810252-14878165511111620', 1, 0, '', NULL, NULL, NULL),
(21208, '2017-02-23 10:22:23', NULL, NULL, 7099, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 10:22:23', 'admin-1487810252-14878165429778778', 1, 0, '', NULL, NULL, NULL),
(21209, '2017-02-23 10:22:31', NULL, NULL, 7099, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 10:22:31', 'admin-1487810252-14878165511111620', 1, 0, '', NULL, NULL, NULL),
(21210, '2017-02-23 10:22:23', NULL, NULL, 7099, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487852013', 'admin', '2017-02-23 10:22:23', 'admin-1487810252-14878165429778778', 1, 0, '', NULL, NULL, NULL),
(21211, '2017-02-23 10:22:14', NULL, NULL, 7099, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1487852013', 'admin', '2017-02-23 10:22:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21212, '2017-02-24 12:05:26', NULL, NULL, 7139, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 12:05:26', 'admin-1487906895-14879091267461621', 1, 1, 'SR', NULL, NULL, NULL),
(21213, '2017-02-24 11:45:45', NULL, NULL, 7137, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 11:45:45', 'admin-1487906895-1487907945045267', 1, 1, 'SR', NULL, NULL, NULL),
(21214, '2017-02-24 11:45:45', NULL, NULL, 7137, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 11:45:45', 'admin-1487906895-1487907945045267', 1, 1, 'SR', NULL, NULL, NULL),
(21215, '2017-02-24 11:54:44', NULL, NULL, 7138, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1487938890', 'admin', '2017-02-24 11:54:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21216, '2017-02-24 11:55:17', NULL, NULL, 7138, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 11:55:17', 'admin-1487906895-14879085176958223', 1, 0, '', NULL, NULL, NULL),
(21217, '2017-02-24 11:55:17', NULL, NULL, 7138, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 11:55:17', 'admin-1487906895-14879085176958223', 1, 0, '', NULL, NULL, NULL),
(21218, '2017-02-24 11:55:17', NULL, NULL, 7138, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 11:55:17', 'admin-1487906895-14879085176958223', 1, 0, '', NULL, NULL, NULL),
(21219, '2017-02-24 11:55:31', NULL, NULL, 7138, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 11:55:31', 'admin-1487906895-14879085312036417', 1, 0, '', NULL, NULL, NULL),
(21220, '2017-02-24 12:04:54', NULL, NULL, 7139, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1487938890', 'admin', '2017-02-24 12:04:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21221, '2017-02-24 12:05:19', NULL, NULL, 7139, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 12:05:19', 'admin-1487906895-14879091188874170', 1, 0, '', NULL, NULL, NULL),
(21222, '2017-02-24 12:05:19', NULL, NULL, 7139, 0, 217, '151', 'Spicy Lemony Wings', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 12:05:19', 'admin-1487906895-14879091188874170', 1, 0, '', NULL, NULL, NULL),
(21223, '2017-02-24 19:19:07', NULL, NULL, 7162, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 19:19:07', 'admin-1487913138-1487935146866612', 1, 1, 'SR', 1, NULL, NULL),
(21224, '2017-02-24 19:08:28', NULL, NULL, 7161, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 19:08:28', 'admin-1487913138-14879345086072354', 1, 1, 'SR', NULL, NULL, NULL),
(21225, '2017-02-24 19:08:22', NULL, NULL, 7161, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.80, 0.0000, 0.0000, 10.80, 1, '27', 1, '1487938890', 'admin', '2017-02-24 19:08:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21226, '2017-02-24 13:47:48', NULL, NULL, 7144, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:47:48', 'admin-1487913138-14879152684724096', 1, 1, 'SR', NULL, NULL, NULL),
(21227, '2017-02-24 13:12:24', NULL, NULL, 7145, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:12:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21228, '2017-02-24 13:12:32', NULL, NULL, 7145, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:12:32', 'admin-1487913138-14879131521205398', 1, 0, '', NULL, NULL, NULL),
(21229, '2017-02-24 13:12:32', NULL, NULL, 7145, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:12:32', 'admin-1487913138-14879131521205398', 1, 1, 'SR', NULL, NULL, NULL),
(21230, '2017-02-24 13:16:33', NULL, NULL, 7137, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:16:33', 'admin-1487913138-14879133931171438', 1, 1, 'SR', NULL, NULL, NULL),
(21231, '2017-02-24 13:24:44', NULL, NULL, 7146, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:24:44', 'admin-1487913138-1487913884529513', 1, 1, 'SR', 1, NULL, '10.0'),
(21232, '2017-02-24 13:32:08', NULL, NULL, 7147, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:32:08', 'admin-1487913138-14879143285471652', 1, 0, '', NULL, NULL, NULL),
(21233, '2017-02-24 20:32:39', NULL, NULL, 7163, 0, 181, '116', 'Open Food ', 'noodle', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 20:32:39', 'admin-1487938890-14879395591148740', 1, 0, '', NULL, NULL, NULL),
(21234, '2017-02-24 19:25:51', NULL, NULL, 7163, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 19:25:51', 'admin-1487913138-14879355517794676', 1, 1, 'SR', NULL, NULL, NULL),
(21235, '2017-02-24 19:26:51', NULL, NULL, 7161, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 19:26:51', 'admin-1487913138-14879356116659666', 1, 0, '', NULL, NULL, NULL),
(21236, '2017-02-24 19:35:01', NULL, NULL, 7164, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1487938890', 'admin', '2017-02-24 19:35:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21237, '2017-02-24 19:35:12', NULL, NULL, 7164, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 19:35:12', 'admin-1487913138-14879361122996025', 1, 1, 'SR', NULL, NULL, NULL),
(21238, '2017-02-24 19:35:12', NULL, NULL, 7164, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 19:35:12', 'admin-1487913138-14879361122996025', 1, 0, '', NULL, NULL, NULL),
(21239, '2017-02-24 19:35:26', NULL, NULL, 7164, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 19:35:26', 'admin-1487913138-14879361262564274', 1, 1, 'SR', NULL, NULL, NULL),
(21240, '2017-02-24 19:35:26', NULL, NULL, 7164, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 19:35:26', 'admin-1487913138-14879361262564274', 1, 0, '', NULL, NULL, NULL),
(21241, '2017-02-24 19:48:51', NULL, NULL, 7161, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 19:48:51', 'admin-1487913138-1487936931354198', 1, 1, 'SR', NULL, NULL, NULL),
(21242, '2017-02-24 19:48:51', NULL, NULL, 7161, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 19:48:51', 'admin-1487913138-1487936931354198', 1, 0, '', NULL, NULL, NULL),
(21243, '2017-02-24 19:49:02', NULL, NULL, 7161, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 19:49:02', 'admin-1487913138-14879369419599637', 1, 1, 'SR', NULL, NULL, NULL),
(21244, '2017-02-24 19:49:02', NULL, NULL, 7161, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 19:49:02', 'admin-1487913138-14879369419599637', 1, 1, 'SR', NULL, NULL, NULL),
(21245, '2017-02-24 20:20:11', NULL, NULL, 7165, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 20:20:11', 'admin-1487913138-14879388116068145', 1, 1, 'SR', 1, NULL, NULL),
(21246, '2017-02-24 20:20:11', NULL, NULL, 7165, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 20:20:11', 'admin-1487913138-14879388116068145', 1, 1, 'SR', 1, NULL, NULL),
(21247, '2017-02-24 20:21:23', NULL, NULL, 7163, 0, 181, '116', 'Open Food ', 'bff', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 20:21:23', 'admin-1487913138-14879388835612397', 1, 0, '', NULL, NULL, NULL),
(21248, '2017-02-24 18:59:14', NULL, NULL, 7160, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 18:59:14', 'admin-1487913138-1487933954327824', 1, 1, 'SR', NULL, NULL, NULL),
(21249, '2017-02-24 12:36:04', NULL, NULL, 7142, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 12:36:04', 'admin-1487906895-14879109644377911', 1, 1, 'SR', NULL, NULL, NULL),
(21250, '2017-02-24 12:44:55', NULL, NULL, 7141, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 12:44:55', 'admin-1487906895-14879114956009534', 1, 1, 'SR', NULL, NULL, NULL),
(21251, '2017-02-24 13:02:20', NULL, NULL, 7143, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:02:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21252, '2017-02-24 12:35:18', NULL, NULL, 7142, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.90, 0.0000, 0.0000, 14.90, 1, '27', 1, '1487938890', 'admin', '2017-02-24 12:35:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21253, '2017-02-24 18:41:43', NULL, NULL, 7159, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 18:41:43', 'admin-1487913138-14879329036666017', 1, 1, 'SR', NULL, NULL, NULL),
(21254, '2017-02-24 18:41:39', NULL, NULL, 7159, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1487938890', 'admin', '2017-02-24 18:41:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21255, '2017-02-24 00:00:00', NULL, NULL, 7157, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 16:56:37', 'admin-1487913138-14879265975802384', 1, 1, 'SR', NULL, NULL, NULL),
(21256, '2017-02-24 17:23:29', NULL, NULL, 7156, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1487938890', 'admin', '2017-02-24 17:23:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21257, '2017-02-24 00:00:00', NULL, NULL, 7156, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 16:56:37', 'admin-1487913138-14879265975802384', 1, 0, '', NULL, NULL, NULL),
(21258, '2017-02-24 17:23:51', NULL, NULL, 7157, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1487938890', 'admin', '2017-02-24 17:23:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21259, '2017-02-24 16:56:37', NULL, NULL, 7155, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 16:56:37', 'admin-1487913138-14879265975802384', 1, 0, '', NULL, NULL, NULL),
(21260, '2017-02-24 16:56:27', NULL, NULL, 7155, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1487938890', 'admin', '2017-02-24 16:56:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21261, '2017-02-24 16:08:51', NULL, NULL, 7154, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 16:08:51', 'admin-1487913138-14879237317711552', 1, 0, '', NULL, NULL, NULL),
(21262, '2017-02-24 16:08:47', NULL, NULL, 7154, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1487938890', 'admin', '2017-02-24 16:08:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21263, '2017-02-24 15:55:06', NULL, NULL, 7153, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 15:55:06', 'admin-1487913138-1487922906333722', 1, 1, 'SR', NULL, NULL, NULL),
(21264, '2017-02-24 15:52:58', NULL, NULL, 7152, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 15:52:58', 'admin-1487913138-14879227786954945', 1, 1, 'SR', NULL, NULL, NULL),
(21265, '2017-02-24 15:47:19', NULL, NULL, 7153, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 15:47:19', 'admin-1487913138-14879224395733815', 1, 0, '', NULL, NULL, NULL),
(21266, '2017-02-24 15:47:16', NULL, NULL, 7153, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1487938890', 'admin', '2017-02-24 15:47:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21267, '2017-02-24 14:47:48', NULL, NULL, 7152, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 14:47:48', 'admin-1487913138-14879188685141860', 1, 1, 'SR', NULL, NULL, NULL),
(21268, '2017-02-24 14:17:31', NULL, NULL, 7149, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 14:17:31', 'admin-1487913138-14879170509204972', 1, 1, 'SR', NULL, NULL, NULL),
(21269, '2017-02-24 14:17:31', NULL, NULL, 7149, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 14:17:31', 'admin-1487913138-14879170509204972', 1, 1, 'SR', NULL, NULL, NULL),
(21270, '2017-02-24 14:05:52', NULL, NULL, 7150, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 14:05:52', 'admin-1487913138-14879163523696685', 1, 1, 'SR', NULL, NULL, NULL),
(21271, '2017-02-24 14:17:31', NULL, NULL, 7149, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 14:17:31', 'admin-1487913138-14879170509204972', 1, 1, 'SR', NULL, NULL, NULL),
(21272, '2017-02-24 14:17:31', NULL, NULL, 7149, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 14:17:31', 'admin-1487913138-14879170509204972', 1, 1, 'SR', NULL, NULL, NULL),
(21273, '2017-02-24 14:16:06', NULL, NULL, 7151, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 14:16:06', 'admin-1487913138-1487916965842382', 1, 1, 'SR', 1, NULL, NULL),
(21274, '2017-02-24 14:05:46', NULL, NULL, 7150, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1487938890', 'admin', '2017-02-24 14:05:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21275, '2017-02-24 13:57:53', NULL, NULL, 7144, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:57:53', 'admin-1487913138-14879158733996217', 1, 0, '', NULL, NULL, NULL),
(21276, '2017-02-24 13:55:58', NULL, NULL, 7149, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:55:58', 'admin-1487913138-1487915758209636', 1, 1, 'SR', NULL, NULL, NULL),
(21277, '2017-02-24 13:55:49', NULL, NULL, 7149, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:55:49', 'admin-1487913138-1487915748972741', 1, 1, 'SR', NULL, NULL, NULL),
(21278, '2017-02-24 13:55:58', NULL, NULL, 7149, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:55:58', 'admin-1487913138-1487915758209636', 1, 1, 'SR', NULL, NULL, NULL),
(21279, '2017-02-24 13:55:49', NULL, NULL, 7149, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:55:49', 'admin-1487913138-1487915748972741', 1, 1, 'SR', NULL, NULL, NULL),
(21280, '2017-02-24 13:55:42', NULL, NULL, 7149, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:55:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21281, '2017-02-24 13:47:48', NULL, NULL, 7144, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:47:48', 'admin-1487913138-14879152684724096', 1, 1, 'SR', NULL, NULL, NULL),
(21282, '2017-02-24 13:33:18', NULL, NULL, 7148, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:33:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21283, '2017-02-24 13:33:25', NULL, NULL, 7148, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:33:25', 'admin-1487913138-14879144049508914', 1, 1, 'SR', NULL, NULL, NULL),
(21284, '2017-02-24 13:32:28', NULL, NULL, 7147, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:32:28', 'admin-1487913138-14879143478053165', 1, 1, 'SR', NULL, NULL, NULL),
(21285, '2017-02-24 13:32:08', NULL, NULL, 7147, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:32:08', 'admin-1487913138-14879143285471652', 1, 1, 'SR', NULL, NULL, NULL),
(21286, '2017-02-24 13:32:27', NULL, NULL, 7147, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:32:27', 'admin-1487913138-14879143478053165', 1, 1, 'SR', NULL, NULL, NULL),
(21287, '2017-02-24 13:32:08', NULL, NULL, 7147, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:32:08', 'admin-1487913138-14879143285471652', 1, 0, '', NULL, NULL, NULL),
(21288, '2017-02-24 13:02:27', NULL, NULL, 7143, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:02:27', 'admin-1487906895-14879125474916215', 1, 0, '', NULL, NULL, NULL),
(21289, '2017-02-24 18:59:06', NULL, NULL, 7160, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 18:59:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21290, '2017-02-24 14:47:48', NULL, NULL, 7152, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 14:47:48', 'admin-1487913138-14879188685141860', 1, 1, 'SR', NULL, NULL, NULL),
(21291, '2017-02-24 13:32:08', NULL, NULL, 7147, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:32:08', 'admin-1487913138-14879143285471652', 1, 0, '', NULL, NULL, NULL),
(21292, '2017-02-24 13:24:44', NULL, NULL, 7146, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:24:44', 'admin-1487913138-1487913884529513', 1, 1, 'SR', 1, NULL, '10.0'),
(21293, '2017-02-24 13:09:04', NULL, NULL, 7144, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:09:04', 'admin-1487906895-14879129440453920', 1, 1, 'SR', NULL, NULL, NULL),
(21294, '2017-02-24 13:09:04', NULL, NULL, 7144, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:09:04', 'admin-1487906895-14879129440453920', 1, 0, '', NULL, NULL, NULL),
(21295, '2017-02-24 13:31:30', NULL, NULL, 7147, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.60, 0.0000, 0.0000, 9.60, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:31:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21296, '2017-02-24 13:08:51', NULL, NULL, 7144, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:08:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21297, '2017-02-24 13:09:04', NULL, NULL, 7144, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:09:04', 'admin-1487906895-14879129440453920', 1, 1, 'SR', NULL, NULL, NULL),
(21298, '2017-02-24 12:05:26', NULL, NULL, 7139, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 12:05:26', 'admin-1487906895-14879091267461621', 1, 0, '', NULL, NULL, NULL),
(21299, '2017-02-24 12:11:06', NULL, NULL, 7140, 0, 265, '199', 'Old Penang PostCard', '', 'DISCOUNT ', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 12:11:06', 'admin-1487906895-14879094660089035', 1, 0, '', 1, NULL, NULL),
(21300, '2017-02-24 12:11:06', NULL, NULL, 7140, 0, 181, '116', 'Open Food ', 'stamp', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 12:11:06', 'admin-1487906895-14879094660089035', 1, 0, '', 1, NULL, NULL),
(21301, '2017-02-24 12:14:47', NULL, NULL, 7141, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1487938890', 'admin', '2017-02-24 12:14:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21302, '2017-02-24 12:15:04', NULL, NULL, 7141, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 12:15:04', 'admin-1487906895-14879097042789484', 1, 0, '', NULL, NULL, NULL),
(21303, '2017-02-24 12:15:04', NULL, NULL, 7141, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 12:15:04', 'admin-1487906895-14879097042789484', 1, 1, 'SR', NULL, NULL, NULL),
(21304, '2017-02-24 12:15:04', NULL, NULL, 7141, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 12:15:04', 'admin-1487906895-14879097042789484', 1, 1, 'SR', NULL, NULL, NULL),
(21305, '2017-02-24 13:02:39', NULL, NULL, 7142, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:02:39', 'admin-1487906895-14879125594434669', 1, 0, '', NULL, NULL, NULL),
(21306, '2017-02-24 13:02:27', NULL, NULL, 7143, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:02:27', 'admin-1487906895-14879125474916215', 1, 1, 'SR', NULL, NULL, NULL),
(21307, '2017-02-24 13:02:27', NULL, NULL, 7143, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 13:02:27', 'admin-1487906895-14879125474916215', 1, 1, 'SR', NULL, NULL, NULL),
(21308, '2017-02-24 12:36:04', NULL, NULL, 7142, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 12:36:04', 'admin-1487906895-14879109644377911', 1, 0, '', NULL, NULL, NULL),
(21309, '2017-02-24 12:36:04', NULL, NULL, 7142, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 12:36:04', 'admin-1487906895-14879109644377911', 1, 0, '', NULL, NULL, NULL),
(21310, '2017-02-24 12:36:04', NULL, NULL, 7142, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 12:36:04', 'admin-1487906895-14879109644377911', 1, 0, '', NULL, NULL, NULL),
(21311, '2017-02-24 12:36:04', NULL, NULL, 7142, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 12:36:04', 'admin-1487906895-14879109644377911', 1, 0, '', NULL, NULL, NULL),
(21312, '2017-02-24 12:36:04', NULL, NULL, 7142, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 12:36:04', 'admin-1487906895-14879109644377911', 1, 0, '', NULL, NULL, NULL),
(21313, '2017-02-24 12:36:04', NULL, NULL, 7142, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 12:36:04', 'admin-1487906895-14879109644377911', 1, 0, '', NULL, NULL, NULL),
(21314, '2017-02-24 14:47:42', NULL, NULL, 7152, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1487938890', 'admin', '2017-02-24 14:47:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21315, '2017-02-24 14:40:43', NULL, NULL, 7149, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 14:40:43', 'admin-1487913138-14879184436343322', 1, 0, '', NULL, NULL, NULL),
(21316, '2017-02-24 14:18:42', NULL, NULL, 7149, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 14:18:42', 'admin-1487913138-14879171221465487', 1, 1, 'SR', NULL, NULL, NULL),
(21317, '2017-02-24 14:40:32', NULL, NULL, 7147, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 14:40:32', 'admin-1487913138-1487918431977590', 1, 0, '', NULL, NULL, NULL),
(21318, '2017-02-24 11:45:35', NULL, NULL, 7137, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1487938890', 'admin', '2017-02-24 11:45:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21319, '2017-02-24 11:23:25', NULL, NULL, 7134, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 11:23:25', 'admin-1487896883-14879066053038910', 1, 0, '', NULL, NULL, NULL),
(21320, '2017-02-24 11:41:43', NULL, NULL, 7135, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1487938890', 'admin', '2017-02-24 11:41:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21321, '2017-02-24 11:41:53', NULL, NULL, 7135, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 11:41:53', 'admin-1487906895-14879077130999067', 1, 0, '', NULL, NULL, NULL),
(21322, '2017-02-24 11:41:53', NULL, NULL, 7135, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 11:41:53', 'admin-1487906895-14879077130999067', 1, 1, 'SR', NULL, NULL, NULL),
(21323, '2017-02-24 11:44:50', NULL, NULL, 7132, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 11:44:50', 'admin-1487906895-14879078905189182', 1, 1, 'SR', NULL, NULL, NULL),
(21324, '2017-02-24 14:40:43', NULL, NULL, 7149, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 14:40:43', 'admin-1487913138-14879184436343322', 1, 0, '', NULL, NULL, NULL),
(21325, '2017-02-24 09:28:49', NULL, NULL, 7130, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1487938890', 'admin', '2017-02-24 09:28:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21326, '2017-02-24 09:29:01', NULL, NULL, 7130, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 09:29:01', 'admin-1487896883-14878997410222947', 1, 1, 'SR', NULL, NULL, NULL),
(21327, '2017-02-24 09:29:01', NULL, NULL, 7130, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 09:29:01', 'admin-1487896883-14878997410222947', 1, 1, 'SR', NULL, NULL, NULL),
(21328, '2017-02-24 09:29:01', NULL, NULL, 7130, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 09:29:01', 'admin-1487896883-14878997410222947', 1, 0, '', NULL, NULL, NULL),
(21329, '2017-02-24 09:29:01', NULL, NULL, 7130, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 09:29:01', 'admin-1487896883-14878997410222947', 1, 0, '', NULL, NULL, NULL),
(21330, '2017-02-24 09:45:51', NULL, NULL, 7131, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1487938890', 'admin', '2017-02-24 09:45:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21331, '2017-02-24 09:45:58', NULL, NULL, 7131, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 09:45:58', 'admin-1487896883-14879007579287850', 1, 0, '', NULL, NULL, NULL),
(21332, '2017-02-24 09:45:58', NULL, NULL, 7131, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 09:45:58', 'admin-1487896883-14879007579287850', 1, 0, '', NULL, NULL, NULL),
(21333, '2017-02-24 09:46:07', NULL, NULL, 7131, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 09:46:07', 'admin-1487896883-14879007670371321', 1, 1, 'SR', NULL, NULL, NULL),
(21334, '2017-02-24 10:17:34', NULL, NULL, 7132, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1487938890', 'admin', '2017-02-24 10:17:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21335, '2017-02-24 10:17:46', NULL, NULL, 7132, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 10:17:46', 'admin-1487896883-14879026666314583', 1, 0, '', NULL, NULL, NULL),
(21336, '2017-02-24 10:17:46', NULL, NULL, 7132, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 10:17:46', 'admin-1487896883-14879026666314583', 1, 0, '', NULL, NULL, NULL),
(21337, '2017-02-24 10:17:46', NULL, NULL, 7132, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 10:17:46', 'admin-1487896883-14879026666314583', 1, 0, '', NULL, NULL, NULL),
(21338, '2017-02-24 10:17:58', NULL, NULL, 7132, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 10:17:58', 'admin-1487896883-14879026782696654', 1, 0, '', NULL, NULL, NULL),
(21339, '2017-02-24 10:17:58', NULL, NULL, 7132, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 10:17:58', 'admin-1487896883-14879026782696654', 1, 1, 'SR', NULL, NULL, NULL),
(21340, '2017-02-24 10:17:58', NULL, NULL, 7132, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 10:17:58', 'admin-1487896883-14879026782696654', 1, 1, 'SR', NULL, NULL, NULL),
(21341, '2017-02-24 10:38:26', NULL, NULL, 7133, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1487938890', 'admin', '2017-02-24 10:38:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21342, '2017-02-24 10:38:34', NULL, NULL, 7133, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 10:38:34', 'admin-1487896883-14879039138276811', 1, 0, '', NULL, NULL, NULL),
(21343, '2017-02-24 11:19:10', NULL, NULL, 7134, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1487938890', 'admin', '2017-02-24 11:19:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21344, '2017-02-24 11:19:18', NULL, NULL, 7134, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 11:19:18', 'admin-1487896883-14879063578916263', 1, 0, '', NULL, NULL, NULL),
(21345, '2017-02-24 11:19:18', NULL, NULL, 7134, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 11:19:18', 'admin-1487896883-14879063578916263', 1, 0, '', NULL, NULL, NULL),
(21346, '2017-02-24 11:20:02', NULL, NULL, 7134, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 11:20:02', 'admin-1487896883-14879064020279654', 1, 1, 'SR', NULL, NULL, NULL),
(21347, '2017-02-24 11:20:02', NULL, NULL, 7134, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 11:20:02', 'admin-1487896883-14879064020279654', 1, 0, '', NULL, NULL, NULL),
(21348, '2017-02-24 09:28:45', NULL, NULL, 7129, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 09:28:45', 'admin-1487896883-14878997249883194', 1, 0, '', NULL, NULL, NULL),
(21349, '2017-02-24 09:28:45', NULL, NULL, 7129, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 09:28:45', 'admin-1487896883-14878997249883194', 1, 1, 'SR', NULL, NULL, NULL),
(21350, '2017-02-24 09:28:45', NULL, NULL, 7129, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 09:28:45', 'admin-1487896883-14878997249883194', 1, 0, '', NULL, NULL, NULL),
(21351, '2017-02-24 09:28:45', NULL, NULL, 7129, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1487938890', 'admin', '2017-02-24 09:28:45', 'admin-1487896883-14878997249883194', 1, 0, '', NULL, NULL, NULL),
(21352, '2017-02-24 09:28:10', NULL, NULL, 7129, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1487938890', 'admin', '2017-02-24 09:28:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21353, '2017-02-25 18:25:10', NULL, NULL, 7224, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 18:25:10', 'admin-1488004602-14880183104948236', 1, 1, 'SR', NULL, NULL, NULL),
(21354, '2017-02-25 18:24:53', NULL, NULL, 7224, 0, 181, '116', 'Open Food ', 'cha siew rice', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 18:24:53', 'admin-1488004602-14880182930006184', 1, 0, '', NULL, NULL, NULL),
(21355, '2017-02-25 19:09:00', NULL, NULL, 7225, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 19:09:00', 'admin-1488004602-14880209402952337', 1, 1, 'SR', NULL, NULL, NULL),
(21356, '2017-02-25 18:30:07', NULL, NULL, 7225, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 18:30:07', 'admin-1488004602-14880186075582286', 1, 1, 'SR', NULL, NULL, NULL),
(21357, '2017-02-25 18:30:07', NULL, NULL, 7225, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 18:30:07', 'admin-1488004602-14880186075582286', 1, 1, 'SR', NULL, NULL, NULL),
(21358, '2017-02-25 18:30:07', NULL, NULL, 7225, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 18:30:07', 'admin-1488004602-14880186075582286', 1, 0, '', NULL, NULL, NULL),
(21359, '2017-02-25 18:30:07', NULL, NULL, 7225, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 18:30:07', 'admin-1488004602-14880186075582286', 1, 1, 'SR', NULL, NULL, NULL),
(21360, '2017-02-25 18:30:07', NULL, NULL, 7225, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 18:30:07', 'admin-1488004602-14880186075582286', 1, 1, 'SR', NULL, NULL, NULL),
(21361, '2017-02-25 18:30:07', NULL, NULL, 7225, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 18:30:07', 'admin-1488004602-14880186075582286', 1, 1, 'SR', NULL, NULL, NULL),
(21362, '2017-02-25 18:30:07', NULL, NULL, 7225, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 18:30:07', 'admin-1488004602-14880186075582286', 1, 0, '', NULL, NULL, NULL),
(21363, '2017-02-25 18:29:10', NULL, NULL, 7225, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.30, 0.0000, 0.0000, 12.30, 1, '27', 1, '1488021498', 'admin', '2017-02-25 18:29:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21364, '2017-02-25 18:28:32', NULL, NULL, 7224, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 18:28:32', 'admin-1488004602-14880185123813432', 1, 0, '', NULL, NULL, NULL),
(21365, '2017-02-25 18:24:53', NULL, NULL, 7224, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 18:24:53', 'admin-1488004602-14880182930006184', 1, 0, '', NULL, NULL, NULL),
(21366, '2017-02-25 18:24:33', NULL, NULL, 7224, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1488021498', 'admin', '2017-02-25 18:24:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21367, '2017-02-25 18:19:16', NULL, NULL, 7223, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 18:19:16', 'admin-1488004602-14880179560671764', 1, 1, 'SR', 1, NULL, NULL),
(21368, '2017-02-25 18:18:58', NULL, NULL, 7221, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 18:18:58', 'admin-1488004602-14880179385784234', 1, 1, 'SR', NULL, NULL, NULL),
(21369, '2017-02-25 18:18:58', NULL, NULL, 7221, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 18:18:58', 'admin-1488004602-14880179385784234', 1, 0, '', NULL, NULL, NULL),
(21370, '2017-02-25 18:16:00', NULL, NULL, 7221, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 18:16:00', 'admin-1488004602-1488017760242105', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(21371, '2017-02-25 18:16:00', NULL, NULL, 7221, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 18:16:00', 'admin-1488004602-1488017760242105', 1, 0, '', NULL, NULL, NULL),
(21372, '2017-02-25 18:15:49', NULL, NULL, 7221, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1488021498', 'admin', '2017-02-25 18:15:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21373, '2017-02-25 14:07:36', NULL, NULL, 7205, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 14:07:36', 'admin-1488002678-14880028567189593', 1, 0, '', NULL, NULL, NULL),
(21374, '2017-02-25 14:20:55', NULL, NULL, 7212, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1488021498', 'admin', '2017-02-25 14:20:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21375, '2017-02-25 13:45:37', NULL, NULL, 7209, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:45:37', 'admin-1488000130-14880015371517736', 1, 1, 'SR', NULL, NULL, NULL),
(21376, '2017-02-25 13:46:09', NULL, NULL, 7210, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:46:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21377, '2017-02-25 13:46:20', NULL, NULL, 7210, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:46:20', 'admin-1488000130-14880015806236924', 1, 1, 'SR', NULL, NULL, NULL),
(21378, '2017-02-25 13:18:01', NULL, NULL, 7205, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:18:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21379, '2017-02-25 13:18:27', NULL, NULL, 7205, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:18:27', 'admin-1487994990-14879999069603753', 1, 0, '', NULL, NULL, NULL),
(21380, '2017-02-25 13:18:27', NULL, NULL, 7205, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:18:27', 'admin-1487994990-14879999069603753', 1, 1, 'SR', NULL, NULL, NULL),
(21381, '2017-02-25 16:40:34', NULL, NULL, 7220, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 16:40:34', 'admin-1488004602-14880120348136151', 1, 1, 'SR', NULL, NULL, NULL),
(21382, '2017-02-25 16:40:27', NULL, NULL, 7220, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1488021498', 'admin', '2017-02-25 16:40:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21383, '2017-02-25 16:40:05', NULL, NULL, 7219, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 16:40:05', 'admin-1488004602-1488012005297685', 1, 1, 'SR', NULL, NULL, NULL),
(21384, '2017-02-25 16:39:08', NULL, NULL, 7219, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 16:39:08', 'admin-1488004602-14880119487601882', 1, 1, 'SR', NULL, NULL, NULL),
(21385, '2017-02-25 14:28:04', NULL, NULL, 7211, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 14:28:04', 'admin-1488002678-14880040839979661', 1, 0, '', NULL, NULL, NULL),
(21386, '2017-02-25 14:39:08', NULL, NULL, 7212, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 14:39:08', 'admin-1488004602-14880047480249794', 1, 0, '', NULL, NULL, NULL),
(21387, '2017-02-25 16:04:54', NULL, NULL, 7216, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 16:04:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21388, '2017-02-25 15:21:25', NULL, NULL, 7215, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 15:21:25', 'admin-1488004602-14880072853769746', 1, 1, 'SR', 1, NULL, NULL),
(21389, '2017-02-25 15:28:29', NULL, NULL, 7214, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 15:28:29', 'admin-1488004602-14880077092347889', 1, 0, '', NULL, NULL, NULL),
(21390, '2017-02-25 16:05:16', NULL, NULL, 7216, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 16:05:16', 'admin-1488004602-14880099165164491', 1, 1, 'SR', NULL, NULL, NULL),
(21391, '2017-02-25 16:05:16', NULL, NULL, 7216, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 16:05:16', 'admin-1488004602-14880099165164491', 1, 1, 'SR', NULL, NULL, NULL),
(21392, '2017-02-25 16:06:51', NULL, NULL, 7216, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 16:06:51', 'admin-1488004602-14880100117235822', 1, 0, '', NULL, NULL, NULL),
(21393, '2017-02-25 16:19:03', NULL, NULL, 7216, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 16:19:03', 'admin-1488004602-14880107429603942', 1, 0, '', NULL, NULL, NULL),
(21394, '2017-02-25 16:19:03', NULL, NULL, 7216, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 16:19:03', 'admin-1488004602-14880107429603942', 1, 0, '', NULL, NULL, NULL),
(21395, '2017-02-25 16:20:49', NULL, NULL, 7216, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 16:20:49', 'admin-1488004602-14880108490611619', 1, 0, '', NULL, NULL, NULL),
(21396, '2017-02-25 16:28:53', NULL, NULL, 7217, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 16:28:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21397, '2017-02-25 16:29:00', NULL, NULL, 7217, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 16:29:00', 'admin-1488004602-1488011340331823', 1, 1, 'SR', NULL, NULL, NULL),
(21398, '2017-02-25 16:35:50', NULL, NULL, 7218, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1488021498', 'admin', '2017-02-25 16:35:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21399, '2017-02-25 13:17:30', NULL, NULL, 7204, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:17:30', 'admin-1487994990-14879998501676574', 1, 0, '', NULL, NULL, NULL),
(21400, '2017-02-25 13:17:30', NULL, NULL, 7204, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:17:30', 'admin-1487994990-14879998501676574', 1, 0, '', NULL, NULL, NULL),
(21401, '2017-02-25 13:17:52', NULL, NULL, 7204, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:17:52', 'admin-1487994990-14879998724384380', 1, 1, 'SR', NULL, NULL, NULL),
(21402, '2017-02-25 13:17:52', NULL, NULL, 7204, 0, 268, '202', 'ICED COCOA CAPPUCINO', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:17:52', 'admin-1487994990-14879998724384380', 1, 0, '', NULL, NULL, NULL),
(21403, '2017-02-25 13:17:52', NULL, NULL, 7204, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:17:52', 'admin-1487994990-14879998724384380', 1, 1, 'SR', NULL, NULL, NULL),
(21404, '2017-02-25 13:17:52', NULL, NULL, 7204, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:17:52', 'admin-1487994990-14879998724384380', 1, 1, 'SR', NULL, NULL, NULL),
(21405, '2017-02-25 13:12:09', NULL, NULL, 7203, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:12:09', 'admin-1487994990-14879995288237436', 1, 1, 'SR', NULL, NULL, NULL),
(21406, '2017-02-25 10:52:27', NULL, NULL, 7174, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:52:27', 'admin-1487988459-14879911472661126', 1, 0, '', 1, NULL, NULL),
(21407, '2017-02-25 10:52:27', NULL, NULL, 7174, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:52:27', 'admin-1487988459-14879911472661126', 1, 0, '', 1, NULL, NULL),
(21408, '2017-02-25 10:52:27', NULL, NULL, 7174, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:52:27', 'admin-1487988459-14879911472661126', 1, 0, '', 1, NULL, NULL),
(21409, '2017-02-25 10:52:27', NULL, NULL, 7174, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:52:27', 'admin-1487988459-14879911472661126', 1, 0, '', 1, NULL, NULL),
(21410, '2017-02-25 10:52:27', NULL, NULL, 7174, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:52:27', 'admin-1487988459-14879911472661126', 1, 0, '', 1, NULL, NULL),
(21411, '2017-02-25 10:52:27', NULL, NULL, 7174, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:52:27', 'admin-1487988459-14879911472661126', 1, 0, '', 1, NULL, NULL),
(21412, '2017-02-25 10:52:27', NULL, NULL, 7174, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:52:27', 'admin-1487988459-14879911472661126', 1, 0, '', 1, NULL, NULL),
(21413, '2017-02-25 10:52:27', NULL, NULL, 7174, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:52:27', 'admin-1487988459-14879911472661126', 1, 0, '', 1, NULL, NULL),
(21414, '2017-02-25 10:52:27', NULL, NULL, 7174, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:52:27', 'admin-1487988459-14879911472661126', 1, 0, '', 1, NULL, NULL),
(21415, '2017-02-25 16:39:03', NULL, NULL, 7219, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1488021498', 'admin', '2017-02-25 16:39:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21416, '2017-02-25 16:36:14', NULL, NULL, 7218, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 16:36:14', 'admin-1488004602-14880117738701048', 1, 0, '', NULL, NULL, NULL),
(21417, '2017-02-25 16:36:14', NULL, NULL, 7218, 0, 181, '116', 'Open Food ', 'bff', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 16:36:14', 'admin-1488004602-14880117738701048', 1, 0, '', NULL, NULL, NULL),
(21418, '2017-02-25 13:45:21', NULL, NULL, 7209, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:45:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21419, '2017-02-25 13:12:01', NULL, NULL, 7203, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:12:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21420, '2017-02-25 13:10:00', NULL, NULL, 7202, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:10:00', 'admin-1487994990-1487999400499811', 1, 1, 'SR', 1, NULL, NULL),
(21421, '2017-02-25 00:00:00', NULL, NULL, 7198, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:56:01', 'admin-1487988459-14879949611952432', 1, 1, 'SR', NULL, NULL, NULL),
(21422, '2017-02-25 11:37:33', NULL, NULL, 7182, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:37:33', 'admin-1487988459-1487993853694342', 1, 0, '', NULL, NULL, NULL),
(21423, '2017-02-25 11:37:33', NULL, NULL, 7182, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:37:33', 'admin-1487988459-1487993853694342', 1, 0, '', NULL, NULL, NULL),
(21424, '2017-02-25 11:37:33', NULL, NULL, 7182, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:37:33', 'admin-1487988459-1487993853694342', 1, 1, 'SR', NULL, NULL, NULL),
(21425, '2017-02-25 11:38:14', NULL, NULL, 7183, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:38:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21426, '2017-02-25 11:38:31', NULL, NULL, 7183, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:38:31', 'admin-1487988459-14879939115019950', 1, 0, '', NULL, NULL, NULL),
(21427, '2017-02-25 11:38:31', NULL, NULL, 7183, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:38:31', 'admin-1487988459-14879939115019950', 1, 0, '', NULL, NULL, NULL),
(21428, '2017-02-25 16:42:28', NULL, NULL, 7220, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 16:42:28', 'admin-1488004602-14880121484006522', 1, 0, '', NULL, NULL, NULL),
(21429, '2017-02-25 16:36:14', NULL, NULL, 7218, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 16:36:14', 'admin-1488004602-14880117738701048', 1, 0, '', NULL, NULL, NULL),
(21430, '2017-02-25 14:28:04', NULL, NULL, 7211, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 14:28:04', 'admin-1488002678-14880040839979661', 1, 0, '', NULL, NULL, NULL),
(21431, '2017-02-25 14:21:32', NULL, NULL, 7213, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1488021498', 'admin', '2017-02-25 14:21:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21432, '2017-02-25 14:21:37', NULL, NULL, 7213, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 14:21:37', 'admin-1488002678-14880036968893412', 1, 1, 'SR', NULL, NULL, NULL),
(21433, '2017-02-25 13:18:27', NULL, NULL, 7205, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:18:27', 'admin-1487994990-14879999069603753', 1, 0, '', NULL, NULL, NULL),
(21434, '2017-02-25 13:22:15', NULL, NULL, 7206, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:22:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21435, '2017-02-25 13:22:24', NULL, NULL, 7206, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:22:24', 'admin-1488000130-14880001447236516', 1, 0, '', NULL, NULL, NULL),
(21436, '2017-02-25 11:38:31', NULL, NULL, 7183, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:38:31', 'admin-1487988459-14879939115019950', 1, 1, 'SR', NULL, NULL, NULL),
(21437, '2017-02-25 14:21:08', NULL, NULL, 7212, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 14:21:08', 'admin-1488002678-14880036686899685', 1, 1, 'SR', NULL, NULL, NULL),
(21438, '2017-02-25 13:22:24', NULL, NULL, 7206, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:22:24', 'admin-1488000130-14880001447236516', 1, 0, '', NULL, NULL, NULL),
(21439, '2017-02-25 13:22:24', NULL, NULL, 7206, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:22:24', 'admin-1488000130-14880001447236516', 1, 1, 'SR', NULL, NULL, NULL),
(21440, '2017-02-25 13:22:27', NULL, NULL, 7207, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:22:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21441, '2017-02-25 13:24:17', NULL, NULL, 7207, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:24:17', 'admin-1488000130-14880002569725565', 1, 1, 'SR', NULL, NULL, NULL),
(21442, '2017-02-25 14:04:30', NULL, NULL, 7211, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 14:04:30', 'admin-1488000130-14880026700316944', 1, 0, '', NULL, NULL, NULL),
(21443, '2017-02-25 14:04:19', NULL, NULL, 7211, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1488021498', 'admin', '2017-02-25 14:04:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21444, '2017-02-25 13:58:32', NULL, NULL, 7210, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:58:32', 'admin-1488000130-14880023121251139', 1, 0, '', NULL, NULL, NULL),
(21445, '2017-02-25 13:53:31', NULL, NULL, 7210, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:53:31', 'admin-1488000130-1488002010934396', 1, 1, 'SR', NULL, NULL, NULL),
(21446, '2017-02-25 13:46:20', NULL, NULL, 7210, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:46:20', 'admin-1488000130-14880015806236924', 1, 1, 'SR', NULL, NULL, NULL),
(21447, '2017-02-25 00:00:00', NULL, NULL, 7200, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:56:01', 'admin-1487988459-14879949611952432', 1, 1, 'SR', NULL, NULL, NULL),
(21448, '2017-02-25 11:38:31', NULL, NULL, 7183, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:38:31', 'admin-1487988459-14879939115019950', 1, 1, 'SR', NULL, NULL, NULL),
(21449, '2017-02-25 11:40:08', NULL, NULL, 7184, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:40:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21450, '2017-02-25 11:40:13', NULL, NULL, 7184, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:40:13', 'admin-1487988459-14879940135158691', 1, 0, '', NULL, NULL, NULL),
(21451, '2017-02-25 12:58:43', NULL, NULL, 7198, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:58:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21452, '2017-02-25 00:00:00', NULL, NULL, 7198, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:56:01', 'admin-1487988459-14879949611952432', 1, 0, '', NULL, NULL, NULL),
(21453, '2017-02-25 11:56:01', NULL, NULL, 7185, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:56:01', 'admin-1487988459-14879949611952432', 1, 1, 'SR', NULL, NULL, NULL),
(21454, '2017-02-25 13:00:03', NULL, NULL, 7200, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:00:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21455, '2017-02-25 11:56:01', NULL, NULL, 7185, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:56:01', 'admin-1487988459-14879949611952432', 1, 0, '', NULL, NULL, NULL),
(21456, '2017-02-25 12:15:53', NULL, NULL, 7193, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:15:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21457, '2017-02-25 13:04:04', NULL, NULL, 7201, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:04:04', 'admin-1487994990-14879990442713630', 1, 1, 'SR', 1, NULL, NULL),
(21458, '2017-02-25 00:00:00', NULL, NULL, 7200, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:57:17', 'admin-1487994990-14879950373347923', 1, 0, '', NULL, NULL, NULL),
(21459, '2017-02-25 00:00:00', NULL, NULL, 7199, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:56:01', 'admin-1487988459-14879949611952432', 1, 0, '', NULL, NULL, NULL),
(21460, '2017-02-25 13:45:37', NULL, NULL, 7209, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:45:37', 'admin-1488000130-14880015371517736', 1, 0, '', NULL, NULL, NULL),
(21461, '2017-02-25 13:24:17', NULL, NULL, 7207, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:24:17', 'admin-1488000130-14880002569725565', 1, 1, 'SR', NULL, NULL, NULL),
(21462, '2017-02-25 13:33:42', NULL, NULL, 7208, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:33:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21463, '2017-02-25 13:33:50', NULL, NULL, 7208, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:33:50', 'admin-1488000130-14880008305907622', 1, 1, 'SR', NULL, NULL, NULL),
(21464, '2017-02-25 13:33:50', NULL, NULL, 7208, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:33:50', 'admin-1488000130-14880008305907622', 1, 0, '', NULL, NULL, NULL),
(21465, '2017-02-25 13:34:13', NULL, NULL, 7208, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:34:13', 'admin-1488000130-14880008535014189', 1, 0, '', NULL, NULL, NULL),
(21466, '2017-02-25 13:34:13', NULL, NULL, 7208, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:34:13', 'admin-1488000130-14880008535014189', 1, 1, 'SR', NULL, NULL, NULL),
(21467, '2017-02-25 13:41:05', NULL, NULL, 7204, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:41:05', 'admin-1488000130-14880012654618477', 1, 1, 'SR', NULL, NULL, NULL),
(21468, '2017-02-25 14:04:30', NULL, NULL, 7211, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 14:04:30', 'admin-1488000130-14880026700316944', 1, 0, '', NULL, NULL, NULL),
(21469, '2017-02-25 13:24:17', NULL, NULL, 7207, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:24:17', 'admin-1488000130-14880002569725565', 1, 0, '', NULL, NULL, NULL),
(21470, '2017-02-25 13:24:17', NULL, NULL, 7207, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:24:17', 'admin-1488000130-14880002569725565', 1, 0, '', NULL, NULL, NULL),
(21471, '2017-02-25 13:15:30', NULL, NULL, 7197, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:15:30', 'admin-1487994990-1487999729972919', 1, 0, '', NULL, NULL, NULL),
(21472, '2017-02-25 13:17:08', NULL, NULL, 7204, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:17:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21473, '2017-02-25 13:17:30', NULL, NULL, 7204, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:17:30', 'admin-1487994990-14879998501676574', 1, 0, '', NULL, NULL, NULL),
(21474, '2017-02-25 00:00:00', NULL, NULL, 7199, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:28:23', 'admin-1487994990-14879969036598132', 1, 0, '', NULL, NULL, NULL),
(21475, '2017-02-25 11:29:25', NULL, NULL, 7179, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:29:25', 'admin-1487988459-1487993365449147', 1, 1, 'SR', NULL, NULL, NULL),
(21476, '2017-02-25 11:29:25', NULL, NULL, 7179, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:29:25', 'admin-1487988459-1487993365449147', 1, 1, 'SR', NULL, NULL, NULL),
(21477, '2017-02-25 11:29:25', NULL, NULL, 7179, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:29:25', 'admin-1487988459-1487993365449147', 1, 1, 'SR', NULL, NULL, NULL),
(21478, '2017-02-25 12:56:54', NULL, NULL, 7179, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:56:54', 'admin-1487994990-14879986145035673', 1, 0, '', NULL, NULL, NULL),
(21479, '2017-02-25 12:45:21', NULL, NULL, 7179, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:45:21', 'admin-1487994990-14879979218258370', 1, 0, '', NULL, NULL, NULL),
(21480, '2017-02-25 12:26:14', NULL, NULL, 7197, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:26:14', 'admin-1487994990-14879967743938945', 1, 0, '', NULL, NULL, NULL),
(21481, '2017-02-25 00:00:00', NULL, NULL, 7199, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:56:01', 'admin-1487988459-14879949611952432', 1, 1, 'SR', NULL, NULL, NULL),
(21482, '2017-02-25 12:33:08', NULL, NULL, 7187, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:33:08', 'admin-1487994990-14879971884434279', 1, 1, 'SR', NULL, NULL, NULL),
(21483, '2017-02-25 12:26:14', NULL, NULL, 7197, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:26:14', 'admin-1487994990-14879967743938945', 1, 1, 'SR', NULL, NULL, NULL),
(21484, '2017-02-25 12:17:13', NULL, NULL, 7195, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:17:13', 'admin-1487994990-14879962336502958', 1, 0, '', NULL, NULL, NULL),
(21485, '2017-02-25 12:26:14', NULL, NULL, 7197, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:26:14', 'admin-1487994990-14879967743938945', 1, 0, '', NULL, NULL, NULL),
(21486, '2017-02-25 12:26:14', NULL, NULL, 7197, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:26:14', 'admin-1487994990-14879967743938945', 1, 0, '', NULL, NULL, NULL),
(21487, '2017-02-25 12:26:01', NULL, NULL, 7197, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:26:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21488, '2017-02-25 00:00:00', NULL, NULL, 7196, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:56:22', 'admin-1487988459-14879949819181460', 1, 0, '', NULL, NULL, NULL),
(21489, '2017-02-25 00:00:00', NULL, NULL, 7192, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:36:57', 'admin-1487988459-14879938173004620', 1, 0, '', NULL, NULL, NULL),
(21490, '2017-02-25 00:00:00', NULL, NULL, 7193, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:58:36', 'admin-1487994990-14879951160488739', 1, 1, 'SR', NULL, NULL, NULL),
(21491, '2017-02-25 00:00:00', NULL, NULL, 7194, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:36:57', 'admin-1487988459-14879938173004620', 1, 1, 'SR', NULL, NULL, NULL),
(21492, '2017-02-25 12:17:07', NULL, NULL, 7195, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:17:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21493, '2017-02-25 12:17:13', NULL, NULL, 7195, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:17:13', 'admin-1487994990-14879962336502958', 1, 1, 'SR', NULL, NULL, NULL),
(21494, '2017-02-25 10:23:03', NULL, NULL, 7173, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:23:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21495, '2017-02-25 11:54:22', NULL, NULL, 7185, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:54:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21496, '2017-02-25 11:14:25', NULL, NULL, 7178, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:14:25', 'admin-1487988459-14879924651336267', 1, 1, 'SR', NULL, NULL, NULL),
(21497, '2017-02-25 11:14:25', NULL, NULL, 7178, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:14:25', 'admin-1487988459-14879924651336267', 1, 1, 'SR', NULL, NULL, NULL),
(21498, '2017-02-25 11:13:22', NULL, NULL, 7178, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:13:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21499, '2017-02-25 11:10:22', NULL, NULL, 7177, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:10:22', 'admin-1487988459-14879922219469075', 1, 1, 'SR', 1, NULL, NULL),
(21500, '2017-02-25 11:10:22', NULL, NULL, 7177, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:10:22', 'admin-1487988459-14879922219469075', 1, 1, 'SR', 1, NULL, NULL),
(21501, '2017-02-25 13:12:09', NULL, NULL, 7203, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 13:12:09', 'admin-1487994990-14879995288237436', 1, 1, 'SR', NULL, NULL, NULL),
(21502, '2017-02-25 00:00:00', NULL, NULL, 7191, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:36:57', 'admin-1487988459-14879938173004620', 1, 1, 'SR', NULL, NULL, NULL),
(21503, '2017-02-25 00:00:00', NULL, NULL, 7190, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:34:13', 'admin-1487988459-14879936529833971', 1, 1, 'SR', NULL, NULL, NULL),
(21504, '2017-02-25 00:00:00', NULL, NULL, 7189, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:36:57', 'admin-1487988459-14879938173004620', 1, 0, '', NULL, NULL, NULL),
(21505, '2017-02-25 00:00:00', NULL, NULL, 7191, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:36:57', 'admin-1487988459-14879938173004620', 1, 0, '', NULL, NULL, NULL),
(21506, '2017-02-25 12:08:53', NULL, NULL, 7188, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:08:53', 'admin-1487994990-14879957331313826', 1, 1, 'SR', NULL, NULL, NULL),
(21507, '2017-02-25 12:08:53', NULL, NULL, 7188, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:08:53', 'admin-1487994990-14879957331313826', 1, 1, 'SR', NULL, NULL, NULL),
(21508, '2017-02-25 12:08:53', NULL, NULL, 7188, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:08:53', 'admin-1487994990-14879957331313826', 1, 0, '', NULL, NULL, NULL),
(21509, '2017-02-25 12:08:32', NULL, NULL, 7188, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:08:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21510, '2017-02-25 12:08:53', NULL, NULL, 7188, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:08:53', 'admin-1487994990-14879957331313826', 1, 0, '', NULL, NULL, NULL),
(21511, '2017-02-25 12:08:22', NULL, NULL, 7187, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:08:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21512, '2017-02-25 12:08:27', NULL, NULL, 7187, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:08:27', 'admin-1487994990-148799570716213', 1, 1, 'SR', NULL, NULL, NULL),
(21513, '2017-02-25 12:01:04', NULL, NULL, 7186, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:01:04', 'admin-1487994990-14879952644097380', 1, 0, '', NULL, NULL, NULL),
(21514, '2017-02-25 12:01:04', NULL, NULL, 7186, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:01:04', 'admin-1487994990-14879952644097380', 1, 0, '', NULL, NULL, NULL),
(21515, '2017-02-25 12:01:04', NULL, NULL, 7186, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:01:04', 'admin-1487994990-14879952644097380', 1, 1, 'SR', NULL, NULL, NULL),
(21516, '2017-02-25 12:01:04', NULL, NULL, 7186, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:01:04', 'admin-1487994990-14879952644097380', 1, 0, '', NULL, NULL, NULL),
(21517, '2017-02-25 00:00:00', NULL, NULL, 7200, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:56:01', 'admin-1487988459-14879949611952432', 1, 0, '', NULL, NULL, NULL),
(21518, '2017-02-25 12:00:46', NULL, NULL, 7186, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:00:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21519, '2017-02-25 12:01:04', NULL, NULL, 7186, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:01:04', 'admin-1487994990-14879952644097380', 1, 1, 'SR', NULL, NULL, NULL),
(21520, '2017-02-25 12:01:04', NULL, NULL, 7186, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:01:04', 'admin-1487994990-14879952644097380', 1, 1, 'SR', NULL, NULL, NULL),
(21521, '2017-02-25 12:19:32', NULL, NULL, 7196, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:19:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21522, '2017-02-25 11:56:22', NULL, NULL, 7184, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:56:22', 'admin-1487988459-14879949819181460', 1, 0, '', NULL, NULL, NULL),
(21523, '2017-02-25 12:59:24', NULL, NULL, 7199, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:59:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21524, '2017-02-25 11:38:31', NULL, NULL, 7183, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:38:31', 'admin-1487988459-14879939115019950', 1, 1, 'SR', NULL, NULL, NULL),
(21525, '2017-02-25 11:37:04', NULL, NULL, 7182, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:37:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21526, '2017-02-25 11:37:33', NULL, NULL, 7182, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:37:33', 'admin-1487988459-1487993853694342', 1, 0, '', NULL, NULL, NULL),
(21527, '2017-02-25 00:00:00', NULL, NULL, 7192, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:36:57', 'admin-1487988459-14879938173004620', 1, 1, 'SR', NULL, NULL, NULL),
(21528, '2017-02-25 00:00:00', NULL, NULL, 7189, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:36:57', 'admin-1487988459-14879938173004620', 1, 1, 'SR', NULL, NULL, NULL),
(21529, '2017-02-25 11:31:03', NULL, NULL, 7180, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:31:03', 'admin-1487988459-14879934627694111', 1, 1, 'SR', NULL, NULL, NULL),
(21530, '2017-02-25 12:14:54', NULL, NULL, 7191, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:14:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21531, '2017-02-25 00:00:00', NULL, NULL, 7190, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:34:13', 'admin-1487988459-14879936529833971', 1, 1, 'SR', NULL, NULL, NULL),
(21532, '2017-02-25 12:14:27', NULL, NULL, 7190, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:14:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21533, '2017-02-25 00:00:00', NULL, NULL, 7194, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, NULL, NULL, 1.40, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:32:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21534, '2017-02-25 10:23:07', NULL, NULL, 7173, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:23:07', 'admin-1487988459-14879893868388266', 1, 1, 'SR', NULL, NULL, NULL),
(21535, '2017-02-25 12:15:21', NULL, NULL, 7192, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:15:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21536, '2017-02-25 12:14:07', NULL, NULL, 7189, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:14:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21537, '2017-02-25 12:17:04', NULL, NULL, 7183, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 12:17:04', 'admin-1487994990-14879962240594619', 1, 0, '', NULL, NULL, NULL),
(21538, '2017-02-25 11:31:03', NULL, NULL, 7180, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:31:03', 'admin-1487988459-14879934627694111', 1, 0, '', NULL, NULL, NULL),
(21539, '2017-02-25 11:30:48', NULL, NULL, 7180, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:30:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21540, '2017-02-25 11:31:02', NULL, NULL, 7180, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:31:03', 'admin-1487988459-14879934627694111', 1, 1, 'SR', NULL, NULL, NULL),
(21541, '2017-02-25 11:29:25', NULL, NULL, 7179, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:29:25', 'admin-1487988459-1487993365449147', 1, 1, 'SR', NULL, NULL, NULL),
(21542, '2017-02-25 11:29:25', NULL, NULL, 7179, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:29:25', 'admin-1487988459-1487993365449147', 1, 0, '', NULL, NULL, NULL),
(21543, '2017-02-25 11:29:25', NULL, NULL, 7179, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:29:25', 'admin-1487988459-1487993365449147', 1, 1, 'SR', NULL, NULL, NULL),
(21544, '2017-02-25 11:14:25', NULL, NULL, 7178, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:14:25', 'admin-1487988459-14879924651336267', 1, 0, '', NULL, NULL, NULL),
(21545, '2017-02-25 11:28:59', NULL, NULL, 7177, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:28:59', 'admin-1487988459-14879933391098213', 1, 1, 'SR', 1, NULL, NULL),
(21546, '2017-02-25 11:29:03', NULL, NULL, 7179, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:29:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21547, '2017-02-25 11:01:38', NULL, NULL, 7175, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:01:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21548, '2017-02-25 11:01:42', NULL, NULL, 7175, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 11:01:42', 'admin-1487988459-14879917022882281', 1, 1, 'SR', NULL, NULL, NULL),
(21549, '2017-02-25 10:18:07', NULL, NULL, 7172, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:18:07', 'admin-1487988459-14879890874973728', 1, 0, '', NULL, NULL, NULL),
(21550, '2017-02-25 10:18:07', NULL, NULL, 7172, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:18:07', 'admin-1487988459-14879890874973728', 1, 0, '', NULL, NULL, NULL),
(21551, '2017-02-25 10:18:07', NULL, NULL, 7172, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:18:07', 'admin-1487988459-14879890874973728', 1, 1, 'SR', NULL, NULL, NULL),
(21552, '2017-02-25 10:18:07', NULL, NULL, 7172, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:18:07', 'admin-1487988459-14879890874973728', 1, 0, '', NULL, NULL, NULL),
(21553, '2017-02-25 09:45:05', NULL, NULL, 7167, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:45:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21554, '2017-02-25 09:45:15', NULL, NULL, 7167, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:45:15', 'admin-1487984790-14879871156982892', 1, 0, '', NULL, NULL, NULL),
(21555, '2017-02-25 09:45:15', NULL, NULL, 7167, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:45:15', 'admin-1487984790-14879871156982892', 1, 0, '', NULL, NULL, NULL),
(21556, '2017-02-25 09:45:31', NULL, NULL, 7167, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:45:31', 'admin-1487984790-14879871316882517', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(21557, '2017-02-25 09:45:31', NULL, NULL, 7167, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:45:31', 'admin-1487984790-14879871316882517', 1, 1, 'SR', NULL, NULL, NULL),
(21558, '2017-02-25 09:46:25', NULL, NULL, 7168, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:46:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21559, '2017-02-25 09:46:52', NULL, NULL, 7168, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:46:52', 'admin-1487984790-1487987212142339', 1, 0, '', NULL, NULL, NULL),
(21560, '2017-02-25 09:46:52', NULL, NULL, 7168, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:46:52', 'admin-1487984790-1487987212142339', 1, 0, '', NULL, NULL, NULL),
(21561, '2017-02-25 09:46:52', NULL, NULL, 7168, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:46:52', 'admin-1487984790-1487987212142339', 1, 1, 'SR', NULL, NULL, NULL),
(21562, '2017-02-25 09:46:52', NULL, NULL, 7168, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:46:52', 'admin-1487984790-1487987212142339', 1, 1, 'SR', NULL, NULL, NULL),
(21563, '2017-02-25 09:46:52', NULL, NULL, 7168, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:46:52', 'admin-1487984790-1487987212142339', 1, 1, 'SR', NULL, NULL, NULL),
(21564, '2017-02-25 09:50:42', NULL, NULL, 7169, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:50:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21565, '2017-02-25 09:50:53', NULL, NULL, 7169, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:50:53', 'admin-1487984790-14879874537543146', 1, 0, '', NULL, NULL, NULL),
(21566, '2017-02-25 09:50:53', NULL, NULL, 7169, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:50:53', 'admin-1487984790-14879874537543146', 1, 0, '', NULL, NULL, NULL),
(21567, '2017-02-25 09:50:53', NULL, NULL, 7169, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:50:53', 'admin-1487984790-14879874537543146', 1, 1, 'SR', NULL, NULL, NULL),
(21568, '2017-02-25 09:50:53', NULL, NULL, 7169, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:50:53', 'admin-1487984790-14879874537543146', 1, 1, 'SR', NULL, NULL, NULL),
(21569, '2017-02-25 09:55:06', NULL, NULL, 7166, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:55:06', 'admin-1487984790-14879877060964167', 1, 1, 'SR', NULL, NULL, NULL),
(21570, '2017-02-25 09:55:06', NULL, NULL, 7166, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:55:06', 'admin-1487984790-14879877060964167', 1, 0, '', NULL, NULL, NULL),
(21571, '2017-02-25 10:07:23', NULL, NULL, 7170, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:07:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21572, '2017-02-25 10:07:33', NULL, NULL, 7170, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:07:33', 'admin-1487984790-14879884537142864', 1, 0, '', NULL, NULL, NULL),
(21573, '2017-02-25 10:07:33', NULL, NULL, 7170, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:07:33', 'admin-1487984790-14879884537142864', 1, 0, '', NULL, NULL, NULL),
(21574, '2017-02-25 10:07:34', NULL, NULL, 7170, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:07:34', 'admin-1487984790-14879884537142864', 1, 0, '', NULL, NULL, NULL),
(21575, '2017-02-25 10:08:02', NULL, NULL, 7170, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:08:02', 'admin-1487988459-14879884827439041', 1, 1, 'SR', NULL, NULL, NULL),
(21576, '2017-02-25 10:08:02', NULL, NULL, 7170, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:08:02', 'admin-1487988459-14879884827439041', 1, 1, 'SR', NULL, NULL, NULL),
(21577, '2017-02-25 10:08:02', NULL, NULL, 7170, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:08:02', 'admin-1487988459-14879884827439041', 1, 1, 'SR', NULL, NULL, NULL),
(21578, '2017-02-25 10:12:51', NULL, NULL, 7171, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:12:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21579, '2017-02-25 10:12:59', NULL, NULL, 7171, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:12:59', 'admin-1487988459-1487988779457296', 1, 0, '', NULL, NULL, NULL),
(21580, '2017-02-25 10:12:59', NULL, NULL, 7171, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:12:59', 'admin-1487988459-1487988779457296', 1, 1, 'SR', NULL, NULL, NULL),
(21581, '2017-02-25 10:17:51', NULL, NULL, 7172, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1488021498', 'admin', '2017-02-25 10:17:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21582, '2017-02-25 09:40:57', NULL, NULL, 7166, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:40:57', 'admin-1487984790-14879868574564769', 1, 1, 'SR', NULL, NULL, NULL),
(21583, '2017-02-25 09:40:47', NULL, NULL, 7166, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:40:47', 'admin-1487984790-14879868468927237', 1, 0, '', NULL, NULL, NULL),
(21584, '2017-02-25 09:40:47', NULL, NULL, 7166, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:40:47', 'admin-1487984790-14879868468927237', 1, 0, '', NULL, NULL, NULL),
(21585, '2017-02-25 09:40:47', NULL, NULL, 7166, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:40:47', 'admin-1487984790-14879868468927237', 1, 0, '', NULL, NULL, NULL),
(21586, '2017-02-25 09:40:47', NULL, NULL, 7166, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:40:47', 'admin-1487984790-14879868468927237', 1, 0, '', NULL, NULL, NULL),
(21587, '2017-02-25 09:39:57', NULL, NULL, 7166, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.90, 0.0000, 0.0000, 9.90, 1, '27', 1, '1488021498', 'admin', '2017-02-25 09:39:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21588, '2017-02-25 19:09:05', NULL, NULL, 7226, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1488021498', 'admin', '2017-02-25 19:09:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21589, '2017-02-25 19:09:13', NULL, NULL, 7226, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 19:09:13', 'admin-1488004602-14880209531114547', 1, 1, 'SR', NULL, NULL, NULL),
(21590, '2017-02-25 19:09:13', NULL, NULL, 7226, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 19:09:13', 'admin-1488004602-14880209531114547', 1, 1, 'SR', NULL, NULL, NULL),
(21591, '2017-02-25 19:09:13', NULL, NULL, 7226, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 19:09:13', 'admin-1488004602-14880209531114547', 1, 0, '', NULL, NULL, NULL),
(21592, '2017-02-25 19:12:43', NULL, NULL, 7225, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 19:12:43', 'admin-1488004602-1488021163523249', 1, 0, '', NULL, NULL, NULL),
(21593, '2017-02-25 19:18:27', NULL, NULL, 7226, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 19:18:27', 'admin-1488021498-14880215072213492', 1, 1, 'SR', NULL, NULL, NULL),
(21594, '2017-02-25 19:19:23', NULL, NULL, 7224, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 19:19:23', 'admin-1488021498-14880215631889336', 1, 0, '', NULL, NULL, NULL),
(21595, '2017-02-25 19:20:48', NULL, NULL, 7224, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 19:20:48', 'admin-1488021498-1488021648405154', 1, 0, '', NULL, NULL, NULL),
(21596, '2017-02-25 19:58:38', NULL, NULL, 7227, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1488021498', 'admin', '2017-02-25 19:58:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21597, '2017-02-25 19:58:40', NULL, NULL, 7227, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488021498', 'admin', '2017-02-25 19:58:40', 'admin-1488021498-14880239203087884', 1, 1, 'SR', NULL, NULL, NULL),
(21598, '2017-02-26 17:42:35', NULL, NULL, 7261, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 17:42:35', 'admin-1488093351-14881021556076082', 1, 0, '', NULL, NULL, NULL),
(21599, '2017-02-26 19:05:53', NULL, NULL, 7265, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 19:05:53', 'admin-1488093351-14881071535421491', 1, 1, 'SR', NULL, NULL, NULL),
(21600, '2017-02-26 17:20:32', NULL, NULL, 7259, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1488093351', 'admin', '2017-02-26 17:20:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21601, '2017-02-26 17:20:40', NULL, NULL, 7259, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 17:20:40', 'admin-1488093351-14881008401766977', 1, 1, 'SR', NULL, NULL, NULL),
(21602, '2017-02-26 17:20:40', NULL, NULL, 7259, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 17:20:40', 'admin-1488093351-14881008401766977', 1, 1, 'SR', NULL, NULL, NULL),
(21603, '2017-02-26 17:20:40', NULL, NULL, 7259, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 17:20:40', 'admin-1488093351-14881008401766977', 1, 0, '', NULL, NULL, NULL),
(21604, '2017-02-26 17:22:10', NULL, NULL, 7259, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 17:22:10', 'admin-1488093351-1488100930470137', 1, 1, 'SR', NULL, NULL, NULL),
(21605, '2017-02-26 17:23:13', NULL, NULL, 7260, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 17:23:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21606, '2017-02-26 17:24:05', NULL, NULL, 7260, 0, 275, '209', 'Carlsberg', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 17:24:05', 'admin-1488093351-14881010449369624', 1, 0, '', NULL, NULL, NULL),
(21607, '2017-02-26 17:42:32', NULL, NULL, 7261, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1488093351', 'admin', '2017-02-26 17:42:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21608, '2017-02-26 11:49:42', NULL, NULL, 7237, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 11:49:42', 'admin-1488074363-14880809818718217', 1, 1, 'SR', NULL, NULL, NULL),
(21609, '2017-02-26 09:29:47', NULL, NULL, 7230, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:29:47', 'admin-1488070900-14880725872836690', 1, 1, 'SR', NULL, NULL, NULL),
(21610, '2017-02-26 09:29:52', NULL, NULL, 7230, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:29:52', 'admin-1488070900-14880725924685390', 1, 1, 'SR', NULL, NULL, NULL),
(21611, '2017-02-26 09:58:41', NULL, NULL, 7231, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.00, 0.0000, 0.0000, 15.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:58:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21612, '2017-02-26 09:59:10', NULL, NULL, 7231, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:59:10', 'admin-1488070900-14880743507204557', 1, 0, '', NULL, NULL, NULL),
(21613, '2017-02-26 09:59:10', NULL, NULL, 7231, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:59:10', 'admin-1488070900-14880743507204557', 1, 0, '', NULL, NULL, NULL),
(21614, '2017-02-26 09:59:10', NULL, NULL, 7231, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:59:10', 'admin-1488070900-14880743507204557', 1, 0, '', NULL, NULL, NULL),
(21615, '2017-02-26 09:59:10', NULL, NULL, 7231, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:59:10', 'admin-1488070900-14880743507204557', 1, 0, '', NULL, NULL, NULL),
(21616, '2017-02-26 09:59:10', NULL, NULL, 7231, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:59:10', 'admin-1488070900-14880743507204557', 1, 0, '', NULL, NULL, NULL),
(21617, '2017-02-26 10:01:44', NULL, NULL, 7232, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:01:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21618, '2017-02-26 10:01:58', NULL, NULL, 7232, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:01:58', 'admin-1488074363-14880745182928653', 1, 1, 'SR', NULL, NULL, NULL),
(21619, '2017-02-26 15:40:49', NULL, NULL, 7252, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 15:40:49', 'admin-1488093351-14880948492232411', 1, 1, 'SR', NULL, NULL, NULL),
(21620, '2017-02-26 15:41:15', NULL, NULL, 7250, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 15:41:15', 'admin-1488093351-14880948751035042', 1, 0, '', NULL, NULL, NULL),
(21621, '2017-02-26 14:25:42', NULL, NULL, 7245, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:25:42', 'admin-1488074363-14880903426304261', 1, 1, 'SR', NULL, NULL, NULL),
(21622, '2017-02-26 14:25:42', NULL, NULL, 7245, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:25:42', 'admin-1488074363-14880903426304261', 1, 1, 'SR', NULL, NULL, NULL),
(21623, '2017-02-26 14:27:44', NULL, NULL, 7245, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:27:44', 'admin-1488074363-14880904638441790', 1, 0, '', NULL, NULL, NULL),
(21624, '2017-02-26 14:27:44', NULL, NULL, 7245, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:27:44', 'admin-1488074363-14880904638441790', 1, 1, 'SR', NULL, NULL, NULL),
(21625, '2017-02-26 14:36:32', NULL, NULL, 7246, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:36:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21626, '2017-02-26 14:36:39', NULL, NULL, 7246, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:36:39', 'admin-1488074363-14880909991871240', 1, 0, '', NULL, NULL, NULL),
(21627, '2017-02-26 15:16:13', NULL, NULL, 7250, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 15:16:13', 'admin-1488093351-14880933728436871', 1, 1, 'SR', NULL, NULL, NULL),
(21628, '2017-02-26 14:48:02', NULL, NULL, 7247, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:48:02', 'admin-1488074363-14880916818709127', 1, 1, 'SR', NULL, NULL, NULL),
(21629, '2017-02-26 14:48:02', NULL, NULL, 7247, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:48:02', 'admin-1488074363-14880916818709127', 1, 0, '', NULL, NULL, NULL),
(21630, '2017-02-26 14:48:02', NULL, NULL, 7247, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:48:02', 'admin-1488074363-14880916818709127', 1, 1, 'SR', NULL, NULL, NULL),
(21631, '2017-02-26 14:48:02', NULL, NULL, 7247, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:48:02', 'admin-1488074363-14880916818709127', 1, 1, 'SR', NULL, NULL, NULL),
(21632, '2017-02-26 14:53:10', NULL, NULL, 7248, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:53:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21633, '2017-02-26 14:53:13', NULL, NULL, 7248, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:53:13', 'admin-1488074363-14880919935033880', 1, 1, 'SR', NULL, NULL, NULL),
(21634, '2017-02-26 14:57:58', NULL, NULL, 7249, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:57:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21635, '2017-02-26 14:58:06', NULL, NULL, 7249, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:58:06', 'admin-1488074363-1488092286357215', 1, 0, '', NULL, NULL, NULL),
(21636, '2017-02-26 14:58:06', NULL, NULL, 7249, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:58:06', 'admin-1488074363-1488092286357215', 1, 0, '', NULL, NULL, NULL),
(21637, '2017-02-26 15:05:11', NULL, NULL, 7249, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 15:05:11', 'admin-1488074363-14880927113386864', 1, 1, 'SR', NULL, NULL, NULL),
(21638, '2017-02-26 15:05:11', NULL, NULL, 7249, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 15:05:11', 'admin-1488074363-14880927113386864', 1, 0, '', NULL, NULL, NULL),
(21639, '2017-02-26 15:05:11', NULL, NULL, 7249, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 15:05:11', 'admin-1488074363-14880927113386864', 1, 1, 'SR', NULL, NULL, NULL),
(21640, '2017-02-26 15:15:03', NULL, NULL, 7250, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.00, 0.0000, 0.0000, 10.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 15:15:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21641, '2017-02-26 15:15:29', NULL, NULL, 7250, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 15:15:29', 'admin-1488074363-14880933293816443', 1, 0, '', NULL, NULL, NULL),
(21642, '2017-02-26 17:49:47', NULL, NULL, 7263, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1488093351', 'admin', '2017-02-26 17:49:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21643, '2017-02-26 17:49:56', NULL, NULL, 7263, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 17:49:56', 'admin-1488093351-14881025961923647', 1, 1, 'SR', NULL, NULL, NULL),
(21644, '2017-02-26 18:04:25', NULL, NULL, 7264, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1488093351', 'admin', '2017-02-26 18:04:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21645, '2017-02-26 18:04:32', NULL, NULL, 7264, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 18:04:32', 'admin-1488093351-14881034726024092', 1, 1, 'SR', NULL, NULL, NULL),
(21646, '2017-02-26 18:19:07', NULL, NULL, 7256, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 18:19:07', 'admin-1488093351-14881043472074687', 1, 0, '', NULL, NULL, NULL),
(21647, '2017-02-26 18:19:31', NULL, NULL, 7258, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 18:19:31', 'admin-1488093351-14881043708785094', 1, 1, 'SR', NULL, NULL, NULL),
(21648, '2017-02-26 18:19:31', NULL, NULL, 7258, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 18:19:31', 'admin-1488093351-14881043708785094', 1, 1, 'SR', NULL, NULL, NULL),
(21649, '2017-02-26 19:05:53', NULL, NULL, 7265, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 19:05:53', 'admin-1488093351-14881071535421491', 1, 0, '', NULL, NULL, NULL),
(21650, '2017-02-26 17:48:26', NULL, NULL, 7262, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1488093351', 'admin', '2017-02-26 17:48:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21651, '2017-02-26 17:48:34', NULL, NULL, 7262, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 17:48:34', 'admin-1488093351-14881025140696413', 1, 1, 'SR', NULL, NULL, NULL),
(21652, '2017-02-26 16:03:34', NULL, NULL, 7254, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 16:03:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21653, '2017-02-26 16:17:32', NULL, NULL, 7252, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 16:17:32', 'admin-1488093351-14880970527052177', 1, 0, '', NULL, NULL, NULL),
(21654, '2017-02-26 16:42:34', NULL, NULL, 7255, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 16:42:34', 'admin-1488093351-14880985544782166', 1, 0, '', 1, NULL, NULL),
(21655, '2017-02-26 16:45:19', NULL, NULL, 7256, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1488093351', 'admin', '2017-02-26 16:45:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21656, '2017-02-26 13:29:10', NULL, NULL, 7236, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 13:29:10', 'admin-1488074363-14880869501776312', 1, 0, '', NULL, NULL, NULL),
(21657, '2017-02-26 13:36:39', NULL, NULL, 7242, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1488093351', 'admin', '2017-02-26 13:36:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21658, '2017-02-26 12:12:45', NULL, NULL, 7238, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:12:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21659, '2017-02-26 12:16:03', NULL, NULL, 7238, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:16:03', 'admin-1488074363-1488082563574795', 1, 0, '', NULL, NULL, NULL),
(21660, '2017-02-26 12:16:03', NULL, NULL, 7238, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:16:03', 'admin-1488074363-1488082563574795', 1, 0, '', NULL, NULL, NULL),
(21661, '2017-02-26 12:16:13', NULL, NULL, 7238, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:16:13', 'admin-1488074363-14880825735825359', 1, 1, 'SR', NULL, NULL, NULL),
(21662, '2017-02-26 12:17:03', NULL, NULL, 7239, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:17:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21663, '2017-02-26 12:17:31', NULL, NULL, 7239, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:17:31', 'admin-1488074363-14880826511679686', 1, 1, 'SR', NULL, NULL, NULL),
(21664, '2017-02-26 12:17:31', NULL, NULL, 7239, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:17:31', 'admin-1488074363-14880826511679686', 1, 0, '', NULL, NULL, NULL),
(21665, '2017-02-26 12:19:02', NULL, NULL, 7240, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:19:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21666, '2017-02-26 12:19:19', NULL, NULL, 7240, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:19:19', 'admin-1488074363-14880827589768565', 1, 0, '', NULL, NULL, NULL),
(21667, '2017-02-26 12:19:19', NULL, NULL, 7240, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:19:19', 'admin-1488074363-14880827589768565', 1, 1, 'SR', NULL, NULL, NULL),
(21668, '2017-02-26 12:19:29', NULL, NULL, 7240, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:19:30', 'admin-1488074363-14880827698099366', 1, 1, 'SR', NULL, NULL, NULL),
(21669, '2017-02-26 12:23:57', NULL, NULL, 7241, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 22.30, 0.0000, 0.0000, 22.30, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:23:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21670, '2017-02-26 12:24:20', NULL, NULL, 7241, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:24:20', 'admin-1488074363-14880830605466442', 1, 0, '', NULL, NULL, NULL),
(21671, '2017-02-26 12:24:20', NULL, NULL, 7241, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:24:20', 'admin-1488074363-14880830605466442', 1, 0, '', NULL, NULL, NULL),
(21672, '2017-02-26 12:24:20', NULL, NULL, 7241, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:24:20', 'admin-1488074363-14880830605466442', 1, 0, '', NULL, NULL, NULL),
(21673, '2017-02-26 12:24:20', NULL, NULL, 7241, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:24:20', 'admin-1488074363-14880830605466442', 1, 0, '', NULL, NULL, NULL),
(21674, '2017-02-26 12:26:57', NULL, NULL, 7236, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:26:57', 'admin-1488074363-14880832169572337', 1, 1, 'SR', NULL, NULL, NULL),
(21675, '2017-02-26 12:26:57', NULL, NULL, 7236, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:26:57', 'admin-1488074363-14880832169572337', 1, 0, '', NULL, NULL, NULL),
(21676, '2017-02-26 12:26:57', NULL, NULL, 7236, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:26:57', 'admin-1488074363-14880832169572337', 1, 0, '', NULL, NULL, NULL),
(21677, '2017-02-26 12:36:44', NULL, NULL, 7241, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:36:44', 'admin-1488074363-14880838041146580', 1, 1, 'SR', NULL, NULL, NULL),
(21678, '2017-02-26 12:36:44', NULL, NULL, 7241, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:36:44', 'admin-1488074363-14880838041146580', 1, 0, '', NULL, NULL, NULL),
(21679, '2017-02-26 12:36:44', NULL, NULL, 7241, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:36:44', 'admin-1488074363-14880838041146580', 1, 1, 'SR', NULL, NULL, NULL),
(21680, '2017-02-26 11:13:44', NULL, NULL, 7236, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1488093351', 'admin', '2017-02-26 11:13:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21681, '2017-02-26 11:13:51', NULL, NULL, 7236, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 11:13:51', 'admin-1488074363-14880788316795724', 1, 0, '', NULL, NULL, NULL),
(21682, '2017-02-26 17:07:59', NULL, NULL, 7258, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 17:07:59', 'admin-1488093351-14881000793216894', 1, 1, 'SR', NULL, NULL, NULL),
(21683, '2017-02-26 17:07:55', NULL, NULL, 7258, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1488093351', 'admin', '2017-02-26 17:07:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21684, '2017-02-26 17:07:59', NULL, NULL, 7258, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 17:07:59', 'admin-1488093351-14881000793216894', 1, 1, 'SR', NULL, NULL, NULL),
(21685, '2017-02-26 16:53:05', NULL, NULL, 7257, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 16:53:05', 'admin-1488093351-14880991855255442', 1, 1, 'SR', 1, NULL, NULL),
(21686, '2017-02-26 16:45:27', NULL, NULL, 7256, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 16:45:27', 'admin-1488093351-14880987277054672', 1, 1, 'SR', NULL, NULL, NULL),
(21687, '2017-02-26 16:45:27', NULL, NULL, 7256, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 16:45:27', 'admin-1488093351-14880987277054672', 1, 1, 'SR', NULL, NULL, NULL),
(21688, '2017-02-26 16:03:40', NULL, NULL, 7254, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 16:03:40', 'admin-1488093351-14880962205392870', 1, 1, 'SR', NULL, NULL, NULL),
(21689, '2017-02-26 15:42:00', NULL, NULL, 7250, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 15:42:00', 'admin-1488093351-14880949199597596', 1, 0, '', NULL, NULL, NULL),
(21690, '2017-02-26 15:42:00', NULL, NULL, 7250, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 15:42:00', 'admin-1488093351-14880949199597596', 1, 0, '', NULL, NULL, NULL),
(21691, '2017-02-26 15:41:44', NULL, NULL, 7253, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 15:41:44', 'admin-1488093351-14880949047766656', 1, 0, '', NULL, NULL, NULL),
(21692, '2017-02-26 15:41:44', NULL, NULL, 7253, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 15:41:44', 'admin-1488093351-14880949047766656', 1, 0, '', NULL, NULL, NULL),
(21693, '2017-02-26 15:39:16', NULL, NULL, 7252, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1488093351', 'admin', '2017-02-26 15:39:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21694, '2017-02-26 15:40:30', NULL, NULL, 7252, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 15:40:30', 'admin-1488093351-14880948299342369', 1, 0, '', NULL, NULL, NULL),
(21695, '2017-02-26 15:40:30', NULL, NULL, 7252, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 15:40:30', 'admin-1488093351-14880948299342369', 1, 1, 'SR', NULL, NULL, NULL),
(21696, '2017-02-26 15:40:30', NULL, NULL, 7252, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 15:40:30', 'admin-1488093351-14880948299342369', 1, 0, '', NULL, NULL, NULL),
(21697, '2017-02-26 15:40:49', NULL, NULL, 7252, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 15:40:49', 'admin-1488093351-14880948492232411', 1, 1, 'SR', NULL, NULL, NULL),
(21698, '2017-02-26 15:16:13', NULL, NULL, 7250, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 15:16:13', 'admin-1488093351-14880933728436871', 1, 1, 'SR', NULL, NULL, NULL),
(21699, '2017-02-26 15:21:41', NULL, NULL, 7251, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 15:21:41', 'admin-1488093351-14880937010356659', 1, 1, 'SR', 1, NULL, NULL),
(21700, '2017-02-26 19:05:43', NULL, NULL, 7265, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1488093351', 'admin', '2017-02-26 19:05:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21701, '2017-02-26 15:15:29', NULL, NULL, 7250, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 15:15:29', 'admin-1488074363-14880933293816443', 1, 0, '', NULL, NULL, NULL),
(21702, '2017-02-26 14:48:02', NULL, NULL, 7247, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:48:02', 'admin-1488074363-14880916818709127', 1, 0, '', NULL, NULL, NULL),
(21703, '2017-02-26 14:48:02', NULL, NULL, 7247, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:48:02', 'admin-1488074363-14880916818709127', 1, 0, '', NULL, NULL, NULL),
(21704, '2017-02-26 15:41:19', NULL, NULL, 7253, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1488093351', 'admin', '2017-02-26 15:41:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21705, '2017-02-26 14:46:54', NULL, NULL, 7245, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:46:54', 'admin-1488074363-14880916142229775', 1, 1, 'SR', NULL, NULL, NULL),
(21706, '2017-02-26 14:47:39', NULL, NULL, 7247, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:47:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21707, '2017-02-26 14:36:52', NULL, NULL, 7246, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:36:52', 'admin-1488074363-14880910127448067', 1, 0, '', NULL, NULL, NULL),
(21708, '2017-02-26 14:46:01', NULL, NULL, 7246, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:46:01', 'admin-1488074363-14880915615656297', 1, 0, '', NULL, NULL, NULL),
(21709, '2017-02-26 14:36:39', NULL, NULL, 7246, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:36:39', 'admin-1488074363-14880909991871240', 1, 1, 'SR', NULL, NULL, NULL),
(21710, '2017-02-26 14:07:32', NULL, NULL, 7244, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:07:32', 'admin-1488074363-1488089251966835', 1, 0, '', 1, NULL, NULL),
(21711, '2017-02-26 13:53:28', NULL, NULL, 7243, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 13:53:28', 'admin-1488074363-14880884084297259', 1, 0, '', NULL, NULL, NULL),
(21712, '2017-02-26 13:53:28', NULL, NULL, 7243, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 13:53:28', 'admin-1488074363-14880884084297259', 1, 1, 'SR', NULL, NULL, NULL),
(21713, '2017-02-26 13:53:15', NULL, NULL, 7243, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1488093351', 'admin', '2017-02-26 13:53:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21714, '2017-02-26 13:36:59', NULL, NULL, 7242, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 13:36:59', 'admin-1488074363-14880874188056293', 1, 0, '', NULL, NULL, NULL),
(21715, '2017-02-26 13:36:59', NULL, NULL, 7242, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 13:36:59', 'admin-1488074363-14880874188056293', 1, 0, '', NULL, NULL, NULL),
(21716, '2017-02-26 13:36:59', NULL, NULL, 7242, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 13:36:59', 'admin-1488074363-14880874188056293', 1, 1, 'SR', NULL, NULL, NULL),
(21717, '2017-02-26 13:36:59', NULL, NULL, 7242, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 13:36:59', 'admin-1488074363-14880874188056293', 1, 1, 'SR', NULL, NULL, NULL),
(21718, '2017-02-26 13:06:01', NULL, NULL, 7241, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 13:06:01', 'admin-1488074363-14880855610847242', 1, 1, 'SR', NULL, NULL, NULL),
(21719, '2017-02-26 13:19:14', NULL, NULL, 7241, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 13:19:14', 'admin-1488074363-1488086353808604', 1, 0, '', NULL, NULL, NULL),
(21720, '2017-02-26 14:25:33', NULL, NULL, 7245, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1488093351', 'admin', '2017-02-26 14:25:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21721, '2017-02-26 12:50:29', NULL, NULL, 7241, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:50:29', 'admin-1488074363-14880846289301527', 1, 0, '', NULL, NULL, NULL),
(21722, '2017-02-26 12:59:15', NULL, NULL, 7241, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:59:15', 'admin-1488074363-14880851547936187', 1, 0, '', NULL, NULL, NULL),
(21723, '2017-02-26 13:03:09', NULL, NULL, 7241, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 13:03:09', 'admin-1488074363-14880853889237845', 1, 0, '', NULL, NULL, NULL),
(21724, '2017-02-26 12:46:33', NULL, NULL, 7241, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:46:33', 'admin-1488074363-14880843935926956', 1, 0, '', NULL, NULL, NULL),
(21725, '2017-02-26 12:46:58', NULL, NULL, 7241, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:46:58', 'admin-1488074363-14880844177685364', 1, 1, 'SR', NULL, NULL, NULL),
(21726, '2017-02-26 12:48:04', NULL, NULL, 7241, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 12:48:04', 'admin-1488074363-14880844839958477', 1, 1, 'SR', NULL, NULL, NULL),
(21727, '2017-02-26 11:13:51', NULL, NULL, 7236, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 11:13:51', 'admin-1488074363-14880788316795724', 1, 0, '', NULL, NULL, NULL),
(21728, '2017-02-26 11:22:21', NULL, NULL, 7237, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1488093351', 'admin', '2017-02-26 11:22:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21729, '2017-02-26 11:22:35', NULL, NULL, 7237, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 11:22:35', 'admin-1488074363-14880793557355168', 1, 0, '', NULL, NULL, NULL),
(21730, '2017-02-26 11:22:35', NULL, NULL, 7237, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 11:22:35', 'admin-1488074363-14880793557355168', 1, 0, '', NULL, NULL, NULL),
(21731, '2017-02-26 10:01:58', NULL, NULL, 7232, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:01:58', 'admin-1488074363-14880745182928653', 1, 1, 'SR', NULL, NULL, NULL),
(21732, '2017-02-26 10:01:58', NULL, NULL, 7232, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:01:58', 'admin-1488074363-14880745182928653', 1, 0, '', NULL, NULL, NULL),
(21733, '2017-02-26 10:01:58', NULL, NULL, 7232, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:01:58', 'admin-1488074363-14880745182928653', 1, 0, '', NULL, NULL, NULL),
(21734, '2017-02-26 10:07:03', NULL, NULL, 7233, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:07:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21735, '2017-02-26 10:07:22', NULL, NULL, 7233, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:07:22', 'admin-1488074363-14880748418599745', 1, 0, '', NULL, NULL, NULL),
(21736, '2017-02-26 10:07:22', NULL, NULL, 7233, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:07:22', 'admin-1488074363-14880748418599745', 1, 0, '', NULL, NULL, NULL),
(21737, '2017-02-26 10:07:22', NULL, NULL, 7233, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:07:22', 'admin-1488074363-14880748418599745', 1, 1, 'SR', NULL, NULL, NULL),
(21738, '2017-02-26 10:07:22', NULL, NULL, 7233, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:07:22', 'admin-1488074363-14880748418599745', 1, 1, 'SR', NULL, NULL, NULL),
(21739, '2017-02-26 10:12:57', NULL, NULL, 7229, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:12:57', 'admin-1488074363-14880751773128462', 1, 0, '', NULL, NULL, NULL),
(21740, '2017-02-26 10:15:41', NULL, NULL, 7234, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:15:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21741, '2017-02-26 10:16:14', NULL, NULL, 7234, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:16:14', 'admin-1488074363-14880753744979115', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(21742, '2017-02-26 10:16:14', NULL, NULL, 7234, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:16:14', 'admin-1488074363-14880753744979115', 1, 0, '', NULL, NULL, NULL),
(21743, '2017-02-26 10:16:14', NULL, NULL, 7234, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:16:14', 'admin-1488074363-14880753744979115', 1, 0, '', NULL, NULL, NULL),
(21744, '2017-02-26 10:16:14', NULL, NULL, 7234, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:16:14', 'admin-1488074363-14880753744979115', 1, 1, 'SR', NULL, NULL, NULL),
(21745, '2017-02-26 10:16:14', NULL, NULL, 7234, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:16:14', 'admin-1488074363-14880753744979115', 1, 1, 'SR', NULL, NULL, NULL),
(21746, '2017-02-26 10:18:19', NULL, NULL, 7229, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:18:19', 'admin-1488074363-14880754995795396', 1, 0, '', NULL, NULL, NULL),
(21747, '2017-02-26 10:18:19', NULL, NULL, 7229, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:18:19', 'admin-1488074363-14880754995795396', 1, 1, 'SR', NULL, NULL, NULL),
(21748, '2017-02-26 10:30:05', NULL, NULL, 7234, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:30:05', 'admin-1488074363-14880762052363441', 1, 0, '', NULL, NULL, NULL),
(21749, '2017-02-26 10:47:27', NULL, NULL, 7235, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:47:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21750, '2017-02-26 10:47:33', NULL, NULL, 7235, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:47:33', 'admin-1488074363-14880772535747116', 1, 1, 'SR', NULL, NULL, NULL),
(21751, '2017-02-26 10:49:10', NULL, NULL, 7235, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:49:10', 'admin-1488074363-14880773499558855', 1, 0, '', NULL, NULL, NULL),
(21752, '2017-02-26 10:49:16', NULL, NULL, 7235, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:49:16', 'admin-1488074363-14880773563634388', 1, 0, '', NULL, NULL, NULL),
(21753, '2017-02-26 10:51:27', NULL, NULL, 7231, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:51:27', 'admin-1488074363-14880774873377993', 1, 1, 'SR', NULL, NULL, NULL),
(21754, '2017-02-26 10:51:27', NULL, NULL, 7231, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:51:27', 'admin-1488074363-14880774873377993', 1, 1, 'SR', NULL, NULL, NULL),
(21755, '2017-02-26 10:51:27', NULL, NULL, 7231, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:51:27', 'admin-1488074363-14880774873377993', 1, 1, 'SR', NULL, NULL, NULL),
(21756, '2017-02-26 10:52:41', NULL, NULL, 7231, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:52:41', 'admin-1488074363-14880775616496445', 1, 1, 'SR', NULL, NULL, NULL),
(21757, '2017-02-26 10:52:41', NULL, NULL, 7231, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:52:41', 'admin-1488074363-14880775616496445', 1, 1, 'SR', NULL, NULL, NULL),
(21758, '2017-02-26 10:58:33', NULL, NULL, 7235, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 10:58:33', 'admin-1488074363-14880779133539425', 1, 0, '', NULL, NULL, NULL),
(21759, '2017-02-26 09:20:25', NULL, NULL, 7228, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:20:25', 'admin-1488070900-1488072024932422', 1, 0, '', NULL, NULL, NULL),
(21760, '2017-02-26 09:29:26', NULL, NULL, 7230, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:29:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21761, '2017-02-26 09:29:47', NULL, NULL, 7230, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:29:47', 'admin-1488070900-14880725872836690', 1, 0, '', NULL, NULL, NULL),
(21762, '2017-02-26 09:29:47', NULL, NULL, 7230, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:29:47', 'admin-1488070900-14880725872836690', 1, 0, '', NULL, NULL, NULL),
(21763, '2017-02-26 09:18:27', NULL, NULL, 7229, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:18:27', 'admin-1488070900-1488071907419755', 1, 1, 'SR', NULL, NULL, NULL),
(21764, '2017-02-26 09:18:27', NULL, NULL, 7229, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:18:27', 'admin-1488070900-1488071907419755', 1, 1, 'SR', NULL, NULL, NULL),
(21765, '2017-02-26 09:18:27', NULL, NULL, 7229, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:18:27', 'admin-1488070900-1488071907419755', 1, 1, 'SR', NULL, NULL, NULL),
(21766, '2017-02-26 09:18:27', NULL, NULL, 7229, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:18:27', 'admin-1488070900-1488071907419755', 1, 0, '', NULL, NULL, NULL),
(21767, '2017-02-26 09:18:27', NULL, NULL, 7229, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:18:27', 'admin-1488070900-1488071907419755', 1, 0, '', NULL, NULL, NULL),
(21768, '2017-02-26 09:18:27', NULL, NULL, 7229, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:18:27', 'admin-1488070900-1488071907419755', 1, 0, '', NULL, NULL, NULL),
(21769, '2017-02-26 09:17:52', NULL, NULL, 7229, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.90, 0.0000, 0.0000, 16.90, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:17:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21770, '2017-02-26 09:18:27', NULL, NULL, 7229, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:18:27', 'admin-1488070900-1488071907419755', 1, 0, '', NULL, NULL, NULL),
(21771, '2017-02-26 09:14:57', NULL, NULL, 7228, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:14:57', 'admin-1488070900-14880716972843123', 1, 0, '', NULL, NULL, NULL),
(21772, '2017-02-26 09:14:41', NULL, NULL, 7228, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:14:41', 'admin-1488070900-1488071680991836', 1, 1, 'SR', NULL, NULL, NULL),
(21773, '2017-02-26 09:15:45', NULL, NULL, 7228, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:15:45', 'admin-1488070900-14880717452949991', 1, 1, 'SR', NULL, NULL, NULL),
(21774, '2017-02-26 09:14:57', NULL, NULL, 7228, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:14:57', 'admin-1488070900-14880716972843123', 1, 0, '', NULL, NULL, NULL),
(21775, '2017-02-26 09:14:41', NULL, NULL, 7228, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:14:41', 'admin-1488070900-1488071680991836', 1, 1, 'SR', NULL, NULL, NULL),
(21776, '2017-02-26 09:14:33', NULL, NULL, 7228, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1488093351', 'admin', '2017-02-26 09:14:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21777, '2017-02-27 13:01:21', NULL, NULL, 7276, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.90, 0.0000, 0.0000, 14.90, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:01:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21778, '2017-02-27 12:35:19', NULL, NULL, 7272, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 12:35:19', 'admin-1488156993-14881701193044174', 1, 0, '', NULL, NULL, NULL),
(21779, '2017-02-27 12:35:19', NULL, NULL, 7272, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1488192900', 'admin', '2017-02-27 12:35:19', 'admin-1488156993-14881701193044174', 1, 0, '', NULL, NULL, NULL),
(21780, '2017-02-27 12:38:29', NULL, NULL, 7273, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1488192900', 'admin', '2017-02-27 12:38:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21781, '2017-02-27 12:38:57', NULL, NULL, 7273, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 12:38:57', 'admin-1488156993-1488170336907180', 1, 1, 'SR', NULL, NULL, NULL),
(21782, '2017-02-27 12:38:57', NULL, NULL, 7273, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 12:38:57', 'admin-1488156993-1488170336907180', 1, 1, 'SR', NULL, NULL, NULL),
(21783, '2017-02-27 12:38:57', NULL, NULL, 7273, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 12:38:57', 'admin-1488156993-1488170336907180', 1, 1, 'SR', NULL, NULL, NULL),
(21784, '2017-02-27 12:38:57', NULL, NULL, 7273, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 12:38:57', 'admin-1488156993-1488170336907180', 1, 0, '', NULL, NULL, NULL),
(21785, '2017-02-27 12:42:58', NULL, NULL, 7274, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 12:42:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21786, '2017-02-27 12:43:05', NULL, NULL, 7274, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 12:43:05', 'admin-1488156993-148817058553293', 1, 1, 'SR', NULL, NULL, NULL),
(21787, '2017-02-27 12:43:05', NULL, NULL, 7274, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 12:43:05', 'admin-1488156993-148817058553293', 1, 1, 'SR', NULL, NULL, NULL),
(21788, '2017-02-27 13:38:32', NULL, NULL, 7280, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:38:32', 'admin-1488171734-14881739128207684', 1, 0, '', NULL, NULL, NULL),
(21789, '2017-02-27 13:38:33', NULL, NULL, 7280, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:38:33', 'admin-1488171734-14881739128207684', 1, 0, '', NULL, NULL, NULL),
(21790, '2017-02-27 13:47:25', NULL, NULL, 7275, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:47:25', 'admin-1488171734-14881744455528926', 1, 0, '', NULL, NULL, NULL),
(21791, '2017-02-27 13:47:25', NULL, NULL, 7275, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:47:25', 'admin-1488171734-14881744455528926', 1, 0, '', NULL, NULL, NULL),
(21792, '2017-02-27 13:49:59', NULL, NULL, 7276, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:49:59', 'admin-1488171734-14881745991298110', 1, 0, '', NULL, NULL, NULL),
(21793, '2017-02-27 13:49:59', NULL, NULL, 7276, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:49:59', 'admin-1488171734-14881745991298110', 1, 1, 'SR', NULL, NULL, NULL),
(21794, '2017-02-27 13:58:33', NULL, NULL, 7281, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:58:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21795, '2017-02-27 19:46:33', NULL, NULL, 7294, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1488192900', 'admin', '2017-02-27 19:46:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21796, '2017-02-27 19:04:52', NULL, NULL, 7292, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 19:04:52', 'admin-1488192900-14881934919694776', 1, 0, '', NULL, NULL, NULL),
(21797, '2017-02-27 19:04:52', NULL, NULL, 7292, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 19:04:52', 'admin-1488192900-14881934919694776', 1, 1, 'SR', NULL, NULL, NULL),
(21798, '2017-02-27 19:04:52', NULL, NULL, 7292, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 19:04:52', 'admin-1488192900-14881934919694776', 1, 1, 'SR', NULL, NULL, NULL),
(21799, '2017-02-27 19:04:52', NULL, NULL, 7292, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 19:04:52', 'admin-1488192900-14881934919694776', 1, 0, '', NULL, NULL, NULL),
(21800, '2017-02-27 19:42:42', NULL, NULL, 7293, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 19:42:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21801, '2017-02-27 19:43:17', NULL, NULL, 7293, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 19:43:17', 'admin-1488192900-14881957972164577', 1, 0, '', NULL, NULL, NULL),
(21802, '2017-02-27 19:43:17', NULL, NULL, 7293, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 19:43:17', 'admin-1488192900-14881957972164577', 1, 0, '', NULL, NULL, NULL),
(21803, '2017-02-27 19:43:17', NULL, NULL, 7293, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 19:43:17', 'admin-1488192900-14881957972164577', 1, 0, '', NULL, NULL, NULL),
(21804, '2017-02-27 19:43:31', NULL, NULL, 7293, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 19:43:31', 'admin-1488192900-1488195811759584', 1, 0, '', NULL, NULL, NULL),
(21805, '2017-02-27 14:19:31', NULL, NULL, 7279, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 14:19:31', 'admin-1488171734-14881763714649764', 1, 0, '', NULL, NULL, NULL),
(21806, '2017-02-27 14:33:34', NULL, NULL, 7281, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 14:33:34', 'admin-1488171734-1488177214199831', 1, 0, '', NULL, NULL, NULL),
(21807, '2017-02-27 14:40:32', NULL, NULL, 7282, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 14:40:32', 'admin-1488171734-14881776322225082', 1, 0, '', NULL, NULL, NULL),
(21808, '2017-02-27 15:12:56', NULL, NULL, 7283, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1488192900', 'admin', '2017-02-27 15:12:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21809, '2017-02-27 13:23:46', NULL, NULL, 7279, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:23:46', 'admin-1488171734-14881730258897437', 1, 0, '', NULL, NULL, NULL),
(21810, '2017-02-27 13:23:46', NULL, NULL, 7279, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:23:46', 'admin-1488171734-14881730258897437', 1, 0, '', NULL, NULL, NULL),
(21811, '2017-02-27 13:24:57', NULL, NULL, 7279, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:24:57', 'admin-1488171734-14881730972348040', 1, 0, '', NULL, NULL, NULL),
(21812, '2017-02-27 13:02:08', NULL, NULL, 7276, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:02:08', 'admin-1488156993-14881717280529956', 1, 1, 'SR', NULL, NULL, NULL),
(21813, '2017-02-27 12:56:32', NULL, NULL, 7275, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 12:56:32', 'admin-1488156993-14881713923127698', 1, 1, 'SR', NULL, NULL, NULL),
(21814, '2017-02-27 12:56:32', NULL, NULL, 7275, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 12:56:32', 'admin-1488156993-14881713923127698', 1, 1, 'SR', NULL, NULL, NULL),
(21815, '2017-02-27 19:00:49', NULL, NULL, 7291, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1488192900', 'admin', '2017-02-27 19:00:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21816, '2017-02-27 19:00:55', NULL, NULL, 7291, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 19:00:55', 'admin-1488192900-1488193255193259', 1, 0, '', NULL, NULL, NULL),
(21817, '2017-02-27 19:01:02', NULL, NULL, 7291, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 19:01:02', 'admin-1488192900-14881932624156118', 1, 1, 'SR', NULL, NULL, NULL),
(21818, '2017-02-27 19:02:29', NULL, NULL, 7291, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 19:02:29', 'admin-1488192900-14881933489648813', 1, 0, '', NULL, NULL, NULL),
(21819, '2017-02-27 19:02:29', NULL, NULL, 7291, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 19:02:29', 'admin-1488192900-14881933489648813', 1, 1, 'SR', NULL, NULL, NULL),
(21820, '2017-02-27 19:04:28', NULL, NULL, 7292, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1488192900', 'admin', '2017-02-27 19:04:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21821, '2017-02-27 15:13:01', NULL, NULL, 7283, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 15:13:01', 'admin-1488171734-1488179581323364', 1, 1, 'SR', NULL, NULL, NULL),
(21822, '2017-02-27 15:20:59', NULL, NULL, 7282, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 15:20:59', 'admin-1488171734-14881800589127873', 1, 1, 'SR', NULL, NULL, NULL),
(21823, '2017-02-27 15:50:06', NULL, NULL, 7284, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1488192900', 'admin', '2017-02-27 15:50:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21824, '2017-02-27 15:50:13', NULL, NULL, 7284, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 15:50:13', 'admin-1488171734-14881818130601750', 1, 0, '', NULL, NULL, NULL),
(21825, '2017-02-27 15:50:13', NULL, NULL, 7284, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 15:50:13', 'admin-1488171734-14881818130601750', 1, 1, 'SR', NULL, NULL, NULL),
(21826, '2017-02-27 16:13:45', NULL, NULL, 7285, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1488192900', 'admin', '2017-02-27 16:13:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21827, '2017-02-27 16:13:57', NULL, NULL, 7285, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 16:13:57', 'admin-1488171734-14881832368206810', 1, 1, 'SR', NULL, NULL, NULL),
(21828, '2017-02-27 16:13:57', NULL, NULL, 7285, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 16:13:57', 'admin-1488171734-14881832368206810', 1, 1, 'SR', NULL, NULL, NULL),
(21829, '2017-02-27 16:13:57', NULL, NULL, 7285, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 16:13:57', 'admin-1488171734-14881832368206810', 1, 1, 'SR', NULL, NULL, NULL),
(21830, '2017-02-27 16:13:57', NULL, NULL, 7285, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 16:13:57', 'admin-1488171734-14881832368206810', 1, 1, 'SR', NULL, NULL, NULL),
(21831, '2017-02-27 19:46:37', NULL, NULL, 7294, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 19:46:37', 'admin-1488192900-14881959969153827', 1, 1, 'SR', NULL, NULL, NULL),
(21832, '2017-02-27 18:54:48', NULL, NULL, 7290, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 18:54:48', 'admin-1488171734-1488192888527808', 1, 0, '', 1, NULL, NULL),
(21833, '2017-02-27 18:32:12', NULL, NULL, 7288, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 18:32:12', 'admin-1488171734-1488191531896239', 1, 1, 'SR', NULL, NULL, NULL),
(21834, '2017-02-27 18:50:45', NULL, NULL, 7289, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 18:50:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21835, '2017-02-27 18:50:51', NULL, NULL, 7289, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 18:50:51', 'admin-1488171734-14881926517181833', 1, 1, 'SR', NULL, NULL, NULL),
(21836, '2017-02-27 18:50:51', NULL, NULL, 7289, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 18:50:51', 'admin-1488171734-14881926517181833', 1, 1, 'SR', NULL, NULL, NULL),
(21837, '2017-02-27 18:32:06', NULL, NULL, 7288, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 18:32:06', 'admin-1488171734-14881915267129668', 1, 0, '', NULL, NULL, NULL),
(21838, '2017-02-27 18:32:06', NULL, NULL, 7288, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 18:32:06', 'admin-1488171734-14881915267129668', 1, 0, '', NULL, NULL, NULL),
(21839, '2017-02-27 18:30:54', NULL, NULL, 7288, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 18:30:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21840, '2017-02-27 17:52:56', NULL, NULL, 7287, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 17:52:56', 'admin-1488171734-1488189176551349', 1, 0, '', 1, NULL, '10.0'),
(21841, '2017-02-27 17:52:56', NULL, NULL, 7287, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 17:52:56', 'admin-1488171734-1488189176551349', 1, 0, '', 1, NULL, '10.0'),
(21842, '2017-02-27 16:24:08', NULL, NULL, 7286, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 16:24:08', 'admin-1488171734-14881838486404498', 1, 1, 'SR', 1, NULL, NULL),
(21843, '2017-02-27 16:15:59', NULL, NULL, 7285, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 16:15:59', 'admin-1488171734-14881833591847030', 1, 1, 'SR', NULL, NULL, NULL),
(21844, '2017-02-27 16:14:42', NULL, NULL, 7285, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 16:14:42', 'admin-1488171734-14881832827421534', 1, 0, '', NULL, NULL, NULL),
(21845, '2017-02-27 13:58:53', NULL, NULL, 7281, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:58:53', 'admin-1488171734-14881751333782556', 1, 1, 'SR', NULL, NULL, NULL),
(21846, '2017-02-27 14:17:32', NULL, NULL, 7280, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 14:17:32', 'admin-1488171734-14881762525227333', 1, 1, 'SR', NULL, NULL, NULL),
(21847, '2017-02-27 14:19:14', NULL, NULL, 7279, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 14:19:14', 'admin-1488171734-14881763547926355', 1, 1, 'SR', NULL, NULL, NULL),
(21848, '2017-02-27 14:19:22', NULL, NULL, 7279, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 14:19:22', 'admin-1488171734-14881763623993737', 1, 0, '', NULL, NULL, NULL),
(21849, '2017-02-27 14:39:42', NULL, NULL, 7282, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 14:39:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21850, '2017-02-27 13:58:53', NULL, NULL, 7281, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:58:53', 'admin-1488171734-14881751333782556', 1, 1, 'SR', NULL, NULL, NULL),
(21851, '2017-02-27 13:58:53', NULL, NULL, 7281, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:58:53', 'admin-1488171734-14881751333782556', 1, 1, 'SR', NULL, NULL, NULL),
(21852, '2017-02-27 13:58:53', NULL, NULL, 7281, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:58:53', 'admin-1488171734-14881751333782556', 1, 1, 'SR', NULL, NULL, NULL),
(21853, '2017-02-27 13:38:23', NULL, NULL, 7280, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:38:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21854, '2017-02-27 13:23:46', NULL, NULL, 7279, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:23:46', 'admin-1488171734-14881730258897437', 1, 0, '', NULL, NULL, NULL),
(21855, '2017-02-27 13:21:31', NULL, NULL, 7276, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:21:31', 'admin-1488171734-14881728914693782', 1, 0, '', NULL, NULL, NULL),
(21856, '2017-02-27 13:23:30', NULL, NULL, 7279, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:23:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21857, '2017-02-27 14:14:06', NULL, NULL, 7276, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 14:14:06', 'admin-1488171734-14881760462157142', 1, 1, 'SR', NULL, NULL, NULL),
(21858, '2017-02-27 14:14:06', NULL, NULL, 7276, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 14:14:06', 'admin-1488171734-14881760462157142', 1, 1, 'SR', NULL, NULL, NULL),
(21859, '2017-02-27 13:11:27', NULL, NULL, 7274, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:11:27', 'admin-1488171734-1488172286811764', 1, 1, 'SR', NULL, NULL, NULL),
(21860, '2017-02-27 10:06:50', NULL, NULL, 7267, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1488192900', 'admin', '2017-02-27 10:06:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21861, '2017-02-27 13:09:10', NULL, NULL, 7275, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:09:10', 'admin-1488171734-14881721500409829', 1, 0, '', NULL, NULL, NULL),
(21862, '2017-02-27 13:09:10', NULL, NULL, 7275, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:09:10', 'admin-1488171734-14881721500409829', 1, 0, '', NULL, NULL, NULL),
(21863, '2017-02-27 13:09:10', NULL, NULL, 7275, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:09:10', 'admin-1488171734-14881721500409829', 1, 0, '', NULL, NULL, NULL),
(21864, '2017-02-27 13:03:55', NULL, NULL, 7277, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:03:55', 'admin-1488171734-14881718350577054', 1, 0, '', NULL, NULL, NULL),
(21865, '2017-02-27 13:03:55', NULL, NULL, 7277, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:03:55', 'admin-1488171734-14881718350577054', 1, 1, 'SR', NULL, NULL, NULL),
(21866, '2017-02-27 13:03:47', NULL, NULL, 7277, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:03:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21867, '2017-02-27 13:02:08', NULL, NULL, 7276, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:02:08', 'admin-1488156993-14881717280529956', 1, 1, 'SR', NULL, NULL, NULL),
(21868, '2017-02-27 13:02:08', NULL, NULL, 7276, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:02:08', 'admin-1488156993-14881717280529956', 1, 0, '', NULL, NULL, NULL),
(21869, '2017-02-27 13:02:08', NULL, NULL, 7276, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:02:08', 'admin-1488156993-14881717280529956', 1, 0, '', NULL, NULL, NULL),
(21870, '2017-02-27 13:02:08', NULL, NULL, 7276, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:02:08', 'admin-1488156993-14881717280529956', 1, 1, 'SR', NULL, NULL, NULL),
(21871, '2017-02-27 13:02:08', NULL, NULL, 7276, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:02:08', 'admin-1488156993-14881717280529956', 1, 0, '', NULL, NULL, NULL),
(21872, '2017-02-27 13:02:08', NULL, NULL, 7276, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 13:02:08', 'admin-1488156993-14881717280529956', 1, 1, 'SR', NULL, NULL, NULL),
(21873, '2017-02-27 12:56:28', NULL, NULL, 7275, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 12:56:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21874, '2017-02-27 10:22:58', NULL, NULL, 7268, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 10:22:58', 'admin-1488156993-14881621780376628', 1, 0, '', NULL, NULL, NULL),
(21875, '2017-02-27 10:22:58', NULL, NULL, 7268, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 10:22:58', 'admin-1488156993-14881621780376628', 1, 1, 'SR', NULL, NULL, NULL),
(21876, '2017-02-27 10:25:01', NULL, NULL, 7269, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1488192900', 'admin', '2017-02-27 10:25:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21877, '2017-02-27 10:52:05', NULL, NULL, 7269, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 10:52:05', 'admin-1488156993-14881639253027896', 1, 0, '', NULL, NULL, NULL),
(21878, '2017-02-27 10:25:43', NULL, NULL, 7269, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 10:25:43', 'admin-1488156993-1488162343044349', 1, 1, 'SR', NULL, NULL, NULL),
(21879, '2017-02-27 10:25:43', NULL, NULL, 7269, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 10:25:43', 'admin-1488156993-1488162343044349', 1, 0, '', NULL, NULL, NULL),
(21880, '2017-02-27 10:25:43', NULL, NULL, 7269, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 10:25:43', 'admin-1488156993-1488162343044349', 1, 0, '', NULL, NULL, NULL),
(21881, '2017-02-27 10:52:05', NULL, NULL, 7269, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 10:52:05', 'admin-1488156993-14881639253027896', 1, 1, 'SR', NULL, NULL, NULL),
(21882, '2017-02-27 10:55:19', NULL, NULL, 7269, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 10:55:19', 'admin-1488156993-14881641196631081', 1, 0, '', NULL, NULL, NULL),
(21883, '2017-02-27 11:21:03', NULL, NULL, 7270, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1488192900', 'admin', '2017-02-27 11:21:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21884, '2017-02-27 11:21:10', NULL, NULL, 7270, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 11:21:10', 'admin-1488156993-14881656701248996', 1, 1, 'SR', NULL, NULL, NULL),
(21885, '2017-02-27 11:21:10', NULL, NULL, 7270, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 11:21:10', 'admin-1488156993-14881656701248996', 1, 1, 'SR', NULL, NULL, NULL),
(21886, '2017-02-27 12:25:06', NULL, NULL, 7271, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.29, 0.0000, 0.0000, 1.29, 1, '27', 1, '1488192900', 'admin', '2017-02-27 12:25:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21887, '2017-02-27 12:25:28', NULL, NULL, 7271, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 12:25:28', 'admin-1488156993-14881695284387935', 1, 1, 'SR', NULL, NULL, NULL),
(21888, '2017-02-27 12:29:02', NULL, NULL, 7271, 0, 181, '116', 'Open Food ', 'Cookie', 'Meals', 'Perfect Meals', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1488192900', 'admin', '2017-02-27 12:29:02', 'admin-1488156993-14881697422495736', 1, 0, '', NULL, NULL, NULL),
(21889, '2017-02-27 12:32:45', NULL, NULL, 7272, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.95, 0.0000, 0.0000, 3.95, 1, '27', 1, '1488192900', 'admin', '2017-02-27 12:32:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21890, '2017-02-27 12:32:53', NULL, NULL, 7272, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 12:32:53', 'admin-1488156993-1488169973362886', 1, 0, '', NULL, NULL, NULL),
(21891, '2017-02-27 12:33:03', NULL, NULL, 7272, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 12:33:03', 'admin-1488156993-14881699833257073', 1, 1, 'SR', NULL, NULL, NULL),
(21892, '2017-02-27 12:33:03', NULL, NULL, 7272, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 12:33:03', 'admin-1488156993-14881699833257073', 1, 1, 'SR', NULL, NULL, NULL),
(21893, '2017-02-27 10:22:48', NULL, NULL, 7268, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1488192900', 'admin', '2017-02-27 10:22:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21894, '2017-02-27 10:09:58', NULL, NULL, 7267, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 10:09:58', 'admin-1488156993-14881613984255469', 1, 0, '', NULL, NULL, NULL),
(21895, '2017-02-27 10:09:58', NULL, NULL, 7267, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 10:09:58', 'admin-1488156993-14881613984255469', 1, 0, '', NULL, NULL, NULL),
(21896, '2017-02-27 10:12:12', NULL, NULL, 7267, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 10:12:12', 'admin-1488156993-14881615323589728', 1, 1, 'SR', NULL, NULL, NULL),
(21897, '2017-02-27 09:49:54', NULL, NULL, 7266, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 09:49:54', 'admin-1488156993-1488160193792581', 1, 0, '', NULL, NULL, NULL),
(21898, '2017-02-27 09:49:54', NULL, NULL, 7266, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 09:49:54', 'admin-1488156993-1488160193792581', 1, 1, 'SR', NULL, NULL, NULL),
(21899, '2017-02-27 09:49:54', NULL, NULL, 7266, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 09:49:54', 'admin-1488156993-1488160193792581', 1, 0, '', NULL, NULL, NULL),
(21900, '2017-02-27 09:49:54', NULL, NULL, 7266, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488192900', 'admin', '2017-02-27 09:49:54', 'admin-1488156993-1488160193792581', 1, 0, '', NULL, NULL, NULL),
(21901, '2017-02-27 09:49:10', NULL, NULL, 7266, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1488192900', 'admin', '2017-02-27 09:49:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21902, '2017-03-01 12:27:13', NULL, NULL, 7304, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:27:13', 'admin-1488328212-14883424333967563', 1, 0, '', NULL, NULL, NULL),
(21903, '2017-03-01 12:27:13', NULL, NULL, 7304, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:27:13', 'admin-1488328212-14883424333967563', 1, 1, 'SR', NULL, NULL, NULL),
(21904, '2017-03-01 12:33:11', NULL, NULL, 7299, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:33:11', 'admin-1488328212-1488342791709383', 1, 1, 'SR', NULL, NULL, NULL),
(21905, '2017-03-01 12:36:26', NULL, NULL, 7305, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.90, 0.0000, 0.0000, 14.90, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:36:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21906, '2017-03-01 12:36:45', NULL, NULL, 7305, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:36:45', 'admin-1488328212-14883430050768373', 1, 1, 'SR', NULL, NULL, NULL),
(21907, '2017-03-01 12:36:45', NULL, NULL, 7305, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:36:45', 'admin-1488328212-14883430050768373', 1, 1, 'SR', NULL, NULL, NULL),
(21908, '2017-03-01 12:36:45', NULL, NULL, 7305, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:36:45', 'admin-1488328212-14883430050768373', 1, 0, '', NULL, NULL, NULL),
(21909, '2017-03-01 12:36:45', NULL, NULL, 7305, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:36:45', 'admin-1488328212-14883430050768373', 1, 1, 'SR', NULL, NULL, NULL),
(21910, '2017-03-01 12:36:45', NULL, NULL, 7305, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:36:45', 'admin-1488328212-14883430050768373', 1, 1, 'SR', NULL, NULL, NULL),
(21911, '2017-03-01 12:37:40', NULL, NULL, 7305, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:37:40', 'admin-1488328212-14883430602439719', 1, 1, 'SR', NULL, NULL, NULL),
(21912, '2017-03-01 12:37:40', NULL, NULL, 7305, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:37:40', 'admin-1488328212-14883430602439719', 1, 1, 'SR', NULL, NULL, NULL),
(21913, '2017-03-01 12:37:40', NULL, NULL, 7305, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:37:40', 'admin-1488328212-14883430602439719', 1, 1, 'SR', NULL, NULL, NULL),
(21914, '2017-03-01 12:37:40', NULL, NULL, 7305, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:37:40', 'admin-1488328212-14883430602439719', 1, 0, '', NULL, NULL, NULL),
(21915, '2017-03-01 12:37:40', NULL, NULL, 7305, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:37:40', 'admin-1488328212-14883430602439719', 1, 1, 'SR', NULL, NULL, NULL),
(21916, '2017-03-01 16:48:49', NULL, NULL, 7320, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 16:48:49', 'admin-1488351757-14883581293948930', 1, 1, 'SR', NULL, NULL, NULL),
(21917, '2017-03-01 16:48:49', NULL, NULL, 7320, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 16:48:49', 'admin-1488351757-14883581293948930', 1, 0, '', NULL, NULL, NULL),
(21918, '2017-03-01 16:48:49', NULL, NULL, 7320, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 16:48:49', 'admin-1488351757-14883581293948930', 1, 0, '', NULL, NULL, NULL),
(21919, '2017-03-01 16:41:21', NULL, NULL, 7319, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1488351757', 'admin', '2017-03-01 16:41:21', '0', 1, 1, 'SR', NULL, NULL, '15.0'),
(21920, '2017-03-01 12:49:15', NULL, NULL, 7306, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:49:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21921, '2017-03-01 16:48:23', NULL, NULL, 7320, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1488351757', 'admin', '2017-03-01 16:48:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21922, '2017-03-01 14:35:23', NULL, NULL, 7310, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1488351757', 'admin', '2017-03-01 14:35:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21923, '2017-03-01 14:35:35', NULL, NULL, 7310, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 14:35:35', 'admin-1488344010-14883501351419919', 1, 0, '', NULL, NULL, NULL),
(21924, '2017-03-01 14:35:35', NULL, NULL, 7310, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 14:35:35', 'admin-1488344010-14883501351419919', 1, 1, 'SR', NULL, NULL, NULL),
(21925, '2017-03-01 14:08:40', NULL, NULL, 7308, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1488351757', 'admin', '2017-03-01 14:08:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21926, '2017-03-01 14:08:47', NULL, NULL, 7308, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 14:08:47', 'admin-1488344010-14883485268796521', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(21927, '2017-03-01 14:08:51', NULL, NULL, 7308, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 14:08:51', 'admin-1488344010-14883485309237891', 1, 1, 'SR', NULL, NULL, NULL),
(21928, '2017-03-01 14:10:03', NULL, NULL, 7309, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1488351757', 'admin', '2017-03-01 14:10:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21929, '2017-03-01 14:10:17', NULL, NULL, 7309, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 14:10:17', 'admin-1488344010-14883486169217363', 1, 1, 'SR', NULL, NULL, NULL),
(21930, '2017-03-01 14:10:17', NULL, NULL, 7309, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 14:10:17', 'admin-1488344010-14883486169217363', 1, 1, 'SR', NULL, NULL, NULL),
(21931, '2017-03-01 14:11:14', NULL, NULL, 7308, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 14:11:14', 'admin-1488344010-1488348674112723', 1, 0, '', NULL, NULL, NULL),
(21932, '2017-03-01 14:11:14', NULL, NULL, 7308, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 14:11:14', 'admin-1488344010-1488348674112723', 1, 0, '', NULL, NULL, NULL),
(21933, '2017-03-01 14:35:35', NULL, NULL, 7310, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 14:35:35', 'admin-1488344010-14883501351419919', 1, 1, 'SR', NULL, NULL, NULL),
(21934, '2017-03-01 14:35:35', NULL, NULL, 7310, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 14:35:35', 'admin-1488344010-14883501351419919', 1, 1, 'SR', NULL, NULL, NULL),
(21935, '2017-03-01 15:20:30', NULL, NULL, 7311, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1488351757', 'admin', '2017-03-01 15:20:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21936, '2017-03-01 15:20:38', NULL, NULL, 7311, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 15:20:38', 'admin-1488351757-14883528379149925', 1, 1, 'SR', NULL, NULL, NULL),
(21937, '2017-03-01 15:20:38', NULL, NULL, 7311, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 15:20:38', 'admin-1488351757-14883528379149925', 1, 0, '', NULL, NULL, NULL),
(21938, '2017-03-01 15:20:47', NULL, NULL, 7312, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1488351757', 'admin', '2017-03-01 15:20:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21939, '2017-03-01 15:20:59', NULL, NULL, 7312, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 15:20:59', 'admin-1488351757-1488352859244514', 1, 1, 'SR', NULL, NULL, NULL),
(21940, '2017-03-01 15:20:59', NULL, NULL, 7312, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 15:20:59', 'admin-1488351757-1488352859244514', 1, 1, 'SR', NULL, NULL, NULL),
(21941, '2017-03-01 15:36:28', NULL, NULL, 7313, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 15:36:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21942, '2017-03-01 15:36:44', NULL, NULL, 7313, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 15:36:44', 'admin-1488351757-14883538044532076', 1, 1, 'SR', NULL, NULL, NULL),
(21943, '2017-03-01 15:36:44', NULL, NULL, 7313, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 15:36:44', 'admin-1488351757-14883538044532076', 1, 0, '', NULL, NULL, NULL),
(21944, '2017-03-01 15:39:13', NULL, NULL, 7314, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1488351757', 'admin', '2017-03-01 15:39:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21945, '2017-03-01 15:39:37', NULL, NULL, 7314, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 15:39:37', 'admin-1488351757-14883539778175822', 1, 1, 'SR', NULL, NULL, NULL),
(21946, '2017-03-01 15:43:50', NULL, NULL, 7315, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1488351757', 'admin', '2017-03-01 15:43:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21947, '2017-03-01 15:43:56', NULL, NULL, 7315, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 15:43:56', 'admin-1488351757-14883542358666522', 1, 1, 'SR', NULL, NULL, NULL),
(21948, '2017-03-01 12:49:37', NULL, NULL, 7306, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:49:37', 'admin-1488328212-1488343776855486', 1, 1, 'SR', NULL, NULL, NULL),
(21949, '2017-03-01 12:49:32', NULL, NULL, 7306, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:49:32', 'admin-1488328212-1488343772503399', 1, 0, '', NULL, NULL, NULL),
(21950, '2017-03-01 12:49:32', NULL, NULL, 7306, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:49:32', 'admin-1488328212-1488343772503399', 1, 1, 'SR', NULL, NULL, NULL),
(21951, '2017-03-01 18:26:07', NULL, NULL, 7326, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 18:26:07', 'admin-1488351757-14883639671789282', 1, 0, '', NULL, NULL, NULL),
(21952, '2017-03-01 18:26:07', NULL, NULL, 7326, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 18:26:07', 'admin-1488351757-14883639671789282', 1, 0, '', NULL, NULL, NULL),
(21953, '2017-03-01 18:19:47', NULL, NULL, 7326, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 18:19:47', 'admin-1488351757-14883635872996053', 1, 0, '', NULL, NULL, NULL),
(21954, '2017-03-01 18:19:47', NULL, NULL, 7326, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 18:19:47', 'admin-1488351757-14883635872996053', 1, 0, '', NULL, NULL, NULL),
(21955, '2017-03-01 18:19:40', NULL, NULL, 7326, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1488351757', 'admin', '2017-03-01 18:19:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21956, '2017-03-01 18:10:37', NULL, NULL, 7325, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 18:10:37', 'admin-1488351757-14883630376313559', 1, 1, 'SR', 1, NULL, NULL),
(21957, '2017-03-01 17:46:33', NULL, NULL, 7324, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1488351757', 'admin', '2017-03-01 17:46:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21958, '2017-03-01 17:46:43', NULL, NULL, 7324, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 17:46:43', 'admin-1488351757-14883616034156938', 1, 1, 'SR', NULL, NULL, NULL),
(21959, '2017-03-01 17:46:43', NULL, NULL, 7324, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 17:46:43', 'admin-1488351757-14883616034156938', 1, 0, '', NULL, NULL, NULL),
(21960, '2017-03-01 17:46:43', NULL, NULL, 7324, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 17:46:43', 'admin-1488351757-14883616034156938', 1, 1, 'SR', NULL, NULL, NULL),
(21961, '2017-03-01 17:07:26', NULL, NULL, 7321, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 17:07:26', 'admin-1488351757-14883592466286031', 1, 1, 'SR', NULL, NULL, NULL),
(21962, '2017-03-01 17:17:14', NULL, NULL, 7322, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1488351757', 'admin', '2017-03-01 17:17:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21963, '2017-03-01 17:17:17', NULL, NULL, 7322, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 17:17:17', 'admin-1488351757-14883598374737072', 1, 1, 'SR', NULL, NULL, NULL),
(21964, '2017-03-01 17:07:26', NULL, NULL, 7321, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 17:07:26', 'admin-1488351757-14883592466286031', 1, 1, 'SR', NULL, NULL, NULL),
(21965, '2017-03-01 17:01:29', NULL, NULL, 7320, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 17:01:29', 'admin-1488351757-14883588890012023', 1, 1, 'SR', NULL, NULL, NULL),
(21966, '2017-03-01 17:07:20', NULL, NULL, 7321, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1488351757', 'admin', '2017-03-01 17:07:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21967, '2017-03-01 17:01:29', NULL, NULL, 7320, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 17:01:29', 'admin-1488351757-14883588890012023', 1, 0, '', NULL, NULL, NULL),
(21968, '2017-03-01 16:48:49', NULL, NULL, 7320, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 16:48:49', 'admin-1488351757-14883581293948930', 1, 1, 'SR', NULL, NULL, NULL),
(21969, '2017-03-01 16:41:30', NULL, NULL, 7319, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 16:41:30', 'admin-1488351757-14883576903584522', 1, 0, '', NULL, NULL, '15.0'),
(21970, '2017-03-01 16:41:30', NULL, NULL, 7319, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 16:41:30', 'admin-1488351757-14883576903584522', 1, 1, 'SR', NULL, NULL, '15.0'),
(21971, '2017-03-01 16:17:24', NULL, NULL, 7318, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 16:17:24', 'admin-1488351757-14883562443449234', 1, 1, 'SR', NULL, NULL, NULL),
(21972, '2017-03-01 16:17:18', NULL, NULL, 7318, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1488351757', 'admin', '2017-03-01 16:17:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21973, '2017-03-01 16:16:33', NULL, NULL, 7317, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 16:16:33', 'admin-1488351757-14883561928508653', 1, 1, 'SR', 1, NULL, NULL),
(21974, '2017-03-01 15:54:58', NULL, NULL, 7311, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 15:54:58', 'admin-1488351757-14883548978186933', 1, 0, '', NULL, NULL, NULL),
(21975, '2017-03-01 15:48:15', NULL, NULL, 7316, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 15:48:15', 'admin-1488351757-1488354495202244', 1, 1, 'SR', NULL, NULL, NULL),
(21976, '2017-03-01 15:48:04', NULL, NULL, 7316, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1488351757', 'admin', '2017-03-01 15:48:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21977, '2017-03-01 13:16:54', NULL, NULL, 7305, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 13:16:54', 'admin-1488344010-14883454144445951', 1, 0, '', NULL, NULL, NULL),
(21978, '2017-03-01 13:03:17', NULL, NULL, 7305, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 13:03:17', 'admin-1488344010-1488344597284959', 1, 0, '', NULL, NULL, NULL),
(21979, '2017-03-01 12:53:18', NULL, NULL, 7305, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:53:18', 'admin-1488328212-14883439985724378', 1, 0, '', NULL, NULL, NULL),
(21980, '2017-03-01 13:03:17', NULL, NULL, 7305, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1488351757', 'admin', '2017-03-01 13:03:17', 'admin-1488344010-1488344597284959', 1, 0, '', NULL, NULL, NULL),
(21981, '2017-03-01 11:30:39', NULL, NULL, 7300, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 11:30:39', 'admin-1488328212-14883390388623370', 1, 1, 'SR', NULL, NULL, NULL),
(21982, '2017-03-01 11:30:39', NULL, NULL, 7300, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 11:30:39', 'admin-1488328212-14883390388623370', 1, 0, '', NULL, NULL, NULL),
(21983, '2017-03-01 12:12:53', NULL, NULL, 7301, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:12:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21984, '2017-03-01 12:13:02', NULL, NULL, 7301, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:13:02', 'admin-1488328212-14883415820862161', 1, 1, 'SR', NULL, NULL, NULL),
(21985, '2017-03-01 12:13:02', NULL, NULL, 7301, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:13:02', 'admin-1488328212-14883415820862161', 1, 0, '', NULL, NULL, NULL),
(21986, '2017-03-01 12:13:08', NULL, NULL, 7302, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:13:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21987, '2017-03-01 12:13:16', NULL, NULL, 7302, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:13:16', 'admin-1488328212-14883415963898157', 1, 1, 'SR', NULL, NULL, NULL),
(21988, '2017-03-01 12:13:16', NULL, NULL, 7302, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:13:16', 'admin-1488328212-14883415963898157', 1, 1, 'SR', NULL, NULL, NULL),
(21989, '2017-03-01 12:26:18', NULL, NULL, 7303, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:26:18', 'admin-1488328212-14883423785784122', 1, 0, '', 1, NULL, NULL),
(21990, '2017-03-01 12:26:41', NULL, NULL, 7304, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:26:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21991, '2017-03-01 12:26:59', NULL, NULL, 7304, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:26:59', 'admin-1488328212-14883424195441718', 1, 0, '', NULL, NULL, NULL),
(21992, '2017-03-01 12:26:59', NULL, NULL, 7304, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 12:26:59', 'admin-1488328212-14883424195441718', 1, 0, '', NULL, NULL, NULL),
(21993, '2017-03-01 10:44:40', NULL, NULL, 7298, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1488351757', 'admin', '2017-03-01 10:44:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21994, '2017-03-01 10:44:44', NULL, NULL, 7298, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 10:44:44', 'admin-1488328212-14883362847822253', 1, 0, '', NULL, NULL, NULL),
(21995, '2017-03-01 10:44:44', NULL, NULL, 7298, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 10:44:44', 'admin-1488328212-14883362847822253', 1, 1, 'SR', NULL, NULL, NULL),
(21996, '2017-03-01 11:25:13', NULL, NULL, 7299, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1488351757', 'admin', '2017-03-01 11:25:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(21997, '2017-03-01 11:25:17', NULL, NULL, 7299, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 11:25:17', 'admin-1488328212-14883387175728575', 1, 0, '', NULL, NULL, NULL),
(21998, '2017-03-01 11:25:23', NULL, NULL, 7299, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 11:25:23', 'admin-1488328212-14883387231376340', 1, 1, 'SR', NULL, NULL, NULL),
(21999, '2017-03-01 11:30:31', NULL, NULL, 7300, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 11:30:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22000, '2017-03-01 10:42:44', NULL, NULL, 7297, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 10:42:44', 'admin-1488328212-14883361640674514', 1, 0, '', NULL, NULL, NULL),
(22001, '2017-03-01 10:42:44', NULL, NULL, 7297, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 10:42:44', 'admin-1488328212-14883361640674514', 1, 0, '', NULL, NULL, NULL),
(22002, '2017-03-01 10:42:44', NULL, NULL, 7297, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 10:42:44', 'admin-1488328212-14883361640674514', 1, 1, 'SR', NULL, NULL, NULL),
(22003, '2017-03-01 09:12:39', NULL, NULL, 7295, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 09:12:39', 'admin-1488328212-14883307597078182', 1, 1, 'SR', NULL, NULL, NULL),
(22004, '2017-03-01 10:13:05', NULL, NULL, 7296, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1488351757', 'admin', '2017-03-01 10:13:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22005, '2017-03-01 10:13:13', NULL, NULL, 7296, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 10:13:13', 'admin-1488328212-14883343929551814', 1, 0, '', NULL, NULL, NULL),
(22006, '2017-03-01 10:13:13', NULL, NULL, 7296, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488351757', 'admin', '2017-03-01 10:13:13', 'admin-1488328212-14883343929551814', 1, 1, 'SR', NULL, NULL, NULL),
(22007, '2017-03-01 10:39:40', NULL, NULL, 7297, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1488351757', 'admin', '2017-03-01 10:39:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22008, '2017-03-01 09:12:36', NULL, NULL, 7295, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1488351757', 'admin', '2017-03-01 09:12:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22009, '2017-03-02 18:32:54', NULL, NULL, 7357, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 18:32:54', 'admin-1488450701-1488450774104851', 1, 1, 'SR', NULL, NULL, NULL),
(22010, '2017-03-02 18:32:54', NULL, NULL, 7357, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 18:32:54', 'admin-1488450701-1488450774104851', 1, 1, 'SR', NULL, NULL, NULL),
(22011, '2017-03-02 19:14:13', NULL, NULL, 7358, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1488450701', 'admin', '2017-03-02 19:14:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22012, '2017-03-02 19:14:18', NULL, NULL, 7358, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 19:14:18', 'admin-1488450701-14884532582976027', 1, 1, 'SR', NULL, NULL, NULL),
(22013, '2017-03-02 19:59:00', NULL, NULL, 7359, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 19:59:00', 'admin-1488450701-14884559398668111', 1, 1, 'SR', 1, NULL, NULL),
(22014, '2017-03-02 09:56:42', NULL, NULL, 7328, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:56:42', 'admin-1488416323-14884198022528420', 1, 0, '', NULL, NULL, NULL),
(22015, '2017-03-02 09:56:42', NULL, NULL, 7328, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:56:42', 'admin-1488416323-14884198022528420', 1, 0, '', NULL, NULL, NULL),
(22016, '2017-03-02 09:56:42', NULL, NULL, 7328, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:56:42', 'admin-1488416323-14884198022528420', 1, 0, '', NULL, NULL, NULL),
(22017, '2017-03-02 09:56:42', NULL, NULL, 7328, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:56:42', 'admin-1488416323-14884198022528420', 1, 0, '', NULL, NULL, NULL),
(22018, '2017-03-02 09:52:44', NULL, NULL, 7329, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:52:44', 'admin-1488416323-1488419564623461', 1, 1, 'SR', NULL, NULL, NULL),
(22019, '2017-03-02 09:52:44', NULL, NULL, 7329, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:52:44', 'admin-1488416323-1488419564623461', 1, 1, 'SR', NULL, NULL, NULL),
(22020, '2017-03-02 09:52:44', NULL, NULL, 7329, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:52:44', 'admin-1488416323-1488419564623461', 1, 1, 'SR', NULL, NULL, NULL),
(22021, '2017-03-02 09:52:45', NULL, NULL, 7329, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:52:45', 'admin-1488416323-1488419564623461', 1, 0, '', NULL, NULL, NULL),
(22022, '2017-03-02 09:52:45', NULL, NULL, 7329, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:52:45', 'admin-1488416323-1488419564623461', 1, 1, 'SR', NULL, NULL, NULL),
(22023, '2017-03-02 09:52:45', NULL, NULL, 7329, 0, 181, '116', 'Open Food ', 'scramble egg', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:52:45', 'admin-1488416323-1488419564623461', 1, 0, '', NULL, NULL, NULL),
(22024, '2017-03-02 12:36:55', NULL, NULL, 7342, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 12:36:55', 'admin-1488421861-14884294155547619', 1, 0, '', NULL, NULL, NULL),
(22025, '2017-03-02 12:36:15', NULL, NULL, 7342, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.60, 0.0000, 0.0000, 13.60, 1, '27', 1, '1488450701', 'admin', '2017-03-02 12:36:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22026, '2017-03-02 14:39:13', NULL, NULL, 7348, 0, 182, '117', 'Open Drinks ', 'PCB', 'Cold Drinks', 'Fresh Juice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 14:39:13', 'admin-1488421861-14884367535149924', 1, 0, '', 1, NULL, NULL),
(22027, '2017-03-02 15:11:09', NULL, NULL, 7349, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1488450701', 'admin', '2017-03-02 15:11:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22028, '2017-03-02 13:55:53', NULL, NULL, 7347, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 13:55:53', 'admin-1488421861-14884341537741615', 1, 1, 'SR', NULL, NULL, NULL),
(22029, '2017-03-02 15:11:19', NULL, NULL, 7349, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 15:11:19', 'admin-1488421861-14884386790893122', 1, 1, 'SR', NULL, NULL, NULL),
(22030, '2017-03-02 13:55:53', NULL, NULL, 7347, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 13:55:53', 'admin-1488421861-14884341537741615', 1, 1, 'SR', NULL, NULL, NULL),
(22031, '2017-03-02 13:55:47', NULL, NULL, 7347, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 13:55:47', 'admin-1488421861-14884341472163417', 1, 0, '', NULL, NULL, NULL),
(22032, '2017-03-02 13:55:47', NULL, NULL, 7347, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 13:55:47', 'admin-1488421861-14884341472163417', 1, 1, 'SR', NULL, NULL, NULL),
(22033, '2017-03-02 10:29:10', NULL, NULL, 7331, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:29:10', 'admin-1488416323-14884217506425472', 1, 0, '', NULL, NULL, NULL),
(22034, '2017-03-02 10:31:11', NULL, NULL, 7332, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:31:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22035, '2017-03-02 00:00:00', NULL, NULL, 7332, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:30:51', 'admin-1488416323-14884218508293893', 1, 1, 'SR', NULL, NULL, NULL),
(22036, '2017-03-02 00:00:00', NULL, NULL, 7332, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:30:51', 'admin-1488416323-14884218508293893', 1, 0, '', NULL, NULL, NULL),
(22037, '2017-03-02 10:34:10', NULL, NULL, 7333, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:34:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22038, '2017-03-02 10:34:14', NULL, NULL, 7333, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:34:14', 'admin-1488421861-1488422054000206', 1, 1, 'SR', NULL, NULL, NULL),
(22039, '2017-03-02 10:35:14', NULL, NULL, 7334, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:35:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22040, '2017-03-02 10:35:24', NULL, NULL, 7334, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:35:24', 'admin-1488421861-14884221246111775', 1, 0, '', NULL, NULL, NULL),
(22041, '2017-03-02 10:35:24', NULL, NULL, 7334, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:35:24', 'admin-1488421861-14884221246111775', 1, 1, 'SR', NULL, NULL, NULL),
(22042, '2017-03-02 10:35:24', NULL, NULL, 7334, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:35:24', 'admin-1488421861-14884221246111775', 1, 0, '', NULL, NULL, NULL),
(22043, '2017-03-02 10:41:35', NULL, NULL, 7328, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:41:35', 'admin-1488421861-14884224957393336', 1, 1, 'SR', NULL, NULL, NULL),
(22044, '2017-03-02 10:41:43', NULL, NULL, 7335, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:41:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22045, '2017-03-02 10:42:33', NULL, NULL, 7335, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:42:33', 'admin-1488421861-14884225537842661', 1, 0, '', NULL, NULL, NULL),
(22046, '2017-03-02 10:42:33', NULL, NULL, 7335, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:42:33', 'admin-1488421861-14884225537842661', 1, 0, '', NULL, NULL, NULL),
(22047, '2017-03-02 10:46:12', NULL, NULL, 7334, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:46:12', 'admin-1488421861-14884227724463273', 1, 1, 'SR', NULL, NULL, NULL),
(22048, '2017-03-02 11:00:22', NULL, NULL, 7333, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 11:00:22', 'admin-1488421861-14884236217996491', 1, 1, 'SR', NULL, NULL, NULL),
(22049, '2017-03-02 11:08:16', NULL, NULL, 7334, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 11:08:16', 'admin-1488421861-14884240966326622', 1, 0, '', NULL, NULL, NULL),
(22050, '2017-03-02 11:12:16', NULL, NULL, 7336, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1488450701', 'admin', '2017-03-02 11:12:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22051, '2017-03-02 11:12:24', NULL, NULL, 7336, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 11:12:24', 'admin-1488421861-14884243444615855', 1, 0, '', NULL, NULL, NULL),
(22052, '2017-03-02 11:12:24', NULL, NULL, 7336, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 11:12:24', 'admin-1488421861-14884243444615855', 1, 1, 'SR', NULL, NULL, NULL),
(22053, '2017-03-02 11:19:56', NULL, NULL, 7337, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1488450701', 'admin', '2017-03-02 11:19:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22054, '2017-03-02 11:20:00', NULL, NULL, 7337, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 11:20:00', 'admin-1488421861-14884247997834921', 1, 1, 'SR', NULL, NULL, NULL),
(22055, '2017-03-02 12:06:44', NULL, NULL, 7338, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 12:06:44', 'admin-1488421861-14884276043538974', 1, 1, 'SR', 1, NULL, '10.0'),
(22056, '2017-03-02 12:06:44', NULL, NULL, 7338, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 12:06:44', 'admin-1488421861-14884276043538974', 1, 1, 'SR', 1, NULL, '10.0'),
(22057, '2017-03-02 13:09:42', NULL, NULL, 7344, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 13:09:42', 'admin-1488421861-14884313818128046', 1, 1, 'SR', NULL, NULL, NULL),
(22058, '2017-03-02 13:09:33', NULL, NULL, 7344, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 13:09:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22059, '2017-03-02 12:19:00', NULL, NULL, 7340, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1488450701', 'admin', '2017-03-02 12:19:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22060, '2017-03-02 17:30:29', NULL, NULL, 7353, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 17:30:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22061, '2017-03-02 17:30:38', NULL, NULL, 7353, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 17:30:38', 'admin-1488421861-14884470379128137', 1, 1, 'SR', NULL, NULL, NULL),
(22062, '2017-03-02 17:30:38', NULL, NULL, 7353, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 17:30:38', 'admin-1488421861-14884470379128137', 1, 1, 'SR', NULL, NULL, NULL),
(22063, '2017-03-02 17:59:53', NULL, NULL, 7354, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1488450701', 'admin', '2017-03-02 17:59:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22064, '2017-03-02 18:00:06', NULL, NULL, 7354, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 18:00:06', 'admin-1488421861-14884488063125348', 1, 1, 'SR', NULL, NULL, NULL),
(22065, '2017-03-02 18:00:06', NULL, NULL, 7354, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 18:00:06', 'admin-1488421861-14884488063125348', 1, 0, '', NULL, NULL, NULL),
(22066, '2017-03-02 18:27:20', NULL, NULL, 7355, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1488450701', 'admin', '2017-03-02 18:27:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22067, '2017-03-02 18:27:28', NULL, NULL, 7355, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 18:27:28', 'admin-1488421861-14884504481355984', 1, 1, 'SR', NULL, NULL, NULL),
(22068, '2017-03-02 18:27:28', NULL, NULL, 7355, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 18:27:28', 'admin-1488421861-14884504481355984', 1, 1, 'SR', NULL, NULL, NULL),
(22069, '2017-03-02 18:28:11', NULL, NULL, 7355, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 18:28:11', 'admin-1488421861-1488450490793173', 1, 0, '', NULL, NULL, NULL),
(22070, '2017-03-02 18:31:55', NULL, NULL, 7356, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 18:31:55', 'admin-1488450701-14884507150136119', 1, 1, 'SR', 1, NULL, '10.0'),
(22071, '2017-03-02 18:32:42', NULL, NULL, 7357, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1488450701', 'admin', '2017-03-02 18:32:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22072, '2017-03-02 13:55:29', NULL, NULL, 7347, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1488450701', 'admin', '2017-03-02 13:55:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22073, '2017-03-02 13:55:47', NULL, NULL, 7347, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 13:55:47', 'admin-1488421861-14884341472163417', 1, 1, 'SR', NULL, NULL, NULL),
(22074, '2017-03-02 13:14:42', NULL, NULL, 7346, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 13:14:42', 'admin-1488421861-1488431682397103', 1, 1, 'SR', NULL, NULL, NULL),
(22075, '2017-03-02 13:14:42', NULL, NULL, 7346, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 13:14:42', 'admin-1488421861-1488431682397103', 1, 0, '', NULL, NULL, NULL),
(22076, '2017-03-02 17:02:03', NULL, NULL, 7352, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 17:02:03', 'admin-1488421861-14884453229005750', 1, 0, '', NULL, NULL, NULL),
(22077, '2017-03-02 15:46:04', NULL, NULL, 7351, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 15:46:04', 'admin-1488421861-14884407641158639', 1, 1, 'SR', NULL, NULL, NULL),
(22078, '2017-03-02 15:30:37', NULL, NULL, 7350, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 15:30:37', 'admin-1488421861-14884398371457242', 1, 1, 'SR', NULL, NULL, NULL),
(22079, '2017-03-02 15:30:37', NULL, NULL, 7350, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 15:30:37', 'admin-1488421861-14884398371457242', 1, 1, 'SR', NULL, NULL, NULL),
(22080, '2017-03-02 17:01:45', NULL, NULL, 7352, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1488450701', 'admin', '2017-03-02 17:01:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22081, '2017-03-02 17:02:03', NULL, NULL, 7352, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 17:02:03', 'admin-1488421861-14884453229005750', 1, 0, '', NULL, NULL, NULL),
(22082, '2017-03-02 12:36:55', NULL, NULL, 7342, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 12:36:55', 'admin-1488421861-14884294155547619', 1, 1, 'SR', NULL, NULL, NULL),
(22083, '2017-03-02 12:37:04', NULL, NULL, 7343, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1488450701', 'admin', '2017-03-02 12:37:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22084, '2017-03-02 12:38:10', NULL, NULL, 7343, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 12:38:10', 'admin-1488421861-14884294899741948', 1, 1, 'SR', NULL, NULL, NULL),
(22085, '2017-03-02 13:10:17', NULL, NULL, 7345, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1488450701', 'admin', '2017-03-02 13:10:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22086, '2017-03-02 15:30:37', NULL, NULL, 7350, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 15:30:37', 'admin-1488421861-14884398371457242', 1, 1, 'SR', NULL, NULL, NULL),
(22087, '2017-03-02 15:11:19', NULL, NULL, 7349, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 15:11:19', 'admin-1488421861-14884386790893122', 1, 1, 'SR', NULL, NULL, NULL),
(22088, '2017-03-02 15:30:23', NULL, NULL, 7350, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1488450701', 'admin', '2017-03-02 15:30:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22089, '2017-03-02 13:28:46', NULL, NULL, 7341, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 13:28:46', 'admin-1488421861-14884325265715823', 1, 1, 'SR', NULL, NULL, NULL),
(22090, '2017-03-02 13:25:33', NULL, NULL, 7345, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 13:25:33', 'admin-1488421861-14884323335216716', 1, 0, '', NULL, NULL, NULL),
(22091, '2017-03-02 13:14:42', NULL, NULL, 7346, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 13:14:42', 'admin-1488421861-1488431682397103', 1, 1, 'SR', NULL, NULL, NULL),
(22092, '2017-03-02 13:14:42', NULL, NULL, 7346, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 13:14:42', 'admin-1488421861-1488431682397103', 1, 1, 'SR', NULL, NULL, NULL),
(22093, '2017-03-02 13:11:35', NULL, NULL, 7345, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 13:11:35', 'admin-1488421861-1488431495430737', 1, 1, 'SR', NULL, NULL, NULL),
(22094, '2017-03-02 13:10:24', NULL, NULL, 7345, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 13:10:24', 'admin-1488421861-14884314238277230', 1, 0, '', NULL, NULL, NULL),
(22095, '2017-03-02 13:11:35', NULL, NULL, 7345, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 13:11:35', 'admin-1488421861-1488431495430737', 1, 1, 'SR', NULL, NULL, NULL),
(22096, '2017-03-02 13:14:27', NULL, NULL, 7346, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1488450701', 'admin', '2017-03-02 13:14:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22097, '2017-03-02 12:50:55', NULL, NULL, 7342, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 12:50:55', 'admin-1488421861-14884302555343938', 1, 0, '', NULL, NULL, NULL),
(22098, '2017-03-02 13:00:56', NULL, NULL, 7342, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 13:00:56', 'admin-1488421861-14884308559662197', 1, 1, 'SR', NULL, NULL, NULL),
(22099, '2017-03-02 12:36:55', NULL, NULL, 7342, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 12:36:55', 'admin-1488421861-14884294155547619', 1, 1, 'SR', NULL, NULL, NULL),
(22100, '2017-03-02 12:36:55', NULL, NULL, 7342, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 12:36:55', 'admin-1488421861-14884294155547619', 1, 1, 'SR', NULL, NULL, NULL),
(22101, '2017-03-02 12:36:55', NULL, NULL, 7342, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 12:36:55', 'admin-1488421861-14884294155547619', 1, 1, 'SR', NULL, NULL, NULL),
(22102, '2017-03-02 12:36:55', NULL, NULL, 7342, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 12:36:55', 'admin-1488421861-14884294155547619', 1, 1, 'SR', NULL, NULL, NULL),
(22103, '2017-03-02 12:36:55', NULL, NULL, 7342, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 12:36:55', 'admin-1488421861-14884294155547619', 1, 1, 'SR', NULL, NULL, NULL),
(22104, '2017-03-02 12:36:55', NULL, NULL, 7342, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 12:36:55', 'admin-1488421861-14884294155547619', 1, 0, '', NULL, NULL, NULL),
(22105, '2017-03-02 12:36:55', NULL, NULL, 7342, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 12:36:55', 'admin-1488421861-14884294155547619', 1, 1, 'SR', NULL, NULL, NULL),
(22106, '2017-03-02 12:19:22', NULL, NULL, 7340, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 12:19:22', 'admin-1488421861-14884283619525463', 1, 1, 'SR', NULL, NULL, NULL),
(22107, '2017-03-02 12:19:22', NULL, NULL, 7340, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 12:19:22', 'admin-1488421861-14884283619525463', 1, 1, 'SR', NULL, NULL, NULL),
(22108, '2017-03-02 12:19:22', NULL, NULL, 7340, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 12:19:22', 'admin-1488421861-14884283619525463', 1, 1, 'SR', NULL, NULL, NULL),
(22109, '2017-03-02 12:32:02', NULL, NULL, 7341, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1488450701', 'admin', '2017-03-02 12:32:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22110, '2017-03-02 12:32:10', NULL, NULL, 7341, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 12:32:10', 'admin-1488421861-14884291307778656', 1, 1, 'SR', NULL, NULL, NULL),
(22111, '2017-03-02 12:32:10', NULL, NULL, 7341, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 12:32:10', 'admin-1488421861-14884291307778656', 1, 1, 'SR', NULL, NULL, NULL),
(22112, '2017-03-02 10:29:10', NULL, NULL, 7331, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:29:10', 'admin-1488416323-14884217506425472', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(22113, '2017-03-02 10:24:19', NULL, NULL, 7331, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:24:19', 'admin-1488416323-14884214589314664', 1, 1, 'SR', NULL, NULL, NULL),
(22114, '2017-03-02 10:29:10', NULL, NULL, 7331, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:29:10', 'admin-1488416323-14884217506425472', 1, 1, 'SR', NULL, NULL, NULL),
(22115, '2017-03-02 10:29:10', NULL, NULL, 7331, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:29:10', 'admin-1488416323-14884217506425472', 1, 1, 'SR', NULL, NULL, NULL),
(22116, '2017-03-02 10:00:48', NULL, NULL, 7330, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:00:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22117, '2017-03-02 10:01:00', NULL, NULL, 7330, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:01:00', 'admin-1488416323-14884200603504555', 1, 0, '', NULL, NULL, NULL),
(22118, '2017-03-02 09:52:44', NULL, NULL, 7329, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:52:44', 'admin-1488416323-1488419564623461', 1, 0, '', NULL, NULL, NULL),
(22119, '2017-03-02 09:52:44', NULL, NULL, 7329, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:52:44', 'admin-1488416323-1488419564623461', 1, 0, '', NULL, NULL, NULL),
(22120, '2017-03-02 09:52:44', NULL, NULL, 7329, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:52:44', 'admin-1488416323-1488419564623461', 1, 0, '', NULL, NULL, NULL),
(22121, '2017-03-02 10:24:19', NULL, NULL, 7331, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:24:19', 'admin-1488416323-14884214589314664', 1, 1, 'SR', NULL, NULL, NULL),
(22122, '2017-03-02 10:24:14', NULL, NULL, 7331, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:24:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22123, '2017-03-02 10:01:00', NULL, NULL, 7330, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:01:00', 'admin-1488416323-14884200603504555', 1, 1, 'SR', NULL, NULL, NULL),
(22124, '2017-03-02 10:01:00', NULL, NULL, 7330, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:01:00', 'admin-1488416323-14884200603504555', 1, 1, 'SR', NULL, NULL, NULL),
(22125, '2017-03-02 10:01:00', NULL, NULL, 7330, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 10:01:00', 'admin-1488416323-14884200603504555', 1, 0, '', NULL, NULL, NULL),
(22126, '2017-03-02 09:52:44', NULL, NULL, 7329, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:52:44', 'admin-1488416323-1488419564623461', 1, 0, '', NULL, NULL, NULL),
(22127, '2017-03-02 09:52:44', NULL, NULL, 7329, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:52:44', 'admin-1488416323-1488419564623461', 1, 0, '', NULL, NULL, NULL),
(22128, '2017-03-02 09:56:42', NULL, NULL, 7328, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:56:42', 'admin-1488416323-14884198022528420', 1, 0, '', NULL, NULL, NULL),
(22129, '2017-03-02 09:52:44', NULL, NULL, 7329, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:52:44', 'admin-1488416323-1488419564623461', 1, 1, 'SR', NULL, NULL, NULL),
(22130, '2017-03-02 09:56:42', NULL, NULL, 7328, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:56:42', 'admin-1488416323-14884198022528420', 1, 1, 'SR', NULL, NULL, NULL),
(22131, '2017-03-02 09:56:42', NULL, NULL, 7328, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:56:42', 'admin-1488416323-14884198022528420', 1, 0, '', NULL, NULL, NULL),
(22132, '2017-03-02 09:12:01', NULL, NULL, 7327, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:12:01', 'admin-1488416323-14884171211744646', 1, 1, 'SR', NULL, NULL, NULL),
(22133, '2017-03-02 09:52:44', NULL, NULL, 7329, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:52:44', 'admin-1488416323-1488419564623461', 1, 1, 'SR', NULL, NULL, NULL),
(22134, '2017-03-02 09:52:44', NULL, NULL, 7329, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:52:44', 'admin-1488416323-1488419564623461', 1, 1, 'SR', NULL, NULL, NULL),
(22135, '2017-03-02 09:52:44', NULL, NULL, 7329, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:52:44', 'admin-1488416323-1488419564623461', 1, 0, '', NULL, NULL, NULL),
(22136, '2017-03-02 09:12:01', NULL, NULL, 7327, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:12:01', 'admin-1488416323-14884171211744646', 1, 1, 'SR', NULL, NULL, NULL),
(22137, '2017-03-02 09:12:01', NULL, NULL, 7327, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:12:01', 'admin-1488416323-14884171211744646', 1, 1, 'SR', NULL, NULL, NULL),
(22138, '2017-03-02 09:12:27', NULL, NULL, 7328, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.70, 0.0000, 0.0000, 14.70, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:12:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22139, '2017-03-02 09:12:34', NULL, NULL, 7328, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:12:34', 'admin-1488416323-14884171540944396', 1, 0, '', NULL, NULL, NULL),
(22140, '2017-03-02 09:21:35', NULL, NULL, 7328, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:21:35', 'admin-1488416323-14884176953696725', 1, 0, '', NULL, NULL, NULL),
(22141, '2017-03-02 09:45:54', NULL, NULL, 7329, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 21.20, 0.0000, 0.0000, 21.20, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:45:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22142, '2017-03-02 09:52:44', NULL, NULL, 7329, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:52:44', 'admin-1488416323-1488419564623461', 1, 0, '', NULL, NULL, NULL),
(22143, '2017-03-02 09:52:44', NULL, NULL, 7329, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:52:44', 'admin-1488416323-1488419564623461', 1, 0, '', NULL, NULL, NULL),
(22144, '2017-03-02 09:11:08', NULL, NULL, 7327, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1488450701', 'admin', '2017-03-02 09:11:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22145, '2017-03-03 00:00:00', NULL, NULL, 7393, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, NULL, NULL, 2.70, 1, '27', 1, '1488518799', 'admin', '2017-03-03 17:01:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22146, '2017-03-03 16:38:08', NULL, NULL, 7387, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 16:38:08', 'admin-1488518799-14885302886652927', 1, 1, 'SR', NULL, NULL, NULL),
(22147, '2017-03-03 16:45:37', NULL, NULL, 7388, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 16:45:37', 'admin-1488518799-14885307377286987', 1, 0, '', 1, NULL, NULL),
(22148, '2017-03-03 16:50:44', NULL, NULL, 7387, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 16:50:44', 'admin-1488518799-14885310442598523', 1, 1, 'SR', NULL, NULL, NULL),
(22149, '2017-03-03 16:54:00', NULL, NULL, 7389, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1488518799', 'admin', '2017-03-03 16:54:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22150, '2017-03-03 16:54:08', NULL, NULL, 7389, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 16:54:08', 'admin-1488518799-14885312483905367', 1, 1, 'SR', NULL, NULL, NULL),
(22151, '2017-03-03 16:54:08', NULL, NULL, 7389, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 16:54:08', 'admin-1488518799-14885312483905367', 1, 1, 'SR', NULL, NULL, NULL),
(22152, '2017-03-03 17:06:25', NULL, NULL, 7391, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1488518799', 'admin', '2017-03-03 17:06:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22153, '2017-03-03 00:00:00', NULL, NULL, 7393, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, NULL, NULL, 6.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 17:01:22', 'admin-1488518799-14885316823215066', 1, 1, 'SR', NULL, NULL, NULL),
(22154, '2017-03-03 17:26:12', NULL, NULL, 7392, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1488518799', 'admin', '2017-03-03 17:26:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22155, '2017-03-03 17:42:19', NULL, NULL, 7394, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1488518799', 'admin', '2017-03-03 17:42:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22156, '2017-03-03 00:00:00', NULL, NULL, 7393, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 17:01:22', 'admin-1488518799-14885316823215066', 1, 0, '', NULL, NULL, NULL),
(22157, '2017-03-03 09:23:23', NULL, NULL, 7360, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:23:23', 'admin-1488503650-14885042034439194', 1, 0, '', NULL, NULL, NULL),
(22158, '2017-03-03 09:27:07', NULL, NULL, 7360, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:27:07', 'admin-1488503650-14885044269957820', 1, 0, '', NULL, NULL, NULL),
(22159, '2017-03-03 09:27:16', NULL, NULL, 7360, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:27:16', 'admin-1488503650-14885044358176698', 1, 1, 'SR', NULL, NULL, NULL),
(22160, '2017-03-03 09:54:58', NULL, NULL, 7361, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:54:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22161, '2017-03-03 09:55:05', NULL, NULL, 7361, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:55:05', 'admin-1488503650-14885061051199197', 1, 0, '', NULL, NULL, NULL),
(22162, '2017-03-03 09:55:05', NULL, NULL, 7361, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:55:05', 'admin-1488503650-14885061051199197', 1, 0, '', NULL, NULL, NULL),
(22163, '2017-03-03 09:55:16', NULL, NULL, 7361, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:55:16', 'admin-1488503650-14885061160875564', 1, 1, 'SR', NULL, NULL, NULL),
(22164, '2017-03-03 18:44:27', NULL, NULL, 7396, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1488518799', 'admin', '2017-03-03 18:44:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22165, '2017-03-03 18:44:34', NULL, NULL, 7396, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 18:44:34', 'admin-1488518799-14885378745461777', 1, 1, 'SR', NULL, NULL, NULL),
(22166, '2017-03-03 18:18:59', NULL, NULL, 7395, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 18:18:59', 'admin-1488518799-14885363396713063', 1, 1, 'SR', NULL, NULL, NULL),
(22167, '2017-03-03 18:18:53', NULL, NULL, 7395, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1488518799', 'admin', '2017-03-03 18:18:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22168, '2017-03-03 00:00:00', NULL, NULL, 7392, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 17:01:22', 'admin-1488518799-14885316823215066', 1, 0, '', NULL, NULL, NULL),
(22169, '2017-03-03 16:34:41', NULL, NULL, 7386, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 16:34:41', 'admin-1488518799-14885300808143626', 1, 0, '', 1, NULL, NULL),
(22170, '2017-03-03 16:37:57', NULL, NULL, 7387, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1488518799', 'admin', '2017-03-03 16:37:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22171, '2017-03-03 17:42:30', NULL, NULL, 7394, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 17:42:30', 'admin-1488518799-14885341500849575', 1, 0, '', NULL, NULL, NULL),
(22172, '2017-03-03 17:42:30', NULL, NULL, 7394, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 17:42:30', 'admin-1488518799-14885341500849575', 1, 1, 'SR', NULL, NULL, NULL),
(22173, '2017-03-03 00:00:00', NULL, NULL, 7393, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, NULL, NULL, 6.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 17:25:51', 'admin-1488518799-14885331513559878', 1, 1, 'SR', NULL, NULL, NULL),
(22174, '2017-03-03 00:00:00', NULL, NULL, 7393, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 17:01:44', 'admin-1488518799-1488531703849329', 1, 1, 'SR', NULL, NULL, NULL),
(22175, '2017-03-03 00:00:00', NULL, NULL, 7392, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 17:01:22', 'admin-1488518799-14885316823215066', 1, 0, '', NULL, NULL, NULL),
(22176, '2017-03-03 13:49:58', NULL, NULL, 7374, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 13:49:58', 'admin-1488518799-14885201979024891', 1, 0, '', NULL, NULL, NULL),
(22177, '2017-03-03 14:02:42', NULL, NULL, 7383, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 14:02:42', 'admin-1488518799-14885209623406735', 1, 0, '', NULL, NULL, NULL),
(22178, '2017-03-03 14:43:34', NULL, NULL, 7384, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1488518799', 'admin', '2017-03-03 14:43:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22179, '2017-03-03 14:43:41', NULL, NULL, 7384, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 14:43:41', 'admin-1488518799-1488523421433356', 1, 1, 'SR', NULL, NULL, NULL),
(22180, '2017-03-03 14:43:41', NULL, NULL, 7384, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 14:43:41', 'admin-1488518799-1488523421433356', 1, 1, 'SR', NULL, NULL, NULL),
(22181, '2017-03-03 15:17:58', NULL, NULL, 7385, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1488518799', 'admin', '2017-03-03 15:17:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22182, '2017-03-03 15:18:01', NULL, NULL, 7385, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 15:18:01', 'admin-1488518799-14885254813461573', 1, 1, 'SR', NULL, NULL, NULL),
(22183, '2017-03-03 15:46:43', NULL, NULL, 7383, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 15:46:43', 'admin-1488518799-14885272037511432', 1, 0, '', NULL, NULL, NULL),
(22184, '2017-03-03 18:18:59', NULL, NULL, 7395, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 18:18:59', 'admin-1488518799-14885363396713063', 1, 1, 'SR', NULL, NULL, NULL),
(22185, '2017-03-03 19:27:46', NULL, NULL, 7398, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 19:27:46', 'admin-1488518799-14885404667619838', 1, 1, 'SR', 1, NULL, NULL),
(22186, '2017-03-03 18:44:34', NULL, NULL, 7396, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 18:44:34', 'admin-1488518799-14885378745461777', 1, 1, 'SR', NULL, NULL, NULL),
(22187, '2017-03-03 16:38:03', NULL, NULL, 7387, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 16:38:03', 'admin-1488518799-1488530282945165', 1, 0, '', NULL, NULL, NULL),
(22188, '2017-03-03 11:03:56', NULL, NULL, 7368, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:03:56', 'admin-1488510217-14885102362716691', 1, 1, 'SR', NULL, NULL, NULL),
(22189, '2017-03-03 11:03:56', NULL, NULL, 7368, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:03:56', 'admin-1488510217-14885102362716691', 1, 1, 'SR', NULL, NULL, NULL),
(22190, '2017-03-03 11:07:35', NULL, NULL, 7369, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:07:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22191, '2017-03-03 11:07:45', NULL, NULL, 7369, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:07:45', 'admin-1488510217-1488510465671710', 1, 0, '', NULL, NULL, NULL),
(22192, '2017-03-03 11:07:45', NULL, NULL, 7369, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:07:45', 'admin-1488510217-1488510465671710', 1, 0, '', NULL, NULL, NULL),
(22193, '2017-03-03 11:07:45', NULL, NULL, 7369, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:07:45', 'admin-1488510217-1488510465671710', 1, 1, 'SR', NULL, NULL, NULL),
(22194, '2017-03-03 11:07:45', NULL, NULL, 7369, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:07:45', 'admin-1488510217-1488510465671710', 1, 1, 'SR', NULL, NULL, NULL),
(22195, '2017-03-03 11:07:45', NULL, NULL, 7369, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:07:45', 'admin-1488510217-1488510465671710', 1, 1, 'SR', NULL, NULL, NULL),
(22196, '2017-03-03 11:07:45', NULL, NULL, 7369, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:07:45', 'admin-1488510217-1488510465671710', 1, 1, 'SR', NULL, NULL, NULL),
(22197, '2017-03-03 11:13:10', NULL, NULL, 7370, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:13:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22198, '2017-03-03 11:13:28', NULL, NULL, 7370, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:13:28', 'admin-1488510217-14885108084939025', 1, 0, '', NULL, NULL, NULL),
(22199, '2017-03-03 11:13:28', NULL, NULL, 7370, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:13:28', 'admin-1488510217-14885108084939025', 1, 0, '', NULL, NULL, NULL),
(22200, '2017-03-03 11:13:43', NULL, NULL, 7370, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:13:43', 'admin-1488510217-1488510823801759', 1, 0, '', NULL, NULL, NULL),
(22201, '2017-03-03 11:13:43', NULL, NULL, 7370, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:13:44', 'admin-1488510217-1488510823801759', 1, 1, 'SR', NULL, NULL, NULL),
(22202, '2017-03-03 11:13:44', NULL, NULL, 7370, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:13:44', 'admin-1488510217-1488510823801759', 1, 0, '', NULL, NULL, NULL),
(22203, '2017-03-03 11:26:43', NULL, NULL, 7371, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:26:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22204, '2017-03-03 11:26:52', NULL, NULL, 7371, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:26:52', 'admin-1488510217-14885116124551222', 1, 0, '', NULL, NULL, NULL),
(22205, '2017-03-03 09:22:33', NULL, NULL, 7360, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:22:33', 'admin-1488503650-14885041534935744', 1, 0, '', NULL, NULL, NULL),
(22206, '2017-03-03 09:22:33', NULL, NULL, 7360, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:22:33', 'admin-1488503650-14885041534935744', 1, 0, '', NULL, NULL, NULL),
(22207, '2017-03-03 09:22:33', NULL, NULL, 7360, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:22:33', 'admin-1488503650-14885041534935744', 1, 0, '', NULL, NULL, NULL),
(22208, '2017-03-03 09:22:33', NULL, NULL, 7360, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:22:33', 'admin-1488503650-14885041534935744', 1, 0, '', NULL, NULL, NULL),
(22209, '2017-03-03 09:23:23', NULL, NULL, 7360, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:23:23', 'admin-1488503650-14885042034439194', 1, 1, 'SR', NULL, NULL, NULL),
(22210, '2017-03-03 09:23:23', NULL, NULL, 7360, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:23:23', 'admin-1488503650-14885042034439194', 1, 1, 'SR', NULL, NULL, NULL),
(22211, '2017-03-03 09:23:23', NULL, NULL, 7360, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:23:23', 'admin-1488503650-14885042034439194', 1, 1, 'SR', NULL, NULL, NULL),
(22212, '2017-03-03 10:48:30', NULL, NULL, 7366, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 10:48:30', 'admin-1488503650-1488509309840312', 1, 0, '', NULL, NULL, NULL),
(22213, '2017-03-03 10:48:30', NULL, NULL, 7366, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 10:48:30', 'admin-1488503650-1488509309840312', 1, 0, '', NULL, NULL, NULL),
(22214, '2017-03-03 10:59:48', NULL, NULL, 7367, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 10:59:48', 'admin-1488503650-14885099887904699', 1, 1, 'SR', 1, NULL, NULL),
(22215, '2017-03-03 11:03:13', NULL, NULL, 7368, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:03:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22216, '2017-03-03 19:26:58', NULL, NULL, 7397, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 19:26:58', 'admin-1488518799-14885404185775073', 1, 1, 'SR', 1, NULL, '10.0'),
(22217, '2017-03-03 19:26:58', NULL, NULL, 7397, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 19:26:58', 'admin-1488518799-14885404185775073', 1, 1, 'SR', 1, NULL, '10.0'),
(22218, '2017-03-03 13:26:14', NULL, NULL, 7381, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1488518799', 'admin', '2017-03-03 13:26:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22219, '2017-03-03 13:26:32', NULL, NULL, 7381, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 13:26:32', 'admin-1488514799-1488518792327652', 1, 1, 'SR', NULL, NULL, NULL),
(22220, '2017-03-03 13:26:32', NULL, NULL, 7381, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 13:26:32', 'admin-1488514799-1488518792327652', 1, 1, 'SR', NULL, NULL, NULL),
(22221, '2017-03-03 13:26:32', NULL, NULL, 7381, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 13:26:32', 'admin-1488514799-1488518792327652', 1, 1, 'SR', NULL, NULL, NULL),
(22222, '2017-03-03 13:26:32', NULL, NULL, 7381, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 13:26:32', 'admin-1488514799-1488518792327652', 1, 1, 'SR', NULL, NULL, NULL),
(22223, '2017-03-03 13:26:32', NULL, NULL, 7381, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 13:26:32', 'admin-1488514799-1488518792327652', 1, 1, 'SR', NULL, NULL, NULL),
(22224, '2017-03-03 13:26:32', NULL, NULL, 7381, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 13:26:32', 'admin-1488514799-1488518792327652', 1, 0, '', NULL, NULL, NULL),
(22225, '2017-03-03 13:26:32', NULL, NULL, 7381, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 13:26:32', 'admin-1488514799-1488518792327652', 1, 0, '', NULL, NULL, NULL),
(22226, '2017-03-03 13:40:46', NULL, NULL, 7382, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1488518799', 'admin', '2017-03-03 13:40:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22227, '2017-03-03 13:40:52', NULL, NULL, 7382, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 13:40:52', 'admin-1488518799-14885196518843135', 1, 1, 'SR', NULL, NULL, NULL),
(22228, '2017-03-03 13:40:52', NULL, NULL, 7382, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 13:40:52', 'admin-1488518799-14885196518843135', 1, 1, 'SR', NULL, NULL, NULL),
(22229, '2017-03-03 13:40:52', NULL, NULL, 7382, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 13:40:52', 'admin-1488518799-14885196518843135', 1, 1, 'SR', NULL, NULL, NULL),
(22230, '2017-03-03 12:33:01', NULL, NULL, 7376, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:33:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22231, '2017-03-03 12:33:35', NULL, NULL, 7376, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:33:35', 'admin-1488514799-14885156149575659', 1, 0, '', NULL, NULL, NULL),
(22232, '2017-03-03 12:33:35', NULL, NULL, 7376, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:33:35', 'admin-1488514799-14885156149575659', 1, 1, 'SR', NULL, NULL, NULL),
(22233, '2017-03-03 12:33:50', NULL, NULL, 7376, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:33:50', 'admin-1488514799-14885156303022431', 1, 1, 'SR', NULL, NULL, NULL),
(22234, '2017-03-03 18:18:59', NULL, NULL, 7395, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 18:18:59', 'admin-1488518799-14885363396713063', 1, 0, '', NULL, NULL, NULL),
(22235, '2017-03-03 17:06:29', NULL, NULL, 7391, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 17:06:29', 'admin-1488518799-14885319895043748', 1, 1, 'SR', NULL, NULL, NULL),
(22236, '2017-03-03 14:02:42', NULL, NULL, 7383, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 14:02:42', 'admin-1488518799-14885209623406735', 1, 0, '', NULL, NULL, NULL),
(22237, '2017-03-03 13:08:45', NULL, NULL, 7379, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 13:08:45', 'admin-1488514799-14885177255489312', 1, 1, 'SR', NULL, NULL, NULL),
(22238, '2017-03-03 14:02:34', NULL, NULL, 7383, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1488518799', 'admin', '2017-03-03 14:02:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22239, '2017-03-03 13:49:58', NULL, NULL, 7374, 0, 181, '116', 'Open Food ', 'bff', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 13:49:58', 'admin-1488518799-14885201979024891', 1, 0, '', NULL, NULL, NULL),
(22240, '2017-03-03 13:57:41', NULL, NULL, 7382, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 13:57:41', 'admin-1488518799-14885206609998070', 1, 1, 'SR', NULL, NULL, NULL),
(22241, '2017-03-03 12:18:01', NULL, NULL, 7374, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:18:01', 'admin-1488510217-14885146813756693', 1, 0, '', NULL, NULL, NULL),
(22242, '2017-03-03 12:20:07', NULL, NULL, 7374, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:20:07', 'admin-1488514799-14885148076571438', 1, 0, '', NULL, NULL, NULL),
(22243, '2017-03-03 13:07:00', NULL, NULL, 7378, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 13:07:00', 'admin-1488514799-14885176206417547', 1, 1, 'SR', NULL, NULL, NULL),
(22244, '2017-03-03 13:08:20', NULL, NULL, 7379, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1488518799', 'admin', '2017-03-03 13:08:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22245, '2017-03-03 13:08:45', NULL, NULL, 7379, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 13:08:45', 'admin-1488514799-14885177255489312', 1, 0, '', NULL, NULL, NULL),
(22246, '2017-03-03 13:08:45', NULL, NULL, 7379, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 13:08:45', 'admin-1488514799-14885177255489312', 1, 1, 'SR', NULL, NULL, NULL),
(22247, '2017-03-03 13:07:00', NULL, NULL, 7378, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 13:07:00', 'admin-1488514799-14885176206417547', 1, 1, 'SR', NULL, NULL, NULL),
(22248, '2017-03-03 13:06:52', NULL, NULL, 7378, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1488518799', 'admin', '2017-03-03 13:06:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22249, '2017-03-03 12:45:13', NULL, NULL, 7377, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:45:13', 'admin-1488514799-14885163131784760', 1, 1, 'SR', NULL, NULL, NULL),
(22250, '2017-03-03 12:45:13', NULL, NULL, 7377, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:45:13', 'admin-1488514799-14885163131784760', 1, 0, '', NULL, NULL, NULL),
(22251, '2017-03-03 12:44:58', NULL, NULL, 7377, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:44:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22252, '2017-03-03 12:38:14', NULL, NULL, 7376, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:38:14', 'admin-1488514799-14885158946187550', 1, 0, '', NULL, NULL, NULL),
(22253, '2017-03-03 12:33:50', NULL, NULL, 7376, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:33:50', 'admin-1488514799-14885156303022431', 1, 1, 'SR', NULL, NULL, NULL),
(22254, '2017-03-03 12:33:50', NULL, NULL, 7376, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:33:50', 'admin-1488514799-14885156303022431', 1, 1, 'SR', NULL, NULL, NULL),
(22255, '2017-03-03 12:30:02', NULL, NULL, 7375, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:30:02', 'admin-1488514799-14885154024173625', 1, 1, 'SR', NULL, NULL, NULL),
(22256, '2017-03-03 12:29:53', NULL, NULL, 7375, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:29:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22257, '2017-03-03 12:30:02', NULL, NULL, 7375, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:30:02', 'admin-1488514799-14885154024173625', 1, 0, '', NULL, NULL, NULL),
(22258, '2017-03-03 12:16:58', NULL, NULL, 7374, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:16:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22259, '2017-03-03 12:17:01', NULL, NULL, 7374, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:17:01', 'admin-1488510217-14885146216896491', 1, 0, '', NULL, NULL, NULL),
(22260, '2017-03-03 12:18:01', NULL, NULL, 7374, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:18:01', 'admin-1488510217-14885146813756693', 1, 0, '', NULL, NULL, NULL),
(22261, '2017-03-03 12:18:01', NULL, NULL, 7374, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:18:01', 'admin-1488510217-14885146813756693', 1, 1, 'SR', NULL, NULL, NULL),
(22262, '2017-03-03 12:04:03', NULL, NULL, 7373, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:04:03', 'admin-1488510217-1488513843332804', 1, 1, 'SR', NULL, NULL, NULL),
(22263, '2017-03-03 12:04:03', NULL, NULL, 7373, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:04:03', 'admin-1488510217-1488513843332804', 1, 0, '', NULL, NULL, NULL),
(22264, '2017-03-03 12:03:58', NULL, NULL, 7373, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:03:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22265, '2017-03-03 11:52:58', NULL, NULL, 7372, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:52:58', 'admin-1488510217-14885131787267571', 1, 1, 'SR', NULL, NULL, NULL),
(22266, '2017-03-03 11:52:54', NULL, NULL, 7372, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:52:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22267, '2017-03-03 11:52:58', NULL, NULL, 7372, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:52:58', 'admin-1488510217-14885131787267571', 1, 1, 'SR', NULL, NULL, NULL),
(22268, '2017-03-03 12:28:44', NULL, NULL, 7366, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 12:28:44', 'admin-1488514799-14885153244172382', 1, 0, '', NULL, NULL, NULL),
(22269, '2017-03-03 11:45:44', NULL, NULL, 7364, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:45:44', 'admin-1488510217-14885127438871881', 1, 0, '', NULL, NULL, '10.0'),
(22270, '2017-03-03 11:26:52', NULL, NULL, 7371, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:26:52', 'admin-1488510217-14885116124551222', 1, 0, '', NULL, NULL, NULL),
(22271, '2017-03-03 09:59:46', NULL, NULL, 7362, 0, 182, '117', 'Open Drinks ', 'banana', 'Cold Drinks', 'Fresh Juice', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:59:46', 'admin-1488503650-14885063865836874', 1, 0, '', NULL, NULL, NULL),
(22272, '2017-03-03 09:22:33', NULL, NULL, 7360, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:22:33', 'admin-1488503650-14885041534935744', 1, 0, '', NULL, NULL, NULL),
(22273, '2017-03-03 10:10:27', NULL, NULL, 7363, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 10:10:27', 'admin-1488503650-14885070275337082', 1, 1, 'SR', NULL, NULL, NULL),
(22274, '2017-03-03 10:31:55', NULL, NULL, 7364, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1488518799', 'admin', '2017-03-03 10:31:55', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(22275, '2017-03-03 10:32:07', NULL, NULL, 7364, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 10:32:07', 'admin-1488503650-1488508327498902', 1, 0, '', NULL, NULL, '10.0'),
(22276, '2017-03-03 10:32:07', NULL, NULL, 7364, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 10:32:07', 'admin-1488503650-1488508327498902', 1, 0, '', NULL, NULL, '10.0'),
(22277, '2017-03-03 10:32:07', NULL, NULL, 7364, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 10:32:07', 'admin-1488503650-1488508327498902', 1, 1, 'SR', NULL, NULL, '10.0'),
(22278, '2017-03-03 10:32:07', NULL, NULL, 7364, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 10:32:07', 'admin-1488503650-1488508327498902', 1, 0, '', NULL, NULL, '10.0'),
(22279, '2017-03-03 10:38:13', NULL, NULL, 7365, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1488518799', 'admin', '2017-03-03 10:38:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22280, '2017-03-03 10:38:40', NULL, NULL, 7365, 0, 153, '87', 'Wake Me Up!', 'without bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 10:38:40', 'admin-1488503650-14885087198943081', 1, 0, '', NULL, NULL, NULL),
(22281, '2017-03-03 10:38:40', NULL, NULL, 7365, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 10:38:40', 'admin-1488503650-14885087198943081', 1, 0, '', NULL, NULL, NULL),
(22282, '2017-03-03 10:41:45', NULL, NULL, 7362, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 10:41:45', 'admin-1488503650-14885089052332864', 1, 1, 'SR', NULL, NULL, NULL),
(22283, '2017-03-03 10:44:53', NULL, NULL, 7366, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1488518799', 'admin', '2017-03-03 10:44:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22284, '2017-03-03 10:48:30', NULL, NULL, 7366, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 10:48:30', 'admin-1488503650-1488509309840312', 1, 1, 'SR', NULL, NULL, NULL),
(22285, '2017-03-03 10:48:30', NULL, NULL, 7366, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 10:48:30', 'admin-1488503650-1488509309840312', 1, 1, 'SR', NULL, NULL, NULL),
(22286, '2017-03-03 10:48:30', NULL, NULL, 7366, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 10:48:30', 'admin-1488503650-1488509309840312', 1, 1, 'SR', NULL, NULL, NULL),
(22287, '2017-03-03 10:48:30', NULL, NULL, 7366, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 10:48:30', 'admin-1488503650-1488509309840312', 1, 1, 'SR', NULL, NULL, NULL),
(22288, '2017-03-03 10:48:30', NULL, NULL, 7366, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 10:48:30', 'admin-1488503650-1488509309840312', 1, 0, '', NULL, NULL, NULL),
(22289, '2017-03-03 11:03:29', NULL, NULL, 7368, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:03:29', 'admin-1488503650-14885102095914253', 1, 0, '', NULL, NULL, NULL),
(22290, '2017-03-03 11:03:29', NULL, NULL, 7368, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 11:03:29', 'admin-1488503650-14885102095914253', 1, 0, '', NULL, NULL, NULL),
(22291, '2017-03-03 09:59:46', NULL, NULL, 7362, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:59:46', 'admin-1488503650-14885063865836874', 1, 1, 'SR', NULL, NULL, NULL),
(22292, '2017-03-03 09:59:33', NULL, NULL, 7362, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.55, 0.0000, 0.0000, 1.55, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:59:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22293, '2017-03-03 09:55:16', NULL, NULL, 7361, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:55:16', 'admin-1488503650-14885061160875564', 1, 1, 'SR', NULL, NULL, NULL),
(22294, '2017-03-03 09:23:23', NULL, NULL, 7360, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:23:23', 'admin-1488503650-14885042034439194', 1, 0, '', NULL, NULL, NULL),
(22295, '2017-03-03 09:23:23', NULL, NULL, 7360, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:23:23', 'admin-1488503650-14885042034439194', 1, 1, 'SR', NULL, NULL, NULL),
(22296, '2017-03-03 10:10:24', NULL, NULL, 7363, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1488518799', 'admin', '2017-03-03 10:10:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22297, '2017-03-03 09:23:23', NULL, NULL, 7360, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:23:23', 'admin-1488503650-14885042034439194', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(22298, '2017-03-03 09:23:23', NULL, NULL, 7360, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:23:23', 'admin-1488503650-14885042034439194', 1, 1, 'SR', NULL, NULL, NULL),
(22299, '2017-03-03 09:23:23', NULL, NULL, 7360, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:23:23', 'admin-1488503650-14885042034439194', 1, 1, 'SR', NULL, NULL, NULL),
(22300, '2017-03-03 09:22:33', NULL, NULL, 7360, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:22:33', 'admin-1488503650-14885041534935744', 1, 0, '', NULL, NULL, NULL),
(22301, '2017-03-03 09:22:33', NULL, NULL, 7360, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:22:33', 'admin-1488503650-14885041534935744', 1, 0, '', NULL, NULL, NULL),
(22302, '2017-03-03 09:22:33', NULL, NULL, 7360, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:22:33', 'admin-1488503650-14885041534935744', 1, 0, '', NULL, NULL, NULL),
(22303, '2017-03-03 09:22:33', NULL, NULL, 7360, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:22:33', 'admin-1488503650-14885041534935744', 1, 0, '', NULL, NULL, NULL),
(22304, '2017-03-03 09:22:33', NULL, NULL, 7360, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:22:33', 'admin-1488503650-14885041534935744', 1, 0, '', NULL, NULL, NULL),
(22305, '2017-03-03 09:21:59', NULL, NULL, 7360, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 26.50, 0.0000, 0.0000, 26.50, 1, '27', 1, '1488518799', 'admin', '2017-03-03 09:21:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22306, '2017-03-04 14:57:12', NULL, NULL, 7432, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:57:12', 'admin-1488608002-14886106324664518', 1, 1, 'SR', NULL, NULL, NULL),
(22307, '2017-03-04 14:58:29', NULL, NULL, 7424, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:58:29', 'admin-1488608002-14886107097399834', 1, 1, 'SR', NULL, NULL, NULL),
(22308, '2017-03-04 15:30:08', NULL, NULL, 7432, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 15:30:08', 'admin-1488608002-14886126083942326', 1, 0, '', NULL, NULL, NULL),
(22309, '2017-03-04 14:55:00', NULL, NULL, 7441, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:55:00', 'admin-1488608002-14886105004449182', 1, 0, '', NULL, NULL, NULL),
(22310, '2017-03-04 13:47:24', NULL, NULL, 7428, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:47:24', 'admin-1488603664-14886064447721695', 1, 1, 'SR', NULL, NULL, NULL),
(22311, '2017-03-04 13:47:24', NULL, NULL, 7428, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:47:24', 'admin-1488603664-14886064447721695', 1, 0, '', NULL, NULL, NULL),
(22312, '2017-03-04 13:48:32', NULL, NULL, 7429, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:48:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22313, '2017-03-04 13:48:43', NULL, NULL, 7429, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:48:43', 'admin-1488603664-14886065237988372', 1, 0, '', NULL, NULL, NULL),
(22314, '2017-03-04 13:59:18', NULL, NULL, 7430, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:59:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22315, '2017-03-04 13:59:23', NULL, NULL, 7430, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:59:23', 'admin-1488603664-1488607162819241', 1, 1, 'SR', NULL, NULL, NULL),
(22316, '2017-03-04 14:04:39', NULL, NULL, 7431, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:04:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22317, '2017-03-04 18:37:11', NULL, NULL, 7449, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 18:37:11', 'admin-1488608002-14886238310669011', 1, 1, 'SR', NULL, NULL, NULL),
(22318, '2017-03-04 18:37:11', NULL, NULL, 7449, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 18:37:11', 'admin-1488608002-14886238310669011', 1, 0, '', NULL, NULL, NULL),
(22319, '2017-03-04 18:37:11', NULL, NULL, 7449, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 18:37:11', 'admin-1488608002-14886238310669011', 1, 0, '', NULL, NULL, NULL),
(22320, '2017-03-04 18:37:11', NULL, NULL, 7449, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 18:37:11', 'admin-1488608002-14886238310669011', 1, 1, 'SR', NULL, NULL, NULL),
(22321, '2017-03-04 18:49:16', NULL, NULL, 7449, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 18:49:16', 'admin-1488608002-14886245560405187', 1, 0, '', NULL, NULL, NULL),
(22322, '2017-03-04 18:57:20', NULL, NULL, 7450, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1488608002', 'admin', '2017-03-04 18:57:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22323, '2017-03-04 18:57:25', NULL, NULL, 7450, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 18:57:25', 'admin-1488608002-14886250450839793', 1, 1, 'SR', NULL, NULL, NULL),
(22324, '2017-03-04 18:57:25', NULL, NULL, 7450, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 18:57:25', 'admin-1488608002-14886250450839793', 1, 1, 'SR', NULL, NULL, NULL),
(22325, '2017-03-04 19:14:43', NULL, NULL, 7449, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 19:14:43', 'admin-1488608002-1488626082863891', 1, 0, '', NULL, NULL, NULL),
(22326, '2017-03-04 16:56:54', NULL, NULL, 7446, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 16:56:54', 'admin-1488608002-14886178138228318', 1, 0, '', 1, NULL, NULL),
(22327, '2017-03-04 16:50:28', NULL, NULL, 7445, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 16:50:28', 'admin-1488608002-14886174282913415', 1, 1, 'SR', NULL, NULL, NULL),
(22328, '2017-03-04 16:50:18', NULL, NULL, 7445, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1488608002', 'admin', '2017-03-04 16:50:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22329, '2017-03-04 16:38:34', NULL, NULL, 7444, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 16:38:34', 'admin-1488608002-14886167146072575', 1, 1, 'SR', NULL, NULL, NULL),
(22330, '2017-03-04 16:37:24', NULL, NULL, 7444, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 16:37:24', 'admin-1488608002-14886166443478733', 1, 0, '', NULL, NULL, NULL),
(22331, '2017-03-04 16:37:42', NULL, NULL, 7444, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 16:37:42', 'admin-1488608002-14886166622725037', 1, 1, 'SR', NULL, NULL, NULL),
(22332, '2017-03-04 16:37:42', NULL, NULL, 7444, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 16:37:42', 'admin-1488608002-14886166622725037', 1, 1, 'SR', NULL, NULL, NULL),
(22333, '2017-03-04 14:43:43', NULL, NULL, 7434, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:43:43', 'admin-1488608002-14886098237009732', 1, 1, 'SR', 1, NULL, NULL),
(22334, '2017-03-04 14:43:43', NULL, NULL, 7434, 0, 181, '116', 'Open Food ', 'scrambled egg', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:43:43', 'admin-1488608002-14886098237009732', 1, 0, '', 1, NULL, NULL),
(22335, '2017-03-04 14:45:52', NULL, NULL, 7435, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:45:52', 'admin-1488608002-14886099524024944', 1, 0, '', 1, NULL, NULL),
(22336, '2017-03-04 14:55:00', NULL, NULL, 7441, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:55:00', 'admin-1488608002-14886105004449182', 1, 1, 'SR', NULL, NULL, NULL),
(22337, '2017-03-04 14:55:00', NULL, NULL, 7441, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:55:00', 'admin-1488608002-14886105004449182', 1, 1, 'SR', NULL, NULL, NULL),
(22338, '2017-03-04 14:54:49', NULL, NULL, 7441, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.60, 0.0000, 0.0000, 10.60, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:54:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22339, '2017-03-04 14:50:03', NULL, NULL, 7440, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:50:03', 'admin-1488608002-1488610203627227', 1, 1, 'SR', 1, NULL, NULL),
(22340, '2017-03-04 14:47:17', NULL, NULL, 7439, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:47:17', 'admin-1488608002-14886100376484575', 1, 1, 'SR', 1, NULL, NULL),
(22341, '2017-03-04 14:46:35', NULL, NULL, 7438, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:46:35', 'admin-1488608002-14886099955579573', 1, 0, '', 1, NULL, NULL),
(22342, '2017-03-04 14:43:43', NULL, NULL, 7434, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:43:43', 'admin-1488608002-14886098237009732', 1, 1, 'SR', 1, NULL, NULL),
(22343, '2017-03-04 14:27:23', NULL, NULL, 7433, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:27:23', 'admin-1488608002-14886088427513729', 1, 0, '', 1, NULL, NULL),
(22344, '2017-03-04 11:16:04', NULL, NULL, 7412, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:16:04', 'admin-1488595909-14885973639808549', 1, 0, '', NULL, NULL, NULL),
(22345, '2017-03-04 11:16:04', NULL, NULL, 7412, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:16:04', 'admin-1488595909-14885973639808549', 1, 0, '', NULL, NULL, NULL),
(22346, '2017-03-04 11:16:04', NULL, NULL, 7412, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:16:04', 'admin-1488595909-14885973639808549', 1, 1, 'SR', NULL, NULL, NULL),
(22347, '2017-03-04 15:30:08', NULL, NULL, 7432, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 15:30:08', 'admin-1488608002-14886126083942326', 1, 0, '', NULL, NULL, NULL),
(22348, '2017-03-04 15:46:57', NULL, NULL, 7441, 0, 268, '202', 'ICED COCOA CAPPUCINO', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 15:46:57', 'admin-1488608002-14886136168305132', 1, 0, '', NULL, NULL, NULL),
(22349, '2017-03-04 17:43:30', NULL, NULL, 7447, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1488608002', 'admin', '2017-03-04 17:43:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22350, '2017-03-04 17:43:33', NULL, NULL, 7447, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 17:43:33', 'admin-1488608002-14886206137179017', 1, 0, '', NULL, NULL, NULL),
(22351, '2017-03-04 17:43:33', NULL, NULL, 7447, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 17:43:33', 'admin-1488608002-14886206137179017', 1, 0, '', NULL, NULL, NULL),
(22352, '2017-03-04 17:44:08', NULL, NULL, 7447, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 17:44:08', 'admin-1488608002-14886206481843148', 1, 1, 'SR', NULL, NULL, NULL),
(22353, '2017-03-04 17:46:59', NULL, NULL, 7447, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 17:46:59', 'admin-1488608002-14886208196585865', 1, 0, '', NULL, NULL, NULL),
(22354, '2017-03-04 17:50:08', NULL, NULL, 7447, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 17:50:08', 'admin-1488608002-14886210087668349', 1, 1, 'SR', NULL, NULL, NULL),
(22355, '2017-03-04 17:57:52', NULL, NULL, 7448, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1488608002', 'admin', '2017-03-04 17:57:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22356, '2017-03-04 17:57:55', NULL, NULL, 7448, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 17:57:55', 'admin-1488608002-14886214755526955', 1, 1, 'SR', NULL, NULL, NULL),
(22357, '2017-03-04 18:36:27', NULL, NULL, 7449, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1488608002', 'admin', '2017-03-04 18:36:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22358, '2017-03-04 14:39:36', NULL, NULL, 7432, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:39:36', 'admin-1488608002-14886095763495220', 1, 0, '', NULL, NULL, NULL),
(22359, '2017-03-04 14:24:08', NULL, NULL, 7431, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:24:08', 'admin-1488608002-14886086482912535', 1, 0, '', NULL, NULL, NULL),
(22360, '2017-03-04 14:12:44', NULL, NULL, 7432, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:12:44', 'admin-1488603664-14886079646365376', 1, 0, '', NULL, NULL, NULL),
(22361, '2017-03-04 14:07:04', NULL, NULL, 7431, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:07:04', 'admin-1488603664-1488607624172915', 1, 1, 'SR', NULL, NULL, NULL),
(22362, '2017-03-04 14:12:37', NULL, NULL, 7432, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:12:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22363, '2017-03-04 14:07:04', NULL, NULL, 7431, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:07:04', 'admin-1488603664-1488607624172915', 1, 0, '', NULL, NULL, NULL),
(22364, '2017-03-04 13:09:58', NULL, NULL, 7423, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:09:58', 'admin-1488603664-14886041987186223', 1, 1, 'SR', NULL, NULL, NULL),
(22365, '2017-03-04 13:09:58', NULL, NULL, 7423, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:09:58', 'admin-1488603664-14886041987186223', 1, 1, 'SR', NULL, NULL, NULL),
(22366, '2017-03-04 13:10:13', NULL, NULL, 7422, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:10:13', 'admin-1488603664-14886042135967557', 1, 0, '', NULL, NULL, NULL),
(22367, '2017-03-04 13:12:08', NULL, NULL, 7424, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:12:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22368, '2017-03-04 13:12:18', NULL, NULL, 7424, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:12:18', 'admin-1488603664-1488604338454390', 1, 1, 'SR', NULL, NULL, NULL),
(22369, '2017-03-04 13:12:18', NULL, NULL, 7424, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:12:18', 'admin-1488603664-1488604338454390', 1, 1, 'SR', NULL, NULL, NULL),
(22370, '2017-03-04 13:13:08', NULL, NULL, 7422, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:13:08', 'admin-1488603664-14886043887671226', 1, 1, 'SR', NULL, NULL, NULL),
(22371, '2017-03-04 13:22:15', NULL, NULL, 7425, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:22:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22372, '2017-03-04 11:24:05', NULL, NULL, 7413, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:24:05', 'admin-1488595909-14885978456372158', 1, 0, '', NULL, NULL, NULL),
(22373, '2017-03-04 18:37:11', NULL, NULL, 7449, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 18:37:11', 'admin-1488608002-14886238310669011', 1, 0, '', NULL, NULL, NULL),
(22374, '2017-03-04 16:37:24', NULL, NULL, 7444, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 16:37:24', 'admin-1488608002-14886166443478733', 1, 0, '', NULL, NULL, NULL),
(22375, '2017-03-04 16:37:00', NULL, NULL, 7444, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1488608002', 'admin', '2017-03-04 16:37:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22376, '2017-03-04 16:05:29', NULL, NULL, 7443, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 16:05:29', 'admin-1488608002-14886147288959926', 1, 0, '', NULL, NULL, NULL),
(22377, '2017-03-04 16:04:51', NULL, NULL, 7443, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 16:04:52', 'admin-1488608002-14886146917014355', 1, 1, 'SR', NULL, NULL, NULL),
(22378, '2017-03-04 16:04:52', NULL, NULL, 7443, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 16:04:52', 'admin-1488608002-14886146917014355', 1, 1, 'SR', NULL, NULL, NULL),
(22379, '2017-03-04 16:04:25', NULL, NULL, 7443, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1488608002', 'admin', '2017-03-04 16:04:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22380, '2017-03-04 15:54:20', NULL, NULL, 7441, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 15:54:20', 'admin-1488608002-14886140597331064', 1, 1, 'SR', NULL, NULL, NULL),
(22381, '2017-03-04 15:54:20', NULL, NULL, 7441, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 15:54:20', 'admin-1488608002-14886140597331064', 1, 0, '', NULL, NULL, NULL),
(22382, '2017-03-04 14:43:43', NULL, NULL, 7434, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:43:43', 'admin-1488608002-14886098237009732', 1, 1, 'SR', 1, NULL, NULL),
(22383, '2017-03-04 14:13:15', NULL, NULL, 7431, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:13:15', 'admin-1488603664-14886079949753841', 1, 0, '', NULL, NULL, NULL),
(22384, '2017-03-04 14:06:50', NULL, NULL, 7431, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:06:50', 'admin-1488603664-14886076100665889', 1, 0, '', NULL, NULL, NULL),
(22385, '2017-03-04 14:06:50', NULL, NULL, 7431, 0, 181, '116', 'Open Food ', '2toast,3scramble eggs,lots mashed potatoes', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:06:50', 'admin-1488603664-14886076100665889', 1, 0, '', NULL, NULL, NULL),
(22386, '2017-03-04 13:23:23', NULL, NULL, 7426, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:23:23', 'admin-1488603664-14886050032512392', 1, 0, '', NULL, NULL, NULL),
(22387, '2017-03-04 13:30:48', NULL, NULL, 7427, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:30:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22388, '2017-03-04 13:31:14', NULL, NULL, 7427, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:31:14', 'admin-1488603664-1488605474076660', 1, 1, 'SR', NULL, NULL, NULL),
(22389, '2017-03-04 13:31:14', NULL, NULL, 7427, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:31:14', 'admin-1488603664-1488605474076660', 1, 0, '', NULL, NULL, NULL),
(22390, '2017-03-04 10:37:43', NULL, NULL, 7408, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:37:43', 'admin-1488593894-14885950634191884', 1, 0, '', NULL, NULL, NULL),
(22391, '2017-03-04 10:37:43', NULL, NULL, 7408, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:37:43', 'admin-1488593894-14885950634191884', 1, 1, 'SR', NULL, NULL, NULL),
(22392, '2017-03-04 10:37:43', NULL, NULL, 7408, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:37:43', 'admin-1488593894-14885950634191884', 1, 1, 'SR', NULL, NULL, NULL),
(22393, '2017-03-04 10:38:04', NULL, NULL, 7407, 0, 153, '87', 'Wake Me Up!', 'take away - no baked beans', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:38:04', 'admin-1488593894-14885950844776132', 1, 0, '', NULL, NULL, NULL),
(22394, '2017-03-04 10:44:42', NULL, NULL, 7409, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:44:43', 'admin-1488593894-14885954828347053', 1, 1, 'SR', 1, NULL, NULL),
(22395, '2017-03-04 10:49:54', NULL, NULL, 7407, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:49:54', 'admin-1488593894-14885957943198687', 1, 1, 'SR', NULL, NULL, NULL),
(22396, '2017-03-04 10:50:15', NULL, NULL, 7405, 0, 181, '116', 'Open Food ', 'Additional Nachos', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:50:15', 'admin-1488593894-14885958150491012', 1, 0, '', NULL, NULL, NULL),
(22397, '2017-03-04 10:59:41', NULL, NULL, 7410, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:59:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22398, '2017-03-04 11:00:18', NULL, NULL, 7410, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:00:18', 'admin-1488595909-14885964182435428', 1, 0, '', NULL, NULL, NULL),
(22399, '2017-03-04 11:00:18', NULL, NULL, 7410, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:00:18', 'admin-1488595909-14885964182435428', 1, 0, '', NULL, NULL, NULL),
(22400, '2017-03-04 11:00:35', NULL, NULL, 7410, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:00:35', 'admin-1488595909-14885964356478395', 1, 1, 'SR', NULL, NULL, NULL),
(22401, '2017-03-04 11:00:35', NULL, NULL, 7410, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:00:35', 'admin-1488595909-14885964356478395', 1, 1, 'SR', NULL, NULL, NULL),
(22402, '2017-03-04 11:11:50', NULL, NULL, 7411, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:11:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22403, '2017-03-04 11:12:17', NULL, NULL, 7411, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:12:17', 'admin-1488595909-14885971370616415', 1, 1, 'SR', NULL, NULL, NULL),
(22404, '2017-03-04 11:12:17', NULL, NULL, 7411, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:12:17', 'admin-1488595909-14885971370616415', 1, 1, 'SR', NULL, NULL, NULL),
(22405, '2017-03-04 11:12:17', NULL, NULL, 7411, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:12:17', 'admin-1488595909-14885971370616415', 1, 0, '', NULL, NULL, NULL),
(22406, '2017-03-04 09:21:34', NULL, NULL, 7400, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 09:21:34', 'admin-1488588848-14885904946282784', 1, 0, '', NULL, NULL, NULL),
(22407, '2017-03-04 09:21:45', NULL, NULL, 7400, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 09:21:45', 'admin-1488588848-14885905051518028', 1, 0, '', NULL, NULL, NULL),
(22408, '2017-03-04 09:18:42', NULL, NULL, 7400, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 09:18:42', 'admin-1488588848-14885903220412517', 1, 1, 'SR', NULL, NULL, NULL),
(22409, '2017-03-04 09:18:42', NULL, NULL, 7400, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 09:18:42', 'admin-1488588848-14885903220412517', 1, 1, 'SR', NULL, NULL, NULL),
(22410, '2017-03-04 09:18:42', NULL, NULL, 7400, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 09:18:42', 'admin-1488588848-14885903220412517', 1, 1, 'SR', NULL, NULL, NULL),
(22411, '2017-03-04 09:18:42', NULL, NULL, 7400, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 09:18:42', 'admin-1488588848-14885903220412517', 1, 1, 'SR', NULL, NULL, NULL),
(22412, '2017-03-04 09:21:45', NULL, NULL, 7400, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 09:21:45', 'admin-1488588848-14885905051518028', 1, 0, '', NULL, NULL, NULL),
(22413, '2017-03-04 09:31:47', NULL, NULL, 7401, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1488608002', 'admin', '2017-03-04 09:31:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22414, '2017-03-04 09:31:57', NULL, NULL, 7401, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 09:31:57', 'admin-1488588848-14885911176537120', 1, 0, '', NULL, NULL, NULL),
(22415, '2017-03-04 09:31:57', NULL, NULL, 7401, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 09:31:57', 'admin-1488588848-14885911176537120', 1, 0, '', NULL, NULL, NULL),
(22416, '2017-03-04 09:31:57', NULL, NULL, 7401, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 09:31:57', 'admin-1488588848-14885911176537120', 1, 0, '', NULL, NULL, NULL),
(22417, '2017-03-04 09:31:57', NULL, NULL, 7401, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 09:31:57', 'admin-1488588848-14885911176537120', 1, 1, 'SR', NULL, NULL, NULL),
(22418, '2017-03-04 09:32:01', NULL, NULL, 7402, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1488608002', 'admin', '2017-03-04 09:32:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22419, '2017-03-04 14:55:00', NULL, NULL, 7441, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:55:00', 'admin-1488608002-14886105004449182', 1, 0, '', NULL, NULL, NULL),
(22420, '2017-03-04 14:04:48', NULL, NULL, 7409, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 14:04:48', 'admin-1488603664-14886074880791842', 1, 0, '', 1, NULL, NULL),
(22421, '2017-03-04 13:47:24', NULL, NULL, 7428, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:47:24', 'admin-1488603664-14886064447721695', 1, 1, 'SR', NULL, NULL, NULL),
(22422, '2017-03-04 13:46:50', NULL, NULL, 7428, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:46:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22423, '2017-03-04 12:04:28', NULL, NULL, 7415, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:04:28', 'admin-1488599397-14886002681167073', 1, 1, 'SR', NULL, NULL, NULL),
(22424, '2017-03-04 12:21:39', NULL, NULL, 7418, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:21:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22425, '2017-03-04 12:21:54', NULL, NULL, 7418, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:21:54', 'admin-1488599397-14886013146659649', 1, 1, 'SR', NULL, NULL, NULL),
(22426, '2017-03-04 12:21:54', NULL, NULL, 7418, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:21:54', 'admin-1488599397-14886013146659649', 1, 1, 'SR', NULL, NULL, NULL),
(22427, '2017-03-04 12:29:19', NULL, NULL, 7418, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:29:19', 'admin-1488599397-14886017592103017', 1, 0, '', NULL, NULL, NULL),
(22428, '2017-03-04 12:40:57', NULL, NULL, 7419, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:40:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22429, '2017-03-04 12:41:28', NULL, NULL, 7419, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:41:28', 'admin-1488599397-14886024880452472', 1, 0, '', NULL, NULL, NULL),
(22430, '2017-03-04 12:41:28', NULL, NULL, 7419, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:41:28', 'admin-1488599397-14886024880452472', 1, 1, 'SR', NULL, NULL, NULL),
(22431, '2017-03-04 12:41:28', NULL, NULL, 7419, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:41:28', 'admin-1488599397-14886024880452472', 1, 1, 'SR', NULL, NULL, NULL),
(22432, '2017-03-04 12:41:28', NULL, NULL, 7419, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:41:28', 'admin-1488599397-14886024880452472', 1, 0, '', NULL, NULL, NULL),
(22433, '2017-03-04 12:45:35', NULL, NULL, 7420, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:45:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22434, '2017-03-04 12:45:52', NULL, NULL, 7420, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:45:52', 'admin-1488599397-14886027522169076', 1, 1, 'SR', NULL, NULL, NULL),
(22435, '2017-03-04 12:45:52', NULL, NULL, 7420, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:45:52', 'admin-1488599397-14886027522169076', 1, 1, 'SR', NULL, NULL, NULL),
(22436, '2017-03-04 12:45:52', NULL, NULL, 7420, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:45:52', 'admin-1488599397-14886027522169076', 1, 1, 'SR', NULL, NULL, NULL),
(22437, '2017-03-04 12:45:52', NULL, NULL, 7420, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:45:52', 'admin-1488599397-14886027522169076', 1, 0, '', NULL, NULL, NULL),
(22438, '2017-03-04 16:38:34', NULL, NULL, 7444, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 16:38:34', 'admin-1488608002-14886167146072575', 1, 0, '', NULL, NULL, NULL),
(22439, '2017-03-04 13:22:57', NULL, NULL, 7425, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:22:57', 'admin-1488603664-1488604977103589', 1, 1, 'SR', NULL, NULL, NULL),
(22440, '2017-03-04 13:22:52', NULL, NULL, 7425, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:22:52', 'admin-1488603664-14886049722495295', 1, 0, '', NULL, NULL, NULL),
(22441, '2017-03-04 13:08:39', NULL, NULL, 7419, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:08:39', 'admin-1488603664-1488604119031236', 1, 0, '', NULL, NULL, NULL),
(22442, '2017-03-04 12:55:10', NULL, NULL, 7422, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:55:10', 'admin-1488599397-14886033107013880', 1, 1, 'SR', NULL, NULL, NULL),
(22443, '2017-03-04 12:58:40', NULL, NULL, 7422, 0, 181, '116', 'Open Food ', 'cookies', 'Meals', 'Perfect Meals', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:58:40', 'admin-1488599397-1488603519927987', 1, 0, '', NULL, NULL, NULL),
(22444, '2017-03-04 12:55:10', NULL, NULL, 7422, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:55:10', 'admin-1488599397-14886033107013880', 1, 0, '', NULL, NULL, NULL),
(22445, '2017-03-04 13:23:16', NULL, NULL, 7426, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:23:16', 'admin-1488603664-14886049965606525', 1, 1, 'SR', NULL, NULL, NULL),
(22446, '2017-03-04 13:22:52', NULL, NULL, 7425, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:22:52', 'admin-1488603664-14886049722495295', 1, 0, '', NULL, NULL, NULL),
(22447, '2017-03-04 12:54:46', NULL, NULL, 7422, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.79, 0.0000, 0.0000, 5.79, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:54:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22448, '2017-03-04 11:38:02', NULL, NULL, 7416, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:38:02', 'admin-1488595909-1488598681934104', 1, 1, 'SR', NULL, NULL, NULL),
(22449, '2017-03-04 11:38:02', NULL, NULL, 7416, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:38:02', 'admin-1488595909-1488598681934104', 1, 0, '', NULL, NULL, NULL),
(22450, '2017-03-04 11:38:51', NULL, NULL, 7415, 0, 182, '117', 'Open Drinks ', 'banana', 'Cold Drinks', 'Fresh Juice', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:38:51', 'admin-1488595909-14885987315644070', 1, 0, '', NULL, NULL, NULL),
(22451, '2017-03-04 11:23:46', NULL, NULL, 7413, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:23:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22452, '2017-03-04 11:12:25', NULL, NULL, 7411, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:12:25', 'admin-1488595909-14885971449677958', 1, 0, '', NULL, NULL, NULL),
(22453, '2017-03-04 13:23:09', NULL, NULL, 7426, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:23:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22454, '2017-03-04 13:07:52', NULL, NULL, 7423, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:07:52', 'admin-1488603664-14886040718687712', 1, 0, '', NULL, NULL, NULL),
(22455, '2017-03-04 13:07:52', NULL, NULL, 7423, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:07:52', 'admin-1488603664-14886040718687712', 1, 0, '', NULL, NULL, NULL),
(22456, '2017-03-04 13:07:23', NULL, NULL, 7423, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1488608002', 'admin', '2017-03-04 13:07:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22457, '2017-03-04 12:46:15', NULL, NULL, 7421, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:46:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22458, '2017-03-04 12:49:27', NULL, NULL, 7420, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:49:27', 'admin-1488599397-14886029668681517', 1, 1, 'SR', NULL, NULL, NULL),
(22459, '2017-03-04 11:35:18', NULL, NULL, 7414, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:35:18', 'admin-1488595909-14885985181267060', 1, 1, 'SR', NULL, NULL, NULL),
(22460, '2017-03-04 12:48:10', NULL, NULL, 7421, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:48:10', 'admin-1488599397-148860289035745', 1, 1, 'SR', NULL, NULL, NULL),
(22461, '2017-03-04 12:48:10', NULL, NULL, 7421, 0, 182, '117', 'Open Drinks ', 'Iced Ginger lemongrass', 'Cold Drinks', 'Fresh Juice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:48:10', 'admin-1488599397-148860289035745', 1, 0, '', NULL, NULL, NULL),
(22462, '2017-03-04 12:46:22', NULL, NULL, 7421, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:46:22', 'admin-1488599397-14886027826576435', 1, 0, '', NULL, NULL, NULL),
(22463, '2017-03-04 12:48:10', NULL, NULL, 7421, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 4, 8.00, 32.0000, 0.0000, 32.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:48:10', 'admin-1488599397-148860289035745', 1, 0, '', NULL, NULL, NULL),
(22464, '2017-03-04 12:46:05', NULL, NULL, 7420, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:46:05', 'admin-1488599397-14886027654746328', 1, 1, 'SR', NULL, NULL, NULL),
(22465, '2017-03-04 12:46:05', NULL, NULL, 7420, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 12:46:05', 'admin-1488599397-14886027654746328', 1, 1, 'SR', NULL, NULL, NULL),
(22466, '2017-03-04 11:24:05', NULL, NULL, 7413, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:24:05', 'admin-1488595909-14885978456372158', 1, 0, '', NULL, NULL, NULL),
(22467, '2017-03-04 11:50:08', NULL, NULL, 7412, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:50:08', 'admin-1488599397-14885994079152965', 1, 1, 'SR', NULL, NULL, NULL),
(22468, '2017-03-04 11:44:30', NULL, NULL, 7417, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:44:30', 'admin-1488595909-14885990698229986', 1, 1, 'SR', 1, NULL, NULL),
(22469, '2017-03-04 11:37:42', NULL, NULL, 7416, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:37:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22470, '2017-03-04 11:36:20', NULL, NULL, 7415, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.55, 0.0000, 0.0000, 1.55, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:36:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22471, '2017-03-04 11:36:25', NULL, NULL, 7415, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:36:25', 'admin-1488595909-1488598585110441', 1, 1, 'SR', NULL, NULL, NULL),
(22472, '2017-03-04 11:34:55', NULL, NULL, 7414, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:34:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22473, '2017-03-04 11:35:18', NULL, NULL, 7414, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:35:18', 'admin-1488595909-14885985181267060', 1, 1, 'SR', NULL, NULL, NULL),
(22474, '2017-03-04 11:24:20', NULL, NULL, 7413, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:24:20', 'admin-1488595909-14885978599462842', 1, 1, 'SR', NULL, NULL, NULL),
(22475, '2017-03-04 11:16:04', NULL, NULL, 7412, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:16:04', 'admin-1488595909-14885973639808549', 1, 1, 'SR', NULL, NULL, NULL),
(22476, '2017-03-04 11:16:04', NULL, NULL, 7412, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:16:04', 'admin-1488595909-14885973639808549', 1, 0, '', NULL, NULL, NULL),
(22477, '2017-03-04 11:15:36', NULL, NULL, 7412, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1488608002', 'admin', '2017-03-04 11:15:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22478, '2017-03-04 10:32:30', NULL, NULL, 7407, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:32:30', 'admin-1488593894-1488594749912351', 1, 0, '', NULL, NULL, NULL),
(22479, '2017-03-04 10:32:30', NULL, NULL, 7407, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:32:30', 'admin-1488593894-1488594749912351', 1, 0, '', NULL, NULL, NULL),
(22480, '2017-03-04 10:32:30', NULL, NULL, 7407, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:32:30', 'admin-1488593894-1488594749912351', 1, 0, '', NULL, NULL, NULL),
(22481, '2017-03-04 10:32:30', NULL, NULL, 7407, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:32:30', 'admin-1488593894-1488594749912351', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(22482, '2017-03-04 10:32:30', NULL, NULL, 7407, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:32:30', 'admin-1488593894-1488594749912351', 1, 1, 'SR', NULL, NULL, NULL),
(22483, '2017-03-04 10:37:33', NULL, NULL, 7408, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:37:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22484, '2017-03-04 10:37:43', NULL, NULL, 7408, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:37:43', 'admin-1488593894-14885950634191884', 1, 0, '', NULL, NULL, NULL),
(22485, '2017-03-04 10:05:24', NULL, NULL, 7403, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:05:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22486, '2017-03-04 10:05:42', NULL, NULL, 7403, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:05:42', 'admin-1488588848-14885931421965199', 1, 1, 'SR', NULL, NULL, NULL),
(22487, '2017-03-04 10:05:42', NULL, NULL, 7403, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:05:42', 'admin-1488588848-14885931421965199', 1, 0, '', NULL, NULL, NULL),
(22488, '2017-03-04 10:05:42', NULL, NULL, 7403, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:05:42', 'admin-1488588848-14885931421965199', 1, 0, '', NULL, NULL, NULL),
(22489, '2017-03-04 10:12:10', NULL, NULL, 7400, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:12:10', 'admin-1488588848-14885935305712695', 1, 0, '', NULL, NULL, NULL),
(22490, '2017-03-04 10:12:10', NULL, NULL, 7400, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:12:10', 'admin-1488588848-14885935305712695', 1, 1, 'SR', NULL, NULL, NULL),
(22491, '2017-03-04 10:18:21', NULL, NULL, 7404, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:18:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22492, '2017-03-04 10:18:30', NULL, NULL, 7404, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:18:30', 'admin-1488593894-1488593910007812', 1, 0, '', NULL, NULL, NULL),
(22493, '2017-03-04 10:18:30', NULL, NULL, 7404, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:18:30', 'admin-1488593894-1488593910007812', 1, 0, '', NULL, NULL, NULL),
(22494, '2017-03-04 10:18:35', NULL, NULL, 7404, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:18:35', 'admin-1488593894-14885939153541970', 1, 1, 'SR', NULL, NULL, NULL),
(22495, '2017-03-04 10:18:35', NULL, NULL, 7404, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:18:35', 'admin-1488593894-14885939153541970', 1, 1, 'SR', NULL, NULL, NULL),
(22496, '2017-03-04 10:29:18', NULL, NULL, 7405, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:29:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22497, '2017-03-04 10:29:32', NULL, NULL, 7405, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:29:32', 'admin-1488593894-14885945718095352', 1, 0, '', NULL, NULL, NULL),
(22498, '2017-03-04 10:29:32', NULL, NULL, 7405, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:29:32', 'admin-1488593894-14885945718095352', 1, 0, '', NULL, NULL, NULL),
(22499, '2017-03-04 10:29:41', NULL, NULL, 7405, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:29:41', 'admin-1488593894-1488594581496244', 1, 1, 'SR', NULL, NULL, NULL),
(22500, '2017-03-04 10:30:00', NULL, NULL, 7406, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:30:00', 'admin-1488593894-14885946001668347', 1, 1, 'SR', 1, NULL, NULL),
(22501, '2017-03-04 10:32:17', NULL, NULL, 7407, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1488608002', 'admin', '2017-03-04 10:32:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22502, '2017-03-04 09:32:53', NULL, NULL, 7402, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 09:32:53', 'admin-1488588848-14885911733751220', 1, 1, 'SR', NULL, NULL, NULL),
(22503, '2017-03-04 09:32:53', NULL, NULL, 7402, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 09:32:53', 'admin-1488588848-14885911733751220', 1, 0, '', NULL, NULL, NULL),
(22504, '2017-03-04 09:32:09', NULL, NULL, 7402, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 09:32:09', 'admin-1488588848-14885911293583445', 1, 0, '', NULL, NULL, NULL),
(22505, '2017-03-04 09:32:09', NULL, NULL, 7402, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 09:32:09', 'admin-1488588848-14885911293583445', 1, 0, '', NULL, NULL, NULL),
(22506, '2017-03-04 09:18:15', NULL, NULL, 7400, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 09:18:15', 'admin-1488588848-14885902954407762', 1, 0, '', NULL, NULL, NULL),
(22507, '2017-03-04 09:18:15', NULL, NULL, 7400, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 09:18:15', 'admin-1488588848-14885902954407762', 1, 0, '', NULL, NULL, NULL),
(22508, '2017-03-04 09:17:59', NULL, NULL, 7400, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.80, 0.0000, 0.0000, 15.80, 1, '27', 1, '1488608002', 'admin', '2017-03-04 09:17:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22509, '2017-03-04 09:18:15', NULL, NULL, 7400, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 09:18:15', 'admin-1488588848-14885902954407762', 1, 0, '', NULL, NULL, NULL),
(22510, '2017-03-04 08:54:23', NULL, NULL, 7399, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488608002', 'admin', '2017-03-04 08:54:23', 'admin-1488588848-14885888635942922', 1, 1, 'SR', 1, NULL, NULL),
(22511, '2017-03-05 17:00:21', NULL, NULL, 7504, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 17:00:21', 'admin-1488702266-14887044217475679', 1, 0, '', NULL, NULL, NULL),
(22512, '2017-03-05 16:53:48', NULL, NULL, 7504, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 16:53:48', 'admin-1488702266-14887040280347230', 1, 0, '', NULL, NULL, NULL),
(22513, '2017-03-05 16:30:20', NULL, NULL, 7502, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1488702266', 'admin', '2017-03-05 16:30:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22514, '2017-03-05 16:30:01', NULL, NULL, 7501, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 16:30:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22515, '2017-03-05 00:00:00', NULL, NULL, 7501, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 15:48:31', 'admin-1488692103-14887001116496172', 1, 0, '', NULL, NULL, NULL),
(22516, '2017-03-05 15:56:43', NULL, NULL, 7494, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 15:56:43', 'admin-1488692103-1488700603384995', 1, 0, '', NULL, NULL, NULL),
(22517, '2017-03-05 15:58:59', NULL, NULL, 7500, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1488702266', 'admin', '2017-03-05 15:58:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22518, '2017-03-05 15:59:21', NULL, NULL, 7500, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 15:59:21', 'admin-1488692103-14887007615272767', 1, 0, '', NULL, NULL, NULL),
(22519, '2017-03-05 15:59:21', NULL, NULL, 7500, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 15:59:21', 'admin-1488692103-14887007615272767', 1, 0, '', NULL, NULL, NULL),
(22520, '2017-03-05 16:00:04', NULL, NULL, 7500, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 16:00:04', 'admin-1488692103-1488700804545969', 1, 1, 'SR', NULL, NULL, NULL),
(22521, '2017-03-05 16:00:04', NULL, NULL, 7500, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 16:00:04', 'admin-1488692103-1488700804545969', 1, 1, 'SR', NULL, NULL, NULL),
(22522, '2017-03-05 16:00:04', NULL, NULL, 7500, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 16:00:04', 'admin-1488692103-1488700804545969', 1, 1, 'SR', NULL, NULL, NULL),
(22523, '2017-03-05 00:00:00', NULL, NULL, 7501, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 15:55:06', 'admin-1488692103-14887005057791113', 1, 0, '', NULL, NULL, NULL),
(22524, '2017-03-05 00:00:00', NULL, NULL, 7502, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 15:48:31', 'admin-1488692103-14887001116496172', 1, 1, 'SR', NULL, NULL, NULL),
(22525, '2017-03-05 16:31:16', NULL, NULL, 7503, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1488702266', 'admin', '2017-03-05 16:31:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22526, '2017-03-05 16:31:20', NULL, NULL, 7503, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 16:31:20', 'admin-1488702266-1488702680515647', 1, 0, '', NULL, NULL, NULL),
(22527, '2017-03-05 16:53:02', NULL, NULL, 7504, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1488702266', 'admin', '2017-03-05 16:53:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22528, '2017-03-05 16:53:48', NULL, NULL, 7504, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 16:53:48', 'admin-1488702266-14887040280347230', 1, 0, '', NULL, NULL, NULL),
(22529, '2017-03-05 16:53:48', NULL, NULL, 7504, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 16:53:48', 'admin-1488702266-14887040280347230', 1, 0, '', NULL, NULL, NULL),
(22530, '2017-03-05 16:53:48', NULL, NULL, 7504, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 16:53:48', 'admin-1488702266-14887040280347230', 1, 0, '', NULL, NULL, NULL),
(22531, '2017-03-05 16:53:48', NULL, NULL, 7504, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 16:53:48', 'admin-1488702266-14887040280347230', 1, 1, 'SR', NULL, NULL, NULL),
(22532, '2017-03-05 13:20:58', NULL, NULL, 7491, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 13:20:58', 'admin-1488687133-14886912584928872', 1, 1, 'SR', NULL, NULL, NULL),
(22533, '2017-03-05 13:20:58', NULL, NULL, 7491, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 13:20:58', 'admin-1488687133-14886912584928872', 1, 0, '', NULL, NULL, NULL),
(22534, '2017-03-05 13:28:24', NULL, NULL, 7491, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 13:28:24', 'admin-1488687133-1488691704413832', 1, 0, '', NULL, NULL, NULL),
(22535, '2017-03-05 14:57:55', NULL, NULL, 7499, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:57:55', 'admin-1488692103-14886970753112758', 1, 1, 'SR', NULL, NULL, NULL),
(22536, '2017-03-05 13:39:50', NULL, NULL, 7491, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 13:39:50', 'admin-1488692103-14886923906313572', 1, 0, '', NULL, NULL, NULL),
(22537, '2017-03-05 11:58:10', NULL, NULL, 7480, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:58:10', 'admin-1488685968-14886862906245531', 1, 0, '', NULL, NULL, NULL),
(22538, '2017-03-05 11:58:10', NULL, NULL, 7480, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:58:10', 'admin-1488685968-14886862906245531', 1, 0, '', NULL, NULL, NULL),
(22539, '2017-03-05 11:46:48', NULL, NULL, 7479, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:46:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22540, '2017-03-05 11:46:55', NULL, NULL, 7479, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:46:55', 'admin-1488683386-148868561490793', 1, 1, 'SR', NULL, NULL, NULL),
(22541, '2017-03-05 11:46:55', NULL, NULL, 7479, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:46:55', 'admin-1488683386-148868561490793', 1, 1, 'SR', NULL, NULL, NULL),
(22542, '2017-03-05 14:57:55', NULL, NULL, 7499, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:57:55', 'admin-1488692103-14886970753112758', 1, 1, 'SR', NULL, NULL, NULL),
(22543, '2017-03-05 10:46:33', NULL, NULL, 7466, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:46:33', 'admin-1488680401-14886819937154061', 1, 1, 'SR', NULL, NULL, NULL),
(22544, '2017-03-05 14:57:55', NULL, NULL, 7499, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:57:55', 'admin-1488692103-14886970753112758', 1, 1, 'SR', NULL, NULL, NULL),
(22545, '2017-03-05 14:57:55', NULL, NULL, 7499, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:57:55', 'admin-1488692103-14886970753112758', 1, 0, '', NULL, NULL, NULL),
(22546, '2017-03-05 13:29:30', NULL, NULL, 7492, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 13:29:30', 'admin-1488687133-14886917703888836', 1, 0, '', NULL, NULL, NULL),
(22547, '2017-03-05 13:31:44', NULL, NULL, 7480, 0, 70, '70', 'Pepper Pork', 'Takeaway', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 13:31:44', 'admin-1488687133-14886919046934997', 1, 1, 'SR', NULL, NULL, NULL),
(22548, '2017-03-05 13:35:22', NULL, NULL, 7491, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 13:35:22', 'admin-1488692103-14886921220622320', 1, 1, 'SR', NULL, NULL, NULL),
(22549, '2017-03-05 13:40:11', NULL, NULL, 7493, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1488702266', 'admin', '2017-03-05 13:40:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22550, '2017-03-05 13:40:26', NULL, NULL, 7493, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 13:40:26', 'admin-1488692103-1488692425954421', 1, 1, 'SR', NULL, NULL, NULL),
(22551, '2017-03-05 13:45:06', NULL, NULL, 7493, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 13:45:06', 'admin-1488692103-14886927065466748', 1, 1, 'SR', NULL, NULL, NULL),
(22552, '2017-03-05 13:45:06', NULL, NULL, 7493, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 13:45:06', 'admin-1488692103-14886927065466748', 1, 0, '', NULL, NULL, NULL),
(22553, '2017-03-05 13:40:26', NULL, NULL, 7493, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 13:40:26', 'admin-1488692103-1488692425954421', 1, 1, 'SR', NULL, NULL, NULL),
(22554, '2017-03-05 14:39:43', NULL, NULL, 7497, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:39:43', 'admin-1488692103-1488695983733999', 1, 1, 'SR', NULL, NULL, NULL),
(22555, '2017-03-05 14:05:30', NULL, NULL, 7491, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:05:30', 'admin-1488692103-14886939302439888', 1, 0, '', NULL, NULL, NULL),
(22556, '2017-03-05 14:19:06', NULL, NULL, 7494, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:19:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22557, '2017-03-05 14:19:51', NULL, NULL, 7494, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:19:51', 'admin-1488692103-14886947911771884', 1, 0, '', NULL, NULL, NULL),
(22558, '2017-03-05 14:19:51', NULL, NULL, 7494, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:19:51', 'admin-1488692103-14886947911771884', 1, 1, 'SR', NULL, NULL, NULL),
(22559, '2017-03-05 14:19:51', NULL, NULL, 7494, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:19:51', 'admin-1488692103-14886947911771884', 1, 1, 'SR', NULL, NULL, NULL),
(22560, '2017-03-05 14:22:14', NULL, NULL, 7495, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:22:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22561, '2017-03-05 14:22:31', NULL, NULL, 7495, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:22:31', 'admin-1488692103-1488694951301467', 1, 0, '', NULL, NULL, NULL),
(22562, '2017-03-05 14:22:31', NULL, NULL, 7495, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:22:31', 'admin-1488692103-1488694951301467', 1, 0, '', NULL, NULL, NULL),
(22563, '2017-03-05 13:28:47', NULL, NULL, 7481, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 13:28:47', 'admin-1488687133-14886917267996263', 1, 0, '', 1, NULL, NULL),
(22564, '2017-03-05 13:29:23', NULL, NULL, 7492, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1488702266', 'admin', '2017-03-05 13:29:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22565, '2017-03-05 13:29:30', NULL, NULL, 7492, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 13:29:30', 'admin-1488687133-14886917703888836', 1, 1, 'SR', NULL, NULL, NULL),
(22566, '2017-03-05 12:43:39', NULL, NULL, 7487, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:43:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22567, '2017-03-05 12:43:42', NULL, NULL, 7487, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:43:42', 'admin-1488687133-14886890222777623', 1, 1, 'SR', NULL, NULL, NULL),
(22568, '2017-03-05 12:51:34', NULL, NULL, 7488, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:51:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22569, '2017-03-05 12:51:42', NULL, NULL, 7488, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:51:42', 'admin-1488687133-14886895022967274', 1, 0, '', NULL, NULL, NULL),
(22570, '2017-03-05 12:51:42', NULL, NULL, 7488, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:51:42', 'admin-1488687133-14886895022967274', 1, 0, '', NULL, NULL, NULL),
(22571, '2017-03-05 12:51:48', NULL, NULL, 7488, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:51:48', 'admin-1488687133-14886895083788614', 1, 1, 'SR', NULL, NULL, NULL),
(22572, '2017-03-05 12:51:48', NULL, NULL, 7488, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:51:48', 'admin-1488687133-14886895083788614', 1, 1, 'SR', NULL, NULL, NULL),
(22573, '2017-03-05 12:52:37', NULL, NULL, 7489, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:52:37', 'admin-1488687133-14886895567999754', 1, 1, 'SR', 1, NULL, NULL),
(22574, '2017-03-05 12:52:37', NULL, NULL, 7489, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:52:37', 'admin-1488687133-14886895567999754', 1, 1, 'SR', 1, NULL, NULL),
(22575, '2017-03-05 15:22:11', NULL, NULL, 7497, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 15:22:11', 'admin-1488692103-14886985313351157', 1, 0, '', NULL, NULL, NULL),
(22576, '2017-03-05 14:57:55', NULL, NULL, 7499, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:57:55', 'admin-1488692103-14886970753112758', 1, 1, 'SR', NULL, NULL, NULL),
(22577, '2017-03-05 15:05:54', NULL, NULL, 7496, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 15:05:54', 'admin-1488692103-14886975541533682', 1, 0, '', NULL, NULL, NULL),
(22578, '2017-03-05 15:05:54', NULL, NULL, 7496, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 15:05:54', 'admin-1488692103-14886975541533682', 1, 0, '', NULL, NULL, NULL),
(22579, '2017-03-05 15:15:08', NULL, NULL, 7499, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 15:15:08', 'admin-1488692103-1488698107882754', 1, 0, '', NULL, NULL, NULL),
(22580, '2017-03-05 14:57:11', NULL, NULL, 7499, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.20, 0.0000, 0.0000, 9.20, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:57:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22581, '2017-03-05 12:26:17', NULL, NULL, 7484, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:26:17', 'admin-1488687133-14886879771291579', 1, 0, '', NULL, NULL, NULL),
(22582, '2017-03-05 14:22:31', NULL, NULL, 7495, 0, 269, '203', 'ESPRESSO CON PANNA', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:22:31', 'admin-1488692103-1488694951301467', 1, 0, '', NULL, NULL, NULL),
(22583, '2017-03-05 10:45:58', NULL, NULL, 7465, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:45:58', 'admin-1488680401-1488681958080682', 1, 1, 'SR', NULL, NULL, NULL),
(22584, '2017-03-05 00:00:00', NULL, NULL, 7467, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 4.00, NULL, NULL, 4.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:47:53', 'admin-1488678420-14886784729504373', 1, 0, '', NULL, NULL, NULL),
(22585, '2017-03-05 10:14:44', NULL, NULL, 7460, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:14:44', 'admin-1488678420-1488680084690317', 1, 0, '', NULL, NULL, NULL),
(22586, '2017-03-05 10:14:44', NULL, NULL, 7460, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:14:44', 'admin-1488678420-1488680084690317', 1, 0, '', NULL, NULL, NULL),
(22587, '2017-03-05 10:14:44', NULL, NULL, 7460, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:14:44', 'admin-1488678420-1488680084690317', 1, 1, 'SR', NULL, NULL, NULL),
(22588, '2017-03-05 15:06:40', NULL, NULL, 7496, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 15:06:40', 'admin-1488692103-14886976002153937', 1, 1, 'SR', NULL, NULL, NULL),
(22589, '2017-03-05 15:06:40', NULL, NULL, 7496, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 15:06:40', 'admin-1488692103-14886976002153937', 1, 1, 'SR', NULL, NULL, NULL),
(22590, '2017-03-05 14:57:55', NULL, NULL, 7499, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:57:55', 'admin-1488692103-14886970753112758', 1, 0, '', NULL, NULL, NULL),
(22591, '2017-03-05 14:45:18', NULL, NULL, 7492, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:45:18', 'admin-1488692103-14886963184164065', 1, 1, 'SR', NULL, NULL, NULL),
(22592, '2017-03-05 14:22:31', NULL, NULL, 7495, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:22:31', 'admin-1488692103-1488694951301467', 1, 1, 'SR', NULL, NULL, NULL),
(22593, '2017-03-05 14:23:10', NULL, NULL, 7494, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:23:10', 'admin-1488692103-1488694990104834', 1, 0, '', NULL, NULL, NULL),
(22594, '2017-03-05 14:39:43', NULL, NULL, 7497, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:39:43', 'admin-1488692103-1488695983733999', 1, 1, 'SR', NULL, NULL, NULL),
(22595, '2017-03-05 14:41:38', NULL, NULL, 7498, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:41:38', 'admin-1488692103-14886960984861631', 1, 0, '', NULL, NULL, NULL),
(22596, '2017-03-05 14:44:52', NULL, NULL, 7492, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:44:52', 'admin-1488692103-14886962925576994', 1, 1, 'SR', NULL, NULL, NULL),
(22597, '2017-03-05 14:57:55', NULL, NULL, 7499, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:57:55', 'admin-1488692103-14886970753112758', 1, 0, '', NULL, NULL, NULL),
(22598, '2017-03-05 13:28:47', NULL, NULL, 7481, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 13:28:47', 'admin-1488687133-14886917267996263', 1, 0, '', 1, NULL, NULL),
(22599, '2017-03-05 11:58:46', NULL, NULL, 7480, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:58:46', 'admin-1488685968-14886863266945926', 1, 0, '', NULL, NULL, NULL),
(22600, '2017-03-05 11:58:46', NULL, NULL, 7480, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:58:46', 'admin-1488685968-14886863266945926', 1, 0, '', NULL, NULL, NULL),
(22601, '2017-03-05 12:10:57', NULL, NULL, 7480, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:10:57', 'admin-1488685968-14886870572599921', 1, 0, '', NULL, NULL, NULL),
(22602, '2017-03-05 11:58:47', NULL, NULL, 7480, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:58:47', 'admin-1488685968-14886863266945926', 1, 0, '', NULL, NULL, NULL),
(22603, '2017-03-05 11:58:55', NULL, NULL, 7481, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:58:55', 'admin-1488685968-14886863355664233', 1, 1, 'SR', 1, NULL, NULL),
(22604, '2017-03-05 12:11:33', NULL, NULL, 7482, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:11:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22605, '2017-03-05 12:11:42', NULL, NULL, 7482, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:11:42', 'admin-1488685968-14886871020696551', 1, 0, '', NULL, NULL, NULL),
(22606, '2017-03-05 12:11:42', NULL, NULL, 7482, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:11:42', 'admin-1488685968-14886871020696551', 1, 0, '', NULL, NULL, NULL),
(22607, '2017-03-05 12:11:42', NULL, NULL, 7482, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:11:42', 'admin-1488685968-14886871020696551', 1, 1, 'SR', NULL, NULL, NULL),
(22608, '2017-03-05 12:11:46', NULL, NULL, 7483, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:11:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22609, '2017-03-05 12:12:00', NULL, NULL, 7483, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:12:00', 'admin-1488685968-14886871206626892', 1, 0, '', NULL, NULL, NULL),
(22610, '2017-03-05 14:39:43', NULL, NULL, 7497, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:39:43', 'admin-1488692103-1488695983733999', 1, 0, '', NULL, NULL, NULL),
(22611, '2017-03-05 14:39:43', NULL, NULL, 7497, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:39:43', 'admin-1488692103-1488695983733999', 1, 0, '', NULL, NULL, NULL),
(22612, '2017-03-05 11:03:27', NULL, NULL, 7471, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:03:27', 'admin-1488680401-14886830073086635', 1, 1, 'SR', NULL, NULL, NULL),
(22613, '2017-03-05 11:06:38', NULL, NULL, 7472, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:06:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22614, '2017-03-05 11:06:51', NULL, NULL, 7472, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:06:51', 'admin-1488680401-14886832115993442', 1, 1, 'SR', NULL, NULL, NULL),
(22615, '2017-03-05 12:28:36', NULL, NULL, 7485, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:28:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22616, '2017-03-05 11:06:51', NULL, NULL, 7472, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:06:51', 'admin-1488680401-14886832115993442', 1, 0, '', NULL, NULL, NULL),
(22617, '2017-03-05 11:06:51', NULL, NULL, 7472, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:06:51', 'admin-1488680401-14886832115993442', 1, 0, '', NULL, NULL, NULL),
(22618, '2017-03-05 11:07:23', NULL, NULL, 7473, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:07:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22619, '2017-03-05 11:07:34', NULL, NULL, 7473, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:07:34', 'admin-1488680401-1488683254784949', 1, 0, '', NULL, NULL, NULL),
(22620, '2017-03-05 10:45:58', NULL, NULL, 7465, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:45:58', 'admin-1488680401-1488681958080682', 1, 0, '', NULL, NULL, NULL),
(22621, '2017-03-05 13:20:45', NULL, NULL, 7491, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.10, 0.0000, 0.0000, 10.10, 1, '27', 1, '1488702266', 'admin', '2017-03-05 13:20:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22622, '2017-03-05 13:28:24', NULL, NULL, 7491, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 13:28:24', 'admin-1488687133-1488691704413832', 1, 1, 'SR', NULL, NULL, NULL),
(22623, '2017-03-05 13:28:32', NULL, NULL, 7491, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 13:28:32', 'admin-1488687133-14886917119594374', 1, 1, 'SR', NULL, NULL, NULL),
(22624, '2017-03-05 14:41:03', NULL, NULL, 7496, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:41:03', 'admin-1488692103-14886960629012857', 1, 1, 'SR', NULL, NULL, NULL),
(22625, '2017-03-05 14:41:34', NULL, NULL, 7498, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:41:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22626, '2017-03-05 14:39:02', NULL, NULL, 7496, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:39:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22627, '2017-03-05 14:39:19', NULL, NULL, 7496, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:39:19', 'admin-1488692103-14886959589269567', 1, 0, '', NULL, NULL, NULL),
(22628, '2017-03-05 15:43:55', NULL, NULL, 7498, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 15:43:55', 'admin-1488692103-14886998352252335', 1, 1, 'SR', NULL, NULL, NULL),
(22629, '2017-03-05 14:39:23', NULL, NULL, 7497, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 14:39:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22630, '2017-03-05 00:00:00', NULL, NULL, 7485, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:05:39', 'admin-1488680401-14886831393934511', 1, 1, 'SR', NULL, NULL, NULL),
(22631, '2017-03-05 12:26:17', NULL, NULL, 7484, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:26:17', 'admin-1488687133-14886879771291579', 1, 0, '', NULL, NULL, NULL),
(22632, '2017-03-05 12:34:42', NULL, NULL, 7486, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:34:42', 'admin-1488687133-1488688482129779', 1, 0, '', 1, NULL, NULL),
(22633, '2017-03-05 12:34:42', NULL, NULL, 7486, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:34:42', 'admin-1488687133-1488688482129779', 1, 0, '', 1, NULL, NULL),
(22634, '2017-03-05 11:26:26', NULL, NULL, 7476, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:26:26', 'admin-1488683386-14886843860266659', 1, 1, 'SR', 1, NULL, NULL),
(22635, '2017-03-05 11:36:35', NULL, NULL, 7477, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:36:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22636, '2017-03-05 09:48:12', NULL, NULL, 7455, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:48:12', 'admin-1488678420-14886784921552620', 1, 1, 'SR', NULL, NULL, NULL),
(22637, '2017-03-05 12:26:17', NULL, NULL, 7484, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:26:17', 'admin-1488687133-14886879771291579', 1, 0, '', NULL, NULL, NULL),
(22638, '2017-03-05 12:26:17', NULL, NULL, 7484, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:26:17', 'admin-1488687133-14886879771291579', 1, 0, '', NULL, NULL, NULL),
(22639, '2017-03-05 12:26:08', NULL, NULL, 7484, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:26:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22640, '2017-03-05 12:12:00', NULL, NULL, 7483, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:12:00', 'admin-1488685968-14886871206626892', 1, 0, '', NULL, NULL, NULL),
(22641, '2017-03-05 12:12:00', NULL, NULL, 7483, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:12:00', 'admin-1488685968-14886871206626892', 1, 1, 'SR', NULL, NULL, NULL),
(22642, '2017-03-05 09:48:12', NULL, NULL, 7455, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:48:12', 'admin-1488678420-14886784921552620', 1, 1, 'SR', NULL, NULL, NULL),
(22643, '2017-03-05 11:00:32', NULL, NULL, 7469, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:00:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22644, '2017-03-05 11:00:39', NULL, NULL, 7469, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:00:39', 'admin-1488680401-1488682839412959', 1, 1, 'SR', NULL, NULL, NULL),
(22645, '2017-03-05 11:02:46', NULL, NULL, 7470, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:02:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22646, '2017-03-05 11:02:54', NULL, NULL, 7470, 0, 269, '203', 'ESPRESSO CON PANNA', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:02:54', 'admin-1488680401-14886829740048681', 1, 0, '', NULL, NULL, NULL),
(22647, '2017-03-05 11:02:54', NULL, NULL, 7470, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:02:54', 'admin-1488680401-14886829740048681', 1, 0, '', NULL, NULL, NULL),
(22648, '2017-03-05 11:02:54', NULL, NULL, 7470, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:02:54', 'admin-1488680401-14886829740048681', 1, 1, 'SR', NULL, NULL, NULL),
(22649, '2017-03-05 11:03:06', NULL, NULL, 7471, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:03:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22650, '2017-03-05 11:03:27', NULL, NULL, 7471, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:03:27', 'admin-1488680401-14886830073086635', 1, 1, 'SR', NULL, NULL, NULL),
(22651, '2017-03-05 09:48:25', NULL, NULL, 7454, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:48:25', 'admin-1488678420-14886785049735843', 1, 1, 'SR', NULL, NULL, NULL),
(22652, '2017-03-05 09:48:25', NULL, NULL, 7454, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:48:25', 'admin-1488678420-14886785049735843', 1, 0, '', NULL, NULL, NULL),
(22653, '2017-03-05 10:34:22', NULL, NULL, 7461, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:34:22', 'admin-1488680401-1488681262734662', 1, 0, '', NULL, NULL, NULL),
(22654, '2017-03-05 10:34:22', NULL, NULL, 7461, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:34:22', 'admin-1488680401-1488681262734662', 1, 0, '', NULL, NULL, NULL),
(22655, '2017-03-05 10:34:22', NULL, NULL, 7461, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:34:22', 'admin-1488680401-1488681262734662', 1, 0, '', NULL, NULL, NULL),
(22656, '2017-03-05 10:34:22', NULL, NULL, 7461, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:34:22', 'admin-1488680401-1488681262734662', 1, 1, 'SR', NULL, NULL, NULL),
(22657, '2017-03-05 10:35:06', NULL, NULL, 7462, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:35:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22658, '2017-03-05 10:35:19', NULL, NULL, 7462, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:35:19', 'admin-1488680401-14886813187719219', 1, 1, 'SR', NULL, NULL, NULL),
(22659, '2017-03-05 10:35:19', NULL, NULL, 7462, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:35:19', 'admin-1488680401-14886813187719219', 1, 1, 'SR', NULL, NULL, NULL),
(22660, '2017-03-05 10:35:19', NULL, NULL, 7462, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:35:19', 'admin-1488680401-14886813187719219', 1, 0, '', NULL, NULL, NULL),
(22661, '2017-03-05 10:35:19', NULL, NULL, 7462, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:35:19', 'admin-1488680401-14886813187719219', 1, 0, '', NULL, NULL, NULL),
(22662, '2017-03-05 12:12:00', NULL, NULL, 7483, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:12:00', 'admin-1488685968-14886871206626892', 1, 0, '', NULL, NULL, NULL),
(22663, '2017-03-05 12:12:00', NULL, NULL, 7483, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:12:00', 'admin-1488685968-14886871206626892', 1, 0, '', NULL, NULL, NULL),
(22664, '2017-03-05 12:05:06', NULL, NULL, 7480, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 12:05:06', 'admin-1488685968-1488686706191234', 1, 0, '', NULL, NULL, NULL),
(22665, '2017-03-05 11:58:10', NULL, NULL, 7480, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:58:10', 'admin-1488685968-14886862906245531', 1, 0, '', NULL, NULL, NULL),
(22666, '2017-03-05 11:53:10', NULL, NULL, 7465, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:53:10', 'admin-1488685968-14886859905788878', 1, 0, '', NULL, NULL, NULL),
(22667, '2017-03-05 10:01:10', NULL, NULL, 7456, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:01:10', 'admin-1488678420-14886792704932822', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(22668, '2017-03-05 10:06:06', NULL, NULL, 7457, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:06:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22669, '2017-03-05 10:06:17', NULL, NULL, 7457, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:06:17', 'admin-1488678420-14886795777683051', 1, 0, '', NULL, NULL, NULL),
(22670, '2017-03-05 10:06:17', NULL, NULL, 7457, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:06:17', 'admin-1488678420-14886795777683051', 1, 0, '', NULL, NULL, NULL),
(22671, '2017-03-05 10:06:18', NULL, NULL, 7457, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:06:18', 'admin-1488678420-14886795777683051', 1, 1, 'SR', NULL, NULL, NULL),
(22672, '2017-03-05 10:09:53', NULL, NULL, 7458, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:09:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22673, '2017-03-05 10:10:02', NULL, NULL, 7458, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:10:02', 'admin-1488678420-14886798021375868', 1, 0, '', NULL, NULL, NULL),
(22674, '2017-03-05 10:10:02', NULL, NULL, 7458, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:10:02', 'admin-1488678420-14886798021375868', 1, 0, '', NULL, NULL, NULL),
(22675, '2017-03-05 10:10:02', NULL, NULL, 7458, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:10:02', 'admin-1488678420-14886798021375868', 1, 1, 'SR', NULL, NULL, NULL),
(22676, '2017-03-05 10:10:02', NULL, NULL, 7458, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:10:02', 'admin-1488678420-14886798021375868', 1, 1, 'SR', NULL, NULL, NULL),
(22677, '2017-03-05 10:12:06', NULL, NULL, 7459, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 19.10, 0.0000, 0.0000, 19.10, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:12:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22678, '2017-03-05 10:12:16', NULL, NULL, 7459, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:12:16', 'admin-1488678420-1488679936374528', 1, 0, '', NULL, NULL, NULL),
(22679, '2017-03-05 10:12:16', NULL, NULL, 7459, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:12:16', 'admin-1488678420-1488679936374528', 1, 0, '', NULL, NULL, NULL),
(22680, '2017-03-05 10:12:16', NULL, NULL, 7459, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:12:16', 'admin-1488678420-1488679936374528', 1, 1, 'SR', NULL, NULL, NULL),
(22681, '2017-03-05 10:14:15', NULL, NULL, 7460, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:14:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22682, '2017-03-05 11:41:36', NULL, NULL, 7478, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:41:36', 'admin-1488683386-14886852965864866', 1, 0, '', NULL, NULL, NULL),
(22683, '2017-03-05 11:37:00', NULL, NULL, 7477, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:37:00', 'admin-1488683386-14886850201475781', 1, 0, '', NULL, NULL, NULL),
(22684, '2017-03-05 11:18:13', NULL, NULL, 7470, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:18:13', 'admin-1488683386-1488683893568425', 1, 0, '', NULL, NULL, NULL),
(22685, '2017-03-05 11:41:36', NULL, NULL, 7478, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:41:36', 'admin-1488683386-14886852965864866', 1, 0, '', NULL, NULL, NULL),
(22686, '2017-03-05 11:37:00', NULL, NULL, 7477, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:37:00', 'admin-1488683386-14886850201475781', 1, 0, '', NULL, NULL, NULL),
(22687, '2017-03-05 11:37:00', NULL, NULL, 7477, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:37:00', 'admin-1488683386-14886850201475781', 1, 0, '', NULL, NULL, NULL),
(22688, '2017-03-05 11:07:34', NULL, NULL, 7473, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:07:34', 'admin-1488680401-1488683254784949', 1, 1, 'SR', NULL, NULL, NULL),
(22689, '2017-03-05 10:45:58', NULL, NULL, 7465, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:45:58', 'admin-1488680401-1488681958080682', 1, 1, 'SR', NULL, NULL, NULL),
(22690, '2017-03-05 10:45:39', NULL, NULL, 7465, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:45:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22691, '2017-03-05 10:45:58', NULL, NULL, 7465, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:45:58', 'admin-1488680401-1488681958080682', 1, 0, '', NULL, NULL, NULL),
(22692, '2017-03-05 10:45:58', NULL, NULL, 7465, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:45:58', 'admin-1488680401-1488681958080682', 1, 0, '', NULL, NULL, NULL),
(22693, '2017-03-05 10:45:58', NULL, NULL, 7465, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:45:58', 'admin-1488680401-1488681958080682', 1, 0, '', NULL, NULL, NULL),
(22694, '2017-03-05 11:41:28', NULL, NULL, 7478, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:41:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22695, '2017-03-05 11:14:54', NULL, NULL, 7474, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:14:54', 'admin-1488683386-1488683694264548', 1, 0, '', 1, NULL, NULL),
(22696, '2017-03-05 11:07:34', NULL, NULL, 7473, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:07:34', 'admin-1488680401-1488683254784949', 1, 0, '', NULL, NULL, NULL),
(22697, '2017-03-05 00:00:00', NULL, NULL, 7468, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:48:12', 'admin-1488678420-14886784921552620', 1, 1, 'SR', NULL, NULL, NULL),
(22698, '2017-03-05 10:41:15', NULL, NULL, 7464, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:41:15', 'admin-1488680401-14886816757029674', 1, 1, 'SR', NULL, NULL, NULL),
(22699, '2017-03-05 11:37:00', NULL, NULL, 7477, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 11:37:00', 'admin-1488683386-14886850201475781', 1, 0, '', NULL, NULL, NULL),
(22700, '2017-03-05 10:46:31', NULL, NULL, 7466, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:46:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22701, '2017-03-05 10:45:58', NULL, NULL, 7465, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:45:58', 'admin-1488680401-1488681958080682', 1, 0, '', NULL, NULL, NULL),
(22702, '2017-03-05 10:45:58', NULL, NULL, 7465, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:45:58', 'admin-1488680401-1488681958080682', 1, 0, '', NULL, NULL, NULL),
(22703, '2017-03-05 10:19:27', NULL, NULL, 7459, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:19:27', 'admin-1488678420-14886803672277544', 1, 0, '', NULL, NULL, NULL),
(22704, '2017-03-05 10:19:27', NULL, NULL, 7459, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:19:27', 'admin-1488678420-14886803672277544', 1, 0, '', NULL, NULL, NULL),
(22705, '2017-03-05 10:19:27', NULL, NULL, 7459, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:19:27', 'admin-1488678420-14886803672277544', 1, 0, '', NULL, NULL, NULL),
(22706, '2017-03-05 10:19:27', NULL, NULL, 7459, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:19:27', 'admin-1488678420-14886803672277544', 1, 0, '', NULL, NULL, NULL),
(22707, '2017-03-05 10:20:35', NULL, NULL, 7459, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:20:35', 'admin-1488680401-1488680435430988', 1, 0, '', NULL, NULL, NULL),
(22708, '2017-03-05 10:20:35', NULL, NULL, 7459, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:20:35', 'admin-1488680401-1488680435430988', 1, 1, 'SR', NULL, NULL, NULL),
(22709, '2017-03-05 10:20:35', NULL, NULL, 7459, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:20:35', 'admin-1488680401-1488680435430988', 1, 1, 'SR', NULL, NULL, NULL),
(22710, '2017-03-05 10:20:35', NULL, NULL, 7459, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:20:35', 'admin-1488680401-1488680435430988', 1, 1, 'SR', NULL, NULL, NULL),
(22711, '2017-03-05 10:40:45', NULL, NULL, 7463, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:40:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22712, '2017-03-05 10:40:51', NULL, NULL, 7463, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:40:51', 'admin-1488680401-14886816512906369', 1, 1, 'SR', NULL, NULL, NULL),
(22713, '2017-03-05 10:40:54', NULL, NULL, 7464, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:40:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22714, '2017-03-05 10:41:15', NULL, NULL, 7464, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:41:15', 'admin-1488680401-14886816757029674', 1, 0, '', NULL, NULL, NULL),
(22715, '2017-03-05 10:41:15', NULL, NULL, 7464, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:41:15', 'admin-1488680401-14886816757029674', 1, 0, '', NULL, NULL, NULL),
(22716, '2017-03-05 10:41:15', NULL, NULL, 7464, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:41:15', 'admin-1488680401-14886816757029674', 1, 1, 'SR', NULL, NULL, NULL),
(22717, '2017-03-05 10:34:07', NULL, NULL, 7461, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:34:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22718, '2017-03-05 00:00:00', NULL, NULL, 7468, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:46:55', 'admin-1488674581-14886784151545718', 1, 0, '', NULL, NULL, NULL),
(22719, '2017-03-05 10:19:27', NULL, NULL, 7459, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:19:27', 'admin-1488678420-14886803672277544', 1, 0, '', NULL, NULL, NULL),
(22720, '2017-03-05 10:14:44', NULL, NULL, 7460, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:14:44', 'admin-1488678420-1488680084690317', 1, 1, 'SR', NULL, NULL, NULL),
(22721, '2017-03-05 10:14:44', NULL, NULL, 7460, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:14:44', 'admin-1488678420-1488680084690317', 1, 1, 'SR', NULL, NULL, NULL),
(22722, '2017-03-05 10:01:08', NULL, NULL, 7456, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:01:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22723, '2017-03-05 09:42:51', NULL, NULL, 7454, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:42:51', 'admin-1488674581-14886781708454364', 1, 0, '', NULL, NULL, NULL),
(22724, '2017-03-05 09:46:42', NULL, NULL, 7455, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:46:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22725, '2017-03-05 09:46:55', NULL, NULL, 7455, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:46:55', 'admin-1488674581-14886784151545718', 1, 0, '', NULL, NULL, NULL),
(22726, '2017-03-05 10:52:07', NULL, NULL, 7468, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:52:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22727, '2017-03-05 09:47:53', NULL, NULL, 7455, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:47:53', 'admin-1488678420-14886784729504373', 1, 0, '', NULL, NULL, NULL),
(22728, '2017-03-05 10:51:41', NULL, NULL, 7467, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1488702266', 'admin', '2017-03-05 10:51:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22729, '2017-03-05 00:00:00', NULL, NULL, 7467, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:47:53', 'admin-1488678420-14886784729504373', 1, 0, '', NULL, NULL, NULL),
(22730, '2017-03-05 09:12:13', NULL, NULL, 7451, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:12:13', 'admin-1488674581-14886763337033847', 1, 1, 'SR', NULL, NULL, NULL),
(22731, '2017-03-05 09:14:11', NULL, NULL, 7452, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.45, 0.0000, 0.0000, 4.45, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:14:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22732, '2017-03-05 09:14:34', NULL, NULL, 7452, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:14:34', 'admin-1488674581-1488676474002178', 1, 0, '', NULL, NULL, NULL),
(22733, '2017-03-05 09:15:44', NULL, NULL, 7452, 0, 181, '116', 'Open Food ', 'friend egg 2', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:15:44', 'admin-1488674581-14886765448087514', 1, 0, '', NULL, NULL, NULL),
(22734, '2017-03-05 09:16:16', NULL, NULL, 7452, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:16:16', 'admin-1488674581-14886765762829139', 1, 1, 'SR', NULL, NULL, NULL),
(22735, '2017-03-05 09:16:16', NULL, NULL, 7452, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:16:16', 'admin-1488674581-14886765762829139', 1, 1, 'SR', NULL, NULL, NULL),
(22736, '2017-03-05 09:16:16', NULL, NULL, 7452, 0, 182, '117', 'Open Drinks ', 'esp shot', 'Cold Drinks', 'Fresh Juice', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:16:16', 'admin-1488674581-14886765762829139', 1, 0, '', NULL, NULL, NULL),
(22737, '2017-03-05 09:18:34', NULL, NULL, 7453, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.20, 0.0000, 0.0000, 11.20, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:18:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22738, '2017-03-05 09:37:14', NULL, NULL, 7453, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:37:14', 'admin-1488674581-14886778338764869', 1, 1, 'SR', NULL, NULL, NULL),
(22739, '2017-03-05 09:37:14', NULL, NULL, 7453, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:37:14', 'admin-1488674581-14886778338764869', 1, 1, 'SR', NULL, NULL, NULL),
(22740, '2017-03-05 09:37:14', NULL, NULL, 7453, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:37:14', 'admin-1488674581-14886778338764869', 1, 1, 'SR', NULL, NULL, NULL),
(22741, '2017-03-05 09:37:14', NULL, NULL, 7453, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:37:14', 'admin-1488674581-14886778338764869', 1, 1, 'SR', NULL, NULL, NULL),
(22742, '2017-03-05 09:18:49', NULL, NULL, 7453, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:18:49', 'admin-1488674581-14886767295777936', 1, 0, '', NULL, NULL, NULL),
(22743, '2017-03-05 09:18:49', NULL, NULL, 7453, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:18:49', 'admin-1488674581-14886767295777936', 1, 0, '', NULL, NULL, NULL),
(22744, '2017-03-05 09:18:49', NULL, NULL, 7453, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:18:49', 'admin-1488674581-14886767295777936', 1, 0, '', NULL, NULL, NULL),
(22745, '2017-03-05 09:18:49', NULL, NULL, 7453, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:18:49', 'admin-1488674581-14886767295777936', 1, 0, '', NULL, NULL, NULL),
(22746, '2017-03-05 09:42:45', NULL, NULL, 7454, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:42:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22747, '2017-03-05 09:42:51', NULL, NULL, 7454, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:42:51', 'admin-1488674581-14886781708454364', 1, 0, '', NULL, NULL, NULL),
(22748, '2017-03-05 09:12:13', NULL, NULL, 7451, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:12:13', 'admin-1488674581-14886763337033847', 1, 0, '', NULL, NULL, NULL),
(22749, '2017-03-05 09:12:13', NULL, NULL, 7451, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:12:13', 'admin-1488674581-14886763337033847', 1, 1, 'SR', NULL, NULL, NULL),
(22750, '2017-03-05 09:12:13', NULL, NULL, 7451, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:12:13', 'admin-1488674581-14886763337033847', 1, 1, 'SR', NULL, NULL, NULL),
(22751, '2017-03-05 09:12:13', NULL, NULL, 7451, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:12:13', 'admin-1488674581-14886763337033847', 1, 1, 'SR', NULL, NULL, NULL),
(22752, '2017-03-05 09:11:47', NULL, NULL, 7451, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:11:47', 'admin-1488674581-14886763075007180', 1, 0, '', NULL, NULL, NULL),
(22753, '2017-03-05 09:11:47', NULL, NULL, 7451, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:11:47', 'admin-1488674581-14886763075007180', 1, 0, '', NULL, NULL, NULL),
(22754, '2017-03-05 09:11:47', NULL, NULL, 7451, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:11:47', 'admin-1488674581-14886763075007180', 1, 0, '', NULL, NULL, NULL),
(22755, '2017-03-05 09:11:47', NULL, NULL, 7451, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:11:47', 'admin-1488674581-14886763075007180', 1, 0, '', NULL, NULL, NULL),
(22756, '2017-03-05 09:11:47', NULL, NULL, 7451, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:11:47', 'admin-1488674581-14886763075007180', 1, 0, '', NULL, NULL, NULL),
(22757, '2017-03-05 09:11:47', NULL, NULL, 7451, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:11:47', 'admin-1488674581-14886763075007180', 1, 0, '', NULL, NULL, NULL),
(22758, '2017-03-05 09:11:26', NULL, NULL, 7451, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.90, 0.0000, 0.0000, 16.90, 1, '27', 1, '1488702266', 'admin', '2017-03-05 09:11:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22759, '2017-03-05 17:00:26', NULL, NULL, 7505, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 17:00:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22760, '2017-03-05 17:00:29', NULL, NULL, 7505, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 17:00:29', 'admin-1488702266-14887044297661413', 1, 0, '', NULL, NULL, NULL),
(22761, '2017-03-05 17:13:36', NULL, NULL, 7505, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 17:13:36', 'admin-1488702266-14887052167329067', 1, 0, '', NULL, NULL, NULL),
(22762, '2017-03-05 18:22:56', NULL, NULL, 7506, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 18:22:56', 'admin-1488702266-14887093761236452', 1, 1, 'SR', 1, NULL, NULL),
(22763, '2017-03-05 18:22:56', NULL, NULL, 7506, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 18:22:56', 'admin-1488702266-14887093761236452', 1, 1, 'SR', 1, NULL, NULL),
(22764, '2017-03-05 18:22:56', NULL, NULL, 7506, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 18:22:56', 'admin-1488702266-14887093761236452', 1, 1, 'SR', 1, NULL, NULL),
(22765, '2017-03-05 18:23:51', NULL, NULL, 7507, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1488702266', 'admin', '2017-03-05 18:23:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22766, '2017-03-05 18:23:55', NULL, NULL, 7507, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 18:23:55', 'admin-1488702266-1488709435117975', 1, 1, 'SR', NULL, NULL, NULL),
(22767, '2017-03-05 18:31:51', NULL, NULL, 7508, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 18:31:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22768, '2017-03-05 18:32:23', NULL, NULL, 7508, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 18:32:23', 'admin-1488702266-14887099435011498', 1, 1, 'SR', NULL, NULL, NULL),
(22769, '2017-03-05 18:32:23', NULL, NULL, 7508, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 18:32:23', 'admin-1488702266-14887099435011498', 1, 1, 'SR', NULL, NULL, NULL),
(22770, '2017-03-05 18:32:23', NULL, NULL, 7508, 0, 74, '74', 'Sunrice', 'Takeaway', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 18:32:23', 'admin-1488702266-14887099435011498', 1, 1, 'SR', NULL, NULL, NULL),
(22771, '2017-03-05 18:32:23', NULL, NULL, 7508, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 18:32:23', 'admin-1488702266-14887099435011498', 1, 1, 'SR', NULL, NULL, NULL),
(22772, '2017-03-05 18:37:35', NULL, NULL, 7509, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1488702266', 'admin', '2017-03-05 18:37:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22773, '2017-03-05 18:37:57', NULL, NULL, 7509, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 18:37:57', 'admin-1488702266-1488710277692953', 1, 0, '', NULL, NULL, NULL),
(22774, '2017-03-05 18:44:01', NULL, NULL, 7510, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1488702266', 'admin', '2017-03-05 18:44:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22775, '2017-03-05 18:44:27', NULL, NULL, 7510, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 18:44:27', 'admin-1488702266-1488710667283193', 1, 0, '', NULL, NULL, NULL),
(22776, '2017-03-05 18:44:27', NULL, NULL, 7510, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 18:44:27', 'admin-1488702266-1488710667283193', 1, 1, 'SR', NULL, NULL, NULL),
(22777, '2017-03-05 18:44:27', NULL, NULL, 7510, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 18:44:27', 'admin-1488702266-1488710667283193', 1, 0, '', NULL, NULL, NULL),
(22778, '2017-03-05 18:44:36', NULL, NULL, 7510, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 18:44:36', 'admin-1488702266-148871067609352', 1, 1, 'SR', NULL, NULL, NULL),
(22779, '2017-03-05 18:44:36', NULL, NULL, 7510, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 18:44:36', 'admin-1488702266-148871067609352', 1, 1, 'SR', NULL, NULL, NULL),
(22780, '2017-03-05 18:47:51', NULL, NULL, 7508, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 18:47:51', 'admin-1488702266-14887108711302930', 1, 0, '', NULL, NULL, NULL),
(22781, '2017-03-05 19:35:54', NULL, NULL, 7511, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1488702266', 'admin', '2017-03-05 19:35:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22782, '2017-03-05 19:36:14', NULL, NULL, 7511, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 19:36:14', 'admin-1488702266-14887137742421157', 1, 1, 'SR', NULL, NULL, NULL),
(22783, '2017-03-05 19:36:14', NULL, NULL, 7511, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488702266', 'admin', '2017-03-05 19:36:14', 'admin-1488702266-14887137742421157', 1, 0, '', NULL, NULL, NULL),
(22784, '2017-03-06 18:26:56', NULL, NULL, 7544, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 18:26:56', 'admin-1488777303-14887960165478499', 1, 0, '', NULL, NULL, NULL),
(22785, '2017-03-06 14:45:28', NULL, NULL, 7539, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 14:45:28', 'admin-1488777303-14887827284325433', 1, 1, 'SR', NULL, NULL, NULL),
(22786, '2017-03-06 18:13:09', NULL, NULL, 7544, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.40, 0.0000, 0.0000, 14.40, 1, '27', 1, '1488777303', 'admin', '2017-03-06 18:13:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22787, '2017-03-06 14:51:31', NULL, NULL, 7540, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 14:51:31', 'admin-1488777303-14887830908468547', 1, 1, 'SR', NULL, NULL, NULL),
(22788, '2017-03-06 14:51:31', NULL, NULL, 7540, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 14:51:31', 'admin-1488777303-14887830908468547', 1, 1, 'SR', NULL, NULL, NULL),
(22789, '2017-03-06 14:55:46', NULL, NULL, 7541, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1488777303', 'admin', '2017-03-06 14:55:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22790, '2017-03-06 14:55:53', NULL, NULL, 7541, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 14:55:53', 'admin-1488777303-1488783353264380', 1, 0, '', NULL, NULL, NULL),
(22791, '2017-03-06 14:55:53', NULL, NULL, 7541, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 14:55:53', 'admin-1488777303-1488783353264380', 1, 0, '', NULL, NULL, NULL),
(22792, '2017-03-06 15:24:59', NULL, NULL, 7542, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 15:24:59', 'admin-1488777303-14887850989946956', 1, 0, '', 1, NULL, NULL),
(22793, '2017-03-06 15:24:59', NULL, NULL, 7542, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 15:24:59', 'admin-1488777303-14887850989946956', 1, 1, 'SR', 1, NULL, NULL),
(22794, '2017-03-06 15:55:44', NULL, NULL, 7543, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 15:55:44', 'admin-1488777303-14887869439454845', 1, 0, '', 1, NULL, NULL),
(22795, '2017-03-06 16:14:14', NULL, NULL, 7540, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 16:14:14', 'admin-1488777303-14887880539803991', 1, 1, 'SR', NULL, NULL, NULL),
(22796, '2017-03-06 18:13:50', NULL, NULL, 7544, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 18:13:50', 'admin-1488777303-14887952298656949', 1, 0, '', NULL, NULL, NULL),
(22797, '2017-03-06 18:13:50', NULL, NULL, 7544, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 18:13:50', 'admin-1488777303-14887952298656949', 1, 0, '', NULL, NULL, NULL),
(22798, '2017-03-06 18:13:50', NULL, NULL, 7544, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 18:13:50', 'admin-1488777303-14887952298656949', 1, 0, '', NULL, NULL, NULL),
(22799, '2017-03-06 18:13:50', NULL, NULL, 7544, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 18:13:50', 'admin-1488777303-14887952298656949', 1, 1, 'SR', NULL, NULL, NULL),
(22800, '2017-03-06 18:13:50', NULL, NULL, 7544, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 18:13:50', 'admin-1488777303-14887952298656949', 1, 1, 'SR', NULL, NULL, NULL),
(22801, '2017-03-06 18:15:27', NULL, NULL, 7545, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1488777303', 'admin', '2017-03-06 18:15:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22802, '2017-03-06 18:15:39', NULL, NULL, 7545, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 18:15:39', 'admin-1488777303-14887953398265916', 1, 0, '', NULL, NULL, NULL),
(22803, '2017-03-06 18:15:40', NULL, NULL, 7545, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 18:15:40', 'admin-1488777303-14887953398265916', 1, 1, 'SR', NULL, NULL, NULL),
(22804, '2017-03-06 18:17:45', NULL, NULL, 7545, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 18:17:45', 'admin-1488777303-148879546514053', 1, 1, 'SR', NULL, NULL, NULL),
(22805, '2017-03-06 13:15:46', NULL, NULL, 7536, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 13:15:46', 'admin-1488777303-1488777346147382', 1, 1, 'SR', NULL, NULL, NULL),
(22806, '2017-03-06 13:15:46', NULL, NULL, 7536, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 13:15:46', 'admin-1488777303-1488777346147382', 1, 1, 'SR', NULL, NULL, NULL),
(22807, '2017-03-06 13:29:18', NULL, NULL, 7537, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1488777303', 'admin', '2017-03-06 13:29:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22808, '2017-03-06 18:54:58', NULL, NULL, 7544, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 18:54:58', 'admin-1488777303-14887976984491870', 1, 0, '', NULL, NULL, NULL),
(22809, '2017-03-06 18:54:58', NULL, NULL, 7544, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 18:54:58', 'admin-1488777303-14887976984491870', 1, 0, '', NULL, NULL, NULL),
(22810, '2017-03-06 18:54:58', NULL, NULL, 7544, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 18:54:58', 'admin-1488777303-14887976984491870', 1, 0, '', NULL, NULL, NULL),
(22811, '2017-03-06 18:55:34', NULL, NULL, 7545, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 18:55:34', 'admin-1488777303-14887977341006590', 1, 0, '', NULL, NULL, NULL),
(22812, '2017-03-06 19:20:44', NULL, NULL, 7544, 0, 181, '116', 'Open Food ', 'pancake', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 19:20:44', 'admin-1488777303-14887992438215328', 1, 0, '', NULL, NULL, NULL),
(22813, '2017-03-06 19:20:47', NULL, NULL, 7546, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1488777303', 'admin', '2017-03-06 19:20:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22814, '2017-03-06 19:20:56', NULL, NULL, 7546, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 19:20:56', 'admin-1488777303-14887992559643491', 1, 0, '', NULL, NULL, NULL),
(22815, '2017-03-06 19:20:56', NULL, NULL, 7546, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 19:20:56', 'admin-1488777303-14887992559643491', 1, 0, '', NULL, NULL, NULL),
(22816, '2017-03-06 19:21:14', NULL, NULL, 7547, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1488777303', 'admin', '2017-03-06 19:21:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22817, '2017-03-06 19:21:50', NULL, NULL, 7547, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 19:21:50', 'admin-1488777303-14887993105067416', 1, 0, '', NULL, NULL, NULL),
(22818, '2017-03-06 13:29:21', NULL, NULL, 7537, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 13:29:21', 'admin-1488777303-1488778161345960', 1, 1, 'SR', NULL, NULL, NULL),
(22819, '2017-03-06 19:21:50', NULL, NULL, 7547, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 19:21:50', 'admin-1488777303-14887993105067416', 1, 0, '', NULL, NULL, NULL),
(22820, '2017-03-06 19:21:50', NULL, NULL, 7547, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 19:21:50', 'admin-1488777303-14887993105067416', 1, 1, 'SR', NULL, NULL, NULL),
(22821, '2017-03-06 19:55:06', NULL, NULL, 7548, 0, 182, '117', 'Open Drinks ', 'ice cream', 'Cold Drinks', 'Fresh Juice', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 19:55:06', 'admin-1488777303-1488801306276491', 1, 0, '', 1, NULL, NULL),
(22822, '2017-03-06 19:58:03', NULL, NULL, 7547, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 19:58:03', 'admin-1488777303-14888014835228339', 1, 1, 'SR', NULL, NULL, NULL),
(22823, '2017-03-06 19:58:21', NULL, NULL, 7547, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 19:58:21', 'admin-1488777303-14888015015318669', 1, 0, '', NULL, NULL, NULL),
(22824, '2017-03-06 12:10:12', NULL, NULL, 7528, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:10:12', 'admin-1488767651-14887734122507331', 1, 1, 'SR', NULL, NULL, NULL),
(22825, '2017-03-06 12:10:12', NULL, NULL, 7528, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:10:12', 'admin-1488767651-14887734122507331', 1, 1, 'SR', NULL, NULL, NULL),
(22826, '2017-03-06 12:16:28', NULL, NULL, 7528, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:16:28', 'admin-1488767651-14887737879054840', 1, 1, 'SR', NULL, NULL, NULL),
(22827, '2017-03-06 12:27:02', NULL, NULL, 7529, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:27:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22828, '2017-03-06 12:27:09', NULL, NULL, 7529, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:27:09', 'admin-1488767651-14887744291892734', 1, 1, 'SR', NULL, NULL, NULL),
(22829, '2017-03-06 12:27:42', NULL, NULL, 7529, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:27:42', 'admin-1488767651-1488774462514997', 1, 1, 'SR', NULL, NULL, NULL),
(22830, '2017-03-06 12:27:42', NULL, NULL, 7529, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:27:42', 'admin-1488767651-1488774462514997', 1, 1, 'SR', NULL, NULL, NULL),
(22831, '2017-03-06 12:27:42', NULL, NULL, 7529, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:27:42', 'admin-1488767651-1488774462514997', 1, 1, 'SR', NULL, NULL, NULL),
(22832, '2017-03-06 12:27:42', NULL, NULL, 7529, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:27:42', 'admin-1488767651-1488774462514997', 1, 0, '', NULL, NULL, NULL),
(22833, '2017-03-06 12:27:42', NULL, NULL, 7529, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:27:42', 'admin-1488767651-1488774462514997', 1, 0, '', NULL, NULL, NULL),
(22834, '2017-03-06 12:27:42', NULL, NULL, 7529, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:27:42', 'admin-1488767651-1488774462514997', 1, 1, 'SR', NULL, NULL, NULL),
(22835, '2017-03-06 12:30:04', NULL, NULL, 7530, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:30:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22836, '2017-03-06 12:30:13', NULL, NULL, 7530, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:30:13', 'admin-1488774486-14887746133579855', 1, 1, 'SR', NULL, NULL, NULL),
(22837, '2017-03-06 12:30:13', NULL, NULL, 7530, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:30:13', 'admin-1488774486-14887746133579855', 1, 1, 'SR', NULL, NULL, NULL),
(22838, '2017-03-06 12:30:41', NULL, NULL, 7528, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:30:41', 'admin-1488774486-14887746412786883', 1, 0, '', NULL, NULL, NULL),
(22839, '2017-03-06 12:30:41', NULL, NULL, 7528, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:30:41', 'admin-1488774486-14887746412786883', 1, 0, '', NULL, NULL, NULL),
(22840, '2017-03-06 12:31:16', NULL, NULL, 7531, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:31:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22841, '2017-03-06 12:31:29', NULL, NULL, 7531, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:31:29', 'admin-1488774486-14887746891611434', 1, 1, 'SR', NULL, NULL, NULL),
(22842, '2017-03-06 12:31:29', NULL, NULL, 7531, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:31:29', 'admin-1488774486-14887746891611434', 1, 1, 'SR', NULL, NULL, NULL),
(22843, '2017-03-06 10:50:13', NULL, NULL, 7522, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:50:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22844, '2017-03-06 10:50:33', NULL, NULL, 7522, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:50:33', 'admin-1488767651-14887686328594884', 1, 1, 'SR', NULL, NULL, NULL),
(22845, '2017-03-06 10:50:33', NULL, NULL, 7522, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:50:33', 'admin-1488767651-14887686328594884', 1, 1, 'SR', NULL, NULL, NULL),
(22846, '2017-03-06 10:50:33', NULL, NULL, 7522, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:50:33', 'admin-1488767651-14887686328594884', 1, 1, 'SR', NULL, NULL, NULL),
(22847, '2017-03-06 10:50:33', NULL, NULL, 7522, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:50:33', 'admin-1488767651-14887686328594884', 1, 0, '', NULL, NULL, NULL),
(22848, '2017-03-06 10:51:12', NULL, NULL, 7523, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:51:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22849, '2017-03-06 10:51:27', NULL, NULL, 7523, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:51:27', 'admin-1488767651-14887686871696529', 1, 1, 'SR', NULL, NULL, NULL),
(22850, '2017-03-06 10:51:27', NULL, NULL, 7523, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:51:27', 'admin-1488767651-14887686871696529', 1, 0, '', NULL, NULL, NULL),
(22851, '2017-03-06 10:51:27', NULL, NULL, 7523, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:51:27', 'admin-1488767651-14887686871696529', 1, 0, '', NULL, NULL, NULL),
(22852, '2017-03-06 10:52:05', NULL, NULL, 7514, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:52:05', 'admin-1488767651-1488768725677765', 1, 0, '', NULL, NULL, NULL),
(22853, '2017-03-06 10:59:09', NULL, NULL, 7514, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:59:09', 'admin-1488767651-14887691493999414', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(22854, '2017-03-06 11:03:03', NULL, NULL, 7524, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1488777303', 'admin', '2017-03-06 11:03:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22855, '2017-03-06 11:03:07', NULL, NULL, 7524, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 11:03:07', 'admin-1488767651-14887693877924722', 1, 1, 'SR', NULL, NULL, NULL),
(22856, '2017-03-06 11:05:01', NULL, NULL, 7525, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1488777303', 'admin', '2017-03-06 11:05:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22857, '2017-03-06 11:05:18', NULL, NULL, 7525, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 11:05:18', 'admin-1488767651-14887695179235155', 1, 0, '', NULL, NULL, NULL),
(22858, '2017-03-06 11:05:18', NULL, NULL, 7525, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 11:05:18', 'admin-1488767651-14887695179235155', 1, 0, '', NULL, NULL, NULL),
(22859, '2017-03-06 13:15:29', NULL, NULL, 7536, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1488777303', 'admin', '2017-03-06 13:15:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22860, '2017-03-06 18:54:58', NULL, NULL, 7544, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 18:54:58', 'admin-1488777303-14887976984491870', 1, 1, 'SR', NULL, NULL, NULL),
(22861, '2017-03-06 13:29:30', NULL, NULL, 7532, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 13:29:30', 'admin-1488777303-14887781697936581', 1, 1, 'SR', NULL, NULL, NULL),
(22862, '2017-03-06 13:29:30', NULL, NULL, 7532, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 13:29:30', 'admin-1488777303-14887781697936581', 1, 0, '', NULL, NULL, NULL),
(22863, '2017-03-06 13:36:44', NULL, NULL, 7536, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 13:36:44', 'admin-1488777303-14887786042091652', 1, 0, '', NULL, NULL, NULL),
(22864, '2017-03-06 13:36:44', NULL, NULL, 7536, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 13:36:44', 'admin-1488777303-14887786042091652', 1, 0, '', NULL, NULL, NULL),
(22865, '2017-03-06 13:42:05', NULL, NULL, 7538, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1488777303', 'admin', '2017-03-06 13:42:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22866, '2017-03-06 12:10:12', NULL, NULL, 7528, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:10:12', 'admin-1488767651-14887734122507331', 1, 0, '', NULL, NULL, NULL),
(22867, '2017-03-06 13:42:08', NULL, NULL, 7538, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 13:42:08', 'admin-1488777303-1488778928259714', 1, 1, 'SR', NULL, NULL, NULL),
(22868, '2017-03-06 13:15:46', NULL, NULL, 7536, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 13:15:46', 'admin-1488777303-1488777346147382', 1, 1, 'SR', NULL, NULL, NULL),
(22869, '2017-03-06 12:55:30', NULL, NULL, 7532, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:55:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22870, '2017-03-06 12:55:51', NULL, NULL, 7532, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:55:51', 'admin-1488774486-14887761513019259', 1, 0, '', NULL, NULL, NULL),
(22871, '2017-03-06 12:57:35', NULL, NULL, 7533, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:57:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22872, '2017-03-06 12:57:38', NULL, NULL, 7533, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:57:38', 'admin-1488774486-14887762585349919', 1, 1, 'SR', NULL, NULL, NULL),
(22873, '2017-03-06 13:02:03', NULL, NULL, 7527, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 13:02:03', 'admin-1488774486-14887765230877762', 1, 0, '', NULL, NULL, NULL),
(22874, '2017-03-06 13:07:27', NULL, NULL, 7534, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 13:07:27', 'admin-1488774486-14887768477082134', 1, 1, 'SR', 1, NULL, NULL),
(22875, '2017-03-06 13:08:08', NULL, NULL, 7535, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 13:08:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22876, '2017-03-06 13:08:12', NULL, NULL, 7535, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 13:08:12', 'admin-1488774486-14887768923453860', 1, 1, 'SR', NULL, NULL, NULL),
(22877, '2017-03-06 13:09:41', NULL, NULL, 7535, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 13:09:41', 'admin-1488774486-14887769814376572', 1, 1, 'SR', NULL, NULL, NULL),
(22878, '2017-03-06 13:09:41', NULL, NULL, 7535, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 13:09:41', 'admin-1488774486-14887769814376572', 1, 1, 'SR', NULL, NULL, NULL),
(22879, '2017-03-06 14:43:47', NULL, NULL, 7539, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1488777303', 'admin', '2017-03-06 14:43:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22880, '2017-03-06 14:44:20', NULL, NULL, 7539, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 14:44:20', 'admin-1488777303-1488782660164426', 1, 0, '', NULL, NULL, NULL),
(22881, '2017-03-06 13:11:47', NULL, NULL, 7529, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 13:11:47', 'admin-1488774486-14887771073562449', 1, 0, '', NULL, NULL, NULL),
(22882, '2017-03-06 13:13:14', NULL, NULL, 7535, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 13:13:14', 'admin-1488774486-14887771942168918', 1, 0, '', NULL, NULL, NULL),
(22883, '2017-03-06 13:13:14', NULL, NULL, 7535, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 13:13:14', 'admin-1488774486-14887771942168918', 1, 1, 'SR', NULL, NULL, NULL),
(22884, '2017-03-06 12:42:51', NULL, NULL, 7527, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:42:51', 'admin-1488774486-14887753709829344', 1, 1, 'SR', NULL, NULL, NULL),
(22885, '2017-03-06 12:55:04', NULL, NULL, 7531, 0, 158, '92', 'Banana Stuffed Nutella Toast ', 'no honey', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:55:04', 'admin-1488774486-14887761047842252', 1, 0, '', NULL, NULL, NULL),
(22886, '2017-03-06 12:55:10', NULL, NULL, 7531, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:55:10', 'admin-1488774486-14887761101876699', 1, 1, 'SR', NULL, NULL, NULL),
(22887, '2017-03-06 12:55:10', NULL, NULL, 7531, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:55:10', 'admin-1488774486-14887761101876699', 1, 1, 'SR', NULL, NULL, NULL),
(22888, '2017-03-06 10:36:48', NULL, NULL, 7517, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:36:48', 'admin-1488767651-14887678080845666', 1, 1, 'SR', NULL, NULL, NULL),
(22889, '2017-03-06 10:47:02', NULL, NULL, 7520, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:47:02', 'admin-1488767651-14887684220249663', 1, 1, 'SR', 1, NULL, NULL),
(22890, '2017-03-06 10:47:02', NULL, NULL, 7520, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:47:02', 'admin-1488767651-14887684220249663', 1, 1, 'SR', 1, NULL, NULL),
(22891, '2017-03-06 10:47:02', NULL, NULL, 7520, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:47:02', 'admin-1488767651-14887684220249663', 1, 1, 'SR', 1, NULL, NULL),
(22892, '2017-03-06 10:47:02', NULL, NULL, 7520, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:47:02', 'admin-1488767651-14887684220249663', 1, 1, 'SR', 1, NULL, NULL),
(22893, '2017-03-06 10:47:02', NULL, NULL, 7520, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:47:02', 'admin-1488767651-14887684220249663', 1, 1, 'SR', 1, NULL, NULL),
(22894, '2017-03-06 10:47:02', NULL, NULL, 7520, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:47:02', 'admin-1488767651-14887684220249663', 1, 1, 'SR', 1, NULL, NULL),
(22895, '2017-03-06 10:47:02', NULL, NULL, 7520, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:47:02', 'admin-1488767651-14887684220249663', 1, 0, '', 1, NULL, NULL),
(22896, '2017-03-06 10:49:22', NULL, NULL, 7521, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:49:22', 'admin-1488767651-14887685626195085', 1, 1, 'SR', 1, NULL, NULL),
(22897, '2017-03-06 10:49:22', NULL, NULL, 7521, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:49:22', 'admin-1488767651-14887685626195085', 1, 1, 'SR', 1, NULL, NULL),
(22898, '2017-03-06 10:49:22', NULL, NULL, 7521, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:49:22', 'admin-1488767651-14887685626195085', 1, 0, '', 1, NULL, NULL),
(22899, '2017-03-06 10:49:22', NULL, NULL, 7521, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:49:22', 'admin-1488767651-14887685626195085', 1, 0, '', 1, NULL, NULL),
(22900, '2017-03-06 10:49:22', NULL, NULL, 7521, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:49:22', 'admin-1488767651-14887685626195085', 1, 0, '', 1, NULL, NULL),
(22901, '2017-03-06 12:10:01', NULL, NULL, 7528, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1488777303', 'admin', '2017-03-06 12:10:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22902, '2017-03-06 11:46:10', NULL, NULL, 7527, 0, 82, '82', 'Set Stir Fried Rice Wine Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 11:46:10', 'admin-1488767651-14887719706416948', 1, 1, 'SR', NULL, NULL, NULL),
(22903, '2017-03-06 11:46:10', NULL, NULL, 7527, 0, 214, '148', 'Set Fried Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 11:46:10', 'admin-1488767651-14887719706416948', 1, 0, '', NULL, NULL, NULL),
(22904, '2017-03-06 11:45:56', NULL, NULL, 7527, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 11:45:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22905, '2017-03-06 11:40:04', NULL, NULL, 7526, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 11:40:04', 'admin-1488767651-14887716045569510', 1, 0, '', 1, NULL, NULL),
(22906, '2017-03-06 11:36:42', NULL, NULL, 7526, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 11:36:42', 'admin-1488767651-14887714027951487', 1, 1, 'SR', 1, NULL, NULL),
(22907, '2017-03-06 11:36:42', NULL, NULL, 7526, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 11:36:42', 'admin-1488767651-14887714027951487', 1, 1, 'SR', 1, NULL, NULL),
(22908, '2017-03-06 11:05:18', NULL, NULL, 7525, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 11:05:18', 'admin-1488767651-14887695179235155', 1, 1, 'SR', NULL, NULL, NULL),
(22909, '2017-03-06 11:05:18', NULL, NULL, 7525, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 11:05:18', 'admin-1488767651-14887695179235155', 1, 1, 'SR', NULL, NULL, NULL),
(22910, '2017-03-06 11:05:18', NULL, NULL, 7525, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 11:05:18', 'admin-1488767651-14887695179235155', 1, 0, '', NULL, NULL, NULL),
(22911, '2017-03-06 10:49:22', NULL, NULL, 7521, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:49:22', 'admin-1488767651-14887685626195085', 1, 0, '', 1, NULL, NULL),
(22912, '2017-03-06 10:49:22', NULL, NULL, 7521, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:49:22', 'admin-1488767651-14887685626195085', 1, 0, '', 1, NULL, NULL),
(22913, '2017-03-06 10:49:22', NULL, NULL, 7521, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:49:22', 'admin-1488767651-14887685626195085', 1, 1, 'SR', 1, NULL, NULL),
(22914, '2017-03-06 10:49:22', NULL, NULL, 7521, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:49:22', 'admin-1488767651-14887685626195085', 1, 1, 'SR', 1, NULL, NULL),
(22915, '2017-03-06 10:49:22', NULL, NULL, 7521, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:49:22', 'admin-1488767651-14887685626195085', 1, 0, '', 1, NULL, NULL),
(22916, '2017-03-06 10:49:22', NULL, NULL, 7521, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:49:22', 'admin-1488767651-14887685626195085', 1, 1, 'SR', 1, NULL, NULL),
(22917, '2017-03-06 10:49:22', NULL, NULL, 7521, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:49:22', 'admin-1488767651-14887685626195085', 1, 0, '', 1, NULL, NULL),
(22918, '2017-03-06 10:49:22', NULL, NULL, 7521, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:49:22', 'admin-1488767651-14887685626195085', 1, 1, 'SR', 1, NULL, NULL),
(22919, '2017-03-06 10:49:22', NULL, NULL, 7521, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:49:22', 'admin-1488767651-14887685626195085', 1, 0, '', 1, NULL, NULL),
(22920, '2017-03-06 10:36:48', NULL, NULL, 7517, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:36:48', 'admin-1488767651-14887678080845666', 1, 1, 'SR', NULL, NULL, NULL),
(22921, '2017-03-06 10:36:37', NULL, NULL, 7519, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:36:37', 'admin-1488767651-1488767796883101', 1, 1, 'SR', NULL, NULL, NULL),
(22922, '2017-03-06 10:36:30', NULL, NULL, 7519, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:36:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22923, '2017-03-06 10:36:25', NULL, NULL, 7518, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:36:25', 'admin-1488767651-1488767785282326', 1, 1, 'SR', NULL, NULL, NULL),
(22924, '2017-03-06 10:36:16', NULL, NULL, 7518, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:36:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22925, '2017-03-06 10:34:01', NULL, NULL, 7517, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:34:01', 'admin-1488762280-1488767641604421', 1, 0, '', NULL, NULL, NULL),
(22926, '2017-03-06 10:33:54', NULL, NULL, 7517, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:33:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22927, '2017-03-06 10:13:26', NULL, NULL, 7515, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:13:26', 'admin-1488762280-14887664060281865', 1, 0, '', NULL, NULL, NULL),
(22928, '2017-03-06 10:13:26', NULL, NULL, 7515, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:13:26', 'admin-1488762280-14887664060281865', 1, 1, 'SR', NULL, NULL, NULL),
(22929, '2017-03-06 10:13:26', NULL, NULL, 7515, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:13:26', 'admin-1488762280-14887664060281865', 1, 0, '', NULL, NULL, NULL),
(22930, '2017-03-06 10:13:26', NULL, NULL, 7515, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:13:26', 'admin-1488762280-14887664060281865', 1, 0, '', NULL, NULL, NULL),
(22931, '2017-03-06 10:13:26', NULL, NULL, 7515, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:13:26', 'admin-1488762280-14887664060281865', 1, 0, '', NULL, NULL, NULL),
(22932, '2017-03-06 10:12:11', NULL, NULL, 7516, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:12:11', 'admin-1488762280-14887663312708922', 1, 1, 'SR', NULL, NULL, NULL),
(22933, '2017-03-06 10:11:51', NULL, NULL, 7515, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:11:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22934, '2017-03-06 09:42:28', NULL, NULL, 7514, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 09:42:28', 'admin-1488762280-14887645480429615', 1, 1, 'SR', NULL, NULL, NULL),
(22935, '2017-03-06 09:42:28', NULL, NULL, 7514, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 09:42:28', 'admin-1488762280-14887645480429615', 1, 1, 'SR', NULL, NULL, NULL),
(22936, '2017-03-06 09:42:22', NULL, NULL, 7514, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 09:42:22', 'admin-1488762280-1488764542194213', 1, 0, '', NULL, NULL, NULL),
(22937, '2017-03-06 09:42:22', NULL, NULL, 7514, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 09:42:22', 'admin-1488762280-1488764542194213', 1, 0, '', NULL, NULL, NULL),
(22938, '2017-03-06 09:42:12', NULL, NULL, 7514, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1488777303', 'admin', '2017-03-06 09:42:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22939, '2017-03-06 09:15:05', NULL, NULL, 7513, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 09:15:05', 'admin-1488762280-14887629057337338', 1, 1, 'SR', NULL, NULL, NULL),
(22940, '2017-03-06 09:08:22', NULL, NULL, 7512, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 09:08:22', 'admin-1488762280-14887625024376589', 1, 1, 'SR', NULL, NULL, NULL),
(22941, '2017-03-06 10:12:06', NULL, NULL, 7516, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1488777303', 'admin', '2017-03-06 10:12:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22942, '2017-03-06 09:15:01', NULL, NULL, 7513, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1488777303', 'admin', '2017-03-06 09:15:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22943, '2017-03-06 09:08:14', NULL, NULL, 7512, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 09:08:14', 'admin-1488762280-14887624946133438', 1, 0, '', NULL, NULL, NULL),
(22944, '2017-03-06 09:08:22', NULL, NULL, 7512, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 09:08:22', 'admin-1488762280-14887625024376589', 1, 1, 'SR', NULL, NULL, NULL),
(22945, '2017-03-06 09:08:14', NULL, NULL, 7512, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488777303', 'admin', '2017-03-06 09:08:14', 'admin-1488762280-14887624946133438', 1, 0, '', NULL, NULL, NULL),
(22946, '2017-03-06 09:08:02', NULL, NULL, 7512, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1488777303', 'admin', '2017-03-06 09:08:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22947, '2017-03-08 00:00:00', NULL, NULL, 7573, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, NULL, NULL, 1.20, 1, '27', 1, '1488959498', 'admin', '2017-03-08 17:20:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22948, '2017-03-08 17:57:20', NULL, NULL, 7572, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1488959498', 'admin', '2017-03-08 17:57:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22949, '2017-03-08 00:00:00', NULL, NULL, 7572, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 17:57:07', 'admin-1488959498-14889670270625369', 1, 1, 'SR', NULL, NULL, NULL),
(22950, '2017-03-08 00:00:00', NULL, NULL, 7573, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 17:57:07', 'admin-1488959498-14889670270625369', 1, 1, 'SR', NULL, NULL, NULL),
(22951, '2017-03-08 18:23:19', NULL, NULL, 7574, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1488959498', 'admin', '2017-03-08 18:23:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22952, '2017-03-08 18:23:25', NULL, NULL, 7574, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 18:23:25', 'admin-1488959498-14889686051497586', 1, 1, 'SR', NULL, NULL, NULL),
(22953, '2017-03-08 20:04:34', NULL, NULL, 7575, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1488959498', 'admin', '2017-03-08 20:04:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22954, '2017-03-08 20:04:52', NULL, NULL, 7575, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 20:04:52', 'admin-1488959498-148897469206133', 1, 1, 'SR', NULL, NULL, NULL),
(22955, '2017-03-08 20:04:52', NULL, NULL, 7575, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 20:04:52', 'admin-1488959498-148897469206133', 1, 0, '', NULL, NULL, NULL),
(22956, '2017-03-08 20:04:52', NULL, NULL, 7575, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 20:04:52', 'admin-1488959498-148897469206133', 1, 1, 'SR', NULL, NULL, NULL),
(22957, '2017-03-08 14:52:46', NULL, NULL, 7564, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1488959498', 'admin', '2017-03-08 14:52:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22958, '2017-03-08 14:15:08', NULL, NULL, 7563, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1488959498', 'admin', '2017-03-08 14:15:08', 'admin-1488953146-14889537083286067', 1, 0, '', NULL, NULL, NULL),
(22959, '2017-03-08 14:35:32', NULL, NULL, 7556, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 14:35:32', 'admin-1488953146-14889549322951359', 1, 1, 'SR', NULL, NULL, NULL),
(22960, '2017-03-08 13:02:37', NULL, NULL, 7553, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:02:37', 'admin-1488948551-14889493577186177', 1, 1, 'SR', NULL, NULL, NULL),
(22961, '2017-03-08 13:17:14', NULL, NULL, 7554, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:17:14', 'admin-1488948551-14889502343583443', 1, 0, '', NULL, NULL, NULL),
(22962, '2017-03-08 13:17:14', NULL, NULL, 7554, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:17:14', 'admin-1488948551-14889502343583443', 1, 1, 'SR', NULL, NULL, NULL),
(22963, '2017-03-08 13:17:14', NULL, NULL, 7554, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:17:14', 'admin-1488948551-14889502343583443', 1, 0, '', NULL, NULL, NULL),
(22964, '2017-03-08 13:20:26', NULL, NULL, 7556, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:20:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22965, '2017-03-08 13:20:32', NULL, NULL, 7556, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:20:32', 'admin-1488948551-14889504327092787', 1, 1, 'SR', NULL, NULL, NULL),
(22966, '2017-03-08 13:26:15', NULL, NULL, 7555, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:26:15', 'admin-1488948551-14889507751866626', 1, 0, '', NULL, NULL, NULL),
(22967, '2017-03-08 13:30:59', NULL, NULL, 7557, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:30:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22968, '2017-03-08 13:31:14', NULL, NULL, 7557, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:31:14', 'admin-1488948551-1488951074748286', 1, 1, 'SR', NULL, NULL, NULL),
(22969, '2017-03-08 13:31:14', NULL, NULL, 7557, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:31:14', 'admin-1488948551-1488951074748286', 1, 1, 'SR', NULL, NULL, NULL),
(22970, '2017-03-08 13:31:14', NULL, NULL, 7557, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:31:14', 'admin-1488948551-1488951074748286', 1, 0, '', NULL, NULL, NULL),
(22971, '2017-03-08 13:31:14', NULL, NULL, 7557, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:31:14', 'admin-1488948551-1488951074748286', 1, 0, '', NULL, NULL, NULL),
(22972, '2017-03-08 13:31:14', NULL, NULL, 7557, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:31:14', 'admin-1488948551-1488951074748286', 1, 1, 'SR', NULL, NULL, NULL),
(22973, '2017-03-08 14:05:38', NULL, NULL, 7562, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 14:05:38', 'admin-1488948551-14889531383853334', 1, 1, 'SR', NULL, NULL, NULL),
(22974, '2017-03-08 14:12:05', NULL, NULL, 7563, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.79, 0.0000, 0.0000, 1.79, 1, '27', 1, '1488959498', 'admin', '2017-03-08 14:12:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22975, '2017-03-08 14:12:08', NULL, NULL, 7563, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 14:12:08', 'admin-1488953146-1488953528741201', 1, 1, 'SR', NULL, NULL, NULL),
(22976, '2017-03-08 12:49:06', NULL, NULL, 7555, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 12:49:06', 'admin-1488938904-14889485460555147', 1, 1, 'SR', NULL, NULL, NULL),
(22977, '2017-03-08 12:49:06', NULL, NULL, 7555, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 12:49:06', 'admin-1488938904-14889485460555147', 1, 1, 'SR', NULL, NULL, NULL),
(22978, '2017-03-08 16:40:58', NULL, NULL, 7570, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 16:40:58', 'admin-1488959498-14889624581967696', 1, 1, 'SR', NULL, NULL, NULL),
(22979, '2017-03-08 16:40:58', NULL, NULL, 7570, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 16:40:58', 'admin-1488959498-14889624581967696', 1, 0, '', NULL, NULL, NULL),
(22980, '2017-03-08 16:10:13', NULL, NULL, 7567, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 16:10:13', 'admin-1488959498-14889606134421883', 1, 1, 'SR', NULL, NULL, NULL),
(22981, '2017-03-08 16:16:08', NULL, NULL, 7569, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1488959498', 'admin', '2017-03-08 16:16:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22982, '2017-03-08 16:16:14', NULL, NULL, 7569, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 16:16:14', 'admin-1488959498-14889609744476818', 1, 0, '', NULL, NULL, NULL),
(22983, '2017-03-08 16:16:14', NULL, NULL, 7569, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 16:16:14', 'admin-1488959498-14889609744476818', 1, 0, '', NULL, NULL, NULL),
(22984, '2017-03-08 16:40:40', NULL, NULL, 7570, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 16:40:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22985, '2017-03-08 16:40:58', NULL, NULL, 7570, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 16:40:58', 'admin-1488959498-14889624581967696', 1, 0, '', NULL, NULL, NULL),
(22986, '2017-03-08 16:40:58', NULL, NULL, 7570, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 16:40:58', 'admin-1488959498-14889624581967696', 1, 1, 'SR', NULL, NULL, NULL),
(22987, '2017-03-08 16:40:58', NULL, NULL, 7570, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 16:40:58', 'admin-1488959498-14889624581967696', 1, 1, 'SR', NULL, NULL, NULL),
(22988, '2017-03-08 14:12:08', NULL, NULL, 7563, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 14:12:08', 'admin-1488953146-1488953528741201', 1, 1, 'SR', NULL, NULL, NULL),
(22989, '2017-03-08 14:52:54', NULL, NULL, 7564, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 14:52:54', 'admin-1488953146-14889559745121579', 1, 0, '', NULL, NULL, NULL),
(22990, '2017-03-08 14:55:24', NULL, NULL, 7564, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 14:55:24', 'admin-1488953146-14889561242405826', 1, 0, '', NULL, NULL, NULL),
(22991, '2017-03-08 14:55:24', NULL, NULL, 7564, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 14:55:24', 'admin-1488953146-14889561242405826', 1, 1, 'SR', NULL, NULL, NULL),
(22992, '2017-03-08 15:24:26', NULL, NULL, 7565, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1488959498', 'admin', '2017-03-08 15:24:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22993, '2017-03-08 15:24:39', NULL, NULL, 7565, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 15:24:39', 'admin-1488953146-14889578793329864', 1, 1, 'SR', NULL, NULL, NULL),
(22994, '2017-03-08 15:24:39', NULL, NULL, 7565, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 15:24:39', 'admin-1488953146-14889578793329864', 1, 1, 'SR', NULL, NULL, NULL),
(22995, '2017-03-08 15:37:57', NULL, NULL, 7566, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1488959498', 'admin', '2017-03-08 15:37:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(22996, '2017-03-08 15:38:09', NULL, NULL, 7566, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 15:38:09', 'admin-1488953146-14889586893356788', 1, 0, '', NULL, NULL, NULL),
(22997, '2017-03-08 15:38:09', NULL, NULL, 7566, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 15:38:09', 'admin-1488953146-14889586893356788', 1, 1, 'SR', NULL, NULL, NULL),
(22998, '2017-03-08 15:47:10', NULL, NULL, 7564, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 15:47:10', 'admin-1488953146-1488959230132108', 1, 1, 'SR', NULL, NULL, NULL),
(22999, '2017-03-08 15:56:38', NULL, NULL, 7567, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1488959498', 'admin', '2017-03-08 15:56:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23000, '2017-03-08 15:56:49', NULL, NULL, 7567, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 15:56:49', 'admin-1488959498-14889598092145968', 1, 0, '', NULL, NULL, NULL),
(23001, '2017-03-08 15:57:46', NULL, NULL, 7567, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 15:57:46', 'admin-1488959498-14889598658836283', 1, 0, '', NULL, NULL, NULL),
(23002, '2017-03-08 15:57:46', NULL, NULL, 7567, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 15:57:46', 'admin-1488959498-14889598658836283', 1, 1, 'SR', NULL, NULL, NULL),
(23003, '2017-03-08 15:57:46', NULL, NULL, 7567, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 15:57:46', 'admin-1488959498-14889598658836283', 1, 0, '', NULL, NULL, NULL),
(23004, '2017-03-08 15:57:46', NULL, NULL, 7567, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 15:57:46', 'admin-1488959498-14889598658836283', 1, 0, '', NULL, NULL, NULL),
(23005, '2017-03-08 15:57:46', NULL, NULL, 7567, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 15:57:46', 'admin-1488959498-14889598658836283', 1, 1, 'SR', NULL, NULL, NULL),
(23006, '2017-03-08 15:57:57', NULL, NULL, 7568, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.10, 0.0000, 0.0000, 10.10, 1, '27', 1, '1488959498', 'admin', '2017-03-08 15:57:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23007, '2017-03-08 15:58:04', NULL, NULL, 7568, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 15:58:04', 'admin-1488959498-14889598843035838', 1, 0, '', NULL, NULL, NULL),
(23008, '2017-03-08 15:58:04', NULL, NULL, 7568, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 15:58:04', 'admin-1488959498-14889598843035838', 1, 0, '', NULL, NULL, NULL),
(23009, '2017-03-08 15:58:04', NULL, NULL, 7568, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 15:58:04', 'admin-1488959498-14889598843035838', 1, 0, '', NULL, NULL, NULL),
(23010, '2017-03-08 15:58:04', NULL, NULL, 7568, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 15:58:04', 'admin-1488959498-14889598843035838', 1, 1, 'SR', NULL, NULL, NULL),
(23011, '2017-03-08 16:01:44', NULL, NULL, 7568, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 16:01:44', 'admin-1488959498-14889601043816683', 1, 1, 'SR', NULL, NULL, NULL),
(23012, '2017-03-08 16:01:44', NULL, NULL, 7568, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 16:01:44', 'admin-1488959498-14889601043816683', 1, 1, 'SR', NULL, NULL, NULL),
(23013, '2017-03-08 12:34:53', NULL, NULL, 7553, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 12:34:53', 'admin-1488938904-14889476928074749', 1, 1, 'SR', NULL, NULL, NULL),
(23014, '2017-03-08 12:41:19', NULL, NULL, 7554, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.30, 0.0000, 0.0000, 13.30, 1, '27', 1, '1488959498', 'admin', '2017-03-08 12:41:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23015, '2017-03-08 12:42:01', NULL, NULL, 7554, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 12:42:01', 'admin-1488938904-14889481210428899', 1, 0, '', NULL, NULL, NULL),
(23016, '2017-03-08 12:42:01', NULL, NULL, 7554, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 12:42:01', 'admin-1488938904-14889481210428899', 1, 0, '', NULL, NULL, NULL),
(23017, '2017-03-08 12:42:01', NULL, NULL, 7554, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 12:42:01', 'admin-1488938904-14889481210428899', 1, 0, '', NULL, NULL, NULL),
(23018, '2017-03-08 12:42:01', NULL, NULL, 7554, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 12:42:01', 'admin-1488938904-14889481210428899', 1, 1, 'SR', NULL, NULL, NULL),
(23019, '2017-03-08 12:42:01', NULL, NULL, 7554, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 12:42:01', 'admin-1488938904-14889481210428899', 1, 0, '', NULL, NULL, NULL),
(23020, '2017-03-08 12:42:01', NULL, NULL, 7554, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 12:42:01', 'admin-1488938904-14889481210428899', 1, 0, '', NULL, NULL, NULL),
(23021, '2017-03-08 13:40:11', NULL, NULL, 7558, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:40:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23022, '2017-03-08 13:40:26', NULL, NULL, 7558, 0, 214, '148', 'Set Fried Hot & Spicy Pork', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:40:26', 'admin-1488948551-14889516264511828', 1, 0, '', NULL, NULL, NULL),
(23023, '2017-03-08 13:40:26', NULL, NULL, 7558, 0, 213, '147', 'Set Stir Fried Lemony Chicken', '', 'Meals', 'Set Lunch', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:40:26', 'admin-1488948551-14889516264511828', 1, 0, '', NULL, NULL, NULL),
(23024, '2017-03-08 13:49:50', NULL, NULL, 7559, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:49:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23025, '2017-03-08 13:49:54', NULL, NULL, 7559, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:49:54', 'admin-1488948551-14889521938914280', 1, 1, 'SR', NULL, NULL, NULL),
(23026, '2017-03-08 13:49:54', NULL, NULL, 7559, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:49:54', 'admin-1488948551-14889521938914280', 1, 0, '', NULL, NULL, NULL),
(23027, '2017-03-08 13:49:58', NULL, NULL, 7560, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:49:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23028, '2017-03-08 13:50:04', NULL, NULL, 7560, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:50:04', 'admin-1488948551-14889522047342453', 1, 1, 'SR', NULL, NULL, NULL),
(23029, '2017-03-08 13:54:46', NULL, NULL, 7559, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:54:46', 'admin-1488948551-14889524867807563', 1, 0, '', NULL, NULL, NULL),
(23030, '2017-03-08 13:54:46', NULL, NULL, 7559, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:54:46', 'admin-1488948551-14889524867807563', 1, 1, 'SR', NULL, NULL, NULL),
(23031, '2017-03-08 13:59:14', NULL, NULL, 7561, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:59:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23032, '2017-03-08 13:59:59', NULL, NULL, 7561, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:59:59', 'admin-1488948551-14889527991172659', 1, 0, '', NULL, NULL, NULL),
(23033, '2017-03-08 13:59:59', NULL, NULL, 7561, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:59:59', 'admin-1488948551-14889527991172659', 1, 0, '', NULL, NULL, NULL),
(23034, '2017-03-08 13:59:59', NULL, NULL, 7561, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:59:59', 'admin-1488948551-14889527991172659', 1, 1, 'SR', NULL, NULL, NULL),
(23035, '2017-03-08 13:59:59', NULL, NULL, 7561, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:59:59', 'admin-1488948551-14889527991172659', 1, 1, 'SR', NULL, NULL, NULL),
(23036, '2017-03-08 14:00:08', NULL, NULL, 7562, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1488959498', 'admin', '2017-03-08 14:00:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23037, '2017-03-08 14:00:19', NULL, NULL, 7562, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 14:00:19', 'admin-1488948551-148895281951139', 1, 0, '', NULL, NULL, NULL),
(23038, '2017-03-08 14:05:38', NULL, NULL, 7562, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 14:05:38', 'admin-1488948551-14889531383853334', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(23039, '2017-03-08 13:02:37', NULL, NULL, 7553, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 13:02:37', 'admin-1488948551-14889493577186177', 1, 0, '', NULL, NULL, NULL),
(23040, '2017-03-08 12:49:06', NULL, NULL, 7555, 0, 14, '14', 'Iced Cappuccino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 12:49:06', 'admin-1488938904-14889485460555147', 1, 1, 'SR', NULL, NULL, NULL),
(23041, '2017-03-08 10:11:42', NULL, NULL, 7549, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 10:11:42', 'admin-1488938904-14889391021358518', 1, 0, '', NULL, NULL, NULL),
(23042, '2017-03-08 10:20:58', NULL, NULL, 7550, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1488959498', 'admin', '2017-03-08 10:20:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23043, '2017-03-08 10:21:09', NULL, NULL, 7550, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 10:21:09', 'admin-1488938904-14889396689675122', 1, 0, '', NULL, NULL, NULL),
(23044, '2017-03-08 10:21:09', NULL, NULL, 7550, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 10:21:09', 'admin-1488938904-14889396689675122', 1, 0, '', NULL, NULL, NULL),
(23045, '2017-03-08 10:21:13', NULL, NULL, 7550, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 10:21:13', 'admin-1488938904-14889396734306445', 1, 1, 'SR', NULL, NULL, NULL),
(23046, '2017-03-08 10:21:13', NULL, NULL, 7550, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 10:21:13', 'admin-1488938904-14889396734306445', 1, 1, 'SR', NULL, NULL, NULL),
(23047, '2017-03-08 11:00:26', NULL, NULL, 7551, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1488959498', 'admin', '2017-03-08 11:00:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23048, '2017-03-08 11:00:29', NULL, NULL, 7551, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 11:00:29', 'admin-1488938904-14889420293995180', 1, 1, 'SR', NULL, NULL, NULL),
(23049, '2017-03-08 11:47:45', NULL, NULL, 7552, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1488959498', 'admin', '2017-03-08 11:47:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23050, '2017-03-08 11:47:51', NULL, NULL, 7552, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 11:47:51', 'admin-1488938904-14889448714087532', 1, 0, '', NULL, NULL, NULL),
(23051, '2017-03-08 11:48:02', NULL, NULL, 7552, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 11:48:02', 'admin-1488938904-14889448825889326', 1, 1, 'SR', NULL, NULL, NULL),
(23052, '2017-03-08 12:04:10', NULL, NULL, 7552, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 12:04:10', 'admin-1488938904-14889458507149937', 1, 1, 'SR', NULL, NULL, NULL),
(23053, '2017-03-08 12:34:08', NULL, NULL, 7553, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.80, 0.0000, 0.0000, 12.80, 1, '27', 1, '1488959498', 'admin', '2017-03-08 12:34:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23054, '2017-03-08 12:34:16', NULL, NULL, 7553, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 12:34:16', 'admin-1488938904-14889476562171261', 1, 0, '', NULL, NULL, NULL),
(23055, '2017-03-08 12:34:16', NULL, NULL, 7553, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 12:34:16', 'admin-1488938904-14889476562171261', 1, 0, '', NULL, NULL, NULL),
(23056, '2017-03-08 12:34:16', NULL, NULL, 7553, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 12:34:16', 'admin-1488938904-14889476562171261', 1, 0, '', NULL, NULL, NULL),
(23057, '2017-03-08 12:34:53', NULL, NULL, 7553, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 12:34:53', 'admin-1488938904-14889476928074749', 1, 1, 'SR', NULL, NULL, NULL),
(23058, '2017-03-08 12:49:06', NULL, NULL, 7555, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 12:49:06', 'admin-1488938904-14889485460555147', 1, 1, 'SR', NULL, NULL, NULL),
(23059, '2017-03-08 12:48:48', NULL, NULL, 7555, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1488959498', 'admin', '2017-03-08 12:48:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23060, '2017-03-08 12:34:53', NULL, NULL, 7553, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 12:34:53', 'admin-1488938904-14889476928074749', 1, 1, 'SR', NULL, NULL, NULL),
(23061, '2017-03-08 10:11:36', NULL, NULL, 7549, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 10:11:36', 'admin-1488938904-14889390965978332', 1, 0, '', NULL, NULL, NULL),
(23062, '2017-03-08 10:11:36', NULL, NULL, 7549, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 10:11:36', 'admin-1488938904-14889390965978332', 1, 0, '', NULL, NULL, NULL),
(23063, '2017-03-08 10:11:36', NULL, NULL, 7549, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1488959498', 'admin', '2017-03-08 10:11:36', 'admin-1488938904-14889390965978332', 1, 0, '', NULL, NULL, NULL),
(23064, '2017-03-08 10:11:29', NULL, NULL, 7549, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1488959498', 'admin', '2017-03-08 10:11:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23065, '2017-03-09 12:37:45', NULL, NULL, 7582, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 12:37:45', 'admin-1489020426-14890342652349714', 1, 1, 'SR', NULL, NULL, NULL),
(23066, '2017-03-09 12:37:45', NULL, NULL, 7582, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 12:37:45', 'admin-1489020426-14890342652349714', 1, 0, '', NULL, NULL, NULL),
(23067, '2017-03-09 12:40:08', NULL, NULL, 7582, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 12:40:08', 'admin-1489034323-14890344085211263', 1, 1, 'SR', NULL, NULL, NULL),
(23068, '2017-03-09 12:40:08', NULL, NULL, 7582, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 12:40:08', 'admin-1489034323-14890344085211263', 1, 1, 'SR', NULL, NULL, NULL),
(23069, '2017-03-09 12:54:51', NULL, NULL, 7582, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 12:54:51', 'admin-1489034323-14890352910288760', 1, 0, '', NULL, NULL, NULL),
(23070, '2017-03-09 12:56:22', NULL, NULL, 7581, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 12:56:22', 'admin-1489034323-1489035382551623', 1, 0, '', NULL, NULL, NULL),
(23071, '2017-03-09 12:56:39', NULL, NULL, 7583, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1489034323', 'admin', '2017-03-09 12:56:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23072, '2017-03-09 12:56:55', NULL, NULL, 7583, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 12:56:55', 'admin-1489034323-14890354155201132', 1, 1, 'SR', NULL, NULL, NULL),
(23073, '2017-03-09 12:56:55', NULL, NULL, 7583, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 12:56:55', 'admin-1489034323-14890354155201132', 1, 1, 'SR', NULL, NULL, NULL),
(23074, '2017-03-09 12:56:55', NULL, NULL, 7583, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 12:56:55', 'admin-1489034323-14890354155201132', 1, 0, '', NULL, NULL, NULL),
(23075, '2017-03-09 12:56:55', NULL, NULL, 7583, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 12:56:55', 'admin-1489034323-14890354155201132', 1, 1, 'SR', NULL, NULL, NULL),
(23076, '2017-03-09 13:24:38', NULL, NULL, 7584, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 13:24:38', 'admin-1489034323-14890370788062747', 1, 0, '', 1, NULL, NULL),
(23077, '2017-03-09 13:41:05', NULL, NULL, 7582, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 13:41:05', 'admin-1489034323-14890380654745761', 1, 0, '', NULL, NULL, NULL),
(23078, '2017-03-09 14:54:23', NULL, NULL, 7585, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 14:54:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23079, '2017-03-09 14:54:32', NULL, NULL, 7585, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 14:54:32', 'admin-1489034323-14890424727533484', 1, 1, 'SR', NULL, NULL, NULL),
(23080, '2017-03-09 14:54:32', NULL, NULL, 7585, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 14:54:32', 'admin-1489034323-14890424727533484', 1, 1, 'SR', NULL, NULL, NULL),
(23081, '2017-03-09 15:21:07', NULL, NULL, 7586, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1489034323', 'admin', '2017-03-09 15:21:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23082, '2017-03-09 15:21:13', NULL, NULL, 7586, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 15:21:13', 'admin-1489034323-1489044073461839', 1, 1, 'SR', NULL, NULL, NULL),
(23083, '2017-03-09 15:52:22', NULL, NULL, 7585, 0, 181, '116', 'Open Food ', 'Pistachio Scone', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 15:52:22', 'admin-1489034323-14890459427014181', 1, 0, '', NULL, NULL, NULL),
(23084, '2017-03-09 17:08:12', NULL, NULL, 7587, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1489034323', 'admin', '2017-03-09 17:08:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23085, '2017-03-09 17:11:22', NULL, NULL, 7587, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 17:11:22', 'admin-1489034323-14890506823124258', 1, 1, 'SR', NULL, NULL, NULL),
(23086, '2017-03-09 17:11:22', NULL, NULL, 7587, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 17:11:22', 'admin-1489034323-14890506823124258', 1, 1, 'SR', NULL, NULL, NULL),
(23087, '2017-03-09 17:11:22', NULL, NULL, 7587, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 17:11:22', 'admin-1489034323-14890506823124258', 1, 0, '', NULL, NULL, NULL),
(23088, '2017-03-09 17:58:19', NULL, NULL, 7588, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 17:58:19', 'admin-1489034323-14890534993554882', 1, 0, '', 1, NULL, NULL),
(23089, '2017-03-09 09:51:04', NULL, NULL, 7577, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1489034323', 'admin', '2017-03-09 09:51:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23090, '2017-03-09 09:51:14', NULL, NULL, 7577, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 09:51:14', 'admin-1489020426-14890242744255669', 1, 0, '', NULL, NULL, NULL),
(23091, '2017-03-09 09:51:14', NULL, NULL, 7577, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 09:51:14', 'admin-1489020426-14890242744255669', 1, 0, '', NULL, NULL, NULL),
(23092, '2017-03-09 09:51:14', NULL, NULL, 7577, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 09:51:14', 'admin-1489020426-14890242744255669', 1, 0, '', NULL, NULL, NULL),
(23093, '2017-03-09 09:51:23', NULL, NULL, 7577, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 09:51:23', 'admin-1489020426-14890242832773269', 1, 1, 'SR', NULL, NULL, NULL),
(23094, '2017-03-09 09:56:47', NULL, NULL, 7577, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 09:56:47', 'admin-1489020426-14890246069513065', 1, 1, 'SR', NULL, NULL, NULL),
(23095, '2017-03-09 10:45:48', NULL, NULL, 7578, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1489034323', 'admin', '2017-03-09 10:45:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23096, '2017-03-09 10:46:11', NULL, NULL, 7578, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 10:46:11', 'admin-1489020426-14890275712897636', 1, 1, 'SR', NULL, NULL, NULL),
(23097, '2017-03-09 10:46:11', NULL, NULL, 7578, 0, 181, '116', 'Open Food ', 'cranberries scone 1 pc', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 10:46:11', 'admin-1489020426-14890275712897636', 1, 0, '', NULL, NULL, NULL),
(23098, '2017-03-09 10:47:40', NULL, NULL, 7577, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 10:47:40', 'admin-1489020426-14890276598346836', 1, 0, '', NULL, NULL, NULL),
(23099, '2017-03-09 11:36:29', NULL, NULL, 7579, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1489034323', 'admin', '2017-03-09 11:36:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23100, '2017-03-09 11:36:33', NULL, NULL, 7579, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 11:36:33', 'admin-1489020426-14890305935114526', 1, 1, 'SR', NULL, NULL, NULL),
(23101, '2017-03-09 11:37:05', NULL, NULL, 7580, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1489034323', 'admin', '2017-03-09 11:37:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23102, '2017-03-09 11:37:10', NULL, NULL, 7580, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 11:37:10', 'admin-1489020426-1489030630363525', 1, 1, 'SR', NULL, NULL, NULL),
(23103, '2017-03-09 12:17:30', NULL, NULL, 7581, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1489034323', 'admin', '2017-03-09 12:17:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23104, '2017-03-09 12:17:37', NULL, NULL, 7581, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 12:17:37', 'admin-1489020426-14890330572485170', 1, 1, 'SR', NULL, NULL, NULL),
(23105, '2017-03-09 12:17:37', NULL, NULL, 7581, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 12:17:37', 'admin-1489020426-14890330572485170', 1, 0, '', NULL, NULL, NULL),
(23106, '2017-03-09 12:34:01', NULL, NULL, 7582, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1489034323', 'admin', '2017-03-09 12:34:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23107, '2017-03-09 09:51:00', NULL, NULL, 7576, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 09:51:00', 'admin-1489020426-1489024260351709', 1, 1, 'SR', NULL, NULL, NULL),
(23108, '2017-03-09 12:37:45', NULL, NULL, 7582, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 12:37:45', 'admin-1489020426-14890342652349714', 1, 1, 'SR', NULL, NULL, NULL),
(23109, '2017-03-09 09:37:16', NULL, NULL, 7576, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 09:37:16', 'admin-1489020426-14890234359216228', 1, 0, '', NULL, NULL, NULL),
(23110, '2017-03-09 09:37:08', NULL, NULL, 7576, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1489034323', 'admin', '2017-03-09 09:37:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23111, '2017-03-10 14:59:25', NULL, NULL, 7604, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1489123543', 'admin', '2017-03-10 14:59:25', 'admin-1489123543-14891291651729466', 1, 1, 'SR', NULL, NULL, NULL),
(23112, '2017-03-10 14:59:25', NULL, NULL, 7604, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1489123543', 'admin', '2017-03-10 14:59:25', 'admin-1489123543-14891291651729466', 1, 1, 'SR', NULL, NULL, NULL),
(23113, '2017-03-10 15:02:15', NULL, NULL, 7597, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489123543', 'admin', '2017-03-10 15:02:15', 'admin-1489123543-14891293357958227', 1, 1, 'SR', NULL, NULL, NULL),
(23114, '2017-03-10 15:22:05', NULL, NULL, 7597, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489123543', 'admin', '2017-03-10 15:22:05', 'admin-1489123543-14891305255064245', 1, 1, 'SR', NULL, NULL, NULL),
(23115, '2017-03-10 16:00:15', NULL, NULL, 7597, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489123543', 'admin', '2017-03-10 16:00:15', 'admin-1489123543-14891328151842151', 1, 1, 'SR', NULL, NULL, NULL),
(23116, '2017-03-10 16:00:20', NULL, NULL, 7597, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1489123543', 'admin', '2017-03-10 16:00:20', 'admin-1489123543-14891328203798140', 1, 0, '', NULL, NULL, NULL),
(23117, '2017-03-10 16:08:03', NULL, NULL, 7605, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489123543', 'admin', '2017-03-10 16:08:03', 'admin-1489123543-14891332836095198', 1, 1, 'SR', NULL, NULL, NULL),
(23118, '2017-03-10 16:08:36', NULL, NULL, 7605, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489123543', 'admin', '2017-03-10 16:08:36', 'admin-1489123543-14891333167288227', 1, 0, '', NULL, NULL, NULL),
(23119, '2017-03-10 16:32:32', NULL, NULL, 7605, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1489123543', 'admin', '2017-03-10 16:32:32', 'admin-1489123543-14891347523353373', 1, 0, '', NULL, NULL, NULL),
(23120, '2017-03-10 16:53:33', NULL, NULL, 7606, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1489123543', 'admin', '2017-03-10 16:53:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23121, '2017-03-10 16:53:36', NULL, NULL, 7606, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1489123543', 'admin', '2017-03-10 16:53:36', 'admin-1489123543-1489136016670201', 1, 1, 'SR', NULL, NULL, NULL),
(23122, '2017-03-10 16:54:27', NULL, NULL, 7607, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489123543', 'admin', '2017-03-10 16:54:27', 'admin-1489123543-14891360673723570', 1, 1, 'SR', NULL, NULL, NULL),
(23123, '2017-03-10 11:26:31', NULL, NULL, 7590, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1489123543', 'lois', '2017-03-10 11:26:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23124, '2017-03-10 11:29:53', NULL, NULL, 7590, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 11:29:53', 'lois-1489107002-1489116593039682', 1, 0, '', NULL, NULL, NULL),
(23125, '2017-03-10 11:29:53', NULL, NULL, 7590, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 11:29:53', 'lois-1489107002-1489116593039682', 1, 1, 'SR', NULL, NULL, NULL),
(23126, '2017-03-10 11:30:00', NULL, NULL, 7590, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 11:30:00', 'lois-1489107002-1489116599995796', 1, 1, 'SR', NULL, NULL, NULL),
(23127, '2017-03-10 11:30:00', NULL, NULL, 7590, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 11:30:00', 'lois-1489107002-1489116599995796', 1, 1, 'SR', NULL, NULL, NULL),
(23128, '2017-03-10 11:47:38', NULL, NULL, 7590, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 11:47:38', 'lois-1489107002-14891176584303412', 1, 1, 'SR', NULL, NULL, NULL),
(23129, '2017-03-10 11:48:24', NULL, NULL, 7591, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1489123543', 'lois', '2017-03-10 11:48:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23130, '2017-03-10 11:49:06', NULL, NULL, 7591, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 11:49:06', 'lois-1489107002-14891177465923735', 1, 0, '', NULL, NULL, NULL),
(23131, '2017-03-10 11:49:06', NULL, NULL, 7591, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 11:49:06', 'lois-1489107002-14891177465923735', 1, 0, '', NULL, NULL, NULL),
(23132, '2017-03-10 11:49:12', NULL, NULL, 7591, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 11:49:12', 'lois-1489107002-1489117751825584', 1, 1, 'SR', NULL, NULL, NULL),
(23133, '2017-03-10 12:07:47', NULL, NULL, 7592, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.85, 0.0000, 0.0000, 8.85, 1, '27', 1, '1489123543', 'lois', '2017-03-10 12:07:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23134, '2017-03-10 12:07:55', NULL, NULL, 7592, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 12:07:55', 'lois-1489107002-14891188751047850', 1, 1, 'SR', NULL, NULL, NULL),
(23135, '2017-03-10 12:07:55', NULL, NULL, 7592, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 12:07:55', 'lois-1489107002-14891188751047850', 1, 0, '', NULL, NULL, NULL),
(23136, '2017-03-10 12:07:55', NULL, NULL, 7592, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 12:07:55', 'lois-1489107002-14891188751047850', 1, 1, 'SR', NULL, NULL, NULL),
(23137, '2017-03-10 12:17:34', NULL, NULL, 7592, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 12:17:34', 'lois-1489107002-14891194545913382', 1, 1, 'SR', NULL, NULL, NULL),
(23138, '2017-03-10 12:17:34', NULL, NULL, 7592, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 12:17:34', 'lois-1489107002-14891194545913382', 1, 0, '', NULL, NULL, NULL),
(23139, '2017-03-10 12:19:07', NULL, NULL, 7592, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1489123543', 'lois', '2017-03-10 12:19:07', 'lois-1489107002-14891195472681981', 1, 0, '', NULL, NULL, NULL),
(23140, '2017-03-10 12:19:07', NULL, NULL, 7592, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 12:19:07', 'lois-1489107002-14891195472681981', 1, 1, 'SR', NULL, NULL, NULL),
(23141, '2017-03-10 12:37:23', NULL, NULL, 7593, 0, 182, '117', 'Open Drinks ', 'post card', 'Cold Drinks', 'Fresh Juice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 12:37:23', 'lois-1489107002-14891206431188274', 1, 0, '', 1, NULL, NULL),
(23142, '2017-03-10 12:39:40', NULL, NULL, 7594, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1489123543', 'lois', '2017-03-10 12:39:40', 'lois-1489107002-14891207807824646', 1, 0, '', 1, NULL, NULL),
(23143, '2017-03-10 12:39:40', NULL, NULL, 7594, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1489123543', 'lois', '2017-03-10 12:39:40', 'lois-1489107002-14891207807824646', 1, 0, '', 1, NULL, NULL),
(23144, '2017-03-10 12:39:40', NULL, NULL, 7594, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1489123543', 'lois', '2017-03-10 12:39:40', 'lois-1489107002-14891207807824646', 1, 0, '', 1, NULL, NULL),
(23145, '2017-03-10 13:08:30', NULL, NULL, 7591, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 13:08:30', 'lois-1489107002-14891225099578468', 1, 0, '', NULL, NULL, NULL),
(23146, '2017-03-10 13:09:51', NULL, NULL, 7595, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1489123543', 'lois', '2017-03-10 13:09:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23147, '2017-03-10 13:10:03', NULL, NULL, 7595, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 13:10:03', 'lois-1489107002-1489122602828858', 1, 1, 'SR', NULL, NULL, NULL),
(23148, '2017-03-10 13:10:03', NULL, NULL, 7595, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 13:10:03', 'lois-1489107002-1489122602828858', 1, 1, 'SR', NULL, NULL, NULL),
(23149, '2017-03-10 13:12:59', NULL, NULL, 7595, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 13:12:59', 'lois-1489107002-14891227792237493', 1, 1, 'SR', NULL, NULL, NULL),
(23150, '2017-03-10 13:12:59', NULL, NULL, 7595, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 13:12:59', 'lois-1489107002-14891227792237493', 1, 1, 'SR', NULL, NULL, NULL),
(23151, '2017-03-10 00:00:00', NULL, NULL, 7603, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, NULL, NULL, 1.20, 1, '27', 1, '1489123543', 'lois', '2017-03-10 13:21:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23152, '2017-03-10 14:59:19', NULL, NULL, 7604, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1489123543', 'admin', '2017-03-10 14:59:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23153, '2017-03-10 14:51:00', NULL, NULL, 7602, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1489123543', 'admin', '2017-03-10 14:51:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23154, '2017-03-10 14:13:29', NULL, NULL, 7592, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1489123543', 'admin', '2017-03-10 14:13:29', 'admin-1489123543-14891264088508737', 1, 0, '', NULL, NULL, NULL),
(23155, '2017-03-10 14:19:39', NULL, NULL, 7595, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1489123543', 'admin', '2017-03-10 14:19:39', 'admin-1489123543-1489126779360302', 1, 0, '', NULL, NULL, NULL),
(23156, '2017-03-10 14:21:49', NULL, NULL, 7597, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1489123543', 'admin', '2017-03-10 14:21:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23157, '2017-03-10 14:22:04', NULL, NULL, 7597, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489123543', 'admin', '2017-03-10 14:22:04', 'admin-1489123543-1489126924312701', 1, 1, 'SR', NULL, NULL, NULL),
(23158, '2017-03-10 14:25:36', NULL, NULL, 7598, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1489123543', 'admin', '2017-03-10 14:25:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23159, '2017-03-10 14:25:45', NULL, NULL, 7598, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1489123543', 'admin', '2017-03-10 14:25:45', 'admin-1489123543-14891271452352511', 1, 1, 'SR', NULL, NULL, NULL),
(23160, '2017-03-10 14:25:45', NULL, NULL, 7598, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1489123543', 'admin', '2017-03-10 14:25:45', 'admin-1489123543-14891271452352511', 1, 1, 'SR', NULL, NULL, NULL),
(23161, '2017-03-10 14:25:47', NULL, NULL, 7599, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.19, 0.0000, 0.0000, 1.19, 1, '27', 1, '1489123543', 'admin', '2017-03-10 14:25:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23162, '2017-03-10 14:25:55', NULL, NULL, 7599, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489123543', 'admin', '2017-03-10 14:25:55', 'admin-1489123543-14891271552149949', 1, 1, 'SR', NULL, NULL, NULL),
(23163, '2017-03-10 14:25:55', NULL, NULL, 7599, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1489123543', 'admin', '2017-03-10 14:25:55', 'admin-1489123543-14891271552149949', 1, 0, '', NULL, NULL, NULL),
(23164, '2017-03-10 16:07:54', NULL, NULL, 7605, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1489123543', 'admin', '2017-03-10 16:07:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23165, '2017-03-10 16:08:03', NULL, NULL, 7605, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489123543', 'admin', '2017-03-10 16:08:03', 'admin-1489123543-14891332836095198', 1, 1, 'SR', NULL, NULL, NULL),
(23166, '2017-03-10 14:46:37', NULL, NULL, 7601, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1489123543', 'admin', '2017-03-10 14:46:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23167, '2017-03-10 14:46:43', NULL, NULL, 7601, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489123543', 'admin', '2017-03-10 14:46:43', 'admin-1489123543-14891284037585311', 1, 1, 'SR', NULL, NULL, NULL),
(23168, '2017-03-10 14:46:43', NULL, NULL, 7601, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489123543', 'admin', '2017-03-10 14:46:43', 'admin-1489123543-14891284037585311', 1, 1, 'SR', NULL, NULL, NULL),
(23169, '2017-03-10 00:00:00', NULL, NULL, 7602, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 13:21:52', 'lois-1489107002-14891233122461930', 1, 0, '', NULL, NULL, NULL),
(23170, '2017-03-10 00:00:00', NULL, NULL, 7603, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 13:21:52', 'lois-1489107002-14891233122461930', 1, 1, 'SR', NULL, NULL, NULL),
(23171, '2017-03-10 11:18:20', NULL, NULL, 7589, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 11:18:20', 'lois-1489107002-14891158998131256', 1, 0, '', NULL, NULL, NULL),
(23172, '2017-03-10 11:18:20', NULL, NULL, 7589, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489123543', 'lois', '2017-03-10 11:18:20', 'lois-1489107002-14891158998131256', 1, 0, '', NULL, NULL, NULL),
(23173, '2017-03-10 11:18:06', NULL, NULL, 7589, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1489123543', 'lois', '2017-03-10 11:18:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23174, '2017-03-11 16:13:45', NULL, NULL, 7643, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1489212539', 'admin', '2017-03-11 16:13:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23175, '2017-03-11 14:08:49', NULL, NULL, 7635, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:08:49', 'admin-1489202449-14892125292956670', 1, 0, '', NULL, NULL, NULL),
(23176, '2017-03-11 13:44:56', NULL, NULL, 7629, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 13:44:56', 'admin-1489202449-14892110959911613', 1, 0, '', NULL, NULL, NULL),
(23177, '2017-03-11 13:45:13', NULL, NULL, 7629, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 13:45:13', 'admin-1489202449-14892111128162242', 1, 1, 'SR', NULL, NULL, NULL),
(23178, '2017-03-11 13:45:13', NULL, NULL, 7629, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 13:45:13', 'admin-1489202449-14892111128162242', 1, 1, 'SR', NULL, NULL, NULL),
(23179, '2017-03-11 13:52:44', NULL, NULL, 7630, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1489212539', 'admin', '2017-03-11 13:52:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23180, '2017-03-11 13:53:00', NULL, NULL, 7630, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 13:53:00', 'admin-1489202449-14892115798156497', 1, 0, '', NULL, NULL, NULL),
(23181, '2017-03-11 13:53:00', NULL, NULL, 7630, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 13:53:00', 'admin-1489202449-14892115798156497', 1, 0, '', NULL, NULL, NULL),
(23182, '2017-03-11 13:53:07', NULL, NULL, 7630, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 13:53:07', 'admin-1489202449-1489211587535811', 1, 1, 'SR', NULL, NULL, NULL),
(23183, '2017-03-11 13:58:01', NULL, NULL, 7631, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1489212539', 'admin', '2017-03-11 13:58:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23184, '2017-03-11 13:58:06', NULL, NULL, 7631, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 13:58:06', 'admin-1489202449-14892118866202010', 1, 1, 'SR', NULL, NULL, NULL),
(23185, '2017-03-11 13:58:06', NULL, NULL, 7631, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 13:58:06', 'admin-1489202449-14892118866202010', 1, 1, 'SR', NULL, NULL, NULL),
(23186, '2017-03-11 14:03:28', NULL, NULL, 7632, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:03:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23187, '2017-03-11 14:03:49', NULL, NULL, 7632, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:03:49', 'admin-1489202449-14892122296749522', 1, 1, 'SR', NULL, NULL, NULL),
(23188, '2017-03-11 14:03:49', NULL, NULL, 7632, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:03:49', 'admin-1489202449-14892122296749522', 1, 1, 'SR', NULL, NULL, NULL),
(23189, '2017-03-11 14:03:49', NULL, NULL, 7632, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:03:49', 'admin-1489202449-14892122296749522', 1, 1, 'SR', NULL, NULL, NULL),
(23190, '2017-03-11 14:04:54', NULL, NULL, 7631, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:04:54', 'admin-1489202449-14892122947841155', 1, 1, 'SR', NULL, NULL, NULL),
(23191, '2017-03-11 14:04:54', NULL, NULL, 7631, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:04:54', 'admin-1489202449-14892122947841155', 1, 0, '', NULL, NULL, NULL),
(23192, '2017-03-11 14:07:33', NULL, NULL, 7633, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:07:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23193, '2017-03-11 14:07:48', NULL, NULL, 7633, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:07:48', 'admin-1489202449-14892124681898356', 1, 0, '', NULL, NULL, NULL),
(23194, '2017-03-11 14:07:48', NULL, NULL, 7633, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:07:48', 'admin-1489202449-14892124681898356', 1, 0, '', NULL, NULL, NULL),
(23195, '2017-03-11 14:07:52', NULL, NULL, 7634, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:07:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23196, '2017-03-11 14:08:01', NULL, NULL, 7634, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 2, 9.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:08:01', 'admin-1489202449-14892124813024449', 1, 1, 'SR', NULL, NULL, NULL),
(23197, '2017-03-11 16:57:09', NULL, NULL, 7645, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1489212539', 'admin', '2017-03-11 16:57:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23198, '2017-03-11 14:08:49', NULL, NULL, 7635, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:08:49', 'admin-1489202449-14892125292956670', 1, 0, '', NULL, NULL, NULL),
(23199, '2017-03-11 14:08:49', NULL, NULL, 7635, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:08:49', 'admin-1489202449-14892125292956670', 1, 1, 'SR', NULL, NULL, NULL),
(23200, '2017-03-11 14:08:49', NULL, NULL, 7635, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:08:49', 'admin-1489202449-14892125292956670', 1, 1, 'SR', NULL, NULL, NULL),
(23201, '2017-03-11 14:08:49', NULL, NULL, 7635, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:08:49', 'admin-1489202449-14892125292956670', 1, 1, 'SR', NULL, NULL, NULL),
(23202, '2017-03-11 14:20:18', NULL, NULL, 7636, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:20:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23203, '2017-03-11 14:33:18', NULL, NULL, 7637, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:33:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23204, '2017-03-11 14:33:23', NULL, NULL, 7637, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:33:23', 'admin-1489212539-14892140029083119', 1, 1, 'SR', NULL, NULL, NULL),
(23205, '2017-03-11 14:39:30', NULL, NULL, 7634, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:39:30', 'admin-1489212539-14892143702905358', 1, 1, 'SR', NULL, NULL, NULL),
(23206, '2017-03-11 14:41:25', NULL, NULL, 7638, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:41:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23207, '2017-03-11 14:42:15', NULL, NULL, 7638, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:42:15', 'admin-1489212539-14892145354462048', 1, 1, 'SR', NULL, NULL, NULL),
(23208, '2017-03-11 14:42:15', NULL, NULL, 7638, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:42:15', 'admin-1489212539-14892145354462048', 1, 1, 'SR', NULL, NULL, NULL),
(23209, '2017-03-11 14:42:15', NULL, NULL, 7638, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:42:15', 'admin-1489212539-14892145354462048', 1, 0, '', NULL, NULL, NULL),
(23210, '2017-03-11 14:42:15', NULL, NULL, 7638, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:42:15', 'admin-1489212539-14892145354462048', 1, 1, 'SR', NULL, NULL, NULL),
(23211, '2017-03-11 14:42:40', NULL, NULL, 7638, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:42:40', 'admin-1489212539-1489214560700640', 1, 0, '', NULL, NULL, NULL),
(23212, '2017-03-11 16:01:40', NULL, NULL, 7642, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 16:01:40', 'admin-1489212539-14892192999243372', 1, 0, '', NULL, NULL, NULL),
(23213, '2017-03-11 16:01:31', NULL, NULL, 7642, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1489212539', 'admin', '2017-03-11 16:01:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23214, '2017-03-11 15:59:00', NULL, NULL, 7639, 0, 181, '116', 'Open Food ', 'rice and bread', 'Meals', 'Perfect Meals', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1489212539', 'admin', '2017-03-11 15:59:00', 'admin-1489212539-14892191406773244', 1, 0, '', NULL, NULL, NULL),
(23215, '2017-03-11 15:54:10', NULL, NULL, 7641, 0, 182, '117', 'Open Drinks ', 'postcard', 'Cold Drinks', 'Fresh Juice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 15:54:10', 'admin-1489212539-14892188502701462', 1, 0, '', 1, NULL, NULL),
(23216, '2017-03-11 15:32:11', NULL, NULL, 7640, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 15:32:11', 'admin-1489212539-14892175318177145', 1, 1, 'SR', NULL, NULL, NULL),
(23217, '2017-03-11 15:32:12', NULL, NULL, 7640, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 15:32:12', 'admin-1489212539-14892175318177145', 1, 1, 'SR', NULL, NULL, NULL),
(23218, '2017-03-11 15:48:44', NULL, NULL, 7639, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 15:48:44', 'admin-1489212539-14892185245244920', 1, 0, '', NULL, NULL, NULL),
(23219, '2017-03-11 15:48:44', NULL, NULL, 7639, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 15:48:44', 'admin-1489212539-14892185245244920', 1, 0, '', NULL, NULL, NULL),
(23220, '2017-03-11 12:30:01', NULL, NULL, 7624, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1489212539', 'admin', '2017-03-11 12:30:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23221, '2017-03-11 11:33:13', NULL, NULL, 7620, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:33:13', 'admin-1489202449-1489203193152768', 1, 0, '', NULL, NULL, NULL),
(23222, '2017-03-11 11:35:41', NULL, NULL, 7621, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:35:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23223, '2017-03-11 11:35:44', NULL, NULL, 7621, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:35:44', 'admin-1489202449-14892033445107275', 1, 0, '', NULL, NULL, NULL),
(23224, '2017-03-11 11:38:21', NULL, NULL, 7621, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:38:21', 'admin-1489202449-14892035008947916', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(23225, '2017-03-11 11:21:16', NULL, NULL, 7619, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:21:16', 'admin-1489202449-1489202476524134', 1, 1, 'SR', NULL, NULL, NULL),
(23226, '2017-03-11 11:21:16', NULL, NULL, 7619, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:21:16', 'admin-1489202449-1489202476524134', 1, 0, '', NULL, NULL, NULL),
(23227, '2017-03-11 11:33:03', NULL, NULL, 7620, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:33:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23228, '2017-03-11 11:18:34', NULL, NULL, 7614, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:18:34', 'admin-1489200450-14892023145888433', 1, 0, '', NULL, NULL, NULL),
(23229, '2017-03-11 11:20:57', NULL, NULL, 7619, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:20:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23230, '2017-03-11 11:21:16', NULL, NULL, 7619, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:21:16', 'admin-1489202449-1489202476524134', 1, 0, '', NULL, NULL, NULL),
(23231, '2017-03-11 11:21:16', NULL, NULL, 7619, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:21:16', 'admin-1489202449-1489202476524134', 1, 0, '', NULL, NULL, NULL),
(23232, '2017-03-11 10:58:30', NULL, NULL, 7616, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:58:30', 'admin-1489200450-1489201109898397', 1, 1, 'SR', NULL, NULL, NULL),
(23233, '2017-03-11 10:46:29', NULL, NULL, 7615, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:46:29', 'admin-1489194179-14892003890394082', 1, 0, '', NULL, NULL, NULL),
(23234, '2017-03-11 10:57:26', NULL, NULL, 7615, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:57:26', 'admin-1489200450-14892010461199921', 1, 1, 'SR', NULL, NULL, NULL),
(23235, '2017-03-11 10:46:29', NULL, NULL, 7615, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:46:29', 'admin-1489194179-14892003890394082', 1, 0, '', NULL, NULL, NULL),
(23236, '2017-03-11 10:46:29', NULL, NULL, 7615, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:46:29', 'admin-1489194179-14892003890394082', 1, 0, '', NULL, NULL, NULL),
(23237, '2017-03-11 10:47:42', NULL, NULL, 7615, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:47:42', 'admin-1489200450-14892004620545610', 1, 0, '', NULL, NULL, NULL),
(23238, '2017-03-11 10:48:09', NULL, NULL, 7614, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:48:09', 'admin-1489200450-14892004889867829', 1, 0, '', NULL, NULL, NULL),
(23239, '2017-03-11 15:32:01', NULL, NULL, 7640, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 15:32:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23240, '2017-03-11 15:29:48', NULL, NULL, 7639, 0, 181, '116', 'Open Food ', '3scramble egg/toast', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 15:29:48', 'admin-1489212539-14892173878394645', 1, 0, '', NULL, NULL, NULL),
(23241, '2017-03-11 15:29:48', NULL, NULL, 7639, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 15:29:48', 'admin-1489212539-14892173878394645', 1, 1, 'SR', NULL, NULL, NULL),
(23242, '2017-03-11 15:24:08', NULL, NULL, 7639, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 15:24:08', 'admin-1489212539-14892170486384217', 1, 1, 'SR', NULL, NULL, NULL),
(23243, '2017-03-11 15:24:08', NULL, NULL, 7639, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 15:24:08', 'admin-1489212539-14892170486384217', 1, 0, '', NULL, NULL, NULL),
(23244, '2017-03-11 15:24:08', NULL, NULL, 7639, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 15:24:08', 'admin-1489212539-14892170486384217', 1, 0, '', NULL, NULL, NULL),
(23245, '2017-03-11 15:23:50', NULL, NULL, 7639, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.45, 0.0000, 0.0000, 7.45, 1, '27', 1, '1489212539', 'admin', '2017-03-11 15:23:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23246, '2017-03-11 14:57:33', NULL, NULL, 7636, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:57:33', 'admin-1489212539-14892154535719930', 1, 1, 'SR', NULL, NULL, NULL),
(23247, '2017-03-11 14:42:40', NULL, NULL, 7638, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:42:40', 'admin-1489212539-1489214560700640', 1, 1, 'SR', NULL, NULL, NULL),
(23248, '2017-03-11 14:42:40', NULL, NULL, 7638, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:42:40', 'admin-1489212539-1489214560700640', 1, 1, 'SR', NULL, NULL, NULL),
(23249, '2017-03-11 11:33:13', NULL, NULL, 7620, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:33:13', 'admin-1489202449-1489203193152768', 1, 1, 'SR', NULL, NULL, NULL),
(23250, '2017-03-11 10:50:51', NULL, NULL, 7615, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:50:51', 'admin-1489200450-14892006515369325', 1, 0, '', NULL, NULL, NULL),
(23251, '2017-03-11 10:50:51', NULL, NULL, 7615, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:50:51', 'admin-1489200450-14892006515369325', 1, 0, '', NULL, NULL, NULL),
(23252, '2017-03-11 10:50:51', NULL, NULL, 7615, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:50:51', 'admin-1489200450-14892006515369325', 1, 1, 'SR', NULL, NULL, NULL),
(23253, '2017-03-11 14:08:14', NULL, NULL, 7635, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:08:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23254, '2017-03-11 14:08:49', NULL, NULL, 7635, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:08:49', 'admin-1489202449-14892125292956670', 1, 0, '', NULL, NULL, NULL),
(23255, '2017-03-11 16:14:00', NULL, NULL, 7643, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 16:14:00', 'admin-1489212539-14892200404113417', 1, 1, 'SR', NULL, NULL, NULL),
(23256, '2017-03-11 16:19:44', NULL, NULL, 7644, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1489212539', 'admin', '2017-03-11 16:19:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23257, '2017-03-11 16:19:49', NULL, NULL, 7644, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 16:19:49', 'admin-1489212539-14892203887997552', 1, 1, 'SR', NULL, NULL, NULL),
(23258, '2017-03-11 16:34:38', NULL, NULL, 7642, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 16:34:38', 'admin-1489212539-14892212786142129', 1, 0, '', NULL, NULL, NULL),
(23259, '2017-03-11 16:57:13', NULL, NULL, 7645, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 16:57:13', 'admin-1489212539-14892226334449565', 1, 1, 'SR', NULL, NULL, NULL),
(23260, '2017-03-11 16:58:02', NULL, NULL, 7646, 0, 181, '116', 'Open Food ', 'cookie', 'Meals', 'Perfect Meals', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1489212539', 'admin', '2017-03-11 16:58:02', 'admin-1489212539-1489222682283688', 1, 0, '', 1, NULL, NULL),
(23261, '2017-03-11 14:17:38', NULL, NULL, 7632, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:17:38', 'admin-1489212539-1489213058545343', 1, 1, 'SR', NULL, NULL, NULL),
(23262, '2017-03-11 14:17:38', NULL, NULL, 7632, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:17:38', 'admin-1489212539-1489213058545343', 1, 1, 'SR', NULL, NULL, NULL),
(23263, '2017-03-11 14:08:49', NULL, NULL, 7635, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 14:08:49', 'admin-1489202449-14892125292956670', 1, 0, '', NULL, NULL, NULL),
(23264, '2017-03-11 16:34:38', NULL, NULL, 7642, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 16:34:38', 'admin-1489212539-14892212786142129', 1, 1, 'SR', NULL, NULL, NULL),
(23265, '2017-03-11 16:13:50', NULL, NULL, 7643, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 16:13:50', 'admin-1489212539-14892200300942519', 1, 1, 'SR', NULL, NULL, NULL),
(23266, '2017-03-11 16:14:00', NULL, NULL, 7643, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 16:14:00', 'admin-1489212539-14892200404113417', 1, 1, 'SR', NULL, NULL, NULL),
(23267, '2017-03-11 12:37:20', NULL, NULL, 7621, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 12:37:20', 'admin-1489202449-14892070402341280', 1, 0, '', NULL, NULL, NULL),
(23268, '2017-03-11 12:50:06', NULL, NULL, 7625, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 12:50:06', 'admin-1489202449-1489207805967717', 1, 1, 'SR', NULL, NULL, NULL),
(23269, '2017-03-11 12:50:06', NULL, NULL, 7625, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 12:50:06', 'admin-1489202449-1489207805967717', 1, 1, 'SR', NULL, NULL, NULL),
(23270, '2017-03-11 12:50:06', NULL, NULL, 7625, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 12:50:06', 'admin-1489202449-1489207805967717', 1, 0, '', NULL, NULL, NULL),
(23271, '2017-03-11 12:50:06', NULL, NULL, 7625, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 12:50:06', 'admin-1489202449-1489207805967717', 1, 0, '', NULL, NULL, NULL),
(23272, '2017-03-11 12:56:45', NULL, NULL, 7626, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1489212539', 'admin', '2017-03-11 12:56:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23273, '2017-03-11 12:56:51', NULL, NULL, 7626, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 12:56:51', 'admin-1489202449-14892082116977676', 1, 1, 'SR', NULL, NULL, NULL),
(23274, '2017-03-11 12:56:51', NULL, NULL, 7626, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 12:56:51', 'admin-1489202449-14892082116977676', 1, 0, '', NULL, NULL, NULL),
(23275, '2017-03-11 13:22:59', NULL, NULL, 7627, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1489212539', 'admin', '2017-03-11 13:22:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23276, '2017-03-11 13:23:04', NULL, NULL, 7627, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 13:23:04', 'admin-1489202449-14892097843353832', 1, 1, 'SR', NULL, NULL, NULL),
(23277, '2017-03-11 13:23:12', NULL, NULL, 7627, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 13:23:12', 'admin-1489202449-14892097920366596', 1, 1, 'SR', NULL, NULL, NULL),
(23278, '2017-03-11 13:23:12', NULL, NULL, 7627, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 13:23:12', 'admin-1489202449-14892097920366596', 1, 1, 'SR', NULL, NULL, NULL),
(23279, '2017-03-11 12:49:45', NULL, NULL, 7625, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 12:49:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23280, '2017-03-11 11:38:33', NULL, NULL, 7621, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:38:33', 'admin-1489202449-14892035130806583', 1, 1, 'SR', NULL, NULL, NULL),
(23281, '2017-03-11 11:39:16', NULL, NULL, 7621, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:39:16', 'admin-1489202449-14892035565756085', 1, 1, 'SR', NULL, NULL, NULL),
(23282, '2017-03-11 11:39:16', NULL, NULL, 7621, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:39:16', 'admin-1489202449-14892035565756085', 1, 0, '', NULL, NULL, NULL),
(23283, '2017-03-11 11:50:12', NULL, NULL, 7622, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:50:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23284, '2017-03-11 11:50:22', NULL, NULL, 7622, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:50:22', 'admin-1489202449-14892042223537451', 1, 0, '', NULL, NULL, NULL),
(23285, '2017-03-11 11:50:22', NULL, NULL, 7622, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:50:22', 'admin-1489202449-14892042223537451', 1, 0, '', NULL, NULL, NULL),
(23286, '2017-03-11 11:50:30', NULL, NULL, 7622, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:50:30', 'admin-1489202449-1489204230242168', 1, 0, '', NULL, NULL, NULL),
(23287, '2017-03-11 11:38:33', NULL, NULL, 7621, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:38:33', 'admin-1489202449-14892035130806583', 1, 0, '', NULL, NULL, NULL),
(23288, '2017-03-11 13:44:56', NULL, NULL, 7629, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 13:44:56', 'admin-1489202449-14892110959911613', 1, 1, 'SR', NULL, NULL, NULL),
(23289, '2017-03-11 13:44:56', NULL, NULL, 7629, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 13:44:56', 'admin-1489202449-14892110959911613', 1, 0, '', NULL, NULL, NULL),
(23290, '2017-03-11 13:43:52', NULL, NULL, 7629, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 13:43:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23291, '2017-03-11 13:41:47', NULL, NULL, 7628, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 13:41:47', 'admin-1489202449-14892109076621181', 1, 0, '', NULL, NULL, NULL),
(23292, '2017-03-11 13:41:39', NULL, NULL, 7628, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 13:41:39', 'admin-1489202449-14892108995431538', 1, 1, 'SR', NULL, NULL, NULL),
(23293, '2017-03-11 13:41:39', NULL, NULL, 7628, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 13:41:39', 'admin-1489202449-14892108995431538', 1, 1, 'SR', NULL, NULL, NULL),
(23294, '2017-03-11 13:41:32', NULL, NULL, 7628, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1489212539', 'admin', '2017-03-11 13:41:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23295, '2017-03-11 12:30:25', NULL, NULL, 7624, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 12:30:25', 'admin-1489202449-14892066248581843', 1, 1, 'SR', NULL, NULL, NULL),
(23296, '2017-03-11 12:06:34', NULL, NULL, 7619, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 12:06:34', 'admin-1489202449-14892051946163157', 1, 0, '', NULL, NULL, NULL),
(23297, '2017-03-11 11:57:37', NULL, NULL, 7623, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:57:37', 'admin-1489202449-14892046573781569', 1, 1, 'SR', NULL, NULL, NULL),
(23298, '2017-03-11 11:57:22', NULL, NULL, 7623, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:57:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23299, '2017-03-11 11:57:37', NULL, NULL, 7623, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:57:37', 'admin-1489202449-14892046573781569', 1, 0, '', NULL, NULL, NULL),
(23300, '2017-03-11 11:50:30', NULL, NULL, 7622, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:50:30', 'admin-1489202449-1489204230242168', 1, 0, '', NULL, NULL, NULL),
(23301, '2017-03-11 09:03:16', NULL, NULL, 7608, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 09:03:16', 'admin-1489194179-14891941964382299', 1, 0, '', NULL, NULL, NULL),
(23302, '2017-03-11 09:03:16', NULL, NULL, 7608, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 09:03:16', 'admin-1489194179-14891941964382299', 1, 1, 'SR', NULL, NULL, NULL),
(23303, '2017-03-11 09:04:31', NULL, NULL, 7609, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1489212539', 'admin', '2017-03-11 09:04:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23304, '2017-03-11 09:05:46', NULL, NULL, 7609, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 09:05:46', 'admin-1489194179-14891943459188455', 1, 0, '', NULL, NULL, NULL),
(23305, '2017-03-11 09:05:46', NULL, NULL, 7609, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 09:05:46', 'admin-1489194179-14891943459188455', 1, 0, '', NULL, NULL, NULL),
(23306, '2017-03-11 09:05:46', NULL, NULL, 7609, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 09:05:46', 'admin-1489194179-14891943459188455', 1, 1, 'SR', NULL, NULL, NULL),
(23307, '2017-03-11 09:16:16', NULL, NULL, 7610, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1489212539', 'admin', '2017-03-11 09:16:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23308, '2017-03-11 09:16:38', NULL, NULL, 7610, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 09:16:38', 'admin-1489194179-14891949982946457', 1, 1, 'SR', NULL, NULL, NULL),
(23309, '2017-03-11 09:16:38', NULL, NULL, 7610, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 09:16:38', 'admin-1489194179-14891949982946457', 1, 1, 'SR', NULL, NULL, NULL),
(23310, '2017-03-11 09:16:38', NULL, NULL, 7610, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 09:16:38', 'admin-1489194179-14891949982946457', 1, 0, '', NULL, NULL, NULL),
(23311, '2017-03-11 09:16:38', NULL, NULL, 7610, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 09:16:38', 'admin-1489194179-14891949982946457', 1, 0, '', NULL, NULL, NULL),
(23312, '2017-03-11 09:50:18', NULL, NULL, 7611, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1489212539', 'admin', '2017-03-11 09:50:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23313, '2017-03-11 09:51:43', NULL, NULL, 7611, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 09:51:43', 'admin-1489194179-14891971034924979', 1, 1, 'SR', NULL, NULL, NULL),
(23314, '2017-03-11 09:51:43', NULL, NULL, 7611, 0, 182, '117', 'Open Drinks ', 'ginger lemongrass', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 09:51:43', 'admin-1489194179-14891971034924979', 1, 0, '', NULL, NULL, NULL),
(23315, '2017-03-11 10:01:54', NULL, NULL, 7612, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.10, 0.0000, 0.0000, 11.10, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:01:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23316, '2017-03-11 10:02:11', NULL, NULL, 7612, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:02:11', 'admin-1489194179-14891977311318319', 1, 0, '', NULL, NULL, NULL),
(23317, '2017-03-11 10:02:11', NULL, NULL, 7612, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:02:11', 'admin-1489194179-14891977311318319', 1, 0, '', NULL, NULL, NULL),
(23318, '2017-03-11 10:02:11', NULL, NULL, 7612, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:02:11', 'admin-1489194179-14891977311318319', 1, 0, '', NULL, NULL, NULL),
(23319, '2017-03-11 10:02:11', NULL, NULL, 7612, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:02:11', 'admin-1489194179-14891977311318319', 1, 0, '', NULL, NULL, NULL),
(23320, '2017-03-11 10:02:11', NULL, NULL, 7612, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:02:11', 'admin-1489194179-14891977311318319', 1, 0, '', NULL, NULL, NULL),
(23321, '2017-03-11 10:02:23', NULL, NULL, 7612, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:02:23', 'admin-1489194179-14891977431306757', 1, 1, 'SR', NULL, NULL, NULL),
(23322, '2017-03-11 10:02:23', NULL, NULL, 7612, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:02:23', 'admin-1489194179-14891977431306757', 1, 1, 'SR', NULL, NULL, NULL),
(23323, '2017-03-11 10:02:23', NULL, NULL, 7612, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:02:23', 'admin-1489194179-14891977431306757', 1, 0, '', NULL, NULL, NULL),
(23324, '2017-03-11 10:13:16', NULL, NULL, 7613, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:13:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23325, '2017-03-11 10:13:31', NULL, NULL, 7613, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:13:31', 'admin-1489194179-14891984117345745', 1, 0, '', NULL, NULL, NULL),
(23326, '2017-03-11 10:13:31', NULL, NULL, 7613, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:13:31', 'admin-1489194179-14891984117345745', 1, 0, '', NULL, NULL, NULL),
(23327, '2017-03-11 10:13:31', NULL, NULL, 7613, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:13:31', 'admin-1489194179-14891984117345745', 1, 0, '', NULL, NULL, NULL),
(23328, '2017-03-11 10:14:00', NULL, NULL, 7613, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:14:00', 'admin-1489194179-14891984405561742', 1, 1, 'SR', NULL, NULL, NULL),
(23329, '2017-03-11 10:14:00', NULL, NULL, 7613, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:14:00', 'admin-1489194179-14891984405561742', 1, 0, '', NULL, NULL, NULL),
(23330, '2017-03-11 11:14:23', NULL, NULL, 7618, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:14:23', 'admin-1489200450-14892020631322729', 1, 0, '', NULL, NULL, NULL),
(23331, '2017-03-11 11:14:18', NULL, NULL, 7618, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:14:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23332, '2017-03-11 11:01:29', NULL, NULL, 7617, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:01:29', 'admin-1489200450-14892012889553152', 1, 0, '', NULL, NULL, NULL),
(23333, '2017-03-11 11:01:29', NULL, NULL, 7617, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:01:29', 'admin-1489200450-14892012889553152', 1, 0, '', NULL, NULL, NULL),
(23334, '2017-03-11 11:01:19', NULL, NULL, 7617, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1489212539', 'admin', '2017-03-11 11:01:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23335, '2017-03-11 10:58:30', NULL, NULL, 7616, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:58:30', 'admin-1489200450-1489201109898397', 1, 1, 'SR', NULL, NULL, NULL),
(23336, '2017-03-11 10:58:30', NULL, NULL, 7616, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:58:30', 'admin-1489200450-1489201109898397', 1, 1, 'SR', NULL, NULL, NULL),
(23337, '2017-03-11 10:58:21', NULL, NULL, 7616, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:58:21', 'admin-1489200450-14892011009269381', 1, 0, '', NULL, NULL, NULL),
(23338, '2017-03-11 10:58:14', NULL, NULL, 7616, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:58:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23339, '2017-03-11 10:58:21', NULL, NULL, 7616, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:58:21', 'admin-1489200450-14892011009269381', 1, 0, '', NULL, NULL, NULL),
(23340, '2017-03-11 10:48:09', NULL, NULL, 7614, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:48:09', 'admin-1489200450-14892004889867829', 1, 0, '', NULL, NULL, NULL),
(23341, '2017-03-11 10:48:09', NULL, NULL, 7614, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:48:09', 'admin-1489200450-14892004889867829', 1, 1, 'SR', NULL, NULL, NULL),
(23342, '2017-03-11 10:48:09', NULL, NULL, 7614, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:48:09', 'admin-1489200450-14892004889867829', 1, 0, '', NULL, NULL, NULL),
(23343, '2017-03-11 10:46:29', NULL, NULL, 7615, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:46:29', 'admin-1489194179-14892003890394082', 1, 0, '', NULL, NULL, NULL),
(23344, '2017-03-11 10:46:08', NULL, NULL, 7615, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.10, 0.0000, 0.0000, 13.10, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:46:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23345, '2017-03-11 10:36:50', NULL, NULL, 7614, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:36:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23346, '2017-03-11 10:14:00', NULL, NULL, 7613, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:14:00', 'admin-1489194179-14891984405561742', 1, 0, '', NULL, NULL, NULL),
(23347, '2017-03-11 10:14:00', NULL, NULL, 7613, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489212539', 'admin', '2017-03-11 10:14:00', 'admin-1489194179-14891984405561742', 1, 1, 'SR', NULL, NULL, NULL),
(23348, '2017-03-11 09:03:09', NULL, NULL, 7608, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1489212539', 'admin', '2017-03-11 09:03:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23349, '2017-03-12 15:08:10', NULL, NULL, 7688, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 15:08:10', 'admin-1489299142-14893024901794382', 1, 1, 'SR', NULL, NULL, NULL),
(23350, '2017-03-12 15:08:17', NULL, NULL, 7688, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 15:08:17', 'admin-1489299142-14893024978172262', 1, 1, 'SR', NULL, NULL, NULL),
(23351, '2017-03-12 15:08:17', NULL, NULL, 7688, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 15:08:17', 'admin-1489299142-14893024978172262', 1, 1, 'SR', NULL, NULL, NULL),
(23352, '2017-03-12 15:26:11', NULL, NULL, 7689, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 15:26:11', 'admin-1489299142-14893035714004639', 1, 1, 'SR', 1, NULL, '10.0'),
(23353, '2017-03-12 16:49:18', NULL, NULL, 7691, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 16:49:18', 'admin-1489299142-14893085580224966', 1, 0, '', NULL, NULL, NULL),
(23354, '2017-03-12 18:43:50', NULL, NULL, 7693, 0, 181, '116', 'Open Food ', 'special order', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 18:43:50', 'admin-1489299142-14893154303679523', 1, 0, '', NULL, NULL, NULL),
(23355, '2017-03-12 18:43:50', NULL, NULL, 7693, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 18:43:50', 'admin-1489299142-14893154303679523', 1, 1, 'SR', NULL, NULL, NULL),
(23356, '2017-03-12 14:43:35', NULL, NULL, 7685, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 14:43:35', 'admin-1489299142-1489301015326946', 1, 0, '', NULL, NULL, NULL),
(23357, '2017-03-12 11:05:31', NULL, NULL, 7665, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 11:05:31', 'admin-1489285491-1489287931274168', 1, 1, 'SR', NULL, NULL, NULL),
(23358, '2017-03-12 11:06:25', NULL, NULL, 7666, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1489299142', 'admin', '2017-03-12 11:06:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23359, '2017-03-12 11:06:32', NULL, NULL, 7666, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 11:06:32', 'admin-1489287976-14892879927485058', 1, 0, '', NULL, NULL, NULL),
(23360, '2017-03-12 00:00:00', NULL, NULL, 7667, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:40:46', 'admin-1489285491-1489286446366153', 1, 0, '', NULL, NULL, NULL),
(23361, '2017-03-12 00:00:00', NULL, NULL, 7668, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:41:41', 'admin-1489285491-14892865007447847', 1, 1, 'SR', NULL, NULL, NULL),
(23362, '2017-03-12 11:17:39', NULL, NULL, 7659, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 11:17:39', 'admin-1489287976-14892886593343220', 1, 0, '', NULL, NULL, NULL),
(23363, '2017-03-12 11:42:56', NULL, NULL, 7669, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1489299142', 'admin', '2017-03-12 11:42:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23364, '2017-03-12 11:43:00', NULL, NULL, 7669, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 11:43:00', 'admin-1489287976-14892901807727715', 1, 0, '', NULL, NULL, NULL),
(23365, '2017-03-12 11:43:12', NULL, NULL, 7669, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 11:43:12', 'admin-1489287976-14892901926437038', 1, 0, '', NULL, NULL, NULL),
(23366, '2017-03-12 11:43:12', NULL, NULL, 7669, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 11:43:12', 'admin-1489287976-14892901926437038', 1, 1, 'SR', NULL, NULL, NULL),
(23367, '2017-03-12 11:43:12', NULL, NULL, 7669, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 11:43:12', 'admin-1489287976-14892901926437038', 1, 1, 'SR', NULL, NULL, NULL),
(23368, '2017-03-12 12:02:40', NULL, NULL, 7670, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:02:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23369, '2017-03-12 12:02:50', NULL, NULL, 7670, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:02:50', 'admin-1489287976-14892913704503352', 1, 0, '', NULL, NULL, NULL),
(23370, '2017-03-12 12:02:50', NULL, NULL, 7670, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:02:50', 'admin-1489287976-14892913704503352', 1, 1, 'SR', NULL, NULL, NULL),
(23371, '2017-03-12 12:02:54', NULL, NULL, 7671, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:02:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23372, '2017-03-12 12:03:23', NULL, NULL, 7671, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:03:23', 'admin-1489287976-14892914035452250', 1, 1, 'SR', NULL, NULL, NULL),
(23373, '2017-03-12 10:55:45', NULL, NULL, 7663, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:55:45', 'admin-1489285491-1489287344989992', 1, 0, '', NULL, NULL, NULL),
(23374, '2017-03-12 10:55:45', NULL, NULL, 7663, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:55:45', 'admin-1489285491-1489287344989992', 1, 0, '', NULL, NULL, NULL),
(23375, '2017-03-12 10:55:45', NULL, NULL, 7663, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:55:45', 'admin-1489285491-1489287344989992', 1, 0, '', NULL, NULL, NULL),
(23376, '2017-03-12 10:55:45', NULL, NULL, 7663, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:55:45', 'admin-1489285491-1489287344989992', 1, 1, 'SR', NULL, NULL, NULL),
(23377, '2017-03-12 18:25:57', NULL, NULL, 7693, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1489299142', 'admin', '2017-03-12 18:25:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23378, '2017-03-12 15:46:29', NULL, NULL, 7690, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 15:46:29', 'admin-1489299142-1489304788962851', 1, 1, 'SR', NULL, NULL, NULL),
(23379, '2017-03-12 16:08:43', NULL, NULL, 7691, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1489299142', 'admin', '2017-03-12 16:08:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23380, '2017-03-12 16:08:48', NULL, NULL, 7691, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 16:08:48', 'admin-1489299142-14893061278767879', 1, 0, '', NULL, NULL, NULL),
(23381, '2017-03-12 13:41:21', NULL, NULL, 7680, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:41:21', 'admin-1489293234-1489297281401391', 1, 1, 'SR', NULL, NULL, NULL),
(23382, '2017-03-12 13:45:21', NULL, NULL, 7681, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:45:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23383, '2017-03-12 13:45:43', NULL, NULL, 7681, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:45:43', 'admin-1489293234-14892975431159775', 1, 1, 'SR', NULL, NULL, NULL),
(23384, '2017-03-12 13:45:43', NULL, NULL, 7681, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:45:43', 'admin-1489293234-14892975431159775', 1, 1, 'SR', NULL, NULL, NULL),
(23385, '2017-03-12 13:45:43', NULL, NULL, 7681, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:45:43', 'admin-1489293234-14892975431159775', 1, 1, 'SR', NULL, NULL, NULL),
(23386, '2017-03-12 14:43:35', NULL, NULL, 7685, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 14:43:35', 'admin-1489299142-1489301015326946', 1, 0, '', NULL, NULL, NULL),
(23387, '2017-03-12 14:43:35', NULL, NULL, 7685, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 14:43:35', 'admin-1489299142-1489301015326946', 1, 0, '', NULL, NULL, NULL),
(23388, '2017-03-12 14:43:35', NULL, NULL, 7685, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 14:43:35', 'admin-1489299142-1489301015326946', 1, 1, 'SR', NULL, NULL, NULL),
(23389, '2017-03-12 14:43:35', NULL, NULL, 7685, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 14:43:35', 'admin-1489299142-1489301015326946', 1, 1, 'SR', NULL, NULL, NULL),
(23390, '2017-03-12 14:43:35', NULL, NULL, 7685, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 14:43:35', 'admin-1489299142-1489301015326946', 1, 0, '', NULL, NULL, NULL),
(23391, '2017-03-12 14:45:00', NULL, NULL, 7685, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 14:45:00', 'admin-1489299142-14893011005769999', 1, 1, 'SR', NULL, NULL, NULL),
(23392, '2017-03-12 14:45:00', NULL, NULL, 7685, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 14:45:00', 'admin-1489299142-14893011005769999', 1, 1, 'SR', NULL, NULL, NULL),
(23393, '2017-03-12 15:03:43', NULL, NULL, 7686, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1489299142', 'admin', '2017-03-12 15:03:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23394, '2017-03-12 15:04:08', NULL, NULL, 7686, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 15:04:08', 'admin-1489299142-14893022478688613', 1, 1, 'SR', NULL, NULL, NULL),
(23395, '2017-03-12 15:04:08', NULL, NULL, 7686, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 15:04:08', 'admin-1489299142-14893022478688613', 1, 0, '', NULL, NULL, NULL),
(23396, '2017-03-12 15:04:33', NULL, NULL, 7687, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1489299142', 'admin', '2017-03-12 15:04:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23397, '2017-03-12 15:04:41', NULL, NULL, 7687, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 15:04:41', 'admin-1489299142-14893022812155263', 1, 1, 'SR', NULL, NULL, NULL),
(23398, '2017-03-12 15:04:41', NULL, NULL, 7687, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 15:04:41', 'admin-1489299142-14893022812155263', 1, 1, 'SR', NULL, NULL, NULL),
(23399, '2017-03-12 15:08:04', NULL, NULL, 7688, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1489299142', 'admin', '2017-03-12 15:08:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23400, '2017-03-12 12:33:44', NULL, NULL, 7670, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:33:44', 'admin-1489287976-1489293224367973', 1, 1, 'SR', NULL, NULL, NULL),
(23401, '2017-03-12 12:46:01', NULL, NULL, 7673, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:46:01', 'admin-1489293234-14892939609932145', 1, 0, '', NULL, NULL, NULL),
(23402, '2017-03-12 10:57:25', NULL, NULL, 7664, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:57:25', 'admin-1489285491-14892874451301557', 1, 0, '', NULL, NULL, NULL),
(23403, '2017-03-12 10:57:36', NULL, NULL, 7664, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:57:36', 'admin-1489285491-14892874565269548', 1, 1, 'SR', NULL, NULL, NULL),
(23404, '2017-03-12 10:57:36', NULL, NULL, 7664, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:57:36', 'admin-1489285491-14892874565269548', 1, 1, 'SR', NULL, NULL, NULL),
(23405, '2017-03-12 10:57:36', NULL, NULL, 7664, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:57:36', 'admin-1489285491-14892874565269548', 1, 0, '', NULL, NULL, NULL),
(23406, '2017-03-12 11:05:13', NULL, NULL, 7665, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1489299142', 'admin', '2017-03-12 11:05:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23407, '2017-03-12 11:05:31', NULL, NULL, 7665, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 11:05:31', 'admin-1489285491-1489287931274168', 1, 0, '', NULL, NULL, NULL),
(23408, '2017-03-12 15:46:24', NULL, NULL, 7690, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 15:46:24', 'admin-1489299142-14893047841224679', 1, 1, 'SR', NULL, NULL, NULL),
(23409, '2017-03-12 18:26:21', NULL, NULL, 7693, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 18:26:21', 'admin-1489299142-14893143812904837', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(23410, '2017-03-12 18:26:21', NULL, NULL, 7693, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 18:26:21', 'admin-1489299142-14893143812904837', 1, 0, '', NULL, NULL, NULL),
(23411, '2017-03-12 16:24:05', NULL, NULL, 7692, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 16:24:05', 'admin-1489299142-1489307045387222', 1, 1, 'SR', 1, NULL, '10.0'),
(23412, '2017-03-12 16:17:32', NULL, NULL, 7690, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 16:17:32', 'admin-1489299142-1489306651948285', 1, 0, '', NULL, NULL, NULL),
(23413, '2017-03-12 15:46:16', NULL, NULL, 7690, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1489299142', 'admin', '2017-03-12 15:46:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23414, '2017-03-12 15:46:24', NULL, NULL, 7690, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 15:46:24', 'admin-1489299142-14893047841224679', 1, 0, '', NULL, NULL, NULL),
(23415, '2017-03-12 00:00:00', NULL, NULL, 7677, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:12:24', 'admin-1489287976-14892919442033513', 1, 1, 'SR', NULL, NULL, NULL),
(23416, '2017-03-12 13:16:02', NULL, NULL, 7676, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:16:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23417, '2017-03-12 13:16:38', NULL, NULL, 7676, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:16:38', 'admin-1489293234-14892957981826149', 1, 1, 'SR', NULL, NULL, NULL),
(23418, '2017-03-12 13:16:38', NULL, NULL, 7676, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:16:38', 'admin-1489293234-14892957981826149', 1, 1, 'SR', NULL, NULL, NULL),
(23419, '2017-03-12 13:16:38', NULL, NULL, 7676, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:16:38', 'admin-1489293234-14892957981826149', 1, 0, '', NULL, NULL, NULL),
(23420, '2017-03-12 13:17:17', NULL, NULL, 7676, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:17:17', 'admin-1489293234-14892958373625739', 1, 1, 'SR', NULL, NULL, NULL),
(23421, '2017-03-12 13:17:17', NULL, NULL, 7676, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:17:17', 'admin-1489293234-14892958373625739', 1, 1, 'SR', NULL, NULL, NULL),
(23422, '2017-03-12 00:00:00', NULL, NULL, 7678, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:12:09', 'admin-1489287976-14892919291154233', 1, 0, '', NULL, NULL, NULL),
(23423, '2017-03-12 13:31:21', NULL, NULL, 7678, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:31:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23424, '2017-03-12 13:36:30', NULL, NULL, 7679, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:36:30', 'admin-1489293234-1489296990403938', 1, 0, '', NULL, NULL, NULL),
(23425, '2017-03-12 13:36:30', NULL, NULL, 7679, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:36:30', 'admin-1489293234-1489296990403938', 1, 1, 'SR', NULL, NULL, NULL),
(23426, '2017-03-12 13:36:49', NULL, NULL, 7679, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:36:49', 'admin-1489293234-14892970091604136', 1, 0, '', NULL, NULL, NULL),
(23427, '2017-03-12 13:39:45', NULL, NULL, 7676, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:39:45', 'admin-1489293234-1489297185521617', 1, 1, 'SR', NULL, NULL, NULL),
(23428, '2017-03-12 12:03:23', NULL, NULL, 7671, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:03:23', 'admin-1489287976-14892914035452250', 1, 1, 'SR', NULL, NULL, NULL),
(23429, '2017-03-12 12:03:23', NULL, NULL, 7671, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:03:23', 'admin-1489287976-14892914035452250', 1, 1, 'SR', NULL, NULL, NULL),
(23430, '2017-03-12 12:10:40', NULL, NULL, 7672, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:10:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23431, '2017-03-12 09:43:29', NULL, NULL, 7651, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:43:29', 'admin-1489280563-14892830091673697', 1, 0, '', NULL, NULL, NULL),
(23432, '2017-03-12 09:43:55', NULL, NULL, 7651, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:43:55', 'admin-1489280563-14892830352624058', 1, 1, 'SR', NULL, NULL, NULL),
(23433, '2017-03-12 09:43:55', NULL, NULL, 7651, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:43:55', 'admin-1489280563-14892830352624058', 1, 1, 'SR', NULL, NULL, NULL),
(23434, '2017-03-12 09:43:55', NULL, NULL, 7651, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:43:55', 'admin-1489280563-14892830352624058', 1, 1, 'SR', NULL, NULL, NULL),
(23435, '2017-03-12 09:43:55', NULL, NULL, 7651, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:43:55', 'admin-1489280563-14892830352624058', 1, 1, 'SR', NULL, NULL, NULL),
(23436, '2017-03-12 09:47:36', NULL, NULL, 7652, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:47:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23437, '2017-03-12 09:47:56', NULL, NULL, 7652, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:47:56', 'admin-1489280563-14892832762347298', 1, 0, '', NULL, NULL, NULL),
(23438, '2017-03-12 09:47:56', NULL, NULL, 7652, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:47:56', 'admin-1489280563-14892832762347298', 1, 0, '', NULL, NULL, NULL),
(23439, '2017-03-12 09:47:56', NULL, NULL, 7652, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:47:56', 'admin-1489280563-14892832762347298', 1, 1, 'SR', NULL, NULL, NULL),
(23440, '2017-03-12 09:47:56', NULL, NULL, 7652, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:47:56', 'admin-1489280563-14892832762347298', 1, 1, 'SR', NULL, NULL, NULL),
(23441, '2017-03-12 10:37:00', NULL, NULL, 7659, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:37:00', 'admin-1489285491-14892862203649098', 1, 0, '', NULL, NULL, NULL),
(23442, '2017-03-12 10:37:00', NULL, NULL, 7659, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:37:00', 'admin-1489285491-14892862203649098', 1, 0, '', NULL, NULL, NULL),
(23443, '2017-03-12 10:37:08', NULL, NULL, 7659, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:37:08', 'admin-1489285491-14892862286872813', 1, 1, 'SR', NULL, NULL, NULL),
(23444, '2017-03-12 09:24:31', NULL, NULL, 7648, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:24:31', 'admin-1489280563-14892818716156585', 1, 1, 'SR', NULL, NULL, NULL),
(23445, '2017-03-12 14:12:12', NULL, NULL, 7684, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 14:12:12', 'admin-1489293234-14892991327625477', 1, 0, '', NULL, NULL, NULL),
(23446, '2017-03-12 15:44:24', NULL, NULL, 7688, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 15:44:24', 'admin-1489299142-14893046645124332', 1, 0, '', NULL, NULL, NULL),
(23447, '2017-03-12 15:08:10', NULL, NULL, 7688, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 15:08:10', 'admin-1489299142-14893024901794382', 1, 0, '', NULL, NULL, NULL),
(23448, '2017-03-12 14:43:35', NULL, NULL, 7685, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 14:43:35', 'admin-1489299142-1489301015326946', 1, 0, '', NULL, NULL, NULL),
(23449, '2017-03-12 12:33:27', NULL, NULL, 7674, 0, 73, '73', 'Marmite Chicken ', 'sauce more', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:33:27', 'admin-1489287976-14892932075434271', 1, 1, 'SR', NULL, NULL, NULL),
(23450, '2017-03-12 14:12:02', NULL, NULL, 7684, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1489299142', 'admin', '2017-03-12 14:12:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23451, '2017-03-12 13:59:35', NULL, NULL, 7683, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:59:35', 'admin-1489293234-1489298375060698', 1, 1, 'SR', NULL, NULL, NULL),
(23452, '2017-03-12 13:59:35', NULL, NULL, 7683, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:59:35', 'admin-1489293234-1489298375060698', 1, 1, 'SR', NULL, NULL, NULL),
(23453, '2017-03-12 13:59:13', NULL, NULL, 7683, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:59:13', 'admin-1489293234-14892983529817010', 1, 0, '', NULL, NULL, NULL),
(23454, '2017-03-12 13:59:13', NULL, NULL, 7683, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:59:13', 'admin-1489293234-14892983529817010', 1, 1, 'SR', NULL, NULL, NULL),
(23455, '2017-03-12 13:59:13', NULL, NULL, 7683, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:59:13', 'admin-1489293234-14892983529817010', 1, 1, 'SR', NULL, NULL, NULL),
(23456, '2017-03-12 13:58:46', NULL, NULL, 7683, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:58:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23457, '2017-03-12 13:55:41', NULL, NULL, 7682, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:55:41', 'admin-1489293234-1489298141388851', 1, 0, '', NULL, NULL, NULL),
(23458, '2017-03-12 13:55:41', NULL, NULL, 7682, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:55:41', 'admin-1489293234-1489298141388851', 1, 1, 'SR', NULL, NULL, NULL),
(23459, '2017-03-12 13:55:41', NULL, NULL, 7682, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:55:41', 'admin-1489293234-1489298141388851', 1, 0, '', NULL, NULL, NULL),
(23460, '2017-03-12 09:32:13', NULL, NULL, 7649, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:32:13', 'admin-1489280563-1489282332975398', 1, 1, 'SR', NULL, NULL, NULL),
(23461, '2017-03-12 09:32:13', NULL, NULL, 7649, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:32:13', 'admin-1489280563-1489282332975398', 1, 0, '', NULL, NULL, NULL),
(23462, '2017-03-12 09:32:13', NULL, NULL, 7649, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:32:13', 'admin-1489280563-1489282332975398', 1, 1, 'SR', NULL, NULL, NULL),
(23463, '2017-03-12 09:39:34', NULL, NULL, 7650, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:39:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23464, '2017-03-12 14:41:28', NULL, NULL, 7685, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 17.30, 0.0000, 0.0000, 17.30, 1, '27', 1, '1489299142', 'admin', '2017-03-12 14:41:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23465, '2017-03-12 14:43:35', NULL, NULL, 7685, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 14:43:35', 'admin-1489299142-1489301015326946', 1, 0, '', NULL, NULL, NULL),
(23466, '2017-03-12 14:43:35', NULL, NULL, 7685, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 14:43:35', 'admin-1489299142-1489301015326946', 1, 1, 'SR', NULL, NULL, NULL),
(23467, '2017-03-12 13:55:21', NULL, NULL, 7682, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:55:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23468, '2017-03-12 00:00:00', NULL, NULL, 7678, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:12:24', 'admin-1489287976-14892919442033513', 1, 0, '', NULL, NULL, NULL),
(23469, '2017-03-12 12:12:09', NULL, NULL, 7673, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:12:09', 'admin-1489287976-14892919291154233', 1, 0, '', NULL, NULL, NULL),
(23470, '2017-03-12 13:30:49', NULL, NULL, 7677, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:30:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23471, '2017-03-12 12:12:24', NULL, NULL, 7673, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 16.0000, 0.0000, 8.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:12:24', 'admin-1489287976-14892919442033513', 1, 0, '', NULL, NULL, NULL),
(23472, '2017-03-12 13:36:06', NULL, NULL, 7679, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:36:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23473, '2017-03-12 13:41:21', NULL, NULL, 7680, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:41:21', 'admin-1489293234-1489297281401391', 1, 1, 'SR', NULL, NULL, NULL),
(23474, '2017-03-12 13:41:06', NULL, NULL, 7680, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1489299142', 'admin', '2017-03-12 13:41:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23475, '2017-03-12 12:33:27', NULL, NULL, 7674, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:33:27', 'admin-1489287976-14892932075434271', 1, 1, 'SR', NULL, NULL, NULL),
(23476, '2017-03-12 12:10:53', NULL, NULL, 7672, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:10:53', 'admin-1489287976-14892918530186380', 1, 1, 'SR', NULL, NULL, NULL),
(23477, '2017-03-12 12:10:53', NULL, NULL, 7672, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:10:53', 'admin-1489287976-14892918530186380', 1, 0, '', NULL, NULL, NULL),
(23478, '2017-03-12 12:12:00', NULL, NULL, 7673, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:12:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23479, '2017-03-12 12:33:27', NULL, NULL, 7674, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:33:27', 'admin-1489287976-14892932075434271', 1, 0, '', NULL, NULL, NULL),
(23480, '2017-03-12 12:33:27', NULL, NULL, 7674, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:33:27', 'admin-1489287976-14892932075434271', 1, 0, '', NULL, NULL, NULL),
(23481, '2017-03-12 00:00:00', NULL, NULL, 7677, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:12:09', 'admin-1489287976-14892919291154233', 1, 0, '', NULL, NULL, NULL),
(23482, '2017-03-12 12:32:29', NULL, NULL, 7674, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:32:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23483, '2017-03-12 12:33:27', NULL, NULL, 7674, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:33:27', 'admin-1489287976-14892932075434271', 1, 0, '', NULL, NULL, NULL),
(23484, '2017-03-12 10:38:27', NULL, NULL, 7654, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:38:27', 'admin-1489285491-14892863076591184', 1, 0, '', NULL, NULL, NULL),
(23485, '2017-03-12 10:40:06', NULL, NULL, 7660, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:40:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23486, '2017-03-12 10:40:11', NULL, NULL, 7660, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:40:11', 'admin-1489285491-14892864110139278', 1, 1, 'SR', NULL, NULL, NULL),
(23487, '2017-03-12 10:40:14', NULL, NULL, 7660, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:40:14', 'admin-1489285491-14892864148244977', 1, 1, 'SR', NULL, NULL, NULL),
(23488, '2017-03-12 00:00:00', NULL, NULL, 7668, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, NULL, NULL, 4.40, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:40:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23489, '2017-03-12 00:00:00', NULL, NULL, 7668, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:40:46', 'admin-1489285491-1489286446366153', 1, 0, '', NULL, NULL, NULL),
(23490, '2017-03-12 11:15:58', NULL, NULL, 7667, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1489299142', 'admin', '2017-03-12 11:15:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23491, '2017-03-12 00:00:00', NULL, NULL, 7668, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:40:46', 'admin-1489285491-1489286446366153', 1, 0, '', NULL, NULL, NULL),
(23492, '2017-03-12 10:44:48', NULL, NULL, 7662, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:44:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23493, '2017-03-12 10:45:09', NULL, NULL, 7662, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:45:09', 'admin-1489285491-1489286709602874', 1, 0, '', NULL, NULL, NULL),
(23494, '2017-03-12 10:45:09', NULL, NULL, 7662, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:45:09', 'admin-1489285491-1489286709602874', 1, 0, '', NULL, NULL, NULL),
(23495, '2017-03-12 10:45:09', NULL, NULL, 7662, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:45:09', 'admin-1489285491-1489286709602874', 1, 1, 'SR', NULL, NULL, NULL),
(23496, '2017-03-12 09:39:45', NULL, NULL, 7650, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:39:45', 'admin-1489280563-14892827854515071', 1, 0, '', NULL, NULL, NULL),
(23497, '2017-03-12 09:39:45', NULL, NULL, 7650, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:39:45', 'admin-1489280563-14892827854515071', 1, 0, '', NULL, NULL, NULL),
(23498, '2017-03-12 09:39:45', NULL, NULL, 7650, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:39:45', 'admin-1489280563-14892827854515071', 1, 0, '', NULL, NULL, NULL),
(23499, '2017-03-12 09:39:45', NULL, NULL, 7650, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:39:45', 'admin-1489280563-14892827854515071', 1, 0, '', NULL, NULL, NULL),
(23500, '2017-03-12 09:39:52', NULL, NULL, 7650, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:39:52', 'admin-1489280563-14892827923962533', 1, 1, 'SR', NULL, NULL, NULL),
(23501, '2017-03-12 12:03:23', NULL, NULL, 7671, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:03:23', 'admin-1489287976-14892914035452250', 1, 0, '', NULL, NULL, NULL),
(23502, '2017-03-12 12:03:23', NULL, NULL, 7671, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 12:03:23', 'admin-1489287976-14892914035452250', 1, 1, 'SR', NULL, NULL, NULL),
(23503, '2017-03-12 11:05:31', NULL, NULL, 7665, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 11:05:31', 'admin-1489285491-1489287931274168', 1, 1, 'SR', NULL, NULL, NULL),
(23504, '2017-03-12 11:05:31', NULL, NULL, 7665, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 11:05:31', 'admin-1489285491-1489287931274168', 1, 0, '', NULL, NULL, NULL),
(23505, '2017-03-12 10:57:25', NULL, NULL, 7664, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:57:25', 'admin-1489285491-14892874451301557', 1, 0, '', NULL, NULL, NULL),
(23506, '2017-03-12 10:57:25', NULL, NULL, 7664, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:57:25', 'admin-1489285491-14892874451301557', 1, 0, '', NULL, NULL, NULL),
(23507, '2017-03-12 10:57:13', NULL, NULL, 7664, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:57:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23508, '2017-03-12 10:55:45', NULL, NULL, 7663, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:55:45', 'admin-1489285491-1489287344989992', 1, 1, 'SR', NULL, NULL, NULL),
(23509, '2017-03-12 10:55:45', NULL, NULL, 7663, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:55:45', 'admin-1489285491-1489287344989992', 1, 1, 'SR', NULL, NULL, NULL),
(23510, '2017-03-12 10:51:03', NULL, NULL, 7663, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:51:03', 'admin-1489285491-14892870637213172', 1, 1, 'SR', NULL, NULL, NULL),
(23511, '2017-03-12 10:45:44', NULL, NULL, 7662, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:45:44', 'admin-1489285491-1489286743840434', 1, 1, 'SR', NULL, NULL, NULL),
(23512, '2017-03-12 10:51:01', NULL, NULL, 7663, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.50, 0.0000, 0.0000, 9.50, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:51:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23513, '2017-03-12 10:07:11', NULL, NULL, 7658, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:07:11', 'admin-1489283284-1489284431319467', 1, 0, '', NULL, NULL, NULL),
(23514, '2017-03-12 10:07:19', NULL, NULL, 7656, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:07:19', 'admin-1489283284-14892844397265047', 1, 0, '', NULL, NULL, NULL),
(23515, '2017-03-12 10:07:11', NULL, NULL, 7658, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:07:11', 'admin-1489283284-1489284431319467', 1, 0, '', NULL, NULL, NULL),
(23516, '2017-03-12 10:07:11', NULL, NULL, 7658, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:07:11', 'admin-1489283284-1489284431319467', 1, 1, 'SR', NULL, NULL, NULL),
(23517, '2017-03-12 10:07:11', NULL, NULL, 7658, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:07:11', 'admin-1489283284-1489284431319467', 1, 0, '', NULL, NULL, NULL),
(23518, '2017-03-12 10:06:48', NULL, NULL, 7658, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:06:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23519, '2017-03-12 10:05:04', NULL, NULL, 7657, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:05:04', 'admin-1489283284-1489284304126154', 1, 1, 'SR', NULL, NULL, NULL),
(23520, '2017-03-12 10:05:04', NULL, NULL, 7657, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:05:04', 'admin-1489283284-1489284304126154', 1, 0, '', NULL, NULL, NULL),
(23521, '2017-03-12 10:05:04', NULL, NULL, 7657, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:05:04', 'admin-1489283284-1489284304126154', 1, 0, '', NULL, NULL, NULL),
(23522, '2017-03-12 10:05:04', NULL, NULL, 7657, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:05:04', 'admin-1489283284-1489284304126154', 1, 0, '', NULL, NULL, NULL),
(23523, '2017-03-12 10:04:35', NULL, NULL, 7657, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:04:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23524, '2017-03-12 10:04:24', NULL, NULL, 7656, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:04:24', 'admin-1489283284-14892842642547164', 1, 1, 'SR', NULL, NULL, NULL),
(23525, '2017-03-12 10:04:24', NULL, NULL, 7656, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:04:24', 'admin-1489283284-14892842642547164', 1, 1, 'SR', NULL, NULL, NULL),
(23526, '2017-03-12 10:04:24', NULL, NULL, 7656, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:04:24', 'admin-1489283284-14892842642547164', 1, 0, '', NULL, NULL, NULL),
(23527, '2017-03-12 10:04:24', NULL, NULL, 7656, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:04:24', 'admin-1489283284-14892842642547164', 1, 0, '', NULL, NULL, NULL),
(23528, '2017-03-12 10:04:04', NULL, NULL, 7656, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:04:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23529, '2017-03-12 10:04:24', NULL, NULL, 7656, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:04:24', 'admin-1489283284-14892842642547164', 1, 0, '', NULL, NULL, NULL),
(23530, '2017-03-12 10:00:43', NULL, NULL, 7655, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:00:43', 'admin-1489283284-14892840431722278', 1, 1, 'SR', NULL, NULL, NULL),
(23531, '2017-03-12 10:00:40', NULL, NULL, 7655, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:00:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23532, '2017-03-12 10:00:43', NULL, NULL, 7655, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:00:43', 'admin-1489283284-14892840431722278', 1, 1, 'SR', NULL, NULL, NULL),
(23533, '2017-03-12 09:59:03', NULL, NULL, 7654, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:59:03', 'admin-1489283284-14892839436025431', 1, 1, 'SR', NULL, NULL, NULL),
(23534, '2017-03-12 09:59:03', NULL, NULL, 7654, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:59:03', 'admin-1489283284-14892839436025431', 1, 0, '', NULL, NULL, NULL),
(23535, '2017-03-12 09:59:03', NULL, NULL, 7654, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:59:03', 'admin-1489283284-14892839436025431', 1, 0, '', NULL, NULL, NULL),
(23536, '2017-03-12 09:59:03', NULL, NULL, 7654, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:59:03', 'admin-1489283284-14892839436025431', 1, 0, '', NULL, NULL, NULL),
(23537, '2017-03-12 09:58:52', NULL, NULL, 7654, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:58:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23538, '2017-03-12 09:53:25', NULL, NULL, 7653, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:53:25', 'admin-1489283284-14892836052933281', 1, 1, 'SR', NULL, NULL, NULL),
(23539, '2017-03-12 09:53:25', NULL, NULL, 7653, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:53:25', 'admin-1489283284-14892836052933281', 1, 1, 'SR', NULL, NULL, NULL),
(23540, '2017-03-12 09:53:20', NULL, NULL, 7653, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:53:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23541, '2017-03-12 09:49:07', NULL, NULL, 7652, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:49:07', 'admin-1489283284-14892833470856049', 1, 1, 'SR', NULL, NULL, NULL),
(23542, '2017-03-12 09:49:07', NULL, NULL, 7652, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:49:07', 'admin-1489283284-14892833470856049', 1, 0, '', NULL, NULL, NULL),
(23543, '2017-03-12 10:36:47', NULL, NULL, 7659, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1489299142', 'admin', '2017-03-12 10:36:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23544, '2017-03-12 09:47:56', NULL, NULL, 7652, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:47:56', 'admin-1489280563-14892832762347298', 1, 1, 'SR', NULL, NULL, NULL),
(23545, '2017-03-12 09:43:29', NULL, NULL, 7651, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:43:29', 'admin-1489280563-14892830091673697', 1, 0, '', NULL, NULL, NULL),
(23546, '2017-03-12 09:43:20', NULL, NULL, 7651, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.60, 0.0000, 0.0000, 9.60, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:43:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23547, '2017-03-12 09:43:29', NULL, NULL, 7651, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:43:29', 'admin-1489280563-14892830091673697', 1, 0, '', NULL, NULL, NULL),
(23548, '2017-03-12 09:39:52', NULL, NULL, 7650, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:39:52', 'admin-1489280563-14892827923962533', 1, 1, 'SR', NULL, NULL, NULL),
(23549, '2017-03-12 09:11:18', NULL, NULL, 7647, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:11:18', 'admin-1489280563-14892810777918460', 1, 0, '', NULL, NULL, NULL),
(23550, '2017-03-12 09:11:18', NULL, NULL, 7647, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:11:18', 'admin-1489280563-14892810777918460', 1, 0, '', NULL, NULL, NULL),
(23551, '2017-03-12 09:11:18', NULL, NULL, 7647, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:11:18', 'admin-1489280563-14892810777918460', 1, 0, '', NULL, NULL, NULL),
(23552, '2017-03-12 09:11:18', NULL, NULL, 7647, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:11:18', 'admin-1489280563-14892810777918460', 1, 0, '', NULL, NULL, NULL),
(23553, '2017-03-12 09:11:27', NULL, NULL, 7647, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:11:27', 'admin-1489280563-14892810870008178', 1, 1, 'SR', NULL, NULL, NULL),
(23554, '2017-03-12 09:23:45', NULL, NULL, 7648, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:23:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23555, '2017-03-12 09:24:13', NULL, NULL, 7648, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:24:13', 'admin-1489280563-1489281853727572', 1, 0, '', NULL, NULL, NULL),
(23556, '2017-03-12 09:31:49', NULL, NULL, 7649, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:31:49', 'admin-1489280563-1489282309342339', 1, 0, '', NULL, NULL, NULL),
(23557, '2017-03-12 09:32:13', NULL, NULL, 7649, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:32:13', 'admin-1489280563-1489282332975398', 1, 0, '', NULL, NULL, NULL),
(23558, '2017-03-12 09:31:49', NULL, NULL, 7649, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:31:49', 'admin-1489280563-1489282309342339', 1, 0, '', NULL, NULL, NULL),
(23559, '2017-03-12 09:31:49', NULL, NULL, 7649, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:31:49', 'admin-1489280563-1489282309342339', 1, 0, '', NULL, NULL, NULL),
(23560, '2017-03-12 09:31:42', NULL, NULL, 7649, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.29, 0.0000, 0.0000, 8.29, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:31:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23561, '2017-03-12 09:24:31', NULL, NULL, 7648, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:24:31', 'admin-1489280563-14892818716156585', 1, 1, 'SR', NULL, NULL, NULL),
(23562, '2017-03-12 09:24:13', NULL, NULL, 7648, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:24:13', 'admin-1489280563-1489281853727572', 1, 0, '', NULL, NULL, NULL),
(23563, '2017-03-12 09:24:13', NULL, NULL, 7648, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:24:13', 'admin-1489280563-1489281853727572', 1, 0, '', NULL, NULL, NULL),
(23564, '2017-03-12 09:11:00', NULL, NULL, 7647, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1489299142', 'admin', '2017-03-12 09:11:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23565, '2017-03-13 19:08:35', NULL, NULL, 7712, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 19:08:35', 'admin-1489384397-14894033154001833', 1, 0, '', NULL, NULL, NULL),
(23566, '2017-03-13 19:08:35', NULL, NULL, 7712, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 19:08:35', 'admin-1489384397-14894033154001833', 1, 0, '', NULL, NULL, NULL),
(23567, '2017-03-13 19:08:35', NULL, NULL, 7712, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 19:08:35', 'admin-1489384397-14894033154001833', 1, 1, 'SR', NULL, NULL, NULL),
(23568, '2017-03-13 19:32:25', NULL, NULL, 7713, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 19:32:25', 'admin-1489384397-14894047451808310', 1, 0, '', NULL, NULL, NULL),
(23569, '2017-03-13 19:32:25', NULL, NULL, 7713, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 19:32:25', 'admin-1489384397-14894047451808310', 1, 0, '', NULL, NULL, NULL),
(23570, '2017-03-13 13:37:38', NULL, NULL, 7704, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1489384397', 'admin', '2017-03-13 13:37:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23571, '2017-03-13 13:37:52', NULL, NULL, 7704, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 13:37:52', 'admin-1489368385-14893834726896344', 1, 0, '', NULL, NULL, NULL),
(23572, '2017-03-13 13:37:52', NULL, NULL, 7704, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 13:37:52', 'admin-1489368385-14893834726896344', 1, 1, 'SR', NULL, NULL, NULL),
(23573, '2017-03-13 13:37:52', NULL, NULL, 7704, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 13:37:52', 'admin-1489368385-14893834726896344', 1, 1, 'SR', NULL, NULL, NULL),
(23574, '2017-03-13 13:40:02', NULL, NULL, 7704, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 13:40:02', 'admin-1489368385-1489383601953514', 1, 0, '', NULL, NULL, NULL),
(23575, '2017-03-13 13:40:02', NULL, NULL, 7704, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 13:40:02', 'admin-1489368385-1489383601953514', 1, 0, '', NULL, NULL, NULL),
(23576, '2017-03-13 13:46:15', NULL, NULL, 7704, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 13:46:15', 'admin-1489368385-14893839753135716', 1, 1, 'SR', NULL, NULL, NULL),
(23577, '2017-03-13 13:51:53', NULL, NULL, 7705, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1489384397', 'admin', '2017-03-13 13:51:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23578, '2017-03-13 13:51:57', NULL, NULL, 7705, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 13:51:57', 'admin-1489368385-14893843177579289', 1, 1, 'SR', NULL, NULL, NULL),
(23579, '2017-03-13 19:32:54', NULL, NULL, 7714, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 19:32:54', 'admin-1489384397-14894047740349767', 1, 0, '', NULL, NULL, NULL),
(23580, '2017-03-13 19:32:54', NULL, NULL, 7714, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 19:32:54', 'admin-1489384397-14894047740349767', 1, 1, 'SR', NULL, NULL, NULL),
(23581, '2017-03-13 19:43:52', NULL, NULL, 7715, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.90, 0.0000, 0.0000, 16.90, 1, '27', 1, '1489384397', 'admin', '2017-03-13 19:43:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23582, '2017-03-13 19:44:01', NULL, NULL, 7715, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 19:44:01', 'admin-1489384397-1489405441051373', 1, 0, '', NULL, NULL, NULL),
(23583, '2017-03-13 19:44:01', NULL, NULL, 7715, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 19:44:01', 'admin-1489384397-1489405441051373', 1, 0, '', NULL, NULL, NULL),
(23584, '2017-03-13 20:16:16', NULL, NULL, 7715, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 20:16:16', 'admin-1489384397-14894073765909236', 1, 1, 'SR', NULL, NULL, NULL),
(23585, '2017-03-13 20:16:16', NULL, NULL, 7715, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 20:16:16', 'admin-1489384397-14894073765909236', 1, 0, '', NULL, NULL, NULL),
(23586, '2017-03-13 20:16:16', NULL, NULL, 7715, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 20:16:16', 'admin-1489384397-14894073765909236', 1, 1, 'SR', NULL, NULL, NULL),
(23587, '2017-03-13 20:16:16', NULL, NULL, 7715, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 20:16:16', 'admin-1489384397-14894073765909236', 1, 1, 'SR', NULL, NULL, NULL),
(23588, '2017-03-13 11:25:56', NULL, NULL, 7699, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 11:25:56', 'admin-1489368385-14893755567738761', 1, 1, 'SR', NULL, NULL, NULL),
(23589, '2017-03-13 11:45:54', NULL, NULL, 7699, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 11:45:54', 'admin-1489368385-14893767545613031', 1, 0, '', NULL, NULL, NULL),
(23590, '2017-03-13 11:45:54', NULL, NULL, 7699, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 11:45:54', 'admin-1489368385-14893767545613031', 1, 1, 'SR', NULL, NULL, NULL),
(23591, '2017-03-13 11:47:07', NULL, NULL, 7700, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1489384397', 'admin', '2017-03-13 11:47:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23592, '2017-03-13 11:47:11', NULL, NULL, 7700, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 11:47:11', 'admin-1489368385-14893768310699228', 1, 1, 'SR', NULL, NULL, NULL),
(23593, '2017-03-13 11:53:00', NULL, NULL, 7701, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1489384397', 'admin', '2017-03-13 11:53:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23594, '2017-03-13 11:53:13', NULL, NULL, 7701, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 11:53:13', 'admin-1489368385-14893771937373387', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(23595, '2017-03-13 11:53:13', NULL, NULL, 7701, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 11:53:13', 'admin-1489368385-14893771937373387', 1, 0, '', NULL, NULL, NULL),
(23596, '2017-03-13 11:53:13', NULL, NULL, 7701, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 11:53:13', 'admin-1489368385-14893771937373387', 1, 1, 'SR', NULL, NULL, NULL),
(23597, '2017-03-13 11:53:13', NULL, NULL, 7701, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 11:53:13', 'admin-1489368385-14893771937373387', 1, 0, '', NULL, NULL, NULL),
(23598, '2017-03-13 12:06:39', NULL, NULL, 7702, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 12:06:39', 'admin-1489368385-14893779994951916', 1, 0, '', 1, NULL, '10.0'),
(23599, '2017-03-13 12:10:45', NULL, NULL, 7698, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 12:10:45', 'admin-1489368385-14893782456459185', 1, 0, '', NULL, NULL, NULL),
(23600, '2017-03-13 12:29:15', NULL, NULL, 7701, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 12:29:15', 'admin-1489368385-14893793549495167', 1, 1, 'SR', NULL, NULL, NULL),
(23601, '2017-03-13 12:29:15', NULL, NULL, 7701, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 12:29:15', 'admin-1489368385-14893793549495167', 1, 1, 'SR', NULL, NULL, NULL),
(23602, '2017-03-13 12:33:33', NULL, NULL, 7703, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1489384397', 'admin', '2017-03-13 12:33:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23603, '2017-03-13 12:34:43', NULL, NULL, 7703, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 12:34:43', 'admin-1489368385-1489379682960991', 1, 1, 'SR', NULL, NULL, NULL),
(23604, '2017-03-13 10:19:20', NULL, NULL, 7696, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 10:19:20', 'admin-1489368385-14893715601061492', 1, 1, 'SR', NULL, NULL, NULL),
(23605, '2017-03-13 10:19:20', NULL, NULL, 7696, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 10:19:20', 'admin-1489368385-14893715601061492', 1, 1, 'SR', NULL, NULL, NULL),
(23606, '2017-03-13 10:38:38', NULL, NULL, 7697, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1489384397', 'admin', '2017-03-13 10:38:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23607, '2017-03-13 10:38:42', NULL, NULL, 7697, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 10:38:42', 'admin-1489368385-14893727227973945', 1, 0, '', NULL, NULL, NULL),
(23608, '2017-03-13 19:32:37', NULL, NULL, 7714, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1489384397', 'admin', '2017-03-13 19:32:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23609, '2017-03-13 19:32:25', NULL, NULL, 7713, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 19:32:25', 'admin-1489384397-14894047451808310', 1, 1, 'SR', NULL, NULL, NULL),
(23610, '2017-03-13 11:25:56', NULL, NULL, 7699, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 11:25:56', 'admin-1489368385-14893755567738761', 1, 1, 'SR', NULL, NULL, NULL),
(23611, '2017-03-13 14:07:47', NULL, NULL, 7707, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 14:07:47', 'admin-1489384397-14893852668247053', 1, 1, 'SR', NULL, NULL, NULL),
(23612, '2017-03-13 14:12:09', NULL, NULL, 7707, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 14:12:09', 'admin-1489384397-14893855289355749', 1, 0, '', NULL, NULL, NULL),
(23613, '2017-03-13 14:13:31', NULL, NULL, 7708, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1489384397', 'admin', '2017-03-13 14:13:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23614, '2017-03-13 21:08:08', NULL, NULL, 7716, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 21:08:08', 'admin-1489384397-14894104885948892', 1, 1, 'SR', NULL, NULL, NULL),
(23615, '2017-03-13 20:58:56', NULL, NULL, 7715, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 20:58:56', 'admin-1489384397-14894099358857658', 1, 1, 'SR', NULL, NULL, NULL),
(23616, '2017-03-13 20:49:21', NULL, NULL, 7716, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 20:49:21', 'admin-1489384397-14894093611184863', 1, 1, 'SR', NULL, NULL, NULL),
(23617, '2017-03-13 20:31:20', NULL, NULL, 7716, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 20:31:20', 'admin-1489384397-14894082805135399', 1, 1, 'SR', NULL, NULL, NULL),
(23618, '2017-03-13 20:31:20', NULL, NULL, 7716, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 20:31:20', 'admin-1489384397-14894082805135399', 1, 1, 'SR', NULL, NULL, NULL),
(23619, '2017-03-13 20:31:20', NULL, NULL, 7716, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 20:31:20', 'admin-1489384397-14894082805135399', 1, 1, 'SR', NULL, NULL, NULL),
(23620, '2017-03-13 20:31:20', NULL, NULL, 7716, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 20:31:20', 'admin-1489384397-14894082805135399', 1, 1, 'SR', NULL, NULL, NULL),
(23621, '2017-03-13 20:27:35', NULL, NULL, 7716, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1489384397', 'admin', '2017-03-13 20:27:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23622, '2017-03-13 20:31:20', NULL, NULL, 7716, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 20:31:20', 'admin-1489384397-14894082805135399', 1, 1, 'SR', NULL, NULL, NULL),
(23623, '2017-03-13 20:16:16', NULL, NULL, 7715, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 20:16:16', 'admin-1489384397-14894073765909236', 1, 1, 'SR', NULL, NULL, NULL),
(23624, '2017-03-13 20:16:16', NULL, NULL, 7715, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 20:16:16', 'admin-1489384397-14894073765909236', 1, 1, 'SR', NULL, NULL, NULL),
(23625, '2017-03-13 20:16:16', NULL, NULL, 7715, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 20:16:16', 'admin-1489384397-14894073765909236', 1, 1, 'SR', NULL, NULL, NULL),
(23626, '2017-03-13 20:16:16', NULL, NULL, 7715, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 20:16:16', 'admin-1489384397-14894073765909236', 1, 0, '', NULL, NULL, NULL),
(23627, '2017-03-13 20:16:16', NULL, NULL, 7715, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 20:16:16', 'admin-1489384397-14894073765909236', 1, 0, '', NULL, NULL, NULL),
(23628, '2017-03-13 19:32:54', NULL, NULL, 7714, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 19:32:54', 'admin-1489384397-14894047740349767', 1, 1, 'SR', NULL, NULL, NULL),
(23629, '2017-03-13 19:32:54', NULL, NULL, 7714, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 19:32:54', 'admin-1489384397-14894047740349767', 1, 1, 'SR', NULL, NULL, NULL),
(23630, '2017-03-13 14:48:48', NULL, NULL, 7709, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 14:48:48', 'admin-1489384397-14893877288079797', 1, 0, '', NULL, NULL, NULL),
(23631, '2017-03-13 15:49:19', NULL, NULL, 7710, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 15:49:19', 'admin-1489384397-14893913593265311', 1, 1, 'SR', NULL, NULL, NULL),
(23632, '2017-03-13 15:49:19', NULL, NULL, 7710, 0, 181, '116', 'Open Food ', 'Cranberry Scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 15:49:19', 'admin-1489384397-14893913593265311', 1, 0, '', NULL, NULL, NULL),
(23633, '2017-03-13 15:50:47', NULL, NULL, 7711, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 15:50:47', 'admin-1489384397-14893914473411995', 1, 0, '', 1, NULL, NULL),
(23634, '2017-03-13 18:34:23', NULL, NULL, 7712, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.40, 0.0000, 0.0000, 14.40, 1, '27', 1, '1489384397', 'admin', '2017-03-13 18:34:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23635, '2017-03-13 18:34:43', NULL, NULL, 7712, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 18:34:43', 'admin-1489384397-14894012834294441', 1, 1, 'SR', NULL, NULL, NULL),
(23636, '2017-03-13 18:34:43', NULL, NULL, 7712, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 18:34:43', 'admin-1489384397-14894012834294441', 1, 1, 'SR', NULL, NULL, NULL),
(23637, '2017-03-13 18:34:43', NULL, NULL, 7712, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 18:34:43', 'admin-1489384397-14894012834294441', 1, 0, '', NULL, NULL, NULL),
(23638, '2017-03-13 18:40:53', NULL, NULL, 7712, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 18:40:53', 'admin-1489384397-14894016528928160', 1, 0, '', NULL, NULL, NULL),
(23639, '2017-03-13 19:32:16', NULL, NULL, 7713, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1489384397', 'admin', '2017-03-13 19:32:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23640, '2017-03-13 19:20:30', NULL, NULL, 7711, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 19:20:30', 'admin-1489384397-14894040307512679', 1, 0, '', 1, NULL, NULL),
(23641, '2017-03-13 15:35:52', NULL, NULL, 7710, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 15:35:52', 'admin-1489384397-14893905520608748', 1, 1, 'SR', NULL, NULL, NULL),
(23642, '2017-03-13 15:35:11', NULL, NULL, 7710, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 15:35:11', 'admin-1489384397-14893905106982792', 1, 0, '', NULL, NULL, NULL),
(23643, '2017-03-13 15:30:40', NULL, NULL, 7710, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1489384397', 'admin', '2017-03-13 15:30:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23644, '2017-03-13 15:30:49', NULL, NULL, 7710, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 15:30:49', 'admin-1489384397-14893902495432061', 1, 1, 'SR', NULL, NULL, NULL),
(23645, '2017-03-13 14:54:09', NULL, NULL, 7707, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 14:54:09', 'admin-1489384397-14893880490901855', 1, 1, 'SR', NULL, NULL, NULL),
(23646, '2017-03-13 14:51:14', NULL, NULL, 7709, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 14:51:14', 'admin-1489384397-14893878736366256', 1, 1, 'SR', NULL, NULL, NULL),
(23647, '2017-03-13 14:48:49', NULL, NULL, 7709, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 14:48:49', 'admin-1489384397-14893877288079797', 1, 1, 'SR', NULL, NULL, NULL),
(23648, '2017-03-13 14:48:49', NULL, NULL, 7709, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 14:48:49', 'admin-1489384397-14893877288079797', 1, 0, '', NULL, NULL, NULL),
(23649, '2017-03-13 14:48:26', NULL, NULL, 7709, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 14:48:26', 'admin-1489384397-14893877066288118', 1, 1, 'SR', NULL, NULL, NULL),
(23650, '2017-03-13 14:48:11', NULL, NULL, 7709, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 14:48:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23651, '2017-03-13 14:48:26', NULL, NULL, 7709, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 14:48:26', 'admin-1489384397-14893877066288118', 1, 0, '', NULL, NULL, NULL),
(23652, '2017-03-13 14:23:38', NULL, NULL, 7705, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 14:23:38', 'admin-1489384397-14893862182324861', 1, 0, '', NULL, NULL, NULL),
(23653, '2017-03-13 14:20:07', NULL, NULL, 7704, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 14:20:07', 'admin-1489384397-14893860072946875', 1, 0, '', NULL, NULL, NULL),
(23654, '2017-03-13 14:14:39', NULL, NULL, 7705, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 14:14:39', 'admin-1489384397-1489385679701918', 1, 0, '', NULL, NULL, NULL),
(23655, '2017-03-13 14:14:39', NULL, NULL, 7705, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 14:14:39', 'admin-1489384397-1489385679701918', 1, 1, 'SR', NULL, NULL, NULL),
(23656, '2017-03-13 14:13:39', NULL, NULL, 7708, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 14:13:39', 'admin-1489384397-14893856193041864', 1, 1, 'SR', NULL, NULL, NULL),
(23657, '2017-03-13 14:13:39', NULL, NULL, 7708, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 14:13:39', 'admin-1489384397-14893856193041864', 1, 1, 'SR', NULL, NULL, NULL),
(23658, '2017-03-13 14:07:42', NULL, NULL, 7707, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1489384397', 'admin', '2017-03-13 14:07:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23659, '2017-03-13 13:57:32', NULL, NULL, 7706, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 13:57:32', 'admin-1489384397-14893846518209938', 1, 1, 'SR', 1, NULL, NULL),
(23660, '2017-03-13 13:53:32', NULL, NULL, 7705, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 13:53:32', 'admin-1489384397-14893844121572892', 1, 0, '', NULL, NULL, NULL),
(23661, '2017-03-13 10:38:42', NULL, NULL, 7697, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 10:38:42', 'admin-1489368385-14893727227973945', 1, 0, '', NULL, NULL, NULL),
(23662, '2017-03-13 10:02:12', NULL, NULL, 7695, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1489384397', 'admin', '2017-03-13 10:02:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23663, '2017-03-13 13:53:11', NULL, NULL, 7705, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 13:53:11', 'admin-1489368385-1489384391603543', 1, 0, '', NULL, NULL, NULL),
(23664, '2017-03-13 13:51:57', NULL, NULL, 7705, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 13:51:57', 'admin-1489368385-14893843177579289', 1, 1, 'SR', NULL, NULL, NULL),
(23665, '2017-03-13 12:34:43', NULL, NULL, 7703, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 12:34:43', 'admin-1489368385-1489379682960991', 1, 0, '', NULL, NULL, NULL),
(23666, '2017-03-13 11:25:37', NULL, NULL, 7699, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 11:25:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23667, '2017-03-13 11:25:56', NULL, NULL, 7699, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 11:25:56', 'admin-1489368385-14893755567738761', 1, 0, '', NULL, NULL, NULL),
(23668, '2017-03-13 11:11:16', NULL, NULL, 7698, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 11:11:16', 'admin-1489368385-14893746763025316', 1, 1, 'SR', NULL, NULL, NULL),
(23669, '2017-03-13 11:11:16', NULL, NULL, 7698, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 11:11:16', 'admin-1489368385-14893746763025316', 1, 1, 'SR', NULL, NULL, NULL),
(23670, '2017-03-13 11:11:12', NULL, NULL, 7698, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 11:11:12', 'admin-1489368385-14893746724393981', 1, 0, '', NULL, NULL, NULL),
(23671, '2017-03-13 11:11:09', NULL, NULL, 7698, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 11:11:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23672, '2017-03-13 10:38:58', NULL, NULL, 7697, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 10:38:58', 'admin-1489368385-14893727382722091', 1, 0, '', NULL, NULL, NULL),
(23673, '2017-03-13 10:38:58', NULL, NULL, 7697, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 10:38:58', 'admin-1489368385-14893727382722091', 1, 1, 'SR', NULL, NULL, NULL),
(23674, '2017-03-13 10:18:58', NULL, NULL, 7696, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1489384397', 'admin', '2017-03-13 10:18:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23675, '2017-03-13 10:19:09', NULL, NULL, 7696, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 10:19:09', 'admin-1489368385-14893715490055232', 1, 0, '', NULL, NULL, NULL),
(23676, '2017-03-13 10:19:09', NULL, NULL, 7696, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 10:19:09', 'admin-1489368385-14893715490055232', 1, 0, '', NULL, NULL, NULL),
(23677, '2017-03-13 10:02:20', NULL, NULL, 7695, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 10:02:20', 'admin-1489368385-14893705405072643', 1, 1, 'SR', NULL, NULL, NULL),
(23678, '2017-03-13 10:02:20', NULL, NULL, 7695, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 10:02:20', 'admin-1489368385-14893705405072643', 1, 0, '', NULL, NULL, NULL),
(23679, '2017-03-13 09:26:48', NULL, NULL, 7694, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 09:26:48', 'admin-1489368385-14893684078315743', 1, 0, '', NULL, NULL, NULL),
(23680, '2017-03-13 09:26:48', NULL, NULL, 7694, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 09:26:48', 'admin-1489368385-14893684078315743', 1, 0, '', NULL, NULL, NULL),
(23681, '2017-03-13 09:26:48', NULL, NULL, 7694, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489384397', 'admin', '2017-03-13 09:26:48', 'admin-1489368385-14893684078315743', 1, 0, '', NULL, NULL, NULL),
(23682, '2017-03-13 09:26:37', NULL, NULL, 7694, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1489384397', 'admin', '2017-03-13 09:26:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23683, '2017-03-15 11:51:20', NULL, NULL, 7726, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1489555735', 'admin', '2017-03-15 11:51:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23684, '2017-03-15 11:51:25', NULL, NULL, 7726, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 11:51:25', 'admin-1489544898-14895498854486990', 1, 1, 'SR', NULL, NULL, NULL),
(23685, '2017-03-15 12:54:07', NULL, NULL, 7727, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.40, 0.0000, 0.0000, 11.40, 1, '27', 1, '1489555735', 'admin', '2017-03-15 12:54:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23686, '2017-03-15 12:56:27', NULL, NULL, 7727, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 12:56:27', 'admin-1489544898-1489553787794678', 1, 1, 'SR', NULL, NULL, NULL),
(23687, '2017-03-15 12:56:27', NULL, NULL, 7727, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 12:56:27', 'admin-1489544898-1489553787794678', 1, 1, 'SR', NULL, NULL, NULL),
(23688, '2017-03-15 12:56:27', NULL, NULL, 7727, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 12:56:27', 'admin-1489544898-1489553787794678', 1, 0, '', NULL, NULL, NULL),
(23689, '2017-03-15 12:56:28', NULL, NULL, 7727, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 12:56:28', 'admin-1489544898-1489553787794678', 1, 0, '', NULL, NULL, NULL),
(23690, '2017-03-15 13:00:02', NULL, NULL, 7727, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 13:00:02', 'admin-1489544898-14895540023056813', 1, 1, 'SR', NULL, NULL, NULL),
(23691, '2017-03-15 13:00:02', NULL, NULL, 7727, 0, 181, '116', 'Open Food ', 'jagung chicken', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 13:00:02', 'admin-1489544898-14895540023056813', 1, 0, '', NULL, NULL, NULL),
(23692, '2017-03-15 10:50:12', NULL, NULL, 7721, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 10:50:12', 'admin-1489544898-14895462118324044', 1, 1, 'SR', NULL, NULL, NULL),
(23693, '2017-03-15 10:32:51', NULL, NULL, 7721, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 10:32:51', 'admin-1489544898-14895451710087838', 1, 1, 'SR', NULL, NULL, NULL),
(23694, '2017-03-15 10:52:08', NULL, NULL, 7722, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1489555735', 'admin', '2017-03-15 10:52:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23695, '2017-03-15 10:52:14', NULL, NULL, 7722, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 10:52:14', 'admin-1489544898-14895463344079285', 1, 0, '', NULL, NULL, NULL),
(23696, '2017-03-15 10:52:14', NULL, NULL, 7722, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 10:52:14', 'admin-1489544898-14895463344079285', 1, 0, '', NULL, NULL, NULL),
(23697, '2017-03-15 10:52:19', NULL, NULL, 7722, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 10:52:19', 'admin-1489544898-14895463390516761', 1, 1, 'SR', NULL, NULL, NULL),
(23698, '2017-03-15 10:52:19', NULL, NULL, 7722, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 10:52:19', 'admin-1489544898-14895463390516761', 1, 1, 'SR', NULL, NULL, NULL),
(23699, '2017-03-15 11:18:25', NULL, NULL, 7723, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1489555735', 'admin', '2017-03-15 11:18:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23700, '2017-03-15 11:18:30', NULL, NULL, 7723, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 11:18:30', 'admin-1489544898-14895479107316927', 1, 1, 'SR', NULL, NULL, NULL),
(23701, '2017-03-15 11:33:56', NULL, NULL, 7721, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 11:33:56', 'admin-1489544898-14895488359183033', 1, 1, 'SR', NULL, NULL, NULL),
(23702, '2017-03-15 11:48:51', NULL, NULL, 7724, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1489555735', 'admin', '2017-03-15 11:48:51', 'admin-1489544898-14895497317438877', 1, 0, '', 1, NULL, NULL),
(23703, '2017-03-15 11:48:51', NULL, NULL, 7724, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1489555735', 'admin', '2017-03-15 11:48:51', 'admin-1489544898-14895497317438877', 1, 0, '', 1, NULL, NULL),
(23704, '2017-03-15 11:48:52', NULL, NULL, 7724, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1489555735', 'admin', '2017-03-15 11:48:52', 'admin-1489544898-14895497317438877', 1, 0, '', 1, NULL, NULL),
(23705, '2017-03-15 11:50:00', NULL, NULL, 7725, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1489555735', 'admin', '2017-03-15 11:50:00', 'admin-1489544898-1489549800613213', 1, 0, '', 1, NULL, NULL),
(23706, '2017-03-15 11:50:00', NULL, NULL, 7725, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1489555735', 'admin', '2017-03-15 11:50:00', 'admin-1489544898-1489549800613213', 1, 0, '', 1, NULL, NULL),
(23707, '2017-03-15 11:50:00', NULL, NULL, 7725, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1489555735', 'admin', '2017-03-15 11:50:00', 'admin-1489544898-1489549800613213', 1, 0, '', 1, NULL, NULL),
(23708, '2017-03-15 09:56:00', NULL, NULL, 7718, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 09:56:00', 'admin-1489538992-1489542960620596', 1, 0, '', NULL, NULL, NULL),
(23709, '2017-03-15 09:56:00', NULL, NULL, 7718, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 09:56:00', 'admin-1489538992-1489542960620596', 1, 1, 'SR', NULL, NULL, NULL),
(23710, '2017-03-15 10:12:50', NULL, NULL, 7718, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 10:12:50', 'admin-1489538992-14895439699712327', 1, 0, '', NULL, NULL, NULL),
(23711, '2017-03-15 10:12:50', NULL, NULL, 7718, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 10:12:50', 'admin-1489538992-14895439699712327', 1, 1, 'SR', NULL, NULL, NULL),
(23712, '2017-03-15 20:00:24', NULL, NULL, 7732, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 20:00:24', 'admin-1489555735-14895792245949160', 1, 1, 'SR', NULL, NULL, NULL),
(23713, '2017-03-15 20:00:24', NULL, NULL, 7732, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 20:00:24', 'admin-1489555735-14895792245949160', 1, 0, '', NULL, NULL, NULL),
(23714, '2017-03-15 20:00:24', NULL, NULL, 7732, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 20:00:24', 'admin-1489555735-14895792245949160', 1, 0, '', NULL, NULL, NULL),
(23715, '2017-03-15 14:21:30', NULL, NULL, 7727, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 14:21:30', 'admin-1489555735-14895588905732612', 1, 0, '', NULL, NULL, NULL),
(23716, '2017-03-15 14:54:10', NULL, NULL, 7728, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 14:54:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23717, '2017-03-15 14:54:16', NULL, NULL, 7728, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 14:54:16', 'admin-1489555735-14895608566834583', 1, 1, 'SR', NULL, NULL, NULL),
(23718, '2017-03-15 14:54:16', NULL, NULL, 7728, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 14:54:16', 'admin-1489555735-14895608566834583', 1, 1, 'SR', NULL, NULL, NULL),
(23719, '2017-03-15 15:25:29', NULL, NULL, 7729, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 15:25:29', 'admin-1489555735-14895627288059556', 1, 0, '', 1, NULL, NULL),
(23720, '2017-03-15 16:47:37', NULL, NULL, 7730, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 16:47:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23721, '2017-03-15 16:47:42', NULL, NULL, 7730, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 16:47:42', 'admin-1489555735-14895676620391211', 1, 1, 'SR', NULL, NULL, NULL),
(23722, '2017-03-15 17:30:00', NULL, NULL, 7730, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 17:30:00', 'admin-1489555735-14895702007453895', 1, 0, '', NULL, NULL, NULL),
(23723, '2017-03-15 18:59:44', NULL, NULL, 7731, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1489555735', 'admin', '2017-03-15 18:59:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23724, '2017-03-15 19:04:27', NULL, NULL, 7731, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 19:04:27', 'admin-1489555735-14895758670331525', 1, 1, 'SR', NULL, NULL, NULL),
(23725, '2017-03-15 19:04:27', NULL, NULL, 7731, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 19:04:27', 'admin-1489555735-14895758670331525', 1, 1, 'SR', NULL, NULL, NULL),
(23726, '2017-03-15 19:04:27', NULL, NULL, 7731, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 19:04:27', 'admin-1489555735-14895758670331525', 1, 0, '', NULL, NULL, NULL),
(23727, '2017-03-15 19:04:27', NULL, NULL, 7731, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 19:04:27', 'admin-1489555735-14895758670331525', 1, 1, 'SR', NULL, NULL, NULL),
(23728, '2017-03-15 19:04:27', NULL, NULL, 7731, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 19:04:27', 'admin-1489555735-14895758670331525', 1, 1, 'SR', NULL, NULL, NULL),
(23729, '2017-03-15 19:04:27', NULL, NULL, 7731, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 19:04:27', 'admin-1489555735-14895758670331525', 1, 1, 'SR', NULL, NULL, NULL),
(23730, '2017-03-15 19:59:56', NULL, NULL, 7732, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1489555735', 'admin', '2017-03-15 19:59:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23731, '2017-03-15 13:53:09', NULL, NULL, 7727, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 13:53:09', 'admin-1489555735-14895571888035537', 1, 0, '', NULL, NULL, NULL),
(23732, '2017-03-15 13:53:09', NULL, NULL, 7727, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 13:53:09', 'admin-1489555735-14895571888035537', 1, 0, '', NULL, NULL, NULL),
(23733, '2017-03-15 13:40:40', NULL, NULL, 7727, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 13:40:40', 'admin-1489555735-14895564401125370', 1, 0, '', NULL, NULL, NULL),
(23734, '2017-03-15 09:23:04', NULL, NULL, 7717, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 09:23:04', 'admin-1489538992-14895409845719199', 1, 0, '', NULL, NULL, NULL),
(23735, '2017-03-15 09:25:45', NULL, NULL, 7717, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 09:25:45', 'admin-1489538992-14895411450745389', 1, 0, '', NULL, NULL, NULL),
(23736, '2017-03-15 09:23:14', NULL, NULL, 7717, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 09:23:14', 'admin-1489538992-14895409944248081', 1, 1, 'SR', NULL, NULL, NULL),
(23737, '2017-03-15 09:23:14', NULL, NULL, 7717, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 09:23:14', 'admin-1489538992-14895409944248081', 1, 1, 'SR', NULL, NULL, NULL),
(23738, '2017-03-15 13:27:52', NULL, NULL, 7727, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 13:27:52', 'admin-1489544898-14895556723897378', 1, 0, '', NULL, NULL, NULL),
(23739, '2017-03-15 10:28:05', NULL, NULL, 7719, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1489555735', 'admin', '2017-03-15 10:28:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23740, '2017-03-15 10:28:12', NULL, NULL, 7719, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 10:28:12', 'admin-1489538992-14895448925673454', 1, 0, '', NULL, NULL, NULL),
(23741, '2017-03-15 10:28:12', NULL, NULL, 7719, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 10:28:12', 'admin-1489538992-14895448925673454', 1, 0, '', NULL, NULL, NULL),
(23742, '2017-03-15 10:28:31', NULL, NULL, 7719, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 10:28:31', 'admin-1489544898-14895449112703038', 1, 1, 'SR', NULL, NULL, NULL),
(23743, '2017-03-15 10:28:31', NULL, NULL, 7719, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 10:28:31', 'admin-1489544898-14895449112703038', 1, 1, 'SR', NULL, NULL, NULL),
(23744, '2017-03-15 10:31:39', NULL, NULL, 7720, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1489555735', 'admin', '2017-03-15 10:31:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23745, '2017-03-15 10:31:52', NULL, NULL, 7720, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 10:31:52', 'admin-1489544898-14895451121016930', 1, 1, 'SR', NULL, NULL, NULL),
(23746, '2017-03-15 10:31:52', NULL, NULL, 7720, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 10:31:52', 'admin-1489544898-14895451121016930', 1, 1, 'SR', NULL, NULL, NULL),
(23747, '2017-03-15 10:32:40', NULL, NULL, 7721, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1489555735', 'admin', '2017-03-15 10:32:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23748, '2017-03-15 10:32:51', NULL, NULL, 7721, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 10:32:51', 'admin-1489544898-14895451710087838', 1, 0, '', NULL, NULL, NULL),
(23749, '2017-03-15 09:48:09', NULL, NULL, 7718, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.30, 0.0000, 0.0000, 11.30, 1, '27', 1, '1489555735', 'admin', '2017-03-15 09:48:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23750, '2017-03-15 09:48:21', NULL, NULL, 7718, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 09:48:21', 'admin-1489538992-1489542500863512', 1, 0, '', NULL, NULL, NULL),
(23751, '2017-03-15 09:48:21', NULL, NULL, 7718, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 09:48:21', 'admin-1489538992-1489542500863512', 1, 0, '', NULL, NULL, NULL),
(23752, '2017-03-15 09:48:21', NULL, NULL, 7718, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 09:48:21', 'admin-1489538992-1489542500863512', 1, 1, 'SR', NULL, NULL, NULL),
(23753, '2017-03-15 09:48:21', NULL, NULL, 7718, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 09:48:21', 'admin-1489538992-1489542500863512', 1, 0, '', NULL, NULL, NULL),
(23754, '2017-03-15 09:25:45', NULL, NULL, 7717, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 09:25:45', 'admin-1489538992-14895411450745389', 1, 0, '', NULL, NULL, NULL),
(23755, '2017-03-15 09:23:14', NULL, NULL, 7717, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 09:23:14', 'admin-1489538992-14895409944248081', 1, 1, 'SR', NULL, NULL, NULL),
(23756, '2017-03-15 09:22:43', NULL, NULL, 7717, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1489555735', 'admin', '2017-03-15 09:22:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23757, '2017-03-16 00:00:00', NULL, NULL, 7752, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 14:52:34', 'admin-1489640169-1489647154561150', 1, 0, '', NULL, NULL, NULL),
(23758, '2017-03-16 00:00:00', NULL, NULL, 7751, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 14:52:34', 'admin-1489640169-1489647154561150', 1, 0, '', NULL, NULL, NULL),
(23759, '2017-03-16 11:11:54', NULL, NULL, 7735, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1489640169', 'admin', '2017-03-16 11:11:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23760, '2017-03-16 11:12:09', NULL, NULL, 7735, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 11:12:09', 'admin-1489625354-14896339290511423', 1, 0, '', NULL, NULL, NULL),
(23761, '2017-03-16 11:12:09', NULL, NULL, 7735, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 11:12:09', 'admin-1489625354-14896339290511423', 1, 0, '', NULL, NULL, NULL),
(23762, '2017-03-16 11:12:09', NULL, NULL, 7735, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 11:12:09', 'admin-1489625354-14896339290511423', 1, 1, 'SR', NULL, NULL, NULL),
(23763, '2017-03-16 11:12:09', NULL, NULL, 7735, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 11:12:09', 'admin-1489625354-14896339290511423', 1, 1, 'SR', NULL, NULL, NULL),
(23764, '2017-03-16 12:04:58', NULL, NULL, 7736, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1489640169', 'admin', '2017-03-16 12:04:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23765, '2017-03-16 12:05:03', NULL, NULL, 7736, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 12:05:03', 'admin-1489625354-14896371031916557', 1, 1, 'SR', NULL, NULL, NULL),
(23766, '2017-03-16 16:50:03', NULL, NULL, 7753, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 16:50:03', 'admin-1489640169-14896542036212777', 1, 1, 'SR', NULL, NULL, NULL),
(23767, '2017-03-16 00:00:00', NULL, NULL, 7752, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 14:56:53', 'admin-1489640169-14896474128581154', 1, 0, '', NULL, NULL, NULL),
(23768, '2017-03-16 00:00:00', NULL, NULL, 7751, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 14:56:48', 'admin-1489640169-14896474083981147', 1, 0, '', NULL, NULL, NULL),
(23769, '2017-03-16 00:00:00', NULL, NULL, 7750, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 14:52:34', 'admin-1489640169-1489647154561150', 1, 0, '', NULL, NULL, NULL),
(23770, '2017-03-16 00:00:00', NULL, NULL, 7750, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 15:17:00', 'admin-1489640169-1489648619872238', 1, 0, '', NULL, NULL, NULL),
(23771, '2017-03-16 00:00:00', NULL, NULL, 7752, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 14:56:48', 'admin-1489640169-14896474083981147', 1, 0, '', NULL, NULL, NULL),
(23772, '2017-03-16 13:13:57', NULL, NULL, 7741, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1489640169', 'admin', '2017-03-16 13:13:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23773, '2017-03-16 00:00:00', NULL, NULL, 7743, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 12:19:48', 'admin-1489625354-14896379882777744', 1, 0, '', NULL, NULL, NULL),
(23774, '2017-03-16 00:00:00', NULL, NULL, 7742, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 12:19:35', 'admin-1489625354-14896379753479876', 1, 0, '', NULL, NULL, NULL),
(23775, '2017-03-16 00:00:00', NULL, NULL, 7744, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, NULL, NULL, 2.60, 1, '27', 1, '1489640169', 'admin', '2017-03-16 12:18:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23776, '2017-03-16 13:14:32', NULL, NULL, 7742, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1489640169', 'admin', '2017-03-16 13:14:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23777, '2017-03-16 00:00:00', NULL, NULL, 7742, 0, 217, '151', 'Spicy Lemony Wings', '', 'Meals', 'Perfect Meals', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 12:19:35', 'admin-1489625354-14896379753479876', 1, 0, '', NULL, NULL, NULL),
(23778, '2017-03-16 00:00:00', NULL, NULL, 7744, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 12:19:35', 'admin-1489625354-14896379753479876', 1, 1, 'SR', NULL, NULL, NULL),
(23779, '2017-03-16 15:37:28', NULL, NULL, 7751, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1489640169', 'admin', '2017-03-16 15:37:28', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(23780, '2017-03-16 15:37:00', NULL, NULL, 7750, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 15:37:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23781, '2017-03-16 00:00:00', NULL, NULL, 7752, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, NULL, NULL, 3.50, 1, '27', 1, '1489640169', 'admin', '2017-03-16 14:52:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23782, '2017-03-16 16:49:59', NULL, NULL, 7753, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1489640169', 'admin', '2017-03-16 16:49:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23783, '2017-03-16 14:37:12', NULL, NULL, 7748, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 14:37:12', 'admin-1489640169-14896462319357723', 1, 1, 'SR', NULL, NULL, NULL),
(23784, '2017-03-16 14:37:12', NULL, NULL, 7748, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 14:37:12', 'admin-1489640169-14896462319357723', 1, 0, '', NULL, NULL, NULL),
(23785, '2017-03-16 17:21:45', NULL, NULL, 7756, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 17:21:45', 'admin-1489640169-14896561055137023', 1, 1, 'SR', 1, NULL, NULL),
(23786, '2017-03-16 18:00:17', NULL, NULL, 7758, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 18:00:17', 'admin-1489640169-14896584167888276', 1, 1, 'SR', NULL, NULL, NULL),
(23787, '2017-03-16 17:07:05', NULL, NULL, 7754, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 17:07:05', 'admin-1489640169-1489655224769561', 1, 1, 'SR', NULL, NULL, NULL),
(23788, '2017-03-16 17:15:22', NULL, NULL, 7754, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 17:15:22', 'admin-1489640169-14896557226246957', 1, 1, 'SR', NULL, NULL, NULL),
(23789, '2017-03-16 17:15:22', NULL, NULL, 7754, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 17:15:22', 'admin-1489640169-14896557226246957', 1, 0, '', NULL, NULL, NULL),
(23790, '2017-03-16 17:20:11', NULL, NULL, 7755, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 17:20:11', 'admin-1489640169-1489656011732355', 1, 1, 'SR', 1, NULL, NULL),
(23791, '2017-03-16 17:20:11', NULL, NULL, 7755, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 17:20:11', 'admin-1489640169-1489656011732355', 1, 1, 'SR', 1, NULL, NULL),
(23792, '2017-03-16 17:20:11', NULL, NULL, 7755, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 17:20:11', 'admin-1489640169-1489656011732355', 1, 1, 'SR', 1, NULL, NULL),
(23793, '2017-03-16 18:12:23', NULL, NULL, 7759, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1489640169', 'admin', '2017-03-16 18:12:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23794, '2017-03-16 18:12:28', NULL, NULL, 7759, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 18:12:28', 'admin-1489640169-14896591477343245', 1, 0, '', NULL, NULL, NULL),
(23795, '2017-03-16 18:00:09', NULL, NULL, 7758, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1489640169', 'admin', '2017-03-16 18:00:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23796, '2017-03-16 18:00:17', NULL, NULL, 7758, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 18:00:17', 'admin-1489640169-14896584167888276', 1, 0, '', NULL, NULL, NULL),
(23797, '2017-03-16 00:00:00', NULL, NULL, 7757, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 17:25:26', 'admin-1489640169-14896563260677080', 1, 1, 'SR', NULL, NULL, NULL),
(23798, '2017-03-16 14:37:12', NULL, NULL, 7748, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 14:37:12', 'admin-1489640169-14896462319357723', 1, 0, '', NULL, NULL, NULL),
(23799, '2017-03-16 13:13:05', NULL, NULL, 7740, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 13:13:05', 'admin-1489640169-14896411854742889', 1, 1, 'SR', NULL, NULL, NULL),
(23800, '2017-03-16 00:00:00', NULL, NULL, 7741, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 12:46:58', 'admin-1489625354-14896396182198584', 1, 1, 'SR', NULL, NULL, NULL),
(23801, '2017-03-16 00:00:00', NULL, NULL, 7742, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 12:46:58', 'admin-1489625354-14896396182198584', 1, 1, 'SR', NULL, NULL, NULL),
(23802, '2017-03-16 00:00:00', NULL, NULL, 7743, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 12:19:35', 'admin-1489625354-14896379753479876', 1, 1, 'SR', NULL, NULL, NULL),
(23803, '2017-03-16 00:00:00', NULL, NULL, 7744, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 12:50:52', 'admin-1489625354-14896398527642789', 1, 0, '', NULL, NULL, NULL),
(23804, '2017-03-16 13:21:32', NULL, NULL, 7745, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1489640169', 'admin', '2017-03-16 13:21:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23805, '2017-03-16 13:21:35', NULL, NULL, 7745, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 13:21:35', 'admin-1489640169-14896416955172063', 1, 1, 'SR', NULL, NULL, NULL),
(23806, '2017-03-16 13:21:35', NULL, NULL, 7745, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 13:21:35', 'admin-1489640169-14896416955172063', 1, 1, 'SR', NULL, NULL, NULL),
(23807, '2017-03-16 13:25:55', NULL, NULL, 7745, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 13:25:55', 'admin-1489640169-1489641954871852', 1, 0, '', NULL, NULL, NULL),
(23808, '2017-03-16 13:25:55', NULL, NULL, 7745, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 13:25:55', 'admin-1489640169-1489641954871852', 1, 0, '', NULL, NULL, NULL),
(23809, '2017-03-16 13:30:04', NULL, NULL, 7746, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 13:30:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23810, '2017-03-16 13:31:46', NULL, NULL, 7746, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 13:31:46', 'admin-1489640169-14896423066778319', 1, 1, 'SR', NULL, NULL, NULL),
(23811, '2017-03-16 13:31:46', NULL, NULL, 7746, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 13:31:46', 'admin-1489640169-14896423066778319', 1, 0, '', NULL, NULL, NULL),
(23812, '2017-03-16 13:33:08', NULL, NULL, 7746, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 13:33:08', 'admin-1489640169-14896423884918843', 1, 0, '', NULL, NULL, NULL),
(23813, '2017-03-16 13:33:08', NULL, NULL, 7746, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 13:33:08', 'admin-1489640169-14896423884918843', 1, 0, '', NULL, NULL, NULL),
(23814, '2017-03-16 13:35:44', NULL, NULL, 7747, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 13:35:44', 'admin-1489640169-14896425446209816', 1, 0, '', 1, NULL, NULL),
(23815, '2017-03-16 14:37:02', NULL, NULL, 7748, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1489640169', 'admin', '2017-03-16 14:37:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23816, '2017-03-16 12:56:01', NULL, NULL, 7739, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 12:56:01', 'admin-1489625354-14896401611737235', 1, 1, 'SR', NULL, NULL, NULL),
(23817, '2017-03-16 12:56:01', NULL, NULL, 7739, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 12:56:01', 'admin-1489625354-14896401611737235', 1, 1, 'SR', NULL, NULL, NULL),
(23818, '2017-03-16 13:13:05', NULL, NULL, 7740, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 13:13:05', 'admin-1489640169-14896411854742889', 1, 1, 'SR', NULL, NULL, NULL),
(23819, '2017-03-16 13:12:58', NULL, NULL, 7740, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1489640169', 'admin', '2017-03-16 13:12:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23820, '2017-03-16 12:56:01', NULL, NULL, 7739, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 12:56:01', 'admin-1489625354-14896401611737235', 1, 1, 'SR', NULL, NULL, NULL),
(23821, '2017-03-16 12:56:01', NULL, NULL, 7739, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 12:56:01', 'admin-1489625354-14896401611737235', 1, 0, '', NULL, NULL, NULL),
(23822, '2017-03-16 12:55:49', NULL, NULL, 7739, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 12:55:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23823, '2017-03-16 00:00:00', NULL, NULL, 7744, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 12:19:48', 'admin-1489625354-14896379882777744', 1, 0, '', NULL, NULL, NULL),
(23824, '2017-03-16 00:00:00', NULL, NULL, 7741, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 12:19:48', 'admin-1489625354-14896379882777744', 1, 0, '', NULL, NULL, NULL),
(23825, '2017-03-16 00:00:00', NULL, NULL, 7742, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 12:19:48', 'admin-1489625354-14896379882777744', 1, 1, 'SR', NULL, NULL, NULL),
(23826, '2017-03-16 00:00:00', NULL, NULL, 7741, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 12:19:35', 'admin-1489625354-14896379753479876', 1, 1, 'SR', NULL, NULL, NULL),
(23827, '2017-03-16 13:15:01', NULL, NULL, 7743, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1489640169', 'admin', '2017-03-16 13:15:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23828, '2017-03-16 12:12:57', NULL, NULL, 7737, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 12:12:57', 'admin-1489625354-1489637577226716', 1, 1, 'SR', NULL, NULL, NULL),
(23829, '2017-03-16 12:12:52', NULL, NULL, 7737, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1489640169', 'admin', '2017-03-16 12:12:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23830, '2017-03-16 10:33:36', NULL, NULL, 7734, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 10:33:36', 'admin-1489625354-14896316164978991', 1, 1, 'SR', NULL, NULL, NULL),
(23831, '2017-03-16 10:33:31', NULL, NULL, 7734, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 10:33:31', 'admin-1489625354-14896316112038854', 1, 0, '', NULL, NULL, NULL),
(23832, '2017-03-16 10:16:08', NULL, NULL, 7733, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 10:16:08', 'admin-1489625354-14896305678675631', 1, 0, '', NULL, NULL, NULL),
(23833, '2017-03-16 10:16:14', NULL, NULL, 7733, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 10:16:14', 'admin-1489625354-14896305741217048', 1, 1, 'SR', NULL, NULL, NULL),
(23834, '2017-03-16 10:33:22', NULL, NULL, 7734, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1489640169', 'admin', '2017-03-16 10:33:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23835, '2017-03-16 10:33:31', NULL, NULL, 7734, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 10:33:31', 'admin-1489625354-14896316112038854', 1, 0, '', NULL, NULL, NULL),
(23836, '2017-03-16 10:33:31', NULL, NULL, 7734, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 10:33:31', 'admin-1489625354-14896316112038854', 1, 0, '', NULL, NULL, NULL),
(23837, '2017-03-16 09:15:34', NULL, NULL, 7733, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 09:15:34', 'admin-1489625354-1489626934803265', 1, 1, 'SR', NULL, NULL, NULL),
(23838, '2017-03-16 09:15:34', NULL, NULL, 7733, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1489640169', 'admin', '2017-03-16 09:15:34', 'admin-1489625354-1489626934803265', 1, 0, '', NULL, NULL, NULL),
(23839, '2017-03-16 10:16:08', NULL, NULL, 7733, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489640169', 'admin', '2017-03-16 10:16:08', 'admin-1489625354-14896305678675631', 1, 0, '', NULL, NULL, NULL),
(23840, '2017-03-16 09:14:42', NULL, NULL, 7733, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.29, 0.0000, 0.0000, 5.29, 1, '27', 1, '1489640169', 'admin', '2017-03-16 09:14:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23841, '2017-03-17 11:45:48', NULL, NULL, 7774, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:45:48', 'admin-1489711683-14897223479893840', 1, 0, '', NULL, NULL, NULL),
(23842, '2017-03-17 11:55:25', NULL, NULL, 7775, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:55:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23843, '2017-03-17 11:55:30', NULL, NULL, 7775, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:55:31', 'admin-1489711683-1489722930821299', 1, 1, 'SR', NULL, NULL, NULL),
(23844, '2017-03-17 12:14:13', NULL, NULL, 7776, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:14:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23845, '2017-03-17 12:14:20', NULL, NULL, 7776, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:14:20', 'admin-1489711683-14897240603238718', 1, 0, '', NULL, NULL, NULL),
(23846, '2017-03-17 12:14:20', NULL, NULL, 7776, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:14:20', 'admin-1489711683-14897240603238718', 1, 1, 'SR', NULL, NULL, NULL),
(23847, '2017-03-17 12:30:37', NULL, NULL, 7777, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:30:37', 'admin-1489711683-14897250372261914', 1, 0, '', NULL, NULL, NULL),
(23848, '2017-03-17 12:30:37', NULL, NULL, 7777, 0, 181, '116', 'Open Food ', 'Lemony wing w/o rice', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:30:37', 'admin-1489711683-14897250372261914', 1, 0, '', NULL, NULL, NULL),
(23849, '2017-03-17 12:30:37', NULL, NULL, 7777, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:30:37', 'admin-1489711683-14897250372261914', 1, 0, '', NULL, NULL, NULL),
(23850, '2017-03-17 12:30:37', NULL, NULL, 7777, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:30:37', 'admin-1489711683-14897250372261914', 1, 1, 'SR', NULL, NULL, NULL),
(23851, '2017-03-17 10:22:11', NULL, NULL, 7763, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.95, 0.0000, 0.0000, 4.95, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:22:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23852, '2017-03-17 10:22:18', NULL, NULL, 7763, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:22:18', 'admin-1489711683-14897173386554667', 1, 0, '', NULL, NULL, NULL),
(23853, '2017-03-17 10:22:18', NULL, NULL, 7763, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:22:18', 'admin-1489711683-14897173386554667', 1, 0, '', NULL, NULL, NULL),
(23854, '2017-03-17 10:25:13', NULL, NULL, 7763, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:25:13', 'admin-1489711683-14897175135445293', 1, 1, 'SR', NULL, NULL, NULL),
(23855, '2017-03-17 10:25:13', NULL, NULL, 7763, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:25:13', 'admin-1489711683-14897175135445293', 1, 0, '', NULL, NULL, NULL),
(23856, '2017-03-17 10:25:13', NULL, NULL, 7763, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 4.50, 4.5000, 0.0000, 4.50, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:25:13', 'admin-1489711683-14897175135445293', 1, 0, '', NULL, NULL, NULL),
(23857, '2017-03-17 10:21:13', NULL, NULL, 7762, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:21:13', 'admin-1489711683-14897172733765365', 1, 1, 'SR', NULL, NULL, NULL),
(23858, '2017-03-17 11:17:40', NULL, NULL, 7769, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:17:40', 'admin-1489711683-14897206602878520', 1, 1, 'SR', NULL, NULL, NULL),
(23859, '2017-03-17 20:26:44', NULL, NULL, 7795, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 20:26:44', 'admin-1489732339-14897536046648716', 1, 0, '', 1, NULL, NULL),
(23860, '2017-03-17 14:12:05', NULL, NULL, 7782, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 14:12:05', 'admin-1489729230-14897311250765288', 1, 0, '', NULL, NULL, NULL),
(23861, '2017-03-17 14:12:05', NULL, NULL, 7782, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 14:12:05', 'admin-1489729230-14897311250765288', 1, 0, '', NULL, NULL, NULL),
(23862, '2017-03-17 14:11:09', NULL, NULL, 7782, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.75, 0.0000, 0.0000, 8.75, 1, '27', 1, '1489732339', 'admin', '2017-03-17 14:11:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23863, '2017-03-17 14:12:05', NULL, NULL, 7782, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 14:12:05', 'admin-1489729230-14897311250765288', 1, 1, 'SR', NULL, NULL, NULL),
(23864, '2017-03-17 14:12:05', NULL, NULL, 7782, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 14:12:05', 'admin-1489729230-14897311250765288', 1, 0, '', NULL, NULL, NULL),
(23865, '2017-03-17 14:50:06', NULL, NULL, 7782, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 14:50:06', 'admin-1489732339-1489733406593546', 1, 0, '', NULL, NULL, NULL),
(23866, '2017-03-17 12:51:36', NULL, NULL, 7778, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:51:36', 'admin-1489711683-14897262964767337', 1, 0, '', NULL, NULL, NULL),
(23867, '2017-03-17 16:27:05', NULL, NULL, 7788, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 16:27:05', 'admin-1489732339-1489739225128235', 1, 1, 'SR', NULL, NULL, NULL),
(23868, '2017-03-17 16:27:05', NULL, NULL, 7788, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 16:27:05', 'admin-1489732339-1489739225128235', 1, 1, 'SR', NULL, NULL, NULL),
(23869, '2017-03-17 17:42:51', NULL, NULL, 7789, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 17:42:51', 'admin-1489732339-14897437712355692', 1, 0, '', 1, NULL, NULL),
(23870, '2017-03-17 18:39:51', NULL, NULL, 7790, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.59, 0.0000, 0.0000, 1.59, 1, '27', 1, '1489732339', 'admin', '2017-03-17 18:39:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23871, '2017-03-17 18:40:00', NULL, NULL, 7790, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 18:40:00', 'admin-1489732339-14897472000239052', 1, 1, 'SR', NULL, NULL, NULL),
(23872, '2017-03-17 14:32:11', NULL, NULL, 7777, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 14:32:11', 'admin-1489729230-14897323316549211', 1, 0, '', NULL, NULL, NULL),
(23873, '2017-03-17 14:24:37', NULL, NULL, 7777, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 14:24:37', 'admin-1489729230-14897318777324560', 1, 0, '', NULL, NULL, NULL),
(23874, '2017-03-17 14:02:01', NULL, NULL, 7781, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 14:02:01', 'admin-1489729230-1489730521571181', 1, 1, 'SR', NULL, NULL, NULL),
(23875, '2017-03-17 13:57:06', NULL, NULL, 7781, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 13:57:06', 'admin-1489729230-14897302265083312', 1, 1, 'SR', NULL, NULL, NULL),
(23876, '2017-03-17 13:56:38', NULL, NULL, 7780, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 13:56:38', 'admin-1489729230-14897301982796928', 1, 0, '', NULL, NULL, NULL),
(23877, '2017-03-17 13:57:01', NULL, NULL, 7781, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1489732339', 'admin', '2017-03-17 13:57:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23878, '2017-03-17 11:36:48', NULL, NULL, 7773, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:36:48', 'admin-1489711683-1489721808372369', 1, 1, 'SR', 1, NULL, NULL),
(23879, '2017-03-17 11:22:15', NULL, NULL, 7772, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:22:15', 'admin-1489711683-14897209356435879', 1, 0, '', NULL, NULL, NULL),
(23880, '2017-03-17 12:29:58', NULL, NULL, 7777, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:29:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23881, '2017-03-17 13:42:09', NULL, NULL, 7780, 0, 181, '116', 'Open Food ', 'rice wine', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 13:42:09', 'admin-1489729230-14897293296787828', 1, 0, '', NULL, NULL, NULL),
(23882, '2017-03-17 13:40:40', NULL, NULL, 7780, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 13:40:40', 'admin-1489729230-14897292401408113', 1, 1, 'SR', NULL, NULL, NULL),
(23883, '2017-03-17 13:40:12', NULL, NULL, 7780, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 13:40:12', 'admin-1489711683-1489729212430125', 1, 0, '', NULL, NULL, NULL),
(23884, '2017-03-17 13:18:00', NULL, NULL, 7777, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 13:18:00', 'admin-1489711683-14897278799595591', 1, 1, 'SR', NULL, NULL, NULL),
(23885, '2017-03-17 13:32:00', NULL, NULL, 7780, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1489732339', 'admin', '2017-03-17 13:32:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23886, '2017-03-17 13:32:07', NULL, NULL, 7780, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 13:32:07', 'admin-1489711683-14897287277233060', 1, 1, 'SR', NULL, NULL, NULL),
(23887, '2017-03-17 13:32:07', NULL, NULL, 7780, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 13:32:07', 'admin-1489711683-14897287277233060', 1, 1, 'SR', NULL, NULL, NULL),
(23888, '2017-03-17 18:40:00', NULL, NULL, 7790, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1489732339', 'admin', '2017-03-17 18:40:00', 'admin-1489732339-14897472000239052', 1, 0, '', NULL, NULL, NULL),
(23889, '2017-03-17 18:59:08', NULL, NULL, 7791, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1489732339', 'admin', '2017-03-17 18:59:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23890, '2017-03-17 18:59:17', NULL, NULL, 7791, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 18:59:17', 'admin-1489732339-1489748357698105', 1, 0, '', NULL, NULL, NULL),
(23891, '2017-03-17 18:59:17', NULL, NULL, 7791, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 18:59:17', 'admin-1489732339-1489748357698105', 1, 1, 'SR', NULL, NULL, NULL),
(23892, '2017-03-17 19:21:43', NULL, NULL, 7792, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.10, 0.0000, 0.0000, 13.10, 1, '27', 1, '1489732339', 'admin', '2017-03-17 19:21:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23893, '2017-03-17 19:24:20', NULL, NULL, 7792, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 19:24:20', 'admin-1489732339-14897498606148481', 1, 0, '', NULL, NULL, NULL),
(23894, '2017-03-17 19:24:20', NULL, NULL, 7792, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 19:24:20', 'admin-1489732339-14897498606148481', 1, 1, 'SR', NULL, NULL, NULL),
(23895, '2017-03-17 19:24:20', NULL, NULL, 7792, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 19:24:20', 'admin-1489732339-14897498606148481', 1, 1, 'SR', NULL, NULL, NULL),
(23896, '2017-03-17 19:24:20', NULL, NULL, 7792, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 19:24:20', 'admin-1489732339-14897498606148481', 1, 0, '', NULL, NULL, NULL),
(23897, '2017-03-17 19:24:20', NULL, NULL, 7792, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 19:24:20', 'admin-1489732339-14897498606148481', 1, 0, '', NULL, NULL, NULL),
(23898, '2017-03-17 19:24:20', NULL, NULL, 7792, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 19:24:20', 'admin-1489732339-14897498606148481', 1, 0, '', NULL, NULL, NULL),
(23899, '2017-03-17 19:24:20', NULL, NULL, 7792, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 19:24:20', 'admin-1489732339-14897498606148481', 1, 0, '', NULL, NULL, NULL),
(23900, '2017-03-17 12:57:02', NULL, NULL, 7779, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:57:02', 'admin-1489711683-14897266222686980', 1, 1, 'SR', NULL, NULL, NULL),
(23901, '2017-03-17 12:56:58', NULL, NULL, 7779, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:56:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23902, '2017-03-17 12:51:59', NULL, NULL, 7778, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:51:59', 'admin-1489711683-14897263187991135', 1, 0, '', NULL, NULL, NULL),
(23903, '2017-03-17 20:26:44', NULL, NULL, 7795, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 20:26:44', 'admin-1489732339-14897536046648716', 1, 0, '', 1, NULL, NULL),
(23904, '2017-03-17 19:27:12', NULL, NULL, 7791, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 19:27:12', 'admin-1489732339-1489750031795695', 1, 0, '', NULL, NULL, NULL),
(23905, '2017-03-17 20:14:38', NULL, NULL, 7793, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 20:14:38', 'admin-1489732339-14897528782525921', 1, 0, '', 1, NULL, NULL),
(23906, '2017-03-17 20:14:59', NULL, NULL, 7794, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 20:14:59', 'admin-1489732339-14897528991527026', 1, 0, '', 1, NULL, NULL),
(23907, '2017-03-17 20:15:41', NULL, NULL, 7792, 0, 181, '116', 'Open Food ', 'pancake', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 20:15:41', 'admin-1489732339-14897529417317221', 1, 0, '', NULL, NULL, NULL),
(23908, '2017-03-17 20:15:48', NULL, NULL, 7792, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 20:15:48', 'admin-1489732339-14897529487352214', 1, 0, '', NULL, NULL, NULL),
(23909, '2017-03-17 16:21:15', NULL, NULL, 7787, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 16:21:15', 'admin-1489732339-14897388750538665', 1, 0, '', 1, NULL, NULL),
(23910, '2017-03-17 16:07:22', NULL, NULL, 7786, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 16:07:22', 'admin-1489732339-14897380424329271', 1, 0, '', NULL, NULL, NULL),
(23911, '2017-03-17 16:27:00', NULL, NULL, 7788, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1489732339', 'admin', '2017-03-17 16:27:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23912, '2017-03-17 16:20:27', NULL, NULL, 7787, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 16:20:27', 'admin-1489732339-14897388268829435', 1, 0, '', 1, NULL, NULL),
(23913, '2017-03-17 15:54:55', NULL, NULL, 7785, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 15:54:55', 'admin-1489732339-14897372952735070', 1, 1, 'SR', NULL, NULL, NULL),
(23914, '2017-03-17 16:07:20', NULL, NULL, 7786, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1489732339', 'admin', '2017-03-17 16:07:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23915, '2017-03-17 12:51:59', NULL, NULL, 7778, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:51:59', 'admin-1489711683-14897263187991135', 1, 0, '', NULL, NULL, NULL),
(23916, '2017-03-17 12:51:59', NULL, NULL, 7778, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:51:59', 'admin-1489711683-14897263187991135', 1, 0, '', NULL, NULL, NULL),
(23917, '2017-03-17 15:19:01', NULL, NULL, 7783, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 15:19:01', 'admin-1489732339-1489735140855746', 1, 1, 'SR', NULL, NULL, NULL),
(23918, '2017-03-17 15:54:51', NULL, NULL, 7785, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1489732339', 'admin', '2017-03-17 15:54:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23919, '2017-03-17 15:19:08', NULL, NULL, 7784, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 15:19:08', 'admin-1489732339-14897351486978028', 1, 1, 'SR', NULL, NULL, NULL),
(23920, '2017-03-17 15:19:05', NULL, NULL, 7784, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1489732339', 'admin', '2017-03-17 15:19:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23921, '2017-03-17 15:19:01', NULL, NULL, 7783, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 15:19:01', 'admin-1489732339-1489735140855746', 1, 1, 'SR', NULL, NULL, NULL),
(23922, '2017-03-17 15:19:01', NULL, NULL, 7783, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 15:19:01', 'admin-1489732339-1489735140855746', 1, 0, '', NULL, NULL, NULL),
(23923, '2017-03-17 15:19:01', NULL, NULL, 7783, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 15:19:01', 'admin-1489732339-1489735140855746', 1, 1, 'SR', NULL, NULL, NULL),
(23924, '2017-03-17 15:19:01', NULL, NULL, 7783, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 15:19:01', 'admin-1489732339-1489735140855746', 1, 0, '', NULL, NULL, NULL),
(23925, '2017-03-17 15:19:01', NULL, NULL, 7783, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 15:19:01', 'admin-1489732339-1489735140855746', 1, 0, '', NULL, NULL, NULL),
(23926, '2017-03-17 15:19:01', NULL, NULL, 7783, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 15:19:01', 'admin-1489732339-1489735140855746', 1, 0, '', NULL, NULL, NULL),
(23927, '2017-03-17 15:19:01', NULL, NULL, 7783, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 15:19:01', 'admin-1489732339-1489735140855746', 1, 0, '', NULL, NULL, NULL),
(23928, '2017-03-17 15:18:37', NULL, NULL, 7783, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.50, 0.0000, 0.0000, 14.50, 1, '27', 1, '1489732339', 'admin', '2017-03-17 15:18:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23929, '2017-03-17 15:19:01', NULL, NULL, 7783, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 15:19:01', 'admin-1489732339-1489735140855746', 1, 0, '', NULL, NULL, NULL),
(23930, '2017-03-17 14:12:05', NULL, NULL, 7782, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 14:12:05', 'admin-1489729230-14897311250765288', 1, 1, 'SR', NULL, NULL, NULL),
(23931, '2017-03-17 14:12:05', NULL, NULL, 7782, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 14:12:05', 'admin-1489729230-14897311250765288', 1, 1, 'SR', NULL, NULL, NULL),
(23932, '2017-03-17 14:50:06', NULL, NULL, 7782, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 6.50, 6.5000, 0.0000, 6.50, 1, '27', 1, '1489732339', 'admin', '2017-03-17 14:50:06', 'admin-1489732339-1489733406593546', 1, 0, '', NULL, NULL, NULL),
(23933, '2017-03-17 14:12:05', NULL, NULL, 7782, 0, 181, '116', 'Open Food ', 'Sweet corn chicken', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 14:12:05', 'admin-1489729230-14897311250765288', 1, 0, '', NULL, NULL, NULL),
(23934, '2017-03-17 14:50:41', NULL, NULL, 7782, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 14:50:41', 'admin-1489732339-14897334411186344', 1, 0, '', NULL, NULL, NULL),
(23935, '2017-03-17 12:51:59', NULL, NULL, 7778, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:51:59', 'admin-1489711683-14897263187991135', 1, 1, 'SR', NULL, NULL, NULL),
(23936, '2017-03-17 12:51:59', NULL, NULL, 7778, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:51:59', 'admin-1489711683-14897263187991135', 1, 1, 'SR', NULL, NULL, NULL),
(23937, '2017-03-17 12:44:52', NULL, NULL, 7777, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:44:52', 'admin-1489711683-14897258920162531', 1, 0, '', NULL, NULL, NULL),
(23938, '2017-03-17 12:47:32', NULL, NULL, 7777, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:47:32', 'admin-1489711683-14897260520732234', 1, 0, '', NULL, NULL, NULL),
(23939, '2017-03-17 12:51:11', NULL, NULL, 7778, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.80, 0.0000, 0.0000, 15.80, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:51:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23940, '2017-03-17 12:51:36', NULL, NULL, 7778, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:51:36', 'admin-1489711683-14897262964767337', 1, 0, '', NULL, NULL, NULL),
(23941, '2017-03-17 12:51:36', NULL, NULL, 7778, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:51:36', 'admin-1489711683-14897262964767337', 1, 1, 'SR', NULL, NULL, NULL),
(23942, '2017-03-17 12:51:36', NULL, NULL, 7778, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:51:36', 'admin-1489711683-14897262964767337', 1, 1, 'SR', NULL, NULL, NULL),
(23943, '2017-03-17 12:51:36', NULL, NULL, 7778, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:51:36', 'admin-1489711683-14897262964767337', 1, 1, 'SR', NULL, NULL, NULL),
(23944, '2017-03-17 11:45:48', NULL, NULL, 7774, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:45:48', 'admin-1489711683-14897223479893840', 1, 1, 'SR', NULL, NULL, NULL),
(23945, '2017-03-17 11:45:48', NULL, NULL, 7774, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:45:48', 'admin-1489711683-14897223479893840', 1, 1, 'SR', NULL, NULL, NULL),
(23946, '2017-03-17 12:51:36', NULL, NULL, 7778, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 12:51:36', 'admin-1489711683-14897262964767337', 1, 1, 'SR', NULL, NULL, NULL),
(23947, '2017-03-17 11:45:40', NULL, NULL, 7774, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:45:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23948, '2017-03-17 11:22:15', NULL, NULL, 7772, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:22:15', 'admin-1489711683-14897209356435879', 1, 1, 'SR', NULL, NULL, NULL),
(23949, '2017-03-17 11:22:03', NULL, NULL, 7772, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:22:03', 'admin-1489711683-14897209233213197', 1, 0, '', NULL, NULL, NULL),
(23950, '2017-03-17 11:22:03', NULL, NULL, 7772, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:22:03', 'admin-1489711683-14897209233213197', 1, 0, '', NULL, NULL, NULL),
(23951, '2017-03-17 11:22:03', NULL, NULL, 7772, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:22:03', 'admin-1489711683-14897209233213197', 1, 1, 'SR', NULL, NULL, NULL),
(23952, '2017-03-17 11:22:15', NULL, NULL, 7772, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:22:15', 'admin-1489711683-14897209356435879', 1, 0, '', NULL, NULL, NULL),
(23953, '2017-03-17 10:31:56', NULL, NULL, 7765, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.05, 0.0000, 0.0000, 1.05, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:31:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23954, '2017-03-17 10:32:00', NULL, NULL, 7765, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:32:00', 'admin-1489711683-1489717920102333', 1, 0, '', NULL, NULL, NULL),
(23955, '2017-03-17 10:32:22', NULL, NULL, 7765, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:32:22', 'admin-1489711683-14897179423972551', 1, 0, '', NULL, NULL, NULL),
(23956, '2017-03-17 10:40:18', NULL, NULL, 7766, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:40:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23957, '2017-03-17 10:40:23', NULL, NULL, 7766, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:40:23', 'admin-1489711683-14897184237032780', 1, 0, '', NULL, NULL, NULL),
(23958, '2017-03-17 10:40:28', NULL, NULL, 7766, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:40:28', 'admin-1489711683-14897184283139874', 1, 1, 'SR', NULL, NULL, NULL),
(23959, '2017-03-17 11:08:56', NULL, NULL, 7767, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.35, 0.0000, 0.0000, 7.35, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:08:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23960, '2017-03-17 11:09:02', NULL, NULL, 7767, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:09:02', 'admin-1489711683-14897201422403826', 1, 0, '', NULL, NULL, NULL),
(23961, '2017-03-17 11:09:02', NULL, NULL, 7767, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:09:02', 'admin-1489711683-14897201422403826', 1, 0, '', NULL, NULL, NULL),
(23962, '2017-03-17 11:09:02', NULL, NULL, 7767, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:09:02', 'admin-1489711683-14897201422403826', 1, 0, '', NULL, NULL, NULL),
(23963, '2017-03-17 11:09:20', NULL, NULL, 7767, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:09:20', 'admin-1489711683-14897201607798830', 1, 1, 'SR', NULL, NULL, NULL),
(23964, '2017-03-17 11:09:20', NULL, NULL, 7767, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:09:20', 'admin-1489711683-14897201607798830', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(23965, '2017-03-17 11:09:20', NULL, NULL, 7767, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 4.50, 4.5000, 0.0000, 4.50, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:09:20', 'admin-1489711683-14897201607798830', 1, 0, '', NULL, NULL, NULL),
(23966, '2017-03-17 11:10:12', NULL, NULL, 7769, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:10:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23967, '2017-03-17 11:10:18', NULL, NULL, 7769, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:10:18', 'admin-1489711683-14897202179185352', 1, 1, 'SR', NULL, NULL, NULL),
(23968, '2017-03-17 11:10:18', NULL, NULL, 7769, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:10:18', 'admin-1489711683-14897202179185352', 1, 1, 'SR', NULL, NULL, NULL),
(23969, '2017-03-17 11:10:56', NULL, NULL, 7770, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:10:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23970, '2017-03-17 11:11:00', NULL, NULL, 7770, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:11:00', 'admin-1489711683-14897202603247491', 1, 1, 'SR', NULL, NULL, NULL),
(23971, '2017-03-17 11:22:03', NULL, NULL, 7772, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:22:03', 'admin-1489711683-14897209233213197', 1, 0, '', NULL, NULL, NULL),
(23972, '2017-03-17 11:22:03', NULL, NULL, 7772, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:22:03', 'admin-1489711683-14897209233213197', 1, 0, '', NULL, NULL, NULL),
(23973, '2017-03-17 11:22:03', NULL, NULL, 7772, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:22:03', 'admin-1489711683-14897209233213197', 1, 0, '', NULL, NULL, NULL),
(23974, '2017-03-17 11:20:11', NULL, NULL, 7772, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.20, 0.0000, 0.0000, 11.20, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:20:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23975, '2017-03-17 11:19:01', NULL, NULL, 7771, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:19:01', 'admin-1489711683-14897207414446410', 1, 1, 'SR', NULL, NULL, NULL),
(23976, '2017-03-17 11:18:57', NULL, NULL, 7771, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1489732339', 'admin', '2017-03-17 11:18:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23977, '2017-03-17 10:27:23', NULL, NULL, 7764, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:27:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23978, '2017-03-17 10:27:37', NULL, NULL, 7764, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:27:37', 'admin-1489711683-14897176572638675', 1, 0, '', NULL, NULL, NULL),
(23979, '2017-03-17 10:27:37', NULL, NULL, 7764, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:27:37', 'admin-1489711683-14897176572638675', 1, 0, '', NULL, NULL, NULL),
(23980, '2017-03-17 10:27:37', NULL, NULL, 7764, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:27:37', 'admin-1489711683-14897176572638675', 1, 1, 'SR', NULL, NULL, NULL),
(23981, '2017-03-17 10:22:07', NULL, NULL, 7762, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 4.50, 4.5000, 0.0000, 4.50, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:22:07', 'admin-1489711683-14897173271013152', 1, 0, '', NULL, NULL, NULL),
(23982, '2017-03-17 09:40:02', NULL, NULL, 7760, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 09:40:02', 'admin-1489711683-1489714801904896', 1, 0, '', NULL, NULL, NULL),
(23983, '2017-03-17 10:07:54', NULL, NULL, 7761, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:07:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23984, '2017-03-17 10:07:59', NULL, NULL, 7761, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:07:59', 'admin-1489711683-14897164790302866', 1, 1, 'SR', NULL, NULL, NULL),
(23985, '2017-03-17 10:07:59', NULL, NULL, 7761, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:07:59', 'admin-1489711683-14897164790302866', 1, 1, 'SR', NULL, NULL, NULL),
(23986, '2017-03-17 10:20:48', NULL, NULL, 7762, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.35, 0.0000, 0.0000, 5.35, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:20:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23987, '2017-03-17 10:21:13', NULL, NULL, 7762, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:21:13', 'admin-1489711683-14897172733765365', 1, 0, '', NULL, NULL, NULL),
(23988, '2017-03-17 10:21:13', NULL, NULL, 7762, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:21:13', 'admin-1489711683-14897172733765365', 1, 1, 'SR', NULL, NULL, NULL),
(23989, '2017-03-17 10:21:13', NULL, NULL, 7762, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489732339', 'admin', '2017-03-17 10:21:13', 'admin-1489711683-14897172733765365', 1, 1, 'SR', NULL, NULL, NULL),
(23990, '2017-03-17 09:39:57', NULL, NULL, 7760, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1489732339', 'admin', '2017-03-17 09:39:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23991, '2017-03-18 18:56:58', NULL, NULL, 7841, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 18:56:58', 'admin-1489833380-14898346182825618', 1, 0, '', NULL, NULL, NULL),
(23992, '2017-03-18 13:35:44', NULL, NULL, 7833, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:35:44', 'admin-1489815317-14898153439813922', 1, 0, '', NULL, NULL, NULL),
(23993, '2017-03-18 13:35:44', NULL, NULL, 7833, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:35:44', 'admin-1489815317-14898153439813922', 1, 0, '', NULL, NULL, NULL),
(23994, '2017-03-18 13:35:44', NULL, NULL, 7833, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:35:44', 'admin-1489815317-14898153439813922', 1, 1, 'SR', NULL, NULL, NULL),
(23995, '2017-03-18 13:36:45', NULL, NULL, 7830, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:36:45', 'admin-1489815317-14898154050584173', 1, 0, '', NULL, NULL, NULL),
(23996, '2017-03-18 13:36:45', NULL, NULL, 7830, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:36:45', 'admin-1489815317-14898154050584173', 1, 0, '', NULL, NULL, NULL),
(23997, '2017-03-18 13:29:17', NULL, NULL, 7832, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:29:17', 'admin-1489812004-14898149568631011', 1, 0, '', NULL, NULL, NULL),
(23998, '2017-03-18 13:34:51', NULL, NULL, 7833, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:34:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(23999, '2017-03-18 13:35:05', NULL, NULL, 7833, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:35:05', 'admin-1489812004-1489815305301307', 1, 0, '', NULL, NULL, NULL),
(24000, '2017-03-18 14:35:25', NULL, NULL, 7836, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1489833380', 'admin', '2017-03-18 14:35:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24001, '2017-03-18 14:35:40', NULL, NULL, 7836, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 14:35:40', 'admin-1489817773-14898189398861898', 1, 0, '', NULL, NULL, NULL),
(24002, '2017-03-18 14:35:40', NULL, NULL, 7836, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 14:35:40', 'admin-1489817773-14898189398861898', 1, 0, '', NULL, NULL, NULL),
(24003, '2017-03-18 14:38:42', NULL, NULL, 7837, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1489833380', 'admin', '2017-03-18 14:38:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24004, '2017-03-18 14:38:56', NULL, NULL, 7837, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 14:38:56', 'admin-1489817773-14898191361096014', 1, 1, 'SR', NULL, NULL, NULL),
(24005, '2017-03-18 14:38:56', NULL, NULL, 7837, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 14:38:56', 'admin-1489817773-14898191361096014', 1, 0, '', NULL, NULL, NULL),
(24006, '2017-03-18 14:40:00', NULL, NULL, 7837, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 14:40:00', 'admin-1489817773-14898192004244254', 1, 0, '', NULL, NULL, NULL),
(24007, '2017-03-18 14:53:08', NULL, NULL, 7835, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 14:53:08', 'admin-1489817773-1489819988486845', 1, 0, '', NULL, NULL, NULL),
(24008, '2017-03-18 13:23:12', NULL, NULL, 7831, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:23:12', 'admin-1489812004-1489814592549617', 1, 1, 'SR', NULL, NULL, NULL),
(24009, '2017-03-18 13:28:55', NULL, NULL, 7832, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:28:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24010, '2017-03-18 13:29:17', NULL, NULL, 7832, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:29:17', 'admin-1489812004-14898149568631011', 1, 1, 'SR', NULL, NULL, NULL),
(24011, '2017-03-18 10:07:42', NULL, NULL, 7809, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:07:42', 'admin-1489801241-14898028627841119', 1, 0, '', NULL, NULL, NULL),
(24012, '2017-03-18 10:07:42', NULL, NULL, 7809, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:07:42', 'admin-1489801241-14898028627841119', 1, 0, '', NULL, NULL, NULL),
(24013, '2017-03-18 09:40:31', NULL, NULL, 7803, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:40:31', 'admin-1489799352-14898012316996586', 1, 0, '', NULL, NULL, NULL),
(24014, '2017-03-18 09:40:51', NULL, NULL, 7803, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:40:51', 'admin-1489801241-14898012513382144', 1, 1, 'SR', NULL, NULL, NULL),
(24015, '2017-03-18 09:47:22', NULL, NULL, 7804, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.60, 0.0000, 0.0000, 16.60, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:47:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24016, '2017-03-18 09:47:55', NULL, NULL, 7804, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:47:55', 'admin-1489801241-14898016757412281', 1, 0, '', NULL, NULL, NULL),
(24017, '2017-03-18 09:47:55', NULL, NULL, 7804, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:47:55', 'admin-1489801241-14898016757412281', 1, 0, '', NULL, NULL, NULL),
(24018, '2017-03-18 09:47:55', NULL, NULL, 7804, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:47:55', 'admin-1489801241-14898016757412281', 1, 0, '', NULL, NULL, NULL),
(24019, '2017-03-18 09:47:55', NULL, NULL, 7804, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:47:55', 'admin-1489801241-14898016757412281', 1, 0, '', NULL, NULL, NULL),
(24020, '2017-03-18 09:47:55', NULL, NULL, 7804, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:47:55', 'admin-1489801241-14898016757412281', 1, 0, '', NULL, NULL, NULL),
(24021, '2017-03-18 09:47:55', NULL, NULL, 7804, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:47:55', 'admin-1489801241-14898016757412281', 1, 0, '', NULL, NULL, NULL),
(24022, '2017-03-18 09:48:40', NULL, NULL, 7804, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:48:40', 'admin-1489801241-14898017203366747', 1, 0, '', NULL, NULL, NULL),
(24023, '2017-03-18 09:48:40', NULL, NULL, 7804, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:48:40', 'admin-1489801241-14898017203366747', 1, 1, 'SR', NULL, NULL, NULL),
(24024, '2017-03-18 09:48:40', NULL, NULL, 7804, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:48:40', 'admin-1489801241-14898017203366747', 1, 1, 'SR', NULL, NULL, NULL),
(24025, '2017-03-18 09:48:40', NULL, NULL, 7804, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:48:40', 'admin-1489801241-14898017203366747', 1, 1, 'SR', NULL, NULL, NULL),
(24026, '2017-03-18 12:52:08', NULL, NULL, 7825, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:52:08', 'admin-1489812004-14898127284081531', 1, 1, 'SR', NULL, NULL, NULL),
(24027, '2017-03-18 12:59:51', NULL, NULL, 7815, 0, 75, '75', 'Meatless Aglio Olio ', 'Extra Spicy,Takeaway', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:59:51', 'admin-1489812004-1489813191248378', 1, 0, '', NULL, NULL, NULL),
(24028, '2017-03-18 18:36:11', NULL, NULL, 7841, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 18:36:11', 'admin-1489817773-14898333714476365', 1, 0, '', NULL, NULL, NULL),
(24029, '2017-03-18 18:36:11', NULL, NULL, 7841, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 18:36:11', 'admin-1489817773-14898333714476365', 1, 1, 'SR', NULL, NULL, NULL),
(24030, '2017-03-18 13:10:33', NULL, NULL, 7828, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:10:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24031, '2017-03-18 13:22:33', NULL, NULL, 7828, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:22:33', 'admin-1489812004-1489814553443772', 1, 0, '', NULL, NULL, NULL),
(24032, '2017-03-18 13:11:43', NULL, NULL, 7828, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:11:43', 'admin-1489812004-14898139037411163', 1, 0, '', NULL, NULL, NULL),
(24033, '2017-03-18 13:11:43', NULL, NULL, 7828, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:11:43', 'admin-1489812004-14898139037411163', 1, 0, '', NULL, NULL, NULL),
(24034, '2017-03-18 13:11:43', NULL, NULL, 7828, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:11:43', 'admin-1489812004-14898139037411163', 1, 0, '', NULL, NULL, NULL),
(24035, '2017-03-18 19:04:05', NULL, NULL, 7842, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 19:04:05', 'admin-1489833380-1489835045085440', 1, 1, 'SR', 1, NULL, NULL),
(24036, '2017-03-18 19:48:57', NULL, NULL, 7843, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1489833380', 'admin', '2017-03-18 19:48:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24037, '2017-03-18 19:49:46', NULL, NULL, 7843, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 19:49:46', 'admin-1489833380-14898377859572979', 1, 1, 'SR', NULL, NULL, NULL),
(24038, '2017-03-18 19:49:46', NULL, NULL, 7843, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 19:49:46', 'admin-1489833380-14898377859572979', 1, 0, '', NULL, NULL, NULL),
(24039, '2017-03-18 18:36:11', NULL, NULL, 7841, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 18:36:11', 'admin-1489817773-14898333714476365', 1, 1, 'SR', NULL, NULL, NULL),
(24040, '2017-03-18 18:36:11', NULL, NULL, 7841, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 18:36:11', 'admin-1489817773-14898333714476365', 1, 0, '', NULL, NULL, NULL),
(24041, '2017-03-18 13:35:05', NULL, NULL, 7833, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:35:05', 'admin-1489812004-1489815305301307', 1, 1, 'SR', NULL, NULL, NULL),
(24042, '2017-03-18 18:36:11', NULL, NULL, 7841, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 18:36:11', 'admin-1489817773-14898333714476365', 1, 1, 'SR', NULL, NULL, NULL),
(24043, '2017-03-18 18:36:11', NULL, NULL, 7841, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 18:36:11', 'admin-1489817773-14898333714476365', 1, 1, 'SR', NULL, NULL, NULL),
(24044, '2017-03-18 18:35:10', NULL, NULL, 7841, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.00, 0.0000, 0.0000, 15.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 18:35:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24045, '2017-03-18 18:36:11', NULL, NULL, 7841, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 18:36:11', 'admin-1489817773-14898333714476365', 1, 0, '', NULL, NULL, NULL),
(24046, '2017-03-18 17:28:18', NULL, NULL, 7840, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 17:28:18', 'admin-1489817773-14898292979199284', 1, 1, 'SR', 1, NULL, NULL),
(24047, '2017-03-18 17:28:18', NULL, NULL, 7840, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 17:28:18', 'admin-1489817773-14898292979199284', 1, 1, 'SR', 1, NULL, NULL),
(24048, '2017-03-18 17:28:18', NULL, NULL, 7840, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 17:28:18', 'admin-1489817773-14898292979199284', 1, 1, 'SR', 1, NULL, NULL),
(24049, '2017-03-18 16:33:34', NULL, NULL, 7839, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 16:33:34', 'admin-1489817773-1489826014733962', 1, 1, 'SR', NULL, NULL, NULL),
(24050, '2017-03-18 16:33:31', NULL, NULL, 7839, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1489833380', 'admin', '2017-03-18 16:33:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24051, '2017-03-18 15:51:46', NULL, NULL, 7838, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 15:51:46', 'admin-1489817773-14898235066217197', 1, 1, 'SR', NULL, NULL, NULL),
(24052, '2017-03-18 15:51:36', NULL, NULL, 7838, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1489833380', 'admin', '2017-03-18 15:51:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24053, '2017-03-18 15:06:38', NULL, NULL, 7835, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 15:06:38', 'admin-1489817773-14898207978816678', 1, 1, 'SR', NULL, NULL, NULL),
(24054, '2017-03-18 12:03:48', NULL, NULL, 7820, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:03:48', 'admin-1489809794-14898098280652020', 1, 1, 'SR', NULL, NULL, NULL),
(24055, '2017-03-18 12:03:48', NULL, NULL, 7820, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:03:48', 'admin-1489809794-14898098280652020', 1, 0, '', NULL, NULL, NULL),
(24056, '2017-03-18 12:04:15', NULL, NULL, 7815, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:04:15', 'admin-1489809794-14898098556103688', 1, 1, 'SR', NULL, NULL, NULL),
(24057, '2017-03-18 12:05:57', NULL, NULL, 7821, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:05:57', 'admin-1489809794-1489809957692593', 1, 1, 'SR', 1, NULL, NULL),
(24058, '2017-03-18 12:14:43', NULL, NULL, 7822, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:14:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24059, '2017-03-18 12:15:25', NULL, NULL, 7822, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:15:25', 'admin-1489809794-14898105250159429', 1, 1, 'SR', NULL, NULL, NULL),
(24060, '2017-03-18 12:15:25', NULL, NULL, 7822, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:15:25', 'admin-1489809794-14898105250159429', 1, 0, '', NULL, NULL, NULL),
(24061, '2017-03-18 12:15:25', NULL, NULL, 7822, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:15:25', 'admin-1489809794-14898105250159429', 1, 0, '', NULL, NULL, NULL),
(24062, '2017-03-18 10:08:52', NULL, NULL, 7810, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:08:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24063, '2017-03-18 19:04:05', NULL, NULL, 7842, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 19:04:05', 'admin-1489833380-1489835045085440', 1, 1, 'SR', 1, NULL, NULL),
(24064, '2017-03-18 18:37:12', NULL, NULL, 7841, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 18:37:12', 'admin-1489833380-14898334321717764', 1, 1, 'SR', NULL, NULL, NULL),
(24065, '2017-03-18 18:37:12', NULL, NULL, 7841, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 18:37:12', 'admin-1489833380-14898334321717764', 1, 1, 'SR', NULL, NULL, NULL),
(24066, '2017-03-18 18:37:12', NULL, NULL, 7841, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 18:37:12', 'admin-1489833380-14898334321717764', 1, 1, 'SR', NULL, NULL, NULL),
(24067, '2017-03-18 14:19:05', NULL, NULL, 7835, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.30, 0.0000, 0.0000, 10.30, 1, '27', 1, '1489833380', 'admin', '2017-03-18 14:19:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24068, '2017-03-18 14:19:55', NULL, NULL, 7835, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 14:19:55', 'admin-1489817773-14898179948782216', 1, 0, '', NULL, NULL, NULL),
(24069, '2017-03-18 14:19:55', NULL, NULL, 7835, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 14:19:55', 'admin-1489817773-14898179948782216', 1, 0, '', NULL, NULL, NULL),
(24070, '2017-03-18 14:27:03', NULL, NULL, 7835, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 14:27:03', 'admin-1489817773-1489818422915526', 1, 0, '', NULL, NULL, NULL),
(24071, '2017-03-18 14:27:03', NULL, NULL, 7835, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 14:27:03', 'admin-1489817773-1489818422915526', 1, 1, 'SR', NULL, NULL, NULL),
(24072, '2017-03-18 14:19:55', NULL, NULL, 7835, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 14:19:55', 'admin-1489817773-14898179948782216', 1, 1, 'SR', NULL, NULL, NULL),
(24073, '2017-03-18 13:56:30', NULL, NULL, 7820, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:56:30', 'admin-1489815317-14898165902248034', 1, 1, 'SR', NULL, NULL, NULL),
(24074, '2017-03-18 13:55:13', NULL, NULL, 7833, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:55:13', 'admin-1489815317-1489816512992770', 1, 1, 'SR', NULL, NULL, NULL),
(24075, '2017-03-18 13:54:53', NULL, NULL, 7820, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:54:53', 'admin-1489815317-14898164934966376', 1, 0, '', NULL, NULL, NULL),
(24076, '2017-03-18 13:53:57', NULL, NULL, 7817, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:53:57', 'admin-1489815317-14898164370936076', 1, 0, '', NULL, NULL, NULL),
(24077, '2017-03-18 13:38:00', NULL, NULL, 7834, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:38:00', 'admin-1489815317-14898154801224931', 1, 0, '', NULL, NULL, NULL),
(24078, '2017-03-18 13:38:00', NULL, NULL, 7834, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:38:00', 'admin-1489815317-14898154801224931', 1, 0, '', NULL, NULL, NULL),
(24079, '2017-03-18 11:40:38', NULL, NULL, 7817, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:40:38', 'admin-1489807771-14898084380157810', 1, 0, '', NULL, NULL, NULL),
(24080, '2017-03-18 11:40:51', NULL, NULL, 7817, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:40:51', 'admin-1489807771-14898084514601081', 1, 1, 'SR', NULL, NULL, NULL),
(24081, '2017-03-18 11:40:51', NULL, NULL, 7817, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:40:51', 'admin-1489807771-14898084514601081', 1, 0, '', NULL, NULL, NULL),
(24082, '2017-03-18 11:48:26', NULL, NULL, 7818, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:48:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24083, '2017-03-18 11:48:36', NULL, NULL, 7818, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:48:36', 'admin-1489807771-14898089159668222', 1, 0, '', NULL, NULL, NULL),
(24084, '2017-03-18 11:48:44', NULL, NULL, 7819, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:48:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24085, '2017-03-18 12:50:02', NULL, NULL, 7820, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:50:02', 'admin-1489812004-14898126027004334', 1, 0, '', NULL, NULL, NULL),
(24086, '2017-03-18 12:50:32', NULL, NULL, 7827, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:50:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24087, '2017-03-18 10:18:41', NULL, NULL, 7806, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:18:41', 'admin-1489802985-1489803521610353', 1, 0, '', NULL, NULL, NULL),
(24088, '2017-03-18 10:33:11', NULL, NULL, 7811, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:33:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24089, '2017-03-18 10:33:27', NULL, NULL, 7811, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:33:27', 'admin-1489802985-14898044077327869', 1, 0, '', NULL, NULL, NULL),
(24090, '2017-03-18 10:33:27', NULL, NULL, 7811, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:33:27', 'admin-1489802985-14898044077327869', 1, 0, '', NULL, NULL, NULL),
(24091, '2017-03-18 10:33:27', NULL, NULL, 7811, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:33:27', 'admin-1489802985-14898044077327869', 1, 1, 'SR', NULL, NULL, NULL),
(24092, '2017-03-18 10:40:02', NULL, NULL, 7812, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:40:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24093, '2017-03-18 10:40:05', NULL, NULL, 7812, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:40:05', 'admin-1489802985-14898048055349346', 1, 1, 'SR', NULL, NULL, NULL),
(24094, '2017-03-18 10:42:20', NULL, NULL, 7813, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:42:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24095, '2017-03-18 09:30:04', NULL, NULL, 7802, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:30:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24096, '2017-03-18 12:50:41', NULL, NULL, 7827, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:50:41', 'admin-1489812004-14898126411034036', 1, 1, 'SR', NULL, NULL, NULL),
(24097, '2017-03-18 12:50:41', NULL, NULL, 7827, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:50:41', 'admin-1489812004-14898126411034036', 1, 1, 'SR', NULL, NULL, NULL),
(24098, '2017-03-18 12:50:41', NULL, NULL, 7827, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:50:41', 'admin-1489812004-14898126411034036', 1, 1, 'SR', NULL, NULL, NULL),
(24099, '2017-03-18 12:49:16', NULL, NULL, 7826, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:49:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24100, '2017-03-18 10:09:31', NULL, NULL, 7810, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:09:31', 'admin-1489801241-14898029714346823', 1, 0, '', NULL, NULL, NULL),
(24101, '2017-03-18 12:49:21', NULL, NULL, 7826, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:49:21', 'admin-1489812004-14898125610039254', 1, 1, 'SR', NULL, NULL, NULL),
(24102, '2017-03-18 12:49:21', NULL, NULL, 7826, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:49:21', 'admin-1489812004-14898125610039254', 1, 1, 'SR', NULL, NULL, NULL),
(24103, '2017-03-18 14:19:55', NULL, NULL, 7835, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 14:19:55', 'admin-1489817773-14898179948782216', 1, 1, 'SR', NULL, NULL, NULL),
(24104, '2017-03-18 13:37:26', NULL, NULL, 7834, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:37:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24105, '2017-03-18 13:38:00', NULL, NULL, 7834, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:38:00', 'admin-1489815317-14898154801224931', 1, 1, 'SR', NULL, NULL, NULL),
(24106, '2017-03-18 13:35:44', NULL, NULL, 7833, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:35:44', 'admin-1489815317-14898153439813922', 1, 0, '', NULL, NULL, NULL),
(24107, '2017-03-18 13:22:59', NULL, NULL, 7831, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:22:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24108, '2017-03-18 12:46:55', NULL, NULL, 7825, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:46:55', 'admin-1489812004-14898124156465993', 1, 1, 'SR', NULL, NULL, NULL),
(24109, '2017-03-18 12:46:55', NULL, NULL, 7825, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:46:55', 'admin-1489812004-14898124156465993', 1, 0, '', NULL, NULL, NULL),
(24110, '2017-03-18 12:46:55', NULL, NULL, 7825, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:46:55', 'admin-1489812004-14898124156465993', 1, 0, '', NULL, NULL, NULL),
(24111, '2017-03-18 12:46:28', NULL, NULL, 7825, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:46:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24112, '2017-03-18 12:39:55', NULL, NULL, 7824, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:39:55', 'admin-1489809794-14898119951031390', 1, 0, '', NULL, NULL, NULL),
(24113, '2017-03-18 12:38:31', NULL, NULL, 7824, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:38:31', 'admin-1489809794-1489811911404842', 1, 1, 'SR', NULL, NULL, NULL),
(24114, '2017-03-18 12:38:31', NULL, NULL, 7824, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:38:31', 'admin-1489809794-1489811911404842', 1, 0, '', NULL, NULL, NULL),
(24115, '2017-03-18 12:38:23', NULL, NULL, 7824, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:38:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24116, '2017-03-18 12:28:18', NULL, NULL, 7815, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:28:18', 'admin-1489809794-14898112983532129', 1, 1, 'SR', NULL, NULL, NULL),
(24117, '2017-03-18 12:26:01', NULL, NULL, 7819, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:26:01', 'admin-1489809794-14898111617604290', 1, 0, '', NULL, NULL, NULL),
(24118, '2017-03-18 12:18:00', NULL, NULL, 7823, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:18:00', 'admin-1489809794-14898106804412361', 1, 0, '', NULL, NULL, NULL),
(24119, '2017-03-18 12:18:00', NULL, NULL, 7823, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:18:00', 'admin-1489809794-14898106804412361', 1, 0, '', NULL, NULL, NULL),
(24120, '2017-03-18 12:17:24', NULL, NULL, 7823, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:17:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24121, '2017-03-18 12:15:25', NULL, NULL, 7822, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:15:25', 'admin-1489809794-14898105250159429', 1, 0, '', NULL, NULL, NULL),
(24122, '2017-03-18 12:15:25', NULL, NULL, 7822, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:15:25', 'admin-1489809794-14898105250159429', 1, 1, 'SR', NULL, NULL, NULL),
(24123, '2017-03-18 13:29:17', NULL, NULL, 7832, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:29:17', 'admin-1489812004-14898149568631011', 1, 0, '', NULL, NULL, NULL),
(24124, '2017-03-18 13:22:05', NULL, NULL, 7830, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:22:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24125, '2017-03-18 13:22:13', NULL, NULL, 7830, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:22:13', 'admin-1489812004-14898145328831721', 1, 0, '', NULL, NULL, NULL),
(24126, '2017-03-18 13:21:21', NULL, NULL, 7815, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:21:21', 'admin-1489812004-14898144809667338', 1, 0, '', NULL, NULL, NULL),
(24127, '2017-03-18 13:16:00', NULL, NULL, 7827, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:16:00', 'admin-1489812004-14898141599208074', 1, 0, '', NULL, NULL, NULL),
(24128, '2017-03-18 13:11:51', NULL, NULL, 7829, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:11:51', 'admin-1489812004-14898139117196980', 1, 1, 'SR', NULL, NULL, NULL),
(24129, '2017-03-18 13:11:51', NULL, NULL, 7829, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:11:51', 'admin-1489812004-14898139117196980', 1, 1, 'SR', NULL, NULL, NULL),
(24130, '2017-03-18 13:11:47', NULL, NULL, 7829, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:11:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24131, '2017-03-18 12:02:59', NULL, NULL, 7816, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:02:59', 'admin-1489807771-14898097789322254', 1, 1, 'SR', NULL, NULL, NULL),
(24132, '2017-03-18 11:49:49', NULL, NULL, 7819, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:49:49', 'admin-1489807771-14898089892879547', 1, 0, '', NULL, NULL, NULL),
(24133, '2017-03-18 13:04:36', NULL, NULL, 7819, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:04:36', 'admin-1489812004-14898134764384210', 1, 1, 'SR', NULL, NULL, NULL),
(24134, '2017-03-18 12:03:48', NULL, NULL, 7820, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:03:48', 'admin-1489809794-14898098280652020', 1, 0, '', NULL, NULL, NULL),
(24135, '2017-03-18 12:03:48', NULL, NULL, 7820, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:03:48', 'admin-1489809794-14898098280652020', 1, 1, 'SR', NULL, NULL, NULL),
(24136, '2017-03-18 12:03:48', NULL, NULL, 7820, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:03:48', 'admin-1489809794-14898098280652020', 1, 1, 'SR', NULL, NULL, NULL),
(24137, '2017-03-18 12:03:02', NULL, NULL, 7820, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.10, 0.0000, 0.0000, 12.10, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:03:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24138, '2017-03-18 12:02:59', NULL, NULL, 7816, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 12:02:59', 'admin-1489807771-14898097789322254', 1, 1, 'SR', NULL, NULL, NULL),
(24139, '2017-03-18 11:49:49', NULL, NULL, 7819, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:49:49', 'admin-1489807771-14898089892879547', 1, 1, 'SR', NULL, NULL, NULL),
(24140, '2017-03-18 11:49:49', NULL, NULL, 7819, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:49:49', 'admin-1489807771-14898089892879547', 1, 0, '', NULL, NULL, NULL),
(24141, '2017-03-18 11:29:46', NULL, NULL, 7816, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:29:46', 'admin-1489807771-14898077866059134', 1, 1, 'SR', NULL, NULL, NULL),
(24142, '2017-03-18 11:40:24', NULL, NULL, 7817, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:40:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24143, '2017-03-18 11:40:38', NULL, NULL, 7817, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:40:38', 'admin-1489807771-14898084380157810', 1, 0, '', NULL, NULL, NULL),
(24144, '2017-03-18 10:09:31', NULL, NULL, 7810, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:09:31', 'admin-1489801241-14898029714346823', 1, 1, 'SR', NULL, NULL, NULL),
(24145, '2017-03-18 11:25:10', NULL, NULL, 7815, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:25:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24146, '2017-03-18 11:25:15', NULL, NULL, 7815, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:25:15', 'admin-1489802985-1489807515818698', 1, 0, '', NULL, NULL, NULL),
(24147, '2017-03-18 11:25:15', NULL, NULL, 7815, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:25:15', 'admin-1489802985-1489807515818698', 1, 0, '', NULL, NULL, NULL),
(24148, '2017-03-18 11:29:46', NULL, NULL, 7816, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:29:46', 'admin-1489807771-14898077866059134', 1, 1, 'SR', NULL, NULL, NULL),
(24149, '2017-03-18 11:29:46', NULL, NULL, 7816, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:29:46', 'admin-1489807771-14898077866059134', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(24150, '2017-03-18 11:29:14', NULL, NULL, 7816, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:29:14', 'admin-1489802985-14898077543137277', 1, 0, '', NULL, NULL, NULL),
(24151, '2017-03-18 11:29:14', NULL, NULL, 7816, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:29:14', 'admin-1489802985-14898077543137277', 1, 0, '', NULL, NULL, NULL),
(24152, '2017-03-18 11:29:14', NULL, NULL, 7816, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:29:14', 'admin-1489802985-14898077543137277', 1, 0, '', NULL, NULL, NULL),
(24153, '2017-03-18 11:29:14', NULL, NULL, 7816, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:29:14', 'admin-1489802985-14898077543137277', 1, 0, '', NULL, NULL, NULL),
(24154, '2017-03-18 11:21:51', NULL, NULL, 7802, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:21:51', 'admin-1489802985-14898073116513157', 1, 0, '', NULL, NULL, NULL),
(24155, '2017-03-18 11:01:20', NULL, NULL, 7814, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:01:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24156, '2017-03-18 11:01:26', NULL, NULL, 7814, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:01:26', 'admin-1489802985-1489806086655445', 1, 0, '', NULL, NULL, NULL),
(24157, '2017-03-18 11:01:32', NULL, NULL, 7814, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:01:32', 'admin-1489802985-14898060926054186', 1, 1, 'SR', NULL, NULL, NULL),
(24158, '2017-03-18 10:42:44', NULL, NULL, 7813, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:42:44', 'admin-1489802985-1489804963910204', 1, 1, 'SR', NULL, NULL, NULL),
(24159, '2017-03-18 11:29:01', NULL, NULL, 7816, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.70, 0.0000, 0.0000, 11.70, 1, '27', 1, '1489833380', 'admin', '2017-03-18 11:29:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24160, '2017-03-18 10:42:44', NULL, NULL, 7813, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:42:44', 'admin-1489802985-1489804963910204', 1, 1, 'SR', NULL, NULL, NULL),
(24161, '2017-03-18 10:42:32', NULL, NULL, 7813, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:42:32', 'admin-1489802985-14898049526467920', 1, 0, '', NULL, NULL, NULL),
(24162, '2017-03-18 10:42:32', NULL, NULL, 7813, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:42:32', 'admin-1489802985-14898049526467920', 1, 0, '', NULL, NULL, NULL),
(24163, '2017-03-18 10:18:41', NULL, NULL, 7806, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:18:41', 'admin-1489802985-1489803521610353', 1, 1, 'SR', NULL, NULL, NULL),
(24164, '2017-03-18 10:03:46', NULL, NULL, 7808, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:03:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24165, '2017-03-18 10:04:02', NULL, NULL, 7808, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:04:02', 'admin-1489801241-14898026425847972', 1, 1, 'SR', NULL, NULL, NULL),
(24166, '2017-03-18 10:04:02', NULL, NULL, 7808, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:04:02', 'admin-1489801241-14898026425847972', 1, 1, 'SR', NULL, NULL, NULL),
(24167, '2017-03-18 10:04:02', NULL, NULL, 7808, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:04:02', 'admin-1489801241-14898026425847972', 1, 0, '', NULL, NULL, NULL),
(24168, '2017-03-18 10:04:02', NULL, NULL, 7808, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:04:02', 'admin-1489801241-14898026425847972', 1, 0, '', NULL, NULL, NULL),
(24169, '2017-03-18 10:07:22', NULL, NULL, 7809, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:07:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24170, '2017-03-18 10:07:42', NULL, NULL, 7809, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:07:42', 'admin-1489801241-14898028627841119', 1, 0, '', NULL, NULL, NULL),
(24171, '2017-03-18 10:09:31', NULL, NULL, 7810, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:09:31', 'admin-1489801241-14898029714346823', 1, 1, 'SR', NULL, NULL, NULL),
(24172, '2017-03-18 10:09:31', NULL, NULL, 7810, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:09:31', 'admin-1489801241-14898029714346823', 1, 0, '', NULL, NULL, NULL),
(24173, '2017-03-18 10:09:31', NULL, NULL, 7810, NULL, 34, '34', 'Ginger Lemongrass ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:09:31', 'admin-1489801241-14898029714346823', 1, 1, 'SR', NULL, NULL, NULL),
(24174, '2017-03-18 10:09:31', NULL, NULL, 7810, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:09:31', 'admin-1489801241-14898029714346823', 1, 0, '', NULL, NULL, NULL),
(24175, '2017-03-18 10:08:13', NULL, NULL, 7802, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:08:13', 'admin-1489801241-1489802893049601', 1, 1, 'SR', NULL, NULL, NULL),
(24176, '2017-03-18 09:58:03', NULL, NULL, 7805, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:58:03', 'admin-1489801241-14898022836173025', 1, 0, '', NULL, NULL, NULL),
(24177, '2017-03-18 09:58:03', NULL, NULL, 7805, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:58:03', 'admin-1489801241-14898022836173025', 1, 0, '', NULL, NULL, NULL),
(24178, '2017-03-18 09:58:47', NULL, NULL, 7800, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:58:47', 'admin-1489801241-1489802327208132', 1, 0, '', NULL, NULL, NULL),
(24179, '2017-03-18 10:00:48', NULL, NULL, 7806, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.45, 0.0000, 0.0000, 8.45, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:00:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24180, '2017-03-18 10:01:28', NULL, NULL, 7806, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:01:28', 'admin-1489801241-14898024884145420', 1, 0, '', NULL, NULL, NULL),
(24181, '2017-03-18 10:01:28', NULL, NULL, 7806, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:01:28', 'admin-1489801241-14898024884145420', 1, 0, '', NULL, NULL, NULL),
(24182, '2017-03-18 10:01:28', NULL, NULL, 7806, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:01:28', 'admin-1489801241-14898024884145420', 1, 0, '', NULL, NULL, NULL),
(24183, '2017-03-18 10:01:28', NULL, NULL, 7806, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:01:28', 'admin-1489801241-14898024884145420', 1, 1, 'SR', NULL, NULL, NULL),
(24184, '2017-03-18 10:01:28', NULL, NULL, 7806, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:01:28', 'admin-1489801241-14898024884145420', 1, 1, 'SR', NULL, NULL, NULL),
(24185, '2017-03-18 10:02:52', NULL, NULL, 7807, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:02:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24186, '2017-03-18 10:03:03', NULL, NULL, 7807, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:03:03', 'admin-1489801241-14898025834324251', 1, 1, 'SR', NULL, NULL, NULL),
(24187, '2017-03-18 10:03:03', NULL, NULL, 7807, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:03:03', 'admin-1489801241-14898025834324251', 1, 0, '', NULL, NULL, NULL),
(24188, '2017-03-18 10:03:03', NULL, NULL, 7807, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:03:03', 'admin-1489801241-14898025834324251', 1, 1, 'SR', NULL, NULL, NULL),
(24189, '2017-03-18 09:09:49', NULL, NULL, 7798, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:09:49', 'admin-1489799352-14897993896012187', 1, 0, '', NULL, NULL, NULL),
(24190, '2017-03-18 09:09:49', NULL, NULL, 7798, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:09:49', 'admin-1489799352-14897993896012187', 1, 1, 'SR', NULL, NULL, NULL),
(24191, '2017-03-18 09:09:49', NULL, NULL, 7798, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:09:49', 'admin-1489799352-14897993896012187', 1, 1, 'SR', NULL, NULL, NULL),
(24192, '2017-03-18 09:24:38', NULL, NULL, 7800, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:24:38', 'admin-1489799352-14898002781004971', 1, 1, 'SR', NULL, NULL, NULL),
(24193, '2017-03-18 09:24:24', NULL, NULL, 7800, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:24:24', 'admin-1489799352-14898002643652636', 1, 0, '', NULL, NULL, NULL),
(24194, '2017-03-18 09:24:24', NULL, NULL, 7800, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:24:24', 'admin-1489799352-14898002643652636', 1, 0, '', NULL, NULL, NULL),
(24195, '2017-03-18 09:25:30', NULL, NULL, 7801, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:25:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24196, '2017-03-18 09:25:39', NULL, NULL, 7801, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:25:39', 'admin-1489799352-14898003397456067', 1, 0, '', NULL, NULL, NULL),
(24197, '2017-03-18 09:25:40', NULL, NULL, 7801, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:25:40', 'admin-1489799352-14898003397456067', 1, 0, '', NULL, NULL, NULL),
(24198, '2017-03-18 09:25:47', NULL, NULL, 7801, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:25:47', 'admin-1489799352-14898003470466739', 1, 1, 'SR', NULL, NULL, NULL),
(24199, '2017-03-18 09:25:47', NULL, NULL, 7801, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:25:47', 'admin-1489799352-14898003470466739', 1, 1, 'SR', NULL, NULL, NULL),
(24200, '2017-03-18 09:25:47', NULL, NULL, 7801, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:25:47', 'admin-1489799352-14898003470466739', 1, 1, 'SR', NULL, NULL, NULL),
(24201, '2017-03-18 13:38:00', NULL, NULL, 7834, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 13:38:00', 'admin-1489815317-14898154801224931', 1, 1, 'SR', NULL, NULL, NULL),
(24202, '2017-03-18 10:07:42', NULL, NULL, 7809, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 10:07:42', 'admin-1489801241-14898028627841119', 1, 1, 'SR', NULL, NULL, NULL),
(24203, '2017-03-18 09:58:11', NULL, NULL, 7805, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:58:11', 'admin-1489801241-14898022911403790', 1, 1, 'SR', NULL, NULL, NULL),
(24204, '2017-03-18 09:58:11', NULL, NULL, 7805, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:58:11', 'admin-1489801241-14898022911403790', 1, 1, 'SR', NULL, NULL, NULL),
(24205, '2017-03-18 09:57:50', NULL, NULL, 7805, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:57:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24206, '2017-03-18 09:48:40', NULL, NULL, 7804, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:48:40', 'admin-1489801241-14898017203366747', 1, 1, 'SR', NULL, NULL, NULL),
(24207, '2017-03-18 09:49:44', NULL, NULL, 7802, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:49:44', 'admin-1489801241-14898017845926370', 1, 1, 'SR', NULL, NULL, NULL),
(24208, '2017-03-18 09:40:25', NULL, NULL, 7803, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:40:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24209, '2017-03-18 09:30:13', NULL, NULL, 7802, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:30:13', 'admin-1489799352-14898006137073048', 1, 0, '', NULL, NULL, NULL),
(24210, '2017-03-18 09:30:13', NULL, NULL, 7802, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:30:13', 'admin-1489799352-14898006137073048', 1, 0, '', NULL, NULL, NULL),
(24211, '2017-03-18 09:21:37', NULL, NULL, 7799, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:21:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24212, '2017-03-18 09:23:28', NULL, NULL, 7799, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:23:28', 'admin-1489799352-14898002086172664', 1, 1, 'SR', NULL, NULL, NULL),
(24213, '2017-03-18 09:23:28', NULL, NULL, 7799, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:23:28', 'admin-1489799352-14898002086172664', 1, 0, '', NULL, NULL, NULL),
(24214, '2017-03-18 09:23:56', NULL, NULL, 7799, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:23:56', 'admin-1489799352-14898002367842770', 1, 0, '', NULL, NULL, NULL),
(24215, '2017-03-18 09:07:58', NULL, NULL, 7797, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:07:58', 'admin-1489798849-14897992782956795', 1, 1, 'SR', 1, NULL, NULL),
(24216, '2017-03-18 09:07:58', NULL, NULL, 7797, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:07:58', 'admin-1489798849-14897992782956795', 1, 1, 'SR', 1, NULL, NULL),
(24217, '2017-03-18 09:07:58', NULL, NULL, 7797, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:07:58', 'admin-1489798849-14897992782956795', 1, 1, 'SR', 1, NULL, NULL),
(24218, '2017-03-18 09:09:26', NULL, NULL, 7798, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:09:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24219, '2017-03-18 09:09:49', NULL, NULL, 7798, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:09:49', 'admin-1489799352-14897993896012187', 1, 0, '', NULL, NULL, NULL),
(24220, '2017-03-18 09:09:49', NULL, NULL, 7798, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:09:49', 'admin-1489799352-14897993896012187', 1, 0, '', NULL, NULL, NULL),
(24221, '2017-03-18 09:24:04', NULL, NULL, 7800, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1489833380', 'admin', '2017-03-18 09:24:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24222, '2017-03-19 17:59:34', NULL, NULL, 7878, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:59:34', 'admin-1489916754-14899175745668721', 1, 1, 'SR', NULL, NULL, NULL),
(24223, '2017-03-19 17:59:34', NULL, NULL, 7878, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:59:34', 'admin-1489916754-14899175745668721', 1, 1, 'SR', NULL, NULL, NULL),
(24224, '2017-03-19 18:10:21', NULL, NULL, 7879, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1489916754', 'admin', '2017-03-19 18:10:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24225, '2017-03-19 18:10:32', NULL, NULL, 7879, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 18:10:32', 'admin-1489916754-14899182319169117', 1, 0, '', NULL, NULL, NULL),
(24226, '2017-03-19 17:38:08', NULL, NULL, 7874, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:38:08', 'admin-1489910045-14899162880742250', 1, 1, 'SR', NULL, NULL, NULL),
(24227, '2017-03-19 17:39:23', NULL, NULL, 7876, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:39:23', 'admin-1489910045-14899163633614234', 1, 0, '', NULL, NULL, NULL),
(24228, '2017-03-19 17:39:23', NULL, NULL, 7876, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:39:23', 'admin-1489910045-14899163633614234', 1, 0, '', NULL, NULL, NULL),
(24229, '2017-03-19 17:46:00', NULL, NULL, 7877, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:46:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24230, '2017-03-19 17:46:37', NULL, NULL, 7877, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:46:37', 'admin-1489916754-1489916797088563', 1, 1, 'SR', NULL, NULL, NULL),
(24231, '2017-03-19 17:46:37', NULL, NULL, 7877, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:46:37', 'admin-1489916754-1489916797088563', 1, 1, 'SR', NULL, NULL, NULL),
(24232, '2017-03-19 17:46:46', NULL, NULL, 7877, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:46:46', 'admin-1489916754-14899168061356614', 1, 0, '', NULL, NULL, NULL),
(24233, '2017-03-19 17:53:53', NULL, NULL, 7875, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:53:53', 'admin-1489916754-14899172328854236', 1, 0, '', NULL, NULL, NULL),
(24234, '2017-03-19 17:58:55', NULL, NULL, 7878, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:58:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24235, '2017-03-19 17:59:34', NULL, NULL, 7878, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:59:34', 'admin-1489916754-14899175745668721', 1, 0, '', NULL, NULL, NULL),
(24236, '2017-03-19 17:59:34', NULL, NULL, 7878, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:59:34', 'admin-1489916754-14899175745668721', 1, 1, 'SR', NULL, NULL, NULL),
(24237, '2017-03-19 17:59:34', NULL, NULL, 7878, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:59:34', 'admin-1489916754-14899175745668721', 1, 1, 'SR', NULL, NULL, NULL),
(24238, '2017-03-19 13:26:03', NULL, NULL, 7867, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 13:26:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24239, '2017-03-19 13:26:14', NULL, NULL, 7867, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 13:26:14', 'admin-1489891524-14899011747281952', 1, 1, 'SR', NULL, NULL, NULL),
(24240, '2017-03-19 10:27:23', NULL, NULL, 7850, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:27:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24241, '2017-03-19 10:28:02', NULL, NULL, 7850, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:28:02', 'admin-1489885177-14898904823218089', 1, 0, '', NULL, NULL, NULL),
(24242, '2017-03-19 10:28:02', NULL, NULL, 7850, 0, 153, '87', 'Wake Me Up!', 'fried egg', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:28:02', 'admin-1489885177-14898904823218089', 1, 0, '', NULL, NULL, NULL),
(24243, '2017-03-19 10:28:02', NULL, NULL, 7850, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:28:02', 'admin-1489885177-14898904823218089', 1, 1, 'SR', NULL, NULL, NULL),
(24244, '2017-03-19 10:28:02', NULL, NULL, 7850, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:28:02', 'admin-1489885177-14898904823218089', 1, 1, 'SR', NULL, NULL, NULL),
(24245, '2017-03-19 10:30:52', NULL, NULL, 7851, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:30:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24246, '2017-03-19 10:31:02', NULL, NULL, 7851, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:31:02', 'admin-1489885177-14898906618961818', 1, 0, '', NULL, NULL, NULL),
(24247, '2017-03-19 10:31:02', NULL, NULL, 7851, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:31:02', 'admin-1489885177-14898906618961818', 1, 0, '', NULL, NULL, NULL),
(24248, '2017-03-19 10:31:02', NULL, NULL, 7851, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:31:02', 'admin-1489885177-14898906618961818', 1, 0, '', NULL, NULL, NULL),
(24249, '2017-03-19 10:31:07', NULL, NULL, 7851, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:31:07', 'admin-1489885177-14898906676728843', 1, 1, 'SR', NULL, NULL, NULL),
(24250, '2017-03-19 10:31:07', NULL, NULL, 7851, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:31:07', 'admin-1489885177-14898906676728843', 1, 1, 'SR', NULL, NULL, NULL),
(24251, '2017-03-19 10:31:07', NULL, NULL, 7851, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:31:07', 'admin-1489885177-14898906676728843', 1, 1, 'SR', NULL, NULL, NULL),
(24252, '2017-03-19 10:32:28', NULL, NULL, 7852, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:32:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24253, '2017-03-19 10:32:41', NULL, NULL, 7852, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:32:41', 'admin-1489885177-14898907609822542', 1, 0, '', NULL, NULL, NULL),
(24254, '2017-03-19 10:32:41', NULL, NULL, 7852, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:32:41', 'admin-1489885177-14898907609822542', 1, 0, '', NULL, NULL, NULL),
(24255, '2017-03-19 18:10:32', NULL, NULL, 7879, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 18:10:32', 'admin-1489916754-14899182319169117', 1, 0, '', NULL, NULL, NULL),
(24256, '2017-03-19 18:23:39', NULL, NULL, 7880, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1489916754', 'admin', '2017-03-19 18:23:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24257, '2017-03-19 18:23:57', NULL, NULL, 7880, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 18:23:57', 'admin-1489916754-1489919037180166', 1, 0, '', NULL, NULL, NULL),
(24258, '2017-03-19 18:23:57', NULL, NULL, 7880, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 18:23:57', 'admin-1489916754-1489919037180166', 1, 1, 'SR', NULL, NULL, NULL),
(24259, '2017-03-19 16:12:28', NULL, NULL, 7873, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 16:12:28', 'admin-1489910045-14899111482341130', 1, 1, 'SR', NULL, NULL, NULL),
(24260, '2017-03-19 16:12:28', NULL, NULL, 7873, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 16:12:28', 'admin-1489910045-14899111482341130', 1, 1, 'SR', NULL, NULL, NULL),
(24261, '2017-03-19 16:12:28', NULL, NULL, 7873, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 16:12:28', 'admin-1489910045-14899111482341130', 1, 0, '', NULL, NULL, NULL),
(24262, '2017-03-19 16:12:28', NULL, NULL, 7873, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 16:12:28', 'admin-1489910045-14899111482341130', 1, 0, '', NULL, NULL, NULL),
(24263, '2017-03-19 16:12:28', NULL, NULL, 7873, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 16:12:28', 'admin-1489910045-14899111482341130', 1, 0, '', NULL, NULL, NULL),
(24264, '2017-03-19 16:12:28', NULL, NULL, 7873, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 16:12:28', 'admin-1489910045-14899111482341130', 1, 0, '', NULL, NULL, NULL),
(24265, '2017-03-19 16:13:01', NULL, NULL, 7873, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 16:13:01', 'admin-1489910045-14899111809673326', 1, 1, 'SR', NULL, NULL, NULL),
(24266, '2017-03-19 16:13:01', NULL, NULL, 7873, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 16:13:01', 'admin-1489910045-14899111809673326', 1, 0, '', NULL, NULL, NULL),
(24267, '2017-03-19 16:13:43', NULL, NULL, 7873, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 16:13:43', 'admin-1489910045-14899112232835052', 1, 0, '', NULL, NULL, NULL),
(24268, '2017-03-19 12:19:41', NULL, NULL, 7856, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 12:19:41', 'admin-1489891524-1489897181733149', 1, 0, '', NULL, NULL, NULL),
(24269, '2017-03-19 12:25:52', NULL, NULL, 7863, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1489916754', 'admin', '2017-03-19 12:25:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24270, '2017-03-19 12:26:09', NULL, NULL, 7863, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 12:26:09', 'admin-1489891524-14898975689457081', 1, 1, 'SR', NULL, NULL, NULL),
(24271, '2017-03-19 12:26:09', NULL, NULL, 7863, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 12:26:09', 'admin-1489891524-14898975689457081', 1, 0, '', NULL, NULL, NULL),
(24272, '2017-03-19 12:26:09', NULL, NULL, 7863, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 12:26:09', 'admin-1489891524-14898975689457081', 1, 0, '', NULL, NULL, NULL),
(24273, '2017-03-19 12:26:14', NULL, NULL, 7863, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 12:26:14', 'admin-1489891524-14898975742143425', 1, 1, 'SR', NULL, NULL, NULL),
(24274, '2017-03-19 10:42:21', NULL, NULL, 7854, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:42:21', 'admin-1489885177-14898913410187966', 1, 1, 'SR', NULL, NULL, NULL),
(24275, '2017-03-19 10:45:29', NULL, NULL, 7855, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:45:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24276, '2017-03-19 10:45:44', NULL, NULL, 7855, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:45:44', 'admin-1489891524-14898915446743319', 1, 0, '', NULL, NULL, NULL),
(24277, '2017-03-19 10:45:44', NULL, NULL, 7855, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:45:44', 'admin-1489891524-14898915446743319', 1, 0, '', NULL, NULL, NULL),
(24278, '2017-03-19 10:45:44', NULL, NULL, 7855, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:45:44', 'admin-1489891524-14898915446743319', 1, 1, 'SR', NULL, NULL, NULL),
(24279, '2017-03-19 10:45:44', NULL, NULL, 7855, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:45:44', 'admin-1489891524-14898915446743319', 1, 1, 'SR', NULL, NULL, NULL),
(24280, '2017-03-19 11:21:01', NULL, NULL, 7856, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1489916754', 'admin', '2017-03-19 11:21:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24281, '2017-03-19 11:21:12', NULL, NULL, 7856, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 11:21:12', 'admin-1489891524-14898936722336537', 1, 0, '', NULL, NULL, NULL),
(24282, '2017-03-19 11:21:12', NULL, NULL, 7856, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 11:21:12', 'admin-1489891524-14898936722336537', 1, 0, '', NULL, NULL, NULL),
(24283, '2017-03-19 11:21:24', NULL, NULL, 7856, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 11:21:24', 'admin-1489891524-14898936841109293', 1, 0, '', NULL, NULL, NULL),
(24284, '2017-03-19 11:21:24', NULL, NULL, 7856, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 11:21:24', 'admin-1489891524-14898936841109293', 1, 1, 'SR', NULL, NULL, NULL),
(24285, '2017-03-19 11:26:11', NULL, NULL, 7857, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1489916754', 'admin', '2017-03-19 11:26:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24286, '2017-03-19 11:26:17', NULL, NULL, 7857, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 11:26:17', 'admin-1489891524-14898939772893351', 1, 0, '', NULL, NULL, NULL),
(24287, '2017-03-19 11:26:17', NULL, NULL, 7857, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 11:26:17', 'admin-1489891524-14898939772893351', 1, 1, 'SR', NULL, NULL, NULL),
(24288, '2017-03-19 11:30:00', NULL, NULL, 7851, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 11:30:00', 'admin-1489891524-14898942005402416', 1, 0, '', NULL, NULL, NULL),
(24289, '2017-03-19 12:11:04', NULL, NULL, 7861, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 12:11:04', 'admin-1489891524-1489896664017123', 1, 1, 'SR', NULL, NULL, NULL),
(24290, '2017-03-19 12:16:29', NULL, NULL, 7862, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1489916754', 'admin', '2017-03-19 12:16:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24291, '2017-03-19 12:16:38', NULL, NULL, 7862, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 12:16:38', 'admin-1489891524-14898969983879885', 1, 1, 'SR', NULL, NULL, NULL),
(24292, '2017-03-19 13:21:31', NULL, NULL, 7865, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 13:21:31', 'admin-1489891524-14899008910171568', 1, 0, '', NULL, NULL, NULL),
(24293, '2017-03-19 13:25:44', NULL, NULL, 7866, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1489916754', 'admin', '2017-03-19 13:25:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24294, '2017-03-19 13:25:51', NULL, NULL, 7866, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 13:25:51', 'admin-1489891524-14899011515356855', 1, 1, 'SR', NULL, NULL, NULL),
(24295, '2017-03-19 13:25:51', NULL, NULL, 7866, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 13:25:51', 'admin-1489891524-14899011515356855', 1, 0, '', NULL, NULL, NULL),
(24296, '2017-03-19 17:38:01', NULL, NULL, 7874, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:38:01', 'admin-1489910045-14899162814315234', 1, 0, '', NULL, NULL, NULL),
(24297, '2017-03-19 17:22:23', NULL, NULL, 7875, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.20, 0.0000, 0.0000, 9.20, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:22:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24298, '2017-03-19 17:22:59', NULL, NULL, 7875, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:22:59', 'admin-1489910045-14899153793144815', 1, 0, '', NULL, NULL, NULL),
(24299, '2017-03-19 17:22:59', NULL, NULL, 7875, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:22:59', 'admin-1489910045-14899153793144815', 1, 0, '', NULL, NULL, NULL),
(24300, '2017-03-19 17:22:59', NULL, NULL, 7875, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:22:59', 'admin-1489910045-14899153793144815', 1, 0, '', NULL, NULL, NULL),
(24301, '2017-03-19 17:22:59', NULL, NULL, 7875, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:22:59', 'admin-1489910045-14899153793144815', 1, 0, '', NULL, NULL, NULL),
(24302, '2017-03-19 17:22:59', NULL, NULL, 7875, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:22:59', 'admin-1489910045-14899153793144815', 1, 1, 'SR', NULL, NULL, NULL),
(24303, '2017-03-19 17:23:21', NULL, NULL, 7876, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:23:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24304, '2017-03-19 17:23:29', NULL, NULL, 7876, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:23:29', 'admin-1489910045-14899154096532286', 1, 0, '', NULL, NULL, NULL),
(24305, '2017-03-19 17:30:04', NULL, NULL, 7876, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:30:04', 'admin-1489910045-1489915804734979', 1, 1, 'SR', NULL, NULL, NULL),
(24306, '2017-03-19 17:30:04', NULL, NULL, 7876, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:30:04', 'admin-1489910045-1489915804734979', 1, 1, 'SR', NULL, NULL, NULL),
(24307, '2017-03-19 17:33:10', NULL, NULL, 7876, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:33:10', 'admin-1489910045-14899159903101775', 1, 0, '', NULL, NULL, NULL),
(24308, '2017-03-19 17:38:01', NULL, NULL, 7874, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:38:01', 'admin-1489910045-14899162814315234', 1, 1, 'SR', NULL, NULL, NULL),
(24309, '2017-03-19 17:38:01', NULL, NULL, 7874, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:38:01', 'admin-1489910045-14899162814315234', 1, 0, '', NULL, NULL, NULL),
(24310, '2017-03-19 18:26:41', NULL, NULL, 7880, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 18:26:41', 'admin-1489916754-14899192017092785', 1, 1, 'SR', NULL, NULL, NULL),
(24311, '2017-03-19 15:53:34', NULL, NULL, 7872, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1489916754', 'admin', '2017-03-19 15:53:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24312, '2017-03-19 15:53:51', NULL, NULL, 7872, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 15:53:51', 'admin-1489891524-1489910031190142', 1, 1, 'SR', NULL, NULL, NULL),
(24313, '2017-03-19 17:06:39', NULL, NULL, 7874, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:06:39', 'admin-1489910045-14899143995792038', 1, 1, 'SR', NULL, NULL, NULL),
(24314, '2017-03-19 17:06:39', NULL, NULL, 7874, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:06:39', 'admin-1489910045-14899143995792038', 1, 1, 'SR', NULL, NULL, NULL),
(24315, '2017-03-19 17:06:39', NULL, NULL, 7874, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:06:39', 'admin-1489910045-14899143995792038', 1, 1, 'SR', NULL, NULL, NULL),
(24316, '2017-03-19 15:42:36', NULL, NULL, 7870, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1489916754', 'admin', '2017-03-19 15:42:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24317, '2017-03-19 13:37:34', NULL, NULL, 7865, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 13:37:34', 'admin-1489891524-14899018543365628', 1, 1, 'SR', NULL, NULL, NULL),
(24318, '2017-03-19 13:49:44', NULL, NULL, 7864, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 13:49:44', 'admin-1489891524-14899025843191564', 1, 1, 'SR', NULL, NULL, NULL),
(24319, '2017-03-19 14:11:53', NULL, NULL, 7860, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 14:11:53', 'admin-1489891524-14899039129074413', 1, 1, 'SR', NULL, NULL, NULL),
(24320, '2017-03-19 14:50:27', NULL, NULL, 7869, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1489916754', 'admin', '2017-03-19 14:50:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24321, '2017-03-19 14:11:53', NULL, NULL, 7860, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 14:11:53', 'admin-1489891524-14899039129074413', 1, 0, '', NULL, NULL, NULL),
(24322, '2017-03-19 17:05:55', NULL, NULL, 7874, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 17:05:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24323, '2017-03-19 15:56:34', NULL, NULL, 7872, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 15:56:34', 'admin-1489910045-14899101939856080', 1, 1, 'SR', NULL, NULL, NULL),
(24324, '2017-03-19 16:12:28', NULL, NULL, 7873, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 16:12:28', 'admin-1489910045-14899111482341130', 1, 1, 'SR', NULL, NULL, NULL),
(24325, '2017-03-19 14:45:21', NULL, NULL, 7868, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 14:45:21', 'admin-1489891524-14899059211855286', 1, 0, '', 1, NULL, NULL),
(24326, '2017-03-19 14:45:21', NULL, NULL, 7868, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 14:45:21', 'admin-1489891524-14899059211855286', 1, 0, '', 1, NULL, NULL),
(24327, '2017-03-19 15:54:28', NULL, NULL, 7872, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 15:54:28', 'admin-1489910045-14899100678868673', 1, 1, 'SR', NULL, NULL, NULL),
(24328, '2017-03-19 16:11:37', NULL, NULL, 7873, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.90, 0.0000, 0.0000, 12.90, 1, '27', 1, '1489916754', 'admin', '2017-03-19 16:11:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24329, '2017-03-19 15:54:28', NULL, NULL, 7872, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 15:54:28', 'admin-1489910045-14899100678868673', 1, 1, 'SR', NULL, NULL, NULL),
(24330, '2017-03-19 16:12:28', NULL, NULL, 7873, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 16:12:28', 'admin-1489910045-14899111482341130', 1, 0, '', NULL, NULL, NULL),
(24331, '2017-03-19 15:50:06', NULL, NULL, 7871, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 15:50:06', 'admin-1489891524-14899098063787067', 1, 1, 'SR', NULL, NULL, NULL),
(24332, '2017-03-19 15:49:30', NULL, NULL, 7871, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1489916754', 'admin', '2017-03-19 15:49:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24333, '2017-03-19 15:50:06', NULL, NULL, 7871, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 15:50:06', 'admin-1489891524-14899098063787067', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(24334, '2017-03-19 15:42:52', NULL, NULL, 7870, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 15:42:52', 'admin-1489891524-14899093726481455', 1, 1, 'SR', NULL, NULL, NULL),
(24335, '2017-03-19 15:42:46', NULL, NULL, 7870, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 15:42:46', 'admin-1489891524-1489909365951831', 1, 1, 'SR', NULL, NULL, NULL),
(24336, '2017-03-19 15:42:46', NULL, NULL, 7870, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 15:42:46', 'admin-1489891524-1489909365951831', 1, 1, 'SR', NULL, NULL, NULL),
(24337, '2017-03-19 15:42:46', NULL, NULL, 7870, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 15:42:46', 'admin-1489891524-1489909365951831', 1, 0, '', NULL, NULL, NULL),
(24338, '2017-03-19 14:45:21', NULL, NULL, 7868, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 14:45:21', 'admin-1489891524-14899059211855286', 1, 0, '', 1, NULL, NULL),
(24339, '2017-03-19 14:45:21', NULL, NULL, 7868, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 14:45:21', 'admin-1489891524-14899059211855286', 1, 0, '', 1, NULL, NULL),
(24340, '2017-03-19 10:36:59', NULL, NULL, 7853, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:36:59', 'admin-1489885177-14898910191385927', 1, 1, 'SR', NULL, NULL, NULL),
(24341, '2017-03-19 12:11:04', NULL, NULL, 7861, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 12:11:04', 'admin-1489891524-1489896664017123', 1, 1, 'SR', NULL, NULL, NULL),
(24342, '2017-03-19 13:26:14', NULL, NULL, 7867, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 13:26:14', 'admin-1489891524-14899011747281952', 1, 1, 'SR', NULL, NULL, NULL),
(24343, '2017-03-19 00:00:00', NULL, NULL, 7869, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 14:11:53', 'admin-1489891524-14899039129074413', 1, 1, 'SR', NULL, NULL, NULL),
(24344, '2017-03-19 13:26:14', NULL, NULL, 7867, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 13:26:14', 'admin-1489891524-14899011747281952', 1, 0, '', NULL, NULL, NULL),
(24345, '2017-03-19 13:01:43', NULL, NULL, 7864, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1489916754', 'admin', '2017-03-19 13:01:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24346, '2017-03-19 13:08:45', NULL, NULL, 7864, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 13:08:45', 'admin-1489891524-14899001256359550', 1, 1, 'SR', NULL, NULL, NULL),
(24347, '2017-03-19 13:26:14', NULL, NULL, 7867, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 13:26:14', 'admin-1489891524-14899011747281952', 1, 1, 'SR', NULL, NULL, NULL),
(24348, '2017-03-19 13:26:14', NULL, NULL, 7867, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 13:26:14', 'admin-1489891524-14899011747281952', 1, 1, 'SR', NULL, NULL, NULL),
(24349, '2017-03-19 13:26:14', NULL, NULL, 7867, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 13:26:14', 'admin-1489891524-14899011747281952', 1, 0, '', NULL, NULL, NULL),
(24350, '2017-03-19 10:13:36', NULL, NULL, 7849, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:13:36', 'admin-1489885177-14898896160028958', 1, 0, '', 1, NULL, NULL),
(24351, '2017-03-19 10:32:55', NULL, NULL, 7852, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:32:55', 'admin-1489885177-14898907753991464', 1, 1, 'SR', NULL, NULL, NULL),
(24352, '2017-03-19 10:32:55', NULL, NULL, 7852, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:32:55', 'admin-1489885177-14898907753991464', 1, 1, 'SR', NULL, NULL, NULL),
(24353, '2017-03-19 10:36:04', NULL, NULL, 7853, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:36:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24354, '2017-03-19 10:36:16', NULL, NULL, 7853, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:36:16', 'admin-1489885177-14898909766238937', 1, 0, '', NULL, NULL, NULL),
(24355, '2017-03-19 10:36:16', NULL, NULL, 7853, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:36:16', 'admin-1489885177-14898909766238937', 1, 0, '', NULL, NULL, NULL),
(24356, '2017-03-19 10:36:59', NULL, NULL, 7853, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:36:59', 'admin-1489885177-14898910191385927', 1, 1, 'SR', NULL, NULL, NULL),
(24357, '2017-03-19 10:36:59', NULL, NULL, 7853, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:36:59', 'admin-1489885177-14898910191385927', 1, 1, 'SR', NULL, NULL, NULL),
(24358, '2017-03-19 13:20:03', NULL, NULL, 7865, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1489916754', 'admin', '2017-03-19 13:20:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24359, '2017-03-19 13:21:31', NULL, NULL, 7865, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 13:21:31', 'admin-1489891524-14899008910171568', 1, 0, '', NULL, NULL, NULL),
(24360, '2017-03-19 13:25:04', NULL, NULL, 7864, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 13:25:04', 'admin-1489891524-14899011046597877', 1, 1, 'SR', NULL, NULL, NULL),
(24361, '2017-03-19 13:08:45', NULL, NULL, 7864, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 13:08:45', 'admin-1489891524-14899001256359550', 1, 0, '', NULL, NULL, NULL),
(24362, '2017-03-19 10:42:21', NULL, NULL, 7854, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:42:21', 'admin-1489885177-14898913410187966', 1, 0, '', NULL, NULL, NULL),
(24363, '2017-03-19 11:48:24', NULL, NULL, 7858, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1489916754', 'admin', '2017-03-19 11:48:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24364, '2017-03-19 11:48:31', NULL, NULL, 7858, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 11:48:31', 'admin-1489891524-14898953108405349', 1, 1, 'SR', NULL, NULL, NULL),
(24365, '2017-03-19 11:48:31', NULL, NULL, 7858, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 11:48:31', 'admin-1489891524-14898953108405349', 1, 1, 'SR', NULL, NULL, NULL),
(24366, '2017-03-19 11:48:46', NULL, NULL, 7858, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 11:48:46', 'admin-1489891524-14898953262736675', 1, 0, '', NULL, NULL, NULL),
(24367, '2017-03-19 11:48:46', NULL, NULL, 7858, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 11:48:46', 'admin-1489891524-14898953262736675', 1, 0, '', NULL, NULL, NULL),
(24368, '2017-03-19 11:52:25', NULL, NULL, 7859, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1489916754', 'admin', '2017-03-19 11:52:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24369, '2017-03-19 11:52:28', NULL, NULL, 7859, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 11:52:28', 'admin-1489891524-1489895548097718', 1, 1, 'SR', NULL, NULL, NULL),
(24370, '2017-03-19 12:00:44', NULL, NULL, 7860, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1489916754', 'admin', '2017-03-19 12:00:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24371, '2017-03-19 12:00:56', NULL, NULL, 7860, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 12:00:56', 'admin-1489891524-14898960563326369', 1, 1, 'SR', NULL, NULL, NULL),
(24372, '2017-03-19 12:10:42', NULL, NULL, 7861, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 12:10:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24373, '2017-03-19 12:10:59', NULL, NULL, 7861, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 12:10:59', 'admin-1489891524-14898966591985159', 1, 0, '', NULL, NULL, NULL),
(24374, '2017-03-19 12:10:59', NULL, NULL, 7861, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 12:10:59', 'admin-1489891524-14898966591985159', 1, 0, '', NULL, NULL, NULL),
(24375, '2017-03-19 09:12:19', NULL, NULL, 7844, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:12:19', 'admin-1489885177-1489885939609351', 1, 1, 'SR', NULL, NULL, NULL),
(24376, '2017-03-19 09:19:38', NULL, NULL, 7845, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:19:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24377, '2017-03-19 09:19:45', NULL, NULL, 7845, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:19:45', 'admin-1489885177-14898863850288521', 1, 0, '', NULL, NULL, NULL),
(24378, '2017-03-19 09:20:20', NULL, NULL, 7845, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:20:20', 'admin-1489885177-14898864199067649', 1, 1, 'SR', NULL, NULL, NULL),
(24379, '2017-03-19 09:58:00', NULL, NULL, 7848, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:58:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24380, '2017-03-19 09:58:19', NULL, NULL, 7848, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:58:19', 'admin-1489885177-14898886997054194', 1, 1, 'SR', NULL, NULL, NULL),
(24381, '2017-03-19 09:58:19', NULL, NULL, 7848, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:58:19', 'admin-1489885177-14898886997054194', 1, 1, 'SR', NULL, NULL, NULL),
(24382, '2017-03-19 09:58:19', NULL, NULL, 7848, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:58:19', 'admin-1489885177-14898886997054194', 1, 0, '', NULL, NULL, NULL),
(24383, '2017-03-19 09:58:19', NULL, NULL, 7848, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:58:19', 'admin-1489885177-14898886997054194', 1, 0, '', NULL, NULL, NULL),
(24384, '2017-03-19 09:58:19', NULL, NULL, 7848, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:58:19', 'admin-1489885177-14898886997054194', 1, 0, '', NULL, NULL, NULL),
(24385, '2017-03-19 10:11:45', NULL, NULL, 7848, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:11:45', 'admin-1489885177-14898895052642236', 1, 0, '', NULL, NULL, NULL),
(24386, '2017-03-19 10:13:09', NULL, NULL, 7849, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:13:09', 'admin-1489885177-14898895890416366', 1, 1, 'SR', 1, NULL, NULL),
(24387, '2017-03-19 10:42:21', NULL, NULL, 7854, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:42:21', 'admin-1489885177-14898913410187966', 1, 0, '', NULL, NULL, NULL),
(24388, '2017-03-19 10:42:06', NULL, NULL, 7854, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:42:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24389, '2017-03-19 10:42:21', NULL, NULL, 7854, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 10:42:21', 'admin-1489885177-14898913410187966', 1, 0, '', NULL, NULL, NULL),
(24390, '2017-03-19 09:46:51', NULL, NULL, 7847, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:46:51', 'admin-1489885177-1489888011486845', 1, 0, '', NULL, NULL, NULL),
(24391, '2017-03-19 09:46:51', NULL, NULL, 7847, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:46:51', 'admin-1489885177-1489888011486845', 1, 0, '', NULL, NULL, NULL),
(24392, '2017-03-19 09:48:13', NULL, NULL, 7847, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:48:13', 'admin-1489885177-14898880937857739', 1, 1, 'SR', NULL, NULL, NULL),
(24393, '2017-03-19 09:48:13', NULL, NULL, 7847, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:48:13', 'admin-1489885177-14898880937857739', 1, 1, 'SR', NULL, NULL, NULL),
(24394, '2017-03-19 09:48:13', NULL, NULL, 7847, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:48:13', 'admin-1489885177-14898880937857739', 1, 0, '', NULL, NULL, NULL),
(24395, '2017-03-19 09:20:20', NULL, NULL, 7845, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:20:20', 'admin-1489885177-14898864199067649', 1, 1, 'SR', NULL, NULL, NULL),
(24396, '2017-03-19 09:46:51', NULL, NULL, 7847, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:46:51', 'admin-1489885177-1489888011486845', 1, 0, '', NULL, NULL, NULL),
(24397, '2017-03-19 09:46:37', NULL, NULL, 7847, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:46:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24398, '2017-03-19 09:21:48', NULL, NULL, 7846, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:21:48', 'admin-1489885177-14898865080528375', 1, 1, 'SR', NULL, NULL, NULL),
(24399, '2017-03-19 09:21:48', NULL, NULL, 7846, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:21:48', 'admin-1489885177-14898865080528375', 1, 1, 'SR', NULL, NULL, NULL),
(24400, '2017-03-19 09:21:34', NULL, NULL, 7846, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:21:34', 'admin-1489885177-1489886493949437', 1, 0, '', NULL, NULL, NULL),
(24401, '2017-03-19 09:21:34', NULL, NULL, 7846, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:21:34', 'admin-1489885177-1489886493949437', 1, 0, '', NULL, NULL, NULL),
(24402, '2017-03-19 09:21:20', NULL, NULL, 7846, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:21:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24403, '2017-03-19 09:20:20', NULL, NULL, 7845, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:20:20', 'admin-1489885177-14898864199067649', 1, 1, 'SR', NULL, NULL, NULL),
(24404, '2017-03-19 09:20:20', NULL, NULL, 7845, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:20:20', 'admin-1489885177-14898864199067649', 1, 1, 'SR', NULL, NULL, NULL),
(24405, '2017-03-19 09:20:20', NULL, NULL, 7845, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:20:20', 'admin-1489885177-14898864199067649', 1, 1, 'SR', NULL, NULL, NULL),
(24406, '2017-03-19 09:10:16', NULL, NULL, 7844, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1489916754', 'admin', '2017-03-19 09:10:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24407, '2017-03-20 20:45:17', NULL, NULL, 7907, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 20:45:17', 'admin-1490013893-14900139177264231', 1, 1, 'SR', NULL, NULL, NULL),
(24408, '2017-03-20 10:51:59', NULL, NULL, 7887, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1490013893', 'admin', '2017-03-20 10:51:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24409, '2017-03-20 09:31:00', NULL, NULL, 7881, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 09:31:00', 'admin-1489970962-14899734599871033', 1, 1, 'SR', NULL, NULL, NULL),
(24410, '2017-03-20 09:31:00', NULL, NULL, 7881, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 09:31:00', 'admin-1489970962-14899734599871033', 1, 1, 'SR', NULL, NULL, NULL),
(24411, '2017-03-20 09:32:53', NULL, NULL, 7882, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1490013893', 'admin', '2017-03-20 09:32:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24412, '2017-03-20 09:33:01', NULL, NULL, 7882, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 09:33:01', 'admin-1489970962-14899735815574098', 1, 0, '', NULL, NULL, NULL),
(24413, '2017-03-20 09:33:01', NULL, NULL, 7882, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 09:33:01', 'admin-1489970962-14899735815574098', 1, 0, '', NULL, NULL, NULL),
(24414, '2017-03-20 09:33:01', NULL, NULL, 7882, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 09:33:01', 'admin-1489970962-14899735815574098', 1, 0, '', NULL, NULL, NULL),
(24415, '2017-03-20 09:43:36', NULL, NULL, 7883, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1490013893', 'admin', '2017-03-20 09:43:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24416, '2017-03-20 09:44:07', NULL, NULL, 7883, 0, 156, '90', 'House Cheddar Omelet', 'no bread add bacon', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 09:44:07', 'admin-1489970962-14899742475967981', 1, 0, '', NULL, NULL, NULL),
(24417, '2017-03-20 09:44:07', NULL, NULL, 7883, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 09:44:07', 'admin-1489970962-14899742475967981', 1, 0, '', NULL, NULL, NULL),
(24418, '2017-03-20 09:44:07', NULL, NULL, 7883, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 09:44:07', 'admin-1489970962-14899742475967981', 1, 0, '', NULL, NULL, NULL),
(24419, '2017-03-20 09:44:07', NULL, NULL, 7883, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 09:44:07', 'admin-1489970962-14899742475967981', 1, 1, 'SR', NULL, NULL, NULL),
(24420, '2017-03-20 10:27:30', NULL, NULL, 7884, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 10:27:30', 'admin-1489970962-14899768507927494', 1, 1, 'SR', 1, NULL, NULL),
(24421, '2017-03-20 10:28:09', NULL, NULL, 7885, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 10:28:09', 'admin-1489970962-1489976889508447', 1, 1, 'SR', 1, NULL, NULL),
(24422, '2017-03-20 10:40:17', NULL, NULL, 7886, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1490013893', 'admin', '2017-03-20 10:40:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24423, '2017-03-20 10:40:27', NULL, NULL, 7886, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 10:40:27', 'admin-1489970962-14899776273798435', 1, 0, '', NULL, NULL, NULL),
(24424, '2017-03-20 21:25:48', NULL, NULL, 7911, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1490013893', 'admin', '2017-03-20 21:25:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24425, '2017-03-20 21:25:54', NULL, NULL, 7911, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 21:25:54', 'admin-1490013893-14900163546248311', 1, 1, 'SR', NULL, NULL, NULL),
(24426, '2017-03-20 21:25:54', NULL, NULL, 7911, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 21:25:54', 'admin-1490013893-14900163546248311', 1, 1, 'SR', NULL, NULL, NULL),
(24427, '2017-03-20 21:42:54', NULL, NULL, 7912, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1490013893', 'admin', '2017-03-20 21:42:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24428, '2017-03-20 21:43:03', NULL, NULL, 7912, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 21:43:03', 'admin-1490013893-1490017383079732', 1, 1, 'SR', NULL, NULL, NULL),
(24429, '2017-03-20 19:47:18', NULL, NULL, 7903, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 19:47:18', 'admin-1489970962-14900104387111282', 1, 1, 'SR', NULL, NULL, NULL),
(24430, '2017-03-20 16:59:10', NULL, NULL, 7901, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:59:10', 'admin-1489970962-14900003507093329', 1, 0, '', NULL, NULL, NULL),
(24431, '2017-03-20 16:21:14', NULL, NULL, 7897, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:21:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24432, '2017-03-20 16:21:32', NULL, NULL, 7897, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:21:32', 'admin-1489970962-14899980918297368', 1, 1, 'SR', NULL, NULL, NULL),
(24433, '2017-03-20 16:21:32', NULL, NULL, 7897, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:21:32', 'admin-1489970962-14899980918297368', 1, 1, 'SR', NULL, NULL, NULL),
(24434, '2017-03-20 16:21:32', NULL, NULL, 7897, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:21:32', 'admin-1489970962-14899980918297368', 1, 0, '', NULL, NULL, NULL),
(24435, '2017-03-20 16:21:40', NULL, NULL, 7898, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:21:40', 'admin-1489970962-14899980998203769', 1, 0, '', 1, NULL, NULL),
(24436, '2017-03-20 16:58:35', NULL, NULL, 7901, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.10, 0.0000, 0.0000, 10.10, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:58:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24437, '2017-03-20 16:59:10', NULL, NULL, 7901, 0, 244, '178', 'Macadamia Scones', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:59:10', 'admin-1489970962-14900003507093329', 1, 0, '', NULL, NULL, NULL),
(24438, '2017-03-20 16:59:10', NULL, NULL, 7901, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:59:10', 'admin-1489970962-14900003507093329', 1, 0, '', NULL, NULL, NULL),
(24439, '2017-03-20 16:59:10', NULL, NULL, 7901, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:59:10', 'admin-1489970962-14900003507093329', 1, 0, '', NULL, NULL, NULL),
(24440, '2017-03-20 16:59:10', NULL, NULL, 7901, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:59:10', 'admin-1489970962-14900003507093329', 1, 1, 'SR', NULL, NULL, NULL),
(24441, '2017-03-20 16:59:10', NULL, NULL, 7901, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:59:10', 'admin-1489970962-14900003507093329', 1, 1, 'SR', NULL, NULL, NULL),
(24442, '2017-03-20 20:45:00', NULL, NULL, 7907, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1490013893', 'admin', '2017-03-20 20:45:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24443, '2017-03-20 20:59:09', NULL, NULL, 7909, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1490013893', 'admin', '2017-03-20 20:59:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24444, '2017-03-20 20:10:11', NULL, NULL, 7905, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 20:10:11', 'admin-1489970962-14900118113432168', 1, 0, '', 1, NULL, NULL),
(24445, '2017-03-20 20:43:26', NULL, NULL, 7903, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 20:43:26', 'admin-1489970962-14900138060981786', 1, 0, '', NULL, NULL, NULL),
(24446, '2017-03-20 16:41:37', NULL, NULL, 7900, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:41:37', 'admin-1489970962-14899992969171582', 1, 0, '', NULL, NULL, NULL),
(24447, '2017-03-20 00:00:00', NULL, NULL, 7908, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 19:47:19', 'admin-1489970962-14900104387111282', 1, 0, '', NULL, NULL, NULL),
(24448, '2017-03-20 19:47:18', NULL, NULL, 7903, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 19:47:18', 'admin-1489970962-14900104387111282', 1, 1, 'SR', NULL, NULL, NULL),
(24449, '2017-03-20 16:59:10', NULL, NULL, 7901, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:59:10', 'admin-1489970962-14900003507093329', 1, 1, 'SR', NULL, NULL, NULL),
(24450, '2017-03-20 17:39:19', NULL, NULL, 7901, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 17:39:19', 'admin-1489970962-14900027594917918', 1, 1, 'SR', NULL, NULL, NULL),
(24451, '2017-03-20 19:09:49', NULL, NULL, 7902, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1490013893', 'admin', '2017-03-20 19:09:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24452, '2017-03-20 20:59:21', NULL, NULL, 7909, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 20:59:21', 'admin-1490013893-14900147617733367', 1, 0, '', NULL, NULL, NULL),
(24453, '2017-03-20 20:59:21', NULL, NULL, 7909, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 20:59:21', 'admin-1490013893-14900147617733367', 1, 1, 'SR', NULL, NULL, NULL),
(24454, '2017-03-20 21:14:44', NULL, NULL, 7910, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1490013893', 'admin', '2017-03-20 21:14:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24455, '2017-03-20 20:45:17', NULL, NULL, 7907, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 20:45:17', 'admin-1490013893-14900139177264231', 1, 1, 'SR', NULL, NULL, NULL),
(24456, '2017-03-20 20:51:08', NULL, NULL, 7908, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1490013893', 'admin', '2017-03-20 20:51:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24457, '2017-03-20 19:47:19', NULL, NULL, 7903, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 19:47:19', 'admin-1489970962-14900104387111282', 1, 0, '', NULL, NULL, NULL),
(24458, '2017-03-20 19:47:19', NULL, NULL, 7903, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 19:47:19', 'admin-1489970962-14900104387111282', 1, 0, '', NULL, NULL, NULL),
(24459, '2017-03-20 19:47:19', NULL, NULL, 7903, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 19:47:19', 'admin-1489970962-14900104387111282', 1, 0, '', NULL, NULL, NULL),
(24460, '2017-03-20 16:21:02', NULL, NULL, 7896, 0, 244, '178', 'Macadamia Scones', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:21:02', 'admin-1489970962-14899980621858217', 1, 0, '', NULL, NULL, NULL),
(24461, '2017-03-20 21:14:49', NULL, NULL, 7910, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 21:14:49', 'admin-1490013893-14900156895335289', 1, 1, 'SR', NULL, NULL, NULL),
(24462, '2017-03-20 20:45:23', NULL, NULL, 7907, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 20:45:23', 'admin-1490013893-1490013923411552', 1, 1, 'SR', NULL, NULL, NULL),
(24463, '2017-03-20 20:45:17', NULL, NULL, 7907, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 20:45:17', 'admin-1490013893-14900139177264231', 1, 0, '', NULL, NULL, NULL),
(24464, '2017-03-20 20:08:57', NULL, NULL, 7903, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 20:08:57', 'admin-1489970962-14900117376064595', 1, 1, 'SR', NULL, NULL, NULL),
(24465, '2017-03-20 19:50:53', NULL, NULL, 7904, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 19:50:53', 'admin-1489970962-1490010653382458', 1, 1, 'SR', 1, NULL, '10.0'),
(24466, '2017-03-20 20:08:57', NULL, NULL, 7903, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 20:08:57', 'admin-1489970962-14900117376064595', 1, 0, '', NULL, NULL, NULL),
(24467, '2017-03-20 20:15:59', NULL, NULL, 7903, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 20:15:59', 'admin-1489970962-14900121597426582', 1, 0, '', NULL, NULL, NULL),
(24468, '2017-03-20 20:08:17', NULL, NULL, 7903, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 20:08:17', 'admin-1489970962-14900116969821188', 1, 1, 'SR', NULL, NULL, NULL),
(24469, '2017-03-20 19:50:53', NULL, NULL, 7904, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 19:50:53', 'admin-1489970962-1490010653382458', 1, 1, 'SR', 1, NULL, '10.0'),
(24470, '2017-03-20 19:47:19', NULL, NULL, 7903, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 19:47:19', 'admin-1489970962-14900104387111282', 1, 1, 'SR', NULL, NULL, NULL),
(24471, '2017-03-20 00:00:00', NULL, NULL, 7908, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 20:51:02', 'admin-1490013893-14900142620748247', 1, 1, 'SR', NULL, NULL, NULL),
(24472, '2017-03-20 19:47:19', NULL, NULL, 7903, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 19:47:19', 'admin-1489970962-14900104387111282', 1, 1, 'SR', NULL, NULL, NULL),
(24473, '2017-03-20 19:20:10', NULL, NULL, 7903, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 19:20:10', 'admin-1489970962-14900088106224058', 1, 0, '', NULL, NULL, NULL),
(24474, '2017-03-20 16:41:37', NULL, NULL, 7900, 0, 275, '209', 'Carlsberg', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:41:37', 'admin-1489970962-14899992969171582', 1, 0, '', NULL, NULL, NULL),
(24475, '2017-03-20 19:30:47', NULL, NULL, 7902, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 19:30:47', 'admin-1489970962-14900094475865516', 1, 1, 'SR', NULL, NULL, NULL),
(24476, '2017-03-20 19:20:10', NULL, NULL, 7903, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 19:20:10', 'admin-1489970962-14900088106224058', 1, 0, '', NULL, NULL, NULL),
(24477, '2017-03-20 19:20:10', NULL, NULL, 7903, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 19:20:10', 'admin-1489970962-14900088106224058', 1, 1, 'SR', NULL, NULL, NULL),
(24478, '2017-03-20 19:19:35', NULL, NULL, 7903, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 20.30, 0.0000, 0.0000, 20.30, 1, '27', 1, '1490013893', 'admin', '2017-03-20 19:19:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24479, '2017-03-20 19:09:58', NULL, NULL, 7902, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 19:09:58', 'admin-1489970962-14900081984677598', 1, 0, '', NULL, NULL, NULL),
(24480, '2017-03-20 16:27:33', NULL, NULL, 7899, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:27:33', 'admin-1489970962-14899984534047054', 1, 1, 'SR', NULL, NULL, NULL),
(24481, '2017-03-20 16:27:33', NULL, NULL, 7899, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:27:33', 'admin-1489970962-14899984534047054', 1, 1, 'SR', NULL, NULL, NULL),
(24482, '2017-03-20 16:41:16', NULL, NULL, 7895, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:41:16', 'admin-1489970962-14899992760957358', 1, 0, '', NULL, NULL, NULL),
(24483, '2017-03-20 16:41:27', NULL, NULL, 7900, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:41:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24484, '2017-03-20 16:41:37', NULL, NULL, 7900, 0, 275, '209', 'Carlsberg', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:41:37', 'admin-1489970962-14899992969171582', 1, 0, '', NULL, NULL, NULL),
(24485, '2017-03-20 16:59:10', NULL, NULL, 7901, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:59:10', 'admin-1489970962-14900003507093329', 1, 0, '', NULL, NULL, NULL),
(24486, '2017-03-20 19:09:58', NULL, NULL, 7902, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 19:09:58', 'admin-1489970962-14900081984677598', 1, 1, 'SR', NULL, NULL, NULL),
(24487, '2017-03-20 16:59:10', NULL, NULL, 7901, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:59:10', 'admin-1489970962-14900003507093329', 1, 1, 'SR', NULL, NULL, NULL),
(24488, '2017-03-20 16:59:10', NULL, NULL, 7901, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:59:10', 'admin-1489970962-14900003507093329', 1, 0, '', NULL, NULL, NULL),
(24489, '2017-03-20 12:10:43', NULL, NULL, 7889, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 12:10:43', 'admin-1489970962-14899830427873343', 1, 0, '', NULL, NULL, NULL),
(24490, '2017-03-20 12:10:52', NULL, NULL, 7889, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 12:10:52', 'admin-1489970962-14899830522867779', 1, 1, 'SR', NULL, NULL, NULL),
(24491, '2017-03-20 12:10:52', NULL, NULL, 7889, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 12:10:52', 'admin-1489970962-14899830522867779', 1, 1, 'SR', NULL, NULL, NULL),
(24492, '2017-03-20 13:27:13', NULL, NULL, 7890, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1490013893', 'admin', '2017-03-20 13:27:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24493, '2017-03-20 13:27:22', NULL, NULL, 7890, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 13:27:22', 'admin-1489970962-14899876426134174', 1, 0, '', NULL, NULL, NULL),
(24494, '2017-03-20 13:27:22', NULL, NULL, 7890, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 13:27:22', 'admin-1489970962-14899876426134174', 1, 1, 'SR', NULL, NULL, NULL),
(24495, '2017-03-20 13:31:53', NULL, NULL, 7891, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1490013893', 'admin', '2017-03-20 13:31:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24496, '2017-03-20 13:32:02', NULL, NULL, 7891, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 13:32:02', 'admin-1489970962-14899879225241881', 1, 1, 'SR', NULL, NULL, NULL),
(24497, '2017-03-20 13:32:32', NULL, NULL, 7891, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 13:32:32', 'admin-1489970962-14899879519965837', 1, 1, 'SR', NULL, NULL, NULL),
(24498, '2017-03-20 14:02:41', NULL, NULL, 7891, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 14:02:41', 'admin-1489970962-1489989761738822', 1, 0, '', NULL, NULL, NULL),
(24499, '2017-03-20 15:07:18', NULL, NULL, 7892, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 15:07:18', 'admin-1489970962-14899936386101067', 1, 1, 'SR', 1, NULL, NULL),
(24500, '2017-03-20 15:12:43', NULL, NULL, 7893, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1490013893', 'admin', '2017-03-20 15:12:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24501, '2017-03-20 15:14:20', NULL, NULL, 7893, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 15:14:20', 'admin-1489970962-14899940598218010', 1, 1, 'SR', NULL, NULL, NULL),
(24502, '2017-03-20 15:14:20', NULL, NULL, 7893, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 15:14:20', 'admin-1489970962-14899940598218010', 1, 1, 'SR', NULL, NULL, NULL),
(24503, '2017-03-20 16:12:34', NULL, NULL, 7894, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:12:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24504, '2017-03-20 16:13:59', NULL, NULL, 7894, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:13:59', 'admin-1489970962-14899976395545827', 1, 0, '', NULL, NULL, NULL),
(24505, '2017-03-20 16:13:59', NULL, NULL, 7894, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:13:59', 'admin-1489970962-14899976395545827', 1, 0, '', NULL, NULL, NULL),
(24506, '2017-03-20 16:13:59', NULL, NULL, 7894, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:13:59', 'admin-1489970962-14899976395545827', 1, 1, 'SR', NULL, NULL, NULL),
(24507, '2017-03-20 16:13:59', NULL, NULL, 7894, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:13:59', 'admin-1489970962-14899976395545827', 1, 0, '', NULL, NULL, NULL),
(24508, '2017-03-20 16:20:33', NULL, NULL, 7895, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:20:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24509, '2017-03-20 16:20:43', NULL, NULL, 7895, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:20:43', 'admin-1489970962-14899980437124684', 1, 1, 'SR', NULL, NULL, NULL),
(24510, '2017-03-20 16:20:43', NULL, NULL, 7895, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:20:43', 'admin-1489970962-14899980437124684', 1, 1, 'SR', NULL, NULL, NULL),
(24511, '2017-03-20 16:20:54', NULL, NULL, 7896, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:20:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24512, '2017-03-20 16:27:26', NULL, NULL, 7899, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:27:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24513, '2017-03-20 16:41:37', NULL, NULL, 7900, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:41:37', 'admin-1489970962-14899992969171582', 1, 0, '', NULL, NULL, NULL),
(24514, '2017-03-20 16:21:02', NULL, NULL, 7896, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 16:21:02', 'admin-1489970962-14899980621858217', 1, 1, 'SR', NULL, NULL, NULL),
(24515, '2017-03-20 11:01:41', NULL, NULL, 7888, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1490013893', 'admin', '2017-03-20 11:01:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24516, '2017-03-20 11:01:51', NULL, NULL, 7888, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 11:01:51', 'admin-1489970962-14899789108399726', 1, 1, 'SR', NULL, NULL, NULL),
(24517, '2017-03-20 12:10:37', NULL, NULL, 7889, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1490013893', 'admin', '2017-03-20 12:10:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24518, '2017-03-20 09:31:00', NULL, NULL, 7881, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 09:31:00', 'admin-1489970962-14899734599871033', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(24519, '2017-03-20 09:31:00', NULL, NULL, 7881, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 09:31:00', 'admin-1489970962-14899734599871033', 1, 1, 'SR', NULL, NULL, NULL),
(24520, '2017-03-20 09:31:00', NULL, NULL, 7881, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 09:31:00', 'admin-1489970962-14899734599871033', 1, 1, 'SR', NULL, NULL, NULL),
(24521, '2017-03-20 10:52:04', NULL, NULL, 7887, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 10:52:04', 'admin-1489970962-14899783245051658', 1, 0, '', NULL, NULL, NULL),
(24522, '2017-03-20 10:52:04', NULL, NULL, 7887, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 10:52:04', 'admin-1489970962-14899783245051658', 1, 0, '', NULL, NULL, NULL),
(24523, '2017-03-20 10:54:52', NULL, NULL, 7887, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 10:54:52', 'admin-1489970962-14899784923665380', 1, 1, 'SR', NULL, NULL, NULL),
(24524, '2017-03-20 10:54:52', NULL, NULL, 7887, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 10:54:52', 'admin-1489970962-14899784923665380', 1, 0, '', NULL, NULL, NULL),
(24525, '2017-03-20 10:40:27', NULL, NULL, 7886, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 10:40:27', 'admin-1489970962-14899776273798435', 1, 1, 'SR', NULL, NULL, NULL),
(24526, '2017-03-20 10:40:27', NULL, NULL, 7886, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 10:40:27', 'admin-1489970962-14899776273798435', 1, 1, 'SR', NULL, NULL, NULL),
(24527, '2017-03-20 09:31:00', NULL, NULL, 7881, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 09:31:00', 'admin-1489970962-14899734599871033', 1, 0, '', NULL, NULL, NULL),
(24528, '2017-03-20 09:31:00', NULL, NULL, 7881, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 09:31:00', 'admin-1489970962-14899734599871033', 1, 0, '', NULL, NULL, NULL),
(24529, '2017-03-20 09:31:00', NULL, NULL, 7881, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490013893', 'admin', '2017-03-20 09:31:00', 'admin-1489970962-14899734599871033', 1, 0, '', NULL, NULL, NULL),
(24530, '2017-03-20 09:30:36', NULL, NULL, 7881, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1490013893', 'admin', '2017-03-20 09:30:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24531, '2017-03-22 14:04:38', NULL, NULL, 7929, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 14:04:38', 'admin-1490161551-14901626786317268', 1, 1, 'SR', NULL, NULL, NULL),
(24532, '2017-03-22 14:04:38', NULL, NULL, 7929, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 14:04:38', 'admin-1490161551-14901626786317268', 1, 1, 'SR', NULL, NULL, NULL),
(24533, '2017-03-22 14:04:42', NULL, NULL, 7930, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1490161551', 'admin', '2017-03-22 14:04:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24534, '2017-03-22 14:04:54', NULL, NULL, 7930, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 14:04:54', 'admin-1490161551-14901626943042427', 1, 1, 'SR', NULL, NULL, NULL),
(24535, '2017-03-22 14:04:54', NULL, NULL, 7930, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 14:04:54', 'admin-1490161551-14901626943042427', 1, 1, 'SR', NULL, NULL, NULL),
(24536, '2017-03-22 14:18:48', NULL, NULL, 7931, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1490161551', 'admin', '2017-03-22 14:18:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24537, '2017-03-22 11:00:01', NULL, NULL, 7916, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:00:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24538, '2017-03-22 11:12:02', NULL, NULL, 7917, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:12:02', 'admin-1490144908-14901523218971868', 1, 0, '', NULL, NULL, NULL),
(24539, '2017-03-22 11:12:02', NULL, NULL, 7917, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:12:02', 'admin-1490144908-14901523218971868', 1, 0, '', NULL, NULL, NULL),
(24540, '2017-03-22 11:12:02', NULL, NULL, 7917, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:12:02', 'admin-1490144908-14901523218971868', 1, 0, '', NULL, NULL, NULL),
(24541, '2017-03-22 11:12:02', NULL, NULL, 7917, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:12:02', 'admin-1490144908-14901523218971868', 1, 1, 'SR', NULL, NULL, NULL),
(24542, '2017-03-22 11:12:02', NULL, NULL, 7917, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:12:02', 'admin-1490144908-14901523218971868', 1, 1, 'SR', NULL, NULL, NULL),
(24543, '2017-03-22 11:12:02', NULL, NULL, 7917, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:12:02', 'admin-1490144908-14901523218971868', 1, 1, 'SR', NULL, NULL, NULL),
(24544, '2017-03-22 11:12:05', NULL, NULL, 7918, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:12:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24545, '2017-03-22 11:12:10', NULL, NULL, 7918, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:12:10', 'admin-1490144908-14901523299748468', 1, 0, '', NULL, NULL, NULL),
(24546, '2017-03-22 11:12:10', NULL, NULL, 7918, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:12:10', 'admin-1490144908-14901523299748468', 1, 1, 'SR', NULL, NULL, NULL),
(24547, '2017-03-22 11:33:37', NULL, NULL, 7919, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:33:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24548, '2017-03-22 11:33:43', NULL, NULL, 7919, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:33:43', 'admin-1490144908-14901536238088830', 1, 1, 'SR', NULL, NULL, NULL),
(24549, '2017-03-22 11:33:43', NULL, NULL, 7919, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:33:43', 'admin-1490144908-14901536238088830', 1, 1, 'SR', NULL, NULL, NULL),
(24550, '2017-03-22 11:50:42', NULL, NULL, 7920, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 50.90, 0.0000, 0.0000, 50.90, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:50:42', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(24551, '2017-03-22 11:50:54', NULL, NULL, 7920, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:50:54', 'admin-1490144908-1490154654055664', 1, 1, 'SR', NULL, NULL, '10.0'),
(24552, '2017-03-22 14:19:00', NULL, NULL, 7931, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 14:19:00', 'admin-1490161551-14901635405341686', 1, 1, 'SR', NULL, NULL, NULL),
(24553, '2017-03-22 14:19:00', NULL, NULL, 7931, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 14:19:00', 'admin-1490161551-14901635405341686', 1, 1, 'SR', NULL, NULL, NULL),
(24554, '2017-03-22 14:19:00', NULL, NULL, 7931, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 14:19:00', 'admin-1490161551-14901635405341686', 1, 0, '', NULL, NULL, NULL),
(24555, '2017-03-22 12:58:46', NULL, NULL, 7923, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 12:58:46', 'admin-1490157479-14901587259735535', 1, 1, 'SR', NULL, NULL, NULL),
(24556, '2017-03-22 13:14:41', NULL, NULL, 7924, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1490161551', 'admin', '2017-03-22 13:14:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24557, '2017-03-22 13:14:51', NULL, NULL, 7924, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 13:14:51', 'admin-1490157479-14901596911245060', 1, 1, 'SR', NULL, NULL, NULL),
(24558, '2017-03-22 13:14:51', NULL, NULL, 7924, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 13:14:51', 'admin-1490157479-14901596911245060', 1, 1, 'SR', NULL, NULL, NULL),
(24559, '2017-03-22 13:14:51', NULL, NULL, 7924, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 13:14:51', 'admin-1490157479-14901596911245060', 1, 0, '', NULL, NULL, NULL),
(24560, '2017-03-22 18:44:32', NULL, NULL, 7936, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 18:44:32', 'admin-1490161551-14901794723714026', 1, 1, 'SR', 1, NULL, NULL),
(24561, '2017-03-22 18:44:32', NULL, NULL, 7936, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 18:44:32', 'admin-1490161551-14901794723714026', 1, 1, 'SR', 1, NULL, NULL),
(24562, '2017-03-22 12:58:03', NULL, NULL, 7923, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 12:58:03', 'admin-1490157479-1490158683466111', 1, 0, '', NULL, NULL, NULL),
(24563, '2017-03-22 00:00:00', NULL, NULL, 7921, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 10:31:47', 'admin-1490144908-14901499068594439', 1, 1, 'SR', NULL, NULL, NULL),
(24564, '2017-03-22 18:44:32', NULL, NULL, 7936, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 18:44:32', 'admin-1490161551-14901794723714026', 1, 0, '', 1, NULL, NULL),
(24565, '2017-03-22 15:58:38', NULL, NULL, 7935, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 15:58:38', 'admin-1490161551-14901695187591721', 1, 0, '', NULL, NULL, NULL),
(24566, '2017-03-22 15:58:33', NULL, NULL, 7935, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 15:58:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24567, '2017-03-22 15:57:50', NULL, NULL, 7934, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 15:57:50', 'admin-1490161551-14901694704276158', 1, 0, '', NULL, NULL, NULL),
(24568, '2017-03-22 13:45:32', NULL, NULL, 7926, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1490161551', 'admin', '2017-03-22 13:45:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24569, '2017-03-22 13:48:10', NULL, NULL, 7927, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 13:48:10', 'admin-1490161551-1490161690044358', 1, 0, '', NULL, NULL, NULL),
(24570, '2017-03-22 15:57:44', NULL, NULL, 7934, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 15:57:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24571, '2017-03-22 12:53:58', NULL, NULL, 7920, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 12:53:58', 'admin-1490157479-14901584379727624', 1, 1, 'SR', NULL, NULL, '10.0'),
(24572, '2017-03-22 12:54:13', NULL, NULL, 7920, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 12:54:13', 'admin-1490157479-14901584528539286', 1, 0, '', NULL, NULL, '10.0'),
(24573, '2017-03-22 12:02:12', NULL, NULL, 7920, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 12:02:12', 'admin-1490144908-14901553324859884', 1, 0, '', NULL, NULL, '10.0'),
(24574, '2017-03-22 12:29:56', NULL, NULL, 7920, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 12:29:56', 'admin-1490144908-14901569966413953', 1, 0, '', NULL, NULL, '10.0'),
(24575, '2017-03-22 15:10:23', NULL, NULL, 7933, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 15:10:23', 'admin-1490161551-14901666234169185', 1, 1, 'SR', NULL, NULL, NULL),
(24576, '2017-03-22 14:51:07', NULL, NULL, 7933, 0, 181, '116', 'Open Food ', 'set', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 14:51:07', 'admin-1490161551-14901654669436893', 1, 0, '', NULL, NULL, NULL),
(24577, '2017-03-22 14:51:07', NULL, NULL, 7933, 0, 74, '74', 'Sunrice', 'without edamame', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 14:51:07', 'admin-1490161551-14901654669436893', 1, 1, 'SR', NULL, NULL, NULL),
(24578, '2017-03-22 14:49:41', NULL, NULL, 7933, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1490161551', 'admin', '2017-03-22 14:49:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24579, '2017-03-22 14:48:33', NULL, NULL, 7932, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 14:48:33', 'admin-1490161551-1490165313209838', 1, 1, 'SR', NULL, NULL, NULL),
(24580, '2017-03-22 14:48:28', NULL, NULL, 7932, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1490161551', 'admin', '2017-03-22 14:48:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24581, '2017-03-22 14:19:00', NULL, NULL, 7931, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 14:19:00', 'admin-1490161551-14901635405341686', 1, 0, '', NULL, NULL, NULL),
(24582, '2017-03-22 14:19:00', NULL, NULL, 7931, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 14:19:00', 'admin-1490161551-14901635405341686', 1, 1, 'SR', NULL, NULL, NULL),
(24583, '2017-03-22 14:51:07', NULL, NULL, 7933, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 14:51:07', 'admin-1490161551-14901654669436893', 1, 1, 'SR', NULL, NULL, NULL),
(24584, '2017-03-22 14:04:19', NULL, NULL, 7929, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1490161551', 'admin', '2017-03-22 14:04:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24585, '2017-03-22 14:04:28', NULL, NULL, 7929, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 14:04:28', 'admin-1490161551-14901626682722930', 1, 0, '', NULL, NULL, NULL),
(24586, '2017-03-22 14:04:28', NULL, NULL, 7929, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 14:04:28', 'admin-1490161551-14901626682722930', 1, 0, '', NULL, NULL, NULL),
(24587, '2017-03-22 13:50:38', NULL, NULL, 7928, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 13:50:38', 'admin-1490161551-1490161838375456', 1, 0, '', NULL, NULL, NULL),
(24588, '2017-03-22 13:50:38', NULL, NULL, 7928, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 13:50:38', 'admin-1490161551-1490161838375456', 1, 0, '', NULL, NULL, NULL),
(24589, '2017-03-22 13:48:10', NULL, NULL, 7927, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 13:48:10', 'admin-1490161551-1490161690044358', 1, 0, '', NULL, NULL, NULL),
(24590, '2017-03-22 13:50:32', NULL, NULL, 7928, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1490161551', 'admin', '2017-03-22 13:50:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24591, '2017-03-22 13:45:41', NULL, NULL, 7926, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 13:45:41', 'admin-1490157479-1490161540859877', 1, 0, '', NULL, NULL, NULL),
(24592, '2017-03-22 13:48:01', NULL, NULL, 7927, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1490161551', 'admin', '2017-03-22 13:48:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24593, '2017-03-22 13:45:41', NULL, NULL, 7926, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 13:45:41', 'admin-1490157479-1490161540859877', 1, 0, '', NULL, NULL, NULL),
(24594, '2017-03-22 13:23:55', NULL, NULL, 7925, 0, 181, '116', 'Open Food ', 'Crispy Chili Pork', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 13:23:55', 'admin-1490157479-14901602352581143', 1, 0, '', NULL, NULL, NULL),
(24595, '2017-03-22 13:23:55', NULL, NULL, 7925, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 13:23:55', 'admin-1490157479-14901602352581143', 1, 0, '', NULL, NULL, NULL),
(24596, '2017-03-22 13:23:55', NULL, NULL, 7925, 0, 181, '116', 'Open Food ', 'set', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 13:23:55', 'admin-1490157479-14901602352581143', 1, 0, '', NULL, NULL, NULL),
(24597, '2017-03-22 13:16:47', NULL, NULL, 7924, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 13:16:47', 'admin-1490157479-14901598077052030', 1, 0, '', NULL, NULL, NULL),
(24598, '2017-03-22 13:22:45', NULL, NULL, 7925, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1490161551', 'admin', '2017-03-22 13:22:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24599, '2017-03-22 11:57:31', NULL, NULL, 7920, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:57:31', 'admin-1490144908-14901550509899819', 1, 0, '', NULL, NULL, '10.0'),
(24600, '2017-03-22 11:57:31', NULL, NULL, 7920, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:57:31', 'admin-1490144908-14901550509899819', 1, 1, 'SR', NULL, NULL, '10.0'),
(24601, '2017-03-22 11:57:31', NULL, NULL, 7920, 0, 181, '116', 'Open Food ', 'sweet corn chicken cube', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:57:31', 'admin-1490144908-14901550509899819', 1, 0, '', NULL, NULL, '10.0'),
(24602, '2017-03-22 12:02:12', NULL, NULL, 7920, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 12:02:12', 'admin-1490144908-14901553324859884', 1, 0, '', NULL, NULL, '10.0'),
(24603, '2017-03-22 13:16:47', NULL, NULL, 7924, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 13:16:47', 'admin-1490157479-14901598077052030', 1, 0, '', NULL, NULL, NULL),
(24604, '2017-03-22 12:58:46', NULL, NULL, 7923, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 12:58:46', 'admin-1490157479-14901587259735535', 1, 1, 'SR', NULL, NULL, NULL),
(24605, '2017-03-22 12:57:58', NULL, NULL, 7923, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 12:57:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24606, '2017-03-22 12:29:56', NULL, NULL, 7920, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 12:29:56', 'admin-1490144908-14901569966413953', 1, 1, 'SR', NULL, NULL, '10.0'),
(24607, '2017-03-22 12:29:56', NULL, NULL, 7920, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 12:29:56', 'admin-1490144908-14901569966413953', 1, 1, 'SR', NULL, NULL, '10.0'),
(24608, '2017-03-22 12:37:52', NULL, NULL, 7920, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 12:37:52', 'admin-1490144908-14901574725224617', 1, 0, '', NULL, NULL, '10.0'),
(24609, '2017-03-22 12:37:52', NULL, NULL, 7920, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 12:37:52', 'admin-1490144908-14901574725224617', 1, 0, '', NULL, NULL, '10.0'),
(24610, '2017-03-22 12:37:52', NULL, NULL, 7920, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 12:37:52', 'admin-1490144908-14901574725224617', 1, 0, '', NULL, NULL, '10.0'),
(24611, '2017-03-22 00:00:00', NULL, NULL, 7922, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 10:33:11', 'admin-1490144908-14901499915575976', 1, 1, 'SR', NULL, NULL, NULL),
(24612, '2017-03-22 12:47:21', NULL, NULL, 7920, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 12:47:21', 'admin-1490157479-1490158040928845', 1, 0, '', NULL, NULL, '10.0'),
(24613, '2017-03-22 12:47:21', NULL, NULL, 7920, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 12:47:21', 'admin-1490157479-1490158040928845', 1, 1, 'SR', NULL, NULL, '10.0'),
(24614, '2017-03-22 11:57:31', NULL, NULL, 7920, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:57:31', 'admin-1490144908-14901550509899819', 1, 1, 'SR', NULL, NULL, '10.0'),
(24615, '2017-03-22 11:57:31', NULL, NULL, 7920, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:57:31', 'admin-1490144908-14901550509899819', 1, 1, 'SR', NULL, NULL, '10.0'),
(24616, '2017-03-22 11:57:31', NULL, NULL, 7920, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:57:31', 'admin-1490144908-14901550509899819', 1, 0, '', NULL, NULL, '10.0'),
(24617, '2017-03-22 11:11:26', NULL, NULL, 7917, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:11:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24618, '2017-03-22 11:00:09', NULL, NULL, 7916, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:00:09', 'admin-1490144908-14901516097946562', 1, 1, 'SR', NULL, NULL, NULL),
(24619, '2017-03-22 11:00:09', NULL, NULL, 7916, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:00:09', 'admin-1490144908-14901516097946562', 1, 0, '', NULL, NULL, NULL),
(24620, '2017-03-22 11:00:09', NULL, NULL, 7916, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:00:09', 'admin-1490144908-14901516097946562', 1, 0, '', NULL, NULL, NULL),
(24621, '2017-03-22 11:50:54', NULL, NULL, 7920, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:50:54', 'admin-1490144908-1490154654055664', 1, 0, '', NULL, NULL, '10.0'),
(24622, '2017-03-22 11:50:54', NULL, NULL, 7920, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:50:54', 'admin-1490144908-1490154654055664', 1, 0, '', NULL, NULL, '10.0'),
(24623, '2017-03-22 11:50:54', NULL, NULL, 7920, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:50:54', 'admin-1490144908-1490154654055664', 1, 0, '', NULL, NULL, '10.0'),
(24624, '2017-03-22 11:56:38', NULL, NULL, 7920, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:56:38', 'admin-1490144908-14901549988139387', 1, 0, '', NULL, NULL, '10.0'),
(24625, '2017-03-22 11:56:38', NULL, NULL, 7920, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:56:39', 'admin-1490144908-14901549988139387', 1, 0, '', NULL, NULL, '10.0'),
(24626, '2017-03-22 11:56:39', NULL, NULL, 7920, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:56:39', 'admin-1490144908-14901549988139387', 1, 0, '', NULL, NULL, '10.0'),
(24627, '2017-03-22 11:56:39', NULL, NULL, 7920, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:56:39', 'admin-1490144908-14901549988139387', 1, 1, 'SR', NULL, NULL, '10.0'),
(24628, '2017-03-22 11:56:39', NULL, NULL, 7920, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:56:39', 'admin-1490144908-14901549988139387', 1, 0, '', NULL, NULL, '10.0'),
(24629, '2017-03-22 11:56:39', NULL, NULL, 7920, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:56:39', 'admin-1490144908-14901549988139387', 1, 0, '', NULL, NULL, '10.0'),
(24630, '2017-03-22 11:56:39', NULL, NULL, 7920, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:56:39', 'admin-1490144908-14901549988139387', 1, 0, '', NULL, NULL, '10.0'),
(24631, '2017-03-22 11:56:39', NULL, NULL, 7920, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:56:39', 'admin-1490144908-14901549988139387', 1, 0, '', NULL, NULL, '10.0'),
(24632, '2017-03-22 11:56:39', NULL, NULL, 7920, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:56:39', 'admin-1490144908-14901549988139387', 1, 1, 'SR', NULL, NULL, '10.0'),
(24633, '2017-03-22 11:56:39', NULL, NULL, 7920, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:56:39', 'admin-1490144908-14901549988139387', 1, 1, 'SR', NULL, NULL, '10.0'),
(24634, '2017-03-22 11:56:39', NULL, NULL, 7920, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:56:39', 'admin-1490144908-14901549988139387', 1, 1, 'SR', NULL, NULL, '10.0'),
(24635, '2017-03-22 11:56:39', NULL, NULL, 7920, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:56:39', 'admin-1490144908-14901549988139387', 1, 1, 'SR', NULL, NULL, '10.0'),
(24636, '2017-03-22 11:56:39', NULL, NULL, 7920, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:56:39', 'admin-1490144908-14901549988139387', 1, 1, 'SR', NULL, NULL, '10.0'),
(24637, '2017-03-22 12:37:52', NULL, NULL, 7920, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 12:37:52', 'admin-1490144908-14901574725224617', 1, 0, '', NULL, NULL, '10.0'),
(24638, '2017-03-22 12:40:02', NULL, NULL, 7920, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 12:40:02', 'admin-1490157479-14901576018432158', 1, 1, 'SR', NULL, NULL, '10.0'),
(24639, '2017-03-22 12:02:12', NULL, NULL, 7920, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 12:02:12', 'admin-1490144908-14901553324859884', 1, 0, '', NULL, NULL, '10.0'),
(24640, '2017-03-22 11:57:31', NULL, NULL, 7920, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:57:31', 'admin-1490144908-14901550509899819', 1, 0, '', NULL, NULL, '10.0'),
(24641, '2017-03-22 11:57:31', NULL, NULL, 7920, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:57:31', 'admin-1490144908-14901550509899819', 1, 0, '', NULL, NULL, '10.0'),
(24642, '2017-03-22 11:57:31', NULL, NULL, 7920, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:57:31', 'admin-1490144908-14901550509899819', 1, 1, 'SR', NULL, NULL, '10.0'),
(24643, '2017-03-22 11:57:31', NULL, NULL, 7920, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 11:57:31', 'admin-1490144908-14901550509899819', 1, 1, 'SR', NULL, NULL, '10.0'),
(24644, '2017-03-22 09:42:52', NULL, NULL, 7913, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 09:42:52', 'admin-1490144908-14901469725502921', 1, 0, '', NULL, NULL, NULL),
(24645, '2017-03-22 09:51:39', NULL, NULL, 7913, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 09:51:39', 'admin-1490144908-14901474994628459', 1, 0, '', NULL, NULL, NULL),
(24646, '2017-03-22 09:42:52', NULL, NULL, 7913, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 09:42:52', 'admin-1490144908-14901469725502921', 1, 0, '', NULL, NULL, NULL),
(24647, '2017-03-22 09:47:25', NULL, NULL, 7913, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 09:47:25', 'admin-1490144908-1490147244871591', 1, 0, '', NULL, NULL, NULL),
(24648, '2017-03-22 00:00:00', NULL, NULL, 7922, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, NULL, NULL, 2.70, 1, '27', 1, '1490161551', 'admin', '2017-03-22 10:31:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24649, '2017-03-22 12:47:21', NULL, NULL, 7920, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 12:47:21', 'admin-1490157479-1490158040928845', 1, 0, '', NULL, NULL, '10.0'),
(24650, '2017-03-22 12:42:39', NULL, NULL, 7921, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1490161551', 'admin', '2017-03-22 12:42:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24651, '2017-03-22 00:00:00', NULL, NULL, 7921, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 10:31:47', 'admin-1490144908-14901499068594439', 1, 0, '', NULL, NULL, NULL),
(24652, '2017-03-22 00:00:00', NULL, NULL, 7922, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 10:31:47', 'admin-1490144908-14901499068594439', 1, 0, '', NULL, NULL, NULL),
(24653, '2017-03-22 10:49:25', NULL, NULL, 7915, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1490161551', 'admin', '2017-03-22 10:49:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24654, '2017-03-22 10:51:03', NULL, NULL, 7915, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 10:51:03', 'admin-1490144908-14901510635839838', 1, 0, '', NULL, NULL, NULL),
(24655, '2017-03-22 10:51:03', NULL, NULL, 7915, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 10:51:03', 'admin-1490144908-14901510635839838', 1, 1, 'SR', NULL, NULL, NULL),
(24656, '2017-03-22 09:42:52', NULL, NULL, 7913, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 09:42:52', 'admin-1490144908-14901469725502921', 1, 0, '', NULL, NULL, NULL),
(24657, '2017-03-22 09:42:52', NULL, NULL, 7913, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490161551', 'admin', '2017-03-22 09:42:52', 'admin-1490144908-14901469725502921', 1, 0, '', NULL, NULL, NULL),
(24658, '2017-03-22 09:42:34', NULL, NULL, 7913, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1490161551', 'admin', '2017-03-22 09:42:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24659, '2017-03-23 13:22:15', NULL, NULL, 7947, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 13:22:15', 'admin-1490244611-14902465355242918', 1, 0, '', NULL, NULL, NULL),
(24660, '2017-03-23 13:36:07', NULL, NULL, 7945, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 13:36:07', 'admin-1490244611-14902473675325870', 1, 0, '', NULL, NULL, NULL),
(24661, '2017-03-23 00:00:00', NULL, NULL, 7953, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, NULL, NULL, 4.40, 1, '27', 1, '1490247953', 'admin', '2017-03-23 13:41:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24662, '2017-03-23 15:03:40', NULL, NULL, 7954, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1490247953', 'admin', '2017-03-23 15:03:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24663, '2017-03-23 14:48:09', NULL, NULL, 7951, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1490247953', 'admin', '2017-03-23 14:48:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24664, '2017-03-23 00:00:00', NULL, NULL, 7951, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 13:41:16', 'admin-1490244611-14902476760347325', 1, 1, 'SR', NULL, NULL, NULL),
(24665, '2017-03-23 00:00:00', NULL, NULL, 7953, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 13:41:16', 'admin-1490244611-14902476760347325', 1, 0, '', NULL, NULL, NULL),
(24666, '2017-03-23 14:48:50', NULL, NULL, 7952, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1490247953', 'admin', '2017-03-23 14:48:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24667, '2017-03-23 14:01:27', NULL, NULL, 7949, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1490247953', 'admin', '2017-03-23 14:01:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24668, '2017-03-23 11:15:48', NULL, NULL, 7939, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 11:15:48', 'admin-1490231242-14902389478728713', 1, 1, 'SR', NULL, NULL, NULL),
(24669, '2017-03-23 12:00:12', NULL, NULL, 7940, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 2, 15.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:00:12', 'admin-1490231242-14902416125819126', 1, 1, 'SR', NULL, NULL, NULL),
(24670, '2017-03-23 12:34:37', NULL, NULL, 7941, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:34:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24671, '2017-03-23 12:34:50', NULL, NULL, 7941, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:34:50', 'admin-1490231242-1490243690041717', 1, 1, 'SR', NULL, NULL, NULL),
(24672, '2017-03-23 12:34:50', NULL, NULL, 7941, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:34:50', 'admin-1490231242-1490243690041717', 1, 0, '', NULL, NULL, NULL),
(24673, '2017-03-23 14:39:43', NULL, NULL, 7941, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 14:39:43', 'admin-1490247953-14902511829178373', 1, 0, '', NULL, NULL, NULL),
(24674, '2017-03-23 14:46:47', NULL, NULL, 7950, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1490247953', 'admin', '2017-03-23 14:46:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24675, '2017-03-23 14:46:55', NULL, NULL, 7950, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 14:46:55', 'admin-1490247953-14902516149884879', 1, 1, 'SR', NULL, NULL, NULL),
(24676, '2017-03-23 14:46:55', NULL, NULL, 7950, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 14:46:55', 'admin-1490247953-14902516149884879', 1, 0, '', NULL, NULL, NULL),
(24677, '2017-03-23 00:00:00', NULL, NULL, 7951, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 13:41:16', 'admin-1490244611-14902476760347325', 1, 1, 'SR', NULL, NULL, NULL),
(24678, '2017-03-23 00:00:00', NULL, NULL, 7952, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 14:30:27', 'admin-1490247953-14902506273626462', 1, 1, 'SR', NULL, NULL, NULL),
(24679, '2017-03-23 13:22:15', NULL, NULL, 7947, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 13:22:15', 'admin-1490244611-14902465355242918', 1, 0, '', NULL, NULL, NULL),
(24680, '2017-03-23 13:16:04', NULL, NULL, 7945, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 13:16:04', 'admin-1490244611-14902461644369582', 1, 1, 'SR', NULL, NULL, NULL),
(24681, '2017-03-23 13:21:21', NULL, NULL, 7947, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1490247953', 'admin', '2017-03-23 13:21:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24682, '2017-03-23 13:31:04', NULL, NULL, 7947, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 13:31:04', 'admin-1490244611-14902470648035240', 1, 1, 'SR', NULL, NULL, NULL),
(24683, '2017-03-23 13:22:15', NULL, NULL, 7947, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 13:22:15', 'admin-1490244611-14902465355242918', 1, 1, 'SR', NULL, NULL, NULL),
(24684, '2017-03-23 17:49:31', NULL, NULL, 7959, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 17:49:31', 'admin-1490247953-14902625701905930', 1, 0, '', 1, NULL, NULL),
(24685, '2017-03-23 15:16:10', NULL, NULL, 7956, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 15:16:10', 'admin-1490247953-14902533706532469', 1, 0, '', NULL, NULL, NULL),
(24686, '2017-03-23 15:20:33', NULL, NULL, 7957, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 15:20:33', 'admin-1490247953-1490253632981111', 1, 0, '', 1, NULL, NULL),
(24687, '2017-03-23 15:21:19', NULL, NULL, 7955, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 15:21:19', 'admin-1490247953-1490253679363994', 1, 0, '', NULL, NULL, NULL),
(24688, '2017-03-23 17:49:30', NULL, NULL, 7959, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 17:49:30', 'admin-1490247953-14902625701905930', 1, 0, '', 1, NULL, NULL),
(24689, '2017-03-23 15:14:36', NULL, NULL, 7956, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1490247953', 'admin', '2017-03-23 15:14:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24690, '2017-03-23 15:14:39', NULL, NULL, 7956, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 15:14:39', 'admin-1490247953-14902532790694425', 1, 0, '', NULL, NULL, NULL),
(24691, '2017-03-23 15:03:50', NULL, NULL, 7955, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 15:03:50', 'admin-1490247953-14902526305648576', 1, 1, 'SR', NULL, NULL, NULL),
(24692, '2017-03-23 15:03:47', NULL, NULL, 7955, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1490247953', 'admin', '2017-03-23 15:03:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24693, '2017-03-23 15:03:44', NULL, NULL, 7954, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 15:03:44', 'admin-1490247953-14902526243903050', 1, 1, 'SR', NULL, NULL, NULL),
(24694, '2017-03-23 00:00:00', NULL, NULL, 7953, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 14:30:27', 'admin-1490247953-14902506273626462', 1, 0, '', NULL, NULL, NULL),
(24695, '2017-03-23 00:00:00', NULL, NULL, 7953, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 13:45:41', 'admin-1490244611-14902479417457640', 1, 1, 'SR', NULL, NULL, NULL),
(24696, '2017-03-23 00:00:00', NULL, NULL, 7952, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 13:47:06', 'admin-1490247953-14902480260072565', 1, 1, 'SR', NULL, NULL, NULL),
(24697, '2017-03-23 14:01:51', NULL, NULL, 7949, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 14:01:51', 'admin-1490247953-14902489116908485', 1, 1, 'SR', NULL, NULL, NULL),
(24698, '2017-03-23 14:01:51', NULL, NULL, 7949, 0, 181, '116', 'Open Food ', ' dressing on side,Chicken Salad', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 14:01:51', 'admin-1490247953-14902489116908485', 1, 0, '', NULL, NULL, NULL),
(24699, '2017-03-23 14:01:51', NULL, NULL, 7949, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 14:01:51', 'admin-1490247953-14902489116908485', 1, 0, '', NULL, NULL, NULL),
(24700, '2017-03-23 12:38:14', NULL, NULL, 7941, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:38:14', 'admin-1490231242-14902438940923154', 1, 1, 'SR', NULL, NULL, NULL),
(24701, '2017-03-23 12:39:42', NULL, NULL, 7942, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:39:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24702, '2017-03-23 12:40:04', NULL, NULL, 7942, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:40:04', 'admin-1490231242-14902440046317288', 1, 1, 'SR', NULL, NULL, NULL),
(24703, '2017-03-23 12:40:04', NULL, NULL, 7942, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:40:04', 'admin-1490231242-14902440046317288', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(24704, '2017-03-23 12:40:04', NULL, NULL, 7942, 0, 181, '116', 'Open Food ', 'Scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:40:04', 'admin-1490231242-14902440046317288', 1, 0, '', NULL, NULL, NULL),
(24705, '2017-03-23 12:45:02', NULL, NULL, 7943, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 18.00, 0.0000, 0.0000, 18.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:45:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24706, '2017-03-23 12:46:47', NULL, NULL, 7943, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:46:48', 'admin-1490231242-14902444078167189', 1, 1, 'SR', NULL, NULL, NULL),
(24707, '2017-03-23 12:46:48', NULL, NULL, 7943, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:46:48', 'admin-1490231242-14902444078167189', 1, 1, 'SR', NULL, NULL, NULL),
(24708, '2017-03-23 12:46:48', NULL, NULL, 7943, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:46:48', 'admin-1490231242-14902444078167189', 1, 1, 'SR', NULL, NULL, NULL),
(24709, '2017-03-23 12:46:48', NULL, NULL, 7943, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:46:48', 'admin-1490231242-14902444078167189', 1, 0, '', NULL, NULL, NULL),
(24710, '2017-03-23 12:46:48', NULL, NULL, 7943, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:46:48', 'admin-1490231242-14902444078167189', 1, 0, '', NULL, NULL, NULL),
(24711, '2017-03-23 12:46:48', NULL, NULL, 7943, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:46:48', 'admin-1490231242-14902444078167189', 1, 0, '', NULL, NULL, NULL),
(24712, '2017-03-23 12:46:48', NULL, NULL, 7943, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:46:48', 'admin-1490231242-14902444078167189', 1, 1, 'SR', NULL, NULL, NULL),
(24713, '2017-03-23 12:46:48', NULL, NULL, 7943, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:46:48', 'admin-1490231242-14902444078167189', 1, 1, 'SR', NULL, NULL, NULL),
(24714, '2017-03-23 12:46:48', NULL, NULL, 7943, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:46:48', 'admin-1490231242-14902444078167189', 1, 0, '', NULL, NULL, NULL),
(24715, '2017-03-23 12:46:48', NULL, NULL, 7943, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:46:48', 'admin-1490231242-14902444078167189', 1, 0, '', NULL, NULL, NULL),
(24716, '2017-03-23 12:46:48', NULL, NULL, 7943, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:46:48', 'admin-1490231242-14902444078167189', 1, 1, 'SR', NULL, NULL, NULL),
(24717, '2017-03-23 12:46:48', NULL, NULL, 7943, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:46:48', 'admin-1490231242-14902444078167189', 1, 0, '', NULL, NULL, NULL),
(24718, '2017-03-23 12:46:48', NULL, NULL, 7943, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:46:48', 'admin-1490231242-14902444078167189', 1, 0, '', NULL, NULL, NULL),
(24719, '2017-03-23 12:46:48', NULL, NULL, 7943, 0, 181, '116', 'Open Food ', 'Fruits Pancake', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:46:48', 'admin-1490231242-14902444078167189', 1, 0, '', NULL, NULL, NULL),
(24720, '2017-03-23 12:47:54', NULL, NULL, 7944, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:47:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24721, '2017-03-23 12:48:05', NULL, NULL, 7944, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:48:05', 'admin-1490231242-1490244485761892', 1, 0, '', NULL, NULL, NULL),
(24722, '2017-03-23 12:48:05', NULL, NULL, 7944, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:48:05', 'admin-1490231242-1490244485761892', 1, 0, '', NULL, NULL, NULL),
(24723, '2017-03-23 12:48:05', NULL, NULL, 7944, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:48:05', 'admin-1490231242-1490244485761892', 1, 0, '', NULL, NULL, NULL),
(24724, '2017-03-23 12:53:06', NULL, NULL, 7944, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:53:06', 'admin-1490244611-14902447858129781', 1, 0, '', NULL, NULL, NULL),
(24725, '2017-03-23 12:53:06', NULL, NULL, 7944, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:53:06', 'admin-1490244611-14902447858129781', 1, 0, '', NULL, NULL, NULL),
(24726, '2017-03-23 13:00:42', NULL, NULL, 7945, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1490247953', 'admin', '2017-03-23 13:00:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24727, '2017-03-23 13:00:48', NULL, NULL, 7945, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 13:00:48', 'admin-1490244611-14902452482388424', 1, 1, 'SR', NULL, NULL, NULL),
(24728, '2017-03-23 13:22:15', NULL, NULL, 7947, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 13:22:15', 'admin-1490244611-14902465355242918', 1, 1, 'SR', NULL, NULL, NULL),
(24729, '2017-03-23 13:16:04', NULL, NULL, 7945, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 13:16:04', 'admin-1490244611-14902461644369582', 1, 1, 'SR', NULL, NULL, NULL),
(24730, '2017-03-23 13:03:50', NULL, NULL, 7946, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 13:03:50', 'admin-1490244611-1490245430713620', 1, 1, 'SR', NULL, NULL, NULL),
(24731, '2017-03-23 13:03:50', NULL, NULL, 7946, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 13:03:50', 'admin-1490244611-1490245430713620', 1, 0, '', NULL, NULL, NULL),
(24732, '2017-03-23 09:52:48', NULL, NULL, 7937, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 09:52:48', 'admin-1490231242-1490233967798199', 1, 0, '', NULL, NULL, NULL),
(24733, '2017-03-23 09:52:59', NULL, NULL, 7937, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 09:52:59', 'admin-1490231242-14902339787257355', 1, 0, '', NULL, NULL, NULL),
(24734, '2017-03-23 09:52:59', NULL, NULL, 7937, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 09:52:59', 'admin-1490231242-14902339787257355', 1, 1, 'SR', NULL, NULL, NULL),
(24735, '2017-03-23 11:06:41', NULL, NULL, 7938, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1490247953', 'admin', '2017-03-23 11:06:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24736, '2017-03-23 11:06:52', NULL, NULL, 7938, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 11:06:52', 'admin-1490231242-14902384124917264', 1, 0, '', NULL, NULL, NULL),
(24737, '2017-03-23 13:03:41', NULL, NULL, 7946, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1490247953', 'admin', '2017-03-23 13:03:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24738, '2017-03-23 13:00:48', NULL, NULL, 7945, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 13:00:48', 'admin-1490244611-14902452482388424', 1, 1, 'SR', NULL, NULL, NULL),
(24739, '2017-03-23 12:38:14', NULL, NULL, 7941, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:38:14', 'admin-1490231242-14902438940923154', 1, 1, 'SR', NULL, NULL, NULL),
(24740, '2017-03-23 12:00:05', NULL, NULL, 7940, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 12:00:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24741, '2017-03-23 11:15:44', NULL, NULL, 7939, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1490247953', 'admin', '2017-03-23 11:15:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24742, '2017-03-23 11:06:52', NULL, NULL, 7938, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 11:06:52', 'admin-1490231242-14902384124917264', 1, 0, '', NULL, NULL, NULL),
(24743, '2017-03-23 11:06:52', NULL, NULL, 7938, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490247953', 'admin', '2017-03-23 11:06:52', 'admin-1490231242-14902384124917264', 1, 0, '', NULL, NULL, NULL),
(24744, '2017-03-23 09:52:42', NULL, NULL, 7937, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1490247953', 'admin', '2017-03-23 09:52:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24745, '2017-03-24 18:30:13', NULL, NULL, 7981, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 18:30:13', 'admin-1490332569-14903514130898061', 1, 0, '', NULL, NULL, NULL),
(24746, '2017-03-24 18:55:49', NULL, NULL, 7981, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 18:55:49', 'admin-1490332569-14903529490702343', 1, 0, '', NULL, NULL, NULL),
(24747, '2017-03-24 18:55:49', NULL, NULL, 7981, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 18:55:49', 'admin-1490332569-14903529490702343', 1, 1, 'SR', NULL, NULL, NULL),
(24748, '2017-03-24 18:56:02', NULL, NULL, 7981, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 18:56:02', 'admin-1490332569-14903529622762366', 1, 0, '', NULL, NULL, NULL),
(24749, '2017-03-24 18:57:31', NULL, NULL, 7981, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 18:57:31', 'admin-1490332569-14903530508759866', 1, 0, '', NULL, NULL, NULL),
(24750, '2017-03-24 19:17:27', NULL, NULL, 7981, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 19:17:27', 'admin-1490332569-14903542471502789', 1, 0, '', NULL, NULL, NULL),
(24751, '2017-03-24 19:36:28', NULL, NULL, 7981, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 19:36:28', 'admin-1490332569-14903553878183057', 1, 1, 'SR', NULL, NULL, NULL),
(24752, '2017-03-24 15:47:59', NULL, NULL, 7979, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 15:47:59', 'admin-1490332569-14903416788901227', 1, 1, 'SR', NULL, NULL, NULL),
(24753, '2017-03-24 12:04:32', NULL, NULL, 7973, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:04:32', 'admin-1490322950-1490328272387998', 1, 0, '', NULL, NULL, NULL),
(24754, '2017-03-24 15:47:55', NULL, NULL, 7979, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1490332569', 'admin', '2017-03-24 15:47:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24755, '2017-03-24 15:19:14', NULL, NULL, 7978, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 15:19:14', 'admin-1490332569-14903399540849852', 1, 1, 'SR', NULL, NULL, NULL),
(24756, '2017-03-24 15:18:01', NULL, NULL, 7978, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 15:18:01', 'admin-1490332569-1490339881418431', 1, 0, '', NULL, NULL, NULL),
(24757, '2017-03-24 15:17:53', NULL, NULL, 7978, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1490332569', 'admin', '2017-03-24 15:17:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24758, '2017-03-24 12:03:50', NULL, NULL, 7973, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:03:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24759, '2017-03-24 12:04:32', NULL, NULL, 7973, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:04:32', 'admin-1490322950-1490328272387998', 1, 0, '', NULL, NULL, NULL),
(24760, '2017-03-24 12:00:18', NULL, NULL, 7970, 0, 181, '116', 'Open Food ', 'sweet corn', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:00:18', 'admin-1490322950-14903280183492351', 1, 0, '', NULL, NULL, NULL),
(24761, '2017-03-24 14:49:07', NULL, NULL, 7977, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 14:49:07', 'admin-1490332569-14903381468072083', 1, 1, 'SR', NULL, NULL, NULL),
(24762, '2017-03-24 09:51:16', NULL, NULL, 7963, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 09:51:16', 'admin-1490317137-14903202759577465', 1, 0, '', NULL, NULL, NULL),
(24763, '2017-03-24 09:51:16', NULL, NULL, 7963, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 09:51:16', 'admin-1490317137-14903202759577465', 1, 1, 'SR', NULL, NULL, NULL),
(24764, '2017-03-24 09:51:09', NULL, NULL, 7963, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1490332569', 'admin', '2017-03-24 09:51:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24765, '2017-03-24 09:51:16', NULL, NULL, 7963, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 09:51:16', 'admin-1490317137-14903202759577465', 1, 0, '', NULL, NULL, NULL),
(24766, '2017-03-24 20:06:23', NULL, NULL, 7981, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 20:06:23', 'admin-1490332569-1490357182911163', 1, 0, '', NULL, NULL, NULL),
(24767, '2017-03-24 20:45:33', NULL, NULL, 7983, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1490332569', 'admin', '2017-03-24 20:45:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24768, '2017-03-24 20:47:38', NULL, NULL, 7983, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 20:47:38', 'admin-1490332569-14903596584166863', 1, 1, 'SR', NULL, NULL, NULL),
(24769, '2017-03-24 00:00:00', NULL, NULL, 7984, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 19:50:49', 'admin-1490332569-1490356249014955', 1, 1, 'SR', NULL, NULL, NULL),
(24770, '2017-03-24 12:59:41', NULL, NULL, 7970, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:59:41', 'admin-1490322950-14903315817073029', 1, 1, 'SR', NULL, NULL, NULL),
(24771, '2017-03-24 12:59:41', NULL, NULL, 7970, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:59:41', 'admin-1490322950-14903315817073029', 1, 0, '', NULL, NULL, NULL),
(24772, '2017-03-24 13:07:00', NULL, NULL, 7976, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1490332569', 'admin', '2017-03-24 13:07:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24773, '2017-03-24 13:07:19', NULL, NULL, 7976, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 13:07:19', 'admin-1490322950-14903320393843915', 1, 0, '', NULL, NULL, NULL),
(24774, '2017-03-24 13:07:19', NULL, NULL, 7976, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 13:07:19', 'admin-1490322950-14903320393843915', 1, 1, 'SR', NULL, NULL, NULL),
(24775, '2017-03-24 13:15:57', NULL, NULL, 7976, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 13:15:57', 'admin-1490322950-1490332557479910', 1, 1, 'SR', NULL, NULL, NULL),
(24776, '2017-03-24 13:15:57', NULL, NULL, 7976, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 13:15:57', 'admin-1490322950-1490332557479910', 1, 0, '', NULL, NULL, NULL),
(24777, '2017-03-24 15:47:59', NULL, NULL, 7979, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 15:47:59', 'admin-1490332569-14903416788901227', 1, 1, 'SR', NULL, NULL, NULL),
(24778, '2017-03-24 14:25:53', NULL, NULL, 7977, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 14:25:53', 'admin-1490332569-1490336752966286', 1, 1, 'SR', NULL, NULL, NULL),
(24779, '2017-03-24 14:25:46', NULL, NULL, 7977, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1490332569', 'admin', '2017-03-24 14:25:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24780, '2017-03-24 14:14:30', NULL, NULL, 7976, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 14:14:30', 'admin-1490332569-149033607069541', 1, 0, '', NULL, NULL, NULL),
(24781, '2017-03-24 20:48:51', NULL, NULL, 7982, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 20:48:51', 'admin-1490332569-14903597312255710', 1, 1, 'SR', NULL, NULL, NULL),
(24782, '2017-03-24 00:00:00', NULL, NULL, 7984, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 19:58:47', 'admin-1490332569-14903567272036241', 1, 0, '', NULL, NULL, NULL),
(24783, '2017-03-24 00:00:00', NULL, NULL, 7983, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 20:19:19', 'admin-1490332569-14903579591038433', 1, 1, 'SR', NULL, NULL, NULL),
(24784, '2017-03-24 20:47:56', NULL, NULL, 7984, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 20:47:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24785, '2017-03-24 20:04:49', NULL, NULL, 7982, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 20:04:49', 'admin-1490332569-14903570889053876', 1, 1, 'SR', NULL, NULL, NULL),
(24786, '2017-03-24 12:38:56', NULL, NULL, 7975, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:38:56', 'admin-1490322950-14903303365224365', 1, 0, '', NULL, NULL, NULL),
(24787, '2017-03-24 19:50:38', NULL, NULL, 7982, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1490332569', 'admin', '2017-03-24 19:50:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24788, '2017-03-24 19:36:28', NULL, NULL, 7981, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 19:36:28', 'admin-1490332569-14903553878183057', 1, 0, '', NULL, NULL, NULL),
(24789, '2017-03-24 18:21:44', NULL, NULL, 7980, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 18:21:44', 'admin-1490332569-14903509040557794', 1, 1, 'SR', 1, NULL, '10.0'),
(24790, '2017-03-24 18:21:44', NULL, NULL, 7980, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 18:21:44', 'admin-1490332569-14903509040557794', 1, 1, 'SR', 1, NULL, '10.0'),
(24791, '2017-03-24 18:21:44', NULL, NULL, 7980, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 18:21:44', 'admin-1490332569-14903509040557794', 1, 1, 'SR', 1, NULL, '10.0'),
(24792, '2017-03-24 18:21:44', NULL, NULL, 7980, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 18:21:44', 'admin-1490332569-14903509040557794', 1, 1, 'SR', 1, NULL, '10.0'),
(24793, '2017-03-24 18:30:03', NULL, NULL, 7981, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.50, 0.0000, 0.0000, 11.50, 1, '27', 1, '1490332569', 'admin', '2017-03-24 18:30:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24794, '2017-03-24 12:59:41', NULL, NULL, 7970, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:59:41', 'admin-1490322950-14903315817073029', 1, 0, '', NULL, NULL, NULL),
(24795, '2017-03-24 12:33:36', NULL, NULL, 7975, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:33:36', 'admin-1490322950-14903300166925962', 1, 1, 'SR', NULL, NULL, NULL),
(24796, '2017-03-24 12:33:36', NULL, NULL, 7975, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:33:36', 'admin-1490322950-14903300166925962', 1, 1, 'SR', NULL, NULL, NULL),
(24797, '2017-03-24 12:33:36', NULL, NULL, 7975, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:33:36', 'admin-1490322950-14903300166925962', 1, 0, '', NULL, NULL, NULL),
(24798, '2017-03-24 12:33:36', NULL, NULL, 7975, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:33:36', 'admin-1490322950-14903300166925962', 1, 0, '', NULL, NULL, NULL),
(24799, '2017-03-24 12:11:04', NULL, NULL, 7974, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:11:04', 'admin-1490322950-14903286646645763', 1, 0, '', NULL, NULL, NULL),
(24800, '2017-03-24 12:11:04', NULL, NULL, 7974, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:11:04', 'admin-1490322950-14903286646645763', 1, 0, '', NULL, NULL, NULL),
(24801, '2017-03-24 12:32:10', NULL, NULL, 7975, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:32:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24802, '2017-03-24 12:10:59', NULL, NULL, 7974, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:10:59', 'admin-1490322950-14903286592681620', 1, 0, '', NULL, NULL, NULL),
(24803, '2017-03-24 12:10:59', NULL, NULL, 7974, 0, 217, '151', 'Spicy Lemony Wings', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:10:59', 'admin-1490322950-14903286592681620', 1, 0, '', NULL, NULL, NULL),
(24804, '2017-03-24 12:10:59', NULL, NULL, 7974, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:10:59', 'admin-1490322950-14903286592681620', 1, 1, 'SR', NULL, NULL, NULL),
(24805, '2017-03-24 12:10:59', NULL, NULL, 7974, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:10:59', 'admin-1490322950-14903286592681620', 1, 1, 'SR', NULL, NULL, NULL),
(24806, '2017-03-24 12:10:59', NULL, NULL, 7974, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:10:59', 'admin-1490322950-14903286592681620', 1, 1, 'SR', NULL, NULL, NULL),
(24807, '2017-03-24 12:10:59', NULL, NULL, 7974, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:10:59', 'admin-1490322950-14903286592681620', 1, 1, 'SR', NULL, NULL, NULL),
(24808, '2017-03-24 12:10:35', NULL, NULL, 7974, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.40, 0.0000, 0.0000, 11.40, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:10:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24809, '2017-03-24 12:04:32', NULL, NULL, 7973, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:04:32', 'admin-1490322950-1490328272387998', 1, 1, 'SR', NULL, NULL, NULL),
(24810, '2017-03-24 12:04:32', NULL, NULL, 7973, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:04:32', 'admin-1490322950-1490328272387998', 1, 1, 'SR', NULL, NULL, NULL),
(24811, '2017-03-24 10:00:37', NULL, NULL, 7964, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1490332569', 'admin', '2017-03-24 10:00:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24812, '2017-03-24 10:01:11', NULL, NULL, 7964, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 10:01:11', 'admin-1490317137-14903208712445636', 1, 0, '', NULL, NULL, NULL),
(24813, '2017-03-24 10:01:11', NULL, NULL, 7964, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 10:01:11', 'admin-1490317137-14903208712445636', 1, 0, '', NULL, NULL, NULL),
(24814, '2017-03-24 10:01:11', NULL, NULL, 7964, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 10:01:11', 'admin-1490317137-14903208712445636', 1, 0, '', NULL, NULL, NULL),
(24815, '2017-03-24 10:01:11', NULL, NULL, 7964, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 10:01:11', 'admin-1490317137-14903208712445636', 1, 0, '', NULL, NULL, NULL),
(24816, '2017-03-24 10:01:17', NULL, NULL, 7964, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 10:01:17', 'admin-1490317137-1490320877070949', 1, 1, 'SR', NULL, NULL, NULL),
(24817, '2017-03-24 10:31:58', NULL, NULL, 7965, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1490332569', 'admin', '2017-03-24 10:31:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24818, '2017-03-24 10:32:03', NULL, NULL, 7965, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 10:32:03', 'admin-1490317137-14903227230291449', 1, 0, '', NULL, NULL, NULL),
(24819, '2017-03-24 10:32:03', NULL, NULL, 7965, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 10:32:03', 'admin-1490317137-14903227230291449', 1, 0, '', NULL, NULL, NULL),
(24820, '2017-03-24 10:32:07', NULL, NULL, 7965, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 10:32:07', 'admin-1490317137-14903227276404477', 1, 0, '', NULL, NULL, NULL),
(24821, '2017-03-24 10:32:07', NULL, NULL, 7965, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 10:32:07', 'admin-1490317137-14903227276404477', 1, 1, 'SR', NULL, NULL, NULL),
(24822, '2017-03-24 10:34:18', NULL, NULL, 7964, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 10:34:18', 'admin-1490317137-14903228581989940', 1, 0, '', NULL, NULL, NULL),
(24823, '2017-03-24 10:35:21', NULL, NULL, 7966, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 10:35:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24824, '2017-03-24 10:35:42', NULL, NULL, 7966, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 10:35:42', 'admin-1490317137-14903229419279415', 1, 0, '', NULL, NULL, NULL),
(24825, '2017-03-24 10:35:42', NULL, NULL, 7966, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 10:35:42', 'admin-1490317137-14903229419279415', 1, 0, '', NULL, NULL, NULL),
(24826, '2017-03-24 10:35:42', NULL, NULL, 7966, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 10:35:42', 'admin-1490317137-14903229419279415', 1, 1, 'SR', NULL, NULL, NULL),
(24827, '2017-03-24 10:35:42', NULL, NULL, 7966, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 10:35:42', 'admin-1490317137-14903229419279415', 1, 1, 'SR', NULL, NULL, NULL),
(24828, '2017-03-24 10:47:37', NULL, NULL, 7967, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1490332569', 'admin', '2017-03-24 10:47:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24829, '2017-03-24 10:47:45', NULL, NULL, 7968, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 10:47:45', 'admin-1490322950-14903236652794491', 1, 0, '', 1, NULL, NULL),
(24830, '2017-03-24 10:59:22', NULL, NULL, 7969, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1490332569', 'admin', '2017-03-24 10:59:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24831, '2017-03-24 10:59:27', NULL, NULL, 7969, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 10:59:27', 'admin-1490322950-14903243672489944', 1, 1, 'SR', NULL, NULL, NULL),
(24832, '2017-03-24 11:03:01', NULL, NULL, 7967, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 11:03:01', 'admin-1490322950-14903245813933724', 1, 1, 'SR', NULL, NULL, NULL),
(24833, '2017-03-24 11:04:35', NULL, NULL, 7967, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 11:04:35', 'admin-1490322950-14903246753288753', 1, 0, '', NULL, NULL, NULL),
(24834, '2017-03-24 11:05:25', NULL, NULL, 7970, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.90, 0.0000, 0.0000, 12.90, 1, '27', 1, '1490332569', 'admin', '2017-03-24 11:05:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24835, '2017-03-24 11:05:29', NULL, NULL, 7970, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 11:05:29', 'admin-1490322950-14903247293241463', 1, 1, 'SR', NULL, NULL, NULL),
(24836, '2017-03-24 11:15:15', NULL, NULL, 7971, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1490332569', 'admin', '2017-03-24 11:15:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24837, '2017-03-24 11:15:18', NULL, NULL, 7971, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 11:15:18', 'admin-1490322950-14903253184333819', 1, 0, '', NULL, NULL, NULL),
(24838, '2017-03-24 11:15:58', NULL, NULL, 7971, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 11:15:58', 'admin-1490322950-14903253585146755', 1, 0, '', NULL, NULL, NULL),
(24839, '2017-03-24 12:00:18', NULL, NULL, 7970, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:00:18', 'admin-1490322950-14903280183492351', 1, 1, 'SR', NULL, NULL, NULL),
(24840, '2017-03-24 12:00:18', NULL, NULL, 7970, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 12:00:18', 'admin-1490322950-14903280183492351', 1, 1, 'SR', NULL, NULL, NULL),
(24841, '2017-03-24 11:56:40', NULL, NULL, 7970, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 11:56:40', 'admin-1490322950-14903277998703581', 1, 1, 'SR', NULL, NULL, NULL),
(24842, '2017-03-24 11:56:26', NULL, NULL, 7972, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 11:56:26', 'admin-1490322950-14903277865571916', 1, 1, 'SR', NULL, NULL, NULL),
(24843, '2017-03-24 11:56:40', NULL, NULL, 7970, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 11:56:40', 'admin-1490322950-14903277998703581', 1, 1, 'SR', NULL, NULL, NULL),
(24844, '2017-03-24 09:32:24', NULL, NULL, 7961, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1490332569', 'admin', '2017-03-24 09:32:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24845, '2017-03-24 09:32:30', NULL, NULL, 7961, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 09:32:30', 'admin-1490317137-14903191500759282', 1, 0, '', NULL, NULL, NULL),
(24846, '2017-03-24 09:32:30', NULL, NULL, 7961, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 09:32:30', 'admin-1490317137-14903191500759282', 1, 0, '', NULL, NULL, NULL),
(24847, '2017-03-24 09:32:38', NULL, NULL, 7961, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 09:32:38', 'admin-1490317137-14903191585014041', 1, 1, 'SR', NULL, NULL, NULL),
(24848, '2017-03-24 09:32:38', NULL, NULL, 7961, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 09:32:38', 'admin-1490317137-14903191585014041', 1, 0, '', NULL, NULL, NULL),
(24849, '2017-03-24 09:49:00', NULL, NULL, 7962, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1490332569', 'admin', '2017-03-24 09:49:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24850, '2017-03-24 11:56:26', NULL, NULL, 7972, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 11:56:26', 'admin-1490322950-14903277865571916', 1, 1, 'SR', NULL, NULL, NULL),
(24851, '2017-03-24 11:15:58', NULL, NULL, 7971, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 11:15:58', 'admin-1490322950-14903253585146755', 1, 1, 'SR', NULL, NULL, NULL),
(24852, '2017-03-24 11:15:58', NULL, NULL, 7971, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 11:15:58', 'admin-1490322950-14903253585146755', 1, 1, 'SR', NULL, NULL, NULL),
(24853, '2017-03-24 11:56:19', NULL, NULL, 7972, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 11:56:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24854, '2017-03-24 09:49:04', NULL, NULL, 7962, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 09:49:04', 'admin-1490317137-14903201445167390', 1, 1, 'SR', NULL, NULL, NULL),
(24855, '2017-03-24 09:14:57', NULL, NULL, 7960, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 09:14:57', 'admin-1490317137-14903180973818897', 1, 0, '', NULL, NULL, NULL),
(24856, '2017-03-24 09:14:57', NULL, NULL, 7960, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490332569', 'admin', '2017-03-24 09:14:57', 'admin-1490317137-14903180973818897', 1, 1, 'SR', NULL, NULL, NULL),
(24857, '2017-03-24 09:14:50', NULL, NULL, 7960, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1490332569', 'admin', '2017-03-24 09:14:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24858, '2017-03-25 13:18:11', NULL, NULL, 7997, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 13:18:11', 'admin-1490416195-14904190916818956', 1, 0, '', NULL, NULL, NULL),
(24859, '2017-03-25 13:18:11', NULL, NULL, 7997, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 13:18:11', 'admin-1490416195-14904190916818956', 1, 0, '', NULL, NULL, NULL),
(24860, '2017-03-25 13:46:08', NULL, NULL, 8003, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1490422947', 'admin', '2017-03-25 13:46:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24861, '2017-03-25 13:46:14', NULL, NULL, 8003, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 13:46:14', 'admin-1490416195-14904207745727262', 1, 1, 'SR', NULL, NULL, NULL),
(24862, '2017-03-25 13:46:14', NULL, NULL, 8003, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 13:46:14', 'admin-1490416195-14904207745727262', 1, 1, 'SR', NULL, NULL, NULL),
(24863, '2017-03-25 13:53:26', NULL, NULL, 8002, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 13:53:26', 'admin-1490416195-14904212063731644', 1, 0, '', NULL, NULL, NULL),
(24864, '2017-03-25 13:53:37', NULL, NULL, 8004, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1490422947', 'admin', '2017-03-25 13:53:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24865, '2017-03-25 13:53:51', NULL, NULL, 8004, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 13:53:51', 'admin-1490416195-14904212310229383', 1, 1, 'SR', NULL, NULL, NULL),
(24866, '2017-03-25 13:53:51', NULL, NULL, 8004, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 13:53:51', 'admin-1490416195-14904212310229383', 1, 1, 'SR', NULL, NULL, NULL),
(24867, '2017-03-25 14:55:38', NULL, NULL, 8008, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:55:38', 'admin-1490422947-14904249378577315', 1, 0, '', 1, NULL, NULL),
(24868, '2017-03-25 14:38:23', NULL, NULL, 8005, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:38:23', 'admin-1490422947-1490423903446632', 1, 0, '', NULL, NULL, NULL),
(24869, '2017-03-25 14:09:56', NULL, NULL, 8007, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:09:56', 'admin-1490416195-14904221963437490', 1, 1, 'SR', NULL, NULL, NULL),
(24870, '2017-03-25 12:22:04', NULL, NULL, 7999, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1490422947', 'admin', '2017-03-25 12:22:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24871, '2017-03-25 12:22:39', NULL, NULL, 7999, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 12:22:39', 'admin-1490408968-14904157588239739', 1, 0, '', NULL, NULL, NULL),
(24872, '2017-03-25 12:22:39', NULL, NULL, 7999, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 12:22:39', 'admin-1490408968-14904157588239739', 1, 0, '', NULL, NULL, NULL),
(24873, '2017-03-25 12:22:39', NULL, NULL, 7999, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 12:22:39', 'admin-1490408968-14904157588239739', 1, 0, '', NULL, NULL, NULL),
(24874, '2017-03-25 09:31:32', NULL, NULL, 7986, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 09:31:32', 'admin-1490402245-14904054919399183', 1, 0, '', NULL, NULL, NULL),
(24875, '2017-03-25 09:31:32', NULL, NULL, 7986, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 09:31:32', 'admin-1490402245-14904054919399183', 1, 0, '', NULL, NULL, NULL),
(24876, '2017-03-25 09:31:32', NULL, NULL, 7986, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 09:31:32', 'admin-1490402245-14904054919399183', 1, 0, '', NULL, NULL, NULL),
(24877, '2017-03-25 18:07:36', NULL, NULL, 8018, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 18:07:36', 'admin-1490422947-14904364566783053', 1, 1, 'SR', 1, NULL, NULL),
(24878, '2017-03-25 14:23:19', NULL, NULL, 7997, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:23:19', 'admin-1490422947-14904229995899179', 1, 0, '', NULL, NULL, NULL),
(24879, '2017-03-25 13:04:34', NULL, NULL, 8001, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1490422947', 'admin', '2017-03-25 13:04:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24880, '2017-03-25 13:04:49', NULL, NULL, 8001, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 13:04:49', 'admin-1490416195-14904182888754839', 1, 1, 'SR', NULL, NULL, NULL),
(24881, '2017-03-25 13:04:49', NULL, NULL, 8001, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 13:04:49', 'admin-1490416195-14904182888754839', 1, 0, '', NULL, NULL, NULL),
(24882, '2017-03-25 13:04:49', NULL, NULL, 8001, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 13:04:49', 'admin-1490416195-14904182888754839', 1, 1, 'SR', NULL, NULL, NULL),
(24883, '2017-03-25 13:04:49', NULL, NULL, 8001, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 13:04:49', 'admin-1490416195-14904182888754839', 1, 1, 'SR', NULL, NULL, NULL),
(24884, '2017-03-25 13:09:51', NULL, NULL, 8002, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1490422947', 'admin', '2017-03-25 13:09:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24885, '2017-03-25 13:10:02', NULL, NULL, 8002, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 13:10:02', 'admin-1490416195-14904186022936850', 1, 1, 'SR', NULL, NULL, NULL),
(24886, '2017-03-25 13:11:24', NULL, NULL, 8002, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 13:11:24', 'admin-1490416195-14904186840279499', 1, 1, 'SR', NULL, NULL, NULL),
(24887, '2017-03-25 17:46:13', NULL, NULL, 8017, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 17:46:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24888, '2017-03-25 17:46:25', NULL, NULL, 8017, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 17:46:25', 'admin-1490422947-14904351849856637', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(24889, '2017-03-25 17:43:04', NULL, NULL, 8012, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 17:43:04', 'admin-1490422947-1490434984215795', 1, 0, '', NULL, NULL, NULL),
(24890, '2017-03-25 15:57:07', NULL, NULL, 8013, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 15:57:07', 'admin-1490422947-14904286277215991', 1, 1, 'SR', NULL, NULL, NULL),
(24891, '2017-03-25 15:57:07', NULL, NULL, 8013, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 15:57:07', 'admin-1490422947-14904286277215991', 1, 1, 'SR', NULL, NULL, NULL),
(24892, '2017-03-25 15:59:31', NULL, NULL, 8012, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 15:59:31', 'admin-1490422947-14904287709062335', 1, 0, '', NULL, NULL, NULL),
(24893, '2017-03-25 16:03:21', NULL, NULL, 8014, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1490422947', 'admin', '2017-03-25 16:03:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24894, '2017-03-25 16:03:35', NULL, NULL, 8014, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 16:03:35', 'admin-1490422947-14904290152125069', 1, 1, 'SR', NULL, NULL, NULL),
(24895, '2017-03-25 16:03:35', NULL, NULL, 8014, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 16:03:35', 'admin-1490422947-14904290152125069', 1, 0, '', NULL, NULL, NULL),
(24896, '2017-03-25 16:04:40', NULL, NULL, 8014, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 16:04:40', 'admin-1490422947-1490429079745423', 1, 0, '', NULL, NULL, NULL),
(24897, '2017-03-25 16:04:44', NULL, NULL, 8015, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1490422947', 'admin', '2017-03-25 16:04:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24898, '2017-03-25 16:04:55', NULL, NULL, 8015, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 16:04:55', 'admin-1490422947-14904290952571318', 1, 1, 'SR', NULL, NULL, NULL),
(24899, '2017-03-25 16:04:55', NULL, NULL, 8015, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 16:04:55', 'admin-1490422947-14904290952571318', 1, 1, 'SR', NULL, NULL, NULL),
(24900, '2017-03-25 16:05:47', NULL, NULL, 8015, 0, 181, '116', 'Open Food ', 'SCONE', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 16:05:47', 'admin-1490422947-1490429147079771', 1, 0, '', NULL, NULL, NULL),
(24901, '2017-03-25 17:23:04', NULL, NULL, 8016, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 17:23:04', 'admin-1490422947-14904337842499951', 1, 1, 'SR', 1, NULL, NULL),
(24902, '2017-03-25 17:23:13', NULL, NULL, 8016, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 17:23:13', 'admin-1490422947-14904337928754719', 1, 1, 'SR', 1, NULL, NULL),
(24903, '2017-03-25 15:07:08', NULL, NULL, 8011, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1490422947', 'admin', '2017-03-25 15:07:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24904, '2017-03-25 15:07:17', NULL, NULL, 8011, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 15:07:17', 'admin-1490422947-14904256369148014', 1, 1, 'SR', NULL, NULL, NULL),
(24905, '2017-03-25 15:50:00', NULL, NULL, 8012, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1490422947', 'admin', '2017-03-25 15:50:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24906, '2017-03-25 15:50:09', NULL, NULL, 8012, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 15:50:09', 'admin-1490422947-1490428208889448', 1, 1, 'SR', NULL, NULL, NULL),
(24907, '2017-03-25 15:57:07', NULL, NULL, 8013, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 15:57:07', 'admin-1490422947-14904286277215991', 1, 1, 'SR', NULL, NULL, NULL),
(24908, '2017-03-25 00:00:00', NULL, NULL, 8010, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:09:56', 'admin-1490416195-14904221963437490', 1, 1, 'SR', NULL, NULL, NULL),
(24909, '2017-03-25 14:23:19', NULL, NULL, 7997, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:23:19', 'admin-1490422947-14904229995899179', 1, 0, '', NULL, NULL, NULL),
(24910, '2017-03-25 17:43:04', NULL, NULL, 8012, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 17:43:04', 'admin-1490422947-1490434984215795', 1, 0, '', NULL, NULL, NULL),
(24911, '2017-03-25 15:56:09', NULL, NULL, 8013, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1490422947', 'admin', '2017-03-25 15:56:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24912, '2017-03-25 15:57:07', NULL, NULL, 8013, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 15:57:07', 'admin-1490422947-14904286277215991', 1, 1, 'SR', NULL, NULL, NULL),
(24913, '2017-03-25 14:23:19', NULL, NULL, 7997, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:23:19', 'admin-1490422947-14904229995899179', 1, 1, 'SR', NULL, NULL, NULL),
(24914, '2017-03-25 14:22:37', NULL, NULL, 8003, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:22:37', 'admin-1490422947-149042295715138', 1, 1, 'SR', NULL, NULL, NULL),
(24915, '2017-03-25 00:00:00', NULL, NULL, 8010, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:09:23', 'admin-1490416195-14904221629763425', 1, 1, 'SR', NULL, NULL, NULL),
(24916, '2017-03-25 14:55:38', NULL, NULL, 8008, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:55:38', 'admin-1490422947-14904249378577315', 1, 0, '', 1, NULL, NULL),
(24917, '2017-03-25 14:02:52', NULL, NULL, 8006, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:02:52', 'admin-1490416195-14904217719841321', 1, 1, 'SR', NULL, NULL, NULL),
(24918, '2017-03-25 14:08:39', NULL, NULL, 8007, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:08:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24919, '2017-03-25 00:00:00', NULL, NULL, 8009, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:09:56', 'admin-1490416195-14904221963437490', 1, 1, 'SR', NULL, NULL, NULL),
(24920, '2017-03-25 15:05:50', NULL, NULL, 8010, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1490422947', 'admin', '2017-03-25 15:05:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24921, '2017-03-25 14:09:23', NULL, NULL, 8007, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:09:23', 'admin-1490416195-14904221629763425', 1, 1, 'SR', NULL, NULL, NULL),
(24922, '2017-03-25 12:40:07', NULL, NULL, 7999, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 12:40:07', 'admin-1490416195-14904168070692359', 1, 0, '', NULL, NULL, NULL),
(24923, '2017-03-25 00:00:00', NULL, NULL, 8009, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:15:56', 'admin-1490416195-14904225566378930', 1, 0, '', NULL, NULL, NULL),
(24924, '2017-03-25 14:23:19', NULL, NULL, 7997, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:23:19', 'admin-1490422947-14904229995899179', 1, 0, '', NULL, NULL, NULL),
(24925, '2017-03-25 15:05:05', NULL, NULL, 8009, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1490422947', 'admin', '2017-03-25 15:05:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24926, '2017-03-25 14:02:41', NULL, NULL, 8005, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:02:41', 'admin-1490416195-14904217616558341', 1, 1, 'SR', NULL, NULL, NULL),
(24927, '2017-03-25 14:02:46', NULL, NULL, 8006, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:02:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24928, '2017-03-25 14:02:41', NULL, NULL, 8005, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:02:41', 'admin-1490416195-14904217616558341', 1, 1, 'SR', NULL, NULL, NULL),
(24929, '2017-03-25 14:01:58', NULL, NULL, 8005, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:01:58', 'admin-1490416195-14904217183205343', 1, 0, '', NULL, NULL, NULL),
(24930, '2017-03-25 14:01:58', NULL, NULL, 8005, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:01:58', 'admin-1490416195-14904217183205343', 1, 0, '', NULL, NULL, NULL),
(24931, '2017-03-25 14:01:58', NULL, NULL, 8005, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:01:58', 'admin-1490416195-14904217183205343', 1, 1, 'SR', NULL, NULL, NULL),
(24932, '2017-03-25 14:00:58', NULL, NULL, 8003, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:00:58', 'admin-1490416195-1490421657935455', 1, 1, 'SR', NULL, NULL, NULL),
(24933, '2017-03-25 14:01:28', NULL, NULL, 8005, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1490422947', 'admin', '2017-03-25 14:01:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24934, '2017-03-25 12:06:51', NULL, NULL, 7998, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1490422947', 'admin', '2017-03-25 12:06:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24935, '2017-03-25 09:32:25', NULL, NULL, 7986, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 09:32:25', 'admin-1490402245-14904055455548681', 1, 1, 'SR', NULL, NULL, NULL),
(24936, '2017-03-25 09:32:25', NULL, NULL, 7986, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 09:32:25', 'admin-1490402245-14904055455548681', 1, 1, 'SR', NULL, NULL, NULL),
(24937, '2017-03-25 09:32:25', NULL, NULL, 7986, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 09:32:25', 'admin-1490402245-14904055455548681', 1, 1, 'SR', NULL, NULL, NULL),
(24938, '2017-03-25 09:35:11', NULL, NULL, 7986, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 09:35:11', 'admin-1490402245-14904057109518093', 1, 0, '', NULL, NULL, NULL),
(24939, '2017-03-25 09:35:18', NULL, NULL, 7986, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 09:35:18', 'admin-1490402245-14904057187702049', 1, 1, 'SR', NULL, NULL, NULL),
(24940, '2017-03-25 09:48:26', NULL, NULL, 7987, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1490422947', 'admin', '2017-03-25 09:48:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24941, '2017-03-25 09:48:35', NULL, NULL, 7987, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 09:48:35', 'admin-1490402245-14904065156403143', 1, 0, '', NULL, NULL, NULL),
(24942, '2017-03-25 09:48:49', NULL, NULL, 7987, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 09:48:49', 'admin-1490402245-14904065296575829', 1, 1, 'SR', NULL, NULL, NULL),
(24943, '2017-03-25 10:24:52', NULL, NULL, 7988, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1490422947', 'admin', '2017-03-25 10:24:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24944, '2017-03-25 10:25:10', NULL, NULL, 7988, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 10:25:10', 'admin-1490402245-14904087098203782', 1, 0, '', NULL, NULL, NULL),
(24945, '2017-03-25 10:25:10', NULL, NULL, 7988, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 10:25:10', 'admin-1490402245-14904087098203782', 1, 0, '', NULL, NULL, NULL),
(24946, '2017-03-25 10:25:10', NULL, NULL, 7988, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 10:25:10', 'admin-1490402245-14904087098203782', 1, 0, '', NULL, NULL, NULL),
(24947, '2017-03-25 10:28:54', NULL, NULL, 7988, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 10:28:54', 'admin-1490402245-14904089343363362', 1, 0, '', NULL, NULL, NULL),
(24948, '2017-03-25 10:25:30', NULL, NULL, 7988, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 10:25:30', 'admin-1490402245-1490408730081863', 1, 1, 'SR', NULL, NULL, NULL),
(24949, '2017-03-25 10:25:30', NULL, NULL, 7988, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 10:25:30', 'admin-1490402245-1490408730081863', 1, 1, 'SR', NULL, NULL, NULL),
(24950, '2017-03-25 10:31:16', NULL, NULL, 7989, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1490422947', 'admin', '2017-03-25 10:31:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24951, '2017-03-25 10:31:21', NULL, NULL, 7989, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 10:31:21', 'admin-1490408968-14904090812221258', 1, 1, 'SR', NULL, NULL, NULL),
(24952, '2017-03-25 11:10:35', NULL, NULL, 7990, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:10:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24953, '2017-03-25 11:10:46', NULL, NULL, 7990, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:10:46', 'admin-1490408968-14904114463392936', 1, 1, 'SR', NULL, NULL, NULL),
(24954, '2017-03-25 12:30:25', NULL, NULL, 8000, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 12:30:25', 'admin-1490416195-1490416225525831', 1, 1, 'SR', NULL, NULL, NULL),
(24955, '2017-03-25 12:30:25', NULL, NULL, 8000, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 12:30:25', 'admin-1490416195-1490416225525831', 1, 1, 'SR', NULL, NULL, NULL),
(24956, '2017-03-25 12:30:25', NULL, NULL, 8000, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 12:30:25', 'admin-1490416195-1490416225525831', 1, 1, 'SR', NULL, NULL, NULL),
(24957, '2017-03-25 12:30:16', NULL, NULL, 8000, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1490422947', 'admin', '2017-03-25 12:30:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24958, '2017-03-25 12:29:43', NULL, NULL, 7995, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 12:29:43', 'admin-1490408968-14904161833475468', 1, 1, 'SR', NULL, NULL, NULL),
(24959, '2017-03-25 12:22:39', NULL, NULL, 7999, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 12:22:39', 'admin-1490408968-14904157588239739', 1, 0, '', NULL, NULL, NULL),
(24960, '2017-03-25 11:50:11', NULL, NULL, 7995, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:50:11', 'admin-1490408968-14904138113906389', 1, 1, 'SR', NULL, NULL, NULL),
(24961, '2017-03-25 11:42:30', NULL, NULL, 7994, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:42:30', 'admin-1490408968-1490413350157841', 1, 1, 'SR', 1, NULL, NULL),
(24962, '2017-03-25 11:42:30', NULL, NULL, 7994, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:42:30', 'admin-1490408968-1490413350157841', 1, 1, 'SR', 1, NULL, NULL),
(24963, '2017-03-25 11:50:11', NULL, NULL, 7995, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:50:11', 'admin-1490408968-14904138113906389', 1, 1, 'SR', NULL, NULL, NULL),
(24964, '2017-03-25 11:50:11', NULL, NULL, 7995, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:50:11', 'admin-1490408968-14904138113906389', 1, 0, '', NULL, NULL, NULL),
(24965, '2017-03-25 11:51:47', NULL, NULL, 7996, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:51:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24966, '2017-03-25 11:52:01', NULL, NULL, 7996, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:52:01', 'admin-1490408968-14904139217292673', 1, 1, 'SR', NULL, NULL, NULL),
(24967, '2017-03-25 11:52:01', NULL, NULL, 7996, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:52:01', 'admin-1490408968-14904139217292673', 1, 1, 'SR', NULL, NULL, NULL),
(24968, '2017-03-25 11:53:28', NULL, NULL, 7997, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.05, 0.0000, 0.0000, 15.05, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:53:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24969, '2017-03-25 11:53:39', NULL, NULL, 7997, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:53:39', 'admin-1490408968-14904140190999385', 1, 1, 'SR', NULL, NULL, NULL),
(24970, '2017-03-25 11:53:39', NULL, NULL, 7997, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:53:39', 'admin-1490408968-14904140190999385', 1, 1, 'SR', NULL, NULL, NULL),
(24971, '2017-03-25 11:53:39', NULL, NULL, 7997, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:53:39', 'admin-1490408968-14904140190999385', 1, 0, '', NULL, NULL, NULL),
(24972, '2017-03-25 11:53:39', NULL, NULL, 7997, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:53:39', 'admin-1490408968-14904140190999385', 1, 1, 'SR', NULL, NULL, NULL),
(24973, '2017-03-25 11:53:39', NULL, NULL, 7997, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:53:39', 'admin-1490408968-14904140190999385', 1, 1, 'SR', NULL, NULL, NULL),
(24974, '2017-03-25 11:53:58', NULL, NULL, 7997, 0, 181, '116', 'Open Food ', 'scone promo', 'Meals', 'Perfect Meals', 1, 4.50, 4.5000, 0.0000, 4.50, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:53:58', 'admin-1490408968-14904140381918117', 1, 0, '', NULL, NULL, NULL),
(24975, '2017-03-25 11:54:38', NULL, NULL, 7996, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:54:38', 'admin-1490408968-14904140779834653', 1, 0, '', NULL, NULL, NULL),
(24976, '2017-03-25 12:01:14', NULL, NULL, 7996, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 12:01:14', 'admin-1490408968-14904144739696950', 1, 1, 'SR', NULL, NULL, NULL),
(24977, '2017-03-25 12:06:12', NULL, NULL, 7995, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 12:06:12', 'admin-1490408968-1490414772246306', 1, 0, '', NULL, NULL, NULL),
(24978, '2017-03-25 12:06:12', NULL, NULL, 7995, 0, 181, '116', 'Open Food ', 'scone promo', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 12:06:12', 'admin-1490408968-1490414772246306', 1, 0, '', NULL, NULL, NULL),
(24979, '2017-03-25 11:32:16', NULL, NULL, 7991, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:32:16', 'admin-1490408968-14904127362281465', 1, 1, 'SR', NULL, NULL, NULL),
(24980, '2017-03-25 11:32:16', NULL, NULL, 7991, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:32:16', 'admin-1490408968-14904127362281465', 1, 1, 'SR', NULL, NULL, NULL),
(24981, '2017-03-25 12:07:14', NULL, NULL, 7998, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 12:07:14', 'admin-1490408968-14904148344568391', 1, 0, '', NULL, NULL, NULL),
(24982, '2017-03-25 12:09:57', NULL, NULL, 7998, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 12:09:57', 'admin-1490408968-14904149972014621', 1, 0, '', NULL, NULL, NULL),
(24983, '2017-03-25 12:07:14', NULL, NULL, 7998, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 12:07:14', 'admin-1490408968-14904148344568391', 1, 1, 'SR', NULL, NULL, NULL),
(24984, '2017-03-25 11:32:16', NULL, NULL, 7991, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:32:16', 'admin-1490408968-14904127362281465', 1, 1, 'SR', NULL, NULL, NULL),
(24985, '2017-03-25 11:32:16', NULL, NULL, 7991, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:32:16', 'admin-1490408968-14904127362281465', 1, 1, 'SR', NULL, NULL, NULL),
(24986, '2017-03-25 09:07:53', NULL, NULL, 7985, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 09:07:53', 'admin-1490402245-14904040737279537', 1, 0, '', NULL, NULL, NULL),
(24987, '2017-03-25 09:07:53', NULL, NULL, 7985, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 09:07:53', 'admin-1490402245-14904040737279537', 1, 0, '', NULL, NULL, NULL),
(24988, '2017-03-25 09:08:17', NULL, NULL, 7985, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 09:08:17', 'admin-1490402245-1490404097678655', 1, 1, 'SR', NULL, NULL, NULL),
(24989, '2017-03-25 09:08:17', NULL, NULL, 7985, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 09:08:17', 'admin-1490402245-1490404097678655', 1, 1, 'SR', NULL, NULL, NULL),
(24990, '2017-03-25 11:43:07', NULL, NULL, 7990, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:43:07', 'admin-1490408968-14904133873143364', 1, 1, 'SR', NULL, NULL, NULL),
(24991, '2017-03-25 11:49:56', NULL, NULL, 7995, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:49:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24992, '2017-03-25 11:10:46', NULL, NULL, 7990, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:10:46', 'admin-1490408968-14904114463392936', 1, 1, 'SR', NULL, NULL, NULL),
(24993, '2017-03-25 11:30:35', NULL, NULL, 7987, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:30:35', 'admin-1490408968-14904126351443375', 1, 1, 'SR', NULL, NULL, NULL),
(24994, '2017-03-25 11:31:30', NULL, NULL, 7991, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:31:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24995, '2017-03-25 11:32:16', NULL, NULL, 7991, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:32:16', 'admin-1490408968-14904127362281465', 1, 0, '', NULL, NULL, NULL),
(24996, '2017-03-25 11:32:16', NULL, NULL, 7991, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 11:32:16', 'admin-1490408968-14904127362281465', 1, 0, '', NULL, NULL, NULL),
(24997, '2017-03-25 09:08:25', NULL, NULL, 7985, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1490422947', 'admin', '2017-03-25 09:08:25', 'admin-1490402245-14904041054657153', 1, 0, '', NULL, NULL, NULL),
(24998, '2017-03-25 09:31:12', NULL, NULL, 7986, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1490422947', 'admin', '2017-03-25 09:31:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(24999, '2017-03-25 09:07:40', NULL, NULL, 7985, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1490422947', 'admin', '2017-03-25 09:07:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25000, '2017-03-26 14:07:18', NULL, NULL, 8049, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1490506376', 'admin', '2017-03-26 14:07:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25001, '2017-03-26 14:07:34', NULL, NULL, 8049, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 14:07:34', 'admin-1490506376-14905084543802962', 1, 0, '', NULL, NULL, NULL),
(25002, '2017-03-26 14:14:41', NULL, NULL, 8049, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 14:14:41', 'admin-1490506376-14905088812783513', 1, 1, 'SR', NULL, NULL, NULL),
(25003, '2017-03-26 14:28:04', NULL, NULL, 8050, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1490506376', 'admin', '2017-03-26 14:28:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25004, '2017-03-26 14:31:46', NULL, NULL, 8050, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 14:31:46', 'admin-1490506376-14905099063528762', 1, 0, '', NULL, NULL, NULL),
(25005, '2017-03-26 14:31:46', NULL, NULL, 8050, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 14:31:46', 'admin-1490506376-14905099063528762', 1, 0, '', NULL, NULL, NULL),
(25006, '2017-03-26 14:31:46', NULL, NULL, 8050, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 14:31:46', 'admin-1490506376-14905099063528762', 1, 0, '', NULL, NULL, NULL),
(25007, '2017-03-26 14:32:06', NULL, NULL, 8050, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 14:32:06', 'admin-1490506376-1490509926212396', 1, 0, '', NULL, NULL, NULL),
(25008, '2017-03-26 14:32:06', NULL, NULL, 8050, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 14:32:06', 'admin-1490506376-1490509926212396', 1, 1, 'SR', NULL, NULL, NULL),
(25009, '2017-03-26 14:32:06', NULL, NULL, 8050, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 14:32:06', 'admin-1490506376-1490509926212396', 1, 0, '', NULL, NULL, NULL),
(25010, '2017-03-26 12:43:00', NULL, NULL, 8037, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:43:00', 'admin-1490503360-14905033806781538', 1, 1, 'SR', NULL, NULL, NULL),
(25011, '2017-03-26 13:43:16', NULL, NULL, 8043, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.80, 0.0000, 0.0000, 9.80, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:43:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25012, '2017-03-26 13:44:41', NULL, NULL, 8043, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:44:41', 'admin-1490506376-14905070808792763', 1, 0, '', NULL, NULL, NULL),
(25013, '2017-03-26 13:44:41', NULL, NULL, 8043, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:44:41', 'admin-1490506376-14905070808792763', 1, 0, '', NULL, NULL, NULL),
(25014, '2017-03-26 11:20:20', NULL, NULL, 8029, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 11:20:20', 'admin-1490493485-1490498419902416', 1, 0, '', NULL, NULL, NULL),
(25015, '2017-03-26 09:16:16', NULL, NULL, 8020, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:16:16', 'admin-1490490760-14904909766815553', 1, 1, 'SR', NULL, NULL, NULL),
(25016, '2017-03-26 09:16:16', NULL, NULL, 8020, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:16:16', 'admin-1490490760-14904909766815553', 1, 1, 'SR', NULL, NULL, NULL),
(25017, '2017-03-26 09:16:16', NULL, NULL, 8020, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:16:16', 'admin-1490490760-14904909766815553', 1, 1, 'SR', NULL, NULL, NULL),
(25018, '2017-03-26 14:57:37', NULL, NULL, 8051, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 14:57:37', 'admin-1490506376-1490511457287533', 1, 1, 'SR', 1, NULL, NULL),
(25019, '2017-03-26 13:51:54', NULL, NULL, 8043, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:51:54', 'admin-1490506376-14905075142751231', 1, 1, 'SR', NULL, NULL, NULL),
(25020, '2017-03-26 12:54:40', NULL, NULL, 8039, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:54:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25021, '2017-03-26 13:00:27', NULL, NULL, 8038, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:00:27', 'admin-1490503360-14905044272689934', 1, 1, 'SR', NULL, NULL, NULL),
(25022, '2017-03-26 11:20:20', NULL, NULL, 8029, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 11:20:20', 'admin-1490493485-1490498419902416', 1, 0, '', NULL, NULL, NULL),
(25023, '2017-03-26 10:17:19', NULL, NULL, 8024, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 10:17:19', 'admin-1490493485-14904946396562627', 1, 0, '', NULL, NULL, NULL),
(25024, '2017-03-26 10:41:59', NULL, NULL, 8025, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 10:41:59', 'admin-1490493485-14904961190832112', 1, 0, '', NULL, NULL, NULL),
(25025, '2017-03-26 10:52:25', NULL, NULL, 8026, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 10:52:25', 'admin-1490493485-14904967448685278', 1, 1, 'SR', 1, NULL, NULL),
(25026, '2017-03-26 10:52:48', NULL, NULL, 8027, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 10:52:48', 'admin-1490493485-1490496768260473', 1, 1, 'SR', 1, NULL, NULL),
(25027, '2017-03-26 11:06:12', NULL, NULL, 8028, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1490506376', 'admin', '2017-03-26 11:06:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25028, '2017-03-26 11:06:28', NULL, NULL, 8028, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 11:06:28', 'admin-1490493485-1490497588152488', 1, 0, '', NULL, NULL, NULL),
(25029, '2017-03-26 13:57:14', NULL, NULL, 8048, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:57:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25030, '2017-03-26 13:57:19', NULL, NULL, 8048, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:57:19', 'admin-1490506376-14905078391663911', 1, 1, 'SR', NULL, NULL, NULL),
(25031, '2017-03-26 00:00:00', NULL, NULL, 8047, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:19:44', 'admin-1490493485-14905019844019680', 1, 0, '', NULL, NULL, NULL),
(25032, '2017-03-26 13:02:37', NULL, NULL, 8041, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:02:37', 'admin-1490503360-14905045573801966', 1, 1, 'SR', NULL, NULL, NULL),
(25033, '2017-03-26 13:02:37', NULL, NULL, 8041, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:02:37', 'admin-1490503360-14905045573801966', 1, 0, '', NULL, NULL, NULL),
(25034, '2017-03-26 13:12:13', NULL, NULL, 8042, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:12:13', 'admin-1490503360-14905051336043551', 1, 0, '', NULL, NULL, NULL),
(25035, '2017-03-26 13:12:13', NULL, NULL, 8042, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:12:13', 'admin-1490503360-14905051336043551', 1, 0, '', NULL, NULL, NULL),
(25036, '2017-03-26 13:12:13', NULL, NULL, 8042, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:12:13', 'admin-1490503360-14905051336043551', 1, 0, '', NULL, NULL, NULL),
(25037, '2017-03-26 13:12:24', NULL, NULL, 8042, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:12:24', 'admin-1490503360-14905051440233899', 1, 1, 'SR', NULL, NULL, NULL),
(25038, '2017-03-26 13:13:59', NULL, NULL, 8042, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:13:59', 'admin-1490503360-14905052391094956', 1, 0, '', NULL, NULL, NULL),
(25039, '2017-03-26 13:15:35', NULL, NULL, 8040, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:15:35', 'admin-1490503360-14905053351035741', 1, 0, '', NULL, NULL, NULL),
(25040, '2017-03-26 13:22:13', NULL, NULL, 8038, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:22:13', 'admin-1490503360-14905057335648488', 1, 1, 'SR', NULL, NULL, NULL),
(25041, '2017-03-26 13:22:57', NULL, NULL, 8037, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:22:57', 'admin-1490503360-14905057768684019', 1, 0, '', NULL, NULL, NULL),
(25042, '2017-03-26 13:44:41', NULL, NULL, 8043, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:44:41', 'admin-1490506376-14905070808792763', 1, 0, '', NULL, NULL, NULL),
(25043, '2017-03-26 13:45:22', NULL, NULL, 8043, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:45:22', 'admin-1490506376-14905071223207138', 1, 0, '', NULL, NULL, NULL),
(25044, '2017-03-26 13:02:12', NULL, NULL, 8041, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:02:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25045, '2017-03-26 13:02:37', NULL, NULL, 8041, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:02:37', 'admin-1490503360-14905045573801966', 1, 1, 'SR', NULL, NULL, NULL),
(25046, '2017-03-26 13:02:37', NULL, NULL, 8041, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:02:37', 'admin-1490503360-14905045573801966', 1, 1, 'SR', NULL, NULL, NULL),
(25047, '2017-03-26 00:00:00', NULL, NULL, 8047, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, NULL, NULL, 2.70, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:19:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25048, '2017-03-26 00:00:00', NULL, NULL, 8044, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, NULL, NULL, 6.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:50:29', 'admin-1490503360-14905038290947157', 1, 1, 'SR', NULL, NULL, NULL),
(25049, '2017-03-26 13:45:54', NULL, NULL, 8043, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:45:54', 'admin-1490506376-14905071540034048', 1, 0, '', NULL, NULL, NULL),
(25050, '2017-03-26 15:16:47', NULL, NULL, 8053, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1490506376', 'admin', '2017-03-26 15:16:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25051, '2017-03-26 15:16:51', NULL, NULL, 8053, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 15:16:51', 'admin-1490506376-14905126113953660', 1, 0, '', NULL, NULL, NULL),
(25052, '2017-03-26 15:16:51', NULL, NULL, 8053, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 15:16:51', 'admin-1490506376-14905126113953660', 1, 0, '', NULL, NULL, NULL),
(25053, '2017-03-26 15:22:17', NULL, NULL, 8054, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1490506376', 'admin', '2017-03-26 15:22:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25054, '2017-03-26 15:49:22', NULL, NULL, 8054, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 15:49:22', 'admin-1490506376-14905145623096063', 1, 0, '', NULL, NULL, NULL),
(25055, '2017-03-26 15:49:22', NULL, NULL, 8054, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 15:49:22', 'admin-1490506376-14905145623096063', 1, 0, '', NULL, NULL, NULL),
(25056, '2017-03-26 16:08:57', NULL, NULL, 8055, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1490506376', 'admin', '2017-03-26 16:08:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25057, '2017-03-26 16:09:47', NULL, NULL, 8055, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 16:09:47', 'admin-1490506376-1490515787660418', 1, 1, 'SR', NULL, NULL, NULL),
(25058, '2017-03-26 16:09:47', NULL, NULL, 8055, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 16:09:47', 'admin-1490506376-1490515787660418', 1, 1, 'SR', NULL, NULL, NULL),
(25059, '2017-03-26 17:13:15', NULL, NULL, 8056, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 17:13:15', 'admin-1490506376-14905195954423281', 1, 0, '', 1, NULL, NULL),
(25060, '2017-03-26 17:13:15', NULL, NULL, 8056, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 17:13:15', 'admin-1490506376-14905195954423281', 1, 0, '', 1, NULL, NULL),
(25061, '2017-03-26 13:45:22', NULL, NULL, 8043, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:45:22', 'admin-1490506376-14905071223207138', 1, 1, 'SR', NULL, NULL, NULL),
(25062, '2017-03-26 12:54:46', NULL, NULL, 8039, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:54:46', 'admin-1490503360-1490504086262131', 1, 1, 'SR', NULL, NULL, NULL),
(25063, '2017-03-26 13:32:50', NULL, NULL, 8040, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:32:50', 'admin-1490503360-14905063698599287', 1, 1, 'SR', NULL, NULL, NULL),
(25064, '2017-03-26 13:02:05', NULL, NULL, 8040, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:02:05', 'admin-1490503360-14905045252508998', 1, 0, '', NULL, NULL, NULL),
(25065, '2017-03-26 15:12:52', NULL, NULL, 8052, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 15:12:52', 'admin-1490506376-14905123720533688', 1, 0, '', 1, NULL, NULL),
(25066, '2017-03-26 13:11:54', NULL, NULL, 8042, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:11:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25067, '2017-03-26 13:00:27', NULL, NULL, 8038, 0, 181, '116', 'Open Food ', 'SET', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:00:27', 'admin-1490503360-14905044272689934', 1, 0, '', NULL, NULL, NULL),
(25068, '2017-03-26 13:12:13', NULL, NULL, 8042, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:12:13', 'admin-1490503360-14905051336043551', 1, 0, '', NULL, NULL, NULL),
(25069, '2017-03-26 13:01:09', NULL, NULL, 8040, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:01:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25070, '2017-03-26 13:02:05', NULL, NULL, 8040, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:02:05', 'admin-1490503360-14905045252508998', 1, 0, '', NULL, NULL, NULL),
(25071, '2017-03-26 13:02:05', NULL, NULL, 8040, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:02:05', 'admin-1490503360-14905045252508998', 1, 0, '', NULL, NULL, NULL),
(25072, '2017-03-26 12:54:46', NULL, NULL, 8039, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:54:46', 'admin-1490503360-1490504086262131', 1, 1, 'SR', NULL, NULL, NULL),
(25073, '2017-03-26 12:53:51', NULL, NULL, 8038, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:53:51', 'admin-1490503360-1490504031171351', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(25074, '2017-03-26 13:00:27', NULL, NULL, 8038, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:00:27', 'admin-1490503360-14905044272689934', 1, 1, 'SR', NULL, NULL, NULL),
(25075, '2017-03-26 12:53:51', NULL, NULL, 8038, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:53:51', 'admin-1490503360-1490504031171351', 1, 1, 'SR', NULL, NULL, NULL),
(25076, '2017-03-26 12:53:51', NULL, NULL, 8038, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:53:51', 'admin-1490503360-1490504031171351', 1, 0, '', NULL, NULL, NULL),
(25077, '2017-03-26 12:53:51', NULL, NULL, 8038, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:53:51', 'admin-1490503360-1490504031171351', 1, 0, '', NULL, NULL, NULL),
(25078, '2017-03-26 11:48:36', NULL, NULL, 8032, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 11:48:36', 'admin-1490493485-14905001161609949', 1, 0, '', NULL, NULL, NULL),
(25079, '2017-03-26 11:48:29', NULL, NULL, 8032, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1490506376', 'admin', '2017-03-26 11:48:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25080, '2017-03-26 12:53:51', NULL, NULL, 8038, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:53:51', 'admin-1490503360-1490504031171351', 1, 1, 'SR', NULL, NULL, NULL),
(25081, '2017-03-26 12:53:51', NULL, NULL, 8038, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:53:51', 'admin-1490503360-1490504031171351', 1, 1, 'SR', NULL, NULL, NULL),
(25082, '2017-03-26 12:53:51', NULL, NULL, 8038, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:53:51', 'admin-1490503360-1490504031171351', 1, 1, 'SR', NULL, NULL, NULL),
(25083, '2017-03-26 12:52:32', NULL, NULL, 8038, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:52:32', 'admin-1490503360-14905039520684672', 1, 1, 'SR', NULL, NULL, NULL),
(25084, '2017-03-26 12:52:32', NULL, NULL, 8038, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:52:32', 'admin-1490503360-14905039520684672', 1, 0, '', NULL, NULL, NULL),
(25085, '2017-03-26 12:43:00', NULL, NULL, 8037, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:43:00', 'admin-1490503360-14905033806781538', 1, 1, 'SR', NULL, NULL, NULL),
(25086, '2017-03-26 00:00:00', NULL, NULL, 8044, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:19:55', 'admin-1490493485-14905019952714847', 1, 1, 'SR', NULL, NULL, NULL),
(25087, '2017-03-26 12:52:00', NULL, NULL, 8038, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.00, 0.0000, 0.0000, 16.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:52:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25088, '2017-03-26 00:00:00', NULL, NULL, 8034, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 11:41:54', 'admin-1490493485-14904997140206444', 1, 0, '', NULL, NULL, NULL),
(25089, '2017-03-26 09:13:11', NULL, NULL, 8019, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:13:11', 'admin-1490490760-14904907910504198', 1, 0, '', NULL, NULL, NULL),
(25090, '2017-03-26 12:42:28', NULL, NULL, 8037, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:42:28', 'admin-1490493485-14905033481337128', 1, 0, '', NULL, NULL, NULL),
(25091, '2017-03-26 12:40:42', NULL, NULL, 8037, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:40:42', 'admin-1490493485-14905032423498281', 1, 0, '', NULL, NULL, NULL),
(25092, '2017-03-26 12:40:42', NULL, NULL, 8037, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:40:42', 'admin-1490493485-14905032423498281', 1, 1, 'SR', NULL, NULL, NULL),
(25093, '2017-03-26 12:40:42', NULL, NULL, 8037, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:40:42', 'admin-1490493485-14905032423498281', 1, 1, 'SR', NULL, NULL, NULL),
(25094, '2017-03-26 12:37:31', NULL, NULL, 8037, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:37:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25095, '2017-03-26 00:00:00', NULL, NULL, 8044, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:19:55', 'admin-1490493485-14905019952714847', 1, 0, '', NULL, NULL, NULL),
(25096, '2017-03-26 00:00:00', NULL, NULL, 8047, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:20:03', 'admin-1490493485-14905020031984555', 1, 1, 'SR', NULL, NULL, NULL),
(25097, '2017-03-26 00:00:00', NULL, NULL, 8044, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:19:44', 'admin-1490493485-14905019844019680', 1, 1, 'SR', NULL, NULL, NULL),
(25098, '2017-03-26 13:50:17', NULL, NULL, 8046, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:50:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25099, '2017-03-26 00:00:00', NULL, NULL, 8046, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:19:44', 'admin-1490493485-14905019844019680', 1, 1, 'SR', NULL, NULL, NULL),
(25100, '2017-03-26 13:49:05', NULL, NULL, 8044, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1490506376', 'admin', '2017-03-26 13:49:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25101, '2017-03-26 00:00:00', NULL, NULL, 8046, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:19:44', 'admin-1490493485-14905019844019680', 1, 1, 'SR', NULL, NULL, NULL),
(25102, '2017-03-26 12:13:25', NULL, NULL, 8035, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:13:25', 'admin-1490493485-14905016054559645', 1, 1, 'SR', NULL, NULL, NULL),
(25103, '2017-03-26 12:13:17', NULL, NULL, 8035, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:13:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25104, '2017-03-26 12:06:48', NULL, NULL, 8033, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1490506376', 'admin', '2017-03-26 12:06:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25105, '2017-03-26 11:46:52', NULL, NULL, 8031, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 11:46:52', 'admin-1490493485-14905000119965597', 1, 1, 'SR', NULL, NULL, NULL),
(25106, '2017-03-26 11:46:43', NULL, NULL, 8031, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 11:46:43', 'admin-1490493485-14905000035735949', 1, 0, '', NULL, NULL, NULL),
(25107, '2017-03-26 11:46:35', NULL, NULL, 8031, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1490506376', 'admin', '2017-03-26 11:46:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25108, '2017-03-26 00:00:00', NULL, NULL, 8034, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, NULL, NULL, 0.80, 1, '27', 1, '1490506376', 'admin', '2017-03-26 11:39:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25109, '2017-03-26 00:00:00', NULL, NULL, 8033, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 11:49:04', 'admin-1490493485-14905001445783397', 1, 0, '', NULL, NULL, NULL),
(25110, '2017-03-26 09:20:31', NULL, NULL, 8021, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:20:31', 'admin-1490490760-14904912310566928', 1, 0, '', NULL, NULL, NULL),
(25111, '2017-03-26 09:23:03', NULL, NULL, 8019, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:23:03', 'admin-1490490760-1490491383575109', 1, 0, '', NULL, NULL, NULL),
(25112, '2017-03-26 09:35:39', NULL, NULL, 8022, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:35:39', 'admin-1490490760-14904921395001063', 1, 1, 'SR', 1, NULL, NULL),
(25113, '2017-03-26 09:41:18', NULL, NULL, 8023, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:41:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25114, '2017-03-26 09:41:36', NULL, NULL, 8023, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:41:36', 'admin-1490490760-14904924957991451', 1, 0, '', NULL, NULL, NULL),
(25115, '2017-03-26 09:41:36', NULL, NULL, 8023, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:41:36', 'admin-1490490760-14904924957991451', 1, 1, 'SR', NULL, NULL, NULL),
(25116, '2017-03-26 09:46:05', NULL, NULL, 8024, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:46:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25117, '2017-03-26 09:46:23', NULL, NULL, 8024, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:46:23', 'admin-1490490760-14904927832282260', 1, 0, '', NULL, NULL, NULL),
(25118, '2017-03-26 09:46:23', NULL, NULL, 8024, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:46:23', 'admin-1490490760-14904927832282260', 1, 0, '', NULL, NULL, NULL),
(25119, '2017-03-26 09:46:31', NULL, NULL, 8024, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:46:31', 'admin-1490490760-14904927908189650', 1, 1, 'SR', NULL, NULL, NULL),
(25120, '2017-03-26 09:47:29', NULL, NULL, 8024, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:47:29', 'admin-1490490760-14904928495571015', 1, 1, 'SR', NULL, NULL, NULL),
(25121, '2017-03-26 09:53:19', NULL, NULL, 8019, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:53:19', 'admin-1490490760-14904931991807286', 1, 1, 'SR', NULL, NULL, NULL),
(25122, '2017-03-26 09:57:49', NULL, NULL, 8025, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.15, 0.0000, 0.0000, 5.15, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:57:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25123, '2017-03-26 09:57:57', NULL, NULL, 8025, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:57:57', 'admin-1490490760-14904934769501573', 1, 0, '', NULL, NULL, NULL),
(25124, '2017-03-26 09:59:01', NULL, NULL, 8025, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:59:01', 'admin-1490493485-14904935413746864', 1, 0, '', NULL, NULL, NULL),
(25125, '2017-03-26 09:59:01', NULL, NULL, 8025, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:59:01', 'admin-1490493485-14904935413746864', 1, 0, '', NULL, NULL, NULL),
(25126, '2017-03-26 09:59:01', NULL, NULL, 8025, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:59:01', 'admin-1490493485-14904935413746864', 1, 0, '', NULL, NULL, NULL),
(25127, '2017-03-26 09:59:01', NULL, NULL, 8025, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:59:01', 'admin-1490493485-14904935413746864', 1, 1, 'SR', NULL, NULL, NULL),
(25128, '2017-03-26 11:06:28', NULL, NULL, 8028, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 11:06:28', 'admin-1490493485-1490497588152488', 1, 0, '', NULL, NULL, NULL),
(25129, '2017-03-26 11:06:28', NULL, NULL, 8028, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 11:06:28', 'admin-1490493485-1490497588152488', 1, 0, '', NULL, NULL, NULL),
(25130, '2017-03-26 11:06:48', NULL, NULL, 8028, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 11:06:48', 'admin-1490493485-14904976086221451', 1, 1, 'SR', NULL, NULL, NULL),
(25131, '2017-03-26 11:06:48', NULL, NULL, 8028, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 11:06:48', 'admin-1490493485-14904976086221451', 1, 1, 'SR', NULL, NULL, NULL),
(25132, '2017-03-26 11:06:48', NULL, NULL, 8028, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 11:06:48', 'admin-1490493485-14904976086221451', 1, 1, 'SR', NULL, NULL, NULL),
(25133, '2017-03-26 11:19:56', NULL, NULL, 8029, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1490506376', 'admin', '2017-03-26 11:19:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25134, '2017-03-26 11:20:20', NULL, NULL, 8029, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 11:20:20', 'admin-1490493485-1490498419902416', 1, 0, '', NULL, NULL, NULL),
(25135, '2017-03-26 11:20:20', NULL, NULL, 8029, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 11:20:20', 'admin-1490493485-1490498419902416', 1, 0, '', NULL, NULL, NULL),
(25136, '2017-03-26 09:13:21', NULL, NULL, 8019, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:13:21', 'admin-1490490760-14904908017039315', 1, 1, 'SR', NULL, NULL, NULL),
(25137, '2017-03-26 09:15:14', NULL, NULL, 8020, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 19.30, 0.0000, 0.0000, 19.30, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:15:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25138, '2017-03-26 09:15:29', NULL, NULL, 8020, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:15:29', 'admin-1490490760-14904909296607699', 1, 0, '', NULL, NULL, NULL),
(25139, '2017-03-26 09:15:29', NULL, NULL, 8020, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:15:29', 'admin-1490490760-14904909296607699', 1, 0, '', NULL, NULL, NULL),
(25140, '2017-03-26 09:15:29', NULL, NULL, 8020, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:15:29', 'admin-1490490760-14904909296607699', 1, 0, '', NULL, NULL, NULL),
(25141, '2017-03-26 09:15:29', NULL, NULL, 8020, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:15:29', 'admin-1490490760-14904909296607699', 1, 0, '', NULL, NULL, NULL),
(25142, '2017-03-26 09:16:16', NULL, NULL, 8020, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 4, 15.00, 60.0000, 0.0000, 60.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:16:16', 'admin-1490490760-14904909766815553', 1, 0, '', NULL, NULL, NULL),
(25143, '2017-03-26 09:20:31', NULL, NULL, 8021, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:20:31', 'admin-1490490760-14904912310566928', 1, 0, '', NULL, NULL, NULL),
(25144, '2017-03-26 09:20:03', NULL, NULL, 8021, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:20:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25145, '2017-03-26 09:20:31', NULL, NULL, 8021, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:20:31', 'admin-1490490760-14904912310566928', 1, 0, '', NULL, NULL, NULL),
(25146, '2017-03-26 09:16:16', NULL, NULL, 8020, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:16:16', 'admin-1490490760-14904909766815553', 1, 1, 'SR', NULL, NULL, NULL),
(25147, '2017-03-26 09:16:16', NULL, NULL, 8020, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:16:16', 'admin-1490490760-14904909766815553', 1, 1, 'SR', NULL, NULL, NULL),
(25148, '2017-03-26 09:16:16', NULL, NULL, 8020, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:16:16', 'admin-1490490760-14904909766815553', 1, 1, 'SR', NULL, NULL, NULL),
(25149, '2017-03-26 09:16:16', NULL, NULL, 8020, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:16:16', 'admin-1490490760-14904909766815553', 1, 1, 'SR', NULL, NULL, NULL),
(25150, '2017-03-26 09:13:21', NULL, NULL, 8019, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:13:21', 'admin-1490490760-14904908017039315', 1, 1, 'SR', NULL, NULL, NULL),
(25151, '2017-03-26 09:13:11', NULL, NULL, 8019, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:13:11', 'admin-1490490760-14904907910504198', 1, 0, '', NULL, NULL, NULL),
(25152, '2017-03-26 09:12:58', NULL, NULL, 8019, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1490506376', 'admin', '2017-03-26 09:12:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25153, '2017-03-27 11:06:50', NULL, NULL, 8066, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 11:06:50', 'admin-1490583316-1490584010755391', 1, 1, 'SR', NULL, NULL, NULL),
(25154, '2017-03-27 10:01:59', NULL, NULL, 8059, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:01:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25155, '2017-03-27 10:02:03', NULL, NULL, 8059, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:02:03', 'admin-1490577124-14905801231132832', 1, 1, 'SR', NULL, NULL, NULL),
(25156, '2017-03-27 10:02:03', NULL, NULL, 8059, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:02:03', 'admin-1490577124-14905801231132832', 1, 1, 'SR', NULL, NULL, NULL),
(25157, '2017-03-27 10:02:05', NULL, NULL, 8060, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:02:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25158, '2017-03-27 10:02:08', NULL, NULL, 8060, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:02:08', 'admin-1490577124-14905801278599834', 1, 1, 'SR', NULL, NULL, NULL),
(25159, '2017-03-27 10:03:22', NULL, NULL, 8061, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:03:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25160, '2017-03-27 00:00:00', NULL, NULL, 8078, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 13:17:39', 'admin-1490583316-1490591859048273', 1, 0, '', NULL, NULL, NULL),
(25161, '2017-03-27 10:55:02', NULL, NULL, 8065, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:55:02', 'admin-1490577124-149058330204563', 1, 1, 'SR', NULL, NULL, NULL),
(25162, '2017-03-27 10:55:02', NULL, NULL, 8065, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:55:02', 'admin-1490577124-149058330204563', 1, 1, 'SR', NULL, NULL, NULL),
(25163, '2017-03-27 11:06:26', NULL, NULL, 8066, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1490600459', 'admin', '2017-03-27 11:06:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25164, '2017-03-27 11:06:37', NULL, NULL, 8066, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 11:06:37', 'admin-1490583316-1490583997428544', 1, 0, '', NULL, NULL, NULL),
(25165, '2017-03-27 11:06:37', NULL, NULL, 8066, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 11:06:37', 'admin-1490583316-1490583997428544', 1, 0, '', NULL, NULL, NULL),
(25166, '2017-03-27 11:06:37', NULL, NULL, 8066, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 11:06:37', 'admin-1490583316-1490583997428544', 1, 0, '', NULL, NULL, NULL),
(25167, '2017-03-27 11:06:50', NULL, NULL, 8066, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 11:06:50', 'admin-1490583316-1490584010755391', 1, 1, 'SR', NULL, NULL, NULL),
(25168, '2017-03-27 11:06:50', NULL, NULL, 8066, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 11:06:50', 'admin-1490583316-1490584010755391', 1, 1, 'SR', NULL, NULL, NULL),
(25169, '2017-03-27 19:38:38', NULL, NULL, 8085, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 19:38:38', 'admin-1490600459-14906147183001587', 1, 0, '', NULL, NULL, NULL),
(25170, '2017-03-27 00:00:00', NULL, NULL, 8078, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 14:23:14', 'admin-1490591865-14905957943847920', 1, 0, '', NULL, NULL, NULL),
(25171, '2017-03-27 17:31:41', NULL, NULL, 8081, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 17:31:41', 'admin-1490600459-14906071017994238', 1, 0, '', NULL, NULL, NULL),
(25172, '2017-03-27 17:31:41', NULL, NULL, 8081, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 17:31:41', 'admin-1490600459-14906071017994238', 1, 0, '', NULL, NULL, NULL),
(25173, '2017-03-27 18:01:43', NULL, NULL, 8082, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1490600459', 'admin', '2017-03-27 18:01:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25174, '2017-03-27 18:01:53', NULL, NULL, 8082, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 18:01:53', 'admin-1490600459-14906089136411542', 1, 0, '', NULL, NULL, NULL),
(25175, '2017-03-27 18:01:53', NULL, NULL, 8082, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 18:01:53', 'admin-1490600459-14906089136411542', 1, 0, '', NULL, NULL, NULL),
(25176, '2017-03-27 18:42:21', NULL, NULL, 8083, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1490600459', 'admin', '2017-03-27 18:42:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25177, '2017-03-27 18:42:39', NULL, NULL, 8083, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 18:42:39', 'admin-1490600459-14906113595331196', 1, 0, '', NULL, NULL, NULL),
(25178, '2017-03-27 18:42:39', NULL, NULL, 8083, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 18:42:39', 'admin-1490600459-14906113595331196', 1, 0, '', NULL, NULL, NULL),
(25179, '2017-03-27 18:42:39', NULL, NULL, 8083, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 18:42:39', 'admin-1490600459-14906113595331196', 1, 1, 'SR', NULL, NULL, NULL),
(25180, '2017-03-27 18:43:46', NULL, NULL, 8084, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 18:43:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25181, '2017-03-27 18:43:51', NULL, NULL, 8084, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 18:43:51', 'admin-1490600459-1490611431662827', 1, 1, 'SR', NULL, NULL, NULL),
(25182, '2017-03-27 18:43:51', NULL, NULL, 8084, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 18:43:51', 'admin-1490600459-1490611431662827', 1, 1, 'SR', NULL, NULL, NULL),
(25183, '2017-03-27 19:38:29', NULL, NULL, 8085, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1490600459', 'admin', '2017-03-27 19:38:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25184, '2017-03-27 19:38:38', NULL, NULL, 8085, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 19:38:38', 'admin-1490600459-14906147183001587', 1, 1, 'SR', NULL, NULL, NULL),
(25185, '2017-03-27 19:38:38', NULL, NULL, 8085, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 19:38:38', 'admin-1490600459-14906147183001587', 1, 1, 'SR', NULL, NULL, NULL),
(25186, '2017-03-27 17:23:31', NULL, NULL, 8081, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 17:23:31', 'admin-1490600459-149060661085267', 1, 1, 'SR', NULL, NULL, NULL),
(25187, '2017-03-27 17:23:31', NULL, NULL, 8081, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 17:23:31', 'admin-1490600459-149060661085267', 1, 0, '', NULL, NULL, NULL),
(25188, '2017-03-27 17:23:24', NULL, NULL, 8081, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1490600459', 'admin', '2017-03-27 17:23:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25189, '2017-03-27 16:23:37', NULL, NULL, 8080, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 16:23:37', 'admin-1490600459-14906030173299512', 1, 1, 'SR', NULL, NULL, NULL),
(25190, '2017-03-27 16:23:34', NULL, NULL, 8080, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1490600459', 'admin', '2017-03-27 16:23:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25191, '2017-03-27 00:00:00', NULL, NULL, 8079, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 14:23:14', 'admin-1490591865-14905957943847920', 1, 1, 'SR', NULL, NULL, NULL),
(25192, '2017-03-27 15:07:58', NULL, NULL, 8076, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 15:07:58', 'admin-1490591865-14905984787521257', 1, 1, 'SR', NULL, NULL, NULL),
(25193, '2017-03-27 15:34:23', NULL, NULL, 8076, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 15:34:23', 'admin-1490591865-14906000630191158', 1, 0, '', NULL, NULL, NULL),
(25194, '2017-03-27 15:41:09', NULL, NULL, 8075, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 15:41:09', 'admin-1490600459-14906004688271237', 1, 1, 'SR', NULL, NULL, NULL),
(25195, '2017-03-27 15:46:35', NULL, NULL, 8077, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1490600459', 'admin', '2017-03-27 15:46:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25196, '2017-03-27 15:46:41', NULL, NULL, 8077, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 15:46:41', 'admin-1490600459-14906008011365312', 1, 1, 'SR', NULL, NULL, NULL),
(25197, '2017-03-27 12:58:27', NULL, NULL, 8069, 0, 181, '116', 'Open Food ', 'set', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 12:58:27', 'admin-1490583316-14905907075746428', 1, 0, '', NULL, NULL, NULL),
(25198, '2017-03-27 12:26:48', NULL, NULL, 8067, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 12:26:48', 'admin-1490583316-1490588808051344', 1, 1, 'SR', NULL, NULL, NULL),
(25199, '2017-03-27 15:46:41', NULL, NULL, 8077, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 15:46:41', 'admin-1490600459-14906008011365312', 1, 0, '', NULL, NULL, NULL),
(25200, '2017-03-27 14:58:40', NULL, NULL, 8074, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 14:58:40', 'admin-1490591865-1490597920272369', 1, 1, 'SR', NULL, NULL, NULL),
(25201, '2017-03-27 15:07:55', NULL, NULL, 8076, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1490600459', 'admin', '2017-03-27 15:07:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25202, '2017-03-27 14:58:40', NULL, NULL, 8074, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 14:58:40', 'admin-1490591865-1490597920272369', 1, 1, 'SR', NULL, NULL, NULL),
(25203, '2017-03-27 14:58:27', NULL, NULL, 8075, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 14:58:27', 'admin-1490591865-1490597907577893', 1, 0, '', NULL, NULL, NULL),
(25204, '2017-03-27 14:25:13', NULL, NULL, 8074, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 14:25:13', 'admin-1490591865-14905959137905610', 1, 1, 'SR', NULL, NULL, NULL),
(25205, '2017-03-27 14:58:27', NULL, NULL, 8075, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 14:58:27', 'admin-1490591865-1490597907577893', 1, 0, '', NULL, NULL, NULL),
(25206, '2017-03-27 14:58:27', NULL, NULL, 8075, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 14:58:27', 'admin-1490591865-1490597907577893', 1, 1, 'SR', NULL, NULL, NULL),
(25207, '2017-03-27 14:58:20', NULL, NULL, 8075, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1490600459', 'admin', '2017-03-27 14:58:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25208, '2017-03-27 14:25:13', NULL, NULL, 8074, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 14:25:13', 'admin-1490591865-14905959137905610', 1, 0, '', NULL, NULL, NULL),
(25209, '2017-03-27 14:24:26', NULL, NULL, 8074, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 14:24:26', 'admin-1490591865-14905958661186050', 1, 1, 'SR', NULL, NULL, NULL),
(25210, '2017-03-27 14:24:26', NULL, NULL, 8074, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 14:24:26', 'admin-1490591865-14905958661186050', 1, 0, '', NULL, NULL, NULL),
(25211, '2017-03-27 15:50:37', NULL, NULL, 8078, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1490600459', 'admin', '2017-03-27 15:50:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25212, '2017-03-27 14:24:18', NULL, NULL, 8074, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 14:24:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25213, '2017-03-27 00:00:00', NULL, NULL, 8079, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 13:17:39', 'admin-1490583316-1490591859048273', 1, 0, '', NULL, NULL, NULL),
(25214, '2017-03-27 14:18:46', NULL, NULL, 8073, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1490600459', 'admin', '2017-03-27 14:18:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25215, '2017-03-27 14:18:55', NULL, NULL, 8073, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 14:18:55', 'admin-1490591865-14905955348406181', 1, 1, 'SR', NULL, NULL, NULL),
(25216, '2017-03-27 13:51:26', NULL, NULL, 8069, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 13:51:26', 'admin-1490591865-14905938861307198', 1, 1, 'SR', NULL, NULL, NULL),
(25217, '2017-03-27 13:37:16', NULL, NULL, 8072, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 13:37:16', 'admin-1490591865-14905930364486630', 1, 1, 'SR', NULL, NULL, NULL),
(25218, '2017-03-27 00:00:00', NULL, NULL, 8079, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, NULL, NULL, 2.50, 1, '27', 1, '1490600459', 'admin', '2017-03-27 13:17:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25219, '2017-03-27 13:37:12', NULL, NULL, 8072, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1490600459', 'admin', '2017-03-27 13:37:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25220, '2017-03-27 13:06:32', NULL, NULL, 8070, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 13:06:32', 'admin-1490583316-1490591192281365', 1, 0, '', NULL, NULL, NULL),
(25221, '2017-03-27 13:06:32', NULL, NULL, 8070, 0, 181, '116', 'Open Food ', 'set', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 13:06:32', 'admin-1490583316-1490591192281365', 1, 0, '', NULL, NULL, NULL),
(25222, '2017-03-27 13:06:32', NULL, NULL, 8070, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 13:06:32', 'admin-1490583316-1490591192281365', 1, 0, '', NULL, NULL, NULL),
(25223, '2017-03-27 13:06:12', NULL, NULL, 8070, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1490600459', 'admin', '2017-03-27 13:06:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25224, '2017-03-27 12:58:27', NULL, NULL, 8069, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 12:58:27', 'admin-1490583316-14905907075746428', 1, 0, '', NULL, NULL, NULL),
(25225, '2017-03-27 12:58:13', NULL, NULL, 8069, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 12:58:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25226, '2017-03-27 12:56:23', NULL, NULL, 8068, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 12:56:23', 'admin-1490583316-14905905834512797', 1, 1, 'SR', NULL, NULL, NULL),
(25227, '2017-03-27 12:56:12', NULL, NULL, 8068, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1490600459', 'admin', '2017-03-27 12:56:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25228, '2017-03-27 12:56:23', NULL, NULL, 8068, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 12:56:23', 'admin-1490583316-14905905834512797', 1, 1, 'SR', NULL, NULL, NULL),
(25229, '2017-03-27 10:11:49', NULL, NULL, 8062, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:11:49', 'admin-1490577124-14905807088508627', 1, 1, 'SR', NULL, NULL, NULL),
(25230, '2017-03-27 10:34:16', NULL, NULL, 8063, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:34:16', 'admin-1490577124-14905820567549010', 1, 0, '', 1, NULL, NULL),
(25231, '2017-03-27 10:34:16', NULL, NULL, 8063, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:34:16', 'admin-1490577124-14905820567549010', 1, 0, '', 1, NULL, NULL),
(25232, '2017-03-27 10:34:16', NULL, NULL, 8063, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:34:16', 'admin-1490577124-14905820567549010', 1, 0, '', 1, NULL, NULL),
(25233, '2017-03-27 10:34:16', NULL, NULL, 8063, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:34:16', 'admin-1490577124-14905820567549010', 1, 0, '', 1, NULL, NULL),
(25234, '2017-03-27 10:34:16', NULL, NULL, 8063, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:34:16', 'admin-1490577124-14905820567549010', 1, 0, '', 1, NULL, NULL),
(25235, '2017-03-27 10:34:16', NULL, NULL, 8063, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:34:16', 'admin-1490577124-14905820567549010', 1, 0, '', 1, NULL, NULL),
(25236, '2017-03-27 10:45:34', NULL, NULL, 8064, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.00, 0.0000, 0.0000, 11.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:45:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25237, '2017-03-27 10:45:55', NULL, NULL, 8064, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:45:55', 'admin-1490577124-14905827549812017', 1, 0, '', NULL, NULL, NULL),
(25238, '2017-03-27 10:45:55', NULL, NULL, 8064, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:45:55', 'admin-1490577124-14905827549812017', 1, 0, '', NULL, NULL, NULL),
(25239, '2017-03-27 10:45:55', NULL, NULL, 8064, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:45:55', 'admin-1490577124-14905827549812017', 1, 0, '', NULL, NULL, NULL),
(25240, '2017-03-27 10:45:55', NULL, NULL, 8064, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:45:55', 'admin-1490577124-14905827549812017', 1, 0, '', NULL, NULL, NULL),
(25241, '2017-03-27 10:45:55', NULL, NULL, 8064, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:45:55', 'admin-1490577124-14905827549812017', 1, 0, '', NULL, NULL, NULL),
(25242, '2017-03-27 10:45:55', NULL, NULL, 8064, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:45:55', 'admin-1490577124-14905827549812017', 1, 1, 'SR', NULL, NULL, NULL),
(25243, '2017-03-27 10:45:55', NULL, NULL, 8064, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:45:55', 'admin-1490577124-14905827549812017', 1, 1, 'SR', NULL, NULL, NULL),
(25244, '2017-03-27 10:45:55', NULL, NULL, 8064, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:45:55', 'admin-1490577124-14905827549812017', 1, 0, '', NULL, NULL, NULL),
(25245, '2017-03-27 10:45:55', NULL, NULL, 8064, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:45:55', 'admin-1490577124-14905827549812017', 1, 0, '', NULL, NULL, NULL),
(25246, '2017-03-27 10:54:44', NULL, NULL, 8065, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:54:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25247, '2017-03-27 10:55:02', NULL, NULL, 8065, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:55:02', 'admin-1490577124-149058330204563', 1, 0, '', NULL, NULL, NULL),
(25248, '2017-03-27 10:55:02', NULL, NULL, 8065, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:55:02', 'admin-1490577124-149058330204563', 1, 0, '', NULL, NULL, NULL),
(25249, '2017-03-27 12:26:48', NULL, NULL, 8067, 0, 181, '116', 'Open Food ', 'set', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 12:26:48', 'admin-1490583316-1490588808051344', 1, 0, '', NULL, NULL, NULL),
(25250, '2017-03-27 12:26:48', NULL, NULL, 8067, 0, 75, '75', 'Meatless Aglio Olio ', 'sausage', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 12:26:48', 'admin-1490583316-1490588808051344', 1, 0, '', NULL, NULL, NULL),
(25251, '2017-03-27 12:26:02', NULL, NULL, 8067, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1490600459', 'admin', '2017-03-27 12:26:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25252, '2017-03-27 09:17:02', NULL, NULL, 8057, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 09:17:02', 'admin-1490577124-14905774221728949', 1, 1, 'SR', NULL, NULL, NULL),
(25253, '2017-03-27 09:17:02', NULL, NULL, 8057, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 09:17:02', 'admin-1490577124-14905774221728949', 1, 1, 'SR', NULL, NULL, NULL),
(25254, '2017-03-27 09:34:29', NULL, NULL, 8058, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1490600459', 'admin', '2017-03-27 09:34:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25255, '2017-03-27 09:34:39', NULL, NULL, 8058, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 09:34:39', 'admin-1490577124-14905784788745382', 1, 0, '', NULL, NULL, NULL),
(25256, '2017-03-27 09:34:39', NULL, NULL, 8058, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 09:34:39', 'admin-1490577124-14905784788745382', 1, 0, '', NULL, NULL, NULL),
(25257, '2017-03-27 09:34:39', NULL, NULL, 8058, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 09:34:39', 'admin-1490577124-14905784788745382', 1, 0, '', NULL, NULL, NULL),
(25258, '2017-03-27 09:35:55', NULL, NULL, 8058, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 09:35:55', 'admin-1490577124-14905785550586847', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(25259, '2017-03-27 10:11:41', NULL, NULL, 8062, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:11:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25260, '2017-03-27 10:11:49', NULL, NULL, 8062, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:11:49', 'admin-1490577124-14905807088508627', 1, 0, '', NULL, NULL, NULL),
(25261, '2017-03-27 10:03:30', NULL, NULL, 8061, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:03:30', 'admin-1490577124-149058021028651', 1, 1, 'SR', NULL, NULL, NULL),
(25262, '2017-03-27 10:03:30', NULL, NULL, 8061, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 10:03:30', 'admin-1490577124-149058021028651', 1, 1, 'SR', NULL, NULL, NULL),
(25263, '2017-03-27 09:35:55', NULL, NULL, 8058, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 09:35:55', 'admin-1490577124-14905785550586847', 1, 1, 'SR', NULL, NULL, NULL),
(25264, '2017-03-27 09:38:16', NULL, NULL, 8058, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 09:38:16', 'admin-1490577124-14905786963877130', 1, 0, '', NULL, NULL, NULL),
(25265, '2017-03-27 09:37:30', NULL, NULL, 8058, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 09:37:30', 'admin-1490577124-14905786506263713', 1, 0, '', NULL, NULL, NULL),
(25266, '2017-03-27 09:16:53', NULL, NULL, 8057, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 09:16:53', 'admin-1490577124-14905774135251725', 1, 0, '', NULL, NULL, NULL),
(25267, '2017-03-27 09:16:53', NULL, NULL, 8057, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490600459', 'admin', '2017-03-27 09:16:53', 'admin-1490577124-14905774135251725', 1, 0, '', NULL, NULL, NULL),
(25268, '2017-03-27 09:16:20', NULL, NULL, 8057, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1490600459', 'admin', '2017-03-27 09:16:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25269, '2017-03-29 12:39:36', NULL, NULL, 8100, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:39:36', 'admin-1490756895-14907623761646319', 1, 0, '', NULL, NULL, NULL),
(25270, '2017-03-29 00:00:00', NULL, NULL, 8101, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:14:29', 'admin-1490756895-14907608691848690', 1, 0, '', NULL, NULL, NULL),
(25271, '2017-03-29 00:00:00', NULL, NULL, 8102, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:14:48', 'admin-1490756895-14907608878797713', 1, 1, 'SR', NULL, NULL, NULL),
(25272, '2017-03-29 11:27:11', NULL, NULL, 8094, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1490764197', 'admin', '2017-03-29 11:27:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25273, '2017-03-29 11:28:51', NULL, NULL, 8095, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1490764197', 'admin', '2017-03-29 11:28:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25274, '2017-03-29 00:00:00', NULL, NULL, 8096, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, NULL, NULL, 2.60, 1, '27', 1, '1490764197', 'admin', '2017-03-29 10:06:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25275, '2017-03-29 00:00:00', NULL, NULL, 8093, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 10:30:28', 'admin-1490749547-14907546278949538', 1, 1, 'SR', NULL, NULL, NULL),
(25276, '2017-03-29 00:00:00', NULL, NULL, 8094, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 10:30:28', 'admin-1490749547-14907546278949538', 1, 0, '', NULL, NULL, NULL),
(25277, '2017-03-29 00:00:00', NULL, NULL, 8095, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 10:30:28', 'admin-1490749547-14907546278949538', 1, 0, '', NULL, NULL, NULL),
(25278, '2017-03-29 13:30:26', NULL, NULL, 8111, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:30:26', 'admin-1490764197-14907654265162898', 1, 1, 'SR', NULL, NULL, NULL),
(25279, '2017-03-29 00:00:00', NULL, NULL, 8116, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:50:49', 'admin-1490756895-14907630492143095', 1, 0, '', NULL, NULL, NULL),
(25280, '2017-03-29 00:00:00', NULL, NULL, 8103, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:14:48', 'admin-1490756895-14907608878797713', 1, 1, 'SR', NULL, NULL, NULL),
(25281, '2017-03-29 00:00:00', NULL, NULL, 8104, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, NULL, NULL, 2.20, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:13:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25282, '2017-03-29 00:00:00', NULL, NULL, 8101, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:14:48', 'admin-1490756895-14907608878797713', 1, 0, '', NULL, NULL, NULL),
(25283, '2017-03-29 00:00:00', NULL, NULL, 8102, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:14:29', 'admin-1490756895-14907608691848690', 1, 0, '', NULL, NULL, NULL),
(25284, '2017-03-29 12:49:41', NULL, NULL, 8103, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:49:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25285, '2017-03-29 00:00:00', NULL, NULL, 8102, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:14:48', 'admin-1490756895-14907608878797713', 1, 1, 'SR', NULL, NULL, NULL),
(25286, '2017-03-29 13:09:52', NULL, NULL, 8107, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:09:52', 'admin-1490756895-14907641919486373', 1, 0, '', NULL, NULL, NULL),
(25287, '2017-03-29 14:59:11', NULL, NULL, 8114, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 14:59:11', 'admin-1490764197-14907707515769884', 1, 1, 'SR', NULL, NULL, NULL),
(25288, '2017-03-29 15:01:27', NULL, NULL, 8115, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 15:01:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25289, '2017-03-29 15:01:47', NULL, NULL, 8115, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 15:01:47', 'admin-1490764197-14907709074273113', 1, 1, 'SR', NULL, NULL, NULL),
(25290, '2017-03-29 00:00:00', NULL, NULL, 8116, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:45:20', 'admin-1490764197-14907663204864464', 1, 1, 'SR', NULL, NULL, NULL),
(25291, '2017-03-29 17:11:16', NULL, NULL, 8117, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1490764197', 'admin', '2017-03-29 17:11:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25292, '2017-03-29 17:11:24', NULL, NULL, 8117, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 17:11:24', 'admin-1490764197-14907786845894332', 1, 1, 'SR', NULL, NULL, NULL),
(25293, '2017-03-29 17:13:16', NULL, NULL, 8117, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 17:13:16', 'admin-1490764197-14907787964962992', 1, 1, 'SR', NULL, NULL, NULL),
(25294, '2017-03-29 17:27:36', NULL, NULL, 8118, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1490764197', 'admin', '2017-03-29 17:27:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25295, '2017-03-29 17:28:49', NULL, NULL, 8119, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 17:28:49', 'admin-1490764197-14907797289589945', 1, 1, 'SR', 1, NULL, NULL),
(25296, '2017-03-29 17:28:49', NULL, NULL, 8119, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 17:28:49', 'admin-1490764197-14907797289589945', 1, 1, 'SR', 1, NULL, NULL),
(25297, '2017-03-29 17:28:49', NULL, NULL, 8119, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 17:28:49', 'admin-1490764197-14907797289589945', 1, 0, '', 1, NULL, NULL),
(25298, '2017-03-29 17:29:45', NULL, NULL, 8118, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 17:29:45', 'admin-1490764197-14907797851413991', 1, 1, 'SR', NULL, NULL, NULL),
(25299, '2017-03-29 17:29:45', NULL, NULL, 8118, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 17:29:45', 'admin-1490764197-14907797851413991', 1, 0, '', NULL, NULL, NULL),
(25300, '2017-03-29 17:31:29', NULL, NULL, 8118, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 17:31:29', 'admin-1490764197-14907798890611885', 1, 0, '', NULL, NULL, NULL),
(25301, '2017-03-29 14:59:06', NULL, NULL, 8114, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1490764197', 'admin', '2017-03-29 14:59:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25302, '2017-03-29 00:00:00', NULL, NULL, 8113, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:50:49', 'admin-1490756895-14907630492143095', 1, 1, 'SR', NULL, NULL, NULL),
(25303, '2017-03-29 14:12:54', NULL, NULL, 8112, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 14:12:54', 'admin-1490764197-14907679738908867', 1, 0, '', NULL, NULL, NULL),
(25304, '2017-03-29 14:12:54', NULL, NULL, 8112, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 14:12:54', 'admin-1490764197-14907679738908867', 1, 1, 'SR', NULL, NULL, NULL),
(25305, '2017-03-29 14:12:54', NULL, NULL, 8112, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 14:12:54', 'admin-1490764197-14907679738908867', 1, 0, '', NULL, NULL, NULL),
(25306, '2017-03-29 13:13:51', NULL, NULL, 8110, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:13:51', 'admin-1490764197-14907644311874516', 1, 1, 'SR', NULL, NULL, NULL),
(25307, '2017-03-29 14:12:54', NULL, NULL, 8112, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 14:12:54', 'admin-1490764197-14907679738908867', 1, 0, '', NULL, NULL, NULL),
(25308, '2017-03-29 13:24:53', NULL, NULL, 8111, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:24:53', 'admin-1490764197-14907650936356020', 1, 1, 'SR', NULL, NULL, NULL),
(25309, '2017-03-29 13:10:40', NULL, NULL, 8108, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:10:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25310, '2017-03-29 13:10:58', NULL, NULL, 8108, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:10:58', 'admin-1490764197-14907642578874353', 1, 1, 'SR', NULL, NULL, NULL),
(25311, '2017-03-29 13:10:58', NULL, NULL, 8108, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:10:58', 'admin-1490764197-14907642578874353', 1, 1, 'SR', NULL, NULL, NULL),
(25312, '2017-03-29 13:11:10', NULL, NULL, 8109, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:11:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25313, '2017-03-29 13:00:58', NULL, NULL, 8106, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:00:58', 'admin-1490756895-14907636583039347', 1, 1, 'SR', NULL, NULL, NULL),
(25314, '2017-03-29 12:26:01', NULL, NULL, 8099, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:26:01', 'admin-1490756895-14907615613039471', 1, 1, 'SR', NULL, NULL, NULL),
(25315, '2017-03-29 13:24:53', NULL, NULL, 8111, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:24:53', 'admin-1490764197-14907650936356020', 1, 0, '', NULL, NULL, NULL),
(25316, '2017-03-29 13:24:53', NULL, NULL, 8111, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:24:53', 'admin-1490764197-14907650936356020', 1, 0, '', NULL, NULL, NULL),
(25317, '2017-03-29 13:24:53', NULL, NULL, 8111, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:24:53', 'admin-1490764197-14907650936356020', 1, 1, 'SR', NULL, NULL, NULL),
(25318, '2017-03-29 13:20:51', NULL, NULL, 8111, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:20:51', 'admin-1490764197-14907648516678118', 1, 1, 'SR', NULL, NULL, NULL),
(25319, '2017-03-29 13:22:27', NULL, NULL, 8099, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:22:27', 'admin-1490764197-14907649470636145', 1, 0, '', NULL, NULL, NULL),
(25320, '2017-03-29 13:20:10', NULL, NULL, 8111, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.20, 0.0000, 0.0000, 9.20, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:20:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25321, '2017-03-29 13:13:51', NULL, NULL, 8110, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:13:51', 'admin-1490764197-14907644311874516', 1, 1, 'SR', NULL, NULL, NULL),
(25322, '2017-03-29 13:13:41', NULL, NULL, 8110, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:13:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25323, '2017-03-29 13:11:44', NULL, NULL, 8109, 0, 181, '116', 'Open Food ', 'set', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:11:44', 'admin-1490764197-14907643038567416', 1, 0, '', NULL, NULL, NULL),
(25324, '2017-03-29 13:11:44', NULL, NULL, 8109, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:11:44', 'admin-1490764197-14907643038567416', 1, 0, '', NULL, NULL, NULL),
(25325, '2017-03-29 13:11:44', NULL, NULL, 8109, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:11:44', 'admin-1490764197-14907643038567416', 1, 0, '', NULL, NULL, NULL),
(25326, '2017-03-29 13:09:52', NULL, NULL, 8107, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:09:52', 'admin-1490756895-14907641919486373', 1, 1, 'SR', NULL, NULL, NULL),
(25327, '2017-03-29 13:09:52', NULL, NULL, 8107, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:09:52', 'admin-1490756895-14907641919486373', 1, 1, 'SR', NULL, NULL, NULL),
(25328, '2017-03-29 00:00:00', NULL, NULL, 8103, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:14:29', 'admin-1490756895-14907608691848690', 1, 0, '', NULL, NULL, NULL),
(25329, '2017-03-29 00:00:00', NULL, NULL, 8104, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:14:48', 'admin-1490756895-14907608878797713', 1, 1, 'SR', NULL, NULL, NULL),
(25330, '2017-03-29 15:11:35', NULL, NULL, 8116, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1490764197', 'admin', '2017-03-29 15:11:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25331, '2017-03-29 12:49:13', NULL, NULL, 8101, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:49:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25332, '2017-03-29 00:00:00', NULL, NULL, 8104, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:14:29', 'admin-1490756895-14907608691848690', 1, 0, '', NULL, NULL, NULL),
(25333, '2017-03-29 12:25:47', NULL, NULL, 8099, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:25:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25334, '2017-03-29 13:01:07', NULL, NULL, 8106, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:01:07', 'admin-1490756895-14907636670833777', 1, 1, 'SR', NULL, NULL, NULL),
(25335, '2017-03-29 13:01:07', NULL, NULL, 8106, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:01:07', 'admin-1490756895-14907636670833777', 1, 0, '', NULL, NULL, NULL),
(25336, '2017-03-29 14:12:34', NULL, NULL, 8112, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1490764197', 'admin', '2017-03-29 14:12:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25337, '2017-03-29 13:09:36', NULL, NULL, 8107, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:09:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25338, '2017-03-29 14:39:15', NULL, NULL, 8113, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1490764197', 'admin', '2017-03-29 14:39:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25339, '2017-03-29 13:00:46', NULL, NULL, 8106, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1490764197', 'admin', '2017-03-29 13:00:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25340, '2017-03-29 12:39:36', NULL, NULL, 8100, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:39:36', 'admin-1490756895-14907623761646319', 1, 1, 'SR', NULL, NULL, NULL),
(25341, '2017-03-29 12:39:36', NULL, NULL, 8100, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:39:36', 'admin-1490756895-14907623761646319', 1, 1, 'SR', NULL, NULL, NULL),
(25342, '2017-03-29 12:39:20', NULL, NULL, 8100, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:39:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25343, '2017-03-29 12:39:36', NULL, NULL, 8100, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:39:36', 'admin-1490756895-14907623761646319', 1, 1, 'SR', NULL, NULL, NULL),
(25344, '2017-03-29 12:49:30', NULL, NULL, 8102, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:49:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25345, '2017-03-29 00:00:00', NULL, NULL, 8095, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 10:30:28', 'admin-1490749547-14907546278949538', 1, 1, 'SR', NULL, NULL, NULL),
(25346, '2017-03-29 11:26:15', NULL, NULL, 8093, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1490764197', 'admin', '2017-03-29 11:26:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25347, '2017-03-29 00:00:00', NULL, NULL, 8095, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 10:06:54', 'admin-1490749547-14907532144646435', 1, 1, 'SR', NULL, NULL, NULL),
(25348, '2017-03-29 00:00:00', NULL, NULL, 8094, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 10:30:28', 'admin-1490749547-14907546278949538', 1, 0, '', NULL, NULL, NULL),
(25349, '2017-03-29 00:00:00', NULL, NULL, 8094, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 10:06:54', 'admin-1490749547-14907532144646435', 1, 1, 'SR', NULL, NULL, NULL),
(25350, '2017-03-29 00:00:00', NULL, NULL, 8096, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 10:22:29', 'admin-1490749547-14907541494124583', 1, 0, '', NULL, NULL, NULL),
(25351, '2017-03-29 00:00:00', NULL, NULL, 8093, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 10:30:28', 'admin-1490749547-14907546278949538', 1, 0, '', NULL, NULL, NULL),
(25352, '2017-03-29 10:44:13', NULL, NULL, 8090, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1490764197', 'admin', '2017-03-29 10:44:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25353, '2017-03-29 10:44:18', NULL, NULL, 8090, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 10:44:18', 'admin-1490749547-1490755458195253', 1, 0, '', NULL, NULL, NULL),
(25354, '2017-03-29 10:44:23', NULL, NULL, 8090, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 10:44:23', 'admin-1490749547-14907554632558557', 1, 0, '', NULL, NULL, NULL),
(25355, '2017-03-29 10:44:23', NULL, NULL, 8090, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 10:44:23', 'admin-1490749547-14907554632558557', 1, 0, '', NULL, NULL, NULL),
(25356, '2017-03-29 11:07:44', NULL, NULL, 8091, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1490764197', 'admin', '2017-03-29 11:07:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25357, '2017-03-29 11:07:51', NULL, NULL, 8091, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 11:07:51', 'admin-1490749547-14907568712301232', 1, 0, '', NULL, NULL, NULL),
(25358, '2017-03-29 11:07:51', NULL, NULL, 8091, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 11:07:51', 'admin-1490749547-14907568712301232', 1, 0, '', NULL, NULL, NULL),
(25359, '2017-03-29 11:08:27', NULL, NULL, 8091, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 11:08:27', 'admin-1490756895-14907569077019174', 1, 1, 'SR', NULL, NULL, NULL),
(25360, '2017-03-29 11:08:27', NULL, NULL, 8091, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 11:08:27', 'admin-1490756895-14907569077019174', 1, 1, 'SR', NULL, NULL, NULL),
(25361, '2017-03-29 11:12:53', NULL, NULL, 8092, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1490764197', 'admin', '2017-03-29 11:12:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25362, '2017-03-29 11:12:58', NULL, NULL, 8092, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 11:12:58', 'admin-1490756895-14907571786677615', 1, 1, 'SR', NULL, NULL, NULL),
(25363, '2017-03-29 11:12:58', NULL, NULL, 8092, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 11:12:58', 'admin-1490756895-14907571786677615', 1, 1, 'SR', NULL, NULL, NULL),
(25364, '2017-03-29 11:12:58', NULL, NULL, 8092, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 11:12:58', 'admin-1490756895-14907571786677615', 1, 1, 'SR', NULL, NULL, NULL),
(25365, '2017-03-29 12:26:01', NULL, NULL, 8099, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:26:01', 'admin-1490756895-14907615613039471', 1, 1, 'SR', NULL, NULL, NULL),
(25366, '2017-03-29 12:26:01', NULL, NULL, 8099, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:26:01', 'admin-1490756895-14907615613039471', 1, 1, 'SR', NULL, NULL, NULL),
(25367, '2017-03-29 12:26:01', NULL, NULL, 8099, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 12:26:01', 'admin-1490756895-14907615613039471', 1, 1, 'SR', NULL, NULL, NULL),
(25368, '2017-03-29 09:10:19', NULL, NULL, 8086, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 09:10:19', 'admin-1490749547-14907498189442080', 1, 0, '', NULL, NULL, NULL),
(25369, '2017-03-29 09:10:19', NULL, NULL, 8086, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 09:10:19', 'admin-1490749547-14907498189442080', 1, 1, 'SR', NULL, NULL, NULL),
(25370, '2017-03-29 09:20:08', NULL, NULL, 8087, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1490764197', 'admin', '2017-03-29 09:20:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25371, '2017-03-29 09:20:15', NULL, NULL, 8087, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 09:20:15', 'admin-1490749547-14907504150262324', 1, 0, '', NULL, NULL, NULL),
(25372, '2017-03-29 09:20:15', NULL, NULL, 8087, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 09:20:15', 'admin-1490749547-14907504150262324', 1, 0, '', NULL, NULL, NULL),
(25373, '2017-03-29 09:30:36', NULL, NULL, 8088, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1490764197', 'admin', '2017-03-29 09:30:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25374, '2017-03-29 09:30:44', NULL, NULL, 8088, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 09:30:44', 'admin-1490749547-1490751044220330', 1, 0, '', NULL, NULL, NULL),
(25375, '2017-03-29 09:30:44', NULL, NULL, 8088, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 09:30:44', 'admin-1490749547-1490751044220330', 1, 0, '', NULL, NULL, NULL),
(25376, '2017-03-29 11:45:58', NULL, NULL, 8097, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1490764197', 'admin', '2017-03-29 11:45:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25377, '2017-03-29 11:46:05', NULL, NULL, 8097, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 11:46:05', 'admin-1490756895-14907591655407147', 1, 1, 'SR', NULL, NULL, NULL),
(25378, '2017-03-29 11:46:05', NULL, NULL, 8097, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 11:46:05', 'admin-1490756895-14907591655407147', 1, 1, 'SR', NULL, NULL, NULL),
(25379, '2017-03-29 00:00:00', NULL, NULL, 8096, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 10:30:28', 'admin-1490749547-14907546278949538', 1, 1, 'SR', NULL, NULL, NULL),
(25380, '2017-03-29 00:00:00', NULL, NULL, 8095, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1490764197', 'admin', '2017-03-29 10:22:29', 'admin-1490749547-14907541494124583', 1, 1, 'SR', NULL, NULL, NULL),
(25381, '2017-03-29 09:10:10', NULL, NULL, 8086, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1490764197', 'admin', '2017-03-29 09:10:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25382, '2017-03-30 18:35:14', NULL, NULL, 8144, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 18:35:14', 'admin-1490846116-14908701145266693', 1, 0, '', NULL, NULL, NULL),
(25383, '2017-03-30 13:10:19', NULL, NULL, 8129, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 13:10:19', 'admin-1490846116-14908506195391942', 1, 1, 'SR', NULL, NULL, NULL),
(25384, '2017-03-30 11:55:09', NULL, NULL, 8125, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 11:55:09', 'admin-1490835159-14908461088545960', 1, 0, '', NULL, NULL, NULL),
(25385, '2017-03-30 12:11:08', NULL, NULL, 8122, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 12:11:08', 'admin-1490846116-14908470684962832', 1, 1, 'SR', NULL, NULL, NULL),
(25386, '2017-03-30 12:21:48', NULL, NULL, 8126, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1490846116', 'admin', '2017-03-30 12:21:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25387, '2017-03-30 12:21:55', NULL, NULL, 8126, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 12:21:55', 'admin-1490846116-14908477150638771', 1, 1, 'SR', NULL, NULL, NULL),
(25388, '2017-03-30 09:42:17', NULL, NULL, 8120, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 09:42:17', 'admin-1490835159-14908381369908876', 1, 0, '', NULL, NULL, NULL),
(25389, '2017-03-30 18:41:33', NULL, NULL, 8144, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 18:41:33', 'admin-1490846116-14908704936683157', 1, 0, '', NULL, NULL, NULL),
(25390, '2017-03-30 18:40:41', NULL, NULL, 8139, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 18:40:41', 'admin-1490846116-14908704414435894', 1, 0, '', NULL, NULL, NULL),
(25391, '2017-03-30 17:20:25', NULL, NULL, 8144, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 17:20:25', 'admin-1490846116-14908656248658027', 1, 0, '', NULL, NULL, NULL),
(25392, '2017-03-30 17:21:01', NULL, NULL, 8144, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 17:21:01', 'admin-1490846116-14908656617073964', 1, 1, 'SR', NULL, NULL, NULL),
(25393, '2017-03-30 17:22:47', NULL, NULL, 8146, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1490846116', 'admin', '2017-03-30 17:22:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25394, '2017-03-30 17:22:50', NULL, NULL, 8146, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 17:22:50', 'admin-1490846116-14908657705207965', 1, 1, 'SR', NULL, NULL, NULL),
(25395, '2017-03-30 14:22:18', NULL, NULL, 8132, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 14:22:18', 'admin-1490846116-14908549386024013', 1, 0, '', NULL, NULL, NULL),
(25396, '2017-03-30 13:24:52', NULL, NULL, 8130, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1490846116', 'admin', '2017-03-30 13:24:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25397, '2017-03-30 13:30:01', NULL, NULL, 8130, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 13:30:01', 'admin-1490846116-14908518010024767', 1, 0, '', NULL, NULL, NULL),
(25398, '2017-03-30 13:30:01', NULL, NULL, 8130, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 13:30:01', 'admin-1490846116-14908518010024767', 1, 0, '', NULL, NULL, NULL),
(25399, '2017-03-30 13:30:09', NULL, NULL, 8131, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1490846116', 'admin', '2017-03-30 13:30:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25400, '2017-03-30 13:30:26', NULL, NULL, 8131, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 13:30:26', 'admin-1490846116-14908518266189773', 1, 1, 'SR', NULL, NULL, NULL),
(25401, '2017-03-30 13:30:26', NULL, NULL, 8131, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 13:30:26', 'admin-1490846116-14908518266189773', 1, 1, 'SR', NULL, NULL, NULL),
(25402, '2017-03-30 13:37:37', NULL, NULL, 8132, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1490846116', 'admin', '2017-03-30 13:37:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25403, '2017-03-30 13:37:46', NULL, NULL, 8132, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 13:37:46', 'admin-1490846116-14908522659198011', 1, 0, '', NULL, NULL, NULL),
(25404, '2017-03-30 13:37:46', NULL, NULL, 8132, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 13:37:46', 'admin-1490846116-14908522659198011', 1, 1, 'SR', NULL, NULL, NULL),
(25405, '2017-03-30 17:28:25', NULL, NULL, 8144, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 17:28:25', 'admin-1490846116-14908661048653932', 1, 0, '', NULL, NULL, NULL),
(25406, '2017-03-30 17:28:25', NULL, NULL, 8144, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 17:28:25', 'admin-1490846116-14908661048653932', 1, 0, '', NULL, NULL, NULL),
(25407, '2017-03-30 17:19:05', NULL, NULL, 8145, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 17:19:05', 'admin-1490846116-1490865545702188', 1, 0, '', 1, NULL, NULL),
(25408, '2017-03-30 16:23:58', NULL, NULL, 8141, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 16:23:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25409, '2017-03-30 17:18:12', NULL, NULL, 8142, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 17:18:12', 'admin-1490846116-14908654927656979', 1, 1, 'SR', NULL, NULL, NULL),
(25410, '2017-03-30 17:29:39', NULL, NULL, 8143, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 17:29:39', 'admin-1490846116-14908661795288343', 1, 1, 'SR', NULL, NULL, NULL),
(25411, '2017-03-30 16:58:35', NULL, NULL, 8142, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 16:58:35', 'admin-1490846116-14908643148047658', 1, 0, '', NULL, NULL, NULL),
(25412, '2017-03-30 17:11:12', NULL, NULL, 8144, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.80, 0.0000, 0.0000, 9.80, 1, '27', 1, '1490846116', 'admin', '2017-03-30 17:11:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25413, '2017-03-30 14:31:15', NULL, NULL, 8133, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 14:31:15', 'admin-1490846116-14908554748608640', 1, 0, '', NULL, NULL, NULL),
(25414, '2017-03-30 13:56:40', NULL, NULL, 8133, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 13:56:40', 'admin-1490846116-1490853400463548', 1, 0, '', NULL, NULL, NULL),
(25415, '2017-03-30 16:53:43', NULL, NULL, 8142, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 16:53:43', 'admin-1490846116-14908640228062063', 1, 0, '', NULL, NULL, NULL),
(25416, '2017-03-30 16:53:43', NULL, NULL, 8142, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 16:53:43', 'admin-1490846116-14908640228062063', 1, 0, '', NULL, NULL, NULL),
(25417, '2017-03-30 15:16:06', NULL, NULL, 8137, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 15:16:06', 'admin-1490846116-14908581664699261', 1, 1, 'SR', NULL, NULL, NULL),
(25418, '2017-03-30 15:19:22', NULL, NULL, 8138, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1490846116', 'admin', '2017-03-30 15:19:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25419, '2017-03-30 15:19:43', NULL, NULL, 8138, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 15:19:43', 'admin-1490846116-14908583833282034', 1, 1, 'SR', NULL, NULL, NULL),
(25420, '2017-03-30 15:19:43', NULL, NULL, 8138, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 15:19:43', 'admin-1490846116-14908583833282034', 1, 1, 'SR', NULL, NULL, NULL),
(25421, '2017-03-30 13:54:56', NULL, NULL, 8133, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1490846116', 'admin', '2017-03-30 13:54:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25422, '2017-03-30 14:27:29', NULL, NULL, 8135, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.79, 0.0000, 0.0000, 1.79, 1, '27', 1, '1490846116', 'admin', '2017-03-30 14:27:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25423, '2017-03-30 16:53:56', NULL, NULL, 8143, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1490846116', 'admin', '2017-03-30 16:53:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25424, '2017-03-30 16:53:43', NULL, NULL, 8142, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 16:53:43', 'admin-1490846116-14908640228062063', 1, 0, '', NULL, NULL, NULL),
(25425, '2017-03-30 16:53:43', NULL, NULL, 8142, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 16:53:43', 'admin-1490846116-14908640228062063', 1, 1, 'SR', NULL, NULL, NULL),
(25426, '2017-03-30 16:24:04', NULL, NULL, 8141, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 16:24:04', 'admin-1490846116-14908622441193933', 1, 1, 'SR', NULL, NULL, NULL),
(25427, '2017-03-30 16:53:25', NULL, NULL, 8142, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1490846116', 'admin', '2017-03-30 16:53:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25428, '2017-03-30 16:13:32', NULL, NULL, 8140, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 16:13:32', 'admin-1490846116-14908616121139415', 1, 1, 'SR', NULL, NULL, NULL),
(25429, '2017-03-30 16:13:32', NULL, NULL, 8140, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 16:13:32', 'admin-1490846116-14908616121139415', 1, 1, 'SR', NULL, NULL, NULL),
(25430, '2017-03-30 16:13:23', NULL, NULL, 8140, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 16:13:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25431, '2017-03-30 15:19:43', NULL, NULL, 8138, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 15:19:43', 'admin-1490846116-14908583833282034', 1, 0, '', NULL, NULL, NULL),
(25432, '2017-03-30 15:52:44', NULL, NULL, 8139, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1490846116', 'admin', '2017-03-30 15:52:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25433, '2017-03-30 15:52:50', NULL, NULL, 8139, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 15:52:50', 'admin-1490846116-14908603702439390', 1, 1, 'SR', NULL, NULL, NULL),
(25434, '2017-03-30 15:16:06', NULL, NULL, 8137, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 15:16:06', 'admin-1490846116-14908581664699261', 1, 1, 'SR', NULL, NULL, NULL),
(25435, '2017-03-30 15:16:06', NULL, NULL, 8137, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 15:16:06', 'admin-1490846116-14908581664699261', 1, 0, '', NULL, NULL, NULL),
(25436, '2017-03-30 15:15:57', NULL, NULL, 8137, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1490846116', 'admin', '2017-03-30 15:15:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25437, '2017-03-30 15:14:32', NULL, NULL, 8136, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1490846116', 'admin', '2017-03-30 15:14:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25438, '2017-03-30 15:15:47', NULL, NULL, 8136, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 15:15:47', 'admin-1490846116-14908581467866424', 1, 0, '', NULL, NULL, NULL),
(25439, '2017-03-30 14:48:50', NULL, NULL, 8130, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 14:48:50', 'admin-1490846116-14908565306669055', 1, 1, 'SR', NULL, NULL, NULL),
(25440, '2017-03-30 11:55:09', NULL, NULL, 8125, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 11:55:09', 'admin-1490835159-14908461088545960', 1, 0, '', NULL, NULL, NULL),
(25441, '2017-03-30 14:28:22', NULL, NULL, 8135, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1490846116', 'admin', '2017-03-30 14:28:22', 'admin-1490846116-1490855302483242', 1, 0, '', NULL, NULL, NULL),
(25442, '2017-03-30 14:28:22', NULL, NULL, 8135, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 14:28:22', 'admin-1490846116-1490855302483242', 1, 1, 'SR', NULL, NULL, NULL),
(25443, '2017-03-30 14:24:30', NULL, NULL, 8134, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1490846116', 'admin', '2017-03-30 14:24:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25444, '2017-03-30 14:24:54', NULL, NULL, 8134, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 14:24:54', 'admin-1490846116-1490855094705885', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(25445, '2017-03-30 13:10:29', NULL, NULL, 8128, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 13:10:29', 'admin-1490846116-1490850629642552', 1, 1, 'SR', NULL, NULL, NULL),
(25446, '2017-03-30 13:10:16', NULL, NULL, 8129, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1490846116', 'admin', '2017-03-30 13:10:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25447, '2017-03-30 11:55:09', NULL, NULL, 8125, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 11:55:09', 'admin-1490835159-14908461088545960', 1, 1, 'SR', NULL, NULL, NULL),
(25448, '2017-03-30 13:09:15', NULL, NULL, 8126, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 13:09:15', 'admin-1490846116-14908505555496549', 1, 1, 'SR', NULL, NULL, NULL),
(25449, '2017-03-30 13:09:15', NULL, NULL, 8126, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 13:09:15', 'admin-1490846116-14908505555496549', 1, 1, 'SR', NULL, NULL, NULL),
(25450, '2017-03-30 13:08:47', NULL, NULL, 8128, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 13:08:47', 'admin-1490846116-14908505276877667', 1, 0, '', NULL, NULL, NULL),
(25451, '2017-03-30 13:08:47', NULL, NULL, 8128, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 13:08:47', 'admin-1490846116-14908505276877667', 1, 1, 'SR', NULL, NULL, NULL),
(25452, '2017-03-30 13:08:47', NULL, NULL, 8128, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 13:08:47', 'admin-1490846116-14908505276877667', 1, 0, '', NULL, NULL, NULL),
(25453, '2017-03-30 13:07:19', NULL, NULL, 8128, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1490846116', 'admin', '2017-03-30 13:07:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25454, '2017-03-30 12:46:24', NULL, NULL, 8127, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 12:46:24', 'admin-1490846116-14908491840051973', 1, 1, 'SR', NULL, NULL, NULL),
(25455, '2017-03-30 12:46:24', NULL, NULL, 8127, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 12:46:24', 'admin-1490846116-14908491840051973', 1, 0, '', NULL, NULL, NULL),
(25456, '2017-03-30 12:42:03', NULL, NULL, 8127, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 12:42:03', 'admin-1490846116-14908489235308763', 1, 1, 'SR', NULL, NULL, NULL),
(25457, '2017-03-30 12:42:03', NULL, NULL, 8127, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 12:42:03', 'admin-1490846116-14908489235308763', 1, 1, 'SR', NULL, NULL, NULL),
(25458, '2017-03-30 12:42:03', NULL, NULL, 8127, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 12:42:03', 'admin-1490846116-14908489235308763', 1, 1, 'SR', NULL, NULL, NULL),
(25459, '2017-03-30 12:41:35', NULL, NULL, 8127, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 12:41:35', 'admin-1490846116-14908488953489376', 1, 0, '', NULL, NULL, NULL),
(25460, '2017-03-30 12:41:35', NULL, NULL, 8127, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 12:41:35', 'admin-1490846116-14908488953489376', 1, 1, 'SR', NULL, NULL, NULL),
(25461, '2017-03-30 12:41:35', NULL, NULL, 8127, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 12:41:35', 'admin-1490846116-14908488953489376', 1, 1, 'SR', NULL, NULL, NULL),
(25462, '2017-03-30 12:41:35', NULL, NULL, 8127, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 12:41:35', 'admin-1490846116-14908488953489376', 1, 0, '', NULL, NULL, NULL),
(25463, '2017-03-30 12:41:35', NULL, NULL, 8127, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 12:41:35', 'admin-1490846116-14908488953489376', 1, 0, '', NULL, NULL, NULL),
(25464, '2017-03-30 12:41:08', NULL, NULL, 8127, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.10, 0.0000, 0.0000, 13.10, 1, '27', 1, '1490846116', 'admin', '2017-03-30 12:41:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25465, '2017-03-30 12:21:55', NULL, NULL, 8126, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 12:21:55', 'admin-1490846116-14908477150638771', 1, 0, '', NULL, NULL, NULL),
(25466, '2017-03-30 11:46:49', NULL, NULL, 8124, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 11:46:49', 'admin-1490835159-14908456092227072', 1, 1, 'SR', NULL, NULL, NULL),
(25467, '2017-03-30 11:46:49', NULL, NULL, 8124, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 11:46:49', 'admin-1490835159-14908456092227072', 1, 1, 'SR', NULL, NULL, NULL),
(25468, '2017-03-30 11:54:58', NULL, NULL, 8125, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1490846116', 'admin', '2017-03-30 11:54:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25469, '2017-03-30 11:55:09', NULL, NULL, 8125, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 11:55:09', 'admin-1490835159-14908461088545960', 1, 0, '', NULL, NULL, NULL),
(25470, '2017-03-30 11:46:43', NULL, NULL, 8124, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 11:46:43', 'admin-1490835159-14908456028809990', 1, 0, '', NULL, NULL, NULL),
(25471, '2017-03-30 11:46:43', NULL, NULL, 8124, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 11:46:43', 'admin-1490835159-14908456028809990', 1, 0, '', NULL, NULL, NULL),
(25472, '2017-03-30 11:43:59', NULL, NULL, 8124, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1490846116', 'admin', '2017-03-30 11:43:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25473, '2017-03-30 11:01:18', NULL, NULL, 8122, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 11:01:18', 'admin-1490835159-14908428781939915', 1, 1, 'SR', NULL, NULL, NULL),
(25474, '2017-03-30 11:31:12', NULL, NULL, 8122, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 11:31:12', 'admin-1490835159-14908446723578066', 1, 1, 'SR', NULL, NULL, NULL),
(25475, '2017-03-30 10:51:59', NULL, NULL, 8123, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 10:51:59', 'admin-1490835159-1490842318833767', 1, 1, 'SR', NULL, NULL, NULL),
(25476, '2017-03-30 10:51:50', NULL, NULL, 8123, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1490846116', 'admin', '2017-03-30 10:51:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25477, '2017-03-30 10:47:19', NULL, NULL, 8122, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 10:47:19', 'admin-1490835159-1490842039713455', 1, 0, '', NULL, NULL, NULL),
(25478, '2017-03-30 10:34:31', NULL, NULL, 8122, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 10:34:31', 'admin-1490835159-14908412715072657', 1, 0, '', NULL, NULL, NULL),
(25479, '2017-03-30 10:45:08', NULL, NULL, 8122, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 10:45:08', 'admin-1490835159-14908419086118027', 1, 1, 'SR', NULL, NULL, NULL),
(25480, '2017-03-30 10:25:40', NULL, NULL, 8122, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 10:25:40', 'admin-1490835159-1490840739957610', 1, 1, 'SR', NULL, NULL, NULL),
(25481, '2017-03-30 10:19:29', NULL, NULL, 8121, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 10:19:29', 'admin-1490835159-14908403695427821', 1, 0, '', 1, NULL, NULL),
(25482, '2017-03-30 10:25:37', NULL, NULL, 8122, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1490846116', 'admin', '2017-03-30 10:25:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25483, '2017-03-30 09:42:23', NULL, NULL, 8120, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1490846116', 'admin', '2017-03-30 09:42:23', 'admin-1490835159-14908381430096224', 1, 1, 'SR', NULL, NULL, NULL),
(25484, '2017-03-30 09:42:09', NULL, NULL, 8120, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1490846116', 'admin', '2017-03-30 09:42:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25485, '2017-03-31 12:21:04', NULL, NULL, 8157, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:21:04', 'admin-1490926551-14909340639795510', 1, 0, '', NULL, NULL, NULL),
(25486, '2017-03-31 09:39:58', NULL, NULL, 8149, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1490954852', 'admin', '2017-03-31 09:39:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25487, '2017-03-31 09:40:04', NULL, NULL, 8149, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 09:40:04', 'admin-1490921958-14909244043119258', 1, 0, '', NULL, NULL, NULL),
(25488, '2017-03-31 12:52:26', NULL, NULL, 8159, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:52:26', 'admin-1490934758-14909359467148618', 1, 0, '', NULL, NULL, NULL),
(25489, '2017-03-31 12:52:37', NULL, NULL, 8157, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:52:37', 'admin-1490934758-14909359571817217', 1, 0, '', NULL, NULL, NULL),
(25490, '2017-03-31 15:25:35', NULL, NULL, 8165, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 15:25:35', 'admin-1490934758-14909451357905252', 1, 0, '', 1, NULL, NULL),
(25491, '2017-03-31 17:10:47', NULL, NULL, 8168, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 17:10:47', 'admin-1490934758-14909514476593035', 1, 0, '', 1, NULL, NULL),
(25492, '2017-03-31 10:13:13', NULL, NULL, 8151, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 10:13:13', 'admin-1490921958-1490926393479844', 1, 0, '', NULL, NULL, NULL),
(25493, '2017-03-31 00:00:00', NULL, NULL, 8154, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, NULL, NULL, 3.40, 1, '27', 1, '1490954852', 'admin', '2017-03-31 10:01:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25494, '2017-03-31 12:03:05', NULL, NULL, 8155, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:03:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25495, '2017-03-31 10:11:28', NULL, NULL, 8151, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1490954852', 'admin', '2017-03-31 10:11:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25496, '2017-03-31 18:07:49', NULL, NULL, 8170, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1490954852', 'admin', '2017-03-31 18:07:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25497, '2017-03-31 18:07:08', NULL, NULL, 8169, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 18:07:08', 'admin-1490934758-14909548284209971', 1, 1, 'SR', NULL, NULL, NULL),
(25498, '2017-03-31 18:28:26', NULL, NULL, 8171, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1490954852', 'admin', '2017-03-31 18:28:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25499, '2017-03-31 18:28:37', NULL, NULL, 8171, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 18:28:37', 'admin-1490954852-14909561175882032', 1, 0, '', NULL, NULL, NULL),
(25500, '2017-03-31 18:28:37', NULL, NULL, 8171, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 18:28:37', 'admin-1490954852-14909561175882032', 1, 1, 'SR', NULL, NULL, NULL),
(25501, '2017-03-31 18:07:02', NULL, NULL, 8169, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1490954852', 'admin', '2017-03-31 18:07:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25502, '2017-03-31 18:07:55', NULL, NULL, 8170, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 18:07:55', 'admin-1490954852-14909548753779750', 1, 1, 'SR', NULL, NULL, NULL),
(25503, '2017-03-31 12:32:33', NULL, NULL, 8158, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:32:33', 'admin-1490926551-14909347537505994', 1, 1, 'SR', NULL, NULL, NULL),
(25504, '2017-03-31 12:34:14', NULL, NULL, 8159, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.19, 0.0000, 0.0000, 3.19, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:34:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25505, '2017-03-31 12:34:20', NULL, NULL, 8159, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:34:20', 'admin-1490934758-14909348600055073', 1, 0, '', NULL, NULL, NULL),
(25506, '2017-03-31 13:03:55', NULL, NULL, 8160, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1490954852', 'admin', '2017-03-31 13:03:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25507, '2017-03-31 13:04:05', NULL, NULL, 8160, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 13:04:05', 'admin-1490934758-14909366448985338', 1, 0, '', NULL, NULL, NULL),
(25508, '2017-03-31 13:04:05', NULL, NULL, 8160, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 13:04:05', 'admin-1490934758-14909366448985338', 1, 0, '', NULL, NULL, NULL),
(25509, '2017-03-31 13:09:32', NULL, NULL, 8161, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1490954852', 'admin', '2017-03-31 13:09:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25510, '2017-03-31 13:09:41', NULL, NULL, 8161, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 13:09:41', 'admin-1490934758-14909369811046145', 1, 0, '', NULL, NULL, NULL),
(25511, '2017-03-31 13:09:41', NULL, NULL, 8161, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 13:09:41', 'admin-1490934758-14909369811046145', 1, 0, '', NULL, NULL, NULL),
(25512, '2017-03-31 13:09:46', NULL, NULL, 8161, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 13:09:46', 'admin-1490934758-14909369858212260', 1, 1, 'SR', NULL, NULL, NULL),
(25513, '2017-03-31 13:09:46', NULL, NULL, 8161, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 13:09:46', 'admin-1490934758-14909369858212260', 1, 1, 'SR', NULL, NULL, NULL),
(25514, '2017-03-31 13:12:26', NULL, NULL, 8162, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.50, 0.0000, 0.0000, 9.50, 1, '27', 1, '1490954852', 'admin', '2017-03-31 13:12:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25515, '2017-03-31 13:12:47', NULL, NULL, 8162, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 13:12:47', 'admin-1490934758-14909371675253133', 1, 0, '', NULL, NULL, NULL),
(25516, '2017-03-31 13:12:47', NULL, NULL, 8162, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 13:12:47', 'admin-1490934758-14909371675253133', 1, 1, 'SR', NULL, NULL, NULL),
(25517, '2017-03-31 13:12:47', NULL, NULL, 8162, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 13:12:47', 'admin-1490934758-14909371675253133', 1, 1, 'SR', NULL, NULL, NULL),
(25518, '2017-03-31 13:12:47', NULL, NULL, 8162, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 13:12:47', 'admin-1490934758-14909371675253133', 1, 0, '', NULL, NULL, NULL),
(25519, '2017-03-31 13:13:00', NULL, NULL, 8162, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 13:13:00', 'admin-1490934758-14909371801935316', 1, 1, 'SR', NULL, NULL, NULL),
(25520, '2017-03-31 13:13:00', NULL, NULL, 8162, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 3, 9.00, 27.0000, 0.0000, 27.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 13:13:00', 'admin-1490934758-14909371801935316', 1, 1, 'SR', NULL, NULL, NULL),
(25521, '2017-03-31 13:53:55', NULL, NULL, 8163, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 13:53:55', 'admin-1490934758-14909396349037215', 1, 0, '', 1, NULL, NULL),
(25522, '2017-03-31 13:53:55', NULL, NULL, 8163, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 13:53:55', 'admin-1490934758-14909396349037215', 1, 0, '', 1, NULL, NULL),
(25523, '2017-03-31 13:53:55', NULL, NULL, 8163, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 13:53:55', 'admin-1490934758-14909396349037215', 1, 0, '', 1, NULL, NULL),
(25524, '2017-03-31 18:07:55', NULL, NULL, 8170, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 18:07:55', 'admin-1490954852-14909548753779750', 1, 1, 'SR', NULL, NULL, NULL),
(25525, '2017-03-31 18:07:08', NULL, NULL, 8169, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 18:07:08', 'admin-1490934758-14909548284209971', 1, 0, '', NULL, NULL, NULL),
(25526, '2017-03-31 09:25:13', NULL, NULL, 8148, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 09:25:13', 'admin-1490921958-1490923512779991', 1, 1, 'SR', NULL, NULL, NULL),
(25527, '2017-03-31 12:21:04', NULL, NULL, 8157, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:21:04', 'admin-1490926551-14909340639795510', 1, 0, '', NULL, NULL, NULL),
(25528, '2017-03-31 00:00:00', NULL, NULL, 8154, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 10:01:14', 'admin-1490921958-1490925674730104', 1, 1, 'SR', NULL, NULL, NULL),
(25529, '2017-03-31 12:32:33', NULL, NULL, 8158, 0, 181, '116', 'Open Food ', 'set', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:32:33', 'admin-1490926551-14909347537505994', 1, 0, '', NULL, NULL, NULL),
(25530, '2017-03-31 12:34:07', NULL, NULL, 8158, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:34:07', 'admin-1490934758-14909348472251710', 1, 0, '', NULL, NULL, NULL),
(25531, '2017-03-31 12:32:33', NULL, NULL, 8158, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:32:33', 'admin-1490926551-14909347537505994', 1, 0, '', NULL, NULL, NULL),
(25532, '2017-03-31 12:32:09', NULL, NULL, 8158, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:32:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25533, '2017-03-31 12:21:04', NULL, NULL, 8157, 0, 181, '116', 'Open Food ', 'set', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:21:04', 'admin-1490926551-14909340639795510', 1, 0, '', NULL, NULL, NULL),
(25534, '2017-03-31 12:21:04', NULL, NULL, 8157, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:21:04', 'admin-1490926551-14909340639795510', 1, 0, '', NULL, NULL, NULL),
(25535, '2017-03-31 09:24:58', NULL, NULL, 8147, 0, 181, '116', 'Open Food ', 'scramble eggs', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 09:24:58', 'admin-1490921958-14909234985841499', 1, 0, '', NULL, NULL, NULL),
(25536, '2017-03-31 11:45:05', NULL, NULL, 8153, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1490954852', 'admin', '2017-03-31 11:45:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25537, '2017-03-31 00:00:00', NULL, NULL, 8153, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 10:23:36', 'admin-1490926551-14909270163386650', 1, 0, '', NULL, NULL, NULL),
(25538, '2017-03-31 11:14:17', NULL, NULL, 8152, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1490954852', 'admin', '2017-03-31 11:14:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25539, '2017-03-31 11:14:20', NULL, NULL, 8152, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 11:14:20', 'admin-1490926551-14909300607794092', 1, 0, '', NULL, NULL, NULL),
(25540, '2017-03-31 11:14:25', NULL, NULL, 8152, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 11:14:25', 'admin-1490926551-14909300651426180', 1, 1, 'SR', NULL, NULL, NULL),
(25541, '2017-03-31 00:00:00', NULL, NULL, 8153, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 10:23:36', 'admin-1490926551-14909270163386650', 1, 0, '', NULL, NULL, NULL),
(25542, '2017-03-31 00:00:00', NULL, NULL, 8154, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 10:13:21', 'admin-1490921958-14909264010678495', 1, 0, '', NULL, NULL, NULL),
(25543, '2017-03-31 12:03:22', NULL, NULL, 8155, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:03:22', 'admin-1490926551-14909330017604628', 1, 1, 'SR', NULL, NULL, NULL),
(25544, '2017-03-31 12:03:22', NULL, NULL, 8155, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:03:22', 'admin-1490926551-14909330017604628', 1, 1, 'SR', NULL, NULL, NULL),
(25545, '2017-03-31 12:03:22', NULL, NULL, 8155, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:03:22', 'admin-1490926551-14909330017604628', 1, 1, 'SR', NULL, NULL, NULL),
(25546, '2017-03-31 12:03:22', NULL, NULL, 8155, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:03:22', 'admin-1490926551-14909330017604628', 1, 0, '', NULL, NULL, NULL),
(25547, '2017-03-31 12:07:19', NULL, NULL, 8156, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:07:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25548, '2017-03-31 12:07:40', NULL, NULL, 8156, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:07:40', 'admin-1490926551-14909332604875646', 1, 1, 'SR', NULL, NULL, NULL),
(25549, '2017-03-31 12:07:40', NULL, NULL, 8156, 0, 181, '116', 'Open Food ', 'set', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:07:40', 'admin-1490926551-14909332604875646', 1, 0, '', NULL, NULL, NULL),
(25550, '2017-03-31 12:34:20', NULL, NULL, 8159, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:34:20', 'admin-1490934758-14909348600055073', 1, 1, 'SR', NULL, NULL, NULL),
(25551, '2017-03-31 12:20:41', NULL, NULL, 8157, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:20:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25552, '2017-03-31 12:07:40', NULL, NULL, 8156, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:07:40', 'admin-1490926551-14909332604875646', 1, 0, '', NULL, NULL, NULL),
(25553, '2017-03-31 12:07:40', NULL, NULL, 8156, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 12:07:40', 'admin-1490926551-14909332604875646', 1, 0, '', NULL, NULL, NULL),
(25554, '2017-03-31 10:13:13', NULL, NULL, 8151, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 10:13:13', 'admin-1490921958-1490926393479844', 1, 0, '', NULL, NULL, NULL),
(25555, '2017-03-31 09:42:32', NULL, NULL, 8147, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 09:42:32', 'admin-1490921958-14909245519488691', 1, 1, 'SR', NULL, NULL, NULL),
(25556, '2017-03-31 09:42:32', NULL, NULL, 8147, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 09:42:32', 'admin-1490921958-14909245519488691', 1, 1, 'SR', NULL, NULL, NULL),
(25557, '2017-03-31 09:40:08', NULL, NULL, 8149, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 09:40:08', 'admin-1490921958-14909244087399587', 1, 1, 'SR', NULL, NULL, NULL),
(25558, '2017-03-31 09:40:08', NULL, NULL, 8149, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 09:40:08', 'admin-1490921958-14909244087399587', 1, 1, 'SR', NULL, NULL, NULL),
(25559, '2017-03-31 09:27:58', NULL, NULL, 8148, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 09:27:58', 'admin-1490921958-14909236783693097', 1, 1, 'SR', NULL, NULL, NULL),
(25560, '2017-03-31 09:31:29', NULL, NULL, 8147, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 09:31:29', 'admin-1490921958-14909238889213447', 1, 0, '', NULL, NULL, NULL),
(25561, '2017-03-31 09:25:12', NULL, NULL, 8148, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 09:25:12', 'admin-1490921958-1490923512779991', 1, 1, 'SR', NULL, NULL, NULL),
(25562, '2017-03-31 09:27:58', NULL, NULL, 8148, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 09:27:58', 'admin-1490921958-14909236783693097', 1, 0, '', NULL, NULL, NULL),
(25563, '2017-03-31 09:25:04', NULL, NULL, 8148, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1490954852', 'admin', '2017-03-31 09:25:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25564, '2017-03-31 09:21:53', NULL, NULL, 8147, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 09:21:53', 'admin-1490921958-14909233132836018', 1, 1, 'SR', NULL, NULL, NULL),
(25565, '2017-03-31 09:21:53', NULL, NULL, 8147, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 09:21:53', 'admin-1490921958-14909233132836018', 1, 1, 'SR', NULL, NULL, NULL),
(25566, '2017-03-31 09:24:58', NULL, NULL, 8147, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1490954852', 'admin', '2017-03-31 09:24:58', 'admin-1490921958-14909234985841499', 1, 0, '', NULL, NULL, NULL),
(25567, '2017-03-31 09:21:48', NULL, NULL, 8147, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1490954852', 'admin', '2017-03-31 09:21:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25568, '2017-04-01 14:54:51', NULL, NULL, 8196, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:54:51', 'admin-1491026052-1491029691086946', 1, 1, 'SR', NULL, NULL, NULL),
(25569, '2017-04-01 14:33:24', NULL, NULL, 8195, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:33:24', 'admin-1491026052-14910284046747295', 1, 1, 'SR', NULL, NULL, NULL),
(25570, '2017-04-01 14:37:17', NULL, NULL, 8189, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:37:17', 'admin-1491026052-14910286373872835', 1, 0, '', NULL, NULL, NULL),
(25571, '2017-04-01 14:45:06', NULL, NULL, 8190, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:45:06', 'admin-1491026052-14910291064873412', 1, 1, 'SR', NULL, NULL, NULL),
(25572, '2017-04-01 14:53:09', NULL, NULL, 8196, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:53:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25573, '2017-04-01 14:54:51', NULL, NULL, 8196, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:54:51', 'admin-1491026052-1491029691086946', 1, 1, 'SR', NULL, NULL, NULL),
(25574, '2017-04-01 13:58:45', NULL, NULL, 8191, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 13:58:45', 'admin-1491026052-14910263249016756', 1, 1, 'SR', NULL, NULL, NULL),
(25575, '2017-04-01 09:26:17', NULL, NULL, 8173, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 09:26:17', 'admin-1491007994-14910099775991976', 1, 1, 'SR', NULL, NULL, NULL),
(25576, '2017-04-01 09:41:52', NULL, NULL, 8172, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 09:41:52', 'admin-1491007994-14910109124974462', 1, 1, 'SR', NULL, NULL, NULL),
(25577, '2017-04-01 10:10:46', NULL, NULL, 8174, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:10:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25578, '2017-04-01 00:00:00', NULL, NULL, 8198, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:03:28', 'admin-1491026052-14910266078722895', 1, 1, 'SR', NULL, NULL, NULL),
(25579, '2017-04-01 14:55:20', NULL, NULL, 8197, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:55:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25580, '2017-04-01 14:55:25', NULL, NULL, 8197, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:55:25', 'admin-1491026052-14910297255401379', 1, 1, 'SR', NULL, NULL, NULL),
(25581, '2017-04-01 14:54:51', NULL, NULL, 8196, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:54:51', 'admin-1491026052-1491029691086946', 1, 0, '', NULL, NULL, NULL),
(25582, '2017-04-01 14:54:51', NULL, NULL, 8196, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:54:51', 'admin-1491026052-1491029691086946', 1, 1, 'SR', NULL, NULL, NULL),
(25583, '2017-04-01 14:54:51', NULL, NULL, 8196, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:54:51', 'admin-1491026052-1491029691086946', 1, 1, 'SR', NULL, NULL, NULL),
(25584, '2017-04-01 14:03:11', NULL, NULL, 8192, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:03:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25585, '2017-04-01 14:09:01', NULL, NULL, 8193, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:09:01', 'admin-1491026052-14910269418007879', 1, 1, 'SR', NULL, NULL, NULL),
(25586, '2017-04-01 18:19:22', NULL, NULL, 8201, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 18:19:22', 'admin-1491026052-14910419619447070', 1, 0, '', NULL, NULL, NULL),
(25587, '2017-04-01 18:19:22', NULL, NULL, 8201, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 18:19:22', 'admin-1491026052-14910419619447070', 1, 1, 'SR', NULL, NULL, NULL),
(25588, '2017-04-01 17:20:10', NULL, NULL, 8199, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 17:20:10', 'admin-1491026052-14910384105176158', 1, 0, '', 1, NULL, NULL),
(25589, '2017-04-01 16:08:58', NULL, NULL, 8197, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 16:08:58', 'admin-1491026052-14910341380275971', 1, 0, '', NULL, NULL, NULL),
(25590, '2017-04-01 14:29:05', NULL, NULL, 8194, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:29:05', 'admin-1491026052-14910281451789789', 1, 1, 'SR', NULL, NULL, NULL),
(25591, '2017-04-01 14:58:50', NULL, NULL, 8198, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:58:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25592, '2017-04-01 17:44:52', NULL, NULL, 8200, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 17:44:52', 'admin-1491026052-14910398918847844', 1, 1, 'SR', NULL, NULL, NULL),
(25593, '2017-04-01 17:44:52', NULL, NULL, 8200, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 17:44:52', 'admin-1491026052-14910398918847844', 1, 1, 'SR', NULL, NULL, NULL),
(25594, '2017-04-01 17:44:52', NULL, NULL, 8200, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 17:44:52', 'admin-1491026052-14910398918847844', 1, 0, '', NULL, NULL, NULL),
(25595, '2017-04-01 14:33:07', NULL, NULL, 8188, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:33:07', 'admin-1491026052-14910283875751495', 1, 0, '', NULL, NULL, NULL),
(25596, '2017-04-01 14:33:07', NULL, NULL, 8188, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:33:07', 'admin-1491026052-14910283875751495', 1, 1, 'SR', NULL, NULL, NULL),
(25597, '2017-04-01 14:33:16', NULL, NULL, 8195, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:33:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25598, '2017-04-01 14:33:24', NULL, NULL, 8195, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:33:24', 'admin-1491026052-14910284046747295', 1, 1, 'SR', NULL, NULL, NULL),
(25599, '2017-04-01 14:10:17', NULL, NULL, 8193, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:10:17', 'admin-1491026052-14910270173305267', 1, 0, '', NULL, NULL, NULL),
(25600, '2017-04-01 10:21:44', NULL, NULL, 8176, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:21:44', 'admin-1491007994-14910133046336065', 1, 0, '', NULL, NULL, NULL),
(25601, '2017-04-01 10:21:44', NULL, NULL, 8176, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:21:44', 'admin-1491007994-14910133046336065', 1, 1, 'SR', NULL, NULL, NULL),
(25602, '2017-04-01 10:24:01', NULL, NULL, 8177, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:24:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25603, '2017-04-01 10:24:07', NULL, NULL, 8177, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:24:07', 'admin-1491007994-14910134477083310', 1, 0, '', NULL, NULL, NULL),
(25604, '2017-04-01 10:24:07', NULL, NULL, 8177, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:24:07', 'admin-1491007994-14910134477083310', 1, 0, '', NULL, NULL, NULL),
(25605, '2017-04-01 10:24:07', NULL, NULL, 8177, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:24:07', 'admin-1491007994-14910134477083310', 1, 0, '', NULL, NULL, NULL),
(25606, '2017-04-01 10:24:16', NULL, NULL, 8177, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:24:16', 'admin-1491007994-14910134567852740', 1, 1, 'SR', NULL, NULL, NULL),
(25607, '2017-04-01 10:11:30', NULL, NULL, 8174, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:11:30', 'admin-1491007994-14910126901315082', 1, 1, 'SR', NULL, NULL, NULL),
(25608, '2017-04-01 09:19:54', NULL, NULL, 8172, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 09:19:54', 'admin-1491007994-1491009594510275', 1, 0, '', NULL, NULL, NULL),
(25609, '2017-04-01 13:58:45', NULL, NULL, 8191, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 13:58:45', 'admin-1491026052-14910263249016756', 1, 0, '', NULL, NULL, NULL),
(25610, '2017-04-01 17:44:52', NULL, NULL, 8200, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 2, 11.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 17:44:52', 'admin-1491026052-14910398918847844', 1, 0, '', NULL, NULL, NULL),
(25611, '2017-04-01 17:43:36', NULL, NULL, 8200, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1491026052', 'admin', '2017-04-01 17:43:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25612, '2017-04-01 15:02:32', NULL, NULL, 8196, 0, 181, '116', 'Open Food ', 'Bread Pudding', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 15:02:32', 'admin-1491026052-14910301522944697', 1, 0, '', NULL, NULL, NULL),
(25613, '2017-04-01 13:57:40', NULL, NULL, 8191, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 13:57:40', 'admin-1491026052-14910262600094015', 1, 0, '', NULL, NULL, NULL),
(25614, '2017-04-01 13:41:51', NULL, NULL, 8189, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 13:41:51', 'admin-1491016270-14910253108217365', 1, 0, '', NULL, NULL, NULL),
(25615, '2017-04-01 13:52:15', NULL, NULL, 8190, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1491026052', 'admin', '2017-04-01 13:52:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25616, '2017-04-01 18:19:12', NULL, NULL, 8201, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1491026052', 'admin', '2017-04-01 18:19:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25617, '2017-04-01 14:33:24', NULL, NULL, 8195, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:33:24', 'admin-1491026052-14910284046747295', 1, 1, 'SR', NULL, NULL, NULL),
(25618, '2017-04-01 14:31:25', NULL, NULL, 8194, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:31:25', 'admin-1491026052-14910282850463163', 1, 0, '', NULL, NULL, NULL),
(25619, '2017-04-01 14:10:17', NULL, NULL, 8193, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:10:17', 'admin-1491026052-14910270173305267', 1, 0, '', NULL, NULL, NULL),
(25620, '2017-04-01 14:29:05', NULL, NULL, 8194, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:29:05', 'admin-1491026052-14910281451789789', 1, 1, 'SR', NULL, NULL, NULL),
(25621, '2017-04-01 14:28:57', NULL, NULL, 8194, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:28:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25622, '2017-04-01 14:10:17', NULL, NULL, 8193, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:10:17', 'admin-1491026052-14910270173305267', 1, 0, '', NULL, NULL, NULL),
(25623, '2017-04-01 14:09:01', NULL, NULL, 8193, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:09:01', 'admin-1491026052-14910269418007879', 1, 1, 'SR', NULL, NULL, NULL),
(25624, '2017-04-01 14:08:32', NULL, NULL, 8193, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:08:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25625, '2017-04-01 13:58:45', NULL, NULL, 8191, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 13:58:45', 'admin-1491026052-14910263249016756', 1, 0, '', NULL, NULL, NULL),
(25626, '2017-04-01 13:57:09', NULL, NULL, 8191, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 13:57:09', 'admin-1491026052-1491026228984978', 1, 0, '', NULL, NULL, NULL),
(25627, '2017-04-01 13:52:24', NULL, NULL, 8190, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 13:52:24', 'admin-1491016270-14910259445605243', 1, 1, 'SR', NULL, NULL, NULL),
(25628, '2017-04-01 13:53:59', NULL, NULL, 8191, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1491026052', 'admin', '2017-04-01 13:53:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25629, '2017-04-01 13:54:03', NULL, NULL, 8191, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 13:54:03', 'admin-1491016270-14910260430352319', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(25630, '2017-04-01 12:09:37', NULL, NULL, 8182, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 12:09:37', 'admin-1491016270-14910197772621283', 1, 1, 'SR', NULL, NULL, NULL),
(25631, '2017-04-01 12:13:49', NULL, NULL, 8183, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1491026052', 'admin', '2017-04-01 12:13:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25632, '2017-04-01 12:13:52', NULL, NULL, 8183, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 12:13:52', 'admin-1491016270-14910200323279717', 1, 1, 'SR', NULL, NULL, NULL),
(25633, '2017-04-01 12:13:52', NULL, NULL, 8183, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 12:13:52', 'admin-1491016270-14910200323279717', 1, 1, 'SR', NULL, NULL, NULL),
(25634, '2017-04-01 12:15:24', NULL, NULL, 8184, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.05, 0.0000, 0.0000, 5.05, 1, '27', 1, '1491026052', 'admin', '2017-04-01 12:15:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25635, '2017-04-01 12:16:13', NULL, NULL, 8184, 0, 74, '74', 'Sunrice', 'fried egg', 'Meals', 'Perfect Meals', 1, 14.50, 14.5000, 0.0000, 14.50, 1, '27', 1, '1491026052', 'admin', '2017-04-01 12:16:13', 'admin-1491016270-14910201730105046', 1, 1, 'SR', NULL, NULL, NULL),
(25636, '2017-04-01 12:16:13', NULL, NULL, 8184, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 12:16:13', 'admin-1491016270-14910201730105046', 1, 0, '', NULL, NULL, NULL),
(25637, '2017-04-01 13:41:51', NULL, NULL, 8189, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 13:41:51', 'admin-1491016270-14910253108217365', 1, 0, '', NULL, NULL, NULL),
(25638, '2017-04-01 13:41:51', NULL, NULL, 8189, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 13:41:51', 'admin-1491016270-14910253108217365', 1, 0, '', NULL, NULL, NULL),
(25639, '2017-04-01 13:41:37', NULL, NULL, 8189, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1491026052', 'admin', '2017-04-01 13:41:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25640, '2017-04-01 13:37:24', NULL, NULL, 8188, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 13:37:24', 'admin-1491016270-14910250441505138', 1, 0, '', NULL, NULL, NULL),
(25641, '2017-04-01 13:37:13', NULL, NULL, 8188, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1491026052', 'admin', '2017-04-01 13:37:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25642, '2017-04-01 13:21:57', NULL, NULL, 8187, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 13:21:57', 'admin-1491016270-1491024117240233', 1, 1, 'SR', NULL, NULL, NULL),
(25643, '2017-04-01 13:18:03', NULL, NULL, 8187, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 13:18:03', 'admin-1491016270-1491023883536450', 1, 0, '', NULL, NULL, NULL),
(25644, '2017-04-01 13:18:03', NULL, NULL, 8187, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 13:18:03', 'admin-1491016270-1491023883536450', 1, 0, '', NULL, NULL, NULL),
(25645, '2017-04-01 13:17:54', NULL, NULL, 8187, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1491026052', 'admin', '2017-04-01 13:17:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25646, '2017-04-01 13:01:24', NULL, NULL, 8186, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1491026052', 'admin', '2017-04-01 13:01:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25647, '2017-04-01 13:01:31', NULL, NULL, 8186, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 13:01:31', 'admin-1491016270-14910228917032335', 1, 1, 'SR', NULL, NULL, NULL),
(25648, '2017-04-01 11:52:58', NULL, NULL, 8181, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 11:52:58', 'admin-1491016270-14910187779005162', 1, 1, 'SR', 1, NULL, NULL),
(25649, '2017-04-01 12:49:23', NULL, NULL, 8185, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 12:49:23', 'admin-1491016270-14910221632282278', 1, 0, '', NULL, NULL, NULL),
(25650, '2017-04-01 12:49:23', NULL, NULL, 8185, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 12:49:23', 'admin-1491016270-14910221632282278', 1, 1, 'SR', NULL, NULL, NULL),
(25651, '2017-04-01 14:03:28', NULL, NULL, 8192, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 14:03:28', 'admin-1491026052-14910266078722895', 1, 1, 'SR', NULL, NULL, NULL),
(25652, '2017-04-01 12:49:23', NULL, NULL, 8185, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 12:49:23', 'admin-1491016270-14910221632282278', 1, 0, '', NULL, NULL, NULL),
(25653, '2017-04-01 12:16:13', NULL, NULL, 8184, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 12:16:13', 'admin-1491016270-14910201730105046', 1, 1, 'SR', NULL, NULL, NULL),
(25654, '2017-04-01 12:16:13', NULL, NULL, 8184, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 12:16:13', 'admin-1491016270-14910201730105046', 1, 1, 'SR', NULL, NULL, NULL),
(25655, '2017-04-01 09:26:17', NULL, NULL, 8173, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 09:26:17', 'admin-1491007994-14910099775991976', 1, 1, 'SR', NULL, NULL, NULL),
(25656, '2017-04-01 10:21:30', NULL, NULL, 8176, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:21:30', 'admin-1491007994-14910132905999243', 1, 0, '', NULL, NULL, NULL),
(25657, '2017-04-01 10:21:30', NULL, NULL, 8176, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:21:30', 'admin-1491007994-14910132905999243', 1, 0, '', NULL, NULL, NULL),
(25658, '2017-04-01 12:49:00', NULL, NULL, 8185, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 12:49:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25659, '2017-04-01 12:09:20', NULL, NULL, 8182, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1491026052', 'admin', '2017-04-01 12:09:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25660, '2017-04-01 11:52:58', NULL, NULL, 8181, 0, 181, '116', 'Open Food ', 'banana', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 11:52:58', 'admin-1491016270-14910187779005162', 1, 0, '', 1, NULL, NULL),
(25661, '2017-04-01 11:11:35', NULL, NULL, 8180, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 11:11:35', 'admin-1491016270-1491016295072824', 1, 1, 'SR', NULL, NULL, NULL),
(25662, '2017-04-01 11:11:35', NULL, NULL, 8180, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 11:11:35', 'admin-1491016270-1491016295072824', 1, 1, 'SR', NULL, NULL, NULL),
(25663, '2017-04-01 11:10:56', NULL, NULL, 8180, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 11:10:56', 'admin-1491007994-1491016256078563', 1, 0, '', NULL, NULL, NULL),
(25664, '2017-04-01 11:10:56', NULL, NULL, 8180, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 11:10:56', 'admin-1491007994-1491016256078563', 1, 0, '', NULL, NULL, NULL),
(25665, '2017-04-01 11:10:56', NULL, NULL, 8180, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 11:10:56', 'admin-1491007994-1491016256078563', 1, 0, '', NULL, NULL, NULL),
(25666, '2017-04-01 11:10:24', NULL, NULL, 8180, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1491026052', 'admin', '2017-04-01 11:10:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25667, '2017-04-01 10:56:48', NULL, NULL, 8179, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:56:48', 'admin-1491007994-14910154087689787', 1, 1, 'SR', NULL, NULL, NULL),
(25668, '2017-04-01 10:56:48', NULL, NULL, 8179, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:56:48', 'admin-1491007994-14910154087689787', 1, 1, 'SR', NULL, NULL, NULL),
(25669, '2017-04-01 10:56:41', NULL, NULL, 8179, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:56:41', 'admin-1491007994-1491015401007463', 1, 0, '', NULL, NULL, NULL),
(25670, '2017-04-01 10:56:41', NULL, NULL, 8179, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:56:41', 'admin-1491007994-1491015401007463', 1, 0, '', NULL, NULL, NULL),
(25671, '2017-04-01 10:56:33', NULL, NULL, 8179, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:56:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25672, '2017-04-01 10:50:01', NULL, NULL, 8178, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:50:01', 'admin-1491007994-14910150017404927', 1, 0, '', 1, NULL, NULL),
(25673, '2017-04-01 10:24:16', NULL, NULL, 8177, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:24:16', 'admin-1491007994-14910134567852740', 1, 1, 'SR', NULL, NULL, NULL),
(25674, '2017-04-01 10:24:16', NULL, NULL, 8177, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:24:16', 'admin-1491007994-14910134567852740', 1, 1, 'SR', NULL, NULL, NULL),
(25675, '2017-04-01 10:21:19', NULL, NULL, 8176, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:21:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25676, '2017-04-01 10:12:43', NULL, NULL, 8175, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:12:43', 'admin-1491007994-14910127633211878', 1, 1, 'SR', NULL, NULL, NULL),
(25677, '2017-04-01 10:12:34', NULL, NULL, 8175, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:12:34', 'admin-1491007994-1491012754511493', 1, 0, '', NULL, NULL, NULL),
(25678, '2017-04-01 10:12:34', NULL, NULL, 8175, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:12:34', 'admin-1491007994-1491012754511493', 1, 0, '', NULL, NULL, NULL),
(25679, '2017-04-01 10:12:43', NULL, NULL, 8175, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:12:43', 'admin-1491007994-14910127633211878', 1, 1, 'SR', NULL, NULL, NULL),
(25680, '2017-04-01 10:11:30', NULL, NULL, 8174, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:11:30', 'admin-1491007994-14910126901315082', 1, 1, 'SR', NULL, NULL, NULL),
(25681, '2017-04-01 10:12:27', NULL, NULL, 8175, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:12:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25682, '2017-04-01 10:11:30', NULL, NULL, 8174, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:11:30', 'admin-1491007994-14910126901315082', 1, 1, 'SR', NULL, NULL, NULL),
(25683, '2017-04-01 10:11:03', NULL, NULL, 8174, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:11:03', 'admin-1491007994-14910126628593486', 1, 0, '', NULL, NULL, NULL),
(25684, '2017-04-01 10:11:03', NULL, NULL, 8174, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:11:03', 'admin-1491007994-14910126628593486', 1, 0, '', NULL, NULL, NULL),
(25685, '2017-04-01 10:11:03', NULL, NULL, 8174, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 10:11:03', 'admin-1491007994-14910126628593486', 1, 0, '', NULL, NULL, NULL),
(25686, '2017-04-01 09:20:08', NULL, NULL, 8172, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 09:20:08', 'admin-1491007994-14910096087141290', 1, 0, '', NULL, NULL, NULL),
(25687, '2017-04-01 09:26:01', NULL, NULL, 8173, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1491026052', 'admin', '2017-04-01 09:26:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25688, '2017-04-01 09:19:54', NULL, NULL, 8172, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 09:19:54', 'admin-1491007994-1491009594510275', 1, 0, '', NULL, NULL, NULL),
(25689, '2017-04-01 09:14:23', NULL, NULL, 8172, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 09:14:23', 'admin-1491007994-14910092632618030', 1, 0, '', NULL, NULL, NULL),
(25690, '2017-04-01 09:14:23', NULL, NULL, 8172, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 09:14:23', 'admin-1491007994-14910092632618030', 1, 1, 'SR', NULL, NULL, NULL),
(25691, '2017-04-01 09:14:23', NULL, NULL, 8172, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491026052', 'admin', '2017-04-01 09:14:23', 'admin-1491007994-14910092632618030', 1, 1, 'SR', NULL, NULL, NULL),
(25692, '2017-04-01 09:14:11', NULL, NULL, 8172, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1491026052', 'admin', '2017-04-01 09:14:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25693, '2017-04-02 17:50:01', NULL, NULL, 8242, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 17:50:01', 'admin-1491109946-14911266012825059', 1, 1, 'SR', NULL, NULL, NULL),
(25694, '2017-04-02 17:50:01', NULL, NULL, 8242, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 17:50:01', 'admin-1491109946-14911266012825059', 1, 1, 'SR', NULL, NULL, NULL),
(25695, '2017-04-02 18:15:52', NULL, NULL, 8243, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1491109946', 'admin', '2017-04-02 18:15:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25696, '2017-04-02 18:16:07', NULL, NULL, 8243, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 18:16:07', 'admin-1491109946-1491128167167876', 1, 1, 'SR', NULL, NULL, NULL),
(25697, '2017-04-02 18:16:07', NULL, NULL, 8243, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 18:16:07', 'admin-1491109946-1491128167167876', 1, 0, '', NULL, NULL, NULL),
(25698, '2017-04-02 17:17:16', NULL, NULL, 8241, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1491109946', 'admin', '2017-04-02 17:17:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25699, '2017-04-02 17:17:19', NULL, NULL, 8241, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 17:17:19', 'admin-1491109946-14911246393829951', 1, 1, 'SR', NULL, NULL, NULL),
(25700, '2017-04-02 17:45:25', NULL, NULL, 8242, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1491109946', 'admin', '2017-04-02 17:45:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25701, '2017-04-02 14:33:19', NULL, NULL, 8232, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:33:19', 'admin-1491109946-14911147995263538', 1, 1, 'SR', NULL, NULL, NULL),
(25702, '2017-04-02 14:55:59', NULL, NULL, 8231, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:55:59', 'admin-1491109946-1491116159251726', 1, 0, '', NULL, NULL, NULL),
(25703, '2017-04-02 15:03:02', NULL, NULL, 8232, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 15:03:02', 'admin-1491109946-14911165821057773', 1, 1, 'SR', NULL, NULL, NULL),
(25704, '2017-04-02 15:38:05', NULL, NULL, 8233, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1491109946', 'admin', '2017-04-02 15:38:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25705, '2017-04-02 15:38:21', NULL, NULL, 8233, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 15:38:21', 'admin-1491109946-14911187012056047', 1, 0, '', NULL, NULL, NULL),
(25706, '2017-04-02 15:38:21', NULL, NULL, 8233, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 15:38:21', 'admin-1491109946-14911187012056047', 1, 1, 'SR', NULL, NULL, NULL),
(25707, '2017-04-02 15:38:21', NULL, NULL, 8233, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 15:38:21', 'admin-1491109946-14911187012056047', 1, 0, '', NULL, NULL, NULL),
(25708, '2017-04-02 15:53:03', NULL, NULL, 8234, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 15:53:03', 'admin-1491109946-14911195828723388', 1, 0, '', 1, NULL, NULL),
(25709, '2017-04-02 14:32:20', NULL, NULL, 8231, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:32:20', 'admin-1491109946-14911147401685857', 1, 1, 'SR', NULL, NULL, NULL),
(25710, '2017-04-02 14:32:20', NULL, NULL, 8231, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:32:20', 'admin-1491109946-14911147401685857', 1, 1, 'SR', NULL, NULL, NULL),
(25711, '2017-04-02 14:32:20', NULL, NULL, 8231, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:32:20', 'admin-1491109946-14911147401685857', 1, 0, '', NULL, NULL, NULL),
(25712, '2017-04-02 14:32:06', NULL, NULL, 8231, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:32:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25713, '2017-04-02 14:29:46', NULL, NULL, 8230, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:29:46', 'admin-1491109946-1491114585683938', 1, 1, 'SR', NULL, NULL, NULL),
(25714, '2017-04-02 14:29:46', NULL, NULL, 8230, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:29:46', 'admin-1491109946-1491114585683938', 1, 1, 'SR', NULL, NULL, NULL),
(25715, '2017-04-02 14:29:46', NULL, NULL, 8230, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:29:46', 'admin-1491109946-1491114585683938', 1, 1, 'SR', NULL, NULL, NULL),
(25716, '2017-04-02 14:29:46', NULL, NULL, 8230, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:29:46', 'admin-1491109946-1491114585683938', 1, 0, '', NULL, NULL, NULL),
(25717, '2017-04-02 14:29:45', NULL, NULL, 8230, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:29:45', 'admin-1491109946-1491114585683938', 1, 1, 'SR', NULL, NULL, NULL),
(25718, '2017-04-02 13:48:26', NULL, NULL, 8226, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:48:26', 'admin-1491109946-14911121066029498', 1, 0, '', NULL, NULL, NULL),
(25719, '2017-04-02 12:42:56', NULL, NULL, 8221, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:42:56', 'admin-1491103005-14911081758595764', 1, 1, 'SR', NULL, NULL, NULL),
(25720, '2017-04-02 12:46:34', NULL, NULL, 8222, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:46:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25721, '2017-04-02 11:33:32', NULL, NULL, 8214, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:33:32', 'admin-1491103005-14911040117955375', 1, 1, 'SR', NULL, NULL, NULL),
(25722, '2017-04-02 12:08:32', NULL, NULL, 8219, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:08:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25723, '2017-04-02 12:08:43', NULL, NULL, 8219, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:08:43', 'admin-1491103005-14911061230483348', 1, 0, '', NULL, NULL, NULL),
(25724, '2017-04-02 12:08:43', NULL, NULL, 8219, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:08:43', 'admin-1491103005-14911061230483348', 1, 0, '', NULL, NULL, NULL),
(25725, '2017-04-02 11:14:35', NULL, NULL, 8211, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:14:35', 'admin-1491100802-14911028750552527', 1, 1, 'SR', NULL, NULL, NULL),
(25726, '2017-04-02 11:16:24', NULL, NULL, 8211, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:16:24', 'admin-1491100802-14911029843355053', 1, 0, '', NULL, NULL, NULL),
(25727, '2017-04-02 09:49:23', NULL, NULL, 8203, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 09:49:23', 'admin-1491093991-14910977637136814', 1, 0, '', NULL, NULL, NULL),
(25728, '2017-04-02 19:10:51', NULL, NULL, 8244, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 19:10:51', 'admin-1491109946-14911314514014696', 1, 0, '', NULL, NULL, NULL),
(25729, '2017-04-02 19:10:51', NULL, NULL, 8244, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 19:10:51', 'admin-1491109946-14911314514014696', 1, 1, 'SR', NULL, NULL, NULL),
(25730, '2017-04-02 19:10:51', NULL, NULL, 8244, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 19:10:51', 'admin-1491109946-14911314514014696', 1, 0, '', NULL, NULL, NULL),
(25731, '2017-04-02 17:49:52', NULL, NULL, 8242, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 17:49:52', 'admin-1491109946-14911265926835737', 1, 1, 'SR', NULL, NULL, NULL),
(25732, '2017-04-02 16:50:08', NULL, NULL, 8240, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 16:50:08', 'admin-1491109946-14911230083435918', 1, 0, '', 1, NULL, NULL),
(25733, '2017-04-02 16:30:25', NULL, NULL, 8239, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 16:30:25', 'admin-1491109946-14911218252169730', 1, 0, '', NULL, NULL, NULL),
(25734, '2017-04-02 16:30:25', NULL, NULL, 8239, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 16:30:25', 'admin-1491109946-14911218252169730', 1, 0, '', NULL, NULL, NULL),
(25735, '2017-04-02 16:30:14', NULL, NULL, 8239, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1491109946', 'admin', '2017-04-02 16:30:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25736, '2017-04-02 14:08:46', NULL, NULL, 8229, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:08:46', 'admin-1491109946-14911133263327084', 1, 1, 'SR', NULL, NULL, NULL),
(25737, '2017-04-02 14:09:21', NULL, NULL, 8229, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:09:21', 'admin-1491109946-14911133609475463', 1, 1, 'SR', NULL, NULL, NULL),
(25738, '2017-04-02 13:48:26', NULL, NULL, 8226, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:48:26', 'admin-1491109946-14911121066029498', 1, 1, 'SR', NULL, NULL, NULL),
(25739, '2017-04-02 13:48:26', NULL, NULL, 8226, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:48:26', 'admin-1491109946-14911121066029498', 1, 1, 'SR', NULL, NULL, NULL),
(25740, '2017-04-02 13:48:26', NULL, NULL, 8226, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:48:26', 'admin-1491109946-14911121066029498', 1, 0, '', NULL, NULL, NULL),
(25741, '2017-04-02 13:48:26', NULL, NULL, 8226, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:48:26', 'admin-1491109946-14911121066029498', 1, 0, '', NULL, NULL, NULL),
(25742, '2017-04-02 13:48:12', NULL, NULL, 8226, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:48:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25743, '2017-04-02 11:33:34', NULL, NULL, 8215, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:33:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25744, '2017-04-02 11:33:43', NULL, NULL, 8215, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:33:43', 'admin-1491103005-14911040233607796', 1, 0, '', NULL, NULL, NULL),
(25745, '2017-04-02 11:33:43', NULL, NULL, 8215, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:33:43', 'admin-1491103005-14911040233607796', 1, 1, 'SR', NULL, NULL, NULL),
(25746, '2017-04-02 17:49:52', NULL, NULL, 8242, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 17:49:52', 'admin-1491109946-14911265926835737', 1, 1, 'SR', NULL, NULL, NULL),
(25747, '2017-04-02 20:05:56', NULL, NULL, 8247, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1491109946', 'admin', '2017-04-02 20:05:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25748, '2017-04-02 20:06:04', NULL, NULL, 8247, NULL, 57, '57', 'House Red Bottle', '', 'Cold Drinks', 'Wine', 1, 88.00, 88.0000, 0.0000, 88.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 20:06:04', 'admin-1491109946-1491134763791952', 1, 1, 'SR', NULL, NULL, NULL),
(25749, '2017-04-02 19:36:50', NULL, NULL, 8246, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1491109946', 'admin', '2017-04-02 19:36:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25750, '2017-04-02 19:36:56', NULL, NULL, 8246, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 19:36:56', 'admin-1491109946-14911330161885257', 1, 0, '', NULL, NULL, NULL),
(25751, '2017-04-02 19:37:46', NULL, NULL, 8246, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 19:37:46', 'admin-1491109946-14911330660985376', 1, 1, 'SR', NULL, NULL, NULL),
(25752, '2017-04-02 19:37:52', NULL, NULL, 8246, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 19:37:52', 'admin-1491109946-14911330718369256', 1, 1, 'SR', NULL, NULL, NULL),
(25753, '2017-04-02 15:58:24', NULL, NULL, 8235, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1491109946', 'admin', '2017-04-02 15:58:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25754, '2017-04-02 15:58:30', NULL, NULL, 8235, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 15:58:30', 'admin-1491109946-1491119909879676', 1, 0, '', NULL, NULL, NULL),
(25755, '2017-04-02 15:58:30', NULL, NULL, 8235, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 15:58:30', 'admin-1491109946-1491119909879676', 1, 1, 'SR', NULL, NULL, NULL),
(25756, '2017-04-02 16:02:17', NULL, NULL, 8236, 0, 265, '199', 'Old Penang PostCard', '', 'DISCOUNT ', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 16:02:17', 'admin-1491109946-14911201368704035', 1, 0, '', 1, NULL, NULL),
(25757, '2017-04-02 16:14:30', NULL, NULL, 8237, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 16:14:30', 'admin-1491109946-1491120870373495', 1, 1, 'SR', 1, NULL, NULL),
(25758, '2017-04-02 16:28:59', NULL, NULL, 8238, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1491109946', 'admin', '2017-04-02 16:28:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25759, '2017-04-02 14:08:46', NULL, NULL, 8229, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:08:46', 'admin-1491109946-14911133263327084', 1, 0, '', NULL, NULL, NULL),
(25760, '2017-04-02 14:08:46', NULL, NULL, 8229, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:08:46', 'admin-1491109946-14911133263327084', 1, 0, '', NULL, NULL, NULL),
(25761, '2017-04-02 14:08:40', NULL, NULL, 8229, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:08:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25762, '2017-04-02 14:06:23', NULL, NULL, 8228, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:06:23', 'admin-1491109946-14911131834346147', 1, 0, '', NULL, NULL, NULL),
(25763, '2017-04-02 14:06:23', NULL, NULL, 8228, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:06:23', 'admin-1491109946-14911131834346147', 1, 1, 'SR', NULL, NULL, NULL),
(25764, '2017-04-02 14:06:15', NULL, NULL, 8228, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:06:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25765, '2017-04-02 13:57:13', NULL, NULL, 8227, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:57:13', 'admin-1491109946-14911126327432718', 1, 0, '', NULL, NULL, NULL),
(25766, '2017-04-02 13:57:12', NULL, NULL, 8227, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:57:12', 'admin-1491109946-14911126327432718', 1, 1, 'SR', NULL, NULL, NULL),
(25767, '2017-04-02 13:57:12', NULL, NULL, 8227, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:57:12', 'admin-1491109946-14911126327432718', 1, 1, 'SR', NULL, NULL, NULL),
(25768, '2017-04-02 13:56:38', NULL, NULL, 8227, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:56:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25769, '2017-04-02 13:29:52', NULL, NULL, 8223, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:29:52', 'admin-1491109946-14911109926537233', 1, 1, 'SR', NULL, NULL, NULL),
(25770, '2017-04-02 13:33:25', NULL, NULL, 8218, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:33:25', 'admin-1491109946-14911112048135064', 1, 1, 'SR', NULL, NULL, NULL),
(25771, '2017-04-02 12:47:11', NULL, NULL, 8222, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:47:11', 'admin-1491103005-149110843125811', 1, 1, 'SR', NULL, NULL, NULL),
(25772, '2017-04-02 12:54:03', NULL, NULL, 8215, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:54:03', 'admin-1491103005-14911088434034110', 1, 1, 'SR', NULL, NULL, NULL),
(25773, '2017-04-02 11:37:20', NULL, NULL, 8216, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:37:20', 'admin-1491103005-14911042399497061', 1, 1, 'SR', NULL, NULL, NULL),
(25774, '2017-04-02 11:45:07', NULL, NULL, 8217, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:45:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25775, '2017-04-02 11:45:34', NULL, NULL, 8217, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:45:34', 'admin-1491103005-14911047345753852', 1, 0, '', NULL, NULL, NULL),
(25776, '2017-04-02 19:18:27', NULL, NULL, 8245, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 19:18:27', 'admin-1491109946-14911319076983966', 1, 1, 'SR', NULL, NULL, NULL),
(25777, '2017-04-02 19:18:19', NULL, NULL, 8245, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 19:18:19', 'admin-1491109946-14911318996731192', 1, 0, '', NULL, NULL, NULL),
(25778, '2017-04-02 13:09:29', NULL, NULL, 8224, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:09:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25779, '2017-04-02 13:09:49', NULL, NULL, 8224, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:09:49', 'admin-1491103005-14911097894476496', 1, 0, '', NULL, NULL, NULL),
(25780, '2017-04-02 13:09:49', NULL, NULL, 8224, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:09:49', 'admin-1491103005-14911097894476496', 1, 0, '', NULL, NULL, NULL),
(25781, '2017-04-02 12:58:31', NULL, NULL, 8223, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:58:31', 'admin-1491103005-1491109111623455', 1, 0, '', NULL, NULL, NULL),
(25782, '2017-04-02 19:10:51', NULL, NULL, 8244, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 19:10:51', 'admin-1491109946-14911314514014696', 1, 0, '', NULL, NULL, NULL),
(25783, '2017-04-02 19:10:06', NULL, NULL, 8244, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1491109946', 'admin', '2017-04-02 19:10:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25784, '2017-04-02 12:42:56', NULL, NULL, 8221, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:42:56', 'admin-1491103005-14911081758595764', 1, 1, 'SR', NULL, NULL, NULL),
(25785, '2017-04-02 12:42:41', NULL, NULL, 8221, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:42:41', 'admin-1491103005-14911081607971447', 1, 0, '', NULL, NULL, NULL),
(25786, '2017-04-02 12:42:41', NULL, NULL, 8221, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:42:41', 'admin-1491103005-14911081607971447', 1, 0, '', NULL, NULL, NULL),
(25787, '2017-04-02 12:42:41', NULL, NULL, 8221, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:42:41', 'admin-1491103005-14911081607971447', 1, 1, 'SR', NULL, NULL, NULL),
(25788, '2017-04-02 13:29:45', NULL, NULL, 8223, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:29:45', 'admin-1491109946-14911109852526544', 1, 0, '', NULL, NULL, NULL),
(25789, '2017-04-02 13:12:45', NULL, NULL, 8225, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:12:45', 'admin-1491109946-14911099654314685', 1, 1, 'SR', NULL, NULL, NULL),
(25790, '2017-04-02 13:12:45', NULL, NULL, 8225, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:12:45', 'admin-1491109946-14911099654314685', 1, 0, '', NULL, NULL, NULL),
(25791, '2017-04-02 13:11:57', NULL, NULL, 8225, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:11:57', 'admin-1491103005-14911099173399910', 1, 0, '', NULL, NULL, NULL),
(25792, '2017-04-02 13:11:57', NULL, NULL, 8225, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:11:57', 'admin-1491103005-14911099173399910', 1, 0, '', NULL, NULL, NULL),
(25793, '2017-04-02 13:11:41', NULL, NULL, 8225, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:11:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25794, '2017-04-02 09:54:04', NULL, NULL, 8204, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 09:54:04', 'admin-1491093991-14910980444693056', 1, 0, '', NULL, NULL, NULL),
(25795, '2017-04-02 13:09:49', NULL, NULL, 8224, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:09:49', 'admin-1491103005-14911097894476496', 1, 1, 'SR', NULL, NULL, NULL),
(25796, '2017-04-02 19:18:27', NULL, NULL, 8245, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 19:18:27', 'admin-1491109946-14911319076983966', 1, 0, '', NULL, NULL, NULL),
(25797, '2017-04-02 17:49:52', NULL, NULL, 8242, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 17:49:52', 'admin-1491109946-14911265926835737', 1, 1, 'SR', NULL, NULL, NULL),
(25798, '2017-04-02 14:33:19', NULL, NULL, 8232, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:33:19', 'admin-1491109946-14911147995263538', 1, 0, '', NULL, NULL, NULL),
(25799, '2017-04-02 19:13:29', NULL, NULL, 8245, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1491109946', 'admin', '2017-04-02 19:13:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25800, '2017-04-02 14:29:45', NULL, NULL, 8230, 0, 153, '87', 'Wake Me Up!', ' replace with bacon,no sausage', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:29:45', 'admin-1491109946-1491114585683938', 1, 0, '', NULL, NULL, NULL),
(25801, '2017-04-02 13:29:52', NULL, NULL, 8223, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:29:52', 'admin-1491109946-14911109926537233', 1, 1, 'SR', NULL, NULL, NULL),
(25802, '2017-04-02 13:02:11', NULL, NULL, 8223, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:02:11', 'admin-1491103005-14911093314042417', 1, 1, 'SR', NULL, NULL, NULL),
(25803, '2017-04-02 13:02:11', NULL, NULL, 8223, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:02:11', 'admin-1491103005-14911093314042417', 1, 1, 'SR', NULL, NULL, NULL),
(25804, '2017-04-02 19:18:19', NULL, NULL, 8245, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 19:18:19', 'admin-1491109946-14911318996731192', 1, 1, 'SR', NULL, NULL, NULL),
(25805, '2017-04-02 14:33:10', NULL, NULL, 8232, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:33:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25806, '2017-04-02 13:09:49', NULL, NULL, 8224, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 13:09:49', 'admin-1491103005-14911097894476496', 1, 1, 'SR', NULL, NULL, NULL),
(25807, '2017-04-02 12:08:43', NULL, NULL, 8219, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:08:43', 'admin-1491103005-14911061230483348', 1, 0, '', NULL, NULL, NULL),
(25808, '2017-04-02 12:13:49', NULL, NULL, 8220, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:13:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25809, '2017-04-02 12:14:06', NULL, NULL, 8220, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:14:06', 'admin-1491103005-14911064461391183', 1, 0, '', NULL, NULL, NULL),
(25810, '2017-04-02 11:37:08', NULL, NULL, 8216, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:37:08', 'admin-1491103005-14911042283581262', 1, 0, '', NULL, NULL, NULL),
(25811, '2017-04-02 12:42:08', NULL, NULL, 8221, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:42:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25812, '2017-04-02 12:14:06', NULL, NULL, 8220, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:14:06', 'admin-1491103005-14911064461391183', 1, 0, '', NULL, NULL, NULL),
(25813, '2017-04-02 12:14:06', NULL, NULL, 8220, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:14:06', 'admin-1491103005-14911064461391183', 1, 1, 'SR', NULL, NULL, NULL),
(25814, '2017-04-02 12:14:43', NULL, NULL, 8220, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:14:43', 'admin-1491103005-1491106482878704', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(25815, '2017-04-02 12:36:33', NULL, NULL, 8217, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:36:33', 'admin-1491103005-14911077931792264', 1, 0, '', NULL, NULL, NULL),
(25816, '2017-04-02 12:14:06', NULL, NULL, 8220, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:14:06', 'admin-1491103005-14911064461391183', 1, 1, 'SR', NULL, NULL, NULL),
(25817, '2017-04-02 11:17:13', NULL, NULL, 8212, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:17:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25818, '2017-04-02 11:29:45', NULL, NULL, 8213, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:29:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25819, '2017-04-02 11:29:51', NULL, NULL, 8213, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:29:51', 'admin-1491103005-14911037912151676', 1, 1, 'SR', NULL, NULL, NULL),
(25820, '2017-04-02 11:33:32', NULL, NULL, 8214, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:33:32', 'admin-1491103005-14911040117955375', 1, 0, '', NULL, NULL, NULL),
(25821, '2017-04-02 11:33:32', NULL, NULL, 8214, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:33:32', 'admin-1491103005-14911040117955375', 1, 0, '', NULL, NULL, NULL),
(25822, '2017-04-02 14:29:08', NULL, NULL, 8230, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1491109946', 'admin', '2017-04-02 14:29:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25823, '2017-04-02 12:58:24', NULL, NULL, 8223, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:58:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25824, '2017-04-02 11:14:35', NULL, NULL, 8211, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:14:35', 'admin-1491100802-14911028750552527', 1, 1, 'SR', NULL, NULL, NULL),
(25825, '2017-04-02 12:47:11', NULL, NULL, 8222, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:47:11', 'admin-1491103005-149110843125811', 1, 0, '', NULL, NULL, NULL),
(25826, '2017-04-02 12:07:43', NULL, NULL, 8215, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 12:07:43', 'admin-1491103005-14911060631249726', 1, 1, 'SR', NULL, NULL, NULL),
(25827, '2017-04-02 11:59:16', NULL, NULL, 8218, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:59:16', 'admin-1491103005-14911055560548520', 1, 1, 'SR', NULL, NULL, NULL),
(25828, '2017-04-02 11:59:16', NULL, NULL, 8218, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:59:16', 'admin-1491103005-14911055560548520', 1, 1, 'SR', NULL, NULL, NULL),
(25829, '2017-04-02 11:58:59', NULL, NULL, 8218, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:58:59', 'admin-1491103005-14911055391038087', 1, 0, '', NULL, NULL, NULL),
(25830, '2017-04-02 11:58:59', NULL, NULL, 8218, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:58:59', 'admin-1491103005-14911055391038087', 1, 0, '', NULL, NULL, NULL),
(25831, '2017-04-02 11:58:59', NULL, NULL, 8218, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:58:59', 'admin-1491103005-14911055391038087', 1, 0, '', NULL, NULL, NULL),
(25832, '2017-04-02 11:58:47', NULL, NULL, 8218, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:58:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25833, '2017-04-02 11:45:54', NULL, NULL, 8217, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:45:54', 'admin-1491103005-1491104754076552', 1, 1, 'SR', NULL, NULL, NULL),
(25834, '2017-04-02 11:45:54', NULL, NULL, 8217, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:45:54', 'admin-1491103005-1491104754076552', 1, 0, '', NULL, NULL, NULL),
(25835, '2017-04-02 11:45:34', NULL, NULL, 8217, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:45:34', 'admin-1491103005-14911047345753852', 1, 0, '', NULL, NULL, NULL),
(25836, '2017-04-02 11:37:08', NULL, NULL, 8216, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:37:08', 'admin-1491103005-14911042283581262', 1, 0, '', NULL, NULL, NULL),
(25837, '2017-04-02 11:36:54', NULL, NULL, 8216, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:36:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25838, '2017-04-02 10:58:28', NULL, NULL, 8209, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:58:28', 'admin-1491100802-14911019079814256', 1, 1, 'SR', NULL, NULL, NULL),
(25839, '2017-04-02 11:00:33', NULL, NULL, 8210, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:00:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25840, '2017-04-02 11:00:39', NULL, NULL, 8210, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:00:39', 'admin-1491100802-14911020397592541', 1, 0, '', NULL, NULL, NULL),
(25841, '2017-04-02 11:00:39', NULL, NULL, 8210, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:00:39', 'admin-1491100802-14911020397592541', 1, 1, 'SR', NULL, NULL, NULL),
(25842, '2017-04-02 11:01:14', NULL, NULL, 8209, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:01:14', 'admin-1491100802-14911020746437696', 1, 0, '', NULL, NULL, NULL),
(25843, '2017-04-02 11:33:21', NULL, NULL, 8214, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:33:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25844, '2017-04-02 11:17:18', NULL, NULL, 8212, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:17:18', 'admin-1491103005-14911030383456568', 1, 1, 'SR', NULL, NULL, NULL),
(25845, '2017-04-02 11:16:24', NULL, NULL, 8211, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:16:24', 'admin-1491100802-14911029843355053', 1, 0, '', NULL, NULL, NULL),
(25846, '2017-04-02 11:17:18', NULL, NULL, 8212, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:17:18', 'admin-1491103005-14911030383456568', 1, 0, '', NULL, NULL, NULL),
(25847, '2017-04-02 11:13:36', NULL, NULL, 8211, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:13:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25848, '2017-04-02 11:16:24', NULL, NULL, 8211, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 11:16:24', 'admin-1491100802-14911029843355053', 1, 0, '', NULL, NULL, NULL),
(25849, '2017-04-02 10:42:12', NULL, NULL, 8208, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:42:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25850, '2017-04-02 09:50:14', NULL, NULL, 8203, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 09:50:14', 'admin-1491093991-14910978147465273', 1, 1, 'SR', NULL, NULL, NULL),
(25851, '2017-04-02 10:38:45', NULL, NULL, 8207, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:38:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25852, '2017-04-02 10:39:32', NULL, NULL, 8207, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:39:32', 'admin-1491093991-14911007726291325', 1, 0, '', NULL, NULL, NULL),
(25853, '2017-04-02 10:58:28', NULL, NULL, 8209, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:58:28', 'admin-1491100802-14911019079814256', 1, 1, 'SR', NULL, NULL, NULL),
(25854, '2017-04-02 10:58:28', NULL, NULL, 8209, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:58:28', 'admin-1491100802-14911019079814256', 1, 1, 'SR', NULL, NULL, NULL),
(25855, '2017-04-02 10:58:28', NULL, NULL, 8209, 0, 182, '117', 'Open Drinks ', 'extra shot', 'Cold Drinks', 'Fresh Juice', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:58:28', 'admin-1491100802-14911019079814256', 1, 0, '', NULL, NULL, NULL),
(25856, '2017-04-02 10:57:18', NULL, NULL, 8209, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:57:18', 'admin-1491100802-14911018379595639', 1, 0, '', NULL, NULL, NULL),
(25857, '2017-04-02 10:56:32', NULL, NULL, 8209, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.65, 0.0000, 0.0000, 8.65, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:56:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25858, '2017-04-02 10:56:43', NULL, NULL, 8209, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:56:43', 'admin-1491100802-14911018032382281', 1, 0, '', NULL, NULL, NULL),
(25859, '2017-04-02 10:42:36', NULL, NULL, 8208, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:42:36', 'admin-1491100802-14911009564699925', 1, 1, 'SR', NULL, NULL, NULL),
(25860, '2017-04-02 10:42:36', NULL, NULL, 8208, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:42:36', 'admin-1491100802-14911009564699925', 1, 1, 'SR', NULL, NULL, NULL),
(25861, '2017-04-02 10:42:36', NULL, NULL, 8208, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:42:36', 'admin-1491100802-14911009564699925', 1, 0, '', NULL, NULL, NULL),
(25862, '2017-04-02 10:26:09', NULL, NULL, 8206, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:26:09', 'admin-1491093991-1491099968855577', 1, 1, 'SR', NULL, NULL, NULL),
(25863, '2017-04-02 10:42:36', NULL, NULL, 8208, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:42:36', 'admin-1491100802-14911009564699925', 1, 0, '', NULL, NULL, NULL),
(25864, '2017-04-02 10:39:32', NULL, NULL, 8207, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:39:32', 'admin-1491093991-14911007726291325', 1, 0, '', NULL, NULL, NULL),
(25865, '2017-04-02 10:40:28', NULL, NULL, 8207, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:40:28', 'admin-1491100802-14911008286898355', 1, 0, '', NULL, NULL, NULL),
(25866, '2017-04-02 10:40:28', NULL, NULL, 8207, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:40:28', 'admin-1491100802-14911008286898355', 1, 1, 'SR', NULL, NULL, NULL),
(25867, '2017-04-02 10:03:36', NULL, NULL, 8205, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:03:36', 'admin-1491093991-14910986162114688', 1, 1, 'SR', NULL, NULL, NULL),
(25868, '2017-04-02 10:03:36', NULL, NULL, 8205, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:03:36', 'admin-1491093991-14910986162114688', 1, 1, 'SR', NULL, NULL, NULL),
(25869, '2017-04-02 10:26:09', NULL, NULL, 8206, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:26:09', 'admin-1491093991-1491099968855577', 1, 0, '', NULL, NULL, NULL),
(25870, '2017-04-02 10:26:09', NULL, NULL, 8206, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:26:09', 'admin-1491093991-1491099968855577', 1, 1, 'SR', NULL, NULL, NULL),
(25871, '2017-04-02 16:29:05', NULL, NULL, 8238, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 16:29:05', 'admin-1491109946-1491121745046438', 1, 1, 'SR', NULL, NULL, NULL),
(25872, '2017-04-02 10:25:48', NULL, NULL, 8206, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:25:48', 'admin-1491093991-14910999480599055', 1, 0, '', NULL, NULL, NULL),
(25873, '2017-04-02 10:25:48', NULL, NULL, 8206, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:25:48', 'admin-1491093991-14910999480599055', 1, 0, '', NULL, NULL, NULL),
(25874, '2017-04-02 10:25:48', NULL, NULL, 8206, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:25:48', 'admin-1491093991-14910999480599055', 1, 0, '', NULL, NULL, NULL),
(25875, '2017-04-02 10:26:09', NULL, NULL, 8206, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:26:09', 'admin-1491093991-1491099968855577', 1, 1, 'SR', NULL, NULL, NULL),
(25876, '2017-04-02 10:03:24', NULL, NULL, 8205, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:03:24', 'admin-1491093991-14910986043371420', 1, 0, '', NULL, NULL, NULL),
(25877, '2017-04-02 10:03:24', NULL, NULL, 8205, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:03:24', 'admin-1491093991-14910986043371420', 1, 0, '', NULL, NULL, NULL),
(25878, '2017-04-02 09:54:11', NULL, NULL, 8204, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 09:54:11', 'admin-1491093991-14910980517008510', 1, 0, '', NULL, NULL, NULL),
(25879, '2017-04-02 10:03:12', NULL, NULL, 8205, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:03:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25880, '2017-04-02 09:50:14', NULL, NULL, 8203, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 09:50:14', 'admin-1491093991-14910978147465273', 1, 1, 'SR', NULL, NULL, NULL),
(25881, '2017-04-02 09:53:50', NULL, NULL, 8204, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 09:53:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25882, '2017-04-02 09:54:04', NULL, NULL, 8204, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 09:54:04', 'admin-1491093991-14910980444693056', 1, 0, '', NULL, NULL, NULL),
(25883, '2017-04-02 09:49:23', NULL, NULL, 8203, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 09:49:23', 'admin-1491093991-14910977637136814', 1, 0, '', NULL, NULL, NULL),
(25884, '2017-04-02 09:48:43', NULL, NULL, 8203, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1491109946', 'admin', '2017-04-02 09:48:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25885, '2017-04-02 09:49:23', NULL, NULL, 8203, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 09:49:23', 'admin-1491093991-14910977637136814', 1, 0, '', NULL, NULL, NULL),
(25886, '2017-04-02 10:25:20', NULL, NULL, 8206, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.50, 0.0000, 0.0000, 9.50, 1, '27', 1, '1491109946', 'admin', '2017-04-02 10:25:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25887, '2017-04-02 09:08:03', NULL, NULL, 8202, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 09:08:03', 'admin-1491093991-14910952833873039', 1, 0, '', NULL, NULL, NULL),
(25888, '2017-04-02 09:07:51', NULL, NULL, 8202, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 09:07:51', 'admin-1491093991-1491095270937946', 1, 1, 'SR', NULL, NULL, NULL),
(25889, '2017-04-02 09:07:51', NULL, NULL, 8202, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 09:07:51', 'admin-1491093991-1491095270937946', 1, 1, 'SR', NULL, NULL, NULL),
(25890, '2017-04-02 09:08:03', NULL, NULL, 8202, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491109946', 'admin', '2017-04-02 09:08:03', 'admin-1491093991-14910952833873039', 1, 0, '', NULL, NULL, NULL),
(25891, '2017-04-02 09:07:40', NULL, NULL, 8202, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1491109946', 'admin', '2017-04-02 09:07:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25892, '2017-04-03 17:21:16', NULL, NULL, 8272, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 17:21:16', 'admin-1491196225-14912112765978587', 1, 1, 'SR', NULL, NULL, NULL),
(25893, '2017-04-03 17:44:42', NULL, NULL, 8273, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1491196225', 'admin', '2017-04-03 17:44:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25894, '2017-04-03 17:45:02', NULL, NULL, 8273, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 17:45:02', 'admin-1491196225-14912127023244083', 1, 1, 'SR', NULL, NULL, NULL),
(25895, '2017-04-03 17:56:37', NULL, NULL, 8275, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1491196225', 'admin', '2017-04-03 17:56:37', 'admin-1491196225-14912133976195736', 1, 0, '', NULL, NULL, NULL),
(25896, '2017-04-03 16:16:32', NULL, NULL, 8269, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1491196225', 'admin', '2017-04-03 16:16:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25897, '2017-04-03 16:16:37', NULL, NULL, 8269, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 16:16:37', 'admin-1491196225-14912073975812340', 1, 1, 'SR', NULL, NULL, NULL),
(25898, '2017-04-03 16:16:39', NULL, NULL, 8270, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1491196225', 'admin', '2017-04-03 16:16:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25899, '2017-04-03 16:16:43', NULL, NULL, 8270, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 16:16:43', 'admin-1491196225-14912074030766732', 1, 0, '', NULL, NULL, NULL),
(25900, '2017-04-03 16:24:20', NULL, NULL, 8271, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1491196225', 'admin', '2017-04-03 16:24:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25901, '2017-04-03 13:13:22', NULL, NULL, 8259, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1491196225', 'admin', '2017-04-03 13:13:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25902, '2017-04-03 13:19:09', NULL, NULL, 8257, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 13:19:09', 'admin-1491196225-14911967488905667', 1, 1, 'SR', NULL, NULL, NULL),
(25903, '2017-04-03 16:24:28', NULL, NULL, 8271, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 16:24:28', 'admin-1491196225-14912078678809733', 1, 1, 'SR', NULL, NULL, NULL),
(25904, '2017-04-03 16:24:28', NULL, NULL, 8271, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 16:24:28', 'admin-1491196225-14912078678809733', 1, 1, 'SR', NULL, NULL, NULL),
(25905, '2017-04-03 16:58:04', NULL, NULL, 8254, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 16:58:04', 'admin-1491196225-14912098838692831', 1, 1, 'SR', NULL, NULL, NULL),
(25906, '2017-04-03 15:10:58', NULL, NULL, 8267, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 15:10:58', 'admin-1491196225-1491203458736986', 1, 1, 'SR', NULL, NULL, NULL),
(25907, '2017-04-03 15:10:58', NULL, NULL, 8267, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 15:10:58', 'admin-1491196225-1491203458736986', 1, 1, 'SR', NULL, NULL, NULL),
(25908, '2017-04-03 15:10:58', NULL, NULL, 8267, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 15:10:58', 'admin-1491196225-1491203458736986', 1, 1, 'SR', NULL, NULL, NULL),
(25909, '2017-04-03 17:45:02', NULL, NULL, 8273, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 17:45:02', 'admin-1491196225-14912127023244083', 1, 1, 'SR', NULL, NULL, NULL),
(25910, '2017-04-03 17:56:37', NULL, NULL, 8275, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 17:56:37', 'admin-1491196225-14912133976195736', 1, 1, 'SR', NULL, NULL, NULL),
(25911, '2017-04-03 14:18:55', NULL, NULL, 8259, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 14:18:55', 'admin-1491196225-14912003357419739', 1, 1, 'SR', NULL, NULL, NULL),
(25912, '2017-04-03 17:56:37', NULL, NULL, 8275, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 17:56:37', 'admin-1491196225-14912133976195736', 1, 0, '', NULL, NULL, NULL),
(25913, '2017-04-03 14:48:35', NULL, NULL, 8265, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 14:48:35', 'admin-1491196225-1491202115225653', 1, 1, 'SR', NULL, NULL, NULL),
(25914, '2017-04-03 14:53:18', NULL, NULL, 8262, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 14:53:18', 'admin-1491196225-14912023981925285', 1, 0, '', NULL, NULL, NULL),
(25915, '2017-04-03 15:01:42', NULL, NULL, 8266, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 15:01:42', 'admin-1491196225-14912029019013716', 1, 1, 'SR', 1, NULL, NULL),
(25916, '2017-04-03 15:04:05', NULL, NULL, 8254, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 15:04:05', 'admin-1491196225-14912030456114278', 1, 1, 'SR', NULL, NULL, NULL),
(25917, '2017-04-03 15:10:40', NULL, NULL, 8267, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1491196225', 'admin', '2017-04-03 15:10:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25918, '2017-04-03 15:10:58', NULL, NULL, 8267, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 15:10:58', 'admin-1491196225-1491203458736986', 1, 1, 'SR', NULL, NULL, NULL),
(25919, '2017-04-03 17:56:37', NULL, NULL, 8275, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 17:56:37', 'admin-1491196225-14912133976195736', 1, 1, 'SR', NULL, NULL, NULL),
(25920, '2017-04-03 11:08:41', NULL, NULL, 8253, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 11:08:41', 'admin-1491179430-14911889213728260', 1, 1, 'SR', 1, NULL, NULL),
(25921, '2017-04-03 12:25:06', NULL, NULL, 8254, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1491196225', 'admin', '2017-04-03 12:25:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25922, '2017-04-03 12:27:37', NULL, NULL, 8254, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 12:27:37', 'admin-1491179430-14911936575327628', 1, 0, '', NULL, NULL, NULL),
(25923, '2017-04-03 12:27:37', NULL, NULL, 8254, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 12:27:37', 'admin-1491179430-14911936575327628', 1, 0, '', NULL, NULL, NULL),
(25924, '2017-04-03 17:55:57', NULL, NULL, 8274, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 17:55:57', 'admin-1491196225-14912133572285173', 1, 0, '', 1, NULL, NULL),
(25925, '2017-04-03 17:56:11', NULL, NULL, 8275, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.89, 0.0000, 0.0000, 2.89, 1, '27', 1, '1491196225', 'admin', '2017-04-03 17:56:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25926, '2017-04-03 16:24:28', NULL, NULL, 8271, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 16:24:28', 'admin-1491196225-14912078678809733', 1, 1, 'SR', NULL, NULL, NULL),
(25927, '2017-04-03 15:50:53', NULL, NULL, 8268, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 15:50:53', 'admin-1491196225-14912058535154675', 1, 1, 'SR', NULL, NULL, NULL),
(25928, '2017-04-03 15:50:46', NULL, NULL, 8268, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 15:50:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25929, '2017-04-03 15:22:36', NULL, NULL, 8265, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 15:22:36', 'admin-1491196225-1491204156340410', 1, 0, '', NULL, NULL, NULL),
(25930, '2017-04-03 15:10:58', NULL, NULL, 8267, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 15:10:58', 'admin-1491196225-1491203458736986', 1, 1, 'SR', NULL, NULL, NULL),
(25931, '2017-04-03 15:10:59', NULL, NULL, 8267, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 15:10:59', 'admin-1491196225-1491203458736986', 1, 1, 'SR', NULL, NULL, NULL),
(25932, '2017-04-03 14:02:02', NULL, NULL, 8263, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 14:02:02', 'admin-1491196225-14911993224541234', 1, 1, 'SR', NULL, NULL, NULL),
(25933, '2017-04-03 14:39:00', NULL, NULL, 8264, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1491196225', 'admin', '2017-04-03 14:39:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25934, '2017-04-03 14:39:02', NULL, NULL, 8264, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 14:39:02', 'admin-1491196225-14912015423451725', 1, 1, 'SR', NULL, NULL, NULL),
(25935, '2017-04-03 14:48:29', NULL, NULL, 8265, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1491196225', 'admin', '2017-04-03 14:48:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25936, '2017-04-03 14:48:35', NULL, NULL, 8265, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 14:48:35', 'admin-1491196225-1491202115225653', 1, 1, 'SR', NULL, NULL, NULL),
(25937, '2017-04-03 13:56:37', NULL, NULL, 8261, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 13:56:37', 'admin-1491196225-14911989975725437', 1, 1, 'SR', 1, NULL, NULL),
(25938, '2017-04-03 13:56:37', NULL, NULL, 8261, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 13:56:37', 'admin-1491196225-14911989975725437', 1, 1, 'SR', 1, NULL, NULL),
(25939, '2017-04-03 13:57:33', NULL, NULL, 8262, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1491196225', 'admin', '2017-04-03 13:57:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25940, '2017-04-03 13:58:03', NULL, NULL, 8262, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 13:58:03', 'admin-1491196225-14911990836999850', 1, 0, '', NULL, NULL, NULL),
(25941, '2017-04-03 13:58:03', NULL, NULL, 8262, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 13:58:03', 'admin-1491196225-14911990836999850', 1, 0, '', NULL, NULL, NULL),
(25942, '2017-04-03 14:18:55', NULL, NULL, 8259, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 14:18:55', 'admin-1491196225-14912003357419739', 1, 1, 'SR', NULL, NULL, NULL),
(25943, '2017-04-03 14:09:56', NULL, NULL, 8258, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1491196225', 'admin', '2017-04-03 14:09:56', 'admin-1491196225-14911997962527231', 1, 0, '', NULL, NULL, NULL),
(25944, '2017-04-03 14:09:56', NULL, NULL, 8258, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1491196225', 'admin', '2017-04-03 14:09:56', 'admin-1491196225-14911997962527231', 1, 0, '', NULL, NULL, NULL),
(25945, '2017-04-03 13:58:03', NULL, NULL, 8262, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 13:58:03', 'admin-1491196225-14911990836999850', 1, 0, '', NULL, NULL, NULL),
(25946, '2017-04-03 14:01:55', NULL, NULL, 8263, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1491196225', 'admin', '2017-04-03 14:01:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25947, '2017-04-03 14:02:02', NULL, NULL, 8263, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 14:02:02', 'admin-1491196225-14911993224541234', 1, 1, 'SR', NULL, NULL, NULL),
(25948, '2017-04-03 13:23:44', NULL, NULL, 8260, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1491196225', 'admin', '2017-04-03 13:23:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25949, '2017-04-03 13:23:49', NULL, NULL, 8260, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 13:23:49', 'admin-1491196225-14911970295284568', 1, 1, 'SR', NULL, NULL, NULL),
(25950, '2017-04-03 12:35:16', NULL, NULL, 8255, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 12:35:16', 'admin-1491179430-14911941167265356', 1, 1, 'SR', NULL, NULL, NULL),
(25951, '2017-04-03 12:35:16', NULL, NULL, 8255, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 12:35:16', 'admin-1491179430-14911941167265356', 1, 1, 'SR', NULL, NULL, NULL),
(25952, '2017-04-03 12:33:31', NULL, NULL, 8255, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1491196225', 'admin', '2017-04-03 12:33:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25953, '2017-04-03 13:47:38', NULL, NULL, 8259, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 13:47:38', 'admin-1491196225-14911984578534689', 1, 1, 'SR', NULL, NULL, NULL),
(25954, '2017-04-03 13:23:49', NULL, NULL, 8260, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 13:23:49', 'admin-1491196225-14911970295284568', 1, 0, '', NULL, NULL, NULL),
(25955, '2017-04-03 15:50:53', NULL, NULL, 8268, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 15:50:53', 'admin-1491196225-14912058535154675', 1, 1, 'SR', NULL, NULL, NULL),
(25956, '2017-04-03 13:58:03', NULL, NULL, 8262, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 13:58:03', 'admin-1491196225-14911990836999850', 1, 0, '', NULL, NULL, NULL),
(25957, '2017-04-03 13:58:03', NULL, NULL, 8262, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 13:58:03', 'admin-1491196225-14911990836999850', 1, 0, '', NULL, NULL, NULL),
(25958, '2017-04-03 13:47:16', NULL, NULL, 8259, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 13:47:16', 'admin-1491196225-14911984360212967', 1, 1, 'SR', NULL, NULL, NULL),
(25959, '2017-04-03 13:47:16', NULL, NULL, 8259, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 13:47:16', 'admin-1491196225-14911984360212967', 1, 0, '', NULL, NULL, NULL),
(25960, '2017-04-03 13:47:38', NULL, NULL, 8259, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 13:47:38', 'admin-1491196225-14911984578534689', 1, 1, 'SR', NULL, NULL, NULL),
(25961, '2017-04-03 13:47:16', NULL, NULL, 8259, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 13:47:16', 'admin-1491196225-14911984360212967', 1, 0, '', NULL, NULL, NULL),
(25962, '2017-04-03 12:35:16', NULL, NULL, 8255, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 12:35:16', 'admin-1491179430-14911941167265356', 1, 0, '', NULL, NULL, NULL),
(25963, '2017-04-03 12:35:16', NULL, NULL, 8255, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 12:35:16', 'admin-1491179430-14911941167265356', 1, 1, 'SR', NULL, NULL, NULL),
(25964, '2017-04-03 12:35:16', NULL, NULL, 8255, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 12:35:16', 'admin-1491179430-14911941167265356', 1, 0, '', NULL, NULL, NULL),
(25965, '2017-04-03 12:35:16', NULL, NULL, 8255, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 12:35:16', 'admin-1491179430-14911941167265356', 1, 0, '', NULL, NULL, NULL),
(25966, '2017-04-03 12:47:09', NULL, NULL, 8256, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1491196225', 'admin', '2017-04-03 12:47:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25967, '2017-04-03 12:47:13', NULL, NULL, 8256, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 12:47:13', 'admin-1491179430-14911948328765252', 1, 1, 'SR', NULL, NULL, NULL),
(25968, '2017-04-03 12:51:33', NULL, NULL, 8257, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1491196225', 'admin', '2017-04-03 12:51:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25969, '2017-04-03 12:51:46', NULL, NULL, 8257, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 12:51:46', 'admin-1491179430-14911951061506299', 1, 0, '', NULL, NULL, NULL),
(25970, '2017-04-03 13:09:31', NULL, NULL, 8258, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1491196225', 'admin', '2017-04-03 13:09:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25971, '2017-04-03 13:10:12', NULL, NULL, 8258, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 13:10:12', 'admin-1491179430-14911962125914345', 1, 0, '', NULL, NULL, NULL),
(25972, '2017-04-03 13:11:13', NULL, NULL, 8258, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 13:11:13', 'admin-1491196225-14911962731686333', 1, 1, 'SR', NULL, NULL, NULL),
(25973, '2017-04-03 14:09:45', NULL, NULL, 8258, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 14:09:45', 'admin-1491196225-14911997855203948', 1, 1, 'SR', NULL, NULL, NULL),
(25974, '2017-04-03 09:16:17', NULL, NULL, 8248, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 09:16:17', 'admin-1491179430-14911821772233824', 1, 0, '', NULL, NULL, NULL),
(25975, '2017-04-03 09:16:32', NULL, NULL, 8249, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1491196225', 'admin', '2017-04-03 09:16:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25976, '2017-04-03 09:16:36', NULL, NULL, 8249, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 09:16:36', 'admin-1491179430-14911821961405397', 1, 1, 'SR', NULL, NULL, NULL),
(25977, '2017-04-03 09:16:36', NULL, NULL, 8249, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 09:16:36', 'admin-1491179430-14911821961405397', 1, 1, 'SR', NULL, NULL, NULL),
(25978, '2017-04-03 09:16:52', NULL, NULL, 8248, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 09:16:52', 'admin-1491179430-1491182212336353', 1, 1, 'SR', NULL, NULL, NULL),
(25979, '2017-04-03 09:16:52', NULL, NULL, 8248, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 09:16:52', 'admin-1491179430-1491182212336353', 1, 1, 'SR', NULL, NULL, NULL),
(25980, '2017-04-03 09:34:48', NULL, NULL, 8249, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 09:34:48', 'admin-1491179430-14911832881159572', 1, 0, '', NULL, NULL, NULL),
(25981, '2017-04-03 09:34:48', NULL, NULL, 8249, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 09:34:48', 'admin-1491179430-14911832881159572', 1, 1, 'SR', NULL, NULL, NULL),
(25982, '2017-04-03 10:00:02', NULL, NULL, 8250, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1491196225', 'admin', '2017-04-03 10:00:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25983, '2017-04-03 10:00:07', NULL, NULL, 8250, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 10:00:07', 'admin-1491179430-14911848075462173', 1, 0, '', NULL, NULL, NULL),
(25984, '2017-04-03 10:00:13', NULL, NULL, 8250, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 10:00:13', 'admin-1491179430-14911848135749210', 1, 1, 'SR', NULL, NULL, NULL),
(25985, '2017-04-03 10:34:44', NULL, NULL, 8251, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1491196225', 'admin', '2017-04-03 10:34:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25986, '2017-04-03 17:21:10', NULL, NULL, 8272, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1491196225', 'admin', '2017-04-03 17:21:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25987, '2017-04-03 12:27:47', NULL, NULL, 8254, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 12:27:47', 'admin-1491179430-14911936669665413', 1, 1, 'SR', NULL, NULL, NULL),
(25988, '2017-04-03 12:27:47', NULL, NULL, 8254, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 12:27:47', 'admin-1491179430-14911936669665413', 1, 1, 'SR', NULL, NULL, NULL),
(25989, '2017-04-03 10:53:28', NULL, NULL, 8252, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 10:53:28', 'admin-1491179430-14911880083411863', 1, 0, '', NULL, NULL, NULL),
(25990, '2017-04-03 10:53:28', NULL, NULL, 8252, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 10:53:28', 'admin-1491179430-14911880083411863', 1, 1, 'SR', NULL, NULL, NULL),
(25991, '2017-04-03 11:08:41', NULL, NULL, 8253, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 11:08:41', 'admin-1491179430-14911889213728260', 1, 0, '', 1, NULL, NULL),
(25992, '2017-04-03 10:53:21', NULL, NULL, 8252, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1491196225', 'admin', '2017-04-03 10:53:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25993, '2017-04-03 10:34:51', NULL, NULL, 8251, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 10:34:51', 'admin-1491179430-14911868909106887', 1, 0, '', NULL, NULL, NULL),
(25994, '2017-04-03 09:16:12', NULL, NULL, 8248, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1491196225', 'admin', '2017-04-03 09:16:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25995, '2017-04-05 12:03:19', NULL, NULL, 8281, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:03:19', 'admin-1491354607-14913649994221915', 1, 1, 'SR', NULL, NULL, NULL),
(25996, '2017-04-05 12:12:42', NULL, NULL, 8282, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:12:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(25997, '2017-04-05 12:12:53', NULL, NULL, 8282, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:12:53', 'admin-1491354607-14913655731951038', 1, 0, '', NULL, NULL, NULL),
(25998, '2017-04-05 12:12:59', NULL, NULL, 8282, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:12:59', 'admin-1491354607-1491365579780382', 1, 0, '', NULL, NULL, NULL),
(25999, '2017-04-05 12:17:36', NULL, NULL, 8283, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:17:36', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(26000, '2017-04-05 14:19:12', NULL, NULL, 8293, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1491439793', 'admin', '2017-04-05 14:19:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26001, '2017-04-05 12:29:07', NULL, NULL, 8284, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.65, 0.0000, 0.0000, 8.65, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:29:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26002, '2017-04-05 12:29:27', NULL, NULL, 8284, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:29:27', 'admin-1491354607-14913665670349267', 1, 1, 'SR', NULL, NULL, NULL),
(26003, '2017-04-05 12:29:27', NULL, NULL, 8284, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:29:27', 'admin-1491354607-14913665670349267', 1, 1, 'SR', NULL, NULL, NULL),
(26004, '2017-04-05 12:29:27', NULL, NULL, 8284, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:29:27', 'admin-1491354607-14913665670349267', 1, 1, 'SR', NULL, NULL, NULL),
(26005, '2017-04-05 12:29:36', NULL, NULL, 8284, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:29:36', 'admin-1491354607-1491366576053566', 1, 1, 'SR', NULL, NULL, NULL),
(26006, '2017-04-05 12:29:36', NULL, NULL, 8284, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:29:36', 'admin-1491354607-1491366576053566', 1, 1, 'SR', NULL, NULL, NULL),
(26007, '2017-04-05 12:31:02', NULL, NULL, 8285, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.10, 0.0000, 0.0000, 10.10, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:31:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26008, '2017-04-05 12:31:44', NULL, NULL, 8285, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:31:44', 'admin-1491366674-14913667047318237', 1, 0, '', NULL, NULL, NULL),
(26009, '2017-04-05 12:31:44', NULL, NULL, 8285, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:31:44', 'admin-1491366674-14913667047318237', 1, 1, 'SR', NULL, NULL, NULL),
(26010, '2017-04-05 12:31:44', NULL, NULL, 8285, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:31:44', 'admin-1491366674-14913667047318237', 1, 1, 'SR', NULL, NULL, NULL),
(26011, '2017-04-05 11:10:18', NULL, NULL, 8279, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 11:10:18', 'admin-1491354607-14913618187103726', 1, 1, 'SR', NULL, NULL, NULL),
(26012, '2017-04-05 11:50:15', NULL, NULL, 8280, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1491439793', 'admin', '2017-04-05 11:50:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26013, '2017-04-05 10:57:44', NULL, NULL, 8278, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1491439793', 'admin', '2017-04-05 10:57:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26014, '2017-04-05 10:57:47', NULL, NULL, 8278, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 10:57:47', 'admin-1491354607-14913610672944253', 1, 1, 'SR', NULL, NULL, NULL),
(26015, '2017-04-05 11:09:57', NULL, NULL, 8279, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1491439793', 'admin', '2017-04-05 11:09:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26016, '2017-04-05 11:10:09', NULL, NULL, 8279, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 11:10:09', 'admin-1491354607-1491361809074258', 1, 0, '', NULL, NULL, NULL),
(26017, '2017-04-05 12:03:15', NULL, NULL, 8281, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:03:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26018, '2017-04-05 12:31:44', NULL, NULL, 8285, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:31:44', 'admin-1491366674-14913667047318237', 1, 1, 'SR', NULL, NULL, NULL),
(26019, '2017-04-05 12:33:09', NULL, NULL, 8285, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:33:09', 'admin-1491366674-1491366789616446', 1, 1, 'SR', NULL, NULL, NULL),
(26020, '2017-04-05 12:35:38', NULL, NULL, 8286, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:35:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26021, '2017-04-05 13:14:30', NULL, NULL, 8288, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 13:14:30', 'admin-1491368731-1491369270481274', 1, 1, 'SR', NULL, NULL, NULL),
(26022, '2017-04-05 13:21:37', NULL, NULL, 8288, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 13:21:37', 'admin-1491368731-1491369697026517', 1, 1, 'SR', NULL, NULL, NULL),
(26023, '2017-04-05 13:51:38', NULL, NULL, 8290, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1491439793', 'admin', '2017-04-05 13:51:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26024, '2017-04-05 11:50:26', NULL, NULL, 8280, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 11:50:26', 'admin-1491354607-14913642263511561', 1, 0, '', NULL, NULL, NULL),
(26025, '2017-04-05 11:50:26', NULL, NULL, 8280, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 11:50:26', 'admin-1491354607-14913642263511561', 1, 0, '', NULL, NULL, NULL),
(26026, '2017-04-05 14:12:36', NULL, NULL, 8292, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1491439793', 'admin', '2017-04-05 14:12:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26027, '2017-04-05 14:12:47', NULL, NULL, 8292, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 14:12:47', 'admin-1491368731-14913727671931341', 1, 1, 'SR', NULL, NULL, NULL),
(26028, '2017-04-05 00:00:00', NULL, NULL, 8293, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:37:13', 'admin-1491366674-14913670328977128', 1, 1, 'SR', NULL, NULL, NULL),
(26029, '2017-04-05 13:58:19', NULL, NULL, 8290, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 13:58:19', 'admin-1491368731-14913718992486887', 1, 0, '', NULL, NULL, NULL),
(26030, '2017-04-05 13:58:19', NULL, NULL, 8290, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 13:58:19', 'admin-1491368731-14913718992486887', 1, 1, 'SR', NULL, NULL, NULL),
(26031, '2017-04-05 13:58:19', NULL, NULL, 8290, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 13:58:19', 'admin-1491368731-14913718992486887', 1, 1, 'SR', NULL, NULL, NULL),
(26032, '2017-04-05 13:51:45', NULL, NULL, 8290, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 13:51:46', 'admin-1491368731-14913715057293616', 1, 1, 'SR', NULL, NULL, NULL),
(26033, '2017-04-05 13:19:36', NULL, NULL, 8288, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 13:19:36', 'admin-1491368731-14913695765232186', 1, 1, 'SR', NULL, NULL, NULL),
(26034, '2017-04-05 13:15:36', NULL, NULL, 8285, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 13:15:36', 'admin-1491368731-1491369336260818', 1, 0, '', NULL, NULL, NULL),
(26035, '2017-04-05 13:14:21', NULL, NULL, 8288, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1491439793', 'admin', '2017-04-05 13:14:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26036, '2017-04-05 13:05:48', NULL, NULL, 8285, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 13:05:48', 'admin-1491368731-14913687485475185', 1, 1, 'SR', NULL, NULL, NULL),
(26037, '2017-04-05 13:05:26', NULL, NULL, 8284, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 13:05:26', 'admin-1491366674-14913687266257743', 1, 1, 'SR', NULL, NULL, NULL),
(26038, '2017-04-05 13:00:55', NULL, NULL, 8287, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 13:00:55', 'admin-1491366674-14913684549373816', 1, 0, '', NULL, NULL, NULL),
(26039, '2017-04-05 13:00:55', NULL, NULL, 8287, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 13:00:55', 'admin-1491366674-14913684549373816', 1, 1, 'SR', NULL, NULL, NULL),
(26040, '2017-04-05 13:00:37', NULL, NULL, 8287, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 13:00:37', 'admin-1491366674-14913684377957033', 1, 0, '', NULL, NULL, NULL),
(26041, '2017-04-05 13:00:30', NULL, NULL, 8287, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1491439793', 'admin', '2017-04-05 13:00:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26042, '2017-04-05 12:44:54', NULL, NULL, 8283, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:44:54', 'admin-1491366674-14913674942293495', 1, 1, 'SR', NULL, NULL, NULL),
(26043, '2017-04-05 00:00:00', NULL, NULL, 8293, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:17:40', 'admin-1491354607-14913658606876892', 1, 0, '', NULL, NULL, NULL),
(26044, '2017-04-05 12:37:13', NULL, NULL, 8283, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:37:13', 'admin-1491366674-14913670328977128', 1, 0, '', NULL, NULL, NULL),
(26045, '2017-04-05 12:37:03', NULL, NULL, 8285, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:37:03', 'admin-1491366674-14913670234709592', 1, 1, 'SR', NULL, NULL, NULL),
(26046, '2017-04-05 12:35:46', NULL, NULL, 8286, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:35:46', 'admin-1491366674-14913669464789865', 1, 1, 'SR', NULL, NULL, NULL),
(26047, '2017-04-05 12:36:53', NULL, NULL, 8284, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:36:53', 'admin-1491366674-14913670131593970', 1, 0, '', NULL, NULL, NULL),
(26048, '2017-04-05 12:35:46', NULL, NULL, 8286, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 12:35:46', 'admin-1491366674-14913669464789865', 1, 1, 'SR', NULL, NULL, NULL),
(26049, '2017-04-05 11:50:26', NULL, NULL, 8280, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 11:50:26', 'admin-1491354607-14913642263511561', 1, 0, '', NULL, NULL, NULL),
(26050, '2017-04-05 11:10:09', NULL, NULL, 8279, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 11:10:09', 'admin-1491354607-1491361809074258', 1, 0, '', NULL, NULL, NULL),
(26051, '2017-04-05 11:10:18', NULL, NULL, 8279, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 11:10:18', 'admin-1491354607-14913618187103726', 1, 0, '', NULL, NULL, NULL),
(26052, '2017-04-05 09:23:15', NULL, NULL, 8276, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 09:23:15', 'admin-1491354607-149135539572249', 1, 1, 'SR', NULL, NULL, NULL),
(26053, '2017-04-05 09:23:15', NULL, NULL, 8276, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491439793', 'admin', '2017-04-05 09:23:15', 'admin-1491354607-149135539572249', 1, 1, 'SR', NULL, NULL, NULL),
(26054, '2017-04-05 09:23:12', NULL, NULL, 8276, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1491439793', 'admin', '2017-04-05 09:23:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26055, '2017-04-06 18:02:51', NULL, NULL, 8309, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 18:02:51', 'admin-1491453550-14914729712059925', 1, 1, 'SR', NULL, NULL, NULL),
(26056, '2017-04-06 18:02:51', NULL, NULL, 8309, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 18:02:51', 'admin-1491453550-14914729712059925', 1, 1, 'SR', NULL, NULL, NULL),
(26057, '2017-04-06 18:09:12', NULL, NULL, 8310, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 18:09:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26058, '2017-04-06 18:09:18', NULL, NULL, 8310, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 18:09:18', 'admin-1491453550-14914733583894410', 1, 0, '', NULL, NULL, NULL),
(26059, '2017-04-06 18:13:56', NULL, NULL, 8310, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 18:13:56', 'admin-1491473587-14914736359474167', 1, 1, 'SR', NULL, NULL, NULL),
(26060, '2017-04-06 18:13:59', NULL, NULL, 8311, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 18:13:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26061, '2017-04-06 18:14:16', NULL, NULL, 8311, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 18:14:16', 'admin-1491473587-14914736558514814', 1, 1, 'SR', NULL, NULL, NULL),
(26062, '2017-04-06 18:14:16', NULL, NULL, 8311, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 18:14:16', 'admin-1491473587-14914736558514814', 1, 1, 'SR', NULL, NULL, NULL),
(26063, '2017-04-06 18:14:16', NULL, NULL, 8311, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 18:14:16', 'admin-1491473587-14914736558514814', 1, 0, '', NULL, NULL, NULL),
(26064, '2017-04-06 18:14:16', NULL, NULL, 8311, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 18:14:16', 'admin-1491473587-14914736558514814', 1, 0, '', NULL, NULL, NULL),
(26065, '2017-04-06 18:19:51', NULL, NULL, 8310, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 18:19:51', 'admin-1491473587-14914739910962780', 1, 0, '', NULL, NULL, NULL),
(26066, '2017-04-06 18:39:36', NULL, NULL, 8311, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 18:39:36', 'admin-1491473587-14914751763776893', 1, 0, '', NULL, NULL, NULL),
(26067, '2017-04-06 19:11:57', NULL, NULL, 8310, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 19:11:57', 'admin-1491473587-14914771171544190', 1, 0, '', NULL, NULL, NULL),
(26068, '2017-04-06 09:28:28', NULL, NULL, 8294, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 09:28:28', 'admin-1491439960-14914421082138571', 1, 0, '', NULL, NULL, NULL),
(26069, '2017-04-06 10:35:54', NULL, NULL, 8297, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 10:35:54', 'admin-1491439960-14914461539492398', 1, 1, 'SR', NULL, NULL, NULL),
(26070, '2017-04-06 10:41:05', NULL, NULL, 8296, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 10:41:05', 'admin-1491439960-14914464654144481', 1, 1, 'SR', NULL, NULL, NULL),
(26071, '2017-04-06 10:45:56', NULL, NULL, 8298, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1491473587', 'admin', '2017-04-06 10:45:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26072, '2017-04-06 10:04:59', NULL, NULL, 8295, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 10:04:59', 'admin-1491439960-14914442992914610', 1, 1, 'SR', 1, NULL, NULL),
(26073, '2017-04-06 17:30:28', NULL, NULL, 8307, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 17:30:28', 'admin-1491453550-14914710282285052', 1, 1, 'SR', NULL, NULL, NULL),
(26074, '2017-04-06 18:02:45', NULL, NULL, 8309, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1491473587', 'admin', '2017-04-06 18:02:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26075, '2017-04-06 16:59:40', NULL, NULL, 8308, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 16:59:40', 'admin-1491453550-14914691803301043', 1, 1, 'SR', NULL, NULL, NULL),
(26076, '2017-04-06 10:07:04', NULL, NULL, 8297, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 10:07:04', 'admin-1491439960-14914444241654328', 1, 0, '', NULL, NULL, NULL),
(26077, '2017-04-06 10:46:04', NULL, NULL, 8298, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 10:46:04', 'admin-1491439960-14914467642303849', 1, 0, '', NULL, NULL, NULL),
(26078, '2017-04-06 10:46:04', NULL, NULL, 8298, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 10:46:04', 'admin-1491439960-14914467642303849', 1, 0, '', NULL, NULL, NULL),
(26079, '2017-04-06 10:46:15', NULL, NULL, 8298, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 10:46:15', 'admin-1491439960-14914467756065065', 1, 1, 'SR', NULL, NULL, NULL),
(26080, '2017-04-06 10:46:15', NULL, NULL, 8298, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 10:46:15', 'admin-1491439960-14914467756065065', 1, 0, '', NULL, NULL, NULL),
(26081, '2017-04-06 10:46:15', NULL, NULL, 8298, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 10:46:15', 'admin-1491439960-14914467756065065', 1, 1, 'SR', NULL, NULL, NULL),
(26082, '2017-04-06 11:50:28', NULL, NULL, 8299, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1491473587', 'admin', '2017-04-06 11:50:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26083, '2017-04-06 11:50:35', NULL, NULL, 8299, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 11:50:35', 'admin-1491439960-14914506355109925', 1, 1, 'SR', NULL, NULL, NULL),
(26084, '2017-04-06 11:52:10', NULL, NULL, 8299, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 11:52:10', 'admin-1491439960-14914507303203088', 1, 0, '', NULL, NULL, NULL),
(26085, '2017-04-06 11:52:10', NULL, NULL, 8299, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 11:52:10', 'admin-1491439960-14914507303203088', 1, 0, '', NULL, NULL, NULL),
(26086, '2017-04-06 11:52:48', NULL, NULL, 8299, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 11:52:48', 'admin-1491439960-1491450768553581', 1, 0, '', NULL, NULL, NULL),
(26087, '2017-04-06 11:52:48', NULL, NULL, 8299, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 11:52:48', 'admin-1491439960-1491450768553581', 1, 1, 'SR', NULL, NULL, NULL),
(26088, '2017-04-06 12:18:35', NULL, NULL, 8300, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 12:18:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26089, '2017-04-06 12:21:22', NULL, NULL, 8300, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 12:21:22', 'admin-1491439960-14914524818564959', 1, 0, '', NULL, NULL, NULL),
(26090, '2017-04-06 12:22:35', NULL, NULL, 8301, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1491473587', 'admin', '2017-04-06 12:22:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26091, '2017-04-06 12:22:43', NULL, NULL, 8301, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 12:22:43', 'admin-1491439960-14914525631564424', 1, 0, '', NULL, NULL, NULL),
(26092, '2017-04-06 12:22:43', NULL, NULL, 8301, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 12:22:43', 'admin-1491439960-14914525631564424', 1, 1, 'SR', NULL, NULL, NULL),
(26093, '2017-04-06 13:49:00', NULL, NULL, 8303, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 13:49:00', 'admin-1491453550-14914577404082393', 1, 1, 'SR', NULL, NULL, NULL),
(26094, '2017-04-06 13:49:00', NULL, NULL, 8303, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 13:49:00', 'admin-1491453550-14914577404082393', 1, 0, '', NULL, NULL, NULL),
(26095, '2017-04-06 16:59:27', NULL, NULL, 8308, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 16:59:27', 'admin-1491453550-14914691677192581', 1, 0, '', NULL, NULL, NULL),
(26096, '2017-04-06 12:57:27', NULL, NULL, 8304, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 12:57:27', 'admin-1491453550-14914546472168473', 1, 0, '', NULL, NULL, NULL),
(26097, '2017-04-06 16:59:27', NULL, NULL, 8308, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 16:59:27', 'admin-1491453550-14914691677192581', 1, 1, 'SR', NULL, NULL, NULL),
(26098, '2017-04-06 16:58:51', NULL, NULL, 8308, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1491473587', 'admin', '2017-04-06 16:58:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26099, '2017-04-06 15:28:43', NULL, NULL, 8307, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 15:28:43', 'admin-1491453550-14914637232267633', 1, 1, 'SR', NULL, NULL, NULL),
(26100, '2017-04-06 14:08:29', NULL, NULL, 8306, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1491473587', 'admin', '2017-04-06 14:08:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26101, '2017-04-06 14:08:38', NULL, NULL, 8306, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 14:08:38', 'admin-1491453550-14914589181839292', 1, 0, '', NULL, NULL, NULL),
(26102, '2017-04-06 14:08:38', NULL, NULL, 8306, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 14:08:38', 'admin-1491453550-14914589181839292', 1, 1, 'SR', NULL, NULL, NULL),
(26103, '2017-04-06 15:28:40', NULL, NULL, 8307, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1491473587', 'admin', '2017-04-06 15:28:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26104, '2017-04-06 14:02:01', NULL, NULL, 8305, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 14:02:01', 'admin-1491453550-14914585216377049', 1, 0, '', NULL, NULL, NULL),
(26105, '2017-04-06 14:01:56', NULL, NULL, 8305, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1491473587', 'admin', '2017-04-06 14:01:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26106, '2017-04-06 13:11:36', NULL, NULL, 8303, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 13:11:36', 'admin-1491453550-14914554965083233', 1, 0, '', NULL, NULL, NULL),
(26107, '2017-04-06 10:05:03', NULL, NULL, 8296, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1491473587', 'admin', '2017-04-06 10:05:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26108, '2017-04-06 10:05:09', NULL, NULL, 8296, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 10:05:09', 'admin-1491439960-1491444308958947', 1, 0, '', NULL, NULL, NULL),
(26109, '2017-04-06 10:05:09', NULL, NULL, 8296, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 10:05:09', 'admin-1491439960-1491444308958947', 1, 1, 'SR', NULL, NULL, NULL),
(26110, '2017-04-06 12:57:27', NULL, NULL, 8304, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 12:57:27', 'admin-1491453550-14914546472168473', 1, 0, '', NULL, NULL, NULL),
(26111, '2017-04-06 12:57:23', NULL, NULL, 8304, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1491473587', 'admin', '2017-04-06 12:57:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26112, '2017-04-06 12:56:27', NULL, NULL, 8303, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 12:56:27', 'admin-1491453550-14914545876903776', 1, 1, 'SR', NULL, NULL, NULL),
(26113, '2017-04-06 12:51:44', NULL, NULL, 8303, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 12:51:44', 'admin-1491453550-1491454304047424', 1, 0, '', NULL, NULL, NULL),
(26114, '2017-04-06 12:56:27', NULL, NULL, 8303, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 12:56:27', 'admin-1491453550-14914545876903776', 1, 0, '', NULL, NULL, NULL),
(26115, '2017-04-06 12:51:36', NULL, NULL, 8303, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1491473587', 'admin', '2017-04-06 12:51:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26116, '2017-04-06 12:51:44', NULL, NULL, 8303, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 12:51:44', 'admin-1491453550-1491454304047424', 1, 0, '', NULL, NULL, NULL),
(26117, '2017-04-06 12:38:55', NULL, NULL, 8302, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 12:38:55', 'admin-1491439960-14914535356796231', 1, 1, 'SR', NULL, NULL, NULL),
(26118, '2017-04-06 12:33:52', NULL, NULL, 8302, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 12:33:52', 'admin-1491439960-14914532321555630', 1, 1, 'SR', NULL, NULL, NULL),
(26119, '2017-04-06 12:38:55', NULL, NULL, 8302, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 12:38:55', 'admin-1491439960-14914535356796231', 1, 1, 'SR', NULL, NULL, NULL),
(26120, '2017-04-06 12:33:47', NULL, NULL, 8302, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1491473587', 'admin', '2017-04-06 12:33:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26121, '2017-04-06 10:06:52', NULL, NULL, 8297, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1491473587', 'admin', '2017-04-06 10:06:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26122, '2017-04-06 10:06:56', NULL, NULL, 8297, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 10:06:56', 'admin-1491439960-14914444167985690', 1, 1, 'SR', NULL, NULL, NULL),
(26123, '2017-04-06 10:05:54', NULL, NULL, 8295, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 10:05:54', 'admin-1491439960-14914443540988660', 1, 0, '', 1, NULL, NULL),
(26124, '2017-04-06 10:04:59', NULL, NULL, 8295, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 10:04:59', 'admin-1491439960-14914442992914610', 1, 1, 'SR', 1, NULL, NULL),
(26125, '2017-04-06 10:04:59', NULL, NULL, 8295, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 10:04:59', 'admin-1491439960-14914442992914610', 1, 1, 'SR', 1, NULL, NULL),
(26126, '2017-04-06 09:28:28', NULL, NULL, 8294, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 09:28:28', 'admin-1491439960-14914421082138571', 1, 1, 'SR', NULL, NULL, NULL),
(26127, '2017-04-06 09:22:56', NULL, NULL, 8294, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 09:22:56', 'admin-1491439960-14914417764278565', 1, 1, 'SR', NULL, NULL, NULL),
(26128, '2017-04-06 09:22:50', NULL, NULL, 8294, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491473587', 'admin', '2017-04-06 09:22:50', 'admin-1491439960-14914417707297516', 1, 0, '', NULL, NULL, NULL),
(26129, '2017-04-06 09:22:40', NULL, NULL, 8294, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1491473587', 'admin', '2017-04-06 09:22:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26130, '2017-04-07 14:16:21', NULL, NULL, 8329, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1491543364', 'admin', '2017-04-07 14:16:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26131, '2017-04-07 00:00:00', NULL, NULL, 8329, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 13:36:54', 'admin-1491543364-14915434139205756', 1, 0, '', NULL, NULL, NULL),
(26132, '2017-04-07 14:16:11', NULL, NULL, 8328, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1491543364', 'admin', '2017-04-07 14:16:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26133, '2017-04-07 00:00:00', NULL, NULL, 8329, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 13:36:54', 'admin-1491543364-14915434139205756', 1, 1, 'SR', NULL, NULL, NULL),
(26134, '2017-04-07 00:00:00', NULL, NULL, 8328, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 13:36:54', 'admin-1491543364-14915434139205756', 1, 1, 'SR', NULL, NULL, NULL),
(26135, '2017-04-07 14:15:57', NULL, NULL, 8327, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1491543364', 'admin', '2017-04-07 14:15:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26136, '2017-04-07 14:15:41', NULL, NULL, 8326, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1491543364', 'admin', '2017-04-07 14:15:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26137, '2017-04-07 00:00:00', NULL, NULL, 8327, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 13:36:54', 'admin-1491543364-14915434139205756', 1, 1, 'SR', NULL, NULL, NULL),
(26138, '2017-04-07 00:00:00', NULL, NULL, 8326, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 13:36:54', 'admin-1491543364-14915434139205756', 1, 0, '', NULL, NULL, NULL),
(26139, '2017-04-07 00:00:00', NULL, NULL, 8326, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 13:36:54', 'admin-1491543364-14915434139205756', 1, 1, 'SR', NULL, NULL, NULL),
(26140, '2017-04-07 14:09:29', NULL, NULL, 8318, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 14:09:29', 'admin-1491543364-1491545369202349', 1, 0, '', 1, NULL, NULL),
(26141, '2017-04-07 14:09:29', NULL, NULL, 8318, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 14:09:29', 'admin-1491543364-1491545369202349', 1, 0, '', 1, NULL, NULL),
(26142, '2017-04-07 00:00:00', NULL, NULL, 8326, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 13:36:54', 'admin-1491543364-14915434139205756', 1, 0, '', NULL, NULL, NULL),
(26143, '2017-04-07 00:00:00', NULL, NULL, 8328, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 13:36:54', 'admin-1491543364-14915434139205756', 1, 1, 'SR', NULL, NULL, NULL),
(26144, '2017-04-07 14:46:59', NULL, NULL, 8330, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1491543364', 'admin', '2017-04-07 14:46:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26145, '2017-04-07 14:47:02', NULL, NULL, 8330, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 14:47:02', 'admin-1491543364-14915476220766599', 1, 1, 'SR', NULL, NULL, NULL),
(26146, '2017-04-07 15:03:29', NULL, NULL, 8330, 0, 182, '117', 'Open Drinks ', 'espresso with ice', 'Cold Drinks', 'Fresh Juice', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 15:03:29', 'admin-1491543364-14915486090812040', 1, 0, '', NULL, NULL, NULL),
(26147, '2017-04-07 09:42:07', NULL, NULL, 8313, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1491543364', 'admin', '2017-04-07 09:42:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26148, '2017-04-07 13:29:27', NULL, NULL, 8325, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 13:29:27', 'admin-1491525861-14915429673491658', 1, 1, 'SR', NULL, NULL, NULL),
(26149, '2017-04-07 13:29:27', NULL, NULL, 8325, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 13:29:27', 'admin-1491525861-14915429673491658', 1, 1, 'SR', NULL, NULL, NULL),
(26150, '2017-04-07 10:01:14', NULL, NULL, 8314, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:01:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26151, '2017-04-07 10:01:17', NULL, NULL, 8314, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:01:17', 'admin-1491525861-1491530477401754', 1, 0, '', NULL, NULL, NULL),
(26152, '2017-04-07 10:03:21', NULL, NULL, 8315, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.30, 0.0000, 0.0000, 10.30, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:03:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26153, '2017-04-07 10:03:47', NULL, NULL, 8315, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:03:47', 'admin-1491525861-14915306270711359', 1, 0, '', NULL, NULL, NULL),
(26154, '2017-04-07 10:03:47', NULL, NULL, 8315, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:03:47', 'admin-1491525861-14915306270711359', 1, 0, '', NULL, NULL, NULL),
(26155, '2017-04-07 10:03:47', NULL, NULL, 8315, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:03:47', 'admin-1491525861-14915306270711359', 1, 0, '', NULL, NULL, NULL),
(26156, '2017-04-07 10:03:47', NULL, NULL, 8315, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:03:47', 'admin-1491525861-14915306270711359', 1, 0, '', NULL, NULL, NULL),
(26157, '2017-04-07 10:03:47', NULL, NULL, 8315, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:03:47', 'admin-1491525861-14915306270711359', 1, 0, '', NULL, NULL, NULL),
(26158, '2017-04-07 10:03:47', NULL, NULL, 8315, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:03:47', 'admin-1491525861-14915306270711359', 1, 0, '', NULL, NULL, NULL),
(26159, '2017-04-07 10:03:56', NULL, NULL, 8315, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:03:56', 'admin-1491525861-14915306358402072', 1, 1, 'SR', NULL, NULL, NULL),
(26160, '2017-04-07 10:40:04', NULL, NULL, 8319, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:40:04', 'admin-1491525861-14915328038632612', 1, 1, 'SR', NULL, NULL, NULL),
(26161, '2017-04-07 10:39:59', NULL, NULL, 8319, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:39:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26162, '2017-04-07 10:28:52', NULL, NULL, 8317, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:28:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26163, '2017-04-07 10:29:04', NULL, NULL, 8317, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:29:04', 'admin-1491525861-14915321443671717', 1, 1, 'SR', NULL, NULL, NULL),
(26164, '2017-04-07 10:29:04', NULL, NULL, 8317, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:29:04', 'admin-1491525861-14915321443671717', 1, 1, 'SR', NULL, NULL, NULL),
(26165, '2017-04-07 10:29:04', NULL, NULL, 8317, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:29:04', 'admin-1491525861-14915321443671717', 1, 0, '', NULL, NULL, NULL),
(26166, '2017-04-07 10:29:18', NULL, NULL, 8317, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:29:18', 'admin-1491525861-14915321582247733', 1, 0, '', NULL, NULL, NULL),
(26167, '2017-04-07 10:29:18', NULL, NULL, 8317, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:29:18', 'admin-1491525861-14915321582247733', 1, 0, '', NULL, NULL, NULL),
(26168, '2017-04-07 10:38:13', NULL, NULL, 8318, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:38:13', 'admin-1491525861-14915326936367778', 1, 1, 'SR', 1, NULL, NULL),
(26169, '2017-04-07 10:59:35', NULL, NULL, 8320, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:59:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26170, '2017-04-07 13:36:54', NULL, NULL, 8324, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 13:36:54', 'admin-1491543364-14915434139205756', 1, 1, 'SR', NULL, NULL, NULL),
(26171, '2017-04-07 13:36:54', NULL, NULL, 8324, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 13:36:54', 'admin-1491543364-14915434139205756', 1, 0, '', NULL, NULL, NULL),
(26172, '2017-04-07 13:27:54', NULL, NULL, 8325, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 13:27:54', 'admin-1491525861-1491542874310856', 1, 1, 'SR', NULL, NULL, NULL),
(26173, '2017-04-07 13:29:33', NULL, NULL, 8325, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 13:29:33', 'admin-1491525861-14915429737642048', 1, 0, '', NULL, NULL, NULL),
(26174, '2017-04-07 13:29:27', NULL, NULL, 8325, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 13:29:27', 'admin-1491525861-14915429673491658', 1, 0, '', NULL, NULL, NULL),
(26175, '2017-04-07 13:27:54', NULL, NULL, 8325, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 13:27:54', 'admin-1491525861-1491542874310856', 1, 1, 'SR', NULL, NULL, NULL),
(26176, '2017-04-07 13:27:54', NULL, NULL, 8325, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 13:27:54', 'admin-1491525861-1491542874310856', 1, 0, '', NULL, NULL, NULL),
(26177, '2017-04-07 13:27:54', NULL, NULL, 8325, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 13:27:54', 'admin-1491525861-1491542874310856', 1, 1, 'SR', NULL, NULL, NULL),
(26178, '2017-04-07 12:34:14', NULL, NULL, 8322, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1491543364', 'admin', '2017-04-07 12:34:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26179, '2017-04-07 12:34:19', NULL, NULL, 8322, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 12:34:19', 'admin-1491525861-14915396591969068', 1, 1, 'SR', NULL, NULL, NULL),
(26180, '2017-04-07 12:34:19', NULL, NULL, 8322, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 12:34:19', 'admin-1491525861-14915396591969068', 1, 1, 'SR', NULL, NULL, NULL),
(26181, '2017-04-07 12:46:54', NULL, NULL, 8323, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1491543364', 'admin', '2017-04-07 12:46:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26182, '2017-04-07 12:47:00', NULL, NULL, 8323, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 12:47:00', 'admin-1491525861-1491540420643283', 1, 0, '', NULL, NULL, NULL),
(26183, '2017-04-07 09:42:13', NULL, NULL, 8313, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 09:42:13', 'admin-1491525861-14915293336494647', 1, 0, '', NULL, NULL, NULL),
(26184, '2017-04-07 09:42:13', NULL, NULL, 8313, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 09:42:13', 'admin-1491525861-14915293336494647', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(26185, '2017-04-07 09:44:13', NULL, NULL, 8313, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 09:44:13', 'admin-1491525861-14915294535985845', 1, 1, 'SR', NULL, NULL, NULL),
(26186, '2017-04-07 13:27:36', NULL, NULL, 8325, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.50, 0.0000, 0.0000, 9.50, 1, '27', 1, '1491543364', 'admin', '2017-04-07 13:27:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26187, '2017-04-07 13:26:54', NULL, NULL, 8324, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1491543364', 'admin', '2017-04-07 13:26:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26188, '2017-04-07 12:47:07', NULL, NULL, 8323, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 12:47:07', 'admin-1491525861-14915404269594722', 1, 1, 'SR', NULL, NULL, NULL),
(26189, '2017-04-07 11:37:33', NULL, NULL, 8321, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 11:37:33', 'admin-1491525861-14915362528727216', 1, 1, 'SR', NULL, NULL, NULL),
(26190, '2017-04-07 11:37:33', NULL, NULL, 8321, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 11:37:33', 'admin-1491525861-14915362528727216', 1, 0, '', NULL, NULL, NULL),
(26191, '2017-04-07 11:37:21', NULL, NULL, 8321, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1491543364', 'admin', '2017-04-07 11:37:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26192, '2017-04-07 11:37:33', NULL, NULL, 8321, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 11:37:33', 'admin-1491525861-14915362528727216', 1, 1, 'SR', NULL, NULL, NULL),
(26193, '2017-04-07 11:37:33', NULL, NULL, 8321, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 11:37:33', 'admin-1491525861-14915362528727216', 1, 1, 'SR', NULL, NULL, NULL),
(26194, '2017-04-07 10:59:43', NULL, NULL, 8320, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:59:43', 'admin-1491525861-14915339834093949', 1, 0, '', NULL, NULL, NULL),
(26195, '2017-04-07 10:59:43', NULL, NULL, 8320, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:59:43', 'admin-1491525861-14915339834093949', 1, 0, '', NULL, NULL, NULL),
(26196, '2017-04-07 10:29:18', NULL, NULL, 8317, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:29:18', 'admin-1491525861-14915321582247733', 1, 0, '', NULL, NULL, NULL),
(26197, '2017-04-07 10:00:35', NULL, NULL, 8312, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:00:35', 'admin-1491525861-14915304351412921', 1, 0, '', NULL, NULL, NULL),
(26198, '2017-04-07 10:00:35', NULL, NULL, 8312, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 10:00:35', 'admin-1491525861-14915304351412921', 1, 1, 'SR', NULL, NULL, NULL),
(26199, '2017-04-07 09:33:04', NULL, NULL, 8312, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 09:33:04', 'admin-1491525861-14915287841056363', 1, 0, '', NULL, NULL, NULL),
(26200, '2017-04-07 09:32:54', NULL, NULL, 8312, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 09:32:54', 'admin-1491525861-14915287741376439', 1, 0, '', NULL, NULL, NULL),
(26201, '2017-04-07 09:33:04', NULL, NULL, 8312, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 09:33:04', 'admin-1491525861-14915287841056363', 1, 0, '', NULL, NULL, NULL),
(26202, '2017-04-07 09:32:54', NULL, NULL, 8312, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491543364', 'admin', '2017-04-07 09:32:54', 'admin-1491525861-14915287741376439', 1, 0, '', NULL, NULL, NULL),
(26203, '2017-04-07 09:31:30', NULL, NULL, 8312, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1491543364', 'admin', '2017-04-07 09:31:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26204, '2017-04-08 16:10:36', NULL, NULL, 8367, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 16:10:36', 'admin-1491625322-14916390362203145', 1, 0, '', NULL, NULL, NULL),
(26205, '2017-04-08 10:47:17', NULL, NULL, 8347, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:47:17', 'admin-1491618162-14916196374227877', 1, 0, '', NULL, NULL, NULL),
(26206, '2017-04-08 10:47:17', NULL, NULL, 8347, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:47:17', 'admin-1491618162-14916196374227877', 1, 0, '', NULL, NULL, NULL),
(26207, '2017-04-08 10:47:17', NULL, NULL, 8347, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:47:17', 'admin-1491618162-14916196374227877', 1, 1, 'SR', NULL, NULL, NULL),
(26208, '2017-04-08 10:47:17', NULL, NULL, 8347, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:47:17', 'admin-1491618162-14916196374227877', 1, 1, 'SR', NULL, NULL, NULL),
(26209, '2017-04-08 10:42:54', NULL, NULL, 8346, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:42:54', 'admin-1491618162-1491619374814924', 1, 1, 'SR', NULL, NULL, NULL),
(26210, '2017-04-08 10:42:54', NULL, NULL, 8346, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:42:54', 'admin-1491618162-1491619374814924', 1, 1, 'SR', NULL, NULL, NULL),
(26211, '2017-04-08 10:42:54', NULL, NULL, 8346, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:42:54', 'admin-1491618162-1491619374814924', 1, 0, '', NULL, NULL, NULL),
(26212, '2017-04-08 10:42:54', NULL, NULL, 8346, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:42:54', 'admin-1491618162-1491619374814924', 1, 0, '', NULL, NULL, NULL),
(26213, '2017-04-08 10:42:49', NULL, NULL, 8346, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:42:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26214, '2017-04-08 10:36:12', NULL, NULL, 8336, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:36:12', 'admin-1491618162-14916189723026334', 1, 0, '', NULL, NULL, NULL),
(26215, '2017-04-08 10:34:49', NULL, NULL, 8345, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:34:49', 'admin-1491618162-14916188896037722', 1, 0, '', NULL, NULL, NULL),
(26216, '2017-04-08 10:34:49', NULL, NULL, 8345, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:34:49', 'admin-1491618162-14916188896037722', 1, 1, 'SR', NULL, NULL, NULL),
(26217, '2017-04-08 10:34:49', NULL, NULL, 8345, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:34:49', 'admin-1491618162-14916188896037722', 1, 0, '', NULL, NULL, NULL),
(26218, '2017-04-08 10:46:58', NULL, NULL, 8347, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:46:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26219, '2017-04-08 09:51:36', NULL, NULL, 8335, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:51:36', 'admin-1491615772-14916162960245550', 1, 1, 'SR', NULL, NULL, NULL),
(26220, '2017-04-08 12:21:54', NULL, NULL, 8355, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 12:21:54', 'admin-1491618162-14916253138521365', 1, 0, '', NULL, NULL, NULL),
(26221, '2017-04-08 11:02:14', NULL, NULL, 8350, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 11:02:14', 'admin-1491618162-14916205345556538', 1, 1, 'SR', 1, NULL, NULL),
(26222, '2017-04-08 11:07:28', NULL, NULL, 8351, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1491644494', 'admin', '2017-04-08 11:07:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26223, '2017-04-08 11:07:38', NULL, NULL, 8351, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 11:07:38', 'admin-1491618162-14916208580911645', 1, 0, '', NULL, NULL, NULL),
(26224, '2017-04-08 11:07:38', NULL, NULL, 8351, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 11:07:38', 'admin-1491618162-14916208580911645', 1, 0, '', NULL, NULL, NULL),
(26225, '2017-04-08 11:10:53', NULL, NULL, 8352, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1491644494', 'admin', '2017-04-08 11:10:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26226, '2017-04-08 11:10:56', NULL, NULL, 8352, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 11:10:56', 'admin-1491618162-14916210565582323', 1, 1, 'SR', NULL, NULL, NULL),
(26227, '2017-04-08 13:49:08', NULL, NULL, 8361, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:49:08', 'admin-1491625322-14916305487282290', 1, 1, 'SR', NULL, NULL, NULL),
(26228, '2017-04-08 13:49:01', NULL, NULL, 8361, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:49:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26229, '2017-04-08 13:47:30', NULL, NULL, 8360, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:47:30', 'admin-1491625322-1491630450211540', 1, 1, 'SR', NULL, NULL, NULL),
(26230, '2017-04-08 11:44:11', NULL, NULL, 8354, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1491644494', 'admin', '2017-04-08 11:44:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26231, '2017-04-08 11:44:16', NULL, NULL, 8354, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 11:44:16', 'admin-1491618162-1491623056475734', 1, 1, 'SR', NULL, NULL, NULL),
(26232, '2017-04-08 12:21:48', NULL, NULL, 8355, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1491644494', 'admin', '2017-04-08 12:21:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26233, '2017-04-08 12:21:54', NULL, NULL, 8355, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 12:21:54', 'admin-1491618162-14916253138521365', 1, 1, 'SR', NULL, NULL, NULL),
(26234, '2017-04-08 17:41:49', NULL, NULL, 8370, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 17:41:49', 'admin-1491644494-14916445091273724', 1, 0, '', NULL, NULL, NULL),
(26235, '2017-04-08 17:18:14', NULL, NULL, 8369, 0, 181, '116', 'Open Food ', 'macadamia scones', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 17:18:14', 'admin-1491625322-14916430941001261', 1, 0, '', 1, NULL, NULL),
(26236, '2017-04-08 17:18:14', NULL, NULL, 8369, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 17:18:14', 'admin-1491625322-14916430941001261', 1, 0, '', 1, NULL, NULL),
(26237, '2017-04-08 13:15:10', NULL, NULL, 8357, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:15:10', 'admin-1491625322-14916285100604572', 1, 0, '', NULL, NULL, NULL),
(26238, '2017-04-08 13:15:10', NULL, NULL, 8357, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:15:10', 'admin-1491625322-14916285100604572', 1, 1, 'SR', NULL, NULL, NULL),
(26239, '2017-04-08 13:15:10', NULL, NULL, 8357, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:15:10', 'admin-1491625322-14916285100604572', 1, 1, 'SR', NULL, NULL, NULL),
(26240, '2017-04-08 13:59:23', NULL, NULL, 8365, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:59:23', 'admin-1491625322-14916311631387316', 1, 0, '', 1, NULL, NULL),
(26241, '2017-04-08 13:59:32', NULL, NULL, 8365, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:59:32', 'admin-1491625322-14916311722218651', 1, 0, '', 1, NULL, NULL),
(26242, '2017-04-08 13:49:08', NULL, NULL, 8361, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:49:08', 'admin-1491625322-14916305487282290', 1, 1, 'SR', NULL, NULL, NULL),
(26243, '2017-04-08 13:49:08', NULL, NULL, 8361, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:49:08', 'admin-1491625322-14916305487282290', 1, 1, 'SR', NULL, NULL, NULL),
(26244, '2017-04-08 13:49:08', NULL, NULL, 8361, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:49:08', 'admin-1491625322-14916305487282290', 1, 1, 'SR', NULL, NULL, NULL),
(26245, '2017-04-08 13:47:23', NULL, NULL, 8360, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:47:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26246, '2017-04-08 15:56:46', NULL, NULL, 8368, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1491644494', 'admin', '2017-04-08 15:56:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26247, '2017-04-08 15:56:59', NULL, NULL, 8368, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 15:56:59', 'admin-1491625322-14916382188597148', 1, 1, 'SR', NULL, NULL, NULL),
(26248, '2017-04-08 15:56:59', NULL, NULL, 8368, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 15:56:59', 'admin-1491625322-14916382188597148', 1, 1, 'SR', NULL, NULL, NULL),
(26249, '2017-04-08 16:10:36', NULL, NULL, 8367, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 16:10:36', 'admin-1491625322-14916390362203145', 1, 0, '', NULL, NULL, NULL),
(26250, '2017-04-08 12:23:41', NULL, NULL, 8355, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 12:23:41', 'admin-1491625322-14916254208666938', 1, 1, 'SR', NULL, NULL, NULL),
(26251, '2017-04-08 12:23:47', NULL, NULL, 8355, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 12:23:47', 'admin-1491625322-14916254275354334', 1, 1, 'SR', NULL, NULL, NULL),
(26252, '2017-04-08 12:40:05', NULL, NULL, 8356, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1491644494', 'admin', '2017-04-08 12:40:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26253, '2017-04-08 12:41:00', NULL, NULL, 8356, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 12:41:00', 'admin-1491625322-1491626459886296', 1, 0, '', NULL, NULL, NULL),
(26254, '2017-04-08 12:41:00', NULL, NULL, 8356, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 12:41:00', 'admin-1491625322-1491626459886296', 1, 0, '', NULL, NULL, NULL),
(26255, '2017-04-08 12:41:05', NULL, NULL, 8356, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 12:41:05', 'admin-1491625322-1491626465534392', 1, 0, '', NULL, NULL, NULL),
(26256, '2017-04-08 12:41:05', NULL, NULL, 8356, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 12:41:05', 'admin-1491625322-1491626465534392', 1, 0, '', NULL, NULL, NULL),
(26257, '2017-04-08 12:43:40', NULL, NULL, 8356, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 12:43:40', 'admin-1491625322-14916266202607999', 1, 1, 'SR', NULL, NULL, NULL),
(26258, '2017-04-08 12:43:40', NULL, NULL, 8356, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 12:43:40', 'admin-1491625322-14916266202607999', 1, 1, 'SR', NULL, NULL, NULL),
(26259, '2017-04-08 12:56:16', NULL, NULL, 8355, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 12:56:16', 'admin-1491625322-14916273764326581', 1, 0, '', NULL, NULL, NULL),
(26260, '2017-04-08 13:15:02', NULL, NULL, 8357, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:15:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26261, '2017-04-08 13:52:06', NULL, NULL, 8362, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:52:06', 'admin-1491625322-1491630726572144', 1, 1, 'SR', NULL, NULL, NULL),
(26262, '2017-04-08 18:53:08', NULL, NULL, 8371, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 18:53:08', 'admin-1491644494-1491648788103847', 1, 1, 'SR', 1, NULL, NULL),
(26263, '2017-04-08 17:41:19', NULL, NULL, 8370, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1491644494', 'admin', '2017-04-08 17:41:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26264, '2017-04-08 17:41:49', NULL, NULL, 8370, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 17:41:49', 'admin-1491644494-14916445091273724', 1, 0, '', NULL, NULL, NULL),
(26265, '2017-04-08 13:52:25', NULL, NULL, 8362, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:52:25', 'admin-1491625322-14916307450982489', 1, 0, '', NULL, NULL, NULL),
(26266, '2017-04-08 15:54:28', NULL, NULL, 8367, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 15:54:28', 'admin-1491625322-1491638067904329', 1, 0, '', NULL, NULL, NULL),
(26267, '2017-04-08 15:06:47', NULL, NULL, 8366, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 15:06:47', 'admin-1491625322-14916352072262799', 1, 1, 'SR', NULL, NULL, NULL),
(26268, '2017-04-08 15:06:37', NULL, NULL, 8366, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1491644494', 'admin', '2017-04-08 15:06:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26269, '2017-04-08 13:59:00', NULL, NULL, 8363, 0, 181, '116', 'Open Food ', 'banana', 'Meals', 'Perfect Meals', 1, 4.50, 4.5000, 0.0000, 4.50, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:59:00', 'admin-1491625322-14916311407277617', 1, 0, '', 1, NULL, NULL),
(26270, '2017-04-08 13:52:25', NULL, NULL, 8362, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:52:25', 'admin-1491625322-14916307450982489', 1, 1, 'SR', NULL, NULL, NULL),
(26271, '2017-04-08 13:51:58', NULL, NULL, 8362, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:51:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26272, '2017-04-08 11:20:20', NULL, NULL, 8353, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 11:20:20', 'admin-1491618162-14916216205112753', 1, 1, 'SR', NULL, NULL, NULL),
(26273, '2017-04-08 13:32:46', NULL, NULL, 8359, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:32:46', 'admin-1491625322-14916295661695733', 1, 1, 'SR', NULL, NULL, NULL),
(26274, '2017-04-08 13:32:39', NULL, NULL, 8359, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:32:39', 'admin-1491625322-14916295593246814', 1, 1, 'SR', NULL, NULL, NULL),
(26275, '2017-04-08 13:32:34', NULL, NULL, 8359, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:32:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26276, '2017-04-08 13:15:20', NULL, NULL, 8358, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:15:20', 'admin-1491625322-1491628520344297', 1, 0, '', NULL, NULL, NULL),
(26277, '2017-04-08 13:15:20', NULL, NULL, 8358, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:15:20', 'admin-1491625322-1491628520344297', 1, 1, 'SR', NULL, NULL, NULL),
(26278, '2017-04-08 13:15:12', NULL, NULL, 8358, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 13:15:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26279, '2017-04-08 15:54:12', NULL, NULL, 8367, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1491644494', 'admin', '2017-04-08 15:54:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26280, '2017-04-08 10:51:00', NULL, NULL, 8348, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:51:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26281, '2017-04-08 10:47:17', NULL, NULL, 8347, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:47:17', 'admin-1491618162-14916196374227877', 1, 0, '', NULL, NULL, NULL),
(26282, '2017-04-08 10:24:29', NULL, NULL, 8344, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:24:29', 'admin-1491618162-14916182691707668', 1, 1, 'SR', 1, NULL, NULL),
(26283, '2017-04-08 10:22:26', NULL, NULL, 8343, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:22:26', 'admin-1491615772-14916181466748212', 1, 0, '', NULL, NULL, NULL),
(26284, '2017-04-08 10:22:50', NULL, NULL, 8343, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:22:50', 'admin-1491618162-14916181702213490', 1, 1, 'SR', NULL, NULL, NULL),
(26285, '2017-04-08 10:23:15', NULL, NULL, 8336, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:23:15', 'admin-1491618162-1491618195289684', 1, 0, '', NULL, NULL, NULL),
(26286, '2017-04-08 12:23:41', NULL, NULL, 8355, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 12:23:41', 'admin-1491625322-14916254208666938', 1, 0, '', NULL, NULL, NULL),
(26287, '2017-04-08 09:12:12', NULL, NULL, 8332, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.00, 0.0000, 0.0000, 10.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:12:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26288, '2017-04-08 10:34:42', NULL, NULL, 8345, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:34:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26289, '2017-04-08 09:59:40', NULL, NULL, 8337, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:59:40', 'admin-1491615772-14916167804413782', 1, 0, '', NULL, NULL, NULL),
(26290, '2017-04-08 09:12:19', NULL, NULL, 8332, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:12:19', 'admin-1491613344-14916139394411925', 1, 0, '', NULL, NULL, NULL),
(26291, '2017-04-08 09:12:19', NULL, NULL, 8332, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:12:19', 'admin-1491613344-14916139394411925', 1, 0, '', NULL, NULL, NULL),
(26292, '2017-04-08 10:22:26', NULL, NULL, 8343, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:22:26', 'admin-1491615772-14916181466748212', 1, 0, '', NULL, NULL, NULL),
(26293, '2017-04-08 10:22:23', NULL, NULL, 8343, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:22:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26294, '2017-04-08 10:19:40', NULL, NULL, 8342, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:19:40', 'admin-1491615772-14916179804126975', 1, 1, 'SR', 1, NULL, NULL),
(26295, '2017-04-08 10:18:54', NULL, NULL, 8341, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:18:54', 'admin-1491615772-14916179339304438', 1, 0, '', 1, NULL, NULL),
(26296, '2017-04-08 10:18:54', NULL, NULL, 8341, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:18:54', 'admin-1491615772-14916179339304438', 1, 0, '', 1, NULL, NULL),
(26297, '2017-04-08 10:18:54', NULL, NULL, 8341, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:18:54', 'admin-1491615772-14916179339304438', 1, 0, '', 1, NULL, NULL),
(26298, '2017-04-08 10:17:51', NULL, NULL, 8336, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:17:51', 'admin-1491615772-14916178707874756', 1, 1, 'SR', NULL, NULL, NULL),
(26299, '2017-04-08 10:13:36', NULL, NULL, 8340, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:13:36', 'admin-1491615772-14916176167917360', 1, 1, 'SR', NULL, NULL, NULL),
(26300, '2017-04-08 10:13:33', NULL, NULL, 8340, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:13:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26301, '2017-04-08 09:56:54', NULL, NULL, 8336, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:56:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26302, '2017-04-08 09:57:02', NULL, NULL, 8336, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:57:02', 'admin-1491615772-14916166223297298', 1, 0, '', NULL, NULL, NULL),
(26303, '2017-04-08 09:57:02', NULL, NULL, 8336, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:57:02', 'admin-1491615772-14916166223297298', 1, 0, '', NULL, NULL, NULL),
(26304, '2017-04-08 09:57:02', NULL, NULL, 8336, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:57:02', 'admin-1491615772-14916166223297298', 1, 0, '', NULL, NULL, NULL),
(26305, '2017-04-08 09:57:02', NULL, NULL, 8336, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:57:02', 'admin-1491615772-14916166223297298', 1, 0, '', NULL, NULL, NULL),
(26306, '2017-04-08 09:59:35', NULL, NULL, 8337, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:59:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26307, '2017-04-08 09:59:40', NULL, NULL, 8337, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:59:40', 'admin-1491615772-14916167804413782', 1, 0, '', NULL, NULL, NULL),
(26308, '2017-04-08 18:53:13', NULL, NULL, 8372, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 18:53:13', 'admin-1491644494-14916487932312093', 1, 0, '', 1, NULL, NULL),
(26309, '2017-04-08 10:57:31', NULL, NULL, 8349, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.49, 0.0000, 0.0000, 1.49, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:57:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26310, '2017-04-08 10:57:36', NULL, NULL, 8349, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:57:36', 'admin-1491618162-14916202562088312', 1, 0, '', NULL, NULL, NULL),
(26311, '2017-04-08 10:57:36', NULL, NULL, 8349, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:57:36', 'admin-1491618162-14916202562088312', 1, 1, 'SR', NULL, NULL, NULL),
(26312, '2017-04-08 11:20:14', NULL, NULL, 8353, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1491644494', 'admin', '2017-04-08 11:20:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26313, '2017-04-08 10:12:56', NULL, NULL, 8339, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:12:56', 'admin-1491615772-14916175768126865', 1, 1, 'SR', NULL, NULL, NULL),
(26314, '2017-04-08 10:12:45', NULL, NULL, 8339, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:12:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26315, '2017-04-08 10:12:39', NULL, NULL, 8338, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:12:39', 'admin-1491615772-14916175595113149', 1, 0, '', NULL, NULL, NULL),
(26316, '2017-04-08 09:51:36', NULL, NULL, 8335, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:51:36', 'admin-1491615772-14916162960245550', 1, 0, '', NULL, NULL, NULL),
(26317, '2017-04-08 10:51:11', NULL, NULL, 8348, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:51:11', 'admin-1491618162-14916198709726860', 1, 0, '', NULL, NULL, NULL),
(26318, '2017-04-08 10:51:11', NULL, NULL, 8348, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:51:11', 'admin-1491618162-14916198709726860', 1, 1, 'SR', NULL, NULL, NULL),
(26319, '2017-04-08 10:51:11', NULL, NULL, 8348, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:51:11', 'admin-1491618162-14916198709726860', 1, 0, '', NULL, NULL, NULL),
(26320, '2017-04-08 10:12:39', NULL, NULL, 8338, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:12:39', 'admin-1491615772-14916175595113149', 1, 0, '', NULL, NULL, NULL),
(26321, '2017-04-08 10:12:28', NULL, NULL, 8333, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:12:28', 'admin-1491615772-14916175483997930', 1, 1, 'SR', NULL, NULL, NULL),
(26322, '2017-04-08 10:12:39', NULL, NULL, 8338, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:12:39', 'admin-1491615772-14916175595113149', 1, 0, '', NULL, NULL, NULL),
(26323, '2017-04-08 10:12:28', NULL, NULL, 8333, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:12:28', 'admin-1491615772-14916175483997930', 1, 1, 'SR', NULL, NULL, NULL),
(26324, '2017-04-08 10:12:28', NULL, NULL, 8333, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:12:28', 'admin-1491615772-14916175483997930', 1, 0, '', NULL, NULL, NULL),
(26325, '2017-04-08 10:05:08', NULL, NULL, 8338, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:05:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26326, '2017-04-08 10:05:13', NULL, NULL, 8338, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 10:05:13', 'admin-1491615772-14916171137091256', 1, 0, '', NULL, NULL, NULL),
(26327, '2017-04-08 09:14:01', NULL, NULL, 8332, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:14:01', 'admin-1491613344-14916140411764837', 1, 1, 'SR', NULL, NULL, NULL),
(26328, '2017-04-08 09:14:01', NULL, NULL, 8332, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:14:01', 'admin-1491613344-14916140411764837', 1, 1, 'SR', NULL, NULL, NULL),
(26329, '2017-04-08 09:14:01', NULL, NULL, 8332, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:14:01', 'admin-1491613344-14916140411764837', 1, 1, 'SR', NULL, NULL, NULL),
(26330, '2017-04-08 09:25:05', NULL, NULL, 8333, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.30, 0.0000, 0.0000, 14.30, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:25:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26331, '2017-04-08 09:25:13', NULL, NULL, 8333, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:25:13', 'admin-1491613344-1491614713453644', 1, 0, '', NULL, NULL, NULL),
(26332, '2017-04-08 09:25:47', NULL, NULL, 8333, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:25:47', 'admin-1491613344-14916147469709363', 1, 0, '', NULL, NULL, NULL),
(26333, '2017-04-08 09:25:13', NULL, NULL, 8333, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:25:13', 'admin-1491613344-1491614713453644', 1, 0, '', NULL, NULL, NULL),
(26334, '2017-04-08 09:25:26', NULL, NULL, 8333, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:25:26', 'admin-1491613344-14916147263993741', 1, 0, '', NULL, NULL, NULL),
(26335, '2017-04-08 09:25:26', NULL, NULL, 8333, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:25:26', 'admin-1491613344-14916147263993741', 1, 0, '', NULL, NULL, NULL),
(26336, '2017-04-08 09:51:24', NULL, NULL, 8335, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:51:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26337, '2017-04-08 09:49:01', NULL, NULL, 8334, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:49:01', 'admin-1491615772-14916161416466295', 1, 1, 'SR', NULL, NULL, NULL),
(26338, '2017-04-08 09:49:01', NULL, NULL, 8334, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:49:01', 'admin-1491615772-14916161416466295', 1, 1, 'SR', NULL, NULL, NULL),
(26339, '2017-04-08 09:25:26', NULL, NULL, 8333, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:25:26', 'admin-1491613344-14916147263993741', 1, 0, '', NULL, NULL, NULL),
(26340, '2017-04-08 09:42:46', NULL, NULL, 8331, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:42:46', 'admin-1491613344-14916157666743441', 1, 0, '', NULL, NULL, NULL),
(26341, '2017-04-08 09:48:30', NULL, NULL, 8334, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:48:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26342, '2017-04-08 09:48:35', NULL, NULL, 8334, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:48:35', 'admin-1491615772-14916161154331237', 1, 0, '', NULL, NULL, NULL),
(26343, '2017-04-08 09:49:01', NULL, NULL, 8334, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:49:01', 'admin-1491615772-14916161416466295', 1, 0, '', NULL, NULL, NULL),
(26344, '2017-04-08 09:25:26', NULL, NULL, 8333, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:25:26', 'admin-1491613344-14916147263993741', 1, 0, '', NULL, NULL, NULL),
(26345, '2017-04-08 09:25:26', NULL, NULL, 8333, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:25:26', 'admin-1491613344-14916147263993741', 1, 0, '', NULL, NULL, NULL),
(26346, '2017-04-08 09:14:01', NULL, NULL, 8332, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:14:01', 'admin-1491613344-14916140411764837', 1, 1, 'SR', NULL, NULL, NULL),
(26347, '2017-04-08 09:12:19', NULL, NULL, 8332, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:12:19', 'admin-1491613344-14916139394411925', 1, 0, '', NULL, NULL, NULL),
(26348, '2017-04-08 09:12:19', NULL, NULL, 8332, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:12:19', 'admin-1491613344-14916139394411925', 1, 0, '', NULL, NULL, NULL),
(26349, '2017-04-08 09:07:08', NULL, NULL, 8331, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:07:08', 'admin-1491613344-14916136280218432', 1, 0, '', NULL, NULL, NULL),
(26350, '2017-04-08 09:09:09', NULL, NULL, 8331, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:09:09', 'admin-1491613344-1491613749797716', 1, 0, '', NULL, NULL, NULL),
(26351, '2017-04-08 09:07:08', NULL, NULL, 8331, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:07:08', 'admin-1491613344-14916136280218432', 1, 0, '', NULL, NULL, NULL),
(26352, '2017-04-08 09:07:08', NULL, NULL, 8331, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:07:08', 'admin-1491613344-14916136280218432', 1, 0, '', NULL, NULL, NULL),
(26353, '2017-04-08 09:07:02', NULL, NULL, 8331, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1491644494', 'admin', '2017-04-08 09:07:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26354, '2017-04-09 15:56:56', NULL, NULL, 8412, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:56:56', 'admin-1491724084-14917246166257950', 1, 0, '', NULL, NULL, NULL),
(26355, '2017-04-09 15:21:02', NULL, NULL, 8409, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:21:02', 'admin-1491721105-14917224625441378', 1, 1, 'SR', NULL, NULL, NULL),
(26356, '2017-04-09 15:56:56', NULL, NULL, 8412, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:56:56', 'admin-1491724084-14917246166257950', 1, 1, 'SR', NULL, NULL, NULL),
(26357, '2017-04-09 15:56:41', NULL, NULL, 8412, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:56:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26358, '2017-04-09 15:55:48', NULL, NULL, 8408, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:55:48', 'admin-1491724084-14917245488119190', 1, 1, 'SR', NULL, NULL, NULL),
(26359, '2017-04-09 15:32:40', NULL, NULL, 8410, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:32:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26360, '2017-04-09 15:32:46', NULL, NULL, 8410, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:32:46', 'admin-1491721105-14917231666694824', 1, 0, '', NULL, NULL, NULL),
(26361, '2017-04-09 15:32:52', NULL, NULL, 8410, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:32:52', 'admin-1491721105-14917231727099238', 1, 0, '', NULL, NULL, NULL),
(26362, '2017-04-09 15:32:52', NULL, NULL, 8410, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:32:52', 'admin-1491721105-14917231727099238', 1, 1, 'SR', NULL, NULL, NULL),
(26363, '2017-04-09 15:45:12', NULL, NULL, 8411, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:45:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26364, '2017-04-09 15:45:19', NULL, NULL, 8411, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:45:19', 'admin-1491721105-14917239195492055', 1, 0, '', NULL, NULL, NULL),
(26365, '2017-04-09 15:21:02', NULL, NULL, 8409, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:21:02', 'admin-1491721105-14917224625441378', 1, 1, 'SR', NULL, NULL, NULL),
(26366, '2017-04-09 14:46:21', NULL, NULL, 8405, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:46:21', 'admin-1491718642-14917203807877388', 1, 0, '', NULL, NULL, NULL),
(26367, '2017-04-09 14:47:08', NULL, NULL, 8405, 0, 181, '116', 'Open Food ', 'macadamia scone', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:47:08', 'admin-1491718642-14917204278814147', 1, 0, '', NULL, NULL, NULL),
(26368, '2017-04-09 14:52:54', NULL, NULL, 8404, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:52:54', 'admin-1491718642-14917207739426041', 1, 0, '', NULL, NULL, NULL),
(26369, '2017-04-09 14:57:43', NULL, NULL, 8406, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:57:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26370, '2017-04-09 14:58:15', NULL, NULL, 8406, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:58:15', 'admin-1491718642-1491721094892909', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(26371, '2017-04-09 14:58:15', NULL, NULL, 8406, 0, 244, '178', 'Macadamia Scones', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:58:15', 'admin-1491718642-1491721094892909', 1, 0, '', NULL, NULL, NULL),
(26372, '2017-04-09 14:58:44', NULL, NULL, 8406, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:58:44', 'admin-1491721105-14917211241932934', 1, 1, 'SR', NULL, NULL, NULL),
(26373, '2017-04-09 14:58:44', NULL, NULL, 8406, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:58:44', 'admin-1491721105-14917211241932934', 1, 1, 'SR', NULL, NULL, NULL),
(26374, '2017-04-09 14:58:44', NULL, NULL, 8406, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:58:44', 'admin-1491721105-14917211241932934', 1, 1, 'SR', NULL, NULL, NULL),
(26375, '2017-04-09 15:01:34', NULL, NULL, 8404, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:01:34', 'admin-1491721105-14917212945552461', 1, 1, 'SR', NULL, NULL, NULL),
(26376, '2017-04-09 15:04:24', NULL, NULL, 8407, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.15, 0.0000, 0.0000, 2.15, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:04:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26377, '2017-04-09 14:07:46', NULL, NULL, 8403, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:07:46', 'admin-1491715686-1491718066384569', 1, 1, 'SR', NULL, NULL, NULL),
(26378, '2017-04-09 14:07:46', NULL, NULL, 8403, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:07:46', 'admin-1491715686-1491718066384569', 1, 1, 'SR', NULL, NULL, NULL),
(26379, '2017-04-09 15:15:01', NULL, NULL, 8408, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:15:01', 'admin-1491721105-14917221009069237', 1, 1, 'SR', NULL, NULL, NULL),
(26380, '2017-04-09 15:17:36', NULL, NULL, 8409, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:17:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26381, '2017-04-09 15:21:28', NULL, NULL, 8409, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:21:28', 'admin-1491721105-14917224881794650', 1, 1, 'SR', NULL, NULL, NULL),
(26382, '2017-04-09 13:51:36', NULL, NULL, 8401, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:51:36', 'admin-1491715686-14917170959169529', 1, 0, '', NULL, NULL, NULL),
(26383, '2017-04-09 13:51:36', NULL, NULL, 8401, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:51:36', 'admin-1491715686-14917170959169529', 1, 0, '', NULL, NULL, NULL),
(26384, '2017-04-09 13:51:36', NULL, NULL, 8401, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:51:36', 'admin-1491715686-14917170959169529', 1, 0, '', NULL, NULL, NULL),
(26385, '2017-04-09 13:51:59', NULL, NULL, 8401, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:51:59', 'admin-1491715686-14917171192088773', 1, 1, 'SR', NULL, NULL, NULL),
(26386, '2017-04-09 13:51:59', NULL, NULL, 8401, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:51:59', 'admin-1491715686-14917171192088773', 1, 1, 'SR', NULL, NULL, NULL),
(26387, '2017-04-09 14:00:48', NULL, NULL, 8402, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:00:48', 'admin-1491715686-14917176487613216', 1, 0, '', NULL, NULL, NULL),
(26388, '2017-04-09 14:00:48', NULL, NULL, 8402, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:00:48', 'admin-1491715686-14917176487613216', 1, 1, 'SR', NULL, NULL, NULL),
(26389, '2017-04-09 14:02:09', NULL, NULL, 8397, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:02:09', 'admin-1491715686-14917177296918570', 1, 1, 'SR', NULL, NULL, NULL),
(26390, '2017-04-09 14:06:48', NULL, NULL, 8403, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.50, 0.0000, 0.0000, 9.50, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:06:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26391, '2017-04-09 12:07:41', NULL, NULL, 8386, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 12:07:41', 'admin-1491710701-14917108609668179', 1, 1, 'SR', NULL, NULL, NULL),
(26392, '2017-04-09 12:18:34', NULL, NULL, 8393, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1491724084', 'admin', '2017-04-09 12:18:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26393, '2017-04-09 11:40:26', NULL, NULL, 8390, 0, 154, '88', 'Daily Dose BLT', 'no sesame sauce', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:40:26', 'admin-1491708693-14917092262873325', 1, 0, '', NULL, NULL, NULL),
(26394, '2017-04-09 11:40:50', NULL, NULL, 8390, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:40:50', 'admin-1491708693-149170925002166', 1, 1, 'SR', NULL, NULL, NULL),
(26395, '2017-04-09 13:08:48', NULL, NULL, 8395, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:08:48', 'admin-1491710701-14917145285791765', 1, 0, '', NULL, NULL, NULL),
(26396, '2017-04-09 13:00:05', NULL, NULL, 8394, 0, 153, '87', 'Wake Me Up!', 'no bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:00:05', 'admin-1491710701-14917140053144262', 1, 0, '', NULL, NULL, NULL),
(26397, '2017-04-09 10:37:02', NULL, NULL, 8382, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:37:02', 'admin-1491704103-14917054221153296', 1, 0, '', NULL, NULL, NULL),
(26398, '2017-04-09 10:31:40', NULL, NULL, 8381, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:31:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26399, '2017-04-09 10:32:01', NULL, NULL, 8381, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:32:01', 'admin-1491704103-14917051215221220', 1, 0, '', NULL, NULL, NULL),
(26400, '2017-04-09 10:32:01', NULL, NULL, 8381, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:32:01', 'admin-1491704103-14917051215221220', 1, 0, '', NULL, NULL, NULL),
(26401, '2017-04-09 10:32:01', NULL, NULL, 8381, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:32:01', 'admin-1491704103-14917051215221220', 1, 0, '', NULL, NULL, NULL),
(26402, '2017-04-09 10:32:20', NULL, NULL, 8381, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:32:20', 'admin-1491704103-14917051400653316', 1, 1, 'SR', NULL, NULL, NULL),
(26403, '2017-04-09 13:08:48', NULL, NULL, 8395, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:08:48', 'admin-1491710701-14917145285791765', 1, 0, '', NULL, NULL, NULL),
(26404, '2017-04-09 13:00:18', NULL, NULL, 8394, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:00:18', 'admin-1491710701-1491714018267938', 1, 1, 'SR', NULL, NULL, NULL),
(26405, '2017-04-09 13:07:25', NULL, NULL, 8395, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:07:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26406, '2017-04-09 13:08:48', NULL, NULL, 8395, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:08:48', 'admin-1491710701-14917145285791765', 1, 0, '', NULL, NULL, NULL),
(26407, '2017-04-09 10:28:38', NULL, NULL, 8380, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:28:38', 'admin-1491704103-14917049182847614', 1, 1, 'SR', NULL, NULL, NULL),
(26408, '2017-04-09 10:28:38', NULL, NULL, 8380, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:28:38', 'admin-1491704103-14917049182847614', 1, 1, 'SR', NULL, NULL, NULL),
(26409, '2017-04-09 14:07:46', NULL, NULL, 8403, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:07:46', 'admin-1491715686-1491718066384569', 1, 0, '', NULL, NULL, NULL),
(26410, '2017-04-09 14:00:14', NULL, NULL, 8402, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:00:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26411, '2017-04-09 10:55:27', NULL, NULL, 8384, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:55:27', 'admin-1491705540-1491706527149626', 1, 1, 'SR', NULL, NULL, '10.0'),
(26412, '2017-04-09 10:55:27', NULL, NULL, 8384, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:55:27', 'admin-1491705540-1491706527149626', 1, 1, 'SR', NULL, NULL, '10.0'),
(26413, '2017-04-09 10:55:27', NULL, NULL, 8384, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:55:27', 'admin-1491705540-1491706527149626', 1, 0, '', NULL, NULL, '10.0'),
(26414, '2017-04-09 10:55:27', NULL, NULL, 8384, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:55:27', 'admin-1491705540-1491706527149626', 1, 1, 'SR', NULL, NULL, '10.0'),
(26415, '2017-04-09 10:39:26', NULL, NULL, 8383, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:39:26', 'admin-1491705540-14917055657525491', 1, 1, 'SR', NULL, NULL, NULL),
(26416, '2017-04-09 10:39:26', NULL, NULL, 8383, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:39:26', 'admin-1491705540-14917055657525491', 1, 1, 'SR', NULL, NULL, NULL),
(26417, '2017-04-09 10:54:35', NULL, NULL, 8384, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 17.20, 0.0000, 0.0000, 17.20, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:54:35', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(26418, '2017-04-09 10:54:53', NULL, NULL, 8384, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:54:53', 'admin-1491705540-14917064931768651', 1, 0, '', NULL, NULL, '10.0'),
(26419, '2017-04-09 10:54:53', NULL, NULL, 8384, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:54:53', 'admin-1491705540-14917064931768651', 1, 0, '', NULL, NULL, '10.0'),
(26420, '2017-04-09 15:04:43', NULL, NULL, 8407, 0, 181, '116', 'Open Food ', 'apple', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:04:43', 'admin-1491721105-14917214830191478', 1, 0, '', NULL, NULL, NULL),
(26421, '2017-04-09 15:09:44', NULL, NULL, 8402, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:09:44', 'admin-1491721105-14917217846471814', 1, 0, '', NULL, NULL, NULL),
(26422, '2017-04-09 15:13:52', NULL, NULL, 8408, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:13:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26423, '2017-04-09 15:14:47', NULL, NULL, 8408, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:14:47', 'admin-1491721105-14917220873205692', 1, 0, '', NULL, NULL, NULL),
(26424, '2017-04-09 15:14:47', NULL, NULL, 8408, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:14:47', 'admin-1491721105-14917220873205692', 1, 0, '', NULL, NULL, NULL),
(26425, '2017-04-09 13:08:48', NULL, NULL, 8395, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:08:48', 'admin-1491710701-14917145285791765', 1, 0, '', NULL, NULL, NULL),
(26426, '2017-04-09 13:10:07', NULL, NULL, 8396, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:10:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26427, '2017-04-09 13:10:16', NULL, NULL, 8396, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:10:16', 'admin-1491710701-14917146160962858', 1, 0, '', NULL, NULL, NULL),
(26428, '2017-04-09 13:10:16', NULL, NULL, 8396, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:10:16', 'admin-1491710701-14917146160962858', 1, 0, '', NULL, NULL, NULL),
(26429, '2017-04-09 13:46:47', NULL, NULL, 8400, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:46:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26430, '2017-04-09 14:00:26', NULL, NULL, 8402, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:00:26', 'admin-1491715686-14917176265584014', 1, 0, '', NULL, NULL, NULL),
(26431, '2017-04-09 14:00:26', NULL, NULL, 8402, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:00:26', 'admin-1491715686-14917176265584014', 1, 0, '', NULL, NULL, NULL),
(26432, '2017-04-09 15:15:01', NULL, NULL, 8408, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:15:01', 'admin-1491721105-14917221009069237', 1, 1, 'SR', NULL, NULL, NULL),
(26433, '2017-04-09 15:04:43', NULL, NULL, 8407, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:04:43', 'admin-1491721105-14917214830191478', 1, 1, 'SR', NULL, NULL, NULL),
(26434, '2017-04-09 14:46:21', NULL, NULL, 8405, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:46:21', 'admin-1491718642-14917203807877388', 1, 1, 'SR', NULL, NULL, NULL),
(26435, '2017-04-09 14:16:34', NULL, NULL, 8404, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:16:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26436, '2017-04-09 14:16:50', NULL, NULL, 8404, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:16:50', 'admin-1491715686-1491718610674878', 1, 1, 'SR', NULL, NULL, NULL),
(26437, '2017-04-09 14:16:50', NULL, NULL, 8404, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:16:50', 'admin-1491715686-1491718610674878', 1, 1, 'SR', NULL, NULL, NULL),
(26438, '2017-04-09 14:17:35', NULL, NULL, 8404, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:17:35', 'admin-1491718642-14917186552456292', 1, 1, 'SR', NULL, NULL, NULL),
(26439, '2017-04-09 14:17:35', NULL, NULL, 8404, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:17:35', 'admin-1491718642-14917186552456292', 1, 0, '', NULL, NULL, NULL),
(26440, '2017-04-09 14:26:03', NULL, NULL, 8402, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:26:03', 'admin-1491718642-14917191633729887', 1, 1, 'SR', NULL, NULL, NULL),
(26441, '2017-04-09 14:42:41', NULL, NULL, 8403, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:42:41', 'admin-1491718642-1491720161373327', 1, 1, 'SR', NULL, NULL, NULL),
(26442, '2017-04-09 14:27:50', NULL, NULL, 8402, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:27:50', 'admin-1491718642-14917192706748819', 1, 0, '', NULL, NULL, NULL),
(26443, '2017-04-09 14:42:41', NULL, NULL, 8403, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:42:41', 'admin-1491718642-1491720161373327', 1, 0, '', NULL, NULL, NULL),
(26444, '2017-04-09 14:42:41', NULL, NULL, 8403, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:42:41', 'admin-1491718642-1491720161373327', 1, 0, '', NULL, NULL, NULL),
(26445, '2017-04-09 14:43:52', NULL, NULL, 8405, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.50, 0.0000, 0.0000, 10.50, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:43:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26446, '2017-04-09 14:44:23', NULL, NULL, 8405, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:44:23', 'admin-1491718642-14917202628303673', 1, 0, '', NULL, NULL, NULL),
(26447, '2017-04-09 14:44:23', NULL, NULL, 8405, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:44:23', 'admin-1491718642-14917202628303673', 1, 0, '', NULL, NULL, NULL),
(26448, '2017-04-09 14:46:20', NULL, NULL, 8405, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:46:20', 'admin-1491718642-14917203807877388', 1, 0, '', NULL, NULL, NULL),
(26449, '2017-04-09 14:46:21', NULL, NULL, 8405, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:46:21', 'admin-1491718642-14917203807877388', 1, 1, 'SR', NULL, NULL, NULL),
(26450, '2017-04-09 14:46:20', NULL, NULL, 8405, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:46:21', 'admin-1491718642-14917203807877388', 1, 1, 'SR', NULL, NULL, NULL),
(26451, '2017-04-09 13:51:36', NULL, NULL, 8401, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:51:36', 'admin-1491715686-14917170959169529', 1, 0, '', NULL, NULL, NULL),
(26452, '2017-04-09 13:39:20', NULL, NULL, 8398, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:39:20', 'admin-1491715686-14917163600834799', 1, 0, '', NULL, NULL, NULL),
(26453, '2017-04-09 13:39:20', NULL, NULL, 8398, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:39:20', 'admin-1491715686-14917163600834799', 1, 0, '', NULL, NULL, NULL),
(26454, '2017-04-09 13:51:59', NULL, NULL, 8401, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:51:59', 'admin-1491715686-14917171192088773', 1, 0, '', NULL, NULL, NULL),
(26455, '2017-04-09 13:51:59', NULL, NULL, 8401, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:51:59', 'admin-1491715686-14917171192088773', 1, 1, 'SR', NULL, NULL, NULL),
(26456, '2017-04-09 13:51:59', NULL, NULL, 8401, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:51:59', 'admin-1491715686-14917171192088773', 1, 1, 'SR', NULL, NULL, NULL),
(26457, '2017-04-09 10:54:53', NULL, NULL, 8384, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:54:53', 'admin-1491705540-14917064931768651', 1, 0, '', NULL, NULL, '10.0'),
(26458, '2017-04-09 10:54:53', NULL, NULL, 8384, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:54:53', 'admin-1491705540-14917064931768651', 1, 0, '', NULL, NULL, '10.0'),
(26459, '2017-04-09 10:54:53', NULL, NULL, 8384, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:54:53', 'admin-1491705540-14917064931768651', 1, 0, '', NULL, NULL, '10.0'),
(26460, '2017-04-09 12:29:26', NULL, NULL, 8392, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 12:29:26', 'admin-1491710701-14917121660565926', 1, 1, 'SR', NULL, NULL, NULL),
(26461, '2017-04-09 15:04:43', NULL, NULL, 8407, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:04:43', 'admin-1491721105-14917214830191478', 1, 0, '', NULL, NULL, NULL),
(26462, '2017-04-09 14:46:20', NULL, NULL, 8405, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:46:20', 'admin-1491718642-14917203807877388', 1, 1, 'SR', NULL, NULL, NULL),
(26463, '2017-04-09 14:07:46', NULL, NULL, 8403, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 14:07:46', 'admin-1491715686-1491718066384569', 1, 0, '', NULL, NULL, NULL),
(26464, '2017-04-09 12:03:37', NULL, NULL, 8392, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.90, 0.0000, 0.0000, 10.90, 1, '27', 1, '1491724084', 'admin', '2017-04-09 12:03:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26465, '2017-04-09 12:18:47', NULL, NULL, 8393, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 12:18:47', 'admin-1491710701-14917115274996949', 1, 0, '', NULL, NULL, NULL),
(26466, '2017-04-09 12:18:47', NULL, NULL, 8393, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 12:18:47', 'admin-1491710701-14917115274996949', 1, 0, '', NULL, NULL, NULL),
(26467, '2017-04-09 12:19:02', NULL, NULL, 8393, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 12:19:02', 'admin-1491710701-14917115426254752', 1, 1, 'SR', NULL, NULL, NULL),
(26468, '2017-04-09 13:51:36', NULL, NULL, 8401, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:51:36', 'admin-1491715686-14917170959169529', 1, 0, '', NULL, NULL, NULL),
(26469, '2017-04-09 13:51:36', NULL, NULL, 8401, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:51:36', 'admin-1491715686-14917170959169529', 1, 0, '', NULL, NULL, NULL),
(26470, '2017-04-09 13:51:19', NULL, NULL, 8401, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.10, 0.0000, 0.0000, 16.10, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:51:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26471, '2017-04-09 15:21:28', NULL, NULL, 8409, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:21:28', 'admin-1491721105-14917224881794650', 1, 0, '', NULL, NULL, NULL),
(26472, '2017-04-09 13:48:24', NULL, NULL, 8400, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:48:24', 'admin-1491715686-1491716903942113', 1, 0, '', NULL, NULL, NULL),
(26473, '2017-04-09 13:48:33', NULL, NULL, 8400, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:48:33', 'admin-1491715686-14917169131527891', 1, 1, 'SR', NULL, NULL, NULL),
(26474, '2017-04-09 13:48:24', NULL, NULL, 8400, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:48:24', 'admin-1491715686-1491716903942113', 1, 1, 'SR', NULL, NULL, NULL),
(26475, '2017-04-09 13:33:56', NULL, NULL, 8399, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:33:56', 'admin-1491715686-14917160362767862', 1, 0, '', NULL, NULL, NULL),
(26476, '2017-04-09 13:33:56', NULL, NULL, 8399, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:33:56', 'admin-1491715686-14917160362767862', 1, 0, '', NULL, NULL, NULL),
(26477, '2017-04-09 13:33:56', NULL, NULL, 8399, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:33:56', 'admin-1491715686-14917160362767862', 1, 0, '', NULL, NULL, NULL),
(26478, '2017-04-09 13:31:51', NULL, NULL, 8398, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:31:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26479, '2017-04-09 13:31:56', NULL, NULL, 8398, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:31:56', 'admin-1491715686-14917159164133085', 1, 0, '', NULL, NULL, NULL),
(26480, '2017-04-09 13:33:29', NULL, NULL, 8399, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:33:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26481, '2017-04-09 13:33:56', NULL, NULL, 8399, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:33:56', 'admin-1491715686-14917160362767862', 1, 1, 'SR', NULL, NULL, NULL),
(26482, '2017-04-09 12:04:50', NULL, NULL, 8392, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 12:04:50', 'admin-1491708693-14917106905011456', 1, 0, '', NULL, NULL, NULL),
(26483, '2017-04-09 12:05:14', NULL, NULL, 8392, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 12:05:14', 'admin-1491710701-1491710714529456', 1, 0, '', NULL, NULL, NULL),
(26484, '2017-04-09 12:07:19', NULL, NULL, 8389, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 12:07:19', 'admin-1491710701-14917108392422832', 1, 0, '', NULL, NULL, NULL),
(26485, '2017-04-09 13:33:56', NULL, NULL, 8399, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:33:56', 'admin-1491715686-14917160362767862', 1, 1, 'SR', NULL, NULL, NULL),
(26486, '2017-04-09 13:33:56', NULL, NULL, 8399, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:33:56', 'admin-1491715686-14917160362767862', 1, 1, 'SR', NULL, NULL, NULL),
(26487, '2017-04-09 13:28:24', NULL, NULL, 8397, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:28:24', 'admin-1491715686-14917157046169136', 1, 1, 'SR', NULL, NULL, NULL),
(26488, '2017-04-09 13:27:48', NULL, NULL, 8397, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:27:48', 'admin-1491710701-14917156679617153', 1, 0, '', NULL, NULL, NULL),
(26489, '2017-04-09 13:27:48', NULL, NULL, 8397, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:27:48', 'admin-1491710701-14917156679617153', 1, 1, 'SR', NULL, NULL, NULL),
(26490, '2017-04-09 13:27:29', NULL, NULL, 8397, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:27:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26491, '2017-04-09 12:25:26', NULL, NULL, 8392, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 12:25:26', 'admin-1491710701-14917119261295876', 1, 0, '', NULL, NULL, NULL),
(26492, '2017-04-09 12:25:26', NULL, NULL, 8392, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 12:25:26', 'admin-1491710701-14917119261295876', 1, 0, '', NULL, NULL, NULL),
(26493, '2017-04-09 12:19:02', NULL, NULL, 8393, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 12:19:02', 'admin-1491710701-14917115426254752', 1, 1, 'SR', NULL, NULL, NULL),
(26494, '2017-04-09 13:10:16', NULL, NULL, 8396, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:10:16', 'admin-1491710701-14917146160962858', 1, 1, 'SR', NULL, NULL, NULL),
(26495, '2017-04-09 11:33:14', NULL, NULL, 8389, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.00, 0.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:33:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26496, '2017-04-09 11:33:18', NULL, NULL, 8389, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:33:18', 'admin-1491708693-14917087987273978', 1, 1, 'SR', NULL, NULL, NULL),
(26497, '2017-04-09 11:37:22', NULL, NULL, 8384, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:37:22', 'admin-1491708693-14917090423872546', 1, 0, '', NULL, NULL, '10.0'),
(26498, '2017-04-09 11:40:11', NULL, NULL, 8390, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:40:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26499, '2017-04-09 11:40:26', NULL, NULL, 8390, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:40:26', 'admin-1491708693-14917092262873325', 1, 0, '', NULL, NULL, NULL),
(26500, '2017-04-09 11:16:49', NULL, NULL, 8387, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:16:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26501, '2017-04-09 13:48:24', NULL, NULL, 8400, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:48:24', 'admin-1491715686-1491716903942113', 1, 0, '', NULL, NULL, NULL),
(26502, '2017-04-09 11:40:50', NULL, NULL, 8390, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:40:50', 'admin-1491708693-149170925002166', 1, 1, 'SR', NULL, NULL, NULL),
(26503, '2017-04-09 11:45:09', NULL, NULL, 8385, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:45:09', 'admin-1491708693-14917095094586496', 1, 0, '', NULL, NULL, NULL),
(26504, '2017-04-09 11:45:28', NULL, NULL, 8389, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:45:28', 'admin-1491708693-14917095281157364', 1, 0, '', NULL, NULL, NULL),
(26505, '2017-04-09 11:45:28', NULL, NULL, 8389, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:45:28', 'admin-1491708693-14917095281157364', 1, 0, '', NULL, NULL, NULL),
(26506, '2017-04-09 11:45:28', NULL, NULL, 8389, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:45:28', 'admin-1491708693-14917095281157364', 1, 0, '', NULL, NULL, NULL),
(26507, '2017-04-09 11:45:28', NULL, NULL, 8389, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:45:28', 'admin-1491708693-14917095281157364', 1, 0, '', NULL, NULL, NULL),
(26508, '2017-04-09 11:45:37', NULL, NULL, 8389, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:45:37', 'admin-1491708693-1491709537140297', 1, 1, 'SR', NULL, NULL, NULL),
(26509, '2017-04-09 11:45:37', NULL, NULL, 8389, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:45:37', 'admin-1491708693-1491709537140297', 1, 1, 'SR', NULL, NULL, NULL),
(26510, '2017-04-09 11:50:15', NULL, NULL, 8391, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:50:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26511, '2017-04-09 11:51:09', NULL, NULL, 8391, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:51:09', 'admin-1491708693-1491709868891982', 1, 0, '', NULL, NULL, NULL),
(26512, '2017-04-09 11:51:09', NULL, NULL, 8391, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:51:09', 'admin-1491708693-1491709868891982', 1, 0, '', NULL, NULL, NULL),
(26513, '2017-04-09 11:51:09', NULL, NULL, 8391, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:51:09', 'admin-1491708693-1491709868891982', 1, 0, '', NULL, NULL, NULL),
(26514, '2017-04-09 11:51:09', NULL, NULL, 8391, 0, 153, '87', 'Wake Me Up!', 'change to sunny side up', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:51:09', 'admin-1491708693-1491709868891982', 1, 0, '', NULL, NULL, NULL),
(26515, '2017-04-09 11:51:21', NULL, NULL, 8391, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:51:21', 'admin-1491708693-14917098815002442', 1, 1, 'SR', NULL, NULL, NULL),
(26516, '2017-04-09 11:51:21', NULL, NULL, 8391, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:51:21', 'admin-1491708693-14917098815002442', 1, 1, 'SR', NULL, NULL, NULL),
(26517, '2017-04-09 11:31:28', NULL, NULL, 8388, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:31:28', 'admin-1491705540-14917086886041917', 1, 0, '', NULL, NULL, NULL),
(26518, '2017-04-09 11:31:28', NULL, NULL, 8388, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:31:28', 'admin-1491705540-14917086886041917', 1, 0, '', NULL, NULL, NULL),
(26519, '2017-04-09 12:04:50', NULL, NULL, 8392, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 12:04:50', 'admin-1491708693-14917106905011456', 1, 0, '', NULL, NULL, NULL),
(26520, '2017-04-09 12:04:50', NULL, NULL, 8392, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 12:04:50', 'admin-1491708693-14917106905011456', 1, 0, '', NULL, NULL, NULL),
(26521, '2017-04-09 11:31:28', NULL, NULL, 8388, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:31:28', 'admin-1491705540-14917086886041917', 1, 1, 'SR', NULL, NULL, NULL),
(26522, '2017-04-09 11:31:28', NULL, NULL, 8388, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:31:28', 'admin-1491705540-14917086886041917', 1, 0, '', NULL, NULL, NULL),
(26523, '2017-04-09 11:40:50', NULL, NULL, 8390, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:40:50', 'admin-1491708693-149170925002166', 1, 1, 'SR', NULL, NULL, NULL),
(26524, '2017-04-09 12:58:32', NULL, NULL, 8394, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1491724084', 'admin', '2017-04-09 12:58:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26525, '2017-04-09 11:40:26', NULL, NULL, 8390, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:40:26', 'admin-1491708693-14917092262873325', 1, 0, '', NULL, NULL, NULL),
(26526, '2017-04-09 11:31:28', NULL, NULL, 8388, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:31:28', 'admin-1491705540-14917086886041917', 1, 1, 'SR', NULL, NULL, NULL),
(26527, '2017-04-09 10:38:41', NULL, NULL, 8383, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:38:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26528, '2017-04-09 10:38:49', NULL, NULL, 8383, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:38:49', 'admin-1491704103-14917055293834254', 1, 0, '', NULL, NULL, NULL),
(26529, '2017-04-09 13:28:24', NULL, NULL, 8397, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:28:24', 'admin-1491715686-14917157046169136', 1, 1, 'SR', NULL, NULL, NULL),
(26530, '2017-04-09 11:31:02', NULL, NULL, 8388, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:31:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26531, '2017-04-09 11:28:21', NULL, NULL, 8382, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:28:21', 'admin-1491705540-1491708501164583', 1, 0, '', NULL, NULL, NULL),
(26532, '2017-04-09 11:28:15', NULL, NULL, 8382, 0, 181, '116', 'Open Food ', 'baked bean', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:28:15', 'admin-1491705540-14917084956905816', 1, 0, '', NULL, NULL, NULL),
(26533, '2017-04-09 11:16:54', NULL, NULL, 8387, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:16:54', 'admin-1491705540-14917078146792748', 1, 0, '', NULL, NULL, NULL),
(26534, '2017-04-09 11:16:54', NULL, NULL, 8387, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:16:54', 'admin-1491705540-14917078146792748', 1, 0, '', NULL, NULL, NULL),
(26535, '2017-04-09 11:05:24', NULL, NULL, 8386, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:05:24', 'admin-1491705540-14917071246101795', 1, 0, '', NULL, NULL, NULL),
(26536, '2017-04-09 11:05:33', NULL, NULL, 8386, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:05:33', 'admin-1491705540-14917071328918734', 1, 0, '', NULL, NULL, NULL),
(26537, '2017-04-09 11:05:12', NULL, NULL, 8386, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:05:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26538, '2017-04-09 11:05:24', NULL, NULL, 8386, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 11:05:24', 'admin-1491705540-14917071246101795', 1, 0, '', NULL, NULL, NULL),
(26539, '2017-04-09 10:57:01', NULL, NULL, 8385, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:57:01', 'admin-1491705540-14917066213986181', 1, 0, '', NULL, NULL, NULL),
(26540, '2017-04-09 10:57:01', NULL, NULL, 8385, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:57:01', 'admin-1491705540-14917066213986181', 1, 1, 'SR', NULL, NULL, NULL),
(26541, '2017-04-09 10:56:46', NULL, NULL, 8385, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:56:46', 'admin-1491705540-14917066062189488', 1, 0, '', NULL, NULL, NULL),
(26542, '2017-04-09 10:56:36', NULL, NULL, 8385, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:56:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26543, '2017-04-09 10:56:46', NULL, NULL, 8385, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:56:46', 'admin-1491705540-14917066062189488', 1, 0, '', NULL, NULL, NULL),
(26544, '2017-04-09 10:14:33', NULL, NULL, 8377, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:14:33', 'admin-1491698647-14917040733622528', 1, 0, '', NULL, NULL, NULL),
(26545, '2017-04-09 10:14:55', NULL, NULL, 8377, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:14:55', 'admin-1491698647-14917040954485810', 1, 0, '', NULL, NULL, NULL),
(26546, '2017-04-09 10:14:55', NULL, NULL, 8377, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:14:55', 'admin-1491698647-14917040954485810', 1, 0, '', NULL, NULL, NULL),
(26547, '2017-04-09 10:15:13', NULL, NULL, 8378, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:15:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26548, '2017-04-09 10:15:31', NULL, NULL, 8378, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:15:31', 'admin-1491704103-14917041312495298', 1, 0, '', NULL, NULL, NULL),
(26549, '2017-04-09 10:15:31', NULL, NULL, 8378, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:15:31', 'admin-1491704103-14917041312495298', 1, 0, '', NULL, NULL, NULL),
(26550, '2017-04-09 10:15:31', NULL, NULL, 8378, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:15:31', 'admin-1491704103-14917041312495298', 1, 0, '', NULL, NULL, NULL),
(26551, '2017-04-09 10:15:31', NULL, NULL, 8378, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:15:31', 'admin-1491704103-14917041312495298', 1, 0, '', NULL, NULL, NULL),
(26552, '2017-04-09 10:16:30', NULL, NULL, 8379, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:16:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26553, '2017-04-09 10:16:37', NULL, NULL, 8379, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:16:37', 'admin-1491704103-14917041972362668', 1, 1, 'SR', NULL, NULL, NULL),
(26554, '2017-04-09 10:16:37', NULL, NULL, 8379, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:16:37', 'admin-1491704103-14917041972362668', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(26555, '2017-04-09 10:20:04', NULL, NULL, 8377, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:20:04', 'admin-1491704103-14917044040454660', 1, 1, 'SR', NULL, NULL, NULL),
(26556, '2017-04-09 10:20:04', NULL, NULL, 8377, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:20:04', 'admin-1491704103-14917044040454660', 1, 1, 'SR', NULL, NULL, NULL),
(26557, '2017-04-09 10:20:04', NULL, NULL, 8377, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:20:04', 'admin-1491704103-14917044040454660', 1, 1, 'SR', NULL, NULL, NULL),
(26558, '2017-04-09 10:20:04', NULL, NULL, 8377, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:20:04', 'admin-1491704103-14917044040454660', 1, 0, '', NULL, NULL, NULL),
(26559, '2017-04-09 10:20:04', NULL, NULL, 8377, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:20:04', 'admin-1491704103-14917044040454660', 1, 1, 'SR', NULL, NULL, NULL),
(26560, '2017-04-09 10:20:04', NULL, NULL, 8377, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:20:04', 'admin-1491704103-14917044040454660', 1, 0, '', NULL, NULL, NULL),
(26561, '2017-04-09 10:27:57', NULL, NULL, 8380, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.60, 0.0000, 0.0000, 11.60, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:27:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26562, '2017-04-09 10:28:17', NULL, NULL, 8380, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:28:17', 'admin-1491704103-1491704897432433', 1, 0, '', NULL, NULL, NULL),
(26563, '2017-04-09 10:28:17', NULL, NULL, 8380, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:28:17', 'admin-1491704103-1491704897432433', 1, 0, '', NULL, NULL, NULL),
(26564, '2017-04-09 10:28:17', NULL, NULL, 8380, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:28:17', 'admin-1491704103-1491704897432433', 1, 0, '', NULL, NULL, NULL),
(26565, '2017-04-09 10:36:27', NULL, NULL, 8382, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:36:27', 'admin-1491704103-1491705387110284', 1, 0, '', NULL, NULL, NULL),
(26566, '2017-04-09 10:36:27', NULL, NULL, 8382, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:36:27', 'admin-1491704103-1491705387110284', 1, 0, '', NULL, NULL, NULL),
(26567, '2017-04-09 10:37:02', NULL, NULL, 8382, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:37:02', 'admin-1491704103-14917054221153296', 1, 1, 'SR', NULL, NULL, NULL),
(26568, '2017-04-09 13:10:16', NULL, NULL, 8396, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:10:16', 'admin-1491710701-14917146160962858', 1, 1, 'SR', NULL, NULL, NULL),
(26569, '2017-04-09 13:00:05', NULL, NULL, 8394, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:00:05', 'admin-1491710701-14917140053144262', 1, 0, '', NULL, NULL, NULL),
(26570, '2017-04-09 10:55:27', NULL, NULL, 8384, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:55:27', 'admin-1491705540-1491706527149626', 1, 0, '', NULL, NULL, '10.0'),
(26571, '2017-04-09 10:38:49', NULL, NULL, 8383, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:38:49', 'admin-1491704103-14917055293834254', 1, 0, '', NULL, NULL, NULL),
(26572, '2017-04-09 10:37:02', NULL, NULL, 8382, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:37:02', 'admin-1491704103-14917054221153296', 1, 0, '', NULL, NULL, NULL),
(26573, '2017-04-09 10:37:02', NULL, NULL, 8382, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:37:02', 'admin-1491704103-14917054221153296', 1, 0, '', NULL, NULL, NULL),
(26574, '2017-04-09 10:37:02', NULL, NULL, 8382, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:37:02', 'admin-1491704103-14917054221153296', 1, 0, '', NULL, NULL, NULL),
(26575, '2017-04-09 10:36:00', NULL, NULL, 8382, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:36:00', 'admin-1491704103-1491705360201526', 1, 0, '', NULL, NULL, NULL),
(26576, '2017-04-09 10:36:00', NULL, NULL, 8382, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:36:00', 'admin-1491704103-1491705360201526', 1, 0, '', NULL, NULL, NULL),
(26577, '2017-04-09 10:36:00', NULL, NULL, 8382, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:36:00', 'admin-1491704103-1491705360201526', 1, 0, '', NULL, NULL, NULL),
(26578, '2017-04-09 10:36:00', NULL, NULL, 8382, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:36:00', 'admin-1491704103-1491705360201526', 1, 0, '', NULL, NULL, NULL),
(26579, '2017-04-09 10:32:20', NULL, NULL, 8381, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:32:20', 'admin-1491704103-14917051400653316', 1, 1, 'SR', NULL, NULL, NULL),
(26580, '2017-04-09 10:32:20', NULL, NULL, 8381, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:32:20', 'admin-1491704103-14917051400653316', 1, 1, 'SR', NULL, NULL, NULL),
(26581, '2017-04-09 09:12:36', NULL, NULL, 8373, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 09:12:36', 'admin-1491698647-14917003566786556', 1, 1, 'SR', NULL, NULL, NULL),
(26582, '2017-04-09 09:59:55', NULL, NULL, 8376, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 09:59:55', 'admin-1491698647-14917031950883236', 1, 0, '', NULL, NULL, NULL),
(26583, '2017-04-09 10:00:01', NULL, NULL, 8376, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:00:01', 'admin-1491698647-14917032010401363', 1, 1, 'SR', NULL, NULL, NULL),
(26584, '2017-04-09 09:32:16', NULL, NULL, 8374, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 09:32:16', 'admin-1491698647-14917015358419718', 1, 1, 'SR', NULL, NULL, NULL),
(26585, '2017-04-09 09:32:16', NULL, NULL, 8374, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 09:32:16', 'admin-1491698647-14917015358419718', 1, 1, 'SR', NULL, NULL, NULL),
(26586, '2017-04-09 09:44:27', NULL, NULL, 8375, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1491724084', 'admin', '2017-04-09 09:44:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26587, '2017-04-09 09:44:34', NULL, NULL, 8375, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 09:44:34', 'admin-1491698647-14917022738021320', 1, 0, '', NULL, NULL, NULL),
(26588, '2017-04-09 09:44:34', NULL, NULL, 8375, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 09:44:34', 'admin-1491698647-14917022738021320', 1, 0, '', NULL, NULL, NULL),
(26589, '2017-04-09 09:44:39', NULL, NULL, 8375, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 09:44:39', 'admin-1491698647-14917022797739825', 1, 0, '', NULL, NULL, NULL),
(26590, '2017-04-09 09:44:39', NULL, NULL, 8375, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 09:44:39', 'admin-1491698647-14917022797739825', 1, 1, 'SR', NULL, NULL, NULL),
(26591, '2017-04-09 10:13:31', NULL, NULL, 8377, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 22.40, 0.0000, 0.0000, 22.40, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:13:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26592, '2017-04-09 10:28:17', NULL, NULL, 8380, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:28:17', 'admin-1491704103-1491704897432433', 1, 0, '', NULL, NULL, NULL),
(26593, '2017-04-09 10:28:17', NULL, NULL, 8380, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:28:17', 'admin-1491704103-1491704897432433', 1, 0, '', NULL, NULL, NULL),
(26594, '2017-04-09 10:28:38', NULL, NULL, 8380, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:28:38', 'admin-1491704103-14917049182847614', 1, 1, 'SR', NULL, NULL, NULL),
(26595, '2017-04-09 10:14:33', NULL, NULL, 8377, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:14:33', 'admin-1491698647-14917040733622528', 1, 0, '', NULL, NULL, NULL),
(26596, '2017-04-09 10:14:33', NULL, NULL, 8377, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:14:33', 'admin-1491698647-14917040733622528', 1, 0, '', NULL, NULL, NULL),
(26597, '2017-04-09 10:14:33', NULL, NULL, 8377, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:14:33', 'admin-1491698647-14917040733622528', 1, 0, '', NULL, NULL, NULL),
(26598, '2017-04-09 10:14:33', NULL, NULL, 8377, 0, 153, '87', 'Wake Me Up!', 'no sausage', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:14:33', 'admin-1491698647-14917040733622528', 1, 0, '', NULL, NULL, NULL),
(26599, '2017-04-09 10:14:33', NULL, NULL, 8377, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:14:33', 'admin-1491698647-14917040733622528', 1, 0, '', NULL, NULL, NULL),
(26600, '2017-04-09 10:14:33', NULL, NULL, 8377, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:14:33', 'admin-1491698647-14917040733622528', 1, 0, '', NULL, NULL, NULL),
(26601, '2017-04-09 10:14:33', NULL, NULL, 8377, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:14:33', 'admin-1491698647-14917040733622528', 1, 0, '', NULL, NULL, NULL),
(26602, '2017-04-09 09:31:59', NULL, NULL, 8374, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 09:31:59', 'admin-1491698647-14917015195952658', 1, 0, '', NULL, NULL, NULL),
(26603, '2017-04-09 10:32:46', NULL, NULL, 8382, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.70, 0.0000, 0.0000, 14.70, 1, '27', 1, '1491724084', 'admin', '2017-04-09 10:32:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26604, '2017-04-09 09:31:59', NULL, NULL, 8374, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 09:31:59', 'admin-1491698647-14917015195952658', 1, 0, '', NULL, NULL, NULL),
(26605, '2017-04-09 09:31:59', NULL, NULL, 8374, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 09:31:59', 'admin-1491698647-14917015195952658', 1, 0, '', NULL, NULL, NULL),
(26606, '2017-04-09 13:08:48', NULL, NULL, 8395, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 13:08:48', 'admin-1491710701-14917145285791765', 1, 0, '', NULL, NULL, NULL),
(26607, '2017-04-09 09:31:45', NULL, NULL, 8374, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1491724084', 'admin', '2017-04-09 09:31:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26608, '2017-04-09 09:59:38', NULL, NULL, 8376, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1491724084', 'admin', '2017-04-09 09:59:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26609, '2017-04-09 09:12:36', NULL, NULL, 8373, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 09:12:36', 'admin-1491698647-14917003566786556', 1, 1, 'SR', NULL, NULL, NULL),
(26610, '2017-04-09 09:12:28', NULL, NULL, 8373, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 09:12:28', 'admin-1491698647-14917003479841486', 1, 0, '', NULL, NULL, NULL),
(26611, '2017-04-09 09:12:28', NULL, NULL, 8373, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 09:12:28', 'admin-1491698647-14917003479841486', 1, 0, '', NULL, NULL, NULL),
(26612, '2017-04-09 09:12:16', NULL, NULL, 8373, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1491724084', 'admin', '2017-04-09 09:12:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26613, '2017-04-09 15:56:56', NULL, NULL, 8412, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:56:56', 'admin-1491724084-14917246166257950', 1, 1, 'SR', NULL, NULL, NULL),
(26614, '2017-04-09 15:56:56', NULL, NULL, 8412, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:56:56', 'admin-1491724084-14917246166257950', 1, 1, 'SR', NULL, NULL, NULL),
(26615, '2017-04-09 15:56:56', NULL, NULL, 8412, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 15:56:56', 'admin-1491724084-14917246166257950', 1, 1, 'SR', NULL, NULL, NULL),
(26616, '2017-04-09 16:01:51', NULL, NULL, 8408, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 16:01:51', 'admin-1491724084-14917249117167762', 1, 1, 'SR', NULL, NULL, NULL),
(26617, '2017-04-09 16:59:54', NULL, NULL, 8413, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1491724084', 'admin', '2017-04-09 16:59:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26618, '2017-04-09 17:00:17', NULL, NULL, 8413, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 17:00:17', 'admin-1491724084-14917284176582640', 1, 1, 'SR', NULL, NULL, NULL),
(26619, '2017-04-09 17:00:17', NULL, NULL, 8413, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 17:00:17', 'admin-1491724084-14917284176582640', 1, 1, 'SR', NULL, NULL, NULL),
(26620, '2017-04-09 17:00:17', NULL, NULL, 8413, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491724084', 'admin', '2017-04-09 17:00:17', 'admin-1491724084-14917284176582640', 1, 0, '', NULL, NULL, NULL),
(26621, '2017-04-10 15:31:28', NULL, NULL, 8428, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 15:31:28', 'admin-1491804960-1491809488039599', 1, 1, 'SR', NULL, NULL, NULL),
(26622, '2017-04-10 15:50:20', NULL, NULL, 8429, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1491804960', 'admin', '2017-04-10 15:50:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26623, '2017-04-10 15:50:35', NULL, NULL, 8429, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 15:50:35', 'admin-1491804960-14918106356466852', 1, 0, '', NULL, NULL, NULL),
(26624, '2017-04-10 15:50:35', NULL, NULL, 8429, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 15:50:35', 'admin-1491804960-14918106356466852', 1, 1, 'SR', NULL, NULL, NULL),
(26625, '2017-04-10 15:50:35', NULL, NULL, 8429, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 15:50:35', 'admin-1491804960-14918106356466852', 1, 1, 'SR', NULL, NULL, NULL),
(26626, '2017-04-10 15:57:35', NULL, NULL, 8428, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 15:57:35', 'admin-1491804960-14918110548857856', 1, 1, 'SR', NULL, NULL, NULL),
(26627, '2017-04-10 15:57:35', NULL, NULL, 8428, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 15:57:35', 'admin-1491804960-14918110548857856', 1, 1, 'SR', NULL, NULL, NULL),
(26628, '2017-04-10 15:57:35', NULL, NULL, 8428, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 15:57:35', 'admin-1491804960-14918110548857856', 1, 1, 'SR', NULL, NULL, NULL),
(26629, '2017-04-10 15:57:35', NULL, NULL, 8428, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 15:57:35', 'admin-1491804960-14918110548857856', 1, 0, '', NULL, NULL, NULL),
(26630, '2017-04-10 15:57:35', NULL, NULL, 8428, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 15:57:35', 'admin-1491804960-14918110548857856', 1, 1, 'SR', NULL, NULL, NULL),
(26631, '2017-04-10 16:02:42', NULL, NULL, 8428, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 16:02:42', 'admin-1491804960-14918113621279326', 1, 1, 'SR', NULL, NULL, NULL),
(26632, '2017-04-10 17:00:43', NULL, NULL, 8433, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1491804960', 'admin', '2017-04-10 17:00:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26633, '2017-04-10 17:00:53', NULL, NULL, 8433, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 17:00:53', 'admin-1491804960-14918148537483941', 1, 1, 'SR', NULL, NULL, NULL),
(26634, '2017-04-10 17:00:53', NULL, NULL, 8433, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 17:00:53', 'admin-1491804960-14918148537483941', 1, 1, 'SR', NULL, NULL, NULL),
(26635, '2017-04-10 17:00:53', NULL, NULL, 8433, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 17:00:53', 'admin-1491804960-14918148537483941', 1, 1, 'SR', NULL, NULL, NULL),
(26636, '2017-04-10 17:40:03', NULL, NULL, 8428, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 17:40:03', 'admin-1491804960-14918172036208537', 1, 0, '', NULL, NULL, NULL),
(26637, '2017-04-10 17:08:57', NULL, NULL, 8432, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 17:08:57', 'admin-1491804960-14918153372025554', 1, 0, '', NULL, NULL, NULL),
(26638, '2017-04-10 17:40:03', NULL, NULL, 8428, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 17:40:03', 'admin-1491804960-14918172036208537', 1, 0, '', NULL, NULL, NULL),
(26639, '2017-04-10 17:46:38', NULL, NULL, 8434, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1491804960', 'admin', '2017-04-10 17:46:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26640, '2017-04-10 17:46:46', NULL, NULL, 8434, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 17:46:46', 'admin-1491804960-1491817606015323', 1, 1, 'SR', NULL, NULL, NULL),
(26641, '2017-04-10 17:46:46', NULL, NULL, 8434, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 17:46:46', 'admin-1491804960-1491817606015323', 1, 1, 'SR', NULL, NULL, NULL),
(26642, '2017-04-10 13:40:27', NULL, NULL, 8422, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1491804960', 'admin', '2017-04-10 13:40:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26643, '2017-04-10 13:40:48', NULL, NULL, 8422, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 13:40:48', 'admin-1491799249-14918028487821653', 1, 1, 'SR', NULL, NULL, NULL),
(26644, '2017-04-10 13:40:48', NULL, NULL, 8422, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 13:40:48', 'admin-1491799249-14918028487821653', 1, 1, 'SR', NULL, NULL, NULL),
(26645, '2017-04-10 13:59:20', NULL, NULL, 8423, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.90, 0.0000, 0.0000, 11.90, 1, '27', 1, '1491804960', 'admin', '2017-04-10 13:59:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26646, '2017-04-10 16:29:49', NULL, NULL, 8430, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 16:29:49', 'admin-1491804960-14918129891271813', 1, 1, 'SR', NULL, NULL, NULL),
(26647, '2017-04-10 16:29:49', NULL, NULL, 8430, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 16:29:49', 'admin-1491804960-14918129891271813', 1, 1, 'SR', NULL, NULL, NULL),
(26648, '2017-04-10 17:08:57', NULL, NULL, 8432, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 17:08:57', 'admin-1491804960-14918153372025554', 1, 0, '', NULL, NULL, NULL),
(26649, '2017-04-10 14:09:46', NULL, NULL, 8424, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 14:09:46', 'admin-1491799249-14918045861566696', 1, 1, 'SR', NULL, NULL, NULL),
(26650, '2017-04-10 14:15:44', NULL, NULL, 8425, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1491804960', 'admin', '2017-04-10 14:15:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26651, '2017-04-10 14:15:50', NULL, NULL, 8425, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 14:15:50', 'admin-1491799249-14918049501421727', 1, 0, '', NULL, NULL, NULL),
(26652, '2017-04-10 14:18:26', NULL, NULL, 8422, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 14:18:26', 'admin-1491804960-1491805105971164', 1, 1, 'SR', NULL, NULL, NULL),
(26653, '2017-04-10 14:46:19', NULL, NULL, 8426, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1491804960', 'admin', '2017-04-10 14:46:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26654, '2017-04-10 14:46:24', NULL, NULL, 8426, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 14:46:24', 'admin-1491804960-14918067839502330', 1, 0, '', NULL, NULL, NULL),
(26655, '2017-04-10 14:48:15', NULL, NULL, 8426, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 14:48:15', 'admin-1491804960-14918068957685985', 1, 0, '', NULL, NULL, NULL),
(26656, '2017-04-10 14:48:15', NULL, NULL, 8426, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 14:48:15', 'admin-1491804960-14918068957685985', 1, 1, 'SR', NULL, NULL, NULL),
(26657, '2017-04-10 14:48:15', NULL, NULL, 8426, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 14:48:15', 'admin-1491804960-14918068957685985', 1, 1, 'SR', NULL, NULL, NULL),
(26658, '2017-04-10 15:01:21', NULL, NULL, 8427, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 15:01:21', 'admin-1491804960-14918076808984155', 1, 0, '', 1, NULL, NULL),
(26659, '2017-04-10 15:31:25', NULL, NULL, 8428, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.80, 0.0000, 0.0000, 12.80, 1, '27', 1, '1491804960', 'admin', '2017-04-10 15:31:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26660, '2017-04-10 12:53:32', NULL, NULL, 8420, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1491804960', 'admin', '2017-04-10 12:53:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26661, '2017-04-10 12:53:41', NULL, NULL, 8420, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 12:53:41', 'admin-1491799249-14918000212425057', 1, 1, 'SR', NULL, NULL, NULL),
(26662, '2017-04-10 12:53:41', NULL, NULL, 8420, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 12:53:41', 'admin-1491799249-14918000212425057', 1, 1, 'SR', NULL, NULL, NULL),
(26663, '2017-04-10 12:53:41', NULL, NULL, 8420, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 12:53:41', 'admin-1491799249-14918000212425057', 1, 0, '', NULL, NULL, NULL),
(26664, '2017-04-10 12:53:47', NULL, NULL, 8420, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 12:53:47', 'admin-1491799249-14918000273867298', 1, 1, 'SR', NULL, NULL, NULL),
(26665, '2017-04-10 12:53:47', NULL, NULL, 8420, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 12:53:47', 'admin-1491799249-14918000273867298', 1, 1, 'SR', NULL, NULL, NULL),
(26666, '2017-04-10 13:37:05', NULL, NULL, 8421, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1491804960', 'admin', '2017-04-10 13:37:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26667, '2017-04-10 13:37:38', NULL, NULL, 8421, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 13:37:38', 'admin-1491799249-1491802658131320', 1, 0, '', NULL, NULL, NULL),
(26668, '2017-04-10 13:37:38', NULL, NULL, 8421, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 13:37:38', 'admin-1491799249-1491802658131320', 1, 1, 'SR', NULL, NULL, NULL),
(26669, '2017-04-10 13:37:38', NULL, NULL, 8421, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 13:37:38', 'admin-1491799249-1491802658131320', 1, 0, '', NULL, NULL, NULL),
(26670, '2017-04-10 16:40:31', NULL, NULL, 8431, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1491804960', 'admin', '2017-04-10 16:40:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26671, '2017-04-10 16:40:40', NULL, NULL, 8431, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 16:40:40', 'admin-1491804960-14918136399264649', 1, 0, '', NULL, NULL, NULL),
(26672, '2017-04-10 16:40:46', NULL, NULL, 8430, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 16:40:46', 'admin-1491804960-14918136461181495', 1, 0, '', NULL, NULL, NULL),
(26673, '2017-04-10 16:02:42', NULL, NULL, 8428, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 16:02:42', 'admin-1491804960-14918113621279326', 1, 1, 'SR', NULL, NULL, NULL),
(26674, '2017-04-10 16:18:01', NULL, NULL, 8429, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 16:18:01', 'admin-1491804960-1491812281485624', 1, 1, 'SR', NULL, NULL, NULL),
(26675, '2017-04-10 17:40:03', NULL, NULL, 8428, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 17:40:03', 'admin-1491804960-14918172036208537', 1, 0, '', NULL, NULL, NULL),
(26676, '2017-04-10 17:40:03', NULL, NULL, 8428, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 17:40:03', 'admin-1491804960-14918172036208537', 1, 0, '', NULL, NULL, NULL),
(26677, '2017-04-10 17:00:40', NULL, NULL, 8431, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 17:00:40', 'admin-1491804960-14918148399912674', 1, 1, 'SR', NULL, NULL, NULL),
(26678, '2017-04-10 16:54:59', NULL, NULL, 8432, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 16:54:59', 'admin-1491804960-1491814499578126', 1, 0, '', NULL, NULL, NULL),
(26679, '2017-04-10 16:54:59', NULL, NULL, 8432, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 16:54:59', 'admin-1491804960-1491814499578126', 1, 1, 'SR', NULL, NULL, NULL),
(26680, '2017-04-10 16:49:58', NULL, NULL, 8432, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1491804960', 'admin', '2017-04-10 16:49:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26681, '2017-04-10 16:50:02', NULL, NULL, 8432, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 16:50:02', 'admin-1491804960-14918142020818778', 1, 1, 'SR', NULL, NULL, NULL),
(26682, '2017-04-10 16:29:49', NULL, NULL, 8430, 0, 265, '199', 'Old Penang PostCard', '', 'DISCOUNT ', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 16:29:49', 'admin-1491804960-14918129891271813', 1, 0, '', NULL, NULL, NULL),
(26683, '2017-04-10 13:59:37', NULL, NULL, 8423, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 13:59:37', 'admin-1491799249-14918039773039619', 1, 1, 'SR', NULL, NULL, NULL),
(26684, '2017-04-10 11:54:02', NULL, NULL, 8417, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 11:54:02', 'admin-1491787222-14917964421466532', 1, 1, 'SR', NULL, NULL, NULL),
(26685, '2017-04-10 11:54:02', NULL, NULL, 8417, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 11:54:02', 'admin-1491787222-14917964421466532', 1, 1, 'SR', NULL, NULL, NULL),
(26686, '2017-04-10 11:54:37', NULL, NULL, 8418, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 11:54:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26687, '2017-04-10 11:56:59', NULL, NULL, 8418, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 11:56:59', 'admin-1491787222-14917966190447380', 1, 0, '', NULL, NULL, NULL),
(26688, '2017-04-10 11:57:19', NULL, NULL, 8418, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 11:57:19', 'admin-1491787222-14917966389524245', 1, 1, 'SR', NULL, NULL, NULL),
(26689, '2017-04-10 11:57:19', NULL, NULL, 8418, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 11:57:19', 'admin-1491787222-14917966389524245', 1, 0, '', NULL, NULL, NULL),
(26690, '2017-04-10 11:57:19', NULL, NULL, 8418, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 11:57:19', 'admin-1491787222-14917966389524245', 1, 0, '', NULL, NULL, NULL),
(26691, '2017-04-10 12:11:07', NULL, NULL, 8419, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1491804960', 'admin', '2017-04-10 12:11:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26692, '2017-04-10 12:11:19', NULL, NULL, 8419, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 12:11:19', 'admin-1491787222-14917974797212224', 1, 0, '', NULL, NULL, NULL),
(26693, '2017-04-10 12:11:19', NULL, NULL, 8419, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 12:11:19', 'admin-1491787222-14917974797212224', 1, 1, 'SR', NULL, NULL, NULL),
(26694, '2017-04-10 12:11:19', NULL, NULL, 8419, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 12:11:19', 'admin-1491787222-14917974797212224', 1, 1, 'SR', NULL, NULL, NULL),
(26695, '2017-04-10 12:14:16', NULL, NULL, 8419, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 12:14:16', 'admin-1491787222-14917976560194935', 1, 1, 'SR', NULL, NULL, NULL),
(26696, '2017-04-10 12:14:22', NULL, NULL, 8419, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 12:14:22', 'admin-1491787222-14917976617434817', 1, 1, 'SR', NULL, NULL, NULL),
(26697, '2017-04-10 16:29:38', NULL, NULL, 8430, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1491804960', 'admin', '2017-04-10 16:29:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26698, '2017-04-10 16:18:01', NULL, NULL, 8429, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 16:18:01', 'admin-1491804960-1491812281485624', 1, 1, 'SR', NULL, NULL, NULL),
(26699, '2017-04-10 13:59:37', NULL, NULL, 8423, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 13:59:37', 'admin-1491799249-14918039773039619', 1, 1, 'SR', NULL, NULL, NULL),
(26700, '2017-04-10 13:59:37', NULL, NULL, 8423, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 13:59:37', 'admin-1491799249-14918039773039619', 1, 1, 'SR', NULL, NULL, NULL),
(26701, '2017-04-10 13:59:46', NULL, NULL, 8423, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 13:59:46', 'admin-1491799249-14918039861667714', 1, 0, '', NULL, NULL, NULL),
(26702, '2017-04-10 13:59:46', NULL, NULL, 8423, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 13:59:46', 'admin-1491799249-14918039861667714', 1, 1, 'SR', NULL, NULL, NULL),
(26703, '2017-04-10 13:59:46', NULL, NULL, 8423, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 13:59:46', 'admin-1491799249-14918039861667714', 1, 1, 'SR', NULL, NULL, NULL),
(26704, '2017-04-10 14:01:19', NULL, NULL, 8423, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 14:01:19', 'admin-1491799249-1491804079143127', 1, 1, 'SR', NULL, NULL, NULL),
(26705, '2017-04-10 14:06:59', NULL, NULL, 8423, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 14:06:59', 'admin-1491799249-14918044193649917', 1, 0, '', NULL, NULL, NULL),
(26706, '2017-04-10 14:09:41', NULL, NULL, 8424, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1491804960', 'admin', '2017-04-10 14:09:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26707, '2017-04-10 13:40:39', NULL, NULL, 8422, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 13:40:39', 'admin-1491799249-14918028391154485', 1, 1, 'SR', NULL, NULL, NULL),
(26708, '2017-04-10 13:40:39', NULL, NULL, 8422, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 13:40:39', 'admin-1491799249-14918028391154485', 1, 0, '', NULL, NULL, NULL),
(26709, '2017-04-10 13:40:39', NULL, NULL, 8422, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 13:40:39', 'admin-1491799249-14918028391154485', 1, 0, '', NULL, NULL, NULL),
(26710, '2017-04-10 11:54:02', NULL, NULL, 8417, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 11:54:02', 'admin-1491787222-14917964421466532', 1, 1, 'SR', NULL, NULL, NULL),
(26711, '2017-04-10 11:54:02', NULL, NULL, 8417, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 11:54:02', 'admin-1491787222-14917964421466532', 1, 1, 'SR', NULL, NULL, NULL),
(26712, '2017-04-10 11:53:49', NULL, NULL, 8417, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 11:53:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26713, '2017-04-10 11:40:46', NULL, NULL, 8416, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 11:40:46', 'admin-1491787222-1491795646017262', 1, 0, '', NULL, NULL, NULL),
(26714, '2017-04-10 11:19:20', NULL, NULL, 8416, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 11:19:20', 'admin-1491787222-14917943601722526', 1, 1, 'SR', NULL, NULL, NULL),
(26715, '2017-04-10 10:51:16', NULL, NULL, 8415, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 10:51:16', 'admin-1491787222-14917926761784177', 1, 1, 'SR', NULL, NULL, NULL),
(26716, '2017-04-10 10:51:16', NULL, NULL, 8415, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 10:51:16', 'admin-1491787222-14917926761784177', 1, 0, '', NULL, NULL, NULL),
(26717, '2017-04-10 11:19:16', NULL, NULL, 8416, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1491804960', 'admin', '2017-04-10 11:19:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26718, '2017-04-10 10:26:23', NULL, NULL, 8414, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 10:26:23', 'admin-1491787222-14917911829862780', 1, 0, '', NULL, NULL, NULL),
(26719, '2017-04-10 10:51:05', NULL, NULL, 8415, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1491804960', 'admin', '2017-04-10 10:51:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26720, '2017-04-10 10:26:23', NULL, NULL, 8414, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 10:26:23', 'admin-1491787222-14917911829862780', 1, 1, 'SR', NULL, NULL, NULL),
(26721, '2017-04-10 10:26:23', NULL, NULL, 8414, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 10:26:23', 'admin-1491787222-14917911829862780', 1, 1, 'SR', NULL, NULL, NULL),
(26722, '2017-04-10 10:26:05', NULL, NULL, 8414, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 10:26:05', 'admin-1491787222-14917911655339630', 1, 0, '', NULL, NULL, NULL),
(26723, '2017-04-10 10:26:01', NULL, NULL, 8414, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1491804960', 'admin', '2017-04-10 10:26:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26724, '2017-04-12 18:30:55', NULL, NULL, 8455, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1491958305', 'admin', '2017-04-12 18:30:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26725, '2017-04-12 14:52:21', NULL, NULL, 8445, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1491958305', 'admin', '2017-04-12 14:52:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26726, '2017-04-12 14:52:25', NULL, NULL, 8445, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 14:52:25', 'admin-1491958305-14919799448779070', 1, 0, '', NULL, NULL, NULL),
(26727, '2017-04-12 14:57:31', NULL, NULL, 8446, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1491958305', 'admin', '2017-04-12 14:57:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26728, '2017-04-12 14:57:38', NULL, NULL, 8446, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 14:57:38', 'admin-1491958305-14919802581111427', 1, 1, 'SR', NULL, NULL, NULL),
(26729, '2017-04-12 14:57:38', NULL, NULL, 8446, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 14:57:38', 'admin-1491958305-14919802581111427', 1, 1, 'SR', NULL, NULL, NULL),
(26730, '2017-04-12 14:58:17', NULL, NULL, 8445, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 14:58:17', 'admin-1491958305-14919802968869643', 1, 0, '', NULL, NULL, NULL),
(26731, '2017-04-12 17:09:02', NULL, NULL, 8450, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 17:09:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26732, '2017-04-12 17:09:05', NULL, NULL, 8450, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 17:09:05', 'admin-1491958305-14919881447541522', 1, 0, '', NULL, NULL, NULL),
(26733, '2017-04-12 17:09:08', NULL, NULL, 8449, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 17:09:08', 'admin-1491958305-14919881482863130', 1, 0, '', NULL, NULL, NULL),
(26734, '2017-04-12 17:42:00', NULL, NULL, 8451, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1491958305', 'admin', '2017-04-12 17:42:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26735, '2017-04-12 17:42:22', NULL, NULL, 8451, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 17:42:22', 'admin-1491958305-14919901424842572', 1, 1, 'SR', NULL, NULL, NULL),
(26736, '2017-04-12 15:26:53', NULL, NULL, 8448, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1491958305', 'admin', '2017-04-12 15:26:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26737, '2017-04-12 15:26:56', NULL, NULL, 8448, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 15:26:56', 'admin-1491958305-14919820166737788', 1, 1, 'SR', NULL, NULL, NULL),
(26738, '2017-04-12 16:18:23', NULL, NULL, 8445, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 16:18:23', 'admin-1491958305-14919851032742786', 1, 0, '', NULL, NULL, NULL),
(26739, '2017-04-12 16:46:02', NULL, NULL, 8449, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1491958305', 'admin', '2017-04-12 16:46:02', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(26740, '2017-04-12 16:46:20', NULL, NULL, 8449, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 16:46:20', 'admin-1491958305-1491986780176648', 1, 0, '', NULL, NULL, NULL),
(26741, '2017-04-12 16:46:20', NULL, NULL, 8449, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 16:46:20', 'admin-1491958305-1491986780176648', 1, 1, 'SR', NULL, NULL, NULL),
(26742, '2017-04-12 11:25:46', NULL, NULL, 8438, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 11:25:46', 'admin-1491958305-1491967546433126', 1, 1, 'SR', 1, NULL, '10.0'),
(26743, '2017-04-12 12:41:58', NULL, NULL, 8439, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1491958305', 'admin', '2017-04-12 12:41:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26744, '2017-04-12 12:42:24', NULL, NULL, 8439, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 12:42:24', 'admin-1491958305-14919721440111187', 1, 0, '', NULL, NULL, NULL),
(26745, '2017-04-12 12:42:24', NULL, NULL, 8439, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 12:42:24', 'admin-1491958305-14919721440111187', 1, 0, '', NULL, NULL, NULL),
(26746, '2017-04-12 12:42:24', NULL, NULL, 8439, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 12:42:24', 'admin-1491958305-14919721440111187', 1, 0, '', NULL, NULL, NULL),
(26747, '2017-04-12 12:42:24', NULL, NULL, 8439, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 12:42:24', 'admin-1491958305-14919721440111187', 1, 1, 'SR', NULL, NULL, NULL),
(26748, '2017-04-12 13:30:02', NULL, NULL, 8440, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1491958305', 'admin', '2017-04-12 13:30:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26749, '2017-04-12 13:30:14', NULL, NULL, 8440, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 13:30:14', 'admin-1491958305-14919750142829176', 1, 1, 'SR', NULL, NULL, NULL),
(26750, '2017-04-12 13:30:14', NULL, NULL, 8440, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 13:30:14', 'admin-1491958305-14919750142829176', 1, 1, 'SR', NULL, NULL, NULL),
(26751, '2017-04-12 19:18:56', NULL, NULL, 8457, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 19:18:56', 'admin-1491958305-14919959363821079', 1, 1, 'SR', NULL, NULL, NULL),
(26752, '2017-04-12 19:18:56', NULL, NULL, 8457, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 19:18:56', 'admin-1491958305-14919959363821079', 1, 1, 'SR', NULL, NULL, NULL),
(26753, '2017-04-12 19:18:56', NULL, NULL, 8457, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 19:18:56', 'admin-1491958305-14919959363821079', 1, 1, 'SR', NULL, NULL, NULL),
(26754, '2017-04-12 19:18:56', NULL, NULL, 8457, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 19:18:56', 'admin-1491958305-14919959363821079', 1, 1, 'SR', NULL, NULL, NULL),
(26755, '2017-04-12 13:56:04', NULL, NULL, 8441, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1491958305', 'admin', '2017-04-12 13:56:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26756, '2017-04-12 13:56:07', NULL, NULL, 8441, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 13:56:07', 'admin-1491958305-1491976567350524', 1, 1, 'SR', NULL, NULL, NULL),
(26757, '2017-04-12 13:56:07', NULL, NULL, 8441, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 13:56:07', 'admin-1491958305-1491976567350524', 1, 1, 'SR', NULL, NULL, NULL),
(26758, '2017-04-12 14:03:00', NULL, NULL, 8442, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1491958305', 'admin', '2017-04-12 14:03:00', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(26759, '2017-04-12 14:03:05', NULL, NULL, 8442, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 14:03:05', 'admin-1491958305-14919769855776916', 1, 1, 'SR', NULL, NULL, '10.0'),
(26760, '2017-04-12 14:04:27', NULL, NULL, 8443, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1491958305', 'admin', '2017-04-12 14:04:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26761, '2017-04-12 14:04:33', NULL, NULL, 8443, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 14:04:33', 'admin-1491958305-14919770734492966', 1, 1, 'SR', NULL, NULL, NULL),
(26762, '2017-04-12 14:04:33', NULL, NULL, 8443, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 14:04:33', 'admin-1491958305-14919770734492966', 1, 0, '', NULL, NULL, NULL),
(26763, '2017-04-12 13:31:00', NULL, NULL, 8440, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 13:31:00', 'admin-1491958305-14919750600629074', 1, 0, '', NULL, NULL, NULL),
(26764, '2017-04-12 18:52:46', NULL, NULL, 8456, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 18:52:46', 'admin-1491958305-14919943658684695', 1, 1, 'SR', NULL, NULL, NULL),
(26765, '2017-04-12 18:52:46', NULL, NULL, 8456, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 18:52:46', 'admin-1491958305-14919943658684695', 1, 0, '', NULL, NULL, NULL),
(26766, '2017-04-12 18:52:01', NULL, NULL, 8454, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 18:52:01', 'admin-1491958305-14919943212728552', 1, 1, 'SR', NULL, NULL, NULL),
(26767, '2017-04-12 18:43:01', NULL, NULL, 8456, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1491958305', 'admin', '2017-04-12 18:43:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26768, '2017-04-12 18:31:03', NULL, NULL, 8455, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 18:31:03', 'admin-1491958305-1491993063715248', 1, 1, 'SR', NULL, NULL, NULL),
(26769, '2017-04-12 18:23:22', NULL, NULL, 8454, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 18:23:22', 'admin-1491958305-14919926022137967', 1, 1, 'SR', NULL, NULL, NULL),
(26770, '2017-04-12 18:23:17', NULL, NULL, 8454, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1491958305', 'admin', '2017-04-12 18:23:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26771, '2017-04-12 18:22:33', NULL, NULL, 8453, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 18:22:33', 'admin-1491958305-14919925527927196', 1, 0, '', 1, NULL, NULL),
(26772, '2017-04-12 18:22:33', NULL, NULL, 8453, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 18:22:33', 'admin-1491958305-14919925527927196', 1, 0, '', 1, NULL, NULL),
(26773, '2017-04-12 18:10:11', NULL, NULL, 8452, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 18:10:11', 'admin-1491958305-14919918117869926', 1, 1, 'SR', NULL, NULL, NULL),
(26774, '2017-04-12 18:10:11', NULL, NULL, 8452, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 18:10:11', 'admin-1491958305-14919918117869926', 1, 1, 'SR', NULL, NULL, NULL),
(26775, '2017-04-12 17:50:22', NULL, NULL, 8451, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 17:50:22', 'admin-1491958305-149199062201911', 1, 1, 'SR', NULL, NULL, NULL),
(26776, '2017-04-12 18:10:05', NULL, NULL, 8452, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 18:10:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26777, '2017-04-12 14:35:14', NULL, NULL, 8444, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 14:35:14', 'admin-1491958305-1491978913822386', 1, 1, 'SR', NULL, NULL, NULL),
(26778, '2017-04-12 19:18:49', NULL, NULL, 8457, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 19:18:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26779, '2017-04-12 15:18:42', NULL, NULL, 8447, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 15:18:42', 'admin-1491958305-1491981522226807', 1, 1, 'SR', 1, NULL, NULL),
(26780, '2017-04-12 15:18:42', NULL, NULL, 8447, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 15:18:42', 'admin-1491958305-1491981522226807', 1, 1, 'SR', 1, NULL, NULL),
(26781, '2017-04-12 14:35:08', NULL, NULL, 8444, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1491958305', 'admin', '2017-04-12 14:35:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26782, '2017-04-12 14:35:14', NULL, NULL, 8444, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 14:35:14', 'admin-1491958305-1491978913822386', 1, 1, 'SR', NULL, NULL, NULL),
(26783, '2017-04-12 13:31:00', NULL, NULL, 8440, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 13:31:00', 'admin-1491958305-14919750600629074', 1, 0, '', NULL, NULL, NULL),
(26784, '2017-04-12 09:23:27', NULL, NULL, 8436, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 09:23:27', 'admin-1491958305-14919602070608170', 1, 0, '', NULL, NULL, NULL),
(26785, '2017-04-12 09:23:32', NULL, NULL, 8436, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 09:23:32', 'admin-1491958305-14919602121188928', 1, 1, 'SR', NULL, NULL, NULL),
(26786, '2017-04-12 11:24:54', NULL, NULL, 8437, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1491958305', 'admin', '2017-04-12 11:24:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26787, '2017-04-12 11:25:40', NULL, NULL, 8437, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 11:25:40', 'admin-1491958305-14919675401317198', 1, 0, '', NULL, NULL, NULL),
(26788, '2017-04-12 11:25:40', NULL, NULL, 8437, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 11:25:40', 'admin-1491958305-14919675401317198', 1, 0, '', NULL, NULL, NULL),
(26789, '2017-04-12 11:25:40', NULL, NULL, 8437, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 11:25:40', 'admin-1491958305-14919675401317198', 1, 1, 'SR', NULL, NULL, NULL),
(26790, '2017-04-12 09:50:25', NULL, NULL, 8436, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 09:50:25', 'admin-1491958305-14919618249971420', 1, 1, 'SR', NULL, NULL, NULL),
(26791, '2017-04-12 09:23:23', NULL, NULL, 8436, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1491958305', 'admin', '2017-04-12 09:23:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26792, '2017-04-12 09:15:37', NULL, NULL, 8435, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 09:15:37', 'admin-1491958305-14919597375548367', 1, 0, '', NULL, NULL, NULL),
(26793, '2017-04-12 09:15:37', NULL, NULL, 8435, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 09:15:37', 'admin-1491958305-14919597375548367', 1, 0, '', NULL, NULL, NULL),
(26794, '2017-04-12 09:15:43', NULL, NULL, 8435, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1491958305', 'admin', '2017-04-12 09:15:43', 'admin-1491958305-1491959742992110', 1, 0, '', NULL, NULL, NULL),
(26795, '2017-04-12 09:15:32', NULL, NULL, 8435, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1491958305', 'admin', '2017-04-12 09:15:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26796, '2017-04-13 17:33:02', NULL, NULL, 8471, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 17:33:02', 'admin-1492052191-14920759818878952', 1, 1, 'SR', 1, NULL, NULL),
(26797, '2017-04-13 15:48:34', NULL, NULL, 8470, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 15:48:34', 'admin-1492052191-14920697138103548', 1, 0, '', NULL, NULL, NULL),
(26798, '2017-04-13 16:11:10', NULL, NULL, 8470, 0, 181, '116', 'Open Food ', 'banana', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1492052191', 'admin', '2017-04-13 16:11:10', 'admin-1492052191-14920710706247587', 1, 0, '', NULL, NULL, NULL),
(26799, '2017-04-13 13:59:43', NULL, NULL, 8468, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 13:59:43', 'admin-1492052191-14920631822485836', 1, 0, '', NULL, NULL, NULL),
(26800, '2017-04-13 10:51:59', NULL, NULL, 8462, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 10:51:59', 'admin-1492045605-14920519197252931', 1, 0, '', NULL, NULL, NULL),
(26801, '2017-04-13 10:49:16', NULL, NULL, 8462, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 10:49:16', 'admin-1492045605-1492051755997764', 1, 1, 'SR', NULL, NULL, NULL),
(26802, '2017-04-13 10:56:17', NULL, NULL, 8463, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 10:56:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26803, '2017-04-13 10:49:22', NULL, NULL, 8462, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 10:49:22', 'admin-1492045605-14920517625707219', 1, 1, 'SR', NULL, NULL, NULL),
(26804, '2017-04-13 17:33:02', NULL, NULL, 8471, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 17:33:02', 'admin-1492052191-14920759818878952', 1, 1, 'SR', 1, NULL, NULL),
(26805, '2017-04-13 11:26:29', NULL, NULL, 8464, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1492052191', 'admin', '2017-04-13 11:26:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26806, '2017-04-13 10:56:26', NULL, NULL, 8463, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 10:56:26', 'admin-1492045605-14920521858353560', 1, 0, '', NULL, NULL, NULL),
(26807, '2017-04-13 10:56:26', NULL, NULL, 8463, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 10:56:26', 'admin-1492045605-14920521858353560', 1, 0, '', NULL, NULL, NULL),
(26808, '2017-04-13 10:56:48', NULL, NULL, 8463, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 10:56:48', 'admin-1492052191-14920522085061861', 1, 1, 'SR', NULL, NULL, NULL),
(26809, '2017-04-13 10:56:48', NULL, NULL, 8463, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 10:56:48', 'admin-1492052191-14920522085061861', 1, 1, 'SR', NULL, NULL, NULL),
(26810, '2017-04-13 09:40:15', NULL, NULL, 8460, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 09:40:15', 'admin-1492045605-14920476156274338', 1, 1, 'SR', NULL, NULL, NULL),
(26811, '2017-04-13 09:40:15', NULL, NULL, 8460, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 09:40:15', 'admin-1492045605-14920476156274338', 1, 1, 'SR', NULL, NULL, NULL),
(26812, '2017-04-13 09:40:15', NULL, NULL, 8460, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 09:40:15', 'admin-1492045605-14920476156274338', 1, 1, 'SR', NULL, NULL, NULL),
(26813, '2017-04-13 09:40:15', NULL, NULL, 8460, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 09:40:15', 'admin-1492045605-14920476156274338', 1, 1, 'SR', NULL, NULL, NULL),
(26814, '2017-04-13 09:40:15', NULL, NULL, 8460, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 09:40:15', 'admin-1492045605-14920476156274338', 1, 1, 'SR', NULL, NULL, NULL),
(26815, '2017-04-13 09:40:15', NULL, NULL, 8460, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 09:40:15', 'admin-1492045605-14920476156274338', 1, 1, 'SR', NULL, NULL, NULL),
(26816, '2017-04-13 09:46:47', NULL, NULL, 8461, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1492052191', 'admin', '2017-04-13 09:46:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26817, '2017-04-13 09:46:54', NULL, NULL, 8461, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 09:46:54', 'admin-1492045605-14920480140932485', 1, 0, '', NULL, NULL, NULL),
(26818, '2017-04-13 10:29:11', NULL, NULL, 8460, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 10:29:11', 'admin-1492045605-14920505509447519', 1, 1, 'SR', NULL, NULL, NULL),
(26819, '2017-04-13 15:48:34', NULL, NULL, 8470, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 15:48:34', 'admin-1492052191-14920697138103548', 1, 1, 'SR', NULL, NULL, NULL),
(26820, '2017-04-13 15:48:34', NULL, NULL, 8470, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 15:48:34', 'admin-1492052191-14920697138103548', 1, 1, 'SR', NULL, NULL, NULL),
(26821, '2017-04-13 11:49:33', NULL, NULL, 8465, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1492052191', 'admin', '2017-04-13 11:49:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26822, '2017-04-13 11:49:42', NULL, NULL, 8465, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 11:49:42', 'admin-1492052191-14920553819443143', 1, 0, '', NULL, NULL, NULL),
(26823, '2017-04-13 11:49:42', NULL, NULL, 8465, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 11:49:42', 'admin-1492052191-14920553819443143', 1, 0, '', NULL, NULL, NULL),
(26824, '2017-04-13 11:50:08', NULL, NULL, 8465, 0, 182, '117', 'Open Drinks ', 'set', 'Cold Drinks', 'Fresh Juice', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 11:50:08', 'admin-1492052191-14920554081662361', 1, 0, '', NULL, NULL, NULL),
(26825, '2017-04-13 12:27:51', NULL, NULL, 8466, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1492052191', 'admin', '2017-04-13 12:27:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26826, '2017-04-13 12:28:00', NULL, NULL, 8466, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 12:28:00', 'admin-1492052191-1492057680776978', 1, 1, 'SR', NULL, NULL, NULL),
(26827, '2017-04-13 12:28:22', NULL, NULL, 8466, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 12:28:22', 'admin-1492052191-14920577026071968', 1, 1, 'SR', NULL, NULL, NULL),
(26828, '2017-04-13 12:29:09', NULL, NULL, 8466, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 12:29:09', 'admin-1492052191-14920577495328345', 1, 1, 'SR', NULL, NULL, NULL),
(26829, '2017-04-13 12:29:09', NULL, NULL, 8466, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 12:29:09', 'admin-1492052191-14920577495328345', 1, 1, 'SR', NULL, NULL, NULL),
(26830, '2017-04-13 12:38:16', NULL, NULL, 8465, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 12:38:16', 'admin-1492052191-14920582960983161', 1, 1, 'SR', NULL, NULL, NULL),
(26831, '2017-04-13 13:08:53', NULL, NULL, 8467, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 13:08:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26832, '2017-04-13 13:09:39', NULL, NULL, 8467, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 13:09:39', 'admin-1492052191-1492060178891896', 1, 0, '', NULL, NULL, NULL),
(26833, '2017-04-13 13:09:39', NULL, NULL, 8467, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 13:09:39', 'admin-1492052191-1492060178891896', 1, 1, 'SR', NULL, NULL, NULL),
(26834, '2017-04-13 13:09:39', NULL, NULL, 8467, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 13:09:39', 'admin-1492052191-1492060178891896', 1, 1, 'SR', NULL, NULL, NULL),
(26835, '2017-04-13 13:09:39', NULL, NULL, 8467, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 13:09:39', 'admin-1492052191-1492060178891896', 1, 1, 'SR', NULL, NULL, NULL),
(26836, '2017-04-13 13:59:36', NULL, NULL, 8468, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1492052191', 'admin', '2017-04-13 13:59:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26837, '2017-04-13 14:58:48', NULL, NULL, 8469, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 14:58:48', 'admin-1492052191-14920667286988041', 1, 1, 'SR', NULL, NULL, NULL),
(26838, '2017-04-13 15:48:26', NULL, NULL, 8470, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.35, 0.0000, 0.0000, 3.35, 1, '27', 1, '1492052191', 'admin', '2017-04-13 15:48:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26839, '2017-04-13 14:45:46', NULL, NULL, 8469, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 14:45:46', 'admin-1492052191-14920659458189225', 1, 1, 'SR', NULL, NULL, NULL),
(26840, '2017-04-13 14:45:46', NULL, NULL, 8469, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 14:45:46', 'admin-1492052191-14920659458189225', 1, 0, '', NULL, NULL, NULL),
(26841, '2017-04-13 14:45:00', NULL, NULL, 8469, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 14:45:00', 'admin-1492052191-14920658997556040', 1, 0, '', NULL, NULL, NULL),
(26842, '2017-04-13 14:45:00', NULL, NULL, 8469, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 14:45:00', 'admin-1492052191-14920658997556040', 1, 0, '', NULL, NULL, NULL),
(26843, '2017-04-13 14:42:08', NULL, NULL, 8469, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1492052191', 'admin', '2017-04-13 14:42:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26844, '2017-04-13 14:16:16', NULL, NULL, 8468, 0, 181, '116', 'Open Food ', '1 pc toast', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 14:16:16', 'admin-1492052191-1492064176015237', 1, 0, '', NULL, NULL, NULL),
(26845, '2017-04-13 10:51:59', NULL, NULL, 8462, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 10:51:59', 'admin-1492045605-14920519197252931', 1, 0, '', NULL, NULL, NULL),
(26846, '2017-04-13 11:26:34', NULL, NULL, 8464, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 11:26:34', 'admin-1492052191-1492053994637162', 1, 1, 'SR', NULL, NULL, NULL),
(26847, '2017-04-13 10:56:48', NULL, NULL, 8463, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 10:56:48', 'admin-1492052191-14920522085061861', 1, 1, 'SR', NULL, NULL, NULL),
(26848, '2017-04-13 13:59:43', NULL, NULL, 8468, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 13:59:43', 'admin-1492052191-14920631822485836', 1, 1, 'SR', NULL, NULL, NULL),
(26849, '2017-04-13 10:56:26', NULL, NULL, 8463, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 10:56:26', 'admin-1492045605-14920521858353560', 1, 0, '', NULL, NULL, NULL),
(26850, '2017-04-13 10:48:41', NULL, NULL, 8462, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1492052191', 'admin', '2017-04-13 10:48:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26851, '2017-04-13 10:49:16', NULL, NULL, 8462, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 10:49:16', 'admin-1492045605-1492051755997764', 1, 0, '', NULL, NULL, NULL),
(26852, '2017-04-13 09:40:15', NULL, NULL, 8460, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 09:40:15', 'admin-1492045605-14920476156274338', 1, 0, '', NULL, NULL, NULL),
(26853, '2017-04-13 09:40:15', NULL, NULL, 8460, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 09:40:15', 'admin-1492045605-14920476156274338', 1, 0, '', NULL, NULL, NULL),
(26854, '2017-04-13 09:40:15', NULL, NULL, 8460, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 09:40:15', 'admin-1492045605-14920476156274338', 1, 0, '', NULL, NULL, NULL),
(26855, '2017-04-13 09:40:15', NULL, NULL, 8460, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 09:40:15', 'admin-1492045605-14920476156274338', 1, 0, '', NULL, NULL, NULL),
(26856, '2017-04-13 09:40:15', NULL, NULL, 8460, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 09:40:15', 'admin-1492045605-14920476156274338', 1, 0, '', NULL, NULL, NULL),
(26857, '2017-04-13 09:40:15', NULL, NULL, 8460, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 09:40:15', 'admin-1492045605-14920476156274338', 1, 0, '', NULL, NULL, NULL),
(26858, '2017-04-13 09:36:11', NULL, NULL, 8460, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 17.30, 0.0000, 0.0000, 17.30, 1, '27', 1, '1492052191', 'admin', '2017-04-13 09:36:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26859, '2017-04-13 09:07:03', NULL, NULL, 8458, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 09:07:03', 'admin-1492045605-14920456231048158', 1, 0, '', NULL, NULL, NULL),
(26860, '2017-04-13 09:15:20', NULL, NULL, 8459, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1492052191', 'admin', '2017-04-13 09:15:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26861, '2017-04-13 09:15:24', NULL, NULL, 8459, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 09:15:24', 'admin-1492045605-14920461240723317', 1, 1, 'SR', NULL, NULL, NULL),
(26862, '2017-04-13 09:07:03', NULL, NULL, 8458, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492052191', 'admin', '2017-04-13 09:07:03', 'admin-1492045605-14920456231048158', 1, 1, 'SR', NULL, NULL, NULL),
(26863, '2017-04-13 09:06:55', NULL, NULL, 8458, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1492052191', 'admin', '2017-04-13 09:06:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26864, '2017-04-14 14:50:05', NULL, NULL, 8492, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1492143587', 'admin', '2017-04-14 14:50:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26865, '2017-04-14 14:50:34', NULL, NULL, 8492, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 14:50:34', 'admin-1492143587-14921526345748575', 1, 0, '', NULL, NULL, NULL),
(26866, '2017-04-14 14:50:34', NULL, NULL, 8492, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 14:50:34', 'admin-1492143587-14921526345748575', 1, 1, 'SR', NULL, NULL, NULL),
(26867, '2017-04-14 14:50:55', NULL, NULL, 8490, 0, 181, '116', 'Open Food ', 'Pepper pork No rice', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 14:50:55', 'admin-1492143587-14921526556925945', 1, 0, '', NULL, NULL, NULL),
(26868, '2017-04-14 14:38:41', NULL, NULL, 8491, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 14:38:41', 'admin-1492143587-14921519212416583', 1, 1, 'SR', NULL, NULL, NULL),
(26869, '2017-04-14 15:15:31', NULL, NULL, 8493, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 15:15:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26870, '2017-04-14 15:15:34', NULL, NULL, 8493, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 15:15:34', 'admin-1492143587-14921541337508927', 1, 0, '', NULL, NULL, NULL),
(26871, '2017-04-14 15:19:47', NULL, NULL, 8494, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1492143587', 'admin', '2017-04-14 15:19:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26872, '2017-04-14 15:19:53', NULL, NULL, 8494, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 15:19:53', 'admin-1492143587-14921543934547026', 1, 1, 'SR', NULL, NULL, NULL),
(26873, '2017-04-14 15:19:53', NULL, NULL, 8494, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 15:19:53', 'admin-1492143587-14921543934547026', 1, 1, 'SR', NULL, NULL, NULL),
(26874, '2017-04-14 16:06:46', NULL, NULL, 8495, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1492143587', 'admin', '2017-04-14 16:06:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26875, '2017-04-14 16:07:02', NULL, NULL, 8495, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 16:07:02', 'admin-1492143587-14921572222499946', 1, 1, 'SR', NULL, NULL, NULL),
(26876, '2017-04-14 15:13:19', NULL, NULL, 8490, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 15:13:19', 'admin-1492143587-14921539996566311', 1, 1, 'SR', NULL, NULL, NULL),
(26877, '2017-04-14 14:28:22', NULL, NULL, 8490, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1492143587', 'admin', '2017-04-14 14:28:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26878, '2017-04-14 14:28:28', NULL, NULL, 8490, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 14:28:28', 'admin-1492143587-14921513086225978', 1, 1, 'SR', NULL, NULL, NULL),
(26879, '2017-04-14 14:38:41', NULL, NULL, 8491, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 14:38:41', 'admin-1492143587-14921519212416583', 1, 0, '', NULL, NULL, NULL),
(26880, '2017-04-14 12:57:34', NULL, NULL, 8484, 0, 182, '117', 'Open Drinks ', 'Penang craft beer 1 ctn', 'Cold Drinks', 'Fresh Juice', 1, 456.00, 456.0000, 0.0000, 456.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 12:57:34', 'admin-1492143587-14921458540226966', 1, 0, '', NULL, NULL, NULL),
(26881, '2017-04-14 13:09:41', NULL, NULL, 8485, 0, 182, '117', 'Open Drinks ', 'water', 'Cold Drinks', 'Fresh Juice', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 13:09:41', 'admin-1492143587-14921465812927465', 1, 0, '', 1, NULL, NULL),
(26882, '2017-04-14 14:34:13', NULL, NULL, 8490, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 14:34:13', 'admin-1492143587-14921516534706593', 1, 1, 'SR', NULL, NULL, NULL),
(26883, '2017-04-14 14:34:13', NULL, NULL, 8490, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 14:34:13', 'admin-1492143587-14921516534706593', 1, 0, '', NULL, NULL, NULL),
(26884, '2017-04-14 14:38:12', NULL, NULL, 8491, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1492143587', 'admin', '2017-04-14 14:38:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26885, '2017-04-14 14:38:41', NULL, NULL, 8491, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 14:38:41', 'admin-1492143587-14921519212416583', 1, 1, 'SR', NULL, NULL, NULL),
(26886, '2017-04-14 14:38:41', NULL, NULL, 8491, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 14:38:41', 'admin-1492143587-14921519212416583', 1, 0, '', NULL, NULL, NULL),
(26887, '2017-04-14 11:43:11', NULL, NULL, 8479, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:43:11', 'admin-1492130095-14921413912462496', 1, 1, 'SR', NULL, NULL, NULL),
(26888, '2017-04-14 11:52:39', NULL, NULL, 8477, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:52:39', 'admin-1492130095-14921419592961228', 1, 0, '', NULL, NULL, NULL),
(26889, '2017-04-14 11:53:15', NULL, NULL, 8481, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:53:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26890, '2017-04-14 11:53:20', NULL, NULL, 8481, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:53:20', 'admin-1492130095-14921420003779746', 1, 0, '', NULL, NULL, NULL),
(26891, '2017-04-14 11:53:20', NULL, NULL, 8481, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:53:20', 'admin-1492130095-14921420003779746', 1, 1, 'SR', NULL, NULL, NULL),
(26892, '2017-04-14 11:53:20', NULL, NULL, 8481, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:53:20', 'admin-1492130095-14921420003779746', 1, 1, 'SR', NULL, NULL, NULL),
(26893, '2017-04-14 10:25:33', NULL, NULL, 8474, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 10:25:33', 'admin-1492130095-1492136733580326', 1, 1, 'SR', NULL, NULL, NULL),
(26894, '2017-04-14 10:25:33', NULL, NULL, 8474, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 10:25:33', 'admin-1492130095-1492136733580326', 1, 0, '', NULL, NULL, NULL),
(26895, '2017-04-14 10:25:33', NULL, NULL, 8474, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 10:25:33', 'admin-1492130095-1492136733580326', 1, 0, '', NULL, NULL, NULL),
(26896, '2017-04-14 10:27:24', NULL, NULL, 8475, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1492143587', 'admin', '2017-04-14 10:27:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26897, '2017-04-14 10:27:37', NULL, NULL, 8475, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 10:27:37', 'admin-1492130095-14921368571536936', 1, 0, '', NULL, NULL, NULL),
(26898, '2017-04-14 10:27:37', NULL, NULL, 8475, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 10:27:37', 'admin-1492130095-14921368571536936', 1, 0, '', NULL, NULL, NULL),
(26899, '2017-04-14 10:27:37', NULL, NULL, 8475, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 10:27:37', 'admin-1492130095-14921368571536936', 1, 1, 'SR', NULL, NULL, NULL),
(26900, '2017-04-14 10:27:37', NULL, NULL, 8475, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 10:27:37', 'admin-1492130095-14921368571536936', 1, 1, 'SR', NULL, NULL, NULL),
(26901, '2017-04-14 10:39:31', NULL, NULL, 8474, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 10:39:31', 'admin-1492130095-14921375717723275', 1, 0, '', NULL, NULL, NULL),
(26902, '2017-04-14 16:07:02', NULL, NULL, 8495, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 16:07:02', 'admin-1492143587-14921572222499946', 1, 1, 'SR', NULL, NULL, NULL),
(26903, '2017-04-14 16:07:02', NULL, NULL, 8495, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 16:07:02', 'admin-1492143587-14921572222499946', 1, 0, '', NULL, NULL, NULL),
(26904, '2017-04-14 16:19:39', NULL, NULL, 8493, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 16:19:39', 'admin-1492143587-1492157979706169', 1, 0, '', NULL, NULL, NULL),
(26905, '2017-04-14 17:16:46', NULL, NULL, 8493, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 17:16:46', 'admin-1492143587-14921614063288618', 1, 0, '', NULL, NULL, NULL),
(26906, '2017-04-14 13:36:53', NULL, NULL, 8487, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 13:36:53', 'admin-1492143587-14921482135329556', 1, 0, '', NULL, NULL, NULL),
(26907, '2017-04-14 13:36:53', NULL, NULL, 8487, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 13:36:53', 'admin-1492143587-14921482135329556', 1, 0, '', NULL, NULL, NULL),
(26908, '2017-04-14 09:57:48', NULL, NULL, 8473, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 09:57:48', 'admin-1492130095-14921350686196838', 1, 0, '', NULL, NULL, NULL),
(26909, '2017-04-14 14:20:03', NULL, NULL, 8489, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 14:20:03', 'admin-1492143587-14921508031203129', 1, 0, '', NULL, NULL, NULL),
(26910, '2017-04-14 14:19:55', NULL, NULL, 8489, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1492143587', 'admin', '2017-04-14 14:19:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26911, '2017-04-14 14:20:03', NULL, NULL, 8489, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 14:20:03', 'admin-1492143587-14921508031203129', 1, 1, 'SR', NULL, NULL, NULL),
(26912, '2017-04-14 14:13:30', NULL, NULL, 8488, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 14:13:30', 'admin-1492143587-14921504103583091', 1, 0, '', NULL, NULL, NULL),
(26913, '2017-04-14 11:15:57', NULL, NULL, 8477, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:15:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26914, '2017-04-14 11:18:22', NULL, NULL, 8477, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:18:22', 'admin-1492130095-1492139902649976', 1, 0, '', NULL, NULL, NULL),
(26915, '2017-04-14 11:19:10', NULL, NULL, 8478, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:19:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26916, '2017-04-14 11:19:19', NULL, NULL, 8478, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:19:19', 'admin-1492130095-14921399593567172', 1, 1, 'SR', NULL, NULL, NULL),
(26917, '2017-04-14 11:19:19', NULL, NULL, 8478, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:19:19', 'admin-1492130095-14921399593567172', 1, 1, 'SR', NULL, NULL, NULL),
(26918, '2017-04-14 11:22:27', NULL, NULL, 8477, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:22:27', 'admin-1492130095-1492140147572525', 1, 0, '', NULL, NULL, NULL),
(26919, '2017-04-14 11:36:00', NULL, NULL, 8479, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:36:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26920, '2017-04-14 11:36:03', NULL, NULL, 8479, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:36:03', 'admin-1492130095-1492140963433653', 1, 0, '', NULL, NULL, NULL),
(26921, '2017-04-14 11:36:03', NULL, NULL, 8479, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:36:03', 'admin-1492130095-1492140963433653', 1, 0, '', NULL, NULL, NULL),
(26922, '2017-04-14 11:43:01', NULL, NULL, 8480, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:43:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26923, '2017-04-14 11:43:07', NULL, NULL, 8480, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:43:07', 'admin-1492130095-1492141387217516', 1, 0, '', NULL, NULL, NULL),
(26924, '2017-04-14 11:43:07', NULL, NULL, 8480, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:43:07', 'admin-1492130095-1492141387217516', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(26925, '2017-04-14 14:28:28', NULL, NULL, 8490, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 14:28:28', 'admin-1492143587-14921513086225978', 1, 1, 'SR', NULL, NULL, NULL),
(26926, '2017-04-14 14:12:30', NULL, NULL, 8488, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1492143587', 'admin', '2017-04-14 14:12:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26927, '2017-04-14 13:10:01', NULL, NULL, 8486, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 13:10:01', 'admin-1492143587-14921466009736768', 1, 1, 'SR', NULL, NULL, NULL),
(26928, '2017-04-14 13:10:01', NULL, NULL, 8486, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 13:10:01', 'admin-1492143587-14921466009736768', 1, 1, 'SR', NULL, NULL, NULL),
(26929, '2017-04-14 13:36:39', NULL, NULL, 8487, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1492143587', 'admin', '2017-04-14 13:36:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26930, '2017-04-14 13:09:58', NULL, NULL, 8486, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 13:09:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26931, '2017-04-14 11:56:01', NULL, NULL, 8483, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:56:01', 'admin-1492130095-14921421609782640', 1, 1, 'SR', NULL, NULL, NULL),
(26932, '2017-04-14 12:15:51', NULL, NULL, 8484, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 53.40, 0.0000, 0.0000, 53.40, 1, '27', 1, '1492143587', 'admin', '2017-04-14 12:15:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26933, '2017-04-14 12:15:54', NULL, NULL, 8484, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 12:15:54', 'admin-1492130095-14921433543702884', 1, 0, '', NULL, NULL, NULL),
(26934, '2017-04-14 11:01:57', NULL, NULL, 8476, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:01:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26935, '2017-04-14 12:25:03', NULL, NULL, 8484, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 12:25:03', 'admin-1492143587-14921439035291854', 1, 0, '', NULL, NULL, NULL),
(26936, '2017-04-14 12:19:58', NULL, NULL, 8484, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 12:19:58', 'admin-1492143587-14921435983021528', 1, 0, '', NULL, NULL, NULL),
(26937, '2017-04-14 14:38:41', NULL, NULL, 8491, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 14:38:41', 'admin-1492143587-14921519212416583', 1, 0, '', NULL, NULL, NULL),
(26938, '2017-04-14 12:19:58', NULL, NULL, 8484, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 12:19:58', 'admin-1492143587-14921435983021528', 1, 0, '', NULL, NULL, NULL),
(26939, '2017-04-14 11:56:01', NULL, NULL, 8483, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:56:01', 'admin-1492130095-14921421609782640', 1, 1, 'SR', NULL, NULL, NULL),
(26940, '2017-04-14 11:55:54', NULL, NULL, 8483, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:55:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26941, '2017-04-14 11:02:02', NULL, NULL, 8476, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 11:02:02', 'admin-1492130095-1492138922208378', 1, 1, 'SR', NULL, NULL, NULL),
(26942, '2017-04-14 09:57:48', NULL, NULL, 8473, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 09:57:48', 'admin-1492130095-14921350686196838', 1, 0, '', NULL, NULL, NULL),
(26943, '2017-04-14 09:57:48', NULL, NULL, 8473, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 09:57:48', 'admin-1492130095-14921350686196838', 1, 1, 'SR', NULL, NULL, NULL),
(26944, '2017-04-14 09:57:48', NULL, NULL, 8473, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 09:57:48', 'admin-1492130095-14921350686196838', 1, 1, 'SR', NULL, NULL, NULL),
(26945, '2017-04-14 09:57:48', NULL, NULL, 8473, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 09:57:48', 'admin-1492130095-14921350686196838', 1, 1, 'SR', NULL, NULL, NULL),
(26946, '2017-04-14 10:25:21', NULL, NULL, 8474, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1492143587', 'admin', '2017-04-14 10:25:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26947, '2017-04-14 10:25:33', NULL, NULL, 8474, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 10:25:33', 'admin-1492130095-1492136733580326', 1, 1, 'SR', NULL, NULL, NULL),
(26948, '2017-04-14 09:56:49', NULL, NULL, 8472, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 09:56:49', 'admin-1492130095-14921350095056828', 1, 0, '', NULL, NULL, NULL),
(26949, '2017-04-14 09:56:49', NULL, NULL, 8472, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 09:56:49', 'admin-1492130095-14921350095056828', 1, 0, '', NULL, NULL, NULL),
(26950, '2017-04-14 09:57:32', NULL, NULL, 8473, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 09:57:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26951, '2017-04-14 09:55:25', NULL, NULL, 8472, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 09:55:25', 'admin-1492130095-14921349253936754', 1, 0, '', NULL, NULL, NULL),
(26952, '2017-04-14 09:55:34', NULL, NULL, 8472, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492143587', 'admin', '2017-04-14 09:55:34', 'admin-1492130095-14921349341718950', 1, 1, 'SR', NULL, NULL, NULL),
(26953, '2017-04-14 09:51:59', NULL, NULL, 8472, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1492143587', 'admin', '2017-04-14 09:51:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26954, '2017-04-15 13:33:18', NULL, NULL, 8521, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 13:33:18', 'admin-1492226133-14922343986797386', 1, 1, 'SR', NULL, NULL, NULL),
(26955, '2017-04-15 12:20:31', NULL, NULL, 8517, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 12:20:31', 'admin-1492226133-14922300317507629', 1, 0, '', NULL, NULL, NULL),
(26956, '2017-04-15 12:22:58', NULL, NULL, 8518, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1492237155', 'admin', '2017-04-15 12:22:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26957, '2017-04-15 12:23:02', NULL, NULL, 8518, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 12:23:02', 'admin-1492226133-14922301825302215', 1, 1, 'SR', NULL, NULL, NULL),
(26958, '2017-04-15 12:23:02', NULL, NULL, 8518, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 12:23:02', 'admin-1492226133-14922301825302215', 1, 1, 'SR', NULL, NULL, NULL),
(26959, '2017-04-15 12:41:32', NULL, NULL, 8515, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 12:41:32', 'admin-1492226133-14922312926398526', 1, 0, '', NULL, NULL, NULL),
(26960, '2017-04-15 13:05:02', NULL, NULL, 8519, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1492237155', 'admin', '2017-04-15 13:05:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26961, '2017-04-15 13:05:11', NULL, NULL, 8519, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 13:05:11', 'admin-1492226133-1492232711326925', 1, 0, '', NULL, NULL, NULL),
(26962, '2017-04-15 13:05:11', NULL, NULL, 8519, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 13:05:11', 'admin-1492226133-1492232711326925', 1, 1, 'SR', NULL, NULL, NULL),
(26963, '2017-04-15 13:05:11', NULL, NULL, 8519, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 13:05:11', 'admin-1492226133-1492232711326925', 1, 0, '', NULL, NULL, NULL),
(26964, '2017-04-15 13:05:17', NULL, NULL, 8519, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 13:05:17', 'admin-1492226133-14922327170161761', 1, 0, '', NULL, NULL, NULL),
(26965, '2017-04-15 13:12:51', NULL, NULL, 8520, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 13:12:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26966, '2017-04-15 11:08:31', NULL, NULL, 8511, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:08:31', 'admin-1492219535-14922257117802770', 1, 1, 'SR', NULL, NULL, NULL),
(26967, '2017-04-15 11:08:31', NULL, NULL, 8511, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:08:31', 'admin-1492219535-14922257117802770', 1, 1, 'SR', NULL, NULL, NULL),
(26968, '2017-04-15 11:14:36', NULL, NULL, 8512, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:14:36', 'admin-1492219535-14922260764716348', 1, 0, '', NULL, NULL, NULL),
(26969, '2017-04-15 11:15:45', NULL, NULL, 8512, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:15:45', 'admin-1492226133-14922261452002854', 1, 0, '', NULL, NULL, NULL),
(26970, '2017-04-15 00:00:00', NULL, NULL, 8501, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:50:55', 'admin-1492219535-14922210555351678', 1, 0, '', NULL, NULL, NULL),
(26971, '2017-04-15 15:06:33', NULL, NULL, 8526, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 15:06:33', 'admin-1492237155-14922399935138191', 1, 1, 'SR', NULL, NULL, NULL),
(26972, '2017-04-15 16:15:20', NULL, NULL, 8532, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1492237155', 'admin', '2017-04-15 16:15:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26973, '2017-04-15 16:15:39', NULL, NULL, 8532, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 16:15:39', 'admin-1492237155-14922441392496493', 1, 1, 'SR', NULL, NULL, NULL),
(26974, '2017-04-15 16:23:15', NULL, NULL, 8532, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 16:23:15', 'admin-1492237155-14922445953151971', 1, 0, '', NULL, NULL, NULL),
(26975, '2017-04-15 15:30:30', NULL, NULL, 8531, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 15:30:30', 'admin-1492237155-14922414303736785', 1, 1, 'SR', NULL, NULL, NULL),
(26976, '2017-04-15 15:11:04', NULL, NULL, 8528, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 15:11:04', 'admin-1492237155-14922402645812289', 1, 0, '', NULL, NULL, NULL),
(26977, '2017-04-15 15:11:04', NULL, NULL, 8528, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 15:11:04', 'admin-1492237155-14922402645812289', 1, 1, 'SR', NULL, NULL, NULL),
(26978, '2017-04-15 15:11:04', NULL, NULL, 8528, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 15:11:04', 'admin-1492237155-14922402645812289', 1, 1, 'SR', NULL, NULL, NULL),
(26979, '2017-04-15 15:30:30', NULL, NULL, 8531, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 15:30:30', 'admin-1492237155-14922414303736785', 1, 1, 'SR', NULL, NULL, NULL),
(26980, '2017-04-15 15:19:11', NULL, NULL, 8527, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 15:19:11', 'admin-1492237155-1492240751501946', 1, 0, '', NULL, NULL, NULL),
(26981, '2017-04-15 15:21:26', NULL, NULL, 8530, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1492237155', 'admin', '2017-04-15 15:21:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26982, '2017-04-15 14:47:54', NULL, NULL, 8525, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1492237155', 'admin', '2017-04-15 14:47:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26983, '2017-04-15 14:48:16', NULL, NULL, 8525, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 14:48:16', 'admin-1492237155-1492238896166851', 1, 0, '', NULL, NULL, NULL),
(26984, '2017-04-15 14:49:14', NULL, NULL, 8525, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 14:49:14', 'admin-1492237155-14922389542762760', 1, 0, '', NULL, NULL, NULL),
(26985, '2017-04-15 14:49:14', NULL, NULL, 8525, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 14:49:14', 'admin-1492237155-14922389542762760', 1, 1, 'SR', NULL, NULL, NULL),
(26986, '2017-04-15 14:40:33', NULL, NULL, 8524, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 14:40:33', 'admin-1492237155-1492238433075212', 1, 1, 'SR', 1, NULL, NULL),
(26987, '2017-04-15 15:21:49', NULL, NULL, 8530, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 15:21:49', 'admin-1492237155-14922409097037118', 1, 1, 'SR', NULL, NULL, NULL),
(26988, '2017-04-15 15:30:11', NULL, NULL, 8531, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 15:30:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26989, '2017-04-15 14:40:33', NULL, NULL, 8524, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 14:40:33', 'admin-1492237155-1492238433075212', 1, 1, 'SR', 1, NULL, NULL),
(26990, '2017-04-15 11:56:09', NULL, NULL, 8515, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:56:09', 'admin-1492226133-14922285695985115', 1, 0, '', NULL, NULL, NULL),
(26991, '2017-04-15 11:58:56', NULL, NULL, 8515, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:58:56', 'admin-1492226133-14922287366918598', 1, 0, '', NULL, NULL, NULL),
(26992, '2017-04-15 12:02:22', NULL, NULL, 8516, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1492237155', 'admin', '2017-04-15 12:02:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(26993, '2017-04-15 12:02:38', NULL, NULL, 8516, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 12:02:38', 'admin-1492226133-14922289584198863', 1, 1, 'SR', NULL, NULL, NULL),
(26994, '2017-04-15 12:02:38', NULL, NULL, 8516, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 12:02:38', 'admin-1492226133-14922289584198863', 1, 0, '', NULL, NULL, NULL),
(26995, '2017-04-15 12:02:38', NULL, NULL, 8516, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 12:02:38', 'admin-1492226133-14922289584198863', 1, 0, '', NULL, NULL, NULL),
(26996, '2017-04-15 12:07:43', NULL, NULL, 8512, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 12:07:43', 'admin-1492226133-14922292628217422', 1, 1, 'SR', NULL, NULL, NULL),
(26997, '2017-04-15 15:21:49', NULL, NULL, 8530, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 15:21:49', 'admin-1492237155-14922409097037118', 1, 1, 'SR', NULL, NULL, NULL),
(26998, '2017-04-15 15:18:19', NULL, NULL, 8527, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 15:18:19', 'admin-1492237155-14922406993848247', 1, 1, 'SR', NULL, NULL, NULL),
(26999, '2017-04-15 14:49:14', NULL, NULL, 8525, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 14:49:14', 'admin-1492237155-14922389542762760', 1, 0, '', NULL, NULL, NULL),
(27000, '2017-04-15 14:49:14', NULL, NULL, 8525, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 14:49:14', 'admin-1492237155-14922389542762760', 1, 1, 'SR', NULL, NULL, NULL),
(27001, '2017-04-15 14:49:14', NULL, NULL, 8525, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 14:49:14', 'admin-1492237155-14922389542762760', 1, 0, '', NULL, NULL, NULL),
(27002, '2017-04-15 14:50:06', NULL, NULL, 8526, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1492237155', 'admin', '2017-04-15 14:50:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27003, '2017-04-15 14:50:17', NULL, NULL, 8526, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 14:50:17', 'admin-1492237155-14922390173885599', 1, 0, '', NULL, NULL, NULL),
(27004, '2017-04-15 14:50:17', NULL, NULL, 8526, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 14:50:17', 'admin-1492237155-14922390173885599', 1, 1, 'SR', NULL, NULL, NULL),
(27005, '2017-04-15 14:50:17', NULL, NULL, 8526, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 14:50:17', 'admin-1492237155-14922390173885599', 1, 0, '', NULL, NULL, NULL),
(27006, '2017-04-15 14:53:16', NULL, NULL, 8527, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1492237155', 'admin', '2017-04-15 14:53:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27007, '2017-04-15 14:56:15', NULL, NULL, 8527, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 14:56:15', 'admin-1492237155-14922393749045297', 1, 0, '', NULL, NULL, NULL),
(27008, '2017-04-15 15:01:05', NULL, NULL, 8525, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 15:01:05', 'admin-1492237155-14922396649338157', 1, 1, 'SR', NULL, NULL, NULL),
(27009, '2017-04-15 15:05:42', NULL, NULL, 8528, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 15:05:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27010, '2017-04-15 15:06:33', NULL, NULL, 8526, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 15:06:33', 'admin-1492237155-14922399935138191', 1, 1, 'SR', NULL, NULL, NULL),
(27011, '2017-04-15 15:06:33', NULL, NULL, 8526, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 15:06:33', 'admin-1492237155-14922399935138191', 1, 0, '', NULL, NULL, NULL),
(27012, '2017-04-15 15:06:33', NULL, NULL, 8526, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 15:06:33', 'admin-1492237155-14922399935138191', 1, 1, 'SR', NULL, NULL, NULL),
(27013, '2017-04-15 15:14:18', NULL, NULL, 8529, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 15:14:18', 'admin-1492237155-14922404578435962', 1, 0, '', NULL, NULL, NULL),
(27014, '2017-04-15 15:14:18', NULL, NULL, 8529, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 15:14:18', 'admin-1492237155-14922404578435962', 1, 1, 'SR', NULL, NULL, NULL),
(27015, '2017-04-15 15:14:18', NULL, NULL, 8529, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 15:14:18', 'admin-1492237155-14922404578435962', 1, 1, 'SR', NULL, NULL, NULL),
(27016, '2017-04-15 15:14:13', NULL, NULL, 8529, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1492237155', 'admin', '2017-04-15 15:14:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27017, '2017-04-15 13:33:09', NULL, NULL, 8521, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 13:33:09', 'admin-1492226133-14922343888246655', 1, 1, 'SR', NULL, NULL, NULL),
(27018, '2017-04-15 13:33:09', NULL, NULL, 8521, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 13:33:09', 'admin-1492226133-14922343888246655', 1, 1, 'SR', NULL, NULL, NULL),
(27019, '2017-04-15 13:33:09', NULL, NULL, 8521, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 13:33:09', 'admin-1492226133-14922343888246655', 1, 0, '', NULL, NULL, NULL),
(27020, '2017-04-15 14:14:36', NULL, NULL, 8522, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1492237155', 'admin', '2017-04-15 14:14:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27021, '2017-04-15 14:14:45', NULL, NULL, 8522, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 14:14:45', 'admin-1492226133-14922368854671428', 1, 0, '', NULL, NULL, NULL),
(27022, '2017-04-15 14:14:45', NULL, NULL, 8522, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 14:14:45', 'admin-1492226133-14922368854671428', 1, 0, '', NULL, NULL, NULL),
(27023, '2017-04-15 14:18:37', NULL, NULL, 8523, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1492237155', 'admin', '2017-04-15 14:18:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27024, '2017-04-15 12:07:43', NULL, NULL, 8512, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 12:07:43', 'admin-1492226133-14922292628217422', 1, 1, 'SR', NULL, NULL, NULL),
(27025, '2017-04-15 00:00:00', NULL, NULL, 8502, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:35:57', 'admin-1492219535-14922201574682435', 1, 1, 'SR', NULL, NULL, NULL),
(27026, '2017-04-15 00:00:00', NULL, NULL, 8503, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:41:54', 'admin-1492219535-14922205138994072', 1, 0, '', NULL, NULL, NULL),
(27027, '2017-04-15 00:00:00', NULL, NULL, 8504, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:20:39', 'admin-1492217881-14922192387511863', 1, 1, 'SR', NULL, NULL, NULL),
(27028, '2017-04-15 00:00:00', NULL, NULL, 8505, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:20:10', 'admin-1492217881-1492219210297253', 1, 0, '', NULL, NULL, NULL),
(27029, '2017-04-15 00:00:00', NULL, NULL, 8506, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:15:40', 'admin-1492217881-14922189404356437', 1, 1, 'SR', NULL, NULL, NULL),
(27030, '2017-04-15 14:19:08', NULL, NULL, 8523, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 14:19:08', 'admin-1492226133-14922371484685982', 1, 0, '', NULL, NULL, NULL),
(27031, '2017-04-15 14:19:08', NULL, NULL, 8523, 0, 181, '116', 'Open Food ', 'add rice', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 14:19:08', 'admin-1492226133-14922371484685982', 1, 0, '', NULL, NULL, NULL),
(27032, '2017-04-15 13:13:04', NULL, NULL, 8520, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 13:13:04', 'admin-1492226133-14922331846953115', 1, 0, '', NULL, NULL, NULL),
(27033, '2017-04-15 13:32:56', NULL, NULL, 8521, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1492237155', 'admin', '2017-04-15 13:32:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27034, '2017-04-15 13:33:09', NULL, NULL, 8521, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 13:33:09', 'admin-1492226133-14922343888246655', 1, 0, '', NULL, NULL, NULL),
(27035, '2017-04-15 13:33:09', NULL, NULL, 8521, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 13:33:09', 'admin-1492226133-14922343888246655', 1, 0, '', NULL, NULL, NULL),
(27036, '2017-04-15 13:33:09', NULL, NULL, 8521, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 13:33:09', 'admin-1492226133-14922343888246655', 1, 1, 'SR', NULL, NULL, NULL),
(27037, '2017-04-15 13:13:04', NULL, NULL, 8520, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 13:13:04', 'admin-1492226133-14922331846953115', 1, 1, 'SR', NULL, NULL, NULL),
(27038, '2017-04-15 13:13:04', NULL, NULL, 8520, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 13:13:04', 'admin-1492226133-14922331846953115', 1, 1, 'SR', NULL, NULL, NULL),
(27039, '2017-04-15 11:50:50', NULL, NULL, 8514, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:50:50', 'admin-1492226133-1492228250139687', 1, 1, 'SR', NULL, NULL, NULL),
(27040, '2017-04-15 11:50:50', NULL, NULL, 8514, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:50:50', 'admin-1492226133-1492228250139687', 1, 1, 'SR', NULL, NULL, NULL),
(27041, '2017-04-15 11:50:15', NULL, NULL, 8514, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:50:15', 'admin-1492226133-14922282148614461', 1, 0, '', NULL, NULL, NULL),
(27042, '2017-04-15 11:50:15', NULL, NULL, 8514, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:50:15', 'admin-1492226133-14922282148614461', 1, 0, '', NULL, NULL, NULL),
(27043, '2017-04-15 11:49:47', NULL, NULL, 8514, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:49:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27044, '2017-04-15 10:40:06', NULL, NULL, 8507, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:40:06', 'admin-1492219535-14922240063493695', 1, 1, 'SR', NULL, NULL, NULL),
(27045, '2017-04-15 11:14:16', NULL, NULL, 8512, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:14:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27046, '2017-04-15 11:06:33', NULL, NULL, 8500, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:06:33', 'admin-1492219535-14922255936306977', 1, 0, '', NULL, NULL, NULL),
(27047, '2017-04-15 11:07:07', NULL, NULL, 8511, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:07:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27048, '2017-04-15 11:07:20', NULL, NULL, 8511, 0, 154, '88', 'Daily Dose BLT', 'bacon not too hard', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:07:20', 'admin-1492219535-1492225640356344', 1, 0, '', NULL, NULL, NULL),
(27049, '2017-04-15 11:07:20', NULL, NULL, 8511, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:07:20', 'admin-1492219535-1492225640356344', 1, 0, '', NULL, NULL, NULL),
(27050, '2017-04-15 00:00:00', NULL, NULL, 8504, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:12:44', 'admin-1492217881-14922187647039117', 1, 0, '', NULL, NULL, NULL),
(27051, '2017-04-15 10:17:26', NULL, NULL, 8501, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:17:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27052, '2017-04-15 09:22:40', NULL, NULL, 8497, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.80, 0.0000, 0.0000, 13.80, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:22:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27053, '2017-04-15 09:23:32', NULL, NULL, 8497, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:23:32', 'admin-1492217881-14922194122748061', 1, 0, '', NULL, NULL, NULL),
(27054, '2017-04-15 09:23:32', NULL, NULL, 8497, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:23:32', 'admin-1492217881-14922194122748061', 1, 0, '', NULL, NULL, NULL),
(27055, '2017-04-15 09:23:32', NULL, NULL, 8497, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:23:32', 'admin-1492217881-14922194122748061', 1, 0, '', NULL, NULL, NULL),
(27056, '2017-04-15 09:23:32', NULL, NULL, 8497, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:23:32', 'admin-1492217881-14922194122748061', 1, 0, '', NULL, NULL, NULL),
(27057, '2017-04-15 09:23:32', NULL, NULL, 8497, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:23:32', 'admin-1492217881-14922194122748061', 1, 0, '', NULL, NULL, NULL),
(27058, '2017-04-15 09:23:45', NULL, NULL, 8497, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:23:45', 'admin-1492217881-1492219425651333', 1, 1, 'SR', NULL, NULL, NULL),
(27059, '2017-04-15 10:17:53', NULL, NULL, 8502, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:17:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27060, '2017-04-15 12:20:28', NULL, NULL, 8517, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1492237155', 'admin', '2017-04-15 12:20:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27061, '2017-04-15 12:17:55', NULL, NULL, 8513, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 12:17:55', 'admin-1492226133-14922298747676596', 1, 1, 'SR', NULL, NULL, NULL),
(27062, '2017-04-15 11:33:45', NULL, NULL, 8513, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:33:45', 'admin-1492226133-1492227225626648', 1, 0, '', NULL, NULL, NULL),
(27063, '2017-04-15 11:33:45', NULL, NULL, 8513, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:33:45', 'admin-1492226133-1492227225626648', 1, 1, 'SR', NULL, NULL, NULL),
(27064, '2017-04-15 11:33:45', NULL, NULL, 8513, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:33:45', 'admin-1492226133-1492227225626648', 1, 1, 'SR', NULL, NULL, NULL),
(27065, '2017-04-15 11:33:45', NULL, NULL, 8513, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:33:45', 'admin-1492226133-1492227225626648', 1, 0, '', NULL, NULL, NULL),
(27066, '2017-04-15 11:33:39', NULL, NULL, 8513, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:33:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27067, '2017-04-15 13:13:04', NULL, NULL, 8520, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 13:13:04', 'admin-1492226133-14922331846953115', 1, 1, 'SR', NULL, NULL, NULL),
(27068, '2017-04-15 10:21:22', NULL, NULL, 8507, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:21:22', 'admin-1492219535-14922228818743169', 1, 0, '', NULL, NULL, NULL),
(27069, '2017-04-15 10:24:20', NULL, NULL, 8508, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:24:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27070, '2017-04-15 10:24:37', NULL, NULL, 8508, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:24:37', 'admin-1492219535-14922230769982936', 1, 0, '', NULL, NULL, NULL),
(27071, '2017-04-15 10:24:37', NULL, NULL, 8508, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:24:37', 'admin-1492219535-14922230769982936', 1, 0, '', NULL, NULL, NULL),
(27072, '2017-04-15 10:25:11', NULL, NULL, 8508, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:25:11', 'admin-1492219535-1492223110835944', 1, 1, 'SR', NULL, NULL, NULL),
(27073, '2017-04-15 10:25:11', NULL, NULL, 8508, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:25:11', 'admin-1492219535-1492223110835944', 1, 1, 'SR', NULL, NULL, NULL),
(27074, '2017-04-15 09:25:14', NULL, NULL, 8498, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:25:14', 'admin-1492217881-14922195146259624', 1, 1, 'SR', NULL, NULL, NULL),
(27075, '2017-04-15 09:32:02', NULL, NULL, 8499, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:32:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27076, '2017-04-15 09:32:16', NULL, NULL, 8499, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:32:16', 'admin-1492219535-14922199358033175', 1, 0, '', NULL, NULL, NULL),
(27077, '2017-04-15 09:32:16', NULL, NULL, 8499, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:32:16', 'admin-1492219535-14922199358033175', 1, 0, '', NULL, NULL, NULL),
(27078, '2017-04-15 09:32:16', NULL, NULL, 8499, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:32:16', 'admin-1492219535-14922199358033175', 1, 0, '', NULL, NULL, NULL),
(27079, '2017-04-15 09:32:16', NULL, NULL, 8499, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:32:16', 'admin-1492219535-14922199358033175', 1, 1, 'SR', NULL, NULL, NULL),
(27080, '2017-04-15 00:00:00', NULL, NULL, 8502, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:20:10', 'admin-1492217881-1492219210297253', 1, 0, '', NULL, NULL, NULL),
(27081, '2017-04-15 00:00:00', NULL, NULL, 8503, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:11:07', 'admin-1492217881-14922186670659638', 1, 1, 'SR', NULL, NULL, NULL),
(27082, '2017-04-15 00:00:00', NULL, NULL, 8501, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:20:39', 'admin-1492217881-14922192387511863', 1, 1, 'SR', NULL, NULL, NULL),
(27083, '2017-04-15 10:19:21', NULL, NULL, 8505, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:19:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27084, '2017-04-15 09:55:22', NULL, NULL, 8497, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:55:22', 'admin-1492219535-14922213217415113', 1, 0, '', NULL, NULL, NULL),
(27085, '2017-04-15 10:07:54', NULL, NULL, 8500, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:07:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27086, '2017-04-15 11:56:06', NULL, NULL, 8515, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:56:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27087, '2017-04-15 11:08:31', NULL, NULL, 8511, 0, 154, '88', 'Daily Dose BLT', 'bacon not too hard', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 11:08:31', 'admin-1492219535-14922257117802770', 1, 0, '', NULL, NULL, NULL),
(27088, '2017-04-15 10:40:06', NULL, NULL, 8507, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:40:06', 'admin-1492219535-14922240063493695', 1, 1, 'SR', NULL, NULL, NULL),
(27089, '2017-04-15 10:31:50', NULL, NULL, 8508, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:31:50', 'admin-1492219535-14922235104149346', 1, 1, 'SR', NULL, NULL, NULL),
(27090, '2017-04-15 10:29:01', NULL, NULL, 8509, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:29:01', 'admin-1492219535-14922233415611260', 1, 1, 'SR', NULL, NULL, NULL),
(27091, '2017-04-15 10:29:01', NULL, NULL, 8509, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:29:01', 'admin-1492219535-14922233415611260', 1, 1, 'SR', NULL, NULL, NULL),
(27092, '2017-04-15 10:29:01', NULL, NULL, 8509, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:29:01', 'admin-1492219535-14922233415611260', 1, 1, 'SR', NULL, NULL, NULL),
(27093, '2017-04-15 10:26:16', NULL, NULL, 8509, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:26:16', 'admin-1492219535-14922231760856737', 1, 0, '', NULL, NULL, NULL),
(27094, '2017-04-15 10:26:16', NULL, NULL, 8509, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:26:16', 'admin-1492219535-14922231760856737', 1, 0, '', NULL, NULL, NULL),
(27095, '2017-04-15 10:26:16', NULL, NULL, 8509, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:26:16', 'admin-1492219535-14922231760856737', 1, 0, '', NULL, NULL, NULL),
(27096, '2017-04-15 10:26:00', NULL, NULL, 8509, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:26:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27097, '2017-04-15 00:00:00', NULL, NULL, 8505, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:50:55', 'admin-1492219535-14922210555351678', 1, 1, 'SR', NULL, NULL, NULL),
(27098, '2017-04-15 10:08:04', NULL, NULL, 8500, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:08:04', 'admin-1492219535-14922220840861274', 1, 0, '', NULL, NULL, NULL),
(27099, '2017-04-15 10:21:22', NULL, NULL, 8507, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:21:22', 'admin-1492219535-14922228818743169', 1, 0, '', NULL, NULL, NULL),
(27100, '2017-04-15 10:08:04', NULL, NULL, 8500, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:08:04', 'admin-1492219535-14922220840861274', 1, 1, 'SR', NULL, NULL, NULL),
(27101, '2017-04-15 10:08:04', NULL, NULL, 8500, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:08:04', 'admin-1492219535-14922220840861274', 1, 0, '', NULL, NULL, NULL),
(27102, '2017-04-15 10:08:04', NULL, NULL, 8500, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:08:04', 'admin-1492219535-14922220840861274', 1, 0, '', NULL, NULL, NULL),
(27103, '2017-04-15 09:25:14', NULL, NULL, 8498, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:25:14', 'admin-1492217881-14922195146259624', 1, 1, 'SR', NULL, NULL, NULL),
(27104, '2017-04-15 09:25:14', NULL, NULL, 8498, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:25:14', 'admin-1492217881-14922195146259624', 1, 0, '', NULL, NULL, NULL),
(27105, '2017-04-15 09:25:14', NULL, NULL, 8498, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:25:14', 'admin-1492217881-14922195146259624', 1, 0, '', NULL, NULL, NULL),
(27106, '2017-04-15 09:25:03', NULL, NULL, 8498, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:25:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27107, '2017-04-15 09:23:45', NULL, NULL, 8497, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:23:45', 'admin-1492217881-1492219425651333', 1, 1, 'SR', NULL, NULL, NULL),
(27108, '2017-04-15 09:23:45', NULL, NULL, 8497, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:23:45', 'admin-1492217881-1492219425651333', 1, 1, 'SR', NULL, NULL, NULL),
(27109, '2017-04-15 00:00:00', NULL, NULL, 8506, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, NULL, NULL, 2.70, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:08:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27110, '2017-04-15 10:21:15', NULL, NULL, 8507, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:21:15', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(27111, '2017-04-15 00:00:00', NULL, NULL, 8503, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:14:32', 'admin-1492217881-14922188719777690', 1, 0, '', NULL, NULL, NULL),
(27112, '2017-04-15 10:18:46', NULL, NULL, 8504, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:18:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27113, '2017-04-15 10:18:16', NULL, NULL, 8503, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1492237155', 'admin', '2017-04-15 10:18:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27114, '2017-04-15 00:00:00', NULL, NULL, 8506, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1492237155', 'admin', '2017-04-15 09:09:30', 'admin-1492217881-14922185699761964', 1, 0, '', NULL, NULL, NULL),
(27115, '2017-04-16 16:42:58', NULL, NULL, 8580, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1492321382', 'admin', '2017-04-16 16:42:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27116, '2017-04-16 13:44:55', NULL, NULL, 8571, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:44:55', 'admin-1492321382-14923214951937486', 1, 1, 'SR', NULL, NULL, NULL),
(27117, '2017-04-16 13:44:55', NULL, NULL, 8571, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:44:55', 'admin-1492321382-14923214951937486', 1, 0, '', NULL, NULL, NULL),
(27118, '2017-04-16 13:44:55', NULL, NULL, 8571, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:44:55', 'admin-1492321382-14923214951937486', 1, 0, '', NULL, NULL, NULL),
(27119, '2017-04-16 13:44:55', NULL, NULL, 8571, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:44:55', 'admin-1492321382-14923214951937486', 1, 1, 'SR', NULL, NULL, NULL),
(27120, '2017-04-16 13:50:31', NULL, NULL, 8572, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:50:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27121, '2017-04-16 13:51:51', NULL, NULL, 8572, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:51:51', 'admin-1492321382-14923219109741078', 1, 0, '', NULL, NULL, NULL),
(27122, '2017-04-16 13:51:51', NULL, NULL, 8572, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:51:51', 'admin-1492321382-14923219109741078', 1, 0, '', NULL, NULL, NULL),
(27123, '2017-04-16 13:52:39', NULL, NULL, 8572, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:52:39', 'admin-1492321382-1492321959042669', 1, 0, '', NULL, NULL, NULL),
(27124, '2017-04-16 13:52:39', NULL, NULL, 8572, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:52:39', 'admin-1492321382-1492321959042669', 1, 1, 'SR', NULL, NULL, NULL),
(27125, '2017-04-16 13:53:16', NULL, NULL, 8573, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:53:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27126, '2017-04-16 15:52:39', NULL, NULL, 8577, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 15:52:39', 'admin-1492321382-14923291594258481', 1, 1, 'SR', NULL, NULL, NULL),
(27127, '2017-04-16 15:54:25', NULL, NULL, 8577, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 15:54:25', 'admin-1492321382-1492329265552977', 1, 1, 'SR', NULL, NULL, NULL),
(27128, '2017-04-16 16:01:45', NULL, NULL, 8577, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 16:01:45', 'admin-1492321382-1492329704985574', 1, 1, 'SR', NULL, NULL, NULL),
(27129, '2017-04-16 16:01:45', NULL, NULL, 8577, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 16:01:45', 'admin-1492321382-1492329704985574', 1, 1, 'SR', NULL, NULL, NULL),
(27130, '2017-04-16 12:27:11', NULL, NULL, 8563, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:27:11', 'admin-1492315036-14923168312767983', 1, 1, 'SR', NULL, NULL, NULL),
(27131, '2017-04-16 12:27:11', NULL, NULL, 8563, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:27:11', 'admin-1492315036-14923168312767983', 1, 1, 'SR', NULL, NULL, NULL),
(27132, '2017-04-16 12:27:11', NULL, NULL, 8563, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:27:11', 'admin-1492315036-14923168312767983', 1, 1, 'SR', NULL, NULL, NULL),
(27133, '2017-04-16 12:27:11', NULL, NULL, 8563, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:27:11', 'admin-1492315036-14923168312767983', 1, 0, '', NULL, NULL, NULL),
(27134, '2017-04-16 11:46:51', NULL, NULL, 8559, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:46:51', 'admin-1492313698-1492314410921871', 1, 0, '', NULL, NULL, NULL),
(27135, '2017-04-16 11:04:33', NULL, NULL, 8548, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:04:33', 'admin-1492310042-14923118728106639', 1, 0, '', NULL, NULL, NULL),
(27136, '2017-04-16 11:04:33', NULL, NULL, 8548, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:04:33', 'admin-1492310042-14923118728106639', 1, 0, '', NULL, NULL, NULL),
(27137, '2017-04-16 11:08:50', NULL, NULL, 8549, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:08:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27138, '2017-04-16 11:09:07', NULL, NULL, 8549, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:09:07', 'admin-1492310042-14923121468893757', 1, 1, 'SR', NULL, NULL, NULL),
(27139, '2017-04-16 11:09:07', NULL, NULL, 8549, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:09:07', 'admin-1492310042-14923121468893757', 1, 1, 'SR', NULL, NULL, NULL),
(27140, '2017-04-16 11:09:07', NULL, NULL, 8549, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:09:07', 'admin-1492310042-14923121468893757', 1, 0, '', NULL, NULL, NULL),
(27141, '2017-04-16 11:12:47', NULL, NULL, 8551, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:12:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27142, '2017-04-16 11:12:56', NULL, NULL, 8551, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:12:56', 'admin-1492310042-1492312375971875', 1, 0, '', NULL, NULL, NULL),
(27143, '2017-04-16 11:12:56', NULL, NULL, 8551, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:12:56', 'admin-1492310042-1492312375971875', 1, 0, '', NULL, NULL, NULL),
(27144, '2017-04-16 11:12:56', NULL, NULL, 8551, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:12:56', 'admin-1492310042-1492312375971875', 1, 0, '', NULL, NULL, NULL),
(27145, '2017-04-16 11:14:40', NULL, NULL, 8550, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:14:40', 'admin-1492310042-1492312480322459', 1, 1, 'SR', NULL, NULL, NULL),
(27146, '2017-04-16 15:52:39', NULL, NULL, 8577, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 15:52:39', 'admin-1492321382-14923291594258481', 1, 0, '', NULL, NULL, NULL),
(27147, '2017-04-16 15:52:39', NULL, NULL, 8577, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 15:52:39', 'admin-1492321382-14923291594258481', 1, 1, 'SR', NULL, NULL, NULL),
(27148, '2017-04-16 15:52:39', NULL, NULL, 8577, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 15:52:39', 'admin-1492321382-14923291594258481', 1, 0, '', NULL, NULL, NULL),
(27149, '2017-04-16 15:52:39', NULL, NULL, 8577, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 15:52:39', 'admin-1492321382-14923291594258481', 1, 0, '', NULL, NULL, NULL),
(27150, '2017-04-16 10:37:38', NULL, NULL, 8542, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:37:38', 'admin-1492310042-14923102586667664', 1, 0, '', NULL, NULL, NULL),
(27151, '2017-04-16 10:38:41', NULL, NULL, 8543, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:38:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27152, '2017-04-16 10:39:01', NULL, NULL, 8543, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:39:01', 'admin-1492310042-14923103410081360', 1, 0, '', NULL, NULL, NULL),
(27153, '2017-04-16 10:39:01', NULL, NULL, 8543, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:39:01', 'admin-1492310042-14923103410081360', 1, 0, '', NULL, NULL, NULL),
(27154, '2017-04-16 16:43:07', NULL, NULL, 8580, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 16:43:07', 'admin-1492321382-14923321875447625', 1, 0, '', NULL, NULL, NULL),
(27155, '2017-04-16 12:18:40', NULL, NULL, 8562, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:18:40', 'admin-1492315036-14923163200024432', 1, 0, '', NULL, NULL, NULL),
(27156, '2017-04-16 12:18:40', NULL, NULL, 8562, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:18:40', 'admin-1492315036-14923163200024432', 1, 1, 'SR', NULL, NULL, NULL),
(27157, '2017-04-16 15:11:35', NULL, NULL, 8575, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 15:11:35', 'admin-1492321382-14923266954346585', 1, 1, 'SR', NULL, NULL, NULL),
(27158, '2017-04-16 12:31:39', NULL, NULL, 8556, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:31:39', 'admin-1492317061-14923170997271389', 1, 1, 'SR', NULL, NULL, NULL),
(27159, '2017-04-16 12:27:11', NULL, NULL, 8563, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:27:11', 'admin-1492315036-14923168312767983', 1, 1, 'SR', NULL, NULL, NULL),
(27160, '2017-04-16 12:27:11', NULL, NULL, 8563, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:27:11', 'admin-1492315036-14923168312767983', 1, 0, '', NULL, NULL, NULL),
(27161, '2017-04-16 12:23:15', NULL, NULL, 8550, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:23:15', 'admin-1492315036-1492316595259330', 1, 1, 'SR', NULL, NULL, NULL),
(27162, '2017-04-16 12:26:48', NULL, NULL, 8563, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.40, 0.0000, 0.0000, 12.40, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:26:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27163, '2017-04-16 16:02:36', NULL, NULL, 8578, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 16:02:36', 'admin-1492321382-14923297567835342', 1, 1, 'SR', NULL, NULL, NULL),
(27164, '2017-04-16 16:02:36', NULL, NULL, 8578, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 16:02:36', 'admin-1492321382-14923297567835342', 1, 0, '', NULL, NULL, NULL),
(27165, '2017-04-16 16:03:12', NULL, NULL, 8579, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1492321382', 'admin', '2017-04-16 16:03:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27166, '2017-04-16 16:03:30', NULL, NULL, 8579, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 16:03:30', 'admin-1492321382-14923298104998472', 1, 1, 'SR', NULL, NULL, NULL),
(27167, '2017-04-16 16:03:30', NULL, NULL, 8579, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 16:03:30', 'admin-1492321382-14923298104998472', 1, 1, 'SR', NULL, NULL, NULL),
(27168, '2017-04-16 16:14:36', NULL, NULL, 8579, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 16:14:36', 'admin-1492321382-14923304763108197', 1, 0, '', NULL, NULL, NULL),
(27169, '2017-04-16 16:16:34', NULL, NULL, 8576, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 16:16:34', 'admin-1492321382-14923305939819012', 1, 0, '', NULL, NULL, NULL),
(27170, '2017-04-16 16:16:34', NULL, NULL, 8576, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 16:16:34', 'admin-1492321382-14923305939819012', 1, 1, 'SR', NULL, NULL, NULL),
(27171, '2017-04-16 16:16:34', NULL, NULL, 8576, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 16:16:34', 'admin-1492321382-14923305939819012', 1, 1, 'SR', NULL, NULL, NULL),
(27172, '2017-04-16 16:01:55', NULL, NULL, 8578, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1492321382', 'admin', '2017-04-16 16:01:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27173, '2017-04-16 15:11:35', NULL, NULL, 8575, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 15:11:35', 'admin-1492321382-14923266954346585', 1, 0, '', NULL, NULL, NULL),
(27174, '2017-04-16 15:11:35', NULL, NULL, 8575, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 15:11:35', 'admin-1492321382-14923266954346585', 1, 1, 'SR', NULL, NULL, NULL),
(27175, '2017-04-16 14:27:02', NULL, NULL, 8574, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 14:27:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27176, '2017-04-16 14:27:58', NULL, NULL, 8574, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 14:27:58', 'admin-1492321382-1492324078252880', 1, 1, 'SR', NULL, NULL, NULL),
(27177, '2017-04-16 14:27:58', NULL, NULL, 8574, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 14:27:58', 'admin-1492321382-1492324078252880', 1, 0, '', NULL, NULL, NULL),
(27178, '2017-04-16 14:45:39', NULL, NULL, 8575, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 22.60, 0.0000, 0.0000, 22.60, 1, '27', 1, '1492321382', 'admin', '2017-04-16 14:45:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27179, '2017-04-16 14:45:49', NULL, NULL, 8575, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 14:45:49', 'admin-1492321382-14923251496694381', 1, 0, '', NULL, NULL, NULL),
(27180, '2017-04-16 14:45:49', NULL, NULL, 8575, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 14:45:49', 'admin-1492321382-14923251496694381', 1, 0, '', NULL, NULL, NULL),
(27181, '2017-04-16 14:45:49', NULL, NULL, 8575, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 14:45:49', 'admin-1492321382-14923251496694381', 1, 1, 'SR', NULL, NULL, NULL),
(27182, '2017-04-16 14:48:14', NULL, NULL, 8575, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 14:48:14', 'admin-1492321382-14923252946227954', 1, 1, 'SR', NULL, NULL, NULL),
(27183, '2017-04-16 12:30:43', NULL, NULL, 8564, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:30:43', 'admin-1492315036-14923170436385916', 1, 0, '', NULL, NULL, NULL),
(27184, '2017-04-16 12:30:43', NULL, NULL, 8564, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:30:43', 'admin-1492315036-14923170436385916', 1, 0, '', NULL, NULL, NULL),
(27185, '2017-04-16 12:30:43', NULL, NULL, 8564, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:30:43', 'admin-1492315036-14923170436385916', 1, 1, 'SR', NULL, NULL, NULL),
(27186, '2017-04-16 12:30:43', NULL, NULL, 8564, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:30:43', 'admin-1492315036-14923170436385916', 1, 1, 'SR', NULL, NULL, NULL),
(27187, '2017-04-16 12:30:43', NULL, NULL, 8564, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:30:43', 'admin-1492315036-14923170436385916', 1, 0, '', NULL, NULL, NULL),
(27188, '2017-04-16 12:30:43', NULL, NULL, 8564, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:30:43', 'admin-1492315036-14923170436385916', 1, 0, '', NULL, NULL, NULL),
(27189, '2017-04-16 15:49:54', NULL, NULL, 8575, NULL, 58, '58', 'House White Bottle', '', 'Cold Drinks', 'Wine', 1, 88.00, 88.0000, 0.0000, 88.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 15:49:54', 'admin-1492321382-14923289942837695', 1, 1, 'SR', NULL, NULL, NULL),
(27190, '2017-04-16 15:51:55', NULL, NULL, 8577, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1492321382', 'admin', '2017-04-16 15:51:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27191, '2017-04-16 13:28:00', NULL, NULL, 8568, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:28:00', 'admin-1492317061-1492320479930401', 1, 0, '', NULL, NULL, NULL),
(27192, '2017-04-16 13:29:17', NULL, NULL, 8569, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:29:17', 'admin-1492317061-1492320557622344', 1, 1, 'SR', 1, NULL, NULL),
(27193, '2017-04-16 13:29:17', NULL, NULL, 8569, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:29:17', 'admin-1492317061-1492320557622344', 1, 1, 'SR', 1, NULL, NULL),
(27194, '2017-04-16 13:29:17', NULL, NULL, 8569, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:29:17', 'admin-1492317061-1492320557622344', 1, 1, 'SR', 1, NULL, NULL),
(27195, '2017-04-16 15:38:56', NULL, NULL, 8576, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 15:38:56', 'admin-1492321382-14923283358851090', 1, 1, 'SR', NULL, NULL, NULL),
(27196, '2017-04-16 13:53:31', NULL, NULL, 8573, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:53:31', 'admin-1492321382-14923220116755155', 1, 1, 'SR', NULL, NULL, NULL),
(27197, '2017-04-16 12:27:11', NULL, NULL, 8563, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:27:11', 'admin-1492315036-14923168312767983', 1, 0, '', NULL, NULL, NULL),
(27198, '2017-04-16 12:27:11', NULL, NULL, 8563, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:27:11', 'admin-1492315036-14923168312767983', 1, 1, 'SR', NULL, NULL, NULL),
(27199, '2017-04-16 15:38:34', NULL, NULL, 8576, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1492321382', 'admin', '2017-04-16 15:38:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27200, '2017-04-16 15:38:56', NULL, NULL, 8576, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 15:38:56', 'admin-1492321382-14923283358851090', 1, 0, '', NULL, NULL, NULL),
(27201, '2017-04-16 15:38:56', NULL, NULL, 8576, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 15:38:56', 'admin-1492321382-14923283358851090', 1, 0, '', NULL, NULL, NULL),
(27202, '2017-04-16 12:54:18', NULL, NULL, 8556, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:54:18', 'admin-1492317061-14923184584764528', 1, 1, 'SR', NULL, NULL, NULL),
(27203, '2017-04-16 13:05:38', NULL, NULL, 8563, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:05:38', 'admin-1492317061-14923191382845684', 1, 0, '', NULL, NULL, NULL),
(27204, '2017-04-16 13:06:37', NULL, NULL, 8550, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:06:37', 'admin-1492317061-14923191977018385', 1, 1, 'SR', NULL, NULL, NULL),
(27205, '2017-04-16 13:13:59', NULL, NULL, 8566, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.49, 0.0000, 0.0000, 1.49, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:13:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27206, '2017-04-16 13:14:03', NULL, NULL, 8566, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:14:03', 'admin-1492317061-14923196427686640', 1, 1, 'SR', NULL, NULL, NULL),
(27207, '2017-04-16 13:20:40', NULL, NULL, 8566, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:20:40', 'admin-1492317061-1492320040102565', 1, 0, '', NULL, NULL, NULL),
(27208, '2017-04-16 13:27:33', NULL, NULL, 8567, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:27:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27209, '2017-04-16 13:27:41', NULL, NULL, 8567, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:27:41', 'admin-1492317061-14923204611302517', 1, 1, 'SR', NULL, NULL, NULL),
(27210, '2017-04-16 13:27:56', NULL, NULL, 8568, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:27:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27211, '2017-04-16 12:31:39', NULL, NULL, 8556, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:31:39', 'admin-1492317061-14923170997271389', 1, 1, 'SR', NULL, NULL, NULL),
(27212, '2017-04-16 12:35:40', NULL, NULL, 8565, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:35:40', 'admin-1492317061-14923173404187688', 1, 0, '', 1, NULL, NULL),
(27213, '2017-04-16 11:35:42', NULL, NULL, 8554, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:35:42', 'admin-1492313698-14923137427705988', 1, 0, '', NULL, NULL, NULL),
(27214, '2017-04-16 11:35:42', NULL, NULL, 8554, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:35:42', 'admin-1492313698-14923137427705988', 1, 0, '', NULL, NULL, NULL),
(27215, '2017-04-16 11:37:38', NULL, NULL, 8555, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:37:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27216, '2017-04-16 11:37:42', NULL, NULL, 8555, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:37:42', 'admin-1492313698-14923138617775831', 1, 0, '', NULL, NULL, NULL),
(27217, '2017-04-16 11:37:48', NULL, NULL, 8548, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:37:48', 'admin-1492313698-14923138686964195', 1, 0, '', NULL, NULL, NULL),
(27218, '2017-04-16 11:38:29', NULL, NULL, 8556, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:38:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27219, '2017-04-16 11:38:33', NULL, NULL, 8556, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:38:33', 'admin-1492313698-14923139137665015', 1, 1, 'SR', NULL, NULL, NULL),
(27220, '2017-04-16 11:39:30', NULL, NULL, 8557, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:39:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27221, '2017-04-16 12:30:17', NULL, NULL, 8564, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:30:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27222, '2017-04-16 10:41:40', NULL, NULL, 8544, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:41:40', 'admin-1492310042-1492310499904644', 1, 0, '', NULL, NULL, NULL),
(27223, '2017-04-16 10:41:40', NULL, NULL, 8544, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:41:40', 'admin-1492310042-1492310499904644', 1, 1, 'SR', NULL, NULL, NULL),
(27224, '2017-04-16 10:41:40', NULL, NULL, 8544, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:41:40', 'admin-1492310042-1492310499904644', 1, 0, '', NULL, NULL, NULL),
(27225, '2017-04-16 10:47:11', NULL, NULL, 8545, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.60, 0.0000, 0.0000, 11.60, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:47:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27226, '2017-04-16 10:47:19', NULL, NULL, 8545, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:47:19', 'admin-1492310042-14923108391201633', 1, 0, '', NULL, NULL, NULL),
(27227, '2017-04-16 10:47:19', NULL, NULL, 8545, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:47:19', 'admin-1492310042-14923108391201633', 1, 0, '', NULL, NULL, NULL),
(27228, '2017-04-16 10:47:19', NULL, NULL, 8545, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:47:19', 'admin-1492310042-14923108391201633', 1, 1, 'SR', NULL, NULL, NULL),
(27229, '2017-04-16 13:44:55', NULL, NULL, 8571, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:44:55', 'admin-1492321382-14923214951937486', 1, 1, 'SR', NULL, NULL, NULL),
(27230, '2017-04-16 11:52:52', NULL, NULL, 8560, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:52:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27231, '2017-04-16 12:09:51', NULL, NULL, 8561, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:09:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27232, '2017-04-16 11:53:09', NULL, NULL, 8560, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:53:09', 'admin-1492313698-1492314789342486', 1, 0, '', NULL, NULL, NULL),
(27233, '2017-04-16 11:53:09', NULL, NULL, 8560, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:53:09', 'admin-1492313698-1492314789342486', 1, 0, '', NULL, NULL, NULL),
(27234, '2017-04-16 11:57:10', NULL, NULL, 8555, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:57:10', 'admin-1492313698-14923150299337411', 1, 0, '', NULL, NULL, NULL),
(27235, '2017-04-16 11:58:06', NULL, NULL, 8548, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:58:06', 'admin-1492315036-14923150858843487', 1, 0, '', NULL, NULL, NULL),
(27236, '2017-04-16 12:10:06', NULL, NULL, 8561, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:10:06', 'admin-1492315036-14923158067589492', 1, 0, '', NULL, NULL, NULL),
(27237, '2017-04-16 12:10:06', NULL, NULL, 8561, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:10:06', 'admin-1492315036-14923158067589492', 1, 1, 'SR', NULL, NULL, NULL),
(27238, '2017-04-16 12:10:06', NULL, NULL, 8561, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:10:06', 'admin-1492315036-14923158067589492', 1, 0, '', NULL, NULL, NULL),
(27239, '2017-04-16 12:10:06', NULL, NULL, 8561, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:10:06', 'admin-1492315036-14923158067589492', 1, 1, 'SR', NULL, NULL, NULL),
(27240, '2017-04-16 12:10:18', NULL, NULL, 8550, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:10:18', 'admin-1492315036-14923158184615567', 1, 0, '', NULL, NULL, NULL),
(27241, '2017-04-16 12:10:18', NULL, NULL, 8550, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:10:18', 'admin-1492315036-14923158184615567', 1, 0, '', NULL, NULL, NULL),
(27242, '2017-04-16 12:10:34', NULL, NULL, 8555, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:10:34', 'admin-1492315036-1492315834134171', 1, 0, '', NULL, NULL, NULL),
(27243, '2017-04-16 12:11:13', NULL, NULL, 8550, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:11:13', 'admin-1492315036-14923158729845817', 1, 0, '', NULL, NULL, NULL),
(27244, '2017-04-16 12:14:31', NULL, NULL, 8545, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:14:31', 'admin-1492315036-14923160712972372', 1, 1, 'SR', NULL, NULL, NULL),
(27245, '2017-04-16 12:18:40', NULL, NULL, 8562, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:18:40', 'admin-1492315036-14923163200024432', 1, 0, '', NULL, NULL, NULL),
(27246, '2017-04-16 12:14:31', NULL, NULL, 8545, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:14:31', 'admin-1492315036-14923160712972372', 1, 0, '', NULL, NULL, NULL),
(27247, '2017-04-16 12:18:29', NULL, NULL, 8562, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1492321382', 'admin', '2017-04-16 12:18:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27248, '2017-04-16 13:44:15', NULL, NULL, 8571, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1492321382', 'admin', '2017-04-16 13:44:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27249, '2017-04-16 11:29:28', NULL, NULL, 8553, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:29:28', 'admin-1492313316-14923133680484060', 1, 0, '', NULL, NULL, NULL),
(27250, '2017-04-16 11:29:51', NULL, NULL, 8550, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:29:51', 'admin-1492313316-14923133916615360', 1, 1, 'SR', NULL, NULL, NULL),
(27251, '2017-04-16 11:31:08', NULL, NULL, 8545, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:31:08', 'admin-1492313316-14923134679129439', 1, 0, '', NULL, NULL, NULL),
(27252, '2017-04-16 10:39:01', NULL, NULL, 8543, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:39:01', 'admin-1492310042-14923103410081360', 1, 1, 'SR', NULL, NULL, NULL),
(27253, '2017-04-16 10:41:23', NULL, NULL, 8544, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:41:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27254, '2017-04-16 10:41:40', NULL, NULL, 8544, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:41:40', 'admin-1492310042-1492310499904644', 1, 0, '', NULL, NULL, NULL),
(27255, '2017-04-16 11:44:26', NULL, NULL, 8558, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:44:26', 'admin-1492313698-1492314266689440', 1, 1, 'SR', 1, NULL, NULL),
(27256, '2017-04-16 11:45:45', NULL, NULL, 8559, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:45:45', 'admin-1492313698-14923143455103824', 1, 0, '', NULL, NULL, NULL),
(27257, '2017-04-16 11:39:43', NULL, NULL, 8557, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:39:43', 'admin-1492313698-14923139824604060', 1, 1, 'SR', NULL, NULL, NULL),
(27258, '2017-04-16 11:39:43', NULL, NULL, 8557, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:39:43', 'admin-1492313698-14923139824604060', 1, 0, '', NULL, NULL, NULL),
(27259, '2017-04-16 11:39:43', NULL, NULL, 8557, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:39:43', 'admin-1492313698-14923139824604060', 1, 0, '', NULL, NULL, NULL),
(27260, '2017-04-16 09:06:47', NULL, NULL, 8533, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:06:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27261, '2017-04-16 11:39:43', NULL, NULL, 8557, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:39:43', 'admin-1492313698-14923139824604060', 1, 0, '', NULL, NULL, NULL),
(27262, '2017-04-16 11:39:43', NULL, NULL, 8557, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:39:43', 'admin-1492313698-14923139824604060', 1, 0, '', NULL, NULL, NULL),
(27263, '2017-04-16 11:29:23', NULL, NULL, 8553, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:29:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27264, '2017-04-16 11:29:28', NULL, NULL, 8553, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:29:28', 'admin-1492313316-14923133680484060', 1, 1, 'SR', NULL, NULL, NULL),
(27265, '2017-04-16 10:58:07', NULL, NULL, 8547, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:58:07', 'admin-1492310042-1492311487135441', 1, 1, 'SR', NULL, NULL, NULL),
(27266, '2017-04-16 10:58:07', NULL, NULL, 8547, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:58:07', 'admin-1492310042-1492311487135441', 1, 0, '', NULL, NULL, NULL),
(27267, '2017-04-16 11:31:08', NULL, NULL, 8545, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:31:08', 'admin-1492313316-14923134679129439', 1, 1, 'SR', NULL, NULL, NULL),
(27268, '2017-04-16 11:31:08', NULL, NULL, 8545, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:31:08', 'admin-1492313316-14923134679129439', 1, 0, '', NULL, NULL, NULL),
(27269, '2017-04-16 11:26:40', NULL, NULL, 8552, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:26:40', 'admin-1492310042-14923132005245654', 1, 0, '', NULL, NULL, NULL),
(27270, '2017-04-16 10:55:19', NULL, NULL, 8546, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:55:19', 'admin-1492310042-14923113190512493', 1, 0, '', NULL, NULL, NULL),
(27271, '2017-04-16 11:26:40', NULL, NULL, 8552, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:26:40', 'admin-1492310042-14923132005245654', 1, 0, '', NULL, NULL, NULL),
(27272, '2017-04-16 11:26:40', NULL, NULL, 8552, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:26:40', 'admin-1492310042-14923132005245654', 1, 1, 'SR', NULL, NULL, NULL),
(27273, '2017-04-16 11:26:40', NULL, NULL, 8552, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:26:40', 'admin-1492310042-14923132005245654', 1, 1, 'SR', NULL, NULL, NULL),
(27274, '2017-04-16 11:26:30', NULL, NULL, 8552, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:26:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27275, '2017-04-16 11:14:40', NULL, NULL, 8550, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:14:40', 'admin-1492310042-1492312480322459', 1, 1, 'SR', NULL, NULL, NULL),
(27276, '2017-04-16 10:37:38', NULL, NULL, 8542, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:37:38', 'admin-1492310042-14923102586667664', 1, 1, 'SR', NULL, NULL, NULL),
(27277, '2017-04-16 10:37:38', NULL, NULL, 8542, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:37:38', 'admin-1492310042-14923102586667664', 1, 1, 'SR', NULL, NULL, NULL),
(27278, '2017-04-16 10:55:19', NULL, NULL, 8546, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:55:19', 'admin-1492310042-14923113190512493', 1, 0, '', NULL, NULL, NULL),
(27279, '2017-04-16 10:55:08', NULL, NULL, 8546, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:55:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27280, '2017-04-16 10:57:54', NULL, NULL, 8547, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:57:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27281, '2017-04-16 11:35:30', NULL, NULL, 8554, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:35:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27282, '2017-04-16 11:35:42', NULL, NULL, 8554, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:35:42', 'admin-1492313698-14923137427705988', 1, 0, '', NULL, NULL, NULL),
(27283, '2017-04-16 11:12:45', NULL, NULL, 8550, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:12:45', 'admin-1492310042-14923123648395828', 1, 0, '', NULL, NULL, NULL),
(27284, '2017-04-16 11:12:45', NULL, NULL, 8550, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:12:45', 'admin-1492310042-14923123648395828', 1, 0, '', NULL, NULL, NULL),
(27285, '2017-04-16 09:53:17', NULL, NULL, 8538, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:53:17', 'admin-1492303857-14923075973163315', 1, 1, 'SR', NULL, NULL, NULL),
(27286, '2017-04-16 11:12:29', NULL, NULL, 8550, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.10, 0.0000, 0.0000, 12.10, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:12:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27287, '2017-04-16 11:09:25', NULL, NULL, 8548, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:09:25', 'admin-1492310042-14923121654713773', 1, 0, '', NULL, NULL, NULL),
(27288, '2017-04-16 11:09:25', NULL, NULL, 8548, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:09:25', 'admin-1492310042-14923121654713773', 1, 1, 'SR', NULL, NULL, NULL),
(27289, '2017-04-16 11:09:25', NULL, NULL, 8548, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:09:25', 'admin-1492310042-14923121654713773', 1, 0, '', NULL, NULL, NULL),
(27290, '2017-04-16 11:09:07', NULL, NULL, 8549, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:09:07', 'admin-1492310042-14923121468893757', 1, 0, '', NULL, NULL, NULL),
(27291, '2017-04-16 11:09:07', NULL, NULL, 8549, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:09:07', 'admin-1492310042-14923121468893757', 1, 0, '', NULL, NULL, NULL),
(27292, '2017-04-16 11:09:07', NULL, NULL, 8549, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:09:07', 'admin-1492310042-14923121468893757', 1, 1, 'SR', NULL, NULL, NULL),
(27293, '2017-04-16 11:09:07', NULL, NULL, 8549, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:09:07', 'admin-1492310042-14923121468893757', 1, 0, '', NULL, NULL, NULL),
(27294, '2017-04-16 11:04:33', NULL, NULL, 8548, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:04:33', 'admin-1492310042-14923118728106639', 1, 0, '', NULL, NULL, NULL),
(27295, '2017-04-16 11:04:33', NULL, NULL, 8548, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:04:33', 'admin-1492310042-14923118728106639', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(27296, '2017-04-16 10:58:07', NULL, NULL, 8547, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:58:07', 'admin-1492310042-1492311487135441', 1, 0, '', NULL, NULL, NULL),
(27297, '2017-04-16 10:58:07', NULL, NULL, 8547, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:58:07', 'admin-1492310042-1492311487135441', 1, 1, 'SR', NULL, NULL, NULL),
(27298, '2017-04-16 11:04:20', NULL, NULL, 8548, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.80, 0.0000, 0.0000, 13.80, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:04:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27299, '2017-04-16 11:04:33', NULL, NULL, 8548, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:04:33', 'admin-1492310042-14923118728106639', 1, 0, '', NULL, NULL, NULL),
(27300, '2017-04-16 11:45:24', NULL, NULL, 8559, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1492321382', 'admin', '2017-04-16 11:45:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27301, '2017-04-16 10:58:07', NULL, NULL, 8547, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:58:07', 'admin-1492310042-1492311487135441', 1, 1, 'SR', NULL, NULL, NULL),
(27302, '2017-04-16 09:25:06', NULL, NULL, 8534, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:25:06', 'admin-1492303857-14923059062011523', 1, 0, '', NULL, NULL, NULL),
(27303, '2017-04-16 10:25:43', NULL, NULL, 8540, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:25:43', 'admin-1492303857-14923095432973471', 1, 0, '', 1, NULL, NULL),
(27304, '2017-04-16 10:25:43', NULL, NULL, 8540, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:25:43', 'admin-1492303857-14923095432973471', 1, 0, '', 1, NULL, NULL),
(27305, '2017-04-16 10:25:43', NULL, NULL, 8540, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:25:43', 'admin-1492303857-14923095432973471', 1, 0, '', 1, NULL, NULL),
(27306, '2017-04-16 10:25:43', NULL, NULL, 8540, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:25:43', 'admin-1492303857-14923095432973471', 1, 0, '', 1, NULL, NULL),
(27307, '2017-04-16 09:54:29', NULL, NULL, 8539, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:54:29', 'admin-1492303857-14923076695185067', 1, 1, 'SR', NULL, NULL, NULL),
(27308, '2017-04-16 09:35:42', NULL, NULL, 8536, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:35:42', 'admin-1492303857-14923065426188611', 1, 0, '', NULL, NULL, NULL),
(27309, '2017-04-16 09:35:42', NULL, NULL, 8536, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:35:42', 'admin-1492303857-14923065426188611', 1, 0, '', NULL, NULL, NULL),
(27310, '2017-04-16 09:35:42', NULL, NULL, 8536, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:35:42', 'admin-1492303857-14923065426188611', 1, 0, '', NULL, NULL, NULL),
(27311, '2017-04-16 09:35:42', NULL, NULL, 8536, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:35:42', 'admin-1492303857-14923065426188611', 1, 0, '', NULL, NULL, NULL),
(27312, '2017-04-16 09:35:47', NULL, NULL, 8536, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:35:47', 'admin-1492303857-14923065471741348', 1, 1, 'SR', NULL, NULL, NULL),
(27313, '2017-04-16 09:35:47', NULL, NULL, 8536, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:35:47', 'admin-1492303857-14923065471741348', 1, 1, 'SR', NULL, NULL, NULL),
(27314, '2017-04-16 09:42:13', NULL, NULL, 8536, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:42:13', 'admin-1492303857-14923069329317367', 1, 0, '', NULL, NULL, NULL),
(27315, '2017-04-16 09:43:13', NULL, NULL, 8537, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:43:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27316, '2017-04-16 09:43:34', NULL, NULL, 8537, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 3, 8.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:43:34', 'admin-1492303857-14923070141223116', 1, 0, '', NULL, NULL, NULL),
(27317, '2017-04-16 09:43:34', NULL, NULL, 8537, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:43:34', 'admin-1492303857-14923070141223116', 1, 1, 'SR', NULL, NULL, NULL),
(27318, '2017-04-16 09:43:34', NULL, NULL, 8537, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:43:34', 'admin-1492303857-14923070141223116', 1, 1, 'SR', NULL, NULL, NULL),
(27319, '2017-04-16 09:44:59', NULL, NULL, 8537, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:44:59', 'admin-1492303857-14923070993088351', 1, 0, '', NULL, NULL, NULL),
(27320, '2017-04-16 10:39:01', NULL, NULL, 8543, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:39:01', 'admin-1492310042-14923103410081360', 1, 0, '', NULL, NULL, NULL),
(27321, '2017-04-16 10:32:24', NULL, NULL, 8541, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:32:24', 'admin-1492303857-14923099445761944', 1, 1, 'SR', NULL, NULL, NULL),
(27322, '2017-04-16 10:32:24', NULL, NULL, 8541, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:32:24', 'admin-1492303857-14923099445761944', 1, 0, '', NULL, NULL, NULL),
(27323, '2017-04-16 10:32:24', NULL, NULL, 8541, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:32:24', 'admin-1492303857-14923099445761944', 1, 0, '', NULL, NULL, NULL),
(27324, '2017-04-16 10:32:24', NULL, NULL, 8541, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:32:24', 'admin-1492303857-14923099445761944', 1, 0, '', NULL, NULL, NULL),
(27325, '2017-04-16 10:30:56', NULL, NULL, 8541, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:30:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27326, '2017-04-16 10:07:50', NULL, NULL, 8537, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:07:50', 'admin-1492303857-1492308470272440', 1, 0, '', NULL, NULL, NULL),
(27327, '2017-04-16 09:54:29', NULL, NULL, 8539, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:54:29', 'admin-1492303857-14923076695185067', 1, 1, 'SR', NULL, NULL, NULL),
(27328, '2017-04-16 10:50:01', NULL, NULL, 8545, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:50:02', 'admin-1492310042-14923110018175065', 1, 0, '', NULL, NULL, NULL),
(27329, '2017-04-16 10:36:08', NULL, NULL, 8542, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1492321382', 'admin', '2017-04-16 10:36:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27330, '2017-04-16 09:54:21', NULL, NULL, 8539, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:54:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27331, '2017-04-16 09:53:17', NULL, NULL, 8538, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:53:17', 'admin-1492303857-14923075973163315', 1, 1, 'SR', NULL, NULL, NULL),
(27332, '2017-04-16 09:54:29', NULL, NULL, 8539, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:54:29', 'admin-1492303857-14923076695185067', 1, 0, '', NULL, NULL, NULL),
(27333, '2017-04-16 09:53:08', NULL, NULL, 8538, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:53:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27334, '2017-04-16 09:53:17', NULL, NULL, 8538, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:53:17', 'admin-1492303857-14923075973163315', 1, 0, '', NULL, NULL, NULL),
(27335, '2017-04-16 09:53:17', NULL, NULL, 8538, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:53:17', 'admin-1492303857-14923075973163315', 1, 0, '', NULL, NULL, NULL),
(27336, '2017-04-16 09:35:42', NULL, NULL, 8536, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:35:42', 'admin-1492303857-14923065426188611', 1, 0, '', NULL, NULL, NULL),
(27337, '2017-04-16 09:35:20', NULL, NULL, 8536, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.10, 0.0000, 0.0000, 10.10, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:35:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27338, '2017-04-16 09:29:39', NULL, NULL, 8535, 0, 181, '116', 'Open Food ', 'banana', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:29:39', 'admin-1492303857-14923061790167373', 1, 0, '', NULL, NULL, NULL),
(27339, '2017-04-16 09:29:39', NULL, NULL, 8535, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:29:39', 'admin-1492303857-14923061790167373', 1, 1, 'SR', NULL, NULL, NULL),
(27340, '2017-04-16 09:25:06', NULL, NULL, 8534, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:25:06', 'admin-1492303857-14923059062011523', 1, 1, 'SR', NULL, NULL, NULL),
(27341, '2017-04-16 09:29:28', NULL, NULL, 8535, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.25, 0.0000, 0.0000, 1.25, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:29:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27342, '2017-04-16 09:25:06', NULL, NULL, 8534, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:25:06', 'admin-1492303857-14923059062011523', 1, 1, 'SR', NULL, NULL, NULL),
(27343, '2017-04-16 09:25:06', NULL, NULL, 8534, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:25:06', 'admin-1492303857-14923059062011523', 1, 0, '', NULL, NULL, NULL),
(27344, '2017-04-16 09:20:54', NULL, NULL, 8534, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:20:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27345, '2017-04-16 09:06:53', NULL, NULL, 8533, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:06:53', 'admin-1492303857-14923048131378054', 1, 0, '', NULL, NULL, NULL),
(27346, '2017-04-16 09:06:53', NULL, NULL, 8533, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492321382', 'admin', '2017-04-16 09:06:53', 'admin-1492303857-14923048131378054', 1, 0, '', NULL, NULL, NULL),
(27347, '2017-04-22 16:03:51', NULL, NULL, 8620, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 16:03:51', 'admin-1492841155-14928482316383968', 1, 0, '', NULL, NULL, NULL),
(27348, '2017-04-22 14:34:15', NULL, NULL, 8615, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 14:34:15', 'admin-1492841155-14928428554629329', 1, 1, 'SR', NULL, NULL, '10.0'),
(27349, '2017-04-22 14:37:58', NULL, NULL, 8615, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 14:37:58', 'admin-1492841155-14928430785369395', 1, 0, '', NULL, NULL, '10.0'),
(27350, '2017-04-22 14:37:58', NULL, NULL, 8615, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 14:37:58', 'admin-1492841155-14928430785369395', 1, 1, 'SR', NULL, NULL, '10.0'),
(27351, '2017-04-22 14:50:44', NULL, NULL, 8616, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.40, 0.0000, 0.0000, 12.40, 1, '27', 1, '1492841155', 'admin', '2017-04-22 14:50:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27352, '2017-04-22 14:50:54', NULL, NULL, 8616, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 14:50:54', 'admin-1492841155-14928438538138311', 1, 0, '', NULL, NULL, NULL),
(27353, '2017-04-22 12:54:42', NULL, NULL, 8602, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:54:42', 'admin-1492835891-14928368822369881', 1, 1, 'SR', NULL, NULL, NULL),
(27354, '2017-04-22 12:54:42', NULL, NULL, 8602, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:54:42', 'admin-1492835891-14928368822369881', 1, 0, '', NULL, NULL, NULL),
(27355, '2017-04-22 12:54:42', NULL, NULL, 8602, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:54:42', 'admin-1492835891-14928368822369881', 1, 1, 'SR', NULL, NULL, NULL),
(27356, '2017-04-22 12:54:42', NULL, NULL, 8602, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:54:42', 'admin-1492835891-14928368822369881', 1, 1, 'SR', NULL, NULL, NULL),
(27357, '2017-04-22 13:11:24', NULL, NULL, 8604, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:11:24', 'admin-1492835891-14928378843709845', 1, 1, 'SR', NULL, NULL, NULL),
(27358, '2017-04-22 13:15:52', NULL, NULL, 8605, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:15:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27359, '2017-04-22 00:00:00', NULL, NULL, 8612, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:37:47', 'admin-1492832694-14928358667861473', 1, 0, '', NULL, NULL, NULL),
(27360, '2017-04-22 13:41:39', NULL, NULL, 8610, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:41:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27361, '2017-04-22 00:00:00', NULL, NULL, 8611, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:37:47', 'admin-1492832694-14928358667861473', 1, 1, 'SR', NULL, NULL, NULL),
(27362, '2017-04-22 12:45:35', NULL, NULL, 8600, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:45:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27363, '2017-04-22 12:47:08', NULL, NULL, 8600, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:47:08', 'admin-1492835891-14928364282948990', 1, 0, '', NULL, NULL, NULL),
(27364, '2017-04-22 12:47:08', NULL, NULL, 8600, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:47:08', 'admin-1492835891-14928364282948990', 1, 0, '', NULL, NULL, NULL),
(27365, '2017-04-22 10:27:07', NULL, NULL, 8589, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:27:07', 'admin-1492823426-14928280274367581', 1, 1, 'SR', NULL, NULL, NULL),
(27366, '2017-04-22 13:59:52', NULL, NULL, 8613, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:59:52', 'admin-1492835891-14928407927527077', 1, 0, '', NULL, NULL, NULL),
(27367, '2017-04-22 12:29:38', NULL, NULL, 8598, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:29:38', 'admin-1492832694-1492835378226837', 1, 1, 'SR', NULL, NULL, NULL),
(27368, '2017-04-22 13:42:32', NULL, NULL, 8611, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:42:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27369, '2017-04-22 00:00:00', NULL, NULL, 8612, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:38:29', 'admin-1492835891-14928359093835456', 1, 1, 'SR', NULL, NULL, NULL),
(27370, '2017-04-22 13:58:40', NULL, NULL, 8613, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.75, 0.0000, 0.0000, 3.75, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:58:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27371, '2017-04-22 16:03:51', NULL, NULL, 8620, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 16:03:51', 'admin-1492841155-14928482316383968', 1, 1, 'SR', NULL, NULL, NULL),
(27372, '2017-04-22 16:03:51', NULL, NULL, 8620, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 16:03:51', 'admin-1492841155-14928482316383968', 1, 0, '', NULL, NULL, NULL),
(27373, '2017-04-22 12:15:54', NULL, NULL, 8597, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:15:54', 'admin-1492832694-14928345542027926', 1, 1, 'SR', NULL, NULL, NULL),
(27374, '2017-04-22 16:03:39', NULL, NULL, 8620, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1492841155', 'admin', '2017-04-22 16:03:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27375, '2017-04-22 14:50:54', NULL, NULL, 8616, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 14:50:54', 'admin-1492841155-14928438538138311', 1, 0, '', NULL, NULL, NULL),
(27376, '2017-04-22 14:50:54', NULL, NULL, 8616, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 14:50:54', 'admin-1492841155-14928438538138311', 1, 0, '', NULL, NULL, NULL),
(27377, '2017-04-22 14:50:59', NULL, NULL, 8616, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 14:50:59', 'admin-1492841155-14928438589898148', 1, 0, '', NULL, NULL, NULL),
(27378, '2017-04-22 14:51:37', NULL, NULL, 8616, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 14:51:37', 'admin-1492841155-14928438977195086', 1, 0, '', NULL, NULL, NULL),
(27379, '2017-04-22 14:51:37', NULL, NULL, 8616, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 14:51:37', 'admin-1492841155-14928438977195086', 1, 1, 'SR', NULL, NULL, NULL),
(27380, '2017-04-22 15:47:52', NULL, NULL, 8617, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1492841155', 'admin', '2017-04-22 15:47:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27381, '2017-04-22 15:47:56', NULL, NULL, 8617, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 15:47:56', 'admin-1492841155-14928472767228187', 1, 0, '', NULL, NULL, NULL),
(27382, '2017-04-22 15:52:54', NULL, NULL, 8618, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 15:52:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27383, '2017-04-22 15:53:11', NULL, NULL, 8618, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 15:53:11', 'admin-1492841155-14928475917551981', 1, 0, '', NULL, NULL, NULL),
(27384, '2017-04-22 15:53:11', NULL, NULL, 8618, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 15:53:11', 'admin-1492841155-14928475917551981', 1, 1, 'SR', NULL, NULL, NULL),
(27385, '2017-04-22 15:54:23', NULL, NULL, 8619, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1492841155', 'admin', '2017-04-22 15:54:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27386, '2017-04-22 00:00:00', NULL, NULL, 8611, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:39:02', 'admin-1492835891-14928359420499882', 1, 1, 'SR', NULL, NULL, NULL),
(27387, '2017-04-22 12:47:08', NULL, NULL, 8600, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:47:08', 'admin-1492835891-14928364282948990', 1, 1, 'SR', NULL, NULL, NULL),
(27388, '2017-04-22 12:47:08', NULL, NULL, 8600, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:47:08', 'admin-1492835891-14928364282948990', 1, 0, '', NULL, NULL, NULL),
(27389, '2017-04-22 12:47:08', NULL, NULL, 8600, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:47:08', 'admin-1492835891-14928364282948990', 1, 0, '', NULL, NULL, NULL),
(27390, '2017-04-22 12:47:08', NULL, NULL, 8600, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:47:08', 'admin-1492835891-14928364282948990', 1, 1, 'SR', NULL, NULL, NULL),
(27391, '2017-04-22 12:51:42', NULL, NULL, 8601, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:51:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27392, '2017-04-22 12:51:47', NULL, NULL, 8601, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:51:47', 'admin-1492835891-14928367072995780', 1, 1, 'SR', NULL, NULL, NULL),
(27393, '2017-04-22 13:40:48', NULL, NULL, 8608, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:40:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27394, '2017-04-22 12:54:05', NULL, NULL, 8602, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.10, 0.0000, 0.0000, 15.10, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:54:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27395, '2017-04-22 16:23:52', NULL, NULL, 8622, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 16:23:52', 'admin-1492841155-14928494324429621', 1, 0, '', 1, NULL, NULL),
(27396, '2017-04-22 16:04:13', NULL, NULL, 8621, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 16:04:13', 'admin-1492841155-14928482534753642', 1, 1, 'SR', NULL, NULL, NULL),
(27397, '2017-04-22 16:04:13', NULL, NULL, 8621, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 16:04:13', 'admin-1492841155-14928482534753642', 1, 1, 'SR', NULL, NULL, NULL),
(27398, '2017-04-22 16:03:54', NULL, NULL, 8621, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1492841155', 'admin', '2017-04-22 16:03:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27399, '2017-04-22 13:11:18', NULL, NULL, 8603, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:11:18', 'admin-1492835891-1492837878513117', 1, 1, 'SR', NULL, NULL, NULL),
(27400, '2017-04-22 13:11:18', NULL, NULL, 8603, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:11:18', 'admin-1492835891-1492837878513117', 1, 1, 'SR', NULL, NULL, NULL),
(27401, '2017-04-22 13:11:18', NULL, NULL, 8603, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:11:18', 'admin-1492835891-1492837878513117', 1, 1, 'SR', NULL, NULL, NULL),
(27402, '2017-04-22 13:11:21', NULL, NULL, 8604, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:11:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27403, '2017-04-22 11:54:56', NULL, NULL, 8594, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1492841155', 'admin', '2017-04-22 11:54:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27404, '2017-04-22 11:55:52', NULL, NULL, 8594, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 11:55:52', 'admin-1492832694-14928333520562286', 1, 0, '', NULL, NULL, NULL),
(27405, '2017-04-22 11:55:52', NULL, NULL, 8594, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 11:55:52', 'admin-1492832694-14928333520562286', 1, 0, '', NULL, NULL, NULL),
(27406, '2017-04-22 11:55:52', NULL, NULL, 8594, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 11:55:52', 'admin-1492832694-14928333520562286', 1, 0, '', NULL, NULL, NULL),
(27407, '2017-04-22 11:55:52', NULL, NULL, 8594, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 11:55:52', 'admin-1492832694-14928333520562286', 1, 0, '', NULL, NULL, NULL),
(27408, '2017-04-22 11:56:10', NULL, NULL, 8594, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 11:56:10', 'admin-1492832694-14928333701336042', 1, 1, 'SR', NULL, NULL, NULL),
(27409, '2017-04-22 11:56:10', NULL, NULL, 8594, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 11:56:10', 'admin-1492832694-14928333701336042', 1, 1, 'SR', NULL, NULL, NULL),
(27410, '2017-04-22 11:56:14', NULL, NULL, 8595, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1492841155', 'admin', '2017-04-22 11:56:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27411, '2017-04-22 11:56:25', NULL, NULL, 8595, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 11:56:25', 'admin-1492832694-14928333851344949', 1, 0, '', NULL, NULL, NULL),
(27412, '2017-04-22 11:56:25', NULL, NULL, 8595, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 11:56:25', 'admin-1492832694-14928333851344949', 1, 0, '', NULL, NULL, NULL),
(27413, '2017-04-22 16:00:39', NULL, NULL, 8619, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 16:00:39', 'admin-1492841155-14928480391375361', 1, 1, 'SR', NULL, NULL, NULL),
(27414, '2017-04-22 16:03:51', NULL, NULL, 8620, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 16:03:51', 'admin-1492841155-14928482316383968', 1, 1, 'SR', NULL, NULL, NULL),
(27415, '2017-04-22 16:00:44', NULL, NULL, 8616, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 16:00:44', 'admin-1492841155-1492848044019737', 1, 0, '', NULL, NULL, NULL),
(27416, '2017-04-22 14:50:54', NULL, NULL, 8616, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 14:50:54', 'admin-1492841155-14928438538138311', 1, 1, 'SR', NULL, NULL, NULL),
(27417, '2017-04-22 13:59:52', NULL, NULL, 8613, 0, 182, '117', 'Open Drinks ', 'Coke Float', 'Cold Drinks', 'Fresh Juice', 1, 7.50, 7.5000, 0.0000, 7.50, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:59:52', 'admin-1492835891-14928407927527077', 1, 0, '', NULL, NULL, NULL),
(27418, '2017-04-22 14:06:03', NULL, NULL, 8614, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1492841155', 'admin', '2017-04-22 14:06:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27419, '2017-04-22 14:06:06', NULL, NULL, 8614, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 14:06:06', 'admin-1492841155-14928411666531793', 1, 1, 'SR', NULL, NULL, NULL),
(27420, '2017-04-22 00:00:00', NULL, NULL, 8610, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:38:29', 'admin-1492835891-14928359093835456', 1, 1, 'SR', NULL, NULL, NULL),
(27421, '2017-04-22 12:11:04', NULL, NULL, 8596, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:11:04', 'admin-1492832694-14928342645869920', 1, 0, '', NULL, NULL, NULL),
(27422, '2017-04-22 12:11:04', NULL, NULL, 8596, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:11:04', 'admin-1492832694-14928342645869920', 1, 0, '', NULL, NULL, NULL),
(27423, '2017-04-22 12:11:04', NULL, NULL, 8596, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:11:04', 'admin-1492832694-14928342645869920', 1, 1, 'SR', NULL, NULL, NULL),
(27424, '2017-04-22 12:13:09', NULL, NULL, 8592, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:13:09', 'admin-1492832694-14928343893386175', 1, 1, 'SR', NULL, NULL, NULL),
(27425, '2017-04-22 13:00:49', NULL, NULL, 8602, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:00:49', 'admin-1492835891-14928372490756682', 1, 0, '', NULL, NULL, NULL),
(27426, '2017-04-22 13:11:09', NULL, NULL, 8603, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:11:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27427, '2017-04-22 13:11:18', NULL, NULL, 8603, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:11:18', 'admin-1492835891-1492837878513117', 1, 0, '', NULL, NULL, NULL),
(27428, '2017-04-22 13:11:18', NULL, NULL, 8603, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:11:18', 'admin-1492835891-1492837878513117', 1, 0, '', NULL, NULL, NULL),
(27429, '2017-04-22 13:11:18', NULL, NULL, 8603, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:11:18', 'admin-1492835891-1492837878513117', 1, 1, 'SR', NULL, NULL, NULL),
(27430, '2017-04-22 14:34:15', NULL, NULL, 8615, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 14:34:15', 'admin-1492841155-14928428554629329', 1, 1, 'SR', NULL, NULL, '10.0'),
(27431, '2017-04-22 14:10:25', NULL, NULL, 8613, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 14:10:25', 'admin-1492841155-14928414257689896', 1, 0, '', NULL, NULL, NULL),
(27432, '2017-04-22 14:33:24', NULL, NULL, 8615, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1492841155', 'admin', '2017-04-22 14:33:24', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(27433, '2017-04-22 10:55:48', NULL, NULL, 8591, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:55:48', 'admin-1492823426-14928297483376215', 1, 1, 'SR', NULL, NULL, NULL),
(27434, '2017-04-22 00:00:00', NULL, NULL, 8609, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:38:29', 'admin-1492835891-14928359093835456', 1, 0, '', NULL, NULL, NULL),
(27435, '2017-04-22 00:00:00', NULL, NULL, 8610, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:37:47', 'admin-1492832694-14928358667861473', 1, 0, '', NULL, NULL, NULL),
(27436, '2017-04-22 13:34:14', NULL, NULL, 8607, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:34:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27437, '2017-04-22 13:34:25', NULL, NULL, 8607, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:34:25', 'admin-1492835891-1492839265524174', 1, 0, '', NULL, NULL, NULL),
(27438, '2017-04-22 13:18:19', NULL, NULL, 8606, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:18:19', 'admin-1492835891-14928382996973768', 1, 1, 'SR', NULL, NULL, NULL),
(27439, '2017-04-22 13:15:55', NULL, NULL, 8605, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:15:55', 'admin-1492835891-14928381548068738', 1, 0, '', NULL, NULL, NULL),
(27440, '2017-04-22 13:18:14', NULL, NULL, 8606, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:18:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27441, '2017-04-22 12:54:42', NULL, NULL, 8602, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:54:42', 'admin-1492835891-14928368822369881', 1, 1, 'SR', NULL, NULL, NULL),
(27442, '2017-04-22 10:55:48', NULL, NULL, 8591, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:55:48', 'admin-1492823426-14928297483376215', 1, 0, '', NULL, NULL, NULL),
(27443, '2017-04-22 10:55:48', NULL, NULL, 8591, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:55:48', 'admin-1492823426-14928297483376215', 1, 0, '', NULL, NULL, NULL),
(27444, '2017-04-22 12:54:42', NULL, NULL, 8602, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:54:42', 'admin-1492835891-14928368822369881', 1, 0, '', NULL, NULL, NULL),
(27445, '2017-04-22 12:54:42', NULL, NULL, 8602, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:54:42', 'admin-1492835891-14928368822369881', 1, 0, '', NULL, NULL, NULL),
(27446, '2017-04-22 12:54:42', NULL, NULL, 8602, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:54:42', 'admin-1492835891-14928368822369881', 1, 1, 'SR', NULL, NULL, NULL),
(27447, '2017-04-22 00:00:00', NULL, NULL, 8609, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:37:47', 'admin-1492832694-14928358667861473', 1, 1, 'SR', NULL, NULL, NULL),
(27448, '2017-04-22 10:16:00', NULL, NULL, 8588, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:16:00', 'admin-1492823426-14928273600671375', 1, 1, 'SR', NULL, NULL, NULL),
(27449, '2017-04-22 10:16:00', NULL, NULL, 8588, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:16:00', 'admin-1492823426-14928273600671375', 1, 0, '', NULL, NULL, NULL),
(27450, '2017-04-22 10:16:00', NULL, NULL, 8588, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:16:00', 'admin-1492823426-14928273600671375', 1, 1, 'SR', NULL, NULL, NULL),
(27451, '2017-04-22 10:16:00', NULL, NULL, 8588, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:16:00', 'admin-1492823426-14928273600671375', 1, 0, '', NULL, NULL, NULL),
(27452, '2017-04-22 10:16:00', NULL, NULL, 8588, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:16:00', 'admin-1492823426-14928273600671375', 1, 0, '', NULL, NULL, NULL),
(27453, '2017-04-22 10:16:00', NULL, NULL, 8588, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:16:00', 'admin-1492823426-14928273600671375', 1, 0, '', NULL, NULL, NULL),
(27454, '2017-04-22 10:16:00', NULL, NULL, 8588, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:16:00', 'admin-1492823426-14928273600671375', 1, 0, '', NULL, NULL, NULL),
(27455, '2017-04-22 10:16:00', NULL, NULL, 8588, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:16:00', 'admin-1492823426-14928273600671375', 1, 0, '', NULL, NULL, NULL),
(27456, '2017-04-22 10:26:27', NULL, NULL, 8589, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:26:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27457, '2017-04-22 10:26:56', NULL, NULL, 8589, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:26:56', 'admin-1492823426-14928280160396478', 1, 0, '', NULL, NULL, NULL),
(27458, '2017-04-22 12:29:38', NULL, NULL, 8598, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:29:38', 'admin-1492832694-1492835378226837', 1, 0, '', NULL, NULL, NULL),
(27459, '2017-04-22 00:00:00', NULL, NULL, 8612, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, NULL, NULL, 3.50, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:37:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27460, '2017-04-22 13:41:15', NULL, NULL, 8609, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1492841155', 'admin', '2017-04-22 13:41:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27461, '2017-04-22 12:29:38', NULL, NULL, 8598, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:29:38', 'admin-1492832694-1492835378226837', 1, 1, 'SR', NULL, NULL, NULL),
(27462, '2017-04-22 12:29:24', NULL, NULL, 8598, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:29:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27463, '2017-04-22 12:29:38', NULL, NULL, 8598, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:29:38', 'admin-1492832694-1492835378226837', 1, 0, '', NULL, NULL, NULL),
(27464, '2017-04-22 12:15:54', NULL, NULL, 8597, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:15:54', 'admin-1492832694-14928345542027926', 1, 1, 'SR', NULL, NULL, NULL),
(27465, '2017-04-22 00:00:00', NULL, NULL, 8608, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:54:02', 'admin-1492835891-14928368424554335', 1, 0, '', NULL, NULL, NULL),
(27466, '2017-04-22 12:54:42', NULL, NULL, 8602, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:54:42', 'admin-1492835891-14928368822369881', 1, 1, 'SR', NULL, NULL, NULL),
(27467, '2017-04-22 12:15:45', NULL, NULL, 8597, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:15:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27468, '2017-04-22 09:21:50', NULL, NULL, 8582, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 09:21:50', 'admin-1492823426-14928241107294434', 1, 0, '', NULL, NULL, NULL),
(27469, '2017-04-22 09:21:50', NULL, NULL, 8582, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 09:21:50', 'admin-1492823426-14928241107294434', 1, 0, '', NULL, NULL, NULL),
(27470, '2017-04-22 09:21:50', NULL, NULL, 8582, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 09:21:50', 'admin-1492823426-14928241107294434', 1, 1, 'SR', NULL, NULL, NULL),
(27471, '2017-04-22 09:36:59', NULL, NULL, 8583, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1492841155', 'admin', '2017-04-22 09:36:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27472, '2017-04-22 09:43:08', NULL, NULL, 8584, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 09:43:08', 'admin-1492823426-14928253880239253', 1, 1, 'SR', NULL, NULL, NULL),
(27473, '2017-04-22 09:43:08', NULL, NULL, 8584, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 09:43:08', 'admin-1492823426-14928253880239253', 1, 0, '', NULL, NULL, NULL),
(27474, '2017-04-22 09:43:08', NULL, NULL, 8584, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 09:43:08', 'admin-1492823426-14928253880239253', 1, 0, '', NULL, NULL, NULL),
(27475, '2017-04-22 09:43:08', NULL, NULL, 8584, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 09:43:08', 'admin-1492823426-14928253880239253', 1, 1, 'SR', NULL, NULL, NULL),
(27476, '2017-04-22 09:46:41', NULL, NULL, 8585, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 09:46:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27477, '2017-04-22 09:47:14', NULL, NULL, 8585, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 09:47:14', 'admin-1492823426-14928256339835777', 1, 0, '', NULL, NULL, NULL),
(27478, '2017-04-22 09:47:14', NULL, NULL, 8585, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 09:47:14', 'admin-1492823426-14928256339835777', 1, 1, 'SR', NULL, NULL, NULL),
(27479, '2017-04-22 09:54:51', NULL, NULL, 8582, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 09:54:51', 'admin-1492823426-14928260915599819', 1, 0, '', NULL, NULL, NULL),
(27480, '2017-04-22 10:04:28', NULL, NULL, 8586, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:04:28', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(27481, '2017-04-22 10:04:40', NULL, NULL, 8586, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:04:40', 'admin-1492823426-14928266808115172', 1, 0, '', NULL, NULL, NULL),
(27482, '2017-04-22 10:04:41', NULL, NULL, 8586, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:04:41', 'admin-1492823426-14928266808115172', 1, 0, '', NULL, NULL, NULL),
(27483, '2017-04-22 10:04:53', NULL, NULL, 8586, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:04:53', 'admin-1492823426-14928266927924021', 1, 0, '', NULL, NULL, NULL),
(27484, '2017-04-22 11:34:53', NULL, NULL, 8593, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1492841155', 'admin', '2017-04-22 11:34:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27485, '2017-04-22 11:35:12', NULL, NULL, 8593, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 11:35:12', 'admin-1492823426-14928321122206028', 1, 1, 'SR', NULL, NULL, NULL),
(27486, '2017-04-22 10:27:07', NULL, NULL, 8589, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:27:07', 'admin-1492823426-14928280274367581', 1, 1, 'SR', NULL, NULL, NULL),
(27487, '2017-04-22 12:10:56', NULL, NULL, 8596, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1492841155', 'admin', '2017-04-22 12:10:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27488, '2017-04-22 11:56:25', NULL, NULL, 8595, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 11:56:25', 'admin-1492832694-14928333851344949', 1, 0, '', NULL, NULL, NULL),
(27489, '2017-04-22 11:56:25', NULL, NULL, 8595, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 11:56:25', 'admin-1492832694-14928333851344949', 1, 0, '', NULL, NULL, NULL),
(27490, '2017-04-22 11:45:49', NULL, NULL, 8593, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 11:45:49', 'admin-1492832694-14928327489578382', 1, 0, '', NULL, NULL, NULL),
(27491, '2017-04-22 10:07:45', NULL, NULL, 8587, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:07:45', 'admin-1492823426-1492826865764267', 1, 1, 'SR', NULL, NULL, NULL),
(27492, '2017-04-22 10:55:32', NULL, NULL, 8591, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:55:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27493, '2017-04-22 11:35:12', NULL, NULL, 8593, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 11:35:12', 'admin-1492823426-14928321122206028', 1, 0, '', NULL, NULL, NULL),
(27494, '2017-04-22 11:30:24', NULL, NULL, 8592, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 11:30:24', 'admin-1492823426-14928318246189617', 1, 1, 'SR', NULL, NULL, NULL),
(27495, '2017-04-22 10:55:48', NULL, NULL, 8591, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:55:48', 'admin-1492823426-14928297483376215', 1, 1, 'SR', NULL, NULL, NULL),
(27496, '2017-04-22 10:45:21', NULL, NULL, 8590, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:45:21', 'admin-1492823426-14928291211866521', 1, 0, '', NULL, NULL, NULL),
(27497, '2017-04-22 10:45:17', NULL, NULL, 8590, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:45:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27498, '2017-04-22 09:41:03', NULL, NULL, 8584, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1492841155', 'admin', '2017-04-22 09:41:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27499, '2017-04-22 09:37:27', NULL, NULL, 8583, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 09:37:27', 'admin-1492823426-14928250476223199', 1, 0, '', NULL, NULL, NULL),
(27500, '2017-04-22 09:37:27', NULL, NULL, 8583, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 09:37:27', 'admin-1492823426-14928250476223199', 1, 0, '', NULL, NULL, NULL),
(27501, '2017-04-22 11:30:16', NULL, NULL, 8592, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 11:30:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27502, '2017-04-22 10:15:43', NULL, NULL, 8588, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.10, 0.0000, 0.0000, 11.10, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:15:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27503, '2017-04-22 10:07:39', NULL, NULL, 8587, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:07:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27504, '2017-04-22 10:05:10', NULL, NULL, 8586, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:05:10', 'admin-1492823426-14928267103856445', 1, 1, 'SR', NULL, NULL, NULL),
(27505, '2017-04-22 09:37:27', NULL, NULL, 8583, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 09:37:27', 'admin-1492823426-14928250476223199', 1, 0, '', NULL, NULL, NULL),
(27506, '2017-04-22 10:05:10', NULL, NULL, 8586, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 10:05:10', 'admin-1492823426-14928267103856445', 1, 0, '', NULL, NULL, NULL),
(27507, '2017-04-22 09:10:31', NULL, NULL, 8581, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1492841155', 'admin', '2017-04-22 09:10:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27508, '2017-04-22 09:10:49', NULL, NULL, 8581, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 09:10:49', 'admin-1492823426-14928234492354730', 1, 0, '', NULL, NULL, NULL),
(27509, '2017-04-22 09:10:49', NULL, NULL, 8581, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 09:10:49', 'admin-1492823426-14928234492354730', 1, 0, '', NULL, NULL, NULL),
(27510, '2017-04-22 09:10:49', NULL, NULL, 8581, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 09:10:49', 'admin-1492823426-14928234492354730', 1, 1, 'SR', NULL, NULL, NULL),
(27511, '2017-04-22 09:21:37', NULL, NULL, 8582, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1492841155', 'admin', '2017-04-22 09:21:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27512, '2017-04-22 09:10:49', NULL, NULL, 8581, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492841155', 'admin', '2017-04-22 09:10:49', 'admin-1492823426-14928234492354730', 1, 0, '', NULL, NULL, NULL),
(27513, '2017-04-23 16:27:48', NULL, NULL, 8656, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 16:27:48', 'admin-1492936048-14929360686877862', 1, 1, 'SR', NULL, NULL, NULL),
(27514, '2017-04-23 16:28:41', NULL, NULL, 8656, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 16:28:41', 'admin-1492936048-14929361212772155', 1, 1, 'SR', NULL, NULL, NULL),
(27515, '2017-04-23 17:09:43', NULL, NULL, 8657, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1492936048', 'admin', '2017-04-23 17:09:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27516, '2017-04-23 17:10:01', NULL, NULL, 8657, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 17:10:01', 'admin-1492936048-14929386015906931', 1, 1, 'SR', NULL, NULL, NULL),
(27517, '2017-04-23 17:10:01', NULL, NULL, 8657, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 17:10:01', 'admin-1492936048-14929386015906931', 1, 1, 'SR', NULL, NULL, NULL),
(27518, '2017-04-23 13:17:12', NULL, NULL, 8646, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 13:17:12', 'admin-1492923865-14929246321909411', 1, 1, 'SR', NULL, NULL, NULL),
(27519, '2017-04-23 13:17:20', NULL, NULL, 8646, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 13:17:20', 'admin-1492923865-14929246404015695', 1, 0, '', NULL, NULL, NULL),
(27520, '2017-04-23 13:17:20', NULL, NULL, 8646, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 13:17:20', 'admin-1492923865-14929246404015695', 1, 1, 'SR', NULL, NULL, NULL),
(27521, '2017-04-23 12:19:05', NULL, NULL, 8643, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 12:19:05', 'admin-1492919495-1492921145040354', 1, 0, '', NULL, NULL, NULL),
(27522, '2017-04-23 00:00:00', NULL, NULL, 8644, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, NULL, NULL, 6.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:48:25', 'admin-1492914672-1492919305613212', 1, 1, 'SR', NULL, NULL, NULL),
(27523, '2017-04-23 12:17:43', NULL, NULL, 8640, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 12:17:43', 'admin-1492919495-14929210636134676', 1, 0, '', NULL, NULL, NULL),
(27524, '2017-04-23 12:18:29', NULL, NULL, 8643, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1492936048', 'admin', '2017-04-23 12:18:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27525, '2017-04-23 12:19:05', NULL, NULL, 8643, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 12:19:05', 'admin-1492919495-1492921145040354', 1, 1, 'SR', NULL, NULL, NULL),
(27526, '2017-04-23 12:19:05', NULL, NULL, 8643, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 12:19:05', 'admin-1492919495-1492921145040354', 1, 1, 'SR', NULL, NULL, NULL),
(27527, '2017-04-23 11:36:45', NULL, NULL, 8640, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:36:45', 'admin-1492914672-14929186049385380', 1, 1, 'SR', NULL, NULL, NULL),
(27528, '2017-04-23 11:36:45', NULL, NULL, 8640, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:36:45', 'admin-1492914672-14929186049385380', 1, 0, '', NULL, NULL, NULL),
(27529, '2017-04-23 11:36:45', NULL, NULL, 8640, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:36:45', 'admin-1492914672-14929186049385380', 1, 0, '', NULL, NULL, NULL),
(27530, '2017-04-23 11:36:45', NULL, NULL, 8640, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:36:45', 'admin-1492914672-14929186049385380', 1, 1, 'SR', NULL, NULL, NULL),
(27531, '2017-04-23 11:36:45', NULL, NULL, 8640, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:36:45', 'admin-1492914672-14929186049385380', 1, 1, 'SR', NULL, NULL, NULL),
(27532, '2017-04-23 11:36:45', NULL, NULL, 8640, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:36:45', 'admin-1492914672-14929186049385380', 1, 1, 'SR', NULL, NULL, NULL),
(27533, '2017-04-23 11:36:45', NULL, NULL, 8640, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:36:45', 'admin-1492914672-14929186049385380', 1, 1, 'SR', NULL, NULL, NULL),
(27534, '2017-04-23 12:21:14', NULL, NULL, 8644, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1492936048', 'admin', '2017-04-23 12:21:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27535, '2017-04-23 00:00:00', NULL, NULL, 8645, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, NULL, NULL, 2.30, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:46:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27536, '2017-04-23 00:00:00', NULL, NULL, 8644, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:48:25', 'admin-1492914672-1492919305613212', 1, 1, 'SR', NULL, NULL, NULL),
(27537, '2017-04-23 11:48:57', NULL, NULL, 8634, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:48:57', 'admin-1492914672-1492919337615527', 1, 0, '', NULL, NULL, NULL),
(27538, '2017-04-23 10:03:53', NULL, NULL, 8629, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:03:53', 'admin-1492909126-14929130337086642', 1, 1, 'SR', NULL, NULL, NULL),
(27539, '2017-04-23 10:04:05', NULL, NULL, 8630, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:04:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27540, '2017-04-23 10:04:14', NULL, NULL, 8630, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:04:14', 'admin-1492909126-1492913053859994', 1, 1, 'SR', NULL, NULL, NULL),
(27541, '2017-04-23 10:09:29', NULL, NULL, 8631, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.20, 0.0000, 0.0000, 11.20, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:09:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27542, '2017-04-23 10:03:53', NULL, NULL, 8629, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:03:53', 'admin-1492909126-14929130337086642', 1, 1, 'SR', NULL, NULL, NULL),
(27543, '2017-04-23 09:44:41', NULL, NULL, 8627, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:44:41', 'admin-1492909126-14929118808525721', 1, 0, '', NULL, NULL, NULL),
(27544, '2017-04-23 09:41:25', NULL, NULL, 8625, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:41:25', 'admin-1492909126-14929116854751731', 1, 0, '', NULL, NULL, NULL),
(27545, '2017-04-23 16:14:33', NULL, NULL, 8654, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 16:14:33', 'admin-1492923865-14929352728451451', 1, 1, 'SR', NULL, NULL, NULL),
(27546, '2017-04-23 16:24:38', NULL, NULL, 8655, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 16:24:38', 'admin-1492923865-14929358781093137', 1, 1, 'SR', NULL, NULL, NULL),
(27547, '2017-04-23 16:27:21', NULL, NULL, 8656, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 16:27:21', 'admin-1492923865-14929360413168174', 1, 1, 'SR', NULL, NULL, NULL),
(27548, '2017-04-23 16:27:21', NULL, NULL, 8656, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 16:27:21', 'admin-1492923865-14929360413168174', 1, 0, '', NULL, NULL, NULL),
(27549, '2017-04-23 16:24:38', NULL, NULL, 8655, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 16:24:38', 'admin-1492923865-14929358781093137', 1, 0, '', NULL, NULL, NULL),
(27550, '2017-04-23 16:24:32', NULL, NULL, 8655, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1492936048', 'admin', '2017-04-23 16:24:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27551, '2017-04-23 10:52:43', NULL, NULL, 8634, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:52:43', 'admin-1492914672-14929159630712649', 1, 0, '', NULL, NULL, NULL),
(27552, '2017-04-23 16:14:33', NULL, NULL, 8654, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 16:14:33', 'admin-1492923865-14929352728451451', 1, 0, '', NULL, NULL, NULL),
(27553, '2017-04-23 16:13:57', NULL, NULL, 8654, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1492936048', 'admin', '2017-04-23 16:13:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27554, '2017-04-23 16:14:33', NULL, NULL, 8654, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 16:14:33', 'admin-1492923865-14929352728451451', 1, 0, '', NULL, NULL, NULL),
(27555, '2017-04-23 15:47:14', NULL, NULL, 8652, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 15:47:14', 'admin-1492923865-14929336341906674', 1, 1, 'SR', NULL, NULL, NULL),
(27556, '2017-04-23 13:01:59', NULL, NULL, 8648, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 13:01:59', 'admin-1492919495-14929237189253170', 1, 1, 'SR', NULL, NULL, NULL),
(27557, '2017-04-23 13:36:09', NULL, NULL, 8651, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 13:36:09', 'admin-1492923865-14929257693723861', 1, 1, 'SR', NULL, NULL, NULL),
(27558, '2017-04-23 13:36:09', NULL, NULL, 8651, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 13:36:09', 'admin-1492923865-14929257693723861', 1, 0, '', NULL, NULL, NULL),
(27559, '2017-04-23 13:04:49', NULL, NULL, 8646, 0, 73, '73', 'Marmite Chicken ', 'take away', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 13:04:49', 'admin-1492923865-14929238892474549', 1, 1, 'SR', NULL, NULL, NULL),
(27560, '2017-04-23 13:00:40', NULL, NULL, 8647, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1492936048', 'admin', '2017-04-23 13:00:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27561, '2017-04-23 13:01:06', NULL, NULL, 8647, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 13:01:06', 'admin-1492919495-14929236661731432', 1, 0, '', NULL, NULL, NULL),
(27562, '2017-04-23 13:01:06', NULL, NULL, 8647, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 13:01:06', 'admin-1492919495-14929236661731432', 1, 0, '', NULL, NULL, NULL),
(27563, '2017-04-23 13:01:06', NULL, NULL, 8647, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 13:01:06', 'admin-1492919495-14929236661731432', 1, 0, '', NULL, NULL, NULL),
(27564, '2017-04-23 13:01:06', NULL, NULL, 8647, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 13:01:06', 'admin-1492919495-14929236661731432', 1, 1, 'SR', NULL, NULL, NULL),
(27565, '2017-04-23 13:01:06', NULL, NULL, 8647, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 13:01:06', 'admin-1492919495-14929236661731432', 1, 1, 'SR', NULL, NULL, NULL),
(27566, '2017-04-23 11:55:54', NULL, NULL, 8634, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:55:54', 'admin-1492919495-14929197544843737', 1, 0, '', NULL, NULL, NULL),
(27567, '2017-04-23 12:03:59', NULL, NULL, 8642, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1492936048', 'admin', '2017-04-23 12:03:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27568, '2017-04-23 12:04:31', NULL, NULL, 8642, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 12:04:31', 'admin-1492919495-14929202711823788', 1, 0, '', NULL, NULL, NULL),
(27569, '2017-04-23 12:04:31', NULL, NULL, 8642, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 12:04:31', 'admin-1492919495-14929202711823788', 1, 1, 'SR', NULL, NULL, NULL),
(27570, '2017-04-23 12:17:21', NULL, NULL, 8640, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 12:17:21', 'admin-1492919495-14929210414311233', 1, 1, 'SR', NULL, NULL, NULL),
(27571, '2017-04-23 11:00:57', NULL, NULL, 8638, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:00:57', 'admin-1492914672-14929164576192785', 1, 0, '', NULL, NULL, NULL),
(27572, '2017-04-23 11:00:57', NULL, NULL, 8638, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:00:57', 'admin-1492914672-14929164576192785', 1, 0, '', NULL, NULL, NULL),
(27573, '2017-04-23 10:46:48', NULL, NULL, 8635, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:46:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27574, '2017-04-23 16:26:59', NULL, NULL, 8656, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 16:26:59', 'admin-1492923865-14929360188915183', 1, 0, '', NULL, NULL, NULL),
(27575, '2017-04-23 16:26:54', NULL, NULL, 8656, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1492936048', 'admin', '2017-04-23 16:26:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27576, '2017-04-23 15:37:04', NULL, NULL, 8653, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 15:37:04', 'admin-1492923865-14929330245338770', 1, 0, '', NULL, NULL, NULL),
(27577, '2017-04-23 13:36:09', NULL, NULL, 8651, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 13:36:09', 'admin-1492923865-14929257693723861', 1, 0, '', NULL, NULL, NULL),
(27578, '2017-04-23 14:44:51', NULL, NULL, 8652, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1492936048', 'admin', '2017-04-23 14:44:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27579, '2017-04-23 14:45:00', NULL, NULL, 8652, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 14:45:00', 'admin-1492923865-14929298998382036', 1, 0, '', NULL, NULL, NULL),
(27580, '2017-04-23 15:28:32', NULL, NULL, 8653, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 15:28:32', 'admin-1492923865-14929325122696826', 1, 1, 'SR', NULL, NULL, NULL),
(27581, '2017-04-23 00:00:00', NULL, NULL, 8645, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:58:03', 'admin-1492919495-14929198835261590', 1, 0, '', NULL, NULL, NULL),
(27582, '2017-04-23 12:46:17', NULL, NULL, 8646, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.40, 0.0000, 0.0000, 15.40, 1, '27', 1, '1492936048', 'admin', '2017-04-23 12:46:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27583, '2017-04-23 12:46:37', NULL, NULL, 8646, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 12:46:37', 'admin-1492919495-14929227968977813', 1, 1, 'SR', NULL, NULL, NULL),
(27584, '2017-04-23 12:46:37', NULL, NULL, 8646, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 12:46:37', 'admin-1492919495-14929227968977813', 1, 1, 'SR', NULL, NULL, NULL),
(27585, '2017-04-23 10:27:18', NULL, NULL, 8632, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:27:18', 'admin-1492909126-14929144385017249', 1, 1, 'SR', NULL, NULL, NULL),
(27586, '2017-04-23 10:27:18', NULL, NULL, 8632, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:27:18', 'admin-1492909126-14929144385017249', 1, 1, 'SR', NULL, NULL, NULL),
(27587, '2017-04-23 10:27:18', NULL, NULL, 8632, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:27:18', 'admin-1492909126-14929144385017249', 1, 1, 'SR', NULL, NULL, NULL),
(27588, '2017-04-23 10:27:18', NULL, NULL, 8632, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:27:18', 'admin-1492909126-14929144385017249', 1, 1, 'SR', NULL, NULL, NULL),
(27589, '2017-04-23 10:29:50', NULL, NULL, 8633, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:29:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27590, '2017-04-23 10:29:59', NULL, NULL, 8633, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:29:59', 'admin-1492909126-14929145995167479', 1, 0, '', NULL, NULL, NULL),
(27591, '2017-04-23 10:29:59', NULL, NULL, 8633, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:29:59', 'admin-1492909126-14929145995167479', 1, 0, '', NULL, NULL, NULL),
(27592, '2017-04-23 10:29:59', NULL, NULL, 8633, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:29:59', 'admin-1492909126-14929145995167479', 1, 0, '', NULL, NULL, NULL),
(27593, '2017-04-23 10:39:04', NULL, NULL, 8634, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.00, 0.0000, 0.0000, 13.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:39:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27594, '2017-04-23 10:49:03', NULL, NULL, 8636, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:49:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27595, '2017-04-23 10:46:38', NULL, NULL, 8625, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:46:38', 'admin-1492914672-1492915598693196', 1, 1, 'SR', NULL, NULL, NULL),
(27596, '2017-04-23 15:06:48', NULL, NULL, 8653, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 15:06:48', 'admin-1492923865-14929312081665946', 1, 0, '', NULL, NULL, NULL),
(27597, '2017-04-23 15:37:34', NULL, NULL, 8653, 0, 181, '116', 'Open Food ', 'French Fries', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 15:37:34', 'admin-1492923865-14929330541644554', 1, 0, '', NULL, NULL, NULL),
(27598, '2017-04-23 15:06:44', NULL, NULL, 8653, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1492936048', 'admin', '2017-04-23 15:06:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27599, '2017-04-23 13:35:46', NULL, NULL, 8651, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1492936048', 'admin', '2017-04-23 13:35:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27600, '2017-04-23 13:13:28', NULL, NULL, 8650, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 13:13:28', 'admin-1492923865-14929244084454950', 1, 0, '', NULL, NULL, NULL),
(27601, '2017-04-23 12:46:37', NULL, NULL, 8646, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 12:46:37', 'admin-1492919495-14929227968977813', 1, 0, '', NULL, NULL, NULL),
(27602, '2017-04-23 13:13:12', NULL, NULL, 8650, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1492936048', 'admin', '2017-04-23 13:13:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27603, '2017-04-23 13:13:28', NULL, NULL, 8650, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 13:13:28', 'admin-1492923865-14929244084454950', 1, 0, '', NULL, NULL, NULL),
(27604, '2017-04-23 13:01:46', NULL, NULL, 8648, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1492936048', 'admin', '2017-04-23 13:01:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27605, '2017-04-23 13:01:59', NULL, NULL, 8648, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 13:01:59', 'admin-1492919495-14929237189253170', 1, 1, 'SR', NULL, NULL, NULL),
(27606, '2017-04-23 12:46:37', NULL, NULL, 8646, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 12:46:37', 'admin-1492919495-14929227968977813', 1, 0, '', NULL, NULL, NULL),
(27607, '2017-04-23 12:46:37', NULL, NULL, 8646, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 12:46:37', 'admin-1492919495-14929227968977813', 1, 1, 'SR', NULL, NULL, NULL),
(27608, '2017-04-23 12:46:37', NULL, NULL, 8646, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 12:46:37', 'admin-1492919495-14929227968977813', 1, 1, 'SR', NULL, NULL, NULL),
(27609, '2017-04-23 12:46:37', NULL, NULL, 8646, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 12:46:37', 'admin-1492919495-14929227968977813', 1, 0, '', NULL, NULL, NULL),
(27610, '2017-04-23 12:19:05', NULL, NULL, 8643, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 12:19:05', 'admin-1492919495-1492921145040354', 1, 0, '', NULL, NULL, NULL),
(27611, '2017-04-23 10:47:00', NULL, NULL, 8635, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:47:00', 'admin-1492914672-14929156201957497', 1, 0, '', NULL, NULL, NULL),
(27612, '2017-04-23 10:47:11', NULL, NULL, 8635, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:47:11', 'admin-1492914672-14929156317315019', 1, 1, 'SR', NULL, NULL, NULL),
(27613, '2017-04-23 10:49:33', NULL, NULL, 8636, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:49:33', 'admin-1492914672-14929157730566795', 1, 1, 'SR', NULL, NULL, NULL),
(27614, '2017-04-23 10:49:50', NULL, NULL, 8636, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:49:50', 'admin-1492914672-14929157900783223', 1, 1, 'SR', NULL, NULL, NULL),
(27615, '2017-04-23 00:00:00', NULL, NULL, 8645, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:48:25', 'admin-1492914672-1492919305613212', 1, 0, '', NULL, NULL, NULL),
(27616, '2017-04-23 12:19:05', NULL, NULL, 8643, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 12:19:05', 'admin-1492919495-1492921145040354', 1, 0, '', NULL, NULL, NULL),
(27617, '2017-04-23 10:10:16', NULL, NULL, 8631, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:10:16', 'admin-1492909126-14929134158864081', 1, 0, '', NULL, NULL, NULL),
(27618, '2017-04-23 10:10:16', NULL, NULL, 8631, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:10:16', 'admin-1492909126-14929134158864081', 1, 0, '', NULL, NULL, NULL),
(27619, '2017-04-23 10:10:16', NULL, NULL, 8631, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:10:16', 'admin-1492909126-14929134158864081', 1, 0, '', NULL, NULL, NULL),
(27620, '2017-04-23 10:10:16', NULL, NULL, 8631, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:10:16', 'admin-1492909126-14929134158864081', 1, 0, '', NULL, NULL, NULL),
(27621, '2017-04-23 10:10:43', NULL, NULL, 8631, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:10:43', 'admin-1492909126-14929134433479094', 1, 0, '', NULL, NULL, NULL),
(27622, '2017-04-23 11:57:39', NULL, NULL, 8634, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:57:39', 'admin-1492919495-14929198589909982', 1, 0, '', NULL, NULL, NULL),
(27623, '2017-04-23 11:48:57', NULL, NULL, 8634, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:48:57', 'admin-1492914672-1492919337615527', 1, 1, 'SR', NULL, NULL, NULL),
(27624, '2017-04-23 11:50:02', NULL, NULL, 8634, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:50:02', 'admin-1492914672-14929194018469282', 1, 1, 'SR', NULL, NULL, NULL),
(27625, '2017-04-23 11:50:33', NULL, NULL, 8634, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 2, 21.00, 42.0000, 0.0000, 42.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:50:33', 'admin-1492914672-14929194334462927', 1, 0, '', NULL, NULL, NULL),
(27626, '2017-04-23 10:52:43', NULL, NULL, 8634, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:52:43', 'admin-1492914672-14929159630712649', 1, 0, '', NULL, NULL, NULL),
(27627, '2017-04-23 10:56:29', NULL, NULL, 8637, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:56:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27628, '2017-04-23 10:57:12', NULL, NULL, 8637, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:57:12', 'admin-1492914672-14929162322822088', 1, 1, 'SR', NULL, NULL, NULL),
(27629, '2017-04-23 11:36:07', NULL, NULL, 8640, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.30, 0.0000, 0.0000, 11.30, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:36:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27630, '2017-04-23 10:57:12', NULL, NULL, 8637, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:57:12', 'admin-1492914672-14929162322822088', 1, 1, 'SR', NULL, NULL, NULL),
(27631, '2017-04-23 10:57:12', NULL, NULL, 8637, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:57:12', 'admin-1492914672-14929162322822088', 1, 1, 'SR', NULL, NULL, NULL),
(27632, '2017-04-23 11:00:12', NULL, NULL, 8638, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.80, 0.0000, 0.0000, 11.80, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:00:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27633, '2017-04-23 11:00:38', NULL, NULL, 8638, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:00:38', 'admin-1492914672-1492916438749957', 1, 0, '', NULL, NULL, NULL),
(27634, '2017-04-23 09:44:41', NULL, NULL, 8627, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:44:41', 'admin-1492909126-14929118808525721', 1, 0, '', NULL, NULL, NULL),
(27635, '2017-04-23 09:44:41', NULL, NULL, 8627, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:44:41', 'admin-1492909126-14929118808525721', 1, 1, 'SR', NULL, NULL, NULL),
(27636, '2017-04-23 09:44:41', NULL, NULL, 8627, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:44:41', 'admin-1492909126-14929118808525721', 1, 1, 'SR', NULL, NULL, NULL),
(27637, '2017-04-23 09:45:50', NULL, NULL, 8627, 0, 181, '116', 'Open Food ', 'BLT add sausage', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:45:50', 'admin-1492909126-14929119505433357', 1, 0, '', NULL, NULL, NULL),
(27638, '2017-04-23 10:02:46', NULL, NULL, 8628, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:02:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27639, '2017-04-23 10:02:58', NULL, NULL, 8628, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:02:58', 'admin-1492909126-14929129783415151', 1, 0, '', NULL, NULL, NULL),
(27640, '2017-04-23 10:02:58', NULL, NULL, 8628, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:02:58', 'admin-1492909126-14929129783415151', 1, 0, '', NULL, NULL, NULL),
(27641, '2017-04-23 10:02:58', NULL, NULL, 8628, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:02:58', 'admin-1492909126-14929129783415151', 1, 1, 'SR', NULL, NULL, NULL),
(27642, '2017-04-23 10:02:58', NULL, NULL, 8628, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:02:58', 'admin-1492909126-14929129783415151', 1, 1, 'SR', NULL, NULL, NULL),
(27643, '2017-04-23 10:03:17', NULL, NULL, 8629, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.20, 0.0000, 0.0000, 9.20, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:03:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27644, '2017-04-23 11:00:39', NULL, NULL, 8638, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:00:39', 'admin-1492914672-1492916438749957', 1, 0, '', NULL, NULL, NULL),
(27645, '2017-04-23 11:00:57', NULL, NULL, 8638, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:00:57', 'admin-1492914672-14929164576192785', 1, 1, 'SR', NULL, NULL, NULL),
(27646, '2017-04-23 11:00:57', NULL, NULL, 8638, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:00:57', 'admin-1492914672-14929164576192785', 1, 1, 'SR', NULL, NULL, NULL),
(27647, '2017-04-23 11:03:47', NULL, NULL, 8639, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 2, 14.00, 28.0000, 0.0000, 28.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:03:47', 'admin-1492914672-1492916627154802', 1, 1, 'SR', NULL, NULL, NULL),
(27648, '2017-04-23 11:03:41', NULL, NULL, 8639, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:03:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27649, '2017-04-23 10:47:00', NULL, NULL, 8635, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:47:00', 'admin-1492914672-14929156201957497', 1, 0, '', NULL, NULL, NULL),
(27650, '2017-04-23 11:00:39', NULL, NULL, 8638, 0, 181, '116', 'Open Food ', 'aLL wAKE mE UP nO BACON', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:00:39', 'admin-1492914672-1492916438749957', 1, 0, '', NULL, NULL, NULL),
(27651, '2017-04-23 10:26:55', NULL, NULL, 8632, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:26:55', 'admin-1492909126-1492914415150679', 1, 0, '', NULL, NULL, NULL),
(27652, '2017-04-23 11:00:39', NULL, NULL, 8638, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:00:39', 'admin-1492914672-1492916438749957', 1, 0, '', NULL, NULL, NULL),
(27653, '2017-04-23 11:00:38', NULL, NULL, 8638, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:00:38', 'admin-1492914672-1492916438749957', 1, 0, '', NULL, NULL, NULL),
(27654, '2017-04-23 09:23:02', NULL, NULL, 8623, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:23:02', 'admin-1492909126-14929105822558570', 1, 0, '', NULL, NULL, NULL),
(27655, '2017-04-23 09:23:38', NULL, NULL, 8623, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:23:38', 'admin-1492909126-14929106179849147', 1, 1, 'SR', NULL, NULL, NULL),
(27656, '2017-04-23 09:23:38', NULL, NULL, 8623, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:23:38', 'admin-1492909126-14929106179849147', 1, 0, '', NULL, NULL, NULL),
(27657, '2017-04-23 09:23:38', NULL, NULL, 8623, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:23:38', 'admin-1492909126-14929106179849147', 1, 1, 'SR', NULL, NULL, NULL),
(27658, '2017-04-23 09:37:58', NULL, NULL, 8624, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 17.20, 0.0000, 0.0000, 17.20, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:37:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27659, '2017-04-23 09:38:27', NULL, NULL, 8624, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 2, 21.00, 42.0000, 0.0000, 42.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:38:27', 'admin-1492909126-14929115067767434', 1, 0, '', NULL, NULL, NULL),
(27660, '2017-04-23 09:38:27', NULL, NULL, 8624, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:38:27', 'admin-1492909126-14929115067767434', 1, 0, '', NULL, NULL, NULL),
(27661, '2017-04-23 09:38:27', NULL, NULL, 8624, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:38:27', 'admin-1492909126-14929115067767434', 1, 0, '', NULL, NULL, NULL),
(27662, '2017-04-23 09:38:27', NULL, NULL, 8624, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:38:27', 'admin-1492909126-14929115067767434', 1, 0, '', NULL, NULL, NULL),
(27663, '2017-04-23 09:38:27', NULL, NULL, 8624, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:38:27', 'admin-1492909126-14929115067767434', 1, 0, '', NULL, NULL, NULL),
(27664, '2017-04-23 09:40:14', NULL, NULL, 8624, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:40:14', 'admin-1492909126-14929116139172246', 1, 1, 'SR', NULL, NULL, NULL),
(27665, '2017-04-23 09:40:14', NULL, NULL, 8624, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:40:14', 'admin-1492909126-14929116139172246', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(27666, '2017-04-23 09:40:14', NULL, NULL, 8624, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:40:14', 'admin-1492909126-14929116139172246', 1, 1, 'SR', NULL, NULL, NULL),
(27667, '2017-04-23 09:40:14', NULL, NULL, 8624, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:40:14', 'admin-1492909126-14929116139172246', 1, 0, '', NULL, NULL, NULL),
(27668, '2017-04-23 09:40:14', NULL, NULL, 8624, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:40:14', 'admin-1492909126-14929116139172246', 1, 1, 'SR', NULL, NULL, NULL),
(27669, '2017-04-23 09:40:14', NULL, NULL, 8624, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:40:14', 'admin-1492909126-14929116139172246', 1, 0, '', NULL, NULL, NULL),
(27670, '2017-04-23 10:10:43', NULL, NULL, 8631, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:10:43', 'admin-1492909126-14929134433479094', 1, 0, '', NULL, NULL, NULL),
(27671, '2017-04-23 10:10:43', NULL, NULL, 8631, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:10:43', 'admin-1492909126-14929134433479094', 1, 1, 'SR', NULL, NULL, NULL),
(27672, '2017-04-23 10:18:38', NULL, NULL, 8629, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:18:38', 'admin-1492909126-14929139178527056', 1, 0, '', NULL, NULL, NULL),
(27673, '2017-04-23 10:26:45', NULL, NULL, 8632, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.00, 0.0000, 0.0000, 13.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:26:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27674, '2017-04-23 10:26:55', NULL, NULL, 8632, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:26:55', 'admin-1492909126-1492914415150679', 1, 1, 'SR', NULL, NULL, NULL),
(27675, '2017-04-23 10:26:55', NULL, NULL, 8632, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:26:55', 'admin-1492909126-1492914415150679', 1, 0, '', NULL, NULL, NULL),
(27676, '2017-04-23 10:26:55', NULL, NULL, 8632, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:26:55', 'admin-1492909126-1492914415150679', 1, 0, '', NULL, NULL, NULL),
(27677, '2017-04-23 10:26:55', NULL, NULL, 8632, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:26:55', 'admin-1492909126-1492914415150679', 1, 0, '', NULL, NULL, NULL),
(27678, '2017-04-23 10:03:25', NULL, NULL, 8629, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:03:25', 'admin-1492909126-14929130053021480', 1, 1, 'SR', NULL, NULL, NULL),
(27679, '2017-04-23 10:03:41', NULL, NULL, 8629, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:03:41', 'admin-1492909126-14929130214409578', 1, 0, '', NULL, NULL, NULL),
(27680, '2017-04-23 10:03:41', NULL, NULL, 8629, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:03:41', 'admin-1492909126-14929130214409578', 1, 0, '', NULL, NULL, NULL),
(27681, '2017-04-23 10:10:43', NULL, NULL, 8631, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:10:43', 'admin-1492909126-14929134433479094', 1, 1, 'SR', NULL, NULL, NULL),
(27682, '2017-04-23 11:55:54', NULL, NULL, 8634, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 11:55:54', 'admin-1492919495-14929197544843737', 1, 0, '', NULL, NULL, NULL),
(27683, '2017-04-23 10:03:41', NULL, NULL, 8629, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 10:03:41', 'admin-1492909126-14929130214409578', 1, 0, '', NULL, NULL, NULL),
(27684, '2017-04-23 09:43:05', NULL, NULL, 8626, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:43:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27685, '2017-04-23 09:43:13', NULL, NULL, 8626, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:43:13', 'admin-1492909126-14929117929393772', 1, 1, 'SR', NULL, NULL, NULL),
(27686, '2017-04-23 09:44:14', NULL, NULL, 8627, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:44:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27687, '2017-04-23 09:44:41', NULL, NULL, 8627, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:44:41', 'admin-1492909126-14929118808525721', 1, 0, '', NULL, NULL, NULL),
(27688, '2017-04-23 09:41:25', NULL, NULL, 8625, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:41:25', 'admin-1492909126-14929116854751731', 1, 0, '', NULL, NULL, NULL),
(27689, '2017-04-23 09:41:11', NULL, NULL, 8625, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:41:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27690, '2017-04-23 09:23:02', NULL, NULL, 8623, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:23:02', 'admin-1492909126-14929105822558570', 1, 0, '', NULL, NULL, NULL),
(27691, '2017-04-23 09:23:02', NULL, NULL, 8623, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:23:02', 'admin-1492909126-14929105822558570', 1, 0, '', NULL, NULL, NULL),
(27692, '2017-04-23 09:23:02', NULL, NULL, 8623, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:23:02', 'admin-1492909126-14929105822558570', 1, 0, '', NULL, NULL, NULL),
(27693, '2017-04-23 09:21:58', NULL, NULL, 8623, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.50, 0.0000, 0.0000, 10.50, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:21:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27694, '2017-04-23 09:23:02', NULL, NULL, 8623, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1492936048', 'admin', '2017-04-23 09:23:02', 'admin-1492909126-14929105822558570', 1, 0, '', NULL, NULL, NULL),
(27695, '2017-04-24 16:31:10', NULL, NULL, 8693, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1493014992', 'admin', '2017-04-24 16:31:10', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(27696, '2017-04-24 16:31:16', NULL, NULL, 8693, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 16:31:16', 'admin-1493014992-14930226759016627', 1, 1, 'SR', NULL, NULL, '10.0'),
(27697, '2017-04-24 16:31:16', NULL, NULL, 8693, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 16:31:16', 'admin-1493014992-14930226759016627', 1, 1, 'SR', NULL, NULL, '10.0'),
(27698, '2017-04-24 16:52:06', NULL, NULL, 8694, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1493014992', 'admin', '2017-04-24 16:52:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27699, '2017-04-24 14:22:40', NULL, NULL, 8687, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 14:22:40', 'admin-1493013350-14930149603438251', 1, 0, '', NULL, NULL, NULL),
(27700, '2017-04-24 14:22:40', NULL, NULL, 8687, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 14:22:40', 'admin-1493013350-14930149603438251', 1, 0, '', NULL, NULL, NULL),
(27701, '2017-04-24 14:22:40', NULL, NULL, 8687, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 14:22:40', 'admin-1493013350-14930149603438251', 1, 0, '', NULL, NULL, NULL),
(27702, '2017-04-24 15:18:42', NULL, NULL, 8690, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 15:18:42', 'admin-1493014992-14930183219096133', 1, 1, 'SR', NULL, NULL, NULL),
(27703, '2017-04-24 15:32:34', NULL, NULL, 8691, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 15:32:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27704, '2017-04-24 15:32:42', NULL, NULL, 8691, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 15:32:42', 'admin-1493014992-14930191621541524', 1, 0, '', NULL, NULL, NULL),
(27705, '2017-04-24 16:03:20', NULL, NULL, 8692, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1493014992', 'admin', '2017-04-24 16:03:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27706, '2017-04-24 16:03:28', NULL, NULL, 8692, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 16:03:28', 'admin-1493014992-1493021008201172', 1, 0, '', NULL, NULL, NULL),
(27707, '2017-04-24 10:19:44', NULL, NULL, 8663, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:19:44', 'admin-1493000362-14930003845735428', 1, 0, '', NULL, NULL, NULL),
(27708, '2017-04-24 10:19:44', NULL, NULL, 8663, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:19:44', 'admin-1493000362-14930003845735428', 1, 0, '', NULL, NULL, NULL),
(27709, '2017-04-24 10:19:44', NULL, NULL, 8663, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:19:44', 'admin-1493000362-14930003845735428', 1, 1, 'SR', NULL, NULL, NULL),
(27710, '2017-04-24 10:19:44', NULL, NULL, 8663, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:19:44', 'admin-1493000362-14930003845735428', 1, 0, '', NULL, NULL, NULL),
(27711, '2017-04-24 10:27:01', NULL, NULL, 8664, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:27:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27712, '2017-04-24 10:27:09', NULL, NULL, 8664, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:27:09', 'admin-1493000362-14930008290832679', 1, 1, 'SR', NULL, NULL, NULL),
(27713, '2017-04-24 10:27:09', NULL, NULL, 8664, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:27:09', 'admin-1493000362-14930008290832679', 1, 1, 'SR', NULL, NULL, NULL),
(27714, '2017-04-24 10:27:28', NULL, NULL, 8664, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:27:28', 'admin-1493000362-14930008485877374', 1, 0, '', NULL, NULL, NULL),
(27715, '2017-04-24 10:27:28', NULL, NULL, 8664, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:27:28', 'admin-1493000362-14930008485877374', 1, 0, '', NULL, NULL, NULL),
(27716, '2017-04-24 16:52:13', NULL, NULL, 8694, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 16:52:13', 'admin-1493014992-14930239331171848', 1, 0, '', NULL, NULL, NULL),
(27717, '2017-04-24 13:57:31', NULL, NULL, 8685, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:57:31', 'admin-1493013350-14930134515761459', 1, 1, 'SR', NULL, NULL, NULL),
(27718, '2017-04-24 13:57:41', NULL, NULL, 8686, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:57:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27719, '2017-04-24 13:58:20', NULL, NULL, 8686, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:58:20', 'admin-1493013350-14930134998936471', 1, 0, '', NULL, NULL, NULL),
(27720, '2017-04-24 13:58:20', NULL, NULL, 8686, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:58:20', 'admin-1493013350-14930134998936471', 1, 0, '', NULL, NULL, NULL),
(27721, '2017-04-24 13:58:20', NULL, NULL, 8686, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:58:20', 'admin-1493013350-14930134998936471', 1, 0, '', NULL, NULL, NULL),
(27722, '2017-04-24 13:58:58', NULL, NULL, 8686, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:58:58', 'admin-1493013350-1493013538397379', 1, 0, '', NULL, NULL, NULL),
(27723, '2017-04-24 13:58:58', NULL, NULL, 8686, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:58:58', 'admin-1493013350-1493013538397379', 1, 1, 'SR', NULL, NULL, NULL),
(27724, '2017-04-24 13:59:46', NULL, NULL, 8686, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:59:46', 'admin-1493013350-14930135861284496', 1, 0, '', NULL, NULL, NULL),
(27725, '2017-04-24 14:02:32', NULL, NULL, 8685, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 14:02:32', 'admin-1493013350-14930137524988997', 1, 0, '', NULL, NULL, NULL),
(27726, '2017-04-24 15:17:13', NULL, NULL, 8690, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1493014992', 'admin', '2017-04-24 15:17:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27727, '2017-04-24 14:53:34', NULL, NULL, 8689, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 14:53:34', 'admin-1493014992-14930168141126790', 1, 0, '', 1, NULL, NULL),
(27728, '2017-04-24 10:58:21', NULL, NULL, 8667, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:58:22', 'admin-1493000362-14930027018273181', 1, 0, '', NULL, NULL, NULL),
(27729, '2017-04-24 10:58:39', NULL, NULL, 8667, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:58:39', 'admin-1493000362-14930027190946716', 1, 0, '', NULL, NULL, NULL),
(27730, '2017-04-24 10:58:39', NULL, NULL, 8667, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:58:39', 'admin-1493000362-14930027190946716', 1, 1, 'SR', NULL, NULL, NULL),
(27731, '2017-04-24 00:00:00', NULL, NULL, 8676, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, NULL, NULL, 1.10, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:02:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27732, '2017-04-24 12:02:16', NULL, NULL, 8670, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:02:16', 'admin-1493005029-14930065366336719', 1, 1, 'SR', NULL, NULL, NULL),
(27733, '2017-04-24 11:43:59', NULL, NULL, 8675, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:43:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27734, '2017-04-24 12:22:48', NULL, NULL, 8677, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:22:48', 'admin-1493005029-14930077684728923', 1, 0, '', NULL, NULL, NULL),
(27735, '2017-04-24 12:22:41', NULL, NULL, 8677, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.20, 0.0000, 0.0000, 10.20, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:22:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27736, '2017-04-24 11:04:22', NULL, NULL, 8670, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:04:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27737, '2017-04-24 14:04:05', NULL, NULL, 8684, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 14:04:05', 'admin-1493013350-149301384560492', 1, 0, '', NULL, NULL, NULL),
(27738, '2017-04-24 14:04:05', NULL, NULL, 8684, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 14:04:05', 'admin-1493013350-149301384560492', 1, 1, 'SR', NULL, NULL, NULL),
(27739, '2017-04-24 14:27:23', NULL, NULL, 8684, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 14:27:23', 'admin-1493014992-14930152437832830', 1, 0, '', NULL, NULL, NULL),
(27740, '2017-04-24 15:18:42', NULL, NULL, 8690, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 15:18:42', 'admin-1493014992-14930183219096133', 1, 0, '', NULL, NULL, NULL),
(27741, '2017-04-24 12:47:09', NULL, NULL, 8679, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:47:09', 'admin-1493005029-14930092295527277', 1, 0, '', NULL, NULL, NULL),
(27742, '2017-04-24 12:47:42', NULL, NULL, 8679, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:47:42', 'admin-1493005029-14930092618667194', 1, 1, 'SR', NULL, NULL, NULL),
(27743, '2017-04-24 12:47:42', NULL, NULL, 8679, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:47:42', 'admin-1493005029-14930092618667194', 1, 1, 'SR', NULL, NULL, NULL),
(27744, '2017-04-24 12:47:42', NULL, NULL, 8679, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:47:42', 'admin-1493005029-14930092618667194', 1, 0, '', NULL, NULL, NULL),
(27745, '2017-04-24 10:37:48', NULL, NULL, 8666, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:37:48', 'admin-1493000362-14930014684908535', 1, 1, 'SR', NULL, NULL, NULL),
(27746, '2017-04-24 10:38:15', NULL, NULL, 8665, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:38:15', 'admin-1493000362-14930014952939868', 1, 1, 'SR', NULL, NULL, NULL),
(27747, '2017-04-24 10:42:01', NULL, NULL, 8666, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:42:01', 'admin-1493000362-14930017210328228', 1, 1, 'SR', NULL, NULL, NULL),
(27748, '2017-04-24 13:11:23', NULL, NULL, 8681, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:11:23', 'admin-1493005029-14930106830701949', 1, 1, 'SR', NULL, NULL, NULL),
(27749, '2017-04-24 16:52:13', NULL, NULL, 8694, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 16:52:13', 'admin-1493014992-14930239331171848', 1, 0, '', NULL, NULL, NULL),
(27750, '2017-04-24 16:03:28', NULL, NULL, 8692, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 16:03:28', 'admin-1493014992-1493021008201172', 1, 1, 'SR', NULL, NULL, NULL),
(27751, '2017-04-24 13:57:31', NULL, NULL, 8685, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:57:31', 'admin-1493013350-14930134515761459', 1, 1, 'SR', NULL, NULL, NULL),
(27752, '2017-04-24 14:22:40', NULL, NULL, 8687, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 14:22:40', 'admin-1493013350-14930149603438251', 1, 0, '', NULL, NULL, NULL),
(27753, '2017-04-24 14:22:32', NULL, NULL, 8687, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1493014992', 'admin', '2017-04-24 14:22:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27754, '2017-04-24 14:04:05', NULL, NULL, 8684, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 14:04:05', 'admin-1493013350-149301384560492', 1, 0, '', NULL, NULL, NULL),
(27755, '2017-04-24 14:03:38', NULL, NULL, 8684, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 14:03:38', 'admin-1493013350-14930138181177957', 1, 0, '', NULL, NULL, NULL),
(27756, '2017-04-24 13:57:31', NULL, NULL, 8685, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:57:31', 'admin-1493013350-14930134515761459', 1, 1, 'SR', NULL, NULL, NULL),
(27757, '2017-04-24 13:57:31', NULL, NULL, 8685, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:57:31', 'admin-1493013350-14930134515761459', 1, 1, 'SR', NULL, NULL, NULL),
(27758, '2017-04-24 13:56:50', NULL, NULL, 8685, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:56:50', 'admin-1493013350-14930134106955296', 1, 0, '', NULL, NULL, NULL),
(27759, '2017-04-24 13:55:57', NULL, NULL, 8685, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:55:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27760, '2017-04-24 13:56:50', NULL, NULL, 8685, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:56:50', 'admin-1493013350-14930134106955296', 1, 0, '', NULL, NULL, NULL),
(27761, '2017-04-24 12:40:58', NULL, NULL, 8678, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:40:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27762, '2017-04-24 12:41:00', NULL, NULL, 8678, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:41:00', 'admin-1493005029-1493008860399852', 1, 1, 'SR', NULL, NULL, NULL),
(27763, '2017-04-24 12:46:54', NULL, NULL, 8679, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:46:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27764, '2017-04-24 12:47:09', NULL, NULL, 8679, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:47:09', 'admin-1493005029-14930092295527277', 1, 1, 'SR', NULL, NULL, NULL),
(27765, '2017-04-24 12:47:09', NULL, NULL, 8679, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:47:09', 'admin-1493005029-14930092295527277', 1, 0, '', NULL, NULL, NULL),
(27766, '2017-04-24 12:47:09', NULL, NULL, 8679, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:47:09', 'admin-1493005029-14930092295527277', 1, 0, '', NULL, NULL, NULL),
(27767, '2017-04-24 13:53:27', NULL, NULL, 8684, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:53:27', 'admin-1493005029-1493013207389918', 1, 1, 'SR', NULL, NULL, NULL),
(27768, '2017-04-24 12:11:39', NULL, NULL, 8671, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:11:39', 'admin-1493005029-1493007099706753', 1, 0, '', NULL, NULL, NULL),
(27769, '2017-04-24 12:22:48', NULL, NULL, 8677, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:22:48', 'admin-1493005029-14930077684728923', 1, 0, '', NULL, NULL, NULL),
(27770, '2017-04-24 12:22:48', NULL, NULL, 8677, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:22:48', 'admin-1493005029-14930077684728923', 1, 0, '', NULL, NULL, NULL),
(27771, '2017-04-24 12:23:04', NULL, NULL, 8677, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:23:04', 'admin-1493005029-14930077843636564', 1, 1, 'SR', NULL, NULL, NULL),
(27772, '2017-04-24 12:23:04', NULL, NULL, 8677, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:23:04', 'admin-1493005029-14930077843636564', 1, 1, 'SR', NULL, NULL, NULL),
(27773, '2017-04-24 13:53:27', NULL, NULL, 8684, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:53:27', 'admin-1493005029-1493013207389918', 1, 0, '', NULL, NULL, NULL),
(27774, '2017-04-24 13:47:46', NULL, NULL, 8684, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:47:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27775, '2017-04-24 13:25:15', NULL, NULL, 8683, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:25:15', 'admin-1493005029-14930115152671290', 1, 1, 'SR', 1, NULL, NULL),
(27776, '2017-04-24 13:14:20', NULL, NULL, 8682, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:14:20', 'admin-1493005029-1493010859935769', 1, 1, 'SR', NULL, NULL, NULL),
(27777, '2017-04-24 13:25:15', NULL, NULL, 8683, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:25:15', 'admin-1493005029-14930115152671290', 1, 1, 'SR', 1, NULL, NULL),
(27778, '2017-04-24 13:14:03', NULL, NULL, 8682, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:14:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27779, '2017-04-24 13:14:20', NULL, NULL, 8682, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:14:20', 'admin-1493005029-1493010859935769', 1, 0, '', NULL, NULL, NULL),
(27780, '2017-04-24 11:36:46', NULL, NULL, 8673, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:36:46', 'admin-1493000362-14930050062271854', 1, 0, '', NULL, NULL, NULL),
(27781, '2017-04-24 11:36:46', NULL, NULL, 8673, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:36:46', 'admin-1493000362-14930050062271854', 1, 0, '', NULL, NULL, NULL),
(27782, '2017-04-24 11:36:46', NULL, NULL, 8673, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:36:46', 'admin-1493000362-14930050062271854', 1, 1, 'SR', NULL, NULL, NULL),
(27783, '2017-04-24 11:36:46', NULL, NULL, 8673, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:36:46', 'admin-1493000362-14930050062271854', 1, 1, 'SR', NULL, NULL, NULL),
(27784, '2017-04-24 11:37:58', NULL, NULL, 8674, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:37:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27785, '2017-04-24 11:38:12', NULL, NULL, 8674, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:38:12', 'admin-1493005029-1493005092660978', 1, 0, '', NULL, NULL, NULL),
(27786, '2017-04-24 11:38:12', NULL, NULL, 8674, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:38:12', 'admin-1493005029-1493005092660978', 1, 0, '', NULL, NULL, NULL),
(27787, '2017-04-24 00:00:00', NULL, NULL, 8675, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:03:00', 'admin-1493000362-14930029801587314', 1, 1, 'SR', NULL, NULL, NULL),
(27788, '2017-04-24 00:00:00', NULL, NULL, 8676, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:03:00', 'admin-1493000362-14930029801587314', 1, 1, 'SR', NULL, NULL, NULL),
(27789, '2017-04-24 09:28:42', NULL, NULL, 8659, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1493014992', 'admin', '2017-04-24 09:28:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27790, '2017-04-24 09:29:07', NULL, NULL, 8659, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 09:29:07', 'admin-1492995574-14929973468786020', 1, 0, '', NULL, NULL, NULL),
(27791, '2017-04-24 09:29:07', NULL, NULL, 8659, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 09:29:07', 'admin-1492995574-14929973468786020', 1, 0, '', NULL, NULL, NULL),
(27792, '2017-04-24 09:29:07', NULL, NULL, 8659, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 09:29:07', 'admin-1492995574-14929973468786020', 1, 0, '', NULL, NULL, NULL),
(27793, '2017-04-24 09:29:32', NULL, NULL, 8659, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 09:29:32', 'admin-1492995574-14929973723967288', 1, 1, 'SR', NULL, NULL, NULL),
(27794, '2017-04-24 12:58:04', NULL, NULL, 8679, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:58:04', 'admin-1493005029-14930098847267580', 1, 1, 'SR', NULL, NULL, NULL),
(27795, '2017-04-24 12:58:10', NULL, NULL, 8680, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:58:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27796, '2017-04-24 12:58:28', NULL, NULL, 8680, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:58:28', 'admin-1493005029-14930099084765065', 1, 0, '', NULL, NULL, NULL),
(27797, '2017-04-24 13:09:41', NULL, NULL, 8681, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:09:41', 'admin-1493005029-14930105810471748', 1, 1, 'SR', NULL, NULL, NULL),
(27798, '2017-04-24 13:07:33', NULL, NULL, 8681, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1493014992', 'admin', '2017-04-24 13:07:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27799, '2017-04-24 12:58:28', NULL, NULL, 8680, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:58:28', 'admin-1493005029-14930099084765065', 1, 0, '', NULL, NULL, NULL),
(27800, '2017-04-24 12:23:04', NULL, NULL, 8677, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:23:04', 'admin-1493005029-14930077843636564', 1, 0, '', NULL, NULL, NULL),
(27801, '2017-04-24 11:04:29', NULL, NULL, 8670, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:04:29', 'admin-1493000362-1493003069616495', 1, 1, 'SR', NULL, NULL, NULL),
(27802, '2017-04-24 12:23:04', NULL, NULL, 8677, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 12:23:04', 'admin-1493005029-14930077843636564', 1, 1, 'SR', NULL, NULL, NULL),
(27803, '2017-04-24 09:29:42', NULL, NULL, 8658, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 09:29:42', 'admin-1492995574-1492997381887915', 1, 0, '', NULL, NULL, NULL),
(27804, '2017-04-24 09:29:42', NULL, NULL, 8658, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 09:29:42', 'admin-1492995574-1492997381887915', 1, 0, '', NULL, NULL, NULL),
(27805, '2017-04-24 09:42:33', NULL, NULL, 8660, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1493014992', 'admin', '2017-04-24 09:42:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27806, '2017-04-24 09:42:44', NULL, NULL, 8660, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 09:42:44', 'admin-1492995574-14929981644925872', 1, 0, '', NULL, NULL, NULL),
(27807, '2017-04-24 09:42:44', NULL, NULL, 8660, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 09:42:44', 'admin-1492995574-14929981644925872', 1, 0, '', NULL, NULL, NULL),
(27808, '2017-04-24 09:42:44', NULL, NULL, 8660, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 09:42:44', 'admin-1492995574-14929981644925872', 1, 0, '', NULL, NULL, NULL),
(27809, '2017-04-24 09:42:44', NULL, NULL, 8660, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 09:42:44', 'admin-1492995574-14929981644925872', 1, 1, 'SR', NULL, NULL, NULL),
(27810, '2017-04-24 09:42:44', NULL, NULL, 8660, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 09:42:44', 'admin-1492995574-14929981644925872', 1, 1, 'SR', NULL, NULL, NULL),
(27811, '2017-04-24 10:02:26', NULL, NULL, 8661, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:02:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27812, '2017-04-24 10:02:42', NULL, NULL, 8661, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:02:42', 'admin-1492995574-14929993619277949', 1, 0, '', NULL, NULL, NULL),
(27813, '2017-04-24 10:02:42', NULL, NULL, 8661, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:02:42', 'admin-1492995574-14929993619277949', 1, 0, '', NULL, NULL, NULL),
(27814, '2017-04-24 10:02:42', NULL, NULL, 8661, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:02:42', 'admin-1492995574-14929993619277949', 1, 1, 'SR', NULL, NULL, NULL),
(27815, '2017-04-24 10:02:42', NULL, NULL, 8661, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:02:42', 'admin-1492995574-14929993619277949', 1, 0, '', NULL, NULL, NULL),
(27816, '2017-04-24 10:16:33', NULL, NULL, 8662, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:16:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27817, '2017-04-24 10:16:44', NULL, NULL, 8662, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:16:44', 'admin-1492995574-14930002037928456', 1, 0, '', NULL, NULL, NULL),
(27818, '2017-04-24 10:16:44', NULL, NULL, 8662, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:16:44', 'admin-1492995574-14930002037928456', 1, 0, '', NULL, NULL, NULL),
(27819, '2017-04-24 10:16:44', NULL, NULL, 8662, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:16:44', 'admin-1492995574-14930002037928456', 1, 1, 'SR', NULL, NULL, NULL),
(27820, '2017-04-24 11:22:26', NULL, NULL, 8671, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:22:26', 'admin-1493000362-14930041465184686', 1, 1, 'SR', NULL, NULL, NULL),
(27821, '2017-04-24 11:22:26', NULL, NULL, 8671, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:22:26', 'admin-1493000362-14930041465184686', 1, 1, 'SR', NULL, NULL, NULL),
(27822, '2017-04-24 11:23:08', NULL, NULL, 8667, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:23:08', 'admin-1493000362-14930041884233337', 1, 0, '', NULL, NULL, NULL),
(27823, '2017-04-24 11:29:13', NULL, NULL, 8672, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.80, 0.0000, 0.0000, 9.80, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:29:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27824, '2017-04-24 11:29:36', NULL, NULL, 8672, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:29:36', 'admin-1493000362-14930045767895768', 1, 0, '', NULL, NULL, NULL),
(27825, '2017-04-24 11:29:36', NULL, NULL, 8672, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:29:36', 'admin-1493000362-14930045767895768', 1, 0, '', NULL, NULL, NULL),
(27826, '2017-04-24 11:29:36', NULL, NULL, 8672, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:29:36', 'admin-1493000362-14930045767895768', 1, 0, '', NULL, NULL, NULL),
(27827, '2017-04-24 11:29:36', NULL, NULL, 8672, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:29:36', 'admin-1493000362-14930045767895768', 1, 0, '', NULL, NULL, NULL),
(27828, '2017-04-24 11:30:04', NULL, NULL, 8672, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:30:04', 'admin-1493000362-14930046047719727', 1, 1, 'SR', NULL, NULL, NULL),
(27829, '2017-04-24 11:30:05', NULL, NULL, 8672, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:30:05', 'admin-1493000362-14930046047719727', 1, 0, '', NULL, NULL, NULL),
(27830, '2017-04-24 11:30:05', NULL, NULL, 8672, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:30:05', 'admin-1493000362-14930046047719727', 1, 1, 'SR', NULL, NULL, NULL),
(27831, '2017-04-24 11:35:49', NULL, NULL, 8673, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:35:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27832, '2017-04-24 11:30:21', NULL, NULL, 8670, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:30:21', 'admin-1493000362-14930046217716560', 1, 0, '', NULL, NULL, NULL),
(27833, '2017-04-24 11:22:21', NULL, NULL, 8671, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:22:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27834, '2017-04-24 11:22:26', NULL, NULL, 8671, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 11:22:26', 'admin-1493000362-14930041465184686', 1, 1, 'SR', NULL, NULL, NULL),
(27835, '2017-04-24 10:58:09', NULL, NULL, 8667, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:58:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27836, '2017-04-24 10:58:21', NULL, NULL, 8667, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:58:21', 'admin-1493000362-14930027018273181', 1, 0, '', NULL, NULL, NULL),
(27837, '2017-04-24 10:35:39', NULL, NULL, 8665, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:35:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27838, '2017-04-24 10:36:33', NULL, NULL, 8665, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:36:33', 'admin-1493000362-1493001393382211', 1, 0, '', NULL, NULL, NULL),
(27839, '2017-04-24 10:36:33', NULL, NULL, 8665, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:36:33', 'admin-1493000362-1493001393382211', 1, 0, '', NULL, NULL, NULL),
(27840, '2017-04-24 10:36:33', NULL, NULL, 8665, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:36:33', 'admin-1493000362-1493001393382211', 1, 1, 'SR', NULL, NULL, NULL),
(27841, '2017-04-24 10:36:33', NULL, NULL, 8665, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:36:33', 'admin-1493000362-1493001393382211', 1, 1, 'SR', NULL, NULL, NULL),
(27842, '2017-04-24 10:37:38', NULL, NULL, 8666, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:37:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27843, '2017-04-24 10:19:30', NULL, NULL, 8663, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:19:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27844, '2017-04-24 10:16:44', NULL, NULL, 8662, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 10:16:44', 'admin-1492995574-14930002037928456', 1, 1, 'SR', NULL, NULL, NULL),
(27845, '2017-04-24 09:29:32', NULL, NULL, 8659, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 09:29:32', 'admin-1492995574-14929973723967288', 1, 0, '', NULL, NULL, NULL),
(27846, '2017-04-24 09:28:31', NULL, NULL, 8658, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493014992', 'admin', '2017-04-24 09:28:31', 'admin-1492995574-1492997311384176', 1, 0, '', NULL, NULL, NULL),
(27847, '2017-04-24 09:28:28', NULL, NULL, 8658, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1493014992', 'admin', '2017-04-24 09:28:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27848, '2017-04-26 14:21:00', NULL, NULL, 8703, 0, 156, '90', 'House Cheddar Omelet', 'no salad', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 14:21:00', 'admin-1493187618-1493187660589147', 1, 0, '', NULL, NULL, NULL),
(27849, '2017-04-26 14:21:00', NULL, NULL, 8703, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 14:21:00', 'admin-1493187618-1493187660589147', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(27850, '2017-04-26 14:21:00', NULL, NULL, 8703, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 14:21:00', 'admin-1493187618-1493187660589147', 1, 0, '', NULL, NULL, NULL),
(27851, '2017-04-26 14:21:00', NULL, NULL, 8703, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 14:21:00', 'admin-1493187618-1493187660589147', 1, 0, '', NULL, NULL, NULL),
(27852, '2017-04-26 14:21:11', NULL, NULL, 8702, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 14:21:11', 'admin-1493187618-14931876709782126', 1, 0, '', NULL, NULL, '10.0'),
(27853, '2017-04-26 14:21:35', NULL, NULL, 8703, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 14:21:35', 'admin-1493187618-14931876957184836', 1, 1, 'SR', NULL, NULL, NULL),
(27854, '2017-04-26 14:21:35', NULL, NULL, 8703, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 14:21:35', 'admin-1493187618-14931876957184836', 1, 1, 'SR', NULL, NULL, NULL),
(27855, '2017-04-26 14:21:35', NULL, NULL, 8703, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 14:21:35', 'admin-1493187618-14931876957184836', 1, 1, 'SR', NULL, NULL, NULL),
(27856, '2017-04-26 14:24:40', NULL, NULL, 8704, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 14:24:40', 'admin-1493187618-14931878807352085', 1, 1, 'SR', 1, NULL, NULL),
(27857, '2017-04-26 14:29:08', NULL, NULL, 8699, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 14:29:08', 'admin-1493187618-14931881488003281', 1, 0, '', NULL, NULL, NULL),
(27858, '2017-04-26 16:24:06', NULL, NULL, 8706, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1493199894', 'admin', '2017-04-26 16:24:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27859, '2017-04-26 16:24:16', NULL, NULL, 8706, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 16:24:16', 'admin-1493187618-14931950561959638', 1, 1, 'SR', NULL, NULL, NULL),
(27860, '2017-04-26 17:44:44', NULL, NULL, 8707, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1493199894', 'admin', '2017-04-26 17:44:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27861, '2017-04-26 10:40:33', NULL, NULL, 8696, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 10:40:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27862, '2017-04-26 10:40:40', NULL, NULL, 8696, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 10:40:40', 'admin-1493168226-1493174440169853', 1, 0, '', NULL, NULL, NULL),
(27863, '2017-04-26 10:40:40', NULL, NULL, 8696, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 10:40:40', 'admin-1493168226-1493174440169853', 1, 0, '', NULL, NULL, NULL),
(27864, '2017-04-26 10:40:53', NULL, NULL, 8696, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 10:40:53', 'admin-1493168226-14931744531459649', 1, 0, '', NULL, NULL, NULL),
(27865, '2017-04-26 10:40:53', NULL, NULL, 8696, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 10:40:53', 'admin-1493168226-14931744531459649', 1, 1, 'SR', NULL, NULL, NULL),
(27866, '2017-04-26 10:47:55', NULL, NULL, 8697, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1493199894', 'admin', '2017-04-26 10:47:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27867, '2017-04-26 10:47:59', NULL, NULL, 8697, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 10:47:59', 'admin-1493168226-149317487952041', 1, 1, 'SR', NULL, NULL, NULL),
(27868, '2017-04-26 10:47:59', NULL, NULL, 8697, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 10:47:59', 'admin-1493168226-149317487952041', 1, 1, 'SR', NULL, NULL, NULL),
(27869, '2017-04-26 10:47:59', NULL, NULL, 8697, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 10:47:59', 'admin-1493168226-149317487952041', 1, 1, 'SR', NULL, NULL, NULL),
(27870, '2017-04-26 10:49:58', NULL, NULL, 8698, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1493199894', 'admin', '2017-04-26 10:49:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27871, '2017-04-26 10:50:02', NULL, NULL, 8698, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 10:50:02', 'admin-1493168226-14931750021508987', 1, 0, '', NULL, NULL, NULL),
(27872, '2017-04-26 10:50:07', NULL, NULL, 8698, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 10:50:07', 'admin-1493168226-14931750075223139', 1, 0, '', NULL, NULL, NULL),
(27873, '2017-04-26 13:29:08', NULL, NULL, 8699, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1493199894', 'admin', '2017-04-26 13:29:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27874, '2017-04-26 13:29:32', NULL, NULL, 8699, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 13:29:32', 'admin-1493168226-1493184572012336', 1, 0, '', NULL, NULL, NULL),
(27875, '2017-04-26 13:29:32', NULL, NULL, 8699, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 13:29:32', 'admin-1493168226-1493184572012336', 1, 0, '', NULL, NULL, NULL),
(27876, '2017-04-26 13:29:39', NULL, NULL, 8699, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 13:29:39', 'admin-1493168226-1493184578822584', 1, 1, 'SR', NULL, NULL, NULL),
(27877, '2017-04-26 13:34:26', NULL, NULL, 8700, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1493199894', 'admin', '2017-04-26 13:34:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27878, '2017-04-26 13:34:35', NULL, NULL, 8700, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 13:34:35', 'admin-1493168226-14931848750644521', 1, 0, '', NULL, NULL, NULL),
(27879, '2017-04-26 13:34:35', NULL, NULL, 8700, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 13:34:35', 'admin-1493168226-14931848750644521', 1, 0, '', NULL, NULL, NULL),
(27880, '2017-04-26 13:34:35', NULL, NULL, 8700, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 13:34:35', 'admin-1493168226-14931848750644521', 1, 0, '', NULL, NULL, NULL),
(27881, '2017-04-26 14:21:35', NULL, NULL, 8703, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 14:21:35', 'admin-1493187618-14931876957184836', 1, 0, '', NULL, NULL, NULL),
(27882, '2017-04-26 14:21:35', NULL, NULL, 8703, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 14:21:35', 'admin-1493187618-14931876957184836', 1, 0, '', NULL, NULL, NULL),
(27883, '2017-04-26 17:59:38', NULL, NULL, 8709, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 17:59:38', 'admin-1493199894-14932007783584659', 1, 0, '', NULL, NULL, NULL),
(27884, '2017-04-26 17:47:17', NULL, NULL, 8707, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 17:47:17', 'admin-1493199894-14932000375469411', 1, 1, 'SR', NULL, NULL, NULL),
(27885, '2017-04-26 17:53:20', NULL, NULL, 8708, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1493199894', 'admin', '2017-04-26 17:53:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27886, '2017-04-26 17:53:40', NULL, NULL, 8708, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 2, 11.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 17:53:40', 'admin-1493199894-14932004202199272', 1, 1, 'SR', NULL, NULL, NULL),
(27887, '2017-04-26 17:53:40', NULL, NULL, 8708, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 17:53:40', 'admin-1493199894-14932004202199272', 1, 0, '', NULL, NULL, NULL),
(27888, '2017-04-26 17:53:40', NULL, NULL, 8708, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 17:53:40', 'admin-1493199894-14932004202199272', 1, 0, '', NULL, NULL, NULL),
(27889, '2017-04-26 17:59:33', NULL, NULL, 8709, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1493199894', 'admin', '2017-04-26 17:59:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27890, '2017-04-26 17:59:38', NULL, NULL, 8709, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 17:59:38', 'admin-1493199894-14932007783584659', 1, 0, '', NULL, NULL, NULL),
(27891, '2017-04-26 13:48:31', NULL, NULL, 8702, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 13:48:31', 'admin-1493168226-1493185711600923', 1, 1, 'SR', NULL, NULL, '10.0'),
(27892, '2017-04-26 13:48:31', NULL, NULL, 8702, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 13:48:31', 'admin-1493168226-1493185711600923', 1, 0, '', NULL, NULL, '10.0'),
(27893, '2017-04-26 14:12:26', NULL, NULL, 8703, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.80, 0.0000, 0.0000, 12.80, 1, '27', 1, '1493199894', 'admin', '2017-04-26 14:12:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27894, '2017-04-26 14:21:00', NULL, NULL, 8703, 0, 153, '87', 'Wake Me Up!', 'no salad n beans', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 14:21:00', 'admin-1493187618-1493187660589147', 1, 0, '', NULL, NULL, NULL),
(27895, '2017-04-26 09:06:55', NULL, NULL, 8695, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1493199894', 'admin', '2017-04-26 09:06:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27896, '2017-04-26 09:07:03', NULL, NULL, 8695, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 09:07:03', 'admin-1493168226-14931688228069582', 1, 0, '', NULL, NULL, NULL),
(27897, '2017-04-26 09:07:03', NULL, NULL, 8695, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 09:07:03', 'admin-1493168226-14931688228069582', 1, 0, '', NULL, NULL, NULL),
(27898, '2017-04-26 09:07:15', NULL, NULL, 8695, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 09:07:15', 'admin-1493168226-14931688349383956', 1, 0, '', NULL, NULL, NULL),
(27899, '2017-04-26 17:45:55', NULL, NULL, 8707, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 17:45:55', 'admin-1493199894-14931999555053473', 1, 1, 'SR', NULL, NULL, NULL),
(27900, '2017-04-26 17:45:55', NULL, NULL, 8707, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 17:45:55', 'admin-1493199894-14931999555053473', 1, 1, 'SR', NULL, NULL, NULL),
(27901, '2017-04-26 13:48:31', NULL, NULL, 8702, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 13:48:31', 'admin-1493168226-1493185711600923', 1, 1, 'SR', NULL, NULL, '10.0'),
(27902, '2017-04-26 13:48:31', NULL, NULL, 8702, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 13:48:31', 'admin-1493168226-1493185711600923', 1, 0, '', NULL, NULL, '10.0'),
(27903, '2017-04-26 13:48:31', NULL, NULL, 8702, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 13:48:31', 'admin-1493168226-1493185711600923', 1, 0, '', NULL, NULL, '10.0'),
(27904, '2017-04-26 13:48:16', NULL, NULL, 8702, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1493199894', 'admin', '2017-04-26 13:48:16', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(27905, '2017-04-26 09:07:15', NULL, NULL, 8695, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493199894', 'admin', '2017-04-26 09:07:15', 'admin-1493168226-14931688349383956', 1, 0, '', NULL, NULL, NULL),
(27906, '2017-04-27 12:48:37', NULL, NULL, 8716, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 12:48:37', 'admin-1493268508-14932685174798048', 1, 1, 'SR', NULL, NULL, NULL),
(27907, '2017-04-27 13:00:35', NULL, NULL, 8717, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1493278057', 'admin', '2017-04-27 13:00:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27908, '2017-04-27 13:02:04', NULL, NULL, 8717, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 13:02:04', 'admin-1493268508-14932693247235072', 1, 0, '', NULL, NULL, NULL),
(27909, '2017-04-27 13:02:04', NULL, NULL, 8717, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 13:02:04', 'admin-1493268508-14932693247235072', 1, 0, '', NULL, NULL, NULL),
(27910, '2017-04-27 13:02:14', NULL, NULL, 8717, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 13:02:14', 'admin-1493268508-14932693339919072', 1, 1, 'SR', NULL, NULL, NULL),
(27911, '2017-04-27 13:02:14', NULL, NULL, 8717, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 13:02:14', 'admin-1493268508-14932693339919072', 1, 0, '', NULL, NULL, NULL),
(27912, '2017-04-27 13:33:31', NULL, NULL, 8718, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1493278057', 'admin', '2017-04-27 13:33:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27913, '2017-04-27 13:33:50', NULL, NULL, 8718, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 13:33:50', 'admin-1493268508-149327122999682', 1, 0, '', NULL, NULL, NULL),
(27914, '2017-04-27 15:27:15', NULL, NULL, 8725, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 15:27:15', 'admin-1493268508-14932780356125465', 1, 0, '', NULL, NULL, NULL),
(27915, '2017-04-27 15:33:31', NULL, NULL, 8725, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 15:33:31', 'admin-1493278057-14932784117795819', 1, 1, 'SR', NULL, NULL, NULL),
(27916, '2017-04-27 13:41:52', NULL, NULL, 8721, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 13:41:52', 'admin-1493268508-14932717124208372', 1, 1, 'SR', 1, NULL, NULL),
(27917, '2017-04-27 10:53:29', NULL, NULL, 8711, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 10:53:29', 'admin-1493255212-14932616090409182', 1, 0, '', NULL, NULL, NULL),
(27918, '2017-04-27 10:53:29', NULL, NULL, 8711, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 10:53:29', 'admin-1493255212-14932616090409182', 1, 0, '', NULL, NULL, NULL),
(27919, '2017-04-27 12:16:20', NULL, NULL, 8714, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 12:16:20', 'admin-1493255212-1493266580536904', 1, 1, 'SR', NULL, NULL, NULL),
(27920, '2017-04-27 12:16:20', NULL, NULL, 8714, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 12:16:20', 'admin-1493255212-1493266580536904', 1, 0, '', NULL, NULL, NULL),
(27921, '2017-04-27 12:16:20', NULL, NULL, 8714, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 12:16:20', 'admin-1493255212-1493266580536904', 1, 1, 'SR', NULL, NULL, NULL),
(27922, '2017-04-27 12:16:20', NULL, NULL, 8714, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 12:16:20', 'admin-1493255212-1493266580536904', 1, 1, 'SR', NULL, NULL, NULL),
(27923, '2017-04-27 12:48:18', NULL, NULL, 8716, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1493278057', 'admin', '2017-04-27 12:48:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27924, '2017-04-27 12:48:22', NULL, NULL, 8716, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 12:48:22', 'admin-1493255212-14932685019849617', 1, 0, '', NULL, NULL, NULL),
(27925, '2017-04-27 15:27:55', NULL, NULL, 8725, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 15:27:55', 'admin-1493278057-14932780755659170', 1, 0, '', NULL, NULL, NULL),
(27926, '2017-04-27 17:09:09', NULL, NULL, 8726, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1493278057', 'admin', '2017-04-27 17:09:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27927, '2017-04-27 15:26:38', NULL, NULL, 8725, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 15:26:38', 'admin-1493268508-1493277997967632', 1, 1, 'SR', NULL, NULL, NULL),
(27928, '2017-04-27 15:26:31', NULL, NULL, 8725, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1493278057', 'admin', '2017-04-27 15:26:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27929, '2017-04-27 14:30:31', NULL, NULL, 8724, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 14:30:31', 'admin-1493268508-1493274631388725', 1, 1, 'SR', NULL, NULL, NULL),
(27930, '2017-04-27 14:30:04', NULL, NULL, 8724, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1493278057', 'admin', '2017-04-27 14:30:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27931, '2017-04-27 14:21:44', NULL, NULL, 8723, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 14:21:44', 'admin-1493268508-14932741046415239', 1, 1, 'SR', NULL, NULL, NULL),
(27932, '2017-04-27 14:21:44', NULL, NULL, 8723, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 14:21:44', 'admin-1493268508-14932741046415239', 1, 1, 'SR', NULL, NULL, NULL),
(27933, '2017-04-27 14:21:38', NULL, NULL, 8723, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1493278057', 'admin', '2017-04-27 14:21:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27934, '2017-04-27 13:43:51', NULL, NULL, 8722, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 13:43:51', 'admin-1493268508-1493271831338534', 1, 0, '', NULL, NULL, NULL),
(27935, '2017-04-27 13:43:51', NULL, NULL, 8722, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 13:43:51', 'admin-1493268508-1493271831338534', 1, 0, '', NULL, NULL, NULL),
(27936, '2017-04-27 13:43:31', NULL, NULL, 8722, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1493278057', 'admin', '2017-04-27 13:43:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27937, '2017-04-27 13:36:34', NULL, NULL, 8720, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 13:36:34', 'admin-1493268508-14932713939326661', 1, 1, 'SR', NULL, NULL, NULL),
(27938, '2017-04-27 13:36:24', NULL, NULL, 8720, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1493278057', 'admin', '2017-04-27 13:36:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27939, '2017-04-27 13:34:17', NULL, NULL, 8719, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 13:34:17', 'admin-1493268508-14932712576358650', 1, 1, 'SR', NULL, NULL, NULL),
(27940, '2017-04-27 13:34:17', NULL, NULL, 8719, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 13:34:17', 'admin-1493268508-14932712576358650', 1, 0, '', NULL, NULL, NULL),
(27941, '2017-04-27 13:33:50', NULL, NULL, 8718, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 13:33:50', 'admin-1493268508-149327122999682', 1, 0, '', NULL, NULL, NULL),
(27942, '2017-04-27 13:33:56', NULL, NULL, 8718, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 13:33:56', 'admin-1493268508-14932712362368865', 1, 0, '', NULL, NULL, NULL),
(27943, '2017-04-27 13:34:10', NULL, NULL, 8719, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1493278057', 'admin', '2017-04-27 13:34:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27944, '2017-04-27 12:12:41', NULL, NULL, 8715, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 12:12:41', 'admin-1493255212-14932663614788263', 1, 0, '', NULL, NULL, NULL),
(27945, '2017-04-27 12:12:41', NULL, NULL, 8715, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 12:12:41', 'admin-1493255212-14932663614788263', 1, 0, '', NULL, NULL, NULL),
(27946, '2017-04-27 12:16:07', NULL, NULL, 8714, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 12:16:07', 'admin-1493255212-1493266567651774', 1, 1, 'SR', NULL, NULL, NULL),
(27947, '2017-04-27 12:16:07', NULL, NULL, 8714, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 12:16:07', 'admin-1493255212-1493266567651774', 1, 1, 'SR', NULL, NULL, NULL),
(27948, '2017-04-27 12:16:07', NULL, NULL, 8714, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 12:16:07', 'admin-1493255212-1493266567651774', 1, 1, 'SR', NULL, NULL, NULL),
(27949, '2017-04-27 12:16:07', NULL, NULL, 8714, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 12:16:07', 'admin-1493255212-1493266567651774', 1, 1, 'SR', NULL, NULL, NULL),
(27950, '2017-04-27 12:16:07', NULL, NULL, 8714, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 12:16:07', 'admin-1493255212-1493266567651774', 1, 0, '', NULL, NULL, NULL),
(27951, '2017-04-27 17:09:15', NULL, NULL, 8726, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 17:09:15', 'admin-1493278057-14932841554117158', 1, 1, 'SR', NULL, NULL, NULL),
(27952, '2017-04-27 17:09:15', NULL, NULL, 8726, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 17:09:15', 'admin-1493278057-14932841554117158', 1, 1, 'SR', NULL, NULL, NULL),
(27953, '2017-04-27 10:53:35', NULL, NULL, 8711, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 10:53:35', 'admin-1493255212-14932616154062549', 1, 1, 'SR', NULL, NULL, NULL),
(27954, '2017-04-27 10:58:41', NULL, NULL, 8712, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1493278057', 'admin', '2017-04-27 10:58:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27955, '2017-04-27 10:58:53', NULL, NULL, 8712, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 10:58:53', 'admin-1493255212-14932619329332938', 1, 0, '', NULL, NULL, NULL),
(27956, '2017-04-27 10:59:00', NULL, NULL, 8712, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 10:59:00', 'admin-1493255212-14932619400187727', 1, 0, '', NULL, NULL, NULL),
(27957, '2017-04-27 11:04:18', NULL, NULL, 8713, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 11:04:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27958, '2017-04-27 11:05:40', NULL, NULL, 8713, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 11:05:40', 'admin-1493255212-14932623394322117', 1, 0, '', NULL, NULL, NULL),
(27959, '2017-04-27 11:05:40', NULL, NULL, 8713, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 11:05:40', 'admin-1493255212-14932623394322117', 1, 0, '', NULL, NULL, NULL),
(27960, '2017-04-27 11:05:40', NULL, NULL, 8713, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 2, 9.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 11:05:40', 'admin-1493255212-14932623394322117', 1, 1, 'SR', NULL, NULL, NULL),
(27961, '2017-04-27 11:42:37', NULL, NULL, 8713, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 11:42:37', 'admin-1493255212-14932645572472989', 1, 1, 'SR', NULL, NULL, NULL),
(27962, '2017-04-27 12:11:09', NULL, NULL, 8714, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.10, 0.0000, 0.0000, 12.10, 1, '27', 1, '1493278057', 'admin', '2017-04-27 12:11:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27963, '2017-04-27 12:12:29', NULL, NULL, 8715, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1493278057', 'admin', '2017-04-27 12:12:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27964, '2017-04-27 12:12:41', NULL, NULL, 8715, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 12:12:41', 'admin-1493255212-14932663614788263', 1, 1, 'SR', NULL, NULL, NULL),
(27965, '2017-04-27 10:53:21', NULL, NULL, 8711, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1493278057', 'admin', '2017-04-27 10:53:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27966, '2017-04-27 09:16:33', NULL, NULL, 8710, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 09:16:33', 'admin-1493255212-14932557934177132', 1, 1, 'SR', NULL, NULL, NULL),
(27967, '2017-04-27 09:16:33', NULL, NULL, 8710, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 09:16:33', 'admin-1493255212-14932557934177132', 1, 0, '', NULL, NULL, NULL),
(27968, '2017-04-27 09:16:20', NULL, NULL, 8710, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1493278057', 'admin', '2017-04-27 09:16:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27969, '2017-04-28 11:06:51', NULL, NULL, 8734, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:06:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27970, '2017-04-28 11:07:03', NULL, NULL, 8734, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:07:03', 'admin-1493341256-14933488231456530', 1, 0, '', NULL, NULL, NULL),
(27971, '2017-04-28 11:07:03', NULL, NULL, 8734, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:07:03', 'admin-1493341256-14933488231456530', 1, 0, '', NULL, NULL, NULL),
(27972, '2017-04-28 11:07:03', NULL, NULL, 8734, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:07:03', 'admin-1493341256-14933488231456530', 1, 1, 'SR', NULL, NULL, NULL),
(27973, '2017-04-28 11:07:03', NULL, NULL, 8734, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:07:03', 'admin-1493341256-14933488231456530', 1, 1, 'SR', NULL, NULL, NULL),
(27974, '2017-04-28 11:09:18', NULL, NULL, 8735, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.79, 0.0000, 0.0000, 10.79, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:09:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27975, '2017-04-28 17:26:19', NULL, NULL, 8744, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1493353672', 'admin', '2017-04-28 17:26:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27976, '2017-04-28 17:30:54', NULL, NULL, 8744, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 17:30:54', 'admin-1493353672-14933718541124799', 1, 0, '', NULL, NULL, NULL),
(27977, '2017-04-28 17:26:22', NULL, NULL, 8744, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 17:26:22', 'admin-1493353672-14933715825024839', 1, 1, 'SR', NULL, NULL, NULL),
(27978, '2017-04-28 09:39:54', NULL, NULL, 8727, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 09:39:54', 'admin-1493341256-14933435937498445', 1, 0, '', NULL, NULL, NULL),
(27979, '2017-04-28 09:40:01', NULL, NULL, 8727, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 09:40:01', 'admin-1493341256-14933436009262393', 1, 0, '', NULL, NULL, NULL),
(27980, '2017-04-28 09:44:05', NULL, NULL, 8728, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1493353672', 'admin', '2017-04-28 09:44:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27981, '2017-04-28 11:09:28', NULL, NULL, 8735, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:09:28', 'admin-1493341256-14933489679195557', 1, 0, '', NULL, NULL, NULL),
(27982, '2017-04-28 11:09:28', NULL, NULL, 8735, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:09:28', 'admin-1493341256-14933489679195557', 1, 1, 'SR', NULL, NULL, NULL),
(27983, '2017-04-28 11:10:09', NULL, NULL, 8735, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:10:09', 'admin-1493348990-14933490092422359', 1, 0, '', NULL, NULL, NULL),
(27984, '2017-04-28 11:10:09', NULL, NULL, 8735, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:10:09', 'admin-1493348990-14933490092422359', 1, 0, '', NULL, NULL, NULL),
(27985, '2017-04-28 11:10:17', NULL, NULL, 8735, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:10:17', 'admin-1493348990-14933490176762632', 1, 1, 'SR', NULL, NULL, NULL),
(27986, '2017-04-28 11:11:28', NULL, NULL, 8736, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:11:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27987, '2017-04-28 11:11:36', NULL, NULL, 8736, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:11:36', 'admin-1493348990-14933490963118410', 1, 1, 'SR', NULL, NULL, NULL),
(27988, '2017-04-28 11:11:36', NULL, NULL, 8736, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:11:36', 'admin-1493348990-14933490963118410', 1, 0, '', NULL, NULL, NULL),
(27989, '2017-04-28 00:00:00', NULL, NULL, 8739, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, NULL, NULL, 3.10, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:23:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27990, '2017-04-28 12:26:57', NULL, NULL, 8738, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 12:26:57', 'admin-1493349202-14933536174462251', 1, 0, '', NULL, NULL, NULL),
(27991, '2017-04-28 00:00:00', NULL, NULL, 8739, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:23:57', 'admin-1493349202-14933498372783125', 1, 0, '', NULL, NULL, NULL),
(27992, '2017-04-28 00:00:00', NULL, NULL, 8740, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, NULL, NULL, 3.30, 1, '27', 1, '1493353672', 'admin', '2017-04-28 12:26:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(27993, '2017-04-28 00:00:00', NULL, NULL, 8739, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:23:57', 'admin-1493349202-14933498372783125', 1, 0, '', NULL, NULL, NULL),
(27994, '2017-04-28 00:00:00', NULL, NULL, 8740, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:24:12', 'admin-1493349202-14933498521571793', 1, 0, '', NULL, NULL, NULL),
(27995, '2017-04-28 11:25:12', NULL, NULL, 8735, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:25:12', 'admin-1493349202-1493349912050574', 1, 1, 'SR', NULL, NULL, NULL),
(27996, '2017-04-28 11:09:28', NULL, NULL, 8735, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:09:28', 'admin-1493341256-14933489679195557', 1, 0, '', NULL, NULL, NULL),
(27997, '2017-04-28 11:03:52', NULL, NULL, 8733, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:03:52', 'admin-1493341256-14933486322971422', 1, 0, '', NULL, NULL, NULL),
(27998, '2017-04-28 11:37:26', NULL, NULL, 8738, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:37:26', 'admin-1493349202-14933506460438151', 1, 0, '', NULL, NULL, NULL),
(27999, '2017-04-28 14:32:29', NULL, NULL, 8743, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 14:32:29', 'admin-1493353672-14933611498013257', 1, 0, '', NULL, NULL, NULL),
(28000, '2017-04-28 00:00:00', NULL, NULL, 8740, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:24:12', 'admin-1493349202-14933498521571793', 1, 1, 'SR', NULL, NULL, NULL),
(28001, '2017-04-28 00:00:00', NULL, NULL, 8739, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:24:12', 'admin-1493349202-14933498521571793', 1, 1, 'SR', NULL, NULL, NULL),
(28002, '2017-04-28 00:00:00', NULL, NULL, 8740, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:57:20', 'admin-1493349202-14933518398759245', 1, 1, 'SR', NULL, NULL, NULL),
(28003, '2017-04-28 14:25:38', NULL, NULL, 8742, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1493353672', 'admin', '2017-04-28 14:25:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28004, '2017-04-28 14:25:40', NULL, NULL, 8742, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 14:25:40', 'admin-1493353672-1493360740224583', 1, 1, 'SR', NULL, NULL, NULL),
(28005, '2017-04-28 14:29:59', NULL, NULL, 8743, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1493353672', 'admin', '2017-04-28 14:29:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28006, '2017-04-28 14:30:21', NULL, NULL, 8743, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 14:30:21', 'admin-1493353672-14933610217909212', 1, 0, '', NULL, NULL, NULL),
(28007, '2017-04-28 14:32:29', NULL, NULL, 8743, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 14:32:29', 'admin-1493353672-14933611498013257', 1, 0, '', NULL, NULL, NULL),
(28008, '2017-04-28 11:54:22', NULL, NULL, 8738, 0, 181, '116', 'Open Food ', 'toast', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:54:22', 'admin-1493349202-14933516619169768', 1, 0, '', NULL, NULL, NULL),
(28009, '2017-04-28 11:54:36', NULL, NULL, 8734, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:54:36', 'admin-1493349202-14933516761779730', 1, 0, '', NULL, NULL, NULL),
(28010, '2017-04-28 11:53:09', NULL, NULL, 8735, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:53:09', 'admin-1493349202-14933515888576023', 1, 0, '', NULL, NULL, NULL),
(28011, '2017-04-28 11:39:21', NULL, NULL, 8734, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:39:21', 'admin-1493349202-14933507616603184', 1, 0, '', NULL, NULL, NULL),
(28012, '2017-04-28 11:46:49', NULL, NULL, 8734, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:46:49', 'admin-1493349202-1493351208872958', 1, 1, 'SR', NULL, NULL, NULL),
(28013, '2017-04-28 11:44:47', NULL, NULL, 8732, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:44:47', 'admin-1493349202-14933510869719938', 1, 1, 'SR', NULL, NULL, NULL),
(28014, '2017-04-28 10:42:13', NULL, NULL, 8732, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1493353672', 'admin', '2017-04-28 10:42:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28015, '2017-04-28 10:42:23', NULL, NULL, 8732, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 10:42:23', 'admin-1493341256-14933473436759812', 1, 0, '', NULL, NULL, NULL),
(28016, '2017-04-28 10:42:23', NULL, NULL, 8732, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 10:42:23', 'admin-1493341256-14933473436759812', 1, 0, '', NULL, NULL, NULL),
(28017, '2017-04-28 10:42:23', NULL, NULL, 8732, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 10:42:23', 'admin-1493341256-14933473436759812', 1, 0, '', NULL, NULL, NULL),
(28018, '2017-04-28 10:42:29', NULL, NULL, 8732, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 10:42:29', 'admin-1493341256-14933473496856799', 1, 1, 'SR', NULL, NULL, NULL),
(28019, '2017-04-28 10:42:30', NULL, NULL, 8732, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 10:42:30', 'admin-1493341256-14933473496856799', 1, 0, '', NULL, NULL, NULL),
(28020, '2017-04-28 11:03:40', NULL, NULL, 8733, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:03:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28021, '2017-04-28 11:03:52', NULL, NULL, 8733, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:03:52', 'admin-1493341256-14933486322971422', 1, 1, 'SR', NULL, NULL, NULL),
(28022, '2017-04-28 11:37:26', NULL, NULL, 8738, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:37:26', 'admin-1493349202-14933506460438151', 1, 0, '', NULL, NULL, NULL),
(28023, '2017-04-28 11:37:19', NULL, NULL, 8738, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 11:37:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28024, '2017-04-28 09:44:12', NULL, NULL, 8728, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 09:44:12', 'admin-1493341256-14933438523247571', 1, 0, '', NULL, NULL, NULL),
(28025, '2017-04-28 09:44:12', NULL, NULL, 8728, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 09:44:12', 'admin-1493341256-14933438523247571', 1, 0, '', NULL, NULL, NULL),
(28026, '2017-04-28 09:44:23', NULL, NULL, 8728, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 09:44:23', 'admin-1493341256-14933438637152261', 1, 0, '', NULL, NULL, NULL),
(28027, '2017-04-28 09:44:23', NULL, NULL, 8728, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 09:44:23', 'admin-1493341256-14933438637152261', 1, 1, 'SR', NULL, NULL, NULL),
(28028, '2017-04-28 10:06:33', NULL, NULL, 8729, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1493353672', 'admin', '2017-04-28 10:06:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28029, '2017-04-28 10:06:38', NULL, NULL, 8729, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 10:06:38', 'admin-1493341256-1493345197960326', 1, 1, 'SR', NULL, NULL, NULL),
(28030, '2017-04-28 10:06:38', NULL, NULL, 8729, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 10:06:38', 'admin-1493341256-1493345197960326', 1, 1, 'SR', NULL, NULL, NULL),
(28031, '2017-04-28 10:16:46', NULL, NULL, 8730, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 10:16:46', 'admin-1493341256-14933458066994054', 1, 1, 'SR', 1, NULL, NULL),
(28032, '2017-04-28 10:22:57', NULL, NULL, 8731, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1493353672', 'admin', '2017-04-28 10:22:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28033, '2017-04-28 10:23:51', NULL, NULL, 8731, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 10:23:51', 'admin-1493341256-14933462314169211', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(28034, '2017-04-28 10:23:51', NULL, NULL, 8731, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 10:23:51', 'admin-1493341256-14933462314169211', 1, 0, '', NULL, NULL, NULL),
(28035, '2017-04-28 10:23:58', NULL, NULL, 8731, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 10:23:58', 'admin-1493341256-14933462380656843', 1, 1, 'SR', NULL, NULL, NULL),
(28036, '2017-04-28 09:38:41', NULL, NULL, 8727, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1493353672', 'admin', '2017-04-28 09:38:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28037, '2017-04-28 09:40:01', NULL, NULL, 8727, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 09:40:01', 'admin-1493341256-14933436009262393', 1, 0, '', NULL, NULL, NULL),
(28038, '2017-04-28 09:39:53', NULL, NULL, 8727, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493353672', 'admin', '2017-04-28 09:39:53', 'admin-1493341256-14933435937498445', 1, 0, '', NULL, NULL, NULL),
(28039, '2017-04-29 16:47:03', NULL, NULL, 8763, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1493445398', 'admin', '2017-04-29 16:47:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28040, '2017-04-29 16:47:17', NULL, NULL, 8763, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 16:47:17', 'admin-1493445398-14934556368213311', 1, 1, 'SR', NULL, NULL, NULL),
(28041, '2017-04-29 16:47:17', NULL, NULL, 8763, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 16:47:17', 'admin-1493445398-14934556368213311', 1, 1, 'SR', NULL, NULL, NULL),
(28042, '2017-04-29 16:47:17', NULL, NULL, 8763, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 16:47:17', 'admin-1493445398-14934556368213311', 1, 0, '', NULL, NULL, NULL),
(28043, '2017-04-29 17:02:52', NULL, NULL, 8764, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1493445398', 'admin', '2017-04-29 17:02:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28044, '2017-04-29 17:03:06', NULL, NULL, 8764, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 17:03:06', 'admin-1493445398-14934565861916974', 1, 1, 'SR', NULL, NULL, NULL),
(28045, '2017-04-29 00:00:00', NULL, NULL, 8759, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 15:12:39', 'admin-1493445398-14934499590034873', 1, 1, 'SR', NULL, NULL, NULL),
(28046, '2017-04-29 15:42:41', NULL, NULL, 8760, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 15:42:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28047, '2017-04-29 10:08:06', NULL, NULL, 8746, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 10:08:06', 'admin-1493427220-14934316865686525', 1, 1, 'SR', NULL, NULL, NULL),
(28048, '2017-04-29 10:08:06', NULL, NULL, 8746, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 10:08:06', 'admin-1493427220-14934316865686525', 1, 1, 'SR', NULL, NULL, NULL),
(28049, '2017-04-29 10:08:06', NULL, NULL, 8746, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 10:08:06', 'admin-1493427220-14934316865686525', 1, 1, 'SR', NULL, NULL, NULL),
(28050, '2017-04-29 10:08:06', NULL, NULL, 8746, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 10:08:06', 'admin-1493427220-14934316865686525', 1, 1, 'SR', NULL, NULL, NULL),
(28051, '2017-04-29 11:26:17', NULL, NULL, 8747, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1493445398', 'admin', '2017-04-29 11:26:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28052, '2017-04-29 11:26:36', NULL, NULL, 8747, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 11:26:36', 'admin-1493427220-14934363965954878', 1, 0, '', NULL, NULL, NULL),
(28053, '2017-04-29 17:45:25', NULL, NULL, 8766, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 17:45:25', 'admin-1493445398-14934591251976178', 1, 1, 'SR', NULL, NULL, NULL),
(28054, '2017-04-29 17:48:49', NULL, NULL, 8767, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1493445398', 'admin', '2017-04-29 17:48:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28055, '2017-04-29 17:49:00', NULL, NULL, 8767, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 17:49:00', 'admin-1493445398-14934593401952934', 1, 1, 'SR', NULL, NULL, NULL),
(28056, '2017-04-29 17:50:37', NULL, NULL, 8768, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1493445398', 'admin', '2017-04-29 17:50:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28057, '2017-04-29 17:51:03', NULL, NULL, 8768, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 17:51:03', 'admin-1493445398-14934594627737883', 1, 0, '', NULL, NULL, NULL),
(28058, '2017-04-29 15:42:45', NULL, NULL, 8760, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 15:42:45', 'admin-1493445398-14934517657176267', 1, 1, 'SR', NULL, NULL, NULL),
(28059, '2017-04-29 17:36:15', NULL, NULL, 8766, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 17:36:15', 'admin-1493445398-1493458575260374', 1, 1, 'SR', NULL, NULL, NULL),
(28060, '2017-04-29 17:36:15', NULL, NULL, 8766, 0, 269, '203', 'Espresso Con Panna', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 17:36:15', 'admin-1493445398-1493458575260374', 1, 0, '', NULL, NULL, NULL),
(28061, '2017-04-29 18:36:13', NULL, NULL, 8767, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 18:36:13', 'admin-1493445398-14934621733896940', 1, 0, '', NULL, NULL, NULL),
(28062, '2017-04-29 00:00:00', NULL, NULL, 8759, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 15:14:46', 'admin-1493445398-14934500864238394', 1, 1, 'SR', NULL, NULL, NULL),
(28063, '2017-04-29 15:12:39', NULL, NULL, 8758, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 15:12:39', 'admin-1493445398-14934499590034873', 1, 1, 'SR', NULL, NULL, NULL),
(28064, '2017-04-29 15:12:23', NULL, NULL, 8758, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1493445398', 'admin', '2017-04-29 15:12:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28065, '2017-04-29 09:42:47', NULL, NULL, 8745, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1493445398', 'admin', '2017-04-29 09:42:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28066, '2017-04-29 09:42:52', NULL, NULL, 8745, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 09:42:52', 'admin-1493427220-14934301724613217', 1, 0, '', NULL, NULL, NULL),
(28067, '2017-04-29 09:42:52', NULL, NULL, 8745, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 09:42:52', 'admin-1493427220-14934301724613217', 1, 1, 'SR', NULL, NULL, NULL),
(28068, '2017-04-29 09:43:16', NULL, NULL, 8745, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 09:43:16', 'admin-1493427220-14934301959344998', 1, 1, 'SR', NULL, NULL, NULL),
(28069, '2017-04-29 18:18:28', NULL, NULL, 8767, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 18:18:28', 'admin-1493445398-1493461108419851', 1, 1, 'SR', NULL, NULL, NULL),
(28070, '2017-04-29 18:19:19', NULL, NULL, 8769, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1493445398', 'admin', '2017-04-29 18:19:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28071, '2017-04-29 18:19:39', NULL, NULL, 8769, 0, 32, '32', 'Tea By Pot ', 'early grey', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 18:19:39', 'admin-1493445398-1493461179751844', 1, 1, 'SR', NULL, NULL, NULL),
(28072, '2017-04-29 18:19:39', NULL, NULL, 8769, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 18:19:39', 'admin-1493445398-1493461179751844', 1, 1, 'SR', NULL, NULL, NULL),
(28073, '2017-04-29 18:36:13', NULL, NULL, 8767, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 18:36:13', 'admin-1493445398-14934621733896940', 1, 0, '', NULL, NULL, NULL),
(28074, '2017-04-29 17:51:03', NULL, NULL, 8768, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 17:51:03', 'admin-1493445398-14934594627737883', 1, 1, 'SR', NULL, NULL, NULL),
(28075, '2017-04-29 15:42:54', NULL, NULL, 8760, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 15:42:54', 'admin-1493445398-14934517741443141', 1, 1, 'SR', NULL, NULL, NULL),
(28076, '2017-04-29 15:45:47', NULL, NULL, 8760, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 15:45:47', 'admin-1493445398-14934519470498196', 1, 0, '', NULL, NULL, NULL),
(28077, '2017-04-29 15:45:47', NULL, NULL, 8760, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 15:45:47', 'admin-1493445398-14934519470498196', 1, 1, 'SR', NULL, NULL, NULL),
(28078, '2017-04-29 16:03:56', NULL, NULL, 8760, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 16:03:56', 'admin-1493445398-14934530364611592', 1, 0, '', NULL, NULL, NULL),
(28079, '2017-04-29 16:05:00', NULL, NULL, 8760, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 16:05:00', 'admin-1493445398-14934531001813763', 1, 0, '', NULL, NULL, NULL),
(28080, '2017-04-29 17:51:03', NULL, NULL, 8768, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 17:51:03', 'admin-1493445398-14934594627737883', 1, 1, 'SR', NULL, NULL, NULL),
(28081, '2017-04-29 17:36:15', NULL, NULL, 8766, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 17:36:15', 'admin-1493445398-1493458575260374', 1, 0, '', NULL, NULL, NULL),
(28082, '2017-04-29 17:36:15', NULL, NULL, 8766, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 17:36:15', 'admin-1493445398-1493458575260374', 1, 1, 'SR', NULL, NULL, NULL),
(28083, '2017-04-29 17:08:38', NULL, NULL, 8764, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 17:08:38', 'admin-1493445398-1493456918771958', 1, 0, '', NULL, NULL, NULL),
(28084, '2017-04-29 17:35:50', NULL, NULL, 8766, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 17:35:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28085, '2017-04-29 17:07:23', NULL, NULL, 8765, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 17:07:23', 'admin-1493445398-1493456843678558', 1, 1, 'SR', NULL, NULL, NULL),
(28086, '2017-04-29 14:07:50', NULL, NULL, 8752, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 14:07:50', 'admin-1493445398-149344607026748', 1, 1, 'SR', NULL, NULL, NULL),
(28087, '2017-04-29 14:08:52', NULL, NULL, 8753, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 14:08:52', 'admin-1493445398-14934461326795413', 1, 1, 'SR', 1, NULL, NULL),
(28088, '2017-04-29 00:00:00', NULL, NULL, 8754, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:45:19', 'admin-1493427220-1493444719595299', 1, 1, 'SR', NULL, NULL, NULL),
(28089, '2017-04-29 14:16:42', NULL, NULL, 8755, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1493445398', 'admin', '2017-04-29 14:16:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28090, '2017-04-29 14:16:48', NULL, NULL, 8755, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 14:16:48', 'admin-1493445398-1493446607968260', 1, 0, '', NULL, NULL, NULL),
(28091, '2017-04-29 14:16:48', NULL, NULL, 8755, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 14:16:48', 'admin-1493445398-1493446607968260', 1, 0, '', NULL, NULL, NULL),
(28092, '2017-04-29 14:17:39', NULL, NULL, 8755, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 14:17:39', 'admin-1493445398-14934466589752943', 1, 1, 'SR', NULL, NULL, NULL),
(28093, '2017-04-29 14:17:39', NULL, NULL, 8755, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 14:17:39', 'admin-1493445398-14934466589752943', 1, 1, 'SR', NULL, NULL, NULL),
(28094, '2017-04-29 14:32:20', NULL, NULL, 8756, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1493445398', 'admin', '2017-04-29 14:32:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28095, '2017-04-29 14:34:05', NULL, NULL, 8757, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 14:34:05', 'admin-1493445398-14934476455939885', 1, 1, 'SR', NULL, NULL, NULL),
(28096, '2017-04-29 14:34:05', NULL, NULL, 8757, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 14:34:05', 'admin-1493445398-14934476455939885', 1, 1, 'SR', NULL, NULL, NULL),
(28097, '2017-04-29 14:33:59', NULL, NULL, 8757, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1493445398', 'admin', '2017-04-29 14:33:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28098, '2017-04-29 14:32:58', NULL, NULL, 8756, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 14:32:58', 'admin-1493445398-14934475783392264', 1, 1, 'SR', NULL, NULL, NULL),
(28099, '2017-04-29 14:32:58', NULL, NULL, 8756, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 14:32:58', 'admin-1493445398-14934475783392264', 1, 0, '', NULL, NULL, NULL),
(28100, '2017-04-29 13:56:30', NULL, NULL, 8751, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:56:30', 'admin-1493427220-1493445389838935', 1, 1, 'SR', NULL, NULL, NULL),
(28101, '2017-04-29 15:34:45', NULL, NULL, 8759, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1493445398', 'admin', '2017-04-29 15:34:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28102, '2017-04-29 14:07:50', NULL, NULL, 8752, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 14:07:50', 'admin-1493445398-149344607026748', 1, 1, 'SR', NULL, NULL, NULL),
(28103, '2017-04-29 13:56:30', NULL, NULL, 8751, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:56:30', 'admin-1493427220-1493445389838935', 1, 0, '', NULL, NULL, NULL),
(28104, '2017-04-29 17:03:06', NULL, NULL, 8764, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 17:03:06', 'admin-1493445398-14934565861916974', 1, 0, '', NULL, NULL, NULL),
(28105, '2017-04-29 16:30:19', NULL, NULL, 8762, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 16:30:19', 'admin-1493445398-14934546188748053', 1, 1, 'SR', NULL, NULL, NULL),
(28106, '2017-04-29 16:30:19', NULL, NULL, 8762, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 16:30:19', 'admin-1493445398-14934546188748053', 1, 0, '', NULL, NULL, NULL),
(28107, '2017-04-29 17:07:19', NULL, NULL, 8765, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1493445398', 'admin', '2017-04-29 17:07:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28108, '2017-04-29 16:11:10', NULL, NULL, 8761, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1493445398', 'admin', '2017-04-29 16:11:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28109, '2017-04-29 16:11:31', NULL, NULL, 8761, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 16:11:31', 'admin-1493445398-1493453491413814', 1, 1, 'SR', NULL, NULL, NULL),
(28110, '2017-04-29 16:30:02', NULL, NULL, 8762, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1493445398', 'admin', '2017-04-29 16:30:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28111, '2017-04-29 16:30:19', NULL, NULL, 8762, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 16:30:19', 'admin-1493445398-14934546188748053', 1, 0, '', NULL, NULL, NULL),
(28112, '2017-04-29 14:07:50', NULL, NULL, 8752, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 14:07:50', 'admin-1493445398-149344607026748', 1, 1, 'SR', NULL, NULL, NULL),
(28113, '2017-04-29 14:05:47', NULL, NULL, 8752, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 14:05:47', 'admin-1493445398-14934459474382389', 1, 1, 'SR', NULL, NULL, NULL),
(28114, '2017-04-29 13:56:30', NULL, NULL, 8751, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:56:30', 'admin-1493427220-1493445389838935', 1, 1, 'SR', NULL, NULL, NULL),
(28115, '2017-04-29 14:01:41', NULL, NULL, 8752, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1493445398', 'admin', '2017-04-29 14:01:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28116, '2017-04-29 14:01:52', NULL, NULL, 8752, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 14:01:52', 'admin-1493445398-14934457126064484', 1, 1, 'SR', NULL, NULL, NULL),
(28117, '2017-04-29 13:23:47', NULL, NULL, 8749, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:23:47', 'admin-1493427220-14934434271599051', 1, 1, 'SR', NULL, NULL, NULL),
(28118, '2017-04-29 13:23:47', NULL, NULL, 8749, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:23:47', 'admin-1493427220-14934434271599051', 1, 1, 'SR', NULL, NULL, NULL),
(28119, '2017-04-29 13:45:01', NULL, NULL, 8750, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:45:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28120, '2017-04-29 13:45:19', NULL, NULL, 8750, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:45:19', 'admin-1493427220-1493444719595299', 1, 1, 'SR', NULL, NULL, NULL),
(28121, '2017-04-29 13:45:19', NULL, NULL, 8750, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:45:19', 'admin-1493427220-1493444719595299', 1, 1, 'SR', NULL, NULL, NULL),
(28122, '2017-04-29 14:13:43', NULL, NULL, 8754, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1493445398', 'admin', '2017-04-29 14:13:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28123, '2017-04-29 13:45:19', NULL, NULL, 8750, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:45:19', 'admin-1493427220-1493444719595299', 1, 1, 'SR', NULL, NULL, NULL),
(28124, '2017-04-29 13:53:41', NULL, NULL, 8751, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:53:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28125, '2017-04-29 13:56:30', NULL, NULL, 8751, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:56:30', 'admin-1493427220-1493445389838935', 1, 1, 'SR', NULL, NULL, NULL),
(28126, '2017-04-29 14:05:47', NULL, NULL, 8752, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 14:05:47', 'admin-1493445398-14934459474382389', 1, 0, '', NULL, NULL, NULL),
(28127, '2017-04-29 14:05:47', NULL, NULL, 8752, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 14:05:47', 'admin-1493445398-14934459474382389', 1, 0, '', NULL, NULL, NULL),
(28128, '2017-04-29 10:07:49', NULL, NULL, 8746, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 10:07:49', 'admin-1493427220-14934316689951995', 1, 0, '', NULL, NULL, NULL),
(28129, '2017-04-29 10:07:49', NULL, NULL, 8746, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 10:07:49', 'admin-1493427220-14934316689951995', 1, 0, '', NULL, NULL, NULL),
(28130, '2017-04-29 10:07:49', NULL, NULL, 8746, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 10:07:49', 'admin-1493427220-14934316689951995', 1, 1, 'SR', NULL, NULL, NULL),
(28131, '2017-04-29 10:07:49', NULL, NULL, 8746, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 10:07:49', 'admin-1493427220-14934316689951995', 1, 0, '', NULL, NULL, NULL),
(28132, '2017-04-29 10:08:06', NULL, NULL, 8746, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 10:08:06', 'admin-1493427220-14934316865686525', 1, 0, '', NULL, NULL, NULL),
(28133, '2017-04-29 10:08:06', NULL, NULL, 8746, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 10:08:06', 'admin-1493427220-14934316865686525', 1, 1, 'SR', NULL, NULL, NULL),
(28134, '2017-04-29 10:08:06', NULL, NULL, 8746, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 10:08:06', 'admin-1493427220-14934316865686525', 1, 1, 'SR', NULL, NULL, NULL),
(28135, '2017-04-29 13:56:30', NULL, NULL, 8751, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:56:30', 'admin-1493427220-1493445389838935', 1, 1, 'SR', NULL, NULL, NULL),
(28136, '2017-04-29 13:56:30', NULL, NULL, 8751, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:56:30', 'admin-1493427220-1493445389838935', 1, 0, '', NULL, NULL, NULL),
(28137, '2017-04-29 13:23:47', NULL, NULL, 8749, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:23:47', 'admin-1493427220-14934434271599051', 1, 1, 'SR', NULL, NULL, NULL),
(28138, '2017-04-29 13:23:47', NULL, NULL, 8749, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:23:47', 'admin-1493427220-14934434271599051', 1, 0, '', NULL, NULL, NULL),
(28139, '2017-04-29 13:23:23', NULL, NULL, 8749, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:23:23', 'admin-1493427220-14934434035168313', 1, 1, 'SR', NULL, NULL, NULL),
(28140, '2017-04-29 13:23:16', NULL, NULL, 8749, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:23:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28141, '2017-04-29 13:06:37', NULL, NULL, 8748, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:06:37', 'admin-1493427220-14934423975626471', 1, 1, 'SR', NULL, NULL, NULL),
(28142, '2017-04-29 13:06:37', NULL, NULL, 8748, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:06:37', 'admin-1493427220-14934423975626471', 1, 1, 'SR', NULL, NULL, NULL),
(28143, '2017-04-29 13:06:24', NULL, NULL, 8748, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:06:24', 'admin-1493427220-1493442384307960', 1, 0, '', NULL, NULL, NULL),
(28144, '2017-04-29 13:06:24', NULL, NULL, 8748, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:06:24', 'admin-1493427220-1493442384307960', 1, 0, '', NULL, NULL, NULL),
(28145, '2017-04-29 13:04:36', NULL, NULL, 8748, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1493445398', 'admin', '2017-04-29 13:04:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28146, '2017-04-29 11:26:44', NULL, NULL, 8747, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 11:26:44', 'admin-1493427220-14934364046758232', 1, 1, 'SR', NULL, NULL, NULL),
(28147, '2017-04-29 11:26:36', NULL, NULL, 8747, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 11:26:36', 'admin-1493427220-14934363965954878', 1, 0, '', NULL, NULL, NULL),
(28148, '2017-04-29 10:08:06', NULL, NULL, 8746, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493445398', 'admin', '2017-04-29 10:08:06', 'admin-1493427220-14934316865686525', 1, 1, 'SR', NULL, NULL, NULL),
(28149, '2017-04-29 10:07:29', NULL, NULL, 8746, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.30, 0.0000, 0.0000, 16.30, 1, '27', 1, '1493445398', 'admin', '2017-04-29 10:07:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28150, '2017-04-30 14:12:28', NULL, NULL, 8799, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:12:28', 'admin-1493530943-14935327484738326', 1, 1, 'SR', NULL, NULL, NULL),
(28151, '2017-04-30 13:47:32', NULL, NULL, 8798, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:47:33', 'admin-1493530943-14935312527662748', 1, 1, 'SR', NULL, NULL, NULL),
(28152, '2017-04-30 13:43:10', NULL, NULL, 8800, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:43:10', 'admin-1493530943-14935309907781182', 1, 0, '', NULL, NULL, NULL),
(28153, '2017-04-30 13:32:17', NULL, NULL, 8799, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:32:17', 'admin-1493527337-14935303370028698', 1, 0, '', NULL, NULL, NULL),
(28154, '2017-04-30 13:17:09', NULL, NULL, 8798, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:17:09', 'admin-1493527337-14935294294546917', 1, 1, 'SR', NULL, NULL, NULL),
(28155, '2017-04-30 12:54:52', NULL, NULL, 8797, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:54:52', 'admin-1493527337-14935280925595423', 1, 1, 'SR', NULL, NULL, NULL),
(28156, '2017-04-30 12:54:32', NULL, NULL, 8797, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:54:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28157, '2017-04-30 12:51:16', NULL, NULL, 8796, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:51:16', 'admin-1493527337-1493527876807929', 1, 0, '', NULL, NULL, NULL),
(28158, '2017-04-30 12:51:16', NULL, NULL, 8796, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:51:16', 'admin-1493527337-1493527876807929', 1, 0, '', NULL, NULL, NULL),
(28159, '2017-04-30 12:42:27', NULL, NULL, 8796, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:42:27', 'admin-1493527337-14935273471787150', 1, 0, '', NULL, NULL, NULL),
(28160, '2017-04-30 12:42:52', NULL, NULL, 8796, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:42:52', 'admin-1493527337-14935273724889281', 1, 1, 'SR', NULL, NULL, NULL),
(28161, '2017-04-30 12:42:52', NULL, NULL, 8796, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:42:52', 'admin-1493527337-14935273724889281', 1, 1, 'SR', NULL, NULL, NULL),
(28162, '2017-04-30 12:41:28', NULL, NULL, 8795, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:41:28', 'admin-1493523673-14935272885208141', 1, 0, '', NULL, NULL, NULL),
(28163, '2017-04-30 12:42:01', NULL, NULL, 8796, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.40, 0.0000, 0.0000, 16.40, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:42:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28164, '2017-04-30 12:42:06', NULL, NULL, 8796, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:42:06', 'admin-1493523673-14935273266563830', 1, 0, '', NULL, NULL, NULL),
(28165, '2017-04-30 12:42:06', NULL, NULL, 8796, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:42:06', 'admin-1493523673-14935273266563830', 1, 0, '', NULL, NULL, NULL),
(28166, '2017-04-30 11:20:49', NULL, NULL, 8784, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:20:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28167, '2017-04-30 11:20:55', NULL, NULL, 8784, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:20:55', 'admin-1493519466-14935224551778925', 1, 0, '', NULL, NULL, NULL),
(28168, '2017-04-30 11:21:00', NULL, NULL, 8784, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:21:00', 'admin-1493519466-1493522460669225', 1, 0, '', NULL, NULL, NULL),
(28169, '2017-04-30 10:15:00', NULL, NULL, 8779, 0, 156, '90', 'House Cheddar Omelet', 'tosted bread change to pancake', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:15:00', 'admin-1493517436-14935185004886068', 1, 0, '', NULL, NULL, NULL),
(28170, '2017-04-30 10:15:00', NULL, NULL, 8779, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:15:00', 'admin-1493517436-14935185004886068', 1, 1, 'SR', NULL, NULL, NULL),
(28171, '2017-04-30 17:11:00', NULL, NULL, 8816, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1493530943', 'admin', '2017-04-30 17:11:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28172, '2017-04-30 17:11:11', NULL, NULL, 8816, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 17:11:11', 'admin-1493530943-14935434708195730', 1, 1, 'SR', NULL, NULL, NULL),
(28173, '2017-04-30 17:11:11', NULL, NULL, 8816, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 17:11:11', 'admin-1493530943-14935434708195730', 1, 0, '', NULL, NULL, NULL),
(28174, '2017-04-30 16:15:09', NULL, NULL, 8814, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 16:15:09', 'admin-1493530943-1493540109632158', 1, 0, '', NULL, NULL, NULL),
(28175, '2017-04-30 16:23:29', NULL, NULL, 8814, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 16:23:29', 'admin-1493530943-14935406093632468', 1, 0, '', NULL, NULL, NULL),
(28176, '2017-04-30 16:38:10', NULL, NULL, 8815, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 16:38:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28177, '2017-04-30 16:38:24', NULL, NULL, 8815, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 16:38:24', 'admin-1493530943-14935415046997641', 1, 1, 'SR', NULL, NULL, NULL),
(28178, '2017-04-30 17:58:16', NULL, NULL, 8817, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.00, 0.0000, 0.0000, 14.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 17:58:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28179, '2017-04-30 17:59:24', NULL, NULL, 8817, 0, 181, '116', 'Open Food ', 'Special Menu', 'Meals', 'Perfect Meals', 1, 140.00, 140.0000, 0.0000, 140.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 17:59:24', 'admin-1493530943-14935463648168615', 1, 0, '', NULL, NULL, NULL),
(28180, '2017-04-30 13:49:21', NULL, NULL, 8804, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:49:21', 'admin-1493530943-14935313616484923', 1, 1, 'SR', NULL, NULL, NULL),
(28181, '2017-04-30 13:49:29', NULL, NULL, 8804, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:49:29', 'admin-1493530943-1493531369638122', 1, 0, '', NULL, NULL, NULL),
(28182, '2017-04-30 14:03:41', NULL, NULL, 8798, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:03:41', 'admin-1493530943-14935322213721047', 1, 0, '', NULL, NULL, NULL),
(28183, '2017-04-30 14:12:28', NULL, NULL, 8799, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:12:28', 'admin-1493530943-14935327484738326', 1, 1, 'SR', NULL, NULL, NULL),
(28184, '2017-04-30 11:33:12', NULL, NULL, 8787, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:33:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28185, '2017-04-30 11:33:18', NULL, NULL, 8787, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:33:18', 'admin-1493519466-14935231981911828', 1, 0, '', NULL, NULL, NULL),
(28186, '2017-04-30 10:12:49', NULL, NULL, 8778, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:12:49', 'admin-1493517436-14935183696017342', 1, 1, 'SR', NULL, NULL, NULL),
(28187, '2017-04-30 09:20:50', NULL, NULL, 8772, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:20:50', 'admin-1493512436-1493515249913455', 1, 0, '', NULL, NULL, NULL),
(28188, '2017-04-30 09:21:10', NULL, NULL, 8772, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:21:10', 'admin-1493512436-14935152705504049', 1, 1, 'SR', NULL, NULL, NULL),
(28189, '2017-04-30 09:21:10', NULL, NULL, 8772, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:21:10', 'admin-1493512436-14935152705504049', 1, 1, 'SR', NULL, NULL, NULL),
(28190, '2017-04-30 09:26:24', NULL, NULL, 8773, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:26:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28191, '2017-04-30 09:26:55', NULL, NULL, 8773, 0, 153, '87', 'Wake Me Up!', 'fried egg', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:26:55', 'admin-1493512436-14935156149942018', 1, 0, '', NULL, NULL, NULL),
(28192, '2017-04-30 09:06:35', NULL, NULL, 8770, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:06:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28193, '2017-04-30 09:06:53', NULL, NULL, 8770, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:06:53', 'admin-1493512436-14935144133044119', 1, 0, '', NULL, NULL, NULL),
(28194, '2017-04-30 13:42:04', NULL, NULL, 8803, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:42:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28195, '2017-04-30 13:47:32', NULL, NULL, 8798, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:47:32', 'admin-1493530943-14935312527662748', 1, 0, '', NULL, NULL, NULL),
(28196, '2017-04-30 13:41:06', NULL, NULL, 8800, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:41:06', 'admin-1493527337-14935308663293336', 1, 0, '', NULL, NULL, NULL),
(28197, '2017-04-30 14:14:49', NULL, NULL, 8805, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:14:49', 'admin-1493530943-14935328892902443', 1, 1, 'SR', NULL, NULL, NULL),
(28198, '2017-04-30 14:22:03', NULL, NULL, 8801, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:22:03', 'admin-1493530943-14935333232813373', 1, 1, 'SR', NULL, NULL, NULL),
(28199, '2017-04-30 14:22:03', NULL, NULL, 8801, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:22:03', 'admin-1493530943-14935333232813373', 1, 1, 'SR', NULL, NULL, NULL),
(28200, '2017-04-30 14:23:45', NULL, NULL, 8805, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:23:45', 'admin-1493530943-14935334250051019', 1, 0, '', NULL, NULL, NULL),
(28201, '2017-04-30 15:08:04', NULL, NULL, 8809, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 15:08:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28202, '2017-04-30 13:40:58', NULL, NULL, 8801, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:40:58', 'admin-1493527337-1493530858244908', 1, 0, '', NULL, NULL, NULL),
(28203, '2017-04-30 13:40:58', NULL, NULL, 8801, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:40:58', 'admin-1493527337-1493530858244908', 1, 0, '', NULL, NULL, NULL),
(28204, '2017-04-30 13:40:58', NULL, NULL, 8801, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:40:58', 'admin-1493527337-1493530858244908', 1, 0, '', NULL, NULL, NULL),
(28205, '2017-04-30 12:51:16', NULL, NULL, 8796, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:51:16', 'admin-1493527337-1493527876807929', 1, 1, 'SR', NULL, NULL, NULL),
(28206, '2017-04-30 15:43:14', NULL, NULL, 8811, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 15:43:14', 'admin-1493530943-1493538194512165', 1, 0, '', NULL, NULL, NULL),
(28207, '2017-04-30 15:45:00', NULL, NULL, 8812, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 15:45:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28208, '2017-04-30 15:45:09', NULL, NULL, 8812, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 15:45:09', 'admin-1493530943-14935383092801313', 1, 1, 'SR', NULL, NULL, NULL),
(28209, '2017-04-30 15:45:09', NULL, NULL, 8812, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 15:45:09', 'admin-1493530943-14935383092801313', 1, 1, 'SR', NULL, NULL, NULL),
(28210, '2017-04-30 15:46:28', NULL, NULL, 8813, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1493530943', 'admin', '2017-04-30 15:46:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28211, '2017-04-30 15:46:34', NULL, NULL, 8813, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 15:46:34', 'admin-1493530943-14935383947985088', 1, 1, 'SR', NULL, NULL, NULL),
(28212, '2017-04-30 15:46:34', NULL, NULL, 8813, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 15:46:34', 'admin-1493530943-14935383947985088', 1, 1, 'SR', NULL, NULL, NULL),
(28213, '2017-04-30 15:55:57', NULL, NULL, 8810, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 15:55:57', 'admin-1493530943-14935389569973614', 1, 1, 'SR', NULL, NULL, NULL),
(28214, '2017-04-30 16:04:52', NULL, NULL, 8810, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 16:04:52', 'admin-1493530943-14935394924233053', 1, 1, 'SR', NULL, NULL, NULL),
(28215, '2017-04-30 16:11:42', NULL, NULL, 8814, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1493530943', 'admin', '2017-04-30 16:11:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28216, '2017-04-30 16:11:52', NULL, NULL, 8814, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 16:11:52', 'admin-1493530943-14935399120095620', 1, 1, 'SR', NULL, NULL, NULL),
(28217, '2017-04-30 16:11:52', NULL, NULL, 8814, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 16:11:52', 'admin-1493530943-14935399120095620', 1, 1, 'SR', NULL, NULL, NULL),
(28218, '2017-04-30 15:43:14', NULL, NULL, 8811, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 15:43:14', 'admin-1493530943-1493538194512165', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(28219, '2017-04-30 15:02:40', NULL, NULL, 8807, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 15:02:40', 'admin-1493530943-1493535760601794', 1, 0, '', NULL, NULL, NULL),
(28220, '2017-04-30 14:12:28', NULL, NULL, 8799, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:12:28', 'admin-1493530943-14935327484738326', 1, 1, 'SR', NULL, NULL, NULL),
(28221, '2017-04-30 14:14:07', NULL, NULL, 8805, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:14:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28222, '2017-04-30 14:14:49', NULL, NULL, 8805, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:14:49', 'admin-1493530943-14935328892902443', 1, 1, 'SR', NULL, NULL, NULL),
(28223, '2017-04-30 14:14:49', NULL, NULL, 8805, 0, 32, '32', 'Tea By Pot ', 'chamomile', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:14:49', 'admin-1493530943-14935328892902443', 1, 1, 'SR', NULL, NULL, NULL),
(28224, '2017-04-30 13:40:58', NULL, NULL, 8801, 0, 181, '116', 'Open Food ', ' ang mo,Lemony less spicy', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:40:58', 'admin-1493527337-1493530858244908', 1, 0, '', NULL, NULL, NULL),
(28225, '2017-04-30 13:37:55', NULL, NULL, 8800, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:37:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28226, '2017-04-30 15:08:16', NULL, NULL, 8809, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 15:08:16', 'admin-1493530943-14935360960839439', 1, 0, '', NULL, NULL, NULL),
(28227, '2017-04-30 15:08:16', NULL, NULL, 8809, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 15:08:16', 'admin-1493530943-14935360960839439', 1, 0, '', NULL, NULL, NULL),
(28228, '2017-04-30 15:42:55', NULL, NULL, 8811, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1493530943', 'admin', '2017-04-30 15:42:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28229, '2017-04-30 15:28:10', NULL, NULL, 8810, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 15:28:10', 'admin-1493530943-14935372905908436', 1, 1, 'SR', NULL, NULL, NULL),
(28230, '2017-04-30 14:14:49', NULL, NULL, 8805, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:14:49', 'admin-1493530943-14935328892902443', 1, 0, '', NULL, NULL, NULL),
(28231, '2017-04-30 15:28:02', NULL, NULL, 8810, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 15:28:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28232, '2017-04-30 15:09:28', NULL, NULL, 8806, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 15:09:28', 'admin-1493530943-14935361682834634', 1, 1, 'SR', NULL, NULL, NULL),
(28233, '2017-04-30 15:08:27', NULL, NULL, 8809, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 15:08:27', 'admin-1493530943-14935361068768927', 1, 1, 'SR', NULL, NULL, NULL),
(28234, '2017-04-30 15:08:27', NULL, NULL, 8809, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 15:08:27', 'admin-1493530943-14935361068768927', 1, 1, 'SR', NULL, NULL, NULL),
(28235, '2017-04-30 15:03:42', NULL, NULL, 8806, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 15:03:42', 'admin-1493530943-14935358217671421', 1, 1, 'SR', NULL, NULL, NULL),
(28236, '2017-04-30 14:55:30', NULL, NULL, 8808, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:55:30', 'admin-1493530943-14935353303735975', 1, 1, 'SR', NULL, NULL, NULL),
(28237, '2017-04-30 14:55:30', NULL, NULL, 8808, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:55:30', 'admin-1493530943-14935353303735975', 1, 0, '', NULL, NULL, NULL),
(28238, '2017-04-30 14:55:19', NULL, NULL, 8808, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:55:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28239, '2017-04-30 14:49:01', NULL, NULL, 8807, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:49:01', 'admin-1493530943-14935349411558117', 1, 1, 'SR', NULL, NULL, NULL),
(28240, '2017-04-30 14:48:45', NULL, NULL, 8807, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:48:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28241, '2017-04-30 14:49:01', NULL, NULL, 8807, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:49:01', 'admin-1493530943-14935349411558117', 1, 0, '', NULL, NULL, NULL),
(28242, '2017-04-30 14:42:39', NULL, NULL, 8806, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:42:39', 'admin-1493530943-14935345587545054', 1, 1, 'SR', NULL, NULL, NULL),
(28243, '2017-04-30 14:42:38', NULL, NULL, 8806, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:42:38', 'admin-1493530943-14935345587545054', 1, 1, 'SR', NULL, NULL, NULL),
(28244, '2017-04-30 14:42:24', NULL, NULL, 8806, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:42:24', 'admin-1493530943-14935345446649865', 1, 0, '', NULL, NULL, NULL),
(28245, '2017-04-30 14:38:49', NULL, NULL, 8806, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.70, 0.0000, 0.0000, 12.70, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:38:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28246, '2017-04-30 14:42:24', NULL, NULL, 8806, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:42:24', 'admin-1493530943-14935345446649865', 1, 1, 'SR', NULL, NULL, NULL),
(28247, '2017-04-30 13:17:09', NULL, NULL, 8798, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:17:09', 'admin-1493527337-14935294294546917', 1, 0, '', NULL, NULL, NULL),
(28248, '2017-04-30 13:43:10', NULL, NULL, 8800, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:43:10', 'admin-1493530943-14935309907781182', 1, 0, '', NULL, NULL, NULL),
(28249, '2017-04-30 14:42:24', NULL, NULL, 8806, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:42:24', 'admin-1493530943-14935345446649865', 1, 1, 'SR', NULL, NULL, NULL),
(28250, '2017-04-30 13:40:58', NULL, NULL, 8801, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:40:58', 'admin-1493527337-1493530858244908', 1, 0, '', NULL, NULL, NULL),
(28251, '2017-04-30 13:38:01', NULL, NULL, 8800, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:38:01', 'admin-1493527337-14935306807756919', 1, 0, '', NULL, NULL, NULL),
(28252, '2017-04-30 13:38:10', NULL, NULL, 8800, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:38:10', 'admin-1493527337-14935306901869236', 1, 1, 'SR', NULL, NULL, NULL),
(28253, '2017-04-30 13:40:21', NULL, NULL, 8801, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.20, 0.0000, 0.0000, 11.20, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:40:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28254, '2017-04-30 13:40:58', NULL, NULL, 8801, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:40:58', 'admin-1493527337-1493530858244908', 1, 0, '', NULL, NULL, NULL),
(28255, '2017-04-30 13:40:58', NULL, NULL, 8801, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:40:58', 'admin-1493527337-1493530858244908', 1, 0, '', NULL, NULL, NULL),
(28256, '2017-04-30 13:32:34', NULL, NULL, 8799, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:32:34', 'admin-1493527337-14935303539853733', 1, 1, 'SR', NULL, NULL, NULL),
(28257, '2017-04-30 13:32:34', NULL, NULL, 8799, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:32:34', 'admin-1493527337-14935303539853733', 1, 1, 'SR', NULL, NULL, NULL),
(28258, '2017-04-30 13:32:34', NULL, NULL, 8799, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:32:34', 'admin-1493527337-14935303539853733', 1, 1, 'SR', NULL, NULL, NULL),
(28259, '2017-04-30 13:32:09', NULL, NULL, 8799, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:32:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28260, '2017-04-30 13:32:17', NULL, NULL, 8799, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:32:17', 'admin-1493527337-14935303370028698', 1, 0, '', NULL, NULL, NULL),
(28261, '2017-04-30 12:11:45', NULL, NULL, 8794, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:11:45', 'admin-1493523673-14935255056354390', 1, 1, 'SR', NULL, NULL, NULL),
(28262, '2017-04-30 12:11:45', NULL, NULL, 8794, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:11:45', 'admin-1493523673-14935255056354390', 1, 0, '', NULL, NULL, NULL),
(28263, '2017-04-30 12:35:08', NULL, NULL, 8795, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.70, 0.0000, 0.0000, 14.70, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:35:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28264, '2017-04-30 12:40:47', NULL, NULL, 8795, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:40:47', 'admin-1493523673-14935272475761137', 1, 1, 'SR', NULL, NULL, NULL),
(28265, '2017-04-30 12:36:24', NULL, NULL, 8795, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:36:24', 'admin-1493523673-14935269846204776', 1, 1, 'SR', NULL, NULL, NULL),
(28266, '2017-04-30 12:36:24', NULL, NULL, 8795, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:36:24', 'admin-1493523673-14935269846204776', 1, 0, '', NULL, NULL, NULL),
(28267, '2017-04-30 12:36:24', NULL, NULL, 8795, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:36:24', 'admin-1493523673-14935269846204776', 1, 1, 'SR', NULL, NULL, NULL),
(28268, '2017-04-30 12:36:24', NULL, NULL, 8795, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:36:24', 'admin-1493523673-14935269846204776', 1, 0, '', NULL, NULL, NULL),
(28269, '2017-04-30 11:59:25', NULL, NULL, 8793, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:59:25', 'admin-1493523673-14935247650066142', 1, 0, '', NULL, NULL, NULL),
(28270, '2017-04-30 11:59:25', NULL, NULL, 8793, 0, 154, '88', 'Daily Dose BLT', 'No egg', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:59:25', 'admin-1493523673-14935247650066142', 1, 0, '', NULL, NULL, NULL),
(28271, '2017-04-30 11:59:04', NULL, NULL, 8793, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:59:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28272, '2017-04-30 10:21:05', NULL, NULL, 8781, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:21:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28273, '2017-04-30 10:21:25', NULL, NULL, 8781, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:21:25', 'admin-1493517436-1493518884876708', 1, 0, '', NULL, NULL, NULL),
(28274, '2017-04-30 12:42:52', NULL, NULL, 8796, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:42:52', 'admin-1493527337-14935273724889281', 1, 0, '', NULL, NULL, NULL),
(28275, '2017-04-30 12:42:52', NULL, NULL, 8796, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:42:52', 'admin-1493527337-14935273724889281', 1, 1, 'SR', NULL, NULL, NULL),
(28276, '2017-04-30 12:42:52', NULL, NULL, 8796, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:42:52', 'admin-1493527337-14935273724889281', 1, 1, 'SR', NULL, NULL, NULL),
(28277, '2017-04-30 12:42:52', NULL, NULL, 8796, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:42:52', 'admin-1493527337-14935273724889281', 1, 1, 'SR', NULL, NULL, NULL),
(28278, '2017-04-30 12:42:52', NULL, NULL, 8796, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:42:52', 'admin-1493527337-14935273724889281', 1, 1, 'SR', NULL, NULL, NULL),
(28279, '2017-04-30 13:17:22', NULL, NULL, 8798, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:17:22', 'admin-1493527337-14935294420876357', 1, 0, '', NULL, NULL, NULL),
(28280, '2017-04-30 13:17:09', NULL, NULL, 8798, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:17:09', 'admin-1493527337-14935294294546917', 1, 1, 'SR', NULL, NULL, NULL),
(28281, '2017-04-30 12:38:51', NULL, NULL, 8795, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:38:51', 'admin-1493523673-14935271309541096', 1, 1, 'SR', NULL, NULL, NULL),
(28282, '2017-04-30 12:38:51', NULL, NULL, 8795, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:38:51', 'admin-1493523673-14935271309541096', 1, 1, 'SR', NULL, NULL, NULL),
(28283, '2017-04-30 11:59:01', NULL, NULL, 8792, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:59:01', 'admin-1493523673-14935247415514624', 1, 1, 'SR', NULL, NULL, NULL),
(28284, '2017-04-30 11:59:01', NULL, NULL, 8792, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:59:01', 'admin-1493523673-14935247415514624', 1, 0, '', NULL, NULL, NULL),
(28285, '2017-04-30 12:54:52', NULL, NULL, 8797, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:54:52', 'admin-1493527337-14935280925595423', 1, 1, 'SR', NULL, NULL, NULL),
(28286, '2017-04-30 12:55:09', NULL, NULL, 8796, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:55:09', 'admin-1493527337-1493528109238237', 1, 1, 'SR', NULL, NULL, NULL),
(28287, '2017-04-30 13:16:48', NULL, NULL, 8798, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:16:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28288, '2017-04-30 13:17:09', NULL, NULL, 8798, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:17:09', 'admin-1493527337-14935294294546917', 1, 1, 'SR', NULL, NULL, NULL),
(28289, '2017-04-30 11:37:13', NULL, NULL, 8789, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:37:13', 'admin-1493519466-14935234333817634', 1, 1, 'SR', NULL, NULL, NULL),
(28290, '2017-04-30 11:40:48', NULL, NULL, 8790, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:40:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28291, '2017-04-30 11:41:07', NULL, NULL, 8790, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:41:07', 'admin-1493519466-14935236672418875', 1, 0, '', NULL, NULL, NULL),
(28292, '2017-04-30 11:41:07', NULL, NULL, 8790, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:41:07', 'admin-1493519466-14935236672418875', 1, 0, '', NULL, NULL, NULL),
(28293, '2017-04-30 11:41:07', NULL, NULL, 8790, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:41:07', 'admin-1493519466-14935236672418875', 1, 0, '', NULL, NULL, NULL),
(28294, '2017-04-30 11:52:38', NULL, NULL, 8791, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:52:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28295, '2017-04-30 11:52:48', NULL, NULL, 8791, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:52:48', 'admin-1493523673-14935243681546392', 1, 1, 'SR', NULL, NULL, NULL),
(28296, '2017-04-30 11:33:18', NULL, NULL, 8787, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:33:18', 'admin-1493519466-14935231981911828', 1, 0, '', NULL, NULL, NULL),
(28297, '2017-04-30 11:59:01', NULL, NULL, 8792, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:59:01', 'admin-1493523673-14935247415514624', 1, 0, '', NULL, NULL, NULL),
(28298, '2017-04-30 11:58:48', NULL, NULL, 8792, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:58:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28299, '2017-04-30 12:42:52', NULL, NULL, 8796, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:42:52', 'admin-1493527337-14935273724889281', 1, 1, 'SR', NULL, NULL, NULL),
(28300, '2017-04-30 14:42:24', NULL, NULL, 8806, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:42:24', 'admin-1493530943-14935345446649865', 1, 1, 'SR', NULL, NULL, NULL),
(28301, '2017-04-30 12:51:16', NULL, NULL, 8796, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:51:16', 'admin-1493527337-1493527876807929', 1, 1, 'SR', NULL, NULL, NULL),
(28302, '2017-04-30 12:42:52', NULL, NULL, 8796, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:42:52', 'admin-1493527337-14935273724889281', 1, 1, 'SR', NULL, NULL, NULL),
(28303, '2017-04-30 15:43:14', NULL, NULL, 8811, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 15:43:14', 'admin-1493530943-1493538194512165', 1, 1, 'SR', NULL, NULL, NULL),
(28304, '2017-04-30 12:38:51', NULL, NULL, 8795, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:38:51', 'admin-1493523673-14935271309541096', 1, 1, 'SR', NULL, NULL, NULL),
(28305, '2017-04-30 12:38:51', NULL, NULL, 8795, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:38:51', 'admin-1493523673-14935271309541096', 1, 1, 'SR', NULL, NULL, NULL),
(28306, '2017-04-30 12:38:51', NULL, NULL, 8795, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:38:51', 'admin-1493523673-14935271309541096', 1, 1, 'SR', NULL, NULL, NULL),
(28307, '2017-04-30 12:42:27', NULL, NULL, 8796, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:42:27', 'admin-1493527337-14935273471787150', 1, 0, '', NULL, NULL, NULL),
(28308, '2017-04-30 12:10:31', NULL, NULL, 8794, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1493530943', 'admin', '2017-04-30 12:10:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28309, '2017-04-30 11:59:25', NULL, NULL, 8793, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:59:25', 'admin-1493523673-14935247650066142', 1, 1, 'SR', NULL, NULL, NULL),
(28310, '2017-04-30 11:59:25', NULL, NULL, 8793, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:59:25', 'admin-1493523673-14935247650066142', 1, 1, 'SR', NULL, NULL, NULL),
(28311, '2017-04-30 14:23:45', NULL, NULL, 8805, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 14:23:45', 'admin-1493530943-14935334250051019', 1, 0, '', NULL, NULL, NULL),
(28312, '2017-04-30 11:55:28', NULL, NULL, 8791, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:55:28', 'admin-1493523673-14935245285146230', 1, 0, '', NULL, NULL, NULL),
(28313, '2017-04-30 11:55:28', NULL, NULL, 8791, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:55:28', 'admin-1493523673-14935245285146230', 1, 0, '', NULL, NULL, NULL),
(28314, '2017-04-30 11:55:28', NULL, NULL, 8791, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:55:28', 'admin-1493523673-14935245285146230', 1, 0, '', NULL, NULL, NULL),
(28315, '2017-04-30 11:52:48', NULL, NULL, 8791, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:52:48', 'admin-1493523673-14935243681546392', 1, 1, 'SR', NULL, NULL, NULL),
(28316, '2017-04-30 13:42:10', NULL, NULL, 8803, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:42:10', 'admin-1493527337-1493530930591319', 1, 0, '', NULL, NULL, NULL),
(28317, '2017-04-30 11:34:47', NULL, NULL, 8788, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:34:47', 'admin-1493519466-14935232876162095', 1, 1, 'SR', NULL, NULL, NULL),
(28318, '2017-04-30 11:34:47', NULL, NULL, 8788, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:34:47', 'admin-1493519466-14935232876162095', 1, 1, 'SR', NULL, NULL, NULL),
(28319, '2017-04-30 11:34:47', NULL, NULL, 8788, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:34:47', 'admin-1493519466-14935232876162095', 1, 0, '', NULL, NULL, NULL),
(28320, '2017-04-30 11:36:55', NULL, NULL, 8789, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:36:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28321, '2017-04-30 11:37:06', NULL, NULL, 8789, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:37:06', 'admin-1493519466-14935234266823264', 1, 0, '', NULL, NULL, NULL),
(28322, '2017-04-30 11:37:06', NULL, NULL, 8789, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:37:06', 'admin-1493519466-14935234266823264', 1, 0, '', NULL, NULL, NULL),
(28323, '2017-04-30 11:37:06', NULL, NULL, 8789, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:37:06', 'admin-1493519466-14935234266823264', 1, 1, 'SR', NULL, NULL, NULL),
(28324, '2017-04-30 11:34:42', NULL, NULL, 8788, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:34:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28325, '2017-04-30 11:33:29', NULL, NULL, 8787, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:33:29', 'admin-1493519466-14935232094148417', 1, 1, 'SR', NULL, NULL, NULL),
(28326, '2017-04-30 11:33:29', NULL, NULL, 8787, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:33:29', 'admin-1493519466-14935232094148417', 1, 0, '', NULL, NULL, NULL),
(28327, '2017-04-30 11:33:29', NULL, NULL, 8787, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:33:29', 'admin-1493519466-14935232094148417', 1, 1, 'SR', NULL, NULL, NULL),
(28328, '2017-04-30 10:21:25', NULL, NULL, 8781, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:21:25', 'admin-1493517436-1493518884876708', 1, 1, 'SR', NULL, NULL, NULL),
(28329, '2017-04-30 10:21:25', NULL, NULL, 8781, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:21:25', 'admin-1493517436-1493518884876708', 1, 0, '', NULL, NULL, NULL),
(28330, '2017-04-30 10:30:42', NULL, NULL, 8782, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:30:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28331, '2017-04-30 10:30:56', NULL, NULL, 8782, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:30:56', 'admin-1493517436-1493519456694452', 1, 0, '', NULL, NULL, NULL),
(28332, '2017-04-30 10:31:20', NULL, NULL, 8782, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:31:20', 'admin-1493519466-14935194800436963', 1, 1, 'SR', NULL, NULL, NULL),
(28333, '2017-04-30 10:31:46', NULL, NULL, 8778, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:31:46', 'admin-1493519466-1493519506045743', 1, 1, 'SR', NULL, NULL, NULL),
(28334, '2017-04-30 10:31:46', NULL, NULL, 8778, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:31:46', 'admin-1493519466-1493519506045743', 1, 1, 'SR', NULL, NULL, NULL),
(28335, '2017-04-30 10:55:08', NULL, NULL, 8783, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:55:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28336, '2017-04-30 10:12:15', NULL, NULL, 8778, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:12:15', 'admin-1493517436-1493518335299942', 1, 0, '', NULL, NULL, NULL),
(28337, '2017-04-30 10:12:15', NULL, NULL, 8778, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:12:15', 'admin-1493517436-1493518335299942', 1, 0, '', NULL, NULL, NULL),
(28338, '2017-04-30 10:12:49', NULL, NULL, 8778, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:12:49', 'admin-1493517436-14935183696017342', 1, 1, 'SR', NULL, NULL, NULL),
(28339, '2017-04-30 11:30:41', NULL, NULL, 8786, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:30:41', 'admin-1493519466-14935230413489796', 1, 0, '', NULL, NULL, NULL),
(28340, '2017-04-30 11:30:53', NULL, NULL, 8786, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:30:53', 'admin-1493519466-14935230533967515', 1, 0, '', NULL, NULL, NULL),
(28341, '2017-04-30 11:30:41', NULL, NULL, 8786, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:30:41', 'admin-1493519466-14935230413489796', 1, 0, '', NULL, NULL, NULL),
(28342, '2017-04-30 11:28:46', NULL, NULL, 8785, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:28:46', 'admin-1493519466-14935229263127610', 1, 0, '', NULL, NULL, NULL),
(28343, '2017-04-30 11:30:13', NULL, NULL, 8786, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:30:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28344, '2017-04-30 11:28:16', NULL, NULL, 8785, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:28:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28345, '2017-04-30 11:28:29', NULL, NULL, 8785, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:28:29', 'admin-1493519466-1493522909469361', 1, 0, '', NULL, NULL, NULL),
(28346, '2017-04-30 11:28:46', NULL, NULL, 8785, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:28:46', 'admin-1493519466-14935229263127610', 1, 1, 'SR', NULL, NULL, NULL),
(28347, '2017-04-30 10:06:44', NULL, NULL, 8777, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:06:44', 'admin-1493517436-14935180047582962', 1, 0, '', NULL, NULL, NULL),
(28348, '2017-04-30 11:59:25', NULL, NULL, 8793, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:59:25', 'admin-1493523673-14935247650066142', 1, 1, 'SR', NULL, NULL, NULL),
(28349, '2017-04-30 10:12:49', NULL, NULL, 8778, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:12:49', 'admin-1493517436-14935183696017342', 1, 0, '', NULL, NULL, NULL),
(28350, '2017-04-30 11:21:00', NULL, NULL, 8784, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:21:00', 'admin-1493519466-1493522460669225', 1, 0, '', NULL, NULL, NULL),
(28351, '2017-04-30 10:55:13', NULL, NULL, 8783, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:55:13', 'admin-1493519466-14935209131952825', 1, 1, 'SR', NULL, NULL, NULL),
(28352, '2017-04-30 10:20:49', NULL, NULL, 8780, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:20:49', 'admin-1493517436-14935188490446379', 1, 1, 'SR', NULL, NULL, NULL),
(28353, '2017-04-30 10:20:44', NULL, NULL, 8780, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:20:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28354, '2017-04-30 10:12:49', NULL, NULL, 8778, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:12:49', 'admin-1493517436-14935183696017342', 1, 1, 'SR', NULL, NULL, NULL),
(28355, '2017-04-30 10:14:05', NULL, NULL, 8779, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:14:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28356, '2017-04-30 09:58:11', NULL, NULL, 8776, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:58:11', 'admin-1493517436-14935174912931193', 1, 0, '', NULL, NULL, NULL),
(28357, '2017-04-30 09:58:40', NULL, NULL, 8776, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:58:40', 'admin-1493517436-14935175201623661', 1, 0, '', NULL, NULL, NULL),
(28358, '2017-04-30 09:58:40', NULL, NULL, 8776, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:58:40', 'admin-1493517436-14935175201623661', 1, 1, 'SR', NULL, NULL, NULL),
(28359, '2017-04-30 09:58:40', NULL, NULL, 8776, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:58:40', 'admin-1493517436-14935175201623661', 1, 1, 'SR', NULL, NULL, NULL),
(28360, '2017-04-30 11:28:29', NULL, NULL, 8785, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:28:29', 'admin-1493519466-1493522909469361', 1, 0, '', NULL, NULL, NULL),
(28361, '2017-04-30 10:06:25', NULL, NULL, 8777, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:06:25', 'admin-1493517436-14935179849114961', 1, 0, '', NULL, NULL, NULL),
(28362, '2017-04-30 10:06:44', NULL, NULL, 8777, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:06:44', 'admin-1493517436-14935180047582962', 1, 1, 'SR', NULL, NULL, NULL),
(28363, '2017-04-30 10:06:44', NULL, NULL, 8777, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:06:44', 'admin-1493517436-14935180047582962', 1, 1, 'SR', NULL, NULL, NULL),
(28364, '2017-04-30 09:52:54', NULL, NULL, 8775, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:52:54', 'admin-1493512436-14935171744364620', 1, 0, '', NULL, NULL, NULL),
(28365, '2017-04-30 09:52:47', NULL, NULL, 8775, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:52:47', 'admin-1493512436-14935171676774637', 1, 1, 'SR', NULL, NULL, NULL),
(28366, '2017-04-30 09:41:55', NULL, NULL, 8774, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:41:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28367, '2017-04-30 09:42:07', NULL, NULL, 8774, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:42:07', 'admin-1493512436-14935165268344883', 1, 0, '', NULL, NULL, NULL),
(28368, '2017-04-30 09:42:07', NULL, NULL, 8774, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:42:07', 'admin-1493512436-14935165268344883', 1, 0, '', NULL, NULL, NULL),
(28369, '2017-04-30 09:42:07', NULL, NULL, 8774, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:42:07', 'admin-1493512436-14935165268344883', 1, 0, '', NULL, NULL, NULL),
(28370, '2017-04-30 09:42:15', NULL, NULL, 8774, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:42:15', 'admin-1493512436-14935165354627731', 1, 1, 'SR', NULL, NULL, NULL),
(28371, '2017-04-30 09:42:15', NULL, NULL, 8774, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:42:15', 'admin-1493512436-14935165354627731', 1, 0, '', NULL, NULL, NULL),
(28372, '2017-04-30 13:49:08', NULL, NULL, 8804, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1493530943', 'admin', '2017-04-30 13:49:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28373, '2017-04-30 11:59:01', NULL, NULL, 8792, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 11:59:01', 'admin-1493523673-14935247415514624', 1, 0, '', NULL, NULL, NULL),
(28374, '2017-04-30 10:12:15', NULL, NULL, 8778, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:12:15', 'admin-1493517436-1493518335299942', 1, 0, '', NULL, NULL, NULL),
(28375, '2017-04-30 10:12:15', NULL, NULL, 8778, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:12:15', 'admin-1493517436-1493518335299942', 1, 0, '', NULL, NULL, NULL),
(28376, '2017-04-30 10:12:15', NULL, NULL, 8778, 0, 153, '87', 'Wake Me Up!', ' replace sausage,no bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:12:15', 'admin-1493517436-1493518335299942', 1, 0, '', NULL, NULL, NULL),
(28377, '2017-04-30 09:06:53', NULL, NULL, 8770, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:06:53', 'admin-1493512436-14935144133044119', 1, 0, '', NULL, NULL, NULL),
(28378, '2017-04-30 09:07:02', NULL, NULL, 8770, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:07:02', 'admin-1493512436-14935144222339151', 1, 1, 'SR', NULL, NULL, NULL),
(28379, '2017-04-30 09:07:02', NULL, NULL, 8770, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:07:02', 'admin-1493512436-14935144222339151', 1, 0, '', NULL, NULL, NULL),
(28380, '2017-04-30 09:08:47', NULL, NULL, 8771, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:08:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28381, '2017-04-30 09:08:54', NULL, NULL, 8771, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:08:54', 'admin-1493512436-14935145348145024', 1, 0, '', NULL, NULL, NULL),
(28382, '2017-04-30 09:09:04', NULL, NULL, 8771, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:09:04', 'admin-1493512436-14935145444912236', 1, 1, 'SR', NULL, NULL, NULL),
(28383, '2017-04-30 09:20:41', NULL, NULL, 8772, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:20:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28384, '2017-04-30 10:11:42', NULL, NULL, 8778, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.90, 0.0000, 0.0000, 14.90, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:11:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28385, '2017-04-30 10:12:49', NULL, NULL, 8778, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:12:49', 'admin-1493517436-14935183696017342', 1, 1, 'SR', NULL, NULL, NULL),
(28386, '2017-04-30 10:06:25', NULL, NULL, 8777, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:06:25', 'admin-1493517436-14935179849114961', 1, 0, '', NULL, NULL, NULL),
(28387, '2017-04-30 10:05:40', NULL, NULL, 8777, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:05:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28388, '2017-04-30 10:06:25', NULL, NULL, 8777, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 10:06:25', 'admin-1493517436-14935179849114961', 1, 0, '', NULL, NULL, NULL),
(28389, '2017-04-30 09:58:02', NULL, NULL, 8776, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:58:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28390, '2017-04-30 09:58:11', NULL, NULL, 8776, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:58:11', 'admin-1493517436-14935174912931193', 1, 0, '', NULL, NULL, NULL),
(28391, '2017-04-30 09:52:47', NULL, NULL, 8775, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:52:47', 'admin-1493512436-14935171676774637', 1, 0, '', NULL, NULL, NULL),
(28392, '2017-04-30 09:52:22', NULL, NULL, 8775, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:52:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28393, '2017-04-30 09:27:07', NULL, NULL, 8773, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:27:07', 'admin-1493512436-14935156272833357', 1, 0, '', NULL, NULL, NULL),
(28394, '2017-04-30 09:27:07', NULL, NULL, 8773, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:27:07', 'admin-1493512436-14935156272833357', 1, 1, 'SR', NULL, NULL, NULL),
(28395, '2017-04-30 09:27:07', NULL, NULL, 8773, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:27:07', 'admin-1493512436-14935156272833357', 1, 1, 'SR', NULL, NULL, NULL),
(28396, '2017-04-30 09:26:55', NULL, NULL, 8773, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:26:55', 'admin-1493512436-14935156149942018', 1, 0, '', NULL, NULL, NULL),
(28397, '2017-04-30 09:20:50', NULL, NULL, 8772, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493530943', 'admin', '2017-04-30 09:20:50', 'admin-1493512436-1493515249913455', 1, 0, '', NULL, NULL, NULL),
(28398, '2017-05-01 16:06:38', NULL, NULL, 8862, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:06:38', 'admin-1493620337-14936259987118551', 1, 1, 'SR', NULL, NULL, NULL),
(28399, '2017-05-01 16:06:38', NULL, NULL, 8862, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:06:38', 'admin-1493620337-14936259987118551', 1, 1, 'SR', NULL, NULL, NULL),
(28400, '2017-05-01 16:06:15', NULL, NULL, 8862, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:06:15', 'admin-1493620337-14936259748754891', 1, 0, '', NULL, NULL, NULL),
(28401, '2017-05-01 15:54:42', NULL, NULL, 8860, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 15:54:42', 'admin-1493620337-14936252823255926', 1, 1, 'SR', NULL, NULL, NULL),
(28402, '2017-05-01 15:54:42', NULL, NULL, 8860, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 15:54:42', 'admin-1493620337-14936252823255926', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(28403, '2017-05-01 10:25:58', NULL, NULL, 8833, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:25:58', 'admin-1493605313-14936055586983219', 1, 1, 'SR', NULL, NULL, NULL),
(28404, '2017-05-01 11:23:06', NULL, NULL, 8840, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:23:06', 'admin-1493607746-14936089859211339', 1, 0, '', NULL, NULL, '15.0'),
(28405, '2017-05-01 11:23:06', NULL, NULL, 8840, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:23:06', 'admin-1493607746-14936089859211339', 1, 0, '', NULL, NULL, '15.0'),
(28406, '2017-05-01 11:23:06', NULL, NULL, 8840, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:23:06', 'admin-1493607746-14936089859211339', 1, 1, 'SR', NULL, NULL, '15.0'),
(28407, '2017-05-01 11:27:17', NULL, NULL, 8839, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:27:17', 'admin-1493607746-14936092377031473', 1, 0, '', NULL, NULL, '15.0'),
(28408, '2017-05-01 11:27:28', NULL, NULL, 8841, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.30, 0.0000, 0.0000, 11.30, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:27:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28409, '2017-05-01 11:27:58', NULL, NULL, 8841, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:27:58', 'admin-1493607746-1493609278561346', 1, 0, '', NULL, NULL, NULL),
(28410, '2017-05-01 11:27:58', NULL, NULL, 8841, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:27:58', 'admin-1493607746-1493609278561346', 1, 0, '', NULL, NULL, NULL),
(28411, '2017-05-01 11:27:58', NULL, NULL, 8841, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:27:58', 'admin-1493607746-1493609278561346', 1, 0, '', NULL, NULL, NULL),
(28412, '2017-05-01 11:27:58', NULL, NULL, 8841, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:27:58', 'admin-1493607746-1493609278561346', 1, 0, '', NULL, NULL, NULL),
(28413, '2017-05-01 09:33:46', NULL, NULL, 8821, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:33:46', 'admin-1493599601-14936024260864287', 1, 0, '', NULL, NULL, '15.0'),
(28414, '2017-05-01 09:35:50', NULL, NULL, 8822, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:35:50', '0', 1, 1, 'SR', NULL, NULL, '15.0'),
(28415, '2017-05-01 09:36:01', NULL, NULL, 8822, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:36:01', 'admin-1493599601-14936025614534769', 1, 0, '', NULL, NULL, '15.0'),
(28416, '2017-05-01 09:36:01', NULL, NULL, 8822, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:36:01', 'admin-1493599601-14936025614534769', 1, 0, '', NULL, NULL, '15.0'),
(28417, '2017-05-01 09:36:16', NULL, NULL, 8823, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.80, 0.0000, 0.0000, 9.80, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:36:16', '0', 1, 1, 'SR', NULL, NULL, '15.0'),
(28418, '2017-05-01 09:36:34', NULL, NULL, 8823, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:36:34', 'admin-1493602570-14936025938741035', 1, 0, '', NULL, NULL, '15.0'),
(28419, '2017-05-01 16:06:15', NULL, NULL, 8862, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:06:15', 'admin-1493620337-14936259748754891', 1, 1, 'SR', NULL, NULL, NULL),
(28420, '2017-05-01 14:07:16', NULL, NULL, 8856, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 14:07:16', 'admin-1493611353-14936188365476940', 1, 0, '', NULL, NULL, '15.0'),
(28421, '2017-05-01 14:26:12', NULL, NULL, 8857, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1493634754', 'admin', '2017-05-01 14:26:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28422, '2017-05-01 14:26:17', NULL, NULL, 8857, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 14:26:17', 'admin-1493611353-14936199775325346', 1, 1, 'SR', NULL, NULL, NULL),
(28423, '2017-05-01 14:00:02', NULL, NULL, 8856, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 14:00:02', 'admin-1493611353-14936184024722774', 1, 1, 'SR', NULL, NULL, '15.0'),
(28424, '2017-05-01 14:00:17', NULL, NULL, 8856, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 14:00:17', 'admin-1493611353-1493618416924842', 1, 0, '', NULL, NULL, '15.0'),
(28425, '2017-05-01 13:25:53', NULL, NULL, 8854, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:25:53', 'admin-1493611353-14936163535053645', 1, 1, 'SR', NULL, NULL, '15.0'),
(28426, '2017-05-01 13:25:53', NULL, NULL, 8854, 0, 181, '116', 'Open Food ', 'spicy pork', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:25:53', 'admin-1493611353-14936163535053645', 1, 0, '', NULL, NULL, '15.0'),
(28427, '2017-05-01 13:25:53', NULL, NULL, 8854, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:25:53', 'admin-1493611353-14936163535053645', 1, 1, 'SR', NULL, NULL, '15.0'),
(28428, '2017-05-01 15:36:00', NULL, NULL, 8859, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 15:36:00', 'admin-1493620337-14936241601443247', 1, 1, 'SR', NULL, NULL, '15.0'),
(28429, '2017-05-01 15:34:00', NULL, NULL, 8859, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 15:34:00', 'admin-1493620337-14936240405135275', 1, 1, 'SR', NULL, NULL, '15.0'),
(28430, '2017-05-01 15:36:00', NULL, NULL, 8859, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 15:36:00', 'admin-1493620337-14936241601443247', 1, 1, 'SR', NULL, NULL, '15.0'),
(28431, '2017-05-01 15:36:00', NULL, NULL, 8859, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 15:36:00', 'admin-1493620337-14936241601443247', 1, 1, 'SR', NULL, NULL, '15.0'),
(28432, '2017-05-01 15:33:57', NULL, NULL, 8859, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1493634754', 'admin', '2017-05-01 15:33:57', '0', 1, 1, 'SR', NULL, NULL, '15.0'),
(28433, '2017-05-01 09:50:55', NULL, NULL, 8825, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:50:55', 'admin-1493602570-14936034556058260', 1, 0, '', NULL, NULL, NULL),
(28434, '2017-05-01 09:56:28', NULL, NULL, 8826, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:56:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28435, '2017-05-01 11:31:07', NULL, NULL, 8841, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:31:07', 'admin-1493609297-14936094671512336', 1, 1, 'SR', NULL, NULL, NULL),
(28436, '2017-05-01 10:25:58', NULL, NULL, 8833, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:25:58', 'admin-1493605313-14936055586983219', 1, 0, '', NULL, NULL, NULL),
(28437, '2017-05-01 10:14:09', NULL, NULL, 8829, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:14:09', 'admin-1493603861-14936048496638776', 1, 0, '', NULL, NULL, '15.0'),
(28438, '2017-05-01 10:14:17', NULL, NULL, 8829, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:14:17', 'admin-1493603861-14936048576967597', 1, 1, 'SR', NULL, NULL, '15.0'),
(28439, '2017-05-01 11:01:21', NULL, NULL, 8835, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:01:21', '0', 1, 1, 'SR', NULL, NULL, '15.0'),
(28440, '2017-05-01 11:01:51', NULL, NULL, 8835, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:01:51', 'admin-1493605313-14936077108926822', 1, 0, '', NULL, NULL, '15.0'),
(28441, '2017-05-01 11:01:51', NULL, NULL, 8835, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:01:51', 'admin-1493605313-14936077108926822', 1, 0, '', NULL, NULL, '15.0'),
(28442, '2017-05-01 11:01:51', NULL, NULL, 8835, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:01:51', 'admin-1493605313-14936077108926822', 1, 0, '', NULL, NULL, '15.0'),
(28443, '2017-05-01 11:01:51', NULL, NULL, 8835, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:01:51', 'admin-1493605313-14936077108926822', 1, 0, '', NULL, NULL, '15.0'),
(28444, '2017-05-01 11:01:51', NULL, NULL, 8835, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:01:51', 'admin-1493605313-14936077108926822', 1, 0, '', NULL, NULL, '15.0'),
(28445, '2017-05-01 15:29:33', NULL, NULL, 8858, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 15:29:33', 'admin-1493620337-14936237730081889', 1, 1, 'SR', NULL, NULL, NULL),
(28446, '2017-05-01 15:29:29', NULL, NULL, 8858, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1493634754', 'admin', '2017-05-01 15:29:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28447, '2017-05-01 15:21:24', NULL, NULL, 8853, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 15:21:24', 'admin-1493620337-14936232842069281', 1, 1, 'SR', NULL, NULL, NULL),
(28448, '2017-05-01 16:05:41', NULL, NULL, 8862, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:05:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28449, '2017-05-01 16:03:40', NULL, NULL, 8861, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:03:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28450, '2017-05-01 14:58:06', NULL, NULL, 8854, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 14:58:06', 'admin-1493620337-14936218863214572', 1, 1, 'SR', NULL, NULL, '15.0'),
(28451, '2017-05-01 14:43:56', NULL, NULL, 8853, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 14:43:56', 'admin-1493620337-1493621035898111', 1, 1, 'SR', NULL, NULL, NULL),
(28452, '2017-05-01 14:40:04', NULL, NULL, 8854, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 14:40:04', 'admin-1493620337-14936208040937599', 1, 1, 'SR', NULL, NULL, '15.0'),
(28453, '2017-05-01 14:32:12', NULL, NULL, 8857, 0, 154, '88', 'Daily Dose BLT', 'dressing aside', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 14:32:12', 'admin-1493611353-14936203319366058', 1, 0, '', NULL, NULL, NULL),
(28454, '2017-05-01 14:26:17', NULL, NULL, 8857, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 14:26:17', 'admin-1493611353-14936199775325346', 1, 1, 'SR', NULL, NULL, NULL),
(28455, '2017-05-01 14:32:12', NULL, NULL, 8857, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 14:32:12', 'admin-1493611353-14936203319366058', 1, 0, '', NULL, NULL, NULL),
(28456, '2017-05-01 13:30:54', NULL, NULL, 8855, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:30:54', 'admin-1493611353-14936166538436114', 1, 0, '', NULL, NULL, NULL),
(28457, '2017-05-01 13:31:02', NULL, NULL, 8855, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:31:02', 'admin-1493611353-14936166620881316', 1, 1, 'SR', NULL, NULL, NULL),
(28458, '2017-05-01 13:31:02', NULL, NULL, 8855, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:31:02', 'admin-1493611353-14936166620881316', 1, 1, 'SR', NULL, NULL, NULL),
(28459, '2017-05-01 13:41:20', NULL, NULL, 8854, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:41:20', 'admin-1493611353-14936172798945091', 1, 0, '', NULL, NULL, '15.0'),
(28460, '2017-05-01 13:59:56', NULL, NULL, 8856, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:59:56', '0', 1, 1, 'SR', NULL, NULL, '15.0'),
(28461, '2017-05-01 14:00:02', NULL, NULL, 8856, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 14:00:02', 'admin-1493611353-14936184024722774', 1, 1, 'SR', NULL, NULL, '15.0'),
(28462, '2017-05-01 14:00:02', NULL, NULL, 8856, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 14:00:02', 'admin-1493611353-14936184024722774', 1, 1, 'SR', NULL, NULL, '15.0'),
(28463, '2017-05-01 14:00:02', NULL, NULL, 8856, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 14:00:02', 'admin-1493611353-14936184024722774', 1, 1, 'SR', NULL, NULL, '15.0'),
(28464, '2017-05-01 12:44:08', NULL, NULL, 8850, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:44:08', 'admin-1493611353-14936138487419817', 1, 1, 'SR', NULL, NULL, NULL),
(28465, '2017-05-01 12:44:09', NULL, NULL, 8850, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:44:09', 'admin-1493611353-14936138487419817', 1, 1, 'SR', NULL, NULL, NULL),
(28466, '2017-05-01 13:04:15', NULL, NULL, 8851, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:04:15', '0', 1, 1, 'SR', NULL, NULL, '15.0'),
(28467, '2017-05-01 13:04:39', NULL, NULL, 8851, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:04:39', 'admin-1493611353-14936150796752956', 1, 0, '', NULL, NULL, '15.0'),
(28468, '2017-05-01 11:01:51', NULL, NULL, 8835, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:01:51', 'admin-1493605313-14936077108926822', 1, 1, 'SR', NULL, NULL, '15.0'),
(28469, '2017-05-01 11:57:05', NULL, NULL, 8846, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:57:05', 'admin-1493609297-14936110249771849', 1, 0, '', NULL, NULL, NULL),
(28470, '2017-05-01 15:36:00', NULL, NULL, 8859, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 15:36:00', 'admin-1493620337-14936241601443247', 1, 1, 'SR', NULL, NULL, '15.0'),
(28471, '2017-05-01 13:16:57', NULL, NULL, 8852, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:16:57', 'admin-1493611353-14936158176063761', 1, 1, 'SR', NULL, NULL, '15.0'),
(28472, '2017-05-01 13:19:36', NULL, NULL, 8853, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:19:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28473, '2017-05-01 13:19:52', NULL, NULL, 8853, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:19:52', 'admin-1493611353-1493615991938122', 1, 0, '', NULL, NULL, NULL),
(28474, '2017-05-01 13:19:52', NULL, NULL, 8853, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:19:52', 'admin-1493611353-1493615991938122', 1, 0, '', NULL, NULL, NULL),
(28475, '2017-05-01 13:19:52', NULL, NULL, 8853, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:19:52', 'admin-1493611353-1493615991938122', 1, 0, '', NULL, NULL, NULL),
(28476, '2017-05-01 13:19:52', NULL, NULL, 8853, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:19:52', 'admin-1493611353-1493615991938122', 1, 1, 'SR', NULL, NULL, NULL),
(28477, '2017-05-01 13:30:44', NULL, NULL, 8855, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:30:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28478, '2017-05-01 13:30:54', NULL, NULL, 8855, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:30:54', 'admin-1493611353-14936166538436114', 1, 0, '', NULL, NULL, NULL),
(28479, '2017-05-01 13:26:13', NULL, NULL, 8852, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:26:13', 'admin-1493611353-14936163728162572', 1, 0, '', NULL, NULL, '15.0'),
(28480, '2017-05-01 11:04:00', NULL, NULL, 8837, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:04:00', 'admin-1493607746-14936078404191836', 1, 0, '', NULL, NULL, NULL),
(28481, '2017-05-01 12:39:11', NULL, NULL, 8849, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:39:11', 'admin-1493611353-14936135514718527', 1, 0, '', NULL, NULL, NULL),
(28482, '2017-05-01 12:39:11', NULL, NULL, 8849, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:39:11', 'admin-1493611353-14936135514718527', 1, 0, '', NULL, NULL, NULL),
(28483, '2017-05-01 13:04:39', NULL, NULL, 8851, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:04:39', 'admin-1493611353-14936150796752956', 1, 0, '', NULL, NULL, '15.0'),
(28484, '2017-05-01 13:25:53', NULL, NULL, 8854, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:25:53', 'admin-1493611353-14936163535053645', 1, 1, 'SR', NULL, NULL, '15.0'),
(28485, '2017-05-01 13:24:29', NULL, NULL, 8854, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.20, 0.0000, 0.0000, 10.20, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:24:29', '0', 1, 1, 'SR', NULL, NULL, '15.0'),
(28486, '2017-05-01 12:39:11', NULL, NULL, 8849, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:39:11', 'admin-1493611353-14936135514718527', 1, 1, 'SR', NULL, NULL, NULL),
(28487, '2017-05-01 12:39:11', NULL, NULL, 8849, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:39:11', 'admin-1493611353-14936135514718527', 1, 1, 'SR', NULL, NULL, NULL),
(28488, '2017-05-01 12:39:11', NULL, NULL, 8849, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:39:11', 'admin-1493611353-14936135514718527', 1, 1, 'SR', NULL, NULL, NULL),
(28489, '2017-05-01 13:16:47', NULL, NULL, 8852, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:16:47', '0', 1, 1, 'SR', NULL, NULL, '15.0'),
(28490, '2017-05-01 13:04:39', NULL, NULL, 8851, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 13:04:39', 'admin-1493611353-14936150796752956', 1, 0, '', NULL, NULL, '15.0'),
(28491, '2017-05-01 12:39:11', NULL, NULL, 8849, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:39:11', 'admin-1493611353-14936135514718527', 1, 1, 'SR', NULL, NULL, NULL),
(28492, '2017-05-01 12:44:01', NULL, NULL, 8850, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:44:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28493, '2017-05-01 12:39:11', NULL, NULL, 8849, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:39:11', 'admin-1493611353-14936135514718527', 1, 0, '', NULL, NULL, NULL),
(28494, '2017-05-01 12:03:39', NULL, NULL, 8838, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:03:39', 'admin-1493611353-14936114196067285', 1, 0, '', NULL, NULL, NULL),
(28495, '2017-05-01 12:04:00', NULL, NULL, 8837, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:04:00', 'admin-1493611353-14936114403103360', 1, 0, '', NULL, NULL, NULL),
(28496, '2017-05-01 11:04:00', NULL, NULL, 8837, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:04:00', 'admin-1493607746-14936078404191836', 1, 0, '', NULL, NULL, NULL),
(28497, '2017-05-01 11:04:00', NULL, NULL, 8837, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:04:00', 'admin-1493607746-14936078404191836', 1, 1, 'SR', NULL, NULL, NULL),
(28498, '2017-05-01 10:28:09', NULL, NULL, 8834, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:28:09', 'admin-1493605313-14936056895712960', 1, 0, '', NULL, NULL, '15.0'),
(28499, '2017-05-01 11:57:05', NULL, NULL, 8846, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:57:05', 'admin-1493609297-14936110249771849', 1, 0, '', NULL, NULL, NULL),
(28500, '2017-05-01 11:31:07', NULL, NULL, 8841, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:31:07', 'admin-1493609297-14936094671512336', 1, 0, '', NULL, NULL, NULL),
(28501, '2017-05-01 15:54:23', NULL, NULL, 8860, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1493634754', 'admin', '2017-05-01 15:54:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28502, '2017-05-01 12:38:46', NULL, NULL, 8849, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:38:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28503, '2017-05-01 12:26:05', NULL, NULL, 8846, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:26:05', 'admin-1493611353-14936127651256950', 1, 0, '', NULL, NULL, NULL),
(28504, '2017-05-01 12:08:25', NULL, NULL, 8847, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:08:25', 'admin-1493611353-14936117055808850', 1, 0, '', NULL, NULL, NULL),
(28505, '2017-05-01 12:08:25', NULL, NULL, 8847, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:08:25', 'admin-1493611353-14936117055808850', 1, 1, 'SR', NULL, NULL, NULL),
(28506, '2017-05-01 12:11:18', NULL, NULL, 8848, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:11:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28507, '2017-05-01 12:11:31', NULL, NULL, 8848, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:11:31', 'admin-1493611353-14936118911518731', 1, 0, '', NULL, NULL, NULL),
(28508, '2017-05-01 12:11:31', NULL, NULL, 8848, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:11:31', 'admin-1493611353-14936118911518731', 1, 0, '', NULL, NULL, NULL),
(28509, '2017-05-01 15:29:43', NULL, NULL, 8858, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 15:29:43', 'admin-1493620337-14936237828439831', 1, 0, '', NULL, NULL, NULL),
(28510, '2017-05-01 12:08:02', NULL, NULL, 8847, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:08:02', 'admin-1493611353-1493611682389333', 1, 1, 'SR', NULL, NULL, NULL),
(28511, '2017-05-01 12:08:02', NULL, NULL, 8847, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:08:02', 'admin-1493611353-1493611682389333', 1, 0, '', NULL, NULL, NULL),
(28512, '2017-05-01 12:07:41', NULL, NULL, 8847, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:07:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28513, '2017-05-01 11:03:34', NULL, NULL, 8836, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:03:34', 'admin-1493607746-1493607814001710', 1, 0, '', NULL, NULL, NULL),
(28514, '2017-05-01 11:03:34', NULL, NULL, 8836, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:03:34', 'admin-1493607746-1493607814001710', 1, 1, 'SR', NULL, NULL, NULL),
(28515, '2017-05-01 11:03:34', NULL, NULL, 8836, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:03:34', 'admin-1493607746-1493607814001710', 1, 1, 'SR', NULL, NULL, NULL),
(28516, '2017-05-01 11:03:45', NULL, NULL, 8837, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:03:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28517, '2017-05-01 11:04:00', NULL, NULL, 8837, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:04:00', 'admin-1493607746-14936078404191836', 1, 0, '', NULL, NULL, NULL),
(28518, '2017-05-01 11:06:07', NULL, NULL, 8838, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:06:07', 'admin-1493607746-14936079670507478', 1, 0, '', NULL, NULL, NULL),
(28519, '2017-05-01 11:08:42', NULL, NULL, 8839, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:08:42', '0', 1, 1, 'SR', NULL, NULL, '15.0'),
(28520, '2017-05-01 11:09:01', NULL, NULL, 8839, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:09:01', 'admin-1493607746-1493608141288829', 1, 0, '', NULL, NULL, '15.0'),
(28521, '2017-05-01 11:09:01', NULL, NULL, 8839, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:09:01', 'admin-1493607746-1493608141288829', 1, 0, '', NULL, NULL, '15.0'),
(28522, '2017-05-01 11:09:01', NULL, NULL, 8839, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:09:01', 'admin-1493607746-1493608141288829', 1, 0, '', NULL, NULL, '15.0'),
(28523, '2017-05-01 11:09:01', NULL, NULL, 8839, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:09:01', 'admin-1493607746-1493608141288829', 1, 1, 'SR', NULL, NULL, '15.0'),
(28524, '2017-05-01 10:28:09', NULL, NULL, 8834, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:28:09', 'admin-1493605313-14936056895712960', 1, 0, '', NULL, NULL, '15.0'),
(28525, '2017-05-01 10:01:01', NULL, NULL, 8827, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:01:01', 'admin-1493603861-14936040616802145', 1, 1, 'SR', NULL, NULL, '15.0'),
(28526, '2017-05-01 10:04:00', NULL, NULL, 8828, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:04:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28527, '2017-05-01 10:04:04', NULL, NULL, 8828, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:04:04', 'admin-1493603861-1493604244033371', 1, 1, 'SR', NULL, NULL, NULL),
(28528, '2017-05-01 10:00:47', NULL, NULL, 8827, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:00:47', 'admin-1493603861-1493604046952288', 1, 0, '', NULL, NULL, '15.0'),
(28529, '2017-05-01 10:00:47', NULL, NULL, 8827, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:00:47', 'admin-1493603861-1493604046952288', 1, 0, '', NULL, NULL, '15.0'),
(28530, '2017-05-01 11:57:05', NULL, NULL, 8846, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:57:05', 'admin-1493609297-14936110249771849', 1, 1, 'SR', NULL, NULL, NULL),
(28531, '2017-05-01 11:36:15', NULL, NULL, 8845, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:36:15', 'admin-1493609297-14936097754585736', 1, 1, 'SR', NULL, NULL, NULL),
(28532, '2017-05-01 11:57:05', NULL, NULL, 8846, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:57:05', 'admin-1493609297-14936110249771849', 1, 1, 'SR', NULL, NULL, NULL),
(28533, '2017-05-01 11:36:03', NULL, NULL, 8845, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:36:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28534, '2017-05-01 11:32:07', NULL, NULL, 8844, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:32:07', 'admin-1493609297-1493609526935137', 1, 1, 'SR', NULL, NULL, NULL),
(28535, '2017-05-01 11:32:07', NULL, NULL, 8844, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:32:07', 'admin-1493609297-1493609526935137', 1, 1, 'SR', NULL, NULL, NULL),
(28536, '2017-05-01 11:31:55', NULL, NULL, 8844, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:31:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28537, '2017-05-01 11:31:07', NULL, NULL, 8841, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:31:07', 'admin-1493609297-14936094671512336', 1, 1, 'SR', NULL, NULL, NULL),
(28538, '2017-05-01 10:42:37', NULL, NULL, 8834, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:42:37', 'admin-1493605313-14936065569121250', 1, 0, '', NULL, NULL, '15.0'),
(28539, '2017-05-01 10:43:35', NULL, NULL, 8834, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:43:35', 'admin-1493605313-14936066147294134', 1, 0, '', NULL, NULL, '15.0'),
(28540, '2017-05-01 10:43:35', NULL, NULL, 8834, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:43:35', 'admin-1493605313-14936066147294134', 1, 1, 'SR', NULL, NULL, '15.0'),
(28541, '2017-05-01 10:43:35', NULL, NULL, 8834, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:43:35', 'admin-1493605313-14936066147294134', 1, 1, 'SR', NULL, NULL, '15.0'),
(28542, '2017-05-01 11:31:07', NULL, NULL, 8841, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:31:07', 'admin-1493609297-14936094671512336', 1, 1, 'SR', NULL, NULL, NULL),
(28543, '2017-05-01 11:31:07', NULL, NULL, 8841, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:31:07', 'admin-1493609297-14936094671512336', 1, 1, 'SR', NULL, NULL, NULL),
(28544, '2017-05-01 11:30:05', NULL, NULL, 8843, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:30:05', 'admin-1493609297-14936094050691552', 1, 1, 'SR', NULL, NULL, NULL),
(28545, '2017-05-01 11:30:01', NULL, NULL, 8843, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:30:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28546, '2017-05-01 11:28:35', NULL, NULL, 8842, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:28:35', 'admin-1493609297-14936093157173597', 1, 0, '', NULL, NULL, NULL),
(28547, '2017-05-01 11:28:35', NULL, NULL, 8842, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:28:35', 'admin-1493609297-14936093157173597', 1, 1, 'SR', NULL, NULL, NULL),
(28548, '2017-05-01 11:28:35', NULL, NULL, 8842, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:28:35', 'admin-1493609297-14936093157173597', 1, 0, '', NULL, NULL, NULL),
(28549, '2017-05-01 11:28:35', NULL, NULL, 8842, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:28:35', 'admin-1493609297-14936093157173597', 1, 0, '', NULL, NULL, NULL),
(28550, '2017-05-01 11:28:24', NULL, NULL, 8842, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:28:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28551, '2017-05-01 11:09:01', NULL, NULL, 8839, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:09:01', 'admin-1493607746-1493608141288829', 1, 1, 'SR', NULL, NULL, '15.0'),
(28552, '2017-05-01 10:17:37', NULL, NULL, 8831, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:17:37', 'admin-1493603861-14936050569826389', 1, 1, 'SR', NULL, NULL, NULL),
(28553, '2017-05-01 15:52:04', NULL, NULL, 8859, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 15:52:04', 'admin-1493620337-1493625124176712', 1, 0, '', NULL, NULL, '15.0'),
(28554, '2017-05-01 11:03:08', NULL, NULL, 8836, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:03:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28555, '2017-05-01 11:05:50', NULL, NULL, 8838, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:05:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28556, '2017-05-01 11:03:34', NULL, NULL, 8836, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:03:34', 'admin-1493607746-1493607814001710', 1, 0, '', NULL, NULL, NULL),
(28557, '2017-05-01 10:28:15', NULL, NULL, 8834, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:28:15', 'admin-1493605313-14936056952074512', 1, 1, 'SR', NULL, NULL, '15.0'),
(28558, '2017-05-01 15:54:42', NULL, NULL, 8860, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 15:54:42', 'admin-1493620337-14936252823255926', 1, 0, '', NULL, NULL, NULL),
(28559, '2017-05-01 16:06:38', NULL, NULL, 8862, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:06:38', 'admin-1493620337-14936259987118551', 1, 1, 'SR', NULL, NULL, NULL),
(28560, '2017-05-01 12:11:31', NULL, NULL, 8848, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:11:31', 'admin-1493611353-14936118911518731', 1, 0, '', NULL, NULL, NULL),
(28561, '2017-05-01 10:43:35', NULL, NULL, 8834, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:43:35', 'admin-1493605313-14936066147294134', 1, 1, 'SR', NULL, NULL, '15.0'),
(28562, '2017-05-01 10:43:35', NULL, NULL, 8834, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:43:35', 'admin-1493605313-14936066147294134', 1, 1, 'SR', NULL, NULL, '15.0'),
(28563, '2017-05-01 10:28:15', NULL, NULL, 8834, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:28:15', 'admin-1493605313-14936056952074512', 1, 1, 'SR', NULL, NULL, '15.0'),
(28564, '2017-05-01 10:14:09', NULL, NULL, 8829, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:14:09', 'admin-1493603861-14936048496638776', 1, 0, '', NULL, NULL, '15.0'),
(28565, '2017-05-01 10:01:01', NULL, NULL, 8827, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:01:01', 'admin-1493603861-14936040616802145', 1, 1, 'SR', NULL, NULL, '15.0'),
(28566, '2017-05-01 10:17:37', NULL, NULL, 8831, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:17:37', 'admin-1493603861-14936050569826389', 1, 1, 'SR', NULL, NULL, NULL),
(28567, '2017-05-01 10:17:37', NULL, NULL, 8831, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:17:37', 'admin-1493603861-14936050569826389', 1, 1, 'SR', NULL, NULL, NULL),
(28568, '2017-05-01 10:27:49', NULL, NULL, 8834, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.50, 0.0000, 0.0000, 13.50, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:27:49', '0', 1, 1, 'SR', NULL, NULL, '15.0'),
(28569, '2017-05-01 10:28:09', NULL, NULL, 8834, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:28:09', 'admin-1493605313-14936056895712960', 1, 0, '', NULL, NULL, '15.0'),
(28570, '2017-05-01 10:28:09', NULL, NULL, 8834, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:28:09', 'admin-1493605313-14936056895712960', 1, 0, '', NULL, NULL, '15.0'),
(28571, '2017-05-01 10:00:36', NULL, NULL, 8827, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.00, 0.0000, 0.0000, 12.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:00:36', '0', 1, 1, 'SR', NULL, NULL, '15.0'),
(28572, '2017-05-01 11:22:56', NULL, NULL, 8840, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:22:56', '0', 1, 1, 'SR', NULL, NULL, '15.0'),
(28573, '2017-05-01 10:20:58', NULL, NULL, 8823, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:20:58', 'admin-1493603861-14936052577958921', 1, 1, 'SR', NULL, NULL, '15.0'),
(28574, '2017-05-01 10:20:58', NULL, NULL, 8823, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:20:58', 'admin-1493603861-14936052577958921', 1, 0, '', NULL, NULL, '15.0'),
(28575, '2017-05-01 10:21:58', NULL, NULL, 8832, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:21:58', '0', 1, 1, 'SR', NULL, NULL, '15.0'),
(28576, '2017-05-01 10:22:10', NULL, NULL, 8832, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:22:10', 'admin-1493605313-14936053304614828', 1, 0, '', NULL, NULL, '15.0'),
(28577, '2017-05-01 10:22:10', NULL, NULL, 8832, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:22:10', 'admin-1493605313-14936053304614828', 1, 0, '', NULL, NULL, '15.0'),
(28578, '2017-05-01 10:22:10', NULL, NULL, 8832, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:22:10', 'admin-1493605313-14936053304614828', 1, 1, 'SR', NULL, NULL, '15.0'),
(28579, '2017-05-01 10:25:50', NULL, NULL, 8833, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:25:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28580, '2017-05-01 09:50:48', NULL, NULL, 8825, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:50:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28581, '2017-05-01 10:17:16', NULL, NULL, 8831, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:17:16', 'admin-1493603861-1493605036239742', 1, 0, '', NULL, NULL, NULL),
(28582, '2017-05-01 10:17:16', NULL, NULL, 8831, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:17:16', 'admin-1493603861-1493605036239742', 1, 0, '', NULL, NULL, NULL),
(28583, '2017-05-01 12:39:11', NULL, NULL, 8849, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 12:39:11', 'admin-1493611353-14936135514718527', 1, 0, '', NULL, NULL, NULL),
(28584, '2017-05-01 10:17:16', NULL, NULL, 8831, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:17:16', 'admin-1493603861-1493605036239742', 1, 0, '', NULL, NULL, NULL),
(28585, '2017-05-01 10:17:16', NULL, NULL, 8831, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:17:16', 'admin-1493603861-1493605036239742', 1, 0, '', NULL, NULL, NULL),
(28586, '2017-05-01 10:16:27', NULL, NULL, 8831, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.10, 0.0000, 0.0000, 10.10, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:16:27', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(28587, '2017-05-01 10:16:10', NULL, NULL, 8830, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:16:10', 'admin-1493603861-14936049701987250', 1, 1, 'SR', NULL, NULL, '15.0'),
(28588, '2017-05-01 09:23:30', NULL, NULL, 8818, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:23:30', 'admin-1493599601-14936018101897610', 1, 1, 'SR', NULL, NULL, '15.0'),
(28589, '2017-05-01 09:23:30', NULL, NULL, 8818, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:23:30', 'admin-1493599601-14936018101897610', 1, 1, 'SR', NULL, NULL, '15.0'),
(28590, '2017-05-01 09:23:30', NULL, NULL, 8818, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:23:30', 'admin-1493599601-14936018101897610', 1, 0, '', NULL, NULL, '15.0'),
(28591, '2017-05-01 09:23:30', NULL, NULL, 8818, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:23:30', 'admin-1493599601-14936018101897610', 1, 0, '', NULL, NULL, '15.0'),
(28592, '2017-05-01 09:26:00', NULL, NULL, 8820, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.40, 0.0000, 0.0000, 15.40, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:26:00', '0', 1, 1, 'SR', NULL, NULL, '15.0'),
(28593, '2017-05-01 09:26:12', NULL, NULL, 8820, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:26:12', 'admin-1493599601-14936019723301743', 1, 0, '', NULL, NULL, '15.0'),
(28594, '2017-05-01 10:16:10', NULL, NULL, 8830, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:16:10', 'admin-1493603861-14936049701987250', 1, 0, '', NULL, NULL, '15.0'),
(28595, '2017-05-01 10:16:05', NULL, NULL, 8830, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:16:05', '0', 1, 1, 'SR', NULL, NULL, '15.0'),
(28596, '2017-05-01 10:14:17', NULL, NULL, 8829, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:14:17', 'admin-1493603861-14936048576967597', 1, 1, 'SR', NULL, NULL, '15.0'),
(28597, '2017-05-01 09:49:35', NULL, NULL, 8824, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:49:35', 'admin-1493602570-1493603375589566', 1, 0, '', NULL, NULL, '15.0'),
(28598, '2017-05-01 09:49:50', NULL, NULL, 8824, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:49:50', 'admin-1493602570-14936033899966368', 1, 1, 'SR', NULL, NULL, '15.0'),
(28599, '2017-05-01 09:49:50', NULL, NULL, 8824, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:49:50', 'admin-1493602570-14936033899966368', 1, 1, 'SR', NULL, NULL, '15.0'),
(28600, '2017-05-01 09:49:50', NULL, NULL, 8824, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:49:50', 'admin-1493602570-14936033899966368', 1, 1, 'SR', NULL, NULL, '15.0'),
(28601, '2017-05-01 09:49:50', NULL, NULL, 8824, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:49:50', 'admin-1493602570-14936033899966368', 1, 1, 'SR', NULL, NULL, '15.0'),
(28602, '2017-05-01 09:49:50', NULL, NULL, 8824, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:49:50', 'admin-1493602570-14936033899966368', 1, 1, 'SR', NULL, NULL, '15.0'),
(28603, '2017-05-01 09:50:06', NULL, NULL, 8820, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:50:06', 'admin-1493602570-14936034061082149', 1, 0, '', NULL, NULL, '15.0'),
(28604, '2017-05-01 11:06:07', NULL, NULL, 8838, 0, 156, '90', 'House Cheddar Omelet', 'Add baked beans', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:06:07', 'admin-1493607746-14936079670507478', 1, 0, '', NULL, NULL, NULL),
(28605, '2017-05-01 09:58:13', NULL, NULL, 8821, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:58:13', 'admin-1493603861-14936038935927373', 1, 1, 'SR', NULL, NULL, '15.0'),
(28606, '2017-05-01 09:57:14', NULL, NULL, 8821, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:57:14', 'admin-1493602570-14936038345152823', 1, 0, '', NULL, NULL, '15.0'),
(28607, '2017-05-01 15:29:43', NULL, NULL, 8858, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 15:29:43', 'admin-1493620337-14936237828439831', 1, 1, 'SR', NULL, NULL, NULL),
(28608, '2017-05-01 10:01:01', NULL, NULL, 8827, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:01:01', 'admin-1493603861-14936040616802145', 1, 1, 'SR', NULL, NULL, '15.0'),
(28609, '2017-05-01 10:00:47', NULL, NULL, 8827, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:00:47', 'admin-1493603861-1493604046952288', 1, 0, '', NULL, NULL, '15.0'),
(28610, '2017-05-01 10:00:47', NULL, NULL, 8827, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:00:47', 'admin-1493603861-1493604046952288', 1, 0, '', NULL, NULL, '15.0'),
(28611, '2017-05-01 16:03:47', NULL, NULL, 8861, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:03:47', 'admin-1493620337-1493625827215790', 1, 0, '', NULL, NULL, NULL),
(28612, '2017-05-01 11:56:45', NULL, NULL, 8846, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:56:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28613, '2017-05-01 11:01:51', NULL, NULL, 8835, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 11:01:51', 'admin-1493605313-14936077108926822', 1, 1, 'SR', NULL, NULL, '15.0'),
(28614, '2017-05-01 10:01:01', NULL, NULL, 8827, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:01:01', 'admin-1493603861-14936040616802145', 1, 1, 'SR', NULL, NULL, '15.0'),
(28615, '2017-05-01 09:59:45', NULL, NULL, 8823, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:59:45', 'admin-1493603861-14936039852321321', 1, 0, '', NULL, NULL, '15.0'),
(28616, '2017-05-01 09:58:13', NULL, NULL, 8821, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:58:13', 'admin-1493603861-14936038935927373', 1, 1, 'SR', NULL, NULL, '15.0'),
(28617, '2017-05-01 09:33:46', NULL, NULL, 8821, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:33:46', 'admin-1493599601-14936024260864287', 1, 1, 'SR', NULL, NULL, '15.0'),
(28618, '2017-05-01 09:26:12', NULL, NULL, 8820, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:26:12', 'admin-1493599601-14936019723301743', 1, 1, 'SR', NULL, NULL, '15.0'),
(28619, '2017-05-01 09:26:12', NULL, NULL, 8820, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:26:12', 'admin-1493599601-14936019723301743', 1, 1, 'SR', NULL, NULL, '15.0'),
(28620, '2017-05-01 09:26:12', NULL, NULL, 8820, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:26:12', 'admin-1493599601-14936019723301743', 1, 1, 'SR', NULL, NULL, '15.0'),
(28621, '2017-05-01 09:33:26', NULL, NULL, 8821, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 20.80, 0.0000, 0.0000, 20.80, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:33:26', '0', 1, 1, 'SR', NULL, NULL, '15.0'),
(28622, '2017-05-01 09:33:46', NULL, NULL, 8821, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:33:46', 'admin-1493599601-14936024260864287', 1, 0, '', NULL, NULL, '15.0'),
(28623, '2017-05-01 10:13:48', NULL, NULL, 8829, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1493634754', 'admin', '2017-05-01 10:13:48', '0', 1, 1, 'SR', NULL, NULL, '15.0'),
(28624, '2017-05-01 09:57:14', NULL, NULL, 8821, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:57:14', 'admin-1493602570-14936038345152823', 1, 0, '', NULL, NULL, '15.0'),
(28625, '2017-05-01 09:57:14', NULL, NULL, 8821, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:57:14', 'admin-1493602570-14936038345152823', 1, 0, '', NULL, NULL, '15.0'),
(28626, '2017-05-01 09:20:26', NULL, NULL, 8818, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:20:26', 'admin-1493599601-14936016263416937', 1, 0, '', NULL, NULL, '15.0'),
(28627, '2017-05-01 09:20:26', NULL, NULL, 8818, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:20:26', 'admin-1493599601-14936016263416937', 1, 0, '', NULL, NULL, '15.0'),
(28628, '2017-05-01 09:21:25', NULL, NULL, 8819, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:21:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28629, '2017-05-01 09:21:34', NULL, NULL, 8819, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:21:34', 'admin-1493599601-14936016945261913', 1, 0, '', NULL, NULL, NULL),
(28630, '2017-05-01 09:21:34', NULL, NULL, 8819, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:21:34', 'admin-1493599601-14936016945261913', 1, 0, '', NULL, NULL, NULL),
(28631, '2017-05-01 09:21:40', NULL, NULL, 8819, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:21:40', 'admin-1493599601-149360170002141', 1, 1, 'SR', NULL, NULL, NULL),
(28632, '2017-05-01 09:21:40', NULL, NULL, 8819, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:21:40', 'admin-1493599601-149360170002141', 1, 1, 'SR', NULL, NULL, NULL),
(28633, '2017-05-01 09:56:35', NULL, NULL, 8826, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:56:35', 'admin-1493602570-14936037949277372', 1, 0, '', NULL, NULL, NULL),
(28634, '2017-05-01 09:50:55', NULL, NULL, 8825, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:50:55', 'admin-1493602570-14936034556058260', 1, 1, 'SR', NULL, NULL, NULL),
(28635, '2017-05-01 09:49:35', NULL, NULL, 8824, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:49:35', 'admin-1493602570-1493603375589566', 1, 0, '', NULL, NULL, '15.0'),
(28636, '2017-05-01 09:36:34', NULL, NULL, 8823, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:36:34', 'admin-1493602570-14936025938741035', 1, 0, '', NULL, NULL, '15.0'),
(28637, '2017-05-01 09:36:34', NULL, NULL, 8823, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:36:34', 'admin-1493602570-14936025938741035', 1, 0, '', NULL, NULL, '15.0'),
(28638, '2017-05-01 09:36:34', NULL, NULL, 8823, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:36:34', 'admin-1493602570-14936025938741035', 1, 1, 'SR', NULL, NULL, '15.0'),
(28639, '2017-05-01 09:37:24', NULL, NULL, 8820, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:37:24', 'admin-1493602570-1493602643908858', 1, 1, 'SR', NULL, NULL, '15.0'),
(28640, '2017-05-01 09:37:24', NULL, NULL, 8820, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:37:24', 'admin-1493602570-1493602643908858', 1, 0, '', NULL, NULL, '15.0'),
(28641, '2017-05-01 09:49:24', NULL, NULL, 8824, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.70, 0.0000, 0.0000, 15.70, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:49:24', '0', 1, 1, 'SR', NULL, NULL, '15.0'),
(28642, '2017-05-01 09:49:35', NULL, NULL, 8824, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:49:35', 'admin-1493602570-1493603375589566', 1, 0, '', NULL, NULL, '15.0'),
(28643, '2017-05-01 09:49:35', NULL, NULL, 8824, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:49:35', 'admin-1493602570-1493603375589566', 1, 0, '', NULL, NULL, '15.0'),
(28644, '2017-05-01 09:49:35', NULL, NULL, 8824, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:49:35', 'admin-1493602570-1493603375589566', 1, 0, '', NULL, NULL, '15.0'),
(28645, '2017-05-01 09:56:35', NULL, NULL, 8826, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:56:35', 'admin-1493602570-14936037949277372', 1, 1, 'SR', NULL, NULL, NULL),
(28646, '2017-05-01 09:49:35', NULL, NULL, 8824, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:49:35', 'admin-1493602570-1493603375589566', 1, 0, '', NULL, NULL, '15.0'),
(28647, '2017-05-01 09:33:46', NULL, NULL, 8821, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:33:46', 'admin-1493599601-14936024260864287', 1, 1, 'SR', NULL, NULL, '15.0'),
(28648, '2017-05-01 09:33:46', NULL, NULL, 8821, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:33:46', 'admin-1493599601-14936024260864287', 1, 0, '', NULL, NULL, '15.0'),
(28649, '2017-05-01 09:33:46', NULL, NULL, 8821, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:33:46', 'admin-1493599601-14936024260864287', 1, 0, '', NULL, NULL, '15.0'),
(28650, '2017-05-01 09:33:46', NULL, NULL, 8821, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:33:46', 'admin-1493599601-14936024260864287', 1, 0, '', NULL, NULL, '15.0'),
(28651, '2017-05-01 09:33:46', NULL, NULL, 8821, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:33:46', 'admin-1493599601-14936024260864287', 1, 0, '', NULL, NULL, '15.0'),
(28652, '2017-05-01 09:33:46', NULL, NULL, 8821, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:33:46', 'admin-1493599601-14936024260864287', 1, 0, '', NULL, NULL, '15.0'),
(28653, '2017-05-01 09:26:12', NULL, NULL, 8820, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:26:12', 'admin-1493599601-14936019723301743', 1, 0, '', NULL, NULL, '15.0'),
(28654, '2017-05-01 09:26:12', NULL, NULL, 8820, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:26:12', 'admin-1493599601-14936019723301743', 1, 0, '', NULL, NULL, '15.0'),
(28655, '2017-05-01 09:26:12', NULL, NULL, 8820, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:26:12', 'admin-1493599601-14936019723301743', 1, 0, '', NULL, NULL, '15.0'),
(28656, '2017-05-01 09:20:26', NULL, NULL, 8818, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:20:26', 'admin-1493599601-14936016263416937', 1, 0, '', NULL, NULL, '15.0'),
(28657, '2017-05-01 09:10:39', NULL, NULL, 8818, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:10:39', 'admin-1493599601-14936010388089210', 1, 0, '', NULL, NULL, '15.0'),
(28658, '2017-05-01 09:20:26', NULL, NULL, 8818, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:20:26', 'admin-1493599601-14936016263416937', 1, 0, '', NULL, NULL, '15.0'),
(28659, '2017-05-01 09:10:36', NULL, NULL, 8818, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:10:36', 'admin-1493599601-14936010362004465', 1, 1, 'SR', NULL, NULL, '15.0'),
(28660, '2017-05-01 09:10:31', NULL, NULL, 8818, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.00, 0.0000, 0.0000, 13.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 09:10:31', '0', 1, 1, 'SR', NULL, NULL, '15.0'),
(28661, '2017-05-01 16:06:38', NULL, NULL, 8862, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:06:38', 'admin-1493620337-14936259987118551', 1, 0, '', NULL, NULL, NULL),
(28662, '2017-05-01 16:17:33', NULL, NULL, 8863, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.70, 0.0000, 0.0000, 9.70, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:17:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28663, '2017-05-01 16:17:44', NULL, NULL, 8863, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:17:44', 'admin-1493620337-1493626664276372', 1, 1, 'SR', NULL, NULL, NULL),
(28664, '2017-05-01 16:17:44', NULL, NULL, 8863, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:17:44', 'admin-1493620337-1493626664276372', 1, 1, 'SR', NULL, NULL, NULL),
(28665, '2017-05-01 16:17:44', NULL, NULL, 8863, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:17:44', 'admin-1493620337-1493626664276372', 1, 1, 'SR', NULL, NULL, NULL),
(28666, '2017-05-01 16:18:43', NULL, NULL, 8864, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:18:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28667, '2017-05-01 16:18:55', NULL, NULL, 8864, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:18:55', 'admin-1493620337-14936267354238290', 1, 1, 'SR', NULL, NULL, NULL),
(28668, '2017-05-01 16:18:55', NULL, NULL, 8864, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:18:55', 'admin-1493620337-14936267354238290', 1, 1, 'SR', NULL, NULL, NULL),
(28669, '2017-05-01 16:24:01', NULL, NULL, 8863, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:24:01', 'admin-1493620337-14936270411183852', 1, 1, 'SR', NULL, NULL, NULL),
(28670, '2017-05-01 16:24:01', NULL, NULL, 8863, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:24:01', 'admin-1493620337-14936270411183852', 1, 0, '', NULL, NULL, NULL),
(28671, '2017-05-01 16:24:01', NULL, NULL, 8863, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:24:01', 'admin-1493620337-14936270411183852', 1, 0, '', NULL, NULL, NULL),
(28672, '2017-05-01 16:31:45', NULL, NULL, 8865, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:31:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28673, '2017-05-01 16:31:54', NULL, NULL, 8865, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:31:54', 'admin-1493620337-1493627514532245', 1, 1, 'SR', NULL, NULL, NULL),
(28674, '2017-05-01 16:31:54', NULL, NULL, 8865, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:31:54', 'admin-1493620337-1493627514532245', 1, 1, 'SR', NULL, NULL, NULL),
(28675, '2017-05-01 16:32:13', NULL, NULL, 8865, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:32:13', 'admin-1493620337-1493627533184453', 1, 0, '', NULL, NULL, NULL),
(28676, '2017-05-01 16:33:17', NULL, NULL, 8863, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 16:33:17', 'admin-1493620337-14936275968807021', 1, 1, 'SR', NULL, NULL, NULL),
(28677, '2017-05-01 17:09:26', NULL, NULL, 8866, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1493634754', 'admin', '2017-05-01 17:09:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28678, '2017-05-01 17:09:35', NULL, NULL, 8866, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 17:09:35', 'admin-1493620337-14936297756644985', 1, 0, '', NULL, NULL, NULL),
(28679, '2017-05-01 17:09:35', NULL, NULL, 8866, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 17:09:35', 'admin-1493620337-14936297756644985', 1, 1, 'SR', NULL, NULL, NULL),
(28680, '2017-05-01 17:09:35', NULL, NULL, 8866, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 17:09:35', 'admin-1493620337-14936297756644985', 1, 0, '', NULL, NULL, NULL),
(28681, '2017-05-01 17:10:04', NULL, NULL, 8866, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 17:10:04', 'admin-1493620337-14936298047432277', 1, 1, 'SR', NULL, NULL, NULL),
(28682, '2017-05-01 17:47:35', NULL, NULL, 8867, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1493634754', 'admin', '2017-05-01 17:47:35', '0', 1, 1, 'SR', NULL, NULL, '15.0'),
(28683, '2017-05-01 17:48:50', NULL, NULL, 8867, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 17:48:50', 'admin-1493620337-14936321307274256', 1, 0, '', NULL, NULL, '15.0'),
(28684, '2017-05-01 17:48:50', NULL, NULL, 8867, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 17:48:50', 'admin-1493620337-14936321307274256', 1, 1, 'SR', NULL, NULL, '15.0'),
(28685, '2017-05-01 17:48:50', NULL, NULL, 8867, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 17:48:50', 'admin-1493620337-14936321307274256', 1, 0, '', NULL, NULL, '15.0'),
(28686, '2017-05-01 17:48:50', NULL, NULL, 8867, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 17:48:50', 'admin-1493620337-14936321307274256', 1, 0, '', NULL, NULL, '15.0'),
(28687, '2017-05-01 17:49:10', NULL, NULL, 8867, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 17:49:10', 'admin-1493620337-14936321505002815', 1, 0, '', NULL, NULL, '15.0'),
(28688, '2017-05-01 18:08:29', NULL, NULL, 8868, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1493634754', 'admin', '2017-05-01 18:08:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28689, '2017-05-01 18:08:46', NULL, NULL, 8868, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 18:08:46', 'admin-1493620337-14936333260541054', 1, 1, 'SR', NULL, NULL, NULL),
(28690, '2017-05-01 18:08:46', NULL, NULL, 8868, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 18:08:46', 'admin-1493620337-14936333260541054', 1, 1, 'SR', NULL, NULL, NULL),
(28691, '2017-05-01 18:09:09', NULL, NULL, 8868, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 18:09:09', 'admin-1493620337-14936333493347910', 1, 0, '', NULL, NULL, NULL),
(28692, '2017-05-01 18:09:09', NULL, NULL, 8868, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 18:09:09', 'admin-1493620337-14936333493347910', 1, 1, 'SR', NULL, NULL, NULL),
(28693, '2017-05-01 18:32:28', NULL, NULL, 8868, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 18:32:28', 'admin-1493620337-14936347486876566', 1, 1, 'SR', NULL, NULL, NULL),
(28694, '2017-05-01 18:33:52', NULL, NULL, 8869, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1493634754', 'admin', '2017-05-01 18:33:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28695, '2017-05-01 18:33:56', NULL, NULL, 8869, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 18:33:56', 'admin-1493634754-14936348361447585', 1, 1, 'SR', NULL, NULL, NULL),
(28696, '2017-05-01 18:33:56', NULL, NULL, 8869, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 18:33:56', 'admin-1493634754-14936348361447585', 1, 1, 'SR', NULL, NULL, NULL),
(28697, '2017-05-01 18:47:37', NULL, NULL, 8870, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1493634754', 'admin', '2017-05-01 18:47:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28698, '2017-05-01 18:47:44', NULL, NULL, 8870, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 18:47:44', 'admin-1493634754-1493635664422490', 1, 1, 'SR', NULL, NULL, NULL),
(28699, '2017-05-01 18:47:44', NULL, NULL, 8870, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493634754', 'admin', '2017-05-01 18:47:44', 'admin-1493634754-1493635664422490', 1, 1, 'SR', NULL, NULL, NULL),
(28700, '2017-05-03 13:11:12', NULL, NULL, 8888, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:11:12', 'admin-1493786746-1493788272077244', 1, 0, '', NULL, NULL, NULL),
(28701, '2017-05-03 13:11:12', NULL, NULL, 8888, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:11:12', 'admin-1493786746-1493788272077244', 1, 1, 'SR', NULL, NULL, NULL),
(28702, '2017-05-03 13:11:12', NULL, NULL, 8888, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:11:12', 'admin-1493786746-1493788272077244', 1, 1, 'SR', NULL, NULL, NULL),
(28703, '2017-05-03 13:11:12', NULL, NULL, 8888, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:11:12', 'admin-1493786746-1493788272077244', 1, 0, '', NULL, NULL, NULL),
(28704, '2017-05-03 13:14:49', NULL, NULL, 8888, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:14:49', 'admin-1493786746-14937884897043660', 1, 0, '', NULL, NULL, NULL),
(28705, '2017-05-03 13:14:49', NULL, NULL, 8888, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:14:49', 'admin-1493786746-14937884897043660', 1, 1, 'SR', NULL, NULL, NULL),
(28706, '2017-05-03 13:01:20', NULL, NULL, 8885, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:01:20', 'admin-1493786746-14937876801944867', 1, 1, 'SR', NULL, NULL, NULL),
(28707, '2017-05-03 13:01:20', NULL, NULL, 8885, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:01:20', 'admin-1493786746-14937876801944867', 1, 1, 'SR', NULL, NULL, NULL),
(28708, '2017-05-03 13:02:14', NULL, NULL, 8886, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:02:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28709, '2017-05-03 13:02:26', NULL, NULL, 8886, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:02:26', 'admin-1493786746-1493787746483257', 1, 0, '', NULL, NULL, NULL),
(28710, '2017-05-03 16:41:04', NULL, NULL, 8896, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1493786746', 'admin', '2017-05-03 16:41:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28711, '2017-05-03 16:49:20', NULL, NULL, 8896, 0, 181, '116', 'Open Food ', 'Scones', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 16:49:20', 'admin-1493786746-1493801360252256', 1, 0, '', NULL, NULL, NULL),
(28712, '2017-05-03 16:49:20', NULL, NULL, 8896, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 16:49:20', 'admin-1493786746-1493801360252256', 1, 1, 'SR', NULL, NULL, NULL),
(28713, '2017-05-03 16:49:20', NULL, NULL, 8896, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 16:49:20', 'admin-1493786746-1493801360252256', 1, 1, 'SR', NULL, NULL, NULL),
(28714, '2017-05-03 12:48:58', NULL, NULL, 8884, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 12:48:58', 'admin-1493786746-14937869378705376', 1, 0, '', NULL, NULL, NULL),
(28715, '2017-05-03 12:47:16', NULL, NULL, 8884, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 2, 11.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 12:47:16', 'admin-1493786746-1493786836102985', 1, 1, 'SR', NULL, NULL, NULL),
(28716, '2017-05-03 12:13:35', NULL, NULL, 8880, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 12:13:35', 'admin-1493776542-14937848156463379', 1, 1, 'SR', NULL, NULL, NULL),
(28717, '2017-05-03 12:18:36', NULL, NULL, 8881, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1493786746', 'admin', '2017-05-03 12:18:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28718, '2017-05-03 12:18:43', NULL, NULL, 8881, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 12:18:43', 'admin-1493776542-14937851237694313', 1, 1, 'SR', NULL, NULL, NULL),
(28719, '2017-05-03 12:18:43', NULL, NULL, 8881, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 12:18:43', 'admin-1493776542-14937851237694313', 1, 1, 'SR', NULL, NULL, NULL),
(28720, '2017-05-03 12:37:08', NULL, NULL, 8882, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1493786746', 'admin', '2017-05-03 12:37:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28721, '2017-05-03 12:37:11', NULL, NULL, 8882, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 12:37:11', 'admin-1493776542-14937862316682886', 1, 1, 'SR', NULL, NULL, NULL),
(28722, '2017-05-03 12:41:05', NULL, NULL, 8883, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1493786746', 'admin', '2017-05-03 12:41:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28723, '2017-05-03 12:41:17', NULL, NULL, 8883, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 12:41:17', 'admin-1493776542-14937864776078577', 1, 1, 'SR', NULL, NULL, NULL),
(28724, '2017-05-03 12:41:17', NULL, NULL, 8883, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 12:41:17', 'admin-1493776542-14937864776078577', 1, 0, '', NULL, NULL, NULL),
(28725, '2017-05-03 12:41:17', NULL, NULL, 8883, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 12:41:17', 'admin-1493776542-14937864776078577', 1, 0, '', NULL, NULL, NULL),
(28726, '2017-05-03 13:14:49', NULL, NULL, 8888, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:14:49', 'admin-1493786746-14937884897043660', 1, 1, 'SR', NULL, NULL, NULL),
(28727, '2017-05-03 13:17:36', NULL, NULL, 8889, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:17:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28728, '2017-05-03 13:17:41', NULL, NULL, 8889, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:17:41', 'admin-1493786746-14937886610708161', 1, 0, '', NULL, NULL, NULL),
(28729, '2017-05-03 13:20:59', NULL, NULL, 8890, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:20:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28730, '2017-05-03 13:21:06', NULL, NULL, 8890, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:21:06', 'admin-1493786746-1493788866536793', 1, 1, 'SR', NULL, NULL, NULL),
(28731, '2017-05-03 13:21:06', NULL, NULL, 8890, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:21:06', 'admin-1493786746-1493788866536793', 1, 1, 'SR', NULL, NULL, NULL),
(28732, '2017-05-03 13:36:22', NULL, NULL, 8891, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:36:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28733, '2017-05-03 13:36:31', NULL, NULL, 8891, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:36:31', 'admin-1493786746-14937897911071022', 1, 1, 'SR', NULL, NULL, NULL),
(28734, '2017-05-03 13:36:31', NULL, NULL, 8891, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:36:31', 'admin-1493786746-14937897911071022', 1, 1, 'SR', NULL, NULL, NULL),
(28735, '2017-05-03 13:36:31', NULL, NULL, 8891, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:36:31', 'admin-1493786746-14937897911071022', 1, 1, 'SR', NULL, NULL, NULL),
(28736, '2017-05-03 13:36:31', NULL, NULL, 8891, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:36:31', 'admin-1493786746-14937897911071022', 1, 0, '', NULL, NULL, NULL),
(28737, '2017-05-03 13:10:47', NULL, NULL, 8888, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.10, 0.0000, 0.0000, 11.10, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:10:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28738, '2017-05-03 13:07:03', NULL, NULL, 8887, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:07:03', 'admin-1493786746-14937880227882247', 1, 1, 'SR', 1, NULL, NULL),
(28739, '2017-05-03 13:07:03', NULL, NULL, 8887, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:07:03', 'admin-1493786746-14937880227882247', 1, 1, 'SR', 1, NULL, NULL),
(28740, '2017-05-03 13:02:26', NULL, NULL, 8886, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:02:26', 'admin-1493786746-1493787746483257', 1, 1, 'SR', NULL, NULL, NULL),
(28741, '2017-05-03 13:02:26', NULL, NULL, 8886, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:02:26', 'admin-1493786746-1493787746483257', 1, 0, '', NULL, NULL, NULL),
(28742, '2017-05-03 13:02:26', NULL, NULL, 8886, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 13:02:26', 'admin-1493786746-1493787746483257', 1, 1, 'SR', NULL, NULL, NULL),
(28743, '2017-05-03 12:59:36', NULL, NULL, 8885, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1493786746', 'admin', '2017-05-03 12:59:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28744, '2017-05-03 12:59:43', NULL, NULL, 8885, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 12:59:43', 'admin-1493786746-14937875833576488', 1, 0, '', NULL, NULL, NULL),
(28745, '2017-05-03 12:59:43', NULL, NULL, 8885, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 12:59:43', 'admin-1493786746-14937875833576488', 1, 0, '', NULL, NULL, NULL),
(28746, '2017-05-03 12:46:37', NULL, NULL, 8884, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1493786746', 'admin', '2017-05-03 12:46:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28747, '2017-05-03 12:47:06', NULL, NULL, 8884, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 12:47:06', 'admin-1493786746-14937868266817270', 1, 1, 'SR', NULL, NULL, NULL),
(28748, '2017-05-03 12:41:17', NULL, NULL, 8883, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 12:41:17', 'admin-1493776542-14937864776078577', 1, 0, '', NULL, NULL, NULL),
(28749, '2017-05-03 12:13:28', NULL, NULL, 8880, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 12:13:28', 'admin-1493776542-14937848086486447', 1, 0, '', NULL, NULL, NULL),
(28750, '2017-05-03 12:13:23', NULL, NULL, 8880, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1493786746', 'admin', '2017-05-03 12:13:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28751, '2017-05-03 16:19:04', NULL, NULL, 8895, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 16:19:04', 'admin-1493786746-14937995446893437', 1, 1, 'SR', NULL, NULL, NULL),
(28752, '2017-05-03 16:19:01', NULL, NULL, 8895, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1493786746', 'admin', '2017-05-03 16:19:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28753, '2017-05-03 11:10:53', NULL, NULL, 8878, 0, 269, '203', 'Espresso Con Panna', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 11:10:53', 'admin-1493776542-14937810534709343', 1, 0, '', NULL, NULL, NULL),
(28754, '2017-05-03 11:10:53', NULL, NULL, 8878, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 11:10:53', 'admin-1493776542-14937810534709343', 1, 1, 'SR', NULL, NULL, NULL),
(28755, '2017-05-03 11:10:53', NULL, NULL, 8878, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 11:10:53', 'admin-1493776542-14937810534709343', 1, 0, '', NULL, NULL, NULL),
(28756, '2017-05-03 11:10:53', NULL, NULL, 8878, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 11:10:53', 'admin-1493776542-14937810534709343', 1, 0, '', NULL, NULL, NULL),
(28757, '2017-05-03 11:10:45', NULL, NULL, 8878, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1493786746', 'admin', '2017-05-03 11:10:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28758, '2017-05-03 11:06:15', NULL, NULL, 8877, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 11:06:15', 'admin-1493776542-14937807753853263', 1, 0, '', NULL, NULL, NULL),
(28759, '2017-05-03 11:06:15', NULL, NULL, 8877, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 11:06:15', 'admin-1493776542-14937807753853263', 1, 1, 'SR', NULL, NULL, NULL),
(28760, '2017-05-03 11:06:15', NULL, NULL, 8877, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 11:06:15', 'admin-1493776542-14937807753853263', 1, 1, 'SR', NULL, NULL, NULL),
(28761, '2017-05-03 11:06:15', NULL, NULL, 8877, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 11:06:15', 'admin-1493776542-14937807753853263', 1, 1, 'SR', NULL, NULL, NULL),
(28762, '2017-05-03 11:06:03', NULL, NULL, 8877, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1493786746', 'admin', '2017-05-03 11:06:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28763, '2017-05-03 10:48:46', NULL, NULL, 8876, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 10:48:46', 'admin-1493776542-14937797258315571', 1, 1, 'SR', NULL, NULL, NULL),
(28764, '2017-05-03 10:48:41', NULL, NULL, 8876, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 10:48:41', 'admin-1493776542-14937797208315680', 1, 0, '', NULL, NULL, NULL),
(28765, '2017-05-03 10:48:41', NULL, NULL, 8876, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 10:48:41', 'admin-1493776542-14937797208315680', 1, 0, '', NULL, NULL, NULL),
(28766, '2017-05-03 10:48:36', NULL, NULL, 8876, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1493786746', 'admin', '2017-05-03 10:48:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28767, '2017-05-03 10:29:45', NULL, NULL, 8875, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 10:29:45', 'admin-1493776542-14937785857807141', 1, 1, 'SR', NULL, NULL, NULL),
(28768, '2017-05-03 10:29:45', NULL, NULL, 8875, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 10:29:45', 'admin-1493776542-14937785857807141', 1, 0, '', NULL, NULL, NULL),
(28769, '2017-05-03 09:52:03', NULL, NULL, 8874, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 09:52:03', 'admin-1493773560-149377632319626', 1, 0, '', NULL, NULL, NULL),
(28770, '2017-05-03 09:52:03', NULL, NULL, 8874, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 09:52:03', 'admin-1493773560-149377632319626', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(28771, '2017-05-03 09:51:50', NULL, NULL, 8874, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 09:51:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28772, '2017-05-03 09:44:37', NULL, NULL, 8873, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 09:44:37', 'admin-1493773560-14937758776228249', 1, 0, '', NULL, NULL, NULL),
(28773, '2017-05-03 09:44:34', NULL, NULL, 8873, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1493786746', 'admin', '2017-05-03 09:44:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28774, '2017-05-03 14:28:36', NULL, NULL, 8890, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 14:28:36', 'admin-1493786746-1493792915786379', 1, 1, 'SR', NULL, NULL, NULL),
(28775, '2017-05-03 14:21:38', NULL, NULL, 8893, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 14:21:38', 'admin-1493786746-14937924980462186', 1, 1, 'SR', NULL, NULL, NULL),
(28776, '2017-05-03 14:28:36', NULL, NULL, 8890, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 14:28:36', 'admin-1493786746-1493792915786379', 1, 0, '', NULL, NULL, NULL),
(28777, '2017-05-03 14:21:38', NULL, NULL, 8893, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 14:21:38', 'admin-1493786746-14937924980462186', 1, 1, 'SR', NULL, NULL, NULL),
(28778, '2017-05-03 14:16:25', NULL, NULL, 8892, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1493786746', 'admin', '2017-05-03 14:16:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28779, '2017-05-03 14:16:29', NULL, NULL, 8892, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 14:16:29', 'admin-1493786746-14937921891753366', 1, 1, 'SR', NULL, NULL, NULL),
(28780, '2017-05-03 14:21:33', NULL, NULL, 8893, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 14:21:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28781, '2017-05-03 10:29:38', NULL, NULL, 8875, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1493786746', 'admin', '2017-05-03 10:29:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28782, '2017-05-03 15:58:07', NULL, NULL, 8894, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 15:58:07', 'admin-1493786746-14937982876755673', 1, 1, 'SR', NULL, NULL, NULL),
(28783, '2017-05-03 09:49:36', NULL, NULL, 8873, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 09:49:36', 'admin-1493773560-14937761765986910', 1, 1, 'SR', NULL, NULL, NULL),
(28784, '2017-05-03 09:49:36', NULL, NULL, 8873, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 09:49:36', 'admin-1493773560-14937761765986910', 1, 1, 'SR', NULL, NULL, NULL),
(28785, '2017-05-03 09:49:31', NULL, NULL, 8873, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 09:49:31', 'admin-1493773560-14937761711583093', 1, 0, '', NULL, NULL, NULL),
(28786, '2017-05-03 15:24:46', NULL, NULL, 8894, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', 'Takeaway', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 15:24:46', 'admin-1493786746-14937962859438999', 1, 1, 'SR', NULL, NULL, NULL),
(28787, '2017-05-03 15:24:26', NULL, NULL, 8894, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1493786746', 'admin', '2017-05-03 15:24:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28788, '2017-05-03 15:24:46', NULL, NULL, 8894, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493786746', 'admin', '2017-05-03 15:24:46', 'admin-1493786746-14937962859438999', 1, 1, 'SR', NULL, NULL, NULL),
(28789, '2017-05-04 00:00:00', NULL, NULL, 8916, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, NULL, NULL, 1.40, 1, '27', 1, '1493864727', 'admin', '2017-05-04 11:59:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28790, '2017-05-04 12:19:19', NULL, NULL, 8915, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1493864727', 'admin', '2017-05-04 12:19:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28791, '2017-05-04 12:18:51', NULL, NULL, 8914, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1493864727', 'admin', '2017-05-04 12:18:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28792, '2017-05-04 00:00:00', NULL, NULL, 8914, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 11:59:29', 'admin-1493864727-14938703693535176', 1, 1, 'SR', NULL, NULL, NULL),
(28793, '2017-05-04 00:00:00', NULL, NULL, 8915, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 11:59:29', 'admin-1493864727-14938703693535176', 1, 1, 'SR', NULL, NULL, NULL),
(28794, '2017-05-04 11:15:58', NULL, NULL, 8907, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 11:15:58', 'admin-1493864727-14938677581174585', 1, 1, 'SR', NULL, NULL, NULL),
(28795, '2017-05-04 11:15:58', NULL, NULL, 8907, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 11:15:58', 'admin-1493864727-14938677581174585', 1, 1, 'SR', NULL, NULL, NULL),
(28796, '2017-05-04 00:00:00', NULL, NULL, 8908, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:25:20', 'admin-1493860053-14938647203242221', 1, 0, '', NULL, NULL, NULL),
(28797, '2017-05-04 00:00:00', NULL, NULL, 8909, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:25:00', 'admin-1493860053-14938647004027375', 1, 0, '', NULL, NULL, NULL),
(28798, '2017-05-04 12:23:15', NULL, NULL, 8912, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 12:23:15', 'admin-1493864727-14938717952715377', 1, 0, '', NULL, NULL, NULL),
(28799, '2017-05-04 12:23:15', NULL, NULL, 8912, 0, 70, '70', 'Pepper Pork', 'Takeaway', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 12:23:15', 'admin-1493864727-14938717952715377', 1, 1, 'SR', NULL, NULL, NULL),
(28800, '2017-05-04 12:23:15', NULL, NULL, 8912, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 12:23:15', 'admin-1493864727-14938717952715377', 1, 0, '', NULL, NULL, NULL),
(28801, '2017-05-04 13:13:25', NULL, NULL, 8917, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1493864727', 'admin', '2017-05-04 13:13:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28802, '2017-05-04 13:13:50', NULL, NULL, 8917, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 13:13:50', 'admin-1493864727-14938748305823473', 1, 1, 'SR', NULL, NULL, NULL),
(28803, '2017-05-04 13:13:50', NULL, NULL, 8917, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 13:13:50', 'admin-1493864727-14938748305823473', 1, 1, 'SR', NULL, NULL, NULL),
(28804, '2017-05-04 13:13:55', NULL, NULL, 8917, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 13:13:55', 'admin-1493864727-14938748353119322', 1, 0, '', NULL, NULL, NULL),
(28805, '2017-05-04 13:13:55', NULL, NULL, 8917, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 13:13:55', 'admin-1493864727-14938748353119322', 1, 0, '', NULL, NULL, NULL),
(28806, '2017-05-04 14:09:32', NULL, NULL, 8918, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1493864727', 'admin', '2017-05-04 14:09:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28807, '2017-05-04 14:09:38', NULL, NULL, 8918, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 14:09:38', 'admin-1493864727-14938781785888258', 1, 1, 'SR', NULL, NULL, NULL),
(28808, '2017-05-04 14:09:38', NULL, NULL, 8918, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 14:09:38', 'admin-1493864727-14938781785888258', 1, 1, 'SR', NULL, NULL, NULL),
(28809, '2017-05-04 11:51:34', NULL, NULL, 8912, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 11:51:34', 'admin-1493864727-14938698946743613', 1, 1, 'SR', NULL, NULL, NULL),
(28810, '2017-05-04 11:51:34', NULL, NULL, 8912, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 11:51:34', 'admin-1493864727-14938698946743613', 1, 0, '', NULL, NULL, NULL),
(28811, '2017-05-04 11:51:42', NULL, NULL, 8912, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 11:51:42', 'admin-1493864727-1493869902584633', 1, 0, '', NULL, NULL, NULL),
(28812, '2017-05-04 11:51:42', NULL, NULL, 8912, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 11:51:42', 'admin-1493864727-1493869902584633', 1, 1, 'SR', NULL, NULL, NULL),
(28813, '2017-05-04 16:32:01', NULL, NULL, 8921, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 16:32:01', 'admin-1493864727-14938867210744034', 1, 1, 'SR', NULL, NULL, NULL),
(28814, '2017-05-04 16:32:01', NULL, NULL, 8921, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 16:32:01', 'admin-1493864727-14938867210744034', 1, 1, 'SR', NULL, NULL, NULL),
(28815, '2017-05-04 00:00:00', NULL, NULL, 8916, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 11:59:29', 'admin-1493864727-14938703693535176', 1, 1, 'SR', NULL, NULL, NULL),
(28816, '2017-05-04 16:31:14', NULL, NULL, 8921, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1493864727', 'admin', '2017-05-04 16:31:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28817, '2017-05-04 16:24:04', NULL, NULL, 8920, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 16:24:04', 'admin-1493864727-14938862446045777', 1, 1, 'SR', NULL, NULL, NULL),
(28818, '2017-05-04 16:26:07', NULL, NULL, 8920, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 16:26:07', 'admin-1493864727-14938863668492893', 1, 0, '', NULL, NULL, NULL),
(28819, '2017-05-04 14:29:57', NULL, NULL, 8919, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1493864727', 'admin', '2017-05-04 14:29:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28820, '2017-05-04 14:30:02', NULL, NULL, 8919, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 14:30:02', 'admin-1493864727-14938794018805526', 1, 1, 'SR', NULL, NULL, NULL),
(28821, '2017-05-04 16:23:59', NULL, NULL, 8920, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1493864727', 'admin', '2017-05-04 16:23:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28822, '2017-05-04 13:13:50', NULL, NULL, 8917, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 13:13:50', 'admin-1493864727-14938748305823473', 1, 0, '', NULL, NULL, NULL),
(28823, '2017-05-04 11:35:53', NULL, NULL, 8911, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1493864727', 'admin', '2017-05-04 11:35:53', 'admin-1493864727-14938689534256038', 1, 0, '', NULL, NULL, NULL),
(28824, '2017-05-04 11:51:20', NULL, NULL, 8912, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.90, 0.0000, 0.0000, 11.90, 1, '27', 1, '1493864727', 'admin', '2017-05-04 11:51:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28825, '2017-05-04 10:25:38', NULL, NULL, 8904, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:25:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28826, '2017-05-04 09:51:53', NULL, NULL, 8898, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1493864727', 'admin', '2017-05-04 09:51:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28827, '2017-05-04 09:58:31', NULL, NULL, 8899, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1493864727', 'admin', '2017-05-04 09:58:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28828, '2017-05-04 10:07:53', NULL, NULL, 8899, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:07:53', 'admin-1493860053-14938636736551558', 1, 0, '', NULL, NULL, NULL),
(28829, '2017-05-04 10:07:53', NULL, NULL, 8899, 0, 283, '217', 'Weight Gain Deal - TBP / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:07:53', 'admin-1493860053-14938636736551558', 1, 0, '', NULL, NULL, NULL),
(28830, '2017-05-04 10:08:29', NULL, NULL, 8900, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:08:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28831, '2017-05-04 10:08:44', NULL, NULL, 8900, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:08:44', 'admin-1493860053-14938637244742869', 1, 0, '', NULL, NULL, NULL),
(28832, '2017-05-04 10:08:44', NULL, NULL, 8900, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:08:44', 'admin-1493860053-14938637244742869', 1, 0, '', NULL, NULL, NULL),
(28833, '2017-05-04 10:10:07', NULL, NULL, 8900, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:10:07', 'admin-1493860053-14938638073258616', 1, 1, 'SR', NULL, NULL, NULL),
(28834, '2017-05-04 10:10:46', NULL, NULL, 8899, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:10:46', 'admin-1493860053-14938638465863136', 1, 0, '', NULL, NULL, NULL),
(28835, '2017-05-04 10:16:15', NULL, NULL, 8901, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:16:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28836, '2017-05-04 10:16:21', NULL, NULL, 8902, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:16:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28837, '2017-05-04 10:16:24', NULL, NULL, 8902, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:16:24', 'admin-1493860053-14938641846051477', 1, 1, 'SR', NULL, NULL, NULL),
(28838, '2017-05-04 10:16:52', NULL, NULL, 8901, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:16:52', 'admin-1493860053-14938642126619942', 1, 0, '', NULL, NULL, NULL),
(28839, '2017-05-04 11:29:27', NULL, NULL, 8911, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 11:29:27', 'admin-1493864727-14938685670352610', 1, 0, '', NULL, NULL, NULL),
(28840, '2017-05-04 10:25:43', NULL, NULL, 8904, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:25:43', 'admin-1493864727-14938647430463823', 1, 0, '', NULL, NULL, NULL),
(28841, '2017-05-04 10:25:43', NULL, NULL, 8904, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:25:43', 'admin-1493864727-14938647430463823', 1, 0, '', NULL, NULL, NULL),
(28842, '2017-05-04 10:27:20', NULL, NULL, 8905, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:27:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28843, '2017-05-04 10:27:28', NULL, NULL, 8905, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:27:28', 'admin-1493864727-1493864848022775', 1, 0, '', NULL, NULL, NULL),
(28844, '2017-05-04 10:27:28', NULL, NULL, 8905, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:27:28', 'admin-1493864727-1493864848022775', 1, 0, '', NULL, NULL, NULL),
(28845, '2017-05-04 10:44:54', NULL, NULL, 8906, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:44:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28846, '2017-05-04 00:00:00', NULL, NULL, 8908, 0, 280, '214', 'Diet Meal - Piccolo / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:25:00', 'admin-1493860053-14938647004027375', 1, 0, '', NULL, NULL, NULL),
(28847, '2017-05-04 11:22:39', NULL, NULL, 8908, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1493864727', 'admin', '2017-05-04 11:22:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28848, '2017-05-04 10:18:06', NULL, NULL, 8901, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:18:06', 'admin-1493860053-14938642866513720', 1, 1, 'SR', NULL, NULL, NULL),
(28849, '2017-05-04 00:00:00', NULL, NULL, 8909, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, NULL, NULL, 2.80, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:24:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28850, '2017-05-04 11:23:59', NULL, NULL, 8910, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1493864727', 'admin', '2017-05-04 11:23:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28851, '2017-05-04 00:00:00', NULL, NULL, 8909, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:25:00', 'admin-1493860053-14938647004027375', 1, 0, '', NULL, NULL, NULL),
(28852, '2017-05-04 11:24:04', NULL, NULL, 8910, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 11:24:04', 'admin-1493864727-14938682443696970', 1, 0, '', NULL, NULL, NULL),
(28853, '2017-05-04 11:24:04', NULL, NULL, 8910, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 11:24:04', 'admin-1493864727-14938682443696970', 1, 0, '', NULL, NULL, NULL),
(28854, '2017-05-04 11:29:21', NULL, NULL, 8911, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.49, 0.0000, 0.0000, 1.49, 1, '27', 1, '1493864727', 'admin', '2017-05-04 11:29:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28855, '2017-05-04 11:15:54', NULL, NULL, 8907, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1493864727', 'admin', '2017-05-04 11:15:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28856, '2017-05-04 10:16:52', NULL, NULL, 8901, 0, 283, '217', 'Weight Gain Deal - TBP / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:16:52', 'admin-1493860053-14938642126619942', 1, 0, '', NULL, NULL, NULL),
(28857, '2017-05-04 09:52:27', NULL, NULL, 8898, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 09:52:27', 'admin-1493860053-14938627476944675', 1, 1, 'SR', NULL, NULL, NULL),
(28858, '2017-05-04 09:51:59', NULL, NULL, 8898, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 09:51:59', 'admin-1493860053-14938627190034611', 1, 1, 'SR', NULL, NULL, NULL),
(28859, '2017-05-04 10:16:52', NULL, NULL, 8901, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:16:52', 'admin-1493860053-14938642126619942', 1, 0, '', NULL, NULL, NULL),
(28860, '2017-05-04 10:16:52', NULL, NULL, 8901, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:16:52', 'admin-1493860053-14938642126619942', 1, 0, '', NULL, NULL, NULL),
(28861, '2017-05-04 10:45:02', NULL, NULL, 8906, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:45:02', 'admin-1493864727-14938659021493685', 1, 0, '', NULL, NULL, NULL),
(28862, '2017-05-04 10:45:41', NULL, NULL, 8906, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493864727', 'admin', '2017-05-04 10:45:41', 'admin-1493864727-14938659408596557', 1, 1, 'SR', NULL, NULL, NULL),
(28863, '2017-05-05 11:33:43', NULL, NULL, 8932, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 11:33:43', 'admin-1493947164-14939552235892631', 1, 1, 'SR', NULL, NULL, NULL),
(28864, '2017-05-05 11:33:43', NULL, NULL, 8932, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 11:33:43', 'admin-1493947164-14939552235892631', 1, 0, '', NULL, NULL, NULL),
(28865, '2017-05-05 11:57:15', NULL, NULL, 8933, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1493947164', 'admin', '2017-05-05 11:57:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28866, '2017-05-05 11:57:19', NULL, NULL, 8933, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 11:57:19', 'admin-1493947164-14939566396964138', 1, 1, 'SR', NULL, NULL, NULL),
(28867, '2017-05-05 11:31:22', NULL, NULL, 8932, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 11:31:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28868, '2017-05-05 11:32:34', NULL, NULL, 8932, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 11:32:34', 'admin-1493947164-14939551545767389', 1, 0, '', NULL, NULL, NULL),
(28869, '2017-05-05 11:32:34', NULL, NULL, 8932, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 11:32:34', 'admin-1493947164-14939551545767389', 1, 1, 'SR', NULL, NULL, NULL),
(28870, '2017-05-05 13:26:30', NULL, NULL, 8938, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 13:26:30', 'admin-1493947164-1493961990210886', 1, 1, 'SR', NULL, NULL, NULL),
(28871, '2017-05-05 14:00:41', NULL, NULL, 8939, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 14:00:41', 'admin-1493947164-1493964041592390', 1, 0, '', 1, NULL, NULL),
(28872, '2017-05-05 14:43:19', NULL, NULL, 8940, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1493947164', 'admin', '2017-05-05 14:43:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28873, '2017-05-05 14:43:22', NULL, NULL, 8940, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 14:43:22', 'admin-1493947164-1493966601927918', 1, 1, 'SR', NULL, NULL, NULL),
(28874, '2017-05-05 13:06:10', NULL, NULL, 8937, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 13:06:10', 'admin-1493947164-14939607707419182', 1, 1, 'SR', NULL, NULL, NULL),
(28875, '2017-05-05 13:06:26', NULL, NULL, 8937, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 13:06:26', 'admin-1493947164-1493960786534875', 1, 1, 'SR', NULL, NULL, NULL),
(28876, '2017-05-05 13:06:43', NULL, NULL, 8937, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 13:06:43', 'admin-1493947164-14939608031078376', 1, 1, 'SR', NULL, NULL, NULL),
(28877, '2017-05-05 13:26:26', NULL, NULL, 8938, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1493947164', 'admin', '2017-05-05 13:26:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28878, '2017-05-05 13:26:30', NULL, NULL, 8938, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 13:26:30', 'admin-1493947164-1493961990210886', 1, 1, 'SR', NULL, NULL, NULL),
(28879, '2017-05-05 17:04:26', NULL, NULL, 8944, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 17:04:26', 'admin-1493947164-14939750663344883', 1, 1, 'SR', NULL, NULL, NULL),
(28880, '2017-05-05 17:04:26', NULL, NULL, 8944, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 17:04:26', 'admin-1493947164-14939750663344883', 1, 0, '', NULL, NULL, NULL),
(28881, '2017-05-05 17:04:09', NULL, NULL, 8944, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1493947164', 'admin', '2017-05-05 17:04:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28882, '2017-05-05 15:41:18', NULL, NULL, 8941, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1493947164', 'admin', '2017-05-05 15:41:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28883, '2017-05-05 15:41:27', NULL, NULL, 8941, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 15:41:27', 'admin-1493947164-14939700872217511', 1, 1, 'SR', NULL, NULL, NULL),
(28884, '2017-05-05 15:41:27', NULL, NULL, 8941, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 15:41:27', 'admin-1493947164-14939700872217511', 1, 1, 'SR', NULL, NULL, NULL),
(28885, '2017-05-05 15:41:27', NULL, NULL, 8941, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 15:41:27', 'admin-1493947164-14939700872217511', 1, 0, '', NULL, NULL, NULL),
(28886, '2017-05-05 15:58:00', NULL, NULL, 8942, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 15:58:00', 'admin-1493947164-14939710798428563', 1, 0, '', 1, NULL, NULL),
(28887, '2017-05-05 15:59:16', NULL, NULL, 8943, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 15:59:16', 'admin-1493947164-14939711562934558', 1, 0, '', 1, NULL, NULL),
(28888, '2017-05-05 14:45:40', NULL, NULL, 8940, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 14:45:40', 'admin-1493947164-14939667403122460', 1, 0, '', NULL, NULL, NULL),
(28889, '2017-05-05 13:04:20', NULL, NULL, 8937, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1493947164', 'admin', '2017-05-05 13:04:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28890, '2017-05-05 13:05:47', NULL, NULL, 8937, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 13:05:47', 'admin-1493947164-14939607475317511', 1, 1, 'SR', NULL, NULL, NULL),
(28891, '2017-05-05 09:44:42', NULL, NULL, 8923, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1493947164', 'admin', '2017-05-05 09:44:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28892, '2017-05-05 09:44:45', NULL, NULL, 8923, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 09:44:45', 'admin-1493947164-14939486856353012', 1, 0, '', NULL, NULL, NULL),
(28893, '2017-05-05 09:44:45', NULL, NULL, 8923, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 09:44:45', 'admin-1493947164-14939486856353012', 1, 0, '', NULL, NULL, NULL),
(28894, '2017-05-05 09:57:45', NULL, NULL, 8924, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1493947164', 'admin', '2017-05-05 09:57:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28895, '2017-05-05 09:58:00', NULL, NULL, 8924, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 09:58:00', 'admin-1493947164-14939494801979024', 1, 0, '', NULL, NULL, NULL),
(28896, '2017-05-05 09:58:00', NULL, NULL, 8924, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 09:58:00', 'admin-1493947164-14939494801979024', 1, 0, '', NULL, NULL, NULL),
(28897, '2017-05-05 09:58:07', NULL, NULL, 8925, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.49, 0.0000, 0.0000, 3.49, 1, '27', 1, '1493947164', 'admin', '2017-05-05 09:58:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28898, '2017-05-05 09:58:36', NULL, NULL, 8925, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 09:58:36', 'admin-1493947164-14939495167878686', 1, 1, 'SR', NULL, NULL, NULL),
(28899, '2017-05-05 09:58:36', NULL, NULL, 8925, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 09:58:36', 'admin-1493947164-14939495167878686', 1, 1, 'SR', NULL, NULL, NULL),
(28900, '2017-05-05 09:58:36', NULL, NULL, 8925, 0, 181, '116', 'Open Food ', 'Scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 09:58:36', 'admin-1493947164-14939495167878686', 1, 0, '', NULL, NULL, NULL),
(28901, '2017-05-05 09:58:36', NULL, NULL, 8925, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1493947164', 'admin', '2017-05-05 09:58:37', 'admin-1493947164-14939495167878686', 1, 0, '', NULL, NULL, NULL),
(28902, '2017-05-05 10:12:06', NULL, NULL, 8925, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 10:12:06', 'admin-1493947164-14939503267125525', 1, 1, 'SR', NULL, NULL, NULL),
(28903, '2017-05-05 10:37:02', NULL, NULL, 8926, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 10:37:02', 'admin-1493947164-14939518222453139', 1, 0, '', NULL, NULL, NULL),
(28904, '2017-05-05 10:37:02', NULL, NULL, 8926, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 10:37:02', 'admin-1493947164-14939518222453139', 1, 0, '', NULL, NULL, NULL),
(28905, '2017-05-05 10:37:02', NULL, NULL, 8926, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 10:37:02', 'admin-1493947164-14939518222453139', 1, 0, '', NULL, NULL, NULL),
(28906, '2017-05-05 11:29:17', NULL, NULL, 8930, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 11:29:17', 'admin-1493947164-14939549573558540', 1, 0, '', NULL, NULL, NULL),
(28907, '2017-05-05 10:48:04', NULL, NULL, 8928, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 10:48:04', 'admin-1493947164-14939524839571477', 1, 1, 'SR', 1, NULL, NULL),
(28908, '2017-05-05 10:51:50', NULL, NULL, 8929, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1493947164', 'admin', '2017-05-05 10:51:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28909, '2017-05-05 10:52:00', NULL, NULL, 8929, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 10:52:00', 'admin-1493947164-14939527198222282', 1, 0, '', NULL, NULL, NULL),
(28910, '2017-05-05 10:52:00', NULL, NULL, 8929, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 10:52:00', 'admin-1493947164-14939527198222282', 1, 0, '', NULL, NULL, NULL),
(28911, '2017-05-05 11:05:36', NULL, NULL, 8930, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1493947164', 'admin', '2017-05-05 11:05:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28912, '2017-05-05 11:05:44', NULL, NULL, 8930, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 11:05:44', 'admin-1493947164-14939535439324150', 1, 1, 'SR', NULL, NULL, NULL),
(28913, '2017-05-05 11:05:44', NULL, NULL, 8930, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 11:05:44', 'admin-1493947164-14939535439324150', 1, 1, 'SR', NULL, NULL, NULL),
(28914, '2017-05-05 11:18:53', NULL, NULL, 8931, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1493947164', 'admin', '2017-05-05 11:18:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28915, '2017-05-05 11:19:08', NULL, NULL, 8931, 0, 280, '214', 'Diet Meal - Piccolo / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 11:19:08', 'admin-1493947164-14939543482764037', 1, 0, '', NULL, NULL, NULL),
(28916, '2017-05-05 12:37:15', NULL, NULL, 8936, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1493947164', 'admin', '2017-05-05 12:37:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28917, '2017-05-05 12:37:20', NULL, NULL, 8936, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 12:37:20', 'admin-1493947164-14939590400874390', 1, 0, '', NULL, NULL, NULL),
(28918, '2017-05-05 12:33:54', NULL, NULL, 8935, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 12:33:54', 'admin-1493947164-14939588340626587', 1, 0, '', NULL, NULL, NULL),
(28919, '2017-05-05 12:33:45', NULL, NULL, 8935, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1493947164', 'admin', '2017-05-05 12:33:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28920, '2017-05-05 12:33:54', NULL, NULL, 8935, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 12:33:54', 'admin-1493947164-14939588340626587', 1, 1, 'SR', NULL, NULL, NULL),
(28921, '2017-05-05 12:22:14', NULL, NULL, 8934, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 12:22:14', 'admin-1493947164-14939581344342314', 1, 0, '', 1, NULL, NULL),
(28922, '2017-05-05 09:19:41', NULL, NULL, 8922, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 09:19:41', 'admin-1493947164-14939471816249138', 1, 1, 'SR', NULL, NULL, NULL),
(28923, '2017-05-05 09:22:58', NULL, NULL, 8922, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 09:22:58', 'admin-1493947164-14939473778361758', 1, 0, '', NULL, NULL, NULL),
(28924, '2017-05-05 10:37:02', NULL, NULL, 8926, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 10:37:02', 'admin-1493947164-14939518222453139', 1, 1, 'SR', NULL, NULL, NULL),
(28925, '2017-05-05 10:37:02', NULL, NULL, 8926, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 10:37:02', 'admin-1493947164-14939518222453139', 1, 1, 'SR', NULL, NULL, NULL),
(28926, '2017-05-05 10:37:02', NULL, NULL, 8926, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 10:37:02', 'admin-1493947164-14939518222453139', 1, 1, 'SR', NULL, NULL, NULL),
(28927, '2017-05-05 10:36:47', NULL, NULL, 8926, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1493947164', 'admin', '2017-05-05 10:36:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28928, '2017-05-05 09:19:31', NULL, NULL, 8922, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1493947164', 'admin', '2017-05-05 09:19:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28929, '2017-05-05 09:19:36', NULL, NULL, 8922, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1493947164', 'admin', '2017-05-05 09:19:36', 'admin-1493947164-149394717638258', 1, 0, '', NULL, NULL, NULL),
(28930, '2017-05-06 00:00:00', NULL, NULL, 8981, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:37:29', 'admin-1494041634-14940454496501210', 1, 1, 'SR', NULL, NULL, NULL),
(28931, '2017-05-06 00:00:00', NULL, NULL, 8982, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:37:29', 'admin-1494041634-14940454496501210', 1, 0, '', NULL, NULL, NULL),
(28932, '2017-05-06 16:15:17', NULL, NULL, 8983, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1494063967', 'admin', '2017-05-06 16:15:17', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(28933, '2017-05-06 16:15:20', NULL, NULL, 8983, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 16:15:20', 'admin-1494052450-14940585204157020', 1, 1, 'SR', NULL, NULL, '10.0'),
(28934, '2017-05-06 16:17:12', NULL, NULL, 8983, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 16:17:12', 'admin-1494052450-14940586318078717', 1, 0, '', NULL, NULL, '10.0'),
(28935, '2017-05-06 16:18:18', NULL, NULL, 8983, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 16:18:18', 'admin-1494052450-14940586981072660', 1, 1, 'SR', NULL, NULL, '10.0'),
(28936, '2017-05-06 13:33:16', NULL, NULL, 8971, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:33:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28937, '2017-05-06 13:33:42', NULL, NULL, 8971, 0, 79, '79', 'Summer Salad ', 'less cherry tomato', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:33:42', 'admin-1494047688-14940488218969474', 1, 1, 'SR', NULL, NULL, NULL),
(28938, '2017-05-06 13:35:58', NULL, NULL, 8972, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:35:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28939, '2017-05-06 13:36:11', NULL, NULL, 8972, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:36:11', 'admin-1494047688-14940489709904822', 1, 1, 'SR', NULL, NULL, NULL),
(28940, '2017-05-06 13:36:11', NULL, NULL, 8972, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:36:11', 'admin-1494047688-14940489709904822', 1, 0, '', NULL, NULL, NULL),
(28941, '2017-05-06 13:06:49', NULL, NULL, 8967, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:06:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28942, '2017-05-06 13:07:03', NULL, NULL, 8967, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:07:03', 'admin-1494046533-14940472228322969', 1, 0, '', NULL, NULL, NULL),
(28943, '2017-05-06 13:48:13', NULL, NULL, 8974, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:48:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28944, '2017-05-06 13:48:32', NULL, NULL, 8974, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:48:32', 'admin-1494048978-14940497122702564', 1, 0, '', NULL, NULL, NULL),
(28945, '2017-05-06 13:48:32', NULL, NULL, 8974, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:48:32', 'admin-1494048978-14940497122702564', 1, 0, '', NULL, NULL, NULL),
(28946, '2017-05-06 12:56:05', NULL, NULL, 8963, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:56:05', 'admin-1494046533-14940465651317789', 1, 1, 'SR', NULL, NULL, NULL),
(28947, '2017-05-06 12:56:05', NULL, NULL, 8963, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:56:05', 'admin-1494046533-14940465651317789', 1, 1, 'SR', NULL, NULL, NULL),
(28948, '2017-05-06 12:56:05', NULL, NULL, 8963, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:56:05', 'admin-1494046533-14940465651317789', 1, 1, 'SR', NULL, NULL, NULL),
(28949, '2017-05-06 12:56:24', NULL, NULL, 8964, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:56:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28950, '2017-05-06 12:56:38', NULL, NULL, 8964, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:56:38', 'admin-1494046533-14940465983911221', 1, 1, 'SR', NULL, NULL, NULL),
(28951, '2017-05-06 12:56:38', NULL, NULL, 8964, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:56:38', 'admin-1494046533-14940465983911221', 1, 1, 'SR', NULL, NULL, NULL),
(28952, '2017-05-06 12:56:38', NULL, NULL, 8964, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:56:38', 'admin-1494046533-14940465983911221', 1, 0, '', NULL, NULL, NULL),
(28953, '2017-05-06 14:07:17', NULL, NULL, 8970, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:07:17', 'admin-1494048978-14940508375728376', 1, 0, '', NULL, NULL, NULL),
(28954, '2017-05-06 14:15:12', NULL, NULL, 8976, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.90, 0.0000, 0.0000, 9.90, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:15:12', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(28955, '2017-05-06 14:15:15', NULL, NULL, 8976, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:15:15', 'admin-1494048978-14940513151351894', 1, 1, 'SR', NULL, NULL, NULL),
(28956, '2017-05-06 16:32:09', NULL, NULL, 8983, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 16:32:09', 'admin-1494052450-14940595291626914', 1, 1, 'SR', NULL, NULL, '10.0'),
(28957, '2017-05-06 16:32:18', NULL, NULL, 8984, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 16:32:18', 'admin-1494052450-14940595385487691', 1, 0, '', 1, NULL, NULL),
(28958, '2017-05-06 16:49:23', NULL, NULL, 8983, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 16:49:23', 'admin-1494052450-14940605629023690', 1, 0, '', NULL, NULL, '10.0'),
(28959, '2017-05-06 17:10:02', NULL, NULL, 8985, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 17:10:02', 'admin-1494052450-14940618017031680', 1, 1, 'SR', 1, NULL, NULL),
(28960, '2017-05-06 17:10:02', NULL, NULL, 8985, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 17:10:02', 'admin-1494052450-14940618017031680', 1, 1, 'SR', 1, NULL, NULL),
(28961, '2017-05-06 17:22:04', NULL, NULL, 8986, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1494063967', 'admin', '2017-05-06 17:22:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28962, '2017-05-06 17:22:09', NULL, NULL, 8986, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 17:22:09', 'admin-1494052450-14940625285687630', 1, 1, 'SR', NULL, NULL, NULL),
(28963, '2017-05-06 18:09:03', NULL, NULL, 8987, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1494063967', 'admin', '2017-05-06 18:09:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28964, '2017-05-06 18:09:10', NULL, NULL, 8987, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 18:09:10', 'admin-1494063967-14940653501082335', 1, 1, 'SR', NULL, NULL, NULL),
(28965, '2017-05-06 18:09:10', NULL, NULL, 8987, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 18:09:10', 'admin-1494063967-14940653501082335', 1, 0, '', NULL, NULL, NULL),
(28966, '2017-05-06 15:13:10', NULL, NULL, 8980, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 15:13:10', 'admin-1494052450-14940547905118330', 1, 1, 'SR', NULL, NULL, NULL),
(28967, '2017-05-06 15:13:10', NULL, NULL, 8980, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 15:13:10', 'admin-1494052450-14940547905118330', 1, 0, '', NULL, NULL, NULL),
(28968, '2017-05-06 14:26:41', NULL, NULL, 8978, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:26:41', 'admin-1494048978-14940520009039822', 1, 1, 'SR', NULL, NULL, NULL),
(28969, '2017-05-06 14:27:46', NULL, NULL, 8974, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:27:46', 'admin-1494048978-14940520662727593', 1, 1, 'SR', NULL, NULL, NULL),
(28970, '2017-05-06 14:34:05', NULL, NULL, 8979, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:34:05', 'admin-1494048978-14940524451013090', 1, 0, '', NULL, NULL, NULL),
(28971, '2017-05-06 14:34:05', NULL, NULL, 8979, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:34:05', 'admin-1494048978-14940524451013090', 1, 1, 'SR', NULL, NULL, NULL),
(28972, '2017-05-06 14:34:05', NULL, NULL, 8979, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:34:05', 'admin-1494048978-14940524451013090', 1, 1, 'SR', NULL, NULL, NULL),
(28973, '2017-05-06 14:34:05', NULL, NULL, 8979, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:34:05', 'admin-1494048978-14940524451013090', 1, 1, 'SR', NULL, NULL, NULL),
(28974, '2017-05-06 14:43:00', NULL, NULL, 8979, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:43:00', 'admin-1494052450-1494052980694726', 1, 1, 'SR', NULL, NULL, NULL),
(28975, '2017-05-06 14:46:19', NULL, NULL, 8976, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:46:19', 'admin-1494052450-1494053179575481', 1, 1, 'SR', NULL, NULL, NULL),
(28976, '2017-05-06 14:46:19', NULL, NULL, 8976, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:46:19', 'admin-1494052450-1494053179575481', 1, 1, 'SR', NULL, NULL, NULL),
(28977, '2017-05-06 14:46:31', NULL, NULL, 8976, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:46:31', 'admin-1494052450-14940531913893019', 1, 1, 'SR', NULL, NULL, NULL),
(28978, '2017-05-06 00:00:00', NULL, NULL, 8982, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:37:29', 'admin-1494041634-14940454496501210', 1, 0, '', NULL, NULL, NULL),
(28979, '2017-05-06 00:00:00', NULL, NULL, 8981, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:42:02', 'admin-1494041634-14940457224253273', 1, 0, '', NULL, NULL, NULL),
(28980, '2017-05-06 00:00:00', NULL, NULL, 8982, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, NULL, NULL, 2.60, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:36:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28981, '2017-05-06 13:48:32', NULL, NULL, 8974, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:48:32', 'admin-1494048978-14940497122702564', 1, 1, 'SR', NULL, NULL, NULL),
(28982, '2017-05-06 13:48:32', NULL, NULL, 8974, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:48:32', 'admin-1494048978-14940497122702564', 1, 1, 'SR', NULL, NULL, NULL),
(28983, '2017-05-06 14:26:27', NULL, NULL, 8978, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:26:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28984, '2017-05-06 13:54:04', NULL, NULL, 8975, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:54:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28985, '2017-05-06 13:54:09', NULL, NULL, 8975, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:54:09', 'admin-1494048978-14940500494915533', 1, 1, 'SR', NULL, NULL, NULL),
(28986, '2017-05-06 13:54:09', NULL, NULL, 8975, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:54:09', 'admin-1494048978-14940500494915533', 1, 0, '', NULL, NULL, NULL),
(28987, '2017-05-06 14:34:05', NULL, NULL, 8979, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:34:05', 'admin-1494048978-14940524451013090', 1, 0, '', NULL, NULL, NULL),
(28988, '2017-05-06 13:18:09', NULL, NULL, 8969, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:18:09', 'admin-1494047688-14940478888784146', 1, 0, '', NULL, NULL, NULL),
(28989, '2017-05-06 13:21:53', NULL, NULL, 8970, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.00, 0.0000, 0.0000, 10.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:21:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28990, '2017-05-06 13:22:07', NULL, NULL, 8970, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:22:07', 'admin-1494047688-14940481269826814', 1, 0, '', NULL, NULL, NULL),
(28991, '2017-05-06 14:16:33', NULL, NULL, 8976, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:16:33', 'admin-1494048978-14940513936326568', 1, 1, 'SR', NULL, NULL, NULL),
(28992, '2017-05-06 12:28:05', NULL, NULL, 8959, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:28:05', 'admin-1494041634-1494044884933209', 1, 0, '', NULL, NULL, NULL),
(28993, '2017-05-06 12:19:04', NULL, NULL, 8958, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:19:04', 'admin-1494041634-1494044344625966', 1, 0, '', NULL, NULL, NULL),
(28994, '2017-05-06 12:27:56', NULL, NULL, 8959, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:27:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(28995, '2017-05-06 12:28:05', NULL, NULL, 8959, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:28:05', 'admin-1494041634-1494044884933209', 1, 1, 'SR', NULL, NULL, NULL),
(28996, '2017-05-06 12:28:05', NULL, NULL, 8959, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:28:05', 'admin-1494041634-1494044884933209', 1, 1, 'SR', NULL, NULL, NULL),
(28997, '2017-05-06 16:32:09', NULL, NULL, 8983, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 16:32:09', 'admin-1494052450-14940595291626914', 1, 0, '', NULL, NULL, '10.0'),
(28998, '2017-05-06 16:31:48', NULL, NULL, 8983, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 16:31:48', 'admin-1494052450-14940595085962082', 1, 1, 'SR', NULL, NULL, '10.0'),
(28999, '2017-05-06 15:16:26', NULL, NULL, 8973, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 15:16:26', 'admin-1494052450-14940549863196992', 1, 1, 'SR', NULL, NULL, NULL),
(29000, '2017-05-06 15:14:11', NULL, NULL, 8980, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 15:14:11', 'admin-1494052450-14940548509638042', 1, 1, 'SR', NULL, NULL, NULL),
(29001, '2017-05-06 13:13:58', NULL, NULL, 8968, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:13:58', 'admin-1494046533-14940476385879649', 1, 0, '', NULL, NULL, NULL),
(29002, '2017-05-06 13:13:58', NULL, NULL, 8968, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:13:58', 'admin-1494046533-14940476385879649', 1, 0, '', NULL, NULL, NULL),
(29003, '2017-05-06 13:13:58', NULL, NULL, 8968, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:13:58', 'admin-1494046533-14940476385879649', 1, 1, 'SR', NULL, NULL, NULL),
(29004, '2017-05-06 13:16:56', NULL, NULL, 8968, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:16:56', 'admin-1494047688-14940478164676685', 1, 0, '', NULL, NULL, NULL),
(29005, '2017-05-06 13:16:56', NULL, NULL, 8968, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:16:56', 'admin-1494047688-14940478164676685', 1, 1, 'SR', NULL, NULL, NULL),
(29006, '2017-05-06 13:17:03', NULL, NULL, 8969, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:17:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29007, '2017-05-06 13:17:20', NULL, NULL, 8969, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:17:20', 'admin-1494047688-14940478399302888', 1, 1, 'SR', NULL, NULL, NULL),
(29008, '2017-05-06 13:17:20', NULL, NULL, 8969, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:17:20', 'admin-1494047688-14940478399302888', 1, 1, 'SR', NULL, NULL, NULL),
(29009, '2017-05-06 12:29:51', NULL, NULL, 8960, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 3, 8.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:29:51', 'admin-1494041634-1494044991159461', 1, 0, '', NULL, NULL, NULL),
(29010, '2017-05-06 12:29:44', NULL, NULL, 8960, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:29:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29011, '2017-05-06 12:28:33', NULL, NULL, 8957, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:28:33', 'admin-1494041634-1494044913681539', 1, 1, 'SR', NULL, NULL, NULL),
(29012, '2017-05-06 11:21:20', NULL, NULL, 8953, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:21:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29013, '2017-05-06 11:22:14', NULL, NULL, 8953, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:22:14', 'admin-1494030508-14940409346914398', 1, 0, '', NULL, NULL, NULL),
(29014, '2017-05-06 11:22:14', NULL, NULL, 8953, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:22:14', 'admin-1494030508-14940409346914398', 1, 0, '', NULL, NULL, NULL),
(29015, '2017-05-06 13:17:20', NULL, NULL, 8969, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:17:20', 'admin-1494047688-14940478399302888', 1, 0, '', NULL, NULL, NULL),
(29016, '2017-05-06 13:00:21', NULL, NULL, 8966, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:00:21', 'admin-1494046533-14940468212113314', 1, 1, 'SR', NULL, NULL, NULL),
(29017, '2017-05-06 15:13:02', NULL, NULL, 8980, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1494063967', 'admin', '2017-05-06 15:13:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29018, '2017-05-06 14:26:41', NULL, NULL, 8978, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:26:41', 'admin-1494048978-14940520009039822', 1, 1, 'SR', NULL, NULL, NULL),
(29019, '2017-05-06 14:33:48', NULL, NULL, 8979, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:33:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29020, '2017-05-06 13:54:42', NULL, NULL, 8975, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:54:42', 'admin-1494048978-14940500821047826', 1, 0, '', NULL, NULL, NULL),
(29021, '2017-05-06 14:26:31', NULL, NULL, 8978, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:26:31', 'admin-1494048978-14940519909724630', 1, 0, '', NULL, NULL, NULL),
(29022, '2017-05-06 14:22:17', NULL, NULL, 8976, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:22:17', 'admin-1494048978-14940517372282425', 1, 0, '', NULL, NULL, NULL),
(29023, '2017-05-06 14:24:07', NULL, NULL, 8977, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:24:07', 'admin-1494048978-14940518475756794', 1, 0, '', 1, NULL, NULL),
(29024, '2017-05-06 14:16:33', NULL, NULL, 8976, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:16:33', 'admin-1494048978-14940513936326568', 1, 0, '', NULL, NULL, NULL),
(29025, '2017-05-06 14:03:15', NULL, NULL, 8975, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 14:03:15', 'admin-1494048978-14940505958041696', 1, 0, '', NULL, NULL, NULL),
(29026, '2017-05-06 13:37:42', NULL, NULL, 8973, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:37:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29027, '2017-05-06 13:37:50', NULL, NULL, 8973, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:37:50', 'admin-1494048978-1494049070324711', 1, 1, 'SR', NULL, NULL, NULL),
(29028, '2017-05-06 13:22:07', NULL, NULL, 8970, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:22:07', 'admin-1494047688-14940481269826814', 1, 0, '', NULL, NULL, NULL),
(29029, '2017-05-06 13:22:07', NULL, NULL, 8970, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:22:07', 'admin-1494047688-14940481269826814', 1, 0, '', NULL, NULL, NULL),
(29030, '2017-05-06 13:22:07', NULL, NULL, 8970, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:22:07', 'admin-1494047688-14940481269826814', 1, 0, '', NULL, NULL, NULL),
(29031, '2017-05-06 13:22:07', NULL, NULL, 8970, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:22:07', 'admin-1494047688-14940481269826814', 1, 0, '', NULL, NULL, NULL),
(29032, '2017-05-06 13:17:20', NULL, NULL, 8969, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:17:20', 'admin-1494047688-14940478399302888', 1, 0, '', NULL, NULL, NULL),
(29033, '2017-05-06 12:16:53', NULL, NULL, 8957, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:16:53', 'admin-1494041634-14940442130433556', 1, 0, '', NULL, NULL, NULL),
(29034, '2017-05-06 12:16:53', NULL, NULL, 8957, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:16:53', 'admin-1494041634-14940442130433556', 1, 1, 'SR', NULL, NULL, NULL),
(29035, '2017-05-06 11:26:24', NULL, NULL, 8954, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:26:24', 'admin-1494030508-14940411844079920', 1, 0, '', NULL, NULL, NULL),
(29036, '2017-05-06 11:26:24', NULL, NULL, 8954, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:26:24', 'admin-1494030508-14940411844079920', 1, 0, '', NULL, NULL, NULL),
(29037, '2017-05-06 11:32:50', NULL, NULL, 8955, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:32:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29038, '2017-05-06 11:33:43', NULL, NULL, 8955, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:33:43', 'admin-1494030508-14940416231352016', 1, 1, 'SR', NULL, NULL, NULL),
(29039, '2017-05-06 12:19:04', NULL, NULL, 8958, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:19:04', 'admin-1494041634-1494044344625966', 1, 0, '', NULL, NULL, NULL),
(29040, '2017-05-06 12:19:04', NULL, NULL, 8958, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:19:04', 'admin-1494041634-1494044344625966', 1, 0, '', NULL, NULL, NULL),
(29041, '2017-05-06 12:18:52', NULL, NULL, 8958, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:18:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29042, '2017-05-06 12:17:11', NULL, NULL, 8954, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:17:11', 'admin-1494041634-14940442314975994', 1, 1, 'SR', NULL, NULL, NULL),
(29043, '2017-05-06 13:13:33', NULL, NULL, 8968, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:13:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29044, '2017-05-06 13:10:40', NULL, NULL, 8967, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:10:40', 'admin-1494046533-14940474404596098', 1, 1, 'SR', NULL, NULL, NULL),
(29045, '2017-05-06 13:00:21', NULL, NULL, 8966, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:00:21', 'admin-1494046533-14940468212113314', 1, 0, '', NULL, NULL, NULL),
(29046, '2017-05-06 13:00:13', NULL, NULL, 8966, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:00:13', 'admin-1494046533-14940468131314758', 1, 0, '', NULL, NULL, NULL),
(29047, '2017-05-06 13:00:06', NULL, NULL, 8966, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:00:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29048, '2017-05-06 13:00:13', NULL, NULL, 8966, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 13:00:13', 'admin-1494046533-14940468131314758', 1, 1, 'SR', NULL, NULL, NULL),
(29049, '2017-05-06 12:56:50', NULL, NULL, 8965, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:56:50', 'admin-1494046533-14940466098421040', 1, 0, '', NULL, NULL, NULL),
(29050, '2017-05-06 12:56:42', NULL, NULL, 8965, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:56:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29051, '2017-05-06 12:56:50', NULL, NULL, 8965, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:56:50', 'admin-1494046533-14940466098421040', 1, 0, '', NULL, NULL, NULL),
(29052, '2017-05-06 12:16:53', NULL, NULL, 8957, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:16:53', 'admin-1494041634-14940442130433556', 1, 0, '', NULL, NULL, NULL),
(29053, '2017-05-06 12:16:09', NULL, NULL, 8957, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:16:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29054, '2017-05-06 11:33:43', NULL, NULL, 8955, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:33:43', 'admin-1494030508-14940416231352016', 1, 1, 'SR', NULL, NULL, NULL),
(29055, '2017-05-06 12:56:05', NULL, NULL, 8963, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:56:05', 'admin-1494046533-14940465651317789', 1, 0, '', NULL, NULL, NULL),
(29056, '2017-05-06 12:46:03', NULL, NULL, 8962, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:46:03', 'admin-1494041634-14940459634256410', 1, 0, '', 1, NULL, NULL),
(29057, '2017-05-06 12:50:48', NULL, NULL, 8958, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:50:48', 'admin-1494041634-1494046248300338', 1, 1, 'SR', NULL, NULL, NULL),
(29058, '2017-05-06 12:50:48', NULL, NULL, 8958, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:50:48', 'admin-1494041634-1494046248300338', 1, 1, 'SR', NULL, NULL, NULL),
(29059, '2017-05-06 12:55:41', NULL, NULL, 8963, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:55:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29060, '2017-05-06 15:25:35', NULL, NULL, 8981, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1494063967', 'admin', '2017-05-06 15:25:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29061, '2017-05-06 12:46:03', NULL, NULL, 8962, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 12:46:03', 'admin-1494041634-14940459634256410', 1, 0, '', 1, NULL, NULL),
(29062, '2017-05-06 11:36:11', NULL, NULL, 8956, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:36:11', 'admin-1494041634-14940417709449886', 1, 0, '', NULL, NULL, NULL),
(29063, '2017-05-06 11:42:55', NULL, NULL, 8954, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:42:55', 'admin-1494041634-14940421755441718', 1, 0, '', NULL, NULL, NULL),
(29064, '2017-05-06 11:36:11', NULL, NULL, 8956, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:36:11', 'admin-1494041634-14940417709449886', 1, 0, '', NULL, NULL, NULL),
(29065, '2017-05-06 11:35:56', NULL, NULL, 8956, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:35:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29066, '2017-05-06 11:33:43', NULL, NULL, 8955, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:33:43', 'admin-1494030508-14940416231352016', 1, 0, '', NULL, NULL, NULL),
(29067, '2017-05-06 11:33:43', NULL, NULL, 8955, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:33:43', 'admin-1494030508-14940416231352016', 1, 1, 'SR', NULL, NULL, NULL),
(29068, '2017-05-06 11:33:43', NULL, NULL, 8955, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:33:43', 'admin-1494030508-14940416231352016', 1, 1, 'SR', NULL, NULL, NULL),
(29069, '2017-05-06 11:26:24', NULL, NULL, 8954, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:26:24', 'admin-1494030508-14940411844079920', 1, 1, 'SR', NULL, NULL, NULL),
(29070, '2017-05-06 10:39:18', NULL, NULL, 8950, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1494063967', 'admin', '2017-05-06 10:39:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29071, '2017-05-06 09:21:27', NULL, NULL, 8945, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 09:21:27', 'admin-1494030508-149403368762355', 1, 0, '', NULL, NULL, NULL),
(29072, '2017-05-06 09:21:27', NULL, NULL, 8945, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 09:21:27', 'admin-1494030508-149403368762355', 1, 1, 'SR', NULL, NULL, NULL),
(29073, '2017-05-06 09:21:27', NULL, NULL, 8945, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 09:21:27', 'admin-1494030508-149403368762355', 1, 1, 'SR', NULL, NULL, NULL),
(29074, '2017-05-06 09:24:22', NULL, NULL, 8946, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1494063967', 'admin', '2017-05-06 09:24:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29075, '2017-05-06 09:24:58', NULL, NULL, 8946, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 09:24:58', 'admin-1494030508-14940338982276238', 1, 0, '', NULL, NULL, NULL),
(29076, '2017-05-06 09:24:58', NULL, NULL, 8946, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 09:24:58', 'admin-1494030508-14940338982276238', 1, 1, 'SR', NULL, NULL, NULL),
(29077, '2017-05-06 09:24:58', NULL, NULL, 8946, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 09:24:58', 'admin-1494030508-14940338982276238', 1, 0, '', NULL, NULL, NULL),
(29078, '2017-05-06 09:24:58', NULL, NULL, 8946, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 09:24:58', 'admin-1494030508-14940338982276238', 1, 0, '', NULL, NULL, NULL),
(29079, '2017-05-06 09:26:19', NULL, NULL, 8947, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1494063967', 'admin', '2017-05-06 09:26:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29080, '2017-05-06 09:26:50', NULL, NULL, 8947, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 09:26:50', 'admin-1494030508-14940340106628137', 1, 0, '', NULL, NULL, NULL),
(29081, '2017-05-06 09:26:50', NULL, NULL, 8947, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 09:26:50', 'admin-1494030508-14940340106628137', 1, 0, '', NULL, NULL, NULL),
(29082, '2017-05-06 09:26:50', NULL, NULL, 8947, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 09:26:50', 'admin-1494030508-14940340106628137', 1, 1, 'SR', NULL, NULL, NULL),
(29083, '2017-05-06 09:26:50', NULL, NULL, 8947, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 09:26:50', 'admin-1494030508-14940340106628137', 1, 1, 'SR', NULL, NULL, NULL),
(29084, '2017-05-06 09:39:47', NULL, NULL, 8948, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 09:39:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29085, '2017-05-06 09:39:55', NULL, NULL, 8948, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 09:39:55', 'admin-1494030508-1494034795808260', 1, 0, '', NULL, NULL, NULL),
(29086, '2017-05-06 09:40:40', NULL, NULL, 8948, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 09:40:40', 'admin-1494030508-14940348406696836', 1, 1, 'SR', NULL, NULL, NULL),
(29087, '2017-05-06 09:59:17', NULL, NULL, 8948, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 09:59:17', 'admin-1494030508-14940359571437290', 1, 1, 'SR', NULL, NULL, NULL),
(29088, '2017-05-06 10:05:39', NULL, NULL, 8949, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1494063967', 'admin', '2017-05-06 10:05:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29089, '2017-05-06 10:05:46', NULL, NULL, 8949, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 10:05:46', 'admin-1494030508-1494036346401767', 1, 0, '', NULL, NULL, NULL),
(29090, '2017-05-06 10:05:46', NULL, NULL, 8949, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 10:05:46', 'admin-1494030508-1494036346401767', 1, 0, '', NULL, NULL, NULL),
(29091, '2017-05-06 10:06:02', NULL, NULL, 8949, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 10:06:02', 'admin-1494030508-14940363624738293', 1, 0, '', NULL, NULL, NULL),
(29092, '2017-05-06 10:06:02', NULL, NULL, 8949, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 10:06:02', 'admin-1494030508-14940363624738293', 1, 0, '', NULL, NULL, NULL),
(29093, '2017-05-06 10:39:33', NULL, NULL, 8950, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 10:39:33', 'admin-1494030508-14940383736928515', 1, 0, '', NULL, NULL, NULL),
(29094, '2017-05-06 10:39:33', NULL, NULL, 8950, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 10:39:33', 'admin-1494030508-14940383736928515', 1, 0, '', NULL, NULL, NULL),
(29095, '2017-05-06 10:40:05', NULL, NULL, 8951, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1494063967', 'admin', '2017-05-06 10:40:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29096, '2017-05-06 11:26:24', NULL, NULL, 8954, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:26:24', 'admin-1494030508-14940411844079920', 1, 0, '', NULL, NULL, NULL),
(29097, '2017-05-06 11:26:00', NULL, NULL, 8954, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.10, 0.0000, 0.0000, 11.10, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:26:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29098, '2017-05-06 11:26:24', NULL, NULL, 8954, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:26:24', 'admin-1494030508-14940411844079920', 1, 0, '', NULL, NULL, NULL),
(29099, '2017-05-06 11:22:14', NULL, NULL, 8953, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:22:14', 'admin-1494030508-14940409346914398', 1, 1, 'SR', NULL, NULL, NULL),
(29100, '2017-05-06 11:22:15', NULL, NULL, 8953, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:22:15', 'admin-1494030508-14940409346914398', 1, 1, 'SR', NULL, NULL, NULL),
(29101, '2017-05-06 11:09:09', NULL, NULL, 8952, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:09:09', 'admin-1494030508-14940401490893024', 1, 0, '', NULL, NULL, NULL),
(29102, '2017-05-06 11:09:16', NULL, NULL, 8952, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:09:16', 'admin-1494030508-14940401559967468', 1, 1, 'SR', NULL, NULL, NULL),
(29103, '2017-05-06 11:09:09', NULL, NULL, 8952, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:09:09', 'admin-1494030508-14940401490893024', 1, 0, '', NULL, NULL, NULL),
(29104, '2017-05-06 11:09:01', NULL, NULL, 8952, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 11:09:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29105, '2017-05-06 10:40:18', NULL, NULL, 8951, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 10:40:18', 'admin-1494030508-14940384178696031', 1, 1, 'SR', NULL, NULL, NULL),
(29106, '2017-05-06 10:48:41', NULL, NULL, 8950, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 10:48:41', 'admin-1494030508-14940389210828514', 1, 1, 'SR', NULL, NULL, NULL),
(29107, '2017-05-06 10:48:41', NULL, NULL, 8950, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 10:48:41', 'admin-1494030508-14940389210828514', 1, 0, '', NULL, NULL, NULL),
(29108, '2017-05-06 10:40:18', NULL, NULL, 8951, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 10:40:18', 'admin-1494030508-14940384178696031', 1, 1, 'SR', NULL, NULL, NULL),
(29109, '2017-05-06 09:20:58', NULL, NULL, 8945, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1494063967', 'admin', '2017-05-06 09:20:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29110, '2017-05-06 09:21:27', NULL, NULL, 8945, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494063967', 'admin', '2017-05-06 09:21:27', 'admin-1494030508-149403368762355', 1, 0, '', NULL, NULL, NULL),
(29111, '2017-05-07 14:17:10', NULL, NULL, 9019, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:17:10', 'admin-1494137499-14941378301355891', 1, 1, 'SR', NULL, NULL, NULL),
(29112, '2017-05-07 14:17:10', NULL, NULL, 9019, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:17:10', 'admin-1494137499-14941378301355891', 1, 1, 'SR', NULL, NULL, NULL),
(29113, '2017-05-07 11:45:16', NULL, NULL, 9001, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 11:45:16', 'admin-1494123938-14941287159315393', 1, 0, '', NULL, NULL, NULL),
(29114, '2017-05-07 11:57:08', NULL, NULL, 9002, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1494137946', 'admin', '2017-05-07 11:57:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29115, '2017-05-07 11:57:17', NULL, NULL, 9002, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 11:57:17', 'admin-1494123938-14941294375967258', 1, 1, 'SR', NULL, NULL, NULL),
(29116, '2017-05-07 12:03:36', NULL, NULL, 9003, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:03:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29117, '2017-05-07 12:03:49', NULL, NULL, 9003, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:03:49', 'admin-1494123938-14941298291112846', 1, 0, '', NULL, NULL, NULL),
(29118, '2017-05-07 12:03:49', NULL, NULL, 9003, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:03:49', 'admin-1494123938-14941298291112846', 1, 1, 'SR', NULL, NULL, NULL),
(29119, '2017-05-07 12:04:40', NULL, NULL, 8999, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:04:40', 'admin-1494123938-14941298805786569', 1, 1, 'SR', NULL, NULL, NULL),
(29120, '2017-05-07 12:11:12', NULL, NULL, 9004, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:11:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29121, '2017-05-07 12:12:10', NULL, NULL, 9004, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:12:10', 'admin-1494123938-14941303303997291', 1, 0, '', NULL, NULL, NULL),
(29122, '2017-05-07 12:12:10', NULL, NULL, 9004, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:12:10', 'admin-1494123938-14941303303997291', 1, 1, 'SR', NULL, NULL, NULL),
(29123, '2017-05-07 13:02:25', NULL, NULL, 9008, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:02:25', 'admin-1494123938-14941333452395821', 1, 1, 'SR', NULL, NULL, NULL),
(29124, '2017-05-07 13:13:11', NULL, NULL, 9009, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:13:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29125, '2017-05-07 13:13:18', NULL, NULL, 9009, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:13:18', 'admin-1494123938-14941339981059726', 1, 1, 'SR', NULL, NULL, NULL),
(29126, '2017-05-07 13:13:18', NULL, NULL, 9009, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:13:18', 'admin-1494123938-14941339981059726', 1, 1, 'SR', NULL, NULL, NULL),
(29127, '2017-05-07 13:15:32', NULL, NULL, 9010, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:15:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29128, '2017-05-07 13:16:13', NULL, NULL, 9010, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:16:13', 'admin-1494123938-14941341732498628', 1, 0, '', NULL, NULL, NULL),
(29129, '2017-05-07 13:16:13', NULL, NULL, 9010, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:16:13', 'admin-1494123938-14941341732498628', 1, 1, 'SR', NULL, NULL, NULL),
(29130, '2017-05-07 13:16:13', NULL, NULL, 9010, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:16:13', 'admin-1494123938-14941341732498628', 1, 1, 'SR', NULL, NULL, NULL),
(29131, '2017-05-07 13:16:19', NULL, NULL, 9011, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:16:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29132, '2017-05-07 13:16:39', NULL, NULL, 9011, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:16:39', 'admin-1494123938-14941341994856428', 1, 0, '', NULL, NULL, NULL),
(29133, '2017-05-07 13:16:39', NULL, NULL, 9011, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:16:39', 'admin-1494123938-14941341994856428', 1, 0, '', NULL, NULL, NULL),
(29134, '2017-05-07 13:55:16', NULL, NULL, 9016, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:55:16', 'admin-1494134862-14941365163348174', 1, 1, 'SR', NULL, NULL, NULL),
(29135, '2017-05-07 13:55:16', NULL, NULL, 9016, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:55:16', 'admin-1494134862-14941365163348174', 1, 0, '', NULL, NULL, NULL),
(29136, '2017-05-07 13:55:16', NULL, NULL, 9016, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:55:16', 'admin-1494134862-14941365163348174', 1, 0, '', NULL, NULL, NULL),
(29137, '2017-05-07 15:51:14', NULL, NULL, 9025, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1494137946', 'admin', '2017-05-07 15:51:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29138, '2017-05-07 14:18:28', NULL, NULL, 9020, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:18:28', 'admin-1494137499-14941379083206231', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(29139, '2017-05-07 14:18:41', NULL, NULL, 9020, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:18:41', 'admin-1494137499-14941379211082660', 1, 0, '', NULL, NULL, NULL),
(29140, '2017-05-07 14:18:58', NULL, NULL, 9020, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:18:58', 'admin-1494137499-1494137938335484', 1, 0, '', NULL, NULL, NULL),
(29141, '2017-05-07 15:42:10', NULL, NULL, 9024, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 15:42:10', 'admin-1494137946-14941429301942378', 1, 0, '', NULL, NULL, NULL),
(29142, '2017-05-07 14:20:02', NULL, NULL, 9020, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:20:02', 'admin-1494137946-14941380026958379', 1, 0, '', NULL, NULL, NULL),
(29143, '2017-05-07 14:25:44', NULL, NULL, 9021, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:25:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29144, '2017-05-07 14:26:21', NULL, NULL, 9021, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:26:21', 'admin-1494137946-14941383810409396', 1, 1, 'SR', NULL, NULL, NULL),
(29145, '2017-05-07 14:26:21', NULL, NULL, 9021, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:26:21', 'admin-1494137946-14941383810409396', 1, 1, 'SR', NULL, NULL, NULL),
(29146, '2017-05-07 15:29:48', NULL, NULL, 9020, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 15:29:48', 'admin-1494137946-14941421879082375', 1, 1, 'SR', NULL, NULL, NULL),
(29147, '2017-05-07 14:31:47', NULL, NULL, 9020, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:31:47', 'admin-1494137946-14941387072826621', 1, 1, 'SR', NULL, NULL, NULL),
(29148, '2017-05-07 14:32:16', NULL, NULL, 9020, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:32:16', 'admin-1494137946-14941387366236973', 1, 1, 'SR', NULL, NULL, NULL),
(29149, '2017-05-07 14:32:16', NULL, NULL, 9020, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:32:16', 'admin-1494137946-14941387366236973', 1, 1, 'SR', NULL, NULL, NULL),
(29150, '2017-05-07 14:32:16', NULL, NULL, 9020, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:32:16', 'admin-1494137946-14941387366236973', 1, 0, '', NULL, NULL, NULL),
(29151, '2017-05-07 13:56:15', NULL, NULL, 9016, 0, 181, '116', 'Open Food ', 'Genius In the bowl softer', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:56:15', 'admin-1494134862-1494136574759766', 1, 0, '', NULL, NULL, NULL),
(29152, '2017-05-07 14:11:10', NULL, NULL, 9017, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:11:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29153, '2017-05-07 14:11:34', NULL, NULL, 9017, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:11:34', 'admin-1494134862-14941374941513995', 1, 0, '', NULL, NULL, NULL),
(29154, '2017-05-07 14:11:34', NULL, NULL, 9017, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:11:34', 'admin-1494134862-14941374941513995', 1, 0, '', NULL, NULL, NULL),
(29155, '2017-05-07 14:11:34', NULL, NULL, 9017, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:11:34', 'admin-1494134862-14941374941513995', 1, 1, 'SR', NULL, NULL, NULL),
(29156, '2017-05-07 14:11:55', NULL, NULL, 9017, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:11:55', 'admin-1494137499-14941375148338152', 1, 0, '', NULL, NULL, NULL),
(29157, '2017-05-07 14:11:55', NULL, NULL, 9017, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:11:55', 'admin-1494137499-14941375148338152', 1, 1, 'SR', NULL, NULL, NULL),
(29158, '2017-05-07 15:09:28', NULL, NULL, 9023, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1494137946', 'admin', '2017-05-07 15:09:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29159, '2017-05-07 15:09:39', NULL, NULL, 9023, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 15:09:39', 'admin-1494137946-14941409798048383', 1, 1, 'SR', NULL, NULL, NULL),
(29160, '2017-05-07 15:29:48', NULL, NULL, 9020, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 15:29:48', 'admin-1494137946-14941421879082375', 1, 1, 'SR', NULL, NULL, NULL),
(29161, '2017-05-07 15:29:48', NULL, NULL, 9020, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 15:29:48', 'admin-1494137946-14941421879082375', 1, 1, 'SR', NULL, NULL, NULL),
(29162, '2017-05-07 15:51:29', NULL, NULL, 9025, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 15:51:29', 'admin-1494137946-14941434890457446', 1, 1, 'SR', NULL, NULL, NULL),
(29163, '2017-05-07 15:58:43', NULL, NULL, 9026, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1494137946', 'admin', '2017-05-07 15:58:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29164, '2017-05-07 15:58:51', NULL, NULL, 9026, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 15:58:51', 'admin-1494137946-1494143930900897', 1, 1, 'SR', NULL, NULL, NULL),
(29165, '2017-05-07 16:16:04', NULL, NULL, 9027, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1494137946', 'admin', '2017-05-07 16:16:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29166, '2017-05-07 12:12:10', NULL, NULL, 9004, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:12:10', 'admin-1494123938-14941303303997291', 1, 0, '', NULL, NULL, NULL),
(29167, '2017-05-07 12:12:10', NULL, NULL, 9004, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:12:10', 'admin-1494123938-14941303303997291', 1, 0, '', NULL, NULL, NULL),
(29168, '2017-05-07 12:12:10', NULL, NULL, 9004, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:12:10', 'admin-1494123938-14941303303997291', 1, 0, '', NULL, NULL, NULL),
(29169, '2017-05-07 14:16:29', NULL, NULL, 9016, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:16:29', 'admin-1494137499-14941377893081595', 1, 1, 'SR', NULL, NULL, NULL),
(29170, '2017-05-07 16:16:52', NULL, NULL, 9027, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 16:16:52', 'admin-1494137946-1494145012785270', 1, 0, '', NULL, NULL, NULL),
(29171, '2017-05-07 16:17:17', NULL, NULL, 9027, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 16:17:17', 'admin-1494137946-14941450376046784', 1, 1, 'SR', NULL, NULL, NULL),
(29172, '2017-05-07 16:18:00', NULL, NULL, 9025, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 16:18:00', 'admin-1494137946-14941450808045136', 1, 1, 'SR', NULL, NULL, NULL),
(29173, '2017-05-07 12:14:27', NULL, NULL, 9005, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:14:27', 'admin-1494123938-14941304672209797', 1, 1, 'SR', NULL, NULL, NULL),
(29174, '2017-05-07 12:14:27', NULL, NULL, 9005, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:14:27', 'admin-1494123938-14941304672209797', 1, 1, 'SR', NULL, NULL, NULL),
(29175, '2017-05-07 12:18:24', NULL, NULL, 9006, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:18:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29176, '2017-05-07 12:18:39', NULL, NULL, 9006, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:18:39', 'admin-1494123938-14941307190644637', 1, 0, '', NULL, NULL, NULL),
(29177, '2017-05-07 14:11:34', NULL, NULL, 9017, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:11:34', 'admin-1494134862-14941374941513995', 1, 0, '', NULL, NULL, NULL),
(29178, '2017-05-07 13:36:47', NULL, NULL, 9007, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:36:47', 'admin-1494134862-14941354076654558', 1, 1, 'SR', NULL, NULL, NULL),
(29179, '2017-05-07 13:44:23', NULL, NULL, 9015, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:44:23', 'admin-1494134862-14941358630491237', 1, 0, '', NULL, NULL, NULL),
(29180, '2017-05-07 13:44:23', NULL, NULL, 9015, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:44:23', 'admin-1494134862-14941358630491237', 1, 0, '', NULL, NULL, NULL),
(29181, '2017-05-07 12:54:16', NULL, NULL, 9007, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:54:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29182, '2017-05-07 12:54:38', NULL, NULL, 9007, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:54:38', 'admin-1494123938-14941328786624111', 1, 0, '', NULL, NULL, NULL),
(29183, '2017-05-07 12:54:38', NULL, NULL, 9007, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:54:38', 'admin-1494123938-14941328786624111', 1, 0, '', NULL, NULL, NULL),
(29184, '2017-05-07 12:54:38', NULL, NULL, 9007, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:54:38', 'admin-1494123938-14941328786624111', 1, 1, 'SR', NULL, NULL, NULL),
(29185, '2017-05-07 12:54:38', NULL, NULL, 9007, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:54:38', 'admin-1494123938-14941328786624111', 1, 0, '', NULL, NULL, NULL),
(29186, '2017-05-07 13:55:16', NULL, NULL, 9016, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:55:16', 'admin-1494134862-14941365163348174', 1, 1, 'SR', NULL, NULL, NULL),
(29187, '2017-05-07 14:18:04', NULL, NULL, 9020, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:18:04', 'admin-1494137499-14941378846859981', 1, 0, '', NULL, NULL, NULL),
(29188, '2017-05-07 14:17:57', NULL, NULL, 9020, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 18.60, 0.0000, 0.0000, 18.60, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:17:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29189, '2017-05-07 13:26:38', NULL, NULL, 9012, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:26:38', 'admin-1494123938-14941347984814784', 1, 0, '', NULL, NULL, NULL),
(29190, '2017-05-07 13:26:38', NULL, NULL, 9012, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:26:38', 'admin-1494123938-14941347984814784', 1, 0, '', NULL, NULL, NULL),
(29191, '2017-05-07 13:26:38', NULL, NULL, 9012, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:26:38', 'admin-1494123938-14941347984814784', 1, 1, 'SR', NULL, NULL, NULL),
(29192, '2017-05-07 13:27:27', NULL, NULL, 9012, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:27:27', 'admin-1494123938-14941348470623187', 1, 1, 'SR', NULL, NULL, NULL),
(29193, '2017-05-07 13:28:16', NULL, NULL, 9012, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:28:16', 'admin-1494134862-14941348967524557', 1, 0, '', NULL, NULL, NULL),
(29194, '2017-05-07 13:29:13', NULL, NULL, 9013, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:29:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29195, '2017-05-07 13:29:33', NULL, NULL, 9013, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:29:33', 'admin-1494134862-14941349732154117', 1, 1, 'SR', NULL, NULL, NULL),
(29196, '2017-05-07 13:29:42', NULL, NULL, 9013, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:29:42', 'admin-1494134862-14941349819197364', 1, 0, '', NULL, NULL, NULL),
(29197, '2017-05-07 12:57:59', NULL, NULL, 9008, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:57:59', 'admin-1494123938-14941330794012242', 1, 0, '', NULL, NULL, NULL),
(29198, '2017-05-07 15:42:10', NULL, NULL, 9024, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 15:42:10', 'admin-1494137946-14941429301942378', 1, 1, 'SR', NULL, NULL, NULL),
(29199, '2017-05-07 14:17:06', NULL, NULL, 9019, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:17:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29200, '2017-05-07 15:42:10', NULL, NULL, 9024, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 15:42:10', 'admin-1494137946-14941429301942378', 1, 0, '', NULL, NULL, NULL),
(29201, '2017-05-07 09:32:08', NULL, NULL, 8990, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:32:08', 'admin-1494118832-14941207284167416', 1, 0, '', NULL, NULL, NULL),
(29202, '2017-05-07 09:32:08', NULL, NULL, 8990, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:32:08', 'admin-1494118832-14941207284167416', 1, 1, 'SR', NULL, NULL, NULL),
(29203, '2017-05-07 09:32:08', NULL, NULL, 8990, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:32:08', 'admin-1494118832-14941207284167416', 1, 1, 'SR', NULL, NULL, NULL),
(29204, '2017-05-07 14:16:29', NULL, NULL, 9016, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:16:29', 'admin-1494137499-14941377893081595', 1, 1, 'SR', NULL, NULL, NULL),
(29205, '2017-05-07 14:16:29', NULL, NULL, 9016, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:16:29', 'admin-1494137499-14941377893081595', 1, 1, 'SR', NULL, NULL, NULL),
(29206, '2017-05-07 14:16:29', NULL, NULL, 9016, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:16:29', 'admin-1494137499-14941377893081595', 1, 0, '', NULL, NULL, NULL),
(29207, '2017-05-07 16:16:52', NULL, NULL, 9027, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 16:16:52', 'admin-1494137946-1494145012785270', 1, 0, '', NULL, NULL, NULL),
(29208, '2017-05-07 13:55:25', NULL, NULL, 9016, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:55:25', 'admin-1494134862-14941365254388635', 1, 0, '', NULL, NULL, NULL),
(29209, '2017-05-07 13:55:25', NULL, NULL, 9016, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:55:25', 'admin-1494134862-14941365254388635', 1, 0, '', NULL, NULL, NULL),
(29210, '2017-05-07 16:16:35', NULL, NULL, 9027, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 16:16:35', 'admin-1494137946-14941449958035734', 1, 0, '', NULL, NULL, NULL),
(29211, '2017-05-07 12:54:45', NULL, NULL, 9007, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:54:45', 'admin-1494123938-14941328856618784', 1, 0, '', NULL, NULL, NULL),
(29212, '2017-05-07 13:45:53', NULL, NULL, 9015, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:45:53', 'admin-1494134862-14941359534479769', 1, 1, 'SR', NULL, NULL, NULL),
(29213, '2017-05-07 13:49:08', NULL, NULL, 8998, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:49:08', 'admin-1494134862-14941361482867890', 1, 1, 'SR', NULL, NULL, NULL),
(29214, '2017-05-07 13:54:50', NULL, NULL, 9016, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 18.00, 0.0000, 0.0000, 18.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:54:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29215, '2017-05-07 13:55:16', NULL, NULL, 9016, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:55:16', 'admin-1494134862-14941365163348174', 1, 1, 'SR', NULL, NULL, NULL),
(29216, '2017-05-07 13:55:16', NULL, NULL, 9016, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:55:16', 'admin-1494134862-14941365163348174', 1, 0, '', NULL, NULL, NULL),
(29217, '2017-05-07 13:44:23', NULL, NULL, 9015, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:44:23', 'admin-1494134862-14941358630491237', 1, 0, '', NULL, NULL, NULL),
(29218, '2017-05-07 12:18:39', NULL, NULL, 9006, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:18:39', 'admin-1494123938-14941307190644637', 1, 0, '', NULL, NULL, NULL),
(29219, '2017-05-07 12:19:06', NULL, NULL, 9006, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:19:06', 'admin-1494123938-14941307460188589', 1, 0, '', NULL, NULL, NULL),
(29220, '2017-05-07 11:16:12', NULL, NULL, 8997, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 11:16:12', 'admin-1494123938-14941269719529122', 1, 0, '', NULL, NULL, NULL),
(29221, '2017-05-07 11:16:25', NULL, NULL, 8997, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 11:16:25', 'admin-1494123938-1494126985592499', 1, 0, '', NULL, NULL, NULL),
(29222, '2017-05-07 13:43:51', NULL, NULL, 9015, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:43:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29223, '2017-05-07 14:39:55', NULL, NULL, 9022, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:39:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29224, '2017-05-07 15:41:53', NULL, NULL, 9024, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1494137946', 'admin', '2017-05-07 15:41:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29225, '2017-05-07 14:40:19', NULL, NULL, 9022, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:40:19', 'admin-1494137946-14941392191184974', 1, 0, '', NULL, NULL, NULL),
(29226, '2017-05-07 14:40:19', NULL, NULL, 9022, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 14:40:19', 'admin-1494137946-14941392191184974', 1, 0, '', NULL, NULL, NULL),
(29227, '2017-05-07 10:25:13', NULL, NULL, 8993, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.30, 0.0000, 0.0000, 12.30, 1, '27', 1, '1494137946', 'admin', '2017-05-07 10:25:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29228, '2017-05-07 13:26:17', NULL, NULL, 9012, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:26:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29229, '2017-05-07 13:16:39', NULL, NULL, 9011, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:16:39', 'admin-1494123938-14941341994856428', 1, 0, '', NULL, NULL, NULL),
(29230, '2017-05-07 12:57:35', NULL, NULL, 9008, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:57:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29231, '2017-05-07 12:57:59', NULL, NULL, 9008, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:57:59', 'admin-1494123938-14941330794012242', 1, 0, '', NULL, NULL, NULL),
(29232, '2017-05-07 13:02:25', NULL, NULL, 9008, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:02:25', 'admin-1494123938-14941333452395821', 1, 1, 'SR', NULL, NULL, NULL),
(29233, '2017-05-07 12:19:06', NULL, NULL, 9006, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:19:06', 'admin-1494123938-14941307460188589', 1, 1, 'SR', NULL, NULL, NULL),
(29234, '2017-05-07 12:19:06', NULL, NULL, 9006, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:19:06', 'admin-1494123938-14941307460188589', 1, 1, 'SR', NULL, NULL, NULL),
(29235, '2017-05-07 12:18:39', NULL, NULL, 9006, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:18:39', 'admin-1494123938-14941307190644637', 1, 0, '', NULL, NULL, NULL),
(29236, '2017-05-07 09:27:09', NULL, NULL, 8989, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:27:09', 'admin-1494118832-14941204294179428', 1, 1, 'SR', NULL, NULL, NULL),
(29237, '2017-05-07 12:14:14', NULL, NULL, 9005, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:14:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29238, '2017-05-07 13:55:16', NULL, NULL, 9016, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 13:55:16', 'admin-1494134862-14941365163348174', 1, 0, '', NULL, NULL, NULL),
(29239, '2017-05-07 12:12:10', NULL, NULL, 9004, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 12:12:10', 'admin-1494123938-14941303303997291', 1, 0, '', NULL, NULL, NULL),
(29240, '2017-05-07 11:42:34', NULL, NULL, 9000, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 11:42:34', 'admin-1494123938-14941285544747862', 1, 0, '', NULL, NULL, NULL),
(29241, '2017-05-07 11:45:07', NULL, NULL, 9001, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1494137946', 'admin', '2017-05-07 11:45:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29242, '2017-05-07 09:50:18', NULL, NULL, 8992, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:50:18', 'admin-1494118832-1494121818806535', 1, 0, '', NULL, NULL, NULL),
(29243, '2017-05-07 09:50:18', NULL, NULL, 8992, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:50:18', 'admin-1494118832-1494121818806535', 1, 0, '', NULL, NULL, NULL),
(29244, '2017-05-07 09:50:18', NULL, NULL, 8992, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:50:18', 'admin-1494118832-1494121818806535', 1, 1, 'SR', NULL, NULL, NULL),
(29245, '2017-05-07 11:42:29', NULL, NULL, 9000, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1494137946', 'admin', '2017-05-07 11:42:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29246, '2017-05-07 11:37:28', NULL, NULL, 8999, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 11:37:28', 'admin-1494123938-14941282481272192', 1, 1, 'SR', NULL, NULL, NULL),
(29247, '2017-05-07 11:37:28', NULL, NULL, 8999, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 11:37:28', 'admin-1494123938-14941282481272192', 1, 1, 'SR', NULL, NULL, NULL),
(29248, '2017-05-07 11:37:14', NULL, NULL, 8999, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 11:37:14', 'admin-1494123938-14941282342554939', 1, 0, '', NULL, NULL, NULL),
(29249, '2017-05-07 11:37:14', NULL, NULL, 8999, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 11:37:14', 'admin-1494123938-14941282342554939', 1, 0, '', NULL, NULL, NULL),
(29250, '2017-05-07 11:36:55', NULL, NULL, 8999, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1494137946', 'admin', '2017-05-07 11:36:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29251, '2017-05-07 11:31:18', NULL, NULL, 8998, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 11:31:18', 'admin-1494123938-14941278785173583', 1, 1, 'SR', NULL, NULL, NULL),
(29252, '2017-05-07 16:16:35', NULL, NULL, 9027, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 16:16:35', 'admin-1494137946-14941449958035734', 1, 0, '', NULL, NULL, NULL),
(29253, '2017-05-07 11:31:18', NULL, NULL, 8998, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 11:31:18', 'admin-1494123938-14941278785173583', 1, 1, 'SR', NULL, NULL, NULL),
(29254, '2017-05-07 11:17:57', NULL, NULL, 8997, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 11:17:57', 'admin-1494123938-1494127077556451', 1, 0, '', NULL, NULL, NULL),
(29255, '2017-05-07 11:31:01', NULL, NULL, 8998, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 11:31:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29256, '2017-05-07 10:58:47', NULL, NULL, 8996, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1494137946', 'admin', '2017-05-07 10:58:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29257, '2017-05-07 10:59:02', NULL, NULL, 8996, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 10:59:02', 'admin-1494123938-14941259418844897', 1, 1, 'SR', NULL, NULL, NULL),
(29258, '2017-05-07 10:59:02', NULL, NULL, 8996, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 10:59:02', 'admin-1494123938-14941259418844897', 1, 1, 'SR', NULL, NULL, NULL),
(29259, '2017-05-07 11:15:44', NULL, NULL, 8997, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.00, 0.0000, 0.0000, 10.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 11:15:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29260, '2017-05-07 11:15:55', NULL, NULL, 8997, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 11:15:55', 'admin-1494123938-1494126955075394', 1, 0, '', NULL, NULL, NULL),
(29261, '2017-05-07 11:15:55', NULL, NULL, 8997, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 11:15:55', 'admin-1494123938-1494126955075394', 1, 0, '', NULL, NULL, NULL),
(29262, '2017-05-07 11:16:12', NULL, NULL, 8997, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 11:16:12', 'admin-1494123938-14941269719529122', 1, 1, 'SR', NULL, NULL, NULL),
(29263, '2017-05-07 10:58:56', NULL, NULL, 8996, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 10:58:56', 'admin-1494123938-14941259360809236', 1, 0, '', NULL, NULL, NULL),
(29264, '2017-05-07 10:58:56', NULL, NULL, 8996, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 10:58:56', 'admin-1494123938-14941259360809236', 1, 0, '', NULL, NULL, NULL),
(29265, '2017-05-07 10:58:56', NULL, NULL, 8996, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 10:58:56', 'admin-1494123938-14941259360809236', 1, 0, '', NULL, NULL, NULL),
(29266, '2017-05-07 10:44:52', NULL, NULL, 8993, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 10:44:52', 'admin-1494123938-1494125092660234', 1, 1, 'SR', NULL, NULL, NULL),
(29267, '2017-05-07 10:44:52', NULL, NULL, 8993, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 10:44:52', 'admin-1494123938-1494125092660234', 1, 1, 'SR', NULL, NULL, NULL),
(29268, '2017-05-07 10:44:46', NULL, NULL, 8993, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 10:44:46', 'admin-1494123938-14941250864438641', 1, 0, '', NULL, NULL, NULL),
(29269, '2017-05-07 10:44:46', NULL, NULL, 8993, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 10:44:46', 'admin-1494123938-14941250864438641', 1, 0, '', NULL, NULL, NULL),
(29270, '2017-05-07 10:42:28', NULL, NULL, 8995, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 10:42:28', 'admin-1494123938-14941249482971895', 1, 0, '', NULL, NULL, NULL),
(29271, '2017-05-07 10:42:28', NULL, NULL, 8995, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 10:42:28', 'admin-1494123938-14941249482971895', 1, 0, '', NULL, NULL, NULL),
(29272, '2017-05-07 10:42:17', NULL, NULL, 8995, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1494137946', 'admin', '2017-05-07 10:42:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29273, '2017-05-07 10:25:24', NULL, NULL, 8993, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 10:25:24', 'admin-1494118832-1494123923794259', 1, 0, '', NULL, NULL, NULL),
(29274, '2017-05-07 10:25:24', NULL, NULL, 8993, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 10:25:24', 'admin-1494118832-1494123923794259', 1, 1, 'SR', NULL, NULL, NULL),
(29275, '2017-05-07 10:25:23', NULL, NULL, 8993, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 10:25:23', 'admin-1494118832-1494123923794259', 1, 0, '', NULL, NULL, NULL),
(29276, '2017-05-07 10:25:23', NULL, NULL, 8993, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 10:25:23', 'admin-1494118832-1494123923794259', 1, 0, '', NULL, NULL, NULL),
(29277, '2017-05-07 09:05:43', NULL, NULL, 8988, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:05:43', 'admin-1494118832-1494119143273594', 1, 0, '', NULL, NULL, NULL),
(29278, '2017-05-07 09:48:59', NULL, NULL, 8991, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:48:59', 'admin-1494118832-14941217391982648', 1, 0, '', NULL, NULL, NULL),
(29279, '2017-05-07 09:48:59', NULL, NULL, 8991, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:48:59', 'admin-1494118832-14941217391982648', 1, 0, '', NULL, NULL, NULL),
(29280, '2017-05-07 09:50:19', NULL, NULL, 8992, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:50:19', 'admin-1494118832-1494121818806535', 1, 1, 'SR', NULL, NULL, NULL),
(29281, '2017-05-07 09:49:32', NULL, NULL, 8992, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:49:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29282, '2017-05-07 09:49:05', NULL, NULL, 8991, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:49:05', 'admin-1494118832-1494121745754287', 1, 1, 'SR', NULL, NULL, NULL),
(29283, '2017-05-07 09:49:05', NULL, NULL, 8991, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:49:05', 'admin-1494118832-1494121745754287', 1, 1, 'SR', NULL, NULL, NULL),
(29284, '2017-05-07 09:30:37', NULL, NULL, 8990, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:30:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29285, '2017-05-07 09:32:08', NULL, NULL, 8990, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:32:08', 'admin-1494118832-14941207284167416', 1, 0, '', NULL, NULL, NULL),
(29286, '2017-05-07 10:38:42', NULL, NULL, 8994, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 10:38:42', 'admin-1494123938-14941247226833330', 1, 1, 'SR', 1, NULL, NULL),
(29287, '2017-05-07 09:27:09', NULL, NULL, 8989, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:27:09', 'admin-1494118832-14941204294179428', 1, 0, '', NULL, NULL, NULL),
(29288, '2017-05-07 09:27:09', NULL, NULL, 8989, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:27:09', 'admin-1494118832-14941204294179428', 1, 0, '', NULL, NULL, NULL),
(29289, '2017-05-07 09:05:43', NULL, NULL, 8988, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:05:43', 'admin-1494118832-1494119143273594', 1, 1, 'SR', NULL, NULL, NULL),
(29290, '2017-05-07 09:05:43', NULL, NULL, 8988, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:05:43', 'admin-1494118832-1494119143273594', 1, 1, 'SR', NULL, NULL, NULL),
(29291, '2017-05-07 09:26:47', NULL, NULL, 8989, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:26:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29292, '2017-05-07 09:27:09', NULL, NULL, 8989, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:27:09', 'admin-1494118832-14941204294179428', 1, 1, 'SR', NULL, NULL, NULL),
(29293, '2017-05-07 09:48:47', NULL, NULL, 8991, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:48:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29294, '2017-05-07 09:05:43', NULL, NULL, 8988, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:05:43', 'admin-1494118832-1494119143273594', 1, 0, '', NULL, NULL, NULL),
(29295, '2017-05-07 09:05:32', NULL, NULL, 8988, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1494137946', 'admin', '2017-05-07 09:05:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29296, '2017-05-08 13:33:45', NULL, NULL, 9041, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 13:33:45', 'admin-1494218794-14942216253029880', 1, 1, 'SR', NULL, NULL, NULL),
(29297, '2017-05-08 12:46:26', NULL, NULL, 9039, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:46:26', 'admin-1494205239-14942187863374177', 1, 1, 'SR', NULL, NULL, NULL),
(29298, '2017-05-08 12:46:26', NULL, NULL, 9039, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:46:26', 'admin-1494205239-14942187863374177', 1, 0, '', NULL, NULL, NULL),
(29299, '2017-05-08 12:51:27', NULL, NULL, 9040, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:51:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29300, '2017-05-08 12:51:35', NULL, NULL, 9040, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:51:35', 'admin-1494218794-1494219094854768', 1, 1, 'SR', NULL, NULL, NULL),
(29301, '2017-05-08 13:24:43', NULL, NULL, 9038, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 13:24:43', 'admin-1494218794-14942210834828572', 1, 0, '', NULL, NULL, NULL),
(29302, '2017-05-08 13:33:30', NULL, NULL, 9041, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1494226510', 'admin', '2017-05-08 13:33:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29303, '2017-05-08 13:33:45', NULL, NULL, 9041, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 13:33:45', 'admin-1494218794-14942216253029880', 1, 0, '', NULL, NULL, NULL),
(29304, '2017-05-08 13:33:45', NULL, NULL, 9041, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 13:33:45', 'admin-1494218794-14942216253029880', 1, 0, '', NULL, NULL, NULL),
(29305, '2017-05-08 13:33:45', NULL, NULL, 9041, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 13:33:45', 'admin-1494218794-14942216253029880', 1, 0, '', NULL, NULL, NULL),
(29306, '2017-05-08 14:03:07', NULL, NULL, 9043, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1494226510', 'admin', '2017-05-08 14:03:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29307, '2017-05-08 14:03:20', NULL, NULL, 9043, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 14:03:20', 'admin-1494218794-14942234000757523', 1, 0, '', NULL, NULL, NULL),
(29308, '2017-05-08 14:03:20', NULL, NULL, 9043, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 14:03:20', 'admin-1494218794-14942234000757523', 1, 1, 'SR', NULL, NULL, NULL),
(29309, '2017-05-08 14:03:20', NULL, NULL, 9043, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 14:03:20', 'admin-1494218794-14942234000757523', 1, 0, '', NULL, NULL, NULL),
(29310, '2017-05-08 14:03:20', NULL, NULL, 9043, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 14:03:20', 'admin-1494218794-14942234000757523', 1, 0, '', NULL, NULL, NULL),
(29311, '2017-05-08 14:27:00', NULL, NULL, 9044, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1494226510', 'admin', '2017-05-08 14:27:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29312, '2017-05-08 14:27:07', NULL, NULL, 9044, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 14:27:07', 'admin-1494218794-14942248275394459', 1, 0, '', NULL, NULL, NULL),
(29313, '2017-05-08 11:01:07', NULL, NULL, 9035, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 11:01:07', 'admin-1494205239-14942124676671521', 1, 1, 'SR', NULL, NULL, NULL),
(29314, '2017-05-08 11:01:07', NULL, NULL, 9035, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 11:01:07', 'admin-1494205239-14942124676671521', 1, 1, 'SR', NULL, NULL, NULL),
(29315, '2017-05-08 11:01:07', NULL, NULL, 9035, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 11:01:07', 'admin-1494205239-14942124676671521', 1, 0, '', NULL, NULL, NULL),
(29316, '2017-05-08 14:39:59', NULL, NULL, 9043, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 14:39:59', 'admin-1494218794-14942255995749188', 1, 1, 'SR', NULL, NULL, NULL),
(29317, '2017-05-08 14:51:09', NULL, NULL, 9044, 0, 181, '116', 'Open Food ', 'scones,scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 14:51:09', 'admin-1494218794-14942262690069418', 1, 0, '', NULL, NULL, NULL),
(29318, '2017-05-08 14:51:15', NULL, NULL, 9044, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 14:51:15', 'admin-1494218794-14942262756228593', 1, 1, 'SR', NULL, NULL, NULL),
(29319, '2017-05-08 15:17:51', NULL, NULL, 9042, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 15:17:51', 'admin-1494226510-14942278708082289', 1, 1, 'SR', NULL, NULL, NULL),
(29320, '2017-05-08 15:17:51', NULL, NULL, 9042, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 15:17:51', 'admin-1494226510-14942278708082289', 1, 1, 'SR', NULL, NULL, NULL),
(29321, '2017-05-08 15:39:50', NULL, NULL, 9044, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 15:39:50', 'admin-1494226510-14942291899327136', 1, 1, 'SR', NULL, NULL, NULL),
(29322, '2017-05-08 16:41:23', NULL, NULL, 9046, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1494226510', 'admin', '2017-05-08 16:41:23', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(29323, '2017-05-08 16:41:28', NULL, NULL, 9046, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 16:41:28', 'admin-1494226510-1494232888466948', 1, 1, 'SR', NULL, NULL, NULL),
(29324, '2017-05-08 12:46:26', NULL, NULL, 9039, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:46:26', 'admin-1494205239-14942187863374177', 1, 0, '', NULL, NULL, NULL),
(29325, '2017-05-08 12:46:26', NULL, NULL, 9039, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:46:26', 'admin-1494205239-14942187863374177', 1, 1, 'SR', NULL, NULL, NULL),
(29326, '2017-05-08 12:29:25', NULL, NULL, 9037, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:29:25', 'admin-1494205239-149421776573899', 1, 1, 'SR', NULL, NULL, NULL),
(29327, '2017-05-08 12:29:25', NULL, NULL, 9037, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:29:25', 'admin-1494205239-149421776573899', 1, 1, 'SR', NULL, NULL, NULL),
(29328, '2017-05-08 12:29:25', NULL, NULL, 9037, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:29:25', 'admin-1494205239-149421776573899', 1, 0, '', NULL, NULL, NULL),
(29329, '2017-05-08 12:29:25', NULL, NULL, 9037, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:29:25', 'admin-1494205239-149421776573899', 1, 0, '', NULL, NULL, NULL),
(29330, '2017-05-08 12:29:25', NULL, NULL, 9037, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:29:25', 'admin-1494205239-149421776573899', 1, 0, '', NULL, NULL, NULL),
(29331, '2017-05-08 12:29:25', NULL, NULL, 9037, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:29:25', 'admin-1494205239-149421776573899', 1, 0, '', NULL, NULL, NULL),
(29332, '2017-05-08 12:29:25', NULL, NULL, 9037, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:29:25', 'admin-1494205239-149421776573899', 1, 1, 'SR', NULL, NULL, NULL),
(29333, '2017-05-08 12:29:25', NULL, NULL, 9037, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:29:25', 'admin-1494205239-149421776573899', 1, 1, 'SR', NULL, NULL, NULL),
(29334, '2017-05-08 12:30:27', NULL, NULL, 9037, 0, 182, '117', 'Open Drinks ', 'set', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:30:27', 'admin-1494205239-14942178275967668', 1, 0, '', NULL, NULL, NULL),
(29335, '2017-05-08 12:32:30', NULL, NULL, 9038, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:32:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29336, '2017-05-08 12:32:46', NULL, NULL, 9038, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:32:46', 'admin-1494205239-14942179666467690', 1, 0, '', NULL, NULL, NULL),
(29337, '2017-05-08 17:32:09', NULL, NULL, 9044, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 17:32:09', 'admin-1494226510-14942359296493245', 1, 0, '', NULL, NULL, NULL),
(29338, '2017-05-08 14:27:12', NULL, NULL, 9043, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 14:27:12', 'admin-1494218794-14942248322055042', 1, 1, 'SR', NULL, NULL, NULL),
(29339, '2017-05-08 14:27:07', NULL, NULL, 9044, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 14:27:07', 'admin-1494218794-14942248275394459', 1, 1, 'SR', NULL, NULL, NULL),
(29340, '2017-05-08 13:49:09', NULL, NULL, 9042, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 13:49:09', 'admin-1494218794-14942225497421148', 1, 0, '', NULL, NULL, NULL),
(29341, '2017-05-08 13:49:09', NULL, NULL, 9042, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 13:49:09', 'admin-1494218794-14942225497421148', 1, 0, '', NULL, NULL, NULL),
(29342, '2017-05-08 13:46:24', NULL, NULL, 9042, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1494226510', 'admin', '2017-05-08 13:46:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29343, '2017-05-08 13:33:45', NULL, NULL, 9041, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 13:33:45', 'admin-1494218794-14942216253029880', 1, 1, 'SR', NULL, NULL, NULL),
(29344, '2017-05-08 12:46:03', NULL, NULL, 9039, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:46:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29345, '2017-05-08 12:32:59', NULL, NULL, 9038, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:32:59', 'admin-1494205239-1494217979510859', 1, 0, '', NULL, NULL, NULL),
(29346, '2017-05-08 12:32:59', NULL, NULL, 9038, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:32:59', 'admin-1494205239-1494217979510859', 1, 1, 'SR', NULL, NULL, NULL),
(29347, '2017-05-08 12:32:59', NULL, NULL, 9038, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:32:59', 'admin-1494205239-1494217979510859', 1, 1, 'SR', NULL, NULL, NULL),
(29348, '2017-05-08 12:32:46', NULL, NULL, 9038, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:32:46', 'admin-1494205239-14942179666467690', 1, 0, '', NULL, NULL, NULL),
(29349, '2017-05-08 10:09:46', NULL, NULL, 9030, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 10:09:46', 'admin-1494205239-14942093863134691', 1, 1, 'SR', NULL, NULL, NULL),
(29350, '2017-05-08 10:00:29', NULL, NULL, 9031, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1494226510', 'admin', '2017-05-08 10:00:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29351, '2017-05-08 10:00:33', NULL, NULL, 9031, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 10:00:33', 'admin-1494205239-14942088337066436', 1, 1, 'SR', NULL, NULL, NULL),
(29352, '2017-05-08 12:21:59', NULL, NULL, 9037, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.90, 0.0000, 0.0000, 13.90, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:21:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29353, '2017-05-08 10:11:55', NULL, NULL, 9033, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.50, 0.0000, 0.0000, 11.50, 1, '27', 1, '1494226510', 'admin', '2017-05-08 10:11:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29354, '2017-05-08 10:12:05', NULL, NULL, 9033, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 10:12:05', 'admin-1494205239-14942095250247568', 1, 0, '', NULL, NULL, NULL),
(29355, '2017-05-08 10:12:05', NULL, NULL, 9033, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 10:12:05', 'admin-1494205239-14942095250247568', 1, 0, '', NULL, NULL, NULL),
(29356, '2017-05-08 10:12:05', NULL, NULL, 9033, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 10:12:05', 'admin-1494205239-14942095250247568', 1, 0, '', NULL, NULL, NULL),
(29357, '2017-05-08 10:12:05', NULL, NULL, 9033, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 10:12:05', 'admin-1494205239-14942095250247568', 1, 0, '', NULL, NULL, NULL),
(29358, '2017-05-08 10:12:18', NULL, NULL, 9033, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 10:12:18', 'admin-1494205239-14942095386138987', 1, 1, 'SR', NULL, NULL, NULL),
(29359, '2017-05-08 10:12:18', NULL, NULL, 9033, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 10:12:18', 'admin-1494205239-14942095386138987', 1, 1, 'SR', NULL, NULL, NULL),
(29360, '2017-05-08 10:12:18', NULL, NULL, 9033, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 10:12:18', 'admin-1494205239-14942095386138987', 1, 1, 'SR', NULL, NULL, NULL),
(29361, '2017-05-08 10:25:28', NULL, NULL, 9034, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1494226510', 'admin', '2017-05-08 10:25:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29362, '2017-05-08 10:25:42', NULL, NULL, 9034, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 10:25:42', 'admin-1494205239-1494210342463611', 1, 0, '', NULL, NULL, NULL),
(29363, '2017-05-08 10:25:42', NULL, NULL, 9034, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 10:25:42', 'admin-1494205239-1494210342463611', 1, 0, '', NULL, NULL, NULL),
(29364, '2017-05-08 10:25:42', NULL, NULL, 9034, 0, 279, '213', 'Diet Meal - Americano / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 10:25:42', 'admin-1494205239-1494210342463611', 1, 0, '', NULL, NULL, NULL),
(29365, '2017-05-08 12:29:25', NULL, NULL, 9037, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 12:29:25', 'admin-1494205239-149421776573899', 1, 1, 'SR', NULL, NULL, NULL),
(29366, '2017-05-08 11:15:59', NULL, NULL, 9036, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1494226510', 'admin', '2017-05-08 11:15:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29367, '2017-05-08 11:16:06', NULL, NULL, 9036, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 11:16:06', 'admin-1494205239-14942133662065474', 1, 1, 'SR', NULL, NULL, NULL),
(29368, '2017-05-08 11:00:50', NULL, NULL, 9035, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1494226510', 'admin', '2017-05-08 11:00:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29369, '2017-05-08 11:00:57', NULL, NULL, 9035, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 11:00:57', 'admin-1494205239-1494212457422615', 1, 0, '', NULL, NULL, NULL),
(29370, '2017-05-08 11:00:57', NULL, NULL, 9035, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 11:00:57', 'admin-1494205239-1494212457422615', 1, 0, '', NULL, NULL, NULL),
(29371, '2017-05-08 10:25:42', NULL, NULL, 9034, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 10:25:42', 'admin-1494205239-1494210342463611', 1, 1, 'SR', NULL, NULL, NULL),
(29372, '2017-05-08 11:00:57', NULL, NULL, 9035, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 11:00:57', 'admin-1494205239-1494212457422615', 1, 0, '', NULL, NULL, NULL),
(29373, '2017-05-08 09:06:40', NULL, NULL, 9028, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 09:06:40', 'admin-1494205239-14942055998003431', 1, 0, '', NULL, NULL, NULL),
(29374, '2017-05-08 09:06:40', NULL, NULL, 9028, 0, 280, '214', 'Diet Meal - Piccolo / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 09:06:40', 'admin-1494205239-14942055998003431', 1, 0, '', NULL, NULL, NULL),
(29375, '2017-05-08 09:10:03', NULL, NULL, 9029, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 09:10:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29376, '2017-05-08 09:10:07', NULL, NULL, 9029, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 09:10:07', 'admin-1494205239-14942058076952280', 1, 0, '', NULL, NULL, NULL),
(29377, '2017-05-08 09:17:59', NULL, NULL, 9030, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1494226510', 'admin', '2017-05-08 09:17:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29378, '2017-05-08 09:06:29', NULL, NULL, 9028, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1494226510', 'admin', '2017-05-08 09:06:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29379, '2017-05-10 15:56:31', NULL, NULL, 9077, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 15:56:31', 'admin-1494398691-14944029916798181', 1, 1, 'SR', NULL, NULL, NULL),
(29380, '2017-05-10 11:15:31', NULL, NULL, 9064, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:15:31', 'admin-1494384980-14943861309559958', 1, 0, '', NULL, NULL, NULL),
(29381, '2017-05-10 11:15:31', NULL, NULL, 9064, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:15:31', 'admin-1494384980-14943861309559958', 1, 0, '', NULL, NULL, NULL),
(29382, '2017-05-10 10:47:44', NULL, NULL, 9059, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:47:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29383, '2017-05-10 10:47:54', NULL, NULL, 9059, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:47:54', 'admin-1494383458-14943844741851672', 1, 0, '', NULL, NULL, NULL),
(29384, '2017-05-10 10:47:54', NULL, NULL, 9059, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:47:54', 'admin-1494383458-14943844741851672', 1, 1, 'SR', NULL, NULL, NULL),
(29385, '2017-05-10 10:51:51', NULL, NULL, 9060, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:51:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29386, '2017-05-10 10:51:55', NULL, NULL, 9060, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:51:55', 'admin-1494383458-14943847157392432', 1, 0, '', NULL, NULL, NULL),
(29387, '2017-05-10 10:23:12', NULL, NULL, 9056, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:23:12', 'admin-1494380783-1494382992621920', 1, 0, '', NULL, NULL, NULL),
(29388, '2017-05-10 10:23:12', NULL, NULL, 9056, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:23:12', 'admin-1494380783-1494382992621920', 1, 0, '', NULL, NULL, NULL),
(29389, '2017-05-10 10:23:12', NULL, NULL, 9056, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:23:12', 'admin-1494380783-1494382992621920', 1, 0, '', NULL, NULL, NULL),
(29390, '2017-05-10 11:42:23', NULL, NULL, 9067, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:42:23', 'admin-1494384980-14943877436807481', 1, 1, 'SR', NULL, NULL, NULL),
(29391, '2017-05-10 11:59:23', NULL, NULL, 9065, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:59:24', 'admin-1494384980-14943887637918940', 1, 0, '', NULL, NULL, NULL),
(29392, '2017-05-10 12:07:21', NULL, NULL, 9068, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.90, 0.0000, 0.0000, 13.90, 1, '27', 1, '1494398691', 'admin', '2017-05-10 12:07:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29393, '2017-05-10 11:26:38', NULL, NULL, 9063, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:26:38', 'admin-1494384980-14943867981772442', 1, 0, '', NULL, NULL, NULL),
(29394, '2017-05-10 11:26:38', NULL, NULL, 9063, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:26:38', 'admin-1494384980-14943867981772442', 1, 0, '', NULL, NULL, NULL),
(29395, '2017-05-10 11:28:19', NULL, NULL, 9065, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:28:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29396, '2017-05-10 11:28:38', NULL, NULL, 9065, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:28:38', 'admin-1494384980-14943869187187983', 1, 0, '', NULL, NULL, NULL),
(29397, '2017-05-10 11:28:38', NULL, NULL, 9065, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:28:38', 'admin-1494384980-14943869187187983', 1, 0, '', NULL, NULL, NULL),
(29398, '2017-05-10 11:28:38', NULL, NULL, 9065, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:28:38', 'admin-1494384980-14943869187187983', 1, 1, 'SR', NULL, NULL, NULL),
(29399, '2017-05-10 11:28:38', NULL, NULL, 9065, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:28:38', 'admin-1494384980-14943869187187983', 1, 1, 'SR', NULL, NULL, NULL),
(29400, '2017-05-10 16:55:31', NULL, NULL, 9079, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 16:55:31', 'admin-1494398691-14944065310555217', 1, 1, 'SR', NULL, NULL, NULL),
(29401, '2017-05-10 17:33:33', NULL, NULL, 9080, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1494398691', 'admin', '2017-05-10 17:33:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29402, '2017-05-10 17:33:46', NULL, NULL, 9080, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 17:33:46', 'admin-1494398691-14944088265221443', 1, 1, 'SR', NULL, NULL, NULL),
(29403, '2017-05-10 17:33:46', NULL, NULL, 9080, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 17:33:46', 'admin-1494398691-14944088265221443', 1, 1, 'SR', NULL, NULL, NULL),
(29404, '2017-05-10 15:50:50', NULL, NULL, 9076, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 15:50:50', 'admin-1494398691-14944026499741247', 1, 0, '', NULL, NULL, NULL),
(29405, '2017-05-10 15:56:16', NULL, NULL, 9077, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1494398691', 'admin', '2017-05-10 15:56:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29406, '2017-05-10 11:15:08', NULL, NULL, 9063, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:15:08', 'admin-1494384980-14943861085439415', 1, 0, '', NULL, NULL, NULL),
(29407, '2017-05-10 11:15:08', NULL, NULL, 9063, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:15:08', 'admin-1494384980-14943861085439415', 1, 0, '', NULL, NULL, NULL),
(29408, '2017-05-10 11:15:00', NULL, NULL, 9063, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.79, 0.0000, 0.0000, 7.79, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:15:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29409, '2017-05-10 11:05:20', NULL, NULL, 9062, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:05:20', 'admin-1494384980-14943855199449372', 1, 1, 'SR', 1, NULL, NULL),
(29410, '2017-05-10 10:23:30', NULL, NULL, 9056, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:23:30', 'admin-1494380783-14943830100521753', 1, 1, 'SR', NULL, NULL, NULL),
(29411, '2017-05-10 10:23:30', NULL, NULL, 9056, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:23:30', 'admin-1494380783-14943830100521753', 1, 0, '', NULL, NULL, NULL),
(29412, '2017-05-10 15:56:31', NULL, NULL, 9077, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 15:56:31', 'admin-1494398691-14944029916798181', 1, 1, 'SR', NULL, NULL, NULL),
(29413, '2017-05-10 16:12:44', NULL, NULL, 9078, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1494398691', 'admin', '2017-05-10 16:12:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29414, '2017-05-10 15:27:29', NULL, NULL, 9074, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1494398691', 'admin', '2017-05-10 15:27:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29415, '2017-05-10 15:27:50', NULL, NULL, 9074, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 15:27:50', 'admin-1494398691-1494401270506417', 1, 1, 'SR', NULL, NULL, NULL),
(29416, '2017-05-10 15:27:50', NULL, NULL, 9074, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 15:27:50', 'admin-1494398691-1494401270506417', 1, 1, 'SR', NULL, NULL, NULL),
(29417, '2017-05-10 15:27:50', NULL, NULL, 9074, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 15:27:50', 'admin-1494398691-1494401270506417', 1, 0, '', NULL, NULL, NULL),
(29418, '2017-05-10 13:54:29', NULL, NULL, 9072, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 13:54:29', 'admin-1494389252-1494395669418813', 1, 1, 'SR', NULL, NULL, NULL),
(29419, '2017-05-10 13:54:29', NULL, NULL, 9072, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 13:54:29', 'admin-1494389252-1494395669418813', 1, 1, 'SR', NULL, NULL, NULL),
(29420, '2017-05-10 13:54:16', NULL, NULL, 9072, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1494398691', 'admin', '2017-05-10 13:54:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29421, '2017-05-10 11:28:38', NULL, NULL, 9065, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:28:38', 'admin-1494384980-14943869187187983', 1, 1, 'SR', NULL, NULL, NULL),
(29422, '2017-05-10 11:30:04', NULL, NULL, 9066, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:30:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29423, '2017-05-10 11:30:20', NULL, NULL, 9066, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:30:20', 'admin-1494384980-14943870206976642', 1, 0, '', NULL, NULL, NULL),
(29424, '2017-05-10 11:30:20', NULL, NULL, 9066, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:30:20', 'admin-1494384980-14943870206976642', 1, 0, '', NULL, NULL, NULL),
(29425, '2017-05-10 10:52:48', NULL, NULL, 9061, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:52:48', 'admin-1494383458-14943847677544798', 1, 1, 'SR', NULL, NULL, NULL),
(29426, '2017-05-10 10:52:48', NULL, NULL, 9061, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:52:48', 'admin-1494383458-14943847677544798', 1, 1, 'SR', NULL, NULL, NULL),
(29427, '2017-05-10 10:56:14', NULL, NULL, 9060, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:56:14', 'admin-1494383458-14943849741613617', 1, 0, '', NULL, NULL, NULL),
(29428, '2017-05-10 10:56:14', NULL, NULL, 9060, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:56:14', 'admin-1494383458-14943849741613617', 1, 1, 'SR', NULL, NULL, NULL),
(29429, '2017-05-10 11:05:20', NULL, NULL, 9062, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:05:20', 'admin-1494384980-14943855199449372', 1, 1, 'SR', 1, NULL, NULL),
(29430, '2017-05-10 14:44:17', NULL, NULL, 9073, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 14:44:17', 'admin-1494389252-14943986576895693', 1, 1, 'SR', NULL, NULL, NULL),
(29431, '2017-05-10 16:13:07', NULL, NULL, 9078, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 16:13:07', 'admin-1494398691-14944039867587761', 1, 1, 'SR', NULL, NULL, NULL),
(29432, '2017-05-10 16:13:07', NULL, NULL, 9078, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 16:13:07', 'admin-1494398691-14944039867587761', 1, 1, 'SR', NULL, NULL, NULL),
(29433, '2017-05-10 16:55:24', NULL, NULL, 9079, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1494398691', 'admin', '2017-05-10 16:55:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29434, '2017-05-10 16:13:07', NULL, NULL, 9078, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 16:13:07', 'admin-1494398691-14944039867587761', 1, 1, 'SR', NULL, NULL, NULL),
(29435, '2017-05-10 12:16:48', NULL, NULL, 9068, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 12:16:48', 'admin-1494389252-14943898082903838', 1, 0, '', NULL, NULL, NULL),
(29436, '2017-05-10 12:16:48', NULL, NULL, 9068, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 12:16:48', 'admin-1494389252-14943898082903838', 1, 0, '', NULL, NULL, NULL),
(29437, '2017-05-10 12:16:48', NULL, NULL, 9068, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 12:16:48', 'admin-1494389252-14943898082903838', 1, 0, '', NULL, NULL, NULL),
(29438, '2017-05-10 12:22:02', NULL, NULL, 9068, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 12:22:02', 'admin-1494389252-1494390122067917', 1, 1, 'SR', NULL, NULL, NULL),
(29439, '2017-05-10 12:22:02', NULL, NULL, 9068, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 12:22:02', 'admin-1494389252-1494390122067917', 1, 1, 'SR', NULL, NULL, NULL),
(29440, '2017-05-10 12:22:02', NULL, NULL, 9068, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 12:22:02', 'admin-1494389252-1494390122067917', 1, 1, 'SR', NULL, NULL, NULL),
(29441, '2017-05-10 12:26:06', NULL, NULL, 9069, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 12:26:06', 'admin-1494389252-1494390365914106', 1, 0, '', 1, NULL, NULL),
(29442, '2017-05-10 12:26:06', NULL, NULL, 9069, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 12:26:06', 'admin-1494389252-1494390365914106', 1, 0, '', 1, NULL, NULL),
(29443, '2017-05-10 12:36:42', NULL, NULL, 9070, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1494398691', 'admin', '2017-05-10 12:36:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29444, '2017-05-10 12:56:29', NULL, NULL, 9068, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 12:56:29', 'admin-1494389252-14943921892741996', 1, 1, 'SR', NULL, NULL, NULL),
(29445, '2017-05-10 15:48:35', NULL, NULL, 9075, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 15:48:35', 'admin-1494398691-14944025155381524', 1, 1, 'SR', NULL, NULL, NULL),
(29446, '2017-05-10 15:50:43', NULL, NULL, 9076, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1494398691', 'admin', '2017-05-10 15:50:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29447, '2017-05-10 09:24:16', NULL, NULL, 9048, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:24:16', 'admin-1494377887-14943794563241830', 1, 0, '', NULL, NULL, NULL),
(29448, '2017-05-10 09:33:09', NULL, NULL, 9049, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:33:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29449, '2017-05-10 09:33:14', NULL, NULL, 9049, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:33:14', 'admin-1494377887-149437999470829', 1, 0, '', NULL, NULL, NULL),
(29450, '2017-05-10 15:42:17', NULL, NULL, 9075, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1494398691', 'admin', '2017-05-10 15:42:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29451, '2017-05-10 15:42:21', NULL, NULL, 9075, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 15:42:21', 'admin-1494398691-14944021409559982', 1, 1, 'SR', NULL, NULL, NULL),
(29452, '2017-05-10 15:56:25', NULL, NULL, 9077, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 15:56:25', 'admin-1494398691-14944029848506958', 1, 0, '', NULL, NULL, NULL),
(29453, '2017-05-10 12:16:48', NULL, NULL, 9068, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 12:16:48', 'admin-1494389252-14943898082903838', 1, 1, 'SR', NULL, NULL, NULL),
(29454, '2017-05-10 14:44:17', NULL, NULL, 9073, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 14:44:17', 'admin-1494389252-14943986576895693', 1, 0, '', NULL, NULL, NULL),
(29455, '2017-05-10 14:45:02', NULL, NULL, 9073, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 14:45:02', 'admin-1494398691-14943987020237328', 1, 1, 'SR', NULL, NULL, NULL),
(29456, '2017-05-10 11:16:50', NULL, NULL, 9064, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:16:50', 'admin-1494384980-14943862098152783', 1, 1, 'SR', NULL, NULL, NULL),
(29457, '2017-05-10 10:32:48', NULL, NULL, 9057, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:32:48', 'admin-1494383458-14943835685928887', 1, 0, '', NULL, NULL, NULL),
(29458, '2017-05-10 10:41:06', NULL, NULL, 9058, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:41:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29459, '2017-05-10 10:41:22', NULL, NULL, 9058, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:41:22', 'admin-1494383458-14943840822497561', 1, 0, '', NULL, NULL, NULL),
(29460, '2017-05-10 10:41:22', NULL, NULL, 9058, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:41:22', 'admin-1494383458-14943840822497561', 1, 0, '', NULL, NULL, NULL),
(29461, '2017-05-10 10:41:22', NULL, NULL, 9058, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:41:22', 'admin-1494383458-14943840822497561', 1, 0, '', NULL, NULL, NULL),
(29462, '2017-05-10 10:41:22', NULL, NULL, 9058, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:41:22', 'admin-1494383458-14943840822497561', 1, 1, 'SR', NULL, NULL, NULL),
(29463, '2017-05-10 10:32:48', NULL, NULL, 9057, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:32:48', 'admin-1494383458-14943835685928887', 1, 0, '', NULL, NULL, NULL),
(29464, '2017-05-10 14:44:02', NULL, NULL, 9073, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1494398691', 'admin', '2017-05-10 14:44:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29465, '2017-05-10 13:54:29', NULL, NULL, 9072, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 13:54:29', 'admin-1494389252-1494395669418813', 1, 1, 'SR', NULL, NULL, NULL),
(29466, '2017-05-10 10:23:12', NULL, NULL, 9056, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:23:12', 'admin-1494380783-1494382992621920', 1, 0, '', NULL, NULL, NULL),
(29467, '2017-05-10 10:23:30', NULL, NULL, 9056, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:23:30', 'admin-1494380783-14943830100521753', 1, 1, 'SR', NULL, NULL, NULL),
(29468, '2017-05-10 10:23:30', NULL, NULL, 9056, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:23:30', 'admin-1494380783-14943830100521753', 1, 1, 'SR', NULL, NULL, NULL),
(29469, '2017-05-10 12:37:22', NULL, NULL, 9070, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 12:37:22', 'admin-1494389252-14943910420101462', 1, 1, 'SR', NULL, NULL, NULL),
(29470, '2017-05-10 12:38:02', NULL, NULL, 9055, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 12:38:02', 'admin-1494389252-14943910817478160', 1, 0, '', NULL, NULL, NULL),
(29471, '2017-05-10 12:36:58', NULL, NULL, 9070, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 12:36:58', 'admin-1494389252-1494391018373723', 1, 0, '', NULL, NULL, NULL),
(29472, '2017-05-10 12:37:22', NULL, NULL, 9070, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 12:37:22', 'admin-1494389252-14943910420101462', 1, 0, '', NULL, NULL, NULL),
(29473, '2017-05-10 12:09:22', NULL, NULL, 9055, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 12:09:22', 'admin-1494389252-14943893618609880', 1, 1, 'SR', NULL, NULL, NULL),
(29474, '2017-05-10 12:11:25', NULL, NULL, 9055, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 12:11:25', 'admin-1494389252-14943894855701648', 1, 1, 'SR', NULL, NULL, NULL),
(29475, '2017-05-10 12:11:58', NULL, NULL, 9055, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1494398691', 'admin', '2017-05-10 12:11:58', 'admin-1494389252-14943895184763395', 1, 0, '', NULL, NULL, NULL),
(29476, '2017-05-10 12:09:22', NULL, NULL, 9055, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 12:09:22', 'admin-1494389252-14943893618609880', 1, 0, '', NULL, NULL, NULL),
(29477, '2017-05-10 12:07:26', NULL, NULL, 9068, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 12:07:26', 'admin-1494384980-14943892463696962', 1, 0, '', NULL, NULL, NULL),
(29478, '2017-05-10 12:09:22', NULL, NULL, 9055, 0, 74, '74', 'Sunrice', 'no eda', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 12:09:22', 'admin-1494389252-14943893618609880', 1, 1, 'SR', NULL, NULL, NULL),
(29479, '2017-05-10 11:42:19', NULL, NULL, 9067, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:42:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29480, '2017-05-10 11:38:16', NULL, NULL, 9063, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:38:16', 'admin-1494384980-14943874957985027', 1, 0, '', NULL, NULL, NULL),
(29481, '2017-05-10 11:30:20', NULL, NULL, 9066, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:30:20', 'admin-1494384980-14943870206976642', 1, 1, 'SR', NULL, NULL, NULL),
(29482, '2017-05-10 11:30:20', NULL, NULL, 9066, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:30:20', 'admin-1494384980-14943870206976642', 1, 1, 'SR', NULL, NULL, NULL),
(29483, '2017-05-10 11:15:19', NULL, NULL, 9063, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:15:19', 'admin-1494384980-14943861188139676', 1, 1, 'SR', NULL, NULL, NULL),
(29484, '2017-05-10 15:08:43', NULL, NULL, 9073, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 15:08:43', 'admin-1494398691-14944001236659977', 1, 1, 'SR', NULL, NULL, NULL),
(29485, '2017-05-10 11:16:50', NULL, NULL, 9064, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:16:50', 'admin-1494384980-14943862098152783', 1, 1, 'SR', NULL, NULL, NULL),
(29486, '2017-05-10 11:15:25', NULL, NULL, 9064, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:15:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29487, '2017-05-10 11:15:19', NULL, NULL, 9063, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 11:15:19', 'admin-1494384980-14943861188139676', 1, 1, 'SR', NULL, NULL, NULL),
(29488, '2017-05-10 09:45:32', NULL, NULL, 9052, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:45:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29489, '2017-05-10 09:45:42', NULL, NULL, 9052, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:45:42', 'admin-1494377887-14943807417543090', 1, 0, '', NULL, NULL, NULL),
(29490, '2017-05-10 09:45:42', NULL, NULL, 9052, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:45:42', 'admin-1494377887-14943807417543090', 1, 0, '', NULL, NULL, NULL),
(29491, '2017-05-10 09:45:42', NULL, NULL, 9052, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:45:42', 'admin-1494377887-14943807417543090', 1, 0, '', NULL, NULL, NULL),
(29492, '2017-05-10 09:45:42', NULL, NULL, 9052, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:45:42', 'admin-1494377887-14943807417543090', 1, 1, 'SR', NULL, NULL, NULL),
(29493, '2017-05-10 09:46:47', NULL, NULL, 9048, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:46:47', 'admin-1494380783-14943808068992594', 1, 0, '', NULL, NULL, NULL),
(29494, '2017-05-10 09:53:41', NULL, NULL, 9053, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:53:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29495, '2017-05-10 09:53:47', NULL, NULL, 9053, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:53:47', 'admin-1494380783-14943812270521179', 1, 0, '', NULL, NULL, NULL),
(29496, '2017-05-10 09:53:47', NULL, NULL, 9053, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:53:47', 'admin-1494380783-14943812270521179', 1, 0, '', NULL, NULL, NULL),
(29497, '2017-05-10 09:53:47', NULL, NULL, 9053, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:53:47', 'admin-1494380783-14943812270521179', 1, 1, 'SR', NULL, NULL, NULL),
(29498, '2017-05-10 09:36:02', NULL, NULL, 9050, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:36:02', 'admin-1494377887-14943801622232969', 1, 0, '', NULL, NULL, NULL),
(29499, '2017-05-10 10:52:45', NULL, NULL, 9061, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:52:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29500, '2017-05-10 10:43:49', NULL, NULL, 9058, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:43:49', 'admin-1494383458-14943842296479471', 1, 0, '', NULL, NULL, NULL),
(29501, '2017-05-10 10:41:22', NULL, NULL, 9058, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:41:22', 'admin-1494383458-14943840822497561', 1, 0, '', NULL, NULL, NULL),
(29502, '2017-05-10 10:32:48', NULL, NULL, 9057, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:32:48', 'admin-1494383458-14943835685928887', 1, 1, 'SR', NULL, NULL, NULL),
(29503, '2017-05-10 10:32:48', NULL, NULL, 9057, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:32:48', 'admin-1494383458-14943835685928887', 1, 0, '', NULL, NULL, NULL),
(29504, '2017-05-10 10:37:12', NULL, NULL, 9057, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:37:12', 'admin-1494383458-14943838323829916', 1, 0, '', NULL, NULL, NULL),
(29505, '2017-05-10 10:32:48', NULL, NULL, 9057, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:32:48', 'admin-1494383458-14943835685928887', 1, 0, '', NULL, NULL, NULL),
(29506, '2017-05-10 10:30:49', NULL, NULL, 9054, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:30:49', 'admin-1494380783-14943834495876534', 1, 0, '', NULL, NULL, NULL),
(29507, '2017-05-10 10:32:32', NULL, NULL, 9057, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:32:32', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(29508, '2017-05-10 10:24:43', NULL, NULL, 9055, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:24:43', 'admin-1494380783-1494383083731949', 1, 1, 'SR', NULL, NULL, NULL),
(29509, '2017-05-10 10:24:43', NULL, NULL, 9055, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:24:43', 'admin-1494380783-1494383083731949', 1, 0, '', NULL, NULL, NULL),
(29510, '2017-05-10 10:23:04', NULL, NULL, 9056, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.40, 0.0000, 0.0000, 12.40, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:23:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29511, '2017-05-10 10:21:20', NULL, NULL, 9055, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:21:20', 'admin-1494380783-14943828805606287', 1, 1, 'SR', NULL, NULL, NULL),
(29512, '2017-05-10 10:10:06', NULL, NULL, 9055, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:10:06', 'admin-1494380783-1494382206077241', 1, 1, 'SR', NULL, NULL, NULL),
(29513, '2017-05-10 10:10:06', NULL, NULL, 9055, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:10:06', 'admin-1494380783-1494382206077241', 1, 1, 'SR', NULL, NULL, NULL),
(29514, '2017-05-10 10:10:06', NULL, NULL, 9055, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:10:06', 'admin-1494380783-1494382206077241', 1, 1, 'SR', NULL, NULL, NULL),
(29515, '2017-05-10 09:24:01', NULL, NULL, 9048, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:24:01', 'admin-1494377887-14943794415112586', 1, 0, '', NULL, NULL, NULL),
(29516, '2017-05-10 09:24:01', NULL, NULL, 9048, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:24:01', 'admin-1494377887-14943794415112586', 1, 0, '', NULL, NULL, NULL),
(29517, '2017-05-10 09:16:49', NULL, NULL, 9047, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:16:49', 'admin-1494377887-14943790094792361', 1, 0, '', NULL, NULL, NULL),
(29518, '2017-05-10 10:09:46', NULL, NULL, 9055, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:09:46', 'admin-1494380783-14943821859699673', 1, 0, '', NULL, NULL, NULL),
(29519, '2017-05-10 10:09:46', NULL, NULL, 9055, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:09:46', 'admin-1494380783-14943821859699673', 1, 0, '', NULL, NULL, NULL),
(29520, '2017-05-10 10:09:46', NULL, NULL, 9055, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:09:46', 'admin-1494380783-14943821859699673', 1, 0, '', NULL, NULL, NULL),
(29521, '2017-05-10 10:09:46', NULL, NULL, 9055, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:09:46', 'admin-1494380783-14943821859699673', 1, 0, '', NULL, NULL, NULL),
(29522, '2017-05-10 10:09:46', NULL, NULL, 9055, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:09:46', 'admin-1494380783-14943821859699673', 1, 0, '', NULL, NULL, NULL),
(29523, '2017-05-10 10:09:23', NULL, NULL, 9055, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 20.89, 0.0000, 0.0000, 20.89, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:09:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29524, '2017-05-10 10:04:01', NULL, NULL, 9054, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:04:01', 'admin-1494380783-14943818413484520', 1, 0, '', NULL, NULL, NULL),
(29525, '2017-05-10 10:04:01', NULL, NULL, 9054, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:04:01', 'admin-1494380783-14943818413484520', 1, 1, 'SR', NULL, NULL, NULL),
(29526, '2017-05-10 10:04:01', NULL, NULL, 9054, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:04:01', 'admin-1494380783-14943818413484520', 1, 0, '', NULL, NULL, NULL),
(29527, '2017-05-10 10:04:01', NULL, NULL, 9054, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:04:01', 'admin-1494380783-14943818413484520', 1, 0, '', NULL, NULL, NULL),
(29528, '2017-05-10 10:03:54', NULL, NULL, 9054, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1494398691', 'admin', '2017-05-10 10:03:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29529, '2017-05-10 09:44:19', NULL, NULL, 9051, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:44:19', 'admin-1494377887-14943806597221887', 1, 0, '', NULL, NULL, NULL),
(29530, '2017-05-10 09:44:36', NULL, NULL, 9051, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:44:36', 'admin-1494377887-14943806761885543', 1, 1, 'SR', NULL, NULL, NULL),
(29531, '2017-05-10 09:44:36', NULL, NULL, 9051, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:44:36', 'admin-1494377887-14943806761885543', 1, 1, 'SR', NULL, NULL, NULL),
(29532, '2017-05-10 09:44:36', NULL, NULL, 9051, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:44:36', 'admin-1494377887-14943806761885543', 1, 1, 'SR', NULL, NULL, NULL),
(29533, '2017-05-10 09:44:19', NULL, NULL, 9051, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:44:19', 'admin-1494377887-14943806597221887', 1, 0, '', NULL, NULL, NULL),
(29534, '2017-05-10 09:44:13', NULL, NULL, 9051, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:44:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29535, '2017-05-10 09:36:02', NULL, NULL, 9050, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:36:02', 'admin-1494377887-14943801622232969', 1, 0, '', NULL, NULL, NULL),
(29536, '2017-05-10 09:35:54', NULL, NULL, 9050, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:35:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29537, '2017-05-10 09:33:14', NULL, NULL, 9049, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:33:14', 'admin-1494377887-149437999470829', 1, 0, '', NULL, NULL, NULL),
(29538, '2017-05-10 09:24:16', NULL, NULL, 9048, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:24:16', 'admin-1494377887-14943794563241830', 1, 1, 'SR', NULL, NULL, NULL),
(29539, '2017-05-10 09:24:16', NULL, NULL, 9048, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:24:16', 'admin-1494377887-14943794563241830', 1, 1, 'SR', NULL, NULL, NULL),
(29540, '2017-05-10 09:24:01', NULL, NULL, 9048, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:24:01', 'admin-1494377887-14943794415112586', 1, 0, '', NULL, NULL, NULL),
(29541, '2017-05-10 09:24:01', NULL, NULL, 9048, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:24:01', 'admin-1494377887-14943794415112586', 1, 0, '', NULL, NULL, NULL),
(29542, '2017-05-10 09:16:49', NULL, NULL, 9047, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:16:49', 'admin-1494377887-14943790094792361', 1, 1, 'SR', NULL, NULL, NULL),
(29543, '2017-05-10 09:23:47', NULL, NULL, 9048, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.40, 0.0000, 0.0000, 11.40, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:23:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29544, '2017-05-10 09:16:40', NULL, NULL, 9047, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1494398691', 'admin', '2017-05-10 09:16:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29545, '2017-05-11 13:19:42', NULL, NULL, 9096, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:19:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29546, '2017-05-11 13:19:49', NULL, NULL, 9096, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:19:49', 'admin-1494479511-14944799896208647', 1, 0, '', NULL, NULL, NULL),
(29547, '2017-05-11 13:29:00', NULL, NULL, 9097, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:29:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29548, '2017-05-11 18:20:47', NULL, NULL, 9102, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 18:20:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29549, '2017-05-11 18:20:55', NULL, NULL, 9102, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 18:20:55', 'admin-1494479511-14944980548619391', 1, 1, 'SR', NULL, NULL, NULL),
(29550, '2017-05-11 13:48:59', NULL, NULL, 9095, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:48:59', 'admin-1494479511-14944817391024126', 1, 0, '', NULL, NULL, NULL),
(29551, '2017-05-11 13:50:19', NULL, NULL, 9098, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:50:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29552, '2017-05-11 13:50:26', NULL, NULL, 9098, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:50:26', 'admin-1494479511-14944818262058779', 1, 1, 'SR', NULL, NULL, NULL),
(29553, '2017-05-11 13:50:26', NULL, NULL, 9098, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:50:26', 'admin-1494479511-14944818262058779', 1, 1, 'SR', NULL, NULL, NULL),
(29554, '2017-05-11 13:50:26', NULL, NULL, 9098, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:50:26', 'admin-1494479511-14944818262058779', 1, 0, '', NULL, NULL, NULL),
(29555, '2017-05-11 13:50:26', NULL, NULL, 9098, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:50:26', 'admin-1494479511-14944818262058779', 1, 0, '', NULL, NULL, NULL),
(29556, '2017-05-11 13:29:20', NULL, NULL, 9097, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:29:20', 'admin-1494479511-1494480560449256', 1, 0, '', NULL, NULL, NULL),
(29557, '2017-05-11 13:43:44', NULL, NULL, 9097, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:43:44', 'admin-1494479511-14944814241964386', 1, 1, 'SR', NULL, NULL, NULL),
(29558, '2017-05-11 13:48:59', NULL, NULL, 9095, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:48:59', 'admin-1494479511-14944817391024126', 1, 0, '', NULL, NULL, NULL),
(29559, '2017-05-11 13:10:39', NULL, NULL, 9094, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:10:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29560, '2017-05-11 13:10:47', NULL, NULL, 9094, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:10:47', 'admin-1494473587-14944794469034864', 1, 1, 'SR', NULL, NULL, NULL),
(29561, '2017-05-11 13:10:47', NULL, NULL, 9094, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:10:47', 'admin-1494473587-14944794469034864', 1, 1, 'SR', NULL, NULL, NULL),
(29562, '2017-05-11 13:11:35', NULL, NULL, 9095, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:11:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29563, '2017-05-11 13:11:44', NULL, NULL, 9095, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:11:44', 'admin-1494473587-14944795047551878', 1, 0, '', NULL, NULL, NULL),
(29564, '2017-05-11 13:11:44', NULL, NULL, 9095, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:11:44', 'admin-1494473587-14944795047551878', 1, 0, '', NULL, NULL, NULL),
(29565, '2017-05-11 13:12:12', NULL, NULL, 9095, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:12:12', 'admin-1494479511-14944795323898669', 1, 1, 'SR', NULL, NULL, NULL),
(29566, '2017-05-11 13:12:12', NULL, NULL, 9095, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:12:12', 'admin-1494479511-14944795323898669', 1, 0, '', NULL, NULL, NULL),
(29567, '2017-05-11 13:12:12', NULL, NULL, 9095, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:12:12', 'admin-1494479511-14944795323898669', 1, 1, 'SR', NULL, NULL, NULL),
(29568, '2017-05-11 11:31:26', NULL, NULL, 9088, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.20, 0.0000, 0.0000, 10.20, 1, '27', 1, '1494479511', 'admin', '2017-05-11 11:31:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29569, '2017-05-11 11:32:59', NULL, NULL, 9088, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 11:32:59', 'admin-1494463371-14944735790359537', 1, 0, '', NULL, NULL, NULL),
(29570, '2017-05-11 11:32:59', NULL, NULL, 9088, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 11:32:59', 'admin-1494463371-14944735790359537', 1, 0, '', NULL, NULL, NULL),
(29571, '2017-05-11 17:17:12', NULL, NULL, 9100, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1494479511', 'admin', '2017-05-11 17:17:12', 'admin-1494479511-14944942320287477', 1, 0, '', NULL, NULL, NULL),
(29572, '2017-05-11 17:17:12', NULL, NULL, 9100, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 17:17:12', 'admin-1494479511-14944942320287477', 1, 1, 'SR', NULL, NULL, NULL),
(29573, '2017-05-11 11:41:30', NULL, NULL, 9089, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 11:41:30', 'admin-1494473587-14944740904633575', 1, 0, '', NULL, NULL, NULL),
(29574, '2017-05-11 11:41:30', NULL, NULL, 9089, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 11:41:30', 'admin-1494473587-14944740904633575', 1, 0, '', NULL, NULL, NULL),
(29575, '2017-05-11 11:41:30', NULL, NULL, 9089, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 11:41:30', 'admin-1494473587-14944740904633575', 1, 0, '', NULL, NULL, NULL),
(29576, '2017-05-11 11:41:39', NULL, NULL, 9089, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 11:41:39', 'admin-1494473587-14944740991979572', 1, 1, 'SR', NULL, NULL, NULL),
(29577, '2017-05-11 11:41:39', NULL, NULL, 9089, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 11:41:39', 'admin-1494473587-14944740991979572', 1, 1, 'SR', NULL, NULL, NULL),
(29578, '2017-05-11 12:04:00', NULL, NULL, 9090, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1494479511', 'admin', '2017-05-11 12:04:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29579, '2017-05-11 12:46:41', NULL, NULL, 9092, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1494479511', 'admin', '2017-05-11 12:46:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29580, '2017-05-11 12:46:51', NULL, NULL, 9092, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 12:46:51', 'admin-1494473587-14944780109699449', 1, 0, '', NULL, NULL, NULL),
(29581, '2017-05-11 12:46:51', NULL, NULL, 9092, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 12:46:51', 'admin-1494473587-14944780109699449', 1, 1, 'SR', NULL, NULL, NULL),
(29582, '2017-05-11 12:46:51', NULL, NULL, 9092, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 12:46:51', 'admin-1494473587-14944780109699449', 1, 1, 'SR', NULL, NULL, NULL),
(29583, '2017-05-11 13:06:36', NULL, NULL, 9093, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:06:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29584, '2017-05-11 13:06:40', NULL, NULL, 9093, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:06:40', 'admin-1494473587-14944791998608141', 1, 1, 'SR', NULL, NULL, NULL),
(29585, '2017-05-11 13:06:40', NULL, NULL, 9093, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:06:40', 'admin-1494473587-14944791998608141', 1, 1, 'SR', NULL, NULL, NULL),
(29586, '2017-05-11 13:10:07', NULL, NULL, 9093, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:10:07', 'admin-1494473587-14944794068573441', 1, 0, '', NULL, NULL, NULL),
(29587, '2017-05-11 13:10:07', NULL, NULL, 9093, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:10:07', 'admin-1494473587-14944794068573441', 1, 0, '', NULL, NULL, NULL),
(29588, '2017-05-11 12:04:10', NULL, NULL, 9090, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 12:04:10', 'admin-1494473587-1494475450784673', 1, 1, 'SR', NULL, NULL, NULL),
(29589, '2017-05-11 11:33:18', NULL, NULL, 9088, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 11:33:18', 'admin-1494473587-1494473598378311', 1, 1, 'SR', NULL, NULL, NULL),
(29590, '2017-05-11 17:52:48', NULL, NULL, 9101, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 17:52:48', 'admin-1494479511-14944963686092828', 1, 1, 'SR', NULL, NULL, NULL),
(29591, '2017-05-11 17:52:48', NULL, NULL, 9101, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 17:52:48', 'admin-1494479511-14944963686092828', 1, 1, 'SR', NULL, NULL, NULL),
(29592, '2017-05-11 17:52:27', NULL, NULL, 9101, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 17:52:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29593, '2017-05-11 17:17:02', NULL, NULL, 9100, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.59, 0.0000, 0.0000, 1.59, 1, '27', 1, '1494479511', 'admin', '2017-05-11 17:17:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29594, '2017-05-11 15:14:49', NULL, NULL, 9099, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 15:14:49', 'admin-1494479511-14944868896543390', 1, 1, 'SR', NULL, NULL, NULL),
(29595, '2017-05-11 15:14:47', NULL, NULL, 9099, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1494479511', 'admin', '2017-05-11 15:14:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29596, '2017-05-11 09:20:22', NULL, NULL, 9081, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 09:20:22', 'admin-1494463371-14944656219952648', 1, 0, '', NULL, NULL, NULL),
(29597, '2017-05-11 09:20:22', NULL, NULL, 9081, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 09:20:22', 'admin-1494463371-14944656219952648', 1, 0, '', NULL, NULL, NULL),
(29598, '2017-05-11 09:20:22', NULL, NULL, 9081, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 09:20:22', 'admin-1494463371-14944656219952648', 1, 1, 'SR', NULL, NULL, NULL),
(29599, '2017-05-11 10:50:17', NULL, NULL, 9086, 0, 280, '214', 'Diet Meal - Piccolo / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 10:50:17', 'admin-1494463371-14944710174615423', 1, 0, '', NULL, NULL, NULL),
(29600, '2017-05-11 13:29:20', NULL, NULL, 9097, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:29:20', 'admin-1494479511-1494480560449256', 1, 1, 'SR', NULL, NULL, NULL),
(29601, '2017-05-11 13:29:20', NULL, NULL, 9097, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 2, 9.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:29:20', 'admin-1494479511-1494480560449256', 1, 1, 'SR', NULL, NULL, NULL),
(29602, '2017-05-11 13:29:20', NULL, NULL, 9097, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:29:20', 'admin-1494479511-1494480560449256', 1, 1, 'SR', NULL, NULL, NULL),
(29603, '2017-05-11 13:12:12', NULL, NULL, 9095, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 13:12:12', 'admin-1494479511-14944795323898669', 1, 0, '', NULL, NULL, NULL),
(29604, '2017-05-11 09:33:55', NULL, NULL, 9082, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 09:33:55', 'admin-1494463371-14944664349539798', 1, 0, '', NULL, NULL, NULL),
(29605, '2017-05-11 09:33:55', NULL, NULL, 9082, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 09:33:55', 'admin-1494463371-14944664349539798', 1, 0, '', NULL, NULL, NULL),
(29606, '2017-05-11 09:33:55', NULL, NULL, 9082, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 09:33:55', 'admin-1494463371-14944664349539798', 1, 0, '', NULL, NULL, NULL),
(29607, '2017-05-11 09:33:55', NULL, NULL, 9082, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 09:33:55', 'admin-1494463371-14944664349539798', 1, 0, '', NULL, NULL, NULL),
(29608, '2017-05-11 09:34:05', NULL, NULL, 9082, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 09:34:05', 'admin-1494463371-1494466445689111', 1, 1, 'SR', NULL, NULL, NULL),
(29609, '2017-05-11 09:34:05', NULL, NULL, 9082, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 09:34:05', 'admin-1494463371-1494466445689111', 1, 1, 'SR', NULL, NULL, NULL),
(29610, '2017-05-11 09:34:05', NULL, NULL, 9082, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 09:34:05', 'admin-1494463371-1494466445689111', 1, 1, 'SR', NULL, NULL, NULL),
(29611, '2017-05-11 09:34:05', NULL, NULL, 9082, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 09:34:05', 'admin-1494463371-1494466445689111', 1, 0, '', NULL, NULL, NULL),
(29612, '2017-05-11 09:53:05', NULL, NULL, 9084, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 09:53:05', 'admin-1494463371-14944675850167856', 1, 1, 'SR', 1, NULL, NULL),
(29613, '2017-05-11 10:09:23', NULL, NULL, 9085, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1494479511', 'admin', '2017-05-11 10:09:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29614, '2017-05-11 10:12:04', NULL, NULL, 9085, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 10:12:04', 'admin-1494463371-14944687246316537', 1, 0, '', NULL, NULL, NULL),
(29615, '2017-05-11 10:12:04', NULL, NULL, 9085, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 10:12:04', 'admin-1494463371-14944687246316537', 1, 0, '', NULL, NULL, NULL),
(29616, '2017-05-11 10:12:13', NULL, NULL, 9085, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 10:12:13', 'admin-1494463371-1494468732891333', 1, 1, 'SR', NULL, NULL, NULL),
(29617, '2017-05-11 10:12:13', NULL, NULL, 9085, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 10:12:13', 'admin-1494463371-1494468732891333', 1, 1, 'SR', NULL, NULL, NULL),
(29618, '2017-05-11 10:12:39', NULL, NULL, 9085, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 10:12:39', 'admin-1494463371-14944687592958245', 1, 0, '', NULL, NULL, NULL),
(29619, '2017-05-11 12:04:10', NULL, NULL, 9090, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 12:04:10', 'admin-1494473587-1494475450784673', 1, 0, '', NULL, NULL, NULL),
(29620, '2017-05-11 12:17:03', NULL, NULL, 9091, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1494479511', 'admin', '2017-05-11 12:17:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29621, '2017-05-11 12:17:06', NULL, NULL, 9091, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 12:17:06', 'admin-1494473587-1494476226298220', 1, 1, 'SR', NULL, NULL, NULL),
(29622, '2017-05-11 12:17:06', NULL, NULL, 9091, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 12:17:06', 'admin-1494473587-1494476226298220', 1, 1, 'SR', NULL, NULL, NULL),
(29623, '2017-05-11 11:33:18', NULL, NULL, 9088, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 11:33:18', 'admin-1494473587-1494473598378311', 1, 1, 'SR', NULL, NULL, NULL),
(29624, '2017-05-11 11:41:21', NULL, NULL, 9089, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1494479511', 'admin', '2017-05-11 11:41:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29625, '2017-05-11 11:32:59', NULL, NULL, 9088, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 11:32:59', 'admin-1494463371-14944735790359537', 1, 0, '', NULL, NULL, NULL),
(29626, '2017-05-11 11:33:18', NULL, NULL, 9088, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 11:33:18', 'admin-1494473587-1494473598378311', 1, 1, 'SR', NULL, NULL, NULL),
(29627, '2017-05-11 11:24:19', NULL, NULL, 9087, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 11:24:19', 'admin-1494463371-1494473059571246', 1, 0, '', NULL, NULL, NULL),
(29628, '2017-05-11 11:24:13', NULL, NULL, 9087, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1494479511', 'admin', '2017-05-11 11:24:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29629, '2017-05-11 11:24:19', NULL, NULL, 9087, 0, 283, '217', 'Weight Gain Deal - TBP / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 11:24:19', 'admin-1494463371-1494473059571246', 1, 0, '', NULL, NULL, NULL),
(29630, '2017-05-11 10:50:10', NULL, NULL, 9086, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1494479511', 'admin', '2017-05-11 10:50:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29631, '2017-05-11 09:20:22', NULL, NULL, 9081, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 09:20:22', 'admin-1494463371-14944656219952648', 1, 1, 'SR', NULL, NULL, NULL),
(29632, '2017-05-11 09:33:39', NULL, NULL, 9082, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.10, 0.0000, 0.0000, 11.10, 1, '27', 1, '1494479511', 'admin', '2017-05-11 09:33:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29633, '2017-05-11 09:20:12', NULL, NULL, 9081, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1494479511', 'admin', '2017-05-11 09:20:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29634, '2017-05-12 14:19:01', NULL, NULL, 9126, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 14:19:01', 'admin-1494567519-14945699412155619', 1, 1, 'SR', NULL, NULL, NULL),
(29635, '2017-05-12 14:18:35', NULL, NULL, 9126, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 14:18:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29636, '2017-05-12 14:18:49', NULL, NULL, 9126, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 14:18:49', 'admin-1494567519-14945699289819437', 1, 0, '', NULL, NULL, NULL),
(29637, '2017-05-12 14:02:12', NULL, NULL, 9125, 0, 181, '116', 'Open Food ', '', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 14:02:12', 'admin-1494567519-14945689321923386', 1, 0, '', 1, NULL, NULL),
(29638, '2017-05-12 12:40:08', NULL, NULL, 9117, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:40:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29639, '2017-05-12 12:40:13', NULL, NULL, 9117, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:40:13', 'admin-1494558188-14945640132127454', 1, 0, '', NULL, NULL, NULL),
(29640, '2017-05-12 12:07:37', NULL, NULL, 9114, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:07:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29641, '2017-05-12 12:41:29', NULL, NULL, 9118, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:41:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29642, '2017-05-12 12:41:47', NULL, NULL, 9118, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:41:47', 'admin-1494564082-14945641074759660', 1, 0, '', NULL, NULL, NULL),
(29643, '2017-05-12 12:41:47', NULL, NULL, 9118, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:41:47', 'admin-1494564082-14945641074759660', 1, 1, 'SR', NULL, NULL, NULL),
(29644, '2017-05-12 12:41:47', NULL, NULL, 9118, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:41:47', 'admin-1494564082-14945641074759660', 1, 0, '', NULL, NULL, NULL),
(29645, '2017-05-12 12:41:49', NULL, NULL, 9119, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:41:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29646, '2017-05-12 12:42:05', NULL, NULL, 9119, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:42:05', 'admin-1494564082-14945641255287847', 1, 0, '', NULL, NULL, NULL),
(29647, '2017-05-12 12:42:05', NULL, NULL, 9119, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:42:05', 'admin-1494564082-14945641255287847', 1, 0, '', NULL, NULL, NULL),
(29648, '2017-05-12 12:42:05', NULL, NULL, 9119, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:42:05', 'admin-1494564082-14945641255287847', 1, 1, 'SR', NULL, NULL, NULL),
(29649, '2017-05-12 12:42:05', NULL, NULL, 9119, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:42:05', 'admin-1494564082-14945641255287847', 1, 0, '', NULL, NULL, NULL),
(29650, '2017-05-12 12:42:05', NULL, NULL, 9119, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:42:05', 'admin-1494564082-14945641255287847', 1, 1, 'SR', NULL, NULL, NULL),
(29651, '2017-05-12 13:13:47', NULL, NULL, 9121, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.60, 0.0000, 0.0000, 11.60, 1, '27', 1, '1494567519', 'admin', '2017-05-12 13:13:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29652, '2017-05-12 13:13:58', NULL, NULL, 9121, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 13:13:58', 'admin-1494564082-1494566038686604', 1, 1, 'SR', NULL, NULL, NULL),
(29653, '2017-05-12 13:53:49', NULL, NULL, 9121, 0, 181, '116', 'Open Food ', 'Scone Promo', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 13:53:49', 'admin-1494567519-14945684287419731', 1, 0, '', NULL, NULL, NULL),
(29654, '2017-05-12 13:14:05', NULL, NULL, 9121, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 13:14:05', 'admin-1494564082-1494566045059412', 1, 0, '', NULL, NULL, NULL),
(29655, '2017-05-12 13:27:53', NULL, NULL, 9122, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1494567519', 'admin', '2017-05-12 13:27:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29656, '2017-05-12 13:27:58', NULL, NULL, 9122, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 13:27:58', 'admin-1494564082-14945668783591845', 1, 0, '', NULL, NULL, NULL),
(29657, '2017-05-12 13:29:32', NULL, NULL, 9122, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 13:29:32', 'admin-1494564082-14945669726427122', 1, 1, 'SR', NULL, NULL, NULL),
(29658, '2017-05-12 14:18:49', NULL, NULL, 9126, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 14:18:49', 'admin-1494567519-14945699289819437', 1, 1, 'SR', NULL, NULL, NULL),
(29659, '2017-05-12 13:45:43', NULL, NULL, 9123, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 13:45:43', 'admin-1494567519-14945679432265247', 1, 1, 'SR', NULL, NULL, NULL),
(29660, '2017-05-12 13:38:28', NULL, NULL, 9123, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 13:38:28', 'admin-1494564082-1494567508364566', 1, 1, 'SR', NULL, NULL, NULL),
(29661, '2017-05-12 13:38:28', NULL, NULL, 9123, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 13:38:28', 'admin-1494564082-1494567508364566', 1, 1, 'SR', NULL, NULL, NULL),
(29662, '2017-05-12 13:38:28', NULL, NULL, 9123, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 13:38:28', 'admin-1494564082-1494567508364566', 1, 0, '', NULL, NULL, NULL),
(29663, '2017-05-12 16:49:21', NULL, NULL, 9132, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 16:49:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29664, '2017-05-12 16:48:44', NULL, NULL, 9131, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1494567519', 'admin', '2017-05-12 16:48:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29665, '2017-05-12 15:48:50', NULL, NULL, 9129, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 15:48:50', 'admin-1494567519-14945753301593065', 1, 1, 'SR', 1, NULL, NULL),
(29666, '2017-05-12 15:49:04', NULL, NULL, 9130, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1494567519', 'admin', '2017-05-12 15:49:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29667, '2017-05-12 11:13:02', NULL, NULL, 9109, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 11:13:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29668, '2017-05-12 11:13:08', NULL, NULL, 9109, 0, 283, '217', 'Weight Gain Deal - TBP / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 11:13:08', 'admin-1494558188-14945587882241999', 1, 0, '', NULL, NULL, NULL),
(29669, '2017-05-12 11:13:08', NULL, NULL, 9109, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 11:13:08', 'admin-1494558188-14945587882241999', 1, 0, '', NULL, NULL, NULL),
(29670, '2017-05-12 11:25:18', NULL, NULL, 9110, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1494567519', 'admin', '2017-05-12 11:25:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29671, '2017-05-12 13:13:58', NULL, NULL, 9121, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 13:13:58', 'admin-1494564082-1494566038686604', 1, 1, 'SR', NULL, NULL, NULL),
(29672, '2017-05-12 13:38:28', NULL, NULL, 9123, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 3, 12.00, 36.0000, 0.0000, 36.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 13:38:28', 'admin-1494564082-1494567508364566', 1, 1, 'SR', NULL, NULL, NULL),
(29673, '2017-05-12 11:33:09', NULL, NULL, 9111, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1494567519', 'admin', '2017-05-12 11:33:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29674, '2017-05-12 11:33:13', NULL, NULL, 9111, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 11:33:13', 'admin-1494558188-14945599937086071', 1, 0, '', NULL, NULL, NULL),
(29675, '2017-05-12 11:33:13', NULL, NULL, 9111, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 11:33:13', 'admin-1494558188-14945599937086071', 1, 1, 'SR', NULL, NULL, NULL),
(29676, '2017-05-12 11:51:20', NULL, NULL, 9112, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1494567519', 'admin', '2017-05-12 11:51:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29677, '2017-05-12 11:51:26', NULL, NULL, 9112, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 11:51:26', 'admin-1494558188-14945610865764499', 1, 0, '', NULL, NULL, NULL),
(29678, '2017-05-12 11:51:26', NULL, NULL, 9112, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 11:51:26', 'admin-1494558188-14945610865764499', 1, 0, '', NULL, NULL, NULL),
(29679, '2017-05-12 00:00:00', NULL, NULL, 9132, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 16:48:36', 'admin-1494567519-14945789165315679', 1, 0, '', NULL, NULL, NULL),
(29680, '2017-05-12 00:00:00', NULL, NULL, 9132, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 15:29:35', 'admin-1494567519-14945741754477864', 1, 1, 'SR', NULL, NULL, NULL),
(29681, '2017-05-12 00:00:00', NULL, NULL, 9131, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 15:29:35', 'admin-1494567519-14945741754477864', 1, 1, 'SR', NULL, NULL, NULL),
(29682, '2017-05-12 00:00:00', NULL, NULL, 9131, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 16:48:36', 'admin-1494567519-14945789165315679', 1, 0, '', NULL, NULL, NULL),
(29683, '2017-05-12 15:49:08', NULL, NULL, 9130, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 15:49:08', 'admin-1494567519-14945753485558991', 1, 1, 'SR', NULL, NULL, NULL),
(29684, '2017-05-12 15:00:18', NULL, NULL, 9127, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 15:00:18', 'admin-1494567519-14945724181968852', 1, 0, '', NULL, NULL, NULL),
(29685, '2017-05-12 15:00:18', NULL, NULL, 9127, 0, 181, '116', 'Open Food ', 'Less spicy', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 15:00:18', 'admin-1494567519-14945724181968852', 1, 0, '', NULL, NULL, NULL),
(29686, '2017-05-12 15:00:18', NULL, NULL, 9127, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 15:00:18', 'admin-1494567519-14945724181968852', 1, 1, 'SR', NULL, NULL, NULL),
(29687, '2017-05-12 15:00:02', NULL, NULL, 9127, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1494567519', 'admin', '2017-05-12 15:00:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29688, '2017-05-12 14:19:01', NULL, NULL, 9126, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 14:19:01', 'admin-1494567519-14945699412155619', 1, 0, '', NULL, NULL, NULL),
(29689, '2017-05-12 14:02:12', NULL, NULL, 9125, 0, 181, '116', 'Open Food ', 'scone promo', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 14:02:12', 'admin-1494567519-14945689321923386', 1, 0, '', 1, NULL, NULL),
(29690, '2017-05-12 11:51:35', NULL, NULL, 9112, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 11:51:35', 'admin-1494558188-14945610957116853', 1, 1, 'SR', NULL, NULL, NULL),
(29691, '2017-05-12 11:25:24', NULL, NULL, 9110, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 11:25:24', 'admin-1494558188-14945595240521669', 1, 1, 'SR', NULL, NULL, NULL),
(29692, '2017-05-12 11:03:02', NULL, NULL, 9107, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 11:03:02', 'admin-1494551748-14945581825354768', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(29693, '2017-05-12 11:03:02', NULL, NULL, 9107, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 11:03:02', 'admin-1494551748-14945581825354768', 1, 0, '', NULL, NULL, NULL),
(29694, '2017-05-12 11:12:26', NULL, NULL, 9108, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1494567519', 'admin', '2017-05-12 11:12:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29695, '2017-05-12 11:12:34', NULL, NULL, 9108, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 11:12:34', 'admin-1494558188-14945587541856418', 1, 0, '', NULL, NULL, NULL),
(29696, '2017-05-12 11:12:34', NULL, NULL, 9108, 0, 283, '217', 'Weight Gain Deal - TBP / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 11:12:34', 'admin-1494558188-14945587541856418', 1, 0, '', NULL, NULL, NULL),
(29697, '2017-05-12 13:38:14', NULL, NULL, 9123, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1494567519', 'admin', '2017-05-12 13:38:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29698, '2017-05-12 13:33:01', NULL, NULL, 9122, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 13:33:01', 'admin-1494564082-14945671811565629', 1, 1, 'SR', NULL, NULL, NULL),
(29699, '2017-05-12 11:25:24', NULL, NULL, 9110, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 11:25:24', 'admin-1494558188-14945595240521669', 1, 0, '', NULL, NULL, NULL),
(29700, '2017-05-12 13:13:58', NULL, NULL, 9121, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 13:13:58', 'admin-1494564082-1494566038686604', 1, 0, '', NULL, NULL, NULL),
(29701, '2017-05-12 13:14:05', NULL, NULL, 9121, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 13:14:05', 'admin-1494564082-1494566045059412', 1, 1, 'SR', NULL, NULL, NULL),
(29702, '2017-05-12 13:13:58', NULL, NULL, 9121, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 13:13:58', 'admin-1494564082-1494566038686604', 1, 0, '', NULL, NULL, NULL),
(29703, '2017-05-12 13:11:48', NULL, NULL, 9120, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 13:11:48', 'admin-1494564082-1494565908469319', 1, 1, 'SR', NULL, NULL, NULL),
(29704, '2017-05-12 12:55:40', NULL, NULL, 9119, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:55:40', 'admin-1494564082-1494564940282323', 1, 1, 'SR', NULL, NULL, NULL),
(29705, '2017-05-12 13:11:44', NULL, NULL, 9120, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1494567519', 'admin', '2017-05-12 13:11:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29706, '2017-05-12 12:49:48', NULL, NULL, 9119, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:49:48', 'admin-1494564082-1494564588580683', 1, 1, 'SR', NULL, NULL, NULL),
(29707, '2017-05-12 12:42:05', NULL, NULL, 9119, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:42:05', 'admin-1494564082-14945641255287847', 1, 1, 'SR', NULL, NULL, NULL),
(29708, '2017-05-12 12:42:05', NULL, NULL, 9119, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:42:05', 'admin-1494564082-14945641255287847', 1, 1, 'SR', NULL, NULL, NULL),
(29709, '2017-05-12 09:50:09', NULL, NULL, 9104, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 09:50:09', 'admin-1494551748-14945538092425141', 1, 0, '', NULL, NULL, NULL),
(29710, '2017-05-12 09:50:09', NULL, NULL, 9104, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 09:50:09', 'admin-1494551748-14945538092425141', 1, 0, '', NULL, NULL, NULL),
(29711, '2017-05-12 09:50:54', NULL, NULL, 9104, 0, 283, '217', 'Weight Gain Deal - TBP / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 09:50:54', 'admin-1494551748-14945538539145232', 1, 0, '', NULL, NULL, NULL),
(29712, '2017-05-12 10:12:43', NULL, NULL, 9105, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1494567519', 'admin', '2017-05-12 10:12:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29713, '2017-05-12 10:12:53', NULL, NULL, 9105, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 10:12:53', 'admin-1494551748-14945551733337194', 1, 0, '', NULL, NULL, NULL),
(29714, '2017-05-12 10:12:53', NULL, NULL, 9105, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 10:12:53', 'admin-1494551748-14945551733337194', 1, 0, '', NULL, NULL, NULL),
(29715, '2017-05-12 10:12:53', NULL, NULL, 9105, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 10:12:53', 'admin-1494551748-14945551733337194', 1, 0, '', NULL, NULL, NULL),
(29716, '2017-05-12 10:13:23', NULL, NULL, 9105, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 10:13:23', 'admin-1494551748-14945552030938898', 1, 1, 'SR', NULL, NULL, NULL),
(29717, '2017-05-12 10:13:28', NULL, NULL, 9106, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1494567519', 'admin', '2017-05-12 10:13:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29718, '2017-05-12 09:38:29', NULL, NULL, 9103, 0, 279, '213', 'Diet Meal - Americano / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 09:38:29', 'admin-1494551748-14945531094094183', 1, 0, '', NULL, NULL, NULL),
(29719, '2017-05-12 12:34:14', NULL, NULL, 9116, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:34:14', 'admin-1494558188-14945636548128897', 1, 0, '', NULL, NULL, NULL),
(29720, '2017-05-12 12:34:14', NULL, NULL, 9116, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:34:14', 'admin-1494558188-14945636548128897', 1, 1, 'SR', NULL, NULL, NULL),
(29721, '2017-05-12 12:34:07', NULL, NULL, 9116, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:34:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29722, '2017-05-12 12:26:33', NULL, NULL, 9115, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:26:33', 'admin-1494558188-14945631936741575', 1, 1, 'SR', NULL, NULL, NULL),
(29723, '2017-05-12 12:26:33', NULL, NULL, 9115, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:26:33', 'admin-1494558188-14945631936741575', 1, 1, 'SR', NULL, NULL, NULL),
(29724, '2017-05-12 12:26:25', NULL, NULL, 9115, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:26:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29725, '2017-05-12 12:18:34', NULL, NULL, 9109, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:18:34', 'admin-1494558188-14945627148244462', 1, 0, '', NULL, NULL, NULL),
(29726, '2017-05-12 12:07:55', NULL, NULL, 9114, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:07:55', 'admin-1494558188-14945620753959514', 1, 1, 'SR', NULL, NULL, NULL),
(29727, '2017-05-12 12:07:55', NULL, NULL, 9114, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:07:55', 'admin-1494558188-14945620753959514', 1, 1, 'SR', NULL, NULL, NULL),
(29728, '2017-05-12 13:13:58', NULL, NULL, 9121, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 13:13:59', 'admin-1494564082-1494566038686604', 1, 0, '', NULL, NULL, NULL),
(29729, '2017-05-12 13:13:58', NULL, NULL, 9121, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 13:13:58', 'admin-1494564082-1494566038686604', 1, 0, '', NULL, NULL, NULL),
(29730, '2017-05-12 12:07:46', NULL, NULL, 9114, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:07:46', 'admin-1494558188-14945620660105074', 1, 0, '', NULL, NULL, NULL),
(29731, '2017-05-12 12:07:46', NULL, NULL, 9114, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:07:46', 'admin-1494558188-14945620660105074', 1, 0, '', NULL, NULL, NULL),
(29732, '2017-05-12 12:05:58', NULL, NULL, 9113, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:05:58', 'admin-1494558188-14945619580906438', 1, 1, 'SR', NULL, NULL, NULL),
(29733, '2017-05-12 12:05:54', NULL, NULL, 9113, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1494567519', 'admin', '2017-05-12 12:05:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29734, '2017-05-12 11:51:35', NULL, NULL, 9112, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 11:51:35', 'admin-1494558188-14945610957116853', 1, 1, 'SR', NULL, NULL, NULL),
(29735, '2017-05-12 11:25:24', NULL, NULL, 9110, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 11:25:24', 'admin-1494558188-14945595240521669', 1, 0, '', NULL, NULL, NULL),
(29736, '2017-05-12 10:13:35', NULL, NULL, 9106, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 10:13:35', 'admin-1494551748-14945552158013018', 1, 1, 'SR', NULL, NULL, NULL),
(29737, '2017-05-12 11:02:58', NULL, NULL, 9107, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1494567519', 'admin', '2017-05-12 11:02:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29738, '2017-05-12 09:49:35', NULL, NULL, 9104, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1494567519', 'admin', '2017-05-12 09:49:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29739, '2017-05-12 09:39:21', NULL, NULL, 9103, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 09:39:21', 'admin-1494551748-14945531612821328', 1, 0, '', NULL, NULL, NULL),
(29740, '2017-05-12 09:38:29', NULL, NULL, 9103, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494567519', 'admin', '2017-05-12 09:38:29', 'admin-1494551748-14945531094094183', 1, 0, '', NULL, NULL, NULL),
(29741, '2017-05-12 09:38:15', NULL, NULL, 9103, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1494567519', 'admin', '2017-05-12 09:38:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29742, '2017-05-13 13:01:11', NULL, NULL, 9162, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:01:11', 'admin-1494650176-14946516708214148', 1, 1, 'SR', NULL, NULL, NULL),
(29743, '2017-05-13 13:01:33', NULL, NULL, 9162, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:01:33', 'admin-1494650176-14946516938085592', 1, 1, 'SR', NULL, NULL, NULL),
(29744, '2017-05-13 11:59:41', NULL, NULL, 9158, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:59:41', 'admin-1494646186-1494647980925497', 1, 1, 'SR', NULL, NULL, NULL),
(29745, '2017-05-13 00:00:00', NULL, NULL, 9167, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, NULL, NULL, 2.10, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:55:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29746, '2017-05-13 13:20:19', NULL, NULL, 9168, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:20:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29747, '2017-05-13 00:00:00', NULL, NULL, 9164, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:59:12', 'admin-1494644339-1494644352683369', 1, 1, 'SR', NULL, NULL, NULL),
(29748, '2017-05-13 00:00:00', NULL, NULL, 9164, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 12:03:11', 'admin-1494646186-1494648191771922', 1, 0, '', NULL, NULL, NULL),
(29749, '2017-05-13 11:59:41', NULL, NULL, 9158, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:59:41', 'admin-1494646186-1494647980925497', 1, 0, '', NULL, NULL, NULL),
(29750, '2017-05-13 11:59:41', NULL, NULL, 9158, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:59:41', 'admin-1494646186-1494647980925497', 1, 0, '', NULL, NULL, NULL),
(29751, '2017-05-13 00:00:00', NULL, NULL, 9165, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:59:12', 'admin-1494644339-1494644352683369', 1, 1, 'SR', NULL, NULL, NULL),
(29752, '2017-05-13 10:43:18', NULL, NULL, 9143, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:43:18', 'admin-1494641902-1494643398373309', 1, 1, 'SR', NULL, NULL, NULL),
(29753, '2017-05-13 10:52:44', NULL, NULL, 9144, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:52:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29754, '2017-05-13 10:52:50', NULL, NULL, 9144, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:52:50', 'admin-1494641902-14946439702867046', 1, 0, '', NULL, NULL, NULL),
(29755, '2017-05-13 10:04:02', NULL, NULL, 9138, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:04:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29756, '2017-05-13 13:55:24', NULL, NULL, 9171, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:55:24', 'admin-1494650176-14946549246786021', 1, 1, 'SR', NULL, NULL, NULL),
(29757, '2017-05-13 11:17:52', NULL, NULL, 9148, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:17:52', 'admin-1494644569-14946454724053013', 1, 1, 'SR', NULL, NULL, NULL),
(29758, '2017-05-13 11:19:57', NULL, NULL, 9149, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:19:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29759, '2017-05-13 11:20:16', NULL, NULL, 9149, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:20:16', 'admin-1494644569-14946456163723072', 1, 0, '', NULL, NULL, NULL),
(29760, '2017-05-13 11:20:16', NULL, NULL, 9149, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:20:16', 'admin-1494644569-14946456163723072', 1, 1, 'SR', NULL, NULL, NULL),
(29761, '2017-05-13 11:56:32', NULL, NULL, 9155, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:56:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29762, '2017-05-13 11:21:30', NULL, NULL, 9151, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:21:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29763, '2017-05-13 11:21:44', NULL, NULL, 9151, 0, 153, '87', 'Wake Me Up!', 'no beans', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:21:44', 'admin-1494644569-14946457044304355', 1, 0, '', NULL, NULL, NULL),
(29764, '2017-05-13 11:21:44', NULL, NULL, 9151, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:21:44', 'admin-1494644569-14946457044304355', 1, 0, '', NULL, NULL, NULL),
(29765, '2017-05-13 11:21:54', NULL, NULL, 9151, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:21:54', 'admin-1494644569-1494645714652408', 1, 1, 'SR', NULL, NULL, NULL),
(29766, '2017-05-13 11:21:54', NULL, NULL, 9151, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:21:54', 'admin-1494644569-1494645714652408', 1, 1, 'SR', NULL, NULL, NULL),
(29767, '2017-05-13 11:37:05', NULL, NULL, 9154, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:37:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29768, '2017-05-13 11:37:29', NULL, NULL, 9154, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:37:29', 'admin-1494646186-149464664957544', 1, 1, 'SR', NULL, NULL, NULL),
(29769, '2017-05-13 11:29:51', NULL, NULL, 9152, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:29:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29770, '2017-05-13 13:52:27', NULL, NULL, 9170, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:52:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29771, '2017-05-13 13:30:33', NULL, NULL, 9169, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:30:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29772, '2017-05-13 13:30:50', NULL, NULL, 9169, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:30:50', 'admin-1494650176-14946534499761360', 1, 1, 'SR', NULL, NULL, NULL),
(29773, '2017-05-13 13:30:50', NULL, NULL, 9169, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:30:50', 'admin-1494650176-14946534499761360', 1, 0, '', NULL, NULL, NULL),
(29774, '2017-05-13 17:00:05', NULL, NULL, 9178, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 17:00:05', 'admin-1494650176-14946660051381969', 1, 1, 'SR', 1, NULL, NULL),
(29775, '2017-05-13 16:21:47', NULL, NULL, 9177, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 16:21:47', 'admin-1494650176-1494663707582116', 1, 1, 'SR', NULL, NULL, NULL),
(29776, '2017-05-13 16:21:47', NULL, NULL, 9177, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 16:21:47', 'admin-1494650176-1494663707582116', 1, 1, 'SR', NULL, NULL, NULL),
(29777, '2017-05-13 16:21:42', NULL, NULL, 9177, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1494650176', 'admin', '2017-05-13 16:21:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29778, '2017-05-13 16:21:39', NULL, NULL, 9176, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 16:21:39', 'admin-1494650176-14946636996879417', 1, 0, '', NULL, NULL, NULL),
(29779, '2017-05-13 16:21:39', NULL, NULL, 9176, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 16:21:39', 'admin-1494650176-14946636996879417', 1, 1, 'SR', NULL, NULL, NULL),
(29780, '2017-05-13 00:00:00', NULL, NULL, 9167, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 12:03:11', 'admin-1494646186-1494648191771922', 1, 0, '', NULL, NULL, NULL),
(29781, '2017-05-13 13:23:24', NULL, NULL, 9168, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:23:24', 'admin-1494650176-14946530040216465', 1, 0, '', NULL, NULL, NULL),
(29782, '2017-05-13 13:25:56', NULL, NULL, 9168, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:25:56', 'admin-1494650176-14946531567882191', 1, 0, '', NULL, NULL, NULL),
(29783, '2017-05-13 00:00:00', NULL, NULL, 9164, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 12:03:11', 'admin-1494646186-1494648191771922', 1, 1, 'SR', NULL, NULL, NULL),
(29784, '2017-05-13 00:00:00', NULL, NULL, 9165, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:58:41', 'admin-1494641902-14946443211407196', 1, 0, '', NULL, NULL, NULL),
(29785, '2017-05-13 10:53:01', NULL, NULL, 9144, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:53:01', 'admin-1494641902-14946439811989787', 1, 1, 'SR', NULL, NULL, NULL),
(29786, '2017-05-13 10:53:01', NULL, NULL, 9144, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:53:01', 'admin-1494641902-14946439811989787', 1, 1, 'SR', NULL, NULL, NULL),
(29787, '2017-05-13 13:09:10', NULL, NULL, 9166, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:09:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29788, '2017-05-13 13:08:01', NULL, NULL, 9164, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:08:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29789, '2017-05-13 00:00:00', NULL, NULL, 9163, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:59:12', 'admin-1494644339-1494644352683369', 1, 1, 'SR', NULL, NULL, NULL),
(29790, '2017-05-13 00:00:00', NULL, NULL, 9163, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, NULL, NULL, 6.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:00:01', 'admin-1494644339-14946444008856451', 1, 1, 'SR', NULL, NULL, NULL),
(29791, '2017-05-13 14:25:05', NULL, NULL, 9175, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 14:25:05', 'admin-1494650176-14946567051331582', 1, 1, 'SR', NULL, NULL, NULL),
(29792, '2017-05-13 13:47:49', NULL, NULL, 9160, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:47:49', 'admin-1494650176-14946544691535076', 1, 0, '', NULL, NULL, NULL),
(29793, '2017-05-13 13:07:24', NULL, NULL, 9163, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:07:24', 'admin-1494650176-14946520438119494', 1, 0, '', NULL, NULL, NULL),
(29794, '2017-05-13 16:21:32', NULL, NULL, 9176, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1494650176', 'admin', '2017-05-13 16:21:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29795, '2017-05-13 14:25:05', NULL, NULL, 9175, 0, 153, '87', 'Wake Me Up!', 'No bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 14:25:05', 'admin-1494650176-14946567051331582', 1, 0, '', NULL, NULL, NULL),
(29796, '2017-05-13 14:21:39', NULL, NULL, 9172, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 14:21:39', 'admin-1494650176-14946564988218287', 1, 0, '', NULL, NULL, NULL),
(29797, '2017-05-13 14:21:39', NULL, NULL, 9172, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 14:21:39', 'admin-1494650176-14946564988218287', 1, 1, 'SR', NULL, NULL, NULL),
(29798, '2017-05-13 14:18:45', NULL, NULL, 9175, 0, 181, '116', 'Open Food ', 'Bff', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 14:18:45', 'admin-1494650176-14946563254506916', 1, 0, '', NULL, NULL, NULL),
(29799, '2017-05-13 14:18:45', NULL, NULL, 9175, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 14:18:45', 'admin-1494650176-14946563254506916', 1, 0, '', NULL, NULL, NULL),
(29800, '2017-05-13 14:17:43', NULL, NULL, 9174, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 14:17:43', 'admin-1494650176-14946562635739524', 1, 0, '', NULL, NULL, NULL),
(29801, '2017-05-13 14:17:43', NULL, NULL, 9174, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 14:17:43', 'admin-1494650176-14946562635739524', 1, 0, '', NULL, NULL, NULL),
(29802, '2017-05-13 14:17:39', NULL, NULL, 9174, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1494650176', 'admin', '2017-05-13 14:17:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29803, '2017-05-13 14:16:45', NULL, NULL, 9173, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 14:16:45', 'admin-1494650176-14946562050067639', 1, 1, 'SR', NULL, NULL, NULL),
(29804, '2017-05-13 14:16:45', NULL, NULL, 9173, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 14:16:45', 'admin-1494650176-14946562050067639', 1, 0, '', NULL, NULL, NULL),
(29805, '2017-05-13 14:16:36', NULL, NULL, 9173, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1494650176', 'admin', '2017-05-13 14:16:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29806, '2017-05-13 13:56:50', NULL, NULL, 9172, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:56:50', 'admin-1494650176-14946550106523487', 1, 1, 'SR', NULL, NULL, NULL),
(29807, '2017-05-13 14:25:09', NULL, NULL, 9175, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 14:25:09', 'admin-1494650176-14946567096679768', 1, 1, 'SR', NULL, NULL, NULL),
(29808, '2017-05-13 13:56:47', NULL, NULL, 9172, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:56:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29809, '2017-05-13 14:25:05', NULL, NULL, 9175, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 14:25:05', 'admin-1494650176-14946567051331582', 1, 1, 'SR', NULL, NULL, NULL),
(29810, '2017-05-13 11:03:11', NULL, NULL, 9146, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:03:11', 'admin-1494644569-14946445913172290', 1, 1, 'SR', NULL, NULL, NULL),
(29811, '2017-05-13 11:16:18', NULL, NULL, 9147, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:16:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29812, '2017-05-13 11:16:22', NULL, NULL, 9147, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:16:22', 'admin-1494644569-14946453828183483', 1, 0, '', NULL, NULL, NULL),
(29813, '2017-05-13 11:16:23', NULL, NULL, 9147, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:16:23', 'admin-1494644569-14946453828183483', 1, 0, '', NULL, NULL, NULL),
(29814, '2017-05-13 11:16:30', NULL, NULL, 9147, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:16:30', 'admin-1494644569-14946453900089795', 1, 1, 'SR', NULL, NULL, NULL),
(29815, '2017-05-13 11:16:30', NULL, NULL, 9147, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:16:30', 'admin-1494644569-14946453900089795', 1, 1, 'SR', NULL, NULL, NULL),
(29816, '2017-05-13 00:00:00', NULL, NULL, 9163, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:59:12', 'admin-1494644339-1494644352683369', 1, 1, 'SR', NULL, NULL, NULL),
(29817, '2017-05-13 13:07:08', NULL, NULL, 9163, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:07:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29818, '2017-05-13 11:56:36', NULL, NULL, 9155, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:56:36', 'admin-1494646186-14946477965183173', 1, 1, 'SR', NULL, NULL, NULL),
(29819, '2017-05-13 11:57:31', NULL, NULL, 9156, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:57:31', 'admin-1494646186-14946478514262451', 1, 0, '', 1, NULL, NULL),
(29820, '2017-05-13 13:55:21', NULL, NULL, 9171, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:55:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29821, '2017-05-13 13:52:34', NULL, NULL, 9170, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:52:34', 'admin-1494650176-14946547542464972', 1, 1, 'SR', NULL, NULL, NULL),
(29822, '2017-05-13 13:52:34', NULL, NULL, 9170, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:52:34', 'admin-1494650176-14946547542464972', 1, 0, '', NULL, NULL, NULL),
(29823, '2017-05-13 11:58:04', NULL, NULL, 9157, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:58:04', 'admin-1494646186-1494647884383354', 1, 0, '', NULL, NULL, NULL),
(29824, '2017-05-13 11:58:04', NULL, NULL, 9157, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:58:04', 'admin-1494646186-1494647884383354', 1, 1, 'SR', NULL, NULL, NULL),
(29825, '2017-05-13 11:58:04', NULL, NULL, 9157, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:58:04', 'admin-1494646186-1494647884383354', 1, 1, 'SR', NULL, NULL, NULL),
(29826, '2017-05-13 17:02:58', NULL, NULL, 9179, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 17:02:58', 'admin-1494650176-14946661785987378', 1, 1, 'SR', NULL, NULL, NULL),
(29827, '2017-05-13 18:00:57', NULL, NULL, 9180, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1494650176', 'admin', '2017-05-13 18:00:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29828, '2017-05-13 18:01:11', NULL, NULL, 9180, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 18:01:11', 'admin-1494650176-14946696710991893', 1, 0, '', NULL, NULL, NULL),
(29829, '2017-05-13 18:01:11', NULL, NULL, 9180, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 18:01:11', 'admin-1494650176-14946696710991893', 1, 1, 'SR', NULL, NULL, NULL),
(29830, '2017-05-13 18:01:11', NULL, NULL, 9180, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 18:01:11', 'admin-1494650176-14946696710991893', 1, 1, 'SR', NULL, NULL, NULL),
(29831, '2017-05-13 18:12:33', NULL, NULL, 9183, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 18:12:33', 'admin-1494650176-14946703529945180', 1, 0, '', 1, NULL, NULL),
(29832, '2017-05-13 18:03:35', NULL, NULL, 9181, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 18:03:35', 'admin-1494650176-14946698150692123', 1, 1, 'SR', NULL, NULL, NULL),
(29833, '2017-05-13 18:03:31', NULL, NULL, 9181, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1494650176', 'admin', '2017-05-13 18:03:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29834, '2017-05-13 14:25:05', NULL, NULL, 9175, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 14:25:05', 'admin-1494650176-14946567051331582', 1, 0, '', NULL, NULL, NULL),
(29835, '2017-05-13 13:30:59', NULL, NULL, 9169, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:30:59', 'admin-1494650176-1494653459625906', 1, 0, '', NULL, NULL, NULL),
(29836, '2017-05-13 13:30:50', NULL, NULL, 9169, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:30:50', 'admin-1494650176-14946534499761360', 1, 0, '', NULL, NULL, NULL),
(29837, '2017-05-13 13:23:24', NULL, NULL, 9168, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:23:24', 'admin-1494650176-14946530040216465', 1, 1, 'SR', NULL, NULL, NULL),
(29838, '2017-05-13 12:55:08', NULL, NULL, 9162, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 12:55:08', 'admin-1494650176-14946513086077598', 1, 0, '', NULL, NULL, NULL),
(29839, '2017-05-13 12:55:08', NULL, NULL, 9162, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 12:55:08', 'admin-1494650176-14946513086077598', 1, 0, '', NULL, NULL, NULL),
(29840, '2017-05-13 12:55:08', NULL, NULL, 9162, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 12:55:08', 'admin-1494650176-14946513086077598', 1, 0, '', NULL, NULL, NULL),
(29841, '2017-05-13 12:55:14', NULL, NULL, 9162, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 12:55:14', 'admin-1494650176-14946513138522620', 1, 1, 'SR', NULL, NULL, NULL),
(29842, '2017-05-13 13:01:11', NULL, NULL, 9162, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:01:11', 'admin-1494650176-14946516708214148', 1, 1, 'SR', NULL, NULL, NULL),
(29843, '2017-05-13 13:01:11', NULL, NULL, 9162, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:01:11', 'admin-1494650176-14946516708214148', 1, 0, '', NULL, NULL, NULL),
(29844, '2017-05-13 13:01:11', NULL, NULL, 9162, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:01:11', 'admin-1494650176-14946516708214148', 1, 0, '', NULL, NULL, NULL),
(29845, '2017-05-13 13:01:11', NULL, NULL, 9162, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:01:11', 'admin-1494650176-14946516708214148', 1, 0, '', NULL, NULL, NULL),
(29846, '2017-05-13 00:00:00', NULL, NULL, 9166, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:59:12', 'admin-1494644339-1494644352683369', 1, 1, 'SR', NULL, NULL, NULL),
(29847, '2017-05-13 13:01:34', NULL, NULL, 9162, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:01:34', 'admin-1494650176-14946516938085592', 1, 1, 'SR', NULL, NULL, NULL),
(29848, '2017-05-13 13:01:34', NULL, NULL, 9162, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:01:34', 'admin-1494650176-14946516938085592', 1, 1, 'SR', NULL, NULL, NULL),
(29849, '2017-05-13 11:57:49', NULL, NULL, 9157, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:57:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29850, '2017-05-13 11:57:31', NULL, NULL, 9156, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:57:31', 'admin-1494646186-14946478514262451', 1, 0, '', 1, NULL, NULL),
(29851, '2017-05-13 11:57:31', NULL, NULL, 9156, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:57:31', 'admin-1494646186-14946478514262451', 1, 0, '', 1, NULL, NULL),
(29852, '2017-05-13 00:00:00', NULL, NULL, 9163, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 12:08:30', 'admin-1494646186-14946485099307615', 1, 1, 'SR', NULL, NULL, NULL),
(29853, '2017-05-13 13:01:34', NULL, NULL, 9162, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:01:34', 'admin-1494650176-14946516938085592', 1, 1, 'SR', NULL, NULL, NULL),
(29854, '2017-05-13 13:01:11', NULL, NULL, 9162, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:01:11', 'admin-1494650176-14946516708214148', 1, 0, '', NULL, NULL, NULL),
(29855, '2017-05-13 13:32:50', NULL, NULL, 9169, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:32:50', 'admin-1494650176-14946535701274628', 1, 1, 'SR', NULL, NULL, NULL),
(29856, '2017-05-13 12:55:02', NULL, NULL, 9162, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 20.80, 0.0000, 0.0000, 20.80, 1, '27', 1, '1494650176', 'admin', '2017-05-13 12:55:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29857, '2017-05-13 12:50:54', NULL, NULL, 9161, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 12:50:54', 'admin-1494650176-14946510539282735', 1, 1, 'SR', NULL, NULL, NULL),
(29858, '2017-05-13 12:50:51', NULL, NULL, 9161, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1494650176', 'admin', '2017-05-13 12:50:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29859, '2017-05-13 11:56:36', NULL, NULL, 9155, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:56:36', 'admin-1494646186-14946477965183173', 1, 1, 'SR', NULL, NULL, NULL),
(29860, '2017-05-13 09:35:38', NULL, NULL, 9135, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:35:38', 'admin-1494637345-14946393384655384', 1, 1, 'SR', NULL, NULL, NULL),
(29861, '2017-05-13 11:37:29', NULL, NULL, 9154, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:37:29', 'admin-1494646186-149464664957544', 1, 0, '', NULL, NULL, NULL),
(29862, '2017-05-13 11:37:29', NULL, NULL, 9154, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:37:29', 'admin-1494646186-149464664957544', 1, 0, '', NULL, NULL, NULL),
(29863, '2017-05-13 00:00:00', NULL, NULL, 9164, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:59:12', 'admin-1494644339-1494644352683369', 1, 1, 'SR', NULL, NULL, NULL),
(29864, '2017-05-13 00:00:00', NULL, NULL, 9163, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:58:41', 'admin-1494641902-14946443211407196', 1, 0, '', NULL, NULL, NULL),
(29865, '2017-05-13 11:02:43', NULL, NULL, 9146, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:02:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29866, '2017-05-13 11:03:11', NULL, NULL, 9146, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:03:11', 'admin-1494644569-14946445913172290', 1, 0, '', NULL, NULL, NULL),
(29867, '2017-05-13 12:36:09', NULL, NULL, 9160, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 12:36:09', 'admin-1494646186-14946501689947779', 1, 0, '', NULL, NULL, NULL),
(29868, '2017-05-13 12:33:08', NULL, NULL, 9160, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 12:33:08', 'admin-1494646186-14946499878093940', 1, 1, 'SR', NULL, NULL, NULL),
(29869, '2017-05-13 12:33:08', NULL, NULL, 9160, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 12:33:08', 'admin-1494646186-14946499878093940', 1, 1, 'SR', NULL, NULL, NULL),
(29870, '2017-05-13 13:34:10', NULL, NULL, 9162, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:34:10', 'admin-1494650176-14946536500959653', 1, 1, 'SR', NULL, NULL, NULL),
(29871, '2017-05-13 00:00:00', NULL, NULL, 9163, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:58:41', 'admin-1494641902-14946443211407196', 1, 0, '', NULL, NULL, NULL),
(29872, '2017-05-13 12:21:42', NULL, NULL, 9148, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 12:21:42', 'admin-1494646186-14946493027801935', 1, 1, 'SR', NULL, NULL, NULL),
(29873, '2017-05-13 12:29:30', NULL, NULL, 9159, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 12:29:30', 'admin-1494646186-14946497700818146', 1, 1, 'SR', 1, NULL, NULL),
(29874, '2017-05-13 12:32:57', NULL, NULL, 9160, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 12:32:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29875, '2017-05-13 12:33:01', NULL, NULL, 9160, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 12:33:01', 'admin-1494646186-14946499814743797', 1, 0, '', NULL, NULL, NULL),
(29876, '2017-05-13 11:59:41', NULL, NULL, 9158, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:59:41', 'admin-1494646186-1494647980925497', 1, 0, '', NULL, NULL, NULL),
(29877, '2017-05-13 11:37:29', NULL, NULL, 9154, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:37:29', 'admin-1494646186-149464664957544', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(29878, '2017-05-13 11:30:54', NULL, NULL, 9153, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:30:54', 'admin-1494646186-14946462545664470', 1, 1, 'SR', NULL, NULL, NULL),
(29879, '2017-05-13 11:30:54', NULL, NULL, 9153, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:30:54', 'admin-1494646186-14946462545664470', 1, 0, '', NULL, NULL, NULL),
(29880, '2017-05-13 11:30:54', NULL, NULL, 9153, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:30:54', 'admin-1494646186-14946462545664470', 1, 0, '', NULL, NULL, NULL),
(29881, '2017-05-13 11:29:56', NULL, NULL, 9152, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:29:56', 'admin-1494646186-14946461965784984', 1, 1, 'SR', NULL, NULL, NULL),
(29882, '2017-05-13 11:29:56', NULL, NULL, 9152, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:29:56', 'admin-1494646186-14946461965784984', 1, 1, 'SR', NULL, NULL, NULL),
(29883, '2017-05-13 11:30:47', NULL, NULL, 9153, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:30:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29884, '2017-05-13 11:17:52', NULL, NULL, 9148, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:17:52', 'admin-1494644569-14946454724053013', 1, 0, '', NULL, NULL, NULL),
(29885, '2017-05-13 11:17:52', NULL, NULL, 9148, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:17:52', 'admin-1494644569-14946454724053013', 1, 0, '', NULL, NULL, NULL),
(29886, '2017-05-13 11:17:52', NULL, NULL, 9148, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:17:52', 'admin-1494644569-14946454724053013', 1, 0, '', NULL, NULL, NULL),
(29887, '2017-05-13 00:00:00', NULL, NULL, 9164, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:58:41', 'admin-1494641902-14946443211407196', 1, 0, '', NULL, NULL, NULL),
(29888, '2017-05-13 11:59:28', NULL, NULL, 9158, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:59:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29889, '2017-05-13 11:17:43', NULL, NULL, 9148, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:17:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29890, '2017-05-13 17:02:56', NULL, NULL, 9179, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1494650176', 'admin', '2017-05-13 17:02:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29891, '2017-05-13 13:52:34', NULL, NULL, 9170, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:52:34', 'admin-1494650176-14946547542464972', 1, 0, '', NULL, NULL, NULL),
(29892, '2017-05-13 11:03:11', NULL, NULL, 9146, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:03:11', 'admin-1494644569-14946445913172290', 1, 1, 'SR', NULL, NULL, NULL),
(29893, '2017-05-13 11:03:11', NULL, NULL, 9146, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 11:03:11', 'admin-1494644569-14946445913172290', 1, 0, '', NULL, NULL, NULL),
(29894, '2017-05-13 09:35:38', NULL, NULL, 9135, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:35:38', 'admin-1494637345-14946393384655384', 1, 0, '', NULL, NULL, NULL),
(29895, '2017-05-13 09:44:58', NULL, NULL, 9136, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.70, 0.0000, 0.0000, 13.70, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:44:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29896, '2017-05-13 09:45:10', NULL, NULL, 9136, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:45:10', 'admin-1494637345-14946399105354635', 1, 0, '', NULL, NULL, NULL),
(29897, '2017-05-13 09:45:10', NULL, NULL, 9136, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:45:10', 'admin-1494637345-14946399105354635', 1, 0, '', NULL, NULL, NULL),
(29898, '2017-05-13 09:45:10', NULL, NULL, 9136, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:45:10', 'admin-1494637345-14946399105354635', 1, 0, '', NULL, NULL, NULL),
(29899, '2017-05-13 09:45:10', NULL, NULL, 9136, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:45:10', 'admin-1494637345-14946399105354635', 1, 0, '', NULL, NULL, NULL),
(29900, '2017-05-13 09:45:10', NULL, NULL, 9136, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:45:10', 'admin-1494637345-14946399105354635', 1, 0, '', NULL, NULL, NULL),
(29901, '2017-05-13 09:45:26', NULL, NULL, 9136, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:45:26', 'admin-1494637345-14946399266322263', 1, 1, 'SR', NULL, NULL, NULL),
(29902, '2017-05-13 09:45:26', NULL, NULL, 9136, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:45:26', 'admin-1494637345-14946399266322263', 1, 1, 'SR', NULL, NULL, NULL),
(29903, '2017-05-13 09:45:26', NULL, NULL, 9136, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:45:26', 'admin-1494637345-14946399266322263', 1, 1, 'SR', NULL, NULL, NULL),
(29904, '2017-05-13 09:45:26', NULL, NULL, 9136, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:45:26', 'admin-1494637345-14946399266322263', 1, 1, 'SR', NULL, NULL, NULL),
(29905, '2017-05-13 13:08:36', NULL, NULL, 9165, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1494650176', 'admin', '2017-05-13 13:08:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29906, '2017-05-13 00:00:00', NULL, NULL, 9166, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:56:02', 'admin-1494641902-14946441621365895', 1, 0, '', NULL, NULL, NULL),
(29907, '2017-05-13 10:53:01', NULL, NULL, 9144, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:53:01', 'admin-1494641902-14946439811989787', 1, 0, '', NULL, NULL, NULL),
(29908, '2017-05-13 10:17:58', NULL, NULL, 9140, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:17:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29909, '2017-05-13 10:18:07', NULL, NULL, 9140, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:18:07', 'admin-1494637345-14946418875753173', 1, 0, '', NULL, NULL, NULL),
(29910, '2017-05-13 10:18:07', NULL, NULL, 9140, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:18:07', 'admin-1494637345-14946418875753173', 1, 1, 'SR', NULL, NULL, NULL),
(29911, '2017-05-13 10:27:32', NULL, NULL, 9141, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:27:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29912, '2017-05-13 10:27:50', NULL, NULL, 9141, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:27:50', 'admin-1494641902-14946424700962997', 1, 0, '', NULL, NULL, NULL),
(29913, '2017-05-13 10:27:50', NULL, NULL, 9141, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:27:50', 'admin-1494641902-14946424700962997', 1, 0, '', NULL, NULL, NULL),
(29914, '2017-05-13 10:27:50', NULL, NULL, 9141, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:27:50', 'admin-1494641902-14946424700962997', 1, 0, '', NULL, NULL, NULL),
(29915, '2017-05-13 10:27:50', NULL, NULL, 9141, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:27:50', 'admin-1494641902-14946424700962997', 1, 0, '', NULL, NULL, NULL),
(29916, '2017-05-13 10:27:50', NULL, NULL, 9141, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:27:50', 'admin-1494641902-14946424700962997', 1, 0, '', NULL, NULL, NULL),
(29917, '2017-05-13 10:27:50', NULL, NULL, 9141, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:27:50', 'admin-1494641902-14946424700962997', 1, 1, 'SR', NULL, NULL, NULL),
(29918, '2017-05-13 10:36:17', NULL, NULL, 9142, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:36:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29919, '2017-05-13 10:36:24', NULL, NULL, 9142, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:36:24', 'admin-1494641902-1494642984003517', 1, 0, '', NULL, NULL, NULL),
(29920, '2017-05-13 10:36:24', NULL, NULL, 9142, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:36:24', 'admin-1494641902-1494642984003517', 1, 0, '', NULL, NULL, NULL),
(29921, '2017-05-13 10:36:34', NULL, NULL, 9142, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:36:34', 'admin-1494641902-14946429939539595', 1, 1, 'SR', NULL, NULL, NULL),
(29922, '2017-05-13 10:36:34', NULL, NULL, 9142, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:36:34', 'admin-1494641902-14946429939539595', 1, 1, 'SR', NULL, NULL, NULL),
(29923, '2017-05-13 10:39:52', NULL, NULL, 9143, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:39:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29924, '2017-05-13 10:39:58', NULL, NULL, 9143, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:39:58', 'admin-1494641902-14946431980979696', 1, 0, '', NULL, NULL, NULL),
(29925, '2017-05-13 10:39:58', NULL, NULL, 9143, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:39:58', 'admin-1494641902-14946431980979696', 1, 1, 'SR', NULL, NULL, NULL),
(29926, '2017-05-13 10:43:13', NULL, NULL, 9143, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:43:13', 'admin-1494641902-14946433931818134', 1, 0, '', NULL, NULL, NULL),
(29927, '2017-05-13 09:57:30', NULL, NULL, 9137, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:57:30', 'admin-1494637345-14946406502316570', 1, 0, '', NULL, NULL, NULL),
(29928, '2017-05-13 10:10:10', NULL, NULL, 9136, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:10:10', 'admin-1494637345-14946414102571011', 1, 0, '', NULL, NULL, NULL),
(29929, '2017-05-13 10:05:35', NULL, NULL, 9139, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:05:35', 'admin-1494637345-14946411352939594', 1, 1, 'SR', NULL, NULL, NULL),
(29930, '2017-05-13 10:04:32', NULL, NULL, 9139, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:04:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29931, '2017-05-13 10:04:42', NULL, NULL, 9139, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:04:42', 'admin-1494637345-14946410817128644', 1, 0, '', NULL, NULL, NULL),
(29932, '2017-05-13 10:05:35', NULL, NULL, 9139, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:05:35', 'admin-1494637345-14946411352939594', 1, 1, 'SR', NULL, NULL, NULL),
(29933, '2017-05-13 10:04:42', NULL, NULL, 9139, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:04:42', 'admin-1494637345-14946410817128644', 1, 0, '', NULL, NULL, NULL),
(29934, '2017-05-13 10:04:05', NULL, NULL, 9138, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:04:05', 'admin-1494637345-14946410450342296', 1, 1, 'SR', NULL, NULL, NULL),
(29935, '2017-05-13 10:04:05', NULL, NULL, 9138, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 10:04:05', 'admin-1494637345-14946410450342296', 1, 1, 'SR', NULL, NULL, NULL),
(29936, '2017-05-13 09:57:30', NULL, NULL, 9137, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:57:30', 'admin-1494637345-14946406502316570', 1, 1, 'SR', NULL, NULL, NULL),
(29937, '2017-05-13 09:57:30', NULL, NULL, 9137, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:57:30', 'admin-1494637345-14946406502316570', 1, 1, 'SR', NULL, NULL, NULL),
(29938, '2017-05-13 09:57:30', NULL, NULL, 9137, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:57:30', 'admin-1494637345-14946406502316570', 1, 0, '', NULL, NULL, NULL),
(29939, '2017-05-13 09:57:30', NULL, NULL, 9137, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:57:30', 'admin-1494637345-14946406502316570', 1, 0, '', NULL, NULL, NULL),
(29940, '2017-05-13 09:55:49', NULL, NULL, 9137, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:55:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29941, '2017-05-13 09:57:30', NULL, NULL, 9137, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:57:30', 'admin-1494637345-14946406502316570', 1, 1, 'SR', NULL, NULL, NULL),
(29942, '2017-05-13 09:22:09', NULL, NULL, 9134, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:22:09', 'admin-1494637345-14946385296544999', 1, 0, '', NULL, NULL, NULL),
(29943, '2017-05-13 09:35:31', NULL, NULL, 9135, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:35:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29944, '2017-05-13 09:21:48', NULL, NULL, 9134, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:21:48', 'admin-1494637345-14946385081622986', 1, 0, '', NULL, NULL, NULL),
(29945, '2017-05-13 09:22:09', NULL, NULL, 9134, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:22:09', 'admin-1494637345-14946385296544999', 1, 0, '', NULL, NULL, NULL),
(29946, '2017-05-13 09:21:43', NULL, NULL, 9134, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1494650176', 'admin', '2017-05-13 09:21:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29947, '2017-05-14 12:53:19', NULL, NULL, 9216, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:53:19', 'admin-1494734357-14947375995081493', 1, 1, 'SR', NULL, NULL, NULL),
(29948, '2017-05-14 17:38:22', NULL, NULL, 9232, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 17:38:22', 'admin-1494741275-14947547021868233', 1, 1, 'SR', NULL, NULL, NULL),
(29949, '2017-05-14 17:16:18', NULL, NULL, 9231, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1494741275', 'admin', '2017-05-14 17:16:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29950, '2017-05-14 17:16:21', NULL, NULL, 9231, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 17:16:21', 'admin-1494741275-14947533817921365', 1, 0, '', NULL, NULL, NULL),
(29951, '2017-05-14 15:41:03', NULL, NULL, 9227, 0, 77, '77', 'Sarawak Kolomee', 'add 1 fried egg', 'Meals', 'Perfect Meals', 1, 13.50, 13.5000, 0.0000, 13.50, 1, '27', 1, '1494741275', 'admin', '2017-05-14 15:41:03', 'admin-1494741275-14947476628344887', 1, 1, 'SR', NULL, NULL, NULL),
(29952, '2017-05-14 12:41:05', NULL, NULL, 9215, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', 'Add rice', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:41:05', 'admin-1494734357-14947368651883462', 1, 1, 'SR', NULL, NULL, NULL),
(29953, '2017-05-14 12:41:05', NULL, NULL, 9215, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', 'Add rice', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:41:05', 'admin-1494734357-14947368651883462', 1, 1, 'SR', NULL, NULL, NULL),
(29954, '2017-05-14 12:41:05', NULL, NULL, 9215, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:41:05', 'admin-1494734357-14947368651883462', 1, 0, '', NULL, NULL, NULL),
(29955, '2017-05-14 11:24:52', NULL, NULL, 9196, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:24:52', 'admin-1494730264-14947322924498562', 1, 1, 'SR', NULL, NULL, NULL),
(29956, '2017-05-14 11:25:32', NULL, NULL, 9199, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:25:32', 'admin-1494730264-14947323321121813', 1, 0, '', NULL, NULL, NULL),
(29957, '2017-05-14 11:25:32', NULL, NULL, 9199, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:25:32', 'admin-1494730264-14947323321121813', 1, 0, '', NULL, NULL, NULL),
(29958, '2017-05-14 11:25:32', NULL, NULL, 9199, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:25:32', 'admin-1494730264-14947323321121813', 1, 0, '', NULL, NULL, NULL),
(29959, '2017-05-14 12:40:07', NULL, NULL, 9196, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:40:07', 'admin-1494734357-14947368069366689', 1, 0, '', NULL, NULL, NULL),
(29960, '2017-05-14 12:39:21', NULL, NULL, 9196, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:39:21', 'admin-1494734357-14947367612166327', 1, 0, '', NULL, NULL, NULL),
(29961, '2017-05-14 10:51:22', NULL, NULL, 9196, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:51:22', 'admin-1494730264-14947302822107475', 1, 1, 'SR', NULL, NULL, NULL),
(29962, '2017-05-14 10:51:22', NULL, NULL, 9196, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:51:22', 'admin-1494730264-14947302822107475', 1, 0, '', NULL, NULL, NULL),
(29963, '2017-05-14 10:01:56', NULL, NULL, 9191, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:01:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29964, '2017-05-14 10:02:27', NULL, NULL, 9191, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:02:27', 'admin-1494723283-14947273474557977', 1, 0, '', NULL, NULL, NULL),
(29965, '2017-05-14 10:00:48', NULL, NULL, 9190, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:00:48', 'admin-1494723283-1494727248666807', 1, 1, 'SR', NULL, NULL, NULL),
(29966, '2017-05-14 12:39:10', NULL, NULL, 9215, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.20, 0.0000, 0.0000, 11.20, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:39:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29967, '2017-05-14 09:47:04', NULL, NULL, 9186, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:47:04', 'admin-1494723283-1494726424254882', 1, 1, 'SR', NULL, NULL, NULL),
(29968, '2017-05-14 16:11:53', NULL, NULL, 9228, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 16:11:53', 'admin-1494741275-14947495135585263', 1, 1, 'SR', NULL, NULL, NULL),
(29969, '2017-05-14 16:12:24', NULL, NULL, 9228, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 16:12:24', 'admin-1494741275-14947495440688461', 1, 0, '', NULL, NULL, NULL),
(29970, '2017-05-14 14:20:51', NULL, NULL, 9226, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 14:20:51', 'admin-1494741275-14947428509316272', 1, 0, '', NULL, NULL, NULL),
(29971, '2017-05-14 15:40:44', NULL, NULL, 9227, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1494741275', 'admin', '2017-05-14 15:40:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29972, '2017-05-14 14:17:27', NULL, NULL, 9225, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 14:17:27', 'admin-1494741275-14947426474892354', 1, 0, '', NULL, NULL, NULL),
(29973, '2017-05-14 14:17:49', NULL, NULL, 9220, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 14:17:49', 'admin-1494741275-14947426691637778', 1, 1, 'SR', NULL, NULL, NULL),
(29974, '2017-05-14 14:20:30', NULL, NULL, 9226, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1494741275', 'admin', '2017-05-14 14:20:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29975, '2017-05-14 17:12:02', NULL, NULL, 9230, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1494741275', 'admin', '2017-05-14 17:12:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29976, '2017-05-14 17:12:42', NULL, NULL, 9230, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 17:12:42', 'admin-1494741275-14947531626963256', 1, 1, 'SR', NULL, NULL, NULL),
(29977, '2017-05-14 17:12:42', NULL, NULL, 9230, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 17:12:42', 'admin-1494741275-14947531626963256', 1, 1, 'SR', NULL, NULL, NULL),
(29978, '2017-05-14 13:37:52', NULL, NULL, 9220, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:37:52', 'admin-1494738059-14947402720205435', 1, 1, 'SR', NULL, NULL, NULL),
(29979, '2017-05-14 11:51:50', NULL, NULL, 9205, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:51:50', 'admin-1494732521-14947339100218820', 1, 0, '', NULL, NULL, NULL),
(29980, '2017-05-14 10:02:27', NULL, NULL, 9191, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:02:27', 'admin-1494723283-14947273474557977', 1, 1, 'SR', NULL, NULL, NULL),
(29981, '2017-05-14 12:39:04', NULL, NULL, 9214, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:39:04', 'admin-1494734357-14947367442829814', 1, 1, 'SR', NULL, NULL, NULL),
(29982, '2017-05-14 12:39:04', NULL, NULL, 9214, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:39:04', 'admin-1494734357-14947367442829814', 1, 0, '', NULL, NULL, NULL),
(29983, '2017-05-14 12:38:51', NULL, NULL, 9214, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:38:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29984, '2017-05-14 12:34:54', NULL, NULL, 9213, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:34:54', 'admin-1494734357-14947364942392831', 1, 0, '', NULL, NULL, NULL),
(29985, '2017-05-14 12:34:54', NULL, NULL, 9213, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:34:54', 'admin-1494734357-14947364942392831', 1, 1, 'SR', NULL, NULL, NULL),
(29986, '2017-05-14 12:34:54', NULL, NULL, 9213, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:34:54', 'admin-1494734357-14947364942392831', 1, 0, '', NULL, NULL, NULL),
(29987, '2017-05-14 12:34:54', NULL, NULL, 9213, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:34:54', 'admin-1494734357-14947364942392831', 1, 0, '', NULL, NULL, NULL),
(29988, '2017-05-14 12:34:54', NULL, NULL, 9213, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:34:54', 'admin-1494734357-14947364942392831', 1, 0, '', NULL, NULL, NULL),
(29989, '2017-05-14 12:34:54', NULL, NULL, 9213, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:34:54', 'admin-1494734357-14947364942392831', 1, 0, '', NULL, NULL, NULL),
(29990, '2017-05-14 16:48:39', NULL, NULL, 9229, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 16:48:39', 'admin-1494741275-14947517188956813', 1, 1, 'SR', NULL, NULL, NULL),
(29991, '2017-05-14 16:48:39', NULL, NULL, 9229, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 16:48:39', 'admin-1494741275-14947517188956813', 1, 1, 'SR', NULL, NULL, NULL),
(29992, '2017-05-14 16:48:32', NULL, NULL, 9229, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1494741275', 'admin', '2017-05-14 16:48:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29993, '2017-05-14 16:12:24', NULL, NULL, 9228, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 16:12:24', 'admin-1494741275-14947495440688461', 1, 1, 'SR', NULL, NULL, NULL),
(29994, '2017-05-14 16:10:35', NULL, NULL, 9228, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1494741275', 'admin', '2017-05-14 16:10:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29995, '2017-05-14 12:53:19', NULL, NULL, 9216, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:53:19', 'admin-1494734357-14947375995081493', 1, 0, '', NULL, NULL, NULL),
(29996, '2017-05-14 13:57:18', NULL, NULL, 9223, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:57:18', 'admin-1494741275-14947414380905130', 1, 0, '', 1, NULL, NULL),
(29997, '2017-05-14 14:06:27', NULL, NULL, 9224, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1494741275', 'admin', '2017-05-14 14:06:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(29998, '2017-05-14 14:06:32', NULL, NULL, 9224, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 14:06:32', 'admin-1494741275-14947419924168464', 1, 0, '', NULL, NULL, NULL),
(29999, '2017-05-14 14:06:32', NULL, NULL, 9224, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 14:06:32', 'admin-1494741275-14947419924168464', 1, 0, '', NULL, NULL, NULL),
(30000, '2017-05-14 14:17:02', NULL, NULL, 9215, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 14:17:02', 'admin-1494741275-14947426221916398', 1, 0, '', NULL, NULL, NULL),
(30001, '2017-05-14 14:17:14', NULL, NULL, 9225, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1494741275', 'admin', '2017-05-14 14:17:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30002, '2017-05-14 14:17:27', NULL, NULL, 9225, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 14:17:27', 'admin-1494741275-14947426474892354', 1, 1, 'SR', NULL, NULL, NULL),
(30003, '2017-05-14 14:17:27', NULL, NULL, 9225, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 14:17:27', 'admin-1494741275-14947426474892354', 1, 1, 'SR', NULL, NULL, NULL),
(30004, '2017-05-14 16:10:20', NULL, NULL, 9227, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 16:10:20', 'admin-1494741275-1494749419822567', 1, 1, 'SR', NULL, NULL, NULL),
(30005, '2017-05-14 15:53:17', NULL, NULL, 9227, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 15:53:17', 'admin-1494741275-14947483974418297', 1, 1, 'SR', NULL, NULL, NULL),
(30006, '2017-05-14 13:54:21', NULL, NULL, 9222, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:54:21', 'admin-1494738059-1494741261257491', 1, 1, 'SR', NULL, NULL, NULL),
(30007, '2017-05-14 13:54:04', NULL, NULL, 9222, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:54:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30008, '2017-05-14 13:54:21', NULL, NULL, 9222, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:54:21', 'admin-1494738059-1494741261257491', 1, 1, 'SR', NULL, NULL, NULL),
(30009, '2017-05-14 13:54:21', NULL, NULL, 9222, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:54:21', 'admin-1494738059-1494741261257491', 1, 1, 'SR', NULL, NULL, NULL),
(30010, '2017-05-14 13:54:21', NULL, NULL, 9222, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:54:21', 'admin-1494738059-1494741261257491', 1, 1, 'SR', NULL, NULL, NULL),
(30011, '2017-05-14 13:39:27', NULL, NULL, 9221, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:39:27', 'admin-1494738059-14947403672988157', 1, 1, 'SR', NULL, NULL, NULL),
(30012, '2017-05-14 13:39:27', NULL, NULL, 9221, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:39:27', 'admin-1494738059-14947403672988157', 1, 0, '', NULL, NULL, NULL),
(30013, '2017-05-14 13:52:57', NULL, NULL, 9213, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:52:57', 'admin-1494738059-1494741176808397', 1, 0, '', NULL, NULL, NULL),
(30014, '2017-05-14 11:44:59', NULL, NULL, 9194, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:44:59', 'admin-1494732521-14947334995795983', 1, 0, '', NULL, NULL, NULL),
(30015, '2017-05-14 11:47:11', NULL, NULL, 9196, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:47:11', 'admin-1494732521-14947336309546713', 1, 0, '', NULL, NULL, NULL),
(30016, '2017-05-14 11:47:18', NULL, NULL, 9196, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:47:18', 'admin-1494732521-14947336384076335', 1, 1, 'SR', NULL, NULL, NULL),
(30017, '2017-05-14 17:12:42', NULL, NULL, 9230, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 17:12:42', 'admin-1494741275-14947531626963256', 1, 1, 'SR', NULL, NULL, NULL),
(30018, '2017-05-14 13:39:27', NULL, NULL, 9221, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:39:27', 'admin-1494738059-14947403672988157', 1, 0, '', NULL, NULL, NULL),
(30019, '2017-05-14 14:20:51', NULL, NULL, 9226, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 14:20:51', 'admin-1494741275-14947428509316272', 1, 0, '', NULL, NULL, NULL),
(30020, '2017-05-14 14:30:23', NULL, NULL, 9226, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 14:30:23', 'admin-1494741275-14947434227961666', 1, 0, '', NULL, NULL, NULL),
(30021, '2017-05-14 14:20:51', NULL, NULL, 9226, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 14:20:51', 'admin-1494741275-14947428509316272', 1, 1, 'SR', NULL, NULL, NULL),
(30022, '2017-05-14 13:37:52', NULL, NULL, 9220, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:37:52', 'admin-1494738059-14947402720205435', 1, 1, 'SR', NULL, NULL, NULL),
(30023, '2017-05-14 13:39:14', NULL, NULL, 9221, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:39:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30024, '2017-05-14 13:39:27', NULL, NULL, 9221, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:39:27', 'admin-1494738059-14947403672988157', 1, 0, '', NULL, NULL, NULL),
(30025, '2017-05-14 13:31:04', NULL, NULL, 9220, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:31:04', 'admin-1494738059-14947398641942565', 1, 1, 'SR', NULL, NULL, NULL),
(30026, '2017-05-14 12:34:30', NULL, NULL, 9213, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.70, 0.0000, 0.0000, 11.70, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:34:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30027, '2017-05-14 12:33:52', NULL, NULL, 9212, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:33:52', 'admin-1494734357-1494736432195358', 1, 1, 'SR', NULL, NULL, NULL),
(30028, '2017-05-14 12:33:47', NULL, NULL, 9212, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:33:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30029, '2017-05-14 12:17:12', NULL, NULL, 9211, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:17:12', 'admin-1494734357-14947354324637895', 1, 1, 'SR', NULL, NULL, NULL),
(30030, '2017-05-14 12:17:12', NULL, NULL, 9211, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:17:12', 'admin-1494734357-14947354324637895', 1, 1, 'SR', NULL, NULL, NULL),
(30031, '2017-05-14 10:51:22', NULL, NULL, 9196, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:51:22', 'admin-1494730264-14947302822107475', 1, 0, '', NULL, NULL, NULL),
(30032, '2017-05-14 10:32:38', NULL, NULL, 9195, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:32:38', 'admin-1494727581-14947291581232631', 1, 1, 'SR', NULL, NULL, NULL),
(30033, '2017-05-14 10:06:28', NULL, NULL, 9192, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:06:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30034, '2017-05-14 10:06:32', NULL, NULL, 9192, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:06:32', 'admin-1494727581-149472759239897', 1, 1, 'SR', NULL, NULL, NULL),
(30035, '2017-05-14 10:07:26', NULL, NULL, 9188, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:07:26', 'admin-1494727581-14947276463514850', 1, 0, '', NULL, NULL, NULL),
(30036, '2017-05-14 10:07:26', NULL, NULL, 9188, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:07:26', 'admin-1494727581-14947276463514850', 1, 0, '', NULL, NULL, NULL),
(30037, '2017-05-14 10:24:55', NULL, NULL, 9193, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:24:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30038, '2017-05-14 10:02:27', NULL, NULL, 9191, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:02:27', 'admin-1494723283-14947273474557977', 1, 1, 'SR', NULL, NULL, NULL),
(30039, '2017-05-14 10:02:44', NULL, NULL, 9191, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:02:44', 'admin-1494723283-14947273639737771', 1, 1, 'SR', NULL, NULL, NULL),
(30040, '2017-05-14 10:06:15', NULL, NULL, 9191, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:06:15', 'admin-1494723283-14947275757238940', 1, 0, '', NULL, NULL, NULL),
(30041, '2017-05-14 12:17:12', NULL, NULL, 9211, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:17:12', 'admin-1494734357-14947354324637895', 1, 0, '', NULL, NULL, NULL),
(30042, '2017-05-14 12:17:12', NULL, NULL, 9211, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:17:12', 'admin-1494734357-14947354324637895', 1, 0, '', NULL, NULL, NULL),
(30043, '2017-05-14 12:17:12', NULL, NULL, 9211, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:17:12', 'admin-1494734357-14947354324637895', 1, 0, '', NULL, NULL, NULL),
(30044, '2017-05-14 12:17:12', NULL, NULL, 9211, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:17:12', 'admin-1494734357-14947354324637895', 1, 1, 'SR', NULL, NULL, NULL),
(30045, '2017-05-14 12:17:12', NULL, NULL, 9211, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:17:12', 'admin-1494734357-14947354324637895', 1, 1, 'SR', NULL, NULL, NULL),
(30046, '2017-05-14 12:53:19', NULL, NULL, 9216, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:53:19', 'admin-1494734357-14947375995081493', 1, 0, '', NULL, NULL, NULL),
(30047, '2017-05-14 13:05:46', NULL, NULL, 9210, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:05:46', 'admin-1494738059-14947383459599845', 1, 0, '', NULL, NULL, NULL),
(30048, '2017-05-14 12:52:56', NULL, NULL, 9216, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:52:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30049, '2017-05-14 13:37:32', NULL, NULL, 9220, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:37:32', 'admin-1494738059-14947402526852417', 1, 0, '', NULL, NULL, NULL),
(30050, '2017-05-14 13:37:32', NULL, NULL, 9220, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:37:32', 'admin-1494738059-14947402526852417', 1, 1, 'SR', NULL, NULL, NULL),
(30051, '2017-05-14 13:24:28', NULL, NULL, 9219, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:24:28', 'admin-1494738059-14947394687091841', 1, 1, 'SR', NULL, NULL, NULL),
(30052, '2017-05-14 13:24:28', NULL, NULL, 9219, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:24:28', 'admin-1494738059-14947394687091841', 1, 1, 'SR', NULL, NULL, NULL),
(30053, '2017-05-14 13:27:07', NULL, NULL, 9215, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:27:07', 'admin-1494738059-14947396276982339', 1, 1, 'SR', NULL, NULL, NULL),
(30054, '2017-05-14 12:16:55', NULL, NULL, 9210, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:16:55', 'admin-1494734357-14947354148694197', 1, 1, 'SR', NULL, NULL, NULL),
(30055, '2017-05-14 12:16:55', NULL, NULL, 9210, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:16:55', 'admin-1494734357-14947354148694197', 1, 1, 'SR', NULL, NULL, NULL),
(30056, '2017-05-14 10:32:38', NULL, NULL, 9195, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:32:38', 'admin-1494727581-14947291581232631', 1, 1, 'SR', NULL, NULL, NULL),
(30057, '2017-05-14 10:32:38', NULL, NULL, 9195, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:32:38', 'admin-1494727581-14947291581232631', 1, 1, 'SR', NULL, NULL, NULL),
(30058, '2017-05-14 13:01:14', NULL, NULL, 9218, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:01:14', 'admin-1494738059-14947380738162445', 1, 0, '', NULL, NULL, NULL),
(30059, '2017-05-14 13:00:46', NULL, NULL, 9218, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:00:46', 'admin-1494734357-14947380461371616', 1, 1, 'SR', NULL, NULL, NULL),
(30060, '2017-05-14 12:57:51', NULL, NULL, 9217, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:57:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30061, '2017-05-14 12:58:10', NULL, NULL, 9217, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:58:10', 'admin-1494734357-14947378903605876', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(30062, '2017-05-14 12:58:10', NULL, NULL, 9217, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:58:10', 'admin-1494734357-14947378903605876', 1, 1, 'SR', NULL, NULL, NULL),
(30063, '2017-05-14 12:58:10', NULL, NULL, 9217, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:58:10', 'admin-1494734357-14947378903605876', 1, 0, '', NULL, NULL, NULL),
(30064, '2017-05-14 13:00:25', NULL, NULL, 9217, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:00:25', 'admin-1494734357-14947380251637313', 1, 0, '', NULL, NULL, NULL),
(30065, '2017-05-14 11:51:09', NULL, NULL, 9204, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:51:09', 'admin-1494732521-14947338696701848', 1, 0, '', NULL, NULL, NULL),
(30066, '2017-05-14 12:16:58', NULL, NULL, 9211, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:16:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30067, '2017-05-14 12:16:55', NULL, NULL, 9210, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:16:55', 'admin-1494734357-14947354148694197', 1, 0, '', NULL, NULL, NULL),
(30068, '2017-05-14 12:16:55', NULL, NULL, 9210, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:16:55', 'admin-1494734357-14947354148694197', 1, 1, 'SR', NULL, NULL, NULL),
(30069, '2017-05-14 12:04:49', NULL, NULL, 9209, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:04:49', 'admin-1494734357-14947346890016132', 1, 0, '', NULL, NULL, NULL),
(30070, '2017-05-14 12:16:37', NULL, NULL, 9210, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:16:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30071, '2017-05-14 12:04:49', NULL, NULL, 9209, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:04:49', 'admin-1494734357-14947346890016132', 1, 0, '', NULL, NULL, NULL),
(30072, '2017-05-14 12:04:49', NULL, NULL, 9209, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:04:49', 'admin-1494734357-14947346890016132', 1, 1, 'SR', NULL, NULL, NULL),
(30073, '2017-05-14 12:04:29', NULL, NULL, 9209, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:04:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30074, '2017-05-14 12:04:49', NULL, NULL, 9209, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:04:49', 'admin-1494734357-14947346890016132', 1, 0, '', NULL, NULL, NULL),
(30075, '2017-05-14 12:00:18', NULL, NULL, 9208, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:00:18', 'admin-1494734357-14947344178707118', 1, 1, 'SR', NULL, NULL, NULL),
(30076, '2017-05-14 13:28:53', NULL, NULL, 9219, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:28:53', 'admin-1494738059-14947397334118447', 1, 0, '', NULL, NULL, NULL),
(30077, '2017-05-14 13:30:52', NULL, NULL, 9220, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:30:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30078, '2017-05-14 13:31:04', NULL, NULL, 9220, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:31:04', 'admin-1494738059-14947398641942565', 1, 0, '', NULL, NULL, NULL),
(30079, '2017-05-14 13:13:15', NULL, NULL, 9217, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:13:15', 'admin-1494738059-1494738794956738', 1, 0, '', NULL, NULL, NULL),
(30080, '2017-05-14 13:24:15', NULL, NULL, 9219, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:24:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30081, '2017-05-14 13:27:07', NULL, NULL, 9215, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:27:07', 'admin-1494738059-14947396276982339', 1, 0, '', NULL, NULL, NULL),
(30082, '2017-05-14 13:28:53', NULL, NULL, 9219, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:28:53', 'admin-1494738059-14947397334118447', 1, 1, 'SR', NULL, NULL, NULL),
(30083, '2017-05-14 12:00:18', NULL, NULL, 9208, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:00:18', 'admin-1494734357-14947344178707118', 1, 1, 'SR', NULL, NULL, NULL),
(30084, '2017-05-14 12:00:07', NULL, NULL, 9208, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:00:07', 'admin-1494734357-1494734406918397', 1, 1, 'SR', NULL, NULL, NULL),
(30085, '2017-05-14 12:00:07', NULL, NULL, 9208, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:00:07', 'admin-1494734357-1494734406918397', 1, 0, '', NULL, NULL, NULL),
(30086, '2017-05-14 15:41:03', NULL, NULL, 9227, 0, 77, '77', 'Sarawak Kolomee', 'add 1 fried egg', 'Meals', 'Perfect Meals', 1, 13.50, 13.5000, 0.0000, 13.50, 1, '27', 1, '1494741275', 'admin', '2017-05-14 15:41:03', 'admin-1494741275-14947476628344887', 1, 1, 'SR', NULL, NULL, NULL),
(30087, '2017-05-14 13:24:28', NULL, NULL, 9219, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:24:28', 'admin-1494738059-14947394687091841', 1, 0, '', NULL, NULL, NULL),
(30088, '2017-05-14 13:24:28', NULL, NULL, 9219, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:24:28', 'admin-1494738059-14947394687091841', 1, 0, '', NULL, NULL, NULL),
(30089, '2017-05-14 10:32:38', NULL, NULL, 9195, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:32:38', 'admin-1494727581-14947291581232631', 1, 1, 'SR', NULL, NULL, NULL),
(30090, '2017-05-14 09:34:37', NULL, NULL, 9185, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:34:37', 'admin-1494723283-14947256777827953', 1, 1, 'SR', NULL, NULL, NULL),
(30091, '2017-05-14 09:34:38', NULL, NULL, 9185, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:34:38', 'admin-1494723283-14947256777827953', 1, 1, 'SR', NULL, NULL, NULL),
(30092, '2017-05-14 09:45:57', NULL, NULL, 9186, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.30, 0.0000, 0.0000, 13.30, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:45:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30093, '2017-05-14 09:46:26', NULL, NULL, 9186, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:46:26', 'admin-1494723283-14947263859313219', 1, 0, '', NULL, NULL, NULL),
(30094, '2017-05-14 09:46:26', NULL, NULL, 9186, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:46:26', 'admin-1494723283-14947263859313219', 1, 0, '', NULL, NULL, NULL),
(30095, '2017-05-14 09:46:26', NULL, NULL, 9186, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:46:26', 'admin-1494723283-14947263859313219', 1, 0, '', NULL, NULL, NULL),
(30096, '2017-05-14 09:46:26', NULL, NULL, 9186, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:46:26', 'admin-1494723283-14947263859313219', 1, 0, '', NULL, NULL, NULL),
(30097, '2017-05-14 11:01:33', NULL, NULL, 9200, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:01:33', 'admin-1494730264-14947308933842596', 1, 1, 'SR', NULL, NULL, NULL),
(30098, '2017-05-14 11:06:10', NULL, NULL, 9201, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:06:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30099, '2017-05-14 11:06:21', NULL, NULL, 9201, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:06:21', 'admin-1494730264-14947311812955286', 1, 0, '', NULL, NULL, NULL),
(30100, '2017-05-14 11:01:33', NULL, NULL, 9200, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:01:33', 'admin-1494730264-14947308933842596', 1, 1, 'SR', NULL, NULL, NULL),
(30101, '2017-05-14 13:00:46', NULL, NULL, 9218, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:00:46', 'admin-1494734357-14947380461371616', 1, 0, '', NULL, NULL, NULL),
(30102, '2017-05-14 13:00:33', NULL, NULL, 9218, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:00:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30103, '2017-05-14 17:38:17', NULL, NULL, 9232, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1494741275', 'admin', '2017-05-14 17:38:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30104, '2017-05-14 10:36:49', NULL, NULL, 9196, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:36:49', 'admin-1494727581-1494729409254215', 1, 0, '', NULL, NULL, NULL),
(30105, '2017-05-14 12:53:19', NULL, NULL, 9216, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:53:19', 'admin-1494734357-14947375995081493', 1, 0, '', NULL, NULL, NULL),
(30106, '2017-05-14 11:59:01', NULL, NULL, 9208, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:59:01', 'admin-1494732521-14947343416254165', 1, 0, '', NULL, NULL, NULL),
(30107, '2017-05-14 11:58:47', NULL, NULL, 9208, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:58:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30108, '2017-05-14 10:32:38', NULL, NULL, 9195, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:32:38', 'admin-1494727581-14947291581232631', 1, 0, '', NULL, NULL, NULL),
(30109, '2017-05-14 11:58:09', NULL, NULL, 9207, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:58:09', 'admin-1494732521-14947342897324510', 1, 1, 'SR', NULL, NULL, NULL),
(30110, '2017-05-14 11:58:09', NULL, NULL, 9207, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:58:09', 'admin-1494732521-14947342897324510', 1, 0, '', NULL, NULL, NULL),
(30111, '2017-05-14 11:58:00', NULL, NULL, 9207, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:58:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30112, '2017-05-14 11:55:11', NULL, NULL, 9206, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:55:11', 'admin-1494732521-14947341109389936', 1, 1, 'SR', NULL, NULL, NULL),
(30113, '2017-05-14 11:55:09', NULL, NULL, 9206, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:55:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30114, '2017-05-14 11:53:00', NULL, NULL, 9205, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:53:00', 'admin-1494732521-14947339802017044', 1, 0, '', NULL, NULL, NULL),
(30115, '2017-05-14 11:52:00', NULL, NULL, 9205, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:52:00', 'admin-1494732521-14947339200484731', 1, 1, 'SR', NULL, NULL, NULL),
(30116, '2017-05-14 12:41:05', NULL, NULL, 9215, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:41:05', 'admin-1494734357-14947368651883462', 1, 0, '', NULL, NULL, NULL),
(30117, '2017-05-14 12:40:07', NULL, NULL, 9196, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:40:07', 'admin-1494734357-14947368069366689', 1, 0, '', NULL, NULL, NULL),
(30118, '2017-05-14 12:40:07', NULL, NULL, 9196, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:40:07', 'admin-1494734357-14947368069366689', 1, 1, 'SR', NULL, NULL, NULL),
(30119, '2017-05-14 12:40:07', NULL, NULL, 9196, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:40:07', 'admin-1494734357-14947368069366689', 1, 1, 'SR', NULL, NULL, NULL),
(30120, '2017-05-14 12:40:07', NULL, NULL, 9196, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:40:07', 'admin-1494734357-14947368069366689', 1, 0, '', NULL, NULL, NULL),
(30121, '2017-05-14 11:51:09', NULL, NULL, 9204, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:51:09', 'admin-1494732521-14947338696701848', 1, 1, 'SR', NULL, NULL, NULL),
(30122, '2017-05-14 10:36:49', NULL, NULL, 9196, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:36:49', 'admin-1494727581-1494729409254215', 1, 0, '', NULL, NULL, NULL),
(30123, '2017-05-14 11:51:09', NULL, NULL, 9204, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:51:09', 'admin-1494732521-14947338696701848', 1, 0, '', NULL, NULL, NULL),
(30124, '2017-05-14 11:51:09', NULL, NULL, 9204, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:51:09', 'admin-1494732521-14947338696701848', 1, 0, '', NULL, NULL, NULL),
(30125, '2017-05-14 11:51:09', NULL, NULL, 9204, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:51:09', 'admin-1494732521-14947338696701848', 1, 0, '', NULL, NULL, NULL),
(30126, '2017-05-14 11:51:09', NULL, NULL, 9204, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:51:09', 'admin-1494732521-14947338696701848', 1, 0, '', NULL, NULL, NULL),
(30127, '2017-05-14 13:39:27', NULL, NULL, 9221, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:39:27', 'admin-1494738059-14947403672988157', 1, 0, '', NULL, NULL, NULL),
(30128, '2017-05-14 11:51:16', NULL, NULL, 9196, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:51:16', 'admin-1494732521-14947338764411399', 1, 0, '', NULL, NULL, NULL),
(30129, '2017-05-14 11:51:35', NULL, NULL, 9205, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:51:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30130, '2017-05-14 11:47:47', NULL, NULL, 9203, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:47:47', 'admin-1494732521-14947336674076016', 1, 0, '', NULL, NULL, NULL),
(30131, '2017-05-14 11:47:47', NULL, NULL, 9203, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:47:47', 'admin-1494732521-14947336674076016', 1, 0, '', NULL, NULL, NULL),
(30132, '2017-05-14 11:47:47', NULL, NULL, 9203, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:47:47', 'admin-1494732521-14947336674076016', 1, 0, '', NULL, NULL, NULL),
(30133, '2017-05-14 11:06:36', NULL, NULL, 9201, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:06:36', 'admin-1494730264-1494731195802112', 1, 1, 'SR', NULL, NULL, NULL),
(30134, '2017-05-14 11:11:57', NULL, NULL, 9199, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:11:57', 'admin-1494730264-14947315177516375', 1, 1, 'SR', NULL, NULL, NULL),
(30135, '2017-05-14 11:14:56', NULL, NULL, 9202, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:14:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30136, '2017-05-14 11:15:04', NULL, NULL, 9202, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:15:04', 'admin-1494730264-14947317038658321', 1, 0, '', NULL, NULL, NULL),
(30137, '2017-05-14 11:15:04', NULL, NULL, 9202, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:15:04', 'admin-1494730264-14947317038658321', 1, 0, '', NULL, NULL, NULL),
(30138, '2017-05-14 11:15:04', NULL, NULL, 9202, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:15:04', 'admin-1494730264-14947317038658321', 1, 1, 'SR', NULL, NULL, NULL),
(30139, '2017-05-14 11:15:04', NULL, NULL, 9202, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:15:04', 'admin-1494730264-14947317038658321', 1, 1, 'SR', NULL, NULL, NULL),
(30140, '2017-05-14 11:16:53', NULL, NULL, 9202, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:16:53', 'admin-1494730264-14947318135582274', 1, 0, '', NULL, NULL, NULL),
(30141, '2017-05-14 11:24:32', NULL, NULL, 9196, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:24:32', 'admin-1494730264-14947322720854515', 1, 0, '', NULL, NULL, NULL),
(30142, '2017-05-14 11:48:06', NULL, NULL, 9203, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:48:06', 'admin-1494732521-14947336863965661', 1, 1, 'SR', NULL, NULL, NULL),
(30143, '2017-05-14 11:50:52', NULL, NULL, 9204, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:50:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30144, '2017-05-14 11:44:11', NULL, NULL, 9203, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:44:11', 'admin-1494732521-1494733451277166', 1, 0, '', NULL, NULL, NULL),
(30145, '2017-05-14 11:44:11', NULL, NULL, 9203, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:44:11', 'admin-1494732521-1494733451277166', 1, 0, '', NULL, NULL, NULL),
(30146, '2017-05-14 11:44:11', NULL, NULL, 9203, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:44:11', 'admin-1494732521-1494733451277166', 1, 0, '', NULL, NULL, NULL),
(30147, '2017-05-14 11:44:11', NULL, NULL, 9203, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:44:11', 'admin-1494732521-1494733451277166', 1, 0, '', NULL, NULL, NULL),
(30148, '2017-05-14 11:43:10', NULL, NULL, 9203, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.80, 0.0000, 0.0000, 10.80, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:43:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30149, '2017-05-14 11:25:32', NULL, NULL, 9199, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:25:32', 'admin-1494730264-14947323321121813', 1, 1, 'SR', NULL, NULL, NULL),
(30150, '2017-05-14 13:56:42', NULL, NULL, 9218, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 13:56:42', 'admin-1494741275-1494741401890574', 1, 0, '', NULL, NULL, NULL),
(30151, '2017-05-14 12:00:07', NULL, NULL, 9208, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:00:07', 'admin-1494734357-1494734406918397', 1, 1, 'SR', NULL, NULL, NULL),
(30152, '2017-05-14 10:56:08', NULL, NULL, 9198, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:56:08', 'admin-1494730264-14947305683152326', 1, 1, 'SR', NULL, NULL, NULL),
(30153, '2017-05-14 10:56:08', NULL, NULL, 9198, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:56:08', 'admin-1494730264-14947305683152326', 1, 0, '', NULL, NULL, NULL),
(30154, '2017-05-14 12:39:04', NULL, NULL, 9214, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:39:04', 'admin-1494734357-14947367442829814', 1, 0, '', NULL, NULL, NULL),
(30155, '2017-05-14 11:24:52', NULL, NULL, 9196, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:24:52', 'admin-1494730264-14947322924498562', 1, 1, 'SR', NULL, NULL, NULL),
(30156, '2017-05-14 11:06:36', NULL, NULL, 9201, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:06:36', 'admin-1494730264-1494731195802112', 1, 0, '', NULL, NULL, NULL),
(30157, '2017-05-14 11:06:21', NULL, NULL, 9201, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:06:21', 'admin-1494730264-14947311812955286', 1, 0, '', NULL, NULL, NULL),
(30158, '2017-05-14 12:34:54', NULL, NULL, 9213, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 12:34:54', 'admin-1494734357-14947364942392831', 1, 1, 'SR', NULL, NULL, NULL),
(30159, '2017-05-14 10:02:27', NULL, NULL, 9191, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:02:27', 'admin-1494723283-14947273474557977', 1, 0, '', NULL, NULL, NULL),
(30160, '2017-05-14 11:01:19', NULL, NULL, 9199, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.60, 0.0000, 0.0000, 11.60, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:01:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30161, '2017-05-14 11:01:28', NULL, NULL, 9199, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:01:28', 'admin-1494730264-14947308880185717', 1, 0, '', NULL, NULL, NULL),
(30162, '2017-05-14 11:01:28', NULL, NULL, 9199, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:01:28', 'admin-1494730264-14947308880185717', 1, 0, '', NULL, NULL, NULL),
(30163, '2017-05-14 11:01:30', NULL, NULL, 9200, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:01:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30164, '2017-05-14 11:01:28', NULL, NULL, 9199, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:01:28', 'admin-1494730264-14947308880185717', 1, 1, 'SR', NULL, NULL, NULL),
(30165, '2017-05-14 10:56:08', NULL, NULL, 9198, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:56:08', 'admin-1494730264-14947305683152326', 1, 1, 'SR', NULL, NULL, NULL),
(30166, '2017-05-14 11:00:22', NULL, NULL, 9193, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 11:00:22', 'admin-1494730264-14947308223132592', 1, 1, 'SR', NULL, NULL, NULL),
(30167, '2017-05-14 10:56:08', NULL, NULL, 9198, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:56:08', 'admin-1494730264-14947305683152326', 1, 1, 'SR', NULL, NULL, NULL),
(30168, '2017-05-14 10:51:22', NULL, NULL, 9196, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:51:22', 'admin-1494730264-14947302822107475', 1, 0, '', NULL, NULL, NULL),
(30169, '2017-05-14 10:51:22', NULL, NULL, 9196, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:51:22', 'admin-1494730264-14947302822107475', 1, 1, 'SR', NULL, NULL, NULL),
(30170, '2017-05-14 10:56:08', NULL, NULL, 9198, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:56:08', 'admin-1494730264-14947305683152326', 1, 1, 'SR', NULL, NULL, NULL),
(30171, '2017-05-14 10:30:29', NULL, NULL, 9195, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:30:29', 'admin-1494727581-14947290291909635', 1, 0, '', NULL, NULL, NULL),
(30172, '2017-05-14 10:30:29', NULL, NULL, 9195, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:30:29', 'admin-1494727581-14947290291909635', 1, 0, '', NULL, NULL, NULL),
(30173, '2017-05-14 10:30:29', NULL, NULL, 9195, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:30:29', 'admin-1494727581-14947290291909635', 1, 0, '', NULL, NULL, NULL),
(30174, '2017-05-14 10:47:35', NULL, NULL, 9198, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:47:35', 'admin-1494727581-14947300555348496', 1, 0, '', NULL, NULL, NULL),
(30175, '2017-05-14 10:47:35', NULL, NULL, 9198, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:47:35', 'admin-1494727581-14947300555348496', 1, 0, '', NULL, NULL, NULL),
(30176, '2017-05-14 10:47:35', NULL, NULL, 9198, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:47:35', 'admin-1494727581-14947300555348496', 1, 0, '', NULL, NULL, NULL),
(30177, '2017-05-14 10:47:35', NULL, NULL, 9198, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:47:35', 'admin-1494727581-14947300555348496', 1, 0, '', NULL, NULL, NULL),
(30178, '2017-05-14 10:47:35', NULL, NULL, 9198, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:47:35', 'admin-1494727581-14947300555348496', 1, 0, '', NULL, NULL, NULL),
(30179, '2017-05-14 10:46:57', NULL, NULL, 9198, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.80, 0.0000, 0.0000, 16.80, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:46:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30180, '2017-05-14 10:47:35', NULL, NULL, 9198, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:47:35', 'admin-1494727581-14947300555348496', 1, 0, '', NULL, NULL, NULL),
(30181, '2017-05-14 10:40:45', NULL, NULL, 9197, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:40:45', 'admin-1494727581-14947296456786560', 1, 1, 'SR', NULL, NULL, NULL),
(30182, '2017-05-14 10:40:45', NULL, NULL, 9197, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:40:45', 'admin-1494727581-14947296456786560', 1, 1, 'SR', NULL, NULL, NULL),
(30183, '2017-05-14 10:40:45', NULL, NULL, 9197, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:40:45', 'admin-1494727581-14947296456786560', 1, 0, '', NULL, NULL, NULL),
(30184, '2017-05-14 10:40:45', NULL, NULL, 9197, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:40:45', 'admin-1494727581-14947296456786560', 1, 0, '', NULL, NULL, NULL),
(30185, '2017-05-14 17:15:48', NULL, NULL, 9230, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 17:15:48', 'admin-1494741275-14947533481543078', 1, 0, '', NULL, NULL, NULL),
(30186, '2017-05-14 10:40:11', NULL, NULL, 9197, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:40:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30187, '2017-05-14 10:37:04', NULL, NULL, 9191, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:37:04', 'admin-1494727581-14947294240508594', 1, 1, 'SR', NULL, NULL, NULL),
(30188, '2017-05-14 10:36:44', NULL, NULL, 9196, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 21.10, 0.0000, 0.0000, 21.10, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:36:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30189, '2017-05-14 10:30:29', NULL, NULL, 9195, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:30:29', 'admin-1494727581-14947290291909635', 1, 0, '', NULL, NULL, NULL),
(30190, '2017-05-14 10:30:29', NULL, NULL, 9195, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:30:29', 'admin-1494727581-14947290291909635', 1, 0, '', NULL, NULL, NULL),
(30191, '2017-05-14 10:30:29', NULL, NULL, 9195, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:30:29', 'admin-1494727581-14947290291909635', 1, 0, '', NULL, NULL, NULL),
(30192, '2017-05-14 10:30:29', NULL, NULL, 9195, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:30:29', 'admin-1494727581-14947290291909635', 1, 0, '', NULL, NULL, NULL),
(30193, '2017-05-14 10:30:05', NULL, NULL, 9195, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 17.00, 0.0000, 0.0000, 17.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:30:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30194, '2017-05-14 10:27:42', NULL, NULL, 9187, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:27:42', 'admin-1494727581-14947288619705257', 1, 1, 'SR', NULL, NULL, NULL),
(30195, '2017-05-14 10:27:42', NULL, NULL, 9187, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:27:42', 'admin-1494727581-14947288619705257', 1, 1, 'SR', NULL, NULL, NULL),
(30196, '2017-05-14 10:25:17', NULL, NULL, 9194, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:25:17', 'admin-1494727581-14947287175532398', 1, 1, 'SR', NULL, NULL, NULL),
(30197, '2017-05-14 10:25:12', NULL, NULL, 9194, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:25:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30198, '2017-05-14 10:25:09', NULL, NULL, 9193, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:25:09', 'admin-1494727581-1494728709340819', 1, 1, 'SR', NULL, NULL, NULL),
(30199, '2017-05-14 10:25:09', NULL, NULL, 9193, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:25:09', 'admin-1494727581-1494728709340819', 1, 1, 'SR', NULL, NULL, NULL),
(30200, '2017-05-14 17:38:22', NULL, NULL, 9232, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 17:38:22', 'admin-1494741275-14947547021868233', 1, 0, '', NULL, NULL, NULL),
(30201, '2017-05-14 10:40:45', NULL, NULL, 9197, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:40:45', 'admin-1494727581-14947296456786560', 1, 0, '', NULL, NULL, NULL),
(30202, '2017-05-14 10:25:09', NULL, NULL, 9193, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:25:09', 'admin-1494727581-1494728709340819', 1, 0, '', NULL, NULL, NULL),
(30203, '2017-05-14 10:25:09', NULL, NULL, 9193, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:25:09', 'admin-1494727581-1494728709340819', 1, 0, '', NULL, NULL, NULL),
(30204, '2017-05-14 09:48:20', NULL, NULL, 9187, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:48:20', 'admin-1494723283-14947265008137768', 1, 0, '', NULL, NULL, NULL),
(30205, '2017-05-14 09:48:20', NULL, NULL, 9187, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:48:20', 'admin-1494723283-14947265008137768', 1, 0, '', NULL, NULL, NULL),
(30206, '2017-05-14 09:48:48', NULL, NULL, 9187, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:48:48', 'admin-1494723283-1494726527925391', 1, 1, 'SR', NULL, NULL, NULL),
(30207, '2017-05-14 09:48:48', NULL, NULL, 9187, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:48:48', 'admin-1494723283-1494726527925391', 1, 1, 'SR', NULL, NULL, NULL),
(30208, '2017-05-14 09:49:30', NULL, NULL, 9188, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.30, 0.0000, 0.0000, 12.30, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:49:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30209, '2017-05-14 09:49:44', NULL, NULL, 9188, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:49:44', 'admin-1494723283-14947265847204575', 1, 0, '', NULL, NULL, NULL),
(30210, '2017-05-14 09:49:44', NULL, NULL, 9188, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:49:44', 'admin-1494723283-14947265847204575', 1, 1, 'SR', NULL, NULL, NULL),
(30211, '2017-05-14 09:50:05', NULL, NULL, 9188, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:50:05', 'admin-1494723283-14947266048337297', 1, 1, 'SR', NULL, NULL, NULL),
(30212, '2017-05-14 09:50:05', NULL, NULL, 9188, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:50:05', 'admin-1494723283-14947266048337297', 1, 0, '', NULL, NULL, NULL),
(30213, '2017-05-14 09:51:58', NULL, NULL, 9188, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:51:58', 'admin-1494723283-1494726717992239', 1, 0, '', NULL, NULL, NULL),
(30214, '2017-05-14 10:05:09', NULL, NULL, 9188, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:05:09', 'admin-1494723283-1494727509042424', 1, 1, 'SR', NULL, NULL, NULL),
(30215, '2017-05-14 09:53:44', NULL, NULL, 9189, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:53:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30216, '2017-05-14 09:53:50', NULL, NULL, 9189, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:53:50', 'admin-1494723283-14947268303527346', 1, 1, 'SR', NULL, NULL, NULL),
(30217, '2017-05-14 09:54:02', NULL, NULL, 9189, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:54:02', 'admin-1494723283-14947268422073954', 1, 0, '', NULL, NULL, NULL),
(30218, '2017-05-14 09:55:16', NULL, NULL, 9188, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:55:16', 'admin-1494723283-14947269158595027', 1, 1, 'SR', NULL, NULL, NULL),
(30219, '2017-05-14 10:00:06', NULL, NULL, 9190, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.90, 0.0000, 0.0000, 10.90, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:00:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30220, '2017-05-14 10:00:48', NULL, NULL, 9190, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:00:48', 'admin-1494723283-1494727248666807', 1, 0, '', NULL, NULL, NULL),
(30221, '2017-05-14 10:00:48', NULL, NULL, 9190, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:00:48', 'admin-1494723283-1494727248666807', 1, 0, '', NULL, NULL, NULL),
(30222, '2017-05-14 10:00:48', NULL, NULL, 9190, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:00:48', 'admin-1494723283-1494727248666807', 1, 0, '', NULL, NULL, NULL),
(30223, '2017-05-14 10:00:48', NULL, NULL, 9190, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:00:48', 'admin-1494723283-1494727248666807', 1, 0, '', NULL, NULL, NULL),
(30224, '2017-05-14 10:00:48', NULL, NULL, 9190, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:00:48', 'admin-1494723283-1494727248666807', 1, 1, 'SR', NULL, NULL, NULL),
(30225, '2017-05-14 09:34:12', NULL, NULL, 9185, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.30, 0.0000, 0.0000, 12.30, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:34:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30226, '2017-05-14 09:34:28', NULL, NULL, 9185, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:34:28', 'admin-1494723283-14947256684304365', 1, 0, '', NULL, NULL, NULL),
(30227, '2017-05-14 09:34:28', NULL, NULL, 9185, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:34:28', 'admin-1494723283-14947256684304365', 1, 0, '', NULL, NULL, NULL),
(30228, '2017-05-14 09:34:28', NULL, NULL, 9185, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:34:28', 'admin-1494723283-14947256684304365', 1, 0, '', NULL, NULL, NULL),
(30229, '2017-05-14 09:34:28', NULL, NULL, 9185, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:34:28', 'admin-1494723283-14947256684304365', 1, 0, '', NULL, NULL, NULL),
(30230, '2017-05-14 09:34:28', NULL, NULL, 9185, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:34:28', 'admin-1494723283-14947256684304365', 1, 0, '', NULL, NULL, NULL),
(30231, '2017-05-14 10:00:48', NULL, NULL, 9190, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:00:48', 'admin-1494723283-1494727248666807', 1, 1, 'SR', NULL, NULL, NULL),
(30232, '2017-05-14 10:00:48', NULL, NULL, 9190, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 10:00:48', 'admin-1494723283-1494727248666807', 1, 1, 'SR', NULL, NULL, NULL),
(30233, '2017-05-14 09:48:12', NULL, NULL, 9187, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:48:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30234, '2017-05-14 09:47:04', NULL, NULL, 9186, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:47:04', 'admin-1494723283-1494726424254882', 1, 1, 'SR', NULL, NULL, NULL),
(30235, '2017-05-14 09:47:04', NULL, NULL, 9186, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:47:04', 'admin-1494723283-1494726424254882', 1, 1, 'SR', NULL, NULL, NULL),
(30236, '2017-05-14 09:47:04', NULL, NULL, 9186, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:47:04', 'admin-1494723283-1494726424254882', 1, 1, 'SR', NULL, NULL, NULL),
(30237, '2017-05-14 09:46:26', NULL, NULL, 9186, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:46:26', 'admin-1494723283-14947263859313219', 1, 0, '', NULL, NULL, NULL),
(30238, '2017-05-14 09:47:04', NULL, NULL, 9186, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:47:04', 'admin-1494723283-1494726424254882', 1, 1, 'SR', NULL, NULL, NULL),
(30239, '2017-05-14 09:34:37', NULL, NULL, 9185, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:34:37', 'admin-1494723283-14947256777827953', 1, 1, 'SR', NULL, NULL, NULL),
(30240, '2017-05-14 09:34:37', NULL, NULL, 9185, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:34:37', 'admin-1494723283-14947256777827953', 1, 1, 'SR', NULL, NULL, NULL),
(30241, '2017-05-14 09:34:37', NULL, NULL, 9185, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:34:37', 'admin-1494723283-14947256777827953', 1, 1, 'SR', NULL, NULL, NULL),
(30242, '2017-05-14 09:19:58', NULL, NULL, 9184, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:19:58', 'admin-1494723283-149472479800082', 1, 0, '', NULL, NULL, NULL),
(30243, '2017-05-14 09:19:58', NULL, NULL, 9184, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:19:58', 'admin-1494723283-149472479800082', 1, 0, '', NULL, NULL, NULL),
(30244, '2017-05-14 09:19:58', NULL, NULL, 9184, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:19:58', 'admin-1494723283-149472479800082', 1, 1, 'SR', NULL, NULL, NULL),
(30245, '2017-05-14 09:21:13', NULL, NULL, 9184, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:21:13', 'admin-1494723283-14947248730007932', 1, 0, '', NULL, NULL, NULL),
(30246, '2017-05-14 09:19:52', NULL, NULL, 9184, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 09:19:52', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(30247, '2017-05-14 17:48:25', NULL, NULL, 9233, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1494741275', 'admin', '2017-05-14 17:48:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30248, '2017-05-14 17:48:29', NULL, NULL, 9233, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 17:48:29', 'admin-1494741275-14947553097365585', 1, 1, 'SR', NULL, NULL, NULL),
(30249, '2017-05-14 18:20:50', NULL, NULL, 9234, 0, 181, '116', 'Open Food ', 'ice cream', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1494741275', 'admin', '2017-05-14 18:20:50', 'admin-1494741275-14947572498927564', 1, 0, '', 1, NULL, NULL),
(30250, '2017-05-15 12:58:48', NULL, NULL, 9257, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1494827320', 'admin', '2017-05-15 12:58:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30251, '2017-05-15 11:56:37', NULL, NULL, 9254, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:56:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30252, '2017-05-15 11:56:45', NULL, NULL, 9254, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:56:45', 'admin-1494812307-14948206049756823', 1, 0, '', NULL, NULL, NULL),
(30253, '2017-05-15 11:56:45', NULL, NULL, 9254, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:56:45', 'admin-1494812307-14948206049756823', 1, 0, '', NULL, NULL, NULL),
(30254, '2017-05-15 11:56:45', NULL, NULL, 9254, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:56:45', 'admin-1494812307-14948206049756823', 1, 1, 'SR', NULL, NULL, NULL),
(30255, '2017-05-15 11:56:45', NULL, NULL, 9254, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:56:45', 'admin-1494812307-14948206049756823', 1, 0, '', NULL, NULL, NULL),
(30256, '2017-05-15 12:11:56', NULL, NULL, 9255, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1494827320', 'admin', '2017-05-15 12:11:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30257, '2017-05-15 12:12:07', NULL, NULL, 9255, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 12:12:07', 'admin-1494820745-14948215274144784', 1, 0, '', NULL, NULL, NULL),
(30258, '2017-05-15 12:12:07', NULL, NULL, 9255, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 12:12:07', 'admin-1494820745-14948215274144784', 1, 1, 'SR', NULL, NULL, NULL),
(30259, '2017-05-15 12:28:11', NULL, NULL, 9256, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 12:28:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30260, '2017-05-15 12:28:27', NULL, NULL, 9256, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 12:28:27', 'admin-1494820745-1494822507717813', 1, 0, '', NULL, NULL, NULL),
(30261, '2017-05-15 12:28:27', NULL, NULL, 9256, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 12:28:27', 'admin-1494820745-1494822507717813', 1, 0, '', NULL, NULL, NULL),
(30262, '2017-05-15 12:28:57', NULL, NULL, 9256, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 12:28:57', 'admin-1494820745-1494822536979394', 1, 1, 'SR', NULL, NULL, NULL),
(30263, '2017-05-15 12:28:57', NULL, NULL, 9256, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 12:28:57', 'admin-1494820745-1494822536979394', 1, 1, 'SR', NULL, NULL, NULL),
(30264, '2017-05-15 12:58:56', NULL, NULL, 9257, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 12:58:56', 'admin-1494820745-14948243359724366', 1, 0, '', NULL, NULL, NULL),
(30265, '2017-05-15 12:58:56', NULL, NULL, 9257, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 12:58:56', 'admin-1494820745-14948243359724366', 1, 0, '', NULL, NULL, NULL),
(30266, '2017-05-15 13:03:04', NULL, NULL, 9258, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:03:04', 'admin-1494820745-14948245841118353', 1, 1, 'SR', 1, NULL, NULL),
(30267, '2017-05-15 13:20:46', NULL, NULL, 9259, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:20:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30268, '2017-05-15 13:20:55', NULL, NULL, 9259, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:20:55', 'admin-1494820745-14948256554241416', 1, 0, '', NULL, NULL, NULL),
(30269, '2017-05-15 13:20:55', NULL, NULL, 9259, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:20:55', 'admin-1494820745-14948256554241416', 1, 0, '', NULL, NULL, NULL),
(30270, '2017-05-15 13:20:55', NULL, NULL, 9259, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:20:55', 'admin-1494820745-14948256554241416', 1, 0, '', NULL, NULL, NULL),
(30271, '2017-05-15 09:41:56', NULL, NULL, 9239, 0, 283, '217', 'Weight Gain Deal - TBP / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 09:41:56', 'admin-1494812307-14948125167371657', 1, 0, '', NULL, NULL, NULL),
(30272, '2017-05-15 13:23:29', NULL, NULL, 9260, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:23:29', 'admin-1494820745-14948258088604330', 1, 1, 'SR', NULL, NULL, NULL),
(30273, '2017-05-15 15:17:13', NULL, NULL, 9267, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 15:17:13', 'admin-1494827320-1494832633515784', 1, 1, 'SR', NULL, NULL, NULL),
(30274, '2017-05-15 16:23:13', NULL, NULL, 9268, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1494827320', 'admin', '2017-05-15 16:23:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30275, '2017-05-15 16:23:27', NULL, NULL, 9268, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 16:23:27', 'admin-1494827320-14948366072414436', 1, 0, '', NULL, NULL, NULL),
(30276, '2017-05-15 16:23:27', NULL, NULL, 9268, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 16:23:27', 'admin-1494827320-14948366072414436', 1, 0, '', NULL, NULL, NULL),
(30277, '2017-05-15 16:23:27', NULL, NULL, 9268, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 16:23:27', 'admin-1494827320-14948366072414436', 1, 1, 'SR', NULL, NULL, NULL),
(30278, '2017-05-15 16:23:27', NULL, NULL, 9268, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 2, 13.00, 26.0000, 0.0000, 26.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 16:23:27', 'admin-1494827320-14948366072414436', 1, 1, 'SR', NULL, NULL, NULL),
(30279, '2017-05-15 09:27:03', NULL, NULL, 9238, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1494827320', 'admin', '2017-05-15 09:27:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30280, '2017-05-15 09:27:08', NULL, NULL, 9238, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 09:27:08', 'admin-1494810299-14948116277999228', 1, 0, '', NULL, NULL, NULL),
(30281, '2017-05-15 09:33:53', NULL, NULL, 9238, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 09:33:53', 'admin-1494810299-1494812033155519', 1, 0, '', NULL, NULL, NULL),
(30282, '2017-05-15 09:38:34', NULL, NULL, 9239, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1494827320', 'admin', '2017-05-15 09:38:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30283, '2017-05-15 16:33:51', NULL, NULL, 9269, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1494827320', 'admin', '2017-05-15 16:33:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30284, '2017-05-15 16:33:54', NULL, NULL, 9269, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 16:33:54', 'admin-1494827320-1494837234537369', 1, 0, '', NULL, NULL, NULL),
(30285, '2017-05-15 16:33:54', NULL, NULL, 9269, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 16:33:54', 'admin-1494827320-1494837234537369', 1, 1, 'SR', NULL, NULL, NULL),
(30286, '2017-05-15 13:48:34', NULL, NULL, 9263, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:48:34', 'admin-1494820745-14948273145066674', 1, 1, 'SR', NULL, NULL, NULL),
(30287, '2017-05-15 10:10:36', NULL, NULL, 9242, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 10:10:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30288, '2017-05-15 13:31:04', NULL, NULL, 9260, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:31:04', 'admin-1494820745-1494826264068257', 1, 1, 'SR', NULL, NULL, NULL),
(30289, '2017-05-15 14:59:59', NULL, NULL, 9266, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 14:59:59', 'admin-1494827320-14948315995825316', 1, 1, 'SR', NULL, NULL, NULL),
(30290, '2017-05-15 15:16:37', NULL, NULL, 9267, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1494827320', 'admin', '2017-05-15 15:16:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30291, '2017-05-15 15:16:40', NULL, NULL, 9267, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 15:16:40', 'admin-1494827320-14948325999042415', 1, 0, '', NULL, NULL, NULL),
(30292, '2017-05-15 13:48:52', NULL, NULL, 9263, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:48:52', 'admin-1494827320-14948273326497914', 1, 1, 'SR', NULL, NULL, NULL),
(30293, '2017-05-15 14:51:15', NULL, NULL, 9265, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 14:51:15', 'admin-1494827320-14948310755839849', 1, 1, 'SR', NULL, NULL, NULL),
(30294, '2017-05-15 14:51:15', NULL, NULL, 9265, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 14:51:15', 'admin-1494827320-14948310755839849', 1, 1, 'SR', NULL, NULL, NULL),
(30295, '2017-05-15 14:59:49', NULL, NULL, 9266, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1494827320', 'admin', '2017-05-15 14:59:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30296, '2017-05-15 14:59:59', NULL, NULL, 9266, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 14:59:59', 'admin-1494827320-14948315995825316', 1, 1, 'SR', NULL, NULL, NULL),
(30297, '2017-05-15 15:17:13', NULL, NULL, 9267, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 15:17:13', 'admin-1494827320-1494832633515784', 1, 1, 'SR', NULL, NULL, NULL),
(30298, '2017-05-15 13:34:36', NULL, NULL, 9262, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:34:36', 'admin-1494820745-14948264765349893', 1, 0, '', NULL, NULL, NULL),
(30299, '2017-05-15 13:34:36', NULL, NULL, 9262, 0, 75, '75', 'Meatless Aglio Olio ', 'extra spicy', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:34:36', 'admin-1494820745-14948264765349893', 1, 0, '', NULL, NULL, NULL),
(30300, '2017-05-15 13:34:36', NULL, NULL, 9262, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:34:36', 'admin-1494820745-14948264765349893', 1, 1, 'SR', NULL, NULL, NULL),
(30301, '2017-05-15 14:51:15', NULL, NULL, 9265, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 14:51:15', 'admin-1494827320-14948310755839849', 1, 0, '', NULL, NULL, NULL),
(30302, '2017-05-15 14:51:04', NULL, NULL, 9265, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1494827320', 'admin', '2017-05-15 14:51:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30303, '2017-05-15 14:51:15', NULL, NULL, 9265, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 14:51:15', 'admin-1494827320-14948310755839849', 1, 0, '', NULL, NULL, NULL),
(30304, '2017-05-15 14:29:26', NULL, NULL, 9264, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 14:29:26', 'admin-1494827320-14948297666529367', 1, 1, 'SR', NULL, NULL, NULL),
(30305, '2017-05-15 14:29:26', NULL, NULL, 9264, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 14:29:26', 'admin-1494827320-14948297666529367', 1, 1, 'SR', NULL, NULL, NULL),
(30306, '2017-05-15 14:29:23', NULL, NULL, 9264, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1494827320', 'admin', '2017-05-15 14:29:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30307, '2017-05-15 11:51:34', NULL, NULL, 9252, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:51:34', 'admin-1494812307-14948202945576342', 1, 1, 'SR', NULL, NULL, NULL),
(30308, '2017-05-15 11:51:34', NULL, NULL, 9252, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:51:34', 'admin-1494812307-14948202945576342', 1, 1, 'SR', NULL, NULL, NULL),
(30309, '2017-05-15 11:53:22', NULL, NULL, 9253, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:53:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30310, '2017-05-15 11:53:41', NULL, NULL, 9253, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:53:41', 'admin-1494812307-14948204208849036', 1, 0, '', NULL, NULL, NULL),
(30311, '2017-05-15 11:53:41', NULL, NULL, 9253, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:53:41', 'admin-1494812307-14948204208849036', 1, 0, '', NULL, NULL, NULL),
(30312, '2017-05-15 11:53:41', NULL, NULL, 9253, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:53:41', 'admin-1494812307-14948204208849036', 1, 1, 'SR', NULL, NULL, NULL),
(30313, '2017-05-15 13:48:52', NULL, NULL, 9263, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:48:52', 'admin-1494827320-14948273326497914', 1, 0, '', NULL, NULL, NULL),
(30314, '2017-05-15 13:48:34', NULL, NULL, 9263, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:48:34', 'admin-1494820745-14948273145066674', 1, 1, 'SR', NULL, NULL, NULL),
(30315, '2017-05-15 13:48:27', NULL, NULL, 9263, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:48:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30316, '2017-05-15 13:35:11', NULL, NULL, 9262, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:35:11', 'admin-1494820745-14948265116195164', 1, 1, 'SR', NULL, NULL, NULL),
(30317, '2017-05-15 13:35:11', NULL, NULL, 9262, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:35:11', 'admin-1494820745-14948265116195164', 1, 1, 'SR', NULL, NULL, NULL),
(30318, '2017-05-15 13:34:36', NULL, NULL, 9262, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:34:36', 'admin-1494820745-14948264765349893', 1, 0, '', NULL, NULL, NULL),
(30319, '2017-05-15 13:35:11', NULL, NULL, 9262, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:35:11', 'admin-1494820745-14948265116195164', 1, 1, 'SR', NULL, NULL, NULL),
(30320, '2017-05-15 13:34:14', NULL, NULL, 9262, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.70, 0.0000, 0.0000, 9.70, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:34:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30321, '2017-05-15 13:31:04', NULL, NULL, 9260, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:31:04', 'admin-1494820745-1494826264068257', 1, 1, 'SR', NULL, NULL, NULL),
(30322, '2017-05-15 13:26:49', NULL, NULL, 9260, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:26:49', 'admin-1494820745-14948260093454431', 1, 1, 'SR', NULL, NULL, NULL),
(30323, '2017-05-15 13:24:53', NULL, NULL, 9261, 0, 181, '116', 'Open Food ', 'ice cream', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:24:53', 'admin-1494820745-14948258935033898', 1, 0, '', 1, NULL, NULL),
(30324, '2017-05-15 13:23:29', NULL, NULL, 9260, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:23:29', 'admin-1494820745-14948258088604330', 1, 1, 'SR', NULL, NULL, NULL),
(30325, '2017-05-15 13:23:29', NULL, NULL, 9260, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:23:29', 'admin-1494820745-14948258088604330', 1, 0, '', NULL, NULL, NULL),
(30326, '2017-05-15 13:23:19', NULL, NULL, 9260, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1494827320', 'admin', '2017-05-15 13:23:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30327, '2017-05-15 11:53:41', NULL, NULL, 9253, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:53:41', 'admin-1494812307-14948204208849036', 1, 0, '', NULL, NULL, NULL),
(30328, '2017-05-15 11:53:41', NULL, NULL, 9253, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:53:41', 'admin-1494812307-14948204208849036', 1, 0, '', NULL, NULL, NULL),
(30329, '2017-05-15 10:10:44', NULL, NULL, 9242, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 10:10:44', 'admin-1494812307-14948142447211871', 1, 0, '', NULL, NULL, NULL),
(30330, '2017-05-15 10:10:44', NULL, NULL, 9242, 0, 280, '214', 'Diet Meal - Piccolo / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 10:10:44', 'admin-1494812307-14948142447211871', 1, 0, '', NULL, NULL, NULL),
(30331, '2017-05-15 10:28:54', NULL, NULL, 9243, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 10:28:54', 'admin-1494812307-1494815334086293', 1, 1, 'SR', 1, NULL, NULL),
(30332, '2017-05-15 10:33:02', NULL, NULL, 9244, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1494827320', 'admin', '2017-05-15 10:33:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30333, '2017-05-15 10:33:10', NULL, NULL, 9244, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 10:33:10', 'admin-1494812307-14948155899995142', 1, 0, '', NULL, NULL, NULL),
(30334, '2017-05-15 10:53:20', NULL, NULL, 9245, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1494827320', 'admin', '2017-05-15 10:53:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30335, '2017-05-15 10:53:24', NULL, NULL, 9245, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 10:53:24', 'admin-1494812307-14948168040675722', 1, 0, '', NULL, NULL, NULL),
(30336, '2017-05-15 10:53:24', NULL, NULL, 9245, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 10:53:24', 'admin-1494812307-14948168040675722', 1, 0, '', NULL, NULL, NULL),
(30337, '2017-05-15 10:54:15', NULL, NULL, 9246, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1494827320', 'admin', '2017-05-15 10:54:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30338, '2017-05-15 10:54:23', NULL, NULL, 9246, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 10:54:23', 'admin-1494812307-14948168628334861', 1, 0, '', NULL, NULL, NULL),
(30339, '2017-05-15 10:54:23', NULL, NULL, 9246, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 10:54:23', 'admin-1494812307-14948168628334861', 1, 0, '', NULL, NULL, NULL),
(30340, '2017-05-15 10:55:17', NULL, NULL, 9247, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1494827320', 'admin', '2017-05-15 10:55:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30341, '2017-05-15 10:55:22', NULL, NULL, 9247, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 10:55:22', 'admin-1494812307-14948169224539849', 1, 0, '', NULL, NULL, NULL),
(30342, '2017-05-15 11:00:29', NULL, NULL, 9248, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:00:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30343, '2017-05-15 11:00:33', NULL, NULL, 9248, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:00:33', 'admin-1494812307-14948172331354385', 1, 1, 'SR', NULL, NULL, NULL),
(30344, '2017-05-15 11:00:33', NULL, NULL, 9248, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:00:33', 'admin-1494812307-14948172331354385', 1, 1, 'SR', NULL, NULL, NULL),
(30345, '2017-05-15 11:07:22', NULL, NULL, 9249, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:07:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30346, '2017-05-15 11:07:28', NULL, NULL, 9249, 0, 279, '213', 'Diet Meal - Americano / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:07:28', 'admin-1494812307-14948176485728131', 1, 0, '', NULL, NULL, NULL),
(30347, '2017-05-15 11:07:28', NULL, NULL, 9249, 0, 279, '213', 'Diet Meal - Americano / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:07:28', 'admin-1494812307-14948176485728131', 1, 0, '', NULL, NULL, NULL),
(30348, '2017-05-15 11:25:11', NULL, NULL, 9250, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:25:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30349, '2017-05-15 11:27:49', NULL, NULL, 9250, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:27:49', 'admin-1494812307-14948188692756343', 1, 0, '', NULL, NULL, NULL),
(30350, '2017-05-15 11:25:35', NULL, NULL, 9250, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:25:35', 'admin-1494812307-149481873501386', 1, 1, 'SR', NULL, NULL, NULL),
(30351, '2017-05-15 11:25:38', NULL, NULL, 9250, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:25:38', 'admin-1494812307-14948187386977058', 1, 0, '', NULL, NULL, NULL),
(30352, '2017-05-15 11:26:16', NULL, NULL, 9250, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:26:16', 'admin-1494812307-14948187760788692', 1, 1, 'SR', NULL, NULL, NULL),
(30353, '2017-05-15 11:48:16', NULL, NULL, 9251, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:48:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30354, '2017-05-15 11:48:23', NULL, NULL, 9251, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:48:23', 'admin-1494812307-1494820103476910', 1, 1, 'SR', NULL, NULL, NULL),
(30355, '2017-05-15 11:48:23', NULL, NULL, 9251, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:48:23', 'admin-1494812307-1494820103476910', 1, 1, 'SR', NULL, NULL, NULL),
(30356, '2017-05-15 11:51:27', NULL, NULL, 9252, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1494827320', 'admin', '2017-05-15 11:51:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30357, '2017-05-15 10:08:56', NULL, NULL, 9241, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 10:08:56', 'admin-1494812307-14948141364587581', 1, 0, '', NULL, NULL, NULL),
(30358, '2017-05-15 10:08:52', NULL, NULL, 9241, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1494827320', 'admin', '2017-05-15 10:08:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30359, '2017-05-15 09:49:57', NULL, NULL, 9240, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 09:49:57', 'admin-1494812307-14948129968333031', 1, 1, 'SR', NULL, NULL, NULL),
(30360, '2017-05-15 09:49:57', NULL, NULL, 9240, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 09:49:57', 'admin-1494812307-14948129968333031', 1, 0, '', NULL, NULL, NULL),
(30361, '2017-05-15 09:49:46', NULL, NULL, 9240, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1494827320', 'admin', '2017-05-15 09:49:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30362, '2017-05-15 09:41:56', NULL, NULL, 9239, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 09:41:56', 'admin-1494812307-14948125167371657', 1, 0, '', NULL, NULL, NULL),
(30363, '2017-05-15 09:41:56', NULL, NULL, 9239, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 09:41:56', 'admin-1494812307-14948125167371657', 1, 0, '', NULL, NULL, NULL),
(30364, '2017-05-15 09:11:41', NULL, NULL, 9237, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 09:11:41', 'admin-1494810299-14948107011733028', 1, 0, '', NULL, NULL, NULL),
(30365, '2017-05-15 09:10:07', NULL, NULL, 9237, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 09:10:07', 'admin-1494810299-14948106068584339', 1, 1, 'SR', NULL, NULL, NULL),
(30366, '2017-05-15 09:10:07', NULL, NULL, 9237, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 09:10:07', 'admin-1494810299-14948106068584339', 1, 0, '', NULL, NULL, NULL),
(30367, '2017-05-15 09:10:07', NULL, NULL, 9237, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 09:10:07', 'admin-1494810299-14948106068584339', 1, 0, '', NULL, NULL, NULL),
(30368, '2017-05-15 09:09:54', NULL, NULL, 9237, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 09:09:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30369, '2017-05-15 09:08:55', NULL, NULL, 9236, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 09:08:55', 'admin-1494810299-1494810535513376', 1, 0, '', NULL, NULL, NULL),
(30370, '2017-05-15 09:08:51', NULL, NULL, 9236, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1494827320', 'admin', '2017-05-15 09:08:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30371, '2017-05-15 09:07:16', NULL, NULL, 9235, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1494827320', 'admin', '2017-05-15 09:07:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30372, '2017-05-15 09:07:25', NULL, NULL, 9235, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1494827320', 'admin', '2017-05-15 09:07:25', 'admin-1494810299-14948104451983661', 1, 0, '', NULL, NULL, NULL),
(30373, '2017-05-17 13:48:42', NULL, NULL, 9293, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.35, 0.0000, 0.0000, 7.35, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:48:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30374, '2017-05-17 13:48:56', NULL, NULL, 9293, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:48:56', 'admin-1494997310-14950001359234724', 1, 1, 'SR', NULL, NULL, NULL),
(30375, '2017-05-17 13:48:56', NULL, NULL, 9293, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:48:56', 'admin-1494997310-14950001359234724', 1, 0, '', NULL, NULL, NULL),
(30376, '2017-05-17 13:48:56', NULL, NULL, 9293, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:48:56', 'admin-1494997310-14950001359234724', 1, 0, '', NULL, NULL, NULL),
(30377, '2017-05-17 11:10:25', NULL, NULL, 9280, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1495000143', 'admin', '2017-05-17 11:10:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30378, '2017-05-17 12:08:12', NULL, NULL, 9283, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:08:12', 'admin-1494990515-14949940926835766', 1, 1, 'SR', NULL, NULL, NULL),
(30379, '2017-05-17 12:08:12', NULL, NULL, 9283, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:08:12', 'admin-1494990515-14949940926835766', 1, 0, '', NULL, NULL, NULL),
(30380, '2017-05-17 12:08:12', NULL, NULL, 9283, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:08:12', 'admin-1494990515-14949940926835766', 1, 0, '', NULL, NULL, NULL),
(30381, '2017-05-17 00:00:00', NULL, NULL, 9288, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.89, NULL, NULL, 3.89, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:09:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30382, '2017-05-17 00:00:00', NULL, NULL, 9287, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:13:26', 'admin-1494990515-14949944063709199', 1, 0, '', NULL, NULL, NULL),
(30383, '2017-05-17 12:47:08', NULL, NULL, 9287, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:47:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30384, '2017-05-17 00:00:00', NULL, NULL, 9288, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:13:26', 'admin-1494990515-14949944063709199', 1, 1, 'SR', NULL, NULL, NULL),
(30385, '2017-05-17 12:57:38', NULL, NULL, 9289, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:57:38', 'admin-1494990515-14949970582414327', 1, 1, 'SR', NULL, NULL, NULL),
(30386, '2017-05-17 16:46:17', NULL, NULL, 9298, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 16:46:17', 'admin-1495000143-14950107775106484', 1, 1, 'SR', NULL, NULL, NULL),
(30387, '2017-05-17 10:57:41', NULL, NULL, 9277, 0, 265, '199', 'Old Penang PostCard', '', 'DISCOUNT ', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 10:57:41', 'admin-1494981904-14949898610898559', 1, 0, '', 1, NULL, NULL),
(30388, '2017-05-17 11:08:26', NULL, NULL, 9278, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 11:08:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30389, '2017-05-17 11:08:30', NULL, NULL, 9278, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 11:08:30', 'admin-1494981904-14949905104721654', 1, 0, '', NULL, NULL, NULL),
(30390, '2017-05-17 11:09:32', NULL, NULL, 9279, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1495000143', 'admin', '2017-05-17 11:09:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30391, '2017-05-17 15:39:00', NULL, NULL, 9297, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 15:39:00', 'admin-1495000143-14950067405781112', 1, 0, '', NULL, NULL, NULL),
(30392, '2017-05-17 16:11:07', NULL, NULL, 9290, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 16:11:07', 'admin-1495000143-14950086672928537', 1, 1, 'SR', NULL, NULL, NULL),
(30393, '2017-05-17 13:06:07', NULL, NULL, 9290, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:06:07', 'admin-1494997310-14949975672023784', 1, 1, 'SR', NULL, NULL, NULL),
(30394, '2017-05-17 13:32:37', NULL, NULL, 9291, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:32:37', 'admin-1494997310-14949991572518469', 1, 0, '', NULL, NULL, NULL),
(30395, '2017-05-17 13:39:00', NULL, NULL, 9292, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:39:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30396, '2017-05-17 13:39:11', NULL, NULL, 9292, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:39:11', 'admin-1494997310-1494999551737883', 1, 1, 'SR', NULL, NULL, NULL),
(30397, '2017-05-17 10:41:53', NULL, NULL, 9276, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1495000143', 'admin', '2017-05-17 10:41:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30398, '2017-05-17 10:42:04', NULL, NULL, 9276, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 10:42:04', 'admin-1494981904-1494988923990839', 1, 0, '', NULL, NULL, NULL),
(30399, '2017-05-17 13:03:15', NULL, NULL, 9291, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:03:15', 'admin-1494997310-14949973951405643', 1, 1, 'SR', NULL, NULL, NULL),
(30400, '2017-05-17 13:05:37', NULL, NULL, 9290, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:05:37', 'admin-1494997310-14949975377589627', 1, 0, '', NULL, NULL, NULL),
(30401, '2017-05-17 13:39:11', NULL, NULL, 9292, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:39:11', 'admin-1494997310-1494999551737883', 1, 1, 'SR', NULL, NULL, NULL),
(30402, '2017-05-17 15:19:52', NULL, NULL, 9296, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1495000143', 'admin', '2017-05-17 15:19:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30403, '2017-05-17 15:19:57', NULL, NULL, 9296, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 15:19:57', 'admin-1495000143-14950055970872116', 1, 1, 'SR', NULL, NULL, NULL),
(30404, '2017-05-17 14:16:41', NULL, NULL, 9295, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 14:16:41', 'admin-1495000143-14950018006681646', 1, 1, 'SR', 1, NULL, NULL),
(30405, '2017-05-17 13:56:04', NULL, NULL, 9294, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:56:04', 'admin-1495000143-14950005644623658', 1, 0, '', NULL, NULL, NULL),
(30406, '2017-05-17 12:57:38', NULL, NULL, 9289, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:57:38', 'admin-1494990515-14949970582414327', 1, 1, 'SR', NULL, NULL, NULL),
(30407, '2017-05-17 16:46:13', NULL, NULL, 9298, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 16:46:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30408, '2017-05-17 13:02:11', NULL, NULL, 9290, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:02:11', 'admin-1494997310-14949973317112359', 1, 0, '', NULL, NULL, NULL),
(30409, '2017-05-17 13:02:11', NULL, NULL, 9290, 0, 217, '151', 'Spicy Lemony Wings', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:02:11', 'admin-1494997310-14949973317112359', 1, 0, '', NULL, NULL, NULL),
(30410, '2017-05-17 14:56:06', NULL, NULL, 9293, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 14:56:06', 'admin-1495000143-14950041659672244', 1, 1, 'SR', NULL, NULL, NULL),
(30411, '2017-05-17 13:56:04', NULL, NULL, 9294, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:56:04', 'admin-1495000143-14950005644623658', 1, 0, '', NULL, NULL, NULL),
(30412, '2017-05-17 13:56:04', NULL, NULL, 9294, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:56:04', 'admin-1495000143-14950005644623658', 1, 0, '', NULL, NULL, NULL),
(30413, '2017-05-17 13:56:04', NULL, NULL, 9294, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:56:04', 'admin-1495000143-14950005644623658', 1, 1, 'SR', NULL, NULL, NULL),
(30414, '2017-05-17 13:56:04', NULL, NULL, 9294, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:56:04', 'admin-1495000143-14950005644623658', 1, 1, 'SR', NULL, NULL, NULL),
(30415, '2017-05-17 15:38:57', NULL, NULL, 9297, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1495000143', 'admin', '2017-05-17 15:38:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30416, '2017-05-17 13:50:33', NULL, NULL, 9293, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:50:33', 'admin-1495000143-14950002331779929', 1, 1, 'SR', NULL, NULL, NULL),
(30417, '2017-05-17 13:55:50', NULL, NULL, 9294, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:55:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30418, '2017-05-17 10:42:04', NULL, NULL, 9276, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 10:42:04', 'admin-1494981904-1494988923990839', 1, 0, '', NULL, NULL, NULL),
(30419, '2017-05-17 10:42:04', NULL, NULL, 9276, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 10:42:04', 'admin-1494981904-1494988923990839', 1, 0, '', NULL, NULL, NULL),
(30420, '2017-05-17 10:42:58', NULL, NULL, 9276, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 10:42:58', 'admin-1494981904-14949889778909368', 1, 1, 'SR', NULL, NULL, NULL),
(30421, '2017-05-17 13:50:33', NULL, NULL, 9293, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:50:33', 'admin-1495000143-14950002331779929', 1, 1, 'SR', NULL, NULL, NULL),
(30422, '2017-05-17 12:57:02', NULL, NULL, 9289, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.50, 0.0000, 0.0000, 10.50, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:57:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30423, '2017-05-17 13:03:15', NULL, NULL, 9291, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:03:15', 'admin-1494997310-14949973951405643', 1, 1, 'SR', NULL, NULL, NULL),
(30424, '2017-05-17 13:02:11', NULL, NULL, 9290, 0, 181, '116', 'Open Food ', 'Wing No rice', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:02:11', 'admin-1494997310-14949973317112359', 1, 0, '', NULL, NULL, NULL),
(30425, '2017-05-17 13:03:02', NULL, NULL, 9291, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.45, 0.0000, 0.0000, 5.45, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:03:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30426, '2017-05-17 13:03:15', NULL, NULL, 9291, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:03:15', 'admin-1494997310-14949973951405643', 1, 1, 'SR', NULL, NULL, NULL),
(30427, '2017-05-17 13:03:15', NULL, NULL, 9291, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:03:15', 'admin-1494997310-14949973951405643', 1, 0, '', NULL, NULL, NULL),
(30428, '2017-05-17 12:57:38', NULL, NULL, 9289, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:57:38', 'admin-1494990515-14949970582414327', 1, 1, 'SR', NULL, NULL, NULL),
(30429, '2017-05-17 12:57:38', NULL, NULL, 9289, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:57:38', 'admin-1494990515-14949970582414327', 1, 0, '', NULL, NULL, NULL),
(30430, '2017-05-17 12:57:38', NULL, NULL, 9289, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:57:38', 'admin-1494990515-14949970582414327', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(30431, '2017-05-17 12:57:38', NULL, NULL, 9289, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:57:38', 'admin-1494990515-14949970582414327', 1, 1, 'SR', NULL, NULL, NULL),
(30432, '2017-05-17 12:57:38', NULL, NULL, 9289, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:57:38', 'admin-1494990515-14949970582414327', 1, 1, 'SR', NULL, NULL, NULL),
(30433, '2017-05-17 12:57:38', NULL, NULL, 9289, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:57:38', 'admin-1494990515-14949970582414327', 1, 0, '', NULL, NULL, NULL),
(30434, '2017-05-17 12:57:38', NULL, NULL, 9289, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:57:38', 'admin-1494990515-14949970582414327', 1, 0, '', NULL, NULL, NULL),
(30435, '2017-05-17 12:55:08', NULL, NULL, 9286, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:55:08', 'admin-1494990515-1494996908481746', 1, 1, 'SR', NULL, NULL, NULL),
(30436, '2017-05-17 13:50:23', NULL, NULL, 9293, 0, 181, '116', 'Open Food ', 'fried egg on hometown', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1495000143', 'admin', '2017-05-17 13:50:23', 'admin-1495000143-14950002233194953', 1, 0, '', NULL, NULL, NULL),
(30437, '2017-05-17 12:55:08', NULL, NULL, 9286, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:55:08', 'admin-1494990515-1494996908481746', 1, 1, 'SR', NULL, NULL, NULL),
(30438, '2017-05-17 12:55:08', NULL, NULL, 9286, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:55:08', 'admin-1494990515-1494996908481746', 1, 0, '', NULL, NULL, NULL),
(30439, '2017-05-17 00:00:00', NULL, NULL, 9288, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, NULL, NULL, 3.90, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:46:55', 'admin-1494990515-14949964150079815', 1, 0, '', NULL, NULL, NULL),
(30440, '2017-05-17 00:00:00', NULL, NULL, 9288, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:13:26', 'admin-1494990515-14949944063709199', 1, 1, 'SR', NULL, NULL, NULL),
(30441, '2017-05-17 00:00:00', NULL, NULL, 9287, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:13:26', 'admin-1494990515-14949944063709199', 1, 0, '', NULL, NULL, NULL),
(30442, '2017-05-17 10:21:12', NULL, NULL, 9275, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 10:21:12', 'admin-1494981904-14949876723761974', 1, 0, '', 1, NULL, NULL),
(30443, '2017-05-17 10:39:43', NULL, NULL, 9274, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 10:39:43', 'admin-1494981904-14949887829014265', 1, 1, 'SR', NULL, NULL, NULL),
(30444, '2017-05-17 09:26:39', NULL, NULL, 9273, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 09:26:39', 'admin-1494981904-14949843990593118', 1, 1, 'SR', NULL, NULL, NULL),
(30445, '2017-05-17 09:26:39', NULL, NULL, 9273, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 09:26:39', 'admin-1494981904-14949843990593118', 1, 1, 'SR', NULL, NULL, NULL),
(30446, '2017-05-17 09:26:20', NULL, NULL, 9273, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1495000143', 'admin', '2017-05-17 09:26:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30447, '2017-05-17 09:26:39', NULL, NULL, 9273, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 09:26:39', 'admin-1494981904-14949843990593118', 1, 0, '', NULL, NULL, NULL),
(30448, '2017-05-17 12:39:14', NULL, NULL, 9286, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:39:14', 'admin-1494990515-14949959547313711', 1, 1, 'SR', NULL, NULL, NULL),
(30449, '2017-05-17 12:39:14', NULL, NULL, 9286, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:39:14', 'admin-1494990515-14949959547313711', 1, 1, 'SR', NULL, NULL, NULL),
(30450, '2017-05-17 12:39:04', NULL, NULL, 9286, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:39:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30451, '2017-05-17 12:24:14', NULL, NULL, 9285, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:24:14', 'admin-1494990515-14949950539914273', 1, 1, 'SR', NULL, NULL, NULL),
(30452, '2017-05-17 12:24:14', NULL, NULL, 9285, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:24:14', 'admin-1494990515-14949950539914273', 1, 1, 'SR', NULL, NULL, NULL),
(30453, '2017-05-17 12:23:51', NULL, NULL, 9285, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:23:51', 'admin-1494990515-14949950314762732', 1, 0, '', NULL, NULL, NULL),
(30454, '2017-05-17 12:23:51', NULL, NULL, 9285, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:23:51', 'admin-1494990515-14949950314762732', 1, 1, 'SR', NULL, NULL, NULL),
(30455, '2017-05-17 00:00:00', NULL, NULL, 9287, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:13:26', 'admin-1494990515-14949944063709199', 1, 1, 'SR', NULL, NULL, NULL),
(30456, '2017-05-17 12:23:46', NULL, NULL, 9285, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:23:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30457, '2017-05-17 00:00:00', NULL, NULL, 9288, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:13:26', 'admin-1494990515-14949944063709199', 1, 1, 'SR', NULL, NULL, NULL),
(30458, '2017-05-17 00:00:00', NULL, NULL, 9287, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:13:26', 'admin-1494990515-14949944063709199', 1, 1, 'SR', NULL, NULL, NULL),
(30459, '2017-05-17 12:08:12', NULL, NULL, 9283, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:08:12', 'admin-1494990515-14949940926835766', 1, 1, 'SR', NULL, NULL, NULL),
(30460, '2017-05-17 11:48:44', NULL, NULL, 9278, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 11:48:44', 'admin-1494990515-14949929244923017', 1, 1, 'SR', NULL, NULL, NULL),
(30461, '2017-05-17 12:07:55', NULL, NULL, 9283, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1495000143', 'admin', '2017-05-17 12:07:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30462, '2017-05-17 11:55:54', NULL, NULL, 9282, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 11:55:54', 'admin-1494990515-14949933545827363', 1, 1, 'SR', NULL, NULL, NULL),
(30463, '2017-05-17 11:55:49', NULL, NULL, 9282, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1495000143', 'admin', '2017-05-17 11:55:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30464, '2017-05-17 11:10:30', NULL, NULL, 9280, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 11:10:30', 'admin-1494990515-14949906302785885', 1, 0, '', NULL, NULL, NULL),
(30465, '2017-05-17 11:10:30', NULL, NULL, 9280, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 11:10:30', 'admin-1494990515-14949906302785885', 1, 0, '', NULL, NULL, NULL),
(30466, '2017-05-17 11:09:36', NULL, NULL, 9279, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 11:09:36', 'admin-1494990515-14949905758609558', 1, 1, 'SR', NULL, NULL, NULL),
(30467, '2017-05-17 11:09:36', NULL, NULL, 9279, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 11:09:36', 'admin-1494990515-14949905758609558', 1, 1, 'SR', NULL, NULL, NULL),
(30468, '2017-05-17 10:39:43', NULL, NULL, 9274, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 10:39:43', 'admin-1494981904-14949887829014265', 1, 1, 'SR', NULL, NULL, NULL),
(30469, '2017-05-17 09:11:49', NULL, NULL, 9271, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1495000143', 'admin', '2017-05-17 09:11:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30470, '2017-05-17 09:11:57', NULL, NULL, 9271, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 09:11:57', 'admin-1494981904-14949835168687161', 1, 0, '', NULL, NULL, NULL),
(30471, '2017-05-17 09:11:57', NULL, NULL, 9271, 0, 279, '213', 'Diet Meal - Americano / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 09:11:57', 'admin-1494981904-14949835168687161', 1, 0, '', NULL, NULL, NULL),
(30472, '2017-05-17 09:57:09', NULL, NULL, 9274, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1495000143', 'admin', '2017-05-17 09:57:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30473, '2017-05-17 09:57:13', NULL, NULL, 9274, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 09:57:13', 'admin-1494981904-14949862336559236', 1, 0, '', NULL, NULL, NULL),
(30474, '2017-05-17 09:57:13', NULL, NULL, 9274, 0, 280, '214', 'Diet Meal - Piccolo / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 09:57:13', 'admin-1494981904-14949862336559236', 1, 0, '', NULL, NULL, NULL),
(30475, '2017-05-17 09:26:39', NULL, NULL, 9273, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 09:26:39', 'admin-1494981904-14949843990593118', 1, 0, '', NULL, NULL, NULL),
(30476, '2017-05-17 09:20:50', NULL, NULL, 9272, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 09:20:50', 'admin-1494981904-14949840506974840', 1, 1, 'SR', NULL, NULL, NULL),
(30477, '2017-05-17 09:20:50', NULL, NULL, 9272, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 09:20:50', 'admin-1494981904-14949840506974840', 1, 0, '', NULL, NULL, NULL),
(30478, '2017-05-17 09:20:42', NULL, NULL, 9272, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1495000143', 'admin', '2017-05-17 09:20:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30479, '2017-05-17 09:02:13', NULL, NULL, 9270, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1495000143', 'admin', '2017-05-17 09:02:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30480, '2017-05-17 09:02:21', NULL, NULL, 9270, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 09:02:21', 'admin-1494981904-14949829415348242', 1, 0, '', NULL, NULL, NULL),
(30481, '2017-05-17 09:02:21', NULL, NULL, 9270, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1495000143', 'admin', '2017-05-17 09:02:21', 'admin-1494981904-14949829415348242', 1, 1, 'SR', NULL, NULL, NULL),
(30482, '2017-05-18 15:30:34', NULL, NULL, 9310, 0, 265, '199', 'Old Penang PostCard', '', 'DISCOUNT ', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 15:30:34', 'admin-1495085098-14950926340076940', 1, 0, '', 1, NULL, NULL),
(30483, '2017-05-18 13:49:18', NULL, NULL, 9309, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 13:49:18', 'admin-1495085098-14950865583605440', 1, 1, 'SR', NULL, NULL, NULL),
(30484, '2017-05-18 13:49:18', NULL, NULL, 9309, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 13:49:18', 'admin-1495085098-14950865583605440', 1, 1, 'SR', NULL, NULL, NULL),
(30485, '2017-05-18 13:49:18', NULL, NULL, 9309, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 13:49:18', 'admin-1495085098-14950865583605440', 1, 0, '', NULL, NULL, NULL),
(30486, '2017-05-18 13:49:18', NULL, NULL, 9309, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 13:49:18', 'admin-1495085098-14950865583605440', 1, 0, '', NULL, NULL, NULL),
(30487, '2017-05-18 12:16:16', NULL, NULL, 9303, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 12:16:16', 'admin-1495069191-14950809767009862', 1, 1, 'SR', NULL, NULL, NULL),
(30488, '2017-05-18 12:13:46', NULL, NULL, 9303, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 12:13:46', 'admin-1495069191-14950808260122257', 1, 0, '', NULL, NULL, NULL),
(30489, '2017-05-18 13:24:53', NULL, NULL, 9307, 0, 77, '77', 'Sarawak Kolomee', 'add fried egg', 'Meals', 'Perfect Meals', 1, 13.50, 13.5000, 0.0000, 13.50, 1, '27', 1, '1495085098', 'admin', '2017-05-18 13:24:53', 'admin-1495069191-14950850928291235', 1, 1, 'SR', NULL, NULL, NULL),
(30490, '2017-05-18 13:25:10', NULL, NULL, 9307, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 13:25:10', 'admin-1495085098-14950851098722421', 1, 1, 'SR', NULL, NULL, NULL),
(30491, '2017-05-18 13:47:46', NULL, NULL, 9308, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1495085098', 'admin', '2017-05-18 13:47:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30492, '2017-05-18 13:47:49', NULL, NULL, 9308, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 13:47:49', 'admin-1495085098-14950864691175474', 1, 1, 'SR', NULL, NULL, NULL),
(30493, '2017-05-18 13:49:11', NULL, NULL, 9309, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1495085098', 'admin', '2017-05-18 13:49:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30494, '2017-05-18 13:09:30', NULL, NULL, 9306, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 13:09:30', 'admin-1495069191-14950841707276440', 1, 1, 'SR', 1, NULL, NULL),
(30495, '2017-05-18 13:24:35', NULL, NULL, 9307, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.55, 0.0000, 0.0000, 2.55, 1, '27', 1, '1495085098', 'admin', '2017-05-18 13:24:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30496, '2017-05-18 12:23:12', NULL, NULL, 9305, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 12:23:12', 'admin-1495069191-14950813922067174', 1, 1, 'SR', NULL, NULL, NULL),
(30497, '2017-05-18 12:23:03', NULL, NULL, 9305, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1495085098', 'admin', '2017-05-18 12:23:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30498, '2017-05-18 12:23:12', NULL, NULL, 9305, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 12:23:12', 'admin-1495069191-14950813922067174', 1, 0, '', NULL, NULL, NULL),
(30499, '2017-05-18 12:21:27', NULL, NULL, 9304, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 12:21:27', 'admin-1495069191-14950812872506514', 1, 0, '', NULL, NULL, NULL),
(30500, '2017-05-18 12:21:27', NULL, NULL, 9304, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 12:21:27', 'admin-1495069191-14950812872506514', 1, 1, 'SR', NULL, NULL, NULL),
(30501, '2017-05-18 12:16:29', NULL, NULL, 9304, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 12:16:29', 'admin-1495069191-14950809889441383', 1, 1, 'SR', NULL, NULL, NULL),
(30502, '2017-05-18 12:21:27', NULL, NULL, 9304, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 12:21:27', 'admin-1495069191-14950812872506514', 1, 0, '', NULL, NULL, NULL),
(30503, '2017-05-18 12:16:23', NULL, NULL, 9304, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1495085098', 'admin', '2017-05-18 12:16:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30504, '2017-05-18 09:39:41', NULL, NULL, 9300, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 09:39:41', 'admin-1495069191-14950715810693812', 1, 1, 'SR', NULL, NULL, NULL),
(30505, '2017-05-18 09:40:18', NULL, NULL, 9300, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 09:40:18', 'admin-1495069191-14950716180566792', 1, 0, '', NULL, NULL, NULL),
(30506, '2017-05-18 10:07:43', NULL, NULL, 9301, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1495085098', 'admin', '2017-05-18 10:07:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30507, '2017-05-18 10:08:49', NULL, NULL, 9301, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 10:08:49', 'admin-1495069191-14950733296786879', 1, 1, 'SR', NULL, NULL, NULL),
(30508, '2017-05-18 10:44:11', NULL, NULL, 9302, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1495085098', 'admin', '2017-05-18 10:44:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30509, '2017-05-18 10:44:15', NULL, NULL, 9302, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 10:44:15', 'admin-1495069191-14950754553252623', 1, 1, 'SR', NULL, NULL, NULL),
(30510, '2017-05-18 10:44:15', NULL, NULL, 9302, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 10:44:15', 'admin-1495069191-14950754553252623', 1, 1, 'SR', NULL, NULL, NULL),
(30511, '2017-05-18 11:07:47', NULL, NULL, 9301, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 11:07:47', 'admin-1495069191-14950768671053612', 1, 0, '', NULL, NULL, NULL),
(30512, '2017-05-18 12:11:41', NULL, NULL, 9303, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1495085098', 'admin', '2017-05-18 12:11:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30513, '2017-05-18 12:12:32', NULL, NULL, 9303, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 12:12:32', 'admin-1495069191-14950807528255722', 1, 0, '', NULL, NULL, NULL),
(30514, '2017-05-18 12:12:32', NULL, NULL, 9303, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 12:12:32', 'admin-1495069191-14950807528255722', 1, 0, '', NULL, NULL, NULL),
(30515, '2017-05-18 09:39:20', NULL, NULL, 9299, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 09:39:20', 'admin-1495069191-14950715606934875', 1, 1, 'SR', NULL, NULL, NULL),
(30516, '2017-05-18 09:39:38', NULL, NULL, 9300, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1495085098', 'admin', '2017-05-18 09:39:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30517, '2017-05-18 09:39:20', NULL, NULL, 9299, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495085098', 'admin', '2017-05-18 09:39:20', 'admin-1495069191-14950715606934875', 1, 1, 'SR', NULL, NULL, NULL),
(30518, '2017-05-18 09:39:01', NULL, NULL, 9299, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1495085098', 'admin', '2017-05-18 09:39:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30519, '2017-05-19 10:31:38', NULL, NULL, 9318, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 10:31:38', 'admin-1495160647-14951610978316595', 1, 1, 'SR', NULL, NULL, NULL),
(30520, '2017-05-19 10:31:38', NULL, NULL, 9318, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 10:31:38', 'admin-1495160647-14951610978316595', 1, 0, '', NULL, NULL, NULL),
(30521, '2017-05-19 10:31:38', NULL, NULL, 9318, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 10:31:38', 'admin-1495160647-14951610978316595', 1, 0, '', NULL, NULL, NULL),
(30522, '2017-05-19 10:31:38', NULL, NULL, 9318, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 10:31:38', 'admin-1495160647-14951610978316595', 1, 0, '', NULL, NULL, NULL),
(30523, '2017-05-19 10:58:21', NULL, NULL, 9319, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1495170643', 'admin', '2017-05-19 10:58:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30524, '2017-05-19 10:58:28', NULL, NULL, 9319, 0, 279, '213', 'Diet Meal - Americano / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 10:58:28', 'admin-1495160647-14951627084641136', 1, 0, '', NULL, NULL, NULL),
(30525, '2017-05-19 10:58:59', NULL, NULL, 9320, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 10:58:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30526, '2017-05-19 10:59:08', NULL, NULL, 9320, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 10:59:08', 'admin-1495160647-14951627479308598', 1, 1, 'SR', NULL, NULL, NULL),
(30527, '2017-05-19 11:00:44', NULL, NULL, 9320, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 11:00:44', 'admin-1495160647-1495162844453257', 1, 0, '', NULL, NULL, NULL),
(30528, '2017-05-19 11:03:17', NULL, NULL, 9321, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1495170643', 'admin', '2017-05-19 11:03:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30529, '2017-05-19 11:03:20', NULL, NULL, 9321, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 11:03:20', 'admin-1495160647-14951630001851141', 1, 0, '', NULL, NULL, NULL),
(30530, '2017-05-19 14:30:18', NULL, NULL, 9328, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 14:30:18', 'admin-1495170643-14951754180091913', 1, 1, 'SR', 1, NULL, NULL),
(30531, '2017-05-19 14:30:18', NULL, NULL, 9328, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 14:30:18', 'admin-1495170643-14951754180091913', 1, 1, 'SR', 1, NULL, NULL),
(30532, '2017-05-19 14:48:07', NULL, NULL, 9329, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 14:48:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30533, '2017-05-19 14:55:35', NULL, NULL, 9331, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1495170643', 'admin', '2017-05-19 14:55:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30534, '2017-05-19 14:55:37', NULL, NULL, 9331, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 14:55:37', 'admin-1495170643-14951769375415453', 1, 1, 'SR', NULL, NULL, NULL),
(30535, '2017-05-19 11:03:49', NULL, NULL, 9321, 0, 279, '213', 'Diet Meal - Americano / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 11:03:49', 'admin-1495160647-14951630289181659', 1, 0, '', NULL, NULL, NULL),
(30536, '2017-05-19 11:05:06', NULL, NULL, 9321, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 11:05:06', 'admin-1495160647-14951631059181798', 1, 0, '', NULL, NULL, NULL),
(30537, '2017-05-19 11:06:04', NULL, NULL, 9322, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 11:06:04', 'admin-1495160647-14951631642354326', 1, 0, '', 1, NULL, NULL),
(30538, '2017-05-19 10:26:06', NULL, NULL, 9317, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 10:26:06', 'admin-1495160647-14951607664478168', 1, 1, 'SR', NULL, NULL, NULL),
(30539, '2017-05-19 10:31:25', NULL, NULL, 9318, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1495170643', 'admin', '2017-05-19 10:31:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30540, '2017-05-19 10:31:38', NULL, NULL, 9318, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 10:31:38', 'admin-1495160647-14951610978316595', 1, 1, 'SR', NULL, NULL, NULL),
(30541, '2017-05-19 12:06:00', NULL, NULL, 9323, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 12:06:00', 'admin-1495160647-14951667602868565', 1, 1, 'SR', 1, NULL, NULL),
(30542, '2017-05-19 12:58:21', NULL, NULL, 9324, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1495170643', 'admin', '2017-05-19 12:58:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30543, '2017-05-19 12:58:26', NULL, NULL, 9324, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 12:58:26', 'admin-1495160647-14951699059269528', 1, 1, 'SR', NULL, NULL, NULL),
(30544, '2017-05-19 13:09:39', NULL, NULL, 9325, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1495170643', 'admin', '2017-05-19 13:09:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30545, '2017-05-19 17:11:59', NULL, NULL, 9334, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 17:11:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30546, '2017-05-19 17:12:09', NULL, NULL, 9334, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 17:12:09', 'admin-1495170643-14951851289976761', 1, 1, 'SR', NULL, NULL, NULL),
(30547, '2017-05-19 17:12:09', NULL, NULL, 9334, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 17:12:09', 'admin-1495170643-14951851289976761', 1, 0, '', NULL, NULL, NULL),
(30548, '2017-05-19 14:49:30', NULL, NULL, 9330, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1495170643', 'admin', '2017-05-19 14:49:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30549, '2017-05-19 16:46:57', NULL, NULL, 9333, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 16:46:57', 'admin-1495170643-14951836170791457', 1, 1, 'SR', NULL, NULL, NULL),
(30550, '2017-05-19 16:46:57', NULL, NULL, 9333, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 16:46:57', 'admin-1495170643-14951836170791457', 1, 1, 'SR', NULL, NULL, NULL),
(30551, '2017-05-19 16:46:54', NULL, NULL, 9333, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1495170643', 'admin', '2017-05-19 16:46:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30552, '2017-05-19 15:05:57', NULL, NULL, 9332, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 15:05:57', 'admin-1495170643-14951775572343315', 1, 0, '', NULL, NULL, NULL),
(30553, '2017-05-19 15:39:03', NULL, NULL, 9331, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 15:39:03', 'admin-1495170643-14951795430032175', 1, 0, '', NULL, NULL, NULL),
(30554, '2017-05-19 15:05:57', NULL, NULL, 9332, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 15:05:57', 'admin-1495170643-14951775572343315', 1, 1, 'SR', NULL, NULL, NULL),
(30555, '2017-05-19 15:05:51', NULL, NULL, 9332, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1495170643', 'admin', '2017-05-19 15:05:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30556, '2017-05-19 14:49:28', NULL, NULL, 9329, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 14:49:28', 'admin-1495170643-14951765681657735', 1, 1, 'SR', NULL, NULL, NULL),
(30557, '2017-05-19 14:49:32', NULL, NULL, 9330, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 14:49:32', 'admin-1495170643-14951765726718462', 1, 1, 'SR', NULL, NULL, NULL),
(30558, '2017-05-19 14:48:13', NULL, NULL, 9329, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 14:48:13', 'admin-1495170643-149517649343692', 1, 0, '', NULL, NULL, NULL),
(30559, '2017-05-19 14:15:02', NULL, NULL, 9327, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 14:15:02', 'admin-1495170643-14951745022125377', 1, 1, 'SR', NULL, NULL, NULL),
(30560, '2017-05-19 14:48:13', NULL, NULL, 9329, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 14:48:13', 'admin-1495170643-149517649343692', 1, 1, 'SR', NULL, NULL, NULL),
(30561, '2017-05-19 14:15:02', NULL, NULL, 9327, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 14:15:02', 'admin-1495170643-14951745022125377', 1, 1, 'SR', NULL, NULL, NULL),
(30562, '2017-05-19 14:14:59', NULL, NULL, 9327, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1495170643', 'admin', '2017-05-19 14:14:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30563, '2017-05-19 13:11:21', NULL, NULL, 9326, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 13:11:21', 'admin-1495170643-14951706811134546', 1, 1, 'SR', NULL, NULL, NULL),
(30564, '2017-05-19 13:11:21', NULL, NULL, 9326, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 13:11:21', 'admin-1495170643-14951706811134546', 1, 1, 'SR', NULL, NULL, NULL),
(30565, '2017-05-19 13:11:21', NULL, NULL, 9326, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 13:11:21', 'admin-1495170643-14951706811134546', 1, 1, 'SR', NULL, NULL, NULL),
(30566, '2017-05-19 13:11:21', NULL, NULL, 9326, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 13:11:21', 'admin-1495170643-14951706811134546', 1, 0, '', NULL, NULL, NULL),
(30567, '2017-05-19 13:11:21', NULL, NULL, 9326, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 13:11:21', 'admin-1495170643-14951706811134546', 1, 1, 'SR', NULL, NULL, NULL),
(30568, '2017-05-19 13:11:21', NULL, NULL, 9326, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 13:11:21', 'admin-1495170643-14951706811134546', 1, 0, '', NULL, NULL, NULL),
(30569, '2017-05-19 13:11:21', NULL, NULL, 9326, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 13:11:21', 'admin-1495170643-14951706811134546', 1, 0, '', NULL, NULL, NULL),
(30570, '2017-05-19 13:10:50', NULL, NULL, 9326, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.40, 0.0000, 0.0000, 11.40, 1, '27', 1, '1495170643', 'admin', '2017-05-19 13:10:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30571, '2017-05-19 13:11:21', NULL, NULL, 9326, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 13:11:21', 'admin-1495170643-14951706811134546', 1, 1, 'SR', NULL, NULL, NULL),
(30572, '2017-05-19 13:09:48', NULL, NULL, 9325, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 13:09:48', 'admin-1495160647-14951705879907121', 1, 1, 'SR', NULL, NULL, NULL),
(30573, '2017-05-19 13:09:48', NULL, NULL, 9325, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 13:09:48', 'admin-1495160647-14951705879907121', 1, 1, 'SR', NULL, NULL, NULL),
(30574, '2017-05-19 12:06:00', NULL, NULL, 9323, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 12:06:00', 'admin-1495160647-14951667602868565', 1, 1, 'SR', 1, NULL, NULL),
(30575, '2017-05-19 12:06:00', NULL, NULL, 9323, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 12:06:00', 'admin-1495160647-14951667602868565', 1, 1, 'SR', 1, NULL, NULL),
(30576, '2017-05-19 10:26:06', NULL, NULL, 9317, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 10:26:06', 'admin-1495160647-14951607664478168', 1, 0, '', NULL, NULL, NULL),
(30577, '2017-05-19 10:26:06', NULL, NULL, 9317, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 10:26:06', 'admin-1495160647-14951607664478168', 1, 0, '', NULL, NULL, NULL),
(30578, '2017-05-19 09:37:01', NULL, NULL, 9315, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1495170643', 'admin', '2017-05-19 09:37:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30579, '2017-05-19 10:31:38', NULL, NULL, 9318, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 10:31:38', 'admin-1495160647-14951610978316595', 1, 0, '', NULL, NULL, NULL),
(30580, '2017-05-19 10:25:48', NULL, NULL, 9317, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1495170643', 'admin', '2017-05-19 10:25:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30581, '2017-05-19 10:25:54', NULL, NULL, 9317, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 10:25:54', 'admin-1495160647-14951607542582251', 1, 0, '', NULL, NULL, NULL),
(30582, '2017-05-19 10:20:33', NULL, NULL, 9316, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 10:20:33', 'admin-1495154371-14951604334337760', 1, 0, '', NULL, NULL, NULL),
(30583, '2017-05-19 10:20:33', NULL, NULL, 9316, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 10:20:33', 'admin-1495154371-14951604334337760', 1, 0, '', NULL, NULL, NULL),
(30584, '2017-05-19 10:20:29', NULL, NULL, 9316, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1495170643', 'admin', '2017-05-19 10:20:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30585, '2017-05-19 09:37:13', NULL, NULL, 9315, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 09:37:13', 'admin-1495154371-14951578335743178', 1, 1, 'SR', NULL, NULL, NULL),
(30586, '2017-05-19 10:16:55', NULL, NULL, 9315, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 10:16:55', 'admin-1495154371-14951602147924621', 1, 1, 'SR', NULL, NULL, NULL),
(30587, '2017-05-19 09:37:13', NULL, NULL, 9315, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 09:37:13', 'admin-1495154371-14951578335743178', 1, 0, '', NULL, NULL, NULL),
(30588, '2017-05-19 09:29:51', NULL, NULL, 9314, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 09:29:51', 'admin-1495154371-1495157390954154', 1, 0, '', NULL, NULL, NULL),
(30589, '2017-05-19 09:29:29', NULL, NULL, 9314, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1495170643', 'admin', '2017-05-19 09:29:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30590, '2017-05-19 09:29:45', NULL, NULL, 9314, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 09:29:45', 'admin-1495154371-14951573848152382', 1, 0, '', NULL, NULL, NULL),
(30591, '2017-05-19 09:29:45', NULL, NULL, 9314, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 09:29:45', 'admin-1495154371-14951573848152382', 1, 0, '', NULL, NULL, NULL),
(30592, '2017-05-19 09:29:45', NULL, NULL, 9314, 0, 157, '91', 'French Toast with Fruits', 'no honey', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 09:29:45', 'admin-1495154371-14951573848152382', 1, 0, '', NULL, NULL, NULL),
(30593, '2017-05-19 09:29:51', NULL, NULL, 9314, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 09:29:51', 'admin-1495154371-1495157390954154', 1, 1, 'SR', NULL, NULL, NULL),
(30594, '2017-05-19 09:23:14', NULL, NULL, 9312, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1495170643', 'admin', '2017-05-19 09:23:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30595, '2017-05-19 09:23:25', NULL, NULL, 9312, 0, 283, '217', 'Weight Gain Deal - TBP / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 09:23:25', 'admin-1495154371-14951570055065144', 1, 0, '', NULL, NULL, NULL),
(30596, '2017-05-19 09:23:25', NULL, NULL, 9312, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 09:23:25', 'admin-1495154371-14951570055065144', 1, 0, '', NULL, NULL, NULL),
(30597, '2017-05-19 09:25:19', NULL, NULL, 9313, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1495170643', 'admin', '2017-05-19 09:25:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30598, '2017-05-19 09:25:28', NULL, NULL, 9313, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 09:25:28', 'admin-1495154371-14951571287353376', 1, 0, '', NULL, NULL, NULL),
(30599, '2017-05-19 09:25:28', NULL, NULL, 9313, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 09:25:28', 'admin-1495154371-14951571287353376', 1, 0, '', NULL, NULL, NULL),
(30600, '2017-05-19 09:25:28', NULL, NULL, 9313, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 09:25:28', 'admin-1495154371-14951571287353376', 1, 0, '', NULL, NULL, NULL),
(30601, '2017-05-19 09:11:45', NULL, NULL, 9311, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495170643', 'admin', '2017-05-19 09:11:45', 'admin-1495154371-14951563050533570', 1, 0, '', NULL, NULL, NULL),
(30602, '2017-05-19 09:11:40', NULL, NULL, 9311, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1495170643', 'admin', '2017-05-19 09:11:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30603, '2017-05-20 14:13:08', NULL, NULL, 9361, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:13:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30604, '2017-05-20 14:13:12', NULL, NULL, 9361, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:13:12', 'admin-1495255615-14952607919466232', 1, 1, 'SR', NULL, NULL, NULL),
(30605, '2017-05-20 14:13:17', NULL, NULL, 9361, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:13:17', 'admin-1495255615-14952607977201956', 1, 0, '', NULL, NULL, NULL),
(30606, '2017-05-20 14:17:11', NULL, NULL, 9362, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:17:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30607, '2017-05-20 14:17:21', NULL, NULL, 9362, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:17:21', 'admin-1495255615-14952610410492163', 1, 1, 'SR', NULL, NULL, NULL),
(30608, '2017-05-20 11:06:49', NULL, NULL, 9346, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1495268667', 'admin', '2017-05-20 11:06:49', 'admin-1495245508-1495249609718776', 1, 0, '', NULL, NULL, NULL),
(30609, '2017-05-20 09:58:52', NULL, NULL, 9340, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:58:52', 'admin-1495245508-14952455318804391', 1, 1, 'SR', NULL, NULL, NULL),
(30610, '2017-05-20 09:58:52', NULL, NULL, 9340, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:58:52', 'admin-1495245508-14952455318804391', 1, 1, 'SR', NULL, NULL, NULL),
(30611, '2017-05-20 09:58:52', NULL, NULL, 9340, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:58:52', 'admin-1495245508-14952455318804391', 1, 1, 'SR', NULL, NULL, NULL),
(30612, '2017-05-20 09:58:52', NULL, NULL, 9340, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:58:52', 'admin-1495245508-14952455318804391', 1, 0, '', NULL, NULL, NULL),
(30613, '2017-05-20 09:58:52', NULL, NULL, 9340, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:58:52', 'admin-1495245508-14952455318804391', 1, 1, 'SR', NULL, NULL, NULL),
(30614, '2017-05-20 10:07:20', NULL, NULL, 9341, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:07:20', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(30615, '2017-05-20 10:07:29', NULL, NULL, 9341, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:07:29', 'admin-1495245508-14952460490328929', 1, 0, '', NULL, NULL, NULL),
(30616, '2017-05-20 10:07:29', NULL, NULL, 9341, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:07:29', 'admin-1495245508-14952460490328929', 1, 0, '', NULL, NULL, NULL),
(30617, '2017-05-20 10:07:29', NULL, NULL, 9341, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:07:29', 'admin-1495245508-14952460490328929', 1, 1, 'SR', NULL, NULL, NULL),
(30618, '2017-05-20 10:07:29', NULL, NULL, 9341, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:07:29', 'admin-1495245508-14952460490328929', 1, 1, 'SR', NULL, NULL, NULL),
(30619, '2017-05-20 10:20:14', NULL, NULL, 9342, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:20:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30620, '2017-05-20 10:20:19', NULL, NULL, 9342, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:20:19', 'admin-1495245508-14952468197537227', 1, 0, '', NULL, NULL, NULL),
(30621, '2017-05-20 14:28:35', NULL, NULL, 9363, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:28:35', 'admin-1495255615-1495261715495494', 1, 1, 'SR', NULL, NULL, NULL),
(30622, '2017-05-20 11:16:21', NULL, NULL, 9348, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1495268667', 'admin', '2017-05-20 11:16:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30623, '2017-05-20 11:18:01', NULL, NULL, 9348, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 11:18:01', 'admin-1495245508-14952502813273650', 1, 1, 'SR', NULL, NULL, NULL),
(30624, '2017-05-20 16:24:18', NULL, NULL, 9374, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1495268667', 'admin', '2017-05-20 16:24:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30625, '2017-05-20 16:25:02', NULL, NULL, 9374, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 16:25:02', 'admin-1495268667-14952687021441040', 1, 0, '', NULL, NULL, NULL),
(30626, '2017-05-20 16:54:18', NULL, NULL, 9375, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1495268667', 'admin', '2017-05-20 16:54:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30627, '2017-05-20 16:54:23', NULL, NULL, 9375, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 16:54:23', 'admin-1495268667-1495270462790537', 1, 1, 'SR', NULL, NULL, NULL),
(30628, '2017-05-20 16:54:23', NULL, NULL, 9375, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 16:54:23', 'admin-1495268667-1495270462790537', 1, 0, '', NULL, NULL, NULL),
(30629, '2017-05-20 17:31:09', NULL, NULL, 9376, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 17:31:09', 'admin-1495268667-14952726692097739', 1, 1, 'SR', 1, NULL, NULL),
(30630, '2017-05-20 15:00:55', NULL, NULL, 9366, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1495268667', 'admin', '2017-05-20 15:00:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30631, '2017-05-20 15:03:51', NULL, NULL, 9366, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 15:03:51', 'admin-1495255615-14952638315344433', 1, 0, '', NULL, NULL, NULL),
(30632, '2017-05-20 15:04:58', NULL, NULL, 9367, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1495268667', 'admin', '2017-05-20 15:04:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30633, '2017-05-20 15:05:16', NULL, NULL, 9367, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 15:05:16', 'admin-1495255615-14952639159508832', 1, 1, 'SR', NULL, NULL, NULL),
(30634, '2017-05-20 15:05:16', NULL, NULL, 9367, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 15:05:16', 'admin-1495255615-14952639159508832', 1, 1, 'SR', NULL, NULL, NULL),
(30635, '2017-05-20 15:05:16', NULL, NULL, 9367, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 15:05:16', 'admin-1495255615-14952639159508832', 1, 0, '', NULL, NULL, NULL),
(30636, '2017-05-20 15:05:16', NULL, NULL, 9367, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 15:05:16', 'admin-1495255615-14952639159508832', 1, 0, '', NULL, NULL, NULL),
(30637, '2017-05-20 00:00:00', NULL, NULL, 9368, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:40:42', 'admin-1495255615-14952624427896768', 1, 1, 'SR', NULL, NULL, NULL),
(30638, '2017-05-20 00:00:00', NULL, NULL, 9369, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:40:49', 'admin-1495255615-14952624489661289', 1, 1, 'SR', NULL, NULL, NULL),
(30639, '2017-05-20 12:07:44', NULL, NULL, 9352, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:07:44', 'admin-1495251509-14952532644183164', 1, 1, 'SR', NULL, NULL, NULL),
(30640, '2017-05-20 12:07:44', NULL, NULL, 9352, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:07:44', 'admin-1495251509-14952532644183164', 1, 1, 'SR', NULL, NULL, NULL),
(30641, '2017-05-20 14:00:10', NULL, NULL, 9360, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:00:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30642, '2017-05-20 14:00:21', NULL, NULL, 9360, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:00:21', 'admin-1495255615-14952600216213199', 1, 0, '', NULL, NULL, NULL),
(30643, '2017-05-20 12:50:52', NULL, NULL, 9357, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:50:52', 'admin-1495255615-14952558518676974', 1, 1, 'SR', NULL, NULL, NULL),
(30644, '2017-05-20 12:54:07', NULL, NULL, 9358, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:54:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30645, '2017-05-20 12:54:11', NULL, NULL, 9358, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:54:11', 'admin-1495255615-14952560516131423', 1, 1, 'SR', NULL, NULL, NULL),
(30646, '2017-05-20 12:07:33', NULL, NULL, 9352, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:07:33', 'admin-1495251509-14952532535525423', 1, 0, '', NULL, NULL, NULL),
(30647, '2017-05-20 09:58:23', NULL, NULL, 9340, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:58:23', 'admin-1495241063-14952455030067146', 1, 0, '', NULL, NULL, NULL),
(30648, '2017-05-20 09:58:52', NULL, NULL, 9340, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:58:52', 'admin-1495245508-14952455318804391', 1, 0, '', NULL, NULL, NULL),
(30649, '2017-05-20 09:58:52', NULL, NULL, 9340, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:58:52', 'admin-1495245508-14952455318804391', 1, 1, 'SR', NULL, NULL, NULL),
(30650, '2017-05-20 12:50:22', NULL, NULL, 9357, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:50:22', 'admin-1495255615-14952558222599048', 1, 1, 'SR', NULL, NULL, NULL),
(30651, '2017-05-20 12:13:11', NULL, NULL, 9354, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:13:11', 'admin-1495251509-14952535911441963', 1, 0, '', NULL, NULL, NULL),
(30652, '2017-05-20 12:13:11', NULL, NULL, 9354, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:13:11', 'admin-1495251509-14952535911441963', 1, 0, '', NULL, NULL, NULL),
(30653, '2017-05-20 12:33:37', NULL, NULL, 9355, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:33:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30654, '2017-05-20 16:21:45', NULL, NULL, 9370, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 16:21:45', 'admin-1495255615-1495268505105431', 1, 0, '', NULL, NULL, NULL),
(30655, '2017-05-20 16:23:21', NULL, NULL, 9372, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 16:23:21', 'admin-1495255615-14952686013993549', 1, 1, 'SR', NULL, NULL, NULL),
(30656, '2017-05-20 16:22:30', NULL, NULL, 9371, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1495268667', 'admin', '2017-05-20 16:22:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30657, '2017-05-20 16:22:33', NULL, NULL, 9371, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 16:22:33', 'admin-1495255615-14952685532536330', 1, 1, 'SR', NULL, NULL, NULL),
(30658, '2017-05-20 14:28:35', NULL, NULL, 9363, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:28:35', 'admin-1495255615-1495261715495494', 1, 0, '', NULL, NULL, NULL),
(30659, '2017-05-20 12:07:44', NULL, NULL, 9352, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:07:44', 'admin-1495251509-14952532644183164', 1, 1, 'SR', NULL, NULL, NULL),
(30660, '2017-05-20 12:07:44', NULL, NULL, 9352, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:07:44', 'admin-1495251509-14952532644183164', 1, 1, 'SR', NULL, NULL, NULL),
(30661, '2017-05-20 14:28:35', NULL, NULL, 9363, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:28:35', 'admin-1495255615-1495261715495494', 1, 0, '', NULL, NULL, NULL),
(30662, '2017-05-20 12:13:11', NULL, NULL, 9354, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:13:11', 'admin-1495251509-14952535911441963', 1, 0, '', NULL, NULL, NULL),
(30663, '2017-05-20 12:13:11', NULL, NULL, 9354, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:13:11', 'admin-1495251509-14952535911441963', 1, 0, '', NULL, NULL, NULL),
(30664, '2017-05-20 11:18:01', NULL, NULL, 9348, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 11:18:01', 'admin-1495245508-14952502813273650', 1, 0, '', NULL, NULL, NULL),
(30665, '2017-05-20 14:28:35', NULL, NULL, 9363, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:28:35', 'admin-1495255615-1495261715495494', 1, 1, 'SR', NULL, NULL, NULL),
(30666, '2017-05-20 14:28:03', NULL, NULL, 9363, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:28:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30667, '2017-05-20 16:23:42', NULL, NULL, 9373, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1495268667', 'admin', '2017-05-20 16:23:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30668, '2017-05-20 16:23:04', NULL, NULL, 9372, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1495268667', 'admin', '2017-05-20 16:23:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30669, '2017-05-20 16:21:38', NULL, NULL, 9370, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1495268667', 'admin', '2017-05-20 16:21:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30670, '2017-05-20 16:21:45', NULL, NULL, 9370, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 16:21:45', 'admin-1495255615-1495268505105431', 1, 1, 'SR', NULL, NULL, NULL),
(30671, '2017-05-20 14:44:32', NULL, NULL, 9365, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:44:32', 'admin-1495255615-14952626720055853', 1, 1, 'SR', NULL, NULL, NULL),
(30672, '2017-05-20 14:44:32', NULL, NULL, 9365, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:44:32', 'admin-1495255615-14952626720055853', 1, 0, '', NULL, NULL, NULL),
(30673, '2017-05-20 00:00:00', NULL, NULL, 9369, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:40:42', 'admin-1495255615-14952624427896768', 1, 0, '', NULL, NULL, NULL),
(30674, '2017-05-20 14:44:13', NULL, NULL, 9365, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:44:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30675, '2017-05-20 14:44:32', NULL, NULL, 9365, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:44:32', 'admin-1495255615-14952626720055853', 1, 1, 'SR', NULL, NULL, NULL),
(30676, '2017-05-20 14:00:38', NULL, NULL, 9360, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:00:38', 'admin-1495255615-14952600378955632', 1, 1, 'SR', NULL, NULL, NULL),
(30677, '2017-05-20 12:50:22', NULL, NULL, 9357, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:50:22', 'admin-1495255615-14952558222599048', 1, 0, '', NULL, NULL, NULL),
(30678, '2017-05-20 12:50:22', NULL, NULL, 9357, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:50:22', 'admin-1495255615-14952558222599048', 1, 0, '', NULL, NULL, NULL),
(30679, '2017-05-20 00:00:00', NULL, NULL, 9368, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:40:49', 'admin-1495255615-14952624489661289', 1, 0, '', NULL, NULL, NULL),
(30680, '2017-05-20 00:00:00', NULL, NULL, 9369, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, NULL, NULL, 2.10, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:40:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30681, '2017-05-20 15:10:32', NULL, NULL, 9368, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1495268667', 'admin', '2017-05-20 15:10:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30682, '2017-05-20 13:56:02', NULL, NULL, 9359, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1495268667', 'admin', '2017-05-20 13:56:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30683, '2017-05-20 16:23:45', NULL, NULL, 9373, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 16:23:45', 'admin-1495255615-14952686255287552', 1, 1, 'SR', NULL, NULL, NULL),
(30684, '2017-05-20 10:20:26', NULL, NULL, 9342, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:20:26', 'admin-1495245508-1495246826382867', 1, 1, 'SR', NULL, NULL, NULL),
(30685, '2017-05-20 10:20:53', NULL, NULL, 9343, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:20:53', 'admin-1495245508-14952468532414569', 1, 1, 'SR', 1, NULL, NULL),
(30686, '2017-05-20 10:35:03', NULL, NULL, 9340, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:35:03', 'admin-1495245508-14952477028715171', 1, 1, 'SR', NULL, NULL, NULL),
(30687, '2017-05-20 12:33:49', NULL, NULL, 9355, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:33:49', 'admin-1495251509-14952548288962488', 1, 1, 'SR', NULL, NULL, NULL),
(30688, '2017-05-20 12:38:37', NULL, NULL, 9356, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:38:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30689, '2017-05-20 12:38:46', NULL, NULL, 9356, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:38:46', 'admin-1495251509-1495255126450933', 1, 0, '', NULL, NULL, NULL),
(30690, '2017-05-20 12:38:46', NULL, NULL, 9356, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:38:46', 'admin-1495251509-1495255126450933', 1, 1, 'SR', NULL, NULL, NULL),
(30691, '2017-05-20 12:49:32', NULL, NULL, 9357, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:49:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30692, '2017-05-20 12:33:49', NULL, NULL, 9355, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:33:49', 'admin-1495251509-14952548288962488', 1, 0, '', NULL, NULL, NULL),
(30693, '2017-05-20 12:07:33', NULL, NULL, 9352, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:07:33', 'admin-1495251509-14952532535525423', 1, 0, '', NULL, NULL, NULL),
(30694, '2017-05-20 12:04:41', NULL, NULL, 9351, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:04:41', 'admin-1495251509-14952530817671856', 1, 1, 'SR', NULL, NULL, NULL),
(30695, '2017-05-20 12:07:25', NULL, NULL, 9352, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:07:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30696, '2017-05-20 11:38:23', NULL, NULL, 9349, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 11:38:23', 'admin-1495245508-14952515036305866', 1, 0, '', NULL, NULL, NULL),
(30697, '2017-05-20 11:38:23', NULL, NULL, 9349, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 11:38:23', 'admin-1495245508-14952515036305866', 1, 1, 'SR', NULL, NULL, NULL),
(30698, '2017-05-20 13:56:06', NULL, NULL, 9359, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 13:56:06', 'admin-1495255615-14952597658992518', 1, 1, 'SR', NULL, NULL, NULL),
(30699, '2017-05-20 11:38:23', NULL, NULL, 9349, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 11:38:23', 'admin-1495245508-14952515036305866', 1, 1, 'SR', NULL, NULL, NULL),
(30700, '2017-05-20 14:28:35', NULL, NULL, 9363, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 14:28:35', 'admin-1495255615-1495261715495494', 1, 0, '', NULL, NULL, NULL),
(30701, '2017-05-20 12:10:09', NULL, NULL, 9353, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:10:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30702, '2017-05-20 12:10:34', NULL, NULL, 9353, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:10:34', 'admin-1495251509-14952534346375356', 1, 1, 'SR', NULL, NULL, NULL),
(30703, '2017-05-20 12:10:34', NULL, NULL, 9353, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:10:34', 'admin-1495251509-14952534346375356', 1, 0, '', NULL, NULL, NULL),
(30704, '2017-05-20 12:10:34', NULL, NULL, 9353, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:10:34', 'admin-1495251509-14952534346375356', 1, 0, '', NULL, NULL, NULL),
(30705, '2017-05-20 12:12:43', NULL, NULL, 9354, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:12:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30706, '2017-05-20 12:04:30', NULL, NULL, 9351, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:04:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30707, '2017-05-20 12:03:40', NULL, NULL, 9350, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:03:40', 'admin-1495251509-14952530204088885', 1, 1, 'SR', NULL, NULL, NULL),
(30708, '2017-05-20 12:03:36', NULL, NULL, 9350, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1495268667', 'admin', '2017-05-20 12:03:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30709, '2017-05-20 11:39:18', NULL, NULL, 9349, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 11:39:18', 'admin-1495251509-14952515579466736', 1, 0, '', NULL, NULL, NULL),
(30710, '2017-05-20 11:39:46', NULL, NULL, 9349, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 11:39:46', 'admin-1495251509-14952515861637851', 1, 1, 'SR', NULL, NULL, NULL),
(30711, '2017-05-20 11:39:06', NULL, NULL, 9349, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 11:39:06', 'admin-1495251509-14952515464257869', 1, 1, 'SR', NULL, NULL, NULL),
(30712, '2017-05-20 11:39:06', NULL, NULL, 9349, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 11:39:06', 'admin-1495251509-14952515464257869', 1, 1, 'SR', NULL, NULL, NULL),
(30713, '2017-05-20 11:38:23', NULL, NULL, 9349, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 11:38:23', 'admin-1495245508-14952515036305866', 1, 1, 'SR', NULL, NULL, NULL),
(30714, '2017-05-20 11:37:35', NULL, NULL, 9349, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.90, 0.0000, 0.0000, 10.90, 1, '27', 1, '1495268667', 'admin', '2017-05-20 11:37:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30715, '2017-05-20 10:35:03', NULL, NULL, 9340, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:35:03', 'admin-1495245508-14952477028715171', 1, 1, 'SR', NULL, NULL, NULL),
(30716, '2017-05-20 10:35:03', NULL, NULL, 9340, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:35:03', 'admin-1495245508-14952477028715171', 1, 1, 'SR', NULL, NULL, NULL),
(30717, '2017-05-20 10:42:17', NULL, NULL, 9344, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:42:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30718, '2017-05-20 10:42:22', NULL, NULL, 9344, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:42:22', 'admin-1495245508-1495248142658249', 1, 1, 'SR', NULL, NULL, NULL),
(30719, '2017-05-20 10:42:22', NULL, NULL, 9344, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:42:22', 'admin-1495245508-1495248142658249', 1, 0, '', NULL, NULL, NULL),
(30720, '2017-05-20 10:46:04', NULL, NULL, 9345, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:46:04', 'admin-1495245508-14952483645745235', 1, 1, 'SR', 1, NULL, NULL),
(30721, '2017-05-20 10:47:01', NULL, NULL, 9346, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.89, 0.0000, 0.0000, 2.89, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:47:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30722, '2017-05-20 10:47:03', NULL, NULL, 9346, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:47:03', 'admin-1495245508-14952484236724382', 1, 1, 'SR', NULL, NULL, NULL),
(30723, '2017-05-20 10:48:56', NULL, NULL, 9346, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:48:56', 'admin-1495245508-1495248536078164', 1, 0, '', NULL, NULL, NULL),
(30724, '2017-05-20 10:49:54', NULL, NULL, 9347, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:49:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30725, '2017-05-20 10:50:18', NULL, NULL, 9347, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:50:18', 'admin-1495245508-14952486181715897', 1, 0, '', NULL, NULL, NULL),
(30726, '2017-05-20 10:50:18', NULL, NULL, 9347, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:50:18', 'admin-1495245508-14952486181715897', 1, 0, '', NULL, NULL, NULL),
(30727, '2017-05-20 10:50:18', NULL, NULL, 9347, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:50:18', 'admin-1495245508-14952486181715897', 1, 1, 'SR', NULL, NULL, NULL),
(30728, '2017-05-20 10:50:18', NULL, NULL, 9347, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:50:18', 'admin-1495245508-14952486181715897', 1, 1, 'SR', NULL, NULL, NULL),
(30729, '2017-05-20 11:06:49', NULL, NULL, 9346, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 11:06:49', 'admin-1495245508-1495249609718776', 1, 0, '', NULL, NULL, NULL),
(30730, '2017-05-20 10:20:19', NULL, NULL, 9342, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 10:20:19', 'admin-1495245508-14952468197537227', 1, 0, '', NULL, NULL, NULL),
(30731, '2017-05-20 09:34:19', NULL, NULL, 9338, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:34:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30732, '2017-05-20 09:58:23', NULL, NULL, 9340, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:58:23', 'admin-1495241063-14952455030067146', 1, 0, '', NULL, NULL, NULL),
(30733, '2017-05-20 09:58:23', NULL, NULL, 9340, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:58:23', 'admin-1495241063-14952455030067146', 1, 0, '', NULL, NULL, NULL),
(30734, '2017-05-20 09:58:23', NULL, NULL, 9340, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:58:23', 'admin-1495241063-14952455030067146', 1, 0, '', NULL, NULL, NULL),
(30735, '2017-05-20 09:58:23', NULL, NULL, 9340, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:58:23', 'admin-1495241063-14952455030067146', 1, 0, '', NULL, NULL, NULL),
(30736, '2017-05-20 09:58:05', NULL, NULL, 9340, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 21.80, 0.0000, 0.0000, 21.80, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:58:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30737, '2017-05-20 09:58:23', NULL, NULL, 9340, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:58:23', 'admin-1495241063-14952455030067146', 1, 0, '', NULL, NULL, NULL),
(30738, '2017-05-20 09:44:43', NULL, NULL, 9339, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:44:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30739, '2017-05-20 09:44:56', NULL, NULL, 9339, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:44:56', 'admin-1495241063-14952446967431684', 1, 0, '', NULL, NULL, NULL),
(30740, '2017-05-20 09:44:56', NULL, NULL, 9339, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:44:56', 'admin-1495241063-14952446967431684', 1, 0, '', NULL, NULL, NULL),
(30741, '2017-05-20 09:34:54', NULL, NULL, 9338, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:34:54', 'admin-1495241063-14952440946168821', 1, 0, '', NULL, NULL, NULL),
(30742, '2017-05-20 09:34:46', NULL, NULL, 9338, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:34:46', 'admin-1495241063-14952440864014644', 1, 1, 'SR', NULL, NULL, NULL),
(30743, '2017-05-20 09:34:46', NULL, NULL, 9338, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:34:46', 'admin-1495241063-14952440864014644', 1, 1, 'SR', NULL, NULL, NULL),
(30744, '2017-05-20 09:34:32', NULL, NULL, 9338, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:34:32', 'admin-1495241063-1495244072669467', 1, 0, '', NULL, NULL, NULL),
(30745, '2017-05-20 09:34:32', NULL, NULL, 9338, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:34:32', 'admin-1495241063-1495244072669467', 1, 0, '', NULL, NULL, NULL),
(30746, '2017-05-20 09:14:05', NULL, NULL, 9335, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:14:05', 'admin-1495241063-14952428456808270', 1, 1, 'SR', NULL, NULL, NULL),
(30747, '2017-05-20 09:14:05', NULL, NULL, 9335, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:14:05', 'admin-1495241063-14952428456808270', 1, 1, 'SR', NULL, NULL, NULL),
(30748, '2017-05-20 09:29:53', NULL, NULL, 9336, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:29:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30749, '2017-05-20 09:30:10', NULL, NULL, 9336, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:30:10', 'admin-1495241063-14952438103102773', 1, 0, '', NULL, NULL, NULL),
(30750, '2017-05-20 09:30:10', NULL, NULL, 9336, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:30:10', 'admin-1495241063-14952438103102773', 1, 0, '', NULL, NULL, NULL),
(30751, '2017-05-20 09:13:46', NULL, NULL, 9335, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:13:46', 'admin-1495241063-1495242825805448', 1, 0, '', NULL, NULL, NULL),
(30752, '2017-05-20 09:33:26', NULL, NULL, 9337, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:33:26', 'admin-1495241063-1495244006569741', 1, 0, '', NULL, NULL, NULL),
(30753, '2017-05-20 09:33:26', NULL, NULL, 9337, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:33:26', 'admin-1495241063-1495244006569741', 1, 1, 'SR', NULL, NULL, NULL),
(30754, '2017-05-20 09:33:07', NULL, NULL, 9337, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:33:07', 'admin-1495241063-14952439871679395', 1, 0, '', NULL, NULL, NULL),
(30755, '2017-05-20 09:33:07', NULL, NULL, 9337, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:33:07', 'admin-1495241063-14952439871679395', 1, 0, '', NULL, NULL, NULL),
(30756, '2017-05-20 09:32:40', NULL, NULL, 9337, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:32:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30757, '2017-05-20 09:30:17', NULL, NULL, 9336, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:30:17', 'admin-1495241063-14952438171583790', 1, 1, 'SR', NULL, NULL, NULL),
(30758, '2017-05-20 09:30:17', NULL, NULL, 9336, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:30:17', 'admin-1495241063-14952438171583790', 1, 0, '', NULL, NULL, NULL),
(30759, '2017-05-20 09:13:46', NULL, NULL, 9335, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:13:46', 'admin-1495241063-1495242825805448', 1, 0, '', NULL, NULL, NULL),
(30760, '2017-05-20 09:13:31', NULL, NULL, 9335, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1495268667', 'admin', '2017-05-20 09:13:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30761, '2017-05-21 13:46:00', NULL, NULL, 9400, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:46:00', 'admin-1495337880-14953455601736459', 1, 0, '', NULL, NULL, NULL),
(30762, '2017-05-21 13:26:33', NULL, NULL, 9397, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:26:33', 'admin-1495337880-14953443928563835', 1, 0, '', NULL, NULL, NULL),
(30763, '2017-05-21 13:26:33', NULL, NULL, 9397, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:26:33', 'admin-1495337880-14953443928563835', 1, 0, '', NULL, NULL, NULL),
(30764, '2017-05-21 13:31:45', NULL, NULL, 9398, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:31:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30765, '2017-05-21 13:32:05', NULL, NULL, 9398, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:32:05', 'admin-1495337880-14953447253089259', 1, 0, '', NULL, NULL, NULL),
(30766, '2017-05-21 13:32:05', NULL, NULL, 9398, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:32:05', 'admin-1495337880-14953447253089259', 1, 0, '', NULL, NULL, NULL),
(30767, '2017-05-21 14:02:22', NULL, NULL, 9404, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:02:22', 'admin-1495337880-14953465421531290', 1, 1, 'SR', NULL, NULL, NULL),
(30768, '2017-05-21 14:02:50', NULL, NULL, 9405, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:02:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30769, '2017-05-21 14:02:54', NULL, NULL, 9405, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:02:54', 'admin-1495337880-1495346574349375', 1, 1, 'SR', NULL, NULL, NULL),
(30770, '2017-05-21 14:02:54', NULL, NULL, 9405, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:02:54', 'admin-1495337880-1495346574349375', 1, 0, '', NULL, NULL, NULL),
(30771, '2017-05-21 09:45:51', NULL, NULL, 9379, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:45:51', 'admin-1495327060-14953311509978913', 1, 0, '', NULL, NULL, NULL),
(30772, '2017-05-21 09:46:25', NULL, NULL, 9379, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:46:25', 'admin-1495327060-14953311852356458', 1, 1, 'SR', NULL, NULL, NULL),
(30773, '2017-05-21 09:46:25', NULL, NULL, 9379, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:46:25', 'admin-1495327060-14953311852356458', 1, 1, 'SR', NULL, NULL, NULL),
(30774, '2017-05-21 09:46:25', NULL, NULL, 9379, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:46:25', 'admin-1495327060-14953311852356458', 1, 1, 'SR', NULL, NULL, NULL),
(30775, '2017-05-21 09:46:25', NULL, NULL, 9379, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:46:25', 'admin-1495327060-14953311852356458', 1, 1, 'SR', NULL, NULL, NULL),
(30776, '2017-05-21 14:27:46', NULL, NULL, 9408, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:27:46', 'admin-1495347258-14953480663239621', 1, 1, 'SR', NULL, NULL, NULL),
(30777, '2017-05-21 10:38:12', NULL, NULL, 9384, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1495349721', 'admin', '2017-05-21 10:38:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30778, '2017-05-21 10:38:29', NULL, NULL, 9384, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 10:38:29', 'admin-1495333393-14953343097463257', 1, 0, '', NULL, NULL, NULL),
(30779, '2017-05-21 09:46:25', NULL, NULL, 9379, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:46:25', 'admin-1495327060-14953311852356458', 1, 0, '', NULL, NULL, NULL),
(30780, '2017-05-21 15:03:11', NULL, NULL, 9409, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:03:11', 'admin-1495349721-1495350191027435', 1, 0, '', NULL, NULL, NULL),
(30781, '2017-05-21 15:06:07', NULL, NULL, 9415, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:06:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30782, '2017-05-21 15:06:27', NULL, NULL, 9415, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:06:27', 'admin-1495349721-14953503874304258', 1, 0, '', NULL, NULL, NULL),
(30783, '2017-05-21 15:06:27', NULL, NULL, 9415, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:06:27', 'admin-1495349721-14953503874304258', 1, 0, '', NULL, NULL, NULL),
(30784, '2017-05-21 15:06:27', NULL, NULL, 9415, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:06:27', 'admin-1495349721-14953503874304258', 1, 0, '', NULL, NULL, NULL),
(30785, '2017-05-21 15:06:27', NULL, NULL, 9415, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:06:27', 'admin-1495349721-14953503874304258', 1, 0, '', NULL, NULL, NULL),
(30786, '2017-05-21 15:18:29', NULL, NULL, 9407, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:18:29', 'admin-1495349721-14953511092548128', 1, 0, '', NULL, NULL, NULL),
(30787, '2017-05-21 15:20:15', NULL, NULL, 9416, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:20:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30788, '2017-05-21 15:20:31', NULL, NULL, 9416, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:20:31', 'admin-1495349721-14953512313603526', 1, 1, 'SR', NULL, NULL, NULL),
(30789, '2017-05-21 15:20:31', NULL, NULL, 9416, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:20:31', 'admin-1495349721-14953512313603526', 1, 1, 'SR', NULL, NULL, NULL),
(30790, '2017-05-21 14:45:26', NULL, NULL, 9413, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:45:26', 'admin-1495347258-14953491261098293', 1, 1, 'SR', NULL, NULL, NULL),
(30791, '2017-05-21 14:20:29', NULL, NULL, 9407, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:20:29', 'admin-1495347258-14953476289084838', 1, 1, 'SR', NULL, NULL, NULL),
(30792, '2017-05-21 12:40:21', NULL, NULL, 9394, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 12:40:21', 'admin-1495337880-14953416210393393', 1, 1, 'SR', NULL, NULL, NULL),
(30793, '2017-05-21 13:12:37', NULL, NULL, 9395, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:12:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30794, '2017-05-21 13:12:45', NULL, NULL, 9395, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:12:45', 'admin-1495337880-1495343564990543', 1, 0, '', NULL, NULL, NULL),
(30795, '2017-05-21 13:37:51', NULL, NULL, 9399, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:37:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30796, '2017-05-21 13:20:59', NULL, NULL, 9396, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:20:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30797, '2017-05-21 13:21:29', NULL, NULL, 9396, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:21:29', 'admin-1495337880-14953440897169080', 1, 1, 'SR', NULL, NULL, NULL),
(30798, '2017-05-21 13:21:29', NULL, NULL, 9396, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:21:29', 'admin-1495337880-14953440897169080', 1, 1, 'SR', NULL, NULL, NULL),
(30799, '2017-05-21 13:25:21', NULL, NULL, 9397, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:25:21', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(30800, '2017-05-21 13:48:06', NULL, NULL, 9400, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:48:06', 'admin-1495337880-14953456865122476', 1, 0, '', NULL, NULL, NULL),
(30801, '2017-05-21 13:48:06', NULL, NULL, 9400, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:48:06', 'admin-1495337880-14953456865122476', 1, 0, '', NULL, NULL, NULL),
(30802, '2017-05-21 13:48:06', NULL, NULL, 9400, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:48:06', 'admin-1495337880-14953456865122476', 1, 0, '', NULL, NULL, NULL),
(30803, '2017-05-21 13:48:06', NULL, NULL, 9400, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:48:06', 'admin-1495337880-14953456865122476', 1, 0, '', NULL, NULL, NULL),
(30804, '2017-05-21 13:49:01', NULL, NULL, 9402, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:49:01', 'admin-1495337880-14953457416616379', 1, 0, '', 1, NULL, NULL),
(30805, '2017-05-21 13:52:12', NULL, NULL, 9403, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:52:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30806, '2017-05-21 13:53:02', NULL, NULL, 9403, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:53:02', 'admin-1495337880-14953459823645299', 1, 0, '', NULL, NULL, NULL),
(30807, '2017-05-21 13:47:16', NULL, NULL, 9401, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:47:16', 'admin-1495337880-1495345636680126', 1, 0, '', NULL, NULL, '10.0'),
(30808, '2017-05-21 14:20:07', NULL, NULL, 9407, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:20:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30809, '2017-05-21 14:20:14', NULL, NULL, 9407, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:20:14', 'admin-1495347258-14953476146965860', 1, 1, 'SR', NULL, NULL, NULL),
(30810, '2017-05-21 14:45:26', NULL, NULL, 9413, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:45:26', 'admin-1495347258-14953491261098293', 1, 1, 'SR', NULL, NULL, NULL),
(30811, '2017-05-21 11:48:40', NULL, NULL, 9382, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:48:40', 'admin-1495337880-14953385207598295', 1, 0, '', NULL, NULL, NULL),
(30812, '2017-05-21 12:00:36', NULL, NULL, 9390, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 12:00:36', 'admin-1495337880-14953392365568054', 1, 0, '', NULL, NULL, NULL),
(30813, '2017-05-21 12:00:36', NULL, NULL, 9390, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 12:00:36', 'admin-1495337880-14953392365568054', 1, 0, '', NULL, NULL, NULL),
(30814, '2017-05-21 12:00:45', NULL, NULL, 9390, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 12:00:45', 'admin-1495337880-14953392451473277', 1, 1, 'SR', NULL, NULL, NULL),
(30815, '2017-05-21 11:38:20', NULL, NULL, 9389, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 2, 15.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:38:20', 'admin-1495337880-14953379002429786', 1, 0, '', NULL, NULL, NULL),
(30816, '2017-05-21 11:10:55', NULL, NULL, 9386, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:10:55', 'admin-1495333393-149533625553122', 1, 1, 'SR', NULL, NULL, NULL),
(30817, '2017-05-21 11:10:55', NULL, NULL, 9386, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:10:55', 'admin-1495333393-149533625553122', 1, 0, '', NULL, NULL, NULL),
(30818, '2017-05-21 11:10:55', NULL, NULL, 9386, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:10:55', 'admin-1495333393-149533625553122', 1, 0, '', NULL, NULL, NULL),
(30819, '2017-05-21 11:10:55', NULL, NULL, 9386, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:10:55', 'admin-1495333393-149533625553122', 1, 0, '', NULL, NULL, NULL),
(30820, '2017-05-21 11:10:55', NULL, NULL, 9386, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:10:55', 'admin-1495333393-149533625553122', 1, 0, '', NULL, NULL, NULL),
(30821, '2017-05-21 12:16:09', NULL, NULL, 9392, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 12:16:09', 'admin-1495337880-14953401690304268', 1, 0, '', NULL, NULL, NULL),
(30822, '2017-05-21 12:16:14', NULL, NULL, 9392, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 12:16:14', 'admin-1495337880-14953401746034975', 1, 1, 'SR', NULL, NULL, NULL),
(30823, '2017-05-21 12:35:47', NULL, NULL, 9393, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 12:35:47', 'admin-1495337880-14953413471975360', 1, 1, 'SR', 1, NULL, NULL),
(30824, '2017-05-21 11:25:36', NULL, NULL, 9387, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:25:36', 'admin-1495333393-14953371363121915', 1, 1, 'SR', NULL, NULL, NULL),
(30825, '2017-05-21 11:25:36', NULL, NULL, 9387, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:25:36', 'admin-1495333393-14953371363121915', 1, 1, 'SR', NULL, NULL, NULL),
(30826, '2017-05-21 14:30:44', NULL, NULL, 9409, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:30:44', 'admin-1495347258-14953482442134725', 1, 1, 'SR', NULL, NULL, NULL),
(30827, '2017-05-21 14:30:44', NULL, NULL, 9409, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:30:44', 'admin-1495347258-14953482442134725', 1, 1, 'SR', NULL, NULL, NULL),
(30828, '2017-05-21 14:30:44', NULL, NULL, 9409, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:30:44', 'admin-1495347258-14953482442134725', 1, 1, 'SR', NULL, NULL, NULL),
(30829, '2017-05-21 14:39:19', NULL, NULL, 9410, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:39:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30830, '2017-05-21 14:40:02', NULL, NULL, 9410, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:40:02', 'admin-1495347258-14953488019729176', 1, 1, 'SR', NULL, NULL, NULL),
(30831, '2017-05-21 14:40:02', NULL, NULL, 9410, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:40:02', 'admin-1495347258-14953488019729176', 1, 1, 'SR', NULL, NULL, NULL),
(30832, '2017-05-21 14:40:02', NULL, NULL, 9410, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:40:02', 'admin-1495347258-14953488019729176', 1, 0, '', NULL, NULL, NULL),
(30833, '2017-05-21 14:42:07', NULL, NULL, 9411, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:42:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30834, '2017-05-21 14:42:16', NULL, NULL, 9411, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:42:16', 'admin-1495347258-14953489359356254', 1, 0, '', NULL, NULL, NULL),
(30835, '2017-05-21 14:42:16', NULL, NULL, 9411, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:42:16', 'admin-1495347258-14953489359356254', 1, 1, 'SR', NULL, NULL, NULL),
(30836, '2017-05-21 14:42:28', NULL, NULL, 9411, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:42:28', 'admin-1495347258-14953489484013665', 1, 1, 'SR', NULL, NULL, NULL),
(30837, '2017-05-21 14:42:28', NULL, NULL, 9411, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:42:28', 'admin-1495347258-14953489484013665', 1, 1, 'SR', NULL, NULL, NULL),
(30838, '2017-05-21 14:43:34', NULL, NULL, 9412, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:43:34', 'admin-1495347258-14953490137824321', 1, 0, '', 1, NULL, NULL),
(30839, '2017-05-21 14:43:34', NULL, NULL, 9412, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:43:34', 'admin-1495347258-14953490137824321', 1, 0, '', 1, NULL, NULL),
(30840, '2017-05-21 14:45:06', NULL, NULL, 9413, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:45:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30841, '2017-05-21 14:45:13', NULL, NULL, 9413, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:45:13', 'admin-1495347258-14953491137134110', 1, 0, '', NULL, NULL, NULL),
(30842, '2017-05-21 14:45:13', NULL, NULL, 9413, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:45:13', 'admin-1495347258-14953491137134110', 1, 1, 'SR', NULL, NULL, NULL),
(30843, '2017-05-21 14:14:32', NULL, NULL, 9406, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:14:32', 'admin-1495347258-14953472717691035', 1, 1, 'SR', NULL, NULL, NULL),
(30844, '2017-05-21 14:06:53', NULL, NULL, 9405, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:06:53', 'admin-1495337880-14953468131008732', 1, 0, '', NULL, NULL, NULL),
(30845, '2017-05-21 14:30:44', NULL, NULL, 9409, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:30:44', 'admin-1495347258-14953482442134725', 1, 0, '', NULL, NULL, NULL),
(30846, '2017-05-21 15:33:24', NULL, NULL, 9411, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:33:24', 'admin-1495349721-14953520040078510', 1, 1, 'SR', NULL, NULL, NULL),
(30847, '2017-05-21 15:36:35', NULL, NULL, 9415, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:36:35', 'admin-1495349721-1495352195561352', 1, 1, 'SR', NULL, NULL, NULL),
(30848, '2017-05-21 15:49:30', NULL, NULL, 9416, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:49:30', 'admin-1495349721-14953529699261216', 1, 0, '', NULL, NULL, NULL),
(30849, '2017-05-21 15:49:50', NULL, NULL, 9416, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:49:50', 'admin-1495349721-14953529905393727', 1, 1, 'SR', NULL, NULL, NULL),
(30850, '2017-05-21 17:25:58', NULL, NULL, 9419, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1495349721', 'admin', '2017-05-21 17:25:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30851, '2017-05-21 17:26:07', NULL, NULL, 9419, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 17:26:07', 'admin-1495349721-14953587671939232', 1, 1, 'SR', NULL, NULL, NULL),
(30852, '2017-05-21 17:26:07', NULL, NULL, 9419, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 17:26:07', 'admin-1495349721-14953587671939232', 1, 1, 'SR', NULL, NULL, NULL),
(30853, '2017-05-21 17:34:33', NULL, NULL, 9420, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.49, 0.0000, 0.0000, 1.49, 1, '27', 1, '1495349721', 'admin', '2017-05-21 17:34:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30854, '2017-05-21 17:34:54', NULL, NULL, 9420, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 17:34:54', 'admin-1495349721-14953592943136087', 1, 1, 'SR', NULL, NULL, NULL),
(30855, '2017-05-21 17:34:54', NULL, NULL, 9420, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1495349721', 'admin', '2017-05-21 17:34:54', 'admin-1495349721-14953592943136087', 1, 0, '', NULL, NULL, NULL),
(30856, '2017-05-21 14:30:29', NULL, NULL, 9409, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:30:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30857, '2017-05-21 14:27:46', NULL, NULL, 9408, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:27:46', 'admin-1495347258-14953480663239621', 1, 1, 'SR', NULL, NULL, NULL),
(30858, '2017-05-21 14:27:46', NULL, NULL, 9408, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:27:46', 'admin-1495347258-14953480663239621', 1, 1, 'SR', NULL, NULL, NULL),
(30859, '2017-05-21 15:33:18', NULL, NULL, 9418, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:33:18', 'admin-1495349721-14953519984406377', 1, 1, 'SR', NULL, NULL, NULL),
(30860, '2017-05-21 15:33:07', NULL, NULL, 9418, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:33:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30861, '2017-05-21 15:33:18', NULL, NULL, 9418, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:33:18', 'admin-1495349721-14953519984406377', 1, 0, '', NULL, NULL, NULL),
(30862, '2017-05-21 15:32:12', NULL, NULL, 9417, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:32:12', 'admin-1495349721-1495351932376697', 1, 1, 'SR', NULL, NULL, NULL),
(30863, '2017-05-21 15:29:34', NULL, NULL, 9417, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:29:34', 'admin-1495349721-14953517744442474', 1, 1, 'SR', NULL, NULL, NULL),
(30864, '2017-05-21 15:29:34', NULL, NULL, 9417, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:29:34', 'admin-1495349721-14953517744442474', 1, 0, '', NULL, NULL, NULL),
(30865, '2017-05-21 15:29:24', NULL, NULL, 9417, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:29:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30866, '2017-05-21 15:29:14', NULL, NULL, 9416, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:29:14', 'admin-1495349721-14953517544485324', 1, 1, 'SR', NULL, NULL, NULL),
(30867, '2017-05-21 11:38:20', NULL, NULL, 9389, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:38:20', 'admin-1495337880-14953379002429786', 1, 1, 'SR', NULL, NULL, NULL),
(30868, '2017-05-21 15:20:31', NULL, NULL, 9416, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 15:20:31', 'admin-1495349721-14953512313603526', 1, 0, '', NULL, NULL, NULL),
(30869, '2017-05-21 14:54:58', NULL, NULL, 9414, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:54:58', 'admin-1495347258-1495349697946124', 1, 0, '', NULL, NULL, NULL),
(30870, '2017-05-21 14:54:58', NULL, NULL, 9414, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:54:58', 'admin-1495347258-1495349697946124', 1, 1, 'SR', NULL, NULL, NULL),
(30871, '2017-05-21 14:27:46', NULL, NULL, 9408, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:27:46', 'admin-1495347258-14953480663239621', 1, 0, '', NULL, NULL, NULL),
(30872, '2017-05-21 14:27:26', NULL, NULL, 9408, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:27:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30873, '2017-05-21 14:23:28', NULL, NULL, 9400, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:23:28', 'admin-1495347258-14953478079225142', 1, 0, '', NULL, NULL, NULL),
(30874, '2017-05-21 14:54:58', NULL, NULL, 9414, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:54:58', 'admin-1495347258-1495349697946124', 1, 1, 'SR', NULL, NULL, NULL),
(30875, '2017-05-21 13:26:33', NULL, NULL, 9397, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:26:33', 'admin-1495337880-14953443928563835', 1, 1, 'SR', NULL, NULL, NULL),
(30876, '2017-05-21 14:20:29', NULL, NULL, 9407, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:20:29', 'admin-1495347258-14953476289084838', 1, 1, 'SR', NULL, NULL, NULL),
(30877, '2017-05-21 14:27:46', NULL, NULL, 9408, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:27:46', 'admin-1495347258-14953480663239621', 1, 0, '', NULL, NULL, NULL),
(30878, '2017-05-21 14:13:56', NULL, NULL, 9406, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:13:56', 'admin-1495337880-14953472362598629', 1, 1, 'SR', NULL, NULL, NULL),
(30879, '2017-05-21 14:13:42', NULL, NULL, 9406, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:13:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30880, '2017-05-21 14:54:35', NULL, NULL, 9414, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:54:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30881, '2017-05-21 13:53:17', NULL, NULL, 9403, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:53:17', 'admin-1495337880-1495345997764835', 1, 1, 'SR', NULL, NULL, NULL),
(30882, '2017-05-21 13:53:02', NULL, NULL, 9403, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:53:02', 'admin-1495337880-14953459823645299', 1, 1, 'SR', NULL, NULL, NULL),
(30883, '2017-05-21 13:48:06', NULL, NULL, 9400, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:48:06', 'admin-1495337880-14953456865122476', 1, 0, '', NULL, NULL, NULL),
(30884, '2017-05-21 13:47:32', NULL, NULL, 9401, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:47:32', 'admin-1495337880-14953456526827539', 1, 1, 'SR', NULL, NULL, '10.0'),
(30885, '2017-05-21 13:46:27', NULL, NULL, 9401, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:46:27', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(30886, '2017-05-21 13:47:16', NULL, NULL, 9401, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:47:16', 'admin-1495337880-1495345636680126', 1, 1, 'SR', NULL, NULL, '10.0'),
(30887, '2017-05-21 11:55:58', NULL, NULL, 9385, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:55:58', 'admin-1495337880-14953389585158889', 1, 0, '', NULL, NULL, NULL),
(30888, '2017-05-21 12:00:26', NULL, NULL, 9390, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1495349721', 'admin', '2017-05-21 12:00:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30889, '2017-05-21 11:26:30', NULL, NULL, 9388, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:26:30', 'admin-1495333393-1495337190330981', 1, 1, 'SR', NULL, NULL, NULL),
(30890, '2017-05-21 00:00:00', NULL, NULL, 9399, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:12:45', 'admin-1495337880-1495343564990543', 1, 0, '', NULL, NULL, NULL),
(30891, '2017-05-21 13:45:54', NULL, NULL, 9400, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.20, 0.0000, 0.0000, 11.20, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:45:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30892, '2017-05-21 13:32:05', NULL, NULL, 9398, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 13:32:05', 'admin-1495337880-14953447253089259', 1, 1, 'SR', NULL, NULL, NULL),
(30893, '2017-05-21 11:10:43', NULL, NULL, 9386, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.80, 0.0000, 0.0000, 14.80, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:10:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30894, '2017-05-21 12:35:47', NULL, NULL, 9393, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 12:35:47', 'admin-1495337880-14953413471975360', 1, 1, 'SR', 1, NULL, NULL),
(30895, '2017-05-21 12:40:13', NULL, NULL, 9394, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1495349721', 'admin', '2017-05-21 12:40:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30896, '2017-05-21 09:38:30', NULL, NULL, 9377, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:38:30', 'admin-1495327060-1495330710676324', 1, 1, 'SR', NULL, NULL, NULL),
(30897, '2017-05-21 12:05:38', NULL, NULL, 9391, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1495349721', 'admin', '2017-05-21 12:05:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30898, '2017-05-21 12:05:50', NULL, NULL, 9391, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 12:05:50', 'admin-1495337880-1495339550551317', 1, 1, 'SR', NULL, NULL, NULL),
(30899, '2017-05-21 12:05:50', NULL, NULL, 9391, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 12:05:50', 'admin-1495337880-1495339550551317', 1, 1, 'SR', NULL, NULL, NULL),
(30900, '2017-05-21 12:16:01', NULL, NULL, 9392, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1495349721', 'admin', '2017-05-21 12:16:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30901, '2017-05-21 12:16:09', NULL, NULL, 9392, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 12:16:09', 'admin-1495337880-14953401690304268', 1, 0, '', NULL, NULL, NULL),
(30902, '2017-05-21 11:26:22', NULL, NULL, 9388, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:26:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30903, '2017-05-21 11:11:11', NULL, NULL, 9386, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:11:11', 'admin-1495333393-14953362714277654', 1, 1, 'SR', NULL, NULL, NULL),
(30904, '2017-05-21 11:11:11', NULL, NULL, 9386, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:11:11', 'admin-1495333393-14953362714277654', 1, 0, '', NULL, NULL, NULL),
(30905, '2017-05-21 11:11:30', NULL, NULL, 9386, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:11:30', 'admin-1495333393-14953362900898526', 1, 1, 'SR', NULL, NULL, NULL),
(30906, '2017-05-21 11:25:15', NULL, NULL, 9387, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:25:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30907, '2017-05-21 11:25:22', NULL, NULL, 9387, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:25:22', 'admin-1495333393-14953371226393519', 1, 0, '', NULL, NULL, NULL),
(30908, '2017-05-21 14:02:18', NULL, NULL, 9404, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:02:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30909, '2017-05-21 12:00:51', NULL, NULL, 9390, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 12:00:51', 'admin-1495337880-14953392514628626', 1, 0, '', NULL, NULL, NULL),
(30910, '2017-05-21 11:38:20', NULL, NULL, 9389, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:38:20', 'admin-1495337880-14953379002429786', 1, 1, 'SR', NULL, NULL, NULL),
(30911, '2017-05-21 11:38:20', NULL, NULL, 9389, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:38:20', 'admin-1495337880-14953379002429786', 1, 1, 'SR', NULL, NULL, NULL),
(30912, '2017-05-21 14:27:46', NULL, NULL, 9408, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:27:46', 'admin-1495347258-14953480663239621', 1, 0, '', NULL, NULL, NULL),
(30913, '2017-05-21 11:37:54', NULL, NULL, 9389, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:37:54', 'admin-1495333393-14953378746436940', 1, 0, '', NULL, NULL, NULL),
(30914, '2017-05-21 11:37:29', NULL, NULL, 9389, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:37:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30915, '2017-05-21 11:26:30', NULL, NULL, 9388, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:26:30', 'admin-1495333393-1495337190330981', 1, 1, 'SR', NULL, NULL, NULL),
(30916, '2017-05-21 11:11:11', NULL, NULL, 9386, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:11:11', 'admin-1495333393-14953362714277654', 1, 0, '', NULL, NULL, NULL),
(30917, '2017-05-21 11:25:36', NULL, NULL, 9387, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:25:36', 'admin-1495333393-14953371363121915', 1, 0, '', NULL, NULL, NULL),
(30918, '2017-05-21 11:25:22', NULL, NULL, 9387, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:25:22', 'admin-1495333393-14953371226393519', 1, 0, '', NULL, NULL, NULL),
(30919, '2017-05-21 11:10:55', NULL, NULL, 9386, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:10:55', 'admin-1495333393-149533625553122', 1, 1, 'SR', NULL, NULL, NULL),
(30920, '2017-05-21 11:10:55', NULL, NULL, 9386, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:10:55', 'admin-1495333393-149533625553122', 1, 0, '', NULL, NULL, NULL),
(30921, '2017-05-21 11:38:20', NULL, NULL, 9389, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 11:38:20', 'admin-1495337880-14953379002429786', 1, 1, 'SR', NULL, NULL, NULL),
(30922, '2017-05-21 10:40:41', NULL, NULL, 9385, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 10:40:41', 'admin-1495333393-14953344417638931', 1, 0, '', NULL, NULL, NULL),
(30923, '2017-05-21 10:40:41', NULL, NULL, 9385, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 10:40:41', 'admin-1495333393-14953344417638931', 1, 1, 'SR', NULL, NULL, NULL),
(30924, '2017-05-21 10:40:41', NULL, NULL, 9385, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 10:40:41', 'admin-1495333393-14953344417638931', 1, 1, 'SR', NULL, NULL, NULL),
(30925, '2017-05-21 10:38:29', NULL, NULL, 9384, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 10:38:29', 'admin-1495333393-14953343097463257', 1, 0, '', NULL, NULL, NULL),
(30926, '2017-05-21 10:38:29', NULL, NULL, 9384, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 10:38:29', 'admin-1495333393-14953343097463257', 1, 0, '', NULL, NULL, NULL),
(30927, '2017-05-21 10:38:38', NULL, NULL, 9384, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 10:38:38', 'admin-1495333393-14953343186895540', 1, 1, 'SR', NULL, NULL, NULL),
(30928, '2017-05-21 09:55:28', NULL, NULL, 9380, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:55:28', 'admin-1495327060-14953317284455236', 1, 1, 'SR', NULL, NULL, NULL),
(30929, '2017-05-21 09:59:01', NULL, NULL, 9381, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:59:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30930, '2017-05-21 09:59:07', NULL, NULL, 9381, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:59:07', 'admin-1495327060-14953319471834683', 1, 1, 'SR', NULL, NULL, NULL),
(30931, '2017-05-21 09:59:07', NULL, NULL, 9381, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:59:07', 'admin-1495327060-14953319471834683', 1, 0, '', NULL, NULL, NULL),
(30932, '2017-05-21 10:21:22', NULL, NULL, 9379, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 10:21:22', 'admin-1495327060-1495333282570955', 1, 1, 'SR', NULL, NULL, NULL),
(30933, '2017-05-21 10:22:46', NULL, NULL, 9382, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1495349721', 'admin', '2017-05-21 10:22:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30934, '2017-05-21 10:22:56', NULL, NULL, 9382, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 10:22:56', 'admin-1495327060-14953333760617649', 1, 0, '', NULL, NULL, NULL),
(30935, '2017-05-21 10:22:56', NULL, NULL, 9382, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 10:22:56', 'admin-1495327060-14953333760617649', 1, 0, '', NULL, NULL, NULL),
(30936, '2017-05-21 10:23:25', NULL, NULL, 9382, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 10:23:25', 'admin-1495333393-14953334051742580', 1, 1, 'SR', NULL, NULL, NULL),
(30937, '2017-05-21 10:23:25', NULL, NULL, 9382, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 10:23:25', 'admin-1495333393-14953334051742580', 1, 1, 'SR', NULL, NULL, NULL),
(30938, '2017-05-21 10:40:41', NULL, NULL, 9385, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 10:40:41', 'admin-1495333393-14953344417638931', 1, 0, '', NULL, NULL, NULL),
(30939, '2017-05-21 10:40:36', NULL, NULL, 9385, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 10:40:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30940, '2017-05-21 10:38:38', NULL, NULL, 9384, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 10:38:38', 'admin-1495333393-14953343186895540', 1, 0, '', NULL, NULL, NULL),
(30941, '2017-05-21 10:35:16', NULL, NULL, 9383, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1495349721', 'admin', '2017-05-21 10:35:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30942, '2017-05-21 10:35:27', NULL, NULL, 9383, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 10:35:27', 'admin-1495333393-14953341269734663', 1, 0, '', NULL, NULL, NULL),
(30943, '2017-05-21 10:35:27', NULL, NULL, 9383, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 10:35:27', 'admin-1495333393-14953341269734663', 1, 0, '', NULL, NULL, NULL),
(30944, '2017-05-21 10:35:27', NULL, NULL, 9383, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 10:35:27', 'admin-1495333393-14953341269734663', 1, 0, '', NULL, NULL, NULL),
(30945, '2017-05-21 09:55:18', NULL, NULL, 9380, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:55:18', 'admin-1495327060-14953317187553419', 1, 0, '', NULL, NULL, NULL),
(30946, '2017-05-21 09:55:18', NULL, NULL, 9380, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:55:18', 'admin-1495327060-14953317187553419', 1, 0, '', NULL, NULL, NULL),
(30947, '2017-05-21 09:55:18', NULL, NULL, 9380, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:55:18', 'admin-1495327060-14953317187553419', 1, 0, '', NULL, NULL, NULL),
(30948, '2017-05-21 09:54:52', NULL, NULL, 9380, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:54:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30949, '2017-05-21 14:54:58', NULL, NULL, 9414, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 14:54:58', 'admin-1495347258-1495349697946124', 1, 0, '', NULL, NULL, NULL),
(30950, '2017-05-21 10:35:27', NULL, NULL, 9383, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 10:35:27', 'admin-1495333393-14953341269734663', 1, 1, 'SR', NULL, NULL, NULL),
(30951, '2017-05-21 09:46:25', NULL, NULL, 9379, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:46:25', 'admin-1495327060-14953311852356458', 1, 1, 'SR', NULL, NULL, NULL),
(30952, '2017-05-21 09:38:39', NULL, NULL, 9378, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:38:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30953, '2017-05-21 09:38:52', NULL, NULL, 9378, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:38:52', 'admin-1495327060-14953307319734076', 1, 0, '', NULL, NULL, NULL),
(30954, '2017-05-21 09:38:52', NULL, NULL, 9378, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:38:52', 'admin-1495327060-14953307319734076', 1, 0, '', NULL, NULL, NULL),
(30955, '2017-05-21 09:38:52', NULL, NULL, 9378, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:38:52', 'admin-1495327060-14953307319734076', 1, 0, '', NULL, NULL, NULL),
(30956, '2017-05-21 09:39:04', NULL, NULL, 9378, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:39:04', 'admin-1495327060-14953307439492262', 1, 1, 'SR', NULL, NULL, NULL),
(30957, '2017-05-21 09:39:04', NULL, NULL, 9378, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:39:04', 'admin-1495327060-14953307439492262', 1, 1, 'SR', NULL, NULL, NULL),
(30958, '2017-05-21 09:39:04', NULL, NULL, 9378, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:39:04', 'admin-1495327060-14953307439492262', 1, 1, 'SR', NULL, NULL, NULL),
(30959, '2017-05-21 09:45:15', NULL, NULL, 9379, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 17.10, 0.0000, 0.0000, 17.10, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:45:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30960, '2017-05-21 09:45:51', NULL, NULL, 9379, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:45:51', 'admin-1495327060-14953311509978913', 1, 0, '', NULL, NULL, NULL),
(30961, '2017-05-21 09:45:51', NULL, NULL, 9379, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:45:51', 'admin-1495327060-14953311509978913', 1, 0, '', NULL, NULL, NULL),
(30962, '2017-05-21 09:45:51', NULL, NULL, 9379, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:45:51', 'admin-1495327060-14953311509978913', 1, 0, '', NULL, NULL, NULL),
(30963, '2017-05-21 09:45:51', NULL, NULL, 9379, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:45:51', 'admin-1495327060-14953311509978913', 1, 0, '', NULL, NULL, NULL),
(30964, '2017-05-21 09:45:51', NULL, NULL, 9379, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:45:51', 'admin-1495327060-14953311509978913', 1, 0, '', NULL, NULL, NULL),
(30965, '2017-05-21 09:38:30', NULL, NULL, 9377, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:38:30', 'admin-1495327060-1495330710676324', 1, 0, '', NULL, NULL, NULL),
(30966, '2017-05-21 09:23:28', NULL, NULL, 9377, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:23:28', 'admin-1495327060-14953298084279334', 1, 0, '', NULL, NULL, NULL),
(30967, '2017-05-21 09:23:28', NULL, NULL, 9377, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:23:28', 'admin-1495327060-14953298084279334', 1, 0, '', NULL, NULL, NULL),
(30968, '2017-05-21 09:23:35', NULL, NULL, 9377, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:23:35', 'admin-1495327060-14953298154036942', 1, 1, 'SR', NULL, NULL, NULL),
(30969, '2017-05-21 09:06:34', NULL, NULL, 9377, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:06:34', 'admin-1495327060-14953287941905023', 1, 1, 'SR', NULL, NULL, NULL),
(30970, '2017-05-21 09:06:29', NULL, NULL, 9377, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1495349721', 'admin', '2017-05-21 09:06:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30971, '2017-05-22 10:19:51', NULL, NULL, 9423, 0, 279, '213', 'Diet Meal - Americano / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 10:19:51', 'admin-1495415085-14954195909033762', 1, 0, '', NULL, NULL, NULL),
(30972, '2017-05-22 10:19:59', NULL, NULL, 9423, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 10:19:59', 'admin-1495415085-14954195991346144', 1, 1, 'SR', NULL, NULL, NULL),
(30973, '2017-05-22 10:23:23', NULL, NULL, 9423, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 10:23:23', 'admin-1495415085-14954198037692611', 1, 0, '', NULL, NULL, NULL),
(30974, '2017-05-22 10:23:30', NULL, NULL, 9423, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 10:23:30', 'admin-1495415085-14954198099706491', 1, 1, 'SR', NULL, NULL, NULL),
(30975, '2017-05-22 10:24:07', NULL, NULL, 9424, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1495436218', 'admin', '2017-05-22 10:24:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30976, '2017-05-22 10:24:15', NULL, NULL, 9424, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 10:24:15', 'admin-1495415085-14954198553034054', 1, 0, '', NULL, NULL, NULL),
(30977, '2017-05-22 11:05:26', NULL, NULL, 9428, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:05:26', 'admin-1495415085-1495422326561159', 1, 0, '', NULL, NULL, NULL),
(30978, '2017-05-22 11:05:21', NULL, NULL, 9428, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:05:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30979, '2017-05-22 17:17:08', NULL, NULL, 9444, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 17:17:08', 'admin-1495436218-14954446285506766', 1, 1, 'SR', NULL, NULL, NULL),
(30980, '2017-05-22 14:24:01', NULL, NULL, 9439, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 14:24:01', 'admin-1495425366-14954342414738947', 1, 0, '', NULL, NULL, NULL),
(30981, '2017-05-22 11:39:15', NULL, NULL, 9435, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:39:15', 'admin-1495423135-1495424355444340', 1, 0, '', NULL, NULL, NULL),
(30982, '2017-05-22 11:40:37', NULL, NULL, 9436, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:40:37', 'admin-1495423135-14954244373487699', 1, 1, 'SR', 1, NULL, NULL),
(30983, '2017-05-22 11:06:38', NULL, NULL, 9429, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:06:38', 'admin-1495415085-14954223981363440', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(30984, '2017-05-22 11:11:45', NULL, NULL, 9430, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:11:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30985, '2017-05-22 11:11:48', NULL, NULL, 9430, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:11:48', 'admin-1495415085-14954227078673496', 1, 0, '', NULL, NULL, NULL),
(30986, '2017-05-22 11:19:00', NULL, NULL, 9431, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:19:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30987, '2017-05-22 11:19:05', NULL, NULL, 9431, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:19:05', 'admin-1495423135-14954231452534099', 1, 0, '', NULL, NULL, NULL),
(30988, '2017-05-22 11:19:05', NULL, NULL, 9431, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:19:05', 'admin-1495423135-14954231452534099', 1, 0, '', NULL, NULL, NULL),
(30989, '2017-05-22 16:40:04', NULL, NULL, 9443, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 16:40:04', 'admin-1495436218-14954424048317799', 1, 1, 'SR', NULL, NULL, NULL),
(30990, '2017-05-22 14:22:32', NULL, NULL, 9439, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.20, 0.0000, 0.0000, 9.20, 1, '27', 1, '1495436218', 'admin', '2017-05-22 14:22:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30991, '2017-05-22 14:24:01', NULL, NULL, 9439, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 14:24:01', 'admin-1495425366-14954342414738947', 1, 1, 'SR', NULL, NULL, NULL),
(30992, '2017-05-22 10:44:01', NULL, NULL, 9425, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 10:44:01', 'admin-1495415085-14954210408612827', 1, 0, '', NULL, NULL, NULL),
(30993, '2017-05-22 10:24:15', NULL, NULL, 9424, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 10:24:15', 'admin-1495415085-14954198553034054', 1, 0, '', NULL, NULL, NULL),
(30994, '2017-05-22 09:59:08', NULL, NULL, 9422, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1495436218', 'admin', '2017-05-22 09:59:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30995, '2017-05-22 15:03:02', NULL, NULL, 9440, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 15:03:02', 'admin-1495436218-14954365821264023', 1, 1, 'SR', NULL, NULL, NULL),
(30996, '2017-05-22 15:03:41', NULL, NULL, 9441, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1495436218', 'admin', '2017-05-22 15:03:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(30997, '2017-05-22 15:03:54', NULL, NULL, 9441, 0, 181, '116', 'Open Food ', 'Scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 15:03:54', 'admin-1495436218-1495436634358396', 1, 0, '', NULL, NULL, NULL),
(30998, '2017-05-22 15:03:54', NULL, NULL, 9441, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 15:03:54', 'admin-1495436218-1495436634358396', 1, 0, '', NULL, NULL, NULL),
(30999, '2017-05-22 15:10:45', NULL, NULL, 9441, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 15:10:45', 'admin-1495436218-1495437045806686', 1, 1, 'SR', NULL, NULL, NULL),
(31000, '2017-05-22 14:24:01', NULL, NULL, 9439, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 14:24:01', 'admin-1495425366-14954342414738947', 1, 0, '', NULL, NULL, NULL),
(31001, '2017-05-22 17:17:03', NULL, NULL, 9444, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1495436218', 'admin', '2017-05-22 17:17:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31002, '2017-05-22 16:39:58', NULL, NULL, 9443, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1495436218', 'admin', '2017-05-22 16:39:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31003, '2017-05-22 16:40:04', NULL, NULL, 9443, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 16:40:04', 'admin-1495436218-14954424048317799', 1, 1, 'SR', NULL, NULL, NULL),
(31004, '2017-05-22 16:10:45', NULL, NULL, 9442, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 16:10:45', 'admin-1495436218-14954406453753936', 1, 1, 'SR', NULL, NULL, NULL),
(31005, '2017-05-22 15:17:09', NULL, NULL, 9442, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1495436218', 'admin', '2017-05-22 15:17:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31006, '2017-05-22 15:17:18', NULL, NULL, 9442, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 15:17:18', 'admin-1495436218-14954374380019177', 1, 1, 'SR', NULL, NULL, NULL),
(31007, '2017-05-22 15:10:45', NULL, NULL, 9441, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 15:10:45', 'admin-1495436218-1495437045806686', 1, 1, 'SR', NULL, NULL, NULL),
(31008, '2017-05-22 14:55:47', NULL, NULL, 9439, 0, 181, '116', 'Open Food ', 'Scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 14:55:47', 'admin-1495425366-14954361477838025', 1, 0, '', NULL, NULL, NULL),
(31009, '2017-05-22 14:55:47', NULL, NULL, 9439, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 14:55:47', 'admin-1495425366-14954361477838025', 1, 1, 'SR', NULL, NULL, NULL),
(31010, '2017-05-22 14:24:01', NULL, NULL, 9439, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 14:24:01', 'admin-1495425366-14954342414738947', 1, 0, '', NULL, NULL, NULL),
(31011, '2017-05-22 14:36:44', NULL, NULL, 9440, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1495436218', 'admin', '2017-05-22 14:36:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31012, '2017-05-22 14:36:47', NULL, NULL, 9440, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 14:36:47', 'admin-1495425366-14954350076154972', 1, 0, '', NULL, NULL, NULL),
(31013, '2017-05-22 14:24:01', NULL, NULL, 9439, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 14:24:01', 'admin-1495425366-14954342414738947', 1, 0, '', NULL, NULL, NULL),
(31014, '2017-05-22 17:17:08', NULL, NULL, 9444, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 17:17:08', 'admin-1495436218-14954446285506766', 1, 0, '', NULL, NULL, NULL),
(31015, '2017-05-22 11:55:43', NULL, NULL, 9437, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:55:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31016, '2017-05-22 11:56:01', NULL, NULL, 9437, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:56:01', 'admin-1495423135-14954253609898280', 1, 1, 'SR', NULL, NULL, NULL),
(31017, '2017-05-22 11:56:01', NULL, NULL, 9437, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:56:01', 'admin-1495423135-14954253609898280', 1, 1, 'SR', NULL, NULL, NULL),
(31018, '2017-05-22 11:56:01', NULL, NULL, 9437, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:56:01', 'admin-1495423135-14954253609898280', 1, 1, 'SR', NULL, NULL, NULL),
(31019, '2017-05-22 11:56:19', NULL, NULL, 9437, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:56:19', 'admin-1495425366-14954253787831650', 1, 1, 'SR', NULL, NULL, NULL),
(31020, '2017-05-22 11:56:19', NULL, NULL, 9437, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:56:19', 'admin-1495425366-14954253787831650', 1, 1, 'SR', NULL, NULL, NULL),
(31021, '2017-05-22 12:15:34', NULL, NULL, 9437, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 12:15:34', 'admin-1495425366-14954265341889641', 1, 1, 'SR', NULL, NULL, NULL),
(31022, '2017-05-22 12:21:08', NULL, NULL, 9433, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 12:21:08', 'admin-1495425366-14954268683676677', 1, 0, '', NULL, NULL, NULL),
(31023, '2017-05-22 11:04:41', NULL, NULL, 9427, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:04:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31024, '2017-05-22 11:04:47', NULL, NULL, 9427, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:04:47', 'admin-1495415085-14954222870898339', 1, 1, 'SR', NULL, NULL, NULL),
(31025, '2017-05-22 13:01:11', NULL, NULL, 9438, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 13:01:11', 'admin-1495425366-14954292717311953', 1, 0, '', NULL, NULL, NULL),
(31026, '2017-05-22 13:01:11', NULL, NULL, 9438, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 13:01:11', 'admin-1495425366-14954292717311953', 1, 0, '', NULL, NULL, NULL),
(31027, '2017-05-22 13:01:07', NULL, NULL, 9438, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1495436218', 'admin', '2017-05-22 13:01:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31028, '2017-05-22 11:46:10', NULL, NULL, 9435, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:46:10', 'admin-1495423135-14954247700709759', 1, 1, 'SR', NULL, NULL, NULL),
(31029, '2017-05-22 11:39:10', NULL, NULL, 9435, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:39:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31030, '2017-05-22 11:39:15', NULL, NULL, 9435, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:39:15', 'admin-1495423135-1495424355444340', 1, 0, '', NULL, NULL, NULL),
(31031, '2017-05-22 11:29:41', NULL, NULL, 9434, 0, 279, '213', 'Diet Meal - Americano / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:29:41', 'admin-1495423135-14954237815217227', 1, 0, '', NULL, NULL, NULL),
(31032, '2017-05-22 11:29:41', NULL, NULL, 9434, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:29:41', 'admin-1495423135-14954237815217227', 1, 0, '', NULL, NULL, NULL),
(31033, '2017-05-22 11:29:25', NULL, NULL, 9434, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:29:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31034, '2017-05-22 11:29:41', NULL, NULL, 9434, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:29:41', 'admin-1495423135-14954237815217227', 1, 0, '', NULL, NULL, NULL),
(31035, '2017-05-22 11:22:17', NULL, NULL, 9432, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:22:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31036, '2017-05-22 11:22:21', NULL, NULL, 9432, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:22:21', 'admin-1495423135-14954233412429070', 1, 0, '', NULL, NULL, NULL),
(31037, '2017-05-22 11:28:08', NULL, NULL, 9433, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:28:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31038, '2017-05-22 11:28:17', NULL, NULL, 9433, 0, 280, '214', 'Diet Meal - Piccolo / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:28:17', 'admin-1495423135-1495423697501399', 1, 0, '', NULL, NULL, NULL),
(31039, '2017-05-22 11:06:33', NULL, NULL, 9429, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:06:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31040, '2017-05-22 11:05:26', NULL, NULL, 9428, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:05:26', 'admin-1495415085-1495422326561159', 1, 0, '', NULL, NULL, NULL),
(31041, '2017-05-22 11:04:47', NULL, NULL, 9427, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 11:04:47', 'admin-1495415085-14954222870898339', 1, 1, 'SR', NULL, NULL, NULL),
(31042, '2017-05-22 10:54:12', NULL, NULL, 9426, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 10:54:12', 'admin-1495415085-1495421652414142', 1, 1, 'SR', NULL, NULL, NULL),
(31043, '2017-05-22 10:54:09', NULL, NULL, 9426, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1495436218', 'admin', '2017-05-22 10:54:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31044, '2017-05-22 10:44:52', NULL, NULL, 9425, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 10:44:52', 'admin-1495415085-14954210918402373', 1, 0, '', NULL, NULL, NULL),
(31045, '2017-05-22 10:44:01', NULL, NULL, 9425, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 10:44:01', 'admin-1495415085-14954210408612827', 1, 1, 'SR', NULL, NULL, NULL),
(31046, '2017-05-22 10:44:01', NULL, NULL, 9425, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 10:44:01', 'admin-1495415085-14954210408612827', 1, 1, 'SR', NULL, NULL, NULL),
(31047, '2017-05-22 10:44:01', NULL, NULL, 9425, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 10:44:01', 'admin-1495415085-14954210408612827', 1, 1, 'SR', NULL, NULL, NULL),
(31048, '2017-05-22 10:44:01', NULL, NULL, 9425, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 10:44:01', 'admin-1495415085-14954210408612827', 1, 0, '', NULL, NULL, NULL),
(31049, '2017-05-22 10:44:01', NULL, NULL, 9425, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 10:44:01', 'admin-1495415085-14954210408612827', 1, 0, '', NULL, NULL, NULL),
(31050, '2017-05-22 10:44:01', NULL, NULL, 9425, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 10:44:01', 'admin-1495415085-14954210408612827', 1, 0, '', NULL, NULL, NULL),
(31051, '2017-05-22 10:43:44', NULL, NULL, 9425, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.10, 0.0000, 0.0000, 11.10, 1, '27', 1, '1495436218', 'admin', '2017-05-22 10:43:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31052, '2017-05-22 10:19:51', NULL, NULL, 9423, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 10:19:51', 'admin-1495415085-14954195909033762', 1, 0, '', NULL, NULL, NULL),
(31053, '2017-05-22 10:19:51', NULL, NULL, 9423, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 10:19:51', 'admin-1495415085-14954195909033762', 1, 0, '', NULL, NULL, NULL),
(31054, '2017-05-22 10:19:35', NULL, NULL, 9423, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1495436218', 'admin', '2017-05-22 10:19:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31055, '2017-05-22 09:59:12', NULL, NULL, 9422, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 09:59:12', 'admin-1495415085-1495418352210143', 1, 0, '', NULL, NULL, NULL),
(31056, '2017-05-22 09:37:20', NULL, NULL, 9421, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495436218', 'admin', '2017-05-22 09:37:20', 'admin-1495415085-14954170406984326', 1, 0, '', NULL, NULL, NULL),
(31057, '2017-05-22 09:37:08', NULL, NULL, 9421, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1495436218', 'admin', '2017-05-22 09:37:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31058, '2017-05-24 09:56:12', NULL, NULL, 9447, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 09:56:12', 'admin-1495588949-14955909725455785', 1, 1, 'SR', NULL, NULL, NULL),
(31059, '2017-05-24 10:10:16', NULL, NULL, 9448, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1495588949', 'admin', '2017-05-24 10:10:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31060, '2017-05-24 10:10:21', NULL, NULL, 9448, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 10:10:21', 'admin-1495588949-14955918216268835', 1, 0, '', NULL, NULL, NULL),
(31061, '2017-05-24 10:25:34', NULL, NULL, 9449, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 10:25:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31062, '2017-05-24 10:25:40', NULL, NULL, 9449, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 10:25:40', 'admin-1495588949-14955927402779212', 1, 0, '', NULL, NULL, NULL),
(31063, '2017-05-24 10:25:40', NULL, NULL, 9449, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 10:25:40', 'admin-1495588949-14955927402779212', 1, 0, '', NULL, NULL, NULL),
(31064, '2017-05-24 12:54:15', NULL, NULL, 9457, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 12:54:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31065, '2017-05-24 12:54:21', NULL, NULL, 9457, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 12:54:21', 'admin-1495588949-14956016609835956', 1, 1, 'SR', NULL, NULL, NULL),
(31066, '2017-05-24 13:42:54', NULL, NULL, 9461, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 2, 11.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 13:42:54', 'admin-1495588949-14956045740369335', 1, 1, 'SR', NULL, NULL, NULL),
(31067, '2017-05-24 14:02:41', NULL, NULL, 9462, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1495588949', 'admin', '2017-05-24 14:02:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31068, '2017-05-24 14:02:54', NULL, NULL, 9462, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 14:02:54', 'admin-1495588949-14956057743408328', 1, 0, '', NULL, NULL, NULL),
(31069, '2017-05-24 14:02:54', NULL, NULL, 9462, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 14:02:54', 'admin-1495588949-14956057743408328', 1, 0, '', NULL, NULL, NULL),
(31070, '2017-05-24 00:00:00', NULL, NULL, 9463, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 13:24:02', 'admin-1495588949-14956034422118952', 1, 1, 'SR', NULL, NULL, NULL),
(31071, '2017-05-24 14:06:25', NULL, NULL, 9464, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 14:06:25', 'admin-1495588949-14956059853412387', 1, 1, 'SR', NULL, NULL, NULL),
(31072, '2017-05-24 14:06:25', NULL, NULL, 9464, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 14:06:25', 'admin-1495588949-14956059853412387', 1, 1, 'SR', NULL, NULL, NULL),
(31073, '2017-05-24 14:15:20', NULL, NULL, 9460, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 14:15:20', 'admin-1495588949-14956065206738719', 1, 1, 'SR', NULL, NULL, NULL),
(31074, '2017-05-24 15:52:23', NULL, NULL, 9465, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 15:52:23', 'admin-1495588949-14956123432687228', 1, 1, 'SR', 1, NULL, NULL),
(31075, '2017-05-24 13:27:09', NULL, NULL, 9460, 0, 153, '87', 'Wake Me Up!', 'fried egg', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 13:27:09', 'admin-1495588949-1495603629755362', 1, 0, '', NULL, NULL, NULL),
(31076, '2017-05-24 13:27:09', NULL, NULL, 9460, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 13:27:09', 'admin-1495588949-1495603629755362', 1, 0, '', NULL, NULL, NULL),
(31077, '2017-05-24 09:23:19', NULL, NULL, 9445, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 09:23:19', 'admin-1495588949-14955889993638651', 1, 1, 'SR', NULL, NULL, NULL),
(31078, '2017-05-24 09:23:19', NULL, NULL, 9445, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 09:23:19', 'admin-1495588949-14955889993638651', 1, 1, 'SR', NULL, NULL, NULL),
(31079, '2017-05-24 09:37:20', NULL, NULL, 9446, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1495588949', 'admin', '2017-05-24 09:37:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31080, '2017-05-24 09:37:26', NULL, NULL, 9446, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 09:37:26', 'admin-1495588949-14955898461154317', 1, 0, '', NULL, NULL, NULL),
(31081, '2017-05-24 13:27:27', NULL, NULL, 9460, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 13:27:27', 'admin-1495588949-14956036476758885', 1, 1, 'SR', NULL, NULL, NULL),
(31082, '2017-05-24 13:42:50', NULL, NULL, 9461, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1495588949', 'admin', '2017-05-24 13:42:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31083, '2017-05-24 11:21:06', NULL, NULL, 9455, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 11:21:06', 'admin-1495588949-14955960666718648', 1, 1, 'SR', NULL, NULL, NULL),
(31084, '2017-05-24 09:56:12', NULL, NULL, 9447, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 09:56:12', 'admin-1495588949-14955909725455785', 1, 0, '', NULL, NULL, NULL),
(31085, '2017-05-24 09:22:41', NULL, NULL, 9445, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 09:22:41', 'admin-1495588949-14955889615615597', 1, 0, '', NULL, NULL, NULL),
(31086, '2017-05-24 09:23:19', NULL, NULL, 9445, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 09:23:19', 'admin-1495588949-14955889993638651', 1, 0, '', NULL, NULL, NULL),
(31087, '2017-05-24 17:22:42', NULL, NULL, 9466, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 17:22:42', 'admin-1495588949-14956177620272949', 1, 1, 'SR', NULL, NULL, NULL),
(31088, '2017-05-24 17:29:54', NULL, NULL, 9467, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1495588949', 'admin', '2017-05-24 17:29:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31089, '2017-05-24 17:29:58', NULL, NULL, 9467, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 17:29:58', 'admin-1495588949-14956181980347424', 1, 1, 'SR', NULL, NULL, NULL),
(31090, '2017-05-24 17:22:42', NULL, NULL, 9466, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 17:22:42', 'admin-1495588949-14956177620272949', 1, 1, 'SR', NULL, NULL, NULL),
(31091, '2017-05-24 17:22:38', NULL, NULL, 9466, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1495588949', 'admin', '2017-05-24 17:22:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31092, '2017-05-24 13:27:27', NULL, NULL, 9460, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 13:27:27', 'admin-1495588949-14956036476758885', 1, 1, 'SR', NULL, NULL, NULL),
(31093, '2017-05-24 11:35:43', NULL, NULL, 9456, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 2, 16.00, 32.0000, 0.0000, 32.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 11:35:43', 'admin-1495588949-14955969433851270', 1, 1, 'SR', NULL, NULL, NULL),
(31094, '2017-05-24 11:34:44', NULL, NULL, 9456, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 22.70, 0.0000, 0.0000, 22.70, 1, '27', 1, '1495588949', 'admin', '2017-05-24 11:34:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31095, '2017-05-24 10:25:46', NULL, NULL, 9449, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 10:25:46', 'admin-1495588949-14955927465623174', 1, 0, '', NULL, NULL, NULL),
(31096, '2017-05-24 10:27:52', NULL, NULL, 9448, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 10:27:52', 'admin-1495588949-1495592872173663', 1, 0, '', NULL, NULL, NULL),
(31097, '2017-05-24 10:32:35', NULL, NULL, 9450, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 10:32:35', 'admin-1495588949-14955931553678324', 1, 0, '', 1, NULL, NULL),
(31098, '2017-05-24 10:33:05', NULL, NULL, 9451, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1495588949', 'admin', '2017-05-24 10:33:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31099, '2017-05-24 10:33:10', NULL, NULL, 9451, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 10:33:10', 'admin-1495588949-1495593190436820', 1, 0, '', NULL, NULL, NULL),
(31100, '2017-05-24 10:33:10', NULL, NULL, 9451, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 10:33:10', 'admin-1495588949-1495593190436820', 1, 0, '', NULL, NULL, NULL),
(31101, '2017-05-24 10:33:52', NULL, NULL, 9452, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1495588949', 'admin', '2017-05-24 10:33:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31102, '2017-05-24 10:34:00', NULL, NULL, 9452, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 10:34:00', 'admin-1495588949-14955932399957234', 1, 0, '', NULL, NULL, NULL),
(31103, '2017-05-24 10:34:00', NULL, NULL, 9452, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 10:34:00', 'admin-1495588949-14955932399957234', 1, 0, '', NULL, NULL, NULL),
(31104, '2017-05-24 10:57:50', NULL, NULL, 9453, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.69, 0.0000, 0.0000, 3.69, 1, '27', 1, '1495588949', 'admin', '2017-05-24 10:57:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31105, '2017-05-24 10:57:55', NULL, NULL, 9453, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 10:57:55', 'admin-1495588949-14955946749728481', 1, 0, '', NULL, NULL, NULL),
(31106, '2017-05-24 10:58:00', NULL, NULL, 9453, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 10:58:00', 'admin-1495588949-1495594679980574', 1, 0, '', NULL, NULL, NULL),
(31107, '2017-05-24 11:05:27', NULL, NULL, 9454, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1495588949', 'admin', '2017-05-24 11:05:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31108, '2017-05-24 11:06:07', NULL, NULL, 9454, 0, 153, '87', 'Wake Me Up!', ' replace sausage,no bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 11:06:07', 'admin-1495588949-14955951671098767', 1, 0, '', NULL, NULL, NULL),
(31109, '2017-05-24 14:05:06', NULL, NULL, 9463, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1495588949', 'admin', '2017-05-24 14:05:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31110, '2017-05-24 13:27:16', NULL, NULL, 9460, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 13:27:16', 'admin-1495588949-14956036364957412', 1, 0, '', NULL, NULL, NULL),
(31111, '2017-05-24 13:27:09', NULL, NULL, 9460, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 13:27:09', 'admin-1495588949-1495603629755362', 1, 1, 'SR', NULL, NULL, NULL),
(31112, '2017-05-24 13:26:46', NULL, NULL, 9460, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1495588949', 'admin', '2017-05-24 13:26:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31113, '2017-05-24 14:06:18', NULL, NULL, 9464, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1495588949', 'admin', '2017-05-24 14:06:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31114, '2017-05-24 13:13:49', NULL, NULL, 9459, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 13:13:49', 'admin-1495588949-1495602829068798', 1, 1, 'SR', NULL, NULL, NULL),
(31115, '2017-05-24 13:13:49', NULL, NULL, 9459, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 13:13:49', 'admin-1495588949-1495602829068798', 1, 1, 'SR', NULL, NULL, NULL),
(31116, '2017-05-24 13:13:46', NULL, NULL, 9459, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1495588949', 'admin', '2017-05-24 13:13:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31117, '2017-05-24 12:59:16', NULL, NULL, 9453, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1495588949', 'admin', '2017-05-24 12:59:16', 'admin-1495588949-14956019562898899', 1, 0, '', NULL, NULL, NULL),
(31118, '2017-05-24 12:55:28', NULL, NULL, 9458, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 12:55:28', 'admin-1495588949-14956017285093752', 1, 1, 'SR', NULL, NULL, NULL),
(31119, '2017-05-24 12:55:28', NULL, NULL, 9458, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 12:55:28', 'admin-1495588949-14956017285093752', 1, 1, 'SR', NULL, NULL, NULL),
(31120, '2017-05-24 12:54:25', NULL, NULL, 9458, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1495588949', 'admin', '2017-05-24 12:54:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31121, '2017-05-24 11:50:05', NULL, NULL, 9456, 0, 182, '117', 'Open Drinks ', 'Fresh Juice', 'Cold Drinks', 'Fresh Juice', 1, 80.00, 80.0000, 0.0000, 80.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 11:50:05', 'admin-1495588949-1495597805001131', 1, 0, '', NULL, NULL, NULL),
(31122, '2017-05-24 11:35:43', NULL, NULL, 9456, 0, 181, '116', 'Open Food ', 'Deep Fried Dumpling', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 11:35:43', 'admin-1495588949-14955969433851270', 1, 0, '', NULL, NULL, NULL),
(31123, '2017-05-24 11:35:43', NULL, NULL, 9456, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 11:35:43', 'admin-1495588949-14955969433851270', 1, 0, '', NULL, NULL, NULL),
(31124, '2017-05-24 11:35:43', NULL, NULL, 9456, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 11:35:43', 'admin-1495588949-14955969433851270', 1, 0, '', NULL, NULL, NULL),
(31125, '2017-05-24 11:35:43', NULL, NULL, 9456, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 2, 16.00, 32.0000, 0.0000, 32.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 11:35:43', 'admin-1495588949-14955969433851270', 1, 1, 'SR', NULL, NULL, NULL),
(31126, '2017-05-24 11:35:43', NULL, NULL, 9456, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 2, 16.00, 32.0000, 0.0000, 32.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 11:35:43', 'admin-1495588949-14955969433851270', 1, 1, 'SR', NULL, NULL, NULL),
(31127, '2017-05-24 11:20:59', NULL, NULL, 9455, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1495588949', 'admin', '2017-05-24 11:20:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31128, '2017-05-24 11:21:06', NULL, NULL, 9455, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 11:21:06', 'admin-1495588949-14955960666718648', 1, 0, '', NULL, NULL, NULL),
(31129, '2017-05-24 11:06:07', NULL, NULL, 9454, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 11:06:07', 'admin-1495588949-14955951671098767', 1, 0, '', NULL, NULL, NULL),
(31130, '2017-05-24 11:06:14', NULL, NULL, 9454, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 11:06:14', 'admin-1495588949-14955951746846495', 1, 1, 'SR', NULL, NULL, NULL),
(31131, '2017-05-24 09:56:12', NULL, NULL, 9447, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 09:56:12', 'admin-1495588949-14955909725455785', 1, 0, '', NULL, NULL, NULL),
(31132, '2017-05-24 09:56:02', NULL, NULL, 9447, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 09:56:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31133, '2017-05-24 09:23:19', NULL, NULL, 9445, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 09:23:19', 'admin-1495588949-14955889993638651', 1, 1, 'SR', NULL, NULL, NULL),
(31134, '2017-05-24 09:23:19', NULL, NULL, 9445, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495588949', 'admin', '2017-05-24 09:23:19', 'admin-1495588949-14955889993638651', 1, 0, '', NULL, NULL, NULL),
(31135, '2017-05-24 09:22:34', NULL, NULL, 9445, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1495588949', 'admin', '2017-05-24 09:22:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31136, '2017-05-25 16:22:10', NULL, NULL, 9494, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 16:22:10', 'admin-1495690898-1495700530079559', 1, 0, '', NULL, NULL, NULL),
(31137, '2017-05-25 16:55:03', NULL, NULL, 9495, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1495690898', 'admin', '2017-05-25 16:55:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31138, '2017-05-25 16:55:05', NULL, NULL, 9495, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 16:55:05', 'admin-1495690898-14957025052402130', 1, 1, 'SR', NULL, NULL, NULL),
(31139, '2017-05-25 13:52:59', NULL, NULL, 9488, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1495690898', 'admin', '2017-05-25 13:52:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31140, '2017-05-25 13:53:30', NULL, NULL, 9488, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 13:53:30', 'admin-1495690898-14956916102523027', 1, 1, 'SR', NULL, NULL, NULL),
(31141, '2017-05-25 13:53:30', NULL, NULL, 9488, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 13:53:30', 'admin-1495690898-14956916102523027', 1, 1, 'SR', NULL, NULL, NULL),
(31142, '2017-05-25 14:02:59', NULL, NULL, 9489, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1495690898', 'admin', '2017-05-25 14:02:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31143, '2017-05-25 14:03:39', NULL, NULL, 9489, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 14:03:39', 'admin-1495690898-14956922194335245', 1, 1, 'SR', NULL, NULL, NULL),
(31144, '2017-05-25 14:03:39', NULL, NULL, 9489, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 14:03:39', 'admin-1495690898-14956922194335245', 1, 1, 'SR', NULL, NULL, NULL),
(31145, '2017-05-25 14:03:39', NULL, NULL, 9489, 0, 181, '116', 'Open Food ', 'Fruits pancake', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 14:03:39', 'admin-1495690898-14956922194335245', 1, 0, '', NULL, NULL, NULL),
(31146, '2017-05-25 10:08:49', NULL, NULL, 9475, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:08:49', 'admin-1495672642-14956781293768545', 1, 1, 'SR', NULL, NULL, NULL),
(31147, '2017-05-25 10:08:49', NULL, NULL, 9475, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:08:49', 'admin-1495672642-14956781293768545', 1, 1, 'SR', NULL, NULL, NULL),
(31148, '2017-05-25 10:08:49', NULL, NULL, 9475, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:08:49', 'admin-1495672642-14956781293768545', 1, 1, 'SR', NULL, NULL, NULL),
(31149, '2017-05-25 10:08:49', NULL, NULL, 9475, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:08:49', 'admin-1495672642-14956781293768545', 1, 1, 'SR', NULL, NULL, NULL),
(31150, '2017-05-25 16:22:06', NULL, NULL, 9494, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1495690898', 'admin', '2017-05-25 16:22:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31151, '2017-05-25 17:18:57', NULL, NULL, 9497, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 17:18:57', 'admin-1495690898-14957039376645449', 1, 0, '', NULL, NULL, NULL),
(31152, '2017-05-25 17:18:57', NULL, NULL, 9497, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 17:18:57', 'admin-1495690898-14957039376645449', 1, 0, '', NULL, NULL, NULL),
(31153, '2017-05-25 17:19:06', NULL, NULL, 9497, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 17:19:06', 'admin-1495690898-14957039458021722', 1, 1, 'SR', NULL, NULL, NULL),
(31154, '2017-05-25 17:19:06', NULL, NULL, 9497, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 17:19:06', 'admin-1495690898-14957039458021722', 1, 1, 'SR', NULL, NULL, NULL),
(31155, '2017-05-25 00:00:00', NULL, NULL, 9498, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 17:00:07', 'admin-1495690898-14957028070693389', 1, 1, 'SR', NULL, NULL, NULL),
(31156, '2017-05-25 00:00:00', NULL, NULL, 9499, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, NULL, NULL, 1.10, 1, '27', 1, '1495690898', 'admin', '2017-05-25 17:00:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31157, '2017-05-25 00:00:00', NULL, NULL, 9499, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 17:00:07', 'admin-1495690898-14957028070693389', 1, 1, 'SR', NULL, NULL, NULL),
(31158, '2017-05-25 14:15:27', NULL, NULL, 9490, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 14:15:27', 'admin-1495690898-14956929270456661', 1, 1, 'SR', NULL, NULL, NULL),
(31159, '2017-05-25 14:16:20', NULL, NULL, 9490, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 14:16:20', 'admin-1495690898-14956929800833385', 1, 0, '', NULL, NULL, NULL),
(31160, '2017-05-25 14:14:18', NULL, NULL, 9490, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1495690898', 'admin', '2017-05-25 14:14:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31161, '2017-05-25 14:15:27', NULL, NULL, 9490, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 14:15:27', 'admin-1495690898-14956929270456661', 1, 1, 'SR', NULL, NULL, NULL),
(31162, '2017-05-25 14:44:03', NULL, NULL, 9485, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 14:44:03', 'admin-1495690898-14956946432254928', 1, 1, 'SR', NULL, NULL, NULL),
(31163, '2017-05-25 00:00:00', NULL, NULL, 9481, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:19:32', 'admin-1495678643-14956787720652570', 1, 1, 'SR', NULL, NULL, NULL),
(31164, '2017-05-25 10:20:20', NULL, NULL, 9474, 0, 181, '116', 'Open Food ', 'baked beans', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:20:20', 'admin-1495678643-1495678820592764', 1, 0, '', NULL, NULL, NULL),
(31165, '2017-05-25 10:21:46', NULL, NULL, 9477, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:21:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31166, '2017-05-25 10:21:56', NULL, NULL, 9477, 0, 279, '213', 'Diet Meal - Americano / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:21:56', 'admin-1495678643-14956789167341566', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(31167, '2017-05-25 10:21:56', NULL, NULL, 9477, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:21:56', 'admin-1495678643-14956789167341566', 1, 1, 'SR', NULL, NULL, NULL),
(31168, '2017-05-25 10:21:56', NULL, NULL, 9477, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:21:56', 'admin-1495678643-14956789167341566', 1, 0, '', NULL, NULL, NULL),
(31169, '2017-05-25 17:51:39', NULL, NULL, 9498, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1495690898', 'admin', '2017-05-25 17:51:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31170, '2017-05-25 17:18:50', NULL, NULL, 9494, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 17:18:50', 'admin-1495690898-14957039307587636', 1, 1, 'SR', NULL, NULL, NULL),
(31171, '2017-05-25 17:18:54', NULL, NULL, 9497, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1495690898', 'admin', '2017-05-25 17:18:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31172, '2017-05-25 15:55:01', NULL, NULL, 9493, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 15:55:01', 'admin-1495690898-14956989017653150', 1, 1, 'SR', NULL, NULL, NULL),
(31173, '2017-05-25 14:16:20', NULL, NULL, 9490, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 14:16:20', 'admin-1495690898-14956929800833385', 1, 0, '', NULL, NULL, NULL),
(31174, '2017-05-25 15:54:56', NULL, NULL, 9493, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1495690898', 'admin', '2017-05-25 15:54:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31175, '2017-05-25 15:55:01', NULL, NULL, 9493, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 15:55:01', 'admin-1495690898-14956989017653150', 1, 0, '', NULL, NULL, NULL),
(31176, '2017-05-25 09:14:39', NULL, NULL, 9469, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 09:14:39', 'admin-1495672642-14956748795821015', 1, 0, '', NULL, NULL, NULL),
(31177, '2017-05-25 09:14:39', NULL, NULL, 9469, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 09:14:39', 'admin-1495672642-14956748795821015', 1, 0, '', NULL, NULL, NULL),
(31178, '2017-05-25 09:14:45', NULL, NULL, 9469, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 09:14:45', 'admin-1495672642-14956748848453851', 1, 0, '', NULL, NULL, NULL),
(31179, '2017-05-25 09:15:15', NULL, NULL, 9470, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 09:15:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31180, '2017-05-25 09:15:21', NULL, NULL, 9470, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 09:15:21', 'admin-1495672642-14956749214874163', 1, 0, '', NULL, NULL, NULL),
(31181, '2017-05-25 15:09:45', NULL, NULL, 9492, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 15:09:45', 'admin-1495690898-14956961855879167', 1, 1, 'SR', NULL, NULL, NULL),
(31182, '2017-05-25 15:10:11', NULL, NULL, 9492, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 15:10:11', 'admin-1495690898-14956962110696196', 1, 1, 'SR', NULL, NULL, NULL),
(31183, '2017-05-25 12:11:53', NULL, NULL, 9484, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 12:11:53', 'admin-1495678643-14956855129172160', 1, 0, '', NULL, NULL, NULL),
(31184, '2017-05-25 00:00:00', NULL, NULL, 9481, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:19:20', 'admin-1495678643-14956787598909077', 1, 0, '', NULL, NULL, NULL),
(31185, '2017-05-25 13:46:13', NULL, NULL, 9487, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 13:46:13', 'admin-1495690898-14956911732447639', 1, 0, '', NULL, NULL, NULL),
(31186, '2017-05-25 13:16:19', NULL, NULL, 9485, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 13:16:19', 'admin-1495678643-14956893788273211', 1, 1, 'SR', NULL, NULL, NULL),
(31187, '2017-05-25 13:41:58', NULL, NULL, 9486, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 13:41:58', 'admin-1495690898-14956909186174364', 1, 0, '', 1, NULL, NULL),
(31188, '2017-05-25 13:44:27', NULL, NULL, 9482, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 13:44:27', 'admin-1495690898-14956910669479924', 1, 1, 'SR', NULL, NULL, NULL),
(31189, '2017-05-25 13:45:01', NULL, NULL, 9485, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 13:45:01', 'admin-1495690898-14956911010083744', 1, 0, '', NULL, NULL, NULL),
(31190, '2017-05-25 13:46:09', NULL, NULL, 9487, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1495690898', 'admin', '2017-05-25 13:46:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31191, '2017-05-25 15:55:49', NULL, NULL, 9487, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 15:55:49', 'admin-1495690898-14956989497884871', 1, 1, 'SR', NULL, NULL, NULL),
(31192, '2017-05-25 15:11:33', NULL, NULL, 9492, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 15:11:33', 'admin-1495690898-14956962936301423', 1, 1, 'SR', NULL, NULL, NULL),
(31193, '2017-05-25 15:34:12', NULL, NULL, 9492, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 15:34:12', 'admin-1495690898-14956976518094863', 1, 1, 'SR', NULL, NULL, NULL),
(31194, '2017-05-25 14:26:06', NULL, NULL, 9491, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 14:26:06', 'admin-1495690898-14956935661802517', 1, 1, 'SR', NULL, NULL, NULL),
(31195, '2017-05-25 13:15:13', NULL, NULL, 9485, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 13:15:13', 'admin-1495678643-14956893129138767', 1, 0, '', NULL, NULL, NULL),
(31196, '2017-05-25 13:16:19', NULL, NULL, 9485, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 13:16:19', 'admin-1495678643-14956893788273211', 1, 1, 'SR', NULL, NULL, NULL),
(31197, '2017-05-25 13:16:19', NULL, NULL, 9485, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 13:16:19', 'admin-1495678643-14956893788273211', 1, 1, 'SR', NULL, NULL, NULL),
(31198, '2017-05-25 14:45:17', NULL, NULL, 9490, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 14:45:17', 'admin-1495690898-14956947171547489', 1, 0, '', NULL, NULL, NULL),
(31199, '2017-05-25 15:09:43', NULL, NULL, 9492, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1495690898', 'admin', '2017-05-25 15:09:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31200, '2017-05-25 12:58:13', NULL, NULL, 9485, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.90, 0.0000, 0.0000, 9.90, 1, '27', 1, '1495690898', 'admin', '2017-05-25 12:58:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31201, '2017-05-25 12:58:18', NULL, NULL, 9485, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 12:58:18', 'admin-1495678643-14956882978343593', 1, 1, 'SR', NULL, NULL, NULL),
(31202, '2017-05-25 12:11:53', NULL, NULL, 9484, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 12:11:53', 'admin-1495678643-14956855129172160', 1, 1, 'SR', NULL, NULL, NULL),
(31203, '2017-05-25 12:11:53', NULL, NULL, 9484, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 12:11:53', 'admin-1495678643-14956855129172160', 1, 0, '', NULL, NULL, NULL),
(31204, '2017-05-25 15:10:11', NULL, NULL, 9492, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 15:10:11', 'admin-1495690898-14956962110696196', 1, 0, '', NULL, NULL, NULL),
(31205, '2017-05-25 10:33:32', NULL, NULL, 9479, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:33:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31206, '2017-05-25 12:11:45', NULL, NULL, 9484, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1495690898', 'admin', '2017-05-25 12:11:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31207, '2017-05-25 12:11:42', NULL, NULL, 9483, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 12:11:42', 'admin-1495678643-14956855020425021', 1, 1, 'SR', NULL, NULL, NULL),
(31208, '2017-05-25 09:15:31', NULL, NULL, 9470, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 09:15:31', 'admin-1495672642-14956749309209737', 1, 1, 'SR', NULL, NULL, NULL),
(31209, '2017-05-25 09:15:31', NULL, NULL, 9470, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 09:15:31', 'admin-1495672642-14956749309209737', 1, 1, 'SR', NULL, NULL, NULL),
(31210, '2017-05-25 12:11:42', NULL, NULL, 9483, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 12:11:42', 'admin-1495678643-14956855020425021', 1, 1, 'SR', NULL, NULL, NULL),
(31211, '2017-05-25 12:09:59', NULL, NULL, 9483, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1495690898', 'admin', '2017-05-25 12:09:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31212, '2017-05-25 12:01:43', NULL, NULL, 9482, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 12:01:43', 'admin-1495678643-14956849036729468', 1, 0, '', NULL, NULL, NULL),
(31213, '2017-05-25 12:01:28', NULL, NULL, 9482, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1495690898', 'admin', '2017-05-25 12:01:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31214, '2017-05-25 00:00:00', NULL, NULL, 9481, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:19:32', 'admin-1495678643-14956787720652570', 1, 1, 'SR', NULL, NULL, NULL),
(31215, '2017-05-25 00:00:00', NULL, NULL, 9480, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:17:18', 'admin-1495672642-1495678637953366', 1, 0, '', NULL, NULL, NULL),
(31216, '2017-05-25 10:33:38', NULL, NULL, 9479, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:33:38', 'admin-1495678643-14956796184852853', 1, 0, '', NULL, NULL, NULL),
(31217, '2017-05-25 10:33:38', NULL, NULL, 9479, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:33:38', 'admin-1495678643-14956796184852853', 1, 0, '', NULL, NULL, NULL),
(31218, '2017-05-25 10:35:29', NULL, NULL, 9479, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:35:29', 'admin-1495678643-14956797294816022', 1, 0, '', NULL, NULL, NULL),
(31219, '2017-05-25 10:33:38', NULL, NULL, 9479, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:33:38', 'admin-1495678643-14956796184852853', 1, 1, 'SR', NULL, NULL, NULL),
(31220, '2017-05-25 10:22:36', NULL, NULL, 9478, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:22:36', 'admin-1495678643-14956789567443920', 1, 1, 'SR', NULL, NULL, NULL),
(31221, '2017-05-25 10:22:33', NULL, NULL, 9478, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:22:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31222, '2017-05-25 11:01:38', NULL, NULL, 9481, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1495690898', 'admin', '2017-05-25 11:01:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31223, '2017-05-25 10:19:20', NULL, NULL, 9476, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:19:20', 'admin-1495678643-14956787598909077', 1, 0, '', NULL, NULL, NULL),
(31224, '2017-05-25 10:19:32', NULL, NULL, 9476, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:19:32', 'admin-1495678643-14956787720652570', 1, 1, 'SR', NULL, NULL, NULL),
(31225, '2017-05-25 00:00:00', NULL, NULL, 9480, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:17:33', 'admin-1495678643-14956786532751298', 1, 1, 'SR', NULL, NULL, NULL),
(31226, '2017-05-25 11:00:49', NULL, NULL, 9480, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1495690898', 'admin', '2017-05-25 11:00:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31227, '2017-05-25 10:08:49', NULL, NULL, 9475, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:08:49', 'admin-1495672642-14956781293768545', 1, 1, 'SR', NULL, NULL, NULL),
(31228, '2017-05-25 14:44:18', NULL, NULL, 9485, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 14:44:18', 'admin-1495690898-14956946588617283', 1, 0, '', NULL, NULL, NULL),
(31229, '2017-05-25 10:17:08', NULL, NULL, 9476, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:17:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31230, '2017-05-25 10:08:49', NULL, NULL, 9475, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:08:49', 'admin-1495672642-14956781293768545', 1, 1, 'SR', NULL, NULL, NULL),
(31231, '2017-05-25 10:07:19', NULL, NULL, 9474, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:07:19', 'admin-1495672642-14956780392283983', 1, 0, '', NULL, NULL, NULL),
(31232, '2017-05-25 10:08:36', NULL, NULL, 9475, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:08:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31233, '2017-05-25 10:06:58', NULL, NULL, 9474, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:06:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31234, '2017-05-25 10:07:19', NULL, NULL, 9474, 0, 154, '88', 'Daily Dose BLT', 'add baked beans', 'Meals', 'Morning Bites ', 1, 17.50, 17.5000, 0.0000, 17.50, 1, '27', 1, '1495690898', 'admin', '2017-05-25 10:07:19', 'admin-1495672642-14956780392283983', 1, 0, '', NULL, NULL, NULL),
(31235, '2017-05-25 09:53:50', NULL, NULL, 9471, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 09:53:50', 'admin-1495672642-14956772302831744', 1, 0, '', NULL, NULL, NULL),
(31236, '2017-05-25 09:49:29', NULL, NULL, 9473, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1495690898', 'admin', '2017-05-25 09:49:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31237, '2017-05-25 09:49:34', NULL, NULL, 9473, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 09:49:34', 'admin-1495672642-14956769739993797', 1, 1, 'SR', NULL, NULL, NULL),
(31238, '2017-05-25 09:38:47', NULL, NULL, 9472, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 09:38:47', 'admin-1495672642-14956763268748355', 1, 1, 'SR', 1, NULL, NULL),
(31239, '2017-05-25 09:30:26', NULL, NULL, 9471, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 09:30:26', 'admin-1495672642-14956758258176549', 1, 0, '', NULL, NULL, NULL),
(31240, '2017-05-25 09:30:15', NULL, NULL, 9471, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1495690898', 'admin', '2017-05-25 09:30:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31241, '2017-05-25 09:15:21', NULL, NULL, 9470, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 09:15:21', 'admin-1495672642-14956749214874163', 1, 0, '', NULL, NULL, NULL),
(31242, '2017-05-25 09:13:15', NULL, NULL, 9468, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 09:13:15', 'admin-1495672642-14956747953564159', 1, 0, '', NULL, NULL, NULL),
(31243, '2017-05-25 09:13:15', NULL, NULL, 9468, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1495690898', 'admin', '2017-05-25 09:13:15', 'admin-1495672642-14956747953564159', 1, 1, 'SR', NULL, NULL, NULL),
(31244, '2017-05-25 09:14:32', NULL, NULL, 9469, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1495690898', 'admin', '2017-05-25 09:14:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31245, '2017-05-25 09:13:08', NULL, NULL, 9468, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1495690898', 'admin', '2017-05-25 09:13:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31246, '2017-05-26 15:35:55', NULL, NULL, 9527, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1495784781', 'admin', '2017-05-26 15:35:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31247, '2017-05-26 15:18:37', NULL, NULL, 9526, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 15:18:37', 'admin-1495777144-14957831176306640', 1, 1, 'SR', NULL, NULL, NULL),
(31248, '2017-05-26 15:18:37', NULL, NULL, 9526, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 15:18:37', 'admin-1495777144-14957831176306640', 1, 0, '', NULL, NULL, NULL),
(31249, '2017-05-26 15:18:37', NULL, NULL, 9526, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 15:18:37', 'admin-1495777144-14957831176306640', 1, 0, '', NULL, NULL, NULL),
(31250, '2017-05-26 13:03:38', NULL, NULL, 9522, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 13:03:38', 'admin-1495768302-14957750183059938', 1, 1, 'SR', NULL, NULL, NULL),
(31251, '2017-05-26 13:03:38', NULL, NULL, 9522, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 13:03:38', 'admin-1495768302-14957750183059938', 1, 0, '', NULL, NULL, NULL),
(31252, '2017-05-26 13:03:57', NULL, NULL, 9522, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 13:03:57', 'admin-1495768302-14957750375929510', 1, 1, 'SR', NULL, NULL, NULL),
(31253, '2017-05-26 13:03:57', NULL, NULL, 9522, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 13:03:57', 'admin-1495768302-14957750375929510', 1, 1, 'SR', NULL, NULL, NULL),
(31254, '2017-05-26 13:03:57', NULL, NULL, 9522, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 13:03:57', 'admin-1495768302-14957750375929510', 1, 1, 'SR', NULL, NULL, NULL),
(31255, '2017-05-26 13:07:06', NULL, NULL, 9521, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 13:07:06', 'admin-1495768302-14957752265704054', 1, 0, '', NULL, NULL, NULL),
(31256, '2017-05-26 13:38:57', NULL, NULL, 9520, 0, 77, '77', 'Sarawak Kolomee', 'replace fried egg,without meat', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 13:38:57', 'admin-1495768302-14957771370118866', 1, 1, 'SR', NULL, NULL, NULL),
(31257, '2017-05-26 13:56:48', NULL, NULL, 9523, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1495784781', 'admin', '2017-05-26 13:56:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31258, '2017-05-26 13:56:55', NULL, NULL, 9523, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 13:56:55', 'admin-1495777144-14957782155105713', 1, 1, 'SR', NULL, NULL, NULL),
(31259, '2017-05-26 10:17:11', NULL, NULL, 9508, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:17:11', 'admin-1495760569-14957650311705833', 1, 0, '', NULL, NULL, NULL),
(31260, '2017-05-26 10:17:11', NULL, NULL, 9508, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:17:11', 'admin-1495760569-14957650311705833', 1, 1, 'SR', NULL, NULL, NULL),
(31261, '2017-05-26 17:33:44', NULL, NULL, 9528, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 17:33:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31262, '2017-05-26 17:33:56', NULL, NULL, 9528, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 17:33:56', 'admin-1495784781-14957912363107686', 1, 1, 'SR', NULL, NULL, NULL),
(31263, '2017-05-26 17:33:56', NULL, NULL, 9528, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 17:33:56', 'admin-1495784781-14957912363107686', 1, 1, 'SR', NULL, NULL, NULL),
(31264, '2017-05-26 17:34:54', NULL, NULL, 9529, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 17:34:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31265, '2017-05-26 17:34:58', NULL, NULL, 9529, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 17:34:58', 'admin-1495784781-14957912985074221', 1, 1, 'SR', NULL, NULL, NULL),
(31266, '2017-05-26 17:49:38', NULL, NULL, 9529, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 17:49:38', 'admin-1495784781-1495792178506249', 1, 1, 'SR', NULL, NULL, NULL),
(31267, '2017-05-26 17:58:42', NULL, NULL, 9530, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1495784781', 'admin', '2017-05-26 17:58:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31268, '2017-05-26 17:58:47', NULL, NULL, 9530, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 17:58:47', 'admin-1495784781-14957927270748313', 1, 1, 'SR', NULL, NULL, NULL),
(31269, '2017-05-26 17:58:47', NULL, NULL, 9530, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 17:58:47', 'admin-1495784781-14957927270748313', 1, 0, '', NULL, NULL, NULL),
(31270, '2017-05-26 18:14:12', NULL, NULL, 9531, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 18:14:12', 'admin-1495784781-14957936523903137', 1, 1, 'SR', 1, NULL, NULL),
(31271, '2017-05-26 12:48:46', NULL, NULL, 9521, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1495784781', 'admin', '2017-05-26 12:48:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31272, '2017-05-26 12:48:55', NULL, NULL, 9521, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 12:48:55', 'admin-1495768302-14957741354335870', 1, 1, 'SR', NULL, NULL, NULL),
(31273, '2017-05-26 12:48:55', NULL, NULL, 9521, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 12:48:55', 'admin-1495768302-14957741354335870', 1, 0, '', NULL, NULL, NULL),
(31274, '2017-05-26 12:48:55', NULL, NULL, 9521, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 12:48:55', 'admin-1495768302-14957741354335870', 1, 1, 'SR', NULL, NULL, NULL),
(31275, '2017-05-26 12:49:09', NULL, NULL, 9521, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 12:49:09', 'admin-1495768302-14957741496954374', 1, 1, 'SR', NULL, NULL, NULL),
(31276, '2017-05-26 12:49:09', NULL, NULL, 9521, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 12:49:09', 'admin-1495768302-14957741496954374', 1, 1, 'SR', NULL, NULL, NULL),
(31277, '2017-05-26 12:49:09', NULL, NULL, 9521, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 12:49:09', 'admin-1495768302-14957741496954374', 1, 1, 'SR', NULL, NULL, NULL),
(31278, '2017-05-26 13:02:29', NULL, NULL, 9522, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 13:02:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31279, '2017-05-26 13:03:38', NULL, NULL, 9522, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 13:03:38', 'admin-1495768302-14957750183059938', 1, 0, '', NULL, NULL, NULL),
(31280, '2017-05-26 15:18:26', NULL, NULL, 9526, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1495784781', 'admin', '2017-05-26 15:18:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31281, '2017-05-26 14:55:01', NULL, NULL, 9525, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 14:55:01', 'admin-1495777144-1495781701690577', 1, 1, 'SR', NULL, NULL, NULL),
(31282, '2017-05-26 14:14:19', NULL, NULL, 9525, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 14:14:19', 'admin-1495777144-14957792591688150', 1, 0, '', NULL, NULL, NULL),
(31283, '2017-05-26 14:14:19', NULL, NULL, 9525, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 14:14:19', 'admin-1495777144-14957792591688150', 1, 0, '', NULL, NULL, NULL),
(31284, '2017-05-26 11:31:52', NULL, NULL, 9519, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1495784781', 'admin', '2017-05-26 11:31:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31285, '2017-05-26 11:32:03', NULL, NULL, 9519, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 11:32:03', 'admin-1495768302-14957695229264484', 1, 0, '', NULL, NULL, NULL),
(31286, '2017-05-26 11:32:03', NULL, NULL, 9519, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 11:32:03', 'admin-1495768302-14957695229264484', 1, 0, '', NULL, NULL, NULL),
(31287, '2017-05-26 11:32:07', NULL, NULL, 9519, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 11:32:07', 'admin-1495768302-14957695275514166', 1, 0, '', NULL, NULL, NULL),
(31288, '2017-05-26 11:32:07', NULL, NULL, 9519, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 11:32:07', 'admin-1495768302-14957695275514166', 1, 0, '', NULL, NULL, NULL),
(31289, '2017-05-26 14:14:19', NULL, NULL, 9525, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 14:14:19', 'admin-1495777144-14957792591688150', 1, 1, 'SR', NULL, NULL, NULL),
(31290, '2017-05-26 14:14:19', NULL, NULL, 9525, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 14:14:19', 'admin-1495777144-14957792591688150', 1, 0, '', NULL, NULL, NULL),
(31291, '2017-05-26 12:40:56', NULL, NULL, 9520, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1495784781', 'admin', '2017-05-26 12:40:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31292, '2017-05-26 12:41:02', NULL, NULL, 9520, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 12:41:02', 'admin-1495768302-14957736620179261', 1, 0, '', NULL, NULL, NULL),
(31293, '2017-05-26 13:56:55', NULL, NULL, 9523, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 13:56:55', 'admin-1495777144-14957782155105713', 1, 0, '', NULL, NULL, NULL),
(31294, '2017-05-26 09:36:19', NULL, NULL, 9501, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 09:36:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31295, '2017-05-26 09:36:26', NULL, NULL, 9501, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 09:36:26', 'admin-1495760569-14957625863715231', 1, 0, '', NULL, NULL, NULL),
(31296, '2017-05-26 09:36:26', NULL, NULL, 9501, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 09:36:26', 'admin-1495760569-14957625863715231', 1, 0, '', NULL, NULL, NULL),
(31297, '2017-05-26 09:36:33', NULL, NULL, 9501, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 09:36:33', 'admin-1495760569-1495762593225984', 1, 1, 'SR', NULL, NULL, NULL),
(31298, '2017-05-26 13:48:42', NULL, NULL, 9520, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 13:48:42', 'admin-1495777144-14957777221234033', 1, 1, 'SR', NULL, NULL, NULL),
(31299, '2017-05-26 10:52:33', NULL, NULL, 9515, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:52:33', 'admin-1495765270-14957671530691968', 1, 0, '', NULL, NULL, NULL),
(31300, '2017-05-26 18:25:38', NULL, NULL, 9532, 0, 182, '117', 'Open Drinks ', 'Beer', 'Cold Drinks', 'Fresh Juice', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 18:25:38', 'admin-1495784781-14957943381619941', 1, 0, '', 1, NULL, NULL),
(31301, '2017-05-26 15:46:39', NULL, NULL, 9527, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 15:46:39', 'admin-1495784781-14957847987635516', 1, 1, 'SR', NULL, NULL, NULL),
(31302, '2017-05-26 13:40:27', NULL, NULL, 9520, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 13:40:27', 'admin-1495777144-14957772276123863', 1, 1, 'SR', NULL, NULL, NULL),
(31303, '2017-05-26 15:40:25', NULL, NULL, 9527, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 15:40:25', 'admin-1495777144-1495784424900319', 1, 1, 'SR', NULL, NULL, NULL),
(31304, '2017-05-26 15:40:25', NULL, NULL, 9527, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 15:40:25', 'admin-1495777144-1495784424900319', 1, 1, 'SR', NULL, NULL, NULL),
(31305, '2017-05-26 12:41:07', NULL, NULL, 9520, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 12:41:07', 'admin-1495768302-14957736672125853', 1, 1, 'SR', NULL, NULL, NULL),
(31306, '2017-05-26 13:38:57', NULL, NULL, 9520, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 13:38:57', 'admin-1495768302-14957771370118866', 1, 0, '', NULL, NULL, NULL),
(31307, '2017-05-26 14:08:39', NULL, NULL, 9524, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1495784781', 'admin', '2017-05-26 14:08:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31308, '2017-05-26 14:08:44', NULL, NULL, 9524, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 14:08:44', 'admin-1495777144-14957789242688155', 1, 1, 'SR', NULL, NULL, NULL),
(31309, '2017-05-26 14:11:28', NULL, NULL, 9525, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.30, 0.0000, 0.0000, 11.30, 1, '27', 1, '1495784781', 'admin', '2017-05-26 14:11:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31310, '2017-05-26 14:11:39', NULL, NULL, 9525, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 14:11:39', 'admin-1495777144-14957790993169191', 1, 1, 'SR', NULL, NULL, NULL),
(31311, '2017-05-26 14:11:39', NULL, NULL, 9525, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 14:11:39', 'admin-1495777144-14957790993169191', 1, 1, 'SR', NULL, NULL, NULL),
(31312, '2017-05-26 14:11:39', NULL, NULL, 9525, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 14:11:39', 'admin-1495777144-14957790993169191', 1, 1, 'SR', NULL, NULL, NULL),
(31313, '2017-05-26 10:28:34', NULL, NULL, 9511, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:28:34', 'admin-1495765270-14957657147782127', 1, 0, '', NULL, NULL, NULL),
(31314, '2017-05-26 10:32:33', NULL, NULL, 9512, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:32:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31315, '2017-05-26 10:32:37', NULL, NULL, 9512, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:32:37', 'admin-1495765270-14957659577679894', 1, 1, 'SR', NULL, NULL, NULL),
(31316, '2017-05-26 10:32:37', NULL, NULL, 9512, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:32:37', 'admin-1495765270-14957659577679894', 1, 1, 'SR', NULL, NULL, NULL),
(31317, '2017-05-26 11:11:15', NULL, NULL, 9516, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 11:11:15', 'admin-1495765270-14957682754031041', 1, 0, '', 1, NULL, NULL),
(31318, '2017-05-26 11:15:22', NULL, NULL, 9517, 0, 181, '116', 'Open Food ', 'apple', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 11:15:22', 'admin-1495768302-14957685223403256', 1, 0, '', 1, NULL, NULL),
(31319, '2017-05-26 11:17:51', NULL, NULL, 9509, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 11:17:51', 'admin-1495768302-14957686715202853', 1, 0, '', NULL, NULL, NULL),
(31320, '2017-05-26 11:23:23', NULL, NULL, 9518, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1495784781', 'admin', '2017-05-26 11:23:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31321, '2017-05-26 11:23:36', NULL, NULL, 9518, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 11:23:36', 'admin-1495768302-14957690164728722', 1, 0, '', NULL, NULL, NULL),
(31322, '2017-05-26 11:23:36', NULL, NULL, 9518, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 11:23:36', 'admin-1495768302-14957690164728722', 1, 0, '', NULL, NULL, NULL),
(31323, '2017-05-26 11:23:36', NULL, NULL, 9518, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 11:23:36', 'admin-1495768302-14957690164728722', 1, 1, 'SR', NULL, NULL, NULL),
(31324, '2017-05-26 10:28:31', NULL, NULL, 9511, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:28:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31325, '2017-05-26 10:04:31', NULL, NULL, 9506, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:04:31', 'admin-1495760569-14957642714188790', 1, 0, '', NULL, NULL, NULL),
(31326, '2017-05-26 10:51:46', NULL, NULL, 9514, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:51:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31327, '2017-05-26 10:24:21', NULL, NULL, 9510, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:24:21', 'admin-1495765270-14957654612831273', 1, 0, '', NULL, NULL, NULL),
(31328, '2017-05-26 11:23:36', NULL, NULL, 9518, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 11:23:36', 'admin-1495768302-14957690164728722', 1, 1, 'SR', NULL, NULL, NULL),
(31329, '2017-05-26 10:52:33', NULL, NULL, 9515, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:52:33', 'admin-1495765270-14957671530691968', 1, 1, 'SR', NULL, NULL, NULL),
(31330, '2017-05-26 10:52:33', NULL, NULL, 9515, 0, 280, '214', 'Diet Meal - Piccolo / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:52:33', 'admin-1495765270-14957671530691968', 1, 0, '', NULL, NULL, NULL),
(31331, '2017-05-26 10:52:24', NULL, NULL, 9515, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:52:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31332, '2017-05-26 09:43:45', NULL, NULL, 9503, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1495784781', 'admin', '2017-05-26 09:43:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31333, '2017-05-26 09:43:51', NULL, NULL, 9503, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 09:43:51', 'admin-1495760569-1495763031756627', 1, 0, '', NULL, NULL, NULL),
(31334, '2017-05-26 09:43:51', NULL, NULL, 9503, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 09:43:51', 'admin-1495760569-1495763031756627', 1, 1, 'SR', NULL, NULL, NULL),
(31335, '2017-05-26 09:48:54', NULL, NULL, 9502, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 09:48:54', 'admin-1495760569-1495763334371874', 1, 1, 'SR', NULL, NULL, NULL),
(31336, '2017-05-26 09:50:14', NULL, NULL, 9504, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1495784781', 'admin', '2017-05-26 09:50:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31337, '2017-05-26 09:50:20', NULL, NULL, 9504, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 09:50:20', 'admin-1495760569-14957634204027686', 1, 0, '', NULL, NULL, NULL),
(31338, '2017-05-26 09:50:20', NULL, NULL, 9504, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 09:50:20', 'admin-1495760569-14957634204027686', 1, 0, '', NULL, NULL, NULL),
(31339, '2017-05-26 10:04:31', NULL, NULL, 9506, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:04:31', 'admin-1495760569-14957642714188790', 1, 0, '', NULL, NULL, NULL),
(31340, '2017-05-26 10:04:31', NULL, NULL, 9506, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:04:31', 'admin-1495760569-14957642714188790', 1, 0, '', NULL, NULL, NULL),
(31341, '2017-05-26 10:04:31', NULL, NULL, 9506, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:04:31', 'admin-1495760569-14957642714188790', 1, 1, 'SR', NULL, NULL, NULL),
(31342, '2017-05-26 10:04:31', NULL, NULL, 9506, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:04:31', 'admin-1495760569-14957642714188790', 1, 1, 'SR', NULL, NULL, NULL),
(31343, '2017-05-26 10:08:46', NULL, NULL, 9507, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:08:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31344, '2017-05-26 10:09:15', NULL, NULL, 9507, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:09:15', 'admin-1495760569-14957645549069569', 1, 0, '', NULL, NULL, NULL),
(31345, '2017-05-26 10:09:15', NULL, NULL, 9507, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:09:15', 'admin-1495760569-14957645549069569', 1, 0, '', NULL, NULL, NULL),
(31346, '2017-05-26 10:09:15', NULL, NULL, 9507, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:09:15', 'admin-1495760569-14957645549069569', 1, 0, '', NULL, NULL, NULL),
(31347, '2017-05-26 10:09:15', NULL, NULL, 9507, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:09:15', 'admin-1495760569-14957645549069569', 1, 0, '', NULL, NULL, NULL),
(31348, '2017-05-26 10:09:15', NULL, NULL, 9507, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:09:15', 'admin-1495760569-14957645549069569', 1, 1, 'SR', NULL, NULL, NULL),
(31349, '2017-05-26 10:51:53', NULL, NULL, 9514, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:51:53', 'admin-1495765270-1495767113629670', 1, 1, 'SR', NULL, NULL, NULL),
(31350, '2017-05-26 10:51:53', NULL, NULL, 9514, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:51:53', 'admin-1495765270-1495767113629670', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(31351, '2017-05-26 10:42:58', NULL, NULL, 9513, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:42:58', 'admin-1495765270-14957665777655329', 1, 0, '', NULL, NULL, NULL),
(31352, '2017-05-26 10:42:58', NULL, NULL, 9513, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:42:58', 'admin-1495765270-14957665777655329', 1, 0, '', NULL, NULL, NULL),
(31353, '2017-05-26 10:17:11', NULL, NULL, 9508, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:17:11', 'admin-1495760569-14957650311705833', 1, 1, 'SR', NULL, NULL, NULL),
(31354, '2017-05-26 10:04:31', NULL, NULL, 9506, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:04:31', 'admin-1495760569-14957642714188790', 1, 1, 'SR', NULL, NULL, NULL),
(31355, '2017-05-26 10:42:51', NULL, NULL, 9513, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:42:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31356, '2017-05-26 10:24:18', NULL, NULL, 9510, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:24:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31357, '2017-05-26 10:17:33', NULL, NULL, 9509, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:17:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31358, '2017-05-26 10:17:39', NULL, NULL, 9509, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:17:39', 'admin-1495760569-14957650592857812', 1, 0, '', NULL, NULL, NULL),
(31359, '2017-05-26 10:17:39', NULL, NULL, 9509, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:17:39', 'admin-1495760569-14957650592857812', 1, 0, '', NULL, NULL, NULL),
(31360, '2017-05-26 10:09:15', NULL, NULL, 9507, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:09:15', 'admin-1495760569-14957645549069569', 1, 1, 'SR', NULL, NULL, NULL),
(31361, '2017-05-26 10:09:15', NULL, NULL, 9507, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:09:15', 'admin-1495760569-14957645549069569', 1, 1, 'SR', NULL, NULL, NULL),
(31362, '2017-05-26 10:17:11', NULL, NULL, 9508, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:17:11', 'admin-1495760569-14957650311705833', 1, 0, '', NULL, NULL, NULL),
(31363, '2017-05-26 10:16:59', NULL, NULL, 9508, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:16:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31364, '2017-05-26 10:04:31', NULL, NULL, 9506, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:04:31', 'admin-1495760569-14957642714188790', 1, 1, 'SR', NULL, NULL, NULL),
(31365, '2017-05-26 09:08:06', NULL, NULL, 9500, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 09:08:06', 'admin-1495760569-1495760886584218', 1, 0, '', NULL, NULL, NULL),
(31366, '2017-05-26 10:02:08', NULL, NULL, 9502, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:02:08', 'admin-1495760569-14957641282706531', 1, 0, '', NULL, NULL, NULL),
(31367, '2017-05-26 10:03:09', NULL, NULL, 9505, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:03:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31368, '2017-05-26 10:03:29', NULL, NULL, 9505, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:03:29', 'admin-1495760569-14957642097495648', 1, 0, '', NULL, NULL, NULL),
(31369, '2017-05-26 10:04:11', NULL, NULL, 9506, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.80, 0.0000, 0.0000, 11.80, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:04:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31370, '2017-05-26 10:04:31', NULL, NULL, 9506, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:04:31', 'admin-1495760569-14957642714188790', 1, 0, '', NULL, NULL, NULL),
(31371, '2017-05-26 10:04:31', NULL, NULL, 9506, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 10:04:31', 'admin-1495760569-14957642714188790', 1, 0, '', NULL, NULL, NULL),
(31372, '2017-05-26 09:42:53', NULL, NULL, 9502, 0, 279, '213', 'Diet Meal - Americano / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 09:42:53', 'admin-1495760569-14957629734816682', 1, 0, '', NULL, NULL, NULL),
(31373, '2017-05-26 09:42:53', NULL, NULL, 9502, 0, 283, '217', 'Weight Gain Deal - TBP / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495784781', 'admin', '2017-05-26 09:42:53', 'admin-1495760569-14957629734816682', 1, 0, '', NULL, NULL, NULL),
(31374, '2017-05-26 09:42:47', NULL, NULL, 9502, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1495784781', 'admin', '2017-05-26 09:42:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31375, '2017-05-26 09:08:04', NULL, NULL, 9500, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1495784781', 'admin', '2017-05-26 09:08:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31376, '2017-05-27 13:19:07', NULL, NULL, 9575, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:19:07', 'admin-1495861619-1495862347166168', 1, 1, 'SR', NULL, NULL, NULL),
(31377, '2017-05-27 13:06:53', NULL, NULL, 9572, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:06:53', 'admin-1495854225-14958616136094926', 1, 0, '', NULL, NULL, NULL),
(31378, '2017-05-27 11:24:14', NULL, NULL, 9563, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:24:14', 'admin-1495854225-14958554544467510', 1, 1, 'SR', NULL, NULL, NULL),
(31379, '2017-05-27 11:24:14', NULL, NULL, 9563, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:24:14', 'admin-1495854225-14958554544467510', 1, 1, 'SR', NULL, NULL, NULL),
(31380, '2017-05-27 11:32:25', NULL, NULL, 9564, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:32:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31381, '2017-05-27 11:33:02', NULL, NULL, 9564, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:33:02', 'admin-1495854225-14958559818589926', 1, 0, '', NULL, NULL, NULL),
(31382, '2017-05-27 11:01:16', NULL, NULL, 9555, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:01:16', 'admin-1495853268-14958540764385642', 1, 1, 'SR', NULL, NULL, '10.0'),
(31383, '2017-05-27 11:01:16', NULL, NULL, 9555, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:01:16', 'admin-1495853268-14958540764385642', 1, 0, '', NULL, NULL, '10.0'),
(31384, '2017-05-27 11:01:16', NULL, NULL, 9555, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:01:16', 'admin-1495853268-14958540764385642', 1, 0, '', NULL, NULL, '10.0'),
(31385, '2017-05-27 11:01:16', NULL, NULL, 9555, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:01:16', 'admin-1495853268-14958540764385642', 1, 0, '', NULL, NULL, '10.0'),
(31386, '2017-05-27 12:15:15', NULL, NULL, 9568, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1495866377', 'admin', '2017-05-27 12:15:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31387, '2017-05-27 10:55:03', NULL, NULL, 9553, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:55:03', 'admin-1495853268-14958537032892688', 1, 0, '', NULL, NULL, NULL),
(31388, '2017-05-27 10:55:03', NULL, NULL, 9553, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:55:03', 'admin-1495853268-14958537032892688', 1, 1, 'SR', NULL, NULL, NULL),
(31389, '2017-05-27 10:55:03', NULL, NULL, 9553, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:55:03', 'admin-1495853268-14958537032892688', 1, 1, 'SR', NULL, NULL, NULL),
(31390, '2017-05-27 10:56:54', NULL, NULL, 9553, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:56:54', 'admin-1495853268-1495853814296794', 1, 0, '', NULL, NULL, NULL),
(31391, '2017-05-27 10:57:10', NULL, NULL, 9553, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:57:10', 'admin-1495853268-14958538298632526', 1, 0, '', NULL, NULL, NULL),
(31392, '2017-05-27 10:59:35', NULL, NULL, 9554, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:59:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31393, '2017-05-27 11:00:33', NULL, NULL, 9554, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:00:33', 'admin-1495853268-14958540334879235', 1, 0, '', NULL, NULL, NULL),
(31394, '2017-05-27 12:15:32', NULL, NULL, 9568, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 12:15:32', 'admin-1495854225-14958585318979987', 1, 1, 'SR', NULL, NULL, NULL),
(31395, '2017-05-27 12:15:32', NULL, NULL, 9568, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 12:15:32', 'admin-1495854225-14958585318979987', 1, 0, '', NULL, NULL, NULL),
(31396, '2017-05-27 10:45:53', NULL, NULL, 9549, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:45:53', 'admin-1495850051-149585315355483', 1, 0, '', NULL, NULL, NULL),
(31397, '2017-05-27 10:45:53', NULL, NULL, 9549, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:45:53', 'admin-1495850051-149585315355483', 1, 0, '', NULL, NULL, NULL),
(31398, '2017-05-27 09:55:12', NULL, NULL, 9539, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.90, 0.0000, 0.0000, 10.90, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:55:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31399, '2017-05-27 09:55:37', NULL, NULL, 9539, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:55:37', 'admin-1495850051-14958501369936439', 1, 0, '', NULL, NULL, NULL),
(31400, '2017-05-27 14:15:45', NULL, NULL, 9583, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:15:45', 'admin-1495865063-14958657450746787', 1, 1, 'SR', NULL, NULL, NULL),
(31401, '2017-05-27 14:15:45', NULL, NULL, 9583, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:15:45', 'admin-1495865063-14958657450746787', 1, 0, '', NULL, NULL, NULL),
(31402, '2017-05-27 14:15:45', NULL, NULL, 9583, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:15:45', 'admin-1495865063-14958657450746787', 1, 0, '', NULL, NULL, NULL),
(31403, '2017-05-27 14:15:45', NULL, NULL, 9583, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:15:45', 'admin-1495865063-14958657450746787', 1, 1, 'SR', NULL, NULL, NULL),
(31404, '2017-05-27 14:50:50', NULL, NULL, 9584, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:50:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31405, '2017-05-27 13:52:38', NULL, NULL, 9581, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:52:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31406, '2017-05-27 13:52:42', NULL, NULL, 9581, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:52:42', 'admin-1495861619-1495864362193377', 1, 0, '', NULL, NULL, NULL),
(31407, '2017-05-27 13:52:42', NULL, NULL, 9581, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:52:42', 'admin-1495861619-1495864362193377', 1, 0, '', NULL, NULL, NULL),
(31408, '2017-05-27 14:04:46', NULL, NULL, 9579, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:04:46', 'admin-1495865063-14958650859087080', 1, 0, '', NULL, NULL, NULL),
(31409, '2017-05-27 14:15:45', NULL, NULL, 9583, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:15:45', 'admin-1495865063-14958657450746787', 1, 0, '', NULL, NULL, NULL),
(31410, '2017-05-27 14:15:45', NULL, NULL, 9583, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:15:45', 'admin-1495865063-14958657450746787', 1, 0, '', NULL, NULL, NULL),
(31411, '2017-05-27 14:15:45', NULL, NULL, 9583, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:15:45', 'admin-1495865063-14958657450746787', 1, 0, '', NULL, NULL, NULL),
(31412, '2017-05-27 10:45:26', NULL, NULL, 9549, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:45:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31413, '2017-05-27 10:47:42', NULL, NULL, 9547, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:47:42', 'admin-1495850051-1495853261741289', 1, 0, '', NULL, NULL, NULL),
(31414, '2017-05-27 10:48:27', NULL, NULL, 9550, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:48:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31415, '2017-05-27 10:48:33', NULL, NULL, 9550, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:48:33', 'admin-1495853268-14958533136575419', 1, 0, '', NULL, NULL, NULL),
(31416, '2017-05-27 10:48:33', NULL, NULL, 9550, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:48:33', 'admin-1495853268-14958533136575419', 1, 0, '', NULL, NULL, NULL),
(31417, '2017-05-27 10:48:51', NULL, NULL, 9550, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:48:51', 'admin-1495853268-14958533311115639', 1, 1, 'SR', NULL, NULL, NULL),
(31418, '2017-05-27 10:48:51', NULL, NULL, 9550, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:48:51', 'admin-1495853268-14958533311115639', 1, 1, 'SR', NULL, NULL, NULL),
(31419, '2017-05-27 10:49:54', NULL, NULL, 9551, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:49:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31420, '2017-05-27 10:50:26', NULL, NULL, 9551, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:50:26', 'admin-1495853268-14958534259584722', 1, 0, '', NULL, NULL, NULL),
(31421, '2017-05-27 10:50:26', NULL, NULL, 9551, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:50:26', 'admin-1495853268-14958534259584722', 1, 0, '', NULL, NULL, NULL),
(31422, '2017-05-27 10:50:26', NULL, NULL, 9551, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:50:26', 'admin-1495853268-14958534259584722', 1, 0, '', NULL, NULL, NULL),
(31423, '2017-05-27 14:51:05', NULL, NULL, 9584, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:51:05', 'admin-1495866377-14958678652478768', 1, 0, '', NULL, NULL, NULL),
(31424, '2017-05-27 14:26:26', NULL, NULL, 9579, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:26:26', 'admin-1495866377-14958663857707637', 1, 1, 'SR', NULL, NULL, NULL),
(31425, '2017-05-27 14:15:45', NULL, NULL, 9583, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:15:45', 'admin-1495865063-14958657450746787', 1, 0, '', NULL, NULL, NULL),
(31426, '2017-05-27 10:20:45', NULL, NULL, 9547, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.30, 0.0000, 0.0000, 13.30, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:20:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31427, '2017-05-27 10:21:11', NULL, NULL, 9547, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:21:11', 'admin-1495850051-1495851670874966', 1, 0, '', NULL, NULL, NULL),
(31428, '2017-05-27 10:21:11', NULL, NULL, 9547, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:21:11', 'admin-1495850051-1495851670874966', 1, 0, '', NULL, NULL, NULL),
(31429, '2017-05-27 10:21:11', NULL, NULL, 9547, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:21:11', 'admin-1495850051-1495851670874966', 1, 0, '', NULL, NULL, NULL),
(31430, '2017-05-27 10:21:11', NULL, NULL, 9547, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:21:11', 'admin-1495850051-1495851670874966', 1, 0, '', NULL, NULL, NULL),
(31431, '2017-05-27 10:21:11', NULL, NULL, 9547, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:21:11', 'admin-1495850051-1495851670874966', 1, 1, 'SR', NULL, NULL, NULL),
(31432, '2017-05-27 10:21:11', NULL, NULL, 9547, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:21:11', 'admin-1495850051-1495851670874966', 1, 1, 'SR', NULL, NULL, NULL),
(31433, '2017-05-27 10:21:11', NULL, NULL, 9547, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:21:11', 'admin-1495850051-1495851670874966', 1, 1, 'SR', NULL, NULL, NULL),
(31434, '2017-05-27 14:11:55', NULL, NULL, 9581, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:11:55', 'admin-1495865063-14958655148945679', 1, 0, '', NULL, NULL, NULL),
(31435, '2017-05-27 14:05:04', NULL, NULL, 9579, 0, 181, '116', 'Open Food ', 'plain rice', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:05:04', 'admin-1495865063-14958651040544666', 1, 0, '', NULL, NULL, NULL),
(31436, '2017-05-27 14:09:18', NULL, NULL, 9579, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:09:18', 'admin-1495865063-1495865357967254', 1, 1, 'SR', NULL, NULL, NULL),
(31437, '2017-05-27 11:04:37', NULL, NULL, 9557, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:04:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31438, '2017-05-27 11:04:43', NULL, NULL, 9557, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:04:43', 'admin-1495854225-1495854283001251', 1, 0, '', NULL, NULL, NULL),
(31439, '2017-05-27 11:06:56', NULL, NULL, 9558, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:06:56', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(31440, '2017-05-27 11:07:12', NULL, NULL, 9558, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:07:12', 'admin-1495854225-14958544327958112', 1, 0, '', NULL, NULL, '10.0'),
(31441, '2017-05-27 11:07:12', NULL, NULL, 9558, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:07:12', 'admin-1495854225-14958544327958112', 1, 0, '', NULL, NULL, '10.0'),
(31442, '2017-05-27 11:08:40', NULL, NULL, 9558, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:08:40', 'admin-1495854225-14958545201631251', 1, 1, 'SR', NULL, NULL, '10.0'),
(31443, '2017-05-27 11:08:40', NULL, NULL, 9558, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:08:40', 'admin-1495854225-14958545201631251', 1, 1, 'SR', NULL, NULL, '10.0'),
(31444, '2017-05-27 11:01:16', NULL, NULL, 9555, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:01:16', 'admin-1495853268-14958540764385642', 1, 1, 'SR', NULL, NULL, '10.0'),
(31445, '2017-05-27 11:01:16', NULL, NULL, 9555, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:01:16', 'admin-1495853268-14958540764385642', 1, 1, 'SR', NULL, NULL, '10.0'),
(31446, '2017-05-27 11:03:29', NULL, NULL, 9556, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:03:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31447, '2017-05-27 13:43:17', NULL, NULL, 9578, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:43:17', 'admin-1495861619-149586379704377', 1, 0, '', NULL, NULL, NULL),
(31448, '2017-05-27 13:43:17', NULL, NULL, 9578, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:43:17', 'admin-1495861619-149586379704377', 1, 1, 'SR', NULL, NULL, NULL),
(31449, '2017-05-27 13:43:17', NULL, NULL, 9578, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:43:17', 'admin-1495861619-149586379704377', 1, 1, 'SR', NULL, NULL, NULL),
(31450, '2017-05-27 14:04:16', NULL, NULL, 9579, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:04:16', 'admin-1495864484-14958650567268738', 1, 0, '', NULL, NULL, NULL),
(31451, '2017-05-27 14:04:33', NULL, NULL, 9576, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:04:33', 'admin-1495865063-1495865073208769', 1, 0, '', NULL, NULL, NULL),
(31452, '2017-05-27 14:04:46', NULL, NULL, 9579, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:04:46', 'admin-1495865063-14958650859087080', 1, 1, 'SR', NULL, NULL, NULL),
(31453, '2017-05-27 14:04:16', NULL, NULL, 9579, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:04:16', 'admin-1495864484-14958650567268738', 1, 0, '', NULL, NULL, NULL),
(31454, '2017-05-27 14:04:16', NULL, NULL, 9579, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:04:16', 'admin-1495864484-14958650567268738', 1, 1, 'SR', NULL, NULL, NULL),
(31455, '2017-05-27 13:52:17', NULL, NULL, 9579, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:52:17', 'admin-1495861619-14958643374035878', 1, 1, 'SR', NULL, NULL, NULL),
(31456, '2017-05-27 13:52:17', NULL, NULL, 9579, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:52:17', 'admin-1495861619-14958643374035878', 1, 1, 'SR', NULL, NULL, NULL),
(31457, '2017-05-27 13:52:17', NULL, NULL, 9579, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:52:17', 'admin-1495861619-14958643374035878', 1, 1, 'SR', NULL, NULL, NULL),
(31458, '2017-05-27 13:18:57', NULL, NULL, 9575, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:18:57', 'admin-1495861619-14958623373652952', 1, 0, '', NULL, NULL, NULL),
(31459, '2017-05-27 13:07:29', NULL, NULL, 9572, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:07:29', 'admin-1495861619-1495861649553679', 1, 1, 'SR', NULL, NULL, NULL),
(31460, '2017-05-27 13:07:29', NULL, NULL, 9572, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:07:29', 'admin-1495861619-1495861649553679', 1, 1, 'SR', NULL, NULL, NULL),
(31461, '2017-05-27 13:07:29', NULL, NULL, 9572, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:07:29', 'admin-1495861619-1495861649553679', 1, 1, 'SR', NULL, NULL, NULL),
(31462, '2017-05-27 10:54:54', NULL, NULL, 9553, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:54:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31463, '2017-05-27 11:00:33', NULL, NULL, 9554, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:00:33', 'admin-1495853268-14958540334879235', 1, 0, '', NULL, NULL, NULL),
(31464, '2017-05-27 11:00:33', NULL, NULL, 9554, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:00:33', 'admin-1495853268-14958540334879235', 1, 0, '', NULL, NULL, NULL),
(31465, '2017-05-27 10:03:13', NULL, NULL, 9543, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:03:13', 'admin-1495850051-14958505930919082', 1, 1, 'SR', NULL, NULL, NULL),
(31466, '2017-05-27 09:47:24', NULL, NULL, 9538, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:47:24', 'admin-1495849608-1495849643952236', 1, 1, 'SR', NULL, NULL, NULL),
(31467, '2017-05-27 09:47:24', NULL, NULL, 9538, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:47:24', 'admin-1495849608-1495849643952236', 1, 1, 'SR', NULL, NULL, NULL),
(31468, '2017-05-27 09:47:24', NULL, NULL, 9538, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:47:24', 'admin-1495849608-1495849643952236', 1, 1, 'SR', NULL, NULL, NULL),
(31469, '2017-05-27 09:47:24', NULL, NULL, 9538, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:47:24', 'admin-1495849608-1495849643952236', 1, 1, 'SR', NULL, NULL, NULL),
(31470, '2017-05-27 09:47:24', NULL, NULL, 9538, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:47:24', 'admin-1495849608-1495849643952236', 1, 1, 'SR', NULL, NULL, NULL),
(31471, '2017-05-27 14:04:16', NULL, NULL, 9579, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:04:16', 'admin-1495864484-14958650567268738', 1, 1, 'SR', NULL, NULL, NULL),
(31472, '2017-05-27 14:03:53', NULL, NULL, 9579, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:03:53', 'admin-1495864484-14958650332543139', 1, 0, '', NULL, NULL, NULL),
(31473, '2017-05-27 14:25:04', NULL, NULL, 9579, 0, 181, '116', 'Open Food ', 'dumpling 8''s', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:25:04', 'admin-1495865063-14958663047698747', 1, 0, '', NULL, NULL, NULL),
(31474, '2017-05-27 14:03:53', NULL, NULL, 9579, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:03:53', 'admin-1495864484-14958650332543139', 1, 0, '', NULL, NULL, NULL),
(31475, '2017-05-27 14:03:53', NULL, NULL, 9579, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:03:53', 'admin-1495864484-14958650332543139', 1, 0, '', NULL, NULL, NULL),
(31476, '2017-05-27 14:51:05', NULL, NULL, 9584, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:51:05', 'admin-1495866377-14958678652478768', 1, 1, 'SR', NULL, NULL, NULL),
(31477, '2017-05-27 14:03:03', NULL, NULL, 9582, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:03:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31478, '2017-05-27 14:03:06', NULL, NULL, 9582, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:03:06', 'admin-1495864484-1495864986536322', 1, 1, 'SR', NULL, NULL, NULL),
(31479, '2017-05-27 14:03:06', NULL, NULL, 9582, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:03:06', 'admin-1495864484-1495864986536322', 1, 1, 'SR', NULL, NULL, NULL),
(31480, '2017-05-27 11:00:33', NULL, NULL, 9554, 0, 32, '32', 'Tea By Pot ', 'strawberry', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:00:33', 'admin-1495853268-14958540334879235', 1, 1, 'SR', NULL, NULL, NULL),
(31481, '2017-05-27 11:01:16', NULL, NULL, 9555, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:01:16', 'admin-1495853268-14958540764385642', 1, 1, 'SR', NULL, NULL, '10.0'),
(31482, '2017-05-27 10:09:50', NULL, NULL, 9542, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:09:50', 'admin-1495850051-1495850989937652', 1, 0, '', NULL, NULL, NULL),
(31483, '2017-05-27 10:17:22', NULL, NULL, 9545, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:17:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31484, '2017-05-27 09:56:38', NULL, NULL, 9541, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:56:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31485, '2017-05-27 09:56:54', NULL, NULL, 9541, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:56:54', 'admin-1495850051-14958502140059563', 1, 1, 'SR', NULL, NULL, NULL),
(31486, '2017-05-27 14:02:51', NULL, NULL, 9579, 0, 181, '116', 'Open Food ', 'lemony chicken', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:02:51', 'admin-1495864484-1495864971470627', 1, 0, '', NULL, NULL, NULL),
(31487, '2017-05-27 14:02:14', NULL, NULL, 9579, 0, 181, '116', 'Open Food ', 'pepper pork', 'Meals', 'Perfect Meals', 1, 30.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:02:14', 'admin-1495864484-1495864934380135', 1, 0, '', NULL, NULL, NULL),
(31488, '2017-05-27 14:01:45', NULL, NULL, 9578, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:01:45', 'admin-1495864484-14958649053722683', 1, 0, '', NULL, NULL, NULL),
(31489, '2017-05-27 13:32:41', NULL, NULL, 9577, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:32:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31490, '2017-05-27 13:06:53', NULL, NULL, 9572, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:06:53', 'admin-1495854225-14958616136094926', 1, 0, '', NULL, NULL, NULL),
(31491, '2017-05-27 13:06:53', NULL, NULL, 9572, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:06:53', 'admin-1495854225-14958616136094926', 1, 0, '', NULL, NULL, NULL),
(31492, '2017-05-27 13:06:32', NULL, NULL, 9572, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.30, 0.0000, 0.0000, 14.30, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:06:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31493, '2017-05-27 11:22:14', NULL, NULL, 9560, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:22:14', 'admin-1495854225-14958553346257469', 1, 0, '', NULL, NULL, NULL),
(31494, '2017-05-27 13:04:58', NULL, NULL, 9571, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:04:58', 'admin-1495854225-1495861497919111', 1, 1, 'SR', NULL, NULL, NULL),
(31495, '2017-05-27 13:04:32', NULL, NULL, 9571, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:04:32', 'admin-1495854225-14958614721851897', 1, 0, '', NULL, NULL, NULL),
(31496, '2017-05-27 13:04:32', NULL, NULL, 9571, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:04:32', 'admin-1495854225-14958614721851897', 1, 1, 'SR', NULL, NULL, NULL),
(31497, '2017-05-27 13:04:32', NULL, NULL, 9571, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:04:32', 'admin-1495854225-14958614721851897', 1, 0, '', NULL, NULL, NULL),
(31498, '2017-05-27 13:03:56', NULL, NULL, 9571, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:03:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31499, '2017-05-27 12:32:50', NULL, NULL, 9570, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 12:32:50', 'admin-1495854225-1495859570450287', 1, 1, 'SR', NULL, NULL, NULL),
(31500, '2017-05-27 12:32:50', NULL, NULL, 9570, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 12:32:50', 'admin-1495854225-1495859570450287', 1, 1, 'SR', NULL, NULL, NULL),
(31501, '2017-05-27 12:32:50', NULL, NULL, 9570, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 12:32:50', 'admin-1495854225-1495859570450287', 1, 1, 'SR', NULL, NULL, NULL),
(31502, '2017-05-27 12:32:42', NULL, NULL, 9570, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1495866377', 'admin', '2017-05-27 12:32:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31503, '2017-05-27 12:22:32', NULL, NULL, 9569, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 12:22:32', 'admin-1495854225-14958589527373011', 1, 0, '', NULL, NULL, NULL),
(31504, '2017-05-27 12:16:49', NULL, NULL, 9569, 0, 32, '32', 'Tea By Pot ', 'senca', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 12:16:49', 'admin-1495854225-14958586096186172', 1, 1, 'SR', NULL, NULL, NULL),
(31505, '2017-05-27 12:16:33', NULL, NULL, 9569, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 12:16:33', 'admin-1495854225-1495858593487345', 1, 0, '', NULL, NULL, NULL),
(31506, '2017-05-27 13:55:25', NULL, NULL, 9581, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:55:25', 'admin-1495864484-14958645257467012', 1, 1, 'SR', NULL, NULL, NULL),
(31507, '2017-05-27 13:55:25', NULL, NULL, 9581, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:55:25', 'admin-1495864484-14958645257467012', 1, 1, 'SR', NULL, NULL, NULL),
(31508, '2017-05-27 13:52:17', NULL, NULL, 9579, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:52:17', 'admin-1495861619-14958643374035878', 1, 1, 'SR', NULL, NULL, NULL),
(31509, '2017-05-27 13:52:05', NULL, NULL, 9579, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 30.40, 0.0000, 0.0000, 30.40, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:52:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31510, '2017-05-27 13:52:17', NULL, NULL, 9579, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:52:17', 'admin-1495861619-14958643374035878', 1, 1, 'SR', NULL, NULL, NULL),
(31511, '2017-05-27 11:23:45', NULL, NULL, 9562, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:23:45', 'admin-1495854225-14958554248101239', 1, 0, '', NULL, NULL, NULL),
(31512, '2017-05-27 13:14:47', NULL, NULL, 9573, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:14:47', 'admin-1495861619-1495862087429723', 1, 1, 'SR', NULL, NULL, NULL),
(31513, '2017-05-27 13:50:52', NULL, NULL, 9572, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:50:52', 'admin-1495861619-14958642520843730', 1, 0, '', NULL, NULL, NULL),
(31514, '2017-05-27 13:46:39', NULL, NULL, 9572, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:46:39', 'admin-1495861619-14958639996579080', 1, 0, '', NULL, NULL, NULL),
(31515, '2017-05-27 11:33:02', NULL, NULL, 9564, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:33:02', 'admin-1495854225-14958559818589926', 1, 0, '', NULL, NULL, NULL),
(31516, '2017-05-27 11:37:49', NULL, NULL, 9549, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:37:49', 'admin-1495854225-14958562688962188', 1, 0, '', NULL, NULL, NULL),
(31517, '2017-05-27 13:44:24', NULL, NULL, 9572, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:44:24', 'admin-1495861619-14958638640698011', 1, 0, '', NULL, NULL, NULL),
(31518, '2017-05-27 13:44:24', NULL, NULL, 9572, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:44:24', 'admin-1495861619-14958638640698011', 1, 1, 'SR', NULL, NULL, NULL),
(31519, '2017-05-27 13:32:56', NULL, NULL, 9577, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:32:56', 'admin-1495861619-14958631766716692', 1, 1, 'SR', NULL, NULL, NULL),
(31520, '2017-05-27 13:42:36', NULL, NULL, 9578, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.30, 0.0000, 0.0000, 11.30, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:42:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31521, '2017-05-27 13:43:17', NULL, NULL, 9578, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:43:17', 'admin-1495861619-149586379704377', 1, 0, '', NULL, NULL, NULL),
(31522, '2017-05-27 11:53:45', NULL, NULL, 9567, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:53:45', 'admin-1495854225-1495857224908793', 1, 0, '', NULL, NULL, NULL),
(31523, '2017-05-27 11:53:52', NULL, NULL, 9567, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:53:52', 'admin-1495854225-1495857232249182', 1, 0, '', NULL, NULL, NULL),
(31524, '2017-05-27 12:00:15', NULL, NULL, 9560, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 12:00:15', 'admin-1495854225-14958576149791984', 1, 0, '', NULL, NULL, NULL),
(31525, '2017-05-27 11:53:31', NULL, NULL, 9567, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:53:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31526, '2017-05-27 11:43:35', NULL, NULL, 9565, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:43:35', 'admin-1495854225-14958566150734841', 1, 0, '', NULL, NULL, NULL),
(31527, '2017-05-27 11:43:35', NULL, NULL, 9565, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:43:35', 'admin-1495854225-14958566150734841', 1, 1, 'SR', NULL, NULL, NULL),
(31528, '2017-05-27 11:43:35', NULL, NULL, 9565, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:43:35', 'admin-1495854225-14958566150734841', 1, 1, 'SR', NULL, NULL, NULL),
(31529, '2017-05-27 11:43:35', NULL, NULL, 9565, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:43:35', 'admin-1495854225-14958566150734841', 1, 0, '', NULL, NULL, NULL),
(31530, '2017-05-27 11:43:35', NULL, NULL, 9565, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:43:35', 'admin-1495854225-14958566150734841', 1, 0, '', NULL, NULL, NULL),
(31531, '2017-05-27 11:43:35', NULL, NULL, 9565, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:43:35', 'admin-1495854225-14958566150734841', 1, 0, '', NULL, NULL, NULL),
(31532, '2017-05-27 11:44:06', NULL, NULL, 9562, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:44:06', 'admin-1495854225-14958566464911141', 1, 1, 'SR', NULL, NULL, NULL),
(31533, '2017-05-27 14:01:45', NULL, NULL, 9578, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:01:45', 'admin-1495864484-14958649053722683', 1, 1, 'SR', NULL, NULL, NULL),
(31534, '2017-05-27 13:19:07', NULL, NULL, 9575, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:19:07', 'admin-1495861619-1495862347166168', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(31535, '2017-05-27 14:13:51', NULL, NULL, 9583, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.55, 0.0000, 0.0000, 10.55, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:13:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31536, '2017-05-27 14:01:45', NULL, NULL, 9578, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:01:45', 'admin-1495864484-14958649053722683', 1, 1, 'SR', NULL, NULL, NULL),
(31537, '2017-05-27 13:22:57', NULL, NULL, 9576, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:22:57', 'admin-1495861619-14958625774713463', 1, 0, '', NULL, NULL, NULL),
(31538, '2017-05-27 13:14:47', NULL, NULL, 9573, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:14:47', 'admin-1495861619-1495862087429723', 1, 0, '', NULL, NULL, NULL),
(31539, '2017-05-27 13:37:30', NULL, NULL, 9577, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:37:30', 'admin-1495861619-14958634499107229', 1, 0, '', NULL, NULL, NULL),
(31540, '2017-05-27 13:22:57', NULL, NULL, 9576, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:22:57', 'admin-1495861619-14958625774713463', 1, 1, 'SR', NULL, NULL, NULL),
(31541, '2017-05-27 14:03:43', NULL, NULL, 9579, 0, 181, '116', 'Open Food ', 'rice wine ginger pork', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:03:43', 'admin-1495864484-14958650237628195', 1, 0, '', NULL, NULL, NULL),
(31542, '2017-05-27 13:18:57', NULL, NULL, 9575, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:18:57', 'admin-1495861619-14958623373652952', 1, 1, 'SR', NULL, NULL, NULL),
(31543, '2017-05-27 13:18:40', NULL, NULL, 9574, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:18:40', 'admin-1495861619-1495862320704480', 1, 1, 'SR', NULL, NULL, NULL),
(31544, '2017-05-27 13:18:43', NULL, NULL, 9575, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:18:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31545, '2017-05-27 13:18:40', NULL, NULL, 9574, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:18:40', 'admin-1495861619-1495862320704480', 1, 1, 'SR', NULL, NULL, NULL),
(31546, '2017-05-27 13:18:23', NULL, NULL, 9574, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:18:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31547, '2017-05-27 13:15:01', NULL, NULL, 9573, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:15:01', 'admin-1495861619-14958621008366678', 1, 1, 'SR', NULL, NULL, NULL),
(31548, '2017-05-27 13:15:01', NULL, NULL, 9573, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:15:01', 'admin-1495861619-14958621008366678', 1, 1, 'SR', NULL, NULL, NULL),
(31549, '2017-05-27 13:15:01', NULL, NULL, 9573, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:15:01', 'admin-1495861619-14958621008366678', 1, 1, 'SR', NULL, NULL, NULL),
(31550, '2017-05-27 13:15:01', NULL, NULL, 9573, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:15:01', 'admin-1495861619-14958621008366678', 1, 1, 'SR', NULL, NULL, NULL),
(31551, '2017-05-27 12:00:15', NULL, NULL, 9560, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 12:00:15', 'admin-1495854225-14958576149791984', 1, 0, '', NULL, NULL, NULL),
(31552, '2017-05-27 11:24:03', NULL, NULL, 9563, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:24:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31553, '2017-05-27 11:24:14', NULL, NULL, 9563, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:24:14', 'admin-1495854225-14958554544467510', 1, 0, '', NULL, NULL, NULL),
(31554, '2017-05-27 11:10:49', NULL, NULL, 9559, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:10:49', 'admin-1495854225-14958546496301837', 1, 1, 'SR', NULL, NULL, NULL),
(31555, '2017-05-27 11:10:49', NULL, NULL, 9559, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:10:49', 'admin-1495854225-14958546496301837', 1, 1, 'SR', NULL, NULL, NULL),
(31556, '2017-05-27 11:12:07', NULL, NULL, 9560, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:12:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31557, '2017-05-27 11:12:11', NULL, NULL, 9560, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:12:11', 'admin-1495854225-14958547309543186', 1, 1, 'SR', NULL, NULL, NULL),
(31558, '2017-05-27 11:12:11', NULL, NULL, 9560, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:12:11', 'admin-1495854225-14958547309543186', 1, 1, 'SR', NULL, NULL, NULL),
(31559, '2017-05-27 11:15:14', NULL, NULL, 9561, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:15:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31560, '2017-05-27 11:15:20', NULL, NULL, 9561, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:15:20', 'admin-1495854225-14958549198744285', 1, 0, '', NULL, NULL, NULL),
(31561, '2017-05-27 13:14:47', NULL, NULL, 9573, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:14:47', 'admin-1495861619-1495862087429723', 1, 0, '', NULL, NULL, NULL),
(31562, '2017-05-27 13:14:47', NULL, NULL, 9573, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:14:47', 'admin-1495861619-1495862087429723', 1, 1, 'SR', NULL, NULL, NULL),
(31563, '2017-05-27 13:14:28', NULL, NULL, 9573, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.50, 0.0000, 0.0000, 9.50, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:14:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31564, '2017-05-27 13:07:29', NULL, NULL, 9572, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:07:29', 'admin-1495861619-1495861649553679', 1, 0, '', NULL, NULL, NULL),
(31565, '2017-05-27 13:06:53', NULL, NULL, 9572, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:06:53', 'admin-1495854225-14958616136094926', 1, 1, 'SR', NULL, NULL, NULL),
(31566, '2017-05-27 11:46:07', NULL, NULL, 9566, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:46:07', 'admin-1495854225-14958567672396882', 1, 1, 'SR', NULL, NULL, NULL),
(31567, '2017-05-27 11:53:45', NULL, NULL, 9567, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:53:45', 'admin-1495854225-1495857224908793', 1, 0, '', NULL, NULL, NULL),
(31568, '2017-05-27 11:46:07', NULL, NULL, 9566, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:46:07', 'admin-1495854225-14958567672396882', 1, 1, 'SR', NULL, NULL, NULL),
(31569, '2017-05-27 11:46:07', NULL, NULL, 9566, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:46:07', 'admin-1495854225-14958567672396882', 1, 1, 'SR', NULL, NULL, NULL),
(31570, '2017-05-27 11:45:58', NULL, NULL, 9566, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:45:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31571, '2017-05-27 11:43:35', NULL, NULL, 9565, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:43:35', 'admin-1495854225-14958566150734841', 1, 0, '', NULL, NULL, NULL),
(31572, '2017-05-27 11:43:35', NULL, NULL, 9565, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:43:35', 'admin-1495854225-14958566150734841', 1, 0, '', NULL, NULL, NULL),
(31573, '2017-05-27 13:06:53', NULL, NULL, 9572, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:06:53', 'admin-1495854225-14958616136094926', 1, 0, '', NULL, NULL, NULL),
(31574, '2017-05-27 11:42:42', NULL, NULL, 9565, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:42:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31575, '2017-05-27 10:53:25', NULL, NULL, 9552, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:53:25', 'admin-1495853268-14958536051123647', 1, 1, 'SR', NULL, NULL, NULL),
(31576, '2017-05-27 10:53:18', NULL, NULL, 9552, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:53:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31577, '2017-05-27 10:53:25', NULL, NULL, 9552, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:53:25', 'admin-1495853268-14958536051123647', 1, 1, 'SR', NULL, NULL, NULL),
(31578, '2017-05-27 10:50:26', NULL, NULL, 9551, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:50:26', 'admin-1495853268-14958534259584722', 1, 0, '', NULL, NULL, NULL),
(31579, '2017-05-27 11:33:02', NULL, NULL, 9564, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:33:02', 'admin-1495854225-14958559818589926', 1, 1, 'SR', NULL, NULL, NULL),
(31580, '2017-05-27 11:24:14', NULL, NULL, 9563, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:24:14', 'admin-1495854225-14958554544467510', 1, 0, '', NULL, NULL, NULL),
(31581, '2017-05-27 10:42:27', NULL, NULL, 9548, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:42:27', 'admin-1495850051-14958529470261852', 1, 0, '', NULL, NULL, NULL),
(31582, '2017-05-27 14:51:05', NULL, NULL, 9584, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:51:05', 'admin-1495866377-14958678652478768', 1, 0, '', NULL, NULL, NULL),
(31583, '2017-05-27 11:23:45', NULL, NULL, 9562, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:23:45', 'admin-1495854225-14958554248101239', 1, 1, 'SR', NULL, NULL, NULL),
(31584, '2017-05-27 12:15:43', NULL, NULL, 9569, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1495866377', 'admin', '2017-05-27 12:15:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31585, '2017-05-27 11:23:33', NULL, NULL, 9562, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:23:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31586, '2017-05-27 11:10:44', NULL, NULL, 9559, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:10:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31587, '2017-05-27 11:08:40', NULL, NULL, 9558, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:08:40', 'admin-1495854225-14958545201631251', 1, 1, 'SR', NULL, NULL, '10.0'),
(31588, '2017-05-27 11:08:40', NULL, NULL, 9558, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:08:40', 'admin-1495854225-14958545201631251', 1, 0, '', NULL, NULL, '10.0'),
(31589, '2017-05-27 11:03:39', NULL, NULL, 9556, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:03:39', 'admin-1495853268-14958542196239897', 1, 1, 'SR', NULL, NULL, NULL),
(31590, '2017-05-27 11:03:39', NULL, NULL, 9556, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:03:39', 'admin-1495853268-14958542196239897', 1, 0, '', NULL, NULL, NULL),
(31591, '2017-05-27 11:03:39', NULL, NULL, 9556, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:03:39', 'admin-1495853268-14958542196239897', 1, 0, '', NULL, NULL, NULL),
(31592, '2017-05-27 11:00:39', NULL, NULL, 9555, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:00:39', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(31593, '2017-05-27 10:03:08', NULL, NULL, 9543, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:03:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31594, '2017-05-27 10:03:13', NULL, NULL, 9543, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:03:13', 'admin-1495850051-14958505930919082', 1, 1, 'SR', NULL, NULL, NULL),
(31595, '2017-05-27 10:47:41', NULL, NULL, 9547, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:47:41', 'admin-1495850051-1495853261741289', 1, 0, '', NULL, NULL, NULL),
(31596, '2017-05-27 10:45:53', NULL, NULL, 9549, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:45:53', 'admin-1495850051-149585315355483', 1, 0, '', NULL, NULL, NULL),
(31597, '2017-05-27 10:45:53', NULL, NULL, 9549, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:45:53', 'admin-1495850051-149585315355483', 1, 0, '', NULL, NULL, NULL),
(31598, '2017-05-27 10:42:27', NULL, NULL, 9548, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:42:27', 'admin-1495850051-14958529470261852', 1, 0, '', NULL, NULL, NULL),
(31599, '2017-05-27 10:20:37', NULL, NULL, 9546, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:20:37', 'admin-1495850051-14958516377753776', 1, 0, '', NULL, NULL, NULL),
(31600, '2017-05-27 11:33:02', NULL, NULL, 9564, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:33:02', 'admin-1495854225-14958559818589926', 1, 0, '', NULL, NULL, NULL),
(31601, '2017-05-27 10:42:27', NULL, NULL, 9548, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:42:27', 'admin-1495850051-14958529470261852', 1, 0, '', NULL, NULL, NULL),
(31602, '2017-05-27 10:42:06', NULL, NULL, 9548, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:42:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31603, '2017-05-27 10:27:57', NULL, NULL, 9533, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:27:57', 'admin-1495850051-14958520769214081', 1, 1, 'SR', NULL, NULL, NULL),
(31604, '2017-05-27 10:20:37', NULL, NULL, 9546, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:20:37', 'admin-1495850051-14958516377753776', 1, 1, 'SR', NULL, NULL, NULL),
(31605, '2017-05-27 10:20:37', NULL, NULL, 9546, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:20:37', 'admin-1495850051-14958516377753776', 1, 0, '', NULL, NULL, NULL),
(31606, '2017-05-27 10:20:37', NULL, NULL, 9546, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:20:37', 'admin-1495850051-14958516377753776', 1, 0, '', NULL, NULL, NULL),
(31607, '2017-05-27 10:20:18', NULL, NULL, 9546, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:20:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31608, '2017-05-27 10:17:53', NULL, NULL, 9545, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:17:53', 'admin-1495850051-14958514734428012', 1, 0, '', NULL, NULL, NULL),
(31609, '2017-05-27 10:17:53', NULL, NULL, 9545, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:17:53', 'admin-1495850051-14958514734428012', 1, 0, '', NULL, NULL, NULL),
(31610, '2017-05-27 10:17:53', NULL, NULL, 9545, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:17:53', 'admin-1495850051-14958514734428012', 1, 1, 'SR', NULL, NULL, NULL),
(31611, '2017-05-27 10:08:02', NULL, NULL, 9544, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:08:02', 'admin-1495850051-14958508819995427', 1, 1, 'SR', NULL, NULL, NULL),
(31612, '2017-05-27 10:08:02', NULL, NULL, 9544, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:08:02', 'admin-1495850051-14958508819995427', 1, 0, '', NULL, NULL, NULL),
(31613, '2017-05-27 10:02:19', NULL, NULL, 9542, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:02:19', 'admin-1495850051-1495850539422882', 1, 0, '', NULL, NULL, NULL),
(31614, '2017-05-27 10:02:19', NULL, NULL, 9542, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:02:19', 'admin-1495850051-1495850539422882', 1, 0, '', NULL, NULL, NULL),
(31615, '2017-05-27 10:02:25', NULL, NULL, 9542, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:02:25', 'admin-1495850051-14958505456852988', 1, 1, 'SR', NULL, NULL, NULL),
(31616, '2017-05-27 09:04:26', NULL, NULL, 9533, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:04:26', 'admin-1495846214-14958470661301065', 1, 1, 'SR', NULL, NULL, NULL),
(31617, '2017-05-27 13:22:43', NULL, NULL, 9576, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1495866377', 'admin', '2017-05-27 13:22:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31618, '2017-05-27 11:33:02', NULL, NULL, 9564, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:33:02', 'admin-1495854225-14958559818589926', 1, 1, 'SR', NULL, NULL, NULL),
(31619, '2017-05-27 10:55:03', NULL, NULL, 9553, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:55:03', 'admin-1495853268-14958537032892688', 1, 0, '', NULL, NULL, NULL),
(31620, '2017-05-27 09:56:54', NULL, NULL, 9541, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:56:54', 'admin-1495850051-14958502140059563', 1, 0, '', NULL, NULL, NULL),
(31621, '2017-05-27 09:56:54', NULL, NULL, 9541, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:56:54', 'admin-1495850051-14958502140059563', 1, 1, 'SR', NULL, NULL, NULL),
(31622, '2017-05-27 10:02:11', NULL, NULL, 9542, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:02:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31623, '2017-05-27 09:55:37', NULL, NULL, 9539, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:55:37', 'admin-1495850051-14958501369936439', 1, 0, '', NULL, NULL, NULL),
(31624, '2017-05-27 09:55:37', NULL, NULL, 9539, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:55:37', 'admin-1495850051-14958501369936439', 1, 0, '', NULL, NULL, NULL),
(31625, '2017-05-27 09:55:37', NULL, NULL, 9539, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:55:37', 'admin-1495850051-14958501369936439', 1, 1, 'SR', NULL, NULL, NULL),
(31626, '2017-05-27 09:55:37', NULL, NULL, 9539, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:55:37', 'admin-1495850051-14958501369936439', 1, 1, 'SR', NULL, NULL, NULL),
(31627, '2017-05-27 09:55:37', NULL, NULL, 9539, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:55:37', 'admin-1495850051-14958501369936439', 1, 0, '', NULL, NULL, NULL),
(31628, '2017-05-27 09:56:54', NULL, NULL, 9541, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:56:54', 'admin-1495850051-14958502140059563', 1, 1, 'SR', NULL, NULL, NULL),
(31629, '2017-05-27 09:56:54', NULL, NULL, 9541, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:56:54', 'admin-1495850051-14958502140059563', 1, 0, '', NULL, NULL, NULL),
(31630, '2017-05-27 09:56:35', NULL, NULL, 9540, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:56:35', 'admin-1495850051-14958501947486454', 1, 1, 'SR', NULL, NULL, NULL),
(31631, '2017-05-27 09:56:35', NULL, NULL, 9540, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:56:35', 'admin-1495850051-14958501947486454', 1, 1, 'SR', NULL, NULL, NULL),
(31632, '2017-05-27 10:07:53', NULL, NULL, 9544, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:07:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31633, '2017-05-27 10:02:25', NULL, NULL, 9542, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:02:25', 'admin-1495850051-14958505456852988', 1, 1, 'SR', NULL, NULL, NULL),
(31634, '2017-05-27 09:05:43', NULL, NULL, 9534, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:05:43', 'admin-1495846214-14958471435006056', 1, 0, '', NULL, NULL, NULL),
(31635, '2017-05-27 09:05:43', NULL, NULL, 9534, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:05:43', 'admin-1495846214-14958471435006056', 1, 0, '', NULL, NULL, NULL),
(31636, '2017-05-27 09:05:43', NULL, NULL, 9534, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:05:43', 'admin-1495846214-14958471435006056', 1, 0, '', NULL, NULL, NULL),
(31637, '2017-05-27 09:07:41', NULL, NULL, 9535, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.80, 0.0000, 0.0000, 10.80, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:07:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31638, '2017-05-27 09:09:15', NULL, NULL, 9535, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:09:15', 'admin-1495846214-14958473554363031', 1, 0, '', NULL, NULL, NULL),
(31639, '2017-05-27 09:09:15', NULL, NULL, 9535, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:09:15', 'admin-1495846214-14958473554363031', 1, 0, '', NULL, NULL, NULL),
(31640, '2017-05-27 09:09:15', NULL, NULL, 9535, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:09:15', 'admin-1495846214-14958473554363031', 1, 0, '', NULL, NULL, NULL),
(31641, '2017-05-27 09:09:15', NULL, NULL, 9535, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:09:15', 'admin-1495846214-14958473554363031', 1, 0, '', NULL, NULL, NULL),
(31642, '2017-05-27 09:09:32', NULL, NULL, 9535, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:09:32', 'admin-1495846214-14958473725784295', 1, 1, 'SR', NULL, NULL, NULL),
(31643, '2017-05-27 09:09:32', NULL, NULL, 9535, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:09:32', 'admin-1495846214-14958473725784295', 1, 1, 'SR', NULL, NULL, NULL),
(31644, '2017-05-27 09:09:32', NULL, NULL, 9535, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:09:32', 'admin-1495846214-14958473725784295', 1, 1, 'SR', NULL, NULL, NULL),
(31645, '2017-05-27 09:09:32', NULL, NULL, 9535, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:09:32', 'admin-1495846214-14958473725784295', 1, 1, 'SR', NULL, NULL, NULL),
(31646, '2017-05-27 09:09:32', NULL, NULL, 9535, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:09:32', 'admin-1495846214-14958473725784295', 1, 1, 'SR', NULL, NULL, NULL),
(31647, '2017-05-27 09:09:45', NULL, NULL, 9534, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:09:45', 'admin-1495846214-14958473850649517', 1, 0, '', NULL, NULL, NULL),
(31648, '2017-05-27 09:24:03', NULL, NULL, 9536, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:24:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31649, '2017-05-27 09:24:35', NULL, NULL, 9536, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:24:35', 'admin-1495846214-14958482754993988', 1, 0, '', NULL, NULL, NULL),
(31650, '2017-05-27 09:24:35', NULL, NULL, 9536, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:24:35', 'admin-1495846214-14958482754993988', 1, 0, '', NULL, NULL, NULL),
(31651, '2017-05-27 09:24:35', NULL, NULL, 9536, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:24:35', 'admin-1495846214-14958482754993988', 1, 1, 'SR', NULL, NULL, NULL),
(31652, '2017-05-27 09:24:35', NULL, NULL, 9536, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:24:35', 'admin-1495846214-14958482754993988', 1, 1, 'SR', NULL, NULL, NULL),
(31653, '2017-05-27 09:25:05', NULL, NULL, 9537, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:25:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31654, '2017-05-27 09:25:40', NULL, NULL, 9537, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:25:40', 'admin-1495846214-1495848340022682', 1, 0, '', NULL, NULL, NULL),
(31655, '2017-05-27 09:25:40', NULL, NULL, 9537, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:25:40', 'admin-1495846214-1495848340022682', 1, 0, '', NULL, NULL, NULL),
(31656, '2017-05-27 09:25:40', NULL, NULL, 9537, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:25:40', 'admin-1495846214-1495848340022682', 1, 0, '', NULL, NULL, NULL),
(31657, '2017-05-27 09:25:40', NULL, NULL, 9537, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:25:40', 'admin-1495846214-1495848340022682', 1, 0, '', NULL, NULL, NULL),
(31658, '2017-05-27 09:25:40', NULL, NULL, 9537, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:25:40', 'admin-1495846214-1495848340022682', 1, 1, 'SR', NULL, NULL, NULL),
(31659, '2017-05-27 09:28:44', NULL, NULL, 9537, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:28:44', 'admin-1495846214-14958485240924862', 1, 0, '', NULL, NULL, NULL),
(31660, '2017-05-27 11:38:32', NULL, NULL, 9561, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 11:38:32', 'admin-1495854225-14958563125973794', 1, 0, '', NULL, NULL, NULL),
(31661, '2017-05-27 10:02:19', NULL, NULL, 9542, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 10:02:19', 'admin-1495850051-1495850539422882', 1, 0, '', NULL, NULL, NULL),
(31662, '2017-05-27 09:56:22', NULL, NULL, 9540, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:56:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31663, '2017-05-27 09:56:34', NULL, NULL, 9540, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:56:34', 'admin-1495850051-14958501947486454', 1, 0, '', NULL, NULL, NULL),
(31664, '2017-05-27 09:56:34', NULL, NULL, 9540, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:56:35', 'admin-1495850051-14958501947486454', 1, 0, '', NULL, NULL, NULL),
(31665, '2017-05-27 09:55:37', NULL, NULL, 9539, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:55:37', 'admin-1495850051-14958501369936439', 1, 1, 'SR', NULL, NULL, NULL),
(31666, '2017-05-27 09:55:37', NULL, NULL, 9539, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:55:37', 'admin-1495850051-14958501369936439', 1, 0, '', NULL, NULL, NULL),
(31667, '2017-05-27 09:55:37', NULL, NULL, 9539, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:55:37', 'admin-1495850051-14958501369936439', 1, 0, '', NULL, NULL, NULL),
(31668, '2017-05-27 09:46:40', NULL, NULL, 9538, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:46:40', 'admin-1495846214-14958496001333855', 1, 0, '', NULL, NULL, NULL),
(31669, '2017-05-27 09:46:40', NULL, NULL, 9538, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:46:40', 'admin-1495846214-14958496001333855', 1, 0, '', NULL, NULL, NULL),
(31670, '2017-05-27 09:46:40', NULL, NULL, 9538, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:46:40', 'admin-1495846214-14958496001333855', 1, 0, '', NULL, NULL, NULL),
(31671, '2017-05-27 09:46:40', NULL, NULL, 9538, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:46:40', 'admin-1495846214-14958496001333855', 1, 0, '', NULL, NULL, NULL),
(31672, '2017-05-27 09:46:40', NULL, NULL, 9538, 0, 155, '89', 'Cheesy Chicken Gratin', 'egg welldone', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:46:40', 'admin-1495846214-14958496001333855', 1, 0, '', NULL, NULL, NULL),
(31673, '2017-05-27 09:47:24', NULL, NULL, 9538, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:47:24', 'admin-1495849608-1495849643952236', 1, 1, 'SR', NULL, NULL, NULL),
(31674, '2017-05-27 09:46:08', NULL, NULL, 9538, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.50, 0.0000, 0.0000, 13.50, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:46:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31675, '2017-05-27 09:05:27', NULL, NULL, 9534, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:05:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31676, '2017-05-27 09:04:26', NULL, NULL, 9533, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:04:26', 'admin-1495846214-14958470661301065', 1, 1, 'SR', NULL, NULL, NULL),
(31677, '2017-05-27 09:04:21', NULL, NULL, 9533, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1495866377', 'admin', '2017-05-27 09:04:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31678, '2017-05-27 14:51:05', NULL, NULL, 9584, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:51:05', 'admin-1495866377-14958678652478768', 1, 1, 'SR', NULL, NULL, NULL),
(31679, '2017-05-27 14:51:05', NULL, NULL, 9584, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:51:05', 'admin-1495866377-14958678652478768', 1, 0, '', NULL, NULL, NULL),
(31680, '2017-05-27 14:59:04', NULL, NULL, 9578, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 14:59:04', 'admin-1495866377-1495868344382362', 1, 1, 'SR', NULL, NULL, NULL),
(31681, '2017-05-27 15:24:32', NULL, NULL, 9585, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1495866377', 'admin', '2017-05-27 15:24:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31682, '2017-05-27 15:24:58', NULL, NULL, 9585, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 15:24:58', 'admin-1495866377-1495869897896230', 1, 0, '', NULL, NULL, NULL),
(31683, '2017-05-27 15:26:41', NULL, NULL, 9585, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 15:26:41', 'admin-1495866377-14958700016172089', 1, 0, '', NULL, NULL, NULL),
(31684, '2017-05-27 15:26:41', NULL, NULL, 9585, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 15:26:41', 'admin-1495866377-14958700016172089', 1, 1, 'SR', NULL, NULL, NULL),
(31685, '2017-05-27 15:26:41', NULL, NULL, 9585, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 15:26:41', 'admin-1495866377-14958700016172089', 1, 1, 'SR', NULL, NULL, NULL),
(31686, '2017-05-27 15:26:41', NULL, NULL, 9585, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 15:26:41', 'admin-1495866377-14958700016172089', 1, 0, '', NULL, NULL, NULL),
(31687, '2017-05-27 16:02:01', NULL, NULL, 9586, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1495866377', 'admin', '2017-05-27 16:02:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31688, '2017-05-27 16:02:06', NULL, NULL, 9586, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 16:02:06', 'admin-1495866377-1495872126072439', 1, 0, '', NULL, NULL, NULL),
(31689, '2017-05-27 16:02:16', NULL, NULL, 9586, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 16:02:16', 'admin-1495866377-14958721361602099', 1, 0, '', NULL, NULL, NULL),
(31690, '2017-05-27 16:05:44', NULL, NULL, 9578, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 16:05:44', 'admin-1495866377-14958723442661574', 1, 0, '', NULL, NULL, NULL),
(31691, '2017-05-27 16:05:44', NULL, NULL, 9578, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 16:05:44', 'admin-1495866377-14958723442661574', 1, 0, '', NULL, NULL, NULL),
(31692, '2017-05-27 16:05:44', NULL, NULL, 9578, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 16:05:44', 'admin-1495866377-14958723442661574', 1, 0, '', NULL, NULL, NULL),
(31693, '2017-05-27 16:16:56', NULL, NULL, 9585, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 16:16:56', 'admin-1495866377-14958730158167247', 1, 0, '', NULL, NULL, NULL),
(31694, '2017-05-27 17:25:28', NULL, NULL, 9587, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1495866377', 'admin', '2017-05-27 17:25:28', '0', 1, 1, 'SR', NULL, '0.0', NULL),
(31695, '2017-05-27 17:25:32', NULL, NULL, 9587, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 17:25:32', 'admin-1495866377-149587713276996', 1, 0, '', NULL, NULL, NULL),
(31696, '2017-05-27 17:26:16', NULL, NULL, 9587, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 17:26:16', 'admin-1495866377-14958771764691320', 1, 1, 'SR', NULL, NULL, NULL),
(31697, '2017-05-27 17:26:16', NULL, NULL, 9587, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 17:26:16', 'admin-1495866377-14958771764691320', 1, 1, 'SR', NULL, NULL, NULL),
(31698, '2017-05-27 17:31:21', NULL, NULL, 9588, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1495866377', 'admin', '2017-05-27 17:31:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31699, '2017-05-27 17:31:33', NULL, NULL, 9588, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 17:31:33', 'admin-1495866377-14958774936093897', 1, 0, '', NULL, NULL, NULL),
(31700, '2017-05-27 17:31:33', NULL, NULL, 9588, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 17:31:33', 'admin-1495866377-14958774936093897', 1, 0, '', NULL, NULL, NULL),
(31701, '2017-05-27 17:31:38', NULL, NULL, 9588, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 17:31:38', 'admin-1495866377-14958774986966475', 1, 1, 'SR', NULL, NULL, NULL),
(31702, '2017-05-27 17:59:02', NULL, NULL, 9589, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 17:59:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31703, '2017-05-27 17:59:07', NULL, NULL, 9589, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 17:59:07', 'admin-1495866377-14958791468358425', 1, 1, 'SR', NULL, NULL, NULL),
(31704, '2017-05-27 17:59:07', NULL, NULL, 9589, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495866377', 'admin', '2017-05-27 17:59:07', 'admin-1495866377-14958791468358425', 1, 1, 'SR', NULL, NULL, NULL),
(31705, '2017-05-28 14:41:40', NULL, NULL, 9633, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:41:40', 'admin-1495946282-14959537003607029', 1, 1, 'SR', NULL, NULL, NULL),
(31706, '2017-05-28 14:42:26', NULL, NULL, 9626, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:42:26', 'admin-1495946282-14959537465176410', 1, 1, 'SR', NULL, NULL, NULL),
(31707, '2017-05-28 14:42:26', NULL, NULL, 9626, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:42:26', 'admin-1495946282-14959537465176410', 1, 1, 'SR', NULL, NULL, NULL),
(31708, '2017-05-28 12:27:52', NULL, NULL, 9618, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:27:52', 'admin-1495945072-14959456719184478', 1, 0, '', NULL, NULL, NULL),
(31709, '2017-05-28 11:39:11', NULL, NULL, 9611, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:39:11', 'admin-1495942548-1495942751136664', 1, 1, 'SR', NULL, NULL, NULL),
(31710, '2017-05-28 11:39:57', NULL, NULL, 9607, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:39:57', 'admin-1495942548-1495942797205717', 1, 1, 'SR', NULL, NULL, NULL),
(31711, '2017-05-28 11:42:38', NULL, NULL, 9612, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:42:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31712, '2017-05-28 11:42:44', NULL, NULL, 9612, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:42:44', 'admin-1495942548-14959429642865356', 1, 0, '', NULL, NULL, NULL),
(31713, '2017-05-28 11:42:44', NULL, NULL, 9612, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:42:44', 'admin-1495942548-14959429642865356', 1, 1, 'SR', NULL, NULL, NULL),
(31714, '2017-05-28 11:37:11', NULL, NULL, 9610, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:37:11', 'admin-1495942548-14959426310077576', 1, 0, '', NULL, NULL, NULL),
(31715, '2017-05-28 11:37:11', NULL, NULL, 9610, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:37:11', 'admin-1495942548-14959426310077576', 1, 1, 'SR', NULL, NULL, NULL),
(31716, '2017-05-28 12:57:26', NULL, NULL, 9620, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:57:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31717, '2017-05-28 12:57:47', NULL, NULL, 9620, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:57:47', 'admin-1495946282-14959474674509634', 1, 1, 'SR', NULL, NULL, NULL),
(31718, '2017-05-28 12:57:47', NULL, NULL, 9620, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:57:47', 'admin-1495946282-14959474674509634', 1, 0, '', NULL, NULL, NULL),
(31719, '2017-05-28 12:35:51', NULL, NULL, 9601, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:35:51', 'admin-1495945072-1495946150855489', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(31720, '2017-05-28 12:38:20', NULL, NULL, 9613, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:38:20', 'admin-1495946282-14959463001043067', 1, 0, '', NULL, NULL, NULL),
(31721, '2017-05-28 14:41:40', NULL, NULL, 9633, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:41:40', 'admin-1495946282-14959537003607029', 1, 1, 'SR', NULL, NULL, NULL),
(31722, '2017-05-28 13:09:32', NULL, NULL, 9618, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:09:32', 'admin-1495946282-14959481727305480', 1, 0, '', NULL, NULL, NULL),
(31723, '2017-05-28 13:12:16', NULL, NULL, 9621, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:12:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31724, '2017-05-28 13:17:11', NULL, NULL, 9621, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:17:11', 'admin-1495946282-14959486313802490', 1, 0, '', NULL, NULL, NULL),
(31725, '2017-05-28 13:20:39', NULL, NULL, 9622, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:20:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31726, '2017-05-28 13:21:06', NULL, NULL, 9622, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:21:06', 'admin-1495946282-14959488659509119', 1, 0, '', NULL, NULL, NULL),
(31727, '2017-05-28 13:21:06', NULL, NULL, 9622, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:21:06', 'admin-1495946282-14959488659509119', 1, 1, 'SR', NULL, NULL, NULL),
(31728, '2017-05-28 13:21:11', NULL, NULL, 9623, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:21:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31729, '2017-05-28 13:22:14', NULL, NULL, 9623, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:22:14', 'admin-1495946282-14959489344099567', 1, 0, '', NULL, NULL, NULL),
(31730, '2017-05-28 13:22:14', NULL, NULL, 9623, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:22:14', 'admin-1495946282-14959489344099567', 1, 1, 'SR', NULL, NULL, NULL),
(31731, '2017-05-28 13:22:14', NULL, NULL, 9623, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:22:14', 'admin-1495946282-14959489344099567', 1, 1, 'SR', NULL, NULL, NULL),
(31732, '2017-05-28 14:41:23', NULL, NULL, 9633, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:41:23', 'admin-1495946282-14959536829385347', 1, 0, '', NULL, NULL, NULL),
(31733, '2017-05-28 16:07:44', NULL, NULL, 9645, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 16:07:44', 'admin-1495946282-14959588641594236', 1, 0, '', NULL, NULL, NULL),
(31734, '2017-05-28 12:16:57', NULL, NULL, 9616, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:16:57', 'admin-1495942548-14959450173617522', 1, 1, 'SR', NULL, NULL, NULL),
(31735, '2017-05-28 12:16:57', NULL, NULL, 9616, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:16:57', 'admin-1495942548-14959450173617522', 1, 0, '', NULL, NULL, NULL),
(31736, '2017-05-28 12:22:15', NULL, NULL, 9601, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:22:15', 'admin-1495945072-14959453356553421', 1, 1, 'SR', NULL, NULL, NULL),
(31737, '2017-05-28 12:24:18', NULL, NULL, 9617, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:24:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31738, '2017-05-28 12:24:46', NULL, NULL, 9617, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:24:46', 'admin-1495945072-14959454858995488', 1, 0, '', NULL, NULL, NULL),
(31739, '2017-05-28 12:24:46', NULL, NULL, 9617, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:24:46', 'admin-1495945072-14959454858995488', 1, 1, 'SR', NULL, NULL, NULL),
(31740, '2017-05-28 12:24:46', NULL, NULL, 9617, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:24:46', 'admin-1495945072-14959454858995488', 1, 1, 'SR', NULL, NULL, NULL),
(31741, '2017-05-28 12:27:40', NULL, NULL, 9618, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:27:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31742, '2017-05-28 12:27:52', NULL, NULL, 9618, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:27:52', 'admin-1495945072-14959456719184478', 1, 1, 'SR', NULL, NULL, NULL),
(31743, '2017-05-28 13:25:36', NULL, NULL, 9623, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:25:36', 'admin-1495946282-1495949136339466', 1, 1, 'SR', NULL, NULL, NULL),
(31744, '2017-05-28 13:25:36', NULL, NULL, 9623, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:25:36', 'admin-1495946282-1495949136339466', 1, 0, '', NULL, NULL, NULL),
(31745, '2017-05-28 13:36:46', NULL, NULL, 9626, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:36:46', 'admin-1495946282-1495949806596738', 1, 1, 'SR', NULL, NULL, NULL),
(31746, '2017-05-28 13:36:28', NULL, NULL, 9626, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:36:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31747, '2017-05-28 13:36:46', NULL, NULL, 9626, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:36:46', 'admin-1495946282-1495949806596738', 1, 1, 'SR', NULL, NULL, NULL),
(31748, '2017-05-28 11:11:01', NULL, NULL, 9604, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:11:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31749, '2017-05-28 11:08:32', NULL, NULL, 9603, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:08:32', 'admin-1495938775-14959409119506351', 1, 0, '', 1, NULL, NULL),
(31750, '2017-05-28 11:10:59', NULL, NULL, 9602, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:10:59', 'admin-1495938775-14959410594711135', 1, 1, 'SR', NULL, NULL, NULL),
(31751, '2017-05-28 11:10:59', NULL, NULL, 9602, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:10:59', 'admin-1495938775-14959410594711135', 1, 1, 'SR', NULL, NULL, NULL),
(31752, '2017-05-28 11:11:06', NULL, NULL, 9604, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:11:06', 'admin-1495938775-14959410664754241', 1, 0, '', NULL, NULL, NULL),
(31753, '2017-05-28 15:55:23', NULL, NULL, 9639, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:55:23', 'admin-1495946282-14959581230773227', 1, 0, '', NULL, NULL, NULL),
(31754, '2017-05-28 16:00:20', NULL, NULL, 9645, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1495946282', 'admin', '2017-05-28 16:00:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31755, '2017-05-28 16:00:44', NULL, NULL, 9645, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 16:00:44', 'admin-1495946282-14959584442955697', 1, 1, 'SR', NULL, NULL, NULL),
(31756, '2017-05-28 16:00:44', NULL, NULL, 9645, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 16:00:44', 'admin-1495946282-14959584442955697', 1, 1, 'SR', NULL, NULL, NULL),
(31757, '2017-05-28 11:47:15', NULL, NULL, 9613, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:47:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31758, '2017-05-28 11:49:50', NULL, NULL, 9613, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:49:50', 'admin-1495942548-14959433901006673', 1, 1, 'SR', NULL, NULL, NULL),
(31759, '2017-05-28 11:49:50', NULL, NULL, 9613, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:49:50', 'admin-1495942548-14959433901006673', 1, 0, '', NULL, NULL, NULL),
(31760, '2017-05-28 11:50:22', NULL, NULL, 9613, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:50:22', 'admin-1495942548-14959434226738457', 1, 1, 'SR', NULL, NULL, NULL),
(31761, '2017-05-28 11:24:16', NULL, NULL, 9607, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:24:16', 'admin-1495941091-14959418562359422', 1, 0, '', NULL, NULL, NULL),
(31762, '2017-05-28 10:39:58', NULL, NULL, 9598, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:39:58', 'admin-1495938775-14959391977454532', 1, 0, '', NULL, NULL, NULL),
(31763, '2017-05-28 10:40:11', NULL, NULL, 9598, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:40:11', 'admin-1495938775-14959392109003082', 1, 1, 'SR', NULL, NULL, NULL),
(31764, '2017-05-28 10:42:35', NULL, NULL, 9599, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:42:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31765, '2017-05-28 10:42:45', NULL, NULL, 9599, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:42:45', 'admin-1495938775-14959393656123475', 1, 0, '', NULL, NULL, NULL),
(31766, '2017-05-28 10:42:45', NULL, NULL, 9599, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:42:45', 'admin-1495938775-14959393656123475', 1, 0, '', NULL, NULL, NULL),
(31767, '2017-05-28 15:30:33', NULL, NULL, 9641, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:30:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31768, '2017-05-28 11:22:36', NULL, NULL, 9606, 0, 153, '87', 'Wake Me Up!', 'no baked beans', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:22:36', 'admin-1495941091-1495941756626739', 1, 0, '', NULL, NULL, NULL),
(31769, '2017-05-28 11:22:36', NULL, NULL, 9606, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:22:36', 'admin-1495941091-1495941756626739', 1, 0, '', NULL, NULL, NULL),
(31770, '2017-05-28 14:50:05', NULL, NULL, 9635, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:50:05', 'admin-1495946282-14959542054907760', 1, 1, 'SR', NULL, NULL, NULL),
(31771, '2017-05-28 14:50:05', NULL, NULL, 9635, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:50:05', 'admin-1495946282-14959542054907760', 1, 0, '', NULL, NULL, NULL),
(31772, '2017-05-28 14:50:05', NULL, NULL, 9635, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:50:05', 'admin-1495946282-14959542054907760', 1, 1, 'SR', NULL, NULL, NULL),
(31773, '2017-05-28 14:50:18', NULL, NULL, 9636, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:50:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31774, '2017-05-28 14:50:47', NULL, NULL, 9636, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:50:47', 'admin-1495946282-14959542477507411', 1, 0, '', NULL, NULL, NULL),
(31775, '2017-05-28 14:50:47', NULL, NULL, 9636, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:50:47', 'admin-1495946282-14959542477507411', 1, 1, 'SR', NULL, NULL, NULL),
(31776, '2017-05-28 15:48:41', NULL, NULL, 9644, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:48:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31777, '2017-05-28 15:38:06', NULL, NULL, 9642, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:38:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31778, '2017-05-28 15:38:16', NULL, NULL, 9642, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:38:16', 'admin-1495946282-14959570962182842', 1, 1, 'SR', NULL, NULL, NULL),
(31779, '2017-05-28 15:00:48', NULL, NULL, 9637, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:00:48', 'admin-1495946282-14959548485351436', 1, 1, 'SR', NULL, NULL, NULL),
(31780, '2017-05-28 15:03:08', NULL, NULL, 9633, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:03:08', 'admin-1495946282-14959549878743916', 1, 0, '', NULL, NULL, NULL),
(31781, '2017-05-28 14:41:23', NULL, NULL, 9633, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:41:23', 'admin-1495946282-14959536829385347', 1, 0, '', NULL, NULL, NULL),
(31782, '2017-05-28 11:50:36', NULL, NULL, 9614, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:50:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31783, '2017-05-28 11:50:46', NULL, NULL, 9614, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:50:46', 'admin-1495942548-14959434462119566', 1, 0, '', NULL, NULL, NULL),
(31784, '2017-05-28 15:04:31', NULL, NULL, 9638, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:04:31', 'admin-1495946282-14959550708835768', 1, 1, 'SR', NULL, NULL, NULL),
(31785, '2017-05-28 15:04:31', NULL, NULL, 9638, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:04:31', 'admin-1495946282-14959550708835768', 1, 1, 'SR', NULL, NULL, NULL),
(31786, '2017-05-28 13:43:36', NULL, NULL, 9627, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:43:36', 'admin-1495946282-14959502165734161', 1, 0, '', NULL, NULL, NULL),
(31787, '2017-05-28 13:43:36', NULL, NULL, 9627, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:43:36', 'admin-1495946282-14959502165734161', 1, 1, 'SR', NULL, NULL, NULL),
(31788, '2017-05-28 14:24:56', NULL, NULL, 9632, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:24:56', 'admin-1495946282-1495952696051686', 1, 1, 'SR', NULL, NULL, NULL),
(31789, '2017-05-28 14:24:34', NULL, NULL, 9632, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:24:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31790, '2017-05-28 13:48:35', NULL, NULL, 9629, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:48:35', 'admin-1495946282-14959505155058043', 1, 1, 'SR', 1, NULL, NULL),
(31791, '2017-05-28 14:17:47', NULL, NULL, 9630, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:17:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31792, '2017-05-28 14:18:00', NULL, NULL, 9630, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:18:00', 'admin-1495946282-14959522798888941', 1, 0, '', NULL, NULL, NULL),
(31793, '2017-05-28 14:18:00', NULL, NULL, 9630, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:18:00', 'admin-1495946282-14959522798888941', 1, 0, '', NULL, NULL, NULL),
(31794, '2017-05-28 15:29:29', NULL, NULL, 9640, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:29:29', 'admin-1495946282-14959565694089280', 1, 0, '', NULL, NULL, NULL),
(31795, '2017-05-28 16:07:44', NULL, NULL, 9645, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 16:07:44', 'admin-1495946282-14959588641594236', 1, 1, 'SR', NULL, NULL, NULL),
(31796, '2017-05-28 15:52:33', NULL, NULL, 9639, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:52:33', 'admin-1495946282-14959579531619918', 1, 1, 'SR', NULL, NULL, NULL),
(31797, '2017-05-28 15:52:33', NULL, NULL, 9639, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:52:33', 'admin-1495946282-14959579531619918', 1, 1, 'SR', NULL, NULL, NULL),
(31798, '2017-05-28 00:00:00', NULL, NULL, 9644, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:28:42', 'admin-1495946282-14959565218933584', 1, 0, '', NULL, NULL, NULL),
(31799, '2017-05-28 15:38:16', NULL, NULL, 9642, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:38:16', 'admin-1495946282-14959570962182842', 1, 1, 'SR', NULL, NULL, NULL),
(31800, '2017-05-28 14:43:58', NULL, NULL, 9633, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:43:58', 'admin-1495946282-14959538379859026', 1, 0, '', NULL, NULL, NULL),
(31801, '2017-05-28 00:00:00', NULL, NULL, 9643, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:28:42', 'admin-1495946282-14959565218933584', 1, 0, '', NULL, NULL, NULL),
(31802, '2017-05-28 15:14:09', NULL, NULL, 9633, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:14:09', 'admin-1495946282-14959556489708097', 1, 0, '', NULL, NULL, NULL),
(31803, '2017-05-28 15:28:32', NULL, NULL, 9639, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:28:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31804, '2017-05-28 14:56:46', NULL, NULL, 9637, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:56:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31805, '2017-05-28 14:57:05', NULL, NULL, 9637, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:57:05', 'admin-1495946282-14959546254668164', 1, 1, 'SR', NULL, NULL, NULL),
(31806, '2017-05-28 14:41:23', NULL, NULL, 9633, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:41:23', 'admin-1495946282-14959536829385347', 1, 1, 'SR', NULL, NULL, NULL),
(31807, '2017-05-28 14:21:29', NULL, NULL, 9631, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:21:29', 'admin-1495946282-14959524888928494', 1, 1, 'SR', NULL, NULL, NULL),
(31808, '2017-05-28 14:25:25', NULL, NULL, 9632, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:25:25', 'admin-1495946282-14959527248921993', 1, 1, 'SR', NULL, NULL, NULL),
(31809, '2017-05-28 14:25:25', NULL, NULL, 9632, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:25:25', 'admin-1495946282-14959527248921993', 1, 0, '', NULL, NULL, NULL),
(31810, '2017-05-28 14:21:29', NULL, NULL, 9631, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:21:29', 'admin-1495946282-14959524888928494', 1, 1, 'SR', NULL, NULL, NULL),
(31811, '2017-05-28 15:31:18', NULL, NULL, 9641, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:31:18', 'admin-1495946282-14959566781937517', 1, 1, 'SR', NULL, NULL, NULL),
(31812, '2017-05-28 15:31:18', NULL, NULL, 9641, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:31:18', 'admin-1495946282-14959566781937517', 1, 0, '', NULL, NULL, NULL),
(31813, '2017-05-28 12:03:48', NULL, NULL, 9615, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:03:48', 'admin-1495942548-14959442282251888', 1, 0, '', NULL, NULL, NULL),
(31814, '2017-05-28 12:08:48', NULL, NULL, 9601, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:08:48', 'admin-1495942548-14959445285232410', 1, 0, '', NULL, NULL, NULL),
(31815, '2017-05-28 15:31:18', NULL, NULL, 9641, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:31:18', 'admin-1495946282-14959566781937517', 1, 1, 'SR', NULL, NULL, NULL),
(31816, '2017-05-28 00:00:00', NULL, NULL, 9644, 0, 244, '178', 'Macadamia Scones', '', 'Desserts', '0', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:33:19', 'admin-1495946282-14959567989644925', 1, 0, '', NULL, NULL, NULL),
(31817, '2017-05-28 15:29:18', NULL, NULL, 9640, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:29:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31818, '2017-05-28 15:47:55', NULL, NULL, 9643, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.30, 0.0000, 0.0000, 0.30, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:47:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31819, '2017-05-28 15:14:09', NULL, NULL, 9633, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:14:09', 'admin-1495946282-14959556489708097', 1, 1, 'SR', NULL, NULL, NULL),
(31820, '2017-05-28 15:07:27', NULL, NULL, 9626, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:07:27', 'admin-1495946282-14959552469898595', 1, 0, '', NULL, NULL, NULL),
(31821, '2017-05-28 15:05:33', NULL, NULL, 9637, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:05:33', 'admin-1495946282-14959551331167370', 1, 0, '', NULL, NULL, NULL),
(31822, '2017-05-28 15:05:21', NULL, NULL, 9633, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:05:21', 'admin-1495946282-1495955121253529', 1, 1, 'SR', NULL, NULL, NULL),
(31823, '2017-05-28 15:04:31', NULL, NULL, 9638, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:04:31', 'admin-1495946282-14959550708835768', 1, 0, '', NULL, NULL, NULL),
(31824, '2017-05-28 15:04:31', NULL, NULL, 9638, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:04:31', 'admin-1495946282-14959550708835768', 1, 0, '', NULL, NULL, NULL),
(31825, '2017-05-28 15:03:08', NULL, NULL, 9633, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:03:08', 'admin-1495946282-14959549878743916', 1, 1, 'SR', NULL, NULL, NULL),
(31826, '2017-05-28 15:03:46', NULL, NULL, 9638, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:03:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31827, '2017-05-28 11:14:55', NULL, NULL, 9605, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:14:55', 'admin-1495941091-14959412955089680', 1, 1, 'SR', NULL, NULL, NULL),
(31828, '2017-05-28 11:14:55', NULL, NULL, 9605, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:14:55', 'admin-1495941091-14959412955089680', 1, 1, 'SR', NULL, NULL, NULL),
(31829, '2017-05-28 14:57:05', NULL, NULL, 9637, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:57:05', 'admin-1495946282-14959546254668164', 1, 0, '', NULL, NULL, NULL),
(31830, '2017-05-28 14:47:01', NULL, NULL, 9634, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:47:01', 'admin-1495946282-14959540215172171', 1, 1, 'SR', 1, NULL, NULL),
(31831, '2017-05-28 14:47:19', NULL, NULL, 9634, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:47:19', 'admin-1495946282-14959540396112233', 1, 1, 'SR', 1, NULL, NULL),
(31832, '2017-05-28 14:48:06', NULL, NULL, 9635, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:48:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31833, '2017-05-28 14:50:05', NULL, NULL, 9635, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:50:05', 'admin-1495946282-14959542054907760', 1, 0, '', NULL, NULL, NULL),
(31834, '2017-05-28 14:50:05', NULL, NULL, 9635, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:50:05', 'admin-1495946282-14959542054907760', 1, 0, '', NULL, NULL, NULL),
(31835, '2017-05-28 14:50:05', NULL, NULL, 9635, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:50:05', 'admin-1495946282-14959542054907760', 1, 0, '', NULL, NULL, NULL),
(31836, '2017-05-28 12:40:55', NULL, NULL, 9601, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:40:55', 'admin-1495946282-14959464549658183', 1, 1, 'SR', NULL, NULL, NULL),
(31837, '2017-05-28 14:41:40', NULL, NULL, 9633, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:41:40', 'admin-1495946282-14959537003607029', 1, 1, 'SR', NULL, NULL, NULL),
(31838, '2017-05-28 14:41:23', NULL, NULL, 9633, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:41:23', 'admin-1495946282-14959536829385347', 1, 0, '', NULL, NULL, NULL),
(31839, '2017-05-28 14:41:23', NULL, NULL, 9633, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:41:23', 'admin-1495946282-14959536829385347', 1, 1, 'SR', NULL, NULL, NULL),
(31840, '2017-05-28 14:40:30', NULL, NULL, 9633, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.90, 0.0000, 0.0000, 16.90, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:40:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31841, '2017-05-28 13:43:01', NULL, NULL, 9627, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:43:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31842, '2017-05-28 13:43:36', NULL, NULL, 9627, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:43:36', 'admin-1495946282-14959502165734161', 1, 0, '', NULL, NULL, NULL),
(31843, '2017-05-28 15:31:18', NULL, NULL, 9641, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 15:31:18', 'admin-1495946282-14959566781937517', 1, 1, 'SR', NULL, NULL, NULL),
(31844, '2017-05-28 14:21:12', NULL, NULL, 9631, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1495946282', 'admin', '2017-05-28 14:21:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31845, '2017-05-28 13:22:34', NULL, NULL, 9624, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:22:34', 'admin-1495946282-14959489546121360', 1, 1, 'SR', NULL, NULL, NULL),
(31846, '2017-05-28 13:22:18', NULL, NULL, 9624, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:22:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31847, '2017-05-28 13:22:23', NULL, NULL, 9624, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 13:22:23', 'admin-1495946282-14959489425459121', 1, 1, 'SR', NULL, NULL, NULL),
(31848, '2017-05-28 11:36:20', NULL, NULL, 9610, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:36:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31849, '2017-05-28 11:37:11', NULL, NULL, 9610, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:37:11', 'admin-1495942548-14959426310077576', 1, 1, 'SR', NULL, NULL, NULL),
(31850, '2017-05-28 12:57:47', NULL, NULL, 9620, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:57:47', 'admin-1495946282-14959474674509634', 1, 0, '', NULL, NULL, NULL),
(31851, '2017-05-28 12:57:47', NULL, NULL, 9620, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:57:47', 'admin-1495946282-14959474674509634', 1, 1, 'SR', NULL, NULL, NULL),
(31852, '2017-05-28 12:27:52', NULL, NULL, 9618, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:27:52', 'admin-1495945072-14959456719184478', 1, 1, 'SR', NULL, NULL, NULL),
(31853, '2017-05-28 12:27:52', NULL, NULL, 9618, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:27:52', 'admin-1495945072-14959456719184478', 1, 0, '', NULL, NULL, NULL),
(31854, '2017-05-28 12:16:57', NULL, NULL, 9616, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:16:57', 'admin-1495942548-14959450173617522', 1, 0, '', NULL, NULL, NULL),
(31855, '2017-05-28 10:32:28', NULL, NULL, 9596, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:32:28', 'admin-1495933254-14959387480143439', 1, 0, '', NULL, NULL, NULL),
(31856, '2017-05-28 11:08:03', NULL, NULL, 9602, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:08:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31857, '2017-05-28 12:16:57', NULL, NULL, 9616, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:16:57', 'admin-1495942548-14959450173617522', 1, 0, '', NULL, NULL, NULL),
(31858, '2017-05-28 12:16:26', NULL, NULL, 9616, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:16:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31859, '2017-05-28 12:03:36', NULL, NULL, 9615, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:03:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31860, '2017-05-28 12:03:48', NULL, NULL, 9615, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:03:48', 'admin-1495942548-14959442282251888', 1, 1, 'SR', NULL, NULL, NULL),
(31861, '2017-05-28 12:08:48', NULL, NULL, 9601, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 12:08:48', 'admin-1495942548-14959445285232410', 1, 0, '', NULL, NULL, NULL),
(31862, '2017-05-28 11:37:11', NULL, NULL, 9610, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:37:11', 'admin-1495942548-14959426310077576', 1, 0, '', NULL, NULL, NULL),
(31863, '2017-05-28 11:11:06', NULL, NULL, 9604, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:11:06', 'admin-1495938775-14959410664754241', 1, 1, 'SR', NULL, NULL, NULL),
(31864, '2017-05-28 11:14:34', NULL, NULL, 9605, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:14:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31865, '2017-05-28 11:14:55', NULL, NULL, 9605, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:14:55', 'admin-1495941091-14959412955089680', 1, 1, 'SR', NULL, NULL, NULL),
(31866, '2017-05-28 11:50:22', NULL, NULL, 9613, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:50:22', 'admin-1495942548-14959434226738457', 1, 1, 'SR', NULL, NULL, NULL),
(31867, '2017-05-28 11:51:22', NULL, NULL, 9614, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:51:22', 'admin-1495942548-1495943482614753', 1, 1, 'SR', NULL, NULL, NULL),
(31868, '2017-05-28 11:50:46', NULL, NULL, 9614, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:50:46', 'admin-1495942548-14959434462119566', 1, 1, 'SR', NULL, NULL, NULL),
(31869, '2017-05-28 11:51:22', NULL, NULL, 9614, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:51:22', 'admin-1495942548-1495943482614753', 1, 1, 'SR', NULL, NULL, NULL),
(31870, '2017-05-28 11:39:11', NULL, NULL, 9611, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:39:11', 'admin-1495942548-1495942751136664', 1, 0, '', NULL, NULL, NULL),
(31871, '2017-05-28 11:37:54', NULL, NULL, 9611, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:37:54', 'admin-1495942548-14959426745285559', 1, 0, '', NULL, NULL, NULL),
(31872, '2017-05-28 10:42:45', NULL, NULL, 9599, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:42:45', 'admin-1495938775-14959393656123475', 1, 1, 'SR', NULL, NULL, NULL),
(31873, '2017-05-28 10:42:45', NULL, NULL, 9599, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:42:45', 'admin-1495938775-14959393656123475', 1, 1, 'SR', NULL, NULL, NULL),
(31874, '2017-05-28 10:42:45', NULL, NULL, 9599, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:42:45', 'admin-1495938775-14959393656123475', 1, 1, 'SR', NULL, NULL, NULL),
(31875, '2017-05-28 10:42:45', NULL, NULL, 9599, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:42:45', 'admin-1495938775-14959393656123475', 1, 1, 'SR', NULL, NULL, NULL),
(31876, '2017-05-28 11:00:19', NULL, NULL, 9600, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.50, 0.0000, 0.0000, 11.50, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:00:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31877, '2017-05-28 11:00:42', NULL, NULL, 9600, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:00:42', 'admin-1495938775-14959404423497353', 1, 0, '', NULL, NULL, NULL),
(31878, '2017-05-28 11:00:42', NULL, NULL, 9600, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:00:42', 'admin-1495938775-14959404423497353', 1, 0, '', NULL, NULL, NULL),
(31879, '2017-05-28 11:00:42', NULL, NULL, 9600, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:00:42', 'admin-1495938775-14959404423497353', 1, 0, '', NULL, NULL, NULL),
(31880, '2017-05-28 11:00:42', NULL, NULL, 9600, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:00:42', 'admin-1495938775-14959404423497353', 1, 0, '', NULL, NULL, NULL),
(31881, '2017-05-28 11:37:11', NULL, NULL, 9610, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:37:11', 'admin-1495942548-14959426310077576', 1, 0, '', NULL, NULL, NULL),
(31882, '2017-05-28 11:37:30', NULL, NULL, 9611, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:37:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31883, '2017-05-28 11:37:54', NULL, NULL, 9611, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:37:54', 'admin-1495942548-14959426745285559', 1, 0, '', NULL, NULL, NULL),
(31884, '2017-05-28 11:37:11', NULL, NULL, 9610, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:37:11', 'admin-1495942548-14959426310077576', 1, 1, 'SR', NULL, NULL, NULL),
(31885, '2017-05-28 11:36:16', NULL, NULL, 9609, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:36:16', 'admin-1495942548-1495942576021766', 1, 0, '', NULL, NULL, NULL),
(31886, '2017-05-28 11:36:16', NULL, NULL, 9609, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:36:16', 'admin-1495942548-1495942576021766', 1, 1, 'SR', NULL, NULL, NULL),
(31887, '2017-05-28 11:36:16', NULL, NULL, 9609, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:36:16', 'admin-1495942548-1495942576021766', 1, 0, '', NULL, NULL, NULL),
(31888, '2017-05-28 11:35:59', NULL, NULL, 9609, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:35:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31889, '2017-05-28 11:35:43', NULL, NULL, 9607, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:35:43', 'admin-1495941091-14959425437553431', 1, 0, '', NULL, NULL, NULL),
(31890, '2017-05-28 11:32:54', NULL, NULL, 9608, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:32:54', 'admin-1495941091-14959423743728588', 1, 0, '', NULL, NULL, NULL),
(31891, '2017-05-28 11:32:33', NULL, NULL, 9608, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:32:33', 'admin-1495941091-14959423529028715', 1, 1, 'SR', NULL, NULL, NULL),
(31892, '2017-05-28 11:32:33', NULL, NULL, 9608, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:32:33', 'admin-1495941091-14959423529028715', 1, 1, 'SR', NULL, NULL, NULL),
(31893, '2017-05-28 11:31:13', NULL, NULL, 9608, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:31:13', 'admin-1495941091-14959422729801914', 1, 0, '', NULL, NULL, NULL),
(31894, '2017-05-28 11:31:13', NULL, NULL, 9608, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:31:13', 'admin-1495941091-14959422729801914', 1, 1, 'SR', NULL, NULL, NULL),
(31895, '2017-05-28 11:30:36', NULL, NULL, 9608, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:30:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31896, '2017-05-28 11:31:13', NULL, NULL, 9608, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:31:13', 'admin-1495941091-14959422729801914', 1, 1, 'SR', NULL, NULL, NULL),
(31897, '2017-05-28 11:26:32', NULL, NULL, 9607, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:26:32', 'admin-1495941091-1495941992780703', 1, 1, 'SR', NULL, NULL, NULL),
(31898, '2017-05-28 11:26:32', NULL, NULL, 9607, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:26:32', 'admin-1495941091-1495941992780703', 1, 0, '', NULL, NULL, NULL),
(31899, '2017-05-28 11:24:16', NULL, NULL, 9607, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:24:16', 'admin-1495941091-14959418562359422', 1, 0, '', NULL, NULL, NULL),
(31900, '2017-05-28 11:24:16', NULL, NULL, 9607, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:24:16', 'admin-1495941091-14959418562359422', 1, 0, '', NULL, NULL, NULL),
(31901, '2017-05-28 11:24:16', NULL, NULL, 9607, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:24:16', 'admin-1495941091-14959418562359422', 1, 0, '', NULL, NULL, NULL),
(31902, '2017-05-28 11:24:16', NULL, NULL, 9607, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:24:16', 'admin-1495941091-14959418562359422', 1, 0, '', NULL, NULL, NULL),
(31903, '2017-05-28 11:23:27', NULL, NULL, 9607, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.50, 0.0000, 0.0000, 13.50, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:23:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31904, '2017-05-28 11:22:36', NULL, NULL, 9606, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:22:36', 'admin-1495941091-1495941756626739', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(31905, '2017-05-28 11:20:54', NULL, NULL, 9606, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:20:54', 'admin-1495941091-1495941653915266', 1, 1, 'SR', NULL, NULL, NULL),
(31906, '2017-05-28 11:20:51', NULL, NULL, 9606, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:20:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31907, '2017-05-28 11:17:53', NULL, NULL, 9604, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:17:53', 'admin-1495941091-14959414736948288', 1, 0, '', NULL, NULL, NULL),
(31908, '2017-05-28 11:14:55', NULL, NULL, 9605, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:14:55', 'admin-1495941091-14959412955089680', 1, 0, '', NULL, NULL, NULL),
(31909, '2017-05-28 11:14:55', NULL, NULL, 9605, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:14:55', 'admin-1495941091-14959412955089680', 1, 0, '', NULL, NULL, NULL),
(31910, '2017-05-28 11:01:06', NULL, NULL, 9601, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.20, 0.0000, 0.0000, 10.20, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:01:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31911, '2017-05-28 11:01:16', NULL, NULL, 9601, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:01:16', 'admin-1495938775-14959404765344258', 1, 0, '', NULL, NULL, NULL),
(31912, '2017-05-28 11:01:16', NULL, NULL, 9601, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:01:16', 'admin-1495938775-14959404765344258', 1, 0, '', NULL, NULL, NULL),
(31913, '2017-05-28 11:00:42', NULL, NULL, 9600, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:00:42', 'admin-1495938775-14959404423497353', 1, 0, '', NULL, NULL, NULL),
(31914, '2017-05-28 11:00:55', NULL, NULL, 9600, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:00:55', 'admin-1495938775-14959404555587186', 1, 1, 'SR', NULL, NULL, NULL),
(31915, '2017-05-28 11:00:55', NULL, NULL, 9600, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:00:55', 'admin-1495938775-14959404555587186', 1, 1, 'SR', NULL, NULL, NULL),
(31916, '2017-05-28 11:00:42', NULL, NULL, 9600, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 11:00:42', 'admin-1495938775-14959404423497353', 1, 0, '', NULL, NULL, NULL),
(31917, '2017-05-28 10:33:13', NULL, NULL, 9596, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:33:13', 'admin-1495938775-14959387932777458', 1, 1, 'SR', NULL, NULL, NULL),
(31918, '2017-05-28 10:33:18', NULL, NULL, 9597, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:33:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31919, '2017-05-28 10:33:23', NULL, NULL, 9597, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:33:23', 'admin-1495938775-14959388037914179', 1, 0, '', NULL, NULL, NULL),
(31920, '2017-05-28 10:33:33', NULL, NULL, 9597, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:33:33', 'admin-1495938775-14959388128847136', 1, 1, 'SR', NULL, NULL, NULL),
(31921, '2017-05-28 10:33:33', NULL, NULL, 9597, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:33:33', 'admin-1495938775-14959388128847136', 1, 1, 'SR', NULL, NULL, NULL),
(31922, '2017-05-28 10:39:37', NULL, NULL, 9598, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:39:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31923, '2017-05-28 10:39:57', NULL, NULL, 9598, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:39:57', 'admin-1495938775-14959391977454532', 1, 0, '', NULL, NULL, NULL),
(31924, '2017-05-28 10:39:57', NULL, NULL, 9598, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:39:57', 'admin-1495938775-14959391977454532', 1, 0, '', NULL, NULL, NULL),
(31925, '2017-05-28 10:32:12', NULL, NULL, 9596, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:32:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31926, '2017-05-28 10:32:28', NULL, NULL, 9596, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:32:28', 'admin-1495933254-14959387480143439', 1, 0, '', NULL, NULL, NULL),
(31927, '2017-05-28 10:28:35', NULL, NULL, 9595, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:28:35', 'admin-1495933254-14959385151304881', 1, 1, 'SR', NULL, NULL, NULL),
(31928, '2017-05-28 10:28:20', NULL, NULL, 9595, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:28:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31929, '2017-05-28 10:11:47', NULL, NULL, 9594, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:11:47', 'admin-1495933254-1495937506868838', 1, 1, 'SR', NULL, NULL, NULL),
(31930, '2017-05-28 10:11:47', NULL, NULL, 9594, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:11:47', 'admin-1495933254-1495937506868838', 1, 1, 'SR', NULL, NULL, NULL),
(31931, '2017-05-28 10:11:47', NULL, NULL, 9594, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:11:47', 'admin-1495933254-1495937506868838', 1, 0, '', NULL, NULL, NULL),
(31932, '2017-05-28 10:11:47', NULL, NULL, 9594, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:11:47', 'admin-1495933254-1495937506868838', 1, 0, '', NULL, NULL, NULL),
(31933, '2017-05-28 10:10:45', NULL, NULL, 9594, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 10:10:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31934, '2017-05-28 09:49:34', NULL, NULL, 9593, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 09:49:34', 'admin-1495933254-14959361743955977', 1, 0, '', NULL, NULL, NULL),
(31935, '2017-05-28 09:49:31', NULL, NULL, 9593, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1495946282', 'admin', '2017-05-28 09:49:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31936, '2017-05-28 09:36:58', NULL, NULL, 9592, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 09:36:58', 'admin-1495933254-1495935417836511', 1, 1, 'SR', NULL, NULL, NULL),
(31937, '2017-05-28 09:36:58', NULL, NULL, 9592, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 09:36:58', 'admin-1495933254-1495935417836511', 1, 0, '', NULL, NULL, NULL),
(31938, '2017-05-28 09:36:58', NULL, NULL, 9592, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 09:36:58', 'admin-1495933254-1495935417836511', 1, 0, '', NULL, NULL, NULL),
(31939, '2017-05-28 09:36:58', NULL, NULL, 9592, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 09:36:58', 'admin-1495933254-1495935417836511', 1, 0, '', NULL, NULL, NULL),
(31940, '2017-05-28 09:36:58', NULL, NULL, 9592, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 09:36:58', 'admin-1495933254-1495935417836511', 1, 0, '', NULL, NULL, NULL),
(31941, '2017-05-28 09:36:58', NULL, NULL, 9592, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 09:36:58', 'admin-1495933254-1495935417836511', 1, 0, '', NULL, NULL, NULL),
(31942, '2017-05-28 09:36:58', NULL, NULL, 9592, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 09:36:58', 'admin-1495933254-1495935417836511', 1, 0, '', NULL, NULL, NULL),
(31943, '2017-05-28 09:36:58', NULL, NULL, 9592, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 09:36:58', 'admin-1495933254-1495935417836511', 1, 1, 'SR', NULL, NULL, NULL),
(31944, '2017-05-28 09:36:08', NULL, NULL, 9592, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.10, 0.0000, 0.0000, 12.10, 1, '27', 1, '1495946282', 'admin', '2017-05-28 09:36:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31945, '2017-05-28 09:36:58', NULL, NULL, 9592, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 09:36:58', 'admin-1495933254-1495935417836511', 1, 0, '', NULL, NULL, NULL),
(31946, '2017-05-28 09:29:16', NULL, NULL, 9591, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 09:29:16', 'admin-1495933254-14959349567096845', 1, 0, '', NULL, NULL, NULL),
(31947, '2017-05-28 09:29:16', NULL, NULL, 9591, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 09:29:16', 'admin-1495933254-14959349567096845', 1, 0, '', NULL, NULL, NULL),
(31948, '2017-05-28 09:29:16', NULL, NULL, 9591, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 09:29:16', 'admin-1495933254-14959349567096845', 1, 0, '', NULL, NULL, NULL),
(31949, '2017-05-28 09:04:58', NULL, NULL, 9590, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 09:04:58', 'admin-1495933254-14959334984368349', 1, 0, '', NULL, NULL, NULL),
(31950, '2017-05-28 09:05:05', NULL, NULL, 9590, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 09:05:05', 'admin-1495933254-14959335057911810', 1, 0, '', NULL, NULL, NULL),
(31951, '2017-05-28 09:04:58', NULL, NULL, 9590, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 09:04:58', 'admin-1495933254-14959334984368349', 1, 0, '', NULL, NULL, NULL),
(31952, '2017-05-28 09:31:01', NULL, NULL, 9591, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 09:31:01', 'admin-1495933254-14959350613554044', 1, 1, 'SR', NULL, NULL, NULL),
(31953, '2017-05-28 09:30:10', NULL, NULL, 9591, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1495946282', 'admin', '2017-05-28 09:30:10', 'admin-1495933254-14959350101689193', 1, 1, 'SR', NULL, NULL, NULL),
(31954, '2017-05-28 09:29:11', NULL, NULL, 9591, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1495946282', 'admin', '2017-05-28 09:29:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31955, '2017-05-28 09:04:49', NULL, NULL, 9590, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1495946282', 'admin', '2017-05-28 09:04:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31956, '2017-05-29 13:47:39', NULL, NULL, 9670, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:47:39', 'admin-1496034809-1496036858693788', 1, 1, 'SR', NULL, NULL, NULL),
(31957, '2017-05-29 13:48:50', NULL, NULL, 9671, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.80, 0.0000, 0.0000, 13.80, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:48:50', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(31958, '2017-05-29 13:48:54', NULL, NULL, 9671, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:48:54', 'admin-1496036925-14960369344341995', 1, 1, 'SR', NULL, NULL, '10.0'),
(31959, '2017-05-29 14:00:41', NULL, NULL, 9664, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 14:00:41', 'admin-1496036925-14960376414291618', 1, 0, '', NULL, NULL, NULL),
(31960, '2017-05-29 13:27:33', NULL, NULL, 9667, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:27:33', 'admin-1496034809-14960356531212021', 1, 0, '', NULL, NULL, NULL),
(31961, '2017-05-29 13:27:33', NULL, NULL, 9667, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:27:33', 'admin-1496034809-14960356531212021', 1, 1, 'SR', NULL, NULL, NULL),
(31962, '2017-05-29 11:41:05', NULL, NULL, 9659, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:41:05', 'admin-1496027243-14960292648891069', 1, 0, '', NULL, NULL, NULL),
(31963, '2017-05-29 11:47:41', NULL, NULL, 9660, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:47:41', 'admin-1496027243-14960296608694889', 1, 1, 'SR', NULL, NULL, NULL),
(31964, '2017-05-29 11:51:49', NULL, NULL, 9661, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.90, 0.0000, 0.0000, 9.90, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:51:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31965, '2017-05-29 14:14:32', NULL, NULL, 9671, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 14:14:32', 'admin-1496036925-14960384720741516', 1, 1, 'SR', NULL, NULL, '10.0'),
(31966, '2017-05-29 14:18:46', NULL, NULL, 9671, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 14:18:46', 'admin-1496036925-14960387262741580', 1, 1, 'SR', NULL, NULL, '10.0'),
(31967, '2017-05-29 13:24:19', NULL, NULL, 9666, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:24:19', 'admin-1496034809-14960354596501871', 1, 1, 'SR', NULL, NULL, NULL),
(31968, '2017-05-29 12:36:49', NULL, NULL, 9662, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1496036925', 'admin', '2017-05-29 12:36:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31969, '2017-05-29 12:36:55', NULL, NULL, 9662, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 12:36:55', 'admin-1496027243-14960326148434695', 1, 1, 'SR', NULL, NULL, NULL),
(31970, '2017-05-29 12:36:55', NULL, NULL, 9662, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 12:36:55', 'admin-1496027243-14960326148434695', 1, 0, '', NULL, NULL, NULL),
(31971, '2017-05-29 12:37:19', NULL, NULL, 9663, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1496036925', 'admin', '2017-05-29 12:37:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31972, '2017-05-29 12:37:26', NULL, NULL, 9663, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 12:37:26', 'admin-1496027243-14960326461703911', 1, 0, '', NULL, NULL, NULL),
(31973, '2017-05-29 10:34:20', NULL, NULL, 9651, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 3, 11.00, 33.0000, 0.0000, 33.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:34:20', 'admin-1496020083-14960252608142455', 1, 0, '', NULL, NULL, NULL),
(31974, '2017-05-29 10:34:20', NULL, NULL, 9651, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:34:20', 'admin-1496020083-14960252608142455', 1, 0, '', NULL, NULL, NULL),
(31975, '2017-05-29 11:02:04', NULL, NULL, 9652, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:02:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31976, '2017-05-29 16:29:05', NULL, NULL, 9673, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1496036925', 'admin', '2017-05-29 16:29:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31977, '2017-05-29 16:29:08', NULL, NULL, 9673, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 16:29:08', 'admin-1496036925-14960465485307473', 1, 1, 'SR', NULL, NULL, NULL),
(31978, '2017-05-29 16:53:47', NULL, NULL, 9674, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1496036925', 'admin', '2017-05-29 16:53:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31979, '2017-05-29 16:53:50', NULL, NULL, 9674, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 16:53:50', 'admin-1496036925-14960480300359156', 1, 1, 'SR', NULL, NULL, NULL),
(31980, '2017-05-29 11:47:33', NULL, NULL, 9660, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:47:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31981, '2017-05-29 11:47:41', NULL, NULL, 9660, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:47:41', 'admin-1496027243-14960296608694889', 1, 0, '', NULL, NULL, NULL),
(31982, '2017-05-29 11:34:10', NULL, NULL, 9657, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:34:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31983, '2017-05-29 11:34:24', NULL, NULL, 9657, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:34:24', 'admin-1496027243-14960288639075497', 1, 1, 'SR', NULL, NULL, NULL),
(31984, '2017-05-29 11:34:24', NULL, NULL, 9657, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:34:24', 'admin-1496027243-14960288639075497', 1, 1, 'SR', NULL, NULL, NULL),
(31985, '2017-05-29 12:30:43', NULL, NULL, 9661, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 12:30:43', 'admin-1496027243-14960322438243692', 1, 0, '', NULL, NULL, NULL),
(31986, '2017-05-29 12:30:43', NULL, NULL, 9661, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 12:30:43', 'admin-1496027243-14960322438243692', 1, 0, '', NULL, NULL, NULL),
(31987, '2017-05-29 12:35:29', NULL, NULL, 9659, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 12:35:29', 'admin-1496027243-14960325290323758', 1, 0, '', NULL, NULL, NULL),
(31988, '2017-05-29 14:19:07', NULL, NULL, 9671, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 14:19:07', 'admin-1496036925-14960387470183340', 1, 1, 'SR', NULL, NULL, '10.0'),
(31989, '2017-05-29 14:37:29', NULL, NULL, 9672, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1496036925', 'admin', '2017-05-29 14:37:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31990, '2017-05-29 11:52:02', NULL, NULL, 9661, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:52:02', 'admin-1496027243-1496029922485316', 1, 1, 'SR', NULL, NULL, NULL),
(31991, '2017-05-29 11:52:02', NULL, NULL, 9661, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:52:02', 'admin-1496027243-1496029922485316', 1, 0, '', NULL, NULL, NULL),
(31992, '2017-05-29 13:27:20', NULL, NULL, 9667, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:27:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31993, '2017-05-29 13:27:33', NULL, NULL, 9667, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:27:33', 'admin-1496034809-14960356531212021', 1, 0, '', NULL, NULL, NULL),
(31994, '2017-05-29 11:07:14', NULL, NULL, 9653, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:07:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(31995, '2017-05-29 11:07:17', NULL, NULL, 9653, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:07:17', 'admin-1496020083-1496027237731584', 1, 0, '', NULL, NULL, NULL),
(31996, '2017-05-29 11:07:31', NULL, NULL, 9653, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:07:31', 'admin-1496027243-14960272510253179', 1, 0, '', NULL, NULL, NULL),
(31997, '2017-05-29 15:06:49', NULL, NULL, 9671, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 15:06:49', 'admin-1496036925-14960416093856750', 1, 0, '', NULL, NULL, '10.0'),
(31998, '2017-05-29 15:06:49', NULL, NULL, 9671, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 15:06:49', 'admin-1496036925-14960416093856750', 1, 1, 'SR', NULL, NULL, '10.0'),
(31999, '2017-05-29 15:06:49', NULL, NULL, 9671, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 15:06:49', 'admin-1496036925-14960416093856750', 1, 0, '', NULL, NULL, '10.0'),
(32000, '2017-05-29 11:34:24', NULL, NULL, 9657, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:34:24', 'admin-1496027243-14960288639075497', 1, 0, '', NULL, NULL, NULL),
(32001, '2017-05-29 11:34:24', NULL, NULL, 9657, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:34:24', 'admin-1496027243-14960288639075497', 1, 0, '', NULL, NULL, NULL),
(32002, '2017-05-29 14:22:10', NULL, NULL, 9671, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 14:22:10', 'admin-1496036925-14960389299534995', 1, 1, 'SR', NULL, NULL, '10.0'),
(32003, '2017-05-29 14:19:07', NULL, NULL, 9671, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 14:19:07', 'admin-1496036925-14960387470183340', 1, 1, 'SR', NULL, NULL, '10.0'),
(32004, '2017-05-29 14:18:46', NULL, NULL, 9671, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 14:18:46', 'admin-1496036925-14960387262741580', 1, 1, 'SR', NULL, NULL, '10.0'),
(32005, '2017-05-29 13:47:39', NULL, NULL, 9670, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:47:39', 'admin-1496034809-1496036858693788', 1, 0, '', NULL, NULL, NULL),
(32006, '2017-05-29 13:27:33', NULL, NULL, 9667, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:27:33', 'admin-1496034809-14960356531212021', 1, 1, 'SR', NULL, NULL, NULL),
(32007, '2017-05-29 13:27:47', NULL, NULL, 9667, 0, 181, '116', 'Open Food ', 'One Bacon Aglio Olio take away', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:27:47', 'admin-1496034809-14960356673727435', 1, 0, '', NULL, NULL, NULL),
(32008, '2017-05-29 13:45:47', NULL, NULL, 9668, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:45:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32009, '2017-05-29 13:46:10', NULL, NULL, 9668, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:46:10', 'admin-1496034809-14960367707396263', 1, 1, 'SR', NULL, NULL, NULL),
(32010, '2017-05-29 13:46:10', NULL, NULL, 9668, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:46:10', 'admin-1496034809-14960367707396263', 1, 0, '', NULL, NULL, NULL),
(32011, '2017-05-29 13:46:10', NULL, NULL, 9668, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:46:10', 'admin-1496034809-14960367707396263', 1, 1, 'SR', NULL, NULL, NULL),
(32012, '2017-05-29 13:47:39', NULL, NULL, 9670, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:47:39', 'admin-1496034809-1496036858693788', 1, 0, '', NULL, NULL, NULL),
(32013, '2017-05-29 13:47:39', NULL, NULL, 9670, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:47:39', 'admin-1496034809-1496036858693788', 1, 0, '', NULL, NULL, NULL),
(32014, '2017-05-29 13:47:39', NULL, NULL, 9670, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:47:39', 'admin-1496034809-1496036858693788', 1, 0, '', NULL, NULL, NULL),
(32015, '2017-05-29 13:46:26', NULL, NULL, 9669, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:46:26', 'admin-1496034809-14960367867298926', 1, 1, 'SR', NULL, NULL, NULL),
(32016, '2017-05-29 13:47:16', NULL, NULL, 9670, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:47:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32017, '2017-05-29 13:46:26', NULL, NULL, 9669, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:46:26', 'admin-1496034809-14960367867298926', 1, 1, 'SR', NULL, NULL, NULL),
(32018, '2017-05-29 13:46:20', NULL, NULL, 9669, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:46:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32019, '2017-05-29 13:24:19', NULL, NULL, 9666, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:24:19', 'admin-1496034809-14960354596501871', 1, 0, '', NULL, NULL, NULL),
(32020, '2017-05-29 13:24:19', NULL, NULL, 9666, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:24:19', 'admin-1496034809-14960354596501871', 1, 1, 'SR', NULL, NULL, NULL),
(32021, '2017-05-29 13:24:19', NULL, NULL, 9666, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:24:19', 'admin-1496034809-14960354596501871', 1, 1, 'SR', NULL, NULL, NULL),
(32022, '2017-05-29 13:24:19', NULL, NULL, 9666, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:24:19', 'admin-1496034809-14960354596501871', 1, 1, 'SR', NULL, NULL, NULL),
(32023, '2017-05-29 13:24:19', NULL, NULL, 9666, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:24:19', 'admin-1496034809-14960354596501871', 1, 1, 'SR', NULL, NULL, NULL),
(32024, '2017-05-29 13:23:59', NULL, NULL, 9666, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:23:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32025, '2017-05-29 13:23:37', NULL, NULL, 9665, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:23:37', 'admin-1496034809-14960354170953680', 1, 0, '', NULL, NULL, NULL),
(32026, '2017-05-29 13:23:37', NULL, NULL, 9665, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:23:37', 'admin-1496034809-14960354170953680', 1, 0, '', NULL, NULL, NULL),
(32027, '2017-05-29 13:22:11', NULL, NULL, 9665, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:22:11', 'admin-1496034809-14960353309364533', 1, 0, '', NULL, NULL, NULL),
(32028, '2017-05-29 13:16:34', NULL, NULL, 9664, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:16:34', 'admin-1496034809-1496034994683514', 1, 1, 'SR', NULL, NULL, NULL),
(32029, '2017-05-29 13:21:53', NULL, NULL, 9665, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:21:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32030, '2017-05-29 13:22:11', NULL, NULL, 9665, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:22:11', 'admin-1496034809-14960353309364533', 1, 0, '', NULL, NULL, NULL),
(32031, '2017-05-29 13:16:34', NULL, NULL, 9664, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:16:34', 'admin-1496034809-1496034994683514', 1, 1, 'SR', NULL, NULL, NULL),
(32032, '2017-05-29 13:16:34', NULL, NULL, 9664, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:16:34', 'admin-1496034809-1496034994683514', 1, 1, 'SR', NULL, NULL, NULL),
(32033, '2017-05-29 13:16:34', NULL, NULL, 9664, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:16:34', 'admin-1496034809-1496034994683514', 1, 1, 'SR', NULL, NULL, NULL),
(32034, '2017-05-29 13:13:18', NULL, NULL, 9664, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:13:18', 'admin-1496027243-1496034798140322', 1, 1, 'SR', NULL, NULL, NULL),
(32035, '2017-05-29 13:13:12', NULL, NULL, 9664, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1496036925', 'admin', '2017-05-29 13:13:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32036, '2017-05-29 12:41:42', NULL, NULL, 9662, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 12:41:42', 'admin-1496027243-14960329021331684', 1, 0, '', NULL, NULL, NULL),
(32037, '2017-05-29 12:37:26', NULL, NULL, 9663, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 12:37:26', 'admin-1496027243-14960326461703911', 1, 0, '', NULL, NULL, NULL),
(32038, '2017-05-29 12:01:52', NULL, NULL, 9655, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 12:01:52', 'admin-1496027243-14960305119948897', 1, 0, '', NULL, NULL, NULL),
(32039, '2017-05-29 11:52:02', NULL, NULL, 9661, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:52:02', 'admin-1496027243-1496029922485316', 1, 1, 'SR', NULL, NULL, NULL),
(32040, '2017-05-29 11:52:02', NULL, NULL, 9661, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:52:02', 'admin-1496027243-1496029922485316', 1, 0, '', NULL, NULL, NULL),
(32041, '2017-05-29 11:52:02', NULL, NULL, 9661, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:52:02', 'admin-1496027243-1496029922485316', 1, 0, '', NULL, NULL, NULL),
(32042, '2017-05-29 11:52:02', NULL, NULL, 9661, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:52:02', 'admin-1496027243-1496029922485316', 1, 1, 'SR', NULL, NULL, NULL),
(32043, '2017-05-29 14:37:33', NULL, NULL, 9672, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 14:37:33', 'admin-1496036925-14960398536687070', 1, 0, '', NULL, NULL, NULL),
(32044, '2017-05-29 11:34:34', NULL, NULL, 9658, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:34:34', 'admin-1496027243-1496028874601359', 1, 1, 'SR', NULL, NULL, NULL),
(32045, '2017-05-29 11:34:34', NULL, NULL, 9658, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:34:34', 'admin-1496027243-1496028874601359', 1, 1, 'SR', NULL, NULL, NULL),
(32046, '2017-05-29 11:34:34', NULL, NULL, 9658, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:34:34', 'admin-1496027243-1496028874601359', 1, 1, 'SR', NULL, NULL, NULL),
(32047, '2017-05-29 11:40:57', NULL, NULL, 9659, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:40:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32048, '2017-05-29 11:41:05', NULL, NULL, 9659, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:41:05', 'admin-1496027243-14960292648891069', 1, 0, '', NULL, NULL, NULL),
(32049, '2017-05-29 11:41:05', NULL, NULL, 9659, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:41:05', 'admin-1496027243-14960292648891069', 1, 0, '', NULL, NULL, NULL),
(32050, '2017-05-29 11:34:27', NULL, NULL, 9658, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:34:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32051, '2017-05-29 11:17:45', NULL, NULL, 9654, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:17:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32052, '2017-05-29 11:17:54', NULL, NULL, 9654, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:17:54', 'admin-1496027243-14960278746581973', 1, 0, '', NULL, NULL, NULL),
(32053, '2017-05-29 11:17:54', NULL, NULL, 9654, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:17:54', 'admin-1496027243-14960278746581973', 1, 1, 'SR', NULL, NULL, NULL),
(32054, '2017-05-29 11:24:25', NULL, NULL, 9655, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:24:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32055, '2017-05-29 11:24:29', NULL, NULL, 9655, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:24:29', 'admin-1496027243-1496028269186894', 1, 1, 'SR', NULL, NULL, NULL),
(32056, '2017-05-29 11:24:29', NULL, NULL, 9655, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:24:29', 'admin-1496027243-1496028269186894', 1, 1, 'SR', NULL, NULL, NULL),
(32057, '2017-05-29 11:29:56', NULL, NULL, 9651, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:29:56', 'admin-1496027243-14960285960144777', 1, 0, '', NULL, NULL, NULL),
(32058, '2017-05-29 11:02:16', NULL, NULL, 9652, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:02:16', 'admin-1496020083-14960269363317891', 1, 1, 'SR', NULL, NULL, NULL),
(32059, '2017-05-29 11:02:16', NULL, NULL, 9652, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 11:02:16', 'admin-1496020083-14960269363317891', 1, 0, '', NULL, NULL, NULL),
(32060, '2017-05-29 09:26:26', NULL, NULL, 9646, 0, 279, '213', 'Diet Meal - Americano / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 09:26:26', 'admin-1496020083-14960211861218645', 1, 0, '', NULL, NULL, NULL),
(32061, '2017-05-29 10:12:57', NULL, NULL, 9648, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:12:57', 'admin-1496020083-14960239776261883', 1, 0, '', NULL, NULL, NULL),
(32062, '2017-05-29 10:18:33', NULL, NULL, 9650, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:18:33', 'admin-1496020083-1496024313109415', 1, 0, '', NULL, NULL, NULL),
(32063, '2017-05-29 10:18:33', NULL, NULL, 9650, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:18:33', 'admin-1496020083-1496024313109415', 1, 1, 'SR', NULL, NULL, NULL),
(32064, '2017-05-29 10:33:52', NULL, NULL, 9651, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.70, 0.0000, 0.0000, 9.70, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:33:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32065, '2017-05-29 10:34:00', NULL, NULL, 9651, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:34:00', 'admin-1496020083-14960252400731066', 1, 0, '', NULL, NULL, NULL),
(32066, '2017-05-29 10:34:00', NULL, NULL, 9651, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:34:00', 'admin-1496020083-14960252400731066', 1, 0, '', NULL, NULL, NULL),
(32067, '2017-05-29 10:12:57', NULL, NULL, 9648, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:12:57', 'admin-1496020083-14960239776261883', 1, 0, '', NULL, NULL, NULL),
(32068, '2017-05-29 10:18:33', NULL, NULL, 9650, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:18:33', 'admin-1496020083-1496024313109415', 1, 1, 'SR', NULL, NULL, NULL),
(32069, '2017-05-29 10:18:33', NULL, NULL, 9650, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:18:33', 'admin-1496020083-1496024313109415', 1, 1, 'SR', NULL, NULL, NULL),
(32070, '2017-05-29 10:13:03', NULL, NULL, 9648, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:13:03', 'admin-1496020083-14960239832418635', 1, 1, 'SR', NULL, NULL, NULL),
(32071, '2017-05-29 10:17:38', NULL, NULL, 9650, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.10, 0.0000, 0.0000, 12.10, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:17:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32072, '2017-05-29 10:18:03', NULL, NULL, 9650, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:18:03', 'admin-1496020083-14960242833581644', 1, 0, '', NULL, NULL, NULL),
(32073, '2017-05-29 10:18:03', NULL, NULL, 9650, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:18:03', 'admin-1496020083-14960242833581644', 1, 0, '', NULL, NULL, NULL),
(32074, '2017-05-29 10:18:03', NULL, NULL, 9650, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:18:03', 'admin-1496020083-14960242833581644', 1, 0, '', NULL, NULL, NULL),
(32075, '2017-05-29 10:18:03', NULL, NULL, 9650, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:18:03', 'admin-1496020083-14960242833581644', 1, 0, '', NULL, NULL, NULL),
(32076, '2017-05-29 10:18:03', NULL, NULL, 9650, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:18:03', 'admin-1496020083-14960242833581644', 1, 0, '', NULL, NULL, NULL),
(32077, '2017-05-29 10:34:00', NULL, NULL, 9651, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:34:00', 'admin-1496020083-14960252400731066', 1, 0, '', NULL, NULL, NULL),
(32078, '2017-05-29 10:34:00', NULL, NULL, 9651, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:34:00', 'admin-1496020083-14960252400731066', 1, 0, '', NULL, NULL, NULL),
(32079, '2017-05-29 10:12:57', NULL, NULL, 9648, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:12:57', 'admin-1496020083-14960239776261883', 1, 0, '', NULL, NULL, NULL),
(32080, '2017-05-29 10:12:57', NULL, NULL, 9648, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:12:57', 'admin-1496020083-14960239776261883', 1, 0, '', NULL, NULL, NULL),
(32081, '2017-05-29 10:09:10', NULL, NULL, 9649, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:09:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32082, '2017-05-29 09:26:32', NULL, NULL, 9646, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 09:26:32', 'admin-1496020083-14960211921602145', 1, 0, '', NULL, NULL, NULL),
(32083, '2017-05-29 09:56:01', NULL, NULL, 9647, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1496036925', 'admin', '2017-05-29 09:56:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32084, '2017-05-29 09:56:06', NULL, NULL, 9647, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 09:56:06', 'admin-1496020083-14960229661631342', 1, 1, 'SR', NULL, NULL, NULL),
(32085, '2017-05-29 09:56:06', NULL, NULL, 9647, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 09:56:06', 'admin-1496020083-14960229661631342', 1, 0, '', NULL, NULL, NULL),
(32086, '2017-05-29 09:26:26', NULL, NULL, 9646, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 09:26:26', 'admin-1496020083-14960211861218645', 1, 0, '', NULL, NULL, NULL),
(32087, '2017-05-29 10:09:20', NULL, NULL, 9649, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:09:20', 'admin-1496020083-14960237599472040', 1, 0, '', NULL, NULL, NULL),
(32088, '2017-05-29 10:09:20', NULL, NULL, 9649, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:09:20', 'admin-1496020083-14960237599472040', 1, 1, 'SR', NULL, NULL, NULL),
(32089, '2017-05-29 10:07:03', NULL, NULL, 9648, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1496036925', 'admin', '2017-05-29 10:07:03', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(32090, '2017-05-29 09:26:11', NULL, NULL, 9646, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1496036925', 'admin', '2017-05-29 09:26:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32091, '2017-05-31 14:35:32', NULL, NULL, 9699, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:35:32', 'admin-1496209864-14962125323764766', 1, 0, '', NULL, NULL, NULL),
(32092, '2017-05-31 14:48:06', NULL, NULL, 9700, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:48:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32093, '2017-05-31 14:48:26', NULL, NULL, 9700, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:48:26', 'admin-1496209864-14962133061284156', 1, 0, '', NULL, NULL, NULL),
(32094, '2017-05-31 14:48:26', NULL, NULL, 9700, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:48:26', 'admin-1496209864-14962133061284156', 1, 0, '', NULL, NULL, NULL),
(32095, '2017-05-31 15:04:17', NULL, NULL, 9701, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 15:04:17', 'admin-1496213320-14962142568631019', 1, 1, 'SR', NULL, NULL, NULL),
(32096, '2017-05-31 13:05:54', NULL, NULL, 9687, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:05:54', 'admin-1496199128-14962071540575198', 1, 0, '', NULL, NULL, NULL),
(32097, '2017-05-31 13:06:39', NULL, NULL, 9687, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:06:39', 'admin-1496199128-14962071989405152', 1, 0, '', NULL, NULL, NULL),
(32098, '2017-05-31 16:44:32', NULL, NULL, 9706, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1496213320', 'admin', '2017-05-31 16:44:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32099, '2017-05-31 16:44:43', NULL, NULL, 9706, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 16:44:43', 'admin-1496213320-14962202829616234', 1, 0, '', NULL, NULL, NULL),
(32100, '2017-05-31 17:35:11', NULL, NULL, 9707, 0, 181, '116', 'Open Food ', 'ice cream', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 17:35:11', 'admin-1496213320-14962233112338843', 1, 0, '', 1, NULL, NULL),
(32101, '2017-05-31 15:47:03', NULL, NULL, 9703, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1496213320', 'admin', '2017-05-31 15:47:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32102, '2017-05-31 15:47:19', NULL, NULL, 9703, 0, 181, '116', 'Open Food ', 'Fruits Pancake', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 15:47:19', 'admin-1496213320-14962168394151916', 1, 0, '', NULL, NULL, NULL),
(32103, '2017-05-31 16:12:43', NULL, NULL, 9704, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1496213320', 'admin', '2017-05-31 16:12:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32104, '2017-05-31 16:12:52', NULL, NULL, 9704, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 16:12:52', 'admin-1496213320-14962183719941624', 1, 1, 'SR', NULL, NULL, NULL),
(32105, '2017-05-31 16:12:52', NULL, NULL, 9704, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 16:12:52', 'admin-1496213320-14962183719941624', 1, 1, 'SR', NULL, NULL, NULL),
(32106, '2017-05-31 11:43:54', NULL, NULL, 9683, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1496213320', 'admin', '2017-05-31 11:43:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32107, '2017-05-31 11:44:00', NULL, NULL, 9683, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 11:44:00', 'admin-1496199128-14962022399418899', 1, 1, 'SR', NULL, NULL, NULL),
(32108, '2017-05-31 09:06:53', NULL, NULL, 9675, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 09:06:53', 'admin-1496192352-14961928135465161', 1, 0, '', NULL, NULL, NULL),
(32109, '2017-05-31 13:09:21', NULL, NULL, 9688, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:09:21', 'admin-1496199128-14962073613012040', 1, 0, '', NULL, NULL, NULL),
(32110, '2017-05-31 13:09:40', NULL, NULL, 9686, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:09:40', 'admin-1496207371-14962073807279584', 1, 0, '', NULL, NULL, NULL),
(32111, '2017-05-31 14:25:41', NULL, NULL, 9698, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:25:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32112, '2017-05-31 14:25:52', NULL, NULL, 9698, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:25:52', 'admin-1496209864-14962119519669380', 1, 0, '', NULL, NULL, NULL),
(32113, '2017-05-31 13:13:08', NULL, NULL, 9689, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.70, 0.0000, 0.0000, 14.70, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:13:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32114, '2017-05-31 13:13:26', NULL, NULL, 9689, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:13:26', 'admin-1496207371-14962076058744518', 1, 1, 'SR', NULL, NULL, NULL),
(32115, '2017-05-31 13:13:26', NULL, NULL, 9689, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:13:26', 'admin-1496207371-14962076058744518', 1, 1, 'SR', NULL, NULL, NULL),
(32116, '2017-05-31 13:13:26', NULL, NULL, 9689, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:13:26', 'admin-1496207371-14962076058744518', 1, 0, '', NULL, NULL, NULL),
(32117, '2017-05-31 11:46:59', NULL, NULL, 9684, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 11:46:59', 'admin-1496199128-14962024195968283', 1, 0, '', NULL, NULL, NULL),
(32118, '2017-05-31 16:33:12', NULL, NULL, 9705, 0, 181, '116', 'Open Food ', 'Scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 16:33:12', 'admin-1496213320-14962195920488385', 1, 0, '', NULL, NULL, NULL),
(32119, '2017-05-31 16:32:43', NULL, NULL, 9705, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1496213320', 'admin', '2017-05-31 16:32:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32120, '2017-05-31 13:03:39', NULL, NULL, 9686, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:03:39', 'admin-1496199128-14962070196243843', 1, 1, 'SR', NULL, NULL, NULL),
(32121, '2017-05-31 13:03:39', NULL, NULL, 9686, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:03:39', 'admin-1496199128-14962070196243843', 1, 1, 'SR', NULL, NULL, NULL),
(32122, '2017-05-31 14:48:26', NULL, NULL, 9700, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:48:26', 'admin-1496209864-14962133061284156', 1, 0, '', NULL, NULL, NULL),
(32123, '2017-05-31 14:48:26', NULL, NULL, 9700, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:48:26', 'admin-1496209864-14962133061284156', 1, 1, 'SR', NULL, NULL, NULL),
(32124, '2017-05-31 14:35:30', NULL, NULL, 9699, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:35:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32125, '2017-05-31 14:57:10', NULL, NULL, 9700, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:57:10', 'admin-1496213320-1496213830640744', 1, 0, '', NULL, NULL, NULL),
(32126, '2017-05-31 15:04:08', NULL, NULL, 9701, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1496213320', 'admin', '2017-05-31 15:04:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32127, '2017-05-31 16:44:43', NULL, NULL, 9706, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 16:44:43', 'admin-1496213320-14962202829616234', 1, 0, '', NULL, NULL, NULL),
(32128, '2017-05-31 15:32:27', NULL, NULL, 9700, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 15:32:27', 'admin-1496213320-14962159476508694', 1, 0, '', NULL, NULL, NULL),
(32129, '2017-05-31 14:22:30', NULL, NULL, 9694, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:22:30', 'admin-1496209864-14962117502685699', 1, 0, '', NULL, NULL, NULL),
(32130, '2017-05-31 14:22:58', NULL, NULL, 9695, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:22:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32131, '2017-05-31 15:20:52', NULL, NULL, 9702, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 15:20:52', 'admin-1496213320-1496215252043643', 1, 1, 'SR', NULL, NULL, NULL),
(32132, '2017-05-31 15:20:48', NULL, NULL, 9702, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1496213320', 'admin', '2017-05-31 15:20:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32133, '2017-05-31 16:44:43', NULL, NULL, 9706, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 16:44:43', 'admin-1496213320-14962202829616234', 1, 0, '', NULL, NULL, NULL),
(32134, '2017-05-31 16:44:43', NULL, NULL, 9706, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 16:44:43', 'admin-1496213320-14962202829616234', 1, 1, 'SR', NULL, NULL, NULL),
(32135, '2017-05-31 15:13:38', NULL, NULL, 9694, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 15:13:38', 'admin-1496213320-1496214818714273', 1, 0, '', NULL, NULL, NULL),
(32136, '2017-05-31 13:34:10', NULL, NULL, 9690, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:34:10', 'admin-1496207371-14962088505569416', 1, 1, 'SR', 1, NULL, NULL),
(32137, '2017-05-31 13:38:47', NULL, NULL, 9691, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:38:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32138, '2017-05-31 13:38:57', NULL, NULL, 9691, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:38:57', 'admin-1496207371-14962091370184258', 1, 1, 'SR', NULL, NULL, NULL),
(32139, '2017-05-31 13:38:57', NULL, NULL, 9691, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:38:57', 'admin-1496207371-14962091370184258', 1, 0, '', NULL, NULL, NULL),
(32140, '2017-05-31 13:38:57', NULL, NULL, 9691, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:38:57', 'admin-1496207371-14962091370184258', 1, 1, 'SR', NULL, NULL, NULL),
(32141, '2017-05-31 13:38:57', NULL, NULL, 9691, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:38:57', 'admin-1496207371-14962091370184258', 1, 1, 'SR', NULL, NULL, NULL),
(32142, '2017-05-31 14:23:02', NULL, NULL, 9695, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:23:02', 'admin-1496209864-1496211782271589', 1, 1, 'SR', NULL, NULL, NULL),
(32143, '2017-05-31 14:23:05', NULL, NULL, 9696, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:23:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32144, '2017-05-31 14:23:09', NULL, NULL, 9696, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:23:09', 'admin-1496209864-14962117891538460', 1, 1, 'SR', NULL, NULL, NULL),
(32145, '2017-05-31 14:23:20', NULL, NULL, 9697, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:23:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32146, '2017-05-31 14:23:28', NULL, NULL, 9697, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:23:28', 'admin-1496209864-14962118083041526', 1, 1, 'SR', NULL, NULL, NULL),
(32147, '2017-05-31 14:23:28', NULL, NULL, 9697, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:23:28', 'admin-1496209864-14962118083041526', 1, 1, 'SR', NULL, NULL, NULL),
(32148, '2017-05-31 14:23:28', NULL, NULL, 9697, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:23:28', 'admin-1496209864-14962118083041526', 1, 0, '', NULL, NULL, NULL),
(32149, '2017-05-31 14:23:28', NULL, NULL, 9697, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:23:28', 'admin-1496209864-14962118083041526', 1, 0, '', NULL, NULL, NULL),
(32150, '2017-05-31 00:00:00', NULL, NULL, 9698, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:00:47', 'admin-1496209864-14962104471849644', 1, 1, 'SR', NULL, NULL, NULL),
(32151, '2017-05-31 00:00:00', NULL, NULL, 9698, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:25:08', 'admin-1496209864-14962119082873563', 1, 0, '', NULL, NULL, NULL),
(32152, '2017-05-31 10:50:33', NULL, NULL, 9682, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 10:50:33', 'admin-1496192352-14961990337625650', 1, 0, '', NULL, NULL, NULL),
(32153, '2017-05-31 10:53:38', NULL, NULL, 9681, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 10:53:38', 'admin-1496199128-14961992184124154', 1, 1, 'SR', NULL, NULL, NULL),
(32154, '2017-05-31 10:53:51', NULL, NULL, 9681, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 10:53:51', 'admin-1496199128-1496199231014438', 1, 0, '', NULL, NULL, NULL),
(32155, '2017-05-31 11:06:53', NULL, NULL, 9682, 0, 279, '213', 'Diet Meal - Americano / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 11:06:53', 'admin-1496199128-14962000134229478', 1, 0, '', NULL, NULL, NULL),
(32156, '2017-05-31 11:30:23', NULL, NULL, 9682, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 11:30:23', 'admin-1496199128-14962014232484079', 1, 0, '', NULL, NULL, NULL),
(32157, '2017-05-31 15:04:17', NULL, NULL, 9701, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 15:04:17', 'admin-1496213320-14962142568631019', 1, 1, 'SR', NULL, NULL, NULL),
(32158, '2017-05-31 14:26:09', NULL, NULL, 9681, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:26:09', 'admin-1496209864-14962119693359028', 1, 0, '', NULL, NULL, NULL),
(32159, '2017-05-31 14:22:30', NULL, NULL, 9694, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:22:30', 'admin-1496209864-14962117502685699', 1, 1, 'SR', NULL, NULL, NULL),
(32160, '2017-05-31 14:08:46', NULL, NULL, 9693, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:08:46', 'admin-1496209864-14962109258895819', 1, 0, '', NULL, NULL, NULL),
(32161, '2017-05-31 14:08:46', NULL, NULL, 9693, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:08:46', 'admin-1496209864-14962109258895819', 1, 0, '', NULL, NULL, NULL),
(32162, '2017-05-31 00:00:00', NULL, NULL, 9698, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:50:37', 'admin-1496207371-14962098374487155', 1, 1, 'SR', NULL, NULL, NULL),
(32163, '2017-05-31 13:58:20', NULL, NULL, 9694, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:58:20', 'admin-1496209864-14962103004038986', 1, 1, 'SR', NULL, NULL, NULL),
(32164, '2017-05-31 13:58:20', NULL, NULL, 9694, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:58:20', 'admin-1496209864-14962103004038986', 1, 0, '', NULL, NULL, NULL),
(32165, '2017-05-31 13:58:20', NULL, NULL, 9694, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:58:20', 'admin-1496209864-14962103004038986', 1, 0, '', NULL, NULL, NULL),
(32166, '2017-05-31 13:58:20', NULL, NULL, 9694, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:58:20', 'admin-1496209864-14962103004038986', 1, 1, 'SR', NULL, NULL, NULL),
(32167, '2017-05-31 13:58:08', NULL, NULL, 9694, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:58:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32168, '2017-05-31 13:57:08', NULL, NULL, 9693, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:57:08', 'admin-1496209864-14962102278484855', 1, 1, 'SR', NULL, NULL, NULL),
(32169, '2017-05-31 13:57:08', NULL, NULL, 9693, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:57:08', 'admin-1496209864-14962102278484855', 1, 1, 'SR', NULL, NULL, NULL),
(32170, '2017-05-31 13:57:08', NULL, NULL, 9693, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:57:08', 'admin-1496209864-14962102278484855', 1, 1, 'SR', NULL, NULL, NULL),
(32171, '2017-05-31 13:56:59', NULL, NULL, 9693, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:56:59', 'admin-1496209864-14962102193551425', 1, 0, '', NULL, NULL, NULL),
(32172, '2017-05-31 14:04:53', NULL, NULL, 9689, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 14:04:53', 'admin-1496209864-14962106936654519', 1, 1, 'SR', NULL, NULL, NULL),
(32173, '2017-05-31 13:56:59', NULL, NULL, 9693, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:56:59', 'admin-1496209864-14962102193551425', 1, 0, '', NULL, NULL, NULL),
(32174, '2017-05-31 13:56:42', NULL, NULL, 9693, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.69, 0.0000, 0.0000, 5.69, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:56:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32175, '2017-05-31 00:00:00', NULL, NULL, 9698, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:12:29', 'admin-1496207371-14962075496253364', 1, 1, 'SR', NULL, NULL, NULL),
(32176, '2017-05-31 16:33:12', NULL, NULL, 9705, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 16:33:12', 'admin-1496213320-14962195920488385', 1, 1, 'SR', NULL, NULL, NULL),
(32177, '2017-05-31 13:44:27', NULL, NULL, 9689, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:44:27', 'admin-1496207371-14962094671284856', 1, 0, '', NULL, NULL, NULL),
(32178, '2017-05-31 13:45:42', NULL, NULL, 9692, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:45:42', 'admin-1496207371-1496209542365336', 1, 1, 'SR', 1, NULL, NULL),
(32179, '2017-05-31 13:44:17', NULL, NULL, 9689, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:44:17', 'admin-1496207371-14962094570108127', 1, 1, 'SR', NULL, NULL, NULL),
(32180, '2017-05-31 13:15:47', NULL, NULL, 9689, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:15:47', 'admin-1496207371-14962077468524936', 1, 0, '', NULL, NULL, NULL),
(32181, '2017-05-31 13:15:47', NULL, NULL, 9689, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:15:47', 'admin-1496207371-14962077468524936', 1, 1, 'SR', NULL, NULL, NULL),
(32182, '2017-05-31 13:15:47', NULL, NULL, 9689, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:15:47', 'admin-1496207371-14962077468524936', 1, 0, '', NULL, NULL, NULL),
(32183, '2017-05-31 13:13:26', NULL, NULL, 9689, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:13:26', 'admin-1496207371-14962076058744518', 1, 0, '', NULL, NULL, NULL),
(32184, '2017-05-31 13:09:21', NULL, NULL, 9688, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:09:21', 'admin-1496199128-14962073613012040', 1, 1, 'SR', NULL, NULL, NULL),
(32185, '2017-05-31 13:09:21', NULL, NULL, 9688, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:09:21', 'admin-1496199128-14962073613012040', 1, 1, 'SR', NULL, NULL, NULL),
(32186, '2017-05-31 13:09:21', NULL, NULL, 9688, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:09:21', 'admin-1496199128-14962073613012040', 1, 0, '', NULL, NULL, NULL),
(32187, '2017-05-31 13:09:21', NULL, NULL, 9688, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:09:21', 'admin-1496199128-14962073613012040', 1, 0, '', NULL, NULL, NULL),
(32188, '2017-05-31 13:09:21', NULL, NULL, 9688, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:09:21', 'admin-1496199128-14962073613012040', 1, 0, '', NULL, NULL, NULL),
(32189, '2017-05-31 13:08:56', NULL, NULL, 9688, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.60, 0.0000, 0.0000, 9.60, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:08:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32190, '2017-05-31 13:09:21', NULL, NULL, 9688, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:09:21', 'admin-1496199128-14962073613012040', 1, 1, 'SR', NULL, NULL, NULL),
(32191, '2017-05-31 13:05:54', NULL, NULL, 9687, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:05:54', 'admin-1496199128-14962071540575198', 1, 1, 'SR', NULL, NULL, NULL),
(32192, '2017-05-31 13:05:54', NULL, NULL, 9687, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:05:54', 'admin-1496199128-14962071540575198', 1, 0, '', NULL, NULL, NULL),
(32193, '2017-05-31 13:05:54', NULL, NULL, 9687, 0, 73, '73', 'Marmite Chicken ', 'mashed potato', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:05:54', 'admin-1496199128-14962071540575198', 1, 1, 'SR', NULL, NULL, NULL),
(32194, '2017-05-31 13:04:51', NULL, NULL, 9687, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:04:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32195, '2017-05-31 13:04:01', NULL, NULL, 9686, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:04:01', 'admin-1496199128-14962070408768687', 1, 0, '', NULL, NULL, NULL),
(32196, '2017-05-31 13:03:30', NULL, NULL, 9686, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1496213320', 'admin', '2017-05-31 13:03:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32197, '2017-05-31 12:56:02', NULL, NULL, 9685, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 12:56:02', 'admin-1496199128-14962065625033468', 1, 1, 'SR', NULL, NULL, NULL),
(32198, '2017-05-31 12:56:02', NULL, NULL, 9685, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 12:56:02', 'admin-1496199128-14962065625033468', 1, 1, 'SR', NULL, NULL, NULL),
(32199, '2017-05-31 12:55:56', NULL, NULL, 9685, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1496213320', 'admin', '2017-05-31 12:55:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32200, '2017-05-31 11:46:59', NULL, NULL, 9684, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 11:46:59', 'admin-1496199128-14962024195968283', 1, 0, '', NULL, NULL, NULL),
(32201, '2017-05-31 11:46:59', NULL, NULL, 9684, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 11:46:59', 'admin-1496199128-14962024195968283', 1, 1, 'SR', NULL, NULL, NULL),
(32202, '2017-05-31 11:58:27', NULL, NULL, 9684, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 11:58:27', 'admin-1496199128-1496203107048265', 1, 1, 'SR', NULL, NULL, NULL),
(32203, '2017-05-31 10:50:22', NULL, NULL, 9682, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1496213320', 'admin', '2017-05-31 10:50:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32204, '2017-05-31 10:50:33', NULL, NULL, 9682, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 10:50:33', 'admin-1496192352-14961990337625650', 1, 0, '', NULL, NULL, NULL),
(32205, '2017-05-31 10:50:33', NULL, NULL, 9682, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 10:50:33', 'admin-1496192352-14961990337625650', 1, 0, '', NULL, NULL, NULL),
(32206, '2017-05-31 10:50:33', NULL, NULL, 9682, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 10:50:33', 'admin-1496192352-14961990337625650', 1, 1, 'SR', NULL, NULL, NULL),
(32207, '2017-05-31 10:02:58', NULL, NULL, 9678, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 10:02:58', 'admin-1496192352-1496196178213763', 1, 0, '', NULL, NULL, NULL),
(32208, '2017-05-31 10:02:58', NULL, NULL, 9678, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 10:02:58', 'admin-1496192352-1496196178213763', 1, 1, 'SR', NULL, NULL, NULL),
(32209, '2017-05-31 10:17:11', NULL, NULL, 9679, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1496213320', 'admin', '2017-05-31 10:17:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32210, '2017-05-31 10:17:16', NULL, NULL, 9679, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 10:17:16', 'admin-1496192352-14961970363309226', 1, 0, '', NULL, NULL, NULL),
(32211, '2017-05-31 10:40:59', NULL, NULL, 9680, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1496213320', 'admin', '2017-05-31 10:40:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32212, '2017-05-31 10:41:10', NULL, NULL, 9680, 0, 280, '214', 'Diet Meal - Piccolo / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 10:41:10', 'admin-1496192352-14961984697856745', 1, 0, '', NULL, NULL, NULL),
(32213, '2017-05-31 10:41:10', NULL, NULL, 9680, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 10:41:10', 'admin-1496192352-14961984697856745', 1, 0, '', NULL, NULL, NULL),
(32214, '2017-05-31 10:41:10', NULL, NULL, 9680, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 10:41:10', 'admin-1496192352-14961984697856745', 1, 0, '', NULL, NULL, NULL),
(32215, '2017-05-31 10:47:52', NULL, NULL, 9681, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1496213320', 'admin', '2017-05-31 10:47:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32216, '2017-05-31 10:47:56', NULL, NULL, 9681, 0, 281, '215', 'Weight Gain Deal - Latte / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 10:47:56', 'admin-1496192352-14961988759198443', 1, 0, '', NULL, NULL, NULL),
(32217, '2017-05-31 10:47:56', NULL, NULL, 9681, 0, 280, '214', 'Diet Meal - Piccolo / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 10:47:56', 'admin-1496192352-14961988759198443', 1, 0, '', NULL, NULL, NULL),
(32218, '2017-05-31 11:46:07', NULL, NULL, 9684, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1496213320', 'admin', '2017-05-31 11:46:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32219, '2017-05-31 11:44:00', NULL, NULL, 9683, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 11:44:00', 'admin-1496199128-14962022399418899', 1, 1, 'SR', NULL, NULL, NULL),
(32220, '2017-05-31 11:30:23', NULL, NULL, 9682, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 11:30:23', 'admin-1496199128-14962014232484079', 1, 0, '', NULL, NULL, NULL),
(32221, '2017-05-31 10:50:33', NULL, NULL, 9682, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 10:50:33', 'admin-1496192352-14961990337625650', 1, 0, '', NULL, NULL, NULL),
(32222, '2017-05-31 09:06:53', NULL, NULL, 9675, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 09:06:53', 'admin-1496192352-14961928135465161', 1, 0, '', NULL, NULL, NULL),
(32223, '2017-05-31 09:06:58', NULL, NULL, 9676, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1496213320', 'admin', '2017-05-31 09:06:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32224, '2017-05-31 09:07:05', NULL, NULL, 9676, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 09:07:05', 'admin-1496192352-14961928256163996', 1, 0, '', NULL, NULL, NULL),
(32225, '2017-05-31 10:41:10', NULL, NULL, 9680, 0, 280, '214', 'Diet Meal - Piccolo / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 10:41:10', 'admin-1496192352-14961984697856745', 1, 0, '', NULL, NULL, NULL),
(32226, '2017-05-31 10:41:10', NULL, NULL, 9680, 0, 282, '216', 'Weight Gain Deal - Cappucino / Junior BLT', '', 'Meals', 'Morning Bites ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 10:41:10', 'admin-1496192352-14961984697856745', 1, 0, '', NULL, NULL, NULL),
(32227, '2017-05-31 10:02:49', NULL, NULL, 9678, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1496213320', 'admin', '2017-05-31 10:02:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32228, '2017-05-31 09:51:05', NULL, NULL, 9677, 0, 279, '213', 'Diet Meal - Americano / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 09:51:05', 'admin-1496192352-14961954653662921', 1, 0, '', NULL, NULL, NULL),
(32229, '2017-05-31 09:51:00', NULL, NULL, 9677, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1496213320', 'admin', '2017-05-31 09:51:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32230, '2017-05-31 09:07:05', NULL, NULL, 9676, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496213320', 'admin', '2017-05-31 09:07:05', 'admin-1496192352-14961928256163996', 1, 1, 'SR', NULL, NULL, NULL),
(32231, '2017-05-31 09:06:46', NULL, NULL, 9675, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1496213320', 'admin', '2017-05-31 09:06:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32232, '2017-06-01 15:17:25', NULL, NULL, 9727, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1496284576', 'admin', '2017-06-01 15:17:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32233, '2017-06-01 15:17:53', NULL, NULL, 9727, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 15:17:53', 'admin-1496284576-14963014735622853', 1, 1, 'SR', NULL, NULL, NULL),
(32234, '2017-06-01 15:18:01', NULL, NULL, 9727, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 15:18:01', 'admin-1496284576-14963014817647752', 1, 1, 'SR', NULL, NULL, NULL),
(32235, '2017-06-01 10:35:56', NULL, NULL, 9715, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.50, 0.0000, 0.0000, 12.50, 1, '27', 1, '1496284576', 'admin', '2017-06-01 10:35:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32236, '2017-06-01 11:16:51', NULL, NULL, 9717, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 11:16:51', 'admin-1496284576-14962870113231666', 1, 0, '', NULL, NULL, NULL),
(32237, '2017-06-01 11:16:51', NULL, NULL, 9717, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 11:16:51', 'admin-1496284576-14962870113231666', 1, 0, '', NULL, NULL, NULL),
(32238, '2017-06-01 16:05:23', NULL, NULL, 9730, 0, 181, '116', 'Open Food ', 'caramel cookies', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 16:05:23', 'admin-1496284576-14963043235924898', 1, 0, '', 1, NULL, NULL),
(32239, '2017-06-01 13:07:12', NULL, NULL, 9724, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 13:07:12', 'admin-1496284576-14962936322846746', 1, 0, '', NULL, NULL, NULL),
(32240, '2017-06-01 14:02:58', NULL, NULL, 9726, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 14:02:58', 'admin-1496284576-1496296978608622', 1, 1, 'SR', 1, NULL, NULL),
(32241, '2017-06-01 14:02:58', NULL, NULL, 9726, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 14:02:58', 'admin-1496284576-1496296978608622', 1, 1, 'SR', 1, NULL, NULL),
(32242, '2017-06-01 00:00:00', NULL, NULL, 9719, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, NULL, NULL, 6.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 10:30:02', 'admin-1496279057-14962842024321928', 1, 1, 'SR', NULL, NULL, NULL),
(32243, '2017-06-01 11:28:42', NULL, NULL, 9720, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 11:28:42', 'admin-1496284576-14962877225357692', 1, 1, 'SR', NULL, NULL, NULL),
(32244, '2017-06-01 09:30:28', NULL, NULL, 9709, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1496284576', 'admin', '2017-06-01 09:30:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32245, '2017-06-01 11:11:47', NULL, NULL, 9716, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 11:11:47', 'admin-1496284576-14962867073971816', 1, 1, 'SR', NULL, NULL, NULL),
(32246, '2017-06-01 12:55:29', NULL, NULL, 9722, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 12:55:29', 'admin-1496284576-1496292929349244', 1, 0, '', NULL, NULL, NULL),
(32247, '2017-06-01 12:55:29', NULL, NULL, 9722, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 12:55:29', 'admin-1496284576-1496292929349244', 1, 1, 'SR', NULL, NULL, NULL),
(32248, '2017-06-01 13:02:06', NULL, NULL, 9723, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1496284576', 'admin', '2017-06-01 13:02:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32249, '2017-06-01 13:02:20', NULL, NULL, 9723, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 13:02:20', 'admin-1496284576-14962933402821271', 1, 0, '', NULL, NULL, NULL),
(32250, '2017-06-01 13:02:20', NULL, NULL, 9723, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 13:02:20', 'admin-1496284576-14962933402821271', 1, 0, '', NULL, NULL, NULL),
(32251, '2017-06-01 13:02:20', NULL, NULL, 9723, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 2, 11.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 13:02:20', 'admin-1496284576-14962933402821271', 1, 0, '', NULL, NULL, NULL),
(32252, '2017-06-01 13:06:47', NULL, NULL, 9724, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.30, 0.0000, 0.0000, 10.30, 1, '27', 1, '1496284576', 'admin', '2017-06-01 13:06:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32253, '2017-06-01 13:41:23', NULL, NULL, 9725, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.50, 0.0000, 0.0000, 11.50, 1, '27', 1, '1496284576', 'admin', '2017-06-01 13:41:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32254, '2017-06-01 13:42:25', NULL, NULL, 9725, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 13:42:25', 'admin-1496284576-14962957449273527', 1, 1, 'SR', NULL, NULL, NULL),
(32255, '2017-06-01 13:42:25', NULL, NULL, 9725, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 13:42:25', 'admin-1496284576-14962957449273527', 1, 0, '', NULL, NULL, NULL),
(32256, '2017-06-01 13:42:25', NULL, NULL, 9725, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 13:42:25', 'admin-1496284576-14962957449273527', 1, 1, 'SR', NULL, NULL, NULL),
(32257, '2017-06-01 13:42:25', NULL, NULL, 9725, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 13:42:25', 'admin-1496284576-14962957449273527', 1, 1, 'SR', NULL, NULL, NULL),
(32258, '2017-06-01 13:42:25', NULL, NULL, 9725, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 13:42:25', 'admin-1496284576-14962957449273527', 1, 0, '', NULL, NULL, NULL),
(32259, '2017-06-01 13:42:25', NULL, NULL, 9725, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 13:42:25', 'admin-1496284576-14962957449273527', 1, 0, '', NULL, NULL, NULL),
(32260, '2017-06-01 13:42:25', NULL, NULL, 9725, 0, 181, '116', 'Open Food ', 'Mummy''s Pork Chop', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 13:42:25', 'admin-1496284576-14962957449273527', 1, 0, '', NULL, NULL, NULL),
(32261, '2017-06-01 00:00:00', NULL, NULL, 9718, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 10:35:23', 'admin-1496279057-14962845230311011', 1, 0, '', NULL, NULL, NULL),
(32262, '2017-06-01 15:40:20', NULL, NULL, 9727, 0, 181, '116', 'Open Food ', 'Scone promo', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 15:40:20', 'admin-1496284576-14963028203838958', 1, 0, '', NULL, NULL, NULL),
(32263, '2017-06-01 15:34:39', NULL, NULL, 9729, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 15:34:39', 'admin-1496284576-14963024788274863', 1, 1, 'SR', 1, NULL, NULL),
(32264, '2017-06-01 11:44:19', NULL, NULL, 9721, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 11:44:19', 'admin-1496284576-14962886597393399', 1, 0, '', NULL, NULL, NULL),
(32265, '2017-06-01 11:44:19', NULL, NULL, 9721, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 11:44:19', 'admin-1496284576-14962886597393399', 1, 1, 'SR', NULL, NULL, NULL),
(32266, '2017-06-01 13:07:12', NULL, NULL, 9724, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 13:07:12', 'admin-1496284576-14962936322846746', 1, 1, 'SR', NULL, NULL, NULL),
(32267, '2017-06-01 13:07:12', NULL, NULL, 9724, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 13:07:12', 'admin-1496284576-14962936322846746', 1, 0, '', NULL, NULL, NULL),
(32268, '2017-06-01 13:07:12', NULL, NULL, 9724, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 13:07:12', 'admin-1496284576-14962936322846746', 1, 0, '', NULL, NULL, NULL),
(32269, '2017-06-01 16:05:23', NULL, NULL, 9730, 0, 181, '116', 'Open Food ', 'baked mashed potato', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 16:05:23', 'admin-1496284576-14963043235924898', 1, 0, '', 1, NULL, NULL),
(32270, '2017-06-01 15:34:39', NULL, NULL, 9729, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 15:34:39', 'admin-1496284576-14963024788274863', 1, 1, 'SR', 1, NULL, NULL),
(32271, '2017-06-01 14:25:44', NULL, NULL, 9724, 0, 181, '116', 'Open Food ', 'Scone Promo', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 14:25:44', 'admin-1496284576-14962983442661322', 1, 0, '', NULL, NULL, NULL),
(32272, '2017-06-01 14:25:59', NULL, NULL, 9725, 0, 181, '116', 'Open Food ', 'Scone Promo', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 14:25:59', 'admin-1496284576-14962983596652085', 1, 0, '', NULL, NULL, NULL),
(32273, '2017-06-01 14:34:29', NULL, NULL, 9725, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 14:34:29', 'admin-1496284576-14962988694377226', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(32274, '2017-06-01 14:22:59', NULL, NULL, 9724, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 14:22:59', 'admin-1496284576-14962981789125164', 1, 0, '', NULL, NULL, NULL),
(32275, '2017-06-01 13:07:12', NULL, NULL, 9724, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 13:07:12', 'admin-1496284576-14962936322846746', 1, 0, '', NULL, NULL, NULL),
(32276, '2017-06-01 11:28:42', NULL, NULL, 9720, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 11:28:42', 'admin-1496284576-14962877225357692', 1, 1, 'SR', NULL, NULL, NULL),
(32277, '2017-06-01 11:44:14', NULL, NULL, 9721, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1496284576', 'admin', '2017-06-01 11:44:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32278, '2017-06-01 11:17:07', NULL, NULL, 9717, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 11:17:07', 'admin-1496284576-14962870274087118', 1, 1, 'SR', NULL, NULL, NULL),
(32279, '2017-06-01 11:17:07', NULL, NULL, 9717, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 11:17:07', 'admin-1496284576-14962870274087118', 1, 1, 'SR', NULL, NULL, NULL),
(32280, '2017-06-01 10:36:11', NULL, NULL, 9715, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 10:36:11', 'admin-1496279057-14962845713475683', 1, 0, '', NULL, NULL, NULL),
(32281, '2017-06-01 10:36:11', NULL, NULL, 9715, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 10:36:11', 'admin-1496279057-14962845713475683', 1, 0, '', NULL, NULL, NULL),
(32282, '2017-06-01 10:36:11', NULL, NULL, 9715, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 10:36:11', 'admin-1496279057-14962845713475683', 1, 0, '', NULL, NULL, NULL),
(32283, '2017-06-01 10:36:11', NULL, NULL, 9715, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 10:36:11', 'admin-1496279057-14962845713475683', 1, 0, '', NULL, NULL, NULL),
(32284, '2017-06-01 10:36:11', NULL, NULL, 9715, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 10:36:11', 'admin-1496279057-14962845713475683', 1, 0, '', NULL, NULL, NULL),
(32285, '2017-06-01 10:36:32', NULL, NULL, 9715, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 10:36:32', 'admin-1496284576-14962845926191458', 1, 1, 'SR', NULL, NULL, NULL),
(32286, '2017-06-01 10:36:32', NULL, NULL, 9715, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 10:36:32', 'admin-1496284576-14962845926191458', 1, 1, 'SR', NULL, NULL, NULL),
(32287, '2017-06-01 11:11:29', NULL, NULL, 9716, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1496284576', 'admin', '2017-06-01 11:11:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32288, '2017-06-01 11:11:47', NULL, NULL, 9716, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 2, 16.00, 32.0000, 0.0000, 32.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 11:11:47', 'admin-1496284576-14962867073971816', 1, 0, '', NULL, NULL, NULL),
(32289, '2017-06-01 00:00:00', NULL, NULL, 9719, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, NULL, NULL, 2.10, 1, '27', 1, '1496284576', 'admin', '2017-06-01 10:29:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32290, '2017-06-01 11:28:35', NULL, NULL, 9720, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1496284576', 'admin', '2017-06-01 11:28:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32291, '2017-06-01 00:00:00', NULL, NULL, 9719, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 10:30:02', 'admin-1496279057-14962842024321928', 1, 0, '', NULL, NULL, NULL),
(32292, '2017-06-01 11:19:09', NULL, NULL, 9718, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1496284576', 'admin', '2017-06-01 11:19:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32293, '2017-06-01 11:16:51', NULL, NULL, 9717, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 11:16:51', 'admin-1496284576-14962870113231666', 1, 0, '', NULL, NULL, NULL),
(32294, '2017-06-01 11:16:51', NULL, NULL, 9717, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 11:16:51', 'admin-1496284576-14962870113231666', 1, 0, '', NULL, NULL, NULL),
(32295, '2017-06-01 12:55:24', NULL, NULL, 9722, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1496284576', 'admin', '2017-06-01 12:55:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32296, '2017-06-01 11:16:28', NULL, NULL, 9717, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1496284576', 'admin', '2017-06-01 11:16:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32297, '2017-06-01 09:48:09', NULL, NULL, 9710, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 09:48:09', 'admin-1496279057-14962816890038370', 1, 0, '', NULL, NULL, NULL),
(32298, '2017-06-01 09:48:09', NULL, NULL, 9710, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 09:48:09', 'admin-1496279057-14962816890038370', 1, 1, 'SR', NULL, NULL, NULL),
(32299, '2017-06-01 09:49:29', NULL, NULL, 9711, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1496284576', 'admin', '2017-06-01 09:49:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32300, '2017-06-01 09:49:41', NULL, NULL, 9711, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 09:49:41', 'admin-1496279057-14962817818252831', 1, 0, '', NULL, NULL, NULL),
(32301, '2017-06-01 09:49:42', NULL, NULL, 9711, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 09:49:42', 'admin-1496279057-14962817818252831', 1, 0, '', NULL, NULL, NULL),
(32302, '2017-06-01 09:49:42', NULL, NULL, 9711, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 09:49:42', 'admin-1496279057-14962817818252831', 1, 1, 'SR', NULL, NULL, NULL),
(32303, '2017-06-01 09:49:46', NULL, NULL, 9710, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 09:49:46', 'admin-1496279057-14962817863446852', 1, 1, 'SR', NULL, NULL, NULL),
(32304, '2017-06-01 09:50:06', NULL, NULL, 9712, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1496284576', 'admin', '2017-06-01 09:50:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32305, '2017-06-01 09:50:18', NULL, NULL, 9712, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 09:50:18', 'admin-1496279057-14962818183865349', 1, 0, '', NULL, NULL, NULL),
(32306, '2017-06-01 09:50:18', NULL, NULL, 9712, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 09:50:18', 'admin-1496279057-14962818183865349', 1, 0, '', NULL, NULL, NULL),
(32307, '2017-06-01 10:02:41', NULL, NULL, 9713, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1496284576', 'admin', '2017-06-01 10:02:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32308, '2017-06-01 10:02:49', NULL, NULL, 9713, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 10:02:49', 'admin-1496279057-14962825688237686', 1, 0, '', NULL, NULL, NULL),
(32309, '2017-06-01 10:02:49', NULL, NULL, 9713, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 10:02:49', 'admin-1496279057-14962825688237686', 1, 0, '', NULL, NULL, NULL),
(32310, '2017-06-01 10:27:32', NULL, NULL, 9713, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 10:27:32', 'admin-1496279057-1496284051827349', 1, 0, '', NULL, NULL, NULL),
(32311, '2017-06-01 09:30:33', NULL, NULL, 9709, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 09:30:33', 'admin-1496279057-14962806329938511', 1, 1, 'SR', NULL, NULL, NULL),
(32312, '2017-06-01 09:47:56', NULL, NULL, 9710, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1496284576', 'admin', '2017-06-01 09:47:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32313, '2017-06-01 09:48:01', NULL, NULL, 9710, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 09:48:01', 'admin-1496279057-14962816815678342', 1, 0, '', NULL, NULL, NULL),
(32314, '2017-06-01 09:25:41', NULL, NULL, 9708, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 09:25:41', 'admin-1496279057-14962803408718742', 1, 1, 'SR', NULL, NULL, NULL),
(32315, '2017-06-01 09:25:41', NULL, NULL, 9708, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496284576', 'admin', '2017-06-01 09:25:41', 'admin-1496279057-14962803408718742', 1, 1, 'SR', NULL, NULL, NULL),
(32316, '2017-06-01 09:21:06', NULL, NULL, 9708, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1496284576', 'admin', '2017-06-01 09:21:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32317, '2017-06-02 13:52:12', NULL, NULL, 9755, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 13:52:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32318, '2017-06-02 13:52:17', NULL, NULL, 9755, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 13:52:17', 'admin-1496372633-14963827371986779', 1, 1, 'SR', NULL, NULL, NULL),
(32319, '2017-06-02 13:34:06', NULL, NULL, 9752, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 13:34:06', 'admin-1496372633-14963816465758196', 1, 1, 'SR', NULL, NULL, NULL),
(32320, '2017-06-02 13:22:55', NULL, NULL, 9753, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 13:22:55', 'admin-1496372633-14963809754238951', 1, 0, '', NULL, NULL, NULL),
(32321, '2017-06-02 13:22:55', NULL, NULL, 9753, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 13:22:55', 'admin-1496372633-14963809754238951', 1, 1, 'SR', NULL, NULL, NULL),
(32322, '2017-06-02 13:50:50', NULL, NULL, 9752, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 13:50:50', 'admin-1496372633-14963826505035311', 1, 0, '', NULL, NULL, NULL),
(32323, '2017-06-02 13:50:50', NULL, NULL, 9752, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 13:50:50', 'admin-1496372633-14963826505035311', 1, 1, 'SR', NULL, NULL, NULL),
(32324, '2017-06-02 15:43:24', NULL, NULL, 9756, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 15:43:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32325, '2017-06-02 15:43:52', NULL, NULL, 9756, 0, 181, '116', 'Open Food ', 'Scone promo', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 15:43:52', 'admin-1496372633-14963894318637456', 1, 0, '', NULL, NULL, NULL),
(32326, '2017-06-02 15:43:52', NULL, NULL, 9756, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 15:43:52', 'admin-1496372633-14963894318637456', 1, 1, 'SR', NULL, NULL, NULL),
(32327, '2017-06-02 15:43:52', NULL, NULL, 9756, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 15:43:52', 'admin-1496372633-14963894318637456', 1, 1, 'SR', NULL, NULL, NULL),
(32328, '2017-06-02 13:22:55', NULL, NULL, 9753, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 13:22:55', 'admin-1496372633-14963809754238951', 1, 1, 'SR', NULL, NULL, NULL),
(32329, '2017-06-02 10:40:17', NULL, NULL, 9737, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:40:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32330, '2017-06-02 10:40:22', NULL, NULL, 9737, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:40:22', 'admin-1496364303-14963712226029852', 1, 1, 'SR', NULL, NULL, NULL),
(32331, '2017-06-02 10:40:22', NULL, NULL, 9737, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:40:22', 'admin-1496364303-14963712226029852', 1, 0, '', NULL, NULL, NULL),
(32332, '2017-06-02 13:04:01', NULL, NULL, 9751, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 13:04:01', 'admin-1496372633-14963798411971738', 1, 1, 'SR', NULL, NULL, NULL),
(32333, '2017-06-02 13:04:01', NULL, NULL, 9751, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 13:04:01', 'admin-1496372633-14963798411971738', 1, 1, 'SR', NULL, NULL, NULL),
(32334, '2017-06-02 13:04:01', NULL, NULL, 9751, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 13:04:01', 'admin-1496372633-14963798411971738', 1, 1, 'SR', NULL, NULL, NULL),
(32335, '2017-06-02 13:05:07', NULL, NULL, 9751, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 13:05:07', 'admin-1496372633-14963799072358571', 1, 1, 'SR', NULL, NULL, NULL),
(32336, '2017-06-02 13:05:07', NULL, NULL, 9751, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 13:05:07', 'admin-1496372633-14963799072358571', 1, 1, 'SR', NULL, NULL, NULL),
(32337, '2017-06-02 13:20:50', NULL, NULL, 9752, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.20, 0.0000, 0.0000, 9.20, 1, '27', 1, '1496372633', 'admin', '2017-06-02 13:20:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32338, '2017-06-02 13:21:03', NULL, NULL, 9752, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 13:21:03', 'admin-1496372633-14963808628235054', 1, 0, '', NULL, NULL, NULL),
(32339, '2017-06-02 13:21:11', NULL, NULL, 9752, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 13:21:11', 'admin-1496372633-14963808711495769', 1, 1, 'SR', NULL, NULL, NULL),
(32340, '2017-06-02 13:21:18', NULL, NULL, 9753, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1496372633', 'admin', '2017-06-02 13:21:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32341, '2017-06-02 12:37:34', NULL, NULL, 9749, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:37:34', 'admin-1496372633-1496378254232198', 1, 1, 'SR', NULL, NULL, NULL),
(32342, '2017-06-02 16:13:32', NULL, NULL, 9757, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 16:13:32', 'admin-1496372633-14963912124948374', 1, 1, 'SR', 1, NULL, NULL),
(32343, '2017-06-02 16:13:32', NULL, NULL, 9757, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 16:13:32', 'admin-1496372633-14963912124948374', 1, 1, 'SR', 1, NULL, NULL),
(32344, '2017-06-02 16:14:09', NULL, NULL, 9757, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 16:14:09', 'admin-1496372633-14963912493437762', 1, 0, '', 1, NULL, NULL),
(32345, '2017-06-02 16:23:27', NULL, NULL, 9758, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 16:23:27', 'admin-1496372633-14963918072946254', 1, 1, 'SR', NULL, NULL, NULL),
(32346, '2017-06-02 16:37:08', NULL, NULL, 9759, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1496372633', 'admin', '2017-06-02 16:37:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32347, '2017-06-02 16:37:18', NULL, NULL, 9759, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 16:37:18', 'admin-1496372633-14963926382318742', 1, 0, '', NULL, NULL, NULL),
(32348, '2017-06-02 16:37:18', NULL, NULL, 9759, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 16:37:18', 'admin-1496372633-14963926382318742', 1, 1, 'SR', NULL, NULL, NULL),
(32349, '2017-06-02 16:37:18', NULL, NULL, 9759, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 16:37:18', 'admin-1496372633-14963926382318742', 1, 1, 'SR', NULL, NULL, NULL),
(32350, '2017-06-02 16:37:18', NULL, NULL, 9759, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 16:37:18', 'admin-1496372633-14963926382318742', 1, 1, 'SR', NULL, NULL, NULL),
(32351, '2017-06-02 16:23:23', NULL, NULL, 9758, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1496372633', 'admin', '2017-06-02 16:23:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32352, '2017-06-02 17:40:32', NULL, NULL, 9761, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 17:40:32', 'admin-1496372633-14963964323072217', 1, 1, 'SR', NULL, NULL, NULL),
(32353, '2017-06-02 17:40:29', NULL, NULL, 9761, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 17:40:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32354, '2017-06-02 17:19:10', NULL, NULL, 9760, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1496372633', 'admin', '2017-06-02 17:19:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32355, '2017-06-02 17:19:15', NULL, NULL, 9760, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 17:19:15', 'admin-1496372633-14963951552086294', 1, 0, '', NULL, NULL, NULL),
(32356, '2017-06-02 09:14:56', NULL, NULL, 9731, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 09:14:56', 'admin-1496364303-14963660966175058', 1, 0, '', NULL, NULL, NULL),
(32357, '2017-06-02 12:37:43', NULL, NULL, 9749, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:37:43', 'admin-1496372633-14963782632152525', 1, 1, 'SR', NULL, NULL, NULL),
(32358, '2017-06-02 12:02:54', NULL, NULL, 9746, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 2, 11.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:02:54', 'admin-1496372633-1496376174431710', 1, 1, 'SR', 1, NULL, NULL),
(32359, '2017-06-02 12:03:02', NULL, NULL, 9747, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:03:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32360, '2017-06-02 12:03:23', NULL, NULL, 9747, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:03:23', 'admin-1496372633-14963762027686456', 1, 1, 'SR', NULL, NULL, NULL),
(32361, '2017-06-02 12:16:49', NULL, NULL, 9747, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:16:49', 'admin-1496372633-14963770091605472', 1, 0, '', NULL, NULL, NULL),
(32362, '2017-06-02 12:03:29', NULL, NULL, 9747, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:03:29', 'admin-1496372633-14963762095455743', 1, 0, '', NULL, NULL, NULL),
(32363, '2017-06-02 12:03:29', NULL, NULL, 9747, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:03:29', 'admin-1496372633-14963762095455743', 1, 0, '', NULL, NULL, NULL),
(32364, '2017-06-02 12:04:17', NULL, NULL, 9748, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:04:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32365, '2017-06-02 10:48:38', NULL, NULL, 9738, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:48:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32366, '2017-06-02 10:48:49', NULL, NULL, 9738, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:48:49', 'admin-1496364303-14963717293738641', 1, 0, '', NULL, NULL, NULL),
(32367, '2017-06-02 10:48:49', NULL, NULL, 9738, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:48:49', 'admin-1496364303-14963717293738641', 1, 0, '', NULL, NULL, NULL),
(32368, '2017-06-02 10:48:49', NULL, NULL, 9738, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:48:49', 'admin-1496364303-14963717293738641', 1, 0, '', NULL, NULL, NULL),
(32369, '2017-06-02 10:48:49', NULL, NULL, 9738, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:48:49', 'admin-1496364303-14963717293738641', 1, 1, 'SR', NULL, NULL, NULL),
(32370, '2017-06-02 10:50:14', NULL, NULL, 9735, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:50:14', 'admin-1496364303-14963718146899984', 1, 0, '', NULL, NULL, NULL),
(32371, '2017-06-02 00:00:00', NULL, NULL, 9745, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, NULL, NULL, 1.40, 1, '27', 1, '1496372633', 'admin', '2017-06-02 11:31:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32372, '2017-06-02 12:01:02', NULL, NULL, 9744, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:01:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32373, '2017-06-02 11:59:19', NULL, NULL, 9742, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1496372633', 'admin', '2017-06-02 11:59:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32374, '2017-06-02 12:00:26', NULL, NULL, 9743, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:00:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32375, '2017-06-02 00:00:00', NULL, NULL, 9742, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 11:31:52', 'admin-1496372633-14963743125033026', 1, 1, 'SR', NULL, NULL, NULL),
(32376, '2017-06-02 00:00:00', NULL, NULL, 9743, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 11:59:01', 'admin-1496372633-14963759418235585', 1, 1, 'SR', NULL, NULL, NULL),
(32377, '2017-06-02 00:00:00', NULL, NULL, 9744, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 11:31:52', 'admin-1496372633-14963743125033026', 1, 1, 'SR', NULL, NULL, NULL),
(32378, '2017-06-02 00:00:00', NULL, NULL, 9745, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 11:31:52', 'admin-1496372633-14963743125033026', 1, 1, 'SR', NULL, NULL, NULL),
(32379, '2017-06-02 10:59:36', NULL, NULL, 9733, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:59:36', 'admin-1496364303-1496372376276481', 1, 1, 'SR', NULL, NULL, NULL),
(32380, '2017-06-02 11:02:48', NULL, NULL, 9735, 0, 181, '116', 'Open Food ', 'scone promo', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 11:02:48', 'admin-1496364303-14963725681363878', 1, 0, '', NULL, NULL, NULL),
(32381, '2017-06-02 11:04:00', NULL, NULL, 9739, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1496372633', 'admin', '2017-06-02 11:04:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32382, '2017-06-02 13:21:25', NULL, NULL, 9753, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 13:21:25', 'admin-1496372633-14963808854523937', 1, 0, '', NULL, NULL, NULL),
(32383, '2017-06-02 13:03:33', NULL, NULL, 9751, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1496372633', 'admin', '2017-06-02 13:03:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32384, '2017-06-02 12:49:58', NULL, NULL, 9750, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:49:58', 'admin-1496372633-1496378997930161', 1, 1, 'SR', NULL, NULL, NULL),
(32385, '2017-06-02 12:51:34', NULL, NULL, 9750, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:51:34', 'admin-1496372633-14963790944165915', 1, 0, '', NULL, NULL, NULL),
(32386, '2017-06-02 12:51:34', NULL, NULL, 9750, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:51:34', 'admin-1496372633-14963790944165915', 1, 1, 'SR', NULL, NULL, NULL),
(32387, '2017-06-02 12:51:50', NULL, NULL, 9750, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:51:50', 'admin-1496372633-14963791100337618', 1, 0, '', NULL, NULL, NULL),
(32388, '2017-06-02 12:53:29', NULL, NULL, 9750, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:53:29', 'admin-1496372633-14963792093157935', 1, 1, 'SR', NULL, NULL, NULL),
(32389, '2017-06-02 12:49:58', NULL, NULL, 9750, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:49:58', 'admin-1496372633-1496378997930161', 1, 1, 'SR', NULL, NULL, NULL),
(32390, '2017-06-02 12:37:43', NULL, NULL, 9749, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:37:43', 'admin-1496372633-14963782632152525', 1, 0, '', NULL, NULL, NULL),
(32391, '2017-06-02 11:04:04', NULL, NULL, 9739, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 11:04:04', 'admin-1496372633-14963726444849573', 1, 1, 'SR', NULL, NULL, NULL),
(32392, '2017-06-02 11:20:17', NULL, NULL, 9740, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1496372633', 'admin', '2017-06-02 11:20:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32393, '2017-06-02 11:20:27', NULL, NULL, 9740, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 11:20:27', 'admin-1496372633-14963736274758931', 1, 0, '', NULL, NULL, NULL),
(32394, '2017-06-02 11:20:27', NULL, NULL, 9740, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 11:20:27', 'admin-1496372633-14963736274758931', 1, 0, '', NULL, NULL, NULL),
(32395, '2017-06-02 11:20:27', NULL, NULL, 9740, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 11:20:27', 'admin-1496372633-14963736274758931', 1, 0, '', NULL, NULL, NULL),
(32396, '2017-06-02 11:20:27', NULL, NULL, 9740, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 11:20:27', 'admin-1496372633-14963736274758931', 1, 1, 'SR', NULL, NULL, NULL),
(32397, '2017-06-02 11:20:27', NULL, NULL, 9740, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 11:20:27', 'admin-1496372633-14963736274758931', 1, 1, 'SR', NULL, NULL, NULL),
(32398, '2017-06-02 10:36:25', NULL, NULL, 9736, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:36:25', 'admin-1496364303-14963709849769916', 1, 1, 'SR', NULL, NULL, NULL),
(32399, '2017-06-02 10:36:25', NULL, NULL, 9736, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:36:25', 'admin-1496364303-14963709849769916', 1, 0, '', NULL, NULL, NULL),
(32400, '2017-06-02 10:36:25', NULL, NULL, 9736, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:36:25', 'admin-1496364303-14963709849769916', 1, 1, 'SR', NULL, NULL, NULL),
(32401, '2017-06-02 12:37:34', NULL, NULL, 9749, 0, 181, '116', 'Open Food ', 'Pork Chop', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:37:34', 'admin-1496372633-1496378254232198', 1, 0, '', NULL, NULL, NULL),
(32402, '2017-06-02 12:37:18', NULL, NULL, 9749, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:37:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32403, '2017-06-02 12:27:47', NULL, NULL, 9748, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:27:47', 'admin-1496372633-14963776669265878', 1, 0, '', NULL, NULL, NULL),
(32404, '2017-06-02 12:49:49', NULL, NULL, 9750, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:49:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32405, '2017-06-02 12:04:23', NULL, NULL, 9748, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:04:23', 'admin-1496372633-1496376263012989', 1, 0, '', NULL, NULL, NULL),
(32406, '2017-06-02 12:49:58', NULL, NULL, 9750, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 12:49:58', 'admin-1496372633-1496378997930161', 1, 0, '', NULL, NULL, NULL),
(32407, '2017-06-02 09:47:18', NULL, NULL, 9732, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 09:47:18', 'admin-1496364303-1496368038395492', 1, 0, '', NULL, NULL, NULL),
(32408, '2017-06-02 09:47:18', NULL, NULL, 9732, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 09:47:18', 'admin-1496364303-1496368038395492', 1, 0, '', NULL, NULL, NULL),
(32409, '2017-06-02 09:47:24', NULL, NULL, 9732, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 09:47:24', 'admin-1496364303-14963680445742063', 1, 1, 'SR', NULL, NULL, NULL),
(32410, '2017-06-02 09:47:24', NULL, NULL, 9732, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 09:47:24', 'admin-1496364303-14963680445742063', 1, 1, 'SR', NULL, NULL, NULL),
(32411, '2017-06-02 10:06:30', NULL, NULL, 9733, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:06:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32412, '2017-06-02 10:06:35', NULL, NULL, 9733, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:06:35', 'admin-1496364303-14963691958092542', 1, 0, '', NULL, NULL, NULL),
(32413, '2017-06-02 10:06:35', NULL, NULL, 9733, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:06:35', 'admin-1496364303-14963691958092542', 1, 0, '', NULL, NULL, NULL),
(32414, '2017-06-02 10:14:12', NULL, NULL, 9734, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:14:12', 'admin-1496364303-1496369651794164', 1, 1, 'SR', 1, NULL, NULL),
(32415, '2017-06-02 10:14:12', NULL, NULL, 9734, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:14:12', 'admin-1496364303-1496369651794164', 1, 1, 'SR', 1, NULL, NULL),
(32416, '2017-06-02 10:30:27', NULL, NULL, 9735, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.60, 0.0000, 0.0000, 9.60, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:30:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32417, '2017-06-02 10:30:35', NULL, NULL, 9735, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:30:35', 'admin-1496364303-14963706355231121', 1, 0, '', NULL, NULL, NULL),
(32418, '2017-06-02 10:30:35', NULL, NULL, 9735, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:30:35', 'admin-1496364303-14963706355231121', 1, 0, '', NULL, NULL, NULL),
(32419, '2017-06-02 10:30:35', NULL, NULL, 9735, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:30:35', 'admin-1496364303-14963706355231121', 1, 0, '', NULL, NULL, NULL),
(32420, '2017-06-02 10:30:45', NULL, NULL, 9735, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:30:45', 'admin-1496364303-14963706448838794', 1, 1, 'SR', NULL, NULL, NULL),
(32421, '2017-06-02 10:30:45', NULL, NULL, 9735, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:30:45', 'admin-1496364303-14963706448838794', 1, 0, '', NULL, NULL, NULL),
(32422, '2017-06-02 13:22:30', NULL, NULL, 9754, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 13:22:30', 'admin-1496372633-14963809501155653', 1, 1, 'SR', 1, NULL, NULL),
(32423, '2017-06-02 10:36:03', NULL, NULL, 9736, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:36:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32424, '2017-06-02 10:30:45', NULL, NULL, 9735, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 10:30:45', 'admin-1496364303-14963706448838794', 1, 0, '', NULL, NULL, NULL),
(32425, '2017-06-02 09:47:10', NULL, NULL, 9732, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1496372633', 'admin', '2017-06-02 09:47:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32426, '2017-06-02 09:14:56', NULL, NULL, 9731, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496372633', 'admin', '2017-06-02 09:14:56', 'admin-1496364303-14963660966175058', 1, 1, 'SR', NULL, NULL, NULL),
(32427, '2017-06-02 09:14:46', NULL, NULL, 9731, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1496372633', 'admin', '2017-06-02 09:14:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32428, '2017-06-03 11:29:31', NULL, NULL, 9783, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:29:31', 'admin-1496456994-14964605710644652', 1, 1, 'SR', NULL, NULL, NULL),
(32429, '2017-06-03 11:29:31', NULL, NULL, 9783, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:29:31', 'admin-1496456994-14964605710644652', 1, 0, '', NULL, NULL, NULL),
(32430, '2017-06-03 11:35:32', NULL, NULL, 9784, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:35:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32431, '2017-06-03 11:35:52', NULL, NULL, 9784, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:35:52', 'admin-1496460619-14964609527143941', 1, 1, 'SR', NULL, NULL, NULL),
(32432, '2017-06-03 11:35:52', NULL, NULL, 9784, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:35:52', 'admin-1496460619-14964609527143941', 1, 1, 'SR', NULL, NULL, NULL),
(32433, '2017-06-03 11:14:27', NULL, NULL, 9779, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:14:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32434, '2017-06-03 11:15:03', NULL, NULL, 9779, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:15:03', 'admin-1496456994-14964597029524812', 1, 0, '', NULL, NULL, NULL),
(32435, '2017-06-03 11:15:03', NULL, NULL, 9779, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:15:03', 'admin-1496456994-14964597029524812', 1, 1, 'SR', NULL, NULL, NULL),
(32436, '2017-06-03 11:15:03', NULL, NULL, 9779, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:15:03', 'admin-1496456994-14964597029524812', 1, 1, 'SR', NULL, NULL, NULL),
(32437, '2017-06-03 11:15:03', NULL, NULL, 9779, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:15:03', 'admin-1496456994-14964597029524812', 1, 0, '', NULL, NULL, NULL),
(32438, '2017-06-03 11:39:53', NULL, NULL, 9785, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:39:53', 'admin-1496460619-1496461192849727', 1, 1, 'SR', NULL, NULL, NULL),
(32439, '2017-06-03 10:55:45', NULL, NULL, 9777, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:55:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32440, '2017-06-03 10:55:51', NULL, NULL, 9777, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:55:51', 'admin-1496456994-14964585511062885', 1, 1, 'SR', NULL, NULL, NULL),
(32441, '2017-06-03 13:20:20', NULL, NULL, 9795, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:20:20', 'admin-1496466110-14964672199972363', 1, 1, 'SR', NULL, NULL, NULL),
(32442, '2017-06-03 13:12:39', NULL, NULL, 9795, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:12:39', 'admin-1496466110-14964667597439186', 1, 0, '', NULL, NULL, NULL),
(32443, '2017-06-03 12:05:56', NULL, NULL, 9788, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:05:56', 'admin-1496460619-14964627564503893', 1, 0, '', NULL, NULL, NULL),
(32444, '2017-06-03 12:05:56', NULL, NULL, 9788, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:05:56', 'admin-1496460619-14964627564503893', 1, 1, 'SR', NULL, NULL, NULL),
(32445, '2017-06-03 12:05:56', NULL, NULL, 9788, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:05:56', 'admin-1496460619-14964627564503893', 1, 1, 'SR', NULL, NULL, NULL),
(32446, '2017-06-03 11:24:09', NULL, NULL, 9781, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:24:09', 'admin-1496456994-14964602490367144', 1, 0, '', 1, NULL, NULL),
(32447, '2017-06-03 11:28:13', NULL, NULL, 9782, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.30, 0.0000, 0.0000, 13.30, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:28:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32448, '2017-06-03 11:28:27', NULL, NULL, 9782, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:28:27', 'admin-1496456994-14964605073435148', 1, 0, '', NULL, NULL, NULL),
(32449, '2017-06-03 11:28:27', NULL, NULL, 9782, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:28:27', 'admin-1496456994-14964605073435148', 1, 0, '', NULL, NULL, NULL),
(32450, '2017-06-03 11:28:27', NULL, NULL, 9782, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:28:27', 'admin-1496456994-14964605073435148', 1, 0, '', NULL, NULL, NULL),
(32451, '2017-06-03 11:28:27', NULL, NULL, 9782, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:28:27', 'admin-1496456994-14964605073435148', 1, 0, '', NULL, NULL, NULL),
(32452, '2017-06-03 11:28:27', NULL, NULL, 9782, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:28:27', 'admin-1496456994-14964605073435148', 1, 0, '', NULL, NULL, NULL),
(32453, '2017-06-03 13:12:03', NULL, NULL, 9795, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:12:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32454, '2017-06-03 13:12:39', NULL, NULL, 9795, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:12:39', 'admin-1496466110-14964667597439186', 1, 0, '', NULL, NULL, NULL),
(32455, '2017-06-03 12:02:06', NULL, NULL, 9786, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:02:06', 'admin-1496460619-14964625263877169', 1, 0, '', NULL, NULL, NULL),
(32456, '2017-06-03 12:02:06', NULL, NULL, 9786, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:02:06', 'admin-1496460619-14964625263877169', 1, 1, 'SR', NULL, NULL, NULL),
(32457, '2017-06-03 12:02:06', NULL, NULL, 9786, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:02:06', 'admin-1496460619-14964625263877169', 1, 1, 'SR', NULL, NULL, NULL),
(32458, '2017-06-03 11:29:31', NULL, NULL, 9783, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:29:31', 'admin-1496456994-14964605710644652', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(32459, '2017-06-03 11:39:53', NULL, NULL, 9785, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:39:53', 'admin-1496460619-1496461192849727', 1, 0, '', NULL, NULL, NULL),
(32460, '2017-06-03 11:04:23', NULL, NULL, 9770, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:04:23', 'admin-1496456994-14964590634713491', 1, 0, '', NULL, NULL, NULL),
(32461, '2017-06-03 10:59:45', NULL, NULL, 9774, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:59:45', 'admin-1496456994-14964587855644642', 1, 0, '', NULL, NULL, NULL),
(32462, '2017-06-03 12:16:12', NULL, NULL, 9790, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:16:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32463, '2017-06-03 12:16:30', NULL, NULL, 9790, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:16:30', 'admin-1496463066-14964633905134167', 1, 1, 'SR', NULL, NULL, NULL),
(32464, '2017-06-03 12:16:30', NULL, NULL, 9790, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:16:30', 'admin-1496463066-14964633905134167', 1, 0, '', NULL, NULL, NULL),
(32465, '2017-06-03 12:51:50', NULL, NULL, 9789, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:51:50', 'admin-1496463066-14964655101876714', 1, 0, '', NULL, NULL, NULL),
(32466, '2017-06-03 10:42:54', NULL, NULL, 9776, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:42:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32467, '2017-06-03 10:43:07', NULL, NULL, 9776, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:43:07', 'admin-1496456994-14964577873002856', 1, 0, '', NULL, NULL, NULL),
(32468, '2017-06-03 10:43:07', NULL, NULL, 9776, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:43:07', 'admin-1496456994-14964577873002856', 1, 0, '', NULL, NULL, NULL),
(32469, '2017-06-03 10:28:54', NULL, NULL, 9773, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:28:54', 'admin-1496454919-14964569345924093', 1, 1, 'SR', NULL, NULL, NULL),
(32470, '2017-06-03 10:28:54', NULL, NULL, 9773, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:28:54', 'admin-1496454919-14964569345924093', 1, 1, 'SR', NULL, NULL, NULL),
(32471, '2017-06-03 10:28:59', NULL, NULL, 9774, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:28:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32472, '2017-06-03 10:29:37', NULL, NULL, 9774, 0, 156, '90', 'House Cheddar Omelet', 'no side salad', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:29:37', 'admin-1496454919-14964569768116265', 1, 0, '', NULL, NULL, NULL),
(32473, '2017-06-03 10:29:37', NULL, NULL, 9774, 0, 156, '90', 'House Cheddar Omelet', 'no side salad', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:29:37', 'admin-1496454919-14964569768116265', 1, 0, '', NULL, NULL, NULL),
(32474, '2017-06-03 10:19:45', NULL, NULL, 9770, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:19:45', 'admin-1496454919-14964563853595620', 1, 0, '', NULL, NULL, NULL),
(32475, '2017-06-03 10:56:10', NULL, NULL, 9778, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:56:10', 'admin-1496456994-14964585699173326', 1, 1, 'SR', NULL, NULL, NULL),
(32476, '2017-06-03 10:56:02', NULL, NULL, 9778, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:56:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32477, '2017-06-03 10:56:10', NULL, NULL, 9778, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:56:10', 'admin-1496456994-14964585699173326', 1, 0, '', NULL, NULL, NULL),
(32478, '2017-06-03 09:58:45', NULL, NULL, 9769, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:58:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32479, '2017-06-03 09:55:14', NULL, NULL, 9768, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:55:14', 'admin-1496451505-14964549138365045', 1, 0, '', NULL, NULL, NULL),
(32480, '2017-06-03 09:55:14', NULL, NULL, 9768, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:55:14', 'admin-1496451505-14964549138365045', 1, 0, '', NULL, NULL, NULL),
(32481, '2017-06-03 09:55:14', NULL, NULL, 9768, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:55:14', 'admin-1496451505-14964549138365045', 1, 1, 'SR', NULL, NULL, NULL),
(32482, '2017-06-03 12:56:33', NULL, NULL, 9793, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:56:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32483, '2017-06-03 12:56:46', NULL, NULL, 9793, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:56:46', 'admin-1496463066-14964658061899336', 1, 1, 'SR', NULL, NULL, NULL),
(32484, '2017-06-03 12:56:46', NULL, NULL, 9793, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:56:46', 'admin-1496463066-14964658061899336', 1, 1, 'SR', NULL, NULL, NULL),
(32485, '2017-06-03 12:57:03', NULL, NULL, 9793, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:57:03', 'admin-1496463066-14964658230162063', 1, 0, '', NULL, NULL, NULL),
(32486, '2017-06-03 12:57:03', NULL, NULL, 9793, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:57:03', 'admin-1496463066-14964658230162063', 1, 1, 'SR', NULL, NULL, NULL),
(32487, '2017-06-03 13:01:10', NULL, NULL, 9794, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:01:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32488, '2017-06-03 13:01:39', NULL, NULL, 9794, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:01:39', 'admin-1496463066-14964660989757111', 1, 0, '', NULL, NULL, NULL),
(32489, '2017-06-03 13:01:39', NULL, NULL, 9794, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:01:39', 'admin-1496463066-14964660989757111', 1, 0, '', NULL, NULL, NULL),
(32490, '2017-06-03 11:39:53', NULL, NULL, 9785, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:39:53', 'admin-1496460619-1496461192849727', 1, 0, '', NULL, NULL, NULL),
(32491, '2017-06-03 11:39:10', NULL, NULL, 9785, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:39:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32492, '2017-06-03 14:27:32', NULL, NULL, 9800, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1496471275', 'admin', '2017-06-03 14:27:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32493, '2017-06-03 14:27:48', NULL, NULL, 9800, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 14:27:48', 'admin-1496466110-14964712685284576', 1, 0, '', NULL, NULL, NULL),
(32494, '2017-06-03 14:27:48', NULL, NULL, 9800, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 14:27:48', 'admin-1496466110-14964712685284576', 1, 1, 'SR', NULL, NULL, NULL),
(32495, '2017-06-03 14:27:48', NULL, NULL, 9800, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 14:27:48', 'admin-1496466110-14964712685284576', 1, 1, 'SR', NULL, NULL, NULL),
(32496, '2017-06-03 12:46:39', NULL, NULL, 9792, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:46:39', 'admin-1496463066-14964651995616772', 1, 0, '', NULL, NULL, NULL),
(32497, '2017-06-03 12:46:39', NULL, NULL, 9792, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:46:39', 'admin-1496463066-14964651995616772', 1, 1, 'SR', NULL, NULL, NULL),
(32498, '2017-06-03 12:47:45', NULL, NULL, 9792, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:47:45', 'admin-1496463066-14964652655612879', 1, 1, 'SR', NULL, NULL, NULL),
(32499, '2017-06-03 12:47:45', NULL, NULL, 9792, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:47:45', 'admin-1496463066-14964652655612879', 1, 1, 'SR', NULL, NULL, NULL),
(32500, '2017-06-03 12:47:45', NULL, NULL, 9792, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:47:45', 'admin-1496463066-14964652655612879', 1, 1, 'SR', NULL, NULL, NULL),
(32501, '2017-06-03 12:47:45', NULL, NULL, 9792, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:47:45', 'admin-1496463066-14964652655612879', 1, 1, 'SR', NULL, NULL, NULL),
(32502, '2017-06-03 12:47:45', NULL, NULL, 9792, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:47:45', 'admin-1496463066-14964652655612879', 1, 1, 'SR', NULL, NULL, NULL),
(32503, '2017-06-03 12:47:45', NULL, NULL, 9792, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:47:45', 'admin-1496463066-14964652655612879', 1, 1, 'SR', NULL, NULL, NULL),
(32504, '2017-06-03 12:47:45', NULL, NULL, 9792, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:47:45', 'admin-1496463066-14964652655612879', 1, 1, 'SR', NULL, NULL, NULL),
(32505, '2017-06-03 13:55:00', NULL, NULL, 9798, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:55:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32506, '2017-06-03 15:20:38', NULL, NULL, 9801, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 15:20:38', 'admin-1496471275-14964744386457134', 1, 1, 'SR', NULL, NULL, NULL),
(32507, '2017-06-03 13:32:01', NULL, NULL, 9796, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:32:01', 'admin-1496466110-14964679212592346', 1, 0, '', NULL, NULL, NULL),
(32508, '2017-06-03 12:12:42', NULL, NULL, 9789, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:12:42', 'admin-1496463066-14964631620701882', 1, 1, 'SR', NULL, NULL, NULL),
(32509, '2017-06-03 12:12:42', NULL, NULL, 9789, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:12:42', 'admin-1496463066-14964631620701882', 1, 1, 'SR', NULL, NULL, NULL),
(32510, '2017-06-03 12:12:42', NULL, NULL, 9789, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:12:42', 'admin-1496463066-14964631620701882', 1, 0, '', NULL, NULL, NULL),
(32511, '2017-06-03 17:24:24', NULL, NULL, 9804, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 17:24:24', 'admin-1496471275-1496481864439827', 1, 1, 'SR', NULL, NULL, NULL),
(32512, '2017-06-03 17:24:24', NULL, NULL, 9804, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 17:24:24', 'admin-1496471275-1496481864439827', 1, 1, 'SR', NULL, NULL, NULL),
(32513, '2017-06-03 17:24:24', NULL, NULL, 9804, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 17:24:24', 'admin-1496471275-1496481864439827', 1, 1, 'SR', NULL, NULL, NULL),
(32514, '2017-06-03 17:23:55', NULL, NULL, 9804, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1496471275', 'admin', '2017-06-03 17:23:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32515, '2017-06-03 11:29:31', NULL, NULL, 9783, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:29:31', 'admin-1496456994-14964605710644652', 1, 0, '', NULL, NULL, NULL),
(32516, '2017-06-03 17:10:07', NULL, NULL, 9803, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 17:10:07', 'admin-1496471275-14964810075499451', 1, 0, '', 1, NULL, NULL),
(32517, '2017-06-03 17:10:07', NULL, NULL, 9803, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 17:10:07', 'admin-1496471275-14964810075499451', 1, 0, '', 1, NULL, NULL),
(32518, '2017-06-03 17:07:59', NULL, NULL, 9802, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 17:07:59', 'admin-1496471275-1496480879131246', 1, 0, '', 1, NULL, NULL),
(32519, '2017-06-03 17:07:59', NULL, NULL, 9802, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 17:07:59', 'admin-1496471275-1496480879131246', 1, 0, '', 1, NULL, NULL),
(32520, '2017-06-03 15:20:38', NULL, NULL, 9801, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 15:20:38', 'admin-1496471275-14964744386457134', 1, 0, '', NULL, NULL, NULL),
(32521, '2017-06-03 15:09:11', NULL, NULL, 9801, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1496471275', 'admin', '2017-06-03 15:09:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32522, '2017-06-03 15:20:38', NULL, NULL, 9801, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 15:20:38', 'admin-1496471275-14964744386457134', 1, 0, '', NULL, NULL, NULL),
(32523, '2017-06-03 13:55:07', NULL, NULL, 9798, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:55:07', 'admin-1496466110-1496469307206521', 1, 1, 'SR', NULL, NULL, NULL),
(32524, '2017-06-03 13:55:07', NULL, NULL, 9798, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:55:07', 'admin-1496466110-1496469307206521', 1, 1, 'SR', NULL, NULL, NULL),
(32525, '2017-06-03 13:58:49', NULL, NULL, 9799, 0, 181, '116', 'Open Food ', 'fruits', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:58:49', 'admin-1496466110-1496469529561124', 1, 0, '', 1, NULL, NULL),
(32526, '2017-06-03 13:47:21', NULL, NULL, 9797, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:47:21', 'admin-1496466110-1496468841402565', 1, 1, 'SR', NULL, NULL, NULL),
(32527, '2017-06-03 11:28:38', NULL, NULL, 9782, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:28:38', 'admin-1496456994-14964605186057279', 1, 1, 'SR', NULL, NULL, NULL),
(32528, '2017-06-03 13:47:21', NULL, NULL, 9797, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:47:21', 'admin-1496466110-1496468841402565', 1, 1, 'SR', NULL, NULL, NULL),
(32529, '2017-06-03 13:47:09', NULL, NULL, 9797, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:47:09', 'admin-1496466110-14964688294196985', 1, 0, '', NULL, NULL, NULL),
(32530, '2017-06-03 13:47:09', NULL, NULL, 9797, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:47:09', 'admin-1496466110-14964688294196985', 1, 0, '', NULL, NULL, NULL),
(32531, '2017-06-03 13:46:38', NULL, NULL, 9797, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:46:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32532, '2017-06-03 13:31:52', NULL, NULL, 9796, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:31:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32533, '2017-06-03 13:35:55', NULL, NULL, 9794, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:35:55', 'admin-1496466110-14964681554944154', 1, 0, '', NULL, NULL, NULL),
(32534, '2017-06-03 17:08:53', NULL, NULL, 9802, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 17:08:53', 'admin-1496471275-14964809330111058', 1, 0, '', 1, NULL, NULL),
(32535, '2017-06-03 13:12:39', NULL, NULL, 9795, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:12:39', 'admin-1496466110-14964667597439186', 1, 1, 'SR', NULL, NULL, NULL),
(32536, '2017-06-03 13:12:39', NULL, NULL, 9795, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:12:39', 'admin-1496466110-14964667597439186', 1, 1, 'SR', NULL, NULL, NULL),
(32537, '2017-06-03 13:01:39', NULL, NULL, 9794, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:01:39', 'admin-1496463066-14964660989757111', 1, 0, '', NULL, NULL, NULL),
(32538, '2017-06-03 13:01:39', NULL, NULL, 9794, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 13:01:39', 'admin-1496463066-14964660989757111', 1, 0, '', NULL, NULL, NULL),
(32539, '2017-06-03 12:47:45', NULL, NULL, 9792, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:47:45', 'admin-1496463066-14964652655612879', 1, 1, 'SR', NULL, NULL, NULL),
(32540, '2017-06-03 12:24:19', NULL, NULL, 9791, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:24:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32541, '2017-06-03 12:24:33', NULL, NULL, 9791, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:24:33', 'admin-1496463066-14964638729947723', 1, 1, 'SR', NULL, NULL, NULL),
(32542, '2017-06-03 12:05:56', NULL, NULL, 9788, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:05:56', 'admin-1496460619-14964627564503893', 1, 0, '', NULL, NULL, NULL),
(32543, '2017-06-03 12:12:42', NULL, NULL, 9789, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:12:42', 'admin-1496463066-14964631620701882', 1, 0, '', NULL, NULL, NULL),
(32544, '2017-06-03 12:06:24', NULL, NULL, 9787, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:06:24', 'admin-1496460619-1496462784590404', 1, 1, 'SR', NULL, NULL, NULL),
(32545, '2017-06-03 12:12:21', NULL, NULL, 9789, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:12:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32546, '2017-06-03 10:59:45', NULL, NULL, 9774, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:59:45', 'admin-1496456994-14964587855644642', 1, 0, '', NULL, NULL, NULL),
(32547, '2017-06-03 10:48:43', NULL, NULL, 9773, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:48:43', 'admin-1496456994-1496458122873711', 1, 0, '', NULL, NULL, NULL),
(32548, '2017-06-03 12:05:41', NULL, NULL, 9788, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:05:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32549, '2017-06-03 12:05:56', NULL, NULL, 9788, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:05:56', 'admin-1496460619-14964627564503893', 1, 0, '', NULL, NULL, NULL),
(32550, '2017-06-03 12:05:39', NULL, NULL, 9783, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:05:39', 'admin-1496460619-14964627392049336', 1, 0, '', NULL, NULL, NULL),
(32551, '2017-06-03 12:02:06', NULL, NULL, 9786, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:02:06', 'admin-1496460619-14964625263877169', 1, 0, '', NULL, NULL, NULL),
(32552, '2017-06-03 12:46:14', NULL, NULL, 9792, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.20, 0.0000, 0.0000, 13.20, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:46:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32553, '2017-06-03 12:02:43', NULL, NULL, 9787, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:02:43', 'admin-1496460619-14964625637209253', 1, 0, '', NULL, NULL, NULL),
(32554, '2017-06-03 12:10:22', NULL, NULL, 9787, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:10:22', 'admin-1496460619-14964630223978310', 1, 0, '', NULL, NULL, NULL),
(32555, '2017-06-03 11:28:38', NULL, NULL, 9782, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:28:38', 'admin-1496456994-14964605186057279', 1, 1, 'SR', NULL, NULL, NULL),
(32556, '2017-06-03 11:28:38', NULL, NULL, 9782, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:28:38', 'admin-1496456994-14964605186057279', 1, 1, 'SR', NULL, NULL, NULL),
(32557, '2017-06-03 12:01:56', NULL, NULL, 9786, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:01:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32558, '2017-06-03 12:02:31', NULL, NULL, 9786, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:02:31', 'admin-1496460619-14964625515138847', 1, 0, '', NULL, NULL, NULL),
(32559, '2017-06-03 12:02:34', NULL, NULL, 9787, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1496471275', 'admin', '2017-06-03 12:02:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32560, '2017-06-03 11:29:19', NULL, NULL, 9783, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:29:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32561, '2017-06-03 11:28:38', NULL, NULL, 9782, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:28:38', 'admin-1496456994-14964605186057279', 1, 1, 'SR', NULL, NULL, NULL),
(32562, '2017-06-03 10:48:43', NULL, NULL, 9773, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:48:43', 'admin-1496456994-1496458122873711', 1, 0, '', NULL, NULL, NULL),
(32563, '2017-06-03 10:34:09', NULL, NULL, 9773, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:34:09', 'admin-1496456994-14964572490038947', 1, 0, '', NULL, NULL, NULL),
(32564, '2017-06-03 10:41:19', NULL, NULL, 9775, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:41:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32565, '2017-06-03 10:41:29', NULL, NULL, 9775, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:41:29', 'admin-1496456994-14964576892838480', 1, 0, '', NULL, NULL, NULL),
(32566, '2017-06-03 10:41:29', NULL, NULL, 9775, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:41:29', 'admin-1496456994-14964576892838480', 1, 0, '', NULL, NULL, NULL),
(32567, '2017-06-03 10:41:37', NULL, NULL, 9775, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:41:37', 'admin-1496456994-14964576971005548', 1, 0, '', NULL, NULL, NULL),
(32568, '2017-06-03 10:41:45', NULL, NULL, 9775, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:41:45', 'admin-1496456994-1496457705676757', 1, 1, 'SR', NULL, NULL, NULL),
(32569, '2017-06-03 11:18:02', NULL, NULL, 9780, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:18:02', 'admin-1496456994-14964598823389681', 1, 0, '', NULL, NULL, NULL),
(32570, '2017-06-03 11:18:02', NULL, NULL, 9780, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:18:02', 'admin-1496456994-14964598823389681', 1, 0, '', NULL, NULL, NULL),
(32571, '2017-06-03 11:18:02', NULL, NULL, 9780, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:18:02', 'admin-1496456994-14964598823389681', 1, 0, '', NULL, NULL, NULL),
(32572, '2017-06-03 11:18:02', NULL, NULL, 9780, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:18:02', 'admin-1496456994-14964598823389681', 1, 1, 'SR', NULL, NULL, NULL),
(32573, '2017-06-03 11:17:44', NULL, NULL, 9780, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:17:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32574, '2017-06-03 11:18:02', NULL, NULL, 9780, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:18:02', 'admin-1496456994-14964598823389681', 1, 1, 'SR', NULL, NULL, NULL),
(32575, '2017-06-03 11:15:03', NULL, NULL, 9779, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:15:03', 'admin-1496456994-14964597029524812', 1, 0, '', NULL, NULL, NULL),
(32576, '2017-06-03 10:33:28', NULL, NULL, 9773, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:33:28', 'admin-1496456994-14964572082888220', 1, 0, '', NULL, NULL, NULL),
(32577, '2017-06-03 10:32:33', NULL, NULL, 9771, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:32:33', 'admin-1496456994-14964571528209466', 1, 1, 'SR', NULL, NULL, NULL),
(32578, '2017-06-03 10:32:33', NULL, NULL, 9771, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:32:33', 'admin-1496456994-14964571528209466', 1, 1, 'SR', NULL, NULL, NULL),
(32579, '2017-06-03 10:32:33', NULL, NULL, 9771, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:32:33', 'admin-1496456994-14964571528209466', 1, 0, '', NULL, NULL, NULL),
(32580, '2017-06-03 10:32:33', NULL, NULL, 9771, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:32:33', 'admin-1496456994-14964571528209466', 1, 1, 'SR', NULL, NULL, NULL),
(32581, '2017-06-03 11:18:14', NULL, NULL, 9780, 0, 181, '116', 'Open Food ', 'All food is takeaway', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:18:14', 'admin-1496456994-14964598941639635', 1, 0, '', NULL, NULL, NULL),
(32582, '2017-06-03 10:43:49', NULL, NULL, 9776, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:43:49', 'admin-1496456994-14964578295485421', 1, 0, '', NULL, NULL, NULL),
(32583, '2017-06-03 10:34:09', NULL, NULL, 9773, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:34:09', 'admin-1496456994-14964572490038947', 1, 0, '', NULL, NULL, NULL),
(32584, '2017-06-03 10:14:32', NULL, NULL, 9772, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:14:32', 'admin-1496454919-1496456072514156', 1, 1, 'SR', NULL, NULL, NULL),
(32585, '2017-06-03 10:15:36', NULL, NULL, 9772, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:15:36', 'admin-1496454919-14964561364035588', 1, 0, '', NULL, NULL, NULL),
(32586, '2017-06-03 10:15:36', NULL, NULL, 9772, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:15:36', 'admin-1496454919-14964561364035588', 1, 0, '', NULL, NULL, NULL),
(32587, '2017-06-03 10:19:45', NULL, NULL, 9770, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:19:45', 'admin-1496454919-14964563853595620', 1, 0, '', NULL, NULL, NULL),
(32588, '2017-06-03 10:19:45', NULL, NULL, 9770, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:19:45', 'admin-1496454919-14964563853595620', 1, 0, '', NULL, NULL, NULL),
(32589, '2017-06-03 10:19:45', NULL, NULL, 9770, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:19:45', 'admin-1496454919-14964563853595620', 1, 0, '', NULL, NULL, NULL),
(32590, '2017-06-03 10:19:45', NULL, NULL, 9770, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:19:45', 'admin-1496454919-14964563853595620', 1, 0, '', NULL, NULL, NULL),
(32591, '2017-06-03 10:19:45', NULL, NULL, 9770, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:19:45', 'admin-1496454919-14964563853595620', 1, 0, '', NULL, NULL, NULL),
(32592, '2017-06-03 10:19:45', NULL, NULL, 9770, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:19:45', 'admin-1496454919-14964563853595620', 1, 0, '', NULL, NULL, NULL),
(32593, '2017-06-03 09:19:28', NULL, NULL, 9762, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:19:28', 'admin-1496451505-14964527680691350', 1, 0, '', NULL, NULL, NULL),
(32594, '2017-06-03 09:23:06', NULL, NULL, 9762, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:23:06', 'admin-1496451505-14964529864234052', 1, 1, 'SR', NULL, NULL, NULL),
(32595, '2017-06-03 09:23:06', NULL, NULL, 9762, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:23:06', 'admin-1496451505-14964529864234052', 1, 1, 'SR', NULL, NULL, NULL),
(32596, '2017-06-03 09:23:10', NULL, NULL, 9763, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:23:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32597, '2017-06-03 09:23:22', NULL, NULL, 9763, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:23:22', 'admin-1496451505-14964530018624936', 1, 0, '', NULL, NULL, NULL),
(32598, '2017-06-03 09:23:22', NULL, NULL, 9763, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:23:22', 'admin-1496451505-14964530018624936', 1, 0, '', NULL, NULL, NULL),
(32599, '2017-06-03 09:23:22', NULL, NULL, 9763, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:23:22', 'admin-1496451505-14964530018624936', 1, 0, '', NULL, NULL, NULL),
(32600, '2017-06-03 09:23:34', NULL, NULL, 9763, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:23:34', 'admin-1496451505-14964530139924788', 1, 1, 'SR', NULL, NULL, NULL),
(32601, '2017-06-03 10:32:33', NULL, NULL, 9771, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:32:33', 'admin-1496456994-14964571528209466', 1, 0, '', NULL, NULL, NULL),
(32602, '2017-06-03 10:32:33', NULL, NULL, 9771, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:32:33', 'admin-1496456994-14964571528209466', 1, 0, '', NULL, NULL, NULL),
(32603, '2017-06-03 10:32:32', NULL, NULL, 9771, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:32:32', 'admin-1496456994-14964571528209466', 1, 0, '', NULL, NULL, NULL),
(32604, '2017-06-03 10:29:37', NULL, NULL, 9774, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:29:37', 'admin-1496454919-14964569768116265', 1, 0, '', NULL, NULL, NULL),
(32605, '2017-06-03 10:29:37', NULL, NULL, 9774, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:29:37', 'admin-1496454919-14964569768116265', 1, 1, 'SR', NULL, NULL, NULL),
(32606, '2017-06-03 09:50:22', NULL, NULL, 9766, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:50:22', 'admin-1496451505-14964546222679581', 1, 0, '', NULL, NULL, NULL),
(32607, '2017-06-03 09:52:12', NULL, NULL, 9766, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:52:12', 'admin-1496451505-14964547324302199', 1, 1, 'SR', NULL, NULL, NULL),
(32608, '2017-06-03 09:52:21', NULL, NULL, 9767, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:52:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32609, '2017-06-03 11:39:53', NULL, NULL, 9785, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 11:39:53', 'admin-1496460619-1496461192849727', 1, 0, '', NULL, NULL, NULL),
(32610, '2017-06-03 10:14:32', NULL, NULL, 9772, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:14:32', 'admin-1496454919-1496456072514156', 1, 1, 'SR', NULL, NULL, NULL),
(32611, '2017-06-03 10:28:54', NULL, NULL, 9773, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:28:54', 'admin-1496454919-14964569345924093', 1, 0, '', NULL, NULL, NULL),
(32612, '2017-06-03 10:28:54', NULL, NULL, 9773, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:28:54', 'admin-1496454919-14964569345924093', 1, 0, '', NULL, NULL, NULL),
(32613, '2017-06-03 10:19:45', NULL, NULL, 9770, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:19:45', 'admin-1496454919-14964563853595620', 1, 1, 'SR', NULL, NULL, NULL),
(32614, '2017-06-03 10:28:25', NULL, NULL, 9773, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.90, 0.0000, 0.0000, 15.90, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:28:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32615, '2017-06-03 10:28:54', NULL, NULL, 9773, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:28:54', 'admin-1496454919-14964569345924093', 1, 0, '', NULL, NULL, NULL),
(32616, '2017-06-03 10:28:54', NULL, NULL, 9773, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:28:54', 'admin-1496454919-14964569345924093', 1, 0, '', NULL, NULL, NULL),
(32617, '2017-06-03 10:19:45', NULL, NULL, 9770, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:19:45', 'admin-1496454919-14964563853595620', 1, 1, 'SR', NULL, NULL, NULL),
(32618, '2017-06-03 09:58:48', NULL, NULL, 9769, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:58:48', 'admin-1496454919-14964551278915295', 1, 1, 'SR', NULL, NULL, NULL),
(32619, '2017-06-03 09:59:55', NULL, NULL, 9770, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 20.40, 0.0000, 0.0000, 20.40, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:59:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32620, '2017-06-03 10:00:22', NULL, NULL, 9770, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:00:22', 'admin-1496454919-14964552225985923', 1, 0, '', NULL, NULL, NULL),
(32621, '2017-06-03 10:00:22', NULL, NULL, 9770, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:00:22', 'admin-1496454919-14964552225985923', 1, 0, '', NULL, NULL, NULL),
(32622, '2017-06-03 10:00:22', NULL, NULL, 9770, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:00:22', 'admin-1496454919-14964552225985923', 1, 1, 'SR', NULL, NULL, NULL),
(32623, '2017-06-03 10:00:22', NULL, NULL, 9770, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:00:22', 'admin-1496454919-14964552225985923', 1, 1, 'SR', NULL, NULL, NULL),
(32624, '2017-06-03 10:00:33', NULL, NULL, 9771, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.00, 0.0000, 0.0000, 16.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:00:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32625, '2017-06-03 10:00:53', NULL, NULL, 9771, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:00:53', 'admin-1496454919-14964552528707798', 1, 0, '', NULL, NULL, NULL),
(32626, '2017-06-03 10:00:53', NULL, NULL, 9771, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:00:53', 'admin-1496454919-14964552528707798', 1, 0, '', NULL, NULL, NULL),
(32627, '2017-06-03 10:00:53', NULL, NULL, 9771, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:00:53', 'admin-1496454919-14964552528707798', 1, 1, 'SR', NULL, NULL, NULL),
(32628, '2017-06-03 10:00:53', NULL, NULL, 9771, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:00:53', 'admin-1496454919-14964552528707798', 1, 0, '', NULL, NULL, NULL),
(32629, '2017-06-03 10:32:33', NULL, NULL, 9771, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:32:33', 'admin-1496456994-14964571528209466', 1, 0, '', NULL, NULL, NULL),
(32630, '2017-06-03 09:52:45', NULL, NULL, 9767, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:52:45', 'admin-1496451505-14964547650251084', 1, 0, '', NULL, NULL, NULL),
(32631, '2017-06-03 09:52:45', NULL, NULL, 9767, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:52:45', 'admin-1496451505-14964547650251084', 1, 1, 'SR', NULL, NULL, NULL),
(32632, '2017-06-03 09:54:59', NULL, NULL, 9768, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:54:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32633, '2017-06-03 10:14:32', NULL, NULL, 9772, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:14:32', 'admin-1496454919-1496456072514156', 1, 1, 'SR', NULL, NULL, NULL),
(32634, '2017-06-03 10:14:32', NULL, NULL, 9772, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:14:32', 'admin-1496454919-1496456072514156', 1, 0, '', NULL, NULL, NULL),
(32635, '2017-06-03 10:14:32', NULL, NULL, 9772, 0, 153, '87', 'Wake Me Up!', ',no bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:14:32', 'admin-1496454919-1496456072514156', 1, 0, '', NULL, NULL, NULL),
(32636, '2017-06-03 10:13:53', NULL, NULL, 9772, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1496471275', 'admin', '2017-06-03 10:13:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32637, '2017-06-03 09:23:34', NULL, NULL, 9763, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:23:34', 'admin-1496451505-14964530139924788', 1, 1, 'SR', NULL, NULL, NULL),
(32638, '2017-06-03 09:23:34', NULL, NULL, 9763, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:23:34', 'admin-1496451505-14964530139924788', 1, 1, 'SR', NULL, NULL, NULL),
(32639, '2017-06-03 09:27:37', NULL, NULL, 9764, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:27:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32640, '2017-06-03 09:27:51', NULL, NULL, 9764, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:27:51', 'admin-1496451505-14964532715527597', 1, 0, '', NULL, NULL, NULL),
(32641, '2017-06-03 09:27:51', NULL, NULL, 9764, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:27:51', 'admin-1496451505-14964532715527597', 1, 0, '', NULL, NULL, NULL),
(32642, '2017-06-03 09:27:51', NULL, NULL, 9764, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:27:51', 'admin-1496451505-14964532715527597', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(32643, '2017-06-03 09:27:51', NULL, NULL, 9764, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:27:51', 'admin-1496451505-14964532715527597', 1, 1, 'SR', NULL, NULL, NULL),
(32644, '2017-06-03 09:40:48', NULL, NULL, 9765, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:40:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32645, '2017-06-03 09:41:01', NULL, NULL, 9765, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:41:01', 'admin-1496451505-149645406105439', 1, 0, '', NULL, NULL, NULL),
(32646, '2017-06-03 09:41:01', NULL, NULL, 9765, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:41:01', 'admin-1496451505-149645406105439', 1, 0, '', NULL, NULL, NULL),
(32647, '2017-06-03 09:41:01', NULL, NULL, 9765, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:41:01', 'admin-1496451505-149645406105439', 1, 0, '', NULL, NULL, NULL),
(32648, '2017-06-03 09:41:01', NULL, NULL, 9765, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:41:01', 'admin-1496451505-149645406105439', 1, 0, '', NULL, NULL, NULL),
(32649, '2017-06-03 09:50:09', NULL, NULL, 9766, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:50:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32650, '2017-06-03 09:50:14', NULL, NULL, 9766, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:50:14', 'admin-1496451505-14964546143815210', 1, 0, '', NULL, NULL, NULL),
(32651, '2017-06-03 09:50:14', NULL, NULL, 9766, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:50:14', 'admin-1496451505-14964546143815210', 1, 0, '', NULL, NULL, NULL),
(32652, '2017-06-03 09:50:22', NULL, NULL, 9766, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:50:22', 'admin-1496451505-14964546222679581', 1, 1, 'SR', NULL, NULL, NULL),
(32653, '2017-06-03 09:50:22', NULL, NULL, 9766, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:50:22', 'admin-1496451505-14964546222679581', 1, 1, 'SR', NULL, NULL, NULL),
(32654, '2017-06-03 09:18:51', NULL, NULL, 9762, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:18:51', 'admin-1496451505-1496452731701393', 1, 0, '', NULL, NULL, NULL),
(32655, '2017-06-03 09:18:51', NULL, NULL, 9762, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:18:51', 'admin-1496451505-1496452731701393', 1, 0, '', NULL, NULL, NULL),
(32656, '2017-06-03 09:18:45', NULL, NULL, 9762, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1496471275', 'admin', '2017-06-03 09:18:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32657, '2017-06-04 11:09:48', NULL, NULL, 9821, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:09:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32658, '2017-06-04 11:09:58', NULL, NULL, 9821, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:09:58', 'admin-1496544263-14965457987758492', 1, 0, '', NULL, NULL, NULL),
(32659, '2017-06-04 10:43:51', NULL, NULL, 9817, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:43:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32660, '2017-06-04 10:44:11', NULL, NULL, 9817, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:44:11', 'admin-1496542619-14965442513739439', 1, 0, '', NULL, NULL, NULL),
(32661, '2017-06-04 12:25:12', NULL, NULL, 9831, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:25:12', 'admin-1496549123-14965503127759334', 1, 0, '', NULL, NULL, NULL),
(32662, '2017-06-04 12:25:57', NULL, NULL, 9832, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:25:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32663, '2017-06-04 12:26:02', NULL, NULL, 9832, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:26:02', 'admin-1496549123-14965503626365645', 1, 0, '', NULL, NULL, NULL),
(32664, '2017-06-04 12:47:02', NULL, NULL, 9836, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:47:02', 'admin-1496549123-1496551622399954', 1, 1, 'SR', NULL, NULL, NULL),
(32665, '2017-06-04 13:26:12', NULL, NULL, 9838, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:26:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32666, '2017-06-04 00:00:00', NULL, NULL, 9840, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, NULL, NULL, 1.80, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:44:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32667, '2017-06-04 00:00:00', NULL, NULL, 9840, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:45:28', 'admin-1496549123-14965515285842438', 1, 0, '', NULL, NULL, NULL),
(32668, '2017-06-04 00:00:00', NULL, NULL, 9839, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:46:18', 'admin-1496549123-14965515785217071', 1, 0, '', NULL, NULL, NULL),
(32669, '2017-06-04 13:27:02', NULL, NULL, 9839, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:27:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32670, '2017-06-04 12:46:45', NULL, NULL, 9836, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:46:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32671, '2017-06-04 12:47:02', NULL, NULL, 9836, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:47:02', 'admin-1496549123-1496551622399954', 1, 0, '', NULL, NULL, NULL),
(32672, '2017-06-04 12:47:02', NULL, NULL, 9836, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:47:02', 'admin-1496549123-1496551622399954', 1, 0, '', NULL, NULL, NULL),
(32673, '2017-06-04 12:47:02', NULL, NULL, 9836, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:47:02', 'admin-1496549123-1496551622399954', 1, 0, '', NULL, NULL, NULL),
(32674, '2017-06-04 13:38:02', NULL, NULL, 9843, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:38:02', 'admin-1496552111-14965546823999779', 1, 0, '', NULL, NULL, NULL),
(32675, '2017-06-04 12:29:40', NULL, NULL, 9833, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:29:40', 'admin-1496549123-14965505806695679', 1, 0, '', NULL, NULL, NULL),
(32676, '2017-06-04 12:29:40', NULL, NULL, 9833, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:29:40', 'admin-1496549123-14965505806695679', 1, 1, 'SR', NULL, NULL, NULL),
(32677, '2017-06-04 12:39:24', NULL, NULL, 9834, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:39:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32678, '2017-06-04 12:41:11', NULL, NULL, 9834, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:41:11', 'admin-1496549123-14965512712883790', 1, 1, 'SR', NULL, NULL, NULL),
(32679, '2017-06-04 12:41:11', NULL, NULL, 9834, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:41:11', 'admin-1496549123-14965512712883790', 1, 1, 'SR', NULL, NULL, NULL),
(32680, '2017-06-04 12:41:11', NULL, NULL, 9834, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:41:11', 'admin-1496549123-14965512712883790', 1, 1, 'SR', NULL, NULL, NULL),
(32681, '2017-06-04 11:33:06', NULL, NULL, 9824, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:33:06', 'admin-1496546186-14965471861119520', 1, 0, '', NULL, NULL, NULL),
(32682, '2017-06-04 11:33:06', NULL, NULL, 9824, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:33:06', 'admin-1496546186-14965471861119520', 1, 1, 'SR', NULL, NULL, NULL),
(32683, '2017-06-04 10:06:04', NULL, NULL, 9809, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:06:04', 'admin-1496537016-14965419645881255', 1, 1, 'SR', NULL, NULL, NULL),
(32684, '2017-06-04 10:09:43', NULL, NULL, 9810, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:09:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32685, '2017-06-04 00:00:00', NULL, NULL, 9838, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:45:28', 'admin-1496549123-14965515285842438', 1, 0, '', NULL, NULL, NULL),
(32686, '2017-06-04 00:00:00', NULL, NULL, 9839, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:46:18', 'admin-1496549123-14965515785217071', 1, 1, 'SR', NULL, NULL, NULL),
(32687, '2017-06-04 00:00:00', NULL, NULL, 9840, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, NULL, NULL, 6.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:46:18', 'admin-1496549123-14965515785217071', 1, 1, 'SR', NULL, NULL, NULL),
(32688, '2017-06-04 13:28:19', NULL, NULL, 9829, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:28:19', 'admin-1496552111-14965540990605170', 1, 0, '', NULL, NULL, NULL),
(32689, '2017-06-04 13:30:09', NULL, NULL, 9841, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:30:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32690, '2017-06-04 13:30:15', NULL, NULL, 9841, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:30:15', 'admin-1496552111-149655421568146', 1, 0, '', NULL, NULL, NULL),
(32691, '2017-06-04 11:10:15', NULL, NULL, 9821, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:10:15', 'admin-1496544263-1496545814812283', 1, 0, '', NULL, NULL, NULL),
(32692, '2017-06-04 11:10:15', NULL, NULL, 9821, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:10:15', 'admin-1496544263-1496545814812283', 1, 1, 'SR', NULL, NULL, NULL),
(32693, '2017-06-04 11:10:21', NULL, NULL, 9822, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:10:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32694, '2017-06-04 11:10:28', NULL, NULL, 9822, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:10:28', 'admin-1496544263-1496545828376529', 1, 0, '', NULL, NULL, NULL),
(32695, '2017-06-04 11:10:28', NULL, NULL, 9822, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:10:28', 'admin-1496544263-1496545828376529', 1, 0, '', NULL, NULL, NULL),
(32696, '2017-06-04 11:10:28', NULL, NULL, 9822, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:10:28', 'admin-1496544263-1496545828376529', 1, 1, 'SR', NULL, NULL, NULL),
(32697, '2017-06-04 11:10:28', NULL, NULL, 9822, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:10:28', 'admin-1496544263-1496545828376529', 1, 1, 'SR', NULL, NULL, NULL),
(32698, '2017-06-04 11:17:49', NULL, NULL, 9823, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:17:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32699, '2017-06-04 11:17:56', NULL, NULL, 9823, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:17:56', 'admin-1496546186-1496546276019361', 1, 0, '', NULL, NULL, NULL),
(32700, '2017-06-04 11:33:01', NULL, NULL, 9824, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:33:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32701, '2017-06-04 13:32:40', NULL, NULL, 9842, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:32:40', 'admin-1496552111-14965543599506643', 1, 0, '', NULL, NULL, NULL),
(32702, '2017-06-04 13:45:50', NULL, NULL, 9844, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:45:50', 'admin-1496552111-14965551501528970', 1, 0, '', 1, NULL, NULL),
(32703, '2017-06-04 14:04:53', NULL, NULL, 9845, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1496556838', 'admin', '2017-06-04 14:04:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32704, '2017-06-04 14:08:30', NULL, NULL, 9845, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 14:08:30', 'admin-1496552111-14965565098129185', 1, 1, 'SR', NULL, NULL, NULL),
(32705, '2017-06-04 14:08:30', NULL, NULL, 9845, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 14:08:30', 'admin-1496552111-14965565098129185', 1, 1, 'SR', NULL, NULL, NULL),
(32706, '2017-06-04 14:08:30', NULL, NULL, 9845, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 14:08:30', 'admin-1496552111-14965565098129185', 1, 0, '', NULL, NULL, NULL),
(32707, '2017-06-04 14:09:40', NULL, NULL, 9845, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 14:09:40', 'admin-1496552111-14965565805432780', 1, 0, '', NULL, NULL, NULL),
(32708, '2017-06-04 14:10:00', NULL, NULL, 9845, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 14:10:00', 'admin-1496552111-14965566005944812', 1, 1, 'SR', NULL, NULL, NULL),
(32709, '2017-06-04 13:38:02', NULL, NULL, 9843, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:38:02', 'admin-1496552111-14965546823999779', 1, 1, 'SR', NULL, NULL, NULL),
(32710, '2017-06-04 13:38:02', NULL, NULL, 9843, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:38:02', 'admin-1496552111-14965546823999779', 1, 1, 'SR', NULL, NULL, NULL),
(32711, '2017-06-04 13:38:02', NULL, NULL, 9843, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:38:02', 'admin-1496552111-14965546823999779', 1, 1, 'SR', NULL, NULL, NULL),
(32712, '2017-06-04 12:47:02', NULL, NULL, 9836, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:47:02', 'admin-1496549123-1496551622399954', 1, 0, '', NULL, NULL, NULL),
(32713, '2017-06-04 13:04:23', NULL, NULL, 9832, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:04:23', 'admin-1496552111-14965526630184830', 1, 0, '', NULL, NULL, NULL),
(32714, '2017-06-04 12:41:11', NULL, NULL, 9834, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:41:11', 'admin-1496549123-14965512712883790', 1, 1, 'SR', NULL, NULL, NULL),
(32715, '2017-06-04 14:10:00', NULL, NULL, 9845, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 14:10:00', 'admin-1496552111-14965566005944812', 1, 1, 'SR', NULL, NULL, NULL),
(32716, '2017-06-04 14:12:50', NULL, NULL, 9846, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1496556838', 'admin', '2017-06-04 14:12:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32717, '2017-06-04 14:12:56', NULL, NULL, 9846, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 14:12:56', 'admin-1496552111-14965567763656586', 1, 1, 'SR', NULL, NULL, NULL),
(32718, '2017-06-04 14:52:09', NULL, NULL, 9847, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 14:52:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32719, '2017-06-04 12:24:59', NULL, NULL, 9831, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:24:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32720, '2017-06-04 12:25:12', NULL, NULL, 9831, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:25:12', 'admin-1496549123-14965503127759334', 1, 0, '', NULL, NULL, NULL),
(32721, '2017-06-04 14:52:15', NULL, NULL, 9847, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 14:52:15', 'admin-1496556838-14965591356191223', 1, 1, 'SR', NULL, NULL, NULL),
(32722, '2017-06-04 14:52:15', NULL, NULL, 9847, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 14:52:15', 'admin-1496556838-14965591356191223', 1, 1, 'SR', NULL, NULL, NULL),
(32723, '2017-06-04 13:38:38', NULL, NULL, 9843, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:38:38', 'admin-1496552111-14965547180438988', 1, 1, 'SR', NULL, NULL, NULL),
(32724, '2017-06-04 13:38:02', NULL, NULL, 9843, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:38:02', 'admin-1496552111-14965546823999779', 1, 1, 'SR', NULL, NULL, NULL),
(32725, '2017-06-04 13:38:02', NULL, NULL, 9843, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:38:02', 'admin-1496552111-14965546823999779', 1, 1, 'SR', NULL, NULL, NULL),
(32726, '2017-06-04 13:38:02', NULL, NULL, 9843, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:38:02', 'admin-1496552111-14965546823999779', 1, 1, 'SR', NULL, NULL, NULL),
(32727, '2017-06-04 13:38:02', NULL, NULL, 9843, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:38:02', 'admin-1496552111-14965546823999779', 1, 0, '', NULL, NULL, NULL),
(32728, '2017-06-04 13:38:02', NULL, NULL, 9843, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:38:02', 'admin-1496552111-14965546823999779', 1, 1, 'SR', NULL, NULL, NULL),
(32729, '2017-06-04 13:32:40', NULL, NULL, 9842, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:32:40', 'admin-1496552111-14965543599506643', 1, 1, 'SR', NULL, NULL, NULL),
(32730, '2017-06-04 13:37:25', NULL, NULL, 9843, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.50, 0.0000, 0.0000, 11.50, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:37:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32731, '2017-06-04 13:32:40', NULL, NULL, 9842, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:32:40', 'admin-1496552111-14965543599506643', 1, 0, '', NULL, NULL, NULL),
(32732, '2017-06-04 13:32:40', NULL, NULL, 9842, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:32:40', 'admin-1496552111-14965543599506643', 1, 1, 'SR', NULL, NULL, NULL),
(32733, '2017-06-04 13:32:30', NULL, NULL, 9842, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:32:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32734, '2017-06-04 13:32:40', NULL, NULL, 9842, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:32:40', 'admin-1496552111-14965543599506643', 1, 1, 'SR', NULL, NULL, NULL),
(32735, '2017-06-04 13:21:22', NULL, NULL, 9837, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:21:22', 'admin-1496552111-14965536819778788', 1, 1, 'SR', NULL, NULL, NULL),
(32736, '2017-06-04 13:21:22', NULL, NULL, 9837, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:21:22', 'admin-1496552111-14965536819778788', 1, 1, 'SR', NULL, NULL, NULL),
(32737, '2017-06-04 12:47:02', NULL, NULL, 9836, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:47:02', 'admin-1496549123-1496551622399954', 1, 1, 'SR', NULL, NULL, NULL),
(32738, '2017-06-04 12:10:36', NULL, NULL, 9829, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:10:36', 'admin-1496549123-14965494363354564', 1, 1, 'SR', NULL, NULL, NULL),
(32739, '2017-06-04 12:10:36', NULL, NULL, 9829, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:10:36', 'admin-1496549123-14965494363354564', 1, 1, 'SR', NULL, NULL, NULL),
(32740, '2017-06-04 13:21:16', NULL, NULL, 9837, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1496556838', 'admin', '2017-06-04 13:21:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32741, '2017-06-04 12:41:11', NULL, NULL, 9834, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:41:11', 'admin-1496549123-14965512712883790', 1, 1, 'SR', NULL, NULL, NULL),
(32742, '2017-06-04 12:41:11', NULL, NULL, 9834, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:41:11', 'admin-1496549123-14965512712883790', 1, 0, '', NULL, NULL, NULL),
(32743, '2017-06-04 12:32:47', NULL, NULL, 9832, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:32:47', 'admin-1496549123-1496550767516828', 1, 0, '', NULL, NULL, NULL),
(32744, '2017-06-04 12:29:40', NULL, NULL, 9833, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:29:40', 'admin-1496549123-14965505806695679', 1, 1, 'SR', NULL, NULL, NULL),
(32745, '2017-06-04 12:33:05', NULL, NULL, 9829, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:33:05', 'admin-1496549123-14965507856091332', 1, 0, '', NULL, NULL, NULL),
(32746, '2017-06-04 12:32:47', NULL, NULL, 9832, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:32:47', 'admin-1496549123-1496550767516828', 1, 0, '', NULL, NULL, NULL),
(32747, '2017-06-04 12:29:40', NULL, NULL, 9833, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:29:40', 'admin-1496549123-14965505806695679', 1, 1, 'SR', NULL, NULL, NULL),
(32748, '2017-06-04 12:12:28', NULL, NULL, 9830, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:12:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32749, '2017-06-04 12:29:40', NULL, NULL, 9833, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:29:40', 'admin-1496549123-14965505806695679', 1, 0, '', NULL, NULL, NULL),
(32750, '2017-06-04 12:29:25', NULL, NULL, 9833, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:29:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32751, '2017-06-04 12:26:02', NULL, NULL, 9832, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:26:02', 'admin-1496549123-14965503626365645', 1, 0, '', NULL, NULL, NULL),
(32752, '2017-06-04 12:12:33', NULL, NULL, 9830, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:12:33', 'admin-1496549123-14965495536999333', 1, 1, 'SR', NULL, NULL, NULL),
(32753, '2017-06-04 11:49:09', NULL, NULL, 9827, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:49:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32754, '2017-06-04 11:43:57', NULL, NULL, 9826, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:43:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32755, '2017-06-04 11:44:13', NULL, NULL, 9826, 0, 157, '91', 'French Toast with Fruits', 'no Banana', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:44:13', 'admin-1496546186-14965478533199728', 1, 0, '', NULL, NULL, NULL),
(32756, '2017-06-04 11:44:13', NULL, NULL, 9826, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:44:13', 'admin-1496546186-14965478533199728', 1, 0, '', NULL, NULL, NULL),
(32757, '2017-06-04 11:44:13', NULL, NULL, 9826, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:44:13', 'admin-1496546186-14965478533199728', 1, 1, 'SR', NULL, NULL, NULL),
(32758, '2017-06-04 11:44:13', NULL, NULL, 9826, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:44:13', 'admin-1496546186-14965478533199728', 1, 1, 'SR', NULL, NULL, NULL),
(32759, '2017-06-04 12:32:47', NULL, NULL, 9832, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:32:47', 'admin-1496549123-1496550767516828', 1, 1, 'SR', NULL, NULL, NULL),
(32760, '2017-06-04 11:50:05', NULL, NULL, 9827, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:50:05', 'admin-1496546186-14965482055818148', 1, 1, 'SR', NULL, NULL, NULL),
(32761, '2017-06-04 11:50:05', NULL, NULL, 9827, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:50:05', 'admin-1496546186-14965482055818148', 1, 1, 'SR', NULL, NULL, NULL),
(32762, '2017-06-04 11:50:05', NULL, NULL, 9827, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:50:05', 'admin-1496546186-14965482055818148', 1, 1, 'SR', NULL, NULL, NULL),
(32763, '2017-06-04 11:50:05', NULL, NULL, 9827, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:50:05', 'admin-1496546186-14965482055818148', 1, 1, 'SR', NULL, NULL, NULL),
(32764, '2017-06-04 11:50:05', NULL, NULL, 9827, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:50:05', 'admin-1496546186-14965482055818148', 1, 0, '', NULL, NULL, NULL),
(32765, '2017-06-04 12:03:55', NULL, NULL, 9827, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:03:55', 'admin-1496549024-14965490348048139', 1, 0, '', NULL, NULL, NULL),
(32766, '2017-06-04 12:06:15', NULL, NULL, 9828, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:06:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32767, '2017-06-04 12:06:23', NULL, NULL, 9828, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:06:23', 'admin-1496549123-14965491829161420', 1, 1, 'SR', NULL, NULL, NULL),
(32768, '2017-06-04 12:06:23', NULL, NULL, 9828, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:06:23', 'admin-1496549123-14965491829161420', 1, 1, 'SR', NULL, NULL, NULL),
(32769, '2017-06-04 12:10:36', NULL, NULL, 9829, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:10:36', 'admin-1496549123-14965494363354564', 1, 0, '', NULL, NULL, NULL),
(32770, '2017-06-04 12:10:36', NULL, NULL, 9829, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:10:36', 'admin-1496549123-14965494363354564', 1, 0, '', NULL, NULL, NULL),
(32771, '2017-06-04 12:10:10', NULL, NULL, 9829, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.60, 0.0000, 0.0000, 10.60, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:10:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32772, '2017-06-04 12:10:36', NULL, NULL, 9829, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:10:36', 'admin-1496549123-14965494363354564', 1, 0, '', NULL, NULL, NULL),
(32773, '2017-06-04 10:32:19', NULL, NULL, 9814, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:32:19', 'admin-1496542619-14965435389218534', 1, 0, '', NULL, NULL, NULL),
(32774, '2017-06-04 12:10:36', NULL, NULL, 9829, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 12:10:36', 'admin-1496549123-14965494363354564', 1, 0, '', NULL, NULL, NULL),
(32775, '2017-06-04 11:49:17', NULL, NULL, 9827, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:49:17', 'admin-1496546186-14965481568998273', 1, 0, '', NULL, NULL, NULL),
(32776, '2017-06-04 10:17:15', NULL, NULL, 9811, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:17:15', 'admin-1496542619-14965426350299655', 1, 1, 'SR', NULL, NULL, NULL),
(32777, '2017-06-04 10:17:15', NULL, NULL, 9811, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:17:15', 'admin-1496542619-14965426350299655', 1, 0, '', NULL, NULL, NULL),
(32778, '2017-06-04 10:17:29', NULL, NULL, 9812, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:17:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32779, '2017-06-04 10:17:43', NULL, NULL, 9812, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:17:43', 'admin-1496542619-14965426636544254', 1, 0, '', NULL, NULL, NULL),
(32780, '2017-06-04 10:17:43', NULL, NULL, 9812, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:17:43', 'admin-1496542619-14965426636544254', 1, 0, '', NULL, NULL, NULL),
(32781, '2017-06-04 10:17:43', NULL, NULL, 9812, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:17:43', 'admin-1496542619-14965426636544254', 1, 1, 'SR', NULL, NULL, NULL),
(32782, '2017-06-04 10:20:44', NULL, NULL, 9812, 0, 181, '116', 'Open Food ', 'scramble egg', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:20:44', 'admin-1496542619-14965428443479569', 1, 0, '', NULL, NULL, NULL),
(32783, '2017-06-04 10:27:36', NULL, NULL, 9813, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:27:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32784, '2017-06-04 10:27:39', NULL, NULL, 9813, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:27:39', 'admin-1496542619-14965432594273782', 1, 1, 'SR', NULL, NULL, NULL),
(32785, '2017-06-04 10:29:01', NULL, NULL, 9810, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:29:01', 'admin-1496542619-14965433409801418', 1, 0, '', NULL, NULL, NULL),
(32786, '2017-06-04 09:23:59', NULL, NULL, 9805, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 09:23:59', 'admin-1496537016-14965394393623630', 1, 0, '', NULL, NULL, NULL),
(32787, '2017-06-04 09:23:59', NULL, NULL, 9805, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 09:23:59', 'admin-1496537016-14965394393623630', 1, 1, 'SR', NULL, NULL, NULL),
(32788, '2017-06-04 09:31:11', NULL, NULL, 9806, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1496556838', 'admin', '2017-06-04 09:31:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32789, '2017-06-04 09:31:27', NULL, NULL, 9806, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 09:31:27', 'admin-1496537016-14965398872668316', 1, 1, 'SR', NULL, NULL, NULL),
(32790, '2017-06-04 09:31:27', NULL, NULL, 9806, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 09:31:27', 'admin-1496537016-14965398872668316', 1, 1, 'SR', NULL, NULL, NULL),
(32791, '2017-06-04 09:31:27', NULL, NULL, 9806, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 09:31:27', 'admin-1496537016-14965398872668316', 1, 0, '', NULL, NULL, NULL),
(32792, '2017-06-04 09:31:27', NULL, NULL, 9806, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 09:31:27', 'admin-1496537016-14965398872668316', 1, 0, '', NULL, NULL, NULL),
(32793, '2017-06-04 09:31:43', NULL, NULL, 9807, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1496556838', 'admin', '2017-06-04 09:31:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32794, '2017-06-04 11:43:55', NULL, NULL, 9825, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:43:55', 'admin-1496546186-14965478350081419', 1, 1, 'SR', NULL, NULL, NULL),
(32795, '2017-06-04 11:43:55', NULL, NULL, 9825, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:43:55', 'admin-1496546186-14965478350081419', 1, 1, 'SR', NULL, NULL, NULL),
(32796, '2017-06-04 11:43:55', NULL, NULL, 9825, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:43:55', 'admin-1496546186-14965478350081419', 1, 0, '', NULL, NULL, NULL),
(32797, '2017-06-04 11:43:55', NULL, NULL, 9825, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:43:55', 'admin-1496546186-14965478350081419', 1, 0, '', NULL, NULL, NULL),
(32798, '2017-06-04 11:43:55', NULL, NULL, 9825, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:43:55', 'admin-1496546186-14965478350081419', 1, 0, '', NULL, NULL, NULL),
(32799, '2017-06-04 10:00:25', NULL, NULL, 9808, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 19.90, 0.0000, 0.0000, 19.90, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:00:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32800, '2017-06-04 10:00:54', NULL, NULL, 9808, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:00:54', 'admin-1496537016-14965416542528112', 1, 0, '', NULL, NULL, NULL),
(32801, '2017-06-04 10:00:54', NULL, NULL, 9808, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:00:54', 'admin-1496537016-14965416542528112', 1, 0, '', NULL, NULL, NULL),
(32802, '2017-06-04 10:16:33', NULL, NULL, 9811, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:16:33', 'admin-1496537016-14965425930817999', 1, 0, '', NULL, NULL, NULL),
(32803, '2017-06-04 11:04:55', NULL, NULL, 9819, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:04:55', 'admin-1496544263-14965454951381087', 1, 1, 'SR', NULL, NULL, NULL),
(32804, '2017-06-04 10:51:21', NULL, NULL, 9813, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:51:21', 'admin-1496544263-14965446812863411', 1, 1, 'SR', NULL, NULL, NULL),
(32805, '2017-06-04 11:09:58', NULL, NULL, 9821, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:09:58', 'admin-1496544263-14965457987758492', 1, 0, '', NULL, NULL, NULL),
(32806, '2017-06-04 11:08:34', NULL, NULL, 9820, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:08:34', 'admin-1496544263-14965457140674920', 1, 1, 'SR', NULL, NULL, NULL),
(32807, '2017-06-04 11:08:23', NULL, NULL, 9820, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:08:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32808, '2017-06-04 11:04:49', NULL, NULL, 9819, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:04:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32809, '2017-06-04 11:04:55', NULL, NULL, 9819, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:04:55', 'admin-1496544263-14965454951381087', 1, 0, '', NULL, NULL, NULL),
(32810, '2017-06-04 10:49:12', NULL, NULL, 9818, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:49:12', 'admin-1496544263-1496544552282688', 1, 1, 'SR', 1, NULL, NULL),
(32811, '2017-06-04 11:43:46', NULL, NULL, 9825, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 11:43:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32812, '2017-06-04 10:44:11', NULL, NULL, 9817, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:44:11', 'admin-1496542619-14965442513739439', 1, 1, 'SR', NULL, NULL, NULL),
(32813, '2017-06-04 10:40:25', NULL, NULL, 9816, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:40:25', 'admin-1496542619-14965440248745642', 1, 1, 'SR', 1, NULL, NULL),
(32814, '2017-06-04 10:38:41', NULL, NULL, 9815, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:38:41', 'admin-1496542619-14965439215731126', 1, 0, '', NULL, NULL, NULL),
(32815, '2017-06-04 10:38:41', NULL, NULL, 9815, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:38:41', 'admin-1496542619-14965439215731126', 1, 1, 'SR', NULL, NULL, NULL),
(32816, '2017-06-04 10:38:32', NULL, NULL, 9815, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:38:32', 'admin-1496542619-14965439118783480', 1, 0, '', NULL, NULL, NULL),
(32817, '2017-06-04 10:38:32', NULL, NULL, 9815, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:38:32', 'admin-1496542619-14965439118783480', 1, 0, '', NULL, NULL, NULL),
(32818, '2017-06-04 10:38:24', NULL, NULL, 9815, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:38:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32819, '2017-06-04 10:32:44', NULL, NULL, 9814, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:32:44', 'admin-1496542619-1496543564099956', 1, 0, '', NULL, NULL, NULL),
(32820, '2017-06-04 10:32:44', NULL, NULL, 9814, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:32:44', 'admin-1496542619-1496543564099956', 1, 1, 'SR', NULL, NULL, NULL),
(32821, '2017-06-04 10:32:44', NULL, NULL, 9814, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:32:44', 'admin-1496542619-1496543564099956', 1, 1, 'SR', NULL, NULL, NULL),
(32822, '2017-06-04 10:32:19', NULL, NULL, 9814, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:32:19', 'admin-1496542619-14965435389218534', 1, 0, '', NULL, NULL, NULL),
(32823, '2017-06-04 10:32:19', NULL, NULL, 9814, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:32:19', 'admin-1496542619-14965435389218534', 1, 0, '', NULL, NULL, NULL),
(32824, '2017-06-04 10:32:08', NULL, NULL, 9814, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:32:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32825, '2017-06-04 10:16:25', NULL, NULL, 9811, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:16:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32826, '2017-06-04 10:16:33', NULL, NULL, 9811, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:16:33', 'admin-1496537016-14965425930817999', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(32827, '2017-06-04 10:09:54', NULL, NULL, 9810, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:09:54', 'admin-1496537016-1496542194606596', 1, 0, '', NULL, NULL, NULL),
(32828, '2017-06-04 10:09:54', NULL, NULL, 9810, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:09:54', 'admin-1496537016-1496542194606596', 1, 0, '', NULL, NULL, NULL),
(32829, '2017-06-04 10:06:04', NULL, NULL, 9809, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:06:04', 'admin-1496537016-14965419645881255', 1, 1, 'SR', NULL, NULL, NULL),
(32830, '2017-06-04 10:06:04', NULL, NULL, 9809, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:06:04', 'admin-1496537016-14965419645881255', 1, 1, 'SR', NULL, NULL, NULL),
(32831, '2017-06-04 10:05:24', NULL, NULL, 9809, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:05:24', 'admin-1496537016-14965419242231769', 1, 0, '', NULL, NULL, NULL),
(32832, '2017-06-04 10:05:24', NULL, NULL, 9809, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:05:24', 'admin-1496537016-14965419242231769', 1, 0, '', NULL, NULL, NULL),
(32833, '2017-06-04 10:05:24', NULL, NULL, 9809, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:05:24', 'admin-1496537016-14965419242231769', 1, 0, '', NULL, NULL, NULL),
(32834, '2017-06-04 10:05:09', NULL, NULL, 9809, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:05:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32835, '2017-06-04 10:01:32', NULL, NULL, 9808, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:01:32', 'admin-1496537016-14965416923265476', 1, 1, 'SR', NULL, NULL, NULL),
(32836, '2017-06-04 10:01:32', NULL, NULL, 9808, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:01:32', 'admin-1496537016-14965416923265476', 1, 1, 'SR', NULL, NULL, NULL),
(32837, '2017-06-04 10:01:32', NULL, NULL, 9808, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:01:32', 'admin-1496537016-14965416923265476', 1, 0, '', NULL, NULL, NULL),
(32838, '2017-06-04 10:01:32', NULL, NULL, 9808, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:01:32', 'admin-1496537016-14965416923265476', 1, 1, 'SR', NULL, NULL, NULL),
(32839, '2017-06-04 10:01:32', NULL, NULL, 9808, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:01:32', 'admin-1496537016-14965416923265476', 1, 1, 'SR', NULL, NULL, NULL),
(32840, '2017-06-04 10:01:32', NULL, NULL, 9808, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:01:32', 'admin-1496537016-14965416923265476', 1, 1, 'SR', NULL, NULL, NULL),
(32841, '2017-06-04 10:01:32', NULL, NULL, 9808, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:01:32', 'admin-1496537016-14965416923265476', 1, 0, '', NULL, NULL, NULL),
(32842, '2017-06-04 10:00:54', NULL, NULL, 9808, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:00:54', 'admin-1496537016-14965416542528112', 1, 0, '', NULL, NULL, NULL),
(32843, '2017-06-04 10:00:54', NULL, NULL, 9808, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:00:54', 'admin-1496537016-14965416542528112', 1, 0, '', NULL, NULL, NULL),
(32844, '2017-06-04 10:00:54', NULL, NULL, 9808, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:00:54', 'admin-1496537016-14965416542528112', 1, 0, '', NULL, NULL, NULL),
(32845, '2017-06-04 10:00:54', NULL, NULL, 9808, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 10:00:54', 'admin-1496537016-14965416542528112', 1, 0, '', NULL, NULL, NULL),
(32846, '2017-06-04 09:37:33', NULL, NULL, 9807, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 09:37:33', 'admin-1496537016-14965402532871162', 1, 0, '', NULL, NULL, NULL),
(32847, '2017-06-04 09:31:47', NULL, NULL, 9807, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496556838', 'admin', '2017-06-04 09:31:47', 'admin-1496537016-14965399076075010', 1, 0, '', NULL, NULL, NULL),
(32848, '2017-06-04 09:23:11', NULL, NULL, 9805, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1496556838', 'admin', '2017-06-04 09:23:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32849, '2017-06-05 14:44:42', NULL, NULL, 9861, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 14:44:42', 'admin-1496641340-14966450822879674', 1, 0, '', NULL, NULL, NULL),
(32850, '2017-06-05 09:50:10', NULL, NULL, 9853, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:50:10', 'admin-1496624231-14966274100882128', 1, 1, 'SR', NULL, NULL, NULL),
(32851, '2017-06-05 09:50:10', NULL, NULL, 9853, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:50:10', 'admin-1496624231-14966274100882128', 1, 0, '', NULL, NULL, NULL),
(32852, '2017-06-05 14:17:20', NULL, NULL, 9866, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1496641340', 'admin', '2017-06-05 14:17:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32853, '2017-06-05 14:17:27', NULL, NULL, 9866, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 14:17:27', 'admin-1496641340-14966434472411439', 1, 0, '', NULL, NULL, NULL),
(32854, '2017-06-05 10:15:19', NULL, NULL, 9854, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 10:15:19', 'admin-1496624231-14966289196996761', 1, 1, 'SR', NULL, NULL, NULL),
(32855, '2017-06-05 10:18:54', NULL, NULL, 9854, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 10:18:54', 'admin-1496624231-14966291344691278', 1, 0, '', NULL, NULL, NULL),
(32856, '2017-06-05 17:20:01', NULL, NULL, 9867, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 17:20:01', 'admin-1496641340-14966544009306150', 1, 1, 'SR', NULL, NULL, NULL),
(32857, '2017-06-05 17:20:01', NULL, NULL, 9867, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 17:20:01', 'admin-1496641340-14966544009306150', 1, 1, 'SR', NULL, NULL, NULL),
(32858, '2017-06-05 09:39:20', NULL, NULL, 9850, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:39:20', 'admin-1496624231-1496626759966183', 1, 0, '', NULL, NULL, NULL),
(32859, '2017-06-05 09:39:20', NULL, NULL, 9850, 0, 153, '87', 'Wake Me Up!', 'No bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:39:20', 'admin-1496624231-1496626759966183', 1, 0, '', NULL, NULL, NULL),
(32860, '2017-06-05 09:39:20', NULL, NULL, 9850, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:39:20', 'admin-1496624231-1496626759966183', 1, 1, 'SR', NULL, NULL, NULL),
(32861, '2017-06-05 16:10:19', NULL, NULL, 9868, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 16:10:19', 'admin-1496641340-14966502188801450', 1, 1, 'SR', 1, NULL, NULL),
(32862, '2017-06-05 14:45:02', NULL, NULL, 9870, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 14:45:02', 'admin-1496641340-14966451026314562', 1, 0, '', NULL, NULL, NULL),
(32863, '2017-06-05 14:45:02', NULL, NULL, 9870, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 14:45:02', 'admin-1496641340-14966451026314562', 1, 0, '', NULL, NULL, NULL),
(32864, '2017-06-05 14:50:19', NULL, NULL, 9861, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 14:50:19', 'admin-1496641340-14966454197732962', 1, 0, '', NULL, NULL, NULL),
(32865, '2017-06-05 15:02:15', NULL, NULL, 9872, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 15:02:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32866, '2017-06-05 15:02:19', NULL, NULL, 9872, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 15:02:19', 'admin-1496641340-14966461395515246', 1, 1, 'SR', NULL, NULL, NULL),
(32867, '2017-06-05 15:11:49', NULL, NULL, 9867, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 15:11:49', 'admin-1496641340-14966467088711184', 1, 1, 'SR', NULL, NULL, NULL),
(32868, '2017-06-05 15:11:49', NULL, NULL, 9867, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 15:11:49', 'admin-1496641340-14966467088711184', 1, 1, 'SR', NULL, NULL, NULL),
(32869, '2017-06-05 15:11:49', NULL, NULL, 9867, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 15:11:49', 'admin-1496641340-14966467088711184', 1, 1, 'SR', NULL, NULL, NULL),
(32870, '2017-06-05 14:18:03', NULL, NULL, 9866, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 14:18:03', 'admin-1496641340-14966434833553322', 1, 1, 'SR', NULL, NULL, NULL),
(32871, '2017-06-05 14:19:02', NULL, NULL, 9867, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 21.00, 0.0000, 0.0000, 21.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 14:19:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32872, '2017-06-05 14:19:05', NULL, NULL, 9867, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 14:19:05', 'admin-1496641340-1496643545556289', 1, 0, '', NULL, NULL, NULL),
(32873, '2017-06-05 12:57:31', NULL, NULL, 9859, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1496641340', 'admin', '2017-06-05 12:57:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32874, '2017-06-05 12:57:42', NULL, NULL, 9859, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 12:57:42', 'admin-1496635131-14966386627914712', 1, 0, '', NULL, NULL, NULL),
(32875, '2017-06-05 12:57:42', NULL, NULL, 9859, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 12:57:42', 'admin-1496635131-14966386627914712', 1, 1, 'SR', NULL, NULL, NULL),
(32876, '2017-06-05 12:57:42', NULL, NULL, 9859, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 12:57:42', 'admin-1496635131-14966386627914712', 1, 1, 'SR', NULL, NULL, NULL),
(32877, '2017-06-05 12:57:42', NULL, NULL, 9859, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 12:57:42', 'admin-1496635131-14966386627914712', 1, 1, 'SR', NULL, NULL, NULL),
(32878, '2017-06-05 13:11:16', NULL, NULL, 9860, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 13:11:16', 'admin-1496635131-14966394763431369', 1, 1, 'SR', 1, NULL, NULL),
(32879, '2017-06-05 13:14:37', NULL, NULL, 9856, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 13:14:37', 'admin-1496635131-1496639677605560', 1, 1, 'SR', NULL, NULL, NULL),
(32880, '2017-06-05 17:23:13', NULL, NULL, 9867, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 17:23:13', 'admin-1496641340-14966545929604447', 1, 1, 'SR', NULL, NULL, NULL),
(32881, '2017-06-05 17:20:06', NULL, NULL, 9873, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 17:20:06', 'admin-1496641340-14966544061271645', 1, 0, '', NULL, NULL, NULL),
(32882, '2017-06-05 17:08:48', NULL, NULL, 9873, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1496641340', 'admin', '2017-06-05 17:08:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32883, '2017-06-05 17:08:52', NULL, NULL, 9873, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 17:08:52', 'admin-1496641340-14966537317474816', 1, 1, 'SR', NULL, NULL, NULL),
(32884, '2017-06-05 13:40:57', NULL, NULL, 9861, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1496641340', 'admin', '2017-06-05 13:40:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32885, '2017-06-05 13:42:29', NULL, NULL, 9862, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1496641340', 'admin', '2017-06-05 13:42:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32886, '2017-06-05 13:42:34', NULL, NULL, 9862, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 13:42:34', 'admin-1496641340-14966413546674819', 1, 0, '', NULL, NULL, NULL),
(32887, '2017-06-05 13:42:34', NULL, NULL, 9862, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 13:42:34', 'admin-1496641340-14966413546674819', 1, 0, '', NULL, NULL, NULL),
(32888, '2017-06-05 13:42:43', NULL, NULL, 9862, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 13:42:43', 'admin-1496641340-14966413632836992', 1, 0, '', NULL, NULL, NULL),
(32889, '2017-06-05 13:42:43', NULL, NULL, 9862, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 13:42:43', 'admin-1496641340-14966413632836992', 1, 1, 'SR', NULL, NULL, NULL),
(32890, '2017-06-05 13:52:16', NULL, NULL, 9861, 0, 181, '116', 'Open Food ', 'pork chop', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 13:52:16', 'admin-1496641340-14966419365061059', 1, 0, '', NULL, NULL, NULL),
(32891, '2017-06-05 13:52:16', NULL, NULL, 9861, 0, 181, '116', 'Open Food ', 'garlic chicken', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 13:52:16', 'admin-1496641340-14966419365061059', 1, 0, '', NULL, NULL, NULL),
(32892, '2017-06-05 13:53:01', NULL, NULL, 9863, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1496641340', 'admin', '2017-06-05 13:53:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32893, '2017-06-05 13:53:14', NULL, NULL, 9863, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 13:53:14', 'admin-1496641340-149664199455259', 1, 0, '', NULL, NULL, NULL),
(32894, '2017-06-05 13:53:14', NULL, NULL, 9863, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 13:53:14', 'admin-1496641340-149664199455259', 1, 0, '', NULL, NULL, NULL),
(32895, '2017-06-05 13:53:14', NULL, NULL, 9863, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 13:53:14', 'admin-1496641340-149664199455259', 1, 1, 'SR', NULL, NULL, NULL),
(32896, '2017-06-05 13:59:52', NULL, NULL, 9864, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 13:59:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32897, '2017-06-05 13:59:57', NULL, NULL, 9864, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 13:59:57', 'admin-1496641340-14966423970426891', 1, 1, 'SR', NULL, NULL, NULL),
(32898, '2017-06-05 13:59:57', NULL, NULL, 9864, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 13:59:57', 'admin-1496641340-14966423970426891', 1, 1, 'SR', NULL, NULL, NULL),
(32899, '2017-06-05 14:01:29', NULL, NULL, 9856, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 14:01:29', 'admin-1496641340-14966424896209378', 1, 0, '', NULL, NULL, NULL),
(32900, '2017-06-05 14:05:19', NULL, NULL, 9865, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 14:05:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32901, '2017-06-05 14:05:29', NULL, NULL, 9865, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 14:05:29', 'admin-1496641340-1496642729717431', 1, 1, 'SR', NULL, NULL, NULL),
(32902, '2017-06-05 16:31:17', NULL, NULL, 9867, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 16:31:17', 'admin-1496641340-14966514778174824', 1, 1, 'SR', NULL, NULL, NULL),
(32903, '2017-06-05 16:31:17', NULL, NULL, 9867, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 16:31:17', 'admin-1496641340-14966514778174824', 1, 1, 'SR', NULL, NULL, NULL),
(32904, '2017-06-05 16:31:17', NULL, NULL, 9867, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 16:31:17', 'admin-1496641340-14966514778174824', 1, 0, '', NULL, NULL, NULL),
(32905, '2017-06-05 14:19:05', NULL, NULL, 9867, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 14:19:05', 'admin-1496641340-1496643545556289', 1, 0, '', NULL, NULL, NULL),
(32906, '2017-06-05 09:25:36', NULL, NULL, 9849, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:25:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32907, '2017-06-05 09:25:47', NULL, NULL, 9849, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:25:47', 'admin-1496624231-1496625947344126', 1, 0, '', NULL, NULL, NULL),
(32908, '2017-06-05 10:35:42', NULL, NULL, 9855, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.65, 0.0000, 0.0000, 2.65, 1, '27', 1, '1496641340', 'admin', '2017-06-05 10:35:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32909, '2017-06-05 14:30:45', NULL, NULL, 9869, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1496641340', 'admin', '2017-06-05 14:30:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32910, '2017-06-05 14:30:05', NULL, NULL, 9868, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 2, 11.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 14:30:05', 'admin-1496641340-14966442056337149', 1, 1, 'SR', 1, NULL, NULL),
(32911, '2017-06-05 14:24:25', NULL, NULL, 9861, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 14:24:25', 'admin-1496641340-1496643864884565', 1, 1, 'SR', NULL, NULL, NULL),
(32912, '2017-06-05 14:19:30', NULL, NULL, 9867, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 14:19:30', 'admin-1496641340-14966435698458615', 1, 0, '', NULL, NULL, NULL),
(32913, '2017-06-05 14:19:30', NULL, NULL, 9867, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 14:19:30', 'admin-1496641340-14966435698458615', 1, 1, 'SR', NULL, NULL, NULL),
(32914, '2017-06-05 15:11:49', NULL, NULL, 9867, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 15:11:49', 'admin-1496641340-14966467088711184', 1, 1, 'SR', NULL, NULL, NULL),
(32915, '2017-06-05 14:30:51', NULL, NULL, 9869, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 14:30:51', 'admin-1496641340-14966442510684789', 1, 0, '', NULL, NULL, NULL),
(32916, '2017-06-05 11:22:45', NULL, NULL, 9848, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 11:22:45', 'admin-1496624231-14966329653357816', 1, 1, 'SR', NULL, NULL, NULL),
(32917, '2017-06-05 11:53:32', NULL, NULL, 9856, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1496641340', 'admin', '2017-06-05 11:53:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32918, '2017-06-05 11:53:36', NULL, NULL, 9856, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 11:53:36', 'admin-1496624231-14966348161559863', 1, 1, 'SR', NULL, NULL, NULL),
(32919, '2017-06-05 11:59:03', NULL, NULL, 9856, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 11:59:03', 'admin-1496635131-14966351428938927', 1, 0, '', NULL, NULL, NULL),
(32920, '2017-06-05 12:18:42', NULL, NULL, 9857, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1496641340', 'admin', '2017-06-05 12:18:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32921, '2017-06-05 12:18:51', NULL, NULL, 9857, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 12:18:51', 'admin-1496635131-14966363311398663', 1, 1, 'SR', NULL, NULL, NULL),
(32922, '2017-06-05 12:18:51', NULL, NULL, 9857, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 12:18:51', 'admin-1496635131-14966363311398663', 1, 1, 'SR', NULL, NULL, NULL),
(32923, '2017-06-05 12:18:57', NULL, NULL, 9857, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 12:18:57', 'admin-1496635131-14966363377151086', 1, 0, '', NULL, NULL, NULL),
(32924, '2017-06-05 12:18:57', NULL, NULL, 9857, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 12:18:57', 'admin-1496635131-14966363377151086', 1, 0, '', NULL, NULL, NULL),
(32925, '2017-06-05 12:34:31', NULL, NULL, 9858, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1496641340', 'admin', '2017-06-05 12:34:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32926, '2017-06-05 14:17:27', NULL, NULL, 9866, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 14:17:27', 'admin-1496641340-14966434472411439', 1, 0, '', NULL, NULL, NULL),
(32927, '2017-06-05 13:14:42', NULL, NULL, 9856, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 13:14:42', 'admin-1496635131-14966396819952921', 1, 1, 'SR', NULL, NULL, NULL),
(32928, '2017-06-05 12:34:39', NULL, NULL, 9858, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 12:34:39', 'admin-1496635131-14966372789177423', 1, 0, '', NULL, NULL, NULL),
(32929, '2017-06-05 12:34:39', NULL, NULL, 9858, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 12:34:39', 'admin-1496635131-14966372789177423', 1, 1, 'SR', NULL, NULL, NULL),
(32930, '2017-06-05 00:00:00', NULL, NULL, 9855, 0, 284, '218', 'Caramel Waffles', '', 'Desserts', '0', 1, 2.50, NULL, NULL, 2.50, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:33:10', 'admin-1496624231-14966263901443554', 1, 0, '', NULL, NULL, NULL),
(32931, '2017-06-05 09:50:10', NULL, NULL, 9853, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:50:10', 'admin-1496624231-14966274100882128', 1, 0, '', NULL, NULL, NULL),
(32932, '2017-06-05 10:02:20', NULL, NULL, 9850, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 10:02:20', 'admin-1496624231-14966281403993852', 1, 1, 'SR', NULL, NULL, NULL),
(32933, '2017-06-05 10:04:55', NULL, NULL, 9850, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 10:04:55', 'admin-1496624231-1496628294901571', 1, 0, '', NULL, NULL, NULL),
(32934, '2017-06-05 10:09:19', NULL, NULL, 9853, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 10:09:19', 'admin-1496624231-1496628559452499', 1, 0, '', NULL, NULL, NULL),
(32935, '2017-06-05 10:09:23', NULL, NULL, 9853, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 10:09:23', 'admin-1496624231-14966285631351158', 1, 1, 'SR', NULL, NULL, NULL),
(32936, '2017-06-05 10:15:15', NULL, NULL, 9854, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1496641340', 'admin', '2017-06-05 10:15:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32937, '2017-06-05 09:50:10', NULL, NULL, 9853, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:50:10', 'admin-1496624231-14966274100882128', 1, 0, '', NULL, NULL, NULL),
(32938, '2017-06-05 09:50:10', NULL, NULL, 9853, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:50:10', 'admin-1496624231-14966274100882128', 1, 0, '', NULL, NULL, NULL),
(32939, '2017-06-05 09:50:01', NULL, NULL, 9853, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.30, 0.0000, 0.0000, 10.30, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:50:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32940, '2017-06-05 09:40:11', NULL, NULL, 9852, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:40:11', 'admin-1496624231-14966268117294128', 1, 1, 'SR', NULL, NULL, NULL),
(32941, '2017-06-05 09:40:11', NULL, NULL, 9852, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:40:11', 'admin-1496624231-14966268117294128', 1, 1, 'SR', NULL, NULL, NULL),
(32942, '2017-06-05 09:40:11', NULL, NULL, 9852, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:40:11', 'admin-1496624231-14966268117294128', 1, 0, '', NULL, NULL, NULL),
(32943, '2017-06-05 09:40:11', NULL, NULL, 9852, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:40:11', 'admin-1496624231-14966268117294128', 1, 0, '', NULL, NULL, NULL),
(32944, '2017-06-05 09:40:03', NULL, NULL, 9852, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:40:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32945, '2017-06-05 09:39:22', NULL, NULL, 9851, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:39:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32946, '2017-06-05 09:39:25', NULL, NULL, 9851, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:39:25', 'admin-1496624231-1496626765737903', 1, 1, 'SR', NULL, NULL, NULL),
(32947, '2017-06-05 00:00:00', NULL, NULL, 9855, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:32:54', 'admin-1496624231-14966263741971429', 1, 0, '', NULL, NULL, NULL),
(32948, '2017-06-05 09:39:04', NULL, NULL, 9850, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:39:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32949, '2017-06-05 00:00:00', NULL, NULL, 9855, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:25:47', 'admin-1496624231-1496625947344126', 1, 1, 'SR', NULL, NULL, NULL),
(32950, '2017-06-05 09:33:01', NULL, NULL, 9849, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:33:01', 'admin-1496624231-14966263808261883', 1, 1, 'SR', NULL, NULL, NULL),
(32951, '2017-06-05 09:11:05', NULL, NULL, 9848, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:11:05', 'admin-1496624231-14966250649257973', 1, 1, 'SR', NULL, NULL, NULL),
(32952, '2017-06-05 09:13:11', NULL, NULL, 9848, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:13:11', 'admin-1496624231-14966251916296717', 1, 0, '', NULL, NULL, NULL),
(32953, '2017-06-05 09:10:13', NULL, NULL, 9848, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1496641340', 'admin', '2017-06-05 09:10:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32954, '2017-06-07 13:17:03', NULL, NULL, 9881, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1496810669', 'admin', '2017-06-07 13:17:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32955, '2017-06-07 12:56:32', NULL, NULL, 9875, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 12:56:32', 'admin-1496810669-14968113917613672', 1, 1, 'SR', 1, NULL, NULL),
(32956, '2017-06-07 13:23:16', NULL, NULL, 9882, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 13:23:16', 'admin-1496810669-14968129964424441', 1, 1, 'SR', 1, NULL, NULL),
(32957, '2017-06-07 13:54:12', NULL, NULL, 9883, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.10, 0.0000, 0.0000, 11.10, 1, '27', 1, '1496810669', 'admin', '2017-06-07 13:54:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32958, '2017-06-07 13:54:41', NULL, NULL, 9883, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 13:54:41', 'admin-1496810669-14968148807999618', 1, 0, '', NULL, NULL, NULL),
(32959, '2017-06-07 13:54:41', NULL, NULL, 9883, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 13:54:41', 'admin-1496810669-14968148807999618', 1, 1, 'SR', NULL, NULL, NULL),
(32960, '2017-06-07 13:54:41', NULL, NULL, 9883, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 13:54:41', 'admin-1496810669-14968148807999618', 1, 0, '', NULL, NULL, NULL),
(32961, '2017-06-07 11:57:37', NULL, NULL, 9876, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 11:57:37', 'admin-1496797835-14968078570813649', 1, 1, 'SR', NULL, NULL, NULL),
(32962, '2017-06-07 11:57:18', NULL, NULL, 9876, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 11:57:18', 'admin-1496797835-14968078387654541', 1, 1, 'SR', NULL, NULL, NULL),
(32963, '2017-06-07 11:57:18', NULL, NULL, 9876, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 11:57:18', 'admin-1496797835-14968078387654541', 1, 0, '', NULL, NULL, NULL),
(32964, '2017-06-07 11:57:18', NULL, NULL, 9876, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 11:57:18', 'admin-1496797835-14968078387654541', 1, 1, 'SR', NULL, NULL, NULL),
(32965, '2017-06-07 13:54:41', NULL, NULL, 9883, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 13:54:41', 'admin-1496810669-14968148807999618', 1, 1, 'SR', NULL, NULL, NULL),
(32966, '2017-06-07 14:27:19', NULL, NULL, 9885, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 14:27:19', 'admin-1496810669-14968168393337566', 1, 0, '', 1, NULL, NULL),
(32967, '2017-06-07 15:18:38', NULL, NULL, 9886, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1496810669', 'admin', '2017-06-07 15:18:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32968, '2017-06-07 15:18:42', NULL, NULL, 9886, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 15:18:42', 'admin-1496810669-14968199222361878', 1, 0, '', NULL, NULL, NULL),
(32969, '2017-06-07 15:30:00', NULL, NULL, 9887, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 15:30:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32970, '2017-06-07 15:30:35', NULL, NULL, 9887, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 15:30:35', 'admin-1496810669-14968206351544313', 1, 1, 'SR', NULL, NULL, NULL),
(32971, '2017-06-07 15:33:23', NULL, NULL, 9887, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 15:33:23', 'admin-1496810669-14968208029267125', 1, 0, '', NULL, NULL, NULL),
(32972, '2017-06-07 16:22:38', NULL, NULL, 9888, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1496810669', 'admin', '2017-06-07 16:22:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32973, '2017-06-07 13:54:41', NULL, NULL, 9883, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 13:54:41', 'admin-1496810669-14968148807999618', 1, 0, '', NULL, NULL, NULL),
(32974, '2017-06-07 13:54:41', NULL, NULL, 9883, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 13:54:41', 'admin-1496810669-14968148807999618', 1, 1, 'SR', NULL, NULL, NULL),
(32975, '2017-06-07 17:36:41', NULL, NULL, 9890, 0, 168, '102', 'Black & White ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 17:36:41', 'admin-1496810669-14968282014161496', 1, 0, '', 1, NULL, NULL),
(32976, '2017-06-07 10:39:25', NULL, NULL, 9874, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 10:39:25', 'admin-1496797835-14968031655269673', 1, 0, '', NULL, NULL, NULL),
(32977, '2017-06-07 12:14:51', NULL, NULL, 9878, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 12:14:51', 'admin-1496797835-1496808891729906', 1, 1, 'SR', NULL, NULL, NULL),
(32978, '2017-06-07 12:41:32', NULL, NULL, 9879, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 12:41:32', 'admin-1496797835-14968104922582234', 1, 1, 'SR', NULL, NULL, '10.0'),
(32979, '2017-06-07 12:41:32', NULL, NULL, 9879, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 12:41:32', 'admin-1496797835-14968104922582234', 1, 1, 'SR', NULL, NULL, '10.0'),
(32980, '2017-06-07 11:56:24', NULL, NULL, 9876, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.90, 0.0000, 0.0000, 10.90, 1, '27', 1, '1496810669', 'admin', '2017-06-07 11:56:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32981, '2017-06-07 11:57:37', NULL, NULL, 9876, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 11:57:37', 'admin-1496797835-14968078570813649', 1, 1, 'SR', NULL, NULL, NULL),
(32982, '2017-06-07 11:57:37', NULL, NULL, 9876, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 11:57:37', 'admin-1496797835-14968078570813649', 1, 0, '', NULL, NULL, NULL),
(32983, '2017-06-07 11:57:37', NULL, NULL, 9876, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 11:57:37', 'admin-1496797835-14968078570813649', 1, 1, 'SR', NULL, NULL, NULL),
(32984, '2017-06-07 11:58:22', NULL, NULL, 9876, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 11:58:22', 'admin-1496797835-14968079018392215', 1, 0, '', NULL, NULL, NULL),
(32985, '2017-06-07 12:01:54', NULL, NULL, 9877, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1496810669', 'admin', '2017-06-07 12:01:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32986, '2017-06-07 12:02:15', NULL, NULL, 9877, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 12:02:15', 'admin-1496797835-14968081351406885', 1, 1, 'SR', NULL, NULL, NULL),
(32987, '2017-06-07 12:02:15', NULL, NULL, 9877, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 12:02:15', 'admin-1496797835-14968081351406885', 1, 1, 'SR', NULL, NULL, NULL),
(32988, '2017-06-07 12:02:15', NULL, NULL, 9877, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 12:02:15', 'admin-1496797835-14968081351406885', 1, 0, '', NULL, NULL, NULL),
(32989, '2017-06-07 12:02:15', NULL, NULL, 9877, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 12:02:15', 'admin-1496797835-14968081351406885', 1, 0, '', NULL, NULL, NULL),
(32990, '2017-06-07 12:02:15', NULL, NULL, 9877, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 12:02:15', 'admin-1496797835-14968081351406885', 1, 1, 'SR', NULL, NULL, NULL),
(32991, '2017-06-07 16:22:44', NULL, NULL, 9888, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 16:22:44', 'admin-1496810669-14968237644506982', 1, 1, 'SR', NULL, NULL, NULL),
(32992, '2017-06-07 16:51:55', NULL, NULL, 9889, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1496810669', 'admin', '2017-06-07 16:51:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32993, '2017-06-07 16:51:59', NULL, NULL, 9889, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 16:51:59', 'admin-1496810669-1496825519129289', 1, 1, 'SR', NULL, NULL, NULL),
(32994, '2017-06-07 13:54:41', NULL, NULL, 9883, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 13:54:41', 'admin-1496810669-14968148807999618', 1, 0, '', NULL, NULL, NULL),
(32995, '2017-06-07 13:54:41', NULL, NULL, 9883, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 13:54:41', 'admin-1496810669-14968148807999618', 1, 0, '', NULL, NULL, NULL),
(32996, '2017-06-07 13:54:41', NULL, NULL, 9883, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 13:54:41', 'admin-1496810669-14968148807999618', 1, 0, '', NULL, NULL, NULL),
(32997, '2017-06-07 12:14:41', NULL, NULL, 9878, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1496810669', 'admin', '2017-06-07 12:14:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(32998, '2017-06-07 12:41:32', NULL, NULL, 9879, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 3, 15.00, 45.0000, 0.0000, 45.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 12:41:32', 'admin-1496797835-14968104922582234', 1, 0, '', NULL, NULL, '10.0'),
(32999, '2017-06-07 12:41:32', NULL, NULL, 9879, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 12:41:32', 'admin-1496797835-14968104922582234', 1, 1, 'SR', NULL, NULL, '10.0'),
(33000, '2017-06-07 12:44:24', NULL, NULL, 9877, 0, 181, '116', 'Open Food ', 'macadamia scone', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 12:44:24', 'admin-1496797835-14968106646299859', 1, 0, '', NULL, NULL, NULL),
(33001, '2017-06-07 12:54:21', NULL, NULL, 9880, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 12:54:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33002, '2017-06-07 12:54:25', NULL, NULL, 9880, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 12:54:25', 'admin-1496810669-14968112650794979', 1, 1, 'SR', NULL, NULL, NULL),
(33003, '2017-06-07 13:17:09', NULL, NULL, 9881, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 13:17:09', 'admin-1496810669-149681262916553', 1, 0, '', NULL, NULL, NULL),
(33004, '2017-06-07 12:41:32', NULL, NULL, 9879, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 12:41:32', 'admin-1496797835-14968104922582234', 1, 0, '', NULL, NULL, '10.0'),
(33005, '2017-06-07 12:41:32', NULL, NULL, 9879, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 12:41:32', 'admin-1496797835-14968104922582234', 1, 0, '', NULL, NULL, '10.0'),
(33006, '2017-06-07 12:14:51', NULL, NULL, 9878, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 12:14:51', 'admin-1496797835-1496808891729906', 1, 0, '', NULL, NULL, NULL),
(33007, '2017-06-07 12:41:13', NULL, NULL, 9879, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.40, 0.0000, 0.0000, 11.40, 1, '27', 1, '1496810669', 'admin', '2017-06-07 12:41:13', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(33008, '2017-06-07 12:14:51', NULL, NULL, 9878, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 12:14:51', 'admin-1496797835-1496808891729906', 1, 0, '', NULL, NULL, NULL),
(33009, '2017-06-07 11:57:18', NULL, NULL, 9876, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 11:57:18', 'admin-1496797835-14968078387654541', 1, 0, '', NULL, NULL, NULL),
(33010, '2017-06-07 12:02:19', NULL, NULL, 9877, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 12:02:19', 'admin-1496797835-14968081392095231', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(33011, '2017-06-07 11:57:18', NULL, NULL, 9876, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 11:57:18', 'admin-1496797835-14968078387654541', 1, 1, 'SR', NULL, NULL, NULL),
(33012, '2017-06-07 10:39:34', NULL, NULL, 9874, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 10:39:34', 'admin-1496797835-14968031746202432', 1, 0, '', NULL, NULL, NULL),
(33013, '2017-06-07 10:58:17', NULL, NULL, 9875, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 10:58:17', 'admin-1496797835-14968042973385249', 1, 0, '', 1, NULL, NULL),
(33014, '2017-06-07 10:39:34', NULL, NULL, 9874, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 10:39:34', 'admin-1496797835-14968031746202432', 1, 1, 'SR', NULL, NULL, NULL),
(33015, '2017-06-07 10:39:25', NULL, NULL, 9874, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496810669', 'admin', '2017-06-07 10:39:25', 'admin-1496797835-14968031655269673', 1, 0, '', NULL, NULL, NULL),
(33016, '2017-06-07 10:38:34', NULL, NULL, 9874, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1496810669', 'admin', '2017-06-07 10:38:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33017, '2017-06-08 12:02:45', NULL, NULL, 9899, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:02:45', 'admin-1496894388-1496894565296934', 1, 1, 'SR', NULL, NULL, NULL),
(33018, '2017-06-08 12:45:12', NULL, NULL, 9899, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:45:12', 'admin-1496894388-14968971120771760', 1, 1, 'SR', NULL, NULL, NULL),
(33019, '2017-06-08 11:48:42', NULL, NULL, 9897, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 11:48:42', 'admin-1496886869-14968937227669535', 1, 0, '', NULL, NULL, NULL),
(33020, '2017-06-08 11:48:54', NULL, NULL, 9897, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 11:48:54', 'admin-1496886869-14968937345374313', 1, 1, 'SR', NULL, NULL, NULL),
(33021, '2017-06-08 09:44:21', NULL, NULL, 9893, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 09:44:21', 'admin-1496884016-14968862614553819', 1, 0, '', NULL, NULL, NULL),
(33022, '2017-06-08 13:14:29', NULL, NULL, 9905, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 13:14:29', 'admin-1496897411-14968988689966196', 1, 1, 'SR', NULL, NULL, NULL),
(33023, '2017-06-08 13:14:29', NULL, NULL, 9905, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 13:14:29', 'admin-1496897411-14968988689966196', 1, 0, '', NULL, NULL, NULL),
(33024, '2017-06-08 14:08:30', NULL, NULL, 9908, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 14:08:30', 'admin-1496901775-14969021102571936', 1, 1, 'SR', NULL, NULL, NULL),
(33025, '2017-06-08 14:08:30', NULL, NULL, 9908, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 14:08:30', 'admin-1496901775-14969021102571936', 1, 1, 'SR', NULL, NULL, NULL),
(33026, '2017-06-08 13:14:06', NULL, NULL, 9905, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 13:14:06', 'admin-1496897411-14968988467008042', 1, 1, 'SR', NULL, NULL, NULL),
(33027, '2017-06-08 13:02:43', NULL, NULL, 9905, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 13:02:43', 'admin-1496897411-14968981637461533', 1, 0, '', NULL, NULL, NULL),
(33028, '2017-06-08 13:02:43', NULL, NULL, 9905, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 13:02:43', 'admin-1496897411-14968981637461533', 1, 1, 'SR', NULL, NULL, NULL),
(33029, '2017-06-08 13:56:39', NULL, NULL, 9906, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 13:56:39', 'admin-1496897411-14969013991536971', 1, 0, '', NULL, NULL, NULL),
(33030, '2017-06-08 14:03:46', NULL, NULL, 9905, 0, 181, '116', 'Open Food ', 'lemon cheese', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 14:03:46', 'admin-1496901775-14969018261251156', 1, 0, '', NULL, NULL, NULL),
(33031, '2017-06-08 14:08:05', NULL, NULL, 9908, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1496901775', 'admin', '2017-06-08 14:08:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33032, '2017-06-08 14:08:30', NULL, NULL, 9908, 0, 181, '116', 'Open Food ', 'Scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 14:08:30', 'admin-1496901775-14969021102571936', 1, 0, '', NULL, NULL, NULL),
(33033, '2017-06-08 11:49:15', NULL, NULL, 9898, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 11:49:15', 'admin-1496886869-14968937553882041', 1, 0, '', NULL, NULL, NULL),
(33034, '2017-06-08 11:49:15', NULL, NULL, 9898, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 11:49:15', 'admin-1496886869-14968937553882041', 1, 0, '', NULL, NULL, NULL),
(33035, '2017-06-08 12:49:51', NULL, NULL, 9903, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:49:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33036, '2017-06-08 12:50:05', NULL, NULL, 9903, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:50:05', 'admin-1496894388-14968974052312547', 1, 0, '', NULL, NULL, NULL),
(33037, '2017-06-08 12:50:05', NULL, NULL, 9903, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:50:05', 'admin-1496894388-14968974052312547', 1, 0, '', NULL, NULL, NULL),
(33038, '2017-06-08 12:50:25', NULL, NULL, 9900, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:50:25', 'admin-1496897411-14968974251372349', 1, 0, '', NULL, NULL, NULL),
(33039, '2017-06-08 12:55:18', NULL, NULL, 9904, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:55:18', 'admin-1496897411-1496897718442349', 1, 1, 'SR', 1, NULL, NULL),
(33040, '2017-06-08 13:02:36', NULL, NULL, 9905, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1496901775', 'admin', '2017-06-08 13:02:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33041, '2017-06-08 13:02:43', NULL, NULL, 9905, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 13:02:43', 'admin-1496897411-14968981637461533', 1, 1, 'SR', NULL, NULL, NULL),
(33042, '2017-06-08 15:51:51', NULL, NULL, 9909, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 15:51:51', 'admin-1496901775-14969083118278998', 1, 1, 'SR', 1, NULL, NULL),
(33043, '2017-06-08 17:53:59', NULL, NULL, 9910, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1496901775', 'admin', '2017-06-08 17:53:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33044, '2017-06-08 17:54:06', NULL, NULL, 9910, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 17:54:06', 'admin-1496901775-14969156462018224', 1, 1, 'SR', NULL, NULL, NULL),
(33045, '2017-06-08 12:47:45', NULL, NULL, 9902, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:47:45', 'admin-1496894388-14968972656328430', 1, 0, '', NULL, NULL, NULL),
(33046, '2017-06-08 12:02:45', NULL, NULL, 9899, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:02:45', 'admin-1496894388-1496894565296934', 1, 0, '', NULL, NULL, NULL),
(33047, '2017-06-08 12:02:58', NULL, NULL, 9899, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:02:58', 'admin-1496894388-1496894578463847', 1, 1, 'SR', NULL, NULL, NULL),
(33048, '2017-06-08 12:02:58', NULL, NULL, 9899, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:02:58', 'admin-1496894388-1496894578463847', 1, 1, 'SR', NULL, NULL, NULL),
(33049, '2017-06-08 12:15:13', NULL, NULL, 9900, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:15:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33050, '2017-06-08 12:15:32', NULL, NULL, 9900, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 2, 14.00, 28.0000, 0.0000, 28.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:15:32', 'admin-1496894388-14968953319184190', 1, 1, 'SR', NULL, NULL, NULL),
(33051, '2017-06-08 12:15:32', NULL, NULL, 9900, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:15:32', 'admin-1496894388-14968953319184190', 1, 0, '', NULL, NULL, NULL),
(33052, '2017-06-08 12:29:52', NULL, NULL, 9901, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:29:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33053, '2017-06-08 12:30:06', NULL, NULL, 9901, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:30:06', 'admin-1496894388-14968962064742775', 1, 1, 'SR', NULL, NULL, NULL),
(33054, '2017-06-08 12:30:06', NULL, NULL, 9901, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:30:06', 'admin-1496894388-14968962064742775', 1, 1, 'SR', NULL, NULL, NULL),
(33055, '2017-06-08 12:30:06', NULL, NULL, 9901, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:30:06', 'admin-1496894388-14968962064742775', 1, 1, 'SR', NULL, NULL, NULL),
(33056, '2017-06-08 12:39:02', NULL, NULL, 9901, 0, 181, '116', 'Open Food ', 'B', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:39:02', 'admin-1496894388-14968967424882245', 1, 0, '', NULL, NULL, NULL),
(33057, '2017-06-08 12:45:36', NULL, NULL, 9896, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:45:36', 'admin-1496894388-14968971361583174', 1, 1, 'SR', NULL, NULL, NULL),
(33058, '2017-06-08 12:47:19', NULL, NULL, 9902, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:47:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33059, '2017-06-08 12:47:27', NULL, NULL, 9902, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:47:27', 'admin-1496894388-14968972468605078', 1, 1, 'SR', NULL, NULL, NULL),
(33060, '2017-06-08 11:54:53', NULL, NULL, 9896, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 11:54:53', 'admin-1496886869-14968940929941527', 1, 1, 'SR', NULL, NULL, NULL),
(33061, '2017-06-08 13:42:49', NULL, NULL, 9907, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 13:42:49', 'admin-1496897411-14969005697076984', 1, 1, 'SR', NULL, NULL, NULL),
(33062, '2017-06-08 13:42:49', NULL, NULL, 9907, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 13:42:49', 'admin-1496897411-14969005697076984', 1, 0, '', NULL, NULL, NULL),
(33063, '2017-06-08 13:42:49', NULL, NULL, 9907, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 13:42:49', 'admin-1496897411-14969005697076984', 1, 1, 'SR', NULL, NULL, NULL),
(33064, '2017-06-08 13:20:29', NULL, NULL, 9906, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1496901775', 'admin', '2017-06-08 13:20:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33065, '2017-06-08 13:20:39', NULL, NULL, 9906, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 13:20:39', 'admin-1496897411-14968992395303089', 1, 1, 'SR', NULL, NULL, NULL),
(33066, '2017-06-08 12:02:45', NULL, NULL, 9899, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:02:45', 'admin-1496894388-1496894565296934', 1, 0, '', NULL, NULL, NULL),
(33067, '2017-06-08 12:02:45', NULL, NULL, 9899, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:02:45', 'admin-1496894388-1496894565296934', 1, 1, 'SR', NULL, NULL, NULL),
(33068, '2017-06-08 12:02:45', NULL, NULL, 9899, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 12:02:45', 'admin-1496894388-1496894565296934', 1, 0, '', NULL, NULL, NULL),
(33069, '2017-06-08 13:42:49', NULL, NULL, 9907, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 13:42:49', 'admin-1496897411-14969005697076984', 1, 0, '', NULL, NULL, NULL),
(33070, '2017-06-08 13:42:49', NULL, NULL, 9907, 0, 181, '116', 'Open Food ', 'Lemon Cheese promo', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 13:42:49', 'admin-1496897411-14969005697076984', 1, 0, '', NULL, NULL, NULL),
(33071, '2017-06-08 13:20:39', NULL, NULL, 9906, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 13:20:39', 'admin-1496897411-14968992395303089', 1, 0, '', NULL, NULL, NULL),
(33072, '2017-06-08 13:20:48', NULL, NULL, 9906, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 13:20:48', 'admin-1496897411-14968992479445682', 1, 1, 'SR', NULL, NULL, NULL),
(33073, '2017-06-08 13:20:48', NULL, NULL, 9906, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 13:20:48', 'admin-1496897411-14968992479445682', 1, 1, 'SR', NULL, NULL, NULL),
(33074, '2017-06-08 13:42:23', NULL, NULL, 9907, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1496901775', 'admin', '2017-06-08 13:42:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33075, '2017-06-08 10:50:29', NULL, NULL, 9895, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 10:50:29', 'admin-1496886869-14968902294702766', 1, 0, '', NULL, NULL, NULL),
(33076, '2017-06-08 09:44:21', NULL, NULL, 9893, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 09:44:21', 'admin-1496884016-14968862614553819', 1, 0, '', NULL, NULL, NULL),
(33077, '2017-06-08 09:44:30', NULL, NULL, 9893, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 09:44:30', 'admin-1496884016-14968862703144152', 1, 1, 'SR', NULL, NULL, NULL),
(33078, '2017-06-08 09:44:30', NULL, NULL, 9893, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 09:44:30', 'admin-1496884016-14968862703144152', 1, 1, 'SR', NULL, NULL, NULL),
(33079, '2017-06-08 09:53:15', NULL, NULL, 9894, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1496901775', 'admin', '2017-06-08 09:53:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33080, '2017-06-08 09:54:23', NULL, NULL, 9894, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 09:54:23', 'admin-1496884016-14968868630774016', 1, 0, '', NULL, NULL, NULL),
(33081, '2017-06-08 09:54:41', NULL, NULL, 9894, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 09:54:41', 'admin-1496886869-14968868814385786', 1, 1, 'SR', NULL, NULL, NULL),
(33082, '2017-06-08 10:11:48', NULL, NULL, 9893, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 10:11:48', 'admin-1496886869-14968879083418744', 1, 0, '', NULL, NULL, NULL),
(33083, '2017-06-08 10:11:48', NULL, NULL, 9893, 0, 181, '116', 'Open Food ', 'Cheesse takeaway', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 10:11:48', 'admin-1496886869-14968879083418744', 1, 0, '', NULL, NULL, NULL),
(33084, '2017-06-08 10:47:17', NULL, NULL, 9895, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1496901775', 'admin', '2017-06-08 10:47:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33085, '2017-06-08 10:50:16', NULL, NULL, 9895, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 10:50:16', 'admin-1496886869-14968902161291747', 1, 0, '', NULL, NULL, NULL),
(33086, '2017-06-08 10:50:16', NULL, NULL, 9895, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 10:50:16', 'admin-1496886869-14968902161291747', 1, 0, '', NULL, NULL, NULL),
(33087, '2017-06-08 10:50:16', NULL, NULL, 9895, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 10:50:16', 'admin-1496886869-14968902161291747', 1, 0, '', NULL, NULL, NULL),
(33088, '2017-06-08 10:50:29', NULL, NULL, 9895, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 10:50:29', 'admin-1496886869-14968902294702766', 1, 1, 'SR', NULL, NULL, NULL),
(33089, '2017-06-08 11:59:44', NULL, NULL, 9897, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 11:59:44', 'admin-1496886869-14968943837407010', 1, 0, '', NULL, NULL, NULL),
(33090, '2017-06-08 11:59:55', NULL, NULL, 9899, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.40, 0.0000, 0.0000, 11.40, 1, '27', 1, '1496901775', 'admin', '2017-06-08 11:59:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33091, '2017-06-08 11:59:44', NULL, NULL, 9897, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 11:59:44', 'admin-1496886869-14968943837407010', 1, 1, 'SR', NULL, NULL, NULL),
(33092, '2017-06-08 11:49:15', NULL, NULL, 9898, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 11:49:15', 'admin-1496886869-14968937553882041', 1, 0, '', NULL, NULL, NULL),
(33093, '2017-06-08 11:49:00', NULL, NULL, 9898, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1496901775', 'admin', '2017-06-08 11:49:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33094, '2017-06-08 11:48:54', NULL, NULL, 9897, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 11:48:54', 'admin-1496886869-14968937345374313', 1, 1, 'SR', NULL, NULL, NULL),
(33095, '2017-06-08 11:21:08', NULL, NULL, 9896, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 11:21:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33096, '2017-06-08 11:21:14', NULL, NULL, 9896, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 11:21:14', 'admin-1496886869-14968920747061692', 1, 1, 'SR', NULL, NULL, NULL),
(33097, '2017-06-08 11:46:13', NULL, NULL, 9897, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.50, 0.0000, 0.0000, 13.50, 1, '27', 1, '1496901775', 'admin', '2017-06-08 11:46:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33098, '2017-06-08 11:48:42', NULL, NULL, 9897, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 11:48:42', 'admin-1496886869-14968937227669535', 1, 0, '', NULL, NULL, NULL),
(33099, '2017-06-08 11:48:42', NULL, NULL, 9897, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 11:48:42', 'admin-1496886869-14968937227669535', 1, 1, 'SR', NULL, NULL, NULL),
(33100, '2017-06-08 11:48:42', NULL, NULL, 9897, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 11:48:42', 'admin-1496886869-14968937227669535', 1, 1, 'SR', NULL, NULL, NULL),
(33101, '2017-06-08 11:48:42', NULL, NULL, 9897, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 11:48:42', 'admin-1496886869-14968937227669535', 1, 1, 'SR', NULL, NULL, NULL),
(33102, '2017-06-08 11:48:42', NULL, NULL, 9897, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 11:48:42', 'admin-1496886869-14968937227669535', 1, 0, '', NULL, NULL, NULL),
(33103, '2017-06-08 09:14:39', NULL, NULL, 9892, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 09:14:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33104, '2017-06-08 09:14:54', NULL, NULL, 9892, 0, 156, '90', 'House Cheddar Omelet', 'without toast', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 09:14:54', 'admin-1496884016-14968844938378289', 1, 0, '', NULL, NULL, NULL),
(33105, '2017-06-08 09:14:54', NULL, NULL, 9892, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 09:14:54', 'admin-1496884016-14968844938378289', 1, 1, 'SR', NULL, NULL, NULL),
(33106, '2017-06-08 09:41:02', NULL, NULL, 9893, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1496901775', 'admin', '2017-06-08 09:41:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33107, '2017-06-08 09:09:03', NULL, NULL, 9891, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 09:09:03', 'admin-1496884016-1496884143409623', 1, 0, '', NULL, NULL, NULL),
(33108, '2017-06-08 09:09:10', NULL, NULL, 9891, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 09:09:10', 'admin-1496884016-1496884150376291', 1, 0, '', NULL, NULL, NULL),
(33109, '2017-06-08 09:09:10', NULL, NULL, 9891, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 09:09:10', 'admin-1496884016-1496884150376291', 1, 0, '', NULL, NULL, NULL),
(33110, '2017-06-08 09:10:06', NULL, NULL, 9891, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 09:10:06', 'admin-1496884016-14968842062406382', 1, 0, '', NULL, NULL, NULL),
(33111, '2017-06-08 09:09:03', NULL, NULL, 9891, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 09:09:03', 'admin-1496884016-1496884143409623', 1, 1, 'SR', NULL, NULL, NULL),
(33112, '2017-06-08 09:09:03', NULL, NULL, 9891, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 09:09:03', 'admin-1496884016-1496884143409623', 1, 1, 'SR', NULL, NULL, NULL),
(33113, '2017-06-08 09:09:03', NULL, NULL, 9891, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 09:09:03', 'admin-1496884016-1496884143409623', 1, 0, '', NULL, NULL, NULL),
(33114, '2017-06-08 09:09:03', NULL, NULL, 9891, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 09:09:03', 'admin-1496884016-1496884143409623', 1, 1, 'SR', NULL, NULL, NULL),
(33115, '2017-06-08 09:09:03', NULL, NULL, 9891, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496901775', 'admin', '2017-06-08 09:09:03', 'admin-1496884016-1496884143409623', 1, 0, '', NULL, NULL, NULL),
(33116, '2017-06-08 09:07:05', NULL, NULL, 9891, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.20, 0.0000, 0.0000, 12.20, 1, '27', 1, '1496901775', 'admin', '2017-06-08 09:07:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33117, '2017-06-09 16:42:28', NULL, NULL, 9928, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 16:42:28', 'admin-1496990027-14969977481035572', 1, 0, '', NULL, NULL, NULL),
(33118, '2017-06-09 13:04:19', NULL, NULL, 9918, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 13:04:19', 'admin-1496977505-14969846592529037', 1, 1, 'SR', NULL, NULL, NULL),
(33119, '2017-06-09 13:16:18', NULL, NULL, 9919, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1496990027', 'admin', '2017-06-09 13:16:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33120, '2017-06-09 13:16:39', NULL, NULL, 9919, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 13:16:39', 'admin-1496977505-14969853996754291', 1, 1, 'SR', NULL, NULL, NULL),
(33121, '2017-06-09 13:16:39', NULL, NULL, 9919, 0, 181, '116', 'Open Food ', 'pork chop', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 13:16:39', 'admin-1496977505-14969853996754291', 1, 0, '', NULL, NULL, NULL),
(33122, '2017-06-09 14:48:47', NULL, NULL, 9924, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 14:48:47', 'admin-1496990027-14969909270326454', 1, 0, '', NULL, NULL, NULL),
(33123, '2017-06-09 14:48:47', NULL, NULL, 9924, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 14:48:47', 'admin-1496990027-14969909270326454', 1, 1, 'SR', NULL, NULL, NULL),
(33124, '2017-06-09 15:47:27', NULL, NULL, 9925, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 15:47:27', 'admin-1496990027-14969944469596827', 1, 1, 'SR', 1, NULL, NULL),
(33125, '2017-06-09 15:53:49', NULL, NULL, 9926, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1496990027', 'admin', '2017-06-09 15:53:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33126, '2017-06-09 15:53:54', NULL, NULL, 9926, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 15:53:54', 'admin-1496990027-14969948341188870', 1, 1, 'SR', NULL, NULL, NULL),
(33127, '2017-06-09 16:09:07', NULL, NULL, 9927, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.35, 0.0000, 0.0000, 2.35, 1, '27', 1, '1496990027', 'admin', '2017-06-09 16:09:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33128, '2017-06-09 16:09:29', NULL, NULL, 9927, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 16:09:29', 'admin-1496990027-14969957695937544', 1, 1, 'SR', NULL, NULL, NULL),
(33129, '2017-06-09 16:09:29', NULL, NULL, 9927, 0, 284, '218', 'Caramel Waffles', '', 'Desserts', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1496990027', 'admin', '2017-06-09 16:09:29', 'admin-1496990027-14969957695937544', 1, 0, '', NULL, NULL, NULL),
(33130, '2017-06-09 10:49:30', NULL, NULL, 9914, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 10:49:30', 'admin-1496968353-14969765699832072', 1, 1, 'SR', NULL, NULL, NULL),
(33131, '2017-06-09 10:53:26', NULL, NULL, 9911, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 10:53:26', 'admin-1496968353-14969768061895862', 1, 0, '', NULL, NULL, NULL),
(33132, '2017-06-09 10:56:38', NULL, NULL, 9915, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1496990027', 'admin', '2017-06-09 10:56:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33133, '2017-06-09 10:57:22', NULL, NULL, 9915, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 10:57:22', 'admin-1496968353-1496977042210763', 1, 0, '', NULL, NULL, NULL),
(33134, '2017-06-09 10:57:22', NULL, NULL, 9915, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 10:57:22', 'admin-1496968353-1496977042210763', 1, 0, '', NULL, NULL, NULL),
(33135, '2017-06-09 10:57:22', NULL, NULL, 9915, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 10:57:22', 'admin-1496968353-1496977042210763', 1, 0, '', NULL, NULL, NULL),
(33136, '2017-06-09 10:57:27', NULL, NULL, 9915, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 10:57:27', 'admin-1496968353-1496977046923380', 1, 1, 'SR', NULL, NULL, NULL),
(33137, '2017-06-09 10:57:27', NULL, NULL, 9915, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 10:57:27', 'admin-1496968353-1496977046923380', 1, 1, 'SR', NULL, NULL, NULL),
(33138, '2017-06-09 18:06:52', NULL, NULL, 9930, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1496990027', 'admin', '2017-06-09 18:06:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33139, '2017-06-09 18:06:58', NULL, NULL, 9930, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 18:06:58', 'admin-1496990027-14970028181169988', 1, 1, 'SR', NULL, NULL, NULL),
(33140, '2017-06-09 14:10:46', NULL, NULL, 9919, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 14:10:46', 'admin-1496985770-14969886464791717', 1, 0, '', NULL, NULL, NULL),
(33141, '2017-06-09 14:16:47', NULL, NULL, 9921, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 14:16:47', 'admin-1496985770-14969890070226770', 1, 1, 'SR', NULL, NULL, NULL),
(33142, '2017-06-09 14:16:47', NULL, NULL, 9921, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 14:16:47', 'admin-1496985770-14969890070226770', 1, 0, '', NULL, NULL, NULL),
(33143, '2017-06-09 14:16:47', NULL, NULL, 9921, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 14:16:47', 'admin-1496985770-14969890070226770', 1, 0, '', NULL, NULL, NULL),
(33144, '2017-06-09 14:17:44', NULL, NULL, 9921, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 14:17:44', 'admin-1496985770-14969890638956441', 1, 0, '', NULL, NULL, NULL),
(33145, '2017-06-09 14:17:44', NULL, NULL, 9921, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 14:17:44', 'admin-1496985770-14969890638956441', 1, 1, 'SR', NULL, NULL, NULL),
(33146, '2017-06-09 14:17:44', NULL, NULL, 9921, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 14:17:44', 'admin-1496985770-14969890638956441', 1, 1, 'SR', NULL, NULL, NULL),
(33147, '2017-06-09 14:21:59', NULL, NULL, 9921, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 14:21:59', 'admin-1496985770-14969893188705926', 1, 0, '', NULL, NULL, NULL),
(33148, '2017-06-09 14:28:43', NULL, NULL, 9921, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 14:28:43', 'admin-1496985770-14969897236984857', 1, 0, '', NULL, NULL, NULL),
(33149, '2017-06-09 14:31:43', NULL, NULL, 9923, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1496990027', 'admin', '2017-06-09 14:31:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33150, '2017-06-09 14:32:11', NULL, NULL, 9923, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 14:32:11', 'admin-1496985770-14969899309584728', 1, 0, '', NULL, NULL, NULL),
(33151, '2017-06-09 11:05:30', NULL, NULL, 9916, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 11:05:30', 'admin-1496977505-14969775305833521', 1, 0, '', NULL, NULL, NULL),
(33152, '2017-06-09 11:05:30', NULL, NULL, 9916, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 11:05:30', 'admin-1496977505-14969775305833521', 1, 1, 'SR', NULL, NULL, NULL),
(33153, '2017-06-09 11:05:30', NULL, NULL, 9916, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 11:05:30', 'admin-1496977505-14969775305833521', 1, 0, '', NULL, NULL, NULL),
(33154, '2017-06-09 11:54:21', NULL, NULL, 9917, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1496990027', 'admin', '2017-06-09 11:54:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33155, '2017-06-09 11:55:21', NULL, NULL, 9917, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 11:55:21', 'admin-1496977505-14969805208577070', 1, 1, 'SR', NULL, NULL, NULL),
(33156, '2017-06-09 16:54:32', NULL, NULL, 9929, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 16:54:32', 'admin-1496990027-14969984721292042', 1, 1, 'SR', NULL, NULL, NULL),
(33157, '2017-06-09 16:09:29', NULL, NULL, 9927, 0, 181, '116', 'Open Food ', 'lemon cheese', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 16:09:29', 'admin-1496990027-14969957695937544', 1, 0, '', NULL, NULL, NULL),
(33158, '2017-06-09 16:42:18', NULL, NULL, 9928, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.95, 0.0000, 0.0000, 3.95, 1, '27', 1, '1496990027', 'admin', '2017-06-09 16:42:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33159, '2017-06-09 16:54:28', NULL, NULL, 9929, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1496990027', 'admin', '2017-06-09 16:54:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33160, '2017-06-09 16:47:11', NULL, NULL, 9928, 0, 284, '218', 'Caramel Waffles', '', 'Desserts', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1496990027', 'admin', '2017-06-09 16:47:11', 'admin-1496990027-14969980316695325', 1, 0, '', NULL, NULL, NULL),
(33161, '2017-06-09 16:42:28', NULL, NULL, 9928, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 16:42:28', 'admin-1496990027-14969977481035572', 1, 0, '', NULL, NULL, NULL),
(33162, '2017-06-09 16:42:28', NULL, NULL, 9928, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 16:42:28', 'admin-1496990027-14969977481035572', 1, 1, 'SR', NULL, NULL, NULL),
(33163, '2017-06-09 14:33:26', NULL, NULL, 9921, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 14:33:26', 'admin-1496985770-14969900065602835', 1, 0, '', NULL, NULL, NULL),
(33164, '2017-06-09 14:33:41', NULL, NULL, 9923, 0, 181, '116', 'Open Food ', 'pork chop', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 14:33:41', 'admin-1496985770-14969900211537797', 1, 0, '', NULL, NULL, NULL),
(33165, '2017-06-09 14:34:04', NULL, NULL, 9921, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 14:34:04', 'admin-1496990027-14969900447521269', 1, 0, '', NULL, NULL, NULL),
(33166, '2017-06-09 14:48:34', NULL, NULL, 9924, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1496990027', 'admin', '2017-06-09 14:48:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33167, '2017-06-09 14:48:47', NULL, NULL, 9924, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 14:48:47', 'admin-1496990027-14969909270326454', 1, 1, 'SR', NULL, NULL, NULL),
(33168, '2017-06-09 13:20:25', NULL, NULL, 9919, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 13:20:25', 'admin-1496977505-14969856257564010', 1, 0, '', NULL, NULL, NULL),
(33169, '2017-06-09 13:20:25', NULL, NULL, 9919, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 13:20:25', 'admin-1496977505-14969856257564010', 1, 0, '', NULL, NULL, NULL),
(33170, '2017-06-09 13:20:25', NULL, NULL, 9919, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 13:20:25', 'admin-1496977505-14969856257564010', 1, 0, '', NULL, NULL, NULL),
(33171, '2017-06-09 13:21:36', NULL, NULL, 9920, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1496990027', 'admin', '2017-06-09 13:21:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33172, '2017-06-09 13:22:02', NULL, NULL, 9920, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 13:22:02', 'admin-1496977505-14969857219048125', 1, 1, 'SR', NULL, NULL, NULL),
(33173, '2017-06-09 13:22:24', NULL, NULL, 9920, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 13:22:24', 'admin-1496977505-14969857447649764', 1, 0, '', NULL, NULL, NULL),
(33174, '2017-06-09 13:36:53', NULL, NULL, 9918, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 13:36:53', 'admin-1496985770-14969866132405667', 1, 1, 'SR', NULL, NULL, NULL),
(33175, '2017-06-09 13:36:53', NULL, NULL, 9918, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 13:36:53', 'admin-1496985770-14969866132405667', 1, 0, '', NULL, NULL, NULL),
(33176, '2017-06-09 13:52:13', NULL, NULL, 9918, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 13:52:13', 'admin-1496985770-14969875337913292', 1, 0, '', NULL, NULL, NULL),
(33177, '2017-06-09 14:05:45', NULL, NULL, 9920, 0, 181, '116', 'Open Food ', 'lemon cheese', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 14:05:45', 'admin-1496985770-1496988344940307', 1, 0, '', NULL, NULL, NULL),
(33178, '2017-06-09 10:29:44', NULL, NULL, 9913, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 10:29:44', 'admin-1496968353-14969753841573794', 1, 1, 'SR', NULL, NULL, NULL),
(33179, '2017-06-09 10:48:48', NULL, NULL, 9914, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1496990027', 'admin', '2017-06-09 10:48:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33180, '2017-06-09 10:49:30', NULL, NULL, 9914, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 10:49:30', 'admin-1496968353-14969765699832072', 1, 0, '', NULL, NULL, NULL),
(33181, '2017-06-09 10:49:30', NULL, NULL, 9914, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 10:49:30', 'admin-1496968353-14969765699832072', 1, 0, '', NULL, NULL, NULL),
(33182, '2017-06-09 10:49:30', NULL, NULL, 9914, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 10:49:30', 'admin-1496968353-14969765699832072', 1, 1, 'SR', NULL, NULL, NULL),
(33183, '2017-06-09 13:16:39', NULL, NULL, 9919, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 13:16:39', 'admin-1496977505-14969853996754291', 1, 0, '', NULL, NULL, NULL),
(33184, '2017-06-09 13:04:09', NULL, NULL, 9918, 0, 181, '116', 'Open Food ', 'pork chop', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 13:04:09', 'admin-1496977505-14969846490802892', 1, 0, '', NULL, NULL, NULL),
(33185, '2017-06-09 13:04:09', NULL, NULL, 9918, 0, 181, '116', 'Open Food ', 'Garlic Chicken', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 13:04:09', 'admin-1496977505-14969846490802892', 1, 0, '', NULL, NULL, NULL),
(33186, '2017-06-09 13:04:09', NULL, NULL, 9918, 0, 181, '116', 'Open Food ', 'pork chop', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 13:04:09', 'admin-1496977505-14969846490802892', 1, 0, '', NULL, NULL, NULL),
(33187, '2017-06-09 13:04:09', NULL, NULL, 9918, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 13:04:09', 'admin-1496977505-14969846490802892', 1, 0, '', NULL, NULL, NULL),
(33188, '2017-06-09 11:56:30', NULL, NULL, 9915, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 11:56:30', 'admin-1496977505-14969805901426955', 1, 0, '', NULL, NULL, NULL),
(33189, '2017-06-09 11:55:21', NULL, NULL, 9917, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 11:55:21', 'admin-1496977505-14969805208577070', 1, 1, 'SR', NULL, NULL, NULL),
(33190, '2017-06-09 12:20:43', NULL, NULL, 9917, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 12:20:43', 'admin-1496977505-14969820430784472', 1, 0, '', NULL, NULL, NULL),
(33191, '2017-06-09 11:55:21', NULL, NULL, 9917, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 11:55:21', 'admin-1496977505-14969805208577070', 1, 0, '', NULL, NULL, NULL),
(33192, '2017-06-09 11:04:30', NULL, NULL, 9916, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 11:04:30', 'admin-1496968353-14969774705278151', 1, 0, '', NULL, NULL, NULL),
(33193, '2017-06-09 11:04:30', NULL, NULL, 9916, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 11:04:30', 'admin-1496968353-14969774705278151', 1, 0, '', NULL, NULL, NULL),
(33194, '2017-06-09 13:03:30', NULL, NULL, 9918, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.60, 0.0000, 0.0000, 13.60, 1, '27', 1, '1496990027', 'admin', '2017-06-09 13:03:30', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(33195, '2017-06-09 13:04:09', NULL, NULL, 9918, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 13:04:09', 'admin-1496977505-14969846490802892', 1, 0, '', NULL, NULL, NULL),
(33196, '2017-06-09 11:03:46', NULL, NULL, 9916, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1496990027', 'admin', '2017-06-09 11:03:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33197, '2017-06-09 10:29:08', NULL, NULL, 9913, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1496990027', 'admin', '2017-06-09 10:29:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33198, '2017-06-09 10:29:39', NULL, NULL, 9913, 0, 153, '87', 'Wake Me Up!', 'sunny side both side', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 10:29:39', 'admin-1496968353-14969753789903217', 1, 0, '', NULL, NULL, NULL),
(33199, '2017-06-09 10:29:39', NULL, NULL, 9913, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 10:29:39', 'admin-1496968353-14969753789903217', 1, 0, '', NULL, NULL, NULL),
(33200, '2017-06-09 10:29:44', NULL, NULL, 9913, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 10:29:44', 'admin-1496968353-14969753841573794', 1, 1, 'SR', NULL, NULL, NULL),
(33201, '2017-06-09 09:59:47', NULL, NULL, 9911, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 09:59:47', 'admin-1496968353-1496973586915436', 1, 1, 'SR', NULL, NULL, NULL),
(33202, '2017-06-09 09:59:47', NULL, NULL, 9911, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 09:59:47', 'admin-1496968353-1496973586915436', 1, 0, '', NULL, NULL, NULL),
(33203, '2017-06-09 09:59:47', NULL, NULL, 9911, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 09:59:47', 'admin-1496968353-1496973586915436', 1, 0, '', NULL, NULL, NULL),
(33204, '2017-06-09 10:16:32', NULL, NULL, 9912, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1496990027', 'admin', '2017-06-09 10:16:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33205, '2017-06-09 10:17:11', NULL, NULL, 9912, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 10:17:11', 'admin-1496968353-14969746312411888', 1, 0, '', NULL, NULL, NULL),
(33206, '2017-06-09 10:17:11', NULL, NULL, 9912, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 10:17:11', 'admin-1496968353-14969746312411888', 1, 1, 'SR', NULL, NULL, NULL),
(33207, '2017-06-09 10:17:11', NULL, NULL, 9912, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 10:17:11', 'admin-1496968353-14969746312411888', 1, 0, '', NULL, NULL, NULL),
(33208, '2017-06-09 09:59:47', NULL, NULL, 9911, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 09:59:47', 'admin-1496968353-1496973586915436', 1, 0, '', NULL, NULL, NULL),
(33209, '2017-06-09 09:59:47', NULL, NULL, 9911, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1496990027', 'admin', '2017-06-09 09:59:47', 'admin-1496968353-1496973586915436', 1, 0, '', NULL, NULL, NULL),
(33210, '2017-06-09 09:58:09', NULL, NULL, 9911, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1496990027', 'admin', '2017-06-09 09:58:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33211, '2017-06-10 10:17:02', NULL, NULL, 9941, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:17:02', 'admin-1497059186-14970610218603733', 1, 1, 'SR', NULL, NULL, NULL),
(33212, '2017-06-10 10:17:42', NULL, NULL, 9942, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:17:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33213, '2017-06-10 10:17:50', NULL, NULL, 9942, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:17:50', 'admin-1497059186-1497061069896767', 1, 0, '', NULL, NULL, NULL),
(33214, '2017-06-10 10:17:50', NULL, NULL, 9942, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:17:50', 'admin-1497059186-1497061069896767', 1, 0, '', NULL, NULL, NULL),
(33215, '2017-06-10 10:18:28', NULL, NULL, 9942, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:18:28', 'admin-1497059186-14970611082201683', 1, 1, 'SR', NULL, NULL, NULL),
(33216, '2017-06-10 13:58:52', NULL, NULL, 9962, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:58:52', 'admin-1497072639-1497074332145982', 1, 0, '', NULL, NULL, NULL),
(33217, '2017-06-10 13:58:52', NULL, NULL, 9962, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:58:52', 'admin-1497072639-1497074332145982', 1, 0, '', NULL, NULL, NULL),
(33218, '2017-06-10 13:58:52', NULL, NULL, 9962, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:58:52', 'admin-1497072639-1497074332145982', 1, 1, 'SR', NULL, NULL, NULL),
(33219, '2017-06-10 14:55:25', NULL, NULL, 9972, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:55:25', 'admin-1497072639-14970777255012279', 1, 1, 'SR', NULL, NULL, NULL),
(33220, '2017-06-10 15:07:24', NULL, NULL, 9973, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1497078843', 'admin', '2017-06-10 15:07:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33221, '2017-06-10 13:09:03', NULL, NULL, 9961, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:09:03', 'admin-1497067645-1497071343036151', 1, 0, '', NULL, NULL, NULL),
(33222, '2017-06-10 14:55:25', NULL, NULL, 9972, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:55:25', 'admin-1497072639-14970777255012279', 1, 0, '', NULL, NULL, NULL),
(33223, '2017-06-10 14:55:15', NULL, NULL, 9972, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:55:15', 'admin-1497072639-14970777148214039', 1, 0, '', NULL, NULL, NULL),
(33224, '2017-06-10 14:55:15', NULL, NULL, 9972, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:55:15', 'admin-1497072639-14970777148214039', 1, 0, '', NULL, NULL, NULL),
(33225, '2017-06-10 14:55:15', NULL, NULL, 9972, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:55:15', 'admin-1497072639-14970777148214039', 1, 0, '', NULL, NULL, NULL),
(33226, '2017-06-10 14:55:00', NULL, NULL, 9972, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:55:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33227, '2017-06-10 14:37:35', NULL, NULL, 9971, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:37:35', 'admin-1497072639-14970766557362444', 1, 1, 'SR', NULL, NULL, NULL),
(33228, '2017-06-10 14:37:35', NULL, NULL, 9971, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:37:35', 'admin-1497072639-14970766557362444', 1, 1, 'SR', NULL, NULL, NULL),
(33229, '2017-06-10 12:39:01', NULL, NULL, 9959, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 12:39:01', 'admin-1497067645-14970695409465743', 1, 1, 'SR', NULL, NULL, NULL),
(33230, '2017-06-10 12:40:01', NULL, NULL, 9958, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 12:40:01', 'admin-1497067645-1497069601267665', 1, 0, '', NULL, NULL, NULL),
(33231, '2017-06-10 12:07:16', NULL, NULL, 9958, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 12:07:16', 'admin-1497064642-1497067635961542', 1, 1, 'SR', NULL, NULL, NULL),
(33232, '2017-06-10 12:07:16', NULL, NULL, 9958, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 12:07:16', 'admin-1497064642-1497067635961542', 1, 1, 'SR', NULL, NULL, NULL),
(33233, '2017-06-10 12:07:16', NULL, NULL, 9958, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 12:07:16', 'admin-1497064642-1497067635961542', 1, 0, '', NULL, NULL, NULL),
(33234, '2017-06-10 12:07:16', NULL, NULL, 9958, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 12:07:16', 'admin-1497064642-1497067635961542', 1, 1, 'SR', NULL, NULL, NULL),
(33235, '2017-06-10 12:07:16', NULL, NULL, 9958, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 12:07:16', 'admin-1497064642-1497067635961542', 1, 0, '', NULL, NULL, NULL),
(33236, '2017-06-10 12:08:28', NULL, NULL, 9958, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 12:08:28', 'admin-1497067645-14970677088109354', 1, 1, 'SR', NULL, NULL, NULL),
(33237, '2017-06-10 11:25:46', NULL, NULL, 9953, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:25:46', 'admin-1497064642-14970651465076744', 1, 1, 'SR', NULL, NULL, NULL),
(33238, '2017-06-10 11:25:46', NULL, NULL, 9953, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:25:46', 'admin-1497064642-14970651465076744', 1, 1, 'SR', NULL, NULL, NULL),
(33239, '2017-06-10 13:24:13', NULL, NULL, 9962, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:24:13', 'admin-1497067645-14970722535472424', 1, 0, '', NULL, NULL, NULL),
(33240, '2017-06-10 13:24:13', NULL, NULL, 9962, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:24:13', 'admin-1497067645-14970722535472424', 1, 1, 'SR', NULL, NULL, NULL),
(33241, '2017-06-10 13:24:13', NULL, NULL, 9962, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:24:13', 'admin-1497067645-14970722535472424', 1, 1, 'SR', NULL, NULL, NULL),
(33242, '2017-06-10 13:30:02', NULL, NULL, 9963, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:30:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33243, '2017-06-10 11:39:06', NULL, NULL, 9955, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:39:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33244, '2017-06-10 11:22:19', NULL, NULL, 9952, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:22:19', 'admin-1497064642-14970649396669812', 1, 0, '', NULL, NULL, NULL),
(33245, '2017-06-10 11:22:19', NULL, NULL, 9952, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:22:19', 'admin-1497064642-14970649396669812', 1, 0, '', NULL, NULL, NULL),
(33246, '2017-06-10 11:25:20', NULL, NULL, 9953, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:25:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33247, '2017-06-10 11:25:37', NULL, NULL, 9953, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:25:37', 'admin-1497064642-1497065137632818', 1, 0, '', NULL, NULL, NULL),
(33248, '2017-06-10 11:25:37', NULL, NULL, 9953, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:25:37', 'admin-1497064642-1497065137632818', 1, 0, '', NULL, NULL, NULL),
(33249, '2017-06-10 11:22:08', NULL, NULL, 9952, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:22:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33250, '2017-06-10 11:26:24', NULL, NULL, 9954, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:26:24', 'admin-1497064642-1497065184496454', 1, 1, 'SR', NULL, NULL, NULL),
(33251, '2017-06-10 11:02:29', NULL, NULL, 9949, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:02:29', 'admin-1497062082-14970637491757823', 1, 0, '', NULL, NULL, NULL),
(33252, '2017-06-10 11:08:05', NULL, NULL, 9950, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:08:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33253, '2017-06-10 11:08:18', NULL, NULL, 9950, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:08:18', 'admin-1497062082-14970640984698732', 1, 0, '', NULL, NULL, NULL),
(33254, '2017-06-10 11:08:18', NULL, NULL, 9950, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:08:18', 'admin-1497062082-14970640984698732', 1, 0, '', NULL, NULL, NULL),
(33255, '2017-06-10 11:08:58', NULL, NULL, 9949, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:08:58', 'admin-1497062082-14970641387144788', 1, 0, '', NULL, NULL, NULL),
(33256, '2017-06-10 11:08:58', NULL, NULL, 9949, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:08:58', 'admin-1497062082-14970641387144788', 1, 0, '', NULL, NULL, NULL),
(33257, '2017-06-10 11:08:58', NULL, NULL, 9949, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:08:58', 'admin-1497062082-14970641387144788', 1, 0, '', NULL, NULL, NULL),
(33258, '2017-06-10 11:08:58', NULL, NULL, 9949, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:08:58', 'admin-1497062082-14970641387144788', 1, 0, '', NULL, NULL, NULL),
(33259, '2017-06-10 11:09:20', NULL, NULL, 9949, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:09:20', 'admin-1497062082-14970641598685756', 1, 1, 'SR', NULL, NULL, NULL),
(33260, '2017-06-10 12:08:28', NULL, NULL, 9958, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 12:08:28', 'admin-1497067645-14970677088109354', 1, 1, 'SR', NULL, NULL, NULL),
(33261, '2017-06-10 12:09:14', NULL, NULL, 9958, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 12:09:14', 'admin-1497067645-14970677539811033', 1, 0, '', NULL, NULL, NULL),
(33262, '2017-06-10 12:09:54', NULL, NULL, 9958, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 12:09:54', 'admin-1497067645-14970677943091691', 1, 0, '', NULL, NULL, NULL),
(33263, '2017-06-10 12:38:15', NULL, NULL, 9959, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 12:38:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33264, '2017-06-10 12:38:47', NULL, NULL, 9959, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 12:38:47', 'admin-1497067645-14970695276363669', 1, 0, '', NULL, NULL, NULL),
(33265, '2017-06-10 12:38:47', NULL, NULL, 9959, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 12:38:47', 'admin-1497067645-14970695276363669', 1, 0, '', NULL, NULL, NULL),
(33266, '2017-06-10 12:38:47', NULL, NULL, 9959, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 12:38:47', 'admin-1497067645-14970695276363669', 1, 1, 'SR', NULL, NULL, NULL),
(33267, '2017-06-10 16:17:58', NULL, NULL, 9977, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 16:17:58', 'admin-1497078843-14970826786556183', 1, 0, '', NULL, NULL, NULL),
(33268, '2017-06-10 13:58:52', NULL, NULL, 9962, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:58:52', 'admin-1497072639-1497074332145982', 1, 0, '', NULL, NULL, NULL),
(33269, '2017-06-10 13:58:52', NULL, NULL, 9962, 0, 181, '116', 'Open Food ', 'lemon cheese', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:58:52', 'admin-1497072639-1497074332145982', 1, 0, '', NULL, NULL, NULL),
(33270, '2017-06-10 13:58:58', NULL, NULL, 9966, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:58:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33271, '2017-06-10 13:59:08', NULL, NULL, 9966, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:59:08', 'admin-1497072639-14970743482965180', 1, 0, '', NULL, NULL, NULL),
(33272, '2017-06-10 13:59:08', NULL, NULL, 9966, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:59:08', 'admin-1497072639-14970743482965180', 1, 0, '', NULL, NULL, NULL),
(33273, '2017-06-10 14:03:05', NULL, NULL, 9967, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:03:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33274, '2017-06-10 14:04:41', NULL, NULL, 9967, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:04:41', 'admin-1497072639-14970746813087364', 1, 0, '', NULL, NULL, NULL),
(33275, '2017-06-10 14:04:41', NULL, NULL, 9967, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:04:41', 'admin-1497072639-14970746813087364', 1, 0, '', NULL, NULL, NULL),
(33276, '2017-06-10 14:04:41', NULL, NULL, 9967, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:04:41', 'admin-1497072639-14970746813087364', 1, 0, '', NULL, NULL, NULL),
(33277, '2017-06-10 14:04:41', NULL, NULL, 9967, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:04:41', 'admin-1497072639-14970746813087364', 1, 1, 'SR', NULL, NULL, NULL),
(33278, '2017-06-10 14:04:41', NULL, NULL, 9967, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:04:41', 'admin-1497072639-14970746813087364', 1, 1, 'SR', NULL, NULL, NULL),
(33279, '2017-06-10 14:04:41', NULL, NULL, 9967, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:04:41', 'admin-1497072639-14970746813087364', 1, 0, '', NULL, NULL, NULL),
(33280, '2017-06-10 14:04:41', NULL, NULL, 9967, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:04:41', 'admin-1497072639-14970746813087364', 1, 1, 'SR', NULL, NULL, NULL),
(33281, '2017-06-10 16:17:50', NULL, NULL, 9977, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1497078843', 'admin', '2017-06-10 16:17:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33282, '2017-06-10 16:07:28', NULL, NULL, 9976, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.84, 0.0000, 0.0000, 2.84, 1, '27', 1, '1497078843', 'admin', '2017-06-10 16:07:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33283, '2017-06-10 15:13:22', NULL, NULL, 9974, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1497078843', 'admin', '2017-06-10 15:13:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33284, '2017-06-10 15:13:58', NULL, NULL, 9974, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 15:13:58', 'admin-1497072639-14970788387838253', 1, 0, '', NULL, NULL, NULL),
(33285, '2017-06-10 15:13:58', NULL, NULL, 9974, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 15:13:58', 'admin-1497072639-14970788387838253', 1, 1, 'SR', NULL, NULL, NULL),
(33286, '2017-06-10 13:19:43', NULL, NULL, 9962, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:19:43', 'admin-1497067645-14970719828128955', 1, 1, 'SR', NULL, NULL, NULL),
(33287, '2017-06-10 13:19:43', NULL, NULL, 9962, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:19:43', 'admin-1497067645-14970719828128955', 1, 0, '', NULL, NULL, NULL),
(33288, '2017-06-10 12:51:16', NULL, NULL, 9960, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 12:51:16', 'admin-1497067645-1497070276589418', 1, 1, 'SR', NULL, NULL, NULL),
(33289, '2017-06-10 11:19:22', NULL, NULL, 9950, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:19:22', 'admin-1497064642-14970647625867197', 1, 0, '', NULL, NULL, NULL),
(33290, '2017-06-10 16:07:47', NULL, NULL, 9976, 0, 284, '218', 'Caramel Waffles', '', 'Desserts', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1497078843', 'admin', '2017-06-10 16:07:47', 'admin-1497078843-14970820670244638', 1, 0, '', NULL, NULL, NULL),
(33291, '2017-06-10 16:07:47', NULL, NULL, 9976, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1497078843', 'admin', '2017-06-10 16:07:47', 'admin-1497078843-14970820670244638', 1, 0, '', NULL, NULL, NULL),
(33292, '2017-06-10 16:07:47', NULL, NULL, 9976, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 16:07:47', 'admin-1497078843-14970820670244638', 1, 1, 'SR', NULL, NULL, NULL),
(33293, '2017-06-10 16:07:47', NULL, NULL, 9976, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 16:07:47', 'admin-1497078843-14970820670244638', 1, 0, '', NULL, NULL, NULL),
(33294, '2017-06-10 15:43:39', NULL, NULL, 9975, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 15:43:39', 'admin-1497078843-14970806187732258', 1, 1, 'SR', NULL, NULL, NULL),
(33295, '2017-06-10 13:32:55', NULL, NULL, 9962, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:32:55', 'admin-1497072639-14970727752803832', 1, 1, 'SR', NULL, NULL, NULL),
(33296, '2017-06-10 15:35:37', NULL, NULL, 9973, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 15:35:37', 'admin-1497078843-14970801370452579', 1, 1, 'SR', NULL, NULL, NULL),
(33297, '2017-06-10 15:43:33', NULL, NULL, 9975, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1497078843', 'admin', '2017-06-10 15:43:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33298, '2017-06-10 15:13:58', NULL, NULL, 9974, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 15:13:58', 'admin-1497072639-14970788387838253', 1, 1, 'SR', NULL, NULL, NULL),
(33299, '2017-06-10 15:09:11', NULL, NULL, 9973, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 15:09:11', 'admin-1497072639-14970785516339171', 1, 0, '', NULL, NULL, NULL),
(33300, '2017-06-10 15:09:11', NULL, NULL, 9973, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 15:09:11', 'admin-1497072639-14970785516339171', 1, 1, 'SR', NULL, NULL, NULL),
(33301, '2017-06-10 15:09:11', NULL, NULL, 9973, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 15:09:11', 'admin-1497072639-14970785516339171', 1, 0, '', NULL, NULL, NULL),
(33302, '2017-06-10 14:18:18', NULL, NULL, 9968, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:18:18', 'admin-1497072639-14970754981099837', 1, 0, '', NULL, NULL, NULL),
(33303, '2017-06-10 14:18:18', NULL, NULL, 9968, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:18:18', 'admin-1497072639-14970754981099837', 1, 0, '', NULL, NULL, NULL),
(33304, '2017-06-10 14:19:41', NULL, NULL, 9969, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:19:41', 'admin-1497072639-14970755808677763', 1, 1, 'SR', 1, NULL, NULL),
(33305, '2017-06-10 14:23:01', NULL, NULL, 9970, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:23:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33306, '2017-06-10 13:46:56', NULL, NULL, 9964, 0, 181, '116', 'Open Food ', 'bread', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:46:56', 'admin-1497072639-14970736161302774', 1, 0, '', 1, NULL, NULL),
(33307, '2017-06-10 12:08:28', NULL, NULL, 9958, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 12:08:28', 'admin-1497067645-14970677088109354', 1, 1, 'SR', NULL, NULL, NULL),
(33308, '2017-06-10 12:01:34', NULL, NULL, 9957, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 12:01:34', 'admin-1497064642-14970672945903891', 1, 1, 'SR', 1, NULL, NULL),
(33309, '2017-06-10 12:06:06', NULL, NULL, 9958, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.10, 0.0000, 0.0000, 15.10, 1, '27', 1, '1497078843', 'admin', '2017-06-10 12:06:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33310, '2017-06-10 15:09:11', NULL, NULL, 9973, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 15:09:11', 'admin-1497072639-14970785516339171', 1, 0, '', NULL, NULL, NULL),
(33311, '2017-06-10 14:23:22', NULL, NULL, 9970, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:23:22', 'admin-1497072639-14970758023513532', 1, 0, '', NULL, NULL, NULL),
(33312, '2017-06-10 14:23:22', NULL, NULL, 9970, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:23:22', 'admin-1497072639-14970758023513532', 1, 0, '', NULL, NULL, NULL),
(33313, '2017-06-10 14:23:22', NULL, NULL, 9970, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:23:22', 'admin-1497072639-14970758023513532', 1, 1, 'SR', NULL, NULL, NULL),
(33314, '2017-06-10 14:17:53', NULL, NULL, 9968, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:17:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33315, '2017-06-10 14:18:04', NULL, NULL, 9968, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:18:04', 'admin-1497072639-14970754847698635', 1, 1, 'SR', NULL, NULL, NULL),
(33316, '2017-06-10 13:48:42', NULL, NULL, 9965, 0, 181, '116', 'Open Food ', 'lemon cheese', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:48:42', 'admin-1497072639-14970737226196376', 1, 0, '', NULL, NULL, NULL),
(33317, '2017-06-10 14:04:41', NULL, NULL, 9967, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:04:41', 'admin-1497072639-14970746813087364', 1, 1, 'SR', NULL, NULL, NULL),
(33318, '2017-06-10 13:48:48', NULL, NULL, 9965, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:48:48', 'admin-1497072639-14970737281735940', 1, 0, '', NULL, NULL, NULL),
(33319, '2017-06-10 13:48:42', NULL, NULL, 9965, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:48:42', 'admin-1497072639-14970737226196376', 1, 0, '', NULL, NULL, NULL),
(33320, '2017-06-10 13:47:50', NULL, NULL, 9965, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:47:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33321, '2017-06-10 13:48:42', NULL, NULL, 9965, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:48:42', 'admin-1497072639-14970737226196376', 1, 1, 'SR', NULL, NULL, NULL),
(33322, '2017-06-10 14:37:18', NULL, NULL, 9971, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1497078843', 'admin', '2017-06-10 14:37:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33323, '2017-06-10 13:30:33', NULL, NULL, 9963, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:30:33', 'admin-1497067645-14970726338051180', 1, 0, '', NULL, NULL, NULL),
(33324, '2017-06-10 13:30:11', NULL, NULL, 9963, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:30:11', 'admin-1497067645-1497072611768561', 1, 1, 'SR', NULL, NULL, NULL),
(33325, '2017-06-10 13:30:11', NULL, NULL, 9963, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:30:11', 'admin-1497067645-1497072611768561', 1, 1, 'SR', NULL, NULL, NULL),
(33326, '2017-06-10 13:30:33', NULL, NULL, 9963, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:30:33', 'admin-1497067645-14970726338051180', 1, 0, '', NULL, NULL, NULL),
(33327, '2017-06-10 13:19:43', NULL, NULL, 9962, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:19:43', 'admin-1497067645-14970719828128955', 1, 0, '', NULL, NULL, NULL),
(33328, '2017-06-10 13:24:13', NULL, NULL, 9962, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:24:13', 'admin-1497067645-14970722535472424', 1, 0, '', NULL, NULL, NULL),
(33329, '2017-06-10 13:19:42', NULL, NULL, 9962, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:19:42', 'admin-1497067645-14970719828128955', 1, 1, 'SR', NULL, NULL, NULL),
(33330, '2017-06-10 11:39:46', NULL, NULL, 9955, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:39:46', 'admin-1497064642-14970659863505254', 1, 1, 'SR', NULL, NULL, NULL),
(33331, '2017-06-10 13:19:15', NULL, NULL, 9962, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 17.25, 0.0000, 0.0000, 17.25, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:19:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33332, '2017-06-10 11:58:00', NULL, NULL, 9955, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:58:00', 'admin-1497064642-14970670806477330', 1, 1, 'SR', NULL, NULL, NULL),
(33333, '2017-06-10 13:06:31', NULL, NULL, 9961, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:06:31', 'admin-1497067645-14970711909041928', 1, 1, 'SR', NULL, NULL, NULL),
(33334, '2017-06-10 13:06:31', NULL, NULL, 9961, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:06:31', 'admin-1497067645-14970711909041928', 1, 1, 'SR', NULL, NULL, NULL),
(33335, '2017-06-10 13:06:16', NULL, NULL, 9961, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:06:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33336, '2017-06-10 13:06:20', NULL, NULL, 9961, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 13:06:20', 'admin-1497067645-14970711805461880', 1, 0, '', NULL, NULL, NULL),
(33337, '2017-06-10 12:51:12', NULL, NULL, 9960, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1497078843', 'admin', '2017-06-10 12:51:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33338, '2017-06-10 12:45:26', NULL, NULL, 9958, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 12:45:26', 'admin-1497067645-1497069926500919', 1, 0, '', NULL, NULL, NULL),
(33339, '2017-06-10 11:22:19', NULL, NULL, 9952, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:22:19', 'admin-1497064642-14970649396669812', 1, 1, 'SR', NULL, NULL, NULL),
(33340, '2017-06-10 10:19:53', NULL, NULL, 9943, 0, 181, '116', 'Open Food ', 'pancake no banana', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:19:53', 'admin-1497059186-14970611937983340', 1, 0, '', NULL, NULL, NULL),
(33341, '2017-06-10 10:22:54', NULL, NULL, 9944, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:22:54', 'admin-1497059186-14970613744453767', 1, 0, '', 1, NULL, NULL),
(33342, '2017-06-10 10:34:01', NULL, NULL, 9945, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:34:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33343, '2017-06-10 10:34:19', NULL, NULL, 9945, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:34:19', 'admin-1497059186-14970620596938458', 1, 0, '', NULL, NULL, NULL),
(33344, '2017-06-10 10:34:19', NULL, NULL, 9945, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:34:19', 'admin-1497059186-14970620596938458', 1, 0, '', NULL, NULL, NULL),
(33345, '2017-06-10 10:34:19', NULL, NULL, 9945, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:34:19', 'admin-1497059186-14970620596938458', 1, 1, 'SR', NULL, NULL, NULL),
(33346, '2017-06-10 10:34:19', NULL, NULL, 9945, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:34:19', 'admin-1497059186-14970620596938458', 1, 1, 'SR', NULL, NULL, NULL),
(33347, '2017-06-10 11:39:46', NULL, NULL, 9955, 0, 156, '90', 'House Cheddar Omelet', 'no cheese', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:39:46', 'admin-1497064642-14970659863505254', 1, 0, '', NULL, NULL, NULL),
(33348, '2017-06-10 11:41:04', NULL, NULL, 9956, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:41:04', 'admin-1497064642-14970660646456318', 1, 1, 'SR', NULL, NULL, NULL),
(33349, '2017-06-10 11:41:04', NULL, NULL, 9956, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:41:04', 'admin-1497064642-14970660646456318', 1, 1, 'SR', NULL, NULL, NULL),
(33350, '2017-06-10 11:40:46', NULL, NULL, 9956, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:40:46', 'admin-1497064642-14970660466002044', 1, 0, '', NULL, NULL, NULL),
(33351, '2017-06-10 11:40:46', NULL, NULL, 9956, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:40:46', 'admin-1497064642-14970660466002044', 1, 0, '', NULL, NULL, NULL),
(33352, '2017-06-10 11:40:46', NULL, NULL, 9956, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:40:46', 'admin-1497064642-14970660466002044', 1, 0, '', NULL, NULL, NULL),
(33353, '2017-06-10 11:40:16', NULL, NULL, 9956, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:40:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33354, '2017-06-10 11:39:46', NULL, NULL, 9955, 0, 32, '32', 'Tea By Pot ', 'sencha', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:39:46', 'admin-1497064642-14970659863505254', 1, 1, 'SR', NULL, NULL, NULL),
(33355, '2017-06-10 11:39:46', NULL, NULL, 9955, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:39:46', 'admin-1497064642-14970659863505254', 1, 0, '', NULL, NULL, NULL),
(33356, '2017-06-10 11:19:22', NULL, NULL, 9950, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:19:22', 'admin-1497064642-14970647625867197', 1, 0, '', NULL, NULL, NULL),
(33357, '2017-06-10 11:19:22', NULL, NULL, 9950, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:19:22', 'admin-1497064642-14970647625867197', 1, 1, 'SR', NULL, NULL, NULL),
(33358, '2017-06-10 11:09:20', NULL, NULL, 9949, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:09:20', 'admin-1497062082-14970641598685756', 1, 1, 'SR', NULL, NULL, NULL),
(33359, '2017-06-10 11:14:03', NULL, NULL, 9946, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:14:03', 'admin-1497062082-14970644429716558', 1, 0, '', NULL, NULL, NULL),
(33360, '2017-06-10 11:26:24', NULL, NULL, 9954, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:26:24', 'admin-1497064642-1497065184496454', 1, 1, 'SR', NULL, NULL, NULL),
(33361, '2017-06-10 11:26:16', NULL, NULL, 9954, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:26:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33362, '2017-06-10 10:35:15', NULL, NULL, 9946, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:35:15', 'admin-1497062082-14970621151236319', 1, 0, '', NULL, NULL, NULL),
(33363, '2017-06-10 10:17:02', NULL, NULL, 9941, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:17:02', 'admin-1497059186-14970610218603733', 1, 0, '', NULL, NULL, NULL),
(33364, '2017-06-10 09:30:49', NULL, NULL, 9936, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:30:49', 'admin-1497056454-14970582497274040', 1, 0, '', NULL, NULL, NULL),
(33365, '2017-06-10 09:31:26', NULL, NULL, 9936, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:31:26', 'admin-1497056454-14970582865901856', 1, 1, 'SR', NULL, NULL, NULL),
(33366, '2017-06-10 09:31:26', NULL, NULL, 9936, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:31:26', 'admin-1497056454-14970582865901856', 1, 1, 'SR', NULL, NULL, NULL),
(33367, '2017-06-10 09:31:26', NULL, NULL, 9936, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:31:26', 'admin-1497056454-14970582865901856', 1, 1, 'SR', NULL, NULL, NULL),
(33368, '2017-06-10 09:31:26', NULL, NULL, 9936, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:31:26', 'admin-1497056454-14970582865901856', 1, 1, 'SR', NULL, NULL, NULL),
(33369, '2017-06-10 09:31:26', NULL, NULL, 9936, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:31:26', 'admin-1497056454-14970582865901856', 1, 1, 'SR', NULL, NULL, NULL),
(33370, '2017-06-10 09:46:09', NULL, NULL, 9937, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:46:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33371, '2017-06-10 09:46:17', NULL, NULL, 9937, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:46:17', 'admin-1497056454-149705917745992', 1, 0, '', NULL, NULL, NULL),
(33372, '2017-06-10 09:46:17', NULL, NULL, 9937, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:46:17', 'admin-1497056454-149705917745992', 1, 0, '', NULL, NULL, NULL),
(33373, '2017-06-10 09:46:38', NULL, NULL, 9937, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:46:38', 'admin-1497059186-14970591987882165', 1, 0, '', NULL, NULL, NULL),
(33374, '2017-06-10 09:46:38', NULL, NULL, 9937, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:46:38', 'admin-1497059186-14970591987882165', 1, 1, 'SR', NULL, NULL, NULL),
(33375, '2017-06-10 10:05:34', NULL, NULL, 9938, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:05:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33376, '2017-06-10 10:05:44', NULL, NULL, 9938, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:05:44', 'admin-1497059186-1497060344311576', 1, 0, '', NULL, NULL, NULL),
(33377, '2017-06-10 10:05:44', NULL, NULL, 9938, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:05:44', 'admin-1497059186-1497060344311576', 1, 0, '', NULL, NULL, NULL),
(33378, '2017-06-10 09:28:45', NULL, NULL, 9935, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:28:45', 'admin-1497056454-14970581255448420', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(33379, '2017-06-10 11:19:22', NULL, NULL, 9950, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:19:22', 'admin-1497064642-14970647625867197', 1, 1, 'SR', NULL, NULL, NULL),
(33380, '2017-06-10 10:08:10', NULL, NULL, 9939, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:08:10', 'admin-1497059186-14970604899603352', 1, 0, '', NULL, NULL, NULL),
(33381, '2017-06-10 11:17:11', NULL, NULL, 9951, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:17:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33382, '2017-06-10 11:17:17', NULL, NULL, 9951, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:17:17', 'admin-1497062082-14970646375548556', 1, 0, '', NULL, NULL, NULL),
(33383, '2017-06-10 11:17:17', NULL, NULL, 9951, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:17:17', 'admin-1497062082-14970646375548556', 1, 0, '', NULL, NULL, NULL),
(33384, '2017-06-10 10:14:24', NULL, NULL, 9940, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:14:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33385, '2017-06-10 10:14:37', NULL, NULL, 9940, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:14:37', 'admin-1497059186-14970608770809617', 1, 0, '', NULL, NULL, NULL),
(33386, '2017-06-10 10:14:37', NULL, NULL, 9940, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:14:37', 'admin-1497059186-14970608770809617', 1, 0, '', NULL, NULL, NULL),
(33387, '2017-06-10 10:16:37', NULL, NULL, 9941, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.65, 0.0000, 0.0000, 2.65, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:16:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33388, '2017-06-10 10:17:02', NULL, NULL, 9941, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:17:02', 'admin-1497059186-14970610218603733', 1, 1, 'SR', NULL, NULL, NULL),
(33389, '2017-06-10 15:07:34', NULL, NULL, 9973, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 15:07:34', 'admin-1497072639-14970784542923565', 1, 1, 'SR', NULL, NULL, NULL),
(33390, '2017-06-10 11:17:36', NULL, NULL, 9951, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:17:36', 'admin-1497064642-14970646564795241', 1, 1, 'SR', NULL, NULL, NULL),
(33391, '2017-06-10 10:35:42', NULL, NULL, 9947, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:35:42', 'admin-1497062082-14970621426815327', 1, 1, 'SR', NULL, NULL, NULL),
(33392, '2017-06-10 10:35:42', NULL, NULL, 9947, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:35:42', 'admin-1497062082-14970621426815327', 1, 1, 'SR', NULL, NULL, NULL),
(33393, '2017-06-10 10:45:59', NULL, NULL, 9948, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:45:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33394, '2017-06-10 10:46:13', NULL, NULL, 9948, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:46:13', 'admin-1497062082-1497062773142448', 1, 0, '', NULL, NULL, NULL),
(33395, '2017-06-10 10:46:13', NULL, NULL, 9948, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:46:13', 'admin-1497062082-1497062773142448', 1, 1, 'SR', NULL, NULL, NULL),
(33396, '2017-06-10 11:02:10', NULL, NULL, 9949, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.00, 0.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:02:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33397, '2017-06-10 11:02:19', NULL, NULL, 9949, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 11:02:19', 'admin-1497062082-14970637389329547', 1, 0, '', NULL, NULL, NULL),
(33398, '2017-06-10 10:35:38', NULL, NULL, 9947, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:35:38', 'admin-1497062082-14970621378998944', 1, 0, '', NULL, NULL, NULL),
(33399, '2017-06-10 10:35:38', NULL, NULL, 9947, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:35:38', 'admin-1497062082-14970621378998944', 1, 0, '', NULL, NULL, NULL),
(33400, '2017-06-10 10:35:24', NULL, NULL, 9947, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:35:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33401, '2017-06-10 10:35:15', NULL, NULL, 9946, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:35:15', 'admin-1497062082-14970621151236319', 1, 1, 'SR', NULL, NULL, NULL),
(33402, '2017-06-10 10:35:15', NULL, NULL, 9946, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:35:15', 'admin-1497062082-14970621151236319', 1, 1, 'SR', NULL, NULL, NULL),
(33403, '2017-06-10 09:28:45', NULL, NULL, 9935, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:28:45', 'admin-1497056454-14970581255448420', 1, 1, 'SR', NULL, NULL, NULL),
(33404, '2017-06-10 09:28:31', NULL, NULL, 9935, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:28:31', 'admin-1497056454-1497058110980744', 1, 0, '', NULL, NULL, NULL),
(33405, '2017-06-10 10:35:15', NULL, NULL, 9946, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:35:15', 'admin-1497062082-14970621151236319', 1, 0, '', NULL, NULL, NULL),
(33406, '2017-06-10 10:34:51', NULL, NULL, 9946, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:34:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33407, '2017-06-10 10:19:53', NULL, NULL, 9943, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:19:53', 'admin-1497059186-14970611937983340', 1, 0, '', NULL, NULL, NULL),
(33408, '2017-06-10 10:19:12', NULL, NULL, 9943, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:19:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33409, '2017-06-10 10:19:53', NULL, NULL, 9943, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:19:53', 'admin-1497059186-14970611937983340', 1, 0, '', NULL, NULL, NULL),
(33410, '2017-06-10 10:17:02', NULL, NULL, 9941, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:17:02', 'admin-1497059186-14970610218603733', 1, 1, 'SR', NULL, NULL, NULL),
(33411, '2017-06-10 09:30:49', NULL, NULL, 9936, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:30:49', 'admin-1497056454-14970582497274040', 1, 0, '', NULL, NULL, NULL),
(33412, '2017-06-10 09:30:49', NULL, NULL, 9936, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:30:49', 'admin-1497056454-14970582497274040', 1, 0, '', NULL, NULL, NULL),
(33413, '2017-06-10 09:30:49', NULL, NULL, 9936, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:30:49', 'admin-1497056454-14970582497274040', 1, 0, '', NULL, NULL, NULL),
(33414, '2017-06-10 09:30:49', NULL, NULL, 9936, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:30:49', 'admin-1497056454-14970582497274040', 1, 0, '', NULL, NULL, NULL),
(33415, '2017-06-10 10:07:41', NULL, NULL, 9939, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:07:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33416, '2017-06-10 10:05:58', NULL, NULL, 9938, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:05:58', 'admin-1497059186-14970603579557791', 1, 0, '', NULL, NULL, NULL),
(33417, '2017-06-10 10:05:58', NULL, NULL, 9938, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 10:05:58', 'admin-1497059186-14970603579557791', 1, 1, 'SR', NULL, NULL, NULL),
(33418, '2017-06-10 09:30:37', NULL, NULL, 9936, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.50, 0.0000, 0.0000, 14.50, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:30:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33419, '2017-06-10 09:30:49', NULL, NULL, 9936, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:30:49', 'admin-1497056454-14970582497274040', 1, 0, '', NULL, NULL, NULL),
(33420, '2017-06-10 09:06:16', NULL, NULL, 9934, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:06:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33421, '2017-06-10 09:28:21', NULL, NULL, 9935, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:28:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33422, '2017-06-10 09:28:31', NULL, NULL, 9935, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:28:31', 'admin-1497056454-1497058110980744', 1, 0, '', NULL, NULL, NULL),
(33423, '2017-06-10 09:06:36', NULL, NULL, 9934, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:06:36', 'admin-1497056454-14970567959284035', 1, 0, '', NULL, NULL, NULL),
(33424, '2017-06-10 09:07:14', NULL, NULL, 9934, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:07:14', 'admin-1497056454-14970568343271373', 1, 1, 'SR', NULL, NULL, NULL),
(33425, '2017-06-10 09:07:14', NULL, NULL, 9934, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:07:14', 'admin-1497056454-14970568343271373', 1, 0, '', NULL, NULL, NULL),
(33426, '2017-06-10 09:07:14', NULL, NULL, 9934, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:07:14', 'admin-1497056454-14970568343271373', 1, 1, 'SR', NULL, NULL, NULL),
(33427, '2017-06-10 09:07:14', NULL, NULL, 9934, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:07:14', 'admin-1497056454-14970568343271373', 1, 0, '', NULL, NULL, NULL),
(33428, '2017-06-10 09:05:19', NULL, NULL, 9933, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:05:19', 'admin-1497056454-14970567195103982', 1, 0, '', NULL, NULL, NULL),
(33429, '2017-06-10 09:05:19', NULL, NULL, 9933, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:05:19', 'admin-1497056454-14970567195103982', 1, 0, '', NULL, NULL, NULL),
(33430, '2017-06-10 09:05:19', NULL, NULL, 9933, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:05:19', 'admin-1497056454-14970567195103982', 1, 0, '', NULL, NULL, NULL),
(33431, '2017-06-10 09:05:02', NULL, NULL, 9933, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1497078843', 'admin', '2017-06-10 09:05:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33432, '2017-06-10 08:18:44', NULL, NULL, 9932, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 08:18:44', 'admin-1497053888-1497053924567614', 1, 1, 'SR', 1, NULL, NULL),
(33433, '2017-06-10 08:18:44', NULL, NULL, 9932, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1497078843', 'admin', '2017-06-10 08:18:44', 'admin-1497053888-1497053924567614', 1, 1, 'SR', 1, NULL, NULL),
(33434, '2017-06-11 11:38:53', NULL, NULL, 9995, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1497158410', 'admin', '2017-06-11 11:38:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33435, '2017-06-11 10:56:02', NULL, NULL, 9992, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:56:02', 'admin-1497147234-14971497624003828', 1, 1, 'SR', NULL, NULL, NULL),
(33436, '2017-06-11 11:07:11', NULL, NULL, 9993, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1497158410', 'admin', '2017-06-11 11:07:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33437, '2017-06-11 11:07:17', NULL, NULL, 9993, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 11:07:17', 'admin-1497147234-1497150437663913', 1, 1, 'SR', NULL, NULL, NULL),
(33438, '2017-06-11 11:32:25', NULL, NULL, 9994, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1497158410', 'admin', '2017-06-11 11:32:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33439, '2017-06-11 13:57:11', NULL, NULL, 10002, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 13:57:11', 'admin-1497158410-14971606313887740', 1, 1, 'SR', NULL, NULL, NULL),
(33440, '2017-06-11 14:19:52', NULL, NULL, 10005, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1497158410', 'admin', '2017-06-11 14:19:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33441, '2017-06-11 14:20:20', NULL, NULL, 10005, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 14:20:20', 'admin-1497158410-14971620205929414', 1, 0, '', NULL, NULL, NULL),
(33442, '2017-06-11 14:20:20', NULL, NULL, 10005, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 14:20:20', 'admin-1497158410-14971620205929414', 1, 1, 'SR', NULL, NULL, NULL),
(33443, '2017-06-11 12:18:29', NULL, NULL, 9998, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:18:29', 'admin-1497152965-1497154708765339', 1, 1, 'SR', NULL, NULL, NULL),
(33444, '2017-06-11 10:07:09', NULL, NULL, 9986, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:07:09', 'admin-1497141346-14971468291158780', 1, 0, '', NULL, NULL, NULL),
(33445, '2017-06-11 11:48:17', NULL, NULL, 9996, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1497158410', 'admin', '2017-06-11 11:48:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33446, '2017-06-11 11:48:47', NULL, NULL, 9996, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 11:48:47', 'admin-1497147234-1497152927031237', 1, 1, 'SR', NULL, NULL, NULL),
(33447, '2017-06-11 11:48:47', NULL, NULL, 9996, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 11:48:47', 'admin-1497147234-1497152927031237', 1, 0, '', NULL, NULL, NULL),
(33448, '2017-06-11 16:45:53', NULL, NULL, 10014, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1497158410', 'admin', '2017-06-11 16:45:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33449, '2017-06-11 14:56:18', NULL, NULL, 10008, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 14:56:18', 'admin-1497158410-1497164178251451', 1, 1, 'SR', NULL, NULL, NULL),
(33450, '2017-06-11 14:58:06', NULL, NULL, 10009, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 14:58:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33451, '2017-06-11 14:58:12', NULL, NULL, 10009, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 14:58:12', 'admin-1497158410-14971642927855075', 1, 1, 'SR', NULL, NULL, NULL),
(33452, '2017-06-11 16:28:00', NULL, NULL, 10011, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 16:28:00', 'admin-1497158410-14971696804767696', 1, 1, 'SR', NULL, NULL, NULL),
(33453, '2017-06-11 16:28:31', NULL, NULL, 10011, 0, 284, '218', 'Caramel Waffles', '', 'Desserts', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1497158410', 'admin', '2017-06-11 16:28:31', 'admin-1497158410-14971697117263843', 1, 0, '', NULL, NULL, NULL),
(33454, '2017-06-11 16:28:31', NULL, NULL, 10011, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 16:28:31', 'admin-1497158410-14971697117263843', 1, 0, '', NULL, NULL, NULL),
(33455, '2017-06-11 16:39:34', NULL, NULL, 10012, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.55, 0.0000, 0.0000, 0.55, 1, '27', 1, '1497158410', 'admin', '2017-06-11 16:39:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33456, '2017-06-11 16:40:03', NULL, NULL, 10012, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 16:40:03', 'admin-1497158410-14971704030554169', 1, 0, '', NULL, NULL, NULL),
(33457, '2017-06-11 16:40:03', NULL, NULL, 10012, 0, 284, '218', 'Caramel Waffles', '', 'Desserts', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1497158410', 'admin', '2017-06-11 16:40:03', 'admin-1497158410-14971704030554169', 1, 0, '', NULL, NULL, NULL),
(33458, '2017-06-11 16:42:02', NULL, NULL, 10013, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1497158410', 'admin', '2017-06-11 16:42:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33459, '2017-06-11 16:42:08', NULL, NULL, 10013, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 16:42:08', 'admin-1497158410-14971705285496830', 1, 0, '', NULL, NULL, NULL),
(33460, '2017-06-11 16:42:08', NULL, NULL, 10013, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 16:42:08', 'admin-1497158410-14971705285496830', 1, 1, 'SR', NULL, NULL, NULL),
(33461, '2017-06-11 13:06:50', NULL, NULL, 10001, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 13:06:50', 'admin-1497152965-14971576107308660', 1, 0, '', NULL, NULL, NULL),
(33462, '2017-06-11 13:20:05', NULL, NULL, 10002, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 13:20:05', 'admin-1497152965-14971584050521995', 1, 1, 'SR', NULL, NULL, NULL),
(33463, '2017-06-11 13:26:20', NULL, NULL, 10003, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1497158410', 'admin', '2017-06-11 13:26:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33464, '2017-06-11 11:39:06', NULL, NULL, 9995, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 11:39:06', 'admin-1497147234-149715234636881', 1, 1, 'SR', NULL, NULL, NULL),
(33465, '2017-06-11 13:16:05', NULL, NULL, 10002, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 13:16:05', 'admin-1497152965-14971581657394777', 1, 1, 'SR', NULL, NULL, NULL),
(33466, '2017-06-11 10:50:09', NULL, NULL, 9991, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:50:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33467, '2017-06-11 10:50:29', NULL, NULL, 9991, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:50:29', 'admin-1497147234-14971494288638379', 1, 1, 'SR', NULL, NULL, NULL),
(33468, '2017-06-11 10:50:29', NULL, NULL, 9991, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:50:29', 'admin-1497147234-14971494288638379', 1, 1, 'SR', NULL, NULL, NULL),
(33469, '2017-06-11 10:54:11', NULL, NULL, 9989, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:54:11', 'admin-1497147234-14971496511959469', 1, 0, '', NULL, NULL, NULL),
(33470, '2017-06-11 10:13:45', NULL, NULL, 9987, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:13:45', 'admin-1497141346-1497147225058114', 1, 0, '', NULL, NULL, NULL),
(33471, '2017-06-11 10:21:11', NULL, NULL, 9988, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:21:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33472, '2017-06-11 10:21:23', NULL, NULL, 9988, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:21:23', 'admin-1497147234-14971476829212443', 1, 0, '', NULL, NULL, NULL),
(33473, '2017-06-11 10:21:23', NULL, NULL, 9988, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:21:23', 'admin-1497147234-14971476829212443', 1, 0, '', NULL, NULL, NULL),
(33474, '2017-06-11 10:21:34', NULL, NULL, 9988, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:21:34', 'admin-1497147234-1497147694503715', 1, 0, '', NULL, NULL, NULL),
(33475, '2017-06-11 10:26:58', NULL, NULL, 9989, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.20, 0.0000, 0.0000, 10.20, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:26:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33476, '2017-06-11 10:28:01', NULL, NULL, 9989, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:28:01', 'admin-1497147234-14971480814977647', 1, 0, '', NULL, NULL, NULL),
(33477, '2017-06-11 10:28:01', NULL, NULL, 9989, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:28:01', 'admin-1497147234-14971480814977647', 1, 0, '', NULL, NULL, NULL),
(33478, '2017-06-11 10:28:01', NULL, NULL, 9989, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:28:01', 'admin-1497147234-14971480814977647', 1, 0, '', NULL, NULL, NULL),
(33479, '2017-06-11 10:28:01', NULL, NULL, 9989, 0, 181, '116', 'Open Food ', '2 toast w/ butter', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:28:01', 'admin-1497147234-14971480814977647', 1, 0, '', NULL, NULL, NULL),
(33480, '2017-06-11 12:19:02', NULL, NULL, 9998, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:19:02', 'admin-1497152965-14971547419178791', 1, 1, 'SR', NULL, NULL, NULL),
(33481, '2017-06-11 12:30:09', NULL, NULL, 9999, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:30:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33482, '2017-06-11 12:30:17', NULL, NULL, 9999, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:30:17', 'admin-1497152965-14971554170591888', 1, 1, 'SR', NULL, NULL, NULL),
(33483, '2017-06-11 12:31:30', NULL, NULL, 10000, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:31:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33484, '2017-06-11 10:33:59', NULL, NULL, 9990, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:33:59', 'admin-1497147234-14971484394514423', 1, 0, '', NULL, NULL, NULL),
(33485, '2017-06-11 10:33:59', NULL, NULL, 9990, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:33:59', 'admin-1497147234-14971484394514423', 1, 0, '', NULL, NULL, NULL),
(33486, '2017-06-11 10:34:26', NULL, NULL, 9990, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:34:26', 'admin-1497147234-149714846595214', 1, 1, 'SR', NULL, NULL, NULL),
(33487, '2017-06-11 16:46:07', NULL, NULL, 10014, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 16:46:07', 'admin-1497158410-14971707675294956', 1, 0, '', NULL, NULL, NULL),
(33488, '2017-06-11 17:11:31', NULL, NULL, 10013, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 17:11:31', 'admin-1497158410-14971722908047231', 1, 0, '', NULL, NULL, NULL),
(33489, '2017-06-11 12:18:29', NULL, NULL, 9998, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:18:29', 'admin-1497152965-1497154708765339', 1, 0, '', NULL, NULL, NULL),
(33490, '2017-06-11 12:19:02', NULL, NULL, 9998, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:19:02', 'admin-1497152965-14971547419178791', 1, 1, 'SR', NULL, NULL, NULL),
(33491, '2017-06-11 10:34:26', NULL, NULL, 9990, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:34:26', 'admin-1497147234-149714846595214', 1, 1, 'SR', NULL, NULL, NULL),
(33492, '2017-06-11 17:15:00', NULL, NULL, 10014, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 17:15:00', 'admin-1497158410-14971725000694338', 1, 0, '', NULL, NULL, NULL),
(33493, '2017-06-11 13:28:59', NULL, NULL, 10002, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 13:28:59', 'admin-1497158410-14971589392168012', 1, 1, 'SR', NULL, NULL, NULL),
(33494, '2017-06-11 17:15:00', NULL, NULL, 10014, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 17:15:00', 'admin-1497158410-14971725000694338', 1, 0, '', NULL, NULL, NULL),
(33495, '2017-06-11 17:14:53', NULL, NULL, 10014, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 17:14:53', 'admin-1497158410-14971724930129644', 1, 0, '', NULL, NULL, NULL),
(33496, '2017-06-11 13:28:59', NULL, NULL, 10002, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 13:28:59', 'admin-1497158410-14971589392168012', 1, 1, 'SR', NULL, NULL, NULL),
(33497, '2017-06-11 16:24:08', NULL, NULL, 10011, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.85, 0.0000, 0.0000, 2.85, 1, '27', 1, '1497158410', 'admin', '2017-06-11 16:24:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33498, '2017-06-11 16:24:15', NULL, NULL, 10011, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 16:24:15', 'admin-1497158410-14971694555168741', 1, 1, 'SR', NULL, NULL, NULL),
(33499, '2017-06-11 16:27:08', NULL, NULL, 10004, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 16:27:08', 'admin-1497158410-14971696287048756', 1, 1, 'SR', NULL, NULL, NULL),
(33500, '2017-06-11 14:53:41', NULL, NULL, 10007, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 14:53:41', 'admin-1497158410-14971640211661527', 1, 1, 'SR', NULL, NULL, NULL),
(33501, '2017-06-11 14:56:08', NULL, NULL, 10008, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1497158410', 'admin', '2017-06-11 14:56:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33502, '2017-06-11 14:56:18', NULL, NULL, 10008, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 14:56:18', 'admin-1497158410-1497164178251451', 1, 1, 'SR', NULL, NULL, NULL),
(33503, '2017-06-11 16:44:36', NULL, NULL, 10013, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 16:44:36', 'admin-1497158410-14971706760786683', 1, 0, '', NULL, NULL, NULL),
(33504, '2017-06-11 12:34:56', NULL, NULL, 9993, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:34:56', 'admin-1497152965-14971556963997316', 1, 1, 'SR', NULL, NULL, NULL),
(33505, '2017-06-11 12:39:18', NULL, NULL, 10001, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:39:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33506, '2017-06-11 15:09:29', NULL, NULL, 10010, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 15:09:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33507, '2017-06-11 15:09:59', NULL, NULL, 10010, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 15:09:59', 'admin-1497158410-14971649996771693', 1, 1, 'SR', NULL, NULL, NULL),
(33508, '2017-06-11 15:09:59', NULL, NULL, 10010, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 15:09:59', 'admin-1497158410-14971649996771693', 1, 1, 'SR', NULL, NULL, NULL),
(33509, '2017-06-11 14:34:06', NULL, NULL, 10006, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 14:34:06', 'admin-1497158410-14971628457929775', 1, 0, '', 1, NULL, NULL),
(33510, '2017-06-11 13:57:11', NULL, NULL, 10002, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 13:57:11', 'admin-1497158410-14971606313887740', 1, 1, 'SR', NULL, NULL, NULL),
(33511, '2017-06-11 14:53:23', NULL, NULL, 10007, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1497158410', 'admin', '2017-06-11 14:53:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33512, '2017-06-11 15:09:59', NULL, NULL, 10010, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 15:09:59', 'admin-1497158410-14971649996771693', 1, 1, 'SR', NULL, NULL, NULL),
(33513, '2017-06-11 14:20:20', NULL, NULL, 10005, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 14:20:20', 'admin-1497158410-14971620205929414', 1, 0, '', NULL, NULL, NULL),
(33514, '2017-06-11 13:29:19', NULL, NULL, 10003, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 13:29:19', 'admin-1497158410-14971589597418861', 1, 0, '', NULL, NULL, NULL),
(33515, '2017-06-11 13:36:05', NULL, NULL, 10004, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1497158410', 'admin', '2017-06-11 13:36:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33516, '2017-06-11 13:36:09', NULL, NULL, 10004, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 13:36:09', 'admin-1497158410-14971593696026339', 1, 1, 'SR', NULL, NULL, NULL),
(33517, '2017-06-11 13:27:28', NULL, NULL, 10003, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 13:27:28', 'admin-1497158410-14971588485931864', 1, 1, 'SR', NULL, NULL, NULL),
(33518, '2017-06-11 13:27:28', NULL, NULL, 10003, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 13:27:28', 'admin-1497158410-14971588485931864', 1, 0, '', NULL, NULL, NULL),
(33519, '2017-06-11 13:28:09', NULL, NULL, 10003, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 13:28:09', 'admin-1497158410-1497158888824967', 1, 1, 'SR', NULL, NULL, NULL),
(33520, '2017-06-11 13:28:09', NULL, NULL, 10003, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 13:28:09', 'admin-1497158410-1497158888824967', 1, 0, '', NULL, NULL, NULL),
(33521, '2017-06-11 13:27:28', NULL, NULL, 10003, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 13:27:28', 'admin-1497158410-14971588485931864', 1, 0, '', NULL, NULL, NULL),
(33522, '2017-06-11 13:27:28', NULL, NULL, 10003, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 13:27:28', 'admin-1497158410-14971588485931864', 1, 1, 'SR', NULL, NULL, NULL),
(33523, '2017-06-11 12:40:23', NULL, NULL, 10001, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:40:23', 'admin-1497152965-14971560229744148', 1, 1, 'SR', NULL, NULL, NULL),
(33524, '2017-06-11 12:40:13', NULL, NULL, 10001, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:40:13', 'admin-1497152965-14971560133843612', 1, 1, 'SR', NULL, NULL, NULL),
(33525, '2017-06-11 12:07:27', NULL, NULL, 9994, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:07:27', 'admin-1497152965-14971540468932064', 1, 1, 'SR', NULL, NULL, NULL),
(33526, '2017-06-11 10:05:15', NULL, NULL, 9985, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:05:15', 'admin-1497141346-14971467156725736', 1, 1, 'SR', NULL, NULL, NULL),
(33527, '2017-06-11 10:04:58', NULL, NULL, 9985, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:04:58', 'admin-1497141346-14971466985305571', 1, 0, '', NULL, NULL, NULL),
(33528, '2017-06-11 12:19:02', NULL, NULL, 9998, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:19:02', 'admin-1497152965-14971547419178791', 1, 1, 'SR', NULL, NULL, NULL),
(33529, '2017-06-11 12:31:37', NULL, NULL, 10000, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:31:37', 'admin-1497152965-14971554969247164', 1, 0, '', NULL, NULL, NULL),
(33530, '2017-06-11 12:19:02', NULL, NULL, 9998, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:19:02', 'admin-1497152965-14971547419178791', 1, 1, 'SR', NULL, NULL, NULL),
(33531, '2017-06-11 12:18:29', NULL, NULL, 9998, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:18:29', 'admin-1497152965-1497154708765339', 1, 0, '', NULL, NULL, NULL),
(33532, '2017-06-11 12:17:51', NULL, NULL, 9998, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.90, 0.0000, 0.0000, 9.90, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:17:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33533, '2017-06-11 12:18:28', NULL, NULL, 9998, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:18:29', 'admin-1497152965-1497154708765339', 1, 0, '', NULL, NULL, NULL),
(33534, '2017-06-11 10:01:02', NULL, NULL, 9984, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:01:02', 'admin-1497141346-14971464624731443', 1, 0, '', NULL, NULL, NULL),
(33535, '2017-06-11 10:02:43', NULL, NULL, 9981, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:02:43', 'admin-1497141346-1497146563653161', 1, 0, '', NULL, NULL, NULL),
(33536, '2017-06-11 10:02:43', NULL, NULL, 9981, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:02:43', 'admin-1497141346-1497146563653161', 1, 0, '', NULL, NULL, NULL),
(33537, '2017-06-11 09:26:00', NULL, NULL, 9980, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:26:00', 'admin-1497141346-14971443600447011', 1, 1, 'SR', NULL, NULL, NULL),
(33538, '2017-06-11 12:12:54', NULL, NULL, 9995, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:12:54', 'admin-1497152965-14971543748007148', 1, 0, '', NULL, NULL, NULL),
(33539, '2017-06-11 12:09:24', NULL, NULL, 9997, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:09:24', 'admin-1497152965-14971541639666732', 1, 0, '', NULL, NULL, NULL),
(33540, '2017-06-11 12:09:24', NULL, NULL, 9997, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:09:24', 'admin-1497152965-14971541639666732', 1, 1, 'SR', NULL, NULL, NULL),
(33541, '2017-06-11 12:09:17', NULL, NULL, 9997, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:09:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33542, '2017-06-11 12:40:13', NULL, NULL, 10001, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 12:40:13', 'admin-1497152965-14971560133843612', 1, 1, 'SR', NULL, NULL, NULL),
(33543, '2017-06-11 11:49:40', NULL, NULL, 9996, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 11:49:40', 'admin-1497152965-1497152980057829', 1, 1, 'SR', NULL, NULL, NULL),
(33544, '2017-06-11 11:54:12', NULL, NULL, 9996, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 11:54:12', 'admin-1497152965-14971532525132229', 1, 0, '', NULL, NULL, NULL),
(33545, '2017-06-11 11:48:47', NULL, NULL, 9996, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 11:48:47', 'admin-1497147234-1497152927031237', 1, 0, '', NULL, NULL, NULL),
(33546, '2017-06-11 11:39:25', NULL, NULL, 9995, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 11:39:25', 'admin-1497147234-14971523649972066', 1, 0, '', NULL, NULL, NULL),
(33547, '2017-06-11 11:46:37', NULL, NULL, 9986, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 11:46:37', 'admin-1497147234-14971527968894260', 1, 0, '', NULL, NULL, NULL),
(33548, '2017-06-11 11:39:25', NULL, NULL, 9995, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 11:39:25', 'admin-1497147234-14971523649972066', 1, 1, 'SR', NULL, NULL, NULL),
(33549, '2017-06-11 13:15:58', NULL, NULL, 10002, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1497158410', 'admin', '2017-06-11 13:15:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33550, '2017-06-11 11:39:06', NULL, NULL, 9995, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 11:39:06', 'admin-1497147234-149715234636881', 1, 1, 'SR', NULL, NULL, NULL),
(33551, '2017-06-11 11:32:42', NULL, NULL, 9994, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 11:32:42', 'admin-1497147234-14971519620143492', 1, 0, '', NULL, NULL, NULL),
(33552, '2017-06-11 11:32:42', NULL, NULL, 9994, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 11:32:42', 'admin-1497147234-14971519620143492', 1, 1, 'SR', NULL, NULL, NULL),
(33553, '2017-06-11 10:55:57', NULL, NULL, 9992, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:55:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33554, '2017-06-11 10:56:02', NULL, NULL, 9992, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:56:02', 'admin-1497147234-14971497624003828', 1, 0, '', NULL, NULL, NULL),
(33555, '2017-06-11 11:32:42', NULL, NULL, 9994, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 11:32:42', 'admin-1497147234-14971519620143492', 1, 1, 'SR', NULL, NULL, NULL),
(33556, '2017-06-11 11:32:42', NULL, NULL, 9994, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 11:32:42', 'admin-1497147234-14971519620143492', 1, 0, '', NULL, NULL, NULL),
(33557, '2017-06-11 09:28:12', NULL, NULL, 9982, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:28:12', 'admin-1497141346-1497144492427588', 1, 0, '', NULL, NULL, NULL),
(33558, '2017-06-11 09:30:49', NULL, NULL, 9983, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:30:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33559, '2017-06-11 09:31:05', NULL, NULL, 9983, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:31:05', 'admin-1497141346-14971446651411465', 1, 0, '', NULL, NULL, NULL),
(33560, '2017-06-11 09:31:16', NULL, NULL, 9983, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:31:16', 'admin-1497141346-14971446767041349', 1, 0, '', NULL, NULL, NULL),
(33561, '2017-06-11 09:31:16', NULL, NULL, 9983, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:31:16', 'admin-1497141346-14971446767041349', 1, 0, '', NULL, NULL, NULL),
(33562, '2017-06-11 09:38:20', NULL, NULL, 9978, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:38:20', 'admin-1497141346-14971450998393615', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(33563, '2017-06-11 09:15:36', NULL, NULL, 9978, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:15:36', 'admin-1497141346-14971437364656243', 1, 1, 'SR', NULL, NULL, NULL),
(33564, '2017-06-11 09:15:36', NULL, NULL, 9978, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:15:36', 'admin-1497141346-14971437364656243', 1, 1, 'SR', NULL, NULL, NULL),
(33565, '2017-06-11 09:15:36', NULL, NULL, 9978, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:15:36', 'admin-1497141346-14971437364656243', 1, 1, 'SR', NULL, NULL, NULL),
(33566, '2017-06-11 09:16:09', NULL, NULL, 9979, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 18.80, 0.0000, 0.0000, 18.80, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:16:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33567, '2017-06-11 09:17:16', NULL, NULL, 9979, 0, 154, '88', 'Daily Dose BLT', 'scramble egg', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:17:16', 'admin-1497141346-14971438362944812', 1, 0, '', NULL, NULL, NULL),
(33568, '2017-06-11 09:17:16', NULL, NULL, 9979, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:17:16', 'admin-1497141346-14971438362944812', 1, 0, '', NULL, NULL, NULL),
(33569, '2017-06-11 09:17:16', NULL, NULL, 9979, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:17:16', 'admin-1497141346-14971438362944812', 1, 0, '', NULL, NULL, NULL),
(33570, '2017-06-11 09:17:16', NULL, NULL, 9979, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:17:16', 'admin-1497141346-14971438362944812', 1, 0, '', NULL, NULL, NULL),
(33571, '2017-06-11 09:17:16', NULL, NULL, 9979, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:17:16', 'admin-1497141346-14971438362944812', 1, 0, '', NULL, NULL, NULL),
(33572, '2017-06-11 09:17:16', NULL, NULL, 9979, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:17:16', 'admin-1497141346-14971438362944812', 1, 0, '', NULL, NULL, NULL),
(33573, '2017-06-11 10:46:13', NULL, NULL, 9987, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:46:13', 'admin-1497147234-14971491734219877', 1, 1, 'SR', NULL, NULL, NULL),
(33574, '2017-06-11 10:34:26', NULL, NULL, 9990, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:34:26', 'admin-1497147234-149714846595214', 1, 1, 'SR', NULL, NULL, NULL),
(33575, '2017-06-11 09:26:00', NULL, NULL, 9980, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:26:00', 'admin-1497141346-14971443600447011', 1, 1, 'SR', NULL, NULL, NULL),
(33576, '2017-06-11 10:33:48', NULL, NULL, 9990, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:33:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33577, '2017-06-11 10:28:22', NULL, NULL, 9989, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:28:22', 'admin-1497147234-14971481022829474', 1, 1, 'SR', NULL, NULL, NULL),
(33578, '2017-06-11 10:28:22', NULL, NULL, 9989, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:28:22', 'admin-1497147234-14971481022829474', 1, 0, '', NULL, NULL, NULL),
(33579, '2017-06-11 10:28:22', NULL, NULL, 9989, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:28:22', 'admin-1497147234-14971481022829474', 1, 1, 'SR', NULL, NULL, NULL),
(33580, '2017-06-11 10:11:35', NULL, NULL, 9987, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:11:35', 'admin-1497141346-14971470955111782', 1, 1, 'SR', NULL, NULL, NULL),
(33581, '2017-06-11 10:11:35', NULL, NULL, 9987, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:11:35', 'admin-1497141346-14971470955111782', 1, 1, 'SR', NULL, NULL, NULL),
(33582, '2017-06-11 10:11:35', NULL, NULL, 9987, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:11:35', 'admin-1497141346-14971470955111782', 1, 1, 'SR', NULL, NULL, NULL),
(33583, '2017-06-11 10:01:02', NULL, NULL, 9984, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:01:02', 'admin-1497141346-14971464624731443', 1, 0, '', NULL, NULL, NULL),
(33584, '2017-06-11 09:23:49', NULL, NULL, 9980, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:23:49', 'admin-1497141346-14971442289373571', 1, 0, '', NULL, NULL, NULL),
(33585, '2017-06-11 10:11:35', NULL, NULL, 9987, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:11:35', 'admin-1497141346-14971470955111782', 1, 1, 'SR', NULL, NULL, NULL),
(33586, '2017-06-11 10:11:35', NULL, NULL, 9987, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:11:35', 'admin-1497141346-14971470955111782', 1, 0, '', NULL, NULL, NULL),
(33587, '2017-06-11 10:10:28', NULL, NULL, 9987, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:10:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33588, '2017-06-11 10:07:09', NULL, NULL, 9986, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:07:09', 'admin-1497141346-14971468291158780', 1, 1, 'SR', NULL, NULL, NULL),
(33589, '2017-06-11 10:06:54', NULL, NULL, 9986, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:06:54', 'admin-1497141346-14971468145447747', 1, 0, '', NULL, NULL, NULL),
(33590, '2017-06-11 10:06:45', NULL, NULL, 9986, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:06:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33591, '2017-06-11 10:06:54', NULL, NULL, 9986, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:06:54', 'admin-1497141346-14971468145447747', 1, 0, '', NULL, NULL, NULL),
(33592, '2017-06-11 10:05:15', NULL, NULL, 9985, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:05:15', 'admin-1497141346-14971467156725736', 1, 0, '', NULL, NULL, NULL),
(33593, '2017-06-11 10:05:15', NULL, NULL, 9985, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:05:15', 'admin-1497141346-14971467156725736', 1, 1, 'SR', NULL, NULL, NULL),
(33594, '2017-06-11 10:05:15', NULL, NULL, 9985, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:05:15', 'admin-1497141346-14971467156725736', 1, 0, '', NULL, NULL, NULL),
(33595, '2017-06-11 10:04:58', NULL, NULL, 9985, 0, 156, '90', 'House Cheddar Omelet', 'without cheese', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:04:58', 'admin-1497141346-14971466985305571', 1, 0, '', NULL, NULL, NULL),
(33596, '2017-06-11 10:04:58', NULL, NULL, 9985, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:04:58', 'admin-1497141346-14971466985305571', 1, 0, '', NULL, NULL, NULL),
(33597, '2017-06-11 10:04:58', NULL, NULL, 9985, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:04:58', 'admin-1497141346-14971466985305571', 1, 0, '', NULL, NULL, NULL),
(33598, '2017-06-11 10:04:16', NULL, NULL, 9985, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.90, 0.0000, 0.0000, 9.90, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:04:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33599, '2017-06-11 09:59:20', NULL, NULL, 9982, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:59:20', 'admin-1497141346-14971463607659268', 1, 0, '', NULL, NULL, NULL),
(33600, '2017-06-11 09:59:20', NULL, NULL, 9982, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:59:20', 'admin-1497141346-14971463607659268', 1, 0, '', NULL, NULL, NULL),
(33601, '2017-06-11 10:00:52', NULL, NULL, 9984, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:00:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33602, '2017-06-11 10:01:02', NULL, NULL, 9984, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 10:01:02', 'admin-1497141346-14971464624731443', 1, 1, 'SR', NULL, NULL, NULL),
(33603, '2017-06-11 09:59:20', NULL, NULL, 9982, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:59:20', 'admin-1497141346-14971463607659268', 1, 1, 'SR', NULL, NULL, NULL),
(33604, '2017-06-11 09:28:07', NULL, NULL, 9982, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:28:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33605, '2017-06-11 09:23:59', NULL, NULL, 9981, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:23:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33606, '2017-06-11 09:24:16', NULL, NULL, 9981, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:24:16', 'admin-1497141346-1497144256647344', 1, 0, '', NULL, NULL, NULL),
(33607, '2017-06-11 09:24:16', NULL, NULL, 9981, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:24:16', 'admin-1497141346-1497144256647344', 1, 0, '', NULL, NULL, NULL),
(33608, '2017-06-11 09:25:15', NULL, NULL, 9979, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:25:15', 'admin-1497141346-14971443151527682', 1, 0, '', NULL, NULL, NULL),
(33609, '2017-06-11 09:25:15', NULL, NULL, 9979, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:25:15', 'admin-1497141346-14971443151527682', 1, 1, 'SR', NULL, NULL, NULL),
(33610, '2017-06-11 09:26:00', NULL, NULL, 9980, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:26:00', 'admin-1497141346-14971443600447011', 1, 1, 'SR', NULL, NULL, NULL),
(33611, '2017-06-11 09:26:00', NULL, NULL, 9980, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:26:00', 'admin-1497141346-14971443600447011', 1, 1, 'SR', NULL, NULL, NULL),
(33612, '2017-06-11 09:26:00', NULL, NULL, 9980, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:26:00', 'admin-1497141346-14971443600447011', 1, 1, 'SR', NULL, NULL, NULL),
(33613, '2017-06-11 09:17:16', NULL, NULL, 9979, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:17:16', 'admin-1497141346-14971438362944812', 1, 0, '', NULL, NULL, NULL),
(33614, '2017-06-11 09:22:52', NULL, NULL, 9979, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:22:52', 'admin-1497141346-1497144172009799', 1, 1, 'SR', NULL, NULL, NULL),
(33615, '2017-06-11 09:22:52', NULL, NULL, 9979, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:22:52', 'admin-1497141346-1497144172009799', 1, 1, 'SR', NULL, NULL, NULL),
(33616, '2017-06-11 09:23:49', NULL, NULL, 9980, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:23:49', 'admin-1497141346-14971442289373571', 1, 0, '', NULL, NULL, NULL),
(33617, '2017-06-11 09:23:49', NULL, NULL, 9980, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:23:49', 'admin-1497141346-14971442289373571', 1, 0, '', NULL, NULL, NULL),
(33618, '2017-06-11 09:23:49', NULL, NULL, 9980, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:23:49', 'admin-1497141346-14971442289373571', 1, 0, '', NULL, NULL, NULL),
(33619, '2017-06-11 09:23:49', NULL, NULL, 9980, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:23:49', 'admin-1497141346-14971442289373571', 1, 0, '', NULL, NULL, NULL),
(33620, '2017-06-11 09:23:02', NULL, NULL, 9980, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.10, 0.0000, 0.0000, 15.10, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:23:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33621, '2017-06-11 09:23:49', NULL, NULL, 9980, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:23:49', 'admin-1497141346-14971442289373571', 1, 0, '', NULL, NULL, NULL),
(33622, '2017-06-11 09:22:52', NULL, NULL, 9979, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:22:52', 'admin-1497141346-1497144172009799', 1, 0, '', NULL, NULL, NULL),
(33623, '2017-06-11 09:22:52', NULL, NULL, 9979, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:22:52', 'admin-1497141346-1497144172009799', 1, 1, 'SR', NULL, NULL, NULL),
(33624, '2017-06-11 09:15:26', NULL, NULL, 9978, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:15:26', 'admin-1497141346-1497143726629891', 1, 0, '', NULL, NULL, NULL),
(33625, '2017-06-11 09:15:26', NULL, NULL, 9978, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:15:26', 'admin-1497141346-1497143726629891', 1, 0, '', NULL, NULL, NULL),
(33626, '2017-06-11 09:15:19', NULL, NULL, 9978, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1497158410', 'admin', '2017-06-11 09:15:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33627, '2017-06-12 12:36:53', NULL, NULL, 10034, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:36:53', 'admin-1497241337-14972422137046812', 1, 1, 'SR', NULL, NULL, NULL),
(33628, '2017-06-12 12:36:53', NULL, NULL, 10034, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:36:53', 'admin-1497241337-14972422137046812', 1, 1, 'SR', NULL, NULL, NULL),
(33629, '2017-06-12 12:27:04', NULL, NULL, 10032, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:27:04', 'admin-1497241337-14972416243767083', 1, 1, 'SR', NULL, NULL, NULL),
(33630, '2017-06-12 12:34:09', NULL, NULL, 10033, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:34:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33631, '2017-06-12 12:34:29', NULL, NULL, 10033, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:34:29', 'admin-1497241337-14972420690338466', 1, 0, '', NULL, NULL, NULL),
(33632, '2017-06-12 13:50:25', NULL, NULL, 10039, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 13:50:25', 'admin-1497241337-14972466256155967', 1, 0, '', NULL, NULL, NULL),
(33633, '2017-06-12 13:54:45', NULL, NULL, 10039, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 13:54:45', 'admin-1497246792-1497246884812486', 1, 1, 'SR', NULL, NULL, NULL),
(33634, '2017-06-12 13:54:45', NULL, NULL, 10039, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 13:54:45', 'admin-1497246792-1497246884812486', 1, 1, 'SR', NULL, NULL, NULL),
(33635, '2017-06-12 13:57:38', NULL, NULL, 10038, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 13:57:38', 'admin-1497246792-14972470585587766', 1, 1, 'SR', NULL, NULL, NULL),
(33636, '2017-06-12 14:13:03', NULL, NULL, 10036, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 14:13:03', 'admin-1497246792-1497247983053646', 1, 1, 'SR', NULL, NULL, NULL),
(33637, '2017-06-12 12:58:49', NULL, NULL, 10036, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:58:49', 'admin-1497241337-14972435288048560', 1, 0, '', NULL, NULL, NULL),
(33638, '2017-06-12 12:59:17', NULL, NULL, 10036, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:59:17', 'admin-1497241337-14972435575721010', 1, 1, 'SR', NULL, NULL, NULL),
(33639, '2017-06-12 12:59:17', NULL, NULL, 10036, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:59:17', 'admin-1497241337-14972435575721010', 1, 1, 'SR', NULL, NULL, NULL),
(33640, '2017-06-12 13:04:21', NULL, NULL, 10037, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 13:04:21', 'admin-1497241337-14972438612204138', 1, 1, 'SR', NULL, NULL, NULL),
(33641, '2017-06-12 10:26:53', NULL, NULL, 10023, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:26:53', 'admin-1497228235-14972344137399744', 1, 0, '', NULL, NULL, NULL),
(33642, '2017-06-12 10:26:53', NULL, NULL, 10023, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:26:53', 'admin-1497228235-14972344137399744', 1, 0, '', NULL, NULL, NULL),
(33643, '2017-06-12 10:26:53', NULL, NULL, 10023, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:26:53', 'admin-1497228235-14972344137399744', 1, 0, '', NULL, NULL, NULL),
(33644, '2017-06-12 12:36:00', NULL, NULL, 10033, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:36:00', 'admin-1497241337-1497242160426864', 1, 1, 'SR', NULL, NULL, NULL),
(33645, '2017-06-12 14:20:16', NULL, NULL, 10040, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 14:20:16', 'admin-1497246792-14972484162124144', 1, 0, '', NULL, NULL, NULL),
(33646, '2017-06-12 14:20:16', NULL, NULL, 10040, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 14:20:16', 'admin-1497246792-14972484162124144', 1, 1, 'SR', NULL, NULL, NULL),
(33647, '2017-06-12 12:36:32', NULL, NULL, 10034, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:36:32', 'admin-1497241337-1497242192623516', 1, 0, '', NULL, NULL, NULL),
(33648, '2017-06-12 17:05:26', NULL, NULL, 10045, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 17:05:26', 'admin-1497251184-14972583257607538', 1, 1, 'SR', 1, NULL, NULL),
(33649, '2017-06-12 17:05:25', NULL, NULL, 10045, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 17:05:25', 'admin-1497251184-14972583257607538', 1, 1, 'SR', 1, NULL, NULL),
(33650, '2017-06-12 16:34:21', NULL, NULL, 10044, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 16:34:21', 'admin-1497251184-14972564617257577', 1, 1, 'SR', 1, NULL, NULL),
(33651, '2017-06-12 13:49:43', NULL, NULL, 10039, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.70, 0.0000, 0.0000, 9.70, 1, '27', 1, '1497251184', 'admin', '2017-06-12 13:49:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33652, '2017-06-12 17:49:11', NULL, NULL, 10047, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 17:49:11', 'admin-1497251184-14972609513976226', 1, 0, '', NULL, NULL, NULL),
(33653, '2017-06-12 17:13:53', NULL, NULL, 10046, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1497251184', 'admin', '2017-06-12 17:13:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33654, '2017-06-12 12:27:04', NULL, NULL, 10032, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:27:04', 'admin-1497241337-14972416243767083', 1, 1, 'SR', NULL, NULL, NULL),
(33655, '2017-06-12 13:03:28', NULL, NULL, 10037, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1497251184', 'admin', '2017-06-12 13:03:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33656, '2017-06-12 13:03:47', NULL, NULL, 10037, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 13:03:47', 'admin-1497241337-14972438277827643', 1, 0, '', NULL, NULL, NULL),
(33657, '2017-06-12 13:03:47', NULL, NULL, 10037, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 13:03:47', 'admin-1497241337-14972438277827643', 1, 0, '', NULL, NULL, NULL),
(33658, '2017-06-12 13:03:47', NULL, NULL, 10037, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 13:03:47', 'admin-1497241337-14972438277827643', 1, 0, '', NULL, NULL, NULL),
(33659, '2017-06-12 13:04:21', NULL, NULL, 10037, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 13:04:21', 'admin-1497241337-14972438612204138', 1, 1, 'SR', NULL, NULL, NULL),
(33660, '2017-06-12 13:04:21', NULL, NULL, 10037, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 13:04:21', 'admin-1497241337-14972438612204138', 1, 1, 'SR', NULL, NULL, NULL),
(33661, '2017-06-12 17:49:08', NULL, NULL, 10047, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1497251184', 'admin', '2017-06-12 17:49:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33662, '2017-06-12 17:14:09', NULL, NULL, 10046, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 17:14:09', 'admin-1497251184-14972588488827228', 1, 1, 'SR', NULL, NULL, NULL),
(33663, '2017-06-12 12:57:52', NULL, NULL, 10036, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:57:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33664, '2017-06-12 12:58:48', NULL, NULL, 10036, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:58:49', 'admin-1497241337-14972435288048560', 1, 1, 'SR', NULL, NULL, NULL),
(33665, '2017-06-12 17:14:09', NULL, NULL, 10046, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 17:14:09', 'admin-1497251184-14972588488827228', 1, 0, '', NULL, NULL, NULL),
(33666, '2017-06-12 14:20:31', NULL, NULL, 10040, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 14:20:31', 'admin-1497246792-14972484316983091', 1, 0, '', NULL, NULL, NULL),
(33667, '2017-06-12 15:06:19', NULL, NULL, 10042, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 15:06:19', 'admin-1497246792-14972511790071747', 1, 1, 'SR', NULL, NULL, NULL),
(33668, '2017-06-12 15:06:19', NULL, NULL, 10042, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 15:06:19', 'admin-1497246792-14972511790071747', 1, 1, 'SR', NULL, NULL, NULL),
(33669, '2017-06-12 15:06:19', NULL, NULL, 10042, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 15:06:19', 'admin-1497246792-14972511790071747', 1, 0, '', NULL, NULL, NULL),
(33670, '2017-06-12 15:06:19', NULL, NULL, 10042, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 15:06:19', 'admin-1497246792-14972511790071747', 1, 0, '', NULL, NULL, NULL),
(33671, '2017-06-12 14:33:21', NULL, NULL, 10041, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 14:33:21', 'admin-1497246792-14972492018035815', 1, 0, '', NULL, NULL, NULL),
(33672, '2017-06-12 15:06:01', NULL, NULL, 10042, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1497251184', 'admin', '2017-06-12 15:06:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33673, '2017-06-12 14:33:08', NULL, NULL, 10041, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 14:33:08', 'admin-1497246792-14972491887075498', 1, 0, '', NULL, NULL, NULL),
(33674, '2017-06-12 14:27:22', NULL, NULL, 10039, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 14:27:22', 'admin-1497246792-1497248842636680', 1, 0, '', NULL, NULL, NULL),
(33675, '2017-06-12 14:32:57', NULL, NULL, 10041, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1497251184', 'admin', '2017-06-12 14:32:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33676, '2017-06-12 12:21:38', NULL, NULL, 10031, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:21:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33677, '2017-06-12 11:17:18', NULL, NULL, 10027, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 11:17:18', 'admin-1497234420-14972374381556263', 1, 0, '', NULL, NULL, NULL),
(33678, '2017-06-12 11:21:26', NULL, NULL, 10028, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1497251184', 'admin', '2017-06-12 11:21:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33679, '2017-06-12 14:20:31', NULL, NULL, 10040, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 14:20:31', 'admin-1497246792-14972484316983091', 1, 1, 'SR', NULL, NULL, NULL),
(33680, '2017-06-12 14:22:00', NULL, NULL, 10040, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 14:22:00', 'admin-1497246792-14972485201782734', 1, 1, 'SR', NULL, NULL, NULL),
(33681, '2017-06-12 14:20:00', NULL, NULL, 10040, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1497251184', 'admin', '2017-06-12 14:20:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33682, '2017-06-12 13:58:27', NULL, NULL, 10039, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 13:58:27', 'admin-1497246792-14972471078384245', 1, 0, '', NULL, NULL, NULL),
(33683, '2017-06-12 14:01:10', NULL, NULL, 10039, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 14:01:10', 'admin-1497246792-14972472700513343', 1, 1, 'SR', NULL, NULL, NULL),
(33684, '2017-06-12 12:22:09', NULL, NULL, 10031, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:22:09', 'admin-1497234420-14972413294886841', 1, 0, '', NULL, NULL, NULL),
(33685, '2017-06-12 12:26:21', NULL, NULL, 10032, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.50, 0.0000, 0.0000, 11.50, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:26:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33686, '2017-06-12 12:27:04', NULL, NULL, 10032, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:27:04', 'admin-1497241337-14972416243767083', 1, 1, 'SR', NULL, NULL, NULL),
(33687, '2017-06-12 12:27:04', NULL, NULL, 10032, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:27:04', 'admin-1497241337-14972416243767083', 1, 1, 'SR', NULL, NULL, NULL),
(33688, '2017-06-12 12:27:04', NULL, NULL, 10032, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:27:04', 'admin-1497241337-14972416243767083', 1, 0, '', NULL, NULL, NULL),
(33689, '2017-06-12 12:27:04', NULL, NULL, 10032, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:27:04', 'admin-1497241337-14972416243767083', 1, 1, 'SR', NULL, NULL, NULL),
(33690, '2017-06-12 12:27:04', NULL, NULL, 10032, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:27:04', 'admin-1497241337-14972416243767083', 1, 0, '', NULL, NULL, NULL),
(33691, '2017-06-12 12:27:04', NULL, NULL, 10032, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:27:04', 'admin-1497241337-14972416243767083', 1, 1, 'SR', NULL, NULL, NULL),
(33692, '2017-06-12 12:36:32', NULL, NULL, 10034, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:36:32', 'admin-1497241337-1497242192623516', 1, 0, '', NULL, NULL, NULL),
(33693, '2017-06-12 13:50:25', NULL, NULL, 10039, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 13:50:25', 'admin-1497241337-14972466256155967', 1, 1, 'SR', NULL, NULL, NULL),
(33694, '2017-06-12 13:28:32', NULL, NULL, 10035, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 13:28:32', 'admin-1497241337-14972453123178169', 1, 0, '', NULL, NULL, NULL),
(33695, '2017-06-12 13:20:36', NULL, NULL, 10038, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 13:20:36', 'admin-1497241337-14972448361607637', 1, 1, 'SR', NULL, NULL, NULL),
(33696, '2017-06-12 13:20:14', NULL, NULL, 10038, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1497251184', 'admin', '2017-06-12 13:20:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33697, '2017-06-12 13:20:25', NULL, NULL, 10038, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 13:20:25', 'admin-1497241337-1497244825204764', 1, 0, '', NULL, NULL, NULL),
(33698, '2017-06-12 12:48:51', NULL, NULL, 10035, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:48:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33699, '2017-06-12 12:48:58', NULL, NULL, 10035, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:48:58', 'admin-1497241337-14972429380894232', 1, 0, '', NULL, NULL, NULL),
(33700, '2017-06-12 12:55:11', NULL, NULL, 10035, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:55:11', 'admin-1497241337-14972433112489037', 1, 0, '', NULL, NULL, NULL),
(33701, '2017-06-12 12:49:06', NULL, NULL, 10035, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:49:06', 'admin-1497241337-14972429459132589', 1, 1, 'SR', NULL, NULL, NULL),
(33702, '2017-06-12 12:34:29', NULL, NULL, 10033, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:34:29', 'admin-1497241337-14972420690338466', 1, 0, '', NULL, NULL, NULL),
(33703, '2017-06-12 12:34:29', NULL, NULL, 10033, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:34:29', 'admin-1497241337-14972420690338466', 1, 0, '', NULL, NULL, NULL),
(33704, '2017-06-12 12:49:06', NULL, NULL, 10035, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:49:06', 'admin-1497241337-14972429459132589', 1, 1, 'SR', NULL, NULL, NULL),
(33705, '2017-06-12 12:36:00', NULL, NULL, 10033, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:36:00', 'admin-1497241337-1497242160426864', 1, 1, 'SR', NULL, NULL, NULL),
(33706, '2017-06-12 12:36:05', NULL, NULL, 10034, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:36:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33707, '2017-06-12 10:26:53', NULL, NULL, 10023, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:26:53', 'admin-1497228235-14972344137399744', 1, 0, '', NULL, NULL, NULL),
(33708, '2017-06-12 10:27:25', NULL, NULL, 10023, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:27:25', 'admin-1497234420-1497234445693145', 1, 1, 'SR', NULL, NULL, NULL),
(33709, '2017-06-12 10:27:25', NULL, NULL, 10023, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:27:25', 'admin-1497234420-1497234445693145', 1, 1, 'SR', NULL, NULL, NULL),
(33710, '2017-06-12 10:27:25', NULL, NULL, 10023, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:27:25', 'admin-1497234420-1497234445693145', 1, 1, 'SR', NULL, NULL, NULL),
(33711, '2017-06-12 10:27:25', NULL, NULL, 10023, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:27:25', 'admin-1497234420-1497234445693145', 1, 1, 'SR', NULL, NULL, NULL),
(33712, '2017-06-12 10:30:03', NULL, NULL, 10024, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:30:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33713, '2017-06-12 10:30:13', NULL, NULL, 10024, 0, 153, '87', 'Wake Me Up!', 'bacon put seperate', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:30:13', 'admin-1497234420-14972346133212648', 1, 0, '', NULL, NULL, NULL),
(33714, '2017-06-12 09:15:58', NULL, NULL, 10016, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:15:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33715, '2017-06-12 09:16:14', NULL, NULL, 10016, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:16:14', 'admin-1497228235-14972301739982075', 1, 0, '', NULL, NULL, NULL),
(33716, '2017-06-12 09:19:54', NULL, NULL, 10016, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:19:54', 'admin-1497228235-14972303939478578', 1, 0, '', NULL, NULL, NULL),
(33717, '2017-06-12 09:22:35', NULL, NULL, 10017, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:22:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33718, '2017-06-12 09:22:46', NULL, NULL, 10017, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:22:46', 'admin-1497228235-14972305662297678', 1, 0, '', NULL, NULL, NULL),
(33719, '2017-06-12 09:25:36', NULL, NULL, 10017, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:25:36', 'admin-1497228235-14972307359259839', 1, 0, '', NULL, NULL, NULL),
(33720, '2017-06-12 09:22:46', NULL, NULL, 10017, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:22:46', 'admin-1497228235-14972305662297678', 1, 0, '', NULL, NULL, NULL),
(33721, '2017-06-12 09:24:57', NULL, NULL, 10016, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:24:57', 'admin-1497228235-14972306968525528', 1, 0, '', NULL, NULL, NULL),
(33722, '2017-06-12 09:27:27', NULL, NULL, 10018, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:27:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33723, '2017-06-12 09:27:44', NULL, NULL, 10018, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:27:44', 'admin-1497228235-14972308641561669', 1, 0, '', NULL, NULL, NULL),
(33724, '2017-06-12 09:27:44', NULL, NULL, 10018, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:27:44', 'admin-1497228235-14972308641561669', 1, 0, '', NULL, NULL, NULL),
(33725, '2017-06-12 10:41:14', NULL, NULL, 10025, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:41:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33726, '2017-06-12 10:41:24', NULL, NULL, 10025, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:41:24', 'admin-1497234420-14972352847635691', 1, 0, '', NULL, NULL, NULL),
(33727, '2017-06-12 10:41:24', NULL, NULL, 10025, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:41:24', 'admin-1497234420-14972352847635691', 1, 0, '', NULL, NULL, NULL),
(33728, '2017-06-12 10:41:50', NULL, NULL, 10025, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:41:50', 'admin-1497234420-14972353100652187', 1, 1, 'SR', NULL, NULL, NULL),
(33729, '2017-06-12 10:41:50', NULL, NULL, 10025, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:41:50', 'admin-1497234420-14972353100652187', 1, 1, 'SR', NULL, NULL, NULL),
(33730, '2017-06-12 12:27:04', NULL, NULL, 10032, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:27:04', 'admin-1497241337-14972416243767083', 1, 1, 'SR', NULL, NULL, NULL),
(33731, '2017-06-12 12:22:09', NULL, NULL, 10031, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:22:09', 'admin-1497234420-14972413294886841', 1, 1, 'SR', NULL, NULL, NULL),
(33732, '2017-06-12 12:22:09', NULL, NULL, 10031, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:22:09', 'admin-1497234420-14972413294886841', 1, 0, '', NULL, NULL, NULL),
(33733, '2017-06-12 12:21:46', NULL, NULL, 10031, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:21:46', 'admin-1497234420-14972413061371242', 1, 1, 'SR', NULL, NULL, NULL),
(33734, '2017-06-12 12:15:20', NULL, NULL, 10030, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:15:20', 'admin-1497234420-14972409198819940', 1, 1, 'SR', NULL, NULL, NULL),
(33735, '2017-06-12 12:15:20', NULL, NULL, 10030, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:15:20', 'admin-1497234420-14972409198819940', 1, 0, '', NULL, NULL, NULL),
(33736, '2017-06-12 12:15:20', NULL, NULL, 10030, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:15:20', 'admin-1497234420-14972409198819940', 1, 1, 'SR', NULL, NULL, NULL),
(33737, '2017-06-12 12:14:59', NULL, NULL, 10030, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:14:59', 'admin-1497234420-1497240899399732', 1, 0, '', NULL, NULL, NULL),
(33738, '2017-06-12 12:14:59', NULL, NULL, 10030, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:14:59', 'admin-1497234420-1497240899399732', 1, 0, '', NULL, NULL, NULL),
(33739, '2017-06-12 12:14:59', NULL, NULL, 10030, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:14:59', 'admin-1497234420-1497240899399732', 1, 0, '', NULL, NULL, NULL),
(33740, '2017-06-12 15:08:43', NULL, NULL, 10043, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1497251184', 'admin', '2017-06-12 15:08:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33741, '2017-06-12 15:08:48', NULL, NULL, 10043, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 15:08:48', 'admin-1497251184-14972513286313033', 1, 1, 'SR', NULL, NULL, NULL),
(33742, '2017-06-12 12:14:35', NULL, NULL, 10030, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1497251184', 'admin', '2017-06-12 12:14:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33743, '2017-06-12 11:22:24', NULL, NULL, 10028, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 11:22:24', 'admin-1497234420-14972377441179530', 1, 1, 'SR', NULL, NULL, NULL),
(33744, '2017-06-12 11:22:24', NULL, NULL, 10028, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 11:22:24', 'admin-1497234420-14972377441179530', 1, 1, 'SR', NULL, NULL, NULL),
(33745, '2017-06-12 11:21:45', NULL, NULL, 10028, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 11:21:45', 'admin-1497234420-14972377054756715', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(33746, '2017-06-12 11:21:45', NULL, NULL, 10028, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 11:21:45', 'admin-1497234420-14972377054756715', 1, 0, '', NULL, NULL, NULL),
(33747, '2017-06-12 10:26:53', NULL, NULL, 10023, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:26:53', 'admin-1497228235-14972344137399744', 1, 0, '', NULL, NULL, NULL),
(33748, '2017-06-12 11:17:18', NULL, NULL, 10027, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 11:17:18', 'admin-1497234420-14972374381556263', 1, 0, '', NULL, NULL, NULL),
(33749, '2017-06-12 11:17:18', NULL, NULL, 10027, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 11:17:18', 'admin-1497234420-14972374381556263', 1, 0, '', NULL, NULL, NULL),
(33750, '2017-06-12 11:17:10', NULL, NULL, 10027, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1497251184', 'admin', '2017-06-12 11:17:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33751, '2017-06-12 11:10:32', NULL, NULL, 10026, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1497251184', 'admin', '2017-06-12 11:10:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33752, '2017-06-12 11:10:38', NULL, NULL, 10026, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 11:10:38', 'admin-1497234420-14972370385758176', 1, 0, '', NULL, NULL, NULL),
(33753, '2017-06-12 09:28:00', NULL, NULL, 10019, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:28:00', 'admin-1497228235-14972308803376512', 1, 0, '', NULL, NULL, NULL),
(33754, '2017-06-12 09:29:01', NULL, NULL, 10019, 0, 156, '90', 'House Cheddar Omelet', 'add bake beans', 'Meals', 'Morning Bites ', 1, 14.50, 14.5000, 0.0000, 14.50, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:29:01', 'admin-1497228235-14972309412663677', 1, 0, '', NULL, NULL, NULL),
(33755, '2017-06-12 09:51:15', NULL, NULL, 10020, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:51:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33756, '2017-06-12 09:51:38', NULL, NULL, 10020, 0, 153, '87', 'Wake Me Up!', 'no sausage', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:51:38', 'admin-1497228235-14972322986693327', 1, 0, '', NULL, NULL, NULL),
(33757, '2017-06-12 09:51:38', NULL, NULL, 10020, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:51:38', 'admin-1497228235-14972322986693327', 1, 0, '', NULL, NULL, NULL),
(33758, '2017-06-12 09:51:47', NULL, NULL, 10020, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:51:47', 'admin-1497228235-14972323073858218', 1, 1, 'SR', NULL, NULL, NULL),
(33759, '2017-06-12 09:51:47', NULL, NULL, 10020, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:51:47', 'admin-1497228235-14972323073858218', 1, 0, '', NULL, NULL, NULL),
(33760, '2017-06-12 09:54:17', NULL, NULL, 10021, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:54:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33761, '2017-06-12 09:54:38', NULL, NULL, 10021, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:54:38', 'admin-1497228235-14972324787492444', 1, 0, '', NULL, NULL, NULL),
(33762, '2017-06-12 09:54:38', NULL, NULL, 10021, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:54:38', 'admin-1497228235-14972324787492444', 1, 0, '', NULL, NULL, NULL),
(33763, '2017-06-12 09:55:11', NULL, NULL, 10021, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:55:11', 'admin-1497228235-14972325111139190', 1, 1, 'SR', NULL, NULL, NULL),
(33764, '2017-06-12 09:55:11', NULL, NULL, 10021, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:55:11', 'admin-1497228235-14972325111139190', 1, 1, 'SR', NULL, NULL, NULL),
(33765, '2017-06-12 10:11:01', NULL, NULL, 10022, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:11:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33766, '2017-06-12 10:11:53', NULL, NULL, 10022, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:11:53', 'admin-1497228235-14972335136597825', 1, 0, '', NULL, NULL, NULL),
(33767, '2017-06-12 10:11:53', NULL, NULL, 10022, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:11:53', 'admin-1497228235-14972335136597825', 1, 0, '', NULL, NULL, NULL),
(33768, '2017-06-12 10:12:26', NULL, NULL, 10022, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:12:26', 'admin-1497228235-14972335458081039', 1, 1, 'SR', NULL, NULL, NULL),
(33769, '2017-06-12 10:12:26', NULL, NULL, 10022, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:12:26', 'admin-1497228235-14972335458081039', 1, 1, 'SR', NULL, NULL, NULL),
(33770, '2017-06-12 10:25:15', NULL, NULL, 10020, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:25:15', 'admin-1497228235-149723431541051', 1, 0, '', NULL, NULL, NULL),
(33771, '2017-06-12 10:26:43', NULL, NULL, 10023, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.00, 0.0000, 0.0000, 13.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 10:26:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33772, '2017-06-12 09:27:48', NULL, NULL, 10019, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.85, 0.0000, 0.0000, 2.85, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:27:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33773, '2017-06-12 09:27:44', NULL, NULL, 10018, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:27:44', 'admin-1497228235-14972308641561669', 1, 0, '', NULL, NULL, NULL),
(33774, '2017-06-12 09:27:44', NULL, NULL, 10018, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:27:44', 'admin-1497228235-14972308641561669', 1, 0, '', NULL, NULL, NULL),
(33775, '2017-06-12 09:15:27', NULL, NULL, 10015, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497251184', 'admin', '2017-06-12 09:15:27', 'admin-1497228235-1497230127092533', 1, 1, 'SR', 1, NULL, NULL),
(33776, '2017-06-14 14:18:26', NULL, NULL, 10076, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1497412185', 'admin', '2017-06-14 14:18:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33777, '2017-06-14 14:18:30', NULL, NULL, 10076, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 14:18:30', 'admin-1497412185-14974211108268141', 1, 0, '', NULL, NULL, NULL),
(33778, '2017-06-14 14:25:46', NULL, NULL, 10076, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 14:25:46', 'admin-1497412185-14974215458298638', 1, 0, '', NULL, NULL, NULL),
(33779, '2017-06-14 14:26:10', NULL, NULL, 10077, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1497412185', 'admin', '2017-06-14 14:26:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33780, '2017-06-14 14:26:14', NULL, NULL, 10077, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 14:26:14', 'admin-1497412185-14974215737437053', 1, 0, '', NULL, NULL, NULL),
(33781, '2017-06-14 14:26:14', NULL, NULL, 10077, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 14:26:14', 'admin-1497412185-14974215737437053', 1, 0, '', NULL, NULL, NULL),
(33782, '2017-06-14 16:18:47', NULL, NULL, 10078, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1497412185', 'admin', '2017-06-14 16:18:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33783, '2017-06-14 16:18:55', NULL, NULL, 10078, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 16:18:55', 'admin-1497412185-1497428335628895', 1, 0, '', NULL, NULL, NULL),
(33784, '2017-06-14 16:18:59', NULL, NULL, 10079, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1497412185', 'admin', '2017-06-14 16:18:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33785, '2017-06-14 10:36:12', NULL, NULL, 10056, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 10:36:12', 'admin-1497401099-1497407772688580', 1, 0, '', NULL, NULL, NULL),
(33786, '2017-06-14 10:36:18', NULL, NULL, 10056, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 10:36:18', 'admin-1497401099-14974077782281533', 1, 1, 'SR', NULL, NULL, NULL),
(33787, '2017-06-14 10:36:18', NULL, NULL, 10056, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 10:36:18', 'admin-1497401099-14974077782281533', 1, 1, 'SR', NULL, NULL, NULL),
(33788, '2017-06-14 11:26:44', NULL, NULL, 10057, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1497412185', 'admin', '2017-06-14 11:26:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33789, '2017-06-14 16:33:04', NULL, NULL, 10078, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 16:33:04', 'admin-1497412185-14974291838743038', 1, 1, 'SR', NULL, NULL, NULL),
(33790, '2017-06-14 16:41:15', NULL, NULL, 10080, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 16:41:15', 'admin-1497412185-14974296751053516', 1, 0, '', 1, NULL, NULL),
(33791, '2017-06-14 11:46:52', NULL, NULL, 10061, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 11:46:52', 'admin-1497401099-1497412011939634', 1, 1, 'SR', NULL, NULL, NULL),
(33792, '2017-06-14 12:49:30', NULL, NULL, 10069, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 12:49:30', 'admin-1497412185-1497415770298226', 1, 1, 'SR', 1, NULL, NULL),
(33793, '2017-06-14 11:46:52', NULL, NULL, 10061, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 11:46:52', 'admin-1497401099-1497412011939634', 1, 1, 'SR', NULL, NULL, NULL),
(33794, '2017-06-14 11:49:16', NULL, NULL, 10062, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1497412185', 'admin', '2017-06-14 11:49:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33795, '2017-06-14 16:19:02', NULL, NULL, 10079, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 16:19:02', 'admin-1497412185-14974283421435551', 1, 1, 'SR', NULL, NULL, NULL),
(33796, '2017-06-14 14:12:01', NULL, NULL, 10075, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 14:12:01', 'admin-1497412185-14974207209842734', 1, 1, 'SR', NULL, NULL, NULL),
(33797, '2017-06-14 11:49:25', NULL, NULL, 10062, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 11:49:25', 'admin-1497401099-1497412164813912', 1, 0, '', NULL, NULL, NULL),
(33798, '2017-06-14 11:49:25', NULL, NULL, 10062, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 11:49:25', 'admin-1497401099-1497412164813912', 1, 1, 'SR', NULL, NULL, NULL),
(33799, '2017-06-14 11:49:32', NULL, NULL, 10063, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1497412185', 'admin', '2017-06-14 11:49:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33800, '2017-06-14 11:49:40', NULL, NULL, 10063, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 11:49:40', 'admin-1497401099-14974121800707980', 1, 1, 'SR', NULL, NULL, NULL),
(33801, '2017-06-14 11:49:40', NULL, NULL, 10063, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 11:49:40', 'admin-1497401099-14974121800707980', 1, 1, 'SR', NULL, NULL, NULL),
(33802, '2017-06-14 12:16:39', NULL, NULL, 10064, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1497412185', 'admin', '2017-06-14 12:16:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33803, '2017-06-14 12:16:44', NULL, NULL, 10064, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 12:16:44', 'admin-1497412185-1497413803912780', 1, 1, 'SR', NULL, NULL, NULL),
(33804, '2017-06-14 12:16:44', NULL, NULL, 10064, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 12:16:44', 'admin-1497412185-1497413803912780', 1, 1, 'SR', NULL, NULL, NULL),
(33805, '2017-06-14 12:21:12', NULL, NULL, 10065, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1497412185', 'admin', '2017-06-14 12:21:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33806, '2017-06-14 12:21:15', NULL, NULL, 10065, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 12:21:15', 'admin-1497412185-14974140749178015', 1, 1, 'SR', NULL, NULL, NULL),
(33807, '2017-06-14 12:35:44', NULL, NULL, 10063, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 12:35:44', 'admin-1497412185-14974149438448676', 1, 1, 'SR', NULL, NULL, NULL),
(33808, '2017-06-14 12:41:35', NULL, NULL, 10066, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1497412185', 'admin', '2017-06-14 12:41:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33809, '2017-06-14 14:11:45', NULL, NULL, 10075, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1497412185', 'admin', '2017-06-14 14:11:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33810, '2017-06-14 13:28:30', NULL, NULL, 10074, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 13:28:30', 'admin-1497412185-14974181103279232', 1, 0, '', 1, NULL, NULL),
(33811, '2017-06-14 11:43:11', NULL, NULL, 10059, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 11:43:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33812, '2017-06-14 11:43:16', NULL, NULL, 10059, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 11:43:16', 'admin-1497401099-1497411796794827', 1, 1, 'SR', NULL, NULL, NULL),
(33813, '2017-06-14 11:43:42', NULL, NULL, 10060, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1497412185', 'admin', '2017-06-14 11:43:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33814, '2017-06-14 11:43:46', NULL, NULL, 10060, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 11:43:46', 'admin-1497401099-14974118259158149', 1, 1, 'SR', NULL, NULL, NULL),
(33815, '2017-06-14 11:45:56', NULL, NULL, 10060, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 11:45:56', 'admin-1497401099-14974119561463979', 1, 1, 'SR', NULL, NULL, NULL),
(33816, '2017-06-14 11:46:44', NULL, NULL, 10061, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1497412185', 'admin', '2017-06-14 11:46:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33817, '2017-06-14 09:05:21', NULL, NULL, 10048, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.70, 0.0000, 0.0000, 11.70, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:05:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33818, '2017-06-14 09:05:31', NULL, NULL, 10048, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:05:31', 'admin-1497401099-1497402331377301', 1, 0, '', NULL, NULL, NULL),
(33819, '2017-06-14 13:19:15', NULL, NULL, 10073, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1497412185', 'admin', '2017-06-14 13:19:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33820, '2017-06-14 13:19:19', NULL, NULL, 10073, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 13:19:19', 'admin-1497412185-14974175596298021', 1, 1, 'SR', NULL, NULL, NULL),
(33821, '2017-06-14 13:18:23', NULL, NULL, 10072, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 13:18:23', 'admin-1497412185-14974175033886810', 1, 1, 'SR', NULL, NULL, NULL),
(33822, '2017-06-14 13:18:13', NULL, NULL, 10072, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 13:18:13', 'admin-1497412185-14974174936546249', 1, 0, '', NULL, NULL, NULL),
(33823, '2017-06-14 13:18:09', NULL, NULL, 10072, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1497412185', 'admin', '2017-06-14 13:18:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33824, '2017-06-14 13:17:56', NULL, NULL, 10071, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 13:17:56', 'admin-1497412185-14974174761991211', 1, 1, 'SR', NULL, NULL, NULL),
(33825, '2017-06-14 13:17:56', NULL, NULL, 10071, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 13:17:56', 'admin-1497412185-14974174761991211', 1, 1, 'SR', NULL, NULL, NULL),
(33826, '2017-06-14 13:17:56', NULL, NULL, 10071, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 13:17:56', 'admin-1497412185-14974174761991211', 1, 0, '', NULL, NULL, NULL),
(33827, '2017-06-14 16:25:10', NULL, NULL, 10078, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 16:25:10', 'admin-1497412185-1497428710617450', 1, 0, '', NULL, NULL, NULL),
(33828, '2017-06-14 11:39:25', NULL, NULL, 10058, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 11:39:25', 'admin-1497401099-14974115656099920', 1, 1, 'SR', NULL, NULL, NULL),
(33829, '2017-06-14 10:26:41', NULL, NULL, 10054, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 10:26:41', 'admin-1497401099-14974072015335375', 1, 0, '', NULL, NULL, NULL),
(33830, '2017-06-14 10:27:10', NULL, NULL, 10055, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1497412185', 'admin', '2017-06-14 10:27:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33831, '2017-06-14 10:27:26', NULL, NULL, 10055, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 10:27:26', 'admin-1497401099-14974072459979798', 1, 0, '', NULL, NULL, NULL),
(33832, '2017-06-14 10:27:26', NULL, NULL, 10055, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 10:27:26', 'admin-1497401099-14974072459979798', 1, 0, '', NULL, NULL, NULL),
(33833, '2017-06-14 10:27:31', NULL, NULL, 10055, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 10:27:31', 'admin-1497401099-14974072510373524', 1, 1, 'SR', NULL, NULL, NULL),
(33834, '2017-06-14 10:27:31', NULL, NULL, 10055, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 10:27:31', 'admin-1497401099-14974072510373524', 1, 1, 'SR', NULL, NULL, NULL),
(33835, '2017-06-14 09:06:34', NULL, NULL, 10048, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:06:34', 'admin-1497401099-14974023944965141', 1, 0, '', NULL, NULL, NULL),
(33836, '2017-06-14 13:05:37', NULL, NULL, 10070, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 13:05:37', 'admin-1497412185-14974167377006872', 1, 1, 'SR', NULL, NULL, NULL),
(33837, '2017-06-14 13:17:47', NULL, NULL, 10071, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1497412185', 'admin', '2017-06-14 13:17:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33838, '2017-06-14 13:05:21', NULL, NULL, 10070, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1497412185', 'admin', '2017-06-14 13:05:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33839, '2017-06-14 13:05:27', NULL, NULL, 10070, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 13:05:27', 'admin-1497412185-1497416727527327', 1, 0, '', NULL, NULL, NULL),
(33840, '2017-06-14 13:05:27', NULL, NULL, 10070, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 13:05:27', 'admin-1497412185-1497416727527327', 1, 0, '', NULL, NULL, NULL),
(33841, '2017-06-14 13:05:37', NULL, NULL, 10070, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 13:05:37', 'admin-1497412185-14974167377006872', 1, 0, '', NULL, NULL, NULL),
(33842, '2017-06-14 12:49:14', NULL, NULL, 10067, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 12:49:14', 'admin-1497412185-14974157539235084', 1, 1, 'SR', NULL, NULL, NULL),
(33843, '2017-06-14 12:49:08', NULL, NULL, 10067, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1497412185', 'admin', '2017-06-14 12:49:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33844, '2017-06-14 12:49:14', NULL, NULL, 10067, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 12:49:14', 'admin-1497412185-14974157539235084', 1, 1, 'SR', NULL, NULL, NULL),
(33845, '2017-06-14 12:42:25', NULL, NULL, 10066, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 12:42:25', 'admin-1497412185-14974153453283839', 1, 1, 'SR', NULL, NULL, NULL),
(33846, '2017-06-14 12:42:25', NULL, NULL, 10066, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 12:42:25', 'admin-1497412185-14974153453283839', 1, 0, '', NULL, NULL, NULL),
(33847, '2017-06-14 12:42:16', NULL, NULL, 10066, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 12:42:16', 'admin-1497412185-14974153359207160', 1, 0, '', NULL, NULL, NULL),
(33848, '2017-06-14 12:42:16', NULL, NULL, 10066, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 12:42:16', 'admin-1497412185-14974153359207160', 1, 0, '', NULL, NULL, NULL),
(33849, '2017-06-14 10:28:17', NULL, NULL, 10054, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 10:28:17', 'admin-1497401099-14974072968434215', 1, 0, '', NULL, NULL, NULL),
(33850, '2017-06-14 10:28:17', NULL, NULL, 10054, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 10:28:17', 'admin-1497401099-14974072968434215', 1, 0, '', NULL, NULL, NULL),
(33851, '2017-06-14 10:28:17', NULL, NULL, 10054, 0, 181, '116', 'Open Food ', ' add egg,x yogurt', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 10:28:17', 'admin-1497401099-14974072968434215', 1, 0, '', NULL, NULL, NULL),
(33852, '2017-06-14 10:36:02', NULL, NULL, 10056, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1497412185', 'admin', '2017-06-14 10:36:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33853, '2017-06-14 10:36:12', NULL, NULL, 10056, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 10:36:12', 'admin-1497401099-1497407772688580', 1, 0, '', NULL, NULL, NULL),
(33854, '2017-06-14 11:39:22', NULL, NULL, 10058, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1497412185', 'admin', '2017-06-14 11:39:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33855, '2017-06-14 11:26:47', NULL, NULL, 10057, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 11:26:47', 'admin-1497401099-14974108076525010', 1, 0, '', NULL, NULL, NULL),
(33856, '2017-06-14 10:26:33', NULL, NULL, 10054, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 10:26:33', 'admin-1497401099-14974071934728357', 1, 1, 'SR', NULL, NULL, NULL),
(33857, '2017-06-14 10:26:41', NULL, NULL, 10054, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 10:26:41', 'admin-1497401099-14974072015335375', 1, 0, '', NULL, NULL, NULL),
(33858, '2017-06-14 09:06:34', NULL, NULL, 10048, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:06:34', 'admin-1497401099-14974023944965141', 1, 1, 'SR', NULL, NULL, NULL),
(33859, '2017-06-14 09:06:34', NULL, NULL, 10048, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:06:34', 'admin-1497401099-14974023944965141', 1, 1, 'SR', NULL, NULL, NULL),
(33860, '2017-06-14 09:14:17', NULL, NULL, 10049, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:14:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33861, '2017-06-14 09:14:20', NULL, NULL, 10049, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:14:20', 'admin-1497401099-14974028606155148', 1, 1, 'SR', NULL, NULL, NULL),
(33862, '2017-06-14 09:41:13', NULL, NULL, 10050, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:41:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33863, '2017-06-14 09:41:18', NULL, NULL, 10050, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:41:18', 'admin-1497401099-14974044781125622', 1, 0, '', NULL, NULL, NULL),
(33864, '2017-06-14 09:41:18', NULL, NULL, 10050, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:41:18', 'admin-1497401099-14974044781125622', 1, 0, '', NULL, NULL, NULL),
(33865, '2017-06-14 09:41:27', NULL, NULL, 10050, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:41:27', 'admin-1497401099-14974044876553932', 1, 0, '', NULL, NULL, NULL),
(33866, '2017-06-14 09:41:27', NULL, NULL, 10050, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:41:27', 'admin-1497401099-14974044876553932', 1, 1, 'SR', NULL, NULL, NULL),
(33867, '2017-06-14 09:52:01', NULL, NULL, 10051, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:52:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33868, '2017-06-14 09:52:03', NULL, NULL, 10051, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:52:03', 'admin-1497401099-1497405123480601', 1, 1, 'SR', NULL, NULL, NULL),
(33869, '2017-06-14 09:56:34', NULL, NULL, 10052, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:56:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33870, '2017-06-14 09:56:45', NULL, NULL, 10052, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:56:45', 'admin-1497401099-14974054056773840', 1, 0, '', NULL, NULL, NULL),
(33871, '2017-06-14 09:56:45', NULL, NULL, 10052, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:56:45', 'admin-1497401099-14974054056773840', 1, 0, '', NULL, NULL, NULL),
(33872, '2017-06-14 09:56:45', NULL, NULL, 10052, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:56:45', 'admin-1497401099-14974054056773840', 1, 1, 'SR', NULL, NULL, NULL),
(33873, '2017-06-14 09:56:45', NULL, NULL, 10052, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:56:45', 'admin-1497401099-14974054056773840', 1, 1, 'SR', NULL, NULL, NULL),
(33874, '2017-06-14 10:10:26', NULL, NULL, 10053, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1497412185', 'admin', '2017-06-14 10:10:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33875, '2017-06-14 10:10:30', NULL, NULL, 10053, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 10:10:30', 'admin-1497401099-14974062306939965', 1, 1, 'SR', NULL, NULL, NULL),
(33876, '2017-06-14 10:26:29', NULL, NULL, 10054, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1497412185', 'admin', '2017-06-14 10:26:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33877, '2017-06-14 10:26:33', NULL, NULL, 10054, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 10:26:33', 'admin-1497401099-14974071934728357', 1, 1, 'SR', NULL, NULL, NULL),
(33878, '2017-06-14 09:06:01', NULL, NULL, 10048, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:06:01', 'admin-1497401099-14974023608112025', 1, 0, '', NULL, NULL, NULL),
(33879, '2017-06-14 09:05:44', NULL, NULL, 10048, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:05:44', 'admin-1497401099-1497402344415758', 1, 0, '', NULL, NULL, NULL),
(33880, '2017-06-14 09:06:01', NULL, NULL, 10048, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:06:01', 'admin-1497401099-14974023608112025', 1, 0, '', NULL, NULL, NULL),
(33881, '2017-06-14 09:05:31', NULL, NULL, 10048, 0, 153, '87', 'Wake Me Up!', 'sunny side up', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497412185', 'admin', '2017-06-14 09:05:31', 'admin-1497401099-1497402331377301', 1, 0, '', NULL, NULL, NULL),
(33882, '2017-06-15 14:56:53', NULL, NULL, 10100, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:56:53', 'admin-1497508226-14975098137499315', 1, 1, 'SR', NULL, NULL, NULL),
(33883, '2017-06-15 14:56:53', NULL, NULL, 10100, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:56:53', 'admin-1497508226-14975098137499315', 1, 1, 'SR', NULL, NULL, NULL),
(33884, '2017-06-15 14:29:52', NULL, NULL, 10096, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:29:52', 'admin-1497497140-14975081920332487', 1, 0, '', NULL, NULL, NULL),
(33885, '2017-06-15 14:32:16', NULL, NULL, 10098, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:32:16', 'admin-1497508226-1497508336317954', 1, 1, 'SR', NULL, NULL, NULL),
(33886, '2017-06-15 14:32:16', NULL, NULL, 10098, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:32:16', 'admin-1497508226-1497508336317954', 1, 1, 'SR', NULL, NULL, NULL),
(33887, '2017-06-15 13:24:46', NULL, NULL, 10093, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 13:24:46', 'admin-1497497140-14975042863656126', 1, 1, 'SR', NULL, NULL, NULL),
(33888, '2017-06-15 13:42:43', NULL, NULL, 10094, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1497508226', 'admin', '2017-06-15 13:42:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33889, '2017-06-15 13:42:46', NULL, NULL, 10094, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 13:42:46', 'admin-1497497140-14975053664614817', 1, 1, 'SR', NULL, NULL, NULL),
(33890, '2017-06-15 14:32:16', NULL, NULL, 10098, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:32:16', 'admin-1497508226-1497508336317954', 1, 0, '', NULL, NULL, NULL),
(33891, '2017-06-15 14:32:16', NULL, NULL, 10098, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:32:16', 'admin-1497508226-1497508336317954', 1, 0, '', NULL, NULL, NULL),
(33892, '2017-06-15 14:32:01', NULL, NULL, 10098, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:32:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33893, '2017-06-15 11:25:35', NULL, NULL, 10088, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:25:35', 'admin-1497488415-14974971348564016', 1, 0, '', NULL, NULL, NULL),
(33894, '2017-06-15 11:25:35', NULL, NULL, 10088, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:25:35', 'admin-1497488415-14974971348564016', 1, 0, '', NULL, NULL, NULL),
(33895, '2017-06-15 11:25:35', NULL, NULL, 10088, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:25:35', 'admin-1497488415-14974971348564016', 1, 1, 'SR', NULL, NULL, NULL),
(33896, '2017-06-15 11:25:35', NULL, NULL, 10088, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:25:35', 'admin-1497488415-14974971348564016', 1, 1, 'SR', NULL, NULL, NULL),
(33897, '2017-06-15 13:05:46', NULL, NULL, 10092, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 13:05:46', 'admin-1497497140-149750314663955', 1, 1, 'SR', NULL, NULL, NULL),
(33898, '2017-06-15 13:24:21', NULL, NULL, 10093, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1497508226', 'admin', '2017-06-15 13:24:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33899, '2017-06-15 13:24:36', NULL, NULL, 10093, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 13:24:36', 'admin-1497497140-14975042766787934', 1, 0, '', NULL, NULL, NULL),
(33900, '2017-06-15 13:24:36', NULL, NULL, 10093, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 13:24:36', 'admin-1497497140-14975042766787934', 1, 0, '', NULL, NULL, NULL),
(33901, '2017-06-15 13:24:36', NULL, NULL, 10093, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 13:24:36', 'admin-1497497140-14975042766787934', 1, 1, 'SR', NULL, NULL, NULL),
(33902, '2017-06-15 15:37:44', NULL, NULL, 10102, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 15:37:44', 'admin-1497508226-1497512264239996', 1, 0, '', NULL, NULL, NULL),
(33903, '2017-06-15 00:00:00', NULL, NULL, 10103, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:31:47', 'admin-1497508226-1497508306948222', 1, 0, '', NULL, NULL, NULL),
(33904, '2017-06-15 14:31:47', NULL, NULL, 10097, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:31:47', 'admin-1497508226-1497508306948222', 1, 0, '', NULL, NULL, NULL),
(33905, '2017-06-15 13:03:37', NULL, NULL, 10091, 0, 181, '116', 'Open Food ', 'Cancel french toast', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 13:03:37', 'admin-1497497140-14975030170615376', 1, 0, '', NULL, NULL, NULL),
(33906, '2017-06-15 15:36:28', NULL, NULL, 10102, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 15:36:28', 'admin-1497508226-14975121880497397', 1, 1, 'SR', NULL, NULL, NULL),
(33907, '2017-06-15 15:36:22', NULL, NULL, 10102, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1497508226', 'admin', '2017-06-15 15:36:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33908, '2017-06-15 15:36:28', NULL, NULL, 10102, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 15:36:28', 'admin-1497508226-14975121880497397', 1, 1, 'SR', NULL, NULL, NULL),
(33909, '2017-06-15 14:30:57', NULL, NULL, 10096, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:30:57', 'admin-1497508226-14975082571431323', 1, 0, '', NULL, NULL, NULL),
(33910, '2017-06-15 15:10:30', NULL, NULL, 10100, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 15:10:30', 'admin-1497508226-14975106307272151', 1, 1, 'SR', NULL, NULL, NULL),
(33911, '2017-06-15 15:00:05', NULL, NULL, 10101, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 15:00:05', 'admin-1497508226-14975100051288093', 1, 1, 'SR', NULL, NULL, NULL),
(33912, '2017-06-15 15:00:00', NULL, NULL, 10101, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1497508226', 'admin', '2017-06-15 15:00:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33913, '2017-06-15 14:58:42', NULL, NULL, 10098, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:58:42', 'admin-1497508226-14975099221714627', 1, 0, '', NULL, NULL, NULL),
(33914, '2017-06-15 14:56:53', NULL, NULL, 10100, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:56:53', 'admin-1497508226-14975098137499315', 1, 1, 'SR', NULL, NULL, NULL),
(33915, '2017-06-15 14:56:53', NULL, NULL, 10100, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:56:53', 'admin-1497508226-14975098137499315', 1, 0, '', NULL, NULL, NULL),
(33916, '2017-06-15 14:56:53', NULL, NULL, 10100, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:56:53', 'admin-1497508226-14975098137499315', 1, 0, '', NULL, NULL, NULL),
(33917, '2017-06-15 14:56:28', NULL, NULL, 10100, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:56:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33918, '2017-06-15 14:33:52', NULL, NULL, 10099, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:33:52', 'admin-1497508226-14975084328095353', 1, 1, 'SR', NULL, NULL, NULL),
(33919, '2017-06-15 14:33:47', NULL, NULL, 10099, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:33:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33920, '2017-06-15 15:51:32', NULL, NULL, 10103, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1497508226', 'admin', '2017-06-15 15:51:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33921, '2017-06-15 14:31:47', NULL, NULL, 10097, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:31:47', 'admin-1497508226-1497508306948222', 1, 0, '', NULL, NULL, NULL),
(33922, '2017-06-15 14:29:52', NULL, NULL, 10096, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:29:52', 'admin-1497497140-14975081920332487', 1, 0, '', NULL, NULL, NULL),
(33923, '2017-06-15 14:31:47', NULL, NULL, 10097, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:31:47', 'admin-1497508226-1497508306948222', 1, 0, '', NULL, NULL, NULL),
(33924, '2017-06-15 14:31:47', NULL, NULL, 10097, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:31:47', 'admin-1497508226-1497508306948222', 1, 1, 'SR', NULL, NULL, NULL),
(33925, '2017-06-15 14:31:09', NULL, NULL, 10097, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:31:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33926, '2017-06-15 14:30:57', NULL, NULL, 10096, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:30:57', 'admin-1497508226-14975082571431323', 1, 1, 'SR', NULL, NULL, NULL),
(33927, '2017-06-15 11:26:39', NULL, NULL, 10089, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.70, 0.0000, 0.0000, 16.70, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:26:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33928, '2017-06-15 11:27:33', NULL, NULL, 10089, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:27:33', 'admin-1497497140-14974972536538653', 1, 0, '', NULL, NULL, NULL),
(33929, '2017-06-15 11:27:33', NULL, NULL, 10089, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:27:33', 'admin-1497497140-14974972536538653', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(33930, '2017-06-15 11:27:33', NULL, NULL, 10089, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:27:33', 'admin-1497497140-14974972536538653', 1, 0, '', NULL, NULL, NULL),
(33931, '2017-06-15 14:30:57', NULL, NULL, 10096, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:30:57', 'admin-1497508226-14975082571431323', 1, 1, 'SR', NULL, NULL, NULL),
(33932, '2017-06-15 14:30:57', NULL, NULL, 10096, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:30:57', 'admin-1497508226-14975082571431323', 1, 1, 'SR', NULL, NULL, NULL),
(33933, '2017-06-15 14:30:57', NULL, NULL, 10096, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:30:57', 'admin-1497508226-14975082571431323', 1, 1, 'SR', NULL, NULL, NULL),
(33934, '2017-06-15 13:03:37', NULL, NULL, 10091, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 13:03:37', 'admin-1497497140-14975030170615376', 1, 0, '', NULL, NULL, NULL),
(33935, '2017-06-15 12:26:41', NULL, NULL, 10090, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1497508226', 'admin', '2017-06-15 12:26:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33936, '2017-06-15 13:48:18', NULL, NULL, 10094, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 13:48:18', 'admin-1497497140-14975056978899617', 1, 0, '', NULL, NULL, NULL),
(33937, '2017-06-15 11:25:35', NULL, NULL, 10088, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:25:35', 'admin-1497488415-14974971348564016', 1, 0, '', NULL, NULL, NULL),
(33938, '2017-06-15 14:29:46', NULL, NULL, 10096, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:29:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33939, '2017-06-15 14:19:38', NULL, NULL, 10090, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:19:38', 'admin-1497497140-14975075782581023', 1, 0, '', NULL, NULL, NULL),
(33940, '2017-06-15 14:02:24', NULL, NULL, 10095, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:02:24', 'admin-1497497140-14975065439575186', 1, 1, 'SR', NULL, NULL, NULL),
(33941, '2017-06-15 14:19:38', NULL, NULL, 10090, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:19:38', 'admin-1497497140-14975075782581023', 1, 0, '', NULL, NULL, NULL),
(33942, '2017-06-15 14:02:24', NULL, NULL, 10095, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:02:24', 'admin-1497497140-14975065439575186', 1, 1, 'SR', NULL, NULL, NULL),
(33943, '2017-06-15 13:48:25', NULL, NULL, 10094, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 13:48:25', 'admin-1497497140-14975057052623082', 1, 1, 'SR', NULL, NULL, NULL),
(33944, '2017-06-15 14:02:20', NULL, NULL, 10095, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1497508226', 'admin', '2017-06-15 14:02:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33945, '2017-06-15 13:48:18', NULL, NULL, 10094, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 13:48:18', 'admin-1497497140-14975056978899617', 1, 1, 'SR', NULL, NULL, NULL),
(33946, '2017-06-15 11:26:27', NULL, NULL, 10087, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:26:27', 'admin-1497497140-14974971874629926', 1, 0, '', NULL, NULL, NULL),
(33947, '2017-06-15 11:25:13', NULL, NULL, 10087, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:25:13', 'admin-1497488415-14974971132246293', 1, 1, 'SR', NULL, NULL, NULL),
(33948, '2017-06-15 11:25:13', NULL, NULL, 10087, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:25:13', 'admin-1497488415-14974971132246293', 1, 0, '', NULL, NULL, NULL),
(33949, '2017-06-15 11:25:13', NULL, NULL, 10087, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:25:13', 'admin-1497488415-14974971132246293', 1, 1, 'SR', NULL, NULL, NULL),
(33950, '2017-06-15 11:25:18', NULL, NULL, 10088, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.50, 0.0000, 0.0000, 10.50, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:25:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33951, '2017-06-15 11:25:35', NULL, NULL, 10088, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:25:35', 'admin-1497488415-14974971348564016', 1, 0, '', NULL, NULL, NULL),
(33952, '2017-06-15 11:25:35', NULL, NULL, 10088, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:25:35', 'admin-1497488415-14974971348564016', 1, 0, '', NULL, NULL, NULL),
(33953, '2017-06-15 13:24:46', NULL, NULL, 10093, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 13:24:46', 'admin-1497497140-14975042863656126', 1, 1, 'SR', NULL, NULL, NULL),
(33954, '2017-06-15 13:05:46', NULL, NULL, 10092, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 13:05:46', 'admin-1497497140-149750314663955', 1, 1, 'SR', NULL, NULL, NULL),
(33955, '2017-06-15 11:17:32', NULL, NULL, 10086, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:17:32', 'admin-1497488415-14974966525611939', 1, 0, '', NULL, NULL, NULL),
(33956, '2017-06-15 11:17:36', NULL, NULL, 10086, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:17:36', 'admin-1497488415-14974966567212043', 1, 1, 'SR', NULL, NULL, NULL),
(33957, '2017-06-15 11:17:36', NULL, NULL, 10086, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:17:36', 'admin-1497488415-14974966567212043', 1, 1, 'SR', NULL, NULL, NULL),
(33958, '2017-06-15 11:24:49', NULL, NULL, 10087, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:24:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33959, '2017-06-15 11:25:13', NULL, NULL, 10087, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:25:13', 'admin-1497488415-14974971132246293', 1, 0, '', NULL, NULL, NULL),
(33960, '2017-06-15 11:25:13', NULL, NULL, 10087, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:25:13', 'admin-1497488415-14974971132246293', 1, 0, '', NULL, NULL, NULL),
(33961, '2017-06-15 11:25:13', NULL, NULL, 10087, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:25:13', 'admin-1497488415-14974971132246293', 1, 0, '', NULL, NULL, NULL),
(33962, '2017-06-15 12:26:59', NULL, NULL, 10090, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 12:26:59', 'admin-1497497140-14975008192003680', 1, 1, 'SR', NULL, NULL, NULL),
(33963, '2017-06-15 12:27:09', NULL, NULL, 10090, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 12:27:09', 'admin-1497497140-14975008292452168', 1, 1, 'SR', NULL, NULL, NULL),
(33964, '2017-06-15 13:02:45', NULL, NULL, 10091, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1497508226', 'admin', '2017-06-15 13:02:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33965, '2017-06-15 13:02:55', NULL, NULL, 10091, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 13:02:55', 'admin-1497497140-14975029749596025', 1, 1, 'SR', NULL, NULL, NULL),
(33966, '2017-06-15 13:05:37', NULL, NULL, 10092, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1497508226', 'admin', '2017-06-15 13:05:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33967, '2017-06-15 12:26:59', NULL, NULL, 10090, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 12:26:59', 'admin-1497497140-14975008192003680', 1, 1, 'SR', NULL, NULL, NULL),
(33968, '2017-06-15 12:26:48', NULL, NULL, 10090, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 12:26:48', 'admin-1497497140-14975008086181019', 1, 1, 'SR', NULL, NULL, NULL),
(33969, '2017-06-15 11:27:33', NULL, NULL, 10089, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:27:33', 'admin-1497497140-14974972536538653', 1, 0, '', NULL, NULL, NULL),
(33970, '2017-06-15 11:27:33', NULL, NULL, 10089, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:27:33', 'admin-1497497140-14974972536538653', 1, 1, 'SR', NULL, NULL, NULL),
(33971, '2017-06-15 11:27:33', NULL, NULL, 10089, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:27:33', 'admin-1497497140-14974972536538653', 1, 1, 'SR', NULL, NULL, NULL),
(33972, '2017-06-15 11:27:33', NULL, NULL, 10089, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:27:33', 'admin-1497497140-14974972536538653', 1, 1, 'SR', NULL, NULL, NULL),
(33973, '2017-06-15 11:27:33', NULL, NULL, 10089, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:27:33', 'admin-1497497140-14974972536538653', 1, 0, '', NULL, NULL, NULL),
(33974, '2017-06-15 11:27:33', NULL, NULL, 10089, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:27:33', 'admin-1497497140-14974972536538653', 1, 1, 'SR', NULL, NULL, NULL),
(33975, '2017-06-15 11:27:33', NULL, NULL, 10089, 0, 181, '116', 'Open Food ', 'pancake add on scrambled egg', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:27:33', 'admin-1497497140-14974972536538653', 1, 0, '', NULL, NULL, NULL),
(33976, '2017-06-15 11:27:33', NULL, NULL, 10089, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:27:33', 'admin-1497497140-14974972536538653', 1, 0, '', NULL, NULL, NULL),
(33977, '2017-06-15 11:27:33', NULL, NULL, 10089, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:27:33', 'admin-1497497140-14974972536538653', 1, 0, '', NULL, NULL, NULL),
(33978, '2017-06-15 11:17:28', NULL, NULL, 10086, 0, 181, '116', 'Open Food ', 'Take it easy add grilled potato', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:17:28', 'admin-1497488415-14974966485869413', 1, 0, '', NULL, NULL, NULL),
(33979, '2017-06-15 10:40:16', NULL, NULL, 10084, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 10:40:16', 'admin-1497488415-14974944167412517', 1, 1, 'SR', NULL, NULL, NULL),
(33980, '2017-06-15 10:40:16', NULL, NULL, 10084, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 10:40:16', 'admin-1497488415-14974944167412517', 1, 1, 'SR', NULL, NULL, NULL),
(33981, '2017-06-15 10:40:16', NULL, NULL, 10084, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 10:40:16', 'admin-1497488415-14974944167412517', 1, 0, '', NULL, NULL, NULL),
(33982, '2017-06-15 09:18:53', NULL, NULL, 10082, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 09:18:53', 'admin-1497488415-1497489533687814', 1, 0, '', NULL, NULL, NULL),
(33983, '2017-06-15 09:09:43', NULL, NULL, 10082, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 09:09:43', 'admin-1497488415-14974889837051482', 1, 0, '', NULL, NULL, NULL),
(33984, '2017-06-15 09:09:43', NULL, NULL, 10082, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 09:09:43', 'admin-1497488415-14974889837051482', 1, 0, '', NULL, NULL, NULL),
(33985, '2017-06-15 09:09:43', NULL, NULL, 10082, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 09:09:43', 'admin-1497488415-14974889837051482', 1, 1, 'SR', NULL, NULL, NULL),
(33986, '2017-06-15 09:09:43', NULL, NULL, 10082, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 09:09:43', 'admin-1497488415-14974889837051482', 1, 0, '', NULL, NULL, NULL),
(33987, '2017-06-15 09:09:43', NULL, NULL, 10082, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 09:09:43', 'admin-1497488415-14974889837051482', 1, 1, 'SR', NULL, NULL, NULL),
(33988, '2017-06-15 09:09:55', NULL, NULL, 10081, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 09:09:55', 'admin-1497488415-1497488995347661', 1, 1, 'SR', NULL, NULL, NULL),
(33989, '2017-06-15 09:09:55', NULL, NULL, 10081, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 09:09:55', 'admin-1497488415-1497488995347661', 1, 1, 'SR', NULL, NULL, NULL),
(33990, '2017-06-15 09:12:04', NULL, NULL, 10083, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1497508226', 'admin', '2017-06-15 09:12:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33991, '2017-06-15 09:12:24', NULL, NULL, 10083, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 09:12:24', 'admin-1497488415-14974891443496282', 1, 1, 'SR', NULL, NULL, NULL),
(33992, '2017-06-15 09:12:24', NULL, NULL, 10083, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 09:12:24', 'admin-1497488415-14974891443496282', 1, 0, '', NULL, NULL, NULL),
(33993, '2017-06-15 09:12:24', NULL, NULL, 10083, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 09:12:24', 'admin-1497488415-14974891443496282', 1, 0, '', NULL, NULL, NULL),
(33994, '2017-06-15 09:12:24', NULL, NULL, 10083, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 09:12:24', 'admin-1497488415-14974891443496282', 1, 0, '', NULL, NULL, NULL),
(33995, '2017-06-15 09:12:24', NULL, NULL, 10083, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 09:12:24', 'admin-1497488415-14974891443496282', 1, 1, 'SR', NULL, NULL, NULL),
(33996, '2017-06-15 09:12:24', NULL, NULL, 10083, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 09:12:24', 'admin-1497488415-14974891443496282', 1, 0, '', NULL, NULL, NULL),
(33997, '2017-06-15 11:17:02', NULL, NULL, 10086, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:17:02', 'admin-1497488415-1497496622544153', 1, 0, '', NULL, NULL, NULL),
(33998, '2017-06-15 11:16:53', NULL, NULL, 10086, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:16:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(33999, '2017-06-15 11:09:34', NULL, NULL, 10085, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:09:34', 'admin-1497488415-14974961740971695', 1, 0, '', NULL, NULL, NULL),
(34000, '2017-06-15 11:09:34', NULL, NULL, 10085, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:09:34', 'admin-1497488415-14974961740971695', 1, 0, '', NULL, NULL, NULL),
(34001, '2017-06-15 11:05:42', NULL, NULL, 10082, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:05:42', 'admin-1497488415-14974959425242699', 1, 0, '', NULL, NULL, NULL),
(34002, '2017-06-15 11:09:28', NULL, NULL, 10085, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1497508226', 'admin', '2017-06-15 11:09:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34003, '2017-06-15 10:40:11', NULL, NULL, 10084, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1497508226', 'admin', '2017-06-15 10:40:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34004, '2017-06-15 09:07:26', NULL, NULL, 10081, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 09:07:26', 'admin-1497488415-1497488845811727', 1, 0, '', NULL, NULL, NULL),
(34005, '2017-06-15 09:09:24', NULL, NULL, 10082, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 09:09:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34006, '2017-06-15 09:07:17', NULL, NULL, 10081, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1497508226', 'admin', '2017-06-15 09:07:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34007, '2017-06-15 09:07:26', NULL, NULL, 10081, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497508226', 'admin', '2017-06-15 09:07:26', 'admin-1497488415-1497488845811727', 1, 0, '', NULL, NULL, NULL),
(34008, '2017-06-16 14:06:09', NULL, NULL, 10122, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 14:06:09', 'admin-1497591193-14975931690959039', 1, 0, '', NULL, NULL, NULL),
(34009, '2017-06-16 13:33:29', NULL, NULL, 10122, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 13:33:29', 'admin-1497591193-14975912093275560', 1, 0, '', NULL, NULL, NULL),
(34010, '2017-06-16 13:36:15', NULL, NULL, 10123, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1497594779', 'admin', '2017-06-16 13:36:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34011, '2017-06-16 13:36:23', NULL, NULL, 10123, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 13:36:23', 'admin-1497591193-14975913837142081', 1, 0, '', NULL, NULL, NULL),
(34012, '2017-06-16 13:36:23', NULL, NULL, 10123, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 13:36:23', 'admin-1497591193-14975913837142081', 1, 1, 'SR', NULL, NULL, NULL),
(34013, '2017-06-16 13:36:30', NULL, NULL, 10123, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 13:36:30', 'admin-1497591193-14975913899598250', 1, 1, 'SR', NULL, NULL, NULL),
(34014, '2017-06-16 13:29:09', NULL, NULL, 10121, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1497594779', 'admin', '2017-06-16 13:29:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34015, '2017-06-16 13:29:19', NULL, NULL, 10121, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 13:29:19', 'admin-1497585921-14975909590516084', 1, 0, '', NULL, NULL, NULL),
(34016, '2017-06-16 13:29:19', NULL, NULL, 10121, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 13:29:19', 'admin-1497585921-14975909590516084', 1, 1, 'SR', NULL, NULL, NULL),
(34017, '2017-06-16 13:29:27', NULL, NULL, 10121, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 13:29:27', 'admin-1497585921-14975909672245173', 1, 1, 'SR', NULL, NULL, NULL),
(34018, '2017-06-16 13:29:27', NULL, NULL, 10121, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 13:29:27', 'admin-1497585921-14975909672245173', 1, 1, 'SR', NULL, NULL, NULL),
(34019, '2017-06-16 15:29:56', NULL, NULL, 10125, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 15:29:56', 'admin-1497594779-1497598196545780', 1, 1, 'SR', NULL, NULL, NULL),
(34020, '2017-06-16 15:12:39', NULL, NULL, 10124, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1497594779', 'admin', '2017-06-16 15:12:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34021, '2017-06-16 15:30:01', NULL, NULL, 10126, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1497594779', 'admin', '2017-06-16 15:30:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34022, '2017-06-16 15:32:24', NULL, NULL, 10127, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 15:32:24', 'admin-1497594779-14975983444546493', 1, 0, '', NULL, NULL, NULL),
(34023, '2017-06-16 15:30:14', NULL, NULL, 10126, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 15:30:14', 'admin-1497594779-14975982144689542', 1, 0, '', NULL, NULL, NULL),
(34024, '2017-06-16 15:30:14', NULL, NULL, 10126, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 15:30:14', 'admin-1497594779-14975982144689542', 1, 0, '', NULL, NULL, NULL),
(34025, '2017-06-16 15:32:17', NULL, NULL, 10127, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1497594779', 'admin', '2017-06-16 15:32:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34026, '2017-06-16 15:30:14', NULL, NULL, 10126, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 15:30:14', 'admin-1497594779-14975982144689542', 1, 0, '', NULL, NULL, NULL),
(34027, '2017-06-16 09:52:36', NULL, NULL, 10109, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 09:52:36', 'admin-1497572248-1497577956115672', 1, 0, '', NULL, NULL, NULL),
(34028, '2017-06-16 15:12:56', NULL, NULL, 10124, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 15:12:56', 'admin-1497594779-14975971766508837', 1, 0, '', NULL, NULL, NULL),
(34029, '2017-06-16 15:12:56', NULL, NULL, 10124, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 15:12:56', 'admin-1497594779-14975971766508837', 1, 0, '', NULL, NULL, NULL),
(34030, '2017-06-16 15:29:34', NULL, NULL, 10125, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 15:29:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34031, '2017-06-16 15:29:56', NULL, NULL, 10125, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 15:29:56', 'admin-1497594779-1497598196545780', 1, 0, '', NULL, NULL, NULL),
(34032, '2017-06-16 15:29:56', NULL, NULL, 10125, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 15:29:56', 'admin-1497594779-1497598196545780', 1, 0, '', NULL, NULL, NULL),
(34033, '2017-06-16 15:29:56', NULL, NULL, 10125, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 15:29:56', 'admin-1497594779-1497598196545780', 1, 0, '', NULL, NULL, NULL),
(34034, '2017-06-16 15:29:56', NULL, NULL, 10125, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 15:29:56', 'admin-1497594779-1497598196545780', 1, 1, 'SR', NULL, NULL, NULL),
(34035, '2017-06-16 15:12:56', NULL, NULL, 10124, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 15:12:56', 'admin-1497594779-14975971766508837', 1, 0, '', NULL, NULL, NULL),
(34036, '2017-06-16 15:12:56', NULL, NULL, 10124, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 15:12:56', 'admin-1497594779-14975971766508837', 1, 1, 'SR', NULL, NULL, NULL),
(34037, '2017-06-16 15:12:56', NULL, NULL, 10124, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 15:12:56', 'admin-1497594779-14975971766508837', 1, 0, '', NULL, NULL, NULL),
(34038, '2017-06-16 12:33:33', NULL, NULL, 10119, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:33:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34039, '2017-06-16 12:34:31', NULL, NULL, 10119, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:34:31', 'admin-1497585921-1497587670851465', 1, 1, 'SR', NULL, NULL, NULL),
(34040, '2017-06-16 12:34:31', NULL, NULL, 10119, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:34:31', 'admin-1497585921-1497587670851465', 1, 1, 'SR', NULL, NULL, NULL),
(34041, '2017-06-16 12:36:17', NULL, NULL, 10120, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:36:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34042, '2017-06-16 12:36:21', NULL, NULL, 10120, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:36:21', 'admin-1497585921-14975877810487724', 1, 1, 'SR', NULL, NULL, NULL),
(34043, '2017-06-16 12:43:09', NULL, NULL, 10120, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 2, 16.00, 32.0000, 0.0000, 32.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:43:09', 'admin-1497585921-14975881897925557', 1, 0, '', NULL, NULL, NULL),
(34044, '2017-06-16 12:43:09', NULL, NULL, 10120, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:43:09', 'admin-1497585921-14975881897925557', 1, 0, '', NULL, NULL, NULL),
(34045, '2017-06-16 13:32:51', NULL, NULL, 10122, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1497594779', 'admin', '2017-06-16 13:32:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34046, '2017-06-16 12:11:17', NULL, NULL, 10114, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:11:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34047, '2017-06-16 12:11:25', NULL, NULL, 10114, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:11:25', 'admin-1497585921-1497586285254944', 1, 1, 'SR', NULL, NULL, NULL),
(34048, '2017-06-16 12:11:25', NULL, NULL, 10114, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:11:25', 'admin-1497585921-1497586285254944', 1, 1, 'SR', NULL, NULL, NULL),
(34049, '2017-06-16 12:25:51', NULL, NULL, 10116, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:25:51', 'admin-1497585921-14975871510768484', 1, 1, 'SR', 1, NULL, NULL),
(34050, '2017-06-16 12:27:16', NULL, NULL, 10117, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:27:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34051, '2017-06-16 12:48:07', NULL, NULL, 10120, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:48:07', 'admin-1497585921-14975884876495396', 1, 1, 'SR', NULL, NULL, NULL),
(34052, '2017-06-16 12:34:31', NULL, NULL, 10119, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:34:31', 'admin-1497585921-1497587670851465', 1, 0, '', NULL, NULL, NULL),
(34053, '2017-06-16 12:33:37', NULL, NULL, 10119, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:33:37', 'admin-1497585921-14975876177451931', 1, 0, '', NULL, NULL, NULL),
(34054, '2017-06-16 12:29:58', NULL, NULL, 10118, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:29:58', 'admin-1497585921-14975873984582917', 1, 1, 'SR', NULL, NULL, NULL),
(34055, '2017-06-16 12:29:58', NULL, NULL, 10118, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:29:58', 'admin-1497585921-14975873984582917', 1, 0, '', NULL, NULL, NULL),
(34056, '2017-06-16 12:28:21', NULL, NULL, 10117, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:28:21', 'admin-1497585921-1497587300995886', 1, 0, '', NULL, NULL, NULL),
(34057, '2017-06-16 12:29:51', NULL, NULL, 10118, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:29:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34058, '2017-06-16 12:28:21', NULL, NULL, 10117, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:28:21', 'admin-1497585921-1497587300995886', 1, 1, 'SR', NULL, NULL, NULL),
(34059, '2017-06-16 09:20:11', NULL, NULL, 10106, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 09:20:11', 'admin-1497572248-1497576011366776', 1, 0, '', NULL, NULL, NULL),
(34060, '2017-06-16 09:20:23', NULL, NULL, 10106, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 09:20:23', 'admin-1497572248-14975760231605190', 1, 1, 'SR', NULL, NULL, NULL),
(34061, '2017-06-16 09:20:23', NULL, NULL, 10106, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 09:20:23', 'admin-1497572248-14975760231605190', 1, 1, 'SR', NULL, NULL, NULL),
(34062, '2017-06-16 09:34:09', NULL, NULL, 10107, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.95, 0.0000, 0.0000, 3.95, 1, '27', 1, '1497594779', 'admin', '2017-06-16 09:34:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34063, '2017-06-16 09:34:13', NULL, NULL, 10107, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 09:34:13', 'admin-1497572248-14975768530914937', 1, 0, '', NULL, NULL, NULL),
(34064, '2017-06-16 09:34:18', NULL, NULL, 10107, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 09:34:18', 'admin-1497572248-14975768580454136', 1, 1, 'SR', NULL, NULL, NULL),
(34065, '2017-06-16 09:48:24', NULL, NULL, 10108, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1497594779', 'admin', '2017-06-16 09:48:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34066, '2017-06-16 09:48:27', NULL, NULL, 10108, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 09:48:27', 'admin-1497572248-1497577707740597', 1, 1, 'SR', NULL, NULL, NULL),
(34067, '2017-06-16 09:52:27', NULL, NULL, 10109, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1497594779', 'admin', '2017-06-16 09:52:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34068, '2017-06-16 09:52:36', NULL, NULL, 10109, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 09:52:36', 'admin-1497572248-1497577956115672', 1, 0, '', NULL, NULL, NULL),
(34069, '2017-06-16 09:52:36', NULL, NULL, 10109, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 09:52:36', 'admin-1497572248-1497577956115672', 1, 0, '', NULL, NULL, NULL),
(34070, '2017-06-16 12:09:00', NULL, NULL, 10113, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:09:00', 'admin-1497585921-1497586140575163', 1, 1, 'SR', NULL, NULL, NULL),
(34071, '2017-06-16 12:08:55', NULL, NULL, 10113, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:08:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34072, '2017-06-16 12:05:30', NULL, NULL, 10112, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:05:30', 'admin-1497585921-14975859301182389', 1, 0, '', NULL, NULL, NULL),
(34073, '2017-06-16 12:05:15', NULL, NULL, 10112, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:05:15', 'admin-1497572248-14975859153974469', 1, 0, '', NULL, NULL, NULL),
(34074, '2017-06-16 12:04:46', NULL, NULL, 10112, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:04:46', 'admin-1497572248-1497585885885348', 1, 0, '', NULL, NULL, NULL),
(34075, '2017-06-16 12:04:46', NULL, NULL, 10112, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:04:46', 'admin-1497572248-1497585885885348', 1, 0, '', NULL, NULL, NULL),
(34076, '2017-06-16 12:04:37', NULL, NULL, 10112, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 12:04:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34077, '2017-06-16 11:53:03', NULL, NULL, 10111, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 11:53:03', 'admin-1497572248-14975851835094297', 1, 1, 'SR', NULL, NULL, NULL),
(34078, '2017-06-16 11:53:03', NULL, NULL, 10111, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 11:53:03', 'admin-1497572248-14975851835094297', 1, 1, 'SR', NULL, NULL, NULL),
(34079, '2017-06-16 11:53:03', NULL, NULL, 10111, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 11:53:03', 'admin-1497572248-14975851835094297', 1, 1, 'SR', NULL, NULL, NULL),
(34080, '2017-06-16 11:52:50', NULL, NULL, 10111, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 11:52:50', 'admin-1497572248-14975851701558350', 1, 0, '', NULL, NULL, NULL),
(34081, '2017-06-16 11:52:50', NULL, NULL, 10111, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 11:52:50', 'admin-1497572248-14975851701558350', 1, 0, '', NULL, NULL, NULL),
(34082, '2017-06-16 11:52:50', NULL, NULL, 10111, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 11:52:50', 'admin-1497572248-14975851701558350', 1, 0, '', NULL, NULL, NULL),
(34083, '2017-06-16 11:52:41', NULL, NULL, 10111, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1497594779', 'admin', '2017-06-16 11:52:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34084, '2017-06-16 10:19:20', NULL, NULL, 10110, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 10:19:20', 'admin-1497572248-14975795605472376', 1, 1, 'SR', NULL, NULL, NULL),
(34085, '2017-06-16 10:19:16', NULL, NULL, 10110, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1497594779', 'admin', '2017-06-16 10:19:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34086, '2017-06-16 10:12:25', NULL, NULL, 10107, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1497594779', 'admin', '2017-06-16 10:12:25', 'admin-1497572248-14975791449655166', 1, 0, '', NULL, NULL, NULL),
(34087, '2017-06-16 10:12:25', NULL, NULL, 10107, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 10:12:25', 'admin-1497572248-14975791449655166', 1, 1, 'SR', NULL, NULL, NULL),
(34088, '2017-06-16 09:52:41', NULL, NULL, 10109, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 09:52:41', 'admin-1497572248-14975779614877724', 1, 1, 'SR', NULL, NULL, NULL),
(34089, '2017-06-16 09:52:41', NULL, NULL, 10109, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 09:52:41', 'admin-1497572248-14975779614877724', 1, 1, 'SR', NULL, NULL, NULL),
(34090, '2017-06-16 09:52:41', NULL, NULL, 10109, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 09:52:41', 'admin-1497572248-14975779614877724', 1, 1, 'SR', NULL, NULL, NULL),
(34091, '2017-06-16 09:20:05', NULL, NULL, 10106, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1497594779', 'admin', '2017-06-16 09:20:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34092, '2017-06-16 09:07:54', NULL, NULL, 10105, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 09:07:54', 'admin-1497572248-14975752742587171', 1, 0, '', NULL, NULL, NULL),
(34093, '2017-06-16 09:07:54', NULL, NULL, 10105, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 09:07:54', 'admin-1497572248-14975752742587171', 1, 0, '', NULL, NULL, NULL),
(34094, '2017-06-16 09:08:00', NULL, NULL, 10105, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 09:08:00', 'admin-1497572248-1497575280055685', 1, 1, 'SR', NULL, NULL, NULL),
(34095, '2017-06-16 09:20:11', NULL, NULL, 10106, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 09:20:11', 'admin-1497572248-1497576011366776', 1, 0, '', NULL, NULL, NULL),
(34096, '2017-06-16 09:08:00', NULL, NULL, 10105, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497594779', 'admin', '2017-06-16 09:08:00', 'admin-1497572248-1497575280055685', 1, 1, 'SR', NULL, NULL, NULL),
(34097, '2017-06-16 09:07:48', NULL, NULL, 10105, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1497594779', 'admin', '2017-06-16 09:07:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34098, '2017-06-17 17:09:08', NULL, NULL, 10163, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 17:09:08', 'admin-1497686642-14976905486031538', 1, 0, '', NULL, NULL, NULL),
(34099, '2017-06-17 16:41:58', NULL, NULL, 10163, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.60, 0.0000, 0.0000, 9.60, 1, '27', 1, '1497686642', 'admin', '2017-06-17 16:41:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34100, '2017-06-17 13:04:45', NULL, NULL, 10150, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 13:04:45', 'admin-1497673009-14976758853793787', 1, 0, '', NULL, NULL, NULL),
(34101, '2017-06-17 13:04:53', NULL, NULL, 10150, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 13:04:53', 'admin-1497673009-1497675893594256', 1, 0, '', NULL, NULL, NULL),
(34102, '2017-06-17 00:00:00', NULL, NULL, 10164, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 16:30:25', 'admin-1497686642-14976882254288112', 1, 1, 'SR', NULL, NULL, NULL),
(34103, '2017-06-17 16:47:21', NULL, NULL, 10165, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1497686642', 'admin', '2017-06-17 16:47:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34104, '2017-06-17 16:47:26', NULL, NULL, 10165, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 16:47:26', 'admin-1497686642-14976892460173757', 1, 1, 'SR', NULL, NULL, NULL),
(34105, '2017-06-17 16:48:28', NULL, NULL, 10163, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 16:48:28', 'admin-1497686642-14976893083001621', 1, 1, 'SR', NULL, NULL, NULL),
(34106, '2017-06-17 16:48:35', NULL, NULL, 10163, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 16:48:35', 'admin-1497686642-1497689315606901', 1, 1, 'SR', NULL, NULL, NULL),
(34107, '2017-06-17 16:59:06', NULL, NULL, 10166, 0, 181, '116', 'Open Food ', 'Postcard with postage', 'Meals', 'Perfect Meals', 1, 36.00, 36.0000, 0.0000, 36.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 16:59:06', 'admin-1497686642-1497689946443321', 1, 0, '', 1, NULL, NULL),
(34108, '2017-06-17 17:02:21', NULL, NULL, 10166, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 17:02:21', 'admin-1497686642-14976901413999985', 1, 0, '', 1, NULL, NULL),
(34109, '2017-06-17 17:02:21', NULL, NULL, 10166, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 17:02:21', 'admin-1497686642-14976901413999985', 1, 0, '', 1, NULL, NULL),
(34110, '2017-06-17 12:52:57', NULL, NULL, 10148, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:52:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34111, '2017-06-17 12:53:16', NULL, NULL, 10148, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:53:16', 'admin-1497673009-14976751964205478', 1, 1, 'SR', NULL, NULL, NULL),
(34112, '2017-06-17 12:53:16', NULL, NULL, 10148, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:53:16', 'admin-1497673009-14976751964205478', 1, 0, '', NULL, NULL, NULL),
(34113, '2017-06-17 12:53:51', NULL, NULL, 10145, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:53:51', 'admin-1497673009-14976752317687354', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(34114, '2017-06-17 12:01:06', NULL, NULL, 10143, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:01:06', 'admin-1497671529-14976720665639410', 1, 0, '', NULL, NULL, NULL),
(34115, '2017-06-17 12:01:06', NULL, NULL, 10143, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:01:06', 'admin-1497671529-14976720665639410', 1, 1, 'SR', NULL, NULL, NULL),
(34116, '2017-06-17 12:01:06', NULL, NULL, 10143, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:01:06', 'admin-1497671529-14976720665639410', 1, 0, '', NULL, NULL, NULL),
(34117, '2017-06-17 12:01:24', NULL, NULL, 10144, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:01:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34118, '2017-06-17 12:01:49', NULL, NULL, 10144, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:01:49', 'admin-1497671529-14976721092924334', 1, 1, 'SR', NULL, NULL, NULL),
(34119, '2017-06-17 12:01:49', NULL, NULL, 10144, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:01:49', 'admin-1497671529-14976721092924334', 1, 0, '', NULL, NULL, NULL),
(34120, '2017-06-17 16:46:28', NULL, NULL, 10164, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1497686642', 'admin', '2017-06-17 16:46:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34121, '2017-06-17 16:31:06', NULL, NULL, 10161, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 16:31:06', 'admin-1497686642-14976882664113831', 1, 1, 'SR', NULL, NULL, NULL),
(34122, '2017-06-17 16:06:42', NULL, NULL, 10162, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 16:06:42', 'admin-1497686642-14976868025155370', 1, 1, 'SR', NULL, NULL, NULL),
(34123, '2017-06-17 16:06:42', NULL, NULL, 10162, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 16:06:42', 'admin-1497686642-14976868025155370', 1, 0, '', NULL, NULL, NULL),
(34124, '2017-06-17 16:21:30', NULL, NULL, 10161, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 16:21:30', 'admin-1497686642-14976876900215535', 1, 0, '', NULL, NULL, NULL),
(34125, '2017-06-17 16:03:55', NULL, NULL, 10161, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 16:03:55', 'admin-1497675902-1497686635599137', 1, 0, '', NULL, NULL, NULL),
(34126, '2017-06-17 16:03:55', NULL, NULL, 10161, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 16:03:55', 'admin-1497675902-1497686635599137', 1, 1, 'SR', NULL, NULL, NULL),
(34127, '2017-06-17 16:03:55', NULL, NULL, 10161, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 16:03:55', 'admin-1497675902-1497686635599137', 1, 0, '', NULL, NULL, NULL),
(34128, '2017-06-17 16:06:28', NULL, NULL, 10162, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1497686642', 'admin', '2017-06-17 16:06:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34129, '2017-06-17 16:03:07', NULL, NULL, 10161, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 16:03:07', 'admin-1497675902-14976865871985296', 1, 0, '', NULL, NULL, NULL),
(34130, '2017-06-17 16:03:07', NULL, NULL, 10161, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 16:03:07', 'admin-1497675902-14976865871985296', 1, 0, '', NULL, NULL, NULL),
(34131, '2017-06-17 15:54:50', NULL, NULL, 10161, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 15:54:50', 'admin-1497675902-14976860899337185', 1, 0, '', NULL, NULL, NULL),
(34132, '2017-06-17 16:03:07', NULL, NULL, 10161, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 16:03:07', 'admin-1497675902-14976865871985296', 1, 0, '', NULL, NULL, NULL),
(34133, '2017-06-17 14:01:26', NULL, NULL, 10153, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 14:01:26', 'admin-1497675902-14976792859965029', 1, 1, 'SR', NULL, NULL, NULL),
(34134, '2017-06-17 14:01:26', NULL, NULL, 10153, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 14:01:26', 'admin-1497675902-14976792859965029', 1, 1, 'SR', NULL, NULL, NULL),
(34135, '2017-06-17 14:01:12', NULL, NULL, 10153, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 14:01:12', 'admin-1497675902-1497679272609765', 1, 0, '', NULL, NULL, NULL),
(34136, '2017-06-17 17:12:14', NULL, NULL, 10163, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 17:12:14', 'admin-1497686642-14976907340545187', 1, 0, '', NULL, NULL, NULL),
(34137, '2017-06-17 17:12:14', NULL, NULL, 10163, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 17:12:14', 'admin-1497686642-14976907340545187', 1, 0, '', NULL, NULL, NULL),
(34138, '2017-06-17 17:02:21', NULL, NULL, 10166, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 17:02:21', 'admin-1497686642-14976901413999985', 1, 0, '', 1, NULL, NULL),
(34139, '2017-06-17 17:02:21', NULL, NULL, 10166, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 17:02:21', 'admin-1497686642-14976901413999985', 1, 0, '', 1, NULL, NULL),
(34140, '2017-06-17 12:21:12', NULL, NULL, 10145, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:21:12', 'admin-1497673009-14976732726038439', 1, 1, 'SR', NULL, NULL, NULL),
(34141, '2017-06-17 17:02:21', NULL, NULL, 10166, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 17:02:21', 'admin-1497686642-14976901413999985', 1, 0, '', 1, NULL, NULL),
(34142, '2017-06-17 14:51:51', NULL, NULL, 10155, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1497686642', 'admin', '2017-06-17 14:51:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34143, '2017-06-17 14:51:56', NULL, NULL, 10155, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 14:51:56', 'admin-1497675902-1497682315785365', 1, 1, 'SR', NULL, NULL, NULL),
(34144, '2017-06-17 15:06:51', NULL, NULL, 10156, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1497686642', 'admin', '2017-06-17 15:06:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34145, '2017-06-17 15:06:54', NULL, NULL, 10156, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 15:06:54', 'admin-1497675902-14976832143607090', 1, 1, 'SR', NULL, NULL, NULL),
(34146, '2017-06-17 15:10:54', NULL, NULL, 10157, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1497686642', 'admin', '2017-06-17 15:10:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34147, '2017-06-17 15:11:02', NULL, NULL, 10157, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 15:11:02', 'admin-1497675902-14976834626218051', 1, 0, '', NULL, NULL, NULL),
(34148, '2017-06-17 15:11:02', NULL, NULL, 10157, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 15:11:02', 'admin-1497675902-14976834626218051', 1, 0, '', NULL, NULL, NULL),
(34149, '2017-06-17 15:12:43', NULL, NULL, 10158, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1497686642', 'admin', '2017-06-17 15:12:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34150, '2017-06-17 15:12:47', NULL, NULL, 10158, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 15:12:47', 'admin-1497675902-14976835669929782', 1, 1, 'SR', NULL, NULL, NULL),
(34151, '2017-06-17 15:19:33', NULL, NULL, 10159, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1497686642', 'admin', '2017-06-17 15:19:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34152, '2017-06-17 15:19:36', NULL, NULL, 10159, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 15:19:36', 'admin-1497675902-1497683976695534', 1, 0, '', NULL, NULL, NULL),
(34153, '2017-06-17 15:38:00', NULL, NULL, 10160, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1497686642', 'admin', '2017-06-17 15:38:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34154, '2017-06-17 15:38:03', NULL, NULL, 10160, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 15:38:03', 'admin-1497675902-14976850833785962', 1, 1, 'SR', NULL, NULL, NULL),
(34155, '2017-06-17 15:54:50', NULL, NULL, 10161, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 15:54:50', 'admin-1497675902-14976860899337185', 1, 1, 'SR', NULL, NULL, NULL),
(34156, '2017-06-17 11:51:58', NULL, NULL, 10141, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.15, 0.0000, 0.0000, 3.15, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:51:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34157, '2017-06-17 11:23:06', NULL, NULL, 10138, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:23:06', 'admin-1497667709-1497669786801690', 1, 1, 'SR', NULL, NULL, NULL),
(34158, '2017-06-17 12:21:23', NULL, NULL, 10145, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:21:23', 'admin-1497673009-14976732830453782', 1, 1, 'SR', NULL, NULL, NULL),
(34159, '2017-06-17 12:21:23', NULL, NULL, 10145, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:21:23', 'admin-1497673009-14976732830453782', 1, 0, '', NULL, NULL, NULL),
(34160, '2017-06-17 12:21:12', NULL, NULL, 10145, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:21:12', 'admin-1497673009-14976732726038439', 1, 0, '', NULL, NULL, NULL),
(34161, '2017-06-17 12:21:12', NULL, NULL, 10145, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:21:12', 'admin-1497673009-14976732726038439', 1, 1, 'SR', NULL, NULL, NULL),
(34162, '2017-06-17 16:42:52', NULL, NULL, 10163, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 16:42:52', 'admin-1497686642-1497688972106869', 1, 1, 'SR', NULL, NULL, NULL),
(34163, '2017-06-17 15:54:50', NULL, NULL, 10161, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 15:54:50', 'admin-1497675902-14976860899337185', 1, 1, 'SR', NULL, NULL, NULL),
(34164, '2017-06-17 16:42:52', NULL, NULL, 10163, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 16:42:52', 'admin-1497686642-1497688972106869', 1, 0, '', NULL, NULL, NULL),
(34165, '2017-06-17 15:54:50', NULL, NULL, 10161, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 15:54:50', 'admin-1497675902-14976860899337185', 1, 1, 'SR', NULL, NULL, NULL),
(34166, '2017-06-17 15:54:33', NULL, NULL, 10161, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 18.60, 0.0000, 0.0000, 18.60, 1, '27', 1, '1497686642', 'admin', '2017-06-17 15:54:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34167, '2017-06-17 17:02:21', NULL, NULL, 10166, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 17:02:21', 'admin-1497686642-14976901413999985', 1, 0, '', 1, NULL, NULL),
(34168, '2017-06-17 14:36:15', NULL, NULL, 10154, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 14:36:15', 'admin-1497675902-14976813754932730', 1, 0, '', NULL, NULL, NULL),
(34169, '2017-06-17 14:36:15', NULL, NULL, 10154, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 14:36:15', 'admin-1497675902-14976813754932730', 1, 0, '', NULL, NULL, NULL),
(34170, '2017-06-17 14:36:15', NULL, NULL, 10154, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 14:36:15', 'admin-1497675902-14976813754932730', 1, 0, '', NULL, NULL, NULL),
(34171, '2017-06-17 14:36:15', NULL, NULL, 10154, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 14:36:15', 'admin-1497675902-14976813754932730', 1, 1, 'SR', NULL, NULL, NULL),
(34172, '2017-06-17 14:36:03', NULL, NULL, 10154, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1497686642', 'admin', '2017-06-17 14:36:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34173, '2017-06-17 14:01:12', NULL, NULL, 10153, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 14:01:12', 'admin-1497675902-1497679272609765', 1, 0, '', NULL, NULL, NULL),
(34174, '2017-06-17 12:01:49', NULL, NULL, 10144, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:01:49', 'admin-1497671529-14976721092924334', 1, 0, '', NULL, NULL, NULL),
(34175, '2017-06-17 12:06:01', NULL, NULL, 10144, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:06:01', 'admin-1497671529-14976723614196493', 1, 0, '', NULL, NULL, NULL),
(34176, '2017-06-17 14:00:48', NULL, NULL, 10153, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1497686642', 'admin', '2017-06-17 14:00:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34177, '2017-06-17 12:51:10', NULL, NULL, 10147, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:51:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34178, '2017-06-17 15:54:50', NULL, NULL, 10161, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 15:54:50', 'admin-1497675902-14976860899337185', 1, 1, 'SR', NULL, NULL, NULL),
(34179, '2017-06-17 14:01:12', NULL, NULL, 10153, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 14:01:12', 'admin-1497675902-1497679272609765', 1, 1, 'SR', NULL, NULL, NULL),
(34180, '2017-06-17 13:54:22', NULL, NULL, 10148, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 13:54:22', 'admin-1497675902-14976788626848754', 1, 1, 'SR', NULL, NULL, NULL),
(34181, '2017-06-17 13:01:26', NULL, NULL, 10149, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 13:01:26', 'admin-1497673009-14976756861777063', 1, 0, '', NULL, NULL, NULL),
(34182, '2017-06-17 13:01:26', NULL, NULL, 10149, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 13:01:26', 'admin-1497673009-14976756861777063', 1, 0, '', NULL, NULL, NULL),
(34183, '2017-06-17 13:38:01', NULL, NULL, 10149, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 13:38:01', 'admin-1497675902-14976778816521885', 1, 1, 'SR', NULL, NULL, NULL),
(34184, '2017-06-17 13:26:14', NULL, NULL, 10151, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1497686642', 'admin', '2017-06-17 13:26:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34185, '2017-06-17 13:26:25', NULL, NULL, 10151, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 13:26:25', 'admin-1497675902-14976771851454376', 1, 1, 'SR', NULL, NULL, NULL),
(34186, '2017-06-17 13:26:25', NULL, NULL, 10151, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 13:26:25', 'admin-1497675902-14976771851454376', 1, 1, 'SR', NULL, NULL, NULL),
(34187, '2017-06-17 13:04:31', NULL, NULL, 10150, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1497686642', 'admin', '2017-06-17 13:04:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34188, '2017-06-17 13:04:45', NULL, NULL, 10150, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 13:04:45', 'admin-1497673009-14976758853793787', 1, 0, '', NULL, NULL, NULL),
(34189, '2017-06-17 12:56:02', NULL, NULL, 10146, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:56:02', 'admin-1497673009-14976753619754084', 1, 0, '', NULL, NULL, NULL),
(34190, '2017-06-17 13:01:00', NULL, NULL, 10149, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1497686642', 'admin', '2017-06-17 13:01:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34191, '2017-06-17 13:01:26', NULL, NULL, 10149, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 13:01:26', 'admin-1497673009-14976756861777063', 1, 0, '', NULL, NULL, NULL),
(34192, '2017-06-17 14:01:12', NULL, NULL, 10153, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 14:01:12', 'admin-1497675902-1497679272609765', 1, 0, '', NULL, NULL, NULL),
(34193, '2017-06-17 12:51:31', NULL, NULL, 10147, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:51:31', 'admin-1497673009-14976750914819512', 1, 1, 'SR', NULL, NULL, NULL),
(34194, '2017-06-17 12:51:31', NULL, NULL, 10147, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:51:31', 'admin-1497673009-14976750914819512', 1, 1, 'SR', NULL, NULL, NULL),
(34195, '2017-06-17 12:51:19', NULL, NULL, 10147, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:51:19', 'admin-1497673009-1497675079799677', 1, 0, '', NULL, NULL, NULL),
(34196, '2017-06-17 12:51:19', NULL, NULL, 10147, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:51:19', 'admin-1497673009-1497675079799677', 1, 1, 'SR', NULL, NULL, NULL),
(34197, '2017-06-17 12:24:50', NULL, NULL, 10139, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:24:50', 'admin-1497673009-14976734906767892', 1, 1, 'SR', NULL, NULL, NULL),
(34198, '2017-06-17 12:19:51', NULL, NULL, 10146, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:19:51', 'admin-1497673009-14976731911423397', 1, 1, 'SR', NULL, NULL, NULL),
(34199, '2017-06-17 12:19:51', NULL, NULL, 10146, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:19:51', 'admin-1497673009-14976731911423397', 1, 1, 'SR', NULL, NULL, NULL),
(34200, '2017-06-17 12:19:51', NULL, NULL, 10146, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:19:51', 'admin-1497673009-14976731911423397', 1, 1, 'SR', NULL, NULL, NULL),
(34201, '2017-06-17 12:19:51', NULL, NULL, 10146, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:19:51', 'admin-1497673009-14976731911423397', 1, 1, 'SR', NULL, NULL, NULL),
(34202, '2017-06-17 12:19:35', NULL, NULL, 10146, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.50, 0.0000, 0.0000, 9.50, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:19:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34203, '2017-06-17 12:19:51', NULL, NULL, 10146, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:19:51', 'admin-1497673009-14976731911423397', 1, 1, 'SR', NULL, NULL, NULL),
(34204, '2017-06-17 12:19:51', NULL, NULL, 10146, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:19:51', 'admin-1497673009-14976731911423397', 1, 1, 'SR', NULL, NULL, NULL),
(34205, '2017-06-17 12:19:51', NULL, NULL, 10146, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:19:51', 'admin-1497673009-14976731911423397', 1, 0, '', NULL, NULL, NULL),
(34206, '2017-06-17 12:19:51', NULL, NULL, 10146, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:19:51', 'admin-1497673009-14976731911423397', 1, 1, 'SR', NULL, NULL, NULL),
(34207, '2017-06-17 12:15:00', NULL, NULL, 10145, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:15:00', 'admin-1497671529-14976729006562776', 1, 0, '', NULL, NULL, NULL),
(34208, '2017-06-17 12:14:57', NULL, NULL, 10145, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:14:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34209, '2017-06-17 12:06:38', NULL, NULL, 10139, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:06:38', 'admin-1497671529-1497672398795673', 1, 0, '', NULL, NULL, NULL),
(34210, '2017-06-17 11:37:28', NULL, NULL, 10139, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.10, 0.0000, 0.0000, 13.10, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:37:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34211, '2017-06-17 11:37:46', NULL, NULL, 10139, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:37:46', 'admin-1497667709-1497670665925751', 1, 0, '', NULL, NULL, NULL),
(34212, '2017-06-17 11:37:46', NULL, NULL, 10139, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:37:46', 'admin-1497667709-1497670665925751', 1, 0, '', NULL, NULL, NULL),
(34213, '2017-06-17 11:37:46', NULL, NULL, 10139, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:37:46', 'admin-1497667709-1497670665925751', 1, 0, '', NULL, NULL, NULL),
(34214, '2017-06-17 11:37:46', NULL, NULL, 10139, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:37:46', 'admin-1497667709-1497670665925751', 1, 0, '', NULL, NULL, NULL),
(34215, '2017-06-17 11:37:46', NULL, NULL, 10139, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:37:46', 'admin-1497667709-1497670665925751', 1, 1, 'SR', NULL, NULL, NULL),
(34216, '2017-06-17 11:37:46', NULL, NULL, 10139, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:37:46', 'admin-1497667709-1497670665925751', 1, 1, 'SR', NULL, NULL, NULL),
(34217, '2017-06-17 11:37:46', NULL, NULL, 10139, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:37:46', 'admin-1497667709-1497670665925751', 1, 1, 'SR', NULL, NULL, NULL),
(34218, '2017-06-17 11:40:27', NULL, NULL, 10140, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:40:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34219, '2017-06-17 11:40:35', NULL, NULL, 10140, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:40:35', 'admin-1497667709-14976708350028125', 1, 0, '', NULL, NULL, NULL),
(34220, '2017-06-17 11:40:35', NULL, NULL, 10140, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:40:35', 'admin-1497667709-14976708350028125', 1, 0, '', NULL, NULL, NULL),
(34221, '2017-06-17 11:40:35', NULL, NULL, 10140, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:40:35', 'admin-1497667709-14976708350028125', 1, 0, '', NULL, NULL, NULL),
(34222, '2017-06-17 11:40:35', NULL, NULL, 10140, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:40:35', 'admin-1497667709-14976708350028125', 1, 0, '', NULL, NULL, NULL),
(34223, '2017-06-17 10:48:24', NULL, NULL, 10135, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:48:24', 'admin-1497660873-14976677039287557', 1, 0, '', NULL, NULL, NULL),
(34224, '2017-06-17 12:01:06', NULL, NULL, 10143, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:01:06', 'admin-1497671529-14976720665639410', 1, 0, '', NULL, NULL, NULL),
(34225, '2017-06-17 11:10:01', NULL, NULL, 10137, 0, 154, '88', 'Daily Dose BLT', 'egg welldone', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:10:01', 'admin-1497667709-14976690012408888', 1, 0, '', NULL, NULL, NULL),
(34226, '2017-06-17 11:10:09', NULL, NULL, 10137, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:10:09', 'admin-1497667709-14976690091176939', 1, 1, 'SR', NULL, NULL, NULL),
(34227, '2017-06-17 11:10:09', NULL, NULL, 10137, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:10:09', 'admin-1497667709-14976690091176939', 1, 1, 'SR', NULL, NULL, NULL),
(34228, '2017-06-17 11:10:49', NULL, NULL, 10135, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:10:49', 'admin-1497667709-1497669049178569', 1, 1, 'SR', NULL, NULL, NULL),
(34229, '2017-06-17 12:00:53', NULL, NULL, 10143, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1497686642', 'admin', '2017-06-17 12:00:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34230, '2017-06-17 10:51:00', NULL, NULL, 10136, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:51:00', 'admin-1497667709-14976678600764864', 1, 1, 'SR', NULL, NULL, NULL),
(34231, '2017-06-17 11:55:43', NULL, NULL, 10142, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:55:43', 'admin-1497671529-14976717435426296', 1, 1, 'SR', NULL, NULL, NULL),
(34232, '2017-06-17 11:52:21', NULL, NULL, 10141, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:52:21', 'admin-1497671529-14976715412597061', 1, 1, 'SR', NULL, NULL, NULL),
(34233, '2017-06-17 11:52:21', NULL, NULL, 10141, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:52:21', 'admin-1497671529-14976715412597061', 1, 0, '', NULL, NULL, NULL),
(34234, '2017-06-17 11:55:39', NULL, NULL, 10142, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:55:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34235, '2017-06-17 11:55:43', NULL, NULL, 10142, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:55:43', 'admin-1497671529-14976717435426296', 1, 0, '', NULL, NULL, NULL),
(34236, '2017-06-17 11:52:03', NULL, NULL, 10141, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:52:03', 'admin-1497667709-14976715228267642', 1, 0, '', NULL, NULL, NULL),
(34237, '2017-06-17 11:23:06', NULL, NULL, 10138, 0, 181, '116', 'Open Food ', 'Scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:23:06', 'admin-1497667709-1497669786801690', 1, 0, '', NULL, NULL, NULL),
(34238, '2017-06-17 11:23:06', NULL, NULL, 10138, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:23:06', 'admin-1497667709-1497669786801690', 1, 1, 'SR', NULL, NULL, NULL),
(34239, '2017-06-17 09:34:56', NULL, NULL, 10129, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1497686642', 'admin', '2017-06-17 09:34:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34240, '2017-06-17 09:35:02', NULL, NULL, 10129, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 09:35:02', 'admin-1497660873-14976633027861227', 1, 0, '', NULL, NULL, NULL),
(34241, '2017-06-17 09:35:02', NULL, NULL, 10129, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 09:35:02', 'admin-1497660873-14976633027861227', 1, 0, '', NULL, NULL, NULL),
(34242, '2017-06-17 09:35:09', NULL, NULL, 10129, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 09:35:09', 'admin-1497660873-14976633090566232', 1, 1, 'SR', NULL, NULL, NULL),
(34243, '2017-06-17 09:47:24', NULL, NULL, 10130, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1497686642', 'admin', '2017-06-17 09:47:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34244, '2017-06-17 09:47:36', NULL, NULL, 10130, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 09:47:36', 'admin-1497660873-14976640566219294', 1, 0, '', NULL, NULL, NULL),
(34245, '2017-06-17 09:47:36', NULL, NULL, 10130, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 09:47:36', 'admin-1497660873-14976640566219294', 1, 0, '', NULL, NULL, NULL),
(34246, '2017-06-17 09:47:36', NULL, NULL, 10130, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 09:47:36', 'admin-1497660873-14976640566219294', 1, 1, 'SR', NULL, NULL, NULL),
(34247, '2017-06-17 09:47:36', NULL, NULL, 10130, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 09:47:36', 'admin-1497660873-14976640566219294', 1, 0, '', NULL, NULL, NULL),
(34248, '2017-06-17 09:58:58', NULL, NULL, 10129, 0, 154, '88', 'Daily Dose BLT', 'Takeaway', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 09:58:58', 'admin-1497660873-1497664738757917', 1, 0, '', NULL, NULL, NULL),
(34249, '2017-06-17 10:14:35', NULL, NULL, 10131, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:14:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34250, '2017-06-17 11:10:49', NULL, NULL, 10135, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:10:49', 'admin-1497667709-1497669049178569', 1, 1, 'SR', NULL, NULL, NULL),
(34251, '2017-06-17 11:10:01', NULL, NULL, 10137, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:10:01', 'admin-1497667709-14976690012408888', 1, 0, '', NULL, NULL, NULL),
(34252, '2017-06-17 11:10:01', NULL, NULL, 10137, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:10:01', 'admin-1497667709-14976690012408888', 1, 0, '', NULL, NULL, NULL),
(34253, '2017-06-17 11:09:43', NULL, NULL, 10137, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:09:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34254, '2017-06-17 10:51:00', NULL, NULL, 10136, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:51:00', 'admin-1497667709-14976678600764864', 1, 1, 'SR', NULL, NULL, NULL),
(34255, '2017-06-17 10:51:00', NULL, NULL, 10136, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:51:00', 'admin-1497667709-14976678600764864', 1, 1, 'SR', NULL, NULL, NULL),
(34256, '2017-06-17 10:51:00', NULL, NULL, 10136, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:51:00', 'admin-1497667709-14976678600764864', 1, 0, '', NULL, NULL, NULL),
(34257, '2017-06-17 10:51:00', NULL, NULL, 10136, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:51:00', 'admin-1497667709-14976678600764864', 1, 0, '', NULL, NULL, NULL),
(34258, '2017-06-17 10:51:00', NULL, NULL, 10136, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:51:00', 'admin-1497667709-14976678600764864', 1, 0, '', NULL, NULL, NULL),
(34259, '2017-06-17 10:50:49', NULL, NULL, 10136, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:50:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34260, '2017-06-17 10:48:24', NULL, NULL, 10135, 0, 181, '116', 'Open Food ', ' ADD FRUITS,pANCAKE NO BACON', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:48:24', 'admin-1497660873-14976677039287557', 1, 0, '', NULL, NULL, NULL),
(34261, '2017-06-17 10:48:24', NULL, NULL, 10135, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:48:24', 'admin-1497660873-14976677039287557', 1, 0, '', NULL, NULL, NULL),
(34262, '2017-06-17 10:48:24', NULL, NULL, 10135, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:48:24', 'admin-1497660873-14976677039287557', 1, 0, '', NULL, NULL, NULL),
(34263, '2017-06-17 10:39:43', NULL, NULL, 10133, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:39:43', 'admin-1497660873-14976671837656149', 1, 1, 'SR', NULL, NULL, NULL),
(34264, '2017-06-17 11:22:53', NULL, NULL, 10138, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1497686642', 'admin', '2017-06-17 11:22:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34265, '2017-06-17 10:38:52', NULL, NULL, 10134, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:38:52', 'admin-1497660873-14976671321466373', 1, 0, '', NULL, NULL, NULL),
(34266, '2017-06-17 10:38:52', NULL, NULL, 10134, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:38:52', 'admin-1497660873-14976671321466373', 1, 0, '', NULL, NULL, NULL),
(34267, '2017-06-17 10:47:58', NULL, NULL, 10135, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:47:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34268, '2017-06-17 10:39:43', NULL, NULL, 10133, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:39:43', 'admin-1497660873-14976671837656149', 1, 1, 'SR', NULL, NULL, NULL),
(34269, '2017-06-17 10:30:55', NULL, NULL, 10132, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:30:55', 'admin-1497660873-1497666655140634', 1, 0, '', NULL, NULL, NULL),
(34270, '2017-06-17 10:37:40', NULL, NULL, 10133, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:37:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34271, '2017-06-17 10:37:45', NULL, NULL, 10133, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:37:45', 'admin-1497660873-1497667065118752', 1, 1, 'SR', NULL, NULL, NULL),
(34272, '2017-06-17 10:38:47', NULL, NULL, 10134, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:38:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34273, '2017-06-17 09:22:29', NULL, NULL, 10128, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 09:22:29', 'admin-1497660873-14976625498012141', 1, 0, '', NULL, NULL, NULL),
(34274, '2017-06-17 10:30:04', NULL, NULL, 10132, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:30:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34275, '2017-06-17 10:16:33', NULL, NULL, 10129, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:16:33', 'admin-1497660873-1497665793410617', 1, 0, '', NULL, NULL, NULL),
(34276, '2017-06-17 10:14:41', NULL, NULL, 10131, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 10:14:42', 'admin-1497660873-14976656818384293', 1, 1, 'SR', NULL, NULL, NULL),
(34277, '2017-06-17 09:22:35', NULL, NULL, 10128, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497686642', 'admin', '2017-06-17 09:22:35', 'admin-1497660873-14976625552918517', 1, 1, 'SR', NULL, NULL, NULL),
(34278, '2017-06-17 09:22:25', NULL, NULL, 10128, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1497686642', 'admin', '2017-06-17 09:22:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34279, '2017-06-18 13:48:58', NULL, NULL, 10200, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:48:58', 'admin-1497764902-14977649378594438', 1, 1, 'SR', NULL, NULL, NULL),
(34280, '2017-06-18 13:23:21', NULL, NULL, 10196, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:23:21', 'admin-1497762058-14977634009435320', 1, 0, '', NULL, NULL, NULL),
(34281, '2017-06-18 13:48:58', NULL, NULL, 10200, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:48:58', 'admin-1497764902-14977649378594438', 1, 0, '', NULL, NULL, NULL),
(34282, '2017-06-18 13:48:58', NULL, NULL, 10200, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:48:58', 'admin-1497764902-14977649378594438', 1, 0, '', NULL, NULL, NULL),
(34283, '2017-06-18 11:51:46', NULL, NULL, 10181, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:51:46', 'admin-1497757804-14977579061827454', 1, 0, '', NULL, NULL, NULL),
(34284, '2017-06-18 14:44:25', NULL, NULL, 10202, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 14:44:25', 'admin-1497764902-1497768265055471', 1, 1, 'SR', NULL, NULL, NULL),
(34285, '2017-06-18 14:44:21', NULL, NULL, 10202, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1497764902', 'admin', '2017-06-18 14:44:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34286, '2017-06-18 16:25:44', NULL, NULL, 10211, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 16:25:44', 'admin-1497764902-14977743445128014', 1, 0, '', 1, NULL, NULL),
(34287, '2017-06-18 16:19:13', NULL, NULL, 10209, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 16:19:13', 'admin-1497764902-14977739537152732', 1, 0, '', NULL, NULL, NULL),
(34288, '2017-06-18 15:04:03', NULL, NULL, 10204, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 15:04:03', 'admin-1497764902-14977694432922747', 1, 0, '', 1, NULL, NULL),
(34289, '2017-06-18 15:10:18', NULL, NULL, 10205, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1497764902', 'admin', '2017-06-18 15:10:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34290, '2017-06-18 14:41:46', NULL, NULL, 10188, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 14:41:46', 'admin-1497764902-14977681061515818', 1, 0, '', NULL, NULL, NULL),
(34291, '2017-06-18 16:19:13', NULL, NULL, 10209, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 16:19:13', 'admin-1497764902-14977739537152732', 1, 1, 'SR', NULL, NULL, NULL),
(34292, '2017-06-18 16:19:13', NULL, NULL, 10209, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 16:19:13', 'admin-1497764902-14977739537152732', 1, 1, 'SR', NULL, NULL, NULL),
(34293, '2017-06-18 16:18:38', NULL, NULL, 10209, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1497764902', 'admin', '2017-06-18 16:18:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34294, '2017-06-18 16:12:11', NULL, NULL, 10208, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 16:12:11', 'admin-1497764902-14977735308698057', 1, 1, 'SR', NULL, NULL, NULL),
(34295, '2017-06-18 16:11:59', NULL, NULL, 10208, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1497764902', 'admin', '2017-06-18 16:11:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34296, '2017-06-18 14:09:01', NULL, NULL, 10188, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 14:09:01', 'admin-1497764902-14977661412547419', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(34297, '2017-06-18 14:08:44', NULL, NULL, 10197, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 14:08:44', 'admin-1497764902-14977661245172526', 1, 0, '', NULL, NULL, NULL),
(34298, '2017-06-18 13:23:04', NULL, NULL, 10196, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:23:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34299, '2017-06-18 13:23:21', NULL, NULL, 10196, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:23:21', 'admin-1497762058-14977634009435320', 1, 1, 'SR', NULL, NULL, NULL),
(34300, '2017-06-18 13:23:21', NULL, NULL, 10196, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:23:21', 'admin-1497762058-14977634009435320', 1, 1, 'SR', NULL, NULL, NULL),
(34301, '2017-06-18 13:53:03', NULL, NULL, 10201, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:53:03', 'admin-1497764902-14977651829067348', 1, 1, 'SR', NULL, NULL, NULL),
(34302, '2017-06-18 13:26:48', NULL, NULL, 10195, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:26:48', 'admin-1497762058-14977636086435537', 1, 1, 'SR', NULL, NULL, NULL),
(34303, '2017-06-18 13:26:48', NULL, NULL, 10195, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:26:48', 'admin-1497762058-14977636086435537', 1, 1, 'SR', NULL, NULL, NULL),
(34304, '2017-06-18 13:26:59', NULL, NULL, 10188, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:26:59', 'admin-1497762058-1497763619621628', 1, 1, 'SR', NULL, NULL, NULL),
(34305, '2017-06-18 13:27:23', NULL, NULL, 10194, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:27:23', 'admin-1497762058-1497763643313776', 1, 0, '', NULL, NULL, NULL),
(34306, '2017-06-18 13:32:06', NULL, NULL, 10197, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.80, 0.0000, 0.0000, 14.80, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:32:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34307, '2017-06-18 12:36:38', NULL, NULL, 10189, 0, 157, '91', 'French Toast with Fruits', 'pancake', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:36:38', 'admin-1497760327-1497760597901632', 1, 0, '', NULL, NULL, NULL),
(34308, '2017-06-18 12:36:38', NULL, NULL, 10189, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:36:38', 'admin-1497760327-1497760597901632', 1, 0, '', NULL, NULL, NULL),
(34309, '2017-06-18 12:36:38', NULL, NULL, 10189, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:36:38', 'admin-1497760327-1497760597901632', 1, 1, 'SR', NULL, NULL, NULL),
(34310, '2017-06-18 11:51:46', NULL, NULL, 10181, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:51:46', 'admin-1497757804-14977579061827454', 1, 1, 'SR', NULL, NULL, NULL),
(34311, '2017-06-18 11:53:11', NULL, NULL, 10182, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:53:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34312, '2017-06-18 11:53:15', NULL, NULL, 10182, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:53:15', 'admin-1497757804-14977579953041122', 1, 1, 'SR', NULL, NULL, NULL),
(34313, '2017-06-18 11:53:15', NULL, NULL, 10182, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:53:15', 'admin-1497757804-14977579953041122', 1, 1, 'SR', NULL, NULL, NULL),
(34314, '2017-06-18 11:53:41', NULL, NULL, 10181, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:53:41', 'admin-1497757804-14977580214308196', 1, 1, 'SR', NULL, NULL, NULL),
(34315, '2017-06-18 11:53:41', NULL, NULL, 10181, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:53:41', 'admin-1497757804-14977580214308196', 1, 1, 'SR', NULL, NULL, NULL),
(34316, '2017-06-18 11:53:41', NULL, NULL, 10181, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:53:41', 'admin-1497757804-14977580214308196', 1, 0, '', NULL, NULL, NULL),
(34317, '2017-06-18 13:48:14', NULL, NULL, 10200, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:48:14', 'admin-1497762058-14977648940938275', 1, 1, 'SR', NULL, NULL, NULL),
(34318, '2017-06-18 13:42:44', NULL, NULL, 10199, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:42:44', 'admin-1497762058-14977645642964162', 1, 1, 'SR', NULL, NULL, NULL),
(34319, '2017-06-18 13:42:44', NULL, NULL, 10199, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:42:44', 'admin-1497762058-14977645642964162', 1, 0, '', NULL, NULL, NULL),
(34320, '2017-06-18 13:47:45', NULL, NULL, 10200, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.20, 0.0000, 0.0000, 9.20, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:47:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34321, '2017-06-18 13:48:14', NULL, NULL, 10200, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:48:14', 'admin-1497762058-14977648940938275', 1, 0, '', NULL, NULL, NULL),
(34322, '2017-06-18 13:41:50', NULL, NULL, 10198, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:41:50', 'admin-1497762058-14977645097665571', 1, 1, 'SR', NULL, NULL, NULL),
(34323, '2017-06-18 13:42:32', NULL, NULL, 10199, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:42:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34324, '2017-06-18 13:42:44', NULL, NULL, 10199, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:42:44', 'admin-1497762058-14977645642964162', 1, 0, '', NULL, NULL, NULL),
(34325, '2017-06-18 13:42:44', NULL, NULL, 10199, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:42:44', 'admin-1497762058-14977645642964162', 1, 1, 'SR', NULL, NULL, NULL),
(34326, '2017-06-18 16:25:44', NULL, NULL, 10211, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 16:25:44', 'admin-1497764902-14977743445128014', 1, 0, '', 1, NULL, NULL),
(34327, '2017-06-18 13:53:03', NULL, NULL, 10201, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:53:03', 'admin-1497764902-14977651829067348', 1, 1, 'SR', NULL, NULL, NULL),
(34328, '2017-06-18 13:41:50', NULL, NULL, 10198, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:41:50', 'admin-1497762058-14977645097665571', 1, 1, 'SR', NULL, NULL, NULL),
(34329, '2017-06-18 13:41:50', NULL, NULL, 10198, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:41:50', 'admin-1497762058-14977645097665571', 1, 1, 'SR', NULL, NULL, NULL),
(34330, '2017-06-18 12:45:28', NULL, NULL, 10192, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:45:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34331, '2017-06-18 12:45:54', NULL, NULL, 10192, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:45:54', 'admin-1497760327-14977611542142059', 1, 0, '', NULL, NULL, NULL),
(34332, '2017-06-18 12:45:54', NULL, NULL, 10192, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:45:54', 'admin-1497760327-14977611542142059', 1, 0, '', NULL, NULL, NULL),
(34333, '2017-06-18 12:45:54', NULL, NULL, 10192, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:45:54', 'admin-1497760327-14977611542142059', 1, 1, 'SR', NULL, NULL, NULL),
(34334, '2017-06-18 12:45:54', NULL, NULL, 10192, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:45:54', 'admin-1497760327-14977611542142059', 1, 1, 'SR', NULL, NULL, NULL),
(34335, '2017-06-18 12:45:54', NULL, NULL, 10192, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:45:54', 'admin-1497760327-14977611542142059', 1, 1, 'SR', NULL, NULL, NULL),
(34336, '2017-06-18 12:41:39', NULL, NULL, 10190, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:41:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34337, '2017-06-18 15:51:34', NULL, NULL, 10207, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 15:51:34', 'admin-1497764902-1497772293823753', 1, 1, 'SR', NULL, NULL, NULL),
(34338, '2017-06-18 15:10:45', NULL, NULL, 10205, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 15:10:45', 'admin-1497764902-14977698454892726', 1, 0, '', NULL, NULL, NULL),
(34339, '2017-06-18 15:51:34', NULL, NULL, 10207, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 15:51:34', 'admin-1497764902-1497772293823753', 1, 0, '', NULL, NULL, NULL),
(34340, '2017-06-18 15:51:34', NULL, NULL, 10207, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 15:51:34', 'admin-1497764902-1497772293823753', 1, 0, '', NULL, NULL, NULL),
(34341, '2017-06-18 15:42:41', NULL, NULL, 10207, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 15:42:41', 'admin-1497764902-14977717610301794', 1, 1, 'SR', NULL, NULL, NULL),
(34342, '2017-06-18 15:40:43', NULL, NULL, 10207, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 15:40:43', 'admin-1497764902-14977716430926364', 1, 1, 'SR', NULL, NULL, NULL),
(34343, '2017-06-18 15:46:58', NULL, NULL, 10207, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 15:46:58', 'admin-1497764902-14977720178551029', 1, 0, '', NULL, NULL, NULL),
(34344, '2017-06-18 15:40:20', NULL, NULL, 10207, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 15:40:20', 'admin-1497764902-14977716199419366', 1, 1, 'SR', NULL, NULL, NULL),
(34345, '2017-06-18 15:40:13', NULL, NULL, 10207, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.60, 0.0000, 0.0000, 9.60, 1, '27', 1, '1497764902', 'admin', '2017-06-18 15:40:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34346, '2017-06-18 15:40:08', NULL, NULL, 10206, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 15:40:08', 'admin-1497764902-14977716080803332', 1, 1, 'SR', NULL, NULL, NULL),
(34347, '2017-06-18 15:40:08', NULL, NULL, 10206, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 15:40:08', 'admin-1497764902-14977716080803332', 1, 1, 'SR', NULL, NULL, NULL),
(34348, '2017-06-18 15:41:12', NULL, NULL, 10206, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 15:41:12', 'admin-1497764902-14977716723379657', 1, 1, 'SR', NULL, NULL, NULL),
(34349, '2017-06-18 15:41:12', NULL, NULL, 10206, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 15:41:12', 'admin-1497764902-14977716723379657', 1, 1, 'SR', NULL, NULL, NULL),
(34350, '2017-06-18 15:39:18', NULL, NULL, 10206, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1497764902', 'admin', '2017-06-18 15:39:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34351, '2017-06-18 15:10:45', NULL, NULL, 10205, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 15:10:45', 'admin-1497764902-14977698454892726', 1, 0, '', NULL, NULL, NULL),
(34352, '2017-06-18 14:08:44', NULL, NULL, 10197, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 14:08:44', 'admin-1497764902-14977661245172526', 1, 1, 'SR', NULL, NULL, NULL),
(34353, '2017-06-18 13:48:58', NULL, NULL, 10200, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:48:58', 'admin-1497764902-14977649378594438', 1, 1, 'SR', NULL, NULL, NULL),
(34354, '2017-06-18 13:41:50', NULL, NULL, 10198, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:41:50', 'admin-1497762058-14977645097665571', 1, 0, '', NULL, NULL, NULL),
(34355, '2017-06-18 13:41:50', NULL, NULL, 10198, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:41:50', 'admin-1497762058-14977645097665571', 1, 0, '', NULL, NULL, NULL),
(34356, '2017-06-18 13:41:28', NULL, NULL, 10198, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:41:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34357, '2017-06-18 13:41:50', NULL, NULL, 10198, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:41:50', 'admin-1497762058-14977645097665571', 1, 0, '', NULL, NULL, NULL),
(34358, '2017-06-18 15:10:45', NULL, NULL, 10205, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 15:10:45', 'admin-1497764902-14977698454892726', 1, 1, 'SR', NULL, NULL, NULL),
(34359, '2017-06-18 14:54:28', NULL, NULL, 10203, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 14:54:28', 'admin-1497764902-1497768868456669', 1, 1, 'SR', NULL, NULL, NULL),
(34360, '2017-06-18 14:54:28', NULL, NULL, 10203, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 14:54:28', 'admin-1497764902-1497768868456669', 1, 0, '', NULL, NULL, NULL),
(34361, '2017-06-18 13:41:10', NULL, NULL, 10195, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:41:10', 'admin-1497762058-14977644704262184', 1, 1, 'SR', NULL, NULL, NULL),
(34362, '2017-06-18 12:48:23', NULL, NULL, 10193, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:48:23', 'admin-1497760327-14977613028011342', 1, 0, '', NULL, NULL, NULL),
(34363, '2017-06-18 14:54:20', NULL, NULL, 10203, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1497764902', 'admin', '2017-06-18 14:54:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34364, '2017-06-18 12:51:02', NULL, NULL, 10193, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:51:02', 'admin-1497760327-14977614620368080', 1, 1, 'SR', NULL, NULL, NULL),
(34365, '2017-06-18 15:10:45', NULL, NULL, 10205, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 15:10:45', 'admin-1497764902-14977698454892726', 1, 1, 'SR', NULL, NULL, NULL),
(34366, '2017-06-18 13:32:40', NULL, NULL, 10197, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:32:40', 'admin-1497762058-14977639599985889', 1, 1, 'SR', NULL, NULL, NULL),
(34367, '2017-06-18 13:32:40', NULL, NULL, 10197, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:32:40', 'admin-1497762058-14977639599985889', 1, 1, 'SR', NULL, NULL, NULL),
(34368, '2017-06-18 13:32:40', NULL, NULL, 10197, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:32:40', 'admin-1497762058-14977639599985889', 1, 1, 'SR', NULL, NULL, NULL),
(34369, '2017-06-18 13:32:40', NULL, NULL, 10197, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:32:40', 'admin-1497762058-14977639599985889', 1, 1, 'SR', NULL, NULL, NULL),
(34370, '2017-06-18 13:32:40', NULL, NULL, 10197, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:32:40', 'admin-1497762058-14977639599985889', 1, 0, '', NULL, NULL, NULL),
(34371, '2017-06-18 13:32:40', NULL, NULL, 10197, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:32:40', 'admin-1497762058-14977639599985889', 1, 1, 'SR', NULL, NULL, NULL),
(34372, '2017-06-18 13:32:40', NULL, NULL, 10197, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:32:40', 'admin-1497762058-14977639599985889', 1, 0, '', NULL, NULL, NULL),
(34373, '2017-06-18 13:32:40', NULL, NULL, 10197, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:32:40', 'admin-1497762058-14977639599985889', 1, 0, '', NULL, NULL, NULL),
(34374, '2017-06-18 13:32:40', NULL, NULL, 10197, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:32:40', 'admin-1497762058-14977639599985889', 1, 1, 'SR', NULL, NULL, NULL),
(34375, '2017-06-18 13:26:48', NULL, NULL, 10195, 0, 157, '91', 'French Toast with Fruits', 'No icing sugar', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:26:48', 'admin-1497762058-14977636086435537', 1, 0, '', NULL, NULL, NULL),
(34376, '2017-06-18 13:23:21', NULL, NULL, 10196, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:23:21', 'admin-1497762058-14977634009435320', 1, 1, 'SR', NULL, NULL, NULL),
(34377, '2017-06-18 13:00:39', NULL, NULL, 10194, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:00:39', 'admin-1497760327-14977620395746843', 1, 0, '', NULL, NULL, NULL),
(34378, '2017-06-18 13:01:10', NULL, NULL, 10194, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:01:10', 'admin-1497762058-14977620700327935', 1, 1, 'SR', NULL, NULL, NULL),
(34379, '2017-06-18 13:12:40', NULL, NULL, 10195, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:12:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34380, '2017-06-18 13:12:50', NULL, NULL, 10195, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:12:50', 'admin-1497762058-14977627702844284', 1, 1, 'SR', NULL, NULL, NULL),
(34381, '2017-06-18 13:12:50', NULL, NULL, 10195, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:12:50', 'admin-1497762058-14977627702844284', 1, 1, 'SR', NULL, NULL, NULL),
(34382, '2017-06-18 13:12:50', NULL, NULL, 10195, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:12:50', 'admin-1497762058-14977627702844284', 1, 0, '', NULL, NULL, NULL),
(34383, '2017-06-18 13:12:50', NULL, NULL, 10195, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:12:50', 'admin-1497762058-14977627702844284', 1, 1, 'SR', NULL, NULL, NULL),
(34384, '2017-06-18 13:00:39', NULL, NULL, 10194, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:00:39', 'admin-1497760327-14977620395746843', 1, 1, 'SR', NULL, NULL, NULL),
(34385, '2017-06-18 14:41:46', NULL, NULL, 10188, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 14:41:46', 'admin-1497764902-14977681061515818', 1, 0, '', NULL, NULL, NULL),
(34386, '2017-06-18 12:55:27', NULL, NULL, 10194, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:55:27', 'admin-1497760327-1497761727407268', 1, 0, '', NULL, NULL, NULL),
(34387, '2017-06-18 12:55:27', NULL, NULL, 10194, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:55:27', 'admin-1497760327-1497761727407268', 1, 1, 'SR', NULL, NULL, NULL),
(34388, '2017-06-18 12:55:07', NULL, NULL, 10194, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.70, 0.0000, 0.0000, 9.70, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:55:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34389, '2017-06-18 12:51:02', NULL, NULL, 10193, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:51:02', 'admin-1497760327-14977614620368080', 1, 1, 'SR', NULL, NULL, NULL),
(34390, '2017-06-18 12:51:02', NULL, NULL, 10193, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:51:02', 'admin-1497760327-14977614620368080', 1, 0, '', NULL, NULL, NULL),
(34391, '2017-06-18 12:48:33', NULL, NULL, 10193, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:48:33', 'admin-1497760327-14977613129312494', 1, 0, '', NULL, NULL, NULL),
(34392, '2017-06-18 12:48:23', NULL, NULL, 10193, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:48:23', 'admin-1497760327-14977613028011342', 1, 0, '', NULL, NULL, NULL),
(34393, '2017-06-18 12:48:23', NULL, NULL, 10193, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:48:23', 'admin-1497760327-14977613028011342', 1, 0, '', NULL, NULL, NULL),
(34394, '2017-06-18 12:48:23', NULL, NULL, 10193, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:48:23', 'admin-1497760327-14977613028011342', 1, 1, 'SR', NULL, NULL, NULL),
(34395, '2017-06-18 12:48:23', NULL, NULL, 10193, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:48:23', 'admin-1497760327-14977613028011342', 1, 1, 'SR', NULL, NULL, NULL),
(34396, '2017-06-18 12:43:30', NULL, NULL, 10191, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:43:30', 'admin-1497760327-14977610104478735', 1, 0, '', NULL, NULL, NULL),
(34397, '2017-06-18 12:31:59', NULL, NULL, 10188, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:31:59', 'admin-1497757804-14977603192493690', 1, 0, '', NULL, NULL, NULL),
(34398, '2017-06-18 12:48:09', NULL, NULL, 10193, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.90, 0.0000, 0.0000, 10.90, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:48:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34399, '2017-06-18 12:43:30', NULL, NULL, 10191, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:43:30', 'admin-1497760327-14977610104478735', 1, 0, '', NULL, NULL, NULL),
(34400, '2017-06-18 12:07:21', NULL, NULL, 10183, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:07:21', 'admin-1497757804-1497758841708497', 1, 0, '', NULL, NULL, NULL),
(34401, '2017-06-18 12:07:26', NULL, NULL, 10183, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:07:26', 'admin-1497757804-14977588465572498', 1, 1, 'SR', NULL, NULL, NULL),
(34402, '2017-06-18 12:13:38', NULL, NULL, 10184, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:13:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34403, '2017-06-18 12:21:50', NULL, NULL, 10185, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:21:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34404, '2017-06-18 12:22:59', NULL, NULL, 10185, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:22:59', 'admin-1497757804-14977597796711633', 1, 0, '', NULL, NULL, NULL),
(34405, '2017-06-18 12:22:59', NULL, NULL, 10185, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:22:59', 'admin-1497757804-14977597796711633', 1, 0, '', NULL, NULL, NULL),
(34406, '2017-06-18 12:22:59', NULL, NULL, 10185, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:22:59', 'admin-1497757804-14977597796711633', 1, 0, '', NULL, NULL, NULL),
(34407, '2017-06-18 12:43:30', NULL, NULL, 10191, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:43:30', 'admin-1497760327-14977610104478735', 1, 1, 'SR', NULL, NULL, NULL),
(34408, '2017-06-18 12:43:30', NULL, NULL, 10191, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:43:30', 'admin-1497760327-14977610104478735', 1, 1, 'SR', NULL, NULL, NULL),
(34409, '2017-06-18 12:43:00', NULL, NULL, 10191, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:43:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34410, '2017-06-18 12:22:59', NULL, NULL, 10185, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:22:59', 'admin-1497757804-14977597796711633', 1, 1, 'SR', NULL, NULL, NULL),
(34411, '2017-06-18 12:41:52', NULL, NULL, 10190, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:41:52', 'admin-1497760327-14977609123236297', 1, 1, 'SR', NULL, NULL, NULL),
(34412, '2017-06-18 13:23:21', NULL, NULL, 10196, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:23:21', 'admin-1497762058-14977634009435320', 1, 1, 'SR', NULL, NULL, NULL),
(34413, '2017-06-18 12:36:38', NULL, NULL, 10189, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:36:38', 'admin-1497760327-1497760597901632', 1, 0, '', NULL, NULL, NULL),
(34414, '2017-06-18 12:35:58', NULL, NULL, 10189, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:35:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34415, '2017-06-18 12:31:59', NULL, NULL, 10188, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:31:59', 'admin-1497757804-14977603192493690', 1, 1, 'SR', NULL, NULL, NULL),
(34416, '2017-06-18 12:31:59', NULL, NULL, 10188, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:31:59', 'admin-1497757804-14977603192493690', 1, 0, '', NULL, NULL, NULL),
(34417, '2017-06-18 12:31:59', NULL, NULL, 10188, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:31:59', 'admin-1497757804-14977603192493690', 1, 0, '', NULL, NULL, NULL),
(34418, '2017-06-18 12:28:11', NULL, NULL, 10186, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:28:11', 'admin-1497757804-14977600914844137', 1, 0, '', NULL, NULL, NULL),
(34419, '2017-06-18 12:28:11', NULL, NULL, 10186, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:28:11', 'admin-1497757804-14977600914844137', 1, 0, '', NULL, NULL, NULL),
(34420, '2017-06-18 12:28:11', NULL, NULL, 10186, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:28:11', 'admin-1497757804-14977600914844137', 1, 0, '', NULL, NULL, NULL),
(34421, '2017-06-18 12:29:21', NULL, NULL, 10177, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:29:21', 'admin-1497757804-14977601610134994', 1, 0, '', NULL, NULL, NULL),
(34422, '2017-06-18 12:31:05', NULL, NULL, 10187, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:31:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34423, '2017-06-18 12:31:25', NULL, NULL, 10187, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:31:25', 'admin-1497757804-14977602848045139', 1, 0, '', NULL, NULL, NULL),
(34424, '2017-06-18 12:31:25', NULL, NULL, 10187, 0, 32, '32', 'Tea By Pot ', 'strawberry', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:31:25', 'admin-1497757804-14977602848045139', 1, 1, 'SR', NULL, NULL, NULL),
(34425, '2017-06-18 12:31:28', NULL, NULL, 10188, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:31:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34426, '2017-06-18 12:27:54', NULL, NULL, 10186, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:27:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34427, '2017-06-18 12:14:05', NULL, NULL, 10184, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:14:05', 'admin-1497757804-14977592452907265', 1, 1, 'SR', NULL, NULL, NULL),
(34428, '2017-06-18 12:14:05', NULL, NULL, 10184, 0, 182, '117', 'Open Drinks ', 'lemon water', 'Cold Drinks', 'Fresh Juice', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:14:05', 'admin-1497757804-14977592452907265', 1, 0, '', NULL, NULL, NULL),
(34429, '2017-06-18 11:53:41', NULL, NULL, 10181, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:53:41', 'admin-1497757804-14977580214308196', 1, 1, 'SR', NULL, NULL, NULL),
(34430, '2017-06-18 12:06:43', NULL, NULL, 10183, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1497764902', 'admin', '2017-06-18 12:06:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34431, '2017-06-18 11:22:13', NULL, NULL, 10175, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:22:13', 'admin-1497751365-14977561335689373', 1, 0, '', NULL, NULL, NULL),
(34432, '2017-06-18 11:22:13', NULL, NULL, 10175, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:22:13', 'admin-1497751365-14977561335689373', 1, 0, '', NULL, NULL, NULL),
(34433, '2017-06-18 11:22:18', NULL, NULL, 10175, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:22:18', 'admin-1497751365-14977561385685652', 1, 1, 'SR', NULL, NULL, NULL),
(34434, '2017-06-18 11:22:18', NULL, NULL, 10175, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:22:18', 'admin-1497751365-14977561385685652', 1, 1, 'SR', NULL, NULL, NULL),
(34435, '2017-06-18 11:22:36', NULL, NULL, 10176, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:22:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34436, '2017-06-18 11:22:57', NULL, NULL, 10176, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:22:57', 'admin-1497751365-14977561772452385', 1, 0, '', NULL, NULL, NULL),
(34437, '2017-06-18 11:22:57', NULL, NULL, 10176, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:22:57', 'admin-1497751365-14977561772452385', 1, 0, '', NULL, NULL, NULL),
(34438, '2017-06-18 11:22:57', NULL, NULL, 10176, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:22:57', 'admin-1497751365-14977561772452385', 1, 0, '', NULL, NULL, NULL),
(34439, '2017-06-18 11:35:39', NULL, NULL, 10177, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:35:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34440, '2017-06-18 11:35:53', NULL, NULL, 10177, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:35:53', 'admin-1497751365-14977569534689983', 1, 0, '', NULL, NULL, NULL),
(34441, '2017-06-18 11:35:53', NULL, NULL, 10177, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:35:53', 'admin-1497751365-14977569534689983', 1, 0, '', NULL, NULL, NULL),
(34442, '2017-06-18 11:35:53', NULL, NULL, 10177, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:35:53', 'admin-1497751365-14977569534689983', 1, 1, 'SR', NULL, NULL, NULL),
(34443, '2017-06-18 11:36:04', NULL, NULL, 10177, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:36:04', 'admin-1497751365-14977569639693899', 1, 1, 'SR', NULL, NULL, NULL),
(34444, '2017-06-18 10:07:58', NULL, NULL, 10172, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 10:07:58', 'admin-1497751365-14977516783612247', 1, 1, 'SR', NULL, NULL, NULL),
(34445, '2017-06-18 10:16:42', NULL, NULL, 10168, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 10:16:42', 'admin-1497751365-14977522024402776', 1, 0, '', NULL, NULL, NULL),
(34446, '2017-06-18 13:48:58', NULL, NULL, 10200, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:48:58', 'admin-1497764902-14977649378594438', 1, 0, '', NULL, NULL, NULL),
(34447, '2017-06-18 13:23:21', NULL, NULL, 10196, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:23:21', 'admin-1497762058-14977634009435320', 1, 1, 'SR', NULL, NULL, NULL),
(34448, '2017-06-18 11:51:46', NULL, NULL, 10181, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:51:46', 'admin-1497757804-14977579061827454', 1, 1, 'SR', NULL, NULL, NULL),
(34449, '2017-06-18 09:44:58', NULL, NULL, 10170, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:44:58', 'admin-1497747858-14977502979274570', 1, 0, '', NULL, NULL, NULL),
(34450, '2017-06-18 09:47:53', NULL, NULL, 10170, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:47:53', 'admin-1497747858-14977504731998189', 1, 0, '', NULL, NULL, NULL),
(34451, '2017-06-18 10:02:06', NULL, NULL, 10171, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 10:02:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34452, '2017-06-18 10:02:19', NULL, NULL, 10171, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 10:02:19', 'admin-1497747858-14977513392916338', 1, 0, '', NULL, NULL, NULL),
(34453, '2017-06-18 10:02:19', NULL, NULL, 10171, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 10:02:19', 'admin-1497747858-14977513392916338', 1, 0, '', NULL, NULL, NULL),
(34454, '2017-06-18 10:03:06', NULL, NULL, 10171, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 10:03:06', 'admin-1497751365-14977513868221029', 1, 1, 'SR', NULL, NULL, NULL),
(34455, '2017-06-18 13:52:51', NULL, NULL, 10201, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1497764902', 'admin', '2017-06-18 13:52:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34456, '2017-06-18 11:51:46', NULL, NULL, 10181, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:51:46', 'admin-1497757804-14977579061827454', 1, 0, '', NULL, NULL, NULL),
(34457, '2017-06-18 11:49:59', NULL, NULL, 10180, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:49:59', 'admin-1497751365-14977577996689143', 1, 0, '', NULL, NULL, NULL),
(34458, '2017-06-18 11:49:59', NULL, NULL, 10180, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:49:59', 'admin-1497751365-14977577996689143', 1, 0, '', NULL, NULL, NULL),
(34459, '2017-06-18 11:50:14', NULL, NULL, 10180, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:50:14', 'admin-1497757804-14977578141817593', 1, 0, '', NULL, NULL, NULL),
(34460, '2017-06-18 11:50:14', NULL, NULL, 10180, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:50:14', 'admin-1497757804-14977578141817593', 1, 0, '', NULL, NULL, NULL),
(34461, '2017-06-18 11:51:36', NULL, NULL, 10181, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.30, 0.0000, 0.0000, 11.30, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:51:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34462, '2017-06-18 10:35:29', NULL, NULL, 10173, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1497764902', 'admin', '2017-06-18 10:35:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34463, '2017-06-18 10:35:38', NULL, NULL, 10173, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 10:35:38', 'admin-1497751365-14977533384926326', 1, 0, '', NULL, NULL, NULL),
(34464, '2017-06-18 09:07:09', NULL, NULL, 10167, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:07:09', 'admin-1497747858-14977480292409886', 1, 0, '', NULL, NULL, NULL),
(34465, '2017-06-18 09:07:09', NULL, NULL, 10167, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:07:09', 'admin-1497747858-14977480292409886', 1, 0, '', NULL, NULL, NULL),
(34466, '2017-06-18 09:07:09', NULL, NULL, 10167, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:07:09', 'admin-1497747858-14977480292409886', 1, 0, '', NULL, NULL, NULL),
(34467, '2017-06-18 09:07:48', NULL, NULL, 10167, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:07:48', 'admin-1497747858-14977480687119758', 1, 1, 'SR', NULL, NULL, NULL),
(34468, '2017-06-18 09:14:20', NULL, NULL, 10168, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:14:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34469, '2017-06-18 09:14:29', NULL, NULL, 10168, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:14:29', 'admin-1497747858-14977484695204272', 1, 0, '', NULL, NULL, NULL),
(34470, '2017-06-18 09:14:29', NULL, NULL, 10168, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:14:29', 'admin-1497747858-14977484695204272', 1, 0, '', NULL, NULL, NULL),
(34471, '2017-06-18 09:14:29', NULL, NULL, 10168, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:14:29', 'admin-1497747858-14977484695204272', 1, 0, '', NULL, NULL, NULL),
(34472, '2017-06-18 09:14:33', NULL, NULL, 10168, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:14:33', 'admin-1497747858-14977484737854849', 1, 1, 'SR', NULL, NULL, NULL),
(34473, '2017-06-18 09:31:22', NULL, NULL, 10169, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:31:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34474, '2017-06-18 09:31:32', NULL, NULL, 10169, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:31:32', 'admin-1497747858-1497749491844177', 1, 1, 'SR', NULL, NULL, NULL),
(34475, '2017-06-18 09:31:32', NULL, NULL, 10169, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:31:32', 'admin-1497747858-1497749491844177', 1, 0, '', NULL, NULL, NULL),
(34476, '2017-06-18 11:49:52', NULL, NULL, 10180, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:49:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34477, '2017-06-18 11:39:36', NULL, NULL, 10179, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:39:36', 'admin-1497751365-14977571762945517', 1, 0, '', NULL, NULL, NULL),
(34478, '2017-06-18 11:39:36', NULL, NULL, 10179, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:39:36', 'admin-1497751365-14977571762945517', 1, 0, '', NULL, NULL, NULL),
(34479, '2017-06-18 11:39:28', NULL, NULL, 10179, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:39:28', 'admin-1497751365-1497757167938837', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(34480, '2017-06-18 11:39:22', NULL, NULL, 10179, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:39:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34481, '2017-06-18 11:37:58', NULL, NULL, 10178, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:37:58', 'admin-1497751365-14977570787426088', 1, 1, 'SR', NULL, NULL, NULL),
(34482, '2017-06-18 11:37:49', NULL, NULL, 10178, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:37:49', 'admin-1497751365-14977570693318042', 1, 0, '', NULL, NULL, NULL),
(34483, '2017-06-18 11:37:38', NULL, NULL, 10178, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:37:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34484, '2017-06-18 11:37:49', NULL, NULL, 10178, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:37:49', 'admin-1497751365-14977570693318042', 1, 0, '', NULL, NULL, NULL),
(34485, '2017-06-18 11:36:04', NULL, NULL, 10177, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:36:04', 'admin-1497751365-14977569639693899', 1, 1, 'SR', NULL, NULL, NULL),
(34486, '2017-06-18 10:46:22', NULL, NULL, 10174, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 10:46:22', 'admin-1497751365-14977539823591150', 1, 1, 'SR', 1, NULL, NULL),
(34487, '2017-06-18 11:22:05', NULL, NULL, 10175, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 11:22:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34488, '2017-06-18 10:35:38', NULL, NULL, 10173, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 10:35:38', 'admin-1497751365-14977533384926326', 1, 1, 'SR', NULL, NULL, NULL),
(34489, '2017-06-18 10:46:22', NULL, NULL, 10174, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 10:46:22', 'admin-1497751365-14977539823591150', 1, 1, 'SR', 1, NULL, NULL),
(34490, '2017-06-18 10:07:04', NULL, NULL, 10172, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1497764902', 'admin', '2017-06-18 10:07:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34491, '2017-06-18 10:07:32', NULL, NULL, 10172, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 10:07:32', 'admin-1497751365-14977516525646058', 1, 0, '', NULL, NULL, NULL),
(34492, '2017-06-18 10:07:32', NULL, NULL, 10172, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 10:07:32', 'admin-1497751365-14977516525646058', 1, 0, '', NULL, NULL, NULL),
(34493, '2017-06-18 10:07:32', NULL, NULL, 10172, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 10:07:32', 'admin-1497751365-14977516525646058', 1, 0, '', NULL, NULL, NULL),
(34494, '2017-06-18 10:07:58', NULL, NULL, 10172, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 10:07:58', 'admin-1497751365-14977516783612247', 1, 1, 'SR', NULL, NULL, NULL),
(34495, '2017-06-18 10:03:06', NULL, NULL, 10171, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 10:03:06', 'admin-1497751365-14977513868221029', 1, 1, 'SR', NULL, NULL, NULL),
(34496, '2017-06-18 09:44:27', NULL, NULL, 10170, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:44:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34497, '2017-06-18 09:44:40', NULL, NULL, 10170, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:44:40', 'admin-1497747858-14977502803386442', 1, 0, '', NULL, NULL, NULL),
(34498, '2017-06-18 09:44:40', NULL, NULL, 10170, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:44:40', 'admin-1497747858-14977502803386442', 1, 0, '', NULL, NULL, NULL),
(34499, '2017-06-18 09:44:40', NULL, NULL, 10170, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:44:40', 'admin-1497747858-14977502803386442', 1, 0, '', NULL, NULL, NULL),
(34500, '2017-06-18 09:44:58', NULL, NULL, 10170, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:44:58', 'admin-1497747858-14977502979274570', 1, 1, 'SR', NULL, NULL, NULL),
(34501, '2017-06-18 09:36:26', NULL, NULL, 10169, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:36:26', 'admin-1497747858-14977497862315647', 1, 0, '', NULL, NULL, NULL),
(34502, '2017-06-18 09:31:32', NULL, NULL, 10169, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:31:32', 'admin-1497747858-1497749491844177', 1, 1, 'SR', NULL, NULL, NULL),
(34503, '2017-06-18 09:36:26', NULL, NULL, 10169, 0, 153, '87', 'Wake Me Up!', 'no salad', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:36:26', 'admin-1497747858-14977497862315647', 1, 0, '', NULL, NULL, NULL),
(34504, '2017-06-18 09:07:03', NULL, NULL, 10167, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1497764902', 'admin', '2017-06-18 09:07:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34505, '2017-06-19 15:19:29', NULL, NULL, 10242, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1497854525', 'admin', '2017-06-19 15:19:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34506, '2017-06-19 13:24:44', NULL, NULL, 10232, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 13:24:44', 'admin-1497844586-14978498845733514', 1, 0, '', NULL, NULL, NULL),
(34507, '2017-06-19 13:24:49', NULL, NULL, 10232, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 13:24:49', 'admin-1497844586-14978498891974065', 1, 1, 'SR', NULL, NULL, NULL),
(34508, '2017-06-19 13:24:49', NULL, NULL, 10232, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 13:24:49', 'admin-1497844586-14978498891974065', 1, 1, 'SR', NULL, NULL, NULL),
(34509, '2017-06-19 13:28:26', NULL, NULL, 10230, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 13:28:26', 'admin-1497844586-14978501062022699', 1, 0, '', NULL, NULL, NULL),
(34510, '2017-06-19 00:00:00', NULL, NULL, 10233, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 11:56:42', 'admin-1497844586-14978446026029075', 1, 1, 'SR', NULL, NULL, NULL),
(34511, '2017-06-19 13:24:44', NULL, NULL, 10232, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 13:24:44', 'admin-1497844586-14978498845733514', 1, 1, 'SR', NULL, NULL, NULL),
(34512, '2017-06-19 15:19:35', NULL, NULL, 10242, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 15:19:35', 'admin-1497854525-14978567748739967', 1, 0, '', NULL, NULL, NULL),
(34513, '2017-06-19 14:18:01', NULL, NULL, 10239, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 14:18:01', 'admin-1497850339-1497853081625505', 1, 0, '', NULL, NULL, NULL),
(34514, '2017-06-19 14:19:07', NULL, NULL, 10239, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 14:19:07', 'admin-1497850339-14978531475572266', 1, 1, 'SR', NULL, NULL, NULL),
(34515, '2017-06-19 14:21:21', NULL, NULL, 10239, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 14:21:21', 'admin-1497850339-14978532811007454', 1, 0, '', NULL, NULL, NULL),
(34516, '2017-06-19 14:21:21', NULL, NULL, 10239, 0, 158, '92', 'Banana Stuffed Nutella Toast ', 'Serve Later', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 14:21:21', 'admin-1497850339-14978532811007454', 1, 0, '', NULL, NULL, NULL),
(34517, '2017-06-19 14:21:21', NULL, NULL, 10239, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 14:21:21', 'admin-1497850339-14978532811007454', 1, 1, 'SR', NULL, NULL, NULL),
(34518, '2017-06-19 13:10:14', NULL, NULL, 10231, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1497854525', 'admin', '2017-06-19 13:10:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34519, '2017-06-19 13:10:27', NULL, NULL, 10231, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 13:10:27', 'admin-1497844586-1497849027479612', 1, 0, '', NULL, NULL, NULL),
(34520, '2017-06-19 13:10:27', NULL, NULL, 10231, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 13:10:27', 'admin-1497844586-1497849027479612', 1, 0, '', NULL, NULL, NULL),
(34521, '2017-06-19 13:10:27', NULL, NULL, 10231, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 13:10:27', 'admin-1497844586-1497849027479612', 1, 0, '', NULL, NULL, NULL),
(34522, '2017-06-19 13:10:36', NULL, NULL, 10231, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 13:10:36', 'admin-1497844586-14978490367682373', 1, 1, 'SR', NULL, NULL, NULL),
(34523, '2017-06-19 13:10:36', NULL, NULL, 10231, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 13:10:36', 'admin-1497844586-14978490367682373', 1, 1, 'SR', NULL, NULL, NULL),
(34524, '2017-06-19 10:38:25', NULL, NULL, 10220, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:38:25', 'admin-1497836447-14978399056725168', 1, 1, 'SR', NULL, NULL, NULL),
(34525, '2017-06-19 11:29:23', NULL, NULL, 10226, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1497854525', 'admin', '2017-06-19 11:29:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34526, '2017-06-19 10:40:45', NULL, NULL, 10222, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.95, 0.0000, 0.0000, 5.95, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:40:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34527, '2017-06-19 13:10:36', NULL, NULL, 10231, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 13:10:36', 'admin-1497844586-14978490367682373', 1, 1, 'SR', NULL, NULL, NULL),
(34528, '2017-06-19 00:00:00', NULL, NULL, 10235, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 11:56:42', 'admin-1497844586-14978446026029075', 1, 1, 'SR', NULL, NULL, NULL),
(34529, '2017-06-19 13:45:28', NULL, NULL, 10238, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1497854525', 'admin', '2017-06-19 13:45:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34530, '2017-06-19 13:31:50', NULL, NULL, 10235, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 13:31:50', 'admin-1497844586-14978503101542973', 1, 0, '', NULL, NULL, NULL),
(34531, '2017-06-19 14:17:59', NULL, NULL, 10239, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.70, 0.0000, 0.0000, 9.70, 1, '27', 1, '1497854525', 'admin', '2017-06-19 14:17:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34532, '2017-06-19 14:22:01', NULL, NULL, 10240, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 14:22:01', 'admin-1497850339-14978533217112374', 1, 1, 'SR', NULL, NULL, NULL),
(34533, '2017-06-19 14:22:01', NULL, NULL, 10240, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 14:22:01', 'admin-1497850339-14978533217112374', 1, 1, 'SR', NULL, NULL, NULL),
(34534, '2017-06-19 14:27:49', NULL, NULL, 10222, 0, 80, '80', 'Oriental Chicken Salad', 'add 1 hard boiled egg,add 1 hard boiled egg', 'Meals', 'Perfect Meals', 1, 22.50, 22.5000, 0.0000, 22.50, 1, '27', 1, '1497854525', 'admin', '2017-06-19 14:27:49', 'admin-1497850339-14978536697363271', 1, 1, 'SR', NULL, NULL, NULL),
(34535, '2017-06-19 14:27:49', NULL, NULL, 10222, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 14:27:49', 'admin-1497850339-14978536697363271', 1, 1, 'SR', NULL, NULL, NULL),
(34536, '2017-06-19 14:35:57', NULL, NULL, 10241, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1497854525', 'admin', '2017-06-19 14:35:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34537, '2017-06-19 14:36:09', NULL, NULL, 10241, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 14:36:09', 'admin-1497850339-14978541691567452', 1, 0, '', NULL, NULL, NULL),
(34538, '2017-06-19 14:36:09', NULL, NULL, 10241, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 14:36:09', 'admin-1497850339-14978541691567452', 1, 0, '', NULL, NULL, NULL),
(34539, '2017-06-19 14:36:09', NULL, NULL, 10241, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 14:36:09', 'admin-1497850339-14978541691567452', 1, 0, '', NULL, NULL, NULL),
(34540, '2017-06-19 14:50:31', NULL, NULL, 10226, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 14:50:31', 'admin-1497854525-14978550315313510', 1, 0, '', NULL, NULL, NULL),
(34541, '2017-06-19 15:03:27', NULL, NULL, 10240, 0, 181, '116', 'Open Food ', 'Scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 15:03:27', 'admin-1497854525-14978558071417865', 1, 0, '', NULL, NULL, NULL),
(34542, '2017-06-19 15:36:35', NULL, NULL, 10243, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 15:36:35', 'admin-1497854525-14978577957427360', 1, 0, '', 1, NULL, NULL),
(34543, '2017-06-19 16:50:20', NULL, NULL, 10245, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 16:50:20', 'admin-1497854525-14978622206435649', 1, 1, 'SR', 1, NULL, NULL),
(34544, '2017-06-19 13:42:41', NULL, NULL, 10237, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1497854525', 'admin', '2017-06-19 13:42:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34545, '2017-06-19 13:30:53', NULL, NULL, 10235, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1497854525', 'admin', '2017-06-19 13:30:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34546, '2017-06-19 13:45:32', NULL, NULL, 10238, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 13:45:32', 'admin-1497850339-1497851132172632', 1, 1, 'SR', NULL, NULL, NULL),
(34547, '2017-06-19 13:29:02', NULL, NULL, 10233, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1497854525', 'admin', '2017-06-19 13:29:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34548, '2017-06-19 13:42:46', NULL, NULL, 10237, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 13:42:46', 'admin-1497850339-14978509659017180', 1, 0, '', NULL, NULL, NULL),
(34549, '2017-06-19 15:36:35', NULL, NULL, 10243, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 15:36:35', 'admin-1497854525-14978577957427360', 1, 1, 'SR', 1, NULL, NULL),
(34550, '2017-06-19 15:19:35', NULL, NULL, 10242, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 15:19:35', 'admin-1497854525-14978567748739967', 1, 1, 'SR', NULL, NULL, NULL),
(34551, '2017-06-19 15:13:01', NULL, NULL, 10232, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 15:13:01', 'admin-1497854525-1497856381171698', 1, 0, '', NULL, NULL, NULL),
(34552, '2017-06-19 14:21:55', NULL, NULL, 10240, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1497854525', 'admin', '2017-06-19 14:21:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34553, '2017-06-19 10:40:59', NULL, NULL, 10223, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:40:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34554, '2017-06-19 10:41:09', NULL, NULL, 10223, 0, 154, '88', 'Daily Dose BLT', 'no egg', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:41:09', 'admin-1497836447-14978400691767649', 1, 0, '', NULL, NULL, NULL),
(34555, '2017-06-19 10:41:09', NULL, NULL, 10223, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:41:09', 'admin-1497836447-14978400691767649', 1, 1, 'SR', NULL, NULL, NULL),
(34556, '2017-06-19 10:46:07', NULL, NULL, 10224, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:46:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34557, '2017-06-19 10:46:18', NULL, NULL, 10224, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:46:18', 'admin-1497836447-1497840378310994', 1, 0, '', NULL, NULL, NULL),
(34558, '2017-06-19 10:46:18', NULL, NULL, 10224, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:46:18', 'admin-1497836447-1497840378310994', 1, 0, '', NULL, NULL, NULL),
(34559, '2017-06-19 10:46:18', NULL, NULL, 10224, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:46:18', 'admin-1497836447-1497840378310994', 1, 0, '', NULL, NULL, NULL),
(34560, '2017-06-19 10:46:23', NULL, NULL, 10224, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:46:23', 'admin-1497836447-1497840382920132', 1, 1, 'SR', NULL, NULL, NULL),
(34561, '2017-06-19 10:46:23', NULL, NULL, 10224, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:46:23', 'admin-1497836447-1497840382920132', 1, 1, 'SR', NULL, NULL, NULL),
(34562, '2017-06-19 10:48:15', NULL, NULL, 10225, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:48:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34563, '2017-06-19 10:48:36', NULL, NULL, 10225, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:48:36', 'admin-1497836447-14978405165881463', 1, 0, '', NULL, NULL, NULL),
(34564, '2017-06-19 10:48:36', NULL, NULL, 10225, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:48:36', 'admin-1497836447-14978405165881463', 1, 0, '', NULL, NULL, NULL),
(34565, '2017-06-19 10:48:36', NULL, NULL, 10225, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:48:36', 'admin-1497836447-14978405165881463', 1, 1, 'SR', NULL, NULL, NULL),
(34566, '2017-06-19 10:48:36', NULL, NULL, 10225, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:48:36', 'admin-1497836447-14978405165881463', 1, 1, 'SR', NULL, NULL, NULL),
(34567, '2017-06-19 11:29:32', NULL, NULL, 10226, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 2, 15.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 11:29:32', 'admin-1497836447-14978429719452976', 1, 0, '', NULL, NULL, NULL),
(34568, '2017-06-19 11:29:32', NULL, NULL, 10226, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 11:29:32', 'admin-1497836447-14978429719452976', 1, 1, 'SR', NULL, NULL, NULL),
(34569, '2017-06-19 14:21:21', NULL, NULL, 10239, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 14:21:21', 'admin-1497850339-14978532811007454', 1, 1, 'SR', NULL, NULL, NULL),
(34570, '2017-06-19 00:00:00', NULL, NULL, 10234, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 11:56:21', 'admin-1497836447-14978445807234668', 1, 1, 'SR', NULL, NULL, NULL),
(34571, '2017-06-19 12:21:14', NULL, NULL, 10229, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 12:21:14', 'admin-1497844586-14978460744079131', 1, 1, 'SR', NULL, NULL, NULL),
(34572, '2017-06-19 09:09:17', NULL, NULL, 10213, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:09:17', 'admin-1497834116-14978345571231022', 1, 0, '', NULL, NULL, NULL),
(34573, '2017-06-19 09:09:46', NULL, NULL, 10214, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:09:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34574, '2017-06-19 09:09:52', NULL, NULL, 10214, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:09:52', 'admin-1497834116-14978345923952695', 1, 0, '', NULL, NULL, NULL),
(34575, '2017-06-19 09:09:52', NULL, NULL, 10214, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:09:52', 'admin-1497834116-14978345923952695', 1, 0, '', NULL, NULL, NULL),
(34576, '2017-06-19 09:13:23', NULL, NULL, 10215, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:13:23', 'admin-1497834116-14978348037583218', 1, 0, '', 1, NULL, NULL),
(34577, '2017-06-19 09:13:23', NULL, NULL, 10215, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:13:23', 'admin-1497834116-14978348037583218', 1, 1, 'SR', 1, NULL, NULL),
(34578, '2017-06-19 13:24:05', NULL, NULL, 10232, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1497854525', 'admin', '2017-06-19 13:24:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34579, '2017-06-19 12:25:33', NULL, NULL, 10229, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 12:25:33', 'admin-1497844586-14978463330245214', 1, 1, 'SR', NULL, NULL, NULL),
(34580, '2017-06-19 12:25:33', NULL, NULL, 10229, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 12:25:33', 'admin-1497844586-14978463330245214', 1, 1, 'SR', NULL, NULL, NULL),
(34581, '2017-06-19 12:35:26', NULL, NULL, 10230, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1497854525', 'admin', '2017-06-19 12:35:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34582, '2017-06-19 12:35:31', NULL, NULL, 10230, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 12:35:31', 'admin-1497844586-14978469314117121', 1, 1, 'SR', NULL, NULL, NULL),
(34583, '2017-06-19 12:50:59', NULL, NULL, 10229, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 12:50:59', 'admin-1497844586-14978478594535856', 1, 0, '', NULL, NULL, NULL),
(34584, '2017-06-19 09:22:54', NULL, NULL, 10216, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:22:54', 'admin-1497834116-1497835374065216', 1, 0, '', NULL, NULL, NULL),
(34585, '2017-06-19 09:22:54', NULL, NULL, 10216, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:22:54', 'admin-1497834116-1497835374065216', 1, 0, '', NULL, NULL, NULL),
(34586, '2017-06-19 09:31:07', NULL, NULL, 10216, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:31:07', 'admin-1497834116-14978358671703769', 1, 0, '', NULL, NULL, NULL),
(34587, '2017-06-19 09:35:26', NULL, NULL, 10212, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:35:26', 'admin-1497834116-14978361261939874', 1, 0, '', NULL, NULL, NULL),
(34588, '2017-06-19 09:40:31', NULL, NULL, 10217, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:40:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34589, '2017-06-19 09:40:36', NULL, NULL, 10217, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:40:36', 'admin-1497834116-14978364362347237', 1, 0, '', NULL, NULL, NULL),
(34590, '2017-06-19 09:40:36', NULL, NULL, 10217, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:40:36', 'admin-1497834116-14978364362347237', 1, 0, '', NULL, NULL, NULL),
(34591, '2017-06-19 09:41:01', NULL, NULL, 10217, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:41:01', 'admin-1497836447-14978364618154285', 1, 1, 'SR', NULL, NULL, NULL),
(34592, '2017-06-19 09:41:01', NULL, NULL, 10217, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:41:01', 'admin-1497836447-14978364618154285', 1, 1, 'SR', NULL, NULL, NULL),
(34593, '2017-06-19 10:27:38', NULL, NULL, 10218, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:27:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34594, '2017-06-19 10:27:48', NULL, NULL, 10218, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:27:48', 'admin-1497836447-1497839268579863', 1, 1, 'SR', NULL, NULL, NULL),
(34595, '2017-06-19 10:27:48', NULL, NULL, 10218, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:27:48', 'admin-1497836447-1497839268579863', 1, 0, '', NULL, NULL, NULL),
(34596, '2017-06-19 10:32:29', NULL, NULL, 10219, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:32:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34597, '2017-06-19 12:21:14', NULL, NULL, 10229, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 12:21:14', 'admin-1497844586-14978460744079131', 1, 1, 'SR', NULL, NULL, NULL),
(34598, '2017-06-19 12:21:09', NULL, NULL, 10229, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1497854525', 'admin', '2017-06-19 12:21:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34599, '2017-06-19 12:02:29', NULL, NULL, 10228, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 12:02:29', 'admin-1497844586-1497844949020535', 1, 1, 'SR', NULL, NULL, NULL),
(34600, '2017-06-19 00:00:00', NULL, NULL, 10235, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 11:56:21', 'admin-1497836447-14978445807234668', 1, 0, '', NULL, NULL, NULL),
(34601, '2017-06-19 12:02:10', NULL, NULL, 10228, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1497854525', 'admin', '2017-06-19 12:02:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34602, '2017-06-19 12:02:29', NULL, NULL, 10228, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 12:02:29', 'admin-1497844586-1497844949020535', 1, 0, '', NULL, NULL, NULL),
(34603, '2017-06-19 13:30:13', NULL, NULL, 10234, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1497854525', 'admin', '2017-06-19 13:30:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34604, '2017-06-19 00:00:00', NULL, NULL, 10233, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 11:56:21', 'admin-1497836447-14978445807234668', 1, 0, '', NULL, NULL, NULL),
(34605, '2017-06-19 00:00:00', NULL, NULL, 10234, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 11:56:42', 'admin-1497844586-14978446026029075', 1, 0, '', NULL, NULL, NULL),
(34606, '2017-06-19 11:29:32', NULL, NULL, 10226, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 11:29:32', 'admin-1497836447-14978429719452976', 1, 1, 'SR', NULL, NULL, NULL),
(34607, '2017-06-19 10:40:52', NULL, NULL, 10222, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:40:52', 'admin-1497836447-14978400522926098', 1, 1, 'SR', NULL, NULL, NULL),
(34608, '2017-06-19 10:40:52', NULL, NULL, 10222, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:40:52', 'admin-1497836447-14978400522926098', 1, 0, '', NULL, NULL, NULL),
(34609, '2017-06-19 10:32:37', NULL, NULL, 10219, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:32:37', 'admin-1497836447-14978395574308346', 1, 0, '', NULL, NULL, NULL),
(34610, '2017-06-19 10:32:37', NULL, NULL, 10219, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:32:37', 'admin-1497836447-14978395574308346', 1, 0, '', NULL, NULL, NULL),
(34611, '2017-06-19 10:32:42', NULL, NULL, 10219, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:32:42', 'admin-1497836447-14978395625088618', 1, 1, 'SR', NULL, NULL, NULL),
(34612, '2017-06-19 10:32:42', NULL, NULL, 10219, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:32:42', 'admin-1497836447-14978395625088618', 1, 1, 'SR', NULL, NULL, NULL),
(34613, '2017-06-19 10:38:21', NULL, NULL, 10220, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:38:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34614, '2017-06-19 10:38:25', NULL, NULL, 10220, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 10:38:25', 'admin-1497836447-14978399056725168', 1, 1, 'SR', NULL, NULL, NULL),
(34615, '2017-06-19 09:08:56', NULL, NULL, 10213, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:08:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34616, '2017-06-19 09:09:08', NULL, NULL, 10213, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:09:08', 'admin-1497834116-14978345487461184', 1, 0, '', NULL, NULL, NULL),
(34617, '2017-06-19 09:09:08', NULL, NULL, 10213, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:09:08', 'admin-1497834116-14978345487461184', 1, 0, '', NULL, NULL, NULL),
(34618, '2017-06-19 09:09:17', NULL, NULL, 10213, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:09:17', 'admin-1497834116-14978345571231022', 1, 1, 'SR', NULL, NULL, NULL),
(34619, '2017-06-19 09:22:46', NULL, NULL, 10216, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:22:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34620, '2017-06-19 09:06:09', NULL, NULL, 10212, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:06:09', 'admin-1497834116-14978343697144154', 1, 0, '', NULL, NULL, NULL),
(34621, '2017-06-19 09:06:19', NULL, NULL, 10212, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:06:19', 'admin-1497834116-1497834379368429', 1, 1, 'SR', NULL, NULL, NULL),
(34622, '2017-06-19 09:06:19', NULL, NULL, 10212, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:06:19', 'admin-1497834116-1497834379368429', 1, 1, 'SR', NULL, NULL, NULL),
(34623, '2017-06-19 09:06:19', NULL, NULL, 10212, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:06:19', 'admin-1497834116-1497834379368429', 1, 0, '', NULL, NULL, NULL),
(34624, '2017-06-19 09:06:06', NULL, NULL, 10212, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1497854525', 'admin', '2017-06-19 09:06:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34625, '2017-06-21 12:27:54', NULL, NULL, 10256, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:27:54', 'admin-1498018148-14980192741302245', 1, 0, '', NULL, NULL, NULL),
(34626, '2017-06-21 12:28:44', NULL, NULL, 10265, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:28:44', 'admin-1498018148-14980193242314095', 1, 1, 'SR', NULL, NULL, NULL),
(34627, '2017-06-21 12:31:25', NULL, NULL, 10266, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:31:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34628, '2017-06-21 12:31:34', NULL, NULL, 10266, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:31:34', 'admin-1498018148-14980194944334524', 1, 1, 'SR', NULL, NULL, NULL),
(34629, '2017-06-21 12:31:34', NULL, NULL, 10266, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:31:34', 'admin-1498018148-14980194944334524', 1, 1, 'SR', NULL, NULL, NULL),
(34630, '2017-06-21 13:07:27', NULL, NULL, 10268, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1498023646', 'admin', '2017-06-21 13:07:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34631, '2017-06-21 12:40:56', NULL, NULL, 10256, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:40:56', 'admin-1498018148-149802005657376', 1, 0, '', NULL, NULL, NULL),
(34632, '2017-06-21 12:40:56', NULL, NULL, 10256, 0, 181, '116', 'Open Food ', 'Additional chicken', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:40:56', 'admin-1498018148-149802005657376', 1, 0, '', NULL, NULL, NULL),
(34633, '2017-06-21 12:50:43', NULL, NULL, 10267, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:50:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34634, '2017-06-21 12:50:51', NULL, NULL, 10267, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:50:51', 'admin-1498018148-14980206510016213', 1, 0, '', NULL, NULL, NULL),
(34635, '2017-06-21 12:50:51', NULL, NULL, 10267, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:50:51', 'admin-1498018148-14980206510016213', 1, 0, '', NULL, NULL, NULL),
(34636, '2017-06-21 12:51:26', NULL, NULL, 10265, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:51:26', 'admin-1498018148-1498020685896894', 1, 1, 'SR', NULL, NULL, NULL),
(34637, '2017-06-21 12:51:26', NULL, NULL, 10265, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:51:26', 'admin-1498018148-1498020685896894', 1, 0, '', NULL, NULL, NULL),
(34638, '2017-06-21 00:00:00', NULL, NULL, 10260, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:25:35', 'admin-1498014732-14980155352816241', 1, 1, 'SR', NULL, NULL, NULL),
(34639, '2017-06-21 00:00:00', NULL, NULL, 10261, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:58:52', 'admin-1498014732-14980175320455312', 1, 0, '', NULL, NULL, NULL),
(34640, '2017-06-21 12:08:04', NULL, NULL, 10262, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:08:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34641, '2017-06-21 12:08:15', NULL, NULL, 10262, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:08:15', 'admin-1498014732-1498018095055266', 1, 0, '', NULL, NULL, NULL),
(34642, '2017-06-21 12:08:15', NULL, NULL, 10262, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:08:15', 'admin-1498014732-1498018095055266', 1, 1, 'SR', NULL, NULL, NULL),
(34643, '2017-06-21 13:40:35', NULL, NULL, 10270, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 13:40:35', 'admin-1498018148-14980236349854916', 1, 0, '', NULL, NULL, NULL),
(34644, '2017-06-21 15:16:20', NULL, NULL, 10275, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 2, 11.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 15:16:20', 'admin-1498023646-14980293805161869', 1, 1, 'SR', NULL, NULL, NULL),
(34645, '2017-06-21 11:10:39', NULL, NULL, 10253, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:10:39', 'admin-1498007850-14980146390862277', 1, 0, '', NULL, NULL, NULL),
(34646, '2017-06-21 11:10:39', NULL, NULL, 10253, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:10:39', 'admin-1498007850-14980146390862277', 1, 0, '', NULL, NULL, NULL),
(34647, '2017-06-21 11:10:39', NULL, NULL, 10253, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:10:39', 'admin-1498007850-14980146390862277', 1, 1, 'SR', NULL, NULL, NULL),
(34648, '2017-06-21 15:44:08', NULL, NULL, 10276, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 15:44:08', 'admin-1498023646-14980310481153560', 1, 1, 'SR', 1, NULL, '10.0'),
(34649, '2017-06-21 15:44:50', NULL, NULL, 10277, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1498023646', 'admin', '2017-06-21 15:44:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34650, '2017-06-21 00:00:00', NULL, NULL, 10269, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:12:45', 'admin-1498018148-14980183649617652', 1, 1, 'SR', NULL, NULL, NULL),
(34651, '2017-06-21 13:10:39', NULL, NULL, 10265, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 13:10:39', 'admin-1498018148-14980218394888199', 1, 1, 'SR', NULL, NULL, NULL),
(34652, '2017-06-21 13:19:19', NULL, NULL, 10256, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 13:19:19', 'admin-1498018148-14980223594771273', 1, 1, 'SR', NULL, NULL, NULL),
(34653, '2017-06-21 12:27:54', NULL, NULL, 10256, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:27:54', 'admin-1498018148-14980192741302245', 1, 1, 'SR', NULL, NULL, NULL),
(34654, '2017-06-21 15:48:15', NULL, NULL, 10277, 0, 181, '116', 'Open Food ', 'Cancel one pesto', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 15:48:15', 'admin-1498023646-14980312958087270', 1, 0, '', NULL, NULL, NULL),
(34655, '2017-06-21 15:48:38', NULL, NULL, 10277, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 15:48:38', 'admin-1498023646-14980313178136488', 1, 1, 'SR', NULL, NULL, NULL),
(34656, '2017-06-21 15:48:15', NULL, NULL, 10277, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 15:48:15', 'admin-1498023646-14980312958087270', 1, 0, '', NULL, NULL, NULL),
(34657, '2017-06-21 15:47:40', NULL, NULL, 10277, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 15:47:40', 'admin-1498023646-14980312607647380', 1, 1, 'SR', NULL, NULL, NULL),
(34658, '2017-06-21 12:08:15', NULL, NULL, 10262, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:08:15', 'admin-1498014732-1498018095055266', 1, 0, '', NULL, NULL, NULL),
(34659, '2017-06-21 12:08:47', NULL, NULL, 10263, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:08:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34660, '2017-06-21 12:09:02', NULL, NULL, 10263, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:09:02', 'admin-1498014732-14980181425319117', 1, 0, '', NULL, NULL, NULL),
(34661, '2017-06-21 12:09:02', NULL, NULL, 10263, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:09:02', 'admin-1498014732-14980181425319117', 1, 0, '', NULL, NULL, NULL),
(34662, '2017-06-21 12:09:02', NULL, NULL, 10263, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:09:02', 'admin-1498014732-14980181425319117', 1, 1, 'SR', NULL, NULL, NULL),
(34663, '2017-06-21 12:09:30', NULL, NULL, 10263, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:09:30', 'admin-1498018148-14980181702076564', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(34664, '2017-06-21 12:09:30', NULL, NULL, 10263, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:09:30', 'admin-1498018148-14980181702076564', 1, 1, 'SR', NULL, NULL, NULL),
(34665, '2017-06-21 12:09:30', NULL, NULL, 10263, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:09:30', 'admin-1498018148-14980181702076564', 1, 1, 'SR', NULL, NULL, NULL),
(34666, '2017-06-21 00:00:00', NULL, NULL, 10269, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:12:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34667, '2017-06-21 13:10:39', NULL, NULL, 10265, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 13:10:39', 'admin-1498018148-14980218394888199', 1, 1, 'SR', NULL, NULL, NULL),
(34668, '2017-06-21 00:00:00', NULL, NULL, 10269, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:12:45', 'admin-1498018148-14980183649617652', 1, 0, '', NULL, NULL, NULL),
(34669, '2017-06-21 12:24:43', NULL, NULL, 10265, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:24:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34670, '2017-06-21 15:20:44', NULL, NULL, 10275, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 15:20:44', 'admin-1498023646-14980296447588079', 1, 0, '', NULL, NULL, NULL),
(34671, '2017-06-21 15:16:20', NULL, NULL, 10275, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 15:16:20', 'admin-1498023646-14980293805161869', 1, 1, 'SR', NULL, NULL, NULL),
(34672, '2017-06-21 15:16:20', NULL, NULL, 10275, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 15:16:20', 'admin-1498023646-14980293805161869', 1, 1, 'SR', NULL, NULL, NULL),
(34673, '2017-06-21 13:40:35', NULL, NULL, 10270, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 13:40:35', 'admin-1498018148-14980236349854916', 1, 1, 'SR', NULL, NULL, NULL),
(34674, '2017-06-21 14:49:13', NULL, NULL, 10271, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 14:49:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34675, '2017-06-21 14:49:17', NULL, NULL, 10271, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 14:49:17', 'admin-1498023646-14980277569045486', 1, 1, 'SR', NULL, NULL, NULL),
(34676, '2017-06-21 14:49:17', NULL, NULL, 10271, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 14:49:17', 'admin-1498023646-14980277569045486', 1, 1, 'SR', NULL, NULL, NULL),
(34677, '2017-06-21 14:49:51', NULL, NULL, 10271, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 14:49:51', 'admin-1498023646-14980277912291966', 1, 1, 'SR', NULL, NULL, NULL),
(34678, '2017-06-21 14:49:51', NULL, NULL, 10271, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 14:49:51', 'admin-1498023646-14980277912291966', 1, 0, '', NULL, NULL, NULL),
(34679, '2017-06-21 15:03:27', NULL, NULL, 10272, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 15:03:27', 'admin-1498023646-14980286074958974', 1, 1, 'SR', 1, NULL, '10.0'),
(34680, '2017-06-21 15:05:55', NULL, NULL, 10273, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1498023646', 'admin', '2017-06-21 15:05:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34681, '2017-06-21 15:05:59', NULL, NULL, 10273, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 15:05:59', 'admin-1498023646-14980287593278298', 1, 1, 'SR', NULL, NULL, NULL),
(34682, '2017-06-21 15:16:05', NULL, NULL, 10274, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1498023646', 'admin', '2017-06-21 15:16:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34683, '2017-06-21 15:16:07', NULL, NULL, 10274, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 15:16:07', 'admin-1498023646-14980293675527161', 1, 1, 'SR', NULL, NULL, NULL),
(34684, '2017-06-21 15:16:09', NULL, NULL, 10275, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1498023646', 'admin', '2017-06-21 15:16:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34685, '2017-06-21 14:01:52', NULL, NULL, 10270, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 14:01:52', 'admin-1498023646-14980249123006032', 1, 0, '', NULL, NULL, NULL),
(34686, '2017-06-21 14:01:52', NULL, NULL, 10270, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 14:01:52', 'admin-1498023646-14980249123006032', 1, 0, '', NULL, NULL, NULL),
(34687, '2017-06-21 13:40:35', NULL, NULL, 10270, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 13:40:35', 'admin-1498018148-14980236349854916', 1, 1, 'SR', NULL, NULL, NULL),
(34688, '2017-06-21 13:40:35', NULL, NULL, 10270, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 13:40:35', 'admin-1498018148-14980236349854916', 1, 0, '', NULL, NULL, NULL),
(34689, '2017-06-21 13:40:20', NULL, NULL, 10270, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 13:40:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34690, '2017-06-21 12:08:15', NULL, NULL, 10262, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:08:15', 'admin-1498014732-1498018095055266', 1, 1, 'SR', NULL, NULL, NULL),
(34691, '2017-06-21 11:58:13', NULL, NULL, 10258, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:58:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34692, '2017-06-21 10:58:22', NULL, NULL, 10252, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1498023646', 'admin', '2017-06-21 10:58:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34693, '2017-06-21 10:58:32', NULL, NULL, 10252, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 10:58:32', 'admin-1498007850-14980139120889482', 1, 0, '', NULL, NULL, NULL),
(34694, '2017-06-21 10:58:32', NULL, NULL, 10252, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 10:58:32', 'admin-1498007850-14980139120889482', 1, 0, '', NULL, NULL, NULL),
(34695, '2017-06-21 10:58:41', NULL, NULL, 10252, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 10:58:41', 'admin-1498007850-14980139216342367', 1, 1, 'SR', NULL, NULL, NULL),
(34696, '2017-06-21 10:58:41', NULL, NULL, 10252, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 10:58:41', 'admin-1498007850-14980139216342367', 1, 0, '', NULL, NULL, NULL),
(34697, '2017-06-21 11:10:28', NULL, NULL, 10253, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:10:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34698, '2017-06-21 00:00:00', NULL, NULL, 10268, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:38:19', 'admin-1498018148-14980198997266651', 1, 1, 'SR', NULL, NULL, NULL),
(34699, '2017-06-21 12:27:54', NULL, NULL, 10256, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:27:54', 'admin-1498018148-14980192741302245', 1, 1, 'SR', NULL, NULL, NULL),
(34700, '2017-06-21 12:27:54', NULL, NULL, 10256, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:27:54', 'admin-1498018148-14980192741302245', 1, 0, '', NULL, NULL, NULL),
(34701, '2017-06-21 12:24:58', NULL, NULL, 10265, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:24:58', 'admin-1498018148-14980190981295363', 1, 1, 'SR', NULL, NULL, NULL),
(34702, '2017-06-21 12:27:54', NULL, NULL, 10256, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:27:54', 'admin-1498018148-14980192741302245', 1, 1, 'SR', NULL, NULL, NULL),
(34703, '2017-06-21 00:00:00', NULL, NULL, 10258, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 10:46:01', 'admin-1498007850-14980131613618146', 1, 1, 'SR', NULL, NULL, NULL),
(34704, '2017-06-21 10:23:11', NULL, NULL, 10248, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 10:23:11', 'admin-1498007850-14980117916898274', 1, 1, 'SR', NULL, NULL, NULL),
(34705, '2017-06-21 10:31:24', NULL, NULL, 10249, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 10:31:24', 'admin-1498007850-14980122841714792', 1, 0, '', 1, NULL, NULL),
(34706, '2017-06-21 10:42:28', NULL, NULL, 10250, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1498023646', 'admin', '2017-06-21 10:42:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34707, '2017-06-21 10:42:49', NULL, NULL, 10250, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 10:42:49', 'admin-1498007850-1498012969679619', 1, 0, '', NULL, NULL, NULL),
(34708, '2017-06-21 10:42:49', NULL, NULL, 10250, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 10:42:49', 'admin-1498007850-1498012969679619', 1, 0, '', NULL, NULL, NULL),
(34709, '2017-06-21 10:42:49', NULL, NULL, 10250, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 10:42:49', 'admin-1498007850-1498012969679619', 1, 1, 'SR', NULL, NULL, NULL),
(34710, '2017-06-21 00:00:00', NULL, NULL, 10257, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:34:33', 'admin-1498014732-14980160736564955', 1, 0, '', NULL, NULL, NULL),
(34711, '2017-06-21 00:00:00', NULL, NULL, 10258, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 10:53:08', 'admin-1498007850-14980135886793626', 1, 0, '', NULL, NULL, NULL),
(34712, '2017-06-21 10:23:04', NULL, NULL, 10248, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 10:23:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34713, '2017-06-21 10:23:11', NULL, NULL, 10248, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 10:23:11', 'admin-1498007850-14980117916898274', 1, 0, '', NULL, NULL, NULL),
(34714, '2017-06-21 10:23:11', NULL, NULL, 10248, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 10:23:11', 'admin-1498007850-14980117916898274', 1, 0, '', NULL, NULL, NULL),
(34715, '2017-06-21 10:23:11', NULL, NULL, 10248, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 10:23:11', 'admin-1498007850-14980117916898274', 1, 1, 'SR', NULL, NULL, NULL),
(34716, '2017-06-21 00:00:00', NULL, NULL, 10261, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:30:47', 'admin-1498014732-1498015847381597', 1, 0, '', NULL, NULL, NULL),
(34717, '2017-06-21 00:00:00', NULL, NULL, 10259, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:51:14', 'admin-1498014732-14980170747308192', 1, 0, '', NULL, NULL, NULL),
(34718, '2017-06-21 12:04:46', NULL, NULL, 10259, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:04:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34719, '2017-06-21 00:00:00', NULL, NULL, 10259, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:51:14', 'admin-1498014732-14980170747308192', 1, 0, '', NULL, NULL, NULL),
(34720, '2017-06-21 00:00:00', NULL, NULL, 10257, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:53:43', 'admin-1498014732-14980172229552238', 1, 0, '', NULL, NULL, NULL),
(34721, '2017-06-21 11:39:01', NULL, NULL, 10256, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:39:01', 'admin-1498014732-1498016341053786', 1, 1, 'SR', NULL, NULL, NULL),
(34722, '2017-06-21 11:38:56', NULL, NULL, 10256, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.20, 0.0000, 0.0000, 12.20, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:38:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34723, '2017-06-21 11:34:48', NULL, NULL, 10252, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:34:48', 'admin-1498014732-14980160884817487', 1, 1, 'SR', NULL, NULL, NULL),
(34724, '2017-06-21 11:57:25', NULL, NULL, 10257, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:57:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34725, '2017-06-21 00:00:00', NULL, NULL, 10260, 0, 155, '89', 'Cheesy Chicken Gratin', 'no egg', 'Meals', 'Morning Bites ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:24:36', 'admin-1498014732-14980154767893619', 1, 0, '', NULL, NULL, NULL),
(34726, '2017-06-21 00:00:00', NULL, NULL, 10261, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:24:36', 'admin-1498014732-14980154767893619', 1, 1, 'SR', NULL, NULL, NULL),
(34727, '2017-06-21 11:25:29', NULL, NULL, 10255, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:25:29', 'admin-1498014732-14980155293867625', 1, 1, 'SR', NULL, NULL, NULL),
(34728, '2017-06-21 11:25:29', NULL, NULL, 10255, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:25:29', 'admin-1498014732-14980155293867625', 1, 1, 'SR', NULL, NULL, NULL),
(34729, '2017-06-21 12:05:36', NULL, NULL, 10260, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1498023646', 'admin', '2017-06-21 12:05:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34730, '2017-06-21 11:25:19', NULL, NULL, 10255, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:25:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34731, '2017-06-21 00:00:00', NULL, NULL, 10261, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, NULL, NULL, 2.70, 1, '27', 1, '1498023646', 'admin', '2017-06-21 10:45:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34732, '2017-06-21 00:00:00', NULL, NULL, 10257, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 10:53:08', 'admin-1498007850-14980135886793626', 1, 0, '', NULL, NULL, NULL),
(34733, '2017-06-21 11:51:41', NULL, NULL, 10254, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:51:41', 'admin-1498014732-14980171016343253', 1, 0, '', NULL, NULL, NULL),
(34734, '2017-06-21 09:43:16', NULL, NULL, 10247, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 09:43:16', 'admin-1498007850-14980093959391054', 1, 0, '', NULL, NULL, NULL),
(34735, '2017-06-21 09:43:16', NULL, NULL, 10247, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 09:43:16', 'admin-1498007850-14980093959391054', 1, 0, '', NULL, NULL, NULL),
(34736, '2017-06-21 09:43:16', NULL, NULL, 10247, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 09:43:16', 'admin-1498007850-14980093959391054', 1, 0, '', NULL, NULL, NULL),
(34737, '2017-06-21 09:43:16', NULL, NULL, 10247, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 09:43:16', 'admin-1498007850-14980093959391054', 1, 0, '', NULL, NULL, NULL),
(34738, '2017-06-21 11:11:57', NULL, NULL, 10254, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1498023646', 'admin', '2017-06-21 11:11:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34739, '2017-06-21 00:00:00', NULL, NULL, 10257, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 10:46:01', 'admin-1498007850-14980131613618146', 1, 1, 'SR', NULL, NULL, NULL),
(34740, '2017-06-21 09:17:53', NULL, NULL, 10246, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 09:17:53', 'admin-1498007850-14980078728218169', 1, 1, 'SR', NULL, NULL, NULL),
(34741, '2017-06-21 09:37:22', NULL, NULL, 10247, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1498023646', 'admin', '2017-06-21 09:37:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34742, '2017-06-21 09:17:53', NULL, NULL, 10246, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498023646', 'admin', '2017-06-21 09:17:53', 'admin-1498007850-14980078728218169', 1, 1, 'SR', NULL, NULL, NULL),
(34743, '2017-06-21 09:17:40', NULL, NULL, 10246, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1498023646', 'admin', '2017-06-21 09:17:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34744, '2017-06-22 15:23:52', NULL, NULL, 10298, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1498105008', 'admin', '2017-06-22 15:23:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34745, '2017-06-22 15:23:54', NULL, NULL, 10298, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 15:23:54', 'admin-1498105008-14981162342655867', 1, 1, 'SR', NULL, NULL, NULL),
(34746, '2017-06-22 15:26:20', NULL, NULL, 10298, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 15:26:20', 'admin-1498105008-14981163801986058', 1, 1, 'SR', NULL, NULL, NULL),
(34747, '2017-06-22 16:19:35', NULL, NULL, 10299, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1498105008', 'admin', '2017-06-22 16:19:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34748, '2017-06-22 16:20:04', NULL, NULL, 10299, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 16:20:04', 'admin-1498105008-14981196047581734', 1, 1, 'SR', NULL, NULL, NULL),
(34749, '2017-06-22 10:23:13', NULL, NULL, 10283, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:23:13', 'admin-1498097986-14980981934353884', 1, 1, 'SR', NULL, NULL, NULL),
(34750, '2017-06-22 10:19:37', NULL, NULL, 10283, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:19:37', 'admin-1498092450-14980979771583276', 1, 0, '', NULL, NULL, NULL),
(34751, '2017-06-22 17:12:24', NULL, NULL, 10300, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 17:12:24', 'admin-1498105008-14981227438638121', 1, 1, 'SR', NULL, NULL, NULL),
(34752, '2017-06-22 17:10:23', NULL, NULL, 10300, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1498105008', 'admin', '2017-06-22 17:10:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34753, '2017-06-22 13:35:10', NULL, NULL, 10294, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 13:35:10', 'admin-1498105008-14981097102595690', 1, 1, 'SR', NULL, NULL, NULL),
(34754, '2017-06-22 16:20:04', NULL, NULL, 10299, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 16:20:04', 'admin-1498105008-14981196047581734', 1, 1, 'SR', NULL, NULL, NULL),
(34755, '2017-06-22 10:19:41', NULL, NULL, 10283, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:19:41', 'admin-1498092450-14980979811027547', 1, 0, '', NULL, NULL, NULL),
(34756, '2017-06-22 11:59:34', NULL, NULL, 10288, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 11:59:34', 'admin-1498097986-14981039738325254', 1, 1, 'SR', NULL, NULL, NULL),
(34757, '2017-06-22 11:59:34', NULL, NULL, 10288, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 11:59:34', 'admin-1498097986-14981039738325254', 1, 1, 'SR', NULL, NULL, NULL),
(34758, '2017-06-22 11:59:34', NULL, NULL, 10288, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 11:59:34', 'admin-1498097986-14981039738325254', 1, 1, 'SR', NULL, NULL, NULL),
(34759, '2017-06-22 14:18:27', NULL, NULL, 10296, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 14:18:27', 'admin-1498105008-14981123075634479', 1, 1, 'SR', NULL, NULL, NULL),
(34760, '2017-06-22 14:04:29', NULL, NULL, 10295, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1498105008', 'admin', '2017-06-22 14:04:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34761, '2017-06-22 14:04:37', NULL, NULL, 10295, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 14:04:37', 'admin-1498105008-14981114771457325', 1, 0, '', NULL, NULL, NULL),
(34762, '2017-06-22 10:40:55', NULL, NULL, 10286, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:40:55', 'admin-1498097986-14980992552082745', 1, 0, '', NULL, NULL, NULL),
(34763, '2017-06-22 10:50:59', NULL, NULL, 10283, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:50:59', 'admin-1498097986-14980998596037133', 1, 0, '', NULL, NULL, NULL),
(34764, '2017-06-22 11:59:03', NULL, NULL, 10288, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.30, 0.0000, 0.0000, 11.30, 1, '27', 1, '1498105008', 'admin', '2017-06-22 11:59:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34765, '2017-06-22 11:59:34', NULL, NULL, 10288, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 11:59:34', 'admin-1498097986-14981039738325254', 1, 1, 'SR', NULL, NULL, NULL),
(34766, '2017-06-22 14:29:20', NULL, NULL, 10297, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 14:29:20', 'admin-1498105008-14981129604014547', 1, 1, 'SR', NULL, NULL, NULL),
(34767, '2017-06-22 14:29:20', NULL, NULL, 10297, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 14:29:20', 'admin-1498105008-14981129604014547', 1, 1, 'SR', NULL, NULL, NULL),
(34768, '2017-06-22 14:28:07', NULL, NULL, 10297, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1498105008', 'admin', '2017-06-22 14:28:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34769, '2017-06-22 14:29:20', NULL, NULL, 10297, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 14:29:20', 'admin-1498105008-14981129604014547', 1, 1, 'SR', NULL, NULL, NULL),
(34770, '2017-06-22 12:11:09', NULL, NULL, 10288, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 12:11:09', 'admin-1498097986-14981046689155790', 1, 0, '', NULL, NULL, NULL),
(34771, '2017-06-22 12:11:12', NULL, NULL, 10290, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1498105008', 'admin', '2017-06-22 12:11:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34772, '2017-06-22 12:11:26', NULL, NULL, 10290, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 12:11:26', 'admin-1498097986-14981046866328173', 1, 0, '', NULL, NULL, NULL),
(34773, '2017-06-22 12:11:26', NULL, NULL, 10290, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 12:11:26', 'admin-1498097986-14981046866328173', 1, 0, '', NULL, NULL, NULL),
(34774, '2017-06-22 12:11:26', NULL, NULL, 10290, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 12:11:26', 'admin-1498097986-14981046866328173', 1, 0, '', NULL, NULL, NULL),
(34775, '2017-06-22 12:11:36', NULL, NULL, 10290, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 12:11:36', 'admin-1498097986-14981046964191368', 1, 0, '', NULL, NULL, NULL),
(34776, '2017-06-22 12:11:36', NULL, NULL, 10290, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 12:11:36', 'admin-1498097986-14981046964191368', 1, 1, 'SR', NULL, NULL, NULL),
(34777, '2017-06-22 12:16:28', NULL, NULL, 10291, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1498105008', 'admin', '2017-06-22 12:16:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34778, '2017-06-22 10:25:07', NULL, NULL, 10285, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:25:07', 'admin-1498097986-14980983068208736', 1, 1, 'SR', NULL, NULL, NULL),
(34779, '2017-06-22 14:18:27', NULL, NULL, 10296, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 14:18:27', 'admin-1498105008-14981123075634479', 1, 1, 'SR', NULL, NULL, NULL),
(34780, '2017-06-22 10:19:37', NULL, NULL, 10283, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:19:37', 'admin-1498092450-14980979771583276', 1, 0, '', NULL, NULL, NULL),
(34781, '2017-06-22 14:04:37', NULL, NULL, 10295, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 14:04:37', 'admin-1498105008-14981114771457325', 1, 1, 'SR', NULL, NULL, NULL),
(34782, '2017-06-22 14:18:27', NULL, NULL, 10296, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 14:18:27', 'admin-1498105008-14981123075634479', 1, 1, 'SR', NULL, NULL, NULL),
(34783, '2017-06-22 14:17:48', NULL, NULL, 10296, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1498105008', 'admin', '2017-06-22 14:17:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34784, '2017-06-22 13:35:10', NULL, NULL, 10294, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 13:35:10', 'admin-1498105008-14981097102595690', 1, 0, '', NULL, NULL, NULL),
(34785, '2017-06-22 13:35:10', NULL, NULL, 10294, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 13:35:10', 'admin-1498105008-14981097102595690', 1, 1, 'SR', NULL, NULL, NULL),
(34786, '2017-06-22 12:16:38', NULL, NULL, 10291, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 12:16:38', 'admin-1498097986-14981049980785265', 1, 1, 'SR', NULL, NULL, NULL),
(34787, '2017-06-22 12:16:59', NULL, NULL, 10292, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1498105008', 'admin', '2017-06-22 12:16:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34788, '2017-06-22 12:17:09', NULL, NULL, 10292, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 12:17:09', 'admin-1498105008-14981050293046815', 1, 0, '', NULL, NULL, NULL),
(34789, '2017-06-22 12:17:09', NULL, NULL, 10292, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 12:17:09', 'admin-1498105008-14981050293046815', 1, 1, 'SR', NULL, NULL, NULL),
(34790, '2017-06-22 12:52:46', NULL, NULL, 10293, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1498105008', 'admin', '2017-06-22 12:52:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34791, '2017-06-22 12:52:50', NULL, NULL, 10293, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 12:52:50', 'admin-1498105008-1498107170326564', 1, 0, '', NULL, NULL, NULL),
(34792, '2017-06-22 12:52:56', NULL, NULL, 10293, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 12:52:56', 'admin-1498105008-14981071762708945', 1, 1, 'SR', NULL, NULL, NULL),
(34793, '2017-06-22 13:34:03', NULL, NULL, 10294, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1498105008', 'admin', '2017-06-22 13:34:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34794, '2017-06-22 13:34:17', NULL, NULL, 10294, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 13:34:17', 'admin-1498105008-14981096570367059', 1, 0, '', NULL, NULL, NULL),
(34795, '2017-06-22 10:23:13', NULL, NULL, 10283, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:23:13', 'admin-1498097986-14980981934353884', 1, 0, '', NULL, NULL, NULL),
(34796, '2017-06-22 11:19:14', NULL, NULL, 10287, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 11:19:14', 'admin-1498097986-14981015543786764', 1, 0, '', 1, NULL, NULL),
(34797, '2017-06-22 11:19:14', NULL, NULL, 10287, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 11:19:14', 'admin-1498097986-14981015543786764', 1, 0, '', 1, NULL, NULL),
(34798, '2017-06-22 11:19:14', NULL, NULL, 10287, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 11:19:14', 'admin-1498097986-14981015543786764', 1, 0, '', 1, NULL, NULL),
(34799, '2017-06-22 11:19:14', NULL, NULL, 10287, 0, 182, '117', 'Open Drinks ', 'stamps', 'Cold Drinks', 'Fresh Juice', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1498105008', 'admin', '2017-06-22 11:19:14', 'admin-1498097986-14981015543786764', 1, 0, '', 1, NULL, NULL),
(34800, '2017-06-22 16:20:27', NULL, NULL, 10299, 0, 181, '116', 'Open Food ', 'apple', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 16:20:27', 'admin-1498105008-14981196273297242', 1, 0, '', NULL, NULL, NULL),
(34801, '2017-06-22 13:35:10', NULL, NULL, 10294, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 13:35:10', 'admin-1498105008-14981097102595690', 1, 1, 'SR', NULL, NULL, NULL),
(34802, '2017-06-22 12:07:06', NULL, NULL, 10289, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 12:07:06', 'admin-1498097986-14981044265059489', 1, 1, 'SR', NULL, NULL, NULL),
(34803, '2017-06-22 12:07:02', NULL, NULL, 10289, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1498105008', 'admin', '2017-06-22 12:07:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34804, '2017-06-22 11:59:49', NULL, NULL, 10288, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 11:59:49', 'admin-1498097986-14981039897532721', 1, 0, '', NULL, NULL, NULL),
(34805, '2017-06-22 11:59:34', NULL, NULL, 10288, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 11:59:34', 'admin-1498097986-14981039738325254', 1, 1, 'SR', NULL, NULL, NULL),
(34806, '2017-06-22 11:59:34', NULL, NULL, 10288, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 11:59:34', 'admin-1498097986-14981039738325254', 1, 0, '', NULL, NULL, NULL),
(34807, '2017-06-22 11:59:34', NULL, NULL, 10288, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 11:59:34', 'admin-1498097986-14981039738325254', 1, 0, '', NULL, NULL, NULL),
(34808, '2017-06-22 11:59:34', NULL, NULL, 10288, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 11:59:34', 'admin-1498097986-14981039738325254', 1, 1, 'SR', NULL, NULL, NULL),
(34809, '2017-06-22 10:25:07', NULL, NULL, 10285, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:25:07', 'admin-1498097986-14980983068208736', 1, 1, 'SR', NULL, NULL, NULL),
(34810, '2017-06-22 10:25:07', NULL, NULL, 10285, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:25:07', 'admin-1498097986-14980983068208736', 1, 1, 'SR', NULL, NULL, NULL),
(34811, '2017-06-22 10:40:43', NULL, NULL, 10286, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:40:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34812, '2017-06-22 10:40:55', NULL, NULL, 10286, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:40:55', 'admin-1498097986-14980992552082745', 1, 1, 'SR', NULL, NULL, NULL),
(34813, '2017-06-22 10:22:26', NULL, NULL, 10284, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:22:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34814, '2017-06-22 10:22:29', NULL, NULL, 10284, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:22:29', 'admin-1498097986-14980981493495018', 1, 1, 'SR', NULL, NULL, NULL),
(34815, '2017-06-22 10:23:13', NULL, NULL, 10283, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:23:13', 'admin-1498097986-14980981934353884', 1, 1, 'SR', NULL, NULL, NULL),
(34816, '2017-06-22 10:23:13', NULL, NULL, 10283, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:23:13', 'admin-1498097986-14980981934353884', 1, 1, 'SR', NULL, NULL, NULL),
(34817, '2017-06-22 10:23:13', NULL, NULL, 10283, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:23:13', 'admin-1498097986-14980981934353884', 1, 1, 'SR', NULL, NULL, NULL),
(34818, '2017-06-22 10:23:13', NULL, NULL, 10283, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:23:13', 'admin-1498097986-14980981934353884', 1, 1, 'SR', NULL, NULL, NULL),
(34819, '2017-06-22 10:23:13', NULL, NULL, 10283, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:23:13', 'admin-1498097986-14980981934353884', 1, 1, 'SR', NULL, NULL, NULL),
(34820, '2017-06-22 10:23:13', NULL, NULL, 10283, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:23:13', 'admin-1498097986-14980981934353884', 1, 1, 'SR', NULL, NULL, NULL),
(34821, '2017-06-22 10:25:07', NULL, NULL, 10285, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:25:07', 'admin-1498097986-14980983068208736', 1, 1, 'SR', NULL, NULL, NULL),
(34822, '2017-06-22 10:25:00', NULL, NULL, 10285, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:25:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34823, '2017-06-22 09:16:05', NULL, NULL, 10279, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1498105008', 'admin', '2017-06-22 09:16:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34824, '2017-06-22 09:16:36', NULL, NULL, 10279, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 09:16:36', 'admin-1498092450-14980941960686130', 1, 1, 'SR', NULL, NULL, NULL),
(34825, '2017-06-22 09:16:36', NULL, NULL, 10279, 0, 181, '116', 'Open Food ', 'junior blt', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 09:16:36', 'admin-1498092450-14980941960686130', 1, 0, '', NULL, NULL, NULL),
(34826, '2017-06-22 12:16:38', NULL, NULL, 10291, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 12:16:38', 'admin-1498097986-14981049980785265', 1, 1, 'SR', NULL, NULL, NULL),
(34827, '2017-06-22 10:23:13', NULL, NULL, 10283, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:23:13', 'admin-1498097986-14980981934353884', 1, 1, 'SR', NULL, NULL, NULL),
(34828, '2017-06-22 10:23:13', NULL, NULL, 10283, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:23:13', 'admin-1498097986-14980981934353884', 1, 1, 'SR', NULL, NULL, NULL),
(34829, '2017-06-22 10:19:37', NULL, NULL, 10283, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:19:37', 'admin-1498092450-14980979771583276', 1, 0, '', NULL, NULL, NULL),
(34830, '2017-06-22 10:19:37', NULL, NULL, 10283, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:19:37', 'admin-1498092450-14980979771583276', 1, 0, '', NULL, NULL, NULL),
(34831, '2017-06-22 10:19:37', NULL, NULL, 10283, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:19:37', 'admin-1498092450-14980979771583276', 1, 0, '', NULL, NULL, NULL),
(34832, '2017-06-22 10:19:37', NULL, NULL, 10283, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:19:37', 'admin-1498092450-14980979771583276', 1, 0, '', NULL, NULL, NULL),
(34833, '2017-06-22 10:19:37', NULL, NULL, 10283, 0, 181, '116', 'Open Food ', 'add bacon', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:19:37', 'admin-1498092450-14980979771583276', 1, 0, '', NULL, NULL, NULL),
(34834, '2017-06-22 10:19:37', NULL, NULL, 10283, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:19:37', 'admin-1498092450-14980979771583276', 1, 0, '', NULL, NULL, NULL),
(34835, '2017-06-22 10:19:37', NULL, NULL, 10283, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:19:37', 'admin-1498092450-14980979771583276', 1, 0, '', NULL, NULL, NULL),
(34836, '2017-06-22 09:22:51', NULL, NULL, 10281, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1498105008', 'admin', '2017-06-22 09:22:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34837, '2017-06-22 09:23:07', NULL, NULL, 10281, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 09:23:07', 'admin-1498092450-1498094587762957', 1, 1, 'SR', NULL, NULL, NULL),
(34838, '2017-06-22 09:23:07', NULL, NULL, 10281, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 09:23:07', 'admin-1498092450-1498094587762957', 1, 1, 'SR', NULL, NULL, NULL),
(34839, '2017-06-22 09:23:08', NULL, NULL, 10281, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 09:23:08', 'admin-1498092450-1498094587762957', 1, 0, '', NULL, NULL, NULL),
(34840, '2017-06-22 09:40:56', NULL, NULL, 10282, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1498105008', 'admin', '2017-06-22 09:40:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34841, '2017-06-22 09:41:02', NULL, NULL, 10282, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 09:41:02', 'admin-1498092450-14980956626165794', 1, 0, '', NULL, NULL, NULL),
(34842, '2017-06-22 09:41:02', NULL, NULL, 10282, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 09:41:02', 'admin-1498092450-14980956626165794', 1, 0, '', NULL, NULL, NULL),
(34843, '2017-06-22 09:41:08', NULL, NULL, 10282, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 09:41:08', 'admin-1498092450-14980956681054469', 1, 1, 'SR', NULL, NULL, NULL),
(34844, '2017-06-22 09:41:08', NULL, NULL, 10282, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 09:41:08', 'admin-1498092450-14980956681054469', 1, 1, 'SR', NULL, NULL, NULL),
(34845, '2017-06-22 09:17:24', NULL, NULL, 10280, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1498105008', 'admin', '2017-06-22 09:17:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34846, '2017-06-22 09:17:32', NULL, NULL, 10280, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 09:17:32', 'admin-1498092450-1498094252372577', 1, 1, 'SR', NULL, NULL, NULL),
(34847, '2017-06-22 09:17:32', NULL, NULL, 10280, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 09:17:32', 'admin-1498092450-1498094252372577', 1, 1, 'SR', NULL, NULL, NULL),
(34848, '2017-06-22 09:17:32', NULL, NULL, 10280, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 09:17:32', 'admin-1498092450-1498094252372577', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(34849, '2017-06-22 10:19:04', NULL, NULL, 10283, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 30.80, 0.0000, 0.0000, 30.80, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:19:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34850, '2017-06-22 10:19:37', NULL, NULL, 10283, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 10:19:37', 'admin-1498092450-14980979771583276', 1, 0, '', NULL, NULL, NULL),
(34851, '2017-06-22 09:17:32', NULL, NULL, 10280, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 09:17:32', 'admin-1498092450-1498094252372577', 1, 0, '', NULL, NULL, NULL),
(34852, '2017-06-22 09:08:27', NULL, NULL, 10278, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 09:08:27', 'admin-1498092450-14980937069641973', 1, 0, '', NULL, NULL, NULL),
(34853, '2017-06-22 09:08:31', NULL, NULL, 10278, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498105008', 'admin', '2017-06-22 09:08:31', 'admin-1498092450-1498093710992313', 1, 1, 'SR', NULL, NULL, NULL),
(34854, '2017-06-22 09:08:23', NULL, NULL, 10278, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1498105008', 'admin', '2017-06-22 09:08:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34855, '2017-06-23 14:07:04', NULL, NULL, 10311, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 3, 11.00, 33.0000, 0.0000, 33.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 14:07:04', 'admin-1498195504-14981980242487291', 1, 1, 'SR', NULL, NULL, NULL),
(34856, '2017-06-23 14:07:04', NULL, NULL, 10311, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 14:07:04', 'admin-1498195504-14981980242487291', 1, 1, 'SR', NULL, NULL, NULL),
(34857, '2017-06-23 16:15:00', NULL, NULL, 10313, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 16:15:00', 'admin-1498195504-14982057001072138', 1, 1, 'SR', NULL, NULL, NULL),
(34858, '2017-06-23 16:49:31', NULL, NULL, 10314, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1498195504', 'admin', '2017-06-23 16:49:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34859, '2017-06-23 16:50:08', NULL, NULL, 10314, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 16:50:08', 'admin-1498195504-14982078078636737', 1, 1, 'SR', NULL, NULL, NULL),
(34860, '2017-06-23 09:47:01', NULL, NULL, 10304, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:47:01', 'admin-1498178121-14981824215166091', 1, 0, '', NULL, NULL, NULL),
(34861, '2017-06-23 17:30:06', NULL, NULL, 10314, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 17:30:06', 'admin-1498195504-14982102067632283', 1, 0, '', NULL, NULL, NULL),
(34862, '2017-06-23 17:30:06', NULL, NULL, 10314, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 17:30:06', 'admin-1498195504-14982102067632283', 1, 1, 'SR', NULL, NULL, NULL),
(34863, '2017-06-23 17:30:36', NULL, NULL, 10315, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 17:30:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34864, '2017-06-23 17:30:40', NULL, NULL, 10315, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 17:30:40', 'admin-1498195504-14982102403224193', 1, 0, '', NULL, NULL, NULL),
(34865, '2017-06-23 17:30:40', NULL, NULL, 10315, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 17:30:40', 'admin-1498195504-14982102403224193', 1, 0, '', NULL, NULL, NULL),
(34866, '2017-06-23 17:36:27', NULL, NULL, 10316, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1498195504', 'admin', '2017-06-23 17:36:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34867, '2017-06-23 17:36:35', NULL, NULL, 10316, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 17:36:35', 'admin-1498195504-14982105951722580', 1, 1, 'SR', NULL, NULL, NULL),
(34868, '2017-06-23 17:36:35', NULL, NULL, 10316, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 17:36:35', 'admin-1498195504-14982105951722580', 1, 1, 'SR', NULL, NULL, NULL),
(34869, '2017-06-23 09:35:08', NULL, NULL, 10302, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:35:08', 'admin-1498178121-14981817082537950', 1, 0, '', NULL, NULL, NULL),
(34870, '2017-06-23 11:17:55', NULL, NULL, 10307, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 11:17:55', 'admin-1498178121-1498187875494244', 1, 0, '', NULL, NULL, NULL),
(34871, '2017-06-23 11:17:55', NULL, NULL, 10307, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 11:17:55', 'admin-1498178121-1498187875494244', 1, 1, 'SR', NULL, NULL, NULL),
(34872, '2017-06-23 11:17:55', NULL, NULL, 10307, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 11:17:55', 'admin-1498178121-1498187875494244', 1, 0, '', NULL, NULL, NULL),
(34873, '2017-06-23 11:27:52', NULL, NULL, 10307, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 11:27:52', 'admin-1498178121-14981884720791775', 1, 0, '', NULL, NULL, NULL),
(34874, '2017-06-23 11:45:36', NULL, NULL, 10308, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1498195504', 'admin', '2017-06-23 11:45:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34875, '2017-06-23 11:45:47', NULL, NULL, 10308, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 11:45:47', 'admin-1498189529-14981895467619784', 1, 1, 'SR', NULL, NULL, NULL),
(34876, '2017-06-23 11:45:47', NULL, NULL, 10308, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 11:45:47', 'admin-1498189529-14981895467619784', 1, 0, '', NULL, NULL, NULL),
(34877, '2017-06-23 11:45:47', NULL, NULL, 10308, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 11:45:47', 'admin-1498189529-14981895467619784', 1, 0, '', NULL, NULL, NULL),
(34878, '2017-06-23 11:45:47', NULL, NULL, 10308, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 11:45:47', 'admin-1498189529-14981895467619784', 1, 0, '', NULL, NULL, NULL),
(34879, '2017-06-23 12:48:42', NULL, NULL, 10309, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1498195504', 'admin', '2017-06-23 12:48:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34880, '2017-06-23 12:48:50', NULL, NULL, 10309, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 12:48:50', 'admin-1498189529-14981933302776638', 1, 1, 'SR', NULL, NULL, NULL),
(34881, '2017-06-23 09:35:08', NULL, NULL, 10302, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:35:08', 'admin-1498178121-14981817082537950', 1, 1, 'SR', NULL, NULL, NULL),
(34882, '2017-06-23 09:35:08', NULL, NULL, 10302, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:35:08', 'admin-1498178121-14981817082537950', 1, 1, 'SR', NULL, NULL, NULL),
(34883, '2017-06-23 09:38:28', NULL, NULL, 10303, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.90, 0.0000, 0.0000, 15.90, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:38:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34884, '2017-06-23 12:48:50', NULL, NULL, 10309, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 12:48:50', 'admin-1498189529-14981933302776638', 1, 1, 'SR', NULL, NULL, NULL),
(34885, '2017-06-23 13:20:58', NULL, NULL, 10310, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.20, 0.0000, 0.0000, 11.20, 1, '27', 1, '1498195504', 'admin', '2017-06-23 13:20:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34886, '2017-06-23 13:21:03', NULL, NULL, 10310, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 13:21:03', 'admin-1498189529-14981952632409222', 1, 1, 'SR', NULL, NULL, NULL),
(34887, '2017-06-23 13:21:03', NULL, NULL, 10310, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 13:21:03', 'admin-1498189529-14981952632409222', 1, 0, '', NULL, NULL, NULL),
(34888, '2017-06-23 13:21:25', NULL, NULL, 10310, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 13:21:25', 'admin-1498189529-14981952849313953', 1, 0, '', NULL, NULL, NULL),
(34889, '2017-06-23 13:21:38', NULL, NULL, 10310, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 13:21:38', 'admin-1498189529-14981952987683149', 1, 1, 'SR', NULL, NULL, NULL),
(34890, '2017-06-23 16:50:08', NULL, NULL, 10314, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 16:50:08', 'admin-1498195504-14982078078636737', 1, 1, 'SR', NULL, NULL, NULL),
(34891, '2017-06-23 16:15:00', NULL, NULL, 10313, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 16:15:00', 'admin-1498195504-14982057001072138', 1, 1, 'SR', NULL, NULL, NULL),
(34892, '2017-06-23 16:14:44', NULL, NULL, 10313, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 16:14:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34893, '2017-06-23 14:06:30', NULL, NULL, 10311, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1498195504', 'admin', '2017-06-23 14:06:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34894, '2017-06-23 14:07:04', NULL, NULL, 10311, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 14:07:04', 'admin-1498195504-14981980242487291', 1, 1, 'SR', NULL, NULL, NULL),
(34895, '2017-06-23 14:07:04', NULL, NULL, 10311, 0, 181, '116', 'Open Food ', 'ginger onion chicken', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 14:07:04', 'admin-1498195504-14981980242487291', 1, 0, '', NULL, NULL, NULL),
(34896, '2017-06-23 13:22:14', NULL, NULL, 10310, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 13:22:14', 'admin-1498189529-14981953346751584', 1, 1, 'SR', NULL, NULL, NULL),
(34897, '2017-06-23 13:22:14', NULL, NULL, 10310, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 13:22:14', 'admin-1498189529-14981953346751584', 1, 1, 'SR', NULL, NULL, NULL),
(34898, '2017-06-23 13:23:00', NULL, NULL, 10310, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 13:23:00', 'admin-1498189529-14981953799668617', 1, 1, 'SR', NULL, NULL, NULL),
(34899, '2017-06-23 13:25:13', NULL, NULL, 10310, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 13:25:13', 'admin-1498195504-14981955137339974', 1, 1, 'SR', NULL, NULL, NULL),
(34900, '2017-06-23 14:47:30', NULL, NULL, 10311, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 14:47:30', 'admin-1498195504-1498200450340425', 1, 1, 'SR', NULL, NULL, NULL),
(34901, '2017-06-23 14:22:01', NULL, NULL, 10312, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 14:22:01', 'admin-1498195504-14981989207848749', 1, 1, 'SR', NULL, NULL, NULL),
(34902, '2017-06-23 14:21:58', NULL, NULL, 10312, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1498195504', 'admin', '2017-06-23 14:21:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34903, '2017-06-23 14:07:04', NULL, NULL, 10311, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 14:07:04', 'admin-1498195504-14981980242487291', 1, 0, '', NULL, NULL, NULL),
(34904, '2017-06-23 10:06:54', NULL, NULL, 10305, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 10:06:54', 'admin-1498178121-14981836142877240', 1, 0, '', NULL, NULL, NULL),
(34905, '2017-06-23 09:12:32', NULL, NULL, 10301, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:12:32', 'admin-1498178121-14981803528115765', 1, 0, '', NULL, NULL, NULL),
(34906, '2017-06-23 09:12:32', NULL, NULL, 10301, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:12:32', 'admin-1498178121-14981803528115765', 1, 0, '', NULL, NULL, NULL),
(34907, '2017-06-23 09:12:32', NULL, NULL, 10301, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:12:32', 'admin-1498178121-14981803528115765', 1, 1, 'SR', NULL, NULL, NULL),
(34908, '2017-06-23 09:34:47', NULL, NULL, 10302, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:34:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34909, '2017-06-23 13:21:38', NULL, NULL, 10310, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 13:21:38', 'admin-1498189529-14981952987683149', 1, 1, 'SR', NULL, NULL, NULL),
(34910, '2017-06-23 10:39:15', NULL, NULL, 10306, 0, 182, '117', 'Open Drinks ', 'americano set', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 10:39:15', 'admin-1498178121-14981855557904192', 1, 0, '', NULL, NULL, NULL),
(34911, '2017-06-23 11:17:41', NULL, NULL, 10307, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1498195504', 'admin', '2017-06-23 11:17:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34912, '2017-06-23 11:17:44', NULL, NULL, 10307, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 11:17:44', 'admin-1498178121-14981878644948219', 1, 0, '', NULL, NULL, NULL),
(34913, '2017-06-23 10:38:29', NULL, NULL, 10306, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 10:38:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34914, '2017-06-23 10:06:54', NULL, NULL, 10305, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 10:06:54', 'admin-1498178121-14981836142877240', 1, 1, 'SR', NULL, NULL, NULL),
(34915, '2017-06-23 10:06:54', NULL, NULL, 10305, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 10:06:54', 'admin-1498178121-14981836142877240', 1, 1, 'SR', NULL, NULL, NULL),
(34916, '2017-06-23 10:06:34', NULL, NULL, 10305, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1498195504', 'admin', '2017-06-23 10:06:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34917, '2017-06-23 09:47:01', NULL, NULL, 10304, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:47:01', 'admin-1498178121-14981824215166091', 1, 0, '', NULL, NULL, NULL),
(34918, '2017-06-23 09:47:01', NULL, NULL, 10304, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:47:01', 'admin-1498178121-14981824215166091', 1, 1, 'SR', NULL, NULL, NULL),
(34919, '2017-06-23 09:47:01', NULL, NULL, 10304, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:47:01', 'admin-1498178121-14981824215166091', 1, 0, '', NULL, NULL, NULL),
(34920, '2017-06-23 09:46:47', NULL, NULL, 10304, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:46:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34921, '2017-06-23 09:47:01', NULL, NULL, 10304, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:47:01', 'admin-1498178121-14981824215166091', 1, 0, '', NULL, NULL, NULL),
(34922, '2017-06-23 09:39:01', NULL, NULL, 10303, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:39:01', 'admin-1498178121-14981819407842339', 1, 1, 'SR', NULL, NULL, NULL),
(34923, '2017-06-23 09:39:01', NULL, NULL, 10303, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:39:01', 'admin-1498178121-14981819407842339', 1, 0, '', NULL, NULL, NULL),
(34924, '2017-06-23 09:39:01', NULL, NULL, 10303, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:39:01', 'admin-1498178121-14981819407842339', 1, 1, 'SR', NULL, NULL, NULL),
(34925, '2017-06-23 09:39:01', NULL, NULL, 10303, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:39:01', 'admin-1498178121-14981819407842339', 1, 1, 'SR', NULL, NULL, NULL),
(34926, '2017-06-23 09:39:00', NULL, NULL, 10303, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:39:00', 'admin-1498178121-14981819407842339', 1, 1, 'SR', NULL, NULL, NULL),
(34927, '2017-06-23 09:38:44', NULL, NULL, 10303, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 2, 15.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:38:44', 'admin-1498178121-14981819242506599', 1, 0, '', NULL, NULL, NULL),
(34928, '2017-06-23 09:38:44', NULL, NULL, 10303, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:38:44', 'admin-1498178121-14981819242506599', 1, 0, '', NULL, NULL, NULL),
(34929, '2017-06-23 09:38:44', NULL, NULL, 10303, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:38:44', 'admin-1498178121-14981819242506599', 1, 0, '', NULL, NULL, NULL),
(34930, '2017-06-23 09:38:44', NULL, NULL, 10303, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:38:44', 'admin-1498178121-14981819242506599', 1, 0, '', NULL, NULL, NULL),
(34931, '2017-06-23 09:38:44', NULL, NULL, 10303, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:38:44', 'admin-1498178121-14981819242506599', 1, 0, '', NULL, NULL, NULL),
(34932, '2017-06-23 09:35:08', NULL, NULL, 10302, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:35:08', 'admin-1498178121-14981817082537950', 1, 1, 'SR', NULL, NULL, NULL),
(34933, '2017-06-23 09:34:54', NULL, NULL, 10302, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:34:54', 'admin-1498178121-14981816947821651', 1, 0, '', NULL, NULL, NULL),
(34934, '2017-06-23 09:34:54', NULL, NULL, 10302, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:34:54', 'admin-1498178121-14981816947821651', 1, 0, '', NULL, NULL, NULL),
(34935, '2017-06-23 09:12:25', NULL, NULL, 10301, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1498195504', 'admin', '2017-06-23 09:12:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34936, '2017-06-24 12:10:57', NULL, NULL, 10339, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:10:57', 'admin-1498274427-14982774570919110', 1, 1, 'SR', NULL, NULL, NULL),
(34937, '2017-06-24 12:10:57', NULL, NULL, 10339, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:10:57', 'admin-1498274427-14982774570919110', 1, 1, 'SR', NULL, NULL, NULL),
(34938, '2017-06-24 12:12:10', NULL, NULL, 10340, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:12:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34939, '2017-06-24 12:12:25', NULL, NULL, 10340, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:12:25', 'admin-1498274427-14982775454145469', 1, 1, 'SR', NULL, NULL, NULL),
(34940, '2017-06-24 12:12:25', NULL, NULL, 10340, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:12:25', 'admin-1498274427-14982775454145469', 1, 1, 'SR', NULL, NULL, NULL),
(34941, '2017-06-24 14:54:55', NULL, NULL, 10348, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1498287316', 'admin', '2017-06-24 14:54:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34942, '2017-06-24 12:12:25', NULL, NULL, 10340, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:12:25', 'admin-1498274427-14982775454145469', 1, 0, '', NULL, NULL, NULL),
(34943, '2017-06-24 15:28:29', NULL, NULL, 10350, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 15:28:29', 'admin-1498287316-14982893092439638', 1, 1, 'SR', NULL, NULL, NULL),
(34944, '2017-06-24 13:03:07', NULL, NULL, 10340, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 13:03:07', 'admin-1498280579-14982805875992548', 1, 1, 'SR', NULL, NULL, NULL),
(34945, '2017-06-24 13:05:44', NULL, NULL, 10343, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1498287316', 'admin', '2017-06-24 13:05:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34946, '2017-06-24 13:07:59', NULL, NULL, 10343, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 13:07:59', 'admin-1498280579-14982808793485645', 1, 0, '', NULL, NULL, NULL),
(34947, '2017-06-24 13:07:59', NULL, NULL, 10343, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 13:07:59', 'admin-1498280579-14982808793485645', 1, 0, '', NULL, NULL, NULL),
(34948, '2017-06-24 12:19:18', NULL, NULL, 10341, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:19:18', 'admin-1498274427-14982779581974027', 1, 1, 'SR', NULL, NULL, NULL),
(34949, '2017-06-24 12:19:18', NULL, NULL, 10341, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:19:18', 'admin-1498274427-14982779581974027', 1, 1, 'SR', NULL, NULL, NULL),
(34950, '2017-06-24 12:19:18', NULL, NULL, 10341, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:19:18', 'admin-1498274427-14982779581974027', 1, 1, 'SR', NULL, NULL, NULL),
(34951, '2017-06-24 12:19:18', NULL, NULL, 10341, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:19:18', 'admin-1498274427-14982779581974027', 1, 0, '', NULL, NULL, NULL),
(34952, '2017-06-24 12:19:18', NULL, NULL, 10341, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:19:18', 'admin-1498274427-14982779581974027', 1, 0, '', NULL, NULL, NULL),
(34953, '2017-06-24 12:19:18', NULL, NULL, 10341, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:19:18', 'admin-1498274427-14982779581974027', 1, 0, '', NULL, NULL, NULL),
(34954, '2017-06-24 12:19:18', NULL, NULL, 10341, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:19:18', 'admin-1498274427-14982779581974027', 1, 0, '', NULL, NULL, NULL),
(34955, '2017-06-24 12:19:18', NULL, NULL, 10341, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:19:18', 'admin-1498274427-14982779581974027', 1, 0, '', NULL, NULL, NULL),
(34956, '2017-06-24 12:18:57', NULL, NULL, 10341, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.10, 0.0000, 0.0000, 10.10, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:18:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34957, '2017-06-24 13:07:59', NULL, NULL, 10343, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 13:07:59', 'admin-1498280579-14982808793485645', 1, 1, 'SR', NULL, NULL, NULL),
(34958, '2017-06-24 13:07:59', NULL, NULL, 10343, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 13:07:59', 'admin-1498280579-14982808793485645', 1, 1, 'SR', NULL, NULL, NULL),
(34959, '2017-06-24 13:08:05', NULL, NULL, 10344, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.10, 0.0000, 0.0000, 14.10, 1, '27', 1, '1498287316', 'admin', '2017-06-24 13:08:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34960, '2017-06-24 13:08:21', NULL, NULL, 10344, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 13:08:21', 'admin-1498280579-14982809008568586', 1, 0, '', NULL, NULL, NULL),
(34961, '2017-06-24 10:27:09', NULL, NULL, 10326, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:27:09', 'admin-1498270351-14982712290804858', 1, 1, 'SR', NULL, NULL, NULL),
(34962, '2017-06-24 10:31:03', NULL, NULL, 10327, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:31:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34963, '2017-06-24 10:31:36', NULL, NULL, 10327, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:31:36', 'admin-1498270351-1498271496477655', 1, 0, '', NULL, NULL, NULL),
(34964, '2017-06-24 10:31:36', NULL, NULL, 10327, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:31:36', 'admin-1498270351-1498271496477655', 1, 0, '', NULL, NULL, NULL),
(34965, '2017-06-24 10:31:36', NULL, NULL, 10327, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:31:36', 'admin-1498270351-1498271496477655', 1, 1, 'SR', NULL, NULL, NULL),
(34966, '2017-06-24 10:31:36', NULL, NULL, 10327, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:31:36', 'admin-1498270351-1498271496477655', 1, 1, 'SR', NULL, NULL, NULL),
(34967, '2017-06-24 13:08:21', NULL, NULL, 10344, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 13:08:21', 'admin-1498280579-14982809008568586', 1, 0, '', NULL, NULL, NULL),
(34968, '2017-06-24 14:22:17', NULL, NULL, 10347, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1498287316', 'admin', '2017-06-24 14:22:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34969, '2017-06-24 13:25:39', NULL, NULL, 10345, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 13:25:39', 'admin-1498280579-14982819395128317', 1, 0, '', NULL, NULL, NULL),
(34970, '2017-06-24 13:40:24', NULL, NULL, 10345, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 13:40:24', 'admin-1498280579-14982828246444841', 1, 0, '', NULL, NULL, NULL),
(34971, '2017-06-24 16:58:36', NULL, NULL, 10353, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 16:58:36', 'admin-1498287316-14982947163428187', 1, 1, 'SR', NULL, NULL, NULL),
(34972, '2017-06-24 16:58:22', NULL, NULL, 10353, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1498287316', 'admin', '2017-06-24 16:58:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34973, '2017-06-24 16:58:36', NULL, NULL, 10353, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 16:58:36', 'admin-1498287316-14982947163428187', 1, 0, '', NULL, NULL, NULL),
(34974, '2017-06-24 16:58:36', NULL, NULL, 10353, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 16:58:36', 'admin-1498287316-14982947163428187', 1, 1, 'SR', NULL, NULL, NULL),
(34975, '2017-06-24 16:44:37', NULL, NULL, 10352, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 16:44:37', 'admin-1498287316-1498293877633964', 1, 0, '', 1, NULL, '10.0'),
(34976, '2017-06-24 16:31:21', NULL, NULL, 10343, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 16:31:21', 'admin-1498287316-14982930814015647', 1, 1, 'SR', NULL, NULL, NULL),
(34977, '2017-06-24 16:13:31', NULL, NULL, 10351, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 16:13:31', 'admin-1498287316-14982920108474952', 1, 1, 'SR', 1, NULL, '10.0'),
(34978, '2017-06-24 16:13:31', NULL, NULL, 10351, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 16:13:31', 'admin-1498287316-14982920108474952', 1, 1, 'SR', 1, NULL, '10.0'),
(34979, '2017-06-24 13:24:38', NULL, NULL, 10345, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1498287316', 'admin', '2017-06-24 13:24:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34980, '2017-06-24 12:12:25', NULL, NULL, 10340, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:12:25', 'admin-1498274427-14982775454145469', 1, 0, '', NULL, NULL, NULL),
(34981, '2017-06-24 14:55:10', NULL, NULL, 10348, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 14:55:10', 'admin-1498280579-1498287309955837', 1, 1, 'SR', NULL, NULL, NULL),
(34982, '2017-06-24 14:55:10', NULL, NULL, 10348, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 14:55:10', 'admin-1498280579-1498287309955837', 1, 1, 'SR', NULL, NULL, NULL),
(34983, '2017-06-24 14:55:10', NULL, NULL, 10348, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 14:55:10', 'admin-1498280579-1498287309955837', 1, 1, 'SR', NULL, NULL, NULL),
(34984, '2017-06-24 15:07:39', NULL, NULL, 10349, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1498287316', 'admin', '2017-06-24 15:07:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34985, '2017-06-24 15:07:46', NULL, NULL, 10349, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 15:07:46', 'admin-1498287316-14982880666976486', 1, 1, 'SR', NULL, NULL, NULL),
(34986, '2017-06-24 15:07:46', NULL, NULL, 10349, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 15:07:46', 'admin-1498287316-14982880666976486', 1, 0, '', NULL, NULL, NULL),
(34987, '2017-06-24 15:28:17', NULL, NULL, 10350, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1498287316', 'admin', '2017-06-24 15:28:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34988, '2017-06-24 12:05:33', NULL, NULL, 10338, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:05:33', 'admin-1498274427-14982771335207959', 1, 1, 'SR', NULL, NULL, NULL),
(34989, '2017-06-24 13:08:21', NULL, NULL, 10344, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 13:08:21', 'admin-1498280579-14982809008568586', 1, 0, '', NULL, NULL, NULL),
(34990, '2017-06-24 14:22:22', NULL, NULL, 10347, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 14:22:22', 'admin-1498280579-14982853420984061', 1, 1, 'SR', NULL, NULL, NULL),
(34991, '2017-06-24 14:22:22', NULL, NULL, 10347, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 14:22:22', 'admin-1498280579-14982853420984061', 1, 1, 'SR', NULL, NULL, NULL),
(34992, '2017-06-24 13:24:46', NULL, NULL, 10345, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 13:24:46', 'admin-1498280579-1498281886299399', 1, 1, 'SR', NULL, NULL, NULL),
(34993, '2017-06-24 13:32:35', NULL, NULL, 10346, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 13:32:35', 'admin-1498280579-1498282355193561', 1, 1, 'SR', NULL, NULL, NULL),
(34994, '2017-06-24 13:32:35', NULL, NULL, 10346, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 13:32:35', 'admin-1498280579-1498282355193561', 1, 1, 'SR', NULL, NULL, NULL),
(34995, '2017-06-24 13:25:39', NULL, NULL, 10345, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 13:25:39', 'admin-1498280579-14982819395128317', 1, 0, '', NULL, NULL, NULL),
(34996, '2017-06-24 13:32:25', NULL, NULL, 10346, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1498287316', 'admin', '2017-06-24 13:32:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34997, '2017-06-24 10:51:08', NULL, NULL, 10330, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:51:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(34998, '2017-06-24 10:52:24', NULL, NULL, 10330, 0, 153, '87', 'Wake Me Up!', 'no beans', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:52:24', 'admin-1498271540-1498272744184578', 1, 0, '', NULL, NULL, NULL),
(34999, '2017-06-24 10:52:24', NULL, NULL, 10330, 0, 155, '89', 'Cheesy Chicken Gratin', 'add sausage', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:52:24', 'admin-1498271540-1498272744184578', 1, 0, '', NULL, NULL, NULL),
(35000, '2017-06-24 13:23:59', NULL, NULL, 10337, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 13:23:59', 'admin-1498280579-14982818392633215', 1, 1, 'SR', NULL, NULL, '10.0'),
(35001, '2017-06-24 12:03:22', NULL, NULL, 10337, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:03:22', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(35002, '2017-06-24 12:03:25', NULL, NULL, 10337, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:03:25', 'admin-1498274427-14982770056654755', 1, 1, 'SR', NULL, NULL, '10.0'),
(35003, '2017-06-24 12:10:57', NULL, NULL, 10339, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:10:57', 'admin-1498274427-14982774570919110', 1, 0, '', NULL, NULL, NULL),
(35004, '2017-06-24 12:10:57', NULL, NULL, 10339, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:10:57', 'admin-1498274427-14982774570919110', 1, 0, '', NULL, NULL, NULL),
(35005, '2017-06-24 11:20:36', NULL, NULL, 10334, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 11:20:36', 'admin-1498274427-1498274436212582', 1, 1, 'SR', NULL, NULL, NULL),
(35006, '2017-06-24 11:20:16', NULL, NULL, 10334, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1498287316', 'admin', '2017-06-24 11:20:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35007, '2017-06-24 11:20:22', NULL, NULL, 10334, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 11:20:22', 'admin-1498271540-14982744220472158', 1, 0, '', NULL, NULL, NULL),
(35008, '2017-06-24 13:00:02', NULL, NULL, 10337, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 13:00:02', 'admin-1498274427-14982804018324331', 1, 1, 'SR', NULL, NULL, '10.0'),
(35009, '2017-06-24 12:44:01', NULL, NULL, 10342, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:44:01', 'admin-1498274427-14982794417735883', 1, 1, 'SR', NULL, NULL, NULL),
(35010, '2017-06-24 12:43:57', NULL, NULL, 10342, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:43:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35011, '2017-06-24 12:20:09', NULL, NULL, 10328, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:20:09', 'admin-1498274427-14982780096471053', 1, 1, 'SR', NULL, NULL, NULL),
(35012, '2017-06-24 12:00:29', NULL, NULL, 10336, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:00:29', 'admin-1498274427-14982768297998218', 1, 1, 'SR', NULL, NULL, '10.0'),
(35013, '2017-06-24 11:24:46', NULL, NULL, 10335, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1498287316', 'admin', '2017-06-24 11:24:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35014, '2017-06-24 11:24:51', NULL, NULL, 10335, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 11:24:51', 'admin-1498274427-14982746917658558', 1, 1, 'SR', NULL, NULL, NULL),
(35015, '2017-06-24 11:29:55', NULL, NULL, 10321, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 11:29:55', 'admin-1498274427-1498274994872869', 1, 0, '', NULL, NULL, NULL),
(35016, '2017-06-24 12:05:26', NULL, NULL, 10338, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:05:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35017, '2017-06-24 13:08:21', NULL, NULL, 10344, NULL, 57, '57', 'House Red Bottle', '', 'Cold Drinks', 'Wine', 1, 88.00, 88.0000, 0.0000, 88.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 13:08:21', 'admin-1498280579-14982809008568586', 1, 1, 'SR', NULL, NULL, NULL),
(35018, '2017-06-24 10:52:24', NULL, NULL, 10330, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:52:24', 'admin-1498271540-1498272744184578', 1, 0, '', NULL, NULL, NULL),
(35019, '2017-06-24 10:52:39', NULL, NULL, 10330, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:52:39', 'admin-1498271540-14982727591008123', 1, 1, 'SR', NULL, NULL, NULL),
(35020, '2017-06-24 10:52:39', NULL, NULL, 10330, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:52:39', 'admin-1498271540-14982727591008123', 1, 1, 'SR', NULL, NULL, NULL),
(35021, '2017-06-24 10:52:39', NULL, NULL, 10330, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:52:39', 'admin-1498271540-14982727591008123', 1, 0, '', NULL, NULL, NULL),
(35022, '2017-06-24 11:01:25', NULL, NULL, 10331, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1498287316', 'admin', '2017-06-24 11:01:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35023, '2017-06-24 11:01:30', NULL, NULL, 10331, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 11:01:30', 'admin-1498271540-1498273290526603', 1, 0, '', NULL, NULL, NULL),
(35024, '2017-06-24 11:01:30', NULL, NULL, 10331, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 11:01:30', 'admin-1498271540-1498273290526603', 1, 1, 'SR', NULL, NULL, NULL),
(35025, '2017-06-24 11:10:17', NULL, NULL, 10332, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1498287316', 'admin', '2017-06-24 11:10:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35026, '2017-06-24 12:10:43', NULL, NULL, 10339, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:10:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35027, '2017-06-24 12:10:57', NULL, NULL, 10339, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:10:57', 'admin-1498274427-14982774570919110', 1, 1, 'SR', NULL, NULL, NULL),
(35028, '2017-06-24 11:18:42', NULL, NULL, 10333, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 11:18:42', 'admin-1498271540-14982743218549559', 1, 1, 'SR', NULL, NULL, NULL),
(35029, '2017-06-24 12:05:33', NULL, NULL, 10338, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:05:33', 'admin-1498274427-14982771335207959', 1, 0, '', NULL, NULL, NULL),
(35030, '2017-06-24 12:00:29', NULL, NULL, 10336, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:00:29', 'admin-1498274427-14982768297998218', 1, 1, 'SR', NULL, NULL, '10.0'),
(35031, '2017-06-24 11:20:36', NULL, NULL, 10334, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 11:20:36', 'admin-1498274427-1498274436212582', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(35032, '2017-06-24 11:22:18', NULL, NULL, 10328, 0, 181, '116', 'Open Food ', 'macadamia scone', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 11:22:18', 'admin-1498274427-14982745386906148', 1, 0, '', NULL, NULL, NULL),
(35033, '2017-06-24 10:19:01', NULL, NULL, 10324, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.60, 0.0000, 0.0000, 9.60, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:19:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35034, '2017-06-24 10:19:17', NULL, NULL, 10324, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:19:17', 'admin-1498270351-14982707570268397', 1, 0, '', NULL, NULL, NULL),
(35035, '2017-06-24 10:19:17', NULL, NULL, 10324, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:19:17', 'admin-1498270351-14982707570268397', 1, 0, '', NULL, NULL, NULL),
(35036, '2017-06-24 10:19:17', NULL, NULL, 10324, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:19:17', 'admin-1498270351-14982707570268397', 1, 0, '', NULL, NULL, NULL),
(35037, '2017-06-24 10:37:06', NULL, NULL, 10324, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:37:06', 'admin-1498271540-14982718259553587', 1, 0, '', NULL, NULL, NULL),
(35038, '2017-06-24 10:19:36', NULL, NULL, 10324, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:19:36', 'admin-1498270351-14982707758746265', 1, 1, 'SR', NULL, NULL, NULL),
(35039, '2017-06-24 10:19:36', NULL, NULL, 10324, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:19:36', 'admin-1498270351-14982707758746265', 1, 1, 'SR', NULL, NULL, NULL),
(35040, '2017-06-24 10:19:36', NULL, NULL, 10324, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:19:36', 'admin-1498270351-14982707758746265', 1, 1, 'SR', NULL, NULL, NULL),
(35041, '2017-06-24 10:19:36', NULL, NULL, 10324, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:19:36', 'admin-1498270351-14982707758746265', 1, 1, 'SR', NULL, NULL, NULL),
(35042, '2017-06-24 10:24:47', NULL, NULL, 10325, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:24:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35043, '2017-06-24 10:24:59', NULL, NULL, 10325, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:24:59', 'admin-1498270351-1498271099110323', 1, 0, '', NULL, NULL, NULL),
(35044, '2017-06-24 09:37:43', NULL, NULL, 10318, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 09:37:43', 'admin-1498265512-14982682636997831', 1, 1, 'SR', NULL, NULL, NULL),
(35045, '2017-06-24 09:34:02', NULL, NULL, 10318, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 09:34:02', 'admin-1498265512-14982680427745633', 1, 0, '', NULL, NULL, NULL),
(35046, '2017-06-24 09:34:02', NULL, NULL, 10318, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 09:34:02', 'admin-1498265512-14982680427745633', 1, 0, '', NULL, NULL, NULL),
(35047, '2017-06-24 09:34:02', NULL, NULL, 10318, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 09:34:02', 'admin-1498265512-14982680427745633', 1, 1, 'SR', NULL, NULL, NULL),
(35048, '2017-06-24 11:18:42', NULL, NULL, 10333, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 11:18:42', 'admin-1498271540-14982743218549559', 1, 1, 'SR', NULL, NULL, NULL),
(35049, '2017-06-24 11:18:33', NULL, NULL, 10333, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1498287316', 'admin', '2017-06-24 11:18:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35050, '2017-06-24 11:10:30', NULL, NULL, 10332, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 11:10:30', 'admin-1498271540-14982738304717693', 1, 1, 'SR', NULL, NULL, NULL),
(35051, '2017-06-24 11:10:30', NULL, NULL, 10332, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 11:10:30', 'admin-1498271540-14982738304717693', 1, 1, 'SR', NULL, NULL, NULL),
(35052, '2017-06-24 11:10:30', NULL, NULL, 10332, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 11:10:30', 'admin-1498271540-14982738304717693', 1, 0, '', NULL, NULL, NULL),
(35053, '2017-06-24 11:20:22', NULL, NULL, 10334, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 11:20:22', 'admin-1498271540-14982744220472158', 1, 0, '', NULL, NULL, NULL),
(35054, '2017-06-24 11:10:30', NULL, NULL, 10332, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 11:10:30', 'admin-1498271540-14982738304717693', 1, 0, '', NULL, NULL, NULL),
(35055, '2017-06-24 10:38:20', NULL, NULL, 10329, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:38:20', 'admin-1498271540-14982719003545546', 1, 0, '', NULL, NULL, NULL),
(35056, '2017-06-24 10:31:50', NULL, NULL, 10328, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:31:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35057, '2017-06-24 10:31:59', NULL, NULL, 10328, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:31:59', 'admin-1498270351-14982715192309437', 1, 0, '', NULL, NULL, NULL),
(35058, '2017-06-24 10:33:58', NULL, NULL, 10328, 0, 182, '117', 'Open Drinks ', 'tea', 'Cold Drinks', 'Fresh Juice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:33:58', 'admin-1498271540-14982716387186263', 1, 0, '', NULL, NULL, NULL),
(35059, '2017-06-24 10:38:11', NULL, NULL, 10329, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:38:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35060, '2017-06-24 10:24:59', NULL, NULL, 10325, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:24:59', 'admin-1498270351-1498271099110323', 1, 0, '', NULL, NULL, NULL),
(35061, '2017-06-24 10:24:59', NULL, NULL, 10325, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:24:59', 'admin-1498270351-1498271099110323', 1, 0, '', NULL, NULL, NULL),
(35062, '2017-06-24 10:25:10', NULL, NULL, 10325, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:25:10', 'admin-1498270351-14982711105332180', 1, 1, 'SR', NULL, NULL, NULL),
(35063, '2017-06-24 10:25:10', NULL, NULL, 10325, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:25:10', 'admin-1498270351-14982711105332180', 1, 1, 'SR', NULL, NULL, NULL),
(35064, '2017-06-24 10:26:29', NULL, NULL, 10326, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:26:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35065, '2017-06-24 10:26:39', NULL, NULL, 10326, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:26:39', 'admin-1498270351-14982711989256453', 1, 0, '', NULL, NULL, NULL),
(35066, '2017-06-24 10:27:09', NULL, NULL, 10326, 0, 269, '203', 'Espresso Con Panna', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:27:09', 'admin-1498270351-14982712290804858', 1, 0, '', NULL, NULL, NULL),
(35067, '2017-06-24 10:38:20', NULL, NULL, 10329, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:38:20', 'admin-1498271540-14982719003545546', 1, 0, '', NULL, NULL, NULL),
(35068, '2017-06-24 10:12:39', NULL, NULL, 10322, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:12:39', 'admin-1498270351-14982703590056557', 1, 1, 'SR', NULL, NULL, NULL),
(35069, '2017-06-24 09:46:30', NULL, NULL, 10318, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 09:46:30', 'admin-1498265512-1498268790347657', 1, 0, '', NULL, NULL, NULL),
(35070, '2017-06-24 09:54:20', NULL, NULL, 10320, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1498287316', 'admin', '2017-06-24 09:54:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35071, '2017-06-24 09:54:31', NULL, NULL, 10320, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 09:54:31', 'admin-1498265512-14982692717019320', 1, 0, '', NULL, NULL, NULL),
(35072, '2017-06-24 10:27:09', NULL, NULL, 10326, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:27:09', 'admin-1498270351-14982712290804858', 1, 1, 'SR', NULL, NULL, NULL),
(35073, '2017-06-24 10:16:31', NULL, NULL, 10323, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:16:31', 'admin-1498270351-14982705910103032', 1, 1, 'SR', NULL, NULL, NULL),
(35074, '2017-06-24 10:16:31', NULL, NULL, 10323, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:16:31', 'admin-1498270351-14982705910103032', 1, 0, '', NULL, NULL, NULL),
(35075, '2017-06-24 10:16:31', NULL, NULL, 10323, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:16:31', 'admin-1498270351-14982705910103032', 1, 1, 'SR', NULL, NULL, NULL),
(35076, '2017-06-24 09:03:47', NULL, NULL, 10317, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 09:03:47', 'admin-1498265512-1498266227449786', 1, 0, '', NULL, NULL, NULL),
(35077, '2017-06-24 10:14:30', NULL, NULL, 10323, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:14:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35078, '2017-06-24 10:16:31', NULL, NULL, 10323, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:16:31', 'admin-1498270351-14982705910103032', 1, 0, '', NULL, NULL, NULL),
(35079, '2017-06-24 10:12:39', NULL, NULL, 10322, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:12:39', 'admin-1498270351-14982703590056557', 1, 1, 'SR', NULL, NULL, NULL),
(35080, '2017-06-24 10:11:52', NULL, NULL, 10322, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:11:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35081, '2017-06-24 10:11:55', NULL, NULL, 10322, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:11:55', 'admin-1498265512-14982703154822456', 1, 0, '', NULL, NULL, NULL),
(35082, '2017-06-24 10:11:55', NULL, NULL, 10322, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:11:55', 'admin-1498265512-14982703154822456', 1, 0, '', NULL, NULL, NULL),
(35083, '2017-06-24 10:05:00', NULL, NULL, 10321, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:05:00', 'admin-1498265512-1498269900227125', 1, 0, '', NULL, NULL, NULL),
(35084, '2017-06-24 10:05:00', NULL, NULL, 10321, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:05:00', 'admin-1498265512-1498269900227125', 1, 0, '', NULL, NULL, NULL),
(35085, '2017-06-24 10:05:00', NULL, NULL, 10321, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:05:00', 'admin-1498265512-1498269900227125', 1, 0, '', NULL, NULL, NULL),
(35086, '2017-06-24 10:05:00', NULL, NULL, 10321, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:05:00', 'admin-1498265512-1498269900227125', 1, 0, '', NULL, NULL, NULL),
(35087, '2017-06-24 10:04:52', NULL, NULL, 10321, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1498287316', 'admin', '2017-06-24 10:04:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35088, '2017-06-24 09:54:31', NULL, NULL, 10320, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 09:54:31', 'admin-1498265512-14982692717019320', 1, 0, '', NULL, NULL, NULL),
(35089, '2017-06-24 09:54:31', NULL, NULL, 10320, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 09:54:31', 'admin-1498265512-14982692717019320', 1, 0, '', NULL, NULL, NULL),
(35090, '2017-06-24 09:46:05', NULL, NULL, 10319, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 09:46:05', 'admin-1498265512-14982687653885032', 1, 1, 'SR', NULL, NULL, NULL),
(35091, '2017-06-24 09:46:05', NULL, NULL, 10319, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 09:46:05', 'admin-1498265512-14982687653885032', 1, 1, 'SR', NULL, NULL, NULL),
(35092, '2017-06-24 09:45:54', NULL, NULL, 10319, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 09:45:54', 'admin-1498265512-14982687540872931', 1, 0, '', NULL, NULL, NULL),
(35093, '2017-06-24 09:45:54', NULL, NULL, 10319, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 09:45:54', 'admin-1498265512-14982687540872931', 1, 0, '', NULL, NULL, NULL),
(35094, '2017-06-24 09:45:35', NULL, NULL, 10319, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1498287316', 'admin', '2017-06-24 09:45:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35095, '2017-06-24 12:10:57', NULL, NULL, 10339, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 12:10:57', 'admin-1498274427-14982774570919110', 1, 0, '', NULL, NULL, NULL),
(35096, '2017-06-24 09:37:43', NULL, NULL, 10318, 0, 176, '111', 'Scones ', '', 'Desserts', '0', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 09:37:43', 'admin-1498265512-14982682636997831', 1, 0, '', NULL, NULL, NULL),
(35097, '2017-06-24 09:34:02', NULL, NULL, 10318, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 09:34:02', 'admin-1498265512-14982680427745633', 1, 1, 'SR', NULL, NULL, NULL),
(35098, '2017-06-24 09:03:47', NULL, NULL, 10317, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 09:03:47', 'admin-1498265512-1498266227449786', 1, 1, 'SR', NULL, NULL, NULL),
(35099, '2017-06-24 09:31:52', NULL, NULL, 10318, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1498287316', 'admin', '2017-06-24 09:31:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35100, '2017-06-24 09:03:38', NULL, NULL, 10317, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1498287316', 'admin', '2017-06-24 09:03:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35101, '2017-06-25 15:54:42', NULL, NULL, 10414, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:54:42', 'admin-1498370688-14983772820869012', 1, 1, 'SR', NULL, NULL, NULL),
(35102, '2017-06-25 15:04:03', NULL, NULL, 10407, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:04:03', 'admin-1498370688-14983742428201537', 1, 1, 'SR', NULL, NULL, NULL),
(35103, '2017-06-25 15:05:17', NULL, NULL, 10407, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:05:17', 'admin-1498370688-14983743171064893', 1, 1, 'SR', NULL, NULL, NULL),
(35104, '2017-06-25 15:05:17', NULL, NULL, 10407, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:05:17', 'admin-1498370688-14983743171064893', 1, 0, '', NULL, NULL, NULL),
(35105, '2017-06-25 15:05:17', NULL, NULL, 10407, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:05:17', 'admin-1498370688-14983743171064893', 1, 1, 'SR', NULL, NULL, NULL),
(35106, '2017-06-25 15:05:26', NULL, NULL, 10407, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:05:26', 'admin-1498370688-1498374326037129', 1, 0, '', NULL, NULL, NULL),
(35107, '2017-06-25 15:07:33', NULL, NULL, 10408, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:07:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35108, '2017-06-25 15:07:40', NULL, NULL, 10408, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:07:40', 'admin-1498370688-14983744602091264', 1, 1, 'SR', NULL, NULL, NULL),
(35109, '2017-06-25 15:07:40', NULL, NULL, 10408, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:07:40', 'admin-1498370688-14983744602091264', 1, 1, 'SR', NULL, NULL, NULL),
(35110, '2017-06-25 14:03:29', NULL, NULL, 10400, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:03:29', 'admin-1498369441-14983706093492145', 1, 0, '', NULL, NULL, NULL),
(35111, '2017-06-25 14:03:29', NULL, NULL, 10400, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:03:29', 'admin-1498369441-14983706093492145', 1, 1, 'SR', NULL, NULL, NULL),
(35112, '2017-06-25 11:27:33', NULL, NULL, 10375, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:27:33', 'admin-1498358543-1498361253557318', 1, 1, 'SR', NULL, NULL, NULL),
(35113, '2017-06-25 11:27:33', NULL, NULL, 10375, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:27:33', 'admin-1498358543-1498361253557318', 1, 1, 'SR', NULL, NULL, NULL),
(35114, '2017-06-25 11:29:12', NULL, NULL, 10376, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.10, 0.0000, 0.0000, 11.10, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:29:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35115, '2017-06-25 11:29:46', NULL, NULL, 10376, 0, 153, '87', 'Wake Me Up!', 'sunny side up', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:29:46', 'admin-1498358543-14983613864695481', 1, 0, '', NULL, NULL, NULL),
(35116, '2017-06-25 11:29:46', NULL, NULL, 10376, 0, 154, '88', 'Daily Dose BLT', 'sceambled egg', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:29:46', 'admin-1498358543-14983613864695481', 1, 0, '', NULL, NULL, NULL),
(35117, '2017-06-25 11:29:46', NULL, NULL, 10376, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:29:46', 'admin-1498358543-14983613864695481', 1, 0, '', NULL, NULL, NULL),
(35118, '2017-06-25 14:01:17', NULL, NULL, 10399, 0, 181, '116', 'Open Food ', 'add bacon', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:01:17', 'admin-1498369441-14983704775948990', 1, 0, '', 1, NULL, '10.0'),
(35119, '2017-06-25 13:28:33', NULL, NULL, 10398, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:28:33', 'admin-1498367574-1498368513159355', 1, 1, 'SR', NULL, NULL, NULL),
(35120, '2017-06-25 12:18:21', NULL, NULL, 10387, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:18:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35121, '2017-06-25 00:00:00', NULL, NULL, 10417, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:32:43', 'admin-1498370688-14983759628734539', 1, 0, '', NULL, NULL, NULL),
(35122, '2017-06-25 14:02:28', NULL, NULL, 10400, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:02:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35123, '2017-06-25 14:01:17', NULL, NULL, 10399, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:01:17', 'admin-1498369441-14983704775948990', 1, 0, '', 1, NULL, '10.0'),
(35124, '2017-06-25 13:43:52', NULL, NULL, 10397, 0, 181, '116', 'Open Food ', 'takeaway home town', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:43:52', 'admin-1498367574-14983694324962518', 1, 0, '', NULL, NULL, NULL),
(35125, '2017-06-25 12:23:37', NULL, NULL, 10389, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:23:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35126, '2017-06-25 12:24:04', NULL, NULL, 10389, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:24:04', 'admin-1498362580-1498364644229387', 1, 0, '', NULL, NULL, NULL),
(35127, '2017-06-25 13:43:52', NULL, NULL, 10397, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:43:52', 'admin-1498367574-14983694324962518', 1, 0, '', NULL, NULL, NULL),
(35128, '2017-06-25 13:39:50', NULL, NULL, 10356, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:39:50', 'admin-1498367574-1498369190351537', 1, 0, '', NULL, NULL, NULL),
(35129, '2017-06-25 13:28:52', NULL, NULL, 10398, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:28:52', 'admin-1498367574-14983685321428689', 1, 1, 'SR', NULL, NULL, NULL),
(35130, '2017-06-25 13:30:46', NULL, NULL, 10396, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:30:46', 'admin-1498367574-14983686464202753', 1, 0, '', NULL, NULL, NULL),
(35131, '2017-06-25 12:25:30', NULL, NULL, 10389, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:25:30', 'admin-1498362580-14983647303273498', 1, 1, 'SR', NULL, NULL, NULL),
(35132, '2017-06-25 12:14:57', NULL, NULL, 10386, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:14:57', 'admin-1498362580-14983640973225570', 1, 0, '', NULL, NULL, NULL),
(35133, '2017-06-25 12:14:57', NULL, NULL, 10386, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:14:57', 'admin-1498362580-14983640973225570', 1, 0, '', NULL, NULL, NULL),
(35134, '2017-06-25 12:14:57', NULL, NULL, 10386, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:14:57', 'admin-1498362580-14983640973225570', 1, 0, '', NULL, NULL, NULL),
(35135, '2017-06-25 12:14:57', NULL, NULL, 10386, 0, 153, '87', 'Wake Me Up!', 'no bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:14:57', 'admin-1498362580-14983640973225570', 1, 0, '', NULL, NULL, NULL),
(35136, '2017-06-25 00:00:00', NULL, NULL, 10390, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:48:34', 'admin-1498361406-1498362514707991', 1, 0, '', NULL, NULL, NULL),
(35137, '2017-06-25 11:36:14', NULL, NULL, 10379, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:36:14', 'admin-1498361406-14983617740568151', 1, 1, 'SR', NULL, NULL, NULL),
(35138, '2017-06-25 11:19:42', NULL, NULL, 10374, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:19:42', 'admin-1498358543-14983607825737666', 1, 0, '', NULL, NULL, NULL),
(35139, '2017-06-25 11:19:42', NULL, NULL, 10374, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:19:42', 'admin-1498358543-14983607825737666', 1, 1, 'SR', NULL, NULL, NULL),
(35140, '2017-06-25 14:47:04', NULL, NULL, 10405, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:47:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35141, '2017-06-25 12:14:57', NULL, NULL, 10386, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:14:57', 'admin-1498362580-14983640973225570', 1, 1, 'SR', NULL, NULL, NULL),
(35142, '2017-06-25 12:14:57', NULL, NULL, 10386, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:14:57', 'admin-1498362580-14983640973225570', 1, 1, 'SR', NULL, NULL, NULL),
(35143, '2017-06-25 00:00:00', NULL, NULL, 10391, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:48:34', 'admin-1498361406-1498362514707991', 1, 1, 'SR', NULL, NULL, NULL),
(35144, '2017-06-25 12:13:47', NULL, NULL, 10386, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.80, 0.0000, 0.0000, 9.80, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:13:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35145, '2017-06-25 12:14:57', NULL, NULL, 10386, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:14:57', 'admin-1498362580-14983640973225570', 1, 1, 'SR', NULL, NULL, NULL),
(35146, '2017-06-25 12:01:01', NULL, NULL, 10356, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:01:01', 'admin-1498362580-1498363261743214', 1, 1, 'SR', NULL, NULL, NULL),
(35147, '2017-06-25 12:00:37', NULL, NULL, 10384, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:00:37', 'admin-1498362580-14983632377368095', 1, 1, 'SR', NULL, NULL, NULL),
(35148, '2017-06-25 11:40:17', NULL, NULL, 10381, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:40:17', 'admin-1498361406-14983620170887934', 1, 1, 'SR', NULL, NULL, NULL),
(35149, '2017-06-25 16:47:56', NULL, NULL, 10419, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 16:47:56', 'admin-1498370688-1498380475860599', 1, 1, 'SR', NULL, NULL, NULL),
(35150, '2017-06-25 16:56:08', NULL, NULL, 10420, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1498370688', 'admin', '2017-06-25 16:56:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35151, '2017-06-25 16:56:22', NULL, NULL, 10420, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 16:56:22', 'admin-1498370688-14983809825866919', 1, 1, 'SR', NULL, NULL, NULL),
(35152, '2017-06-25 12:00:33', NULL, NULL, 10384, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:00:33', 'admin-1498362580-14983632328765927', 1, 0, '', NULL, NULL, NULL),
(35153, '2017-06-25 12:00:09', NULL, NULL, 10385, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:00:09', 'admin-1498362580-14983632092706343', 1, 1, 'SR', NULL, NULL, NULL),
(35154, '2017-06-25 12:00:09', NULL, NULL, 10385, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:00:09', 'admin-1498362580-14983632092706343', 1, 0, '', NULL, NULL, NULL),
(35155, '2017-06-25 12:00:01', NULL, NULL, 10385, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:00:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35156, '2017-06-25 11:59:54', NULL, NULL, 10384, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:59:54', 'admin-1498362580-14983631945961146', 1, 0, '', NULL, NULL, NULL),
(35157, '2017-06-25 11:59:54', NULL, NULL, 10384, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:59:54', 'admin-1498362580-14983631945961146', 1, 1, 'SR', NULL, NULL, NULL),
(35158, '2017-06-25 11:59:54', NULL, NULL, 10384, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:59:54', 'admin-1498362580-14983631945961146', 1, 1, 'SR', NULL, NULL, NULL),
(35159, '2017-06-25 11:59:35', NULL, NULL, 10384, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:59:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35160, '2017-06-25 11:49:34', NULL, NULL, 10383, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:49:34', 'admin-1498361406-149836257435669', 1, 1, 'SR', NULL, NULL, NULL),
(35161, '2017-06-25 15:25:10', NULL, NULL, 10410, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:25:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35162, '2017-06-25 15:25:19', NULL, NULL, 10410, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:25:19', 'admin-1498370688-1498375519127612', 1, 0, '', NULL, NULL, NULL),
(35163, '2017-06-25 15:27:13', NULL, NULL, 10411, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:27:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35164, '2017-06-25 15:27:28', NULL, NULL, 10411, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:27:28', 'admin-1498370688-14983756478989580', 1, 1, 'SR', NULL, NULL, NULL),
(35165, '2017-06-25 15:27:28', NULL, NULL, 10411, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:27:28', 'admin-1498370688-14983756478989580', 1, 1, 'SR', NULL, NULL, NULL),
(35166, '2017-06-25 15:28:55', NULL, NULL, 10411, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:28:55', 'admin-1498370688-1498375735520498', 1, 1, 'SR', NULL, NULL, NULL),
(35167, '2017-06-25 15:28:55', NULL, NULL, 10411, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:28:55', 'admin-1498370688-1498375735520498', 1, 1, 'SR', NULL, NULL, NULL),
(35168, '2017-06-25 16:21:43', NULL, NULL, 10415, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 16:21:43', 'admin-1498370688-14983789030069444', 1, 0, '', NULL, NULL, NULL),
(35169, '2017-06-25 16:29:16', NULL, NULL, 10416, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1498370688', 'admin', '2017-06-25 16:29:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35170, '2017-06-25 16:29:24', NULL, NULL, 10416, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 16:29:24', 'admin-1498370688-14983793646652751', 1, 0, '', NULL, NULL, NULL),
(35171, '2017-06-25 14:52:36', NULL, NULL, 10406, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:52:36', 'admin-1498370688-14983735564325940', 1, 1, 'SR', NULL, NULL, NULL),
(35172, '2017-06-25 14:03:29', NULL, NULL, 10400, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:03:29', 'admin-1498369441-14983706093492145', 1, 0, '', NULL, NULL, NULL),
(35173, '2017-06-25 14:47:46', NULL, NULL, 10405, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:47:46', 'admin-1498370688-1498373266150425', 1, 0, '', NULL, NULL, NULL),
(35174, '2017-06-25 14:47:46', NULL, NULL, 10405, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:47:46', 'admin-1498370688-1498373266150425', 1, 1, 'SR', NULL, NULL, NULL),
(35175, '2017-06-25 13:28:52', NULL, NULL, 10398, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:28:52', 'admin-1498367574-14983685321428689', 1, 1, 'SR', NULL, NULL, NULL),
(35176, '2017-06-25 13:28:52', NULL, NULL, 10398, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:28:52', 'admin-1498367574-14983685321428689', 1, 1, 'SR', NULL, NULL, NULL),
(35177, '2017-06-25 13:13:11', NULL, NULL, 10397, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:13:11', 'admin-1498367574-14983675911935250', 1, 1, 'SR', NULL, NULL, NULL),
(35178, '2017-06-25 13:15:11', NULL, NULL, 10393, 0, 181, '116', 'Open Food ', 'Scone Set', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:15:11', 'admin-1498367574-14983677114559948', 1, 0, '', NULL, NULL, NULL),
(35179, '2017-06-25 13:28:12', NULL, NULL, 10398, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:28:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35180, '2017-06-25 13:28:21', NULL, NULL, 10398, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:28:21', 'admin-1498367574-14983685010863726', 1, 0, '', NULL, NULL, NULL),
(35181, '2017-06-25 13:10:43', NULL, NULL, 10397, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:10:43', 'admin-1498365799-14983674429176677', 1, 0, '', NULL, NULL, NULL),
(35182, '2017-06-25 13:11:03', NULL, NULL, 10397, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:11:03', 'admin-1498365799-14983674632262181', 1, 1, 'SR', NULL, NULL, NULL),
(35183, '2017-06-25 13:12:16', NULL, NULL, 10397, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:12:16', 'admin-1498365799-1498367536367445', 1, 1, 'SR', NULL, NULL, NULL),
(35184, '2017-06-25 13:12:24', NULL, NULL, 10392, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:12:24', 'admin-1498365799-14983675442293166', 1, 0, '', NULL, NULL, NULL),
(35185, '2017-06-25 14:11:08', NULL, NULL, 10402, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:11:08', 'admin-1498370688-14983710681143642', 1, 1, 'SR', NULL, NULL, NULL),
(35186, '2017-06-25 14:36:29', NULL, NULL, 10356, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:36:29', 'admin-1498370688-14983725888611664', 1, 1, 'SR', NULL, NULL, NULL),
(35187, '2017-06-25 12:21:01', NULL, NULL, 10388, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:21:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35188, '2017-06-25 12:46:11', NULL, NULL, 10392, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:46:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35189, '2017-06-25 17:48:04', NULL, NULL, 10421, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1498370688', 'admin', '2017-06-25 17:48:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35190, '2017-06-25 17:48:10', NULL, NULL, 10421, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 17:48:10', 'admin-1498370688-14983840906845696', 1, 1, 'SR', NULL, NULL, NULL),
(35191, '2017-06-25 17:12:48', NULL, NULL, 10419, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 17:12:48', 'admin-1498370688-14983819686928061', 1, 1, 'SR', NULL, NULL, NULL),
(35192, '2017-06-25 15:54:42', NULL, NULL, 10414, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:54:42', 'admin-1498370688-14983772820869012', 1, 1, 'SR', NULL, NULL, NULL),
(35193, '2017-06-25 00:00:00', NULL, NULL, 10418, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:32:43', 'admin-1498370688-14983759628734539', 1, 1, 'SR', NULL, NULL, NULL),
(35194, '2017-06-25 15:50:56', NULL, NULL, 10413, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:50:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35195, '2017-06-25 15:51:10', NULL, NULL, 10413, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:51:10', 'admin-1498370688-14983770707047353', 1, 1, 'SR', NULL, NULL, NULL),
(35196, '2017-06-25 15:51:10', NULL, NULL, 10413, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:51:10', 'admin-1498370688-14983770707047353', 1, 1, 'SR', NULL, NULL, NULL),
(35197, '2017-06-25 14:43:56', NULL, NULL, 10404, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:43:56', 'admin-1498370688-14983730361014426', 1, 1, 'SR', NULL, NULL, NULL),
(35198, '2017-06-25 14:43:56', NULL, NULL, 10404, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:43:56', 'admin-1498370688-14983730361014426', 1, 0, '', NULL, NULL, NULL),
(35199, '2017-06-25 14:43:20', NULL, NULL, 10404, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:43:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35200, '2017-06-25 14:48:30', NULL, NULL, 10405, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:48:30', 'admin-1498370688-14983733097784295', 1, 0, '', NULL, NULL, NULL),
(35201, '2017-06-25 14:48:30', NULL, NULL, 10405, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:48:30', 'admin-1498370688-14983733097784295', 1, 1, 'SR', NULL, NULL, NULL),
(35202, '2017-06-25 14:48:30', NULL, NULL, 10405, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:48:30', 'admin-1498370688-14983733097784295', 1, 1, 'SR', NULL, NULL, NULL),
(35203, '2017-06-25 13:10:43', NULL, NULL, 10397, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:10:43', 'admin-1498365799-14983674429176677', 1, 0, '', NULL, NULL, NULL),
(35204, '2017-06-25 12:25:30', NULL, NULL, 10389, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:25:30', 'admin-1498362580-14983647303273498', 1, 0, '', NULL, NULL, NULL),
(35205, '2017-06-25 13:10:10', NULL, NULL, 10397, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:10:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35206, '2017-06-25 13:02:19', NULL, NULL, 10396, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:02:19', 'admin-1498365799-14983669394899575', 1, 1, 'SR', NULL, NULL, NULL),
(35207, '2017-06-25 13:02:19', NULL, NULL, 10396, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:02:19', 'admin-1498365799-14983669394899575', 1, 1, 'SR', NULL, NULL, NULL),
(35208, '2017-06-25 13:01:23', NULL, NULL, 10396, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:01:23', 'admin-1498365799-14983668832808378', 1, 1, 'SR', NULL, NULL, NULL),
(35209, '2017-06-25 11:40:32', NULL, NULL, 10381, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:40:32', 'admin-1498361406-14983620324541360', 1, 0, '', NULL, NULL, NULL),
(35210, '2017-06-25 00:00:00', NULL, NULL, 10418, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:34:41', 'admin-1498370688-14983760817403395', 1, 0, '', NULL, NULL, NULL),
(35211, '2017-06-25 16:47:52', NULL, NULL, 10419, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1498370688', 'admin', '2017-06-25 16:47:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35212, '2017-06-25 15:58:34', NULL, NULL, 10414, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:58:34', 'admin-1498370688-14983775142665121', 1, 0, '', NULL, NULL, NULL),
(35213, '2017-06-25 16:19:39', NULL, NULL, 10415, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1498370688', 'admin', '2017-06-25 16:19:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35214, '2017-06-25 16:20:20', NULL, NULL, 10415, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 16:20:20', 'admin-1498370688-14983788206608565', 1, 0, '', NULL, NULL, NULL),
(35215, '2017-06-25 16:20:20', NULL, NULL, 10415, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 16:20:20', 'admin-1498370688-14983788206608565', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(35216, '2017-06-25 16:19:55', NULL, NULL, 10415, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 16:19:55', 'admin-1498370688-14983787953456565', 1, 1, 'SR', NULL, NULL, NULL),
(35217, '2017-06-25 16:42:34', NULL, NULL, 10417, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1498370688', 'admin', '2017-06-25 16:42:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35218, '2017-06-25 14:05:44', NULL, NULL, 10401, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:05:44', 'admin-1498370688-14983707440722953', 1, 0, '', NULL, NULL, NULL),
(35219, '2017-06-25 13:01:23', NULL, NULL, 10396, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:01:23', 'admin-1498365799-14983668832808378', 1, 1, 'SR', NULL, NULL, NULL),
(35220, '2017-06-25 15:54:42', NULL, NULL, 10414, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:54:42', 'admin-1498370688-14983772820869012', 1, 0, '', NULL, NULL, NULL),
(35221, '2017-06-25 15:58:34', NULL, NULL, 10414, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:58:34', 'admin-1498370688-14983775142665121', 1, 0, '', NULL, NULL, NULL),
(35222, '2017-06-25 15:54:42', NULL, NULL, 10414, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:54:42', 'admin-1498370688-14983772820869012', 1, 1, 'SR', NULL, NULL, NULL),
(35223, '2017-06-25 15:54:42', NULL, NULL, 10414, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:54:42', 'admin-1498370688-14983772820869012', 1, 0, '', NULL, NULL, NULL),
(35224, '2017-06-25 12:59:53', NULL, NULL, 10396, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.40, 0.0000, 0.0000, 11.40, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:59:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35225, '2017-06-25 12:51:26', NULL, NULL, 10395, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:51:26', 'admin-1498365799-14983662864378437', 1, 1, 'SR', NULL, NULL, NULL),
(35226, '2017-06-25 12:51:26', NULL, NULL, 10395, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:51:26', 'admin-1498365799-14983662864378437', 1, 1, 'SR', NULL, NULL, NULL),
(35227, '2017-06-25 12:49:12', NULL, NULL, 10394, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:49:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35228, '2017-06-25 12:49:27', NULL, NULL, 10394, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:49:27', 'admin-1498365799-14983661667861821', 1, 0, '', NULL, NULL, NULL),
(35229, '2017-06-25 12:51:22', NULL, NULL, 10395, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:51:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35230, '2017-06-25 12:48:47', NULL, NULL, 10393, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:48:47', 'admin-1498365799-14983661270596667', 1, 0, '', NULL, NULL, NULL),
(35231, '2017-06-25 12:48:41', NULL, NULL, 10393, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:48:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35232, '2017-06-25 12:46:52', NULL, NULL, 10392, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:46:52', 'admin-1498365799-14983660127315819', 1, 1, 'SR', NULL, NULL, NULL),
(35233, '2017-06-25 12:46:40', NULL, NULL, 10392, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:46:40', 'admin-1498365799-14983660002781826', 1, 0, '', NULL, NULL, NULL),
(35234, '2017-06-25 12:46:40', NULL, NULL, 10392, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:46:40', 'admin-1498365799-14983660002781826', 1, 0, '', NULL, NULL, NULL),
(35235, '2017-06-25 12:46:40', NULL, NULL, 10392, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:46:40', 'admin-1498365799-14983660002781826', 1, 1, 'SR', NULL, NULL, NULL),
(35236, '2017-06-25 12:42:44', NULL, NULL, 10383, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:42:44', 'admin-1498362580-14983657642569935', 1, 1, 'SR', NULL, NULL, NULL),
(35237, '2017-06-25 15:53:46', NULL, NULL, 10414, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:53:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35238, '2017-06-25 15:53:57', NULL, NULL, 10414, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:53:57', 'admin-1498370688-14983772368618083', 1, 0, '', NULL, NULL, NULL),
(35239, '2017-06-25 00:00:00', NULL, NULL, 10418, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, NULL, NULL, 2.70, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:30:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35240, '2017-06-25 14:52:24', NULL, NULL, 10406, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:52:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35241, '2017-06-25 15:20:41', NULL, NULL, 10409, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:20:41', 'admin-1498370688-14983752411424378', 1, 0, '', 1, NULL, '10.0'),
(35242, '2017-06-25 14:47:46', NULL, NULL, 10405, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:47:46', 'admin-1498370688-1498373266150425', 1, 0, '', NULL, NULL, NULL),
(35243, '2017-06-25 14:11:08', NULL, NULL, 10402, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:11:08', 'admin-1498370688-14983710681143642', 1, 1, 'SR', NULL, NULL, NULL),
(35244, '2017-06-25 14:06:01', NULL, NULL, 10401, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:06:01', 'admin-1498370688-14983707609686459', 1, 1, 'SR', NULL, NULL, NULL),
(35245, '2017-06-25 14:10:58', NULL, NULL, 10402, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:10:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35246, '2017-06-25 14:03:29', NULL, NULL, 10400, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:03:29', 'admin-1498369441-14983706093492145', 1, 0, '', NULL, NULL, NULL),
(35247, '2017-06-25 14:05:29', NULL, NULL, 10401, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1498370688', 'admin', '2017-06-25 14:05:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35248, '2017-06-25 13:04:05', NULL, NULL, 10396, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:04:05', 'admin-1498365799-14983670447836334', 1, 1, 'SR', NULL, NULL, NULL),
(35249, '2017-06-25 00:00:00', NULL, NULL, 10391, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:05:02', 'admin-1498362580-14983635025257351', 1, 1, 'SR', NULL, NULL, NULL),
(35250, '2017-06-25 12:25:30', NULL, NULL, 10389, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:25:30', 'admin-1498362580-14983647303273498', 1, 0, '', NULL, NULL, NULL),
(35251, '2017-06-25 12:21:43', NULL, NULL, 10388, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:21:43', 'admin-1498362580-14983645028939225', 1, 0, '', NULL, NULL, NULL),
(35252, '2017-06-25 12:24:04', NULL, NULL, 10389, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:24:04', 'admin-1498362580-1498364644229387', 1, 1, 'SR', NULL, NULL, NULL),
(35253, '2017-06-25 12:21:43', NULL, NULL, 10388, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:21:43', 'admin-1498362580-14983645028939225', 1, 0, '', NULL, NULL, NULL),
(35254, '2017-06-25 12:21:16', NULL, NULL, 10388, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:21:16', 'admin-1498362580-1498364476137139', 1, 1, 'SR', NULL, NULL, NULL),
(35255, '2017-06-25 12:21:16', NULL, NULL, 10388, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:21:16', 'admin-1498362580-1498364476137139', 1, 1, 'SR', NULL, NULL, NULL),
(35256, '2017-06-25 11:34:41', NULL, NULL, 10378, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.35, 0.0000, 0.0000, 2.35, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:34:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35257, '2017-06-25 11:49:34', NULL, NULL, 10383, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:49:34', 'admin-1498361406-149836257435669', 1, 1, 'SR', NULL, NULL, NULL),
(35258, '2017-06-25 11:33:57', NULL, NULL, 10377, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:33:57', 'admin-1498361406-14983616373324529', 1, 0, '', NULL, NULL, NULL),
(35259, '2017-06-25 16:56:22', NULL, NULL, 10420, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 16:56:22', 'admin-1498370688-14983809825866919', 1, 1, 'SR', NULL, NULL, NULL),
(35260, '2017-06-25 11:33:52', NULL, NULL, 10377, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:33:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35261, '2017-06-25 11:27:33', NULL, NULL, 10375, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:27:33', 'admin-1498358543-1498361253557318', 1, 0, '', NULL, NULL, NULL),
(35262, '2017-06-25 12:18:25', NULL, NULL, 10387, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:18:25', 'admin-1498362580-14983643053373714', 1, 0, '', NULL, NULL, NULL),
(35263, '2017-06-25 12:39:24', NULL, NULL, 10390, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:39:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35264, '2017-06-25 11:48:52', NULL, NULL, 10375, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:48:52', 'admin-1498361406-14983625319795898', 1, 1, 'SR', NULL, NULL, NULL),
(35265, '2017-06-25 11:49:06', NULL, NULL, 10383, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:49:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35266, '2017-06-25 11:49:34', NULL, NULL, 10383, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:49:34', 'admin-1498361406-149836257435669', 1, 0, '', NULL, NULL, NULL),
(35267, '2017-06-25 11:49:34', NULL, NULL, 10383, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:49:34', 'admin-1498361406-149836257435669', 1, 0, '', NULL, NULL, NULL),
(35268, '2017-06-25 00:00:00', NULL, NULL, 10391, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:48:34', 'admin-1498361406-1498362514707991', 1, 0, '', NULL, NULL, NULL),
(35269, '2017-06-25 00:00:00', NULL, NULL, 10391, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, NULL, NULL, 3.40, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:47:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35270, '2017-06-25 00:00:00', NULL, NULL, 10390, 0, 269, '203', 'Espresso Con Panna', '', 'Hot Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:48:35', 'admin-1498361406-1498362514707991', 1, 0, '', NULL, NULL, NULL),
(35271, '2017-06-25 11:45:39', NULL, NULL, 10378, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:45:39', 'admin-1498361406-14983623392272016', 1, 0, '', NULL, NULL, NULL),
(35272, '2017-06-25 11:36:57', NULL, NULL, 10380, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:36:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35273, '2017-06-25 15:32:56', NULL, NULL, 10411, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:32:56', 'admin-1498370688-14983759761325010', 1, 1, 'SR', NULL, NULL, NULL),
(35274, '2017-06-25 11:39:40', NULL, NULL, 10381, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:39:40', 'admin-1498361406-14983619805668712', 1, 0, '', NULL, NULL, NULL),
(35275, '2017-06-25 11:37:25', NULL, NULL, 10381, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:37:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35276, '2017-06-25 11:37:00', NULL, NULL, 10380, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:37:00', 'admin-1498361406-14983618200595028', 1, 0, '', NULL, NULL, NULL),
(35277, '2017-06-25 11:36:14', NULL, NULL, 10379, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:36:14', 'admin-1498361406-14983617740568151', 1, 1, 'SR', NULL, NULL, NULL),
(35278, '2017-06-25 11:36:14', NULL, NULL, 10379, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:36:14', 'admin-1498361406-14983617740568151', 1, 0, '', NULL, NULL, NULL),
(35279, '2017-06-25 11:36:00', NULL, NULL, 10379, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:36:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35280, '2017-06-25 11:34:46', NULL, NULL, 10378, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:34:46', 'admin-1498361406-14983616865328427', 1, 1, 'SR', NULL, NULL, NULL),
(35281, '2017-06-25 11:29:46', NULL, NULL, 10376, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:29:46', 'admin-1498358543-14983613864695481', 1, 1, 'SR', NULL, NULL, NULL),
(35282, '2017-06-25 11:29:46', NULL, NULL, 10376, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:29:46', 'admin-1498358543-14983613864695481', 1, 0, '', NULL, NULL, NULL),
(35283, '2017-06-25 11:33:57', NULL, NULL, 10377, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:33:57', 'admin-1498361406-14983616373324529', 1, 0, '', NULL, NULL, NULL),
(35284, '2017-06-25 11:34:46', NULL, NULL, 10378, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:34:46', 'admin-1498361406-14983616865328427', 1, 1, 'SR', NULL, NULL, NULL),
(35285, '2017-06-25 11:31:26', NULL, NULL, 10376, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:31:26', 'admin-1498361406-14983614860498218', 1, 1, 'SR', NULL, NULL, NULL),
(35286, '2017-06-25 11:29:46', NULL, NULL, 10376, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:29:46', 'admin-1498358543-14983613864695481', 1, 1, 'SR', NULL, NULL, NULL),
(35287, '2017-06-25 11:31:26', NULL, NULL, 10376, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:31:26', 'admin-1498361406-14983614860498218', 1, 0, '', NULL, NULL, NULL),
(35288, '2017-06-25 09:24:25', NULL, NULL, 10356, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:24:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35289, '2017-06-25 09:24:58', NULL, NULL, 10356, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:24:58', 'admin-1498350984-14983538983807832', 1, 1, 'SR', NULL, NULL, NULL),
(35290, '2017-06-25 09:24:58', NULL, NULL, 10356, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:24:58', 'admin-1498350984-14983538983807832', 1, 0, '', NULL, NULL, NULL),
(35291, '2017-06-25 15:01:28', NULL, NULL, 10407, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1498370688', 'admin', '2017-06-25 15:01:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35292, '2017-06-25 11:11:27', NULL, NULL, 10372, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:11:27', 'admin-1498358543-1498360287830312', 1, 1, 'SR', NULL, NULL, NULL),
(35293, '2017-06-25 10:56:42', NULL, NULL, 10371, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:56:42', 'admin-1498358543-1498359402760893', 1, 0, '', NULL, NULL, NULL),
(35294, '2017-06-25 10:56:43', NULL, NULL, 10371, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:56:43', 'admin-1498358543-1498359402760893', 1, 0, '', NULL, NULL, NULL),
(35295, '2017-06-25 10:57:11', NULL, NULL, 10371, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:57:11', 'admin-1498358543-14983594310897053', 1, 1, 'SR', NULL, NULL, NULL),
(35296, '2017-06-25 10:33:49', NULL, NULL, 10365, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:33:49', 'admin-1498357366-14983580295859562', 1, 0, '', NULL, NULL, NULL),
(35297, '2017-06-25 09:11:53', NULL, NULL, 10354, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:11:53', 'admin-1498350984-1498353113684929', 1, 1, 'SR', NULL, NULL, NULL),
(35298, '2017-06-25 09:19:31', NULL, NULL, 10355, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:19:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35299, '2017-06-25 09:19:37', NULL, NULL, 10355, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:19:37', 'admin-1498350984-14983535774549864', 1, 0, '', NULL, NULL, NULL),
(35300, '2017-06-25 09:19:37', NULL, NULL, 10355, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:19:37', 'admin-1498350984-14983535774549864', 1, 1, 'SR', NULL, NULL, NULL),
(35301, '2017-06-25 13:04:05', NULL, NULL, 10396, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:04:05', 'admin-1498365799-14983670447836334', 1, 0, '', NULL, NULL, NULL),
(35302, '2017-06-25 13:01:23', NULL, NULL, 10396, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 13:01:23', 'admin-1498365799-14983668832808378', 1, 1, 'SR', NULL, NULL, NULL),
(35303, '2017-06-25 11:27:33', NULL, NULL, 10375, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:27:33', 'admin-1498358543-1498361253557318', 1, 1, 'SR', NULL, NULL, NULL),
(35304, '2017-06-25 11:27:33', NULL, NULL, 10375, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:27:33', 'admin-1498358543-1498361253557318', 1, 0, '', NULL, NULL, NULL),
(35305, '2017-06-25 11:27:17', NULL, NULL, 10375, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:27:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35306, '2017-06-25 10:57:11', NULL, NULL, 10371, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:57:11', 'admin-1498358543-14983594310897053', 1, 1, 'SR', NULL, NULL, NULL),
(35307, '2017-06-25 11:01:33', NULL, NULL, 10363, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:01:33', 'admin-1498358543-14983596937206445', 1, 1, 'SR', NULL, NULL, NULL),
(35308, '2017-06-25 11:20:05', NULL, NULL, 10374, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:20:05', 'admin-1498358543-14983608048513080', 1, 1, 'SR', NULL, NULL, NULL),
(35309, '2017-06-25 11:20:05', NULL, NULL, 10374, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:20:05', 'admin-1498358543-14983608048513080', 1, 0, '', NULL, NULL, NULL),
(35310, '2017-06-25 11:20:05', NULL, NULL, 10374, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:20:05', 'admin-1498358543-14983608048513080', 1, 0, '', NULL, NULL, NULL),
(35311, '2017-06-25 11:19:42', NULL, NULL, 10374, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:19:42', 'admin-1498358543-14983607825737666', 1, 1, 'SR', NULL, NULL, NULL),
(35312, '2017-06-25 10:52:08', NULL, NULL, 10370, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:52:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35313, '2017-06-25 10:52:18', NULL, NULL, 10370, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:52:18', 'admin-1498358543-14983591379792562', 1, 0, '', NULL, NULL, NULL),
(35314, '2017-06-25 10:52:18', NULL, NULL, 10370, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:52:18', 'admin-1498358543-14983591379792562', 1, 0, '', NULL, NULL, NULL),
(35315, '2017-06-25 10:52:18', NULL, NULL, 10370, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:52:18', 'admin-1498358543-14983591379792562', 1, 1, 'SR', NULL, NULL, NULL),
(35316, '2017-06-25 10:52:18', NULL, NULL, 10370, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:52:18', 'admin-1498358543-14983591379792562', 1, 1, 'SR', NULL, NULL, NULL),
(35317, '2017-06-25 10:33:49', NULL, NULL, 10365, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:33:49', 'admin-1498357366-14983580295859562', 1, 1, 'SR', NULL, NULL, NULL),
(35318, '2017-06-25 10:33:49', NULL, NULL, 10365, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:33:49', 'admin-1498357366-14983580295859562', 1, 1, 'SR', NULL, NULL, NULL),
(35319, '2017-06-25 11:19:42', NULL, NULL, 10374, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:19:42', 'admin-1498358543-14983607825737666', 1, 0, '', NULL, NULL, NULL),
(35320, '2017-06-25 11:19:42', NULL, NULL, 10374, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:19:42', 'admin-1498358543-14983607825737666', 1, 0, '', NULL, NULL, NULL),
(35321, '2017-06-25 11:10:53', NULL, NULL, 10372, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:10:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35322, '2017-06-25 11:01:48', NULL, NULL, 10363, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:01:48', 'admin-1498358543-14983597079294454', 1, 0, '', NULL, NULL, NULL),
(35323, '2017-06-25 12:14:57', NULL, NULL, 10386, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 12:14:57', 'admin-1498362580-14983640973225570', 1, 1, 'SR', NULL, NULL, NULL),
(35324, '2017-06-25 11:01:33', NULL, NULL, 10363, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:01:33', 'admin-1498358543-14983596937206445', 1, 0, '', NULL, NULL, NULL),
(35325, '2017-06-25 11:01:33', NULL, NULL, 10363, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:01:33', 'admin-1498358543-14983596937206445', 1, 0, '', NULL, NULL, NULL),
(35326, '2017-06-25 10:56:30', NULL, NULL, 10371, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:56:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35327, '2017-06-25 10:16:47', NULL, NULL, 10362, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:16:47', 'admin-1498355160-14983570076775093', 1, 1, 'SR', NULL, NULL, NULL),
(35328, '2017-06-25 10:16:47', NULL, NULL, 10362, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:16:47', 'admin-1498355160-14983570076775093', 1, 0, '', NULL, NULL, NULL),
(35329, '2017-06-25 10:30:35', NULL, NULL, 10364, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:30:35', 'admin-1498357366-14983578352743294', 1, 1, 'SR', NULL, NULL, NULL),
(35330, '2017-06-25 10:27:31', NULL, NULL, 10363, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:27:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35331, '2017-06-25 10:27:44', NULL, NULL, 10363, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:27:44', 'admin-1498357366-14983576643247048', 1, 0, '', NULL, NULL, NULL),
(35332, '2017-06-25 10:27:44', NULL, NULL, 10363, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:27:44', 'admin-1498357366-14983576643247048', 1, 0, '', NULL, NULL, NULL),
(35333, '2017-06-25 10:27:44', NULL, NULL, 10363, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:27:44', 'admin-1498357366-14983576643247048', 1, 1, 'SR', NULL, NULL, NULL),
(35334, '2017-06-25 10:29:24', NULL, NULL, 10364, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:29:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35335, '2017-06-25 10:33:34', NULL, NULL, 10365, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:33:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35336, '2017-06-25 09:10:41', NULL, NULL, 10354, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:10:41', 'admin-1498350984-14983530410522127', 1, 0, '', NULL, NULL, NULL),
(35337, '2017-06-25 10:42:38', NULL, NULL, 10369, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:42:38', 'admin-1498358543-14983585578327271', 1, 1, 'SR', NULL, NULL, NULL),
(35338, '2017-06-25 10:42:38', NULL, NULL, 10369, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:42:38', 'admin-1498358543-14983585578327271', 1, 1, 'SR', NULL, NULL, NULL),
(35339, '2017-06-25 10:41:59', NULL, NULL, 10369, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:41:59', 'admin-1498357366-14983585193413547', 1, 0, '', NULL, NULL, NULL),
(35340, '2017-06-25 10:41:59', NULL, NULL, 10369, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:41:59', 'admin-1498357366-14983585193413547', 1, 0, '', NULL, NULL, NULL),
(35341, '2017-06-25 10:36:03', NULL, NULL, 10368, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:36:03', 'admin-1498357366-1498358163550648', 1, 0, '', NULL, NULL, NULL),
(35342, '2017-06-25 10:37:39', NULL, NULL, 10368, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:37:39', 'admin-1498357366-14983582593746697', 1, 1, 'SR', NULL, NULL, NULL),
(35343, '2017-06-25 11:19:23', NULL, NULL, 10374, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.40, 0.0000, 0.0000, 11.40, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:19:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35344, '2017-06-25 11:16:44', NULL, NULL, 10373, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:16:44', 'admin-1498358543-14983606039335544', 1, 1, 'SR', NULL, NULL, NULL),
(35345, '2017-06-25 10:16:19', NULL, NULL, 10361, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:16:19', 'admin-1498355160-14983569791113855', 1, 0, '', NULL, NULL, NULL),
(35346, '2017-06-25 10:41:49', NULL, NULL, 10369, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:41:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35347, '2017-06-25 10:37:39', NULL, NULL, 10368, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:37:39', 'admin-1498357366-14983582593746697', 1, 1, 'SR', NULL, NULL, NULL),
(35348, '2017-06-25 10:36:03', NULL, NULL, 10368, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:36:03', 'admin-1498357366-1498358163550648', 1, 0, '', NULL, NULL, NULL),
(35349, '2017-06-25 10:36:03', NULL, NULL, 10368, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:36:03', 'admin-1498357366-1498358163550648', 1, 0, '', NULL, NULL, NULL),
(35350, '2017-06-25 10:35:31', NULL, NULL, 10368, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:35:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35351, '2017-06-25 10:34:58', NULL, NULL, 10367, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:34:58', 'admin-1498357366-14983580984164113', 1, 1, 'SR', NULL, NULL, NULL),
(35352, '2017-06-25 10:34:58', NULL, NULL, 10367, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:34:58', 'admin-1498357366-14983580984164113', 1, 0, '', NULL, NULL, NULL),
(35353, '2017-06-25 10:09:23', NULL, NULL, 10359, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:09:23', 'admin-1498355160-14983565628895021', 1, 1, 'SR', NULL, NULL, NULL),
(35354, '2017-06-25 10:09:23', NULL, NULL, 10359, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:09:23', 'admin-1498355160-14983565628895021', 1, 1, 'SR', NULL, NULL, NULL),
(35355, '2017-06-25 10:13:43', NULL, NULL, 10360, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:13:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35356, '2017-06-25 10:13:54', NULL, NULL, 10360, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:13:54', 'admin-1498355160-14983568345822327', 1, 0, '', NULL, NULL, NULL),
(35357, '2017-06-25 10:13:54', NULL, NULL, 10360, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:13:54', 'admin-1498355160-14983568345822327', 1, 0, '', NULL, NULL, NULL),
(35358, '2017-06-25 10:13:54', NULL, NULL, 10360, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:13:54', 'admin-1498355160-14983568345822327', 1, 0, '', NULL, NULL, NULL),
(35359, '2017-06-25 10:13:54', NULL, NULL, 10360, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:13:54', 'admin-1498355160-14983568345822327', 1, 1, 'SR', NULL, NULL, NULL),
(35360, '2017-06-25 10:13:54', NULL, NULL, 10360, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:13:54', 'admin-1498355160-14983568345822327', 1, 1, 'SR', NULL, NULL, NULL),
(35361, '2017-06-25 10:13:54', NULL, NULL, 10360, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:13:54', 'admin-1498355160-14983568345822327', 1, 1, 'SR', NULL, NULL, NULL),
(35362, '2017-06-25 10:34:58', NULL, NULL, 10367, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:34:58', 'admin-1498357366-14983580984164113', 1, 0, '', NULL, NULL, NULL),
(35363, '2017-06-25 11:16:36', NULL, NULL, 10373, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:16:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35364, '2017-06-25 10:34:50', NULL, NULL, 10367, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:34:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35365, '2017-06-25 10:15:52', NULL, NULL, 10361, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:15:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35366, '2017-06-25 09:45:32', NULL, NULL, 10357, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:45:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35367, '2017-06-25 09:45:45', NULL, NULL, 10357, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:45:45', 'admin-1498350984-14983551456321554', 1, 0, '', NULL, NULL, NULL),
(35368, '2017-06-25 09:45:45', NULL, NULL, 10357, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:45:45', 'admin-1498350984-14983551456321554', 1, 0, '', NULL, NULL, NULL),
(35369, '2017-06-25 11:27:33', NULL, NULL, 10375, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 11:27:33', 'admin-1498358543-1498361253557318', 1, 0, '', NULL, NULL, NULL),
(35370, '2017-06-25 10:16:47', NULL, NULL, 10362, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:16:47', 'admin-1498355160-14983570076775093', 1, 1, 'SR', NULL, NULL, NULL),
(35371, '2017-06-25 10:16:19', NULL, NULL, 10361, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:16:19', 'admin-1498355160-14983569791113855', 1, 0, '', NULL, NULL, NULL),
(35372, '2017-06-25 10:16:27', NULL, NULL, 10362, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:16:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35373, '2017-06-25 09:52:25', NULL, NULL, 10358, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:52:25', 'admin-1498355160-14983555454129645', 1, 0, '', NULL, NULL, NULL),
(35374, '2017-06-25 09:52:25', NULL, NULL, 10358, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:52:25', 'admin-1498355160-14983555454129645', 1, 1, 'SR', NULL, NULL, NULL),
(35375, '2017-06-25 10:09:09', NULL, NULL, 10359, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:09:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35376, '2017-06-25 10:09:23', NULL, NULL, 10359, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:09:23', 'admin-1498355160-14983565628895021', 1, 0, '', NULL, NULL, NULL),
(35377, '2017-06-25 10:09:23', NULL, NULL, 10359, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:09:23', 'admin-1498355160-14983565628895021', 1, 0, '', NULL, NULL, NULL),
(35378, '2017-06-25 10:09:23', NULL, NULL, 10359, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 10:09:23', 'admin-1498355160-14983565628895021', 1, 0, '', NULL, NULL, NULL),
(35379, '2017-06-25 09:52:18', NULL, NULL, 10358, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:52:18', 'admin-1498355160-14983555381689896', 1, 0, '', NULL, NULL, NULL),
(35380, '2017-06-25 09:52:18', NULL, NULL, 10358, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:52:18', 'admin-1498355160-14983555381689896', 1, 0, '', NULL, NULL, NULL),
(35381, '2017-06-25 09:46:12', NULL, NULL, 10357, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:46:12', 'admin-1498355160-14983551725143652', 1, 1, 'SR', NULL, NULL, NULL),
(35382, '2017-06-25 09:52:11', NULL, NULL, 10358, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:52:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35383, '2017-06-25 09:46:12', NULL, NULL, 10357, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:46:12', 'admin-1498355160-14983551725143652', 1, 1, 'SR', NULL, NULL, NULL),
(35384, '2017-06-25 09:46:12', NULL, NULL, 10357, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:46:12', 'admin-1498355160-14983551725143652', 1, 1, 'SR', NULL, NULL, NULL),
(35385, '2017-06-25 09:45:45', NULL, NULL, 10357, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:45:45', 'admin-1498350984-14983551456321554', 1, 0, '', NULL, NULL, NULL),
(35386, '2017-06-25 09:45:45', NULL, NULL, 10357, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:45:45', 'admin-1498350984-14983551456321554', 1, 0, '', NULL, NULL, NULL),
(35387, '2017-06-25 09:45:29', NULL, NULL, 10354, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:45:29', 'admin-1498350984-14983551287967113', 1, 0, '', NULL, NULL, NULL),
(35388, '2017-06-25 09:24:58', NULL, NULL, 10356, 0, 182, '117', 'Open Drinks ', 'banana', 'Cold Drinks', 'Fresh Juice', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:24:58', 'admin-1498350984-14983538983807832', 1, 0, '', NULL, NULL, NULL),
(35389, '2017-06-25 09:23:49', NULL, NULL, 10355, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:23:49', 'admin-1498350984-14983538297158074', 1, 0, '', NULL, NULL, NULL),
(35390, '2017-06-25 09:11:53', NULL, NULL, 10354, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:11:53', 'admin-1498350984-1498353113684929', 1, 1, 'SR', NULL, NULL, NULL),
(35391, '2017-06-25 09:23:49', NULL, NULL, 10355, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:23:49', 'admin-1498350984-14983538297158074', 1, 0, '', NULL, NULL, NULL),
(35392, '2017-06-25 09:45:16', NULL, NULL, 10354, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:45:16', 'admin-1498350984-14983551159266319', 1, 1, 'SR', NULL, NULL, NULL),
(35393, '2017-06-25 09:11:53', NULL, NULL, 10354, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:11:53', 'admin-1498350984-1498353113684929', 1, 1, 'SR', NULL, NULL, NULL),
(35394, '2017-06-25 09:10:45', NULL, NULL, 10354, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:10:45', 'admin-1498350984-1498353045569252', 1, 0, '', NULL, NULL, NULL),
(35395, '2017-06-25 09:10:56', NULL, NULL, 10354, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:10:56', 'admin-1498350984-14983530560941621', 1, 0, '', NULL, NULL, NULL),
(35396, '2017-06-25 09:10:56', NULL, NULL, 10354, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:10:56', 'admin-1498350984-14983530560941621', 1, 0, '', NULL, NULL, NULL),
(35397, '2017-06-25 09:06:21', NULL, NULL, 10354, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.90, 0.0000, 0.0000, 12.90, 1, '27', 1, '1498370688', 'admin', '2017-06-25 09:06:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35398, '2017-06-26 12:35:42', NULL, NULL, 10464, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:35:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35399, '2017-06-26 12:06:04', NULL, NULL, 10459, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:06:04', 'admin-1498448388-14984499647007491', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(35400, '2017-06-26 11:28:20', NULL, NULL, 10451, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:28:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35401, '2017-06-26 11:28:46', NULL, NULL, 10451, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:28:46', 'admin-1498447642-14984477262151323', 1, 0, '', NULL, NULL, NULL),
(35402, '2017-06-26 11:28:46', NULL, NULL, 10451, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:28:46', 'admin-1498447642-14984477262151323', 1, 0, '', NULL, NULL, NULL),
(35403, '2017-06-26 11:28:59', NULL, NULL, 10451, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:28:59', 'admin-1498447642-14984477390189383', 1, 1, 'SR', NULL, NULL, NULL),
(35404, '2017-06-26 11:29:22', NULL, NULL, 10452, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:29:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35405, '2017-06-26 11:29:55', NULL, NULL, 10452, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:29:55', 'admin-1498447642-14984477951189768', 1, 0, '', NULL, NULL, NULL),
(35406, '2017-06-26 11:32:19', NULL, NULL, 10452, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:32:19', 'admin-1498447642-14984479391254217', 1, 0, '', NULL, NULL, NULL),
(35407, '2017-06-26 11:32:31', NULL, NULL, 10452, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:32:31', 'admin-1498447642-14984479512355599', 1, 1, 'SR', NULL, NULL, NULL),
(35408, '2017-06-26 11:33:05', NULL, NULL, 10453, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:33:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35409, '2017-06-26 12:28:23', NULL, NULL, 10463, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:28:23', 'admin-1498450740-14984513030452067', 1, 1, 'SR', NULL, NULL, NULL),
(35410, '2017-06-26 12:06:04', NULL, NULL, 10459, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:06:04', 'admin-1498448388-14984499647007491', 1, 0, '', NULL, NULL, NULL),
(35411, '2017-06-26 12:05:28', NULL, NULL, 10458, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:05:28', 'admin-1498448388-14984499284735335', 1, 1, 'SR', NULL, NULL, NULL),
(35412, '2017-06-26 17:05:32', NULL, NULL, 10478, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 17:05:32', 'admin-1498457127-14984679324085098', 1, 1, 'SR', NULL, NULL, NULL),
(35413, '2017-06-26 13:42:44', NULL, NULL, 10467, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 13:42:44', 'admin-1498450740-14984557647007946', 1, 1, 'SR', NULL, NULL, '10.0'),
(35414, '2017-06-26 13:43:00', NULL, NULL, 10466, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 13:43:00', 'admin-1498450740-1498455779993687', 1, 1, 'SR', NULL, NULL, NULL),
(35415, '2017-06-26 13:43:13', NULL, NULL, 10466, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 13:43:13', 'admin-1498450740-14984557932936063', 1, 1, 'SR', NULL, NULL, NULL),
(35416, '2017-06-26 12:46:05', NULL, NULL, 10465, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:46:05', 'admin-1498450740-14984523657286196', 1, 1, 'SR', NULL, NULL, NULL),
(35417, '2017-06-26 13:32:33', NULL, NULL, 10466, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 13:32:33', 'admin-1498450740-14984551535083649', 1, 1, 'SR', NULL, NULL, NULL),
(35418, '2017-06-26 13:32:33', NULL, NULL, 10466, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 13:32:33', 'admin-1498450740-14984551535083649', 1, 0, '', NULL, NULL, NULL),
(35419, '2017-06-26 10:45:12', NULL, NULL, 10443, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:45:12', 'admin-1498443768-14984451127115986', 1, 0, '', NULL, NULL, NULL),
(35420, '2017-06-26 10:45:12', NULL, NULL, 10443, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:45:12', 'admin-1498443768-14984451127115986', 1, 0, '', NULL, NULL, NULL),
(35421, '2017-06-26 14:25:21', NULL, NULL, 10471, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:25:21', 'admin-1498457127-14984583208317619', 1, 0, '', NULL, NULL, NULL),
(35422, '2017-06-26 14:34:42', NULL, NULL, 10467, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:34:42', 'admin-1498457127-1498458882015357', 1, 1, 'SR', NULL, NULL, '10.0'),
(35423, '2017-06-26 16:55:56', NULL, NULL, 10479, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 16:55:56', 'admin-1498457127-1498467356668248', 1, 0, '', 1, NULL, NULL),
(35424, '2017-06-26 17:05:32', NULL, NULL, 10478, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 17:05:32', 'admin-1498457127-14984679324085098', 1, 1, 'SR', NULL, NULL, NULL),
(35425, '2017-06-26 15:58:00', NULL, NULL, 10478, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:58:00', 'admin-1498457127-14984638804139475', 1, 1, 'SR', NULL, NULL, NULL),
(35426, '2017-06-26 11:33:42', NULL, NULL, 10453, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:33:42', 'admin-1498447642-14984480218751272', 1, 1, 'SR', NULL, NULL, NULL),
(35427, '2017-06-26 11:54:55', NULL, NULL, 10456, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:54:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35428, '2017-06-26 11:39:23', NULL, NULL, 10454, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:39:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35429, '2017-06-26 14:24:46', NULL, NULL, 10471, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:24:46', 'admin-1498457127-14984582864666353', 1, 0, '', NULL, NULL, NULL),
(35430, '2017-06-26 14:24:46', NULL, NULL, 10471, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:24:46', 'admin-1498457127-14984582864666353', 1, 1, 'SR', NULL, NULL, NULL),
(35431, '2017-06-26 15:55:55', NULL, NULL, 10474, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:55:55', 'admin-1498457127-1498463755583180', 1, 1, 'SR', NULL, NULL, NULL),
(35432, '2017-06-26 15:57:54', NULL, NULL, 10478, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:57:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35433, '2017-06-26 15:38:35', NULL, NULL, 10477, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:38:35', 'admin-1498457127-1498462715089970', 1, 0, '', NULL, NULL, NULL),
(35434, '2017-06-26 15:38:35', NULL, NULL, 10477, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:38:35', 'admin-1498457127-1498462715089970', 1, 1, 'SR', NULL, NULL, NULL),
(35435, '2017-06-26 15:30:15', NULL, NULL, 10476, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:30:15', 'admin-1498457127-1498462215774822', 1, 0, '', NULL, NULL, NULL),
(35436, '2017-06-26 15:26:41', NULL, NULL, 10475, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:26:41', 'admin-1498457127-1498462001733955', 1, 0, '', NULL, NULL, NULL),
(35437, '2017-06-26 15:30:11', NULL, NULL, 10476, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:30:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35438, '2017-06-26 15:26:41', NULL, NULL, 10475, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:26:41', 'admin-1498457127-1498462001733955', 1, 1, 'SR', NULL, NULL, NULL),
(35439, '2017-06-26 15:26:41', NULL, NULL, 10475, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:26:41', 'admin-1498457127-1498462001733955', 1, 1, 'SR', NULL, NULL, NULL),
(35440, '2017-06-26 11:17:25', NULL, NULL, 10448, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.50, 0.0000, 0.0000, 9.50, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:17:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35441, '2017-06-26 15:26:14', NULL, NULL, 10475, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:26:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35442, '2017-06-26 15:22:13', NULL, NULL, 10474, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:22:13', 'admin-1498457127-14984617334019347', 1, 0, '', NULL, NULL, NULL),
(35443, '2017-06-26 13:56:15', NULL, NULL, 10467, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 13:56:15', 'admin-1498456261-14984565748315313', 1, 0, '', NULL, NULL, '10.0'),
(35444, '2017-06-26 13:56:15', NULL, NULL, 10467, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 13:56:15', 'admin-1498456261-14984565748315313', 1, 0, '', NULL, NULL, '10.0'),
(35445, '2017-06-26 15:00:34', NULL, NULL, 10472, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:00:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35446, '2017-06-26 15:00:56', NULL, NULL, 10472, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:00:56', 'admin-1498457127-14984604565193855', 1, 1, 'SR', NULL, NULL, NULL),
(35447, '2017-06-26 14:04:54', NULL, NULL, 10469, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:04:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35448, '2017-06-26 14:05:16', NULL, NULL, 10469, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:05:16', 'admin-1498456261-14984571164393215', 1, 0, '', NULL, NULL, NULL),
(35449, '2017-06-26 14:16:59', NULL, NULL, 10470, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:16:59', 'admin-1498457127-14984578197481068', 1, 0, '', NULL, NULL, NULL),
(35450, '2017-06-26 14:09:59', NULL, NULL, 10467, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:09:59', 'admin-1498457127-14984573998293144', 1, 1, 'SR', NULL, NULL, '10.0'),
(35451, '2017-06-26 13:31:42', NULL, NULL, 10466, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1498457127', 'admin', '2017-06-26 13:31:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35452, '2017-06-26 12:35:49', NULL, NULL, 10464, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:35:49', 'admin-1498450740-1498451749444485', 1, 1, 'SR', NULL, NULL, NULL),
(35453, '2017-06-26 12:45:01', NULL, NULL, 10465, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:45:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35454, '2017-06-26 12:45:13', NULL, NULL, 10465, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:45:13', 'admin-1498450740-14984523131156382', 1, 0, '', NULL, NULL, NULL),
(35455, '2017-06-26 12:46:05', NULL, NULL, 10465, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:46:05', 'admin-1498450740-14984523657286196', 1, 1, 'SR', NULL, NULL, NULL),
(35456, '2017-06-26 12:18:53', NULL, NULL, 10462, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:18:53', 'admin-1498448388-14984507335983439', 1, 1, 'SR', NULL, NULL, NULL),
(35457, '2017-06-26 12:18:53', NULL, NULL, 10462, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:18:53', 'admin-1498448388-14984507335983439', 1, 0, '', NULL, NULL, NULL),
(35458, '2017-06-26 12:18:53', NULL, NULL, 10462, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:18:53', 'admin-1498448388-14984507335983439', 1, 0, '', NULL, NULL, NULL),
(35459, '2017-06-26 12:19:17', NULL, NULL, 10446, 0, 181, '116', 'Open Food ', 'Scones tea set', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:19:17', 'admin-1498450740-14984507569093251', 1, 0, '', NULL, NULL, NULL),
(35460, '2017-06-26 12:21:55', NULL, NULL, 10458, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:21:55', 'admin-1498450740-14984509155932520', 1, 0, '', NULL, NULL, NULL),
(35461, '2017-06-26 12:26:03', NULL, NULL, 10452, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:26:03', 'admin-1498450740-14984511632047770', 1, 0, '', NULL, NULL, NULL),
(35462, '2017-06-26 12:06:04', NULL, NULL, 10459, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:06:04', 'admin-1498448388-14984499647007491', 1, 1, 'SR', NULL, NULL, NULL),
(35463, '2017-06-26 14:27:07', NULL, NULL, 10471, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:27:07', 'admin-1498457127-14984584271127767', 1, 0, '', NULL, NULL, NULL),
(35464, '2017-06-26 14:24:46', NULL, NULL, 10471, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:24:46', 'admin-1498457127-14984582864666353', 1, 0, '', NULL, NULL, NULL),
(35465, '2017-06-26 14:25:11', NULL, NULL, 10471, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:25:11', 'admin-1498457127-14984583110532071', 1, 1, 'SR', NULL, NULL, NULL),
(35466, '2017-06-26 14:25:11', NULL, NULL, 10471, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:25:11', 'admin-1498457127-14984583110532071', 1, 1, 'SR', NULL, NULL, NULL),
(35467, '2017-06-26 15:08:24', NULL, NULL, 10473, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:08:24', 'admin-1498457127-14984609040197855', 1, 1, 'SR', NULL, NULL, NULL),
(35468, '2017-06-26 15:08:24', NULL, NULL, 10473, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:08:24', 'admin-1498457127-14984609040197855', 1, 1, 'SR', NULL, NULL, NULL),
(35469, '2017-06-26 09:35:41', NULL, NULL, 10428, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:35:41', 'admin-1498438916-1498440941719145', 1, 0, '', NULL, NULL, NULL),
(35470, '2017-06-26 15:07:33', NULL, NULL, 10472, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:07:33', 'admin-1498457127-14984608532276279', 1, 0, '', NULL, NULL, NULL),
(35471, '2017-06-26 15:08:16', NULL, NULL, 10473, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:08:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35472, '2017-06-26 12:02:15', NULL, NULL, 10457, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:02:15', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(35473, '2017-06-26 12:04:32', NULL, NULL, 10458, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.60, 0.0000, 0.0000, 9.60, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:04:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35474, '2017-06-26 14:24:46', NULL, NULL, 10471, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:24:46', 'admin-1498457127-14984582864666353', 1, 0, '', NULL, NULL, NULL),
(35475, '2017-06-26 15:08:24', NULL, NULL, 10473, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:08:24', 'admin-1498457127-14984609040197855', 1, 1, 'SR', NULL, NULL, NULL),
(35476, '2017-06-26 15:00:56', NULL, NULL, 10472, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:00:56', 'admin-1498457127-14984604565193855', 1, 1, 'SR', NULL, NULL, NULL),
(35477, '2017-06-26 12:03:31', NULL, NULL, 10457, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:03:31', 'admin-1498448388-14984498113038935', 1, 1, 'SR', NULL, NULL, '10.0'),
(35478, '2017-06-26 12:03:31', NULL, NULL, 10457, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:03:31', 'admin-1498448388-14984498113038935', 1, 1, 'SR', NULL, NULL, '10.0'),
(35479, '2017-06-26 11:24:26', NULL, NULL, 10448, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:24:26', 'admin-1498445415-14984474665203336', 1, 1, 'SR', NULL, NULL, NULL),
(35480, '2017-06-26 11:24:26', NULL, NULL, 10448, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:24:26', 'admin-1498445415-14984474665203336', 1, 1, 'SR', NULL, NULL, NULL),
(35481, '2017-06-26 11:24:26', NULL, NULL, 10448, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:24:26', 'admin-1498445415-14984474665203336', 1, 1, 'SR', NULL, NULL, NULL),
(35482, '2017-06-26 11:24:34', NULL, NULL, 10449, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:24:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35483, '2017-06-26 11:25:06', NULL, NULL, 10449, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:25:06', 'admin-1498445415-14984475064778895', 1, 0, '', NULL, NULL, NULL),
(35484, '2017-06-26 11:25:06', NULL, NULL, 10449, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:25:06', 'admin-1498445415-14984475064778895', 1, 0, '', NULL, NULL, NULL),
(35485, '2017-06-26 11:25:06', NULL, NULL, 10449, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:25:06', 'admin-1498445415-14984475064778895', 1, 0, '', NULL, NULL, NULL),
(35486, '2017-06-26 11:25:56', NULL, NULL, 10449, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:25:56', 'admin-1498445415-14984475562227469', 1, 0, '', NULL, NULL, NULL),
(35487, '2017-06-26 11:25:56', NULL, NULL, 10449, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:25:56', 'admin-1498445415-14984475562227469', 1, 1, 'SR', NULL, NULL, NULL),
(35488, '2017-06-26 11:25:56', NULL, NULL, 10449, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:25:56', 'admin-1498445415-14984475562227469', 1, 0, '', NULL, NULL, NULL),
(35489, '2017-06-26 11:26:29', NULL, NULL, 10450, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:26:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35490, '2017-06-26 11:26:56', NULL, NULL, 10450, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:26:56', 'admin-1498445415-14984476163135139', 1, 0, '', NULL, NULL, NULL),
(35491, '2017-06-26 11:27:44', NULL, NULL, 10450, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:27:44', 'admin-1498447642-14984476641706858', 1, 0, '', NULL, NULL, NULL),
(35492, '2017-06-26 11:28:11', NULL, NULL, 10450, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:28:11', 'admin-1498447642-149844769132387', 1, 0, '', NULL, NULL, NULL),
(35493, '2017-06-26 11:07:20', NULL, NULL, 10447, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:07:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35494, '2017-06-26 11:07:45', NULL, NULL, 10447, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:07:45', 'admin-1498445415-1498446465781120', 1, 0, '', NULL, NULL, NULL),
(35495, '2017-06-26 14:24:46', NULL, NULL, 10471, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:24:46', 'admin-1498457127-14984582864666353', 1, 1, 'SR', NULL, NULL, NULL),
(35496, '2017-06-26 14:24:46', NULL, NULL, 10471, 0, 181, '116', 'Open Food ', 'change to pasta', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:24:46', 'admin-1498457127-14984582864666353', 1, 0, '', NULL, NULL, NULL),
(35497, '2017-06-26 14:24:46', NULL, NULL, 10471, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:24:46', 'admin-1498457127-14984582864666353', 1, 0, '', NULL, NULL, NULL),
(35498, '2017-06-26 14:21:59', NULL, NULL, 10471, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.90, 0.0000, 0.0000, 14.90, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:21:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35499, '2017-06-26 14:16:59', NULL, NULL, 10470, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:16:59', 'admin-1498457127-14984578197481068', 1, 0, '', NULL, NULL, NULL),
(35500, '2017-06-26 14:16:59', NULL, NULL, 10470, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:16:59', 'admin-1498457127-14984578197481068', 1, 0, '', NULL, NULL, NULL),
(35501, '2017-06-26 14:16:30', NULL, NULL, 10468, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:16:30', 'admin-1498457127-14984577899673051', 1, 1, 'SR', NULL, NULL, NULL),
(35502, '2017-06-26 14:16:30', NULL, NULL, 10468, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:16:30', 'admin-1498457127-14984577899673051', 1, 1, 'SR', NULL, NULL, NULL),
(35503, '2017-06-26 11:07:45', NULL, NULL, 10447, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:07:46', 'admin-1498445415-1498446465781120', 1, 1, 'SR', NULL, NULL, NULL),
(35504, '2017-06-26 14:09:52', NULL, NULL, 10467, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:09:52', 'admin-1498457127-14984573924844562', 1, 1, 'SR', NULL, NULL, '10.0'),
(35505, '2017-06-26 14:16:30', NULL, NULL, 10468, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:16:30', 'admin-1498457127-14984577899673051', 1, 1, 'SR', NULL, NULL, NULL),
(35506, '2017-06-26 14:06:12', NULL, NULL, 10469, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:06:12', 'admin-1498457127-14984571728284261', 1, 1, 'SR', NULL, NULL, NULL),
(35507, '2017-06-26 14:06:12', NULL, NULL, 10469, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:06:12', 'admin-1498457127-14984571728284261', 1, 1, 'SR', NULL, NULL, NULL),
(35508, '2017-06-26 13:53:38', NULL, NULL, 10468, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 13:53:38', 'admin-1498456261-14984564183409297', 1, 1, 'SR', NULL, NULL, NULL),
(35509, '2017-06-26 13:52:09', NULL, NULL, 10468, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 13:52:09', 'admin-1498456261-1498456329688196', 1, 0, '', NULL, NULL, NULL),
(35510, '2017-06-26 13:53:13', NULL, NULL, 10468, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 13:53:13', 'admin-1498456261-14984563931902978', 1, 0, '', NULL, NULL, NULL),
(35511, '2017-06-26 13:51:08', NULL, NULL, 10468, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.20, 0.0000, 0.0000, 9.20, 1, '27', 1, '1498457127', 'admin', '2017-06-26 13:51:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35512, '2017-06-26 13:53:13', NULL, NULL, 10468, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 13:53:13', 'admin-1498456261-14984563931902978', 1, 0, '', NULL, NULL, NULL),
(35513, '2017-06-26 13:44:38', NULL, NULL, 10455, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 13:44:38', 'admin-1498450740-14984558786722952', 1, 0, '', NULL, NULL, NULL),
(35514, '2017-06-26 13:42:44', NULL, NULL, 10467, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 13:42:44', 'admin-1498450740-14984557647007946', 1, 1, 'SR', NULL, NULL, '10.0'),
(35515, '2017-06-26 13:42:05', NULL, NULL, 10467, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1498457127', 'admin', '2017-06-26 13:42:05', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(35516, '2017-06-26 13:32:33', NULL, NULL, 10466, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 13:32:33', 'admin-1498450740-14984551535083649', 1, 0, '', NULL, NULL, NULL),
(35517, '2017-06-26 12:15:53', NULL, NULL, 10461, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:15:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35518, '2017-06-26 12:35:49', NULL, NULL, 10464, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:35:49', 'admin-1498450740-1498451749444485', 1, 1, 'SR', NULL, NULL, NULL),
(35519, '2017-06-26 12:28:23', NULL, NULL, 10463, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:28:23', 'admin-1498450740-14984513030452067', 1, 0, '', NULL, NULL, NULL),
(35520, '2017-06-26 12:28:23', NULL, NULL, 10463, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:28:23', 'admin-1498450740-14984513030452067', 1, 1, 'SR', NULL, NULL, NULL),
(35521, '2017-06-26 12:28:04', NULL, NULL, 10463, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:28:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35522, '2017-06-26 12:18:26', NULL, NULL, 10462, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:18:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35523, '2017-06-26 11:07:45', NULL, NULL, 10447, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:07:45', 'admin-1498445415-1498446465781120', 1, 1, 'SR', NULL, NULL, NULL),
(35524, '2017-06-26 15:22:13', NULL, NULL, 10474, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:22:13', 'admin-1498457127-14984617334019347', 1, 1, 'SR', NULL, NULL, NULL),
(35525, '2017-06-26 12:16:01', NULL, NULL, 10461, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:16:01', 'admin-1498448388-14984505617938973', 1, 0, '', NULL, NULL, NULL),
(35526, '2017-06-26 12:16:01', NULL, NULL, 10461, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:16:01', 'admin-1498448388-14984505617938973', 1, 0, '', NULL, NULL, NULL),
(35527, '2017-06-26 12:16:01', NULL, NULL, 10461, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:16:01', 'admin-1498448388-14984505617938973', 1, 1, 'SR', NULL, NULL, NULL),
(35528, '2017-06-26 11:08:51', NULL, NULL, 10445, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:08:51', 'admin-1498445415-14984465309828745', 1, 0, '', NULL, NULL, NULL),
(35529, '2017-06-26 12:15:44', NULL, NULL, 10460, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:15:44', 'admin-1498448388-14984505444588062', 1, 1, 'SR', NULL, NULL, NULL),
(35530, '2017-06-26 12:15:31', NULL, NULL, 10460, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:15:31', 'admin-1498448388-14984505312317643', 1, 0, '', NULL, NULL, NULL),
(35531, '2017-06-26 12:15:44', NULL, NULL, 10460, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:15:44', 'admin-1498448388-14984505444588062', 1, 1, 'SR', NULL, NULL, NULL),
(35532, '2017-06-26 12:15:49', NULL, NULL, 10460, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:15:49', 'admin-1498448388-14984505493738924', 1, 1, 'SR', NULL, NULL, NULL),
(35533, '2017-06-26 12:15:31', NULL, NULL, 10460, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:15:31', 'admin-1498448388-14984505312317643', 1, 0, '', NULL, NULL, NULL),
(35534, '2017-06-26 12:15:23', NULL, NULL, 10460, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:15:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35535, '2017-06-26 11:39:39', NULL, NULL, 10454, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:39:39', 'admin-1498447642-14984483789697744', 1, 0, '', NULL, NULL, NULL),
(35536, '2017-06-26 11:40:11', NULL, NULL, 10454, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:40:11', 'admin-1498448388-14984484113701749', 1, 0, '', NULL, NULL, NULL),
(35537, '2017-06-26 11:40:18', NULL, NULL, 10455, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:40:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35538, '2017-06-26 14:16:34', NULL, NULL, 10470, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:16:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35539, '2017-06-26 14:16:59', NULL, NULL, 10470, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:16:59', 'admin-1498457127-14984578197481068', 1, 0, '', NULL, NULL, NULL),
(35540, '2017-06-26 12:06:04', NULL, NULL, 10459, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:06:04', 'admin-1498448388-14984499647007491', 1, 1, 'SR', NULL, NULL, NULL),
(35541, '2017-06-26 12:05:28', NULL, NULL, 10458, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:05:28', 'admin-1498448388-14984499284735335', 1, 0, '', NULL, NULL, NULL),
(35542, '2017-06-26 12:05:28', NULL, NULL, 10458, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:05:28', 'admin-1498448388-14984499284735335', 1, 1, 'SR', NULL, NULL, NULL),
(35543, '2017-06-26 12:05:28', NULL, NULL, 10458, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:05:28', 'admin-1498448388-14984499284735335', 1, 1, 'SR', NULL, NULL, NULL),
(35544, '2017-06-26 12:05:28', NULL, NULL, 10458, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:05:28', 'admin-1498448388-14984499284735335', 1, 1, 'SR', NULL, NULL, NULL),
(35545, '2017-06-26 12:05:28', NULL, NULL, 10458, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:05:28', 'admin-1498448388-14984499284735335', 1, 1, 'SR', NULL, NULL, NULL),
(35546, '2017-06-26 12:03:31', NULL, NULL, 10457, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:03:31', 'admin-1498448388-14984498113038935', 1, 0, '', NULL, NULL, '10.0'),
(35547, '2017-06-26 12:03:31', NULL, NULL, 10457, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:03:31', 'admin-1498448388-14984498113038935', 1, 0, '', NULL, NULL, '10.0'),
(35548, '2017-06-26 10:38:17', NULL, NULL, 10441, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:38:17', 'admin-1498443768-14984446969085612', 1, 0, '', NULL, NULL, NULL),
(35549, '2017-06-26 12:03:31', NULL, NULL, 10457, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:03:31', 'admin-1498448388-14984498113038935', 1, 1, 'SR', NULL, NULL, '10.0'),
(35550, '2017-06-26 12:03:31', NULL, NULL, 10457, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:03:31', 'admin-1498448388-14984498113038935', 1, 1, 'SR', NULL, NULL, '10.0'),
(35551, '2017-06-26 11:57:46', NULL, NULL, 10456, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:57:46', 'admin-1498448388-14984494667719875', 1, 1, 'SR', NULL, NULL, NULL),
(35552, '2017-06-26 11:06:45', NULL, NULL, 10445, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:06:45', 'admin-1498445415-1498446405635333', 1, 0, '', NULL, NULL, NULL),
(35553, '2017-06-26 10:49:48', NULL, NULL, 10444, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:49:48', 'admin-1498443768-14984453886998366', 1, 1, 'SR', NULL, NULL, NULL),
(35554, '2017-06-26 10:50:03', NULL, NULL, 10444, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:50:03', 'admin-1498443768-14984454034063121', 1, 0, '', NULL, NULL, NULL),
(35555, '2017-06-26 10:50:03', NULL, NULL, 10444, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:50:03', 'admin-1498443768-14984454034063121', 1, 0, '', NULL, NULL, NULL),
(35556, '2017-06-26 11:05:35', NULL, NULL, 10445, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:05:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35557, '2017-06-26 14:10:29', NULL, NULL, 10466, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 14:10:29', 'admin-1498457127-14984574288489532', 1, 0, '', NULL, NULL, NULL),
(35558, '2017-06-26 11:57:46', NULL, NULL, 10456, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:57:46', 'admin-1498448388-14984494667719875', 1, 1, 'SR', NULL, NULL, NULL),
(35559, '2017-06-26 10:03:13', NULL, NULL, 10431, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:03:13', 'admin-1498440957-14984425934186021', 1, 1, 'SR', NULL, NULL, NULL),
(35560, '2017-06-26 17:05:32', NULL, NULL, 10478, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 17:05:32', 'admin-1498457127-14984679324085098', 1, 1, 'SR', NULL, NULL, NULL),
(35561, '2017-06-26 15:38:26', NULL, NULL, 10477, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:38:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35562, '2017-06-26 11:40:36', NULL, NULL, 10455, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:40:36', 'admin-1498448388-14984484366008263', 1, 1, 'SR', NULL, NULL, NULL),
(35563, '2017-06-26 11:45:45', NULL, NULL, 10445, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:45:45', 'admin-1498448388-14984487455118856', 1, 1, 'SR', NULL, NULL, NULL),
(35564, '2017-06-26 11:40:27', NULL, NULL, 10455, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:40:27', 'admin-1498448388-14984484270012265', 1, 0, '', NULL, NULL, NULL),
(35565, '2017-06-26 11:39:39', NULL, NULL, 10454, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:39:39', 'admin-1498447642-14984483789697744', 1, 0, '', NULL, NULL, NULL),
(35566, '2017-06-26 11:33:25', NULL, NULL, 10453, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:33:25', 'admin-1498447642-14984480050806758', 1, 0, '', NULL, NULL, NULL),
(35567, '2017-06-26 11:33:42', NULL, NULL, 10453, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:33:42', 'admin-1498447642-14984480218751272', 1, 0, '', NULL, NULL, NULL),
(35568, '2017-06-26 11:33:25', NULL, NULL, 10453, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:33:25', 'admin-1498447642-14984480050806758', 1, 0, '', NULL, NULL, NULL),
(35569, '2017-06-26 10:37:54', NULL, NULL, 10441, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:37:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35570, '2017-06-26 10:38:17', NULL, NULL, 10441, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:38:17', 'admin-1498443768-14984446969085612', 1, 0, '', NULL, NULL, NULL),
(35571, '2017-06-26 09:35:21', NULL, NULL, 10428, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.10, 0.0000, 0.0000, 11.10, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:35:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35572, '2017-06-26 09:35:41', NULL, NULL, 10428, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:35:41', 'admin-1498438916-1498440941719145', 1, 0, '', NULL, NULL, NULL),
(35573, '2017-06-26 09:35:41', NULL, NULL, 10428, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:35:41', 'admin-1498438916-1498440941719145', 1, 0, '', NULL, NULL, NULL),
(35574, '2017-06-26 10:44:46', NULL, NULL, 10443, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.50, 0.0000, 0.0000, 13.50, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:44:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35575, '2017-06-26 10:45:12', NULL, NULL, 10443, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:45:12', 'admin-1498443768-14984451127115986', 1, 0, '', NULL, NULL, NULL),
(35576, '2017-06-26 10:38:17', NULL, NULL, 10441, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:38:17', 'admin-1498443768-14984446969085612', 1, 1, 'SR', NULL, NULL, NULL),
(35577, '2017-06-26 10:38:17', NULL, NULL, 10441, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:38:17', 'admin-1498443768-14984446969085612', 1, 1, 'SR', NULL, NULL, NULL),
(35578, '2017-06-26 12:05:54', NULL, NULL, 10459, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1498457127', 'admin', '2017-06-26 12:05:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35579, '2017-06-26 09:25:56', NULL, NULL, 10427, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:25:56', 'admin-1498438916-1498440356362225', 1, 0, '', NULL, NULL, NULL),
(35580, '2017-06-26 09:25:56', NULL, NULL, 10427, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:25:56', 'admin-1498438916-1498440356362225', 1, 0, '', NULL, NULL, NULL),
(35581, '2017-06-26 09:25:56', NULL, NULL, 10427, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:25:56', 'admin-1498438916-1498440356362225', 1, 1, 'SR', NULL, NULL, NULL),
(35582, '2017-06-26 09:25:56', NULL, NULL, 10427, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:25:56', 'admin-1498438916-1498440356362225', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(35583, '2017-06-26 11:07:16', NULL, NULL, 10446, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:07:16', 'admin-1498445415-14984464363579720', 1, 1, 'SR', NULL, NULL, NULL),
(35584, '2017-06-26 11:18:06', NULL, NULL, 10448, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:18:06', 'admin-1498445415-1498447085844336', 1, 0, '', NULL, NULL, NULL),
(35585, '2017-06-26 11:06:52', NULL, NULL, 10446, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:06:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35586, '2017-06-26 10:28:54', NULL, NULL, 10438, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:28:54', 'admin-1498443768-14984441345715748', 1, 0, '', NULL, NULL, NULL),
(35587, '2017-06-26 10:25:25', NULL, NULL, 10437, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:25:25', 'admin-1498443768-14984439254581975', 1, 1, 'SR', NULL, NULL, NULL),
(35588, '2017-06-26 10:25:25', NULL, NULL, 10437, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:25:25', 'admin-1498443768-14984439254581975', 1, 1, 'SR', NULL, NULL, NULL),
(35589, '2017-06-26 10:25:25', NULL, NULL, 10437, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:25:25', 'admin-1498443768-14984439254581975', 1, 1, 'SR', NULL, NULL, NULL),
(35590, '2017-06-26 10:28:25', NULL, NULL, 10438, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:28:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35591, '2017-06-26 10:28:54', NULL, NULL, 10438, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:28:54', 'admin-1498443768-14984441345715748', 1, 0, '', NULL, NULL, NULL),
(35592, '2017-06-26 10:28:54', NULL, NULL, 10438, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:28:54', 'admin-1498443768-14984441345715748', 1, 0, '', NULL, NULL, NULL),
(35593, '2017-06-26 10:11:29', NULL, NULL, 10433, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:11:29', 'admin-1498442801-14984430894316884', 1, 0, '', NULL, NULL, NULL),
(35594, '2017-06-26 10:13:12', NULL, NULL, 10434, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:13:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35595, '2017-06-26 15:22:06', NULL, NULL, 10474, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1498457127', 'admin', '2017-06-26 15:22:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35596, '2017-06-26 11:06:45', NULL, NULL, 10445, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:06:45', 'admin-1498445415-1498446405635333', 1, 0, '', NULL, NULL, NULL),
(35597, '2017-06-26 11:18:06', NULL, NULL, 10448, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:18:06', 'admin-1498445415-1498447085844336', 1, 0, '', NULL, NULL, NULL),
(35598, '2017-06-26 10:49:48', NULL, NULL, 10444, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:49:48', 'admin-1498443768-14984453886998366', 1, 1, 'SR', NULL, NULL, NULL),
(35599, '2017-06-26 10:49:32', NULL, NULL, 10444, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:49:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35600, '2017-06-26 10:45:13', NULL, NULL, 10443, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:45:13', 'admin-1498443768-14984451127115986', 1, 1, 'SR', NULL, NULL, NULL),
(35601, '2017-06-26 10:45:12', NULL, NULL, 10443, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:45:12', 'admin-1498443768-14984451127115986', 1, 0, '', NULL, NULL, NULL),
(35602, '2017-06-26 10:45:12', NULL, NULL, 10443, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:45:12', 'admin-1498443768-14984451127115986', 1, 1, 'SR', NULL, NULL, NULL),
(35603, '2017-06-26 10:45:12', NULL, NULL, 10443, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:45:12', 'admin-1498443768-14984451127115986', 1, 0, '', NULL, NULL, NULL),
(35604, '2017-06-26 11:18:06', NULL, NULL, 10448, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:18:06', 'admin-1498445415-1498447085844336', 1, 0, '', NULL, NULL, NULL),
(35605, '2017-06-26 10:45:12', NULL, NULL, 10443, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:45:12', 'admin-1498443768-14984451127115986', 1, 0, '', NULL, NULL, NULL),
(35606, '2017-06-26 10:44:09', NULL, NULL, 10442, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:44:09', 'admin-1498443768-14984450495396270', 1, 1, 'SR', NULL, NULL, NULL),
(35607, '2017-06-26 11:07:45', NULL, NULL, 10447, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:07:45', 'admin-1498445415-1498446465781120', 1, 0, '', NULL, NULL, NULL),
(35608, '2017-06-26 10:44:09', NULL, NULL, 10442, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:44:09', 'admin-1498443768-14984450495396270', 1, 1, 'SR', NULL, NULL, NULL),
(35609, '2017-06-26 10:44:09', NULL, NULL, 10442, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:44:09', 'admin-1498443768-14984450495396270', 1, 0, '', NULL, NULL, NULL),
(35610, '2017-06-26 10:43:59', NULL, NULL, 10442, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:43:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35611, '2017-06-26 10:44:09', NULL, NULL, 10442, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:44:09', 'admin-1498443768-14984450495396270', 1, 0, '', NULL, NULL, NULL),
(35612, '2017-06-26 10:22:15', NULL, NULL, 10436, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:22:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35613, '2017-06-26 10:22:26', NULL, NULL, 10436, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:22:26', 'admin-1498442801-14984437464293349', 1, 0, '', NULL, NULL, NULL),
(35614, '2017-06-26 10:03:47', NULL, NULL, 10432, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:03:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35615, '2017-06-26 10:06:31', NULL, NULL, 10432, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:06:31', 'admin-1498440957-14984427909305367', 1, 0, '', NULL, NULL, NULL),
(35616, '2017-06-26 10:07:40', NULL, NULL, 10432, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:07:40', 'admin-1498442801-14984428601205718', 1, 0, '', NULL, NULL, NULL),
(35617, '2017-06-26 09:10:02', NULL, NULL, 10423, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:10:02', 'admin-1498438916-14984394021108662', 1, 0, '', 1, NULL, NULL),
(35618, '2017-06-26 09:16:34', NULL, NULL, 10424, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:16:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35619, '2017-06-26 09:16:46', NULL, NULL, 10424, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:16:46', 'admin-1498438916-14984398063323558', 1, 0, '', NULL, NULL, NULL),
(35620, '2017-06-26 09:16:46', NULL, NULL, 10424, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:16:46', 'admin-1498438916-14984398063323558', 1, 0, '', NULL, NULL, NULL),
(35621, '2017-06-26 09:17:14', NULL, NULL, 10424, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:17:14', 'admin-1498438916-14984398344999046', 1, 1, 'SR', NULL, NULL, NULL),
(35622, '2017-06-26 09:47:29', NULL, NULL, 10429, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:47:29', 'admin-1498440957-14984416489168765', 1, 0, '', NULL, NULL, NULL),
(35623, '2017-06-26 09:47:29', NULL, NULL, 10429, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:47:29', 'admin-1498440957-14984416489168765', 1, 0, '', NULL, NULL, NULL),
(35624, '2017-06-26 11:18:06', NULL, NULL, 10448, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:18:06', 'admin-1498445415-1498447085844336', 1, 0, '', NULL, NULL, NULL),
(35625, '2017-06-26 10:32:17', NULL, NULL, 10439, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:32:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35626, '2017-06-26 10:32:30', NULL, NULL, 10439, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:32:30', 'admin-1498443768-14984443507216294', 1, 1, 'SR', NULL, NULL, NULL),
(35627, '2017-06-26 10:32:30', NULL, NULL, 10439, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:32:30', 'admin-1498443768-14984443507216294', 1, 1, 'SR', NULL, NULL, NULL),
(35628, '2017-06-26 11:15:21', NULL, NULL, 10443, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:15:21', 'admin-1498445415-14984469216222054', 1, 0, '', NULL, NULL, NULL),
(35629, '2017-06-26 10:13:54', NULL, NULL, 10434, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:13:54', 'admin-1498442801-14984432347642827', 1, 0, '', NULL, NULL, NULL),
(35630, '2017-06-26 10:32:42', NULL, NULL, 10439, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:32:42', 'admin-1498443768-14984443620036447', 1, 0, '', NULL, NULL, NULL),
(35631, '2017-06-26 09:50:33', NULL, NULL, 10428, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:50:33', 'admin-1498440957-14984418333387518', 1, 0, '', NULL, NULL, NULL),
(35632, '2017-06-26 09:53:48', NULL, NULL, 10430, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:53:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35633, '2017-06-26 09:54:04', NULL, NULL, 10430, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:54:04', 'admin-1498440957-14984420440479149', 1, 0, '', NULL, NULL, NULL),
(35634, '2017-06-26 09:54:04', NULL, NULL, 10430, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:54:04', 'admin-1498440957-14984420440479149', 1, 1, 'SR', NULL, NULL, NULL),
(35635, '2017-06-26 11:07:16', NULL, NULL, 10446, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 11:07:16', 'admin-1498445415-14984464363579720', 1, 1, 'SR', NULL, NULL, NULL),
(35636, '2017-06-26 10:29:06', NULL, NULL, 10438, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:29:06', 'admin-1498443768-1498444145945156', 1, 1, 'SR', NULL, NULL, NULL),
(35637, '2017-06-26 10:25:25', NULL, NULL, 10437, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:25:25', 'admin-1498443768-14984439254581975', 1, 0, '', NULL, NULL, NULL),
(35638, '2017-06-26 10:24:55', NULL, NULL, 10437, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:24:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35639, '2017-06-26 10:25:25', NULL, NULL, 10437, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:25:25', 'admin-1498443768-14984439254581975', 1, 0, '', NULL, NULL, NULL),
(35640, '2017-06-26 10:23:48', NULL, NULL, 10436, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:23:48', 'admin-1498443768-14984438284647655', 1, 1, 'SR', NULL, NULL, NULL),
(35641, '2017-06-26 10:16:28', NULL, NULL, 10431, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:16:28', 'admin-1498442801-14984433881955381', 1, 0, '', NULL, NULL, NULL),
(35642, '2017-06-26 10:15:59', NULL, NULL, 10435, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:15:59', 'admin-1498442801-1498443359425818', 1, 1, 'SR', NULL, NULL, NULL),
(35643, '2017-06-26 10:15:47', NULL, NULL, 10435, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:15:47', 'admin-1498442801-14984433468851922', 1, 0, '', NULL, NULL, NULL),
(35644, '2017-06-26 10:15:47', NULL, NULL, 10435, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:15:47', 'admin-1498442801-14984433468851922', 1, 0, '', NULL, NULL, NULL),
(35645, '2017-06-26 10:14:51', NULL, NULL, 10435, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:14:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35646, '2017-06-26 10:13:54', NULL, NULL, 10434, 0, 32, '32', 'Tea By Pot ', 'earl grey', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:13:54', 'admin-1498442801-14984432347642827', 1, 1, 'SR', NULL, NULL, NULL),
(35647, '2017-06-26 10:13:54', NULL, NULL, 10434, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:13:54', 'admin-1498442801-14984432347642827', 1, 1, 'SR', NULL, NULL, NULL),
(35648, '2017-06-26 10:13:54', NULL, NULL, 10434, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:13:54', 'admin-1498442801-14984432347642827', 1, 0, '', NULL, NULL, NULL),
(35649, '2017-06-26 10:11:18', NULL, NULL, 10433, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:11:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35650, '2017-06-26 09:36:36', NULL, NULL, 10428, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:36:36', 'admin-1498440957-14984409961937947', 1, 1, 'SR', NULL, NULL, NULL),
(35651, '2017-06-26 09:36:56', NULL, NULL, 10428, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:36:56', 'admin-1498440957-14984410166252864', 1, 1, 'SR', NULL, NULL, NULL),
(35652, '2017-06-26 09:36:56', NULL, NULL, 10428, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:36:56', 'admin-1498440957-14984410166252864', 1, 1, 'SR', NULL, NULL, NULL),
(35653, '2017-06-26 09:47:09', NULL, NULL, 10429, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:47:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35654, '2017-06-26 10:03:40', NULL, NULL, 10424, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:03:40', 'admin-1498440957-14984426203876949', 1, 0, '', NULL, NULL, NULL),
(35655, '2017-06-26 10:00:55', NULL, NULL, 10431, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:00:55', 'admin-1498440957-14984424551677881', 1, 1, 'SR', NULL, NULL, NULL),
(35656, '2017-06-26 10:00:55', NULL, NULL, 10431, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:00:55', 'admin-1498440957-14984424551677881', 1, 0, '', NULL, NULL, NULL),
(35657, '2017-06-26 10:01:16', NULL, NULL, 10431, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:01:16', 'admin-1498440957-14984424763899745', 1, 1, 'SR', NULL, NULL, NULL),
(35658, '2017-06-26 10:01:16', NULL, NULL, 10431, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:01:16', 'admin-1498440957-14984424763899745', 1, 0, '', NULL, NULL, NULL),
(35659, '2017-06-26 10:00:55', NULL, NULL, 10431, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:00:55', 'admin-1498440957-14984424551677881', 1, 1, 'SR', NULL, NULL, NULL),
(35660, '2017-06-26 10:00:20', NULL, NULL, 10431, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:00:20', 'admin-1498440957-14984424199409835', 1, 0, '', NULL, NULL, NULL),
(35661, '2017-06-26 10:00:20', NULL, NULL, 10431, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:00:20', 'admin-1498440957-14984424199409835', 1, 0, '', NULL, NULL, NULL),
(35662, '2017-06-26 10:00:20', NULL, NULL, 10431, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:00:20', 'admin-1498440957-14984424199409835', 1, 0, '', NULL, NULL, NULL),
(35663, '2017-06-26 10:00:20', NULL, NULL, 10431, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:00:20', 'admin-1498440957-14984424199409835', 1, 0, '', NULL, NULL, NULL),
(35664, '2017-06-26 10:00:20', NULL, NULL, 10431, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:00:20', 'admin-1498440957-14984424199409835', 1, 0, '', NULL, NULL, NULL),
(35665, '2017-06-26 10:00:20', NULL, NULL, 10431, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 10:00:20', 'admin-1498440957-14984424199409835', 1, 0, '', NULL, NULL, NULL),
(35666, '2017-06-26 09:58:32', NULL, NULL, 10431, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 19.70, 0.0000, 0.0000, 19.70, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:58:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35667, '2017-06-26 09:54:58', NULL, NULL, 10428, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:54:58', 'admin-1498440957-14984420978268339', 1, 1, 'SR', NULL, NULL, NULL),
(35668, '2017-06-26 09:54:04', NULL, NULL, 10430, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:54:04', 'admin-1498440957-14984420440479149', 1, 1, 'SR', NULL, NULL, NULL),
(35669, '2017-06-26 09:48:09', NULL, NULL, 10429, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:48:09', 'admin-1498440957-14984416892708450', 1, 1, 'SR', NULL, NULL, NULL),
(35670, '2017-06-26 09:48:09', NULL, NULL, 10429, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:48:09', 'admin-1498440957-14984416892708450', 1, 1, 'SR', NULL, NULL, NULL),
(35671, '2017-06-26 09:47:58', NULL, NULL, 10429, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:47:58', 'admin-1498440957-14984416787609941', 1, 1, 'SR', NULL, NULL, NULL),
(35672, '2017-06-26 09:47:29', NULL, NULL, 10429, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:47:29', 'admin-1498440957-14984416489168765', 1, 0, '', NULL, NULL, NULL),
(35673, '2017-06-26 09:21:39', NULL, NULL, 10426, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:21:39', 'admin-1498438916-14984400994788517', 1, 1, 'SR', NULL, NULL, NULL),
(35674, '2017-06-26 09:21:28', NULL, NULL, 10426, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:21:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35675, '2017-06-26 09:21:39', NULL, NULL, 10426, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:21:39', 'admin-1498438916-14984400994788517', 1, 0, '', NULL, NULL, NULL),
(35676, '2017-06-26 09:17:14', NULL, NULL, 10424, 0, 32, '32', 'Tea By Pot ', 'ginger', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:17:14', 'admin-1498438916-14984398344999046', 1, 1, 'SR', NULL, NULL, NULL),
(35677, '2017-06-26 09:25:42', NULL, NULL, 10427, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:25:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35678, '2017-06-26 09:04:07', NULL, NULL, 10422, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:04:07', 'admin-1498438916-14984390475434826', 1, 1, 'SR', NULL, NULL, NULL),
(35679, '2017-06-26 09:04:07', NULL, NULL, 10422, 0, 32, '32', 'Tea By Pot ', 'ginsheng', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:04:07', 'admin-1498438916-14984390475434826', 1, 1, 'SR', NULL, NULL, NULL),
(35680, '2017-06-26 09:04:07', NULL, NULL, 10422, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:04:07', 'admin-1498438916-14984390475434826', 1, 0, '', NULL, NULL, NULL),
(35681, '2017-06-26 09:04:07', NULL, NULL, 10422, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:04:07', 'admin-1498438916-14984390475434826', 1, 0, '', NULL, NULL, NULL),
(35682, '2017-06-26 09:03:25', NULL, NULL, 10422, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1498457127', 'admin', '2017-06-26 09:03:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35683, '2017-06-28 16:10:47', NULL, NULL, 10508, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 16:10:47', 'admin-1498626392-1498637447263641', 1, 0, '', NULL, NULL, NULL),
(35684, '2017-06-28 13:52:16', NULL, NULL, 10503, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:52:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35685, '2017-06-28 13:52:25', NULL, NULL, 10503, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:52:25', 'admin-1498626392-14986291455635517', 1, 1, 'SR', NULL, NULL, NULL),
(35686, '2017-06-28 13:52:25', NULL, NULL, 10503, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:52:25', 'admin-1498626392-14986291455635517', 1, 0, '', NULL, NULL, NULL),
(35687, '2017-06-28 13:52:25', NULL, NULL, 10503, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:52:25', 'admin-1498626392-14986291455635517', 1, 0, '', NULL, NULL, NULL),
(35688, '2017-06-28 16:31:17', NULL, NULL, 10510, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 16:31:17', 'admin-1498626392-14986386776795590', 1, 0, '', NULL, NULL, NULL),
(35689, '2017-06-28 13:52:25', NULL, NULL, 10503, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:52:25', 'admin-1498626392-14986291455635517', 1, 1, 'SR', NULL, NULL, NULL),
(35690, '2017-06-28 14:32:48', NULL, NULL, 10504, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1498626392', 'admin', '2017-06-28 14:32:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35691, '2017-06-28 14:32:53', NULL, NULL, 10504, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 14:32:53', 'admin-1498626392-14986315733309382', 1, 1, 'SR', NULL, NULL, NULL),
(35692, '2017-06-28 14:32:53', NULL, NULL, 10504, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 14:32:53', 'admin-1498626392-14986315733309382', 1, 1, 'SR', NULL, NULL, NULL),
(35693, '2017-06-28 15:10:56', NULL, NULL, 10505, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1498626392', 'admin', '2017-06-28 15:10:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35694, '2017-06-28 15:11:01', NULL, NULL, 10505, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 15:11:01', 'admin-1498626392-14986338612401996', 1, 1, 'SR', NULL, NULL, NULL),
(35695, '2017-06-28 15:11:01', NULL, NULL, 10505, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 15:11:01', 'admin-1498626392-14986338612401996', 1, 1, 'SR', NULL, NULL, NULL),
(35696, '2017-06-28 15:24:36', NULL, NULL, 10506, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1498626392', 'admin', '2017-06-28 15:24:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35697, '2017-06-28 15:24:38', NULL, NULL, 10506, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 15:24:38', 'admin-1498626392-14986346787718644', 1, 1, 'SR', NULL, NULL, NULL),
(35698, '2017-06-28 15:24:41', NULL, NULL, 10507, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1498626392', 'admin', '2017-06-28 15:24:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35699, '2017-06-28 15:26:38', NULL, NULL, 10507, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 15:26:38', 'admin-1498626392-14986347981862065', 1, 0, '', NULL, NULL, NULL),
(35700, '2017-06-28 15:26:38', NULL, NULL, 10507, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 15:26:38', 'admin-1498626392-14986347981862065', 1, 0, '', NULL, NULL, NULL),
(35701, '2017-06-28 15:26:38', NULL, NULL, 10507, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 15:26:38', 'admin-1498626392-14986347981862065', 1, 1, 'SR', NULL, NULL, NULL),
(35702, '2017-06-28 15:26:38', NULL, NULL, 10507, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 15:26:38', 'admin-1498626392-14986347981862065', 1, 0, '', NULL, NULL, NULL),
(35703, '2017-06-28 13:37:20', NULL, NULL, 10496, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:37:20', 'admin-1498626392-14986282402629447', 1, 1, 'SR', NULL, NULL, '10.0'),
(35704, '2017-06-28 13:37:46', NULL, NULL, 10498, 0, 182, '117', 'Open Drinks ', 'yogurt', 'Cold Drinks', 'Fresh Juice', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:37:46', 'admin-1498626392-14986282657996830', 1, 0, '', NULL, NULL, NULL),
(35705, '2017-06-28 13:05:40', NULL, NULL, 10496, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:05:40', 'admin-1498617250-1498626339859667', 1, 0, '', NULL, NULL, '10.0'),
(35706, '2017-06-28 16:10:47', NULL, NULL, 10508, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 16:10:47', 'admin-1498626392-1498637447263641', 1, 1, 'SR', NULL, NULL, NULL),
(35707, '2017-06-28 17:08:03', NULL, NULL, 10512, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 17:08:03', 'admin-1498626392-14986408838189465', 1, 0, '', NULL, NULL, NULL),
(35708, '2017-06-28 17:10:58', NULL, NULL, 10512, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 17:10:58', 'admin-1498626392-14986410585659697', 1, 0, '', NULL, NULL, NULL),
(35709, '2017-06-28 17:10:58', NULL, NULL, 10512, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 17:10:58', 'admin-1498626392-14986410585659697', 1, 1, 'SR', NULL, NULL, NULL),
(35710, '2017-06-28 17:17:54', NULL, NULL, 10513, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1498626392', 'admin', '2017-06-28 17:17:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35711, '2017-06-28 17:18:14', NULL, NULL, 10514, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 17:18:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35712, '2017-06-28 17:18:22', NULL, NULL, 10514, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 17:18:22', 'admin-1498626392-14986415027694812', 1, 1, 'SR', NULL, NULL, NULL),
(35713, '2017-06-28 17:18:11', NULL, NULL, 10513, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 17:18:11', 'admin-1498626392-14986414910869819', 1, 1, 'SR', NULL, NULL, NULL),
(35714, '2017-06-28 17:18:11', NULL, NULL, 10513, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 17:18:11', 'admin-1498626392-14986414910869819', 1, 0, '', NULL, NULL, NULL),
(35715, '2017-06-28 17:18:11', NULL, NULL, 10513, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 17:18:11', 'admin-1498626392-14986414910869819', 1, 0, '', NULL, NULL, NULL),
(35716, '2017-06-28 11:20:59', NULL, NULL, 10493, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1498626392', 'admin', '2017-06-28 11:20:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35717, '2017-06-28 09:37:20', NULL, NULL, 10482, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1498626392', 'admin', '2017-06-28 09:37:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35718, '2017-06-28 09:37:31', NULL, NULL, 10482, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 09:37:31', 'admin-1498611394-14986138514411817', 1, 0, '', NULL, NULL, NULL),
(35719, '2017-06-28 09:37:31', NULL, NULL, 10482, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 09:37:31', 'admin-1498611394-14986138514411817', 1, 0, '', NULL, NULL, NULL),
(35720, '2017-06-28 09:37:31', NULL, NULL, 10482, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 09:37:31', 'admin-1498611394-14986138514411817', 1, 0, '', NULL, NULL, NULL),
(35721, '2017-06-28 09:37:31', NULL, NULL, 10482, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 09:37:31', 'admin-1498611394-14986138514411817', 1, 1, 'SR', NULL, NULL, NULL),
(35722, '2017-06-28 16:10:53', NULL, NULL, 10508, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 16:10:53', 'admin-1498626392-14986374536598740', 1, 1, 'SR', NULL, NULL, NULL),
(35723, '2017-06-28 16:12:55', NULL, NULL, 10504, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 16:12:55', 'admin-1498626392-14986375753005824', 1, 0, '', NULL, NULL, NULL),
(35724, '2017-06-28 13:05:40', NULL, NULL, 10496, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:05:40', 'admin-1498617250-1498626339859667', 1, 1, 'SR', NULL, NULL, '10.0'),
(35725, '2017-06-28 13:16:23', NULL, NULL, 10499, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:16:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35726, '2017-06-28 13:18:09', NULL, NULL, 10499, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:18:09', 'admin-1498626392-14986270892076153', 1, 0, '', NULL, NULL, NULL),
(35727, '2017-06-28 13:18:09', NULL, NULL, 10499, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:18:09', 'admin-1498626392-14986270892076153', 1, 0, '', NULL, NULL, NULL),
(35728, '2017-06-28 13:32:34', NULL, NULL, 10500, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:32:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35729, '2017-06-28 13:32:38', NULL, NULL, 10500, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:32:38', 'admin-1498626392-14986279584317922', 1, 1, 'SR', NULL, NULL, NULL),
(35730, '2017-06-28 12:44:02', NULL, NULL, 10496, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 12:44:02', 'admin-1498617250-1498625042693988', 1, 0, '', NULL, NULL, '10.0'),
(35731, '2017-06-28 12:44:02', NULL, NULL, 10496, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 12:44:02', 'admin-1498617250-1498625042693988', 1, 1, 'SR', NULL, NULL, '10.0'),
(35732, '2017-06-28 17:18:22', NULL, NULL, 10514, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 17:18:22', 'admin-1498626392-14986415027694812', 1, 1, 'SR', NULL, NULL, NULL),
(35733, '2017-06-28 13:52:25', NULL, NULL, 10503, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:52:25', 'admin-1498626392-14986291455635517', 1, 0, '', NULL, NULL, NULL),
(35734, '2017-06-28 17:18:11', NULL, NULL, 10513, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 17:18:11', 'admin-1498626392-14986414910869819', 1, 1, 'SR', NULL, NULL, NULL),
(35735, '2017-06-28 17:08:03', NULL, NULL, 10512, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 17:08:03', 'admin-1498626392-14986408838189465', 1, 1, 'SR', NULL, NULL, NULL),
(35736, '2017-06-28 17:02:23', NULL, NULL, 10511, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 17:02:23', 'admin-1498626392-1498640543013324', 1, 1, 'SR', NULL, NULL, NULL),
(35737, '2017-06-28 17:07:56', NULL, NULL, 10512, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1498626392', 'admin', '2017-06-28 17:07:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35738, '2017-06-28 17:02:23', NULL, NULL, 10511, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 17:02:23', 'admin-1498626392-1498640543013324', 1, 1, 'SR', NULL, NULL, NULL),
(35739, '2017-06-28 17:01:25', NULL, NULL, 10511, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1498626392', 'admin', '2017-06-28 17:01:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35740, '2017-06-28 16:31:07', NULL, NULL, 10509, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 16:31:07', 'admin-1498626392-14986386674524357', 1, 0, '', NULL, NULL, NULL),
(35741, '2017-06-28 16:31:13', NULL, NULL, 10510, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1498626392', 'admin', '2017-06-28 16:31:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35742, '2017-06-28 16:10:47', NULL, NULL, 10508, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 16:10:47', 'admin-1498626392-1498637447263641', 1, 0, '', NULL, NULL, NULL),
(35743, '2017-06-28 12:33:47', NULL, NULL, 10495, 0, 75, '75', 'Meatless Aglio Olio ', 'no spicy', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 12:33:47', 'admin-1498617250-14986244267204463', 1, 0, '', NULL, NULL, NULL),
(35744, '2017-06-28 16:31:03', NULL, NULL, 10509, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1498626392', 'admin', '2017-06-28 16:31:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35745, '2017-06-28 15:26:38', NULL, NULL, 10507, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 15:26:38', 'admin-1498626392-14986347981862065', 1, 1, 'SR', NULL, NULL, NULL),
(35746, '2017-06-28 16:10:28', NULL, NULL, 10508, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1498626392', 'admin', '2017-06-28 16:10:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35747, '2017-06-28 13:02:39', NULL, NULL, 10498, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:02:39', 'admin-1498617250-14986261591838742', 1, 1, 'SR', NULL, NULL, NULL),
(35748, '2017-06-28 12:33:56', NULL, NULL, 10495, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 12:33:56', 'admin-1498617250-14986244361298658', 1, 1, 'SR', NULL, NULL, NULL),
(35749, '2017-06-28 12:33:56', NULL, NULL, 10495, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 12:33:56', 'admin-1498617250-14986244361298658', 1, 1, 'SR', NULL, NULL, NULL),
(35750, '2017-06-28 12:42:01', NULL, NULL, 10496, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.30, 0.0000, 0.0000, 11.30, 1, '27', 1, '1498626392', 'admin', '2017-06-28 12:42:01', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(35751, '2017-06-28 09:12:23', NULL, NULL, 10480, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1498626392', 'admin', '2017-06-28 09:12:23', 'admin-1498611394-14986123433392492', 1, 0, '', NULL, NULL, NULL),
(35752, '2017-06-28 09:12:23', NULL, NULL, 10480, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 09:12:23', 'admin-1498611394-14986123433392492', 1, 0, '', NULL, NULL, NULL),
(35753, '2017-06-28 00:00:00', NULL, NULL, 10484, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 09:31:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35754, '2017-06-28 10:01:43', NULL, NULL, 10485, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1498626392', 'admin', '2017-06-28 10:01:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35755, '2017-06-28 00:00:00', NULL, NULL, 10484, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 09:32:49', 'admin-1498611394-1498613569128117', 1, 0, '', NULL, NULL, NULL),
(35756, '2017-06-28 00:00:00', NULL, NULL, 10484, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 09:32:49', 'admin-1498611394-1498613569128117', 1, 0, '', NULL, NULL, NULL),
(35757, '2017-06-28 10:01:52', NULL, NULL, 10485, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 10:01:52', 'admin-1498611394-14986153119688259', 1, 0, '', NULL, NULL, NULL),
(35758, '2017-06-28 10:01:52', NULL, NULL, 10485, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 10:01:52', 'admin-1498611394-14986153119688259', 1, 0, '', NULL, NULL, NULL),
(35759, '2017-06-28 10:07:04', NULL, NULL, 10486, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1498626392', 'admin', '2017-06-28 10:07:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35760, '2017-06-28 10:07:10', NULL, NULL, 10486, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 10:07:10', 'admin-1498611394-14986156301912084', 1, 0, '', NULL, NULL, NULL),
(35761, '2017-06-28 10:07:10', NULL, NULL, 10486, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 10:07:10', 'admin-1498611394-14986156301912084', 1, 0, '', NULL, NULL, NULL),
(35762, '2017-06-28 10:07:15', NULL, NULL, 10486, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 10:07:15', 'admin-1498611394-149861563517939', 1, 1, 'SR', NULL, NULL, NULL),
(35763, '2017-06-28 12:45:21', NULL, NULL, 10496, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 12:45:21', 'admin-1498617250-1498625121316405', 1, 1, 'SR', NULL, NULL, '10.0'),
(35764, '2017-06-28 12:44:02', NULL, NULL, 10496, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 12:44:02', 'admin-1498617250-1498625042693988', 1, 1, 'SR', NULL, NULL, '10.0'),
(35765, '2017-06-28 12:45:21', NULL, NULL, 10496, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 12:45:21', 'admin-1498617250-1498625121316405', 1, 1, 'SR', NULL, NULL, '10.0'),
(35766, '2017-06-28 10:36:15', NULL, NULL, 10490, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 10:36:15', 'admin-1498617250-14986173755322928', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(35767, '2017-06-28 10:34:39', NULL, NULL, 10490, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 10:34:39', 'admin-1498617250-14986172793513159', 1, 1, 'SR', NULL, NULL, NULL),
(35768, '2017-06-28 10:46:30', NULL, NULL, 10491, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1498626392', 'admin', '2017-06-28 10:46:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35769, '2017-06-28 10:46:36', NULL, NULL, 10491, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 10:46:36', 'admin-1498617250-14986179963088844', 1, 0, '', NULL, NULL, NULL),
(35770, '2017-06-28 10:46:36', NULL, NULL, 10491, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 10:46:36', 'admin-1498617250-14986179963088844', 1, 0, '', NULL, NULL, NULL),
(35771, '2017-06-28 13:42:09', NULL, NULL, 10502, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:42:09', 'admin-1498626392-14986285295719086', 1, 0, '', 1, NULL, NULL),
(35772, '2017-06-28 13:32:46', NULL, NULL, 10501, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:32:46', 'admin-1498626392-14986279662885236', 1, 1, 'SR', NULL, NULL, NULL),
(35773, '2017-06-28 13:32:42', NULL, NULL, 10501, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:32:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35774, '2017-06-28 13:02:39', NULL, NULL, 10498, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 3, 11.00, 33.0000, 0.0000, 33.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:02:39', 'admin-1498617250-14986261591838742', 1, 1, 'SR', NULL, NULL, NULL),
(35775, '2017-06-28 12:57:10', NULL, NULL, 10497, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1498626392', 'admin', '2017-06-28 12:57:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35776, '2017-06-28 12:57:21', NULL, NULL, 10497, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 12:57:21', 'admin-1498617250-14986258412121493', 1, 1, 'SR', NULL, NULL, NULL),
(35777, '2017-06-28 12:57:21', NULL, NULL, 10497, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 12:57:21', 'admin-1498617250-14986258412121493', 1, 0, '', NULL, NULL, NULL),
(35778, '2017-06-28 12:57:21', NULL, NULL, 10497, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 12:57:21', 'admin-1498617250-14986258412121493', 1, 1, 'SR', NULL, NULL, NULL),
(35779, '2017-06-28 12:57:21', NULL, NULL, 10497, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 12:57:21', 'admin-1498617250-14986258412121493', 1, 1, 'SR', NULL, NULL, NULL),
(35780, '2017-06-28 13:02:14', NULL, NULL, 10498, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.30, 0.0000, 0.0000, 12.30, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:02:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35781, '2017-06-28 13:02:29', NULL, NULL, 10498, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:02:29', 'admin-1498617250-14986261490883220', 1, 0, '', NULL, NULL, NULL),
(35782, '2017-06-28 13:02:29', NULL, NULL, 10498, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:02:29', 'admin-1498617250-14986261490883220', 1, 1, 'SR', NULL, NULL, NULL),
(35783, '2017-06-28 13:02:29', NULL, NULL, 10498, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:02:29', 'admin-1498617250-14986261490883220', 1, 1, 'SR', NULL, NULL, NULL),
(35784, '2017-06-28 13:02:29', NULL, NULL, 10498, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:02:29', 'admin-1498617250-14986261490883220', 1, 0, '', NULL, NULL, NULL),
(35785, '2017-06-28 13:02:39', NULL, NULL, 10498, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 13:02:39', 'admin-1498617250-14986261591838742', 1, 1, 'SR', NULL, NULL, NULL),
(35786, '2017-06-28 09:57:23', NULL, NULL, 10483, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1498626392', 'admin', '2017-06-28 09:57:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35787, '2017-06-28 10:14:32', NULL, NULL, 10487, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 10:14:32', 'admin-1498611394-14986160727216166', 1, 0, '', 1, NULL, NULL),
(35788, '2017-06-28 10:24:30', NULL, NULL, 10488, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1498626392', 'admin', '2017-06-28 10:24:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35789, '2017-06-28 12:33:46', NULL, NULL, 10495, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 12:33:46', 'admin-1498617250-14986244267204463', 1, 0, '', NULL, NULL, NULL),
(35790, '2017-06-28 12:33:46', NULL, NULL, 10495, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 12:33:46', 'admin-1498617250-14986244267204463', 1, 1, 'SR', NULL, NULL, NULL),
(35791, '2017-06-28 12:33:46', NULL, NULL, 10495, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 12:33:46', 'admin-1498617250-14986244267204463', 1, 1, 'SR', NULL, NULL, NULL),
(35792, '2017-06-28 12:33:47', NULL, NULL, 10495, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 12:33:47', 'admin-1498617250-14986244267204463', 1, 0, '', NULL, NULL, NULL),
(35793, '2017-06-28 12:33:22', NULL, NULL, 10495, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.60, 0.0000, 0.0000, 10.60, 1, '27', 1, '1498626392', 'admin', '2017-06-28 12:33:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35794, '2017-06-28 12:09:34', NULL, NULL, 10494, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1498626392', 'admin', '2017-06-28 12:09:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35795, '2017-06-28 12:09:37', NULL, NULL, 10494, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 12:09:37', 'admin-1498617250-14986229776753644', 1, 0, '', NULL, NULL, NULL),
(35796, '2017-06-28 11:21:17', NULL, NULL, 10493, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 11:21:17', 'admin-1498617250-14986200775897243', 1, 1, 'SR', NULL, NULL, NULL),
(35797, '2017-06-28 11:22:13', NULL, NULL, 10493, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 11:22:13', 'admin-1498617250-14986201327865493', 1, 1, 'SR', NULL, NULL, NULL),
(35798, '2017-06-28 11:21:17', NULL, NULL, 10493, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 11:21:17', 'admin-1498617250-14986200775897243', 1, 1, 'SR', NULL, NULL, NULL),
(35799, '2017-06-28 11:02:03', NULL, NULL, 10492, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 11:02:03', 'admin-1498617250-14986189231037213', 1, 1, 'SR', NULL, NULL, NULL),
(35800, '2017-06-28 11:01:59', NULL, NULL, 10492, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1498626392', 'admin', '2017-06-28 11:01:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35801, '2017-06-28 10:47:05', NULL, NULL, 10491, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 10:47:05', 'admin-1498617250-1498618024849854', 1, 1, 'SR', NULL, NULL, NULL),
(35802, '2017-06-28 10:47:05', NULL, NULL, 10491, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 10:47:05', 'admin-1498617250-1498618024849854', 1, 1, 'SR', NULL, NULL, NULL),
(35803, '2017-06-28 10:32:35', NULL, NULL, 10490, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1498626392', 'admin', '2017-06-28 10:32:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35804, '2017-06-28 10:33:40', NULL, NULL, 10490, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 10:33:40', 'admin-1498611394-14986172203591960', 1, 0, '', NULL, NULL, NULL),
(35805, '2017-06-28 10:33:40', NULL, NULL, 10490, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 10:33:40', 'admin-1498611394-14986172203591960', 1, 0, '', NULL, NULL, NULL),
(35806, '2017-06-28 00:00:00', NULL, NULL, 10483, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 09:32:49', 'admin-1498611394-1498613569128117', 1, 1, 'SR', NULL, NULL, NULL),
(35807, '2017-06-28 10:24:37', NULL, NULL, 10488, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 10:24:37', 'admin-1498611394-14986166775021726', 1, 1, 'SR', NULL, NULL, NULL),
(35808, '2017-06-28 10:24:37', NULL, NULL, 10488, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 10:24:37', 'admin-1498611394-14986166775021726', 1, 1, 'SR', NULL, NULL, NULL),
(35809, '2017-06-28 10:24:49', NULL, NULL, 10489, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 10:24:49', 'admin-1498611394-14986166890175221', 1, 1, 'SR', 1, NULL, NULL),
(35810, '2017-06-28 09:06:16', NULL, NULL, 10480, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 09:06:16', 'admin-1498611394-1498611976330893', 1, 1, 'SR', NULL, NULL, NULL),
(35811, '2017-06-28 09:06:16', NULL, NULL, 10480, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 09:06:16', 'admin-1498611394-1498611976330893', 1, 1, 'SR', NULL, NULL, NULL),
(35812, '2017-06-28 09:06:16', NULL, NULL, 10480, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 09:06:16', 'admin-1498611394-1498611976330893', 1, 0, '', NULL, NULL, NULL),
(35813, '2017-06-28 09:06:16', NULL, NULL, 10480, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498626392', 'admin', '2017-06-28 09:06:16', 'admin-1498611394-1498611976330893', 1, 0, '', NULL, NULL, NULL),
(35814, '2017-06-28 09:06:06', NULL, NULL, 10480, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.19, 0.0000, 0.0000, 6.19, 1, '27', 1, '1498626392', 'admin', '2017-06-28 09:06:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35815, '2017-06-29 12:53:17', NULL, NULL, 10534, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:53:17', 'admin-1498710862-14987119968413377', 1, 0, '', NULL, NULL, NULL),
(35816, '2017-06-29 17:17:24', NULL, NULL, 10552, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 17:17:24', 'admin-1498714477-1498727844427249', 1, 1, 'SR', NULL, NULL, NULL),
(35817, '2017-06-29 17:17:24', NULL, NULL, 10552, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 17:17:24', 'admin-1498714477-1498727844427249', 1, 1, 'SR', NULL, NULL, NULL),
(35818, '2017-06-29 00:00:00', NULL, NULL, 10550, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:29:14', 'admin-1498704985-14987105547172779', 1, 0, '', NULL, NULL, NULL),
(35819, '2017-06-29 13:22:17', NULL, NULL, 10536, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:22:17', 'admin-1498710862-14987137375806045', 1, 1, 'SR', NULL, NULL, NULL),
(35820, '2017-06-29 13:22:17', NULL, NULL, 10536, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:22:17', 'admin-1498710862-14987137375806045', 1, 1, 'SR', NULL, NULL, NULL),
(35821, '2017-06-29 13:23:15', NULL, NULL, 10537, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:23:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35822, '2017-06-29 13:23:25', NULL, NULL, 10537, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:23:25', 'admin-1498710862-14987138048419452', 1, 1, 'SR', NULL, NULL, NULL),
(35823, '2017-06-29 13:23:25', NULL, NULL, 10537, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:23:25', 'admin-1498710862-14987138048419452', 1, 0, '', NULL, NULL, NULL),
(35824, '2017-06-29 13:34:32', NULL, NULL, 10536, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:34:32', 'admin-1498710862-14987144726067475', 1, 1, 'SR', NULL, NULL, NULL),
(35825, '2017-06-29 00:00:00', NULL, NULL, 10525, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 11:05:37', 'admin-1498704985-14987055372463422', 1, 1, 'SR', NULL, NULL, NULL),
(35826, '2017-06-29 15:10:08', NULL, NULL, 10546, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 15:10:08', 'admin-1498714477-1498720208492839', 1, 1, 'SR', NULL, NULL, NULL),
(35827, '2017-06-29 15:06:27', NULL, NULL, 10546, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1498714477', 'admin', '2017-06-29 15:06:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35828, '2017-06-29 15:06:30', NULL, NULL, 10546, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 15:06:30', 'admin-1498714477-14987199899573251', 1, 1, 'SR', NULL, NULL, NULL),
(35829, '2017-06-29 14:16:45', NULL, NULL, 10540, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 14:16:45', 'admin-1498714477-14987170057155265', 1, 1, 'SR', NULL, NULL, NULL),
(35830, '2017-06-29 14:16:45', NULL, NULL, 10540, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 14:16:45', 'admin-1498714477-14987170057155265', 1, 1, 'SR', NULL, NULL, NULL),
(35831, '2017-06-29 00:00:00', NULL, NULL, 10541, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:38:29', 'admin-1498714477-14987147095277523', 1, 0, '', NULL, NULL, NULL),
(35832, '2017-06-29 00:00:00', NULL, NULL, 10541, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 14:18:39', 'admin-1498714477-14987171192858346', 1, 0, '', NULL, NULL, NULL),
(35833, '2017-06-29 00:00:00', NULL, NULL, 10542, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:38:29', 'admin-1498714477-14987147095277523', 1, 1, 'SR', NULL, NULL, NULL),
(35834, '2017-06-29 00:00:00', NULL, NULL, 10543, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:38:29', 'admin-1498714477-14987147095277523', 1, 1, 'SR', NULL, NULL, NULL),
(35835, '2017-06-29 14:20:34', NULL, NULL, 10540, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 14:20:34', 'admin-1498714477-14987172344848597', 1, 1, 'SR', NULL, NULL, NULL),
(35836, '2017-06-29 14:20:58', NULL, NULL, 10544, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1498714477', 'admin', '2017-06-29 14:20:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35837, '2017-06-29 14:21:02', NULL, NULL, 10544, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 14:21:02', 'admin-1498714477-14987172623099841', 1, 1, 'SR', NULL, NULL, NULL),
(35838, '2017-06-29 14:21:56', NULL, NULL, 10529, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 14:21:56', 'admin-1498714477-1498717316486201', 1, 1, 'SR', NULL, NULL, NULL),
(35839, '2017-06-29 14:42:01', NULL, NULL, 10540, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 14:42:01', 'admin-1498714477-14987185214033894', 1, 1, 'SR', NULL, NULL, NULL),
(35840, '2017-06-29 14:29:12', NULL, NULL, 10545, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 2, 11.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 14:29:12', 'admin-1498714477-14987177523328656', 1, 1, 'SR', NULL, NULL, '10.0'),
(35841, '2017-06-29 14:29:02', NULL, NULL, 10545, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 14:29:02', 'admin-1498714477-14987177427447080', 1, 0, '', NULL, NULL, '10.0'),
(35842, '2017-06-29 14:28:56', NULL, NULL, 10545, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1498714477', 'admin', '2017-06-29 14:28:56', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(35843, '2017-06-29 14:16:45', NULL, NULL, 10540, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 14:16:45', 'admin-1498714477-14987170057155265', 1, 0, '', NULL, NULL, NULL),
(35844, '2017-06-29 14:16:45', NULL, NULL, 10540, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 14:16:45', 'admin-1498714477-14987170057155265', 1, 1, 'SR', NULL, NULL, NULL),
(35845, '2017-06-29 16:22:53', NULL, NULL, 10549, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1498714477', 'admin', '2017-06-29 16:22:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35846, '2017-06-29 16:22:59', NULL, NULL, 10549, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 16:22:59', 'admin-1498714477-14987245789893799', 1, 1, 'SR', NULL, NULL, NULL),
(35847, '2017-06-29 12:11:54', NULL, NULL, 10528, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:11:54', 'admin-1498704985-14987095143709345', 1, 0, '', NULL, NULL, NULL),
(35848, '2017-06-29 12:11:54', NULL, NULL, 10528, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:11:54', 'admin-1498704985-14987095143709345', 1, 1, 'SR', NULL, NULL, NULL),
(35849, '2017-06-29 17:18:21', NULL, NULL, 10552, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 17:18:21', 'admin-1498714477-14987279017213777', 1, 0, '', NULL, NULL, NULL),
(35850, '2017-06-29 17:18:31', NULL, NULL, 10552, 0, 284, '218', 'Caramel Waffles', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 17:18:31', 'admin-1498714477-14987279111921094', 1, 0, '', NULL, NULL, NULL),
(35851, '2017-06-29 13:34:32', NULL, NULL, 10536, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:34:32', 'admin-1498710862-14987144726067475', 1, 1, 'SR', NULL, NULL, NULL),
(35852, '2017-06-29 13:34:48', NULL, NULL, 10534, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:34:48', 'admin-1498714477-14987144884268744', 1, 0, '', NULL, NULL, NULL),
(35853, '2017-06-29 00:00:00', NULL, NULL, 10542, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:38:13', 'admin-1498714477-14987146934709488', 1, 0, '', NULL, NULL, NULL),
(35854, '2017-06-29 17:09:47', NULL, NULL, 10551, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1498714477', 'admin', '2017-06-29 17:09:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35855, '2017-06-29 16:22:59', NULL, NULL, 10549, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 16:22:59', 'admin-1498714477-14987245789893799', 1, 0, '', NULL, NULL, NULL),
(35856, '2017-06-29 16:22:59', NULL, NULL, 10549, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 16:22:59', 'admin-1498714477-14987245789893799', 1, 1, 'SR', NULL, NULL, NULL),
(35857, '2017-06-29 17:09:58', NULL, NULL, 10551, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 17:09:58', 'admin-1498714477-14987273981727725', 1, 1, 'SR', NULL, NULL, NULL),
(35858, '2017-06-29 17:09:58', NULL, NULL, 10551, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 17:09:58', 'admin-1498714477-14987273981727725', 1, 1, 'SR', NULL, NULL, NULL),
(35859, '2017-06-29 17:09:58', NULL, NULL, 10551, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 17:09:58', 'admin-1498714477-14987273981727725', 1, 0, '', NULL, NULL, NULL),
(35860, '2017-06-29 17:19:31', NULL, NULL, 10553, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 17:19:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35861, '2017-06-29 17:19:33', NULL, NULL, 10553, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 17:19:33', 'admin-1498714477-14987279736928384', 1, 1, 'SR', NULL, NULL, NULL),
(35862, '2017-06-29 17:19:33', NULL, NULL, 10553, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 17:19:33', 'admin-1498714477-14987279736928384', 1, 1, 'SR', NULL, NULL, NULL),
(35863, '2017-06-29 14:16:31', NULL, NULL, 10540, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1498714477', 'admin', '2017-06-29 14:16:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35864, '2017-06-29 00:00:00', NULL, NULL, 10543, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, NULL, NULL, 4.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:37:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35865, '2017-06-29 14:19:47', NULL, NULL, 10542, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 14:19:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35866, '2017-06-29 00:00:00', NULL, NULL, 10543, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:38:13', 'admin-1498714477-14987146934709488', 1, 0, '', NULL, NULL, NULL),
(35867, '2017-06-29 10:16:57', NULL, NULL, 10518, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 10:16:57', 'admin-1498696035-14987026169497679', 1, 0, '', NULL, NULL, NULL),
(35868, '2017-06-29 09:40:25', NULL, NULL, 10516, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 09:40:25', 'admin-1498696035-14987004254916487', 1, 0, '', NULL, NULL, NULL),
(35869, '2017-06-29 15:49:45', NULL, NULL, 10548, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 15:49:45', 'admin-1498714477-14987225850004958', 1, 1, 'SR', NULL, NULL, NULL),
(35870, '2017-06-29 15:49:45', NULL, NULL, 10548, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 15:49:45', 'admin-1498714477-14987225850004958', 1, 1, 'SR', NULL, NULL, NULL),
(35871, '2017-06-29 15:49:45', NULL, NULL, 10548, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 15:49:45', 'admin-1498714477-14987225850004958', 1, 1, 'SR', NULL, NULL, NULL),
(35872, '2017-06-29 17:17:14', NULL, NULL, 10552, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1498714477', 'admin', '2017-06-29 17:17:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35873, '2017-06-29 15:35:39', NULL, NULL, 10547, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1498714477', 'admin', '2017-06-29 15:35:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35874, '2017-06-29 15:35:44', NULL, NULL, 10547, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 15:35:44', 'admin-1498714477-14987217448015841', 1, 1, 'SR', NULL, NULL, NULL),
(35875, '2017-06-29 15:35:44', NULL, NULL, 10547, 0, 265, '199', 'Old Penang PostCard', '', 'DISCOUNT ', '0', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 15:35:44', 'admin-1498714477-14987217448015841', 1, 0, '', NULL, NULL, NULL),
(35876, '2017-06-29 15:49:22', NULL, NULL, 10548, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1498714477', 'admin', '2017-06-29 15:49:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35877, '2017-06-29 15:49:27', NULL, NULL, 10548, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 15:49:27', 'admin-1498714477-1498722567471471', 1, 0, '', NULL, NULL, NULL),
(35878, '2017-06-29 13:57:58', NULL, NULL, 10539, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:57:58', 'admin-1498714477-14987158779223589', 1, 0, '', NULL, NULL, NULL),
(35879, '2017-06-29 13:57:58', NULL, NULL, 10539, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:57:58', 'admin-1498714477-14987158779223589', 1, 0, '', NULL, NULL, NULL),
(35880, '2017-06-29 13:57:58', NULL, NULL, 10539, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:57:58', 'admin-1498714477-14987158779223589', 1, 1, 'SR', NULL, NULL, NULL),
(35881, '2017-06-29 13:57:58', NULL, NULL, 10539, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:57:58', 'admin-1498714477-14987158779223589', 1, 1, 'SR', NULL, NULL, NULL),
(35882, '2017-06-29 15:49:45', NULL, NULL, 10548, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 15:49:45', 'admin-1498714477-14987225850004958', 1, 1, 'SR', NULL, NULL, NULL),
(35883, '2017-06-29 12:56:49', NULL, NULL, 10535, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:56:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35884, '2017-06-29 12:56:58', NULL, NULL, 10535, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:56:58', 'admin-1498710862-14987122184523779', 1, 1, 'SR', NULL, NULL, NULL),
(35885, '2017-06-29 12:56:58', NULL, NULL, 10535, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:56:58', 'admin-1498710862-14987122184523779', 1, 1, 'SR', NULL, NULL, NULL),
(35886, '2017-06-29 12:56:58', NULL, NULL, 10535, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:56:58', 'admin-1498710862-14987122184523779', 1, 1, 'SR', NULL, NULL, NULL),
(35887, '2017-06-29 13:57:52', NULL, NULL, 10539, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:57:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35888, '2017-06-29 00:00:00', NULL, NULL, 10542, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:38:29', 'admin-1498714477-14987147095277523', 1, 1, 'SR', NULL, NULL, NULL),
(35889, '2017-06-29 14:18:52', NULL, NULL, 10541, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 14:18:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35890, '2017-06-29 10:20:21', NULL, NULL, 10519, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 10:20:21', 'admin-1498696035-14987028209619110', 1, 1, 'SR', NULL, NULL, NULL),
(35891, '2017-06-29 12:44:31', NULL, NULL, 10532, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:44:31', 'admin-1498710862-14987114711492637', 1, 0, '', NULL, NULL, NULL),
(35892, '2017-06-29 12:44:31', NULL, NULL, 10532, 0, 153, '87', 'Wake Me Up!', 'sunny side', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:44:31', 'admin-1498710862-14987114711492637', 1, 0, '', NULL, NULL, NULL),
(35893, '2017-06-29 15:35:37', NULL, NULL, 10546, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 15:35:37', 'admin-1498714477-14987217375234495', 1, 1, 'SR', NULL, NULL, NULL),
(35894, '2017-06-29 15:14:29', NULL, NULL, 10546, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 15:14:29', 'admin-1498714477-1498720468859668', 1, 1, 'SR', NULL, NULL, NULL),
(35895, '2017-06-29 00:00:00', NULL, NULL, 10543, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:38:13', 'admin-1498714477-14987146934709488', 1, 0, '', NULL, NULL, NULL),
(35896, '2017-06-29 12:44:31', NULL, NULL, 10532, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:44:31', 'admin-1498710862-14987114711492637', 1, 0, '', NULL, NULL, NULL),
(35897, '2017-06-29 12:44:37', NULL, NULL, 10532, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:44:37', 'admin-1498710862-14987114777326357', 1, 0, '', NULL, NULL, NULL),
(35898, '2017-06-29 12:44:37', NULL, NULL, 10532, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:44:37', 'admin-1498710862-14987114777326357', 1, 0, '', NULL, NULL, NULL),
(35899, '2017-06-29 12:51:51', NULL, NULL, 10533, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:51:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35900, '2017-06-29 12:52:11', NULL, NULL, 10533, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:52:11', 'admin-1498710862-1498711931436267', 1, 0, '', NULL, NULL, NULL),
(35901, '2017-06-29 12:52:11', NULL, NULL, 10533, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:52:11', 'admin-1498710862-1498711931436267', 1, 0, '', NULL, NULL, NULL),
(35902, '2017-06-29 12:52:11', NULL, NULL, 10533, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:52:11', 'admin-1498710862-1498711931436267', 1, 0, '', NULL, NULL, NULL),
(35903, '2017-06-29 12:53:01', NULL, NULL, 10534, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:53:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35904, '2017-06-29 13:19:56', NULL, NULL, 10536, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:19:56', 'admin-1498710862-14987135960886217', 1, 1, 'SR', NULL, NULL, NULL),
(35905, '2017-06-29 10:53:38', NULL, NULL, 10520, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 10:53:38', 'admin-1498696035-14987048183078024', 1, 0, '', NULL, NULL, NULL),
(35906, '2017-06-29 10:53:38', NULL, NULL, 10520, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 10:53:38', 'admin-1498696035-14987048183078024', 1, 1, 'SR', NULL, NULL, NULL),
(35907, '2017-06-29 12:53:21', NULL, NULL, 10534, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:53:21', 'admin-1498710862-1498712001474819', 1, 1, 'SR', NULL, NULL, NULL),
(35908, '2017-06-29 12:53:17', NULL, NULL, 10534, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:53:17', 'admin-1498710862-14987119968413377', 1, 0, '', NULL, NULL, NULL),
(35909, '2017-06-29 12:53:17', NULL, NULL, 10534, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:53:17', 'admin-1498710862-14987119968413377', 1, 0, '', NULL, NULL, NULL),
(35910, '2017-06-29 11:49:58', NULL, NULL, 10524, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 11:49:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35911, '2017-06-29 11:18:05', NULL, NULL, 10522, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1498714477', 'admin', '2017-06-29 11:18:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35912, '2017-06-29 11:18:12', NULL, NULL, 10522, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 11:18:12', 'admin-1498704985-14987062924145568', 1, 0, '', NULL, NULL, NULL),
(35913, '2017-06-29 11:18:12', NULL, NULL, 10522, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 11:18:12', 'admin-1498704985-14987062924145568', 1, 0, '', NULL, NULL, NULL),
(35914, '2017-06-29 11:18:20', NULL, NULL, 10522, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 11:18:20', 'admin-1498704985-14987063006825130', 1, 1, 'SR', NULL, NULL, NULL),
(35915, '2017-06-29 10:20:21', NULL, NULL, 10519, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 10:20:21', 'admin-1498696035-14987028209619110', 1, 1, 'SR', NULL, NULL, NULL),
(35916, '2017-06-29 09:39:14', NULL, NULL, 10517, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 09:39:14', 'admin-1498696035-14987003544976522', 1, 1, 'SR', NULL, NULL, NULL),
(35917, '2017-06-29 09:39:14', NULL, NULL, 10517, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 09:39:14', 'admin-1498696035-14987003544976522', 1, 0, '', NULL, NULL, NULL),
(35918, '2017-06-29 12:44:31', NULL, NULL, 10532, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:44:31', 'admin-1498710862-14987114711492637', 1, 0, '', NULL, NULL, NULL),
(35919, '2017-06-29 12:44:31', NULL, NULL, 10532, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:44:31', 'admin-1498710862-14987114711492637', 1, 0, '', NULL, NULL, NULL),
(35920, '2017-06-29 13:19:49', NULL, NULL, 10536, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.00, 0.0000, 0.0000, 11.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:19:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35921, '2017-06-29 12:44:09', NULL, NULL, 10532, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.10, 0.0000, 0.0000, 11.10, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:44:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35922, '2017-06-29 12:31:36', NULL, NULL, 10531, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:31:36', 'admin-1498704985-14987106967129410', 1, 0, '', NULL, NULL, NULL),
(35923, '2017-06-29 12:31:36', NULL, NULL, 10531, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:31:36', 'admin-1498704985-14987106967129410', 1, 0, '', NULL, NULL, NULL),
(35924, '2017-06-29 12:31:21', NULL, NULL, 10531, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:31:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35925, '2017-06-29 12:30:24', NULL, NULL, 10530, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:30:24', 'admin-1498704985-14987106239519695', 1, 0, '', NULL, NULL, NULL),
(35926, '2017-06-29 12:30:24', NULL, NULL, 10530, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:30:24', 'admin-1498704985-14987106239519695', 1, 0, '', NULL, NULL, NULL),
(35927, '2017-06-29 12:12:02', NULL, NULL, 10528, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:12:02', 'admin-1498704985-14987095223646182', 1, 1, 'SR', NULL, NULL, NULL),
(35928, '2017-06-29 12:30:09', NULL, NULL, 10530, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:30:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35929, '2017-06-29 12:30:19', NULL, NULL, 10530, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:30:19', 'admin-1498704985-14987106190844349', 1, 1, 'SR', NULL, NULL, NULL),
(35930, '2017-06-29 12:30:19', NULL, NULL, 10530, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:30:19', 'admin-1498704985-14987106190844349', 1, 0, '', NULL, NULL, NULL),
(35931, '2017-06-29 00:00:00', NULL, NULL, 10550, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, NULL, NULL, 2.10, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:29:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35932, '2017-06-29 12:30:05', NULL, NULL, 10529, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:30:05', 'admin-1498704985-1498710605049760', 1, 1, 'SR', NULL, NULL, NULL),
(35933, '2017-06-29 16:31:01', NULL, NULL, 10529, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1498714477', 'admin', '2017-06-29 16:31:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35934, '2017-06-29 00:00:00', NULL, NULL, 10542, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 13:38:13', 'admin-1498714477-14987146934709488', 1, 0, '', NULL, NULL, NULL),
(35935, '2017-06-29 12:12:02', NULL, NULL, 10528, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:12:02', 'admin-1498704985-14987095223646182', 1, 1, 'SR', NULL, NULL, NULL),
(35936, '2017-06-29 12:12:02', NULL, NULL, 10528, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:12:02', 'admin-1498704985-14987095223646182', 1, 0, '', NULL, NULL, NULL),
(35937, '2017-06-29 12:11:39', NULL, NULL, 10528, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.30, 0.0000, 0.0000, 11.30, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:11:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35938, '2017-06-29 12:11:54', NULL, NULL, 10528, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:11:54', 'admin-1498704985-14987095143709345', 1, 0, '', NULL, NULL, NULL),
(35939, '2017-06-29 12:11:54', NULL, NULL, 10528, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:11:54', 'admin-1498704985-14987095143709345', 1, 0, '', NULL, NULL, NULL),
(35940, '2017-06-29 12:04:20', NULL, NULL, 10527, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:04:20', 'admin-1498704985-1498709060728255', 1, 1, 'SR', NULL, NULL, NULL),
(35941, '2017-06-29 12:04:17', NULL, NULL, 10527, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1498714477', 'admin', '2017-06-29 12:04:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35942, '2017-06-29 11:51:22', NULL, NULL, 10523, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 11:51:22', 'admin-1498704985-1498708282113706', 1, 1, 'SR', NULL, NULL, NULL),
(35943, '2017-06-29 00:00:00', NULL, NULL, 10526, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 11:05:37', 'admin-1498704985-14987055372463422', 1, 1, 'SR', NULL, NULL, NULL),
(35944, '2017-06-29 00:00:00', NULL, NULL, 10524, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 11:05:37', 'admin-1498704985-14987055372463422', 1, 1, 'SR', NULL, NULL, NULL),
(35945, '2017-06-29 11:49:48', NULL, NULL, 10523, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 11:49:48', 'admin-1498704985-14987081880254359', 1, 0, '', NULL, NULL, NULL),
(35946, '2017-06-29 11:49:48', NULL, NULL, 10523, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 11:49:48', 'admin-1498704985-14987081880254359', 1, 0, '', NULL, NULL, NULL),
(35947, '2017-06-29 11:18:20', NULL, NULL, 10522, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 11:18:20', 'admin-1498704985-14987063006825130', 1, 1, 'SR', NULL, NULL, NULL),
(35948, '2017-06-29 00:00:00', NULL, NULL, 10526, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, NULL, NULL, 1.40, 1, '27', 1, '1498714477', 'admin', '2017-06-29 11:05:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35949, '2017-06-29 11:51:22', NULL, NULL, 10523, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 11:51:22', 'admin-1498704985-1498708282113706', 1, 1, 'SR', NULL, NULL, NULL),
(35950, '2017-06-29 11:50:17', NULL, NULL, 10525, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1498714477', 'admin', '2017-06-29 11:50:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35951, '2017-06-29 10:20:21', NULL, NULL, 10519, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 10:20:21', 'admin-1498696035-14987028209619110', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(35952, '2017-06-29 10:20:21', NULL, NULL, 10519, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 10:20:21', 'admin-1498696035-14987028209619110', 1, 1, 'SR', NULL, NULL, NULL),
(35953, '2017-06-29 10:53:32', NULL, NULL, 10520, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1498714477', 'admin', '2017-06-29 10:53:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35954, '2017-06-29 10:53:38', NULL, NULL, 10520, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 10:53:38', 'admin-1498696035-14987048183078024', 1, 0, '', NULL, NULL, NULL),
(35955, '2017-06-29 11:49:41', NULL, NULL, 10523, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1498714477', 'admin', '2017-06-29 11:49:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35956, '2017-06-29 10:20:21', NULL, NULL, 10519, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 10:20:21', 'admin-1498696035-14987028209619110', 1, 0, '', NULL, NULL, NULL),
(35957, '2017-06-29 10:20:07', NULL, NULL, 10519, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1498714477', 'admin', '2017-06-29 10:20:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35958, '2017-06-29 10:20:21', NULL, NULL, 10519, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 10:20:21', 'admin-1498696035-14987028209619110', 1, 0, '', NULL, NULL, NULL),
(35959, '2017-06-29 10:18:37', NULL, NULL, 10518, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 10:18:37', 'admin-1498696035-14987027171928697', 1, 0, '', NULL, NULL, NULL),
(35960, '2017-06-29 10:18:37', NULL, NULL, 10518, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 10:18:37', 'admin-1498696035-14987027171928697', 1, 1, 'SR', NULL, NULL, NULL),
(35961, '2017-06-29 10:16:57', NULL, NULL, 10518, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 10:16:57', 'admin-1498696035-14987026169497679', 1, 0, '', NULL, NULL, NULL),
(35962, '2017-06-29 10:17:01', NULL, NULL, 10518, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 10:17:01', 'admin-1498696035-14987026211724778', 1, 0, '', NULL, NULL, NULL),
(35963, '2017-06-29 10:16:47', NULL, NULL, 10518, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1498714477', 'admin', '2017-06-29 10:16:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35964, '2017-06-29 10:16:57', NULL, NULL, 10518, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 10:16:57', 'admin-1498696035-14987026169497679', 1, 0, '', NULL, NULL, NULL),
(35965, '2017-06-29 09:39:14', NULL, NULL, 10517, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 09:39:14', 'admin-1498696035-14987003544976522', 1, 0, '', NULL, NULL, NULL),
(35966, '2017-06-29 09:40:25', NULL, NULL, 10516, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 09:40:25', 'admin-1498696035-14987004254916487', 1, 1, 'SR', NULL, NULL, NULL),
(35967, '2017-06-29 09:40:25', NULL, NULL, 10516, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 09:40:25', 'admin-1498696035-14987004254916487', 1, 0, '', NULL, NULL, NULL),
(35968, '2017-06-29 09:40:25', NULL, NULL, 10516, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 09:40:25', 'admin-1498696035-14987004254916487', 1, 1, 'SR', NULL, NULL, NULL),
(35969, '2017-06-29 09:15:48', NULL, NULL, 10515, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 09:15:48', 'admin-1498696035-14986989482311972', 1, 0, '', NULL, NULL, NULL),
(35970, '2017-06-29 09:15:48', NULL, NULL, 10515, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 09:15:48', 'admin-1498696035-14986989482311972', 1, 0, '', NULL, NULL, NULL),
(35971, '2017-06-29 09:16:00', NULL, NULL, 10515, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 24.0000, 0.0000, 12.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 09:16:00', 'admin-1498696035-14986989608563163', 1, 1, 'SR', NULL, NULL, NULL),
(35972, '2017-06-29 09:16:00', NULL, NULL, 10515, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 09:16:00', 'admin-1498696035-14986989608563163', 1, 1, 'SR', NULL, NULL, NULL),
(35973, '2017-06-29 09:39:14', NULL, NULL, 10517, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 09:39:14', 'admin-1498696035-14987003544976522', 1, 1, 'SR', NULL, NULL, NULL),
(35974, '2017-06-29 09:39:14', NULL, NULL, 10517, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 09:39:14', 'admin-1498696035-14987003544976522', 1, 1, 'SR', NULL, NULL, NULL),
(35975, '2017-06-29 09:39:14', NULL, NULL, 10517, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 09:39:14', 'admin-1498696035-14987003544976522', 1, 1, 'SR', NULL, NULL, NULL),
(35976, '2017-06-29 09:38:59', NULL, NULL, 10517, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1498714477', 'admin', '2017-06-29 09:38:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35977, '2017-06-29 09:37:38', NULL, NULL, 10516, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1498714477', 'admin', '2017-06-29 09:37:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35978, '2017-06-29 09:15:42', NULL, NULL, 10515, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1498714477', 'admin', '2017-06-29 09:15:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35979, '2017-06-30 15:20:23', NULL, NULL, 10574, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 15:20:23', 'admin-1498792010-1498807222888285', 1, 0, '', NULL, NULL, NULL),
(35980, '2017-06-30 15:20:23', NULL, NULL, 10574, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 15:20:23', 'admin-1498792010-1498807222888285', 1, 1, 'SR', NULL, NULL, NULL),
(35981, '2017-06-30 15:32:43', NULL, NULL, 10574, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 15:32:43', 'admin-1498792010-14988079629656436', 1, 0, '', NULL, NULL, NULL),
(35982, '2017-06-30 15:46:57', NULL, NULL, 10574, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 15:46:57', 'admin-1498792010-14988088167313418', 1, 0, '', NULL, NULL, NULL),
(35983, '2017-06-30 12:23:39', NULL, NULL, 10571, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:23:39', 'admin-1498792010-14987966194631117', 1, 1, 'SR', NULL, NULL, NULL),
(35984, '2017-06-30 12:23:39', NULL, NULL, 10571, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:23:39', 'admin-1498792010-14987966194631117', 1, 1, 'SR', NULL, NULL, NULL),
(35985, '2017-06-30 11:32:16', NULL, NULL, 10565, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:32:16', 'admin-1498792010-1498793535831523', 1, 1, 'SR', NULL, NULL, NULL),
(35986, '2017-06-30 12:16:15', NULL, NULL, 10570, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:16:15', 'admin-1498792010-14987961750253054', 1, 0, '', NULL, NULL, NULL),
(35987, '2017-06-30 11:39:33', NULL, NULL, 10567, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:39:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35988, '2017-06-30 11:39:51', NULL, NULL, 10567, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:39:51', 'admin-1498792010-14987939916568316', 1, 0, '', NULL, NULL, NULL),
(35989, '2017-06-30 11:39:51', NULL, NULL, 10567, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:39:51', 'admin-1498792010-14987939916568316', 1, 1, 'SR', NULL, NULL, NULL),
(35990, '2017-06-30 10:14:39', NULL, NULL, 10556, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 10:14:39', 'admin-1498783768-1498788879664677', 1, 0, '', NULL, NULL, NULL),
(35991, '2017-06-30 12:28:58', NULL, NULL, 10572, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:28:58', 'admin-1498792010-14987969387246632', 1, 0, '', NULL, NULL, NULL),
(35992, '2017-06-30 12:28:58', NULL, NULL, 10572, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:28:58', 'admin-1498792010-14987969387246632', 1, 0, '', NULL, NULL, NULL),
(35993, '2017-06-30 12:28:58', NULL, NULL, 10572, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:28:58', 'admin-1498792010-14987969387246632', 1, 0, '', NULL, NULL, NULL),
(35994, '2017-06-30 12:28:58', NULL, NULL, 10572, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:28:58', 'admin-1498792010-14987969387246632', 1, 1, 'SR', NULL, NULL, NULL),
(35995, '2017-06-30 11:52:09', NULL, NULL, 10568, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:52:09', 'admin-1498792010-14987947290512325', 1, 0, '', NULL, NULL, NULL),
(35996, '2017-06-30 12:06:04', NULL, NULL, 10569, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:06:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35997, '2017-06-30 12:06:09', NULL, NULL, 10569, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:06:09', 'admin-1498792010-1498795568873794', 1, 1, 'SR', NULL, NULL, NULL),
(35998, '2017-06-30 12:15:58', NULL, NULL, 10570, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:15:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(35999, '2017-06-30 10:45:23', NULL, NULL, 10555, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 10:45:23', 'admin-1498783768-14987907231098163', 1, 1, 'SR', NULL, NULL, NULL),
(36000, '2017-06-30 11:00:39', NULL, NULL, 10560, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:00:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36001, '2017-06-30 11:00:44', NULL, NULL, 10560, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:00:44', 'admin-1498783768-1498791644550833', 1, 0, '', NULL, NULL, NULL),
(36002, '2017-06-30 11:06:41', NULL, NULL, 10561, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:06:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36003, '2017-06-30 11:39:51', NULL, NULL, 10567, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:39:51', 'admin-1498792010-14987939916568316', 1, 1, 'SR', NULL, NULL, NULL),
(36004, '2017-06-30 11:52:03', NULL, NULL, 10568, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:52:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36005, '2017-06-30 11:52:09', NULL, NULL, 10568, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:52:09', 'admin-1498792010-14987947290512325', 1, 1, 'SR', NULL, NULL, NULL),
(36006, '2017-06-30 15:20:17', NULL, NULL, 10574, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1498792010', 'admin', '2017-06-30 15:20:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36007, '2017-06-30 12:35:28', NULL, NULL, 10573, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:35:28', 'admin-1498792010-14987973283676544', 1, 0, '', NULL, NULL, NULL),
(36008, '2017-06-30 12:35:28', NULL, NULL, 10573, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:35:28', 'admin-1498792010-14987973283676544', 1, 0, '', NULL, NULL, NULL),
(36009, '2017-06-30 12:35:28', NULL, NULL, 10573, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:35:28', 'admin-1498792010-14987973283676544', 1, 1, 'SR', NULL, NULL, NULL),
(36010, '2017-06-30 12:35:22', NULL, NULL, 10573, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:35:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36011, '2017-06-30 12:28:58', NULL, NULL, 10572, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:28:58', 'admin-1498792010-14987969387246632', 1, 0, '', NULL, NULL, NULL),
(36012, '2017-06-30 12:28:58', NULL, NULL, 10572, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:28:58', 'admin-1498792010-14987969387246632', 1, 0, '', NULL, NULL, NULL),
(36013, '2017-06-30 12:23:50', NULL, NULL, 10571, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:23:50', 'admin-1498792010-14987966300083443', 1, 0, '', NULL, NULL, NULL),
(36014, '2017-06-30 12:23:50', NULL, NULL, 10571, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:23:50', 'admin-1498792010-14987966300083443', 1, 0, '', NULL, NULL, NULL),
(36015, '2017-06-30 12:23:50', NULL, NULL, 10571, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:23:50', 'admin-1498792010-14987966300083443', 1, 0, '', NULL, NULL, NULL),
(36016, '2017-06-30 12:23:50', NULL, NULL, 10571, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:23:50', 'admin-1498792010-14987966300083443', 1, 0, '', NULL, NULL, NULL),
(36017, '2017-06-30 12:23:50', NULL, NULL, 10571, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:23:50', 'admin-1498792010-14987966300083443', 1, 0, '', NULL, NULL, NULL),
(36018, '2017-06-30 12:23:39', NULL, NULL, 10571, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:23:39', 'admin-1498792010-14987966194631117', 1, 0, '', NULL, NULL, NULL),
(36019, '2017-06-30 12:23:39', NULL, NULL, 10571, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:23:39', 'admin-1498792010-14987966194631117', 1, 0, '', NULL, NULL, NULL),
(36020, '2017-06-30 12:23:39', NULL, NULL, 10571, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:23:39', 'admin-1498792010-14987966194631117', 1, 1, 'SR', NULL, NULL, NULL),
(36021, '2017-06-30 12:16:15', NULL, NULL, 10570, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:16:15', 'admin-1498792010-14987961750253054', 1, 0, '', NULL, NULL, NULL),
(36022, '2017-06-30 12:16:15', NULL, NULL, 10570, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:16:15', 'admin-1498792010-14987961750253054', 1, 0, '', NULL, NULL, NULL),
(36023, '2017-06-30 12:16:15', NULL, NULL, 10570, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:16:15', 'admin-1498792010-14987961750253054', 1, 1, 'SR', NULL, NULL, NULL),
(36024, '2017-06-30 12:23:11', NULL, NULL, 10571, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.20, 0.0000, 0.0000, 14.20, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:23:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36025, '2017-06-30 12:23:39', NULL, NULL, 10571, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:23:39', 'admin-1498792010-14987966194631117', 1, 0, '', NULL, NULL, NULL),
(36026, '2017-06-30 12:16:15', NULL, NULL, 10570, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:16:15', 'admin-1498792010-14987961750253054', 1, 1, 'SR', NULL, NULL, NULL),
(36027, '2017-06-30 11:39:51', NULL, NULL, 10567, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:39:51', 'admin-1498792010-14987939916568316', 1, 1, 'SR', NULL, NULL, NULL),
(36028, '2017-06-30 11:38:09', NULL, NULL, 10566, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:38:09', 'admin-1498792010-14987938897143479', 1, 0, '', NULL, NULL, NULL),
(36029, '2017-06-30 11:38:02', NULL, NULL, 10566, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:38:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36030, '2017-06-30 11:38:09', NULL, NULL, 10566, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:38:09', 'admin-1498792010-14987938897143479', 1, 1, 'SR', NULL, NULL, NULL),
(36031, '2017-06-30 11:38:09', NULL, NULL, 10566, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:38:09', 'admin-1498792010-14987938897143479', 1, 0, '', NULL, NULL, NULL),
(36032, '2017-06-30 11:32:16', NULL, NULL, 10565, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:32:16', 'admin-1498792010-1498793535831523', 1, 1, 'SR', NULL, NULL, NULL),
(36033, '2017-06-30 11:30:09', NULL, NULL, 10564, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:30:09', 'admin-1498792010-14987934097717881', 1, 0, '', 1, NULL, NULL),
(36034, '2017-06-30 11:30:09', NULL, NULL, 10564, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:30:09', 'admin-1498792010-14987934097717881', 1, 0, '', 1, NULL, NULL),
(36035, '2017-06-30 11:32:16', NULL, NULL, 10565, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:32:16', 'admin-1498792010-1498793535831523', 1, 0, '', NULL, NULL, NULL),
(36036, '2017-06-30 11:32:16', NULL, NULL, 10565, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:32:16', 'admin-1498792010-1498793535831523', 1, 0, '', NULL, NULL, NULL),
(36037, '2017-06-30 10:32:54', NULL, NULL, 10559, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 10:32:54', 'admin-1498783768-14987899741328419', 1, 1, 'SR', NULL, NULL, NULL),
(36038, '2017-06-30 11:32:04', NULL, NULL, 10565, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:32:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36039, '2017-06-30 11:30:09', NULL, NULL, 10564, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:30:09', 'admin-1498792010-14987934097717881', 1, 0, '', 1, NULL, NULL),
(36040, '2017-06-30 11:29:33', NULL, NULL, 10562, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:29:33', 'admin-1498792010-14987933733453632', 1, 0, '', 1, NULL, NULL),
(36041, '2017-06-30 12:28:38', NULL, NULL, 10572, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1498792010', 'admin', '2017-06-30 12:28:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36042, '2017-06-30 11:07:00', NULL, NULL, 10561, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:07:00', 'admin-1498792010-14987920202894713', 1, 1, 'SR', NULL, NULL, NULL),
(36043, '2017-06-30 09:24:07', NULL, NULL, 10555, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 09:24:07', 'admin-1498783768-14987858473625241', 1, 0, '', NULL, NULL, NULL),
(36044, '2017-06-30 09:12:52', NULL, NULL, 10554, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 09:12:52', 'admin-1498783768-14987851724614481', 1, 0, '', NULL, NULL, NULL),
(36045, '2017-06-30 11:06:45', NULL, NULL, 10561, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 11:06:45', 'admin-1498783768-14987920054307524', 1, 0, '', NULL, NULL, NULL),
(36046, '2017-06-30 10:32:54', NULL, NULL, 10559, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 10:32:54', 'admin-1498783768-14987899741328419', 1, 1, 'SR', NULL, NULL, NULL),
(36047, '2017-06-30 10:32:54', NULL, NULL, 10559, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 10:32:54', 'admin-1498783768-14987899741328419', 1, 0, '', NULL, NULL, NULL),
(36048, '2017-06-30 10:24:00', NULL, NULL, 10558, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 10:24:00', 'admin-1498783768-14987894402709139', 1, 0, '', NULL, NULL, NULL),
(36049, '2017-06-30 10:32:46', NULL, NULL, 10559, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1498792010', 'admin', '2017-06-30 10:32:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36050, '2017-06-30 10:32:54', NULL, NULL, 10559, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 10:32:54', 'admin-1498783768-14987899741328419', 1, 0, '', NULL, NULL, NULL),
(36051, '2017-06-30 10:23:27', NULL, NULL, 10558, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1498792010', 'admin', '2017-06-30 10:23:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36052, '2017-06-30 10:24:00', NULL, NULL, 10558, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 10:24:00', 'admin-1498783768-14987894402709139', 1, 0, '', NULL, NULL, NULL),
(36053, '2017-06-30 10:24:00', NULL, NULL, 10558, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 10:24:00', 'admin-1498783768-14987894402709139', 1, 0, '', NULL, NULL, NULL),
(36054, '2017-06-30 10:24:00', NULL, NULL, 10558, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 10:24:00', 'admin-1498783768-14987894402709139', 1, 0, '', NULL, NULL, NULL),
(36055, '2017-06-30 10:24:00', NULL, NULL, 10558, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 10:24:00', 'admin-1498783768-14987894402709139', 1, 1, 'SR', NULL, NULL, NULL),
(36056, '2017-06-30 10:21:02', NULL, NULL, 10557, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 10:21:02', 'admin-1498783768-14987892620201870', 1, 1, 'SR', NULL, NULL, '10.0'),
(36057, '2017-06-30 10:21:02', NULL, NULL, 10557, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 10:21:02', 'admin-1498783768-14987892620201870', 1, 1, 'SR', NULL, NULL, '10.0'),
(36058, '2017-06-30 10:20:50', NULL, NULL, 10557, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1498792010', 'admin', '2017-06-30 10:20:50', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(36059, '2017-06-30 10:14:39', NULL, NULL, 10556, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 10:14:39', 'admin-1498783768-1498788879664677', 1, 1, 'SR', NULL, NULL, NULL),
(36060, '2017-06-30 10:14:39', NULL, NULL, 10556, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 10:14:39', 'admin-1498783768-1498788879664677', 1, 1, 'SR', NULL, NULL, NULL),
(36061, '2017-06-30 10:10:35', NULL, NULL, 10556, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1498792010', 'admin', '2017-06-30 10:10:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36062, '2017-06-30 10:14:24', NULL, NULL, 10556, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 10:14:24', 'admin-1498783768-14987888644259076', 1, 0, '', NULL, NULL, NULL),
(36063, '2017-06-30 10:14:24', NULL, NULL, 10556, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 10:14:24', 'admin-1498783768-14987888644259076', 1, 0, '', NULL, NULL, NULL),
(36064, '2017-06-30 10:14:24', NULL, NULL, 10556, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 10:14:24', 'admin-1498783768-14987888644259076', 1, 0, '', NULL, NULL, NULL),
(36065, '2017-06-30 09:24:07', NULL, NULL, 10555, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 09:24:07', 'admin-1498783768-14987858473625241', 1, 1, 'SR', NULL, NULL, NULL),
(36066, '2017-06-30 09:24:07', NULL, NULL, 10555, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 09:24:07', 'admin-1498783768-14987858473625241', 1, 1, 'SR', NULL, NULL, NULL),
(36067, '2017-06-30 09:24:07', NULL, NULL, 10555, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 09:24:07', 'admin-1498783768-14987858473625241', 1, 0, '', NULL, NULL, NULL),
(36068, '2017-06-30 09:12:52', NULL, NULL, 10554, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 09:12:52', 'admin-1498783768-14987851724614481', 1, 1, 'SR', NULL, NULL, NULL),
(36069, '2017-06-30 09:20:05', NULL, NULL, 10555, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1498792010', 'admin', '2017-06-30 09:20:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36070, '2017-06-30 09:12:47', NULL, NULL, 10554, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1498792010', 'admin', '2017-06-30 09:12:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36071, '2017-07-01 16:54:14', NULL, NULL, 10612, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1498895817', 'admin', '2017-07-01 16:54:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36072, '2017-07-01 16:54:20', NULL, NULL, 10612, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 16:54:20', 'admin-1498895817-1498899260712611', 1, 1, 'SR', NULL, NULL, NULL),
(36073, '2017-07-01 16:58:39', NULL, NULL, 10613, 0, 181, '116', 'Open Food ', 'mashed potato', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 16:58:39', 'admin-1498895817-14988995192773396', 1, 0, '', 1, NULL, '10.0'),
(36074, '2017-07-01 16:59:16', NULL, NULL, 10614, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 16:59:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36075, '2017-07-01 16:59:21', NULL, NULL, 10614, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 16:59:21', 'admin-1498895817-14988995617945238', 1, 1, 'SR', NULL, NULL, NULL),
(36076, '2017-07-01 16:59:21', NULL, NULL, 10614, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 16:59:21', 'admin-1498895817-14988995617945238', 1, 1, 'SR', NULL, NULL, NULL),
(36077, '2017-07-01 17:21:18', NULL, NULL, 10613, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 17:21:18', 'admin-1498895817-149890087820143', 1, 1, 'SR', 1, NULL, '10.0'),
(36078, '2017-07-01 17:28:08', NULL, NULL, 10604, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 17:28:08', 'admin-1498895817-14989012885749359', 1, 0, '', NULL, NULL, '10.0'),
(36079, '2017-07-01 15:41:38', NULL, NULL, 10604, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:41:38', 'admin-1498882487-14988948982799726', 1, 0, '', NULL, NULL, '10.0'),
(36080, '2017-07-01 16:21:33', NULL, NULL, 10605, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 16:21:33', 'admin-1498895817-14988972931526543', 1, 1, 'SR', NULL, NULL, NULL),
(36081, '2017-07-01 16:20:25', NULL, NULL, 10611, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1498895817', 'admin', '2017-07-01 16:20:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36082, '2017-07-01 12:15:45', NULL, NULL, 10592, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:15:45', 'admin-1498882487-14988825455735327', 1, 1, 'SR', NULL, NULL, NULL),
(36083, '2017-07-01 12:22:01', NULL, NULL, 10593, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:22:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36084, '2017-07-01 12:24:28', NULL, NULL, 10593, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:24:28', 'admin-1498882487-14988830685827396', 1, 1, 'SR', NULL, NULL, NULL),
(36085, '2017-07-01 15:26:35', NULL, NULL, 10606, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:26:35', 'admin-1498882487-14988939954756234', 1, 1, 'SR', NULL, NULL, NULL),
(36086, '2017-07-01 15:25:26', NULL, NULL, 10605, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:25:26', 'admin-1498882487-1498893925850967', 1, 1, 'SR', NULL, NULL, NULL),
(36087, '2017-07-01 15:26:16', NULL, NULL, 10606, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:26:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36088, '2017-07-01 15:26:35', NULL, NULL, 10606, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:26:35', 'admin-1498882487-14988939954756234', 1, 0, '', NULL, NULL, NULL),
(36089, '2017-07-01 12:15:45', NULL, NULL, 10592, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:15:45', 'admin-1498882487-14988825455735327', 1, 0, '', NULL, NULL, NULL),
(36090, '2017-07-01 12:15:45', NULL, NULL, 10592, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:15:45', 'admin-1498882487-14988825455735327', 1, 0, '', NULL, NULL, NULL),
(36091, '2017-07-01 12:15:13', NULL, NULL, 10592, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:15:13', 'admin-1498882487-14988825129084043', 1, 0, '', NULL, NULL, NULL),
(36092, '2017-07-01 12:15:03', NULL, NULL, 10592, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:15:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36093, '2017-07-01 12:06:58', NULL, NULL, 10591, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:06:58', 'admin-1498880635-14988820177936141', 1, 1, 'SR', NULL, NULL, NULL),
(36094, '2017-07-01 12:14:24', NULL, NULL, 10586, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:14:24', 'admin-1498880635-1498882464302267', 1, 0, '', NULL, NULL, NULL),
(36095, '2017-07-01 11:59:59', NULL, NULL, 10590, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:59:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36096, '2017-07-01 12:00:50', NULL, NULL, 10590, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:00:50', 'admin-1498880635-14988816505225759', 1, 0, '', NULL, NULL, NULL),
(36097, '2017-07-01 11:05:05', NULL, NULL, 10584, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:05:05', 'admin-1498876031-1498878305736246', 1, 1, 'SR', NULL, NULL, NULL),
(36098, '2017-07-01 12:06:58', NULL, NULL, 10591, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:06:58', 'admin-1498880635-14988820177936141', 1, 1, 'SR', NULL, NULL, NULL),
(36099, '2017-07-01 15:32:54', NULL, NULL, 10607, 0, 181, '116', 'Open Food ', 'creme brulee', 'Meals', 'Perfect Meals', 1, 36.00, 36.0000, 0.0000, 36.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:32:54', 'admin-1498882487-14988943746022687', 1, 0, '', 1, NULL, NULL),
(36100, '2017-07-01 15:26:35', NULL, NULL, 10606, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:26:35', 'admin-1498882487-14988939954756234', 1, 1, 'SR', NULL, NULL, NULL),
(36101, '2017-07-01 15:26:35', NULL, NULL, 10606, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:26:35', 'admin-1498882487-14988939954756234', 1, 0, '', NULL, NULL, NULL),
(36102, '2017-07-01 13:35:06', NULL, NULL, 10599, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 13:35:06', 'admin-1498882487-14988873066578388', 1, 0, '', NULL, NULL, NULL),
(36103, '2017-07-01 13:35:06', NULL, NULL, 10599, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 13:35:06', 'admin-1498882487-14988873066578388', 1, 0, '', NULL, NULL, NULL),
(36104, '2017-07-01 13:35:06', NULL, NULL, 10599, 0, 181, '116', 'Open Food ', 'smoked Duck Pestp Pasta', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 13:35:06', 'admin-1498882487-14988873066578388', 1, 0, '', NULL, NULL, NULL),
(36105, '2017-07-01 13:35:06', NULL, NULL, 10599, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 13:35:06', 'admin-1498882487-14988873066578388', 1, 0, '', NULL, NULL, NULL),
(36106, '2017-07-01 13:49:20', NULL, NULL, 10600, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1498895817', 'admin', '2017-07-01 13:49:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36107, '2017-07-01 13:49:31', NULL, NULL, 10600, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 13:49:31', 'admin-1498882487-14988881711741181', 1, 0, '', NULL, NULL, NULL),
(36108, '2017-07-01 13:49:31', NULL, NULL, 10600, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 13:49:31', 'admin-1498882487-14988881711741181', 1, 0, '', NULL, NULL, NULL),
(36109, '2017-07-01 13:49:55', NULL, NULL, 10600, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 13:49:55', 'admin-1498882487-14988881948985211', 1, 1, 'SR', NULL, NULL, NULL),
(36110, '2017-07-01 13:49:55', NULL, NULL, 10600, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 13:49:55', 'admin-1498882487-14988881948985211', 1, 1, 'SR', NULL, NULL, NULL),
(36111, '2017-07-01 14:22:34', NULL, NULL, 10600, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 14:22:34', 'admin-1498882487-1498890154133651', 1, 0, '', NULL, NULL, NULL),
(36112, '2017-07-01 14:29:20', NULL, NULL, 10601, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1498895817', 'admin', '2017-07-01 14:29:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36113, '2017-07-01 14:29:23', NULL, NULL, 10601, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 14:29:23', 'admin-1498882487-14988905628606277', 1, 1, 'SR', NULL, NULL, NULL),
(36114, '2017-07-01 15:04:38', NULL, NULL, 10602, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:04:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36115, '2017-07-01 15:04:46', NULL, NULL, 10602, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:04:46', 'admin-1498882487-14988926859248456', 1, 0, '', NULL, NULL, NULL),
(36116, '2017-07-01 15:04:46', NULL, NULL, 10602, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:04:46', 'admin-1498882487-14988926859248456', 1, 0, '', NULL, NULL, NULL),
(36117, '2017-07-01 15:04:55', NULL, NULL, 10602, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:04:55', 'admin-1498882487-14988926950801232', 1, 1, 'SR', NULL, NULL, NULL),
(36118, '2017-07-01 13:28:05', NULL, NULL, 10598, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 13:28:05', 'admin-1498882487-14988868858189153', 1, 0, '', NULL, NULL, NULL),
(36119, '2017-07-01 13:28:06', NULL, NULL, 10598, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 13:28:06', 'admin-1498882487-14988868858189153', 1, 1, 'SR', NULL, NULL, NULL),
(36120, '2017-07-01 13:34:45', NULL, NULL, 10599, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1498895817', 'admin', '2017-07-01 13:34:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36121, '2017-07-01 13:25:39', NULL, NULL, 10585, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 13:25:39', 'admin-1498882487-14988867390269287', 1, 1, 'SR', NULL, NULL, NULL),
(36122, '2017-07-01 13:27:45', NULL, NULL, 10598, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1498895817', 'admin', '2017-07-01 13:27:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36123, '2017-07-01 16:21:03', NULL, NULL, 10611, 0, 181, '116', 'Open Food ', 'spicy lemony not so spicy', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 16:21:03', 'admin-1498895817-14988972630014889', 1, 0, '', NULL, NULL, NULL),
(36124, '2017-07-01 11:41:46', NULL, NULL, 10586, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:41:46', 'admin-1498876031-14988805067943265', 1, 1, 'SR', NULL, NULL, NULL),
(36125, '2017-07-01 11:41:46', NULL, NULL, 10586, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:41:46', 'admin-1498876031-14988805067943265', 1, 1, 'SR', NULL, NULL, NULL),
(36126, '2017-07-01 11:41:46', NULL, NULL, 10586, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:41:46', 'admin-1498876031-14988805067943265', 1, 0, '', NULL, NULL, NULL),
(36127, '2017-07-01 15:31:48', NULL, NULL, 10606, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:31:48', 'admin-1498882487-14988943085983248', 1, 0, '', NULL, NULL, NULL),
(36128, '2017-07-01 15:25:26', NULL, NULL, 10605, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:25:26', 'admin-1498882487-1498893925850967', 1, 1, 'SR', NULL, NULL, NULL),
(36129, '2017-07-01 15:20:04', NULL, NULL, 10605, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:20:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36130, '2017-07-01 15:56:38', NULL, NULL, 10609, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:56:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36131, '2017-07-01 15:56:45', NULL, NULL, 10609, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:56:45', 'admin-1498882487-14988958057997898', 1, 0, '', NULL, NULL, NULL),
(36132, '2017-07-01 15:56:45', NULL, NULL, 10609, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:56:45', 'admin-1498882487-14988958057997898', 1, 0, '', NULL, NULL, NULL),
(36133, '2017-07-01 15:57:11', NULL, NULL, 10609, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:57:11', 'admin-1498895817-14988958315866089', 1, 0, '', NULL, NULL, NULL),
(36134, '2017-07-01 15:17:07', NULL, NULL, 10604, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:17:07', 'admin-1498882487-14988934271361139', 1, 0, '', NULL, NULL, '10.0'),
(36135, '2017-07-01 15:17:07', NULL, NULL, 10604, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:17:07', 'admin-1498882487-14988934271361139', 1, 0, '', NULL, NULL, '10.0');
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(36136, '2017-07-01 12:15:45', NULL, NULL, 10592, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:15:45', 'admin-1498882487-14988825455735327', 1, 0, '', NULL, NULL, NULL),
(36137, '2017-07-01 17:28:08', NULL, NULL, 10604, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 17:28:08', 'admin-1498895817-14989012885749359', 1, 0, '', NULL, NULL, '10.0'),
(36138, '2017-07-01 15:17:01', NULL, NULL, 10604, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:17:01', 'admin-1498882487-14988934215105590', 1, 0, '', NULL, NULL, '10.0'),
(36139, '2017-07-01 15:04:55', NULL, NULL, 10602, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:04:55', 'admin-1498882487-14988926950801232', 1, 1, 'SR', NULL, NULL, NULL),
(36140, '2017-07-01 15:08:39', NULL, NULL, 10603, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:08:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36141, '2017-07-01 15:08:45', NULL, NULL, 10603, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:08:45', 'admin-1498882487-14988929254084190', 1, 0, '', NULL, NULL, NULL),
(36142, '2017-07-01 15:08:45', NULL, NULL, 10603, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:08:45', 'admin-1498882487-14988929254084190', 1, 0, '', NULL, NULL, NULL),
(36143, '2017-07-01 15:08:45', NULL, NULL, 10603, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:08:45', 'admin-1498882487-14988929254084190', 1, 1, 'SR', NULL, NULL, NULL),
(36144, '2017-07-01 13:02:20', NULL, NULL, 10597, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 13:02:20', 'admin-1498882487-14988853405031010', 1, 1, 'SR', NULL, NULL, NULL),
(36145, '2017-07-01 13:02:20', NULL, NULL, 10597, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 13:02:20', 'admin-1498882487-14988853405031010', 1, 1, 'SR', NULL, NULL, NULL),
(36146, '2017-07-01 16:21:33', NULL, NULL, 10605, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 16:21:33', 'admin-1498895817-14988972931526543', 1, 1, 'SR', NULL, NULL, NULL),
(36147, '2017-07-01 16:21:18', NULL, NULL, 10611, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 16:21:18', 'admin-1498895817-14988972778506397', 1, 1, 'SR', NULL, NULL, NULL),
(36148, '2017-07-01 12:57:49', NULL, NULL, 10597, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:57:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36149, '2017-07-01 12:03:44', NULL, NULL, 10590, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:03:44', 'admin-1498880635-1498881823838383', 1, 1, 'SR', NULL, NULL, NULL),
(36150, '2017-07-01 12:03:44', NULL, NULL, 10590, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:03:44', 'admin-1498880635-1498881823838383', 1, 1, 'SR', NULL, NULL, NULL),
(36151, '2017-07-01 12:03:44', NULL, NULL, 10590, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:03:44', 'admin-1498880635-1498881823838383', 1, 0, '', NULL, NULL, NULL),
(36152, '2017-07-01 12:03:44', NULL, NULL, 10590, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:03:44', 'admin-1498880635-1498881823838383', 1, 0, '', NULL, NULL, NULL),
(36153, '2017-07-01 12:03:44', NULL, NULL, 10590, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:03:44', 'admin-1498880635-1498881823838383', 1, 0, '', NULL, NULL, NULL),
(36154, '2017-07-01 12:05:49', NULL, NULL, 10591, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:05:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36155, '2017-07-01 16:21:18', NULL, NULL, 10611, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 16:21:18', 'admin-1498895817-14988972778506397', 1, 1, 'SR', NULL, NULL, NULL),
(36156, '2017-07-01 15:57:11', NULL, NULL, 10609, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:57:11', 'admin-1498895817-14988958315866089', 1, 1, 'SR', NULL, NULL, NULL),
(36157, '2017-07-01 16:21:03', NULL, NULL, 10611, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 16:21:03', 'admin-1498895817-14988972630014889', 1, 0, '', NULL, NULL, NULL),
(36158, '2017-07-01 16:21:03', NULL, NULL, 10611, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 16:21:03', 'admin-1498895817-14988972630014889', 1, 1, 'SR', NULL, NULL, NULL),
(36159, '2017-07-01 16:08:20', NULL, NULL, 10610, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 16:08:20', 'admin-1498895817-14988964997668590', 1, 1, 'SR', NULL, NULL, NULL),
(36160, '2017-07-01 16:08:14', NULL, NULL, 10610, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1498895817', 'admin', '2017-07-01 16:08:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36161, '2017-07-01 15:56:21', NULL, NULL, 10608, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:56:21', 'admin-1498882487-14988957811449484', 1, 1, 'SR', NULL, NULL, NULL),
(36162, '2017-07-01 15:56:17', NULL, NULL, 10608, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:56:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36163, '2017-07-01 15:46:06', NULL, NULL, 10605, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:46:06', 'admin-1498882487-14988951661049057', 1, 1, 'SR', NULL, NULL, NULL),
(36164, '2017-07-01 15:46:06', NULL, NULL, 10605, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:46:06', 'admin-1498882487-14988951661049057', 1, 0, '', NULL, NULL, NULL),
(36165, '2017-07-01 12:29:35', NULL, NULL, 10595, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:29:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36166, '2017-07-01 12:29:42', NULL, NULL, 10595, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:29:42', 'admin-1498882487-14988833823168151', 1, 0, '', NULL, NULL, NULL),
(36167, '2017-07-01 12:29:42', NULL, NULL, 10595, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:29:42', 'admin-1498882487-14988833823168151', 1, 1, 'SR', NULL, NULL, NULL),
(36168, '2017-07-01 13:02:20', NULL, NULL, 10597, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 13:02:20', 'admin-1498882487-14988853405031010', 1, 0, '', NULL, NULL, NULL),
(36169, '2017-07-01 13:02:20', NULL, NULL, 10597, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 13:02:20', 'admin-1498882487-14988853405031010', 1, 0, '', NULL, NULL, NULL),
(36170, '2017-07-01 13:02:20', NULL, NULL, 10597, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 13:02:20', 'admin-1498882487-14988853405031010', 1, 1, 'SR', NULL, NULL, NULL),
(36171, '2017-07-01 13:02:20', NULL, NULL, 10597, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 13:02:20', 'admin-1498882487-14988853405031010', 1, 0, '', NULL, NULL, NULL),
(36172, '2017-07-01 15:16:56', NULL, NULL, 10604, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.50, 0.0000, 0.0000, 10.50, 1, '27', 1, '1498895817', 'admin', '2017-07-01 15:16:56', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(36173, '2017-07-01 12:36:46', NULL, NULL, 10589, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:36:46', 'admin-1498882487-14988838057983367', 1, 0, '', NULL, NULL, NULL),
(36174, '2017-07-01 12:34:22', NULL, NULL, 10596, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:34:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36175, '2017-07-01 12:24:28', NULL, NULL, 10593, 0, 153, '87', 'Wake Me Up!', 'no salad n egg', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:24:28', 'admin-1498882487-14988830685827396', 1, 0, '', NULL, NULL, NULL),
(36176, '2017-07-01 12:25:58', NULL, NULL, 10594, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:25:58', 'admin-1498882487-1498883158118992', 1, 1, 'SR', NULL, NULL, '10.0'),
(36177, '2017-07-01 12:25:58', NULL, NULL, 10594, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:25:58', 'admin-1498882487-1498883158118992', 1, 1, 'SR', NULL, NULL, '10.0'),
(36178, '2017-07-01 12:25:36', NULL, NULL, 10594, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:25:36', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(36179, '2017-07-01 12:24:28', NULL, NULL, 10593, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:24:28', 'admin-1498882487-14988830685827396', 1, 0, '', NULL, NULL, NULL),
(36180, '2017-07-01 10:26:26', NULL, NULL, 10580, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:26:26', 'admin-1498871185-14988759866495126', 1, 1, 'SR', NULL, NULL, NULL),
(36181, '2017-07-01 11:00:26', NULL, NULL, 10583, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:00:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36182, '2017-07-01 11:00:29', NULL, NULL, 10583, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:00:29', 'admin-1498876031-14988780288683286', 1, 1, 'SR', NULL, NULL, NULL),
(36183, '2017-07-01 11:00:29', NULL, NULL, 10583, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:00:29', 'admin-1498876031-14988780288683286', 1, 1, 'SR', NULL, NULL, NULL),
(36184, '2017-07-01 11:04:08', NULL, NULL, 10584, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:04:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36185, '2017-07-01 11:04:48', NULL, NULL, 10584, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:04:48', 'admin-1498876031-149887828868736', 1, 0, '', NULL, NULL, NULL),
(36186, '2017-07-01 12:15:45', NULL, NULL, 10592, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:15:45', 'admin-1498882487-14988825455735327', 1, 1, 'SR', NULL, NULL, NULL),
(36187, '2017-07-01 12:14:24', NULL, NULL, 10586, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:14:24', 'admin-1498880635-1498882464302267', 1, 0, '', NULL, NULL, NULL),
(36188, '2017-07-01 11:05:05', NULL, NULL, 10584, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:05:05', 'admin-1498876031-1498878305736246', 1, 0, '', NULL, NULL, NULL),
(36189, '2017-07-01 10:27:22', NULL, NULL, 10580, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:27:22', 'admin-1498876031-14988760425067525', 1, 1, 'SR', NULL, NULL, NULL),
(36190, '2017-07-01 10:16:51', NULL, NULL, 10579, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:16:51', 'admin-1498871185-14988754116997678', 1, 0, '', NULL, NULL, NULL),
(36191, '2017-07-01 10:03:45', NULL, NULL, 10578, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:03:45', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(36192, '2017-07-01 10:03:49', NULL, NULL, 10578, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:03:49', 'admin-1498871185-14988746294393132', 1, 1, 'SR', NULL, NULL, '10.0'),
(36193, '2017-07-01 10:03:49', NULL, NULL, 10578, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:03:49', 'admin-1498871185-14988746294393132', 1, 1, 'SR', NULL, NULL, '10.0'),
(36194, '2017-07-01 11:50:03', NULL, NULL, 10589, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.10, 0.0000, 0.0000, 10.10, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:50:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36195, '2017-07-01 12:15:45', NULL, NULL, 10592, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:15:45', 'admin-1498882487-14988825455735327', 1, 0, '', NULL, NULL, NULL),
(36196, '2017-07-01 12:03:44', NULL, NULL, 10590, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:03:44', 'admin-1498880635-1498881823838383', 1, 1, 'SR', NULL, NULL, NULL),
(36197, '2017-07-01 10:35:37', NULL, NULL, 10577, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:35:37', 'admin-1498876031-14988765377314763', 1, 1, 'SR', NULL, NULL, NULL),
(36198, '2017-07-01 10:41:13', NULL, NULL, 10581, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:41:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36199, '2017-07-01 10:41:19', NULL, NULL, 10581, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:41:19', 'admin-1498876031-14988768789895177', 1, 0, '', NULL, NULL, NULL),
(36200, '2017-07-01 10:41:19', NULL, NULL, 10581, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:41:19', 'admin-1498876031-14988768789895177', 1, 0, '', NULL, NULL, NULL),
(36201, '2017-07-01 10:41:32', NULL, NULL, 10581, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:41:32', 'admin-1498876031-14988768923465973', 1, 1, 'SR', NULL, NULL, NULL),
(36202, '2017-07-01 10:41:32', NULL, NULL, 10581, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:41:32', 'admin-1498876031-14988768923465973', 1, 1, 'SR', NULL, NULL, NULL),
(36203, '2017-07-01 10:26:26', NULL, NULL, 10580, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:26:26', 'admin-1498871185-14988759866495126', 1, 0, '', NULL, NULL, NULL),
(36204, '2017-07-01 10:26:26', NULL, NULL, 10580, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:26:26', 'admin-1498871185-14988759866495126', 1, 0, '', NULL, NULL, NULL),
(36205, '2017-07-01 10:26:26', NULL, NULL, 10580, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:26:26', 'admin-1498871185-14988759866495126', 1, 0, '', NULL, NULL, NULL),
(36206, '2017-07-01 12:24:28', NULL, NULL, 10593, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:24:28', 'admin-1498882487-14988830685827396', 1, 1, 'SR', NULL, NULL, NULL),
(36207, '2017-07-01 11:43:37', NULL, NULL, 10587, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:43:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36208, '2017-07-01 11:43:46', NULL, NULL, 10587, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:43:46', 'admin-1498876031-14988806265747531', 1, 1, 'SR', NULL, NULL, NULL),
(36209, '2017-07-01 11:43:46', NULL, NULL, 10587, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:43:46', 'admin-1498876031-14988806265747531', 1, 1, 'SR', NULL, NULL, NULL),
(36210, '2017-07-01 11:43:46', NULL, NULL, 10587, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:43:46', 'admin-1498876031-14988806265747531', 1, 1, 'SR', NULL, NULL, NULL),
(36211, '2017-07-01 11:44:24', NULL, NULL, 10587, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:44:24', 'admin-1498880635-14988806641886589', 1, 0, '', NULL, NULL, NULL),
(36212, '2017-07-01 11:47:14', NULL, NULL, 10588, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:47:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36213, '2017-07-01 11:47:21', NULL, NULL, 10588, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:47:21', 'admin-1498880635-14988808413385882', 1, 0, '', NULL, NULL, NULL),
(36214, '2017-07-01 11:47:21', NULL, NULL, 10588, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:47:21', 'admin-1498880635-14988808413385882', 1, 1, 'SR', NULL, NULL, NULL),
(36215, '2017-07-01 12:14:24', NULL, NULL, 10586, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:14:24', 'admin-1498880635-1498882464302267', 1, 0, '', NULL, NULL, NULL),
(36216, '2017-07-01 11:50:42', NULL, NULL, 10589, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:50:42', 'admin-1498880635-14988810423686084', 1, 1, 'SR', NULL, NULL, NULL),
(36217, '2017-07-01 11:50:42', NULL, NULL, 10589, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:50:42', 'admin-1498880635-14988810423686084', 1, 1, 'SR', NULL, NULL, NULL),
(36218, '2017-07-01 11:54:47', NULL, NULL, 10583, 0, 70, '70', 'Pepper Pork', 'Takeaway', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:54:47', 'admin-1498880635-1498881286803829', 1, 1, 'SR', NULL, NULL, NULL),
(36219, '2017-07-01 11:50:42', NULL, NULL, 10589, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:50:42', 'admin-1498880635-14988810423686084', 1, 0, '', NULL, NULL, NULL),
(36220, '2017-07-01 11:50:42', NULL, NULL, 10589, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:50:42', 'admin-1498880635-14988810423686084', 1, 1, 'SR', NULL, NULL, NULL),
(36221, '2017-07-01 11:50:42', NULL, NULL, 10589, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:50:42', 'admin-1498880635-14988810423686084', 1, 1, 'SR', NULL, NULL, NULL),
(36222, '2017-07-01 12:06:57', NULL, NULL, 10591, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:06:57', 'admin-1498880635-14988820177936141', 1, 1, 'SR', NULL, NULL, NULL),
(36223, '2017-07-01 11:53:18', NULL, NULL, 10589, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:53:18', 'admin-1498880635-14988811985742145', 1, 0, '', NULL, NULL, NULL),
(36224, '2017-07-01 11:50:42', NULL, NULL, 10589, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:50:42', 'admin-1498880635-14988810423686084', 1, 1, 'SR', NULL, NULL, NULL),
(36225, '2017-07-01 11:41:34', NULL, NULL, 10586, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:41:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36226, '2017-07-01 11:40:22', NULL, NULL, 10584, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:40:22', 'admin-1498876031-14988804223295387', 1, 0, '', NULL, NULL, NULL),
(36227, '2017-07-01 11:10:30', NULL, NULL, 10585, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:10:30', 'admin-1498876031-14988786305705699', 1, 1, 'SR', NULL, NULL, NULL),
(36228, '2017-07-01 11:09:55', NULL, NULL, 10585, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:09:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36229, '2017-07-01 10:42:14', NULL, NULL, 10582, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:42:14', 'admin-1498876031-14988769344586567', 1, 0, '', NULL, NULL, NULL),
(36230, '2017-07-01 10:42:14', NULL, NULL, 10582, 0, 181, '116', 'Open Food ', 'cbt  scramble', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:42:14', 'admin-1498876031-14988769344586567', 1, 0, '', NULL, NULL, NULL),
(36231, '2017-07-01 10:42:14', NULL, NULL, 10582, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:42:14', 'admin-1498876031-14988769344586567', 1, 0, '', NULL, NULL, NULL),
(36232, '2017-07-01 10:42:44', NULL, NULL, 10582, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:42:44', 'admin-1498876031-14988769639344087', 1, 1, 'SR', NULL, NULL, NULL),
(36233, '2017-07-01 10:42:51', NULL, NULL, 10579, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:42:51', 'admin-1498876031-1498876971316166', 1, 0, '', NULL, NULL, NULL),
(36234, '2017-07-01 10:42:51', NULL, NULL, 10579, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:42:51', 'admin-1498876031-1498876971316166', 1, 0, '', NULL, NULL, NULL),
(36235, '2017-07-01 12:14:24', NULL, NULL, 10586, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 12:14:24', 'admin-1498880635-1498882464302267', 1, 0, '', NULL, NULL, NULL),
(36236, '2017-07-01 11:04:48', NULL, NULL, 10584, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 11:04:48', 'admin-1498876031-149887828868736', 1, 0, '', NULL, NULL, NULL),
(36237, '2017-07-01 10:43:28', NULL, NULL, 10582, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:43:28', 'admin-1498876031-14988770082626791', 1, 1, 'SR', NULL, NULL, NULL),
(36238, '2017-07-01 09:56:03', NULL, NULL, 10576, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1498895817', 'admin', '2017-07-01 09:56:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36239, '2017-07-01 09:56:20', NULL, NULL, 10576, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 09:56:20', 'admin-1498871185-14988741804762794', 1, 0, '', NULL, NULL, NULL),
(36240, '2017-07-01 10:41:41', NULL, NULL, 10582, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:41:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36241, '2017-07-01 10:27:22', NULL, NULL, 10580, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:27:22', 'admin-1498876031-14988760425067525', 1, 1, 'SR', NULL, NULL, NULL),
(36242, '2017-07-01 10:30:31', NULL, NULL, 10580, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:30:31', 'admin-1498876031-14988762315088365', 1, 1, 'SR', NULL, NULL, NULL),
(36243, '2017-07-01 10:27:22', NULL, NULL, 10580, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:27:22', 'admin-1498876031-14988760425067525', 1, 1, 'SR', NULL, NULL, NULL),
(36244, '2017-07-01 10:26:26', NULL, NULL, 10580, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:26:26', 'admin-1498871185-14988759866495126', 1, 1, 'SR', NULL, NULL, NULL),
(36245, '2017-07-01 10:26:26', NULL, NULL, 10580, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:26:26', 'admin-1498871185-14988759866495126', 1, 0, '', NULL, NULL, NULL),
(36246, '2017-07-01 10:26:26', NULL, NULL, 10580, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:26:26', 'admin-1498871185-14988759866495126', 1, 0, '', NULL, NULL, NULL),
(36247, '2017-07-01 10:16:51', NULL, NULL, 10579, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:16:51', 'admin-1498871185-14988754116997678', 1, 0, '', NULL, NULL, NULL),
(36248, '2017-07-01 10:17:53', NULL, NULL, 10579, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:17:53', 'admin-1498871185-14988754729066348', 1, 1, 'SR', NULL, NULL, NULL),
(36249, '2017-07-01 10:17:53', NULL, NULL, 10579, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:17:53', 'admin-1498871185-14988754729066348', 1, 1, 'SR', NULL, NULL, NULL),
(36250, '2017-07-01 10:17:53', NULL, NULL, 10579, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:17:53', 'admin-1498871185-14988754729066348', 1, 0, '', NULL, NULL, NULL),
(36251, '2017-07-01 10:25:48', NULL, NULL, 10580, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 17.40, 0.0000, 0.0000, 17.40, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:25:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36252, '2017-07-01 10:26:26', NULL, NULL, 10580, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:26:26', 'admin-1498871185-14988759866495126', 1, 0, '', NULL, NULL, NULL),
(36253, '2017-07-01 10:16:51', NULL, NULL, 10579, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:16:51', 'admin-1498871185-14988754116997678', 1, 0, '', NULL, NULL, NULL),
(36254, '2017-07-01 10:16:51', NULL, NULL, 10579, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:16:51', 'admin-1498871185-14988754116997678', 1, 0, '', NULL, NULL, NULL),
(36255, '2017-07-01 10:16:21', NULL, NULL, 10579, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.40, 0.0000, 0.0000, 15.40, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:16:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36256, '2017-07-01 10:16:51', NULL, NULL, 10579, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:16:51', 'admin-1498871185-14988754116997678', 1, 0, '', NULL, NULL, NULL),
(36257, '2017-07-01 10:03:04', NULL, NULL, 10577, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:03:04', 'admin-1498871185-1498874584046162', 1, 1, 'SR', NULL, NULL, NULL),
(36258, '2017-07-01 10:03:22', NULL, NULL, 10577, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:03:22', 'admin-1498871185-14988746027057054', 1, 1, 'SR', NULL, NULL, NULL),
(36259, '2017-07-01 09:56:20', NULL, NULL, 10576, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 09:56:20', 'admin-1498871185-14988741804762794', 1, 1, 'SR', NULL, NULL, NULL),
(36260, '2017-07-01 09:57:28', NULL, NULL, 10576, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 09:57:28', 'admin-1498871185-1498874248187492', 1, 0, '', NULL, NULL, NULL),
(36261, '2017-07-01 10:02:57', NULL, NULL, 10577, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:02:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36262, '2017-07-01 10:03:04', NULL, NULL, 10577, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:03:04', 'admin-1498871185-1498874584046162', 1, 0, '', NULL, NULL, NULL),
(36263, '2017-07-01 10:03:04', NULL, NULL, 10577, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 10:03:04', 'admin-1498871185-1498874584046162', 1, 0, '', NULL, NULL, NULL),
(36264, '2017-07-01 09:56:20', NULL, NULL, 10576, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 09:56:20', 'admin-1498871185-14988741804762794', 1, 1, 'SR', NULL, NULL, NULL),
(36265, '2017-07-01 09:19:06', NULL, NULL, 10575, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 09:19:06', 'admin-1498871185-149887194659042', 1, 0, '', NULL, NULL, NULL),
(36266, '2017-07-01 09:19:06', NULL, NULL, 10575, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498895817', 'admin', '2017-07-01 09:19:06', 'admin-1498871185-149887194659042', 1, 1, 'SR', NULL, NULL, NULL),
(36267, '2017-07-01 09:18:56', NULL, NULL, 10575, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1498895817', 'admin', '2017-07-01 09:18:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36268, '2017-07-02 13:09:28', NULL, NULL, 10651, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:09:28', 'admin-1498972092-14989721687123968', 1, 0, '', NULL, NULL, NULL),
(36269, '2017-07-02 12:46:05', NULL, NULL, 10647, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:46:05', 'admin-1498970043-14989707650039282', 1, 1, 'SR', NULL, NULL, NULL),
(36270, '2017-07-02 12:46:05', NULL, NULL, 10647, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:46:05', 'admin-1498970043-14989707650039282', 1, 1, 'SR', NULL, NULL, NULL),
(36271, '2017-07-02 12:46:05', NULL, NULL, 10647, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:46:05', 'admin-1498970043-14989707650039282', 1, 1, 'SR', NULL, NULL, NULL),
(36272, '2017-07-02 13:15:03', NULL, NULL, 10639, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:15:03', 'admin-1498972092-14989725035166520', 1, 0, '', NULL, NULL, NULL),
(36273, '2017-07-02 13:09:28', NULL, NULL, 10651, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:09:28', 'admin-1498972092-14989721687123968', 1, 0, '', NULL, NULL, NULL),
(36274, '2017-07-02 12:46:05', NULL, NULL, 10647, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:46:05', 'admin-1498970043-14989707650039282', 1, 1, 'SR', NULL, NULL, NULL),
(36275, '2017-07-02 13:09:28', NULL, NULL, 10651, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:09:28', 'admin-1498972092-14989721687123968', 1, 0, '', NULL, NULL, NULL),
(36276, '2017-07-02 13:05:46', NULL, NULL, 10649, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:05:46', 'admin-1498970043-14989719459437329', 1, 0, '', NULL, NULL, NULL),
(36277, '2017-07-02 13:31:54', NULL, NULL, 10653, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:31:54', 'admin-1498972092-14989735142946414', 1, 0, '', NULL, NULL, NULL),
(36278, '2017-07-02 13:33:36', NULL, NULL, 10646, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:33:36', 'admin-1498972092-14989736160216436', 1, 0, '', NULL, NULL, NULL),
(36279, '2017-07-02 12:38:01', NULL, NULL, 10646, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:38:01', 'admin-1498970043-14989702815285861', 1, 1, 'SR', NULL, NULL, NULL),
(36280, '2017-07-02 12:36:09', NULL, NULL, 10645, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:36:09', 'admin-1498970043-14989701691427655', 1, 1, 'SR', NULL, NULL, NULL),
(36281, '2017-07-02 12:29:46', NULL, NULL, 10644, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:29:46', 'admin-1498968964-14989697867653354', 1, 1, 'SR', NULL, NULL, NULL),
(36282, '2017-07-02 14:19:42', NULL, NULL, 10659, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:19:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36283, '2017-07-02 14:19:47', NULL, NULL, 10659, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:19:47', 'admin-1498973776-14989763870916893', 1, 1, 'SR', NULL, NULL, NULL),
(36284, '2017-07-02 12:17:09', NULL, NULL, 10640, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:17:09', 'admin-1498968964-14989690297449064', 1, 0, '', NULL, NULL, NULL),
(36285, '2017-07-02 12:17:09', NULL, NULL, 10640, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:17:09', 'admin-1498968964-14989690297449064', 1, 0, '', NULL, NULL, NULL),
(36286, '2017-07-02 12:19:28', NULL, NULL, 10639, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:19:28', 'admin-1498968964-14989691685574350', 1, 0, '', NULL, NULL, NULL),
(36287, '2017-07-02 13:07:05', NULL, NULL, 10650, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', 'add rice', 'Meals', 'Perfect Meals', 2, 16.00, 32.0000, 0.0000, 32.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:07:05', 'admin-1498970043-14989720254338750', 1, 1, 'SR', NULL, NULL, '10.0'),
(36288, '2017-07-02 13:07:14', NULL, NULL, 10650, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:07:14', 'admin-1498970043-14989720346241871', 1, 0, '', NULL, NULL, '10.0'),
(36289, '2017-07-02 13:08:22', NULL, NULL, 10651, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:08:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36290, '2017-07-02 13:07:05', NULL, NULL, 10650, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:07:05', 'admin-1498970043-14989720254338750', 1, 0, '', NULL, NULL, '10.0'),
(36291, '2017-07-02 13:05:54', NULL, NULL, 10650, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:05:54', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(36292, '2017-07-02 13:05:46', NULL, NULL, 10649, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:05:46', 'admin-1498970043-14989719459437329', 1, 0, '', NULL, NULL, NULL),
(36293, '2017-07-02 11:24:01', NULL, NULL, 10633, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:24:01', 'admin-1498965772-1498965841485433', 1, 1, 'SR', NULL, NULL, NULL),
(36294, '2017-07-02 11:24:15', NULL, NULL, 10634, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:24:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36295, '2017-07-02 11:25:32', NULL, NULL, 10634, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:25:32', 'admin-1498965772-14989659321951456', 1, 0, '', NULL, NULL, NULL),
(36296, '2017-07-02 11:25:32', NULL, NULL, 10634, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:25:32', 'admin-1498965772-14989659321951456', 1, 0, '', NULL, NULL, NULL),
(36297, '2017-07-02 11:25:32', NULL, NULL, 10634, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:25:32', 'admin-1498965772-14989659321951456', 1, 0, '', NULL, NULL, NULL),
(36298, '2017-07-02 14:23:46', NULL, NULL, 10660, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:23:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36299, '2017-07-02 14:25:03', NULL, NULL, 10660, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:25:03', 'admin-1498973776-14989767033177069', 1, 1, 'SR', NULL, NULL, NULL),
(36300, '2017-07-02 14:25:03', NULL, NULL, 10660, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:25:03', 'admin-1498973776-14989767033177069', 1, 1, 'SR', NULL, NULL, NULL),
(36301, '2017-07-02 14:25:03', NULL, NULL, 10660, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:25:03', 'admin-1498973776-14989767033177069', 1, 0, '', NULL, NULL, NULL),
(36302, '2017-07-02 14:25:03', NULL, NULL, 10660, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:25:03', 'admin-1498973776-14989767033177069', 1, 0, '', NULL, NULL, NULL),
(36303, '2017-07-02 12:17:09', NULL, NULL, 10640, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:17:09', 'admin-1498968964-14989690297449064', 1, 1, 'SR', NULL, NULL, NULL),
(36304, '2017-07-02 13:15:19', NULL, NULL, 10652, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:15:19', 'admin-1498972092-14989725189571949', 1, 1, 'SR', NULL, NULL, NULL),
(36305, '2017-07-02 00:00:00', NULL, NULL, 10666, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:25:15', 'admin-1498973776-14989767152132714', 1, 1, 'SR', NULL, NULL, NULL),
(36306, '2017-07-02 14:42:47', NULL, NULL, 10662, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:42:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36307, '2017-07-02 14:43:55', NULL, NULL, 10662, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:43:55', 'admin-1498976735-1498977835646404', 1, 1, 'SR', NULL, NULL, NULL),
(36308, '2017-07-02 14:43:55', NULL, NULL, 10662, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:43:55', 'admin-1498976735-1498977835646404', 1, 0, '', NULL, NULL, NULL),
(36309, '2017-07-02 14:47:34', NULL, NULL, 10663, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.70, 0.0000, 0.0000, 11.70, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:47:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36310, '2017-07-02 14:48:50', NULL, NULL, 10663, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:48:50', 'admin-1498976735-14989781307846137', 1, 0, '', NULL, NULL, NULL),
(36311, '2017-07-02 15:16:28', NULL, NULL, 10664, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1498976735', 'admin', '2017-07-02 15:16:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36312, '2017-07-02 00:00:00', NULL, NULL, 10666, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:25:44', 'admin-1498976735-1498976744126679', 1, 0, '', NULL, NULL, NULL),
(36313, '2017-07-02 15:19:43', NULL, NULL, 10664, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 15:19:43', 'admin-1498976735-14989799831446263', 1, 0, '', NULL, NULL, NULL),
(36314, '2017-07-02 15:20:30', NULL, NULL, 10667, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1498976735', 'admin', '2017-07-02 15:20:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36315, '2017-07-02 00:00:00', NULL, NULL, 10656, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:38:13', 'admin-1498973776-14989738931183967', 1, 0, '', NULL, NULL, NULL),
(36316, '2017-07-02 00:00:00', NULL, NULL, 10657, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, NULL, NULL, 2.40, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:37:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36317, '2017-07-02 14:19:12', NULL, NULL, 10658, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:19:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36318, '2017-07-02 14:16:49', NULL, NULL, 10656, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:16:49', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(36319, '2017-07-02 00:00:00', NULL, NULL, 10657, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:38:13', 'admin-1498973776-14989738931183967', 1, 1, 'SR', NULL, NULL, NULL),
(36320, '2017-07-02 13:39:42', NULL, NULL, 10653, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:39:42', 'admin-1498973776-14989739820328289', 1, 1, 'SR', NULL, NULL, NULL),
(36321, '2017-07-02 13:39:42', NULL, NULL, 10653, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:39:42', 'admin-1498973776-14989739820328289', 1, 1, 'SR', NULL, NULL, NULL),
(36322, '2017-07-02 13:55:54', NULL, NULL, 10653, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:55:54', 'admin-1498973776-14989749547945423', 1, 1, 'SR', NULL, NULL, NULL),
(36323, '2017-07-02 13:56:20', NULL, NULL, 10653, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:56:20', 'admin-1498973776-14989749806332251', 1, 0, '', NULL, NULL, NULL),
(36324, '2017-07-02 13:56:36', NULL, NULL, 10650, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:56:36', 'admin-1498973776-14989749967941567', 1, 1, 'SR', NULL, NULL, '10.0'),
(36325, '2017-07-02 13:58:58', NULL, NULL, 10655, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:58:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36326, '2017-07-02 13:59:03', NULL, NULL, 10655, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:59:03', 'admin-1498973776-14989751431995323', 1, 1, 'SR', NULL, NULL, NULL),
(36327, '2017-07-02 00:00:00', NULL, NULL, 10656, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:38:13', 'admin-1498973776-14989738931183967', 1, 1, 'SR', NULL, NULL, NULL),
(36328, '2017-07-02 15:20:33', NULL, NULL, 10667, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 15:20:33', 'admin-1498976735-1498980033456242', 1, 1, 'SR', NULL, NULL, NULL),
(36329, '2017-07-02 15:36:57', NULL, NULL, 10668, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1498976735', 'admin', '2017-07-02 15:36:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36330, '2017-07-02 15:37:03', NULL, NULL, 10668, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 15:37:03', 'admin-1498976735-1498981023137712', 1, 0, '', NULL, NULL, NULL),
(36331, '2017-07-02 13:05:46', NULL, NULL, 10649, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:05:46', 'admin-1498970043-14989719459437329', 1, 0, '', NULL, NULL, NULL),
(36332, '2017-07-02 13:05:46', NULL, NULL, 10649, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:05:46', 'admin-1498970043-14989719459437329', 1, 1, 'SR', NULL, NULL, NULL),
(36333, '2017-07-02 13:04:46', NULL, NULL, 10649, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:04:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36334, '2017-07-02 12:59:07', NULL, NULL, 10646, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:59:07', 'admin-1498970043-14989715477226322', 1, 0, '', NULL, NULL, NULL),
(36335, '2017-07-02 13:01:09', NULL, NULL, 10648, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:01:09', 'admin-1498970043-14989716696545447', 1, 0, '', NULL, NULL, NULL),
(36336, '2017-07-02 13:00:38', NULL, NULL, 10648, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:00:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36337, '2017-07-02 13:01:09', NULL, NULL, 10648, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:01:09', 'admin-1498970043-14989716696545447', 1, 0, '', NULL, NULL, NULL),
(36338, '2017-07-02 00:00:00', NULL, NULL, 10627, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:17:55', 'admin-1498961112-14989618751391867', 1, 0, '', NULL, NULL, NULL),
(36339, '2017-07-02 00:00:00', NULL, NULL, 10628, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:18:11', 'admin-1498961112-14989618910985541', 1, 1, 'SR', NULL, NULL, NULL),
(36340, '2017-07-02 10:58:16', NULL, NULL, 10630, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:58:16', 'admin-1498961112-14989642964037445', 1, 1, 'SR', NULL, NULL, NULL),
(36341, '2017-07-02 10:58:16', NULL, NULL, 10630, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:58:16', 'admin-1498961112-14989642964037445', 1, 1, 'SR', NULL, NULL, NULL),
(36342, '2017-07-02 10:58:16', NULL, NULL, 10630, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:58:16', 'admin-1498961112-14989642964037445', 1, 0, '', NULL, NULL, NULL),
(36343, '2017-07-02 10:58:16', NULL, NULL, 10630, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:58:16', 'admin-1498961112-14989642964037445', 1, 0, '', NULL, NULL, NULL),
(36344, '2017-07-02 11:12:04', NULL, NULL, 10631, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:12:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36345, '2017-07-02 11:12:31', NULL, NULL, 10631, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:12:31', 'admin-1498961112-14989651514849865', 1, 1, 'SR', NULL, NULL, NULL),
(36346, '2017-07-02 11:12:31', NULL, NULL, 10631, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:12:31', 'admin-1498961112-14989651514849865', 1, 1, 'SR', NULL, NULL, NULL),
(36347, '2017-07-02 11:12:31', NULL, NULL, 10631, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:12:31', 'admin-1498961112-14989651514849865', 1, 0, '', NULL, NULL, NULL),
(36348, '2017-07-02 11:12:31', NULL, NULL, 10631, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:12:31', 'admin-1498961112-14989651514849865', 1, 0, '', NULL, NULL, NULL),
(36349, '2017-07-02 11:21:55', NULL, NULL, 10632, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:21:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36350, '2017-07-02 16:21:47', NULL, NULL, 10669, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 16:21:47', 'admin-1498976735-14989837070761280', 1, 1, 'SR', 1, NULL, NULL),
(36351, '2017-07-02 15:16:32', NULL, NULL, 10664, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 15:16:32', 'admin-1498976735-14989797924367625', 1, 1, 'SR', NULL, NULL, NULL),
(36352, '2017-07-02 00:00:00', NULL, NULL, 10665, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:25:15', 'admin-1498973776-14989767152132714', 1, 1, 'SR', NULL, NULL, NULL),
(36353, '2017-07-02 15:16:32', NULL, NULL, 10664, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 15:16:32', 'admin-1498976735-14989797924367625', 1, 1, 'SR', NULL, NULL, NULL),
(36354, '2017-07-02 12:45:29', NULL, NULL, 10647, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:45:29', 'admin-1498970043-14989707291291132', 1, 0, '', NULL, NULL, NULL),
(36355, '2017-07-02 13:31:43', NULL, NULL, 10653, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:31:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36356, '2017-07-02 12:36:09', NULL, NULL, 10645, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:36:09', 'admin-1498970043-14989701691427655', 1, 1, 'SR', NULL, NULL, NULL),
(36357, '2017-07-02 15:00:00', NULL, NULL, 10662, 0, 181, '116', 'Open Food ', 'Welldone sunny egg', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 15:00:00', 'admin-1498976735-14989788002445673', 1, 0, '', NULL, NULL, NULL),
(36358, '2017-07-02 14:51:13', NULL, NULL, 10663, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:51:13', 'admin-1498976735-14989782736829450', 1, 1, 'SR', NULL, NULL, NULL),
(36359, '2017-07-02 14:51:13', NULL, NULL, 10663, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:51:13', 'admin-1498976735-14989782736829450', 1, 1, 'SR', NULL, NULL, NULL),
(36360, '2017-07-02 14:51:13', NULL, NULL, 10663, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:51:13', 'admin-1498976735-14989782736829450', 1, 1, 'SR', NULL, NULL, NULL),
(36361, '2017-07-02 14:48:50', NULL, NULL, 10663, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:48:50', 'admin-1498976735-14989781307846137', 1, 0, '', NULL, NULL, NULL),
(36362, '2017-07-02 14:48:50', NULL, NULL, 10663, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:48:51', 'admin-1498976735-14989781307846137', 1, 1, 'SR', NULL, NULL, NULL),
(36363, '2017-07-02 14:48:50', NULL, NULL, 10663, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:48:50', 'admin-1498976735-14989781307846137', 1, 0, '', NULL, NULL, NULL),
(36364, '2017-07-02 14:48:50', NULL, NULL, 10663, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:48:50', 'admin-1498976735-14989781307846137', 1, 0, '', NULL, NULL, NULL),
(36365, '2017-07-02 14:48:50', NULL, NULL, 10663, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:48:50', 'admin-1498976735-14989781307846137', 1, 0, '', NULL, NULL, NULL),
(36366, '2017-07-02 00:00:00', NULL, NULL, 10666, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:25:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36367, '2017-07-02 00:00:00', NULL, NULL, 10665, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:25:44', 'admin-1498976735-1498976744126679', 1, 1, 'SR', NULL, NULL, NULL),
(36368, '2017-07-02 15:18:03', NULL, NULL, 10665, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1498976735', 'admin', '2017-07-02 15:18:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36369, '2017-07-02 14:19:26', NULL, NULL, 10658, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:19:26', 'admin-1498973776-14989763665907450', 1, 1, 'SR', NULL, NULL, NULL),
(36370, '2017-07-02 12:57:57', NULL, NULL, 10646, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:57:57', 'admin-1498970043-14989714768429812', 1, 0, '', NULL, NULL, NULL),
(36371, '2017-07-02 12:57:57', NULL, NULL, 10646, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:57:57', 'admin-1498970043-14989714768429812', 1, 0, '', NULL, NULL, NULL),
(36372, '2017-07-02 12:21:23', NULL, NULL, 10641, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:21:23', 'admin-1498968964-14989692832857153', 1, 1, 'SR', NULL, NULL, NULL),
(36373, '2017-07-02 12:22:16', NULL, NULL, 10642, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:22:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36374, '2017-07-02 12:57:57', NULL, NULL, 10646, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:57:57', 'admin-1498970043-14989714768429812', 1, 0, '', NULL, NULL, NULL),
(36375, '2017-07-02 14:19:26', NULL, NULL, 10658, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:19:26', 'admin-1498973776-14989763665907450', 1, 1, 'SR', NULL, NULL, NULL),
(36376, '2017-07-02 14:19:16', NULL, NULL, 10658, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:19:16', 'admin-1498973776-14989763561566685', 1, 0, '', NULL, NULL, NULL),
(36377, '2017-07-02 00:00:00', NULL, NULL, 10657, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:38:13', 'admin-1498973776-14989738931183967', 1, 1, 'SR', NULL, NULL, NULL),
(36378, '2017-07-02 14:51:37', NULL, NULL, 10663, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:51:37', 'admin-1498976735-14989782976889345', 1, 0, '', NULL, NULL, NULL),
(36379, '2017-07-02 11:23:00', NULL, NULL, 10633, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.10, 0.0000, 0.0000, 11.10, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:23:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36380, '2017-07-02 11:23:44', NULL, NULL, 10633, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:23:44', 'admin-1498965772-14989658239413740', 1, 0, '', NULL, NULL, NULL),
(36381, '2017-07-02 11:23:44', NULL, NULL, 10633, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:23:44', 'admin-1498965772-14989658239413740', 1, 0, '', NULL, NULL, NULL),
(36382, '2017-07-02 13:01:09', NULL, NULL, 10648, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:01:09', 'admin-1498970043-14989716696545447', 1, 1, 'SR', NULL, NULL, NULL),
(36383, '2017-07-02 12:49:14', NULL, NULL, 10647, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:49:14', 'admin-1498970043-14989709539076671', 1, 1, 'SR', NULL, NULL, NULL),
(36384, '2017-07-02 12:49:14', NULL, NULL, 10647, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:49:14', 'admin-1498970043-14989709539076671', 1, 1, 'SR', NULL, NULL, NULL),
(36385, '2017-07-02 14:51:13', NULL, NULL, 10663, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 14:51:13', 'admin-1498976735-14989782736829450', 1, 0, '', NULL, NULL, NULL),
(36386, '2017-07-02 13:15:09', NULL, NULL, 10652, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:15:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36387, '2017-07-02 13:15:19', NULL, NULL, 10652, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:15:19', 'admin-1498972092-14989725189571949', 1, 0, '', NULL, NULL, NULL),
(36388, '2017-07-02 12:32:28', NULL, NULL, 10645, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.90, 0.0000, 0.0000, 11.90, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:32:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36389, '2017-07-02 12:32:53', NULL, NULL, 10645, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:32:53', 'admin-1498968964-14989699733466345', 1, 0, '', NULL, NULL, NULL),
(36390, '2017-07-02 12:32:53', NULL, NULL, 10645, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:32:53', 'admin-1498968964-14989699733466345', 1, 0, '', NULL, NULL, NULL),
(36391, '2017-07-02 12:32:53', NULL, NULL, 10645, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:32:53', 'admin-1498968964-14989699733466345', 1, 0, '', NULL, NULL, NULL),
(36392, '2017-07-02 12:32:53', NULL, NULL, 10645, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:32:53', 'admin-1498968964-14989699733466345', 1, 0, '', NULL, NULL, NULL),
(36393, '2017-07-02 13:15:03', NULL, NULL, 10639, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:15:03', 'admin-1498972092-14989725035166520', 1, 1, 'SR', NULL, NULL, NULL),
(36394, '2017-07-02 13:15:03', NULL, NULL, 10639, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:15:03', 'admin-1498972092-14989725035166520', 1, 1, 'SR', NULL, NULL, NULL),
(36395, '2017-07-02 12:45:29', NULL, NULL, 10647, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:45:29', 'admin-1498970043-14989707291291132', 1, 1, 'SR', NULL, NULL, NULL),
(36396, '2017-07-02 12:45:29', NULL, NULL, 10647, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:45:29', 'admin-1498970043-14989707291291132', 1, 0, '', NULL, NULL, NULL),
(36397, '2017-07-02 13:09:28', NULL, NULL, 10651, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:09:28', 'admin-1498972092-14989721687123968', 1, 0, '', NULL, NULL, NULL),
(36398, '2017-07-02 12:45:29', NULL, NULL, 10647, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:45:29', 'admin-1498970043-14989707291291132', 1, 1, 'SR', NULL, NULL, NULL),
(36399, '2017-07-02 13:15:03', NULL, NULL, 10639, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:15:03', 'admin-1498972092-14989725035166520', 1, 1, 'SR', NULL, NULL, NULL),
(36400, '2017-07-02 13:15:03', NULL, NULL, 10639, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:15:03', 'admin-1498972092-14989725035166520', 1, 0, '', NULL, NULL, NULL),
(36401, '2017-07-02 12:44:37', NULL, NULL, 10647, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.10, 0.0000, 0.0000, 14.10, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:44:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36402, '2017-07-02 12:57:57', NULL, NULL, 10646, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:57:57', 'admin-1498970043-14989714768429812', 1, 1, 'SR', NULL, NULL, NULL),
(36403, '2017-07-02 12:38:01', NULL, NULL, 10646, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:38:01', 'admin-1498970043-14989702815285861', 1, 0, '', NULL, NULL, NULL),
(36404, '2017-07-02 12:38:01', NULL, NULL, 10646, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:38:01', 'admin-1498970043-14989702815285861', 1, 1, 'SR', NULL, NULL, NULL),
(36405, '2017-07-02 12:23:50', NULL, NULL, 10637, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:23:50', 'admin-1498968964-14989694299148145', 1, 1, 'SR', NULL, NULL, NULL),
(36406, '2017-07-02 12:27:45', NULL, NULL, 10643, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:27:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36407, '2017-07-02 12:38:01', NULL, NULL, 10646, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:38:01', 'admin-1498970043-14989702815285861', 1, 1, 'SR', NULL, NULL, NULL),
(36408, '2017-07-02 12:38:01', NULL, NULL, 10646, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:38:01', 'admin-1498970043-14989702815285861', 1, 1, 'SR', NULL, NULL, NULL),
(36409, '2017-07-02 12:11:14', NULL, NULL, 10638, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:11:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36410, '2017-07-02 12:11:27', NULL, NULL, 10638, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:11:27', 'admin-1498965772-14989686868079412', 1, 1, 'SR', NULL, NULL, NULL),
(36411, '2017-07-02 12:12:43', NULL, NULL, 10639, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.00, 0.0000, 0.0000, 10.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:12:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36412, '2017-07-02 12:14:57', NULL, NULL, 10638, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:14:57', 'admin-1498965772-14989688969323542', 1, 0, '', NULL, NULL, NULL),
(36413, '2017-07-02 12:16:17', NULL, NULL, 10638, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:16:17', 'admin-1498968964-14989689770068697', 1, 0, '', NULL, NULL, NULL),
(36414, '2017-07-02 12:36:50', NULL, NULL, 10646, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.60, 0.0000, 0.0000, 14.60, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:36:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36415, '2017-07-02 12:38:01', NULL, NULL, 10646, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:38:01', 'admin-1498970043-14989702815285861', 1, 0, '', NULL, NULL, NULL),
(36416, '2017-07-02 12:36:09', NULL, NULL, 10645, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:36:09', 'admin-1498970043-14989701691427655', 1, 1, 'SR', NULL, NULL, NULL),
(36417, '2017-07-02 12:36:09', NULL, NULL, 10645, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:36:09', 'admin-1498970043-14989701691427655', 1, 1, 'SR', NULL, NULL, NULL),
(36418, '2017-07-02 13:15:03', NULL, NULL, 10639, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:15:03', 'admin-1498972092-14989725035166520', 1, 1, 'SR', NULL, NULL, NULL),
(36419, '2017-07-02 12:45:29', NULL, NULL, 10647, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:45:29', 'admin-1498970043-14989707291291132', 1, 0, '', NULL, NULL, NULL),
(36420, '2017-07-02 12:28:22', NULL, NULL, 10643, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:28:22', 'admin-1498968964-14989697017945424', 1, 1, 'SR', NULL, NULL, NULL),
(36421, '2017-07-02 12:29:31', NULL, NULL, 10644, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:29:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36422, '2017-07-02 12:16:51', NULL, NULL, 10639, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:16:51', 'admin-1498968964-14989690115889483', 1, 1, 'SR', NULL, NULL, NULL),
(36423, '2017-07-02 12:16:56', NULL, NULL, 10640, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:16:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36424, '2017-07-02 12:38:01', NULL, NULL, 10646, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:38:01', 'admin-1498970043-14989702815285861', 1, 1, 'SR', NULL, NULL, NULL),
(36425, '2017-07-02 12:28:22', NULL, NULL, 10643, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:28:22', 'admin-1498968964-14989697017945424', 1, 1, 'SR', NULL, NULL, NULL),
(36426, '2017-07-02 12:28:22', NULL, NULL, 10643, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:28:22', 'admin-1498968964-14989697017945424', 1, 1, 'SR', NULL, NULL, NULL),
(36427, '2017-07-02 12:28:22', NULL, NULL, 10643, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:28:22', 'admin-1498968964-14989697017945424', 1, 1, 'SR', NULL, NULL, NULL),
(36428, '2017-07-02 12:23:50', NULL, NULL, 10637, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:23:50', 'admin-1498968964-14989694299148145', 1, 1, 'SR', NULL, NULL, NULL),
(36429, '2017-07-02 12:23:07', NULL, NULL, 10642, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:23:07', 'admin-1498968964-14989693868051422', 1, 1, 'SR', NULL, NULL, NULL),
(36430, '2017-07-02 11:29:55', NULL, NULL, 10632, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:29:55', 'admin-1498965772-14989661955759389', 1, 1, 'SR', NULL, NULL, NULL),
(36431, '2017-07-02 11:29:55', NULL, NULL, 10632, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:29:55', 'admin-1498965772-14989661955759389', 1, 1, 'SR', NULL, NULL, NULL),
(36432, '2017-07-02 11:46:50', NULL, NULL, 10635, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:46:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36433, '2017-07-02 12:28:22', NULL, NULL, 10643, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:28:22', 'admin-1498968964-14989697017945424', 1, 1, 'SR', NULL, NULL, NULL),
(36434, '2017-07-02 12:22:37', NULL, NULL, 10642, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:22:37', 'admin-1498968964-14989693577989289', 1, 0, '', NULL, NULL, NULL),
(36435, '2017-07-02 12:22:37', NULL, NULL, 10642, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:22:37', 'admin-1498968964-14989693577989289', 1, 1, 'SR', NULL, NULL, NULL),
(36436, '2017-07-02 11:50:43', NULL, NULL, 10636, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:50:43', 'admin-1498965772-14989674437376734', 1, 1, 'SR', NULL, NULL, NULL),
(36437, '2017-07-02 12:21:23', NULL, NULL, 10641, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:21:23', 'admin-1498968964-14989692832857153', 1, 1, 'SR', NULL, NULL, NULL),
(36438, '2017-07-02 09:52:44', NULL, NULL, 10622, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:52:44', 'admin-1498957416-14989603640753583', 1, 1, 'SR', NULL, NULL, NULL),
(36439, '2017-07-02 09:52:22', NULL, NULL, 10622, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:52:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36440, '2017-07-02 09:52:35', NULL, NULL, 10622, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:52:35', 'admin-1498957416-14989603553114940', 1, 0, '', NULL, NULL, NULL),
(36441, '2017-07-02 09:52:35', NULL, NULL, 10622, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:52:35', 'admin-1498957416-14989603553114940', 1, 0, '', NULL, NULL, NULL),
(36442, '2017-07-02 12:21:23', NULL, NULL, 10641, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:21:23', 'admin-1498968964-14989692832857153', 1, 0, '', NULL, NULL, NULL),
(36443, '2017-07-02 12:21:23', NULL, NULL, 10641, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:21:23', 'admin-1498968964-14989692832857153', 1, 1, 'SR', NULL, NULL, NULL),
(36444, '2017-07-02 12:21:11', NULL, NULL, 10641, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:21:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36445, '2017-07-02 12:21:23', NULL, NULL, 10641, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:21:23', 'admin-1498968964-14989692832857153', 1, 0, '', NULL, NULL, NULL),
(36446, '2017-07-02 10:42:43', NULL, NULL, 10626, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:42:43', 'admin-1498961112-14989633628494925', 1, 1, 'SR', NULL, NULL, NULL),
(36447, '2017-07-02 09:27:59', NULL, NULL, 10616, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:27:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36448, '2017-07-02 09:28:05', NULL, NULL, 10616, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:28:05', 'admin-1498957416-14989588855796774', 1, 1, 'SR', NULL, NULL, NULL),
(36449, '2017-07-02 10:04:35', NULL, NULL, 10621, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:04:35', 'admin-1498957416-14989610755198165', 1, 0, '', NULL, NULL, NULL),
(36450, '2017-07-02 09:36:49', NULL, NULL, 10619, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:36:49', 'admin-1498957416-14989594095677323', 1, 1, 'SR', NULL, NULL, NULL),
(36451, '2017-07-02 09:36:49', NULL, NULL, 10619, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:36:49', 'admin-1498957416-14989594095677323', 1, 0, '', NULL, NULL, NULL),
(36452, '2017-07-02 09:31:33', NULL, NULL, 10618, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:31:33', 'admin-1498957416-14989590936579859', 1, 0, '', NULL, NULL, NULL),
(36453, '2017-07-02 09:36:31', NULL, NULL, 10619, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:36:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36454, '2017-07-02 09:36:49', NULL, NULL, 10619, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:36:49', 'admin-1498957416-14989594095677323', 1, 1, 'SR', NULL, NULL, NULL),
(36455, '2017-07-02 11:23:44', NULL, NULL, 10633, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:23:44', 'admin-1498965772-14989658239413740', 1, 1, 'SR', NULL, NULL, NULL),
(36456, '2017-07-02 11:24:01', NULL, NULL, 10633, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:24:01', 'admin-1498965772-1498965841485433', 1, 1, 'SR', NULL, NULL, NULL),
(36457, '2017-07-02 11:23:44', NULL, NULL, 10633, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:23:44', 'admin-1498965772-14989658239413740', 1, 0, '', NULL, NULL, NULL),
(36458, '2017-07-02 13:07:05', NULL, NULL, 10650, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:07:05', 'admin-1498970043-14989720254338750', 1, 0, '', NULL, NULL, '10.0'),
(36459, '2017-07-02 12:16:17', NULL, NULL, 10638, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:16:17', 'admin-1498968964-14989689770068697', 1, 1, 'SR', NULL, NULL, NULL),
(36460, '2017-07-02 00:00:00', NULL, NULL, 10628, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, NULL, NULL, 2.60, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:17:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36461, '2017-07-02 10:45:39', NULL, NULL, 10627, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:45:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36462, '2017-07-02 00:00:00', NULL, NULL, 10628, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:17:55', 'admin-1498961112-14989618751391867', 1, 0, '', NULL, NULL, NULL),
(36463, '2017-07-02 10:53:53', NULL, NULL, 10629, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:53:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36464, '2017-07-02 10:54:02', NULL, NULL, 10629, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:54:02', 'admin-1498961112-14989640419524120', 1, 0, '', NULL, NULL, NULL),
(36465, '2017-07-02 10:54:02', NULL, NULL, 10629, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:54:02', 'admin-1498961112-14989640419524120', 1, 0, '', NULL, NULL, NULL),
(36466, '2017-07-02 10:54:18', NULL, NULL, 10629, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:54:18', 'admin-1498961112-14989640584043361', 1, 1, 'SR', NULL, NULL, NULL),
(36467, '2017-07-02 10:54:18', NULL, NULL, 10629, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:54:18', 'admin-1498961112-14989640584043361', 1, 1, 'SR', NULL, NULL, NULL),
(36468, '2017-07-02 10:57:39', NULL, NULL, 10630, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:57:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36469, '2017-07-02 11:54:37', NULL, NULL, 10637, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:54:37', 'admin-1498965772-14989676772109349', 1, 1, 'SR', NULL, NULL, NULL),
(36470, '2017-07-02 11:54:32', NULL, NULL, 10637, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:54:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36471, '2017-07-02 11:50:32', NULL, NULL, 10636, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:50:32', 'admin-1498965772-14989674325347768', 1, 1, 'SR', NULL, NULL, NULL),
(36472, '2017-07-02 11:47:25', NULL, NULL, 10636, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:47:25', 'admin-1498965772-1498967245308660', 1, 1, 'SR', NULL, NULL, NULL),
(36473, '2017-07-02 11:47:25', NULL, NULL, 10636, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:47:25', 'admin-1498965772-1498967245308660', 1, 0, '', NULL, NULL, NULL),
(36474, '2017-07-02 11:47:20', NULL, NULL, 10636, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:47:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36475, '2017-07-02 11:47:04', NULL, NULL, 10635, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:47:04', 'admin-1498965772-14989672238837230', 1, 1, 'SR', NULL, NULL, NULL),
(36476, '2017-07-02 11:25:32', NULL, NULL, 10634, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:25:32', 'admin-1498965772-14989659321951456', 1, 1, 'SR', NULL, NULL, NULL),
(36477, '2017-07-02 11:25:32', NULL, NULL, 10634, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:25:32', 'admin-1498965772-14989659321951456', 1, 1, 'SR', NULL, NULL, NULL),
(36478, '2017-07-02 13:09:28', NULL, NULL, 10651, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 13:09:28', 'admin-1498972092-14989721687123968', 1, 0, '', NULL, NULL, NULL),
(36479, '2017-07-02 10:42:43', NULL, NULL, 10626, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:42:43', 'admin-1498961112-14989633628494925', 1, 1, 'SR', NULL, NULL, NULL),
(36480, '2017-07-02 10:42:43', NULL, NULL, 10626, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:42:43', 'admin-1498961112-14989633628494925', 1, 1, 'SR', NULL, NULL, NULL),
(36481, '2017-07-02 10:42:43', NULL, NULL, 10626, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:42:43', 'admin-1498961112-14989633628494925', 1, 1, 'SR', NULL, NULL, NULL),
(36482, '2017-07-02 10:42:43', NULL, NULL, 10626, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:42:43', 'admin-1498961112-14989633628494925', 1, 1, 'SR', NULL, NULL, NULL),
(36483, '2017-07-02 10:42:43', NULL, NULL, 10626, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:42:43', 'admin-1498961112-14989633628494925', 1, 1, 'SR', NULL, NULL, NULL),
(36484, '2017-07-02 10:42:43', NULL, NULL, 10626, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:42:43', 'admin-1498961112-14989633628494925', 1, 0, '', NULL, NULL, NULL),
(36485, '2017-07-02 10:43:52', NULL, NULL, 10626, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:43:52', 'admin-1498961112-14989634327371483', 1, 0, '', NULL, NULL, NULL),
(36486, '2017-07-02 10:43:52', NULL, NULL, 10626, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:43:52', 'admin-1498961112-14989634327371483', 1, 0, '', NULL, NULL, NULL),
(36487, '2017-07-02 10:43:52', NULL, NULL, 10626, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:43:52', 'admin-1498961112-14989634327371483', 1, 0, '', NULL, NULL, NULL),
(36488, '2017-07-02 11:54:37', NULL, NULL, 10637, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:54:37', 'admin-1498965772-14989676772109349', 1, 1, 'SR', NULL, NULL, NULL),
(36489, '2017-07-02 11:23:44', NULL, NULL, 10633, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:23:44', 'admin-1498965772-14989658239413740', 1, 0, '', NULL, NULL, NULL),
(36490, '2017-07-02 11:23:44', NULL, NULL, 10633, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:23:44', 'admin-1498965772-14989658239413740', 1, 0, '', NULL, NULL, NULL),
(36491, '2017-07-02 11:22:14', NULL, NULL, 10632, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:22:14', 'admin-1498961112-14989657338387326', 1, 0, '', NULL, NULL, NULL),
(36492, '2017-07-02 11:22:14', NULL, NULL, 10632, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:22:14', 'admin-1498961112-14989657338387326', 1, 0, '', NULL, NULL, NULL),
(36493, '2017-07-02 11:22:14', NULL, NULL, 10632, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 11:22:14', 'admin-1498961112-14989657338387326', 1, 0, '', NULL, NULL, NULL),
(36494, '2017-07-02 10:31:15', NULL, NULL, 10625, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:31:15', 'admin-1498961112-14989626748593954', 1, 0, '', NULL, NULL, NULL),
(36495, '2017-07-02 10:31:15', NULL, NULL, 10625, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:31:15', 'admin-1498961112-14989626748593954', 1, 0, '', NULL, NULL, NULL),
(36496, '2017-07-02 10:31:15', NULL, NULL, 10625, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:31:15', 'admin-1498961112-14989626748593954', 1, 1, 'SR', NULL, NULL, NULL),
(36497, '2017-07-02 10:31:15', NULL, NULL, 10625, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:31:15', 'admin-1498961112-14989626748593954', 1, 1, 'SR', NULL, NULL, NULL),
(36498, '2017-07-02 10:37:34', NULL, NULL, 10626, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.50, 0.0000, 0.0000, 12.50, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:37:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36499, '2017-07-02 10:37:41', NULL, NULL, 10626, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:37:41', 'admin-1498961112-14989630612041752', 1, 1, 'SR', NULL, NULL, NULL),
(36500, '2017-07-02 12:17:09', NULL, NULL, 10640, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:17:09', 'admin-1498968964-14989690297449064', 1, 0, '', NULL, NULL, NULL),
(36501, '2017-07-02 10:43:52', NULL, NULL, 10626, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:43:52', 'admin-1498961112-14989634327371483', 1, 1, 'SR', NULL, NULL, NULL),
(36502, '2017-07-02 09:36:49', NULL, NULL, 10619, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:36:49', 'admin-1498957416-14989594095677323', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(36503, '2017-07-02 10:37:41', NULL, NULL, 10626, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:37:41', 'admin-1498961112-14989630612041752', 1, 1, 'SR', NULL, NULL, NULL),
(36504, '2017-07-02 12:16:42', NULL, NULL, 10639, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 12:16:42', 'admin-1498968964-14989690019609859', 1, 0, '', NULL, NULL, NULL),
(36505, '2017-07-02 10:30:50', NULL, NULL, 10625, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:30:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36506, '2017-07-02 09:52:35', NULL, NULL, 10622, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:52:35', 'admin-1498957416-14989603553114940', 1, 0, '', NULL, NULL, NULL),
(36507, '2017-07-02 09:52:44', NULL, NULL, 10622, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:52:44', 'admin-1498957416-14989603640753583', 1, 1, 'SR', NULL, NULL, NULL),
(36508, '2017-07-02 10:05:32', NULL, NULL, 10623, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:05:32', 'admin-1498961112-14989611323214495', 1, 0, '', NULL, NULL, NULL),
(36509, '2017-07-02 10:05:18', NULL, NULL, 10623, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1498976735', 'admin', '2017-07-02 10:05:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36510, '2017-07-02 09:55:17', NULL, NULL, 10621, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:55:17', 'admin-1498957416-14989605173147229', 1, 1, 'SR', NULL, NULL, NULL),
(36511, '2017-07-02 09:38:38', NULL, NULL, 10620, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:38:38', 'admin-1498957416-14989595181295285', 1, 0, '', NULL, NULL, NULL),
(36512, '2017-07-02 09:38:38', NULL, NULL, 10620, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:38:38', 'admin-1498957416-14989595181295285', 1, 1, 'SR', NULL, NULL, NULL),
(36513, '2017-07-02 09:38:38', NULL, NULL, 10620, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:38:38', 'admin-1498957416-14989595181295285', 1, 1, 'SR', NULL, NULL, NULL),
(36514, '2017-07-02 09:49:20', NULL, NULL, 10621, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:49:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36515, '2017-07-02 09:49:45', NULL, NULL, 10621, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:49:45', 'admin-1498957416-1498960185587274', 1, 0, '', NULL, NULL, NULL),
(36516, '2017-07-02 09:49:45', NULL, NULL, 10621, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:49:45', 'admin-1498957416-1498960185587274', 1, 0, '', NULL, NULL, NULL),
(36517, '2017-07-02 09:49:45', NULL, NULL, 10621, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:49:45', 'admin-1498957416-1498960185587274', 1, 1, 'SR', NULL, NULL, NULL),
(36518, '2017-07-02 09:38:12', NULL, NULL, 10620, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:38:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36519, '2017-07-02 09:36:49', NULL, NULL, 10619, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:36:49', 'admin-1498957416-14989594095677323', 1, 1, 'SR', NULL, NULL, NULL),
(36520, '2017-07-02 09:31:33', NULL, NULL, 10618, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:31:33', 'admin-1498957416-14989590936579859', 1, 0, '', NULL, NULL, NULL),
(36521, '2017-07-02 09:31:33', NULL, NULL, 10618, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:31:33', 'admin-1498957416-14989590936579859', 1, 1, 'SR', NULL, NULL, NULL),
(36522, '2017-07-02 09:08:57', NULL, NULL, 10615, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:08:57', 'admin-1498957416-14989577372945570', 1, 0, '', NULL, NULL, NULL),
(36523, '2017-07-02 09:31:33', NULL, NULL, 10618, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:31:33', 'admin-1498957416-14989590936579859', 1, 1, 'SR', NULL, NULL, NULL),
(36524, '2017-07-02 09:28:44', NULL, NULL, 10617, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:28:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36525, '2017-07-02 09:28:53', NULL, NULL, 10617, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:28:53', 'admin-1498957416-1498958932929945', 1, 1, 'SR', NULL, NULL, NULL),
(36526, '2017-07-02 09:31:04', NULL, NULL, 10618, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:31:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36527, '2017-07-02 09:09:13', NULL, NULL, 10615, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:09:13', 'admin-1498957416-14989577534001821', 1, 0, '', NULL, NULL, NULL),
(36528, '2017-07-02 09:09:13', NULL, NULL, 10615, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:09:13', 'admin-1498957416-14989577534001821', 1, 1, 'SR', NULL, NULL, NULL),
(36529, '2017-07-02 09:08:57', NULL, NULL, 10615, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:08:57', 'admin-1498957416-14989577372945570', 1, 0, '', NULL, NULL, NULL),
(36530, '2017-07-02 09:08:43', NULL, NULL, 10615, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1498976735', 'admin', '2017-07-02 09:08:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36531, '2017-07-03 14:09:07', NULL, NULL, 10688, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 14:09:07', 'admin-1499056173-14990621474002657', 1, 1, 'SR', NULL, NULL, NULL),
(36532, '2017-07-03 13:37:52', NULL, NULL, 10687, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 13:37:52', 'admin-1499056173-1499060272270974', 1, 1, 'SR', NULL, NULL, NULL),
(36533, '2017-07-03 13:37:52', NULL, NULL, 10687, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 13:37:52', 'admin-1499056173-1499060272270974', 1, 1, 'SR', NULL, NULL, NULL),
(36534, '2017-07-03 13:37:52', NULL, NULL, 10687, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 13:37:52', 'admin-1499056173-1499060272270974', 1, 0, '', NULL, NULL, NULL),
(36535, '2017-07-03 14:09:07', NULL, NULL, 10688, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 14:09:07', 'admin-1499056173-14990621474002657', 1, 0, '', NULL, NULL, NULL),
(36536, '2017-07-03 14:09:07', NULL, NULL, 10688, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 14:09:07', 'admin-1499056173-14990621474002657', 1, 1, 'SR', NULL, NULL, NULL),
(36537, '2017-07-03 10:11:05', NULL, NULL, 10674, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:11:05', 'admin-1499047855-1499047865628472', 1, 1, 'SR', NULL, NULL, NULL),
(36538, '2017-07-03 10:15:49', NULL, NULL, 10675, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:15:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36539, '2017-07-03 10:16:02', NULL, NULL, 10675, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:16:02', 'admin-1499047855-14990481621679858', 1, 0, '', NULL, NULL, NULL),
(36540, '2017-07-03 10:16:02', NULL, NULL, 10675, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:16:02', 'admin-1499047855-14990481621679858', 1, 0, '', NULL, NULL, NULL),
(36541, '2017-07-03 10:16:02', NULL, NULL, 10675, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:16:02', 'admin-1499047855-14990481621679858', 1, 1, 'SR', NULL, NULL, NULL),
(36542, '2017-07-03 10:16:02', NULL, NULL, 10675, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:16:02', 'admin-1499047855-14990481621679858', 1, 1, 'SR', NULL, NULL, NULL),
(36543, '2017-07-03 10:17:39', NULL, NULL, 10676, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:17:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36544, '2017-07-03 10:17:47', NULL, NULL, 10676, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:17:47', 'admin-1499047855-14990482675528229', 1, 0, '', NULL, NULL, NULL),
(36545, '2017-07-03 10:17:47', NULL, NULL, 10676, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:17:47', 'admin-1499047855-14990482675528229', 1, 0, '', NULL, NULL, NULL),
(36546, '2017-07-03 10:17:54', NULL, NULL, 10676, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:17:54', 'admin-1499047855-14990482744345828', 1, 1, 'SR', NULL, NULL, NULL),
(36547, '2017-07-03 10:32:11', NULL, NULL, 10676, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:32:11', 'admin-1499047855-14990491309558981', 1, 0, '', NULL, NULL, NULL),
(36548, '2017-07-03 12:29:02', NULL, NULL, 10683, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 12:29:02', 'admin-1499053371-14990561421048081', 1, 1, 'SR', NULL, NULL, NULL),
(36549, '2017-07-03 12:20:37', NULL, NULL, 10682, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1499056173', 'admin', '2017-07-03 12:20:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36550, '2017-07-03 12:20:50', NULL, NULL, 10682, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 12:20:50', 'admin-1499053371-14990556499876878', 1, 1, 'SR', NULL, NULL, NULL),
(36551, '2017-07-03 12:20:50', NULL, NULL, 10682, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 12:20:50', 'admin-1499053371-14990556499876878', 1, 1, 'SR', NULL, NULL, NULL),
(36552, '2017-07-03 12:20:50', NULL, NULL, 10682, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 12:20:50', 'admin-1499053371-14990556499876878', 1, 1, 'SR', NULL, NULL, NULL),
(36553, '2017-07-03 12:28:54', NULL, NULL, 10683, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1499056173', 'admin', '2017-07-03 12:28:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36554, '2017-07-03 00:00:00', NULL, NULL, 10680, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:43:12', 'admin-1499047855-14990497920422359', 1, 0, '', NULL, NULL, NULL),
(36555, '2017-07-03 00:00:00', NULL, NULL, 10679, 0, 156, '90', 'House Cheddar Omelet', 'no salad', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:43:12', 'admin-1499047855-14990497920422359', 1, 0, '', NULL, NULL, NULL),
(36556, '2017-07-03 10:46:02', NULL, NULL, 10678, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.30, 0.0000, 0.0000, 12.30, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:46:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36557, '2017-07-03 11:42:46', NULL, NULL, 10681, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 11:42:46', 'admin-1499047855-14990533667068321', 1, 0, '', NULL, NULL, NULL),
(36558, '2017-07-03 09:15:21', NULL, NULL, 10671, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:15:21', 'admin-1499043648-14990445213858057', 1, 0, '', NULL, NULL, NULL),
(36559, '2017-07-03 09:35:11', NULL, NULL, 10672, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.30, 0.0000, 0.0000, 12.30, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:35:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36560, '2017-07-03 09:35:36', NULL, NULL, 10672, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:35:36', 'admin-1499043648-14990457360494149', 1, 0, '', NULL, NULL, NULL),
(36561, '2017-07-03 09:15:21', NULL, NULL, 10671, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:15:21', 'admin-1499043648-14990445213858057', 1, 1, 'SR', NULL, NULL, NULL),
(36562, '2017-07-03 09:15:21', NULL, NULL, 10671, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:15:21', 'admin-1499043648-14990445213858057', 1, 1, 'SR', NULL, NULL, NULL),
(36563, '2017-07-03 09:35:36', NULL, NULL, 10672, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:35:36', 'admin-1499043648-14990457360494149', 1, 1, 'SR', NULL, NULL, NULL),
(36564, '2017-07-03 09:35:36', NULL, NULL, 10672, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:35:36', 'admin-1499043648-14990457360494149', 1, 1, 'SR', NULL, NULL, NULL),
(36565, '2017-07-03 09:37:21', NULL, NULL, 10671, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:37:21', 'admin-1499043648-14990458411317180', 1, 0, '', NULL, NULL, NULL),
(36566, '2017-07-03 10:46:25', NULL, NULL, 10678, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:46:25', 'admin-1499047855-14990499851616914', 1, 1, 'SR', NULL, NULL, NULL),
(36567, '2017-07-03 10:46:25', NULL, NULL, 10678, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:46:25', 'admin-1499047855-14990499851616914', 1, 0, '', NULL, NULL, NULL),
(36568, '2017-07-03 10:46:25', NULL, NULL, 10678, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:46:25', 'admin-1499047855-14990499851616914', 1, 1, 'SR', NULL, NULL, NULL),
(36569, '2017-07-03 10:54:06', NULL, NULL, 10675, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:54:06', 'admin-1499047855-14990504460545819', 1, 0, '', NULL, NULL, NULL),
(36570, '2017-07-03 00:00:00', NULL, NULL, 10679, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:43:12', 'admin-1499047855-14990497920422359', 1, 1, 'SR', NULL, NULL, NULL),
(36571, '2017-07-03 00:00:00', NULL, NULL, 10680, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:43:12', 'admin-1499047855-14990497920422359', 1, 1, 'SR', NULL, NULL, NULL),
(36572, '2017-07-03 11:42:46', NULL, NULL, 10681, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 11:42:46', 'admin-1499047855-14990533667068321', 1, 0, '', NULL, NULL, NULL),
(36573, '2017-07-03 12:39:56', NULL, NULL, 10685, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1499056173', 'admin', '2017-07-03 12:39:56', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(36574, '2017-07-03 12:40:06', NULL, NULL, 10685, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 12:40:06', 'admin-1499056173-14990568067396499', 1, 0, '', NULL, NULL, '10.0'),
(36575, '2017-07-03 12:40:06', NULL, NULL, 10685, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 12:40:06', 'admin-1499056173-14990568067396499', 1, 1, 'SR', NULL, NULL, '10.0'),
(36576, '2017-07-03 13:37:52', NULL, NULL, 10687, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 13:37:52', 'admin-1499056173-1499060272270974', 1, 0, '', NULL, NULL, NULL),
(36577, '2017-07-03 13:37:52', NULL, NULL, 10687, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 13:37:52', 'admin-1499056173-1499060272270974', 1, 1, 'SR', NULL, NULL, NULL),
(36578, '2017-07-03 13:36:11', NULL, NULL, 10687, 0, 181, '116', 'Open Food ', 'Lemony change to bread', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 13:36:11', 'admin-1499056173-14990601712712173', 1, 0, '', NULL, NULL, NULL),
(36579, '2017-07-03 13:36:11', NULL, NULL, 10687, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 13:36:11', 'admin-1499056173-14990601712712173', 1, 0, '', NULL, NULL, NULL),
(36580, '2017-07-03 13:34:43', NULL, NULL, 10687, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1499056173', 'admin', '2017-07-03 13:34:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36581, '2017-07-03 12:59:23', NULL, NULL, 10686, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 12:59:23', 'admin-1499056173-14990579635012732', 1, 1, 'SR', NULL, NULL, NULL),
(36582, '2017-07-03 12:59:20', NULL, NULL, 10686, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 12:59:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36583, '2017-07-03 14:08:49', NULL, NULL, 10688, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1499056173', 'admin', '2017-07-03 14:08:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36584, '2017-07-03 12:48:55', NULL, NULL, 10685, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 12:48:55', 'admin-1499056173-14990573349465261', 1, 0, '', NULL, NULL, '10.0'),
(36585, '2017-07-03 12:40:14', NULL, NULL, 10685, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 12:40:14', 'admin-1499056173-14990568147871421', 1, 0, '', NULL, NULL, '10.0'),
(36586, '2017-07-03 12:29:26', NULL, NULL, 10684, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 12:29:26', 'admin-1499053371-14990561662123976', 1, 1, 'SR', NULL, NULL, NULL),
(36587, '2017-07-03 12:29:26', NULL, NULL, 10684, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 12:29:26', 'admin-1499053371-14990561662123976', 1, 1, 'SR', NULL, NULL, NULL),
(36588, '2017-07-03 12:29:13', NULL, NULL, 10683, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 12:29:13', 'admin-1499053371-14990561530139074', 1, 0, '', NULL, NULL, NULL),
(36589, '2017-07-03 12:29:13', NULL, NULL, 10683, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 12:29:13', 'admin-1499053371-14990561530139074', 1, 1, 'SR', NULL, NULL, NULL),
(36590, '2017-07-03 12:29:18', NULL, NULL, 10684, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1499056173', 'admin', '2017-07-03 12:29:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36591, '2017-07-03 09:47:42', NULL, NULL, 10673, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:47:42', 'admin-1499043648-14990464620786776', 1, 0, '', NULL, NULL, NULL),
(36592, '2017-07-03 09:47:42', NULL, NULL, 10673, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:47:42', 'admin-1499043648-14990464620786776', 1, 0, '', NULL, NULL, NULL),
(36593, '2017-07-03 09:47:42', NULL, NULL, 10673, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:47:42', 'admin-1499043648-14990464620786776', 1, 0, '', NULL, NULL, NULL),
(36594, '2017-07-03 09:47:42', NULL, NULL, 10673, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:47:42', 'admin-1499043648-14990464620786776', 1, 0, '', NULL, NULL, NULL),
(36595, '2017-07-03 12:29:02', NULL, NULL, 10683, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 12:29:02', 'admin-1499053371-14990561421048081', 1, 1, 'SR', NULL, NULL, NULL),
(36596, '2017-07-03 11:43:03', NULL, NULL, 10681, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 2, 15.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 11:43:03', 'admin-1499053371-14990533830161367', 1, 1, 'SR', NULL, NULL, NULL),
(36597, '2017-07-03 10:46:11', NULL, NULL, 10678, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:46:11', 'admin-1499047855-14990499713391154', 1, 0, '', NULL, NULL, NULL),
(36598, '2017-07-03 10:46:11', NULL, NULL, 10678, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:46:11', 'admin-1499047855-14990499713391154', 1, 0, '', NULL, NULL, NULL),
(36599, '2017-07-03 10:46:11', NULL, NULL, 10678, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:46:11', 'admin-1499047855-14990499713391154', 1, 0, '', NULL, NULL, NULL),
(36600, '2017-07-03 10:46:25', NULL, NULL, 10678, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:46:25', 'admin-1499047855-14990499851616914', 1, 1, 'SR', NULL, NULL, NULL),
(36601, '2017-07-03 10:46:11', NULL, NULL, 10678, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:46:11', 'admin-1499047855-14990499713391154', 1, 0, '', NULL, NULL, NULL),
(36602, '2017-07-03 11:09:46', NULL, NULL, 10679, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1499056173', 'admin', '2017-07-03 11:09:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36603, '2017-07-03 00:00:00', NULL, NULL, 10680, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, NULL, NULL, 2.90, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:42:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36604, '2017-07-03 11:42:42', NULL, NULL, 10681, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 11:42:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36605, '2017-07-03 10:32:19', NULL, NULL, 10676, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:32:19', 'admin-1499047855-14990491390201133', 1, 1, 'SR', NULL, NULL, NULL),
(36606, '2017-07-03 10:32:11', NULL, NULL, 10676, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:32:11', 'admin-1499047855-14990491309558981', 1, 0, '', NULL, NULL, NULL),
(36607, '2017-07-03 09:35:36', NULL, NULL, 10672, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:35:36', 'admin-1499043648-14990457360494149', 1, 0, '', NULL, NULL, NULL),
(36608, '2017-07-03 09:47:42', NULL, NULL, 10673, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:47:42', 'admin-1499043648-14990464620786776', 1, 1, 'SR', NULL, NULL, NULL),
(36609, '2017-07-03 09:47:42', NULL, NULL, 10673, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:47:42', 'admin-1499043648-14990464620786776', 1, 1, 'SR', NULL, NULL, NULL),
(36610, '2017-07-03 09:47:42', NULL, NULL, 10673, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:47:42', 'admin-1499043648-14990464620786776', 1, 1, 'SR', NULL, NULL, NULL),
(36611, '2017-07-03 09:47:42', NULL, NULL, 10673, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:47:42', 'admin-1499043648-14990464620786776', 1, 1, 'SR', NULL, NULL, NULL),
(36612, '2017-07-03 09:47:42', NULL, NULL, 10673, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:47:42', 'admin-1499043648-14990464620786776', 1, 1, 'SR', NULL, NULL, NULL),
(36613, '2017-07-03 09:47:42', NULL, NULL, 10673, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:47:42', 'admin-1499043648-14990464620786776', 1, 1, 'SR', NULL, NULL, NULL),
(36614, '2017-07-03 09:47:42', NULL, NULL, 10673, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:47:42', 'admin-1499043648-14990464620786776', 1, 1, 'SR', NULL, NULL, NULL),
(36615, '2017-07-03 10:10:45', NULL, NULL, 10674, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:10:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36616, '2017-07-03 09:09:40', NULL, NULL, 10670, 0, 181, '116', 'Open Food ', 'junior blt', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:09:40', 'admin-1499043648-14990441798535760', 1, 0, '', NULL, NULL, NULL),
(36617, '2017-07-03 10:32:19', NULL, NULL, 10676, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:32:19', 'admin-1499047855-14990491390201133', 1, 1, 'SR', NULL, NULL, NULL),
(36618, '2017-07-03 10:10:50', NULL, NULL, 10674, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 10:10:50', 'admin-1499043648-14990478500097298', 1, 0, '', NULL, NULL, NULL),
(36619, '2017-07-03 09:47:14', NULL, NULL, 10673, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.60, 0.0000, 0.0000, 16.60, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:47:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36620, '2017-07-03 09:47:42', NULL, NULL, 10673, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:47:42', 'admin-1499043648-14990464620786776', 1, 0, '', NULL, NULL, NULL),
(36621, '2017-07-03 09:35:36', NULL, NULL, 10672, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:35:36', 'admin-1499043648-14990457360494149', 1, 1, 'SR', NULL, NULL, NULL),
(36622, '2017-07-03 09:35:36', NULL, NULL, 10672, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:35:36', 'admin-1499043648-14990457360494149', 1, 0, '', NULL, NULL, NULL),
(36623, '2017-07-03 09:35:36', NULL, NULL, 10672, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:35:36', 'admin-1499043648-14990457360494149', 1, 1, 'SR', NULL, NULL, NULL),
(36624, '2017-07-03 09:15:21', NULL, NULL, 10671, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:15:21', 'admin-1499043648-14990445213858057', 1, 0, '', NULL, NULL, NULL),
(36625, '2017-07-03 09:35:36', NULL, NULL, 10672, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:35:36', 'admin-1499043648-14990457360494149', 1, 0, '', NULL, NULL, NULL),
(36626, '2017-07-03 09:15:08', NULL, NULL, 10671, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:15:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36627, '2017-07-03 09:15:21', NULL, NULL, 10671, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:15:21', 'admin-1499043648-14990445213858057', 1, 0, '', NULL, NULL, NULL),
(36628, '2017-07-03 09:09:44', NULL, NULL, 10670, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:09:44', 'admin-1499043648-14990441839556615', 1, 1, 'SR', NULL, NULL, NULL),
(36629, '2017-07-03 09:09:17', NULL, NULL, 10670, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1499056173', 'admin', '2017-07-03 09:09:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36630, '2017-07-05 11:02:36', NULL, NULL, 10693, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 11:02:36', 'admin-1499217590-14992237567124686', 1, 0, '', NULL, NULL, NULL),
(36631, '2017-07-05 11:03:19', NULL, NULL, 10693, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 11:03:19', 'admin-1499223792-14992237993184783', 1, 1, 'SR', NULL, NULL, NULL),
(36632, '2017-07-05 11:26:04', NULL, NULL, 10693, 0, 160, '94', 'Signature Dumpling (5 Pcs)', 'Takeaway', 'Meals', 'Snacks ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 11:26:04', 'admin-1499223792-1499225164357560', 1, 0, '', NULL, NULL, NULL),
(36633, '2017-07-05 11:37:25', NULL, NULL, 10696, 0, 284, '218', 'Caramel Waffles', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 11:37:25', 'admin-1499223792-14992258451526868', 1, 0, '', 1, NULL, NULL),
(36634, '2017-07-05 11:40:55', NULL, NULL, 10697, 0, 74, '74', 'Sunrice', 'Takeaway', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 11:40:55', 'admin-1499223792-14992260555185590', 1, 1, 'SR', 1, NULL, NULL),
(36635, '2017-07-05 11:53:06', NULL, NULL, 10698, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.89, 0.0000, 0.0000, 9.89, 1, '27', 1, '1499228549', 'admin', '2017-07-05 11:53:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36636, '2017-07-05 11:53:31', NULL, NULL, 10698, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 11:53:31', 'admin-1499223792-1499226811010143', 1, 0, '', NULL, NULL, NULL),
(36637, '2017-07-05 11:53:31', NULL, NULL, 10698, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 11:53:31', 'admin-1499223792-1499226811010143', 1, 0, '', NULL, NULL, NULL),
(36638, '2017-07-05 11:53:31', NULL, NULL, 10698, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 11:53:31', 'admin-1499223792-1499226811010143', 1, 0, '', NULL, NULL, NULL),
(36639, '2017-07-05 10:39:01', NULL, NULL, 10690, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 10:39:01', 'admin-1499217590-14992223416185172', 1, 0, '', NULL, NULL, NULL),
(36640, '2017-07-05 10:39:01', NULL, NULL, 10690, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 10:39:01', 'admin-1499217590-14992223416185172', 1, 0, '', NULL, NULL, NULL),
(36641, '2017-07-05 15:39:40', NULL, NULL, 10709, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 15:39:40', 'admin-1499228549-14992403807844665', 1, 1, 'SR', NULL, NULL, NULL),
(36642, '2017-07-05 14:04:14', NULL, NULL, 10707, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 14:04:14', 'admin-1499228549-14992346544711467', 1, 0, '', NULL, NULL, NULL),
(36643, '2017-07-05 12:43:04', NULL, NULL, 10702, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1499228549', 'admin', '2017-07-05 12:43:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36644, '2017-07-05 12:43:28', NULL, NULL, 10702, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 12:43:28', 'admin-1499228549-14992298086897095', 1, 0, '', NULL, NULL, NULL),
(36645, '2017-07-05 14:00:17', NULL, NULL, 10705, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1499228549', 'admin', '2017-07-05 14:00:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36646, '2017-07-05 12:43:28', NULL, NULL, 10702, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 24.0000, 0.0000, 12.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 12:43:28', 'admin-1499228549-14992298086897095', 1, 1, 'SR', NULL, NULL, NULL),
(36647, '2017-07-05 13:04:48', NULL, NULL, 10703, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 13:04:48', 'admin-1499228549-14992310883717238', 1, 1, 'SR', 1, NULL, '10.0'),
(36648, '2017-07-05 15:08:45', NULL, NULL, 10708, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 15:08:45', 'admin-1499228549-14992385252827370', 1, 1, 'SR', NULL, NULL, NULL),
(36649, '2017-07-05 10:44:01', NULL, NULL, 10691, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 10:44:01', 'admin-1499217590-14992226412243214', 1, 1, 'SR', NULL, NULL, NULL),
(36650, '2017-07-05 10:44:01', NULL, NULL, 10691, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 10:44:01', 'admin-1499217590-14992226412243214', 1, 0, '', NULL, NULL, NULL),
(36651, '2017-07-05 10:44:01', NULL, NULL, 10691, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 10:44:01', 'admin-1499217590-14992226412243214', 1, 0, '', NULL, NULL, NULL),
(36652, '2017-07-05 11:19:00', NULL, NULL, 10694, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 11:19:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36653, '2017-07-05 11:19:09', NULL, NULL, 10694, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 11:19:09', 'admin-1499223792-14992247497138696', 1, 0, '', NULL, NULL, NULL),
(36654, '2017-07-05 11:19:09', NULL, NULL, 10694, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 11:19:09', 'admin-1499223792-14992247497138696', 1, 1, 'SR', NULL, NULL, NULL),
(36655, '2017-07-05 11:20:49', NULL, NULL, 10695, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1499228549', 'admin', '2017-07-05 11:20:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36656, '2017-07-05 11:20:54', NULL, NULL, 10695, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 11:20:54', 'admin-1499223792-14992248546556442', 1, 1, 'SR', NULL, NULL, NULL),
(36657, '2017-07-05 14:04:14', NULL, NULL, 10707, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 14:04:14', 'admin-1499228549-14992346544711467', 1, 0, '', NULL, NULL, NULL),
(36658, '2017-07-05 14:04:14', NULL, NULL, 10707, 0, 182, '117', 'Open Drinks ', 'apple', 'Cold Drinks', 'Fresh Juice', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 14:04:14', 'admin-1499228549-14992346544711467', 1, 0, '', NULL, NULL, NULL),
(36659, '2017-07-05 00:00:00', NULL, NULL, 10705, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 12:43:28', 'admin-1499228549-14992298086897095', 1, 0, '', NULL, NULL, NULL),
(36660, '2017-07-05 00:00:00', NULL, NULL, 10705, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 14:00:03', 'admin-1499228549-14992344035704050', 1, 1, 'SR', NULL, NULL, NULL),
(36661, '2017-07-05 14:01:55', NULL, NULL, 10706, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1499228549', 'admin', '2017-07-05 14:01:55', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(36662, '2017-07-05 14:02:05', NULL, NULL, 10706, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 14:02:05', 'admin-1499228549-14992345249423119', 1, 0, '', NULL, NULL, '10.0'),
(36663, '2017-07-05 13:04:48', NULL, NULL, 10703, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 13:04:48', 'admin-1499228549-14992310883717238', 1, 1, 'SR', 1, NULL, '10.0'),
(36664, '2017-07-05 15:39:40', NULL, NULL, 10709, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 15:39:40', 'admin-1499228549-14992403807844665', 1, 1, 'SR', NULL, NULL, NULL),
(36665, '2017-07-05 10:50:46', NULL, NULL, 10692, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 10:50:46', 'admin-1499217590-14992230461048189', 1, 0, '', NULL, NULL, NULL),
(36666, '2017-07-05 10:50:46', NULL, NULL, 10692, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 10:50:46', 'admin-1499217590-14992230461048189', 1, 0, '', NULL, NULL, NULL),
(36667, '2017-07-05 10:50:46', NULL, NULL, 10692, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 10:50:46', 'admin-1499217590-14992230461048189', 1, 1, 'SR', NULL, NULL, NULL),
(36668, '2017-07-05 10:50:46', NULL, NULL, 10692, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 10:50:46', 'admin-1499217590-14992230461048189', 1, 0, '', NULL, NULL, NULL),
(36669, '2017-07-05 11:02:03', NULL, NULL, 10693, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1499228549', 'admin', '2017-07-05 11:02:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36670, '2017-07-05 11:02:06', NULL, NULL, 10693, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 11:02:06', 'admin-1499217590-14992237259659418', 1, 0, '', NULL, NULL, NULL),
(36671, '2017-07-05 15:39:33', NULL, NULL, 10709, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1499228549', 'admin', '2017-07-05 15:39:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36672, '2017-07-05 14:02:15', NULL, NULL, 10706, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 14:02:15', 'admin-1499228549-14992345350223553', 1, 1, 'SR', NULL, NULL, '10.0'),
(36673, '2017-07-05 14:04:46', NULL, NULL, 10708, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1499228549', 'admin', '2017-07-05 14:04:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36674, '2017-07-05 14:04:51', NULL, NULL, 10708, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 14:04:51', 'admin-1499228549-1499234690998543', 1, 1, 'SR', NULL, NULL, NULL),
(36675, '2017-07-05 14:03:54', NULL, NULL, 10707, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 14:03:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36676, '2017-07-05 14:04:14', NULL, NULL, 10707, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 14:04:14', 'admin-1499228549-14992346544711467', 1, 1, 'SR', NULL, NULL, NULL),
(36677, '2017-07-05 11:53:42', NULL, NULL, 10698, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 11:53:42', 'admin-1499223792-14992268220392174', 1, 1, 'SR', NULL, NULL, NULL),
(36678, '2017-07-05 11:53:42', NULL, NULL, 10698, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 11:53:42', 'admin-1499223792-14992268220392174', 1, 1, 'SR', NULL, NULL, NULL),
(36679, '2017-07-05 12:39:32', NULL, NULL, 10698, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1499228549', 'admin', '2017-07-05 12:39:32', 'admin-1499228549-14992295718981771', 1, 0, '', NULL, NULL, NULL),
(36680, '2017-07-05 12:36:13', NULL, NULL, 10701, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 12:36:13', 'admin-1499228549-14992293736823736', 1, 0, '', NULL, NULL, NULL),
(36681, '2017-07-05 12:35:57', NULL, NULL, 10701, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1499228549', 'admin', '2017-07-05 12:35:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36682, '2017-07-05 12:22:24', NULL, NULL, 10700, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 12:22:24', 'admin-1499223792-14992285445109356', 1, 1, 'SR', NULL, NULL, NULL),
(36683, '2017-07-05 12:22:24', NULL, NULL, 10700, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 12:22:24', 'admin-1499223792-14992285445109356', 1, 1, 'SR', NULL, NULL, NULL),
(36684, '2017-07-05 12:22:17', NULL, NULL, 10700, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1499228549', 'admin', '2017-07-05 12:22:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36685, '2017-07-05 12:20:11', NULL, NULL, 10699, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 12:20:11', 'admin-1499223792-149922841112821', 1, 1, 'SR', NULL, NULL, '10.0'),
(36686, '2017-07-05 12:19:13', NULL, NULL, 10699, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 12:19:13', 'admin-1499223792-14992283530903861', 1, 0, '', NULL, NULL, '10.0');
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(36687, '2017-07-05 12:19:13', NULL, NULL, 10699, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 12:19:13', 'admin-1499223792-14992283530903861', 1, 0, '', NULL, NULL, '10.0'),
(36688, '2017-07-05 12:19:02', NULL, NULL, 10699, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1499228549', 'admin', '2017-07-05 12:19:02', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(36689, '2017-07-05 11:53:31', NULL, NULL, 10698, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 11:53:31', 'admin-1499223792-1499226811010143', 1, 0, '', NULL, NULL, NULL),
(36690, '2017-07-05 11:02:36', NULL, NULL, 10693, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 11:02:36', 'admin-1499217590-14992237567124686', 1, 0, '', NULL, NULL, NULL),
(36691, '2017-07-05 10:50:31', NULL, NULL, 10692, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1499228549', 'admin', '2017-07-05 10:50:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36692, '2017-07-05 10:39:01', NULL, NULL, 10690, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 10:39:01', 'admin-1499217590-14992223416185172', 1, 0, '', NULL, NULL, NULL),
(36693, '2017-07-05 10:43:49', NULL, NULL, 10691, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1499228549', 'admin', '2017-07-05 10:43:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36694, '2017-07-05 10:37:35', NULL, NULL, 10690, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 10:37:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36695, '2017-07-05 10:44:01', NULL, NULL, 10691, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 10:44:01', 'admin-1499217590-14992226412243214', 1, 0, '', NULL, NULL, NULL),
(36696, '2017-07-05 10:44:01', NULL, NULL, 10691, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 10:44:01', 'admin-1499217590-14992226412243214', 1, 0, '', NULL, NULL, NULL),
(36697, '2017-07-05 10:39:01', NULL, NULL, 10690, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 10:39:01', 'admin-1499217590-14992223416185172', 1, 1, 'SR', NULL, NULL, NULL),
(36698, '2017-07-05 09:53:35', NULL, NULL, 10689, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 09:53:35', 'admin-1499217590-14992196149438657', 1, 0, '', NULL, NULL, NULL),
(36699, '2017-07-05 09:53:35', NULL, NULL, 10689, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499228549', 'admin', '2017-07-05 09:53:35', 'admin-1499217590-14992196149438657', 1, 0, '', NULL, NULL, NULL),
(36700, '2017-07-05 09:53:29', NULL, NULL, 10689, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1499228549', 'admin', '2017-07-05 09:53:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36701, '2017-07-06 14:10:15', NULL, NULL, 10732, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 14:10:15', 'admin-1499321405-1499321415744136', 1, 1, 'SR', NULL, NULL, NULL),
(36702, '2017-07-06 14:11:36', NULL, NULL, 10732, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 14:11:36', 'admin-1499321405-1499321496615964', 1, 1, 'SR', NULL, NULL, NULL),
(36703, '2017-07-06 15:40:33', NULL, NULL, 10735, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 15:40:33', 'admin-1499321405-14993268335526872', 1, 1, 'SR', NULL, NULL, NULL),
(36704, '2017-07-06 15:40:33', NULL, NULL, 10735, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 15:40:33', 'admin-1499321405-14993268335526872', 1, 0, '', NULL, NULL, NULL),
(36705, '2017-07-06 15:40:33', NULL, NULL, 10735, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 15:40:33', 'admin-1499321405-14993268335526872', 1, 0, '', NULL, NULL, NULL),
(36706, '2017-07-06 16:56:45', NULL, NULL, 10736, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 16:56:45', 'admin-1499321405-14993314052722738', 1, 1, 'SR', 1, NULL, '10.0'),
(36707, '2017-07-06 14:27:18', NULL, NULL, 10733, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1499321405', 'admin', '2017-07-06 14:27:18', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(36708, '2017-07-06 14:27:24', NULL, NULL, 10733, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 14:27:24', 'admin-1499321405-14993224445448395', 1, 0, '', NULL, NULL, '10.0'),
(36709, '2017-07-06 11:01:41', NULL, NULL, 10715, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 11:01:41', 'admin-1499309018-14993101016543414', 1, 0, '', NULL, NULL, NULL),
(36710, '2017-07-06 11:09:35', NULL, NULL, 10716, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1499321405', 'admin', '2017-07-06 11:09:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36711, '2017-07-06 11:09:43', NULL, NULL, 10716, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 11:09:43', 'admin-1499309018-14993105832786011', 1, 0, '', NULL, NULL, NULL),
(36712, '2017-07-06 11:09:43', NULL, NULL, 10716, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 11:09:43', 'admin-1499309018-14993105832786011', 1, 1, 'SR', NULL, NULL, NULL),
(36713, '2017-07-06 11:09:43', NULL, NULL, 10716, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 11:09:43', 'admin-1499309018-14993105832786011', 1, 1, 'SR', NULL, NULL, NULL),
(36714, '2017-07-06 11:39:27', NULL, NULL, 10719, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1499321405', 'admin', '2017-07-06 11:39:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36715, '2017-07-06 00:00:00', NULL, NULL, 10721, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, NULL, NULL, 1.20, 1, '27', 1, '1499321405', 'admin', '2017-07-06 11:17:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36716, '2017-07-06 11:39:47', NULL, NULL, 10720, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1499321405', 'admin', '2017-07-06 11:39:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36717, '2017-07-06 11:39:09', NULL, NULL, 10718, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1499321405', 'admin', '2017-07-06 11:39:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36718, '2017-07-06 11:38:37', NULL, NULL, 10716, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 11:38:37', 'admin-1499309018-14993123173446193', 1, 0, '', NULL, NULL, NULL),
(36719, '2017-07-06 00:00:00', NULL, NULL, 10718, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 11:17:20', 'admin-1499309018-14993110399424848', 1, 1, 'SR', NULL, NULL, NULL),
(36720, '2017-07-06 13:13:34', NULL, NULL, 10728, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1499321405', 'admin', '2017-07-06 13:13:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36721, '2017-07-06 14:09:06', NULL, NULL, 10731, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 14:09:06', 'admin-1499317491-1499321346002134', 1, 1, 'SR', NULL, NULL, NULL),
(36722, '2017-07-06 12:57:38', NULL, NULL, 10727, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 12:57:38', 'admin-1499309018-14993170584941872', 1, 0, '', NULL, NULL, NULL),
(36723, '2017-07-06 12:29:13', NULL, NULL, 10724, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 12:29:13', 'admin-1499309018-1499315353673327', 1, 0, '', NULL, NULL, '10.0'),
(36724, '2017-07-06 12:40:42', NULL, NULL, 10725, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 12:40:42', 'admin-1499309018-14993160424816718', 1, 1, 'SR', 1, NULL, NULL),
(36725, '2017-07-06 12:55:40', NULL, NULL, 10726, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1499321405', 'admin', '2017-07-06 12:55:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36726, '2017-07-06 12:55:45', NULL, NULL, 10726, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 12:55:45', 'admin-1499309018-14993169454196510', 1, 0, '', NULL, NULL, NULL),
(36727, '2017-07-06 14:01:22', NULL, NULL, 10730, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 14:01:22', 'admin-1499317491-14993208826919876', 1, 0, '', NULL, NULL, NULL),
(36728, '2017-07-06 14:09:00', NULL, NULL, 10731, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1499321405', 'admin', '2017-07-06 14:09:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36729, '2017-07-06 09:59:54', NULL, NULL, 10711, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 09:59:54', 'admin-1499303022-1499306394526664', 1, 1, 'SR', NULL, NULL, NULL),
(36730, '2017-07-06 10:04:39', NULL, NULL, 10712, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1499321405', 'admin', '2017-07-06 10:04:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36731, '2017-07-06 10:04:46', NULL, NULL, 10712, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 10:04:46', 'admin-1499303022-1499306686115613', 1, 0, '', NULL, NULL, NULL),
(36732, '2017-07-06 10:04:53', NULL, NULL, 10712, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 10:04:53', 'admin-1499303022-14993066937969853', 1, 1, 'SR', NULL, NULL, NULL),
(36733, '2017-07-06 10:19:33', NULL, NULL, 10713, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1499321405', 'admin', '2017-07-06 10:19:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36734, '2017-07-06 10:19:39', NULL, NULL, 10713, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 10:19:39', 'admin-1499303022-1499307579288326', 1, 0, '', NULL, NULL, NULL),
(36735, '2017-07-06 10:19:39', NULL, NULL, 10713, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 10:19:39', 'admin-1499303022-1499307579288326', 1, 0, '', NULL, NULL, NULL),
(36736, '2017-07-06 13:58:20', NULL, NULL, 10730, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 13:58:20', 'admin-1499317491-14993207006225055', 1, 1, 'SR', NULL, NULL, NULL),
(36737, '2017-07-06 13:57:43', NULL, NULL, 10730, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 13:57:43', 'admin-1499317491-1499320663590882', 1, 1, 'SR', NULL, NULL, NULL),
(36738, '2017-07-06 13:57:03', NULL, NULL, 10730, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 13:57:03', 'admin-1499317491-14993206237024379', 1, 0, '', NULL, NULL, NULL),
(36739, '2017-07-06 13:57:43', NULL, NULL, 10730, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 13:57:43', 'admin-1499317491-1499320663590882', 1, 1, 'SR', NULL, NULL, NULL),
(36740, '2017-07-06 13:55:32', NULL, NULL, 10730, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 13:55:32', 'admin-1499317491-14993205320144885', 1, 1, 'SR', NULL, NULL, NULL),
(36741, '2017-07-06 13:55:32', NULL, NULL, 10730, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 13:55:32', 'admin-1499317491-14993205320144885', 1, 0, '', NULL, NULL, NULL),
(36742, '2017-07-06 13:13:54', NULL, NULL, 10728, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 13:13:54', 'admin-1499317491-14993180338684741', 1, 1, 'SR', NULL, NULL, NULL),
(36743, '2017-07-06 17:48:59', NULL, NULL, 10739, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 17:48:59', 'admin-1499321405-14993345391582438', 1, 1, 'SR', 1, NULL, '10.0'),
(36744, '2017-07-06 17:22:30', NULL, NULL, 10737, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1499321405', 'admin', '2017-07-06 17:22:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36745, '2017-07-06 17:22:36', NULL, NULL, 10737, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 17:22:36', 'admin-1499321405-14993329564283668', 1, 0, '', NULL, NULL, NULL),
(36746, '2017-07-06 17:22:36', NULL, NULL, 10737, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 17:22:36', 'admin-1499321405-14993329564283668', 1, 1, 'SR', NULL, NULL, NULL),
(36747, '2017-07-06 17:35:00', NULL, NULL, 10738, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1499321405', 'admin', '2017-07-06 17:35:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36748, '2017-07-06 17:35:04', NULL, NULL, 10738, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 17:35:04', 'admin-1499321405-14993337044966775', 1, 1, 'SR', NULL, NULL, NULL),
(36749, '2017-07-06 17:35:04', NULL, NULL, 10738, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 17:35:04', 'admin-1499321405-14993337044966775', 1, 1, 'SR', NULL, NULL, NULL),
(36750, '2017-07-06 15:40:28', NULL, NULL, 10735, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1499321405', 'admin', '2017-07-06 15:40:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36751, '2017-07-06 14:57:28', NULL, NULL, 10734, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 14:57:28', 'admin-1499321405-14993242486223663', 1, 1, 'SR', NULL, NULL, NULL),
(36752, '2017-07-06 14:57:13', NULL, NULL, 10734, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1499321405', 'admin', '2017-07-06 14:57:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36753, '2017-07-06 14:09:06', NULL, NULL, 10731, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 14:09:06', 'admin-1499317491-1499321346002134', 1, 0, '', NULL, NULL, NULL),
(36754, '2017-07-06 14:27:28', NULL, NULL, 10733, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 14:27:28', 'admin-1499321405-14993224483815484', 1, 1, 'SR', NULL, NULL, '10.0'),
(36755, '2017-07-06 14:27:24', NULL, NULL, 10733, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 14:27:24', 'admin-1499321405-14993224445448395', 1, 0, '', NULL, NULL, '10.0'),
(36756, '2017-07-06 14:10:09', NULL, NULL, 10732, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1499321405', 'admin', '2017-07-06 14:10:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36757, '2017-07-06 14:10:15', NULL, NULL, 10732, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 14:10:15', 'admin-1499321405-1499321415744136', 1, 1, 'SR', NULL, NULL, NULL),
(36758, '2017-07-06 13:13:54', NULL, NULL, 10728, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 13:13:54', 'admin-1499317491-14993180338684741', 1, 1, 'SR', NULL, NULL, NULL),
(36759, '2017-07-06 13:55:27', NULL, NULL, 10730, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1499321405', 'admin', '2017-07-06 13:55:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36760, '2017-07-06 13:42:11', NULL, NULL, 10729, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1499321405', 'admin', '2017-07-06 13:42:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36761, '2017-07-06 13:42:16', NULL, NULL, 10729, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 13:42:16', 'admin-1499317491-14993197358101311', 1, 0, '', NULL, NULL, NULL),
(36762, '2017-07-06 13:42:16', NULL, NULL, 10729, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 13:42:16', 'admin-1499317491-14993197358101311', 1, 1, 'SR', NULL, NULL, NULL),
(36763, '2017-07-06 13:48:16', NULL, NULL, 10724, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 13:48:16', 'admin-1499317491-14993200959793953', 1, 0, '', NULL, NULL, '10.0'),
(36764, '2017-07-06 10:43:33', NULL, NULL, 10714, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 10:43:33', 'admin-1499303022-14993090132965789', 1, 0, '', NULL, NULL, NULL),
(36765, '2017-07-06 10:40:39', NULL, NULL, 10714, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 10:40:39', 'admin-1499303022-14993088396502378', 1, 0, '', NULL, NULL, NULL),
(36766, '2017-07-06 10:40:39', NULL, NULL, 10714, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 10:40:39', 'admin-1499303022-14993088396502378', 1, 1, 'SR', NULL, NULL, NULL),
(36767, '2017-07-06 10:40:39', NULL, NULL, 10714, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 10:40:39', 'admin-1499303022-14993088396502378', 1, 1, 'SR', NULL, NULL, NULL),
(36768, '2017-07-06 11:01:31', NULL, NULL, 10715, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 11:01:31', 'admin-1499309018-14993100911638057', 1, 0, '', NULL, NULL, NULL),
(36769, '2017-07-06 11:01:41', NULL, NULL, 10715, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 11:01:41', 'admin-1499309018-14993101016543414', 1, 0, '', NULL, NULL, NULL),
(36770, '2017-07-06 11:01:41', NULL, NULL, 10715, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 11:01:41', 'admin-1499309018-14993101016543414', 1, 1, 'SR', NULL, NULL, NULL),
(36771, '2017-07-06 12:57:47', NULL, NULL, 10727, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 12:57:47', 'admin-1499309018-14993170671957778', 1, 1, 'SR', NULL, NULL, NULL),
(36772, '2017-07-06 13:04:46', NULL, NULL, 10724, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 13:04:46', 'admin-1499309018-14993174861471972', 1, 1, 'SR', NULL, NULL, '10.0'),
(36773, '2017-07-06 12:57:38', NULL, NULL, 10727, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 12:57:38', 'admin-1499309018-14993170584941872', 1, 0, '', NULL, NULL, NULL),
(36774, '2017-07-06 12:57:47', NULL, NULL, 10727, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 12:57:47', 'admin-1499309018-14993170671957778', 1, 1, 'SR', NULL, NULL, NULL),
(36775, '2017-07-06 12:57:27', NULL, NULL, 10727, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1499321405', 'admin', '2017-07-06 12:57:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36776, '2017-07-06 12:28:23', NULL, NULL, 10724, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 12:28:23', 'admin-1499309018-1499315303194118', 1, 1, 'SR', NULL, NULL, '10.0'),
(36777, '2017-07-06 12:28:16', NULL, NULL, 10724, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1499321405', 'admin', '2017-07-06 12:28:16', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(36778, '2017-07-06 12:28:23', NULL, NULL, 10724, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 12:28:23', 'admin-1499309018-1499315303194118', 1, 1, 'SR', NULL, NULL, '10.0'),
(36779, '2017-07-06 12:24:09', NULL, NULL, 10723, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 12:24:09', 'admin-1499309018-14993150492977296', 1, 1, 'SR', NULL, NULL, NULL),
(36780, '2017-07-06 12:24:09', NULL, NULL, 10723, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 12:24:09', 'admin-1499309018-14993150492977296', 1, 1, 'SR', NULL, NULL, NULL),
(36781, '2017-07-06 12:24:05', NULL, NULL, 10723, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1499321405', 'admin', '2017-07-06 12:24:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36782, '2017-07-06 11:57:56', NULL, NULL, 10722, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 11:57:56', 'admin-1499309018-14993134763798932', 1, 1, 'SR', 1, NULL, NULL),
(36783, '2017-07-06 00:00:00', NULL, NULL, 10719, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 11:17:20', 'admin-1499309018-14993110399424848', 1, 1, 'SR', NULL, NULL, NULL),
(36784, '2017-07-06 00:00:00', NULL, NULL, 10720, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 11:17:20', 'admin-1499309018-14993110399424848', 1, 1, 'SR', NULL, NULL, NULL),
(36785, '2017-07-06 00:00:00', NULL, NULL, 10721, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 11:17:20', 'admin-1499309018-14993110399424848', 1, 1, 'SR', NULL, NULL, NULL),
(36786, '2017-07-06 11:57:56', NULL, NULL, 10722, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 11:57:56', 'admin-1499309018-14993134763798932', 1, 1, 'SR', 1, NULL, NULL),
(36787, '2017-07-06 12:55:45', NULL, NULL, 10726, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 12:55:45', 'admin-1499309018-14993169454196510', 1, 1, 'SR', NULL, NULL, NULL),
(36788, '2017-07-06 10:39:39', NULL, NULL, 10714, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1499321405', 'admin', '2017-07-06 10:39:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36789, '2017-07-06 11:01:25', NULL, NULL, 10715, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1499321405', 'admin', '2017-07-06 11:01:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36790, '2017-07-06 11:01:31', NULL, NULL, 10715, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 11:01:31', 'admin-1499309018-14993100911638057', 1, 0, '', NULL, NULL, NULL),
(36791, '2017-07-06 09:59:54', NULL, NULL, 10711, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 09:59:54', 'admin-1499303022-1499306394526664', 1, 0, '', NULL, NULL, NULL),
(36792, '2017-07-06 09:59:54', NULL, NULL, 10711, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 09:59:54', 'admin-1499303022-1499306394526664', 1, 0, '', NULL, NULL, NULL),
(36793, '2017-07-06 09:45:00', NULL, NULL, 10710, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 09:45:00', 'admin-1499303022-14993054998474013', 1, 0, '', NULL, NULL, NULL),
(36794, '2017-07-06 10:19:45', NULL, NULL, 10713, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 10:19:45', 'admin-1499303022-14993075852147827', 1, 1, 'SR', NULL, NULL, NULL),
(36795, '2017-07-06 10:19:45', NULL, NULL, 10713, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 10:19:45', 'admin-1499303022-14993075852147827', 1, 1, 'SR', NULL, NULL, NULL),
(36796, '2017-07-06 09:59:54', NULL, NULL, 10711, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 09:59:54', 'admin-1499303022-1499306394526664', 1, 1, 'SR', NULL, NULL, NULL),
(36797, '2017-07-06 09:59:47', NULL, NULL, 10711, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 09:59:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36798, '2017-07-06 09:45:00', NULL, NULL, 10710, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499321405', 'admin', '2017-07-06 09:45:00', 'admin-1499303022-14993054998474013', 1, 0, '', NULL, NULL, NULL),
(36799, '2017-07-06 09:44:54', NULL, NULL, 10710, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1499321405', 'admin', '2017-07-06 09:44:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36800, '2017-07-07 15:08:00', NULL, NULL, 10785, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 2, 11.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:08:00', 'admin-1499407772-1499411279955952', 1, 1, 'SR', NULL, NULL, '10.0'),
(36801, '2017-07-07 13:28:21', NULL, NULL, 10775, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:28:21', 'admin-1499404413-14994053008467962', 1, 1, 'SR', 1, NULL, NULL),
(36802, '2017-07-07 13:30:23', NULL, NULL, 10776, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:30:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36803, '2017-07-07 13:31:03', NULL, NULL, 10776, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:31:03', 'admin-1499404413-149940546345248', 1, 1, 'SR', NULL, NULL, NULL),
(36804, '2017-07-07 13:31:03', NULL, NULL, 10776, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:31:03', 'admin-1499404413-149940546345248', 1, 1, 'SR', NULL, NULL, NULL),
(36805, '2017-07-07 13:31:03', NULL, NULL, 10776, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:31:03', 'admin-1499404413-149940546345248', 1, 1, 'SR', NULL, NULL, NULL),
(36806, '2017-07-07 13:31:03', NULL, NULL, 10776, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:31:03', 'admin-1499404413-149940546345248', 1, 0, '', NULL, NULL, NULL),
(36807, '2017-07-07 14:08:10', NULL, NULL, 10780, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 14:08:10', 'admin-1499404413-1499407690265883', 1, 0, '', NULL, NULL, NULL),
(36808, '2017-07-07 14:24:46', NULL, NULL, 10782, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 14:24:46', 'admin-1499407772-14994086861275535', 1, 0, '', NULL, NULL, NULL),
(36809, '2017-07-07 14:24:54', NULL, NULL, 10782, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 14:24:54', 'admin-1499407772-14994086939694310', 1, 1, 'SR', NULL, NULL, NULL),
(36810, '2017-07-07 14:24:54', NULL, NULL, 10782, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 14:24:54', 'admin-1499407772-14994086939694310', 1, 1, 'SR', NULL, NULL, NULL),
(36811, '2017-07-07 13:54:49', NULL, NULL, 10779, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:54:49', 'admin-1499404413-14994068887706789', 1, 0, '', NULL, NULL, NULL),
(36812, '2017-07-07 13:41:28', NULL, NULL, 10771, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:41:28', 'admin-1499404413-1499406087951944', 1, 1, 'SR', NULL, NULL, NULL),
(36813, '2017-07-07 00:00:00', NULL, NULL, 10793, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:25:19', 'admin-1499407772-14994123196419471', 1, 0, '', NULL, NULL, NULL),
(36814, '2017-07-07 00:00:00', NULL, NULL, 10792, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:25:38', 'admin-1499407772-14994123378683159', 1, 1, 'SR', NULL, NULL, NULL),
(36815, '2017-07-07 00:00:00', NULL, NULL, 10793, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:25:38', 'admin-1499407772-14994123378683159', 1, 1, 'SR', NULL, NULL, NULL),
(36816, '2017-07-07 13:41:03', NULL, NULL, 10771, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:41:03', 'admin-1499404413-14994060627963798', 1, 1, 'SR', NULL, NULL, NULL),
(36817, '2017-07-07 13:41:03', NULL, NULL, 10771, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:41:03', 'admin-1499404413-14994060627963798', 1, 0, '', NULL, NULL, NULL),
(36818, '2017-07-07 13:49:43', NULL, NULL, 10777, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:49:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36819, '2017-07-07 12:06:44', NULL, NULL, 10758, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:06:44', 'admin-1499398762-14994004047218535', 1, 0, '', NULL, NULL, NULL),
(36820, '2017-07-07 12:18:15', NULL, NULL, 10761, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.20, 0.0000, 0.0000, 9.20, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:18:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36821, '2017-07-07 11:55:47', NULL, NULL, 10760, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:55:47', 'admin-1499398762-14993997472122716', 1, 0, '', NULL, NULL, NULL),
(36822, '2017-07-07 11:55:36', NULL, NULL, 10760, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:55:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36823, '2017-07-07 00:00:00', NULL, NULL, 10793, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, NULL, NULL, 6.50, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:25:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36824, '2017-07-07 00:00:00', NULL, NULL, 10793, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:25:19', 'admin-1499407772-14994123196419471', 1, 0, '', NULL, NULL, NULL),
(36825, '2017-07-07 13:01:43', NULL, NULL, 10764, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:01:43', 'admin-1499401813-14994037030891516', 1, 0, '', NULL, NULL, NULL),
(36826, '2017-07-07 13:13:20', NULL, NULL, 10769, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:13:20', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(36827, '2017-07-07 13:13:28', NULL, NULL, 10769, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:13:28', 'admin-1499401813-14994044085714336', 1, 0, '', NULL, NULL, '10.0'),
(36828, '2017-07-07 13:13:28', NULL, NULL, 10769, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:13:28', 'admin-1499401813-14994044085714336', 1, 0, '', NULL, NULL, '10.0'),
(36829, '2017-07-07 13:13:50', NULL, NULL, 10761, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:13:50', 'admin-1499404413-14994044307108793', 1, 1, 'SR', NULL, NULL, NULL),
(36830, '2017-07-07 13:54:49', NULL, NULL, 10779, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:54:49', 'admin-1499404413-14994068887706789', 1, 1, 'SR', NULL, NULL, NULL),
(36831, '2017-07-07 13:50:06', NULL, NULL, 10777, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:50:06', 'admin-1499404413-14994066058587659', 1, 0, '', NULL, NULL, NULL),
(36832, '2017-07-07 13:51:33', NULL, NULL, 10777, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:51:33', 'admin-1499404413-14994066931422798', 1, 1, 'SR', NULL, NULL, NULL),
(36833, '2017-07-07 13:51:33', NULL, NULL, 10777, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:51:33', 'admin-1499404413-14994066931422798', 1, 1, 'SR', NULL, NULL, NULL),
(36834, '2017-07-07 13:51:41', NULL, NULL, 10776, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:51:41', 'admin-1499404413-14994067014929894', 1, 1, 'SR', NULL, NULL, NULL),
(36835, '2017-07-07 13:51:45', NULL, NULL, 10778, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:51:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36836, '2017-07-07 13:51:50', NULL, NULL, 10778, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:51:50', 'admin-1499404413-14994067107975758', 1, 1, 'SR', NULL, NULL, NULL),
(36837, '2017-07-07 17:01:24', NULL, NULL, 10794, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 17:01:24', 'admin-1499407772-14994180839777327', 1, 0, '', NULL, NULL, NULL),
(36838, '2017-07-07 17:01:24', NULL, NULL, 10794, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 17:01:24', 'admin-1499407772-14994180839777327', 1, 0, '', NULL, NULL, NULL),
(36839, '2017-07-07 17:01:24', NULL, NULL, 10794, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 17:01:24', 'admin-1499407772-14994180839777327', 1, 1, 'SR', NULL, NULL, NULL),
(36840, '2017-07-07 11:53:10', NULL, NULL, 10758, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:53:10', 'admin-1499398762-14993995902052970', 1, 0, '', NULL, NULL, NULL),
(36841, '2017-07-07 11:53:10', NULL, NULL, 10758, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:53:10', 'admin-1499398762-14993995902052970', 1, 0, '', NULL, NULL, NULL),
(36842, '2017-07-07 11:53:10', NULL, NULL, 10758, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:53:10', 'admin-1499398762-14993995902052970', 1, 0, '', NULL, NULL, NULL),
(36843, '2017-07-07 11:33:27', NULL, NULL, 10756, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:33:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36844, '2017-07-07 10:44:04', NULL, NULL, 10751, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:44:04', 'admin-1499394285-1499395444312128', 1, 1, 'SR', NULL, NULL, NULL),
(36845, '2017-07-07 15:56:19', NULL, NULL, 10790, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:56:19', 'admin-1499407772-1499414179196746', 1, 1, 'SR', NULL, NULL, NULL),
(36846, '2017-07-07 14:55:02', NULL, NULL, 10782, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 14:55:02', 'admin-1499407772-14994105023202746', 1, 0, '', NULL, NULL, NULL),
(36847, '2017-07-07 15:25:00', NULL, NULL, 10787, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:25:00', 'admin-1499407772-14994123006351197', 1, 0, '', NULL, NULL, NULL),
(36848, '2017-07-07 15:25:00', NULL, NULL, 10787, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:25:00', 'admin-1499407772-14994123006351197', 1, 1, 'SR', NULL, NULL, NULL),
(36849, '2017-07-07 15:25:00', NULL, NULL, 10787, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:25:00', 'admin-1499407772-14994123006351197', 1, 0, '', NULL, NULL, NULL),
(36850, '2017-07-07 10:23:44', NULL, NULL, 10749, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:23:44', 'admin-1499387663-14993942244041291', 1, 0, '', NULL, NULL, NULL),
(36851, '2017-07-07 10:23:44', NULL, NULL, 10749, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:23:44', 'admin-1499387663-14993942244041291', 1, 1, 'SR', NULL, NULL, NULL),
(36852, '2017-07-07 11:53:10', NULL, NULL, 10758, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:53:10', 'admin-1499398762-14993995902052970', 1, 0, '', NULL, NULL, NULL),
(36853, '2017-07-07 11:53:10', NULL, NULL, 10758, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:53:10', 'admin-1499398762-14993995902052970', 1, 0, '', NULL, NULL, NULL),
(36854, '2017-07-07 11:39:41', NULL, NULL, 10759, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:39:41', 'admin-1499398762-14993987816758842', 1, 0, '', NULL, NULL, NULL),
(36855, '2017-07-07 11:39:41', NULL, NULL, 10759, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:39:41', 'admin-1499398762-14993987816758842', 1, 1, 'SR', NULL, NULL, NULL),
(36856, '2017-07-07 09:39:41', NULL, NULL, 10743, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:39:41', 'admin-1499387663-14993915808945448', 1, 0, '', NULL, NULL, NULL),
(36857, '2017-07-07 09:42:44', NULL, NULL, 10744, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:42:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36858, '2017-07-07 09:42:52', NULL, NULL, 10744, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:42:52', 'admin-1499387663-14993917725342193', 1, 0, '', NULL, NULL, NULL),
(36859, '2017-07-07 09:42:52', NULL, NULL, 10744, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:42:52', 'admin-1499387663-14993917725342193', 1, 0, '', NULL, NULL, NULL),
(36860, '2017-07-07 09:39:32', NULL, NULL, 10743, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:39:32', 'admin-1499387663-1499391572280496', 1, 0, '', NULL, NULL, NULL),
(36861, '2017-07-07 13:50:06', NULL, NULL, 10777, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:50:06', 'admin-1499404413-14994066058587659', 1, 1, 'SR', NULL, NULL, NULL),
(36862, '2017-07-07 15:07:52', NULL, NULL, 10785, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:07:52', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(36863, '2017-07-07 14:35:21', NULL, NULL, 10783, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 14:35:21', 'admin-1499407772-14994093211289323', 1, 0, '', NULL, NULL, NULL),
(36864, '2017-07-07 14:35:38', NULL, NULL, 10783, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 14:35:38', 'admin-1499407772-14994093379504470', 1, 1, 'SR', NULL, NULL, NULL),
(36865, '2017-07-07 00:00:00', NULL, NULL, 10793, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:25:38', 'admin-1499407772-14994123378683159', 1, 1, 'SR', NULL, NULL, NULL),
(36866, '2017-07-07 17:01:14', NULL, NULL, 10794, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1499407772', 'admin', '2017-07-07 17:01:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36867, '2017-07-07 16:10:01', NULL, NULL, 10791, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1499407772', 'admin', '2017-07-07 16:10:01', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(36868, '2017-07-07 16:10:10', NULL, NULL, 10791, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 16:10:10', 'admin-1499407772-14994150101848945', 1, 1, 'SR', NULL, NULL, '10.0'),
(36869, '2017-07-07 00:00:00', NULL, NULL, 10792, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:25:19', 'admin-1499407772-14994123196419471', 1, 0, '', NULL, NULL, NULL),
(36870, '2017-07-07 15:52:05', NULL, NULL, 10787, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:52:05', 'admin-1499407772-14994139250541389', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(36871, '2017-07-07 15:56:15', NULL, NULL, 10790, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:56:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36872, '2017-07-07 15:27:00', NULL, NULL, 10789, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:27:00', 'admin-1499407772-14994124200773921', 1, 0, '', NULL, NULL, NULL),
(36873, '2017-07-07 15:27:00', NULL, NULL, 10789, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:27:00', 'admin-1499407772-14994124200773921', 1, 1, 'SR', NULL, NULL, NULL),
(36874, '2017-07-07 00:00:00', NULL, NULL, 10792, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:25:19', 'admin-1499407772-14994123196419471', 1, 1, 'SR', NULL, NULL, NULL),
(36875, '2017-07-07 15:26:53', NULL, NULL, 10789, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:26:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36876, '2017-07-07 15:09:18', NULL, NULL, 10786, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:09:18', 'admin-1499407772-14994113587013110', 1, 1, 'SR', 1, NULL, '10.0'),
(36877, '2017-07-07 00:00:00', NULL, NULL, 10792, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:25:38', 'admin-1499407772-14994123378683159', 1, 1, 'SR', NULL, NULL, NULL),
(36878, '2017-07-07 16:10:54', NULL, NULL, 10792, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1499407772', 'admin', '2017-07-07 16:10:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36879, '2017-07-07 13:15:28', NULL, NULL, 10770, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:15:28', 'admin-1499404413-14994045278325990', 1, 0, '', NULL, NULL, NULL),
(36880, '2017-07-07 13:15:30', NULL, NULL, 10771, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.00, 0.0000, 0.0000, 14.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:15:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36881, '2017-07-07 13:52:54', NULL, NULL, 10779, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:52:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36882, '2017-07-07 15:09:18', NULL, NULL, 10786, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:09:18', 'admin-1499407772-14994113587013110', 1, 1, 'SR', 1, NULL, '10.0'),
(36883, '2017-07-07 15:25:00', NULL, NULL, 10787, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:25:00', 'admin-1499407772-14994123006351197', 1, 1, 'SR', NULL, NULL, NULL),
(36884, '2017-07-07 14:34:38', NULL, NULL, 10783, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1499407772', 'admin', '2017-07-07 14:34:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36885, '2017-07-07 15:08:00', NULL, NULL, 10785, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:08:00', 'admin-1499407772-1499411279955952', 1, 1, 'SR', NULL, NULL, '10.0'),
(36886, '2017-07-07 15:05:06', NULL, NULL, 10784, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:05:06', 'admin-1499407772-1499411106265769', 1, 0, '', NULL, NULL, NULL),
(36887, '2017-07-07 15:05:03', NULL, NULL, 10784, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:05:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36888, '2017-07-07 15:05:06', NULL, NULL, 10784, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:05:06', 'admin-1499407772-1499411106265769', 1, 0, '', NULL, NULL, NULL),
(36889, '2017-07-07 15:24:45', NULL, NULL, 10787, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1499407772', 'admin', '2017-07-07 15:24:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36890, '2017-07-07 14:35:38', NULL, NULL, 10783, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 14:35:38', 'admin-1499407772-14994093379504470', 1, 1, 'SR', NULL, NULL, NULL),
(36891, '2017-07-07 14:35:21', NULL, NULL, 10783, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 14:35:21', 'admin-1499407772-14994093211289323', 1, 1, 'SR', NULL, NULL, NULL),
(36892, '2017-07-07 14:24:46', NULL, NULL, 10782, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 14:24:46', 'admin-1499407772-14994086861275535', 1, 0, '', NULL, NULL, NULL),
(36893, '2017-07-07 14:24:38', NULL, NULL, 10782, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1499407772', 'admin', '2017-07-07 14:24:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36894, '2017-07-07 14:09:20', NULL, NULL, 10781, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 14:09:20', 'admin-1499404413-14994077598366943', 1, 0, '', NULL, NULL, '10.0'),
(36895, '2017-07-07 14:08:27', NULL, NULL, 10780, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 14:08:27', 'admin-1499404413-1499407707447594', 1, 0, '', NULL, NULL, NULL),
(36896, '2017-07-07 13:41:03', NULL, NULL, 10771, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:41:03', 'admin-1499404413-14994060627963798', 1, 0, '', NULL, NULL, NULL),
(36897, '2017-07-07 13:41:03', NULL, NULL, 10771, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:41:03', 'admin-1499404413-14994060627963798', 1, 0, '', NULL, NULL, NULL),
(36898, '2017-07-07 13:41:03', NULL, NULL, 10771, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:41:03', 'admin-1499404413-14994060627963798', 1, 0, '', NULL, NULL, NULL),
(36899, '2017-07-07 13:54:49', NULL, NULL, 10779, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:54:49', 'admin-1499404413-14994068887706789', 1, 1, 'SR', NULL, NULL, NULL),
(36900, '2017-07-07 14:08:10', NULL, NULL, 10780, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 14:08:10', 'admin-1499404413-1499407690265883', 1, 0, '', NULL, NULL, NULL),
(36901, '2017-07-07 12:44:47', NULL, NULL, 10761, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:44:47', 'admin-1499401813-1499402687113908', 1, 1, 'SR', NULL, NULL, NULL),
(36902, '2017-07-07 12:29:35', NULL, NULL, 10763, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:29:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36903, '2017-07-07 12:30:03', NULL, NULL, 10763, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:30:03', 'admin-1499398762-1499401803783996', 1, 0, '', NULL, NULL, NULL),
(36904, '2017-07-07 12:30:03', NULL, NULL, 10763, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:30:03', 'admin-1499398762-1499401803783996', 1, 0, '', NULL, NULL, NULL),
(36905, '2017-07-07 12:30:03', NULL, NULL, 10763, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:30:03', 'admin-1499398762-1499401803783996', 1, 0, '', NULL, NULL, NULL),
(36906, '2017-07-07 12:41:57', NULL, NULL, 10765, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:41:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36907, '2017-07-07 12:42:22', NULL, NULL, 10765, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:42:22', 'admin-1499401813-14994025424861776', 1, 0, '', NULL, NULL, NULL),
(36908, '2017-07-07 12:30:38', NULL, NULL, 10763, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:30:38', 'admin-1499401813-14994018383618213', 1, 1, 'SR', NULL, NULL, NULL),
(36909, '2017-07-07 11:39:41', NULL, NULL, 10759, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:39:41', 'admin-1499398762-14993987816758842', 1, 0, '', NULL, NULL, NULL),
(36910, '2017-07-07 13:31:03', NULL, NULL, 10776, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:31:03', 'admin-1499404413-149940546345248', 1, 0, '', NULL, NULL, NULL),
(36911, '2017-07-07 14:07:53', NULL, NULL, 10780, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1499407772', 'admin', '2017-07-07 14:07:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36912, '2017-07-07 13:41:02', NULL, NULL, 10771, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:41:02', 'admin-1499404413-14994060627963798', 1, 1, 'SR', NULL, NULL, NULL),
(36913, '2017-07-07 10:15:08', NULL, NULL, 10748, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:15:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36914, '2017-07-07 10:15:39', NULL, NULL, 10748, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:15:39', 'admin-1499387663-1499393739313643', 1, 0, '', NULL, NULL, NULL),
(36915, '2017-07-07 10:15:39', NULL, NULL, 10748, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:15:39', 'admin-1499387663-1499393739313643', 1, 1, 'SR', NULL, NULL, NULL),
(36916, '2017-07-07 10:20:08', NULL, NULL, 10747, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:20:08', 'admin-1499387663-14993940082786947', 1, 0, '', NULL, NULL, NULL),
(36917, '2017-07-07 13:50:06', NULL, NULL, 10777, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:50:06', 'admin-1499404413-14994066058587659', 1, 0, '', NULL, NULL, NULL),
(36918, '2017-07-07 13:50:06', NULL, NULL, 10777, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:50:06', 'admin-1499404413-14994066058587659', 1, 0, '', NULL, NULL, NULL),
(36919, '2017-07-07 12:19:22', NULL, NULL, 10761, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:19:22', 'admin-1499398762-14994011618588135', 1, 1, 'SR', NULL, NULL, NULL),
(36920, '2017-07-07 12:19:22', NULL, NULL, 10761, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:19:22', 'admin-1499398762-14994011618588135', 1, 0, '', NULL, NULL, NULL),
(36921, '2017-07-07 12:19:22', NULL, NULL, 10761, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:19:22', 'admin-1499398762-14994011618588135', 1, 0, '', NULL, NULL, NULL),
(36922, '2017-07-07 14:09:04', NULL, NULL, 10781, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1499407772', 'admin', '2017-07-07 14:09:04', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(36923, '2017-07-07 14:09:20', NULL, NULL, 10781, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 14:09:20', 'admin-1499404413-14994077598366943', 1, 0, '', NULL, NULL, '10.0'),
(36924, '2017-07-07 13:41:02', NULL, NULL, 10771, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:41:02', 'admin-1499404413-14994060627963798', 1, 0, '', NULL, NULL, NULL),
(36925, '2017-07-07 13:21:31', NULL, NULL, 10772, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:21:31', 'admin-1499404413-14994048911818726', 1, 0, '', NULL, NULL, NULL),
(36926, '2017-07-07 13:21:31', NULL, NULL, 10772, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:21:31', 'admin-1499404413-14994048911818726', 1, 1, 'SR', NULL, NULL, NULL),
(36927, '2017-07-07 13:21:12', NULL, NULL, 10772, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:21:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36928, '2017-07-07 11:55:56', NULL, NULL, 10760, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:55:56', 'admin-1499398762-14993997565449650', 1, 1, 'SR', NULL, NULL, NULL),
(36929, '2017-07-07 13:18:29', NULL, NULL, 10758, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:18:29', 'admin-1499404413-1499404708814413', 1, 0, '', NULL, NULL, NULL),
(36930, '2017-07-07 13:21:41', NULL, NULL, 10772, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:21:41', 'admin-1499404413-14994049017519384', 1, 0, '', NULL, NULL, NULL),
(36931, '2017-07-07 13:26:13', NULL, NULL, 10773, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:26:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36932, '2017-07-07 13:26:25', NULL, NULL, 10773, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:26:25', 'admin-1499404413-14994051857472558', 1, 1, 'SR', NULL, NULL, NULL),
(36933, '2017-07-07 13:26:25', NULL, NULL, 10773, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:26:25', 'admin-1499404413-14994051857472558', 1, 0, '', NULL, NULL, NULL),
(36934, '2017-07-07 13:28:06', NULL, NULL, 10774, 0, 284, '218', 'Caramel Waffles', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:28:06', 'admin-1499404413-14994052861207345', 1, 0, '', 1, NULL, NULL),
(36935, '2017-07-07 12:20:33', NULL, NULL, 10762, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:20:33', 'admin-1499398762-14994012335255578', 1, 0, '', 1, NULL, '10.0'),
(36936, '2017-07-07 12:20:33', NULL, NULL, 10762, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:20:33', 'admin-1499398762-14994012335255578', 1, 1, 'SR', 1, NULL, '10.0'),
(36937, '2017-07-07 12:21:53', NULL, NULL, 10761, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:21:53', 'admin-1499398762-14994013127735874', 1, 1, 'SR', NULL, NULL, NULL),
(36938, '2017-07-07 13:15:37', NULL, NULL, 10771, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:15:37', 'admin-1499404413-14994045371748089', 1, 1, 'SR', NULL, NULL, NULL),
(36939, '2017-07-07 13:15:37', NULL, NULL, 10771, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:15:37', 'admin-1499404413-14994045371748089', 1, 1, 'SR', NULL, NULL, NULL),
(36940, '2017-07-07 12:30:38', NULL, NULL, 10763, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:30:38', 'admin-1499401813-14994018383618213', 1, 1, 'SR', NULL, NULL, NULL),
(36941, '2017-07-07 12:34:06', NULL, NULL, 10761, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:34:06', 'admin-1499401813-14994020463101857', 1, 0, '', NULL, NULL, NULL),
(36942, '2017-07-07 12:36:58', NULL, NULL, 10764, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:36:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36943, '2017-07-07 12:37:03', NULL, NULL, 10764, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:37:03', 'admin-1499401813-14994022230658429', 1, 1, 'SR', NULL, NULL, NULL),
(36944, '2017-07-07 12:37:55', NULL, NULL, 10764, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:37:55', 'admin-1499401813-1499402275638445', 1, 0, '', NULL, NULL, NULL),
(36945, '2017-07-07 12:42:22', NULL, NULL, 10765, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:42:22', 'admin-1499401813-14994025424861776', 1, 0, '', NULL, NULL, NULL),
(36946, '2017-07-07 12:42:22', NULL, NULL, 10765, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:42:22', 'admin-1499401813-14994025424861776', 1, 0, '', NULL, NULL, NULL),
(36947, '2017-07-07 13:54:49', NULL, NULL, 10779, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:54:49', 'admin-1499404413-14994068887706789', 1, 0, '', NULL, NULL, NULL),
(36948, '2017-07-07 13:15:28', NULL, NULL, 10770, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:15:28', 'admin-1499404413-14994045278325990', 1, 1, 'SR', NULL, NULL, NULL),
(36949, '2017-07-07 13:15:20', NULL, NULL, 10770, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1499407772', 'admin', '2017-07-07 13:15:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36950, '2017-07-07 11:39:04', NULL, NULL, 10758, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:39:04', 'admin-1499394285-14993987446846870', 1, 0, '', NULL, NULL, NULL),
(36951, '2017-07-07 10:13:30', NULL, NULL, 10747, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:13:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36952, '2017-07-07 09:19:36', NULL, NULL, 10741, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:19:36', 'admin-1499387663-14993903761386314', 1, 1, 'SR', NULL, NULL, NULL),
(36953, '2017-07-07 09:20:40', NULL, NULL, 10741, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:20:40', 'admin-1499387663-14993904408252434', 1, 0, '', NULL, NULL, NULL),
(36954, '2017-07-07 09:27:56', NULL, NULL, 10742, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:27:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36955, '2017-07-07 09:28:04', NULL, NULL, 10742, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:28:04', 'admin-1499387663-14993908840095631', 1, 0, '', NULL, NULL, NULL),
(36956, '2017-07-07 09:28:04', NULL, NULL, 10742, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:28:04', 'admin-1499387663-14993908840095631', 1, 1, 'SR', NULL, NULL, NULL),
(36957, '2017-07-07 09:39:27', NULL, NULL, 10743, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:39:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36958, '2017-07-07 09:39:32', NULL, NULL, 10743, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:39:32', 'admin-1499387663-1499391572280496', 1, 0, '', NULL, NULL, NULL),
(36959, '2017-07-07 12:58:43', NULL, NULL, 10768, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:58:43', 'admin-1499401813-1499403523693361', 1, 0, '', 1, NULL, NULL),
(36960, '2017-07-07 11:39:41', NULL, NULL, 10759, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:39:41', 'admin-1499398762-14993987816758842', 1, 0, '', NULL, NULL, NULL),
(36961, '2017-07-07 12:58:06', NULL, NULL, 10767, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:58:06', 'admin-1499401813-14994034863919586', 1, 0, '', 1, NULL, NULL),
(36962, '2017-07-07 11:55:47', NULL, NULL, 10760, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:55:47', 'admin-1499398762-14993997472122716', 1, 0, '', NULL, NULL, NULL),
(36963, '2017-07-07 11:38:55', NULL, NULL, 10758, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.30, 0.0000, 0.0000, 12.30, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:38:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36964, '2017-07-07 11:36:30', NULL, NULL, 10757, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:36:30', 'admin-1499394285-14993985907291962', 1, 1, 'SR', NULL, NULL, NULL),
(36965, '2017-07-07 11:35:38', NULL, NULL, 10757, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:35:38', 'admin-1499394285-14993985378788155', 1, 0, '', NULL, NULL, NULL),
(36966, '2017-07-07 11:36:30', NULL, NULL, 10757, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:36:30', 'admin-1499394285-14993985907291962', 1, 1, 'SR', NULL, NULL, NULL),
(36967, '2017-07-07 11:35:51', NULL, NULL, 10757, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:35:51', 'admin-1499394285-14993985509287139', 1, 1, 'SR', NULL, NULL, NULL),
(36968, '2017-07-07 10:43:57', NULL, NULL, 10751, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:43:57', 'admin-1499394285-14993954372439045', 1, 0, '', NULL, NULL, NULL),
(36969, '2017-07-07 10:43:57', NULL, NULL, 10751, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:43:57', 'admin-1499394285-14993954372439045', 1, 0, '', NULL, NULL, NULL),
(36970, '2017-07-07 11:35:38', NULL, NULL, 10757, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:35:38', 'admin-1499394285-14993985378788155', 1, 1, 'SR', NULL, NULL, NULL),
(36971, '2017-07-07 11:33:41', NULL, NULL, 10756, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:33:41', 'admin-1499394285-14993984213257482', 1, 1, 'SR', NULL, NULL, NULL),
(36972, '2017-07-07 11:35:38', NULL, NULL, 10757, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:35:38', 'admin-1499394285-14993985378788155', 1, 0, '', NULL, NULL, NULL),
(36973, '2017-07-07 11:25:33', NULL, NULL, 10751, 0, 284, '218', 'Caramel Waffles', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:25:33', 'admin-1499394285-14993979331241635', 1, 0, '', NULL, NULL, NULL),
(36974, '2017-07-07 11:18:03', NULL, NULL, 10755, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:18:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36975, '2017-07-07 11:18:33', NULL, NULL, 10755, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:18:33', 'admin-1499394285-14993975136663868', 1, 0, '', NULL, NULL, NULL),
(36976, '2017-07-07 11:18:33', NULL, NULL, 10755, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:18:33', 'admin-1499394285-14993975136663868', 1, 0, '', NULL, NULL, NULL),
(36977, '2017-07-07 11:18:33', NULL, NULL, 10755, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:18:33', 'admin-1499394285-14993975136663868', 1, 0, '', NULL, NULL, NULL),
(36978, '2017-07-07 11:18:33', NULL, NULL, 10755, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:18:33', 'admin-1499394285-14993975136663868', 1, 0, '', NULL, NULL, NULL),
(36979, '2017-07-07 11:18:33', NULL, NULL, 10755, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:18:33', 'admin-1499394285-14993975136663868', 1, 0, '', NULL, NULL, NULL),
(36980, '2017-07-07 12:20:14', NULL, NULL, 10761, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:20:14', 'admin-1499398762-1499401214360428', 1, 0, '', NULL, NULL, NULL),
(36981, '2017-07-07 11:34:11', NULL, NULL, 10757, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:34:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36982, '2017-07-07 11:33:41', NULL, NULL, 10756, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:33:41', 'admin-1499394285-14993984213257482', 1, 0, '', NULL, NULL, NULL),
(36983, '2017-07-07 10:51:08', NULL, NULL, 10754, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:51:08', 'admin-1499394285-1499395868731928', 1, 1, 'SR', NULL, NULL, NULL),
(36984, '2017-07-07 10:48:40', NULL, NULL, 10752, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:48:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36985, '2017-07-07 10:48:45', NULL, NULL, 10752, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:48:45', 'admin-1499394285-14993957257541734', 1, 1, 'SR', NULL, NULL, NULL),
(36986, '2017-07-07 10:48:45', NULL, NULL, 10752, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:48:45', 'admin-1499394285-14993957257541734', 1, 0, '', NULL, NULL, NULL),
(36987, '2017-07-07 10:48:45', NULL, NULL, 10752, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:48:45', 'admin-1499394285-14993957257541734', 1, 0, '', NULL, NULL, NULL),
(36988, '2017-07-07 10:49:11', NULL, NULL, 10753, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:49:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36989, '2017-07-07 10:49:21', NULL, NULL, 10753, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:49:21', 'admin-1499394285-149939576088195', 1, 0, '', NULL, NULL, NULL),
(36990, '2017-07-07 10:51:01', NULL, NULL, 10754, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:51:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36991, '2017-07-07 10:49:21', NULL, NULL, 10753, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:49:21', 'admin-1499394285-149939576088195', 1, 0, '', NULL, NULL, NULL),
(36992, '2017-07-07 10:32:11', NULL, NULL, 10747, 0, 181, '116', 'Open Food ', 'sausage sunny side up', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:32:11', 'admin-1499394285-14993947316686430', 1, 0, '', NULL, NULL, NULL),
(36993, '2017-07-07 10:14:38', NULL, NULL, 10747, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:14:38', 'admin-1499387663-14993936785931263', 1, 1, 'SR', NULL, NULL, NULL),
(36994, '2017-07-07 09:56:09', NULL, NULL, 10745, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:56:09', 'admin-1499387663-14993925695158078', 1, 0, '', NULL, NULL, NULL),
(36995, '2017-07-07 09:56:09', NULL, NULL, 10745, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:56:09', 'admin-1499387663-14993925695158078', 1, 0, '', NULL, NULL, NULL),
(36996, '2017-07-07 09:56:32', NULL, NULL, 10745, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:56:32', 'admin-1499387663-14993925927319594', 1, 0, '', NULL, NULL, NULL),
(36997, '2017-07-07 10:43:49', NULL, NULL, 10751, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:43:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(36998, '2017-07-07 10:33:24', NULL, NULL, 10750, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:33:24', 'admin-1499394285-14993948042466878', 1, 1, 'SR', NULL, NULL, NULL),
(36999, '2017-07-07 10:33:24', NULL, NULL, 10750, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:33:24', 'admin-1499394285-14993948042466878', 1, 1, 'SR', NULL, NULL, NULL),
(37000, '2017-07-07 10:33:13', NULL, NULL, 10750, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:33:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37001, '2017-07-07 10:23:44', NULL, NULL, 10749, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:23:44', 'admin-1499387663-14993942244041291', 1, 0, '', NULL, NULL, NULL),
(37002, '2017-07-07 10:20:23', NULL, NULL, 10749, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:20:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37003, '2017-07-07 10:23:44', NULL, NULL, 10749, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:23:44', 'admin-1499387663-14993942244041291', 1, 0, '', NULL, NULL, NULL),
(37004, '2017-07-07 10:02:28', NULL, NULL, 10746, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:02:28', 'admin-1499387663-14993929480404563', 1, 1, 'SR', NULL, NULL, '10.0'),
(37005, '2017-07-07 10:07:30', NULL, NULL, 10744, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:07:30', 'admin-1499387663-14993932499142716', 1, 1, 'SR', NULL, NULL, NULL),
(37006, '2017-07-07 12:57:35', NULL, NULL, 10766, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 12:57:35', 'admin-1499401813-14994034549432837', 1, 0, '', 1, NULL, NULL),
(37007, '2017-07-07 10:44:04', NULL, NULL, 10751, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:44:04', 'admin-1499394285-1499395444312128', 1, 1, 'SR', NULL, NULL, NULL),
(37008, '2017-07-07 10:23:44', NULL, NULL, 10749, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:23:44', 'admin-1499387663-14993942244041291', 1, 0, '', NULL, NULL, NULL),
(37009, '2017-07-07 10:00:57', NULL, NULL, 10746, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:00:57', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(37010, '2017-07-07 09:56:32', NULL, NULL, 10745, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:56:32', 'admin-1499387663-14993925927319594', 1, 1, 'SR', NULL, NULL, NULL),
(37011, '2017-07-07 11:39:29', NULL, NULL, 10759, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1499407772', 'admin', '2017-07-07 11:39:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37012, '2017-07-07 10:02:28', NULL, NULL, 10746, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:02:28', 'admin-1499387663-14993929480404563', 1, 0, '', NULL, NULL, '10.0'),
(37013, '2017-07-07 10:14:38', NULL, NULL, 10747, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:14:38', 'admin-1499387663-14993936785931263', 1, 0, '', NULL, NULL, NULL),
(37014, '2017-07-07 10:01:58', NULL, NULL, 10746, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:01:58', 'admin-1499387663-14993929185407314', 1, 1, 'SR', NULL, NULL, '10.0'),
(37015, '2017-07-07 09:57:54', NULL, NULL, 10744, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:57:54', 'admin-1499387663-14993926746463095', 1, 0, '', NULL, NULL, NULL),
(37016, '2017-07-07 10:01:58', NULL, NULL, 10746, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:01:58', 'admin-1499387663-14993929185407314', 1, 0, '', NULL, NULL, '10.0'),
(37017, '2017-07-07 10:01:58', NULL, NULL, 10746, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:01:58', 'admin-1499387663-14993929185407314', 1, 0, '', NULL, NULL, '10.0'),
(37018, '2017-07-07 10:01:58', NULL, NULL, 10746, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 10:01:58', 'admin-1499387663-14993929185407314', 1, 0, '', NULL, NULL, '10.0'),
(37019, '2017-07-07 09:43:02', NULL, NULL, 10744, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:43:02', 'admin-1499387663-14993917822099724', 1, 1, 'SR', NULL, NULL, NULL),
(37020, '2017-07-07 09:55:57', NULL, NULL, 10745, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:55:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37021, '2017-07-07 09:43:02', NULL, NULL, 10744, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:43:02', 'admin-1499387663-14993917822099724', 1, 1, 'SR', NULL, NULL, NULL),
(37022, '2017-07-07 09:39:41', NULL, NULL, 10743, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:39:41', 'admin-1499387663-14993915808945448', 1, 1, 'SR', NULL, NULL, NULL),
(37023, '2017-07-07 09:19:24', NULL, NULL, 10741, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:19:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37024, '2017-07-07 09:19:31', NULL, NULL, 10741, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:19:31', 'admin-1499387663-1499390371189375', 1, 0, '', NULL, NULL, NULL),
(37025, '2017-07-07 09:19:31', NULL, NULL, 10741, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:19:31', 'admin-1499387663-1499390371189375', 1, 0, '', NULL, NULL, NULL),
(37026, '2017-07-07 09:11:33', NULL, NULL, 10740, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:11:33', 'admin-1499387663-1499389893424379', 1, 0, '', NULL, NULL, NULL),
(37027, '2017-07-07 09:11:44', NULL, NULL, 10740, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:11:44', 'admin-1499387663-14993899043454859', 1, 0, '', NULL, NULL, NULL),
(37028, '2017-07-07 09:11:44', NULL, NULL, 10740, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:11:44', 'admin-1499387663-14993899043454859', 1, 1, 'SR', NULL, NULL, NULL),
(37029, '2017-07-07 09:11:33', NULL, NULL, 10740, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:11:33', 'admin-1499387663-1499389893424379', 1, 0, '', NULL, NULL, NULL),
(37030, '2017-07-07 09:11:33', NULL, NULL, 10740, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:11:33', 'admin-1499387663-1499389893424379', 1, 0, '', NULL, NULL, NULL),
(37031, '2017-07-07 09:10:11', NULL, NULL, 10740, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1499407772', 'admin', '2017-07-07 09:10:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37032, '2017-07-08 13:20:35', NULL, NULL, 10818, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:20:35', 'admin-1499490738-14994912350448065', 1, 1, 'SR', NULL, NULL, NULL),
(37033, '2017-07-08 12:20:21', NULL, NULL, 10823, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:20:21', 'admin-1499485631-14994876211997315', 1, 1, 'SR', NULL, NULL, NULL),
(37034, '2017-07-08 14:12:02', NULL, NULL, 10840, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:12:02', 'admin-1499490738-14994943224087568', 1, 0, '', NULL, NULL, NULL),
(37035, '2017-07-08 14:12:02', NULL, NULL, 10840, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:12:02', 'admin-1499490738-14994943224087568', 1, 1, 'SR', NULL, NULL, NULL),
(37036, '2017-07-08 14:10:34', NULL, NULL, 10840, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:10:34', 'admin-1499490738-14994942344018512', 1, 0, '', NULL, NULL, NULL),
(37037, '2017-07-08 14:10:34', NULL, NULL, 10840, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:10:34', 'admin-1499490738-14994942344018512', 1, 1, 'SR', NULL, NULL, NULL),
(37038, '2017-07-08 11:02:42', NULL, NULL, 10814, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:02:42', 'admin-1499480915-14994829624726069', 1, 1, 'SR', NULL, NULL, NULL),
(37039, '2017-07-08 11:19:33', NULL, NULL, 10816, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:19:33', 'admin-1499480915-14994839736874321', 1, 0, '', 1, NULL, NULL),
(37040, '2017-07-08 17:28:55', NULL, NULL, 10857, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 17:28:55', 'admin-1499495883-14995061352045915', 1, 1, 'SR', NULL, NULL, NULL),
(37041, '2017-07-08 17:28:55', NULL, NULL, 10857, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 17:28:55', 'admin-1499495883-14995061352045915', 1, 1, 'SR', NULL, NULL, NULL),
(37042, '2017-07-08 17:28:46', NULL, NULL, 10857, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1499495883', 'admin', '2017-07-08 17:28:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37043, '2017-07-08 17:24:00', NULL, NULL, 10856, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 17:24:00', 'admin-1499495883-1499505840110736', 1, 1, 'SR', NULL, NULL, NULL),
(37044, '2017-07-08 17:23:56', NULL, NULL, 10856, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1499495883', 'admin', '2017-07-08 17:23:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37045, '2017-07-08 17:08:56', NULL, NULL, 10854, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 17:08:56', 'admin-1499495883-14995049367732814', 1, 0, '', NULL, NULL, NULL),
(37046, '2017-07-08 17:07:21', NULL, NULL, 10854, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 17:07:21', 'admin-1499495883-1499504841372522', 1, 1, 'SR', NULL, NULL, NULL),
(37047, '2017-07-08 15:37:10', NULL, NULL, 10850, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 15:37:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37048, '2017-07-08 15:37:31', NULL, NULL, 10850, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 15:37:31', 'admin-1499495883-14994994508608116', 1, 0, '', NULL, NULL, NULL),
(37049, '2017-07-08 14:46:37', NULL, NULL, 10840, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:46:37', 'admin-1499495883-14994963972773262', 1, 1, 'SR', NULL, NULL, NULL),
(37050, '2017-07-08 13:23:44', NULL, NULL, 10832, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:23:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37051, '2017-07-08 12:42:05', NULL, NULL, 10828, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.00, 0.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:42:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37052, '2017-07-08 12:42:24', NULL, NULL, 10828, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:42:24', 'admin-1499488383-14994889447502622', 1, 0, '', NULL, NULL, NULL),
(37053, '2017-07-08 12:42:24', NULL, NULL, 10828, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:42:24', 'admin-1499488383-14994889447502622', 1, 0, '', NULL, NULL, NULL),
(37054, '2017-07-08 17:07:21', NULL, NULL, 10854, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 17:07:21', 'admin-1499495883-1499504841372522', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(37055, '2017-07-08 14:09:57', NULL, NULL, 10840, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.90, 0.0000, 0.0000, 12.90, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:09:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37056, '2017-07-08 13:55:56', NULL, NULL, 10839, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:55:56', 'admin-1499490738-14994933563838662', 1, 1, 'SR', NULL, NULL, NULL),
(37057, '2017-07-08 13:55:56', NULL, NULL, 10839, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:55:56', 'admin-1499490738-14994933563838662', 1, 1, 'SR', NULL, NULL, NULL),
(37058, '2017-07-08 00:00:00', NULL, NULL, 10841, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:28:38', 'admin-1499490738-14994917183912820', 1, 1, 'SR', NULL, NULL, NULL),
(37059, '2017-07-08 14:10:34', NULL, NULL, 10840, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:10:34', 'admin-1499490738-14994942344018512', 1, 0, '', NULL, NULL, NULL),
(37060, '2017-07-08 12:36:17', NULL, NULL, 10827, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:36:17', 'admin-1499488383-1499488577017149', 1, 1, 'SR', NULL, NULL, NULL),
(37061, '2017-07-08 12:36:35', NULL, NULL, 10826, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:36:35', 'admin-1499488383-14994885955135397', 1, 0, '', NULL, NULL, NULL),
(37062, '2017-07-08 13:55:46', NULL, NULL, 10839, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:55:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37063, '2017-07-08 10:28:23', NULL, NULL, 10804, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:28:23', 'admin-1499480008-14994809028296782', 1, 0, '', NULL, NULL, NULL),
(37064, '2017-07-08 10:28:23', NULL, NULL, 10804, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:28:23', 'admin-1499480008-14994809028296782', 1, 0, '', NULL, NULL, NULL),
(37065, '2017-07-08 16:13:46', NULL, NULL, 10853, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 16:13:46', 'admin-1499495883-14995016263474062', 1, 1, 'SR', 1, NULL, '10.0'),
(37066, '2017-07-08 15:37:31', NULL, NULL, 10850, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 15:37:31', 'admin-1499495883-14994994508608116', 1, 0, '', NULL, NULL, NULL),
(37067, '2017-07-08 13:55:13', NULL, NULL, 10838, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:55:13', 'admin-1499490738-14994933136019178', 1, 1, 'SR', NULL, NULL, NULL),
(37068, '2017-07-08 13:52:56', NULL, NULL, 10837, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:52:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37069, '2017-07-08 10:38:22', NULL, NULL, 10812, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:38:22', 'admin-1499480915-14994815021825168', 1, 1, 'SR', NULL, NULL, NULL),
(37070, '2017-07-08 10:38:22', NULL, NULL, 10812, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:38:22', 'admin-1499480915-14994815021825168', 1, 0, '', NULL, NULL, NULL),
(37071, '2017-07-08 10:50:13', NULL, NULL, 10812, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:50:13', 'admin-1499480915-1499482213059745', 1, 0, '', NULL, NULL, NULL),
(37072, '2017-07-08 10:55:51', NULL, NULL, 10813, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:55:51', 'admin-1499480915-14994825517065652', 1, 0, '', 1, NULL, NULL),
(37073, '2017-07-08 16:13:46', NULL, NULL, 10853, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 16:13:46', 'admin-1499495883-14995016263474062', 1, 1, 'SR', 1, NULL, '10.0'),
(37074, '2017-07-08 17:05:20', NULL, NULL, 10854, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1499495883', 'admin', '2017-07-08 17:05:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37075, '2017-07-08 17:05:27', NULL, NULL, 10854, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 17:05:27', 'admin-1499495883-14995047277258053', 1, 1, 'SR', NULL, NULL, NULL),
(37076, '2017-07-08 15:52:28', NULL, NULL, 10851, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 15:52:28', 'admin-1499495883-14995003479594469', 1, 1, 'SR', NULL, NULL, NULL),
(37077, '2017-07-08 15:43:21', NULL, NULL, 10851, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 15:43:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37078, '2017-07-08 15:43:24', NULL, NULL, 10851, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 15:43:24', 'admin-1499495883-1499499804254516', 1, 0, '', NULL, NULL, NULL),
(37079, '2017-07-08 11:26:35', NULL, NULL, 10817, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:26:35', 'admin-1499480915-14994843949046964', 1, 0, '', NULL, NULL, NULL),
(37080, '2017-07-08 11:26:35', NULL, NULL, 10817, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:26:35', 'admin-1499480915-14994843949046964', 1, 0, '', NULL, NULL, NULL),
(37081, '2017-07-08 11:26:42', NULL, NULL, 10817, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:26:42', 'admin-1499480915-14994844018818355', 1, 1, 'SR', NULL, NULL, NULL),
(37082, '2017-07-08 11:26:42', NULL, NULL, 10817, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:26:42', 'admin-1499480915-14994844018818355', 1, 1, 'SR', NULL, NULL, NULL),
(37083, '2017-07-08 11:37:51', NULL, NULL, 10818, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:37:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37084, '2017-07-08 11:38:03', NULL, NULL, 10818, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:38:03', 'admin-1499480915-14994850830459830', 1, 1, 'SR', NULL, NULL, NULL),
(37085, '2017-07-08 11:38:03', NULL, NULL, 10818, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:38:03', 'admin-1499480915-14994850830459830', 1, 0, '', NULL, NULL, NULL),
(37086, '2017-07-08 15:37:31', NULL, NULL, 10850, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 15:37:31', 'admin-1499495883-14994994508608116', 1, 1, 'SR', NULL, NULL, NULL),
(37087, '2017-07-08 15:03:28', NULL, NULL, 10838, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 15:03:28', 'admin-1499495883-1499497408354328', 1, 1, 'SR', NULL, NULL, NULL),
(37088, '2017-07-08 14:36:49', NULL, NULL, 10837, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:36:49', 'admin-1499490738-14994958096919555', 1, 0, '', NULL, NULL, NULL),
(37089, '2017-07-08 14:45:14', NULL, NULL, 10842, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:45:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37090, '2017-07-08 14:45:21', NULL, NULL, 10842, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:45:21', 'admin-1499495883-14994963211386780', 1, 1, 'SR', NULL, NULL, NULL),
(37091, '2017-07-08 14:45:21', NULL, NULL, 10842, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:45:21', 'admin-1499495883-14994963211386780', 1, 1, 'SR', NULL, NULL, NULL),
(37092, '2017-07-08 13:41:15', NULL, NULL, 10835, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:41:15', 'admin-1499490738-14994924755675030', 1, 1, 'SR', 1, NULL, NULL),
(37093, '2017-07-08 13:49:09', NULL, NULL, 10836, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:49:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37094, '2017-07-08 13:38:24', NULL, NULL, 10834, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:38:24', 'admin-1499490738-14994923045467096', 1, 0, '', NULL, NULL, NULL),
(37095, '2017-07-08 13:38:24', NULL, NULL, 10834, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:38:24', 'admin-1499490738-14994923045467096', 1, 1, 'SR', NULL, NULL, NULL),
(37096, '2017-07-08 15:11:28', NULL, NULL, 10846, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1499495883', 'admin', '2017-07-08 15:11:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37097, '2017-07-08 00:00:00', NULL, NULL, 10849, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, NULL, NULL, 4.40, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:55:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37098, '2017-07-08 15:00:24', NULL, NULL, 10844, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 15:00:24', 'admin-1499495883-1499497224144982', 1, 1, 'SR', NULL, NULL, NULL),
(37099, '2017-07-08 15:00:14', NULL, NULL, 10844, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1499495883', 'admin', '2017-07-08 15:00:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37100, '2017-07-08 00:00:00', NULL, NULL, 10849, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:56:51', 'admin-1499495883-14994970116822625', 1, 1, 'SR', NULL, NULL, NULL),
(37101, '2017-07-08 00:00:00', NULL, NULL, 10849, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:56:51', 'admin-1499495883-14994970116822625', 1, 1, 'SR', NULL, NULL, NULL),
(37102, '2017-07-08 13:55:13', NULL, NULL, 10838, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:55:13', 'admin-1499490738-14994933136019178', 1, 1, 'SR', NULL, NULL, NULL),
(37103, '2017-07-08 13:55:13', NULL, NULL, 10838, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:55:13', 'admin-1499490738-14994933136019178', 1, 1, 'SR', NULL, NULL, NULL),
(37104, '2017-07-08 13:55:13', NULL, NULL, 10838, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:55:13', 'admin-1499490738-14994933136019178', 1, 1, 'SR', NULL, NULL, NULL),
(37105, '2017-07-08 13:55:08', NULL, NULL, 10838, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:55:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37106, '2017-07-08 10:24:16', NULL, NULL, 10809, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:24:16', 'admin-1499480008-14994806567866726', 1, 0, '', NULL, NULL, NULL),
(37107, '2017-07-08 10:10:38', NULL, NULL, 10804, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.90, 0.0000, 0.0000, 9.90, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:10:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37108, '2017-07-08 15:07:30', NULL, NULL, 10845, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 15:07:30', 'admin-1499495883-14994976505715322', 1, 0, '', NULL, NULL, NULL),
(37109, '2017-07-08 15:08:23', NULL, NULL, 10840, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 15:08:23', 'admin-1499495883-14994977033872915', 1, 0, '', NULL, NULL, NULL),
(37110, '2017-07-08 00:00:00', NULL, NULL, 10846, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 15:01:51', 'admin-1499495883-14994973113557618', 1, 1, 'SR', NULL, NULL, NULL),
(37111, '2017-07-08 14:48:34', NULL, NULL, 10840, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:48:34', 'admin-1499495883-14994965147641783', 1, 1, 'SR', NULL, NULL, NULL),
(37112, '2017-07-08 00:00:00', NULL, NULL, 10849, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 2, 12.00, NULL, NULL, 24.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:55:56', 'admin-1499495883-14994969565378473', 1, 1, 'SR', NULL, NULL, NULL),
(37113, '2017-07-08 15:13:10', NULL, NULL, 10848, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1499495883', 'admin', '2017-07-08 15:13:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37114, '2017-07-08 14:45:10', NULL, NULL, 10838, 0, 284, '218', 'Caramel Waffles', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:45:10', 'admin-1499495883-1499496310529360', 1, 0, '', NULL, NULL, NULL),
(37115, '2017-07-08 14:32:47', NULL, NULL, 10838, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:32:47', 'admin-1499490738-14994955675906370', 1, 1, 'SR', NULL, NULL, NULL),
(37116, '2017-07-08 13:37:48', NULL, NULL, 10834, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:37:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37117, '2017-07-08 13:38:24', NULL, NULL, 10834, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:38:24', 'admin-1499490738-14994923045467096', 1, 1, 'SR', NULL, NULL, NULL),
(37118, '2017-07-08 15:07:21', NULL, NULL, 10845, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1499495883', 'admin', '2017-07-08 15:07:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37119, '2017-07-08 14:46:37', NULL, NULL, 10840, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:46:37', 'admin-1499495883-14994963972773262', 1, 1, 'SR', NULL, NULL, NULL),
(37120, '2017-07-08 13:53:15', NULL, NULL, 10837, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:53:15', 'admin-1499490738-14994931950965949', 1, 1, 'SR', NULL, NULL, NULL),
(37121, '2017-07-08 12:58:55', NULL, NULL, 10823, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:58:55', 'admin-1499488383-14994899353684841', 1, 1, 'SR', NULL, NULL, NULL),
(37122, '2017-07-08 13:12:10', NULL, NULL, 10828, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:12:10', 'admin-1499488383-14994907300082895', 1, 1, 'SR', NULL, NULL, NULL),
(37123, '2017-07-08 13:12:10', NULL, NULL, 10828, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:12:10', 'admin-1499488383-14994907300082895', 1, 0, '', NULL, NULL, NULL),
(37124, '2017-07-08 13:14:10', NULL, NULL, 10828, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:14:10', 'admin-1499490738-14994908504827927', 1, 0, '', NULL, NULL, NULL),
(37125, '2017-07-08 13:16:21', NULL, NULL, 10828, 0, 32, '32', 'Tea By Pot ', 'rasberry', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:16:21', 'admin-1499490738-14994909815015420', 1, 1, 'SR', NULL, NULL, NULL),
(37126, '2017-07-08 13:18:51', NULL, NULL, 10831, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:18:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37127, '2017-07-08 13:53:15', NULL, NULL, 10837, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:53:15', 'admin-1499490738-14994931950965949', 1, 0, '', NULL, NULL, NULL),
(37128, '2017-07-08 12:35:52', NULL, NULL, 10827, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:35:52', 'admin-1499488383-14994885522426924', 1, 1, 'SR', NULL, NULL, NULL),
(37129, '2017-07-08 09:22:25', NULL, NULL, 10798, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:22:25', 'admin-1499475812-14994769448009659', 1, 0, '', NULL, NULL, NULL),
(37130, '2017-07-08 09:22:25', NULL, NULL, 10798, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:22:25', 'admin-1499475812-14994769448009659', 1, 0, '', NULL, NULL, NULL),
(37131, '2017-07-08 09:22:25', NULL, NULL, 10798, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:22:25', 'admin-1499475812-14994769448009659', 1, 1, 'SR', NULL, NULL, NULL),
(37132, '2017-07-08 09:22:25', NULL, NULL, 10798, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:22:25', 'admin-1499475812-14994769448009659', 1, 1, 'SR', NULL, NULL, NULL),
(37133, '2017-07-08 17:08:30', NULL, NULL, 10855, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 17:08:30', 'admin-1499495883-14995049101649686', 1, 1, 'SR', 1, NULL, NULL),
(37134, '2017-07-08 14:32:47', NULL, NULL, 10838, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:32:47', 'admin-1499490738-14994955675906370', 1, 1, 'SR', NULL, NULL, NULL),
(37135, '2017-07-08 00:00:00', NULL, NULL, 10848, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 15:01:51', 'admin-1499495883-14994973113557618', 1, 0, '', NULL, NULL, NULL),
(37136, '2017-07-08 00:00:00', NULL, NULL, 10841, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:28:38', 'admin-1499490738-14994917183912820', 1, 1, 'SR', NULL, NULL, NULL),
(37137, '2017-07-08 14:32:38', NULL, NULL, 10838, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:32:38', 'admin-1499490738-14994955586468472', 1, 0, '', NULL, NULL, NULL),
(37138, '2017-07-08 14:14:12', NULL, NULL, 10840, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:14:12', 'admin-1499490738-1499494452385926', 1, 0, '', NULL, NULL, NULL),
(37139, '2017-07-08 13:53:15', NULL, NULL, 10837, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:53:15', 'admin-1499490738-14994931950965949', 1, 0, '', NULL, NULL, NULL),
(37140, '2017-07-08 12:42:24', NULL, NULL, 10828, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:42:24', 'admin-1499488383-14994889447502622', 1, 0, '', NULL, NULL, NULL),
(37141, '2017-07-08 12:42:24', NULL, NULL, 10828, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:42:24', 'admin-1499488383-14994889447502622', 1, 1, 'SR', NULL, NULL, NULL),
(37142, '2017-07-08 13:53:15', NULL, NULL, 10837, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:53:15', 'admin-1499490738-14994931950965949', 1, 0, '', NULL, NULL, NULL),
(37143, '2017-07-08 12:58:25', NULL, NULL, 10830, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:58:25', 'admin-1499488383-1499489905373337', 1, 0, '', NULL, NULL, NULL),
(37144, '2017-07-08 12:58:25', NULL, NULL, 10830, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:58:25', 'admin-1499488383-1499489905373337', 1, 0, '', NULL, NULL, NULL),
(37145, '2017-07-08 12:58:38', NULL, NULL, 10830, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:58:38', 'admin-1499488383-14994899185511553', 1, 1, 'SR', NULL, NULL, NULL),
(37146, '2017-07-08 12:58:38', NULL, NULL, 10830, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:58:38', 'admin-1499488383-14994899185511553', 1, 0, '', NULL, NULL, NULL),
(37147, '2017-07-08 13:38:24', NULL, NULL, 10834, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:38:24', 'admin-1499490738-14994923045467096', 1, 0, '', NULL, NULL, NULL),
(37148, '2017-07-08 00:00:00', NULL, NULL, 10841, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:28:38', 'admin-1499490738-14994917183912820', 1, 0, '', NULL, NULL, NULL),
(37149, '2017-07-08 13:28:38', NULL, NULL, 10833, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:28:38', 'admin-1499490738-14994917183912820', 1, 1, 'SR', NULL, NULL, NULL),
(37150, '2017-07-08 13:28:38', NULL, NULL, 10833, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:28:38', 'admin-1499490738-14994917183912820', 1, 1, 'SR', NULL, NULL, NULL),
(37151, '2017-07-08 14:22:03', NULL, NULL, 10841, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:22:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37152, '2017-07-08 13:28:38', NULL, NULL, 10833, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:28:38', 'admin-1499490738-14994917183912820', 1, 0, '', NULL, NULL, NULL),
(37153, '2017-07-08 13:28:38', NULL, NULL, 10833, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:28:38', 'admin-1499490738-14994917183912820', 1, 1, 'SR', NULL, NULL, NULL),
(37154, '2017-07-08 11:26:28', NULL, NULL, 10817, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:26:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37155, '2017-07-08 11:26:35', NULL, NULL, 10817, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:26:35', 'admin-1499480915-14994843949046964', 1, 0, '', NULL, NULL, NULL),
(37156, '2017-07-08 15:03:28', NULL, NULL, 10838, 0, 284, '218', 'Caramel Waffles', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 15:03:28', 'admin-1499495883-1499497408354328', 1, 0, '', NULL, NULL, NULL),
(37157, '2017-07-08 13:26:18', NULL, NULL, 10833, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:26:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37158, '2017-07-08 17:05:27', NULL, NULL, 10854, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 17:05:27', 'admin-1499495883-14995047277258053', 1, 1, 'SR', NULL, NULL, NULL),
(37159, '2017-07-08 13:24:31', NULL, NULL, 10832, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:24:31', 'admin-1499490738-14994914717916316', 1, 1, 'SR', NULL, NULL, NULL),
(37160, '2017-07-08 13:24:31', NULL, NULL, 10832, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:24:31', 'admin-1499490738-14994914717916316', 1, 1, 'SR', NULL, NULL, NULL),
(37161, '2017-07-08 13:20:35', NULL, NULL, 10818, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:20:35', 'admin-1499490738-14994912350448065', 1, 1, 'SR', NULL, NULL, NULL),
(37162, '2017-07-08 13:19:00', NULL, NULL, 10831, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:19:00', 'admin-1499490738-14994911406951755', 1, 1, 'SR', NULL, NULL, NULL),
(37163, '2017-07-08 13:19:00', NULL, NULL, 10831, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:19:00', 'admin-1499490738-14994911406951755', 1, 0, '', NULL, NULL, NULL),
(37164, '2017-07-08 13:19:00', NULL, NULL, 10831, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:19:00', 'admin-1499490738-14994911406951755', 1, 0, '', NULL, NULL, NULL),
(37165, '2017-07-08 12:36:35', NULL, NULL, 10826, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:36:35', 'admin-1499488383-14994885955135397', 1, 1, 'SR', NULL, NULL, NULL),
(37166, '2017-07-08 12:49:31', NULL, NULL, 10829, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:49:31', 'admin-1499488383-1499489371506761', 1, 1, 'SR', NULL, NULL, NULL),
(37167, '2017-07-08 12:58:02', NULL, NULL, 10830, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:58:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37168, '2017-07-08 13:49:12', NULL, NULL, 10836, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:49:12', 'admin-1499490738-14994929519419427', 1, 1, 'SR', NULL, NULL, NULL),
(37169, '2017-07-08 12:49:18', NULL, NULL, 10829, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:49:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37170, '2017-07-08 12:40:25', NULL, NULL, 10827, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:40:25', 'admin-1499488383-14994888253406059', 1, 0, '', NULL, NULL, NULL),
(37171, '2017-07-08 12:32:56', NULL, NULL, 10825, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:32:56', 'admin-1499485631-14994883765836188', 1, 1, 'SR', NULL, NULL, NULL),
(37172, '2017-07-08 12:20:21', NULL, NULL, 10823, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:20:21', 'admin-1499485631-14994876211997315', 1, 1, 'SR', NULL, NULL, NULL),
(37173, '2017-07-08 12:23:01', NULL, NULL, 10824, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:23:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37174, '2017-07-08 12:36:35', NULL, NULL, 10826, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:36:35', 'admin-1499488383-14994885955135397', 1, 1, 'SR', NULL, NULL, NULL),
(37175, '2017-07-08 12:32:56', NULL, NULL, 10825, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:32:56', 'admin-1499485631-14994883765836188', 1, 0, '', NULL, NULL, NULL),
(37176, '2017-07-08 12:32:56', NULL, NULL, 10825, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:32:56', 'admin-1499485631-14994883765836188', 1, 1, 'SR', NULL, NULL, NULL),
(37177, '2017-07-08 12:32:56', NULL, NULL, 10825, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:32:56', 'admin-1499485631-14994883765836188', 1, 0, '', NULL, NULL, NULL),
(37178, '2017-07-08 12:32:56', NULL, NULL, 10825, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:32:56', 'admin-1499485631-14994883765836188', 1, 0, '', NULL, NULL, NULL),
(37179, '2017-07-08 14:10:34', NULL, NULL, 10840, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 14:10:34', 'admin-1499490738-14994942344018512', 1, 0, '', NULL, NULL, NULL),
(37180, '2017-07-08 12:36:17', NULL, NULL, 10827, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:36:17', 'admin-1499488383-1499488577017149', 1, 0, '', NULL, NULL, NULL),
(37181, '2017-07-08 12:20:21', NULL, NULL, 10823, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:20:21', 'admin-1499485631-14994876211997315', 1, 0, '', NULL, NULL, NULL),
(37182, '2017-07-08 12:36:17', NULL, NULL, 10827, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:36:17', 'admin-1499488383-1499488577017149', 1, 1, 'SR', NULL, NULL, NULL),
(37183, '2017-07-08 11:46:21', NULL, NULL, 10819, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:46:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37184, '2017-07-08 11:46:51', NULL, NULL, 10819, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:46:51', 'admin-1499480915-14994856113869046', 1, 0, '', NULL, NULL, NULL),
(37185, '2017-07-08 12:10:44', NULL, NULL, 10821, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:10:44', 'admin-1499485631-14994870439063645', 1, 0, '', NULL, NULL, NULL),
(37186, '2017-07-08 12:10:44', NULL, NULL, 10821, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:10:44', 'admin-1499485631-14994870439063645', 1, 0, '', NULL, NULL, NULL),
(37187, '2017-07-08 12:10:56', NULL, NULL, 10821, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:10:56', 'admin-1499485631-1499487055888374', 1, 1, 'SR', NULL, NULL, NULL),
(37188, '2017-07-08 12:10:56', NULL, NULL, 10821, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:10:56', 'admin-1499485631-1499487055888374', 1, 1, 'SR', NULL, NULL, NULL),
(37189, '2017-07-08 12:14:37', NULL, NULL, 10822, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:14:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37190, '2017-07-08 10:38:22', NULL, NULL, 10812, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:38:22', 'admin-1499480915-14994815021825168', 1, 1, 'SR', NULL, NULL, NULL),
(37191, '2017-07-08 12:35:20', NULL, NULL, 10827, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.90, 0.0000, 0.0000, 9.90, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:35:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37192, '2017-07-08 12:35:52', NULL, NULL, 10827, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:35:52', 'admin-1499488383-14994885522426924', 1, 0, '', NULL, NULL, NULL),
(37193, '2017-07-08 11:15:17', NULL, NULL, 10815, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:15:17', 'admin-1499480915-14994837172092242', 1, 1, 'SR', 1, NULL, NULL),
(37194, '2017-07-08 12:35:52', NULL, NULL, 10827, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:35:52', 'admin-1499488383-14994885522426924', 1, 1, 'SR', NULL, NULL, NULL),
(37195, '2017-07-08 10:05:18', NULL, NULL, 10802, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:05:18', 'admin-1499477746-14994795183524533', 1, 0, '', NULL, NULL, NULL),
(37196, '2017-07-08 10:05:18', NULL, NULL, 10802, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:05:18', 'admin-1499477746-14994795183524533', 1, 1, 'SR', NULL, NULL, NULL),
(37197, '2017-07-08 10:07:27', NULL, NULL, 10803, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:07:27', 'admin-1499477746-14994796475677925', 1, 0, '', NULL, NULL, NULL),
(37198, '2017-07-08 10:07:27', NULL, NULL, 10803, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:07:27', 'admin-1499477746-14994796475677925', 1, 0, '', NULL, NULL, NULL),
(37199, '2017-07-08 09:22:25', NULL, NULL, 10798, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:22:25', 'admin-1499475812-14994769448009659', 1, 0, '', NULL, NULL, NULL),
(37200, '2017-07-08 12:35:14', NULL, NULL, 10826, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:35:14', 'admin-1499488383-1499488514232214', 1, 0, '', NULL, NULL, NULL),
(37201, '2017-07-08 00:00:00', NULL, NULL, 10841, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 13:28:38', 'admin-1499490738-14994917183912820', 1, 0, '', NULL, NULL, NULL),
(37202, '2017-07-08 12:33:59', NULL, NULL, 10826, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:33:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37203, '2017-07-08 12:35:14', NULL, NULL, 10826, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:35:14', 'admin-1499488383-1499488514232214', 1, 1, 'SR', NULL, NULL, NULL),
(37204, '2017-07-08 12:32:56', NULL, NULL, 10825, 0, 32, '32', 'Tea By Pot ', 'charmomile', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:32:56', 'admin-1499485631-14994883765836188', 1, 1, 'SR', NULL, NULL, NULL),
(37205, '2017-07-08 12:24:09', NULL, NULL, 10824, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:24:09', 'admin-1499485631-14994878490251174', 1, 0, '', NULL, NULL, NULL),
(37206, '2017-07-08 12:32:09', NULL, NULL, 10825, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:32:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37207, '2017-07-08 12:32:56', NULL, NULL, 10825, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:32:56', 'admin-1499485631-14994883765836188', 1, 1, 'SR', NULL, NULL, NULL),
(37208, '2017-07-08 12:24:09', NULL, NULL, 10824, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:24:09', 'admin-1499485631-14994878490251174', 1, 1, 'SR', NULL, NULL, NULL),
(37209, '2017-07-08 10:23:36', NULL, NULL, 10808, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:23:36', 'admin-1499480008-14994806165291258', 1, 0, '', NULL, NULL, NULL),
(37210, '2017-07-08 10:23:36', NULL, NULL, 10808, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:23:36', 'admin-1499480008-14994806165291258', 1, 0, '', NULL, NULL, NULL),
(37211, '2017-07-08 12:15:29', NULL, NULL, 10822, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:15:29', 'admin-1499485631-14994873295027352', 1, 1, 'SR', NULL, NULL, NULL),
(37212, '2017-07-08 12:15:29', NULL, NULL, 10822, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:15:29', 'admin-1499485631-14994873295027352', 1, 0, '', NULL, NULL, NULL),
(37213, '2017-07-08 12:15:29', NULL, NULL, 10822, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:15:29', 'admin-1499485631-14994873295027352', 1, 1, 'SR', NULL, NULL, NULL),
(37214, '2017-07-08 12:15:29', NULL, NULL, 10822, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:15:29', 'admin-1499485631-14994873295027352', 1, 1, 'SR', NULL, NULL, NULL),
(37215, '2017-07-08 15:07:30', NULL, NULL, 10845, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 15:07:30', 'admin-1499495883-14994976505715322', 1, 1, 'SR', NULL, NULL, NULL),
(37216, '2017-07-08 12:20:21', NULL, NULL, 10823, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:20:21', 'admin-1499485631-14994876211997315', 1, 1, 'SR', NULL, NULL, NULL),
(37217, '2017-07-08 10:24:16', NULL, NULL, 10809, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:24:16', 'admin-1499480008-14994806567866726', 1, 1, 'SR', NULL, NULL, NULL),
(37218, '2017-07-08 10:24:25', NULL, NULL, 10810, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:24:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37219, '2017-07-08 10:24:38', NULL, NULL, 10810, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:24:38', 'admin-1499480008-14994806778807683', 1, 0, '', NULL, NULL, NULL),
(37220, '2017-07-08 12:20:21', NULL, NULL, 10823, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:20:21', 'admin-1499485631-14994876211997315', 1, 1, 'SR', NULL, NULL, NULL),
(37221, '2017-07-08 12:18:54', NULL, NULL, 10823, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:18:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37222, '2017-07-08 12:20:21', NULL, NULL, 10823, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:20:21', 'admin-1499485631-14994876211997315', 1, 0, '', NULL, NULL, NULL),
(37223, '2017-07-08 12:15:29', NULL, NULL, 10822, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:15:29', 'admin-1499485631-14994873295027352', 1, 0, '', NULL, NULL, NULL),
(37224, '2017-07-08 11:59:14', NULL, NULL, 10820, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:59:14', 'admin-1499485631-14994863538042112', 1, 0, '', NULL, NULL, NULL),
(37225, '2017-07-08 11:59:14', NULL, NULL, 10820, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:59:14', 'admin-1499485631-14994863538042112', 1, 0, '', NULL, NULL, NULL),
(37226, '2017-07-08 11:59:14', NULL, NULL, 10820, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:59:14', 'admin-1499485631-14994863538042112', 1, 0, '', NULL, NULL, NULL),
(37227, '2017-07-08 11:47:32', NULL, NULL, 10819, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:47:32', 'admin-1499485631-14994856522374088', 1, 1, 'SR', NULL, NULL, NULL),
(37228, '2017-07-08 11:58:58', NULL, NULL, 10820, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:58:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37229, '2017-07-08 11:47:32', NULL, NULL, 10819, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:47:32', 'admin-1499485631-14994856522374088', 1, 1, 'SR', NULL, NULL, NULL),
(37230, '2017-07-08 12:10:16', NULL, NULL, 10821, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:10:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37231, '2017-07-08 11:02:42', NULL, NULL, 10814, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:02:42', 'admin-1499480915-14994829624726069', 1, 0, '', NULL, NULL, NULL),
(37232, '2017-07-08 11:02:42', NULL, NULL, 10814, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:02:42', 'admin-1499480915-14994829624726069', 1, 0, '', NULL, NULL, NULL),
(37233, '2017-07-08 11:02:27', NULL, NULL, 10814, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1499495883', 'admin', '2017-07-08 11:02:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37234, '2017-07-08 09:13:46', NULL, NULL, 10796, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:13:46', 'admin-1499475812-14994764259918261', 1, 1, 'SR', NULL, NULL, NULL),
(37235, '2017-07-08 09:13:55', NULL, NULL, 10797, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:13:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37236, '2017-07-08 09:14:22', NULL, NULL, 10797, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:14:22', 'admin-1499475812-14994764626207284', 1, 0, '', NULL, NULL, NULL),
(37237, '2017-07-08 09:14:22', NULL, NULL, 10797, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:14:22', 'admin-1499475812-14994764626207284', 1, 0, '', NULL, NULL, NULL),
(37238, '2017-07-08 09:14:22', NULL, NULL, 10797, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:14:22', 'admin-1499475812-14994764626207284', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(37239, '2017-07-08 09:19:41', NULL, NULL, 10797, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:19:41', 'admin-1499475812-1499476780822973', 1, 1, 'SR', NULL, NULL, NULL),
(37240, '2017-07-08 09:21:32', NULL, NULL, 10798, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.40, 0.0000, 0.0000, 15.40, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:21:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37241, '2017-07-08 09:22:25', NULL, NULL, 10798, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:22:25', 'admin-1499475812-14994769448009659', 1, 0, '', NULL, NULL, NULL),
(37242, '2017-07-08 10:34:38', NULL, NULL, 10811, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:34:38', 'admin-1499480915-14994812786246775', 1, 1, 'SR', NULL, NULL, NULL),
(37243, '2017-07-08 10:37:48', NULL, NULL, 10812, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:37:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37244, '2017-07-08 10:38:22', NULL, NULL, 10812, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:38:22', 'admin-1499480915-14994815021825168', 1, 0, '', NULL, NULL, NULL),
(37245, '2017-07-08 10:10:43', NULL, NULL, 10804, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:10:43', 'admin-1499477746-14994798436282886', 1, 0, '', NULL, NULL, NULL),
(37246, '2017-07-08 10:10:43', NULL, NULL, 10804, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:10:43', 'admin-1499477746-14994798436282886', 1, 0, '', NULL, NULL, NULL),
(37247, '2017-07-08 10:34:38', NULL, NULL, 10811, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:34:38', 'admin-1499480915-14994812786246775', 1, 1, 'SR', NULL, NULL, NULL),
(37248, '2017-07-08 10:33:48', NULL, NULL, 10811, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:33:48', 'admin-1499480915-14994812278008245', 1, 0, '', NULL, NULL, NULL),
(37249, '2017-07-08 10:33:48', NULL, NULL, 10811, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:33:48', 'admin-1499480915-14994812278008245', 1, 0, '', NULL, NULL, NULL),
(37250, '2017-07-08 10:33:48', NULL, NULL, 10811, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:33:48', 'admin-1499480915-14994812278008245', 1, 0, '', NULL, NULL, NULL),
(37251, '2017-07-08 10:33:47', NULL, NULL, 10811, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:33:47', 'admin-1499480915-14994812278008245', 1, 0, '', NULL, NULL, NULL),
(37252, '2017-07-08 10:28:55', NULL, NULL, 10804, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:28:55', 'admin-1499480915-1499480935195149', 1, 1, 'SR', NULL, NULL, NULL),
(37253, '2017-07-08 10:28:55', NULL, NULL, 10804, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:28:55', 'admin-1499480915-1499480935195149', 1, 1, 'SR', NULL, NULL, NULL),
(37254, '2017-07-08 10:33:08', NULL, NULL, 10811, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:33:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37255, '2017-07-08 10:28:55', NULL, NULL, 10804, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:28:55', 'admin-1499480915-1499480935195149', 1, 1, 'SR', NULL, NULL, NULL),
(37256, '2017-07-08 00:00:00', NULL, NULL, 10848, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 15:06:42', 'admin-1499495883-14994976026465420', 1, 1, 'SR', NULL, NULL, NULL),
(37257, '2017-07-08 10:23:36', NULL, NULL, 10808, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:23:36', 'admin-1499480008-14994806165291258', 1, 1, 'SR', NULL, NULL, NULL),
(37258, '2017-07-08 10:23:36', NULL, NULL, 10808, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:23:36', 'admin-1499480008-14994806165291258', 1, 0, '', NULL, NULL, NULL),
(37259, '2017-07-08 10:23:36', NULL, NULL, 10808, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:23:36', 'admin-1499480008-14994806165291258', 1, 0, '', NULL, NULL, NULL),
(37260, '2017-07-08 10:16:21', NULL, NULL, 10806, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:16:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37261, '2017-07-08 10:16:51', NULL, NULL, 10806, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:16:51', 'admin-1499480008-14994802114328485', 1, 0, '', NULL, NULL, NULL),
(37262, '2017-07-08 10:16:51', NULL, NULL, 10806, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:16:51', 'admin-1499480008-14994802114328485', 1, 0, '', NULL, NULL, NULL),
(37263, '2017-07-08 10:16:51', NULL, NULL, 10806, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:16:51', 'admin-1499480008-14994802114328485', 1, 0, '', NULL, NULL, NULL),
(37264, '2017-07-08 10:16:51', NULL, NULL, 10806, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:16:51', 'admin-1499480008-14994802114328485', 1, 0, '', NULL, NULL, NULL),
(37265, '2017-07-08 10:16:51', NULL, NULL, 10806, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:16:51', 'admin-1499480008-14994802114328485', 1, 1, 'SR', NULL, NULL, NULL),
(37266, '2017-07-08 10:24:38', NULL, NULL, 10810, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:24:38', 'admin-1499480008-14994806778807683', 1, 0, '', NULL, NULL, NULL),
(37267, '2017-07-08 10:23:54', NULL, NULL, 10809, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:23:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37268, '2017-07-08 10:23:36', NULL, NULL, 10808, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:23:36', 'admin-1499480008-14994806165291258', 1, 0, '', NULL, NULL, NULL),
(37269, '2017-07-08 10:17:27', NULL, NULL, 10807, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:17:27', 'admin-1499480008-14994802477663147', 1, 1, 'SR', NULL, NULL, NULL),
(37270, '2017-07-08 10:23:36', NULL, NULL, 10808, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:23:36', 'admin-1499480008-14994806165291258', 1, 1, 'SR', NULL, NULL, NULL),
(37271, '2017-07-08 10:23:36', NULL, NULL, 10808, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:23:36', 'admin-1499480008-14994806165291258', 1, 1, 'SR', NULL, NULL, NULL),
(37272, '2017-07-08 10:22:42', NULL, NULL, 10808, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.80, 0.0000, 0.0000, 9.80, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:22:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37273, '2017-07-08 15:37:31', NULL, NULL, 10850, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 15:37:31', 'admin-1499495883-14994994508608116', 1, 1, 'SR', NULL, NULL, NULL),
(37274, '2017-07-08 10:17:27', NULL, NULL, 10807, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:17:27', 'admin-1499480008-14994802477663147', 1, 0, '', NULL, NULL, NULL),
(37275, '2017-07-08 10:16:58', NULL, NULL, 10807, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:16:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37276, '2017-07-08 10:17:27', NULL, NULL, 10807, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:17:27', 'admin-1499480008-14994802477663147', 1, 0, '', NULL, NULL, NULL),
(37277, '2017-07-08 10:16:51', NULL, NULL, 10806, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:16:51', 'admin-1499480008-14994802114328485', 1, 1, 'SR', NULL, NULL, NULL),
(37278, '2017-07-08 09:29:19', NULL, NULL, 10799, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:29:19', 'admin-1499475812-14994773593772713', 1, 1, 'SR', NULL, NULL, NULL),
(37279, '2017-07-08 09:31:35', NULL, NULL, 10799, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:31:35', 'admin-1499475812-14994774952246074', 1, 1, 'SR', NULL, NULL, NULL),
(37280, '2017-07-08 09:35:21', NULL, NULL, 10800, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:35:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37281, '2017-07-08 09:35:35', NULL, NULL, 10800, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:35:35', 'admin-1499475812-14994777356532841', 1, 0, '', NULL, NULL, NULL),
(37282, '2017-07-08 09:35:35', NULL, NULL, 10800, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:35:35', 'admin-1499475812-14994777356532841', 1, 1, 'SR', NULL, NULL, NULL),
(37283, '2017-07-08 09:28:18', NULL, NULL, 10799, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:28:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37284, '2017-07-08 09:29:19', NULL, NULL, 10799, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:29:19', 'admin-1499475812-14994773593772713', 1, 0, '', NULL, NULL, NULL),
(37285, '2017-07-08 09:29:19', NULL, NULL, 10799, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:29:19', 'admin-1499475812-14994773593772713', 1, 0, '', NULL, NULL, NULL),
(37286, '2017-07-08 10:05:03', NULL, NULL, 10802, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:05:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37287, '2017-07-08 10:17:27', NULL, NULL, 10807, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:17:27', 'admin-1499480008-14994802477663147', 1, 0, '', NULL, NULL, NULL),
(37288, '2017-07-08 10:13:44', NULL, NULL, 10805, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:13:44', 'admin-1499480008-1499480024521962', 1, 1, 'SR', NULL, NULL, NULL),
(37289, '2017-07-08 10:13:23', NULL, NULL, 10805, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:13:23', 'admin-1499477746-1499480002787633', 1, 0, '', NULL, NULL, NULL),
(37290, '2017-07-08 10:13:23', NULL, NULL, 10805, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:13:23', 'admin-1499477746-1499480002787633', 1, 0, '', NULL, NULL, NULL),
(37291, '2017-07-08 10:13:16', NULL, NULL, 10805, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:13:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37292, '2017-07-08 10:07:35', NULL, NULL, 10803, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:07:35', 'admin-1499477746-14994796549535357', 1, 1, 'SR', NULL, NULL, NULL),
(37293, '2017-07-08 10:07:35', NULL, NULL, 10803, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:07:35', 'admin-1499477746-14994796549535357', 1, 0, '', NULL, NULL, NULL),
(37294, '2017-07-08 10:55:51', NULL, NULL, 10813, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:55:51', 'admin-1499480915-14994825517065652', 1, 0, '', 1, NULL, NULL),
(37295, '2017-07-08 10:07:27', NULL, NULL, 10803, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:07:27', 'admin-1499477746-14994796475677925', 1, 0, '', NULL, NULL, NULL),
(37296, '2017-07-08 10:05:18', NULL, NULL, 10802, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:05:18', 'admin-1499477746-14994795183524533', 1, 0, '', NULL, NULL, NULL),
(37297, '2017-07-08 09:49:23', NULL, NULL, 10801, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:49:23', 'admin-1499477746-1499478563689931', 1, 1, 'SR', NULL, NULL, NULL),
(37298, '2017-07-08 09:49:23', NULL, NULL, 10801, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:49:23', 'admin-1499477746-1499478563689931', 1, 0, '', NULL, NULL, NULL),
(37299, '2017-07-08 09:49:23', NULL, NULL, 10801, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:49:23', 'admin-1499477746-1499478563689931', 1, 1, 'SR', NULL, NULL, NULL),
(37300, '2017-07-08 09:49:23', NULL, NULL, 10801, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:49:23', 'admin-1499477746-1499478563689931', 1, 0, '', NULL, NULL, NULL),
(37301, '2017-07-08 09:49:23', NULL, NULL, 10801, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:49:23', 'admin-1499477746-1499478563689931', 1, 0, '', NULL, NULL, NULL),
(37302, '2017-07-08 09:49:23', NULL, NULL, 10801, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:49:23', 'admin-1499477746-1499478563689931', 1, 0, '', NULL, NULL, NULL),
(37303, '2017-07-08 10:07:17', NULL, NULL, 10803, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1499495883', 'admin', '2017-07-08 10:07:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37304, '2017-07-08 09:42:02', NULL, NULL, 10797, 0, 181, '116', 'Open Food ', '2toast', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:42:02', 'admin-1499477746-14994781224525011', 1, 0, '', NULL, NULL, NULL),
(37305, '2017-07-08 09:48:52', NULL, NULL, 10801, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:48:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37306, '2017-07-08 09:22:25', NULL, NULL, 10798, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:22:25', 'admin-1499475812-14994769448009659', 1, 1, 'SR', NULL, NULL, NULL),
(37307, '2017-07-08 09:22:25', NULL, NULL, 10798, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:22:25', 'admin-1499475812-14994769448009659', 1, 1, 'SR', NULL, NULL, NULL),
(37308, '2017-07-08 09:22:25', NULL, NULL, 10798, 0, 32, '32', 'Tea By Pot ', 'earl grey', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:22:25', 'admin-1499475812-14994769448009659', 1, 1, 'SR', NULL, NULL, NULL),
(37309, '2017-07-08 09:22:25', NULL, NULL, 10798, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:22:25', 'admin-1499475812-14994769448009659', 1, 1, 'SR', NULL, NULL, NULL),
(37310, '2017-07-08 09:13:46', NULL, NULL, 10796, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:13:46', 'admin-1499475812-14994764259918261', 1, 0, '', NULL, NULL, NULL),
(37311, '2017-07-08 09:13:46', NULL, NULL, 10796, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:13:46', 'admin-1499475812-14994764259918261', 1, 1, 'SR', NULL, NULL, NULL),
(37312, '2017-07-08 09:22:25', NULL, NULL, 10798, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:22:25', 'admin-1499475812-14994769448009659', 1, 0, '', NULL, NULL, NULL),
(37313, '2017-07-08 12:35:14', NULL, NULL, 10826, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 12:35:14', 'admin-1499488383-1499488514232214', 1, 0, '', NULL, NULL, NULL),
(37314, '2017-07-08 09:03:48', NULL, NULL, 10795, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:03:48', 'admin-1499475812-14994758285717719', 1, 0, '', NULL, NULL, NULL),
(37315, '2017-07-08 09:13:13', NULL, NULL, 10796, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:13:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37316, '2017-07-08 09:13:46', NULL, NULL, 10796, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:13:46', 'admin-1499475812-14994764259918261', 1, 0, '', NULL, NULL, NULL),
(37317, '2017-07-08 09:13:46', NULL, NULL, 10796, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:13:46', 'admin-1499475812-14994764259918261', 1, 0, '', NULL, NULL, NULL),
(37318, '2017-07-08 09:13:46', NULL, NULL, 10796, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:13:46', 'admin-1499475812-14994764259918261', 1, 0, '', NULL, NULL, NULL),
(37319, '2017-07-08 09:03:39', NULL, NULL, 10795, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1499495883', 'admin', '2017-07-08 09:03:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37320, '2017-07-09 15:10:11', NULL, NULL, 10898, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 15:10:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37321, '2017-07-09 15:10:25', NULL, NULL, 10898, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 15:10:25', 'admin-1499579780-14995842254079887', 1, 0, '', NULL, NULL, NULL),
(37322, '2017-07-09 12:38:08', NULL, NULL, 10886, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:38:08', 'admin-1499574708-14995750886905636', 1, 1, 'SR', NULL, NULL, '10.0'),
(37323, '2017-07-09 12:38:19', NULL, NULL, 10886, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:38:19', 'admin-1499574708-14995750989175695', 1, 1, 'SR', NULL, NULL, '10.0'),
(37324, '2017-07-09 12:42:50', NULL, NULL, 10887, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:42:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37325, '2017-07-09 12:43:18', NULL, NULL, 10887, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:43:18', 'admin-1499574708-14995753979054495', 1, 0, '', NULL, NULL, NULL),
(37326, '2017-07-09 12:43:18', NULL, NULL, 10887, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:43:18', 'admin-1499574708-14995753979054495', 1, 0, '', NULL, NULL, NULL),
(37327, '2017-07-09 12:43:24', NULL, NULL, 10887, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:43:24', 'admin-1499574708-1499575404177176', 1, 1, 'SR', NULL, NULL, NULL),
(37328, '2017-07-09 12:04:08', NULL, NULL, 10882, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:04:08', 'admin-1499572088-14995730478238468', 1, 0, '', NULL, NULL, NULL),
(37329, '2017-07-09 12:04:08', NULL, NULL, 10882, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:04:08', 'admin-1499572088-14995730478238468', 1, 0, '', NULL, NULL, NULL),
(37330, '2017-07-09 13:33:15', NULL, NULL, 10892, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:33:15', 'admin-1499577344-14995783948314385', 1, 0, '', NULL, NULL, NULL),
(37331, '2017-07-09 13:36:17', NULL, NULL, 10893, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:36:17', 'admin-1499577344-14995785772756234', 1, 0, '', 1, NULL, '10.0'),
(37332, '2017-07-09 14:48:33', NULL, NULL, 10897, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 14:48:33', 'admin-1499579780-1499582913289743', 1, 0, '', NULL, NULL, NULL),
(37333, '2017-07-09 13:24:49', NULL, NULL, 10891, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:24:49', 'admin-1499577344-14995778893686459', 1, 1, 'SR', NULL, NULL, NULL),
(37334, '2017-07-09 13:24:22', NULL, NULL, 10891, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:24:22', 'admin-1499577344-14995778619079950', 1, 1, 'SR', NULL, NULL, NULL),
(37335, '2017-07-09 13:24:49', NULL, NULL, 10891, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:24:49', 'admin-1499577344-14995778893686459', 1, 1, 'SR', NULL, NULL, NULL),
(37336, '2017-07-09 13:24:49', NULL, NULL, 10891, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:24:49', 'admin-1499577344-14995778893686459', 1, 0, '', NULL, NULL, NULL),
(37337, '2017-07-09 11:39:26', NULL, NULL, 10878, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.60, 0.0000, 0.0000, 11.60, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:39:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37338, '2017-07-09 11:39:40', NULL, NULL, 10878, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:39:40', 'admin-1499568841-14995715801347997', 1, 0, '', NULL, NULL, NULL),
(37339, '2017-07-09 13:44:46', NULL, NULL, 10894, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:44:46', 'admin-1499577344-14995790864308165', 1, 0, '', NULL, NULL, NULL),
(37340, '2017-07-09 13:56:11', NULL, NULL, 10891, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:56:11', 'admin-1499577344-14995797712234634', 1, 0, '', NULL, NULL, NULL),
(37341, '2017-07-09 13:20:09', NULL, NULL, 10889, 0, 181, '116', 'Open Food ', '2pcs toast', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:20:09', 'admin-1499577344-14995776096945965', 1, 0, '', NULL, NULL, NULL),
(37342, '2017-07-09 10:13:16', NULL, NULL, 10863, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:13:16', 'admin-1499566363-14995663967183586', 1, 1, 'SR', NULL, NULL, NULL),
(37343, '2017-07-09 11:52:43', NULL, NULL, 10879, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:52:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37344, '2017-07-09 14:02:34', NULL, NULL, 10884, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 14:02:34', 'admin-1499579780-14995801539408043', 1, 0, '', NULL, NULL, NULL),
(37345, '2017-07-09 14:13:48', NULL, NULL, 10895, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 14:13:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37346, '2017-07-09 11:39:59', NULL, NULL, 10878, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:39:59', 'admin-1499568841-14995715990251923', 1, 1, 'SR', NULL, NULL, NULL),
(37347, '2017-07-09 13:06:58', NULL, NULL, 10889, 0, 181, '116', 'Open Food ', '2pcs toast', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:06:58', 'admin-1499574708-14995768182108985', 1, 0, '', NULL, NULL, NULL),
(37348, '2017-07-09 00:00:00', NULL, NULL, 10874, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:47:52', 'admin-1499566363-14995684721848918', 1, 1, 'SR', NULL, NULL, NULL),
(37349, '2017-07-09 11:24:08', NULL, NULL, 10875, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:24:08', 'admin-1499568841-1499570648212290', 1, 0, '', NULL, NULL, NULL),
(37350, '2017-07-09 11:24:08', NULL, NULL, 10875, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:24:08', 'admin-1499568841-1499570648212290', 1, 0, '', NULL, NULL, NULL),
(37351, '2017-07-09 12:35:14', NULL, NULL, 10885, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:35:14', 'admin-1499574708-1499574914052737', 1, 1, 'SR', NULL, NULL, NULL),
(37352, '2017-07-09 12:15:34', NULL, NULL, 10884, 0, 32, '32', 'Tea By Pot ', 'ginseng', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:15:34', 'admin-1499572088-14995737348159534', 1, 1, 'SR', NULL, NULL, NULL),
(37353, '2017-07-09 12:15:35', NULL, NULL, 10884, 0, 80, '80', 'Oriental Chicken Salad', 'sauce separate', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:15:35', 'admin-1499572088-14995737348159534', 1, 1, 'SR', NULL, NULL, NULL),
(37354, '2017-07-09 12:15:35', NULL, NULL, 10884, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:15:35', 'admin-1499572088-14995737348159534', 1, 0, '', NULL, NULL, NULL),
(37355, '2017-07-09 12:30:34', NULL, NULL, 10885, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 19.70, 0.0000, 0.0000, 19.70, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:30:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37356, '2017-07-09 12:31:38', NULL, NULL, 10885, 0, 153, '87', 'Wake Me Up!', 'no bake bean add potato', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:31:38', 'admin-1499572088-14995746978794792', 1, 0, '', NULL, NULL, NULL),
(37357, '2017-07-09 11:05:06', NULL, NULL, 10870, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:05:06', 'admin-1499568841-149956950663479', 1, 1, 'SR', NULL, NULL, NULL),
(37358, '2017-07-09 11:06:14', NULL, NULL, 10872, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:06:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37359, '2017-07-09 13:13:50', NULL, NULL, 10890, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:13:50', 'admin-1499574708-14995772300834896', 1, 0, '', NULL, NULL, NULL),
(37360, '2017-07-09 13:13:50', NULL, NULL, 10890, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:13:50', 'admin-1499574708-14995772300834896', 1, 0, '', NULL, NULL, NULL),
(37361, '2017-07-09 13:13:50', NULL, NULL, 10890, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:13:50', 'admin-1499574708-14995772300834896', 1, 0, '', NULL, NULL, NULL),
(37362, '2017-07-09 13:14:08', NULL, NULL, 10890, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:14:08', 'admin-1499574708-14995772478653610', 1, 1, 'SR', NULL, NULL, NULL),
(37363, '2017-07-09 11:48:01', NULL, NULL, 10878, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:48:01', 'admin-1499568841-14995720815774010', 1, 0, '', NULL, NULL, NULL),
(37364, '2017-07-09 11:48:01', NULL, NULL, 10878, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:48:01', 'admin-1499568841-14995720815774010', 1, 1, 'SR', NULL, NULL, NULL),
(37365, '2017-07-09 15:18:41', NULL, NULL, 10899, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 15:18:41', 'admin-1499579780-14995847214824455', 1, 1, 'SR', NULL, NULL, NULL),
(37366, '2017-07-09 15:18:45', NULL, NULL, 10899, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 15:18:45', 'admin-1499579780-14995847250384290', 1, 1, 'SR', NULL, NULL, NULL),
(37367, '2017-07-09 14:47:01', NULL, NULL, 10897, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1499579780', 'admin', '2017-07-09 14:47:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37368, '2017-07-09 14:47:37', NULL, NULL, 10897, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 14:47:37', 'admin-1499579780-14995828569826949', 1, 1, 'SR', NULL, NULL, NULL),
(37369, '2017-07-09 14:14:12', NULL, NULL, 10895, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 14:14:12', 'admin-1499579780-1499580852195333', 1, 0, '', NULL, NULL, NULL),
(37370, '2017-07-09 14:14:12', NULL, NULL, 10895, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 14:14:12', 'admin-1499579780-1499580852195333', 1, 0, '', NULL, NULL, NULL),
(37371, '2017-07-09 14:14:31', NULL, NULL, 10895, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 14:14:31', 'admin-1499579780-14995808708833152', 1, 1, 'SR', NULL, NULL, NULL),
(37372, '2017-07-09 14:14:31', NULL, NULL, 10895, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 14:14:31', 'admin-1499579780-14995808708833152', 1, 1, 'SR', NULL, NULL, NULL),
(37373, '2017-07-09 14:14:31', NULL, NULL, 10895, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 14:14:31', 'admin-1499579780-14995808708833152', 1, 0, '', NULL, NULL, NULL),
(37374, '2017-07-09 12:51:10', NULL, NULL, 10889, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:51:10', 'admin-1499574708-14995758700178828', 1, 1, 'SR', NULL, NULL, NULL),
(37375, '2017-07-09 12:51:10', NULL, NULL, 10889, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:51:10', 'admin-1499574708-14995758700178828', 1, 1, 'SR', NULL, NULL, NULL),
(37376, '2017-07-09 12:51:10', NULL, NULL, 10889, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:51:10', 'admin-1499574708-14995758700178828', 1, 1, 'SR', NULL, NULL, NULL),
(37377, '2017-07-09 12:51:10', NULL, NULL, 10889, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:51:10', 'admin-1499574708-14995758700178828', 1, 1, 'SR', NULL, NULL, NULL),
(37378, '2017-07-09 13:12:58', NULL, NULL, 10890, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:12:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37379, '2017-07-09 12:51:10', NULL, NULL, 10889, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:51:10', 'admin-1499574708-14995758700178828', 1, 1, 'SR', NULL, NULL, NULL),
(37380, '2017-07-09 12:31:38', NULL, NULL, 10885, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:31:38', 'admin-1499572088-14995746978794792', 1, 1, 'SR', NULL, NULL, NULL),
(37381, '2017-07-09 12:35:14', NULL, NULL, 10885, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:35:14', 'admin-1499574708-1499574914052737', 1, 0, '', NULL, NULL, NULL),
(37382, '2017-07-09 15:10:25', NULL, NULL, 10898, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 15:10:25', 'admin-1499579780-14995842254079887', 1, 1, 'SR', NULL, NULL, NULL),
(37383, '2017-07-09 15:18:36', NULL, NULL, 10899, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1499579780', 'admin', '2017-07-09 15:18:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37384, '2017-07-09 14:53:08', NULL, NULL, 10897, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 14:53:08', 'admin-1499579780-14995831882933724', 1, 0, '', NULL, NULL, NULL),
(37385, '2017-07-09 13:44:20', NULL, NULL, 10894, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:44:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37386, '2017-07-09 13:45:04', NULL, NULL, 10894, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:45:04', 'admin-1499577344-14995791038147472', 1, 0, '', NULL, NULL, NULL),
(37387, '2017-07-09 14:30:21', NULL, NULL, 10896, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 14:30:21', 'admin-1499579780-14995818216374436', 1, 1, 'SR', 1, NULL, NULL),
(37388, '2017-07-09 13:45:04', NULL, NULL, 10894, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:45:04', 'admin-1499577344-14995791038147472', 1, 0, '', NULL, NULL, NULL),
(37389, '2017-07-09 13:44:46', NULL, NULL, 10894, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:44:46', 'admin-1499577344-14995790864308165', 1, 0, '', NULL, NULL, NULL),
(37390, '2017-07-09 11:53:03', NULL, NULL, 10879, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:53:03', 'admin-1499572088-14995723828433245', 1, 1, 'SR', NULL, NULL, NULL),
(37391, '2017-07-09 14:14:12', NULL, NULL, 10895, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 14:14:12', 'admin-1499579780-1499580852195333', 1, 0, '', NULL, NULL, NULL),
(37392, '2017-07-09 12:45:06', NULL, NULL, 10888, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:45:06', 'admin-1499574708-1499575506148427', 1, 1, 'SR', NULL, NULL, NULL),
(37393, '2017-07-09 12:04:31', NULL, NULL, 10882, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:04:31', 'admin-1499572088-14995730715059648', 1, 1, 'SR', NULL, NULL, NULL),
(37394, '2017-07-09 12:04:31', NULL, NULL, 10882, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:04:31', 'admin-1499572088-14995730715059648', 1, 1, 'SR', NULL, NULL, NULL),
(37395, '2017-07-09 12:31:38', NULL, NULL, 10885, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:31:38', 'admin-1499572088-14995746978794792', 1, 0, '', NULL, NULL, NULL),
(37396, '2017-07-09 12:31:38', NULL, NULL, 10885, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:31:38', 'admin-1499572088-14995746978794792', 1, 0, '', NULL, NULL, NULL),
(37397, '2017-07-09 13:33:07', NULL, NULL, 10892, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:33:07', 'admin-1499577344-1499578387123483', 1, 0, '', NULL, NULL, NULL),
(37398, '2017-07-09 12:44:38', NULL, NULL, 10888, 0, 76, '76', 'Meatless Pesto Pasta', 'no cheese', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:44:38', 'admin-1499574708-14995754784718098', 1, 1, 'SR', NULL, NULL, NULL),
(37399, '2017-07-09 12:44:38', NULL, NULL, 10888, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:44:38', 'admin-1499574708-14995754784718098', 1, 0, '', NULL, NULL, NULL),
(37400, '2017-07-09 12:45:06', NULL, NULL, 10888, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:45:06', 'admin-1499574708-1499575506148427', 1, 1, 'SR', NULL, NULL, NULL),
(37401, '2017-07-09 13:24:22', NULL, NULL, 10891, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:24:22', 'admin-1499577344-14995778619079950', 1, 0, '', NULL, NULL, NULL),
(37402, '2017-07-09 13:15:36', NULL, NULL, 10885, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:15:36', 'admin-1499574708-14995773363948529', 1, 1, 'SR', NULL, NULL, NULL),
(37403, '2017-07-09 13:24:22', NULL, NULL, 10891, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:24:22', 'admin-1499577344-14995778619079950', 1, 0, '', NULL, NULL, NULL),
(37404, '2017-07-09 13:21:42', NULL, NULL, 10884, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:21:42', 'admin-1499577344-14995777026896145', 1, 0, '', NULL, NULL, NULL),
(37405, '2017-07-09 12:04:31', NULL, NULL, 10882, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:04:31', 'admin-1499572088-14995730715059648', 1, 1, 'SR', NULL, NULL, NULL),
(37406, '2017-07-09 12:09:09', NULL, NULL, 10883, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 19.80, 0.0000, 0.0000, 19.80, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:09:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37407, '2017-07-09 12:09:51', NULL, NULL, 10883, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:09:51', 'admin-1499572088-1499573391315722', 1, 1, 'SR', NULL, NULL, NULL),
(37408, '2017-07-09 12:09:51', NULL, NULL, 10883, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:09:51', 'admin-1499572088-1499573391315722', 1, 0, '', NULL, NULL, NULL),
(37409, '2017-07-09 12:09:51', NULL, NULL, 10883, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:09:51', 'admin-1499572088-1499573391315722', 1, 0, '', NULL, NULL, NULL),
(37410, '2017-07-09 12:04:08', NULL, NULL, 10882, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:04:08', 'admin-1499572088-14995730478238468', 1, 0, '', NULL, NULL, NULL),
(37411, '2017-07-09 12:04:08', NULL, NULL, 10882, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:04:08', 'admin-1499572088-14995730478238468', 1, 0, '', NULL, NULL, NULL),
(37412, '2017-07-09 13:16:07', NULL, NULL, 10885, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:16:07', 'admin-1499577344-1499577367583497', 1, 1, 'SR', NULL, NULL, NULL),
(37413, '2017-07-09 13:16:07', NULL, NULL, 10885, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:16:07', 'admin-1499577344-1499577367583497', 1, 0, '', NULL, NULL, NULL),
(37414, '2017-07-09 11:06:28', NULL, NULL, 10872, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:06:28', 'admin-1499568841-14995695878552620', 1, 0, '', NULL, NULL, NULL),
(37415, '2017-07-09 11:06:28', NULL, NULL, 10872, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:06:28', 'admin-1499568841-14995695878552620', 1, 1, 'SR', NULL, NULL, NULL),
(37416, '2017-07-09 12:37:51', NULL, NULL, 10886, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:37:51', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(37417, '2017-07-09 10:37:09', NULL, NULL, 10865, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:37:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37418, '2017-07-09 10:37:22', NULL, NULL, 10865, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:37:22', 'admin-1499566363-14995678424187351', 1, 0, '', NULL, NULL, NULL),
(37419, '2017-07-09 10:13:16', NULL, NULL, 10863, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:13:16', 'admin-1499566363-14995663967183586', 1, 1, 'SR', NULL, NULL, NULL),
(37420, '2017-07-09 10:21:10', NULL, NULL, 10863, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:21:10', 'admin-1499566363-1499566869903233', 1, 1, 'SR', NULL, NULL, NULL),
(37421, '2017-07-09 09:31:03', NULL, NULL, 10860, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 09:31:03', 'admin-1499560967-14995638636759513', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(37422, '2017-07-09 09:30:53', NULL, NULL, 10860, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1499579780', 'admin', '2017-07-09 09:30:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37423, '2017-07-09 12:50:30', NULL, NULL, 10889, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.40, 0.0000, 0.0000, 11.40, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:50:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37424, '2017-07-09 12:51:10', NULL, NULL, 10889, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:51:10', 'admin-1499574708-14995758700178828', 1, 0, '', NULL, NULL, NULL),
(37425, '2017-07-09 13:13:50', NULL, NULL, 10890, 0, 217, '151', 'Spicy Lemony Wings', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:13:50', 'admin-1499574708-14995772300834896', 1, 0, '', NULL, NULL, NULL),
(37426, '2017-07-09 12:51:10', NULL, NULL, 10889, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:51:10', 'admin-1499574708-14995758700178828', 1, 1, 'SR', NULL, NULL, NULL),
(37427, '2017-07-09 12:51:10', NULL, NULL, 10889, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:51:10', 'admin-1499574708-14995758700178828', 1, 0, '', NULL, NULL, NULL),
(37428, '2017-07-09 12:45:06', NULL, NULL, 10888, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:45:06', 'admin-1499574708-1499575506148427', 1, 1, 'SR', NULL, NULL, NULL),
(37429, '2017-07-09 13:33:07', NULL, NULL, 10892, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:33:07', 'admin-1499577344-1499578387123483', 1, 1, 'SR', NULL, NULL, NULL),
(37430, '2017-07-09 13:32:54', NULL, NULL, 10892, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:32:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37431, '2017-07-09 12:45:06', NULL, NULL, 10888, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:45:06', 'admin-1499574708-1499575506148427', 1, 1, 'SR', NULL, NULL, NULL),
(37432, '2017-07-09 12:45:06', NULL, NULL, 10888, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:45:06', 'admin-1499574708-1499575506148427', 1, 0, '', NULL, NULL, NULL),
(37433, '2017-07-09 12:45:06', NULL, NULL, 10888, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:45:06', 'admin-1499574708-1499575506148427', 1, 1, 'SR', NULL, NULL, NULL),
(37434, '2017-07-09 12:44:38', NULL, NULL, 10888, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:44:38', 'admin-1499574708-14995754784718098', 1, 0, '', NULL, NULL, NULL),
(37435, '2017-07-09 11:30:25', NULL, NULL, 10876, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:30:25', 'admin-1499568841-14995710256058143', 1, 0, '', NULL, NULL, NULL),
(37436, '2017-07-09 11:30:25', NULL, NULL, 10876, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:30:25', 'admin-1499568841-14995710256058143', 1, 1, 'SR', NULL, NULL, NULL),
(37437, '2017-07-09 12:11:09', NULL, NULL, 10883, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:11:09', 'admin-1499572088-14995734689144943', 1, 1, 'SR', NULL, NULL, NULL),
(37438, '2017-07-09 12:11:09', NULL, NULL, 10883, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:11:09', 'admin-1499572088-14995734689144943', 1, 1, 'SR', NULL, NULL, NULL),
(37439, '2017-07-09 12:11:09', NULL, NULL, 10883, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:11:09', 'admin-1499572088-14995734689144943', 1, 1, 'SR', NULL, NULL, NULL),
(37440, '2017-07-09 12:11:09', NULL, NULL, 10883, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:11:09', 'admin-1499572088-14995734689144943', 1, 0, '', NULL, NULL, NULL),
(37441, '2017-07-09 12:43:53', NULL, NULL, 10888, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.80, 0.0000, 0.0000, 10.80, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:43:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37442, '2017-07-09 12:35:14', NULL, NULL, 10885, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:35:14', 'admin-1499574708-1499574914052737', 1, 1, 'SR', NULL, NULL, NULL),
(37443, '2017-07-09 12:35:14', NULL, NULL, 10885, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:35:14', 'admin-1499574708-1499574914052737', 1, 1, 'SR', NULL, NULL, NULL),
(37444, '2017-07-09 12:31:38', NULL, NULL, 10885, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:31:38', 'admin-1499572088-14995746978794792', 1, 0, '', NULL, NULL, NULL),
(37445, '2017-07-09 12:11:09', NULL, NULL, 10883, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:11:09', 'admin-1499572088-14995734689144943', 1, 1, 'SR', NULL, NULL, NULL),
(37446, '2017-07-09 12:14:41', NULL, NULL, 10884, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:14:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37447, '2017-07-09 12:11:09', NULL, NULL, 10883, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:11:09', 'admin-1499572088-14995734689144943', 1, 1, 'SR', NULL, NULL, NULL),
(37448, '2017-07-09 12:11:09', NULL, NULL, 10883, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:11:09', 'admin-1499572088-14995734689144943', 1, 1, 'SR', NULL, NULL, NULL),
(37449, '2017-07-09 12:11:09', NULL, NULL, 10883, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:11:09', 'admin-1499572088-14995734689144943', 1, 0, '', NULL, NULL, NULL),
(37450, '2017-07-09 12:10:11', NULL, NULL, 10883, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:10:11', 'admin-1499572088-1499573411291452', 1, 0, '', NULL, NULL, NULL),
(37451, '2017-07-09 12:10:11', NULL, NULL, 10883, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:10:11', 'admin-1499572088-1499573411291452', 1, 0, '', NULL, NULL, NULL),
(37452, '2017-07-09 12:09:51', NULL, NULL, 10883, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:09:51', 'admin-1499572088-1499573391315722', 1, 0, '', NULL, NULL, NULL),
(37453, '2017-07-09 12:09:51', NULL, NULL, 10883, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:09:51', 'admin-1499572088-1499573391315722', 1, 0, '', NULL, NULL, NULL),
(37454, '2017-07-09 13:24:03', NULL, NULL, 10891, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:24:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37455, '2017-07-09 00:00:00', NULL, NULL, 10874, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, NULL, NULL, 1.10, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:47:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37456, '2017-07-09 11:15:22', NULL, NULL, 10873, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:15:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37457, '2017-07-09 10:49:38', NULL, NULL, 10869, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:49:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37458, '2017-07-09 10:37:22', NULL, NULL, 10865, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:37:22', 'admin-1499566363-14995678424187351', 1, 1, 'SR', NULL, NULL, NULL),
(37459, '2017-07-09 10:37:22', NULL, NULL, 10865, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:37:22', 'admin-1499566363-14995678424187351', 1, 1, 'SR', NULL, NULL, NULL),
(37460, '2017-07-09 10:42:57', NULL, NULL, 10866, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:42:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37461, '2017-07-09 10:43:03', NULL, NULL, 10866, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:43:03', 'admin-1499566363-14995681828181468', 1, 1, 'SR', NULL, NULL, NULL),
(37462, '2017-07-09 10:43:07', NULL, NULL, 10867, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:43:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37463, '2017-07-09 10:43:20', NULL, NULL, 10867, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:43:20', 'admin-1499566363-14995682003127015', 1, 0, '', NULL, NULL, NULL),
(37464, '2017-07-09 10:43:20', NULL, NULL, 10867, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:43:20', 'admin-1499566363-14995682003127015', 1, 0, '', NULL, NULL, NULL),
(37465, '2017-07-09 10:43:32', NULL, NULL, 10867, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:43:32', 'admin-1499566363-14995682119857674', 1, 1, 'SR', NULL, NULL, NULL),
(37466, '2017-07-09 10:43:32', NULL, NULL, 10867, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:43:32', 'admin-1499566363-14995682119857674', 1, 1, 'SR', NULL, NULL, NULL),
(37467, '2017-07-09 11:59:09', NULL, NULL, 10881, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:59:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37468, '2017-07-09 12:00:23', NULL, NULL, 10881, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:00:23', 'admin-1499572088-14995728231917763', 1, 1, 'SR', NULL, NULL, NULL),
(37469, '2017-07-09 12:00:23', NULL, NULL, 10881, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:00:23', 'admin-1499572088-14995728231917763', 1, 0, '', NULL, NULL, NULL),
(37470, '2017-07-09 12:04:08', NULL, NULL, 10882, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:04:08', 'admin-1499572088-14995730478238468', 1, 0, '', NULL, NULL, NULL),
(37471, '2017-07-09 11:53:27', NULL, NULL, 10880, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:53:27', 'admin-1499572088-14995724069174995', 1, 1, 'SR', NULL, NULL, NULL),
(37472, '2017-07-09 11:53:27', NULL, NULL, 10880, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:53:27', 'admin-1499572088-14995724069174995', 1, 0, '', NULL, NULL, NULL),
(37473, '2017-07-09 11:53:03', NULL, NULL, 10879, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:53:03', 'admin-1499572088-14995723828433245', 1, 1, 'SR', NULL, NULL, NULL),
(37474, '2017-07-09 11:53:03', NULL, NULL, 10879, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:53:03', 'admin-1499572088-14995723828433245', 1, 0, '', NULL, NULL, NULL),
(37475, '2017-07-09 10:28:29', NULL, NULL, 10864, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:28:29', 'admin-1499566363-14995673097281571', 1, 0, '', NULL, NULL, NULL),
(37476, '2017-07-09 11:53:08', NULL, NULL, 10880, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:53:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37477, '2017-07-09 11:53:03', NULL, NULL, 10879, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:53:03', 'admin-1499572088-14995723828433245', 1, 0, '', NULL, NULL, NULL),
(37478, '2017-07-09 11:39:59', NULL, NULL, 10878, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:39:59', 'admin-1499568841-14995715990251923', 1, 0, '', NULL, NULL, NULL),
(37479, '2017-07-09 11:39:59', NULL, NULL, 10878, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:39:59', 'admin-1499568841-14995715990251923', 1, 1, 'SR', NULL, NULL, NULL),
(37480, '2017-07-09 10:50:14', NULL, NULL, 10869, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:50:14', 'admin-1499566363-14995686141333111', 1, 0, '', NULL, NULL, NULL),
(37481, '2017-07-09 10:50:14', NULL, NULL, 10869, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:50:14', 'admin-1499566363-14995686141333111', 1, 1, 'SR', NULL, NULL, NULL),
(37482, '2017-07-09 10:50:35', NULL, NULL, 10869, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:50:35', 'admin-1499566363-14995686349303171', 1, 1, 'SR', NULL, NULL, NULL),
(37483, '2017-07-09 10:53:00', NULL, NULL, 10870, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.00, 0.0000, 0.0000, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:53:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37484, '2017-07-09 10:53:55', NULL, NULL, 10870, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:53:55', 'admin-1499566363-14995688349537826', 1, 0, '', NULL, NULL, NULL),
(37485, '2017-07-09 10:53:55', NULL, NULL, 10870, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:53:55', 'admin-1499566363-14995688349537826', 1, 0, '', NULL, NULL, NULL),
(37486, '2017-07-09 11:39:40', NULL, NULL, 10878, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:39:40', 'admin-1499568841-14995715801347997', 1, 0, '', NULL, NULL, NULL),
(37487, '2017-07-09 11:39:40', NULL, NULL, 10878, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:39:40', 'admin-1499568841-14995715801347997', 1, 0, '', NULL, NULL, NULL),
(37488, '2017-07-09 11:36:57', NULL, NULL, 10877, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:36:57', 'admin-1499568841-14995714173842630', 1, 0, '', NULL, NULL, NULL),
(37489, '2017-07-09 11:36:57', NULL, NULL, 10877, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:36:57', 'admin-1499568841-14995714173842630', 1, 0, '', NULL, NULL, NULL),
(37490, '2017-07-09 11:36:46', NULL, NULL, 10877, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:36:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37491, '2017-07-09 11:36:57', NULL, NULL, 10877, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:36:57', 'admin-1499568841-14995714173842630', 1, 1, 'SR', NULL, NULL, NULL),
(37492, '2017-07-09 11:30:25', NULL, NULL, 10876, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:30:25', 'admin-1499568841-14995710256058143', 1, 0, '', NULL, NULL, NULL),
(37493, '2017-07-09 11:30:12', NULL, NULL, 10876, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:30:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37494, '2017-07-09 10:53:55', NULL, NULL, 10870, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:53:55', 'admin-1499566363-14995688349537826', 1, 0, '', NULL, NULL, NULL),
(37495, '2017-07-09 11:24:08', NULL, NULL, 10875, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:24:08', 'admin-1499568841-1499570648212290', 1, 1, 'SR', NULL, NULL, NULL),
(37496, '2017-07-09 11:24:08', NULL, NULL, 10875, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:24:08', 'admin-1499568841-1499570648212290', 1, 1, 'SR', NULL, NULL, NULL),
(37497, '2017-07-09 10:59:58', NULL, NULL, 10871, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:59:58', 'admin-1499568841-14995691985432530', 1, 1, 'SR', NULL, NULL, NULL),
(37498, '2017-07-09 10:59:58', NULL, NULL, 10871, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:59:58', 'admin-1499568841-14995691985432530', 1, 0, '', NULL, NULL, NULL),
(37499, '2017-07-09 10:59:45', NULL, NULL, 10871, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:59:45', 'admin-1499568841-14995691850158385', 1, 0, '', NULL, NULL, NULL),
(37500, '2017-07-09 10:59:36', NULL, NULL, 10871, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:59:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37501, '2017-07-09 10:53:55', NULL, NULL, 10870, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:53:55', 'admin-1499566363-14995688349537826', 1, 1, 'SR', NULL, NULL, NULL),
(37502, '2017-07-09 10:53:55', NULL, NULL, 10870, 0, 32, '32', 'Tea By Pot ', 'earl grey', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:53:55', 'admin-1499566363-14995688349537826', 1, 1, 'SR', NULL, NULL, NULL),
(37503, '2017-07-09 10:01:46', NULL, NULL, 10862, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:01:46', 'admin-1499560967-14995657058427332', 1, 0, '', NULL, NULL, NULL),
(37504, '2017-07-09 10:12:12', NULL, NULL, 10863, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:12:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37505, '2017-07-09 10:12:24', NULL, NULL, 10863, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:12:24', 'admin-1499560967-14995663438894266', 1, 0, '', NULL, NULL, NULL),
(37506, '2017-07-09 09:26:09', NULL, NULL, 10859, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 09:26:09', 'admin-1499560967-14995635692684410', 1, 0, '', NULL, NULL, NULL),
(37507, '2017-07-09 10:53:55', NULL, NULL, 10870, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:53:55', 'admin-1499566363-14995688349537826', 1, 0, '', NULL, NULL, NULL),
(37508, '2017-07-09 10:50:14', NULL, NULL, 10869, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:50:14', 'admin-1499566363-14995686141333111', 1, 0, '', NULL, NULL, NULL),
(37509, '2017-07-09 10:50:14', NULL, NULL, 10869, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:50:14', 'admin-1499566363-14995686141333111', 1, 0, '', NULL, NULL, NULL),
(37510, '2017-07-09 10:50:14', NULL, NULL, 10869, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:50:14', 'admin-1499566363-14995686141333111', 1, 0, '', NULL, NULL, NULL),
(37511, '2017-07-09 12:03:33', NULL, NULL, 10882, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.80, 0.0000, 0.0000, 10.80, 1, '27', 1, '1499579780', 'admin', '2017-07-09 12:03:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37512, '2017-07-09 00:00:00', NULL, NULL, 10873, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:47:52', 'admin-1499566363-14995684721848918', 1, 0, '', NULL, NULL, NULL),
(37513, '2017-07-09 11:23:33', NULL, NULL, 10875, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1499579780', 'admin', '2017-07-09 11:23:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37514, '2017-07-09 10:53:55', NULL, NULL, 10870, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:53:55', 'admin-1499566363-14995688349537826', 1, 0, '', NULL, NULL, NULL),
(37515, '2017-07-09 10:37:22', NULL, NULL, 10865, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:37:22', 'admin-1499566363-14995678424187351', 1, 1, 'SR', NULL, NULL, NULL),
(37516, '2017-07-09 13:15:36', NULL, NULL, 10885, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 13:15:36', 'admin-1499574708-14995773363948529', 1, 1, 'SR', NULL, NULL, NULL),
(37517, '2017-07-09 10:37:22', NULL, NULL, 10865, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:37:22', 'admin-1499566363-14995678424187351', 1, 0, '', NULL, NULL, NULL),
(37518, '2017-07-09 10:28:49', NULL, NULL, 10864, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:28:49', 'admin-1499566363-14995673294744551', 1, 0, '', NULL, NULL, NULL),
(37519, '2017-07-09 00:00:00', NULL, NULL, 10873, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:47:52', 'admin-1499566363-14995684721848918', 1, 0, '', NULL, NULL, NULL),
(37520, '2017-07-09 10:28:49', NULL, NULL, 10864, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:28:49', 'admin-1499566363-14995673294744551', 1, 1, 'SR', NULL, NULL, NULL),
(37521, '2017-07-09 10:28:49', NULL, NULL, 10864, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:28:49', 'admin-1499566363-14995673294744551', 1, 0, '', NULL, NULL, NULL),
(37522, '2017-07-09 10:28:49', NULL, NULL, 10864, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:28:49', 'admin-1499566363-14995673294744551', 1, 0, '', NULL, NULL, NULL),
(37523, '2017-07-09 10:28:29', NULL, NULL, 10864, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:28:29', 'admin-1499566363-14995673097281571', 1, 0, '', NULL, NULL, NULL),
(37524, '2017-07-09 10:28:11', NULL, NULL, 10864, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:28:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37525, '2017-07-09 10:13:02', NULL, NULL, 10863, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:13:02', 'admin-1499566363-14995663823762472', 1, 0, '', NULL, NULL, NULL),
(37526, '2017-07-09 09:42:19', NULL, NULL, 10861, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 09:42:19', 'admin-1499560967-14995645397232745', 1, 0, '', NULL, NULL, NULL),
(37527, '2017-07-09 09:42:19', NULL, NULL, 10861, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 09:42:19', 'admin-1499560967-14995645397232745', 1, 0, '', NULL, NULL, NULL),
(37528, '2017-07-09 09:42:28', NULL, NULL, 10861, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 09:42:28', 'admin-1499560967-1499564548467208', 1, 1, 'SR', NULL, NULL, NULL),
(37529, '2017-07-09 09:42:28', NULL, NULL, 10861, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 09:42:28', 'admin-1499560967-1499564548467208', 1, 1, 'SR', NULL, NULL, NULL),
(37530, '2017-07-09 09:42:06', NULL, NULL, 10861, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1499579780', 'admin', '2017-07-09 09:42:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37531, '2017-07-09 09:31:03', NULL, NULL, 10860, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 09:31:03', 'admin-1499560967-14995638636759513', 1, 1, 'SR', NULL, NULL, NULL),
(37532, '2017-07-09 09:42:01', NULL, NULL, 10859, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 09:42:01', 'admin-1499560967-14995645214808583', 1, 0, '', NULL, NULL, NULL),
(37533, '2017-07-09 10:01:32', NULL, NULL, 10862, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:01:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37534, '2017-07-09 09:26:15', NULL, NULL, 10859, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 09:26:15', 'admin-1499560967-14995635756852426', 1, 1, 'SR', NULL, NULL, NULL),
(37535, '2017-07-09 10:01:46', NULL, NULL, 10862, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 10:01:46', 'admin-1499560967-14995657058427332', 1, 1, 'SR', NULL, NULL, NULL),
(37536, '2017-07-09 09:25:59', NULL, NULL, 10859, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1499579780', 'admin', '2017-07-09 09:25:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37537, '2017-07-09 09:03:17', NULL, NULL, 10858, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 09:03:17', 'admin-1499560967-14995621971159184', 1, 1, 'SR', NULL, NULL, NULL),
(37538, '2017-07-09 09:03:12', NULL, NULL, 10858, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499579780', 'admin', '2017-07-09 09:03:12', 'admin-1499560967-14995621920678730', 1, 0, '', NULL, NULL, NULL),
(37539, '2017-07-09 09:03:02', NULL, NULL, 10858, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1499579780', 'admin', '2017-07-09 09:03:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37540, '2017-07-10 14:20:59', NULL, NULL, 10933, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 14:20:59', 'admin-1499662074-14996676591445630', 1, 1, 'SR', NULL, NULL, NULL),
(37541, '2017-07-10 11:49:05', NULL, NULL, 10922, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1499662074', 'admin', '2017-07-10 11:49:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37542, '2017-07-10 11:49:12', NULL, NULL, 10922, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 11:49:12', 'admin-1499655310-14996585524786878', 1, 0, '', NULL, NULL, NULL),
(37543, '2017-07-10 11:49:18', NULL, NULL, 10922, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 11:49:18', 'admin-1499655310-14996585583364216', 1, 1, 'SR', NULL, NULL, NULL),
(37544, '2017-07-10 11:55:27', NULL, NULL, 10921, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 11:55:27', 'admin-1499655310-1499658926832396', 1, 1, 'SR', NULL, NULL, NULL),
(37545, '2017-07-10 12:00:33', NULL, NULL, 10923, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1499662074', 'admin', '2017-07-10 12:00:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37546, '2017-07-10 12:00:43', NULL, NULL, 10923, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 12:00:43', 'admin-1499655310-14996592436821383', 1, 0, '', NULL, NULL, NULL),
(37547, '2017-07-10 10:46:54', NULL, NULL, 10914, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:46:54', 'admin-1499652714-1499654813987778', 1, 1, 'SR', NULL, NULL, NULL),
(37548, '2017-07-10 13:52:09', NULL, NULL, 10932, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:52:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37549, '2017-07-10 13:52:36', NULL, NULL, 10932, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:52:36', 'admin-1499662074-14996659563864079', 1, 0, '', NULL, NULL, NULL),
(37550, '2017-07-10 13:52:36', NULL, NULL, 10932, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:52:36', 'admin-1499662074-14996659563864079', 1, 0, '', NULL, NULL, NULL),
(37551, '2017-07-10 13:52:50', NULL, NULL, 10932, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:52:50', 'admin-1499662074-14996659702872942', 1, 1, 'SR', NULL, NULL, NULL),
(37552, '2017-07-10 12:56:27', NULL, NULL, 10926, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1499662074', 'admin', '2017-07-10 12:56:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37553, '2017-07-10 12:00:43', NULL, NULL, 10923, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 12:00:43', 'admin-1499655310-14996592436821383', 1, 1, 'SR', NULL, NULL, NULL),
(37554, '2017-07-10 10:54:53', NULL, NULL, 10917, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:54:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37555, '2017-07-10 10:55:06', NULL, NULL, 10917, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:55:06', 'admin-1499652714-14996553058765586', 1, 0, '', NULL, NULL, NULL),
(37556, '2017-07-10 14:42:38', NULL, NULL, 10936, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 14:42:38', 'admin-1499662074-14996689587203638', 1, 1, 'SR', NULL, NULL, NULL),
(37557, '2017-07-10 14:36:00', NULL, NULL, 10935, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1499662074', 'admin', '2017-07-10 14:36:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37558, '2017-07-10 14:36:03', NULL, NULL, 10935, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 14:36:03', 'admin-1499662074-14996685630725744', 1, 1, 'SR', NULL, NULL, NULL),
(37559, '2017-07-10 10:52:40', NULL, NULL, 10916, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:52:40', 'admin-1499652714-1499655160612562', 1, 1, 'SR', NULL, NULL, NULL),
(37560, '2017-07-10 10:09:31', NULL, NULL, 10911, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:09:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37561, '2017-07-10 14:11:35', NULL, NULL, 10933, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 14:11:35', 'admin-1499662074-1499667095770428', 1, 0, '', NULL, NULL, NULL),
(37562, '2017-07-10 10:06:40', NULL, NULL, 10910, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:06:40', 'admin-1499650469-14996523997915187', 1, 1, 'SR', NULL, NULL, NULL),
(37563, '2017-07-10 09:54:14', NULL, NULL, 10909, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:54:14', 'admin-1499650469-14996516547317917', 1, 1, 'SR', NULL, NULL, NULL),
(37564, '2017-07-10 10:06:35', NULL, NULL, 10910, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:06:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37565, '2017-07-10 10:06:40', NULL, NULL, 10910, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:06:40', 'admin-1499650469-14996523997915187', 1, 0, '', NULL, NULL, NULL),
(37566, '2017-07-10 11:34:12', NULL, NULL, 10920, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1499662074', 'admin', '2017-07-10 11:34:12', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(37567, '2017-07-10 12:56:45', NULL, NULL, 10926, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 12:56:45', 'admin-1499662074-14996626051587342', 1, 1, 'SR', NULL, NULL, NULL),
(37568, '2017-07-10 10:46:54', NULL, NULL, 10914, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:46:54', 'admin-1499652714-1499654813987778', 1, 0, '', NULL, NULL, NULL),
(37569, '2017-07-10 10:46:54', NULL, NULL, 10914, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:46:54', 'admin-1499652714-1499654813987778', 1, 0, '', NULL, NULL, NULL),
(37570, '2017-07-10 14:53:18', NULL, NULL, 10939, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 14:53:18', 'admin-1499662074-14996695981922622', 1, 0, '', NULL, NULL, NULL),
(37571, '2017-07-10 13:56:05', NULL, NULL, 10933, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:56:05', 'admin-1499662074-14996661649679088', 1, 1, 'SR', NULL, NULL, NULL),
(37572, '2017-07-10 13:56:05', NULL, NULL, 10933, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:56:05', 'admin-1499662074-14996661649679088', 1, 0, '', NULL, NULL, NULL),
(37573, '2017-07-10 13:56:05', NULL, NULL, 10933, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:56:05', 'admin-1499662074-14996661649679088', 1, 0, '', NULL, NULL, NULL),
(37574, '2017-07-10 14:08:40', NULL, NULL, 10928, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 14:08:40', 'admin-1499662074-14996669202726893', 1, 0, '', NULL, NULL, NULL),
(37575, '2017-07-10 11:01:45', NULL, NULL, 10918, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 11:01:45', 'admin-1499655310-14996557053629423', 1, 0, '', NULL, NULL, NULL),
(37576, '2017-07-10 10:46:42', NULL, NULL, 10914, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:46:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37577, '2017-07-10 10:46:54', NULL, NULL, 10914, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:46:54', 'admin-1499652714-1499654813987778', 1, 0, '', NULL, NULL, NULL),
(37578, '2017-07-10 16:45:09', NULL, NULL, 10943, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 16:45:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37579, '2017-07-10 16:45:19', NULL, NULL, 10943, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 16:45:19', 'admin-1499662074-1499676319506374', 1, 0, '', NULL, NULL, NULL),
(37580, '2017-07-10 17:06:33', NULL, NULL, 10944, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 17:06:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37581, '2017-07-10 15:26:28', NULL, NULL, 10940, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 15:26:28', 'admin-1499662074-14996715879179784', 1, 1, 'SR', NULL, NULL, NULL),
(37582, '2017-07-10 15:26:28', NULL, NULL, 10940, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 15:26:28', 'admin-1499662074-14996715879179784', 1, 1, 'SR', NULL, NULL, NULL),
(37583, '2017-07-10 15:26:28', NULL, NULL, 10940, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 15:26:28', 'admin-1499662074-14996715879179784', 1, 1, 'SR', NULL, NULL, NULL),
(37584, '2017-07-10 15:26:28', NULL, NULL, 10940, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 15:26:28', 'admin-1499662074-14996715879179784', 1, 0, '', NULL, NULL, NULL),
(37585, '2017-07-10 13:45:14', NULL, NULL, 10931, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:45:14', 'admin-1499662074-14996655140577863', 1, 1, 'SR', NULL, NULL, NULL),
(37586, '2017-07-10 13:45:14', NULL, NULL, 10931, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:45:14', 'admin-1499662074-14996655140577863', 1, 0, '', NULL, NULL, NULL),
(37587, '2017-07-10 13:45:14', NULL, NULL, 10931, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:45:14', 'admin-1499662074-14996655140577863', 1, 0, '', NULL, NULL, NULL),
(37588, '2017-07-10 13:45:14', NULL, NULL, 10931, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:45:14', 'admin-1499662074-14996655140577863', 1, 1, 'SR', NULL, NULL, NULL),
(37589, '2017-07-10 13:45:14', NULL, NULL, 10931, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:45:14', 'admin-1499662074-14996655140577863', 1, 1, 'SR', NULL, NULL, NULL),
(37590, '2017-07-10 13:52:50', NULL, NULL, 10932, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:52:50', 'admin-1499662074-14996659702872942', 1, 0, '', NULL, NULL, NULL),
(37591, '2017-07-10 13:55:55', NULL, NULL, 10933, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:55:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37592, '2017-07-10 14:43:25', NULL, NULL, 10937, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1499662074', 'admin', '2017-07-10 14:43:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37593, '2017-07-10 13:22:03', NULL, NULL, 10928, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:22:03', 'admin-1499662074-14996641236505684', 1, 1, 'SR', NULL, NULL, NULL),
(37594, '2017-07-10 17:06:37', NULL, NULL, 10944, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 17:06:37', 'admin-1499662074-14996775969926677', 1, 1, 'SR', NULL, NULL, NULL),
(37595, '2017-07-10 15:16:50', NULL, NULL, 10941, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 15:16:50', 'admin-1499662074-1499671010167941', 1, 1, 'SR', 1, NULL, '10.0'),
(37596, '2017-07-10 15:16:50', NULL, NULL, 10941, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 15:16:50', 'admin-1499662074-1499671010167941', 1, 1, 'SR', 1, NULL, '10.0'),
(37597, '2017-07-10 14:53:18', NULL, NULL, 10939, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 14:53:18', 'admin-1499662074-14996695981922622', 1, 0, '', NULL, NULL, NULL),
(37598, '2017-07-10 14:53:18', NULL, NULL, 10939, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 14:53:18', 'admin-1499662074-14996695981922622', 1, 1, 'SR', NULL, NULL, NULL),
(37599, '2017-07-10 13:45:14', NULL, NULL, 10931, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:45:14', 'admin-1499662074-14996655140577863', 1, 1, 'SR', NULL, NULL, NULL),
(37600, '2017-07-10 13:33:35', NULL, NULL, 10930, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:33:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37601, '2017-07-10 13:33:39', NULL, NULL, 10930, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:33:39', 'admin-1499662074-14996648190848817', 1, 0, '', NULL, NULL, NULL),
(37602, '2017-07-10 13:39:40', NULL, NULL, 10919, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:39:40', 'admin-1499662074-14996651799466088', 1, 0, '', NULL, NULL, NULL),
(37603, '2017-07-10 09:48:25', NULL, NULL, 10907, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:48:25', 'admin-1499650469-1499651304828364', 1, 1, 'SR', NULL, NULL, NULL),
(37604, '2017-07-10 14:53:18', NULL, NULL, 10939, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 14:53:18', 'admin-1499662074-14996695981922622', 1, 0, '', NULL, NULL, NULL),
(37605, '2017-07-10 12:42:25', NULL, NULL, 10924, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1499662074', 'admin', '2017-07-10 12:42:25', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(37606, '2017-07-10 12:43:04', NULL, NULL, 10924, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 12:43:04', 'admin-1499655310-14996617841749014', 1, 0, '', NULL, NULL, NULL),
(37607, '2017-07-10 10:52:40', NULL, NULL, 10916, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:52:40', 'admin-1499652714-1499655160612562', 1, 0, '', NULL, NULL, NULL),
(37608, '2017-07-10 16:32:54', NULL, NULL, 10942, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1499662074', 'admin', '2017-07-10 16:32:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37609, '2017-07-10 16:32:59', NULL, NULL, 10942, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 16:32:59', 'admin-1499662074-14996755794986478', 1, 1, 'SR', NULL, NULL, NULL),
(37610, '2017-07-10 14:43:33', NULL, NULL, 10937, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 14:43:33', 'admin-1499662074-14996690131016374', 1, 1, 'SR', NULL, NULL, NULL),
(37611, '2017-07-10 14:43:33', NULL, NULL, 10937, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 14:43:33', 'admin-1499662074-14996690131016374', 1, 1, 'SR', NULL, NULL, NULL),
(37612, '2017-07-10 14:42:35', NULL, NULL, 10936, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1499662074', 'admin', '2017-07-10 14:42:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37613, '2017-07-10 13:25:48', NULL, NULL, 10929, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:25:48', 'admin-1499662074-14996643478622165', 1, 1, 'SR', NULL, NULL, NULL),
(37614, '2017-07-10 09:48:06', NULL, NULL, 10907, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:48:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37615, '2017-07-10 10:45:29', NULL, NULL, 10913, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:45:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37616, '2017-07-10 10:45:38', NULL, NULL, 10913, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:45:38', 'admin-1499652714-14996547386563132', 1, 0, '', NULL, NULL, NULL),
(37617, '2017-07-10 10:45:38', NULL, NULL, 10913, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:45:38', 'admin-1499652714-14996547386563132', 1, 0, '', NULL, NULL, NULL),
(37618, '2017-07-10 10:45:38', NULL, NULL, 10913, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:45:38', 'admin-1499652714-14996547386563132', 1, 1, 'SR', NULL, NULL, NULL),
(37619, '2017-07-10 10:45:38', NULL, NULL, 10913, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:45:38', 'admin-1499652714-14996547386563132', 1, 1, 'SR', NULL, NULL, NULL),
(37620, '2017-07-10 14:10:08', NULL, NULL, 10934, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 14:10:08', 'admin-1499662074-1499667008388718', 1, 1, 'SR', NULL, NULL, NULL),
(37621, '2017-07-10 14:10:03', NULL, NULL, 10934, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1499662074', 'admin', '2017-07-10 14:10:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37622, '2017-07-10 13:56:05', NULL, NULL, 10933, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:56:05', 'admin-1499662074-14996661649679088', 1, 1, 'SR', NULL, NULL, NULL),
(37623, '2017-07-10 13:45:14', NULL, NULL, 10931, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:45:14', 'admin-1499662074-14996655140577863', 1, 0, '', NULL, NULL, NULL),
(37624, '2017-07-10 13:45:14', NULL, NULL, 10931, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:45:14', 'admin-1499662074-14996655140577863', 1, 0, '', NULL, NULL, NULL),
(37625, '2017-07-10 14:53:18', NULL, NULL, 10939, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 14:53:18', 'admin-1499662074-14996695981922622', 1, 0, '', NULL, NULL, NULL),
(37626, '2017-07-10 13:25:48', NULL, NULL, 10929, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:25:48', 'admin-1499662074-14996643478622165', 1, 1, 'SR', NULL, NULL, NULL),
(37627, '2017-07-10 13:44:37', NULL, NULL, 10931, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.90, 0.0000, 0.0000, 10.90, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:44:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37628, '2017-07-10 13:39:40', NULL, NULL, 10919, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:39:40', 'admin-1499662074-14996651799466088', 1, 0, '', NULL, NULL, NULL),
(37629, '2017-07-10 13:25:48', NULL, NULL, 10929, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:25:48', 'admin-1499662074-14996643478622165', 1, 0, '', NULL, NULL, NULL),
(37630, '2017-07-10 13:25:48', NULL, NULL, 10929, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:25:48', 'admin-1499662074-14996643478622165', 1, 0, '', NULL, NULL, NULL),
(37631, '2017-07-10 13:14:06', NULL, NULL, 10927, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:14:06', 'admin-1499662074-14996636462637666', 1, 1, 'SR', NULL, NULL, NULL),
(37632, '2017-07-10 13:21:50', NULL, NULL, 10928, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:21:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37633, '2017-07-10 13:22:03', NULL, NULL, 10928, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:22:03', 'admin-1499662074-14996641236505684', 1, 1, 'SR', NULL, NULL, NULL),
(37634, '2017-07-10 13:29:41', NULL, NULL, 10928, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:29:41', 'admin-1499662074-14996645808737461', 1, 0, '', NULL, NULL, NULL),
(37635, '2017-07-10 13:22:03', NULL, NULL, 10928, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:22:03', 'admin-1499662074-14996641236505684', 1, 0, '', NULL, NULL, NULL),
(37636, '2017-07-10 13:25:48', NULL, NULL, 10929, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:25:48', 'admin-1499662074-14996643478622165', 1, 0, '', NULL, NULL, NULL),
(37637, '2017-07-10 13:25:48', NULL, NULL, 10929, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:25:48', 'admin-1499662074-14996643478622165', 1, 0, '', NULL, NULL, NULL),
(37638, '2017-07-10 13:25:03', NULL, NULL, 10929, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:25:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37639, '2017-07-10 13:25:48', NULL, NULL, 10929, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:25:48', 'admin-1499662074-14996643478622165', 1, 1, 'SR', NULL, NULL, NULL),
(37640, '2017-07-10 13:22:03', NULL, NULL, 10928, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:22:03', 'admin-1499662074-14996641236505684', 1, 0, '', NULL, NULL, NULL),
(37641, '2017-07-10 14:52:21', NULL, NULL, 10939, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1499662074', 'admin', '2017-07-10 14:52:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37642, '2017-07-10 12:56:45', NULL, NULL, 10926, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 12:56:45', 'admin-1499662074-14996626051587342', 1, 0, '', NULL, NULL, NULL),
(37643, '2017-07-10 13:10:52', NULL, NULL, 10926, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:10:52', 'admin-1499662074-14996634523569888', 1, 0, '', NULL, NULL, NULL),
(37644, '2017-07-10 13:14:01', NULL, NULL, 10927, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:14:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37645, '2017-07-10 13:14:06', NULL, NULL, 10927, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 13:14:06', 'admin-1499662074-14996636462637666', 1, 0, '', NULL, NULL, NULL),
(37646, '2017-07-10 12:48:41', NULL, NULL, 10924, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 12:48:41', 'admin-1499662074-14996621213833142', 1, 1, 'SR', NULL, NULL, NULL),
(37647, '2017-07-10 12:43:40', NULL, NULL, 10925, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 12:43:40', 'admin-1499655310-1499661820329456', 1, 1, 'SR', NULL, NULL, NULL),
(37648, '2017-07-10 12:43:29', NULL, NULL, 10925, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1499662074', 'admin', '2017-07-10 12:43:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37649, '2017-07-10 12:43:04', NULL, NULL, 10924, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 12:43:04', 'admin-1499655310-14996617841749014', 1, 0, '', NULL, NULL, NULL),
(37650, '2017-07-10 12:43:24', NULL, NULL, 10924, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 12:43:24', 'admin-1499655310-14996618040351424', 1, 0, '', NULL, NULL, NULL),
(37651, '2017-07-10 12:43:04', NULL, NULL, 10924, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 12:43:04', 'admin-1499655310-14996617841749014', 1, 0, '', NULL, NULL, NULL),
(37652, '2017-07-10 12:00:43', NULL, NULL, 10923, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 12:00:43', 'admin-1499655310-14996592436821383', 1, 1, 'SR', NULL, NULL, NULL),
(37653, '2017-07-10 09:48:25', NULL, NULL, 10907, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:48:25', 'admin-1499650469-1499651304828364', 1, 1, 'SR', NULL, NULL, NULL),
(37654, '2017-07-10 09:48:29', NULL, NULL, 10908, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:48:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37655, '2017-07-10 09:48:56', NULL, NULL, 10908, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:48:56', 'admin-1499650469-1499651336318248', 1, 0, '', NULL, NULL, NULL),
(37656, '2017-07-10 09:48:56', NULL, NULL, 10908, 0, 153, '87', 'Wake Me Up!', 'no salad extra potato', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:48:56', 'admin-1499650469-1499651336318248', 1, 0, '', NULL, NULL, NULL),
(37657, '2017-07-10 09:53:51', NULL, NULL, 10909, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.50, 0.0000, 0.0000, 9.50, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:53:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37658, '2017-07-10 09:54:14', NULL, NULL, 10909, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:54:14', 'admin-1499650469-14996516547317917', 1, 0, '', NULL, NULL, NULL),
(37659, '2017-07-10 09:54:14', NULL, NULL, 10909, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:54:14', 'admin-1499650469-14996516547317917', 1, 0, '', NULL, NULL, NULL),
(37660, '2017-07-10 09:54:14', NULL, NULL, 10909, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:54:14', 'admin-1499650469-14996516547317917', 1, 0, '', NULL, NULL, NULL),
(37661, '2017-07-10 09:54:14', NULL, NULL, 10909, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:54:14', 'admin-1499650469-14996516547317917', 1, 1, 'SR', NULL, NULL, NULL),
(37662, '2017-07-10 11:36:38', NULL, NULL, 10921, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 11:36:38', 'admin-1499655310-14996577986152666', 1, 0, '', NULL, NULL, NULL),
(37663, '2017-07-10 11:36:38', NULL, NULL, 10921, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 11:36:38', 'admin-1499655310-14996577986152666', 1, 0, '', NULL, NULL, NULL),
(37664, '2017-07-10 10:09:44', NULL, NULL, 10911, 0, 158, '92', 'Banana Stuffed Nutella Toast ', 'Add bacon', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:09:44', 'admin-1499650469-14996525844981134', 1, 0, '', NULL, NULL, NULL),
(37665, '2017-07-10 09:54:14', NULL, NULL, 10909, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:54:14', 'admin-1499650469-14996516547317917', 1, 1, 'SR', NULL, NULL, NULL),
(37666, '2017-07-10 11:35:18', NULL, NULL, 10921, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1499662074', 'admin', '2017-07-10 11:35:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37667, '2017-07-10 11:36:38', NULL, NULL, 10921, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 11:36:38', 'admin-1499655310-14996577986152666', 1, 1, 'SR', NULL, NULL, NULL),
(37668, '2017-07-10 11:36:38', NULL, NULL, 10921, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 11:36:38', 'admin-1499655310-14996577986152666', 1, 0, '', NULL, NULL, NULL),
(37669, '2017-07-10 11:09:22', NULL, NULL, 10919, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1499662074', 'admin', '2017-07-10 11:09:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37670, '2017-07-10 11:15:15', NULL, NULL, 10919, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 11:15:15', 'admin-1499655310-14996565155034595', 1, 1, 'SR', NULL, NULL, NULL),
(37671, '2017-07-10 11:15:15', NULL, NULL, 10919, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 11:15:15', 'admin-1499655310-14996565155034595', 1, 1, 'SR', NULL, NULL, NULL),
(37672, '2017-07-10 11:01:45', NULL, NULL, 10918, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 11:01:45', 'admin-1499655310-14996557053629423', 1, 0, '', NULL, NULL, NULL),
(37673, '2017-07-10 10:55:06', NULL, NULL, 10917, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:55:06', 'admin-1499652714-14996553058765586', 1, 1, 'SR', NULL, NULL, NULL),
(37674, '2017-07-10 10:17:04', NULL, NULL, 10912, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:17:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37675, '2017-07-10 10:17:11', NULL, NULL, 10912, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:17:11', 'admin-1499652714-1499653031296558', 1, 0, '', NULL, NULL, NULL),
(37676, '2017-07-10 10:17:11', NULL, NULL, 10912, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:17:11', 'admin-1499652714-1499653031296558', 1, 0, '', NULL, NULL, NULL),
(37677, '2017-07-10 10:17:11', NULL, NULL, 10912, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:17:11', 'admin-1499652714-1499653031296558', 1, 1, 'SR', NULL, NULL, NULL),
(37678, '2017-07-10 09:28:54', NULL, NULL, 10903, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:28:54', 'admin-1499648658-14996501344678695', 1, 0, '', NULL, NULL, NULL),
(37679, '2017-07-10 09:33:42', NULL, NULL, 10904, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.60, 0.0000, 0.0000, 9.60, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:33:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37680, '2017-07-10 09:33:58', NULL, NULL, 10904, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:33:58', 'admin-1499648658-14996504381762182', 1, 0, '', NULL, NULL, NULL),
(37681, '2017-07-10 11:01:30', NULL, NULL, 10918, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1499662074', 'admin', '2017-07-10 11:01:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37682, '2017-07-10 11:59:41', NULL, NULL, 10920, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 11:59:41', 'admin-1499655310-14996591809529923', 1, 1, 'SR', NULL, NULL, '10.0'),
(37683, '2017-07-10 10:52:40', NULL, NULL, 10916, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:52:40', 'admin-1499652714-1499655160612562', 1, 1, 'SR', NULL, NULL, NULL),
(37684, '2017-07-10 10:49:03', NULL, NULL, 10915, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:49:03', 'admin-1499652714-14996549434132396', 1, 1, 'SR', NULL, NULL, NULL),
(37685, '2017-07-10 10:52:23', NULL, NULL, 10916, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:52:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37686, '2017-07-10 10:52:40', NULL, NULL, 10916, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:52:40', 'admin-1499652714-1499655160612562', 1, 0, '', NULL, NULL, NULL),
(37687, '2017-07-10 10:49:03', NULL, NULL, 10915, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:49:03', 'admin-1499652714-14996549434132396', 1, 1, 'SR', NULL, NULL, NULL),
(37688, '2017-07-10 10:49:03', NULL, NULL, 10915, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:49:03', 'admin-1499652714-14996549434132396', 1, 0, '', NULL, NULL, NULL),
(37689, '2017-07-10 10:49:03', NULL, NULL, 10915, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:49:03', 'admin-1499652714-14996549434132396', 1, 0, '', NULL, NULL, NULL),
(37690, '2017-07-10 10:48:56', NULL, NULL, 10915, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:48:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37691, '2017-07-10 10:46:54', NULL, NULL, 10914, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:46:54', 'admin-1499652714-1499654813987778', 1, 1, 'SR', NULL, NULL, NULL),
(37692, '2017-07-10 09:34:23', NULL, NULL, 10905, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:34:23', 'admin-1499648658-1499650463693216', 1, 1, 'SR', NULL, NULL, NULL),
(37693, '2017-07-10 09:34:23', NULL, NULL, 10905, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:34:23', 'admin-1499648658-1499650463693216', 1, 1, 'SR', NULL, NULL, NULL),
(37694, '2017-07-10 09:34:23', NULL, NULL, 10905, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:34:23', 'admin-1499648658-1499650463693216', 1, 1, 'SR', NULL, NULL, NULL),
(37695, '2017-07-10 09:40:00', NULL, NULL, 10906, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:40:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37696, '2017-07-10 09:40:13', NULL, NULL, 10906, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:40:13', 'admin-1499650469-14996508135675539', 1, 0, '', NULL, NULL, NULL),
(37697, '2017-07-10 09:40:13', NULL, NULL, 10906, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:40:13', 'admin-1499650469-14996508135675539', 1, 0, '', NULL, NULL, NULL),
(37698, '2017-07-10 09:40:13', NULL, NULL, 10906, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:40:13', 'admin-1499650469-14996508135675539', 1, 1, 'SR', NULL, NULL, NULL),
(37699, '2017-07-10 09:44:40', NULL, NULL, 10903, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:44:40', 'admin-1499650469-14996510807498597', 1, 1, 'SR', NULL, NULL, NULL),
(37700, '2017-07-10 09:20:23', NULL, NULL, 10901, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:20:23', 'admin-1499648658-14996496237984793', 1, 0, '', NULL, NULL, NULL),
(37701, '2017-07-10 09:20:23', NULL, NULL, 10901, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:20:23', 'admin-1499648658-14996496237984793', 1, 0, '', NULL, NULL, NULL),
(37702, '2017-07-10 09:20:34', NULL, NULL, 10901, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:20:34', 'admin-1499648658-14996496338909539', 1, 1, 'SR', NULL, NULL, NULL),
(37703, '2017-07-10 09:44:40', NULL, NULL, 10903, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:44:40', 'admin-1499650469-14996510807498597', 1, 1, 'SR', NULL, NULL, NULL),
(37704, '2017-07-10 10:17:11', NULL, NULL, 10912, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:17:11', 'admin-1499652714-1499653031296558', 1, 1, 'SR', NULL, NULL, NULL),
(37705, '2017-07-10 10:14:19', NULL, NULL, 10905, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:14:19', 'admin-1499652714-14996528595956633', 1, 1, 'SR', NULL, NULL, NULL),
(37706, '2017-07-10 10:09:44', NULL, NULL, 10911, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:09:44', 'admin-1499650469-14996525844981134', 1, 1, 'SR', NULL, NULL, NULL),
(37707, '2017-07-10 10:09:44', NULL, NULL, 10911, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:09:44', 'admin-1499650469-14996525844981134', 1, 1, 'SR', NULL, NULL, NULL),
(37708, '2017-07-10 10:09:44', NULL, NULL, 10911, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 10:09:44', 'admin-1499650469-14996525844981134', 1, 0, '', NULL, NULL, NULL),
(37709, '2017-07-10 09:54:14', NULL, NULL, 10909, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:54:14', 'admin-1499650469-14996516547317917', 1, 1, 'SR', NULL, NULL, NULL),
(37710, '2017-07-10 09:48:24', NULL, NULL, 10907, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:48:24', 'admin-1499650469-1499651304828364', 1, 0, '', NULL, NULL, NULL),
(37711, '2017-07-10 09:48:25', NULL, NULL, 10907, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:48:25', 'admin-1499650469-1499651304828364', 1, 0, '', NULL, NULL, NULL),
(37712, '2017-07-10 09:34:23', NULL, NULL, 10905, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:34:23', 'admin-1499648658-1499650463693216', 1, 0, '', NULL, NULL, NULL),
(37713, '2017-07-10 09:34:07', NULL, NULL, 10905, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.60, 0.0000, 0.0000, 9.60, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:34:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37714, '2017-07-10 09:34:23', NULL, NULL, 10905, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:34:23', 'admin-1499648658-1499650463693216', 1, 0, '', NULL, NULL, NULL),
(37715, '2017-07-10 09:34:23', NULL, NULL, 10905, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:34:23', 'admin-1499648658-1499650463693216', 1, 0, '', NULL, NULL, NULL),
(37716, '2017-07-10 09:33:58', NULL, NULL, 10904, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:33:58', 'admin-1499648658-14996504381762182', 1, 1, 'SR', NULL, NULL, NULL),
(37717, '2017-07-10 09:33:58', NULL, NULL, 10904, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:33:58', 'admin-1499648658-14996504381762182', 1, 1, 'SR', NULL, NULL, NULL),
(37718, '2017-07-10 09:24:20', NULL, NULL, 10902, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:24:20', 'admin-1499648658-14996498599747937', 1, 1, 'SR', NULL, NULL, NULL),
(37719, '2017-07-10 09:24:09', NULL, NULL, 10902, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:24:09', 'admin-1499648658-14996498494628879', 1, 0, '', NULL, NULL, NULL),
(37720, '2017-07-10 09:24:09', NULL, NULL, 10902, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:24:09', 'admin-1499648658-14996498494628879', 1, 0, '', NULL, NULL, NULL),
(37721, '2017-07-10 09:33:58', NULL, NULL, 10904, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:33:58', 'admin-1499648658-14996504381762182', 1, 0, '', NULL, NULL, NULL),
(37722, '2017-07-10 09:33:58', NULL, NULL, 10904, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:33:58', 'admin-1499648658-14996504381762182', 1, 0, '', NULL, NULL, NULL),
(37723, '2017-07-10 09:33:58', NULL, NULL, 10904, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:33:58', 'admin-1499648658-14996504381762182', 1, 1, 'SR', NULL, NULL, NULL),
(37724, '2017-07-10 09:33:58', NULL, NULL, 10904, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:33:58', 'admin-1499648658-14996504381762182', 1, 1, 'SR', NULL, NULL, NULL),
(37725, '2017-07-10 09:24:20', NULL, NULL, 10902, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:24:20', 'admin-1499648658-14996498599747937', 1, 1, 'SR', NULL, NULL, NULL),
(37726, '2017-07-10 09:28:47', NULL, NULL, 10903, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:28:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37727, '2017-07-10 09:28:54', NULL, NULL, 10903, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:28:54', 'admin-1499648658-14996501344678695', 1, 0, '', NULL, NULL, NULL),
(37728, '2017-07-10 09:23:54', NULL, NULL, 10902, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:23:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37729, '2017-07-10 09:20:34', NULL, NULL, 10901, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:20:34', 'admin-1499648658-14996496338909539', 1, 1, 'SR', NULL, NULL, NULL),
(37730, '2017-07-10 09:20:17', NULL, NULL, 10901, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:20:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37731, '2017-07-10 09:19:33', NULL, NULL, 10900, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:19:33', 'admin-1499648658-149964957336827', 1, 0, '', NULL, NULL, NULL),
(37732, '2017-07-10 09:19:33', NULL, NULL, 10900, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:19:33', 'admin-1499648658-149964957336827', 1, 0, '', NULL, NULL, NULL),
(37733, '2017-07-10 09:19:29', NULL, NULL, 10900, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1499662074', 'admin', '2017-07-10 09:19:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37734, '2017-07-12 13:58:03', NULL, NULL, 10966, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:58:03', 'admin-1499836063-14998390828404178', 1, 0, '', NULL, NULL, '10.0'),
(37735, '2017-07-12 13:46:18', NULL, NULL, 10968, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:46:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37736, '2017-07-12 13:46:25', NULL, NULL, 10968, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:46:25', 'admin-1499836063-14998383856716028', 1, 1, 'SR', NULL, NULL, NULL),
(37737, '2017-07-12 13:47:13', NULL, NULL, 10968, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:47:13', 'admin-1499836063-14998384331425677', 1, 1, 'SR', NULL, NULL, NULL),
(37738, '2017-07-12 13:46:25', NULL, NULL, 10968, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:46:25', 'admin-1499836063-14998383856716028', 1, 1, 'SR', NULL, NULL, NULL),
(37739, '2017-07-12 13:38:56', NULL, NULL, 10967, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:38:56', 'admin-1499836063-14998379359932452', 1, 0, '', NULL, NULL, NULL),
(37740, '2017-07-12 09:22:48', NULL, NULL, 10945, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 09:22:48', 'admin-1499821639-14998225683922525', 1, 0, '', NULL, NULL, NULL),
(37741, '2017-07-12 13:14:10', NULL, NULL, 10962, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:14:10', 'admin-1499836063-14998364506446783', 1, 1, 'SR', NULL, NULL, NULL),
(37742, '2017-07-12 16:19:02', NULL, NULL, 10974, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 16:19:02', 'admin-1499845049-14998475422837077', 1, 1, 'SR', NULL, NULL, NULL),
(37743, '2017-07-12 14:29:07', NULL, NULL, 10972, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 14:29:07', 'admin-1499836063-14998409477433335', 1, 0, '', NULL, NULL, NULL),
(37744, '2017-07-12 11:49:57', NULL, NULL, 10958, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.80, 0.0000, 0.0000, 9.80, 1, '27', 1, '1499845049', 'admin', '2017-07-12 11:49:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37745, '2017-07-12 11:50:10', NULL, NULL, 10958, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 11:50:10', 'admin-1499831389-14998314106534242', 1, 1, 'SR', NULL, NULL, NULL),
(37746, '2017-07-12 11:50:10', NULL, NULL, 10958, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 11:50:10', 'admin-1499831389-14998314106534242', 1, 0, '', NULL, NULL, NULL),
(37747, '2017-07-12 17:27:38', NULL, NULL, 10962, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 17:27:38', 'admin-1499845049-14998516581909780', 1, 0, '', NULL, NULL, NULL),
(37748, '2017-07-12 16:02:02', NULL, NULL, 10974, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 16:02:02', 'admin-1499845049-14998465226385545', 1, 1, 'SR', NULL, NULL, NULL),
(37749, '2017-07-12 16:35:23', NULL, NULL, 10977, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 16:35:23', 'admin-1499845049-1499848523443708', 1, 1, 'SR', NULL, NULL, NULL),
(37750, '2017-07-12 14:09:32', NULL, NULL, 10971, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 14:09:32', 'admin-1499836063-14998397723543212', 1, 1, 'SR', 1, NULL, NULL),
(37751, '2017-07-12 13:17:42', NULL, NULL, 10966, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:17:42', 'admin-1499836063-14998366623244571', 1, 1, 'SR', NULL, NULL, '10.0'),
(37752, '2017-07-12 15:02:37', NULL, NULL, 10972, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 15:02:37', 'admin-1499836063-14998429572381715', 1, 0, '', NULL, NULL, NULL),
(37753, '2017-07-12 15:03:05', NULL, NULL, 10962, 0, 179, '114', 'Creme Brulee ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 15:03:05', 'admin-1499836063-14998429855935995', 1, 0, '', NULL, NULL, NULL),
(37754, '2017-07-12 15:03:05', NULL, NULL, 10962, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 15:03:05', 'admin-1499836063-14998429855935995', 1, 1, 'SR', NULL, NULL, NULL),
(37755, '2017-07-12 15:03:45', NULL, NULL, 10972, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 15:03:45', 'admin-1499836063-14998430247958660', 1, 1, 'SR', NULL, NULL, NULL),
(37756, '2017-07-12 15:20:51', NULL, NULL, 10973, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1499845049', 'admin', '2017-07-12 15:20:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37757, '2017-07-12 15:20:57', NULL, NULL, 10973, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 15:20:57', 'admin-1499836063-14998440574458847', 1, 1, 'SR', NULL, NULL, NULL),
(37758, '2017-07-12 13:52:02', NULL, NULL, 10968, 0, 80, '80', 'Oriental Chicken Salad', 'add bacon', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:52:02', 'admin-1499836063-1499838722055308', 1, 1, 'SR', NULL, NULL, NULL),
(37759, '2017-07-12 13:45:30', NULL, NULL, 10966, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:45:30', 'admin-1499836063-14998383299601574', 1, 0, '', NULL, NULL, '10.0'),
(37760, '2017-07-12 16:35:29', NULL, NULL, 10974, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 16:35:29', 'admin-1499845049-1499848528992297', 1, 0, '', NULL, NULL, NULL),
(37761, '2017-07-12 12:37:41', NULL, NULL, 10958, 0, 74, '74', 'Sunrice', 'Takeaway', 'Meals', 'Perfect Meals', 2, 15.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 12:37:41', 'admin-1499831389-14998342616687423', 1, 1, 'SR', NULL, NULL, NULL),
(37762, '2017-07-12 12:46:00', NULL, NULL, 10962, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.10, 0.0000, 0.0000, 11.10, 1, '27', 1, '1499845049', 'admin', '2017-07-12 12:46:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37763, '2017-07-12 12:46:05', NULL, NULL, 10962, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 12:46:05', 'admin-1499831389-14998347652789097', 1, 0, '', NULL, NULL, NULL),
(37764, '2017-07-12 12:46:05', NULL, NULL, 10962, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 12:46:05', 'admin-1499831389-14998347652789097', 1, 1, 'SR', NULL, NULL, NULL),
(37765, '2017-07-12 12:55:38', NULL, NULL, 10963, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 12:55:38', 'admin-1499835170-14998353383143083', 1, 1, 'SR', 1, NULL, '10.0'),
(37766, '2017-07-12 09:27:06', NULL, NULL, 10946, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1499845049', 'admin', '2017-07-12 09:27:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37767, '2017-07-12 09:27:12', NULL, NULL, 10946, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 09:27:12', 'admin-1499821639-14998228327378183', 1, 0, '', NULL, NULL, NULL),
(37768, '2017-07-12 16:13:09', NULL, NULL, 10975, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 16:13:09', 'admin-1499845049-14998471897358232', 1, 0, '', NULL, NULL, NULL),
(37769, '2017-07-12 16:15:21', NULL, NULL, 10976, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 16:15:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37770, '2017-07-12 16:15:26', NULL, NULL, 10976, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 16:15:26', 'admin-1499845049-14998473268047973', 1, 1, 'SR', NULL, NULL, NULL),
(37771, '2017-07-12 16:15:26', NULL, NULL, 10976, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 16:15:26', 'admin-1499845049-14998473268047973', 1, 1, 'SR', NULL, NULL, NULL),
(37772, '2017-07-12 16:35:29', NULL, NULL, 10974, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 16:35:29', 'admin-1499845049-1499848528992297', 1, 1, 'SR', NULL, NULL, NULL),
(37773, '2017-07-12 16:35:29', NULL, NULL, 10974, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 16:35:29', 'admin-1499845049-1499848528992297', 1, 1, 'SR', NULL, NULL, NULL),
(37774, '2017-07-12 16:35:29', NULL, NULL, 10974, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 16:35:29', 'admin-1499845049-1499848528992297', 1, 0, '', NULL, NULL, NULL),
(37775, '2017-07-12 16:35:23', NULL, NULL, 10977, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 16:35:23', 'admin-1499845049-1499848523443708', 1, 1, 'SR', NULL, NULL, NULL),
(37776, '2017-07-12 16:35:18', NULL, NULL, 10977, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 16:35:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37777, '2017-07-12 16:19:02', NULL, NULL, 10974, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 16:19:02', 'admin-1499845049-14998475422837077', 1, 1, 'SR', NULL, NULL, NULL),
(37778, '2017-07-12 16:13:09', NULL, NULL, 10975, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 16:13:09', 'admin-1499845049-14998471897358232', 1, 1, 'SR', NULL, NULL, NULL),
(37779, '2017-07-12 16:13:09', NULL, NULL, 10975, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 16:13:09', 'admin-1499845049-14998471897358232', 1, 1, 'SR', NULL, NULL, NULL),
(37780, '2017-07-12 16:13:03', NULL, NULL, 10975, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1499845049', 'admin', '2017-07-12 16:13:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37781, '2017-07-12 16:02:02', NULL, NULL, 10974, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 16:02:02', 'admin-1499845049-14998465226385545', 1, 1, 'SR', NULL, NULL, NULL),
(37782, '2017-07-12 16:01:59', NULL, NULL, 10974, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.20, 0.0000, 0.0000, 11.20, 1, '27', 1, '1499845049', 'admin', '2017-07-12 16:01:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37783, '2017-07-12 16:02:02', NULL, NULL, 10974, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 16:02:02', 'admin-1499845049-14998465226385545', 1, 1, 'SR', NULL, NULL, NULL),
(37784, '2017-07-12 15:37:38', NULL, NULL, 10973, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 15:37:38', 'admin-1499845049-14998450582268369', 1, 0, '', NULL, NULL, NULL),
(37785, '2017-07-12 15:46:01', NULL, NULL, 10970, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 15:46:01', 'admin-1499845049-149984556110146', 1, 0, '', NULL, NULL, NULL),
(37786, '2017-07-12 15:37:38', NULL, NULL, 10973, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 15:37:38', 'admin-1499845049-14998450582268369', 1, 0, '', NULL, NULL, NULL),
(37787, '2017-07-12 14:29:07', NULL, NULL, 10972, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 14:29:07', 'admin-1499836063-14998409477433335', 1, 1, 'SR', NULL, NULL, NULL),
(37788, '2017-07-12 14:28:39', NULL, NULL, 10972, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 14:28:39', 'admin-1499836063-14998409188137221', 1, 0, '', NULL, NULL, NULL),
(37789, '2017-07-12 14:28:39', NULL, NULL, 10972, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 14:28:39', 'admin-1499836063-14998409188137221', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(37790, '2017-07-12 14:28:39', NULL, NULL, 10972, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 14:28:39', 'admin-1499836063-14998409188137221', 1, 0, '', NULL, NULL, NULL),
(37791, '2017-07-12 14:28:39', NULL, NULL, 10972, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 14:28:39', 'admin-1499836063-14998409188137221', 1, 0, '', NULL, NULL, NULL),
(37792, '2017-07-12 14:28:21', NULL, NULL, 10972, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1499845049', 'admin', '2017-07-12 14:28:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37793, '2017-07-12 13:14:10', NULL, NULL, 10962, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:14:10', 'admin-1499836063-14998364506446783', 1, 1, 'SR', NULL, NULL, NULL),
(37794, '2017-07-12 13:17:35', NULL, NULL, 10966, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:17:35', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(37795, '2017-07-12 14:09:32', NULL, NULL, 10971, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 14:09:32', 'admin-1499836063-14998397723543212', 1, 1, 'SR', 1, NULL, NULL),
(37796, '2017-07-12 12:19:35', NULL, NULL, 10961, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1499845049', 'admin', '2017-07-12 12:19:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37797, '2017-07-12 12:19:38', NULL, NULL, 10961, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 12:19:38', 'admin-1499831389-1499833178542417', 1, 1, 'SR', NULL, NULL, NULL),
(37798, '2017-07-12 11:51:21', NULL, NULL, 10959, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 11:51:21', 'admin-1499831389-14998314813035669', 1, 0, '', NULL, NULL, NULL),
(37799, '2017-07-12 11:51:21', NULL, NULL, 10959, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 11:51:21', 'admin-1499831389-14998314813035669', 1, 0, '', NULL, NULL, NULL),
(37800, '2017-07-12 11:51:21', NULL, NULL, 10959, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 11:51:21', 'admin-1499831389-14998314813035669', 1, 1, 'SR', NULL, NULL, NULL),
(37801, '2017-07-12 12:08:04', NULL, NULL, 10960, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1499845049', 'admin', '2017-07-12 12:08:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37802, '2017-07-12 12:08:20', NULL, NULL, 10960, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 12:08:20', 'admin-1499831389-14998325002714548', 1, 1, 'SR', NULL, NULL, NULL),
(37803, '2017-07-12 12:08:20', NULL, NULL, 10960, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 12:08:20', 'admin-1499831389-14998325002714548', 1, 1, 'SR', NULL, NULL, NULL),
(37804, '2017-07-12 12:08:20', NULL, NULL, 10960, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 12:08:20', 'admin-1499831389-14998325002714548', 1, 0, '', NULL, NULL, NULL),
(37805, '2017-07-12 12:08:20', NULL, NULL, 10960, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 12:08:20', 'admin-1499831389-14998325002714548', 1, 1, 'SR', NULL, NULL, NULL),
(37806, '2017-07-12 13:52:11', NULL, NULL, 10970, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:52:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37807, '2017-07-12 13:52:15', NULL, NULL, 10970, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:52:15', 'admin-1499836063-14998387356611913', 1, 1, 'SR', NULL, NULL, NULL),
(37808, '2017-07-12 13:58:03', NULL, NULL, 10966, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:58:03', 'admin-1499836063-14998390828404178', 1, 0, '', NULL, NULL, '10.0'),
(37809, '2017-07-12 13:52:02', NULL, NULL, 10968, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:52:02', 'admin-1499836063-1499838722055308', 1, 0, '', NULL, NULL, NULL),
(37810, '2017-07-12 13:47:22', NULL, NULL, 10969, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:47:22', 'admin-1499836063-14998384419956838', 1, 1, 'SR', 1, NULL, NULL),
(37811, '2017-07-12 13:46:25', NULL, NULL, 10968, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:46:25', 'admin-1499836063-14998383856716028', 1, 1, 'SR', NULL, NULL, NULL),
(37812, '2017-07-12 09:33:40', NULL, NULL, 10947, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1499845049', 'admin', '2017-07-12 09:33:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37813, '2017-07-12 09:33:48', NULL, NULL, 10947, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 09:33:48', 'admin-1499821639-14998232285882667', 1, 0, '', NULL, NULL, NULL),
(37814, '2017-07-12 13:08:01', NULL, NULL, 10965, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:08:01', 'admin-1499836063-14998360812193839', 1, 1, 'SR', NULL, NULL, NULL),
(37815, '2017-07-12 13:38:56', NULL, NULL, 10967, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:38:56', 'admin-1499836063-14998379359932452', 1, 0, '', NULL, NULL, NULL),
(37816, '2017-07-12 13:38:56', NULL, NULL, 10967, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:38:56', 'admin-1499836063-14998379359932452', 1, 1, 'SR', NULL, NULL, NULL),
(37817, '2017-07-12 13:38:56', NULL, NULL, 10967, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:38:56', 'admin-1499836063-14998379359932452', 1, 1, 'SR', NULL, NULL, NULL),
(37818, '2017-07-12 14:56:04', NULL, NULL, 10972, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 14:56:04', 'admin-1499836063-14998425637863950', 1, 0, '', NULL, NULL, NULL),
(37819, '2017-07-12 13:38:47', NULL, NULL, 10967, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:38:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37820, '2017-07-12 13:17:42', NULL, NULL, 10966, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:17:42', 'admin-1499836063-14998366623244571', 1, 0, '', NULL, NULL, '10.0'),
(37821, '2017-07-12 13:14:10', NULL, NULL, 10962, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:14:10', 'admin-1499836063-14998364506446783', 1, 1, 'SR', NULL, NULL, NULL),
(37822, '2017-07-12 13:14:10', NULL, NULL, 10962, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:14:10', 'admin-1499836063-14998364506446783', 1, 0, '', NULL, NULL, NULL),
(37823, '2017-07-12 13:10:33', NULL, NULL, 10964, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:10:33', 'admin-1499836063-1499836233551788', 1, 1, 'SR', NULL, NULL, NULL),
(37824, '2017-07-12 09:46:54', NULL, NULL, 10948, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1499845049', 'admin', '2017-07-12 09:46:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37825, '2017-07-12 09:46:59', NULL, NULL, 10948, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 09:46:59', 'admin-1499821639-1499824019550692', 1, 0, '', NULL, NULL, NULL),
(37826, '2017-07-12 09:46:59', NULL, NULL, 10948, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 09:46:59', 'admin-1499821639-1499824019550692', 1, 0, '', NULL, NULL, NULL),
(37827, '2017-07-12 09:52:05', NULL, NULL, 10945, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 09:52:05', 'admin-1499821639-1499824325711692', 1, 1, 'SR', NULL, NULL, NULL),
(37828, '2017-07-12 10:08:57', NULL, NULL, 10949, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1499845049', 'admin', '2017-07-12 10:08:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37829, '2017-07-12 10:09:01', NULL, NULL, 10949, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 10:09:01', 'admin-1499821639-1499825341444774', 1, 1, 'SR', NULL, NULL, NULL),
(37830, '2017-07-12 10:19:47', NULL, NULL, 10950, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1499845049', 'admin', '2017-07-12 10:19:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37831, '2017-07-12 10:19:50', NULL, NULL, 10950, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 10:19:50', 'admin-1499821639-1499825990485127', 1, 0, '', NULL, NULL, NULL),
(37832, '2017-07-12 10:55:31', NULL, NULL, 10951, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 10:55:31', 'admin-1499821639-1499828131532619', 1, 1, 'SR', 1, NULL, NULL),
(37833, '2017-07-12 10:55:31', NULL, NULL, 10951, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 10:55:31', 'admin-1499821639-1499828131532619', 1, 1, 'SR', 1, NULL, NULL),
(37834, '2017-07-12 10:57:51', NULL, NULL, 10952, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 10:57:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37835, '2017-07-12 10:57:59', NULL, NULL, 10952, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 10:57:59', 'admin-1499821639-14998282788852686', 1, 0, '', NULL, NULL, NULL),
(37836, '2017-07-12 13:08:01', NULL, NULL, 10965, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:08:01', 'admin-1499836063-14998360812193839', 1, 0, '', NULL, NULL, NULL),
(37837, '2017-07-12 13:07:48', NULL, NULL, 10965, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:07:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37838, '2017-07-12 13:08:01', NULL, NULL, 10965, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:08:01', 'admin-1499836063-14998360812193839', 1, 1, 'SR', NULL, NULL, NULL),
(37839, '2017-07-12 13:08:01', NULL, NULL, 10965, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:08:01', 'admin-1499836063-14998360812193839', 1, 1, 'SR', NULL, NULL, NULL),
(37840, '2017-07-12 13:07:37', NULL, NULL, 10964, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1499845049', 'admin', '2017-07-12 13:07:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37841, '2017-07-12 11:51:11', NULL, NULL, 10959, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1499845049', 'admin', '2017-07-12 11:51:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37842, '2017-07-12 11:50:37', NULL, NULL, 10958, 0, 74, '74', 'Sunrice', 'Takeaway', 'Meals', 'Perfect Meals', 3, 15.00, 45.0000, 0.0000, 45.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 11:50:37', 'admin-1499831389-14998314376133626', 1, 1, 'SR', NULL, NULL, NULL),
(37843, '2017-07-12 11:44:45', NULL, NULL, 10953, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 11:44:45', 'admin-1499821639-1499831085589619', 1, 1, 'SR', NULL, NULL, NULL),
(37844, '2017-07-12 11:46:03', NULL, NULL, 10953, 0, 181, '116', 'Open Food ', 'Plain bread', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 11:46:03', 'admin-1499821639-14998311631121762', 1, 0, '', NULL, NULL, NULL),
(37845, '2017-07-12 00:00:00', NULL, NULL, 10957, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, NULL, NULL, 1.50, 1, '27', 1, '1499845049', 'admin', '2017-07-12 11:25:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37846, '2017-07-12 00:00:00', NULL, NULL, 10956, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, NULL, NULL, 6.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 11:25:58', 'admin-1499821639-14998299585593783', 1, 1, 'SR', NULL, NULL, NULL),
(37847, '2017-07-12 00:00:00', NULL, NULL, 10957, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 11:25:58', 'admin-1499821639-14998299585593783', 1, 1, 'SR', NULL, NULL, NULL),
(37848, '2017-07-12 11:40:46', NULL, NULL, 10956, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1499845049', 'admin', '2017-07-12 11:40:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37849, '2017-07-12 10:57:59', NULL, NULL, 10952, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 10:57:59', 'admin-1499821639-14998282788852686', 1, 1, 'SR', NULL, NULL, NULL),
(37850, '2017-07-12 11:17:29', NULL, NULL, 10954, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 11:17:29', 'admin-1499821639-14998294491115073', 1, 1, 'SR', NULL, NULL, NULL),
(37851, '2017-07-12 15:20:57', NULL, NULL, 10973, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 15:20:57', 'admin-1499836063-14998440574458847', 1, 1, 'SR', NULL, NULL, NULL),
(37852, '2017-07-12 11:17:23', NULL, NULL, 10954, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 11:17:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37853, '2017-07-12 11:01:45', NULL, NULL, 10953, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 11:01:45', 'admin-1499821639-14998285051721393', 1, 1, 'SR', NULL, NULL, NULL),
(37854, '2017-07-12 11:01:45', NULL, NULL, 10953, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 11:01:45', 'admin-1499821639-14998285051721393', 1, 1, 'SR', NULL, NULL, NULL),
(37855, '2017-07-12 11:01:37', NULL, NULL, 10953, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1499845049', 'admin', '2017-07-12 11:01:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37856, '2017-07-12 10:57:59', NULL, NULL, 10952, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 10:57:59', 'admin-1499821639-14998282788852686', 1, 1, 'SR', NULL, NULL, NULL),
(37857, '2017-07-12 10:57:59', NULL, NULL, 10952, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 10:57:59', 'admin-1499821639-14998282788852686', 1, 0, '', NULL, NULL, NULL),
(37858, '2017-07-12 09:33:48', NULL, NULL, 10947, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 09:33:48', 'admin-1499821639-14998232285882667', 1, 1, 'SR', NULL, NULL, NULL),
(37859, '2017-07-12 09:27:12', NULL, NULL, 10946, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 09:27:12', 'admin-1499821639-14998228327378183', 1, 1, 'SR', NULL, NULL, NULL),
(37860, '2017-07-12 09:22:48', NULL, NULL, 10945, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 09:22:48', 'admin-1499821639-14998225683922525', 1, 0, '', NULL, NULL, NULL),
(37861, '2017-07-12 09:22:48', NULL, NULL, 10945, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 09:22:48', 'admin-1499821639-14998225683922525', 1, 1, 'SR', NULL, NULL, NULL),
(37862, '2017-07-12 09:22:48', NULL, NULL, 10945, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499845049', 'admin', '2017-07-12 09:22:48', 'admin-1499821639-14998225683922525', 1, 0, '', NULL, NULL, NULL),
(37863, '2017-07-12 09:20:33', NULL, NULL, 10945, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1499845049', 'admin', '2017-07-12 09:20:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37864, '2017-07-13 13:17:57', NULL, NULL, 11000, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:17:57', 'admin-1499913735-14999230772564353', 1, 1, 'SR', NULL, NULL, '10.0'),
(37865, '2017-07-13 13:17:57', NULL, NULL, 11000, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:17:57', 'admin-1499913735-14999230772564353', 1, 0, '', NULL, NULL, '10.0'),
(37866, '2017-07-13 13:17:57', NULL, NULL, 11000, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:17:57', 'admin-1499913735-14999230772564353', 1, 0, '', NULL, NULL, '10.0'),
(37867, '2017-07-13 13:17:57', NULL, NULL, 11000, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:17:57', 'admin-1499913735-14999230772564353', 1, 1, 'SR', NULL, NULL, '10.0'),
(37868, '2017-07-13 13:17:57', NULL, NULL, 11000, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:17:57', 'admin-1499913735-14999230772564353', 1, 1, 'SR', NULL, NULL, '10.0'),
(37869, '2017-07-13 13:17:57', NULL, NULL, 11000, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:17:57', 'admin-1499913735-14999230772564353', 1, 1, 'SR', NULL, NULL, '10.0'),
(37870, '2017-07-13 13:17:57', NULL, NULL, 11000, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:17:57', 'admin-1499913735-14999230772564353', 1, 0, '', NULL, NULL, '10.0'),
(37871, '2017-07-13 10:57:29', NULL, NULL, 10987, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 10:57:29', 'admin-1499913735-14999146495598145', 1, 1, 'SR', NULL, NULL, NULL),
(37872, '2017-07-13 10:57:29', NULL, NULL, 10987, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 10:57:29', 'admin-1499913735-14999146495598145', 1, 0, '', NULL, NULL, NULL),
(37873, '2017-07-13 18:06:05', NULL, NULL, 11015, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 18:06:05', 'admin-1499932464-14999403651351429', 1, 0, '', NULL, NULL, '10.0'),
(37874, '2017-07-13 13:07:51', NULL, NULL, 10997, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:07:51', 'admin-1499913735-14999224710622526', 1, 1, 'SR', NULL, NULL, '10.0'),
(37875, '2017-07-13 13:07:51', NULL, NULL, 10997, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:07:51', 'admin-1499913735-14999224710622526', 1, 1, 'SR', NULL, NULL, '10.0'),
(37876, '2017-07-13 13:07:51', NULL, NULL, 10997, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:07:51', 'admin-1499913735-14999224710622526', 1, 0, '', NULL, NULL, '10.0'),
(37877, '2017-07-13 13:07:51', NULL, NULL, 10997, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:07:51', 'admin-1499913735-14999224710622526', 1, 1, 'SR', NULL, NULL, '10.0'),
(37878, '2017-07-13 15:27:47', NULL, NULL, 11009, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 15:27:47', 'admin-1499913735-14999308677116879', 1, 0, '', NULL, NULL, NULL),
(37879, '2017-07-13 12:30:50', NULL, NULL, 10989, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 12:30:50', 'admin-1499913735-14999202504973035', 1, 0, '', NULL, NULL, NULL),
(37880, '2017-07-13 12:33:48', NULL, NULL, 10989, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 12:33:48', 'admin-1499913735-14999204286616520', 1, 0, '', NULL, NULL, NULL),
(37881, '2017-07-13 14:38:49', NULL, NULL, 11007, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 14:38:49', 'admin-1499913735-14999279289111071', 1, 1, 'SR', NULL, NULL, NULL),
(37882, '2017-07-13 14:38:49', NULL, NULL, 11007, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 14:38:49', 'admin-1499913735-14999279289111071', 1, 1, 'SR', NULL, NULL, NULL),
(37883, '2017-07-13 15:16:55', NULL, NULL, 11007, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 15:16:55', 'admin-1499913735-14999302155565540', 1, 0, '', NULL, NULL, NULL),
(37884, '2017-07-13 15:16:55', NULL, NULL, 11007, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 15:16:55', 'admin-1499913735-14999302155565540', 1, 0, '', NULL, NULL, NULL),
(37885, '2017-07-13 18:06:05', NULL, NULL, 11015, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 18:06:05', 'admin-1499932464-14999403651351429', 1, 0, '', NULL, NULL, '10.0'),
(37886, '2017-07-13 16:34:02', NULL, NULL, 11015, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1499932464', 'admin', '2017-07-13 16:34:02', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(37887, '2017-07-13 13:09:09', NULL, NULL, 10998, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:09:09', 'admin-1499913735-14999225494501631', 1, 0, '', NULL, NULL, NULL),
(37888, '2017-07-13 13:09:09', NULL, NULL, 10998, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:09:09', 'admin-1499913735-14999225494501631', 1, 0, '', NULL, NULL, NULL),
(37889, '2017-07-13 13:09:09', NULL, NULL, 10998, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:09:09', 'admin-1499913735-14999225494501631', 1, 0, '', NULL, NULL, NULL),
(37890, '2017-07-13 13:10:13', NULL, NULL, 10999, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:10:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37891, '2017-07-13 13:10:16', NULL, NULL, 10999, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:10:16', 'admin-1499913735-14999226165316553', 1, 1, 'SR', NULL, NULL, NULL),
(37892, '2017-07-13 16:05:23', NULL, NULL, 11014, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 16:05:23', 'admin-1499932464-14999331231868219', 1, 1, 'SR', NULL, NULL, NULL),
(37893, '2017-07-13 13:17:34', NULL, NULL, 11000, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.00, 0.0000, 0.0000, 13.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:17:34', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(37894, '2017-07-13 16:05:23', NULL, NULL, 11014, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 16:05:23', 'admin-1499932464-14999331231868219', 1, 1, 'SR', NULL, NULL, NULL),
(37895, '2017-07-13 10:42:05', NULL, NULL, 10985, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 10:42:05', 'admin-1499906815-1499913725713791', 1, 0, '', NULL, NULL, '10.0'),
(37896, '2017-07-13 10:42:22', NULL, NULL, 10985, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 10:42:22', 'admin-1499913735-14999137421276916', 1, 1, 'SR', NULL, NULL, '10.0'),
(37897, '2017-07-13 10:54:20', NULL, NULL, 10986, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1499932464', 'admin', '2017-07-13 10:54:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37898, '2017-07-13 10:54:24', NULL, NULL, 10986, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 10:54:24', 'admin-1499913735-14999144646582666', 1, 1, 'SR', NULL, NULL, NULL),
(37899, '2017-07-13 10:57:17', NULL, NULL, 10987, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 10:57:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37900, '2017-07-13 00:00:00', NULL, NULL, 11013, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 15:21:57', 'admin-1499913735-14999305168952965', 1, 1, 'SR', NULL, NULL, NULL),
(37901, '2017-07-13 00:00:00', NULL, NULL, 11012, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 15:20:15', 'admin-1499913735-14999304147938020', 1, 0, '', NULL, NULL, NULL),
(37902, '2017-07-13 00:00:00', NULL, NULL, 11013, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, NULL, NULL, 3.50, 1, '27', 1, '1499932464', 'admin', '2017-07-13 15:16:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37903, '2017-07-13 00:00:00', NULL, NULL, 11013, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 15:20:15', 'admin-1499913735-14999304147938020', 1, 0, '', NULL, NULL, NULL),
(37904, '2017-07-13 15:27:01', NULL, NULL, 11009, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 15:27:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37905, '2017-07-13 15:27:06', NULL, NULL, 11009, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 15:27:06', 'admin-1499913735-14999308260795355', 1, 0, '', NULL, NULL, NULL),
(37906, '2017-07-13 00:00:00', NULL, NULL, 11012, 0, 181, '116', 'Open Food ', 'Salad add on chicken', 'Meals', 'Perfect Meals', 1, 4.00, NULL, NULL, 4.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 15:20:15', 'admin-1499913735-14999304147938020', 1, 0, '', NULL, NULL, NULL),
(37907, '2017-07-13 15:28:36', NULL, NULL, 11011, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 15:28:36', 'admin-1499913735-14999309160781042', 1, 1, 'SR', NULL, NULL, NULL),
(37908, '2017-07-13 16:34:05', NULL, NULL, 11015, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 16:34:05', 'admin-1499932464-14999348456291539', 1, 0, '', NULL, NULL, '10.0'),
(37909, '2017-07-13 15:28:26', NULL, NULL, 11011, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 15:28:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37910, '2017-07-13 15:28:13', NULL, NULL, 11010, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 15:28:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37911, '2017-07-13 15:28:16', NULL, NULL, 11010, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 15:28:16', 'admin-1499913735-1499930895972167', 1, 1, 'SR', NULL, NULL, NULL),
(37912, '2017-07-13 15:54:34', NULL, NULL, 11012, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1499932464', 'admin', '2017-07-13 15:54:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37913, '2017-07-13 14:38:49', NULL, NULL, 11007, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 14:38:49', 'admin-1499913735-14999279289111071', 1, 1, 'SR', NULL, NULL, NULL),
(37914, '2017-07-13 14:38:49', NULL, NULL, 11007, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 14:38:49', 'admin-1499913735-14999279289111071', 1, 0, '', NULL, NULL, NULL),
(37915, '2017-07-13 14:25:09', NULL, NULL, 11006, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 14:25:09', 'admin-1499913735-14999271089117365', 1, 1, 'SR', NULL, NULL, NULL),
(37916, '2017-07-13 14:38:32', NULL, NULL, 11007, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1499932464', 'admin', '2017-07-13 14:38:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37917, '2017-07-13 14:25:09', NULL, NULL, 11006, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 14:25:09', 'admin-1499913735-14999271089117365', 1, 1, 'SR', NULL, NULL, NULL),
(37918, '2017-07-13 14:25:09', NULL, NULL, 11006, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 14:25:09', 'admin-1499913735-14999271089117365', 1, 1, 'SR', NULL, NULL, NULL),
(37919, '2017-07-13 00:00:00', NULL, NULL, 11005, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:56:18', 'admin-1499913735-14999253778804663', 1, 1, 'SR', NULL, NULL, NULL),
(37920, '2017-07-13 00:00:00', NULL, NULL, 11005, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, NULL, NULL, 1.50, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:56:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37921, '2017-07-13 00:00:00', NULL, NULL, 11004, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:56:18', 'admin-1499913735-14999253778804663', 1, 1, 'SR', NULL, NULL, NULL),
(37922, '2017-07-13 14:23:55', NULL, NULL, 11004, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1499932464', 'admin', '2017-07-13 14:23:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37923, '2017-07-13 14:24:59', NULL, NULL, 11006, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1499932464', 'admin', '2017-07-13 14:24:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37924, '2017-07-13 13:07:51', NULL, NULL, 10997, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:07:51', 'admin-1499913735-14999224710622526', 1, 1, 'SR', NULL, NULL, '10.0'),
(37925, '2017-07-13 13:07:51', NULL, NULL, 10997, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:07:51', 'admin-1499913735-14999224710622526', 1, 1, 'SR', NULL, NULL, '10.0'),
(37926, '2017-07-13 13:07:51', NULL, NULL, 10997, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:07:51', 'admin-1499913735-14999224710622526', 1, 1, 'SR', NULL, NULL, '10.0'),
(37927, '2017-07-13 16:34:05', NULL, NULL, 11015, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 16:34:05', 'admin-1499932464-14999348456291539', 1, 0, '', NULL, NULL, '10.0'),
(37928, '2017-07-13 13:49:07', NULL, NULL, 11002, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:49:07', 'admin-1499913735-14999249471356392', 1, 0, '', NULL, NULL, NULL),
(37929, '2017-07-13 13:48:57', NULL, NULL, 11002, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:48:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37930, '2017-07-13 12:49:06', NULL, NULL, 10990, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 12:49:06', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(37931, '2017-07-13 12:49:17', NULL, NULL, 10990, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 12:49:17', 'admin-1499913735-14999213575437094', 1, 1, 'SR', NULL, NULL, '10.0'),
(37932, '2017-07-13 12:49:17', NULL, NULL, 10990, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 12:49:17', 'admin-1499913735-14999213575437094', 1, 1, 'SR', NULL, NULL, '10.0'),
(37933, '2017-07-13 12:50:08', NULL, NULL, 10989, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 12:50:08', 'admin-1499913735-14999214083196280', 1, 1, 'SR', NULL, NULL, NULL),
(37934, '2017-07-13 12:57:25', NULL, NULL, 10991, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1499932464', 'admin', '2017-07-13 12:57:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37935, '2017-07-13 12:57:28', NULL, NULL, 10991, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 12:57:28', 'admin-1499913735-14999218485249259', 1, 1, 'SR', NULL, NULL, NULL),
(37936, '2017-07-13 12:59:46', NULL, NULL, 10993, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1499932464', 'admin', '2017-07-13 12:59:46', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(37937, '2017-07-13 13:09:00', NULL, NULL, 10998, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:09:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37938, '2017-07-13 13:09:09', NULL, NULL, 10998, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:09:09', 'admin-1499913735-14999225494501631', 1, 1, 'SR', NULL, NULL, NULL),
(37939, '2017-07-13 13:17:57', NULL, NULL, 11000, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:17:57', 'admin-1499913735-14999230772564353', 1, 0, '', NULL, NULL, '10.0'),
(37940, '2017-07-13 13:17:57', NULL, NULL, 11000, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:17:57', 'admin-1499913735-14999230772564353', 1, 1, 'SR', NULL, NULL, '10.0'),
(37941, '2017-07-13 13:17:57', NULL, NULL, 11000, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:17:57', 'admin-1499913735-14999230772564353', 1, 1, 'SR', NULL, NULL, '10.0'),
(37942, '2017-07-13 09:16:35', NULL, NULL, 10979, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 09:16:35', 'admin-1499906815-1499908595673367', 1, 0, '', NULL, NULL, NULL),
(37943, '2017-07-13 09:16:43', NULL, NULL, 10979, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 09:16:43', 'admin-1499906815-1499908603393215', 1, 1, 'SR', NULL, NULL, NULL),
(37944, '2017-07-13 09:16:43', NULL, NULL, 10979, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 09:16:43', 'admin-1499906815-1499908603393215', 1, 1, 'SR', NULL, NULL, NULL),
(37945, '2017-07-13 13:00:13', NULL, NULL, 10993, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:00:13', 'admin-1499913735-1499922012945474', 1, 0, '', NULL, NULL, '10.0'),
(37946, '2017-07-13 13:02:29', NULL, NULL, 10995, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:02:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37947, '2017-07-13 13:02:32', NULL, NULL, 10995, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:02:32', 'admin-1499913735-14999221527683113', 1, 1, 'SR', NULL, NULL, NULL),
(37948, '2017-07-13 13:05:14', NULL, NULL, 10996, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:05:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37949, '2017-07-13 13:05:23', NULL, NULL, 10996, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:05:23', 'admin-1499913735-14999223234651485', 1, 1, 'SR', NULL, NULL, NULL),
(37950, '2017-07-13 13:05:23', NULL, NULL, 10996, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:05:23', 'admin-1499913735-14999223234651485', 1, 1, 'SR', NULL, NULL, NULL),
(37951, '2017-07-13 13:07:27', NULL, NULL, 10997, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.80, 0.0000, 0.0000, 11.80, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:07:27', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(37952, '2017-07-13 13:07:51', NULL, NULL, 10997, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:07:51', 'admin-1499913735-14999224710622526', 1, 1, 'SR', NULL, NULL, '10.0'),
(37953, '2017-07-13 09:55:49', NULL, NULL, 10980, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1499932464', 'admin', '2017-07-13 09:55:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37954, '2017-07-13 09:55:58', NULL, NULL, 10980, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 09:55:58', 'admin-1499906815-14999109587263333', 1, 0, '', NULL, NULL, NULL),
(37955, '2017-07-13 09:55:58', NULL, NULL, 10980, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 09:55:58', 'admin-1499906815-14999109587263333', 1, 0, '', NULL, NULL, NULL),
(37956, '2017-07-13 09:55:58', NULL, NULL, 10980, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 09:55:58', 'admin-1499906815-14999109587263333', 1, 0, '', NULL, NULL, NULL),
(37957, '2017-07-13 09:56:07', NULL, NULL, 10980, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 09:56:07', 'admin-1499906815-1499910967158803', 1, 1, 'SR', NULL, NULL, NULL),
(37958, '2017-07-13 09:16:29', NULL, NULL, 10979, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1499932464', 'admin', '2017-07-13 09:16:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37959, '2017-07-13 09:56:07', NULL, NULL, 10980, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 09:56:07', 'admin-1499906815-1499910967158803', 1, 1, 'SR', NULL, NULL, NULL),
(37960, '2017-07-13 09:58:30', NULL, NULL, 10981, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1499932464', 'admin', '2017-07-13 09:58:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37961, '2017-07-13 09:58:35', NULL, NULL, 10981, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 09:58:35', 'admin-1499906815-14999111155078663', 1, 0, '', NULL, NULL, NULL),
(37962, '2017-07-13 09:58:35', NULL, NULL, 10981, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 09:58:35', 'admin-1499906815-14999111155078663', 1, 0, '', NULL, NULL, NULL),
(37963, '2017-07-13 09:58:41', NULL, NULL, 10981, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 09:58:41', 'admin-1499906815-14999111208545237', 1, 1, 'SR', NULL, NULL, NULL),
(37964, '2017-07-13 10:25:55', NULL, NULL, 10982, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1499932464', 'admin', '2017-07-13 10:25:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37965, '2017-07-13 10:25:59', NULL, NULL, 10982, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 10:25:59', 'admin-1499906815-14999127594062796', 1, 1, 'SR', NULL, NULL, NULL),
(37966, '2017-07-13 13:07:51', NULL, NULL, 10997, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:07:51', 'admin-1499913735-14999224710622526', 1, 0, '', NULL, NULL, '10.0'),
(37967, '2017-07-13 10:31:12', NULL, NULL, 10983, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 10:31:12', 'admin-1499906815-14999130727263798', 1, 1, 'SR', NULL, NULL, NULL),
(37968, '2017-07-13 10:40:20', NULL, NULL, 10984, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1499932464', 'admin', '2017-07-13 10:40:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37969, '2017-07-13 13:00:04', NULL, NULL, 10994, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:00:04', 'admin-1499913735-1499922004581764', 1, 0, '', NULL, NULL, NULL),
(37970, '2017-07-13 16:05:14', NULL, NULL, 11014, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1499932464', 'admin', '2017-07-13 16:05:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37971, '2017-07-13 13:52:37', NULL, NULL, 10999, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:52:37', 'admin-1499913735-14999251571502356', 1, 1, 'SR', NULL, NULL, NULL),
(37972, '2017-07-13 13:48:08', NULL, NULL, 11001, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 13:48:08', 'admin-1499913735-14999248880042054', 1, 1, 'SR', 1, NULL, '10.0'),
(37973, '2017-07-13 12:59:59', NULL, NULL, 10994, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1499932464', 'admin', '2017-07-13 12:59:59', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(37974, '2017-07-13 12:59:55', NULL, NULL, 10993, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 12:59:55', 'admin-1499913735-14999219952322417', 1, 0, '', NULL, NULL, '10.0'),
(37975, '2017-07-13 12:25:46', NULL, NULL, 10989, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1499932464', 'admin', '2017-07-13 12:25:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37976, '2017-07-13 12:30:35', NULL, NULL, 10989, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 12:30:35', 'admin-1499913735-14999202356851876', 1, 0, '', NULL, NULL, NULL),
(37977, '2017-07-13 12:30:50', NULL, NULL, 10989, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 12:30:50', 'admin-1499913735-14999202504973035', 1, 1, 'SR', NULL, NULL, NULL),
(37978, '2017-07-13 12:30:50', NULL, NULL, 10989, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 12:30:50', 'admin-1499913735-14999202504973035', 1, 1, 'SR', NULL, NULL, NULL),
(37979, '2017-07-13 12:04:21', NULL, NULL, 10988, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 12:04:22', 'admin-1499913735-14999186618351186', 1, 1, 'SR', NULL, NULL, NULL),
(37980, '2017-07-13 10:31:12', NULL, NULL, 10983, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 10:31:12', 'admin-1499906815-14999130727263798', 1, 1, 'SR', NULL, NULL, NULL),
(37981, '2017-07-13 10:31:12', NULL, NULL, 10983, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 10:31:12', 'admin-1499906815-14999130727263798', 1, 0, '', NULL, NULL, NULL),
(37982, '2017-07-13 10:57:21', NULL, NULL, 10987, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 10:57:21', 'admin-1499913735-14999146411573189', 1, 0, '', NULL, NULL, NULL),
(37983, '2017-07-13 10:42:03', NULL, NULL, 10985, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1499932464', 'admin', '2017-07-13 10:42:03', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(37984, '2017-07-13 10:40:33', NULL, NULL, 10984, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 10:40:33', 'admin-1499906815-14999136334455164', 1, 0, '', NULL, NULL, NULL),
(37985, '2017-07-13 10:40:33', NULL, NULL, 10984, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 10:40:33', 'admin-1499906815-14999136334455164', 1, 1, 'SR', NULL, NULL, NULL),
(37986, '2017-07-13 10:40:33', NULL, NULL, 10984, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 10:40:33', 'admin-1499906815-14999136334455164', 1, 1, 'SR', NULL, NULL, NULL),
(37987, '2017-07-13 10:30:32', NULL, NULL, 10983, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 10:30:32', 'admin-1499906815-14999130320219869', 1, 0, '', NULL, NULL, NULL),
(37988, '2017-07-13 10:30:32', NULL, NULL, 10983, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 10:30:32', 'admin-1499906815-14999130320219869', 1, 0, '', NULL, NULL, NULL),
(37989, '2017-07-13 10:30:25', NULL, NULL, 10983, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 10:30:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37990, '2017-07-13 12:04:19', NULL, NULL, 10988, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1499932464', 'admin', '2017-07-13 12:04:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37991, '2017-07-13 09:16:35', NULL, NULL, 10979, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 09:16:35', 'admin-1499906815-1499908595673367', 1, 0, '', NULL, NULL, NULL),
(37992, '2017-07-13 09:13:39', NULL, NULL, 10978, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 09:13:39', 'admin-1499906815-14999084195325774', 1, 1, 'SR', NULL, NULL, NULL),
(37993, '2017-07-13 09:13:39', NULL, NULL, 10978, 0, 181, '116', 'Open Food ', 'junior blt', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1499932464', 'admin', '2017-07-13 09:13:39', 'admin-1499906815-14999084195325774', 1, 0, '', NULL, NULL, NULL),
(37994, '2017-07-13 09:13:25', NULL, NULL, 10978, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1499932464', 'admin', '2017-07-13 09:13:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(37995, '2017-07-14 13:03:02', NULL, NULL, 11032, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 13:03:02', 'admin-1500007115-15000085828071814', 1, 1, 'SR', NULL, NULL, NULL),
(37996, '2017-07-14 13:31:06', NULL, NULL, 11033, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1500014039', 'admin', '2017-07-14 13:31:06', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(37997, '2017-07-14 13:31:23', NULL, NULL, 11033, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 13:31:23', 'admin-1500007115-15000102837866376', 1, 0, '', NULL, NULL, '10.0'),
(37998, '2017-07-14 13:31:23', NULL, NULL, 11033, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 13:31:23', 'admin-1500007115-15000102837866376', 1, 0, '', NULL, NULL, '10.0'),
(37999, '2017-07-14 13:31:23', NULL, NULL, 11033, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 2, 11.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 13:31:23', 'admin-1500007115-15000102837866376', 1, 1, 'SR', NULL, NULL, '10.0'),
(38000, '2017-07-14 13:40:59', NULL, NULL, 11034, 0, 181, '116', 'Open Food ', 'garlic rice', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 13:40:59', 'admin-1500007115-15000108591829193', 1, 0, '', 1, NULL, '10.0'),
(38001, '2017-07-14 13:43:58', NULL, NULL, 11035, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1500014039', 'admin', '2017-07-14 13:43:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38002, '2017-07-14 13:44:15', NULL, NULL, 11035, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 13:44:15', 'admin-1500007115-15000110555535819', 1, 0, '', NULL, NULL, NULL),
(38003, '2017-07-14 13:44:40', NULL, NULL, 11036, 0, 181, '116', 'Open Food ', 'garlic rice', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 13:44:40', 'admin-1500007115-15000110806634764', 1, 0, '', NULL, NULL, NULL),
(38004, '2017-07-14 00:00:00', NULL, NULL, 11043, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 15:09:27', 'admin-1500014039-15000161676283372', 1, 1, 'SR', NULL, NULL, NULL),
(38005, '2017-07-14 17:11:46', NULL, NULL, 11042, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 17:11:46', 'admin-1500014039-1500023506468160', 1, 0, '', NULL, NULL, NULL),
(38006, '2017-07-14 11:07:18', NULL, NULL, 11019, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 11:07:18', 'admin-1500000286-15000016383527791', 1, 0, '', NULL, NULL, NULL),
(38007, '2017-07-14 11:07:18', NULL, NULL, 11019, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 11:07:18', 'admin-1500000286-15000016383527791', 1, 0, '', NULL, NULL, NULL),
(38008, '2017-07-14 11:23:04', NULL, NULL, 11025, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 11:23:04', 'admin-1500000286-1500002584344518', 1, 1, 'SR', NULL, NULL, NULL),
(38009, '2017-07-14 12:08:15', NULL, NULL, 11026, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:08:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38010, '2017-07-14 12:11:05', NULL, NULL, 11026, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:11:05', 'admin-1500000286-15000054649438127', 1, 0, '', NULL, NULL, NULL),
(38011, '2017-07-14 12:11:17', NULL, NULL, 11026, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:11:17', 'admin-1500000286-15000054774623282', 1, 1, 'SR', NULL, NULL, NULL),
(38012, '2017-07-14 12:11:17', NULL, NULL, 11026, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:11:17', 'admin-1500000286-15000054774623282', 1, 1, 'SR', NULL, NULL, NULL),
(38013, '2017-07-14 12:14:42', NULL, NULL, 11027, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:14:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38014, '2017-07-14 11:21:42', NULL, NULL, 11025, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 11:21:42', 'admin-1500000286-15000025022872890', 1, 0, '', NULL, NULL, NULL),
(38015, '2017-07-14 10:35:03', NULL, NULL, 11022, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 10:35:03', 'admin-1499993902-1499999703071688', 1, 0, '', NULL, NULL, NULL),
(38016, '2017-07-14 10:43:56', NULL, NULL, 11023, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1500014039', 'admin', '2017-07-14 10:43:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38017, '2017-07-14 10:44:01', NULL, NULL, 11023, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 10:44:01', 'admin-1499993902-15000002413679310', 1, 0, '', NULL, NULL, NULL),
(38018, '2017-07-14 10:44:01', NULL, NULL, 11023, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 10:44:01', 'admin-1499993902-15000002413679310', 1, 0, '', NULL, NULL, NULL),
(38019, '2017-07-14 10:44:56', NULL, NULL, 11023, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 10:44:56', 'admin-1500000286-15000002963392363', 1, 1, 'SR', NULL, NULL, NULL),
(38020, '2017-07-14 10:51:04', NULL, NULL, 11019, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 10:51:04', 'admin-1500000286-15000006646106510', 1, 1, 'SR', NULL, NULL, NULL),
(38021, '2017-07-14 17:11:46', NULL, NULL, 11042, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 17:11:46', 'admin-1500014039-1500023506468160', 1, 0, '', NULL, NULL, NULL),
(38022, '2017-07-14 00:00:00', NULL, NULL, 11043, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, NULL, NULL, 2.30, 1, '27', 1, '1500014039', 'admin', '2017-07-14 15:09:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38023, '2017-07-14 00:00:00', NULL, NULL, 11043, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 15:09:27', 'admin-1500014039-15000161676283372', 1, 1, 'SR', NULL, NULL, NULL),
(38024, '2017-07-14 15:14:26', NULL, NULL, 11041, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 15:14:26', 'admin-1500014039-15000164658492015', 1, 1, 'SR', NULL, NULL, NULL),
(38025, '2017-07-14 14:33:46', NULL, NULL, 11039, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1500014039', 'admin', '2017-07-14 14:33:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38026, '2017-07-14 14:33:53', NULL, NULL, 11039, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 14:33:53', 'admin-1500007115-15000140333477977', 1, 0, '', NULL, NULL, NULL),
(38027, '2017-07-14 14:33:53', NULL, NULL, 11039, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 14:33:53', 'admin-1500007115-15000140333477977', 1, 1, 'SR', NULL, NULL, NULL),
(38028, '2017-07-14 15:26:45', NULL, NULL, 11042, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 15:26:45', 'admin-1500014039-150001720499581', 1, 1, 'SR', NULL, NULL, NULL),
(38029, '2017-07-14 15:26:40', NULL, NULL, 11042, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1500014039', 'admin', '2017-07-14 15:26:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38030, '2017-07-14 15:13:33', NULL, NULL, 11041, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 15:13:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38031, '2017-07-14 11:20:30', NULL, NULL, 11024, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 11:20:30', 'admin-1500000286-15000024307419318', 1, 1, 'SR', NULL, NULL, NULL),
(38032, '2017-07-14 15:14:26', NULL, NULL, 11041, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 15:14:26', 'admin-1500014039-15000164658492015', 1, 0, '', NULL, NULL, NULL),
(38033, '2017-07-14 14:14:21', NULL, NULL, 11030, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 14:14:21', 'admin-1500007115-15000128608438341', 1, 1, 'SR', NULL, NULL, NULL),
(38034, '2017-07-14 00:00:00', NULL, NULL, 11043, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 15:11:05', 'admin-1500014039-15000162656859890', 1, 1, 'SR', NULL, NULL, NULL),
(38035, '2017-07-14 13:47:30', NULL, NULL, 11037, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 13:47:30', 'admin-1500007115-15000112506789145', 1, 1, 'SR', NULL, NULL, NULL),
(38036, '2017-07-14 13:50:51', NULL, NULL, 11034, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 13:50:51', 'admin-1500007115-15000114510431235', 1, 1, 'SR', 1, NULL, '10.0'),
(38037, '2017-07-14 12:50:42', NULL, NULL, 11031, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:50:42', 'admin-1500007115-15000078425613741', 1, 1, 'SR', NULL, NULL, NULL),
(38038, '2017-07-14 13:47:30', NULL, NULL, 11037, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 13:47:30', 'admin-1500007115-15000112506789145', 1, 1, 'SR', NULL, NULL, NULL),
(38039, '2017-07-14 13:57:29', NULL, NULL, 11038, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1500014039', 'admin', '2017-07-14 13:57:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38040, '2017-07-14 13:57:33', NULL, NULL, 11038, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 13:57:33', 'admin-1500007115-15000118531105538', 1, 1, 'SR', NULL, NULL, NULL),
(38041, '2017-07-14 14:03:01', NULL, NULL, 11036, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 14:03:01', 'admin-1500007115-15000121809756118', 1, 0, '', NULL, NULL, NULL),
(38042, '2017-07-14 13:44:24', NULL, NULL, 11036, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1500014039', 'admin', '2017-07-14 13:44:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38043, '2017-07-14 13:47:30', NULL, NULL, 11037, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 13:47:30', 'admin-1500007115-15000112506789145', 1, 0, '', NULL, NULL, NULL),
(38044, '2017-07-14 13:47:20', NULL, NULL, 11037, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1500014039', 'admin', '2017-07-14 13:47:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38045, '2017-07-14 11:21:54', NULL, NULL, 11025, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 11:21:54', 'admin-1500000286-15000025145319456', 1, 1, 'SR', NULL, NULL, NULL),
(38046, '2017-07-14 11:23:04', NULL, NULL, 11025, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 11:23:04', 'admin-1500000286-1500002584344518', 1, 0, '', NULL, NULL, NULL),
(38047, '2017-07-14 10:21:53', NULL, NULL, 11019, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 10:21:53', 'admin-1499993902-14999989133056752', 1, 0, '', NULL, NULL, NULL),
(38048, '2017-07-14 10:21:53', NULL, NULL, 11019, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 10:21:53', 'admin-1499993902-14999989133056752', 1, 0, '', NULL, NULL, NULL),
(38049, '2017-07-14 12:08:13', NULL, NULL, 11025, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:08:13', 'admin-1500000286-15000052928855520', 1, 1, 'SR', NULL, NULL, NULL),
(38050, '2017-07-14 10:31:57', NULL, NULL, 11021, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 10:31:57', 'admin-1499993902-14999995175433247', 1, 1, 'SR', 1, NULL, '10.0'),
(38051, '2017-07-14 10:34:58', NULL, NULL, 11022, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1500014039', 'admin', '2017-07-14 10:34:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38052, '2017-07-14 10:35:03', NULL, NULL, 11022, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 10:35:03', 'admin-1499993902-1499999703071688', 1, 0, '', NULL, NULL, NULL),
(38053, '2017-07-14 10:35:03', NULL, NULL, 11022, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 10:35:03', 'admin-1499993902-1499999703071688', 1, 1, 'SR', NULL, NULL, NULL),
(38054, '2017-07-14 13:44:40', NULL, NULL, 11036, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 13:44:40', 'admin-1500007115-15000110806634764', 1, 1, 'SR', NULL, NULL, NULL),
(38055, '2017-07-14 13:44:15', NULL, NULL, 11035, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 13:44:15', 'admin-1500007115-15000110555535819', 1, 1, 'SR', NULL, NULL, NULL),
(38056, '2017-07-14 13:44:15', NULL, NULL, 11035, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 13:44:15', 'admin-1500007115-15000110555535819', 1, 0, '', NULL, NULL, NULL),
(38057, '2017-07-14 13:44:15', NULL, NULL, 11035, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 13:44:15', 'admin-1500007115-15000110555535819', 1, 1, 'SR', NULL, NULL, NULL),
(38058, '2017-07-14 12:50:42', NULL, NULL, 11031, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:50:42', 'admin-1500007115-15000078425613741', 1, 1, 'SR', NULL, NULL, NULL),
(38059, '2017-07-14 13:02:58', NULL, NULL, 11032, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1500014039', 'admin', '2017-07-14 13:02:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38060, '2017-07-14 09:11:32', NULL, NULL, 11016, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 09:11:32', 'admin-1499993902-14999946919307964', 1, 1, 'SR', NULL, NULL, NULL),
(38061, '2017-07-14 09:11:32', NULL, NULL, 11016, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 09:11:32', 'admin-1499993902-14999946919307964', 1, 0, '', NULL, NULL, NULL),
(38062, '2017-07-14 09:26:53', NULL, NULL, 11016, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 09:26:53', 'admin-1499993902-14999956134581573', 1, 0, '', NULL, NULL, NULL),
(38063, '2017-07-14 12:14:53', NULL, NULL, 11027, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:14:53', 'admin-1500000286-1500005692970766', 1, 1, 'SR', NULL, NULL, NULL),
(38064, '2017-07-14 12:28:11', NULL, NULL, 11028, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:28:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38065, '2017-07-14 12:28:26', NULL, NULL, 11028, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:28:26', 'admin-1500000286-15000065063285639', 1, 0, '', NULL, NULL, NULL),
(38066, '2017-07-14 11:07:18', NULL, NULL, 11019, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 11:07:18', 'admin-1500000286-15000016383527791', 1, 1, 'SR', NULL, NULL, NULL),
(38067, '2017-07-14 11:20:06', NULL, NULL, 11024, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1500014039', 'admin', '2017-07-14 11:20:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38068, '2017-07-14 11:20:22', NULL, NULL, 11024, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 11:20:22', 'admin-1500000286-15000024225973210', 1, 0, '', NULL, NULL, NULL),
(38069, '2017-07-14 11:20:22', NULL, NULL, 11024, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 11:20:22', 'admin-1500000286-15000024225973210', 1, 0, '', NULL, NULL, NULL),
(38070, '2017-07-14 11:20:22', NULL, NULL, 11024, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 11:20:22', 'admin-1500000286-15000024225973210', 1, 0, '', NULL, NULL, NULL),
(38071, '2017-07-14 15:14:26', NULL, NULL, 11041, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 15:14:26', 'admin-1500014039-15000164658492015', 1, 1, 'SR', NULL, NULL, NULL),
(38072, '2017-07-14 12:50:34', NULL, NULL, 11031, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:50:34', 'admin-1500007115-15000078346193652', 1, 0, '', NULL, NULL, NULL),
(38073, '2017-07-14 12:50:34', NULL, NULL, 11031, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:50:34', 'admin-1500007115-15000078346193652', 1, 0, '', NULL, NULL, NULL),
(38074, '2017-07-14 12:50:26', NULL, NULL, 11031, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:50:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38075, '2017-07-14 12:38:46', NULL, NULL, 11030, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:38:46', 'admin-1500007115-1500007126271886', 1, 1, 'SR', NULL, NULL, NULL),
(38076, '2017-07-14 12:38:46', NULL, NULL, 11030, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:38:46', 'admin-1500007115-1500007126271886', 1, 1, 'SR', NULL, NULL, NULL),
(38077, '2017-07-14 12:38:27', NULL, NULL, 11030, 0, 181, '116', 'Open Food ', 'garlic rice', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:38:27', 'admin-1500000286-15000071068439570', 1, 0, '', NULL, NULL, NULL),
(38078, '2017-07-14 12:38:27', NULL, NULL, 11030, 0, 181, '116', 'Open Food ', 'garlic rice', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:38:27', 'admin-1500000286-15000071068439570', 1, 0, '', NULL, NULL, NULL),
(38079, '2017-07-14 12:38:13', NULL, NULL, 11030, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:38:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38080, '2017-07-14 12:31:42', NULL, NULL, 11029, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:31:42', 'admin-1500000286-15000067026448837', 1, 1, 'SR', NULL, NULL, NULL),
(38081, '2017-07-14 12:31:42', NULL, NULL, 11029, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:31:42', 'admin-1500000286-15000067026448837', 1, 1, 'SR', NULL, NULL, NULL),
(38082, '2017-07-14 12:31:34', NULL, NULL, 11029, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:31:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38083, '2017-07-14 12:28:26', NULL, NULL, 11028, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:28:26', 'admin-1500000286-15000065063285639', 1, 1, 'SR', NULL, NULL, NULL),
(38084, '2017-07-14 12:28:26', NULL, NULL, 11028, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:28:26', 'admin-1500000286-15000065063285639', 1, 0, '', NULL, NULL, NULL),
(38085, '2017-07-14 10:56:23', NULL, NULL, 11023, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 10:56:23', 'admin-1500000286-15000009837835457', 1, 1, 'SR', NULL, NULL, NULL),
(38086, '2017-07-14 11:02:28', NULL, NULL, 11019, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 11:02:28', 'admin-1500000286-15000013478891451', 1, 1, 'SR', NULL, NULL, NULL),
(38087, '2017-07-14 11:21:31', NULL, NULL, 11025, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1500014039', 'admin', '2017-07-14 11:21:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38088, '2017-07-14 12:14:53', NULL, NULL, 11027, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:14:53', 'admin-1500000286-1500005692970766', 1, 1, 'SR', NULL, NULL, NULL),
(38089, '2017-07-14 11:20:30', NULL, NULL, 11024, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 11:20:30', 'admin-1500000286-15000024307419318', 1, 1, 'SR', NULL, NULL, NULL),
(38090, '2017-07-14 11:02:42', NULL, NULL, 11023, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 11:02:42', 'admin-1500000286-15000013627858850', 1, 1, 'SR', NULL, NULL, NULL),
(38091, '2017-07-14 09:34:50', NULL, NULL, 11017, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1500014039', 'admin', '2017-07-14 09:34:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38092, '2017-07-14 09:35:02', NULL, NULL, 11017, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 09:35:02', 'admin-1499993902-14999961021337595', 1, 0, '', NULL, NULL, NULL),
(38093, '2017-07-14 09:35:02', NULL, NULL, 11017, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 09:35:02', 'admin-1499993902-14999961021337595', 1, 0, '', NULL, NULL, NULL),
(38094, '2017-07-14 09:35:02', NULL, NULL, 11017, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 09:35:02', 'admin-1499993902-14999961021337595', 1, 0, '', NULL, NULL, NULL),
(38095, '2017-07-14 09:35:02', NULL, NULL, 11017, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 09:35:02', 'admin-1499993902-14999961021337595', 1, 0, '', NULL, NULL, NULL),
(38096, '2017-07-14 09:35:07', NULL, NULL, 11017, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 09:35:07', 'admin-1499993902-14999961075944347', 1, 1, 'SR', NULL, NULL, NULL),
(38097, '2017-07-14 09:52:51', NULL, NULL, 11018, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1500014039', 'admin', '2017-07-14 09:52:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38098, '2017-07-14 10:56:13', NULL, NULL, 11023, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 10:56:13', 'admin-1500000286-15000009733682696', 1, 0, '', NULL, NULL, NULL),
(38099, '2017-07-14 09:52:59', NULL, NULL, 11018, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 09:52:59', 'admin-1499993902-14999971791091141', 1, 0, '', NULL, NULL, NULL),
(38100, '2017-07-14 10:08:24', NULL, NULL, 11017, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 10:08:24', 'admin-1499993902-14999981043891173', 1, 1, 'SR', NULL, NULL, NULL),
(38101, '2017-07-14 10:19:36', NULL, NULL, 11018, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 10:19:36', 'admin-1499993902-14999987762833969', 1, 0, '', NULL, NULL, NULL),
(38102, '2017-07-14 10:21:41', NULL, NULL, 11019, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1500014039', 'admin', '2017-07-14 10:21:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38103, '2017-07-14 10:21:53', NULL, NULL, 11019, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 10:21:53', 'admin-1499993902-14999989133056752', 1, 1, 'SR', NULL, NULL, NULL),
(38104, '2017-07-14 10:21:53', NULL, NULL, 11019, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 10:21:53', 'admin-1499993902-14999989133056752', 1, 0, '', NULL, NULL, NULL),
(38105, '2017-07-14 10:21:53', NULL, NULL, 11019, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 10:21:53', 'admin-1499993902-14999989133056752', 1, 0, '', NULL, NULL, NULL),
(38106, '2017-07-14 12:28:26', NULL, NULL, 11028, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 12:28:26', 'admin-1500000286-15000065063285639', 1, 1, 'SR', NULL, NULL, NULL),
(38107, '2017-07-14 09:52:59', NULL, NULL, 11018, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 09:52:59', 'admin-1499993902-14999971791091141', 1, 0, '', NULL, NULL, NULL),
(38108, '2017-07-14 09:11:22', NULL, NULL, 11016, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 09:11:22', 'admin-1499993902-14999946823296789', 1, 0, '', NULL, NULL, NULL),
(38109, '2017-07-14 09:11:22', NULL, NULL, 11016, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500014039', 'admin', '2017-07-14 09:11:22', 'admin-1499993902-14999946823296789', 1, 0, '', NULL, NULL, NULL),
(38110, '2017-07-14 09:11:16', NULL, NULL, 11016, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1500014039', 'admin', '2017-07-14 09:11:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38111, '2017-07-15 13:11:56', NULL, NULL, 11068, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:11:56', 'admin-1500091184-1500095515935592', 1, 1, 'SR', NULL, NULL, NULL),
(38112, '2017-07-15 10:46:18', NULL, NULL, 11052, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:46:18', 'admin-1500084910-15000867781904463', 1, 1, 'SR', NULL, NULL, NULL),
(38113, '2017-07-15 11:46:15', NULL, NULL, 11056, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:46:15', 'admin-1500084910-15000903752696139', 1, 0, '', NULL, NULL, NULL),
(38114, '2017-07-15 11:47:37', NULL, NULL, 11055, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:47:37', 'admin-1500084910-15000904570799289', 1, 0, '', NULL, NULL, NULL),
(38115, '2017-07-15 11:47:37', NULL, NULL, 11055, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:47:37', 'admin-1500084910-15000904570799289', 1, 1, 'SR', NULL, NULL, NULL),
(38116, '2017-07-15 12:09:36', NULL, NULL, 11062, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:09:36', 'admin-1500091184-15000917762331025', 1, 0, '', NULL, NULL, NULL),
(38117, '2017-07-15 12:09:36', NULL, NULL, 11062, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:09:36', 'admin-1500091184-15000917762331025', 1, 0, '', NULL, NULL, NULL),
(38118, '2017-07-15 13:11:56', NULL, NULL, 11068, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:11:56', 'admin-1500091184-1500095515935592', 1, 1, 'SR', NULL, NULL, NULL),
(38119, '2017-07-15 15:50:01', NULL, NULL, 11078, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:50:01', 'admin-1500100134-15001050011727547', 1, 1, 'SR', NULL, NULL, NULL),
(38120, '2017-07-15 15:50:01', NULL, NULL, 11078, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:50:01', 'admin-1500100134-15001050011727547', 1, 1, 'SR', NULL, NULL, NULL),
(38121, '2017-07-15 15:50:01', NULL, NULL, 11078, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:50:01', 'admin-1500100134-15001050011727547', 1, 0, '', NULL, NULL, NULL),
(38122, '2017-07-15 15:50:01', NULL, NULL, 11078, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:50:01', 'admin-1500100134-15001050011727547', 1, 1, 'SR', NULL, NULL, NULL),
(38123, '2017-07-15 14:53:53', NULL, NULL, 11074, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 14:53:53', 'admin-1500100134-15001016336756193', 1, 1, 'SR', NULL, NULL, NULL),
(38124, '2017-07-15 13:58:30', NULL, NULL, 11073, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:58:30', 'admin-1500091184-15000983098304214', 1, 1, 'SR', NULL, NULL, NULL),
(38125, '2017-07-15 13:11:35', NULL, NULL, 11068, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:11:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38126, '2017-07-15 15:26:03', NULL, NULL, 11078, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:26:03', 'admin-1500100134-15001035633015848', 1, 0, '', NULL, NULL, NULL),
(38127, '2017-07-15 13:41:54', NULL, NULL, 11070, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:41:54', 'admin-1500091184-15000973139022364', 1, 0, '', NULL, NULL, NULL),
(38128, '2017-07-15 13:41:54', NULL, NULL, 11070, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:41:54', 'admin-1500091184-15000973139022364', 1, 0, '', NULL, NULL, NULL),
(38129, '2017-07-15 13:49:02', NULL, NULL, 11072, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:49:02', 'admin-1500091184-15000977425125317', 1, 1, 'SR', NULL, NULL, NULL),
(38130, '2017-07-15 13:48:58', NULL, NULL, 11072, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:48:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38131, '2017-07-15 13:46:45', NULL, NULL, 11071, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:46:45', 'admin-1500091184-15000976057211372', 1, 0, '', NULL, NULL, NULL),
(38132, '2017-07-15 15:21:43', NULL, NULL, 11075, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:21:43', 'admin-1500100134-15001033032428228', 1, 1, 'SR', 1, NULL, NULL),
(38133, '2017-07-15 15:21:43', NULL, NULL, 11075, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:21:43', 'admin-1500100134-15001033032428228', 1, 1, 'SR', 1, NULL, NULL),
(38134, '2017-07-15 15:25:30', NULL, NULL, 11078, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.20, 0.0000, 0.0000, 11.20, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:25:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38135, '2017-07-15 15:26:03', NULL, NULL, 11078, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:26:03', 'admin-1500100134-15001035633015848', 1, 0, '', NULL, NULL, NULL),
(38136, '2017-07-15 10:17:31', NULL, NULL, 11050, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:17:31', 'admin-1500084910-1500085051446204', 1, 0, '', NULL, NULL, NULL),
(38137, '2017-07-15 10:17:31', NULL, NULL, 11050, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:17:31', 'admin-1500084910-1500085051446204', 1, 0, '', NULL, NULL, NULL),
(38138, '2017-07-15 15:26:03', NULL, NULL, 11078, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:26:03', 'admin-1500100134-15001035633015848', 1, 0, '', NULL, NULL, NULL),
(38139, '2017-07-15 15:06:42', NULL, NULL, 11076, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:06:42', 'admin-1500100134-15001024026147440', 1, 1, 'SR', NULL, NULL, NULL),
(38140, '2017-07-15 15:06:42', NULL, NULL, 11076, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:06:42', 'admin-1500100134-15001024026147440', 1, 1, 'SR', NULL, NULL, NULL),
(38141, '2017-07-15 15:07:59', NULL, NULL, 11076, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:07:59', 'admin-1500100134-15001024794441397', 1, 1, 'SR', NULL, NULL, NULL),
(38142, '2017-07-15 15:08:33', NULL, NULL, 11076, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:08:33', 'admin-1500100134-15001025128431585', 1, 0, '', NULL, NULL, NULL),
(38143, '2017-07-15 15:08:33', NULL, NULL, 11076, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:08:33', 'admin-1500100134-15001025128431585', 1, 0, '', NULL, NULL, NULL),
(38144, '2017-07-15 15:10:03', NULL, NULL, 11076, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:10:03', 'admin-1500100134-15001026036732923', 1, 0, '', NULL, NULL, NULL),
(38145, '2017-07-15 15:12:14', NULL, NULL, 11077, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:12:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38146, '2017-07-15 15:12:24', NULL, NULL, 11077, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:12:24', 'admin-1500100134-1500102744281664', 1, 1, 'SR', NULL, NULL, NULL),
(38147, '2017-07-15 15:12:24', NULL, NULL, 11077, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:12:24', 'admin-1500100134-1500102744281664', 1, 1, 'SR', NULL, NULL, NULL),
(38148, '2017-07-15 16:23:28', NULL, NULL, 11078, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 16:23:28', 'admin-1500100134-15001070086965284', 1, 0, '', NULL, NULL, NULL),
(38149, '2017-07-15 15:51:16', NULL, NULL, 11078, 0, 181, '116', 'Open Food ', 'fries', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:51:16', 'admin-1500100134-1500105076390119', 1, 0, '', NULL, NULL, NULL),
(38150, '2017-07-15 16:03:08', NULL, NULL, 11079, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 16:03:08', 'admin-1500100134-15001057886407426', 1, 0, '', 1, NULL, '10.0'),
(38151, '2017-07-15 15:06:10', NULL, NULL, 11076, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:06:10', 'admin-1500100134-15001023701774453', 1, 1, 'SR', NULL, NULL, NULL),
(38152, '2017-07-15 15:06:10', NULL, NULL, 11076, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:06:10', 'admin-1500100134-15001023701774453', 1, 0, '', NULL, NULL, NULL),
(38153, '2017-07-15 16:53:50', NULL, NULL, 11081, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 16:53:50', 'admin-1500107018-15001088300248085', 1, 1, 'SR', 1, NULL, NULL),
(38154, '2017-07-15 13:46:45', NULL, NULL, 11071, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:46:45', 'admin-1500091184-15000976057211372', 1, 0, '', NULL, NULL, NULL),
(38155, '2017-07-15 13:46:35', NULL, NULL, 11071, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:46:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38156, '2017-07-15 13:42:29', NULL, NULL, 11070, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:42:29', 'admin-1500091184-1500097349297453', 1, 1, 'SR', NULL, NULL, NULL),
(38157, '2017-07-15 13:42:29', NULL, NULL, 11070, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:42:29', 'admin-1500091184-1500097349297453', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(38158, '2017-07-15 10:17:31', NULL, NULL, 11050, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:17:31', 'admin-1500084910-1500085051446204', 1, 1, 'SR', NULL, NULL, NULL),
(38159, '2017-07-15 16:53:50', NULL, NULL, 11081, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 16:53:50', 'admin-1500107018-15001088300248085', 1, 1, 'SR', 1, NULL, NULL),
(38160, '2017-07-15 13:05:22', NULL, NULL, 11066, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:05:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38161, '2017-07-15 12:00:40', NULL, NULL, 11061, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:00:40', 'admin-1500091184-15000912408092084', 1, 0, '', NULL, NULL, NULL),
(38162, '2017-07-15 11:58:16', NULL, NULL, 11061, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:58:16', 'admin-1500084910-15000910961731448', 1, 1, 'SR', NULL, NULL, NULL),
(38163, '2017-07-15 11:52:03', NULL, NULL, 11059, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:52:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38164, '2017-07-15 11:52:16', NULL, NULL, 11059, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:52:16', 'admin-1500084910-15000907357958763', 1, 1, 'SR', NULL, NULL, NULL),
(38165, '2017-07-15 11:52:16', NULL, NULL, 11059, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:52:16', 'admin-1500084910-15000907357958763', 1, 1, 'SR', NULL, NULL, NULL),
(38166, '2017-07-15 11:52:59', NULL, NULL, 11060, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:52:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38167, '2017-07-15 11:54:01', NULL, NULL, 11060, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:54:01', 'admin-1500084910-15000908407401459', 1, 1, 'SR', NULL, NULL, NULL),
(38168, '2017-07-15 12:15:05', NULL, NULL, 11063, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:15:05', 'admin-1500091184-15000921049115843', 1, 1, 'SR', NULL, NULL, NULL),
(38169, '2017-07-15 13:58:30', NULL, NULL, 11073, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:58:30', 'admin-1500091184-15000983098304214', 1, 1, 'SR', NULL, NULL, NULL),
(38170, '2017-07-15 13:33:25', NULL, NULL, 11069, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:33:25', 'admin-1500091184-15000968055232390', 1, 1, 'SR', NULL, NULL, NULL),
(38171, '2017-07-15 13:41:33', NULL, NULL, 11070, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:41:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38172, '2017-07-15 10:46:00', NULL, NULL, 11052, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:46:00', 'admin-1500084910-15000867598863453', 1, 0, '', NULL, NULL, NULL),
(38173, '2017-07-15 11:26:43', NULL, NULL, 11056, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.89, 0.0000, 0.0000, 1.89, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:26:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38174, '2017-07-15 11:26:51', NULL, NULL, 11056, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:26:51', 'admin-1500084910-15000892110599124', 1, 1, 'SR', NULL, NULL, NULL),
(38175, '2017-07-15 11:26:51', NULL, NULL, 11056, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:26:51', 'admin-1500084910-15000892110599124', 1, 0, '', NULL, NULL, NULL),
(38176, '2017-07-15 11:31:07', NULL, NULL, 11057, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:31:08', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(38177, '2017-07-15 11:31:25', NULL, NULL, 11057, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:31:25', 'admin-1500084910-15000894857944549', 1, 1, 'SR', NULL, NULL, '10.0'),
(38178, '2017-07-15 12:37:48', NULL, NULL, 11065, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:37:48', 'admin-1500091184-15000934677834726', 1, 0, '', NULL, NULL, NULL),
(38179, '2017-07-15 15:26:03', NULL, NULL, 11078, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:26:03', 'admin-1500100134-15001035633015848', 1, 0, '', NULL, NULL, NULL),
(38180, '2017-07-15 14:53:53', NULL, NULL, 11074, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 14:53:53', 'admin-1500100134-15001016336756193', 1, 1, 'SR', NULL, NULL, NULL),
(38181, '2017-07-15 15:05:52', NULL, NULL, 11076, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:05:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38182, '2017-07-15 15:21:43', NULL, NULL, 11075, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 15:21:43', 'admin-1500100134-15001033032428228', 1, 1, 'SR', 1, NULL, NULL),
(38183, '2017-07-15 14:13:41', NULL, NULL, 11074, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 14:13:41', 'admin-1500091184-1500099221165868', 1, 1, 'SR', NULL, NULL, NULL),
(38184, '2017-07-15 14:38:01', NULL, NULL, 11075, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 14:38:01', 'admin-1500100134-15001006817103411', 1, 1, 'SR', 1, NULL, NULL),
(38185, '2017-07-15 14:13:41', NULL, NULL, 11074, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 14:13:41', 'admin-1500091184-1500099221165868', 1, 1, 'SR', NULL, NULL, NULL),
(38186, '2017-07-15 14:13:35', NULL, NULL, 11074, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 14:13:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38187, '2017-07-15 13:33:20', NULL, NULL, 11069, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:33:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38188, '2017-07-15 13:12:15', NULL, NULL, 11068, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:12:15', 'admin-1500091184-15000955349219368', 1, 1, 'SR', NULL, NULL, NULL),
(38189, '2017-07-15 13:08:19', NULL, NULL, 11067, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:08:19', 'admin-1500091184-1500095299665455', 1, 1, 'SR', 1, NULL, NULL),
(38190, '2017-07-15 13:57:35', NULL, NULL, 11073, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:57:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38191, '2017-07-15 13:57:42', NULL, NULL, 11073, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:57:42', 'admin-1500091184-15000982627052099', 1, 0, '', NULL, NULL, NULL),
(38192, '2017-07-15 13:05:42', NULL, NULL, 11066, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:05:42', 'admin-1500091184-15000951426261092', 1, 1, 'SR', NULL, NULL, NULL),
(38193, '2017-07-15 13:05:32', NULL, NULL, 11066, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:05:32', 'admin-1500091184-15000951317978537', 1, 1, 'SR', NULL, NULL, NULL),
(38194, '2017-07-15 12:38:00', NULL, NULL, 11065, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:38:00', 'admin-1500091184-15000934802085078', 1, 0, '', NULL, NULL, NULL),
(38195, '2017-07-15 11:54:01', NULL, NULL, 11060, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:54:01', 'admin-1500084910-15000908407401459', 1, 0, '', NULL, NULL, NULL),
(38196, '2017-07-15 11:54:01', NULL, NULL, 11060, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:54:01', 'admin-1500084910-15000908407401459', 1, 0, '', NULL, NULL, NULL),
(38197, '2017-07-15 11:54:01', NULL, NULL, 11060, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:54:01', 'admin-1500084910-15000908407401459', 1, 0, '', NULL, NULL, NULL),
(38198, '2017-07-15 11:54:01', NULL, NULL, 11060, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:54:01', 'admin-1500084910-15000908407401459', 1, 0, '', NULL, NULL, NULL),
(38199, '2017-07-15 12:57:03', NULL, NULL, 11064, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:57:03', 'admin-1500091184-15000946235919864', 1, 0, '', NULL, NULL, NULL),
(38200, '2017-07-15 12:37:47', NULL, NULL, 11065, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:37:47', 'admin-1500091184-15000934677834726', 1, 0, '', NULL, NULL, NULL),
(38201, '2017-07-15 12:38:00', NULL, NULL, 11065, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:38:00', 'admin-1500091184-15000934802085078', 1, 1, 'SR', NULL, NULL, NULL),
(38202, '2017-07-15 12:37:24', NULL, NULL, 11065, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:37:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38203, '2017-07-15 11:54:01', NULL, NULL, 11060, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:54:01', 'admin-1500084910-15000908407401459', 1, 0, '', NULL, NULL, NULL),
(38204, '2017-07-15 12:29:50', NULL, NULL, 11064, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:29:50', 'admin-1500091184-15000929901804698', 1, 0, '', NULL, NULL, NULL),
(38205, '2017-07-15 12:29:57', NULL, NULL, 11064, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:29:57', 'admin-1500091184-15000929975547887', 1, 1, 'SR', NULL, NULL, NULL),
(38206, '2017-07-15 12:29:57', NULL, NULL, 11064, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:29:57', 'admin-1500091184-15000929975547887', 1, 1, 'SR', NULL, NULL, NULL),
(38207, '2017-07-15 12:29:50', NULL, NULL, 11064, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:29:50', 'admin-1500091184-15000929901804698', 1, 0, '', NULL, NULL, NULL),
(38208, '2017-07-15 12:29:40', NULL, NULL, 11064, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.39, 0.0000, 0.0000, 5.39, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:29:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38209, '2017-07-15 12:19:11', NULL, NULL, 11063, 0, 182, '117', 'Open Drinks ', 'orange', 'Cold Drinks', 'Fresh Juice', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:19:11', 'admin-1500091184-15000923511042944', 1, 0, '', NULL, NULL, NULL),
(38210, '2017-07-15 11:54:01', NULL, NULL, 11060, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:54:01', 'admin-1500084910-15000908407401459', 1, 1, 'SR', NULL, NULL, NULL),
(38211, '2017-07-15 12:15:05', NULL, NULL, 11063, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:15:05', 'admin-1500091184-15000921049115843', 1, 1, 'SR', NULL, NULL, NULL),
(38212, '2017-07-15 12:14:50', NULL, NULL, 11063, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:14:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38213, '2017-07-15 11:57:03', NULL, NULL, 11061, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:57:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38214, '2017-07-15 12:14:06', NULL, NULL, 11062, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:14:06', 'admin-1500091184-15000920459717469', 1, 1, 'SR', NULL, NULL, NULL),
(38215, '2017-07-15 09:28:36', NULL, NULL, 11048, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 09:28:36', 'admin-1500079614-15000821160484112', 1, 1, 'SR', NULL, NULL, NULL),
(38216, '2017-07-15 09:28:36', NULL, NULL, 11048, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 09:28:36', 'admin-1500079614-15000821160484112', 1, 0, '', NULL, NULL, NULL),
(38217, '2017-07-15 09:28:36', NULL, NULL, 11048, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 09:28:36', 'admin-1500079614-15000821160484112', 1, 0, '', NULL, NULL, NULL),
(38218, '2017-07-15 10:12:46', NULL, NULL, 11048, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:12:46', 'admin-1500079614-15000847659229663', 1, 0, '', NULL, NULL, NULL),
(38219, '2017-07-15 10:12:46', NULL, NULL, 11048, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:12:46', 'admin-1500079614-15000847659229663', 1, 0, '', NULL, NULL, NULL),
(38220, '2017-07-15 10:13:04', NULL, NULL, 11048, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:13:04', 'admin-1500079614-15000847845434199', 1, 1, 'SR', NULL, NULL, NULL),
(38221, '2017-07-15 10:13:04', NULL, NULL, 11048, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:13:04', 'admin-1500079614-15000847845434199', 1, 1, 'SR', NULL, NULL, NULL),
(38222, '2017-07-15 11:54:01', NULL, NULL, 11060, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:54:01', 'admin-1500084910-15000908407401459', 1, 1, 'SR', NULL, NULL, NULL),
(38223, '2017-07-15 11:54:01', NULL, NULL, 11060, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:54:01', 'admin-1500084910-15000908407401459', 1, 1, 'SR', NULL, NULL, NULL),
(38224, '2017-07-15 10:56:56', NULL, NULL, 11050, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:56:56', 'admin-1500084910-15000874162258898', 1, 0, '', NULL, NULL, NULL),
(38225, '2017-07-15 10:56:56', NULL, NULL, 11050, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:56:56', 'admin-1500084910-15000874162258898', 1, 0, '', NULL, NULL, NULL),
(38226, '2017-07-15 11:07:59', NULL, NULL, 11054, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:07:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38227, '2017-07-15 11:08:03', NULL, NULL, 11054, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:08:03', 'admin-1500084910-15000880836417348', 1, 0, '', NULL, NULL, NULL),
(38228, '2017-07-15 11:08:08', NULL, NULL, 11054, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:08:08', 'admin-1500084910-15000880878692191', 1, 1, 'SR', NULL, NULL, NULL),
(38229, '2017-07-15 10:17:31', NULL, NULL, 11050, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:17:31', 'admin-1500084910-1500085051446204', 1, 1, 'SR', NULL, NULL, NULL),
(38230, '2017-07-15 10:17:31', NULL, NULL, 11050, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:17:31', 'admin-1500084910-1500085051446204', 1, 1, 'SR', NULL, NULL, NULL),
(38231, '2017-07-15 10:35:36', NULL, NULL, 11051, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:35:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38232, '2017-07-15 10:35:52', NULL, NULL, 11051, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:35:52', 'admin-1500084910-15000861524123395', 1, 1, 'SR', NULL, NULL, NULL),
(38233, '2017-07-15 10:35:52', NULL, NULL, 11051, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:35:52', 'admin-1500084910-15000861524123395', 1, 0, '', NULL, NULL, NULL),
(38234, '2017-07-15 11:54:01', NULL, NULL, 11060, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:54:01', 'admin-1500084910-15000908407401459', 1, 1, 'SR', NULL, NULL, NULL),
(38235, '2017-07-15 12:05:25', NULL, NULL, 11062, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:05:25', 'admin-1500091184-15000915253122045', 1, 1, 'SR', NULL, NULL, NULL),
(38236, '2017-07-15 12:05:14', NULL, NULL, 11062, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:05:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38237, '2017-07-15 12:00:40', NULL, NULL, 11061, 0, 181, '116', 'Open Food ', 'chicken', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:00:40', 'admin-1500091184-15000912408092084', 1, 0, '', NULL, NULL, NULL),
(38238, '2017-07-15 11:17:58', NULL, NULL, 11055, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:17:58', 'admin-1500084910-15000886777629825', 1, 1, 'SR', NULL, NULL, NULL),
(38239, '2017-07-15 11:17:57', NULL, NULL, 11055, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:17:57', 'admin-1500084910-15000886777629825', 1, 0, '', NULL, NULL, NULL),
(38240, '2017-07-15 11:17:52', NULL, NULL, 11055, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:17:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38241, '2017-07-15 10:55:59', NULL, NULL, 11053, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:55:59', 'admin-1500084910-15000873591716590', 1, 0, '', NULL, NULL, NULL),
(38242, '2017-07-15 10:55:59', NULL, NULL, 11053, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:55:59', 'admin-1500084910-15000873591716590', 1, 1, 'SR', NULL, NULL, NULL),
(38243, '2017-07-15 10:55:59', NULL, NULL, 11053, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:55:59', 'admin-1500084910-15000873591716590', 1, 0, '', NULL, NULL, NULL),
(38244, '2017-07-15 10:54:53', NULL, NULL, 11053, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:54:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38245, '2017-07-15 10:47:12', NULL, NULL, 11048, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:47:12', 'admin-1500084910-1500086832075335', 1, 1, 'SR', NULL, NULL, NULL),
(38246, '2017-07-15 11:31:25', NULL, NULL, 11057, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 11:31:25', 'admin-1500084910-15000894857944549', 1, 0, '', NULL, NULL, '10.0'),
(38247, '2017-07-15 10:46:18', NULL, NULL, 11052, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:46:18', 'admin-1500084910-15000867781904463', 1, 1, 'SR', NULL, NULL, NULL),
(38248, '2017-07-15 10:46:18', NULL, NULL, 11052, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:46:18', 'admin-1500084910-15000867781904463', 1, 1, 'SR', NULL, NULL, NULL),
(38249, '2017-07-15 09:26:09', NULL, NULL, 11046, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 09:26:09', 'admin-1500079614-15000819688299936', 1, 0, '', NULL, NULL, NULL),
(38250, '2017-07-15 09:26:09', NULL, NULL, 11046, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 09:26:09', 'admin-1500079614-15000819688299936', 1, 0, '', NULL, NULL, NULL),
(38251, '2017-07-15 09:28:11', NULL, NULL, 11047, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1500107018', 'admin', '2017-07-15 09:28:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38252, '2017-07-15 09:28:18', NULL, NULL, 11047, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 09:28:18', 'admin-1500079614-15000820980323765', 1, 1, 'SR', NULL, NULL, NULL),
(38253, '2017-07-15 12:37:47', NULL, NULL, 11065, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:37:48', 'admin-1500091184-15000934677834726', 1, 0, '', NULL, NULL, NULL),
(38254, '2017-07-15 10:46:18', NULL, NULL, 11052, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:46:18', 'admin-1500084910-15000867781904463', 1, 1, 'SR', NULL, NULL, NULL),
(38255, '2017-07-15 10:45:46', NULL, NULL, 11052, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:45:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38256, '2017-07-15 10:46:00', NULL, NULL, 11052, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:46:00', 'admin-1500084910-15000867598863453', 1, 0, '', NULL, NULL, NULL),
(38257, '2017-07-15 12:05:25', NULL, NULL, 11062, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 12:05:25', 'admin-1500091184-15000915253122045', 1, 0, '', NULL, NULL, NULL),
(38258, '2017-07-15 10:17:31', NULL, NULL, 11050, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:17:31', 'admin-1500084910-1500085051446204', 1, 0, '', NULL, NULL, NULL),
(38259, '2017-07-15 10:17:31', NULL, NULL, 11050, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:17:31', 'admin-1500084910-1500085051446204', 1, 0, '', NULL, NULL, NULL),
(38260, '2017-07-15 10:17:31', NULL, NULL, 11050, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:17:31', 'admin-1500084910-1500085051446204', 1, 0, '', NULL, NULL, NULL),
(38261, '2017-07-15 10:16:55', NULL, NULL, 11050, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.40, 0.0000, 0.0000, 11.40, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:16:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38262, '2017-07-15 10:15:05', NULL, NULL, 11049, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:15:05', 'admin-1500079614-15000849050121837', 1, 0, '', NULL, NULL, NULL),
(38263, '2017-07-15 10:15:01', NULL, NULL, 11049, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:15:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38264, '2017-07-15 10:13:54', NULL, NULL, 11048, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:13:54', 'admin-1500079614-15000848341591414', 1, 0, '', NULL, NULL, NULL),
(38265, '2017-07-15 13:05:42', NULL, NULL, 11066, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:05:42', 'admin-1500091184-15000951426261092', 1, 0, '', NULL, NULL, NULL),
(38266, '2017-07-15 10:13:54', NULL, NULL, 11048, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:13:54', 'admin-1500079614-15000848341591414', 1, 1, 'SR', NULL, NULL, NULL),
(38267, '2017-07-15 13:33:25', NULL, NULL, 11069, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 13:33:25', 'admin-1500091184-15000968055232390', 1, 1, 'SR', NULL, NULL, NULL),
(38268, '2017-07-15 09:09:51', NULL, NULL, 11045, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 09:09:51', 'admin-1500079614-15000809912487058', 1, 0, '', NULL, NULL, NULL),
(38269, '2017-07-15 09:09:51', NULL, NULL, 11045, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 09:09:51', 'admin-1500079614-15000809912487058', 1, 0, '', NULL, NULL, NULL),
(38270, '2017-07-15 09:09:51', NULL, NULL, 11045, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 09:09:51', 'admin-1500079614-15000809912487058', 1, 1, 'SR', NULL, NULL, NULL),
(38271, '2017-07-15 09:09:51', NULL, NULL, 11045, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 09:09:51', 'admin-1500079614-15000809912487058', 1, 1, 'SR', NULL, NULL, NULL),
(38272, '2017-07-15 09:09:51', NULL, NULL, 11045, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 09:09:51', 'admin-1500079614-15000809912487058', 1, 0, '', NULL, NULL, NULL),
(38273, '2017-07-15 09:25:47', NULL, NULL, 11046, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1500107018', 'admin', '2017-07-15 09:25:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38274, '2017-07-15 09:26:09', NULL, NULL, 11046, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 09:26:09', 'admin-1500079614-15000819688299936', 1, 1, 'SR', NULL, NULL, NULL),
(38275, '2017-07-15 10:55:59', NULL, NULL, 11053, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 10:55:59', 'admin-1500084910-15000873591716590', 1, 1, 'SR', NULL, NULL, NULL),
(38276, '2017-07-15 09:28:18', NULL, NULL, 11047, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 09:28:18', 'admin-1500079614-15000820980323765', 1, 1, 'SR', NULL, NULL, NULL),
(38277, '2017-07-15 09:28:25', NULL, NULL, 11048, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.20, 0.0000, 0.0000, 14.20, 1, '27', 1, '1500107018', 'admin', '2017-07-15 09:28:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38278, '2017-07-15 09:26:09', NULL, NULL, 11046, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 09:26:09', 'admin-1500079614-15000819688299936', 1, 1, 'SR', NULL, NULL, NULL),
(38279, '2017-07-15 09:09:31', NULL, NULL, 11045, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1500107018', 'admin', '2017-07-15 09:09:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38280, '2017-07-15 09:09:51', NULL, NULL, 11045, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 09:09:51', 'admin-1500079614-15000809912487058', 1, 0, '', NULL, NULL, NULL),
(38281, '2017-07-15 09:02:41', NULL, NULL, 11044, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500107018', 'admin', '2017-07-15 09:02:41', 'admin-1500079614-15000805617266864', 1, 0, '', 1, NULL, NULL),
(38282, '2017-07-16 13:27:45', NULL, NULL, 11094, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:27:46', 'admin-1500181895-15001828657284943', 1, 1, 'SR', NULL, NULL, NULL),
(38283, '2017-07-16 12:53:57', NULL, NULL, 11119, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:53:57', 'admin-1500179863-15001808377601595', 1, 1, 'SR', NULL, NULL, NULL),
(38284, '2017-07-16 10:33:36', NULL, NULL, 11096, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:33:36', 'admin-1500169344-1500172416612123', 1, 1, 'SR', NULL, NULL, NULL),
(38285, '2017-07-16 10:34:11', NULL, NULL, 11095, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:34:11', 'admin-1500172442-15001724516005076', 1, 1, 'SR', NULL, NULL, '10.0'),
(38286, '2017-07-16 10:35:55', NULL, NULL, 11097, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:35:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38287, '2017-07-16 10:36:07', NULL, NULL, 11097, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:36:07', 'admin-1500172442-15001725675118548', 1, 0, '', NULL, NULL, NULL),
(38288, '2017-07-16 10:36:07', NULL, NULL, 11097, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:36:07', 'admin-1500172442-15001725675118548', 1, 0, '', NULL, NULL, NULL),
(38289, '2017-07-16 10:36:07', NULL, NULL, 11097, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:36:07', 'admin-1500172442-15001725675118548', 1, 0, '', NULL, NULL, NULL),
(38290, '2017-07-16 10:36:07', NULL, NULL, 11097, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:36:07', 'admin-1500172442-15001725675118548', 1, 0, '', NULL, NULL, NULL),
(38291, '2017-07-16 15:01:46', NULL, NULL, 11133, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 15:01:46', 'admin-1500184404-1500188505924109', 1, 1, 'SR', NULL, NULL, NULL),
(38292, '2017-07-16 13:19:30', NULL, NULL, 11120, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:19:30', 'admin-1500181895-1500182369929472', 1, 1, 'SR', NULL, NULL, NULL),
(38293, '2017-07-16 13:19:30', NULL, NULL, 11120, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:19:30', 'admin-1500181895-1500182369929472', 1, 0, '', NULL, NULL, NULL),
(38294, '2017-07-16 13:18:11', NULL, NULL, 11120, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:18:11', 'admin-1500181895-15001822913106498', 1, 0, '', NULL, NULL, NULL),
(38295, '2017-07-16 13:31:52', NULL, NULL, 11123, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:31:52', 'admin-1500181895-15001831123465679', 1, 0, '', NULL, NULL, '10.0'),
(38296, '2017-07-16 13:31:52', NULL, NULL, 11123, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:31:52', 'admin-1500181895-15001831123465679', 1, 1, 'SR', NULL, NULL, '10.0'),
(38297, '2017-07-16 17:39:25', NULL, NULL, 11141, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 17:39:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38298, '2017-07-16 17:39:29', NULL, NULL, 11141, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 2, 20.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 17:39:29', 'admin-1500189795-1500197969255365', 1, 1, 'SR', NULL, NULL, NULL),
(38299, '2017-07-16 13:50:31', NULL, NULL, 11126, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:50:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38300, '2017-07-16 13:11:25', NULL, NULL, 11121, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:11:25', 'admin-1500179863-15001818854285298', 1, 0, '', NULL, NULL, NULL),
(38301, '2017-07-16 13:11:25', NULL, NULL, 11121, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:11:25', 'admin-1500179863-15001818854285298', 1, 0, '', NULL, NULL, NULL),
(38302, '2017-07-16 13:04:47', NULL, NULL, 11120, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:04:47', 'admin-1500179863-1500181487283565', 1, 1, 'SR', NULL, NULL, NULL),
(38303, '2017-07-16 13:11:14', NULL, NULL, 11121, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:11:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38304, '2017-07-16 15:40:16', NULL, NULL, 11136, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1500189795', 'admin', '2017-07-16 15:40:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38305, '2017-07-16 13:39:56', NULL, NULL, 11124, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:39:56', 'admin-1500181895-15001835963645258', 1, 1, 'SR', NULL, NULL, '10.0'),
(38306, '2017-07-16 12:51:24', NULL, NULL, 11118, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:51:24', 'admin-1500179863-1500180683803892', 1, 0, '', NULL, NULL, NULL),
(38307, '2017-07-16 11:49:16', NULL, NULL, 11107, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:49:16', 'admin-1500172442-15001769562002020', 1, 1, 'SR', NULL, NULL, NULL),
(38308, '2017-07-16 11:51:04', NULL, NULL, 11100, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:51:04', 'admin-1500172442-15001770640819052', 1, 1, 'SR', NULL, NULL, NULL),
(38309, '2017-07-16 11:51:04', NULL, NULL, 11100, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:51:04', 'admin-1500172442-15001770640819052', 1, 0, '', NULL, NULL, NULL),
(38310, '2017-07-16 11:51:04', NULL, NULL, 11100, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:51:04', 'admin-1500172442-15001770640819052', 1, 0, '', NULL, NULL, NULL),
(38311, '2017-07-16 16:56:27', NULL, NULL, 11137, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 16:56:27', 'admin-1500189795-15001953871136493', 1, 0, '', NULL, NULL, NULL),
(38312, '2017-07-16 17:21:35', NULL, NULL, 11140, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1500189795', 'admin', '2017-07-16 17:21:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38313, '2017-07-16 14:59:29', NULL, NULL, 11131, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 14:59:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38314, '2017-07-16 13:53:31', NULL, NULL, 11127, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:53:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38315, '2017-07-16 13:53:46', NULL, NULL, 11127, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:53:46', 'admin-1500184404-15001844267727269', 1, 0, '', NULL, NULL, NULL),
(38316, '2017-07-16 13:53:46', NULL, NULL, 11127, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:53:46', 'admin-1500184404-15001844267727269', 1, 0, '', NULL, NULL, NULL),
(38317, '2017-07-16 13:54:03', NULL, NULL, 11127, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:54:03', 'admin-1500184404-15001844430908452', 1, 1, 'SR', NULL, NULL, NULL),
(38318, '2017-07-16 13:54:03', NULL, NULL, 11127, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:54:03', 'admin-1500184404-15001844430908452', 1, 1, 'SR', NULL, NULL, NULL),
(38319, '2017-07-16 13:57:19', NULL, NULL, 11128, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:57:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38320, '2017-07-16 13:57:25', NULL, NULL, 11128, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:57:25', 'admin-1500184404-15001846448888834', 1, 0, '', NULL, NULL, NULL),
(38321, '2017-07-16 17:21:38', NULL, NULL, 11140, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 17:21:38', 'admin-1500189795-15001968984002511', 1, 1, 'SR', NULL, NULL, NULL),
(38322, '2017-07-16 16:56:27', NULL, NULL, 11137, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 16:56:27', 'admin-1500189795-15001953871136493', 1, 0, '', NULL, NULL, NULL),
(38323, '2017-07-16 13:39:44', NULL, NULL, 11124, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:39:44', 'admin-1500181895-15001835842133398', 1, 1, 'SR', NULL, NULL, '10.0'),
(38324, '2017-07-16 13:39:44', NULL, NULL, 11124, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:39:44', 'admin-1500181895-15001835842133398', 1, 0, '', NULL, NULL, '10.0'),
(38325, '2017-07-16 13:39:44', NULL, NULL, 11124, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:39:44', 'admin-1500181895-15001835842133398', 1, 0, '', NULL, NULL, '10.0'),
(38326, '2017-07-16 13:39:56', NULL, NULL, 11124, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:39:56', 'admin-1500181895-15001835963645258', 1, 1, 'SR', NULL, NULL, '10.0'),
(38327, '2017-07-16 13:39:56', NULL, NULL, 11124, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:39:56', 'admin-1500181895-15001835963645258', 1, 1, 'SR', NULL, NULL, '10.0'),
(38328, '2017-07-16 16:14:35', NULL, NULL, 11136, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 16:14:35', 'admin-1500189795-15001928756162310', 1, 1, 'SR', NULL, NULL, NULL),
(38329, '2017-07-16 16:52:16', NULL, NULL, 11138, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 16:52:16', 'admin-1500189795-1500195136644702', 1, 0, '', 1, NULL, '10.0'),
(38330, '2017-07-16 12:53:33', NULL, NULL, 11119, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.70, 0.0000, 0.0000, 9.70, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:53:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38331, '2017-07-16 12:53:57', NULL, NULL, 11119, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:53:57', 'admin-1500179863-15001808377601595', 1, 1, 'SR', NULL, NULL, NULL),
(38332, '2017-07-16 11:45:00', NULL, NULL, 11106, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:45:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38333, '2017-07-16 16:09:30', NULL, NULL, 11137, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 16:09:30', 'admin-1500189795-15001925698646822', 1, 0, '', NULL, NULL, NULL),
(38334, '2017-07-16 16:09:24', NULL, NULL, 11137, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1500189795', 'admin', '2017-07-16 16:09:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38335, '2017-07-16 16:09:30', NULL, NULL, 11137, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 16:09:30', 'admin-1500189795-15001925698646822', 1, 0, '', NULL, NULL, NULL),
(38336, '2017-07-16 15:40:26', NULL, NULL, 11136, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 15:40:26', 'admin-1500189795-15001908262785733', 1, 0, '', NULL, NULL, NULL),
(38337, '2017-07-16 15:40:26', NULL, NULL, 11136, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 15:40:26', 'admin-1500189795-15001908262785733', 1, 1, 'SR', NULL, NULL, NULL),
(38338, '2017-07-16 15:23:24', NULL, NULL, 11135, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 15:23:24', 'admin-1500189795-15001898038923422', 1, 1, 'SR', NULL, NULL, NULL),
(38339, '2017-07-16 15:23:03', NULL, NULL, 11135, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1500189795', 'admin', '2017-07-16 15:23:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38340, '2017-07-16 15:23:11', NULL, NULL, 11135, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 15:23:11', 'admin-1500184404-15001897911275591', 1, 0, '', NULL, NULL, NULL),
(38341, '2017-07-16 15:01:08', NULL, NULL, 11132, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 15:01:08', 'admin-1500184404-15001884683149656', 1, 1, 'SR', 1, NULL, '10.0'),
(38342, '2017-07-16 15:22:46', NULL, NULL, 11131, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 15:22:46', 'admin-1500184404-15001897661795959', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(38343, '2017-07-16 15:22:46', NULL, NULL, 11131, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 15:22:46', 'admin-1500184404-15001897661795959', 1, 0, '', NULL, NULL, NULL),
(38344, '2017-07-16 14:59:36', NULL, NULL, 11131, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 14:59:36', 'admin-1500184404-15001883761631886', 1, 0, '', NULL, NULL, NULL),
(38345, '2017-07-16 13:39:44', NULL, NULL, 11124, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:39:44', 'admin-1500181895-15001835842133398', 1, 1, 'SR', NULL, NULL, '10.0'),
(38346, '2017-07-16 13:03:36', NULL, NULL, 11118, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:03:36', 'admin-1500179863-1500181416123757', 1, 0, '', NULL, NULL, NULL),
(38347, '2017-07-16 13:04:29', NULL, NULL, 11120, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:04:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38348, '2017-07-16 13:02:44', NULL, NULL, 11116, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:02:44', 'admin-1500179863-15001813645838288', 1, 1, 'SR', NULL, NULL, NULL),
(38349, '2017-07-16 12:40:39', NULL, NULL, 11112, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:40:39', 'admin-1500179863-1500180038834297', 1, 1, 'SR', NULL, NULL, NULL),
(38350, '2017-07-16 15:22:56', NULL, NULL, 11131, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 15:22:56', 'admin-1500184404-15001897764357027', 1, 1, 'SR', NULL, NULL, NULL),
(38351, '2017-07-16 15:22:46', NULL, NULL, 11131, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 15:22:46', 'admin-1500184404-15001897661795959', 1, 0, '', NULL, NULL, NULL),
(38352, '2017-07-16 15:02:43', NULL, NULL, 11134, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1500189795', 'admin', '2017-07-16 15:02:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38353, '2017-07-16 14:12:55', NULL, NULL, 11129, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 14:12:55', 'admin-1500184404-15001855756666089', 1, 0, '', NULL, NULL, NULL),
(38354, '2017-07-16 13:39:44', NULL, NULL, 11124, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:39:44', 'admin-1500181895-15001835842133398', 1, 1, 'SR', NULL, NULL, '10.0'),
(38355, '2017-07-16 13:39:44', NULL, NULL, 11124, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:39:44', 'admin-1500181895-15001835842133398', 1, 1, 'SR', NULL, NULL, '10.0'),
(38356, '2017-07-16 13:39:28', NULL, NULL, 11124, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.80, 0.0000, 0.0000, 12.80, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:39:28', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(38357, '2017-07-16 12:40:39', NULL, NULL, 11112, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:40:39', 'admin-1500179863-1500180038834297', 1, 0, '', NULL, NULL, NULL),
(38358, '2017-07-16 12:40:39', NULL, NULL, 11112, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:40:39', 'admin-1500179863-1500180038834297', 1, 0, '', NULL, NULL, NULL),
(38359, '2017-07-16 12:19:50', NULL, NULL, 11111, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:19:50', 'admin-1500177418-1500178790178590', 1, 1, 'SR', NULL, NULL, NULL),
(38360, '2017-07-16 14:24:53', NULL, NULL, 11130, 0, 73, '73', 'Marmite Chicken ', 'With mashed potato', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 14:24:53', 'admin-1500184404-1500186292887625', 1, 1, 'SR', NULL, NULL, '10.0'),
(38361, '2017-07-16 13:02:44', NULL, NULL, 11116, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:02:44', 'admin-1500179863-15001813645838288', 1, 1, 'SR', NULL, NULL, NULL),
(38362, '2017-07-16 11:56:50', NULL, NULL, 11108, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:56:50', 'admin-1500172442-15001774107817710', 1, 0, '', NULL, NULL, NULL),
(38363, '2017-07-16 11:56:50', NULL, NULL, 11108, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:56:50', 'admin-1500172442-15001774107817710', 1, 0, '', NULL, NULL, NULL),
(38364, '2017-07-16 11:57:07', NULL, NULL, 11106, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:57:07', 'admin-1500177418-1500177427262996', 1, 0, '', NULL, NULL, NULL),
(38365, '2017-07-16 11:57:44', NULL, NULL, 11108, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:57:44', 'admin-1500177418-15001774646211986', 1, 1, 'SR', NULL, NULL, NULL),
(38366, '2017-07-16 11:31:42', NULL, NULL, 11105, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:31:42', 'admin-1500172442-15001759019566384', 1, 1, 'SR', NULL, NULL, NULL),
(38367, '2017-07-16 15:01:46', NULL, NULL, 11133, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 15:01:46', 'admin-1500184404-1500188505924109', 1, 1, 'SR', NULL, NULL, NULL),
(38368, '2017-07-16 15:01:37', NULL, NULL, 11133, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1500189795', 'admin', '2017-07-16 15:01:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38369, '2017-07-16 15:01:46', NULL, NULL, 11133, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 15:01:46', 'admin-1500184404-1500188505924109', 1, 1, 'SR', NULL, NULL, NULL),
(38370, '2017-07-16 10:09:11', NULL, NULL, 11093, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:09:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38371, '2017-07-16 10:09:27', NULL, NULL, 11093, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:09:27', 'admin-1500169344-1500170967512976', 1, 0, '', NULL, NULL, NULL),
(38372, '2017-07-16 13:31:52', NULL, NULL, 11123, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:31:52', 'admin-1500181895-15001831123465679', 1, 0, '', NULL, NULL, '10.0'),
(38373, '2017-07-16 13:31:52', NULL, NULL, 11123, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:31:52', 'admin-1500181895-15001831123465679', 1, 1, 'SR', NULL, NULL, '10.0'),
(38374, '2017-07-16 13:02:20', NULL, NULL, 11119, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:02:20', 'admin-1500179863-1500181340347174', 1, 0, '', NULL, NULL, NULL),
(38375, '2017-07-16 13:02:20', NULL, NULL, 11119, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:02:20', 'admin-1500179863-1500181340347174', 1, 1, 'SR', NULL, NULL, NULL),
(38376, '2017-07-16 14:24:40', NULL, NULL, 11130, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1500189795', 'admin', '2017-07-16 14:24:40', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(38377, '2017-07-16 14:12:47', NULL, NULL, 11129, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1500189795', 'admin', '2017-07-16 14:12:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38378, '2017-07-16 12:53:57', NULL, NULL, 11119, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:53:57', 'admin-1500179863-15001808377601595', 1, 1, 'SR', NULL, NULL, NULL),
(38379, '2017-07-16 12:53:58', NULL, NULL, 11119, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:53:58', 'admin-1500179863-15001808377601595', 1, 0, '', NULL, NULL, NULL),
(38380, '2017-07-16 12:55:20', NULL, NULL, 11115, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:55:20', 'admin-1500179863-15001809207504094', 1, 1, 'SR', NULL, NULL, NULL),
(38381, '2017-07-16 12:55:20', NULL, NULL, 11115, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:55:20', 'admin-1500179863-15001809207504094', 1, 1, 'SR', NULL, NULL, NULL),
(38382, '2017-07-16 12:57:00', NULL, NULL, 11119, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:57:00', 'admin-1500179863-1500181019952341', 1, 0, '', NULL, NULL, NULL),
(38383, '2017-07-16 12:37:36', NULL, NULL, 11117, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:37:36', 'admin-1500177418-1500179856432518', 1, 1, 'SR', NULL, NULL, NULL),
(38384, '2017-07-16 12:35:48', NULL, NULL, 11117, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:35:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38385, '2017-07-16 12:34:34', NULL, NULL, 11116, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:34:34', 'admin-1500177418-15001796738679128', 1, 0, '', NULL, NULL, NULL),
(38386, '2017-07-16 12:34:34', NULL, NULL, 11116, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:34:34', 'admin-1500177418-15001796738679128', 1, 0, '', NULL, NULL, NULL),
(38387, '2017-07-16 12:34:23', NULL, NULL, 11116, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:34:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38388, '2017-07-16 12:32:33', NULL, NULL, 11112, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:32:33', 'admin-1500177418-1500179553083872', 1, 0, '', NULL, NULL, NULL),
(38389, '2017-07-16 12:32:33', NULL, NULL, 11112, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:32:33', 'admin-1500177418-1500179553083872', 1, 0, '', NULL, NULL, NULL),
(38390, '2017-07-16 12:24:55', NULL, NULL, 11115, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:24:55', 'admin-1500177418-15001790950961695', 1, 1, 'SR', NULL, NULL, NULL),
(38391, '2017-07-16 12:24:55', NULL, NULL, 11115, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:24:55', 'admin-1500177418-15001790950961695', 1, 0, '', NULL, NULL, NULL),
(38392, '2017-07-16 13:50:45', NULL, NULL, 11126, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:50:45', 'admin-1500181895-15001842453366729', 1, 0, '', NULL, NULL, NULL),
(38393, '2017-07-16 13:31:05', NULL, NULL, 11123, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:31:05', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(38394, '2017-07-16 13:31:52', NULL, NULL, 11123, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:31:52', 'admin-1500181895-15001831123465679', 1, 0, '', NULL, NULL, '10.0'),
(38395, '2017-07-16 13:31:52', NULL, NULL, 11123, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:31:52', 'admin-1500181895-15001831123465679', 1, 1, 'SR', NULL, NULL, '10.0'),
(38396, '2017-07-16 14:12:55', NULL, NULL, 11129, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 14:12:55', 'admin-1500184404-15001855756666089', 1, 1, 'SR', NULL, NULL, NULL),
(38397, '2017-07-16 13:27:38', NULL, NULL, 11094, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:27:38', 'admin-1500181895-1500182857760188', 1, 0, '', NULL, NULL, NULL),
(38398, '2017-07-16 13:26:46', NULL, NULL, 11122, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:26:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38399, '2017-07-16 13:27:38', NULL, NULL, 11094, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:27:38', 'admin-1500181895-1500182857760188', 1, 0, '', NULL, NULL, NULL),
(38400, '2017-07-16 13:26:50', NULL, NULL, 11122, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:26:50', 'admin-1500181895-15001828107513569', 1, 1, 'SR', NULL, NULL, NULL),
(38401, '2017-07-16 00:00:00', NULL, NULL, 11114, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:11:22', 'admin-1500172442-15001746822596538', 1, 0, '', NULL, NULL, NULL),
(38402, '2017-07-16 13:33:00', NULL, NULL, 11122, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:33:00', 'admin-1500181895-15001831802921221', 1, 0, '', NULL, NULL, NULL),
(38403, '2017-07-16 13:01:30', NULL, NULL, 11118, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:01:30', 'admin-1500179863-15001812898643262', 1, 1, 'SR', NULL, NULL, NULL),
(38404, '2017-07-16 12:19:50', NULL, NULL, 11111, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:19:50', 'admin-1500177418-1500178790178590', 1, 0, '', NULL, NULL, NULL),
(38405, '2017-07-16 12:19:50', NULL, NULL, 11111, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:19:50', 'admin-1500177418-1500178790178590', 1, 1, 'SR', NULL, NULL, NULL),
(38406, '2017-07-16 12:19:50', NULL, NULL, 11111, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:19:50', 'admin-1500177418-1500178790178590', 1, 0, '', NULL, NULL, NULL),
(38407, '2017-07-16 12:20:43', NULL, NULL, 11113, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:20:43', 'admin-1500177418-15001788437362096', 1, 0, '', NULL, NULL, '10.0'),
(38408, '2017-07-16 12:20:37', NULL, NULL, 11113, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:20:37', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(38409, '2017-07-16 12:19:13', NULL, NULL, 11111, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:19:13', 'admin-1500177418-15001787527833530', 1, 0, '', NULL, NULL, NULL),
(38410, '2017-07-16 12:19:13', NULL, NULL, 11111, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:19:13', 'admin-1500177418-15001787527833530', 1, 0, '', NULL, NULL, NULL),
(38411, '2017-07-16 09:52:54', NULL, NULL, 11090, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:52:54', 'admin-1500169344-15001699741236258', 1, 0, '', NULL, NULL, NULL),
(38412, '2017-07-16 10:32:01', NULL, NULL, 11095, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:32:01', 'admin-1500169344-15001723212726376', 1, 0, '', NULL, NULL, '10.0'),
(38413, '2017-07-16 13:50:45', NULL, NULL, 11126, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:50:45', 'admin-1500181895-15001842453366729', 1, 0, '', NULL, NULL, NULL),
(38414, '2017-07-16 11:06:35', NULL, NULL, 11099, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:06:35', 'admin-1500172442-15001743952694188', 1, 0, '', NULL, NULL, NULL),
(38415, '2017-07-16 11:10:53', NULL, NULL, 11100, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:10:53', 'admin-1500172442-15001746528473044', 1, 0, '', NULL, NULL, NULL),
(38416, '2017-07-16 12:19:13', NULL, NULL, 11111, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:19:13', 'admin-1500177418-15001787527833530', 1, 0, '', NULL, NULL, NULL),
(38417, '2017-07-16 12:19:13', NULL, NULL, 11111, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:19:13', 'admin-1500177418-15001787527833530', 1, 0, '', NULL, NULL, NULL),
(38418, '2017-07-16 12:17:50', NULL, NULL, 11111, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 17.50, 0.0000, 0.0000, 17.50, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:17:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38419, '2017-07-16 12:10:55', NULL, NULL, 11110, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:10:55', 'admin-1500177418-15001782557371675', 1, 1, 'SR', NULL, NULL, NULL),
(38420, '2017-07-16 12:51:24', NULL, NULL, 11118, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:51:24', 'admin-1500179863-1500180683803892', 1, 1, 'SR', NULL, NULL, NULL),
(38421, '2017-07-16 12:10:49', NULL, NULL, 11110, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:10:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38422, '2017-07-16 11:26:35', NULL, NULL, 11105, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:26:35', 'admin-1500172442-15001755953713722', 1, 0, '', NULL, NULL, NULL),
(38423, '2017-07-16 09:52:21', NULL, NULL, 11089, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:52:21', 'admin-1500169344-1500169940897978', 1, 0, '', NULL, NULL, NULL),
(38424, '2017-07-16 09:52:21', NULL, NULL, 11089, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:52:21', 'admin-1500169344-1500169940897978', 1, 1, 'SR', NULL, NULL, NULL),
(38425, '2017-07-16 10:21:31', NULL, NULL, 11094, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:21:31', 'admin-1500169344-15001716908657699', 1, 1, 'SR', NULL, NULL, NULL),
(38426, '2017-07-16 10:32:01', NULL, NULL, 11095, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:32:01', 'admin-1500169344-15001723212726376', 1, 0, '', NULL, NULL, '10.0'),
(38427, '2017-07-16 10:33:01', NULL, NULL, 11096, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:33:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38428, '2017-07-16 10:33:36', NULL, NULL, 11096, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:33:36', 'admin-1500169344-1500172416612123', 1, 0, '', NULL, NULL, NULL),
(38429, '2017-07-16 12:00:23', NULL, NULL, 11109, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:00:23', 'admin-1500177418-1500177622856119', 1, 1, 'SR', NULL, NULL, NULL),
(38430, '2017-07-16 13:02:20', NULL, NULL, 11119, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:02:20', 'admin-1500179863-1500181340347174', 1, 0, '', NULL, NULL, NULL),
(38431, '2017-07-16 12:37:36', NULL, NULL, 11117, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:37:36', 'admin-1500177418-1500179856432518', 1, 0, '', NULL, NULL, NULL),
(38432, '2017-07-16 12:00:12', NULL, NULL, 11109, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:00:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38433, '2017-07-16 12:24:27', NULL, NULL, 11115, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:24:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38434, '2017-07-16 12:20:05', NULL, NULL, 11112, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:20:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38435, '2017-07-16 11:59:21', NULL, NULL, 11100, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:59:21', 'admin-1500177418-15001775614483737', 1, 1, 'SR', NULL, NULL, NULL),
(38436, '2017-07-16 11:56:20', NULL, NULL, 11108, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:56:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38437, '2017-07-16 11:55:45', NULL, NULL, 11106, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:55:45', 'admin-1500172442-15001773453487086', 1, 1, 'SR', NULL, NULL, NULL),
(38438, '2017-07-16 11:55:45', NULL, NULL, 11106, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:55:45', 'admin-1500172442-15001773453487086', 1, 1, 'SR', NULL, NULL, NULL),
(38439, '2017-07-16 11:55:14', NULL, NULL, 11106, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:55:14', 'admin-1500172442-15001773139499715', 1, 0, '', NULL, NULL, NULL),
(38440, '2017-07-16 11:55:14', NULL, NULL, 11106, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:55:14', 'admin-1500172442-15001773139499715', 1, 1, 'SR', NULL, NULL, NULL),
(38441, '2017-07-16 12:19:13', NULL, NULL, 11111, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:19:13', 'admin-1500177418-15001787527833530', 1, 0, '', NULL, NULL, NULL),
(38442, '2017-07-16 11:49:16', NULL, NULL, 11107, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:49:16', 'admin-1500172442-15001769562002020', 1, 1, 'SR', NULL, NULL, NULL),
(38443, '2017-07-16 11:49:16', NULL, NULL, 11107, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:49:16', 'admin-1500172442-15001769562002020', 1, 0, '', NULL, NULL, NULL),
(38444, '2017-07-16 10:39:43', NULL, NULL, 11098, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:39:43', 'admin-1500172442-15001727831108497', 1, 0, '', NULL, NULL, NULL),
(38445, '2017-07-16 10:39:43', NULL, NULL, 11098, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:39:43', 'admin-1500172442-15001727831108497', 1, 0, '', NULL, NULL, NULL),
(38446, '2017-07-16 15:22:56', NULL, NULL, 11131, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 15:22:56', 'admin-1500184404-15001897764357027', 1, 1, 'SR', NULL, NULL, NULL),
(38447, '2017-07-16 11:45:05', NULL, NULL, 11106, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:45:05', 'admin-1500172442-1500176705098534', 1, 0, '', NULL, NULL, NULL),
(38448, '2017-07-16 09:52:00', NULL, NULL, 11089, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:52:00', 'admin-1500169344-15001699199864256', 1, 0, '', NULL, NULL, NULL),
(38449, '2017-07-16 09:52:21', NULL, NULL, 11089, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:52:21', 'admin-1500169344-1500169940897978', 1, 1, 'SR', NULL, NULL, NULL),
(38450, '2017-07-16 11:20:46', NULL, NULL, 11103, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:20:46', 'admin-1500172442-15001752464222450', 1, 1, 'SR', NULL, NULL, NULL),
(38451, '2017-07-16 11:21:50', NULL, NULL, 11103, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:21:50', 'admin-1500172442-15001753108131316', 1, 0, '', NULL, NULL, NULL),
(38452, '2017-07-16 11:26:02', NULL, NULL, 11104, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:26:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38453, '2017-07-16 11:26:15', NULL, NULL, 11104, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:26:15', 'admin-1500172442-15001755754521024', 1, 1, 'SR', NULL, NULL, NULL),
(38454, '2017-07-16 11:26:15', NULL, NULL, 11104, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:26:15', 'admin-1500172442-15001755754521024', 1, 0, '', NULL, NULL, NULL),
(38455, '2017-07-16 11:26:35', NULL, NULL, 11105, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:26:35', 'admin-1500172442-15001755953713722', 1, 0, '', NULL, NULL, NULL),
(38456, '2017-07-16 11:26:24', NULL, NULL, 11105, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:26:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38457, '2017-07-16 10:36:23', NULL, NULL, 11097, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:36:23', 'admin-1500172442-15001725827332890', 1, 1, 'SR', NULL, NULL, NULL),
(38458, '2017-07-16 11:26:35', NULL, NULL, 11105, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:26:35', 'admin-1500172442-15001755953713722', 1, 1, 'SR', NULL, NULL, NULL),
(38459, '2017-07-16 15:02:50', NULL, NULL, 11134, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 15:02:50', 'admin-1500184404-15001885705603814', 1, 1, 'SR', NULL, NULL, NULL),
(38460, '2017-07-16 12:22:14', NULL, NULL, 11114, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:22:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38461, '2017-07-16 00:00:00', NULL, NULL, 11114, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:03:20', 'admin-1500172442-15001742006125984', 1, 1, 'SR', NULL, NULL, NULL),
(38462, '2017-07-16 00:00:00', NULL, NULL, 11114, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:11:22', 'admin-1500172442-15001746822596538', 1, 0, '', NULL, NULL, NULL),
(38463, '2017-07-16 11:20:46', NULL, NULL, 11103, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:20:46', 'admin-1500172442-15001752464222450', 1, 0, '', NULL, NULL, NULL),
(38464, '2017-07-16 11:20:46', NULL, NULL, 11103, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:20:46', 'admin-1500172442-15001752464222450', 1, 0, '', NULL, NULL, NULL),
(38465, '2017-07-16 11:20:08', NULL, NULL, 11103, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:20:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38466, '2017-07-16 11:18:13', NULL, NULL, 11102, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:18:13', 'admin-1500172442-15001750930258660', 1, 1, 'SR', 1, NULL, NULL),
(38467, '2017-07-16 10:38:09', NULL, NULL, 11092, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:38:09', 'admin-1500172442-15001726892157669', 1, 1, 'SR', NULL, NULL, NULL),
(38468, '2017-07-16 10:39:12', NULL, NULL, 11098, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.50, 0.0000, 0.0000, 9.50, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:39:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38469, '2017-07-16 10:39:43', NULL, NULL, 11098, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:39:43', 'admin-1500172442-15001727831108497', 1, 0, '', NULL, NULL, NULL),
(38470, '2017-07-16 10:39:43', NULL, NULL, 11098, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:39:43', 'admin-1500172442-15001727831108497', 1, 0, '', NULL, NULL, NULL),
(38471, '2017-07-16 12:19:50', NULL, NULL, 11111, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:19:50', 'admin-1500177418-1500178790178590', 1, 1, 'SR', NULL, NULL, NULL),
(38472, '2017-07-16 11:18:13', NULL, NULL, 11102, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:18:13', 'admin-1500172442-15001750930258660', 1, 1, 'SR', 1, NULL, NULL),
(38473, '2017-07-16 11:10:53', NULL, NULL, 11100, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:10:53', 'admin-1500172442-15001746528473044', 1, 1, 'SR', NULL, NULL, NULL),
(38474, '2017-07-16 12:51:14', NULL, NULL, 11118, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:51:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38475, '2017-07-16 10:06:36', NULL, NULL, 11085, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:06:36', 'admin-1500169344-15001707967563655', 1, 0, '', NULL, NULL, NULL),
(38476, '2017-07-16 09:27:10', NULL, NULL, 11085, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:27:10', 'admin-1500165095-15001684301943736', 1, 0, '', NULL, NULL, NULL),
(38477, '2017-07-16 09:27:10', NULL, NULL, 11085, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:27:10', 'admin-1500165095-15001684301943736', 1, 0, '', NULL, NULL, NULL),
(38478, '2017-07-16 09:27:10', NULL, NULL, 11085, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', 'Takeaway', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:27:10', 'admin-1500165095-15001684301943736', 1, 0, '', NULL, NULL, NULL),
(38479, '2017-07-16 09:29:04', NULL, NULL, 11086, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:29:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38480, '2017-07-16 09:06:56', NULL, NULL, 11083, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:06:56', 'admin-1500165095-15001672160319568', 1, 0, '', NULL, NULL, NULL),
(38481, '2017-07-16 09:06:56', NULL, NULL, 11083, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:06:56', 'admin-1500165095-15001672160319568', 1, 0, '', NULL, NULL, NULL),
(38482, '2017-07-16 09:08:50', NULL, NULL, 11083, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:08:50', 'admin-1500165095-1500167330214237', 1, 0, '', NULL, NULL, NULL),
(38483, '2017-07-16 11:10:35', NULL, NULL, 11100, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:10:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38484, '2017-07-16 11:10:53', NULL, NULL, 11100, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:10:53', 'admin-1500172442-15001746528473044', 1, 0, '', NULL, NULL, NULL),
(38485, '2017-07-16 10:43:57', NULL, NULL, 11087, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:43:57', 'admin-1500172442-15001730374159816', 1, 1, 'SR', NULL, NULL, NULL),
(38486, '2017-07-16 10:44:07', NULL, NULL, 11087, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:44:07', 'admin-1500172442-15001730477416997', 1, 0, '', NULL, NULL, NULL),
(38487, '2017-07-16 10:36:23', NULL, NULL, 11097, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:36:23', 'admin-1500172442-15001725827332890', 1, 1, 'SR', NULL, NULL, NULL),
(38488, '2017-07-16 10:36:23', NULL, NULL, 11097, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:36:23', 'admin-1500172442-15001725827332890', 1, 1, 'SR', NULL, NULL, NULL),
(38489, '2017-07-16 09:25:35', NULL, NULL, 11084, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:25:35', 'admin-1500165095-15001683351877516', 1, 1, 'SR', NULL, NULL, NULL),
(38490, '2017-07-16 09:25:35', NULL, NULL, 11084, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:25:35', 'admin-1500165095-15001683351877516', 1, 1, 'SR', NULL, NULL, NULL),
(38491, '2017-07-16 09:26:32', NULL, NULL, 11085, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:26:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38492, '2017-07-16 12:19:13', NULL, NULL, 11111, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:19:13', 'admin-1500177418-15001787527833530', 1, 0, '', NULL, NULL, NULL),
(38493, '2017-07-16 11:06:35', NULL, NULL, 11099, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:06:35', 'admin-1500172442-15001743952694188', 1, 0, '', NULL, NULL, NULL),
(38494, '2017-07-16 11:06:30', NULL, NULL, 11099, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:06:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38495, '2017-07-16 11:03:47', NULL, NULL, 11093, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:03:47', 'admin-1500172442-15001742273128842', 1, 0, '', NULL, NULL, NULL),
(38496, '2017-07-16 00:00:00', NULL, NULL, 11114, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:11:22', 'admin-1500172442-15001746822596538', 1, 1, 'SR', NULL, NULL, NULL),
(38497, '2017-07-16 10:57:01', NULL, NULL, 11094, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:57:01', 'admin-1500172442-15001738217324438', 1, 0, '', NULL, NULL, NULL),
(38498, '2017-07-16 10:39:43', NULL, NULL, 11098, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:39:43', 'admin-1500172442-15001727831108497', 1, 1, 'SR', NULL, NULL, NULL),
(38499, '2017-07-16 10:39:43', NULL, NULL, 11098, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:39:43', 'admin-1500172442-15001727831108497', 1, 0, '', NULL, NULL, NULL),
(38500, '2017-07-16 10:31:57', NULL, NULL, 11095, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:31:57', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(38501, '2017-07-16 09:52:54', NULL, NULL, 11090, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:52:54', 'admin-1500169344-15001699741236258', 1, 1, 'SR', NULL, NULL, NULL),
(38502, '2017-07-16 09:52:54', NULL, NULL, 11090, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:52:54', 'admin-1500169344-15001699741236258', 1, 0, '', NULL, NULL, NULL),
(38503, '2017-07-16 10:01:08', NULL, NULL, 11091, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:01:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38504, '2017-07-16 10:01:26', NULL, NULL, 11091, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:01:26', 'admin-1500169344-15001704860933330', 1, 0, '', NULL, NULL, NULL),
(38505, '2017-07-16 10:01:26', NULL, NULL, 11091, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:01:26', 'admin-1500169344-15001704860933330', 1, 0, '', NULL, NULL, NULL),
(38506, '2017-07-16 10:01:26', NULL, NULL, 11091, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:01:26', 'admin-1500169344-15001704860933330', 1, 0, '', NULL, NULL, NULL),
(38507, '2017-07-16 10:02:00', NULL, NULL, 11087, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:02:00', 'admin-1500169344-15001705203093255', 1, 0, '', NULL, NULL, NULL),
(38508, '2017-07-16 09:29:22', NULL, NULL, 11086, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:29:22', 'admin-1500165095-15001685621242229', 1, 0, '', NULL, NULL, NULL),
(38509, '2017-07-16 09:29:22', NULL, NULL, 11086, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:29:22', 'admin-1500165095-15001685621242229', 1, 0, '', NULL, NULL, NULL),
(38510, '2017-07-16 09:29:22', NULL, NULL, 11086, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:29:22', 'admin-1500165095-15001685621242229', 1, 1, 'SR', NULL, NULL, NULL),
(38511, '2017-07-16 09:29:22', NULL, NULL, 11086, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:29:22', 'admin-1500165095-15001685621242229', 1, 1, 'SR', NULL, NULL, NULL),
(38512, '2017-07-16 09:29:22', NULL, NULL, 11086, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:29:22', 'admin-1500165095-15001685621242229', 1, 1, 'SR', NULL, NULL, NULL),
(38513, '2017-07-16 09:42:12', NULL, NULL, 11087, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:42:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38514, '2017-07-16 09:42:19', NULL, NULL, 11087, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:42:19', 'admin-1500165095-15001693391309184', 1, 0, '', NULL, NULL, NULL),
(38515, '2017-07-16 09:42:19', NULL, NULL, 11087, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:42:19', 'admin-1500165095-15001693391309184', 1, 1, 'SR', NULL, NULL, NULL),
(38516, '2017-07-16 09:08:50', NULL, NULL, 11083, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:08:50', 'admin-1500165095-1500167330214237', 1, 0, '', NULL, NULL, NULL),
(38517, '2017-07-16 09:25:15', NULL, NULL, 11084, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:25:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38518, '2017-07-16 09:25:30', NULL, NULL, 11084, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:25:30', 'admin-1500165095-15001683303908082', 1, 0, '', NULL, NULL, NULL),
(38519, '2017-07-16 09:25:30', NULL, NULL, 11084, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:25:30', 'admin-1500165095-15001683303908082', 1, 0, '', NULL, NULL, NULL),
(38520, '2017-07-16 10:33:36', NULL, NULL, 11096, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:33:36', 'admin-1500169344-1500172416612123', 1, 1, 'SR', NULL, NULL, NULL),
(38521, '2017-07-16 10:33:36', NULL, NULL, 11096, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:33:36', 'admin-1500169344-1500172416612123', 1, 0, '', NULL, NULL, NULL),
(38522, '2017-07-16 13:04:39', NULL, NULL, 11120, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 13:04:39', 'admin-1500179863-1500181479448328', 1, 0, '', NULL, NULL, NULL),
(38523, '2017-07-16 10:33:36', NULL, NULL, 11096, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:33:36', 'admin-1500169344-1500172416612123', 1, 0, '', NULL, NULL, NULL),
(38524, '2017-07-16 10:09:27', NULL, NULL, 11093, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:09:27', 'admin-1500169344-1500170967512976', 1, 0, '', NULL, NULL, NULL),
(38525, '2017-07-16 12:00:23', NULL, NULL, 11109, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 12:00:23', 'admin-1500177418-1500177622856119', 1, 0, '', NULL, NULL, NULL),
(38526, '2017-07-16 11:49:06', NULL, NULL, 11107, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:49:06', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(38527, '2017-07-16 10:21:22', NULL, NULL, 11094, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:21:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38528, '2017-07-16 10:09:35', NULL, NULL, 11093, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:09:35', 'admin-1500169344-15001709751646359', 1, 0, '', NULL, NULL, NULL),
(38529, '2017-07-16 10:08:58', NULL, NULL, 11092, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:08:58', 'admin-1500169344-15001709381587180', 1, 0, '', NULL, NULL, NULL),
(38530, '2017-07-16 10:08:58', NULL, NULL, 11092, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:08:58', 'admin-1500169344-15001709381587180', 1, 1, 'SR', NULL, NULL, NULL),
(38531, '2017-07-16 10:08:58', NULL, NULL, 11092, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:08:58', 'admin-1500169344-15001709381587180', 1, 0, '', NULL, NULL, NULL),
(38532, '2017-07-16 10:08:58', NULL, NULL, 11092, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:08:58', 'admin-1500169344-15001709381587180', 1, 0, '', NULL, NULL, NULL),
(38533, '2017-07-16 10:07:53', NULL, NULL, 11092, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1500189795', 'admin', '2017-07-16 10:07:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38534, '2017-07-16 09:52:47', NULL, NULL, 11090, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:52:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38535, '2017-07-16 11:49:16', NULL, NULL, 11107, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 11:49:16', 'admin-1500172442-15001769562002020', 1, 1, 'SR', NULL, NULL, NULL),
(38536, '2017-07-16 09:52:21', NULL, NULL, 11089, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:52:21', 'admin-1500169344-1500169940897978', 1, 1, 'SR', NULL, NULL, NULL),
(38537, '2017-07-16 09:52:00', NULL, NULL, 11089, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:52:00', 'admin-1500169344-15001699199864256', 1, 0, '', NULL, NULL, NULL),
(38538, '2017-07-16 09:52:00', NULL, NULL, 11089, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:52:00', 'admin-1500169344-15001699199864256', 1, 0, '', NULL, NULL, NULL),
(38539, '2017-07-16 09:46:10', NULL, NULL, 11089, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:46:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38540, '2017-07-16 09:43:31', NULL, NULL, 11088, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:43:31', 'admin-1500169344-15001694109585612', 1, 1, 'SR', NULL, NULL, NULL),
(38541, '2017-07-16 09:43:31', NULL, NULL, 11088, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:43:31', 'admin-1500169344-15001694109585612', 1, 1, 'SR', NULL, NULL, NULL),
(38542, '2017-07-16 09:43:27', NULL, NULL, 11088, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:43:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38543, '2017-07-16 09:29:22', NULL, NULL, 11086, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:29:22', 'admin-1500165095-15001685621242229', 1, 0, '', NULL, NULL, NULL),
(38544, '2017-07-16 09:25:30', NULL, NULL, 11084, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:25:30', 'admin-1500165095-15001683303908082', 1, 0, '', NULL, NULL, NULL),
(38545, '2017-07-16 09:52:00', NULL, NULL, 11089, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:52:00', 'admin-1500169344-15001699199864256', 1, 0, '', NULL, NULL, NULL),
(38546, '2017-07-16 09:05:53', NULL, NULL, 11082, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:05:53', 'admin-1500165095-15001671532951743', 1, 1, 'SR', NULL, NULL, NULL),
(38547, '2017-07-16 09:06:52', NULL, NULL, 11083, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:06:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38548, '2017-07-16 09:05:47', NULL, NULL, 11082, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:05:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38549, '2017-07-16 09:05:53', NULL, NULL, 11082, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500189795', 'admin', '2017-07-16 09:05:53', 'admin-1500165095-15001671532951743', 1, 0, '', NULL, NULL, NULL),
(38550, '2017-07-17 13:31:54', NULL, NULL, 11169, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:31:54', 'admin-1500265652-1500269514299777', 1, 0, '', NULL, NULL, NULL),
(38551, '2017-07-17 13:32:31', NULL, NULL, 11170, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:32:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38552, '2017-07-17 13:32:35', NULL, NULL, 11170, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:32:35', 'admin-1500265652-15002695553838252', 1, 0, '', NULL, NULL, NULL),
(38553, '2017-07-17 13:36:26', NULL, NULL, 11164, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:36:26', 'admin-1500265652-15002697864964282', 1, 0, '', NULL, NULL, NULL),
(38554, '2017-07-17 13:39:05', NULL, NULL, 11161, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:39:05', 'admin-1500265652-1500269944800691', 1, 0, '', NULL, NULL, NULL),
(38555, '2017-07-17 13:39:05', NULL, NULL, 11161, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:39:05', 'admin-1500265652-1500269944800691', 1, 1, 'SR', NULL, NULL, NULL),
(38556, '2017-07-17 13:40:39', NULL, NULL, 11168, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:40:39', 'admin-1500265652-15002700388299536', 1, 1, 'SR', NULL, NULL, NULL),
(38557, '2017-07-17 12:30:51', NULL, NULL, 11159, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 12:30:51', 'admin-1500265652-15002658517509745', 1, 1, 'SR', NULL, NULL, NULL),
(38558, '2017-07-17 13:31:27', NULL, NULL, 11168, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:31:27', 'admin-1500265652-15002694877425360', 1, 1, 'SR', NULL, NULL, NULL),
(38559, '2017-07-17 13:31:32', NULL, NULL, 11169, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:31:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38560, '2017-07-17 11:10:16', NULL, NULL, 11150, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:10:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38561, '2017-07-17 11:10:27', NULL, NULL, 11150, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:10:27', 'admin-1500252965-15002610278181278', 1, 0, '', NULL, NULL, NULL),
(38562, '2017-07-17 11:10:27', NULL, NULL, 11150, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:10:27', 'admin-1500252965-15002610278181278', 1, 1, 'SR', NULL, NULL, NULL),
(38563, '2017-07-17 11:12:52', NULL, NULL, 11151, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:12:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38564, '2017-07-17 15:15:16', NULL, NULL, 11169, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 15:15:16', 'admin-1500270044-15002757165288934', 1, 1, 'SR', NULL, NULL, NULL),
(38565, '2017-07-17 12:27:23', NULL, NULL, 11159, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1500270044', 'admin', '2017-07-17 12:27:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38566, '2017-07-17 12:27:27', NULL, NULL, 11159, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 12:27:27', 'admin-1500261032-15002656477509571', 1, 0, '', NULL, NULL, NULL),
(38567, '2017-07-17 12:27:42', NULL, NULL, 11159, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 12:27:42', 'admin-1500265652-15002656623461549', 1, 0, '', NULL, NULL, NULL),
(38568, '2017-07-17 12:40:54', NULL, NULL, 11161, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1500270044', 'admin', '2017-07-17 12:40:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38569, '2017-07-17 12:40:58', NULL, NULL, 11161, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 12:40:58', 'admin-1500265652-15002664582688241', 1, 0, '', NULL, NULL, NULL),
(38570, '2017-07-17 12:42:52', NULL, NULL, 11157, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 12:42:52', 'admin-1500265652-15002665727548252', 1, 1, 'SR', NULL, NULL, NULL),
(38571, '2017-07-17 12:53:39', NULL, NULL, 11162, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1500270044', 'admin', '2017-07-17 12:53:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38572, '2017-07-17 12:54:01', NULL, NULL, 11162, 0, 181, '116', 'Open Food ', 'You guys are special', 'Meals', 'Perfect Meals', 2, 10.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 12:54:01', 'admin-1500265652-15002672410194184', 1, 0, '', NULL, NULL, NULL),
(38573, '2017-07-17 16:03:24', NULL, NULL, 11174, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1500270044', 'admin', '2017-07-17 16:03:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38574, '2017-07-17 13:02:50', NULL, NULL, 11164, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.60, 0.0000, 0.0000, 10.60, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:02:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38575, '2017-07-17 13:02:55', NULL, NULL, 11164, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:02:55', 'admin-1500265652-15002677750489671', 1, 1, 'SR', NULL, NULL, NULL),
(38576, '2017-07-17 13:06:28', NULL, NULL, 11162, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:06:28', 'admin-1500265652-15002679884249176', 1, 1, 'SR', NULL, NULL, NULL),
(38577, '2017-07-17 13:19:47', NULL, NULL, 11164, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:19:47', 'admin-1500265652-15002687867393444', 1, 1, 'SR', NULL, NULL, NULL),
(38578, '2017-07-17 13:19:47', NULL, NULL, 11164, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:19:47', 'admin-1500265652-15002687867393444', 1, 1, 'SR', NULL, NULL, NULL),
(38579, '2017-07-17 13:19:47', NULL, NULL, 11164, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:19:47', 'admin-1500265652-15002687867393444', 1, 1, 'SR', NULL, NULL, NULL),
(38580, '2017-07-17 13:24:58', NULL, NULL, 11164, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:24:58', 'admin-1500265652-15002690984879734', 1, 0, '', NULL, NULL, NULL),
(38581, '2017-07-17 13:25:53', NULL, NULL, 11165, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:25:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38582, '2017-07-17 14:01:19', NULL, NULL, 11172, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 14:01:19', 'admin-1500270044-15002712794341514', 1, 1, 'SR', NULL, NULL, NULL),
(38583, '2017-07-17 16:03:29', NULL, NULL, 11174, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 16:03:29', 'admin-1500270044-1500278609435139', 1, 1, 'SR', NULL, NULL, NULL),
(38584, '2017-07-17 13:25:56', NULL, NULL, 11165, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:25:56', 'admin-1500265652-15002691563638067', 1, 0, '', NULL, NULL, NULL),
(38585, '2017-07-17 10:49:10', NULL, NULL, 11145, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 10:49:10', 'admin-1500252965-15002597499365648', 1, 1, 'SR', NULL, NULL, NULL),
(38586, '2017-07-17 11:33:21', NULL, NULL, 11152, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:33:21', 'admin-1500261032-15002624008885862', 1, 0, '', 1, NULL, NULL),
(38587, '2017-07-17 11:33:21', NULL, NULL, 11152, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:33:21', 'admin-1500261032-15002624008885862', 1, 1, 'SR', 1, NULL, NULL),
(38588, '2017-07-17 11:41:52', NULL, NULL, 11153, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:41:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38589, '2017-07-17 13:28:16', NULL, NULL, 11167, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:28:16', 'admin-1500265652-15002692960826999', 1, 1, 'SR', NULL, NULL, NULL),
(38590, '2017-07-17 16:03:29', NULL, NULL, 11174, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 16:03:29', 'admin-1500270044-1500278609435139', 1, 1, 'SR', NULL, NULL, NULL),
(38591, '2017-07-17 11:02:27', NULL, NULL, 11148, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:02:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38592, '2017-07-17 11:02:31', NULL, NULL, 11148, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:02:31', 'admin-1500252965-15002605508549812', 1, 1, 'SR', NULL, NULL, NULL),
(38593, '2017-07-17 11:07:58', NULL, NULL, 11149, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:07:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38594, '2017-07-17 13:28:16', NULL, NULL, 11167, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:28:16', 'admin-1500265652-15002692960826999', 1, 0, '', NULL, NULL, NULL),
(38595, '2017-07-17 13:30:21', NULL, NULL, 11166, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:30:21', 'admin-1500265652-15002694211774496', 1, 1, 'SR', NULL, NULL, NULL),
(38596, '2017-07-17 13:30:21', NULL, NULL, 11166, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:30:21', 'admin-1500265652-15002694211774496', 1, 0, '', NULL, NULL, NULL),
(38597, '2017-07-17 13:30:26', NULL, NULL, 11166, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:30:26', 'admin-1500265652-15002694259617830', 1, 1, 'SR', NULL, NULL, NULL),
(38598, '2017-07-17 13:30:26', NULL, NULL, 11166, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:30:26', 'admin-1500265652-15002694259617830', 1, 1, 'SR', NULL, NULL, NULL),
(38599, '2017-07-17 13:31:22', NULL, NULL, 11168, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.00, 0.0000, 0.0000, 10.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:31:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38600, '2017-07-17 13:31:27', NULL, NULL, 11168, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:31:27', 'admin-1500265652-15002694877425360', 1, 1, 'SR', NULL, NULL, NULL),
(38601, '2017-07-17 13:31:27', NULL, NULL, 11168, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:31:27', 'admin-1500265652-15002694877425360', 1, 1, 'SR', NULL, NULL, NULL),
(38602, '2017-07-17 13:31:27', NULL, NULL, 11168, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:31:27', 'admin-1500265652-15002694877425360', 1, 1, 'SR', NULL, NULL, NULL),
(38603, '2017-07-17 13:59:23', NULL, NULL, 11171, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:59:23', 'admin-1500270044-15002711631065941', 1, 0, '', NULL, NULL, NULL),
(38604, '2017-07-17 09:08:27', NULL, NULL, 11142, 0, 181, '116', 'Open Food ', 'sunny side up', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 09:08:27', 'admin-1500252965-1500253707057562', 1, 0, '', NULL, NULL, NULL),
(38605, '2017-07-17 09:08:31', NULL, NULL, 11142, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 09:08:31', 'admin-1500252965-15002537117234754', 1, 1, 'SR', NULL, NULL, NULL),
(38606, '2017-07-17 10:36:47', NULL, NULL, 11143, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 10:36:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38607, '2017-07-17 11:19:37', NULL, NULL, 11143, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:19:37', 'admin-1500261032-15002615774628048', 1, 0, '', NULL, NULL, NULL),
(38608, '2017-07-17 10:37:00', NULL, NULL, 11143, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 10:37:00', 'admin-1500252965-15002590202716372', 1, 0, '', NULL, NULL, NULL),
(38609, '2017-07-17 10:37:00', NULL, NULL, 11143, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 10:37:00', 'admin-1500252965-15002590202716372', 1, 0, '', NULL, NULL, NULL),
(38610, '2017-07-17 10:37:00', NULL, NULL, 11143, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 10:37:00', 'admin-1500252965-15002590202716372', 1, 1, 'SR', NULL, NULL, NULL),
(38611, '2017-07-17 10:44:05', NULL, NULL, 11144, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1500270044', 'admin', '2017-07-17 10:44:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38612, '2017-07-17 10:44:11', NULL, NULL, 11144, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 10:44:11', 'admin-1500252965-1500259451585268', 1, 0, '', NULL, NULL, NULL),
(38613, '2017-07-17 14:43:53', NULL, NULL, 11171, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 14:43:53', 'admin-1500270044-15002738331652293', 1, 0, '', NULL, NULL, NULL),
(38614, '2017-07-17 14:01:19', NULL, NULL, 11172, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 14:01:19', 'admin-1500270044-15002712794341514', 1, 0, '', NULL, NULL, NULL),
(38615, '2017-07-17 14:25:06', NULL, NULL, 11168, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 14:25:06', 'admin-1500270044-15002727066837140', 1, 0, '', NULL, NULL, NULL),
(38616, '2017-07-17 14:36:53', NULL, NULL, 11173, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1500270044', 'admin', '2017-07-17 14:36:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38617, '2017-07-17 14:36:58', NULL, NULL, 11173, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 14:36:58', 'admin-1500270044-15002734181621384', 1, 0, '', NULL, NULL, NULL),
(38618, '2017-07-17 10:44:17', NULL, NULL, 11144, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 10:44:17', 'admin-1500252965-15002594573556439', 1, 1, 'SR', NULL, NULL, NULL),
(38619, '2017-07-17 10:48:24', NULL, NULL, 11145, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1500270044', 'admin', '2017-07-17 10:48:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38620, '2017-07-17 10:49:04', NULL, NULL, 11145, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 10:49:04', 'admin-1500252965-1500259744761511', 1, 0, '', NULL, NULL, NULL),
(38621, '2017-07-17 14:43:53', NULL, NULL, 11171, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 14:43:53', 'admin-1500270044-15002738331652293', 1, 1, 'SR', NULL, NULL, NULL),
(38622, '2017-07-17 14:37:03', NULL, NULL, 11173, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 14:37:03', 'admin-1500270044-15002734232942061', 1, 1, 'SR', NULL, NULL, NULL),
(38623, '2017-07-17 14:37:03', NULL, NULL, 11173, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 14:37:03', 'admin-1500270044-15002734232942061', 1, 1, 'SR', NULL, NULL, NULL),
(38624, '2017-07-17 13:45:03', NULL, NULL, 11171, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:45:03', 'admin-1500270044-15002703031211027', 1, 1, 'SR', NULL, NULL, NULL),
(38625, '2017-07-17 13:45:03', NULL, NULL, 11171, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:45:03', 'admin-1500270044-15002703031211027', 1, 1, 'SR', NULL, NULL, NULL),
(38626, '2017-07-17 13:53:37', NULL, NULL, 11164, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:53:37', 'admin-1500270044-1500270817603479', 1, 1, 'SR', NULL, NULL, NULL),
(38627, '2017-07-17 13:53:37', NULL, NULL, 11164, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:53:37', 'admin-1500270044-1500270817603479', 1, 1, 'SR', NULL, NULL, NULL),
(38628, '2017-07-17 14:01:19', NULL, NULL, 11172, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 14:01:19', 'admin-1500270044-15002712794341514', 1, 1, 'SR', NULL, NULL, NULL),
(38629, '2017-07-17 14:01:19', NULL, NULL, 11172, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 14:01:19', 'admin-1500270044-15002712794341514', 1, 1, 'SR', NULL, NULL, NULL),
(38630, '2017-07-17 14:01:06', NULL, NULL, 11172, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1500270044', 'admin', '2017-07-17 14:01:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38631, '2017-07-17 11:41:57', NULL, NULL, 11153, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:41:57', 'admin-1500261032-15002629174978221', 1, 0, '', NULL, NULL, NULL),
(38632, '2017-07-17 11:50:31', NULL, NULL, 11149, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:50:31', 'admin-1500261032-15002634315734961', 1, 0, '', NULL, NULL, NULL),
(38633, '2017-07-17 11:42:56', NULL, NULL, 11153, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:42:56', 'admin-1500261032-1500262976497177', 1, 1, 'SR', NULL, NULL, NULL),
(38634, '2017-07-17 11:54:59', NULL, NULL, 11154, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:54:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38635, '2017-07-17 11:55:04', NULL, NULL, 11154, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:55:04', 'admin-1500261032-15002637040463452', 1, 1, 'SR', NULL, NULL, NULL),
(38636, '2017-07-17 12:01:30', NULL, NULL, 11155, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1500270044', 'admin', '2017-07-17 12:01:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38637, '2017-07-17 12:01:34', NULL, NULL, 11155, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 12:01:34', 'admin-1500261032-15002640942829920', 1, 1, 'SR', NULL, NULL, NULL),
(38638, '2017-07-17 12:18:35', NULL, NULL, 11158, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 12:18:35', 'admin-1500261032-15002651157431289', 1, 0, '', NULL, NULL, NULL),
(38639, '2017-07-17 12:18:26', NULL, NULL, 11158, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1500270044', 'admin', '2017-07-17 12:18:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38640, '2017-07-17 12:13:51', NULL, NULL, 11157, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.50, 0.0000, 0.0000, 9.50, 1, '27', 1, '1500270044', 'admin', '2017-07-17 12:13:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38641, '2017-07-17 12:14:10', NULL, NULL, 11157, 0, 217, '151', 'Spicy Lemony Wings', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 12:14:10', 'admin-1500261032-1500264850337922', 1, 0, '', NULL, NULL, NULL),
(38642, '2017-07-17 13:44:55', NULL, NULL, 11171, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:44:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38643, '2017-07-17 13:40:39', NULL, NULL, 11168, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:40:39', 'admin-1500265652-15002700388299536', 1, 1, 'SR', NULL, NULL, NULL),
(38644, '2017-07-17 13:40:39', NULL, NULL, 11168, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:40:39', 'admin-1500265652-15002700388299536', 1, 0, '', NULL, NULL, NULL),
(38645, '2017-07-17 13:40:39', NULL, NULL, 11168, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:40:39', 'admin-1500265652-15002700388299536', 1, 0, '', NULL, NULL, NULL),
(38646, '2017-07-17 13:31:54', NULL, NULL, 11169, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:31:54', 'admin-1500265652-1500269514299777', 1, 0, '', NULL, NULL, NULL),
(38647, '2017-07-17 13:31:54', NULL, NULL, 11169, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:31:54', 'admin-1500265652-1500269514299777', 1, 0, '', NULL, NULL, NULL),
(38648, '2017-07-17 11:12:55', NULL, NULL, 11151, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:12:55', 'admin-1500261032-15002611753437586', 1, 1, 'SR', NULL, NULL, NULL),
(38649, '2017-07-17 13:28:11', NULL, NULL, 11167, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:28:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38650, '2017-07-17 13:27:12', NULL, NULL, 11166, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1500270044', 'admin', '2017-07-17 13:27:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38651, '2017-07-17 12:18:35', NULL, NULL, 11158, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 12:18:35', 'admin-1500261032-15002651157431289', 1, 1, 'SR', NULL, NULL, NULL),
(38652, '2017-07-17 12:14:47', NULL, NULL, 11157, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 12:14:47', 'admin-1500261032-15002648871101438', 1, 1, 'SR', NULL, NULL, NULL),
(38653, '2017-07-17 12:14:47', NULL, NULL, 11157, 0, 156, '90', 'House Cheddar Omelet', 'bacon', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 12:14:47', 'admin-1500261032-15002648871101438', 1, 0, '', NULL, NULL, NULL),
(38654, '2017-07-17 12:14:47', NULL, NULL, 11157, 0, 156, '90', 'House Cheddar Omelet', 'bacon', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 12:14:47', 'admin-1500261032-15002648871101438', 1, 0, '', NULL, NULL, NULL),
(38655, '2017-07-17 12:14:10', NULL, NULL, 11157, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 12:14:10', 'admin-1500261032-1500264850337922', 1, 0, '', NULL, NULL, NULL),
(38656, '2017-07-17 11:09:37', NULL, NULL, 11149, 0, 279, '213', 'Diet Meal - Americano / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:09:37', 'admin-1500252965-15002609776277635', 1, 0, '', NULL, NULL, NULL),
(38657, '2017-07-17 11:21:57', NULL, NULL, 11149, 0, 279, '213', 'Diet Meal - Americano / Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:21:57', 'admin-1500261032-1500261716930475', 1, 0, '', NULL, NULL, NULL),
(38658, '2017-07-17 11:09:45', NULL, NULL, 11149, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:09:45', 'admin-1500252965-15002609849571530', 1, 1, 'SR', NULL, NULL, NULL),
(38659, '2017-07-17 11:02:02', NULL, NULL, 11147, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:02:02', 'admin-1500252965-15002605226687484', 1, 1, 'SR', NULL, NULL, NULL),
(38660, '2017-07-17 09:08:27', NULL, NULL, 11142, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 09:08:27', 'admin-1500252965-1500253707057562', 1, 0, '', NULL, NULL, NULL),
(38661, '2017-07-17 11:01:58', NULL, NULL, 11147, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:01:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38662, '2017-07-17 11:01:32', NULL, NULL, 11146, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:01:32', 'admin-1500252965-15002604923015513', 1, 1, 'SR', NULL, NULL, NULL),
(38663, '2017-07-17 11:01:28', NULL, NULL, 11146, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:01:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38664, '2017-07-17 11:01:32', NULL, NULL, 11146, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 11:01:32', 'admin-1500252965-15002604923015513', 1, 1, 'SR', NULL, NULL, NULL),
(38665, '2017-07-17 10:49:10', NULL, NULL, 11145, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 10:49:10', 'admin-1500252965-15002597499365648', 1, 1, 'SR', NULL, NULL, NULL),
(38666, '2017-07-17 10:49:04', NULL, NULL, 11145, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 10:49:04', 'admin-1500252965-1500259744761511', 1, 0, '', NULL, NULL, NULL),
(38667, '2017-07-17 10:44:17', NULL, NULL, 11144, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 10:44:17', 'admin-1500252965-15002594573556439', 1, 1, 'SR', NULL, NULL, NULL),
(38668, '2017-07-17 10:44:11', NULL, NULL, 11144, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 10:44:11', 'admin-1500252965-1500259451585268', 1, 0, '', NULL, NULL, NULL),
(38669, '2017-07-17 09:08:27', NULL, NULL, 11142, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500270044', 'admin', '2017-07-17 09:08:27', 'admin-1500252965-1500253707057562', 1, 0, '', NULL, NULL, NULL),
(38670, '2017-07-17 09:06:30', NULL, NULL, 11142, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1500270044', 'admin', '2017-07-17 09:06:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38671, '2017-07-19 12:58:46', NULL, NULL, 11191, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 12:58:46', 'admin-1500439386-15004403258653692', 1, 1, 'SR', NULL, NULL, NULL),
(38672, '2017-07-19 12:58:46', NULL, NULL, 11191, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 12:58:46', 'admin-1500439386-15004403258653692', 1, 1, 'SR', NULL, NULL, NULL),
(38673, '2017-07-19 12:58:46', NULL, NULL, 11191, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 12:58:46', 'admin-1500439386-15004403258653692', 1, 1, 'SR', NULL, NULL, NULL),
(38674, '2017-07-19 12:58:46', NULL, NULL, 11191, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 12:58:46', 'admin-1500439386-15004403258653692', 1, 0, '', NULL, NULL, NULL),
(38675, '2017-07-19 12:58:46', NULL, NULL, 11191, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 12:58:46', 'admin-1500439386-15004403258653692', 1, 0, '', NULL, NULL, NULL),
(38676, '2017-07-19 13:00:22', NULL, NULL, 11189, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 13:00:22', 'admin-1500439386-15004404220262032', 1, 0, '', NULL, NULL, NULL),
(38677, '2017-07-19 13:10:48', NULL, NULL, 11192, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 13:10:48', 'admin-1500439386-15004410480157546', 1, 1, 'SR', 1, NULL, '10.0'),
(38678, '2017-07-19 15:56:04', NULL, NULL, 11203, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 15:56:04', 'admin-1500439386-15004509647437090', 1, 1, 'SR', NULL, NULL, NULL),
(38679, '2017-07-19 16:05:09', NULL, NULL, 11204, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1500456537', 'admin', '2017-07-19 16:05:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38680, '2017-07-19 11:37:03', NULL, NULL, 11184, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1500456537', 'admin', '2017-07-19 11:37:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38681, '2017-07-19 11:37:06', NULL, NULL, 11184, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 11:37:06', 'admin-1500429669-15004354261723780', 1, 1, 'SR', NULL, NULL, NULL),
(38682, '2017-07-19 11:44:35', NULL, NULL, 11185, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1500456537', 'admin', '2017-07-19 11:44:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38683, '2017-07-19 11:46:43', NULL, NULL, 11185, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 11:46:43', 'admin-1500429669-15004360028417496', 1, 0, '', NULL, NULL, NULL),
(38684, '2017-07-19 17:09:49', NULL, NULL, 11206, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 17:09:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38685, '2017-07-19 12:21:35', NULL, NULL, 11188, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 12:21:35', 'admin-1500429669-15004380958164042', 1, 0, '', NULL, NULL, NULL),
(38686, '2017-07-19 12:21:24', NULL, NULL, 11188, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1500456537', 'admin', '2017-07-19 12:21:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38687, '2017-07-19 12:21:35', NULL, NULL, 11188, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 12:21:35', 'admin-1500429669-15004380958164042', 1, 0, '', NULL, NULL, NULL),
(38688, '2017-07-19 14:27:28', NULL, NULL, 11196, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 14:27:28', 'admin-1500439386-1500445648449682', 1, 1, 'SR', 1, NULL, '10.0'),
(38689, '2017-07-19 14:28:04', NULL, NULL, 11197, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1500456537', 'admin', '2017-07-19 14:28:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38690, '2017-07-19 14:28:09', NULL, NULL, 11197, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 14:28:09', 'admin-1500439386-15004456895738365', 1, 0, '', NULL, NULL, NULL),
(38691, '2017-07-19 14:30:18', NULL, NULL, 11198, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 14:30:18', 'admin-1500439386-15004458187896920', 1, 1, 'SR', 1, NULL, NULL),
(38692, '2017-07-19 14:36:09', NULL, NULL, 11197, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 14:36:09', 'admin-1500439386-15004461698138089', 1, 1, 'SR', NULL, NULL, NULL),
(38693, '2017-07-19 14:38:30', NULL, NULL, 11199, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.49, 0.0000, 0.0000, 2.49, 1, '27', 1, '1500456537', 'admin', '2017-07-19 14:38:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38694, '2017-07-19 14:38:47', NULL, NULL, 11199, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 14:38:47', 'admin-1500439386-15004463272698862', 1, 1, 'SR', NULL, NULL, NULL),
(38695, '2017-07-19 14:38:47', NULL, NULL, 11199, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 14:38:47', 'admin-1500439386-15004463272698862', 1, 0, '', NULL, NULL, NULL),
(38696, '2017-07-19 14:38:47', NULL, NULL, 11199, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1500456537', 'admin', '2017-07-19 14:38:47', 'admin-1500439386-15004463272698862', 1, 0, '', NULL, NULL, NULL),
(38697, '2017-07-19 17:15:22', NULL, NULL, 11206, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 17:15:22', 'admin-1500439386-15004557224627865', 1, 0, '', NULL, NULL, NULL),
(38698, '2017-07-19 13:44:15', NULL, NULL, 11186, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 13:44:15', 'admin-1500439386-1500443054979737', 1, 0, '', NULL, NULL, NULL),
(38699, '2017-07-19 13:44:27', NULL, NULL, 11195, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 13:44:27', 'admin-1500439386-15004430675617520', 1, 1, 'SR', NULL, NULL, NULL),
(38700, '2017-07-19 17:10:07', NULL, NULL, 11206, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 17:10:07', 'admin-1500439386-15004554076851248', 1, 0, '', NULL, NULL, NULL),
(38701, '2017-07-19 17:15:22', NULL, NULL, 11206, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 17:15:22', 'admin-1500439386-15004557224627865', 1, 0, '', NULL, NULL, NULL),
(38702, '2017-07-19 17:15:22', NULL, NULL, 11206, 0, 284, '218', 'Caramel Waffles', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 17:15:22', 'admin-1500439386-15004557224627865', 1, 0, '', NULL, NULL, NULL),
(38703, '2017-07-19 17:14:23', NULL, NULL, 11206, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 17:14:23', 'admin-1500439386-15004556632958715', 1, 1, 'SR', NULL, NULL, NULL),
(38704, '2017-07-19 17:10:07', NULL, NULL, 11206, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 17:10:07', 'admin-1500439386-15004554076851248', 1, 1, 'SR', NULL, NULL, NULL),
(38705, '2017-07-19 12:47:52', NULL, NULL, 11190, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 12:47:52', 'admin-1500439386-15004396724985498', 1, 0, '', NULL, NULL, '10.0'),
(38706, '2017-07-19 12:28:28', NULL, NULL, 11185, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 12:28:28', 'admin-1500429669-15004385084694447', 1, 1, 'SR', NULL, NULL, NULL),
(38707, '2017-07-19 15:48:51', NULL, NULL, 11202, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1500456537', 'admin', '2017-07-19 15:48:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38708, '2017-07-19 15:48:57', NULL, NULL, 11202, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 15:48:57', 'admin-1500439386-15004505370342180', 1, 0, '', NULL, NULL, NULL),
(38709, '2017-07-19 11:28:07', NULL, NULL, 11183, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1500456537', 'admin', '2017-07-19 11:28:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38710, '2017-07-19 11:28:10', NULL, NULL, 11183, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 11:28:10', 'admin-1500429669-15004348906553416', 1, 0, '', NULL, NULL, NULL),
(38711, '2017-07-19 11:28:15', NULL, NULL, 11183, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 11:28:15', 'admin-1500429669-15004348950111597', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(38712, '2017-07-19 16:44:17', NULL, NULL, 11205, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 16:44:17', 'admin-1500439386-15004538574105740', 1, 0, '', NULL, NULL, NULL),
(38713, '2017-07-19 16:56:58', NULL, NULL, 11205, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 16:56:58', 'admin-1500439386-15004546177901632', 1, 0, '', NULL, NULL, NULL),
(38714, '2017-07-19 16:44:17', NULL, NULL, 11205, 0, 56, '56', 'House red (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 16:44:17', 'admin-1500439386-15004538574105740', 1, 1, 'SR', NULL, NULL, NULL),
(38715, '2017-07-19 16:44:17', NULL, NULL, 11205, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 16:44:17', 'admin-1500439386-15004538574105740', 1, 0, '', NULL, NULL, NULL),
(38716, '2017-07-19 16:44:09', NULL, NULL, 11205, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1500456537', 'admin', '2017-07-19 16:44:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38717, '2017-07-19 16:05:14', NULL, NULL, 11204, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 16:05:14', 'admin-1500439386-15004515146203335', 1, 1, 'SR', NULL, NULL, NULL),
(38718, '2017-07-19 16:05:14', NULL, NULL, 11204, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 16:05:14', 'admin-1500439386-15004515146203335', 1, 1, 'SR', NULL, NULL, NULL),
(38719, '2017-07-19 16:56:58', NULL, NULL, 11205, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 16:56:58', 'admin-1500439386-15004546177901632', 1, 0, '', NULL, NULL, NULL),
(38720, '2017-07-19 09:49:09', NULL, NULL, 11175, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 09:49:09', 'admin-1500426805-15004289489348224', 1, 1, 'SR', NULL, NULL, NULL),
(38721, '2017-07-19 09:52:40', NULL, NULL, 11175, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 09:52:40', 'admin-1500426805-15004291607421067', 1, 0, '', NULL, NULL, NULL),
(38722, '2017-07-19 10:00:41', NULL, NULL, 11176, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1500456537', 'admin', '2017-07-19 10:00:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38723, '2017-07-19 10:00:59', NULL, NULL, 11176, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 10:00:59', 'admin-1500426805-1500429659302508', 1, 0, '', NULL, NULL, NULL),
(38724, '2017-07-19 10:00:59', NULL, NULL, 11176, 0, 153, '87', 'Wake Me Up!', 'No salad,add vege', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 10:00:59', 'admin-1500426805-1500429659302508', 1, 0, '', NULL, NULL, NULL),
(38725, '2017-07-19 10:00:59', NULL, NULL, 11176, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 10:00:59', 'admin-1500426805-1500429659302508', 1, 0, '', NULL, NULL, NULL),
(38726, '2017-07-19 10:00:59', NULL, NULL, 11176, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 10:00:59', 'admin-1500426805-1500429659302508', 1, 1, 'SR', NULL, NULL, NULL),
(38727, '2017-07-19 10:00:59', NULL, NULL, 11176, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 10:00:59', 'admin-1500426805-1500429659302508', 1, 1, 'SR', NULL, NULL, NULL),
(38728, '2017-07-19 10:14:10', NULL, NULL, 11175, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 10:14:10', 'admin-1500429669-1500430450550662', 1, 1, 'SR', NULL, NULL, NULL),
(38729, '2017-07-19 11:19:58', NULL, NULL, 11182, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1500456537', 'admin', '2017-07-19 11:19:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38730, '2017-07-19 15:56:04', NULL, NULL, 11203, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 15:56:04', 'admin-1500439386-15004509647437090', 1, 0, '', NULL, NULL, NULL),
(38731, '2017-07-19 15:48:57', NULL, NULL, 11202, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 15:48:57', 'admin-1500439386-15004505370342180', 1, 0, '', NULL, NULL, NULL),
(38732, '2017-07-19 15:55:57', NULL, NULL, 11203, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1500456537', 'admin', '2017-07-19 15:55:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38733, '2017-07-19 13:43:29', NULL, NULL, 11195, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1500456537', 'admin', '2017-07-19 13:43:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38734, '2017-07-19 13:44:06', NULL, NULL, 11195, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 13:44:06', 'admin-1500439386-15004430464062693', 1, 0, '', NULL, NULL, NULL),
(38735, '2017-07-19 13:44:06', NULL, NULL, 11195, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 13:44:06', 'admin-1500439386-15004430464062693', 1, 0, '', NULL, NULL, NULL),
(38736, '2017-07-19 13:26:25', NULL, NULL, 11191, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 13:26:25', 'admin-1500439386-15004419853063344', 1, 0, '', NULL, NULL, NULL),
(38737, '2017-07-19 11:02:48', NULL, NULL, 11180, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1500456537', 'admin', '2017-07-19 11:02:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38738, '2017-07-19 00:00:00', NULL, NULL, 11180, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 10:19:44', 'admin-1500429669-1500430784449339', 1, 0, '', NULL, NULL, NULL),
(38739, '2017-07-19 00:00:00', NULL, NULL, 11181, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 10:19:44', 'admin-1500429669-1500430784449339', 1, 0, '', NULL, NULL, NULL),
(38740, '2017-07-19 15:38:04', NULL, NULL, 11201, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1500456537', 'admin', '2017-07-19 15:38:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38741, '2017-07-19 15:38:09', NULL, NULL, 11201, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 15:38:09', 'admin-1500439386-15004498894849876', 1, 0, '', NULL, NULL, NULL),
(38742, '2017-07-19 15:38:09', NULL, NULL, 11201, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 15:38:09', 'admin-1500439386-15004498894849876', 1, 0, '', NULL, NULL, NULL),
(38743, '2017-07-19 15:01:28', NULL, NULL, 11200, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 15:01:28', 'admin-1500439386-15004476881791596', 1, 1, 'SR', NULL, NULL, NULL),
(38744, '2017-07-19 15:01:28', NULL, NULL, 11200, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 15:01:28', 'admin-1500439386-15004476881791596', 1, 1, 'SR', NULL, NULL, NULL),
(38745, '2017-07-19 15:01:22', NULL, NULL, 11200, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1500456537', 'admin', '2017-07-19 15:01:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38746, '2017-07-19 13:44:15', NULL, NULL, 11186, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 13:44:15', 'admin-1500439386-1500443054979737', 1, 1, 'SR', NULL, NULL, NULL),
(38747, '2017-07-19 11:46:43', NULL, NULL, 11185, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 11:46:43', 'admin-1500429669-15004360028417496', 1, 0, '', NULL, NULL, NULL),
(38748, '2017-07-19 11:46:51', NULL, NULL, 11185, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 11:46:51', 'admin-1500429669-15004360112526465', 1, 1, 'SR', NULL, NULL, NULL),
(38749, '2017-07-19 11:46:51', NULL, NULL, 11185, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 11:46:51', 'admin-1500429669-15004360112526465', 1, 1, 'SR', NULL, NULL, NULL),
(38750, '2017-07-19 12:38:13', NULL, NULL, 11189, 0, 217, '151', 'Spicy Lemony Wings', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 12:38:13', 'admin-1500429669-15004390928379438', 1, 0, '', NULL, NULL, NULL),
(38751, '2017-07-19 12:42:30', NULL, NULL, 11190, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.60, 0.0000, 0.0000, 10.60, 1, '27', 1, '1500456537', 'admin', '2017-07-19 12:42:30', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(38752, '2017-07-19 12:43:02', NULL, NULL, 11190, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 12:43:02', 'admin-1500429669-15004393821833856', 1, 1, 'SR', NULL, NULL, '10.0'),
(38753, '2017-07-19 12:43:02', NULL, NULL, 11190, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 12:43:02', 'admin-1500429669-15004393821833856', 1, 0, '', NULL, NULL, '10.0'),
(38754, '2017-07-19 12:43:02', NULL, NULL, 11190, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 12:43:02', 'admin-1500429669-15004393821833856', 1, 0, '', NULL, NULL, '10.0'),
(38755, '2017-07-19 12:43:27', NULL, NULL, 11190, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 12:43:27', 'admin-1500439386-1500439407018271', 1, 1, 'SR', NULL, NULL, '10.0'),
(38756, '2017-07-19 12:43:27', NULL, NULL, 11190, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 12:43:27', 'admin-1500439386-1500439407018271', 1, 0, '', NULL, NULL, '10.0'),
(38757, '2017-07-19 12:43:27', NULL, NULL, 11190, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 12:43:27', 'admin-1500439386-1500439407018271', 1, 1, 'SR', NULL, NULL, '10.0'),
(38758, '2017-07-19 13:26:25', NULL, NULL, 11191, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 13:26:25', 'admin-1500439386-15004419853063344', 1, 0, '', NULL, NULL, NULL),
(38759, '2017-07-19 13:20:24', NULL, NULL, 11194, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 13:20:24', 'admin-1500439386-15004416244129397', 1, 1, 'SR', NULL, NULL, NULL),
(38760, '2017-07-19 13:20:14', NULL, NULL, 11193, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 13:20:14', 'admin-1500439386-15004416141781357', 1, 0, '', NULL, NULL, NULL),
(38761, '2017-07-19 13:20:19', NULL, NULL, 11194, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 13:20:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38762, '2017-07-19 13:20:07', NULL, NULL, 11193, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 13:20:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38763, '2017-07-19 12:58:30', NULL, NULL, 11191, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 12:58:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38764, '2017-07-19 13:10:02', NULL, NULL, 11189, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 13:10:02', 'admin-1500439386-15004410021454255', 1, 1, 'SR', NULL, NULL, NULL),
(38765, '2017-07-19 13:44:27', NULL, NULL, 11195, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 13:44:27', 'admin-1500439386-15004430675617520', 1, 1, 'SR', NULL, NULL, NULL),
(38766, '2017-07-19 12:21:35', NULL, NULL, 11188, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 12:21:35', 'admin-1500429669-15004380958164042', 1, 0, '', NULL, NULL, NULL),
(38767, '2017-07-19 11:55:31', NULL, NULL, 11187, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 11:55:31', 'admin-1500429669-15004365309751312', 1, 1, 'SR', NULL, NULL, NULL),
(38768, '2017-07-19 11:55:31', NULL, NULL, 11187, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 11:55:31', 'admin-1500429669-15004365309751312', 1, 1, 'SR', NULL, NULL, NULL),
(38769, '2017-07-19 11:55:31', NULL, NULL, 11187, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 11:55:31', 'admin-1500429669-15004365309751312', 1, 0, '', NULL, NULL, NULL),
(38770, '2017-07-19 14:16:30', NULL, NULL, 11189, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 14:16:30', 'admin-1500439386-1500444990396457', 1, 1, 'SR', NULL, NULL, NULL),
(38771, '2017-07-19 11:55:04', NULL, NULL, 11187, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1500456537', 'admin', '2017-07-19 11:55:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38772, '2017-07-19 11:50:14', NULL, NULL, 11186, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 11:50:14', 'admin-1500429669-15004362143103980', 1, 1, 'SR', NULL, NULL, NULL),
(38773, '2017-07-19 11:50:14', NULL, NULL, 11186, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 11:50:14', 'admin-1500429669-15004362143103980', 1, 1, 'SR', NULL, NULL, NULL),
(38774, '2017-07-19 12:37:12', NULL, NULL, 11189, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 12:37:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38775, '2017-07-19 11:50:08', NULL, NULL, 11186, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1500456537', 'admin', '2017-07-19 11:50:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38776, '2017-07-19 11:20:31', NULL, NULL, 11182, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 11:20:31', 'admin-1500429669-15004344311605787', 1, 0, '', NULL, NULL, NULL),
(38777, '2017-07-19 11:20:44', NULL, NULL, 11182, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 11:20:44', 'admin-1500429669-1500434443850776', 1, 1, 'SR', NULL, NULL, NULL),
(38778, '2017-07-19 00:00:00', NULL, NULL, 11180, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 10:19:44', 'admin-1500429669-1500430784449339', 1, 1, 'SR', NULL, NULL, NULL),
(38779, '2017-07-19 00:00:00', NULL, NULL, 11181, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 10:19:44', 'admin-1500429669-1500430784449339', 1, 1, 'SR', NULL, NULL, NULL),
(38780, '2017-07-19 10:56:37', NULL, NULL, 11179, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1500456537', 'admin', '2017-07-19 10:56:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38781, '2017-07-19 10:56:43', NULL, NULL, 11179, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 10:56:43', 'admin-1500429669-1500433003532428', 1, 1, 'SR', NULL, NULL, NULL),
(38782, '2017-07-19 00:00:00', NULL, NULL, 11181, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 10:19:44', 'admin-1500429669-1500430784449339', 1, 1, 'SR', NULL, NULL, NULL),
(38783, '2017-07-19 00:00:00', NULL, NULL, 11180, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 10:19:44', 'admin-1500429669-1500430784449339', 1, 0, '', NULL, NULL, NULL),
(38784, '2017-07-19 10:33:08', NULL, NULL, 11178, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1500456537', 'admin', '2017-07-19 10:33:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38785, '2017-07-19 10:33:11', NULL, NULL, 11178, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1500456537', 'admin', '2017-07-19 10:33:11', 'admin-1500429669-15004315915778951', 1, 1, 'SR', NULL, NULL, NULL),
(38786, '2017-07-19 00:00:00', NULL, NULL, 11181, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, NULL, NULL, 2.90, 1, '27', 1, '1500456537', 'admin', '2017-07-19 10:19:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38787, '2017-07-19 09:49:06', NULL, NULL, 11175, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1500456537', 'admin', '2017-07-19 09:49:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38788, '2017-07-20 12:25:43', NULL, NULL, 11220, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:25:43', 'admin-1500518667-15005247433726991', 1, 0, '', NULL, NULL, NULL),
(38789, '2017-07-20 12:25:43', NULL, NULL, 11220, 0, 223, '157', 'Crispy Bacon Aglio Olio', 'More garlic', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:25:43', 'admin-1500518667-15005247433726991', 1, 0, '', NULL, NULL, NULL),
(38790, '2017-07-20 12:25:43', NULL, NULL, 11220, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:25:43', 'admin-1500518667-15005247433726991', 1, 0, '', NULL, NULL, NULL),
(38791, '2017-07-20 12:25:43', NULL, NULL, 11220, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:25:43', 'admin-1500518667-15005247433726991', 1, 0, '', NULL, NULL, NULL),
(38792, '2017-07-20 12:25:43', NULL, NULL, 11220, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:25:43', 'admin-1500518667-15005247433726991', 1, 1, 'SR', NULL, NULL, NULL),
(38793, '2017-07-20 12:36:19', NULL, NULL, 11221, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:36:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38794, '2017-07-20 12:36:33', NULL, NULL, 11221, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:36:33', 'admin-1500524749-15005253933355498', 1, 1, 'SR', NULL, NULL, NULL),
(38795, '2017-07-20 12:36:33', NULL, NULL, 11221, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:36:33', 'admin-1500524749-15005253933355498', 1, 1, 'SR', NULL, NULL, NULL),
(38796, '2017-07-20 13:49:24', NULL, NULL, 11226, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 13:49:24', 'admin-1500527734-15005297640976619', 1, 1, 'SR', NULL, NULL, NULL),
(38797, '2017-07-20 13:49:24', NULL, NULL, 11226, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 13:49:24', 'admin-1500527734-15005297640976619', 1, 1, 'SR', NULL, NULL, NULL),
(38798, '2017-07-20 13:23:44', NULL, NULL, 11225, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 13:23:44', 'admin-1500527734-15005282239209880', 1, 0, '', NULL, NULL, NULL),
(38799, '2017-07-20 14:26:04', NULL, NULL, 11227, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 14:26:04', 'admin-1500527734-15005319647686416', 1, 0, '', NULL, NULL, NULL),
(38800, '2017-07-20 14:26:04', NULL, NULL, 11227, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 14:26:04', 'admin-1500527734-15005319647686416', 1, 1, 'SR', NULL, NULL, NULL),
(38801, '2017-07-20 14:26:04', NULL, NULL, 11227, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 14:26:04', 'admin-1500527734-15005319647686416', 1, 0, '', NULL, NULL, NULL),
(38802, '2017-07-20 14:33:11', NULL, NULL, 11228, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1500527734', 'admin', '2017-07-20 14:33:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38803, '2017-07-20 14:33:16', NULL, NULL, 11228, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 14:33:16', 'admin-1500527734-15005323965346560', 1, 1, 'SR', NULL, NULL, NULL),
(38804, '2017-07-20 16:35:30', NULL, NULL, 11233, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 16:35:30', 'admin-1500527734-15005397299908068', 1, 1, 'SR', NULL, NULL, NULL),
(38805, '2017-07-20 12:07:31', NULL, NULL, 11217, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:07:31', 'admin-1500518667-15005236517191621', 1, 1, 'SR', NULL, NULL, '10.0'),
(38806, '2017-07-20 16:35:30', NULL, NULL, 11233, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 16:35:30', 'admin-1500527734-15005397299908068', 1, 1, 'SR', NULL, NULL, NULL),
(38807, '2017-07-20 12:07:31', NULL, NULL, 11217, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:07:31', 'admin-1500518667-15005236517191621', 1, 1, 'SR', NULL, NULL, '10.0'),
(38808, '2017-07-20 12:07:31', NULL, NULL, 11217, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:07:31', 'admin-1500518667-15005236517191621', 1, 1, 'SR', NULL, NULL, '10.0'),
(38809, '2017-07-20 16:35:30', NULL, NULL, 11233, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 16:35:30', 'admin-1500527734-15005397299908068', 1, 0, '', NULL, NULL, NULL),
(38810, '2017-07-20 13:15:29', NULL, NULL, 11223, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 13:15:29', 'admin-1500524749-15005277289926063', 1, 0, '', NULL, NULL, '10.0'),
(38811, '2017-07-20 13:23:37', NULL, NULL, 11225, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1500527734', 'admin', '2017-07-20 13:23:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38812, '2017-07-20 11:50:50', NULL, NULL, 11215, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1500527734', 'admin', '2017-07-20 11:50:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38813, '2017-07-20 11:51:20', NULL, NULL, 11215, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 11:51:20', 'admin-1500518667-15005226803768592', 1, 1, 'SR', NULL, NULL, NULL),
(38814, '2017-07-20 10:44:43', NULL, NULL, 11213, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1500527734', 'admin', '2017-07-20 10:44:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38815, '2017-07-20 09:45:07', NULL, NULL, 11208, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:45:07', 'admin-1500512269-1500515107273875', 1, 0, '', NULL, NULL, NULL),
(38816, '2017-07-20 09:50:29', NULL, NULL, 11210, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:50:29', 'admin-1500512269-15005154295324179', 1, 1, 'SR', NULL, NULL, NULL),
(38817, '2017-07-20 09:50:29', NULL, NULL, 11210, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:50:29', 'admin-1500512269-15005154295324179', 1, 1, 'SR', NULL, NULL, NULL),
(38818, '2017-07-20 10:09:53', NULL, NULL, 11211, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1500527734', 'admin', '2017-07-20 10:09:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38819, '2017-07-20 10:10:04', NULL, NULL, 11211, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 10:10:04', 'admin-1500512269-15005166038878726', 1, 0, '', NULL, NULL, NULL),
(38820, '2017-07-20 10:10:04', NULL, NULL, 11211, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 10:10:04', 'admin-1500512269-15005166038878726', 1, 0, '', NULL, NULL, NULL),
(38821, '2017-07-20 10:10:12', NULL, NULL, 11211, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 10:10:12', 'admin-1500512269-15005166124848161', 1, 1, 'SR', NULL, NULL, NULL),
(38822, '2017-07-20 16:11:35', NULL, NULL, 11232, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 16:11:35', 'admin-1500527734-1500538295374746', 1, 1, 'SR', NULL, NULL, '10.0'),
(38823, '2017-07-20 14:25:49', NULL, NULL, 11227, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 14:25:49', 'admin-1500527734-15005319494749788', 1, 0, '', NULL, NULL, NULL),
(38824, '2017-07-20 16:11:31', NULL, NULL, 11232, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 16:11:31', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(38825, '2017-07-20 16:35:23', NULL, NULL, 11233, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1500527734', 'admin', '2017-07-20 16:35:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38826, '2017-07-20 15:20:13', NULL, NULL, 11231, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 15:20:13', 'admin-1500527734-15005352127633546', 1, 1, 'SR', 1, NULL, '10.0'),
(38827, '2017-07-20 14:36:36', NULL, NULL, 11229, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1500527734', 'admin', '2017-07-20 14:36:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38828, '2017-07-20 14:36:43', NULL, NULL, 11229, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 14:36:43', 'admin-1500527734-15005326031558073', 1, 1, 'SR', NULL, NULL, NULL),
(38829, '2017-07-20 14:36:43', NULL, NULL, 11229, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 14:36:43', 'admin-1500527734-15005326031558073', 1, 1, 'SR', NULL, NULL, NULL),
(38830, '2017-07-20 14:59:48', NULL, NULL, 11230, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 14:59:48', 'admin-1500527734-15005339885521047', 1, 1, 'SR', NULL, NULL, NULL),
(38831, '2017-07-20 14:59:44', NULL, NULL, 11230, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 14:59:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38832, '2017-07-20 13:05:34', NULL, NULL, 11224, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 13:05:34', 'admin-1500524749-15005271340788549', 1, 0, '', NULL, NULL, NULL),
(38833, '2017-07-20 09:35:47', NULL, NULL, 11208, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:35:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38834, '2017-07-20 09:50:07', NULL, NULL, 11210, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:50:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38835, '2017-07-20 09:35:12', NULL, NULL, 11207, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:35:12', 'admin-1500512269-15005145118716074', 1, 1, 'SR', NULL, NULL, NULL),
(38836, '2017-07-20 14:26:04', NULL, NULL, 11227, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 14:26:04', 'admin-1500527734-15005319647686416', 1, 1, 'SR', NULL, NULL, NULL),
(38837, '2017-07-20 14:26:04', NULL, NULL, 11227, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 14:26:04', 'admin-1500527734-15005319647686416', 1, 1, 'SR', NULL, NULL, NULL),
(38838, '2017-07-20 14:26:04', NULL, NULL, 11227, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 14:26:04', 'admin-1500527734-15005319647686416', 1, 1, 'SR', NULL, NULL, NULL),
(38839, '2017-07-20 14:25:43', NULL, NULL, 11227, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1500527734', 'admin', '2017-07-20 14:25:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38840, '2017-07-20 14:02:35', NULL, NULL, 11223, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 14:02:35', 'admin-1500527734-1500530555145741', 1, 1, 'SR', NULL, NULL, '10.0'),
(38841, '2017-07-20 13:49:24', NULL, NULL, 11226, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 13:49:24', 'admin-1500527734-15005297640976619', 1, 0, '', NULL, NULL, NULL),
(38842, '2017-07-20 12:36:33', NULL, NULL, 11221, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:36:33', 'admin-1500524749-15005253933355498', 1, 1, 'SR', NULL, NULL, NULL),
(38843, '2017-07-20 12:36:33', NULL, NULL, 11221, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:36:33', 'admin-1500524749-15005253933355498', 1, 1, 'SR', NULL, NULL, NULL),
(38844, '2017-07-20 12:36:33', NULL, NULL, 11221, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:36:33', 'admin-1500524749-15005253933355498', 1, 1, 'SR', NULL, NULL, NULL),
(38845, '2017-07-20 12:47:05', NULL, NULL, 11222, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:47:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38846, '2017-07-20 12:47:15', NULL, NULL, 11222, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:47:15', 'admin-1500524749-15005260357115777', 1, 1, 'SR', NULL, NULL, NULL),
(38847, '2017-07-20 12:47:38', NULL, NULL, 11222, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:47:38', 'admin-1500524749-15005260580886041', 1, 1, 'SR', NULL, NULL, NULL),
(38848, '2017-07-20 12:49:10', NULL, NULL, 11221, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:49:10', 'admin-1500524749-15005261501486828', 1, 0, '', NULL, NULL, NULL),
(38849, '2017-07-20 12:51:26', NULL, NULL, 11223, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:51:26', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(38850, '2017-07-20 12:51:46', NULL, NULL, 11223, 0, 181, '116', 'Open Food ', 'French beans fried rice', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:51:46', 'admin-1500524749-1500526305868282', 1, 0, '', NULL, NULL, '10.0'),
(38851, '2017-07-20 12:52:03', NULL, NULL, 11223, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:52:03', 'admin-1500524749-15005263230858172', 1, 0, '', NULL, NULL, '10.0'),
(38852, '2017-07-20 13:49:15', NULL, NULL, 11226, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1500527734', 'admin', '2017-07-20 13:49:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38853, '2017-07-20 12:24:17', NULL, NULL, 11219, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:24:17', 'admin-1500518667-15005246570659371', 1, 0, '', NULL, NULL, NULL),
(38854, '2017-07-20 12:25:23', NULL, NULL, 11220, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:25:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38855, '2017-07-20 13:05:34', NULL, NULL, 11224, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 13:05:34', 'admin-1500524749-15005271340788549', 1, 1, 'SR', NULL, NULL, NULL),
(38856, '2017-07-20 13:05:34', NULL, NULL, 11224, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 13:05:34', 'admin-1500524749-15005271340788549', 1, 1, 'SR', NULL, NULL, NULL),
(38857, '2017-07-20 13:05:34', NULL, NULL, 11224, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 13:05:34', 'admin-1500524749-15005271340788549', 1, 1, 'SR', NULL, NULL, NULL),
(38858, '2017-07-20 13:23:44', NULL, NULL, 11225, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 13:23:44', 'admin-1500527734-15005282239209880', 1, 0, '', NULL, NULL, NULL),
(38859, '2017-07-20 13:05:34', NULL, NULL, 11224, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 13:05:34', 'admin-1500524749-15005271340788549', 1, 0, '', NULL, NULL, NULL),
(38860, '2017-07-20 13:05:34', NULL, NULL, 11224, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 13:05:34', 'admin-1500524749-15005271340788549', 1, 1, 'SR', NULL, NULL, NULL),
(38861, '2017-07-20 13:05:34', NULL, NULL, 11224, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 13:05:34', 'admin-1500524749-15005271340788549', 1, 1, 'SR', NULL, NULL, NULL),
(38862, '2017-07-20 13:05:08', NULL, NULL, 11224, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1500527734', 'admin', '2017-07-20 13:05:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38863, '2017-07-20 12:59:19', NULL, NULL, 11218, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:59:19', 'admin-1500524749-15005267594105075', 1, 1, 'SR', NULL, NULL, NULL),
(38864, '2017-07-20 12:59:13', NULL, NULL, 11223, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:59:13', 'admin-1500524749-15005267529415850', 1, 1, 'SR', NULL, NULL, '10.0'),
(38865, '2017-07-20 12:19:46', NULL, NULL, 11218, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:19:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38866, '2017-07-20 12:19:52', NULL, NULL, 11218, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:19:52', 'admin-1500518667-15005243925484356', 1, 1, 'SR', NULL, NULL, NULL),
(38867, '2017-07-20 12:19:52', NULL, NULL, 11218, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:19:52', 'admin-1500518667-15005243925484356', 1, 1, 'SR', NULL, NULL, NULL),
(38868, '2017-07-20 12:22:00', NULL, NULL, 11219, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:22:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38869, '2017-07-20 12:22:03', NULL, NULL, 11219, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:22:03', 'admin-1500518667-1500524523637249', 1, 1, 'SR', NULL, NULL, NULL),
(38870, '2017-07-20 12:24:17', NULL, NULL, 11219, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:24:17', 'admin-1500518667-15005246570659371', 1, 1, 'SR', NULL, NULL, NULL),
(38871, '2017-07-20 10:27:29', NULL, NULL, 11212, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1500527734', 'admin', '2017-07-20 10:27:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38872, '2017-07-20 10:27:39', NULL, NULL, 11212, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 10:27:39', 'admin-1500512269-15005176597408041', 1, 0, '', NULL, NULL, NULL),
(38873, '2017-07-20 10:27:39', NULL, NULL, 11212, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 10:27:39', 'admin-1500512269-15005176597408041', 1, 0, '', NULL, NULL, NULL),
(38874, '2017-07-20 10:27:39', NULL, NULL, 11212, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 10:27:39', 'admin-1500512269-15005176597408041', 1, 1, 'SR', NULL, NULL, NULL),
(38875, '2017-07-20 10:27:39', NULL, NULL, 11212, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 10:27:39', 'admin-1500512269-15005176597408041', 1, 1, 'SR', NULL, NULL, NULL),
(38876, '2017-07-20 00:00:00', NULL, NULL, 11213, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:35:50', 'admin-1500512269-15005145506759712', 1, 1, 'SR', NULL, NULL, NULL),
(38877, '2017-07-20 11:16:19', NULL, NULL, 11214, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1500527734', 'admin', '2017-07-20 11:16:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38878, '2017-07-20 11:16:24', NULL, NULL, 11214, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 11:16:24', 'admin-1500518667-15005205843082670', 1, 1, 'SR', NULL, NULL, NULL),
(38879, '2017-07-20 09:35:12', NULL, NULL, 11207, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:35:12', 'admin-1500512269-15005145118716074', 1, 1, 'SR', NULL, NULL, NULL),
(38880, '2017-07-20 09:50:20', NULL, NULL, 11210, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:50:20', 'admin-1500512269-15005154202615443', 1, 0, '', NULL, NULL, NULL),
(38881, '2017-07-20 09:50:20', NULL, NULL, 11210, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:50:20', 'admin-1500512269-15005154202615443', 1, 0, '', NULL, NULL, NULL),
(38882, '2017-07-20 16:35:30', NULL, NULL, 11233, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 16:35:30', 'admin-1500527734-15005397299908068', 1, 0, '', NULL, NULL, NULL),
(38883, '2017-07-20 12:36:33', NULL, NULL, 11221, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:36:33', 'admin-1500524749-15005253933355498', 1, 1, 'SR', NULL, NULL, NULL),
(38884, '2017-07-20 12:00:13', NULL, NULL, 11216, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:00:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38885, '2017-07-20 16:13:17', NULL, NULL, 11230, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 16:13:17', 'admin-1500527734-15005383974746043', 1, 1, 'SR', NULL, NULL, NULL),
(38886, '2017-07-20 12:24:17', NULL, NULL, 11219, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:24:17', 'admin-1500518667-15005246570659371', 1, 0, '', NULL, NULL, NULL),
(38887, '2017-07-20 12:59:13', NULL, NULL, 11223, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:59:13', 'admin-1500524749-15005267529415850', 1, 1, 'SR', NULL, NULL, '10.0'),
(38888, '2017-07-20 12:18:50', NULL, NULL, 11217, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:18:50', 'admin-1500518667-15005243306126714', 1, 0, '', NULL, NULL, '10.0'),
(38889, '2017-07-20 12:07:31', NULL, NULL, 11217, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:07:31', 'admin-1500518667-15005236517191621', 1, 1, 'SR', NULL, NULL, '10.0'),
(38890, '2017-07-20 12:07:19', NULL, NULL, 11217, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:07:19', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(38891, '2017-07-20 12:00:17', NULL, NULL, 11216, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:00:17', 'admin-1500518667-1500523217535615', 1, 0, '', NULL, NULL, NULL),
(38892, '2017-07-20 12:00:22', NULL, NULL, 11216, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:00:22', 'admin-1500518667-1500523222278242', 1, 1, 'SR', NULL, NULL, NULL),
(38893, '2017-07-20 11:51:20', NULL, NULL, 11215, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 11:51:20', 'admin-1500518667-15005226803768592', 1, 1, 'SR', NULL, NULL, NULL),
(38894, '2017-07-20 09:45:07', NULL, NULL, 11208, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:45:07', 'admin-1500512269-1500515107273875', 1, 1, 'SR', NULL, NULL, NULL),
(38895, '2017-07-20 13:49:24', NULL, NULL, 11226, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 13:49:24', 'admin-1500527734-15005297640976619', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(38896, '2017-07-20 09:44:14', NULL, NULL, 11209, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:44:14', 'admin-1500512269-15005150543491193', 1, 0, '', NULL, NULL, NULL),
(38897, '2017-07-20 00:00:00', NULL, NULL, 11213, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:45:07', 'admin-1500512269-1500515107273875', 1, 0, '', NULL, NULL, NULL),
(38898, '2017-07-20 09:44:09', NULL, NULL, 11209, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:44:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38899, '2017-07-20 09:08:19', NULL, NULL, 11207, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:08:19', 'admin-1500512269-15005128997502182', 1, 0, '', NULL, NULL, NULL),
(38900, '2017-07-20 09:08:19', NULL, NULL, 11207, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:08:19', 'admin-1500512269-15005128997502182', 1, 0, '', NULL, NULL, NULL),
(38901, '2017-07-20 09:05:23', NULL, NULL, 11207, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:05:23', 'admin-1500512269-1500512723193791', 1, 1, 'SR', NULL, NULL, NULL),
(38902, '2017-07-20 09:05:23', NULL, NULL, 11207, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:05:23', 'admin-1500512269-1500512723193791', 1, 1, 'SR', NULL, NULL, NULL),
(38903, '2017-07-20 12:59:13', NULL, NULL, 11223, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 12:59:13', 'admin-1500524749-15005267529415850', 1, 0, '', NULL, NULL, '10.0'),
(38904, '2017-07-20 09:08:19', NULL, NULL, 11207, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:08:19', 'admin-1500512269-15005128997502182', 1, 0, '', NULL, NULL, NULL),
(38905, '2017-07-20 09:05:23', NULL, NULL, 11207, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:05:23', 'admin-1500512269-1500512723193791', 1, 1, 'SR', NULL, NULL, NULL),
(38906, '2017-07-20 09:05:23', NULL, NULL, 11207, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:05:23', 'admin-1500512269-1500512723193791', 1, 1, 'SR', NULL, NULL, NULL),
(38907, '2017-07-20 09:05:23', NULL, NULL, 11207, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:05:23', 'admin-1500512269-1500512723193791', 1, 1, 'SR', NULL, NULL, NULL),
(38908, '2017-07-20 09:05:12', NULL, NULL, 11207, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.50, 0.0000, 0.0000, 11.50, 1, '27', 1, '1500527734', 'admin', '2017-07-20 09:05:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38909, '2017-07-21 13:25:11', NULL, NULL, 11259, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:25:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38910, '2017-07-21 13:25:18', NULL, NULL, 11259, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:25:18', 'admin-1500611801-15006147187025279', 1, 0, '', NULL, NULL, NULL),
(38911, '2017-07-21 13:23:32', NULL, NULL, 11258, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:23:32', 'admin-1500611801-15006146118129311', 1, 0, '', NULL, NULL, NULL),
(38912, '2017-07-21 13:23:32', NULL, NULL, 11258, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:23:32', 'admin-1500611801-15006146118129311', 1, 1, 'SR', NULL, NULL, NULL),
(38913, '2017-07-21 13:23:32', NULL, NULL, 11258, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:23:32', 'admin-1500611801-15006146118129311', 1, 0, '', NULL, NULL, NULL),
(38914, '2017-07-21 13:22:59', NULL, NULL, 11258, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:22:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38915, '2017-07-21 13:19:54', NULL, NULL, 11257, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:19:54', 'admin-1500611801-15006143939767110', 1, 1, 'SR', NULL, NULL, NULL),
(38916, '2017-07-21 13:19:49', NULL, NULL, 11257, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:19:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38917, '2017-07-21 13:10:15', NULL, NULL, 11256, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:10:15', 'admin-1500611801-15006138151386738', 1, 1, 'SR', 1, NULL, '10.0'),
(38918, '2017-07-21 13:04:24', NULL, NULL, 11255, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:04:24', 'admin-1500611801-15006134640665335', 1, 1, 'SR', NULL, NULL, NULL),
(38919, '2017-07-21 13:03:52', NULL, NULL, 11255, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:03:52', 'admin-1500611801-15006134322012272', 1, 1, 'SR', NULL, NULL, NULL),
(38920, '2017-07-21 13:03:52', NULL, NULL, 11255, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:03:52', 'admin-1500611801-15006134322012272', 1, 0, '', NULL, NULL, NULL),
(38921, '2017-07-21 13:03:52', NULL, NULL, 11255, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:03:52', 'admin-1500611801-15006134322012272', 1, 1, 'SR', NULL, NULL, NULL),
(38922, '2017-07-21 12:33:54', NULL, NULL, 11251, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:33:54', 'admin-1500606849-1500611633747268', 1, 0, '', NULL, NULL, NULL),
(38923, '2017-07-21 13:03:52', NULL, NULL, 11255, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:03:52', 'admin-1500611801-15006134322012272', 1, 0, '', NULL, NULL, NULL),
(38924, '2017-07-21 13:52:17', NULL, NULL, 11255, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:52:17', 'admin-1500611801-15006163374009748', 1, 0, '', NULL, NULL, NULL),
(38925, '2017-07-21 13:54:06', NULL, NULL, 11261, 0, 182, '117', 'Open Drinks ', 'apple', 'Cold Drinks', 'Fresh Juice', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:54:06', 'admin-1500611801-15006164467879380', 1, 0, '', 1, NULL, NULL),
(38926, '2017-07-21 11:14:05', NULL, NULL, 11245, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 11:14:05', 'admin-1500603185-15006068447962282', 1, 1, 'SR', NULL, NULL, NULL),
(38927, '2017-07-21 12:33:15', NULL, NULL, 11251, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 24.40, 0.0000, 0.0000, 24.40, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:33:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38928, '2017-07-21 10:11:48', NULL, NULL, 11237, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:11:48', 'admin-1500598066-15006031085005516', 1, 0, '', NULL, NULL, NULL),
(38929, '2017-07-21 10:32:13', NULL, NULL, 11240, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:32:13', 'admin-1500603185-15006043334168046', 1, 1, 'SR', NULL, NULL, NULL),
(38930, '2017-07-21 12:51:13', NULL, NULL, 11254, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:51:13', 'admin-1500611801-15006126735809734', 1, 1, 'SR', NULL, NULL, NULL),
(38931, '2017-07-21 13:03:29', NULL, NULL, 11255, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:03:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38932, '2017-07-21 12:07:50', NULL, NULL, 11250, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:07:50', 'admin-1500606849-15006100698977494', 1, 1, 'SR', NULL, NULL, NULL),
(38933, '2017-07-21 11:37:52', NULL, NULL, 11247, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1500611801', 'admin', '2017-07-21 11:37:52', 'admin-1500606849-15006082721916015', 1, 0, '', 1, NULL, NULL),
(38934, '2017-07-21 11:37:52', NULL, NULL, 11247, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1500611801', 'admin', '2017-07-21 11:37:52', 'admin-1500606849-15006082721916015', 1, 0, '', 1, NULL, NULL),
(38935, '2017-07-21 10:32:13', NULL, NULL, 11240, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:32:13', 'admin-1500603185-15006043334168046', 1, 1, 'SR', NULL, NULL, NULL),
(38936, '2017-07-21 11:14:05', NULL, NULL, 11245, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 11:14:05', 'admin-1500603185-15006068447962282', 1, 1, 'SR', NULL, NULL, NULL),
(38937, '2017-07-21 10:11:48', NULL, NULL, 11237, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:11:48', 'admin-1500598066-15006031085005516', 1, 0, '', NULL, NULL, NULL),
(38938, '2017-07-21 10:11:48', NULL, NULL, 11237, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:11:48', 'admin-1500598066-15006031085005516', 1, 0, '', NULL, NULL, NULL),
(38939, '2017-07-21 10:12:14', NULL, NULL, 11238, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:12:14', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(38940, '2017-07-21 10:12:19', NULL, NULL, 11238, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:12:19', 'admin-1500598066-1500603139066772', 1, 0, '', NULL, NULL, '10.0'),
(38941, '2017-07-21 10:12:19', NULL, NULL, 11238, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:12:19', 'admin-1500598066-1500603139066772', 1, 1, 'SR', NULL, NULL, '10.0'),
(38942, '2017-07-21 10:12:55', NULL, NULL, 11237, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:12:55', 'admin-1500598066-15006031753598484', 1, 0, '', NULL, NULL, NULL),
(38943, '2017-07-21 10:13:42', NULL, NULL, 11237, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:13:42', 'admin-1500603185-15006032224029665', 1, 1, 'SR', NULL, NULL, NULL),
(38944, '2017-07-21 10:13:42', NULL, NULL, 11237, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:13:42', 'admin-1500603185-15006032224029665', 1, 1, 'SR', NULL, NULL, NULL),
(38945, '2017-07-21 10:16:01', NULL, NULL, 11239, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:16:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38946, '2017-07-21 10:16:20', NULL, NULL, 11239, 0, 154, '88', 'Daily Dose BLT', 'add 2 bread', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:16:20', 'admin-1500603185-15006033802223081', 1, 0, '', NULL, NULL, NULL),
(38947, '2017-07-21 13:57:10', NULL, NULL, 11262, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:57:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38948, '2017-07-21 12:35:41', NULL, NULL, 11253, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:35:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38949, '2017-07-21 13:25:18', NULL, NULL, 11259, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:25:18', 'admin-1500611801-15006147187025279', 1, 1, 'SR', NULL, NULL, NULL),
(38950, '2017-07-21 13:26:24', NULL, NULL, 11260, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:26:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38951, '2017-07-21 13:26:30', NULL, NULL, 11260, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:26:30', 'admin-1500611801-15006147904195427', 1, 0, '', NULL, NULL, NULL),
(38952, '2017-07-21 13:26:30', NULL, NULL, 11260, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:26:30', 'admin-1500611801-15006147904195427', 1, 0, '', NULL, NULL, NULL),
(38953, '2017-07-21 10:37:22', NULL, NULL, 11242, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:37:22', 'admin-1500603185-15006046421823664', 1, 1, 'SR', NULL, NULL, NULL),
(38954, '2017-07-21 12:35:53', NULL, NULL, 11253, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:35:53', 'admin-1500606849-15006117532758586', 1, 0, '', NULL, NULL, NULL),
(38955, '2017-07-21 12:34:29', NULL, NULL, 11252, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:34:29', 'admin-1500606849-15006116689756856', 1, 1, 'SR', NULL, NULL, NULL),
(38956, '2017-07-21 12:35:53', NULL, NULL, 11253, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:35:53', 'admin-1500606849-15006117532758586', 1, 1, 'SR', NULL, NULL, NULL),
(38957, '2017-07-21 12:34:29', NULL, NULL, 11252, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:34:29', 'admin-1500606849-15006116689756856', 1, 1, 'SR', NULL, NULL, NULL),
(38958, '2017-07-21 12:33:54', NULL, NULL, 11251, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:33:54', 'admin-1500606849-1500611633747268', 1, 0, '', NULL, NULL, NULL),
(38959, '2017-07-21 12:34:29', NULL, NULL, 11252, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:34:29', 'admin-1500606849-15006116689756856', 1, 0, '', NULL, NULL, NULL),
(38960, '2017-07-21 12:36:35', NULL, NULL, 11251, 0, 153, '87', 'Wake Me Up!', 'no bread', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:36:35', 'admin-1500606849-15006117957433077', 1, 0, '', NULL, NULL, NULL),
(38961, '2017-07-21 13:57:16', NULL, NULL, 11262, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:57:16', 'admin-1500611801-15006166358829078', 1, 0, '', NULL, NULL, NULL),
(38962, '2017-07-21 13:57:23', NULL, NULL, 11262, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:57:23', 'admin-1500611801-15006166430989860', 1, 0, '', NULL, NULL, NULL),
(38963, '2017-07-21 13:57:23', NULL, NULL, 11262, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:57:23', 'admin-1500611801-15006166430989860', 1, 1, 'SR', NULL, NULL, NULL),
(38964, '2017-07-21 13:58:36', NULL, NULL, 11258, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:58:36', 'admin-1500611801-1500616716666579', 1, 0, '', NULL, NULL, NULL),
(38965, '2017-07-21 12:33:54', NULL, NULL, 11251, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:33:54', 'admin-1500606849-1500611633747268', 1, 0, '', NULL, NULL, NULL),
(38966, '2017-07-21 12:33:54', NULL, NULL, 11251, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:33:54', 'admin-1500606849-1500611633747268', 1, 0, '', NULL, NULL, NULL),
(38967, '2017-07-21 10:07:51', NULL, NULL, 11235, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:07:51', 'admin-1500598066-15006028709593257', 1, 0, '', NULL, NULL, NULL),
(38968, '2017-07-21 15:23:45', NULL, NULL, 11263, 0, 217, '151', 'Spicy Lemony Wings', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 15:23:45', 'admin-1500611801-15006218252169818', 1, 0, '', 1, NULL, '10.0'),
(38969, '2017-07-21 12:33:54', NULL, NULL, 11251, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:33:54', 'admin-1500606849-1500611633747268', 1, 0, '', NULL, NULL, NULL),
(38970, '2017-07-21 12:33:54', NULL, NULL, 11251, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:33:54', 'admin-1500606849-1500611633747268', 1, 0, '', NULL, NULL, NULL),
(38971, '2017-07-21 12:33:54', NULL, NULL, 11251, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:33:54', 'admin-1500606849-1500611633747268', 1, 0, '', NULL, NULL, NULL),
(38972, '2017-07-21 12:33:54', NULL, NULL, 11251, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:33:54', 'admin-1500606849-1500611633747268', 1, 0, '', NULL, NULL, NULL),
(38973, '2017-07-21 12:33:54', NULL, NULL, 11251, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:33:54', 'admin-1500606849-1500611633747268', 1, 0, '', NULL, NULL, NULL),
(38974, '2017-07-21 12:07:44', NULL, NULL, 11250, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:07:44', 'admin-1500606849-15006100644998395', 1, 0, '', NULL, NULL, NULL),
(38975, '2017-07-21 12:33:54', NULL, NULL, 11251, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:33:54', 'admin-1500606849-1500611633747268', 1, 0, '', NULL, NULL, NULL),
(38976, '2017-07-21 12:33:54', NULL, NULL, 11251, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:33:54', 'admin-1500606849-1500611633747268', 1, 0, '', NULL, NULL, NULL),
(38977, '2017-07-21 12:35:53', NULL, NULL, 11253, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:35:53', 'admin-1500606849-15006117532758586', 1, 0, '', NULL, NULL, NULL),
(38978, '2017-07-21 10:37:22', NULL, NULL, 11242, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:37:22', 'admin-1500603185-15006046421823664', 1, 1, 'SR', NULL, NULL, NULL),
(38979, '2017-07-21 10:47:25', NULL, NULL, 11243, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:47:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38980, '2017-07-21 10:47:43', NULL, NULL, 11243, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:47:43', 'admin-1500603185-1500605263118218', 1, 0, '', NULL, NULL, NULL),
(38981, '2017-07-21 10:47:43', NULL, NULL, 11243, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:47:43', 'admin-1500603185-1500605263118218', 1, 1, 'SR', NULL, NULL, NULL),
(38982, '2017-07-21 10:47:43', NULL, NULL, 11243, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:47:43', 'admin-1500603185-1500605263118218', 1, 1, 'SR', NULL, NULL, NULL),
(38983, '2017-07-21 10:48:18', NULL, NULL, 11239, 0, 181, '116', 'Open Food ', '1 toast', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:48:18', 'admin-1500603185-15006052983084063', 1, 0, '', NULL, NULL, NULL),
(38984, '2017-07-21 11:07:37', NULL, NULL, 11244, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1500611801', 'admin', '2017-07-21 11:07:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38985, '2017-07-21 11:07:44', NULL, NULL, 11244, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 11:07:44', 'admin-1500603185-15006064639003214', 1, 0, '', NULL, NULL, NULL),
(38986, '2017-07-21 11:07:44', NULL, NULL, 11244, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 11:07:44', 'admin-1500603185-15006064639003214', 1, 1, 'SR', NULL, NULL, NULL),
(38987, '2017-07-21 13:04:24', NULL, NULL, 11255, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 13:04:24', 'admin-1500611801-15006134640665335', 1, 1, 'SR', NULL, NULL, NULL),
(38988, '2017-07-21 12:33:54', NULL, NULL, 11251, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:33:54', 'admin-1500606849-1500611633747268', 1, 0, '', NULL, NULL, NULL),
(38989, '2017-07-21 10:35:28', NULL, NULL, 11241, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:35:28', 'admin-1500603185-15006045277764250', 1, 0, '', NULL, NULL, NULL),
(38990, '2017-07-21 10:35:28', NULL, NULL, 11241, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:35:28', 'admin-1500603185-15006045277764250', 1, 1, 'SR', NULL, NULL, NULL),
(38991, '2017-07-21 10:36:57', NULL, NULL, 11242, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:36:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38992, '2017-07-21 10:37:08', NULL, NULL, 11242, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:37:08', 'admin-1500603185-1500604627806124', 1, 0, '', NULL, NULL, NULL),
(38993, '2017-07-21 10:37:08', NULL, NULL, 11242, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:37:08', 'admin-1500603185-1500604627806124', 1, 0, '', NULL, NULL, NULL),
(38994, '2017-07-21 10:37:08', NULL, NULL, 11242, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:37:08', 'admin-1500603185-1500604627806124', 1, 0, '', NULL, NULL, NULL),
(38995, '2017-07-21 12:07:44', NULL, NULL, 11250, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:07:44', 'admin-1500606849-15006100644998395', 1, 0, '', NULL, NULL, NULL),
(38996, '2017-07-21 12:05:35', NULL, NULL, 11249, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:05:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(38997, '2017-07-21 12:05:42', NULL, NULL, 11249, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:05:42', 'admin-1500606849-15006099417643776', 1, 0, '', NULL, NULL, NULL),
(38998, '2017-07-21 12:05:49', NULL, NULL, 11249, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:05:49', 'admin-1500606849-15006099494791323', 1, 1, 'SR', NULL, NULL, NULL),
(38999, '2017-07-21 12:05:49', NULL, NULL, 11249, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:05:49', 'admin-1500606849-15006099494791323', 1, 1, 'SR', NULL, NULL, NULL),
(39000, '2017-07-21 10:35:18', NULL, NULL, 11241, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:35:18', 'admin-1500603185-15006045178088865', 1, 0, '', NULL, NULL, NULL),
(39001, '2017-07-21 10:35:18', NULL, NULL, 11241, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:35:18', 'admin-1500603185-15006045178088865', 1, 0, '', NULL, NULL, NULL),
(39002, '2017-07-21 09:41:17', NULL, NULL, 11235, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 09:41:17', 'admin-1500598066-1500601277249231', 1, 1, 'SR', NULL, NULL, NULL),
(39003, '2017-07-21 12:07:36', NULL, NULL, 11250, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:07:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39004, '2017-07-21 11:47:10', NULL, NULL, 11248, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 11:47:10', 'admin-1500606849-15006088302694610', 1, 0, '', 1, NULL, NULL),
(39005, '2017-07-21 11:40:01', NULL, NULL, 11242, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 11:40:01', 'admin-1500606849-15006084010791758', 1, 0, '', NULL, NULL, NULL),
(39006, '2017-07-21 11:37:52', NULL, NULL, 11247, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1500611801', 'admin', '2017-07-21 11:37:52', 'admin-1500606849-15006082721916015', 1, 0, '', 1, NULL, NULL),
(39007, '2017-07-21 11:37:52', NULL, NULL, 11247, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1500611801', 'admin', '2017-07-21 11:37:52', 'admin-1500606849-15006082721916015', 1, 0, '', 1, NULL, NULL),
(39008, '2017-07-21 11:37:52', NULL, NULL, 11247, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1500611801', 'admin', '2017-07-21 11:37:52', 'admin-1500606849-15006082721916015', 1, 0, '', 1, NULL, NULL),
(39009, '2017-07-21 11:37:52', NULL, NULL, 11247, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 11:37:52', 'admin-1500606849-15006082721916015', 1, 0, '', 1, NULL, NULL),
(39010, '2017-07-21 11:37:52', NULL, NULL, 11247, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 11:37:52', 'admin-1500606849-15006082721916015', 1, 0, '', 1, NULL, NULL),
(39011, '2017-07-21 11:37:52', NULL, NULL, 11247, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 11:37:52', 'admin-1500606849-15006082721916015', 1, 0, '', 1, NULL, NULL),
(39012, '2017-07-21 11:18:28', NULL, NULL, 11246, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 11:18:28', 'admin-1500606849-15006071082956410', 1, 0, '', NULL, NULL, NULL),
(39013, '2017-07-21 11:18:23', NULL, NULL, 11246, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1500611801', 'admin', '2017-07-21 11:18:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39014, '2017-07-21 11:13:50', NULL, NULL, 11245, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1500611801', 'admin', '2017-07-21 11:13:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39015, '2017-07-21 11:14:05', NULL, NULL, 11245, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 11:14:05', 'admin-1500603185-15006068447962282', 1, 0, '', NULL, NULL, NULL),
(39016, '2017-07-21 11:14:05', NULL, NULL, 11245, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 11:14:05', 'admin-1500603185-15006068447962282', 1, 0, '', NULL, NULL, NULL),
(39017, '2017-07-21 11:14:05', NULL, NULL, 11245, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 11:14:05', 'admin-1500603185-15006068447962282', 1, 0, '', NULL, NULL, NULL),
(39018, '2017-07-21 12:51:10', NULL, NULL, 11254, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:51:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39019, '2017-07-21 12:34:23', NULL, NULL, 11252, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:34:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39020, '2017-07-21 10:16:20', NULL, NULL, 11239, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:16:20', 'admin-1500603185-15006033802223081', 1, 0, '', NULL, NULL, NULL),
(39021, '2017-07-21 10:37:22', NULL, NULL, 11242, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:37:22', 'admin-1500603185-15006046421823664', 1, 1, 'SR', NULL, NULL, NULL),
(39022, '2017-07-21 12:35:53', NULL, NULL, 11253, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 12:35:53', 'admin-1500606849-15006117532758586', 1, 1, 'SR', NULL, NULL, NULL),
(39023, '2017-07-21 09:33:07', NULL, NULL, 11235, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 09:33:07', 'admin-1500598066-15006007878201129', 1, 1, 'SR', NULL, NULL, NULL),
(39024, '2017-07-21 10:35:08', NULL, NULL, 11241, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:35:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39025, '2017-07-21 10:31:55', NULL, NULL, 11240, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:31:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39026, '2017-07-21 10:32:03', NULL, NULL, 11240, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:32:03', 'admin-1500603185-15006043231935540', 1, 0, '', NULL, NULL, NULL),
(39027, '2017-07-21 10:32:03', NULL, NULL, 11240, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:32:03', 'admin-1500603185-15006043231935540', 1, 0, '', NULL, NULL, NULL),
(39028, '2017-07-21 10:16:20', NULL, NULL, 11239, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:16:20', 'admin-1500603185-15006033802223081', 1, 1, 'SR', NULL, NULL, NULL),
(39029, '2017-07-21 11:14:05', NULL, NULL, 11245, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 11:14:05', 'admin-1500603185-15006068447962282', 1, 1, 'SR', NULL, NULL, NULL),
(39030, '2017-07-21 10:11:40', NULL, NULL, 11237, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:11:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39031, '2017-07-21 10:05:04', NULL, NULL, 11236, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:05:04', 'admin-1500598066-15006027039671367', 1, 1, 'SR', NULL, NULL, NULL),
(39032, '2017-07-21 10:05:04', NULL, NULL, 11236, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:05:04', 'admin-1500598066-15006027039671367', 1, 1, 'SR', NULL, NULL, NULL),
(39033, '2017-07-21 09:32:57', NULL, NULL, 11235, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1500611801', 'admin', '2017-07-21 09:32:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39034, '2017-07-21 09:33:03', NULL, NULL, 11235, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 09:33:03', 'admin-1500598066-15006007833727820', 1, 0, '', NULL, NULL, NULL),
(39035, '2017-07-21 10:04:55', NULL, NULL, 11236, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:04:55', 'admin-1500598066-15006026957567085', 1, 0, '', NULL, NULL, NULL),
(39036, '2017-07-21 10:03:57', NULL, NULL, 11236, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:03:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39037, '2017-07-21 10:04:55', NULL, NULL, 11236, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 10:04:55', 'admin-1500598066-15006026957567085', 1, 0, '', NULL, NULL, NULL),
(39038, '2017-07-21 09:33:03', NULL, NULL, 11235, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 09:33:03', 'admin-1500598066-15006007833727820', 1, 0, '', NULL, NULL, NULL),
(39039, '2017-07-21 09:26:40', NULL, NULL, 11234, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 09:26:40', 'admin-1500598066-1500600400224324', 1, 1, 'SR', NULL, NULL, NULL),
(39040, '2017-07-21 09:26:40', NULL, NULL, 11234, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 09:26:40', 'admin-1500598066-1500600400224324', 1, 1, 'SR', NULL, NULL, NULL),
(39041, '2017-07-21 09:26:34', NULL, NULL, 11234, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 09:26:34', 'admin-1500598066-15006003941097578', 1, 0, '', NULL, NULL, NULL),
(39042, '2017-07-21 09:26:34', NULL, NULL, 11234, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500611801', 'admin', '2017-07-21 09:26:34', 'admin-1500598066-15006003941097578', 1, 0, '', NULL, NULL, NULL),
(39043, '2017-07-21 09:25:25', NULL, NULL, 11234, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1500611801', 'admin', '2017-07-21 09:25:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39044, '2017-07-22 15:24:59', NULL, NULL, 11305, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:24:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39045, '2017-07-22 15:25:17', NULL, NULL, 11305, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:25:17', 'admin-1500706560-15007083176487683', 1, 1, 'SR', NULL, NULL, NULL),
(39046, '2017-07-22 18:00:01', NULL, NULL, 11321, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1500709637', 'admin', '2017-07-22 18:00:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39047, '2017-07-22 16:22:29', NULL, NULL, 11315, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:22:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39048, '2017-07-22 13:20:38', NULL, NULL, 11294, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:20:38', 'admin-1500692858-15007008384869258', 1, 0, '', NULL, NULL, NULL),
(39049, '2017-07-22 13:20:38', NULL, NULL, 11294, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:20:38', 'admin-1500692858-15007008384869258', 1, 1, 'SR', NULL, NULL, NULL),
(39050, '2017-07-22 13:20:38', NULL, NULL, 11294, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:20:38', 'admin-1500692858-15007008384869258', 1, 1, 'SR', NULL, NULL, NULL),
(39051, '2017-07-22 13:20:38', NULL, NULL, 11294, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:20:38', 'admin-1500692858-15007008384869258', 1, 0, '', NULL, NULL, NULL),
(39052, '2017-07-22 11:03:42', NULL, NULL, 11279, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:03:42', 'admin-1500691734-15006926227999471', 1, 0, '', NULL, NULL, NULL),
(39053, '2017-07-22 12:05:42', NULL, NULL, 11291, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 12:05:42', 'admin-1500692858-15006963427457274', 1, 1, 'SR', NULL, NULL, NULL),
(39054, '2017-07-22 12:23:44', NULL, NULL, 11292, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1500709637', 'admin', '2017-07-22 12:23:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39055, '2017-07-22 16:00:29', NULL, NULL, 11311, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:00:29', 'admin-1500709637-15007104297391441', 1, 0, '', 1, NULL, NULL),
(39056, '2017-07-22 14:15:05', NULL, NULL, 11299, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:15:05', 'admin-1500702063-15007041054116197', 1, 1, 'SR', NULL, NULL, NULL),
(39057, '2017-07-22 17:48:50', NULL, NULL, 11320, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1500709637', 'admin', '2017-07-22 17:48:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39058, '2017-07-22 17:48:57', NULL, NULL, 11320, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 17:48:57', 'admin-1500709637-1500716937240117', 1, 0, '', NULL, NULL, NULL),
(39059, '2017-07-22 17:48:57', NULL, NULL, 11320, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 17:48:57', 'admin-1500709637-1500716937240117', 1, 1, 'SR', NULL, NULL, NULL),
(39060, '2017-07-22 00:00:00', NULL, NULL, 11321, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:20:32', 'admin-1500709637-15007116321518759', 1, 1, 'SR', NULL, NULL, NULL),
(39061, '2017-07-22 15:47:13', NULL, NULL, 11309, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:47:13', 'admin-1500706560-15007096335368451', 1, 0, '', NULL, NULL, NULL),
(39062, '2017-07-22 15:44:00', NULL, NULL, 11308, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:44:00', 'admin-1500706560-15007094403839890', 1, 1, 'SR', 1, NULL, NULL),
(39063, '2017-07-22 15:44:33', NULL, NULL, 11303, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:44:33', 'admin-1500706560-15007094731839549', 1, 1, 'SR', NULL, NULL, NULL),
(39064, '2017-07-22 00:00:00', NULL, NULL, 11290, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, NULL, NULL, 0.60, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:47:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39065, '2017-07-22 00:00:00', NULL, NULL, 11289, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:47:28', 'admin-1500691627-1500691648235195', 1, 1, 'SR', NULL, NULL, NULL),
(39066, '2017-07-22 15:47:41', NULL, NULL, 11309, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:47:41', 'admin-1500709637-15007096611309345', 1, 1, 'SR', NULL, NULL, NULL),
(39067, '2017-07-22 13:20:24', NULL, NULL, 11293, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:20:24', 'admin-1500692858-15007008240961558', 1, 1, 'SR', NULL, NULL, NULL),
(39068, '2017-07-22 13:13:14', NULL, NULL, 11293, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:13:14', 'admin-1500692858-15007003941019278', 1, 1, 'SR', NULL, NULL, NULL),
(39069, '2017-07-22 11:30:08', NULL, NULL, 11283, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:30:08', 'admin-1500692858-15006942078983379', 1, 0, '', NULL, NULL, NULL),
(39070, '2017-07-22 00:00:00', NULL, NULL, 11323, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:47:41', 'admin-1500709637-15007096611309345', 1, 1, 'SR', NULL, NULL, NULL),
(39071, '2017-07-22 00:00:00', NULL, NULL, 11322, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:20:32', 'admin-1500709637-15007116321518759', 1, 0, '', NULL, NULL, NULL),
(39072, '2017-07-22 16:22:52', NULL, NULL, 11315, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:22:52', 'admin-1500709637-15007117723515797', 1, 1, 'SR', NULL, NULL, NULL),
(39073, '2017-07-22 16:23:55', NULL, NULL, 11316, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:23:55', 'admin-1500709637-15007118353934924', 1, 1, 'SR', 1, NULL, NULL),
(39074, '2017-07-22 16:23:55', NULL, NULL, 11316, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:23:55', 'admin-1500709637-15007118353934924', 1, 1, 'SR', 1, NULL, NULL),
(39075, '2017-07-22 16:34:35', NULL, NULL, 11317, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:34:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39076, '2017-07-22 16:34:41', NULL, NULL, 11317, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:34:41', 'admin-1500709637-15007124809877573', 1, 1, 'SR', NULL, NULL, NULL),
(39077, '2017-07-22 18:05:50', NULL, NULL, 11320, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 18:05:50', 'admin-1500709637-1500717950258449', 1, 1, 'SR', NULL, NULL, NULL),
(39078, '2017-07-22 00:00:00', NULL, NULL, 11323, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:47:13', 'admin-1500706560-15007096335368451', 1, 0, '', NULL, NULL, NULL),
(39079, '2017-07-22 16:03:12', NULL, NULL, 11312, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:03:12', 'admin-1500709637-15007105922533649', 1, 1, 'SR', NULL, NULL, '10.0');
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(39080, '2017-07-22 15:07:41', NULL, NULL, 11303, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:07:41', 'admin-1500706560-15007072611026198', 1, 0, '', NULL, NULL, NULL),
(39081, '2017-07-22 13:13:14', NULL, NULL, 11293, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:13:14', 'admin-1500692858-15007003941019278', 1, 0, '', NULL, NULL, NULL),
(39082, '2017-07-22 17:42:56', NULL, NULL, 11319, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 17:42:56', 'admin-1500709637-15007165757912916', 1, 1, 'SR', NULL, NULL, NULL),
(39083, '2017-07-22 17:42:56', NULL, NULL, 11319, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 17:42:56', 'admin-1500709637-15007165757912916', 1, 0, '', NULL, NULL, NULL),
(39084, '2017-07-22 17:42:56', NULL, NULL, 11319, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 17:42:56', 'admin-1500709637-15007165757912916', 1, 0, '', NULL, NULL, NULL),
(39085, '2017-07-22 16:18:21', NULL, NULL, 11314, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:18:21', 'admin-1500709637-15007115014894657', 1, 1, 'SR', NULL, NULL, NULL),
(39086, '2017-07-22 17:42:56', NULL, NULL, 11319, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 17:42:56', 'admin-1500709637-15007165757912916', 1, 1, 'SR', NULL, NULL, NULL),
(39087, '2017-07-22 17:42:42', NULL, NULL, 11319, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1500709637', 'admin', '2017-07-22 17:42:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39088, '2017-07-22 17:27:51', NULL, NULL, 11318, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 17:27:51', 'admin-1500709637-15007156714512585', 1, 1, 'SR', NULL, NULL, '10.0'),
(39089, '2017-07-22 17:28:52', NULL, NULL, 11318, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 17:28:52', 'admin-1500709637-15007157322861245', 1, 0, '', NULL, NULL, '10.0'),
(39090, '2017-07-22 13:52:08', NULL, NULL, 11296, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:52:08', 'admin-1500702063-15007027284016255', 1, 0, '', NULL, NULL, NULL),
(39091, '2017-07-22 12:24:02', NULL, NULL, 11292, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 12:24:02', 'admin-1500692858-15006974422189338', 1, 1, 'SR', NULL, NULL, NULL),
(39092, '2017-07-22 16:18:21', NULL, NULL, 11314, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:18:21', 'admin-1500709637-15007115014894657', 1, 0, '', NULL, NULL, NULL),
(39093, '2017-07-22 16:18:21', NULL, NULL, 11314, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:18:21', 'admin-1500709637-15007115014894657', 1, 1, 'SR', NULL, NULL, NULL),
(39094, '2017-07-22 16:18:21', NULL, NULL, 11314, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:18:21', 'admin-1500709637-15007115014894657', 1, 1, 'SR', NULL, NULL, NULL),
(39095, '2017-07-22 17:27:46', NULL, NULL, 11318, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1500709637', 'admin', '2017-07-22 17:27:46', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(39096, '2017-07-22 16:10:08', NULL, NULL, 11313, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:10:08', 'admin-1500709637-15007110083403494', 1, 1, 'SR', NULL, NULL, NULL),
(39097, '2017-07-22 16:22:43', NULL, NULL, 11315, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:22:43', 'admin-1500709637-15007117633868935', 1, 1, 'SR', NULL, NULL, NULL),
(39098, '2017-07-22 18:00:50', NULL, NULL, 11322, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1500709637', 'admin', '2017-07-22 18:00:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39099, '2017-07-22 16:04:59', NULL, NULL, 11310, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:04:59', 'admin-1500709637-15007106989238591', 1, 0, '', NULL, NULL, NULL),
(39100, '2017-07-22 16:10:04', NULL, NULL, 11313, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:10:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39101, '2017-07-22 14:08:36', NULL, NULL, 11298, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:08:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39102, '2017-07-22 14:08:50', NULL, NULL, 11298, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:08:50', 'admin-1500702063-15007037300784084', 1, 1, 'SR', NULL, NULL, NULL),
(39103, '2017-07-22 14:10:04', NULL, NULL, 11295, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:10:04', 'admin-1500702063-15007038043487972', 1, 1, 'SR', NULL, NULL, '10.0'),
(39104, '2017-07-22 14:14:32', NULL, NULL, 11299, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:14:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39105, '2017-07-22 14:14:46', NULL, NULL, 11299, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:14:46', 'admin-1500702063-15007040865976918', 1, 0, '', NULL, NULL, NULL),
(39106, '2017-07-22 14:14:46', NULL, NULL, 11299, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:14:46', 'admin-1500702063-15007040865976918', 1, 0, '', NULL, NULL, NULL),
(39107, '2017-07-22 13:13:14', NULL, NULL, 11293, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:13:14', 'admin-1500692858-15007003941019278', 1, 0, '', NULL, NULL, NULL),
(39108, '2017-07-22 13:13:14', NULL, NULL, 11293, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:13:14', 'admin-1500692858-15007003941019278', 1, 1, 'SR', NULL, NULL, NULL),
(39109, '2017-07-22 12:04:39', NULL, NULL, 11288, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 12:04:39', 'admin-1500692858-1500696278987487', 1, 1, 'SR', NULL, NULL, '10.0'),
(39110, '2017-07-22 12:04:39', NULL, NULL, 11288, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 12:04:39', 'admin-1500692858-1500696278987487', 1, 1, 'SR', NULL, NULL, '10.0'),
(39111, '2017-07-22 10:38:05', NULL, NULL, 11274, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:38:05', 'admin-1500690447-15006910857143275', 1, 0, '', NULL, NULL, NULL),
(39112, '2017-07-22 18:01:50', NULL, NULL, 11323, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1500709637', 'admin', '2017-07-22 18:01:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39113, '2017-07-22 15:48:07', NULL, NULL, 11303, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:48:07', 'admin-1500709637-1500709687214388', 1, 0, '', NULL, NULL, NULL),
(39114, '2017-07-22 00:00:00', NULL, NULL, 11307, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, NULL, NULL, 2.20, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:29:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39115, '2017-07-22 00:00:00', NULL, NULL, 11307, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:29:42', 'admin-1500702063-15007049820882211', 1, 0, '', NULL, NULL, NULL),
(39116, '2017-07-22 00:00:00', NULL, NULL, 11306, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:29:42', 'admin-1500702063-15007049820882211', 1, 0, '', NULL, NULL, NULL),
(39117, '2017-07-22 14:52:23', NULL, NULL, 11302, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.20, 0.0000, 0.0000, 9.20, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:52:23', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(39118, '2017-07-22 14:52:36', NULL, NULL, 11302, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:52:36', 'admin-1500702063-15007063566835036', 1, 1, 'SR', NULL, NULL, '10.0'),
(39119, '2017-07-22 16:02:53', NULL, NULL, 11312, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:02:53', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(39120, '2017-07-22 16:00:29', NULL, NULL, 11311, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:00:29', 'admin-1500709637-15007104297391441', 1, 0, '', 1, NULL, NULL),
(39121, '2017-07-22 15:50:09', NULL, NULL, 11310, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:50:09', 'admin-1500709637-1500709809397267', 1, 1, 'SR', NULL, NULL, NULL),
(39122, '2017-07-22 12:24:02', NULL, NULL, 11292, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 12:24:02', 'admin-1500692858-15006974422189338', 1, 1, 'SR', NULL, NULL, NULL),
(39123, '2017-07-22 00:00:00', NULL, NULL, 11307, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:29:42', 'admin-1500702063-15007049820882211', 1, 1, 'SR', NULL, NULL, NULL),
(39124, '2017-07-22 15:50:03', NULL, NULL, 11310, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:50:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39125, '2017-07-22 15:15:31', NULL, NULL, 11304, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:15:31', 'admin-1500706560-15007077312557248', 1, 0, '', NULL, NULL, NULL),
(39126, '2017-07-22 15:15:31', NULL, NULL, 11304, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:15:31', 'admin-1500706560-15007077312557248', 1, 0, '', NULL, NULL, NULL),
(39127, '2017-07-22 15:25:17', NULL, NULL, 11305, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:25:17', 'admin-1500706560-15007083176487683', 1, 1, 'SR', NULL, NULL, NULL),
(39128, '2017-07-22 10:32:10', NULL, NULL, 11273, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:32:10', 'admin-1500690447-1500690730710827', 1, 1, 'SR', NULL, NULL, '10.0'),
(39129, '2017-07-22 10:37:31', NULL, NULL, 11274, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:37:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39130, '2017-07-22 10:37:44', NULL, NULL, 11274, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:37:44', 'admin-1500690447-15006910638873512', 1, 0, '', NULL, NULL, NULL),
(39131, '2017-07-22 09:54:06', NULL, NULL, 11268, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:54:06', 'admin-1500684602-1500688446504868', 1, 1, 'SR', NULL, NULL, NULL),
(39132, '2017-07-22 09:59:33', NULL, NULL, 11269, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:59:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39133, '2017-07-22 10:00:07', NULL, NULL, 11269, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:00:07', 'admin-1500684602-15006888072291493', 1, 0, '', NULL, NULL, NULL),
(39134, '2017-07-22 10:00:07', NULL, NULL, 11269, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:00:07', 'admin-1500684602-15006888072291493', 1, 0, '', NULL, NULL, NULL),
(39135, '2017-07-22 10:00:07', NULL, NULL, 11269, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:00:07', 'admin-1500684602-15006888072291493', 1, 0, '', NULL, NULL, NULL),
(39136, '2017-07-22 10:00:53', NULL, NULL, 11269, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:00:53', 'admin-1500684602-15006888536622981', 1, 1, 'SR', NULL, NULL, NULL),
(39137, '2017-07-22 10:01:07', NULL, NULL, 11269, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:01:07', 'admin-1500684602-15006888675696725', 1, 1, 'SR', NULL, NULL, NULL),
(39138, '2017-07-22 10:01:55', NULL, NULL, 11270, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:01:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39139, '2017-07-22 10:02:16', NULL, NULL, 11270, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:02:16', 'admin-1500684602-15006889362707380', 1, 1, 'SR', NULL, NULL, NULL),
(39140, '2017-07-22 10:02:16', NULL, NULL, 11270, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:02:16', 'admin-1500684602-15006889362707380', 1, 1, 'SR', NULL, NULL, NULL),
(39141, '2017-07-22 10:02:16', NULL, NULL, 11270, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:02:16', 'admin-1500684602-15006889362707380', 1, 0, '', NULL, NULL, NULL),
(39142, '2017-07-22 10:02:16', NULL, NULL, 11270, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:02:16', 'admin-1500684602-15006889362707380', 1, 0, '', NULL, NULL, NULL),
(39143, '2017-07-22 15:47:04', NULL, NULL, 11309, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:47:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39144, '2017-07-22 15:12:35', NULL, NULL, 11303, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:12:35', 'admin-1500706560-15007075554174954', 1, 1, 'SR', NULL, NULL, NULL),
(39145, '2017-07-22 14:56:14', NULL, NULL, 11302, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:56:14', 'admin-1500706560-15007065739513139', 1, 1, 'SR', NULL, NULL, '10.0'),
(39146, '2017-07-22 14:56:14', NULL, NULL, 11302, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:56:14', 'admin-1500706560-15007065739513139', 1, 1, 'SR', NULL, NULL, '10.0'),
(39147, '2017-07-22 14:56:14', NULL, NULL, 11302, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:56:14', 'admin-1500706560-15007065739513139', 1, 1, 'SR', NULL, NULL, '10.0'),
(39148, '2017-07-22 00:00:00', NULL, NULL, 11306, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:29:42', 'admin-1500702063-15007049820882211', 1, 1, 'SR', NULL, NULL, NULL),
(39149, '2017-07-22 15:22:43', NULL, NULL, 11304, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:22:43', 'admin-1500706560-15007081637309336', 1, 1, 'SR', NULL, NULL, NULL),
(39150, '2017-07-22 14:52:36', NULL, NULL, 11302, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:52:36', 'admin-1500702063-15007063566835036', 1, 0, '', NULL, NULL, '10.0'),
(39151, '2017-07-22 15:15:31', NULL, NULL, 11304, 0, 72, '72', 'Mushroom Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:15:31', 'admin-1500706560-15007077312557248', 1, 1, 'SR', NULL, NULL, NULL),
(39152, '2017-07-22 15:14:39', NULL, NULL, 11304, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:14:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39153, '2017-07-22 15:06:21', NULL, NULL, 11303, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:06:21', 'admin-1500706560-1500707181413114', 1, 0, '', NULL, NULL, NULL),
(39154, '2017-07-22 13:38:34', NULL, NULL, 11295, 0, 181, '116', 'Open Food ', 'Sweet corn chicken', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:38:34', 'admin-1500692858-15007019146461780', 1, 0, '', NULL, NULL, '10.0'),
(39155, '2017-07-22 13:38:34', NULL, NULL, 11295, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:38:34', 'admin-1500692858-15007019146461780', 1, 0, '', NULL, NULL, '10.0'),
(39156, '2017-07-22 13:39:17', NULL, NULL, 11295, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:39:17', 'admin-1500692858-15007019575381347', 1, 1, 'SR', NULL, NULL, '10.0'),
(39157, '2017-07-22 13:39:33', NULL, NULL, 11295, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:39:33', 'admin-1500692858-15007019731541548', 1, 1, 'SR', NULL, NULL, '10.0'),
(39158, '2017-07-22 13:41:18', NULL, NULL, 11295, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:41:18', 'admin-1500702063-15007020783159175', 1, 1, 'SR', NULL, NULL, '10.0'),
(39159, '2017-07-22 14:15:05', NULL, NULL, 11299, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:15:05', 'admin-1500702063-15007041054116197', 1, 1, 'SR', NULL, NULL, NULL),
(39160, '2017-07-22 14:16:31', NULL, NULL, 11300, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:16:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39161, '2017-07-22 14:16:34', NULL, NULL, 11300, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:16:34', 'admin-1500702063-15007041946568614', 1, 0, '', NULL, NULL, NULL),
(39162, '2017-07-22 10:26:50', NULL, NULL, 11272, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:26:50', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(39163, '2017-07-22 10:16:34', NULL, NULL, 11271, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:16:34', 'admin-1500684602-15006897945339225', 1, 0, '', NULL, NULL, NULL),
(39164, '2017-07-22 15:13:18', NULL, NULL, 11303, 0, 181, '116', 'Open Food ', 'fries', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:13:18', 'admin-1500706560-1500707597931108', 1, 0, '', NULL, NULL, NULL),
(39165, '2017-07-22 10:46:33', NULL, NULL, 11273, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:46:33', 'admin-1500690447-15006915930452668', 1, 0, '', NULL, NULL, '10.0'),
(39166, '2017-07-22 13:52:33', NULL, NULL, 11296, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:52:33', 'admin-1500702063-1500702753164775', 1, 0, '', NULL, NULL, NULL),
(39167, '2017-07-22 13:52:33', NULL, NULL, 11296, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:52:33', 'admin-1500702063-1500702753164775', 1, 0, '', NULL, NULL, NULL),
(39168, '2017-07-22 12:05:09', NULL, NULL, 11291, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1500709637', 'admin', '2017-07-22 12:05:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39169, '2017-07-22 12:05:27', NULL, NULL, 11291, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 12:05:27', 'admin-1500692858-15006963275495010', 1, 0, '', NULL, NULL, NULL),
(39170, '2017-07-22 00:00:00', NULL, NULL, 11290, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, NULL, NULL, 6.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:10:51', 'admin-1500692858-15006930516746375', 1, 1, 'SR', NULL, NULL, NULL),
(39171, '2017-07-22 11:55:36', NULL, NULL, 11287, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:55:36', 'admin-1500692858-15006957360834986', 1, 0, '', NULL, NULL, NULL),
(39172, '2017-07-22 11:15:41', NULL, NULL, 11282, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:15:41', 'admin-1500692858-1500693341251932', 1, 1, 'SR', NULL, NULL, NULL),
(39173, '2017-07-22 15:07:41', NULL, NULL, 11303, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:07:41', 'admin-1500706560-15007072611026198', 1, 0, '', NULL, NULL, NULL),
(39174, '2017-07-22 11:11:05', NULL, NULL, 11281, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:11:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39175, '2017-07-22 11:11:25', NULL, NULL, 11281, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:11:25', 'admin-1500692858-15006930858118393', 1, 0, '', NULL, NULL, NULL),
(39176, '2017-07-22 15:07:41', NULL, NULL, 11303, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:07:41', 'admin-1500706560-15007072611026198', 1, 1, 'SR', NULL, NULL, NULL),
(39177, '2017-07-22 15:06:21', NULL, NULL, 11303, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:06:21', 'admin-1500706560-1500707181413114', 1, 0, '', NULL, NULL, NULL),
(39178, '2017-07-22 00:00:00', NULL, NULL, 11289, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:10:51', 'admin-1500692858-15006930516746375', 1, 0, '', NULL, NULL, NULL),
(39179, '2017-07-22 11:56:43', NULL, NULL, 11288, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:56:43', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(39180, '2017-07-22 11:56:58', NULL, NULL, 11288, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:56:58', 'admin-1500692858-15006958183716293', 1, 0, '', NULL, NULL, '10.0'),
(39181, '2017-07-22 11:56:58', NULL, NULL, 11288, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:56:58', 'admin-1500692858-15006958183716293', 1, 1, 'SR', NULL, NULL, '10.0'),
(39182, '2017-07-22 11:55:44', NULL, NULL, 11287, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:55:44', 'admin-1500692858-15006957437869372', 1, 1, 'SR', NULL, NULL, NULL),
(39183, '2017-07-22 14:55:56', NULL, NULL, 11302, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:55:56', 'admin-1500702063-1500706556458796', 1, 1, 'SR', NULL, NULL, '10.0'),
(39184, '2017-07-22 11:55:44', NULL, NULL, 11287, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:55:44', 'admin-1500692858-15006957437869372', 1, 0, '', NULL, NULL, NULL),
(39185, '2017-07-22 16:00:29', NULL, NULL, 11311, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:00:29', 'admin-1500709637-15007104297391441', 1, 0, '', 1, NULL, NULL),
(39186, '2017-07-22 14:55:56', NULL, NULL, 11302, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:55:56', 'admin-1500702063-1500706556458796', 1, 0, '', NULL, NULL, '10.0'),
(39187, '2017-07-22 16:03:12', NULL, NULL, 11312, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:03:12', 'admin-1500709637-15007105922533649', 1, 0, '', NULL, NULL, '10.0'),
(39188, '2017-07-22 11:42:08', NULL, NULL, 11286, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:42:08', 'admin-1500692858-1500694928501332', 1, 0, '', NULL, NULL, NULL),
(39189, '2017-07-22 11:42:08', NULL, NULL, 11286, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:42:08', 'admin-1500692858-1500694928501332', 1, 0, '', NULL, NULL, NULL),
(39190, '2017-07-22 15:26:58', NULL, NULL, 11306, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:26:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39191, '2017-07-22 00:00:00', NULL, NULL, 11306, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:29:42', 'admin-1500702063-15007049820882211', 1, 1, 'SR', NULL, NULL, NULL),
(39192, '2017-07-22 13:45:49', NULL, NULL, 11293, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:45:49', 'admin-1500702063-15007023497041620', 1, 0, '', NULL, NULL, NULL),
(39193, '2017-07-22 13:45:49', NULL, NULL, 11293, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:45:49', 'admin-1500702063-15007023497041620', 1, 0, '', NULL, NULL, NULL),
(39194, '2017-07-22 11:55:36', NULL, NULL, 11287, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:55:36', 'admin-1500692858-15006957360834986', 1, 0, '', NULL, NULL, NULL),
(39195, '2017-07-22 11:55:24', NULL, NULL, 11287, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:55:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39196, '2017-07-22 11:55:36', NULL, NULL, 11287, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:55:36', 'admin-1500692858-15006957360834986', 1, 1, 'SR', NULL, NULL, NULL),
(39197, '2017-07-22 14:01:35', NULL, NULL, 11297, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:01:35', 'admin-1500702063-1500703295346792', 1, 1, 'SR', NULL, NULL, NULL),
(39198, '2017-07-22 09:54:01', NULL, NULL, 11268, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:54:01', 'admin-1500684602-15006884409851729', 1, 0, '', NULL, NULL, NULL),
(39199, '2017-07-22 13:45:49', NULL, NULL, 11293, 0, 270, '204', 'Homemade Savoury Pancake', 'no bacon change sausage', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:45:49', 'admin-1500702063-15007023497041620', 1, 0, '', NULL, NULL, NULL),
(39200, '2017-07-22 13:45:49', NULL, NULL, 11293, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:45:49', 'admin-1500702063-15007023497041620', 1, 1, 'SR', NULL, NULL, NULL),
(39201, '2017-07-22 13:45:49', NULL, NULL, 11293, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:45:49', 'admin-1500702063-15007023497041620', 1, 0, '', NULL, NULL, NULL),
(39202, '2017-07-22 13:46:03', NULL, NULL, 11293, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:46:03', 'admin-1500702063-15007023637797413', 1, 1, 'SR', NULL, NULL, NULL),
(39203, '2017-07-22 14:01:26', NULL, NULL, 11297, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:01:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39204, '2017-07-22 14:01:35', NULL, NULL, 11297, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:01:35', 'admin-1500702063-1500703295346792', 1, 0, '', NULL, NULL, NULL),
(39205, '2017-07-22 13:52:08', NULL, NULL, 11296, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:52:08', 'admin-1500702063-15007027284016255', 1, 0, '', NULL, NULL, NULL),
(39206, '2017-07-22 13:13:00', NULL, NULL, 11293, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.30, 0.0000, 0.0000, 14.30, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:13:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39207, '2017-07-22 16:17:33', NULL, NULL, 11314, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:17:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39208, '2017-07-22 13:20:26', NULL, NULL, 11294, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:20:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39209, '2017-07-22 11:41:54', NULL, NULL, 11286, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:41:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39210, '2017-07-22 00:00:00', NULL, NULL, 11284, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:10:51', 'admin-1500692858-15006930516746375', 1, 1, 'SR', NULL, NULL, NULL),
(39211, '2017-07-22 11:30:08', NULL, NULL, 11283, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:30:08', 'admin-1500692858-15006942078983379', 1, 0, '', NULL, NULL, NULL),
(39212, '2017-07-22 11:29:52', NULL, NULL, 11283, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:29:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39213, '2017-07-22 11:15:41', NULL, NULL, 11282, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:15:41', 'admin-1500692858-1500693341251932', 1, 0, '', NULL, NULL, NULL),
(39214, '2017-07-22 11:15:41', NULL, NULL, 11282, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:15:41', 'admin-1500692858-1500693341251932', 1, 0, '', NULL, NULL, NULL),
(39215, '2017-07-22 11:15:19', NULL, NULL, 11282, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:15:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39216, '2017-07-22 11:15:41', NULL, NULL, 11282, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:15:41', 'admin-1500692858-1500693341251932', 1, 0, '', NULL, NULL, NULL),
(39217, '2017-07-22 13:43:44', NULL, NULL, 11295, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:43:44', 'admin-1500702063-15007022244477686', 1, 1, 'SR', NULL, NULL, '10.0'),
(39218, '2017-07-22 13:38:18', NULL, NULL, 11295, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.80, 0.0000, 0.0000, 9.80, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:38:18', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(39219, '2017-07-22 10:16:16', NULL, NULL, 11271, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:16:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39220, '2017-07-22 12:05:27', NULL, NULL, 11291, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 12:05:27', 'admin-1500692858-15006963275495010', 1, 0, '', NULL, NULL, NULL),
(39221, '2017-07-22 11:11:26', NULL, NULL, 11281, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:11:26', 'admin-1500692858-15006930858118393', 1, 1, 'SR', NULL, NULL, NULL),
(39222, '2017-07-22 10:16:34', NULL, NULL, 11271, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:16:34', 'admin-1500684602-15006897945339225', 1, 1, 'SR', NULL, NULL, NULL),
(39223, '2017-07-22 10:16:34', NULL, NULL, 11271, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:16:34', 'admin-1500684602-15006897945339225', 1, 1, 'SR', NULL, NULL, NULL),
(39224, '2017-07-22 10:16:34', NULL, NULL, 11271, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:16:34', 'admin-1500684602-15006897945339225', 1, 1, 'SR', NULL, NULL, NULL),
(39225, '2017-07-22 10:27:20', NULL, NULL, 11272, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:27:20', 'admin-1500684602-15006904399475716', 1, 0, '', NULL, NULL, '10.0'),
(39226, '2017-07-22 10:45:53', NULL, NULL, 11272, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:45:53', 'admin-1500690447-15006915537496065', 1, 0, '', NULL, NULL, '10.0'),
(39227, '2017-07-22 10:27:20', NULL, NULL, 11272, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:27:20', 'admin-1500684602-15006904399475716', 1, 1, 'SR', NULL, NULL, '10.0'),
(39228, '2017-07-22 10:27:20', NULL, NULL, 11272, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:27:20', 'admin-1500684602-15006904399475716', 1, 0, '', NULL, NULL, '10.0'),
(39229, '2017-07-22 10:31:43', NULL, NULL, 11273, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:31:43', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(39230, '2017-07-22 10:32:10', NULL, NULL, 11273, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:32:10', 'admin-1500690447-1500690730710827', 1, 0, '', NULL, NULL, '10.0'),
(39231, '2017-07-22 13:52:01', NULL, NULL, 11296, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1500709637', 'admin', '2017-07-22 13:52:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39232, '2017-07-22 11:11:25', NULL, NULL, 11281, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:11:26', 'admin-1500692858-15006930858118393', 1, 0, '', NULL, NULL, NULL),
(39233, '2017-07-22 11:11:26', NULL, NULL, 11281, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:11:26', 'admin-1500692858-15006930858118393', 1, 1, 'SR', NULL, NULL, NULL),
(39234, '2017-07-22 11:03:43', NULL, NULL, 11279, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:03:43', 'admin-1500691734-15006926227999471', 1, 1, 'SR', NULL, NULL, NULL),
(39235, '2017-07-22 11:09:26', NULL, NULL, 11280, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:09:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39236, '2017-07-22 11:10:22', NULL, NULL, 11280, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:10:22', 'admin-1500692858-15006930227384280', 1, 0, '', NULL, NULL, NULL),
(39237, '2017-07-22 11:10:22', NULL, NULL, 11280, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:10:22', 'admin-1500692858-15006930227384280', 1, 0, '', NULL, NULL, NULL),
(39238, '2017-07-22 11:10:22', NULL, NULL, 11280, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:10:22', 'admin-1500692858-15006930227384280', 1, 1, 'SR', NULL, NULL, NULL),
(39239, '2017-07-22 11:10:22', NULL, NULL, 11280, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:10:22', 'admin-1500692858-15006930227384280', 1, 0, '', NULL, NULL, NULL),
(39240, '2017-07-22 00:00:00', NULL, NULL, 11284, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:47:28', 'admin-1500691627-1500691648235195', 1, 0, '', NULL, NULL, NULL),
(39241, '2017-07-22 00:00:00', NULL, NULL, 11285, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:47:28', 'admin-1500691627-1500691648235195', 1, 1, 'SR', NULL, NULL, NULL),
(39242, '2017-07-22 11:37:25', NULL, NULL, 11285, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:37:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39243, '2017-07-22 10:40:51', NULL, NULL, 11275, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:40:51', 'admin-1500690447-15006912511711221', 1, 0, '', NULL, NULL, NULL),
(39244, '2017-07-22 00:00:00', NULL, NULL, 11285, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:47:28', 'admin-1500691627-1500691648235195', 1, 0, '', NULL, NULL, NULL),
(39245, '2017-07-22 12:01:39', NULL, NULL, 11289, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1500709637', 'admin', '2017-07-22 12:01:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39246, '2017-07-22 11:36:49', NULL, NULL, 11284, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:36:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39247, '2017-07-22 11:03:43', NULL, NULL, 11279, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:03:43', 'admin-1500691734-15006926227999471', 1, 0, '', NULL, NULL, NULL),
(39248, '2017-07-22 11:02:55', NULL, NULL, 11279, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1500709637', 'admin', '2017-07-22 11:02:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39249, '2017-07-22 10:53:10', NULL, NULL, 11278, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:53:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39250, '2017-07-22 10:53:33', NULL, NULL, 11278, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:53:33', 'admin-1500691734-1500692012951223', 1, 0, '', NULL, NULL, NULL),
(39251, '2017-07-22 10:53:33', NULL, NULL, 11278, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:53:33', 'admin-1500691734-1500692012951223', 1, 0, '', NULL, NULL, NULL),
(39252, '2017-07-22 10:53:33', NULL, NULL, 11278, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:53:33', 'admin-1500691734-1500692012951223', 1, 0, '', NULL, NULL, NULL),
(39253, '2017-07-22 10:53:47', NULL, NULL, 11278, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:53:47', 'admin-1500691734-1500692027685798', 1, 1, 'SR', NULL, NULL, NULL),
(39254, '2017-07-22 10:53:47', NULL, NULL, 11278, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:53:47', 'admin-1500691734-1500692027685798', 1, 1, 'SR', NULL, NULL, NULL),
(39255, '2017-07-22 10:52:03', NULL, NULL, 11277, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:52:03', 'admin-1500691734-15006919233362297', 1, 0, '', NULL, NULL, NULL),
(39256, '2017-07-22 10:52:03', NULL, NULL, 11277, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:52:03', 'admin-1500691734-15006919233362297', 1, 0, '', NULL, NULL, NULL),
(39257, '2017-07-22 10:52:03', NULL, NULL, 11277, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:52:03', 'admin-1500691734-15006919233362297', 1, 0, '', NULL, NULL, NULL),
(39258, '2017-07-22 10:51:50', NULL, NULL, 11277, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:51:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39259, '2017-07-22 09:52:27', NULL, NULL, 11264, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:52:27', 'admin-1500684602-15006883470557437', 1, 1, 'SR', NULL, NULL, NULL),
(39260, '2017-07-22 09:52:27', NULL, NULL, 11264, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:52:27', 'admin-1500684602-15006883470557437', 1, 0, '', NULL, NULL, NULL),
(39261, '2017-07-22 09:53:50', NULL, NULL, 11268, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:53:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39262, '2017-07-22 10:02:16', NULL, NULL, 11270, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:02:16', 'admin-1500684602-15006889362707380', 1, 0, '', NULL, NULL, NULL),
(39263, '2017-07-22 10:40:51', NULL, NULL, 11275, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:40:51', 'admin-1500690447-15006912511711221', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(39264, '2017-07-22 10:40:21', NULL, NULL, 11275, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:40:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39265, '2017-07-22 10:38:16', NULL, NULL, 11274, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:38:16', 'admin-1500690447-15006910966414327', 1, 1, 'SR', NULL, NULL, NULL),
(39266, '2017-07-22 10:37:44', NULL, NULL, 11274, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:37:44', 'admin-1500690447-15006910638873512', 1, 0, '', NULL, NULL, NULL),
(39267, '2017-07-22 00:00:00', NULL, NULL, 11321, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 16:21:31', 'admin-1500709637-15007116915304369', 1, 0, '', NULL, NULL, NULL),
(39268, '2017-07-22 10:32:10', NULL, NULL, 11273, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:32:10', 'admin-1500690447-1500690730710827', 1, 1, 'SR', NULL, NULL, '10.0'),
(39269, '2017-07-22 15:06:12', NULL, NULL, 11303, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.80, 0.0000, 0.0000, 11.80, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:06:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39270, '2017-07-22 10:46:33', NULL, NULL, 11273, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 10:46:33', 'admin-1500690447-15006915930452668', 1, 0, '', NULL, NULL, '10.0'),
(39271, '2017-07-22 14:52:36', NULL, NULL, 11302, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 14:52:36', 'admin-1500702063-15007063566835036', 1, 0, '', NULL, NULL, '10.0'),
(39272, '2017-07-22 09:33:06', NULL, NULL, 11264, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:33:06', 'admin-1500684602-15006871867413369', 1, 1, 'SR', NULL, NULL, NULL),
(39273, '2017-07-22 09:34:55', NULL, NULL, 11265, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:34:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39274, '2017-07-22 09:35:08', NULL, NULL, 11265, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:35:08', 'admin-1500684602-15006873081553164', 1, 0, '', NULL, NULL, NULL),
(39275, '2017-07-22 09:35:08', NULL, NULL, 11265, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:35:08', 'admin-1500684602-15006873081553164', 1, 1, 'SR', NULL, NULL, NULL),
(39276, '2017-07-22 09:41:20', NULL, NULL, 11266, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:41:20', 'admin-1500684602-15006876797835953', 1, 0, '', 1, NULL, NULL),
(39277, '2017-07-22 09:45:34', NULL, NULL, 11267, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:45:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39278, '2017-07-22 09:45:55', NULL, NULL, 11267, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:45:55', 'admin-1500684602-15006879554652814', 1, 0, '', NULL, NULL, NULL),
(39279, '2017-07-22 09:54:06', NULL, NULL, 11268, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:54:06', 'admin-1500684602-1500688446504868', 1, 1, 'SR', NULL, NULL, NULL),
(39280, '2017-07-22 09:54:06', NULL, NULL, 11268, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:54:06', 'admin-1500684602-1500688446504868', 1, 1, 'SR', NULL, NULL, NULL),
(39281, '2017-07-22 09:52:27', NULL, NULL, 11264, 0, 270, '204', 'Homemade Savoury Pancake', 'no pork bacon replace with scramble egg', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:52:27', 'admin-1500684602-15006883470557437', 1, 0, '', NULL, NULL, NULL),
(39282, '2017-07-22 09:54:01', NULL, NULL, 11268, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:54:01', 'admin-1500684602-15006884409851729', 1, 0, '', NULL, NULL, NULL),
(39283, '2017-07-22 09:54:01', NULL, NULL, 11268, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:54:01', 'admin-1500684602-15006884409851729', 1, 0, '', NULL, NULL, NULL),
(39284, '2017-07-22 09:45:55', NULL, NULL, 11267, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:45:55', 'admin-1500684602-15006879554652814', 1, 0, '', NULL, NULL, NULL),
(39285, '2017-07-22 09:45:55', NULL, NULL, 11267, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:45:55', 'admin-1500684602-15006879554652814', 1, 0, '', NULL, NULL, NULL),
(39286, '2017-07-22 09:52:27', NULL, NULL, 11264, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:52:27', 'admin-1500684602-15006883470557437', 1, 0, '', NULL, NULL, NULL),
(39287, '2017-07-22 15:12:35', NULL, NULL, 11303, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 15:12:35', 'admin-1500706560-15007075554174954', 1, 1, 'SR', NULL, NULL, NULL),
(39288, '2017-07-22 09:33:06', NULL, NULL, 11264, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:33:06', 'admin-1500684602-15006871867413369', 1, 1, 'SR', NULL, NULL, NULL),
(39289, '2017-07-22 09:33:06', NULL, NULL, 11264, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:33:06', 'admin-1500684602-15006871867413369', 1, 0, '', NULL, NULL, NULL),
(39290, '2017-07-22 09:32:57', NULL, NULL, 11264, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:32:57', 'admin-1500684602-15006871775525642', 1, 0, '', NULL, NULL, NULL),
(39291, '2017-07-22 09:32:57', NULL, NULL, 11264, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:32:57', 'admin-1500684602-15006871775525642', 1, 0, '', NULL, NULL, NULL),
(39292, '2017-07-22 09:32:57', NULL, NULL, 11264, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:32:57', 'admin-1500684602-15006871775525642', 1, 0, '', NULL, NULL, NULL),
(39293, '2017-07-22 09:32:50', NULL, NULL, 11264, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.60, 0.0000, 0.0000, 14.60, 1, '27', 1, '1500709637', 'admin', '2017-07-22 09:32:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39294, '2017-07-23 10:56:55', NULL, NULL, 11349, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:56:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39295, '2017-07-23 10:25:28', NULL, NULL, 11339, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:25:28', 'admin-1500776009-15007767284694135', 1, 0, '', NULL, NULL, NULL),
(39296, '2017-07-23 10:25:28', NULL, NULL, 11339, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:25:28', 'admin-1500776009-15007767284694135', 1, 1, 'SR', NULL, NULL, NULL),
(39297, '2017-07-23 10:25:28', NULL, NULL, 11339, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:25:28', 'admin-1500776009-15007767284694135', 1, 0, '', NULL, NULL, NULL),
(39298, '2017-07-23 10:25:28', NULL, NULL, 11339, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:25:28', 'admin-1500776009-15007767284694135', 1, 1, 'SR', NULL, NULL, NULL),
(39299, '2017-07-23 09:50:38', NULL, NULL, 11331, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:50:38', 'admin-1500773888-15007746383984674', 1, 1, 'SR', NULL, NULL, NULL),
(39300, '2017-07-23 14:38:42', NULL, NULL, 11367, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 14:38:42', 'admin-1500781238-15007919227085498', 1, 1, 'SR', NULL, NULL, NULL),
(39301, '2017-07-23 16:59:22', NULL, NULL, 11377, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 16:59:22', 'admin-1500781238-15008003621804073', 1, 1, 'SR', NULL, NULL, NULL),
(39302, '2017-07-23 14:04:57', NULL, NULL, 11365, 0, 181, '116', 'Open Food ', '38.00x35', 'Meals', 'Perfect Meals', 1, 1330.00, 1330.0000, 0.0000, 1330.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 14:04:57', 'admin-1500781238-15007898970265578', 1, 0, '', NULL, NULL, NULL),
(39303, '2017-07-23 15:40:58', NULL, NULL, 11369, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 15:40:58', 'admin-1500781238-15007956578947781', 1, 1, 'SR', 1, NULL, '10.0'),
(39304, '2017-07-23 14:38:42', NULL, NULL, 11367, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 14:38:42', 'admin-1500781238-15007919227085498', 1, 1, 'SR', NULL, NULL, NULL),
(39305, '2017-07-23 11:58:44', NULL, NULL, 11347, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:58:44', 'admin-1500781238-15007823245653373', 1, 0, '', NULL, NULL, NULL),
(39306, '2017-07-23 10:35:30', NULL, NULL, 11341, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:35:30', 'admin-1500776009-15007773299349374', 1, 1, 'SR', NULL, NULL, NULL),
(39307, '2017-07-23 10:35:30', NULL, NULL, 11341, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:35:30', 'admin-1500776009-15007773299349374', 1, 0, '', NULL, NULL, NULL),
(39308, '2017-07-23 10:36:06', NULL, NULL, 11342, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.89, 0.0000, 0.0000, 4.89, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:36:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39309, '2017-07-23 14:38:42', NULL, NULL, 11367, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 14:38:42', 'admin-1500781238-15007919227085498', 1, 0, '', NULL, NULL, NULL),
(39310, '2017-07-23 14:49:49', NULL, NULL, 11365, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 14:49:49', 'admin-1500781238-15007925897259287', 1, 1, 'SR', NULL, NULL, NULL),
(39311, '2017-07-23 14:38:42', NULL, NULL, 11367, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 14:38:42', 'admin-1500781238-15007919227085498', 1, 0, '', NULL, NULL, NULL),
(39312, '2017-07-23 17:08:29', NULL, NULL, 11378, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 17:08:29', 'admin-1500781238-15008009096753063', 1, 0, '', NULL, NULL, NULL),
(39313, '2017-07-23 15:57:26', NULL, NULL, 11372, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 15:57:26', 'admin-1500781238-15007966458667277', 1, 1, 'SR', NULL, NULL, NULL),
(39314, '2017-07-23 10:53:20', NULL, NULL, 11348, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:53:20', 'admin-1500778074-15007784006106188', 1, 0, '', NULL, NULL, NULL),
(39315, '2017-07-23 10:53:20', NULL, NULL, 11348, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:53:20', 'admin-1500778074-15007784006106188', 1, 0, '', NULL, NULL, NULL),
(39316, '2017-07-23 11:14:08', NULL, NULL, 11353, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:14:08', 'admin-1500779539-15007796480258780', 1, 0, '', NULL, NULL, NULL),
(39317, '2017-07-23 11:14:15', NULL, NULL, 11354, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:14:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39318, '2017-07-23 11:14:27', NULL, NULL, 11354, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:14:27', 'admin-1500779539-15007796673995030', 1, 0, '', NULL, NULL, NULL),
(39319, '2017-07-23 11:14:27', NULL, NULL, 11354, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:14:27', 'admin-1500779539-15007796673995030', 1, 0, '', NULL, NULL, NULL),
(39320, '2017-07-23 11:14:27', NULL, NULL, 11354, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:14:27', 'admin-1500779539-15007796673995030', 1, 1, 'SR', NULL, NULL, NULL),
(39321, '2017-07-23 11:18:15', NULL, NULL, 11355, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:18:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39322, '2017-07-23 13:30:42', NULL, NULL, 11363, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 13:30:42', 'admin-1500781238-15007878425936795', 1, 1, 'SR', 1, NULL, NULL),
(39323, '2017-07-23 11:18:29', NULL, NULL, 11355, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:18:29', 'admin-1500779539-15007799096571993', 1, 0, '', NULL, NULL, NULL),
(39324, '2017-07-23 11:19:09', NULL, NULL, 11356, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:19:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39325, '2017-07-23 11:19:27', NULL, NULL, 11356, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:19:27', 'admin-1500779539-1500779967562225', 1, 0, '', NULL, NULL, NULL),
(39326, '2017-07-23 17:06:49', NULL, NULL, 11380, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 17:06:49', 'admin-1500781238-1500800808895438', 1, 1, 'SR', NULL, NULL, NULL),
(39327, '2017-07-23 16:35:19', NULL, NULL, 11375, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1500781238', 'admin', '2017-07-23 16:35:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39328, '2017-07-23 16:35:27', NULL, NULL, 11375, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 16:35:27', 'admin-1500781238-15007989268061779', 1, 1, 'SR', NULL, NULL, NULL),
(39329, '2017-07-23 16:35:27', NULL, NULL, 11375, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 16:35:27', 'admin-1500781238-15007989268061779', 1, 1, 'SR', NULL, NULL, NULL),
(39330, '2017-07-23 16:41:23', NULL, NULL, 11376, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1500781238', 'admin', '2017-07-23 16:41:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39331, '2017-07-23 17:06:40', NULL, NULL, 11380, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1500781238', 'admin', '2017-07-23 17:06:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39332, '2017-07-23 17:06:49', NULL, NULL, 11380, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 17:06:49', 'admin-1500781238-1500800808895438', 1, 1, 'SR', NULL, NULL, NULL),
(39333, '2017-07-23 11:33:04', NULL, NULL, 11359, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:33:04', 'admin-1500779539-15007807840803348', 1, 1, 'SR', NULL, NULL, NULL),
(39334, '2017-07-23 11:33:04', NULL, NULL, 11359, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:33:04', 'admin-1500779539-15007807840803348', 1, 1, 'SR', NULL, NULL, NULL),
(39335, '2017-07-23 11:33:26', NULL, NULL, 11356, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:33:26', 'admin-1500779539-15007808059509556', 1, 1, 'SR', NULL, NULL, NULL),
(39336, '2017-07-23 11:19:27', NULL, NULL, 11356, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:19:27', 'admin-1500779539-1500779967562225', 1, 1, 'SR', NULL, NULL, NULL),
(39337, '2017-07-23 17:04:00', NULL, NULL, 11378, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1500781238', 'admin', '2017-07-23 17:04:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39338, '2017-07-23 17:04:11', NULL, NULL, 11378, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 17:04:11', 'admin-1500781238-1500800651164441', 1, 1, 'SR', NULL, NULL, NULL),
(39339, '2017-07-23 16:59:22', NULL, NULL, 11377, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 16:59:22', 'admin-1500781238-15008003621804073', 1, 1, 'SR', NULL, NULL, NULL),
(39340, '2017-07-23 16:41:32', NULL, NULL, 11376, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 16:41:32', 'admin-1500781238-15007992921081283', 1, 0, '', NULL, NULL, NULL),
(39341, '2017-07-23 17:05:46', NULL, NULL, 11379, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1500781238', 'admin', '2017-07-23 17:05:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39342, '2017-07-23 16:58:54', NULL, NULL, 11377, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1500781238', 'admin', '2017-07-23 16:58:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39343, '2017-07-23 16:41:32', NULL, NULL, 11376, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 16:41:32', 'admin-1500781238-15007992921081283', 1, 1, 'SR', NULL, NULL, NULL),
(39344, '2017-07-23 16:41:32', NULL, NULL, 11376, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 16:41:32', 'admin-1500781238-15007992921081283', 1, 1, 'SR', NULL, NULL, NULL),
(39345, '2017-07-23 10:39:04', NULL, NULL, 11343, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:39:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39346, '2017-07-23 10:39:43', NULL, NULL, 11343, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:39:43', 'admin-1500776009-15007775831336554', 1, 0, '', NULL, NULL, NULL),
(39347, '2017-07-23 16:55:06', NULL, NULL, 11375, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 16:55:06', 'admin-1500781238-15008001060058797', 1, 0, '', NULL, NULL, NULL),
(39348, '2017-07-23 10:57:19', NULL, NULL, 11349, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:57:19', 'admin-1500778074-15007786394602675', 1, 0, '', NULL, NULL, NULL),
(39349, '2017-07-23 10:57:19', NULL, NULL, 11349, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:57:19', 'admin-1500778074-15007786394602675', 1, 0, '', NULL, NULL, NULL),
(39350, '2017-07-23 16:14:23', NULL, NULL, 11373, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 16:14:23', 'admin-1500781238-15007976635657017', 1, 0, '', NULL, NULL, NULL),
(39351, '2017-07-23 16:14:23', NULL, NULL, 11373, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 16:14:23', 'admin-1500781238-15007976635657017', 1, 1, 'SR', NULL, NULL, NULL),
(39352, '2017-07-23 16:14:23', NULL, NULL, 11373, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 16:14:23', 'admin-1500781238-15007976635657017', 1, 1, 'SR', NULL, NULL, NULL),
(39353, '2017-07-23 16:41:32', NULL, NULL, 11376, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 16:41:32', 'admin-1500781238-15007992921081283', 1, 0, '', NULL, NULL, NULL),
(39354, '2017-07-23 16:25:44', NULL, NULL, 11374, 0, 182, '117', 'Open Drinks ', 'coffee beans', 'Cold Drinks', 'Fresh Juice', 1, 38.00, 38.0000, 0.0000, 38.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 16:25:44', 'admin-1500781238-15007983439868582', 1, 0, '', 1, NULL, NULL),
(39355, '2017-07-23 09:56:15', NULL, NULL, 11332, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:56:15', 'admin-1500773888-15007749747266381', 1, 1, 'SR', NULL, NULL, NULL),
(39356, '2017-07-23 09:56:15', NULL, NULL, 11332, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:56:15', 'admin-1500773888-15007749747266381', 1, 1, 'SR', NULL, NULL, NULL),
(39357, '2017-07-23 11:09:26', NULL, NULL, 11352, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:09:26', 'admin-1500778074-15007793667038395', 1, 1, 'SR', NULL, NULL, NULL),
(39358, '2017-07-23 16:14:04', NULL, NULL, 11373, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1500781238', 'admin', '2017-07-23 16:14:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39359, '2017-07-23 15:57:26', NULL, NULL, 11372, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 15:57:26', 'admin-1500781238-15007966458667277', 1, 0, '', NULL, NULL, NULL),
(39360, '2017-07-23 15:57:26', NULL, NULL, 11372, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 15:57:26', 'admin-1500781238-15007966458667277', 1, 1, 'SR', NULL, NULL, NULL),
(39361, '2017-07-23 15:57:26', NULL, NULL, 11372, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 15:57:26', 'admin-1500781238-15007966458667277', 1, 1, 'SR', NULL, NULL, NULL),
(39362, '2017-07-23 15:57:26', NULL, NULL, 11372, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 15:57:26', 'admin-1500781238-15007966458667277', 1, 1, 'SR', NULL, NULL, NULL),
(39363, '2017-07-23 11:04:18', NULL, NULL, 11350, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:04:18', 'admin-1500778074-15007790581904213', 1, 1, 'SR', NULL, NULL, NULL),
(39364, '2017-07-23 11:04:18', NULL, NULL, 11350, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:04:18', 'admin-1500778074-15007790581904213', 1, 1, 'SR', NULL, NULL, NULL),
(39365, '2017-07-23 09:56:15', NULL, NULL, 11332, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:56:15', 'admin-1500773888-15007749747266381', 1, 1, 'SR', NULL, NULL, NULL),
(39366, '2017-07-23 09:34:24', NULL, NULL, 11328, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:34:24', 'admin-1500771896-15007736645036215', 1, 0, '', NULL, NULL, NULL),
(39367, '2017-07-23 15:51:28', NULL, NULL, 11370, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 15:51:28', 'admin-1500781238-15007962880381087', 1, 0, '', 1, NULL, '10.0'),
(39368, '2017-07-23 15:51:28', NULL, NULL, 11370, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 15:51:28', 'admin-1500781238-15007962880381087', 1, 1, 'SR', 1, NULL, '10.0'),
(39369, '2017-07-23 15:42:00', NULL, NULL, 11369, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 15:42:00', 'admin-1500781238-15007957198397036', 1, 1, 'SR', 1, NULL, '10.0'),
(39370, '2017-07-23 10:39:43', NULL, NULL, 11343, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:39:43', 'admin-1500776009-15007775831336554', 1, 0, '', NULL, NULL, NULL),
(39371, '2017-07-23 14:49:57', NULL, NULL, 11368, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 14:49:57', 'admin-1500781238-1500792597155341', 1, 1, 'SR', 1, NULL, NULL),
(39372, '2017-07-23 11:04:18', NULL, NULL, 11350, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:04:18', 'admin-1500778074-15007790581904213', 1, 1, 'SR', NULL, NULL, NULL),
(39373, '2017-07-23 10:53:03', NULL, NULL, 11348, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:53:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39374, '2017-07-23 13:41:07', NULL, NULL, 11364, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 13:41:07', 'admin-1500781238-15007884673107873', 1, 0, '', NULL, NULL, NULL),
(39375, '2017-07-23 14:03:51', NULL, NULL, 11365, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 138.40, 0.0000, 0.0000, 138.40, 1, '27', 1, '1500781238', 'admin', '2017-07-23 14:03:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39376, '2017-07-23 13:36:39', NULL, NULL, 11364, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1500781238', 'admin', '2017-07-23 13:36:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39377, '2017-07-23 09:56:14', NULL, NULL, 11332, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:56:14', 'admin-1500773888-15007749747266381', 1, 0, '', NULL, NULL, NULL),
(39378, '2017-07-23 09:56:14', NULL, NULL, 11332, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:56:15', 'admin-1500773888-15007749747266381', 1, 0, '', NULL, NULL, NULL),
(39379, '2017-07-23 09:56:15', NULL, NULL, 11332, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:56:15', 'admin-1500773888-15007749747266381', 1, 0, '', NULL, NULL, NULL),
(39380, '2017-07-23 09:34:24', NULL, NULL, 11328, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:34:24', 'admin-1500771896-15007736645036215', 1, 1, 'SR', NULL, NULL, NULL),
(39381, '2017-07-23 09:34:24', NULL, NULL, 11328, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:34:24', 'admin-1500771896-15007736645036215', 1, 1, 'SR', NULL, NULL, NULL),
(39382, '2017-07-23 09:37:19', NULL, NULL, 11329, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:37:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39383, '2017-07-23 09:38:02', NULL, NULL, 11329, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:38:02', 'admin-1500771896-15007738821406535', 1, 0, '', NULL, NULL, NULL),
(39384, '2017-07-23 09:38:02', NULL, NULL, 11329, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:38:02', 'admin-1500771896-15007738821406535', 1, 0, '', NULL, NULL, NULL),
(39385, '2017-07-23 09:38:02', NULL, NULL, 11329, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:38:02', 'admin-1500771896-15007738821406535', 1, 0, '', NULL, NULL, NULL),
(39386, '2017-07-23 09:38:02', NULL, NULL, 11329, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:38:02', 'admin-1500771896-15007738821406535', 1, 1, 'SR', NULL, NULL, NULL),
(39387, '2017-07-23 09:38:02', NULL, NULL, 11329, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:38:02', 'admin-1500771896-15007738821406535', 1, 1, 'SR', NULL, NULL, NULL),
(39388, '2017-07-23 09:38:57', NULL, NULL, 11329, 0, 181, '116', 'Open Food ', 'add sunny side up on chessy bacon toast', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:38:57', 'admin-1500773888-15007739374647141', 1, 0, '', NULL, NULL, NULL),
(39389, '2017-07-23 09:41:09', NULL, NULL, 11330, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:41:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39390, '2017-07-23 09:41:24', NULL, NULL, 11330, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:41:24', 'admin-1500773888-15007740844307845', 1, 1, 'SR', NULL, NULL, NULL),
(39391, '2017-07-23 09:41:24', NULL, NULL, 11330, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:41:24', 'admin-1500773888-15007740844307845', 1, 0, '', NULL, NULL, NULL),
(39392, '2017-07-23 09:41:24', NULL, NULL, 11330, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:41:24', 'admin-1500773888-15007740844307845', 1, 1, 'SR', NULL, NULL, NULL),
(39393, '2017-07-23 09:24:57', NULL, NULL, 11326, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:24:57', 'admin-1500771896-15007730974116394', 1, 0, '', NULL, NULL, NULL),
(39394, '2017-07-23 11:25:32', NULL, NULL, 11357, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:25:32', 'admin-1500779539-15007803323982962', 1, 0, '', NULL, NULL, NULL),
(39395, '2017-07-23 11:25:32', NULL, NULL, 11357, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:25:32', 'admin-1500779539-15007803323982962', 1, 0, '', NULL, NULL, NULL),
(39396, '2017-07-23 11:25:32', NULL, NULL, 11357, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:25:32', 'admin-1500779539-15007803323982962', 1, 0, '', NULL, NULL, NULL),
(39397, '2017-07-23 14:21:55', NULL, NULL, 11366, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 14:21:55', 'admin-1500781238-15007909152325732', 1, 0, '', NULL, NULL, NULL),
(39398, '2017-07-23 11:03:55', NULL, NULL, 11350, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:03:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39399, '2017-07-23 09:50:38', NULL, NULL, 11331, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:50:38', 'admin-1500773888-15007746383984674', 1, 0, '', NULL, NULL, NULL),
(39400, '2017-07-23 13:36:43', NULL, NULL, 11364, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 13:36:43', 'admin-1500781238-15007882033127026', 1, 1, 'SR', NULL, NULL, NULL),
(39401, '2017-07-23 13:36:43', NULL, NULL, 11364, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 13:36:43', 'admin-1500781238-15007882033127026', 1, 1, 'SR', NULL, NULL, NULL),
(39402, '2017-07-23 11:48:04', NULL, NULL, 11355, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:48:04', 'admin-1500781238-15007816846664147', 1, 0, '', NULL, NULL, NULL),
(39403, '2017-07-23 15:56:23', NULL, NULL, 11372, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1500781238', 'admin', '2017-07-23 15:56:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39404, '2017-07-23 15:55:03', NULL, NULL, 11371, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1500781238', 'admin', '2017-07-23 15:55:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39405, '2017-07-23 15:55:11', NULL, NULL, 11371, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 15:55:11', 'admin-1500781238-15007965117484158', 1, 1, 'SR', NULL, NULL, NULL),
(39406, '2017-07-23 12:01:08', NULL, NULL, 11361, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 12:01:08', 'admin-1500781238-15007824685245420', 1, 1, 'SR', NULL, NULL, NULL),
(39407, '2017-07-23 12:01:08', NULL, NULL, 11361, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 12:01:08', 'admin-1500781238-15007824685245420', 1, 0, '', NULL, NULL, NULL),
(39408, '2017-07-23 12:00:44', NULL, NULL, 11361, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1500781238', 'admin', '2017-07-23 12:00:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39409, '2017-07-23 11:51:44', NULL, NULL, 11360, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:51:44', 'admin-1500781238-15007819041417850', 1, 0, '', NULL, NULL, NULL),
(39410, '2017-07-23 11:51:31', NULL, NULL, 11355, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:51:31', 'admin-1500781238-15007818912499446', 1, 0, '', NULL, NULL, NULL),
(39411, '2017-07-23 14:04:13', NULL, NULL, 11365, 0, 181, '116', 'Open Food ', 'Additional pasta', 'Meals', 'Perfect Meals', 1, 30.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 14:04:13', 'admin-1500781238-1500789853563672', 1, 0, '', NULL, NULL, NULL),
(39412, '2017-07-23 10:48:22', NULL, NULL, 11346, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:48:22', 'admin-1500778074-15007781020258989', 1, 0, '', NULL, NULL, NULL),
(39413, '2017-07-23 11:42:40', NULL, NULL, 11360, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:42:40', 'admin-1500781238-15007813599225126', 1, 0, '', NULL, NULL, NULL),
(39414, '2017-07-23 11:41:38', NULL, NULL, 11360, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:41:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39415, '2017-07-23 11:42:40', NULL, NULL, 11360, NULL, 37, '37', 'Pineapple Orange', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:42:40', 'admin-1500781238-15007813599225126', 1, 1, 'SR', NULL, NULL, NULL),
(39416, '2017-07-23 11:38:43', NULL, NULL, 11359, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:38:43', 'admin-1500779539-1500781123275919', 1, 0, '', NULL, NULL, NULL),
(39417, '2017-07-23 11:38:43', NULL, NULL, 11359, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:38:43', 'admin-1500779539-1500781123275919', 1, 0, '', NULL, NULL, NULL),
(39418, '2017-07-23 11:27:24', NULL, NULL, 11358, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:27:24', 'admin-1500779539-15007804441672446', 1, 1, 'SR', NULL, NULL, NULL),
(39419, '2017-07-23 09:24:57', NULL, NULL, 11326, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:24:57', 'admin-1500771896-15007730974116394', 1, 0, '', NULL, NULL, NULL),
(39420, '2017-07-23 09:24:57', NULL, NULL, 11326, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:24:57', 'admin-1500771896-15007730974116394', 1, 0, '', NULL, NULL, NULL),
(39421, '2017-07-23 11:31:26', NULL, NULL, 11342, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:31:26', 'admin-1500779539-1500780686685978', 1, 0, '', NULL, NULL, NULL),
(39422, '2017-07-23 11:32:51', NULL, NULL, 11359, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:32:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39423, '2017-07-23 11:25:55', NULL, NULL, 11357, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:25:55', 'admin-1500779539-15007803553082118', 1, 1, 'SR', NULL, NULL, NULL),
(39424, '2017-07-23 11:27:24', NULL, NULL, 11358, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:27:24', 'admin-1500779539-15007804441672446', 1, 0, '', NULL, NULL, NULL),
(39425, '2017-07-23 11:27:03', NULL, NULL, 11358, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:27:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39426, '2017-07-23 11:25:55', NULL, NULL, 11357, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:25:55', 'admin-1500779539-15007803553082118', 1, 0, '', NULL, NULL, NULL),
(39427, '2017-07-23 11:25:55', NULL, NULL, 11357, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:25:55', 'admin-1500779539-15007803553082118', 1, 0, '', NULL, NULL, NULL),
(39428, '2017-07-23 10:53:20', NULL, NULL, 11348, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:53:20', 'admin-1500778074-15007784006106188', 1, 0, '', NULL, NULL, NULL),
(39429, '2017-07-23 11:25:17', NULL, NULL, 11357, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:25:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39430, '2017-07-23 09:55:46', NULL, NULL, 11332, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.60, 0.0000, 0.0000, 10.60, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:55:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39431, '2017-07-23 11:19:27', NULL, NULL, 11356, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:19:27', 'admin-1500779539-1500779967562225', 1, 0, '', NULL, NULL, NULL),
(39432, '2017-07-23 11:19:27', NULL, NULL, 11356, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:19:27', 'admin-1500779539-1500779967562225', 1, 0, '', NULL, NULL, NULL),
(39433, '2017-07-23 10:53:20', NULL, NULL, 11348, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:53:20', 'admin-1500778074-15007784006106188', 1, 1, 'SR', NULL, NULL, NULL),
(39434, '2017-07-23 11:14:08', NULL, NULL, 11353, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:14:08', 'admin-1500779539-15007796480258780', 1, 1, 'SR', NULL, NULL, NULL),
(39435, '2017-07-23 11:14:08', NULL, NULL, 11353, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:14:08', 'admin-1500779539-15007796480258780', 1, 0, '', NULL, NULL, NULL),
(39436, '2017-07-23 10:51:27', NULL, NULL, 11347, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:51:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39437, '2017-07-23 10:51:46', NULL, NULL, 11347, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:51:46', 'admin-1500778074-15007783063494530', 1, 0, '', NULL, NULL, NULL),
(39438, '2017-07-23 11:14:08', NULL, NULL, 11353, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:14:08', 'admin-1500779539-15007796480258780', 1, 0, '', NULL, NULL, NULL),
(39439, '2017-07-23 11:09:26', NULL, NULL, 11352, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:09:26', 'admin-1500778074-15007793667038395', 1, 0, '', NULL, NULL, NULL),
(39440, '2017-07-23 11:12:12', NULL, NULL, 11347, 0, 181, '116', 'Open Food ', 'toast bread 2', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:12:12', 'admin-1500778074-15007795327514857', 1, 0, '', NULL, NULL, NULL),
(39441, '2017-07-23 10:51:46', NULL, NULL, 11347, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:51:46', 'admin-1500778074-15007783063494530', 1, 0, '', NULL, NULL, NULL),
(39442, '2017-07-23 11:04:42', NULL, NULL, 11351, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:04:42', 'admin-1500778074-15007790824049431', 1, 0, '', NULL, NULL, NULL),
(39443, '2017-07-23 11:04:42', NULL, NULL, 11351, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:04:42', 'admin-1500778074-15007790824049431', 1, 0, '', NULL, NULL, NULL),
(39444, '2017-07-23 09:34:24', NULL, NULL, 11328, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:34:24', 'admin-1500771896-15007736645036215', 1, 0, '', NULL, NULL, NULL),
(39445, '2017-07-23 09:34:00', NULL, NULL, 11328, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:34:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39446, '2017-07-23 14:38:26', NULL, NULL, 11367, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 14:38:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39447, '2017-07-23 11:09:26', NULL, NULL, 11352, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:09:26', 'admin-1500778074-15007793667038395', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(39448, '2017-07-23 11:09:06', NULL, NULL, 11352, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:09:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39449, '2017-07-23 11:05:33', NULL, NULL, 11338, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:05:33', 'admin-1500778074-15007791333232865', 1, 0, '', NULL, NULL, NULL),
(39450, '2017-07-23 11:33:04', NULL, NULL, 11359, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:33:04', 'admin-1500779539-15007807840803348', 1, 1, 'SR', NULL, NULL, NULL),
(39451, '2017-07-23 11:04:42', NULL, NULL, 11351, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:04:42', 'admin-1500778074-15007790824049431', 1, 1, 'SR', NULL, NULL, NULL),
(39452, '2017-07-23 11:04:42', NULL, NULL, 11351, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:04:42', 'admin-1500778074-15007790824049431', 1, 1, 'SR', NULL, NULL, NULL),
(39453, '2017-07-23 16:55:06', NULL, NULL, 11375, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 16:55:06', 'admin-1500781238-15008001060058797', 1, 0, '', NULL, NULL, NULL),
(39454, '2017-07-23 11:12:50', NULL, NULL, 11353, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:12:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39455, '2017-07-23 11:04:24', NULL, NULL, 11351, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:04:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39456, '2017-07-23 11:04:42', NULL, NULL, 11351, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:04:42', 'admin-1500778074-15007790824049431', 1, 0, '', NULL, NULL, NULL),
(39457, '2017-07-23 14:21:46', NULL, NULL, 11366, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1500781238', 'admin', '2017-07-23 14:21:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39458, '2017-07-23 10:57:19', NULL, NULL, 11349, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:57:19', 'admin-1500778074-15007786394602675', 1, 0, '', NULL, NULL, NULL),
(39459, '2017-07-23 10:57:19', NULL, NULL, 11349, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:57:19', 'admin-1500778074-15007786394602675', 1, 1, 'SR', NULL, NULL, NULL),
(39460, '2017-07-23 10:25:01', NULL, NULL, 11339, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:25:01', 'admin-1500776009-15007767009821616', 1, 0, '', NULL, NULL, NULL),
(39461, '2017-07-23 10:25:01', NULL, NULL, 11339, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:25:01', 'admin-1500776009-15007767009821616', 1, 0, '', NULL, NULL, NULL),
(39462, '2017-07-23 10:13:21', NULL, NULL, 11337, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:13:21', 'admin-1500773888-15007760012882858', 1, 0, '', NULL, NULL, NULL),
(39463, '2017-07-23 10:01:30', NULL, NULL, 11333, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:01:30', 'admin-1500773888-15007752905592026', 1, 0, '', NULL, NULL, NULL),
(39464, '2017-07-23 10:01:30', NULL, NULL, 11333, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:01:30', 'admin-1500773888-15007752905592026', 1, 0, '', NULL, NULL, NULL),
(39465, '2017-07-23 10:51:46', NULL, NULL, 11347, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:51:46', 'admin-1500778074-15007783063494530', 1, 1, 'SR', NULL, NULL, NULL),
(39466, '2017-07-23 10:51:46', NULL, NULL, 11347, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:51:46', 'admin-1500778074-15007783063494530', 1, 1, 'SR', NULL, NULL, NULL),
(39467, '2017-07-23 10:47:12', NULL, NULL, 11345, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:47:12', 'admin-1500776009-15007780322519358', 1, 1, 'SR', NULL, NULL, NULL),
(39468, '2017-07-23 10:48:22', NULL, NULL, 11346, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:48:22', 'admin-1500778074-15007781020258989', 1, 1, 'SR', NULL, NULL, NULL),
(39469, '2017-07-23 10:48:46', NULL, NULL, 11333, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:48:46', 'admin-1500778074-15007781262555025', 1, 0, '', NULL, NULL, NULL),
(39470, '2017-07-23 11:38:43', NULL, NULL, 11359, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 11:38:43', 'admin-1500779539-1500781123275919', 1, 0, '', NULL, NULL, NULL),
(39471, '2017-07-23 10:47:12', NULL, NULL, 11345, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:47:12', 'admin-1500776009-15007780322519358', 1, 1, 'SR', NULL, NULL, NULL),
(39472, '2017-07-23 10:47:12', NULL, NULL, 11345, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:47:12', 'admin-1500776009-15007780322519358', 1, 0, '', NULL, NULL, NULL),
(39473, '2017-07-23 10:46:48', NULL, NULL, 11345, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:46:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39474, '2017-07-23 10:47:12', NULL, NULL, 11345, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:47:12', 'admin-1500776009-15007780322519358', 1, 0, '', NULL, NULL, NULL),
(39475, '2017-07-23 10:46:05', NULL, NULL, 11344, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:46:05', 'admin-1500776009-15007779656517149', 1, 1, 'SR', 1, NULL, NULL),
(39476, '2017-07-23 10:40:07', NULL, NULL, 11342, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:40:07', 'admin-1500776009-15007776071361893', 1, 0, '', NULL, NULL, NULL),
(39477, '2017-07-23 10:40:07', NULL, NULL, 11342, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:40:07', 'admin-1500776009-15007776071361893', 1, 0, '', NULL, NULL, NULL),
(39478, '2017-07-23 09:50:38', NULL, NULL, 11331, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:50:38', 'admin-1500773888-15007746383984674', 1, 0, '', NULL, NULL, NULL),
(39479, '2017-07-23 10:39:43', NULL, NULL, 11343, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:39:43', 'admin-1500776009-15007775831336554', 1, 1, 'SR', NULL, NULL, NULL),
(39480, '2017-07-23 10:39:43', NULL, NULL, 11343, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:39:43', 'admin-1500776009-15007775831336554', 1, 1, 'SR', NULL, NULL, NULL),
(39481, '2017-07-23 10:38:35', NULL, NULL, 11334, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:38:35', 'admin-1500776009-15007775153427530', 1, 1, 'SR', NULL, NULL, NULL),
(39482, '2017-07-23 10:38:12', NULL, NULL, 11342, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:38:12', 'admin-1500776009-15007774926075928', 1, 0, '', NULL, NULL, NULL),
(39483, '2017-07-23 10:38:12', NULL, NULL, 11342, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:38:12', 'admin-1500776009-15007774926075928', 1, 0, '', NULL, NULL, NULL),
(39484, '2017-07-23 10:01:30', NULL, NULL, 11333, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:01:30', 'admin-1500773888-15007752905592026', 1, 0, '', NULL, NULL, NULL),
(39485, '2017-07-23 10:10:26', NULL, NULL, 11334, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:10:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39486, '2017-07-23 10:10:37', NULL, NULL, 11334, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:10:37', 'admin-1500773888-15007758376592449', 1, 1, 'SR', NULL, NULL, NULL),
(39487, '2017-07-23 00:00:00', NULL, NULL, 11335, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:32:24', 'admin-1500771896-15007735444929662', 1, 1, 'SR', NULL, NULL, NULL),
(39488, '2017-07-23 00:00:00', NULL, NULL, 11336, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:32:24', 'admin-1500771896-15007735444929662', 1, 1, 'SR', NULL, NULL, NULL),
(39489, '2017-07-23 10:35:30', NULL, NULL, 11341, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:35:30', 'admin-1500776009-15007773299349374', 1, 0, '', NULL, NULL, NULL),
(39490, '2017-07-23 10:24:44', NULL, NULL, 11339, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:24:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39491, '2017-07-23 10:01:30', NULL, NULL, 11333, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:01:30', 'admin-1500773888-15007752905592026', 1, 1, 'SR', NULL, NULL, NULL),
(39492, '2017-07-23 10:01:30', NULL, NULL, 11333, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:01:30', 'admin-1500773888-15007752905592026', 1, 0, '', NULL, NULL, NULL),
(39493, '2017-07-23 10:35:15', NULL, NULL, 11341, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:35:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39494, '2017-07-23 10:48:09', NULL, NULL, 11346, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:48:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39495, '2017-07-23 10:48:22', NULL, NULL, 11346, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:48:22', 'admin-1500778074-15007781020258989', 1, 0, '', NULL, NULL, NULL),
(39496, '2017-07-23 16:41:32', NULL, NULL, 11376, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 16:41:32', 'admin-1500781238-15007992921081283', 1, 0, '', NULL, NULL, NULL),
(39497, '2017-07-23 10:28:22', NULL, NULL, 11339, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:28:22', 'admin-1500776009-15007769018859945', 1, 0, '', NULL, NULL, NULL),
(39498, '2017-07-23 10:25:01', NULL, NULL, 11339, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:25:01', 'admin-1500776009-15007767009821616', 1, 0, '', NULL, NULL, NULL),
(39499, '2017-07-23 10:22:34', NULL, NULL, 11338, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:22:34', 'admin-1500776009-15007765542615930', 1, 0, '', NULL, NULL, NULL),
(39500, '2017-07-23 10:22:34', NULL, NULL, 11338, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:22:34', 'admin-1500776009-15007765542615930', 1, 0, '', NULL, NULL, NULL),
(39501, '2017-07-23 10:22:34', NULL, NULL, 11338, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:22:34', 'admin-1500776009-15007765542615930', 1, 0, '', NULL, NULL, NULL),
(39502, '2017-07-23 10:22:34', NULL, NULL, 11338, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:22:34', 'admin-1500776009-15007765542615930', 1, 0, '', NULL, NULL, NULL),
(39503, '2017-07-23 10:22:34', NULL, NULL, 11338, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:22:34', 'admin-1500776009-15007765542615930', 1, 0, '', NULL, NULL, NULL),
(39504, '2017-07-23 10:22:34', NULL, NULL, 11338, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:22:34', 'admin-1500776009-15007765542615930', 1, 1, 'SR', NULL, NULL, NULL),
(39505, '2017-07-23 10:21:33', NULL, NULL, 11338, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:21:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39506, '2017-07-23 10:13:21', NULL, NULL, 11337, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:13:21', 'admin-1500773888-15007760012882858', 1, 1, 'SR', NULL, NULL, NULL),
(39507, '2017-07-23 10:13:21', NULL, NULL, 11337, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:13:21', 'admin-1500773888-15007760012882858', 1, 1, 'SR', NULL, NULL, NULL),
(39508, '2017-07-23 10:13:21', NULL, NULL, 11337, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:13:21', 'admin-1500773888-15007760012882858', 1, 0, '', NULL, NULL, NULL),
(39509, '2017-07-23 10:01:30', NULL, NULL, 11333, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:01:30', 'admin-1500773888-15007752905592026', 1, 1, 'SR', NULL, NULL, NULL),
(39510, '2017-07-23 10:01:30', NULL, NULL, 11333, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:01:30', 'admin-1500773888-15007752905592026', 1, 0, '', NULL, NULL, NULL),
(39511, '2017-07-23 10:00:59', NULL, NULL, 11333, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:00:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39512, '2017-07-23 10:01:30', NULL, NULL, 11333, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:01:30', 'admin-1500773888-15007752905592026', 1, 0, '', NULL, NULL, NULL),
(39513, '2017-07-23 09:56:15', NULL, NULL, 11332, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:56:15', 'admin-1500773888-15007749747266381', 1, 0, '', NULL, NULL, NULL),
(39514, '2017-07-23 09:51:27', NULL, NULL, 11330, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:51:27', 'admin-1500773888-15007746868357996', 1, 1, 'SR', NULL, NULL, NULL),
(39515, '2017-07-23 14:04:13', NULL, NULL, 11365, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 14:04:13', 'admin-1500781238-1500789853563672', 1, 1, 'SR', NULL, NULL, NULL),
(39516, '2017-07-23 09:56:14', NULL, NULL, 11332, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:56:14', 'admin-1500773888-15007749747266381', 1, 0, '', NULL, NULL, NULL),
(39517, '2017-07-23 09:51:27', NULL, NULL, 11330, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:51:27', 'admin-1500773888-15007746868357996', 1, 0, '', NULL, NULL, NULL),
(39518, '2017-07-23 09:50:38', NULL, NULL, 11331, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:50:38', 'admin-1500773888-15007746383984674', 1, 0, '', NULL, NULL, NULL),
(39519, '2017-07-23 09:16:41', NULL, NULL, 11325, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:16:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39520, '2017-07-23 09:16:48', NULL, NULL, 11325, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:16:48', 'admin-1500771896-15007726083421048', 1, 0, '', NULL, NULL, NULL),
(39521, '2017-07-23 09:16:48', NULL, NULL, 11325, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:16:48', 'admin-1500771896-15007726083421048', 1, 0, '', NULL, NULL, NULL),
(39522, '2017-07-23 09:16:48', NULL, NULL, 11325, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:16:48', 'admin-1500771896-15007726083421048', 1, 0, '', NULL, NULL, NULL),
(39523, '2017-07-23 09:16:58', NULL, NULL, 11325, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:16:58', 'admin-1500771896-15007726186815642', 1, 1, 'SR', NULL, NULL, NULL),
(39524, '2017-07-23 09:16:58', NULL, NULL, 11325, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:16:58', 'admin-1500771896-15007726186815642', 1, 1, 'SR', NULL, NULL, NULL),
(39525, '2017-07-23 09:16:58', NULL, NULL, 11325, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:16:58', 'admin-1500771896-15007726186815642', 1, 1, 'SR', NULL, NULL, NULL),
(39526, '2017-07-23 09:24:47', NULL, NULL, 11326, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:24:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39527, '2017-07-23 17:05:49', NULL, NULL, 11379, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 17:05:49', 'admin-1500781238-1500800749213897', 1, 1, 'SR', NULL, NULL, NULL),
(39528, '2017-07-23 09:25:03', NULL, NULL, 11326, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:25:03', 'admin-1500771896-15007731030769362', 1, 1, 'SR', NULL, NULL, NULL),
(39529, '2017-07-23 00:00:00', NULL, NULL, 11336, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, NULL, NULL, 2.20, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:32:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39530, '2017-07-23 10:12:57', NULL, NULL, 11337, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:12:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39531, '2017-07-23 10:11:48', NULL, NULL, 11335, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1500781238', 'admin', '2017-07-23 10:11:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39532, '2017-07-23 00:00:00', NULL, NULL, 11336, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:32:13', 'admin-1500771896-15007735336064075', 1, 0, '', NULL, NULL, NULL),
(39533, '2017-07-23 00:00:00', NULL, NULL, 11335, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:32:13', 'admin-1500771896-15007735336064075', 1, 0, '', NULL, NULL, NULL),
(39534, '2017-07-23 09:25:03', NULL, NULL, 11326, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:25:03', 'admin-1500771896-15007731030769362', 1, 1, 'SR', NULL, NULL, NULL),
(39535, '2017-07-23 09:50:13', NULL, NULL, 11331, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:50:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39536, '2017-07-23 09:09:14', NULL, NULL, 11324, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:09:14', 'admin-1500771896-1500772154128795', 1, 0, '', NULL, NULL, NULL),
(39537, '2017-07-23 09:09:14', NULL, NULL, 11324, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:09:14', 'admin-1500771896-1500772154128795', 1, 0, '', NULL, NULL, NULL),
(39538, '2017-07-23 09:09:21', NULL, NULL, 11324, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:09:21', 'admin-1500771896-15007721617301687', 1, 1, 'SR', NULL, NULL, NULL),
(39539, '2017-07-23 09:09:21', NULL, NULL, 11324, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:09:21', 'admin-1500771896-15007721617301687', 1, 0, '', NULL, NULL, NULL),
(39540, '2017-07-23 09:09:08', NULL, NULL, 11324, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1500781238', 'admin', '2017-07-23 09:09:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39541, '2017-07-24 16:18:02', NULL, NULL, 11405, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 16:18:02', 'admin-1500875902-15008842820307561', 1, 1, 'SR', NULL, NULL, NULL),
(39542, '2017-07-24 10:25:40', NULL, NULL, 11386, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:25:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39543, '2017-07-24 10:25:43', NULL, NULL, 11386, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:25:43', 'admin-1500857971-1500863142877906', 1, 1, 'SR', NULL, NULL, NULL),
(39544, '2017-07-24 10:27:16', NULL, NULL, 11385, 0, 181, '116', 'Open Food ', 'additional 2 bacons', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:27:16', 'admin-1500857971-15008632360442756', 1, 0, '', NULL, NULL, NULL),
(39545, '2017-07-24 10:39:27', NULL, NULL, 11387, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:39:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39546, '2017-07-24 10:39:34', NULL, NULL, 11387, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:39:34', 'admin-1500857971-15008639740416982', 1, 0, '', NULL, NULL, NULL),
(39547, '2017-07-24 13:42:34', NULL, NULL, 11402, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1500875902', 'admin', '2017-07-24 13:42:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39548, '2017-07-24 13:46:10', NULL, NULL, 11402, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 13:46:10', 'admin-1500871739-1500875170119378', 1, 1, 'SR', NULL, NULL, NULL),
(39549, '2017-07-24 13:46:10', NULL, NULL, 11402, 0, 225, '159', 'Smoked Duck Salad', 'dressing aside', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 13:46:10', 'admin-1500871739-1500875170119378', 1, 0, '', NULL, NULL, NULL),
(39550, '2017-07-24 13:11:24', NULL, NULL, 11401, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 13:11:24', 'admin-1500871739-1500873083897314', 1, 1, 'SR', NULL, NULL, NULL),
(39551, '2017-07-24 13:11:24', NULL, NULL, 11401, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 13:11:24', 'admin-1500871739-1500873083897314', 1, 1, 'SR', NULL, NULL, NULL),
(39552, '2017-07-24 16:36:33', NULL, NULL, 11411, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1500875902', 'admin', '2017-07-24 16:36:33', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(39553, '2017-07-24 16:36:29', NULL, NULL, 11410, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 16:36:29', 'admin-1500875902-15008853892973790', 1, 1, 'SR', NULL, NULL, NULL),
(39554, '2017-07-24 16:36:38', NULL, NULL, 11411, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 16:36:38', 'admin-1500875902-15008853985218357', 1, 0, '', NULL, NULL, '10.0'),
(39555, '2017-07-24 16:36:38', NULL, NULL, 11411, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 16:36:38', 'admin-1500875902-15008853985218357', 1, 0, '', NULL, NULL, '10.0'),
(39556, '2017-07-24 12:21:14', NULL, NULL, 11395, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:21:14', 'admin-1500864754-15008700740178481', 1, 1, 'SR', NULL, NULL, NULL),
(39557, '2017-07-24 12:23:00', NULL, NULL, 11396, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:23:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39558, '2017-07-24 15:53:34', NULL, NULL, 11409, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 15:53:34', 'admin-1500875902-15008828140418146', 1, 1, 'SR', NULL, NULL, NULL),
(39559, '2017-07-24 11:58:22', NULL, NULL, 11392, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1500875902', 'admin', '2017-07-24 11:58:22', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(39560, '2017-07-24 10:39:34', NULL, NULL, 11387, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:39:34', 'admin-1500857971-15008639740416982', 1, 1, 'SR', NULL, NULL, NULL),
(39561, '2017-07-24 10:44:07', NULL, NULL, 11382, 0, 182, '117', 'Open Drinks ', 'orange', 'Cold Drinks', 'Fresh Juice', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:44:07', 'admin-1500857971-15008642476713942', 1, 0, '', NULL, NULL, NULL),
(39562, '2017-07-24 10:51:29', NULL, NULL, 11388, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:51:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39563, '2017-07-24 10:51:33', NULL, NULL, 11388, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:51:33', 'admin-1500857971-15008646929298650', 1, 0, '', NULL, NULL, NULL),
(39564, '2017-07-24 11:42:45', NULL, NULL, 11391, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 11:42:45', 'admin-1500864754-15008677651589634', 1, 0, '', NULL, NULL, NULL),
(39565, '2017-07-24 11:42:49', NULL, NULL, 11391, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 11:42:49', 'admin-1500864754-15008677695454023', 1, 1, 'SR', NULL, NULL, NULL),
(39566, '2017-07-24 11:58:30', NULL, NULL, 11392, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 11:58:30', 'admin-1500864754-1500868709851498', 1, 1, 'SR', NULL, NULL, '10.0'),
(39567, '2017-07-24 11:58:30', NULL, NULL, 11392, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 11:58:30', 'admin-1500864754-1500868709851498', 1, 0, '', NULL, NULL, '10.0'),
(39568, '2017-07-24 11:59:35', NULL, NULL, 11393, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1500875902', 'admin', '2017-07-24 11:59:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39569, '2017-07-24 14:56:05', NULL, NULL, 11405, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 14:56:05', 'admin-1500875902-15008793649858451', 1, 1, 'SR', NULL, NULL, NULL),
(39570, '2017-07-24 16:36:25', NULL, NULL, 11410, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1500875902', 'admin', '2017-07-24 16:36:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39571, '2017-07-24 12:09:28', NULL, NULL, 11394, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:09:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39572, '2017-07-24 13:11:24', NULL, NULL, 11401, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 13:11:24', 'admin-1500871739-1500873083897314', 1, 1, 'SR', NULL, NULL, NULL),
(39573, '2017-07-24 12:10:28', NULL, NULL, 11394, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:10:28', 'admin-1500864754-15008694282668829', 1, 1, 'SR', NULL, NULL, NULL),
(39574, '2017-07-24 12:12:36', NULL, NULL, 11394, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:12:36', 'admin-1500864754-15008695558876293', 1, 1, 'SR', NULL, NULL, NULL),
(39575, '2017-07-24 12:12:36', NULL, NULL, 11394, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:12:36', 'admin-1500864754-15008695558876293', 1, 0, '', NULL, NULL, NULL),
(39576, '2017-07-24 12:20:43', NULL, NULL, 11395, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:20:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39577, '2017-07-24 12:21:05', NULL, NULL, 11395, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:21:05', 'admin-1500864754-15008700657438718', 1, 0, '', NULL, NULL, NULL),
(39578, '2017-07-24 12:21:05', NULL, NULL, 11395, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:21:05', 'admin-1500864754-15008700657438718', 1, 1, 'SR', NULL, NULL, NULL),
(39579, '2017-07-24 12:21:05', NULL, NULL, 11395, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:21:05', 'admin-1500864754-15008700657438718', 1, 0, '', NULL, NULL, NULL),
(39580, '2017-07-24 12:21:05', NULL, NULL, 11395, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:21:05', 'admin-1500864754-15008700657438718', 1, 0, '', NULL, NULL, NULL),
(39581, '2017-07-24 11:42:40', NULL, NULL, 11391, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1500875902', 'admin', '2017-07-24 11:42:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39582, '2017-07-24 10:51:33', NULL, NULL, 11388, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:51:33', 'admin-1500857971-15008646929298650', 1, 0, '', NULL, NULL, NULL),
(39583, '2017-07-24 12:46:47', NULL, NULL, 11397, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:46:47', 'admin-1500864754-15008716067744925', 1, 1, 'SR', NULL, NULL, NULL),
(39584, '2017-07-24 16:57:56', NULL, NULL, 11411, 0, 285, '219', 'Tip Tap Lor Bak', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 16:57:56', 'admin-1500875902-1500886676046159', 1, 0, '', NULL, NULL, '10.0'),
(39585, '2017-07-24 17:27:37', NULL, NULL, 11411, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 17:27:37', 'admin-1500875902-1500888456809294', 1, 0, '', NULL, NULL, '10.0'),
(39586, '2017-07-24 12:50:53', NULL, NULL, 11398, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:50:53', 'admin-1500871739-15008718535817546', 1, 1, 'SR', NULL, NULL, NULL),
(39587, '2017-07-24 13:02:43', NULL, NULL, 11392, 0, 181, '116', 'Open Food ', 'Teochew stewed pork', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 13:02:43', 'admin-1500871739-15008725628044278', 1, 0, '', NULL, NULL, '10.0'),
(39588, '2017-07-24 13:04:24', NULL, NULL, 11395, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 13:04:24', 'admin-1500871739-15008726643729448', 1, 0, '', NULL, NULL, NULL),
(39589, '2017-07-24 13:06:26', NULL, NULL, 11400, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1500875902', 'admin', '2017-07-24 13:06:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39590, '2017-07-24 12:50:12', NULL, NULL, 11398, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:50:12', 'admin-1500871739-1500871812592503', 1, 1, 'SR', NULL, NULL, NULL),
(39591, '2017-07-24 12:23:14', NULL, NULL, 11396, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:23:14', 'admin-1500864754-1500870194296178', 1, 0, '', NULL, NULL, NULL),
(39592, '2017-07-24 12:23:14', NULL, NULL, 11396, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:23:14', 'admin-1500864754-1500870194296178', 1, 1, 'SR', NULL, NULL, NULL),
(39593, '2017-07-24 12:23:14', NULL, NULL, 11396, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:23:14', 'admin-1500864754-1500870194296178', 1, 0, '', NULL, NULL, NULL),
(39594, '2017-07-24 12:46:37', NULL, NULL, 11397, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:46:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39595, '2017-07-24 12:46:47', NULL, NULL, 11397, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:46:47', 'admin-1500864754-15008716067744925', 1, 0, '', NULL, NULL, NULL),
(39596, '2017-07-24 12:46:47', NULL, NULL, 11397, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:46:47', 'admin-1500864754-15008716067744925', 1, 0, '', NULL, NULL, NULL),
(39597, '2017-07-24 13:46:10', NULL, NULL, 11402, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 13:46:10', 'admin-1500871739-1500875170119378', 1, 0, '', NULL, NULL, NULL),
(39598, '2017-07-24 13:46:35', NULL, NULL, 11401, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 13:46:35', 'admin-1500875180-15008751952103475', 1, 0, '', NULL, NULL, NULL),
(39599, '2017-07-24 13:47:01', NULL, NULL, 11401, 0, 181, '116', 'Open Food ', 'Loh Bak', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 13:47:01', 'admin-1500875180-15008752210989919', 1, 0, '', NULL, NULL, NULL),
(39600, '2017-07-24 13:54:58', NULL, NULL, 11403, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 13:54:58', 'admin-1500875180-15008756983079461', 1, 1, 'SR', 1, NULL, NULL),
(39601, '2017-07-24 14:04:49', NULL, NULL, 11402, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 14:04:49', 'admin-1500875902-15008762895025960', 1, 1, 'SR', NULL, NULL, NULL),
(39602, '2017-07-24 15:21:49', NULL, NULL, 11407, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1500875902', 'admin', '2017-07-24 15:21:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39603, '2017-07-24 00:00:00', NULL, NULL, 11408, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, NULL, NULL, 6.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 14:55:31', 'admin-1500875902-15008793312965593', 1, 1, 'SR', NULL, NULL, NULL),
(39604, '2017-07-24 00:00:00', NULL, NULL, 11406, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 14:55:31', 'admin-1500875902-15008793312965593', 1, 0, '', NULL, NULL, NULL),
(39605, '2017-07-24 00:00:00', NULL, NULL, 11407, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, NULL, NULL, 6.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 14:55:31', 'admin-1500875902-15008793312965593', 1, 1, 'SR', NULL, NULL, NULL),
(39606, '2017-07-24 12:50:12', NULL, NULL, 11398, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:50:12', 'admin-1500871739-1500871812592503', 1, 0, '', NULL, NULL, NULL),
(39607, '2017-07-24 12:50:12', NULL, NULL, 11398, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:50:12', 'admin-1500871739-1500871812592503', 1, 0, '', NULL, NULL, NULL),
(39608, '2017-07-24 09:36:26', NULL, NULL, 11382, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1500875902', 'admin', '2017-07-24 09:36:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39609, '2017-07-24 09:36:41', NULL, NULL, 11382, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 09:36:41', 'admin-1500857971-15008602009737340', 1, 0, '', NULL, NULL, NULL),
(39610, '2017-07-24 09:36:41', NULL, NULL, 11382, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 09:36:41', 'admin-1500857971-15008602009737340', 1, 1, 'SR', NULL, NULL, NULL),
(39611, '2017-07-24 16:25:00', NULL, NULL, 11409, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 16:25:00', 'admin-1500875902-15008847001048851', 1, 1, 'SR', NULL, NULL, NULL),
(39612, '2017-07-24 15:00:32', NULL, NULL, 11405, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 15:00:32', 'admin-1500875902-15008796317733850', 1, 0, '', NULL, NULL, NULL),
(39613, '2017-07-24 14:55:36', NULL, NULL, 11405, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 14:55:36', 'admin-1500875902-15008793361986590', 1, 1, 'SR', NULL, NULL, NULL),
(39614, '2017-07-24 14:55:33', NULL, NULL, 11405, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1500875902', 'admin', '2017-07-24 14:55:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39615, '2017-07-24 00:00:00', NULL, NULL, 11408, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, NULL, NULL, 0.60, 1, '27', 1, '1500875902', 'admin', '2017-07-24 14:55:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39616, '2017-07-24 15:53:30', NULL, NULL, 11409, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 15:53:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39617, '2017-07-24 13:06:28', NULL, NULL, 11400, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 13:06:28', 'admin-1500871739-15008727887284735', 1, 0, '', NULL, NULL, NULL),
(39618, '2017-07-24 13:11:00', NULL, NULL, 11401, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1500875902', 'admin', '2017-07-24 13:11:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39619, '2017-07-24 13:11:24', NULL, NULL, 11401, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 13:11:24', 'admin-1500871739-1500873083897314', 1, 0, '', NULL, NULL, NULL),
(39620, '2017-07-24 12:56:19', NULL, NULL, 11399, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:56:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39621, '2017-07-24 12:56:35', NULL, NULL, 11399, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 2, 21.00, 42.0000, 0.0000, 42.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:56:35', 'admin-1500871739-15008721954616846', 1, 0, '', NULL, NULL, NULL),
(39622, '2017-07-24 12:56:44', NULL, NULL, 11399, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:56:44', 'admin-1500871739-15008722047144685', 1, 0, '', NULL, NULL, NULL),
(39623, '2017-07-24 12:57:02', NULL, NULL, 11399, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:57:02', 'admin-1500871739-15008722225913487', 1, 1, 'SR', NULL, NULL, NULL),
(39624, '2017-07-24 12:57:02', NULL, NULL, 11399, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:57:02', 'admin-1500871739-15008722225913487', 1, 1, 'SR', NULL, NULL, NULL),
(39625, '2017-07-24 13:02:42', NULL, NULL, 11392, 0, 181, '116', 'Open Food ', 'Squid rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 13:02:42', 'admin-1500871739-15008725628044278', 1, 0, '', NULL, NULL, '10.0'),
(39626, '2017-07-24 12:50:12', NULL, NULL, 11398, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:50:12', 'admin-1500871739-1500871812592503', 1, 0, '', NULL, NULL, NULL),
(39627, '2017-07-24 12:50:12', NULL, NULL, 11398, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:50:12', 'admin-1500871739-1500871812592503', 1, 0, '', NULL, NULL, NULL),
(39628, '2017-07-24 12:50:12', NULL, NULL, 11398, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:50:12', 'admin-1500871739-1500871812592503', 1, 0, '', NULL, NULL, NULL),
(39629, '2017-07-24 10:22:33', NULL, NULL, 11384, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:22:33', 'admin-1500857971-15008629535647739', 1, 0, '', NULL, NULL, NULL),
(39630, '2017-07-24 10:22:33', NULL, NULL, 11384, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:22:33', 'admin-1500857971-15008629535647739', 1, 0, '', NULL, NULL, NULL),
(39631, '2017-07-24 10:22:33', NULL, NULL, 11384, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:22:33', 'admin-1500857971-15008629535647739', 1, 1, 'SR', NULL, NULL, NULL),
(39632, '2017-07-24 15:21:21', NULL, NULL, 11406, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1500875902', 'admin', '2017-07-24 15:21:21', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(39633, '2017-07-24 12:50:12', NULL, NULL, 11398, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:50:12', 'admin-1500871739-1500871812592503', 1, 1, 'SR', NULL, NULL, NULL),
(39634, '2017-07-24 12:49:40', NULL, NULL, 11398, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:49:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39635, '2017-07-24 11:18:37', NULL, NULL, 11390, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 11:18:37', 'admin-1500864754-1500866317411758', 1, 1, 'SR', NULL, NULL, NULL),
(39636, '2017-07-24 12:21:14', NULL, NULL, 11395, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 12:21:14', 'admin-1500864754-15008700740178481', 1, 1, 'SR', NULL, NULL, NULL),
(39637, '2017-07-24 11:59:39', NULL, NULL, 11393, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 11:59:39', 'admin-1500864754-15008687788817568', 1, 1, 'SR', NULL, NULL, NULL),
(39638, '2017-07-24 11:18:37', NULL, NULL, 11390, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 11:18:37', 'admin-1500864754-1500866317411758', 1, 0, '', NULL, NULL, NULL),
(39639, '2017-07-24 11:18:37', NULL, NULL, 11390, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 11:18:37', 'admin-1500864754-1500866317411758', 1, 1, 'SR', NULL, NULL, NULL),
(39640, '2017-07-24 11:18:27', NULL, NULL, 11390, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1500875902', 'admin', '2017-07-24 11:18:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39641, '2017-07-24 11:17:57', NULL, NULL, 11389, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 11:17:57', 'admin-1500864754-15008662775511039', 1, 1, 'SR', NULL, NULL, NULL),
(39642, '2017-07-24 11:17:57', NULL, NULL, 11389, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 11:17:57', 'admin-1500864754-15008662775511039', 1, 1, 'SR', NULL, NULL, NULL),
(39643, '2017-07-24 11:17:57', NULL, NULL, 11389, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 11:17:57', 'admin-1500864754-15008662775511039', 1, 0, '', NULL, NULL, NULL),
(39644, '2017-07-24 11:17:50', NULL, NULL, 11389, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1500875902', 'admin', '2017-07-24 11:17:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39645, '2017-07-24 10:23:45', NULL, NULL, 11385, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:23:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39646, '2017-07-24 10:23:56', NULL, NULL, 11385, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:23:56', 'admin-1500857971-15008630367306099', 1, 1, 'SR', NULL, NULL, NULL),
(39647, '2017-07-24 10:23:56', NULL, NULL, 11385, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:23:56', 'admin-1500857971-15008630367306099', 1, 1, 'SR', NULL, NULL, NULL),
(39648, '2017-07-24 10:23:56', NULL, NULL, 11385, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:23:56', 'admin-1500857971-15008630367306099', 1, 1, 'SR', NULL, NULL, NULL),
(39649, '2017-07-24 10:23:56', NULL, NULL, 11385, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:23:56', 'admin-1500857971-15008630367306099', 1, 0, '', NULL, NULL, NULL),
(39650, '2017-07-24 10:23:56', NULL, NULL, 11385, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:23:56', 'admin-1500857971-15008630367306099', 1, 0, '', NULL, NULL, NULL),
(39651, '2017-07-24 10:22:33', NULL, NULL, 11384, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:22:33', 'admin-1500857971-15008629535647739', 1, 1, 'SR', NULL, NULL, NULL),
(39652, '2017-07-24 10:22:33', NULL, NULL, 11384, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:22:33', 'admin-1500857971-15008629535647739', 1, 0, '', NULL, NULL, NULL),
(39653, '2017-07-24 10:22:21', NULL, NULL, 11384, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:22:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39654, '2017-07-24 10:21:10', NULL, NULL, 11383, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 10:21:10', 'admin-1500857971-15008628706299811', 1, 1, 'SR', 1, NULL, '10.0'),
(39655, '2017-07-24 09:05:14', NULL, NULL, 11381, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 09:05:14', 'admin-1500857971-1500858314331649', 1, 1, 'SR', NULL, NULL, NULL),
(39656, '2017-07-24 09:05:14', NULL, NULL, 11381, 0, 181, '116', 'Open Food ', 'junior blt', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1500875902', 'admin', '2017-07-24 09:05:14', 'admin-1500857971-1500858314331649', 1, 0, '', NULL, NULL, NULL),
(39657, '2017-07-24 09:05:00', NULL, NULL, 11381, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1500875902', 'admin', '2017-07-24 09:05:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39658, '2017-07-26 17:42:19', NULL, NULL, 11446, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 17:42:19', 'admin-1501053580-15010621392822221', 1, 0, '', 1, NULL, '10.0'),
(39659, '2017-07-26 17:49:14', NULL, NULL, 11447, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 17:49:14', 'admin-1501053580-15010625545678671', 1, 0, '', NULL, NULL, NULL),
(39660, '2017-07-26 17:46:28', NULL, NULL, 11445, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 17:46:28', 'admin-1501053580-15010623887057174', 1, 0, '', NULL, NULL, NULL),
(39661, '2017-07-26 15:51:32', NULL, NULL, 11439, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 15:51:32', 'admin-1501053580-15010554922797875', 1, 1, 'SR', NULL, NULL, NULL),
(39662, '2017-07-26 17:43:32', NULL, NULL, 11447, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1501053580', 'admin', '2017-07-26 17:43:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39663, '2017-07-26 17:43:36', NULL, NULL, 11447, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 17:43:36', 'admin-1501053580-15010622163138654', 1, 0, '', NULL, NULL, NULL),
(39664, '2017-07-26 17:42:19', NULL, NULL, 11446, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 17:42:19', 'admin-1501053580-15010621392822221', 1, 0, '', 1, NULL, '10.0'),
(39665, '2017-07-26 17:11:17', NULL, NULL, 11436, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 17:11:17', 'admin-1501053580-15010602769767889', 1, 1, 'SR', 1, NULL, '10.0'),
(39666, '2017-07-26 17:05:43', NULL, NULL, 11445, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 17:05:43', 'admin-1501053580-15010599436369026', 1, 0, '', NULL, NULL, NULL),
(39667, '2017-07-26 17:05:41', NULL, NULL, 11445, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1501053580', 'admin', '2017-07-26 17:05:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39668, '2017-07-26 11:14:33', NULL, NULL, 11420, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:14:33', 'admin-1501037957-15010388729771146', 1, 0, '', NULL, NULL, NULL),
(39669, '2017-07-26 11:14:33', NULL, NULL, 11420, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:14:33', 'admin-1501037957-15010388729771146', 1, 1, 'SR', NULL, NULL, NULL),
(39670, '2017-07-26 13:02:20', NULL, NULL, 11431, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 13:02:20', 'admin-1501044964-15010453402495435', 1, 1, 'SR', NULL, NULL, NULL),
(39671, '2017-07-26 12:27:22', NULL, NULL, 11429, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1501053580', 'admin', '2017-07-26 12:27:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39672, '2017-07-26 15:42:50', NULL, NULL, 11444, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1501053580', 'admin', '2017-07-26 15:42:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39673, '2017-07-26 15:43:30', NULL, NULL, 11444, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 15:43:30', 'admin-1501053580-15010550099089690', 1, 1, 'SR', NULL, NULL, NULL),
(39674, '2017-07-26 15:42:01', NULL, NULL, 11442, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 15:42:01', 'admin-1501053580-15010549216614940', 1, 1, 'SR', NULL, NULL, NULL),
(39675, '2017-07-26 13:26:52', NULL, NULL, 11434, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 13:26:52', 'admin-1501044964-15010468124528086', 1, 1, 'SR', 1, NULL, '10.0'),
(39676, '2017-07-26 15:42:01', NULL, NULL, 11442, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 15:42:01', 'admin-1501053580-15010549216614940', 1, 1, 'SR', NULL, NULL, NULL),
(39677, '2017-07-26 15:42:01', NULL, NULL, 11442, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 15:42:01', 'admin-1501053580-15010549216614940', 1, 1, 'SR', NULL, NULL, NULL),
(39678, '2017-07-26 15:00:57', NULL, NULL, 11439, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 15:00:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39679, '2017-07-26 15:00:59', NULL, NULL, 11439, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 15:00:59', 'admin-1501044964-15010524597874061', 1, 1, 'SR', NULL, NULL, NULL),
(39680, '2017-07-26 15:11:37', NULL, NULL, 11440, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1501053580', 'admin', '2017-07-26 15:11:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39681, '2017-07-26 15:11:43', NULL, NULL, 11440, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 15:11:43', 'admin-1501044964-15010531029624844', 1, 1, 'SR', NULL, NULL, NULL),
(39682, '2017-07-26 15:20:05', NULL, NULL, 11439, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 15:20:05', 'admin-1501053580-15010536057068842', 1, 1, 'SR', NULL, NULL, NULL),
(39683, '2017-07-26 15:29:46', NULL, NULL, 11441, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.30, 0.0000, 0.0000, 0.30, 1, '27', 1, '1501053580', 'admin', '2017-07-26 15:29:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39684, '2017-07-26 15:30:05', NULL, NULL, 11441, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 15:30:05', 'admin-1501053580-15010542048512163', 1, 0, '', NULL, NULL, NULL),
(39685, '2017-07-26 15:31:15', NULL, NULL, 11442, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1501053580', 'admin', '2017-07-26 15:31:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39686, '2017-07-26 15:31:29', NULL, NULL, 11442, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 15:31:29', 'admin-1501053580-15010542889572986', 1, 0, '', NULL, NULL, NULL),
(39687, '2017-07-26 15:31:29', NULL, NULL, 11442, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 15:31:29', 'admin-1501053580-15010542889572986', 1, 1, 'SR', NULL, NULL, NULL),
(39688, '2017-07-26 15:32:34', NULL, NULL, 11443, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1501053580', 'admin', '2017-07-26 15:32:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39689, '2017-07-26 15:32:49', NULL, NULL, 11443, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 15:32:49', 'admin-1501053580-15010543698151564', 1, 1, 'SR', NULL, NULL, NULL),
(39690, '2017-07-26 15:32:49', NULL, NULL, 11443, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 15:32:50', 'admin-1501053580-15010543698151564', 1, 0, '', NULL, NULL, NULL),
(39691, '2017-07-26 15:42:01', NULL, NULL, 11442, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 15:42:01', 'admin-1501053580-15010549216614940', 1, 1, 'SR', NULL, NULL, NULL),
(39692, '2017-07-26 10:40:01', NULL, NULL, 11416, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 10:40:01', 'admin-1501031193-15010368016518899', 1, 1, 'SR', NULL, NULL, NULL),
(39693, '2017-07-26 15:00:54', NULL, NULL, 11438, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 15:00:54', 'admin-1501044964-15010524539633013', 1, 1, 'SR', NULL, NULL, NULL),
(39694, '2017-07-26 12:56:29', NULL, NULL, 11430, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 12:56:29', 'admin-1501044964-15010449892176679', 1, 1, 'SR', NULL, NULL, NULL),
(39695, '2017-07-26 12:34:06', NULL, NULL, 11424, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 12:34:06', 'admin-1501040900-15010436461422394', 1, 1, 'SR', NULL, NULL, NULL),
(39696, '2017-07-26 12:55:53', NULL, NULL, 11430, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1501053580', 'admin', '2017-07-26 12:55:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39697, '2017-07-26 12:55:58', NULL, NULL, 11430, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 12:55:58', 'admin-1501040900-15010449587576910', 1, 0, '', NULL, NULL, NULL),
(39698, '2017-07-26 11:14:24', NULL, NULL, 11420, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:14:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39699, '2017-07-26 12:15:03', NULL, NULL, 11421, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 12:15:03', 'admin-1501040900-15010425036712447', 1, 1, 'SR', NULL, NULL, NULL),
(39700, '2017-07-26 14:18:11', NULL, NULL, 11438, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 14:18:11', 'admin-1501044964-15010498915629152', 1, 0, '', NULL, NULL, NULL),
(39701, '2017-07-26 14:18:11', NULL, NULL, 11438, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 14:18:11', 'admin-1501044964-15010498915629152', 1, 1, 'SR', NULL, NULL, NULL),
(39702, '2017-07-26 14:18:11', NULL, NULL, 11438, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 14:18:11', 'admin-1501044964-15010498915629152', 1, 0, '', NULL, NULL, NULL),
(39703, '2017-07-26 14:18:11', NULL, NULL, 11438, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 14:18:11', 'admin-1501044964-15010498915629152', 1, 0, '', NULL, NULL, NULL),
(39704, '2017-07-26 13:44:02', NULL, NULL, 11437, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 13:44:02', 'admin-1501044964-1501047842206701', 1, 0, '', 1, NULL, NULL),
(39705, '2017-07-26 13:38:18', NULL, NULL, 11436, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 13:38:18', 'admin-1501044964-15010474984451144', 1, 1, 'SR', 1, NULL, '10.0'),
(39706, '2017-07-26 13:38:18', NULL, NULL, 11436, 0, 181, '116', 'Open Food ', 'garlic rice', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 13:38:18', 'admin-1501044964-15010474984451144', 1, 0, '', 1, NULL, '10.0'),
(39707, '2017-07-26 17:42:19', NULL, NULL, 11446, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 17:42:19', 'admin-1501053580-15010621392822221', 1, 0, '', 1, NULL, '10.0'),
(39708, '2017-07-26 13:19:56', NULL, NULL, 11433, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 13:19:56', 'admin-1501044964-15010463966439327', 1, 1, 'SR', NULL, NULL, NULL),
(39709, '2017-07-26 13:19:56', NULL, NULL, 11433, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 13:19:56', 'admin-1501044964-15010463966439327', 1, 1, 'SR', NULL, NULL, NULL),
(39710, '2017-07-26 13:03:34', NULL, NULL, 11432, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 13:03:34', 'admin-1501044964-15010454145774724', 1, 1, 'SR', NULL, NULL, NULL),
(39711, '2017-07-26 13:03:52', NULL, NULL, 11431, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 13:03:52', 'admin-1501044964-1501045432181234', 1, 1, 'SR', NULL, NULL, NULL),
(39712, '2017-07-26 13:19:32', NULL, NULL, 11433, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1501053580', 'admin', '2017-07-26 13:19:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39713, '2017-07-26 10:40:01', NULL, NULL, 11416, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 10:40:01', 'admin-1501031193-15010368016518899', 1, 0, '', NULL, NULL, NULL),
(39714, '2017-07-26 10:40:01', NULL, NULL, 11416, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 10:40:01', 'admin-1501031193-15010368016518899', 1, 0, '', NULL, NULL, NULL),
(39715, '2017-07-26 11:43:18', NULL, NULL, 11423, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:43:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39716, '2017-07-26 11:44:50', NULL, NULL, 11423, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:44:50', 'admin-1501037957-15010406905684051', 1, 0, '', NULL, NULL, NULL),
(39717, '2017-07-26 11:44:50', NULL, NULL, 11423, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:44:50', 'admin-1501037957-15010406905684051', 1, 0, '', NULL, NULL, NULL),
(39718, '2017-07-26 11:44:59', NULL, NULL, 11423, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:44:59', 'admin-1501037957-15010406992371363', 1, 1, 'SR', NULL, NULL, NULL),
(39719, '2017-07-26 11:44:59', NULL, NULL, 11423, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:44:59', 'admin-1501037957-15010406992371363', 1, 1, 'SR', NULL, NULL, NULL),
(39720, '2017-07-26 11:48:11', NULL, NULL, 11424, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:48:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39721, '2017-07-26 11:48:15', NULL, NULL, 11424, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:48:15', 'admin-1501037957-15010408948086761', 1, 1, 'SR', NULL, NULL, NULL),
(39722, '2017-07-26 10:52:09', NULL, NULL, 11417, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1501053580', 'admin', '2017-07-26 10:52:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39723, '2017-07-26 10:52:33', NULL, NULL, 11417, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 10:52:33', 'admin-1501031193-1501037552998737', 1, 0, '', NULL, NULL, NULL),
(39724, '2017-07-26 14:17:57', NULL, NULL, 11438, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1501053580', 'admin', '2017-07-26 14:17:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39725, '2017-07-26 13:03:34', NULL, NULL, 11432, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 13:03:34', 'admin-1501044964-15010454145774724', 1, 0, '', NULL, NULL, NULL),
(39726, '2017-07-26 13:03:34', NULL, NULL, 11432, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 13:03:34', 'admin-1501044964-15010454145774724', 1, 0, '', NULL, NULL, NULL),
(39727, '2017-07-26 13:03:23', NULL, NULL, 11432, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1501053580', 'admin', '2017-07-26 13:03:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39728, '2017-07-26 13:17:03', NULL, NULL, 11431, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 13:17:03', 'admin-1501044964-15010462227618058', 1, 0, '', NULL, NULL, NULL),
(39729, '2017-07-26 11:22:21', NULL, NULL, 11421, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:22:21', 'admin-1501037957-15010393409097289', 1, 0, '', NULL, NULL, NULL),
(39730, '2017-07-26 00:00:00', NULL, NULL, 11427, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:27:01', 'admin-1501037957-15010396210548083', 1, 0, '', NULL, NULL, NULL),
(39731, '2017-07-26 13:01:45', NULL, NULL, 11431, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1501053580', 'admin', '2017-07-26 13:01:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39732, '2017-07-26 12:29:57', NULL, NULL, 11429, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 12:29:57', 'admin-1501040900-1501043397148139', 1, 1, 'SR', NULL, NULL, NULL),
(39733, '2017-07-26 12:29:34', NULL, NULL, 11429, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 12:29:34', 'admin-1501040900-15010433747968325', 1, 1, 'SR', NULL, NULL, NULL),
(39734, '2017-07-26 12:57:07', NULL, NULL, 11424, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 12:57:07', 'admin-1501044964-15010450273276147', 1, 0, '', NULL, NULL, NULL),
(39735, '2017-07-26 09:06:49', NULL, NULL, 11412, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 09:06:49', 'admin-1501031193-15010312087605272', 1, 0, '', NULL, NULL, NULL),
(39736, '2017-07-26 09:06:49', NULL, NULL, 11412, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 09:06:49', 'admin-1501031193-15010312087605272', 1, 0, '', NULL, NULL, NULL),
(39737, '2017-07-26 09:06:53', NULL, NULL, 11412, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 09:06:53', 'admin-1501031193-15010312131718583', 1, 0, '', NULL, NULL, NULL),
(39738, '2017-07-26 09:06:53', NULL, NULL, 11412, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 09:06:53', 'admin-1501031193-15010312131718583', 1, 0, '', NULL, NULL, NULL),
(39739, '2017-07-26 12:29:35', NULL, NULL, 11429, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 12:29:35', 'admin-1501040900-15010433747968325', 1, 0, '', NULL, NULL, NULL),
(39740, '2017-07-26 11:48:30', NULL, NULL, 11424, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:48:30', 'admin-1501040900-15010409104017263', 1, 1, 'SR', NULL, NULL, NULL),
(39741, '2017-07-26 09:34:46', NULL, NULL, 11413, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 09:34:46', 'admin-1501031193-15010328858847648', 1, 1, 'SR', NULL, NULL, NULL),
(39742, '2017-07-26 10:05:11', NULL, NULL, 11414, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1501053580', 'admin', '2017-07-26 10:05:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39743, '2017-07-26 11:25:57', NULL, NULL, 11422, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:25:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39744, '2017-07-26 00:00:00', NULL, NULL, 11426, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:27:01', 'admin-1501037957-15010396210548083', 1, 0, '', NULL, NULL, NULL),
(39745, '2017-07-26 11:26:24', NULL, NULL, 11422, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:26:24', 'admin-1501037957-15010395847365399', 1, 1, 'SR', NULL, NULL, NULL),
(39746, '2017-07-26 00:00:00', NULL, NULL, 11428, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:26:24', 'admin-1501037957-15010395847365399', 1, 1, 'SR', NULL, NULL, NULL),
(39747, '2017-07-26 12:21:48', NULL, NULL, 11424, 0, 74, '74', 'Sunrice', 'Takeaway', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 12:21:48', 'admin-1501040900-1501042908058911', 1, 1, 'SR', NULL, NULL, NULL),
(39748, '2017-07-26 12:08:46', NULL, NULL, 11425, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 12:08:46', 'admin-1501040900-1501042126061664', 1, 1, 'SR', NULL, NULL, NULL),
(39749, '2017-07-26 12:08:36', NULL, NULL, 11425, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 12:08:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39750, '2017-07-26 12:08:46', NULL, NULL, 11425, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 12:08:46', 'admin-1501040900-1501042126061664', 1, 1, 'SR', NULL, NULL, NULL),
(39751, '2017-07-26 11:59:50', NULL, NULL, 11424, 0, 285, '219', 'Tip Tap Lor Bak', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:59:50', 'admin-1501040900-15010415902038692', 1, 0, '', NULL, NULL, NULL),
(39752, '2017-07-26 11:59:03', NULL, NULL, 11424, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:59:03', 'admin-1501040900-15010415435382519', 1, 1, 'SR', NULL, NULL, NULL),
(39753, '2017-07-26 12:18:46', NULL, NULL, 11427, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1501053580', 'admin', '2017-07-26 12:18:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39754, '2017-07-26 12:19:17', NULL, NULL, 11428, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1501053580', 'admin', '2017-07-26 12:19:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39755, '2017-07-26 11:27:01', NULL, NULL, 11422, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:27:01', 'admin-1501037957-15010396210548083', 1, 0, '', NULL, NULL, NULL),
(39756, '2017-07-26 12:18:06', NULL, NULL, 11426, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1501053580', 'admin', '2017-07-26 12:18:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39757, '2017-07-26 00:00:00', NULL, NULL, 11427, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:27:19', 'admin-1501037957-15010396392262963', 1, 0, '', NULL, NULL, NULL),
(39758, '2017-07-26 00:00:00', NULL, NULL, 11428, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:27:01', 'admin-1501037957-15010396210548083', 1, 0, '', NULL, NULL, NULL),
(39759, '2017-07-26 11:22:37', NULL, NULL, 11420, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:22:37', 'admin-1501037957-15010393571104653', 1, 1, 'SR', NULL, NULL, NULL),
(39760, '2017-07-26 00:00:00', NULL, NULL, 11426, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:41:11', 'admin-1501037957-15010404712629375', 1, 1, 'SR', NULL, NULL, NULL),
(39761, '2017-07-26 11:22:21', NULL, NULL, 11421, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:22:21', 'admin-1501037957-15010393409097289', 1, 0, '', NULL, NULL, NULL),
(39762, '2017-07-26 11:22:25', NULL, NULL, 11421, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:22:25', 'admin-1501037957-15010393455753788', 1, 1, 'SR', NULL, NULL, NULL),
(39763, '2017-07-26 11:22:14', NULL, NULL, 11421, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:22:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39764, '2017-07-26 11:14:33', NULL, NULL, 11420, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:14:33', 'admin-1501037957-15010388729771146', 1, 0, '', NULL, NULL, NULL),
(39765, '2017-07-26 11:02:53', NULL, NULL, 11419, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:02:53', 'admin-1501037957-15010381732304540', 1, 0, '', NULL, NULL, NULL),
(39766, '2017-07-26 11:02:53', NULL, NULL, 11419, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:02:53', 'admin-1501037957-15010381732304540', 1, 1, 'SR', NULL, NULL, NULL),
(39767, '2017-07-26 11:02:32', NULL, NULL, 11419, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1501053580', 'admin', '2017-07-26 11:02:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39768, '2017-07-26 10:58:56', NULL, NULL, 11418, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 10:58:56', 'admin-1501031193-15010379362771173', 1, 1, 'SR', NULL, NULL, NULL),
(39769, '2017-07-26 10:58:56', NULL, NULL, 11418, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 10:58:56', 'admin-1501031193-15010379362771173', 1, 0, '', NULL, NULL, NULL),
(39770, '2017-07-26 10:58:49', NULL, NULL, 11418, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1501053580', 'admin', '2017-07-26 10:58:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39771, '2017-07-26 10:52:33', NULL, NULL, 11417, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 10:52:33', 'admin-1501031193-1501037552998737', 1, 0, '', NULL, NULL, NULL),
(39772, '2017-07-26 10:52:51', NULL, NULL, 11417, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 10:52:51', 'admin-1501031193-15010375716707966', 1, 1, 'SR', NULL, NULL, NULL),
(39773, '2017-07-26 13:23:57', NULL, NULL, 11430, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 13:23:57', 'admin-1501044964-15010466375628774', 1, 1, 'SR', NULL, NULL, NULL),
(39774, '2017-07-26 10:05:20', NULL, NULL, 11414, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 10:05:20', 'admin-1501031193-15010347199278070', 1, 0, '', NULL, NULL, NULL),
(39775, '2017-07-26 10:05:20', NULL, NULL, 11414, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 10:05:20', 'admin-1501031193-15010347199278070', 1, 1, 'SR', NULL, NULL, NULL),
(39776, '2017-07-26 10:40:01', NULL, NULL, 11416, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 10:40:01', 'admin-1501031193-15010368016518899', 1, 0, '', NULL, NULL, NULL),
(39777, '2017-07-26 10:39:51', NULL, NULL, 11416, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1501053580', 'admin', '2017-07-26 10:39:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39778, '2017-07-26 10:19:34', NULL, NULL, 11415, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 10:19:34', 'admin-1501031193-15010355744906156', 1, 0, '', NULL, NULL, NULL),
(39779, '2017-07-26 10:05:20', NULL, NULL, 11414, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 10:05:20', 'admin-1501031193-15010347199278070', 1, 1, 'SR', NULL, NULL, NULL),
(39780, '2017-07-26 09:34:46', NULL, NULL, 11413, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 09:34:46', 'admin-1501031193-15010328858847648', 1, 1, 'SR', NULL, NULL, NULL),
(39781, '2017-07-26 09:34:29', NULL, NULL, 11413, 0, 153, '87', 'Wake Me Up!', 'Toast change to 1 fried egg', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 09:34:29', 'admin-1501031193-15010328692379056', 1, 0, '', NULL, NULL, NULL),
(39782, '2017-07-26 09:34:29', NULL, NULL, 11413, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501053580', 'admin', '2017-07-26 09:34:29', 'admin-1501031193-15010328692379056', 1, 0, '', NULL, NULL, NULL),
(39783, '2017-07-26 09:32:56', NULL, NULL, 11413, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1501053580', 'admin', '2017-07-26 09:32:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39784, '2017-07-26 09:06:41', NULL, NULL, 11412, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1501053580', 'admin', '2017-07-26 09:06:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39785, '2017-07-27 12:42:02', NULL, NULL, 11462, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 12:42:02', 'admin-1501115441-15011305222522386', 1, 1, 'SR', NULL, NULL, NULL),
(39786, '2017-07-27 12:42:02', NULL, NULL, 11462, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 12:42:02', 'admin-1501115441-15011305222522386', 1, 1, 'SR', NULL, NULL, NULL),
(39787, '2017-07-27 13:41:31', NULL, NULL, 11468, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:41:31', 'admin-1501115441-15011340910839215', 1, 0, '', NULL, NULL, NULL),
(39788, '2017-07-27 16:25:35', NULL, NULL, 11476, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 16:25:35', 'admin-1501134804-15011439354161893', 1, 1, 'SR', NULL, NULL, NULL),
(39789, '2017-07-27 16:25:35', NULL, NULL, 11476, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 16:25:35', 'admin-1501134804-15011439354161893', 1, 1, 'SR', NULL, NULL, NULL),
(39790, '2017-07-27 11:30:17', NULL, NULL, 11455, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 11:30:17', 'admin-1501115441-15011262169346517', 1, 1, 'SR', NULL, NULL, NULL),
(39791, '2017-07-27 11:30:17', NULL, NULL, 11455, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 11:30:17', 'admin-1501115441-15011262169346517', 1, 1, 'SR', NULL, NULL, NULL),
(39792, '2017-07-27 11:30:49', NULL, NULL, 11456, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1501147751', 'admin', '2017-07-27 11:30:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39793, '2017-07-27 16:46:47', NULL, NULL, 11478, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1501147751', 'admin', '2017-07-27 16:46:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39794, '2017-07-27 16:46:51', NULL, NULL, 11478, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 16:46:51', 'admin-1501134804-15011452110671649', 1, 1, 'SR', NULL, NULL, NULL),
(39795, '2017-07-27 16:46:12', NULL, NULL, 11477, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1501147751', 'admin', '2017-07-27 16:46:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39796, '2017-07-27 16:36:56', NULL, NULL, 11476, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 16:36:56', 'admin-1501134804-15011446162006542', 1, 0, '', NULL, NULL, NULL),
(39797, '2017-07-27 13:53:17', NULL, NULL, 11470, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:53:17', 'admin-1501115441-15011347976807365', 1, 0, '', NULL, NULL, NULL),
(39798, '2017-07-27 13:53:17', NULL, NULL, 11470, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:53:17', 'admin-1501115441-15011347976807365', 1, 0, '', NULL, NULL, NULL),
(39799, '2017-07-27 13:53:47', NULL, NULL, 11470, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:53:47', 'admin-1501134804-15011348277192352', 1, 0, '', NULL, NULL, NULL),
(39800, '2017-07-27 12:41:47', NULL, NULL, 11462, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1501147751', 'admin', '2017-07-27 12:41:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39801, '2017-07-27 13:40:58', NULL, NULL, 11468, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:40:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39802, '2017-07-27 13:41:31', NULL, NULL, 11468, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:41:31', 'admin-1501115441-15011340910839215', 1, 1, 'SR', NULL, NULL, NULL),
(39803, '2017-07-27 16:25:35', NULL, NULL, 11476, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 16:25:35', 'admin-1501134804-15011439354161893', 1, 1, 'SR', NULL, NULL, NULL),
(39804, '2017-07-27 16:23:03', NULL, NULL, 11476, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1501147751', 'admin', '2017-07-27 16:23:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39805, '2017-07-27 16:18:53', NULL, NULL, 11471, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 16:18:53', 'admin-1501134804-1501143533379588', 1, 1, 'SR', NULL, NULL, NULL),
(39806, '2017-07-27 15:11:44', NULL, NULL, 11473, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1501147751', 'admin', '2017-07-27 15:11:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39807, '2017-07-27 15:55:13', NULL, NULL, 11475, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 15:55:13', 'admin-1501134804-15011421132988571', 1, 1, 'SR', NULL, NULL, NULL),
(39808, '2017-07-27 15:17:29', NULL, NULL, 11474, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1501147751', 'admin', '2017-07-27 15:17:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39809, '2017-07-27 15:17:37', NULL, NULL, 11474, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 15:17:37', 'admin-1501134804-1501139857287381', 1, 0, '', NULL, NULL, NULL),
(39810, '2017-07-27 15:17:37', NULL, NULL, 11474, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 15:17:37', 'admin-1501134804-1501139857287381', 1, 1, 'SR', NULL, NULL, NULL),
(39811, '2017-07-27 15:55:13', NULL, NULL, 11475, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 15:55:13', 'admin-1501134804-15011421132988571', 1, 1, 'SR', NULL, NULL, NULL),
(39812, '2017-07-27 15:29:32', NULL, NULL, 11471, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 15:29:32', 'admin-1501134804-15011405719454366', 1, 1, 'SR', NULL, NULL, NULL),
(39813, '2017-07-27 15:02:11', NULL, NULL, 11471, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 15:02:11', 'admin-1501134804-15011389309551922', 1, 1, 'SR', NULL, NULL, NULL),
(39814, '2017-07-27 15:11:39', NULL, NULL, 11472, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 15:11:39', 'admin-1501134804-15011394990994487', 1, 1, 'SR', NULL, NULL, NULL),
(39815, '2017-07-27 11:30:00', NULL, NULL, 11454, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1501147751', 'admin', '2017-07-27 11:30:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39816, '2017-07-27 11:30:02', NULL, NULL, 11454, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 11:30:02', 'admin-1501115441-15011262027453013', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(39817, '2017-07-27 11:27:26', NULL, NULL, 11453, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 11:27:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39818, '2017-07-27 12:26:10', NULL, NULL, 11459, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1501147751', 'admin', '2017-07-27 12:26:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39819, '2017-07-27 12:26:16', NULL, NULL, 11459, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 12:26:16', 'admin-1501115441-15011295762422587', 1, 1, 'SR', NULL, NULL, NULL),
(39820, '2017-07-27 12:33:51', NULL, NULL, 11460, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1501147751', 'admin', '2017-07-27 12:33:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39821, '2017-07-27 12:34:00', NULL, NULL, 11460, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 12:34:00', 'admin-1501115441-15011300399775576', 1, 1, 'SR', NULL, NULL, NULL),
(39822, '2017-07-27 12:34:00', NULL, NULL, 11460, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 12:34:00', 'admin-1501115441-15011300399775576', 1, 1, 'SR', NULL, NULL, NULL),
(39823, '2017-07-27 12:34:00', NULL, NULL, 11460, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 12:34:00', 'admin-1501115441-15011300399775576', 1, 1, 'SR', NULL, NULL, NULL),
(39824, '2017-07-27 12:34:00', NULL, NULL, 11460, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 12:34:00', 'admin-1501115441-15011300399775576', 1, 1, 'SR', NULL, NULL, NULL),
(39825, '2017-07-27 11:27:32', NULL, NULL, 11453, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 11:27:32', 'admin-1501115441-15011260524465570', 1, 1, 'SR', NULL, NULL, NULL),
(39826, '2017-07-27 11:27:32', NULL, NULL, 11453, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 11:27:32', 'admin-1501115441-15011260524465570', 1, 1, 'SR', NULL, NULL, NULL),
(39827, '2017-07-27 16:25:35', NULL, NULL, 11476, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 16:25:35', 'admin-1501134804-15011439354161893', 1, 1, 'SR', NULL, NULL, NULL),
(39828, '2017-07-27 15:11:48', NULL, NULL, 11473, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 15:11:48', 'admin-1501134804-15011395084205194', 1, 1, 'SR', NULL, NULL, NULL),
(39829, '2017-07-27 15:11:39', NULL, NULL, 11472, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 15:11:39', 'admin-1501134804-15011394990994487', 1, 1, 'SR', NULL, NULL, NULL),
(39830, '2017-07-27 15:55:08', NULL, NULL, 11475, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1501147751', 'admin', '2017-07-27 15:55:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39831, '2017-07-27 14:31:42', NULL, NULL, 11470, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 14:31:42', 'admin-1501134804-15011371026723289', 1, 0, '', NULL, NULL, NULL),
(39832, '2017-07-27 14:18:07', NULL, NULL, 11472, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 14:18:07', 'admin-1501134804-15011362869512421', 1, 1, 'SR', NULL, NULL, NULL),
(39833, '2017-07-27 14:18:00', NULL, NULL, 11472, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 14:18:00', 'admin-1501134804-15011362807741376', 1, 0, '', NULL, NULL, NULL),
(39834, '2017-07-27 13:06:42', NULL, NULL, 11464, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:06:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39835, '2017-07-27 13:06:51', NULL, NULL, 11464, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:06:51', 'admin-1501115441-15011320114735987', 1, 1, 'SR', NULL, NULL, NULL),
(39836, '2017-07-27 13:06:51', NULL, NULL, 11464, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:06:51', 'admin-1501115441-15011320114735987', 1, 1, 'SR', NULL, NULL, NULL),
(39837, '2017-07-27 13:26:00', NULL, NULL, 11466, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:26:00', 'admin-1501115441-15011331598587847', 1, 1, 'SR', NULL, NULL, NULL),
(39838, '2017-07-27 14:13:54', NULL, NULL, 11472, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 14:13:54', 'admin-1501134804-15011360341794748', 1, 1, 'SR', NULL, NULL, NULL),
(39839, '2017-07-27 14:13:39', NULL, NULL, 11472, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1501147751', 'admin', '2017-07-27 14:13:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39840, '2017-07-27 14:10:05', NULL, NULL, 11471, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 14:10:05', 'admin-1501134804-15011358052903062', 1, 1, 'SR', NULL, NULL, NULL),
(39841, '2017-07-27 14:10:05', NULL, NULL, 11471, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 14:10:05', 'admin-1501134804-15011358052903062', 1, 1, 'SR', NULL, NULL, NULL),
(39842, '2017-07-27 14:10:00', NULL, NULL, 11471, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1501147751', 'admin', '2017-07-27 14:10:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39843, '2017-07-27 14:18:00', NULL, NULL, 11472, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 14:18:00', 'admin-1501134804-15011362807741376', 1, 0, '', NULL, NULL, NULL),
(39844, '2017-07-27 13:53:47', NULL, NULL, 11470, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:53:47', 'admin-1501134804-15011348277192352', 1, 0, '', NULL, NULL, NULL),
(39845, '2017-07-27 10:50:02', NULL, NULL, 11450, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1501147751', 'admin', '2017-07-27 10:50:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39846, '2017-07-27 10:50:11', NULL, NULL, 11450, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 10:50:11', 'admin-1501115441-15011238113938858', 1, 0, '', NULL, NULL, NULL),
(39847, '2017-07-27 13:22:27', NULL, NULL, 11465, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:22:27', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(39848, '2017-07-27 12:23:56', NULL, NULL, 11457, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 12:23:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39849, '2017-07-27 12:24:00', NULL, NULL, 11457, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 12:24:00', 'admin-1501115441-15011294404474457', 1, 1, 'SR', NULL, NULL, NULL),
(39850, '2017-07-27 13:53:08', NULL, NULL, 11470, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:53:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39851, '2017-07-27 13:51:47', NULL, NULL, 11469, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:51:47', 'admin-1501115441-1501134707556746', 1, 0, '', NULL, NULL, NULL),
(39852, '2017-07-27 13:51:45', NULL, NULL, 11469, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:51:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39853, '2017-07-27 13:38:36', NULL, NULL, 11465, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:38:36', 'admin-1501115441-15011339158325496', 1, 1, 'SR', NULL, NULL, '10.0'),
(39854, '2017-07-27 13:34:04', NULL, NULL, 11467, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:34:04', 'admin-1501115441-15011336447772668', 1, 1, 'SR', NULL, NULL, '10.0'),
(39855, '2017-07-27 13:34:04', NULL, NULL, 11467, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:34:04', 'admin-1501115441-15011336447772668', 1, 0, '', NULL, NULL, '10.0'),
(39856, '2017-07-27 13:33:56', NULL, NULL, 11467, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:33:56', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(39857, '2017-07-27 13:26:00', NULL, NULL, 11466, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:26:00', 'admin-1501115441-15011331598587847', 1, 0, '', NULL, NULL, NULL),
(39858, '2017-07-27 13:25:51', NULL, NULL, 11466, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:25:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39859, '2017-07-27 13:23:41', NULL, NULL, 11465, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:23:41', 'admin-1501115441-15011330218016553', 1, 0, '', NULL, NULL, '10.0'),
(39860, '2017-07-27 13:22:58', NULL, NULL, 11465, 0, 285, '219', 'Tip Tap Lor Bak', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:22:58', 'admin-1501115441-15011329780615845', 1, 0, '', NULL, NULL, '10.0'),
(39861, '2017-07-27 13:22:58', NULL, NULL, 11465, 0, 272, '206', 'Genius in The Bowl', 'with egg', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:22:58', 'admin-1501115441-15011329780615845', 1, 0, '', NULL, NULL, '10.0'),
(39862, '2017-07-27 13:22:58', NULL, NULL, 11465, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:22:58', 'admin-1501115441-15011329780615845', 1, 1, 'SR', NULL, NULL, '10.0'),
(39863, '2017-07-27 13:22:58', NULL, NULL, 11465, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:22:58', 'admin-1501115441-15011329780615845', 1, 1, 'SR', NULL, NULL, '10.0'),
(39864, '2017-07-27 13:04:28', NULL, NULL, 11463, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:04:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39865, '2017-07-27 13:04:36', NULL, NULL, 11463, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:04:36', 'admin-1501115441-15011318767514387', 1, 1, 'SR', NULL, NULL, NULL),
(39866, '2017-07-27 13:04:41', NULL, NULL, 11463, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 13:04:41', 'admin-1501115441-1501131881764893', 1, 1, 'SR', NULL, NULL, NULL),
(39867, '2017-07-27 11:27:32', NULL, NULL, 11453, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 11:27:32', 'admin-1501115441-15011260524465570', 1, 1, 'SR', NULL, NULL, NULL),
(39868, '2017-07-27 14:18:07', NULL, NULL, 11472, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 14:18:07', 'admin-1501134804-15011362869512421', 1, 0, '', NULL, NULL, NULL),
(39869, '2017-07-27 12:38:24', NULL, NULL, 11461, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 12:38:24', 'admin-1501115441-15011303042299443', 1, 1, 'SR', NULL, NULL, NULL),
(39870, '2017-07-27 12:38:19', NULL, NULL, 11461, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 12:38:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39871, '2017-07-27 12:25:54', NULL, NULL, 11458, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 12:25:54', 'admin-1501115441-15011295541806789', 1, 1, 'SR', NULL, NULL, NULL),
(39872, '2017-07-27 12:25:54', NULL, NULL, 11458, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 12:25:54', 'admin-1501115441-15011295541806789', 1, 1, 'SR', NULL, NULL, NULL),
(39873, '2017-07-27 12:25:46', NULL, NULL, 11458, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1501147751', 'admin', '2017-07-27 12:25:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39874, '2017-07-27 11:30:56', NULL, NULL, 11456, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 11:30:56', 'admin-1501115441-15011262561528364', 1, 1, 'SR', NULL, NULL, NULL),
(39875, '2017-07-27 11:30:56', NULL, NULL, 11456, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 11:30:56', 'admin-1501115441-15011262561528364', 1, 0, '', NULL, NULL, NULL),
(39876, '2017-07-27 11:30:11', NULL, NULL, 11455, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 11:30:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39877, '2017-07-27 16:46:16', NULL, NULL, 11477, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 16:46:16', 'admin-1501134804-15011451768271121', 1, 0, '', NULL, NULL, NULL),
(39878, '2017-07-27 11:27:32', NULL, NULL, 11453, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 11:27:32', 'admin-1501115441-15011260524465570', 1, 1, 'SR', NULL, NULL, NULL),
(39879, '2017-07-27 10:50:11', NULL, NULL, 11450, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 10:50:11', 'admin-1501115441-15011238113938858', 1, 1, 'SR', NULL, NULL, NULL),
(39880, '2017-07-27 11:03:42', NULL, NULL, 11451, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1501147751', 'admin', '2017-07-27 11:03:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39881, '2017-07-27 11:03:46', NULL, NULL, 11451, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 11:03:46', 'admin-1501115441-15011246264403331', 1, 1, 'SR', NULL, NULL, NULL),
(39882, '2017-07-27 10:33:30', NULL, NULL, 11449, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1501147751', 'admin', '2017-07-27 10:33:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39883, '2017-07-27 10:33:37', NULL, NULL, 11449, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 10:33:37', 'admin-1501115441-15011228175729474', 1, 1, 'SR', NULL, NULL, NULL),
(39884, '2017-07-27 10:33:37', NULL, NULL, 11449, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 10:33:37', 'admin-1501115441-15011228175729474', 1, 1, 'SR', NULL, NULL, NULL),
(39885, '2017-07-27 09:28:07', NULL, NULL, 11448, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 09:28:07', 'admin-1501115441-15011188870706459', 1, 1, 'SR', NULL, NULL, NULL),
(39886, '2017-07-27 09:28:07', NULL, NULL, 11448, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501147751', 'admin', '2017-07-27 09:28:07', 'admin-1501115441-15011188870706459', 1, 1, 'SR', NULL, NULL, NULL),
(39887, '2017-07-27 09:28:04', NULL, NULL, 11448, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1501147751', 'admin', '2017-07-27 09:28:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39888, '2017-07-28 16:54:02', NULL, NULL, 11506, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 16:54:02', 'admin-1501220813-15012320420001997', 1, 0, '', NULL, NULL, NULL),
(39889, '2017-07-28 17:00:56', NULL, NULL, 11507, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1501220813', 'admin', '2017-07-28 17:00:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39890, '2017-07-28 13:43:49', NULL, NULL, 11500, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 13:43:49', 'admin-1501213126-15012206292974380', 1, 1, 'SR', NULL, NULL, NULL),
(39891, '2017-07-28 13:43:49', NULL, NULL, 11500, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 13:43:49', 'admin-1501213126-15012206292974380', 1, 1, 'SR', NULL, NULL, NULL),
(39892, '2017-07-28 17:17:01', NULL, NULL, 11508, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 17:17:01', 'admin-1501220813-15012334217621113', 1, 1, 'SR', NULL, NULL, NULL),
(39893, '2017-07-28 17:13:05', NULL, NULL, 11508, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 17:13:05', 'admin-1501220813-15012331850269698', 1, 1, 'SR', NULL, NULL, NULL),
(39894, '2017-07-28 17:13:05', NULL, NULL, 11508, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 17:13:05', 'admin-1501220813-15012331850269698', 1, 0, '', NULL, NULL, NULL),
(39895, '2017-07-28 09:37:02', NULL, NULL, 11481, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 09:37:02', 'admin-1501203783-15012058226637359', 1, 0, '', NULL, NULL, NULL),
(39896, '2017-07-28 10:09:10', NULL, NULL, 11482, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1501220813', 'admin', '2017-07-28 10:09:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39897, '2017-07-28 10:09:24', NULL, NULL, 11482, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 10:09:24', 'admin-1501203783-15012077643103745', 1, 0, '', NULL, NULL, NULL),
(39898, '2017-07-28 10:09:24', NULL, NULL, 11482, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 10:09:24', 'admin-1501203783-15012077643103745', 1, 1, 'SR', NULL, NULL, NULL),
(39899, '2017-07-28 10:09:24', NULL, NULL, 11482, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 10:09:24', 'admin-1501203783-15012077643103745', 1, 1, 'SR', NULL, NULL, NULL),
(39900, '2017-07-28 10:11:16', NULL, NULL, 11483, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1501220813', 'admin', '2017-07-28 10:11:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39901, '2017-07-28 10:11:27', NULL, NULL, 11483, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 10:11:27', 'admin-1501203783-15012078867648898', 1, 1, 'SR', NULL, NULL, NULL),
(39902, '2017-07-28 10:25:04', NULL, NULL, 11484, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1501220813', 'admin', '2017-07-28 10:25:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39903, '2017-07-28 10:25:41', NULL, NULL, 11484, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 10:25:41', 'admin-1501203783-1501208741597875', 1, 0, '', NULL, NULL, NULL),
(39904, '2017-07-28 10:25:41', NULL, NULL, 11484, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 10:25:41', 'admin-1501203783-1501208741597875', 1, 0, '', NULL, NULL, NULL),
(39905, '2017-07-28 10:25:41', NULL, NULL, 11484, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 10:25:41', 'admin-1501203783-1501208741597875', 1, 0, '', NULL, NULL, NULL),
(39906, '2017-07-28 10:27:17', NULL, NULL, 11484, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 10:27:17', 'admin-1501208782-15012088370612671', 1, 0, '', NULL, NULL, NULL),
(39907, '2017-07-28 10:30:30', NULL, NULL, 11483, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 10:30:30', 'admin-1501208782-15012090304093849', 1, 0, '', NULL, NULL, NULL),
(39908, '2017-07-28 10:30:30', NULL, NULL, 11483, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 10:30:30', 'admin-1501208782-15012090304093849', 1, 0, '', NULL, NULL, NULL),
(39909, '2017-07-28 17:12:50', NULL, NULL, 11508, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1501220813', 'admin', '2017-07-28 17:12:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39910, '2017-07-28 14:32:26', NULL, NULL, 11505, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1501220813', 'admin', '2017-07-28 14:32:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39911, '2017-07-28 17:01:04', NULL, NULL, 11507, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 17:01:04', 'admin-1501220813-15012324639971450', 1, 1, 'SR', NULL, NULL, NULL),
(39912, '2017-07-28 17:01:04', NULL, NULL, 11507, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 17:01:04', 'admin-1501220813-15012324639971450', 1, 0, '', NULL, NULL, NULL),
(39913, '2017-07-28 00:00:00', NULL, NULL, 11496, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 13:07:49', 'admin-1501213126-15012184693934387', 1, 1, 'SR', NULL, NULL, NULL),
(39914, '2017-07-28 11:29:38', NULL, NULL, 11489, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:29:38', 'admin-1501208782-15012125778966821', 1, 1, 'SR', NULL, NULL, NULL),
(39915, '2017-07-28 16:54:02', NULL, NULL, 11506, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 16:54:02', 'admin-1501220813-15012320420001997', 1, 0, '', NULL, NULL, NULL),
(39916, '2017-07-28 14:32:42', NULL, NULL, 11505, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 14:32:42', 'admin-1501220813-15012235624272382', 1, 0, '', NULL, NULL, NULL),
(39917, '2017-07-28 14:01:20', NULL, NULL, 11502, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 14:01:20', 'admin-1501220813-15012216797921521', 1, 1, 'SR', NULL, NULL, NULL),
(39918, '2017-07-28 14:32:42', NULL, NULL, 11505, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 14:32:42', 'admin-1501220813-15012235624272382', 1, 0, '', NULL, NULL, NULL),
(39919, '2017-07-28 14:29:27', NULL, NULL, 11504, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1501220813', 'admin', '2017-07-28 14:29:27', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(39920, '2017-07-28 14:29:40', NULL, NULL, 11504, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 14:29:40', 'admin-1501220813-1501223379828954', 1, 1, 'SR', NULL, NULL, '10.0'),
(39921, '2017-07-28 14:01:48', NULL, NULL, 11502, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 14:01:48', 'admin-1501220813-15012217077899896', 1, 1, 'SR', NULL, NULL, NULL),
(39922, '2017-07-28 14:01:55', NULL, NULL, 11503, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1501220813', 'admin', '2017-07-28 14:01:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39923, '2017-07-28 13:46:48', NULL, NULL, 11500, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 13:46:48', 'admin-1501213126-15012208086481194', 1, 1, 'SR', NULL, NULL, NULL),
(39924, '2017-07-28 13:46:48', NULL, NULL, 11500, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 13:46:48', 'admin-1501213126-15012208086481194', 1, 1, 'SR', NULL, NULL, NULL),
(39925, '2017-07-28 14:29:40', NULL, NULL, 11504, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 14:29:40', 'admin-1501220813-1501223379828954', 1, 1, 'SR', NULL, NULL, '10.0'),
(39926, '2017-07-28 13:59:26', NULL, NULL, 11502, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1501220813', 'admin', '2017-07-28 13:59:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39927, '2017-07-28 12:58:45', NULL, NULL, 11495, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 12:58:45', 'admin-1501213126-15012179249107389', 1, 0, '', NULL, NULL, NULL),
(39928, '2017-07-28 11:48:51', NULL, NULL, 11491, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:48:51', 'admin-1501213126-1501213731599193', 1, 1, 'SR', NULL, NULL, '10.0'),
(39929, '2017-07-28 11:49:12', NULL, NULL, 11491, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:49:12', 'admin-1501213126-15012137524039954', 1, 1, 'SR', NULL, NULL, '10.0'),
(39930, '2017-07-28 09:18:40', NULL, NULL, 11480, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1501220813', 'admin', '2017-07-28 09:18:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39931, '2017-07-28 09:15:27', NULL, NULL, 11479, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 09:15:27', 'admin-1501203783-15012045269784078', 1, 0, '', NULL, NULL, NULL),
(39932, '2017-07-28 11:06:41', NULL, NULL, 11485, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:06:41', 'admin-1501208782-15012112008148468', 1, 0, '', NULL, NULL, NULL),
(39933, '2017-07-28 11:13:18', NULL, NULL, 11486, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:13:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39934, '2017-07-28 11:13:34', NULL, NULL, 11486, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:13:34', 'admin-1501208782-15012116146217824', 1, 1, 'SR', NULL, NULL, NULL),
(39935, '2017-07-28 11:13:34', NULL, NULL, 11486, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:13:34', 'admin-1501208782-15012116146217824', 1, 1, 'SR', NULL, NULL, NULL),
(39936, '2017-07-28 11:18:33', NULL, NULL, 11487, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:18:33', 'admin-1501208782-15012119137519421', 1, 1, 'SR', 1, NULL, NULL),
(39937, '2017-07-28 11:24:37', NULL, NULL, 11488, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:24:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39938, '2017-07-28 11:24:46', NULL, NULL, 11488, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:24:46', 'admin-1501208782-15012122862169378', 1, 0, '', NULL, NULL, NULL),
(39939, '2017-07-28 09:18:54', NULL, NULL, 11480, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 09:18:54', 'admin-1501203783-15012047343798996', 1, 1, 'SR', NULL, NULL, NULL),
(39940, '2017-07-28 09:35:46', NULL, NULL, 11481, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1501220813', 'admin', '2017-07-28 09:35:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39941, '2017-07-28 09:37:02', NULL, NULL, 11481, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 09:37:02', 'admin-1501203783-15012058226637359', 1, 0, '', NULL, NULL, NULL),
(39942, '2017-07-28 16:53:56', NULL, NULL, 11506, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1501220813', 'admin', '2017-07-28 16:53:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39943, '2017-07-28 14:02:54', NULL, NULL, 11502, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 14:02:54', 'admin-1501220813-15012217744375147', 1, 1, 'SR', NULL, NULL, NULL),
(39944, '2017-07-28 14:01:20', NULL, NULL, 11502, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 14:01:20', 'admin-1501220813-15012216797921521', 1, 0, '', NULL, NULL, NULL),
(39945, '2017-07-28 13:11:12', NULL, NULL, 11498, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1501220813', 'admin', '2017-07-28 13:11:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39946, '2017-07-28 00:00:00', NULL, NULL, 11499, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:38:57', 'admin-1501213126-15012131376315345', 1, 0, '', NULL, NULL, NULL),
(39947, '2017-07-28 14:02:00', NULL, NULL, 11503, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 14:02:00', 'admin-1501220813-15012217206858431', 1, 0, '', NULL, NULL, NULL),
(39948, '2017-07-28 12:32:31', NULL, NULL, 11493, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1501220813', 'admin', '2017-07-28 12:32:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39949, '2017-07-28 11:53:22', NULL, NULL, 11492, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:53:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39950, '2017-07-28 11:53:27', NULL, NULL, 11492, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:53:27', 'admin-1501213126-15012140075799672', 1, 1, 'SR', NULL, NULL, NULL),
(39951, '2017-07-28 00:00:00', NULL, NULL, 11493, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', 'no mushroom', 'Meals', 'Perfect Meals', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:52:20', 'admin-1501213126-15012139405847289', 1, 0, '', NULL, NULL, NULL),
(39952, '2017-07-28 12:42:42', NULL, NULL, 11494, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1501220813', 'admin', '2017-07-28 12:42:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39953, '2017-07-28 12:43:27', NULL, NULL, 11494, 0, 153, '87', 'Wake Me Up!', 'change baked beans to corn', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 12:43:27', 'admin-1501213126-15012170078157319', 1, 0, '', NULL, NULL, NULL),
(39954, '2017-07-28 00:00:00', NULL, NULL, 11497, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:38:57', 'admin-1501213126-15012131376315345', 1, 0, '', NULL, NULL, NULL),
(39955, '2017-07-28 13:45:00', NULL, NULL, 11501, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 13:45:00', 'admin-1501213126-15012206999373298', 1, 1, 'SR', 1, NULL, '10.0'),
(39956, '2017-07-28 09:15:27', NULL, NULL, 11479, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 09:15:27', 'admin-1501203783-15012045269784078', 1, 0, '', NULL, NULL, NULL),
(39957, '2017-07-28 09:15:27', NULL, NULL, 11479, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 09:15:27', 'admin-1501203783-15012045269784078', 1, 0, '', NULL, NULL, NULL),
(39958, '2017-07-28 09:15:27', NULL, NULL, 11479, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 09:15:27', 'admin-1501203783-15012045269784078', 1, 0, '', NULL, NULL, NULL),
(39959, '2017-07-28 13:43:41', NULL, NULL, 11500, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1501220813', 'admin', '2017-07-28 13:43:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39960, '2017-07-28 00:00:00', NULL, NULL, 11498, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:38:57', 'admin-1501213126-15012131376315345', 1, 0, '', NULL, NULL, NULL),
(39961, '2017-07-28 00:00:00', NULL, NULL, 11496, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:38:57', 'admin-1501213126-15012131376315345', 1, 0, '', NULL, NULL, NULL),
(39962, '2017-07-28 12:58:52', NULL, NULL, 11495, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 12:58:52', 'admin-1501213126-1501217932107618', 1, 1, 'SR', NULL, NULL, NULL),
(39963, '2017-07-28 12:58:52', NULL, NULL, 11495, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 12:58:52', 'admin-1501213126-1501217932107618', 1, 1, 'SR', NULL, NULL, NULL),
(39964, '2017-07-28 12:57:42', NULL, NULL, 11495, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 12:57:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39965, '2017-07-28 12:58:45', NULL, NULL, 11495, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 12:58:45', 'admin-1501213126-15012179249107389', 1, 0, '', NULL, NULL, NULL),
(39966, '2017-07-28 12:58:45', NULL, NULL, 11495, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 12:58:45', 'admin-1501213126-15012179249107389', 1, 1, 'SR', NULL, NULL, NULL),
(39967, '2017-07-28 12:43:27', NULL, NULL, 11494, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 12:43:27', 'admin-1501213126-15012170078157319', 1, 1, 'SR', NULL, NULL, NULL),
(39968, '2017-07-28 11:49:12', NULL, NULL, 11491, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:49:12', 'admin-1501213126-15012137524039954', 1, 0, '', NULL, NULL, '10.0'),
(39969, '2017-07-28 00:00:00', NULL, NULL, 11496, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:38:41', 'admin-1501208782-15012131214701275', 1, 0, '', NULL, NULL, NULL),
(39970, '2017-07-28 11:48:44', NULL, NULL, 11491, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:48:44', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(39971, '2017-07-28 00:00:00', NULL, NULL, 11498, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:38:41', 'admin-1501208782-15012131214701275', 1, 0, '', NULL, NULL, NULL),
(39972, '2017-07-28 00:00:00', NULL, NULL, 11499, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:38:41', 'admin-1501208782-15012131214701275', 1, 0, '', NULL, NULL, NULL),
(39973, '2017-07-28 13:08:06', NULL, NULL, 11496, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1501220813', 'admin', '2017-07-28 13:08:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39974, '2017-07-28 00:00:00', NULL, NULL, 11497, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:38:41', 'admin-1501208782-15012131214701275', 1, 0, '', NULL, NULL, NULL),
(39975, '2017-07-28 11:06:17', NULL, NULL, 11485, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:06:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39976, '2017-07-28 11:06:41', NULL, NULL, 11485, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:06:41', 'admin-1501208782-15012112008148468', 1, 0, '', NULL, NULL, NULL),
(39977, '2017-07-28 11:06:41', NULL, NULL, 11485, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:06:41', 'admin-1501208782-15012112008148468', 1, 0, '', NULL, NULL, NULL),
(39978, '2017-07-28 13:09:42', NULL, NULL, 11497, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1501220813', 'admin', '2017-07-28 13:09:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39979, '2017-07-28 00:00:00', NULL, NULL, 11499, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, NULL, NULL, 2.70, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:38:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39980, '2017-07-28 13:17:16', NULL, NULL, 11489, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 13:17:16', 'admin-1501213126-15012190365585670', 1, 0, '', NULL, NULL, NULL),
(39981, '2017-07-28 11:29:38', NULL, NULL, 11489, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:29:38', 'admin-1501208782-15012125778966821', 1, 1, 'SR', NULL, NULL, NULL),
(39982, '2017-07-28 11:29:19', NULL, NULL, 11489, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:29:19', 'admin-1501208782-15012125596961855', 1, 0, '', NULL, NULL, NULL),
(39983, '2017-07-28 11:29:19', NULL, NULL, 11489, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:29:19', 'admin-1501208782-15012125596961855', 1, 0, '', NULL, NULL, NULL),
(39984, '2017-07-28 11:29:03', NULL, NULL, 11489, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:29:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39985, '2017-07-28 11:06:41', NULL, NULL, 11485, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 11:06:41', 'admin-1501208782-15012112008148468', 1, 1, 'SR', NULL, NULL, NULL),
(39986, '2017-07-28 10:42:20', NULL, NULL, 11484, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 10:42:20', 'admin-1501208782-1501209740085672', 1, 0, '', NULL, NULL, NULL),
(39987, '2017-07-28 14:02:54', NULL, NULL, 11502, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 14:02:54', 'admin-1501220813-15012217744375147', 1, 1, 'SR', NULL, NULL, NULL),
(39988, '2017-07-28 10:30:30', NULL, NULL, 11483, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 10:30:30', 'admin-1501208782-15012090304093849', 1, 0, '', NULL, NULL, NULL),
(39989, '2017-07-28 17:12:54', NULL, NULL, 11508, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 17:12:54', 'admin-1501220813-15012331742172073', 1, 1, 'SR', NULL, NULL, NULL),
(39990, '2017-07-28 10:30:30', NULL, NULL, 11483, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 10:30:30', 'admin-1501208782-15012090304093849', 1, 1, 'SR', NULL, NULL, NULL),
(39991, '2017-07-28 09:37:02', NULL, NULL, 11481, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 09:37:02', 'admin-1501203783-15012058226637359', 1, 0, '', NULL, NULL, NULL),
(39992, '2017-07-28 09:18:54', NULL, NULL, 11480, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 09:18:54', 'admin-1501203783-15012047343798996', 1, 0, '', NULL, NULL, NULL),
(39993, '2017-07-28 09:44:30', NULL, NULL, 11480, 0, 181, '116', 'Open Food ', 'Take It Easy', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 09:44:30', 'admin-1501203783-15012062705124682', 1, 0, '', NULL, NULL, NULL),
(39994, '2017-07-28 09:14:04', NULL, NULL, 11479, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 09:14:04', 'admin-1501203783-15012044439442565', 1, 0, '', NULL, NULL, NULL),
(39995, '2017-07-28 09:14:04', NULL, NULL, 11479, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 09:14:04', 'admin-1501203783-15012044439442565', 1, 1, 'SR', NULL, NULL, NULL),
(39996, '2017-07-28 09:15:14', NULL, NULL, 11479, 0, 207, '142', 'Cheesy Bacon Toast', 'No salad', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 09:15:14', 'admin-1501203783-15012045143069172', 1, 0, '', NULL, NULL, NULL),
(39997, '2017-07-28 09:15:14', NULL, NULL, 11479, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501220813', 'admin', '2017-07-28 09:15:14', 'admin-1501203783-15012045143069172', 1, 0, '', NULL, NULL, NULL),
(39998, '2017-07-28 09:13:05', NULL, NULL, 11479, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1501220813', 'admin', '2017-07-28 09:13:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(39999, '2017-07-29 13:13:13', NULL, NULL, 11536, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:13:13', 'admin-1501304242-15013051931806564', 1, 0, '', NULL, NULL, NULL),
(40000, '2017-07-29 13:13:22', NULL, NULL, 11537, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:13:22', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(40001, '2017-07-29 15:54:29', NULL, NULL, 11544, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 15:54:29', 'admin-1501307487-15013148690125854', 1, 0, '', NULL, NULL, NULL),
(40002, '2017-07-29 12:30:24', NULL, NULL, 11530, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:30:24', 'admin-1501299416-15013026244658885', 1, 1, 'SR', NULL, NULL, NULL),
(40003, '2017-07-29 13:44:05', NULL, NULL, 11540, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:44:05', 'admin-1501304242-15013070448888423', 1, 1, 'SR', NULL, NULL, NULL),
(40004, '2017-07-29 13:44:05', NULL, NULL, 11540, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:44:05', 'admin-1501304242-15013070448888423', 1, 0, '', NULL, NULL, NULL),
(40005, '2017-07-29 12:41:47', NULL, NULL, 11533, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:41:47', 'admin-1501299416-15013033073224351', 1, 0, '', NULL, NULL, NULL),
(40006, '2017-07-29 11:07:53', NULL, NULL, 11523, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:07:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40007, '2017-07-29 13:42:55', NULL, NULL, 11540, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:42:55', 'admin-1501304242-15013069753141445', 1, 0, '', NULL, NULL, NULL),
(40008, '2017-07-29 13:42:55', NULL, NULL, 11540, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:42:55', 'admin-1501304242-15013069753141445', 1, 0, '', NULL, NULL, NULL),
(40009, '2017-07-29 13:44:45', NULL, NULL, 11537, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:44:45', 'admin-1501304242-15013070853836535', 1, 1, 'SR', NULL, NULL, NULL),
(40010, '2017-07-29 13:45:16', NULL, NULL, 11537, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:45:16', 'admin-1501304242-15013071167542416', 1, 0, '', NULL, NULL, NULL),
(40011, '2017-07-29 13:45:16', NULL, NULL, 11537, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:45:16', 'admin-1501304242-15013071167542416', 1, 0, '', NULL, NULL, NULL),
(40012, '2017-07-29 13:50:33', NULL, NULL, 11540, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:50:33', 'admin-1501304242-1501307433096248', 1, 0, '', NULL, NULL, NULL),
(40013, '2017-07-29 13:51:37', NULL, NULL, 11517, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:51:37', 'admin-1501307487-15013074973809713', 1, 1, 'SR', 1, NULL, '10.0'),
(40014, '2017-07-29 12:41:47', NULL, NULL, 11533, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:41:47', 'admin-1501299416-15013033073224351', 1, 1, 'SR', NULL, NULL, NULL),
(40015, '2017-07-29 12:41:31', NULL, NULL, 11533, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:41:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40016, '2017-07-29 12:15:46', NULL, NULL, 11529, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:15:46', 'admin-1501299416-15013017457861885', 1, 0, '', NULL, NULL, NULL),
(40017, '2017-07-29 12:15:46', NULL, NULL, 11529, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:15:46', 'admin-1501299416-15013017457861885', 1, 0, '', NULL, NULL, NULL),
(40018, '2017-07-29 12:16:01', NULL, NULL, 11529, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:16:01', 'admin-1501299416-15013017613454350', 1, 1, 'SR', NULL, NULL, NULL),
(40019, '2017-07-29 16:39:28', NULL, NULL, 11546, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.59, 0.0000, 0.0000, 1.59, 1, '27', 1, '1501307487', 'admin', '2017-07-29 16:39:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40020, '2017-07-29 16:24:46', NULL, NULL, 11545, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 16:24:46', 'admin-1501307487-15013166864212710', 1, 0, '', NULL, NULL, NULL),
(40021, '2017-07-29 16:39:34', NULL, NULL, 11546, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 16:39:34', 'admin-1501307487-15013175739505699', 1, 1, 'SR', NULL, NULL, NULL),
(40022, '2017-07-29 12:57:04', NULL, NULL, 11535, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:57:04', 'admin-1501299416-1501304224643231', 1, 1, 'SR', NULL, NULL, NULL),
(40023, '2017-07-29 12:37:19', NULL, NULL, 11522, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:37:19', 'admin-1501299416-15013030387751833', 1, 1, 'SR', NULL, NULL, NULL),
(40024, '2017-07-29 12:39:12', NULL, NULL, 11532, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:39:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40025, '2017-07-29 12:36:04', NULL, NULL, 11531, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:36:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40026, '2017-07-29 12:36:18', NULL, NULL, 11531, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 2, 14.00, 28.0000, 0.0000, 28.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:36:18', 'admin-1501299416-15013029781686213', 1, 1, 'SR', NULL, NULL, NULL),
(40027, '2017-07-29 12:48:20', NULL, NULL, 11534, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:48:20', 'admin-1501299416-15013037000098827', 1, 1, 'SR', NULL, NULL, NULL),
(40028, '2017-07-29 12:41:47', NULL, NULL, 11533, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:41:47', 'admin-1501299416-15013033073224351', 1, 1, 'SR', NULL, NULL, NULL),
(40029, '2017-07-29 12:47:58', NULL, NULL, 11534, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:47:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40030, '2017-07-29 12:48:20', NULL, NULL, 11534, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:48:20', 'admin-1501299416-15013037000098827', 1, 0, '', NULL, NULL, NULL),
(40031, '2017-07-29 14:18:32', NULL, NULL, 11541, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1501307487', 'admin', '2017-07-29 14:18:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40032, '2017-07-29 14:18:38', NULL, NULL, 11541, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 14:18:38', 'admin-1501307487-15013091180551398', 1, 0, '', NULL, NULL, NULL),
(40033, '2017-07-29 16:52:24', NULL, NULL, 11546, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1501307487', 'admin', '2017-07-29 16:52:24', 'admin-1501307487-15013183438677717', 1, 0, '', NULL, NULL, NULL),
(40034, '2017-07-29 14:53:43', NULL, NULL, 11542, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1501307487', 'admin', '2017-07-29 14:53:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40035, '2017-07-29 14:53:56', NULL, NULL, 11542, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 14:53:56', 'admin-1501307487-15013112365278413', 1, 0, '', NULL, NULL, NULL),
(40036, '2017-07-29 15:59:09', NULL, NULL, 11544, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 15:59:09', 'admin-1501307487-15013151494326293', 1, 1, 'SR', NULL, NULL, NULL),
(40037, '2017-07-29 15:54:20', NULL, NULL, 11544, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1501307487', 'admin', '2017-07-29 15:54:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40038, '2017-07-29 15:38:35', NULL, NULL, 11543, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 15:38:36', 'admin-1501307487-15013139157592766', 1, 0, '', NULL, NULL, NULL),
(40039, '2017-07-29 15:38:35', NULL, NULL, 11543, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 15:38:35', 'admin-1501307487-15013139157592766', 1, 1, 'SR', NULL, NULL, NULL),
(40040, '2017-07-29 15:38:35', NULL, NULL, 11543, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 15:38:35', 'admin-1501307487-15013139157592766', 1, 0, '', NULL, NULL, NULL),
(40041, '2017-07-29 12:30:20', NULL, NULL, 11530, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:30:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40042, '2017-07-29 12:19:59', NULL, NULL, 11522, 0, 284, '218', 'Caramel Waffles', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:19:59', 'admin-1501299416-15013019993634575', 1, 0, '', NULL, NULL, NULL),
(40043, '2017-07-29 12:15:46', NULL, NULL, 11529, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:15:46', 'admin-1501299416-15013017457861885', 1, 0, '', NULL, NULL, NULL),
(40044, '2017-07-29 11:28:54', NULL, NULL, 11526, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:28:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40045, '2017-07-29 11:28:58', NULL, NULL, 11526, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:28:58', 'admin-1501297702-15012989383505735', 1, 0, '', NULL, NULL, NULL),
(40046, '2017-07-29 15:38:35', NULL, NULL, 11543, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 15:38:35', 'admin-1501307487-15013139157592766', 1, 0, '', NULL, NULL, NULL),
(40047, '2017-07-29 15:38:14', NULL, NULL, 11543, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 15:38:14', 'admin-1501307487-15013138940638893', 1, 0, '', NULL, NULL, NULL),
(40048, '2017-07-29 14:53:56', NULL, NULL, 11542, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 14:53:56', 'admin-1501307487-15013112365278413', 1, 1, 'SR', NULL, NULL, NULL),
(40049, '2017-07-29 15:37:27', NULL, NULL, 11543, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1501307487', 'admin', '2017-07-29 15:37:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40050, '2017-07-29 12:11:13', NULL, NULL, 11526, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:11:13', 'admin-1501299416-15013014734977511', 1, 0, '', NULL, NULL, NULL),
(40051, '2017-07-29 12:11:13', NULL, NULL, 11526, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:11:13', 'admin-1501299416-15013014734977511', 1, 1, 'SR', NULL, NULL, NULL),
(40052, '2017-07-29 12:16:01', NULL, NULL, 11529, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:16:01', 'admin-1501299416-15013017613454350', 1, 0, '', NULL, NULL, NULL),
(40053, '2017-07-29 09:47:06', NULL, NULL, 11511, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:47:06', 'admin-1501290298-15012928268002817', 1, 1, 'SR', NULL, NULL, NULL),
(40054, '2017-07-29 14:53:56', NULL, NULL, 11542, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 14:53:56', 'admin-1501307487-15013112365278413', 1, 0, '', NULL, NULL, NULL),
(40055, '2017-07-29 14:53:56', NULL, NULL, 11542, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 14:53:56', 'admin-1501307487-15013112365278413', 1, 0, '', NULL, NULL, NULL),
(40056, '2017-07-29 11:50:00', NULL, NULL, 11528, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:50:00', 'admin-1501299416-15013002007644745', 1, 1, 'SR', NULL, NULL, NULL),
(40057, '2017-07-29 11:50:00', NULL, NULL, 11528, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:50:00', 'admin-1501299416-15013002007644745', 1, 1, 'SR', NULL, NULL, NULL),
(40058, '2017-07-29 12:16:01', NULL, NULL, 11529, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:16:01', 'admin-1501299416-15013017613454350', 1, 1, 'SR', NULL, NULL, NULL),
(40059, '2017-07-29 09:32:25', NULL, NULL, 11510, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:32:25', 'admin-1501290298-15012919451614390', 1, 0, '', NULL, NULL, NULL),
(40060, '2017-07-29 09:10:53', NULL, NULL, 11509, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:10:53', 'admin-1501290298-1501290653117614', 1, 1, 'SR', NULL, NULL, NULL),
(40061, '2017-07-29 09:10:07', NULL, NULL, 11509, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:10:07', 'admin-1501290298-15012906076325226', 1, 0, '', NULL, NULL, NULL),
(40062, '2017-07-29 11:50:00', NULL, NULL, 11528, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:50:00', 'admin-1501299416-15013002007644745', 1, 1, 'SR', NULL, NULL, NULL),
(40063, '2017-07-29 11:49:54', NULL, NULL, 11528, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:49:54', 'admin-1501299416-15013001940764529', 1, 0, '', NULL, NULL, NULL),
(40064, '2017-07-29 11:49:54', NULL, NULL, 11528, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:49:54', 'admin-1501299416-15013001940764529', 1, 0, '', NULL, NULL, NULL),
(40065, '2017-07-29 11:49:28', NULL, NULL, 11528, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:49:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40066, '2017-07-29 11:40:47', NULL, NULL, 11515, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:40:47', 'admin-1501299416-15012996472454227', 1, 1, 'SR', NULL, NULL, NULL),
(40067, '2017-07-29 11:36:39', NULL, NULL, 11527, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:36:39', 'admin-1501297702-15012993995188558', 1, 1, 'SR', NULL, NULL, NULL),
(40068, '2017-07-29 11:35:01', NULL, NULL, 11527, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:35:01', 'admin-1501297702-15012993017484259', 1, 1, 'SR', NULL, NULL, NULL),
(40069, '2017-07-29 11:34:51', NULL, NULL, 11527, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:34:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40070, '2017-07-29 11:35:01', NULL, NULL, 11527, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:35:01', 'admin-1501297702-15012993017484259', 1, 0, '', NULL, NULL, NULL),
(40071, '2017-07-29 11:30:05', NULL, NULL, 11526, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:30:05', 'admin-1501297702-15012990049073757', 1, 1, 'SR', NULL, NULL, NULL),
(40072, '2017-07-29 11:05:38', NULL, NULL, 11522, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:05:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40073, '2017-07-29 13:13:28', NULL, NULL, 11537, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:13:28', 'admin-1501304242-1501305208797271', 1, 1, 'SR', NULL, NULL, NULL),
(40074, '2017-07-29 13:13:28', NULL, NULL, 11537, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:13:28', 'admin-1501304242-1501305208797271', 1, 1, 'SR', NULL, NULL, NULL),
(40075, '2017-07-29 13:16:28', NULL, NULL, 11538, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:16:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40076, '2017-07-29 12:48:20', NULL, NULL, 11534, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:48:20', 'admin-1501299416-15013037000098827', 1, 1, 'SR', NULL, NULL, NULL),
(40077, '2017-07-29 12:48:20', NULL, NULL, 11534, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:48:20', 'admin-1501299416-15013037000098827', 1, 0, '', NULL, NULL, NULL),
(40078, '2017-07-29 12:15:16', NULL, NULL, 11529, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:15:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40079, '2017-07-29 11:30:05', NULL, NULL, 11526, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:30:05', 'admin-1501297702-15012990049073757', 1, 1, 'SR', NULL, NULL, NULL),
(40080, '2017-07-29 11:29:53', NULL, NULL, 11519, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:29:53', 'admin-1501297702-15012989934595438', 1, 1, 'SR', NULL, NULL, NULL),
(40081, '2017-07-29 13:58:45', NULL, NULL, 11536, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:58:45', 'admin-1501307487-15013079249424924', 1, 1, 'SR', NULL, NULL, NULL),
(40082, '2017-07-29 13:59:18', NULL, NULL, 11536, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:59:18', 'admin-1501307487-15013079583833199', 1, 1, 'SR', NULL, NULL, NULL),
(40083, '2017-07-29 13:42:55', NULL, NULL, 11540, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:42:55', 'admin-1501304242-15013069753141445', 1, 0, '', NULL, NULL, NULL),
(40084, '2017-07-29 13:44:05', NULL, NULL, 11540, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:44:05', 'admin-1501304242-15013070448888423', 1, 1, 'SR', NULL, NULL, NULL),
(40085, '2017-07-29 12:57:35', NULL, NULL, 11535, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:57:35', 'admin-1501304242-15013042556236319', 1, 1, 'SR', NULL, NULL, NULL),
(40086, '2017-07-29 12:57:35', NULL, NULL, 11535, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:57:35', 'admin-1501304242-15013042556236319', 1, 1, 'SR', NULL, NULL, NULL),
(40087, '2017-07-29 12:57:40', NULL, NULL, 11535, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:57:40', 'admin-1501304242-15013042605645660', 1, 0, '', NULL, NULL, NULL),
(40088, '2017-07-29 11:29:53', NULL, NULL, 11519, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:29:53', 'admin-1501297702-15012989934595438', 1, 0, '', NULL, NULL, NULL),
(40089, '2017-07-29 11:29:53', NULL, NULL, 11519, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:29:53', 'admin-1501297702-15012989934595438', 1, 0, '', NULL, NULL, NULL),
(40090, '2017-07-29 13:44:05', NULL, NULL, 11540, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:44:05', 'admin-1501304242-15013070448888423', 1, 1, 'SR', NULL, NULL, NULL),
(40091, '2017-07-29 13:09:10', NULL, NULL, 11536, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:09:10', 'admin-1501304242-15013049504756917', 1, 0, '', NULL, NULL, NULL),
(40092, '2017-07-29 13:44:05', NULL, NULL, 11540, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:44:05', 'admin-1501304242-15013070448888423', 1, 0, '', NULL, NULL, NULL),
(40093, '2017-07-29 13:44:05', NULL, NULL, 11540, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:44:05', 'admin-1501304242-15013070448888423', 1, 1, 'SR', NULL, NULL, NULL),
(40094, '2017-07-29 11:36:51', NULL, NULL, 11525, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:36:51', 'admin-1501297702-15012994116005113', 1, 0, '', NULL, NULL, NULL),
(40095, '2017-07-29 11:13:07', NULL, NULL, 11524, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:13:07', 'admin-1501297702-15012979872033579', 1, 1, 'SR', NULL, NULL, NULL),
(40096, '2017-07-29 11:17:08', NULL, NULL, 11525, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:17:08', 'admin-1501297702-15012982286495769', 1, 1, 'SR', NULL, NULL, NULL),
(40097, '2017-07-29 11:17:08', NULL, NULL, 11525, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:17:08', 'admin-1501297702-15012982286495769', 1, 1, 'SR', NULL, NULL, NULL),
(40098, '2017-07-29 11:17:08', NULL, NULL, 11525, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:17:08', 'admin-1501297702-15012982286495769', 1, 0, '', NULL, NULL, NULL),
(40099, '2017-07-29 11:17:08', NULL, NULL, 11525, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:17:08', 'admin-1501297702-15012982286495769', 1, 0, '', NULL, NULL, NULL),
(40100, '2017-07-29 11:17:08', NULL, NULL, 11525, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:17:08', 'admin-1501297702-15012982286495769', 1, 0, '', NULL, NULL, NULL),
(40101, '2017-07-29 11:08:08', NULL, NULL, 11523, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:08:08', 'admin-1501296421-15012976882979120', 1, 0, '', NULL, NULL, NULL),
(40102, '2017-07-29 11:08:08', NULL, NULL, 11523, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:08:08', 'admin-1501296421-15012976882979120', 1, 1, 'SR', NULL, NULL, NULL),
(40103, '2017-07-29 11:13:07', NULL, NULL, 11524, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:13:07', 'admin-1501297702-15012979872033579', 1, 1, 'SR', NULL, NULL, NULL),
(40104, '2017-07-29 14:25:33', NULL, NULL, 11537, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 14:25:33', 'admin-1501307487-15013095331665559', 1, 0, '', NULL, NULL, NULL),
(40105, '2017-07-29 13:42:27', NULL, NULL, 11540, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.50, 0.0000, 0.0000, 13.50, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:42:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40106, '2017-07-29 13:38:38', NULL, NULL, 11539, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:38:38', 'admin-1501304242-15013067185385691', 1, 1, 'SR', NULL, NULL, NULL),
(40107, '2017-07-29 13:42:55', NULL, NULL, 11540, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:42:55', 'admin-1501304242-15013069753141445', 1, 1, 'SR', NULL, NULL, NULL),
(40108, '2017-07-29 13:21:23', NULL, NULL, 11539, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:21:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40109, '2017-07-29 13:22:07', NULL, NULL, 11539, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:22:07', 'admin-1501304242-15013057273715637', 1, 1, 'SR', NULL, NULL, NULL),
(40110, '2017-07-29 13:22:07', NULL, NULL, 11539, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:22:07', 'admin-1501304242-15013057273715637', 1, 0, '', NULL, NULL, NULL),
(40111, '2017-07-29 13:17:04', NULL, NULL, 11538, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:17:04', 'admin-1501304242-15013054242739164', 1, 1, 'SR', NULL, NULL, NULL),
(40112, '2017-07-29 13:17:04', NULL, NULL, 11538, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:17:04', 'admin-1501304242-15013054242739164', 1, 1, 'SR', NULL, NULL, NULL),
(40113, '2017-07-29 13:17:04', NULL, NULL, 11538, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:17:04', 'admin-1501304242-15013054242739164', 1, 0, '', NULL, NULL, NULL),
(40114, '2017-07-29 14:18:38', NULL, NULL, 11541, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 14:18:38', 'admin-1501307487-15013091180551398', 1, 1, 'SR', NULL, NULL, NULL),
(40115, '2017-07-29 13:17:04', NULL, NULL, 11538, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:17:04', 'admin-1501304242-15013054242739164', 1, 0, '', NULL, NULL, NULL),
(40116, '2017-07-29 13:09:10', NULL, NULL, 11536, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:09:10', 'admin-1501304242-15013049504756917', 1, 1, 'SR', NULL, NULL, NULL),
(40117, '2017-07-29 09:47:00', NULL, NULL, 11511, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:47:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40118, '2017-07-29 13:09:10', NULL, NULL, 11536, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:09:10', 'admin-1501304242-15013049504756917', 1, 1, 'SR', NULL, NULL, NULL),
(40119, '2017-07-29 13:09:10', NULL, NULL, 11536, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:09:10', 'admin-1501304242-15013049504756917', 1, 0, '', NULL, NULL, NULL),
(40120, '2017-07-29 13:09:10', NULL, NULL, 11536, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:09:10', 'admin-1501304242-15013049504756917', 1, 0, '', NULL, NULL, NULL),
(40121, '2017-07-29 09:55:37', NULL, NULL, 11512, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:55:37', 'admin-1501290298-15012933375448931', 1, 0, '', NULL, NULL, NULL),
(40122, '2017-07-29 11:05:53', NULL, NULL, 11522, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:05:53', 'admin-1501296421-15012975532648877', 1, 0, '', NULL, NULL, NULL),
(40123, '2017-07-29 11:17:08', NULL, NULL, 11525, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:17:08', 'admin-1501297702-15012982286495769', 1, 1, 'SR', NULL, NULL, NULL),
(40124, '2017-07-29 11:16:49', NULL, NULL, 11525, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:16:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40125, '2017-07-29 10:44:39', NULL, NULL, 11520, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:44:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40126, '2017-07-29 10:45:52', NULL, NULL, 11520, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:45:52', 'admin-1501293644-15012963522892747', 1, 0, '', NULL, NULL, NULL),
(40127, '2017-07-29 12:55:44', NULL, NULL, 11535, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.30, 0.0000, 0.0000, 16.30, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:55:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40128, '2017-07-29 12:57:04', NULL, NULL, 11535, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:57:04', 'admin-1501299416-1501304224643231', 1, 0, '', NULL, NULL, NULL),
(40129, '2017-07-29 12:57:04', NULL, NULL, 11535, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:57:04', 'admin-1501299416-1501304224643231', 1, 0, '', NULL, NULL, NULL),
(40130, '2017-07-29 13:07:12', NULL, NULL, 11536, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.50, 0.0000, 0.0000, 10.50, 1, '27', 1, '1501307487', 'admin', '2017-07-29 13:07:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40131, '2017-07-29 12:57:35', NULL, NULL, 11535, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:57:35', 'admin-1501304242-15013042556236319', 1, 1, 'SR', NULL, NULL, NULL),
(40132, '2017-07-29 11:13:07', NULL, NULL, 11524, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:13:07', 'admin-1501297702-15012979872033579', 1, 0, '', NULL, NULL, NULL),
(40133, '2017-07-29 11:04:41', NULL, NULL, 11515, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:04:41', 'admin-1501296421-15012974817252434', 1, 0, '', NULL, NULL, NULL),
(40134, '2017-07-29 12:57:04', NULL, NULL, 11535, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:57:04', 'admin-1501299416-1501304224643231', 1, 0, '', NULL, NULL, NULL),
(40135, '2017-07-29 12:57:04', NULL, NULL, 11535, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:57:04', 'admin-1501299416-1501304224643231', 1, 1, 'SR', NULL, NULL, NULL),
(40136, '2017-07-29 12:57:04', NULL, NULL, 11535, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:57:04', 'admin-1501299416-1501304224643231', 1, 0, '', NULL, NULL, NULL),
(40137, '2017-07-29 12:57:04', NULL, NULL, 11535, 0, 75, '75', 'Meatless Aglio Olio ', 'No mushroom', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:57:04', 'admin-1501299416-1501304224643231', 1, 0, '', NULL, NULL, NULL),
(40138, '2017-07-29 09:55:37', NULL, NULL, 11512, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:55:37', 'admin-1501290298-15012933375448931', 1, 0, '', NULL, NULL, NULL),
(40139, '2017-07-29 09:55:37', NULL, NULL, 11512, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:55:37', 'admin-1501290298-15012933375448931', 1, 0, '', NULL, NULL, NULL),
(40140, '2017-07-29 09:56:02', NULL, NULL, 11512, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:56:02', 'admin-1501290298-15012933621658591', 1, 1, 'SR', NULL, NULL, NULL),
(40141, '2017-07-29 09:56:02', NULL, NULL, 11512, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:56:02', 'admin-1501290298-15012933621658591', 1, 1, 'SR', NULL, NULL, NULL),
(40142, '2017-07-29 09:56:02', NULL, NULL, 11512, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:56:02', 'admin-1501290298-15012933621658591', 1, 1, 'SR', NULL, NULL, NULL),
(40143, '2017-07-29 10:12:44', NULL, NULL, 11513, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:12:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40144, '2017-07-29 10:13:34', NULL, NULL, 11513, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:13:34', 'admin-1501293644-15012944146706223', 1, 0, '', NULL, NULL, NULL),
(40145, '2017-07-29 10:13:34', NULL, NULL, 11513, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:13:34', 'admin-1501293644-15012944146706223', 1, 0, '', NULL, NULL, NULL),
(40146, '2017-07-29 10:13:34', NULL, NULL, 11513, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:13:34', 'admin-1501293644-15012944146706223', 1, 0, '', NULL, NULL, NULL),
(40147, '2017-07-29 12:41:47', NULL, NULL, 11533, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:41:47', 'admin-1501299416-15013033073224351', 1, 1, 'SR', NULL, NULL, NULL),
(40148, '2017-07-29 12:41:47', NULL, NULL, 11533, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:41:47', 'admin-1501299416-15013033073224351', 1, 1, 'SR', NULL, NULL, NULL),
(40149, '2017-07-29 11:13:07', NULL, NULL, 11524, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:13:07', 'admin-1501297702-15012979872033579', 1, 1, 'SR', NULL, NULL, NULL),
(40150, '2017-07-29 11:08:08', NULL, NULL, 11523, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:08:08', 'admin-1501296421-15012976882979120', 1, 0, '', NULL, NULL, NULL),
(40151, '2017-07-29 10:45:52', NULL, NULL, 11520, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:45:52', 'admin-1501293644-15012963522892747', 1, 0, '', NULL, NULL, NULL),
(40152, '2017-07-29 10:45:52', NULL, NULL, 11520, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:45:52', 'admin-1501293644-15012963522892747', 1, 1, 'SR', NULL, NULL, NULL),
(40153, '2017-07-29 10:45:52', NULL, NULL, 11520, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:45:52', 'admin-1501293644-15012963522892747', 1, 1, 'SR', NULL, NULL, NULL),
(40154, '2017-07-29 10:45:52', NULL, NULL, 11520, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:45:52', 'admin-1501293644-15012963522892747', 1, 1, 'SR', NULL, NULL, NULL),
(40155, '2017-07-29 10:26:04', NULL, NULL, 11516, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:26:04', 'admin-1501293644-15012951639973374', 1, 0, '', NULL, NULL, NULL),
(40156, '2017-07-29 10:14:32', NULL, NULL, 11514, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:14:32', 'admin-1501293644-15012944725792499', 1, 0, '', NULL, NULL, NULL),
(40157, '2017-07-29 12:19:43', NULL, NULL, 11522, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:19:43', 'admin-1501299416-15013019837902161', 1, 1, 'SR', NULL, NULL, NULL),
(40158, '2017-07-29 12:57:35', NULL, NULL, 11535, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:57:35', 'admin-1501304242-15013042556236319', 1, 0, '', NULL, NULL, NULL),
(40159, '2017-07-29 12:39:15', NULL, NULL, 11532, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:39:15', 'admin-1501299416-15013031549784355', 1, 1, 'SR', NULL, NULL, NULL),
(40160, '2017-07-29 11:06:14', NULL, NULL, 11522, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:06:14', 'admin-1501296421-15012975740342141', 1, 1, 'SR', NULL, NULL, NULL),
(40161, '2017-07-29 11:06:14', NULL, NULL, 11522, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:06:14', 'admin-1501296421-15012975740342141', 1, 0, '', NULL, NULL, NULL),
(40162, '2017-07-29 10:14:43', NULL, NULL, 11514, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:14:43', 'admin-1501293644-15012944834172922', 1, 1, 'SR', NULL, NULL, NULL),
(40163, '2017-07-29 10:14:43', NULL, NULL, 11514, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:14:43', 'admin-1501293644-15012944834172922', 1, 0, '', NULL, NULL, NULL),
(40164, '2017-07-29 11:05:53', NULL, NULL, 11522, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:05:53', 'admin-1501296421-15012975532648877', 1, 0, '', NULL, NULL, NULL),
(40165, '2017-07-29 10:26:04', NULL, NULL, 11516, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:26:04', 'admin-1501293644-15012951639973374', 1, 0, '', NULL, NULL, NULL),
(40166, '2017-07-29 10:58:45', NULL, NULL, 11521, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:58:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40167, '2017-07-29 10:59:01', NULL, NULL, 11521, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:59:01', 'admin-1501296421-15012971410738122', 1, 0, '', NULL, NULL, NULL),
(40168, '2017-07-29 11:28:30', NULL, NULL, 11524, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:28:30', 'admin-1501297702-1501298909963374', 1, 0, '', NULL, NULL, NULL),
(40169, '2017-07-29 11:12:39', NULL, NULL, 11524, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.65, 0.0000, 0.0000, 7.65, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:12:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40170, '2017-07-29 10:59:01', NULL, NULL, 11521, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:59:01', 'admin-1501296421-15012971410738122', 1, 1, 'SR', NULL, NULL, NULL),
(40171, '2017-07-29 11:13:07', NULL, NULL, 11524, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:13:07', 'admin-1501297702-15012979872033579', 1, 1, 'SR', NULL, NULL, NULL),
(40172, '2017-07-29 10:47:39', NULL, NULL, 11519, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:47:39', 'admin-1501296421-15012964595053083', 1, 1, 'SR', NULL, NULL, NULL),
(40173, '2017-07-29 10:47:39', NULL, NULL, 11519, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:47:39', 'admin-1501296421-15012964595053083', 1, 0, '', NULL, NULL, NULL),
(40174, '2017-07-29 10:34:01', NULL, NULL, 11518, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:34:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40175, '2017-07-29 10:34:16', NULL, NULL, 11518, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:34:16', 'admin-1501293644-15012956561414790', 1, 0, '', NULL, NULL, NULL),
(40176, '2017-07-29 10:34:16', NULL, NULL, 11518, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:34:16', 'admin-1501293644-15012956561414790', 1, 0, '', NULL, NULL, NULL),
(40177, '2017-07-29 10:34:16', NULL, NULL, 11518, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:34:16', 'admin-1501293644-15012956561414790', 1, 1, 'SR', NULL, NULL, NULL),
(40178, '2017-07-29 10:41:05', NULL, NULL, 11519, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.80, 0.0000, 0.0000, 10.80, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:41:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40179, '2017-07-29 10:41:17', NULL, NULL, 11519, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:41:17', 'admin-1501293644-15012960777094681', 1, 0, '', NULL, NULL, NULL),
(40180, '2017-07-29 10:41:17', NULL, NULL, 11519, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:41:17', 'admin-1501293644-15012960777094681', 1, 0, '', NULL, NULL, NULL),
(40181, '2017-07-29 10:32:27', NULL, NULL, 11517, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:32:27', 'admin-1501293644-15012955468388770', 1, 0, '', 1, NULL, '10.0'),
(40182, '2017-07-29 10:26:04', NULL, NULL, 11516, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:26:04', 'admin-1501293644-15012951639973374', 1, 0, '', NULL, NULL, NULL),
(40183, '2017-07-29 10:26:04', NULL, NULL, 11516, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:26:04', 'admin-1501293644-15012951639973374', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(40184, '2017-07-29 10:25:38', NULL, NULL, 11515, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:25:38', 'admin-1501293644-15012951379047722', 1, 1, 'SR', NULL, NULL, NULL),
(40185, '2017-07-29 11:28:58', NULL, NULL, 11526, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:28:58', 'admin-1501297702-15012989383505735', 1, 1, 'SR', NULL, NULL, NULL),
(40186, '2017-07-29 10:25:41', NULL, NULL, 11516, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:25:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40187, '2017-07-29 10:25:16', NULL, NULL, 11515, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:25:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40188, '2017-07-29 10:14:43', NULL, NULL, 11514, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:14:43', 'admin-1501293644-15012944834172922', 1, 1, 'SR', NULL, NULL, NULL),
(40189, '2017-07-29 12:48:20', NULL, NULL, 11534, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 12:48:20', 'admin-1501299416-15013037000098827', 1, 1, 'SR', NULL, NULL, NULL),
(40190, '2017-07-29 15:55:00', NULL, NULL, 11544, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 15:55:00', 'admin-1501307487-15013149003196689', 1, 1, 'SR', NULL, NULL, NULL),
(40191, '2017-07-29 10:14:43', NULL, NULL, 11514, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:14:43', 'admin-1501293644-15012944834172922', 1, 1, 'SR', NULL, NULL, NULL),
(40192, '2017-07-29 10:14:32', NULL, NULL, 11514, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:14:32', 'admin-1501293644-15012944725792499', 1, 0, '', NULL, NULL, NULL),
(40193, '2017-07-29 10:14:32', NULL, NULL, 11514, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:14:32', 'admin-1501293644-15012944725792499', 1, 0, '', NULL, NULL, NULL),
(40194, '2017-07-29 10:14:32', NULL, NULL, 11514, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:14:32', 'admin-1501293644-15012944725792499', 1, 0, '', NULL, NULL, NULL),
(40195, '2017-07-29 10:13:34', NULL, NULL, 11513, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:13:34', 'admin-1501293644-15012944146706223', 1, 1, 'SR', NULL, NULL, NULL),
(40196, '2017-07-29 10:13:34', NULL, NULL, 11513, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:13:34', 'admin-1501293644-15012944146706223', 1, 1, 'SR', NULL, NULL, NULL),
(40197, '2017-07-29 10:14:23', NULL, NULL, 11514, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.80, 0.0000, 0.0000, 10.80, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:14:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40198, '2017-07-29 10:13:34', NULL, NULL, 11513, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 10:13:34', 'admin-1501293644-15012944146706223', 1, 0, '', NULL, NULL, NULL),
(40199, '2017-07-29 09:55:37', NULL, NULL, 11512, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:55:37', 'admin-1501290298-15012933375448931', 1, 0, '', NULL, NULL, NULL),
(40200, '2017-07-29 09:51:41', NULL, NULL, 11509, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:51:41', 'admin-1501290298-15012931013698619', 1, 1, 'SR', NULL, NULL, NULL),
(40201, '2017-07-29 09:32:25', NULL, NULL, 11510, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:32:25', 'admin-1501290298-15012919451614390', 1, 1, 'SR', NULL, NULL, NULL),
(40202, '2017-07-29 09:55:05', NULL, NULL, 11512, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.80, 0.0000, 0.0000, 9.80, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:55:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40203, '2017-07-29 09:32:25', NULL, NULL, 11510, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:32:25', 'admin-1501290298-15012919451614390', 1, 0, '', NULL, NULL, NULL),
(40204, '2017-07-29 09:32:17', NULL, NULL, 11510, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:32:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40205, '2017-07-29 09:10:53', NULL, NULL, 11509, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:10:53', 'admin-1501290298-1501290653117614', 1, 1, 'SR', NULL, NULL, NULL),
(40206, '2017-07-29 11:13:07', NULL, NULL, 11524, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 11:13:07', 'admin-1501297702-15012979872033579', 1, 1, 'SR', NULL, NULL, NULL),
(40207, '2017-07-29 09:10:53', NULL, NULL, 11509, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:10:53', 'admin-1501290298-1501290653117614', 1, 1, 'SR', NULL, NULL, NULL),
(40208, '2017-07-29 09:10:07', NULL, NULL, 11509, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:10:07', 'admin-1501290298-15012906076325226', 1, 0, '', NULL, NULL, NULL),
(40209, '2017-07-29 09:10:07', NULL, NULL, 11509, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:10:07', 'admin-1501290298-15012906076325226', 1, 0, '', NULL, NULL, NULL),
(40210, '2017-07-29 09:10:07', NULL, NULL, 11509, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:10:07', 'admin-1501290298-15012906076325226', 1, 0, '', NULL, NULL, NULL),
(40211, '2017-07-29 09:09:27', NULL, NULL, 11509, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1501307487', 'admin', '2017-07-29 09:09:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40212, '2017-07-30 13:36:08', NULL, NULL, 11594, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:36:08', 'admin-1501392616-15013929680374164', 1, 0, '', NULL, NULL, NULL),
(40213, '2017-07-30 13:35:52', NULL, NULL, 11594, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:35:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40214, '2017-07-30 13:30:49', NULL, NULL, 11593, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:30:49', 'admin-1501392616-15013926494185469', 1, 1, 'SR', NULL, NULL, NULL),
(40215, '2017-07-30 13:30:49', NULL, NULL, 11593, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:30:49', 'admin-1501392616-15013926494185469', 1, 0, '', NULL, NULL, NULL),
(40216, '2017-07-30 13:30:08', NULL, NULL, 11593, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:30:08', 'admin-1501390516-15013926080198228', 1, 0, '', NULL, NULL, NULL),
(40217, '2017-07-30 13:30:08', NULL, NULL, 11593, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:30:08', 'admin-1501390516-15013926080198228', 1, 0, '', NULL, NULL, NULL),
(40218, '2017-07-30 13:29:39', NULL, NULL, 11593, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:29:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40219, '2017-07-30 13:25:19', NULL, NULL, 11582, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:25:19', 'admin-1501390516-15013923197549777', 1, 0, '', NULL, NULL, NULL),
(40220, '2017-07-30 13:25:19', NULL, NULL, 11582, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:25:19', 'admin-1501390516-15013923197549777', 1, 0, '', NULL, NULL, NULL),
(40221, '2017-07-30 13:24:23', NULL, NULL, 11592, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:24:23', 'admin-1501390516-15013922632768650', 1, 1, 'SR', NULL, NULL, NULL),
(40222, '2017-07-30 14:39:11', NULL, NULL, 11599, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:39:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40223, '2017-07-30 14:36:25', NULL, NULL, 11598, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:36:25', 'admin-1501392616-15013965848732429', 1, 0, '', NULL, NULL, NULL),
(40224, '2017-07-30 14:36:25', NULL, NULL, 11598, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:36:25', 'admin-1501392616-15013965848732429', 1, 1, 'SR', NULL, NULL, NULL),
(40225, '2017-07-30 14:36:25', NULL, NULL, 11598, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:36:25', 'admin-1501392616-15013965848732429', 1, 0, '', NULL, NULL, NULL),
(40226, '2017-07-30 14:36:25', NULL, NULL, 11598, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:36:25', 'admin-1501392616-15013965848732429', 1, 0, '', NULL, NULL, NULL),
(40227, '2017-07-30 13:03:54', NULL, NULL, 11587, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:03:54', 'admin-1501390516-15013910347169553', 1, 0, '', NULL, NULL, NULL),
(40228, '2017-07-30 16:03:42', NULL, NULL, 11604, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 16:03:42', 'admin-1501396592-15014018223466973', 1, 1, 'SR', NULL, NULL, NULL),
(40229, '2017-07-30 16:03:42', NULL, NULL, 11604, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 16:03:42', 'admin-1501396592-15014018223466973', 1, 1, 'SR', NULL, NULL, NULL),
(40230, '2017-07-30 14:36:25', NULL, NULL, 11598, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:36:25', 'admin-1501392616-15013965848732429', 1, 0, '', NULL, NULL, NULL),
(40231, '2017-07-30 14:35:26', NULL, NULL, 11598, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:35:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40232, '2017-07-30 14:25:24', NULL, NULL, 11597, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:25:24', 'admin-1501392616-15013959239231442', 1, 0, '', NULL, NULL, NULL),
(40233, '2017-07-30 15:23:17', NULL, NULL, 11603, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1501396592', 'admin', '2017-07-30 15:23:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40234, '2017-07-30 15:24:54', NULL, NULL, 11603, 0, 181, '116', 'Open Food ', 'nutella toast', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 15:24:54', 'admin-1501396592-15013994941267783', 1, 0, '', NULL, NULL, NULL),
(40235, '2017-07-30 15:24:02', NULL, NULL, 11603, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 15:24:02', 'admin-1501396592-15013994425909418', 1, 1, 'SR', NULL, NULL, NULL),
(40236, '2017-07-30 15:24:54', NULL, NULL, 11603, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 15:24:54', 'admin-1501396592-15013994941267783', 1, 1, 'SR', NULL, NULL, NULL),
(40237, '2017-07-30 14:00:46', NULL, NULL, 11596, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:00:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40238, '2017-07-30 13:58:06', NULL, NULL, 11590, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:58:06', 'admin-1501392616-15013942862231246', 1, 0, '', NULL, NULL, NULL),
(40239, '2017-07-30 13:58:06', NULL, NULL, 11590, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:58:06', 'admin-1501392616-15013942862231246', 1, 1, 'SR', NULL, NULL, NULL),
(40240, '2017-07-30 14:50:13', NULL, NULL, 11601, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:50:13', 'admin-1501396592-15013974134003392', 1, 1, 'SR', NULL, NULL, NULL),
(40241, '2017-07-30 14:50:13', NULL, NULL, 11601, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:50:13', 'admin-1501396592-15013974134003392', 1, 1, 'SR', NULL, NULL, NULL),
(40242, '2017-07-30 14:50:13', NULL, NULL, 11601, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:50:13', 'admin-1501396592-15013974134003392', 1, 0, '', NULL, NULL, NULL),
(40243, '2017-07-30 15:13:00', NULL, NULL, 11601, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 15:13:00', 'admin-1501396592-15013987800353941', 1, 1, 'SR', NULL, NULL, NULL),
(40244, '2017-07-30 15:13:00', NULL, NULL, 11601, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 15:13:00', 'admin-1501396592-15013987800353941', 1, 0, '', NULL, NULL, NULL),
(40245, '2017-07-30 14:39:23', NULL, NULL, 11599, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:39:23', 'admin-1501396592-15013967633494920', 1, 1, 'SR', NULL, NULL, NULL),
(40246, '2017-07-30 13:52:40', NULL, NULL, 11587, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:52:40', 'admin-1501392616-15013939606374849', 1, 1, 'SR', NULL, NULL, NULL),
(40247, '2017-07-30 13:24:23', NULL, NULL, 11592, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:24:23', 'admin-1501390516-15013922632768650', 1, 1, 'SR', NULL, NULL, NULL),
(40248, '2017-07-30 12:50:11', NULL, NULL, 11586, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:50:11', 'admin-1501388385-15013902108776758', 1, 0, '', NULL, NULL, NULL),
(40249, '2017-07-30 13:03:54', NULL, NULL, 11587, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:03:54', 'admin-1501390516-15013910347169553', 1, 1, 'SR', NULL, NULL, NULL),
(40250, '2017-07-30 13:05:54', NULL, NULL, 11588, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:05:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40251, '2017-07-30 12:50:11', NULL, NULL, 11586, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:50:11', 'admin-1501388385-15013902108776758', 1, 0, '', NULL, NULL, NULL),
(40252, '2017-07-30 12:02:57', NULL, NULL, 11579, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:02:57', 'admin-1501386887-1501387376988750', 1, 0, '', NULL, NULL, NULL),
(40253, '2017-07-30 12:02:57', NULL, NULL, 11579, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:02:57', 'admin-1501386887-1501387376988750', 1, 1, 'SR', NULL, NULL, NULL),
(40254, '2017-07-30 11:57:35', NULL, NULL, 11578, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:57:35', 'admin-1501386887-15013870553155440', 1, 1, 'SR', NULL, NULL, NULL),
(40255, '2017-07-30 11:57:35', NULL, NULL, 11578, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:57:35', 'admin-1501386887-15013870553155440', 1, 0, '', NULL, NULL, NULL),
(40256, '2017-07-30 14:01:16', NULL, NULL, 11596, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:01:16', 'admin-1501392616-15013944758912756', 1, 1, 'SR', NULL, NULL, NULL),
(40257, '2017-07-30 13:24:05', NULL, NULL, 11592, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:24:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40258, '2017-07-30 14:01:05', NULL, NULL, 11596, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:01:05', 'admin-1501392616-15013944652125170', 1, 0, '', NULL, NULL, NULL),
(40259, '2017-07-30 14:01:16', NULL, NULL, 11596, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:01:16', 'admin-1501392616-15013944758912756', 1, 0, '', NULL, NULL, NULL),
(40260, '2017-07-30 13:24:23', NULL, NULL, 11592, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:24:23', 'admin-1501390516-15013922632768650', 1, 1, 'SR', NULL, NULL, NULL),
(40261, '2017-07-30 13:10:33', NULL, NULL, 11591, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:10:33', 'admin-1501390516-1501391433334193', 1, 0, '', NULL, NULL, NULL),
(40262, '2017-07-30 13:10:33', NULL, NULL, 11591, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:10:33', 'admin-1501390516-1501391433334193', 1, 1, 'SR', NULL, NULL, NULL),
(40263, '2017-07-30 13:10:33', NULL, NULL, 11591, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:10:33', 'admin-1501390516-1501391433334193', 1, 0, '', NULL, NULL, NULL),
(40264, '2017-07-30 13:06:18', NULL, NULL, 11588, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:06:18', 'admin-1501390516-15013911786925851', 1, 1, 'SR', NULL, NULL, NULL),
(40265, '2017-07-30 13:06:18', NULL, NULL, 11588, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:06:18', 'admin-1501390516-15013911786925851', 1, 1, 'SR', NULL, NULL, NULL),
(40266, '2017-07-30 13:06:18', NULL, NULL, 11588, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:06:18', 'admin-1501390516-15013911786925851', 1, 1, 'SR', NULL, NULL, NULL),
(40267, '2017-07-30 13:36:08', NULL, NULL, 11594, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:36:08', 'admin-1501392616-15013929680374164', 1, 1, 'SR', NULL, NULL, NULL),
(40268, '2017-07-30 13:47:38', NULL, NULL, 11595, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:47:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40269, '2017-07-30 13:48:02', NULL, NULL, 11595, 0, 73, '73', 'Marmite Chicken ', 'Takeaway', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:48:02', 'admin-1501392616-15013936827114040', 1, 1, 'SR', NULL, NULL, NULL),
(40270, '2017-07-30 13:10:04', NULL, NULL, 11591, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:10:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40271, '2017-07-30 13:08:49', NULL, NULL, 11590, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:08:49', 'admin-1501390516-15013913291951388', 1, 0, '', NULL, NULL, NULL),
(40272, '2017-07-30 13:07:46', NULL, NULL, 11590, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:07:46', 'admin-1501390516-1501391266783711', 1, 0, '', NULL, NULL, NULL),
(40273, '2017-07-30 13:07:46', NULL, NULL, 11590, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:07:46', 'admin-1501390516-1501391266783711', 1, 0, '', NULL, NULL, NULL),
(40274, '2017-07-30 13:07:42', NULL, NULL, 11590, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:07:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40275, '2017-07-30 11:44:19', NULL, NULL, 11574, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:44:19', 'admin-1501384088-15013862594953487', 1, 0, '', NULL, NULL, NULL),
(40276, '2017-07-30 11:44:19', NULL, NULL, 11574, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:44:19', 'admin-1501384088-15013862594953487', 1, 0, '', NULL, NULL, NULL),
(40277, '2017-07-30 11:44:19', NULL, NULL, 11574, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:44:19', 'admin-1501384088-15013862594953487', 1, 0, '', NULL, NULL, NULL),
(40278, '2017-07-30 10:01:54', NULL, NULL, 11554, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:01:54', 'admin-1501379810-15013801138377241', 1, 0, '', NULL, NULL, NULL),
(40279, '2017-07-30 10:01:54', NULL, NULL, 11554, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:01:54', 'admin-1501379810-15013801138377241', 1, 0, '', NULL, NULL, NULL),
(40280, '2017-07-30 10:01:54', NULL, NULL, 11554, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:01:54', 'admin-1501379810-15013801138377241', 1, 1, 'SR', NULL, NULL, NULL),
(40281, '2017-07-30 10:01:54', NULL, NULL, 11554, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:01:54', 'admin-1501379810-15013801138377241', 1, 0, '', NULL, NULL, NULL),
(40282, '2017-07-30 10:05:21', NULL, NULL, 11550, 0, 181, '116', 'Open Food ', 'scramble egg', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:05:21', 'admin-1501379810-15013803217009124', 1, 0, '', NULL, NULL, NULL),
(40283, '2017-07-30 14:50:02', NULL, NULL, 11601, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:50:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40284, '2017-07-30 14:44:40', NULL, NULL, 11600, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:44:40', 'admin-1501396592-15013970807604378', 1, 1, 'SR', NULL, NULL, NULL),
(40285, '2017-07-30 12:50:11', NULL, NULL, 11586, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:50:11', 'admin-1501388385-15013902108776758', 1, 0, '', NULL, NULL, NULL),
(40286, '2017-07-30 12:50:11', NULL, NULL, 11586, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:50:11', 'admin-1501388385-15013902108776758', 1, 0, '', NULL, NULL, NULL),
(40287, '2017-07-30 10:34:48', NULL, NULL, 11560, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:34:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40288, '2017-07-30 10:35:32', NULL, NULL, 11560, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:35:32', 'admin-1501380991-15013821320249988', 1, 1, 'SR', NULL, NULL, NULL),
(40289, '2017-07-30 11:07:26', NULL, NULL, 11566, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:07:26', 'admin-1501380991-15013840467753545', 1, 0, '', NULL, NULL, NULL),
(40290, '2017-07-30 11:07:26', NULL, NULL, 11566, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:07:26', 'admin-1501380991-15013840467753545', 1, 1, 'SR', NULL, NULL, NULL),
(40291, '2017-07-30 13:06:18', NULL, NULL, 11588, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:06:18', 'admin-1501390516-15013911786925851', 1, 0, '', NULL, NULL, NULL),
(40292, '2017-07-30 12:50:11', NULL, NULL, 11586, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:50:11', 'admin-1501388385-15013902108776758', 1, 1, 'SR', NULL, NULL, NULL),
(40293, '2017-07-30 12:50:11', NULL, NULL, 11586, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:50:11', 'admin-1501388385-15013902108776758', 1, 1, 'SR', NULL, NULL, NULL),
(40294, '2017-07-30 13:03:43', NULL, NULL, 11587, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:03:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40295, '2017-07-30 12:50:11', NULL, NULL, 11586, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:50:11', 'admin-1501388385-15013902108776758', 1, 0, '', NULL, NULL, NULL),
(40296, '2017-07-30 11:15:53', NULL, NULL, 11568, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:15:53', 'admin-1501384088-15013845533909854', 1, 1, 'SR', NULL, NULL, NULL),
(40297, '2017-07-30 11:19:42', NULL, NULL, 11559, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:19:42', 'admin-1501384088-15013847824087120', 1, 0, '', NULL, NULL, NULL),
(40298, '2017-07-30 11:21:11', NULL, NULL, 11569, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:21:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40299, '2017-07-30 11:21:43', NULL, NULL, 11569, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:21:43', 'admin-1501384088-15013849029205948', 1, 0, '', NULL, NULL, NULL),
(40300, '2017-07-30 14:44:40', NULL, NULL, 11600, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:44:40', 'admin-1501396592-15013970807604378', 1, 1, 'SR', NULL, NULL, NULL),
(40301, '2017-07-30 14:44:16', NULL, NULL, 11600, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:44:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40302, '2017-07-30 14:40:12', NULL, NULL, 11599, 0, 181, '116', 'Open Food ', 'vege rice', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:40:12', 'admin-1501396592-15013968126192232', 1, 0, '', NULL, NULL, NULL),
(40303, '2017-07-30 14:40:12', NULL, NULL, 11599, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:40:12', 'admin-1501396592-15013968126192232', 1, 1, 'SR', NULL, NULL, NULL),
(40304, '2017-07-30 12:47:55', NULL, NULL, 11586, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.20, 0.0000, 0.0000, 12.20, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:47:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40305, '2017-07-30 12:07:01', NULL, NULL, 11580, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:07:01', 'admin-1501386887-15013876207398999', 1, 0, '', NULL, NULL, '10.0'),
(40306, '2017-07-30 12:07:01', NULL, NULL, 11580, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:07:01', 'admin-1501386887-15013876207398999', 1, 0, '', NULL, NULL, '10.0'),
(40307, '2017-07-30 12:07:01', NULL, NULL, 11580, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:07:01', 'admin-1501386887-15013876207398999', 1, 1, 'SR', NULL, NULL, '10.0'),
(40308, '2017-07-30 13:48:02', NULL, NULL, 11595, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', 'Takeaway', 'Meals', 'Perfect Meals', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:48:02', 'admin-1501392616-15013936827114040', 1, 0, '', NULL, NULL, NULL),
(40309, '2017-07-30 10:01:54', NULL, NULL, 11554, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:01:54', 'admin-1501379810-15013801138377241', 1, 0, '', NULL, NULL, NULL),
(40310, '2017-07-30 11:44:19', NULL, NULL, 11574, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:44:19', 'admin-1501384088-15013862594953487', 1, 0, '', NULL, NULL, NULL),
(40311, '2017-07-30 11:44:19', NULL, NULL, 11574, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:44:19', 'admin-1501384088-15013862594953487', 1, 0, '', NULL, NULL, NULL),
(40312, '2017-07-30 13:33:09', NULL, NULL, 11590, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:33:09', 'admin-1501392616-15013927888472734', 1, 1, 'SR', NULL, NULL, NULL),
(40313, '2017-07-30 11:49:23', NULL, NULL, 11576, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:49:23', 'admin-1501384088-15013865630063239', 1, 0, '', NULL, NULL, NULL),
(40314, '2017-07-30 11:49:23', NULL, NULL, 11576, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:49:23', 'admin-1501384088-15013865630063239', 1, 1, 'SR', NULL, NULL, NULL),
(40315, '2017-07-30 12:30:59', NULL, NULL, 11585, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:30:59', 'admin-1501388385-15013890587842791', 1, 1, 'SR', NULL, NULL, NULL),
(40316, '2017-07-30 12:30:59', NULL, NULL, 11585, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:30:59', 'admin-1501388385-15013890587842791', 1, 1, 'SR', NULL, NULL, NULL),
(40317, '2017-07-30 12:30:58', NULL, NULL, 11585, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:30:58', 'admin-1501388385-15013890587842791', 1, 0, '', NULL, NULL, NULL),
(40318, '2017-07-30 12:30:11', NULL, NULL, 11584, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:30:11', 'admin-1501388385-15013890110231718', 1, 1, 'SR', NULL, NULL, NULL),
(40319, '2017-07-30 12:30:23', NULL, NULL, 11585, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:30:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40320, '2017-07-30 12:30:58', NULL, NULL, 11585, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:30:58', 'admin-1501388385-15013890587842791', 1, 0, '', NULL, NULL, NULL),
(40321, '2017-07-30 10:53:11', NULL, NULL, 11563, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:53:11', 'admin-1501380991-15013831916861650', 1, 0, '', NULL, NULL, NULL),
(40322, '2017-07-30 11:34:50', NULL, NULL, 11571, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:34:50', 'admin-1501384088-15013856907998319', 1, 0, '', NULL, NULL, NULL),
(40323, '2017-07-30 10:33:21', NULL, NULL, 11559, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:33:21', 'admin-1501380991-15013820012126049', 1, 0, '', NULL, NULL, NULL),
(40324, '2017-07-30 10:34:43', NULL, NULL, 11559, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:34:43', 'admin-1501380991-15013820833979761', 1, 1, 'SR', NULL, NULL, NULL),
(40325, '2017-07-30 12:29:02', NULL, NULL, 11584, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:29:02', 'admin-1501388385-15013889420869879', 1, 0, '', NULL, NULL, NULL),
(40326, '2017-07-30 12:26:47', NULL, NULL, 11574, 0, 181, '116', 'Open Food ', 'potato mashed', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:26:47', 'admin-1501388385-15013888074592072', 1, 0, '', NULL, NULL, NULL),
(40327, '2017-07-30 12:30:11', NULL, NULL, 11584, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:30:11', 'admin-1501388385-15013890110231718', 1, 1, 'SR', NULL, NULL, NULL),
(40328, '2017-07-30 11:21:43', NULL, NULL, 11569, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:21:43', 'admin-1501384088-15013849029205948', 1, 0, '', NULL, NULL, NULL),
(40329, '2017-07-30 12:29:02', NULL, NULL, 11584, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:29:02', 'admin-1501388385-15013889420869879', 1, 1, 'SR', NULL, NULL, NULL),
(40330, '2017-07-30 11:07:22', NULL, NULL, 11566, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:07:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40331, '2017-07-30 10:35:32', NULL, NULL, 11560, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:35:32', 'admin-1501380991-15013821320249988', 1, 1, 'SR', NULL, NULL, NULL),
(40332, '2017-07-30 10:39:30', NULL, NULL, 11549, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:39:30', 'admin-1501380991-15013823707979821', 1, 0, '', NULL, NULL, NULL),
(40333, '2017-07-30 10:47:12', NULL, NULL, 11561, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:47:12', 'admin-1501380991-1501382832741490', 1, 1, 'SR', NULL, NULL, NULL),
(40334, '2017-07-30 09:27:34', NULL, NULL, 11548, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:27:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40335, '2017-07-30 12:25:14', NULL, NULL, 11580, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:25:14', 'admin-1501388385-15013887146829597', 1, 0, '', NULL, NULL, '10.0'),
(40336, '2017-07-30 12:26:19', NULL, NULL, 11580, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:26:19', 'admin-1501388385-15013887792579285', 1, 1, 'SR', NULL, NULL, '10.0'),
(40337, '2017-07-30 13:06:18', NULL, NULL, 11588, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:06:18', 'admin-1501390516-15013911786925851', 1, 0, '', NULL, NULL, NULL),
(40338, '2017-07-30 12:24:37', NULL, NULL, 11583, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:24:37', 'admin-1501388385-15013886776376818', 1, 1, 'SR', NULL, NULL, NULL),
(40339, '2017-07-30 12:24:37', NULL, NULL, 11583, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:24:37', 'admin-1501388385-15013886776376818', 1, 1, 'SR', NULL, NULL, NULL),
(40340, '2017-07-30 13:36:08', NULL, NULL, 11594, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:36:08', 'admin-1501392616-15013929680374164', 1, 0, '', NULL, NULL, NULL),
(40341, '2017-07-30 09:33:14', NULL, NULL, 11549, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:33:14', 'admin-1501376774-15013783943044230', 1, 1, 'SR', NULL, NULL, NULL),
(40342, '2017-07-30 09:53:23', NULL, NULL, 11550, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:53:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40343, '2017-07-30 12:12:06', NULL, NULL, 11581, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:12:06', 'admin-1501386887-15013879261144138', 1, 1, 'SR', NULL, NULL, NULL),
(40344, '2017-07-30 12:19:15', NULL, NULL, 11581, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:19:15', 'admin-1501386887-15013883554711266', 1, 0, '', NULL, NULL, NULL),
(40345, '2017-07-30 12:12:06', NULL, NULL, 11581, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:12:06', 'admin-1501386887-15013879261144138', 1, 1, 'SR', NULL, NULL, NULL),
(40346, '2017-07-30 12:20:55', NULL, NULL, 11582, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:20:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40347, '2017-07-30 12:10:39', NULL, NULL, 11581, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:10:39', 'admin-1501386887-15013878391058092', 1, 0, '', NULL, NULL, NULL),
(40348, '2017-07-30 11:54:17', NULL, NULL, 11577, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:54:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40349, '2017-07-30 11:54:40', NULL, NULL, 11577, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:54:40', 'admin-1501384088-15013868805536581', 1, 0, '', NULL, NULL, NULL),
(40350, '2017-07-30 11:54:40', NULL, NULL, 11577, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:54:40', 'admin-1501384088-15013868805536581', 1, 0, '', NULL, NULL, NULL),
(40351, '2017-07-30 11:54:40', NULL, NULL, 11577, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:54:40', 'admin-1501384088-15013868805536581', 1, 0, '', NULL, NULL, NULL),
(40352, '2017-07-30 11:54:40', NULL, NULL, 11577, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:54:40', 'admin-1501384088-15013868805536581', 1, 1, 'SR', NULL, NULL, NULL),
(40353, '2017-07-30 11:57:18', NULL, NULL, 11578, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:57:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40354, '2017-07-30 11:57:35', NULL, NULL, 11578, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:57:35', 'admin-1501386887-15013870553155440', 1, 0, '', NULL, NULL, NULL),
(40355, '2017-07-30 11:51:55', NULL, NULL, 11574, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:51:55', 'admin-1501384088-1501386715634989', 1, 0, '', NULL, NULL, NULL),
(40356, '2017-07-30 12:50:11', NULL, NULL, 11586, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:50:11', 'admin-1501388385-15013902108776758', 1, 0, '', NULL, NULL, NULL),
(40357, '2017-07-30 12:09:30', NULL, NULL, 11581, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:09:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40358, '2017-07-30 12:07:24', NULL, NULL, 11580, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:07:24', 'admin-1501386887-15013876443743119', 1, 1, 'SR', NULL, NULL, '10.0'),
(40359, '2017-07-30 12:07:24', NULL, NULL, 11580, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:07:24', 'admin-1501386887-15013876443743119', 1, 0, '', NULL, NULL, '10.0'),
(40360, '2017-07-30 12:07:01', NULL, NULL, 11580, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:07:01', 'admin-1501386887-15013876207398999', 1, 0, '', NULL, NULL, '10.0'),
(40361, '2017-07-30 12:07:00', NULL, NULL, 11580, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:07:00', 'admin-1501386887-15013876207398999', 1, 1, 'SR', NULL, NULL, '10.0'),
(40362, '2017-07-30 12:07:00', NULL, NULL, 11580, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:07:00', 'admin-1501386887-15013876207398999', 1, 1, 'SR', NULL, NULL, '10.0'),
(40363, '2017-07-30 12:50:11', NULL, NULL, 11586, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:50:11', 'admin-1501388385-15013902108776758', 1, 0, '', NULL, NULL, NULL),
(40364, '2017-07-30 12:07:00', NULL, NULL, 11580, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:07:00', 'admin-1501386887-15013876207398999', 1, 1, 'SR', NULL, NULL, '10.0'),
(40365, '2017-07-30 12:03:09', NULL, NULL, 11580, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.90, 0.0000, 0.0000, 15.90, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:03:09', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(40366, '2017-07-30 12:02:57', NULL, NULL, 11579, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:02:57', 'admin-1501386887-1501387376988750', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(40367, '2017-07-30 11:23:02', NULL, NULL, 11569, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:23:02', 'admin-1501384088-15013849826937654', 1, 0, '', NULL, NULL, NULL),
(40368, '2017-07-30 11:23:02', NULL, NULL, 11569, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:23:02', 'admin-1501384088-15013849826937654', 1, 0, '', NULL, NULL, NULL),
(40369, '2017-07-30 11:23:11', NULL, NULL, 11570, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:23:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40370, '2017-07-30 11:23:42', NULL, NULL, 11570, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:23:42', 'admin-1501384088-15013850224744631', 1, 1, 'SR', NULL, NULL, NULL),
(40371, '2017-07-30 11:23:42', NULL, NULL, 11570, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:23:42', 'admin-1501384088-15013850224744631', 1, 1, 'SR', NULL, NULL, NULL),
(40372, '2017-07-30 10:15:26', NULL, NULL, 11556, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:15:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40373, '2017-07-30 14:25:24', NULL, NULL, 11597, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:25:24', 'admin-1501392616-15013959239231442', 1, 1, 'SR', NULL, NULL, NULL),
(40374, '2017-07-30 13:30:08', NULL, NULL, 11593, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:30:08', 'admin-1501390516-15013926080198228', 1, 1, 'SR', NULL, NULL, NULL),
(40375, '2017-07-30 11:57:35', NULL, NULL, 11578, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:57:35', 'admin-1501386887-15013870553155440', 1, 0, '', NULL, NULL, NULL),
(40376, '2017-07-30 11:11:22', NULL, NULL, 11567, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:11:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40377, '2017-07-30 10:00:53', NULL, NULL, 11553, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:00:53', 'admin-1501379810-1501380053545946', 1, 0, '', NULL, NULL, NULL),
(40378, '2017-07-30 14:25:10', NULL, NULL, 11597, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:25:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40379, '2017-07-30 11:51:55', NULL, NULL, 11574, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:51:55', 'admin-1501384088-1501386715634989', 1, 1, 'SR', NULL, NULL, NULL),
(40380, '2017-07-30 10:21:43', NULL, NULL, 11557, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:21:43', 'admin-1501380991-15013813028963243', 1, 0, '', NULL, NULL, NULL),
(40381, '2017-07-30 10:34:43', NULL, NULL, 11559, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:34:43', 'admin-1501380991-15013820833979761', 1, 1, 'SR', NULL, NULL, NULL),
(40382, '2017-07-30 10:28:53', NULL, NULL, 11555, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:28:53', 'admin-1501380991-15013817329302662', 1, 0, '', NULL, NULL, NULL),
(40383, '2017-07-30 11:25:00', NULL, NULL, 11571, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:25:00', 'admin-1501384088-15013851005792445', 1, 1, 'SR', NULL, NULL, NULL),
(40384, '2017-07-30 11:25:00', NULL, NULL, 11571, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:25:00', 'admin-1501384088-15013851005792445', 1, 1, 'SR', NULL, NULL, NULL),
(40385, '2017-07-30 11:35:18', NULL, NULL, 11572, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:35:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40386, '2017-07-30 11:35:48', NULL, NULL, 11572, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:35:48', 'admin-1501384088-15013857483309777', 1, 0, '', NULL, NULL, NULL),
(40387, '2017-07-30 12:21:00', NULL, NULL, 11582, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:21:00', 'admin-1501388385-15013884601396321', 1, 0, '', NULL, NULL, NULL),
(40388, '2017-07-30 11:39:27', NULL, NULL, 11574, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:39:27', 'admin-1501384088-15013859675331420', 1, 1, 'SR', NULL, NULL, NULL),
(40389, '2017-07-30 11:50:47', NULL, NULL, 11576, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:50:47', 'admin-1501384088-15013866475995777', 1, 1, 'SR', NULL, NULL, NULL),
(40390, '2017-07-30 11:48:53', NULL, NULL, 11576, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:48:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40391, '2017-07-30 11:48:47', NULL, NULL, 11574, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:48:47', 'admin-1501384088-15013865276105195', 1, 0, '', NULL, NULL, NULL),
(40392, '2017-07-30 11:44:19', NULL, NULL, 11574, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:44:19', 'admin-1501384088-15013862594953487', 1, 0, '', NULL, NULL, NULL),
(40393, '2017-07-30 11:43:37', NULL, NULL, 11575, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:43:37', 'admin-1501384088-15013862176416577', 1, 0, '', NULL, NULL, NULL),
(40394, '2017-07-30 11:43:37', NULL, NULL, 11575, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:43:37', 'admin-1501384088-15013862176416577', 1, 0, '', NULL, NULL, NULL),
(40395, '2017-07-30 11:43:21', NULL, NULL, 11575, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:43:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40396, '2017-07-30 11:39:27', NULL, NULL, 11574, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:39:27', 'admin-1501384088-15013859675331420', 1, 0, '', NULL, NULL, NULL),
(40397, '2017-07-30 11:39:27', NULL, NULL, 11574, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:39:27', 'admin-1501384088-15013859675331420', 1, 0, '', NULL, NULL, NULL),
(40398, '2017-07-30 14:01:05', NULL, NULL, 11596, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:01:05', 'admin-1501392616-15013944652125170', 1, 1, 'SR', NULL, NULL, NULL),
(40399, '2017-07-30 11:38:53', NULL, NULL, 11572, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:38:53', 'admin-1501384088-15013859337625760', 1, 0, '', NULL, NULL, NULL),
(40400, '2017-07-30 11:39:27', NULL, NULL, 11574, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:39:27', 'admin-1501384088-15013859675331420', 1, 1, 'SR', NULL, NULL, NULL),
(40401, '2017-07-30 11:35:48', NULL, NULL, 11572, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:35:48', 'admin-1501384088-15013857483309777', 1, 0, '', NULL, NULL, NULL),
(40402, '2017-07-30 11:39:27', NULL, NULL, 11574, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:39:27', 'admin-1501384088-15013859675331420', 1, 1, 'SR', NULL, NULL, NULL),
(40403, '2017-07-30 13:06:43', NULL, NULL, 11589, 0, 182, '117', 'Open Drinks ', 'stamp', 'Cold Drinks', 'Fresh Juice', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:06:43', 'admin-1501390516-1501391203333784', 1, 0, '', 1, NULL, NULL),
(40404, '2017-07-30 11:36:49', NULL, NULL, 11574, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:36:49', 'admin-1501384088-15013858094457960', 1, 1, 'SR', NULL, NULL, NULL),
(40405, '2017-07-30 11:37:13', NULL, NULL, 11572, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:37:13', 'admin-1501384088-1501385833415172', 1, 0, '', NULL, NULL, NULL),
(40406, '2017-07-30 15:20:50', NULL, NULL, 11602, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 15:20:50', 'admin-1501396592-15013992507078016', 1, 1, 'SR', 1, NULL, '10.0'),
(40407, '2017-07-30 12:24:23', NULL, NULL, 11583, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:24:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40408, '2017-07-30 13:10:33', NULL, NULL, 11591, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:10:33', 'admin-1501390516-1501391433334193', 1, 0, '', NULL, NULL, NULL),
(40409, '2017-07-30 11:36:27', NULL, NULL, 11574, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 19.50, 0.0000, 0.0000, 19.50, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:36:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40410, '2017-07-30 12:28:33', NULL, NULL, 11584, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:28:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40411, '2017-07-30 11:35:48', NULL, NULL, 11572, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:35:48', 'admin-1501384088-15013857483309777', 1, 0, '', NULL, NULL, NULL),
(40412, '2017-07-30 11:36:01', NULL, NULL, 11573, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:36:01', 'admin-1501384088-15013857616778217', 1, 0, '', 1, NULL, NULL),
(40413, '2017-07-30 09:56:01', NULL, NULL, 11551, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:56:01', 'admin-1501376774-15013797614086670', 1, 0, '', NULL, NULL, NULL),
(40414, '2017-07-30 09:56:01', NULL, NULL, 11551, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:56:01', 'admin-1501376774-15013797614086670', 1, 0, '', NULL, NULL, NULL),
(40415, '2017-07-30 11:35:48', NULL, NULL, 11572, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:35:48', 'admin-1501384088-15013857483309777', 1, 1, 'SR', NULL, NULL, NULL),
(40416, '2017-07-30 10:33:06', NULL, NULL, 11559, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:33:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40417, '2017-07-30 10:18:22', NULL, NULL, 11557, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:18:22', 'admin-1501380991-15013811024234494', 1, 0, '', NULL, NULL, NULL),
(40418, '2017-07-30 10:18:22', NULL, NULL, 11557, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:18:22', 'admin-1501380991-15013811024234494', 1, 0, '', NULL, NULL, NULL),
(40419, '2017-07-30 10:18:22', NULL, NULL, 11557, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:18:22', 'admin-1501380991-15013811024234494', 1, 1, 'SR', NULL, NULL, NULL),
(40420, '2017-07-30 10:05:49', NULL, NULL, 11555, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:05:49', 'admin-1501379810-15013803492237136', 1, 0, '', NULL, NULL, NULL),
(40421, '2017-07-30 10:19:14', NULL, NULL, 11549, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:19:14', 'admin-1501380991-15013811540319033', 1, 0, '', NULL, NULL, NULL),
(40422, '2017-07-30 11:25:00', NULL, NULL, 11571, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:25:00', 'admin-1501384088-15013851005792445', 1, 0, '', NULL, NULL, NULL),
(40423, '2017-07-30 11:24:45', NULL, NULL, 11571, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.59, 0.0000, 0.0000, 4.59, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:24:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40424, '2017-07-30 16:03:31', NULL, NULL, 11604, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1501396592', 'admin', '2017-07-30 16:03:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40425, '2017-07-30 14:39:23', NULL, NULL, 11599, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 14:39:23', 'admin-1501396592-15013967633494920', 1, 1, 'SR', NULL, NULL, NULL),
(40426, '2017-07-30 12:02:25', NULL, NULL, 11579, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:02:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40427, '2017-07-30 10:50:43', NULL, NULL, 11562, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:50:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40428, '2017-07-30 10:50:48', NULL, NULL, 11562, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:50:48', 'admin-1501380991-15013830480531744', 1, 1, 'SR', NULL, NULL, NULL),
(40429, '2017-07-30 10:50:48', NULL, NULL, 11562, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:50:48', 'admin-1501380991-15013830480531744', 1, 0, '', NULL, NULL, NULL),
(40430, '2017-07-30 10:53:02', NULL, NULL, 11563, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:53:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40431, '2017-07-30 10:53:11', NULL, NULL, 11563, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:53:11', 'admin-1501380991-15013831916861650', 1, 0, '', NULL, NULL, NULL),
(40432, '2017-07-30 11:21:43', NULL, NULL, 11569, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:21:43', 'admin-1501384088-15013849029205948', 1, 0, '', NULL, NULL, NULL),
(40433, '2017-07-30 11:15:53', NULL, NULL, 11568, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:15:53', 'admin-1501384088-15013845533909854', 1, 1, 'SR', NULL, NULL, NULL),
(40434, '2017-07-30 16:03:42', NULL, NULL, 11604, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 16:03:42', 'admin-1501396592-15014018223466973', 1, 1, 'SR', NULL, NULL, NULL),
(40435, '2017-07-30 10:53:11', NULL, NULL, 11563, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:53:11', 'admin-1501380991-15013831916861650', 1, 1, 'SR', NULL, NULL, NULL),
(40436, '2017-07-30 10:53:11', NULL, NULL, 11563, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:53:11', 'admin-1501380991-15013831916861650', 1, 1, 'SR', NULL, NULL, NULL),
(40437, '2017-07-30 10:57:35', NULL, NULL, 11564, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:57:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40438, '2017-07-30 10:57:39', NULL, NULL, 11564, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:57:39', 'admin-1501380991-15013834594705412', 1, 1, 'SR', NULL, NULL, NULL),
(40439, '2017-07-30 10:57:39', NULL, NULL, 11564, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:57:39', 'admin-1501380991-15013834594705412', 1, 1, 'SR', NULL, NULL, NULL),
(40440, '2017-07-30 11:01:53', NULL, NULL, 11565, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:01:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40441, '2017-07-30 11:02:10', NULL, NULL, 11565, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:02:10', 'admin-1501380991-15013837305447440', 1, 0, '', NULL, NULL, NULL),
(40442, '2017-07-30 11:02:10', NULL, NULL, 11565, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:02:10', 'admin-1501380991-15013837305447440', 1, 1, 'SR', NULL, NULL, NULL),
(40443, '2017-07-30 11:02:10', NULL, NULL, 11565, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:02:10', 'admin-1501380991-15013837305447440', 1, 1, 'SR', NULL, NULL, NULL),
(40444, '2017-07-30 11:02:10', NULL, NULL, 11565, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:02:10', 'admin-1501380991-15013837305447440', 1, 1, 'SR', NULL, NULL, NULL),
(40445, '2017-07-30 11:15:18', NULL, NULL, 11568, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:15:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40446, '2017-07-30 11:11:26', NULL, NULL, 11567, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:11:26', 'admin-1501384088-15013842858617728', 1, 1, 'SR', NULL, NULL, NULL),
(40447, '2017-07-30 09:27:56', NULL, NULL, 11548, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:27:56', 'admin-1501376774-15013780764823465', 1, 0, '', NULL, NULL, NULL),
(40448, '2017-07-30 09:27:56', NULL, NULL, 11548, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:27:56', 'admin-1501376774-15013780764823465', 1, 0, '', NULL, NULL, NULL),
(40449, '2017-07-30 09:27:56', NULL, NULL, 11548, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:27:56', 'admin-1501376774-15013780764823465', 1, 0, '', NULL, NULL, NULL),
(40450, '2017-07-30 09:32:02', NULL, NULL, 11549, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:32:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40451, '2017-07-30 09:32:37', NULL, NULL, 11549, 0, 157, '91', 'French Toast with Fruits', 'no banana', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:32:37', 'admin-1501376774-15013783574458830', 1, 0, '', NULL, NULL, NULL),
(40452, '2017-07-30 10:16:16', NULL, NULL, 11556, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:16:16', 'admin-1501379810-1501380976053596', 1, 1, 'SR', NULL, NULL, NULL),
(40453, '2017-07-30 10:01:13', NULL, NULL, 11553, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:01:13', 'admin-1501379810-15013800737271940', 1, 1, 'SR', NULL, NULL, NULL),
(40454, '2017-07-30 10:53:11', NULL, NULL, 11563, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:53:11', 'admin-1501380991-15013831916861650', 1, 0, '', NULL, NULL, NULL),
(40455, '2017-07-30 10:47:08', NULL, NULL, 11561, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:47:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40456, '2017-07-30 09:56:42', NULL, NULL, 11552, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:56:42', 'admin-1501376774-15013798019565731', 1, 0, '', NULL, NULL, NULL),
(40457, '2017-07-30 09:56:42', NULL, NULL, 11552, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:56:42', 'admin-1501376774-15013798019565731', 1, 1, 'SR', NULL, NULL, NULL),
(40458, '2017-07-30 09:56:42', NULL, NULL, 11552, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:56:42', 'admin-1501376774-15013798019565731', 1, 1, 'SR', NULL, NULL, NULL),
(40459, '2017-07-30 10:00:14', NULL, NULL, 11553, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:00:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40460, '2017-07-30 10:00:53', NULL, NULL, 11553, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:00:53', 'admin-1501379810-1501380053545946', 1, 0, '', NULL, NULL, NULL),
(40461, '2017-07-30 10:00:53', NULL, NULL, 11553, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:00:53', 'admin-1501379810-1501380053545946', 1, 0, '', NULL, NULL, NULL),
(40462, '2017-07-30 13:48:03', NULL, NULL, 11595, 0, 222, '156', 'Seasoned Chicken Aglio Olio', 'Takeaway', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 13:48:03', 'admin-1501392616-15013936827114040', 1, 0, '', NULL, NULL, NULL),
(40463, '2017-07-30 11:23:42', NULL, NULL, 11570, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:23:42', 'admin-1501384088-15013850224744631', 1, 1, 'SR', NULL, NULL, NULL),
(40464, '2017-07-30 10:33:21', NULL, NULL, 11559, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:33:21', 'admin-1501380991-15013820012126049', 1, 0, '', NULL, NULL, NULL),
(40465, '2017-07-30 09:54:06', NULL, NULL, 11550, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:54:06', 'admin-1501376774-15013796464323682', 1, 0, '', NULL, NULL, NULL),
(40466, '2017-07-30 09:54:27', NULL, NULL, 11550, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:54:27', 'admin-1501376774-15013796671551982', 1, 1, 'SR', NULL, NULL, NULL),
(40467, '2017-07-30 09:56:16', NULL, NULL, 11552, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:56:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40468, '2017-07-30 10:33:21', NULL, NULL, 11559, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:33:21', 'admin-1501380991-15013820012126049', 1, 0, '', NULL, NULL, NULL),
(40469, '2017-07-30 12:50:11', NULL, NULL, 11586, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:50:11', 'admin-1501388385-15013902108776758', 1, 0, '', NULL, NULL, NULL),
(40470, '2017-07-30 11:23:02', NULL, NULL, 11569, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:23:02', 'admin-1501384088-15013849826937654', 1, 1, 'SR', NULL, NULL, NULL),
(40471, '2017-07-30 10:27:22', NULL, NULL, 11558, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:27:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40472, '2017-07-30 10:27:32', NULL, NULL, 11558, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:27:32', 'admin-1501380991-15013816518033465', 1, 0, '', NULL, NULL, NULL),
(40473, '2017-07-30 10:27:32', NULL, NULL, 11558, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:27:32', 'admin-1501380991-15013816518033465', 1, 0, '', NULL, NULL, NULL),
(40474, '2017-07-30 10:16:16', NULL, NULL, 11556, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:16:16', 'admin-1501379810-1501380976053596', 1, 0, '', NULL, NULL, NULL),
(40475, '2017-07-30 10:16:16', NULL, NULL, 11556, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:16:16', 'admin-1501379810-1501380976053596', 1, 1, 'SR', NULL, NULL, NULL),
(40476, '2017-07-30 10:17:38', NULL, NULL, 11549, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:17:38', 'admin-1501380991-15013810580207452', 1, 1, 'SR', NULL, NULL, NULL),
(40477, '2017-07-30 10:17:43', NULL, NULL, 11557, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:17:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40478, '2017-07-30 10:18:22', NULL, NULL, 11557, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:18:22', 'admin-1501380991-15013811024234494', 1, 0, '', NULL, NULL, NULL),
(40479, '2017-07-30 09:33:14', NULL, NULL, 11549, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:33:14', 'admin-1501376774-15013783943044230', 1, 0, '', NULL, NULL, NULL),
(40480, '2017-07-30 10:18:22', NULL, NULL, 11557, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:18:22', 'admin-1501380991-15013811024234494', 1, 1, 'SR', NULL, NULL, NULL),
(40481, '2017-07-30 10:16:16', NULL, NULL, 11556, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:16:16', 'admin-1501379810-1501380976053596', 1, 0, '', NULL, NULL, NULL),
(40482, '2017-07-30 10:16:16', NULL, NULL, 11556, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:16:16', 'admin-1501379810-1501380976053596', 1, 0, '', NULL, NULL, NULL),
(40483, '2017-07-30 10:16:16', NULL, NULL, 11556, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:16:16', 'admin-1501379810-1501380976053596', 1, 0, '', NULL, NULL, NULL),
(40484, '2017-07-30 10:09:58', NULL, NULL, 11551, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:09:58', 'admin-1501379810-15013805980679183', 1, 1, 'SR', NULL, NULL, NULL),
(40485, '2017-07-30 10:09:58', NULL, NULL, 11551, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:09:58', 'admin-1501379810-15013805980679183', 1, 0, '', NULL, NULL, NULL),
(40486, '2017-07-30 10:05:49', NULL, NULL, 11555, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:05:49', 'admin-1501379810-15013803492237136', 1, 1, 'SR', NULL, NULL, NULL),
(40487, '2017-07-30 10:05:49', NULL, NULL, 11555, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:05:49', 'admin-1501379810-15013803492237136', 1, 0, '', NULL, NULL, NULL),
(40488, '2017-07-30 12:34:38', NULL, NULL, 11580, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 12:34:38', 'admin-1501388385-15013892782315364', 1, 1, 'SR', NULL, NULL, '10.0'),
(40489, '2017-07-30 10:05:28', NULL, NULL, 11555, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:05:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40490, '2017-07-30 10:01:13', NULL, NULL, 11553, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:01:13', 'admin-1501379810-15013800737271940', 1, 0, '', NULL, NULL, NULL),
(40491, '2017-07-30 10:01:35', NULL, NULL, 11554, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:01:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40492, '2017-07-30 11:15:53', NULL, NULL, 11568, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:15:53', 'admin-1501384088-15013845533909854', 1, 1, 'SR', NULL, NULL, NULL),
(40493, '2017-07-30 10:53:11', NULL, NULL, 11563, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:53:11', 'admin-1501380991-15013831916861650', 1, 0, '', NULL, NULL, NULL),
(40494, '2017-07-30 10:00:53', NULL, NULL, 11553, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 10:00:53', 'admin-1501379810-1501380053545946', 1, 0, '', NULL, NULL, NULL),
(40495, '2017-07-30 09:56:01', NULL, NULL, 11551, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:56:01', 'admin-1501376774-15013797614086670', 1, 1, 'SR', NULL, NULL, NULL),
(40496, '2017-07-30 09:56:01', NULL, NULL, 11551, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:56:01', 'admin-1501376774-15013797614086670', 1, 0, '', NULL, NULL, NULL),
(40497, '2017-07-30 09:56:42', NULL, NULL, 11552, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:56:42', 'admin-1501376774-15013798019565731', 1, 0, '', NULL, NULL, NULL),
(40498, '2017-07-30 09:54:27', NULL, NULL, 11550, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:54:27', 'admin-1501376774-15013796671551982', 1, 1, 'SR', NULL, NULL, NULL),
(40499, '2017-07-30 09:54:27', NULL, NULL, 11550, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:54:27', 'admin-1501376774-15013796671551982', 1, 0, '', NULL, NULL, NULL),
(40500, '2017-07-30 11:50:47', NULL, NULL, 11576, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 11:50:47', 'admin-1501384088-15013866475995777', 1, 1, 'SR', NULL, NULL, NULL),
(40501, '2017-07-30 09:56:01', NULL, NULL, 11551, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:56:01', 'admin-1501376774-15013797614086670', 1, 0, '', NULL, NULL, NULL),
(40502, '2017-07-30 09:54:06', NULL, NULL, 11550, 0, 153, '87', 'Wake Me Up!', 'plain scramble egg', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:54:06', 'admin-1501376774-15013796464323682', 1, 0, '', NULL, NULL, NULL),
(40503, '2017-07-30 09:54:06', NULL, NULL, 11550, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:54:06', 'admin-1501376774-15013796464323682', 1, 0, '', NULL, NULL, NULL),
(40504, '2017-07-30 09:55:29', NULL, NULL, 11551, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.50, 0.0000, 0.0000, 9.50, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:55:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40505, '2017-07-30 09:33:14', NULL, NULL, 11549, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:33:14', 'admin-1501376774-15013783943044230', 1, 0, '', NULL, NULL, NULL),
(40506, '2017-07-30 09:32:37', NULL, NULL, 11549, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:32:37', 'admin-1501376774-15013783574458830', 1, 0, '', NULL, NULL, NULL),
(40507, '2017-07-30 09:22:00', NULL, NULL, 11547, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:22:00', 'admin-1501376774-15013777203297049', 1, 1, 'SR', NULL, NULL, NULL),
(40508, '2017-07-30 09:22:00', NULL, NULL, 11547, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:22:00', 'admin-1501376774-15013777203297049', 1, 0, '', NULL, NULL, NULL),
(40509, '2017-07-30 09:22:00', NULL, NULL, 11547, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:22:00', 'admin-1501376774-15013777203297049', 1, 0, '', NULL, NULL, NULL),
(40510, '2017-07-30 09:22:00', NULL, NULL, 11547, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:22:00', 'admin-1501376774-15013777203297049', 1, 1, 'SR', NULL, NULL, NULL),
(40511, '2017-07-30 09:21:47', NULL, NULL, 11547, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 09:21:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40512, '2017-07-30 16:16:35', NULL, NULL, 11605, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1501396592', 'admin', '2017-07-30 16:16:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40513, '2017-07-30 16:16:45', NULL, NULL, 11605, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 16:16:45', 'admin-1501396592-15014026050333283', 1, 0, '', NULL, NULL, NULL),
(40514, '2017-07-30 16:16:45', NULL, NULL, 11605, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 16:16:45', 'admin-1501396592-15014026050333283', 1, 1, 'SR', NULL, NULL, NULL),
(40515, '2017-07-30 16:16:53', NULL, NULL, 11606, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 16:16:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40516, '2017-07-30 16:16:59', NULL, NULL, 11606, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 16:16:59', 'admin-1501396592-15014026189284321', 1, 1, 'SR', NULL, NULL, NULL),
(40517, '2017-07-30 16:16:59', NULL, NULL, 11606, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 16:16:59', 'admin-1501396592-15014026189284321', 1, 1, 'SR', NULL, NULL, NULL),
(40518, '2017-07-30 16:16:59', NULL, NULL, 11606, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 16:16:59', 'admin-1501396592-15014026189284321', 1, 1, 'SR', NULL, NULL, NULL),
(40519, '2017-07-30 16:18:41', NULL, NULL, 11607, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1501396592', 'admin', '2017-07-30 16:18:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40520, '2017-07-30 16:18:48', NULL, NULL, 11607, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 16:18:48', 'admin-1501396592-1501402728029764', 1, 1, 'SR', NULL, NULL, NULL),
(40521, '2017-07-30 16:18:48', NULL, NULL, 11607, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 16:18:48', 'admin-1501396592-1501402728029764', 1, 1, 'SR', NULL, NULL, NULL),
(40522, '2017-07-30 16:18:48', NULL, NULL, 11607, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 16:18:48', 'admin-1501396592-1501402728029764', 1, 0, '', NULL, NULL, NULL),
(40523, '2017-07-30 16:18:48', NULL, NULL, 11607, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 16:18:48', 'admin-1501396592-1501402728029764', 1, 0, '', NULL, NULL, NULL),
(40524, '2017-07-30 16:28:24', NULL, NULL, 11608, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1501396592', 'admin', '2017-07-30 16:28:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40525, '2017-07-30 16:28:26', NULL, NULL, 11608, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 16:28:26', 'admin-1501396592-15014033067969115', 1, 1, 'SR', NULL, NULL, NULL),
(40526, '2017-07-30 16:28:26', NULL, NULL, 11608, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 16:28:26', 'admin-1501396592-15014033067969115', 1, 1, 'SR', NULL, NULL, NULL),
(40527, '2017-07-30 16:59:43', NULL, NULL, 11609, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 16:59:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40528, '2017-07-30 16:59:46', NULL, NULL, 11609, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 16:59:46', 'admin-1501396592-15014051867305440', 1, 1, 'SR', NULL, NULL, NULL),
(40529, '2017-07-30 17:18:19', NULL, NULL, 11610, 0, 181, '116', 'Open Food ', 'ICE CREAM', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1501396592', 'admin', '2017-07-30 17:18:19', 'admin-1501396592-15014062996806872', 1, 0, '', 1, NULL, NULL),
(40530, '2017-07-31 14:03:52', NULL, NULL, 11626, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:03:52', 'admin-1501472156-1501481032000204', 1, 0, '', NULL, NULL, NULL),
(40531, '2017-07-31 14:04:16', NULL, NULL, 11626, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:04:16', 'admin-1501472156-15014810565104411', 1, 0, '', NULL, NULL, NULL),
(40532, '2017-07-31 14:28:51', NULL, NULL, 11628, 0, 181, '116', 'Open Food ', 'bacon', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:28:51', 'admin-1501482174-15014825308643938', 1, 0, '', NULL, NULL, NULL),
(40533, '2017-07-31 14:28:51', NULL, NULL, 11628, 0, 181, '116', 'Open Food ', 'bacon', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:28:51', 'admin-1501482174-15014825308643938', 1, 0, '', NULL, NULL, NULL),
(40534, '2017-07-31 14:28:51', NULL, NULL, 11628, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:28:51', 'admin-1501482174-15014825308643938', 1, 0, '', NULL, NULL, NULL),
(40535, '2017-07-31 14:29:08', NULL, NULL, 11628, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:29:08', 'admin-1501482174-15014825481027225', 1, 1, 'SR', NULL, NULL, NULL),
(40536, '2017-07-31 14:29:08', NULL, NULL, 11628, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:29:08', 'admin-1501482174-15014825481027225', 1, 1, 'SR', NULL, NULL, NULL),
(40537, '2017-07-31 14:29:08', NULL, NULL, 11628, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:29:08', 'admin-1501482174-15014825481027225', 1, 1, 'SR', NULL, NULL, NULL),
(40538, '2017-07-31 14:32:07', NULL, NULL, 11629, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:32:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40539, '2017-07-31 14:32:16', NULL, NULL, 11629, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:32:16', 'admin-1501482174-15014827364499053', 1, 0, '', NULL, NULL, NULL),
(40540, '2017-07-31 14:32:16', NULL, NULL, 11629, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:32:16', 'admin-1501482174-15014827364499053', 1, 1, 'SR', NULL, NULL, NULL),
(40541, '2017-07-31 14:44:42', NULL, NULL, 11630, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:44:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40542, '2017-07-31 14:44:46', NULL, NULL, 11630, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:44:46', 'admin-1501482174-15014834859454232', 1, 1, 'SR', NULL, NULL, NULL),
(40543, '2017-07-31 14:48:47', NULL, NULL, 11631, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:48:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40544, '2017-07-31 14:49:31', NULL, NULL, 11631, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:49:31', 'admin-1501482174-15014837710822927', 1, 0, '', NULL, NULL, NULL),
(40545, '2017-07-31 16:43:10', NULL, NULL, 11636, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 16:43:10', 'admin-1501484253-1501490590666653', 1, 1, 'SR', NULL, NULL, NULL),
(40546, '2017-07-31 16:43:12', NULL, NULL, 11637, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1501492896', 'admin', '2017-07-31 16:43:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40547, '2017-07-31 16:43:20', NULL, NULL, 11637, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 16:43:20', 'admin-1501484253-1501490600217236', 1, 1, 'SR', NULL, NULL, NULL),
(40548, '2017-07-31 17:21:11', NULL, NULL, 11638, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1501492896', 'admin', '2017-07-31 17:21:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40549, '2017-07-31 00:00:00', NULL, NULL, 11638, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 16:43:20', 'admin-1501484253-1501490600217236', 1, 1, 'SR', NULL, NULL, NULL),
(40550, '2017-07-31 14:59:34', NULL, NULL, 11632, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:59:34', 'admin-1501484253-15014843741314989', 1, 0, '', 1, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(40551, '2017-07-31 16:43:04', NULL, NULL, 11636, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1501492896', 'admin', '2017-07-31 16:43:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40552, '2017-07-31 16:43:10', NULL, NULL, 11636, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 16:43:10', 'admin-1501484253-1501490590666653', 1, 1, 'SR', NULL, NULL, NULL),
(40553, '2017-07-31 15:30:03', NULL, NULL, 11634, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 15:30:03', 'admin-1501484253-15014862028305344', 1, 1, 'SR', NULL, NULL, NULL),
(40554, '2017-07-31 15:30:03', NULL, NULL, 11634, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 15:30:03', 'admin-1501484253-15014862028305344', 1, 1, 'SR', NULL, NULL, NULL),
(40555, '2017-07-31 15:30:03', NULL, NULL, 11634, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 15:30:03', 'admin-1501484253-15014862028305344', 1, 1, 'SR', NULL, NULL, NULL),
(40556, '2017-07-31 15:30:03', NULL, NULL, 11634, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 15:30:03', 'admin-1501484253-15014862028305344', 1, 0, '', NULL, NULL, NULL),
(40557, '2017-07-31 15:30:03', NULL, NULL, 11634, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 15:30:03', 'admin-1501484253-15014862028305344', 1, 1, 'SR', NULL, NULL, NULL),
(40558, '2017-07-31 16:18:19', NULL, NULL, 11635, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1501492896', 'admin', '2017-07-31 16:18:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40559, '2017-07-31 16:18:24', NULL, NULL, 11635, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 16:18:24', 'admin-1501484253-15014891043448498', 1, 0, '', NULL, NULL, NULL),
(40560, '2017-07-31 11:33:10', NULL, NULL, 11615, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 11:33:10', 'admin-1501464189-1501471989920453', 1, 0, '', NULL, NULL, NULL),
(40561, '2017-07-31 14:51:01', NULL, NULL, 11626, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:51:01', 'admin-1501482174-15014838611951177', 1, 1, 'SR', NULL, NULL, NULL),
(40562, '2017-07-31 14:51:01', NULL, NULL, 11626, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:51:01', 'admin-1501482174-15014838611951177', 1, 1, 'SR', NULL, NULL, NULL),
(40563, '2017-07-31 14:56:37', NULL, NULL, 11631, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:56:37', 'admin-1501482174-15014841972066948', 1, 0, '', NULL, NULL, NULL),
(40564, '2017-07-31 14:23:07', NULL, NULL, 11627, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:23:07', 'admin-1501482174-15014821876255494', 1, 0, '', NULL, NULL, NULL),
(40565, '2017-07-31 14:23:07', NULL, NULL, 11627, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:23:07', 'admin-1501482174-15014821876255494', 1, 0, '', NULL, NULL, NULL),
(40566, '2017-07-31 14:25:09', NULL, NULL, 11628, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.00, 0.0000, 0.0000, 11.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:25:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40567, '2017-07-31 14:25:29', NULL, NULL, 11628, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:25:29', 'admin-1501482174-1501482329087636', 1, 0, '', NULL, NULL, NULL),
(40568, '2017-07-31 14:25:29', NULL, NULL, 11628, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:25:29', 'admin-1501482174-1501482329087636', 1, 0, '', NULL, NULL, NULL),
(40569, '2017-07-31 14:00:59', NULL, NULL, 11626, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:00:59', 'admin-1501472156-15014808587358463', 1, 1, 'SR', NULL, NULL, NULL),
(40570, '2017-07-31 13:18:55', NULL, NULL, 11623, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1501492896', 'admin', '2017-07-31 13:18:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40571, '2017-07-31 13:18:59', NULL, NULL, 11623, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 13:18:59', 'admin-1501472156-15014783394134645', 1, 1, 'SR', NULL, NULL, NULL),
(40572, '2017-07-31 13:18:59', NULL, NULL, 11623, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 13:18:59', 'admin-1501472156-15014783394134645', 1, 0, '', NULL, NULL, NULL),
(40573, '2017-07-31 13:23:21', NULL, NULL, 11624, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1501492896', 'admin', '2017-07-31 13:23:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40574, '2017-07-31 13:23:28', NULL, NULL, 11624, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 13:23:28', 'admin-1501472156-15014786084042871', 1, 0, '', NULL, NULL, NULL),
(40575, '2017-07-31 13:23:28', NULL, NULL, 11624, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 13:23:28', 'admin-1501472156-15014786084042871', 1, 1, 'SR', NULL, NULL, NULL),
(40576, '2017-07-31 13:51:33', NULL, NULL, 11625, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1501492896', 'admin', '2017-07-31 13:51:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40577, '2017-07-31 13:51:39', NULL, NULL, 11625, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 13:51:39', 'admin-1501472156-15014802994677275', 1, 1, 'SR', NULL, NULL, NULL),
(40578, '2017-07-31 13:51:39', NULL, NULL, 11625, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 13:51:39', 'admin-1501472156-15014802994677275', 1, 0, '', NULL, NULL, NULL),
(40579, '2017-07-31 14:00:53', NULL, NULL, 11626, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:00:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40580, '2017-07-31 15:10:50', NULL, NULL, 11623, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 15:10:50', 'admin-1501484253-1501485049749933', 1, 1, 'SR', NULL, NULL, NULL),
(40581, '2017-07-31 15:12:48', NULL, NULL, 11633, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1501492896', 'admin', '2017-07-31 15:12:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40582, '2017-07-31 11:43:28', NULL, NULL, 11619, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 11:43:28', 'admin-1501472156-15014726085887324', 1, 0, '', NULL, NULL, NULL),
(40583, '2017-07-31 11:45:48', NULL, NULL, 11619, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 11:45:48', 'admin-1501472156-15014727485454360', 1, 1, 'SR', NULL, NULL, NULL),
(40584, '2017-07-31 12:37:54', NULL, NULL, 11620, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 12:37:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40585, '2017-07-31 12:38:03', NULL, NULL, 11620, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 12:38:03', 'admin-1501472156-15014758830682837', 1, 1, 'SR', NULL, NULL, NULL),
(40586, '2017-07-31 12:46:53', NULL, NULL, 11621, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1501492896', 'admin', '2017-07-31 12:46:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40587, '2017-07-31 12:46:57', NULL, NULL, 11621, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 12:46:57', 'admin-1501472156-1501476417692269', 1, 1, 'SR', NULL, NULL, NULL),
(40588, '2017-07-31 11:12:59', NULL, NULL, 11618, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 11:12:59', 'admin-1501464189-15014707793315570', 1, 1, 'SR', NULL, NULL, NULL),
(40589, '2017-07-31 11:12:59', NULL, NULL, 11618, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 11:12:59', 'admin-1501464189-15014707793315570', 1, 0, '', NULL, NULL, NULL),
(40590, '2017-07-31 11:23:08', NULL, NULL, 11615, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 11:23:08', 'admin-1501464189-15014713885686647', 1, 0, '', NULL, NULL, NULL),
(40591, '2017-07-31 13:08:53', NULL, NULL, 11622, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 13:08:53', 'admin-1501472156-15014777332829660', 1, 0, '', NULL, NULL, NULL),
(40592, '2017-07-31 16:18:24', NULL, NULL, 11635, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 16:18:24', 'admin-1501484253-15014891043448498', 1, 1, 'SR', NULL, NULL, NULL),
(40593, '2017-07-31 15:29:43', NULL, NULL, 11634, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1501492896', 'admin', '2017-07-31 15:29:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40594, '2017-07-31 15:13:09', NULL, NULL, 11633, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 15:13:09', 'admin-1501484253-1501485188880577', 1, 1, 'SR', NULL, NULL, NULL),
(40595, '2017-07-31 15:13:09', NULL, NULL, 11633, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 15:13:09', 'admin-1501484253-1501485188880577', 1, 0, '', NULL, NULL, NULL),
(40596, '2017-07-31 15:13:09', NULL, NULL, 11633, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 15:13:09', 'admin-1501484253-1501485188880577', 1, 1, 'SR', NULL, NULL, NULL),
(40597, '2017-07-31 15:13:09', NULL, NULL, 11633, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 15:13:09', 'admin-1501484253-1501485188880577', 1, 1, 'SR', NULL, NULL, NULL),
(40598, '2017-07-31 11:08:01', NULL, NULL, 11617, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1501492896', 'admin', '2017-07-31 11:08:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40599, '2017-07-31 11:08:06', NULL, NULL, 11617, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 11:08:06', 'admin-1501464189-15014704861746339', 1, 0, '', NULL, NULL, NULL),
(40600, '2017-07-31 11:08:19', NULL, NULL, 11617, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 11:08:19', 'admin-1501464189-1501470498836177', 1, 1, 'SR', NULL, NULL, NULL),
(40601, '2017-07-31 11:08:19', NULL, NULL, 11617, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 11:08:19', 'admin-1501464189-1501470498836177', 1, 1, 'SR', NULL, NULL, NULL),
(40602, '2017-07-31 11:12:51', NULL, NULL, 11618, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 11:12:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40603, '2017-07-31 14:21:16', NULL, NULL, 11627, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:21:16', 'admin-1501472156-15014820762172773', 1, 0, '', NULL, NULL, NULL),
(40604, '2017-07-31 14:17:00', NULL, NULL, 11626, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:17:00', 'admin-1501472156-15014818205602340', 1, 1, 'SR', NULL, NULL, NULL),
(40605, '2017-07-31 14:48:54', NULL, NULL, 11631, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:48:54', 'admin-1501482174-15014837339991423', 1, 1, 'SR', NULL, NULL, NULL),
(40606, '2017-07-31 14:48:54', NULL, NULL, 11631, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:48:54', 'admin-1501482174-15014837339991423', 1, 0, '', NULL, NULL, NULL),
(40607, '2017-07-31 14:21:11', NULL, NULL, 11627, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:21:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40608, '2017-07-31 14:00:59', NULL, NULL, 11626, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 14:00:59', 'admin-1501472156-15014808587358463', 1, 1, 'SR', NULL, NULL, NULL),
(40609, '2017-07-31 13:09:16', NULL, NULL, 11622, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 13:09:16', 'admin-1501472156-15014777561917012', 1, 0, '', NULL, NULL, NULL),
(40610, '2017-07-31 13:09:16', NULL, NULL, 11622, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 13:09:16', 'admin-1501472156-15014777561917012', 1, 1, 'SR', NULL, NULL, NULL),
(40611, '2017-07-31 13:09:16', NULL, NULL, 11622, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 13:09:16', 'admin-1501472156-15014777561917012', 1, 1, 'SR', NULL, NULL, NULL),
(40612, '2017-07-31 13:09:16', NULL, NULL, 11622, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 13:09:16', 'admin-1501472156-15014777561917012', 1, 1, 'SR', NULL, NULL, NULL),
(40613, '2017-07-31 13:08:53', NULL, NULL, 11622, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 13:08:53', 'admin-1501472156-15014777332829660', 1, 0, '', NULL, NULL, NULL),
(40614, '2017-07-31 13:08:53', NULL, NULL, 11622, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 13:08:53', 'admin-1501472156-15014777332829660', 1, 1, 'SR', NULL, NULL, NULL),
(40615, '2017-07-31 13:08:32', NULL, NULL, 11622, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.80, 0.0000, 0.0000, 9.80, 1, '27', 1, '1501492896', 'admin', '2017-07-31 13:08:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40616, '2017-07-31 11:33:10', NULL, NULL, 11615, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 11:33:10', 'admin-1501464189-1501471989920453', 1, 0, '', NULL, NULL, NULL),
(40617, '2017-07-31 10:23:32', NULL, NULL, 11616, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1501492896', 'admin', '2017-07-31 10:23:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40618, '2017-07-31 10:23:37', NULL, NULL, 11616, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 10:23:37', 'admin-1501464189-15014678176238492', 1, 1, 'SR', NULL, NULL, NULL),
(40619, '2017-07-31 10:01:31', NULL, NULL, 11615, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 10:01:31', 'admin-1501464189-15014664913084475', 1, 0, '', NULL, NULL, NULL),
(40620, '2017-07-31 10:01:31', NULL, NULL, 11615, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 10:01:31', 'admin-1501464189-15014664913084475', 1, 1, 'SR', NULL, NULL, NULL),
(40621, '2017-07-31 11:43:18', NULL, NULL, 11619, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1501492896', 'admin', '2017-07-31 11:43:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40622, '2017-07-31 10:00:27', NULL, NULL, 11615, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 10:00:27', 'admin-1501464189-15014664277293972', 1, 0, '', NULL, NULL, NULL),
(40623, '2017-07-31 10:00:27', NULL, NULL, 11615, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 10:00:27', 'admin-1501464189-15014664277293972', 1, 0, '', NULL, NULL, NULL),
(40624, '2017-07-31 10:00:27', NULL, NULL, 11615, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 10:00:27', 'admin-1501464189-15014664277293972', 1, 0, '', NULL, NULL, NULL),
(40625, '2017-07-31 10:00:27', NULL, NULL, 11615, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 10:00:27', 'admin-1501464189-15014664277293972', 1, 0, '', NULL, NULL, NULL),
(40626, '2017-07-31 10:00:27', NULL, NULL, 11615, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 10:00:27', 'admin-1501464189-15014664277293972', 1, 0, '', NULL, NULL, NULL),
(40627, '2017-07-31 10:00:27', NULL, NULL, 11615, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 10:00:27', 'admin-1501464189-15014664277293972', 1, 0, '', NULL, NULL, NULL),
(40628, '2017-07-31 10:00:27', NULL, NULL, 11615, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 10:00:27', 'admin-1501464189-15014664277293972', 1, 0, '', NULL, NULL, NULL),
(40629, '2017-07-31 10:00:27', NULL, NULL, 11615, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 10:00:27', 'admin-1501464189-15014664277293972', 1, 0, '', NULL, NULL, NULL),
(40630, '2017-07-31 10:00:27', NULL, NULL, 11615, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 10:00:27', 'admin-1501464189-15014664277293972', 1, 0, '', NULL, NULL, NULL),
(40631, '2017-07-31 10:00:01', NULL, NULL, 11615, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 18.80, 0.0000, 0.0000, 18.80, 1, '27', 1, '1501492896', 'admin', '2017-07-31 10:00:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40632, '2017-07-31 09:59:19', NULL, NULL, 11614, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 09:59:19', 'admin-1501464189-15014663594255326', 1, 1, 'SR', NULL, NULL, NULL),
(40633, '2017-07-31 09:59:19', NULL, NULL, 11614, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 09:59:19', 'admin-1501464189-15014663594255326', 1, 1, 'SR', NULL, NULL, NULL),
(40634, '2017-07-31 10:20:06', NULL, NULL, 11613, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 10:20:06', 'admin-1501464189-15014676058533523', 1, 1, 'SR', NULL, NULL, NULL),
(40635, '2017-07-31 09:50:55', NULL, NULL, 11612, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 09:50:55', 'admin-1501464189-15014658553911875', 1, 1, 'SR', NULL, NULL, '10.0'),
(40636, '2017-07-31 09:50:52', NULL, NULL, 11612, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1501492896', 'admin', '2017-07-31 09:50:52', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(40637, '2017-07-31 09:59:00', NULL, NULL, 11614, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 09:59:00', 'admin-1501464189-1501466340033660', 1, 0, '', NULL, NULL, NULL),
(40638, '2017-07-31 09:59:00', NULL, NULL, 11614, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 09:59:00', 'admin-1501464189-1501466340033660', 1, 0, '', NULL, NULL, NULL),
(40639, '2017-07-31 09:58:56', NULL, NULL, 11614, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1501492896', 'admin', '2017-07-31 09:58:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40640, '2017-07-31 09:58:14', NULL, NULL, 11613, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 09:58:14', 'admin-1501464189-1501466294090964', 1, 0, '', NULL, NULL, NULL),
(40641, '2017-07-31 09:58:11', NULL, NULL, 11613, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1501492896', 'admin', '2017-07-31 09:58:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40642, '2017-07-31 09:45:13', NULL, NULL, 11611, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 09:45:13', 'admin-1501464189-1501465513453382', 1, 0, '', NULL, NULL, NULL),
(40643, '2017-07-31 09:39:27', NULL, NULL, 11611, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 09:39:27', 'admin-1501464189-15014651675885453', 1, 0, '', NULL, NULL, NULL),
(40644, '2017-07-31 09:39:19', NULL, NULL, 11611, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1501492896', 'admin', '2017-07-31 09:39:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40645, '2017-07-31 09:39:27', NULL, NULL, 11611, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501492896', 'admin', '2017-07-31 09:39:27', 'admin-1501464189-15014651675885453', 1, 1, 'SR', NULL, NULL, NULL),
(40646, '2017-08-02 16:12:10', NULL, NULL, 11664, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:12:10', 'admin-1501656207-15016615301874477', 1, 0, '', NULL, NULL, NULL),
(40647, '2017-08-02 16:12:10', NULL, NULL, 11664, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:12:10', 'admin-1501656207-15016615301874477', 1, 0, '', NULL, NULL, NULL),
(40648, '2017-08-02 16:01:22', NULL, NULL, 11662, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:01:22', 'admin-1501656207-15016608824304213', 1, 1, 'SR', NULL, NULL, NULL),
(40649, '2017-08-02 16:11:57', NULL, NULL, 11664, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:11:57', 'admin-1501656207-15016615171775415', 1, 0, '', NULL, NULL, NULL),
(40650, '2017-08-02 16:01:22', NULL, NULL, 11662, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:01:22', 'admin-1501656207-15016608824304213', 1, 0, '', NULL, NULL, NULL),
(40651, '2017-08-02 15:58:20', NULL, NULL, 11665, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 3.50, 3.5000, 0.0000, 3.50, 1, '27', 1, '1501656207', 'admin', '2017-08-02 15:58:20', 'admin-1501656207-15016607000576747', 1, 0, '', NULL, NULL, NULL),
(40652, '2017-08-02 15:58:20', NULL, NULL, 11665, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 3.50, 3.5000, 0.0000, 3.50, 1, '27', 1, '1501656207', 'admin', '2017-08-02 15:58:20', 'admin-1501656207-15016607000576747', 1, 0, '', NULL, NULL, NULL),
(40653, '2017-08-02 16:01:22', NULL, NULL, 11662, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:01:22', 'admin-1501656207-15016608824304213', 1, 1, 'SR', NULL, NULL, NULL),
(40654, '2017-08-02 16:01:22', NULL, NULL, 11662, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:01:22', 'admin-1501656207-15016608824304213', 1, 1, 'SR', NULL, NULL, NULL),
(40655, '2017-08-02 15:57:00', NULL, NULL, 11665, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 15:57:00', 'admin-1501656207-15016606203867840', 1, 0, '', NULL, NULL, NULL),
(40656, '2017-08-02 15:57:00', NULL, NULL, 11665, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 15:57:00', 'admin-1501656207-15016606203867840', 1, 0, '', NULL, NULL, NULL),
(40657, '2017-08-02 15:57:00', NULL, NULL, 11665, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 15:57:00', 'admin-1501656207-15016606203867840', 1, 0, '', NULL, NULL, NULL),
(40658, '2017-08-02 15:31:42', NULL, NULL, 11663, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 15:31:42', 'admin-1501656207-15016591022718662', 1, 1, 'SR', NULL, NULL, NULL),
(40659, '2017-08-02 15:29:00', NULL, NULL, 11662, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 15:29:00', 'admin-1501656207-15016589400613820', 1, 1, 'SR', NULL, NULL, NULL),
(40660, '2017-08-02 15:29:00', NULL, NULL, 11662, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 15:29:00', 'admin-1501656207-15016589400613820', 1, 1, 'SR', NULL, NULL, NULL),
(40661, '2017-08-02 15:28:38', NULL, NULL, 11665, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1501656207', 'admin', '2017-08-02 15:28:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40662, '2017-08-02 15:28:50', NULL, NULL, 11665, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 2, 15.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 15:28:50', 'admin-1501656207-15016589304581476', 1, 1, 'SR', NULL, NULL, NULL),
(40663, '2017-08-02 15:15:21', NULL, NULL, 11664, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 15:15:21', 'admin-1501656207-15016581214589458', 1, 1, 'SR', NULL, NULL, NULL),
(40664, '2017-08-02 15:15:21', NULL, NULL, 11664, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 15:15:21', 'admin-1501656207-15016581214589458', 1, 1, 'SR', NULL, NULL, NULL),
(40665, '2017-08-02 15:15:21', NULL, NULL, 11664, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 15:15:21', 'admin-1501656207-15016581214589458', 1, 0, '', NULL, NULL, NULL),
(40666, '2017-08-02 12:36:21', NULL, NULL, 11651, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:36:21', 'admin-1501642747-15016485814465231', 1, 1, 'SR', NULL, NULL, NULL),
(40667, '2017-08-02 13:57:36', NULL, NULL, 11659, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1501656207', 'admin', '2017-08-02 13:57:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40668, '2017-08-02 17:54:44', NULL, NULL, 11669, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 17:54:44', 'admin-1501656207-1501667684222769', 1, 0, '', NULL, NULL, NULL),
(40669, '2017-08-02 15:15:05', NULL, NULL, 11664, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.70, 0.0000, 0.0000, 11.70, 1, '27', 1, '1501656207', 'admin', '2017-08-02 15:15:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40670, '2017-08-02 15:15:21', NULL, NULL, 11664, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 15:15:21', 'admin-1501656207-15016581214589458', 1, 1, 'SR', NULL, NULL, NULL),
(40671, '2017-08-02 15:00:39', NULL, NULL, 11663, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 15:00:39', 'admin-1501656207-15016572395146984', 1, 1, 'SR', NULL, NULL, NULL),
(40672, '2017-08-02 15:00:34', NULL, NULL, 11663, 0, 272, '206', 'Genius in The Bowl', 'More spring oinion', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 15:00:34', 'admin-1501656207-15016572345516779', 1, 0, '', NULL, NULL, NULL),
(40673, '2017-08-02 14:59:43', NULL, NULL, 11655, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 14:59:43', 'admin-1501656207-15016571831789580', 1, 1, 'SR', 1, NULL, NULL),
(40674, '2017-08-02 14:45:36', NULL, NULL, 11662, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 14:45:36', 'admin-1501656207-1501656336755209', 1, 1, 'SR', NULL, NULL, NULL),
(40675, '2017-08-02 14:44:04', NULL, NULL, 11661, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 14:44:04', 'admin-1501656207-15016562441151336', 1, 1, 'SR', NULL, NULL, NULL),
(40676, '2017-08-02 17:54:44', NULL, NULL, 11669, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 17:54:44', 'admin-1501656207-1501667684222769', 1, 1, 'SR', NULL, NULL, NULL),
(40677, '2017-08-02 16:12:10', NULL, NULL, 11664, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:12:10', 'admin-1501656207-15016615301874477', 1, 0, '', NULL, NULL, NULL),
(40678, '2017-08-02 16:12:10', NULL, NULL, 11664, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:12:10', 'admin-1501656207-15016615301874477', 1, 0, '', NULL, NULL, NULL),
(40679, '2017-08-02 13:11:48', NULL, NULL, 11657, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1501656207', 'admin', '2017-08-02 13:11:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40680, '2017-08-02 13:12:24', NULL, NULL, 11657, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 13:12:24', 'admin-1501650691-15016507441724656', 1, 0, '', NULL, NULL, NULL),
(40681, '2017-08-02 13:12:24', NULL, NULL, 11657, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 13:12:24', 'admin-1501650691-15016507441724656', 1, 0, '', NULL, NULL, NULL),
(40682, '2017-08-02 13:12:24', NULL, NULL, 11657, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 13:12:24', 'admin-1501650691-15016507441724656', 1, 1, 'SR', NULL, NULL, NULL),
(40683, '2017-08-02 13:12:34', NULL, NULL, 11657, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 13:12:34', 'admin-1501650691-1501650754631850', 1, 0, '', NULL, NULL, NULL),
(40684, '2017-08-02 13:12:34', NULL, NULL, 11657, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 13:12:34', 'admin-1501650691-1501650754631850', 1, 1, 'SR', NULL, NULL, NULL),
(40685, '2017-08-02 12:02:30', NULL, NULL, 11649, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:02:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40686, '2017-08-02 12:02:41', NULL, NULL, 11649, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:02:41', 'admin-1501642747-15016465611875898', 1, 0, '', NULL, NULL, NULL),
(40687, '2017-08-02 14:45:36', NULL, NULL, 11662, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 14:45:36', 'admin-1501656207-1501656336755209', 1, 0, '', NULL, NULL, NULL),
(40688, '2017-08-02 16:28:16', NULL, NULL, 11666, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:28:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40689, '2017-08-02 14:45:32', NULL, NULL, 11662, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1501656207', 'admin', '2017-08-02 14:45:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40690, '2017-08-02 12:47:49', NULL, NULL, 11649, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:47:49', 'admin-1501642747-1501649269400861', 1, 1, 'SR', NULL, NULL, NULL),
(40691, '2017-08-02 12:47:49', NULL, NULL, 11649, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:47:49', 'admin-1501642747-1501649269400861', 1, 1, 'SR', NULL, NULL, NULL),
(40692, '2017-08-02 12:53:26', NULL, NULL, 11653, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:53:26', 'admin-1501642747-15016496062569186', 1, 0, '', 1, NULL, '10.0'),
(40693, '2017-08-02 12:55:14', NULL, NULL, 11654, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:55:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40694, '2017-08-02 12:55:19', NULL, NULL, 11654, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:55:19', 'admin-1501642747-15016497195512593', 1, 1, 'SR', NULL, NULL, NULL),
(40695, '2017-08-02 16:12:10', NULL, NULL, 11664, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:12:10', 'admin-1501656207-15016615301874477', 1, 0, '', NULL, NULL, NULL),
(40696, '2017-08-02 16:12:10', NULL, NULL, 11664, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:12:10', 'admin-1501656207-15016615301874477', 1, 0, '', NULL, NULL, NULL),
(40697, '2017-08-02 16:12:10', NULL, NULL, 11664, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:12:10', 'admin-1501656207-15016615301874477', 1, 0, '', NULL, NULL, NULL),
(40698, '2017-08-02 16:12:10', NULL, NULL, 11664, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:12:10', 'admin-1501656207-15016615301874477', 1, 0, '', NULL, NULL, NULL),
(40699, '2017-08-02 12:21:09', NULL, NULL, 11651, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:21:09', 'admin-1501642747-1501647668834312', 1, 1, 'SR', NULL, NULL, NULL),
(40700, '2017-08-02 12:08:09', NULL, NULL, 11650, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:08:09', 'admin-1501642747-15016468895341769', 1, 1, 'SR', NULL, NULL, NULL),
(40701, '2017-08-02 12:14:36', NULL, NULL, 11651, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:14:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40702, '2017-08-02 12:18:29', NULL, NULL, 11651, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:18:29', 'admin-1501642747-1501647509794655', 1, 0, '', NULL, NULL, NULL),
(40703, '2017-08-02 12:18:29', NULL, NULL, 11651, 0, 181, '116', 'Open Food ', 'Garlic Fried Rice', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:18:29', 'admin-1501642747-1501647509794655', 1, 0, '', NULL, NULL, NULL),
(40704, '2017-08-02 12:18:29', NULL, NULL, 11651, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:18:29', 'admin-1501642747-1501647509794655', 1, 0, '', NULL, NULL, NULL),
(40705, '2017-08-02 12:18:29', NULL, NULL, 11651, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:18:29', 'admin-1501642747-1501647509794655', 1, 0, '', NULL, NULL, NULL),
(40706, '2017-08-02 13:57:46', NULL, NULL, 11659, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 13:57:46', 'admin-1501653271-1501653465957980', 1, 1, 'SR', NULL, NULL, NULL),
(40707, '2017-08-02 13:57:46', NULL, NULL, 11659, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 13:57:46', 'admin-1501653271-1501653465957980', 1, 1, 'SR', NULL, NULL, NULL),
(40708, '2017-08-02 14:06:00', NULL, NULL, 11660, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1501656207', 'admin', '2017-08-02 14:06:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40709, '2017-08-02 16:45:48', NULL, NULL, 11668, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:45:48', 'admin-1501656207-1501663547974693', 1, 1, 'SR', 1, NULL, NULL),
(40710, '2017-08-02 17:54:37', NULL, NULL, 11669, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1501656207', 'admin', '2017-08-02 17:54:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40711, '2017-08-02 16:45:48', NULL, NULL, 11668, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:45:48', 'admin-1501656207-1501663547974693', 1, 0, '', 1, NULL, NULL),
(40712, '2017-08-02 16:45:48', NULL, NULL, 11668, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:45:48', 'admin-1501656207-1501663547974693', 1, 0, '', 1, NULL, NULL),
(40713, '2017-08-02 16:45:48', NULL, NULL, 11668, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:45:48', 'admin-1501656207-1501663547974693', 1, 1, 'SR', 1, NULL, NULL),
(40714, '2017-08-02 16:37:08', NULL, NULL, 11667, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:37:08', 'admin-1501656207-15016630278851253', 1, 1, 'SR', NULL, NULL, NULL),
(40715, '2017-08-02 16:37:03', NULL, NULL, 11667, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:37:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40716, '2017-08-02 14:06:04', NULL, NULL, 11660, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 14:06:04', 'admin-1501653271-1501653964573295', 1, 0, '', NULL, NULL, NULL),
(40717, '2017-08-02 00:00:00', NULL, NULL, 11666, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 14:44:04', 'admin-1501656207-15016562441151336', 1, 1, 'SR', NULL, NULL, NULL),
(40718, '2017-08-02 10:58:58', NULL, NULL, 11647, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1501656207', 'admin', '2017-08-02 10:58:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40719, '2017-08-02 10:59:02', NULL, NULL, 11647, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 10:59:02', 'admin-1501635703-15016427422905349', 1, 0, '', NULL, NULL, NULL),
(40720, '2017-08-02 10:59:20', NULL, NULL, 11647, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 10:59:20', 'admin-1501642747-15016427603027582', 1, 0, '', NULL, NULL, NULL),
(40721, '2017-08-02 09:51:20', NULL, NULL, 11643, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 09:51:20', 'admin-1501635703-1501638680750922', 1, 0, '', NULL, NULL, NULL),
(40722, '2017-08-02 09:51:20', NULL, NULL, 11643, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 09:51:20', 'admin-1501635703-1501638680750922', 1, 1, 'SR', NULL, NULL, NULL),
(40723, '2017-08-02 09:51:20', NULL, NULL, 11643, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 09:51:20', 'admin-1501635703-1501638680750922', 1, 1, 'SR', NULL, NULL, NULL),
(40724, '2017-08-02 10:25:16', NULL, NULL, 11644, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1501656207', 'admin', '2017-08-02 10:25:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40725, '2017-08-02 10:26:43', NULL, NULL, 11644, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 10:26:43', 'admin-1501635703-15016408038014482', 1, 0, '', NULL, NULL, NULL),
(40726, '2017-08-02 16:12:10', NULL, NULL, 11664, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:12:10', 'admin-1501656207-15016615301874477', 1, 0, '', NULL, NULL, NULL),
(40727, '2017-08-02 12:55:32', NULL, NULL, 11654, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:55:32', 'admin-1501642747-15016497323127955', 1, 1, 'SR', NULL, NULL, NULL),
(40728, '2017-08-02 13:02:01', NULL, NULL, 11655, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 13:02:01', 'admin-1501642747-15016501214001144', 1, 0, '', 1, NULL, NULL),
(40729, '2017-08-02 13:39:06', NULL, NULL, 11658, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 13:39:06', 'admin-1501650691-15016523459881450', 1, 1, 'SR', NULL, NULL, NULL),
(40730, '2017-08-02 13:55:00', NULL, NULL, 11658, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 13:55:00', 'admin-1501653271-15016533004806828', 1, 1, 'SR', NULL, NULL, NULL),
(40731, '2017-08-02 13:55:00', NULL, NULL, 11658, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 13:55:00', 'admin-1501653271-15016533004806828', 1, 1, 'SR', NULL, NULL, NULL),
(40732, '2017-08-02 14:56:43', NULL, NULL, 11663, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1501656207', 'admin', '2017-08-02 14:56:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40733, '2017-08-02 13:36:30', NULL, NULL, 11651, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 13:36:30', 'admin-1501650691-15016521904137190', 1, 0, '', NULL, NULL, NULL),
(40734, '2017-08-02 13:11:44', NULL, NULL, 11656, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 13:11:44', 'admin-1501650691-15016507041117440', 1, 1, 'SR', NULL, NULL, NULL),
(40735, '2017-08-02 13:39:02', NULL, NULL, 11658, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1501656207', 'admin', '2017-08-02 13:39:02', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(40736, '2017-08-02 13:11:44', NULL, NULL, 11656, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 13:11:44', 'admin-1501650691-15016507041117440', 1, 1, 'SR', NULL, NULL, NULL),
(40737, '2017-08-02 13:11:25', NULL, NULL, 11656, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 13:11:25', 'admin-1501642747-1501650685392786', 1, 0, '', NULL, NULL, NULL),
(40738, '2017-08-02 13:11:25', NULL, NULL, 11656, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 13:11:25', 'admin-1501642747-1501650685392786', 1, 0, '', NULL, NULL, NULL),
(40739, '2017-08-02 15:00:34', NULL, NULL, 11663, 0, 272, '206', 'Genius in The Bowl', 'More spring oinion', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 15:00:34', 'admin-1501656207-15016572345516779', 1, 0, '', NULL, NULL, NULL),
(40740, '2017-08-02 13:10:33', NULL, NULL, 11656, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1501656207', 'admin', '2017-08-02 13:10:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40741, '2017-08-02 09:48:08', NULL, NULL, 11641, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 09:48:08', 'admin-1501635703-15016384887738258', 1, 0, '', 1, NULL, NULL),
(40742, '2017-08-02 09:48:09', NULL, NULL, 11641, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 09:48:09', 'admin-1501635703-15016384887738258', 1, 0, '', 1, NULL, NULL),
(40743, '2017-08-02 09:48:16', NULL, NULL, 11642, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 09:48:16', 'admin-1501635703-15016384960994812', 1, 1, 'SR', 1, NULL, NULL),
(40744, '2017-08-02 09:51:10', NULL, NULL, 11643, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1501656207', 'admin', '2017-08-02 09:51:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40745, '2017-08-02 14:59:43', NULL, NULL, 11655, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 14:59:43', 'admin-1501656207-15016571831789580', 1, 1, 'SR', 1, NULL, NULL),
(40746, '2017-08-02 14:06:10', NULL, NULL, 11660, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 14:06:10', 'admin-1501653271-1501653970091162', 1, 0, '', NULL, NULL, NULL),
(40747, '2017-08-02 12:36:21', NULL, NULL, 11651, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:36:21', 'admin-1501642747-15016485814465231', 1, 1, 'SR', NULL, NULL, NULL),
(40748, '2017-08-02 12:23:52', NULL, NULL, 11652, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:23:52', 'admin-1501642747-15016478326864296', 1, 0, '', NULL, NULL, NULL),
(40749, '2017-08-02 12:23:52', NULL, NULL, 11652, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:23:52', 'admin-1501642747-15016478326864296', 1, 1, 'SR', NULL, NULL, NULL),
(40750, '2017-08-02 12:21:09', NULL, NULL, 11651, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:21:09', 'admin-1501642747-1501647668834312', 1, 1, 'SR', NULL, NULL, NULL),
(40751, '2017-08-02 12:23:42', NULL, NULL, 11652, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:23:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40752, '2017-08-02 16:12:10', NULL, NULL, 11664, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:12:10', 'admin-1501656207-15016615301874477', 1, 0, '', NULL, NULL, NULL),
(40753, '2017-08-02 14:43:45', NULL, NULL, 11661, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1501656207', 'admin', '2017-08-02 14:43:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40754, '2017-08-02 12:18:30', NULL, NULL, 11651, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:18:30', 'admin-1501642747-1501647509794655', 1, 0, '', NULL, NULL, NULL),
(40755, '2017-08-02 12:07:53', NULL, NULL, 11650, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:07:53', 'admin-1501642747-1501646872983114', 1, 0, '', NULL, NULL, NULL),
(40756, '2017-08-02 12:07:41', NULL, NULL, 11650, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:07:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40757, '2017-08-02 12:02:58', NULL, NULL, 11649, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:02:58', 'admin-1501642747-15016465784407261', 1, 0, '', NULL, NULL, NULL),
(40758, '2017-08-02 12:02:58', NULL, NULL, 11649, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:02:58', 'admin-1501642747-15016465784407261', 1, 1, 'SR', NULL, NULL, NULL),
(40759, '2017-08-02 12:02:58', NULL, NULL, 11649, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:02:58', 'admin-1501642747-15016465784407261', 1, 1, 'SR', NULL, NULL, NULL),
(40760, '2017-08-02 16:12:10', NULL, NULL, 11664, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 16:12:10', 'admin-1501656207-15016615301874477', 1, 0, '', NULL, NULL, NULL),
(40761, '2017-08-02 11:28:33', NULL, NULL, 11648, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 11:28:33', 'admin-1501642747-15016445130238933', 1, 0, '', NULL, NULL, NULL),
(40762, '2017-08-02 12:02:41', NULL, NULL, 11649, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 12:02:41', 'admin-1501642747-15016465611875898', 1, 0, '', NULL, NULL, NULL),
(40763, '2017-08-02 11:31:18', NULL, NULL, 11648, 0, 181, '116', 'Open Food ', 'add bacon', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 11:31:18', 'admin-1501642747-15016446780697799', 1, 0, '', NULL, NULL, NULL),
(40764, '2017-08-02 11:28:33', NULL, NULL, 11648, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 11:28:33', 'admin-1501642747-15016445130238933', 1, 1, 'SR', NULL, NULL, NULL),
(40765, '2017-08-02 11:28:33', NULL, NULL, 11648, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 11:28:33', 'admin-1501642747-15016445130238933', 1, 0, '', NULL, NULL, NULL),
(40766, '2017-08-02 11:24:02', NULL, NULL, 11648, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 11:24:02', 'admin-1501642747-15016442418985013', 1, 1, 'SR', NULL, NULL, NULL),
(40767, '2017-08-02 10:29:36', NULL, NULL, 11645, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1501656207', 'admin', '2017-08-02 10:29:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40768, '2017-08-02 11:23:53', NULL, NULL, 11648, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1501656207', 'admin', '2017-08-02 11:23:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40769, '2017-08-02 11:24:02', NULL, NULL, 11648, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 11:24:02', 'admin-1501642747-15016442418985013', 1, 1, 'SR', NULL, NULL, NULL),
(40770, '2017-08-02 10:59:20', NULL, NULL, 11647, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 10:59:20', 'admin-1501642747-15016427603027582', 1, 1, 'SR', NULL, NULL, NULL),
(40771, '2017-08-02 10:50:05', NULL, NULL, 11646, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 10:50:05', 'admin-1501635703-15016422048601083', 1, 1, 'SR', NULL, NULL, NULL),
(40772, '2017-08-02 10:50:05', NULL, NULL, 11646, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 10:50:05', 'admin-1501635703-15016422048601083', 1, 1, 'SR', NULL, NULL, NULL),
(40773, '2017-08-02 10:29:47', NULL, NULL, 11645, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 10:29:47', 'admin-1501635703-15016409871197986', 1, 0, '', NULL, NULL, NULL),
(40774, '2017-08-02 10:49:55', NULL, NULL, 11646, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1501656207', 'admin', '2017-08-02 10:49:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40775, '2017-08-02 10:29:47', NULL, NULL, 11645, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 10:29:47', 'admin-1501635703-15016409871197986', 1, 1, 'SR', NULL, NULL, NULL),
(40776, '2017-08-02 10:26:48', NULL, NULL, 11644, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 10:26:48', 'admin-1501635703-15016408079304658', 1, 1, 'SR', NULL, NULL, NULL),
(40777, '2017-08-02 09:09:41', NULL, NULL, 11640, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 09:09:41', 'admin-1501635703-15016361809361968', 1, 1, 'SR', NULL, NULL, NULL),
(40778, '2017-08-02 09:09:41', NULL, NULL, 11640, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 09:09:41', 'admin-1501635703-15016361809361968', 1, 1, 'SR', NULL, NULL, NULL),
(40779, '2017-08-02 09:09:33', NULL, NULL, 11640, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1501656207', 'admin', '2017-08-02 09:09:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40780, '2017-08-02 09:05:34', NULL, NULL, 11639, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 09:05:34', 'admin-1501635703-1501635934153225', 1, 1, 'SR', NULL, NULL, NULL),
(40781, '2017-08-02 09:05:34', NULL, NULL, 11639, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 09:05:34', 'admin-1501635703-1501635934153225', 1, 1, 'SR', NULL, NULL, NULL),
(40782, '2017-08-02 09:48:08', NULL, NULL, 11641, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 09:48:08', 'admin-1501635703-15016384887738258', 1, 0, '', 1, NULL, NULL),
(40783, '2017-08-02 09:05:16', NULL, NULL, 11639, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 09:05:16', 'admin-1501635703-15016359161843853', 1, 0, '', NULL, NULL, NULL),
(40784, '2017-08-02 09:09:41', NULL, NULL, 11640, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 09:09:41', 'admin-1501635703-15016361809361968', 1, 0, '', NULL, NULL, NULL),
(40785, '2017-08-02 09:05:34', NULL, NULL, 11639, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 09:05:34', 'admin-1501635703-1501635934153225', 1, 1, 'SR', NULL, NULL, NULL),
(40786, '2017-08-02 09:05:34', NULL, NULL, 11639, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 09:05:34', 'admin-1501635703-1501635934153225', 1, 1, 'SR', NULL, NULL, NULL),
(40787, '2017-08-02 09:05:16', NULL, NULL, 11639, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 09:05:16', 'admin-1501635703-15016359161843853', 1, 0, '', NULL, NULL, NULL),
(40788, '2017-08-02 09:05:06', NULL, NULL, 11639, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.20, 0.0000, 0.0000, 11.20, 1, '27', 1, '1501656207', 'admin', '2017-08-02 09:05:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40789, '2017-08-02 09:05:16', NULL, NULL, 11639, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 09:05:16', 'admin-1501635703-15016359161843853', 1, 0, '', NULL, NULL, NULL),
(40790, '2017-08-02 09:05:16', NULL, NULL, 11639, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501656207', 'admin', '2017-08-02 09:05:16', 'admin-1501635703-15016359161843853', 1, 0, '', NULL, NULL, NULL),
(40791, '2017-08-03 13:31:28', NULL, NULL, 11681, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 13:31:28', 'admin-1501729293-15017382879694286', 1, 1, 'SR', NULL, NULL, NULL),
(40792, '2017-08-03 13:12:38', NULL, NULL, 11679, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 13:12:38', 'admin-1501729293-15017371577881320', 1, 1, 'SR', NULL, NULL, NULL),
(40793, '2017-08-03 17:34:02', NULL, NULL, 11684, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 17:34:02', 'admin-1501739307-15017528424403170', 1, 1, 'SR', NULL, NULL, NULL),
(40794, '2017-08-03 17:59:55', NULL, NULL, 11686, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1501739307', 'admin', '2017-08-03 17:59:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40795, '2017-08-03 17:59:59', NULL, NULL, 11686, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 17:59:59', 'admin-1501739307-15017543992207391', 1, 1, 'SR', NULL, NULL, NULL),
(40796, '2017-08-03 13:34:15', NULL, NULL, 11677, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 13:34:15', 'admin-1501729293-15017384554506823', 1, 1, 'SR', NULL, NULL, '10.0'),
(40797, '2017-08-03 13:48:42', NULL, NULL, 11678, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 13:48:42', 'admin-1501739307-15017393220589740', 1, 1, 'SR', NULL, NULL, '10.0'),
(40798, '2017-08-03 13:48:42', NULL, NULL, 11678, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 13:48:42', 'admin-1501739307-15017393220589740', 1, 1, 'SR', NULL, NULL, '10.0'),
(40799, '2017-08-03 12:05:41', NULL, NULL, 11677, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1501739307', 'admin', '2017-08-03 12:05:41', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(40800, '2017-08-03 12:05:48', NULL, NULL, 11677, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 12:05:48', 'admin-1501729293-15017331482319533', 1, 1, 'SR', NULL, NULL, '10.0'),
(40801, '2017-08-03 12:17:04', NULL, NULL, 11678, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.75, 0.0000, 0.0000, 4.75, 1, '27', 1, '1501739307', 'admin', '2017-08-03 12:17:04', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(40802, '2017-08-03 12:17:11', NULL, NULL, 11678, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 12:17:11', 'admin-1501729293-15017338310004645', 1, 0, '', NULL, NULL, '10.0'),
(40803, '2017-08-03 12:17:11', NULL, NULL, 11678, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 12:17:11', 'admin-1501729293-15017338310004645', 1, 1, 'SR', NULL, NULL, '10.0'),
(40804, '2017-08-03 12:22:58', NULL, NULL, 11679, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1501739307', 'admin', '2017-08-03 12:22:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40805, '2017-08-03 12:23:22', NULL, NULL, 11679, 0, 153, '87', 'Wake Me Up!', 'no beans', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 12:23:22', 'admin-1501729293-15017342021372721', 1, 0, '', NULL, NULL, NULL),
(40806, '2017-08-03 11:01:11', NULL, NULL, 11674, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 11:01:11', 'admin-1501721568-15017292717475862', 1, 0, '', NULL, NULL, '10.0'),
(40807, '2017-08-03 11:01:11', NULL, NULL, 11674, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 11:01:11', 'admin-1501721568-15017292717475862', 1, 0, '', NULL, NULL, '10.0'),
(40808, '2017-08-03 14:21:02', NULL, NULL, 11677, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 14:21:02', 'admin-1501739307-15017412623439640', 1, 1, 'SR', NULL, NULL, '10.0'),
(40809, '2017-08-03 09:12:06', NULL, NULL, 11670, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 09:12:06', 'admin-1501721568-15017227260257271', 1, 1, 'SR', NULL, NULL, NULL),
(40810, '2017-08-03 09:43:00', NULL, NULL, 11671, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1501739307', 'admin', '2017-08-03 09:43:00', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(40811, '2017-08-03 09:44:40', NULL, NULL, 11671, 0, 154, '88', 'Daily Dose BLT', 'No bread', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 09:44:40', 'admin-1501721568-15017246803821712', 1, 0, '', NULL, NULL, '10.0'),
(40812, '2017-08-03 09:44:40', NULL, NULL, 11671, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 09:44:40', 'admin-1501721568-15017246803821712', 1, 0, '', NULL, NULL, '10.0'),
(40813, '2017-08-03 09:44:40', NULL, NULL, 11671, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 09:44:40', 'admin-1501721568-15017246803821712', 1, 1, 'SR', NULL, NULL, '10.0'),
(40814, '2017-08-03 14:46:24', NULL, NULL, 11682, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 14:46:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40815, '2017-08-03 14:46:33', NULL, NULL, 11682, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 14:46:33', 'admin-1501739307-15017427931171321', 1, 1, 'SR', NULL, NULL, NULL),
(40816, '2017-08-03 14:46:43', NULL, NULL, 11676, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 14:46:43', 'admin-1501739307-15017428032719874', 1, 0, '', NULL, NULL, '10.0'),
(40817, '2017-08-03 17:20:07', NULL, NULL, 11683, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1501739307', 'admin', '2017-08-03 17:20:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40818, '2017-08-03 17:20:09', NULL, NULL, 11683, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 17:20:09', 'admin-1501739307-15017520096264956', 1, 1, 'SR', NULL, NULL, NULL),
(40819, '2017-08-03 17:33:53', NULL, NULL, 11684, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1501739307', 'admin', '2017-08-03 17:33:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40820, '2017-08-03 17:34:02', NULL, NULL, 11684, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 17:34:02', 'admin-1501739307-15017528424403170', 1, 1, 'SR', NULL, NULL, NULL),
(40821, '2017-08-03 17:34:02', NULL, NULL, 11684, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 17:34:02', 'admin-1501739307-15017528424403170', 1, 0, '', NULL, NULL, NULL),
(40822, '2017-08-03 13:50:09', NULL, NULL, 11677, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 13:50:09', 'admin-1501739307-1501739408789171', 1, 1, 'SR', NULL, NULL, '10.0'),
(40823, '2017-08-03 13:34:15', NULL, NULL, 11677, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 13:34:15', 'admin-1501729293-15017384554506823', 1, 1, 'SR', NULL, NULL, '10.0'),
(40824, '2017-08-03 13:31:28', NULL, NULL, 11681, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 13:31:28', 'admin-1501729293-15017382879694286', 1, 1, 'SR', NULL, NULL, NULL),
(40825, '2017-08-03 12:57:43', NULL, NULL, 11680, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1501739307', 'admin', '2017-08-03 12:57:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40826, '2017-08-03 12:57:46', NULL, NULL, 11680, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 12:57:46', 'admin-1501729293-1501736266044735', 1, 1, 'SR', NULL, NULL, NULL),
(40827, '2017-08-03 13:31:28', NULL, NULL, 11681, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 13:31:28', 'admin-1501729293-15017382879694286', 1, 1, 'SR', NULL, NULL, NULL),
(40828, '2017-08-03 13:31:24', NULL, NULL, 11681, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 13:31:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40829, '2017-08-03 12:23:40', NULL, NULL, 11678, 0, 181, '116', 'Open Food ', 'fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1501739307', 'admin', '2017-08-03 12:23:40', 'admin-1501729293-15017342202578117', 1, 0, '', NULL, NULL, '10.0'),
(40830, '2017-08-03 12:02:37', NULL, NULL, 11676, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 12:02:37', 'admin-1501729293-15017329576956618', 1, 0, '', NULL, NULL, '10.0'),
(40831, '2017-08-03 12:02:28', NULL, NULL, 11676, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1501739307', 'admin', '2017-08-03 12:02:28', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(40832, '2017-08-03 11:25:06', NULL, NULL, 11675, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1501739307', 'admin', '2017-08-03 11:25:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40833, '2017-08-03 11:26:06', NULL, NULL, 11675, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 11:26:06', 'admin-1501729293-15017307665046387', 1, 0, '', NULL, NULL, NULL),
(40834, '2017-08-03 11:01:11', NULL, NULL, 11674, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 11:01:11', 'admin-1501721568-15017292717475862', 1, 1, 'SR', NULL, NULL, '10.0'),
(40835, '2017-08-03 11:01:26', NULL, NULL, 11674, 0, 181, '116', 'Open Food ', ' add potato,Wake me up no sald', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 11:01:26', 'admin-1501721568-15017292861994122', 1, 0, '', NULL, NULL, '10.0'),
(40836, '2017-08-03 11:01:11', NULL, NULL, 11674, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 11:01:11', 'admin-1501721568-15017292717475862', 1, 1, 'SR', NULL, NULL, '10.0'),
(40837, '2017-08-03 11:01:11', NULL, NULL, 11674, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 11:01:11', 'admin-1501721568-15017292717475862', 1, 0, '', NULL, NULL, '10.0'),
(40838, '2017-08-03 10:54:24', NULL, NULL, 11673, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 10:54:24', 'admin-1501721568-15017288648213984', 1, 0, '', NULL, NULL, NULL),
(40839, '2017-08-03 10:54:24', NULL, NULL, 11673, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 10:54:24', 'admin-1501721568-15017288648213984', 1, 1, 'SR', NULL, NULL, NULL),
(40840, '2017-08-03 10:52:58', NULL, NULL, 11672, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 10:52:58', 'admin-1501721568-15017287780885151', 1, 1, 'SR', NULL, NULL, NULL),
(40841, '2017-08-03 10:54:19', NULL, NULL, 11673, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 10:54:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40842, '2017-08-03 10:52:50', NULL, NULL, 11672, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 10:52:50', 'admin-1501721568-15017287704251754', 1, 0, '', NULL, NULL, NULL),
(40843, '2017-08-03 10:52:58', NULL, NULL, 11672, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 10:52:58', 'admin-1501721568-15017287780885151', 1, 1, 'SR', NULL, NULL, NULL),
(40844, '2017-08-03 11:00:57', NULL, NULL, 11674, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1501739307', 'admin', '2017-08-03 11:00:57', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(40845, '2017-08-03 10:52:50', NULL, NULL, 11672, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 10:52:50', 'admin-1501721568-15017287704251754', 1, 0, '', NULL, NULL, NULL),
(40846, '2017-08-03 09:44:40', NULL, NULL, 11671, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 09:44:40', 'admin-1501721568-15017246803821712', 1, 1, 'SR', NULL, NULL, '10.0'),
(40847, '2017-08-03 10:51:20', NULL, NULL, 11672, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1501739307', 'admin', '2017-08-03 10:51:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40848, '2017-08-03 09:11:45', NULL, NULL, 11670, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1501739307', 'admin', '2017-08-03 09:11:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40849, '2017-08-03 09:11:59', NULL, NULL, 11670, 0, 181, '116', 'Open Food ', 'junior blt', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501739307', 'admin', '2017-08-03 09:11:59', 'admin-1501721568-15017227189439094', 1, 0, '', NULL, NULL, NULL),
(40850, '2017-08-04 13:38:13', NULL, NULL, 11696, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 13:38:13', 'admin-1501820063-1501825093555301', 1, 1, 'SR', NULL, NULL, NULL),
(40851, '2017-08-04 15:15:39', NULL, NULL, 11706, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 15:15:39', 'admin-1501820063-15018309394327620', 1, 1, 'SR', NULL, NULL, NULL),
(40852, '2017-08-04 15:03:34', NULL, NULL, 11706, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 15:03:34', 'admin-1501820063-15018302141547483', 1, 0, '', NULL, NULL, NULL),
(40853, '2017-08-04 16:26:15', NULL, NULL, 11707, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1501820063', 'admin', '2017-08-04 16:26:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40854, '2017-08-04 14:28:50', NULL, NULL, 11704, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:28:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40855, '2017-08-04 14:29:06', NULL, NULL, 11704, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:29:06', 'admin-1501820063-1501828146696543', 1, 1, 'SR', NULL, NULL, NULL),
(40856, '2017-08-04 14:29:32', NULL, NULL, 11704, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:29:32', 'admin-1501820063-15018281721705517', 1, 1, 'SR', NULL, NULL, NULL),
(40857, '2017-08-04 15:03:15', NULL, NULL, 11706, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1501820063', 'admin', '2017-08-04 15:03:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40858, '2017-08-04 15:03:34', NULL, NULL, 11706, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 15:03:34', 'admin-1501820063-15018302141547483', 1, 1, 'SR', NULL, NULL, NULL),
(40859, '2017-08-04 14:40:57', NULL, NULL, 11705, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:40:57', 'admin-1501820063-15018288576823423', 1, 1, 'SR', NULL, NULL, NULL),
(40860, '2017-08-04 14:40:57', NULL, NULL, 11705, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:40:57', 'admin-1501820063-15018288576823423', 1, 1, 'SR', NULL, NULL, NULL),
(40861, '2017-08-04 14:40:57', NULL, NULL, 11705, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:40:57', 'admin-1501820063-15018288576823423', 1, 0, '', NULL, NULL, NULL),
(40862, '2017-08-04 14:40:57', NULL, NULL, 11705, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:40:57', 'admin-1501820063-15018288576823423', 1, 0, '', NULL, NULL, NULL),
(40863, '2017-08-04 14:40:57', NULL, NULL, 11705, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:40:57', 'admin-1501820063-15018288576823423', 1, 1, 'SR', NULL, NULL, NULL),
(40864, '2017-08-04 13:46:25', NULL, NULL, 11697, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 13:46:25', 'admin-1501820063-15018255854812984', 1, 0, '', NULL, NULL, '10.0'),
(40865, '2017-08-04 13:46:25', NULL, NULL, 11697, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 13:46:25', 'admin-1501820063-15018255854812984', 1, 1, 'SR', NULL, NULL, '10.0'),
(40866, '2017-08-04 13:48:19', NULL, NULL, 11698, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1501820063', 'admin', '2017-08-04 13:48:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40867, '2017-08-04 13:48:31', NULL, NULL, 11698, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 13:48:31', 'admin-1501820063-1501825711188254', 1, 1, 'SR', NULL, NULL, NULL),
(40868, '2017-08-04 15:15:39', NULL, NULL, 11706, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 15:15:39', 'admin-1501820063-15018309394327620', 1, 1, 'SR', NULL, NULL, NULL),
(40869, '2017-08-04 16:31:36', NULL, NULL, 11707, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 16:31:36', 'admin-1501820063-15018354962715952', 1, 1, 'SR', NULL, NULL, NULL),
(40870, '2017-08-04 16:31:36', NULL, NULL, 11707, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 16:31:36', 'admin-1501820063-15018354962715952', 1, 0, '', NULL, NULL, NULL),
(40871, '2017-08-04 16:31:36', NULL, NULL, 11707, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 16:31:36', 'admin-1501820063-15018354962715952', 1, 0, '', NULL, NULL, NULL),
(40872, '2017-08-04 16:31:36', NULL, NULL, 11707, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 16:31:36', 'admin-1501820063-15018354962715952', 1, 0, '', NULL, NULL, NULL),
(40873, '2017-08-04 14:06:25', NULL, NULL, 11699, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:06:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40874, '2017-08-04 12:15:03', NULL, NULL, 11694, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 12:15:03', 'admin-1501820063-15018201029653077', 1, 0, '', NULL, NULL, NULL),
(40875, '2017-08-04 14:22:32', NULL, NULL, 11702, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:22:32', 'admin-1501820063-15018277520595084', 1, 0, '', NULL, NULL, NULL),
(40876, '2017-08-04 14:22:32', NULL, NULL, 11702, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:22:32', 'admin-1501820063-15018277520595084', 1, 1, 'SR', NULL, NULL, NULL),
(40877, '2017-08-04 14:22:07', NULL, NULL, 11702, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:22:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40878, '2017-08-04 14:17:37', NULL, NULL, 11701, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:17:37', 'admin-1501820063-15018274570265547', 1, 1, 'SR', NULL, NULL, NULL),
(40879, '2017-08-04 14:17:23', NULL, NULL, 11701, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:17:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40880, '2017-08-04 11:08:50', NULL, NULL, 11691, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 11:08:50', 'admin-1501806629-15018161302693947', 1, 1, 'SR', NULL, NULL, NULL),
(40881, '2017-08-04 11:08:50', NULL, NULL, 11691, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 11:08:50', 'admin-1501806629-15018161302693947', 1, 1, 'SR', NULL, NULL, NULL),
(40882, '2017-08-04 17:29:55', NULL, NULL, 11709, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 17:29:55', 'admin-1501820063-15018389953609831', 1, 1, 'SR', NULL, NULL, NULL),
(40883, '2017-08-04 14:14:44', NULL, NULL, 11700, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:14:44', 'admin-1501820063-1501827283921256', 1, 1, 'SR', NULL, NULL, NULL),
(40884, '2017-08-04 11:09:25', NULL, NULL, 11692, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1501820063', 'admin', '2017-08-04 11:09:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40885, '2017-08-04 11:09:36', NULL, NULL, 11692, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 11:09:36', 'admin-1501806629-15018161759787466', 1, 0, '', NULL, NULL, NULL),
(40886, '2017-08-04 11:09:36', NULL, NULL, 11692, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 11:09:36', 'admin-1501806629-15018161759787466', 1, 0, '', NULL, NULL, NULL),
(40887, '2017-08-04 11:09:36', NULL, NULL, 11692, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 11:09:36', 'admin-1501806629-15018161759787466', 1, 1, 'SR', NULL, NULL, NULL),
(40888, '2017-08-04 11:09:36', NULL, NULL, 11692, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 11:09:36', 'admin-1501806629-15018161759787466', 1, 0, '', NULL, NULL, NULL),
(40889, '2017-08-04 17:29:55', NULL, NULL, 11709, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 17:29:55', 'admin-1501820063-15018389953609831', 1, 1, 'SR', NULL, NULL, NULL),
(40890, '2017-08-04 17:29:47', NULL, NULL, 11709, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1501820063', 'admin', '2017-08-04 17:29:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40891, '2017-08-04 16:57:33', NULL, NULL, 11708, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1501820063', 'admin', '2017-08-04 16:57:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40892, '2017-08-04 16:57:37', NULL, NULL, 11708, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 16:57:37', 'admin-1501820063-15018370576158190', 1, 0, '', NULL, NULL, NULL),
(40893, '2017-08-04 14:40:57', NULL, NULL, 11705, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:40:57', 'admin-1501820063-15018288576823423', 1, 1, 'SR', NULL, NULL, NULL),
(40894, '2017-08-04 16:57:37', NULL, NULL, 11708, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 16:57:37', 'admin-1501820063-15018370576158190', 1, 0, '', NULL, NULL, NULL),
(40895, '2017-08-04 14:14:44', NULL, NULL, 11700, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:14:44', 'admin-1501820063-1501827283921256', 1, 0, '', NULL, NULL, NULL),
(40896, '2017-08-04 14:14:36', NULL, NULL, 11700, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:14:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40897, '2017-08-04 14:09:46', NULL, NULL, 11699, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:09:46', 'admin-1501820063-15018269867342019', 1, 0, '', NULL, NULL, NULL),
(40898, '2017-08-04 14:06:29', NULL, NULL, 11699, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:06:29', 'admin-1501820063-15018267891014075', 1, 1, 'SR', NULL, NULL, NULL),
(40899, '2017-08-04 14:06:29', NULL, NULL, 11699, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:06:29', 'admin-1501820063-15018267891014075', 1, 1, 'SR', NULL, NULL, NULL),
(40900, '2017-08-04 14:03:15', NULL, NULL, 11698, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:03:15', 'admin-1501820063-15018265948601330', 1, 1, 'SR', NULL, NULL, NULL),
(40901, '2017-08-04 14:01:23', NULL, NULL, 11698, 0, 285, '219', 'Tip Tap Lor Bak', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:01:23', 'admin-1501820063-1501826483538649', 1, 0, '', NULL, NULL, NULL),
(40902, '2017-08-04 14:40:29', NULL, NULL, 11705, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1501820063', 'admin', '2017-08-04 14:40:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40903, '2017-08-04 13:48:31', NULL, NULL, 11698, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 13:48:31', 'admin-1501820063-1501825711188254', 1, 1, 'SR', NULL, NULL, NULL),
(40904, '2017-08-04 13:45:59', NULL, NULL, 11697, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1501820063', 'admin', '2017-08-04 13:45:59', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(40905, '2017-08-04 13:34:07', NULL, NULL, 11696, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 13:34:07', 'admin-1501820063-15018248469425482', 1, 0, '', NULL, NULL, NULL),
(40906, '2017-08-04 12:15:03', NULL, NULL, 11694, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 12:15:03', 'admin-1501820063-15018201029653077', 1, 0, '', NULL, NULL, NULL),
(40907, '2017-08-04 12:15:03', NULL, NULL, 11694, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 12:15:03', 'admin-1501820063-15018201029653077', 1, 1, 'SR', NULL, NULL, NULL),
(40908, '2017-08-04 12:38:36', NULL, NULL, 11695, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1501820063', 'admin', '2017-08-04 12:38:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40909, '2017-08-04 12:38:41', NULL, NULL, 11695, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 12:38:41', 'admin-1501820063-15018215209331113', 1, 0, '', NULL, NULL, NULL),
(40910, '2017-08-04 13:33:54', NULL, NULL, 11696, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 13:33:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40911, '2017-08-04 12:14:42', NULL, NULL, 11694, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1501820063', 'admin', '2017-08-04 12:14:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40912, '2017-08-04 12:15:03', NULL, NULL, 11694, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 12:15:03', 'admin-1501820063-15018201029653077', 1, 0, '', NULL, NULL, NULL),
(40913, '2017-08-04 11:48:12', NULL, NULL, 11693, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 11:48:12', 'admin-1501806629-15018184921324017', 1, 1, 'SR', NULL, NULL, NULL),
(40914, '2017-08-04 11:48:12', NULL, NULL, 11693, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 11:48:12', 'admin-1501806629-15018184921324017', 1, 1, 'SR', NULL, NULL, NULL),
(40915, '2017-08-04 11:48:12', NULL, NULL, 11693, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 11:48:12', 'admin-1501806629-15018184921324017', 1, 1, 'SR', NULL, NULL, NULL),
(40916, '2017-08-04 11:47:56', NULL, NULL, 11693, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1501820063', 'admin', '2017-08-04 11:47:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40917, '2017-08-04 11:48:12', NULL, NULL, 11693, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 11:48:12', 'admin-1501806629-15018184921324017', 1, 0, '', NULL, NULL, NULL),
(40918, '2017-08-04 11:48:12', NULL, NULL, 11693, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 11:48:12', 'admin-1501806629-15018184921324017', 1, 0, '', NULL, NULL, NULL),
(40919, '2017-08-04 10:26:16', NULL, NULL, 11690, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 10:26:16', 'admin-1501806629-15018135766909370', 1, 1, 'SR', NULL, NULL, NULL),
(40920, '2017-08-04 10:26:16', NULL, NULL, 11690, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 10:26:16', 'admin-1501806629-15018135766909370', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(40921, '2017-08-04 11:08:32', NULL, NULL, 11691, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1501820063', 'admin', '2017-08-04 11:08:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40922, '2017-08-04 11:08:50', NULL, NULL, 11691, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 11:08:50', 'admin-1501806629-15018161302693947', 1, 0, '', NULL, NULL, NULL),
(40923, '2017-08-04 11:08:50', NULL, NULL, 11691, 0, 153, '87', 'Wake Me Up!', 'no sausage add bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 11:08:50', 'admin-1501806629-15018161302693947', 1, 0, '', NULL, NULL, NULL),
(40924, '2017-08-04 10:12:36', NULL, NULL, 11689, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 10:12:36', 'admin-1501806629-15018127566039455', 1, 0, '', NULL, NULL, NULL),
(40925, '2017-08-04 10:24:34', NULL, NULL, 11690, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1501820063', 'admin', '2017-08-04 10:24:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40926, '2017-08-04 10:12:30', NULL, NULL, 11689, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 10:12:30', 'admin-1501806629-15018127500581011', 1, 0, '', NULL, NULL, NULL),
(40927, '2017-08-04 10:05:14', NULL, NULL, 11688, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1501820063', 'admin', '2017-08-04 10:05:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40928, '2017-08-04 10:05:18', NULL, NULL, 11688, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 10:05:18', 'admin-1501806629-15018123185659019', 1, 1, 'SR', NULL, NULL, NULL),
(40929, '2017-08-04 10:12:14', NULL, NULL, 11689, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1501820063', 'admin', '2017-08-04 10:12:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40930, '2017-08-04 10:12:30', NULL, NULL, 11689, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 10:12:30', 'admin-1501806629-15018127500581011', 1, 0, '', NULL, NULL, NULL),
(40931, '2017-08-04 09:44:10', NULL, NULL, 11687, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1501820063', 'admin', '2017-08-04 09:44:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40932, '2017-08-04 09:44:14', NULL, NULL, 11687, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501820063', 'admin', '2017-08-04 09:44:14', 'admin-1501806629-15018110546625778', 1, 1, 'SR', NULL, NULL, NULL),
(40933, '2017-08-05 14:44:10', NULL, NULL, 11746, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:44:10', 'admin-1501912953-1501915450570121', 1, 1, 'SR', NULL, NULL, NULL),
(40934, '2017-08-05 17:51:59', NULL, NULL, 11765, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1501923116', 'admin', '2017-08-05 17:51:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40935, '2017-08-05 14:44:10', NULL, NULL, 11746, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:44:10', 'admin-1501912953-1501915450570121', 1, 0, '', NULL, NULL, NULL),
(40936, '2017-08-05 12:21:57', NULL, NULL, 11733, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:21:57', 'admin-1501906887-15019069175356098', 1, 0, '', NULL, NULL, NULL),
(40937, '2017-08-05 12:21:57', NULL, NULL, 11733, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:21:57', 'admin-1501906887-15019069175356098', 1, 1, 'SR', NULL, NULL, NULL),
(40938, '2017-08-05 12:21:57', NULL, NULL, 11733, 0, 181, '116', 'Open Food ', 'Pancake ice cream', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:21:57', 'admin-1501906887-15019069175356098', 1, 0, '', NULL, NULL, NULL),
(40939, '2017-08-05 14:08:08', NULL, NULL, 11743, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:08:08', 'admin-1501912953-15019132884314966', 1, 0, '', NULL, NULL, NULL),
(40940, '2017-08-05 14:08:08', NULL, NULL, 11743, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:08:08', 'admin-1501912953-15019132884314966', 1, 0, '', NULL, NULL, NULL),
(40941, '2017-08-05 14:41:57', NULL, NULL, 11746, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:41:57', 'admin-1501912953-15019153171998921', 1, 1, 'SR', NULL, NULL, NULL),
(40942, '2017-08-05 14:47:46', NULL, NULL, 11745, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:47:46', 'admin-1501915458-15019156660047983', 1, 1, 'SR', NULL, NULL, NULL),
(40943, '2017-08-05 14:47:46', NULL, NULL, 11745, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:47:46', 'admin-1501915458-15019156660047983', 1, 0, '', NULL, NULL, NULL),
(40944, '2017-08-05 14:53:56', NULL, NULL, 11745, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:53:56', 'admin-1501915458-15019160362507981', 1, 1, 'SR', NULL, NULL, NULL),
(40945, '2017-08-05 14:55:29', NULL, NULL, 11747, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:55:29', 'admin-1501915458-15019161295378171', 1, 1, 'SR', NULL, NULL, NULL),
(40946, '2017-08-05 17:11:58', NULL, NULL, 11764, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 17:11:58', 'admin-1501923116-1501924318618701', 1, 1, 'SR', NULL, NULL, NULL),
(40947, '2017-08-05 16:38:26', NULL, NULL, 11756, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 16:38:26', 'admin-1501915458-15019223062828720', 1, 0, '', NULL, NULL, NULL),
(40948, '2017-08-05 17:05:49', NULL, NULL, 11763, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1501923116', 'admin', '2017-08-05 17:05:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40949, '2017-08-05 17:07:01', NULL, NULL, 11763, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 17:07:01', 'admin-1501923116-15019240211344559', 1, 1, 'SR', NULL, NULL, NULL),
(40950, '2017-08-05 15:00:10', NULL, NULL, 11748, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 15:00:10', 'admin-1501915458-15019164105676867', 1, 1, 'SR', NULL, NULL, NULL),
(40951, '2017-08-05 15:00:10', NULL, NULL, 11748, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 15:00:10', 'admin-1501915458-15019164105676867', 1, 1, 'SR', NULL, NULL, NULL),
(40952, '2017-08-05 15:03:52', NULL, NULL, 11745, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 15:03:52', 'admin-1501915458-15019166325932945', 1, 1, 'SR', NULL, NULL, NULL),
(40953, '2017-08-05 15:27:52', NULL, NULL, 11752, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 15:27:52', 'admin-1501915458-15019180723045819', 1, 1, 'SR', NULL, NULL, NULL),
(40954, '2017-08-05 15:27:52', NULL, NULL, 11752, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 15:27:52', 'admin-1501915458-15019180723045819', 1, 1, 'SR', NULL, NULL, NULL),
(40955, '2017-08-05 15:49:50', NULL, NULL, 11753, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 15:49:50', 'admin-1501915458-15019193901361023', 1, 0, '', NULL, NULL, NULL),
(40956, '2017-08-05 16:01:07', NULL, NULL, 11754, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1501923116', 'admin', '2017-08-05 16:01:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40957, '2017-08-05 14:06:32', NULL, NULL, 11743, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:06:32', 'admin-1501912953-15019131923508618', 1, 0, '', NULL, NULL, NULL),
(40958, '2017-08-05 14:06:25', NULL, NULL, 11741, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:06:25', 'admin-1501912953-15019131851561618', 1, 1, 'SR', NULL, NULL, NULL),
(40959, '2017-08-05 14:06:29', NULL, NULL, 11743, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:06:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40960, '2017-08-05 14:03:57', NULL, NULL, 11742, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:03:57', 'admin-1501912953-15019130369805074', 1, 0, '', NULL, NULL, NULL),
(40961, '2017-08-05 14:03:57', NULL, NULL, 11742, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:03:57', 'admin-1501912953-15019130369805074', 1, 0, '', NULL, NULL, NULL),
(40962, '2017-08-05 15:04:43', NULL, NULL, 11749, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 15:04:43', 'admin-1501915458-15019166832114891', 1, 1, 'SR', NULL, NULL, NULL),
(40963, '2017-08-05 14:08:08', NULL, NULL, 11743, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:08:08', 'admin-1501912953-15019132884314966', 1, 0, '', NULL, NULL, NULL),
(40964, '2017-08-05 14:08:08', NULL, NULL, 11743, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:08:08', 'admin-1501912953-15019132884314966', 1, 1, 'SR', NULL, NULL, NULL),
(40965, '2017-08-05 14:08:42', NULL, NULL, 11743, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:08:42', 'admin-1501912953-15019133220046088', 1, 1, 'SR', NULL, NULL, NULL),
(40966, '2017-08-05 14:08:42', NULL, NULL, 11743, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:08:42', 'admin-1501912953-15019133220046088', 1, 1, 'SR', NULL, NULL, NULL),
(40967, '2017-08-05 00:00:00', NULL, NULL, 11744, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:44:17', 'admin-1501906887-15019082576914524', 1, 1, 'SR', NULL, NULL, NULL),
(40968, '2017-08-05 14:59:58', NULL, NULL, 11748, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:59:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40969, '2017-08-05 15:47:21', NULL, NULL, 11751, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 15:47:21', 'admin-1501915458-15019192408614276', 1, 1, 'SR', NULL, NULL, '10.0'),
(40970, '2017-08-05 15:49:27', NULL, NULL, 11753, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1501923116', 'admin', '2017-08-05 15:49:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40971, '2017-08-05 15:49:50', NULL, NULL, 11753, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 15:49:50', 'admin-1501915458-15019193901361023', 1, 1, 'SR', NULL, NULL, NULL),
(40972, '2017-08-05 17:07:01', NULL, NULL, 11763, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 17:07:01', 'admin-1501923116-15019240211344559', 1, 1, 'SR', NULL, NULL, NULL),
(40973, '2017-08-05 17:11:34', NULL, NULL, 11764, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 17:11:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40974, '2017-08-05 14:03:57', NULL, NULL, 11742, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:03:57', 'admin-1501912953-15019130369805074', 1, 1, 'SR', NULL, NULL, NULL),
(40975, '2017-08-05 14:03:57', NULL, NULL, 11742, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:03:57', 'admin-1501912953-15019130369805074', 1, 0, '', NULL, NULL, NULL),
(40976, '2017-08-05 13:40:52', NULL, NULL, 11739, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 13:40:52', 'admin-1501909439-15019116526892694', 1, 0, '', NULL, NULL, NULL),
(40977, '2017-08-05 13:40:52', NULL, NULL, 11739, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 13:40:52', 'admin-1501909439-15019116526892694', 1, 1, 'SR', NULL, NULL, NULL),
(40978, '2017-08-05 00:00:00', NULL, NULL, 11740, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 13:03:47', 'admin-1501906887-15019094275635159', 1, 0, '', NULL, NULL, NULL),
(40979, '2017-08-05 13:57:09', NULL, NULL, 11740, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 13:57:09', 'admin-1501909439-15019126290761383', 1, 1, 'SR', NULL, NULL, NULL),
(40980, '2017-08-05 14:01:49', NULL, NULL, 11741, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.50, 0.0000, 0.0000, 11.50, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:01:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40981, '2017-08-05 14:02:19', NULL, NULL, 11741, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:02:19', 'admin-1501909439-15019129389437211', 1, 0, '', NULL, NULL, NULL),
(40982, '2017-08-05 14:02:19', NULL, NULL, 11741, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:02:19', 'admin-1501909439-15019129389437211', 1, 0, '', NULL, NULL, NULL),
(40983, '2017-08-05 14:02:19', NULL, NULL, 11741, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:02:19', 'admin-1501909439-15019129389437211', 1, 0, '', NULL, NULL, NULL),
(40984, '2017-08-05 14:02:19', NULL, NULL, 11741, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:02:19', 'admin-1501909439-15019129389437211', 1, 0, '', NULL, NULL, NULL),
(40985, '2017-08-05 17:07:01', NULL, NULL, 11763, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 17:07:01', 'admin-1501923116-15019240211344559', 1, 1, 'SR', NULL, NULL, NULL),
(40986, '2017-08-05 14:41:23', NULL, NULL, 11746, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:41:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40987, '2017-08-05 14:41:57', NULL, NULL, 11746, 0, 73, '73', 'Marmite Chicken ', 'no egg', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:41:57', 'admin-1501912953-15019153171998921', 1, 1, 'SR', NULL, NULL, NULL),
(40988, '2017-08-05 13:56:55', NULL, NULL, 11740, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1501923116', 'admin', '2017-08-05 13:56:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40989, '2017-08-05 12:47:50', NULL, NULL, 11730, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:47:50', 'admin-1501906887-15019084697852977', 1, 0, '', NULL, NULL, NULL),
(40990, '2017-08-05 10:47:10', NULL, NULL, 11722, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:47:10', 'admin-1501898907-15019012304761182', 1, 0, '', NULL, NULL, NULL),
(40991, '2017-08-05 15:12:00', NULL, NULL, 11750, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1501923116', 'admin', '2017-08-05 15:12:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(40992, '2017-08-05 15:12:12', NULL, NULL, 11750, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 15:12:12', 'admin-1501915458-15019171319543667', 1, 1, 'SR', NULL, NULL, NULL),
(40993, '2017-08-05 15:12:12', NULL, NULL, 11750, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 15:12:12', 'admin-1501915458-15019171319543667', 1, 1, 'SR', NULL, NULL, NULL),
(40994, '2017-08-05 17:11:43', NULL, NULL, 11764, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 17:11:43', 'admin-1501923116-15019243031379559', 1, 1, 'SR', NULL, NULL, NULL),
(40995, '2017-08-05 15:12:12', NULL, NULL, 11750, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 15:12:12', 'admin-1501915458-15019171319543667', 1, 0, '', NULL, NULL, NULL),
(40996, '2017-08-05 15:24:18', NULL, NULL, 11751, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1501923116', 'admin', '2017-08-05 15:24:18', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(40997, '2017-08-05 15:24:44', NULL, NULL, 11751, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 15:24:44', 'admin-1501915458-1501917884189934', 1, 1, 'SR', NULL, NULL, '10.0'),
(40998, '2017-08-05 15:24:44', NULL, NULL, 11751, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 15:24:44', 'admin-1501915458-1501917884189934', 1, 1, 'SR', NULL, NULL, '10.0'),
(40999, '2017-08-05 00:00:00', NULL, NULL, 11740, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:44:17', 'admin-1501906887-15019082576914524', 1, 1, 'SR', NULL, NULL, NULL),
(41000, '2017-08-05 13:14:58', NULL, NULL, 11737, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 13:14:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41001, '2017-08-05 13:15:17', NULL, NULL, 11737, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 13:15:17', 'admin-1501909439-15019101174558165', 1, 1, 'SR', NULL, NULL, NULL),
(41002, '2017-08-05 13:15:17', NULL, NULL, 11737, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 13:15:17', 'admin-1501909439-15019101174558165', 1, 1, 'SR', NULL, NULL, NULL),
(41003, '2017-08-05 13:19:41', NULL, NULL, 11738, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1501923116', 'admin', '2017-08-05 13:19:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41004, '2017-08-05 13:19:49', NULL, NULL, 11738, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 13:19:49', 'admin-1501909439-15019103893099531', 1, 1, 'SR', NULL, NULL, NULL),
(41005, '2017-08-05 13:19:49', NULL, NULL, 11738, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 13:19:49', 'admin-1501909439-15019103893099531', 1, 0, '', NULL, NULL, NULL),
(41006, '2017-08-05 13:20:01', NULL, NULL, 11738, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 13:20:01', 'admin-1501909439-15019104016377146', 1, 1, 'SR', NULL, NULL, NULL),
(41007, '2017-08-05 13:20:01', NULL, NULL, 11738, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 13:20:01', 'admin-1501909439-15019104016377146', 1, 1, 'SR', NULL, NULL, NULL),
(41008, '2017-08-05 14:03:13', NULL, NULL, 11742, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:03:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41009, '2017-08-05 14:03:01', NULL, NULL, 11741, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:03:01', 'admin-1501912953-15019129814504146', 1, 1, 'SR', NULL, NULL, NULL),
(41010, '2017-08-05 14:03:01', NULL, NULL, 11741, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:03:01', 'admin-1501912953-15019129814504146', 1, 1, 'SR', NULL, NULL, NULL),
(41011, '2017-08-05 13:36:21', NULL, NULL, 11739, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 13:36:21', 'admin-1501909439-1501911381569691', 1, 0, '', NULL, NULL, NULL),
(41012, '2017-08-05 11:55:12', NULL, NULL, 11730, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:55:12', 'admin-1501901672-15019053121996011', 1, 1, 'SR', NULL, NULL, NULL),
(41013, '2017-08-05 12:50:23', NULL, NULL, 11721, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:50:23', 'admin-1501906887-15019086228381094', 1, 1, 'SR', NULL, NULL, NULL),
(41014, '2017-08-05 11:45:31', NULL, NULL, 11729, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:45:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41015, '2017-08-05 17:52:03', NULL, NULL, 11765, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 17:52:03', 'admin-1501923116-15019267230371178', 1, 0, '', NULL, NULL, NULL),
(41016, '2017-08-05 17:37:13', NULL, NULL, 11752, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 17:37:13', 'admin-1501923116-15019258335537231', 1, 0, '', NULL, NULL, NULL),
(41017, '2017-08-05 13:36:17', NULL, NULL, 11739, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1501923116', 'admin', '2017-08-05 13:36:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41018, '2017-08-05 12:16:32', NULL, NULL, 11732, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:16:32', 'admin-1501906300-15019065920006461', 1, 0, '', NULL, NULL, NULL),
(41019, '2017-08-05 11:56:18', NULL, NULL, 11730, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:56:18', 'admin-1501905326-1501905377731524', 1, 1, 'SR', NULL, NULL, NULL),
(41020, '2017-08-05 11:59:21', NULL, NULL, 11731, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:59:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41021, '2017-08-05 11:59:27', NULL, NULL, 11731, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:59:27', 'admin-1501905326-15019055669621250', 1, 0, '', NULL, NULL, NULL),
(41022, '2017-08-05 11:59:27', NULL, NULL, 11731, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:59:27', 'admin-1501905326-15019055669621250', 1, 0, '', NULL, NULL, NULL),
(41023, '2017-08-05 12:16:09', NULL, NULL, 11732, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:16:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41024, '2017-08-05 12:16:32', NULL, NULL, 11732, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:16:32', 'admin-1501906300-15019065920006461', 1, 0, '', NULL, NULL, NULL),
(41025, '2017-08-05 12:16:32', NULL, NULL, 11732, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:16:32', 'admin-1501906300-15019065920006461', 1, 0, '', NULL, NULL, NULL),
(41026, '2017-08-05 15:24:44', NULL, NULL, 11751, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 15:24:44', 'admin-1501915458-1501917884189934', 1, 0, '', NULL, NULL, '10.0'),
(41027, '2017-08-05 16:56:59', NULL, NULL, 11762, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 16:56:59', 'admin-1501923116-15019234196828244', 1, 1, 'SR', NULL, NULL, '10.0'),
(41028, '2017-08-05 16:52:16', NULL, NULL, 11759, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 16:52:16', 'admin-1501923116-15019231363861534', 1, 1, 'SR', 1, NULL, '10.0'),
(41029, '2017-08-05 16:56:53', NULL, NULL, 11762, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1501923116', 'admin', '2017-08-05 16:56:53', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(41030, '2017-08-05 16:52:16', NULL, NULL, 11759, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 16:52:16', 'admin-1501923116-15019231363861534', 1, 1, 'SR', 1, NULL, '10.0'),
(41031, '2017-08-05 12:34:07', NULL, NULL, 11735, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:34:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41032, '2017-08-05 12:34:42', NULL, NULL, 11735, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:34:42', 'admin-1501906887-15019076826756540', 1, 0, '', NULL, NULL, NULL),
(41033, '2017-08-05 12:34:42', NULL, NULL, 11735, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:34:42', 'admin-1501906887-15019076826756540', 1, 0, '', NULL, NULL, NULL),
(41034, '2017-08-05 16:38:26', NULL, NULL, 11756, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 16:38:26', 'admin-1501915458-15019223062828720', 1, 0, '', NULL, NULL, NULL),
(41035, '2017-08-05 16:38:26', NULL, NULL, 11756, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 16:38:26', 'admin-1501915458-15019223062828720', 1, 0, '', NULL, NULL, NULL),
(41036, '2017-08-05 16:01:23', NULL, NULL, 11754, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 16:01:23', 'admin-1501915458-15019200834936667', 1, 1, 'SR', NULL, NULL, NULL),
(41037, '2017-08-05 16:01:23', NULL, NULL, 11754, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 16:01:23', 'admin-1501915458-15019200834936667', 1, 0, '', NULL, NULL, NULL),
(41038, '2017-08-05 15:27:52', NULL, NULL, 11752, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 15:27:52', 'admin-1501915458-15019180723045819', 1, 0, '', NULL, NULL, NULL),
(41039, '2017-08-05 16:38:19', NULL, NULL, 11756, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1501923116', 'admin', '2017-08-05 16:38:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41040, '2017-08-05 15:27:37', NULL, NULL, 11752, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1501923116', 'admin', '2017-08-05 15:27:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41041, '2017-08-05 15:24:44', NULL, NULL, 11751, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 15:24:44', 'admin-1501915458-1501917884189934', 1, 1, 'SR', NULL, NULL, '10.0'),
(41042, '2017-08-05 15:04:39', NULL, NULL, 11749, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1501923116', 'admin', '2017-08-05 15:04:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41043, '2017-08-05 14:55:29', NULL, NULL, 11747, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:55:29', 'admin-1501915458-15019161295378171', 1, 1, 'SR', NULL, NULL, NULL),
(41044, '2017-08-05 14:55:23', NULL, NULL, 11747, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:55:23', 'admin-1501915458-15019161231407341', 1, 0, '', NULL, NULL, NULL),
(41045, '2017-08-05 14:55:23', NULL, NULL, 11747, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:55:23', 'admin-1501915458-15019161231407341', 1, 0, '', NULL, NULL, NULL),
(41046, '2017-08-05 12:23:32', NULL, NULL, 11734, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:23:32', 'admin-1501906887-15019070125015315', 1, 1, 'SR', NULL, NULL, NULL),
(41047, '2017-08-05 17:15:50', NULL, NULL, 11752, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 17:15:50', 'admin-1501923116-15019245505622097', 1, 1, 'SR', NULL, NULL, NULL),
(41048, '2017-08-05 14:16:16', NULL, NULL, 11744, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:16:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41049, '2017-08-05 12:43:55', NULL, NULL, 11721, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:43:55', 'admin-1501906887-1501908235462571', 1, 1, 'SR', NULL, NULL, NULL),
(41050, '2017-08-05 00:00:00', NULL, NULL, 11744, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:43:15', 'admin-1501906887-15019081948802550', 1, 0, '', NULL, NULL, NULL),
(41051, '2017-08-05 10:47:10', NULL, NULL, 11722, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:47:10', 'admin-1501898907-15019012304761182', 1, 1, 'SR', NULL, NULL, NULL),
(41052, '2017-08-05 10:25:01', NULL, NULL, 11720, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:25:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41053, '2017-08-05 10:25:14', NULL, NULL, 11720, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:25:14', 'admin-1501898907-15018999138297334', 1, 0, '', NULL, NULL, NULL),
(41054, '2017-08-05 10:25:14', NULL, NULL, 11720, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:25:14', 'admin-1501898907-15018999138297334', 1, 1, 'SR', NULL, NULL, NULL),
(41055, '2017-08-05 14:55:08', NULL, NULL, 11747, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:55:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41056, '2017-08-05 14:44:10', NULL, NULL, 11746, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 2, 14.00, 28.0000, 0.0000, 28.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:44:10', 'admin-1501912953-1501915450570121', 1, 1, 'SR', NULL, NULL, NULL),
(41057, '2017-08-05 14:44:10', NULL, NULL, 11746, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:44:10', 'admin-1501912953-1501915450570121', 1, 0, '', NULL, NULL, NULL),
(41058, '2017-08-05 12:41:35', NULL, NULL, 11721, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:41:35', 'admin-1501906887-15019080955945067', 1, 1, 'SR', NULL, NULL, NULL),
(41059, '2017-08-05 12:41:35', NULL, NULL, 11721, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:41:35', 'admin-1501906887-15019080955945067', 1, 1, 'SR', NULL, NULL, NULL),
(41060, '2017-08-05 12:42:55', NULL, NULL, 11736, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:42:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41061, '2017-08-05 12:43:15', NULL, NULL, 11736, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:43:15', 'admin-1501906887-15019081948802550', 1, 1, 'SR', NULL, NULL, NULL),
(41062, '2017-08-05 16:56:59', NULL, NULL, 11762, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 16:56:59', 'admin-1501923116-15019234196828244', 1, 1, 'SR', NULL, NULL, '10.0'),
(41063, '2017-08-05 14:28:31', NULL, NULL, 11745, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:28:31', 'admin-1501912953-15019145115497388', 1, 0, '', NULL, NULL, NULL),
(41064, '2017-08-05 14:28:19', NULL, NULL, 11745, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:28:19', 'admin-1501912953-15019144995135510', 1, 1, 'SR', NULL, NULL, NULL),
(41065, '2017-08-05 14:28:09', NULL, NULL, 11745, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:28:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41066, '2017-08-05 14:03:01', NULL, NULL, 11741, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 14:03:01', 'admin-1501912953-15019129814504146', 1, 1, 'SR', NULL, NULL, NULL),
(41067, '2017-08-05 11:41:31', NULL, NULL, 11728, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:41:31', 'admin-1501901672-15019044908927111', 1, 1, 'SR', NULL, NULL, NULL),
(41068, '2017-08-05 11:40:50', NULL, NULL, 11728, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:40:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41069, '2017-08-05 11:41:07', NULL, NULL, 11728, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:41:07', 'admin-1501901672-15019044677067654', 1, 0, '', NULL, NULL, NULL),
(41070, '2017-08-05 11:41:07', NULL, NULL, 11728, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:41:07', 'admin-1501901672-15019044677067654', 1, 0, '', NULL, NULL, NULL),
(41071, '2017-08-05 11:41:07', NULL, NULL, 11728, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:41:07', 'admin-1501901672-15019044677067654', 1, 0, '', NULL, NULL, NULL),
(41072, '2017-08-05 11:41:31', NULL, NULL, 11728, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:41:31', 'admin-1501901672-15019044908927111', 1, 0, '', NULL, NULL, NULL),
(41073, '2017-08-05 10:19:37', NULL, NULL, 11719, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:19:37', 'admin-1501898907-15018995777126694', 1, 1, 'SR', NULL, NULL, NULL),
(41074, '2017-08-05 10:15:36', NULL, NULL, 11718, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:15:36', 'admin-1501898907-15018993360755273', 1, 1, 'SR', NULL, NULL, NULL),
(41075, '2017-08-05 10:15:36', NULL, NULL, 11718, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:15:36', 'admin-1501898907-15018993360755273', 1, 0, '', NULL, NULL, NULL),
(41076, '2017-08-05 10:19:19', NULL, NULL, 11719, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:19:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41077, '2017-08-05 10:19:37', NULL, NULL, 11719, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:19:37', 'admin-1501898907-15018995777126694', 1, 1, 'SR', NULL, NULL, NULL),
(41078, '2017-08-05 12:23:32', NULL, NULL, 11734, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:23:32', 'admin-1501906887-15019070125015315', 1, 1, 'SR', NULL, NULL, NULL),
(41079, '2017-08-05 12:34:42', NULL, NULL, 11735, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:34:42', 'admin-1501906887-15019076826756540', 1, 0, '', NULL, NULL, NULL),
(41080, '2017-08-05 12:23:32', NULL, NULL, 11734, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:23:32', 'admin-1501906887-15019070125015315', 1, 1, 'SR', NULL, NULL, NULL),
(41081, '2017-08-05 11:41:31', NULL, NULL, 11728, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:41:31', 'admin-1501901672-15019044908927111', 1, 0, '', NULL, NULL, NULL),
(41082, '2017-08-05 11:26:38', NULL, NULL, 11727, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:26:38', 'admin-1501901672-15019035983428884', 1, 1, 'SR', NULL, NULL, NULL),
(41083, '2017-08-05 11:37:06', NULL, NULL, 11725, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:37:06', 'admin-1501901672-15019042265787196', 1, 0, '', NULL, NULL, NULL),
(41084, '2017-08-05 11:26:38', NULL, NULL, 11727, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:26:38', 'admin-1501901672-15019035983428884', 1, 1, 'SR', NULL, NULL, NULL),
(41085, '2017-08-05 11:26:38', NULL, NULL, 11727, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:26:38', 'admin-1501901672-15019035983428884', 1, 1, 'SR', NULL, NULL, NULL),
(41086, '2017-08-05 11:26:24', NULL, NULL, 11727, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:26:24', 'admin-1501901672-15019035837635879', 1, 0, '', NULL, NULL, NULL),
(41087, '2017-08-05 10:15:36', NULL, NULL, 11718, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:15:36', 'admin-1501898907-15018993360755273', 1, 0, '', NULL, NULL, NULL),
(41088, '2017-08-05 11:26:24', NULL, NULL, 11727, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:26:24', 'admin-1501901672-15019035837635879', 1, 0, '', NULL, NULL, NULL),
(41089, '2017-08-05 11:23:06', NULL, NULL, 11727, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:23:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41090, '2017-08-05 11:19:17', NULL, NULL, 11726, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:19:17', 'admin-1501901672-15019031574249553', 1, 1, 'SR', NULL, NULL, NULL),
(41091, '2017-08-05 10:38:17', NULL, NULL, 11721, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:38:17', 'admin-1501898907-15019006976466752', 1, 0, '', NULL, NULL, NULL),
(41092, '2017-08-05 10:38:17', NULL, NULL, 11721, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:38:17', 'admin-1501898907-15019006976466752', 1, 0, '', NULL, NULL, NULL),
(41093, '2017-08-05 10:38:17', NULL, NULL, 11721, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:38:17', 'admin-1501898907-15019006976466752', 1, 1, 'SR', NULL, NULL, NULL),
(41094, '2017-08-05 10:38:17', NULL, NULL, 11721, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:38:17', 'admin-1501898907-15019006976466752', 1, 1, 'SR', NULL, NULL, NULL),
(41095, '2017-08-05 10:38:17', NULL, NULL, 11721, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:38:17', 'admin-1501898907-15019006976466752', 1, 1, 'SR', NULL, NULL, NULL),
(41096, '2017-08-05 12:22:08', NULL, NULL, 11734, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:22:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41097, '2017-08-05 12:21:12', NULL, NULL, 11733, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:21:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41098, '2017-08-05 10:47:10', NULL, NULL, 11722, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:47:10', 'admin-1501898907-15019012304761182', 1, 1, 'SR', NULL, NULL, NULL),
(41099, '2017-08-05 11:56:05', NULL, NULL, 11730, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:56:05', 'admin-1501905326-15019053654556066', 1, 1, 'SR', NULL, NULL, NULL),
(41100, '2017-08-05 11:56:05', NULL, NULL, 11730, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:56:05', 'admin-1501905326-15019053654556066', 1, 1, 'SR', NULL, NULL, NULL),
(41101, '2017-08-05 11:45:36', NULL, NULL, 11729, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:45:36', 'admin-1501901672-1501904736172582', 1, 0, '', NULL, NULL, NULL),
(41102, '2017-08-05 11:55:01', NULL, NULL, 11730, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:55:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41103, '2017-08-05 11:00:02', NULL, NULL, 11725, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:00:02', 'admin-1501901672-15019020022816410', 1, 0, '', NULL, NULL, NULL),
(41104, '2017-08-05 10:53:53', NULL, NULL, 11723, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:53:53', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(41105, '2017-08-05 10:54:06', NULL, NULL, 11723, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:54:06', 'admin-1501898907-1501901645781632', 1, 0, '', NULL, NULL, NULL),
(41106, '2017-08-05 10:54:06', NULL, NULL, 11723, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:54:06', 'admin-1501898907-1501901645781632', 1, 0, '', NULL, NULL, NULL),
(41107, '2017-08-05 10:54:49', NULL, NULL, 11723, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:54:49', 'admin-1501901672-15019016897796961', 1, 1, 'SR', NULL, NULL, NULL),
(41108, '2017-08-05 10:54:50', NULL, NULL, 11723, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:54:50', 'admin-1501901672-15019016897796961', 1, 1, 'SR', NULL, NULL, NULL),
(41109, '2017-08-05 10:57:57', NULL, NULL, 11724, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:57:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41110, '2017-08-05 10:58:18', NULL, NULL, 11724, 0, 270, '204', 'Homemade Savoury Pancake', ' add 1 bacon,No banana', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:58:18', 'admin-1501901672-15019018983298160', 1, 0, '', NULL, NULL, NULL),
(41111, '2017-08-05 10:58:18', NULL, NULL, 11724, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:58:18', 'admin-1501901672-15019018983298160', 1, 0, '', NULL, NULL, NULL),
(41112, '2017-08-05 11:19:17', NULL, NULL, 11726, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:19:17', 'admin-1501901672-15019031574249553', 1, 0, '', NULL, NULL, NULL),
(41113, '2017-08-05 11:19:17', NULL, NULL, 11726, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:19:17', 'admin-1501901672-15019031574249553', 1, 0, '', NULL, NULL, NULL),
(41114, '2017-08-05 11:19:10', NULL, NULL, 11726, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:19:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41115, '2017-08-05 11:00:02', NULL, NULL, 11725, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:00:02', 'admin-1501901672-15019020022816410', 1, 0, '', NULL, NULL, NULL),
(41116, '2017-08-05 10:58:18', NULL, NULL, 11724, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:58:18', 'admin-1501901672-15019018983298160', 1, 1, 'SR', NULL, NULL, NULL),
(41117, '2017-08-05 10:59:42', NULL, NULL, 11725, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:59:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41118, '2017-08-05 11:00:02', NULL, NULL, 11725, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 11:00:02', 'admin-1501901672-15019020022816410', 1, 0, '', NULL, NULL, NULL),
(41119, '2017-08-05 10:47:10', NULL, NULL, 11722, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:47:10', 'admin-1501898907-15019012304761182', 1, 0, '', NULL, NULL, NULL),
(41120, '2017-08-05 10:47:00', NULL, NULL, 11722, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:47:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41121, '2017-08-05 10:36:37', NULL, NULL, 11719, 0, 182, '117', 'Open Drinks ', 'milk', 'Cold Drinks', 'Fresh Juice', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:36:37', 'admin-1501898907-15019005974031427', 1, 0, '', NULL, NULL, NULL),
(41122, '2017-08-05 10:58:18', NULL, NULL, 11724, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:58:18', 'admin-1501901672-15019018983298160', 1, 0, '', NULL, NULL, NULL),
(41123, '2017-08-05 10:47:10', NULL, NULL, 11722, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:47:10', 'admin-1501898907-15019012304761182', 1, 0, '', NULL, NULL, NULL),
(41124, '2017-08-05 10:38:07', NULL, NULL, 11721, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:38:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41125, '2017-08-05 10:07:32', NULL, NULL, 11716, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:07:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41126, '2017-08-05 09:58:40', NULL, NULL, 11714, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:58:40', 'admin-1501896350-15018983197973746', 1, 0, '', NULL, NULL, NULL),
(41127, '2017-08-05 09:58:40', NULL, NULL, 11714, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:58:40', 'admin-1501896350-15018983197973746', 1, 1, 'SR', NULL, NULL, NULL),
(41128, '2017-08-05 10:01:07', NULL, NULL, 11715, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:01:07', 'admin-1501896350-15018984671344961', 1, 0, '', NULL, NULL, NULL),
(41129, '2017-08-05 10:01:07', NULL, NULL, 11715, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:01:07', 'admin-1501896350-15018984671344961', 1, 0, '', NULL, NULL, NULL),
(41130, '2017-08-05 10:05:53', NULL, NULL, 11711, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:05:53', 'admin-1501896350-15018987529278089', 1, 0, '', NULL, NULL, NULL),
(41131, '2017-08-05 17:11:43', NULL, NULL, 11764, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 17:11:43', 'admin-1501923116-15019243031379559', 1, 1, 'SR', NULL, NULL, NULL),
(41132, '2017-08-05 10:11:15', NULL, NULL, 11717, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:11:15', 'admin-1501898907-15018990750034373', 1, 0, '', NULL, NULL, NULL),
(41133, '2017-08-05 10:11:21', NULL, NULL, 11717, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:11:21', 'admin-1501898907-15018990814457228', 1, 0, '', NULL, NULL, NULL),
(41134, '2017-08-05 10:15:23', NULL, NULL, 11718, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:15:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41135, '2017-08-05 10:07:44', NULL, NULL, 11716, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:07:44', 'admin-1501896350-15018988644231995', 1, 0, '', NULL, NULL, NULL),
(41136, '2017-08-05 10:07:44', NULL, NULL, 11716, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:07:44', 'admin-1501896350-15018988644231995', 1, 1, 'SR', NULL, NULL, NULL),
(41137, '2017-08-05 10:11:08', NULL, NULL, 11717, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:11:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41138, '2017-08-05 12:23:32', NULL, NULL, 11734, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 12:23:32', 'admin-1501906887-15019070125015315', 1, 0, '', NULL, NULL, NULL),
(41139, '2017-08-05 10:11:15', NULL, NULL, 11717, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:11:15', 'admin-1501898907-15018990750034373', 1, 0, '', NULL, NULL, NULL),
(41140, '2017-08-05 09:58:40', NULL, NULL, 11714, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:58:40', 'admin-1501896350-15018983197973746', 1, 1, 'SR', NULL, NULL, NULL),
(41141, '2017-08-05 09:58:40', NULL, NULL, 11714, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:58:40', 'admin-1501896350-15018983197973746', 1, 1, 'SR', NULL, NULL, NULL),
(41142, '2017-08-05 09:26:15', NULL, NULL, 11710, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:26:15', 'admin-1501896350-15018963751705427', 1, 0, '', NULL, NULL, NULL),
(41143, '2017-08-05 09:58:40', NULL, NULL, 11714, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:58:40', 'admin-1501896350-15018983197973746', 1, 0, '', NULL, NULL, NULL),
(41144, '2017-08-05 10:00:43', NULL, NULL, 11715, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1501923116', 'admin', '2017-08-05 10:00:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41145, '2017-08-05 09:58:40', NULL, NULL, 11714, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:58:40', 'admin-1501896350-15018983197973746', 1, 0, '', NULL, NULL, NULL),
(41146, '2017-08-05 09:58:04', NULL, NULL, 11714, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:58:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41147, '2017-08-05 09:45:38', NULL, NULL, 11713, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:45:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41148, '2017-08-05 09:45:49', NULL, NULL, 11713, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:45:49', 'admin-1501896350-15018975494126354', 1, 0, '', NULL, NULL, NULL),
(41149, '2017-08-05 09:45:49', NULL, NULL, 11713, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:45:49', 'admin-1501896350-15018975494126354', 1, 0, '', NULL, NULL, NULL),
(41150, '2017-08-05 09:45:49', NULL, NULL, 11713, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:45:49', 'admin-1501896350-15018975494126354', 1, 1, 'SR', NULL, NULL, NULL),
(41151, '2017-08-05 09:45:49', NULL, NULL, 11713, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:45:49', 'admin-1501896350-15018975494126354', 1, 1, 'SR', NULL, NULL, NULL),
(41152, '2017-08-05 09:30:16', NULL, NULL, 11711, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:30:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41153, '2017-08-05 09:30:51', NULL, NULL, 11711, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:30:51', 'admin-1501896350-15018966516876795', 1, 0, '', NULL, NULL, NULL),
(41154, '2017-08-05 09:30:51', NULL, NULL, 11711, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:30:51', 'admin-1501896350-15018966516876795', 1, 0, '', NULL, NULL, NULL),
(41155, '2017-08-05 09:30:51', NULL, NULL, 11711, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:30:51', 'admin-1501896350-15018966516876795', 1, 1, 'SR', NULL, NULL, NULL),
(41156, '2017-08-05 09:30:51', NULL, NULL, 11711, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:30:51', 'admin-1501896350-15018966516876795', 1, 1, 'SR', NULL, NULL, NULL),
(41157, '2017-08-05 09:39:23', NULL, NULL, 11712, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:39:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41158, '2017-08-05 09:40:00', NULL, NULL, 11712, 0, 32, '32', 'Tea By Pot ', 'earl grey', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:40:00', 'admin-1501896350-15018972004625336', 1, 1, 'SR', NULL, NULL, NULL),
(41159, '2017-08-05 09:40:00', NULL, NULL, 11712, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:40:00', 'admin-1501896350-15018972004625336', 1, 1, 'SR', NULL, NULL, NULL),
(41160, '2017-08-05 09:40:00', NULL, NULL, 11712, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:40:00', 'admin-1501896350-15018972004625336', 1, 0, '', NULL, NULL, NULL),
(41161, '2017-08-05 09:26:15', NULL, NULL, 11710, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:26:15', 'admin-1501896350-15018963751705427', 1, 0, '', NULL, NULL, NULL),
(41162, '2017-08-05 09:26:15', NULL, NULL, 11710, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:26:15', 'admin-1501896350-15018963751705427', 1, 0, '', NULL, NULL, NULL),
(41163, '2017-08-05 09:25:58', NULL, NULL, 11710, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1501923116', 'admin', '2017-08-05 09:25:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41164, '2017-08-06 12:58:50', NULL, NULL, 11794, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:58:50', 'admin-1501993848-15019955301095142', 1, 1, 'SR', NULL, NULL, NULL),
(41165, '2017-08-06 12:58:50', NULL, NULL, 11794, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:58:50', 'admin-1501993848-15019955301095142', 1, 0, '', NULL, NULL, NULL),
(41166, '2017-08-06 12:59:07', NULL, NULL, 11795, 0, 182, '117', 'Open Drinks ', 'americano promo', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:59:07', 'admin-1501993848-15019955477152937', 1, 0, '', 1, NULL, NULL),
(41167, '2017-08-06 13:26:32', NULL, NULL, 11797, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:26:32', 'admin-1501993848-1501997192002568', 1, 0, '', NULL, NULL, NULL),
(41168, '2017-08-06 13:26:32', NULL, NULL, 11797, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:26:32', 'admin-1501993848-1501997192002568', 1, 1, 'SR', NULL, NULL, NULL),
(41169, '2017-08-06 13:26:32', NULL, NULL, 11797, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:26:32', 'admin-1501993848-1501997192002568', 1, 1, 'SR', NULL, NULL, NULL),
(41170, '2017-08-06 13:32:40', NULL, NULL, 11798, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:32:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41171, '2017-08-06 13:32:44', NULL, NULL, 11798, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:32:44', 'admin-1501993848-15019975637645614', 1, 1, 'SR', NULL, NULL, NULL),
(41172, '2017-08-06 13:45:00', NULL, NULL, 11792, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:45:00', 'admin-1501993848-1501998300277372', 1, 0, '', NULL, NULL, NULL),
(41173, '2017-08-06 13:45:00', NULL, NULL, 11792, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:45:00', 'admin-1501993848-1501998300277372', 1, 0, '', NULL, NULL, NULL),
(41174, '2017-08-06 12:57:43', NULL, NULL, 11793, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:57:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41175, '2017-08-06 12:57:54', NULL, NULL, 11793, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:57:54', 'admin-1501993848-15019954740174868', 1, 1, 'SR', NULL, NULL, NULL),
(41176, '2017-08-06 12:57:54', NULL, NULL, 11793, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:57:54', 'admin-1501993848-15019954740174868', 1, 0, '', NULL, NULL, NULL),
(41177, '2017-08-06 12:58:36', NULL, NULL, 11794, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:58:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41178, '2017-08-06 16:07:39', NULL, NULL, 11813, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 16:07:39', 'admin-1502000461-1502006858815917', 1, 1, 'SR', NULL, NULL, NULL),
(41179, '2017-08-06 16:19:51', NULL, NULL, 11815, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 16:19:51', 'admin-1502007576-15020075910421931', 1, 0, '', NULL, NULL, NULL),
(41180, '2017-08-06 16:19:26', NULL, NULL, 11815, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1502007576', 'admin', '2017-08-06 16:19:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41181, '2017-08-06 16:13:30', NULL, NULL, 11814, 0, 181, '116', 'Open Food ', 'pancake with ice cream', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 16:13:30', 'admin-1502000461-15020072106843295', 1, 0, '', NULL, NULL, '10.0'),
(41182, '2017-08-06 16:13:30', NULL, NULL, 11814, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 16:13:30', 'admin-1502000461-15020072106843295', 1, 0, '', NULL, NULL, '10.0'),
(41183, '2017-08-06 16:13:30', NULL, NULL, 11814, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 16:13:30', 'admin-1502000461-15020072106843295', 1, 1, 'SR', NULL, NULL, '10.0'),
(41184, '2017-08-06 14:07:22', NULL, NULL, 11800, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:07:22', 'admin-1501998678-1501999641955115', 1, 1, 'SR', NULL, NULL, NULL),
(41185, '2017-08-06 14:07:22', NULL, NULL, 11800, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:07:22', 'admin-1501998678-1501999641955115', 1, 0, '', NULL, NULL, NULL),
(41186, '2017-08-06 15:46:50', NULL, NULL, 11810, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 15:46:50', 'admin-1502000461-15020056098127042', 1, 1, 'SR', NULL, NULL, NULL),
(41187, '2017-08-06 15:47:27', NULL, NULL, 11811, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1502007576', 'admin', '2017-08-06 15:47:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41188, '2017-08-06 15:47:35', NULL, NULL, 11811, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 15:47:35', 'admin-1502000461-15020056554082196', 1, 0, '', NULL, NULL, NULL),
(41189, '2017-08-06 15:07:21', NULL, NULL, 11809, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 15:07:21', 'admin-1502000461-15020032411984333', 1, 1, 'SR', NULL, NULL, NULL),
(41190, '2017-08-06 13:53:47', NULL, NULL, 11799, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:53:47', 'admin-1501998678-15019988276491192', 1, 1, 'SR', NULL, NULL, NULL),
(41191, '2017-08-06 13:53:47', NULL, NULL, 11799, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:53:47', 'admin-1501998678-15019988276491192', 1, 1, 'SR', NULL, NULL, NULL),
(41192, '2017-08-06 13:08:13', NULL, NULL, 11796, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:08:13', 'admin-1501993848-15019960931195790', 1, 0, '', NULL, NULL, NULL),
(41193, '2017-08-06 13:08:13', NULL, NULL, 11796, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:08:13', 'admin-1501993848-15019960931195790', 1, 0, '', NULL, NULL, NULL),
(41194, '2017-08-06 16:07:39', NULL, NULL, 11813, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 16:07:39', 'admin-1502000461-1502006858815917', 1, 1, 'SR', NULL, NULL, NULL),
(41195, '2017-08-06 15:33:43', NULL, NULL, 11807, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 15:33:43', 'admin-1502000461-15020048236665213', 1, 1, 'SR', NULL, NULL, NULL),
(41196, '2017-08-06 15:46:40', NULL, NULL, 11810, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1502007576', 'admin', '2017-08-06 15:46:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41197, '2017-08-06 14:23:15', NULL, NULL, 11804, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:23:15', 'admin-1502000461-15020005955937215', 1, 0, '', NULL, NULL, NULL),
(41198, '2017-08-06 13:26:32', NULL, NULL, 11797, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:26:32', 'admin-1501993848-1501997192002568', 1, 0, '', NULL, NULL, NULL),
(41199, '2017-08-06 16:07:18', NULL, NULL, 11813, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1502007576', 'admin', '2017-08-06 16:07:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41200, '2017-08-06 16:06:03', NULL, NULL, 11812, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 16:06:03', 'admin-1502000461-15020067632395397', 1, 1, 'SR', NULL, NULL, NULL),
(41201, '2017-08-06 16:06:00', NULL, NULL, 11812, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1502007576', 'admin', '2017-08-06 16:06:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41202, '2017-08-06 15:47:35', NULL, NULL, 11811, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 15:47:35', 'admin-1502000461-15020056554082196', 1, 1, 'SR', NULL, NULL, NULL),
(41203, '2017-08-06 14:19:47', NULL, NULL, 11802, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:19:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41204, '2017-08-06 14:45:41', NULL, NULL, 11807, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:45:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41205, '2017-08-06 14:45:46', NULL, NULL, 11807, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:45:46', 'admin-1502000461-15020019460665318', 1, 1, 'SR', NULL, NULL, NULL),
(41206, '2017-08-06 14:55:02', NULL, NULL, 11803, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:55:02', 'admin-1502000461-15020025021955959', 1, 1, 'SR', NULL, NULL, NULL),
(41207, '2017-08-06 14:55:17', NULL, NULL, 11808, 0, 182, '117', 'Open Drinks ', 'americano promo', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:55:17', 'admin-1502000461-15020025169244028', 1, 0, '', 1, NULL, NULL),
(41208, '2017-08-06 12:52:30', NULL, NULL, 11792, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:52:30', 'admin-1501993848-15019951503436652', 1, 1, 'SR', NULL, NULL, NULL),
(41209, '2017-08-06 12:48:11', NULL, NULL, 11788, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:48:11', 'admin-1501993848-15019948911623691', 1, 1, 'SR', NULL, NULL, NULL),
(41210, '2017-08-06 12:48:11', NULL, NULL, 11788, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:48:11', 'admin-1501993848-15019948911623691', 1, 1, 'SR', NULL, NULL, NULL),
(41211, '2017-08-06 15:07:12', NULL, NULL, 11809, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1502007576', 'admin', '2017-08-06 15:07:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41212, '2017-08-06 15:07:21', NULL, NULL, 11809, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 15:07:21', 'admin-1502000461-15020032411984333', 1, 1, 'SR', NULL, NULL, NULL),
(41213, '2017-08-06 14:20:54', NULL, NULL, 11803, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:20:54', 'admin-1501998678-15020004547512037', 1, 1, 'SR', NULL, NULL, NULL),
(41214, '2017-08-06 14:20:54', NULL, NULL, 11803, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:20:54', 'admin-1501998678-15020004547512037', 1, 0, '', NULL, NULL, NULL),
(41215, '2017-08-06 14:21:19', NULL, NULL, 11803, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:21:19', 'admin-1502000461-15020004796194655', 1, 1, 'SR', NULL, NULL, NULL),
(41216, '2017-08-06 10:45:06', NULL, NULL, 11777, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:45:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41217, '2017-08-06 10:45:15', NULL, NULL, 11777, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:45:15', 'admin-1501987066-15019875154241077', 1, 0, '', NULL, NULL, NULL),
(41218, '2017-08-06 10:45:15', NULL, NULL, 11777, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:45:15', 'admin-1501987066-15019875154241077', 1, 0, '', NULL, NULL, NULL),
(41219, '2017-08-06 10:45:32', NULL, NULL, 11777, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:45:32', 'admin-1501987066-1501987532429168', 1, 1, 'SR', NULL, NULL, NULL),
(41220, '2017-08-06 10:45:32', NULL, NULL, 11777, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:45:32', 'admin-1501987066-1501987532429168', 1, 1, 'SR', NULL, NULL, NULL),
(41221, '2017-08-06 10:58:14', NULL, NULL, 11778, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:58:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41222, '2017-08-06 10:58:22', NULL, NULL, 11778, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:58:22', 'admin-1501987066-15019883021954784', 1, 0, '', NULL, NULL, NULL),
(41223, '2017-08-06 12:52:52', NULL, NULL, 11792, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:52:52', 'admin-1501993848-15019951721356961', 1, 1, 'SR', NULL, NULL, NULL),
(41224, '2017-08-06 12:52:52', NULL, NULL, 11792, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:52:52', 'admin-1501993848-15019951721356961', 1, 0, '', NULL, NULL, NULL),
(41225, '2017-08-06 12:52:30', NULL, NULL, 11792, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:52:30', 'admin-1501993848-15019951503436652', 1, 1, 'SR', NULL, NULL, NULL),
(41226, '2017-08-06 12:52:30', NULL, NULL, 11792, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:52:30', 'admin-1501993848-15019951503436652', 1, 0, '', NULL, NULL, NULL),
(41227, '2017-08-06 14:39:10', NULL, NULL, 11806, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:39:10', 'admin-1502000461-15020015506699745', 1, 1, 'SR', NULL, NULL, NULL),
(41228, '2017-08-06 16:07:39', NULL, NULL, 11813, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 16:07:39', 'admin-1502000461-1502006858815917', 1, 0, '', NULL, NULL, NULL),
(41229, '2017-08-06 14:39:10', NULL, NULL, 11806, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:39:10', 'admin-1502000461-15020015506699745', 1, 0, '', NULL, NULL, NULL),
(41230, '2017-08-06 14:39:10', NULL, NULL, 11806, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:39:10', 'admin-1502000461-15020015506699745', 1, 0, '', NULL, NULL, NULL),
(41231, '2017-08-06 10:37:29', NULL, NULL, 11773, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:37:29', 'admin-1501985608-15019870489492137', 1, 0, '', NULL, NULL, NULL),
(41232, '2017-08-06 14:38:30', NULL, NULL, 11806, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:38:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41233, '2017-08-06 14:36:52', NULL, NULL, 11799, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:36:52', 'admin-1502000461-15020014122526380', 1, 1, 'SR', NULL, NULL, NULL),
(41234, '2017-08-06 14:27:40', NULL, NULL, 11805, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:27:40', 'admin-1502000461-15020008602567415', 1, 1, 'SR', NULL, NULL, NULL),
(41235, '2017-08-06 14:27:13', NULL, NULL, 11805, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:27:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41236, '2017-08-06 14:27:40', NULL, NULL, 11805, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:27:40', 'admin-1502000461-15020008602567415', 1, 0, '', NULL, NULL, NULL),
(41237, '2017-08-06 14:07:51', NULL, NULL, 11800, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:07:51', 'admin-1501998678-15019996707984519', 1, 1, 'SR', NULL, NULL, NULL),
(41238, '2017-08-06 14:07:51', NULL, NULL, 11800, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:07:51', 'admin-1501998678-15019996707984519', 1, 1, 'SR', NULL, NULL, NULL),
(41239, '2017-08-06 14:07:51', NULL, NULL, 11800, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:07:51', 'admin-1501998678-15019996707984519', 1, 1, 'SR', NULL, NULL, NULL),
(41240, '2017-08-06 14:07:51', NULL, NULL, 11800, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:07:51', 'admin-1501998678-15019996707984519', 1, 0, '', NULL, NULL, NULL),
(41241, '2017-08-06 14:11:15', NULL, NULL, 11801, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:11:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41242, '2017-08-06 14:11:47', NULL, NULL, 11801, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:11:47', 'admin-1501998678-15019999072225969', 1, 1, 'SR', NULL, NULL, NULL),
(41243, '2017-08-06 14:11:47', NULL, NULL, 11801, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:11:47', 'admin-1501998678-15019999072225969', 1, 1, 'SR', NULL, NULL, NULL),
(41244, '2017-08-06 14:11:47', NULL, NULL, 11801, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:11:47', 'admin-1501998678-15019999072225969', 1, 1, 'SR', NULL, NULL, NULL),
(41245, '2017-08-06 14:14:15', NULL, NULL, 11800, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:14:15', 'admin-1501998678-15020000554119113', 1, 1, 'SR', NULL, NULL, NULL),
(41246, '2017-08-06 14:07:22', NULL, NULL, 11800, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:07:22', 'admin-1501998678-1501999641955115', 1, 0, '', NULL, NULL, NULL),
(41247, '2017-08-06 14:07:22', NULL, NULL, 11800, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:07:22', 'admin-1501998678-1501999641955115', 1, 0, '', NULL, NULL, NULL),
(41248, '2017-08-06 14:07:51', NULL, NULL, 11800, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:07:51', 'admin-1501998678-15019996707984519', 1, 1, 'SR', NULL, NULL, NULL),
(41249, '2017-08-06 14:21:19', NULL, NULL, 11803, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:21:19', 'admin-1502000461-15020004796194655', 1, 0, '', NULL, NULL, NULL),
(41250, '2017-08-06 14:20:10', NULL, NULL, 11802, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:20:10', 'admin-1501998678-15020004098322769', 1, 1, 'SR', NULL, NULL, NULL),
(41251, '2017-08-06 11:54:02', NULL, NULL, 11784, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:54:02', 'admin-1501990006-15019916420723865', 1, 1, 'SR', NULL, NULL, NULL),
(41252, '2017-08-06 12:40:05', NULL, NULL, 11791, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:40:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41253, '2017-08-06 13:09:03', NULL, NULL, 11796, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:09:03', 'admin-1501993848-15019961437142566', 1, 1, 'SR', NULL, NULL, NULL),
(41254, '2017-08-06 14:20:10', NULL, NULL, 11802, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:20:10', 'admin-1501998678-15020004098322769', 1, 0, '', NULL, NULL, NULL),
(41255, '2017-08-06 14:07:22', NULL, NULL, 11800, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:07:22', 'admin-1501998678-1501999641955115', 1, 0, '', NULL, NULL, NULL),
(41256, '2017-08-06 14:07:51', NULL, NULL, 11800, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:07:51', 'admin-1501998678-15019996707984519', 1, 1, 'SR', NULL, NULL, NULL),
(41257, '2017-08-06 12:20:14', NULL, NULL, 11788, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:20:14', 'admin-1501990006-15019932147034856', 1, 1, 'SR', NULL, NULL, NULL),
(41258, '2017-08-06 11:18:08', NULL, NULL, 11773, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:18:08', 'admin-1501987066-15019894877527382', 1, 0, '', NULL, NULL, NULL),
(41259, '2017-08-06 13:09:03', NULL, NULL, 11796, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:09:03', 'admin-1501993848-15019961437142566', 1, 1, 'SR', NULL, NULL, NULL),
(41260, '2017-08-06 14:20:32', NULL, NULL, 11803, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:20:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41261, '2017-08-06 16:12:51', NULL, NULL, 11814, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1502007576', 'admin', '2017-08-06 16:12:51', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(41262, '2017-08-06 12:04:20', NULL, NULL, 11786, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:04:20', 'admin-1501990006-1501992260223924', 1, 1, 'SR', NULL, NULL, NULL),
(41263, '2017-08-06 12:04:20', NULL, NULL, 11786, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:04:20', 'admin-1501990006-1501992260223924', 1, 1, 'SR', NULL, NULL, NULL),
(41264, '2017-08-06 12:09:54', NULL, NULL, 11787, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:09:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41265, '2017-08-06 12:10:34', NULL, NULL, 11787, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:10:34', 'admin-1501990006-15019926342146941', 1, 0, '', NULL, NULL, NULL),
(41266, '2017-08-06 12:10:34', NULL, NULL, 11787, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:10:34', 'admin-1501990006-15019926342146941', 1, 0, '', NULL, NULL, NULL),
(41267, '2017-08-06 11:53:46', NULL, NULL, 11784, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:53:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41268, '2017-08-06 11:58:17', NULL, NULL, 11785, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:58:17', 'admin-1501990006-15019918971903660', 1, 1, 'SR', NULL, NULL, NULL),
(41269, '2017-08-06 11:58:17', NULL, NULL, 11785, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:58:17', 'admin-1501990006-15019918971903660', 1, 1, 'SR', NULL, NULL, NULL),
(41270, '2017-08-06 14:36:52', NULL, NULL, 11799, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:36:52', 'admin-1502000461-15020014122526380', 1, 1, 'SR', NULL, NULL, NULL),
(41271, '2017-08-06 10:37:29', NULL, NULL, 11773, 0, 156, '90', 'House Cheddar Omelet', 'Bacon', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:37:29', 'admin-1501985608-15019870489492137', 1, 0, '', NULL, NULL, NULL),
(41272, '2017-08-06 10:38:00', NULL, NULL, 11773, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:38:00', 'admin-1501987066-15019870804631485', 1, 1, 'SR', NULL, NULL, NULL),
(41273, '2017-08-06 14:07:51', NULL, NULL, 11800, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:07:51', 'admin-1501998678-15019996707984519', 1, 1, 'SR', NULL, NULL, NULL),
(41274, '2017-08-06 13:51:08', NULL, NULL, 11799, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:51:08', 'admin-1501993848-15019986685613490', 1, 1, 'SR', NULL, NULL, NULL),
(41275, '2017-08-06 13:53:02', NULL, NULL, 11799, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:53:02', 'admin-1501998678-15019987820335864', 1, 0, '', NULL, NULL, NULL),
(41276, '2017-08-06 12:31:15', NULL, NULL, 11790, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:31:15', 'admin-1501993848-15019938750841039', 1, 1, 'SR', NULL, NULL, NULL),
(41277, '2017-08-06 12:31:15', NULL, NULL, 11790, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:31:15', 'admin-1501993848-15019938750841039', 1, 1, 'SR', NULL, NULL, NULL),
(41278, '2017-08-06 12:34:42', NULL, NULL, 11783, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:34:42', 'admin-1501993848-15019940819761439', 1, 0, '', NULL, NULL, NULL),
(41279, '2017-08-06 14:07:22', NULL, NULL, 11800, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:07:22', 'admin-1501998678-1501999641955115', 1, 1, 'SR', NULL, NULL, NULL),
(41280, '2017-08-06 14:07:22', NULL, NULL, 11800, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:07:22', 'admin-1501998678-1501999641955115', 1, 0, '', NULL, NULL, NULL),
(41281, '2017-08-06 13:50:48', NULL, NULL, 11799, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.50, 0.0000, 0.0000, 10.50, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:50:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41282, '2017-08-06 13:51:08', NULL, NULL, 11799, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:51:08', 'admin-1501993848-15019986685613490', 1, 1, 'SR', NULL, NULL, NULL),
(41283, '2017-08-06 13:53:02', NULL, NULL, 11799, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:53:02', 'admin-1501998678-15019987820335864', 1, 0, '', NULL, NULL, NULL),
(41284, '2017-08-06 13:45:00', NULL, NULL, 11792, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:45:00', 'admin-1501993848-1501998300277372', 1, 0, '', NULL, NULL, NULL),
(41285, '2017-08-06 13:26:05', NULL, NULL, 11797, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:26:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41286, '2017-08-06 16:13:30', NULL, NULL, 11814, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 16:13:30', 'admin-1502000461-15020072106843295', 1, 1, 'SR', NULL, NULL, '10.0'),
(41287, '2017-08-06 13:08:13', NULL, NULL, 11796, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:08:13', 'admin-1501993848-15019960931195790', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(41288, '2017-08-06 13:08:13', NULL, NULL, 11796, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:08:13', 'admin-1501993848-15019960931195790', 1, 1, 'SR', NULL, NULL, NULL),
(41289, '2017-08-06 13:08:13', NULL, NULL, 11796, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:08:13', 'admin-1501993848-15019960931195790', 1, 0, '', NULL, NULL, NULL),
(41290, '2017-08-06 13:08:13', NULL, NULL, 11796, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:08:13', 'admin-1501993848-15019960931195790', 1, 0, '', NULL, NULL, NULL),
(41291, '2017-08-06 14:06:47', NULL, NULL, 11800, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 20.40, 0.0000, 0.0000, 20.40, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:06:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41292, '2017-08-06 13:09:03', NULL, NULL, 11796, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:09:03', 'admin-1501993848-15019961437142566', 1, 1, 'SR', NULL, NULL, NULL),
(41293, '2017-08-06 13:09:03', NULL, NULL, 11796, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:09:03', 'admin-1501993848-15019961437142566', 1, 1, 'SR', NULL, NULL, NULL),
(41294, '2017-08-06 13:09:03', NULL, NULL, 11796, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:09:03', 'admin-1501993848-15019961437142566', 1, 1, 'SR', NULL, NULL, NULL),
(41295, '2017-08-06 11:18:25', NULL, NULL, 11780, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:18:25', 'admin-1501987066-1501989505196179', 1, 0, '', NULL, NULL, NULL),
(41296, '2017-08-06 11:26:16', NULL, NULL, 11781, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:26:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41297, '2017-08-06 11:26:37', NULL, NULL, 11781, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:26:37', 'admin-1501987066-15019899973174523', 1, 0, '', NULL, NULL, NULL),
(41298, '2017-08-06 11:26:37', NULL, NULL, 11781, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:26:37', 'admin-1501987066-15019899973174523', 1, 0, '', NULL, NULL, NULL),
(41299, '2017-08-06 11:26:37', NULL, NULL, 11781, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:26:37', 'admin-1501987066-15019899973174523', 1, 1, 'SR', NULL, NULL, NULL),
(41300, '2017-08-06 14:23:04', NULL, NULL, 11804, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:23:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41301, '2017-08-06 13:09:03', NULL, NULL, 11796, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:09:03', 'admin-1501993848-15019961437142566', 1, 0, '', NULL, NULL, NULL),
(41302, '2017-08-06 13:07:32', NULL, NULL, 11796, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.60, 0.0000, 0.0000, 15.60, 1, '27', 1, '1502007576', 'admin', '2017-08-06 13:07:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41303, '2017-08-06 12:30:43', NULL, NULL, 11790, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:30:43', 'admin-1501990006-15019938432228368', 1, 0, '', NULL, NULL, NULL),
(41304, '2017-08-06 12:30:43', NULL, NULL, 11790, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:30:43', 'admin-1501990006-15019938432228368', 1, 0, '', NULL, NULL, NULL),
(41305, '2017-08-06 12:31:15', NULL, NULL, 11790, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:31:15', 'admin-1501993848-15019938750841039', 1, 1, 'SR', NULL, NULL, NULL),
(41306, '2017-08-06 12:52:52', NULL, NULL, 11792, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:52:52', 'admin-1501993848-15019951721356961', 1, 1, 'SR', NULL, NULL, NULL),
(41307, '2017-08-06 12:52:09', NULL, NULL, 11792, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.90, 0.0000, 0.0000, 9.90, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:52:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41308, '2017-08-06 11:58:07', NULL, NULL, 11785, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:58:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41309, '2017-08-06 11:54:02', NULL, NULL, 11784, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:54:02', 'admin-1501990006-15019916420723865', 1, 0, '', NULL, NULL, NULL),
(41310, '2017-08-06 12:40:27', NULL, NULL, 11791, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:40:27', 'admin-1501993848-15019944271138751', 1, 1, 'SR', NULL, NULL, NULL),
(41311, '2017-08-06 12:40:27', NULL, NULL, 11791, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:40:27', 'admin-1501993848-15019944271138751', 1, 1, 'SR', NULL, NULL, NULL),
(41312, '2017-08-06 11:45:16', NULL, NULL, 11782, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:45:16', 'admin-1501990006-15019911161978074', 1, 0, '', NULL, NULL, NULL),
(41313, '2017-08-06 11:45:16', NULL, NULL, 11782, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:45:16', 'admin-1501990006-15019911161978074', 1, 0, '', NULL, NULL, NULL),
(41314, '2017-08-06 11:53:35', NULL, NULL, 11783, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:53:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41315, '2017-08-06 11:53:41', NULL, NULL, 11783, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:53:41', 'admin-1501990006-1501991620847630', 1, 0, '', NULL, NULL, NULL),
(41316, '2017-08-06 12:30:43', NULL, NULL, 11790, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:30:43', 'admin-1501990006-15019938432228368', 1, 0, '', NULL, NULL, NULL),
(41317, '2017-08-06 11:18:07', NULL, NULL, 11773, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:18:08', 'admin-1501987066-15019894877527382', 1, 0, '', NULL, NULL, NULL),
(41318, '2017-08-06 12:24:20', NULL, NULL, 11788, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:24:20', 'admin-1501990006-15019934598141739', 1, 1, 'SR', NULL, NULL, NULL),
(41319, '2017-08-06 12:26:45', NULL, NULL, 11789, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:26:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41320, '2017-08-06 12:27:28', NULL, NULL, 11789, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:27:28', 'admin-1501990006-15019936487465770', 1, 0, '', NULL, NULL, NULL),
(41321, '2017-08-06 12:27:28', NULL, NULL, 11789, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:27:28', 'admin-1501990006-15019936487465770', 1, 1, 'SR', NULL, NULL, NULL),
(41322, '2017-08-06 12:30:43', NULL, NULL, 11790, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:30:43', 'admin-1501990006-15019938432228368', 1, 0, '', NULL, NULL, NULL),
(41323, '2017-08-06 12:31:15', NULL, NULL, 11790, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:31:15', 'admin-1501993848-15019938750841039', 1, 0, '', NULL, NULL, NULL),
(41324, '2017-08-06 10:21:37', NULL, NULL, 11773, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:21:37', 'admin-1501985608-15019860970414431', 1, 0, '', NULL, NULL, NULL),
(41325, '2017-08-06 12:30:43', NULL, NULL, 11790, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:30:43', 'admin-1501990006-15019938432228368', 1, 0, '', NULL, NULL, NULL),
(41326, '2017-08-06 12:30:43', NULL, NULL, 11790, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:30:43', 'admin-1501990006-15019938432228368', 1, 0, '', NULL, NULL, NULL),
(41327, '2017-08-06 12:30:43', NULL, NULL, 11790, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:30:43', 'admin-1501990006-15019938432228368', 1, 0, '', NULL, NULL, NULL),
(41328, '2017-08-06 12:30:16', NULL, NULL, 11790, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.10, 0.0000, 0.0000, 13.10, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:30:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41329, '2017-08-06 12:27:45', NULL, NULL, 11789, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:27:45', 'admin-1501990006-15019936653681281', 1, 1, 'SR', NULL, NULL, NULL),
(41330, '2017-08-06 12:24:20', NULL, NULL, 11788, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:24:20', 'admin-1501990006-15019934598141739', 1, 1, 'SR', NULL, NULL, NULL),
(41331, '2017-08-06 16:19:51', NULL, NULL, 11815, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 16:19:51', 'admin-1502007576-15020075910421931', 1, 0, '', NULL, NULL, NULL),
(41332, '2017-08-06 14:23:15', NULL, NULL, 11804, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:23:15', 'admin-1502000461-15020005955937215', 1, 0, '', NULL, NULL, NULL),
(41333, '2017-08-06 14:22:39', NULL, NULL, 11802, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:22:39', 'admin-1502000461-1502000558935131', 1, 0, '', NULL, NULL, NULL),
(41334, '2017-08-06 10:21:37', NULL, NULL, 11773, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:21:37', 'admin-1501985608-15019860970414431', 1, 1, 'SR', NULL, NULL, NULL),
(41335, '2017-08-06 12:30:43', NULL, NULL, 11790, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:30:43', 'admin-1501990006-15019938432228368', 1, 1, 'SR', NULL, NULL, NULL),
(41336, '2017-08-06 12:20:14', NULL, NULL, 11788, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:20:14', 'admin-1501990006-15019932147034856', 1, 1, 'SR', NULL, NULL, NULL),
(41337, '2017-08-06 10:58:22', NULL, NULL, 11778, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:58:22', 'admin-1501987066-15019883021954784', 1, 1, 'SR', NULL, NULL, NULL),
(41338, '2017-08-06 11:02:50', NULL, NULL, 11779, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:02:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41339, '2017-08-06 11:03:11', NULL, NULL, 11779, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:03:11', 'admin-1501987066-15019885913106817', 1, 1, 'SR', NULL, NULL, NULL),
(41340, '2017-08-06 11:03:11', NULL, NULL, 11779, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:03:11', 'admin-1501987066-15019885913106817', 1, 1, 'SR', NULL, NULL, NULL),
(41341, '2017-08-06 14:39:10', NULL, NULL, 11806, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:39:10', 'admin-1502000461-15020015506699745', 1, 1, 'SR', NULL, NULL, NULL),
(41342, '2017-08-06 12:20:00', NULL, NULL, 11788, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:20:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41343, '2017-08-06 12:10:34', NULL, NULL, 11787, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:10:34', 'admin-1501990006-15019926342146941', 1, 1, 'SR', NULL, NULL, NULL),
(41344, '2017-08-06 12:10:34', NULL, NULL, 11787, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:10:34', 'admin-1501990006-15019926342146941', 1, 1, 'SR', NULL, NULL, NULL),
(41345, '2017-08-06 12:10:34', NULL, NULL, 11787, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:10:34', 'admin-1501990006-15019926342146941', 1, 0, '', NULL, NULL, NULL),
(41346, '2017-08-06 12:03:27', NULL, NULL, 11786, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1502007576', 'admin', '2017-08-06 12:03:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41347, '2017-08-06 11:54:02', NULL, NULL, 11784, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:54:02', 'admin-1501990006-15019916420723865', 1, 0, '', NULL, NULL, NULL),
(41348, '2017-08-06 11:28:41', NULL, NULL, 11773, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:28:41', 'admin-1501990006-15019901208773118', 1, 0, '', NULL, NULL, NULL),
(41349, '2017-08-06 11:45:02', NULL, NULL, 11782, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:45:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41350, '2017-08-06 10:26:17', NULL, NULL, 11774, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:26:17', 'admin-1501985608-15019863773653615', 1, 0, '', NULL, NULL, NULL),
(41351, '2017-08-06 10:29:44', NULL, NULL, 11775, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:29:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41352, '2017-08-06 10:29:53', NULL, NULL, 11775, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:29:53', 'admin-1501985608-15019865933395289', 1, 0, '', NULL, NULL, NULL),
(41353, '2017-08-06 10:29:53', NULL, NULL, 11775, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:29:53', 'admin-1501985608-15019865933395289', 1, 0, '', NULL, NULL, NULL),
(41354, '2017-08-06 10:29:53', NULL, NULL, 11775, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:29:53', 'admin-1501985608-15019865933395289', 1, 0, '', NULL, NULL, NULL),
(41355, '2017-08-06 10:29:53', NULL, NULL, 11775, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:29:53', 'admin-1501985608-15019865933395289', 1, 0, '', NULL, NULL, NULL),
(41356, '2017-08-06 10:32:59', NULL, NULL, 11775, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:32:59', 'admin-1501985608-15019867789852675', 1, 1, 'SR', NULL, NULL, NULL),
(41357, '2017-08-06 10:34:22', NULL, NULL, 11776, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:34:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41358, '2017-08-06 10:34:32', NULL, NULL, 11776, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:34:32', 'admin-1501985608-15019868725052956', 1, 0, '', NULL, NULL, NULL),
(41359, '2017-08-06 10:34:32', NULL, NULL, 11776, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:34:32', 'admin-1501985608-15019868725052956', 1, 0, '', NULL, NULL, NULL),
(41360, '2017-08-06 10:34:53', NULL, NULL, 11776, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:34:53', 'admin-1501985608-15019868935575996', 1, 0, '', NULL, NULL, NULL),
(41361, '2017-08-06 10:34:53', NULL, NULL, 11776, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:34:53', 'admin-1501985608-15019868935575996', 1, 1, 'SR', NULL, NULL, NULL),
(41362, '2017-08-06 14:20:10', NULL, NULL, 11802, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 14:20:10', 'admin-1501998678-15020004098322769', 1, 0, '', NULL, NULL, NULL),
(41363, '2017-08-06 11:05:01', NULL, NULL, 11780, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:05:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41364, '2017-08-06 11:05:08', NULL, NULL, 11780, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:05:08', 'admin-1501987066-15019887083159913', 1, 0, '', NULL, NULL, NULL),
(41365, '2017-08-06 11:05:08', NULL, NULL, 11780, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:05:08', 'admin-1501987066-15019887083159913', 1, 0, '', NULL, NULL, NULL),
(41366, '2017-08-06 10:21:37', NULL, NULL, 11773, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:21:37', 'admin-1501985608-15019860970414431', 1, 1, 'SR', NULL, NULL, NULL),
(41367, '2017-08-06 11:03:11', NULL, NULL, 11779, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 11:03:11', 'admin-1501987066-15019885913106817', 1, 0, '', NULL, NULL, NULL),
(41368, '2017-08-06 09:29:19', NULL, NULL, 11771, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:29:19', 'admin-1501981868-15019829595689294', 1, 1, 'SR', NULL, NULL, NULL),
(41369, '2017-08-06 10:26:03', NULL, NULL, 11774, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:26:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41370, '2017-08-06 10:08:35', NULL, NULL, 11772, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:08:35', 'admin-1501981868-15019853157658134', 1, 0, '', NULL, NULL, NULL),
(41371, '2017-08-06 10:08:35', NULL, NULL, 11772, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:08:35', 'admin-1501981868-15019853157658134', 1, 1, 'SR', NULL, NULL, NULL),
(41372, '2017-08-06 10:21:19', NULL, NULL, 11773, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 17.10, 0.0000, 0.0000, 17.10, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:21:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41373, '2017-08-06 10:07:21', NULL, NULL, 11767, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:07:21', 'admin-1501981868-1501985240881219', 1, 0, '', NULL, NULL, NULL),
(41374, '2017-08-06 10:08:25', NULL, NULL, 11772, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:08:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41375, '2017-08-06 10:08:35', NULL, NULL, 11772, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:08:35', 'admin-1501981868-15019853157658134', 1, 0, '', NULL, NULL, NULL),
(41376, '2017-08-06 15:46:50', NULL, NULL, 11810, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 15:46:50', 'admin-1502000461-15020056098127042', 1, 1, 'SR', NULL, NULL, NULL),
(41377, '2017-08-06 10:38:00', NULL, NULL, 11773, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:38:00', 'admin-1501987066-15019870804631485', 1, 1, 'SR', NULL, NULL, NULL),
(41378, '2017-08-06 10:21:37', NULL, NULL, 11773, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:21:37', 'admin-1501985608-15019860970414431', 1, 0, '', NULL, NULL, NULL),
(41379, '2017-08-06 10:21:37', NULL, NULL, 11773, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:21:37', 'admin-1501985608-15019860970414431', 1, 0, '', NULL, NULL, NULL),
(41380, '2017-08-06 10:34:53', NULL, NULL, 11776, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:34:53', 'admin-1501985608-15019868935575996', 1, 1, 'SR', NULL, NULL, NULL),
(41381, '2017-08-06 10:26:17', NULL, NULL, 11774, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:26:17', 'admin-1501985608-15019863773653615', 1, 0, '', NULL, NULL, NULL),
(41382, '2017-08-06 10:26:17', NULL, NULL, 11774, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:26:17', 'admin-1501985608-15019863773653615', 1, 0, '', NULL, NULL, NULL),
(41383, '2017-08-06 10:21:37', NULL, NULL, 11773, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:21:37', 'admin-1501985608-15019860970414431', 1, 1, 'SR', NULL, NULL, NULL),
(41384, '2017-08-06 09:29:11', NULL, NULL, 11771, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:29:11', 'admin-1501981868-15019829508756768', 1, 0, '', NULL, NULL, NULL),
(41385, '2017-08-06 09:29:11', NULL, NULL, 11771, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:29:11', 'admin-1501981868-15019829508756768', 1, 0, '', NULL, NULL, NULL),
(41386, '2017-08-06 10:21:37', NULL, NULL, 11773, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 10:21:37', 'admin-1501985608-15019860970414431', 1, 0, '', NULL, NULL, NULL),
(41387, '2017-08-06 09:15:12', NULL, NULL, 11768, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:15:12', 'admin-1501981868-1501982112814211', 1, 0, '', NULL, NULL, NULL),
(41388, '2017-08-06 09:11:34', NULL, NULL, 11767, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:11:34', 'admin-1501981868-15019818944753744', 1, 0, '', NULL, NULL, NULL),
(41389, '2017-08-06 09:11:34', NULL, NULL, 11767, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:11:34', 'admin-1501981868-15019818944753744', 1, 0, '', NULL, NULL, NULL),
(41390, '2017-08-06 09:11:42', NULL, NULL, 11767, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:11:42', 'admin-1501981868-15019819022594287', 1, 1, 'SR', NULL, NULL, NULL),
(41391, '2017-08-06 09:29:19', NULL, NULL, 11771, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:29:19', 'admin-1501981868-15019829595689294', 1, 0, '', NULL, NULL, NULL),
(41392, '2017-08-06 09:15:02', NULL, NULL, 11768, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:15:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41393, '2017-08-06 09:15:12', NULL, NULL, 11768, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:15:12', 'admin-1501981868-1501982112814211', 1, 0, '', NULL, NULL, NULL),
(41394, '2017-08-06 09:29:05', NULL, NULL, 11771, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:29:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41395, '2017-08-06 09:27:46', NULL, NULL, 11770, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:27:46', 'admin-1501981868-150198286633393', 1, 1, 'SR', NULL, NULL, NULL),
(41396, '2017-08-06 09:27:46', NULL, NULL, 11770, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:27:46', 'admin-1501981868-150198286633393', 1, 0, '', NULL, NULL, NULL),
(41397, '2017-08-06 09:27:46', NULL, NULL, 11770, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:27:46', 'admin-1501981868-150198286633393', 1, 0, '', NULL, NULL, NULL),
(41398, '2017-08-06 09:27:29', NULL, NULL, 11770, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:27:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41399, '2017-08-06 09:23:04', NULL, NULL, 11769, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:23:04', 'admin-1501981868-15019825847799187', 1, 1, 'SR', NULL, NULL, NULL),
(41400, '2017-08-06 09:23:04', NULL, NULL, 11769, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:23:04', 'admin-1501981868-15019825847799187', 1, 0, '', NULL, NULL, NULL),
(41401, '2017-08-06 09:22:52', NULL, NULL, 11769, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:22:52', 'admin-1501981868-1501982572237256', 1, 0, '', NULL, NULL, NULL),
(41402, '2017-08-06 09:22:52', NULL, NULL, 11769, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:22:52', 'admin-1501981868-1501982572237256', 1, 0, '', NULL, NULL, NULL),
(41403, '2017-08-06 09:22:52', NULL, NULL, 11769, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:22:52', 'admin-1501981868-1501982572237256', 1, 0, '', NULL, NULL, NULL),
(41404, '2017-08-06 09:22:33', NULL, NULL, 11769, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:22:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41405, '2017-08-06 09:22:52', NULL, NULL, 11769, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:22:52', 'admin-1501981868-1501982572237256', 1, 0, '', NULL, NULL, NULL),
(41406, '2017-08-06 09:11:42', NULL, NULL, 11767, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:11:42', 'admin-1501981868-15019819022594287', 1, 1, 'SR', NULL, NULL, NULL),
(41407, '2017-08-06 09:11:24', NULL, NULL, 11767, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1502007576', 'admin', '2017-08-06 09:11:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41408, '2017-08-07 12:29:29', NULL, NULL, 11828, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 12:29:29', 'admin-1502076683-15020801689041973', 1, 1, 'SR', NULL, NULL, NULL),
(41409, '2017-08-07 12:29:29', NULL, NULL, 11828, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 12:29:29', 'admin-1502076683-15020801689041973', 1, 1, 'SR', NULL, NULL, NULL),
(41410, '2017-08-07 12:29:29', NULL, NULL, 11828, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 12:29:29', 'admin-1502076683-15020801689041973', 1, 1, 'SR', NULL, NULL, NULL),
(41411, '2017-08-07 13:17:25', NULL, NULL, 11831, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.35, 0.0000, 0.0000, 2.35, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:17:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41412, '2017-08-07 00:00:00', NULL, NULL, 11841, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, NULL, NULL, 1.30, 1, '27', 1, '1502085210', 'admin', '2017-08-07 14:09:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41413, '2017-08-07 15:47:16', NULL, NULL, 11842, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 15:47:16', 'admin-1502085210-15020920364926379', 1, 0, '', NULL, NULL, NULL),
(41414, '2017-08-07 15:49:24', NULL, NULL, 11842, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 15:49:24', 'admin-1502085210-15020921645772015', 1, 1, 'SR', NULL, NULL, NULL),
(41415, '2017-08-07 11:59:58', NULL, NULL, 11826, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 11:59:58', 'admin-1502076683-15020783985936452', 1, 1, 'SR', NULL, NULL, NULL),
(41416, '2017-08-07 11:59:58', NULL, NULL, 11826, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 11:59:58', 'admin-1502076683-15020783985936452', 1, 0, '', NULL, NULL, NULL),
(41417, '2017-08-07 11:59:58', NULL, NULL, 11826, 0, 182, '117', 'Open Drinks ', 'banana', 'Cold Drinks', 'Fresh Juice', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 11:59:58', 'admin-1502076683-15020783985936452', 1, 0, '', NULL, NULL, NULL),
(41418, '2017-08-07 12:17:39', NULL, NULL, 11827, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 12:17:39', 'admin-1502076683-15020794594075594', 1, 1, 'SR', 1, NULL, '10.0'),
(41419, '2017-08-07 10:09:55', NULL, NULL, 11820, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1502085210', 'admin', '2017-08-07 10:09:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41420, '2017-08-07 09:56:03', NULL, NULL, 11818, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:56:03', 'admin-1502067675-15020709628378318', 1, 1, 'SR', NULL, NULL, NULL),
(41421, '2017-08-07 15:28:04', NULL, NULL, 11840, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1502085210', 'admin', '2017-08-07 15:28:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41422, '2017-08-07 14:19:55', NULL, NULL, 11835, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 14:19:55', 'admin-1502085210-15020867955008758', 1, 1, 'SR', NULL, NULL, NULL),
(41423, '2017-08-07 11:59:27', NULL, NULL, 11826, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1502085210', 'admin', '2017-08-07 11:59:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41424, '2017-08-07 17:32:10', NULL, NULL, 11846, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 17:32:10', 'admin-1502085210-15020983300088475', 1, 1, 'SR', NULL, NULL, NULL),
(41425, '2017-08-07 17:32:10', NULL, NULL, 11846, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 17:32:10', 'admin-1502085210-15020983300088475', 1, 1, 'SR', NULL, NULL, NULL),
(41426, '2017-08-07 17:11:54', NULL, NULL, 11842, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 17:11:54', 'admin-1502085210-15020971144339955', 1, 1, 'SR', NULL, NULL, NULL),
(41427, '2017-08-07 17:11:54', NULL, NULL, 11842, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 17:11:54', 'admin-1502085210-15020971144339955', 1, 1, 'SR', NULL, NULL, NULL),
(41428, '2017-08-07 13:50:45', NULL, NULL, 11834, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:50:45', 'admin-1502076683-15020850451241882', 1, 1, 'SR', NULL, NULL, NULL),
(41429, '2017-08-07 13:12:06', NULL, NULL, 11830, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:12:06', 'admin-1502076683-15020827263546889', 1, 1, 'SR', NULL, NULL, NULL),
(41430, '2017-08-07 13:12:06', NULL, NULL, 11830, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:12:06', 'admin-1502076683-15020827263546889', 1, 0, '', NULL, NULL, NULL),
(41431, '2017-08-07 13:50:45', NULL, NULL, 11834, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:50:45', 'admin-1502076683-15020850451241882', 1, 1, 'SR', NULL, NULL, NULL),
(41432, '2017-08-07 13:58:39', NULL, NULL, 11836, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:58:39', 'admin-1502085210-15020855190073235', 1, 0, '', 1, NULL, NULL),
(41433, '2017-08-07 13:58:39', NULL, NULL, 11836, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:58:39', 'admin-1502085210-15020855190073235', 1, 0, '', 1, NULL, NULL),
(41434, '2017-08-07 13:58:39', NULL, NULL, 11836, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:58:39', 'admin-1502085210-15020855190073235', 1, 0, '', 1, NULL, NULL),
(41435, '2017-08-07 00:00:00', NULL, NULL, 11841, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 14:09:50', 'admin-1502085210-1502086190123965', 1, 1, 'SR', NULL, NULL, NULL),
(41436, '2017-08-07 16:06:09', NULL, NULL, 11843, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1502085210', 'admin', '2017-08-07 16:06:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41437, '2017-08-07 16:06:19', NULL, NULL, 11843, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 16:06:19', 'admin-1502085210-15020931790191383', 1, 0, '', NULL, NULL, NULL),
(41438, '2017-08-07 16:47:50', NULL, NULL, 11842, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 16:47:50', 'admin-1502085210-1502095670501257', 1, 0, '', NULL, NULL, NULL),
(41439, '2017-08-07 13:41:01', NULL, NULL, 11833, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:41:01', 'admin-1502076683-15020844608539150', 1, 1, 'SR', NULL, NULL, NULL),
(41440, '2017-08-07 13:44:19', NULL, NULL, 11823, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:44:19', 'admin-1502076683-15020846591763786', 1, 1, 'SR', NULL, NULL, NULL),
(41441, '2017-08-07 13:50:24', NULL, NULL, 11834, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:50:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41442, '2017-08-07 13:50:45', NULL, NULL, 11834, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:50:45', 'admin-1502076683-15020850451241882', 1, 1, 'SR', NULL, NULL, NULL),
(41443, '2017-08-07 13:50:45', NULL, NULL, 11834, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:50:45', 'admin-1502076683-15020850451241882', 1, 0, '', NULL, NULL, NULL),
(41444, '2017-08-07 15:11:31', NULL, NULL, 11839, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1502085210', 'admin', '2017-08-07 15:11:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41445, '2017-08-07 15:11:35', NULL, NULL, 11839, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 15:11:35', 'admin-1502085210-15020898952295855', 1, 0, '', NULL, NULL, NULL),
(41446, '2017-08-07 00:00:00', NULL, NULL, 11840, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 14:09:50', 'admin-1502085210-1502086190123965', 1, 1, 'SR', NULL, NULL, NULL),
(41447, '2017-08-07 16:06:19', NULL, NULL, 11843, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 16:06:19', 'admin-1502085210-15020931790191383', 1, 0, '', NULL, NULL, NULL),
(41448, '2017-08-07 13:17:30', NULL, NULL, 11831, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:17:30', 'admin-1502076683-15020830501546346', 1, 0, '', NULL, NULL, NULL),
(41449, '2017-08-07 13:19:39', NULL, NULL, 11832, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:19:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41450, '2017-08-07 13:19:45', NULL, NULL, 11832, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:19:45', 'admin-1502076683-15020831849425178', 1, 1, 'SR', NULL, NULL, NULL),
(41451, '2017-08-07 13:40:40', NULL, NULL, 11833, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:40:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41452, '2017-08-07 13:40:53', NULL, NULL, 11833, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:40:53', 'admin-1502076683-15020844536156595', 1, 0, '', NULL, NULL, NULL),
(41453, '2017-08-07 13:40:53', NULL, NULL, 11833, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:40:53', 'admin-1502076683-15020844536156595', 1, 0, '', NULL, NULL, NULL),
(41454, '2017-08-07 15:47:13', NULL, NULL, 11842, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1502085210', 'admin', '2017-08-07 15:47:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41455, '2017-08-07 14:09:04', NULL, NULL, 11837, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 14:09:04', 'admin-1502085210-15020861445916853', 1, 0, '', NULL, NULL, NULL),
(41456, '2017-08-07 14:09:04', NULL, NULL, 11837, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 14:09:04', 'admin-1502085210-15020861445916853', 1, 0, '', NULL, NULL, NULL),
(41457, '2017-08-07 14:08:55', NULL, NULL, 11837, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1502085210', 'admin', '2017-08-07 14:08:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41458, '2017-08-07 14:09:04', NULL, NULL, 11837, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 14:09:04', 'admin-1502085210-15020861445916853', 1, 0, '', NULL, NULL, NULL),
(41459, '2017-08-07 13:50:45', NULL, NULL, 11834, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:50:45', 'admin-1502076683-15020850451241882', 1, 1, 'SR', NULL, NULL, NULL),
(41460, '2017-08-07 14:34:37', NULL, NULL, 11837, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 14:34:37', 'admin-1502085210-1502087676907699', 1, 0, '', NULL, NULL, NULL),
(41461, '2017-08-07 10:16:32', NULL, NULL, 11821, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 10:16:32', 'admin-1502067675-15020721920494868', 1, 1, 'SR', NULL, NULL, '10.0'),
(41462, '2017-08-07 10:16:32', NULL, NULL, 11821, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 10:16:32', 'admin-1502067675-15020721920494868', 1, 1, 'SR', NULL, NULL, '10.0'),
(41463, '2017-08-07 11:11:33', NULL, NULL, 11822, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 11:11:33', 'admin-1502067675-1502075492985883', 1, 0, '', NULL, NULL, NULL),
(41464, '2017-08-07 11:26:51', NULL, NULL, 11823, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1502085210', 'admin', '2017-08-07 11:26:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41465, '2017-08-07 11:26:58', NULL, NULL, 11823, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 11:26:58', 'admin-1502067675-15020764183405753', 1, 1, 'SR', NULL, NULL, NULL),
(41466, '2017-08-07 11:27:04', NULL, NULL, 11824, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1502085210', 'admin', '2017-08-07 11:27:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41467, '2017-08-07 11:27:07', NULL, NULL, 11824, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 11:27:07', 'admin-1502067675-15020764273332156', 1, 1, 'SR', NULL, NULL, NULL),
(41468, '2017-08-07 11:31:18', NULL, NULL, 11823, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 11:31:18', 'admin-1502067675-15020766783088784', 1, 0, '', NULL, NULL, NULL),
(41469, '2017-08-07 11:32:41', NULL, NULL, 11825, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1502085210', 'admin', '2017-08-07 11:32:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41470, '2017-08-07 11:32:45', NULL, NULL, 11825, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 11:32:45', 'admin-1502076683-15020767649793086', 1, 1, 'SR', NULL, NULL, NULL),
(41471, '2017-08-07 12:57:30', NULL, NULL, 11829, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1502085210', 'admin', '2017-08-07 12:57:30', '0', 1, 1, 'SR', NULL, NULL, '10.0');
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(41472, '2017-08-07 12:57:34', NULL, NULL, 11829, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 12:57:34', 'admin-1502076683-15020818544832529', 1, 1, 'SR', NULL, NULL, '10.0'),
(41473, '2017-08-07 13:00:04', NULL, NULL, 11829, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:00:04', 'admin-1502076683-15020820047966875', 1, 1, 'SR', NULL, NULL, '10.0'),
(41474, '2017-08-07 17:31:15', NULL, NULL, 11846, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 17:31:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41475, '2017-08-07 13:04:46', NULL, NULL, 11829, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:04:46', 'admin-1502076683-15020822863112780', 1, 0, '', NULL, NULL, '10.0'),
(41476, '2017-08-07 13:58:24', NULL, NULL, 11835, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:58:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41477, '2017-08-07 13:17:30', NULL, NULL, 11831, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:17:30', 'admin-1502076683-15020830501546346', 1, 0, '', NULL, NULL, NULL),
(41478, '2017-08-07 13:11:57', NULL, NULL, 11830, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:11:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41479, '2017-08-07 12:24:22', NULL, NULL, 11828, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1502085210', 'admin', '2017-08-07 12:24:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41480, '2017-08-07 12:29:12', NULL, NULL, 11828, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 12:29:12', 'admin-1502076683-15020801520727320', 1, 0, '', NULL, NULL, NULL),
(41481, '2017-08-07 12:29:12', NULL, NULL, 11828, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 12:29:12', 'admin-1502076683-15020801520727320', 1, 0, '', NULL, NULL, NULL),
(41482, '2017-08-07 09:55:41', NULL, NULL, 11818, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:55:41', 'admin-1502067675-15020709414282692', 1, 0, '', NULL, NULL, NULL),
(41483, '2017-08-07 11:11:33', NULL, NULL, 11822, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 11:11:33', 'admin-1502067675-1502075492985883', 1, 0, '', NULL, NULL, NULL),
(41484, '2017-08-07 11:11:33', NULL, NULL, 11822, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 11:11:33', 'admin-1502067675-1502075492985883', 1, 0, '', NULL, NULL, NULL),
(41485, '2017-08-07 10:16:21', NULL, NULL, 11821, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 10:16:21', 'admin-1502067675-15020721816576272', 1, 0, '', NULL, NULL, '10.0'),
(41486, '2017-08-07 09:34:04', NULL, NULL, 11817, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:34:04', 'admin-1502067675-1502069643846691', 1, 0, '', NULL, NULL, NULL),
(41487, '2017-08-07 09:34:04', NULL, NULL, 11817, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:34:04', 'admin-1502067675-1502069643846691', 1, 0, '', NULL, NULL, NULL),
(41488, '2017-08-07 12:29:29', NULL, NULL, 11828, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 12:29:29', 'admin-1502076683-15020801689041973', 1, 1, 'SR', NULL, NULL, NULL),
(41489, '2017-08-07 10:09:59', NULL, NULL, 11820, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 10:09:59', 'admin-1502067675-15020717990549634', 1, 1, 'SR', NULL, NULL, NULL),
(41490, '2017-08-07 10:09:59', NULL, NULL, 11820, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 10:09:59', 'admin-1502067675-15020717990549634', 1, 1, 'SR', NULL, NULL, NULL),
(41491, '2017-08-07 13:17:30', NULL, NULL, 11831, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 13:17:30', 'admin-1502076683-15020830501546346', 1, 0, '', NULL, NULL, NULL),
(41492, '2017-08-07 11:59:58', NULL, NULL, 11826, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 11:59:58', 'admin-1502076683-15020783985936452', 1, 1, 'SR', NULL, NULL, NULL),
(41493, '2017-08-07 10:16:21', NULL, NULL, 11821, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 10:16:21', 'admin-1502067675-15020721816576272', 1, 0, '', NULL, NULL, '10.0'),
(41494, '2017-08-07 16:18:12', NULL, NULL, 11845, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 16:18:12', 'admin-1502085210-15020938926667827', 1, 0, '', 1, NULL, '10.0'),
(41495, '2017-08-07 10:16:21', NULL, NULL, 11821, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 10:16:21', 'admin-1502067675-15020721816576272', 1, 0, '', NULL, NULL, '10.0'),
(41496, '2017-08-07 09:56:03', NULL, NULL, 11818, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:56:03', 'admin-1502067675-15020709628378318', 1, 1, 'SR', NULL, NULL, NULL),
(41497, '2017-08-07 09:56:03', NULL, NULL, 11818, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:56:03', 'admin-1502067675-15020709628378318', 1, 1, 'SR', NULL, NULL, NULL),
(41498, '2017-08-07 09:56:03', NULL, NULL, 11818, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:56:03', 'admin-1502067675-15020709628378318', 1, 1, 'SR', NULL, NULL, NULL),
(41499, '2017-08-07 10:16:05', NULL, NULL, 11821, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1502085210', 'admin', '2017-08-07 10:16:05', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(41500, '2017-08-07 10:06:50', NULL, NULL, 11819, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 10:06:50', 'admin-1502067675-15020716107297836', 1, 1, 'SR', NULL, NULL, NULL),
(41501, '2017-08-07 10:06:50', NULL, NULL, 11819, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 10:06:50', 'admin-1502067675-15020716107297836', 1, 1, 'SR', NULL, NULL, NULL),
(41502, '2017-08-07 10:06:46', NULL, NULL, 11819, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1502085210', 'admin', '2017-08-07 10:06:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41503, '2017-08-07 09:56:03', NULL, NULL, 11818, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:56:03', 'admin-1502067675-15020709628378318', 1, 1, 'SR', NULL, NULL, NULL),
(41504, '2017-08-07 09:56:03', NULL, NULL, 11818, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:56:03', 'admin-1502067675-15020709628378318', 1, 1, 'SR', NULL, NULL, NULL),
(41505, '2017-08-07 09:55:41', NULL, NULL, 11818, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:55:41', 'admin-1502067675-15020709414282692', 1, 0, '', NULL, NULL, NULL),
(41506, '2017-08-07 09:55:41', NULL, NULL, 11818, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:55:41', 'admin-1502067675-15020709414282692', 1, 0, '', NULL, NULL, NULL),
(41507, '2017-08-07 09:55:41', NULL, NULL, 11818, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:55:41', 'admin-1502067675-15020709414282692', 1, 0, '', NULL, NULL, NULL),
(41508, '2017-08-07 11:11:27', NULL, NULL, 11822, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1502085210', 'admin', '2017-08-07 11:11:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41509, '2017-08-07 09:55:41', NULL, NULL, 11818, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:55:41', 'admin-1502067675-15020709414282692', 1, 0, '', NULL, NULL, NULL),
(41510, '2017-08-07 09:55:30', NULL, NULL, 11818, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 18.40, 0.0000, 0.0000, 18.40, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:55:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41511, '2017-08-07 09:55:41', NULL, NULL, 11818, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:55:41', 'admin-1502067675-15020709414282692', 1, 0, '', NULL, NULL, NULL),
(41512, '2017-08-07 09:34:16', NULL, NULL, 11817, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:34:16', 'admin-1502067675-15020696564947219', 1, 1, 'SR', NULL, NULL, NULL),
(41513, '2017-08-07 09:34:16', NULL, NULL, 11817, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:34:16', 'admin-1502067675-15020696564947219', 1, 1, 'SR', NULL, NULL, NULL),
(41514, '2017-08-07 09:34:16', NULL, NULL, 11817, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:34:16', 'admin-1502067675-15020696564947219', 1, 1, 'SR', NULL, NULL, NULL),
(41515, '2017-08-07 09:34:04', NULL, NULL, 11817, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:34:04', 'admin-1502067675-1502069643846691', 1, 0, '', NULL, NULL, NULL),
(41516, '2017-08-07 09:29:08', NULL, NULL, 11816, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:29:08', 'admin-1502067675-1502069348435911', 1, 1, 'SR', NULL, NULL, NULL),
(41517, '2017-08-07 09:29:08', NULL, NULL, 11816, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:29:08', 'admin-1502067675-1502069348435911', 1, 1, 'SR', NULL, NULL, NULL),
(41518, '2017-08-07 09:33:53', NULL, NULL, 11817, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:33:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41519, '2017-08-07 09:29:03', NULL, NULL, 11816, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:29:03', 'admin-1502067675-15020693429838481', 1, 0, '', NULL, NULL, NULL),
(41520, '2017-08-07 09:29:03', NULL, NULL, 11816, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:29:03', 'admin-1502067675-15020693429838481', 1, 0, '', NULL, NULL, NULL),
(41521, '2017-08-07 09:28:57', NULL, NULL, 11816, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1502085210', 'admin', '2017-08-07 09:28:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41522, '2017-08-09 00:00:00', NULL, NULL, 11880, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 15:52:11', 'admin-1502262698-1502265131413798', 1, 1, 'SR', NULL, NULL, NULL),
(41523, '2017-08-09 00:00:00', NULL, NULL, 11879, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 15:52:11', 'admin-1502262698-1502265131413798', 1, 1, 'SR', NULL, NULL, NULL),
(41524, '2017-08-09 16:16:06', NULL, NULL, 11878, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 16:16:06', 'admin-1502262698-15022665663452550', 1, 1, 'SR', NULL, NULL, NULL),
(41525, '2017-08-09 12:26:58', NULL, NULL, 11857, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 12:26:58', 'admin-1502250878-15022528179002041', 1, 0, '', NULL, NULL, '10.0'),
(41526, '2017-08-09 13:36:48', NULL, NULL, 11871, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:36:48', 'admin-1502256100-15022570082975437', 1, 1, 'SR', NULL, NULL, NULL),
(41527, '2017-08-09 13:37:04', NULL, NULL, 11872, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:37:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41528, '2017-08-09 16:21:53', NULL, NULL, 11881, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1502262698', 'admin', '2017-08-09 16:21:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41529, '2017-08-09 16:21:31', NULL, NULL, 11880, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1502262698', 'admin', '2017-08-09 16:21:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41530, '2017-08-09 16:20:54', NULL, NULL, 11879, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1502262698', 'admin', '2017-08-09 16:20:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41531, '2017-08-09 00:00:00', NULL, NULL, 11861, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:56:52', 'admin-1502250878-15022510121707185', 1, 0, '', NULL, NULL, NULL),
(41532, '2017-08-09 00:00:00', NULL, NULL, 11863, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:56:52', 'admin-1502250878-15022510121707185', 1, 0, '', NULL, NULL, NULL),
(41533, '2017-08-09 12:55:17', NULL, NULL, 11860, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1502262698', 'admin', '2017-08-09 12:55:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41534, '2017-08-09 00:00:00', NULL, NULL, 11860, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:56:52', 'admin-1502250878-15022510121707185', 1, 0, '', NULL, NULL, NULL),
(41535, '2017-08-09 11:43:59', NULL, NULL, 11854, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 22.20, 0.0000, 0.0000, 22.20, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:43:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41536, '2017-08-09 11:44:09', NULL, NULL, 11854, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:44:09', 'admin-1502240775-15022502493483111', 1, 0, '', NULL, NULL, NULL),
(41537, '2017-08-09 11:54:03', NULL, NULL, 11854, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:54:03', 'admin-1502240775-15022508429403451', 1, 1, 'SR', NULL, NULL, NULL),
(41538, '2017-08-09 17:14:38', NULL, NULL, 11885, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 17:14:38', 'admin-1502262698-15022700785428956', 1, 1, 'SR', NULL, NULL, NULL),
(41539, '2017-08-09 16:16:06', NULL, NULL, 11878, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 16:16:06', 'admin-1502262698-15022665663452550', 1, 1, 'SR', NULL, NULL, NULL),
(41540, '2017-08-09 12:40:13', NULL, NULL, 11858, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 12:40:13', 'admin-1502250878-15022536128417447', 1, 1, 'SR', NULL, NULL, NULL),
(41541, '2017-08-09 16:22:20', NULL, NULL, 11882, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 16:22:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41542, '2017-08-09 16:15:53', NULL, NULL, 11878, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 16:15:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41543, '2017-08-09 13:00:01', NULL, NULL, 11864, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:00:01', 'admin-1502254762-15022548018306038', 1, 1, 'SR', NULL, NULL, NULL),
(41544, '2017-08-09 13:00:02', NULL, NULL, 11864, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:00:02', 'admin-1502254762-15022548018306038', 1, 1, 'SR', NULL, NULL, NULL),
(41545, '2017-08-09 13:26:28', NULL, NULL, 11870, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:26:28', 'admin-1502256100-15022563882043318', 1, 1, 'SR', NULL, NULL, NULL),
(41546, '2017-08-09 13:26:28', NULL, NULL, 11870, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:26:28', 'admin-1502256100-15022563882043318', 1, 1, 'SR', NULL, NULL, NULL),
(41547, '2017-08-09 13:35:54', NULL, NULL, 11871, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.20, 0.0000, 0.0000, 10.20, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:35:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41548, '2017-08-09 13:36:48', NULL, NULL, 11871, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:36:48', 'admin-1502256100-15022570082975437', 1, 0, '', NULL, NULL, NULL),
(41549, '2017-08-09 13:36:48', NULL, NULL, 11871, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:36:48', 'admin-1502256100-15022570082975437', 1, 1, 'SR', NULL, NULL, NULL),
(41550, '2017-08-09 13:36:48', NULL, NULL, 11871, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:36:48', 'admin-1502256100-15022570082975437', 1, 0, '', NULL, NULL, NULL),
(41551, '2017-08-09 13:36:48', NULL, NULL, 11871, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:36:48', 'admin-1502256100-15022570082975437', 1, 0, '', NULL, NULL, NULL),
(41552, '2017-08-09 13:36:48', NULL, NULL, 11871, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:36:48', 'admin-1502256100-15022570082975437', 1, 1, 'SR', NULL, NULL, NULL),
(41553, '2017-08-09 14:30:55', NULL, NULL, 11874, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 14:30:55', 'admin-1502256100-1502260255759207', 1, 1, 'SR', NULL, NULL, NULL),
(41554, '2017-08-09 14:30:55', NULL, NULL, 11874, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 14:30:55', 'admin-1502256100-1502260255759207', 1, 1, 'SR', NULL, NULL, NULL),
(41555, '2017-08-09 14:33:22', NULL, NULL, 11864, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 14:33:22', 'admin-1502256100-15022604022208791', 1, 1, 'SR', NULL, NULL, NULL),
(41556, '2017-08-09 14:33:29', NULL, NULL, 11864, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 14:33:29', 'admin-1502256100-15022604090548442', 1, 1, 'SR', NULL, NULL, NULL),
(41557, '2017-08-09 00:00:00', NULL, NULL, 11882, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 16:01:44', 'admin-1502262698-15022657040136722', 1, 0, '', NULL, NULL, NULL),
(41558, '2017-08-09 15:56:44', NULL, NULL, 11877, 0, 181, '116', 'Open Food ', 'fruits', 'Meals', 'Perfect Meals', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 15:56:44', 'admin-1502262698-15022654043671291', 1, 0, '', 1, NULL, NULL),
(41559, '2017-08-09 00:00:00', NULL, NULL, 11882, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 16:01:44', 'admin-1502262698-15022657040136722', 1, 0, '', NULL, NULL, NULL),
(41560, '2017-08-09 16:23:37', NULL, NULL, 11883, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.99, 0.0000, 0.0000, 0.99, 1, '27', 1, '1502262698', 'admin', '2017-08-09 16:23:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41561, '2017-08-09 16:23:52', NULL, NULL, 11883, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 16:23:52', 'admin-1502262698-15022670322383028', 1, 1, 'SR', NULL, NULL, NULL),
(41562, '2017-08-09 12:40:13', NULL, NULL, 11858, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 12:40:13', 'admin-1502250878-15022536128417447', 1, 1, 'SR', NULL, NULL, NULL),
(41563, '2017-08-09 15:11:58', NULL, NULL, 11875, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1502262698', 'admin', '2017-08-09 15:11:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41564, '2017-08-09 15:12:02', NULL, NULL, 11875, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 15:12:02', 'admin-1502262698-15022627225883533', 1, 1, 'SR', NULL, NULL, NULL),
(41565, '2017-08-09 15:12:02', NULL, NULL, 11875, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 15:12:02', 'admin-1502262698-15022627225883533', 1, 1, 'SR', NULL, NULL, NULL),
(41566, '2017-08-09 15:51:54', NULL, NULL, 11876, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 15:51:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41567, '2017-08-09 17:11:42', NULL, NULL, 11885, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 17:11:42', 'admin-1502262698-1502269902317163', 1, 0, '', NULL, NULL, NULL),
(41568, '2017-08-09 17:14:11', NULL, NULL, 11886, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1502262698', 'admin', '2017-08-09 17:14:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41569, '2017-08-09 17:14:29', NULL, NULL, 11886, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 17:14:29', 'admin-1502262698-15022700688249435', 1, 1, 'SR', NULL, NULL, NULL),
(41570, '2017-08-09 12:54:04', NULL, NULL, 11859, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1502262698', 'admin', '2017-08-09 12:54:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41571, '2017-08-09 12:17:00', NULL, NULL, 11856, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1502262698', 'admin', '2017-08-09 12:17:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41572, '2017-08-09 12:17:55', NULL, NULL, 11856, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 12:17:55', 'admin-1502250878-1502252275077159', 1, 0, '', NULL, NULL, NULL),
(41573, '2017-08-09 12:17:55', NULL, NULL, 11856, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 12:17:55', 'admin-1502250878-1502252275077159', 1, 0, '', NULL, NULL, NULL),
(41574, '2017-08-09 12:17:55', NULL, NULL, 11856, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 12:17:55', 'admin-1502250878-1502252275077159', 1, 1, 'SR', NULL, NULL, NULL),
(41575, '2017-08-09 14:34:39', NULL, NULL, 11864, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 14:34:39', 'admin-1502256100-1502260479044693', 1, 0, '', NULL, NULL, NULL),
(41576, '2017-08-09 13:41:24', NULL, NULL, 11854, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:41:24', 'admin-1502256100-15022572839395956', 1, 1, 'SR', NULL, NULL, NULL),
(41577, '2017-08-09 13:41:24', NULL, NULL, 11854, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:41:24', 'admin-1502256100-15022572839395956', 1, 1, 'SR', NULL, NULL, NULL),
(41578, '2017-08-09 14:30:55', NULL, NULL, 11874, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 14:30:55', 'admin-1502256100-1502260255759207', 1, 0, '', NULL, NULL, NULL),
(41579, '2017-08-09 17:14:29', NULL, NULL, 11886, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 17:14:29', 'admin-1502262698-15022700688249435', 1, 0, '', NULL, NULL, NULL),
(41580, '2017-08-09 17:10:59', NULL, NULL, 11885, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1502262698', 'admin', '2017-08-09 17:10:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41581, '2017-08-09 00:00:00', NULL, NULL, 11862, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:56:52', 'admin-1502250878-15022510121707185', 1, 1, 'SR', NULL, NULL, NULL),
(41582, '2017-08-09 00:00:00', NULL, NULL, 11863, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, NULL, NULL, 2.70, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:56:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41583, '2017-08-09 17:14:29', NULL, NULL, 11886, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 17:14:29', 'admin-1502262698-15022700688249435', 1, 0, '', NULL, NULL, NULL),
(41584, '2017-08-09 17:04:10', NULL, NULL, 11884, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1502262698', 'admin', '2017-08-09 17:04:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41585, '2017-08-09 14:30:47', NULL, NULL, 11874, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1502262698', 'admin', '2017-08-09 14:30:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41586, '2017-08-09 14:30:55', NULL, NULL, 11874, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 14:30:55', 'admin-1502256100-1502260255759207', 1, 1, 'SR', NULL, NULL, NULL),
(41587, '2017-08-09 13:37:41', NULL, NULL, 11872, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:37:41', 'admin-1502256100-15022570614639882', 1, 1, 'SR', NULL, NULL, NULL),
(41588, '2017-08-09 13:37:41', NULL, NULL, 11872, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:37:41', 'admin-1502256100-15022570614639882', 1, 0, '', NULL, NULL, NULL),
(41589, '2017-08-09 13:24:11', NULL, NULL, 11868, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:24:11', 'admin-1502256100-15022562515166419', 1, 1, 'SR', NULL, NULL, NULL),
(41590, '2017-08-09 13:10:03', NULL, NULL, 11867, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:10:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41591, '2017-08-09 13:10:09', NULL, NULL, 11867, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:10:09', 'admin-1502254762-15022554092204585', 1, 1, 'SR', NULL, NULL, NULL),
(41592, '2017-08-09 13:10:09', NULL, NULL, 11867, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:10:09', 'admin-1502254762-15022554092204585', 1, 0, '', NULL, NULL, NULL),
(41593, '2017-08-09 17:11:42', NULL, NULL, 11885, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 17:11:42', 'admin-1502262698-1502269902317163', 1, 0, '', NULL, NULL, NULL),
(41594, '2017-08-09 17:11:42', NULL, NULL, 11885, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 17:11:42', 'admin-1502262698-1502269902317163', 1, 1, 'SR', NULL, NULL, NULL),
(41595, '2017-08-09 17:11:42', NULL, NULL, 11885, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 17:11:42', 'admin-1502262698-1502269902317163', 1, 1, 'SR', NULL, NULL, NULL),
(41596, '2017-08-09 17:04:16', NULL, NULL, 11884, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 17:04:16', 'admin-1502262698-15022694558812848', 1, 1, 'SR', NULL, NULL, NULL),
(41597, '2017-08-09 17:04:16', NULL, NULL, 11884, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 17:04:16', 'admin-1502262698-15022694558812848', 1, 1, 'SR', NULL, NULL, NULL),
(41598, '2017-08-09 16:23:52', NULL, NULL, 11883, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1502262698', 'admin', '2017-08-09 16:23:52', 'admin-1502262698-15022670322383028', 1, 0, '', NULL, NULL, NULL),
(41599, '2017-08-09 00:00:00', NULL, NULL, 11881, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 15:52:11', 'admin-1502262698-1502265131413798', 1, 1, 'SR', NULL, NULL, NULL),
(41600, '2017-08-09 13:08:52', NULL, NULL, 11865, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:08:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41601, '2017-08-09 13:37:41', NULL, NULL, 11872, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:37:41', 'admin-1502256100-15022570614639882', 1, 1, 'SR', NULL, NULL, NULL),
(41602, '2017-08-09 00:00:00', NULL, NULL, 11859, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 12:01:41', 'admin-1502250878-15022513011119357', 1, 0, '', NULL, NULL, NULL),
(41603, '2017-08-09 00:00:00', NULL, NULL, 11860, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:56:52', 'admin-1502250878-15022510121707185', 1, 1, 'SR', NULL, NULL, NULL),
(41604, '2017-08-09 00:00:00', NULL, NULL, 11861, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:56:52', 'admin-1502250878-15022510121707185', 1, 1, 'SR', NULL, NULL, NULL),
(41605, '2017-08-09 00:00:00', NULL, NULL, 11862, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:56:52', 'admin-1502250878-15022510121707185', 1, 0, '', NULL, NULL, NULL),
(41606, '2017-08-09 00:00:00', NULL, NULL, 11863, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:56:52', 'admin-1502250878-15022510121707185', 1, 1, 'SR', NULL, NULL, NULL),
(41607, '2017-08-09 12:59:14', NULL, NULL, 11854, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 12:59:14', 'admin-1502250878-1502254754519878', 1, 0, '', NULL, NULL, NULL),
(41608, '2017-08-09 13:37:41', NULL, NULL, 11872, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:37:41', 'admin-1502256100-15022570614639882', 1, 0, '', NULL, NULL, NULL),
(41609, '2017-08-09 13:26:04', NULL, NULL, 11870, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:26:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41610, '2017-08-09 13:24:46', NULL, NULL, 11856, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:24:46', 'admin-1502256100-15022562864816713', 1, 0, '', NULL, NULL, NULL),
(41611, '2017-08-09 13:09:07', NULL, NULL, 11865, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:09:07', 'admin-1502254762-15022553470452834', 1, 1, 'SR', NULL, NULL, NULL),
(41612, '2017-08-09 13:09:07', NULL, NULL, 11865, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:09:07', 'admin-1502254762-15022553470452834', 1, 1, 'SR', NULL, NULL, NULL),
(41613, '2017-08-09 13:24:11', NULL, NULL, 11868, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:24:11', 'admin-1502256100-15022562515166419', 1, 1, 'SR', NULL, NULL, NULL),
(41614, '2017-08-09 13:24:22', NULL, NULL, 11869, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:24:22', 'admin-1502256100-15022562626329225', 1, 1, 'SR', NULL, NULL, NULL),
(41615, '2017-08-09 13:24:15', NULL, NULL, 11869, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:24:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41616, '2017-08-09 11:56:03', NULL, NULL, 11854, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:56:03', 'admin-1502250878-15022509628445017', 1, 1, 'SR', NULL, NULL, NULL),
(41617, '2017-08-09 13:24:11', NULL, NULL, 11868, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:24:11', 'admin-1502256100-15022562515166419', 1, 1, 'SR', NULL, NULL, NULL),
(41618, '2017-08-09 10:31:14', NULL, NULL, 11851, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 10:31:14', 'admin-1502240775-15022458742007519', 1, 1, 'SR', NULL, NULL, NULL),
(41619, '2017-08-09 10:31:14', NULL, NULL, 11851, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 10:31:14', 'admin-1502240775-15022458742007519', 1, 1, 'SR', NULL, NULL, NULL),
(41620, '2017-08-09 10:37:47', NULL, NULL, 11852, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1502262698', 'admin', '2017-08-09 10:37:47', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(41621, '2017-08-09 10:37:55', NULL, NULL, 11852, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 10:37:55', 'admin-1502240775-1502246275286479', 1, 0, '', NULL, NULL, '10.0'),
(41622, '2017-08-09 10:37:55', NULL, NULL, 11852, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 10:37:55', 'admin-1502240775-1502246275286479', 1, 0, '', NULL, NULL, '10.0'),
(41623, '2017-08-09 10:37:55', NULL, NULL, 11852, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 10:37:55', 'admin-1502240775-1502246275286479', 1, 1, 'SR', NULL, NULL, '10.0'),
(41624, '2017-08-09 10:37:55', NULL, NULL, 11852, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 10:37:55', 'admin-1502240775-1502246275286479', 1, 1, 'SR', NULL, NULL, '10.0'),
(41625, '2017-08-09 10:48:46', NULL, NULL, 11852, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 10:48:46', 'admin-1502240775-15022469266384951', 1, 0, '', NULL, NULL, '10.0'),
(41626, '2017-08-09 10:48:46', NULL, NULL, 11852, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 10:48:46', 'admin-1502240775-15022469266384951', 1, 0, '', NULL, NULL, '10.0'),
(41627, '2017-08-09 13:24:11', NULL, NULL, 11868, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:24:11', 'admin-1502256100-15022562515166419', 1, 0, '', NULL, NULL, NULL),
(41628, '2017-08-09 13:23:06', NULL, NULL, 11868, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:23:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41629, '2017-08-09 13:24:11', NULL, NULL, 11868, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:24:11', 'admin-1502256100-15022562515166419', 1, 0, '', NULL, NULL, NULL),
(41630, '2017-08-09 12:59:50', NULL, NULL, 11864, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1502262698', 'admin', '2017-08-09 12:59:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41631, '2017-08-09 12:59:14', NULL, NULL, 11854, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 12:59:14', 'admin-1502250878-1502254754519878', 1, 1, 'SR', NULL, NULL, NULL),
(41632, '2017-08-09 13:50:02', NULL, NULL, 11871, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 13:50:02', 'admin-1502256100-15022578026239189', 1, 1, 'SR', NULL, NULL, NULL),
(41633, '2017-08-09 12:40:07', NULL, NULL, 11858, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1502262698', 'admin', '2017-08-09 12:40:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41634, '2017-08-09 12:33:16', NULL, NULL, 11857, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 12:33:16', 'admin-1502250878-1502253196574491', 1, 1, 'SR', NULL, NULL, '10.0'),
(41635, '2017-08-09 10:31:02', NULL, NULL, 11851, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1502262698', 'admin', '2017-08-09 10:31:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41636, '2017-08-09 10:31:14', NULL, NULL, 11851, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 10:31:14', 'admin-1502240775-15022458742007519', 1, 0, '', NULL, NULL, NULL),
(41637, '2017-08-09 10:31:14', NULL, NULL, 11851, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 10:31:14', 'admin-1502240775-15022458742007519', 1, 0, '', NULL, NULL, NULL),
(41638, '2017-08-09 10:06:42', NULL, NULL, 11849, 0, 156, '90', 'House Cheddar Omelet', ' change to potato,No side salad', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 10:06:42', 'admin-1502240775-1502244402453261', 1, 0, '', NULL, NULL, NULL),
(41639, '2017-08-09 10:06:52', NULL, NULL, 11849, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 10:06:52', 'admin-1502240775-15022444125308474', 1, 1, 'SR', NULL, NULL, NULL),
(41640, '2017-08-09 12:26:58', NULL, NULL, 11857, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 12:26:58', 'admin-1502250878-15022528179002041', 1, 1, 'SR', NULL, NULL, '10.0'),
(41641, '2017-08-09 16:16:06', NULL, NULL, 11878, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 16:16:06', 'admin-1502262698-15022665663452550', 1, 1, 'SR', NULL, NULL, NULL),
(41642, '2017-08-09 12:26:33', NULL, NULL, 11857, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1502262698', 'admin', '2017-08-09 12:26:33', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(41643, '2017-08-09 12:17:55', NULL, NULL, 11856, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 12:17:55', 'admin-1502250878-1502252275077159', 1, 1, 'SR', NULL, NULL, NULL),
(41644, '2017-08-09 00:00:00', NULL, NULL, 11882, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 15:52:11', 'admin-1502262698-1502265131413798', 1, 1, 'SR', NULL, NULL, NULL),
(41645, '2017-08-09 12:17:55', NULL, NULL, 11856, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 12:17:55', 'admin-1502250878-1502252275077159', 1, 1, 'SR', NULL, NULL, NULL),
(41646, '2017-08-09 12:56:08', NULL, NULL, 11861, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1502262698', 'admin', '2017-08-09 12:56:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41647, '2017-08-09 00:00:00', NULL, NULL, 11860, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:56:52', 'admin-1502250878-15022510121707185', 1, 1, 'SR', NULL, NULL, NULL),
(41648, '2017-08-09 10:25:51', NULL, NULL, 11850, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1502262698', 'admin', '2017-08-09 10:25:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41649, '2017-08-09 12:56:54', NULL, NULL, 11862, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1502262698', 'admin', '2017-08-09 12:56:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41650, '2017-08-09 00:00:00', NULL, NULL, 11860, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:56:52', 'admin-1502250878-15022510121707185', 1, 1, 'SR', NULL, NULL, NULL),
(41651, '2017-08-09 11:56:03', NULL, NULL, 11854, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:56:03', 'admin-1502250878-15022509628445017', 1, 1, 'SR', NULL, NULL, NULL),
(41652, '2017-08-09 11:56:11', NULL, NULL, 11854, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:56:11', 'admin-1502250878-15022509710593968', 1, 1, 'SR', NULL, NULL, NULL),
(41653, '2017-08-09 11:55:31', NULL, NULL, 11854, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:55:31', 'admin-1502250878-15022509308179439', 1, 0, '', NULL, NULL, NULL),
(41654, '2017-08-09 11:55:57', NULL, NULL, 11854, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:55:57', 'admin-1502250878-1502250956847679', 1, 0, '', NULL, NULL, NULL),
(41655, '2017-08-09 11:54:03', NULL, NULL, 11854, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:54:03', 'admin-1502240775-15022508429403451', 1, 0, '', NULL, NULL, NULL),
(41656, '2017-08-09 11:55:15', NULL, NULL, 11854, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:55:15', 'admin-1502250878-15022509155297918', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(41657, '2017-08-09 11:54:03', NULL, NULL, 11854, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:54:03', 'admin-1502240775-15022508429403451', 1, 1, 'SR', NULL, NULL, NULL),
(41658, '2017-08-09 11:54:03', NULL, NULL, 11854, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:54:03', 'admin-1502240775-15022508429403451', 1, 1, 'SR', NULL, NULL, NULL),
(41659, '2017-08-09 11:44:09', NULL, NULL, 11854, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:44:09', 'admin-1502240775-15022502493483111', 1, 0, '', NULL, NULL, NULL),
(41660, '2017-08-09 11:11:19', NULL, NULL, 11853, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:11:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41661, '2017-08-09 11:11:51', NULL, NULL, 11853, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 11:11:51', 'admin-1502240775-15022483115716550', 1, 1, 'SR', NULL, NULL, NULL),
(41662, '2017-08-09 10:26:01', NULL, NULL, 11850, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 10:26:01', 'admin-1502240775-1502245560913729', 1, 1, 'SR', NULL, NULL, NULL),
(41663, '2017-08-09 10:26:01', NULL, NULL, 11850, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 10:26:01', 'admin-1502240775-1502245560913729', 1, 1, 'SR', NULL, NULL, NULL),
(41664, '2017-08-09 10:26:01', NULL, NULL, 11850, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 10:26:01', 'admin-1502240775-1502245560913729', 1, 0, '', NULL, NULL, NULL),
(41665, '2017-08-09 10:26:01', NULL, NULL, 11850, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 10:26:01', 'admin-1502240775-1502245560913729', 1, 0, '', NULL, NULL, NULL),
(41666, '2017-08-09 09:44:00', NULL, NULL, 11847, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 09:44:00', 'admin-1502240775-15022430404075491', 1, 1, 'SR', NULL, NULL, NULL),
(41667, '2017-08-09 09:53:30', NULL, NULL, 11848, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1502262698', 'admin', '2017-08-09 09:53:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41668, '2017-08-09 09:53:34', NULL, NULL, 11848, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 09:53:34', 'admin-1502240775-15022436145307844', 1, 1, 'SR', NULL, NULL, NULL),
(41669, '2017-08-09 10:06:42', NULL, NULL, 11849, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502262698', 'admin', '2017-08-09 10:06:42', 'admin-1502240775-1502244402453261', 1, 0, '', NULL, NULL, NULL),
(41670, '2017-08-09 10:02:41', NULL, NULL, 11849, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1502262698', 'admin', '2017-08-09 10:02:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41671, '2017-08-09 09:43:56', NULL, NULL, 11847, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1502262698', 'admin', '2017-08-09 09:43:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41672, '2017-08-10 12:38:33', NULL, NULL, 11900, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 12:38:33', 'admin-1502335407-15023399135663286', 1, 1, 'SR', NULL, NULL, '10.0'),
(41673, '2017-08-10 12:38:33', NULL, NULL, 11900, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 12:38:33', 'admin-1502335407-15023399135663286', 1, 1, 'SR', NULL, NULL, '10.0'),
(41674, '2017-08-10 12:38:33', NULL, NULL, 11900, 0, 285, '219', 'Tip Tap Lor Bak', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 12:38:33', 'admin-1502335407-15023399135663286', 1, 0, '', NULL, NULL, '10.0'),
(41675, '2017-08-10 10:58:00', NULL, NULL, 11893, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 10:58:00', 'admin-1502325747-15023338798625057', 1, 1, 'SR', NULL, NULL, NULL),
(41676, '2017-08-10 12:41:04', NULL, NULL, 11900, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 12:41:04', 'admin-1502335407-15023400646226480', 1, 1, 'SR', NULL, NULL, '10.0'),
(41677, '2017-08-10 12:44:29', NULL, NULL, 11901, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 12:44:29', 'admin-1502335407-15023402697218342', 1, 0, '', NULL, NULL, NULL),
(41678, '2017-08-10 17:00:07', NULL, NULL, 11906, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 17:00:07', 'admin-1502340275-15023556072221086', 1, 1, 'SR', NULL, NULL, NULL),
(41679, '2017-08-10 13:28:51', NULL, NULL, 11902, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 13:28:51', 'admin-1502340275-15023429308635879', 1, 1, 'SR', 1, NULL, NULL),
(41680, '2017-08-10 12:53:26', NULL, NULL, 11901, 0, 284, '218', 'Caramel Waffles', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 12:53:26', 'admin-1502340275-15023408059274688', 1, 0, '', NULL, NULL, NULL),
(41681, '2017-08-10 14:44:34', NULL, NULL, 11903, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 14:44:34', 'admin-1502340275-15023474742426339', 1, 0, '', NULL, NULL, NULL),
(41682, '2017-08-10 14:59:44', NULL, NULL, 11904, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1502340275', 'admin', '2017-08-10 14:59:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41683, '2017-08-10 14:59:52', NULL, NULL, 11904, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 14:59:52', 'admin-1502340275-15023483919651694', 1, 1, 'SR', NULL, NULL, NULL),
(41684, '2017-08-10 15:12:32', NULL, NULL, 11905, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1502340275', 'admin', '2017-08-10 15:12:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41685, '2017-08-10 15:15:30', NULL, NULL, 11905, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 15:15:30', 'admin-1502340275-15023493303997426', 1, 0, '', NULL, NULL, NULL),
(41686, '2017-08-10 15:15:30', NULL, NULL, 11905, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 15:15:30', 'admin-1502340275-15023493303997426', 1, 1, 'SR', NULL, NULL, NULL),
(41687, '2017-08-10 12:28:33', NULL, NULL, 11899, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 12:28:33', 'admin-1502335407-1502339313526687', 1, 1, 'SR', NULL, NULL, NULL),
(41688, '2017-08-10 12:28:33', NULL, NULL, 11899, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 12:28:33', 'admin-1502335407-1502339313526687', 1, 0, '', NULL, NULL, NULL),
(41689, '2017-08-10 16:59:37', NULL, NULL, 11906, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1502340275', 'admin', '2017-08-10 16:59:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41690, '2017-08-10 11:54:16', NULL, NULL, 11897, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1502340275', 'admin', '2017-08-10 11:54:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41691, '2017-08-10 12:38:55', NULL, NULL, 11900, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 12:38:55', 'admin-1502335407-15023399347367691', 1, 1, 'SR', NULL, NULL, '10.0'),
(41692, '2017-08-10 12:41:38', NULL, NULL, 11900, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 12:41:38', 'admin-1502335407-15023400981639471', 1, 1, 'SR', NULL, NULL, '10.0'),
(41693, '2017-08-10 11:26:26', NULL, NULL, 11896, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 11:26:26', 'admin-1502335407-15023355858555543', 1, 0, '', NULL, NULL, NULL),
(41694, '2017-08-10 11:26:26', NULL, NULL, 11896, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 11:26:26', 'admin-1502335407-15023355858555543', 1, 0, '', NULL, NULL, NULL),
(41695, '2017-08-10 11:26:26', NULL, NULL, 11896, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 11:26:26', 'admin-1502335407-15023355858555543', 1, 1, 'SR', NULL, NULL, NULL),
(41696, '2017-08-10 11:26:26', NULL, NULL, 11896, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 11:26:26', 'admin-1502335407-15023355858555543', 1, 1, 'SR', NULL, NULL, NULL),
(41697, '2017-08-10 17:00:07', NULL, NULL, 11906, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 17:00:07', 'admin-1502340275-15023556072221086', 1, 1, 'SR', NULL, NULL, NULL),
(41698, '2017-08-10 17:00:07', NULL, NULL, 11906, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 17:00:07', 'admin-1502340275-15023556072221086', 1, 1, 'SR', NULL, NULL, NULL),
(41699, '2017-08-10 16:59:47', NULL, NULL, 11906, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 16:59:47', 'admin-1502340275-15023555873466289', 1, 1, 'SR', NULL, NULL, NULL),
(41700, '2017-08-10 14:44:28', NULL, NULL, 11903, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1502340275', 'admin', '2017-08-10 14:44:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41701, '2017-08-10 15:15:30', NULL, NULL, 11905, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 15:15:30', 'admin-1502340275-15023493303997426', 1, 1, 'SR', NULL, NULL, NULL),
(41702, '2017-08-10 15:15:30', NULL, NULL, 11905, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 15:15:30', 'admin-1502340275-15023493303997426', 1, 1, 'SR', NULL, NULL, NULL),
(41703, '2017-08-10 15:15:30', NULL, NULL, 11905, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 15:15:30', 'admin-1502340275-15023493303997426', 1, 1, 'SR', NULL, NULL, NULL),
(41704, '2017-08-10 09:42:06', NULL, NULL, 11887, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 09:42:06', 'admin-1502325747-15023293259321843', 1, 1, 'SR', NULL, NULL, NULL),
(41705, '2017-08-10 09:42:06', NULL, NULL, 11887, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 09:42:06', 'admin-1502325747-15023293259321843', 1, 1, 'SR', NULL, NULL, NULL),
(41706, '2017-08-10 09:46:20', NULL, NULL, 11888, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1502340275', 'admin', '2017-08-10 09:46:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41707, '2017-08-10 09:46:28', NULL, NULL, 11888, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 09:46:28', 'admin-1502325747-15023295878556543', 1, 0, '', NULL, NULL, NULL),
(41708, '2017-08-10 09:46:28', NULL, NULL, 11888, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 09:46:28', 'admin-1502325747-15023295878556543', 1, 0, '', NULL, NULL, NULL),
(41709, '2017-08-10 09:46:37', NULL, NULL, 11888, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 09:46:37', 'admin-1502325747-15023295970377135', 1, 1, 'SR', NULL, NULL, NULL),
(41710, '2017-08-10 09:46:37', NULL, NULL, 11888, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 09:46:37', 'admin-1502325747-15023295970377135', 1, 1, 'SR', NULL, NULL, NULL),
(41711, '2017-08-10 09:55:25', NULL, NULL, 11889, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1502340275', 'admin', '2017-08-10 09:55:25', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(41712, '2017-08-10 09:55:42', NULL, NULL, 11889, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 09:55:42', 'admin-1502325747-15023301422137996', 1, 0, '', NULL, NULL, '10.0'),
(41713, '2017-08-10 15:15:30', NULL, NULL, 11905, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 15:15:30', 'admin-1502340275-15023493303997426', 1, 1, 'SR', NULL, NULL, NULL),
(41714, '2017-08-10 13:40:30', NULL, NULL, 11900, 0, 181, '116', 'Open Food ', 'Coffee beans', 'Meals', 'Perfect Meals', 1, 38.00, 38.0000, 0.0000, 38.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 13:40:30', 'admin-1502340275-1502343630453287', 1, 0, '', NULL, NULL, '10.0'),
(41715, '2017-08-10 12:44:29', NULL, NULL, 11901, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 12:44:29', 'admin-1502335407-15023402697218342', 1, 1, 'SR', NULL, NULL, NULL),
(41716, '2017-08-10 12:38:33', NULL, NULL, 11900, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 12:38:33', 'admin-1502335407-15023399135663286', 1, 1, 'SR', NULL, NULL, '10.0'),
(41717, '2017-08-10 09:41:57', NULL, NULL, 11887, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 09:41:57', 'admin-1502325747-15023293176794843', 1, 0, '', NULL, NULL, NULL),
(41718, '2017-08-10 12:44:29', NULL, NULL, 11901, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 12:44:29', 'admin-1502335407-15023402697218342', 1, 0, '', NULL, NULL, NULL),
(41719, '2017-08-10 12:44:15', NULL, NULL, 11901, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1502340275', 'admin', '2017-08-10 12:44:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41720, '2017-08-10 12:38:03', NULL, NULL, 11900, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.30, 0.0000, 0.0000, 13.30, 1, '27', 1, '1502340275', 'admin', '2017-08-10 12:38:03', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(41721, '2017-08-10 10:47:35', NULL, NULL, 11891, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 10:47:35', 'admin-1502325747-1502333255234173', 1, 1, 'SR', NULL, NULL, NULL),
(41722, '2017-08-10 10:47:35', NULL, NULL, 11891, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 10:47:35', 'admin-1502325747-1502333255234173', 1, 1, 'SR', NULL, NULL, NULL),
(41723, '2017-08-10 10:52:14', NULL, NULL, 11891, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 10:52:14', 'admin-1502325747-15023335345496619', 1, 0, '', NULL, NULL, NULL),
(41724, '2017-08-10 09:41:57', NULL, NULL, 11887, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 09:41:57', 'admin-1502325747-15023293176794843', 1, 0, '', NULL, NULL, NULL),
(41725, '2017-08-10 09:42:06', NULL, NULL, 11887, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 09:42:06', 'admin-1502325747-15023293259321843', 1, 1, 'SR', NULL, NULL, NULL),
(41726, '2017-08-10 12:38:55', NULL, NULL, 11900, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 12:38:55', 'admin-1502335407-15023399347367691', 1, 0, '', NULL, NULL, '10.0'),
(41727, '2017-08-10 12:28:33', NULL, NULL, 11899, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 12:28:33', 'admin-1502335407-1502339313526687', 1, 1, 'SR', NULL, NULL, NULL),
(41728, '2017-08-10 12:28:33', NULL, NULL, 11899, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 12:28:33', 'admin-1502335407-1502339313526687', 1, 1, 'SR', NULL, NULL, NULL),
(41729, '2017-08-10 12:28:11', NULL, NULL, 11899, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1502340275', 'admin', '2017-08-10 12:28:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41730, '2017-08-10 12:16:40', NULL, NULL, 11898, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 12:16:40', 'admin-1502335407-15023386005108513', 1, 1, 'SR', NULL, NULL, NULL),
(41731, '2017-08-10 11:54:19', NULL, NULL, 11897, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 11:54:19', 'admin-1502335407-15023372596045587', 1, 1, 'SR', NULL, NULL, NULL),
(41732, '2017-08-10 11:50:05', NULL, NULL, 11896, 0, 181, '116', 'Open Food ', 'whipped cream', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 11:50:05', 'admin-1502335407-15023370048702326', 1, 0, '', NULL, NULL, NULL),
(41733, '2017-08-10 12:16:33', NULL, NULL, 11898, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1502340275', 'admin', '2017-08-10 12:16:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41734, '2017-08-10 11:26:26', NULL, NULL, 11896, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 11:26:26', 'admin-1502335407-15023355858555543', 1, 0, '', NULL, NULL, NULL),
(41735, '2017-08-10 11:26:09', NULL, NULL, 11896, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 11:26:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41736, '2017-08-10 11:16:50', NULL, NULL, 11895, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 11:16:50', 'admin-1502325747-15023350105609955', 1, 1, 'SR', NULL, NULL, NULL),
(41737, '2017-08-10 11:16:50', NULL, NULL, 11895, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 11:16:50', 'admin-1502325747-15023350105609955', 1, 0, '', NULL, NULL, NULL),
(41738, '2017-08-10 11:16:50', NULL, NULL, 11895, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 11:16:50', 'admin-1502325747-15023350105609955', 1, 1, 'SR', NULL, NULL, NULL),
(41739, '2017-08-10 11:12:59', NULL, NULL, 11894, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1502340275', 'admin', '2017-08-10 11:12:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41740, '2017-08-10 11:13:05', NULL, NULL, 11894, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 11:13:05', 'admin-1502325747-15023347851028064', 1, 1, 'SR', NULL, NULL, NULL),
(41741, '2017-08-10 11:16:40', NULL, NULL, 11895, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1502340275', 'admin', '2017-08-10 11:16:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41742, '2017-08-10 10:54:11', NULL, NULL, 11892, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 10:54:11', 'admin-1502325747-15023336512182470', 1, 0, '', NULL, NULL, NULL),
(41743, '2017-08-10 10:54:11', NULL, NULL, 11892, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 10:54:11', 'admin-1502325747-15023336512182470', 1, 1, 'SR', NULL, NULL, NULL),
(41744, '2017-08-10 10:57:50', NULL, NULL, 11893, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1502340275', 'admin', '2017-08-10 10:57:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41745, '2017-08-10 10:52:14', NULL, NULL, 11891, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 10:52:14', 'admin-1502325747-15023335345496619', 1, 0, '', NULL, NULL, NULL),
(41746, '2017-08-10 10:52:23', NULL, NULL, 11892, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 10:52:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41747, '2017-08-10 10:52:30', NULL, NULL, 11892, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 10:52:30', 'admin-1502325747-15023335504307382', 1, 1, 'SR', NULL, NULL, NULL),
(41748, '2017-08-10 10:47:29', NULL, NULL, 11891, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 10:47:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41749, '2017-08-10 10:36:05', NULL, NULL, 11889, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 10:36:05', 'admin-1502325747-1502332565194228', 1, 1, 'SR', NULL, NULL, '10.0'),
(41750, '2017-08-10 10:46:13', NULL, NULL, 11890, 0, 182, '117', 'Open Drinks ', 'omellet', 'Cold Drinks', 'Fresh Juice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 10:46:13', 'admin-1502325747-15023331733358041', 1, 0, '', 1, NULL, '10.0'),
(41751, '2017-08-10 10:36:05', NULL, NULL, 11889, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 10:36:05', 'admin-1502325747-1502332565194228', 1, 1, 'SR', NULL, NULL, '10.0'),
(41752, '2017-08-10 09:55:42', NULL, NULL, 11889, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 09:55:42', 'admin-1502325747-15023301422137996', 1, 1, 'SR', NULL, NULL, '10.0'),
(41753, '2017-08-10 09:55:42', NULL, NULL, 11889, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 09:55:42', 'admin-1502325747-15023301422137996', 1, 1, 'SR', NULL, NULL, '10.0'),
(41754, '2017-08-10 09:55:42', NULL, NULL, 11889, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 09:55:42', 'admin-1502325747-15023301422137996', 1, 0, '', NULL, NULL, '10.0'),
(41755, '2017-08-10 09:41:57', NULL, NULL, 11887, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502340275', 'admin', '2017-08-10 09:41:57', 'admin-1502325747-15023293176794843', 1, 0, '', NULL, NULL, NULL),
(41756, '2017-08-10 09:41:47', NULL, NULL, 11887, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1502340275', 'admin', '2017-08-10 09:41:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41757, '2017-08-11 12:58:13', NULL, NULL, 11920, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 12:58:13', 'admin-1502422481-15024274934874839', 1, 1, 'SR', NULL, NULL, NULL),
(41758, '2017-08-11 12:58:13', NULL, NULL, 11920, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 12:58:13', 'admin-1502422481-15024274934874839', 1, 1, 'SR', NULL, NULL, NULL),
(41759, '2017-08-11 11:13:11', NULL, NULL, 11912, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:13:11', 'admin-1502411696-15024211913521511', 1, 1, 'SR', NULL, NULL, NULL),
(41760, '2017-08-11 16:54:45', NULL, NULL, 11932, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 16:54:45', 'admin-1502433080-1502441685290485', 1, 1, 'SR', NULL, NULL, NULL),
(41761, '2017-08-11 14:41:58', NULL, NULL, 11930, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 14:41:58', 'admin-1502433080-15024337179513249', 1, 1, 'SR', NULL, NULL, NULL),
(41762, '2017-08-11 15:07:37', NULL, NULL, 11931, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 15:07:37', 'admin-1502433080-15024352574658676', 1, 1, 'SR', NULL, NULL, NULL),
(41763, '2017-08-11 13:50:01', NULL, NULL, 11926, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:50:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41764, '2017-08-11 13:23:46', NULL, NULL, 11923, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:23:46', 'admin-1502427641-15024290259016772', 1, 1, 'SR', NULL, NULL, NULL),
(41765, '2017-08-11 13:23:46', NULL, NULL, 11923, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:23:46', 'admin-1502427641-15024290259016772', 1, 1, 'SR', NULL, NULL, NULL),
(41766, '2017-08-11 13:25:12', NULL, NULL, 11924, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:25:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41767, '2017-08-11 13:25:18', NULL, NULL, 11924, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:25:18', 'admin-1502427641-15024291180076210', 1, 1, 'SR', NULL, NULL, NULL),
(41768, '2017-08-11 13:26:25', NULL, NULL, 11919, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:26:25', 'admin-1502427641-15024291848476133', 1, 1, 'SR', NULL, NULL, NULL),
(41769, '2017-08-11 13:34:05', NULL, NULL, 11920, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:34:05', 'admin-1502427641-15024296453319281', 1, 0, '', NULL, NULL, NULL),
(41770, '2017-08-11 13:37:07', NULL, NULL, 11925, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:37:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41771, '2017-08-11 13:37:27', NULL, NULL, 11925, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:37:27', 'admin-1502427641-15024298471718613', 1, 0, '', NULL, NULL, NULL),
(41772, '2017-08-11 12:52:17', NULL, NULL, 11919, 0, 153, '87', 'Wake Me Up!', ',No baked beans', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 12:52:17', 'admin-1502422481-15024271376088897', 1, 0, '', NULL, NULL, NULL),
(41773, '2017-08-11 14:40:37', NULL, NULL, 11930, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1502433080', 'admin', '2017-08-11 14:40:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41774, '2017-08-11 15:07:32', NULL, NULL, 11931, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1502433080', 'admin', '2017-08-11 15:07:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41775, '2017-08-11 14:21:51', NULL, NULL, 11927, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 14:21:51', 'admin-1502427641-15024325114469361', 1, 0, '', NULL, NULL, NULL),
(41776, '2017-08-11 14:30:42', NULL, NULL, 11929, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1502433080', 'admin', '2017-08-11 14:30:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41777, '2017-08-11 14:31:00', NULL, NULL, 11929, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 14:31:00', 'admin-1502427641-1502433060728864', 1, 1, 'SR', NULL, NULL, NULL),
(41778, '2017-08-11 14:31:01', NULL, NULL, 11929, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 14:31:01', 'admin-1502427641-1502433060728864', 1, 1, 'SR', NULL, NULL, NULL),
(41779, '2017-08-11 14:31:01', NULL, NULL, 11929, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 14:31:01', 'admin-1502427641-1502433060728864', 1, 1, 'SR', NULL, NULL, NULL),
(41780, '2017-08-11 12:52:05', NULL, NULL, 11919, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1502433080', 'admin', '2017-08-11 12:52:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41781, '2017-08-11 14:03:46', NULL, NULL, 11928, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1502433080', 'admin', '2017-08-11 14:03:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41782, '2017-08-11 16:54:41', NULL, NULL, 11932, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1502433080', 'admin', '2017-08-11 16:54:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41783, '2017-08-11 14:41:58', NULL, NULL, 11930, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 14:41:58', 'admin-1502433080-15024337179513249', 1, 1, 'SR', NULL, NULL, NULL),
(41784, '2017-08-11 13:40:02', NULL, NULL, 11925, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:40:02', 'admin-1502427641-15024300022079660', 1, 1, 'SR', NULL, NULL, NULL),
(41785, '2017-08-11 13:40:02', NULL, NULL, 11925, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:40:02', 'admin-1502427641-15024300022079660', 1, 0, '', NULL, NULL, NULL),
(41786, '2017-08-11 12:58:45', NULL, NULL, 11921, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1502433080', 'admin', '2017-08-11 12:58:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41787, '2017-08-11 12:59:09', NULL, NULL, 11921, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 12:59:09', 'admin-1502422481-15024275488886741', 1, 1, 'SR', NULL, NULL, NULL),
(41788, '2017-08-11 12:59:09', NULL, NULL, 11921, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 12:59:09', 'admin-1502422481-15024275488886741', 1, 1, 'SR', NULL, NULL, NULL),
(41789, '2017-08-11 12:59:09', NULL, NULL, 11921, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 12:59:09', 'admin-1502422481-15024275488886741', 1, 1, 'SR', NULL, NULL, NULL),
(41790, '2017-08-11 12:59:09', NULL, NULL, 11921, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 12:59:09', 'admin-1502422481-15024275488886741', 1, 1, 'SR', NULL, NULL, NULL),
(41791, '2017-08-11 12:59:09', NULL, NULL, 11921, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 12:59:09', 'admin-1502422481-15024275488886741', 1, 0, '', NULL, NULL, NULL),
(41792, '2017-08-11 13:00:34', NULL, NULL, 11920, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:00:34', 'admin-1502422481-15024276342823777', 1, 1, 'SR', NULL, NULL, NULL),
(41793, '2017-08-11 14:31:01', NULL, NULL, 11929, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 14:31:01', 'admin-1502427641-1502433060728864', 1, 1, 'SR', NULL, NULL, NULL),
(41794, '2017-08-11 14:31:00', NULL, NULL, 11929, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 14:31:01', 'admin-1502427641-1502433060728864', 1, 1, 'SR', NULL, NULL, NULL),
(41795, '2017-08-11 14:31:00', NULL, NULL, 11929, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 14:31:00', 'admin-1502427641-1502433060728864', 1, 1, 'SR', NULL, NULL, NULL),
(41796, '2017-08-11 14:03:53', NULL, NULL, 11928, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 14:03:53', 'admin-1502427641-15024314336173239', 1, 1, 'SR', NULL, NULL, NULL),
(41797, '2017-08-11 13:50:49', NULL, NULL, 11927, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:50:49', 'admin-1502427641-15024306495925579', 1, 1, 'SR', NULL, NULL, NULL),
(41798, '2017-08-11 13:37:27', NULL, NULL, 11925, 0, 223, '157', 'Crispy Bacon Aglio Olio', 'no spicy', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:37:27', 'admin-1502427641-15024298471718613', 1, 0, '', NULL, NULL, NULL),
(41799, '2017-08-11 13:37:27', NULL, NULL, 11925, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:37:27', 'admin-1502427641-15024298471718613', 1, 0, '', NULL, NULL, NULL),
(41800, '2017-08-11 13:07:03', NULL, NULL, 11923, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:07:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41801, '2017-08-11 13:50:05', NULL, NULL, 11926, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:50:05', 'admin-1502427641-15024306053317523', 1, 0, '', NULL, NULL, NULL),
(41802, '2017-08-11 12:42:27', NULL, NULL, 11918, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1502433080', 'admin', '2017-08-11 12:42:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41803, '2017-08-11 12:42:31', NULL, NULL, 11918, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 12:42:31', 'admin-1502422481-15024265511613360', 1, 0, '', NULL, NULL, NULL),
(41804, '2017-08-11 11:34:56', NULL, NULL, 11913, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:34:56', 'admin-1502422481-1502422496697983', 1, 1, 'SR', NULL, NULL, NULL),
(41805, '2017-08-11 11:38:24', NULL, NULL, 11914, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:38:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41806, '2017-08-11 11:38:32', NULL, NULL, 11914, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:38:32', 'admin-1502422481-15024227123581820', 1, 0, '', NULL, NULL, NULL),
(41807, '2017-08-11 11:38:32', NULL, NULL, 11914, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:38:32', 'admin-1502422481-15024227123581820', 1, 0, '', NULL, NULL, NULL),
(41808, '2017-08-11 13:09:05', NULL, NULL, 11921, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:09:05', 'admin-1502427641-15024281447694382', 1, 1, 'SR', NULL, NULL, NULL),
(41809, '2017-08-11 13:07:09', NULL, NULL, 11923, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:07:09', 'admin-1502427641-15024280294996511', 1, 0, '', NULL, NULL, NULL),
(41810, '2017-08-11 13:50:44', NULL, NULL, 11927, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:50:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41811, '2017-08-11 13:09:05', NULL, NULL, 11921, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:09:05', 'admin-1502427641-15024281447694382', 1, 1, 'SR', NULL, NULL, NULL),
(41812, '2017-08-11 13:07:09', NULL, NULL, 11923, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:07:09', 'admin-1502427641-15024280294996511', 1, 1, 'SR', NULL, NULL, NULL),
(41813, '2017-08-11 13:01:03', NULL, NULL, 11922, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:01:03', 'admin-1502427641-1502427663071642', 1, 1, 'SR', NULL, NULL, NULL),
(41814, '2017-08-11 13:01:03', NULL, NULL, 11922, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:01:03', 'admin-1502427641-1502427663071642', 1, 1, 'SR', NULL, NULL, NULL),
(41815, '2017-08-11 13:01:03', NULL, NULL, 11922, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:01:03', 'admin-1502427641-1502427663071642', 1, 1, 'SR', NULL, NULL, NULL),
(41816, '2017-08-11 13:00:34', NULL, NULL, 11920, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:00:34', 'admin-1502422481-15024276342823777', 1, 1, 'SR', NULL, NULL, NULL),
(41817, '2017-08-11 10:32:40', NULL, NULL, 11909, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 10:32:40', 'admin-1502411696-15024187599246510', 1, 0, '', NULL, NULL, NULL),
(41818, '2017-08-11 10:32:40', NULL, NULL, 11909, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 10:32:40', 'admin-1502411696-15024187599246510', 1, 0, '', NULL, NULL, NULL),
(41819, '2017-08-11 10:45:53', NULL, NULL, 11910, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1502433080', 'admin', '2017-08-11 10:45:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41820, '2017-08-11 10:45:56', NULL, NULL, 11910, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 10:45:56', 'admin-1502411696-1502419556414474', 1, 1, 'SR', NULL, NULL, NULL),
(41821, '2017-08-11 10:46:59', NULL, NULL, 11911, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1502433080', 'admin', '2017-08-11 10:46:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41822, '2017-08-11 10:47:07', NULL, NULL, 11911, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 10:47:07', 'admin-1502411696-15024196268928041', 1, 0, '', NULL, NULL, NULL),
(41823, '2017-08-11 10:47:07', NULL, NULL, 11911, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 10:47:07', 'admin-1502411696-15024196268928041', 1, 0, '', NULL, NULL, NULL),
(41824, '2017-08-11 10:47:07', NULL, NULL, 11911, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 10:47:07', 'admin-1502411696-15024196268928041', 1, 1, 'SR', NULL, NULL, NULL),
(41825, '2017-08-11 10:47:07', NULL, NULL, 11911, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 10:47:07', 'admin-1502411696-15024196268928041', 1, 1, 'SR', NULL, NULL, NULL),
(41826, '2017-08-11 11:12:50', NULL, NULL, 11912, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.29, 0.0000, 0.0000, 9.29, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:12:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41827, '2017-08-11 13:40:02', NULL, NULL, 11925, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:40:02', 'admin-1502427641-15024300022079660', 1, 0, '', NULL, NULL, NULL),
(41828, '2017-08-11 13:00:52', NULL, NULL, 11922, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:00:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41829, '2017-08-11 12:58:13', NULL, NULL, 11920, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 12:58:13', 'admin-1502422481-15024274934874839', 1, 0, '', NULL, NULL, NULL),
(41830, '2017-08-11 12:57:56', NULL, NULL, 11920, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1502433080', 'admin', '2017-08-11 12:57:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41831, '2017-08-11 13:00:34', NULL, NULL, 11920, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:00:34', 'admin-1502422481-15024276342823777', 1, 0, '', NULL, NULL, NULL),
(41832, '2017-08-11 13:50:05', NULL, NULL, 11926, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 13:50:05', 'admin-1502427641-15024306053317523', 1, 1, 'SR', NULL, NULL, NULL),
(41833, '2017-08-11 12:27:45', NULL, NULL, 11914, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 12:27:45', 'admin-1502422481-1502425665494877', 1, 0, '', NULL, NULL, NULL),
(41834, '2017-08-11 12:33:54', NULL, NULL, 11917, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1502433080', 'admin', '2017-08-11 12:33:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41835, '2017-08-11 12:34:03', NULL, NULL, 11917, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 12:34:03', 'admin-1502422481-1502426042778394', 1, 1, 'SR', NULL, NULL, NULL),
(41836, '2017-08-11 12:34:03', NULL, NULL, 11917, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 12:34:03', 'admin-1502422481-1502426042778394', 1, 0, '', NULL, NULL, NULL),
(41837, '2017-08-11 09:03:14', NULL, NULL, 11907, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 09:03:14', 'admin-1502411696-1502413394324798', 1, 0, '', NULL, NULL, NULL),
(41838, '2017-08-11 09:03:14', NULL, NULL, 11907, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 09:03:14', 'admin-1502411696-1502413394324798', 1, 0, '', NULL, NULL, NULL),
(41839, '2017-08-11 09:03:19', NULL, NULL, 11907, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 09:03:19', 'admin-1502411696-15024133993913871', 1, 1, 'SR', NULL, NULL, NULL),
(41840, '2017-08-11 12:42:35', NULL, NULL, 11918, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 12:42:35', 'admin-1502422481-1502426555600232', 1, 1, 'SR', NULL, NULL, NULL),
(41841, '2017-08-11 12:10:26', NULL, NULL, 11916, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 12:10:26', 'admin-1502422481-15024246266462170', 1, 0, '', 1, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(41842, '2017-08-11 11:52:10', NULL, NULL, 11915, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:52:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41843, '2017-08-11 11:52:17', NULL, NULL, 11915, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:52:17', 'admin-1502422481-15024235376756599', 1, 1, 'SR', NULL, NULL, NULL),
(41844, '2017-08-11 11:13:11', NULL, NULL, 11912, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:13:11', 'admin-1502411696-15024211913521511', 1, 1, 'SR', NULL, NULL, NULL),
(41845, '2017-08-11 11:52:04', NULL, NULL, 11914, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:52:04', 'admin-1502422481-15024235239574392', 1, 0, '', NULL, NULL, NULL),
(41846, '2017-08-11 11:39:08', NULL, NULL, 11914, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:39:08', 'admin-1502422481-15024227480145822', 1, 1, 'SR', NULL, NULL, NULL),
(41847, '2017-08-11 11:48:04', NULL, NULL, 11914, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:48:04', 'admin-1502422481-15024232840833591', 1, 0, '', NULL, NULL, NULL),
(41848, '2017-08-11 11:39:08', NULL, NULL, 11914, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:39:08', 'admin-1502422481-15024227480145822', 1, 1, 'SR', NULL, NULL, NULL),
(41849, '2017-08-11 11:34:56', NULL, NULL, 11913, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:34:56', 'admin-1502422481-1502422496697983', 1, 1, 'SR', NULL, NULL, NULL),
(41850, '2017-08-11 11:34:56', NULL, NULL, 11913, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:34:56', 'admin-1502422481-1502422496697983', 1, 1, 'SR', NULL, NULL, NULL),
(41851, '2017-08-11 11:34:56', NULL, NULL, 11913, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:34:56', 'admin-1502422481-1502422496697983', 1, 1, 'SR', NULL, NULL, NULL),
(41852, '2017-08-11 11:31:14', NULL, NULL, 11912, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:31:14', 'admin-1502411696-15024222742721930', 1, 0, '', NULL, NULL, NULL),
(41853, '2017-08-11 11:34:08', NULL, NULL, 11908, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:34:08', 'admin-1502411696-15024224486379337', 1, 1, 'SR', NULL, NULL, NULL),
(41854, '2017-08-11 11:34:12', NULL, NULL, 11913, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:34:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41855, '2017-08-11 11:34:20', NULL, NULL, 11913, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:34:20', 'admin-1502411696-15024224599667789', 1, 0, '', NULL, NULL, NULL),
(41856, '2017-08-11 11:34:20', NULL, NULL, 11913, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:34:20', 'admin-1502411696-15024224599667789', 1, 0, '', NULL, NULL, NULL),
(41857, '2017-08-11 11:13:11', NULL, NULL, 11912, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:13:11', 'admin-1502411696-15024211913521511', 1, 1, 'SR', NULL, NULL, NULL),
(41858, '2017-08-11 11:13:11', NULL, NULL, 11912, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:13:11', 'admin-1502411696-15024211913521511', 1, 1, 'SR', NULL, NULL, NULL),
(41859, '2017-08-11 11:13:11', NULL, NULL, 11912, 0, 158, '92', 'Banana Stuffed Nutella Toast ', 'No banana', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:13:11', 'admin-1502411696-15024211913521511', 1, 0, '', NULL, NULL, NULL),
(41860, '2017-08-11 11:13:11', NULL, NULL, 11912, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:13:11', 'admin-1502411696-15024211913521511', 1, 0, '', NULL, NULL, NULL),
(41861, '2017-08-11 11:13:11', NULL, NULL, 11912, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 11:13:11', 'admin-1502411696-15024211913521511', 1, 0, '', NULL, NULL, NULL),
(41862, '2017-08-11 10:29:03', NULL, NULL, 11909, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1502433080', 'admin', '2017-08-11 10:29:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41863, '2017-08-11 10:29:37', NULL, NULL, 11909, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 10:29:37', 'admin-1502411696-15024185776044189', 1, 1, 'SR', NULL, NULL, NULL),
(41864, '2017-08-11 10:29:37', NULL, NULL, 11909, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 10:29:37', 'admin-1502411696-15024185776044189', 1, 1, 'SR', NULL, NULL, NULL),
(41865, '2017-08-11 10:21:17', NULL, NULL, 11908, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 10:21:17', 'admin-1502411696-15024180777572961', 1, 1, 'SR', NULL, NULL, NULL),
(41866, '2017-08-11 10:20:20', NULL, NULL, 11908, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 10:20:20', 'admin-1502411696-1502418020367502', 1, 0, '', NULL, NULL, NULL),
(41867, '2017-08-11 10:18:56', NULL, NULL, 11908, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1502433080', 'admin', '2017-08-11 10:18:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41868, '2017-08-11 09:03:19', NULL, NULL, 11907, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 09:03:19', 'admin-1502411696-15024133993913871', 1, 1, 'SR', NULL, NULL, NULL),
(41869, '2017-08-11 09:03:19', NULL, NULL, 11907, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502433080', 'admin', '2017-08-11 09:03:19', 'admin-1502411696-15024133993913871', 1, 1, 'SR', NULL, NULL, NULL),
(41870, '2017-08-11 09:01:44', NULL, NULL, 11907, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1502433080', 'admin', '2017-08-11 09:01:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41871, '2017-08-12 10:47:00', NULL, NULL, 11951, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:47:00', 'admin-1502505146-15025060205249976', 1, 0, '', NULL, NULL, NULL),
(41872, '2017-08-12 16:00:56', NULL, NULL, 11975, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 16:00:56', 'admin-1502511755-15025248564791653', 1, 0, '', NULL, NULL, NULL),
(41873, '2017-08-12 14:33:16', NULL, NULL, 11969, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 14:33:16', 'admin-1502511755-15025195964163253', 1, 1, 'SR', NULL, NULL, NULL),
(41874, '2017-08-12 16:03:33', NULL, NULL, 11975, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 16:03:33', 'admin-1502511755-15025250134265960', 1, 1, 'SR', NULL, NULL, NULL),
(41875, '2017-08-12 15:50:39', NULL, NULL, 11974, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 15:50:39', 'admin-1502511755-1502524239378171', 1, 0, '', NULL, NULL, NULL),
(41876, '2017-08-12 15:50:39', NULL, NULL, 11974, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 15:50:39', 'admin-1502511755-1502524239378171', 1, 1, 'SR', NULL, NULL, NULL),
(41877, '2017-08-12 15:51:54', NULL, NULL, 11974, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 15:51:54', 'admin-1502511755-1502524314400827', 1, 1, 'SR', NULL, NULL, NULL),
(41878, '2017-08-12 13:45:11', NULL, NULL, 11965, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 13:45:11', 'admin-1502511755-15025167116701124', 1, 1, 'SR', NULL, NULL, NULL),
(41879, '2017-08-12 13:45:11', NULL, NULL, 11965, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 13:45:11', 'admin-1502511755-15025167116701124', 1, 1, 'SR', NULL, NULL, NULL),
(41880, '2017-08-12 13:45:11', NULL, NULL, 11965, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 13:45:11', 'admin-1502511755-15025167116701124', 1, 1, 'SR', NULL, NULL, NULL),
(41881, '2017-08-12 13:45:11', NULL, NULL, 11965, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 13:45:11', 'admin-1502511755-15025167116701124', 1, 1, 'SR', NULL, NULL, NULL),
(41882, '2017-08-12 15:33:49', NULL, NULL, 11973, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 15:33:49', 'admin-1502511755-15025232296638458', 1, 0, '', NULL, NULL, NULL),
(41883, '2017-08-12 15:33:49', NULL, NULL, 11973, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 15:33:49', 'admin-1502511755-15025232296638458', 1, 1, 'SR', NULL, NULL, NULL),
(41884, '2017-08-12 00:00:00', NULL, NULL, 11966, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 13:11:11', 'admin-1502511755-15025146716092388', 1, 0, '', NULL, NULL, NULL),
(41885, '2017-08-12 09:58:45', NULL, NULL, 11945, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:58:45', 'admin-1502502817-1502503124961942', 1, 1, 'SR', NULL, NULL, NULL),
(41886, '2017-08-12 09:58:45', NULL, NULL, 11945, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:58:45', 'admin-1502502817-1502503124961942', 1, 1, 'SR', NULL, NULL, NULL),
(41887, '2017-08-12 09:58:45', NULL, NULL, 11945, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:58:45', 'admin-1502502817-1502503124961942', 1, 1, 'SR', NULL, NULL, NULL),
(41888, '2017-08-12 15:00:33', NULL, NULL, 11972, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 15:00:33', 'admin-1502511755-15025212335539322', 1, 1, 'SR', NULL, NULL, NULL),
(41889, '2017-08-12 14:03:45', NULL, NULL, 11969, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 14:03:45', 'admin-1502511755-15025178251145919', 1, 1, 'SR', NULL, NULL, NULL),
(41890, '2017-08-12 14:03:08', NULL, NULL, 11969, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1502511755', 'admin', '2017-08-12 14:03:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41891, '2017-08-12 13:45:11', NULL, NULL, 11965, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 13:45:11', 'admin-1502511755-15025167116701124', 1, 1, 'SR', NULL, NULL, NULL),
(41892, '2017-08-12 13:45:11', NULL, NULL, 11965, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 13:45:11', 'admin-1502511755-15025167116701124', 1, 1, 'SR', NULL, NULL, NULL),
(41893, '2017-08-12 13:44:39', NULL, NULL, 11965, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.69, 0.0000, 0.0000, 9.69, 1, '27', 1, '1502511755', 'admin', '2017-08-12 13:44:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41894, '2017-08-12 00:00:00', NULL, NULL, 11966, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, NULL, NULL, 2.10, 1, '27', 1, '1502511755', 'admin', '2017-08-12 13:10:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41895, '2017-08-12 13:44:07', NULL, NULL, 11962, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 13:44:07', 'admin-1502511755-15025166476506229', 1, 1, 'SR', NULL, NULL, NULL),
(41896, '2017-08-12 13:52:48', NULL, NULL, 11962, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 13:52:48', 'admin-1502511755-15025171686328222', 1, 1, 'SR', NULL, NULL, NULL),
(41897, '2017-08-12 16:37:37', NULL, NULL, 11969, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 16:37:37', 'admin-1502511755-15025270571188882', 1, 0, '', NULL, NULL, NULL),
(41898, '2017-08-12 16:56:26', NULL, NULL, 11976, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 16:56:26', 'admin-1502511755-1502528186073273', 1, 0, '', NULL, NULL, NULL),
(41899, '2017-08-12 16:37:37', NULL, NULL, 11969, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 16:37:37', 'admin-1502511755-15025270571188882', 1, 0, '', NULL, NULL, NULL),
(41900, '2017-08-12 16:44:34', NULL, NULL, 11975, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 16:44:34', 'admin-1502511755-15025274743947821', 1, 0, '', NULL, NULL, NULL),
(41901, '2017-08-12 12:43:49', NULL, NULL, 11957, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 12:43:49', 'admin-1502511755-15025130293621721', 1, 0, '', NULL, NULL, NULL),
(41902, '2017-08-12 12:41:20', NULL, NULL, 11963, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 12:41:20', 'admin-1502511755-15025128807528845', 1, 0, '', 1, NULL, NULL),
(41903, '2017-08-12 12:22:20', NULL, NULL, 11960, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1502511755', 'admin', '2017-08-12 12:22:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41904, '2017-08-12 09:44:32', NULL, NULL, 11940, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:44:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41905, '2017-08-12 09:44:47', NULL, NULL, 11940, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:44:47', 'admin-1502501091-15025022869932751', 1, 0, '', NULL, NULL, NULL),
(41906, '2017-08-12 11:33:23', NULL, NULL, 11955, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:33:23', 'admin-1502505146-15025088030359895', 1, 1, 'SR', NULL, NULL, NULL),
(41907, '2017-08-12 11:33:06', NULL, NULL, 11955, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:33:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41908, '2017-08-12 11:33:23', NULL, NULL, 11955, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:33:23', 'admin-1502505146-15025088030359895', 1, 0, '', NULL, NULL, NULL),
(41909, '2017-08-12 11:33:23', NULL, NULL, 11955, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:33:23', 'admin-1502505146-15025088030359895', 1, 0, '', NULL, NULL, NULL),
(41910, '2017-08-12 12:39:47', NULL, NULL, 11962, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 12:39:47', 'admin-1502511755-15025127869825566', 1, 1, 'SR', NULL, NULL, NULL),
(41911, '2017-08-12 11:37:43', NULL, NULL, 11957, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:37:43', 'admin-1502505146-15025090629009058', 1, 0, '', NULL, NULL, NULL),
(41912, '2017-08-12 15:57:37', NULL, NULL, 11975, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 15:57:37', 'admin-1502511755-15025246572142090', 1, 0, '', NULL, NULL, NULL),
(41913, '2017-08-12 12:39:47', NULL, NULL, 11962, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 12:39:47', 'admin-1502511755-15025127869825566', 1, 1, 'SR', NULL, NULL, NULL),
(41914, '2017-08-12 12:39:47', NULL, NULL, 11962, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 12:39:47', 'admin-1502511755-15025127869825566', 1, 0, '', NULL, NULL, NULL),
(41915, '2017-08-12 11:22:45', NULL, NULL, 11954, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:22:45', 'admin-1502505146-15025081650966032', 1, 0, '', NULL, NULL, NULL),
(41916, '2017-08-12 11:22:45', NULL, NULL, 11954, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:22:45', 'admin-1502505146-15025081650966032', 1, 0, '', NULL, NULL, NULL),
(41917, '2017-08-12 11:22:45', NULL, NULL, 11954, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:22:45', 'admin-1502505146-15025081650966032', 1, 1, 'SR', NULL, NULL, NULL),
(41918, '2017-08-12 09:49:42', NULL, NULL, 11943, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:49:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41919, '2017-08-12 09:49:59', NULL, NULL, 11943, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:49:59', 'admin-1502501091-15025025992788846', 1, 0, '', NULL, NULL, NULL),
(41920, '2017-08-12 09:49:59', NULL, NULL, 11943, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:49:59', 'admin-1502501091-15025025992788846', 1, 0, '', NULL, NULL, NULL),
(41921, '2017-08-12 09:49:59', NULL, NULL, 11943, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:49:59', 'admin-1502501091-15025025992788846', 1, 1, 'SR', NULL, NULL, NULL),
(41922, '2017-08-12 09:51:10', NULL, NULL, 11944, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:51:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41923, '2017-08-12 09:51:19', NULL, NULL, 11944, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:51:19', 'admin-1502501091-15025026798249240', 1, 0, '', NULL, NULL, NULL),
(41924, '2017-08-12 16:46:37', NULL, NULL, 11976, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 16:46:37', 'admin-1502511755-15025275975246978', 1, 0, '', NULL, NULL, NULL),
(41925, '2017-08-12 16:49:48', NULL, NULL, 11976, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1502511755', 'admin', '2017-08-12 16:49:48', 'admin-1502511755-15025277881384276', 1, 0, '', NULL, NULL, NULL),
(41926, '2017-08-12 11:46:16', NULL, NULL, 11952, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:46:16', 'admin-1502505146-15025095764458751', 1, 0, '', NULL, NULL, NULL),
(41927, '2017-08-12 11:46:16', NULL, NULL, 11952, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:46:16', 'admin-1502505146-15025095764458751', 1, 0, '', NULL, NULL, NULL),
(41928, '2017-08-12 11:46:30', NULL, NULL, 11958, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:46:30', 'admin-1502505146-15025095903556873', 1, 1, 'SR', 1, NULL, NULL),
(41929, '2017-08-12 11:46:30', NULL, NULL, 11958, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:46:30', 'admin-1502505146-15025095903556873', 1, 1, 'SR', 1, NULL, NULL),
(41930, '2017-08-12 12:39:47', NULL, NULL, 11962, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 12:39:47', 'admin-1502511755-15025127869825566', 1, 0, '', NULL, NULL, NULL),
(41931, '2017-08-12 12:39:47', NULL, NULL, 11962, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 12:39:47', 'admin-1502511755-15025127869825566', 1, 0, '', NULL, NULL, NULL),
(41932, '2017-08-12 12:33:34', NULL, NULL, 11961, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 12:33:34', 'admin-1502511755-15025124141713795', 1, 1, 'SR', NULL, NULL, '10.0'),
(41933, '2017-08-12 12:39:25', NULL, NULL, 11962, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.60, 0.0000, 0.0000, 12.60, 1, '27', 1, '1502511755', 'admin', '2017-08-12 12:39:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41934, '2017-08-12 12:33:34', NULL, NULL, 11961, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 12:33:34', 'admin-1502511755-15025124141713795', 1, 0, '', NULL, NULL, '10.0'),
(41935, '2017-08-12 12:33:12', NULL, NULL, 11961, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1502511755', 'admin', '2017-08-12 12:33:12', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(41936, '2017-08-12 16:46:37', NULL, NULL, 11976, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 16:46:37', 'admin-1502511755-15025275975246978', 1, 1, 'SR', NULL, NULL, NULL),
(41937, '2017-08-12 16:49:48', NULL, NULL, 11976, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1502511755', 'admin', '2017-08-12 16:49:48', 'admin-1502511755-15025277881384276', 1, 0, '', NULL, NULL, NULL),
(41938, '2017-08-12 12:39:47', NULL, NULL, 11962, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 12:39:47', 'admin-1502511755-15025127869825566', 1, 1, 'SR', NULL, NULL, NULL),
(41939, '2017-08-12 16:03:33', NULL, NULL, 11975, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 16:03:33', 'admin-1502511755-15025250134265960', 1, 1, 'SR', NULL, NULL, NULL),
(41940, '2017-08-12 11:54:36', NULL, NULL, 11957, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:54:36', 'admin-1502505146-15025100759339663', 1, 0, '', NULL, NULL, NULL),
(41941, '2017-08-12 11:56:40', NULL, NULL, 11959, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:56:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41942, '2017-08-12 11:56:52', NULL, NULL, 11959, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:56:52', 'admin-1502505146-15025102122186076', 1, 0, '', NULL, NULL, NULL),
(41943, '2017-08-12 11:56:52', NULL, NULL, 11959, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:56:52', 'admin-1502505146-15025102122186076', 1, 0, '', NULL, NULL, NULL),
(41944, '2017-08-12 11:33:23', NULL, NULL, 11955, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:33:23', 'admin-1502505146-15025088030359895', 1, 0, '', NULL, NULL, NULL),
(41945, '2017-08-12 16:46:30', NULL, NULL, 11976, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.24, 0.0000, 0.0000, 4.24, 1, '27', 1, '1502511755', 'admin', '2017-08-12 16:46:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41946, '2017-08-12 15:54:20', NULL, NULL, 11975, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1502511755', 'admin', '2017-08-12 15:54:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41947, '2017-08-12 15:54:36', NULL, NULL, 11975, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 15:54:36', 'admin-1502511755-15025244763226445', 1, 1, 'SR', NULL, NULL, NULL),
(41948, '2017-08-12 15:51:54', NULL, NULL, 11974, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 15:51:54', 'admin-1502511755-1502524314400827', 1, 1, 'SR', NULL, NULL, NULL),
(41949, '2017-08-12 15:33:49', NULL, NULL, 11973, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 15:33:49', 'admin-1502511755-15025232296638458', 1, 1, 'SR', NULL, NULL, NULL),
(41950, '2017-08-12 15:33:49', NULL, NULL, 11973, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 2, 13.00, 26.0000, 0.0000, 26.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 15:33:49', 'admin-1502511755-15025232296638458', 1, 1, 'SR', NULL, NULL, NULL),
(41951, '2017-08-12 15:50:29', NULL, NULL, 11974, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 15:50:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41952, '2017-08-12 11:37:27', NULL, NULL, 11957, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:37:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41953, '2017-08-12 10:48:53', NULL, NULL, 11952, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:48:53', 'admin-1502505146-15025061335023649', 1, 0, '', NULL, NULL, NULL),
(41954, '2017-08-12 10:49:00', NULL, NULL, 11952, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:49:00', 'admin-1502505146-15025061400294273', 1, 1, 'SR', NULL, NULL, NULL),
(41955, '2017-08-12 10:49:00', NULL, NULL, 11952, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:49:00', 'admin-1502505146-15025061400294273', 1, 1, 'SR', NULL, NULL, NULL),
(41956, '2017-08-12 15:50:39', NULL, NULL, 11974, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 15:50:39', 'admin-1502511755-1502524239378171', 1, 1, 'SR', NULL, NULL, NULL),
(41957, '2017-08-12 14:11:30', NULL, NULL, 11962, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 14:11:30', 'admin-1502511755-1502518290112569', 1, 1, 'SR', NULL, NULL, NULL),
(41958, '2017-08-12 14:58:47', NULL, NULL, 11971, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 14:58:47', 'admin-1502511755-15025211275125945', 1, 0, '', 1, NULL, '10.0'),
(41959, '2017-08-12 15:33:33', NULL, NULL, 11973, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1502511755', 'admin', '2017-08-12 15:33:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41960, '2017-08-12 14:03:45', NULL, NULL, 11969, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 14:03:45', 'admin-1502511755-15025178251145919', 1, 0, '', NULL, NULL, NULL),
(41961, '2017-08-12 14:33:16', NULL, NULL, 11969, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 14:33:16', 'admin-1502511755-15025195964163253', 1, 1, 'SR', NULL, NULL, NULL),
(41962, '2017-08-12 14:14:09', NULL, NULL, 11970, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 14:14:09', 'admin-1502511755-15025184496858095', 1, 1, 'SR', NULL, NULL, NULL),
(41963, '2017-08-12 14:14:09', NULL, NULL, 11970, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 14:14:09', 'admin-1502511755-15025184496858095', 1, 0, '', NULL, NULL, NULL),
(41964, '2017-08-12 14:14:09', NULL, NULL, 11970, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 14:14:09', 'admin-1502511755-15025184496858095', 1, 0, '', NULL, NULL, NULL),
(41965, '2017-08-12 14:13:57', NULL, NULL, 11970, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1502511755', 'admin', '2017-08-12 14:13:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41966, '2017-08-12 14:11:38', NULL, NULL, 11965, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 14:11:38', 'admin-1502511755-15025182987313171', 1, 0, '', NULL, NULL, NULL),
(41967, '2017-08-12 14:02:03', NULL, NULL, 11968, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 14:02:03', 'admin-1502511755-15025177228909836', 1, 0, '', NULL, NULL, NULL),
(41968, '2017-08-12 15:00:24', NULL, NULL, 11972, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1502511755', 'admin', '2017-08-12 15:00:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41969, '2017-08-12 15:00:28', NULL, NULL, 11972, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 15:00:28', 'admin-1502511755-15025212285477731', 1, 0, '', NULL, NULL, NULL),
(41970, '2017-08-12 14:01:54', NULL, NULL, 11968, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1502511755', 'admin', '2017-08-12 14:01:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41971, '2017-08-12 12:22:30', NULL, NULL, 11960, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 12:22:30', 'admin-1502505146-15025117505908170', 1, 1, 'SR', NULL, NULL, NULL),
(41972, '2017-08-12 12:02:01', NULL, NULL, 11957, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 12:02:01', 'admin-1502505146-15025105214139293', 1, 0, '', NULL, NULL, NULL),
(41973, '2017-08-12 11:57:00', NULL, NULL, 11959, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:57:00', 'admin-1502505146-15025102206013473', 1, 0, '', NULL, NULL, NULL),
(41974, '2017-08-12 11:57:00', NULL, NULL, 11959, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:57:00', 'admin-1502505146-15025102206013473', 1, 0, '', NULL, NULL, NULL),
(41975, '2017-08-12 13:53:59', NULL, NULL, 11965, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 13:53:59', 'admin-1502511755-15025172396915470', 1, 0, '', NULL, NULL, NULL),
(41976, '2017-08-12 11:34:06', NULL, NULL, 11956, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:34:06', 'admin-1502505146-15025088457974129', 1, 1, 'SR', NULL, NULL, NULL),
(41977, '2017-08-12 11:22:15', NULL, NULL, 11954, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:22:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41978, '2017-08-12 11:22:45', NULL, NULL, 11954, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:22:45', 'admin-1502505146-15025081650966032', 1, 0, '', NULL, NULL, NULL),
(41979, '2017-08-12 13:45:11', NULL, NULL, 11965, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 13:45:11', 'admin-1502511755-15025167116701124', 1, 1, 'SR', NULL, NULL, NULL),
(41980, '2017-08-12 11:46:16', NULL, NULL, 11952, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:46:16', 'admin-1502505146-15025095764458751', 1, 0, '', NULL, NULL, NULL),
(41981, '2017-08-12 09:44:47', NULL, NULL, 11940, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:44:47', 'admin-1502501091-15025022869932751', 1, 1, 'SR', NULL, NULL, NULL),
(41982, '2017-08-12 11:37:43', NULL, NULL, 11957, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:37:43', 'admin-1502505146-15025090629009058', 1, 0, '', NULL, NULL, NULL),
(41983, '2017-08-12 11:34:00', NULL, NULL, 11956, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:34:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41984, '2017-08-12 11:33:23', NULL, NULL, 11955, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:33:23', 'admin-1502505146-15025088030359895', 1, 1, 'SR', NULL, NULL, NULL),
(41985, '2017-08-12 11:22:45', NULL, NULL, 11954, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:22:45', 'admin-1502505146-15025081650966032', 1, 0, '', NULL, NULL, NULL),
(41986, '2017-08-12 10:14:26', NULL, NULL, 11948, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:14:26', 'admin-1502504032-1502504066800379', 1, 0, '', NULL, NULL, NULL),
(41987, '2017-08-12 10:00:49', NULL, NULL, 11938, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:00:49', 'admin-1502502817-15025032496699716', 1, 1, 'SR', NULL, NULL, NULL),
(41988, '2017-08-12 10:00:49', NULL, NULL, 11938, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:00:49', 'admin-1502502817-15025032496699716', 1, 1, 'SR', NULL, NULL, NULL),
(41989, '2017-08-12 10:06:56', NULL, NULL, 11941, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:06:56', 'admin-1502502817-15025036163746228', 1, 0, '', NULL, NULL, NULL),
(41990, '2017-08-12 10:06:56', NULL, NULL, 11941, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:06:56', 'admin-1502502817-15025036163746228', 1, 1, 'SR', NULL, NULL, NULL),
(41991, '2017-08-12 10:08:42', NULL, NULL, 11947, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:08:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41992, '2017-08-12 10:08:49', NULL, NULL, 11947, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:08:49', 'admin-1502502817-15025037295266388', 1, 0, '', NULL, NULL, NULL),
(41993, '2017-08-12 10:08:49', NULL, NULL, 11947, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:08:49', 'admin-1502502817-15025037295266388', 1, 1, 'SR', NULL, NULL, NULL),
(41994, '2017-08-12 11:37:43', NULL, NULL, 11957, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:37:43', 'admin-1502505146-15025090629009058', 1, 1, 'SR', NULL, NULL, NULL),
(41995, '2017-08-12 11:07:28', NULL, NULL, 11953, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:07:28', 'admin-1502505146-15025072486195481', 1, 1, 'SR', NULL, NULL, NULL),
(41996, '2017-08-12 12:22:30', NULL, NULL, 11960, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 12:22:30', 'admin-1502505146-15025117505908170', 1, 0, '', NULL, NULL, NULL),
(41997, '2017-08-12 11:07:19', NULL, NULL, 11953, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:07:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(41998, '2017-08-12 11:07:28', NULL, NULL, 11953, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 11:07:28', 'admin-1502505146-15025072486195481', 1, 0, '', NULL, NULL, NULL),
(41999, '2017-08-12 10:51:18', NULL, NULL, 11948, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:51:18', 'admin-1502505146-15025062784784810', 1, 0, '', NULL, NULL, NULL),
(42000, '2017-08-12 10:50:20', NULL, NULL, 11941, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:50:20', 'admin-1502505146-15025062199131337', 1, 0, '', NULL, NULL, NULL),
(42001, '2017-08-12 10:48:42', NULL, NULL, 11952, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:48:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42002, '2017-08-12 10:48:53', NULL, NULL, 11952, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:48:53', 'admin-1502505146-15025061335023649', 1, 0, '', NULL, NULL, NULL),
(42003, '2017-08-12 10:33:45', NULL, NULL, 11950, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:33:45', 'admin-1502505146-15025052255139427', 1, 0, '', NULL, NULL, NULL),
(42004, '2017-08-12 10:14:21', NULL, NULL, 11948, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:14:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42005, '2017-08-12 16:01:08', NULL, NULL, 11975, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 16:01:08', 'admin-1502511755-1502524867761929', 1, 0, '', NULL, NULL, NULL),
(42006, '2017-08-12 09:51:19', NULL, NULL, 11944, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:51:20', 'admin-1502501091-15025026798249240', 1, 0, '', NULL, NULL, NULL),
(42007, '2017-08-12 09:47:22', NULL, NULL, 11942, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:47:22', 'admin-1502501091-15025024426491646', 1, 0, '', NULL, NULL, NULL),
(42008, '2017-08-12 09:47:22', NULL, NULL, 11942, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:47:22', 'admin-1502501091-15025024426491646', 1, 0, '', NULL, NULL, NULL),
(42009, '2017-08-12 09:47:40', NULL, NULL, 11942, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:47:40', 'admin-1502501091-15025024604641590', 1, 1, 'SR', NULL, NULL, NULL),
(42010, '2017-08-12 09:47:40', NULL, NULL, 11942, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:47:40', 'admin-1502501091-15025024604641590', 1, 1, 'SR', NULL, NULL, NULL),
(42011, '2017-08-12 10:47:00', NULL, NULL, 11951, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:47:00', 'admin-1502505146-15025060205249976', 1, 1, 'SR', NULL, NULL, NULL),
(42012, '2017-08-12 10:47:00', NULL, NULL, 11951, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:47:00', 'admin-1502505146-15025060205249976', 1, 1, 'SR', NULL, NULL, NULL),
(42013, '2017-08-12 09:41:08', NULL, NULL, 11939, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:41:08', 'admin-1502501091-15025020687357854', 1, 0, '', NULL, NULL, NULL),
(42014, '2017-08-12 10:47:00', NULL, NULL, 11951, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:47:00', 'admin-1502505146-15025060205249976', 1, 0, '', NULL, NULL, NULL),
(42015, '2017-08-12 10:47:00', NULL, NULL, 11951, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:47:00', 'admin-1502505146-15025060205249976', 1, 1, 'SR', NULL, NULL, NULL),
(42016, '2017-08-12 10:33:52', NULL, NULL, 11950, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:33:52', 'admin-1502505146-15025052321275255', 1, 1, 'SR', NULL, NULL, NULL),
(42017, '2017-08-12 10:33:52', NULL, NULL, 11950, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:33:52', 'admin-1502505146-15025052321275255', 1, 1, 'SR', NULL, NULL, NULL),
(42018, '2017-08-12 10:45:35', NULL, NULL, 11951, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:45:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42019, '2017-08-12 13:53:59', NULL, NULL, 11965, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1502511755', 'admin', '2017-08-12 13:53:59', 'admin-1502511755-15025172396915470', 1, 0, '', NULL, NULL, NULL),
(42020, '2017-08-12 10:33:45', NULL, NULL, 11950, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:33:45', 'admin-1502505146-15025052255139427', 1, 0, '', NULL, NULL, NULL),
(42021, '2017-08-12 10:33:35', NULL, NULL, 11950, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:33:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42022, '2017-08-12 10:32:13', NULL, NULL, 11949, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:32:13', 'admin-1502504032-15025051335798416', 1, 1, 'SR', NULL, NULL, NULL),
(42023, '2017-08-12 09:14:06', NULL, NULL, 11935, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:14:06', 'admin-1502499757-15025004465412695', 1, 0, '', NULL, NULL, NULL),
(42024, '2017-08-12 09:14:06', NULL, NULL, 11935, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:14:06', 'admin-1502499757-15025004465412695', 1, 0, '', NULL, NULL, NULL),
(42025, '2017-08-12 09:14:06', NULL, NULL, 11935, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:14:06', 'admin-1502499757-15025004465412695', 1, 1, 'SR', NULL, NULL, NULL),
(42026, '2017-08-12 10:32:13', NULL, NULL, 11949, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:32:13', 'admin-1502504032-15025051335798416', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(42027, '2017-08-12 10:32:13', NULL, NULL, 11949, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:32:13', 'admin-1502504032-15025051335798416', 1, 0, '', NULL, NULL, NULL),
(42028, '2017-08-12 10:32:13', NULL, NULL, 11949, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:32:13', 'admin-1502504032-15025051335798416', 1, 0, '', NULL, NULL, NULL),
(42029, '2017-08-12 10:30:39', NULL, NULL, 11949, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:30:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42030, '2017-08-12 10:15:04', NULL, NULL, 11948, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:15:04', 'admin-1502504032-15025041039313580', 1, 1, 'SR', NULL, NULL, NULL),
(42031, '2017-08-12 10:15:04', NULL, NULL, 11948, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:15:04', 'admin-1502504032-15025041039313580', 1, 1, 'SR', NULL, NULL, NULL),
(42032, '2017-08-12 10:14:26', NULL, NULL, 11948, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:14:26', 'admin-1502504032-1502504066800379', 1, 0, '', NULL, NULL, NULL),
(42033, '2017-08-12 09:46:25', NULL, NULL, 11941, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:46:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42034, '2017-08-12 10:47:00', NULL, NULL, 11951, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:47:00', 'admin-1502505146-15025060205249976', 1, 0, '', NULL, NULL, NULL),
(42035, '2017-08-12 09:58:45', NULL, NULL, 11945, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:58:45', 'admin-1502502817-1502503124961942', 1, 0, '', NULL, NULL, NULL),
(42036, '2017-08-12 09:58:45', NULL, NULL, 11945, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:58:45', 'admin-1502502817-1502503124961942', 1, 0, '', NULL, NULL, NULL),
(42037, '2017-08-12 09:40:51', NULL, NULL, 11938, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:40:51', 'admin-1502501091-15025020507525926', 1, 1, 'SR', NULL, NULL, NULL),
(42038, '2017-08-12 09:09:09', NULL, NULL, 11934, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:09:09', 'admin-1502499757-15025001493236594', 1, 1, 'SR', NULL, NULL, NULL),
(42039, '2017-08-12 09:08:55', NULL, NULL, 11934, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:08:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42040, '2017-08-12 10:04:19', NULL, NULL, 11946, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:04:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42041, '2017-08-12 10:05:23', NULL, NULL, 11946, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:05:23', 'admin-1502502817-15025035233173194', 1, 1, 'SR', NULL, NULL, NULL),
(42042, '2017-08-12 10:05:23', NULL, NULL, 11946, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:05:23', 'admin-1502502817-15025035233173194', 1, 1, 'SR', NULL, NULL, NULL),
(42043, '2017-08-12 09:47:11', NULL, NULL, 11942, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:47:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42044, '2017-08-12 09:46:30', NULL, NULL, 11941, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:46:30', 'admin-1502501091-15025023901985196', 1, 1, 'SR', NULL, NULL, NULL),
(42045, '2017-08-12 09:58:28', NULL, NULL, 11945, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:58:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42046, '2017-08-12 09:44:47', NULL, NULL, 11940, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:44:47', 'admin-1502501091-15025022869932751', 1, 0, '', NULL, NULL, NULL),
(42047, '2017-08-12 09:41:08', NULL, NULL, 11939, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:41:08', 'admin-1502501091-15025020687357854', 1, 1, 'SR', NULL, NULL, NULL),
(42048, '2017-08-12 09:44:47', NULL, NULL, 11940, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:44:47', 'admin-1502501091-15025022869932751', 1, 1, 'SR', NULL, NULL, NULL),
(42049, '2017-08-12 09:41:08', NULL, NULL, 11939, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:41:08', 'admin-1502501091-15025020687357854', 1, 1, 'SR', NULL, NULL, NULL),
(42050, '2017-08-12 09:14:29', NULL, NULL, 11936, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:14:29', 'admin-1502499757-15025004697269810', 1, 0, '', NULL, NULL, '10.0'),
(42051, '2017-08-12 09:14:06', NULL, NULL, 11935, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:14:06', 'admin-1502499757-15025004465412695', 1, 1, 'SR', NULL, NULL, NULL),
(42052, '2017-08-12 10:47:00', NULL, NULL, 11951, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:47:00', 'admin-1502505146-15025060205249976', 1, 0, '', NULL, NULL, NULL),
(42053, '2017-08-12 09:40:58', NULL, NULL, 11939, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:40:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42054, '2017-08-12 09:40:51', NULL, NULL, 11938, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:40:51', 'admin-1502501091-15025020507525926', 1, 1, 'SR', NULL, NULL, NULL),
(42055, '2017-08-12 09:40:50', NULL, NULL, 11938, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:40:50', 'admin-1502501091-15025020507525926', 1, 0, '', NULL, NULL, NULL),
(42056, '2017-08-12 09:40:50', NULL, NULL, 11938, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:40:50', 'admin-1502501091-15025020507525926', 1, 0, '', NULL, NULL, NULL),
(42057, '2017-08-12 09:40:30', NULL, NULL, 11938, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:40:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42058, '2017-08-12 09:31:58', NULL, NULL, 11934, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:31:58', 'admin-1502501091-15025015183496124', 1, 1, 'SR', NULL, NULL, NULL),
(42059, '2017-08-12 10:06:56', NULL, NULL, 11941, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:06:56', 'admin-1502502817-15025036163746228', 1, 0, '', NULL, NULL, NULL),
(42060, '2017-08-12 10:05:23', NULL, NULL, 11946, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:05:23', 'admin-1502502817-15025035233173194', 1, 0, '', NULL, NULL, NULL),
(42061, '2017-08-12 10:05:23', NULL, NULL, 11946, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:05:23', 'admin-1502502817-15025035233173194', 1, 0, '', NULL, NULL, NULL),
(42062, '2017-08-12 10:05:23', NULL, NULL, 11946, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 10:05:23', 'admin-1502502817-15025035233173194', 1, 0, '', NULL, NULL, NULL),
(42063, '2017-08-12 09:14:29', NULL, NULL, 11936, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:14:29', 'admin-1502499757-15025004697269810', 1, 0, '', NULL, NULL, '10.0'),
(42064, '2017-08-12 09:14:29', NULL, NULL, 11936, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:14:29', 'admin-1502499757-15025004697269810', 1, 1, 'SR', NULL, NULL, '10.0'),
(42065, '2017-08-12 09:14:29', NULL, NULL, 11936, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:14:29', 'admin-1502499757-15025004697269810', 1, 0, '', NULL, NULL, '10.0'),
(42066, '2017-08-12 09:10:25', NULL, NULL, 11934, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:10:25', 'admin-1502499757-15025002255863626', 1, 0, '', NULL, NULL, NULL),
(42067, '2017-08-12 09:14:13', NULL, NULL, 11936, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:14:13', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(42068, '2017-08-12 09:12:42', NULL, NULL, 11935, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:12:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42069, '2017-08-12 09:09:09', NULL, NULL, 11934, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:09:09', 'admin-1502499757-15025001493236594', 1, 0, '', NULL, NULL, NULL),
(42070, '2017-08-12 09:04:28', NULL, NULL, 11933, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:04:28', 'admin-1502499757-15024998681998362', 1, 0, '', NULL, NULL, NULL),
(42071, '2017-08-12 09:04:28', NULL, NULL, 11933, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:04:28', 'admin-1502499757-15024998681998362', 1, 0, '', NULL, NULL, NULL),
(42072, '2017-08-12 09:04:28', NULL, NULL, 11933, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:04:28', 'admin-1502499757-15024998681998362', 1, 1, 'SR', NULL, NULL, NULL),
(42073, '2017-08-12 09:04:28', NULL, NULL, 11933, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:04:28', 'admin-1502499757-15024998681998362', 1, 1, 'SR', NULL, NULL, NULL),
(42074, '2017-08-12 09:03:55', NULL, NULL, 11933, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1502511755', 'admin', '2017-08-12 09:03:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42075, '2017-08-13 14:46:45', NULL, NULL, 12028, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 14:46:45', 'admin-1502604446-15026068050732118', 1, 1, 'SR', NULL, NULL, NULL),
(42076, '2017-08-13 15:16:54', NULL, NULL, 12030, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:16:55', 'admin-1502604446-15026086148441794', 1, 1, 'SR', NULL, NULL, NULL),
(42077, '2017-08-13 15:19:35', NULL, NULL, 12031, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:19:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42078, '2017-08-13 15:20:14', NULL, NULL, 12031, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:20:14', 'admin-1502604446-15026088143425057', 1, 1, 'SR', NULL, NULL, NULL),
(42079, '2017-08-13 15:20:14', NULL, NULL, 12031, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:20:14', 'admin-1502604446-15026088143425057', 1, 1, 'SR', NULL, NULL, NULL),
(42080, '2017-08-13 15:35:37', NULL, NULL, 12032, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:35:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42081, '2017-08-13 15:36:06', NULL, NULL, 12032, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:36:06', 'admin-1502604446-15026097659032727', 1, 0, '', NULL, NULL, NULL),
(42082, '2017-08-13 15:36:06', NULL, NULL, 12032, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:36:06', 'admin-1502604446-15026097659032727', 1, 1, 'SR', NULL, NULL, NULL),
(42083, '2017-08-13 15:38:33', NULL, NULL, 12033, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:38:33', 'admin-1502604446-15026099128808473', 1, 1, 'SR', 1, NULL, '10.0'),
(42084, '2017-08-13 15:38:33', NULL, NULL, 12033, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:38:33', 'admin-1502604446-15026099128808473', 1, 1, 'SR', 1, NULL, '10.0'),
(42085, '2017-08-13 14:46:45', NULL, NULL, 12028, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 14:46:45', 'admin-1502604446-15026068050732118', 1, 1, 'SR', NULL, NULL, NULL),
(42086, '2017-08-13 14:25:13', NULL, NULL, 12026, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 14:25:13', 'admin-1502604446-15026055129811993', 1, 0, '', NULL, NULL, NULL),
(42087, '2017-08-13 14:28:18', NULL, NULL, 12026, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 14:28:18', 'admin-1502604446-150260569863085', 1, 1, 'SR', NULL, NULL, NULL),
(42088, '2017-08-13 14:30:21', NULL, NULL, 12025, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 14:30:21', 'admin-1502604446-15026058211908526', 1, 0, '', NULL, NULL, NULL),
(42089, '2017-08-13 14:31:15', NULL, NULL, 12026, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 14:31:15', 'admin-1502604446-15026058749017719', 1, 0, '', NULL, NULL, NULL),
(42090, '2017-08-13 13:27:51', NULL, NULL, 12023, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:27:51', 'admin-1502601812-15026020708524869', 1, 0, '', NULL, NULL, '10.0'),
(42091, '2017-08-13 13:27:56', NULL, NULL, 12024, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:27:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42092, '2017-08-13 13:28:22', NULL, NULL, 12024, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:28:22', 'admin-1502601812-15026021018248481', 1, 0, '', NULL, NULL, NULL),
(42093, '2017-08-13 13:28:22', NULL, NULL, 12024, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:28:22', 'admin-1502601812-15026021018248481', 1, 1, 'SR', NULL, NULL, NULL),
(42094, '2017-08-13 13:28:22', NULL, NULL, 12024, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:28:22', 'admin-1502601812-15026021018248481', 1, 1, 'SR', NULL, NULL, NULL),
(42095, '2017-08-13 13:29:40', NULL, NULL, 12022, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:29:40', 'admin-1502601812-1502602180784873', 1, 0, '', NULL, NULL, NULL),
(42096, '2017-08-13 13:30:51', NULL, NULL, 12020, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:30:51', 'admin-1502601812-15026022510244753', 1, 0, '', NULL, NULL, NULL),
(42097, '2017-08-13 16:25:58', NULL, NULL, 12037, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 16:25:58', 'admin-1502604446-15026127577546725', 1, 1, 'SR', NULL, NULL, NULL),
(42098, '2017-08-13 13:15:44', NULL, NULL, 12019, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:15:44', 'admin-1502597154-15026013439806895', 1, 0, '', NULL, NULL, NULL),
(42099, '2017-08-13 13:15:44', NULL, NULL, 12019, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:15:44', 'admin-1502597154-15026013439806895', 1, 1, 'SR', NULL, NULL, NULL),
(42100, '2017-08-13 13:19:10', NULL, NULL, 12019, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:19:10', 'admin-1502597154-1502601550268305', 1, 0, '', NULL, NULL, NULL),
(42101, '2017-08-13 13:19:10', NULL, NULL, 12019, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:19:10', 'admin-1502597154-1502601550268305', 1, 0, '', NULL, NULL, NULL),
(42102, '2017-08-13 14:04:28', NULL, NULL, 12025, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1502604446', 'admin', '2017-08-13 14:04:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42103, '2017-08-13 14:04:34', NULL, NULL, 12025, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 14:04:34', 'admin-1502601812-15026042744871291', 1, 1, 'SR', NULL, NULL, NULL),
(42104, '2017-08-13 14:25:13', NULL, NULL, 12026, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 14:25:13', 'admin-1502604446-15026055129811993', 1, 1, 'SR', NULL, NULL, NULL),
(42105, '2017-08-13 14:25:05', NULL, NULL, 12026, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1502604446', 'admin', '2017-08-13 14:25:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42106, '2017-08-13 14:07:20', NULL, NULL, 12025, 0, 217, '151', 'Spicy Lemony Wings', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 14:07:20', 'admin-1502601812-15026044405957848', 1, 0, '', NULL, NULL, NULL),
(42107, '2017-08-13 15:16:54', NULL, NULL, 12030, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:16:54', 'admin-1502604446-15026086148441794', 1, 1, 'SR', NULL, NULL, NULL),
(42108, '2017-08-13 11:44:16', NULL, NULL, 12003, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:44:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42109, '2017-08-13 13:15:37', NULL, NULL, 12019, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:15:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42110, '2017-08-13 00:00:00', NULL, NULL, 12018, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:39:32', 'admin-1502590289-1502591972375122', 1, 1, 'SR', NULL, NULL, NULL),
(42111, '2017-08-13 12:31:35', NULL, NULL, 12005, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:31:35', 'admin-1502597154-1502598694811320', 1, 1, 'SR', NULL, NULL, NULL),
(42112, '2017-08-13 00:00:00', NULL, NULL, 12015, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:21:35', 'admin-1502590289-15025908950882434', 1, 0, '', NULL, NULL, NULL),
(42113, '2017-08-13 00:00:00', NULL, NULL, 12016, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:21:35', 'admin-1502590289-15025908950882434', 1, 0, '', NULL, NULL, NULL),
(42114, '2017-08-13 00:00:00', NULL, NULL, 12014, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:21:35', 'admin-1502590289-15025908950882434', 1, 0, '', NULL, NULL, NULL),
(42115, '2017-08-13 17:13:27', NULL, NULL, 12039, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1502604446', 'admin', '2017-08-13 17:13:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42116, '2017-08-13 17:13:32', NULL, NULL, 12039, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 17:13:32', 'admin-1502604446-15026156123536074', 1, 1, 'SR', NULL, NULL, NULL),
(42117, '2017-08-13 17:11:24', NULL, NULL, 12038, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 17:11:24', 'admin-1502604446-15026154845114862', 1, 1, 'SR', NULL, NULL, NULL),
(42118, '2017-08-13 17:10:50', NULL, NULL, 12038, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 17:10:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42119, '2017-08-13 16:25:58', NULL, NULL, 12037, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 16:25:58', 'admin-1502604446-15026127577546725', 1, 0, '', NULL, NULL, NULL),
(42120, '2017-08-13 14:46:45', NULL, NULL, 12028, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 14:46:45', 'admin-1502604446-15026068050732118', 1, 0, '', NULL, NULL, NULL),
(42121, '2017-08-13 11:44:29', NULL, NULL, 12003, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:44:29', 'admin-1502592651-15025958695653233', 1, 1, 'SR', NULL, NULL, NULL),
(42122, '2017-08-13 11:51:23', NULL, NULL, 12004, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.90, 0.0000, 0.0000, 9.90, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:51:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42123, '2017-08-13 11:51:41', NULL, NULL, 12004, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:51:41', 'admin-1502592651-15025963017629024', 1, 0, '', NULL, NULL, NULL),
(42124, '2017-08-13 11:51:41', NULL, NULL, 12004, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:51:41', 'admin-1502592651-15025963017629024', 1, 0, '', NULL, NULL, NULL),
(42125, '2017-08-13 11:51:41', NULL, NULL, 12004, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:51:41', 'admin-1502592651-15025963017629024', 1, 0, '', NULL, NULL, NULL),
(42126, '2017-08-13 17:13:32', NULL, NULL, 12039, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 17:13:32', 'admin-1502604446-15026156123536074', 1, 1, 'SR', NULL, NULL, NULL),
(42127, '2017-08-13 13:26:08', NULL, NULL, 12021, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:26:08', 'admin-1502601812-15026019679855256', 1, 0, '', NULL, NULL, NULL),
(42128, '2017-08-13 09:42:47', NULL, NULL, 11988, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:42:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42129, '2017-08-13 09:43:02', NULL, NULL, 11988, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:43:02', 'admin-1502588024-15025885825631998', 1, 1, 'SR', NULL, NULL, NULL),
(42130, '2017-08-13 09:43:02', NULL, NULL, 11988, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:43:02', 'admin-1502588024-15025885825631998', 1, 1, 'SR', NULL, NULL, NULL),
(42131, '2017-08-13 15:44:35', NULL, NULL, 12032, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:44:35', 'admin-1502604446-15026102755054470', 1, 1, 'SR', NULL, NULL, NULL),
(42132, '2017-08-13 15:55:24', NULL, NULL, 12036, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:55:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42133, '2017-08-13 15:55:31', NULL, NULL, 12036, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:55:31', 'admin-1502604446-15026109314952692', 1, 0, '', NULL, NULL, NULL),
(42134, '2017-08-13 15:55:31', NULL, NULL, 12036, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:55:31', 'admin-1502604446-15026109314952692', 1, 0, '', NULL, NULL, NULL),
(42135, '2017-08-13 15:55:31', NULL, NULL, 12036, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:55:31', 'admin-1502604446-15026109314952692', 1, 1, 'SR', NULL, NULL, NULL),
(42136, '2017-08-13 15:10:13', NULL, NULL, 12029, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:10:13', 'admin-1502604446-15026082133274393', 1, 1, 'SR', NULL, NULL, NULL),
(42137, '2017-08-13 15:10:13', NULL, NULL, 12029, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:10:13', 'admin-1502604446-15026082133274393', 1, 1, 'SR', NULL, NULL, NULL),
(42138, '2017-08-13 16:25:58', NULL, NULL, 12037, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 16:25:58', 'admin-1502604446-15026127577546725', 1, 0, '', NULL, NULL, NULL),
(42139, '2017-08-13 16:25:58', NULL, NULL, 12037, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 16:25:58', 'admin-1502604446-15026127577546725', 1, 0, '', NULL, NULL, NULL),
(42140, '2017-08-13 16:25:58', NULL, NULL, 12037, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 16:25:58', 'admin-1502604446-15026127577546725', 1, 0, '', NULL, NULL, NULL),
(42141, '2017-08-13 16:20:18', NULL, NULL, 12036, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 16:20:18', 'admin-1502604446-15026124185583012', 1, 0, '', NULL, NULL, NULL),
(42142, '2017-08-13 16:25:30', NULL, NULL, 12037, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1502604446', 'admin', '2017-08-13 16:25:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42143, '2017-08-13 12:02:06', NULL, NULL, 12006, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:02:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42144, '2017-08-13 11:51:41', NULL, NULL, 12004, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:51:41', 'admin-1502592651-15025963017629024', 1, 0, '', NULL, NULL, NULL),
(42145, '2017-08-13 13:27:51', NULL, NULL, 12023, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:27:51', 'admin-1502601812-15026020708524869', 1, 1, 'SR', NULL, NULL, '10.0'),
(42146, '2017-08-13 13:27:51', NULL, NULL, 12023, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:27:51', 'admin-1502601812-15026020708524869', 1, 1, 'SR', NULL, NULL, '10.0'),
(42147, '2017-08-13 13:26:34', NULL, NULL, 12023, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:26:34', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(42148, '2017-08-13 13:27:51', NULL, NULL, 12023, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:27:51', 'admin-1502601812-15026020708524869', 1, 1, 'SR', NULL, NULL, '10.0'),
(42149, '2017-08-13 15:55:31', NULL, NULL, 12036, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:55:31', 'admin-1502604446-15026109314952692', 1, 1, 'SR', NULL, NULL, NULL),
(42150, '2017-08-13 15:40:42', NULL, NULL, 12034, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:40:42', 'admin-1502604446-15026100423829943', 1, 0, '', NULL, NULL, '10.0'),
(42151, '2017-08-13 15:42:33', NULL, NULL, 12035, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:42:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42152, '2017-08-13 15:42:46', NULL, NULL, 12035, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:42:46', 'admin-1502604446-15026101658455789', 1, 1, 'SR', NULL, NULL, NULL),
(42153, '2017-08-13 12:48:07', NULL, NULL, 12013, 0, 181, '116', 'Open Food ', 'BBQ Rice', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:48:07', 'admin-1502597154-15025996873085196', 1, 0, '', NULL, NULL, NULL),
(42154, '2017-08-13 12:48:07', NULL, NULL, 12013, 0, 223, '157', 'Crispy Bacon Aglio Olio', 'No chili', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:48:07', 'admin-1502597154-15025996873085196', 1, 0, '', NULL, NULL, NULL),
(42155, '2017-08-13 11:11:21', NULL, NULL, 12000, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:11:21', 'admin-1502592651-1502593880811159', 1, 0, '', NULL, NULL, NULL),
(42156, '2017-08-13 12:50:36', NULL, NULL, 12013, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:50:36', 'admin-1502597154-15025998363855618', 1, 1, 'SR', NULL, NULL, NULL),
(42157, '2017-08-13 12:50:36', NULL, NULL, 12013, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:50:36', 'admin-1502597154-15025998363855618', 1, 1, 'SR', NULL, NULL, NULL),
(42158, '2017-08-13 12:39:48', NULL, NULL, 12012, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:39:48', 'admin-1502597154-15025991880409412', 1, 1, 'SR', NULL, NULL, NULL),
(42159, '2017-08-13 15:38:33', NULL, NULL, 12033, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:38:33', 'admin-1502604446-15026099128808473', 1, 1, 'SR', 1, NULL, '10.0'),
(42160, '2017-08-13 15:10:13', NULL, NULL, 12029, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:10:13', 'admin-1502604446-15026082133274393', 1, 0, '', NULL, NULL, NULL),
(42161, '2017-08-13 13:26:29', NULL, NULL, 12022, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:26:29', 'admin-1502601812-1502601989667797', 1, 1, 'SR', NULL, NULL, NULL),
(42162, '2017-08-13 11:11:41', NULL, NULL, 12000, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:11:41', 'admin-1502592651-15025939014998092', 1, 0, '', NULL, NULL, NULL),
(42163, '2017-08-13 13:26:14', NULL, NULL, 12022, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:26:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42164, '2017-08-13 13:26:29', NULL, NULL, 12022, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:26:29', 'admin-1502601812-1502601989667797', 1, 1, 'SR', NULL, NULL, NULL),
(42165, '2017-08-13 12:48:07', NULL, NULL, 12013, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:48:07', 'admin-1502597154-15025996873085196', 1, 1, 'SR', NULL, NULL, NULL),
(42166, '2017-08-13 12:48:07', NULL, NULL, 12013, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:48:07', 'admin-1502597154-15025996873085196', 1, 0, '', NULL, NULL, NULL),
(42167, '2017-08-13 12:48:07', NULL, NULL, 12013, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:48:07', 'admin-1502597154-15025996873085196', 1, 1, 'SR', NULL, NULL, NULL),
(42168, '2017-08-13 11:44:29', NULL, NULL, 12003, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:44:29', 'admin-1502592651-15025958695653233', 1, 0, '', NULL, NULL, NULL),
(42169, '2017-08-13 12:47:28', NULL, NULL, 12013, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.90, 0.0000, 0.0000, 9.90, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:47:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42170, '2017-08-13 12:48:07', NULL, NULL, 12013, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:48:07', 'admin-1502597154-15025996873085196', 1, 1, 'SR', NULL, NULL, NULL),
(42171, '2017-08-13 11:22:45', NULL, NULL, 12001, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:22:45', 'admin-1502592651-15025945656646587', 1, 1, 'SR', NULL, NULL, NULL),
(42172, '2017-08-13 10:08:23', NULL, NULL, 11993, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:08:23', 'admin-1502589215-15025901036836431', 1, 0, '', NULL, NULL, NULL),
(42173, '2017-08-13 09:57:47', NULL, NULL, 11992, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:57:47', 'admin-1502589215-15025894672225257', 1, 0, '', NULL, NULL, NULL),
(42174, '2017-08-13 09:40:26', NULL, NULL, 11986, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.90, 0.0000, 0.0000, 9.90, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:40:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42175, '2017-08-13 15:10:13', NULL, NULL, 12029, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:10:13', 'admin-1502604446-15026082133274393', 1, 1, 'SR', NULL, NULL, NULL),
(42176, '2017-08-13 15:16:43', NULL, NULL, 12030, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:16:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42177, '2017-08-13 10:47:25', NULL, NULL, 11997, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:47:25', 'admin-1502590289-15025924456826955', 1, 1, 'SR', NULL, NULL, NULL),
(42178, '2017-08-13 10:43:18', NULL, NULL, 11998, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:43:18', 'admin-1502590289-15025921979197647', 1, 0, '', NULL, NULL, NULL),
(42179, '2017-08-13 10:47:25', NULL, NULL, 11997, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:47:25', 'admin-1502590289-15025924456826955', 1, 0, '', NULL, NULL, NULL),
(42180, '2017-08-13 10:47:25', NULL, NULL, 11997, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:47:25', 'admin-1502590289-15025924456826955', 1, 1, 'SR', NULL, NULL, NULL),
(42181, '2017-08-13 15:10:13', NULL, NULL, 12029, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:10:13', 'admin-1502604446-15026082133274393', 1, 1, 'SR', NULL, NULL, NULL),
(42182, '2017-08-13 15:09:20', NULL, NULL, 12029, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:09:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42183, '2017-08-13 12:28:54', NULL, NULL, 12010, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:28:54', 'admin-1502597154-15025985348271775', 1, 1, 'SR', 1, NULL, NULL),
(42184, '2017-08-13 15:07:38', NULL, NULL, 12026, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:07:38', 'admin-1502604446-15026080578286421', 1, 0, '', NULL, NULL, NULL),
(42185, '2017-08-13 15:06:55', NULL, NULL, 12005, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:06:55', 'admin-1502604446-15026080155776516', 1, 0, '', NULL, NULL, NULL),
(42186, '2017-08-13 13:26:08', NULL, NULL, 12021, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:26:08', 'admin-1502601812-15026019679855256', 1, 1, 'SR', NULL, NULL, NULL),
(42187, '2017-08-13 13:25:14', NULL, NULL, 12020, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:25:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42188, '2017-08-13 13:25:37', NULL, NULL, 12021, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:25:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42189, '2017-08-13 14:46:45', NULL, NULL, 12028, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 14:46:45', 'admin-1502604446-15026068050732118', 1, 1, 'SR', NULL, NULL, NULL),
(42190, '2017-08-13 12:05:45', NULL, NULL, 12007, 0, 219, '153', 'Fried Rice With Bacon', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:05:45', 'admin-1502592651-15025971456806550', 1, 0, '', NULL, NULL, NULL),
(42191, '2017-08-13 12:05:45', NULL, NULL, 12007, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:05:45', 'admin-1502592651-15025971456806550', 1, 0, '', NULL, NULL, NULL),
(42192, '2017-08-13 12:05:45', NULL, NULL, 12007, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:05:45', 'admin-1502592651-15025971456806550', 1, 1, 'SR', NULL, NULL, NULL),
(42193, '2017-08-13 12:05:45', NULL, NULL, 12007, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:05:45', 'admin-1502592651-15025971456806550', 1, 1, 'SR', NULL, NULL, NULL),
(42194, '2017-08-13 12:12:10', NULL, NULL, 12008, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.90, 0.0000, 0.0000, 9.90, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:12:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42195, '2017-08-13 12:13:20', NULL, NULL, 12008, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:13:20', 'admin-1502597154-15025976007001068', 1, 0, '', NULL, NULL, NULL),
(42196, '2017-08-13 12:13:20', NULL, NULL, 12008, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:13:20', 'admin-1502597154-15025976007001068', 1, 0, '', NULL, NULL, NULL),
(42197, '2017-08-13 12:13:20', NULL, NULL, 12008, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:13:20', 'admin-1502597154-15025976007001068', 1, 0, '', NULL, NULL, NULL),
(42198, '2017-08-13 12:13:20', NULL, NULL, 12008, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:13:20', 'admin-1502597154-15025976007001068', 1, 1, 'SR', NULL, NULL, NULL),
(42199, '2017-08-13 09:22:42', NULL, NULL, 11978, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:22:42', 'admin-1502586496-15025873618685429', 1, 1, 'SR', NULL, NULL, NULL),
(42200, '2017-08-13 09:22:42', NULL, NULL, 11978, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:22:42', 'admin-1502586496-15025873618685429', 1, 1, 'SR', NULL, NULL, NULL),
(42201, '2017-08-13 09:24:27', NULL, NULL, 11980, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:24:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42202, '2017-08-13 09:25:05', NULL, NULL, 11980, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:25:05', 'admin-1502586496-15025875054396776', 1, 0, '', NULL, NULL, NULL),
(42203, '2017-08-13 09:25:05', NULL, NULL, 11980, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:25:05', 'admin-1502586496-15025875054396776', 1, 0, '', NULL, NULL, NULL),
(42204, '2017-08-13 09:25:05', NULL, NULL, 11980, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:25:05', 'admin-1502586496-15025875054396776', 1, 1, 'SR', NULL, NULL, NULL),
(42205, '2017-08-13 14:46:45', NULL, NULL, 12028, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 14:46:45', 'admin-1502604446-15026068050732118', 1, 0, '', NULL, NULL, NULL),
(42206, '2017-08-13 14:46:45', NULL, NULL, 12028, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 14:46:45', 'admin-1502604446-15026068050732118', 1, 0, '', NULL, NULL, NULL),
(42207, '2017-08-13 14:46:45', NULL, NULL, 12028, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 14:46:45', 'admin-1502604446-15026068050732118', 1, 0, '', NULL, NULL, NULL),
(42208, '2017-08-13 14:31:15', NULL, NULL, 12026, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 14:31:15', 'admin-1502604446-15026058749017719', 1, 1, 'SR', NULL, NULL, NULL),
(42209, '2017-08-13 14:40:55', NULL, NULL, 12025, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 14:40:55', 'admin-1502604446-15026064555109475', 1, 0, '', NULL, NULL, NULL),
(42210, '2017-08-13 10:49:09', NULL, NULL, 11990, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:49:09', 'admin-1502590289-15025925489911032', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(42211, '2017-08-13 16:25:58', NULL, NULL, 12037, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 16:25:58', 'admin-1502604446-15026127577546725', 1, 1, 'SR', NULL, NULL, NULL),
(42212, '2017-08-13 12:38:03', NULL, NULL, 12011, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:38:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42213, '2017-08-13 12:38:27', NULL, NULL, 12011, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:38:27', 'admin-1502597154-1502599107136933', 1, 0, '', NULL, NULL, NULL),
(42214, '2017-08-13 11:29:55', NULL, NULL, 12002, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:29:55', 'admin-1502592651-15025949950011683', 1, 0, '', NULL, NULL, NULL),
(42215, '2017-08-13 12:31:02', NULL, NULL, 12001, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:31:02', 'admin-1502597154-15025986627225165', 1, 1, 'SR', NULL, NULL, NULL),
(42216, '2017-08-13 11:00:26', NULL, NULL, 11986, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:00:26', 'admin-1502592651-15025932267226127', 1, 1, 'SR', NULL, NULL, NULL),
(42217, '2017-08-13 11:06:54', NULL, NULL, 11998, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:06:54', 'admin-1502592651-15025936147917729', 1, 1, 'SR', NULL, NULL, NULL),
(42218, '2017-08-13 11:11:08', NULL, NULL, 12000, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.00, 0.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:11:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42219, '2017-08-13 11:11:21', NULL, NULL, 12000, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:11:21', 'admin-1502592651-1502593880811159', 1, 0, '', NULL, NULL, NULL),
(42220, '2017-08-13 11:11:21', NULL, NULL, 12000, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:11:21', 'admin-1502592651-1502593880811159', 1, 0, '', NULL, NULL, NULL),
(42221, '2017-08-13 12:39:48', NULL, NULL, 12012, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:39:48', 'admin-1502597154-15025991880409412', 1, 0, '', NULL, NULL, NULL),
(42222, '2017-08-13 12:39:18', NULL, NULL, 12012, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:39:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42223, '2017-08-13 12:38:27', NULL, NULL, 12011, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:38:27', 'admin-1502597154-1502599107136933', 1, 1, 'SR', NULL, NULL, NULL),
(42224, '2017-08-13 10:32:05', NULL, NULL, 11986, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:32:05', 'admin-1502590289-15025915255853439', 1, 1, 'SR', NULL, NULL, NULL),
(42225, '2017-08-13 12:13:20', NULL, NULL, 12008, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:13:20', 'admin-1502597154-15025976007001068', 1, 1, 'SR', NULL, NULL, NULL),
(42226, '2017-08-13 12:39:48', NULL, NULL, 12012, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:39:48', 'admin-1502597154-15025991880409412', 1, 0, '', NULL, NULL, NULL),
(42227, '2017-08-13 12:31:02', NULL, NULL, 12001, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:31:02', 'admin-1502597154-15025986627225165', 1, 1, 'SR', NULL, NULL, NULL),
(42228, '2017-08-13 12:15:57', NULL, NULL, 12009, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:15:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42229, '2017-08-13 13:15:44', NULL, NULL, 12019, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:15:44', 'admin-1502597154-15026013439806895', 1, 0, '', NULL, NULL, NULL),
(42230, '2017-08-13 12:16:08', NULL, NULL, 12009, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:16:08', 'admin-1502597154-1502597768157446', 1, 1, 'SR', NULL, NULL, NULL),
(42231, '2017-08-13 10:11:42', NULL, NULL, 11994, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:11:42', 'admin-1502590289-1502590302185714', 1, 1, 'SR', NULL, NULL, NULL),
(42232, '2017-08-13 10:11:42', NULL, NULL, 11994, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:11:42', 'admin-1502590289-1502590302185714', 1, 1, 'SR', NULL, NULL, NULL),
(42233, '2017-08-13 10:11:42', NULL, NULL, 11994, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:11:42', 'admin-1502590289-1502590302185714', 1, 1, 'SR', NULL, NULL, NULL),
(42234, '2017-08-13 13:04:26', NULL, NULL, 12015, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:04:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42235, '2017-08-13 13:03:51', NULL, NULL, 12014, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:03:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42236, '2017-08-13 12:13:20', NULL, NULL, 12008, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:13:20', 'admin-1502597154-15025976007001068', 1, 1, 'SR', NULL, NULL, NULL),
(42237, '2017-08-13 12:05:45', NULL, NULL, 12007, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:05:45', 'admin-1502592651-15025971456806550', 1, 0, '', NULL, NULL, NULL),
(42238, '2017-08-13 12:05:45', NULL, NULL, 12007, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:05:45', 'admin-1502592651-15025971456806550', 1, 0, '', NULL, NULL, NULL),
(42239, '2017-08-13 12:04:51', NULL, NULL, 12007, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:04:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42240, '2017-08-13 11:32:15', NULL, NULL, 12001, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:32:15', 'admin-1502592651-1502595135486819', 1, 1, 'SR', NULL, NULL, NULL),
(42241, '2017-08-13 13:04:45', NULL, NULL, 12016, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:04:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42242, '2017-08-13 00:00:00', NULL, NULL, 12016, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:21:35', 'admin-1502590289-15025908950882434', 1, 0, '', NULL, NULL, NULL),
(42243, '2017-08-13 10:22:57', NULL, NULL, 11996, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:22:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42244, '2017-08-13 10:23:09', NULL, NULL, 11996, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:23:09', 'admin-1502590289-15025909894337227', 1, 0, '', NULL, NULL, NULL),
(42245, '2017-08-13 11:53:33', NULL, NULL, 12005, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:53:33', 'admin-1502592651-15025964129109875', 1, 0, '', NULL, NULL, NULL),
(42246, '2017-08-13 13:26:08', NULL, NULL, 12021, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:26:08', 'admin-1502601812-15026019679855256', 1, 1, 'SR', NULL, NULL, NULL),
(42247, '2017-08-13 11:53:21', NULL, NULL, 12005, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:53:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42248, '2017-08-13 11:44:29', NULL, NULL, 12003, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:44:29', 'admin-1502592651-15025958695653233', 1, 0, '', NULL, NULL, NULL),
(42249, '2017-08-13 11:25:38', NULL, NULL, 11986, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:25:38', 'admin-1502592651-1502594737846348', 1, 0, '', NULL, NULL, NULL),
(42250, '2017-08-13 12:02:11', NULL, NULL, 12006, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:02:11', 'admin-1502592651-15025969308552435', 1, 1, 'SR', NULL, NULL, NULL),
(42251, '2017-08-13 13:30:51', NULL, NULL, 12020, 0, 55, '55', 'House White (Glass)', '', 'Cold Drinks', 'Wine', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:30:51', 'admin-1502601812-15026022510244753', 1, 1, 'SR', NULL, NULL, NULL),
(42252, '2017-08-13 10:40:58', NULL, NULL, 11997, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:40:58', 'admin-1502590289-15025920585273964', 1, 0, '', NULL, NULL, NULL),
(42253, '2017-08-13 11:40:47', NULL, NULL, 12000, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:40:47', 'admin-1502592651-15025956476539780', 1, 0, '', NULL, NULL, NULL),
(42254, '2017-08-13 11:32:15', NULL, NULL, 12001, 0, 158, '92', 'Banana Stuffed Nutella Toast ', 'Add 1 Scoop vanilla ice cream', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:32:15', 'admin-1502592651-1502595135486819', 1, 0, '', NULL, NULL, NULL),
(42255, '2017-08-13 11:32:15', NULL, NULL, 12001, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:32:15', 'admin-1502592651-1502595135486819', 1, 0, '', NULL, NULL, NULL),
(42256, '2017-08-13 11:29:55', NULL, NULL, 12002, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:29:55', 'admin-1502592651-15025949950011683', 1, 0, '', NULL, NULL, NULL),
(42257, '2017-08-13 11:32:15', NULL, NULL, 12001, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:32:15', 'admin-1502592651-1502595135486819', 1, 1, 'SR', NULL, NULL, NULL),
(42258, '2017-08-13 11:29:55', NULL, NULL, 12002, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:29:55', 'admin-1502592651-15025949950011683', 1, 0, '', NULL, NULL, NULL),
(42259, '2017-08-13 11:29:55', NULL, NULL, 12002, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:29:55', 'admin-1502592651-15025949950011683', 1, 0, '', NULL, NULL, NULL),
(42260, '2017-08-13 11:29:32', NULL, NULL, 12002, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:29:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42261, '2017-08-13 11:22:45', NULL, NULL, 12001, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:22:45', 'admin-1502592651-15025945656646587', 1, 1, 'SR', NULL, NULL, NULL),
(42262, '2017-08-13 11:22:42', NULL, NULL, 12001, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:22:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42263, '2017-08-13 11:11:41', NULL, NULL, 12000, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:11:41', 'admin-1502592651-15025939014998092', 1, 1, 'SR', NULL, NULL, NULL),
(42264, '2017-08-13 14:07:20', NULL, NULL, 12025, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 14:07:20', 'admin-1502601812-15026044405957848', 1, 0, '', NULL, NULL, NULL),
(42265, '2017-08-13 10:43:12', NULL, NULL, 11998, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:43:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42266, '2017-08-13 10:43:18', NULL, NULL, 11998, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:43:18', 'admin-1502590289-15025921979197647', 1, 1, 'SR', NULL, NULL, NULL),
(42267, '2017-08-13 00:00:00', NULL, NULL, 12018, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:39:16', 'admin-1502590289-15025919566569851', 1, 0, '', NULL, NULL, NULL),
(42268, '2017-08-13 10:40:46', NULL, NULL, 11997, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:40:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42269, '2017-08-13 09:22:27', NULL, NULL, 11978, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:22:27', 'admin-1502586496-1502587347583199', 1, 0, '', NULL, NULL, NULL),
(42270, '2017-08-13 11:11:41', NULL, NULL, 12000, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:11:41', 'admin-1502592651-15025939014998092', 1, 1, 'SR', NULL, NULL, NULL),
(42271, '2017-08-13 00:00:00', NULL, NULL, 12017, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:21:35', 'admin-1502590289-15025908950882434', 1, 0, '', NULL, NULL, NULL),
(42272, '2017-08-13 11:11:41', NULL, NULL, 12000, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 11:11:41', 'admin-1502592651-15025939014998092', 1, 1, 'SR', NULL, NULL, NULL),
(42273, '2017-08-13 13:26:08', NULL, NULL, 12021, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:26:08', 'admin-1502601812-15026019679855256', 1, 1, 'SR', NULL, NULL, NULL),
(42274, '2017-08-13 10:50:37', NULL, NULL, 11999, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:50:37', 'admin-1502590289-15025926368806170', 1, 1, 'SR', NULL, NULL, NULL),
(42275, '2017-08-13 10:50:37', NULL, NULL, 11999, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:50:37', 'admin-1502590289-15025926368806170', 1, 0, '', NULL, NULL, NULL),
(42276, '2017-08-13 15:40:33', NULL, NULL, 12034, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.39, 0.0000, 0.0000, 0.39, 1, '27', 1, '1502604446', 'admin', '2017-08-13 15:40:33', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(42277, '2017-08-13 10:50:25', NULL, NULL, 11999, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:50:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42278, '2017-08-13 10:40:58', NULL, NULL, 11997, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:40:58', 'admin-1502590289-15025920585273964', 1, 0, '', NULL, NULL, NULL),
(42279, '2017-08-13 10:40:58', NULL, NULL, 11997, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:40:58', 'admin-1502590289-15025920585273964', 1, 0, '', NULL, NULL, NULL),
(42280, '2017-08-13 09:18:47', NULL, NULL, 11978, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.60, 0.0000, 0.0000, 14.60, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:18:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42281, '2017-08-13 09:21:29', NULL, NULL, 11978, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:21:29', 'admin-1502586496-15025872897511979', 1, 0, '', NULL, NULL, NULL),
(42282, '2017-08-13 09:21:29', NULL, NULL, 11978, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:21:29', 'admin-1502586496-15025872897511979', 1, 0, '', NULL, NULL, NULL),
(42283, '2017-08-13 09:21:29', NULL, NULL, 11978, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:21:29', 'admin-1502586496-15025872897511979', 1, 1, 'SR', NULL, NULL, NULL),
(42284, '2017-08-13 09:21:29', NULL, NULL, 11978, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:21:29', 'admin-1502586496-15025872897511979', 1, 1, 'SR', NULL, NULL, NULL),
(42285, '2017-08-13 09:21:33', NULL, NULL, 11979, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:21:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42286, '2017-08-13 09:21:42', NULL, NULL, 11979, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:21:42', 'admin-1502586496-15025873023069066', 1, 1, 'SR', NULL, NULL, NULL),
(42287, '2017-08-13 10:26:47', NULL, NULL, 11985, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:26:47', 'admin-1502590289-15025912074298140', 1, 1, 'SR', NULL, NULL, '10.0'),
(42288, '2017-08-13 14:41:43', NULL, NULL, 12027, 0, 182, '117', 'Open Drinks ', 'americano waffles', 'Cold Drinks', 'Fresh Juice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 14:41:43', 'admin-1502604446-15026065037503429', 1, 0, '', 1, NULL, NULL),
(42289, '2017-08-13 10:11:25', NULL, NULL, 11994, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:11:25', 'admin-1502589215-15025902848877672', 1, 0, '', NULL, NULL, NULL),
(42290, '2017-08-13 10:23:09', NULL, NULL, 11996, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:23:09', 'admin-1502590289-15025909894337227', 1, 1, 'SR', NULL, NULL, NULL),
(42291, '2017-08-13 09:58:21', NULL, NULL, 11985, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:58:21', 'admin-1502589215-15025895011288757', 1, 0, '', NULL, NULL, '10.0'),
(42292, '2017-08-13 09:58:21', NULL, NULL, 11985, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:58:21', 'admin-1502589215-15025895011288757', 1, 0, '', NULL, NULL, '10.0'),
(42293, '2017-08-13 09:40:44', NULL, NULL, 11986, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:40:44', 'admin-1502588024-1502588444206998', 1, 0, '', NULL, NULL, NULL),
(42294, '2017-08-13 09:40:44', NULL, NULL, 11986, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:40:44', 'admin-1502588024-1502588444206998', 1, 0, '', NULL, NULL, NULL),
(42295, '2017-08-13 09:42:43', NULL, NULL, 11987, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:42:43', 'admin-1502588024-1502588562819154', 1, 0, '', NULL, NULL, NULL),
(42296, '2017-08-13 12:39:56', NULL, NULL, 12012, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:39:56', 'admin-1502597154-15025991959828839', 1, 1, 'SR', NULL, NULL, NULL),
(42297, '2017-08-13 14:04:34', NULL, NULL, 12025, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 14:04:34', 'admin-1502601812-15026042744871291', 1, 1, 'SR', NULL, NULL, NULL),
(42298, '2017-08-13 10:11:25', NULL, NULL, 11994, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:11:25', 'admin-1502589215-15025902848877672', 1, 0, '', NULL, NULL, NULL),
(42299, '2017-08-13 10:11:25', NULL, NULL, 11994, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:11:25', 'admin-1502589215-15025902848877672', 1, 0, '', NULL, NULL, NULL),
(42300, '2017-08-13 10:11:09', NULL, NULL, 11994, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.60, 0.0000, 0.0000, 9.60, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:11:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42301, '2017-08-13 10:08:23', NULL, NULL, 11993, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:08:23', 'admin-1502589215-15025901036836431', 1, 1, 'SR', NULL, NULL, NULL),
(42302, '2017-08-13 10:08:23', NULL, NULL, 11993, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:08:23', 'admin-1502589215-15025901036836431', 1, 0, '', NULL, NULL, NULL),
(42303, '2017-08-13 09:57:47', NULL, NULL, 11992, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:57:47', 'admin-1502589215-15025894672225257', 1, 0, '', NULL, NULL, NULL),
(42304, '2017-08-13 09:57:47', NULL, NULL, 11992, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:57:47', 'admin-1502589215-15025894672225257', 1, 1, 'SR', NULL, NULL, NULL),
(42305, '2017-08-13 13:05:10', NULL, NULL, 12017, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1502604446', 'admin', '2017-08-13 13:05:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42306, '2017-08-13 09:57:47', NULL, NULL, 11992, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:57:47', 'admin-1502589215-15025894672225257', 1, 1, 'SR', NULL, NULL, NULL),
(42307, '2017-08-13 00:00:00', NULL, NULL, 12018, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, NULL, NULL, 2.80, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:21:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42308, '2017-08-13 09:46:05', NULL, NULL, 11989, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:46:05', 'admin-1502588024-15025887654273744', 1, 0, '', NULL, NULL, '10.0'),
(42309, '2017-08-13 09:46:05', NULL, NULL, 11989, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:46:05', 'admin-1502588024-15025887654273744', 1, 0, '', NULL, NULL, '10.0'),
(42310, '2017-08-13 09:46:05', NULL, NULL, 11989, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:46:05', 'admin-1502588024-15025887654273744', 1, 0, '', NULL, NULL, '10.0'),
(42311, '2017-08-13 09:57:04', NULL, NULL, 11992, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:57:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42312, '2017-08-13 09:57:00', NULL, NULL, 11985, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:57:00', 'admin-1502589215-15025894204524832', 1, 1, 'SR', NULL, NULL, '10.0'),
(42313, '2017-08-13 09:57:00', NULL, NULL, 11985, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:57:00', 'admin-1502589215-15025894204524832', 1, 1, 'SR', NULL, NULL, '10.0'),
(42314, '2017-08-13 09:51:15', NULL, NULL, 11990, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:51:15', 'admin-1502588024-15025890748008857', 1, 0, '', NULL, NULL, NULL),
(42315, '2017-08-13 09:51:15', NULL, NULL, 11990, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:51:15', 'admin-1502588024-15025890748008857', 1, 0, '', NULL, NULL, NULL),
(42316, '2017-08-13 09:51:15', NULL, NULL, 11990, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:51:15', 'admin-1502588024-15025890748008857', 1, 0, '', NULL, NULL, NULL),
(42317, '2017-08-13 09:51:15', NULL, NULL, 11990, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:51:15', 'admin-1502588024-15025890748008857', 1, 1, 'SR', NULL, NULL, NULL),
(42318, '2017-08-13 12:01:42', NULL, NULL, 12004, 0, 223, '157', 'Crispy Bacon Aglio Olio', 'EXTRA SPICY', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:01:42', 'admin-1502592651-1502596902353396', 1, 0, '', NULL, NULL, NULL),
(42319, '2017-08-13 09:54:33', NULL, NULL, 11989, 0, 181, '116', 'Open Food ', 'pancake honey', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:54:33', 'admin-1502589215-15025892736857947', 1, 0, '', NULL, NULL, '10.0'),
(42320, '2017-08-13 09:37:47', NULL, NULL, 11985, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.20, 0.0000, 0.0000, 15.20, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:37:47', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(42321, '2017-08-13 09:38:00', NULL, NULL, 11985, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:38:00', 'admin-1502588024-1502588280135487', 1, 0, '', NULL, NULL, '10.0'),
(42322, '2017-08-13 09:38:00', NULL, NULL, 11985, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:38:00', 'admin-1502588024-1502588280135487', 1, 0, '', NULL, NULL, '10.0'),
(42323, '2017-08-13 09:38:00', NULL, NULL, 11985, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:38:00', 'admin-1502588024-1502588280135487', 1, 0, '', NULL, NULL, '10.0'),
(42324, '2017-08-13 12:16:08', NULL, NULL, 12009, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 12:16:08', 'admin-1502597154-1502597768157446', 1, 0, '', NULL, NULL, NULL),
(42325, '2017-08-13 09:50:52', NULL, NULL, 11990, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:50:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42326, '2017-08-13 09:42:02', NULL, NULL, 11987, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.80, 0.0000, 0.0000, 11.80, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:42:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42327, '2017-08-13 14:46:31', NULL, NULL, 12028, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 14:46:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42328, '2017-08-13 09:46:05', NULL, NULL, 11989, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:46:05', 'admin-1502588024-15025887654273744', 1, 1, 'SR', NULL, NULL, '10.0'),
(42329, '2017-08-13 09:45:15', NULL, NULL, 11989, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:45:15', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(42330, '2017-08-13 09:42:43', NULL, NULL, 11987, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:42:43', 'admin-1502588024-1502588562819154', 1, 0, '', NULL, NULL, NULL),
(42331, '2017-08-13 09:42:43', NULL, NULL, 11987, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:42:43', 'admin-1502588024-1502588562819154', 1, 1, 'SR', NULL, NULL, NULL),
(42332, '2017-08-13 09:09:53', NULL, NULL, 11977, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:09:53', 'admin-1502586496-15025865934873838', 1, 0, '', NULL, NULL, NULL),
(42333, '2017-08-13 09:09:53', NULL, NULL, 11977, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:09:53', 'admin-1502586496-15025865934873838', 1, 0, '', NULL, NULL, NULL),
(42334, '2017-08-13 09:09:53', NULL, NULL, 11977, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:09:53', 'admin-1502586496-15025865934873838', 1, 0, '', NULL, NULL, NULL),
(42335, '2017-08-13 09:09:53', NULL, NULL, 11977, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:09:53', 'admin-1502586496-15025865934873838', 1, 0, '', NULL, NULL, NULL),
(42336, '2017-08-13 09:42:43', NULL, NULL, 11987, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:42:43', 'admin-1502588024-1502588562819154', 1, 1, 'SR', NULL, NULL, NULL),
(42337, '2017-08-13 09:42:43', NULL, NULL, 11987, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:42:43', 'admin-1502588024-1502588562819154', 1, 0, '', NULL, NULL, NULL),
(42338, '2017-08-13 09:42:43', NULL, NULL, 11987, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:42:43', 'admin-1502588024-1502588562819154', 1, 1, 'SR', NULL, NULL, NULL),
(42339, '2017-08-13 09:46:05', NULL, NULL, 11989, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:46:05', 'admin-1502588024-15025887654273744', 1, 1, 'SR', NULL, NULL, '10.0'),
(42340, '2017-08-13 09:40:49', NULL, NULL, 11986, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:40:49', 'admin-1502588024-1502588449104298', 1, 1, 'SR', NULL, NULL, NULL),
(42341, '2017-08-13 09:42:42', NULL, NULL, 11987, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:42:42', 'admin-1502588024-1502588562819154', 1, 0, '', NULL, NULL, NULL),
(42342, '2017-08-13 09:42:43', NULL, NULL, 11987, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:42:43', 'admin-1502588024-1502588562819154', 1, 0, '', NULL, NULL, NULL),
(42343, '2017-08-13 09:25:05', NULL, NULL, 11980, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:25:05', 'admin-1502586496-15025875054396776', 1, 0, '', NULL, NULL, NULL),
(42344, '2017-08-13 09:40:44', NULL, NULL, 11986, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:40:44', 'admin-1502588024-1502588444206998', 1, 0, '', NULL, NULL, NULL),
(42345, '2017-08-13 09:40:49', NULL, NULL, 11986, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:40:49', 'admin-1502588024-1502588449104298', 1, 1, 'SR', NULL, NULL, NULL),
(42346, '2017-08-13 09:38:37', NULL, NULL, 11985, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:38:37', 'admin-1502588024-15025883169019736', 1, 1, 'SR', NULL, NULL, '10.0'),
(42347, '2017-08-13 09:40:44', NULL, NULL, 11986, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:40:44', 'admin-1502588024-1502588444206998', 1, 0, '', NULL, NULL, NULL),
(42348, '2017-08-13 09:34:55', NULL, NULL, 11984, 0, 181, '116', 'Open Food ', 'americano with waffle', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:34:55', 'admin-1502588024-15025880948643556', 1, 0, '', 1, NULL, NULL),
(42349, '2017-08-13 09:38:37', NULL, NULL, 11985, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:38:37', 'admin-1502588024-15025883169019736', 1, 1, 'SR', NULL, NULL, '10.0'),
(42350, '2017-08-13 09:38:37', NULL, NULL, 11985, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:38:37', 'admin-1502588024-15025883169019736', 1, 1, 'SR', NULL, NULL, '10.0'),
(42351, '2017-08-13 09:33:57', NULL, NULL, 11983, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:33:57', 'admin-1502588024-1502588037118595', 1, 0, '', NULL, NULL, NULL),
(42352, '2017-08-13 09:33:37', NULL, NULL, 11983, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:33:37', 'admin-1502586496-15025880173208128', 1, 0, '', NULL, NULL, NULL),
(42353, '2017-08-13 09:38:37', NULL, NULL, 11985, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:38:37', 'admin-1502588024-15025883169019736', 1, 0, '', NULL, NULL, '10.0'),
(42354, '2017-08-13 10:08:08', NULL, NULL, 11993, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1502604446', 'admin', '2017-08-13 10:08:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42355, '2017-08-13 09:33:26', NULL, NULL, 11983, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:33:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42356, '2017-08-13 09:33:37', NULL, NULL, 11983, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:33:37', 'admin-1502586496-15025880173208128', 1, 0, '', NULL, NULL, NULL),
(42357, '2017-08-13 09:27:57', NULL, NULL, 11982, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:27:57', 'admin-1502586496-15025876768826898', 1, 1, 'SR', NULL, NULL, NULL),
(42358, '2017-08-13 09:27:57', NULL, NULL, 11982, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:27:57', 'admin-1502586496-15025876768826898', 1, 0, '', NULL, NULL, NULL),
(42359, '2017-08-13 09:27:57', NULL, NULL, 11982, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:27:57', 'admin-1502586496-15025876768826898', 1, 0, '', NULL, NULL, NULL),
(42360, '2017-08-13 09:27:57', NULL, NULL, 11982, 0, 153, '87', 'Wake Me Up!', 'sausage change to bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:27:57', 'admin-1502586496-15025876768826898', 1, 0, '', NULL, NULL, NULL),
(42361, '2017-08-13 09:27:57', NULL, NULL, 11982, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:27:57', 'admin-1502586496-15025876768826898', 1, 0, '', NULL, NULL, NULL),
(42362, '2017-08-13 09:26:49', NULL, NULL, 11981, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:26:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42363, '2017-08-13 09:27:04', NULL, NULL, 11982, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:27:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42364, '2017-08-13 09:22:42', NULL, NULL, 11978, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:22:42', 'admin-1502586496-15025873618685429', 1, 1, 'SR', NULL, NULL, NULL),
(42365, '2017-08-13 09:22:27', NULL, NULL, 11978, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 2, 16.00, 32.0000, 0.0000, 32.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:22:27', 'admin-1502586496-1502587347583199', 1, 0, '', NULL, NULL, NULL),
(42366, '2017-08-13 09:10:17', NULL, NULL, 11977, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:10:17', 'admin-1502586496-15025866175967159', 1, 0, '', NULL, NULL, NULL),
(42367, '2017-08-13 09:10:17', NULL, NULL, 11977, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:10:17', 'admin-1502586496-15025866175967159', 1, 1, 'SR', NULL, NULL, NULL),
(42368, '2017-08-13 09:10:17', NULL, NULL, 11977, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:10:17', 'admin-1502586496-15025866175967159', 1, 1, 'SR', NULL, NULL, NULL),
(42369, '2017-08-13 09:09:43', NULL, NULL, 11977, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1502604446', 'admin', '2017-08-13 09:09:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42370, '2017-08-14 13:04:16', NULL, NULL, 12049, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:04:16', 'admin-1502686902-15026870567032215', 1, 0, '', NULL, NULL, '10.0'),
(42371, '2017-08-14 13:20:15', NULL, NULL, 12053, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:20:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42372, '2017-08-14 13:21:23', NULL, NULL, 12053, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:21:23', 'admin-1502686902-15026880833674617', 1, 0, '', NULL, NULL, NULL),
(42373, '2017-08-14 13:58:14', NULL, NULL, 12057, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:58:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42374, '2017-08-14 17:11:27', NULL, NULL, 12060, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 17:11:27', 'admin-1502686902-15027018877834685', 1, 1, 'SR', NULL, NULL, NULL),
(42375, '2017-08-14 12:56:15', NULL, NULL, 12051, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:56:15', 'admin-1502684691-1502686575707875', 1, 0, '', NULL, NULL, NULL),
(42376, '2017-08-14 12:56:15', NULL, NULL, 12051, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:56:15', 'admin-1502684691-1502686575707875', 1, 1, 'SR', NULL, NULL, NULL),
(42377, '2017-08-14 12:59:20', NULL, NULL, 12052, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:59:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42378, '2017-08-14 10:19:07', NULL, NULL, 12040, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 10:19:07', 'admin-1502673052-15026771475419143', 1, 0, '', NULL, NULL, NULL),
(42379, '2017-08-14 10:19:11', NULL, NULL, 12042, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1502686902', 'admin', '2017-08-14 10:19:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42380, '2017-08-14 10:19:14', NULL, NULL, 12042, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 10:19:14', 'admin-1502673052-15026771546729851', 1, 1, 'SR', NULL, NULL, NULL),
(42381, '2017-08-14 10:19:14', NULL, NULL, 12042, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 10:19:14', 'admin-1502673052-15026771546729851', 1, 0, '', NULL, NULL, NULL),
(42382, '2017-08-14 10:19:23', NULL, NULL, 12040, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 10:19:23', 'admin-1502673052-15026771631128673', 1, 1, 'SR', NULL, NULL, NULL),
(42383, '2017-08-14 10:23:03', NULL, NULL, 12043, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1502686902', 'admin', '2017-08-14 10:23:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42384, '2017-08-14 13:34:18', NULL, NULL, 12049, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:34:18', 'admin-1502686902-15026888581672628', 1, 1, 'SR', NULL, NULL, '10.0'),
(42385, '2017-08-14 13:58:28', NULL, NULL, 12057, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:58:28', 'admin-1502686902-1502690307980448', 1, 1, 'SR', NULL, NULL, NULL),
(42386, '2017-08-14 13:58:28', NULL, NULL, 12057, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:58:28', 'admin-1502686902-1502690307980448', 1, 1, 'SR', NULL, NULL, NULL),
(42387, '2017-08-14 12:25:00', NULL, NULL, 12046, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:25:00', 'admin-1502684691-15026846999459586', 1, 1, 'SR', NULL, NULL, NULL),
(42388, '2017-08-14 12:25:00', NULL, NULL, 12046, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:25:00', 'admin-1502684691-15026846999459586', 1, 1, 'SR', NULL, NULL, NULL),
(42389, '2017-08-14 13:41:44', NULL, NULL, 12054, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:41:44', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(42390, '2017-08-14 13:50:18', NULL, NULL, 12056, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:50:18', 'admin-1502686902-15026898182786418', 1, 1, 'SR', NULL, NULL, NULL),
(42391, '2017-08-14 16:18:05', NULL, NULL, 12059, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1502686902', 'admin', '2017-08-14 16:18:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42392, '2017-08-14 16:18:12', NULL, NULL, 12059, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 16:18:12', 'admin-1502686902-15026986920004734', 1, 1, 'SR', NULL, NULL, NULL),
(42393, '2017-08-14 12:24:23', NULL, NULL, 12046, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:24:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42394, '2017-08-14 12:24:47', NULL, NULL, 12046, 0, 73, '73', 'Marmite Chicken ', 'egg welldone', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:24:47', 'admin-1502673052-15026846873893683', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(42395, '2017-08-14 13:58:28', NULL, NULL, 12057, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:58:28', 'admin-1502686902-1502690307980448', 1, 1, 'SR', NULL, NULL, NULL),
(42396, '2017-08-14 12:26:37', NULL, NULL, 12047, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.20, 0.0000, 0.0000, 11.20, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:26:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42397, '2017-08-14 12:26:53', NULL, NULL, 12047, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:26:53', 'admin-1502684691-15026848132398189', 1, 0, '', NULL, NULL, NULL),
(42398, '2017-08-14 13:41:47', NULL, NULL, 12054, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:41:47', 'admin-1502686902-15026893071867480', 1, 1, 'SR', NULL, NULL, '10.0'),
(42399, '2017-08-14 13:41:47', NULL, NULL, 12054, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:41:47', 'admin-1502686902-15026893071867480', 1, 1, 'SR', NULL, NULL, '10.0'),
(42400, '2017-08-14 13:41:51', NULL, NULL, 12054, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:41:51', 'admin-1502686902-15026893110752255', 1, 0, '', NULL, NULL, '10.0'),
(42401, '2017-08-14 14:28:30', NULL, NULL, 12058, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 14:28:30', 'admin-1502686902-15026921101524086', 1, 1, 'SR', 1, NULL, '10.0'),
(42402, '2017-08-14 16:18:12', NULL, NULL, 12059, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 16:18:12', 'admin-1502686902-15026986920004734', 1, 0, '', NULL, NULL, NULL),
(42403, '2017-08-14 16:18:15', NULL, NULL, 12060, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1502686902', 'admin', '2017-08-14 16:18:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42404, '2017-08-14 16:18:17', NULL, NULL, 12060, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 16:18:17', 'admin-1502686902-15026986975505160', 1, 1, 'SR', NULL, NULL, NULL),
(42405, '2017-08-14 16:18:19', NULL, NULL, 12061, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1502686902', 'admin', '2017-08-14 16:18:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42406, '2017-08-14 16:18:22', NULL, NULL, 12061, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 16:18:22', 'admin-1502686902-1502698702383123', 1, 1, 'SR', NULL, NULL, NULL),
(42407, '2017-08-14 10:15:25', NULL, NULL, 12041, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 10:15:25', 'admin-1502673052-15026769253859211', 1, 0, '', NULL, NULL, NULL),
(42408, '2017-08-14 12:48:16', NULL, NULL, 12050, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:48:16', 'admin-1502684691-15026860961718981', 1, 0, '', NULL, NULL, NULL),
(42409, '2017-08-14 12:55:26', NULL, NULL, 12051, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:55:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42410, '2017-08-14 12:55:33', NULL, NULL, 12051, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:55:33', 'admin-1502684691-15026865328783772', 1, 1, 'SR', NULL, NULL, NULL),
(42411, '2017-08-14 17:11:27', NULL, NULL, 12060, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 17:11:27', 'admin-1502686902-15027018877834685', 1, 0, '', NULL, NULL, NULL),
(42412, '2017-08-14 13:58:28', NULL, NULL, 12057, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:58:28', 'admin-1502686902-1502690307980448', 1, 0, '', NULL, NULL, NULL),
(42413, '2017-08-14 13:41:51', NULL, NULL, 12054, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:41:51', 'admin-1502686902-15026893110752255', 1, 0, '', NULL, NULL, '10.0'),
(42414, '2017-08-14 13:48:53', NULL, NULL, 12055, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:48:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42415, '2017-08-14 13:49:01', NULL, NULL, 12055, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:49:01', 'admin-1502686902-1502689741102229', 1, 1, 'SR', NULL, NULL, NULL),
(42416, '2017-08-14 13:49:01', NULL, NULL, 12055, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:49:01', 'admin-1502686902-1502689741102229', 1, 1, 'SR', NULL, NULL, NULL),
(42417, '2017-08-14 13:50:01', NULL, NULL, 12056, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:50:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42418, '2017-08-14 13:50:12', NULL, NULL, 12056, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:50:12', 'admin-1502686902-15026898124385125', 1, 0, '', NULL, NULL, NULL),
(42419, '2017-08-14 13:50:12', NULL, NULL, 12056, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:50:12', 'admin-1502686902-15026898124385125', 1, 0, '', NULL, NULL, NULL),
(42420, '2017-08-14 13:50:18', NULL, NULL, 12056, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:50:18', 'admin-1502686902-15026898182786418', 1, 0, '', NULL, NULL, NULL),
(42421, '2017-08-14 12:39:51', NULL, NULL, 12049, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:39:51', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(42422, '2017-08-14 12:40:08', NULL, NULL, 12049, 0, 73, '73', 'Marmite Chicken ', 'ex rice', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:40:08', 'admin-1502684691-1502685608722168', 1, 1, 'SR', NULL, NULL, '10.0'),
(42423, '2017-08-14 12:40:08', NULL, NULL, 12049, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', 'ex rice', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:40:08', 'admin-1502684691-1502685608722168', 1, 0, '', NULL, NULL, '10.0'),
(42424, '2017-08-14 12:48:07', NULL, NULL, 12050, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:48:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42425, '2017-08-14 10:15:08', NULL, NULL, 12041, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1502686902', 'admin', '2017-08-14 10:15:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42426, '2017-08-14 12:59:37', NULL, NULL, 12052, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:59:37', 'admin-1502684691-1502686777211697', 1, 0, '', NULL, NULL, NULL),
(42427, '2017-08-14 13:34:18', NULL, NULL, 12049, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:34:18', 'admin-1502686902-15026888581672628', 1, 1, 'SR', NULL, NULL, '10.0'),
(42428, '2017-08-14 13:32:50', NULL, NULL, 12052, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:32:50', 'admin-1502686902-15026887704175379', 1, 0, '', NULL, NULL, NULL),
(42429, '2017-08-14 13:21:23', NULL, NULL, 12053, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:21:23', 'admin-1502686902-15026880833674617', 1, 1, 'SR', NULL, NULL, NULL),
(42430, '2017-08-14 12:26:53', NULL, NULL, 12047, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:26:53', 'admin-1502684691-15026848132398189', 1, 0, '', NULL, NULL, NULL),
(42431, '2017-08-14 12:26:53', NULL, NULL, 12047, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:26:53', 'admin-1502684691-15026848132398189', 1, 0, '', NULL, NULL, NULL),
(42432, '2017-08-14 12:27:11', NULL, NULL, 12047, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:27:11', 'admin-1502684691-15026848312238528', 1, 1, 'SR', NULL, NULL, NULL),
(42433, '2017-08-14 12:27:11', NULL, NULL, 12047, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:27:11', 'admin-1502684691-15026848312238528', 1, 1, 'SR', NULL, NULL, NULL),
(42434, '2017-08-14 12:27:11', NULL, NULL, 12047, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:27:11', 'admin-1502684691-15026848312238528', 1, 1, 'SR', NULL, NULL, NULL),
(42435, '2017-08-14 12:27:11', NULL, NULL, 12047, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:27:11', 'admin-1502684691-15026848312238528', 1, 1, 'SR', NULL, NULL, NULL),
(42436, '2017-08-14 12:36:16', NULL, NULL, 12048, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:36:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42437, '2017-08-14 13:21:23', NULL, NULL, 12053, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:21:23', 'admin-1502686902-15026880833674617', 1, 1, 'SR', NULL, NULL, NULL),
(42438, '2017-08-14 13:21:23', NULL, NULL, 12053, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:21:23', 'admin-1502686902-15026880833674617', 1, 0, '', NULL, NULL, NULL),
(42439, '2017-08-14 12:59:37', NULL, NULL, 12052, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:59:37', 'admin-1502684691-1502686777211697', 1, 0, '', NULL, NULL, NULL),
(42440, '2017-08-14 12:59:37', NULL, NULL, 12052, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:59:37', 'admin-1502684691-1502686777211697', 1, 1, 'SR', NULL, NULL, NULL),
(42441, '2017-08-14 12:59:37', NULL, NULL, 12052, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:59:37', 'admin-1502684691-1502686777211697', 1, 1, 'SR', NULL, NULL, NULL),
(42442, '2017-08-14 12:59:37', NULL, NULL, 12052, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:59:37', 'admin-1502684691-1502686777211697', 1, 1, 'SR', NULL, NULL, NULL),
(42443, '2017-08-14 12:36:27', NULL, NULL, 12048, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:36:27', 'admin-1502684691-15026853870184573', 1, 1, 'SR', NULL, NULL, NULL),
(42444, '2017-08-14 13:01:37', NULL, NULL, 12052, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 13:01:37', 'admin-1502684691-1502686897370192', 1, 0, '', NULL, NULL, NULL),
(42445, '2017-08-14 12:48:13', NULL, NULL, 12050, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:48:13', 'admin-1502684691-15026860931115969', 1, 1, 'SR', NULL, NULL, NULL),
(42446, '2017-08-14 12:36:27', NULL, NULL, 12048, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:36:27', 'admin-1502684691-15026853870184573', 1, 1, 'SR', NULL, NULL, NULL),
(42447, '2017-08-14 12:36:27', NULL, NULL, 12048, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:36:27', 'admin-1502684691-15026853870184573', 1, 1, 'SR', NULL, NULL, NULL),
(42448, '2017-08-14 12:36:27', NULL, NULL, 12048, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:36:27', 'admin-1502684691-15026853870184573', 1, 0, '', NULL, NULL, NULL),
(42449, '2017-08-14 12:26:53', NULL, NULL, 12047, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:26:53', 'admin-1502684691-15026848132398189', 1, 0, '', NULL, NULL, NULL),
(42450, '2017-08-14 10:23:10', NULL, NULL, 12043, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 10:23:10', 'admin-1502673052-15026773901784462', 1, 0, '', NULL, NULL, NULL),
(42451, '2017-08-14 12:24:47', NULL, NULL, 12046, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 12:24:47', 'admin-1502673052-15026846873893683', 1, 1, 'SR', NULL, NULL, NULL),
(42452, '2017-08-14 10:30:42', NULL, NULL, 12044, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 10:30:42', 'admin-1502673052-15026778423178543', 1, 1, 'SR', NULL, NULL, NULL),
(42453, '2017-08-14 10:38:24', NULL, NULL, 12045, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1502686902', 'admin', '2017-08-14 10:38:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42454, '2017-08-14 10:38:26', NULL, NULL, 12045, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 10:38:26', 'admin-1502673052-15026783065547626', 1, 1, 'SR', NULL, NULL, NULL),
(42455, '2017-08-14 10:30:34', NULL, NULL, 12044, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 10:30:34', 'admin-1502673052-15026778343747943', 1, 0, '', NULL, NULL, NULL),
(42456, '2017-08-14 10:30:42', NULL, NULL, 12044, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 10:30:42', 'admin-1502673052-15026778423178543', 1, 1, 'SR', NULL, NULL, NULL),
(42457, '2017-08-14 10:23:18', NULL, NULL, 12043, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 10:23:18', 'admin-1502673052-15026773980833831', 1, 1, 'SR', NULL, NULL, NULL),
(42458, '2017-08-14 10:29:57', NULL, NULL, 12044, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.05, 0.0000, 0.0000, 5.05, 1, '27', 1, '1502686902', 'admin', '2017-08-14 10:29:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42459, '2017-08-14 10:30:34', NULL, NULL, 12044, 0, 271, '205', 'Take It Easy', 'add baked beans', 'Meals', 'Morning Bites ', 1, 16.50, 16.5000, 0.0000, 16.50, 1, '27', 1, '1502686902', 'admin', '2017-08-14 10:30:34', 'admin-1502673052-15026778343747943', 1, 0, '', NULL, NULL, NULL),
(42460, '2017-08-14 10:15:25', NULL, NULL, 12041, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 10:15:25', 'admin-1502673052-15026769253859211', 1, 0, '', NULL, NULL, NULL),
(42461, '2017-08-14 10:15:25', NULL, NULL, 12041, 0, 153, '87', 'Wake Me Up!', ' add potato,No bread', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 10:15:25', 'admin-1502673052-15026769253859211', 1, 0, '', NULL, NULL, NULL),
(42462, '2017-08-14 09:51:22', NULL, NULL, 12040, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 09:51:22', 'admin-1502673052-150267548242584', 1, 1, 'SR', NULL, NULL, NULL),
(42463, '2017-08-14 09:11:11', NULL, NULL, 12040, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 09:11:11', 'admin-1502673052-15026730708123424', 1, 0, '', NULL, NULL, NULL),
(42464, '2017-08-14 09:11:11', NULL, NULL, 12040, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 09:11:11', 'admin-1502673052-15026730708123424', 1, 1, 'SR', NULL, NULL, NULL),
(42465, '2017-08-14 09:10:59', NULL, NULL, 12040, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1502686902', 'admin', '2017-08-14 09:10:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42466, '2017-08-16 16:26:56', NULL, NULL, 12085, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 16:26:56', 'admin-1502859986-1502872016303609', 1, 0, '', NULL, NULL, NULL),
(42467, '2017-08-16 16:26:56', NULL, NULL, 12085, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 16:26:56', 'admin-1502859986-1502872016303609', 1, 1, 'SR', NULL, NULL, NULL),
(42468, '2017-08-16 16:26:52', NULL, NULL, 12085, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1502859986', 'admin', '2017-08-16 16:26:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42469, '2017-08-16 13:20:50', NULL, NULL, 12075, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:20:50', 'admin-1502859986-15028608504375147', 1, 1, 'SR', NULL, NULL, NULL),
(42470, '2017-08-16 13:16:41', NULL, NULL, 12074, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:16:41', 'admin-1502859986-15028606011302261', 1, 1, 'SR', NULL, NULL, NULL),
(42471, '2017-08-16 13:51:44', NULL, NULL, 12078, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:51:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42472, '2017-08-16 13:51:50', NULL, NULL, 12078, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:51:50', 'admin-1502859986-15028627104477220', 1, 1, 'SR', NULL, NULL, NULL),
(42473, '2017-08-16 10:12:05', NULL, NULL, 12063, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 10:12:05', 'admin-1502845141-1502849525479472', 1, 0, '', NULL, NULL, NULL),
(42474, '2017-08-16 10:23:03', NULL, NULL, 12064, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1502859986', 'admin', '2017-08-16 10:23:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42475, '2017-08-16 10:23:07', NULL, NULL, 12064, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 10:23:07', 'admin-1502845141-15028501868914334', 1, 0, '', NULL, NULL, NULL),
(42476, '2017-08-16 10:23:10', NULL, NULL, 12064, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 10:23:10', 'admin-1502845141-15028501908198117', 1, 1, 'SR', NULL, NULL, NULL),
(42477, '2017-08-16 10:43:15', NULL, NULL, 12062, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 10:43:15', 'admin-1502845141-15028513953623896', 1, 0, '', NULL, NULL, NULL),
(42478, '2017-08-16 10:45:43', NULL, NULL, 12065, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1502859986', 'admin', '2017-08-16 10:45:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42479, '2017-08-16 16:21:15', NULL, NULL, 12084, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1502859986', 'admin', '2017-08-16 16:21:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42480, '2017-08-16 15:58:00', NULL, NULL, 12082, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 15:58:00', 'admin-1502859986-15028702798686389', 1, 1, 'SR', NULL, NULL, NULL),
(42481, '2017-08-16 15:58:13', NULL, NULL, 12082, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 15:58:13', 'admin-1502859986-15028702937129434', 1, 0, '', NULL, NULL, NULL),
(42482, '2017-08-16 15:58:06', NULL, NULL, 12083, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 15:58:06', 'admin-1502859986-1502870286356199', 1, 1, 'SR', NULL, NULL, NULL),
(42483, '2017-08-16 11:39:26', NULL, NULL, 12068, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 11:39:26', 'admin-1502845141-15028547666659253', 1, 1, 'SR', NULL, NULL, NULL),
(42484, '2017-08-16 11:53:17', NULL, NULL, 12069, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1502859986', 'admin', '2017-08-16 11:53:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42485, '2017-08-16 13:06:20', NULL, NULL, 12073, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:06:20', 'admin-1502857330-15028599806235193', 1, 0, '', NULL, NULL, NULL),
(42486, '2017-08-16 15:58:02', NULL, NULL, 12083, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1502859986', 'admin', '2017-08-16 15:58:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42487, '2017-08-16 13:16:41', NULL, NULL, 12074, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:16:41', 'admin-1502859986-15028606011302261', 1, 1, 'SR', NULL, NULL, NULL),
(42488, '2017-08-16 10:54:52', NULL, NULL, 12066, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 10:54:52', 'admin-1502845141-15028520919239977', 1, 1, 'SR', 1, NULL, '10.0'),
(42489, '2017-08-16 15:57:55', NULL, NULL, 12082, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1502859986', 'admin', '2017-08-16 15:57:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42490, '2017-08-16 16:21:21', NULL, NULL, 12084, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 16:21:21', 'admin-1502859986-15028716814309075', 1, 0, '', NULL, NULL, NULL),
(42491, '2017-08-16 15:03:42', NULL, NULL, 12080, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 15:03:42', 'admin-1502859986-15028670219912497', 1, 0, '', NULL, NULL, NULL),
(42492, '2017-08-16 14:51:51', NULL, NULL, 12080, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1502859986', 'admin', '2017-08-16 14:51:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42493, '2017-08-16 14:52:02', NULL, NULL, 12080, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 2, 11.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 14:52:02', 'admin-1502859986-1502866322677724', 1, 0, '', NULL, NULL, NULL),
(42494, '2017-08-16 15:00:43', NULL, NULL, 12081, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1502859986', 'admin', '2017-08-16 15:00:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42495, '2017-08-16 15:00:48', NULL, NULL, 12081, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 15:00:48', 'admin-1502859986-1502866848783394', 1, 1, 'SR', NULL, NULL, NULL),
(42496, '2017-08-16 13:58:04', NULL, NULL, 12079, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:58:04', 'admin-1502859986-15028630847058249', 1, 1, 'SR', NULL, NULL, NULL),
(42497, '2017-08-16 13:58:04', NULL, NULL, 12079, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:58:04', 'admin-1502859986-15028630847058249', 1, 0, '', NULL, NULL, NULL),
(42498, '2017-08-16 13:57:34', NULL, NULL, 12079, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:57:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42499, '2017-08-16 13:21:04', NULL, NULL, 12075, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:21:04', 'admin-1502859986-15028608638577375', 1, 0, '', NULL, NULL, NULL),
(42500, '2017-08-16 13:31:10', NULL, NULL, 12076, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:31:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42501, '2017-08-16 13:31:14', NULL, NULL, 12076, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:31:14', 'admin-1502859986-15028614742368095', 1, 1, 'SR', NULL, NULL, NULL),
(42502, '2017-08-16 13:31:14', NULL, NULL, 12076, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:31:14', 'admin-1502859986-15028614742368095', 1, 1, 'SR', NULL, NULL, NULL),
(42503, '2017-08-16 13:48:24', NULL, NULL, 12077, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:48:24', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(42504, '2017-08-16 10:11:23', NULL, NULL, 12063, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1502859986', 'admin', '2017-08-16 10:11:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42505, '2017-08-16 10:12:05', NULL, NULL, 12063, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 10:12:05', 'admin-1502845141-1502849525479472', 1, 0, '', NULL, NULL, NULL),
(42506, '2017-08-16 12:32:47', NULL, NULL, 12070, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 12:32:47', 'admin-1502857330-15028579673177070', 1, 0, '', NULL, NULL, NULL),
(42507, '2017-08-16 12:32:47', NULL, NULL, 12070, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 12:32:47', 'admin-1502857330-15028579673177070', 1, 1, 'SR', NULL, NULL, NULL),
(42508, '2017-08-16 12:32:47', NULL, NULL, 12070, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 12:32:47', 'admin-1502857330-15028579673177070', 1, 1, 'SR', NULL, NULL, NULL),
(42509, '2017-08-16 13:48:30', NULL, NULL, 12077, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:48:30', 'admin-1502859986-15028625099512967', 1, 0, '', NULL, NULL, '10.0'),
(42510, '2017-08-16 13:48:30', NULL, NULL, 12077, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:48:30', 'admin-1502859986-15028625099512967', 1, 0, '', NULL, NULL, '10.0'),
(42511, '2017-08-16 13:48:30', NULL, NULL, 12077, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:48:30', 'admin-1502859986-15028625099512967', 1, 1, 'SR', NULL, NULL, '10.0'),
(42512, '2017-08-16 13:48:30', NULL, NULL, 12077, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:48:30', 'admin-1502859986-15028625099512967', 1, 1, 'SR', NULL, NULL, '10.0'),
(42513, '2017-08-16 13:31:06', NULL, NULL, 12072, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:31:06', 'admin-1502859986-15028614667312520', 1, 0, '', NULL, NULL, NULL),
(42514, '2017-08-16 13:21:04', NULL, NULL, 12075, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:21:04', 'admin-1502859986-15028608638577375', 1, 1, 'SR', NULL, NULL, NULL),
(42515, '2017-08-16 13:21:04', NULL, NULL, 12075, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:21:04', 'admin-1502859986-15028608638577375', 1, 1, 'SR', NULL, NULL, NULL),
(42516, '2017-08-16 13:20:50', NULL, NULL, 12075, 0, 80, '80', 'Oriental Chicken Salad', 'add bacon', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:20:50', 'admin-1502859986-15028608504375147', 1, 1, 'SR', NULL, NULL, NULL),
(42517, '2017-08-16 13:20:50', NULL, NULL, 12075, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:20:50', 'admin-1502859986-15028608504375147', 1, 1, 'SR', NULL, NULL, NULL),
(42518, '2017-08-16 13:20:28', NULL, NULL, 12075, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:20:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42519, '2017-08-16 13:16:41', NULL, NULL, 12074, 0, 77, '77', 'Sarawak Kolomee', 'no chili', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:16:41', 'admin-1502859986-15028606011302261', 1, 1, 'SR', NULL, NULL, NULL),
(42520, '2017-08-16 13:16:05', NULL, NULL, 12074, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:16:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42521, '2017-08-16 13:16:41', NULL, NULL, 12074, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:16:41', 'admin-1502859986-15028606011302261', 1, 1, 'SR', NULL, NULL, NULL),
(42522, '2017-08-16 12:34:22', NULL, NULL, 12070, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 12:34:22', 'admin-1502857330-15028580621461852', 1, 0, '', NULL, NULL, NULL),
(42523, '2017-08-16 09:58:52', NULL, NULL, 12062, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 09:58:52', 'admin-1502845141-15028487324476139', 1, 0, '', NULL, NULL, NULL),
(42524, '2017-08-16 09:59:04', NULL, NULL, 12062, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 09:59:04', 'admin-1502845141-15028487438579242', 1, 0, '', NULL, NULL, NULL),
(42525, '2017-08-16 13:06:20', NULL, NULL, 12073, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:06:20', 'admin-1502857330-15028599806235193', 1, 1, 'SR', NULL, NULL, NULL),
(42526, '2017-08-16 13:01:49', NULL, NULL, 12072, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:01:49', 'admin-1502857330-15028597089406899', 1, 1, 'SR', NULL, NULL, NULL),
(42527, '2017-08-16 12:30:56', NULL, NULL, 12071, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 12:30:56', 'admin-1502857330-15028578561095051', 1, 0, '', NULL, NULL, NULL),
(42528, '2017-08-16 13:01:49', NULL, NULL, 12072, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:01:49', 'admin-1502857330-15028597089406899', 1, 1, 'SR', NULL, NULL, NULL),
(42529, '2017-08-16 13:01:49', NULL, NULL, 12072, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:01:49', 'admin-1502857330-15028597089406899', 1, 1, 'SR', NULL, NULL, NULL),
(42530, '2017-08-16 12:24:54', NULL, NULL, 12070, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.20, 0.0000, 0.0000, 15.20, 1, '27', 1, '1502859986', 'admin', '2017-08-16 12:24:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42531, '2017-08-16 12:25:31', NULL, NULL, 12070, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 12:25:31', 'admin-1502857330-1502857531115461', 1, 1, 'SR', NULL, NULL, NULL),
(42532, '2017-08-16 12:25:31', NULL, NULL, 12070, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 12:25:31', 'admin-1502857330-1502857531115461', 1, 0, '', NULL, NULL, NULL),
(42533, '2017-08-16 12:25:31', NULL, NULL, 12070, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 12:25:31', 'admin-1502857330-1502857531115461', 1, 0, '', NULL, NULL, NULL),
(42534, '2017-08-16 12:25:31', NULL, NULL, 12070, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 12:25:31', 'admin-1502857330-1502857531115461', 1, 0, '', NULL, NULL, NULL),
(42535, '2017-08-16 12:25:31', NULL, NULL, 12070, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 12:25:31', 'admin-1502857330-1502857531115461', 1, 0, '', NULL, NULL, NULL),
(42536, '2017-08-16 13:06:20', NULL, NULL, 12073, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:06:20', 'admin-1502857330-15028599806235193', 1, 0, '', NULL, NULL, NULL),
(42537, '2017-08-16 13:05:54', NULL, NULL, 12073, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:05:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42538, '2017-08-16 13:01:49', NULL, NULL, 12072, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:01:49', 'admin-1502857330-15028597089406899', 1, 0, '', NULL, NULL, NULL),
(42539, '2017-08-16 13:01:49', NULL, NULL, 12072, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:01:49', 'admin-1502857330-15028597089406899', 1, 1, 'SR', NULL, NULL, NULL),
(42540, '2017-08-16 12:54:16', NULL, NULL, 12071, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 12:54:16', 'admin-1502857330-15028592564652950', 1, 0, '', NULL, NULL, NULL),
(42541, '2017-08-16 16:21:21', NULL, NULL, 12084, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 16:21:21', 'admin-1502859986-15028716814309075', 1, 1, 'SR', NULL, NULL, NULL),
(42542, '2017-08-16 13:01:11', NULL, NULL, 12072, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1502859986', 'admin', '2017-08-16 13:01:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42543, '2017-08-16 12:35:58', NULL, NULL, 12070, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 12:35:58', 'admin-1502857330-15028581585633689', 1, 1, 'SR', NULL, NULL, NULL),
(42544, '2017-08-16 12:34:22', NULL, NULL, 12070, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 12:34:22', 'admin-1502857330-15028580621461852', 1, 0, '', NULL, NULL, NULL),
(42545, '2017-08-16 12:32:47', NULL, NULL, 12070, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 12:32:47', 'admin-1502857330-15028579673177070', 1, 1, 'SR', NULL, NULL, NULL),
(42546, '2017-08-16 12:31:13', NULL, NULL, 12071, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 12:31:13', 'admin-1502857330-1502857872826671', 1, 0, '', NULL, NULL, NULL),
(42547, '2017-08-16 12:31:13', NULL, NULL, 12071, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 12:31:13', 'admin-1502857330-1502857872826671', 1, 1, 'SR', NULL, NULL, NULL),
(42548, '2017-08-16 12:30:43', NULL, NULL, 12071, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1502859986', 'admin', '2017-08-16 12:30:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42549, '2017-08-16 12:30:56', NULL, NULL, 12071, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 12:30:56', 'admin-1502857330-15028578561095051', 1, 1, 'SR', NULL, NULL, NULL),
(42550, '2017-08-16 11:54:17', NULL, NULL, 12069, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 11:54:17', 'admin-1502845141-15028556574352558', 1, 0, '', NULL, NULL, NULL),
(42551, '2017-08-16 11:53:19', NULL, NULL, 12069, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 11:53:20', 'admin-1502845141-15028555998203142', 1, 0, '', NULL, NULL, NULL),
(42552, '2017-08-16 11:26:41', NULL, NULL, 12068, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 11:26:41', 'admin-1502845141-15028540017588550', 1, 1, 'SR', NULL, NULL, NULL),
(42553, '2017-08-16 11:01:31', NULL, NULL, 12067, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 11:01:31', 'admin-1502845141-1502852490816394', 1, 1, 'SR', NULL, NULL, NULL),
(42554, '2017-08-16 11:01:31', NULL, NULL, 12067, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 11:01:31', 'admin-1502845141-1502852490816394', 1, 1, 'SR', NULL, NULL, NULL),
(42555, '2017-08-16 11:26:20', NULL, NULL, 12068, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1502859986', 'admin', '2017-08-16 11:26:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42556, '2017-08-16 11:26:41', NULL, NULL, 12068, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 11:26:41', 'admin-1502845141-15028540017588550', 1, 0, '', NULL, NULL, NULL),
(42557, '2017-08-16 11:26:41', NULL, NULL, 12068, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 11:26:41', 'admin-1502845141-15028540017588550', 1, 0, '', NULL, NULL, NULL),
(42558, '2017-08-16 11:01:25', NULL, NULL, 12067, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1502859986', 'admin', '2017-08-16 11:01:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42559, '2017-08-16 10:54:52', NULL, NULL, 12066, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1502859986', 'admin', '2017-08-16 10:54:52', 'admin-1502845141-15028520919239977', 1, 0, '', 1, NULL, '10.0'),
(42560, '2017-08-16 10:45:49', NULL, NULL, 12065, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 10:45:49', 'admin-1502845141-15028515494876073', 1, 0, '', NULL, NULL, NULL),
(42561, '2017-08-16 10:45:56', NULL, NULL, 12065, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 10:45:56', 'admin-1502845141-1502851556105761', 1, 1, 'SR', NULL, NULL, NULL),
(42562, '2017-08-16 10:45:49', NULL, NULL, 12065, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 10:45:49', 'admin-1502845141-15028515494876073', 1, 0, '', NULL, NULL, NULL),
(42563, '2017-08-16 09:59:04', NULL, NULL, 12062, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 09:59:04', 'admin-1502845141-15028487438579242', 1, 1, 'SR', NULL, NULL, NULL),
(42564, '2017-08-16 09:59:04', NULL, NULL, 12062, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502859986', 'admin', '2017-08-16 09:59:04', 'admin-1502845141-15028487438579242', 1, 1, 'SR', NULL, NULL, NULL),
(42565, '2017-08-16 09:58:48', NULL, NULL, 12062, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1502859986', 'admin', '2017-08-16 09:58:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42566, '2017-08-17 16:45:06', NULL, NULL, 12114, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1502948728', 'admin', '2017-08-17 16:45:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42567, '2017-08-17 16:45:11', NULL, NULL, 12114, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 16:45:11', 'admin-1502948728-15029595109979325', 1, 0, '', NULL, NULL, NULL),
(42568, '2017-08-17 16:22:30', NULL, NULL, 12113, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 16:22:30', 'admin-1502948728-15029581500239456', 1, 0, '', NULL, NULL, NULL),
(42569, '2017-08-17 16:22:26', NULL, NULL, 12113, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1502948728', 'admin', '2017-08-17 16:22:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42570, '2017-08-17 15:10:20', NULL, NULL, 12110, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 15:10:20', 'admin-1502948728-15029538202799193', 1, 0, '', NULL, NULL, NULL),
(42571, '2017-08-17 15:42:03', NULL, NULL, 12112, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 15:42:03', 'admin-1502948728-1502955723004333', 1, 1, 'SR', NULL, NULL, NULL),
(42572, '2017-08-17 15:45:32', NULL, NULL, 12112, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 15:45:32', 'admin-1502948728-15029559323986285', 1, 1, 'SR', NULL, NULL, NULL),
(42573, '2017-08-17 14:13:56', NULL, NULL, 12107, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 14:13:56', 'admin-1502948728-1502950436153789', 1, 0, '', NULL, NULL, '10.0'),
(42574, '2017-08-17 14:13:56', NULL, NULL, 12107, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 14:13:56', 'admin-1502948728-1502950436153789', 1, 0, '', NULL, NULL, '10.0'),
(42575, '2017-08-17 12:52:10', NULL, NULL, 12100, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 12:52:10', 'admin-1502939025-15029455301865631', 1, 1, 'SR', NULL, NULL, '10.0'),
(42576, '2017-08-17 12:53:26', NULL, NULL, 12100, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 12:53:26', 'admin-1502939025-15029456060264257', 1, 0, '', NULL, NULL, '10.0'),
(42577, '2017-08-17 13:00:03', NULL, NULL, 12100, 0, 14, '14', 'Iced Cappucino ', 'add syrup', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 13:00:03', 'admin-1502939025-15029460035005286', 1, 1, 'SR', NULL, NULL, '10.0');
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(42578, '2017-08-17 13:20:29', NULL, NULL, 12101, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 13:20:29', 'admin-1502939025-15029472290784198', 1, 1, 'SR', 1, NULL, NULL),
(42579, '2017-08-17 13:44:24', NULL, NULL, 12102, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1502948728', 'admin', '2017-08-17 13:44:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42580, '2017-08-17 15:17:10', NULL, NULL, 12111, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1502948728', 'admin', '2017-08-17 15:17:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42581, '2017-08-17 15:09:25', NULL, NULL, 12110, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1502948728', 'admin', '2017-08-17 15:09:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42582, '2017-08-17 15:10:20', NULL, NULL, 12110, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 15:10:20', 'admin-1502948728-15029538202799193', 1, 0, '', NULL, NULL, NULL),
(42583, '2017-08-17 15:34:57', NULL, NULL, 12111, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 15:34:57', 'admin-1502948728-15029552971852037', 1, 0, '', NULL, NULL, NULL),
(42584, '2017-08-17 15:17:19', NULL, NULL, 12111, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 15:17:19', 'admin-1502948728-1502954239218154', 1, 1, 'SR', NULL, NULL, NULL),
(42585, '2017-08-17 10:16:30', NULL, NULL, 12089, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1502948728', 'admin', '2017-08-17 10:16:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42586, '2017-08-17 10:16:35', NULL, NULL, 12089, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 10:16:35', 'admin-1502931780-15029361955666584', 1, 0, '', NULL, NULL, NULL),
(42587, '2017-08-17 13:44:53', NULL, NULL, 12102, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 13:44:53', 'admin-1502939025-15029486928366471', 1, 0, '', NULL, NULL, NULL),
(42588, '2017-08-17 15:41:55', NULL, NULL, 12112, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1502948728', 'admin', '2017-08-17 15:41:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42589, '2017-08-17 15:10:20', NULL, NULL, 12110, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 15:10:20', 'admin-1502948728-15029538202799193', 1, 0, '', NULL, NULL, NULL),
(42590, '2017-08-17 14:13:56', NULL, NULL, 12107, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 14:13:56', 'admin-1502948728-1502950436153789', 1, 0, '', NULL, NULL, '10.0'),
(42591, '2017-08-17 14:32:23', NULL, NULL, 12108, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 14:32:23', 'admin-1502948728-15029515435665120', 1, 0, '', NULL, NULL, NULL),
(42592, '2017-08-17 14:32:23', NULL, NULL, 12108, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 14:32:23', 'admin-1502948728-15029515435665120', 1, 0, '', NULL, NULL, NULL),
(42593, '2017-08-17 14:32:23', NULL, NULL, 12108, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 14:32:23', 'admin-1502948728-15029515435665120', 1, 1, 'SR', NULL, NULL, NULL),
(42594, '2017-08-17 14:32:23', NULL, NULL, 12108, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 14:32:23', 'admin-1502948728-15029515435665120', 1, 1, 'SR', NULL, NULL, NULL),
(42595, '2017-08-17 14:32:58', NULL, NULL, 12109, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1502948728', 'admin', '2017-08-17 14:32:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42596, '2017-08-17 14:33:03', NULL, NULL, 12109, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 14:33:03', 'admin-1502948728-15029515837232515', 1, 0, '', NULL, NULL, NULL),
(42597, '2017-08-17 14:41:27', NULL, NULL, 12097, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 14:41:27', 'admin-1502948728-15029520872078866', 1, 0, '', NULL, NULL, NULL),
(42598, '2017-08-17 14:02:48', NULL, NULL, 12105, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 14:02:48', 'admin-1502948728-1502949768092412', 1, 1, 'SR', NULL, NULL, NULL),
(42599, '2017-08-17 14:02:48', NULL, NULL, 12105, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 14:02:48', 'admin-1502948728-1502949768092412', 1, 0, '', NULL, NULL, NULL),
(42600, '2017-08-17 14:03:04', NULL, NULL, 12106, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 14:03:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42601, '2017-08-17 14:03:31', NULL, NULL, 12106, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 14:03:31', 'admin-1502948728-15029498114858230', 1, 1, 'SR', NULL, NULL, NULL),
(42602, '2017-08-17 14:13:35', NULL, NULL, 12107, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1502948728', 'admin', '2017-08-17 14:13:35', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(42603, '2017-08-17 12:24:40', NULL, NULL, 12099, 0, 153, '87', 'Wake Me Up!', 'extra potato,no salad', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 12:24:40', 'admin-1502939025-15029438800564425', 1, 0, '', NULL, NULL, NULL),
(42604, '2017-08-17 14:31:40', NULL, NULL, 12108, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1502948728', 'admin', '2017-08-17 14:31:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42605, '2017-08-17 14:13:56', NULL, NULL, 12107, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 14:13:56', 'admin-1502948728-1502950436153789', 1, 1, 'SR', NULL, NULL, '10.0'),
(42606, '2017-08-17 12:10:06', NULL, NULL, 12097, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1502948728', 'admin', '2017-08-17 12:10:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42607, '2017-08-17 12:10:11', NULL, NULL, 12097, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 12:10:11', 'admin-1502939025-1502943010787449', 1, 0, '', NULL, NULL, NULL),
(42608, '2017-08-17 12:17:01', NULL, NULL, 12098, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 12:17:01', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(42609, '2017-08-17 12:17:07', NULL, NULL, 12098, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 12:17:07', 'admin-1502939025-1502943426982901', 1, 1, 'SR', NULL, NULL, '10.0'),
(42610, '2017-08-17 16:51:07', NULL, NULL, 12115, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1502948728', 'admin', '2017-08-17 16:51:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42611, '2017-08-17 16:51:09', NULL, NULL, 12115, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 16:51:09', 'admin-1502948728-15029598696154554', 1, 1, 'SR', NULL, NULL, NULL),
(42612, '2017-08-17 16:22:39', NULL, NULL, 12113, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 16:22:39', 'admin-1502948728-15029581592977284', 1, 1, 'SR', NULL, NULL, NULL),
(42613, '2017-08-17 16:22:39', NULL, NULL, 12113, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 16:22:39', 'admin-1502948728-15029581592977284', 1, 0, '', NULL, NULL, NULL),
(42614, '2017-08-17 15:42:03', NULL, NULL, 12112, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 15:42:03', 'admin-1502948728-1502955723004333', 1, 0, '', NULL, NULL, NULL),
(42615, '2017-08-17 14:13:56', NULL, NULL, 12107, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 14:13:56', 'admin-1502948728-1502950436153789', 1, 0, '', NULL, NULL, '10.0'),
(42616, '2017-08-17 14:13:56', NULL, NULL, 12107, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 14:13:56', 'admin-1502948728-1502950436153789', 1, 0, '', NULL, NULL, '10.0'),
(42617, '2017-08-17 12:24:47', NULL, NULL, 12099, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 12:24:47', 'admin-1502939025-15029438870198642', 1, 1, 'SR', NULL, NULL, NULL),
(42618, '2017-08-17 12:25:41', NULL, NULL, 12097, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 12:25:41', 'admin-1502939025-1502943941206476', 1, 0, '', NULL, NULL, NULL),
(42619, '2017-08-17 12:52:04', NULL, NULL, 12100, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1502948728', 'admin', '2017-08-17 12:52:04', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(42620, '2017-08-17 12:52:10', NULL, NULL, 12100, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 12:52:10', 'admin-1502939025-15029455301865631', 1, 1, 'SR', NULL, NULL, '10.0'),
(42621, '2017-08-17 10:28:41', NULL, NULL, 12090, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 10:28:41', 'admin-1502931780-15029369210043371', 1, 1, 'SR', NULL, NULL, NULL),
(42622, '2017-08-17 10:28:41', NULL, NULL, 12090, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 10:28:41', 'admin-1502931780-15029369210043371', 1, 1, 'SR', NULL, NULL, NULL),
(42623, '2017-08-17 10:36:43', NULL, NULL, 12091, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1502948728', 'admin', '2017-08-17 10:36:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42624, '2017-08-17 10:36:58', NULL, NULL, 12091, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 10:36:58', 'admin-1502931780-15029374183588346', 1, 1, 'SR', NULL, NULL, NULL),
(42625, '2017-08-17 11:03:39', NULL, NULL, 12093, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 11:03:39', 'admin-1502931780-15029390190671795', 1, 0, '', NULL, NULL, '10.0'),
(42626, '2017-08-17 11:03:39', NULL, NULL, 12093, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 11:03:39', 'admin-1502931780-15029390190671795', 1, 0, '', NULL, NULL, '10.0'),
(42627, '2017-08-17 11:11:34', NULL, NULL, 12094, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1502948728', 'admin', '2017-08-17 11:11:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42628, '2017-08-17 11:11:43', NULL, NULL, 12094, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 11:11:43', 'admin-1502939025-15029395033493561', 1, 0, '', NULL, NULL, NULL),
(42629, '2017-08-17 11:29:44', NULL, NULL, 12095, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 11:29:44', 'admin-1502939025-15029405838528127', 1, 0, '', 1, NULL, '10.0'),
(42630, '2017-08-17 14:00:06', NULL, NULL, 12100, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 14:00:06', 'admin-1502948728-15029496060446766', 1, 1, 'SR', NULL, NULL, '10.0'),
(42631, '2017-08-17 13:53:23', NULL, NULL, 12104, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 13:53:23', 'admin-1502948728-15029492029315994', 1, 1, 'SR', NULL, NULL, NULL),
(42632, '2017-08-17 13:53:23', NULL, NULL, 12104, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 13:53:23', 'admin-1502948728-15029492029315994', 1, 0, '', NULL, NULL, NULL),
(42633, '2017-08-17 14:02:34', NULL, NULL, 12105, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1502948728', 'admin', '2017-08-17 14:02:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42634, '2017-08-17 13:45:12', NULL, NULL, 12103, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1502948728', 'admin', '2017-08-17 13:45:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42635, '2017-08-17 13:44:40', NULL, NULL, 12102, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 13:44:40', 'admin-1502939025-15029486804527579', 1, 0, '', NULL, NULL, NULL),
(42636, '2017-08-17 10:28:34', NULL, NULL, 12090, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1502948728', 'admin', '2017-08-17 10:28:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42637, '2017-08-17 13:45:22', NULL, NULL, 12103, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 13:45:22', 'admin-1502939025-1502948722143940', 1, 0, '', NULL, NULL, NULL),
(42638, '2017-08-17 10:16:46', NULL, NULL, 12089, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 10:16:46', 'admin-1502931780-1502936206503998', 1, 1, 'SR', NULL, NULL, NULL),
(42639, '2017-08-17 11:00:41', NULL, NULL, 12092, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1502948728', 'admin', '2017-08-17 11:00:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42640, '2017-08-17 11:01:02', NULL, NULL, 12092, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 11:01:02', 'admin-1502931780-15029388617934977', 1, 0, '', NULL, NULL, NULL),
(42641, '2017-08-17 11:01:02', NULL, NULL, 12092, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 11:01:02', 'admin-1502931780-15029388617934977', 1, 0, '', NULL, NULL, NULL),
(42642, '2017-08-17 11:01:02', NULL, NULL, 12092, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 11:01:02', 'admin-1502931780-15029388617934977', 1, 1, 'SR', NULL, NULL, NULL),
(42643, '2017-08-17 11:01:02', NULL, NULL, 12092, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 11:01:02', 'admin-1502931780-15029388617934977', 1, 1, 'SR', NULL, NULL, NULL),
(42644, '2017-08-17 11:03:27', NULL, NULL, 12093, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1502948728', 'admin', '2017-08-17 11:03:27', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(42645, '2017-08-17 15:07:52', NULL, NULL, 12108, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 15:07:52', 'admin-1502948728-1502953672068471', 1, 1, 'SR', NULL, NULL, NULL),
(42646, '2017-08-17 13:44:40', NULL, NULL, 12102, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 13:44:40', 'admin-1502939025-15029486804527579', 1, 0, '', NULL, NULL, NULL),
(42647, '2017-08-17 13:44:53', NULL, NULL, 12102, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 13:44:53', 'admin-1502939025-15029486928366471', 1, 1, 'SR', NULL, NULL, NULL),
(42648, '2017-08-17 13:53:02', NULL, NULL, 12104, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1502948728', 'admin', '2017-08-17 13:53:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42649, '2017-08-17 12:24:40', NULL, NULL, 12099, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 12:24:40', 'admin-1502939025-15029438800564425', 1, 0, '', NULL, NULL, NULL),
(42650, '2017-08-17 12:24:47', NULL, NULL, 12099, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 12:24:47', 'admin-1502939025-15029438870198642', 1, 1, 'SR', NULL, NULL, NULL),
(42651, '2017-08-17 09:56:54', NULL, NULL, 12088, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 09:56:54', 'admin-1502931780-15029350142099755', 1, 1, 'SR', NULL, NULL, NULL),
(42652, '2017-08-17 13:44:40', NULL, NULL, 12102, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 13:44:40', 'admin-1502939025-15029486804527579', 1, 0, '', NULL, NULL, NULL),
(42653, '2017-08-17 12:23:02', NULL, NULL, 12099, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1502948728', 'admin', '2017-08-17 12:23:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42654, '2017-08-17 12:17:07', NULL, NULL, 12098, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 12:17:07', 'admin-1502939025-1502943426982901', 1, 1, 'SR', NULL, NULL, '10.0'),
(42655, '2017-08-17 11:43:11', NULL, NULL, 12096, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 11:43:11', 'admin-1502939025-15029413913469656', 1, 1, 'SR', NULL, NULL, NULL),
(42656, '2017-08-17 11:43:11', NULL, NULL, 12096, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 11:43:11', 'admin-1502939025-15029413913469656', 1, 1, 'SR', NULL, NULL, NULL),
(42657, '2017-08-17 11:42:46', NULL, NULL, 12096, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1502948728', 'admin', '2017-08-17 11:42:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42658, '2017-08-17 10:16:35', NULL, NULL, 12089, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 10:16:35', 'admin-1502931780-15029361955666584', 1, 0, '', NULL, NULL, NULL),
(42659, '2017-08-17 10:16:46', NULL, NULL, 12089, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 10:16:46', 'admin-1502931780-1502936206503998', 1, 1, 'SR', NULL, NULL, NULL),
(42660, '2017-08-17 09:56:36', NULL, NULL, 12088, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1502948728', 'admin', '2017-08-17 09:56:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42661, '2017-08-17 09:56:46', NULL, NULL, 12088, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 09:56:46', 'admin-1502931780-15029350063279366', 1, 0, '', NULL, NULL, NULL),
(42662, '2017-08-17 09:56:46', NULL, NULL, 12088, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 09:56:46', 'admin-1502931780-15029350063279366', 1, 0, '', NULL, NULL, NULL),
(42663, '2017-08-17 09:44:42', NULL, NULL, 12087, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 09:44:42', 'admin-1502931780-15029342825735295', 1, 1, 'SR', NULL, NULL, NULL),
(42664, '2017-08-17 09:56:54', NULL, NULL, 12088, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 09:56:54', 'admin-1502931780-15029350142099755', 1, 1, 'SR', NULL, NULL, NULL),
(42665, '2017-08-17 09:56:46', NULL, NULL, 12088, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 09:56:46', 'admin-1502931780-15029350063279366', 1, 0, '', NULL, NULL, NULL),
(42666, '2017-08-17 09:44:42', NULL, NULL, 12087, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 09:44:42', 'admin-1502931780-15029342825735295', 1, 1, 'SR', NULL, NULL, NULL),
(42667, '2017-08-17 09:29:07', NULL, NULL, 12086, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 09:29:07', 'admin-1502931780-15029333476072078', 1, 1, 'SR', NULL, NULL, NULL),
(42668, '2017-08-17 09:44:20', NULL, NULL, 12087, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1502948728', 'admin', '2017-08-17 09:44:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42669, '2017-08-17 09:44:42', NULL, NULL, 12087, 0, 207, '142', 'Cheesy Bacon Toast', 'scramble egg', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 09:44:42', 'admin-1502931780-15029342825735295', 1, 0, '', NULL, NULL, NULL),
(42670, '2017-08-17 09:44:42', NULL, NULL, 12087, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 09:44:42', 'admin-1502931780-15029342825735295', 1, 0, '', NULL, NULL, NULL),
(42671, '2017-08-17 09:29:07', NULL, NULL, 12086, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 09:29:07', 'admin-1502931780-15029333476072078', 1, 1, 'SR', NULL, NULL, NULL),
(42672, '2017-08-17 09:28:58', NULL, NULL, 12086, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 09:28:58', 'admin-1502931780-15029333381328894', 1, 0, '', NULL, NULL, NULL),
(42673, '2017-08-17 09:28:58', NULL, NULL, 12086, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1502948728', 'admin', '2017-08-17 09:28:58', 'admin-1502931780-15029333381328894', 1, 0, '', NULL, NULL, NULL),
(42674, '2017-08-17 09:28:51', NULL, NULL, 12086, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1502948728', 'admin', '2017-08-17 09:28:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42675, '2017-08-18 11:11:55', NULL, NULL, 12120, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 11:11:55', 'admin-1503016596-1503025914872824', 1, 0, '', NULL, NULL, NULL),
(42676, '2017-08-18 11:11:55', NULL, NULL, 12120, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 11:11:55', 'admin-1503016596-1503025914872824', 1, 1, 'SR', NULL, NULL, NULL),
(42677, '2017-08-18 12:46:27', NULL, NULL, 12126, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.89, 0.0000, 0.0000, 1.89, 1, '27', 1, '1503032561', 'admin', '2017-08-18 12:46:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42678, '2017-08-18 16:12:06', NULL, NULL, 12134, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1503032561', 'admin', '2017-08-18 16:12:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42679, '2017-08-18 14:56:43', NULL, NULL, 12131, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 14:56:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42680, '2017-08-18 14:57:09', NULL, NULL, 12131, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 14:57:09', 'admin-1503032561-15030394288182474', 1, 0, '', NULL, NULL, NULL),
(42681, '2017-08-18 15:42:02', NULL, NULL, 12132, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1503032561', 'admin', '2017-08-18 15:42:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42682, '2017-08-18 15:42:19', NULL, NULL, 12132, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 15:42:19', 'admin-1503032561-15030421390985481', 1, 1, 'SR', NULL, NULL, NULL),
(42683, '2017-08-18 15:42:19', NULL, NULL, 12132, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 15:42:19', 'admin-1503032561-15030421390985481', 1, 1, 'SR', NULL, NULL, NULL),
(42684, '2017-08-18 15:54:59', NULL, NULL, 12133, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 15:54:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42685, '2017-08-18 15:55:04', NULL, NULL, 12133, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 15:55:04', 'admin-1503032561-15030429038248763', 1, 1, 'SR', NULL, NULL, NULL),
(42686, '2017-08-18 00:00:00', NULL, NULL, 12134, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 14:17:48', 'admin-1503032561-15030370684063038', 1, 0, '', NULL, NULL, NULL),
(42687, '2017-08-18 16:24:54', NULL, NULL, 12135, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1503032561', 'admin', '2017-08-18 16:24:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42688, '2017-08-18 12:38:05', NULL, NULL, 12125, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 12:38:05', 'admin-1503016596-15030310855733098', 1, 1, 'SR', NULL, NULL, NULL),
(42689, '2017-08-18 12:48:13', NULL, NULL, 12127, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1503032561', 'admin', '2017-08-18 12:48:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42690, '2017-08-18 12:48:51', NULL, NULL, 12127, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 12:48:51', 'admin-1503016596-1503031731278799', 1, 1, 'SR', NULL, NULL, NULL),
(42691, '2017-08-18 12:53:27', NULL, NULL, 12128, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1503032561', 'admin', '2017-08-18 12:53:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42692, '2017-08-18 11:57:54', NULL, NULL, 12122, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 11:57:54', 'admin-1503016596-15030286744234168', 1, 0, '', NULL, NULL, NULL),
(42693, '2017-08-18 16:25:07', NULL, NULL, 12135, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 16:25:07', 'admin-1503032561-15030447073385457', 1, 1, 'SR', NULL, NULL, NULL),
(42694, '2017-08-18 14:16:05', NULL, NULL, 12130, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1503032561', 'admin', '2017-08-18 14:16:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42695, '2017-08-18 14:17:48', NULL, NULL, 12130, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 14:17:48', 'admin-1503032561-15030370684063038', 1, 1, 'SR', NULL, NULL, NULL),
(42696, '2017-08-18 13:05:29', NULL, NULL, 12129, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 13:05:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42697, '2017-08-18 13:05:45', NULL, NULL, 12129, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 13:05:45', 'admin-1503032561-15030327457645675', 1, 1, 'SR', NULL, NULL, NULL),
(42698, '2017-08-18 11:26:53', NULL, NULL, 12119, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 11:26:53', 'admin-1503016596-1503026813496274', 1, 0, '', NULL, NULL, NULL),
(42699, '2017-08-18 11:28:00', NULL, NULL, 12121, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1503032561', 'admin', '2017-08-18 11:28:00', 'admin-1503016596-15030268799471921', 1, 0, '', NULL, NULL, NULL),
(42700, '2017-08-18 12:27:04', NULL, NULL, 12124, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1503032561', 'admin', '2017-08-18 12:27:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42701, '2017-08-18 12:27:13', NULL, NULL, 12124, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 12:27:13', 'admin-1503016596-15030304332843765', 1, 0, '', NULL, NULL, NULL),
(42702, '2017-08-18 12:27:13', NULL, NULL, 12124, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 12:27:13', 'admin-1503016596-15030304332843765', 1, 1, 'SR', NULL, NULL, NULL),
(42703, '2017-08-18 12:27:13', NULL, NULL, 12124, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 12:27:13', 'admin-1503016596-15030304332843765', 1, 1, 'SR', NULL, NULL, NULL),
(42704, '2017-08-18 12:37:50', NULL, NULL, 12125, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1503032561', 'admin', '2017-08-18 12:37:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42705, '2017-08-18 16:25:07', NULL, NULL, 12135, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 16:25:07', 'admin-1503032561-15030447073385457', 1, 1, 'SR', NULL, NULL, NULL),
(42706, '2017-08-18 16:25:07', NULL, NULL, 12135, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 16:25:07', 'admin-1503032561-15030447073385457', 1, 0, '', NULL, NULL, NULL),
(42707, '2017-08-18 16:25:07', NULL, NULL, 12135, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 16:25:07', 'admin-1503032561-15030447073385457', 1, 1, 'SR', NULL, NULL, NULL),
(42708, '2017-08-18 12:38:05', NULL, NULL, 12125, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 12:38:05', 'admin-1503016596-15030310855733098', 1, 1, 'SR', NULL, NULL, NULL),
(42709, '2017-08-18 11:57:54', NULL, NULL, 12122, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 11:57:54', 'admin-1503016596-15030286744234168', 1, 0, '', NULL, NULL, NULL),
(42710, '2017-08-18 11:35:42', NULL, NULL, 12122, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.50, 0.0000, 0.0000, 11.50, 1, '27', 1, '1503032561', 'admin', '2017-08-18 11:35:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42711, '2017-08-18 10:56:17', NULL, NULL, 12119, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 10:56:17', 'admin-1503016596-15030249774637210', 1, 1, 'SR', NULL, NULL, NULL),
(42712, '2017-08-18 13:05:45', NULL, NULL, 12129, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 13:05:45', 'admin-1503032561-15030327457645675', 1, 1, 'SR', NULL, NULL, NULL),
(42713, '2017-08-18 13:05:45', NULL, NULL, 12129, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 13:05:45', 'admin-1503032561-15030327457645675', 1, 1, 'SR', NULL, NULL, NULL),
(42714, '2017-08-18 12:56:36', NULL, NULL, 12128, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 12:56:36', 'admin-1503016596-15030321961614669', 1, 1, 'SR', NULL, NULL, NULL),
(42715, '2017-08-18 12:56:36', NULL, NULL, 12128, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 12:56:36', 'admin-1503016596-15030321961614669', 1, 1, 'SR', NULL, NULL, NULL),
(42716, '2017-08-18 12:56:36', NULL, NULL, 12128, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 12:56:36', 'admin-1503016596-15030321961614669', 1, 0, '', NULL, NULL, NULL),
(42717, '2017-08-18 12:56:36', NULL, NULL, 12128, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 12:56:36', 'admin-1503016596-15030321961614669', 1, 1, 'SR', NULL, NULL, NULL),
(42718, '2017-08-18 12:46:51', NULL, NULL, 12126, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1503032561', 'admin', '2017-08-18 12:46:51', 'admin-1503016596-15030316108713634', 1, 0, '', NULL, NULL, NULL),
(42719, '2017-08-18 12:46:51', NULL, NULL, 12126, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 12:46:51', 'admin-1503016596-15030316108713634', 1, 1, 'SR', NULL, NULL, NULL),
(42720, '2017-08-18 13:05:45', NULL, NULL, 12129, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 13:05:45', 'admin-1503032561-15030327457645675', 1, 0, '', NULL, NULL, NULL),
(42721, '2017-08-18 12:38:05', NULL, NULL, 12125, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 12:38:05', 'admin-1503016596-15030310855733098', 1, 1, 'SR', NULL, NULL, NULL),
(42722, '2017-08-18 12:38:05', NULL, NULL, 12125, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 12:38:05', 'admin-1503016596-15030310855733098', 1, 0, '', NULL, NULL, NULL),
(42723, '2017-08-18 12:02:05', NULL, NULL, 12122, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 12:02:05', 'admin-1503016596-15030289250045825', 1, 1, 'SR', NULL, NULL, NULL),
(42724, '2017-08-18 10:56:17', NULL, NULL, 12119, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 10:56:17', 'admin-1503016596-15030249774637210', 1, 1, 'SR', NULL, NULL, NULL),
(42725, '2017-08-18 11:57:54', NULL, NULL, 12122, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 11:57:54', 'admin-1503016596-15030286744234168', 1, 0, '', NULL, NULL, NULL),
(42726, '2017-08-18 11:45:51', NULL, NULL, 12123, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 11:45:51', 'admin-1503016596-15030279511375950', 1, 1, 'SR', NULL, NULL, NULL),
(42727, '2017-08-18 11:57:54', NULL, NULL, 12122, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 11:57:54', 'admin-1503016596-15030286744234168', 1, 0, '', NULL, NULL, NULL),
(42728, '2017-08-18 11:46:18', NULL, NULL, 12122, 0, 182, '117', 'Open Drinks ', 'Banana', 'Cold Drinks', 'Fresh Juice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 11:46:18', 'admin-1503016596-15030279783881096', 1, 0, '', NULL, NULL, NULL),
(42729, '2017-08-18 11:46:24', NULL, NULL, 12122, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 11:46:24', 'admin-1503016596-15030279847499133', 1, 1, 'SR', NULL, NULL, NULL),
(42730, '2017-08-18 11:46:25', NULL, NULL, 12122, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 11:46:25', 'admin-1503016596-15030279847499133', 1, 1, 'SR', NULL, NULL, NULL),
(42731, '2017-08-18 11:45:51', NULL, NULL, 12123, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 11:45:51', 'admin-1503016596-15030279511375950', 1, 1, 'SR', NULL, NULL, NULL),
(42732, '2017-08-18 11:45:31', NULL, NULL, 12123, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1503032561', 'admin', '2017-08-18 11:45:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42733, '2017-08-18 11:21:13', NULL, NULL, 12121, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 11:21:13', 'admin-1503016596-15030264732496710', 1, 1, 'SR', NULL, NULL, NULL),
(42734, '2017-08-18 11:21:13', NULL, NULL, 12121, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 11:21:13', 'admin-1503016596-15030264732496710', 1, 0, '', NULL, NULL, NULL),
(42735, '2017-08-18 11:21:18', NULL, NULL, 12121, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 11:21:18', 'admin-1503016596-15030264786221677', 1, 1, 'SR', NULL, NULL, NULL),
(42736, '2017-08-18 11:21:18', NULL, NULL, 12121, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 11:21:18', 'admin-1503016596-15030264786221677', 1, 1, 'SR', NULL, NULL, NULL),
(42737, '2017-08-18 11:20:44', NULL, NULL, 12121, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.19, 0.0000, 0.0000, 4.19, 1, '27', 1, '1503032561', 'admin', '2017-08-18 11:20:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42738, '2017-08-18 11:11:46', NULL, NULL, 12120, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1503032561', 'admin', '2017-08-18 11:11:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42739, '2017-08-18 10:54:47', NULL, NULL, 12119, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 10:54:47', 'admin-1503016596-15030248872162427', 1, 0, '', NULL, NULL, NULL),
(42740, '2017-08-18 10:56:17', NULL, NULL, 12119, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 10:56:17', 'admin-1503016596-15030249774637210', 1, 0, '', NULL, NULL, NULL),
(42741, '2017-08-18 10:15:40', NULL, NULL, 12117, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 10:15:40', 'admin-1503016596-15030225407469967', 1, 1, 'SR', NULL, NULL, NULL),
(42742, '2017-08-18 10:15:40', NULL, NULL, 12117, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 10:15:40', 'admin-1503016596-15030225407469967', 1, 1, 'SR', NULL, NULL, NULL),
(42743, '2017-08-18 10:51:53', NULL, NULL, 12119, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1503032561', 'admin', '2017-08-18 10:51:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42744, '2017-08-18 09:34:53', NULL, NULL, 12116, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 09:34:53', 'admin-1503016596-15030200933652827', 1, 0, '', NULL, NULL, NULL),
(42745, '2017-08-18 10:15:37', NULL, NULL, 12117, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1503032561', 'admin', '2017-08-18 10:15:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42746, '2017-08-18 09:35:00', NULL, NULL, 12116, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503032561', 'admin', '2017-08-18 09:35:00', 'admin-1503016596-15030201001085760', 1, 1, 'SR', NULL, NULL, NULL),
(42747, '2017-08-18 09:34:42', NULL, NULL, 12116, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1503032561', 'admin', '2017-08-18 09:34:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42748, '2017-08-19 12:55:05', NULL, NULL, 12160, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:55:05', 'admin-1503116100-15031185048478067', 1, 0, '', NULL, NULL, '10.0'),
(42749, '2017-08-19 13:34:58', NULL, NULL, 12162, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1503122978', 'admin', '2017-08-19 13:34:58', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(42750, '2017-08-19 12:23:32', NULL, NULL, 12157, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:23:32', 'admin-1503116100-15031166126602969', 1, 1, 'SR', 1, NULL, '10.0'),
(42751, '2017-08-19 14:12:53', NULL, NULL, 12165, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1503122978', 'admin', '2017-08-19 14:12:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42752, '2017-08-19 16:49:29', NULL, NULL, 12170, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1503122978', 'admin', '2017-08-19 16:49:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42753, '2017-08-19 12:15:42', NULL, NULL, 12155, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:15:42', 'admin-1503116100-15031161422528789', 1, 1, 'SR', NULL, NULL, NULL),
(42754, '2017-08-19 12:49:30', NULL, NULL, 12159, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:49:30', 'admin-1503116100-1503118170212291', 1, 1, 'SR', NULL, NULL, NULL),
(42755, '2017-08-19 14:19:48', NULL, NULL, 12165, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 14:19:48', 'admin-1503122978-15031235884921561', 1, 1, 'SR', NULL, NULL, NULL),
(42756, '2017-08-19 14:27:23', NULL, NULL, 12163, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 14:27:23', 'admin-1503122978-15031240433122847', 1, 0, '', NULL, NULL, NULL),
(42757, '2017-08-19 14:22:23', NULL, NULL, 12162, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 14:22:23', 'admin-1503122978-15031237430453912', 1, 0, '', NULL, NULL, '10.0'),
(42758, '2017-08-19 12:14:52', NULL, NULL, 12155, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:14:52', 'admin-1503114043-15031160927345132', 1, 0, '', NULL, NULL, NULL),
(42759, '2017-08-19 12:55:05', NULL, NULL, 12160, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:55:05', 'admin-1503116100-15031185048478067', 1, 0, '', NULL, NULL, '10.0'),
(42760, '2017-08-19 12:55:05', NULL, NULL, 12160, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:55:05', 'admin-1503116100-15031185048478067', 1, 0, '', NULL, NULL, '10.0'),
(42761, '2017-08-19 12:55:05', NULL, NULL, 12160, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:55:05', 'admin-1503116100-15031185048478067', 1, 1, 'SR', NULL, NULL, '10.0');
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(42762, '2017-08-19 12:55:05', NULL, NULL, 12160, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:55:05', 'admin-1503116100-15031185048478067', 1, 0, '', NULL, NULL, '10.0'),
(42763, '2017-08-19 15:32:45', NULL, NULL, 12168, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 15:32:45', 'admin-1503122978-15031279648352723', 1, 0, '', NULL, NULL, NULL),
(42764, '2017-08-19 12:14:52', NULL, NULL, 12155, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:14:52', 'admin-1503114043-15031160927345132', 1, 0, '', NULL, NULL, NULL),
(42765, '2017-08-19 11:45:46', NULL, NULL, 12150, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:45:46', 'admin-1503114043-1503114346367201', 1, 1, 'SR', NULL, NULL, NULL),
(42766, '2017-08-19 11:46:19', NULL, NULL, 12151, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:46:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42767, '2017-08-19 11:45:46', NULL, NULL, 12150, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:45:46', 'admin-1503114043-1503114346367201', 1, 1, 'SR', NULL, NULL, NULL),
(42768, '2017-08-19 11:45:46', NULL, NULL, 12150, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:45:46', 'admin-1503114043-1503114346367201', 1, 0, '', NULL, NULL, NULL),
(42769, '2017-08-19 12:28:30', NULL, NULL, 12158, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:28:30', 'admin-1503116100-15031169102209823', 1, 0, '', NULL, NULL, NULL),
(42770, '2017-08-19 12:28:30', NULL, NULL, 12158, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:28:30', 'admin-1503116100-15031169102209823', 1, 0, '', NULL, NULL, NULL),
(42771, '2017-08-19 14:51:17', NULL, NULL, 12166, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 14:51:17', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(42772, '2017-08-19 14:51:26', NULL, NULL, 12166, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 14:51:26', 'admin-1503122978-15031254863209473', 1, 1, 'SR', NULL, NULL, '10.0'),
(42773, '2017-08-19 15:32:23', NULL, NULL, 12168, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1503122978', 'admin', '2017-08-19 15:32:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42774, '2017-08-19 15:32:45', NULL, NULL, 12168, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 15:32:45', 'admin-1503122978-15031279648352723', 1, 1, 'SR', NULL, NULL, NULL),
(42775, '2017-08-19 16:50:16', NULL, NULL, 12170, 0, 284, '218', 'Caramel Waffles', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 16:50:16', 'admin-1503122978-15031326164729259', 1, 0, '', NULL, NULL, NULL),
(42776, '2017-08-19 10:57:24', NULL, NULL, 12143, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:57:24', 'admin-1503107856-15031114441944261', 1, 0, '', NULL, NULL, NULL),
(42777, '2017-08-19 10:57:24', NULL, NULL, 12143, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:57:24', 'admin-1503107856-15031114441944261', 1, 0, '', NULL, NULL, NULL),
(42778, '2017-08-19 10:57:24', NULL, NULL, 12143, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:57:24', 'admin-1503107856-15031114441944261', 1, 0, '', NULL, NULL, NULL),
(42779, '2017-08-19 10:57:24', NULL, NULL, 12143, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:57:24', 'admin-1503107856-15031114441944261', 1, 0, '', NULL, NULL, NULL),
(42780, '2017-08-19 10:57:24', NULL, NULL, 12143, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:57:24', 'admin-1503107856-15031114441944261', 1, 0, '', NULL, NULL, NULL),
(42781, '2017-08-19 10:57:24', NULL, NULL, 12143, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:57:24', 'admin-1503107856-15031114441944261', 1, 1, 'SR', NULL, NULL, NULL),
(42782, '2017-08-19 13:35:51', NULL, NULL, 12162, 0, 181, '116', 'Open Food ', 'Braised Mushroom Chicken', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 13:35:51', 'admin-1503116100-15031209517503173', 1, 0, '', NULL, NULL, '10.0'),
(42783, '2017-08-19 15:17:44', NULL, NULL, 12167, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1503122978', 'admin', '2017-08-19 15:17:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42784, '2017-08-19 15:20:19', NULL, NULL, 12167, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 15:20:19', 'admin-1503122978-15031272190041229', 1, 1, 'SR', NULL, NULL, NULL),
(42785, '2017-08-19 15:19:25', NULL, NULL, 12167, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 15:19:25', 'admin-1503122978-15031271648162574', 1, 1, 'SR', NULL, NULL, NULL),
(42786, '2017-08-19 11:57:37', NULL, NULL, 12153, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:57:37', 'admin-1503114043-1503115056954993', 1, 0, '', NULL, NULL, NULL),
(42787, '2017-08-19 11:55:20', NULL, NULL, 12152, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:55:20', 'admin-1503114043-15031149202818160', 1, 1, 'SR', NULL, NULL, NULL),
(42788, '2017-08-19 12:14:52', NULL, NULL, 12155, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:14:52', 'admin-1503114043-15031160927345132', 1, 0, '', NULL, NULL, NULL),
(42789, '2017-08-19 16:49:39', NULL, NULL, 12170, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 16:49:39', 'admin-1503122978-15031325795425255', 1, 1, 'SR', NULL, NULL, NULL),
(42790, '2017-08-19 12:32:15', NULL, NULL, 12152, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:32:15', 'admin-1503116100-15031171355875312', 1, 1, 'SR', NULL, NULL, NULL),
(42791, '2017-08-19 12:32:15', NULL, NULL, 12152, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:32:15', 'admin-1503116100-15031171355875312', 1, 1, 'SR', NULL, NULL, NULL),
(42792, '2017-08-19 12:33:44', NULL, NULL, 12158, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:33:44', 'admin-1503116100-15031172240978386', 1, 1, 'SR', NULL, NULL, NULL),
(42793, '2017-08-19 12:13:14', NULL, NULL, 12155, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 20.20, 0.0000, 0.0000, 20.20, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:13:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42794, '2017-08-19 09:24:42', NULL, NULL, 12138, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:24:42', 'admin-1503104393-15031058818941544', 1, 0, '', NULL, NULL, NULL),
(42795, '2017-08-19 09:24:42', NULL, NULL, 12138, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:24:42', 'admin-1503104393-15031058818941544', 1, 0, '', NULL, NULL, NULL),
(42796, '2017-08-19 09:24:42', NULL, NULL, 12138, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:24:42', 'admin-1503104393-15031058818941544', 1, 1, 'SR', NULL, NULL, NULL),
(42797, '2017-08-19 16:50:25', NULL, NULL, 12170, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 16:50:25', 'admin-1503122978-15031326248417133', 1, 1, 'SR', NULL, NULL, NULL),
(42798, '2017-08-19 16:50:25', NULL, NULL, 12170, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 16:50:25', 'admin-1503122978-15031326248417133', 1, 1, 'SR', NULL, NULL, NULL),
(42799, '2017-08-19 10:15:17', NULL, NULL, 12142, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:15:17', 'admin-1503107856-15031089170097793', 1, 0, '', NULL, NULL, NULL),
(42800, '2017-08-19 16:50:16', NULL, NULL, 12170, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 16:50:16', 'admin-1503122978-15031326164729259', 1, 0, '', NULL, NULL, NULL),
(42801, '2017-08-19 16:50:16', NULL, NULL, 12170, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 16:50:16', 'admin-1503122978-15031326164729259', 1, 0, '', NULL, NULL, NULL),
(42802, '2017-08-19 16:49:39', NULL, NULL, 12170, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 16:49:39', 'admin-1503122978-15031325795425255', 1, 1, 'SR', NULL, NULL, NULL),
(42803, '2017-08-19 16:50:16', NULL, NULL, 12170, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 16:50:16', 'admin-1503122978-15031326164729259', 1, 0, '', NULL, NULL, NULL),
(42804, '2017-08-19 16:21:38', NULL, NULL, 12169, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 16:21:38', 'admin-1503122978-15031308983958788', 1, 0, '', 1, NULL, NULL),
(42805, '2017-08-19 12:16:01', NULL, NULL, 12156, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:16:01', 'admin-1503116100-15031161610098874', 1, 0, '', NULL, NULL, NULL),
(42806, '2017-08-19 12:16:01', NULL, NULL, 12156, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:16:01', 'admin-1503116100-15031161610098874', 1, 0, '', NULL, NULL, NULL),
(42807, '2017-08-19 12:16:01', NULL, NULL, 12156, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:16:01', 'admin-1503116100-15031161610098874', 1, 0, '', NULL, NULL, NULL),
(42808, '2017-08-19 16:21:38', NULL, NULL, 12169, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 16:21:38', 'admin-1503122978-15031308983958788', 1, 0, '', 1, NULL, NULL),
(42809, '2017-08-19 12:11:14', NULL, NULL, 12154, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:11:14', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(42810, '2017-08-19 12:11:30', NULL, NULL, 12154, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:11:30', 'admin-1503114043-1503115890354944', 1, 1, 'SR', NULL, NULL, '10.0'),
(42811, '2017-08-19 12:09:41', NULL, NULL, 12152, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:09:41', 'admin-1503114043-1503115781635597', 1, 1, 'SR', NULL, NULL, NULL),
(42812, '2017-08-19 16:21:38', NULL, NULL, 12169, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 16:21:38', 'admin-1503122978-15031308983958788', 1, 0, '', 1, NULL, NULL),
(42813, '2017-08-19 15:32:45', NULL, NULL, 12168, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 15:32:45', 'admin-1503122978-15031279648352723', 1, 0, '', NULL, NULL, NULL),
(42814, '2017-08-19 14:02:31', NULL, NULL, 12163, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 14:02:31', 'admin-1503116100-15031225517651526', 1, 1, 'SR', NULL, NULL, NULL),
(42815, '2017-08-19 14:02:31', NULL, NULL, 12163, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 14:02:32', 'admin-1503116100-15031225517651526', 1, 1, 'SR', NULL, NULL, NULL),
(42816, '2017-08-19 14:02:32', NULL, NULL, 12163, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 14:02:32', 'admin-1503116100-15031225517651526', 1, 0, '', NULL, NULL, NULL),
(42817, '2017-08-19 15:19:25', NULL, NULL, 12167, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 15:19:25', 'admin-1503122978-15031271648162574', 1, 0, '', NULL, NULL, NULL),
(42818, '2017-08-19 12:44:10', NULL, NULL, 12155, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:44:10', 'admin-1503116100-15031178507735839', 1, 1, 'SR', NULL, NULL, NULL),
(42819, '2017-08-19 13:35:51', NULL, NULL, 12162, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 13:35:51', 'admin-1503116100-15031209517503173', 1, 0, '', NULL, NULL, '10.0'),
(42820, '2017-08-19 14:12:49', NULL, NULL, 12164, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 14:12:49', 'admin-1503122978-15031231691056473', 1, 0, '', NULL, NULL, NULL),
(42821, '2017-08-19 14:12:36', NULL, NULL, 12164, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 14:12:36', 'admin-1503122978-1503123156217179', 1, 0, '', NULL, NULL, NULL),
(42822, '2017-08-19 14:12:36', NULL, NULL, 12164, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 14:12:36', 'admin-1503122978-1503123156217179', 1, 0, '', NULL, NULL, NULL),
(42823, '2017-08-19 14:01:27', NULL, NULL, 12163, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 14:01:27', 'admin-1503116100-15031224871973747', 1, 1, 'SR', NULL, NULL, NULL),
(42824, '2017-08-19 14:12:16', NULL, NULL, 12164, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1503122978', 'admin', '2017-08-19 14:12:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42825, '2017-08-19 12:28:42', NULL, NULL, 12158, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:28:42', 'admin-1503116100-15031169218597499', 1, 1, 'SR', NULL, NULL, NULL),
(42826, '2017-08-19 12:28:42', NULL, NULL, 12158, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:28:42', 'admin-1503116100-15031169218597499', 1, 1, 'SR', NULL, NULL, NULL),
(42827, '2017-08-19 13:17:14', NULL, NULL, 12160, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 13:17:14', 'admin-1503116100-15031198340214866', 1, 0, '', NULL, NULL, '10.0'),
(42828, '2017-08-19 12:17:15', NULL, NULL, 12155, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:17:15', 'admin-1503116100-15031162348831785', 1, 1, 'SR', NULL, NULL, NULL),
(42829, '2017-08-19 13:35:51', NULL, NULL, 12162, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 13:35:51', 'admin-1503116100-15031209517503173', 1, 0, '', NULL, NULL, '10.0'),
(42830, '2017-08-19 14:01:24', NULL, NULL, 12163, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1503122978', 'admin', '2017-08-19 14:01:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42831, '2017-08-19 11:57:23', NULL, NULL, 12153, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:57:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42832, '2017-08-19 11:57:37', NULL, NULL, 12153, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:57:37', 'admin-1503114043-1503115056954993', 1, 0, '', NULL, NULL, NULL),
(42833, '2017-08-19 10:50:43', NULL, NULL, 12146, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:50:43', 'admin-1503107856-15031110434197553', 1, 1, 'SR', NULL, NULL, NULL),
(42834, '2017-08-19 11:40:56', NULL, NULL, 12149, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:40:56', 'admin-1503114043-15031140559218494', 1, 1, 'SR', NULL, NULL, NULL),
(42835, '2017-08-19 11:40:39', NULL, NULL, 12149, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:40:39', 'admin-1503107856-15031140393339841', 1, 0, '', NULL, NULL, NULL),
(42836, '2017-08-19 11:40:39', NULL, NULL, 12149, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:40:39', 'admin-1503107856-15031140393339841', 1, 0, '', NULL, NULL, NULL),
(42837, '2017-08-19 13:18:02', NULL, NULL, 12161, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1503122978', 'admin', '2017-08-19 13:18:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42838, '2017-08-19 13:18:11', NULL, NULL, 12161, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 13:18:11', 'admin-1503116100-15031198909838434', 1, 1, 'SR', NULL, NULL, NULL),
(42839, '2017-08-19 13:33:27', NULL, NULL, 12155, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 13:33:27', 'admin-1503116100-15031208077643248', 1, 0, '', NULL, NULL, NULL),
(42840, '2017-08-19 12:55:05', NULL, NULL, 12160, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:55:05', 'admin-1503116100-15031185048478067', 1, 0, '', NULL, NULL, '10.0'),
(42841, '2017-08-19 12:54:53', NULL, NULL, 12160, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:54:53', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(42842, '2017-08-19 11:59:10', NULL, NULL, 12152, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:59:10', 'admin-1503114043-15031151504725382', 1, 0, '', NULL, NULL, NULL),
(42843, '2017-08-19 11:57:37', NULL, NULL, 12153, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:57:37', 'admin-1503114043-1503115056954993', 1, 0, '', NULL, NULL, NULL),
(42844, '2017-08-19 11:40:33', NULL, NULL, 12149, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:40:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42845, '2017-08-19 11:23:47', NULL, NULL, 12143, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:23:47', 'admin-1503107856-1503113027554740', 1, 0, '', NULL, NULL, NULL),
(42846, '2017-08-19 11:14:06', NULL, NULL, 12148, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:14:06', 'admin-1503107856-15031124460134616', 1, 1, 'SR', NULL, NULL, NULL),
(42847, '2017-08-19 11:14:06', NULL, NULL, 12148, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:14:06', 'admin-1503107856-15031124460134616', 1, 0, '', NULL, NULL, NULL),
(42848, '2017-08-19 10:47:36', NULL, NULL, 12145, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:47:36', 'admin-1503107856-1503110856334525', 1, 1, 'SR', NULL, NULL, NULL),
(42849, '2017-08-19 10:47:36', NULL, NULL, 12145, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:47:36', 'admin-1503107856-1503110856334525', 1, 1, 'SR', NULL, NULL, NULL),
(42850, '2017-08-19 12:49:30', NULL, NULL, 12159, 0, 231, '165', 'Hometown Fried Rice', '', 'Meals', 'Perfect Meals', 2, 15.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:49:30', 'admin-1503116100-1503118170212291', 1, 0, '', NULL, NULL, NULL),
(42851, '2017-08-19 10:15:17', NULL, NULL, 12142, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:15:17', 'admin-1503107856-15031089170097793', 1, 1, 'SR', NULL, NULL, NULL),
(42852, '2017-08-19 12:49:21', NULL, NULL, 12159, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:49:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42853, '2017-08-19 12:15:42', NULL, NULL, 12155, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:15:42', 'admin-1503116100-15031161422528789', 1, 1, 'SR', NULL, NULL, NULL),
(42854, '2017-08-19 12:15:42', NULL, NULL, 12155, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:15:42', 'admin-1503116100-15031161422528789', 1, 1, 'SR', NULL, NULL, NULL),
(42855, '2017-08-19 12:15:44', NULL, NULL, 12156, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:15:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42856, '2017-08-19 12:16:01', NULL, NULL, 12156, 0, 73, '73', 'Marmite Chicken ', 'less rice', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:16:01', 'admin-1503116100-15031161610098874', 1, 1, 'SR', NULL, NULL, NULL),
(42857, '2017-08-19 11:47:46', NULL, NULL, 12152, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:47:46', 'admin-1503114043-15031144663521353', 1, 1, 'SR', NULL, NULL, NULL),
(42858, '2017-08-19 11:47:36', NULL, NULL, 12152, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:47:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42859, '2017-08-19 12:28:20', NULL, NULL, 12158, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:28:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42860, '2017-08-19 12:28:15', NULL, NULL, 12147, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:28:15', 'admin-1503116100-15031168948735337', 1, 1, 'SR', NULL, NULL, NULL),
(42861, '2017-08-19 12:14:53', NULL, NULL, 12155, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:14:53', 'admin-1503114043-15031160927345132', 1, 0, '', NULL, NULL, NULL),
(42862, '2017-08-19 12:14:53', NULL, NULL, 12155, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:14:53', 'admin-1503114043-15031160927345132', 1, 0, '', NULL, NULL, NULL),
(42863, '2017-08-19 11:47:20', NULL, NULL, 12143, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:47:20', 'admin-1503114043-1503114440405918', 1, 1, 'SR', NULL, NULL, NULL),
(42864, '2017-08-19 11:46:57', NULL, NULL, 12151, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:46:57', 'admin-1503114043-15031144168566157', 1, 0, '', NULL, NULL, NULL),
(42865, '2017-08-19 11:47:08', NULL, NULL, 12151, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:47:08', 'admin-1503114043-15031144285091189', 1, 1, 'SR', NULL, NULL, NULL),
(42866, '2017-08-19 11:47:08', NULL, NULL, 12151, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:47:08', 'admin-1503114043-15031144285091189', 1, 1, 'SR', NULL, NULL, NULL),
(42867, '2017-08-19 11:47:08', NULL, NULL, 12151, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:47:08', 'admin-1503114043-15031144285091189', 1, 0, '', NULL, NULL, NULL),
(42868, '2017-08-19 11:46:57', NULL, NULL, 12151, 0, 153, '87', 'Wake Me Up!', 'no sosej replace bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:46:57', 'admin-1503114043-15031144168566157', 1, 0, '', NULL, NULL, NULL),
(42869, '2017-08-19 11:46:57', NULL, NULL, 12151, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:46:57', 'admin-1503114043-15031144168566157', 1, 0, '', NULL, NULL, NULL),
(42870, '2017-08-19 12:15:42', NULL, NULL, 12155, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:15:42', 'admin-1503116100-15031161422528789', 1, 1, 'SR', NULL, NULL, NULL),
(42871, '2017-08-19 12:15:42', NULL, NULL, 12155, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:15:42', 'admin-1503116100-15031161422528789', 1, 1, 'SR', NULL, NULL, NULL),
(42872, '2017-08-19 12:11:30', NULL, NULL, 12154, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:11:30', 'admin-1503114043-1503115890354944', 1, 0, '', NULL, NULL, '10.0'),
(42873, '2017-08-19 11:14:06', NULL, NULL, 12148, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:14:06', 'admin-1503107856-15031124460134616', 1, 0, '', NULL, NULL, NULL),
(42874, '2017-08-19 11:13:54', NULL, NULL, 12148, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:13:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42875, '2017-08-19 11:07:46', NULL, NULL, 12147, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:07:46', 'admin-1503107856-15031120658282589', 1, 0, '', NULL, NULL, NULL),
(42876, '2017-08-19 10:57:24', NULL, NULL, 12143, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:57:24', 'admin-1503107856-15031114441944261', 1, 1, 'SR', NULL, NULL, NULL),
(42877, '2017-08-19 11:07:34', NULL, NULL, 12147, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:07:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42878, '2017-08-19 10:47:23', NULL, NULL, 12145, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:47:23', 'admin-1503107856-15031108432391350', 1, 0, '', NULL, NULL, NULL),
(42879, '2017-08-19 10:47:23', NULL, NULL, 12145, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:47:23', 'admin-1503107856-15031108432391350', 1, 0, '', NULL, NULL, NULL),
(42880, '2017-08-19 09:57:27', NULL, NULL, 12141, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:57:27', 'admin-1503104393-1503107847478135', 1, 1, 'SR', NULL, NULL, NULL),
(42881, '2017-08-19 10:50:43', NULL, NULL, 12146, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:50:43', 'admin-1503107856-15031110434197553', 1, 1, 'SR', NULL, NULL, NULL),
(42882, '2017-08-19 09:30:45', NULL, NULL, 12139, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:30:45', 'admin-1503104393-15031062456428394', 1, 0, '', NULL, NULL, NULL),
(42883, '2017-08-19 09:31:03', NULL, NULL, 12139, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:31:03', 'admin-1503104393-15031062632392615', 1, 1, 'SR', NULL, NULL, NULL),
(42884, '2017-08-19 09:36:59', NULL, NULL, 12138, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:36:59', 'admin-1503104393-1503106618955587', 1, 1, 'SR', NULL, NULL, NULL),
(42885, '2017-08-19 09:38:17', NULL, NULL, 12140, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:38:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42886, '2017-08-19 09:39:11', NULL, NULL, 12140, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:39:11', 'admin-1503104393-15031067514709096', 1, 0, '', NULL, NULL, NULL),
(42887, '2017-08-19 09:39:11', NULL, NULL, 12140, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:39:11', 'admin-1503104393-15031067514709096', 1, 1, 'SR', NULL, NULL, NULL),
(42888, '2017-08-19 09:39:11', NULL, NULL, 12140, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:39:11', 'admin-1503104393-15031067514709096', 1, 1, 'SR', NULL, NULL, NULL),
(42889, '2017-08-19 10:47:36', NULL, NULL, 12145, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:47:36', 'admin-1503107856-1503110856334525', 1, 0, '', NULL, NULL, NULL),
(42890, '2017-08-19 10:50:43', NULL, NULL, 12146, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:50:43', 'admin-1503107856-15031110434197553', 1, 0, '', NULL, NULL, NULL),
(42891, '2017-08-19 10:50:28', NULL, NULL, 12146, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:50:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42892, '2017-08-19 10:50:43', NULL, NULL, 12146, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:50:43', 'admin-1503107856-15031110434197553', 1, 0, '', NULL, NULL, NULL),
(42893, '2017-08-19 10:47:23', NULL, NULL, 12145, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:47:23', 'admin-1503107856-15031108432391350', 1, 0, '', NULL, NULL, NULL),
(42894, '2017-08-19 11:40:56', NULL, NULL, 12149, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:40:56', 'admin-1503114043-15031140559218494', 1, 1, 'SR', NULL, NULL, NULL),
(42895, '2017-08-19 10:19:36', NULL, NULL, 12143, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.40, 0.0000, 0.0000, 15.40, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:19:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42896, '2017-08-19 10:19:45', NULL, NULL, 12143, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:19:45', 'admin-1503107856-15031091849941670', 1, 1, 'SR', NULL, NULL, NULL),
(42897, '2017-08-19 10:19:45', NULL, NULL, 12143, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:19:45', 'admin-1503107856-15031091849941670', 1, 1, 'SR', NULL, NULL, NULL),
(42898, '2017-08-19 10:42:10', NULL, NULL, 12144, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:42:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42899, '2017-08-19 10:43:03', NULL, NULL, 12144, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:43:03', 'admin-1503107856-15031105832076122', 1, 0, '', NULL, NULL, NULL),
(42900, '2017-08-19 10:43:03', NULL, NULL, 12144, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:43:03', 'admin-1503107856-15031105832076122', 1, 0, '', NULL, NULL, NULL),
(42901, '2017-08-19 10:43:03', NULL, NULL, 12144, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:43:03', 'admin-1503107856-15031105832076122', 1, 0, '', NULL, NULL, NULL),
(42902, '2017-08-19 11:46:57', NULL, NULL, 12151, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:46:57', 'admin-1503114043-15031144168566157', 1, 1, 'SR', NULL, NULL, NULL),
(42903, '2017-08-19 10:47:03', NULL, NULL, 12145, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.80, 0.0000, 0.0000, 10.80, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:47:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42904, '2017-08-19 10:47:23', NULL, NULL, 12145, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:47:23', 'admin-1503107856-15031108432391350', 1, 0, '', NULL, NULL, NULL),
(42905, '2017-08-19 10:43:03', NULL, NULL, 12144, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:43:03', 'admin-1503107856-15031105832076122', 1, 1, 'SR', NULL, NULL, NULL),
(42906, '2017-08-19 10:17:10', NULL, NULL, 12141, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:17:10', 'admin-1503107856-15031090297478389', 1, 0, '', NULL, NULL, NULL),
(42907, '2017-08-19 10:13:29', NULL, NULL, 12142, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:13:29', 'admin-1503107856-15031088094327732', 1, 0, '', NULL, NULL, NULL),
(42908, '2017-08-19 10:13:29', NULL, NULL, 12142, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:13:29', 'admin-1503107856-15031088094327732', 1, 0, '', NULL, NULL, NULL),
(42909, '2017-08-19 12:28:30', NULL, NULL, 12158, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:28:30', 'admin-1503116100-15031169102209823', 1, 0, '', NULL, NULL, NULL),
(42910, '2017-08-19 10:13:18', NULL, NULL, 12142, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1503122978', 'admin', '2017-08-19 10:13:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42911, '2017-08-19 09:57:27', NULL, NULL, 12141, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:57:27', 'admin-1503104393-1503107847478135', 1, 0, '', NULL, NULL, NULL),
(42912, '2017-08-19 09:24:42', NULL, NULL, 12138, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:24:42', 'admin-1503104393-15031058818941544', 1, 0, '', NULL, NULL, NULL),
(42913, '2017-08-19 11:44:34', NULL, NULL, 12150, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 11:44:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42914, '2017-08-19 12:14:52', NULL, NULL, 12155, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 12:14:52', 'admin-1503114043-15031160927345132', 1, 0, '', NULL, NULL, NULL),
(42915, '2017-08-19 09:57:27', NULL, NULL, 12141, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:57:27', 'admin-1503104393-1503107847478135', 1, 1, 'SR', NULL, NULL, NULL),
(42916, '2017-08-19 09:57:27', NULL, NULL, 12141, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:57:27', 'admin-1503104393-1503107847478135', 1, 1, 'SR', NULL, NULL, NULL),
(42917, '2017-08-19 09:57:27', NULL, NULL, 12141, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:57:27', 'admin-1503104393-1503107847478135', 1, 0, '', NULL, NULL, NULL),
(42918, '2017-08-19 09:57:27', NULL, NULL, 12141, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:57:27', 'admin-1503104393-1503107847478135', 1, 0, '', NULL, NULL, NULL),
(42919, '2017-08-19 09:49:37', NULL, NULL, 12139, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:49:37', 'admin-1503104393-15031073772318823', 1, 1, 'SR', NULL, NULL, NULL),
(42920, '2017-08-19 09:57:09', NULL, NULL, 12141, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.80, 0.0000, 0.0000, 10.80, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:57:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42921, '2017-08-19 09:24:42', NULL, NULL, 12138, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:24:42', 'admin-1503104393-15031058818941544', 1, 0, '', NULL, NULL, NULL),
(42922, '2017-08-19 09:28:58', NULL, NULL, 12139, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:28:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42923, '2017-08-19 09:29:16', NULL, NULL, 12139, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:29:16', 'admin-1503104393-15031061565915694', 1, 1, 'SR', NULL, NULL, NULL),
(42924, '2017-08-19 09:30:19', NULL, NULL, 12139, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:30:19', 'admin-1503104393-15031062188545857', 1, 0, '', NULL, NULL, NULL),
(42925, '2017-08-19 09:30:19', NULL, NULL, 12139, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:30:19', 'admin-1503104393-15031062188545857', 1, 1, 'SR', NULL, NULL, NULL),
(42926, '2017-08-19 09:30:45', NULL, NULL, 12139, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:30:45', 'admin-1503104393-15031062456428394', 1, 0, '', NULL, NULL, NULL),
(42927, '2017-08-19 09:24:10', NULL, NULL, 12138, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:24:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42928, '2017-08-19 09:17:57', NULL, NULL, 12137, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:17:58', 'admin-1503104393-15031054777766398', 1, 0, '', NULL, NULL, NULL),
(42929, '2017-08-19 09:17:04', NULL, NULL, 12136, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:17:04', 'admin-1503104393-15031054239211382', 1, 1, 'SR', NULL, NULL, NULL),
(42930, '2017-08-19 09:17:44', NULL, NULL, 12137, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:17:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42931, '2017-08-19 09:17:57', NULL, NULL, 12137, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:17:57', 'admin-1503104393-15031054777766398', 1, 0, '', NULL, NULL, NULL),
(42932, '2017-08-19 09:17:04', NULL, NULL, 12136, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:17:04', 'admin-1503104393-15031054239211382', 1, 0, '', NULL, NULL, NULL),
(42933, '2017-08-19 09:17:04', NULL, NULL, 12136, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:17:04', 'admin-1503104393-15031054239211382', 1, 1, 'SR', NULL, NULL, NULL),
(42934, '2017-08-19 09:17:04', NULL, NULL, 12136, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:17:04', 'admin-1503104393-15031054239211382', 1, 0, '', NULL, NULL, NULL),
(42935, '2017-08-19 09:17:04', NULL, NULL, 12136, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:17:04', 'admin-1503104393-15031054239211382', 1, 0, '', NULL, NULL, NULL),
(42936, '2017-08-19 09:16:40', NULL, NULL, 12136, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1503122978', 'admin', '2017-08-19 09:16:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42937, '2017-08-20 16:30:44', NULL, NULL, 12224, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 16:30:44', 'admin-1503217811-15032178439401731', 1, 1, 'SR', NULL, NULL, NULL),
(42938, '2017-08-20 16:30:44', NULL, NULL, 12224, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 16:30:44', 'admin-1503217811-15032178439401731', 1, 1, 'SR', NULL, NULL, NULL),
(42939, '2017-08-20 16:30:44', NULL, NULL, 12224, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 16:30:44', 'admin-1503217811-15032178439401731', 1, 0, '', NULL, NULL, NULL),
(42940, '2017-08-20 16:30:44', NULL, NULL, 12224, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 16:30:44', 'admin-1503217811-15032178439401731', 1, 0, '', NULL, NULL, NULL),
(42941, '2017-08-20 16:46:09', NULL, NULL, 12212, 0, 182, '117', 'Open Drinks ', 'Coffee beans', 'Cold Drinks', 'Fresh Juice', 1, 38.00, 38.0000, 0.0000, 38.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 16:46:09', 'admin-1503217811-15032187691466584', 1, 0, '', NULL, NULL, '10.0'),
(42942, '2017-08-20 16:52:34', NULL, NULL, 12224, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 16:52:34', 'admin-1503217811-15032191539127138', 1, 0, '', NULL, NULL, NULL),
(42943, '2017-08-20 16:52:34', NULL, NULL, 12224, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 16:52:34', 'admin-1503217811-15032191539127138', 1, 1, 'SR', NULL, NULL, NULL),
(42944, '2017-08-20 16:52:34', NULL, NULL, 12224, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 16:52:34', 'admin-1503217811-15032191539127138', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(42945, '2017-08-20 16:13:52', NULL, NULL, 12223, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 16:13:52', 'admin-1503211146-15032168320966457', 1, 1, 'SR', NULL, NULL, NULL),
(42946, '2017-08-20 16:13:52', NULL, NULL, 12223, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 16:13:52', 'admin-1503211146-15032168320966457', 1, 1, 'SR', NULL, NULL, NULL),
(42947, '2017-08-20 15:45:28', NULL, NULL, 12220, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:45:28', 'admin-1503211146-15032151284144079', 1, 1, 'SR', NULL, NULL, NULL),
(42948, '2017-08-20 15:45:52', NULL, NULL, 12220, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:45:52', 'admin-1503211146-15032151524278534', 1, 1, 'SR', NULL, NULL, NULL),
(42949, '2017-08-20 15:45:52', NULL, NULL, 12220, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:45:52', 'admin-1503211146-15032151524278534', 1, 1, 'SR', NULL, NULL, NULL),
(42950, '2017-08-20 15:45:52', NULL, NULL, 12220, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:45:52', 'admin-1503211146-15032151524278534', 1, 1, 'SR', NULL, NULL, NULL),
(42951, '2017-08-20 15:49:21', NULL, NULL, 12219, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:49:21', 'admin-1503211146-15032153617293963', 1, 0, '', NULL, NULL, NULL),
(42952, '2017-08-20 15:49:53', NULL, NULL, 12221, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:49:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42953, '2017-08-20 15:49:58', NULL, NULL, 12221, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:49:58', 'admin-1503211146-1503215397885197', 1, 0, '', NULL, NULL, NULL),
(42954, '2017-08-20 13:57:55', NULL, NULL, 12207, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:57:55', 'admin-1503207695-15032086749277145', 1, 0, '', NULL, NULL, NULL),
(42955, '2017-08-20 13:57:55', NULL, NULL, 12207, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:57:55', 'admin-1503207695-15032086749277145', 1, 0, '', NULL, NULL, NULL),
(42956, '2017-08-20 13:57:55', NULL, NULL, 12207, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:57:55', 'admin-1503207695-15032086749277145', 1, 0, '', NULL, NULL, NULL),
(42957, '2017-08-20 13:57:55', NULL, NULL, 12207, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:57:55', 'admin-1503207695-15032086749277145', 1, 1, 'SR', NULL, NULL, NULL),
(42958, '2017-08-20 13:57:55', NULL, NULL, 12207, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:57:55', 'admin-1503207695-15032086749277145', 1, 0, '', NULL, NULL, NULL),
(42959, '2017-08-20 11:34:30', NULL, NULL, 12194, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 11:34:30', 'admin-1503197194-1503200070346499', 1, 0, '', NULL, NULL, NULL),
(42960, '2017-08-20 15:45:15', NULL, NULL, 12220, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:45:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42961, '2017-08-20 09:32:04', NULL, NULL, 12176, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:32:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42962, '2017-08-20 15:18:30', NULL, NULL, 12215, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:18:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42963, '2017-08-20 14:34:00', NULL, NULL, 12212, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:34:00', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(42964, '2017-08-20 12:42:12', NULL, NULL, 12199, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 23.40, 0.0000, 0.0000, 23.40, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:42:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42965, '2017-08-20 13:41:20', NULL, NULL, 12206, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:41:20', 'admin-1503204457-15032076807626530', 1, 1, 'SR', NULL, NULL, NULL),
(42966, '2017-08-20 13:12:08', NULL, NULL, 12197, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:12:08', 'admin-1503204457-15032059283451552', 1, 0, '', NULL, NULL, NULL),
(42967, '2017-08-20 13:10:00', NULL, NULL, 12200, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:10:00', 'admin-1503204457-15032058006252160', 1, 0, '', NULL, NULL, NULL),
(42968, '2017-08-20 10:57:47', NULL, NULL, 12190, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:57:47', 'admin-1503197194-15031978673801460', 1, 0, '', NULL, NULL, NULL),
(42969, '2017-08-20 16:29:55', NULL, NULL, 12224, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 16:29:55', 'admin-1503211146-15032177954573336', 1, 0, '', NULL, NULL, NULL),
(42970, '2017-08-20 14:04:14', NULL, NULL, 12208, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:04:14', 'admin-1503207695-15032090544356011', 1, 1, 'SR', NULL, NULL, NULL),
(42971, '2017-08-20 16:29:55', NULL, NULL, 12224, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 3, 13.00, 39.0000, 0.0000, 39.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 16:29:55', 'admin-1503211146-15032177954573336', 1, 1, 'SR', NULL, NULL, NULL),
(42972, '2017-08-20 16:29:55', NULL, NULL, 12224, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 16:29:55', 'admin-1503211146-15032177954573336', 1, 1, 'SR', NULL, NULL, NULL),
(42973, '2017-08-20 16:29:42', NULL, NULL, 12224, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 19.00, 0.0000, 0.0000, 19.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 16:29:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42974, '2017-08-20 16:20:11', NULL, NULL, 12214, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 16:20:11', 'admin-1503211146-15032172112406826', 1, 0, '', NULL, NULL, '10.0'),
(42975, '2017-08-20 14:04:14', NULL, NULL, 12208, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:04:14', 'admin-1503207695-15032090544356011', 1, 0, '', NULL, NULL, NULL),
(42976, '2017-08-20 14:04:14', NULL, NULL, 12208, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:04:14', 'admin-1503207695-15032090544356011', 1, 0, '', NULL, NULL, NULL),
(42977, '2017-08-20 13:27:37', NULL, NULL, 12204, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:27:37', 'admin-1503204457-15032068575719091', 1, 0, '', NULL, NULL, NULL),
(42978, '2017-08-20 13:27:37', NULL, NULL, 12204, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:27:37', 'admin-1503204457-15032068575719091', 1, 1, 'SR', NULL, NULL, NULL),
(42979, '2017-08-20 13:27:37', NULL, NULL, 12204, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:27:37', 'admin-1503204457-15032068575719091', 1, 1, 'SR', NULL, NULL, NULL),
(42980, '2017-08-20 13:37:17', NULL, NULL, 12205, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:37:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42981, '2017-08-20 13:37:23', NULL, NULL, 12205, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:37:23', 'admin-1503204457-15032074430227410', 1, 1, 'SR', NULL, NULL, NULL),
(42982, '2017-08-20 16:13:12', NULL, NULL, 12223, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1503217811', 'admin', '2017-08-20 16:13:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42983, '2017-08-20 14:17:17', NULL, NULL, 12210, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:17:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(42984, '2017-08-20 13:41:20', NULL, NULL, 12206, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:41:20', 'admin-1503204457-15032076807626530', 1, 0, '', NULL, NULL, NULL),
(42985, '2017-08-20 13:41:20', NULL, NULL, 12206, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:41:20', 'admin-1503204457-15032076807626530', 1, 1, 'SR', NULL, NULL, NULL),
(42986, '2017-08-20 10:57:47', NULL, NULL, 12190, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:57:47', 'admin-1503197194-15031978673801460', 1, 0, '', NULL, NULL, NULL),
(42987, '2017-08-20 09:33:44', NULL, NULL, 12177, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:33:44', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(42988, '2017-08-20 09:32:09', NULL, NULL, 12176, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:32:09', 'admin-1503192542-15031927297462816', 1, 1, 'SR', NULL, NULL, NULL),
(42989, '2017-08-20 09:39:29', NULL, NULL, 12177, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:39:29', 'admin-1503192542-15031931692728286', 1, 0, '', NULL, NULL, '10.0'),
(42990, '2017-08-20 15:32:39', NULL, NULL, 12219, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:32:39', 'admin-1503211146-15032143589164839', 1, 0, '', NULL, NULL, NULL),
(42991, '2017-08-20 15:32:52', NULL, NULL, 12219, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:32:52', 'admin-1503211146-15032143723246839', 1, 0, '', NULL, NULL, NULL),
(42992, '2017-08-20 15:13:01', NULL, NULL, 12214, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:13:01', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(42993, '2017-08-20 15:13:11', NULL, NULL, 12214, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:13:11', 'admin-1503211146-15032131909953795', 1, 1, 'SR', NULL, NULL, '10.0'),
(42994, '2017-08-20 15:14:28', NULL, NULL, 12214, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:14:28', 'admin-1503211146-15032132688041657', 1, 1, 'SR', NULL, NULL, '10.0'),
(42995, '2017-08-20 14:20:36', NULL, NULL, 12210, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:20:36', 'admin-1503207695-15032100366442019', 1, 1, 'SR', NULL, NULL, NULL),
(42996, '2017-08-20 14:21:22', NULL, NULL, 12211, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:21:22', 'admin-1503207695-15032100820436439', 1, 1, 'SR', NULL, NULL, NULL),
(42997, '2017-08-20 15:51:07', NULL, NULL, 12222, 0, 182, '117', 'Open Drinks ', 'a promo,americano promo', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:51:07', 'admin-1503211146-1503215467188689', 1, 0, '', 1, NULL, NULL),
(42998, '2017-08-20 15:32:52', NULL, NULL, 12219, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:32:52', 'admin-1503211146-15032143723246839', 1, 1, 'SR', NULL, NULL, NULL),
(42999, '2017-08-20 15:32:52', NULL, NULL, 12219, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:32:52', 'admin-1503211146-15032143723246839', 1, 1, 'SR', NULL, NULL, NULL),
(43000, '2017-08-20 15:50:25', NULL, NULL, 12221, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:50:25', 'admin-1503211146-15032154248674227', 1, 1, 'SR', NULL, NULL, NULL),
(43001, '2017-08-20 15:45:28', NULL, NULL, 12220, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:45:28', 'admin-1503211146-15032151284144079', 1, 0, '', NULL, NULL, NULL),
(43002, '2017-08-20 15:32:52', NULL, NULL, 12219, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:32:52', 'admin-1503211146-15032143723246839', 1, 1, 'SR', NULL, NULL, NULL),
(43003, '2017-08-20 15:24:46', NULL, NULL, 12218, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:24:46', 'admin-1503211146-15032138867515790', 1, 0, '', 1, NULL, NULL),
(43004, '2017-08-20 15:24:46', NULL, NULL, 12218, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:24:46', 'admin-1503211146-15032138867515790', 1, 1, 'SR', 1, NULL, NULL),
(43005, '2017-08-20 13:27:37', NULL, NULL, 12204, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:27:37', 'admin-1503204457-15032068575719091', 1, 0, '', NULL, NULL, NULL),
(43006, '2017-08-20 11:34:30', NULL, NULL, 12194, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 11:34:30', 'admin-1503197194-1503200070346499', 1, 1, 'SR', NULL, NULL, NULL),
(43007, '2017-08-20 11:34:30', NULL, NULL, 12194, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 11:34:30', 'admin-1503197194-1503200070346499', 1, 1, 'SR', NULL, NULL, NULL),
(43008, '2017-08-20 14:38:58', NULL, NULL, 12210, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', 'Takeaway', 'Meals', 'Perfect Meals', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:38:58', 'admin-1503207695-15032111380486460', 1, 0, '', NULL, NULL, NULL),
(43009, '2017-08-20 14:39:12', NULL, NULL, 12213, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:39:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43010, '2017-08-20 14:39:22', NULL, NULL, 12213, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:39:22', 'admin-1503211146-15032111625489787', 1, 1, 'SR', NULL, NULL, NULL),
(43011, '2017-08-20 13:53:16', NULL, NULL, 12199, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:53:16', 'admin-1503207695-15032083962515029', 1, 1, 'SR', NULL, NULL, NULL),
(43012, '2017-08-20 15:19:13', NULL, NULL, 12215, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:19:13', 'admin-1503211146-1503213552870386', 1, 1, 'SR', NULL, NULL, NULL),
(43013, '2017-08-20 13:27:37', NULL, NULL, 12204, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:27:37', 'admin-1503204457-15032068575719091', 1, 1, 'SR', NULL, NULL, NULL),
(43014, '2017-08-20 15:19:13', NULL, NULL, 12215, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:19:13', 'admin-1503211146-1503213552870386', 1, 1, 'SR', NULL, NULL, NULL),
(43015, '2017-08-20 15:32:39', NULL, NULL, 12219, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:32:39', 'admin-1503211146-15032143589164839', 1, 1, 'SR', NULL, NULL, NULL),
(43016, '2017-08-20 15:19:13', NULL, NULL, 12215, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:19:13', 'admin-1503211146-1503213552870386', 1, 1, 'SR', NULL, NULL, NULL),
(43017, '2017-08-20 15:19:13', NULL, NULL, 12215, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:19:13', 'admin-1503211146-1503213552870386', 1, 1, 'SR', NULL, NULL, NULL),
(43018, '2017-08-20 15:19:13', NULL, NULL, 12215, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:19:13', 'admin-1503211146-1503213552870386', 1, 1, 'SR', NULL, NULL, NULL),
(43019, '2017-08-20 14:39:22', NULL, NULL, 12213, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:39:22', 'admin-1503211146-15032111625489787', 1, 1, 'SR', NULL, NULL, NULL),
(43020, '2017-08-20 13:25:24', NULL, NULL, 12203, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:25:24', 'admin-1503204457-15032067244807492', 1, 0, '', NULL, NULL, NULL),
(43021, '2017-08-20 14:39:22', NULL, NULL, 12213, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:39:22', 'admin-1503211146-15032111625489787', 1, 1, 'SR', NULL, NULL, NULL),
(43022, '2017-08-20 13:25:42', NULL, NULL, 12203, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:25:42', 'admin-1503204457-15032067418512687', 1, 1, 'SR', NULL, NULL, NULL),
(43023, '2017-08-20 13:27:09', NULL, NULL, 12204, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:27:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43024, '2017-08-20 09:45:34', NULL, NULL, 12178, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:45:34', 'admin-1503193507-15031935343032545', 1, 1, 'SR', NULL, NULL, NULL),
(43025, '2017-08-20 09:45:34', NULL, NULL, 12178, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:45:34', 'admin-1503193507-15031935343032545', 1, 1, 'SR', NULL, NULL, NULL),
(43026, '2017-08-20 15:32:30', NULL, NULL, 12219, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.30, 0.0000, 0.0000, 10.30, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:32:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43027, '2017-08-20 14:34:12', NULL, NULL, 12212, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:34:12', 'admin-1503207695-15032108525219197', 1, 1, 'SR', NULL, NULL, '10.0'),
(43028, '2017-08-20 14:21:22', NULL, NULL, 12211, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:21:22', 'admin-1503207695-15032100820436439', 1, 1, 'SR', NULL, NULL, NULL),
(43029, '2017-08-20 14:21:22', NULL, NULL, 12211, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:21:22', 'admin-1503207695-15032100820436439', 1, 0, '', NULL, NULL, NULL),
(43030, '2017-08-20 11:33:33', NULL, NULL, 12193, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 11:33:33', 'admin-1503197194-15032000132144389', 1, 1, 'SR', NULL, NULL, NULL),
(43031, '2017-08-20 09:46:46', NULL, NULL, 12179, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:46:46', 'admin-1503193507-15031936067876512', 1, 1, 'SR', NULL, NULL, NULL),
(43032, '2017-08-20 09:47:33', NULL, NULL, 12171, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:47:33', 'admin-1503193507-15031936537667771', 1, 1, 'SR', NULL, NULL, NULL),
(43033, '2017-08-20 14:20:36', NULL, NULL, 12210, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:20:36', 'admin-1503207695-15032100366442019', 1, 0, '', NULL, NULL, NULL),
(43034, '2017-08-20 14:20:01', NULL, NULL, 12211, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:20:01', 'admin-1503207695-15032100014869141', 1, 1, 'SR', NULL, NULL, NULL),
(43035, '2017-08-20 12:12:54', NULL, NULL, 12196, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:12:54', 'admin-1503197194-1503202374727354', 1, 0, '', NULL, NULL, NULL),
(43036, '2017-08-20 12:13:17', NULL, NULL, 12196, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:13:17', 'admin-1503197194-15032023970258211', 1, 1, 'SR', NULL, NULL, NULL),
(43037, '2017-08-20 14:19:37', NULL, NULL, 12211, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:19:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43038, '2017-08-20 14:20:01', NULL, NULL, 12211, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:20:01', 'admin-1503207695-15032100014869141', 1, 1, 'SR', NULL, NULL, NULL),
(43039, '2017-08-20 12:43:27', NULL, NULL, 12199, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:43:27', 'admin-1503197194-1503204207430991', 1, 1, 'SR', NULL, NULL, NULL),
(43040, '2017-08-20 12:43:27', NULL, NULL, 12199, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:43:27', 'admin-1503197194-1503204207430991', 1, 1, 'SR', NULL, NULL, NULL),
(43041, '2017-08-20 13:14:07', NULL, NULL, 12201, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:14:07', 'admin-1503204457-15032060477263063', 1, 0, '', NULL, NULL, NULL),
(43042, '2017-08-20 14:17:56', NULL, NULL, 12210, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:17:56', 'admin-1503207695-15032098760288170', 1, 0, '', NULL, NULL, NULL),
(43043, '2017-08-20 15:50:25', NULL, NULL, 12221, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:50:25', 'admin-1503211146-15032154248674227', 1, 1, 'SR', NULL, NULL, NULL),
(43044, '2017-08-20 14:12:47', NULL, NULL, 12209, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:12:47', 'admin-1503207695-15032095672729649', 1, 1, 'SR', NULL, NULL, NULL),
(43045, '2017-08-20 14:12:39', NULL, NULL, 12209, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:12:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43046, '2017-08-20 14:12:47', NULL, NULL, 12209, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:12:47', 'admin-1503207695-15032095672729649', 1, 1, 'SR', NULL, NULL, NULL),
(43047, '2017-08-20 14:04:14', NULL, NULL, 12208, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:04:14', 'admin-1503207695-15032090544356011', 1, 1, 'SR', NULL, NULL, NULL),
(43048, '2017-08-20 14:01:17', NULL, NULL, 12199, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:01:17', 'admin-1503207695-15032088774129949', 1, 0, '', NULL, NULL, NULL),
(43049, '2017-08-20 13:53:16', NULL, NULL, 12199, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:53:16', 'admin-1503207695-15032083962515029', 1, 1, 'SR', NULL, NULL, NULL),
(43050, '2017-08-20 13:59:25', NULL, NULL, 12203, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:59:25', 'admin-1503207695-15032087650493162', 1, 0, '', NULL, NULL, NULL),
(43051, '2017-08-20 13:57:16', NULL, NULL, 12207, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.70, 0.0000, 0.0000, 9.70, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:57:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43052, '2017-08-20 12:08:36', NULL, NULL, 12187, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:08:36', 'admin-1503197194-15032021158932556', 1, 0, '', NULL, NULL, NULL),
(43053, '2017-08-20 12:11:11', NULL, NULL, 12195, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:11:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43054, '2017-08-20 12:12:10', NULL, NULL, 12195, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:12:10', 'admin-1503197194-15032023298172126', 1, 0, '', NULL, NULL, NULL),
(43055, '2017-08-20 12:12:10', NULL, NULL, 12195, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:12:10', 'admin-1503197194-15032023298172126', 1, 1, 'SR', NULL, NULL, NULL),
(43056, '2017-08-20 12:12:25', NULL, NULL, 12196, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:12:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43057, '2017-08-20 12:12:54', NULL, NULL, 12196, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:12:54', 'admin-1503197194-1503202374727354', 1, 1, 'SR', NULL, NULL, NULL),
(43058, '2017-08-20 13:25:42', NULL, NULL, 12203, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:25:42', 'admin-1503204457-15032067418512687', 1, 1, 'SR', NULL, NULL, NULL),
(43059, '2017-08-20 12:43:27', NULL, NULL, 12199, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:43:27', 'admin-1503197194-1503204207430991', 1, 0, '', NULL, NULL, NULL),
(43060, '2017-08-20 12:43:27', NULL, NULL, 12199, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:43:27', 'admin-1503197194-1503204207430991', 1, 0, '', NULL, NULL, NULL),
(43061, '2017-08-20 14:04:00', NULL, NULL, 12208, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1503217811', 'admin', '2017-08-20 14:04:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43062, '2017-08-20 13:20:54', NULL, NULL, 12202, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:20:54', 'admin-1503204457-15032064543763699', 1, 1, 'SR', NULL, NULL, NULL),
(43063, '2017-08-20 13:20:54', NULL, NULL, 12202, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:20:54', 'admin-1503204457-15032064543763699', 1, 1, 'SR', NULL, NULL, NULL),
(43064, '2017-08-20 11:11:06', NULL, NULL, 12191, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1503217811', 'admin', '2017-08-20 11:11:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43065, '2017-08-20 11:11:10', NULL, NULL, 12191, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 11:11:10', 'admin-1503197194-15031986703962888', 1, 0, '', NULL, NULL, NULL),
(43066, '2017-08-20 11:11:44', NULL, NULL, 12192, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1503217811', 'admin', '2017-08-20 11:11:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43067, '2017-08-20 11:11:48', NULL, NULL, 12192, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 11:11:48', 'admin-1503197194-15031987081621168', 1, 1, 'SR', NULL, NULL, NULL),
(43068, '2017-08-20 13:41:20', NULL, NULL, 12206, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:41:20', 'admin-1503204457-15032076807626530', 1, 1, 'SR', NULL, NULL, NULL),
(43069, '2017-08-20 09:33:55', NULL, NULL, 12177, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:33:55', 'admin-1503192542-15031928348572295', 1, 1, 'SR', NULL, NULL, '10.0'),
(43070, '2017-08-20 09:43:12', NULL, NULL, 12178, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.50, 0.0000, 0.0000, 12.50, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:43:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43071, '2017-08-20 09:43:33', NULL, NULL, 12178, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:43:33', 'admin-1503192542-15031934131241488', 1, 0, '', NULL, NULL, NULL),
(43072, '2017-08-20 09:43:33', NULL, NULL, 12178, 0, 156, '90', 'House Cheddar Omelet', 'add 2 bacon', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:43:33', 'admin-1503192542-15031934131241488', 1, 0, '', NULL, NULL, NULL),
(43073, '2017-08-20 09:43:33', NULL, NULL, 12178, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:43:33', 'admin-1503192542-15031934131241488', 1, 0, '', NULL, NULL, NULL),
(43074, '2017-08-20 13:14:07', NULL, NULL, 12201, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:14:07', 'admin-1503204457-15032060477263063', 1, 1, 'SR', NULL, NULL, NULL),
(43075, '2017-08-20 13:09:53', NULL, NULL, 12200, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:09:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43076, '2017-08-20 13:13:50', NULL, NULL, 12201, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:13:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43077, '2017-08-20 13:14:07', NULL, NULL, 12201, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:14:07', 'admin-1503204457-15032060477263063', 1, 0, '', NULL, NULL, NULL),
(43078, '2017-08-20 11:33:33', NULL, NULL, 12193, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 11:33:33', 'admin-1503197194-15032000132144389', 1, 0, '', NULL, NULL, NULL),
(43079, '2017-08-20 13:14:08', NULL, NULL, 12201, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:14:08', 'admin-1503204457-15032060477263063', 1, 1, 'SR', NULL, NULL, NULL),
(43080, '2017-08-20 13:57:55', NULL, NULL, 12207, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:57:55', 'admin-1503207695-15032086749277145', 1, 0, '', NULL, NULL, NULL),
(43081, '2017-08-20 12:21:58', NULL, NULL, 12197, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:21:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43082, '2017-08-20 11:13:24', NULL, NULL, 12192, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 11:13:24', 'admin-1503197194-15031988045577163', 1, 1, 'SR', NULL, NULL, NULL),
(43083, '2017-08-20 11:13:24', NULL, NULL, 12192, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 11:13:24', 'admin-1503197194-15031988045577163', 1, 0, '', NULL, NULL, NULL),
(43084, '2017-08-20 12:47:03', NULL, NULL, 12199, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:47:03', 'admin-1503197194-15032044232159290', 1, 1, 'SR', NULL, NULL, NULL),
(43085, '2017-08-20 12:47:03', NULL, NULL, 12199, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:47:03', 'admin-1503197194-15032044232159290', 1, 0, '', NULL, NULL, NULL),
(43086, '2017-08-20 15:32:39', NULL, NULL, 12219, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:32:39', 'admin-1503211146-15032143589164839', 1, 0, '', NULL, NULL, NULL),
(43087, '2017-08-20 12:47:03', NULL, NULL, 12199, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:47:03', 'admin-1503197194-15032044232159290', 1, 0, '', NULL, NULL, NULL),
(43088, '2017-08-20 12:47:03', NULL, NULL, 12199, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:47:03', 'admin-1503197194-15032044232159290', 1, 1, 'SR', NULL, NULL, NULL),
(43089, '2017-08-20 12:47:03', NULL, NULL, 12199, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:47:03', 'admin-1503197194-15032044232159290', 1, 0, '', NULL, NULL, NULL),
(43090, '2017-08-20 12:26:10', NULL, NULL, 12197, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:26:10', 'admin-1503197194-15032031707067378', 1, 1, 'SR', NULL, NULL, NULL),
(43091, '2017-08-20 12:26:16', NULL, NULL, 12198, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:26:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43092, '2017-08-20 12:26:43', NULL, NULL, 12198, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:26:43', 'admin-1503197194-15032032035337149', 1, 0, '', NULL, NULL, NULL),
(43093, '2017-08-20 12:26:43', NULL, NULL, 12198, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:26:43', 'admin-1503197194-15032032035337149', 1, 0, '', NULL, NULL, NULL),
(43094, '2017-08-20 12:26:43', NULL, NULL, 12198, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:26:43', 'admin-1503197194-15032032035337149', 1, 0, '', NULL, NULL, NULL),
(43095, '2017-08-20 12:43:27', NULL, NULL, 12199, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:43:27', 'admin-1503197194-1503204207430991', 1, 1, 'SR', NULL, NULL, NULL),
(43096, '2017-08-20 10:31:52', NULL, NULL, 12182, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:31:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43097, '2017-08-20 13:24:52', NULL, NULL, 12199, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:24:52', 'admin-1503204457-15032066922859812', 1, 0, '', NULL, NULL, NULL),
(43098, '2017-08-20 12:43:27', NULL, NULL, 12199, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:43:27', 'admin-1503197194-1503204207430991', 1, 0, '', NULL, NULL, NULL),
(43099, '2017-08-20 16:29:55', NULL, NULL, 12224, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 16:29:55', 'admin-1503211146-15032177954573336', 1, 0, '', NULL, NULL, NULL),
(43100, '2017-08-20 13:40:54', NULL, NULL, 12206, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:40:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43101, '2017-08-20 12:26:43', NULL, NULL, 12198, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:26:43', 'admin-1503197194-15032032035337149', 1, 1, 'SR', NULL, NULL, NULL),
(43102, '2017-08-20 12:22:55', NULL, NULL, 12197, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:22:55', 'admin-1503197194-15032029754055739', 1, 1, 'SR', NULL, NULL, NULL),
(43103, '2017-08-20 12:26:10', NULL, NULL, 12197, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:26:10', 'admin-1503197194-15032031707067378', 1, 1, 'SR', NULL, NULL, NULL),
(43104, '2017-08-20 12:13:17', NULL, NULL, 12196, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:13:17', 'admin-1503197194-15032023970258211', 1, 0, '', NULL, NULL, NULL),
(43105, '2017-08-20 15:50:25', NULL, NULL, 12221, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:50:25', 'admin-1503211146-15032154248674227', 1, 0, '', NULL, NULL, NULL),
(43106, '2017-08-20 12:26:10', NULL, NULL, 12197, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:26:10', 'admin-1503197194-15032031707067378', 1, 1, 'SR', NULL, NULL, NULL),
(43107, '2017-08-20 12:22:55', NULL, NULL, 12197, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:22:55', 'admin-1503197194-15032029754055739', 1, 0, '', NULL, NULL, NULL),
(43108, '2017-08-20 11:33:19', NULL, NULL, 12193, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1503217811', 'admin', '2017-08-20 11:33:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43109, '2017-08-20 12:47:03', NULL, NULL, 12199, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:47:03', 'admin-1503197194-15032044232159290', 1, 1, 'SR', NULL, NULL, NULL),
(43110, '2017-08-20 12:13:17', NULL, NULL, 12196, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:13:17', 'admin-1503197194-15032023970258211', 1, 1, 'SR', NULL, NULL, NULL),
(43111, '2017-08-20 10:30:58', NULL, NULL, 12181, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:30:58', 'admin-1503193507-15031962581795983', 1, 1, 'SR', NULL, NULL, NULL),
(43112, '2017-08-20 12:12:54', NULL, NULL, 12196, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:12:54', 'admin-1503197194-1503202374727354', 1, 0, '', NULL, NULL, NULL),
(43113, '2017-08-20 13:24:52', NULL, NULL, 12199, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:24:52', 'admin-1503204457-15032066922859812', 1, 0, '', NULL, NULL, NULL),
(43114, '2017-08-20 10:31:58', NULL, NULL, 12182, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:31:58', 'admin-1503193507-1503196317914186', 1, 0, '', NULL, NULL, NULL),
(43115, '2017-08-20 10:31:58', NULL, NULL, 12182, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:31:58', 'admin-1503193507-1503196317914186', 1, 0, '', NULL, NULL, NULL),
(43116, '2017-08-20 10:31:58', NULL, NULL, 12182, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:31:58', 'admin-1503193507-1503196317914186', 1, 1, 'SR', NULL, NULL, NULL),
(43117, '2017-08-20 10:33:59', NULL, NULL, 12183, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.20, 0.0000, 0.0000, 10.20, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:33:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43118, '2017-08-20 10:34:15', NULL, NULL, 12183, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:34:15', 'admin-1503193507-15031964556808942', 1, 0, '', NULL, NULL, NULL),
(43119, '2017-08-20 12:22:55', NULL, NULL, 12197, 0, 217, '151', 'Spicy Lemony Wings', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:22:55', 'admin-1503197194-15032029754055739', 1, 0, '', NULL, NULL, NULL),
(43120, '2017-08-20 11:34:01', NULL, NULL, 12194, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 11:34:01', 'admin-1503197194-15032000414666239', 1, 0, '', NULL, NULL, NULL),
(43121, '2017-08-20 11:34:30', NULL, NULL, 12194, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 11:34:30', 'admin-1503197194-1503200070346499', 1, 1, 'SR', NULL, NULL, NULL),
(43122, '2017-08-20 11:37:28', NULL, NULL, 12192, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 11:37:28', 'admin-1503197194-15032002487838782', 1, 0, '', NULL, NULL, NULL),
(43123, '2017-08-20 10:57:47', NULL, NULL, 12190, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:57:47', 'admin-1503197194-15031978673801460', 1, 1, 'SR', NULL, NULL, NULL),
(43124, '2017-08-20 10:45:56', NULL, NULL, 12186, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:45:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43125, '2017-08-20 15:50:25', NULL, NULL, 12221, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 15:50:25', 'admin-1503211146-15032154248674227', 1, 0, '', NULL, NULL, NULL),
(43126, '2017-08-20 10:30:41', NULL, NULL, 12181, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:30:41', 'admin-1503193507-15031962412355373', 1, 0, '', NULL, NULL, NULL),
(43127, '2017-08-20 10:39:15', NULL, NULL, 12184, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:39:15', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(43128, '2017-08-20 10:39:32', NULL, NULL, 12184, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:39:32', 'admin-1503193507-150319677200439', 1, 0, '', NULL, NULL, NULL),
(43129, '2017-08-20 10:39:32', NULL, NULL, 12184, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:39:32', 'admin-1503193507-150319677200439', 1, 0, '', NULL, NULL, NULL),
(43130, '2017-08-20 10:39:32', NULL, NULL, 12184, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:39:32', 'admin-1503193507-150319677200439', 1, 1, 'SR', NULL, NULL, NULL),
(43131, '2017-08-20 10:40:05', NULL, NULL, 12185, 0, 182, '117', 'Open Drinks ', 'americano set', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:40:05', 'admin-1503193507-15031968051806485', 1, 0, '', 1, NULL, NULL),
(43132, '2017-08-20 10:34:47', NULL, NULL, 12183, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:34:47', 'admin-1503193507-15031964875876944', 1, 1, 'SR', NULL, NULL, NULL),
(43133, '2017-08-20 10:34:47', NULL, NULL, 12183, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:34:47', 'admin-1503193507-15031964875876944', 1, 1, 'SR', NULL, NULL, NULL),
(43134, '2017-08-20 09:17:30', NULL, NULL, 12173, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:17:30', 'admin-1503190854-1503191850347567', 1, 1, 'SR', NULL, NULL, NULL),
(43135, '2017-08-20 09:17:30', NULL, NULL, 12173, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:17:30', 'admin-1503190854-1503191850347567', 1, 0, '', NULL, NULL, NULL),
(43136, '2017-08-20 10:46:07', NULL, NULL, 12186, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:46:07', 'admin-1503193507-15031971677854258', 1, 0, '', NULL, NULL, NULL),
(43137, '2017-08-20 10:46:50', NULL, NULL, 12186, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:46:50', 'admin-1503197194-15031972101726114', 1, 0, '', NULL, NULL, NULL),
(43138, '2017-08-20 10:51:07', NULL, NULL, 12187, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:51:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43139, '2017-08-20 10:51:18', NULL, NULL, 12187, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:51:18', 'admin-1503197194-15031974780289875', 1, 0, '', NULL, NULL, NULL),
(43140, '2017-08-20 10:51:18', NULL, NULL, 12187, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:51:18', 'admin-1503197194-15031974780289875', 1, 0, '', NULL, NULL, NULL),
(43141, '2017-08-20 10:51:31', NULL, NULL, 12187, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:51:31', 'admin-1503197194-15031974916939657', 1, 0, '', NULL, NULL, NULL),
(43142, '2017-08-20 10:51:31', NULL, NULL, 12187, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:51:31', 'admin-1503197194-15031974916939657', 1, 1, 'SR', NULL, NULL, NULL),
(43143, '2017-08-20 10:51:38', NULL, NULL, 12188, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:51:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43144, '2017-08-20 13:20:08', NULL, NULL, 12202, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:20:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43145, '2017-08-20 11:13:02', NULL, NULL, 12192, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 11:13:02', 'admin-1503197194-15031987826481697', 1, 0, '', NULL, NULL, NULL),
(43146, '2017-08-20 10:57:31', NULL, NULL, 12190, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:57:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43147, '2017-08-20 10:57:26', NULL, NULL, 12189, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:57:26', 'admin-1503197194-15031978466593692', 1, 0, '', NULL, NULL, NULL),
(43148, '2017-08-20 10:57:26', NULL, NULL, 12189, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:57:26', 'admin-1503197194-15031978466593692', 1, 0, '', NULL, NULL, NULL),
(43149, '2017-08-20 10:57:26', NULL, NULL, 12189, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:57:26', 'admin-1503197194-15031978466593692', 1, 1, 'SR', NULL, NULL, NULL),
(43150, '2017-08-20 10:57:26', NULL, NULL, 12189, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:57:26', 'admin-1503197194-15031978466593692', 1, 1, 'SR', NULL, NULL, NULL),
(43151, '2017-08-20 10:57:05', NULL, NULL, 12189, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:57:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43152, '2017-08-20 10:57:26', NULL, NULL, 12189, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:57:26', 'admin-1503197194-15031978466593692', 1, 0, '', NULL, NULL, NULL),
(43153, '2017-08-20 10:30:41', NULL, NULL, 12181, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:30:41', 'admin-1503193507-15031962412355373', 1, 0, '', NULL, NULL, NULL),
(43154, '2017-08-20 16:30:44', NULL, NULL, 12224, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 16:30:44', 'admin-1503217811-15032178439401731', 1, 1, 'SR', NULL, NULL, NULL),
(43155, '2017-08-20 10:51:42', NULL, NULL, 12188, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:51:42', 'admin-1503197194-15031975018596438', 1, 1, 'SR', NULL, NULL, NULL),
(43156, '2017-08-20 10:46:50', NULL, NULL, 12186, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:46:50', 'admin-1503197194-15031972101726114', 1, 1, 'SR', NULL, NULL, NULL),
(43157, '2017-08-20 10:11:50', NULL, NULL, 12171, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:11:50', 'admin-1503193507-15031951102253066', 1, 0, '', NULL, NULL, NULL),
(43158, '2017-08-20 10:30:29', NULL, NULL, 12181, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.70, 0.0000, 0.0000, 11.70, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:30:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43159, '2017-08-20 10:30:41', NULL, NULL, 12181, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:30:41', 'admin-1503193507-15031962412355373', 1, 0, '', NULL, NULL, NULL),
(43160, '2017-08-20 10:46:07', NULL, NULL, 12186, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:46:07', 'admin-1503193507-15031971677854258', 1, 0, '', NULL, NULL, NULL),
(43161, '2017-08-20 09:46:33', NULL, NULL, 12179, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:46:33', 'admin-1503193507-15031935936021315', 1, 0, '', NULL, NULL, NULL),
(43162, '2017-08-20 09:46:33', NULL, NULL, 12179, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:46:33', 'admin-1503193507-15031935936021315', 1, 0, '', NULL, NULL, NULL),
(43163, '2017-08-20 09:46:46', NULL, NULL, 12179, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:46:46', 'admin-1503193507-15031936067876512', 1, 1, 'SR', NULL, NULL, NULL),
(43164, '2017-08-20 10:34:47', NULL, NULL, 12183, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:34:47', 'admin-1503193507-15031964875876944', 1, 1, 'SR', NULL, NULL, NULL),
(43165, '2017-08-20 10:34:15', NULL, NULL, 12183, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:34:15', 'admin-1503193507-15031964556808942', 1, 0, '', NULL, NULL, NULL),
(43166, '2017-08-20 09:23:32', NULL, NULL, 12171, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:23:32', 'admin-1503190854-15031922122514082', 1, 0, '', NULL, NULL, NULL),
(43167, '2017-08-20 09:23:32', NULL, NULL, 12171, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:23:32', 'admin-1503190854-15031922122514082', 1, 0, '', NULL, NULL, NULL),
(43168, '2017-08-20 09:23:32', NULL, NULL, 12171, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:23:32', 'admin-1503190854-15031922122514082', 1, 0, '', NULL, NULL, NULL),
(43169, '2017-08-20 09:23:32', NULL, NULL, 12171, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:23:32', 'admin-1503190854-15031922122514082', 1, 1, 'SR', NULL, NULL, NULL),
(43170, '2017-08-20 09:27:41', NULL, NULL, 12174, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:27:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43171, '2017-08-20 09:27:47', NULL, NULL, 12174, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:27:47', 'admin-1503190854-15031924674594758', 1, 0, '', NULL, NULL, NULL),
(43172, '2017-08-20 09:27:47', NULL, NULL, 12174, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:27:47', 'admin-1503190854-15031924674594758', 1, 0, '', NULL, NULL, NULL),
(43173, '2017-08-20 09:27:51', NULL, NULL, 12174, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:27:51', 'admin-1503190854-15031924715529866', 1, 1, 'SR', NULL, NULL, NULL),
(43174, '2017-08-20 13:25:13', NULL, NULL, 12203, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:25:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43175, '2017-08-20 13:20:54', NULL, NULL, 12202, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 13:20:54', 'admin-1503204457-15032064543763699', 1, 1, 'SR', NULL, NULL, NULL),
(43176, '2017-08-20 09:45:34', NULL, NULL, 12178, 0, 182, '117', 'Open Drinks ', '2 types smoothies', 'Cold Drinks', 'Fresh Juice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:45:34', 'admin-1503193507-15031935343032545', 1, 0, '', NULL, NULL, NULL),
(43177, '2017-08-20 09:45:44', NULL, NULL, 12178, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:45:44', 'admin-1503193507-15031935446771538', 1, 1, 'SR', NULL, NULL, NULL),
(43178, '2017-08-20 09:28:26', NULL, NULL, 12175, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.75, 0.0000, 0.0000, 3.75, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:28:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43179, '2017-08-20 10:34:47', NULL, NULL, 12183, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:34:47', 'admin-1503193507-15031964875876944', 1, 1, 'SR', NULL, NULL, NULL),
(43180, '2017-08-20 10:34:15', NULL, NULL, 12183, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:34:15', 'admin-1503193507-15031964556808942', 1, 0, '', NULL, NULL, NULL),
(43181, '2017-08-20 11:33:47', NULL, NULL, 12194, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1503217811', 'admin', '2017-08-20 11:33:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43182, '2017-08-20 10:34:15', NULL, NULL, 12183, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:34:15', 'admin-1503193507-15031964556808942', 1, 0, '', NULL, NULL, NULL),
(43183, '2017-08-20 10:09:07', NULL, NULL, 12180, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:09:07', 'admin-1503193507-15031949476906269', 1, 0, '', NULL, NULL, NULL),
(43184, '2017-08-20 10:09:07', NULL, NULL, 12180, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:09:07', 'admin-1503193507-15031949476906269', 1, 0, '', NULL, NULL, NULL),
(43185, '2017-08-20 10:09:07', NULL, NULL, 12180, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:09:07', 'admin-1503193507-15031949476906269', 1, 0, '', NULL, NULL, NULL),
(43186, '2017-08-20 10:09:07', NULL, NULL, 12180, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:09:07', 'admin-1503193507-15031949476906269', 1, 0, '', NULL, NULL, NULL),
(43187, '2017-08-20 10:30:58', NULL, NULL, 12181, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:30:58', 'admin-1503193507-15031962581795983', 1, 1, 'SR', NULL, NULL, NULL),
(43188, '2017-08-20 10:30:58', NULL, NULL, 12181, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:30:58', 'admin-1503193507-15031962581795983', 1, 1, 'SR', NULL, NULL, NULL),
(43189, '2017-08-20 10:30:58', NULL, NULL, 12181, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:30:58', 'admin-1503193507-15031962581795983', 1, 1, 'SR', NULL, NULL, NULL),
(43190, '2017-08-20 12:12:54', NULL, NULL, 12196, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 12:12:54', 'admin-1503197194-1503202374727354', 1, 0, '', NULL, NULL, NULL),
(43191, '2017-08-20 10:10:30', NULL, NULL, 12180, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:10:30', 'admin-1503193507-15031950300621468', 1, 1, 'SR', NULL, NULL, NULL),
(43192, '2017-08-20 10:30:41', NULL, NULL, 12181, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:30:41', 'admin-1503193507-15031962412355373', 1, 0, '', NULL, NULL, NULL),
(43193, '2017-08-20 10:10:30', NULL, NULL, 12180, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:10:30', 'admin-1503193507-15031950300621468', 1, 1, 'SR', NULL, NULL, NULL),
(43194, '2017-08-20 10:10:30', NULL, NULL, 12180, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:10:30', 'admin-1503193507-15031950300621468', 1, 1, 'SR', NULL, NULL, NULL),
(43195, '2017-08-20 09:56:05', NULL, NULL, 12178, 0, 181, '116', 'Open Food ', 'additional bacon', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:56:05', 'admin-1503193507-15031941648799025', 1, 0, '', NULL, NULL, NULL),
(43196, '2017-08-20 10:09:00', NULL, NULL, 12180, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.50, 0.0000, 0.0000, 10.50, 1, '27', 1, '1503217811', 'admin', '2017-08-20 10:09:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43197, '2017-08-20 09:46:46', NULL, NULL, 12179, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:46:46', 'admin-1503193507-15031936067876512', 1, 1, 'SR', NULL, NULL, NULL),
(43198, '2017-08-20 09:29:57', NULL, NULL, 12174, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:29:57', 'admin-1503192542-15031925977941242', 1, 1, 'SR', NULL, NULL, NULL),
(43199, '2017-08-20 09:28:58', NULL, NULL, 12175, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:28:58', 'admin-1503190854-15031925378385339', 1, 0, '', NULL, NULL, NULL),
(43200, '2017-08-20 09:46:25', NULL, NULL, 12179, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:46:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43201, '2017-08-20 09:43:33', NULL, NULL, 12178, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:43:33', 'admin-1503192542-15031934131241488', 1, 0, '', NULL, NULL, NULL),
(43202, '2017-08-20 09:28:58', NULL, NULL, 12175, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:28:58', 'admin-1503190854-15031925378385339', 1, 0, '', NULL, NULL, NULL),
(43203, '2017-08-20 09:28:58', NULL, NULL, 12175, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:28:58', 'admin-1503190854-15031925378385339', 1, 1, 'SR', NULL, NULL, NULL),
(43204, '2017-08-20 09:28:58', NULL, NULL, 12175, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:28:58', 'admin-1503190854-15031925378385339', 1, 1, 'SR', NULL, NULL, NULL),
(43205, '2017-08-20 09:06:49', NULL, NULL, 12171, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:06:49', 'admin-1503190854-15031912096794818', 1, 1, 'SR', NULL, NULL, NULL),
(43206, '2017-08-20 09:06:49', NULL, NULL, 12171, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:06:49', 'admin-1503190854-15031912096794818', 1, 1, 'SR', NULL, NULL, NULL),
(43207, '2017-08-20 09:08:27', NULL, NULL, 12172, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:08:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43208, '2017-08-20 09:08:45', NULL, NULL, 12172, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:08:45', 'admin-1503190854-15031913251267397', 1, 0, '', NULL, NULL, NULL),
(43209, '2017-08-20 09:08:45', NULL, NULL, 12172, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:08:45', 'admin-1503190854-15031913251267397', 1, 0, '', NULL, NULL, NULL),
(43210, '2017-08-20 09:08:45', NULL, NULL, 12172, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:08:45', 'admin-1503190854-15031913251267397', 1, 0, '', NULL, NULL, NULL),
(43211, '2017-08-20 09:08:45', NULL, NULL, 12172, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:08:45', 'admin-1503190854-15031913251267397', 1, 1, 'SR', NULL, NULL, NULL),
(43212, '2017-08-20 09:17:30', NULL, NULL, 12173, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:17:30', 'admin-1503190854-1503191850347567', 1, 1, 'SR', NULL, NULL, NULL),
(43213, '2017-08-20 09:17:15', NULL, NULL, 12173, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:17:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43214, '2017-08-20 09:17:30', NULL, NULL, 12173, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:17:30', 'admin-1503190854-1503191850347567', 1, 0, '', NULL, NULL, NULL),
(43215, '2017-08-20 09:17:30', NULL, NULL, 12173, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:17:30', 'admin-1503190854-1503191850347567', 1, 0, '', NULL, NULL, NULL),
(43216, '2017-08-20 09:06:49', NULL, NULL, 12171, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:06:49', 'admin-1503190854-15031912096794818', 1, 0, '', NULL, NULL, NULL),
(43217, '2017-08-20 09:06:49', NULL, NULL, 12171, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:06:49', 'admin-1503190854-15031912096794818', 1, 1, 'SR', NULL, NULL, NULL),
(43218, '2017-08-20 09:08:45', NULL, NULL, 12172, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:08:45', 'admin-1503190854-15031913251267397', 1, 1, 'SR', NULL, NULL, NULL),
(43219, '2017-08-20 09:06:49', NULL, NULL, 12171, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:06:49', 'admin-1503190854-15031912096794818', 1, 0, '', NULL, NULL, NULL),
(43220, '2017-08-20 09:06:28', NULL, NULL, 12171, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.60, 0.0000, 0.0000, 12.60, 1, '27', 1, '1503217811', 'admin', '2017-08-20 09:06:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43221, '2017-08-21 15:45:41', NULL, NULL, 12250, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1503296751', 'admin', '2017-08-21 15:45:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43222, '2017-08-21 15:45:47', NULL, NULL, 12250, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 15:45:47', 'admin-1503296751-15033015468805771', 1, 1, 'SR', NULL, NULL, NULL),
(43223, '2017-08-21 15:52:09', NULL, NULL, 12251, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1503296751', 'admin', '2017-08-21 15:52:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43224, '2017-08-21 15:52:12', NULL, NULL, 12251, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 15:52:12', 'admin-1503296751-15033019321649761', 1, 1, 'SR', NULL, NULL, NULL),
(43225, '2017-08-21 10:56:15', NULL, NULL, 12232, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:56:15', 'admin-1503277942-15032841750378082', 1, 0, '', NULL, NULL, NULL),
(43226, '2017-08-21 11:34:23', NULL, NULL, 12235, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1503296751', 'admin', '2017-08-21 11:34:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43227, '2017-08-21 11:34:35', NULL, NULL, 12235, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 11:34:35', 'admin-1503285279-15032864748505913', 1, 0, '', NULL, NULL, NULL),
(43228, '2017-08-21 11:34:45', NULL, NULL, 12236, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 11:34:45', 'admin-1503285279-15032864849076619', 1, 1, 'SR', 1, NULL, '10.0'),
(43229, '2017-08-21 14:18:16', NULL, NULL, 12245, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:18:16', 'admin-1503286711-15032962965508230', 1, 0, '', NULL, NULL, NULL),
(43230, '2017-08-21 14:18:16', NULL, NULL, 12245, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:18:16', 'admin-1503286711-15032962965508230', 1, 1, 'SR', NULL, NULL, NULL),
(43231, '2017-08-21 16:39:44', NULL, NULL, 12253, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1503296751', 'admin', '2017-08-21 16:39:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43232, '2017-08-21 14:12:42', NULL, NULL, 12244, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:12:42', 'admin-1503286711-15032959626378685', 1, 1, 'SR', NULL, NULL, NULL),
(43233, '2017-08-21 16:39:49', NULL, NULL, 12253, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 16:39:49', 'admin-1503296751-15033047895564023', 1, 0, '', NULL, NULL, NULL),
(43234, '2017-08-21 14:31:26', NULL, NULL, 12245, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:31:26', 'admin-1503296751-15032970864041448', 1, 1, 'SR', NULL, NULL, NULL),
(43235, '2017-08-21 13:07:28', NULL, NULL, 12241, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 13:07:28', 'admin-1503286711-15032920480317649', 1, 1, 'SR', NULL, NULL, NULL),
(43236, '2017-08-21 12:33:04', NULL, NULL, 12238, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 12:33:04', 'admin-1503286711-15032899844733334', 1, 0, '', NULL, NULL, '10.0'),
(43237, '2017-08-21 15:52:15', NULL, NULL, 12252, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1503296751', 'admin', '2017-08-21 15:52:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43238, '2017-08-21 15:52:19', NULL, NULL, 12252, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 15:52:19', 'admin-1503296751-15033019397014686', 1, 1, 'SR', NULL, NULL, NULL),
(43239, '2017-08-21 14:35:38', NULL, NULL, 12247, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:35:38', 'admin-1503296751-15032973379248642', 1, 0, '', NULL, NULL, NULL),
(43240, '2017-08-21 12:47:58', NULL, NULL, 12240, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 12:47:58', 'admin-1503286711-1503290878396239', 1, 1, 'SR', NULL, NULL, NULL),
(43241, '2017-08-21 13:04:08', NULL, NULL, 12241, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1503296751', 'admin', '2017-08-21 13:04:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43242, '2017-08-21 13:07:22', NULL, NULL, 12241, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 13:07:22', 'admin-1503286711-15032920419603430', 1, 0, '', NULL, NULL, NULL),
(43243, '2017-08-21 12:32:49', NULL, NULL, 12238, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 12:32:49', 'admin-1503286711-15032899691994034', 1, 0, '', NULL, NULL, '10.0'),
(43244, '2017-08-21 14:35:38', NULL, NULL, 12247, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:35:38', 'admin-1503296751-15032973379248642', 1, 1, 'SR', NULL, NULL, NULL),
(43245, '2017-08-21 14:25:46', NULL, NULL, 12246, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:25:46', 'admin-1503286711-15032967466678597', 1, 0, '', NULL, NULL, NULL),
(43246, '2017-08-21 13:31:55', NULL, NULL, 12240, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 13:31:55', 'admin-1503286711-1503293515099647', 1, 0, '', NULL, NULL, NULL),
(43247, '2017-08-21 13:53:34', NULL, NULL, 12242, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 13:53:34', 'admin-1503286711-15032948141591178', 1, 1, 'SR', NULL, NULL, '10.0'),
(43248, '2017-08-21 10:33:57', NULL, NULL, 12231, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:33:57', 'admin-1503277942-15032828374167771', 1, 0, '', NULL, NULL, NULL),
(43249, '2017-08-21 14:35:38', NULL, NULL, 12247, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:35:38', 'admin-1503296751-15032973379248642', 1, 0, '', NULL, NULL, NULL),
(43250, '2017-08-21 14:35:46', NULL, NULL, 12246, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:35:46', 'admin-1503296751-15032973464687052', 1, 1, 'SR', NULL, NULL, NULL),
(43251, '2017-08-21 14:47:40', NULL, NULL, 12248, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:47:40', 'admin-1503296751-15032980597472955', 1, 1, 'SR', NULL, NULL, NULL),
(43252, '2017-08-21 14:47:40', NULL, NULL, 12248, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:47:40', 'admin-1503296751-15032980597472955', 1, 1, 'SR', NULL, NULL, NULL),
(43253, '2017-08-21 14:54:31', NULL, NULL, 12249, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:54:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43254, '2017-08-21 14:54:44', NULL, NULL, 12249, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:54:44', 'admin-1503296751-15032984840118311', 1, 0, '', NULL, NULL, NULL),
(43255, '2017-08-21 14:54:44', NULL, NULL, 12249, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:54:44', 'admin-1503296751-15032984840118311', 1, 0, '', NULL, NULL, NULL),
(43256, '2017-08-21 14:54:44', NULL, NULL, 12249, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:54:44', 'admin-1503296751-15032984840118311', 1, 0, '', NULL, NULL, NULL),
(43257, '2017-08-21 11:15:01', NULL, NULL, 12234, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1503296751', 'admin', '2017-08-21 11:15:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43258, '2017-08-21 11:15:15', NULL, NULL, 12234, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 11:15:15', 'admin-1503285279-1503285315215481', 1, 0, '', NULL, NULL, NULL),
(43259, '2017-08-21 10:56:29', NULL, NULL, 12232, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:56:29', 'admin-1503277942-15032841895659067', 1, 1, 'SR', NULL, NULL, NULL),
(43260, '2017-08-21 14:47:19', NULL, NULL, 12248, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:47:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43261, '2017-08-21 14:35:22', NULL, NULL, 12247, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:35:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43262, '2017-08-21 14:26:12', NULL, NULL, 12246, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:26:12', 'admin-1503296751-15032967720761024', 1, 1, 'SR', NULL, NULL, NULL),
(43263, '2017-08-21 14:26:12', NULL, NULL, 12246, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:26:12', 'admin-1503296751-15032967720761024', 1, 1, 'SR', NULL, NULL, NULL),
(43264, '2017-08-21 14:25:46', NULL, NULL, 12246, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:25:46', 'admin-1503286711-15032967466678597', 1, 1, 'SR', NULL, NULL, NULL),
(43265, '2017-08-21 14:25:46', NULL, NULL, 12246, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:25:46', 'admin-1503286711-15032967466678597', 1, 1, 'SR', NULL, NULL, NULL),
(43266, '2017-08-21 14:24:41', NULL, NULL, 12246, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:24:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43267, '2017-08-21 10:56:15', NULL, NULL, 12232, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:56:15', 'admin-1503277942-15032841750378082', 1, 0, '', NULL, NULL, NULL),
(43268, '2017-08-21 10:33:57', NULL, NULL, 12231, 0, 157, '91', 'French Toast with Fruits', 'no fruits', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:33:57', 'admin-1503277942-15032828374167771', 1, 0, '', NULL, NULL, NULL),
(43269, '2017-08-21 10:34:03', NULL, NULL, 12231, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:34:03', 'admin-1503277942-1503282843155254', 1, 1, 'SR', NULL, NULL, NULL),
(43270, '2017-08-21 10:34:03', NULL, NULL, 12231, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:34:03', 'admin-1503277942-1503282843155254', 1, 1, 'SR', NULL, NULL, NULL),
(43271, '2017-08-21 10:56:01', NULL, NULL, 12232, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.80, 0.0000, 0.0000, 11.80, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:56:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43272, '2017-08-21 10:56:15', NULL, NULL, 12232, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:56:15', 'admin-1503277942-15032841750378082', 1, 0, '', NULL, NULL, NULL),
(43273, '2017-08-21 10:56:15', NULL, NULL, 12232, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:56:15', 'admin-1503277942-15032841750378082', 1, 0, '', NULL, NULL, NULL),
(43274, '2017-08-21 10:56:15', NULL, NULL, 12232, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:56:15', 'admin-1503277942-15032841750378082', 1, 0, '', NULL, NULL, NULL),
(43275, '2017-08-21 14:18:40', NULL, NULL, 12245, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:18:40', 'admin-1503286711-15032963200555863', 1, 1, 'SR', NULL, NULL, NULL),
(43276, '2017-08-21 14:17:57', NULL, NULL, 12245, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:17:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43277, '2017-08-21 14:12:40', NULL, NULL, 12244, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:12:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43278, '2017-08-21 14:12:42', NULL, NULL, 12244, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:12:42', 'admin-1503286711-15032959626378685', 1, 1, 'SR', NULL, NULL, NULL),
(43279, '2017-08-21 13:54:20', NULL, NULL, 12243, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 13:54:20', 'admin-1503286711-15032948598742762', 1, 0, '', 1, NULL, NULL),
(43280, '2017-08-21 12:47:58', NULL, NULL, 12240, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 12:47:58', 'admin-1503286711-1503290878396239', 1, 1, 'SR', NULL, NULL, NULL),
(43281, '2017-08-21 12:47:58', NULL, NULL, 12240, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 12:47:58', 'admin-1503286711-1503290878396239', 1, 1, 'SR', NULL, NULL, NULL),
(43282, '2017-08-21 12:47:47', NULL, NULL, 12240, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 12:47:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43283, '2017-08-21 12:40:21', NULL, NULL, 12239, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 12:40:21', 'admin-1503286711-15032904218026641', 1, 1, 'SR', NULL, NULL, NULL),
(43284, '2017-08-21 12:40:21', NULL, NULL, 12239, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 12:40:21', 'admin-1503286711-15032904218026641', 1, 0, '', NULL, NULL, NULL),
(43285, '2017-08-21 12:40:02', NULL, NULL, 12239, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1503296751', 'admin', '2017-08-21 12:40:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43286, '2017-08-21 12:32:49', NULL, NULL, 12238, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 12:32:49', 'admin-1503286711-15032899691994034', 1, 1, 'SR', NULL, NULL, '10.0'),
(43287, '2017-08-21 12:32:49', NULL, NULL, 12238, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 12:32:49', 'admin-1503286711-15032899691994034', 1, 0, '', NULL, NULL, '10.0'),
(43288, '2017-08-21 14:18:16', NULL, NULL, 12245, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 14:18:16', 'admin-1503286711-15032962965508230', 1, 1, 'SR', NULL, NULL, NULL),
(43289, '2017-08-21 13:53:26', NULL, NULL, 12242, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 13:53:26', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(43290, '2017-08-21 11:56:47', NULL, NULL, 12237, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 11:56:47', 'admin-1503286711-15032878075737087', 1, 1, 'SR', NULL, NULL, NULL),
(43291, '2017-08-21 11:56:47', NULL, NULL, 12237, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 11:56:47', 'admin-1503286711-15032878075737087', 1, 1, 'SR', NULL, NULL, NULL),
(43292, '2017-08-21 12:32:49', NULL, NULL, 12238, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 12:32:49', 'admin-1503286711-15032899691994034', 1, 1, 'SR', NULL, NULL, '10.0'),
(43293, '2017-08-21 12:32:25', NULL, NULL, 12238, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1503296751', 'admin', '2017-08-21 12:32:25', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(43294, '2017-08-21 11:56:41', NULL, NULL, 12237, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1503296751', 'admin', '2017-08-21 11:56:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43295, '2017-08-21 11:15:15', NULL, NULL, 12234, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 11:15:15', 'admin-1503285279-1503285315215481', 1, 1, 'SR', NULL, NULL, NULL),
(43296, '2017-08-21 11:14:48', NULL, NULL, 12233, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 11:14:48', 'admin-1503285279-15032852879804930', 1, 0, '', NULL, NULL, NULL),
(43297, '2017-08-21 11:14:32', NULL, NULL, 12233, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 11:14:32', 'admin-1503277942-15032852727538880', 1, 0, '', NULL, NULL, NULL),
(43298, '2017-08-21 11:14:32', NULL, NULL, 12233, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 11:14:32', 'admin-1503277942-15032852727538880', 1, 0, '', NULL, NULL, NULL),
(43299, '2017-08-21 11:14:24', NULL, NULL, 12233, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1503296751', 'admin', '2017-08-21 11:14:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43300, '2017-08-21 10:56:29', NULL, NULL, 12232, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:56:29', 'admin-1503277942-15032841895659067', 1, 1, 'SR', NULL, NULL, NULL),
(43301, '2017-08-21 11:38:47', NULL, NULL, 12235, 0, 181, '116', 'Open Food ', 'pancake', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 11:38:47', 'admin-1503286711-15032867274037692', 1, 0, '', NULL, NULL, NULL),
(43302, '2017-08-21 10:56:29', NULL, NULL, 12232, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:56:29', 'admin-1503277942-15032841895659067', 1, 0, '', NULL, NULL, NULL),
(43303, '2017-08-21 09:14:28', NULL, NULL, 12225, 0, 181, '116', 'Open Food ', 'Junior BLT', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 09:14:28', 'admin-1503277942-15032780686682488', 1, 0, '', NULL, NULL, NULL),
(43304, '2017-08-21 09:14:35', NULL, NULL, 12225, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 09:14:35', 'admin-1503277942-15032780752963576', 1, 1, 'SR', NULL, NULL, NULL),
(43305, '2017-08-21 09:21:39', NULL, NULL, 12226, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1503296751', 'admin', '2017-08-21 09:21:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43306, '2017-08-21 09:21:49', NULL, NULL, 12226, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 09:21:49', 'admin-1503277942-15032785092873576', 1, 0, '', NULL, NULL, NULL),
(43307, '2017-08-21 09:21:49', NULL, NULL, 12226, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 09:21:49', 'admin-1503277942-15032785092873576', 1, 1, 'SR', NULL, NULL, NULL),
(43308, '2017-08-21 00:00:00', NULL, NULL, 12230, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, NULL, NULL, 2.80, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:02:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43309, '2017-08-21 10:33:46', NULL, NULL, 12231, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:33:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43310, '2017-08-21 10:29:01', NULL, NULL, 12229, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:29:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43311, '2017-08-21 00:00:00', NULL, NULL, 12230, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:02:48', 'admin-1503277942-15032809684566518', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(43312, '2017-08-21 00:00:00', NULL, NULL, 12229, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:02:48', 'admin-1503277942-15032809684566518', 1, 0, '', NULL, NULL, NULL),
(43313, '2017-08-21 10:13:24', NULL, NULL, 12228, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:13:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43314, '2017-08-21 10:13:30', NULL, NULL, 12228, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:13:30', 'admin-1503277942-15032816103831235', 1, 0, '', NULL, NULL, NULL),
(43315, '2017-08-21 10:13:30', NULL, NULL, 12228, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:13:30', 'admin-1503277942-15032816103831235', 1, 1, 'SR', NULL, NULL, NULL),
(43316, '2017-08-21 00:00:00', NULL, NULL, 12229, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:02:55', 'admin-1503277942-15032809752975655', 1, 1, 'SR', NULL, NULL, NULL),
(43317, '2017-08-21 00:00:00', NULL, NULL, 12230, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1503296751', 'admin', '2017-08-21 10:02:55', 'admin-1503277942-15032809752975655', 1, 1, 'SR', NULL, NULL, NULL),
(43318, '2017-08-21 09:14:07', NULL, NULL, 12225, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1503296751', 'admin', '2017-08-21 09:14:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43319, '2017-08-23 15:00:14', NULL, NULL, 12272, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 15:00:14', 'admin-1503465960-15034716138804783', 1, 1, 'SR', NULL, NULL, NULL),
(43320, '2017-08-23 15:00:27', NULL, NULL, 12272, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 15:00:27', 'admin-1503465960-1503471627381828', 1, 0, '', NULL, NULL, NULL),
(43321, '2017-08-23 15:10:48', NULL, NULL, 12273, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1503465960', 'admin', '2017-08-23 15:10:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43322, '2017-08-23 11:51:21', NULL, NULL, 12261, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:51:21', 'admin-1503451445-15034602808351998', 1, 0, '', NULL, NULL, NULL),
(43323, '2017-08-23 11:54:27', NULL, NULL, 12260, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:54:27', 'admin-1503451445-15034604672946071', 1, 0, '', NULL, NULL, NULL),
(43324, '2017-08-23 11:55:44', NULL, NULL, 12260, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:55:44', 'admin-1503451445-15034605443697235', 1, 0, '', NULL, NULL, NULL),
(43325, '2017-08-23 11:56:14', NULL, NULL, 12262, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:56:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43326, '2017-08-23 11:56:42', NULL, NULL, 12262, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:56:42', 'admin-1503460550-15034606024223942', 1, 1, 'SR', NULL, NULL, NULL),
(43327, '2017-08-23 13:22:33', NULL, NULL, 12264, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 13:22:33', 'admin-1503460550-15034657533329480', 1, 0, '', NULL, NULL, NULL),
(43328, '2017-08-23 12:38:49', NULL, NULL, 12264, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 12:38:49', 'admin-1503460550-15034631295225847', 1, 0, '', NULL, NULL, NULL),
(43329, '2017-08-23 12:00:37', NULL, NULL, 12263, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1503465960', 'admin', '2017-08-23 12:00:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43330, '2017-08-23 13:18:15', NULL, NULL, 12267, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 13:18:15', 'admin-1503460550-15034654948906155', 1, 1, 'SR', NULL, NULL, NULL),
(43331, '2017-08-23 13:18:15', NULL, NULL, 12267, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 13:18:15', 'admin-1503460550-15034654948906155', 1, 0, '', NULL, NULL, NULL),
(43332, '2017-08-23 13:22:33', NULL, NULL, 12264, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 13:22:33', 'admin-1503460550-15034657533329480', 1, 1, 'SR', NULL, NULL, NULL),
(43333, '2017-08-23 15:00:02', NULL, NULL, 12272, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1503465960', 'admin', '2017-08-23 15:00:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43334, '2017-08-23 14:42:00', NULL, NULL, 12271, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 14:42:00', 'admin-1503465960-15034705201811652', 1, 1, 'SR', 1, NULL, '10.0'),
(43335, '2017-08-23 15:10:52', NULL, NULL, 12273, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 15:10:52', 'admin-1503465960-1503472252524901', 1, 1, 'SR', NULL, NULL, NULL),
(43336, '2017-08-23 12:07:41', NULL, NULL, 12263, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 12:07:41', 'admin-1503460550-15034612614864685', 1, 0, '', NULL, NULL, NULL),
(43337, '2017-08-23 11:20:25', NULL, NULL, 12258, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:20:25', 'admin-1503451445-15034584248207322', 1, 0, '', NULL, NULL, NULL),
(43338, '2017-08-23 13:37:57', NULL, NULL, 12268, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 13:37:57', 'admin-1503465960-15034666776103225', 1, 1, 'SR', NULL, NULL, NULL),
(43339, '2017-08-23 13:48:13', NULL, NULL, 12269, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1503465960', 'admin', '2017-08-23 13:48:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43340, '2017-08-23 13:48:32', NULL, NULL, 12269, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 13:48:32', 'admin-1503465960-15034673119991917', 1, 0, '', NULL, NULL, NULL),
(43341, '2017-08-23 13:48:32', NULL, NULL, 12269, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 13:48:32', 'admin-1503465960-15034673119991917', 1, 1, 'SR', NULL, NULL, NULL),
(43342, '2017-08-23 12:00:45', NULL, NULL, 12263, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 12:00:45', 'admin-1503460550-15034608448439819', 1, 0, '', NULL, NULL, NULL),
(43343, '2017-08-23 12:51:46', NULL, NULL, 12265, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 12:51:46', 'admin-1503460550-15034639060977475', 1, 0, '', NULL, NULL, NULL),
(43344, '2017-08-23 13:01:26', NULL, NULL, 12266, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1503465960', 'admin', '2017-08-23 13:01:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43345, '2017-08-23 14:09:06', NULL, NULL, 12264, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 14:09:06', 'admin-1503465960-15034685460711989', 1, 0, '', NULL, NULL, NULL),
(43346, '2017-08-23 14:13:02', NULL, NULL, 12270, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1503465960', 'admin', '2017-08-23 14:13:02', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(43347, '2017-08-23 14:13:11', NULL, NULL, 12270, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 14:13:11', 'admin-1503465960-15034687912102445', 1, 0, '', NULL, NULL, '10.0'),
(43348, '2017-08-23 14:13:11', NULL, NULL, 12270, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 14:13:11', 'admin-1503465960-15034687912102445', 1, 0, '', NULL, NULL, '10.0'),
(43349, '2017-08-23 14:42:00', NULL, NULL, 12271, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 14:42:00', 'admin-1503465960-15034705201811652', 1, 0, '', 1, NULL, '10.0'),
(43350, '2017-08-23 11:08:55', NULL, NULL, 12256, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 16.0000, 0.0000, 8.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:08:55', 'admin-1503451445-15034577357666495', 1, 0, '', NULL, NULL, NULL),
(43351, '2017-08-23 11:08:55', NULL, NULL, 12256, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:08:55', 'admin-1503451445-15034577357666495', 1, 0, '', NULL, NULL, NULL),
(43352, '2017-08-23 11:08:55', NULL, NULL, 12256, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:08:55', 'admin-1503451445-15034577357666495', 1, 0, '', NULL, NULL, NULL),
(43353, '2017-08-23 11:16:43', NULL, NULL, 12257, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:16:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43354, '2017-08-23 14:07:38', NULL, NULL, 12269, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 14:07:38', 'admin-1503465960-15034684585802829', 1, 1, 'SR', NULL, NULL, NULL),
(43355, '2017-08-23 13:48:38', NULL, NULL, 12269, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 13:48:38', 'admin-1503465960-15034673179213068', 1, 1, 'SR', NULL, NULL, NULL),
(43356, '2017-08-23 13:37:53', NULL, NULL, 12268, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1503465960', 'admin', '2017-08-23 13:37:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43357, '2017-08-23 13:01:41', NULL, NULL, 12266, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 13:01:41', 'admin-1503460550-15034645012849142', 1, 0, '', NULL, NULL, NULL),
(43358, '2017-08-23 12:51:41', NULL, NULL, 12265, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1503465960', 'admin', '2017-08-23 12:51:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43359, '2017-08-23 12:00:45', NULL, NULL, 12263, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 12:00:45', 'admin-1503460550-15034608448439819', 1, 0, '', NULL, NULL, NULL),
(43360, '2017-08-23 13:17:52', NULL, NULL, 12267, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1503465960', 'admin', '2017-08-23 13:17:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43361, '2017-08-23 13:06:53', NULL, NULL, 12266, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 13:06:53', 'admin-1503460550-15034648136069889', 1, 1, 'SR', NULL, NULL, NULL),
(43362, '2017-08-23 12:38:49', NULL, NULL, 12264, 0, 73, '73', 'Marmite Chicken ', 'ex rice', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 12:38:49', 'admin-1503460550-15034631295225847', 1, 1, 'SR', NULL, NULL, NULL),
(43363, '2017-08-23 12:38:49', NULL, NULL, 12264, 0, 73, '73', 'Marmite Chicken ', 'ex rice', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 12:38:49', 'admin-1503460550-15034631295225847', 1, 1, 'SR', NULL, NULL, NULL),
(43364, '2017-08-23 12:38:20', NULL, NULL, 12264, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 12:38:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43365, '2017-08-23 12:38:49', NULL, NULL, 12264, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', 'ex rice', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 12:38:49', 'admin-1503460550-15034631295225847', 1, 0, '', NULL, NULL, NULL),
(43366, '2017-08-23 11:56:58', NULL, NULL, 12262, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:56:58', 'admin-1503460550-15034606180957721', 1, 1, 'SR', NULL, NULL, NULL),
(43367, '2017-08-23 11:56:42', NULL, NULL, 12262, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:56:42', 'admin-1503460550-15034606024223942', 1, 0, '', NULL, NULL, NULL),
(43368, '2017-08-23 11:56:58', NULL, NULL, 12262, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:56:58', 'admin-1503460550-15034606180957721', 1, 1, 'SR', NULL, NULL, NULL),
(43369, '2017-08-23 11:47:01', NULL, NULL, 12261, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:47:01', 'admin-1503451445-15034600213885756', 1, 1, 'SR', NULL, NULL, NULL),
(43370, '2017-08-23 11:40:59', NULL, NULL, 12259, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:40:59', 'admin-1503451445-15034596597488444', 1, 1, 'SR', NULL, NULL, NULL),
(43371, '2017-08-23 11:46:32', NULL, NULL, 12260, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:46:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43372, '2017-08-23 11:46:42', NULL, NULL, 12260, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:46:42', 'admin-1503451445-15034600019892968', 1, 1, 'SR', NULL, NULL, NULL),
(43373, '2017-08-23 11:56:42', NULL, NULL, 12262, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:56:42', 'admin-1503460550-15034606024223942', 1, 0, '', NULL, NULL, NULL),
(43374, '2017-08-23 11:54:27', NULL, NULL, 12260, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:54:27', 'admin-1503451445-15034604672946071', 1, 1, 'SR', NULL, NULL, NULL),
(43375, '2017-08-23 11:47:01', NULL, NULL, 12261, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:47:01', 'admin-1503451445-15034600213885756', 1, 1, 'SR', NULL, NULL, NULL),
(43376, '2017-08-23 11:46:51', NULL, NULL, 12261, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:46:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43377, '2017-08-23 11:40:59', NULL, NULL, 12259, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:40:59', 'admin-1503451445-15034596597488444', 1, 0, '', NULL, NULL, NULL),
(43378, '2017-08-23 11:40:59', NULL, NULL, 12259, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:40:59', 'admin-1503451445-15034596597488444', 1, 1, 'SR', NULL, NULL, NULL),
(43379, '2017-08-23 11:40:59', NULL, NULL, 12259, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:40:59', 'admin-1503451445-15034596597488444', 1, 0, '', NULL, NULL, NULL),
(43380, '2017-08-23 11:40:59', NULL, NULL, 12259, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:40:59', 'admin-1503451445-15034596597488444', 1, 0, '', NULL, NULL, NULL),
(43381, '2017-08-23 11:40:10', NULL, NULL, 12259, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:40:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43382, '2017-08-23 11:30:53', NULL, NULL, 12256, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:30:53', 'admin-1503451445-15034590530559968', 1, 0, '', NULL, NULL, NULL),
(43383, '2017-08-23 11:20:33', NULL, NULL, 12258, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:20:33', 'admin-1503451445-15034584331899510', 1, 0, '', NULL, NULL, NULL),
(43384, '2017-08-23 11:19:36', NULL, NULL, 12258, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:19:36', 'admin-1503451445-15034583766406125', 1, 1, 'SR', NULL, NULL, NULL),
(43385, '2017-08-23 11:19:30', NULL, NULL, 12258, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:19:30', 'admin-1503451445-15034583707106729', 1, 0, '', NULL, NULL, NULL),
(43386, '2017-08-23 11:19:24', NULL, NULL, 12258, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:19:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43387, '2017-08-23 11:16:48', NULL, NULL, 12257, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:16:48', 'admin-1503451445-15034582079596820', 1, 1, 'SR', NULL, NULL, NULL),
(43388, '2017-08-23 11:08:35', NULL, NULL, 12256, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1503465960', 'admin', '2017-08-23 11:08:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43389, '2017-08-23 10:10:03', NULL, NULL, 12255, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 10:10:03', 'admin-1503451445-15034542031188242', 1, 1, 'SR', NULL, NULL, NULL),
(43390, '2017-08-23 10:10:00', NULL, NULL, 12255, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1503465960', 'admin', '2017-08-23 10:10:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43391, '2017-08-23 09:43:16', NULL, NULL, 12254, 0, 157, '91', 'French Toast with Fruits', 'no fruits', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 09:43:16', 'admin-1503451445-15034525960642686', 1, 0, '', NULL, NULL, NULL),
(43392, '2017-08-23 09:43:21', NULL, NULL, 12254, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503465960', 'admin', '2017-08-23 09:43:21', 'admin-1503451445-1503452601085407', 1, 1, 'SR', NULL, NULL, NULL),
(43393, '2017-08-23 09:43:05', NULL, NULL, 12254, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1503465960', 'admin', '2017-08-23 09:43:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43394, '2017-08-24 14:05:04', NULL, NULL, 12289, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 14:05:04', 'admin-1503554629-15035547041535319', 1, 1, 'SR', NULL, NULL, NULL),
(43395, '2017-08-24 14:15:36', NULL, NULL, 12284, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 14:15:36', 'admin-1503554629-15035553360358437', 1, 1, 'SR', NULL, NULL, '10.0'),
(43396, '2017-08-24 14:21:10', NULL, NULL, 12288, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 14:21:10', 'admin-1503554629-15035556702992836', 1, 1, 'SR', NULL, NULL, NULL),
(43397, '2017-08-24 14:22:50', NULL, NULL, 12290, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1503554629', 'admin', '2017-08-24 14:22:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43398, '2017-08-24 11:51:35', NULL, NULL, 12280, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 11:51:35', 'admin-1503544242-15035466956421877', 1, 1, 'SR', NULL, NULL, NULL),
(43399, '2017-08-24 11:52:10', NULL, NULL, 12280, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 11:52:10', 'admin-1503544242-15035467306091926', 1, 1, 'SR', NULL, NULL, NULL),
(43400, '2017-08-24 13:40:14', NULL, NULL, 12285, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1503554629', 'admin', '2017-08-24 13:40:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43401, '2017-08-24 14:00:29', NULL, NULL, 12286, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1503554629', 'admin', '2017-08-24 14:00:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43402, '2017-08-24 14:00:33', NULL, NULL, 12286, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 14:00:33', 'admin-1503544242-15035544330476373', 1, 1, 'SR', NULL, NULL, NULL),
(43403, '2017-08-24 14:00:37', NULL, NULL, 12287, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 14:00:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43404, '2017-08-24 14:55:22', NULL, NULL, 12284, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 14:55:22', 'admin-1503554629-1503557722392785', 1, 1, 'SR', NULL, NULL, '10.0'),
(43405, '2017-08-24 16:17:29', NULL, NULL, 12287, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 16:17:29', 'admin-1503554629-15035626494519883', 1, 1, 'SR', NULL, NULL, NULL),
(43406, '2017-08-24 16:17:29', NULL, NULL, 12287, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 16:17:29', 'admin-1503554629-15035626494519883', 1, 1, 'SR', NULL, NULL, NULL),
(43407, '2017-08-24 16:50:47', NULL, NULL, 12291, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 16:50:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43408, '2017-08-24 16:50:55', NULL, NULL, 12291, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 2, 15.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 16:50:55', 'admin-1503554629-15035646555857142', 1, 1, 'SR', NULL, NULL, NULL),
(43409, '2017-08-24 14:00:43', NULL, NULL, 12287, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 14:00:43', 'admin-1503544242-15035544430883419', 1, 1, 'SR', NULL, NULL, NULL),
(43410, '2017-08-24 10:06:30', NULL, NULL, 12277, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 10:06:30', 'admin-1503536743-15035403904943390', 1, 0, '', NULL, NULL, NULL),
(43411, '2017-08-24 14:04:56', NULL, NULL, 12289, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1503554629', 'admin', '2017-08-24 14:04:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43412, '2017-08-24 14:05:04', NULL, NULL, 12289, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 14:05:04', 'admin-1503554629-15035547041535319', 1, 1, 'SR', NULL, NULL, NULL),
(43413, '2017-08-24 14:03:33', NULL, NULL, 12288, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 14:03:33', 'admin-1503544242-1503554613482619', 1, 0, '', NULL, NULL, NULL),
(43414, '2017-08-24 14:03:33', NULL, NULL, 12288, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 14:03:33', 'admin-1503544242-1503554613482619', 1, 1, 'SR', NULL, NULL, NULL),
(43415, '2017-08-24 14:03:33', NULL, NULL, 12288, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 14:03:33', 'admin-1503544242-1503554613482619', 1, 1, 'SR', NULL, NULL, NULL),
(43416, '2017-08-24 14:02:56', NULL, NULL, 12288, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1503554629', 'admin', '2017-08-24 14:02:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43417, '2017-08-24 14:03:33', NULL, NULL, 12288, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 14:03:33', 'admin-1503544242-1503554613482619', 1, 0, '', NULL, NULL, NULL),
(43418, '2017-08-24 14:03:33', NULL, NULL, 12288, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 14:03:33', 'admin-1503544242-1503554613482619', 1, 1, 'SR', NULL, NULL, NULL),
(43419, '2017-08-24 14:22:54', NULL, NULL, 12290, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 14:22:54', 'admin-1503554629-15035557739895376', 1, 1, 'SR', NULL, NULL, NULL),
(43420, '2017-08-24 13:40:31', NULL, NULL, 12285, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 13:40:31', 'admin-1503544242-15035532308653038', 1, 1, 'SR', NULL, NULL, NULL),
(43421, '2017-08-24 13:40:31', NULL, NULL, 12285, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 13:40:31', 'admin-1503544242-15035532308653038', 1, 1, 'SR', NULL, NULL, NULL),
(43422, '2017-08-24 13:40:31', NULL, NULL, 12285, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 13:40:31', 'admin-1503544242-15035532308653038', 1, 1, 'SR', NULL, NULL, NULL),
(43423, '2017-08-24 09:22:12', NULL, NULL, 12275, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 09:22:12', 'admin-1503536743-15035377323277491', 1, 1, 'SR', NULL, NULL, NULL),
(43424, '2017-08-24 09:51:02', NULL, NULL, 12276, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1503554629', 'admin', '2017-08-24 09:51:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43425, '2017-08-24 09:51:08', NULL, NULL, 12276, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 09:51:08', 'admin-1503536743-1503539468619328', 1, 0, '', NULL, NULL, NULL),
(43426, '2017-08-24 09:51:08', NULL, NULL, 12276, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 09:51:08', 'admin-1503536743-1503539468619328', 1, 0, '', NULL, NULL, NULL),
(43427, '2017-08-24 09:51:18', NULL, NULL, 12276, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 09:51:18', 'admin-1503536743-15035394781724240', 1, 1, 'SR', NULL, NULL, NULL),
(43428, '2017-08-24 13:41:05', NULL, NULL, 12284, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 13:41:05', 'admin-1503544242-15035532657669172', 1, 0, '', NULL, NULL, '10.0'),
(43429, '2017-08-24 13:41:06', NULL, NULL, 12284, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 13:41:06', 'admin-1503544242-15035532657669172', 1, 0, '', NULL, NULL, '10.0'),
(43430, '2017-08-24 14:03:33', NULL, NULL, 12288, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 14:03:33', 'admin-1503544242-1503554613482619', 1, 1, 'SR', NULL, NULL, NULL),
(43431, '2017-08-24 13:40:31', NULL, NULL, 12285, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 13:40:31', 'admin-1503544242-15035532308653038', 1, 1, 'SR', NULL, NULL, NULL),
(43432, '2017-08-24 12:40:59', NULL, NULL, 12282, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1503554629', 'admin', '2017-08-24 12:40:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43433, '2017-08-24 12:41:03', NULL, NULL, 12282, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 12:41:03', 'admin-1503544242-15035496628195425', 1, 0, '', NULL, NULL, NULL),
(43434, '2017-08-24 13:16:56', NULL, NULL, 12283, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1503554629', 'admin', '2017-08-24 13:16:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43435, '2017-08-24 13:16:59', NULL, NULL, 12283, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 13:16:59', 'admin-1503544242-15035518189321666', 1, 1, 'SR', NULL, NULL, NULL),
(43436, '2017-08-24 11:50:38', NULL, NULL, 12280, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1503554629', 'admin', '2017-08-24 11:50:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43437, '2017-08-24 11:51:28', NULL, NULL, 12280, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 11:51:28', 'admin-1503544242-15035466884151658', 1, 0, '', NULL, NULL, NULL),
(43438, '2017-08-24 13:38:49', NULL, NULL, 12284, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 13:38:49', 'admin-1503544242-15035531288201942', 1, 0, '', NULL, NULL, '10.0'),
(43439, '2017-08-24 13:38:41', NULL, NULL, 12284, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 13:38:41', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(43440, '2017-08-24 11:51:28', NULL, NULL, 12280, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 11:51:28', 'admin-1503544242-15035466884151658', 1, 0, '', NULL, NULL, NULL),
(43441, '2017-08-24 11:07:43', NULL, NULL, 12279, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1503554629', 'admin', '2017-08-24 11:07:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43442, '2017-08-24 11:10:37', NULL, NULL, 12279, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 11:10:37', 'admin-1503536743-15035442372535692', 1, 0, '', NULL, NULL, NULL),
(43443, '2017-08-24 11:11:14', NULL, NULL, 12279, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 11:11:14', 'admin-1503544242-1503544274761672', 1, 0, '', NULL, NULL, NULL),
(43444, '2017-08-24 12:32:55', NULL, NULL, 12281, 0, 73, '73', 'Marmite Chicken ', 'egg welldone', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 12:32:55', 'admin-1503544242-15035491755664848', 1, 1, 'SR', NULL, NULL, '10.0'),
(43445, '2017-08-24 12:33:02', NULL, NULL, 12281, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 12:33:02', 'admin-1503544242-1503549182674916', 1, 1, 'SR', NULL, NULL, '10.0'),
(43446, '2017-08-24 12:32:55', NULL, NULL, 12281, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 12:32:55', 'admin-1503544242-15035491755664848', 1, 0, '', NULL, NULL, '10.0'),
(43447, '2017-08-24 12:33:02', NULL, NULL, 12281, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 12:33:02', 'admin-1503544242-1503549182674916', 1, 0, '', NULL, NULL, '10.0'),
(43448, '2017-08-24 12:32:33', NULL, NULL, 12281, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1503554629', 'admin', '2017-08-24 12:32:33', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(43449, '2017-08-24 10:06:30', NULL, NULL, 12277, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 10:06:30', 'admin-1503536743-15035403904943390', 1, 1, 'SR', NULL, NULL, NULL),
(43450, '2017-08-24 10:11:27', NULL, NULL, 12278, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1503554629', 'admin', '2017-08-24 10:11:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43451, '2017-08-24 10:12:27', NULL, NULL, 12278, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 10:12:27', 'admin-1503536743-15035407472638110', 1, 0, '', NULL, NULL, NULL),
(43452, '2017-08-24 10:12:27', NULL, NULL, 12278, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 10:12:27', 'admin-1503536743-15035407472638110', 1, 0, '', NULL, NULL, NULL),
(43453, '2017-08-24 10:12:36', NULL, NULL, 12278, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 10:12:36', 'admin-1503536743-15035407568131067', 1, 1, 'SR', NULL, NULL, NULL),
(43454, '2017-08-24 10:12:36', NULL, NULL, 12278, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 10:12:36', 'admin-1503536743-15035407568131067', 1, 0, '', NULL, NULL, NULL),
(43455, '2017-08-24 09:22:12', NULL, NULL, 12275, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 09:22:12', 'admin-1503536743-15035377323277491', 1, 1, 'SR', NULL, NULL, NULL),
(43456, '2017-08-24 14:49:49', NULL, NULL, 12290, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 14:49:49', 'admin-1503554629-15035573894354679', 1, 1, 'SR', NULL, NULL, NULL),
(43457, '2017-08-24 10:06:19', NULL, NULL, 12277, 0, 153, '87', 'Wake Me Up!', 'sunny side up', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 10:06:19', 'admin-1503536743-1503540378785978', 1, 0, '', NULL, NULL, NULL),
(43458, '2017-08-24 10:02:32', NULL, NULL, 12277, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1503554629', 'admin', '2017-08-24 10:02:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43459, '2017-08-24 10:06:19', NULL, NULL, 12277, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 10:06:19', 'admin-1503536743-1503540378785978', 1, 0, '', NULL, NULL, NULL),
(43460, '2017-08-24 09:51:18', NULL, NULL, 12276, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 09:51:18', 'admin-1503536743-15035394781724240', 1, 1, 'SR', NULL, NULL, NULL),
(43461, '2017-08-24 09:22:07', NULL, NULL, 12275, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 09:22:07', 'admin-1503536743-15035377268552152', 1, 0, '', NULL, NULL, NULL),
(43462, '2017-08-24 09:22:07', NULL, NULL, 12275, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 09:22:07', 'admin-1503536743-15035377268552152', 1, 0, '', NULL, NULL, NULL),
(43463, '2017-08-24 09:20:29', NULL, NULL, 12274, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 09:20:29', 'admin-1503536743-15035376294374063', 1, 1, 'SR', NULL, NULL, NULL),
(43464, '2017-08-24 09:21:57', NULL, NULL, 12275, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1503554629', 'admin', '2017-08-24 09:21:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43465, '2017-08-24 09:20:29', NULL, NULL, 12274, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503554629', 'admin', '2017-08-24 09:20:29', 'admin-1503536743-15035376294374063', 1, 0, '', NULL, NULL, NULL),
(43466, '2017-08-24 09:05:52', NULL, NULL, 12274, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1503554629', 'admin', '2017-08-24 09:05:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43467, '2017-08-25 16:34:40', NULL, NULL, 12318, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1503643027', 'admin', '2017-08-25 16:34:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43468, '2017-08-25 16:34:49', NULL, NULL, 12318, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 16:34:49', 'admin-1503643027-15036500896045984', 1, 1, 'SR', NULL, NULL, NULL),
(43469, '2017-08-25 16:34:53', NULL, NULL, 12318, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 16:34:53', 'admin-1503643027-15036500937018864', 1, 0, '', NULL, NULL, NULL),
(43470, '2017-08-25 16:36:32', NULL, NULL, 12318, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 16:36:32', 'admin-1503643027-15036501925956471', 1, 0, '', NULL, NULL, NULL),
(43471, '2017-08-25 13:13:37', NULL, NULL, 12308, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:13:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43472, '2017-08-25 13:15:09', NULL, NULL, 12308, 0, 181, '116', 'Open Food ', 'soup noodle', 'Meals', 'Perfect Meals', 2, 15.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:15:09', 'admin-1503632165-1503638109182131', 1, 0, '', NULL, NULL, NULL),
(43473, '2017-08-25 13:15:09', NULL, NULL, 12308, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:15:09', 'admin-1503632165-1503638109182131', 1, 0, '', NULL, NULL, NULL),
(43474, '2017-08-25 13:15:09', NULL, NULL, 12308, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:15:09', 'admin-1503632165-1503638109182131', 1, 0, '', NULL, NULL, NULL),
(43475, '2017-08-25 13:15:09', NULL, NULL, 12308, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:15:09', 'admin-1503632165-1503638109182131', 1, 1, 'SR', NULL, NULL, NULL),
(43476, '2017-08-25 13:15:09', NULL, NULL, 12308, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:15:09', 'admin-1503632165-1503638109182131', 1, 1, 'SR', NULL, NULL, NULL),
(43477, '2017-08-25 13:20:26', NULL, NULL, 12309, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:20:26', 'admin-1503638117-15036384265152116', 1, 1, 'SR', NULL, NULL, NULL),
(43478, '2017-08-25 13:20:26', NULL, NULL, 12309, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:20:26', 'admin-1503638117-15036384265152116', 1, 1, 'SR', NULL, NULL, NULL),
(43479, '2017-08-25 16:50:03', NULL, NULL, 12319, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 16:50:03', 'admin-1503643027-15036510029457762', 1, 0, '', NULL, NULL, NULL),
(43480, '2017-08-25 17:00:48', NULL, NULL, 12320, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1503643027', 'admin', '2017-08-25 17:00:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43481, '2017-08-25 17:00:54', NULL, NULL, 12320, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 17:00:54', 'admin-1503643027-15036516543964470', 1, 1, 'SR', NULL, NULL, NULL),
(43482, '2017-08-25 17:00:54', NULL, NULL, 12320, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 17:00:54', 'admin-1503643027-15036516543964470', 1, 1, 'SR', NULL, NULL, NULL),
(43483, '2017-08-25 15:00:05', NULL, NULL, 12314, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 15:00:05', 'admin-1503643027-15036444057159529', 1, 1, 'SR', NULL, NULL, NULL),
(43484, '2017-08-25 14:37:42', NULL, NULL, 12313, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 14:37:42', 'admin-1503643027-15036430617925561', 1, 1, 'SR', NULL, NULL, NULL),
(43485, '2017-08-25 14:59:59', NULL, NULL, 12314, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1503643027', 'admin', '2017-08-25 14:59:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43486, '2017-08-25 14:37:42', NULL, NULL, 12313, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 14:37:42', 'admin-1503643027-15036430617925561', 1, 0, '', NULL, NULL, NULL),
(43487, '2017-08-25 14:37:42', NULL, NULL, 12313, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 14:37:42', 'admin-1503643027-15036430617925561', 1, 1, 'SR', NULL, NULL, NULL),
(43488, '2017-08-25 13:15:09', NULL, NULL, 12308, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:15:09', 'admin-1503632165-1503638109182131', 1, 0, '', NULL, NULL, NULL),
(43489, '2017-08-25 13:19:53', NULL, NULL, 12309, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:19:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43490, '2017-08-25 15:37:19', NULL, NULL, 12316, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 15:37:19', 'admin-1503643027-1503646639047172', 1, 1, 'SR', NULL, NULL, '10.0'),
(43491, '2017-08-25 15:45:27', NULL, NULL, 12317, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1503643027', 'admin', '2017-08-25 15:45:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43492, '2017-08-25 15:45:41', NULL, NULL, 12317, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 15:45:41', 'admin-1503643027-15036471411907772', 1, 0, '', NULL, NULL, NULL),
(43493, '2017-08-25 15:45:41', NULL, NULL, 12317, 0, 181, '116', 'Open Food ', 'Noodle soup', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 15:45:41', 'admin-1503643027-15036471411907772', 1, 0, '', NULL, NULL, NULL),
(43494, '2017-08-25 15:45:54', NULL, NULL, 12317, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 15:45:54', 'admin-1503643027-15036471546055721', 1, 1, 'SR', NULL, NULL, NULL),
(43495, '2017-08-25 15:45:54', NULL, NULL, 12317, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 15:45:54', 'admin-1503643027-15036471546055721', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(43496, '2017-08-25 14:24:27', NULL, NULL, 12312, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 14:24:27', 'admin-1503638117-1503642267739276', 1, 1, 'SR', NULL, NULL, NULL),
(43497, '2017-08-25 14:24:27', NULL, NULL, 12312, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 14:24:27', 'admin-1503638117-1503642267739276', 1, 1, 'SR', NULL, NULL, NULL),
(43498, '2017-08-25 14:24:27', NULL, NULL, 12312, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 14:24:27', 'admin-1503638117-1503642267739276', 1, 1, 'SR', NULL, NULL, NULL),
(43499, '2017-08-25 14:24:27', NULL, NULL, 12312, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 14:24:27', 'admin-1503638117-1503642267739276', 1, 0, '', NULL, NULL, NULL),
(43500, '2017-08-25 14:36:12', NULL, NULL, 12313, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1503643027', 'admin', '2017-08-25 14:36:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43501, '2017-08-25 14:24:07', NULL, NULL, 12312, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 14:24:07', 'admin-1503638117-15036422471901060', 1, 1, 'SR', NULL, NULL, NULL),
(43502, '2017-08-25 12:11:15', NULL, NULL, 12303, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1503643027', 'admin', '2017-08-25 12:11:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43503, '2017-08-25 12:11:47', NULL, NULL, 12303, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 12:11:47', 'admin-1503632165-15036343071198134', 1, 0, '', NULL, NULL, NULL),
(43504, '2017-08-25 14:36:59', NULL, NULL, 12313, 0, 181, '116', 'Open Food ', 'soup noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 14:36:59', 'admin-1503638117-15036430196039049', 1, 0, '', NULL, NULL, NULL),
(43505, '2017-08-25 14:36:59', NULL, NULL, 12313, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 14:36:59', 'admin-1503638117-15036430196039049', 1, 1, 'SR', NULL, NULL, NULL),
(43506, '2017-08-25 10:32:37', NULL, NULL, 12294, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 10:32:37', 'admin-1503622823-15036283573684287', 1, 0, '', NULL, NULL, NULL),
(43507, '2017-08-25 12:14:31', NULL, NULL, 12304, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1503643027', 'admin', '2017-08-25 12:14:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43508, '2017-08-25 12:14:51', NULL, NULL, 12304, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 12:14:51', 'admin-1503632165-15036344916541275', 1, 1, 'SR', NULL, NULL, NULL),
(43509, '2017-08-25 15:37:19', NULL, NULL, 12316, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 15:37:19', 'admin-1503643027-1503646639047172', 1, 0, '', NULL, NULL, '10.0'),
(43510, '2017-08-25 13:20:26', NULL, NULL, 12309, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:20:26', 'admin-1503638117-15036384265152116', 1, 1, 'SR', NULL, NULL, NULL),
(43511, '2017-08-25 14:24:07', NULL, NULL, 12312, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 14:24:07', 'admin-1503638117-15036422471901060', 1, 0, '', NULL, NULL, NULL),
(43512, '2017-08-25 14:09:05', NULL, NULL, 12311, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1503643027', 'admin', '2017-08-25 14:09:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43513, '2017-08-25 14:16:15', NULL, NULL, 12311, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 14:16:15', 'admin-1503638117-15036417753121582', 1, 1, 'SR', NULL, NULL, NULL),
(43514, '2017-08-25 13:15:09', NULL, NULL, 12308, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:15:09', 'admin-1503632165-1503638109182131', 1, 1, 'SR', NULL, NULL, NULL),
(43515, '2017-08-25 11:35:42', NULL, NULL, 12301, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1503643027', 'admin', '2017-08-25 11:35:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43516, '2017-08-25 11:35:57', NULL, NULL, 12301, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 11:35:57', 'admin-1503622823-1503632157157642', 1, 0, '', NULL, NULL, NULL),
(43517, '2017-08-25 11:35:57', NULL, NULL, 12301, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 11:35:57', 'admin-1503622823-1503632157157642', 1, 1, 'SR', NULL, NULL, NULL),
(43518, '2017-08-25 11:39:55', NULL, NULL, 12299, 0, 153, '87', 'Wake Me Up!', 'Takeaway', 'Meals', 'Morning Bites ', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 11:39:55', 'admin-1503632165-15036323952851892', 1, 0, '', NULL, NULL, NULL),
(43519, '2017-08-25 11:41:39', NULL, NULL, 12302, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1503643027', 'admin', '2017-08-25 11:41:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43520, '2017-08-25 11:41:58', NULL, NULL, 12302, 0, 153, '87', 'Wake Me Up!', 'sunny side up', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 11:41:58', 'admin-1503632165-1503632518682191', 1, 0, '', NULL, NULL, NULL),
(43521, '2017-08-25 10:34:13', NULL, NULL, 12295, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 10:34:13', 'admin-1503622823-15036284535289530', 1, 1, 'SR', NULL, NULL, NULL),
(43522, '2017-08-25 14:24:07', NULL, NULL, 12312, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 14:24:07', 'admin-1503638117-15036422471901060', 1, 0, '', NULL, NULL, NULL),
(43523, '2017-08-25 14:18:11', NULL, NULL, 12311, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 14:18:11', 'admin-1503638117-15036418911292997', 1, 1, 'SR', NULL, NULL, NULL),
(43524, '2017-08-25 14:18:11', NULL, NULL, 12311, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 14:18:11', 'admin-1503638117-15036418911292997', 1, 1, 'SR', NULL, NULL, NULL),
(43525, '2017-08-25 13:08:41', NULL, NULL, 12307, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:08:41', 'admin-1503632165-15036377213533868', 1, 1, 'SR', NULL, NULL, NULL),
(43526, '2017-08-25 13:08:41', NULL, NULL, 12307, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:08:41', 'admin-1503632165-15036377213533868', 1, 1, 'SR', NULL, NULL, NULL),
(43527, '2017-08-25 12:14:51', NULL, NULL, 12304, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 12:14:51', 'admin-1503632165-15036344916541275', 1, 0, '', NULL, NULL, NULL),
(43528, '2017-08-25 12:19:26', NULL, NULL, 12301, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 12:19:26', 'admin-1503632165-1503634766415945', 1, 1, 'SR', NULL, NULL, NULL),
(43529, '2017-08-25 12:20:58', NULL, NULL, 12304, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 12:20:58', 'admin-1503632165-1503634858290774', 1, 1, 'SR', NULL, NULL, NULL),
(43530, '2017-08-25 16:49:59', NULL, NULL, 12319, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1503643027', 'admin', '2017-08-25 16:49:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43531, '2017-08-25 15:16:59', NULL, NULL, 12315, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1503643027', 'admin', '2017-08-25 15:16:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43532, '2017-08-25 15:17:07', NULL, NULL, 12315, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 15:17:07', 'admin-1503643027-15036454267419917', 1, 1, 'SR', NULL, NULL, NULL),
(43533, '2017-08-25 15:17:07', NULL, NULL, 12315, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 15:17:07', 'admin-1503643027-15036454267419917', 1, 1, 'SR', NULL, NULL, NULL),
(43534, '2017-08-25 15:29:16', NULL, NULL, 12316, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1503643027', 'admin', '2017-08-25 15:29:16', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(43535, '2017-08-25 15:29:39', NULL, NULL, 12316, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 15:29:39', 'admin-1503643027-15036461793796870', 1, 0, '', NULL, NULL, '10.0'),
(43536, '2017-08-25 15:29:39', NULL, NULL, 12316, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 15:29:39', 'admin-1503643027-15036461793796870', 1, 1, 'SR', NULL, NULL, '10.0'),
(43537, '2017-08-25 15:29:39', NULL, NULL, 12316, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 15:29:39', 'admin-1503643027-15036461793796870', 1, 0, '', NULL, NULL, '10.0'),
(43538, '2017-08-25 14:17:23', NULL, NULL, 12311, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 14:17:23', 'admin-1503638117-1503641842977458', 1, 1, 'SR', NULL, NULL, NULL),
(43539, '2017-08-25 14:17:23', NULL, NULL, 12311, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 14:17:23', 'admin-1503638117-1503641842977458', 1, 0, '', NULL, NULL, NULL),
(43540, '2017-08-25 11:08:32', NULL, NULL, 12298, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 11:08:32', 'admin-1503622823-15036305125623493', 1, 0, '', NULL, NULL, NULL),
(43541, '2017-08-25 11:08:32', NULL, NULL, 12298, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 11:08:32', 'admin-1503622823-15036305125623493', 1, 0, '', NULL, NULL, NULL),
(43542, '2017-08-25 11:08:32', NULL, NULL, 12298, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 11:08:32', 'admin-1503622823-15036305125623493', 1, 1, 'SR', NULL, NULL, NULL),
(43543, '2017-08-25 14:36:59', NULL, NULL, 12313, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 14:36:59', 'admin-1503638117-15036430196039049', 1, 0, '', NULL, NULL, NULL),
(43544, '2017-08-25 13:43:30', NULL, NULL, 12310, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:43:30', 'admin-1503638117-15036398106529240', 1, 1, 'SR', NULL, NULL, NULL),
(43545, '2017-08-25 13:43:30', NULL, NULL, 12310, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:43:30', 'admin-1503638117-15036398106529240', 1, 1, 'SR', NULL, NULL, NULL),
(43546, '2017-08-25 13:20:26', NULL, NULL, 12309, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:20:26', 'admin-1503638117-15036384265152116', 1, 1, 'SR', NULL, NULL, NULL),
(43547, '2017-08-25 13:43:24', NULL, NULL, 12310, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:43:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43548, '2017-08-25 13:06:30', NULL, NULL, 12306, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:06:30', 'admin-1503632165-1503637590713190', 1, 1, 'SR', NULL, NULL, NULL),
(43549, '2017-08-25 13:08:29', NULL, NULL, 12307, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:08:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43550, '2017-08-25 13:06:30', NULL, NULL, 12306, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:06:30', 'admin-1503632165-1503637590713190', 1, 1, 'SR', NULL, NULL, NULL),
(43551, '2017-08-25 13:06:21', NULL, NULL, 12306, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:06:21', 'admin-1503632165-15036375816439470', 1, 1, 'SR', NULL, NULL, NULL),
(43552, '2017-08-25 13:06:21', NULL, NULL, 12306, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:06:21', 'admin-1503632165-15036375816439470', 1, 0, '', NULL, NULL, NULL),
(43553, '2017-08-25 12:57:38', NULL, NULL, 12306, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 12:57:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43554, '2017-08-25 12:42:35', NULL, NULL, 12305, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 12:42:35', 'admin-1503632165-15036361550899133', 1, 1, 'SR', NULL, NULL, NULL),
(43555, '2017-08-25 13:15:09', NULL, NULL, 12308, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:15:09', 'admin-1503632165-1503638109182131', 1, 0, '', NULL, NULL, NULL),
(43556, '2017-08-25 12:38:16', NULL, NULL, 12303, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 12:38:16', 'admin-1503632165-15036358962783392', 1, 1, 'SR', NULL, NULL, NULL),
(43557, '2017-08-25 12:26:57', NULL, NULL, 12305, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 12:26:57', 'admin-1503632165-15036352173455548', 1, 1, 'SR', NULL, NULL, NULL),
(43558, '2017-08-25 12:26:52', NULL, NULL, 12305, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1503643027', 'admin', '2017-08-25 12:26:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43559, '2017-08-25 14:23:52', NULL, NULL, 12312, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1503643027', 'admin', '2017-08-25 14:23:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43560, '2017-08-25 13:06:21', NULL, NULL, 12306, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 13:06:21', 'admin-1503632165-15036375816439470', 1, 1, 'SR', NULL, NULL, NULL),
(43561, '2017-08-25 12:14:51', NULL, NULL, 12304, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 12:14:51', 'admin-1503632165-15036344916541275', 1, 1, 'SR', NULL, NULL, NULL),
(43562, '2017-08-25 11:10:42', NULL, NULL, 12299, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1503643027', 'admin', '2017-08-25 11:10:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43563, '2017-08-25 11:10:53', NULL, NULL, 12299, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 11:10:53', 'admin-1503622823-15036306535173456', 1, 1, 'SR', NULL, NULL, NULL),
(43564, '2017-08-25 11:10:53', NULL, NULL, 12299, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 11:10:53', 'admin-1503622823-15036306535173456', 1, 0, '', NULL, NULL, NULL),
(43565, '2017-08-25 11:20:12', NULL, NULL, 12300, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1503643027', 'admin', '2017-08-25 11:20:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43566, '2017-08-25 11:08:14', NULL, NULL, 12298, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1503643027', 'admin', '2017-08-25 11:08:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43567, '2017-08-25 10:57:09', NULL, NULL, 12296, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 10:57:09', 'admin-1503622823-15036298296706353', 1, 1, 'SR', NULL, NULL, NULL),
(43568, '2017-08-25 10:58:43', NULL, NULL, 12297, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1503643027', 'admin', '2017-08-25 10:58:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43569, '2017-08-25 10:58:51', NULL, NULL, 12297, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 10:58:51', 'admin-1503622823-15036299316374497', 1, 1, 'SR', NULL, NULL, NULL),
(43570, '2017-08-25 10:57:09', NULL, NULL, 12296, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 10:57:09', 'admin-1503622823-15036298296706353', 1, 0, '', NULL, NULL, NULL),
(43571, '2017-08-25 10:34:13', NULL, NULL, 12295, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 10:34:13', 'admin-1503622823-15036284535289530', 1, 1, 'SR', NULL, NULL, NULL),
(43572, '2017-08-25 10:56:39', NULL, NULL, 12296, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1503643027', 'admin', '2017-08-25 10:56:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43573, '2017-08-25 11:41:58', NULL, NULL, 12302, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 11:41:58', 'admin-1503632165-1503632518682191', 1, 0, '', NULL, NULL, NULL),
(43574, '2017-08-25 11:41:58', NULL, NULL, 12302, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 11:41:58', 'admin-1503632165-1503632518682191', 1, 1, 'SR', NULL, NULL, NULL),
(43575, '2017-08-25 11:41:58', NULL, NULL, 12302, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 11:41:58', 'admin-1503632165-1503632518682191', 1, 0, '', NULL, NULL, NULL),
(43576, '2017-08-25 11:20:25', NULL, NULL, 12300, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 11:20:25', 'admin-1503622823-15036312257931198', 1, 1, 'SR', NULL, NULL, NULL),
(43577, '2017-08-25 11:20:25', NULL, NULL, 12300, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 11:20:25', 'admin-1503622823-15036312257931198', 1, 1, 'SR', NULL, NULL, NULL),
(43578, '2017-08-25 11:08:32', NULL, NULL, 12298, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 11:08:32', 'admin-1503622823-15036305125623493', 1, 1, 'SR', NULL, NULL, NULL),
(43579, '2017-08-25 10:57:09', NULL, NULL, 12296, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 10:57:09', 'admin-1503622823-15036298296706353', 1, 0, '', NULL, NULL, NULL),
(43580, '2017-08-25 09:04:10', NULL, NULL, 12292, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 09:04:10', 'admin-1503622823-15036230500255188', 1, 1, 'SR', NULL, NULL, NULL),
(43581, '2017-08-25 09:04:10', NULL, NULL, 12292, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 09:04:10', 'admin-1503622823-15036230500255188', 1, 1, 'SR', NULL, NULL, NULL),
(43582, '2017-08-25 09:04:10', NULL, NULL, 12292, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 09:04:10', 'admin-1503622823-15036230500255188', 1, 1, 'SR', NULL, NULL, NULL),
(43583, '2017-08-25 09:52:11', NULL, NULL, 12293, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 09:52:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43584, '2017-08-25 10:32:24', NULL, NULL, 12294, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1503643027', 'admin', '2017-08-25 10:32:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43585, '2017-08-25 10:57:09', NULL, NULL, 12296, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 10:57:09', 'admin-1503622823-15036298296706353', 1, 0, '', NULL, NULL, NULL),
(43586, '2017-08-25 10:32:37', NULL, NULL, 12294, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 10:32:37', 'admin-1503622823-15036283573684287', 1, 1, 'SR', NULL, NULL, NULL),
(43587, '2017-08-25 10:33:41', NULL, NULL, 12295, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1503643027', 'admin', '2017-08-25 10:33:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43588, '2017-08-25 10:34:13', NULL, NULL, 12295, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 10:34:13', 'admin-1503622823-15036284535289530', 1, 0, '', NULL, NULL, NULL),
(43589, '2017-08-25 10:34:13', NULL, NULL, 12295, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 10:34:13', 'admin-1503622823-15036284535289530', 1, 1, 'SR', NULL, NULL, NULL),
(43590, '2017-08-25 09:52:28', NULL, NULL, 12293, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 09:52:28', 'admin-1503622823-15036259481061690', 1, 0, '', NULL, NULL, NULL),
(43591, '2017-08-25 09:52:28', NULL, NULL, 12293, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 09:52:28', 'admin-1503622823-15036259481061690', 1, 0, '', NULL, NULL, NULL),
(43592, '2017-08-25 09:52:45', NULL, NULL, 12293, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 09:52:45', 'admin-1503622823-15036259650575675', 1, 1, 'SR', NULL, NULL, NULL),
(43593, '2017-08-25 09:52:45', NULL, NULL, 12293, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 09:52:45', 'admin-1503622823-15036259650575675', 1, 1, 'SR', NULL, NULL, NULL),
(43594, '2017-08-25 09:04:03', NULL, NULL, 12292, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 09:04:03', 'admin-1503622823-15036230436413317', 1, 0, '', NULL, NULL, NULL),
(43595, '2017-08-25 09:04:03', NULL, NULL, 12292, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503643027', 'admin', '2017-08-25 09:04:03', 'admin-1503622823-15036230436413317', 1, 0, '', NULL, NULL, NULL),
(43596, '2017-08-25 09:03:21', NULL, NULL, 12292, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1503643027', 'admin', '2017-08-25 09:03:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43597, '2017-08-26 15:10:54', NULL, NULL, 12354, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1503731258', 'admin', '2017-08-26 15:10:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43598, '2017-08-26 15:11:00', NULL, NULL, 12354, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 15:11:00', 'admin-1503731258-1503731460469296', 1, 1, 'SR', NULL, NULL, NULL),
(43599, '2017-08-26 15:11:00', NULL, NULL, 12354, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 15:11:00', 'admin-1503731258-1503731460469296', 1, 1, 'SR', NULL, NULL, NULL),
(43600, '2017-08-26 15:22:53', NULL, NULL, 12355, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1503731258', 'admin', '2017-08-26 15:22:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43601, '2017-08-26 15:23:55', NULL, NULL, 12355, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 15:23:55', 'admin-1503731258-15037322349356548', 1, 0, '', NULL, NULL, NULL),
(43602, '2017-08-26 15:23:55', NULL, NULL, 12355, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 15:23:55', 'admin-1503731258-15037322349356548', 1, 1, 'SR', NULL, NULL, NULL),
(43603, '2017-08-26 15:47:55', NULL, NULL, 12356, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1503731258', 'admin', '2017-08-26 15:47:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43604, '2017-08-26 15:48:03', NULL, NULL, 12356, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 15:48:03', 'admin-1503731258-15037336832587674', 1, 0, '', NULL, NULL, NULL),
(43605, '2017-08-26 15:48:47', NULL, NULL, 12356, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 15:48:47', 'admin-1503731258-1503733727275872', 1, 0, '', NULL, NULL, NULL),
(43606, '2017-08-26 15:48:47', NULL, NULL, 12356, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 15:48:47', 'admin-1503731258-1503733727275872', 1, 1, 'SR', NULL, NULL, NULL),
(43607, '2017-08-26 12:17:25', NULL, NULL, 12345, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:17:25', 'admin-1503718638-15037210454087638', 1, 0, '', NULL, NULL, NULL),
(43608, '2017-08-26 12:17:25', NULL, NULL, 12345, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:17:25', 'admin-1503718638-15037210454087638', 1, 1, 'SR', NULL, NULL, NULL),
(43609, '2017-08-26 12:17:25', NULL, NULL, 12345, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:17:25', 'admin-1503718638-15037210454087638', 1, 1, 'SR', NULL, NULL, NULL),
(43610, '2017-08-26 12:18:43', NULL, NULL, 12346, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:18:43', 'admin-1503718638-15037211232929485', 1, 1, 'SR', NULL, NULL, NULL),
(43611, '2017-08-26 11:31:46', NULL, NULL, 12337, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:31:46', 'admin-1503715959-15037183061315436', 1, 0, '', NULL, NULL, NULL),
(43612, '2017-08-26 11:26:12', NULL, NULL, 12336, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:26:12', 'admin-1503715959-15037179725441773', 1, 0, '', NULL, NULL, NULL),
(43613, '2017-08-26 11:26:12', NULL, NULL, 12336, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:26:12', 'admin-1503715959-15037179725441773', 1, 1, 'SR', NULL, NULL, NULL),
(43614, '2017-08-26 11:26:12', NULL, NULL, 12336, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:26:12', 'admin-1503715959-15037179725441773', 1, 0, '', NULL, NULL, NULL),
(43615, '2017-08-26 11:31:31', NULL, NULL, 12337, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:31:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43616, '2017-08-26 13:39:44', NULL, NULL, 12347, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 13:39:44', 'lois-1503722221-15037259841428918', 1, 0, '', NULL, NULL, NULL),
(43617, '2017-08-26 13:43:16', NULL, NULL, 12347, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 13:43:16', 'lois-1503722221-15037261958484210', 1, 1, 'SR', NULL, NULL, NULL),
(43618, '2017-08-26 13:54:18', NULL, NULL, 12349, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 13:54:18', 'lois-1503722221-15037268581023834', 1, 0, '', NULL, NULL, '10.0'),
(43619, '2017-08-26 13:54:28', NULL, NULL, 12349, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 13:54:28', 'lois-1503722221-1503726868702725', 1, 0, '', NULL, NULL, '10.0'),
(43620, '2017-08-26 15:07:26', NULL, NULL, 12353, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 15:07:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43621, '2017-08-26 11:34:43', NULL, NULL, 12338, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:34:43', 'admin-1503715959-15037184834336222', 1, 1, 'SR', NULL, NULL, NULL),
(43622, '2017-08-26 11:34:43', NULL, NULL, 12338, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:34:43', 'admin-1503715959-15037184834336222', 1, 0, '', NULL, NULL, NULL),
(43623, '2017-08-26 11:37:10', NULL, NULL, 12335, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:37:10', 'admin-1503715959-1503718629811903', 1, 1, 'SR', NULL, NULL, NULL),
(43624, '2017-08-26 11:38:27', NULL, NULL, 12335, 0, 181, '116', 'Open Food ', 'Noodles Soup', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:38:27', 'admin-1503718638-15037187070582196', 1, 0, '', NULL, NULL, NULL),
(43625, '2017-08-26 12:47:20', NULL, NULL, 12348, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 12:47:20', 'lois-1503722221-15037228399816620', 1, 0, '', NULL, NULL, NULL),
(43626, '2017-08-26 12:11:27', NULL, NULL, 12344, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:11:27', 'admin-1503718638-15037206870502347', 1, 1, 'SR', NULL, NULL, NULL),
(43627, '2017-08-26 12:11:27', NULL, NULL, 12344, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:11:27', 'admin-1503718638-15037206870502347', 1, 1, 'SR', NULL, NULL, NULL),
(43628, '2017-08-26 12:45:58', NULL, NULL, 12342, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 12:45:58', 'lois-1503722221-15037227587927681', 1, 1, 'SR', NULL, NULL, NULL),
(43629, '2017-08-26 12:46:55', NULL, NULL, 12348, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1503731258', 'lois', '2017-08-26 12:46:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43630, '2017-08-26 14:56:45', NULL, NULL, 12352, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 14:56:45', 'lois-1503722221-15037306048765127', 1, 1, 'SR', NULL, NULL, NULL),
(43631, '2017-08-26 14:58:34', NULL, NULL, 12352, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 14:58:34', 'lois-1503722221-1503730714621719', 1, 0, '', NULL, NULL, NULL),
(43632, '2017-08-26 12:01:39', NULL, NULL, 12343, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:01:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43633, '2017-08-26 12:01:56', NULL, NULL, 12343, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:01:56', 'admin-1503718638-1503720116546220', 1, 1, 'SR', NULL, NULL, NULL),
(43634, '2017-08-26 12:01:56', NULL, NULL, 12343, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:01:56', 'admin-1503718638-1503720116546220', 1, 1, 'SR', NULL, NULL, NULL),
(43635, '2017-08-26 12:01:56', NULL, NULL, 12343, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:01:56', 'admin-1503718638-1503720116546220', 1, 1, 'SR', NULL, NULL, NULL),
(43636, '2017-08-26 11:59:38', NULL, NULL, 12342, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:59:38', 'admin-1503718638-15037199778407487', 1, 1, 'SR', NULL, NULL, NULL),
(43637, '2017-08-26 14:56:45', NULL, NULL, 12352, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 14:56:45', 'lois-1503722221-15037306048765127', 1, 0, '', NULL, NULL, NULL),
(43638, '2017-08-26 12:34:25', NULL, NULL, 12347, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:34:25', 'admin-1503718638-15037220656718457', 1, 0, '', NULL, NULL, NULL),
(43639, '2017-08-26 12:34:25', NULL, NULL, 12347, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:34:25', 'admin-1503718638-15037220656718457', 1, 0, '', NULL, NULL, NULL),
(43640, '2017-08-26 12:34:25', NULL, NULL, 12347, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:34:25', 'admin-1503718638-15037220656718457', 1, 0, '', NULL, NULL, NULL),
(43641, '2017-08-26 11:44:53', NULL, NULL, 12338, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:44:53', 'admin-1503718638-15037190937242584', 1, 1, 'SR', NULL, NULL, NULL),
(43642, '2017-08-26 12:34:25', NULL, NULL, 12347, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:34:25', 'admin-1503718638-15037220656718457', 1, 0, '', NULL, NULL, NULL),
(43643, '2017-08-26 11:46:16', NULL, NULL, 12339, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:46:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43644, '2017-08-26 12:34:15', NULL, NULL, 12347, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.20, 0.0000, 0.0000, 11.20, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:34:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43645, '2017-08-26 12:24:12', NULL, NULL, 12346, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:24:12', 'admin-1503718638-15037214524863285', 1, 0, '', NULL, NULL, NULL),
(43646, '2017-08-26 12:18:43', NULL, NULL, 12346, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:18:43', 'admin-1503718638-15037211232929485', 1, 1, 'SR', NULL, NULL, NULL),
(43647, '2017-08-26 12:18:43', NULL, NULL, 12346, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:18:43', 'admin-1503718638-15037211232929485', 1, 1, 'SR', NULL, NULL, NULL),
(43648, '2017-08-26 12:47:20', NULL, NULL, 12348, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 12:47:20', 'lois-1503722221-15037228399816620', 1, 0, '', NULL, NULL, NULL),
(43649, '2017-08-26 12:47:20', NULL, NULL, 12348, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 12:47:20', 'lois-1503722221-15037228399816620', 1, 1, 'SR', NULL, NULL, NULL),
(43650, '2017-08-26 12:47:20', NULL, NULL, 12348, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 12:47:20', 'lois-1503722221-15037228399816620', 1, 1, 'SR', NULL, NULL, NULL),
(43651, '2017-08-26 12:47:20', NULL, NULL, 12348, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 12:47:20', 'lois-1503722221-15037228399816620', 1, 1, 'SR', NULL, NULL, NULL),
(43652, '2017-08-26 12:18:43', NULL, NULL, 12346, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:18:43', 'admin-1503718638-15037211232929485', 1, 1, 'SR', NULL, NULL, NULL),
(43653, '2017-08-26 12:30:35', NULL, NULL, 12335, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:30:35', 'admin-1503718638-15037218350665570', 1, 0, '', NULL, NULL, NULL),
(43654, '2017-08-26 12:18:43', NULL, NULL, 12346, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:18:43', 'admin-1503718638-15037211232929485', 1, 0, '', NULL, NULL, NULL),
(43655, '2017-08-26 12:18:43', NULL, NULL, 12346, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:18:43', 'admin-1503718638-15037211232929485', 1, 0, '', NULL, NULL, NULL),
(43656, '2017-08-26 11:53:30', NULL, NULL, 12340, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:53:30', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(43657, '2017-08-26 12:17:25', NULL, NULL, 12345, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:17:25', 'admin-1503718638-15037210454087638', 1, 0, '', NULL, NULL, NULL),
(43658, '2017-08-26 10:08:35', NULL, NULL, 12329, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 10:08:35', 'admin-1503712207-1503713315651188', 1, 1, 'SR', NULL, NULL, NULL),
(43659, '2017-08-26 12:17:25', NULL, NULL, 12345, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:17:25', 'admin-1503718638-15037210454087638', 1, 0, '', NULL, NULL, NULL),
(43660, '2017-08-26 12:17:39', NULL, NULL, 12346, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.10, 0.0000, 0.0000, 11.10, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:17:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43661, '2017-08-26 15:00:12', NULL, NULL, 12347, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 15:00:12', 'lois-1503722221-15037308128107918', 1, 0, '', NULL, NULL, NULL),
(43662, '2017-08-26 15:48:03', NULL, NULL, 12356, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 15:48:03', 'admin-1503731258-15037336832587674', 1, 0, '', NULL, NULL, NULL),
(43663, '2017-08-26 15:07:48', NULL, NULL, 12353, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 15:07:48', 'admin-1503731258-15037312683414857', 1, 1, 'SR', NULL, NULL, NULL),
(43664, '2017-08-26 15:07:33', NULL, NULL, 12353, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 15:07:33', 'lois-1503722221-15037312533553782', 1, 0, '', NULL, NULL, NULL),
(43665, '2017-08-26 14:29:10', NULL, NULL, 12351, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1503731258', 'lois', '2017-08-26 14:29:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43666, '2017-08-26 12:11:27', NULL, NULL, 12344, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:11:27', 'admin-1503718638-15037206870502347', 1, 1, 'SR', NULL, NULL, NULL),
(43667, '2017-08-26 14:58:34', NULL, NULL, 12352, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 14:58:34', 'lois-1503722221-1503730714621719', 1, 1, 'SR', NULL, NULL, NULL),
(43668, '2017-08-26 15:00:06', NULL, NULL, 12347, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 15:00:06', 'lois-1503722221-15037308062535637', 1, 0, '', NULL, NULL, NULL),
(43669, '2017-08-26 14:58:34', NULL, NULL, 12352, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 14:58:34', 'lois-1503722221-1503730714621719', 1, 1, 'SR', NULL, NULL, NULL),
(43670, '2017-08-26 09:49:59', NULL, NULL, 12326, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:49:59', 'admin-1503708992-15037121992583813', 1, 0, '', NULL, NULL, NULL),
(43671, '2017-08-26 14:56:45', NULL, NULL, 12352, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 14:56:45', 'lois-1503722221-15037306048765127', 1, 0, '', NULL, NULL, NULL),
(43672, '2017-08-26 14:55:54', NULL, NULL, 12352, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1503731258', 'lois', '2017-08-26 14:55:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43673, '2017-08-26 14:29:22', NULL, NULL, 12351, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 14:29:22', 'lois-1503722221-15037289626767037', 1, 1, 'SR', NULL, NULL, NULL),
(43674, '2017-08-26 14:29:22', NULL, NULL, 12351, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 14:29:22', 'lois-1503722221-15037289626767037', 1, 1, 'SR', NULL, NULL, NULL),
(43675, '2017-08-26 12:18:43', NULL, NULL, 12346, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:18:43', 'admin-1503718638-15037211232929485', 1, 1, 'SR', NULL, NULL, NULL),
(43676, '2017-08-26 10:08:35', NULL, NULL, 12329, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 10:08:35', 'admin-1503712207-1503713315651188', 1, 0, '', NULL, NULL, NULL),
(43677, '2017-08-26 14:29:22', NULL, NULL, 12351, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 14:29:22', 'lois-1503722221-15037289626767037', 1, 1, 'SR', NULL, NULL, NULL),
(43678, '2017-08-26 10:51:36', NULL, NULL, 12333, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1503731258', 'admin', '2017-08-26 10:51:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43679, '2017-08-26 13:49:48', NULL, NULL, 12350, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1503731258', 'lois', '2017-08-26 13:49:48', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(43680, '2017-08-26 11:44:53', NULL, NULL, 12338, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:44:53', 'admin-1503718638-15037190937242584', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(43681, '2017-08-26 12:16:32', NULL, NULL, 12345, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:16:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43682, '2017-08-26 11:11:16', NULL, NULL, 12334, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:11:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43683, '2017-08-26 11:11:31', NULL, NULL, 12334, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:11:31', 'admin-1503715959-15037170912461381', 1, 0, '', NULL, NULL, NULL),
(43684, '2017-08-26 11:11:31', NULL, NULL, 12334, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:11:31', 'admin-1503715959-15037170912461381', 1, 0, '', NULL, NULL, NULL),
(43685, '2017-08-26 11:11:31', NULL, NULL, 12334, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:11:31', 'admin-1503715959-15037170912461381', 1, 0, '', NULL, NULL, NULL),
(43686, '2017-08-26 11:19:58', NULL, NULL, 12333, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:19:58', 'admin-1503715959-1503717598411998', 1, 0, '', NULL, NULL, NULL),
(43687, '2017-08-26 11:25:05', NULL, NULL, 12335, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:25:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43688, '2017-08-26 11:25:40', NULL, NULL, 12335, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:25:40', 'admin-1503715959-1503717940579495', 1, 0, '', NULL, NULL, NULL),
(43689, '2017-08-26 13:23:39', NULL, NULL, 12349, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1503731258', 'lois', '2017-08-26 13:23:39', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(43690, '2017-08-26 12:11:27', NULL, NULL, 12344, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:11:27', 'admin-1503718638-15037206870502347', 1, 1, 'SR', NULL, NULL, NULL),
(43691, '2017-08-26 12:11:27', NULL, NULL, 12344, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:11:27', 'admin-1503718638-15037206870502347', 1, 0, '', NULL, NULL, NULL),
(43692, '2017-08-26 12:10:56', NULL, NULL, 12344, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:10:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43693, '2017-08-26 10:11:31', NULL, NULL, 12330, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1503731258', 'admin', '2017-08-26 10:11:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43694, '2017-08-26 10:12:14', NULL, NULL, 12330, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 10:12:14', 'admin-1503712207-15037135338852656', 1, 0, '', NULL, NULL, NULL),
(43695, '2017-08-26 10:12:14', NULL, NULL, 12330, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 10:12:14', 'admin-1503712207-15037135338852656', 1, 0, '', NULL, NULL, NULL),
(43696, '2017-08-26 12:01:56', NULL, NULL, 12343, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:01:56', 'admin-1503718638-1503720116546220', 1, 0, '', NULL, NULL, NULL),
(43697, '2017-08-26 13:50:04', NULL, NULL, 12350, 0, 73, '73', 'Marmite Chicken ', ' no rice,No salad', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 13:50:04', 'lois-1503722221-15037266044628276', 1, 1, 'SR', NULL, NULL, '10.0'),
(43698, '2017-08-26 11:46:27', NULL, NULL, 12339, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:46:27', 'admin-1503718638-15037191870154735', 1, 1, 'SR', NULL, NULL, NULL),
(43699, '2017-08-26 11:59:30', NULL, NULL, 12342, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:59:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43700, '2017-08-26 11:56:50', NULL, NULL, 12341, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:56:50', 'admin-1503718638-15037198103233131', 1, 0, '', NULL, NULL, NULL),
(43701, '2017-08-26 11:56:50', NULL, NULL, 12341, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:56:50', 'admin-1503718638-15037198103233131', 1, 1, 'SR', NULL, NULL, NULL),
(43702, '2017-08-26 11:53:58', NULL, NULL, 12340, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:53:58', 'admin-1503718638-1503719637903351', 1, 1, 'SR', NULL, NULL, '10.0'),
(43703, '2017-08-26 11:56:27', NULL, NULL, 12341, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:56:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43704, '2017-08-26 11:53:58', NULL, NULL, 12340, 0, 181, '116', 'Open Food ', 'Noodles Soup', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:53:58', 'admin-1503718638-1503719637903351', 1, 0, '', NULL, NULL, '10.0'),
(43705, '2017-08-26 13:50:04', NULL, NULL, 12350, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 13:50:04', 'lois-1503722221-15037266044628276', 1, 1, 'SR', NULL, NULL, '10.0'),
(43706, '2017-08-26 00:00:00', NULL, NULL, 12331, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:56:19', 'admin-1503712207-15037125796542368', 1, 0, '', NULL, NULL, NULL),
(43707, '2017-08-26 00:00:00', NULL, NULL, 12332, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, NULL, NULL, 3.90, 1, '27', 1, '1503731258', 'admin', '2017-08-26 10:15:12', 'admin-1503712207-15037137121297493', 1, 0, '', NULL, NULL, NULL),
(43708, '2017-08-26 00:00:00', NULL, NULL, 12331, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 10:03:07', 'admin-1503712207-15037129875202127', 1, 0, '', NULL, NULL, NULL),
(43709, '2017-08-26 09:58:55', NULL, NULL, 12328, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:58:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43710, '2017-08-26 09:59:15', NULL, NULL, 12328, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:59:15', 'admin-1503712207-15037127548988820', 1, 0, '', NULL, NULL, NULL),
(43711, '2017-08-26 09:59:15', NULL, NULL, 12328, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:59:15', 'admin-1503712207-15037127548988820', 1, 0, '', NULL, NULL, NULL),
(43712, '2017-08-26 11:46:27', NULL, NULL, 12339, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:46:27', 'admin-1503718638-15037191870154735', 1, 1, 'SR', NULL, NULL, NULL),
(43713, '2017-08-26 11:34:43', NULL, NULL, 12338, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:34:43', 'admin-1503715959-15037184834336222', 1, 0, '', NULL, NULL, NULL),
(43714, '2017-08-26 11:31:46', NULL, NULL, 12337, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:31:46', 'admin-1503715959-15037183061315436', 1, 1, 'SR', NULL, NULL, NULL),
(43715, '2017-08-26 11:34:23', NULL, NULL, 12338, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:34:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43716, '2017-08-26 11:34:43', NULL, NULL, 12338, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:34:43', 'admin-1503715959-15037184834336222', 1, 0, '', NULL, NULL, NULL),
(43717, '2017-08-26 11:25:40', NULL, NULL, 12335, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:25:40', 'admin-1503715959-1503717940579495', 1, 0, '', NULL, NULL, NULL),
(43718, '2017-08-26 11:25:40', NULL, NULL, 12335, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:25:40', 'admin-1503715959-1503717940579495', 1, 1, 'SR', NULL, NULL, NULL),
(43719, '2017-08-26 11:25:47', NULL, NULL, 12336, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:25:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43720, '2017-08-26 11:26:12', NULL, NULL, 12336, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:26:12', 'admin-1503715959-15037179725441773', 1, 1, 'SR', NULL, NULL, NULL),
(43721, '2017-08-26 10:12:14', NULL, NULL, 12330, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 10:12:14', 'admin-1503712207-15037135338852656', 1, 1, 'SR', NULL, NULL, NULL),
(43722, '2017-08-26 10:12:14', NULL, NULL, 12330, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 10:12:14', 'admin-1503712207-15037135338852656', 1, 1, 'SR', NULL, NULL, NULL),
(43723, '2017-08-26 10:12:14', NULL, NULL, 12330, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 10:12:14', 'admin-1503712207-15037135338852656', 1, 0, '', NULL, NULL, NULL),
(43724, '2017-08-26 00:00:00', NULL, NULL, 12332, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:56:19', 'admin-1503712207-15037125796542368', 1, 1, 'SR', NULL, NULL, NULL),
(43725, '2017-08-26 10:52:46', NULL, NULL, 12333, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 10:52:46', 'admin-1503715959-15037159665777295', 1, 1, 'SR', NULL, NULL, NULL),
(43726, '2017-08-26 10:52:01', NULL, NULL, 12333, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 10:52:01', 'admin-1503712207-15037159208697072', 1, 0, '', NULL, NULL, NULL),
(43727, '2017-08-26 10:52:46', NULL, NULL, 12333, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 10:52:46', 'admin-1503715959-15037159665777295', 1, 1, 'SR', NULL, NULL, NULL),
(43728, '2017-08-26 10:03:56', NULL, NULL, 12325, 0, 181, '116', 'Open Food ', 'bread', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 10:03:56', 'admin-1503712207-15037130363577654', 1, 0, '', NULL, NULL, NULL),
(43729, '2017-08-26 10:52:01', NULL, NULL, 12333, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 10:52:01', 'admin-1503712207-15037159208697072', 1, 0, '', NULL, NULL, NULL),
(43730, '2017-08-26 10:12:14', NULL, NULL, 12330, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 10:12:14', 'admin-1503712207-15037135338852656', 1, 0, '', NULL, NULL, NULL),
(43731, '2017-08-26 13:24:43', NULL, NULL, 12349, 0, 181, '116', 'Open Food ', 'soup noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503731258', 'lois', '2017-08-26 13:24:43', 'lois-1503722221-15037250831181990', 1, 0, '', NULL, NULL, '10.0'),
(43732, '2017-08-26 11:31:46', NULL, NULL, 12337, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 11:31:46', 'admin-1503715959-15037183061315436', 1, 0, '', NULL, NULL, NULL),
(43733, '2017-08-26 09:49:13', NULL, NULL, 12325, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:49:13', 'admin-1503708992-15037121532829075', 1, 0, '', NULL, NULL, NULL),
(43734, '2017-08-26 09:49:13', NULL, NULL, 12325, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:49:13', 'admin-1503708992-15037121532829075', 1, 0, '', NULL, NULL, NULL),
(43735, '2017-08-26 09:49:42', NULL, NULL, 12326, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:49:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43736, '2017-08-26 00:00:00', NULL, NULL, 12332, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.99, NULL, NULL, 2.99, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:56:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43737, '2017-08-26 10:08:12', NULL, NULL, 12329, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 10:08:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43738, '2017-08-26 10:08:35', NULL, NULL, 12329, 0, 270, '204', 'Homemade Savoury Pancake', 'add sunny side up', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 10:08:35', 'admin-1503712207-1503713315651188', 1, 0, '', NULL, NULL, NULL),
(43739, '2017-08-26 09:24:06', NULL, NULL, 12323, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:24:06', 'admin-1503708992-15037106465842131', 1, 1, 'SR', NULL, NULL, NULL),
(43740, '2017-08-26 09:27:14', NULL, NULL, 12324, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:27:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43741, '2017-08-26 09:27:35', NULL, NULL, 12324, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:27:35', 'admin-1503708992-15037108549385787', 1, 0, '', NULL, NULL, NULL),
(43742, '2017-08-26 12:17:25', NULL, NULL, 12345, 0, 181, '116', 'Open Food ', 'Soup Noodles', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:17:25', 'admin-1503718638-15037210454087638', 1, 0, '', NULL, NULL, NULL),
(43743, '2017-08-26 09:27:35', NULL, NULL, 12324, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:27:35', 'admin-1503708992-15037108549385787', 1, 1, 'SR', NULL, NULL, NULL),
(43744, '2017-08-26 10:42:55', NULL, NULL, 12331, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1503731258', 'admin', '2017-08-26 10:42:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43745, '2017-08-26 09:59:15', NULL, NULL, 12328, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:59:15', 'admin-1503712207-15037127548988820', 1, 1, 'SR', NULL, NULL, NULL),
(43746, '2017-08-26 10:01:04', NULL, NULL, 12323, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 10:01:04', 'admin-1503712207-15037128642749344', 1, 1, 'SR', NULL, NULL, NULL),
(43747, '2017-08-26 00:00:00', NULL, NULL, 12332, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:56:13', 'admin-1503712207-15037125728521615', 1, 0, '', NULL, NULL, NULL),
(43748, '2017-08-26 12:34:25', NULL, NULL, 12347, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 12:34:25', 'admin-1503718638-15037220656718457', 1, 0, '', NULL, NULL, NULL),
(43749, '2017-08-26 10:08:35', NULL, NULL, 12329, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 10:08:35', 'admin-1503712207-1503713315651188', 1, 1, 'SR', NULL, NULL, NULL),
(43750, '2017-08-26 09:59:15', NULL, NULL, 12328, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:59:15', 'admin-1503712207-15037127548988820', 1, 1, 'SR', NULL, NULL, NULL),
(43751, '2017-08-26 09:49:59', NULL, NULL, 12326, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:49:59', 'admin-1503708992-15037121992583813', 1, 1, 'SR', NULL, NULL, NULL),
(43752, '2017-08-26 09:49:59', NULL, NULL, 12326, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:49:59', 'admin-1503708992-15037121992583813', 1, 0, '', NULL, NULL, NULL),
(43753, '2017-08-26 09:09:50', NULL, NULL, 12321, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:09:50', 'admin-1503708992-15037097901759444', 1, 0, '', NULL, NULL, NULL),
(43754, '2017-08-26 09:09:50', NULL, NULL, 12321, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:09:50', 'admin-1503708992-15037097901759444', 1, 0, '', NULL, NULL, NULL),
(43755, '2017-08-26 09:09:50', NULL, NULL, 12321, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:09:50', 'admin-1503708992-15037097901759444', 1, 0, '', NULL, NULL, NULL),
(43756, '2017-08-26 09:09:50', NULL, NULL, 12321, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:09:50', 'admin-1503708992-15037097901759444', 1, 1, 'SR', NULL, NULL, NULL),
(43757, '2017-08-26 09:09:50', NULL, NULL, 12321, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:09:50', 'admin-1503708992-15037097901759444', 1, 1, 'SR', NULL, NULL, NULL),
(43758, '2017-08-26 09:09:50', NULL, NULL, 12321, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:09:50', 'admin-1503708992-15037097901759444', 1, 1, 'SR', NULL, NULL, NULL),
(43759, '2017-08-26 09:27:35', NULL, NULL, 12324, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:27:35', 'admin-1503708992-15037108549385787', 1, 1, 'SR', NULL, NULL, NULL),
(43760, '2017-08-26 09:48:55', NULL, NULL, 12325, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:48:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43761, '2017-08-26 09:27:35', NULL, NULL, 12324, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:27:35', 'admin-1503708992-15037108549385787', 1, 0, '', NULL, NULL, NULL),
(43762, '2017-08-26 09:24:02', NULL, NULL, 12323, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:24:02', 'admin-1503708992-1503710642380923', 1, 0, '', NULL, NULL, NULL),
(43763, '2017-08-26 09:23:55', NULL, NULL, 12323, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:23:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43764, '2017-08-26 09:21:28', NULL, NULL, 12322, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:21:28', 'admin-1503708992-1503710488582793', 1, 1, 'SR', NULL, NULL, NULL),
(43765, '2017-08-26 09:21:28', NULL, NULL, 12322, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:21:28', 'admin-1503708992-1503710488582793', 1, 1, 'SR', NULL, NULL, NULL),
(43766, '2017-08-26 09:21:23', NULL, NULL, 12322, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:21:23', 'admin-1503708992-15037104835781889', 1, 0, '', NULL, NULL, NULL),
(43767, '2017-08-26 09:21:04', NULL, NULL, 12322, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:21:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43768, '2017-08-26 09:21:23', NULL, NULL, 12322, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:21:23', 'admin-1503708992-15037104835781889', 1, 0, '', NULL, NULL, NULL),
(43769, '2017-08-26 09:09:20', NULL, NULL, 12321, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1503731258', 'admin', '2017-08-26 09:09:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43770, '2017-08-27 14:43:37', NULL, NULL, 12413, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 14:43:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43771, '2017-08-27 00:00:00', NULL, NULL, 12411, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:46:01', 'admin-1503810286-15038127616683373', 1, 1, 'SR', NULL, NULL, NULL),
(43772, '2017-08-27 00:00:00', NULL, NULL, 12410, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:39:03', 'admin-1503810286-1503812342830993', 1, 1, 'SR', NULL, NULL, NULL),
(43773, '2017-08-27 14:04:34', NULL, NULL, 12397, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 14:04:34', 'admin-1503810286-15038138742581053', 1, 0, '', NULL, NULL, NULL),
(43774, '2017-08-27 13:54:47', NULL, NULL, 12407, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:54:47', 'admin-1503810286-15038132871374474', 1, 0, '', NULL, NULL, NULL),
(43775, '2017-08-27 13:55:28', NULL, NULL, 12407, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:55:28', 'admin-1503810286-15038133278701313', 1, 0, '', NULL, NULL, NULL),
(43776, '2017-08-27 13:55:28', NULL, NULL, 12407, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:55:28', 'admin-1503810286-15038133278701313', 1, 0, '', NULL, NULL, NULL),
(43777, '2017-08-27 13:55:28', NULL, NULL, 12407, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:55:28', 'admin-1503810286-15038133278701313', 1, 1, 'SR', NULL, NULL, NULL),
(43778, '2017-08-27 13:55:28', NULL, NULL, 12407, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:55:28', 'admin-1503810286-15038133278701313', 1, 1, 'SR', NULL, NULL, NULL),
(43779, '2017-08-27 15:05:37', NULL, NULL, 12414, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 15:05:37', 'admin-1503814520-15038175376213666', 1, 0, '', NULL, NULL, NULL),
(43780, '2017-08-27 15:05:47', NULL, NULL, 12414, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 15:05:47', 'admin-1503814520-15038175472383592', 1, 1, 'SR', NULL, NULL, NULL),
(43781, '2017-08-27 15:05:47', NULL, NULL, 12414, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 15:05:47', 'admin-1503814520-15038175472383592', 1, 1, 'SR', NULL, NULL, NULL),
(43782, '2017-08-27 15:37:00', NULL, NULL, 12416, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 15:37:00', 'admin-1503814520-15038194204381441', 1, 1, 'SR', NULL, NULL, NULL),
(43783, '2017-08-27 15:36:54', NULL, NULL, 12416, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 15:36:54', 'admin-1503814520-15038194145162199', 1, 1, 'SR', NULL, NULL, NULL),
(43784, '2017-08-27 13:58:21', NULL, NULL, 12409, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:58:21', 'admin-1503810286-15038135017431989', 1, 0, '', NULL, NULL, NULL),
(43785, '2017-08-27 15:36:54', NULL, NULL, 12416, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 15:36:54', 'admin-1503814520-15038194145162199', 1, 0, '', NULL, NULL, NULL),
(43786, '2017-08-27 14:27:26', NULL, NULL, 12409, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 14:27:26', 'admin-1503814520-15038152460605697', 1, 1, 'SR', NULL, NULL, NULL),
(43787, '2017-08-27 14:27:26', NULL, NULL, 12409, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 14:27:26', 'admin-1503814520-15038152460605697', 1, 1, 'SR', NULL, NULL, NULL),
(43788, '2017-08-27 14:21:20', NULL, NULL, 12412, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 14:21:20', 'admin-1503814520-15038148798348842', 1, 1, 'SR', NULL, NULL, NULL),
(43789, '2017-08-27 13:41:36', NULL, NULL, 12404, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:41:36', 'admin-1503810286-15038124961009061', 1, 1, 'SR', NULL, NULL, NULL),
(43790, '2017-08-27 13:41:36', NULL, NULL, 12404, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:41:36', 'admin-1503810286-15038124961009061', 1, 1, 'SR', NULL, NULL, NULL),
(43791, '2017-08-27 13:41:36', NULL, NULL, 12404, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:41:36', 'admin-1503810286-15038124961009061', 1, 1, 'SR', NULL, NULL, NULL),
(43792, '2017-08-27 13:42:02', NULL, NULL, 12402, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:42:02', 'admin-1503810286-15038125224606259', 1, 1, 'SR', NULL, NULL, '10.0'),
(43793, '2017-08-27 00:00:00', NULL, NULL, 12411, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:54:10', 'admin-1503806685-15038096498699720', 1, 0, '', NULL, NULL, NULL),
(43794, '2017-08-27 13:53:10', NULL, NULL, 12406, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:53:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43795, '2017-08-27 13:53:14', NULL, NULL, 12406, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:53:14', 'admin-1503810286-150381319463149', 1, 1, 'SR', NULL, NULL, NULL),
(43796, '2017-08-27 14:21:20', NULL, NULL, 12412, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 14:21:20', 'admin-1503814520-15038148798348842', 1, 1, 'SR', NULL, NULL, NULL),
(43797, '2017-08-27 15:15:12', NULL, NULL, 12409, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 15:15:12', 'admin-1503814520-15038181122686960', 1, 1, 'SR', NULL, NULL, NULL),
(43798, '2017-08-27 15:15:12', NULL, NULL, 12409, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 15:15:12', 'admin-1503814520-15038181122686960', 1, 1, 'SR', NULL, NULL, NULL),
(43799, '2017-08-27 15:15:01', NULL, NULL, 12415, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 15:15:01', 'admin-1503814520-15038181017889060', 1, 1, 'SR', NULL, NULL, NULL),
(43800, '2017-08-27 12:40:02', NULL, NULL, 12396, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:40:02', 'admin-1503806685-15038088024885529', 1, 1, 'SR', NULL, NULL, NULL),
(43801, '2017-08-27 12:41:59', NULL, NULL, 12394, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:41:59', 'admin-1503806685-1503808919581588', 1, 0, '', NULL, NULL, NULL),
(43802, '2017-08-27 12:43:02', NULL, NULL, 12396, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:43:02', 'admin-1503806685-15038089827443334', 1, 0, '', NULL, NULL, NULL),
(43803, '2017-08-27 12:43:02', NULL, NULL, 12396, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:43:02', 'admin-1503806685-15038089827443334', 1, 0, '', NULL, NULL, NULL),
(43804, '2017-08-27 12:44:55', NULL, NULL, 12397, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:44:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43805, '2017-08-27 15:37:00', NULL, NULL, 12416, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 15:37:00', 'admin-1503814520-15038194204381441', 1, 1, 'SR', NULL, NULL, NULL),
(43806, '2017-08-27 15:15:01', NULL, NULL, 12415, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 15:15:01', 'admin-1503814520-15038181017889060', 1, 1, 'SR', NULL, NULL, NULL),
(43807, '2017-08-27 15:14:47', NULL, NULL, 12415, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 15:14:47', 'admin-1503814520-15038180875265043', 1, 0, '', NULL, NULL, NULL),
(43808, '2017-08-27 13:40:35', NULL, NULL, 12405, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:40:35', 'admin-1503810286-15038124352878215', 1, 1, 'SR', NULL, NULL, NULL),
(43809, '2017-08-27 13:17:15', NULL, NULL, 12399, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:17:15', 'admin-1503810286-1503811035406644', 1, 0, '', NULL, NULL, NULL),
(43810, '2017-08-27 13:21:27', NULL, NULL, 12402, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:21:27', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(43811, '2017-08-27 13:58:21', NULL, NULL, 12409, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:58:21', 'admin-1503810286-15038135017431989', 1, 1, 'SR', NULL, NULL, NULL),
(43812, '2017-08-27 13:54:47', NULL, NULL, 12407, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:54:47', 'admin-1503810286-15038132871374474', 1, 0, '', NULL, NULL, NULL),
(43813, '2017-08-27 15:14:47', NULL, NULL, 12415, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 15:14:47', 'admin-1503814520-15038180875265043', 1, 1, 'SR', NULL, NULL, NULL),
(43814, '2017-08-27 13:58:08', NULL, NULL, 12409, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:58:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43815, '2017-08-27 12:04:41', NULL, NULL, 12383, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:04:41', 'admin-1503802629-15038066697444770', 1, 1, 'SR', NULL, NULL, '10.0'),
(43816, '2017-08-27 13:54:47', NULL, NULL, 12407, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:54:47', 'admin-1503810286-15038132871374474', 1, 1, 'SR', NULL, NULL, NULL),
(43817, '2017-08-27 13:55:42', NULL, NULL, 12408, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:55:42', 'admin-1503810286-15038133423631916', 1, 0, '', NULL, NULL, NULL),
(43818, '2017-08-27 13:54:47', NULL, NULL, 12407, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:54:47', 'admin-1503810286-15038132871374474', 1, 0, '', NULL, NULL, NULL),
(43819, '2017-08-27 15:05:34', NULL, NULL, 12414, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1503814520', 'admin', '2017-08-27 15:05:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43820, '2017-08-27 14:43:55', NULL, NULL, 12413, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 14:43:55', 'admin-1503814520-15038162349885966', 1, 0, '', NULL, NULL, NULL),
(43821, '2017-08-27 13:55:34', NULL, NULL, 12408, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:55:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43822, '2017-08-27 12:12:46', NULL, NULL, 12389, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:12:46', 'admin-1503806685-15038071658925849', 1, 1, 'SR', NULL, NULL, NULL),
(43823, '2017-08-27 12:12:46', NULL, NULL, 12389, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:12:46', 'admin-1503806685-15038071658925849', 1, 1, 'SR', NULL, NULL, NULL),
(43824, '2017-08-27 12:12:46', NULL, NULL, 12389, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:12:46', 'admin-1503806685-15038071658925849', 1, 1, 'SR', NULL, NULL, NULL),
(43825, '2017-08-27 15:36:38', NULL, NULL, 12416, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1503814520', 'admin', '2017-08-27 15:36:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43826, '2017-08-27 12:15:19', NULL, NULL, 12392, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:15:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43827, '2017-08-27 12:15:48', NULL, NULL, 12392, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:15:48', 'admin-1503806685-15038073478446725', 1, 0, '', NULL, NULL, NULL),
(43828, '2017-08-27 12:15:48', NULL, NULL, 12392, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:15:48', 'admin-1503806685-15038073478446725', 1, 0, '', NULL, NULL, NULL),
(43829, '2017-08-27 13:55:28', NULL, NULL, 12407, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:55:28', 'admin-1503810286-15038133278701313', 1, 0, '', NULL, NULL, NULL),
(43830, '2017-08-27 11:53:47', NULL, NULL, 12391, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:53:47', 'admin-1503802629-1503806027340914', 1, 1, 'SR', NULL, NULL, NULL),
(43831, '2017-08-27 11:53:47', NULL, NULL, 12391, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:53:47', 'admin-1503802629-1503806027340914', 1, 1, 'SR', NULL, NULL, NULL),
(43832, '2017-08-27 11:53:47', NULL, NULL, 12391, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:53:47', 'admin-1503802629-1503806027340914', 1, 0, '', NULL, NULL, NULL),
(43833, '2017-08-27 11:53:47', NULL, NULL, 12391, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:53:47', 'admin-1503802629-1503806027340914', 1, 0, '', NULL, NULL, NULL),
(43834, '2017-08-27 11:53:20', NULL, NULL, 12391, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:53:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43835, '2017-08-27 11:46:53', NULL, NULL, 12390, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:46:53', 'admin-1503802629-15038056128582291', 1, 0, '', NULL, NULL, NULL),
(43836, '2017-08-27 11:46:53', NULL, NULL, 12390, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:46:53', 'admin-1503802629-15038056128582291', 1, 1, 'SR', NULL, NULL, NULL),
(43837, '2017-08-27 13:38:05', NULL, NULL, 12403, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:38:05', 'admin-1503810286-15038122854155362', 1, 0, '', NULL, NULL, NULL),
(43838, '2017-08-27 11:46:53', NULL, NULL, 12390, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:46:53', 'admin-1503802629-15038056128582291', 1, 0, '', NULL, NULL, NULL),
(43839, '2017-08-27 11:43:49', NULL, NULL, 12389, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:43:49', 'admin-1503802629-15038054292449935', 1, 0, '', NULL, NULL, NULL),
(43840, '2017-08-27 11:46:32', NULL, NULL, 12390, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:46:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43841, '2017-08-27 09:59:33', NULL, NULL, 12362, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:59:33', 'admin-1503794105-15037991734682753', 1, 1, 'SR', NULL, NULL, NULL),
(43842, '2017-08-27 09:59:33', NULL, NULL, 12362, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:59:33', 'admin-1503794105-15037991734682753', 1, 0, '', NULL, NULL, NULL),
(43843, '2017-08-27 14:21:20', NULL, NULL, 12412, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 14:21:20', 'admin-1503814520-15038148798348842', 1, 1, 'SR', NULL, NULL, NULL),
(43844, '2017-08-27 13:54:47', NULL, NULL, 12407, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:54:47', 'admin-1503810286-15038132871374474', 1, 0, '', NULL, NULL, NULL),
(43845, '2017-08-27 13:22:29', NULL, NULL, 12402, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:22:29', 'admin-1503810286-15038113490693797', 1, 1, 'SR', NULL, NULL, '10.0'),
(43846, '2017-08-27 11:43:49', NULL, NULL, 12389, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:43:49', 'admin-1503802629-15038054292449935', 1, 0, '', NULL, NULL, NULL),
(43847, '2017-08-27 10:28:46', NULL, NULL, 12367, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:28:46', 'admin-1503794105-15038009258725885', 1, 1, 'SR', NULL, NULL, NULL),
(43848, '2017-08-27 10:28:46', NULL, NULL, 12367, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:28:46', 'admin-1503794105-15038009258725885', 1, 1, 'SR', NULL, NULL, NULL),
(43849, '2017-08-27 10:30:21', NULL, NULL, 12359, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:30:21', 'admin-1503800947-15038010209037252', 1, 0, '', NULL, NULL, NULL),
(43850, '2017-08-27 10:32:13', NULL, NULL, 12368, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:32:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43851, '2017-08-27 11:43:18', NULL, NULL, 12389, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:43:18', 'admin-1503802629-15038053987625095', 1, 1, 'SR', NULL, NULL, NULL),
(43852, '2017-08-27 11:43:18', NULL, NULL, 12389, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:43:18', 'admin-1503802629-15038053987625095', 1, 1, 'SR', NULL, NULL, NULL),
(43853, '2017-08-27 11:39:02', NULL, NULL, 12387, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:39:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43854, '2017-08-27 11:39:21', NULL, NULL, 12387, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:39:21', 'admin-1503802629-15038051616274880', 1, 1, 'SR', NULL, NULL, NULL),
(43855, '2017-08-27 13:08:00', NULL, NULL, 12401, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:08:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43856, '2017-08-27 13:09:54', NULL, NULL, 12401, 0, 154, '88', 'Daily Dose BLT', 'extra 2 bacon', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:09:54', 'admin-1503810286-15038105938529224', 1, 0, '', NULL, NULL, NULL),
(43857, '2017-08-27 13:09:54', NULL, NULL, 12401, 0, 181, '116', 'Open Food ', 'scramble egg (3 eggs)', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:09:54', 'admin-1503810286-15038105938529224', 1, 0, '', NULL, NULL, NULL),
(43858, '2017-08-27 13:10:05', NULL, NULL, 12401, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:10:05', 'admin-1503810286-15038106053494945', 1, 1, 'SR', NULL, NULL, NULL),
(43859, '2017-08-27 13:10:05', NULL, NULL, 12401, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:10:05', 'admin-1503810286-15038106053494945', 1, 1, 'SR', NULL, NULL, NULL),
(43860, '2017-08-27 13:17:15', NULL, NULL, 12399, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:17:15', 'admin-1503810286-1503811035406644', 1, 0, '', NULL, NULL, NULL),
(43861, '2017-08-27 13:39:59', NULL, NULL, 12404, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:39:59', 'admin-1503810286-15038123994937453', 1, 0, '', NULL, NULL, NULL),
(43862, '2017-08-27 13:39:59', NULL, NULL, 12404, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:39:59', 'admin-1503810286-15038123994937453', 1, 0, '', NULL, NULL, NULL),
(43863, '2017-08-27 10:52:19', NULL, NULL, 12375, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:52:19', 'admin-1503800947-15038023390312482', 1, 1, 'SR', NULL, NULL, NULL),
(43864, '2017-08-27 00:00:00', NULL, NULL, 12376, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:18:27', 'admin-1503794105-1503800307772218', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(43865, '2017-08-27 13:41:36', NULL, NULL, 12404, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:41:36', 'admin-1503810286-15038124961009061', 1, 1, 'SR', NULL, NULL, NULL),
(43866, '2017-08-27 13:40:24', NULL, NULL, 12405, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:40:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43867, '2017-08-27 11:24:35', NULL, NULL, 12386, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:24:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43868, '2017-08-27 13:40:17', NULL, NULL, 12404, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:40:17', 'admin-1503810286-15038124175032459', 1, 1, 'SR', NULL, NULL, NULL),
(43869, '2017-08-27 12:31:17', NULL, NULL, 12395, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:31:17', 'admin-1503806685-15038082776027551', 1, 1, 'SR', NULL, NULL, NULL),
(43870, '2017-08-27 14:43:55', NULL, NULL, 12413, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 14:43:55', 'admin-1503814520-15038162349885966', 1, 0, '', NULL, NULL, NULL),
(43871, '2017-08-27 00:00:00', NULL, NULL, 12410, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:53:55', 'admin-1503806685-15038096350369299', 1, 0, '', NULL, NULL, NULL),
(43872, '2017-08-27 13:39:18', NULL, NULL, 12404, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.50, 0.0000, 0.0000, 13.50, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:39:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43873, '2017-08-27 13:39:59', NULL, NULL, 12404, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:39:59', 'admin-1503810286-15038123994937453', 1, 0, '', NULL, NULL, NULL),
(43874, '2017-08-27 10:32:36', NULL, NULL, 12368, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:32:36', 'admin-1503800947-15038011558049039', 1, 1, 'SR', NULL, NULL, NULL),
(43875, '2017-08-27 10:33:00', NULL, NULL, 12369, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:33:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43876, '2017-08-27 10:33:11', NULL, NULL, 12369, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:33:11', 'admin-1503800947-15038011917733510', 1, 0, '', NULL, NULL, NULL),
(43877, '2017-08-27 10:33:11', NULL, NULL, 12369, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:33:11', 'admin-1503800947-15038011917733510', 1, 0, '', NULL, NULL, NULL),
(43878, '2017-08-27 10:33:11', NULL, NULL, 12369, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:33:11', 'admin-1503800947-15038011917733510', 1, 1, 'SR', NULL, NULL, NULL),
(43879, '2017-08-27 13:38:05', NULL, NULL, 12403, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:38:05', 'admin-1503810286-15038122854155362', 1, 0, '', NULL, NULL, NULL),
(43880, '2017-08-27 12:56:37', NULL, NULL, 12397, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:56:37', 'admin-1503806685-15038097969646777', 1, 1, 'SR', NULL, NULL, NULL),
(43881, '2017-08-27 13:04:11', NULL, NULL, 12400, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:04:11', 'admin-1503806685-15038102514494354', 1, 1, 'SR', 1, NULL, '10.0'),
(43882, '2017-08-27 11:43:18', NULL, NULL, 12389, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:43:18', 'admin-1503802629-15038053987625095', 1, 1, 'SR', NULL, NULL, NULL),
(43883, '2017-08-27 11:43:18', NULL, NULL, 12389, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:43:18', 'admin-1503802629-15038053987625095', 1, 1, 'SR', NULL, NULL, NULL),
(43884, '2017-08-27 13:38:05', NULL, NULL, 12403, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:38:05', 'admin-1503810286-15038122854155362', 1, 0, '', NULL, NULL, NULL),
(43885, '2017-08-27 13:38:05', NULL, NULL, 12403, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:38:05', 'admin-1503810286-15038122854155362', 1, 0, '', NULL, NULL, NULL),
(43886, '2017-08-27 13:37:25', NULL, NULL, 12403, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:37:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43887, '2017-08-27 12:45:19', NULL, NULL, 12397, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:45:19', 'admin-1503806685-1503809119614634', 1, 1, 'SR', NULL, NULL, NULL),
(43888, '2017-08-27 11:42:37', NULL, NULL, 12389, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:42:37', 'admin-1503802629-15038053568514858', 1, 0, '', NULL, NULL, NULL),
(43889, '2017-08-27 11:42:37', NULL, NULL, 12389, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:42:37', 'admin-1503802629-15038053568514858', 1, 0, '', NULL, NULL, NULL),
(43890, '2017-08-27 11:25:03', NULL, NULL, 12386, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:25:03', 'admin-1503802629-15038043031641574', 1, 0, '', NULL, NULL, NULL),
(43891, '2017-08-27 13:54:47', NULL, NULL, 12407, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:54:47', 'admin-1503810286-15038132871374474', 1, 1, 'SR', NULL, NULL, NULL),
(43892, '2017-08-27 13:22:29', NULL, NULL, 12402, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:22:29', 'admin-1503810286-15038113490693797', 1, 1, 'SR', NULL, NULL, '10.0'),
(43893, '2017-08-27 12:55:01', NULL, NULL, 12399, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:55:01', 'admin-1503806685-15038097010486969', 1, 1, 'SR', NULL, NULL, NULL),
(43894, '2017-08-27 12:55:01', NULL, NULL, 12399, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:55:01', 'admin-1503806685-15038097010486969', 1, 1, 'SR', NULL, NULL, NULL),
(43895, '2017-08-27 11:42:37', NULL, NULL, 12389, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:42:37', 'admin-1503802629-15038053568514858', 1, 0, '', NULL, NULL, NULL),
(43896, '2017-08-27 12:21:33', NULL, NULL, 12393, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:21:33', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(43897, '2017-08-27 12:22:03', NULL, NULL, 12393, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:22:03', 'admin-1503806685-15038077237126617', 1, 0, '', NULL, NULL, '10.0'),
(43898, '2017-08-27 15:14:39', NULL, NULL, 12415, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1503814520', 'admin', '2017-08-27 15:14:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43899, '2017-08-27 11:08:54', NULL, NULL, 12383, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:08:54', 'admin-1503802629-1503803334089286', 1, 1, 'SR', NULL, NULL, '10.0'),
(43900, '2017-08-27 11:08:54', NULL, NULL, 12383, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:08:54', 'admin-1503802629-1503803334089286', 1, 0, '', NULL, NULL, '10.0'),
(43901, '2017-08-27 11:13:59', NULL, NULL, 12384, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.20, 0.0000, 0.0000, 11.20, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:13:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43902, '2017-08-27 11:14:59', NULL, NULL, 12384, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:14:59', 'admin-1503802629-1503803699681241', 1, 0, '', NULL, NULL, NULL),
(43903, '2017-08-27 11:14:59', NULL, NULL, 12384, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:14:59', 'admin-1503802629-1503803699681241', 1, 0, '', NULL, NULL, NULL),
(43904, '2017-08-27 11:14:59', NULL, NULL, 12384, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:14:59', 'admin-1503802629-1503803699681241', 1, 0, '', NULL, NULL, NULL),
(43905, '2017-08-27 11:14:59', NULL, NULL, 12384, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:14:59', 'admin-1503802629-1503803699681241', 1, 0, '', NULL, NULL, NULL),
(43906, '2017-08-27 11:14:59', NULL, NULL, 12384, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:14:59', 'admin-1503802629-1503803699681241', 1, 1, 'SR', NULL, NULL, NULL),
(43907, '2017-08-27 11:14:59', NULL, NULL, 12384, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:14:59', 'admin-1503802629-1503803699681241', 1, 1, 'SR', NULL, NULL, NULL),
(43908, '2017-08-27 11:14:59', NULL, NULL, 12384, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:14:59', 'admin-1503802629-1503803699681241', 1, 1, 'SR', NULL, NULL, NULL),
(43909, '2017-08-27 11:15:00', NULL, NULL, 12384, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:15:00', 'admin-1503802629-1503803699681241', 1, 1, 'SR', NULL, NULL, NULL),
(43910, '2017-08-27 11:15:12', NULL, NULL, 12381, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:15:12', 'admin-1503802629-15038037119407738', 1, 0, '', NULL, NULL, NULL),
(43911, '2017-08-27 11:15:23', NULL, NULL, 12383, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:15:23', 'admin-1503802629-15038037230111714', 1, 0, '', NULL, NULL, '10.0'),
(43912, '2017-08-27 11:17:34', NULL, NULL, 12385, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:17:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43913, '2017-08-27 11:17:43', NULL, NULL, 12385, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:17:43', 'admin-1503802629-15038038634435362', 1, 1, 'SR', NULL, NULL, NULL),
(43914, '2017-08-27 13:55:52', NULL, NULL, 12408, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:55:52', 'admin-1503810286-1503813352555955', 1, 0, '', NULL, NULL, NULL),
(43915, '2017-08-27 15:37:00', NULL, NULL, 12416, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 15:37:00', 'admin-1503814520-15038194204381441', 1, 0, '', NULL, NULL, NULL),
(43916, '2017-08-27 11:42:37', NULL, NULL, 12389, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:42:37', 'admin-1503802629-15038053568514858', 1, 0, '', NULL, NULL, NULL),
(43917, '2017-08-27 11:40:38', NULL, NULL, 12388, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:40:38', 'admin-1503802629-15038052385315072', 1, 1, 'SR', NULL, NULL, NULL),
(43918, '2017-08-27 11:40:38', NULL, NULL, 12388, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:40:38', 'admin-1503802629-15038052385315072', 1, 0, '', NULL, NULL, NULL),
(43919, '2017-08-27 15:15:01', NULL, NULL, 12415, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 15:15:01', 'admin-1503814520-15038181017889060', 1, 1, 'SR', NULL, NULL, NULL),
(43920, '2017-08-27 11:42:20', NULL, NULL, 12389, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.90, 0.0000, 0.0000, 10.90, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:42:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43921, '2017-08-27 11:42:37', NULL, NULL, 12389, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:42:37', 'admin-1503802629-15038053568514858', 1, 0, '', NULL, NULL, NULL),
(43922, '2017-08-27 09:56:59', NULL, NULL, 12361, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:56:59', 'admin-1503794105-15037990193518225', 1, 0, '', NULL, NULL, NULL),
(43923, '2017-08-27 09:56:59', NULL, NULL, 12361, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:56:59', 'admin-1503794105-15037990193518225', 1, 0, '', NULL, NULL, NULL),
(43924, '2017-08-27 11:40:38', NULL, NULL, 12388, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:40:38', 'admin-1503802629-15038052385315072', 1, 0, '', NULL, NULL, NULL),
(43925, '2017-08-27 00:00:00', NULL, NULL, 12411, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, NULL, NULL, 3.50, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:53:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43926, '2017-08-27 12:54:58', NULL, NULL, 12399, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:54:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43927, '2017-08-27 00:00:00', NULL, NULL, 12410, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:53:55', 'admin-1503806685-15038096350369299', 1, 1, 'SR', NULL, NULL, NULL),
(43928, '2017-08-27 14:21:09', NULL, NULL, 12412, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1503814520', 'admin', '2017-08-27 14:21:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43929, '2017-08-27 14:15:39', NULL, NULL, 12410, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1503814520', 'admin', '2017-08-27 14:15:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43930, '2017-08-27 15:36:54', NULL, NULL, 12416, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 15:36:54', 'admin-1503814520-15038194145162199', 1, 0, '', NULL, NULL, NULL),
(43931, '2017-08-27 11:40:38', NULL, NULL, 12388, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:40:38', 'admin-1503802629-15038052385315072', 1, 0, '', NULL, NULL, NULL),
(43932, '2017-08-27 10:52:19', NULL, NULL, 12375, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:52:19', 'admin-1503800947-15038023390312482', 1, 0, '', NULL, NULL, NULL),
(43933, '2017-08-27 10:32:36', NULL, NULL, 12368, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:32:36', 'admin-1503800947-15038011558049039', 1, 1, 'SR', NULL, NULL, NULL),
(43934, '2017-08-27 11:40:21', NULL, NULL, 12388, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:40:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43935, '2017-08-27 11:40:13', NULL, NULL, 12387, 0, 181, '116', 'Open Food ', 'pepper pork rice half only', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:40:13', 'admin-1503802629-15038052131598673', 1, 0, '', NULL, NULL, NULL),
(43936, '2017-08-27 12:31:17', NULL, NULL, 12395, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:31:17', 'admin-1503806685-15038082776027551', 1, 1, 'SR', NULL, NULL, NULL),
(43937, '2017-08-27 11:39:41', NULL, NULL, 12387, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:39:41', 'admin-1503802629-15038051808505440', 1, 1, 'SR', NULL, NULL, NULL),
(43938, '2017-08-27 11:39:41', NULL, NULL, 12387, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:39:41', 'admin-1503802629-15038051808505440', 1, 1, 'SR', NULL, NULL, NULL),
(43939, '2017-08-27 11:39:41', NULL, NULL, 12387, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:39:41', 'admin-1503802629-15038051808505440', 1, 1, 'SR', NULL, NULL, NULL),
(43940, '2017-08-27 11:39:21', NULL, NULL, 12387, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:39:21', 'admin-1503802629-15038051616274880', 1, 1, 'SR', NULL, NULL, NULL),
(43941, '2017-08-27 12:45:19', NULL, NULL, 12397, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:45:19', 'admin-1503806685-1503809119614634', 1, 0, '', NULL, NULL, NULL),
(43942, '2017-08-27 12:45:19', NULL, NULL, 12397, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:45:19', 'admin-1503806685-1503809119614634', 1, 0, '', NULL, NULL, NULL),
(43943, '2017-08-27 12:45:19', NULL, NULL, 12397, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:45:19', 'admin-1503806685-1503809119614634', 1, 0, '', NULL, NULL, NULL),
(43944, '2017-08-27 11:39:21', NULL, NULL, 12387, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:39:21', 'admin-1503802629-15038051616274880', 1, 1, 'SR', NULL, NULL, NULL),
(43945, '2017-08-27 11:25:03', NULL, NULL, 12386, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:25:03', 'admin-1503802629-15038043031641574', 1, 0, '', NULL, NULL, NULL),
(43946, '2017-08-27 11:25:03', NULL, NULL, 12386, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:25:03', 'admin-1503802629-15038043031641574', 1, 1, 'SR', NULL, NULL, NULL),
(43947, '2017-08-27 00:00:00', NULL, NULL, 12378, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:18:27', 'admin-1503794105-1503800307772218', 1, 0, '', NULL, NULL, NULL),
(43948, '2017-08-27 12:40:02', NULL, NULL, 12396, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:40:02', 'admin-1503806685-15038088024885529', 1, 1, 'SR', NULL, NULL, NULL),
(43949, '2017-08-27 12:39:53', NULL, NULL, 12396, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:39:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43950, '2017-08-27 14:21:20', NULL, NULL, 12412, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 14:21:20', 'admin-1503814520-15038148798348842', 1, 1, 'SR', NULL, NULL, NULL),
(43951, '2017-08-27 13:39:59', NULL, NULL, 12404, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:39:59', 'admin-1503810286-15038123994937453', 1, 0, '', NULL, NULL, NULL),
(43952, '2017-08-27 12:31:17', NULL, NULL, 12395, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:31:17', 'admin-1503806685-15038082776027551', 1, 0, '', NULL, NULL, NULL),
(43953, '2017-08-27 10:52:19', NULL, NULL, 12375, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:52:19', 'admin-1503800947-15038023390312482', 1, 0, '', NULL, NULL, NULL),
(43954, '2017-08-27 12:31:17', NULL, NULL, 12395, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:31:17', 'admin-1503806685-15038082776027551', 1, 0, '', NULL, NULL, NULL),
(43955, '2017-08-27 12:22:03', NULL, NULL, 12393, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:22:03', 'admin-1503806685-15038077237126617', 1, 0, '', NULL, NULL, '10.0'),
(43956, '2017-08-27 12:29:49', NULL, NULL, 12394, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.29, 0.0000, 0.0000, 3.29, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:29:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43957, '2017-08-27 12:30:00', NULL, NULL, 12394, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:30:00', 'admin-1503806685-15038081999231595', 1, 0, '', NULL, NULL, NULL),
(43958, '2017-08-27 12:30:00', NULL, NULL, 12394, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:30:00', 'admin-1503806685-15038081999231595', 1, 0, '', NULL, NULL, NULL),
(43959, '2017-08-27 12:30:00', NULL, NULL, 12394, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:30:00', 'admin-1503806685-15038081999231595', 1, 0, '', NULL, NULL, NULL),
(43960, '2017-08-27 12:30:39', NULL, NULL, 12395, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:30:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43961, '2017-08-27 13:58:21', NULL, NULL, 12409, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:58:21', 'admin-1503810286-15038135017431989', 1, 1, 'SR', NULL, NULL, NULL),
(43962, '2017-08-27 12:56:37', NULL, NULL, 12397, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:56:37', 'admin-1503806685-15038097969646777', 1, 0, '', NULL, NULL, NULL),
(43963, '2017-08-27 09:56:47', NULL, NULL, 12361, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:56:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43964, '2017-08-27 11:25:03', NULL, NULL, 12386, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:25:03', 'admin-1503802629-15038043031641574', 1, 0, '', NULL, NULL, NULL),
(43965, '2017-08-27 10:33:38', NULL, NULL, 12370, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:33:38', 'admin-1503800947-15038012183198827', 1, 1, 'SR', NULL, NULL, NULL),
(43966, '2017-08-27 12:15:48', NULL, NULL, 12392, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:15:48', 'admin-1503806685-15038073478446725', 1, 0, '', NULL, NULL, NULL),
(43967, '2017-08-27 12:05:32', NULL, NULL, 12387, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:05:32', 'admin-1503806685-15038067323976220', 1, 0, '', NULL, NULL, NULL),
(43968, '2017-08-27 12:31:17', NULL, NULL, 12395, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:31:17', 'admin-1503806685-15038082776027551', 1, 1, 'SR', NULL, NULL, NULL),
(43969, '2017-08-27 12:04:41', NULL, NULL, 12383, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:04:41', 'admin-1503802629-15038066697444770', 1, 0, '', NULL, NULL, '10.0'),
(43970, '2017-08-27 12:01:53', NULL, NULL, 12386, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:01:53', 'admin-1503802629-1503806513664742', 1, 0, '', NULL, NULL, NULL),
(43971, '2017-08-27 11:08:54', NULL, NULL, 12383, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:08:54', 'admin-1503802629-1503803334089286', 1, 0, '', NULL, NULL, '10.0'),
(43972, '2017-08-27 11:08:54', NULL, NULL, 12383, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:08:54', 'admin-1503802629-1503803334089286', 1, 0, '', NULL, NULL, '10.0'),
(43973, '2017-08-27 11:08:23', NULL, NULL, 12383, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.60, 0.0000, 0.0000, 9.60, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:08:23', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(43974, '2017-08-27 11:06:43', NULL, NULL, 12382, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:06:43', 'admin-1503802629-15038032031463325', 1, 1, 'SR', NULL, NULL, NULL),
(43975, '2017-08-27 10:59:04', NULL, NULL, 12381, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:59:04', 'admin-1503802629-15038027443749148', 1, 1, 'SR', NULL, NULL, NULL),
(43976, '2017-08-27 10:59:04', NULL, NULL, 12381, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:59:04', 'admin-1503802629-15038027443749148', 1, 1, 'SR', NULL, NULL, NULL),
(43977, '2017-08-27 11:06:39', NULL, NULL, 12382, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:06:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43978, '2017-08-27 12:22:03', NULL, NULL, 12393, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 12:22:03', 'admin-1503806685-15038077237126617', 1, 1, 'SR', NULL, NULL, '10.0'),
(43979, '2017-08-27 11:42:37', NULL, NULL, 12389, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:42:37', 'admin-1503802629-15038053568514858', 1, 0, '', NULL, NULL, NULL),
(43980, '2017-08-27 10:59:04', NULL, NULL, 12381, 0, 207, '142', 'Cheesy Bacon Toast', 'Takeaway,no vege', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:59:04', 'admin-1503802629-15038027443749148', 1, 0, '', NULL, NULL, NULL),
(43981, '2017-08-27 10:59:04', NULL, NULL, 12381, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:59:04', 'admin-1503802629-15038027443749148', 1, 0, '', NULL, NULL, NULL),
(43982, '2017-08-27 10:54:55', NULL, NULL, 12376, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:54:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43983, '2017-08-27 00:00:00', NULL, NULL, 12377, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:18:27', 'admin-1503794105-1503800307772218', 1, 0, '', NULL, NULL, NULL),
(43984, '2017-08-27 00:00:00', NULL, NULL, 12379, 0, 153, '87', 'Wake Me Up!', 'no bacon', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:18:27', 'admin-1503794105-1503800307772218', 1, 0, '', NULL, NULL, NULL),
(43985, '2017-08-27 10:07:56', NULL, NULL, 12363, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:07:56', 'admin-1503794105-15037996768146530', 1, 0, '', NULL, NULL, NULL),
(43986, '2017-08-27 13:54:05', NULL, NULL, 12407, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.90, 0.0000, 0.0000, 16.90, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:54:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43987, '2017-08-27 09:59:33', NULL, NULL, 12362, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:59:33', 'admin-1503794105-15037991734682753', 1, 1, 'SR', NULL, NULL, NULL),
(43988, '2017-08-27 10:07:57', NULL, NULL, 12363, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:07:57', 'admin-1503794105-15037996768146530', 1, 1, 'SR', NULL, NULL, NULL),
(43989, '2017-08-27 10:52:19', NULL, NULL, 12375, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:52:19', 'admin-1503800947-15038023390312482', 1, 0, '', NULL, NULL, NULL),
(43990, '2017-08-27 10:23:45', NULL, NULL, 12366, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:23:45', 'admin-1503794105-15038006257038442', 1, 1, 'SR', NULL, NULL, NULL),
(43991, '2017-08-27 10:28:26', NULL, NULL, 12367, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:28:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43992, '2017-08-27 10:28:46', NULL, NULL, 12367, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:28:46', 'admin-1503794105-15038009258725885', 1, 0, '', NULL, NULL, NULL),
(43993, '2017-08-27 09:58:20', NULL, NULL, 12362, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.10, 0.0000, 0.0000, 15.10, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:58:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(43994, '2017-08-27 09:58:31', NULL, NULL, 12362, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:58:31', 'admin-1503794105-15037991112017862', 1, 0, '', NULL, NULL, NULL),
(43995, '2017-08-27 09:58:31', NULL, NULL, 12362, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:58:31', 'admin-1503794105-15037991112017862', 1, 0, '', NULL, NULL, NULL),
(43996, '2017-08-27 09:58:31', NULL, NULL, 12362, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:58:31', 'admin-1503794105-15037991112017862', 1, 0, '', NULL, NULL, NULL),
(43997, '2017-08-27 09:58:31', NULL, NULL, 12362, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:58:31', 'admin-1503794105-15037991112017862', 1, 0, '', NULL, NULL, NULL),
(43998, '2017-08-27 09:58:31', NULL, NULL, 12362, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:58:31', 'admin-1503794105-15037991112017862', 1, 0, '', NULL, NULL, NULL),
(43999, '2017-08-27 09:59:33', NULL, NULL, 12362, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:59:33', 'admin-1503794105-15037991734682753', 1, 1, 'SR', NULL, NULL, NULL),
(44000, '2017-08-27 00:00:00', NULL, NULL, 12380, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:20:37', 'admin-1503794105-15038004368294993', 1, 1, 'SR', NULL, NULL, NULL),
(44001, '2017-08-27 10:40:47', NULL, NULL, 12372, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:40:47', 'admin-1503800947-15038016470792694', 1, 1, 'SR', NULL, NULL, NULL),
(44002, '2017-08-27 10:42:36', NULL, NULL, 12366, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:42:36', 'admin-1503800947-15038017560972626', 1, 0, '', NULL, NULL, NULL),
(44003, '2017-08-27 10:42:36', NULL, NULL, 12366, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:42:36', 'admin-1503800947-15038017560972626', 1, 0, '', NULL, NULL, NULL),
(44004, '2017-08-27 10:42:36', NULL, NULL, 12366, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:42:36', 'admin-1503800947-15038017560972626', 1, 1, 'SR', NULL, NULL, NULL),
(44005, '2017-08-27 10:46:04', NULL, NULL, 12373, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:46:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44006, '2017-08-27 11:02:48', NULL, NULL, 12373, 0, 284, '218', 'Caramel Waffles', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:02:48', 'admin-1503802629-15038029685059587', 1, 0, '', NULL, NULL, NULL),
(44007, '2017-08-27 10:46:17', NULL, NULL, 12373, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:46:17', 'admin-1503800947-15038019769416861', 1, 1, 'SR', NULL, NULL, NULL),
(44008, '2017-08-27 10:51:06', NULL, NULL, 12374, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:51:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44009, '2017-08-27 10:51:19', NULL, NULL, 12374, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:51:19', 'admin-1503800947-15038022795087411', 1, 0, '', NULL, NULL, NULL),
(44010, '2017-08-27 11:42:37', NULL, NULL, 12389, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:42:37', 'admin-1503802629-15038053568514858', 1, 0, '', NULL, NULL, NULL),
(44011, '2017-08-27 10:52:12', NULL, NULL, 12375, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:52:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44012, '2017-08-27 10:51:19', NULL, NULL, 12374, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:51:19', 'admin-1503800947-15038022795087411', 1, 0, '', NULL, NULL, NULL),
(44013, '2017-08-27 10:40:47', NULL, NULL, 12372, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:40:47', 'admin-1503800947-15038016470792694', 1, 0, '', NULL, NULL, NULL),
(44014, '2017-08-27 10:40:34', NULL, NULL, 12372, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:40:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44015, '2017-08-27 10:34:12', NULL, NULL, 12371, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:34:12', 'admin-1503800947-15038012527103850', 1, 1, 'SR', NULL, NULL, NULL),
(44016, '2017-08-27 10:34:12', NULL, NULL, 12371, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:34:12', 'admin-1503800947-15038012527103850', 1, 1, 'SR', NULL, NULL, NULL),
(44017, '2017-08-27 10:33:59', NULL, NULL, 12371, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:33:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44018, '2017-08-27 10:34:12', NULL, NULL, 12371, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:34:12', 'admin-1503800947-15038012527103850', 1, 0, '', NULL, NULL, NULL),
(44019, '2017-08-27 10:34:12', NULL, NULL, 12371, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:34:12', 'admin-1503800947-15038012527103850', 1, 0, '', NULL, NULL, NULL),
(44020, '2017-08-27 13:21:59', NULL, NULL, 12402, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:21:59', 'admin-1503810286-15038113198059787', 1, 1, 'SR', NULL, NULL, '10.0'),
(44021, '2017-08-27 10:33:11', NULL, NULL, 12369, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:33:11', 'admin-1503800947-15038011917733510', 1, 1, 'SR', NULL, NULL, NULL),
(44022, '2017-08-27 10:33:38', NULL, NULL, 12370, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:33:38', 'admin-1503800947-15038012183198827', 1, 0, '', NULL, NULL, NULL),
(44023, '2017-08-27 10:33:30', NULL, NULL, 12370, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:33:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44024, '2017-08-27 09:57:10', NULL, NULL, 12361, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:57:10', 'admin-1503794105-15037990303372687', 1, 0, '', NULL, NULL, NULL),
(44025, '2017-08-27 09:19:50', NULL, NULL, 12357, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:19:50', 'admin-1503794105-15037967901125670', 1, 0, '', NULL, NULL, NULL),
(44026, '2017-08-27 09:22:00', NULL, NULL, 12358, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:22:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44027, '2017-08-27 09:22:16', NULL, NULL, 12358, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:22:16', 'admin-1503794105-15037969360792937', 1, 0, '', NULL, NULL, NULL),
(44028, '2017-08-27 10:59:04', NULL, NULL, 12381, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:59:04', 'admin-1503802629-15038027443749148', 1, 0, '', NULL, NULL, NULL),
(44029, '2017-08-27 00:00:00', NULL, NULL, 12377, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:20:37', 'admin-1503794105-15038004368294993', 1, 1, 'SR', NULL, NULL, NULL),
(44030, '2017-08-27 00:00:00', NULL, NULL, 12379, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:20:37', 'admin-1503794105-15038004368294993', 1, 1, 'SR', NULL, NULL, NULL),
(44031, '2017-08-27 00:00:00', NULL, NULL, 12380, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, NULL, NULL, 3.70, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:17:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44032, '2017-08-27 10:58:25', NULL, NULL, 12381, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:58:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44033, '2017-08-27 00:00:00', NULL, NULL, 12378, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:20:37', 'admin-1503794105-15038004368294993', 1, 1, 'SR', NULL, NULL, NULL),
(44034, '2017-08-27 00:00:00', NULL, NULL, 12376, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:20:37', 'admin-1503794105-15038004368294993', 1, 1, 'SR', NULL, NULL, NULL),
(44035, '2017-08-27 10:56:02', NULL, NULL, 12377, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:56:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44036, '2017-08-27 10:32:36', NULL, NULL, 12368, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:32:36', 'admin-1503800947-15038011558049039', 1, 0, '', NULL, NULL, NULL),
(44037, '2017-08-27 10:57:33', NULL, NULL, 12379, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:57:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44038, '2017-08-27 00:00:00', NULL, NULL, 12380, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:20:37', 'admin-1503794105-15038004368294993', 1, 1, 'SR', NULL, NULL, NULL),
(44039, '2017-08-27 10:20:44', NULL, NULL, 12365, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:20:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44040, '2017-08-27 10:20:52', NULL, NULL, 12365, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:20:52', 'admin-1503794105-1503800452650384', 1, 0, '', NULL, NULL, NULL),
(44041, '2017-08-27 10:20:52', NULL, NULL, 12365, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:20:52', 'admin-1503794105-1503800452650384', 1, 0, '', NULL, NULL, NULL),
(44042, '2017-08-27 10:23:18', NULL, NULL, 12366, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:23:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44043, '2017-08-27 10:32:36', NULL, NULL, 12368, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:32:36', 'admin-1503800947-15038011558049039', 1, 0, '', NULL, NULL, NULL),
(44044, '2017-08-27 10:28:46', NULL, NULL, 12367, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:28:46', 'admin-1503794105-15038009258725885', 1, 0, '', NULL, NULL, NULL),
(44045, '2017-08-27 10:28:46', NULL, NULL, 12367, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:28:46', 'admin-1503794105-15038009258725885', 1, 0, '', NULL, NULL, NULL),
(44046, '2017-08-27 10:28:46', NULL, NULL, 12367, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:28:46', 'admin-1503794105-15038009258725885', 1, 0, '', NULL, NULL, NULL),
(44047, '2017-08-27 13:22:29', NULL, NULL, 12402, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 13:22:29', 'admin-1503810286-15038113490693797', 1, 0, '', NULL, NULL, '10.0'),
(44048, '2017-08-27 11:25:03', NULL, NULL, 12386, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:25:03', 'admin-1503802629-15038043031641574', 1, 0, '', NULL, NULL, NULL),
(44049, '2017-08-27 10:56:37', NULL, NULL, 12378, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:56:37', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(44050, '2017-08-27 09:28:06', NULL, NULL, 12359, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:28:06', 'admin-1503794105-15037972866648252', 1, 1, 'SR', NULL, NULL, NULL),
(44051, '2017-08-27 09:28:06', NULL, NULL, 12359, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:28:06', 'admin-1503794105-15037972866648252', 1, 1, 'SR', NULL, NULL, NULL),
(44052, '2017-08-27 09:28:06', NULL, NULL, 12359, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:28:06', 'admin-1503794105-15037972866648252', 1, 0, '', NULL, NULL, NULL),
(44053, '2017-08-27 09:28:18', NULL, NULL, 12358, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:28:18', 'admin-1503794105-15037972979471416', 1, 1, 'SR', NULL, NULL, NULL),
(44054, '2017-08-27 09:57:10', NULL, NULL, 12361, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:57:10', 'admin-1503794105-15037990303372687', 1, 1, 'SR', NULL, NULL, NULL),
(44055, '2017-08-27 10:07:56', NULL, NULL, 12363, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:07:56', 'admin-1503794105-15037996768146530', 1, 1, 'SR', NULL, NULL, NULL),
(44056, '2017-08-27 10:07:56', NULL, NULL, 12363, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:07:56', 'admin-1503794105-15037996768146530', 1, 0, '', NULL, NULL, NULL),
(44057, '2017-08-27 10:07:34', NULL, NULL, 12363, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:07:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44058, '2017-08-27 00:00:00', NULL, NULL, 12380, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 10:18:27', 'admin-1503794105-1503800307772218', 1, 0, '', NULL, NULL, NULL),
(44059, '2017-08-27 09:59:33', NULL, NULL, 12362, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:59:33', 'admin-1503794105-15037991734682753', 1, 1, 'SR', NULL, NULL, NULL),
(44060, '2017-08-27 09:27:47', NULL, NULL, 12359, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:27:47', 'admin-1503794105-15037972675542869', 1, 0, '', NULL, NULL, NULL),
(44061, '2017-08-27 09:27:47', NULL, NULL, 12359, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:27:47', 'admin-1503794105-15037972675542869', 1, 0, '', NULL, NULL, NULL),
(44062, '2017-08-27 11:42:37', NULL, NULL, 12389, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 11:42:37', 'admin-1503802629-15038053568514858', 1, 0, '', NULL, NULL, NULL),
(44063, '2017-08-27 09:50:06', NULL, NULL, 12360, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:50:06', 'admin-1503794105-15037986061644652', 1, 1, 'SR', NULL, NULL, NULL),
(44064, '2017-08-27 09:50:06', NULL, NULL, 12360, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:50:06', 'admin-1503794105-15037986061644652', 1, 1, 'SR', NULL, NULL, NULL),
(44065, '2017-08-27 09:56:59', NULL, NULL, 12361, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:56:59', 'admin-1503794105-15037990193518225', 1, 0, '', NULL, NULL, NULL),
(44066, '2017-08-27 09:50:06', NULL, NULL, 12360, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:50:06', 'admin-1503794105-15037986061644652', 1, 1, 'SR', NULL, NULL, NULL),
(44067, '2017-08-27 09:50:06', NULL, NULL, 12360, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:50:06', 'admin-1503794105-15037986061644652', 1, 1, 'SR', NULL, NULL, NULL),
(44068, '2017-08-27 09:50:06', NULL, NULL, 12360, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:50:06', 'admin-1503794105-15037986061644652', 1, 1, 'SR', NULL, NULL, NULL),
(44069, '2017-08-27 09:50:06', NULL, NULL, 12360, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:50:06', 'admin-1503794105-15037986061644652', 1, 0, '', NULL, NULL, NULL),
(44070, '2017-08-27 09:50:06', NULL, NULL, 12360, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:50:06', 'admin-1503794105-15037986061644652', 1, 0, '', NULL, NULL, NULL),
(44071, '2017-08-27 09:50:06', NULL, NULL, 12360, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:50:06', 'admin-1503794105-15037986061644652', 1, 0, '', NULL, NULL, NULL),
(44072, '2017-08-27 09:50:06', NULL, NULL, 12360, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:50:06', 'admin-1503794105-15037986061644652', 1, 0, '', NULL, NULL, NULL),
(44073, '2017-08-27 09:50:06', NULL, NULL, 12360, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:50:06', 'admin-1503794105-15037986061644652', 1, 0, '', NULL, NULL, NULL),
(44074, '2017-08-27 09:49:38', NULL, NULL, 12360, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.30, 0.0000, 0.0000, 14.30, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:49:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44075, '2017-08-27 09:30:18', NULL, NULL, 12359, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:30:18', 'admin-1503794105-15037974184908190', 1, 0, '', NULL, NULL, NULL),
(44076, '2017-08-27 09:27:47', NULL, NULL, 12359, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:27:47', 'admin-1503794105-15037972675542869', 1, 0, '', NULL, NULL, NULL),
(44077, '2017-08-27 09:28:06', NULL, NULL, 12359, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:28:06', 'admin-1503794105-15037972866648252', 1, 1, 'SR', NULL, NULL, NULL),
(44078, '2017-08-27 09:27:31', NULL, NULL, 12359, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.20, 0.0000, 0.0000, 12.20, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:27:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44079, '2017-08-27 09:27:47', NULL, NULL, 12359, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:27:47', 'admin-1503794105-15037972675542869', 1, 0, '', NULL, NULL, NULL),
(44080, '2017-08-27 09:22:30', NULL, NULL, 12358, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:22:30', 'admin-1503794105-15037969505571459', 1, 1, 'SR', NULL, NULL, NULL),
(44081, '2017-08-27 09:22:16', NULL, NULL, 12358, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:22:16', 'admin-1503794105-15037969360792937', 1, 0, '', NULL, NULL, NULL),
(44082, '2017-08-27 09:22:16', NULL, NULL, 12358, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:22:16', 'admin-1503794105-15037969360792937', 1, 0, '', NULL, NULL, NULL),
(44083, '2017-08-27 09:19:50', NULL, NULL, 12357, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:19:50', 'admin-1503794105-15037967901125670', 1, 1, 'SR', NULL, NULL, NULL),
(44084, '2017-08-27 09:19:50', NULL, NULL, 12357, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:19:50', 'admin-1503794105-15037967901125670', 1, 1, 'SR', NULL, NULL, NULL),
(44085, '2017-08-27 09:19:50', NULL, NULL, 12357, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:19:50', 'admin-1503794105-15037967901125670', 1, 0, '', NULL, NULL, NULL),
(44086, '2017-08-27 09:19:32', NULL, NULL, 12357, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 09:19:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44087, '2017-08-27 15:44:18', NULL, NULL, 12417, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1503814520', 'admin', '2017-08-27 15:44:18', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(44088, '2017-08-27 15:44:30', NULL, NULL, 12417, 0, 77, '77', 'Sarawak Kolomee', 'mai chai', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 15:44:30', 'admin-1503814520-15038198705282558', 1, 1, 'SR', NULL, NULL, '10.0'),
(44089, '2017-08-27 16:00:22', NULL, NULL, 12418, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1503814520', 'admin', '2017-08-27 16:00:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44090, '2017-08-27 16:00:32', NULL, NULL, 12418, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 16:00:32', 'admin-1503814520-1503820831861196', 1, 0, '', NULL, NULL, NULL),
(44091, '2017-08-27 16:00:32', NULL, NULL, 12418, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 16:00:32', 'admin-1503814520-1503820831861196', 1, 1, 'SR', NULL, NULL, NULL),
(44092, '2017-08-27 16:00:32', NULL, NULL, 12418, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 16:00:32', 'admin-1503814520-1503820831861196', 1, 0, '', NULL, NULL, NULL),
(44093, '2017-08-27 16:20:28', NULL, NULL, 12416, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 16:20:28', 'admin-1503814520-1503822028355897', 1, 1, 'SR', NULL, NULL, NULL),
(44094, '2017-08-27 16:22:19', NULL, NULL, 12419, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1503814520', 'admin', '2017-08-27 16:22:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44095, '2017-08-27 16:22:24', NULL, NULL, 12419, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 16:22:24', 'admin-1503814520-15038221441821336', 1, 1, 'SR', NULL, NULL, NULL),
(44096, '2017-08-27 16:52:28', NULL, NULL, 12420, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1503814520', 'admin', '2017-08-27 16:52:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44097, '2017-08-27 16:52:31', NULL, NULL, 12420, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 16:52:31', 'admin-1503814520-15038239512892287', 1, 1, 'SR', NULL, NULL, NULL),
(44098, '2017-08-27 17:03:16', NULL, NULL, 12421, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1503814520', 'admin', '2017-08-27 17:03:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44099, '2017-08-27 17:03:27', NULL, NULL, 12421, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 17:03:27', 'admin-1503814520-15038246070524934', 1, 1, 'SR', NULL, NULL, NULL),
(44100, '2017-08-27 17:03:27', NULL, NULL, 12421, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 17:03:27', 'admin-1503814520-15038246070524934', 1, 1, 'SR', NULL, NULL, NULL),
(44101, '2017-08-27 17:03:27', NULL, NULL, 12421, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 17:03:27', 'admin-1503814520-15038246070524934', 1, 0, '', NULL, NULL, NULL),
(44102, '2017-08-27 17:03:27', NULL, NULL, 12421, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 17:03:27', 'admin-1503814520-15038246070524934', 1, 0, '', NULL, NULL, NULL),
(44103, '2017-08-27 17:21:35', NULL, NULL, 12422, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.59, 0.0000, 0.0000, 2.59, 1, '27', 1, '1503814520', 'admin', '2017-08-27 17:21:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44104, '2017-08-27 17:21:41', NULL, NULL, 12422, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 17:21:41', 'admin-1503814520-15038257009918824', 1, 1, 'SR', NULL, NULL, NULL),
(44105, '2017-08-27 17:21:41', NULL, NULL, 12422, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 17:21:41', 'admin-1503814520-15038257009918824', 1, 1, 'SR', NULL, NULL, NULL),
(44106, '2017-08-27 17:29:04', NULL, NULL, 12421, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503814520', 'admin', '2017-08-27 17:29:04', 'admin-1503814520-15038261443838493', 1, 0, '', NULL, NULL, NULL),
(44107, '2017-08-27 17:53:40', NULL, NULL, 12422, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1503814520', 'admin', '2017-08-27 17:53:40', 'admin-1503814520-15038276203678228', 1, 0, '', NULL, NULL, NULL),
(44108, '2017-08-28 17:51:24', NULL, NULL, 12454, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 17:51:24', 'admin-1503898703-15039138840488012', 1, 0, '', NULL, NULL, '10.0'),
(44109, '2017-08-28 17:51:24', NULL, NULL, 12454, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 17:51:24', 'admin-1503898703-15039138840488012', 1, 0, '', NULL, NULL, '10.0'),
(44110, '2017-08-28 11:51:17', NULL, NULL, 12428, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 11:51:17', 'admin-1503882076-15038922773683861', 1, 0, '', NULL, NULL, NULL),
(44111, '2017-08-28 13:10:28', NULL, NULL, 12438, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:10:28', 'admin-1503882076-15038970282196071', 1, 1, 'SR', NULL, NULL, NULL),
(44112, '2017-08-28 13:10:28', NULL, NULL, 12438, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:10:28', 'admin-1503882076-15038970282196071', 1, 0, '', NULL, NULL, NULL),
(44113, '2017-08-28 13:11:13', NULL, NULL, 12438, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:11:13', 'admin-1503882076-15038970728565173', 1, 1, 'SR', NULL, NULL, NULL),
(44114, '2017-08-28 14:28:41', NULL, NULL, 12447, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 14:28:41', 'admin-1503898703-15039017210004732', 1, 1, 'SR', NULL, NULL, NULL),
(44115, '2017-08-28 13:28:59', NULL, NULL, 12440, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:28:59', 'admin-1503882076-15038981397894934', 1, 1, 'SR', NULL, NULL, NULL),
(44116, '2017-08-28 15:03:24', NULL, NULL, 12450, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 15:03:24', 'admin-1503898703-15039038045859496', 1, 0, '', NULL, NULL, NULL),
(44117, '2017-08-28 00:00:00', NULL, NULL, 12452, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 15:31:37', 'admin-1503898703-15039054977064673', 1, 1, 'SR', NULL, NULL, NULL),
(44118, '2017-08-28 15:02:16', NULL, NULL, 12450, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1503898703', 'admin', '2017-08-28 15:02:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44119, '2017-08-28 15:03:24', NULL, NULL, 12450, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 15:03:24', 'admin-1503898703-15039038045859496', 1, 0, '', NULL, NULL, NULL),
(44120, '2017-08-28 00:00:00', NULL, NULL, 12434, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:05:41', 'admin-1503882076-15038931408491676', 1, 1, 'SR', NULL, NULL, NULL),
(44121, '2017-08-28 12:39:29', NULL, NULL, 12432, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:39:29', 'admin-1503882076-15038951691618867', 1, 0, '', NULL, NULL, NULL),
(44122, '2017-08-28 14:33:49', NULL, NULL, 12449, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 14:33:49', 'admin-1503898703-15039020296279716', 1, 0, '', 1, NULL, '10.0'),
(44123, '2017-08-28 13:09:50', NULL, NULL, 12438, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:09:50', 'admin-1503882076-1503896990259643', 1, 0, '', NULL, NULL, NULL),
(44124, '2017-08-28 14:28:41', NULL, NULL, 12447, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 14:28:41', 'admin-1503898703-15039017210004732', 1, 1, 'SR', NULL, NULL, NULL),
(44125, '2017-08-28 13:38:37', NULL, NULL, 12441, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:38:37', 'admin-1503898703-15038987174503296', 1, 1, 'SR', NULL, NULL, NULL),
(44126, '2017-08-28 13:13:07', NULL, NULL, 12440, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:13:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44127, '2017-08-28 13:54:21', NULL, NULL, 12443, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:54:21', 'admin-1503898703-1503899661143666', 1, 1, 'SR', NULL, NULL, NULL),
(44128, '2017-08-28 13:54:16', NULL, NULL, 12443, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:54:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44129, '2017-08-28 12:57:30', NULL, NULL, 12436, 0, 223, '157', 'Crispy Bacon Aglio Olio', 'Add garlic', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:57:30', 'admin-1503882076-15038962501184917', 1, 0, '', NULL, NULL, NULL),
(44130, '2017-08-28 12:57:30', NULL, NULL, 12436, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:57:30', 'admin-1503882076-15038962501184917', 1, 1, 'SR', NULL, NULL, NULL),
(44131, '2017-08-28 12:57:30', NULL, NULL, 12436, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:57:30', 'admin-1503882076-15038962501184917', 1, 1, 'SR', NULL, NULL, NULL),
(44132, '2017-08-28 12:57:30', NULL, NULL, 12436, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:57:30', 'admin-1503882076-15038962501184917', 1, 0, '', NULL, NULL, NULL),
(44133, '2017-08-28 13:06:50', NULL, NULL, 12437, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:06:50', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(44134, '2017-08-28 13:07:00', NULL, NULL, 12437, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:07:00', 'admin-1503882076-1503896820226881', 1, 0, '', NULL, NULL, '10.0'),
(44135, '2017-08-28 13:07:00', NULL, NULL, 12437, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', 'Add rice', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:07:00', 'admin-1503882076-1503896820226881', 1, 0, '', NULL, NULL, '10.0'),
(44136, '2017-08-28 14:13:30', NULL, NULL, 12443, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 14:13:30', 'admin-1503898703-15039008105262134', 1, 1, 'SR', NULL, NULL, NULL),
(44137, '2017-08-28 00:00:00', NULL, NULL, 12448, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 14:17:15', 'admin-1503898703-15039010350589117', 1, 0, '', NULL, NULL, NULL),
(44138, '2017-08-28 14:19:51', NULL, NULL, 12443, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 14:19:51', 'admin-1503898703-15039011916686649', 1, 1, 'SR', NULL, NULL, NULL),
(44139, '2017-08-28 14:22:54', NULL, NULL, 12445, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1503898703', 'admin', '2017-08-28 14:22:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44140, '2017-08-28 14:22:57', NULL, NULL, 12445, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 14:22:57', 'admin-1503898703-15039013769534094', 1, 1, 'SR', NULL, NULL, NULL),
(44141, '2017-08-28 00:00:00', NULL, NULL, 12448, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.39, NULL, NULL, 1.39, 1, '27', 1, '1503898703', 'admin', '2017-08-28 14:27:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44142, '2017-08-28 13:12:44', NULL, NULL, 12439, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:12:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44143, '2017-08-28 11:40:06', NULL, NULL, 12427, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1503898703', 'admin', '2017-08-28 11:40:06', 'admin-1503882076-15038916067988060', 1, 0, '', NULL, NULL, NULL),
(44144, '2017-08-28 15:25:33', NULL, NULL, 12451, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1503898703', 'admin', '2017-08-28 15:25:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44145, '2017-08-28 15:25:38', NULL, NULL, 12451, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 15:25:38', 'admin-1503898703-15039051375454973', 1, 1, 'SR', NULL, NULL, NULL),
(44146, '2017-08-28 15:51:38', NULL, NULL, 12452, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1503898703', 'admin', '2017-08-28 15:51:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44147, '2017-08-28 17:43:45', NULL, NULL, 12453, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1503898703', 'admin', '2017-08-28 17:43:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44148, '2017-08-28 17:43:53', NULL, NULL, 12453, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 17:43:53', 'admin-1503898703-15039134337468912', 1, 1, 'SR', NULL, NULL, NULL),
(44149, '2017-08-28 17:51:14', NULL, NULL, 12454, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1503898703', 'admin', '2017-08-28 17:51:14', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(44150, '2017-08-28 17:51:24', NULL, NULL, 12454, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 17:51:24', 'admin-1503898703-15039138840488012', 1, 0, '', NULL, NULL, '10.0'),
(44151, '2017-08-28 12:57:30', NULL, NULL, 12436, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:57:30', 'admin-1503882076-15038962501184917', 1, 1, 'SR', NULL, NULL, NULL),
(44152, '2017-08-28 14:05:37', NULL, NULL, 12439, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 14:05:37', 'admin-1503898703-15039003377542849', 1, 0, '', NULL, NULL, NULL),
(44153, '2017-08-28 14:09:46', NULL, NULL, 12444, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1503898703', 'admin', '2017-08-28 14:09:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44154, '2017-08-28 14:09:54', NULL, NULL, 12444, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 14:09:54', 'admin-1503898703-15039005940985457', 1, 1, 'SR', NULL, NULL, NULL),
(44155, '2017-08-28 14:09:54', NULL, NULL, 12444, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 14:09:54', 'admin-1503898703-15039005940985457', 1, 1, 'SR', NULL, NULL, NULL),
(44156, '2017-08-28 14:09:54', NULL, NULL, 12444, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 14:09:54', 'admin-1503898703-15039005940985457', 1, 0, '', NULL, NULL, NULL),
(44157, '2017-08-28 14:09:54', NULL, NULL, 12444, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 14:09:54', 'admin-1503898703-15039005940985457', 1, 0, '', NULL, NULL, NULL),
(44158, '2017-08-28 14:13:30', NULL, NULL, 12443, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 14:13:30', 'admin-1503898703-15039008105262134', 1, 1, 'SR', NULL, NULL, NULL),
(44159, '2017-08-28 00:00:00', NULL, NULL, 12448, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, NULL, NULL, 3.90, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:39:35', 'admin-1503882076-1503895175705719', 1, 0, '', NULL, NULL, NULL),
(44160, '2017-08-28 14:28:41', NULL, NULL, 12447, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 14:28:41', 'admin-1503898703-15039017210004732', 1, 0, '', NULL, NULL, NULL),
(44161, '2017-08-28 14:28:41', NULL, NULL, 12447, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 14:28:41', 'admin-1503898703-15039017210004732', 1, 0, '', NULL, NULL, NULL),
(44162, '2017-08-28 00:00:00', NULL, NULL, 12435, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:05:41', 'admin-1503882076-15038931408491676', 1, 0, '', NULL, NULL, NULL),
(44163, '2017-08-28 10:29:26', NULL, NULL, 12426, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 10:29:26', 'admin-1503882076-15038873661006565', 1, 0, '', NULL, NULL, NULL),
(44164, '2017-08-28 10:29:26', NULL, NULL, 12426, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 10:29:26', 'admin-1503882076-15038873661006565', 1, 1, 'SR', NULL, NULL, NULL),
(44165, '2017-08-28 10:29:26', NULL, NULL, 12426, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 10:29:26', 'admin-1503882076-15038873661006565', 1, 0, '', NULL, NULL, NULL),
(44166, '2017-08-28 13:39:03', NULL, NULL, 12441, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:39:03', 'admin-1503898703-1503898742814174', 1, 0, '', NULL, NULL, NULL),
(44167, '2017-08-28 13:50:27', NULL, NULL, 12442, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:50:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44168, '2017-08-28 13:50:51', NULL, NULL, 12442, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:50:51', 'admin-1503898703-15038994511237020', 1, 1, 'SR', NULL, NULL, NULL),
(44169, '2017-08-28 13:50:51', NULL, NULL, 12442, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:50:51', 'admin-1503898703-15038994511237020', 1, 1, 'SR', NULL, NULL, NULL),
(44170, '2017-08-28 13:50:51', NULL, NULL, 12442, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:50:51', 'admin-1503898703-15038994511237020', 1, 1, 'SR', NULL, NULL, NULL),
(44171, '2017-08-28 13:50:51', NULL, NULL, 12442, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:50:51', 'admin-1503898703-15038994511237020', 1, 1, 'SR', NULL, NULL, NULL),
(44172, '2017-08-28 13:50:51', NULL, NULL, 12442, 0, 74, '74', 'Sunrice', '', 'Meals', 'Perfect Meals', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:50:51', 'admin-1503898703-15038994511237020', 1, 1, 'SR', NULL, NULL, NULL),
(44173, '2017-08-28 13:13:09', NULL, NULL, 12440, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:13:09', 'admin-1503882076-15038971893546493', 1, 1, 'SR', NULL, NULL, NULL),
(44174, '2017-08-28 13:38:37', NULL, NULL, 12441, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:38:37', 'admin-1503898703-15038987174503296', 1, 0, '', NULL, NULL, NULL),
(44175, '2017-08-28 13:38:19', NULL, NULL, 12441, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:38:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44176, '2017-08-28 13:32:29', NULL, NULL, 12437, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:32:29', 'admin-1503882076-15038983488251582', 1, 0, '', NULL, NULL, '10.0'),
(44177, '2017-08-28 12:57:30', NULL, NULL, 12436, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:57:30', 'admin-1503882076-15038962501184917', 1, 0, '', NULL, NULL, NULL),
(44178, '2017-08-28 13:28:59', NULL, NULL, 12440, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:28:59', 'admin-1503882076-15038981397894934', 1, 1, 'SR', NULL, NULL, NULL),
(44179, '2017-08-28 13:12:50', NULL, NULL, 12439, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:12:50', 'admin-1503882076-15038971703654594', 1, 1, 'SR', NULL, NULL, NULL),
(44180, '2017-08-28 13:12:50', NULL, NULL, 12439, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:12:50', 'admin-1503882076-15038971703654594', 1, 1, 'SR', NULL, NULL, NULL),
(44181, '2017-08-28 13:12:50', NULL, NULL, 12439, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:12:50', 'admin-1503882076-15038971703654594', 1, 1, 'SR', NULL, NULL, NULL),
(44182, '2017-08-28 13:09:23', NULL, NULL, 12438, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:09:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44183, '2017-08-28 11:51:31', NULL, NULL, 12428, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 11:51:31', 'admin-1503882076-15038922910876875', 1, 0, '', NULL, NULL, NULL),
(44184, '2017-08-28 13:38:37', NULL, NULL, 12441, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:38:37', 'admin-1503898703-15038987174503296', 1, 1, 'SR', NULL, NULL, NULL),
(44185, '2017-08-28 13:09:26', NULL, NULL, 12438, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:09:26', 'admin-1503882076-15038969668224485', 1, 1, 'SR', NULL, NULL, NULL),
(44186, '2017-08-28 00:00:00', NULL, NULL, 12433, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:05:41', 'admin-1503882076-15038931408491676', 1, 1, 'SR', NULL, NULL, NULL),
(44187, '2017-08-28 12:15:40', NULL, NULL, 12428, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:15:40', 'admin-1503882076-15038937400127048', 1, 1, 'SR', NULL, NULL, NULL),
(44188, '2017-08-28 12:30:11', NULL, NULL, 12431, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:30:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44189, '2017-08-28 12:30:15', NULL, NULL, 12431, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:30:15', 'admin-1503882076-15038946151399721', 1, 0, '', NULL, NULL, NULL),
(44190, '2017-08-28 12:57:30', NULL, NULL, 12436, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:57:30', 'admin-1503882076-15038962501184917', 1, 0, '', NULL, NULL, NULL),
(44191, '2017-08-28 11:40:06', NULL, NULL, 12427, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 11:40:06', 'admin-1503882076-15038916067988060', 1, 0, '', NULL, NULL, NULL),
(44192, '2017-08-28 11:40:06', NULL, NULL, 12427, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 11:40:07', 'admin-1503882076-15038916067988060', 1, 1, 'SR', NULL, NULL, NULL),
(44193, '2017-08-28 11:48:59', NULL, NULL, 12428, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1503898703', 'admin', '2017-08-28 11:48:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44194, '2017-08-28 12:57:01', NULL, NULL, 12436, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.10, 0.0000, 0.0000, 10.10, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:57:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44195, '2017-08-28 12:30:15', NULL, NULL, 12431, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:30:15', 'admin-1503882076-15038946151399721', 1, 1, 'SR', NULL, NULL, NULL),
(44196, '2017-08-28 12:39:24', NULL, NULL, 12432, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:39:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44197, '2017-08-28 12:30:15', NULL, NULL, 12431, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:30:15', 'admin-1503882076-15038946151399721', 1, 1, 'SR', NULL, NULL, NULL),
(44198, '2017-08-28 13:50:51', NULL, NULL, 12442, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 13:50:51', 'admin-1503898703-15038994511237020', 1, 0, '', NULL, NULL, NULL),
(44199, '2017-08-28 00:00:00', NULL, NULL, 12433, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, NULL, NULL, 6.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:05:41', 'admin-1503882076-15038931408491676', 1, 1, 'SR', NULL, NULL, NULL),
(44200, '2017-08-28 00:00:00', NULL, NULL, 12448, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:39:29', 'admin-1503882076-15038951691618867', 1, 1, 'SR', NULL, NULL, NULL),
(44201, '2017-08-28 14:28:30', NULL, NULL, 12447, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1503898703', 'admin', '2017-08-28 14:28:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44202, '2017-08-28 12:51:00', NULL, NULL, 12433, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:51:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44203, '2017-08-28 12:51:36', NULL, NULL, 12434, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:51:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44204, '2017-08-28 00:00:00', NULL, NULL, 12435, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, NULL, NULL, 1.80, 1, '27', 1, '1503898703', 'admin', '2017-08-28 11:57:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44205, '2017-08-28 12:01:38', NULL, NULL, 12430, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 12:01:38', 'admin-1503882076-15038928985719967', 1, 0, '', NULL, NULL, NULL),
(44206, '2017-08-28 11:59:16', NULL, NULL, 12430, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 11:59:16', 'admin-1503882076-15038927564336770', 1, 0, '', NULL, NULL, NULL),
(44207, '2017-08-28 11:59:14', NULL, NULL, 12430, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1503898703', 'admin', '2017-08-28 11:59:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44208, '2017-08-28 11:51:31', NULL, NULL, 12428, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 11:51:31', 'admin-1503882076-15038922910876875', 1, 1, 'SR', NULL, NULL, NULL),
(44209, '2017-08-28 11:51:31', NULL, NULL, 12428, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 11:51:31', 'admin-1503882076-15038922910876875', 1, 1, 'SR', NULL, NULL, NULL),
(44210, '2017-08-28 11:51:17', NULL, NULL, 12428, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 11:51:17', 'admin-1503882076-15038922773683861', 1, 0, '', NULL, NULL, NULL),
(44211, '2017-08-28 11:40:06', NULL, NULL, 12427, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 11:40:06', 'admin-1503882076-15038916067988060', 1, 1, 'SR', NULL, NULL, NULL),
(44212, '2017-08-28 11:39:54', NULL, NULL, 12427, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 11:39:54', 'admin-1503882076-1503891594385339', 1, 0, '', NULL, NULL, NULL),
(44213, '2017-08-28 11:39:54', NULL, NULL, 12427, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 11:39:54', 'admin-1503882076-1503891594385339', 1, 0, '', NULL, NULL, NULL),
(44214, '2017-08-28 11:39:49', NULL, NULL, 12427, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.59, 0.0000, 0.0000, 6.59, 1, '27', 1, '1503898703', 'admin', '2017-08-28 11:39:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44215, '2017-08-28 11:19:30', NULL, NULL, 12425, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 11:19:30', 'admin-1503882076-15038903706004652', 1, 1, 'SR', NULL, NULL, NULL),
(44216, '2017-08-28 10:29:26', NULL, NULL, 12426, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 10:29:26', 'admin-1503882076-15038873661006565', 1, 0, '', NULL, NULL, NULL),
(44217, '2017-08-28 10:29:15', NULL, NULL, 12426, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1503898703', 'admin', '2017-08-28 10:29:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44218, '2017-08-28 10:05:34', NULL, NULL, 12425, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 10:05:34', 'admin-1503882076-1503885934307348', 1, 1, 'SR', NULL, NULL, NULL),
(44219, '2017-08-28 10:01:28', NULL, NULL, 12425, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 10:01:28', 'admin-1503882076-15038856884404525', 1, 0, '', NULL, NULL, NULL),
(44220, '2017-08-28 09:45:49', NULL, NULL, 12424, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 09:45:49', 'admin-1503882076-15038847491272124', 1, 0, '', NULL, NULL, NULL),
(44221, '2017-08-28 09:45:49', NULL, NULL, 12424, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 09:45:49', 'admin-1503882076-15038847491272124', 1, 0, '', NULL, NULL, NULL),
(44222, '2017-08-28 09:45:49', NULL, NULL, 12424, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 09:45:49', 'admin-1503882076-15038847491272124', 1, 1, 'SR', NULL, NULL, NULL),
(44223, '2017-08-28 09:45:49', NULL, NULL, 12424, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 09:45:49', 'admin-1503882076-15038847491272124', 1, 0, '', NULL, NULL, NULL),
(44224, '2017-08-28 09:45:49', NULL, NULL, 12424, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 09:45:49', 'admin-1503882076-15038847491272124', 1, 0, '', NULL, NULL, NULL),
(44225, '2017-08-28 09:45:49', NULL, NULL, 12424, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 09:45:49', 'admin-1503882076-15038847491272124', 1, 0, '', NULL, NULL, NULL),
(44226, '2017-08-28 09:35:53', NULL, NULL, 12423, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 09:35:53', 'admin-1503882076-15038841535454488', 1, 0, '', NULL, NULL, NULL),
(44227, '2017-08-28 09:35:53', NULL, NULL, 12423, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 09:35:53', 'admin-1503882076-15038841535454488', 1, 0, '', NULL, NULL, NULL),
(44228, '2017-08-28 09:35:53', NULL, NULL, 12423, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 09:35:53', 'admin-1503882076-15038841535454488', 1, 1, 'SR', NULL, NULL, NULL),
(44229, '2017-08-28 09:31:04', NULL, NULL, 12423, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 09:31:04', 'admin-1503882076-15038838641833351', 1, 1, 'SR', NULL, NULL, NULL),
(44230, '2017-08-28 09:28:51', NULL, NULL, 12423, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 09:28:51', 'admin-1503882076-15038837312405766', 1, 0, '', NULL, NULL, NULL),
(44231, '2017-08-28 10:01:23', NULL, NULL, 12425, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1503898703', 'admin', '2017-08-28 10:01:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44232, '2017-08-28 09:45:49', NULL, NULL, 12424, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 09:45:49', 'admin-1503882076-15038847491272124', 1, 1, 'SR', NULL, NULL, NULL),
(44233, '2017-08-28 09:45:49', NULL, NULL, 12424, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 09:45:49', 'admin-1503882076-15038847491272124', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(44234, '2017-08-28 09:45:49', NULL, NULL, 12424, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 09:45:49', 'admin-1503882076-15038847491272124', 1, 0, '', NULL, NULL, NULL),
(44235, '2017-08-28 09:45:24', NULL, NULL, 12424, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.80, 0.0000, 0.0000, 11.80, 1, '27', 1, '1503898703', 'admin', '2017-08-28 09:45:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44236, '2017-08-28 09:31:04', NULL, NULL, 12423, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 09:31:04', 'admin-1503882076-15038838641833351', 1, 1, 'SR', NULL, NULL, NULL),
(44237, '2017-08-28 09:28:51', NULL, NULL, 12423, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1503898703', 'admin', '2017-08-28 09:28:51', 'admin-1503882076-15038837312405766', 1, 0, '', NULL, NULL, NULL),
(44238, '2017-08-28 09:28:45', NULL, NULL, 12423, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.80, 0.0000, 0.0000, 9.80, 1, '27', 1, '1503898703', 'admin', '2017-08-28 09:28:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44239, '2017-08-30 12:44:23', NULL, NULL, 12466, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 12:44:23', 'admin-1504060332-15040682630061289', 1, 1, 'SR', NULL, NULL, NULL),
(44240, '2017-08-30 11:27:23', NULL, NULL, 12462, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 11:27:23', 'admin-1504060332-15040636432612726', 1, 0, '', NULL, NULL, NULL),
(44241, '2017-08-30 13:02:18', NULL, NULL, 12466, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 13:02:18', 'admin-1504060332-15040693378824146', 1, 1, 'SR', NULL, NULL, NULL),
(44242, '2017-08-30 12:04:55', NULL, NULL, 12464, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1504070318', 'admin', '2017-08-30 12:04:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44243, '2017-08-30 11:19:56', NULL, NULL, 12463, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1504070318', 'admin', '2017-08-30 11:19:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44244, '2017-08-30 12:44:33', NULL, NULL, 12466, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 3, 9.00, 27.0000, 0.0000, 27.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 12:44:33', 'admin-1504060332-15040682735327327', 1, 1, 'SR', NULL, NULL, NULL),
(44245, '2017-08-30 10:54:45', NULL, NULL, 12461, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:54:45', 'admin-1504060332-15040616852322060', 1, 0, '', NULL, NULL, NULL),
(44246, '2017-08-30 11:02:16', NULL, NULL, 12462, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 11:02:16', 'admin-1504060332-15040621361221664', 1, 1, 'SR', NULL, NULL, NULL),
(44247, '2017-08-30 12:05:03', NULL, NULL, 12464, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 12:05:03', 'admin-1504060332-1504065903349356', 1, 1, 'SR', NULL, NULL, NULL),
(44248, '2017-08-30 12:05:03', NULL, NULL, 12464, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 12:05:03', 'admin-1504060332-1504065903349356', 1, 0, '', NULL, NULL, NULL),
(44249, '2017-08-30 12:32:10', NULL, NULL, 12465, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1504070318', 'admin', '2017-08-30 12:32:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44250, '2017-08-30 12:32:57', NULL, NULL, 12465, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 12:32:57', 'admin-1504060332-15040675775011393', 1, 0, '', NULL, NULL, NULL),
(44251, '2017-08-30 13:55:04', NULL, NULL, 12465, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504070318', 'lois', '2017-08-30 13:55:04', 'lois-1504070318-15040725044111633', 1, 0, '', NULL, NULL, NULL),
(44252, '2017-08-30 12:32:57', NULL, NULL, 12465, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 12:32:57', 'admin-1504060332-15040675775011393', 1, 1, 'SR', NULL, NULL, NULL),
(44253, '2017-08-30 12:32:57', NULL, NULL, 12465, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 12:32:57', 'admin-1504060332-15040675775011393', 1, 0, '', NULL, NULL, NULL),
(44254, '2017-08-30 11:02:16', NULL, NULL, 12462, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 11:02:16', 'admin-1504060332-15040621361221664', 1, 1, 'SR', NULL, NULL, NULL),
(44255, '2017-08-30 11:02:16', NULL, NULL, 12462, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 11:02:16', 'admin-1504060332-15040621361221664', 1, 1, 'SR', NULL, NULL, NULL),
(44256, '2017-08-30 13:07:10', NULL, NULL, 12465, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 13:07:10', 'admin-1504060332-1504069630063618', 1, 1, 'SR', NULL, NULL, NULL),
(44257, '2017-08-30 13:18:18', NULL, NULL, 12468, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 49.66, 0.0000, 0.0000, 49.66, 1, '27', 1, '1504070318', 'admin', '2017-08-30 13:18:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44258, '2017-08-30 13:18:30', NULL, NULL, 12468, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 13:18:30', 'admin-1504060332-15040703106163149', 1, 0, '', NULL, NULL, NULL),
(44259, '2017-08-30 13:18:30', NULL, NULL, 12468, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', 'ex rice', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 13:18:30', 'admin-1504060332-15040703106163149', 1, 1, 'SR', NULL, NULL, NULL),
(44260, '2017-08-30 13:18:52', NULL, NULL, 12469, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1504070318', 'lois', '2017-08-30 13:18:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44261, '2017-08-30 13:19:16', NULL, NULL, 12469, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504070318', 'lois', '2017-08-30 13:19:16', 'lois-1504070318-15040703567403193', 1, 1, 'SR', NULL, NULL, NULL),
(44262, '2017-08-30 13:19:16', NULL, NULL, 12469, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504070318', 'lois', '2017-08-30 13:19:16', 'lois-1504070318-15040703567403193', 1, 1, 'SR', NULL, NULL, NULL),
(44263, '2017-08-30 13:19:16', NULL, NULL, 12469, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504070318', 'lois', '2017-08-30 13:19:16', 'lois-1504070318-15040703567403193', 1, 0, '', NULL, NULL, NULL),
(44264, '2017-08-30 13:56:06', NULL, NULL, 12468, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504070318', 'lois', '2017-08-30 13:56:06', 'lois-1504070318-15040725664299891', 1, 1, 'SR', NULL, NULL, NULL),
(44265, '2017-08-30 14:28:38', NULL, NULL, 12468, 0, 182, '117', 'Open Drinks ', 'Craft Beer', 'Cold Drinks', 'Fresh Juice', 1, 453.60, 453.6000, 0.0000, 453.60, 1, '27', 1, '1504070318', 'lois', '2017-08-30 14:28:38', 'lois-1504070318-15040745184756479', 1, 0, '', NULL, NULL, NULL),
(44266, '2017-08-30 14:31:48', NULL, NULL, 12469, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504070318', 'lois', '2017-08-30 14:31:48', 'lois-1504070318-1504074707965777', 1, 1, 'SR', NULL, NULL, NULL),
(44267, '2017-08-30 14:31:51', NULL, NULL, 12469, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504070318', 'lois', '2017-08-30 14:31:51', 'lois-1504070318-15040747112598188', 1, 1, 'SR', NULL, NULL, NULL),
(44268, '2017-08-30 15:38:11', NULL, NULL, 12470, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504070318', 'lois', '2017-08-30 15:38:11', 'lois-1504070318-1504078690789385', 1, 1, 'SR', NULL, NULL, '10.0'),
(44269, '2017-08-30 15:38:06', NULL, NULL, 12470, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1504070318', 'lois', '2017-08-30 15:38:06', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(44270, '2017-08-30 10:54:45', NULL, NULL, 12461, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:54:45', 'admin-1504060332-15040616852322060', 1, 1, 'SR', NULL, NULL, NULL),
(44271, '2017-08-30 13:02:02', NULL, NULL, 12467, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 13:02:02', 'admin-1504060332-15040693223303497', 1, 0, '', NULL, NULL, NULL),
(44272, '2017-08-30 13:01:56', NULL, NULL, 12467, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1504070318', 'admin', '2017-08-30 13:01:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44273, '2017-08-30 10:32:27', NULL, NULL, 12460, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:32:27', 'admin-1504060332-1504060347153586', 1, 0, '', NULL, NULL, NULL),
(44274, '2017-08-30 10:32:27', NULL, NULL, 12460, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:32:27', 'admin-1504060332-1504060347153586', 1, 1, 'SR', NULL, NULL, NULL),
(44275, '2017-08-30 11:02:16', NULL, NULL, 12462, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 11:02:16', 'admin-1504060332-15040621361221664', 1, 0, '', NULL, NULL, NULL),
(44276, '2017-08-30 12:46:15', NULL, NULL, 12466, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 12:46:15', 'admin-1504060332-15040683751996287', 1, 0, '', NULL, NULL, NULL),
(44277, '2017-08-30 12:43:55', NULL, NULL, 12466, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.80, 0.0000, 0.0000, 13.80, 1, '27', 1, '1504070318', 'admin', '2017-08-30 12:43:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44278, '2017-08-30 12:44:23', NULL, NULL, 12466, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 12:44:23', 'admin-1504060332-15040682630061289', 1, 0, '', NULL, NULL, NULL),
(44279, '2017-08-30 12:44:23', NULL, NULL, 12466, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 12:44:23', 'admin-1504060332-15040682630061289', 1, 1, 'SR', NULL, NULL, NULL),
(44280, '2017-08-30 12:46:15', NULL, NULL, 12466, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 12:46:15', 'admin-1504060332-15040683751996287', 1, 0, '', NULL, NULL, NULL),
(44281, '2017-08-30 12:44:23', NULL, NULL, 12466, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 12:44:23', 'admin-1504060332-15040682630061289', 1, 1, 'SR', NULL, NULL, NULL),
(44282, '2017-08-30 11:20:33', NULL, NULL, 12463, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 11:20:33', 'admin-1504060332-15040632336518176', 1, 1, 'SR', NULL, NULL, NULL),
(44283, '2017-08-30 11:20:48', NULL, NULL, 12463, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 11:20:48', 'admin-1504060332-1504063248506345', 1, 1, 'SR', NULL, NULL, NULL),
(44284, '2017-08-30 11:20:33', NULL, NULL, 12463, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 11:20:33', 'admin-1504060332-15040632336518176', 1, 0, '', NULL, NULL, NULL),
(44285, '2017-08-30 11:02:16', NULL, NULL, 12462, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 11:02:16', 'admin-1504060332-15040621361221664', 1, 0, '', NULL, NULL, NULL),
(44286, '2017-08-30 11:02:16', NULL, NULL, 12462, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 11:02:16', 'admin-1504060332-15040621361221664', 1, 1, 'SR', NULL, NULL, NULL),
(44287, '2017-08-30 11:02:16', NULL, NULL, 12462, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 11:02:16', 'admin-1504060332-15040621361221664', 1, 0, '', NULL, NULL, NULL),
(44288, '2017-08-30 11:02:16', NULL, NULL, 12462, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 11:02:16', 'admin-1504060332-15040621361221664', 1, 0, '', NULL, NULL, NULL),
(44289, '2017-08-30 11:02:16', NULL, NULL, 12462, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 11:02:16', 'admin-1504060332-15040621361221664', 1, 0, '', NULL, NULL, NULL),
(44290, '2017-08-30 10:48:04', NULL, NULL, 12458, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:48:04', 'admin-1504060332-15040612841255356', 1, 1, 'SR', NULL, NULL, NULL),
(44291, '2017-08-30 10:54:28', NULL, NULL, 12461, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:54:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44292, '2017-08-30 11:01:05', NULL, NULL, 12462, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.00, 0.0000, 0.0000, 15.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 11:01:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44293, '2017-08-30 11:02:16', NULL, NULL, 12462, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 11:02:16', 'admin-1504060332-15040621361221664', 1, 0, '', NULL, NULL, NULL),
(44294, '2017-08-30 10:54:45', NULL, NULL, 12461, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:54:45', 'admin-1504060332-15040616852322060', 1, 0, '', NULL, NULL, NULL),
(44295, '2017-08-30 10:54:45', NULL, NULL, 12461, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:54:45', 'admin-1504060332-15040616852322060', 1, 1, 'SR', NULL, NULL, NULL),
(44296, '2017-08-30 10:54:45', NULL, NULL, 12461, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:54:45', 'admin-1504060332-15040616852322060', 1, 0, '', NULL, NULL, NULL),
(44297, '2017-08-30 10:54:45', NULL, NULL, 12461, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:54:45', 'admin-1504060332-15040616852322060', 1, 0, '', NULL, NULL, NULL),
(44298, '2017-08-30 10:32:41', NULL, NULL, 12460, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:32:41', 'admin-1504060332-15040603612398971', 1, 0, '', NULL, NULL, NULL),
(44299, '2017-08-30 09:32:26', NULL, NULL, 12456, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 09:32:26', 'admin-1504055748-1504056746469895', 1, 0, '', NULL, NULL, NULL),
(44300, '2017-08-30 09:40:48', NULL, NULL, 12456, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 09:40:48', 'admin-1504055748-15040572483263022', 1, 0, '', NULL, NULL, NULL),
(44301, '2017-08-30 10:04:50', NULL, NULL, 12457, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:04:50', 'admin-1504055748-15040586900392687', 1, 0, '', NULL, NULL, NULL),
(44302, '2017-08-30 10:04:50', NULL, NULL, 12457, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:04:50', 'admin-1504055748-15040586900392687', 1, 0, '', NULL, NULL, NULL),
(44303, '2017-08-30 10:04:50', NULL, NULL, 12457, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:04:50', 'admin-1504055748-15040586900392687', 1, 1, 'SR', NULL, NULL, NULL),
(44304, '2017-08-30 10:04:50', NULL, NULL, 12457, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:04:50', 'admin-1504055748-15040586900392687', 1, 1, 'SR', NULL, NULL, NULL),
(44305, '2017-08-30 10:04:50', NULL, NULL, 12457, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:04:50', 'admin-1504055748-15040586900392687', 1, 1, 'SR', NULL, NULL, NULL),
(44306, '2017-08-30 10:08:03', NULL, NULL, 12458, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:08:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44307, '2017-08-30 10:08:10', NULL, NULL, 12458, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:08:10', 'admin-1504055748-1504058890217677', 1, 0, '', NULL, NULL, NULL),
(44308, '2017-08-30 10:08:10', NULL, NULL, 12458, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:08:10', 'admin-1504055748-1504058890217677', 1, 0, '', NULL, NULL, NULL),
(44309, '2017-08-30 10:19:18', NULL, NULL, 12459, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:19:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44310, '2017-08-30 10:19:28', NULL, NULL, 12459, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:19:28', 'admin-1504055748-15040595683921757', 1, 0, '', NULL, NULL, NULL),
(44311, '2017-08-30 10:19:28', NULL, NULL, 12459, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:19:28', 'admin-1504055748-15040595683921757', 1, 1, 'SR', NULL, NULL, NULL),
(44312, '2017-08-30 10:19:28', NULL, NULL, 12459, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:19:28', 'admin-1504055748-15040595683921757', 1, 1, 'SR', NULL, NULL, NULL),
(44313, '2017-08-30 10:32:07', NULL, NULL, 12460, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:32:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44314, '2017-08-30 10:32:27', NULL, NULL, 12460, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:32:27', 'admin-1504060332-1504060347153586', 1, 0, '', NULL, NULL, NULL),
(44315, '2017-08-30 09:30:20', NULL, NULL, 12456, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 09:30:20', 'admin-1504055748-15040566198881823', 1, 0, '', NULL, NULL, NULL),
(44316, '2017-08-30 09:30:20', NULL, NULL, 12456, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 09:30:20', 'admin-1504055748-15040566198881823', 1, 0, '', NULL, NULL, NULL),
(44317, '2017-08-30 09:33:03', NULL, NULL, 12456, 0, 270, '204', 'Homemade Savoury Pancake', 'Change to french toast bread', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 09:33:03', 'admin-1504055748-15040567836201115', 1, 0, '', NULL, NULL, NULL),
(44318, '2017-08-30 09:32:19', NULL, NULL, 12456, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 09:32:19', 'admin-1504055748-15040567392222818', 1, 0, '', NULL, NULL, NULL),
(44319, '2017-08-30 09:32:26', NULL, NULL, 12456, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 09:32:26', 'admin-1504055748-1504056746469895', 1, 1, 'SR', NULL, NULL, NULL),
(44320, '2017-08-30 09:30:20', NULL, NULL, 12456, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 09:30:20', 'admin-1504055748-15040566198881823', 1, 0, '', NULL, NULL, NULL),
(44321, '2017-08-30 09:23:40', NULL, NULL, 12455, 0, 181, '116', 'Open Food ', 'scramble eggs with bread', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 09:23:40', 'admin-1504055748-15040562207317980', 1, 0, '', NULL, NULL, NULL),
(44322, '2017-08-30 09:23:50', NULL, NULL, 12455, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504070318', 'admin', '2017-08-30 09:23:50', 'admin-1504055748-15040562307921533', 1, 1, 'SR', NULL, NULL, NULL),
(44323, '2017-08-30 10:04:38', NULL, NULL, 12457, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1504070318', 'admin', '2017-08-30 10:04:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44324, '2017-08-30 09:30:11', NULL, NULL, 12456, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.10, 0.0000, 0.0000, 11.10, 1, '27', 1, '1504070318', 'admin', '2017-08-30 09:30:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44325, '2017-08-30 09:23:08', NULL, NULL, 12455, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1504070318', 'admin', '2017-08-30 09:23:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44326, '2017-08-31 12:53:35', NULL, NULL, 12498, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:53:35', 'admin-1504152136-15041552148297180', 1, 1, 'SR', NULL, NULL, NULL),
(44327, '2017-08-31 17:20:52', NULL, NULL, 12520, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 17:20:52', 'admin-1504161458-15041712525349511', 1, 1, 'SR', NULL, NULL, NULL),
(44328, '2017-08-31 15:48:19', NULL, NULL, 12513, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:48:19', 'admin-1504161458-15041656990537058', 1, 1, 'SR', NULL, NULL, NULL),
(44329, '2017-08-31 16:47:04', NULL, NULL, 12517, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:47:04', 'admin-1504161458-15041692240823583', 1, 1, 'SR', NULL, NULL, NULL),
(44330, '2017-08-31 15:48:19', NULL, NULL, 12513, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:48:19', 'admin-1504161458-15041656990537058', 1, 1, 'SR', NULL, NULL, NULL),
(44331, '2017-08-31 15:48:19', NULL, NULL, 12513, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:48:19', 'admin-1504161458-15041656990537058', 1, 1, 'SR', NULL, NULL, NULL),
(44332, '2017-08-31 16:29:32', NULL, NULL, 12513, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:29:32', 'admin-1504161458-1504168172725898', 1, 0, '', NULL, NULL, NULL),
(44333, '2017-08-31 16:31:28', NULL, NULL, 12515, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:31:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44334, '2017-08-31 16:31:31', NULL, NULL, 12515, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:31:31', 'admin-1504161458-15041682910858920', 1, 1, 'SR', NULL, NULL, NULL),
(44335, '2017-08-31 16:32:01', NULL, NULL, 12516, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:32:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44336, '2017-08-31 16:32:08', NULL, NULL, 12516, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:32:08', 'admin-1504161458-15041683281281961', 1, 0, '', NULL, NULL, NULL),
(44337, '2017-08-31 17:12:47', NULL, NULL, 12519, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1504161458', 'admin', '2017-08-31 17:12:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44338, '2017-08-31 17:12:59', NULL, NULL, 12519, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 17:12:59', 'admin-1504161458-15041707794464151', 1, 0, '', NULL, NULL, NULL),
(44339, '2017-08-31 17:12:59', NULL, NULL, 12519, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 17:12:59', 'admin-1504161458-15041707794464151', 1, 0, '', NULL, NULL, NULL),
(44340, '2017-08-31 15:35:24', NULL, NULL, 12512, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:35:24', 'admin-1504161458-1504164924225277', 1, 1, 'SR', NULL, NULL, NULL),
(44341, '2017-08-31 15:47:18', NULL, NULL, 12513, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:47:18', 'admin-1504161458-15041656386132246', 1, 1, 'SR', NULL, NULL, NULL),
(44342, '2017-08-31 15:47:18', NULL, NULL, 12513, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:47:18', 'admin-1504161458-15041656386132246', 1, 1, 'SR', NULL, NULL, NULL),
(44343, '2017-08-31 15:47:18', NULL, NULL, 12513, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:47:18', 'admin-1504161458-15041656386132246', 1, 0, '', NULL, NULL, NULL),
(44344, '2017-08-31 15:22:37', NULL, NULL, 12511, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:22:37', 'admin-1504161458-15041641573936165', 1, 1, 'SR', NULL, NULL, NULL),
(44345, '2017-08-31 15:22:37', NULL, NULL, 12511, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:22:37', 'admin-1504161458-15041641573936165', 1, 1, 'SR', NULL, NULL, NULL),
(44346, '2017-08-31 15:22:37', NULL, NULL, 12511, 0, 181, '116', 'Open Food ', 'French Fries', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:22:37', 'admin-1504161458-15041641573936165', 1, 0, '', NULL, NULL, NULL),
(44347, '2017-08-31 15:26:30', NULL, NULL, 12511, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:26:30', 'admin-1504161458-15041643906039654', 1, 1, 'SR', NULL, NULL, NULL),
(44348, '2017-08-31 15:34:56', NULL, NULL, 12512, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:34:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44349, '2017-08-31 15:35:24', NULL, NULL, 12512, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:35:24', 'admin-1504161458-1504164924225277', 1, 0, '', NULL, NULL, NULL),
(44350, '2017-08-31 15:35:24', NULL, NULL, 12512, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:35:24', 'admin-1504161458-1504164924225277', 1, 0, '', NULL, NULL, NULL),
(44351, '2017-08-31 15:35:24', NULL, NULL, 12512, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:35:24', 'admin-1504161458-1504164924225277', 1, 1, 'SR', NULL, NULL, NULL),
(44352, '2017-08-31 12:41:39', NULL, NULL, 12496, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:41:39', 'admin-1504152136-15041544991485429', 1, 0, '', NULL, NULL, NULL),
(44353, '2017-08-31 12:41:39', NULL, NULL, 12496, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:41:39', 'admin-1504152136-15041544991485429', 1, 0, '', NULL, NULL, NULL),
(44354, '2017-08-31 12:45:41', NULL, NULL, 12497, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:45:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44355, '2017-08-31 12:09:05', NULL, NULL, 12492, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:09:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44356, '2017-08-31 12:09:14', NULL, NULL, 12492, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:09:14', 'admin-1504152136-1504152554720715', 1, 1, 'SR', NULL, NULL, NULL),
(44357, '2017-08-31 12:09:14', NULL, NULL, 12492, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:09:14', 'admin-1504152136-1504152554720715', 1, 1, 'SR', NULL, NULL, NULL),
(44358, '2017-08-31 10:17:44', NULL, NULL, 12481, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:17:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44359, '2017-08-31 13:54:34', NULL, NULL, 12502, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 13:54:34', 'admin-1504152136-15041588742448991', 1, 0, '', NULL, NULL, NULL),
(44360, '2017-08-31 13:50:36', NULL, NULL, 12501, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 13:50:36', 'admin-1504152136-15041586366357911', 1, 0, '', 1, NULL, NULL),
(44361, '2017-08-31 13:53:52', NULL, NULL, 12502, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.20, 0.0000, 0.0000, 9.20, 1, '27', 1, '1504161458', 'admin', '2017-08-31 13:53:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44362, '2017-08-31 15:48:19', NULL, NULL, 12513, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:48:19', 'admin-1504161458-15041656990537058', 1, 1, 'SR', NULL, NULL, NULL),
(44363, '2017-08-31 15:48:51', NULL, NULL, 12513, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:48:51', 'admin-1504161458-15041657309027095', 1, 0, '', NULL, NULL, NULL),
(44364, '2017-08-31 16:13:39', NULL, NULL, 12514, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:13:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44365, '2017-08-31 16:13:54', NULL, NULL, 12514, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:13:54', 'admin-1504161458-1504167233946495', 1, 0, '', NULL, NULL, NULL),
(44366, '2017-08-31 16:13:54', NULL, NULL, 12514, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:13:54', 'admin-1504161458-1504167233946495', 1, 0, '', NULL, NULL, NULL),
(44367, '2017-08-31 13:34:29', NULL, NULL, 12499, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1504161458', 'admin', '2017-08-31 13:34:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44368, '2017-08-31 13:34:33', NULL, NULL, 12499, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 13:34:33', 'admin-1504152136-15041576733983849', 1, 1, 'SR', NULL, NULL, NULL),
(44369, '2017-08-31 13:46:15', NULL, NULL, 12500, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1504161458', 'admin', '2017-08-31 13:46:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44370, '2017-08-31 16:13:54', NULL, NULL, 12514, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:13:54', 'admin-1504161458-1504167233946495', 1, 0, '', NULL, NULL, NULL),
(44371, '2017-08-31 16:13:54', NULL, NULL, 12514, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:13:54', 'admin-1504161458-1504167233946495', 1, 1, 'SR', NULL, NULL, NULL),
(44372, '2017-08-31 16:42:50', NULL, NULL, 12517, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:42:50', 'admin-1504161458-15041689699305559', 1, 0, '', NULL, NULL, NULL),
(44373, '2017-08-31 16:42:50', NULL, NULL, 12517, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:42:50', 'admin-1504161458-15041689699305559', 1, 0, '', NULL, NULL, NULL),
(44374, '2017-08-31 15:48:19', NULL, NULL, 12513, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:48:19', 'admin-1504161458-15041656990537058', 1, 1, 'SR', NULL, NULL, NULL),
(44375, '2017-08-31 15:48:19', NULL, NULL, 12513, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:48:19', 'admin-1504161458-15041656990537058', 1, 0, '', NULL, NULL, NULL),
(44376, '2017-08-31 17:05:59', NULL, NULL, 12518, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1504161458', 'admin', '2017-08-31 17:05:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44377, '2017-08-31 17:08:15', NULL, NULL, 12518, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 17:08:15', 'admin-1504161458-15041704956804260', 1, 0, '', NULL, NULL, NULL),
(44378, '2017-08-31 12:14:57', NULL, NULL, 12493, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:14:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44379, '2017-08-31 12:07:41', NULL, NULL, 12491, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:07:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44380, '2017-08-31 12:08:55', NULL, NULL, 12491, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:08:55', 'admin-1504152136-1504152534939838', 1, 0, '', NULL, NULL, NULL),
(44381, '2017-08-31 12:08:55', NULL, NULL, 12491, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:08:55', 'admin-1504152136-1504152534939838', 1, 0, '', NULL, NULL, NULL),
(44382, '2017-08-31 12:08:55', NULL, NULL, 12491, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:08:55', 'admin-1504152136-1504152534939838', 1, 1, 'SR', NULL, NULL, NULL),
(44383, '2017-08-31 14:37:46', NULL, NULL, 12507, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 14:37:46', 'admin-1504161458-15041614664353990', 1, 1, 'SR', 1, NULL, '10.0'),
(44384, '2017-08-31 14:56:00', NULL, NULL, 12508, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1504161458', 'admin', '2017-08-31 14:56:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44385, '2017-08-31 14:56:19', NULL, NULL, 12508, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 14:56:19', 'admin-1504161458-15041625796934734', 1, 1, 'SR', NULL, NULL, NULL),
(44386, '2017-08-31 14:56:19', NULL, NULL, 12508, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 14:56:19', 'admin-1504161458-15041625796934734', 1, 0, '', NULL, NULL, NULL),
(44387, '2017-08-31 12:29:02', NULL, NULL, 12495, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:29:02', 'admin-1504152136-15041537420847098', 1, 0, '', NULL, NULL, NULL),
(44388, '2017-08-31 12:21:03', NULL, NULL, 12494, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:21:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44389, '2017-08-31 12:29:02', NULL, NULL, 12495, 0, 153, '87', 'Wake Me Up!', 'add on potato', 'Meals', 'Morning Bites ', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:29:02', 'admin-1504152136-15041537420847098', 1, 0, '', NULL, NULL, NULL),
(44390, '2017-08-31 11:56:18', NULL, NULL, 12489, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 11:56:18', 'admin-1504146305-15041517785151287', 1, 0, '', NULL, NULL, NULL),
(44391, '2017-08-31 11:56:18', NULL, NULL, 12489, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 11:56:18', 'admin-1504146305-15041517785151287', 1, 0, '', NULL, NULL, NULL),
(44392, '2017-08-31 14:56:19', NULL, NULL, 12508, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 14:56:19', 'admin-1504161458-15041625796934734', 1, 0, '', NULL, NULL, NULL),
(44393, '2017-08-31 14:56:33', NULL, NULL, 12508, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 14:56:33', 'admin-1504161458-1504162593596413', 1, 0, '', NULL, NULL, NULL),
(44394, '2017-08-31 14:56:33', NULL, NULL, 12508, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 14:56:33', 'admin-1504161458-1504162593596413', 1, 0, '', NULL, NULL, NULL),
(44395, '2017-08-31 14:56:33', NULL, NULL, 12508, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 14:56:33', 'admin-1504161458-1504162593596413', 1, 1, 'SR', NULL, NULL, NULL),
(44396, '2017-08-31 15:08:27', NULL, NULL, 12509, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:08:27', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(44397, '2017-08-31 15:08:30', NULL, NULL, 12509, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:08:30', 'admin-1504161458-15041633101772935', 1, 0, '', NULL, NULL, '10.0'),
(44398, '2017-08-31 15:09:41', NULL, NULL, 12509, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:09:41', 'admin-1504161458-15041633812745184', 1, 0, '', NULL, NULL, '10.0'),
(44399, '2017-08-31 15:10:44', NULL, NULL, 12509, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:10:44', 'admin-1504161458-15041634444618049', 1, 0, '', NULL, NULL, '10.0'),
(44400, '2017-08-31 15:10:44', NULL, NULL, 12509, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:10:44', 'admin-1504161458-15041634444618049', 1, 0, '', NULL, NULL, '10.0'),
(44401, '2017-08-31 15:20:58', NULL, NULL, 12510, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:20:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44402, '2017-08-31 15:21:08', NULL, NULL, 12510, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:21:08', 'admin-1504161458-15041640686699413', 1, 0, '', NULL, NULL, NULL),
(44403, '2017-08-31 15:21:08', NULL, NULL, 12510, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:21:08', 'admin-1504161458-15041640686699413', 1, 0, '', NULL, NULL, NULL),
(44404, '2017-08-31 15:21:08', NULL, NULL, 12510, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:21:08', 'admin-1504161458-15041640686699413', 1, 0, '', NULL, NULL, NULL),
(44405, '2017-08-31 12:21:12', NULL, NULL, 12494, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:21:12', 'admin-1504152136-15041532720973577', 1, 1, 'SR', NULL, NULL, NULL),
(44406, '2017-08-31 12:28:31', NULL, NULL, 12495, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:28:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44407, '2017-08-31 17:08:15', NULL, NULL, 12518, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 17:08:15', 'admin-1504161458-15041704956804260', 1, 0, '', NULL, NULL, NULL),
(44408, '2017-08-31 17:20:45', NULL, NULL, 12520, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 17:20:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44409, '2017-08-31 17:08:23', NULL, NULL, 12518, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 17:08:23', 'admin-1504161458-15041705037055137', 1, 1, 'SR', NULL, NULL, NULL),
(44410, '2017-08-31 15:46:36', NULL, NULL, 12513, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 26.89, 0.0000, 0.0000, 26.89, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:46:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44411, '2017-08-31 15:47:18', NULL, NULL, 12513, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:47:18', 'admin-1504161458-15041656386132246', 1, 1, 'SR', NULL, NULL, NULL),
(44412, '2017-08-31 15:47:18', NULL, NULL, 12513, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:47:18', 'admin-1504161458-15041656386132246', 1, 1, 'SR', NULL, NULL, NULL),
(44413, '2017-08-31 15:47:18', NULL, NULL, 12513, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:47:18', 'admin-1504161458-15041656386132246', 1, 0, '', NULL, NULL, NULL),
(44414, '2017-08-31 15:47:18', NULL, NULL, 12513, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:47:18', 'admin-1504161458-15041656386132246', 1, 0, '', NULL, NULL, NULL),
(44415, '2017-08-31 16:42:55', NULL, NULL, 12517, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:42:55', 'admin-1504161458-15041689755847735', 1, 1, 'SR', NULL, NULL, NULL),
(44416, '2017-08-31 16:42:39', NULL, NULL, 12517, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:42:39', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(44417, '2017-08-31 16:36:22', NULL, NULL, 12515, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:36:22', 'admin-1504161458-150416858191751', 1, 0, '', NULL, NULL, NULL),
(44418, '2017-08-31 16:36:22', NULL, NULL, 12515, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:36:22', 'admin-1504161458-150416858191751', 1, 0, '', NULL, NULL, NULL),
(44419, '2017-08-31 16:32:08', NULL, NULL, 12516, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:32:08', 'admin-1504161458-15041683281281961', 1, 1, 'SR', NULL, NULL, NULL),
(44420, '2017-08-31 16:35:43', NULL, NULL, 12515, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:35:43', 'admin-1504161458-15041685432308715', 1, 0, '', NULL, NULL, NULL),
(44421, '2017-08-31 16:35:43', NULL, NULL, 12515, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:35:43', 'admin-1504161458-15041685432308715', 1, 1, 'SR', NULL, NULL, NULL),
(44422, '2017-08-31 16:35:43', NULL, NULL, 12515, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:35:43', 'admin-1504161458-15041685432308715', 1, 1, 'SR', NULL, NULL, NULL),
(44423, '2017-08-31 12:33:15', NULL, NULL, 12489, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:33:15', 'admin-1504152136-15041539952767415', 1, 0, '', NULL, NULL, NULL),
(44424, '2017-08-31 12:41:10', NULL, NULL, 12496, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:41:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44425, '2017-08-31 12:41:39', NULL, NULL, 12496, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:41:39', 'admin-1504152136-15041544991485429', 1, 0, '', NULL, NULL, NULL),
(44426, '2017-08-31 11:56:18', NULL, NULL, 12489, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 11:56:18', 'admin-1504146305-15041517785151287', 1, 0, '', NULL, NULL, NULL),
(44427, '2017-08-31 11:56:18', NULL, NULL, 12489, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 11:56:18', 'admin-1504146305-15041517785151287', 1, 0, '', NULL, NULL, NULL),
(44428, '2017-08-31 16:21:54', NULL, NULL, 12513, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:21:54', 'admin-1504161458-1504167714537617', 1, 1, 'SR', NULL, NULL, NULL),
(44429, '2017-08-31 12:29:02', NULL, NULL, 12495, 0, 153, '87', 'Wake Me Up!', 'add on potato', 'Meals', 'Morning Bites ', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:29:02', 'admin-1504152136-15041537420847098', 1, 0, '', NULL, NULL, NULL),
(44430, '2017-08-31 16:21:54', NULL, NULL, 12513, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:21:54', 'admin-1504161458-1504167714537617', 1, 1, 'SR', NULL, NULL, NULL),
(44431, '2017-08-31 14:12:52', NULL, NULL, 12505, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 14:12:52', 'admin-1504152136-15041599724007551', 1, 1, 'SR', NULL, NULL, NULL),
(44432, '2017-08-31 12:49:15', NULL, NULL, 12498, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:49:15', 'admin-1504152136-1504154955052790', 1, 1, 'SR', NULL, NULL, NULL),
(44433, '2017-08-31 13:54:34', NULL, NULL, 12502, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 13:54:34', 'admin-1504152136-15041588742448991', 1, 0, '', NULL, NULL, NULL),
(44434, '2017-08-31 13:54:43', NULL, NULL, 12503, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1504161458', 'admin', '2017-08-31 13:54:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44435, '2017-08-31 13:54:49', NULL, NULL, 12503, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 13:54:49', 'admin-1504152136-15041588894681449', 1, 0, '', NULL, NULL, NULL),
(44436, '2017-08-31 13:57:09', NULL, NULL, 12504, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 13:57:09', 'admin-1504152136-15041590288072676', 1, 0, '', 1, NULL, '10.0'),
(44437, '2017-08-31 13:58:16', NULL, NULL, 12502, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 13:58:16', 'admin-1504152136-15041590964377382', 1, 0, '', NULL, NULL, NULL),
(44438, '2017-08-31 13:58:16', NULL, NULL, 12502, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 13:58:16', 'admin-1504152136-15041590964377382', 1, 1, 'SR', NULL, NULL, NULL),
(44439, '2017-08-31 10:14:29', NULL, NULL, 12479, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:14:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44440, '2017-08-31 10:14:48', NULL, NULL, 12479, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:14:48', 'admin-1504140108-15041456883561285', 1, 0, '', NULL, NULL, NULL),
(44441, '2017-08-31 10:12:54', NULL, NULL, 12478, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:12:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44442, '2017-08-31 11:56:48', NULL, NULL, 12489, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 11:56:48', 'admin-1504146305-15041518085132537', 1, 1, 'SR', NULL, NULL, NULL),
(44443, '2017-08-31 15:48:19', NULL, NULL, 12513, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:48:19', 'admin-1504161458-15041656990537058', 1, 1, 'SR', NULL, NULL, NULL),
(44444, '2017-08-31 15:47:18', NULL, NULL, 12513, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:47:18', 'admin-1504161458-15041656386132246', 1, 0, '', NULL, NULL, NULL),
(44445, '2017-08-31 15:21:08', NULL, NULL, 12510, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:21:08', 'admin-1504161458-15041640686699413', 1, 1, 'SR', NULL, NULL, NULL),
(44446, '2017-08-31 15:22:16', NULL, NULL, 12511, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:22:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44447, '2017-08-31 15:22:37', NULL, NULL, 12511, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 15:22:37', 'admin-1504161458-15041641573936165', 1, 0, '', NULL, NULL, NULL),
(44448, '2017-08-31 12:21:12', NULL, NULL, 12494, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:21:12', 'admin-1504152136-15041532720973577', 1, 1, 'SR', NULL, NULL, NULL),
(44449, '2017-08-31 14:12:56', NULL, NULL, 12506, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1504161458', 'admin', '2017-08-31 14:12:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44450, '2017-08-31 14:13:03', NULL, NULL, 12506, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 14:13:03', 'admin-1504152136-15041599834477211', 1, 1, 'SR', NULL, NULL, NULL),
(44451, '2017-08-31 14:02:36', NULL, NULL, 12505, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 14:02:36', 'admin-1504152136-15041593562284261', 1, 0, '', NULL, NULL, NULL),
(44452, '2017-08-31 14:02:36', NULL, NULL, 12505, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 14:02:36', 'admin-1504152136-15041593562284261', 1, 1, 'SR', NULL, NULL, NULL),
(44453, '2017-08-31 14:01:41', NULL, NULL, 12505, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 14:01:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44454, '2017-08-31 14:02:36', NULL, NULL, 12505, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 14:02:36', 'admin-1504152136-15041593562284261', 1, 0, '', NULL, NULL, NULL),
(44455, '2017-08-31 10:54:56', NULL, NULL, 12486, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.90, 0.0000, 0.0000, 10.90, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:54:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44456, '2017-08-31 09:55:56', NULL, NULL, 12477, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:55:56', 'admin-1504140108-15041445559647289', 1, 1, 'SR', NULL, NULL, NULL),
(44457, '2017-08-31 12:15:37', NULL, NULL, 12493, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:15:37', 'admin-1504152136-15041529374341957', 1, 0, '', NULL, NULL, NULL),
(44458, '2017-08-31 13:58:16', NULL, NULL, 12502, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 13:58:16', 'admin-1504152136-15041590964377382', 1, 1, 'SR', NULL, NULL, NULL),
(44459, '2017-08-31 11:13:17', NULL, NULL, 12488, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 11:13:17', 'admin-1504146305-15041491971647381', 1, 0, '', NULL, NULL, NULL),
(44460, '2017-08-31 11:13:17', NULL, NULL, 12488, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 11:13:17', 'admin-1504146305-15041491971647381', 1, 0, '', NULL, NULL, NULL),
(44461, '2017-08-31 11:13:17', NULL, NULL, 12488, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 11:13:17', 'admin-1504146305-15041491971647381', 1, 1, 'SR', NULL, NULL, NULL),
(44462, '2017-08-31 11:17:45', NULL, NULL, 12480, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 11:17:45', 'admin-1504146305-15041494657007672', 1, 0, '', NULL, NULL, NULL),
(44463, '2017-08-31 12:41:39', NULL, NULL, 12496, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:41:39', 'admin-1504152136-15041544991485429', 1, 0, '', NULL, NULL, NULL),
(44464, '2017-08-31 10:16:07', NULL, NULL, 12480, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:16:07', 'admin-1504140108-15041457672746823', 1, 0, '', NULL, NULL, NULL),
(44465, '2017-08-31 10:16:07', NULL, NULL, 12480, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:16:07', 'admin-1504140108-15041457672746823', 1, 0, '', NULL, NULL, NULL),
(44466, '2017-08-31 12:09:14', NULL, NULL, 12492, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:09:14', 'admin-1504152136-1504152554720715', 1, 0, '', NULL, NULL, NULL),
(44467, '2017-08-31 13:58:16', NULL, NULL, 12502, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 13:58:16', 'admin-1504152136-15041590964377382', 1, 1, 'SR', NULL, NULL, NULL),
(44468, '2017-08-31 12:49:04', NULL, NULL, 12498, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:49:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44469, '2017-08-31 12:45:53', NULL, NULL, 12497, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:45:53', 'admin-1504152136-15041547528598577', 1, 1, 'SR', NULL, NULL, NULL),
(44470, '2017-08-31 12:45:53', NULL, NULL, 12497, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:45:53', 'admin-1504152136-15041547528598577', 1, 1, 'SR', NULL, NULL, NULL),
(44471, '2017-08-31 12:02:07', NULL, NULL, 12490, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:02:07', 'admin-1504146305-15041521271954284', 1, 0, '', NULL, NULL, NULL),
(44472, '2017-08-31 12:02:07', NULL, NULL, 12490, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:02:07', 'admin-1504146305-15041521271954284', 1, 0, '', NULL, NULL, NULL),
(44473, '2017-08-31 12:02:07', NULL, NULL, 12490, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:02:07', 'admin-1504146305-15041521271954284', 1, 1, 'SR', NULL, NULL, NULL),
(44474, '2017-08-31 12:02:07', NULL, NULL, 12490, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:02:07', 'admin-1504146305-15041521271954284', 1, 0, '', NULL, NULL, NULL),
(44475, '2017-08-31 12:02:07', NULL, NULL, 12490, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:02:07', 'admin-1504146305-15041521271954284', 1, 1, 'SR', NULL, NULL, NULL),
(44476, '2017-08-31 12:02:07', NULL, NULL, 12490, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:02:07', 'admin-1504146305-15041521271954284', 1, 1, 'SR', NULL, NULL, NULL),
(44477, '2017-08-31 11:56:48', NULL, NULL, 12489, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 11:56:48', 'admin-1504146305-15041518085132537', 1, 1, 'SR', NULL, NULL, NULL),
(44478, '2017-08-31 11:13:17', NULL, NULL, 12488, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 11:13:17', 'admin-1504146305-15041491971647381', 1, 0, '', NULL, NULL, NULL),
(44479, '2017-08-31 10:57:59', NULL, NULL, 12486, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:57:59', 'admin-1504146305-15041482797745512', 1, 1, 'SR', NULL, NULL, NULL),
(44480, '2017-08-31 10:58:00', NULL, NULL, 12486, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:58:00', 'admin-1504146305-15041482797745512', 1, 1, 'SR', NULL, NULL, NULL),
(44481, '2017-08-31 10:58:00', NULL, NULL, 12486, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:58:00', 'admin-1504146305-15041482797745512', 1, 0, '', NULL, NULL, NULL),
(44482, '2017-08-31 11:06:31', NULL, NULL, 12487, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1504161458', 'admin', '2017-08-31 11:06:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44483, '2017-08-31 11:06:41', NULL, NULL, 12487, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 11:06:41', 'admin-1504146305-15041488014107662', 1, 0, '', NULL, NULL, NULL),
(44484, '2017-08-31 11:06:41', NULL, NULL, 12487, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 11:06:41', 'admin-1504146305-15041488014107662', 1, 0, '', NULL, NULL, NULL),
(44485, '2017-08-31 11:06:41', NULL, NULL, 12487, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 11:06:41', 'admin-1504146305-15041488014107662', 1, 0, '', NULL, NULL, NULL),
(44486, '2017-08-31 11:12:47', NULL, NULL, 12488, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1504161458', 'admin', '2017-08-31 11:12:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44487, '2017-08-31 12:08:55', NULL, NULL, 12491, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:08:55', 'admin-1504152136-1504152534939838', 1, 1, 'SR', NULL, NULL, NULL),
(44488, '2017-08-31 10:57:59', NULL, NULL, 12486, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:57:59', 'admin-1504146305-15041482797745512', 1, 1, 'SR', NULL, NULL, NULL),
(44489, '2017-08-31 10:55:40', NULL, NULL, 12485, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:55:40', 'admin-1504146305-15041481401707478', 1, 0, '', NULL, NULL, NULL),
(44490, '2017-08-31 10:55:16', NULL, NULL, 12486, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:55:16', 'admin-1504146305-15041481162586839', 1, 0, '', NULL, NULL, NULL),
(44491, '2017-08-31 10:55:16', NULL, NULL, 12486, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:55:16', 'admin-1504146305-15041481162586839', 1, 0, '', NULL, NULL, NULL),
(44492, '2017-08-31 10:55:16', NULL, NULL, 12486, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:55:16', 'admin-1504146305-15041481162586839', 1, 0, '', NULL, NULL, NULL),
(44493, '2017-08-31 12:01:22', NULL, NULL, 12490, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:01:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44494, '2017-08-31 11:17:45', NULL, NULL, 12480, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 11:17:45', 'admin-1504146305-15041494657007672', 1, 1, 'SR', NULL, NULL, NULL),
(44495, '2017-08-31 10:55:16', NULL, NULL, 12486, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:55:16', 'admin-1504146305-15041481162586839', 1, 0, '', NULL, NULL, NULL),
(44496, '2017-08-31 11:56:48', NULL, NULL, 12489, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 11:56:48', 'admin-1504146305-15041518085132537', 1, 1, 'SR', NULL, NULL, NULL),
(44497, '2017-08-31 11:56:18', NULL, NULL, 12489, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 11:56:18', 'admin-1504146305-15041517785151287', 1, 0, '', NULL, NULL, NULL),
(44498, '2017-08-31 12:15:37', NULL, NULL, 12493, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:15:37', 'admin-1504152136-15041529374341957', 1, 1, 'SR', NULL, NULL, NULL),
(44499, '2017-08-31 10:54:04', NULL, NULL, 12485, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:54:04', 'admin-1504146305-15041480442951773', 1, 1, 'SR', NULL, NULL, NULL),
(44500, '2017-08-31 10:53:58', NULL, NULL, 12485, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:53:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44501, '2017-08-31 10:48:58', NULL, NULL, 12484, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:48:58', 'admin-1504146305-1504147738418367', 1, 1, 'SR', NULL, NULL, NULL),
(44502, '2017-08-31 10:46:55', NULL, NULL, 12484, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:46:55', 'admin-1504146305-15041476150339671', 1, 1, 'SR', NULL, NULL, NULL),
(44503, '2017-08-31 10:46:51', NULL, NULL, 12484, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:46:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44504, '2017-08-31 10:46:03', NULL, NULL, 12483, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:46:03', 'admin-1504146305-1504147562855637', 1, 1, 'SR', NULL, NULL, NULL),
(44505, '2017-08-31 10:46:03', NULL, NULL, 12483, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:46:03', 'admin-1504146305-1504147562855637', 1, 0, '', NULL, NULL, NULL),
(44506, '2017-08-31 10:35:37', NULL, NULL, 12483, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:35:37', 'admin-1504146305-15041469376257135', 1, 1, 'SR', NULL, NULL, NULL),
(44507, '2017-08-31 10:35:37', NULL, NULL, 12483, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:35:37', 'admin-1504146305-15041469376257135', 1, 0, '', NULL, NULL, NULL),
(44508, '2017-08-31 10:35:31', NULL, NULL, 12483, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:35:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44509, '2017-08-31 10:35:37', NULL, NULL, 12483, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:35:37', 'admin-1504146305-15041469376257135', 1, 0, '', NULL, NULL, NULL),
(44510, '2017-08-31 10:29:14', NULL, NULL, 12480, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:29:14', 'admin-1504146305-1504146554495177', 1, 0, '', NULL, NULL, NULL),
(44511, '2017-08-31 11:55:17', NULL, NULL, 12489, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.00, 0.0000, 0.0000, 15.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 11:55:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44512, '2017-08-31 10:25:20', NULL, NULL, 12482, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:25:20', 'admin-1504146305-15041463202255633', 1, 0, '', NULL, NULL, NULL),
(44513, '2017-08-31 10:25:20', NULL, NULL, 12482, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:25:20', 'admin-1504146305-15041463202255633', 1, 0, '', NULL, NULL, NULL),
(44514, '2017-08-31 10:25:20', NULL, NULL, 12482, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:25:20', 'admin-1504146305-15041463202255633', 1, 1, 'SR', NULL, NULL, NULL),
(44515, '2017-08-31 16:21:54', NULL, NULL, 12513, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 16:21:54', 'admin-1504161458-1504167714537617', 1, 0, '', NULL, NULL, NULL),
(44516, '2017-08-31 12:09:14', NULL, NULL, 12492, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:09:14', 'admin-1504152136-1504152554720715', 1, 0, '', NULL, NULL, NULL),
(44517, '2017-08-31 10:25:20', NULL, NULL, 12482, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:25:20', 'admin-1504146305-15041463202255633', 1, 0, '', NULL, NULL, NULL),
(44518, '2017-08-31 13:49:53', NULL, NULL, 12500, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 13:49:53', 'admin-1504152136-15041585928489851', 1, 1, 'SR', NULL, NULL, NULL),
(44519, '2017-08-31 13:46:31', NULL, NULL, 12500, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 13:46:31', 'admin-1504152136-15041583911059558', 1, 1, 'SR', NULL, NULL, NULL),
(44520, '2017-08-31 10:25:01', NULL, NULL, 12482, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:25:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44521, '2017-08-31 10:17:56', NULL, NULL, 12481, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:17:56', 'admin-1504140108-15041458763424568', 1, 0, '', NULL, NULL, NULL),
(44522, '2017-08-31 09:37:41', NULL, NULL, 12475, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:37:41', 'admin-1504140108-15041434617842296', 1, 0, '', NULL, NULL, NULL),
(44523, '2017-08-31 09:37:41', NULL, NULL, 12475, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:37:41', 'admin-1504140108-15041434617842296', 1, 0, '', NULL, NULL, NULL),
(44524, '2017-08-31 12:49:15', NULL, NULL, 12498, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 12:49:15', 'admin-1504152136-1504154955052790', 1, 0, '', NULL, NULL, NULL),
(44525, '2017-08-31 09:55:56', NULL, NULL, 12477, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:55:56', 'admin-1504140108-15041445559647289', 1, 1, 'SR', NULL, NULL, NULL),
(44526, '2017-08-31 10:17:56', NULL, NULL, 12481, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:17:56', 'admin-1504140108-15041458763424568', 1, 0, '', NULL, NULL, NULL),
(44527, '2017-08-31 11:56:18', NULL, NULL, 12489, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 11:56:18', 'admin-1504146305-15041517785151287', 1, 0, '', NULL, NULL, NULL),
(44528, '2017-08-31 10:15:57', NULL, NULL, 12480, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.40, 0.0000, 0.0000, 11.40, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:15:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44529, '2017-08-31 10:16:07', NULL, NULL, 12480, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:16:07', 'admin-1504140108-15041457672746823', 1, 0, '', NULL, NULL, NULL),
(44530, '2017-08-31 10:16:07', NULL, NULL, 12480, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:16:07', 'admin-1504140108-15041457672746823', 1, 0, '', NULL, NULL, NULL),
(44531, '2017-08-31 17:08:23', NULL, NULL, 12518, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 17:08:23', 'admin-1504161458-15041705037055137', 1, 1, 'SR', NULL, NULL, NULL),
(44532, '2017-08-31 11:56:48', NULL, NULL, 12489, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 11:56:48', 'admin-1504146305-15041518085132537', 1, 1, 'SR', NULL, NULL, NULL),
(44533, '2017-08-31 10:13:10', NULL, NULL, 12478, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:13:10', 'admin-1504140108-1504145589915962', 1, 1, 'SR', NULL, NULL, NULL),
(44534, '2017-08-31 10:13:10', NULL, NULL, 12478, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:13:10', 'admin-1504140108-1504145589915962', 1, 0, '', NULL, NULL, NULL),
(44535, '2017-08-31 10:17:56', NULL, NULL, 12481, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:17:56', 'admin-1504140108-15041458763424568', 1, 1, 'SR', NULL, NULL, NULL),
(44536, '2017-08-31 09:05:33', NULL, NULL, 12471, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:05:33', 'admin-1504140108-15041415332431931', 1, 1, 'SR', NULL, NULL, NULL),
(44537, '2017-08-31 09:05:33', NULL, NULL, 12471, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:05:33', 'admin-1504140108-15041415332431931', 1, 1, 'SR', NULL, NULL, NULL),
(44538, '2017-08-31 09:05:33', NULL, NULL, 12471, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:05:33', 'admin-1504140108-15041415332431931', 1, 1, 'SR', NULL, NULL, NULL),
(44539, '2017-08-31 09:05:33', NULL, NULL, 12471, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:05:33', 'admin-1504140108-15041415332431931', 1, 1, 'SR', NULL, NULL, NULL),
(44540, '2017-08-31 09:05:33', NULL, NULL, 12471, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:05:33', 'admin-1504140108-15041415332431931', 1, 1, 'SR', NULL, NULL, NULL),
(44541, '2017-08-31 09:06:58', NULL, NULL, 12471, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:06:58', 'admin-1504140108-1504141618346989', 1, 0, '', NULL, NULL, NULL),
(44542, '2017-08-31 09:10:20', NULL, NULL, 12472, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:10:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44543, '2017-08-31 09:05:33', NULL, NULL, 12471, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:05:33', 'admin-1504140108-15041415332431931', 1, 0, '', NULL, NULL, NULL),
(44544, '2017-08-31 09:05:33', NULL, NULL, 12471, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:05:33', 'admin-1504140108-15041415332431931', 1, 0, '', NULL, NULL, NULL),
(44545, '2017-08-31 10:17:56', NULL, NULL, 12481, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 10:17:56', 'admin-1504140108-15041458763424568', 1, 1, 'SR', NULL, NULL, NULL),
(44546, '2017-08-31 09:37:41', NULL, NULL, 12475, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:37:41', 'admin-1504140108-15041434617842296', 1, 0, '', NULL, NULL, NULL),
(44547, '2017-08-31 09:37:41', NULL, NULL, 12475, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:37:41', 'admin-1504140108-15041434617842296', 1, 1, 'SR', NULL, NULL, NULL),
(44548, '2017-08-31 09:43:24', NULL, NULL, 12476, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:43:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44549, '2017-08-31 09:43:29', NULL, NULL, 12476, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:43:29', 'admin-1504140108-15041438091329210', 1, 0, '', NULL, NULL, NULL),
(44550, '2017-08-31 09:55:35', NULL, NULL, 12477, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:55:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44551, '2017-08-31 09:55:56', NULL, NULL, 12477, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:55:56', 'admin-1504140108-15041445559647289', 1, 0, '', NULL, NULL, NULL),
(44552, '2017-08-31 09:55:56', NULL, NULL, 12477, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:55:56', 'admin-1504140108-15041445559647289', 1, 0, '', NULL, NULL, NULL),
(44553, '2017-08-31 09:22:49', NULL, NULL, 12472, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:22:49', 'admin-1504140108-1504142569061569', 1, 1, 'SR', NULL, NULL, NULL),
(44554, '2017-08-31 09:37:09', NULL, NULL, 12475, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:37:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44555, '2017-08-31 09:37:41', NULL, NULL, 12475, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:37:41', 'admin-1504140108-15041434617842296', 1, 0, '', NULL, NULL, NULL),
(44556, '2017-08-31 09:10:34', NULL, NULL, 12472, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:10:34', 'admin-1504140108-15041418346348099', 1, 0, '', NULL, NULL, NULL),
(44557, '2017-08-31 09:10:34', NULL, NULL, 12472, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:10:34', 'admin-1504140108-15041418346348099', 1, 0, '', NULL, NULL, NULL),
(44558, '2017-08-31 09:10:34', NULL, NULL, 12472, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:10:34', 'admin-1504140108-15041418346348099', 1, 1, 'SR', NULL, NULL, NULL),
(44559, '2017-08-31 09:10:34', NULL, NULL, 12472, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:10:34', 'admin-1504140108-15041418346348099', 1, 1, 'SR', NULL, NULL, NULL),
(44560, '2017-08-31 09:10:34', NULL, NULL, 12472, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:10:34', 'admin-1504140108-15041418346348099', 1, 1, 'SR', NULL, NULL, NULL),
(44561, '2017-08-31 09:14:10', NULL, NULL, 12473, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:14:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44562, '2017-08-31 09:14:27', NULL, NULL, 12473, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:14:27', 'admin-1504140108-15041420676697062', 1, 0, '', NULL, NULL, NULL),
(44563, '2017-08-31 09:14:27', NULL, NULL, 12473, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:14:27', 'admin-1504140108-15041420676697062', 1, 0, '', NULL, NULL, NULL),
(44564, '2017-08-31 09:14:27', NULL, NULL, 12473, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:14:27', 'admin-1504140108-15041420676697062', 1, 0, '', NULL, NULL, NULL),
(44565, '2017-08-31 09:14:27', NULL, NULL, 12473, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:14:27', 'admin-1504140108-15041420676697062', 1, 1, 'SR', NULL, NULL, NULL),
(44566, '2017-08-31 09:14:27', NULL, NULL, 12473, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:14:27', 'admin-1504140108-15041420676697062', 1, 0, '', NULL, NULL, NULL),
(44567, '2017-08-31 09:18:17', NULL, NULL, 12474, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.50, 0.0000, 0.0000, 10.50, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:18:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44568, '2017-08-31 09:18:46', NULL, NULL, 12474, 0, 153, '87', 'Wake Me Up!', 'Add fruits', 'Meals', 'Morning Bites ', 1, 26.00, 26.0000, 0.0000, 26.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:18:46', 'admin-1504140108-15041423259002060', 1, 0, '', NULL, NULL, NULL),
(44569, '2017-08-31 09:18:46', NULL, NULL, 12474, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:18:46', 'admin-1504140108-15041423259002060', 1, 1, 'SR', NULL, NULL, NULL),
(44570, '2017-08-31 09:18:46', NULL, NULL, 12474, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:18:46', 'admin-1504140108-15041423259002060', 1, 1, 'SR', NULL, NULL, NULL),
(44571, '2017-08-31 09:18:46', NULL, NULL, 12474, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:18:46', 'admin-1504140108-15041423259002060', 1, 1, 'SR', NULL, NULL, NULL),
(44572, '2017-08-31 09:18:46', NULL, NULL, 12474, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:18:46', 'admin-1504140108-15041423259002060', 1, 1, 'SR', NULL, NULL, NULL),
(44573, '2017-08-31 09:22:49', NULL, NULL, 12472, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:22:49', 'admin-1504140108-1504142569061569', 1, 0, '', NULL, NULL, NULL),
(44574, '2017-08-31 09:05:33', NULL, NULL, 12471, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:05:33', 'admin-1504140108-15041415332431931', 1, 0, '', NULL, NULL, NULL),
(44575, '2017-08-31 09:18:46', NULL, NULL, 12474, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:18:46', 'admin-1504140108-15041423259002060', 1, 0, '', NULL, NULL, NULL),
(44576, '2017-08-31 09:18:46', NULL, NULL, 12474, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:18:46', 'admin-1504140108-15041423259002060', 1, 0, '', NULL, NULL, NULL),
(44577, '2017-08-31 09:18:46', NULL, NULL, 12474, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:18:46', 'admin-1504140108-15041423259002060', 1, 0, '', NULL, NULL, NULL),
(44578, '2017-08-31 09:05:33', NULL, NULL, 12471, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:05:33', 'admin-1504140108-15041415332431931', 1, 0, '', NULL, NULL, NULL),
(44579, '2017-08-31 09:05:07', NULL, NULL, 12471, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.60, 0.0000, 0.0000, 13.60, 1, '27', 1, '1504161458', 'admin', '2017-08-31 09:05:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44580, '2017-09-01 15:48:59', NULL, NULL, 12560, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:48:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44581, '2017-09-01 14:45:25', NULL, NULL, 12554, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 14:45:25', 'admin-1504244728-15042483257014942', 1, 0, '', NULL, NULL, NULL),
(44582, '2017-09-01 14:48:27', NULL, NULL, 12555, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1504251976', 'admin', '2017-09-01 14:48:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44583, '2017-09-01 14:48:55', NULL, NULL, 12555, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 14:48:55', 'admin-1504244728-15042485350079573', 1, 1, 'SR', NULL, NULL, NULL),
(44584, '2017-09-01 14:48:55', NULL, NULL, 12555, 0, 223, '157', 'Crispy Bacon Aglio Olio', 'no spicy', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 14:48:55', 'admin-1504244728-15042485350079573', 1, 0, '', NULL, NULL, NULL),
(44585, '2017-09-01 14:49:19', NULL, NULL, 12555, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 14:49:19', 'admin-1504244728-15042485597964681', 1, 1, 'SR', NULL, NULL, NULL),
(44586, '2017-09-01 16:57:06', NULL, NULL, 12568, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 16:57:06', 'admin-1504251976-15042562264166049', 1, 0, '', NULL, NULL, NULL),
(44587, '2017-09-01 17:00:18', NULL, NULL, 12569, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 17:00:18', 'admin-1504251976-15042564186809362', 1, 0, '', 1, NULL, NULL),
(44588, '2017-09-01 16:15:23', NULL, NULL, 12565, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 16:15:23', 'admin-1504251976-150425372299122', 1, 0, '', 1, NULL, '10.0'),
(44589, '2017-09-01 16:20:35', NULL, NULL, 12557, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 16:20:35', 'admin-1504251976-15042540354134732', 1, 1, 'SR', NULL, NULL, NULL),
(44590, '2017-09-01 14:49:19', NULL, NULL, 12555, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 14:49:20', 'admin-1504244728-15042485597964681', 1, 0, '', NULL, NULL, NULL),
(44591, '2017-09-01 15:04:36', NULL, NULL, 12556, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:04:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44592, '2017-09-01 15:04:47', NULL, NULL, 12556, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:04:47', 'admin-1504244728-15042494873539548', 1, 0, '', NULL, NULL, NULL),
(44593, '2017-09-01 15:04:47', NULL, NULL, 12556, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:04:47', 'admin-1504244728-15042494873539548', 1, 1, 'SR', NULL, NULL, NULL),
(44594, '2017-09-01 14:03:33', NULL, NULL, 12553, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 14:03:33', 'admin-1504244728-15042458128712671', 1, 1, 'SR', NULL, NULL, '10.0'),
(44595, '2017-09-01 14:24:28', NULL, NULL, 12549, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 14:24:28', 'admin-1504244728-1504247068697243', 1, 0, '', NULL, NULL, NULL),
(44596, '2017-09-01 14:29:05', NULL, NULL, 12552, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 14:29:05', 'admin-1504244728-15042473454907489', 1, 1, 'SR', NULL, NULL, NULL),
(44597, '2017-09-01 14:45:00', NULL, NULL, 12554, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1504251976', 'admin', '2017-09-01 14:45:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44598, '2017-09-01 14:45:25', NULL, NULL, 12554, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 14:45:25', 'admin-1504244728-15042483257014942', 1, 0, '', NULL, NULL, NULL),
(44599, '2017-09-01 14:45:25', NULL, NULL, 12554, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 14:45:25', 'admin-1504244728-15042483257014942', 1, 0, '', NULL, NULL, NULL),
(44600, '2017-09-01 14:45:25', NULL, NULL, 12554, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 14:45:25', 'admin-1504244728-15042483257014942', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(44601, '2017-09-01 13:11:27', NULL, NULL, 12548, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 18.20, 0.0000, 0.0000, 18.20, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:11:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44602, '2017-09-01 13:12:33', NULL, NULL, 12548, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:12:33', 'admin-1504238239-1504242753757312', 1, 1, 'SR', NULL, NULL, NULL),
(44603, '2017-09-01 13:12:33', NULL, NULL, 12548, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:12:33', 'admin-1504238239-1504242753757312', 1, 0, '', NULL, NULL, NULL),
(44604, '2017-09-01 13:14:53', NULL, NULL, 12548, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:14:53', 'admin-1504238239-1504242893023353', 1, 1, 'SR', NULL, NULL, NULL),
(44605, '2017-09-01 11:13:56', NULL, NULL, 12533, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:13:56', 'admin-1504235199-1504235636702963', 1, 1, 'SR', NULL, NULL, NULL),
(44606, '2017-09-01 11:13:56', NULL, NULL, 12533, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:13:56', 'admin-1504235199-1504235636702963', 1, 1, 'SR', NULL, NULL, NULL),
(44607, '2017-09-01 11:19:14', NULL, NULL, 12534, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.35, 0.0000, 0.0000, 6.35, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:19:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44608, '2017-09-01 13:14:53', NULL, NULL, 12548, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:14:53', 'admin-1504238239-1504242893023353', 1, 0, '', NULL, NULL, NULL),
(44609, '2017-09-01 15:04:57', NULL, NULL, 12556, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:04:57', 'admin-1504244728-15042494975036385', 1, 0, '', NULL, NULL, NULL),
(44610, '2017-09-01 13:18:02', NULL, NULL, 12549, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:18:02', 'admin-1504238239-15042430826629724', 1, 1, 'SR', NULL, NULL, NULL),
(44611, '2017-09-01 13:18:02', NULL, NULL, 12549, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:18:02', 'admin-1504238239-15042430826629724', 1, 1, 'SR', NULL, NULL, NULL),
(44612, '2017-09-01 13:18:36', NULL, NULL, 12550, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:18:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44613, '2017-09-01 11:25:12', NULL, NULL, 12535, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:25:12', 'admin-1504235199-15042363123932987', 1, 0, '', NULL, NULL, NULL),
(44614, '2017-09-01 11:25:12', NULL, NULL, 12535, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:25:12', 'admin-1504235199-15042363123932987', 1, 0, '', NULL, NULL, NULL),
(44615, '2017-09-01 13:14:53', NULL, NULL, 12548, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:14:53', 'admin-1504238239-1504242893023353', 1, 1, 'SR', NULL, NULL, NULL),
(44616, '2017-09-01 13:43:49', NULL, NULL, 12552, 0, 182, '117', 'Open Drinks ', 'yogurt', 'Cold Drinks', 'Fresh Juice', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:43:49', 'admin-1504238239-15042446298461453', 1, 0, '', NULL, NULL, NULL),
(44617, '2017-09-01 13:45:17', NULL, NULL, 12552, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:45:17', 'admin-1504238239-15042447169775938', 1, 1, 'SR', NULL, NULL, NULL),
(44618, '2017-09-01 13:45:17', NULL, NULL, 12552, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:45:17', 'admin-1504238239-15042447169775938', 1, 0, '', NULL, NULL, NULL),
(44619, '2017-09-01 11:57:11', NULL, NULL, 12539, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:57:11', 'admin-1504235199-15042382312097722', 1, 0, '', NULL, NULL, NULL),
(44620, '2017-09-01 11:54:08', NULL, NULL, 12538, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:54:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44621, '2017-09-01 11:54:37', NULL, NULL, 12539, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:54:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44622, '2017-09-01 11:39:30', NULL, NULL, 12537, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:39:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44623, '2017-09-01 16:41:48', NULL, NULL, 12568, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 16:41:48', 'admin-1504251976-15042553083153890', 1, 0, '', NULL, NULL, NULL),
(44624, '2017-09-01 16:33:31', NULL, NULL, 12568, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 16:33:31', 'admin-1504251976-15042548111883646', 1, 1, 'SR', NULL, NULL, NULL),
(44625, '2017-09-01 16:33:31', NULL, NULL, 12568, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 16:33:31', 'admin-1504251976-15042548111883646', 1, 1, 'SR', NULL, NULL, NULL),
(44626, '2017-09-01 16:33:22', NULL, NULL, 12568, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1504251976', 'admin', '2017-09-01 16:33:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44627, '2017-09-01 16:27:59', NULL, NULL, 12567, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 16:27:59', 'admin-1504251976-15042544789608462', 1, 0, '', NULL, NULL, NULL),
(44628, '2017-09-01 16:27:59', NULL, NULL, 12567, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 16:27:59', 'admin-1504251976-15042544789608462', 1, 0, '', NULL, NULL, NULL),
(44629, '2017-09-01 16:27:46', NULL, NULL, 12567, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1504251976', 'admin', '2017-09-01 16:27:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44630, '2017-09-01 16:21:11', NULL, NULL, 12566, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1504251976', 'admin', '2017-09-01 16:21:11', 'admin-1504251976-15042540712112655', 1, 0, '', NULL, NULL, NULL),
(44631, '2017-09-01 13:47:14', NULL, NULL, 12552, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:47:14', 'admin-1504244728-15042448341896980', 1, 1, 'SR', NULL, NULL, NULL),
(44632, '2017-09-01 14:03:17', NULL, NULL, 12553, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1504251976', 'admin', '2017-09-01 14:03:17', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(44633, '2017-09-01 16:21:11', NULL, NULL, 12566, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 16:21:11', 'admin-1504251976-15042540712112655', 1, 0, '', NULL, NULL, NULL),
(44634, '2017-09-01 16:21:11', NULL, NULL, 12566, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 16:21:11', 'admin-1504251976-15042540712112655', 1, 0, '', NULL, NULL, NULL),
(44635, '2017-09-01 16:21:11', NULL, NULL, 12566, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 16:21:11', 'admin-1504251976-15042540712112655', 1, 1, 'SR', NULL, NULL, NULL),
(44636, '2017-09-01 10:57:44', NULL, NULL, 12531, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:57:44', 'admin-1504226956-1504234663802815', 1, 1, 'SR', NULL, NULL, '10.0'),
(44637, '2017-09-01 10:57:44', NULL, NULL, 12531, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:57:44', 'admin-1504226956-1504234663802815', 1, 1, 'SR', NULL, NULL, '10.0'),
(44638, '2017-09-01 10:57:44', NULL, NULL, 12531, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:57:44', 'admin-1504226956-1504234663802815', 1, 0, '', NULL, NULL, '10.0'),
(44639, '2017-09-01 10:57:44', NULL, NULL, 12531, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:57:44', 'admin-1504226956-1504234663802815', 1, 1, 'SR', NULL, NULL, '10.0'),
(44640, '2017-09-01 12:59:40', NULL, NULL, 12545, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 12:59:40', 'admin-1504238239-15042419804412127', 1, 0, '', NULL, NULL, NULL),
(44641, '2017-09-01 15:57:30', NULL, NULL, 12558, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:57:30', 'admin-1504251976-1504252649979869', 1, 1, 'SR', NULL, NULL, NULL),
(44642, '2017-09-01 15:56:43', NULL, NULL, 12563, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:56:43', 'admin-1504251976-15042526031964124', 1, 1, 'SR', NULL, NULL, NULL),
(44643, '2017-09-01 15:56:43', NULL, NULL, 12563, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:56:43', 'admin-1504251976-15042526031964124', 1, 0, '', NULL, NULL, NULL),
(44644, '2017-09-01 15:56:35', NULL, NULL, 12563, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:56:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44645, '2017-09-01 15:53:19', NULL, NULL, 12562, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:53:19', 'admin-1504251976-15042523993355170', 1, 0, '', NULL, NULL, NULL),
(44646, '2017-09-01 15:53:19', NULL, NULL, 12562, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:53:19', 'admin-1504251976-15042523993355170', 1, 0, '', NULL, NULL, NULL),
(44647, '2017-09-01 15:49:19', NULL, NULL, 12560, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:49:19', 'admin-1504251976-15042521593307842', 1, 1, 'SR', NULL, NULL, NULL),
(44648, '2017-09-01 15:49:19', NULL, NULL, 12560, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:49:19', 'admin-1504251976-15042521593307842', 1, 0, '', NULL, NULL, NULL),
(44649, '2017-09-01 15:49:19', NULL, NULL, 12560, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:49:19', 'admin-1504251976-15042521593307842', 1, 1, 'SR', NULL, NULL, NULL),
(44650, '2017-09-01 12:59:20', NULL, NULL, 12545, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1504251976', 'admin', '2017-09-01 12:59:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44651, '2017-09-01 12:40:03', NULL, NULL, 12544, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 12:40:03', 'admin-1504238239-1504240802987790', 1, 0, '', NULL, NULL, NULL),
(44652, '2017-09-01 15:52:28', NULL, NULL, 12562, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:52:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44653, '2017-09-01 13:14:53', NULL, NULL, 12548, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:14:53', 'admin-1504238239-1504242893023353', 1, 0, '', NULL, NULL, NULL),
(44654, '2017-09-01 15:16:48', NULL, NULL, 12558, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:16:48', 'admin-1504244728-15042502085446436', 1, 0, '', NULL, NULL, NULL),
(44655, '2017-09-01 15:12:40', NULL, NULL, 12558, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:12:40', 'admin-1504244728-15042499607721996', 1, 1, 'SR', NULL, NULL, NULL),
(44656, '2017-09-01 15:12:40', NULL, NULL, 12558, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:12:40', 'admin-1504244728-15042499607721996', 1, 1, 'SR', NULL, NULL, NULL),
(44657, '2017-09-01 15:12:22', NULL, NULL, 12558, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:12:22', 'admin-1504244728-15042499424541719', 1, 0, '', NULL, NULL, NULL),
(44658, '2017-09-01 15:12:22', NULL, NULL, 12558, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:12:22', 'admin-1504244728-15042499424541719', 1, 1, 'SR', NULL, NULL, NULL),
(44659, '2017-09-01 15:11:56', NULL, NULL, 12558, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:11:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44660, '2017-09-01 15:07:09', NULL, NULL, 12557, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:07:09', 'admin-1504244728-15042496291166199', 1, 1, 'SR', NULL, NULL, NULL),
(44661, '2017-09-01 15:07:02', NULL, NULL, 12557, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:07:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44662, '2017-09-01 11:25:12', NULL, NULL, 12535, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:25:12', 'admin-1504235199-15042363123932987', 1, 0, '', NULL, NULL, NULL),
(44663, '2017-09-01 10:53:19', NULL, NULL, 12530, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:53:19', 'admin-1504226956-15042343994955874', 1, 1, 'SR', NULL, NULL, NULL),
(44664, '2017-09-01 09:39:40', NULL, NULL, 12524, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 09:39:40', 'admin-1504226956-15042299800395518', 1, 0, '', NULL, NULL, NULL),
(44665, '2017-09-01 09:50:54', NULL, NULL, 12525, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1504251976', 'admin', '2017-09-01 09:50:54', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(44666, '2017-09-01 15:04:57', NULL, NULL, 12556, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:04:57', 'admin-1504244728-15042494975036385', 1, 1, 'SR', NULL, NULL, NULL),
(44667, '2017-09-01 13:14:53', NULL, NULL, 12548, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:14:53', 'admin-1504238239-1504242893023353', 1, 0, '', NULL, NULL, NULL),
(44668, '2017-09-01 15:04:47', NULL, NULL, 12556, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:04:47', 'admin-1504244728-15042494873539548', 1, 0, '', NULL, NULL, NULL),
(44669, '2017-09-01 14:49:19', NULL, NULL, 12555, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 14:49:19', 'admin-1504244728-15042485597964681', 1, 1, 'SR', NULL, NULL, NULL),
(44670, '2017-09-01 14:03:26', NULL, NULL, 12553, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 14:03:26', 'admin-1504244728-15042458061671142', 1, 0, '', NULL, NULL, '10.0'),
(44671, '2017-09-01 13:47:14', NULL, NULL, 12552, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:47:14', 'admin-1504244728-15042448341896980', 1, 0, '', NULL, NULL, NULL),
(44672, '2017-09-01 13:47:14', NULL, NULL, 12552, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:47:14', 'admin-1504244728-15042448341896980', 1, 0, '', NULL, NULL, NULL),
(44673, '2017-09-01 13:45:17', NULL, NULL, 12552, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:45:17', 'admin-1504238239-15042447169775938', 1, 1, 'SR', NULL, NULL, NULL),
(44674, '2017-09-01 13:45:17', NULL, NULL, 12552, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:45:17', 'admin-1504238239-15042447169775938', 1, 1, 'SR', NULL, NULL, NULL),
(44675, '2017-09-01 13:42:50', NULL, NULL, 12552, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.60, 0.0000, 0.0000, 9.60, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:42:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44676, '2017-09-01 13:43:06', NULL, NULL, 12552, 0, 181, '116', 'Open Food ', 'kid pasta', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:43:06', 'admin-1504238239-15042445862387413', 1, 0, '', NULL, NULL, NULL),
(44677, '2017-09-01 11:56:51', NULL, NULL, 12538, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:56:51', 'admin-1504235199-15042382113313526', 1, 0, '', NULL, NULL, NULL),
(44678, '2017-09-01 13:36:41', NULL, NULL, 12551, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:36:41', 'admin-1504238239-15042442009807976', 1, 0, '', NULL, NULL, NULL),
(44679, '2017-09-01 13:36:41', NULL, NULL, 12551, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:36:41', 'admin-1504238239-15042442009807976', 1, 1, 'SR', NULL, NULL, NULL),
(44680, '2017-09-01 13:14:53', NULL, NULL, 12548, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:14:53', 'admin-1504238239-1504242893023353', 1, 1, 'SR', NULL, NULL, NULL),
(44681, '2017-09-01 13:36:41', NULL, NULL, 12551, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:36:41', 'admin-1504238239-15042442009807976', 1, 0, '', NULL, NULL, NULL),
(44682, '2017-09-01 13:36:21', NULL, NULL, 12551, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:36:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44683, '2017-09-01 13:18:40', NULL, NULL, 12550, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:18:40', 'admin-1504238239-15042431201384883', 1, 1, 'SR', NULL, NULL, NULL),
(44684, '2017-09-01 13:17:57', NULL, NULL, 12549, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:17:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44685, '2017-09-01 11:20:09', NULL, NULL, 12534, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:20:09', 'admin-1504235199-15042360088428956', 1, 0, '', NULL, NULL, NULL),
(44686, '2017-09-01 11:13:56', NULL, NULL, 12533, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:13:56', 'admin-1504235199-1504235636702963', 1, 0, '', NULL, NULL, NULL),
(44687, '2017-09-01 13:14:53', NULL, NULL, 12548, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:14:53', 'admin-1504238239-1504242893023353', 1, 1, 'SR', NULL, NULL, NULL),
(44688, '2017-09-01 13:14:53', NULL, NULL, 12548, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:14:53', 'admin-1504238239-1504242893023353', 1, 0, '', NULL, NULL, NULL),
(44689, '2017-09-01 13:36:41', NULL, NULL, 12551, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:36:41', 'admin-1504238239-15042442009807976', 1, 0, '', NULL, NULL, NULL),
(44690, '2017-09-01 13:14:53', NULL, NULL, 12548, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:14:53', 'admin-1504238239-1504242893023353', 1, 1, 'SR', NULL, NULL, NULL),
(44691, '2017-09-01 13:14:53', NULL, NULL, 12548, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:14:53', 'admin-1504238239-1504242893023353', 1, 0, '', NULL, NULL, NULL),
(44692, '2017-09-01 12:02:23', NULL, NULL, 12541, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 12:02:23', 'admin-1504238239-15042385432127874', 1, 0, '', NULL, NULL, NULL),
(44693, '2017-09-01 12:02:23', NULL, NULL, 12541, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 12:02:23', 'admin-1504238239-15042385432127874', 1, 1, 'SR', NULL, NULL, NULL),
(44694, '2017-09-01 12:59:40', NULL, NULL, 12545, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 12:59:40', 'admin-1504238239-15042419804412127', 1, 1, 'SR', NULL, NULL, NULL),
(44695, '2017-09-01 13:00:23', NULL, NULL, 12546, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:00:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44696, '2017-09-01 13:00:32', NULL, NULL, 12546, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:00:32', 'admin-1504238239-15042420324601610', 1, 1, 'SR', NULL, NULL, NULL),
(44697, '2017-09-01 11:24:16', NULL, NULL, 12535, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:24:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44698, '2017-09-01 15:50:11', NULL, NULL, 12561, 0, 182, '117', 'Open Drinks ', 'americano promo', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:50:11', 'admin-1504251976-15042522116846698', 1, 0, '', 1, NULL, NULL),
(44699, '2017-09-01 13:04:30', NULL, NULL, 12546, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:04:30', 'admin-1504238239-15042422703916717', 1, 0, '', NULL, NULL, NULL),
(44700, '2017-09-01 13:04:30', NULL, NULL, 12546, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:04:30', 'admin-1504238239-15042422703916717', 1, 0, '', NULL, NULL, NULL),
(44701, '2017-09-01 13:05:19', NULL, NULL, 12547, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:05:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44702, '2017-09-01 13:05:56', NULL, NULL, 12547, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:05:56', 'admin-1504238239-15042423566475154', 1, 0, '', NULL, NULL, NULL),
(44703, '2017-09-01 13:05:56', NULL, NULL, 12547, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:05:56', 'admin-1504238239-15042423566475154', 1, 1, 'SR', NULL, NULL, NULL),
(44704, '2017-09-01 13:05:56', NULL, NULL, 12547, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:05:56', 'admin-1504238239-15042423566475154', 1, 1, 'SR', NULL, NULL, NULL),
(44705, '2017-09-01 13:05:56', NULL, NULL, 12547, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:05:56', 'admin-1504238239-15042423566475154', 1, 1, 'SR', NULL, NULL, NULL),
(44706, '2017-09-01 13:05:56', NULL, NULL, 12547, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:05:56', 'admin-1504238239-15042423566475154', 1, 1, 'SR', NULL, NULL, NULL),
(44707, '2017-09-01 13:14:53', NULL, NULL, 12548, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:14:53', 'admin-1504238239-1504242893023353', 1, 1, 'SR', NULL, NULL, NULL),
(44708, '2017-09-01 11:55:33', NULL, NULL, 12538, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:55:33', 'admin-1504235199-1504238132866769', 1, 1, 'SR', NULL, NULL, NULL),
(44709, '2017-09-01 11:56:31', NULL, NULL, 12540, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:56:31', 'admin-1504235199-15042381908472981', 1, 1, 'SR', NULL, NULL, NULL),
(44710, '2017-09-01 13:04:30', NULL, NULL, 12546, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:04:30', 'admin-1504238239-15042422703916717', 1, 0, '', NULL, NULL, NULL),
(44711, '2017-09-01 11:13:56', NULL, NULL, 12533, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:13:56', 'admin-1504235199-1504235636702963', 1, 0, '', NULL, NULL, NULL),
(44712, '2017-09-01 12:40:03', NULL, NULL, 12544, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 12:40:03', 'admin-1504238239-1504240802987790', 1, 0, '', NULL, NULL, NULL),
(44713, '2017-09-01 12:39:57', NULL, NULL, 12544, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1504251976', 'admin', '2017-09-01 12:39:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44714, '2017-09-01 12:37:29', NULL, NULL, 12543, 0, 182, '117', 'Open Drinks ', 'drinks', 'Cold Drinks', 'Fresh Juice', 1, 18.70, 18.7000, 0.0000, 18.70, 1, '27', 1, '1504251976', 'admin', '2017-09-01 12:37:29', 'admin-1504238239-15042406495571762', 1, 0, '', 1, NULL, NULL),
(44715, '2017-09-01 13:14:53', NULL, NULL, 12548, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:14:53', 'admin-1504238239-1504242893023353', 1, 0, '', NULL, NULL, NULL),
(44716, '2017-09-01 13:00:32', NULL, NULL, 12546, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 13:00:32', 'admin-1504238239-15042420324601610', 1, 1, 'SR', NULL, NULL, NULL),
(44717, '2017-09-01 12:02:23', NULL, NULL, 12541, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 12:02:23', 'admin-1504238239-15042385432127874', 1, 1, 'SR', NULL, NULL, NULL),
(44718, '2017-09-01 12:02:23', NULL, NULL, 12541, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 12:02:23', 'admin-1504238239-15042385432127874', 1, 1, 'SR', NULL, NULL, NULL),
(44719, '2017-09-01 10:53:19', NULL, NULL, 12530, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:53:19', 'admin-1504226956-15042343994955874', 1, 1, 'SR', NULL, NULL, NULL),
(44720, '2017-09-01 10:53:19', NULL, NULL, 12530, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:53:19', 'admin-1504226956-15042343994955874', 1, 0, '', NULL, NULL, NULL),
(44721, '2017-09-01 10:53:19', NULL, NULL, 12530, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:53:19', 'admin-1504226956-15042343994955874', 1, 1, 'SR', NULL, NULL, NULL),
(44722, '2017-09-01 10:57:32', NULL, NULL, 12531, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:57:32', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(44723, '2017-09-01 12:01:51', NULL, NULL, 12541, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1504251976', 'admin', '2017-09-01 12:01:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44724, '2017-09-01 11:56:51', NULL, NULL, 12538, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:56:51', 'admin-1504235199-15042382113313526', 1, 0, '', NULL, NULL, NULL),
(44725, '2017-09-01 11:56:31', NULL, NULL, 12540, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:56:31', 'admin-1504235199-15042381908472981', 1, 0, '', NULL, NULL, NULL),
(44726, '2017-09-01 11:56:01', NULL, NULL, 12540, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:56:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44727, '2017-09-01 11:56:31', NULL, NULL, 12540, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:56:31', 'admin-1504235199-15042381908472981', 1, 0, '', NULL, NULL, NULL),
(44728, '2017-09-01 11:54:49', NULL, NULL, 12539, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:54:49', 'admin-1504235199-15042380889339174', 1, 0, '', NULL, NULL, NULL),
(44729, '2017-09-01 11:54:49', NULL, NULL, 12539, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:54:49', 'admin-1504235199-15042380889339174', 1, 0, '', NULL, NULL, NULL),
(44730, '2017-09-01 11:55:33', NULL, NULL, 12538, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:55:33', 'admin-1504235199-1504238132866769', 1, 0, '', NULL, NULL, NULL),
(44731, '2017-09-01 11:55:33', NULL, NULL, 12538, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:55:33', 'admin-1504235199-1504238132866769', 1, 1, 'SR', NULL, NULL, NULL),
(44732, '2017-09-01 11:39:41', NULL, NULL, 12537, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:39:41', 'admin-1504235199-15042371810743955', 1, 0, '', NULL, NULL, NULL),
(44733, '2017-09-01 11:44:39', NULL, NULL, 12530, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:44:39', 'admin-1504235199-15042374794236469', 1, 1, 'SR', NULL, NULL, NULL),
(44734, '2017-09-01 11:39:41', NULL, NULL, 12537, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:39:41', 'admin-1504235199-15042371810743955', 1, 0, '', NULL, NULL, NULL),
(44735, '2017-09-01 11:13:31', NULL, NULL, 12533, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:13:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44736, '2017-09-01 10:47:14', NULL, NULL, 12529, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:47:14', 'admin-1504226956-1504234034673107', 1, 1, 'SR', NULL, NULL, NULL),
(44737, '2017-09-01 11:20:09', NULL, NULL, 12534, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:20:09', 'admin-1504235199-15042360088428956', 1, 1, 'SR', NULL, NULL, NULL),
(44738, '2017-09-01 11:20:09', NULL, NULL, 12534, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:20:09', 'admin-1504235199-15042360088428956', 1, 1, 'SR', NULL, NULL, NULL),
(44739, '2017-09-01 11:25:12', NULL, NULL, 12535, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:25:12', 'admin-1504235199-15042363123932987', 1, 1, 'SR', NULL, NULL, NULL),
(44740, '2017-09-01 11:25:12', NULL, NULL, 12535, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:25:12', 'admin-1504235199-15042363123932987', 1, 1, 'SR', NULL, NULL, NULL),
(44741, '2017-09-01 11:13:56', NULL, NULL, 12533, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:13:56', 'admin-1504235199-1504235636702963', 1, 0, '', NULL, NULL, NULL),
(44742, '2017-09-01 15:53:19', NULL, NULL, 12562, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 15:53:19', 'admin-1504251976-15042523993355170', 1, 0, '', NULL, NULL, NULL),
(44743, '2017-09-01 16:20:59', NULL, NULL, 12566, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.69, 0.0000, 0.0000, 3.69, 1, '27', 1, '1504251976', 'admin', '2017-09-01 16:20:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44744, '2017-09-01 11:20:09', NULL, NULL, 12534, 0, 207, '142', 'Cheesy Bacon Toast', 'add baked beans', 'Meals', 'Morning Bites ', 1, 18.50, 18.5000, 0.0000, 18.50, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:20:09', 'admin-1504235199-15042360088428956', 1, 0, '', NULL, NULL, NULL),
(44745, '2017-09-01 10:53:19', NULL, NULL, 12530, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:53:19', 'admin-1504226956-15042343994955874', 1, 0, '', NULL, NULL, NULL),
(44746, '2017-09-01 10:53:19', NULL, NULL, 12530, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 3, 15.00, 45.0000, 0.0000, 45.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:53:19', 'admin-1504226956-15042343994955874', 1, 0, '', NULL, NULL, NULL),
(44747, '2017-09-01 10:31:55', NULL, NULL, 12528, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:31:55', 'admin-1504226956-15042331149544351', 1, 1, 'SR', NULL, NULL, NULL),
(44748, '2017-09-01 10:46:58', NULL, NULL, 12529, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:46:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44749, '2017-09-01 10:47:14', NULL, NULL, 12529, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:47:14', 'admin-1504226956-1504234034673107', 1, 1, 'SR', NULL, NULL, NULL),
(44750, '2017-09-01 10:53:19', NULL, NULL, 12530, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:53:19', 'admin-1504226956-15042343994955874', 1, 1, 'SR', NULL, NULL, NULL),
(44751, '2017-09-01 10:06:55', NULL, NULL, 12526, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:06:55', 'admin-1504226956-15042316156858932', 1, 0, '', NULL, NULL, NULL),
(44752, '2017-09-01 09:34:53', NULL, NULL, 12521, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 09:34:53', 'admin-1504226956-15042296928492417', 1, 1, 'SR', NULL, NULL, NULL),
(44753, '2017-09-01 09:35:19', NULL, NULL, 12524, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1504251976', 'admin', '2017-09-01 09:35:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44754, '2017-09-01 09:35:32', NULL, NULL, 12524, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 09:35:32', 'admin-1504226956-15042297318018362', 1, 0, '', NULL, NULL, NULL),
(44755, '2017-09-01 12:59:40', NULL, NULL, 12545, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 12:59:40', 'admin-1504238239-15042419804412127', 1, 0, '', NULL, NULL, NULL),
(44756, '2017-09-01 10:53:19', NULL, NULL, 12530, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:53:19', 'admin-1504226956-15042343994955874', 1, 1, 'SR', NULL, NULL, NULL),
(44757, '2017-09-01 10:53:19', NULL, NULL, 12530, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:53:19', 'admin-1504226956-15042343994955874', 1, 1, 'SR', NULL, NULL, NULL),
(44758, '2017-09-01 10:53:19', NULL, NULL, 12530, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:53:19', 'admin-1504226956-15042343994955874', 1, 1, 'SR', NULL, NULL, NULL),
(44759, '2017-09-01 12:35:13', NULL, NULL, 12541, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 12:35:13', 'admin-1504238239-15042405128706948', 1, 0, '', NULL, NULL, NULL),
(44760, '2017-09-01 09:26:57', NULL, NULL, 12521, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 09:26:57', 'admin-1504226956-15042292170025378', 1, 0, '', NULL, NULL, NULL),
(44761, '2017-09-01 09:26:57', NULL, NULL, 12521, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 09:26:57', 'admin-1504226956-15042292170025378', 1, 0, '', NULL, NULL, NULL),
(44762, '2017-09-01 09:26:57', NULL, NULL, 12521, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 09:26:57', 'admin-1504226956-15042292170025378', 1, 0, '', NULL, NULL, NULL),
(44763, '2017-09-01 09:28:03', NULL, NULL, 12522, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 09:28:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44764, '2017-09-01 09:28:43', NULL, NULL, 12522, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 09:28:43', 'admin-1504226956-15042293228321986', 1, 0, '', NULL, NULL, NULL),
(44765, '2017-09-01 09:28:43', NULL, NULL, 12522, 0, 153, '87', 'Wake Me Up!', 'no sausage', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 09:28:43', 'admin-1504226956-15042293228321986', 1, 0, '', NULL, NULL, NULL),
(44766, '2017-09-01 09:28:43', NULL, NULL, 12522, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 09:28:43', 'admin-1504226956-15042293228321986', 1, 0, '', NULL, NULL, NULL),
(44767, '2017-09-01 10:21:48', NULL, NULL, 12527, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:21:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44768, '2017-09-01 10:22:01', NULL, NULL, 12527, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:22:01', 'admin-1504226956-15042325214831026', 1, 0, '', NULL, NULL, NULL),
(44769, '2017-09-01 11:22:36', NULL, NULL, 12530, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 11:22:36', 'admin-1504235199-15042361562327363', 1, 0, '', NULL, NULL, NULL),
(44770, '2017-09-01 10:53:19', NULL, NULL, 12530, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:53:19', 'admin-1504226956-15042343994955874', 1, 0, '', NULL, NULL, NULL),
(44771, '2017-09-01 10:53:19', NULL, NULL, 12530, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:53:19', 'admin-1504226956-15042343994955874', 1, 0, '', NULL, NULL, NULL),
(44772, '2017-09-01 10:51:59', NULL, NULL, 12530, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 20.70, 0.0000, 0.0000, 20.70, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:51:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44773, '2017-09-01 10:47:14', NULL, NULL, 12529, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:47:14', 'admin-1504226956-1504234034673107', 1, 1, 'SR', NULL, NULL, NULL),
(44774, '2017-09-01 10:47:14', NULL, NULL, 12529, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:47:14', 'admin-1504226956-1504234034673107', 1, 1, 'SR', NULL, NULL, NULL),
(44775, '2017-09-01 10:47:14', NULL, NULL, 12529, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:47:14', 'admin-1504226956-1504234034673107', 1, 1, 'SR', NULL, NULL, NULL),
(44776, '2017-09-01 10:47:14', NULL, NULL, 12529, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:47:14', 'admin-1504226956-1504234034673107', 1, 1, 'SR', NULL, NULL, NULL),
(44777, '2017-09-01 10:47:14', NULL, NULL, 12529, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:47:14', 'admin-1504226956-1504234034673107', 1, 1, 'SR', NULL, NULL, NULL),
(44778, '2017-09-01 10:47:14', NULL, NULL, 12529, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:47:14', 'admin-1504226956-1504234034673107', 1, 1, 'SR', NULL, NULL, NULL),
(44779, '2017-09-01 10:31:55', NULL, NULL, 12528, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:31:55', 'admin-1504226956-15042331149544351', 1, 1, 'SR', NULL, NULL, NULL),
(44780, '2017-09-01 10:31:55', NULL, NULL, 12528, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:31:55', 'admin-1504226956-15042331149544351', 1, 1, 'SR', NULL, NULL, NULL),
(44781, '2017-09-01 10:31:55', NULL, NULL, 12528, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:31:55', 'admin-1504226956-15042331149544351', 1, 0, '', NULL, NULL, NULL),
(44782, '2017-09-01 10:31:55', NULL, NULL, 12528, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:31:55', 'admin-1504226956-15042331149544351', 1, 0, '', NULL, NULL, NULL),
(44783, '2017-09-01 10:31:55', NULL, NULL, 12528, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:31:55', 'admin-1504226956-15042331149544351', 1, 0, '', NULL, NULL, NULL),
(44784, '2017-09-01 10:31:30', NULL, NULL, 12528, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:31:30', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(44785, '2017-09-01 10:22:01', NULL, NULL, 12527, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:22:01', 'admin-1504226956-15042325214831026', 1, 0, '', NULL, NULL, NULL),
(44786, '2017-09-01 10:22:01', NULL, NULL, 12527, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:22:01', 'admin-1504226956-15042325214831026', 1, 0, '', NULL, NULL, NULL),
(44787, '2017-09-01 10:06:55', NULL, NULL, 12526, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:06:55', 'admin-1504226956-15042316156858932', 1, 1, 'SR', NULL, NULL, NULL),
(44788, '2017-09-01 10:06:55', NULL, NULL, 12526, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:06:55', 'admin-1504226956-15042316156858932', 1, 1, 'SR', NULL, NULL, NULL),
(44789, '2017-09-01 10:06:55', NULL, NULL, 12526, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:06:55', 'admin-1504226956-15042316156858932', 1, 0, '', NULL, NULL, NULL),
(44790, '2017-09-01 10:06:35', NULL, NULL, 12526, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1504251976', 'admin', '2017-09-01 10:06:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44791, '2017-09-01 09:51:04', NULL, NULL, 12525, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 09:51:04', 'admin-1504226956-15042306646307035', 1, 1, 'SR', NULL, NULL, '10.0'),
(44792, '2017-09-01 09:51:04', NULL, NULL, 12525, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 09:51:04', 'admin-1504226956-15042306646307035', 1, 0, '', NULL, NULL, '10.0'),
(44793, '2017-09-01 09:51:04', NULL, NULL, 12525, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 09:51:04', 'admin-1504226956-15042306646307035', 1, 0, '', NULL, NULL, '10.0'),
(44794, '2017-09-01 09:35:32', NULL, NULL, 12524, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 09:35:32', 'admin-1504226956-15042297318018362', 1, 1, 'SR', NULL, NULL, NULL),
(44795, '2017-09-01 09:31:50', NULL, NULL, 12523, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 09:31:50', 'admin-1504226956-15042295101326652', 1, 1, 'SR', NULL, NULL, NULL),
(44796, '2017-09-01 09:32:43', NULL, NULL, 12522, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504251976', 'admin', '2017-09-01 09:32:43', 'admin-1504226956-15042295630588931', 1, 1, 'SR', NULL, NULL, NULL),
(44797, '2017-09-01 09:31:45', NULL, NULL, 12523, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1504251976', 'admin', '2017-09-01 09:31:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44798, '2017-09-01 09:26:45', NULL, NULL, 12521, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1504251976', 'admin', '2017-09-01 09:26:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44799, '2017-09-02 14:02:51', NULL, NULL, 12599, 0, 181, '116', 'Open Food ', 'plain yogurt', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 14:02:51', 'admin-1504324863-1504332171344824', 1, 0, '', NULL, NULL, NULL),
(44800, '2017-09-02 14:02:51', NULL, NULL, 12599, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 14:02:51', 'admin-1504324863-1504332171344824', 1, 0, '', NULL, NULL, NULL),
(44801, '2017-09-02 14:02:51', NULL, NULL, 12599, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 14:02:51', 'admin-1504324863-1504332171344824', 1, 1, 'SR', NULL, NULL, NULL),
(44802, '2017-09-02 14:02:51', NULL, NULL, 12599, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 2, 11.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 14:02:51', 'admin-1504324863-1504332171344824', 1, 1, 'SR', NULL, NULL, NULL),
(44803, '2017-09-02 14:08:05', NULL, NULL, 12599, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 14:08:05', 'admin-1504324863-15043324854024059', 1, 0, '', NULL, NULL, NULL),
(44804, '2017-09-02 14:08:05', NULL, NULL, 12599, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 14:08:05', 'admin-1504324863-15043324854024059', 1, 0, '', NULL, NULL, NULL),
(44805, '2017-09-02 12:17:41', NULL, NULL, 12594, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:17:41', 'admin-1504324863-15043258617097396', 1, 1, 'SR', NULL, NULL, NULL),
(44806, '2017-09-02 12:20:08', NULL, NULL, 12584, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:20:08', 'admin-1504324863-15043260085654649', 1, 0, '', NULL, NULL, NULL),
(44807, '2017-09-02 12:24:17', NULL, NULL, 12595, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:24:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44808, '2017-09-02 12:24:48', NULL, NULL, 12595, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:24:48', 'admin-1504324863-15043262882671099', 1, 1, 'SR', NULL, NULL, NULL),
(44809, '2017-09-02 12:24:48', NULL, NULL, 12595, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:24:48', 'admin-1504324863-15043262882671099', 1, 1, 'SR', NULL, NULL, NULL),
(44810, '2017-09-02 10:41:08', NULL, NULL, 12580, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 10:41:08', 'admin-1504319848-15043200681312756', 1, 0, '', NULL, NULL, NULL),
(44811, '2017-09-02 10:41:08', NULL, NULL, 12580, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 10:41:08', 'admin-1504319848-15043200681312756', 1, 0, '', NULL, NULL, NULL),
(44812, '2017-09-02 10:41:08', NULL, NULL, 12580, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 10:41:08', 'admin-1504319848-15043200681312756', 1, 1, 'SR', NULL, NULL, NULL),
(44813, '2017-09-02 14:02:51', NULL, NULL, 12599, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 14:02:51', 'admin-1504324863-1504332171344824', 1, 1, 'SR', NULL, NULL, NULL),
(44814, '2017-09-02 12:14:20', NULL, NULL, 12593, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:14:20', 'admin-1504324863-15043256605308554', 1, 1, 'SR', 1, NULL, '10.0'),
(44815, '2017-09-02 12:15:24', NULL, NULL, 12592, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:15:24', 'admin-1504324863-15043257241922996', 1, 1, 'SR', NULL, NULL, NULL),
(44816, '2017-09-02 12:17:30', NULL, NULL, 12594, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:17:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44817, '2017-09-02 12:17:41', NULL, NULL, 12594, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:17:41', 'admin-1504324863-15043258617097396', 1, 1, 'SR', NULL, NULL, NULL),
(44818, '2017-09-02 16:19:40', NULL, NULL, 12605, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 16:19:40', 'admin-1504324863-15043403805687723', 1, 1, 'SR', NULL, NULL, NULL),
(44819, '2017-09-02 09:18:48', NULL, NULL, 12572, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:18:48', 'sanni-1504259386-15043151284633676', 1, 1, 'SR', NULL, NULL, NULL),
(44820, '2017-09-02 11:24:00', NULL, NULL, 12583, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:24:00', 'admin-1504319848-15043226402444514', 1, 0, '', NULL, NULL, NULL),
(44821, '2017-09-02 11:24:07', NULL, NULL, 12583, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:24:07', 'admin-1504319848-15043226471315741', 1, 1, 'SR', NULL, NULL, NULL),
(44822, '2017-09-02 11:24:07', NULL, NULL, 12583, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:24:07', 'admin-1504319848-15043226471315741', 1, 1, 'SR', NULL, NULL, NULL),
(44823, '2017-09-02 11:42:46', NULL, NULL, 12584, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:42:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44824, '2017-09-02 11:43:01', NULL, NULL, 12584, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:43:01', 'admin-1504319848-15043237811253475', 1, 0, '', NULL, NULL, NULL),
(44825, '2017-09-02 12:58:35', NULL, NULL, 12596, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:58:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44826, '2017-09-02 12:59:07', NULL, NULL, 12596, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:59:07', 'admin-1504324863-15043283468106012', 1, 0, '', NULL, NULL, NULL),
(44827, '2017-09-02 12:59:07', NULL, NULL, 12596, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:59:07', 'admin-1504324863-15043283468106012', 1, 1, 'SR', NULL, NULL, NULL),
(44828, '2017-09-02 13:12:47', NULL, NULL, 12592, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 13:12:47', 'admin-1504324863-15043291674943945', 1, 0, '', NULL, NULL, NULL),
(44829, '2017-09-02 13:22:00', NULL, NULL, 12597, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 13:22:00', 'admin-1504324863-15043297205062589', 1, 0, '', 1, NULL, '10.0'),
(44830, '2017-09-02 13:45:53', NULL, NULL, 12598, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 13:45:53', 'admin-1504324863-15043311536545545', 1, 0, '', NULL, NULL, NULL),
(44831, '2017-09-02 11:58:15', NULL, NULL, 12588, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:58:15', 'admin-1504319848-15043246948312263', 1, 1, 'SR', NULL, NULL, NULL),
(44832, '2017-09-02 12:45:11', NULL, NULL, 12592, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:45:11', 'admin-1504324863-15043275112854362', 1, 1, 'SR', NULL, NULL, NULL),
(44833, '2017-09-02 11:44:02', NULL, NULL, 12584, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:44:02', 'admin-1504319848-15043238420968210', 1, 0, '', NULL, NULL, NULL),
(44834, '2017-09-02 11:47:03', NULL, NULL, 12585, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:47:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44835, '2017-09-02 10:44:25', NULL, NULL, 12581, 0, 153, '87', 'Wake Me Up!', 'NO BACON', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 10:44:25', 'admin-1504319848-15043202649827983', 1, 0, '', NULL, NULL, NULL),
(44836, '2017-09-02 10:44:25', NULL, NULL, 12581, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 10:44:25', 'admin-1504319848-15043202649827983', 1, 1, 'SR', NULL, NULL, NULL),
(44837, '2017-09-02 10:44:25', NULL, NULL, 12581, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 10:44:25', 'admin-1504319848-15043202649827983', 1, 1, 'SR', NULL, NULL, NULL),
(44838, '2017-09-02 10:54:29', NULL, NULL, 12582, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1504324863', 'admin', '2017-09-02 10:54:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44839, '2017-09-02 10:54:56', NULL, NULL, 12582, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 10:54:56', 'admin-1504319848-15043208959764097', 1, 0, '', NULL, NULL, NULL),
(44840, '2017-09-02 10:54:56', NULL, NULL, 12582, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 10:54:56', 'admin-1504319848-15043208959764097', 1, 1, 'SR', NULL, NULL, NULL),
(44841, '2017-09-02 11:47:26', NULL, NULL, 12585, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:47:26', 'admin-1504319848-1504324046317686', 1, 1, 'SR', NULL, NULL, NULL),
(44842, '2017-09-02 11:47:26', NULL, NULL, 12585, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:47:26', 'admin-1504319848-1504324046317686', 1, 1, 'SR', NULL, NULL, NULL),
(44843, '2017-09-02 13:45:40', NULL, NULL, 12598, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1504324863', 'admin', '2017-09-02 13:45:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44844, '2017-09-02 10:43:51', NULL, NULL, 12581, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1504324863', 'admin', '2017-09-02 10:43:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44845, '2017-09-02 10:44:25', NULL, NULL, 12581, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 10:44:25', 'admin-1504319848-15043202649827983', 1, 0, '', NULL, NULL, NULL),
(44846, '2017-09-02 16:11:58', NULL, NULL, 12603, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 16:11:58', 'admin-1504324863-1504339918660433', 1, 1, 'SR', NULL, NULL, NULL),
(44847, '2017-09-02 16:16:32', NULL, NULL, 12604, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 16:16:32', 'admin-1504324863-15043401917304641', 1, 1, 'SR', 1, NULL, '10.0'),
(44848, '2017-09-02 16:19:29', NULL, NULL, 12605, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 16:19:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44849, '2017-09-02 14:37:08', NULL, NULL, 12601, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1504324863', 'admin', '2017-09-02 14:37:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44850, '2017-09-02 14:37:41', NULL, NULL, 12601, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 14:37:41', 'admin-1504324863-15043342608579840', 1, 1, 'SR', NULL, NULL, NULL),
(44851, '2017-09-02 14:37:41', NULL, NULL, 12601, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 14:37:41', 'admin-1504324863-15043342608579840', 1, 0, '', NULL, NULL, NULL),
(44852, '2017-09-02 14:37:41', NULL, NULL, 12601, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 14:37:41', 'admin-1504324863-15043342608579840', 1, 1, 'SR', NULL, NULL, NULL),
(44853, '2017-09-02 14:49:09', NULL, NULL, 12602, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1504324863', 'admin', '2017-09-02 14:49:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44854, '2017-09-02 14:49:31', NULL, NULL, 12602, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 14:49:31', 'admin-1504324863-15043349711427183', 1, 1, 'SR', NULL, NULL, NULL),
(44855, '2017-09-02 15:55:20', NULL, NULL, 12601, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 15:55:20', 'admin-1504324863-15043389199975959', 1, 1, 'SR', NULL, NULL, NULL),
(44856, '2017-09-02 15:55:20', NULL, NULL, 12601, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 15:55:20', 'admin-1504324863-15043389199975959', 1, 1, 'SR', NULL, NULL, NULL),
(44857, '2017-09-02 16:11:22', NULL, NULL, 12603, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1504324863', 'admin', '2017-09-02 16:11:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44858, '2017-09-02 16:11:47', NULL, NULL, 12603, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 16:11:47', 'admin-1504324863-15043399072705414', 1, 0, '', NULL, NULL, NULL),
(44859, '2017-09-02 14:28:15', NULL, NULL, 12600, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1504324863', 'admin', '2017-09-02 14:28:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44860, '2017-09-02 14:29:24', NULL, NULL, 12600, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 14:29:24', 'admin-1504324863-15043337640333297', 1, 1, 'SR', NULL, NULL, NULL),
(44861, '2017-09-02 14:29:24', NULL, NULL, 12600, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 14:29:24', 'admin-1504324863-15043337640333297', 1, 1, 'SR', NULL, NULL, NULL),
(44862, '2017-09-02 12:12:07', NULL, NULL, 12591, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:12:07', 'admin-1504324863-15043255274094332', 1, 1, 'SR', NULL, NULL, NULL),
(44863, '2017-09-02 12:12:34', NULL, NULL, 12592, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:12:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44864, '2017-09-02 12:13:21', NULL, NULL, 12592, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:13:21', 'admin-1504324863-15043256015688873', 1, 0, '', NULL, NULL, NULL),
(44865, '2017-09-02 11:49:43', NULL, NULL, 12586, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:49:43', 'admin-1504319848-15043241835711268', 1, 0, '', NULL, NULL, NULL),
(44866, '2017-09-02 10:33:44', NULL, NULL, 12578, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 10:33:44', 'sanni-1504259386-15043196246503651', 1, 0, '', NULL, NULL, NULL),
(44867, '2017-09-02 10:34:00', NULL, NULL, 12578, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 10:34:00', 'sanni-1504259386-15043196405292342', 1, 0, '', NULL, NULL, NULL),
(44868, '2017-09-02 10:39:38', NULL, NULL, 12579, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1504324863', 'admin', '2017-09-02 10:39:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44869, '2017-09-02 10:39:47', NULL, NULL, 12579, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 10:39:47', 'admin-1504319848-15043199868596176', 1, 0, '', NULL, NULL, NULL),
(44870, '2017-09-02 10:19:16', NULL, NULL, 12578, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 10:19:16', 'sanni-1504259386-15043187564127122', 1, 1, 'SR', NULL, NULL, NULL),
(44871, '2017-09-02 14:01:20', NULL, NULL, 12599, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1504324863', 'admin', '2017-09-02 14:01:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44872, '2017-09-02 12:13:21', NULL, NULL, 12592, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:13:21', 'admin-1504324863-15043256015688873', 1, 0, '', NULL, NULL, NULL),
(44873, '2017-09-02 12:13:43', NULL, NULL, 12590, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:13:43', 'admin-1504324863-1504325622877948', 1, 1, 'SR', NULL, NULL, NULL),
(44874, '2017-09-02 12:13:43', NULL, NULL, 12590, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:13:43', 'admin-1504324863-1504325622877948', 1, 1, 'SR', NULL, NULL, NULL),
(44875, '2017-09-02 13:46:07', NULL, NULL, 12598, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 13:46:07', 'admin-1504324863-15043311674588840', 1, 1, 'SR', NULL, NULL, NULL),
(44876, '2017-09-02 13:46:07', NULL, NULL, 12598, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 13:46:07', 'admin-1504324863-15043311674588840', 1, 1, 'SR', NULL, NULL, NULL),
(44877, '2017-09-02 13:45:53', NULL, NULL, 12598, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 13:45:53', 'admin-1504324863-15043311536545545', 1, 0, '', NULL, NULL, NULL),
(44878, '2017-09-02 12:24:48', NULL, NULL, 12595, 0, 269, '203', 'Espresso Con Panna', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:24:48', 'admin-1504324863-15043262882671099', 1, 0, '', NULL, NULL, NULL),
(44879, '2017-09-02 12:00:54', NULL, NULL, 12589, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:00:54', 'admin-1504319848-15043248542764531', 1, 1, 'SR', NULL, NULL, NULL),
(44880, '2017-09-02 12:08:40', NULL, NULL, 12590, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:08:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44881, '2017-09-02 12:08:57', NULL, NULL, 12590, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:08:57', 'admin-1504324863-15043253375435742', 1, 0, '', NULL, NULL, NULL),
(44882, '2017-09-02 12:08:57', NULL, NULL, 12590, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:08:57', 'admin-1504324863-15043253375435742', 1, 0, '', NULL, NULL, NULL),
(44883, '2017-09-02 12:11:12', NULL, NULL, 12591, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:11:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44884, '2017-09-02 12:11:50', NULL, NULL, 12591, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:11:50', 'admin-1504324863-15043255107566927', 1, 0, '', NULL, NULL, NULL),
(44885, '2017-09-02 12:11:50', NULL, NULL, 12591, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:11:50', 'admin-1504324863-15043255107566927', 1, 0, '', NULL, NULL, NULL),
(44886, '2017-09-02 12:11:50', NULL, NULL, 12591, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:11:50', 'admin-1504324863-15043255107566927', 1, 1, 'SR', NULL, NULL, NULL),
(44887, '2017-09-02 12:13:21', NULL, NULL, 12592, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:13:21', 'admin-1504324863-15043256015688873', 1, 0, '', NULL, NULL, NULL),
(44888, '2017-09-02 12:13:21', NULL, NULL, 12592, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:13:21', 'admin-1504324863-15043256015688873', 1, 1, 'SR', NULL, NULL, NULL),
(44889, '2017-09-02 11:58:15', NULL, NULL, 12588, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:58:15', 'admin-1504319848-15043246948312263', 1, 0, '', NULL, NULL, NULL),
(44890, '2017-09-02 12:00:54', NULL, NULL, 12589, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:00:54', 'admin-1504319848-15043248542764531', 1, 1, 'SR', NULL, NULL, NULL),
(44891, '2017-09-02 12:00:54', NULL, NULL, 12589, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:00:54', 'admin-1504319848-15043248542764531', 1, 0, '', NULL, NULL, NULL),
(44892, '2017-09-02 12:00:54', NULL, NULL, 12589, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:00:54', 'admin-1504319848-15043248542764531', 1, 0, '', NULL, NULL, NULL),
(44893, '2017-09-02 16:11:47', NULL, NULL, 12603, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 16:11:47', 'admin-1504324863-15043399072705414', 1, 1, 'SR', NULL, NULL, NULL),
(44894, '2017-09-02 11:58:15', NULL, NULL, 12588, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:58:15', 'admin-1504319848-15043246948312263', 1, 0, '', NULL, NULL, NULL),
(44895, '2017-09-02 12:00:13', NULL, NULL, 12589, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:00:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44896, '2017-09-02 11:58:15', NULL, NULL, 12588, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:58:15', 'admin-1504319848-15043246948312263', 1, 0, '', NULL, NULL, NULL),
(44897, '2017-09-02 11:55:19', NULL, NULL, 12587, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:55:19', 'admin-1504319848-15043245192323276', 1, 0, '', NULL, NULL, NULL),
(44898, '2017-09-02 11:53:00', NULL, NULL, 12587, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:53:00', 'admin-1504319848-15043243806975991', 1, 0, '', NULL, NULL, NULL),
(44899, '2017-09-02 11:57:35', NULL, NULL, 12588, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:57:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44900, '2017-09-02 11:53:00', NULL, NULL, 12587, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:53:00', 'admin-1504319848-15043243806975991', 1, 1, 'SR', NULL, NULL, NULL),
(44901, '2017-09-02 11:53:00', NULL, NULL, 12587, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:53:00', 'admin-1504319848-15043243806975991', 1, 1, 'SR', NULL, NULL, NULL),
(44902, '2017-09-02 11:53:00', NULL, NULL, 12587, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:53:00', 'admin-1504319848-15043243806975991', 1, 1, 'SR', NULL, NULL, NULL),
(44903, '2017-09-02 11:50:09', NULL, NULL, 12586, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:50:09', 'admin-1504319848-15043242091957428', 1, 1, 'SR', NULL, NULL, NULL),
(44904, '2017-09-02 11:51:50', NULL, NULL, 12587, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:51:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44905, '2017-09-02 11:53:00', NULL, NULL, 12587, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:53:00', 'admin-1504319848-15043243806975991', 1, 0, '', NULL, NULL, NULL),
(44906, '2017-09-02 10:25:09', NULL, NULL, 12572, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 10:25:09', 'sanni-1504259386-15043191089229430', 1, 0, '', NULL, NULL, NULL),
(44907, '2017-09-02 11:50:09', NULL, NULL, 12586, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:50:09', 'admin-1504319848-15043242091957428', 1, 0, '', NULL, NULL, NULL),
(44908, '2017-09-02 11:49:43', NULL, NULL, 12586, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:49:43', 'admin-1504319848-15043241835711268', 1, 0, '', NULL, NULL, NULL),
(44909, '2017-09-02 11:49:15', NULL, NULL, 12586, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.10, 0.0000, 0.0000, 10.10, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:49:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44910, '2017-09-02 11:49:43', NULL, NULL, 12586, 0, 212, '146', 'Crispy Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:49:43', 'admin-1504319848-15043241835711268', 1, 0, '', NULL, NULL, NULL),
(44911, '2017-09-02 11:47:26', NULL, NULL, 12585, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:47:26', 'admin-1504319848-1504324046317686', 1, 0, '', NULL, NULL, NULL),
(44912, '2017-09-02 11:43:01', NULL, NULL, 12584, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:43:01', 'admin-1504319848-15043237811253475', 1, 0, '', NULL, NULL, NULL),
(44913, '2017-09-02 09:31:20', NULL, NULL, 12575, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:31:20', 'sanni-1504259386-15043158806822887', 1, 1, 'SR', NULL, NULL, NULL),
(44914, '2017-09-02 10:15:55', NULL, NULL, 12574, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 10:15:55', 'sanni-1504259386-15043185553951868', 1, 0, '', NULL, NULL, NULL),
(44915, '2017-09-02 10:18:59', NULL, NULL, 12578, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 10:18:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44916, '2017-09-02 10:19:16', NULL, NULL, 12578, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 10:19:16', 'sanni-1504259386-15043187564127122', 1, 0, '', NULL, NULL, NULL),
(44917, '2017-09-02 11:50:09', NULL, NULL, 12586, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:50:09', 'admin-1504319848-15043242091957428', 1, 0, '', NULL, NULL, NULL),
(44918, '2017-09-02 16:11:47', NULL, NULL, 12603, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 16:11:47', 'admin-1504324863-15043399072705414', 1, 0, '', NULL, NULL, NULL),
(44919, '2017-09-02 12:13:21', NULL, NULL, 12592, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 12:13:21', 'admin-1504324863-15043256015688873', 1, 0, '', NULL, NULL, NULL),
(44920, '2017-09-02 11:23:53', NULL, NULL, 12583, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:23:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44921, '2017-09-02 11:24:00', NULL, NULL, 12583, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:24:00', 'admin-1504319848-15043226402444514', 1, 0, '', NULL, NULL, NULL),
(44922, '2017-09-02 11:50:09', NULL, NULL, 12586, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 11:50:09', 'admin-1504319848-15043242091957428', 1, 1, 'SR', NULL, NULL, NULL),
(44923, '2017-09-02 10:54:56', NULL, NULL, 12582, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 10:54:56', 'admin-1504319848-15043208959764097', 1, 0, '', NULL, NULL, NULL),
(44924, '2017-09-02 10:54:56', NULL, NULL, 12582, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 10:54:56', 'admin-1504319848-15043208959764097', 1, 1, 'SR', NULL, NULL, NULL),
(44925, '2017-09-02 10:40:53', NULL, NULL, 12580, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 10:40:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44926, '2017-09-02 10:39:47', NULL, NULL, 12579, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504324863', 'admin', '2017-09-02 10:39:47', 'admin-1504319848-15043199868596176', 1, 0, '', NULL, NULL, NULL),
(44927, '2017-09-02 09:31:07', NULL, NULL, 12575, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:31:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44928, '2017-09-02 09:37:51', NULL, NULL, 12576, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:37:51', 'sanni-1504259386-15043162711697278', 1, 0, '', NULL, NULL, NULL),
(44929, '2017-09-02 09:37:51', NULL, NULL, 12576, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:37:51', 'sanni-1504259386-15043162711697278', 1, 1, 'SR', NULL, NULL, NULL),
(44930, '2017-09-02 09:52:32', NULL, NULL, 12574, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:52:32', 'sanni-1504259386-15043171521559951', 1, 0, '', NULL, NULL, NULL),
(44931, '2017-09-02 10:06:20', NULL, NULL, 12577, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 10:06:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44932, '2017-09-02 10:06:35', NULL, NULL, 12577, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 10:06:35', 'sanni-1504259386-15043179950222865', 1, 0, '', NULL, NULL, NULL),
(44933, '2017-09-02 10:06:35', NULL, NULL, 12577, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 10:06:35', 'sanni-1504259386-15043179950222865', 1, 0, '', NULL, NULL, NULL),
(44934, '2017-09-02 10:11:40', NULL, NULL, 12571, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 10:11:40', 'sanni-1504259386-15043183003884564', 1, 0, '', NULL, NULL, NULL),
(44935, '2017-09-02 09:31:20', NULL, NULL, 12575, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:31:20', 'sanni-1504259386-15043158806822887', 1, 0, '', NULL, NULL, NULL),
(44936, '2017-09-02 09:37:42', NULL, NULL, 12576, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:37:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44937, '2017-09-02 09:31:20', NULL, NULL, 12575, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:31:20', 'sanni-1504259386-15043158806822887', 1, 0, '', NULL, NULL, NULL),
(44938, '2017-09-02 09:30:48', NULL, NULL, 12574, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:30:48', 'sanni-1504259386-15043158477713867', 1, 1, 'SR', NULL, NULL, NULL),
(44939, '2017-09-02 09:31:20', NULL, NULL, 12575, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:31:20', 'sanni-1504259386-15043158806822887', 1, 0, '', NULL, NULL, NULL),
(44940, '2017-09-02 09:30:48', NULL, NULL, 12574, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:30:48', 'sanni-1504259386-15043158477713867', 1, 0, '', NULL, NULL, NULL),
(44941, '2017-09-02 09:30:48', NULL, NULL, 12574, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:30:48', 'sanni-1504259386-15043158477713867', 1, 0, '', NULL, NULL, NULL),
(44942, '2017-09-02 09:30:48', NULL, NULL, 12574, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:30:48', 'sanni-1504259386-15043158477713867', 1, 1, 'SR', NULL, NULL, NULL),
(44943, '2017-09-02 09:30:48', NULL, NULL, 12574, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:30:48', 'sanni-1504259386-15043158477713867', 1, 0, '', NULL, NULL, NULL),
(44944, '2017-09-02 09:30:48', NULL, NULL, 12574, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:30:48', 'sanni-1504259386-15043158477713867', 1, 0, '', NULL, NULL, NULL),
(44945, '2017-09-02 09:30:48', NULL, NULL, 12574, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:30:48', 'sanni-1504259386-15043158477713867', 1, 0, '', NULL, NULL, NULL),
(44946, '2017-09-02 09:30:48', NULL, NULL, 12574, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:30:48', 'sanni-1504259386-15043158477713867', 1, 0, '', NULL, NULL, NULL),
(44947, '2017-09-02 09:30:02', NULL, NULL, 12574, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.80, 0.0000, 0.0000, 12.80, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:30:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44948, '2017-09-02 09:28:08', NULL, NULL, 12573, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:28:08', 'sanni-1504259386-15043156880182341', 1, 1, 'SR', NULL, NULL, NULL),
(44949, '2017-09-02 09:28:08', NULL, NULL, 12573, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:28:08', 'sanni-1504259386-15043156880182341', 1, 1, 'SR', NULL, NULL, NULL),
(44950, '2017-09-02 09:28:01', NULL, NULL, 12573, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:28:01', 'sanni-1504259386-15043156814364129', 1, 0, '', NULL, NULL, NULL),
(44951, '2017-09-02 09:27:54', NULL, NULL, 12573, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:27:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44952, '2017-09-02 09:18:48', NULL, NULL, 12572, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:18:48', 'sanni-1504259386-15043151284633676', 1, 0, '', NULL, NULL, NULL),
(44953, '2017-09-02 09:18:48', NULL, NULL, 12572, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:18:48', 'sanni-1504259386-15043151284633676', 1, 0, '', NULL, NULL, NULL),
(44954, '2017-09-02 09:18:48', NULL, NULL, 12572, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:18:48', 'sanni-1504259386-15043151284633676', 1, 0, '', NULL, NULL, NULL),
(44955, '2017-09-02 09:06:44', NULL, NULL, 12571, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:06:44', 'sanni-1504259386-15043144046474950', 1, 1, 'SR', NULL, NULL, NULL),
(44956, '2017-09-02 09:18:48', NULL, NULL, 12572, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:18:48', 'sanni-1504259386-15043151284633676', 1, 0, '', NULL, NULL, NULL),
(44957, '2017-09-02 09:18:20', NULL, NULL, 12572, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:18:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44958, '2017-09-02 09:18:48', NULL, NULL, 12572, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:18:48', 'sanni-1504259386-15043151284633676', 1, 0, '', NULL, NULL, NULL),
(44959, '2017-09-02 09:06:44', NULL, NULL, 12571, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:06:44', 'sanni-1504259386-15043144046474950', 1, 1, 'SR', NULL, NULL, NULL),
(44960, '2017-09-02 09:05:19', NULL, NULL, 12570, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:05:19', 'sanni-1504259386-15043143195432759', 1, 0, '', NULL, NULL, NULL),
(44961, '2017-09-02 09:06:33', NULL, NULL, 12571, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:06:33', 'sanni-1504259386-15043143933273354', 1, 0, '', NULL, NULL, NULL),
(44962, '2017-09-02 09:06:33', NULL, NULL, 12571, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:06:33', 'sanni-1504259386-15043143933273354', 1, 0, '', NULL, NULL, NULL),
(44963, '2017-09-02 09:05:29', NULL, NULL, 12570, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:05:29', 'sanni-1504259386-15043143287814942', 1, 1, 'SR', NULL, NULL, NULL),
(44964, '2017-09-02 09:06:28', NULL, NULL, 12571, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:06:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44965, '2017-09-02 09:05:28', NULL, NULL, 12570, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:05:28', 'sanni-1504259386-15043143287814942', 1, 1, 'SR', NULL, NULL, NULL),
(44966, '2017-09-02 09:05:28', NULL, NULL, 12570, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:05:28', 'sanni-1504259386-15043143287814942', 1, 1, 'SR', NULL, NULL, NULL),
(44967, '2017-09-02 09:05:19', NULL, NULL, 12570, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:05:19', 'sanni-1504259386-15043143195432759', 1, 0, '', NULL, NULL, NULL),
(44968, '2017-09-02 09:05:19', NULL, NULL, 12570, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:05:19', 'sanni-1504259386-15043143195432759', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(44969, '2017-09-02 09:05:19', NULL, NULL, 12570, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:05:19', 'sanni-1504259386-15043143195432759', 1, 0, '', NULL, NULL, NULL),
(44970, '2017-09-02 09:05:08', NULL, NULL, 12570, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.70, 0.0000, 0.0000, 11.70, 1, '27', 1, '1504324863', 'sanni', '2017-09-02 09:05:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44971, '2017-09-03 15:10:34', NULL, NULL, 12638, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1504414860', 'admin', '2017-09-03 15:10:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44972, '2017-09-03 15:11:05', NULL, NULL, 12638, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 15:11:05', 'admin-1504414860-15044226655677234', 1, 1, 'SR', NULL, NULL, NULL),
(44973, '2017-09-03 15:11:05', NULL, NULL, 12638, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 15:11:05', 'admin-1504414860-15044226655677234', 1, 0, '', NULL, NULL, NULL),
(44974, '2017-09-03 15:39:35', NULL, NULL, 12640, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1504414860', 'admin', '2017-09-03 15:39:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44975, '2017-09-03 15:41:59', NULL, NULL, 12640, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 15:41:59', 'admin-1504414860-15044245195878216', 1, 0, '', NULL, NULL, NULL),
(44976, '2017-09-03 14:31:15', NULL, NULL, 12637, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 14:31:15', 'admin-1504414860-1504420275052163', 1, 1, 'SR', NULL, NULL, NULL),
(44977, '2017-09-03 14:31:15', NULL, NULL, 12637, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 14:31:15', 'admin-1504414860-1504420275052163', 1, 0, '', NULL, NULL, NULL),
(44978, '2017-09-03 14:31:15', NULL, NULL, 12637, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 14:31:15', 'admin-1504414860-1504420275052163', 1, 0, '', NULL, NULL, NULL),
(44979, '2017-09-03 14:31:26', NULL, NULL, 12637, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 14:31:26', 'admin-1504414860-15044202862349579', 1, 1, 'SR', NULL, NULL, NULL),
(44980, '2017-09-03 14:31:26', NULL, NULL, 12637, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 14:31:26', 'admin-1504414860-15044202862349579', 1, 1, 'SR', NULL, NULL, NULL),
(44981, '2017-09-03 14:31:26', NULL, NULL, 12637, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 14:31:26', 'admin-1504414860-15044202862349579', 1, 1, 'SR', NULL, NULL, NULL),
(44982, '2017-09-03 14:12:04', NULL, NULL, 12629, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 14:12:04', 'admin-1504414860-15044191242392444', 1, 0, '', NULL, NULL, NULL),
(44983, '2017-09-03 14:14:48', NULL, NULL, 12636, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 14:14:48', 'admin-1504414860-15044192880713359', 1, 0, '', 1, NULL, '10.0'),
(44984, '2017-09-03 14:31:00', NULL, NULL, 12637, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1504414860', 'admin', '2017-09-03 14:31:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44985, '2017-09-03 11:00:32', NULL, NULL, 12617, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:00:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44986, '2017-09-03 11:00:44', NULL, NULL, 12617, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:00:44', 'admin-1504407199-15044076441892546', 1, 0, '', NULL, NULL, NULL),
(44987, '2017-09-03 11:00:44', NULL, NULL, 12617, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:00:44', 'admin-1504407199-15044076441892546', 1, 0, '', NULL, NULL, NULL),
(44988, '2017-09-03 12:56:12', NULL, NULL, 12631, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:56:12', 'admin-1504413175-15044145720025791', 1, 1, 'SR', NULL, NULL, NULL),
(44989, '2017-09-03 12:55:57', NULL, NULL, 12631, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:55:57', 'admin-1504413175-15044145575026441', 1, 1, 'SR', NULL, NULL, NULL),
(44990, '2017-09-03 12:55:57', NULL, NULL, 12631, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:55:57', 'admin-1504413175-15044145575026441', 1, 0, '', NULL, NULL, NULL),
(44991, '2017-09-03 12:43:40', NULL, NULL, 12626, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:43:40', 'admin-1504413175-1504413820005359', 1, 1, 'SR', NULL, NULL, NULL),
(44992, '2017-09-03 12:43:51', NULL, NULL, 12627, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:43:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(44993, '2017-09-03 12:44:20', NULL, NULL, 12627, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:44:20', 'admin-1504413175-15044138607029345', 1, 0, '', NULL, NULL, NULL),
(44994, '2017-09-03 12:44:20', NULL, NULL, 12627, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:44:20', 'admin-1504413175-15044138607029345', 1, 1, 'SR', NULL, NULL, NULL),
(44995, '2017-09-03 13:17:19', NULL, NULL, 12635, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 13:17:19', 'admin-1504414860-1504415839185662', 1, 1, 'SR', NULL, NULL, NULL),
(44996, '2017-09-03 13:02:56', NULL, NULL, 12622, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 13:02:56', 'admin-1504414860-15044149766624899', 1, 0, '', NULL, NULL, NULL),
(44997, '2017-09-03 13:14:53', NULL, NULL, 12634, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 13:14:53', 'admin-1504414860-1504415693256416', 1, 1, 'SR', NULL, NULL, NULL),
(44998, '2017-09-03 13:14:53', NULL, NULL, 12634, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 13:14:53', 'admin-1504414860-1504415693256416', 1, 1, 'SR', NULL, NULL, NULL),
(44999, '2017-09-03 10:30:52', NULL, NULL, 12610, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:30:52', 'admin-1504400131-15044058523795454', 1, 0, '', NULL, NULL, NULL),
(45000, '2017-09-03 10:31:21', NULL, NULL, 12610, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:31:21', 'admin-1504400131-15044058811174545', 1, 0, '', NULL, NULL, NULL),
(45001, '2017-09-03 11:20:11', NULL, NULL, 12619, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:20:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45002, '2017-09-03 11:20:35', NULL, NULL, 12619, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:20:35', 'admin-1504407199-15044088354404144', 1, 0, '', NULL, NULL, NULL),
(45003, '2017-09-03 11:20:35', NULL, NULL, 12619, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:20:35', 'admin-1504407199-15044088354404144', 1, 0, '', NULL, NULL, NULL),
(45004, '2017-09-03 11:20:35', NULL, NULL, 12619, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:20:35', 'admin-1504407199-15044088354404144', 1, 0, '', NULL, NULL, NULL),
(45005, '2017-09-03 11:20:35', NULL, NULL, 12619, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:20:35', 'admin-1504407199-15044088354404144', 1, 1, 'SR', NULL, NULL, NULL),
(45006, '2017-09-03 11:20:35', NULL, NULL, 12619, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:20:35', 'admin-1504407199-15044088354404144', 1, 1, 'SR', NULL, NULL, NULL),
(45007, '2017-09-03 11:20:35', NULL, NULL, 12619, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:20:35', 'admin-1504407199-15044088354404144', 1, 1, 'SR', NULL, NULL, NULL),
(45008, '2017-09-03 11:20:43', NULL, NULL, 12620, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:20:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45009, '2017-09-03 11:21:12', NULL, NULL, 12620, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:21:12', 'admin-1504407199-15044088720314939', 1, 0, '', NULL, NULL, NULL),
(45010, '2017-09-03 11:21:12', NULL, NULL, 12620, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:21:12', 'admin-1504407199-15044088720314939', 1, 0, '', NULL, NULL, NULL),
(45011, '2017-09-03 11:21:12', NULL, NULL, 12620, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:21:12', 'admin-1504407199-15044088720314939', 1, 0, '', NULL, NULL, NULL),
(45012, '2017-09-03 11:21:12', NULL, NULL, 12620, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:21:12', 'admin-1504407199-15044088720314939', 1, 1, 'SR', NULL, NULL, NULL),
(45013, '2017-09-03 14:01:26', NULL, NULL, 12631, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 14:01:26', 'admin-1504414860-15044184862859452', 1, 0, '', NULL, NULL, NULL),
(45014, '2017-09-03 12:34:24', NULL, NULL, 12625, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:34:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45015, '2017-09-03 12:04:30', NULL, NULL, 12622, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:04:30', 'admin-1504407199-15044114703982227', 1, 1, 'SR', NULL, NULL, NULL),
(45016, '2017-09-03 13:14:38', NULL, NULL, 12634, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1504414860', 'admin', '2017-09-03 13:14:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45017, '2017-09-03 13:26:20', NULL, NULL, 12617, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 13:26:20', 'admin-1504414860-15044163801109176', 1, 1, 'SR', NULL, NULL, NULL),
(45018, '2017-09-03 13:26:20', NULL, NULL, 12617, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 13:26:20', 'admin-1504414860-15044163801109176', 1, 1, 'SR', NULL, NULL, NULL),
(45019, '2017-09-03 13:28:40', NULL, NULL, 12630, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 13:28:40', 'admin-1504414860-15044165201819746', 1, 1, 'SR', NULL, NULL, NULL),
(45020, '2017-09-03 13:30:06', NULL, NULL, 12626, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 13:30:06', 'admin-1504414860-15044166058635417', 1, 0, '', NULL, NULL, NULL),
(45021, '2017-09-03 13:31:49', NULL, NULL, 12630, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 13:31:49', 'admin-1504414860-15044167096935451', 1, 0, '', NULL, NULL, NULL),
(45022, '2017-09-03 13:41:30', NULL, NULL, 12629, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 13:41:30', 'admin-1504414860-1504417289988699', 1, 1, 'SR', NULL, NULL, NULL),
(45023, '2017-09-03 12:04:30', NULL, NULL, 12622, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:04:30', 'admin-1504407199-15044114703982227', 1, 0, '', NULL, NULL, NULL),
(45024, '2017-09-03 12:44:50', NULL, NULL, 12628, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:44:50', 'admin-1504413175-15044138901434954', 1, 1, 'SR', NULL, NULL, NULL),
(45025, '2017-09-03 12:32:46', NULL, NULL, 12624, 0, 181, '116', 'Open Food ', 'kids pasta', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:32:46', 'admin-1504407199-1504413165994273', 1, 0, '', NULL, NULL, NULL),
(45026, '2017-09-03 15:41:59', NULL, NULL, 12640, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 15:41:59', 'admin-1504414860-15044245195878216', 1, 0, '', NULL, NULL, NULL),
(45027, '2017-09-03 15:21:25', NULL, NULL, 12639, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1504414860', 'admin', '2017-09-03 15:21:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45028, '2017-09-03 10:57:39', NULL, NULL, 12616, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:57:39', 'admin-1504407199-15044074591637999', 1, 0, '', NULL, NULL, NULL),
(45029, '2017-09-03 16:01:46', NULL, NULL, 12641, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 16:01:46', 'admin-1504414860-15044257067607964', 1, 1, 'SR', 1, NULL, '10.0'),
(45030, '2017-09-03 15:42:46', NULL, NULL, 12637, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 15:42:46', 'admin-1504414860-15044245664102835', 1, 0, '', NULL, NULL, NULL),
(45031, '2017-09-03 15:21:30', NULL, NULL, 12639, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 15:21:30', 'admin-1504414860-15044232898182580', 1, 1, 'SR', NULL, NULL, NULL),
(45032, '2017-09-03 15:11:05', NULL, NULL, 12638, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 15:11:05', 'admin-1504414860-15044226655677234', 1, 0, '', NULL, NULL, NULL),
(45033, '2017-09-03 15:11:05', NULL, NULL, 12638, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 15:11:05', 'admin-1504414860-15044226655677234', 1, 1, 'SR', NULL, NULL, NULL),
(45034, '2017-09-03 12:34:36', NULL, NULL, 12625, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:34:36', 'admin-1504413175-1504413276630555', 1, 0, '', NULL, NULL, NULL),
(45035, '2017-09-03 12:34:36', NULL, NULL, 12625, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:34:36', 'admin-1504413175-1504413276630555', 1, 1, 'SR', NULL, NULL, NULL),
(45036, '2017-09-03 12:39:50', NULL, NULL, 12626, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:39:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45037, '2017-09-03 13:02:03', NULL, NULL, 12633, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 13:02:03', 'admin-1504414860-15044149235218530', 1, 0, '', NULL, NULL, NULL),
(45038, '2017-09-03 13:00:24', NULL, NULL, 12632, 0, 182, '117', 'Open Drinks ', 'americano promo', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 13:00:24', 'admin-1504413175-15044148245925862', 1, 0, '', 1, NULL, NULL),
(45039, '2017-09-03 13:00:33', NULL, NULL, 12633, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1504414860', 'admin', '2017-09-03 13:00:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45040, '2017-09-03 13:00:56', NULL, NULL, 12633, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 13:00:56', 'admin-1504413175-15044148558694420', 1, 1, 'SR', NULL, NULL, NULL),
(45041, '2017-09-03 13:00:56', NULL, NULL, 12633, 0, 220, '154', 'Smoked Bacon Basil Pesto', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 13:00:56', 'admin-1504413175-15044148558694420', 1, 0, '', NULL, NULL, NULL),
(45042, '2017-09-03 13:00:56', NULL, NULL, 12633, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 13:00:56', 'admin-1504413175-15044148558694420', 1, 0, '', NULL, NULL, NULL),
(45043, '2017-09-03 13:17:19', NULL, NULL, 12635, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 13:17:19', 'admin-1504414860-1504415839185662', 1, 0, '', NULL, NULL, NULL),
(45044, '2017-09-03 13:17:19', NULL, NULL, 12635, 0, 223, '157', 'Crispy Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 13:17:19', 'admin-1504414860-1504415839185662', 1, 0, '', NULL, NULL, NULL),
(45045, '2017-09-03 13:17:19', NULL, NULL, 12635, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 13:17:19', 'admin-1504414860-1504415839185662', 1, 0, '', NULL, NULL, NULL),
(45046, '2017-09-03 12:03:25', NULL, NULL, 12622, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.90, 0.0000, 0.0000, 9.90, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:03:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45047, '2017-09-03 13:16:18', NULL, NULL, 12635, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1504414860', 'admin', '2017-09-03 13:16:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45048, '2017-09-03 12:55:45', NULL, NULL, 12631, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:55:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45049, '2017-09-03 12:56:12', NULL, NULL, 12631, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:56:12', 'admin-1504413175-15044145720025791', 1, 1, 'SR', NULL, NULL, NULL),
(45050, '2017-09-03 12:56:12', NULL, NULL, 12631, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:56:12', 'admin-1504413175-15044145720025791', 1, 1, 'SR', NULL, NULL, NULL),
(45051, '2017-09-03 12:44:50', NULL, NULL, 12628, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:44:50', 'admin-1504413175-15044138901434954', 1, 0, '', NULL, NULL, NULL),
(45052, '2017-09-03 12:44:50', NULL, NULL, 12628, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:44:50', 'admin-1504413175-15044138901434954', 1, 1, 'SR', NULL, NULL, NULL),
(45053, '2017-09-03 10:29:55', NULL, NULL, 12610, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 20.50, 0.0000, 0.0000, 20.50, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:29:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45054, '2017-09-03 10:30:52', NULL, NULL, 12610, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:30:52', 'admin-1504400131-15044058523795454', 1, 0, '', NULL, NULL, NULL),
(45055, '2017-09-03 10:30:52', NULL, NULL, 12610, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:30:52', 'admin-1504400131-15044058523795454', 1, 0, '', NULL, NULL, NULL),
(45056, '2017-09-03 10:30:52', NULL, NULL, 12610, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:30:52', 'admin-1504400131-15044058523795454', 1, 0, '', NULL, NULL, NULL),
(45057, '2017-09-03 12:04:30', NULL, NULL, 12622, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:04:30', 'admin-1504407199-15044114703982227', 1, 0, '', NULL, NULL, NULL),
(45058, '2017-09-03 12:04:30', NULL, NULL, 12622, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:04:30', 'admin-1504407199-15044114703982227', 1, 1, 'SR', NULL, NULL, NULL),
(45059, '2017-09-03 12:04:44', NULL, NULL, 12622, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:04:44', 'admin-1504407199-1504411484611217', 1, 0, '', NULL, NULL, NULL),
(45060, '2017-09-03 12:48:43', NULL, NULL, 12630, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:48:43', 'admin-1504413175-15044141236719638', 1, 1, 'SR', NULL, NULL, NULL),
(45061, '2017-09-03 12:48:43', NULL, NULL, 12630, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:48:43', 'admin-1504413175-15044141236719638', 1, 1, 'SR', NULL, NULL, NULL),
(45062, '2017-09-03 12:48:43', NULL, NULL, 12630, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:48:43', 'admin-1504413175-15044141236719638', 1, 1, 'SR', NULL, NULL, NULL),
(45063, '2017-09-03 12:48:43', NULL, NULL, 12630, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:48:43', 'admin-1504413175-15044141236719638', 1, 0, '', NULL, NULL, NULL),
(45064, '2017-09-03 12:48:00', NULL, NULL, 12630, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:48:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45065, '2017-09-03 12:48:12', NULL, NULL, 12630, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:48:12', 'admin-1504413175-1504414091967459', 1, 0, '', NULL, NULL, NULL),
(45066, '2017-09-03 12:47:53', NULL, NULL, 12629, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:47:53', 'admin-1504413175-1504414073463437', 1, 1, 'SR', NULL, NULL, NULL),
(45067, '2017-09-03 12:47:53', NULL, NULL, 12629, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:47:53', 'admin-1504413175-1504414073463437', 1, 1, 'SR', NULL, NULL, NULL),
(45068, '2017-09-03 12:47:53', NULL, NULL, 12629, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:47:53', 'admin-1504413175-1504414073463437', 1, 1, 'SR', NULL, NULL, NULL),
(45069, '2017-09-03 12:47:53', NULL, NULL, 12629, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:47:53', 'admin-1504413175-1504414073463437', 1, 1, 'SR', NULL, NULL, NULL),
(45070, '2017-09-03 12:47:53', NULL, NULL, 12629, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:47:53', 'admin-1504413175-1504414073463437', 1, 0, '', NULL, NULL, NULL),
(45071, '2017-09-03 12:47:53', NULL, NULL, 12629, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:47:53', 'admin-1504413175-1504414073463437', 1, 1, 'SR', NULL, NULL, NULL),
(45072, '2017-09-03 12:47:53', NULL, NULL, 12629, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:47:53', 'admin-1504413175-1504414073463437', 1, 1, 'SR', NULL, NULL, NULL),
(45073, '2017-09-03 12:47:53', NULL, NULL, 12629, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:47:53', 'admin-1504413175-1504414073463437', 1, 1, 'SR', NULL, NULL, NULL),
(45074, '2017-09-03 12:46:05', NULL, NULL, 12629, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.60, 0.0000, 0.0000, 11.60, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:46:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45075, '2017-09-03 12:30:09', NULL, NULL, 12624, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:30:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45076, '2017-09-03 12:44:27', NULL, NULL, 12628, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:44:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45077, '2017-09-03 12:41:55', NULL, NULL, 12626, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:41:55', 'admin-1504413175-15044137157784553', 1, 0, '', NULL, NULL, NULL),
(45078, '2017-09-03 12:41:55', NULL, NULL, 12626, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:41:55', 'admin-1504413175-15044137157784553', 1, 0, '', NULL, NULL, NULL),
(45079, '2017-09-03 12:41:55', NULL, NULL, 12626, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:41:55', 'admin-1504413175-15044137157784553', 1, 0, '', NULL, NULL, NULL),
(45080, '2017-09-03 12:41:55', NULL, NULL, 12626, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:41:55', 'admin-1504413175-15044137157784553', 1, 1, 'SR', NULL, NULL, NULL),
(45081, '2017-09-03 12:33:16', NULL, NULL, 12624, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:33:16', 'admin-1504413175-15044131965683060', 1, 1, 'SR', NULL, NULL, NULL),
(45082, '2017-09-03 12:33:16', NULL, NULL, 12624, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:33:16', 'admin-1504413175-15044131965683060', 1, 1, 'SR', NULL, NULL, NULL),
(45083, '2017-09-03 12:33:16', NULL, NULL, 12624, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:33:16', 'admin-1504413175-15044131965683060', 1, 1, 'SR', NULL, NULL, NULL),
(45084, '2017-09-03 12:32:46', NULL, NULL, 12624, 0, 182, '117', 'Open Drinks ', 'yogurt', 'Cold Drinks', 'Fresh Juice', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:32:46', 'admin-1504407199-1504413165994273', 1, 0, '', NULL, NULL, NULL),
(45085, '2017-09-03 11:21:12', NULL, NULL, 12620, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:21:12', 'admin-1504407199-15044088720314939', 1, 1, 'SR', NULL, NULL, NULL),
(45086, '2017-09-03 11:30:27', NULL, NULL, 12621, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:30:27', 'admin-1504407199-15044094274934699', 1, 0, '', NULL, NULL, NULL),
(45087, '2017-09-03 11:30:27', NULL, NULL, 12621, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:30:27', 'admin-1504407199-15044094274934699', 1, 1, 'SR', NULL, NULL, NULL),
(45088, '2017-09-03 11:30:27', NULL, NULL, 12621, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:30:27', 'admin-1504407199-15044094274934699', 1, 1, 'SR', NULL, NULL, NULL),
(45089, '2017-09-03 11:05:23', NULL, NULL, 12618, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:05:23', 'admin-1504407199-1504407923418452', 1, 0, '', NULL, NULL, NULL),
(45090, '2017-09-03 11:05:23', NULL, NULL, 12618, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:05:23', 'admin-1504407199-1504407923418452', 1, 0, '', NULL, NULL, NULL),
(45091, '2017-09-03 11:05:23', NULL, NULL, 12618, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:05:23', 'admin-1504407199-1504407923418452', 1, 1, 'SR', NULL, NULL, NULL),
(45092, '2017-09-03 11:05:23', NULL, NULL, 12618, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:05:23', 'admin-1504407199-1504407923418452', 1, 1, 'SR', NULL, NULL, NULL),
(45093, '2017-09-03 10:45:50', NULL, NULL, 12610, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:45:50', 'admin-1504400131-15044067506115017', 1, 0, '', NULL, NULL, NULL),
(45094, '2017-09-03 10:52:21', NULL, NULL, 12615, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:52:21', 'admin-1504400131-15044071412156035', 1, 0, '', NULL, NULL, '10.0'),
(45095, '2017-09-03 10:48:37', NULL, NULL, 12611, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:48:37', 'admin-1504400131-15044069175177378', 1, 1, 'SR', NULL, NULL, NULL),
(45096, '2017-09-03 10:48:44', NULL, NULL, 12612, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:48:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45097, '2017-09-03 12:05:20', NULL, NULL, 12623, 0, 182, '117', 'Open Drinks ', 'americano promo', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:05:20', 'admin-1504407199-15044115201961650', 1, 0, '', 1, NULL, NULL),
(45098, '2017-09-03 12:32:46', NULL, NULL, 12624, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:32:46', 'admin-1504407199-1504413165994273', 1, 0, '', NULL, NULL, NULL),
(45099, '2017-09-03 12:32:46', NULL, NULL, 12624, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:32:46', 'admin-1504407199-1504413165994273', 1, 0, '', NULL, NULL, NULL),
(45100, '2017-09-03 12:04:44', NULL, NULL, 12622, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:04:44', 'admin-1504407199-1504411484611217', 1, 1, 'SR', NULL, NULL, NULL),
(45101, '2017-09-03 12:04:30', NULL, NULL, 12622, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:04:30', 'admin-1504407199-15044114703982227', 1, 0, '', NULL, NULL, NULL),
(45102, '2017-09-03 10:53:11', NULL, NULL, 12612, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:53:11', 'admin-1504400131-15044071913248143', 1, 0, '', NULL, NULL, NULL),
(45103, '2017-09-03 10:53:11', NULL, NULL, 12612, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:53:11', 'admin-1504400131-15044071913248143', 1, 0, '', NULL, NULL, NULL),
(45104, '2017-09-03 10:49:36', NULL, NULL, 12613, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:49:36', 'admin-1504400131-15044069759648258', 1, 0, '', NULL, NULL, NULL),
(45105, '2017-09-03 11:30:27', NULL, NULL, 12621, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:30:27', 'admin-1504407199-15044094274934699', 1, 0, '', NULL, NULL, NULL),
(45106, '2017-09-03 11:29:05', NULL, NULL, 12621, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:29:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45107, '2017-09-03 11:00:44', NULL, NULL, 12617, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:00:44', 'admin-1504407199-15044076441892546', 1, 1, 'SR', NULL, NULL, NULL),
(45108, '2017-09-03 11:00:44', NULL, NULL, 12617, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:00:44', 'admin-1504407199-15044076441892546', 1, 1, 'SR', NULL, NULL, NULL),
(45109, '2017-09-03 10:53:43', NULL, NULL, 12615, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:53:43', 'admin-1504407199-15044072234996219', 1, 1, 'SR', NULL, NULL, '10.0'),
(45110, '2017-09-03 14:01:26', NULL, NULL, 12631, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 14:01:26', 'admin-1504414860-15044184862859452', 1, 0, '', NULL, NULL, NULL),
(45111, '2017-09-03 11:04:59', NULL, NULL, 12618, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:04:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45112, '2017-09-03 10:57:30', NULL, NULL, 12616, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:57:30', 'admin-1504407199-15044074507557095', 1, 1, 'SR', NULL, NULL, NULL),
(45113, '2017-09-03 10:57:30', NULL, NULL, 12616, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:57:30', 'admin-1504407199-15044074507557095', 1, 0, '', NULL, NULL, NULL),
(45114, '2017-09-03 12:55:57', NULL, NULL, 12631, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 12:55:57', 'admin-1504413175-15044145575026441', 1, 0, '', NULL, NULL, NULL),
(45115, '2017-09-03 10:57:04', NULL, NULL, 12616, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:57:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45116, '2017-09-03 10:52:21', NULL, NULL, 12615, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:52:21', 'admin-1504400131-15044071412156035', 1, 0, '', NULL, NULL, '10.0'),
(45117, '2017-09-03 10:53:43', NULL, NULL, 12615, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:53:43', 'admin-1504407199-15044072234996219', 1, 0, '', NULL, NULL, '10.0'),
(45118, '2017-09-03 10:53:11', NULL, NULL, 12612, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:53:11', 'admin-1504400131-15044071913248143', 1, 0, '', NULL, NULL, NULL),
(45119, '2017-09-03 09:11:54', NULL, NULL, 12607, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1504414860', 'admin', '2017-09-03 09:11:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45120, '2017-09-03 09:11:24', NULL, NULL, 12606, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 09:11:24', 'admin-1504400131-15044010844608971', 1, 0, '', NULL, NULL, NULL),
(45121, '2017-09-03 09:11:24', NULL, NULL, 12606, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 09:11:24', 'admin-1504400131-15044010844608971', 1, 0, '', NULL, NULL, NULL),
(45122, '2017-09-03 10:19:46', NULL, NULL, 12609, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:19:46', 'admin-1504400131-15044051861864274', 1, 0, '', NULL, NULL, NULL),
(45123, '2017-09-03 10:19:46', NULL, NULL, 12609, 0, 271, '205', 'Take It Easy', 'fried egg', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:19:46', 'admin-1504400131-15044051861864274', 1, 0, '', NULL, NULL, NULL),
(45124, '2017-09-03 10:20:43', NULL, NULL, 12609, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:20:43', 'admin-1504400131-1504405242810895', 1, 0, '', NULL, NULL, NULL),
(45125, '2017-09-03 10:20:43', NULL, NULL, 12609, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:20:43', 'admin-1504400131-1504405242810895', 1, 0, '', NULL, NULL, NULL),
(45126, '2017-09-03 11:21:12', NULL, NULL, 12620, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 11:21:12', 'admin-1504407199-15044088720314939', 1, 1, 'SR', NULL, NULL, NULL),
(45127, '2017-09-03 10:50:54', NULL, NULL, 12614, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:50:54', 'admin-1504400131-15044070544328074', 1, 1, 'SR', NULL, NULL, NULL),
(45128, '2017-09-03 10:51:12', NULL, NULL, 12615, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:51:12', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(45129, '2017-09-03 10:50:54', NULL, NULL, 12614, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:50:54', 'admin-1504400131-15044070544328074', 1, 0, '', NULL, NULL, NULL),
(45130, '2017-09-03 10:50:54', NULL, NULL, 12614, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:50:54', 'admin-1504400131-15044070544328074', 1, 1, 'SR', NULL, NULL, NULL),
(45131, '2017-09-03 10:50:36', NULL, NULL, 12614, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:50:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45132, '2017-09-03 10:48:47', NULL, NULL, 12612, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:48:47', 'admin-1504400131-1504406927284784', 1, 1, 'SR', NULL, NULL, NULL),
(45133, '2017-09-03 10:49:31', NULL, NULL, 12613, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:49:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45134, '2017-09-03 10:31:21', NULL, NULL, 12610, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:31:21', 'admin-1504400131-15044058811174545', 1, 1, 'SR', NULL, NULL, NULL),
(45135, '2017-09-03 10:48:37', NULL, NULL, 12611, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:48:37', 'admin-1504400131-15044069175177378', 1, 0, '', NULL, NULL, NULL),
(45136, '2017-09-03 10:48:25', NULL, NULL, 12611, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:48:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45137, '2017-09-03 10:31:21', NULL, NULL, 12610, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:31:21', 'admin-1504400131-15044058811174545', 1, 1, 'SR', NULL, NULL, NULL),
(45138, '2017-09-03 10:31:21', NULL, NULL, 12610, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:31:21', 'admin-1504400131-15044058811174545', 1, 1, 'SR', NULL, NULL, NULL),
(45139, '2017-09-03 10:31:21', NULL, NULL, 12610, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:31:21', 'admin-1504400131-15044058811174545', 1, 1, 'SR', NULL, NULL, NULL),
(45140, '2017-09-03 10:31:21', NULL, NULL, 12610, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:31:21', 'admin-1504400131-15044058811174545', 1, 1, 'SR', NULL, NULL, NULL),
(45141, '2017-09-03 10:31:21', NULL, NULL, 12610, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:31:21', 'admin-1504400131-15044058811174545', 1, 1, 'SR', NULL, NULL, NULL),
(45142, '2017-09-03 10:30:52', NULL, NULL, 12610, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:30:52', 'admin-1504400131-15044058523795454', 1, 0, '', NULL, NULL, NULL),
(45143, '2017-09-03 10:30:52', NULL, NULL, 12610, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:30:52', 'admin-1504400131-15044058523795454', 1, 0, '', NULL, NULL, NULL),
(45144, '2017-09-03 09:12:13', NULL, NULL, 12607, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 09:12:13', 'admin-1504400131-1504401133624890', 1, 1, 'SR', NULL, NULL, NULL),
(45145, '2017-09-03 09:12:13', NULL, NULL, 12607, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 09:12:13', 'admin-1504400131-1504401133624890', 1, 1, 'SR', NULL, NULL, NULL),
(45146, '2017-09-03 09:45:42', NULL, NULL, 12608, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1504414860', 'admin', '2017-09-03 09:45:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45147, '2017-09-03 09:46:10', NULL, NULL, 12608, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 09:46:10', 'admin-1504400131-1504403169873725', 1, 0, '', NULL, NULL, NULL),
(45148, '2017-09-03 09:46:10', NULL, NULL, 12608, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 09:46:10', 'admin-1504400131-1504403169873725', 1, 0, '', NULL, NULL, NULL),
(45149, '2017-09-03 09:46:38', NULL, NULL, 12607, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 09:46:38', 'admin-1504400131-15044031986876860', 1, 0, '', NULL, NULL, NULL),
(45150, '2017-09-03 09:47:46', NULL, NULL, 12608, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 09:47:46', 'admin-1504400131-15044032665176283', 1, 1, 'SR', NULL, NULL, NULL),
(45151, '2017-09-03 09:47:46', NULL, NULL, 12608, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 09:47:46', 'admin-1504400131-15044032665176283', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(45152, '2017-09-03 09:12:07', NULL, NULL, 12607, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 09:12:07', 'admin-1504400131-15044011275533458', 1, 0, '', NULL, NULL, NULL),
(45153, '2017-09-03 09:12:07', NULL, NULL, 12607, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 09:12:07', 'admin-1504400131-15044011275533458', 1, 0, '', NULL, NULL, NULL),
(45154, '2017-09-03 10:19:16', NULL, NULL, 12609, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1504414860', 'admin', '2017-09-03 10:19:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45155, '2017-09-03 09:11:46', NULL, NULL, 12606, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 09:11:46', 'admin-1504400131-15044011063707977', 1, 1, 'SR', NULL, NULL, NULL),
(45156, '2017-09-03 09:11:46', NULL, NULL, 12606, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504414860', 'admin', '2017-09-03 09:11:46', 'admin-1504400131-15044011063707977', 1, 1, 'SR', NULL, NULL, NULL),
(45157, '2017-09-03 09:11:15', NULL, NULL, 12606, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1504414860', 'admin', '2017-09-03 09:11:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45158, '2017-09-04 15:55:10', NULL, NULL, 12672, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:55:10', 'admin-1504506284-1504511710159378', 1, 0, '', NULL, NULL, NULL),
(45159, '2017-09-04 13:32:30', NULL, NULL, 12665, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 13:32:30', 'lois-1504493749-15045031507431517', 1, 1, 'SR', NULL, NULL, NULL),
(45160, '2017-09-04 12:30:09', NULL, NULL, 12663, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 12:30:09', 'lois-1504493749-15044994088399763', 1, 1, 'SR', NULL, NULL, NULL),
(45161, '2017-09-04 12:29:36', NULL, NULL, 12663, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 12:29:36', 'lois-1504493749-15044993766742021', 1, 1, 'SR', NULL, NULL, NULL),
(45162, '2017-09-04 12:29:36', NULL, NULL, 12663, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 12:29:36', 'lois-1504493749-15044993766742021', 1, 0, '', NULL, NULL, NULL),
(45163, '2017-09-04 12:29:44', NULL, NULL, 12663, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 12:29:44', 'lois-1504493749-15044993839525353', 1, 1, 'SR', NULL, NULL, NULL),
(45164, '2017-09-04 12:29:44', NULL, NULL, 12663, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 12:29:44', 'lois-1504493749-15044993839525353', 1, 1, 'SR', NULL, NULL, NULL),
(45165, '2017-09-04 12:29:36', NULL, NULL, 12663, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 12:29:36', 'lois-1504493749-15044993766742021', 1, 0, '', NULL, NULL, NULL),
(45166, '2017-09-04 15:41:18', NULL, NULL, 12671, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:41:18', 'admin-1504506284-15045108781275234', 1, 1, 'SR', NULL, NULL, NULL),
(45167, '2017-09-04 15:41:18', NULL, NULL, 12671, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:41:18', 'admin-1504506284-15045108781275234', 1, 1, 'SR', NULL, NULL, NULL),
(45168, '2017-09-04 15:41:18', NULL, NULL, 12671, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:41:18', 'admin-1504506284-15045108781275234', 1, 1, 'SR', NULL, NULL, NULL),
(45169, '2017-09-04 15:54:54', NULL, NULL, 12672, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:54:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45170, '2017-09-04 15:55:10', NULL, NULL, 12672, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:55:10', 'admin-1504506284-1504511710159378', 1, 1, 'SR', NULL, NULL, NULL),
(45171, '2017-09-04 10:20:26', NULL, NULL, 12645, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:20:26', 'admin-1504485270-15044916267228269', 1, 0, '', NULL, NULL, '10.0'),
(45172, '2017-09-04 10:20:26', NULL, NULL, 12645, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:20:26', 'admin-1504485270-15044916267228269', 1, 1, 'SR', NULL, NULL, '10.0'),
(45173, '2017-09-04 12:14:55', NULL, NULL, 12661, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1504506284', 'lois', '2017-09-04 12:14:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45174, '2017-09-04 10:31:08', NULL, NULL, 12646, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:31:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45175, '2017-09-04 10:31:20', NULL, NULL, 12646, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:31:20', 'admin-1504485270-15044922800029363', 1, 0, '', NULL, NULL, NULL),
(45176, '2017-09-04 10:31:20', NULL, NULL, 12646, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:31:20', 'admin-1504485270-15044922800029363', 1, 1, 'SR', NULL, NULL, NULL),
(45177, '2017-09-04 10:31:27', NULL, NULL, 12647, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.20, 0.0000, 0.0000, 9.20, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:31:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45178, '2017-09-04 10:32:12', NULL, NULL, 12647, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:32:12', 'admin-1504485270-15044923322493041', 1, 0, '', NULL, NULL, NULL),
(45179, '2017-09-04 10:32:12', NULL, NULL, 12647, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:32:12', 'admin-1504485270-15044923322493041', 1, 0, '', NULL, NULL, NULL),
(45180, '2017-09-04 10:32:12', NULL, NULL, 12647, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:32:12', 'admin-1504485270-15044923322493041', 1, 0, '', NULL, NULL, NULL),
(45181, '2017-09-04 10:32:12', NULL, NULL, 12647, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:32:12', 'admin-1504485270-15044923322493041', 1, 0, '', NULL, NULL, NULL),
(45182, '2017-09-04 10:32:12', NULL, NULL, 12647, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:32:12', 'admin-1504485270-15044923322493041', 1, 1, 'SR', NULL, NULL, NULL),
(45183, '2017-09-04 10:32:12', NULL, NULL, 12647, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:32:12', 'admin-1504485270-15044923322493041', 1, 1, 'SR', NULL, NULL, NULL),
(45184, '2017-09-04 10:32:12', NULL, NULL, 12647, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:32:12', 'admin-1504485270-15044923322493041', 1, 1, 'SR', NULL, NULL, NULL),
(45185, '2017-09-04 10:32:25', NULL, NULL, 12645, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:32:25', 'admin-1504485270-15044923455822185', 1, 0, '', NULL, NULL, '10.0'),
(45186, '2017-09-04 10:47:42', NULL, NULL, 12648, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:47:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45187, '2017-09-04 11:33:00', NULL, NULL, 12656, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:33:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45188, '2017-09-04 11:33:07', NULL, NULL, 12656, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:33:07', 'lois-1504493749-15044959872995392', 1, 0, '', NULL, NULL, NULL),
(45189, '2017-09-04 12:15:13', NULL, NULL, 12661, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 12:15:13', 'lois-1504493749-1504498513704746', 1, 0, '', NULL, NULL, NULL),
(45190, '2017-09-04 12:29:44', NULL, NULL, 12663, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 12:29:44', 'lois-1504493749-15044993839525353', 1, 1, 'SR', NULL, NULL, NULL),
(45191, '2017-09-04 11:49:44', NULL, NULL, 12658, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:49:44', 'lois-1504493749-15044969846779494', 1, 1, 'SR', NULL, NULL, NULL),
(45192, '2017-09-04 11:59:08', NULL, NULL, 12660, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:59:08', 'lois-1504493749-15044975481619928', 1, 0, '', NULL, NULL, NULL),
(45193, '2017-09-04 11:59:08', NULL, NULL, 12660, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:59:08', 'lois-1504493749-15044975481619928', 1, 1, 'SR', NULL, NULL, NULL),
(45194, '2017-09-04 15:05:34', NULL, NULL, 12667, 0, 215, '149', 'Stir Fried Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:05:34', 'admin-1504506284-15045087347548898', 1, 0, '', NULL, NULL, NULL),
(45195, '2017-09-04 16:03:19', NULL, NULL, 12674, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 16:03:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45196, '2017-09-04 11:33:53', NULL, NULL, 12657, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:33:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45197, '2017-09-04 16:30:55', NULL, NULL, 12675, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 16:30:55', 'admin-1504506284-15045138553286588', 1, 1, 'SR', NULL, NULL, NULL),
(45198, '2017-09-04 16:03:30', NULL, NULL, 12674, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 16:03:30', 'admin-1504506284-15045122098396247', 1, 1, 'SR', NULL, NULL, NULL),
(45199, '2017-09-04 16:03:30', NULL, NULL, 12674, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 16:03:30', 'admin-1504506284-15045122098396247', 1, 0, '', NULL, NULL, NULL),
(45200, '2017-09-04 15:55:42', NULL, NULL, 12673, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:55:42', 'admin-1504506284-15045117427875856', 1, 0, '', NULL, NULL, '10.0'),
(45201, '2017-09-04 15:55:42', NULL, NULL, 12673, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:55:42', 'admin-1504506284-15045117427875856', 1, 1, 'SR', NULL, NULL, '10.0'),
(45202, '2017-09-04 15:20:29', NULL, NULL, 12669, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:20:29', 'admin-1504506284-15045096288561991', 1, 0, '', NULL, NULL, NULL),
(45203, '2017-09-04 15:20:29', NULL, NULL, 12669, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:20:29', 'admin-1504506284-15045096288561991', 1, 0, '', NULL, NULL, NULL),
(45204, '2017-09-04 15:28:18', NULL, NULL, 12670, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:28:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45205, '2017-09-04 15:30:44', NULL, NULL, 12670, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:30:44', 'admin-1504506284-15045102447189190', 1, 0, '', NULL, NULL, NULL),
(45206, '2017-09-04 15:30:44', NULL, NULL, 12670, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:30:44', 'admin-1504506284-15045102447189190', 1, 1, 'SR', NULL, NULL, NULL),
(45207, '2017-09-04 15:38:31', NULL, NULL, 12670, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:38:31', 'admin-1504506284-15045107115288155', 1, 0, '', NULL, NULL, NULL),
(45208, '2017-09-04 15:41:18', NULL, NULL, 12671, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:41:18', 'admin-1504506284-15045108781275234', 1, 1, 'SR', NULL, NULL, NULL),
(45209, '2017-09-04 15:55:26', NULL, NULL, 12673, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:55:26', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(45210, '2017-09-04 15:40:29', NULL, NULL, 12671, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:40:29', 'admin-1504506284-15045108296184536', 1, 0, '', NULL, NULL, NULL),
(45211, '2017-09-04 15:45:52', NULL, NULL, 12671, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:45:52', 'admin-1504506284-15045111518282531', 1, 0, '', NULL, NULL, NULL),
(45212, '2017-09-04 15:40:29', NULL, NULL, 12671, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:40:29', 'admin-1504506284-15045108296184536', 1, 0, '', NULL, NULL, NULL),
(45213, '2017-09-04 15:40:03', NULL, NULL, 12671, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.70, 0.0000, 0.0000, 9.70, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:40:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45214, '2017-09-04 15:40:29', NULL, NULL, 12671, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:40:29', 'admin-1504506284-15045108296184536', 1, 0, '', NULL, NULL, NULL),
(45215, '2017-09-04 15:45:39', NULL, NULL, 12670, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:45:39', 'admin-1504506284-15045111392618497', 1, 0, '', NULL, NULL, NULL),
(45216, '2017-09-04 15:38:31', NULL, NULL, 12670, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:38:31', 'admin-1504506284-15045107115288155', 1, 1, 'SR', NULL, NULL, NULL),
(45217, '2017-09-04 15:20:23', NULL, NULL, 12669, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:20:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45218, '2017-09-04 15:18:41', NULL, NULL, 12668, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:18:41', 'admin-1504506284-15045095210969646', 1, 1, 'SR', NULL, NULL, NULL),
(45219, '2017-09-04 11:14:41', NULL, NULL, 12645, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:14:41', 'lois-1504493749-15044948811816325', 1, 1, 'SR', NULL, NULL, '10.0'),
(45220, '2017-09-04 11:17:27', NULL, NULL, 12654, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:17:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45221, '2017-09-04 11:18:22', NULL, NULL, 12654, 0, 153, '87', 'Wake Me Up!', 'change baked beans to potato', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:18:22', 'lois-1504493749-15044951025115538', 1, 0, '', NULL, NULL, NULL),
(45222, '2017-09-04 15:18:41', NULL, NULL, 12668, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:18:41', 'admin-1504506284-15045095210969646', 1, 1, 'SR', NULL, NULL, NULL),
(45223, '2017-09-04 15:18:41', NULL, NULL, 12668, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:18:41', 'admin-1504506284-15045095210969646', 1, 0, '', NULL, NULL, NULL),
(45224, '2017-09-04 15:18:41', NULL, NULL, 12668, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:18:41', 'admin-1504506284-15045095210969646', 1, 0, '', NULL, NULL, NULL),
(45225, '2017-09-04 15:18:22', NULL, NULL, 12668, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:18:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45226, '2017-09-04 15:05:50', NULL, NULL, 12667, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:05:50', 'admin-1504506284-15045087501331484', 1, 1, 'SR', NULL, NULL, NULL),
(45227, '2017-09-04 15:05:34', NULL, NULL, 12667, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:05:34', 'admin-1504506284-15045087347548898', 1, 0, '', NULL, NULL, NULL),
(45228, '2017-09-04 14:24:35', NULL, NULL, 12666, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 14:24:35', 'lois-1504493749-15045062751746974', 1, 0, '', NULL, NULL, NULL),
(45229, '2017-09-04 15:05:23', NULL, NULL, 12667, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:05:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45230, '2017-09-04 14:08:32', NULL, NULL, 12666, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 14:08:32', 'lois-1504493749-15045053119434058', 1, 0, '', NULL, NULL, NULL),
(45231, '2017-09-04 14:08:37', NULL, NULL, 12666, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 14:08:37', 'lois-1504493749-1504505317356615', 1, 1, 'SR', NULL, NULL, NULL),
(45232, '2017-09-04 14:08:21', NULL, NULL, 12666, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1504506284', 'lois', '2017-09-04 14:08:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45233, '2017-09-04 14:08:32', NULL, NULL, 12666, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 14:08:32', 'lois-1504493749-15045053119434058', 1, 0, '', NULL, NULL, NULL),
(45234, '2017-09-04 12:38:56', NULL, NULL, 12664, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 12:38:56', 'lois-1504493749-15044999359033525', 1, 1, 'SR', NULL, NULL, NULL),
(45235, '2017-09-04 12:38:53', NULL, NULL, 12664, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1504506284', 'lois', '2017-09-04 12:38:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45236, '2017-09-04 12:37:01', NULL, NULL, 12663, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 12:37:01', 'lois-1504493749-15044998217509691', 1, 0, '', NULL, NULL, NULL),
(45237, '2017-09-04 11:59:08', NULL, NULL, 12660, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:59:08', 'lois-1504493749-15044975481619928', 1, 0, '', NULL, NULL, NULL),
(45238, '2017-09-04 11:25:35', NULL, NULL, 12655, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:25:35', 'lois-1504493749-1504495535358193', 1, 1, 'SR', NULL, NULL, NULL),
(45239, '2017-09-04 12:29:36', NULL, NULL, 12663, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 12:29:36', 'lois-1504493749-15044993766742021', 1, 0, '', NULL, NULL, NULL),
(45240, '2017-09-04 12:29:21', NULL, NULL, 12663, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.70, 0.0000, 0.0000, 13.70, 1, '27', 1, '1504506284', 'lois', '2017-09-04 12:29:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45241, '2017-09-04 12:17:10', NULL, NULL, 12662, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 12:17:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45242, '2017-09-04 15:55:42', NULL, NULL, 12673, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 15:55:42', 'admin-1504506284-15045117427875856', 1, 1, 'SR', NULL, NULL, '10.0'),
(45243, '2017-09-04 12:17:15', NULL, NULL, 12662, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 12:17:15', 'lois-1504493749-15044986355745441', 1, 1, 'SR', NULL, NULL, NULL),
(45244, '2017-09-04 13:32:26', NULL, NULL, 12665, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1504506284', 'lois', '2017-09-04 13:32:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45245, '2017-09-04 12:15:13', NULL, NULL, 12661, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 12:15:13', 'lois-1504493749-1504498513704746', 1, 1, 'SR', NULL, NULL, NULL),
(45246, '2017-09-04 12:15:13', NULL, NULL, 12661, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 12:15:13', 'lois-1504493749-1504498513704746', 1, 0, '', NULL, NULL, NULL),
(45247, '2017-09-04 11:03:54', NULL, NULL, 12653, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:03:54', 'lois-1504493749-15044942344271088', 1, 1, 'SR', NULL, NULL, NULL),
(45248, '2017-09-04 11:34:27', NULL, NULL, 12657, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:34:27', 'lois-1504493749-15044960670335094', 1, 1, 'SR', NULL, NULL, NULL),
(45249, '2017-09-04 11:49:08', NULL, NULL, 12658, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:49:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45250, '2017-09-04 11:49:44', NULL, NULL, 12658, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:49:44', 'lois-1504493749-15044969846779494', 1, 0, '', NULL, NULL, NULL),
(45251, '2017-09-04 11:49:44', NULL, NULL, 12658, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:49:44', 'lois-1504493749-15044969846779494', 1, 1, 'SR', NULL, NULL, NULL),
(45252, '2017-09-04 11:25:35', NULL, NULL, 12655, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:25:35', 'lois-1504493749-1504495535358193', 1, 1, 'SR', NULL, NULL, NULL),
(45253, '2017-09-04 10:55:30', NULL, NULL, 12650, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:55:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45254, '2017-09-04 10:55:44', NULL, NULL, 12650, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:55:44', 'admin-1504485270-15044937443052146', 1, 0, '', NULL, NULL, NULL),
(45255, '2017-09-04 10:55:44', NULL, NULL, 12650, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:55:44', 'admin-1504485270-15044937443052146', 1, 0, '', NULL, NULL, NULL),
(45256, '2017-09-04 10:55:44', NULL, NULL, 12650, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:55:44', 'admin-1504485270-15044937443052146', 1, 0, '', NULL, NULL, NULL),
(45257, '2017-09-04 10:56:01', NULL, NULL, 12650, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 10:56:01', 'lois-1504493749-15044937610123743', 1, 1, 'SR', NULL, NULL, NULL),
(45258, '2017-09-04 11:03:54', NULL, NULL, 12653, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:03:54', 'lois-1504493749-15044942344271088', 1, 0, '', NULL, NULL, NULL),
(45259, '2017-09-04 11:01:16', NULL, NULL, 12651, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:01:16', 'lois-1504493749-15044940762936937', 1, 0, '', NULL, NULL, NULL),
(45260, '2017-09-04 11:01:16', NULL, NULL, 12651, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:01:16', 'lois-1504493749-15044940762936937', 1, 0, '', NULL, NULL, NULL),
(45261, '2017-09-04 11:01:16', NULL, NULL, 12651, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:01:16', 'lois-1504493749-15044940762936937', 1, 0, '', NULL, NULL, NULL),
(45262, '2017-09-04 11:53:56', NULL, NULL, 12659, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:53:56', 'lois-1504493749-15044972364778864', 1, 1, 'SR', NULL, NULL, NULL),
(45263, '2017-09-04 11:58:51', NULL, NULL, 12660, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:58:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45264, '2017-09-04 11:53:56', NULL, NULL, 12659, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:53:56', 'lois-1504493749-15044972364778864', 1, 1, 'SR', NULL, NULL, NULL),
(45265, '2017-09-04 11:53:56', NULL, NULL, 12659, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:53:56', 'lois-1504493749-15044972364778864', 1, 0, '', NULL, NULL, NULL),
(45266, '2017-09-04 11:18:39', NULL, NULL, 12649, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:18:39', 'lois-1504493749-15044951189412567', 1, 0, '', NULL, NULL, NULL),
(45267, '2017-09-04 11:25:06', NULL, NULL, 12655, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.20, 0.0000, 0.0000, 9.20, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:25:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45268, '2017-09-04 11:25:19', NULL, NULL, 12655, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:25:19', 'lois-1504493749-15044955189796685', 1, 0, '', NULL, NULL, NULL),
(45269, '2017-09-04 11:25:19', NULL, NULL, 12655, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:25:19', 'lois-1504493749-15044955189796685', 1, 0, '', NULL, NULL, NULL),
(45270, '2017-09-04 11:03:34', NULL, NULL, 12653, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:03:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45271, '2017-09-04 11:03:54', NULL, NULL, 12653, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:03:54', 'lois-1504493749-15044942344271088', 1, 1, 'SR', NULL, NULL, NULL),
(45272, '2017-09-04 11:34:27', NULL, NULL, 12657, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:34:27', 'lois-1504493749-15044960670335094', 1, 1, 'SR', NULL, NULL, NULL),
(45273, '2017-09-04 11:34:27', NULL, NULL, 12657, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:34:27', 'lois-1504493749-15044960670335094', 1, 0, '', NULL, NULL, NULL),
(45274, '2017-09-04 11:34:27', NULL, NULL, 12657, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:34:27', 'lois-1504493749-15044960670335094', 1, 0, '', NULL, NULL, NULL),
(45275, '2017-09-04 11:34:27', NULL, NULL, 12657, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:34:27', 'lois-1504493749-15044960670335094', 1, 0, '', NULL, NULL, NULL),
(45276, '2017-09-04 09:39:13', NULL, NULL, 12642, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 09:39:13', 'admin-1504485270-15044891537162139', 1, 0, '', NULL, NULL, NULL),
(45277, '2017-09-04 10:19:26', NULL, NULL, 12645, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.60, 0.0000, 0.0000, 15.60, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:19:26', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(45278, '2017-09-04 10:20:01', NULL, NULL, 12645, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:20:01', 'admin-1504485270-15044916010069081', 1, 1, 'SR', NULL, NULL, '10.0'),
(45279, '2017-09-04 11:33:07', NULL, NULL, 12656, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:33:07', 'lois-1504493749-15044959872995392', 1, 0, '', NULL, NULL, NULL),
(45280, '2017-09-04 11:25:35', NULL, NULL, 12655, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:25:35', 'lois-1504493749-1504495535358193', 1, 1, 'SR', NULL, NULL, NULL),
(45281, '2017-09-04 11:25:19', NULL, NULL, 12655, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:25:19', 'lois-1504493749-15044955189796685', 1, 0, '', NULL, NULL, NULL),
(45282, '2017-09-04 11:18:39', NULL, NULL, 12649, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:18:39', 'lois-1504493749-15044951189412567', 1, 0, '', NULL, NULL, NULL),
(45283, '2017-09-04 11:18:22', NULL, NULL, 12654, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:18:22', 'lois-1504493749-15044951025115538', 1, 0, '', NULL, NULL, NULL),
(45284, '2017-09-04 09:39:13', NULL, NULL, 12642, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 09:39:13', 'admin-1504485270-15044891537162139', 1, 0, '', NULL, NULL, NULL),
(45285, '2017-09-04 09:39:13', NULL, NULL, 12642, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 09:39:13', 'admin-1504485270-15044891537162139', 1, 1, 'SR', NULL, NULL, NULL),
(45286, '2017-09-04 09:39:13', NULL, NULL, 12642, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 09:39:13', 'admin-1504485270-15044891537162139', 1, 0, '', NULL, NULL, NULL),
(45287, '2017-09-04 11:03:54', NULL, NULL, 12653, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:03:54', 'lois-1504493749-15044942344271088', 1, 0, '', NULL, NULL, NULL),
(45288, '2017-09-04 11:53:56', NULL, NULL, 12659, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:53:56', 'lois-1504493749-15044972364778864', 1, 0, '', NULL, NULL, NULL),
(45289, '2017-09-04 11:52:48', NULL, NULL, 12659, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:52:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45290, '2017-09-04 11:53:56', NULL, NULL, 12659, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:53:56', 'lois-1504493749-15044972364778864', 1, 0, '', NULL, NULL, NULL),
(45291, '2017-09-04 11:01:21', NULL, NULL, 12651, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:01:21', 'lois-1504493749-15044940810601615', 1, 1, 'SR', NULL, NULL, NULL),
(45292, '2017-09-04 11:01:21', NULL, NULL, 12651, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:01:21', 'lois-1504493749-15044940810601615', 1, 1, 'SR', NULL, NULL, NULL),
(45293, '2017-09-04 11:01:16', NULL, NULL, 12651, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:01:16', 'lois-1504493749-15044940762936937', 1, 0, '', NULL, NULL, NULL),
(45294, '2017-09-04 10:56:01', NULL, NULL, 12650, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 10:56:01', 'lois-1504493749-15044937610123743', 1, 1, 'SR', NULL, NULL, NULL),
(45295, '2017-09-04 11:01:01', NULL, NULL, 12651, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:01:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45296, '2017-09-04 11:51:29', NULL, NULL, 12649, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:51:29', 'lois-1504493749-15044970895272212', 1, 1, 'SR', NULL, NULL, NULL),
(45297, '2017-09-04 11:51:29', NULL, NULL, 12649, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:51:29', 'lois-1504493749-15044970895272212', 1, 1, 'SR', NULL, NULL, NULL),
(45298, '2017-09-04 11:53:56', NULL, NULL, 12659, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:53:56', 'lois-1504493749-15044972364778864', 1, 0, '', NULL, NULL, NULL),
(45299, '2017-09-04 11:32:56', NULL, NULL, 12648, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504506284', 'lois', '2017-09-04 11:32:56', 'lois-1504493749-1504495975824691', 1, 0, '', NULL, NULL, NULL),
(45300, '2017-09-04 10:49:34', NULL, NULL, 12649, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:49:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45301, '2017-09-04 10:30:06', NULL, NULL, 12645, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:30:06', 'admin-1504485270-1504492206767282', 1, 1, 'SR', NULL, NULL, '10.0'),
(45302, '2017-09-04 10:20:01', NULL, NULL, 12645, 0, 153, '87', 'Wake Me Up!', 'NO BAKED BEANS', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:20:01', 'admin-1504485270-15044916010069081', 1, 0, '', NULL, NULL, '10.0'),
(45303, '2017-09-04 10:20:26', NULL, NULL, 12645, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:20:26', 'admin-1504485270-15044916267228269', 1, 1, 'SR', NULL, NULL, '10.0'),
(45304, '2017-09-04 09:41:40', NULL, NULL, 12643, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1504506284', 'admin', '2017-09-04 09:41:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45305, '2017-09-04 09:41:51', NULL, NULL, 12643, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 09:41:51', 'admin-1504485270-15044893115255339', 1, 1, 'SR', NULL, NULL, NULL),
(45306, '2017-09-04 09:41:51', NULL, NULL, 12643, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 09:41:51', 'admin-1504485270-15044893115255339', 1, 0, '', NULL, NULL, NULL),
(45307, '2017-09-04 09:55:54', NULL, NULL, 12644, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1504506284', 'admin', '2017-09-04 09:55:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45308, '2017-09-04 09:56:10', NULL, NULL, 12644, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 09:56:10', 'admin-1504485270-15044901700058127', 1, 1, 'SR', NULL, NULL, NULL),
(45309, '2017-09-04 09:56:10', NULL, NULL, 12644, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 09:56:10', 'admin-1504485270-15044901700058127', 1, 0, '', NULL, NULL, NULL),
(45310, '2017-09-04 10:20:01', NULL, NULL, 12645, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:20:01', 'admin-1504485270-15044916010069081', 1, 1, 'SR', NULL, NULL, '10.0'),
(45311, '2017-09-04 10:20:01', NULL, NULL, 12645, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:20:01', 'admin-1504485270-15044916010069081', 1, 0, '', NULL, NULL, '10.0'),
(45312, '2017-09-04 10:20:01', NULL, NULL, 12645, 0, 153, '87', 'Wake Me Up!', 'NO BAKED BEANS', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 10:20:01', 'admin-1504485270-15044916010069081', 1, 0, '', NULL, NULL, '10.0'),
(45313, '2017-09-04 09:39:13', NULL, NULL, 12642, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 09:39:13', 'admin-1504485270-15044891537162139', 1, 0, '', NULL, NULL, NULL),
(45314, '2017-09-04 09:39:13', NULL, NULL, 12642, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 09:39:13', 'admin-1504485270-15044891537162139', 1, 1, 'SR', NULL, NULL, NULL),
(45315, '2017-09-04 09:39:13', NULL, NULL, 12642, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 09:39:13', 'admin-1504485270-15044891537162139', 1, 0, '', NULL, NULL, NULL),
(45316, '2017-09-04 09:39:13', NULL, NULL, 12642, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 09:39:13', 'admin-1504485270-15044891537162139', 1, 0, '', NULL, NULL, NULL),
(45317, '2017-09-04 09:39:13', NULL, NULL, 12642, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504506284', 'admin', '2017-09-04 09:39:13', 'admin-1504485270-15044891537162139', 1, 0, '', NULL, NULL, NULL),
(45318, '2017-09-04 09:38:18', NULL, NULL, 12642, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.10, 0.0000, 0.0000, 13.10, 1, '27', 1, '1504506284', 'admin', '2017-09-04 09:38:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45319, '2017-09-06 12:02:53', NULL, NULL, 12682, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 12:02:53', 'admin-1504660309-15046705733181230', 1, 1, 'SR', NULL, NULL, NULL),
(45320, '2017-09-06 12:18:42', NULL, NULL, 12683, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1504660309', 'admin', '2017-09-06 12:18:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45321, '2017-09-06 12:18:51', NULL, NULL, 12683, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 12:18:51', 'admin-1504660309-15046715312804478', 1, 1, 'SR', NULL, NULL, NULL),
(45322, '2017-09-06 11:54:33', NULL, NULL, 12681, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 11:54:33', 'admin-1504660309-15046700736805612', 1, 1, 'SR', NULL, NULL, '10.0'),
(45323, '2017-09-06 13:08:30', NULL, NULL, 12688, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 13:08:30', 'admin-1504660309-15046745107243833', 1, 0, '', NULL, NULL, NULL),
(45324, '2017-09-06 13:39:34', NULL, NULL, 12689, 0, 181, '116', 'Open Food ', 'Bff', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 13:39:34', 'admin-1504660309-15046763742015524', 1, 0, '', NULL, NULL, NULL),
(45325, '2017-09-06 14:18:02', NULL, NULL, 12690, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1504660309', 'admin', '2017-09-06 14:18:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45326, '2017-09-06 14:18:16', NULL, NULL, 12690, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 14:18:16', 'admin-1504660309-15046786959081687', 1, 1, 'SR', NULL, NULL, NULL),
(45327, '2017-09-06 14:18:16', NULL, NULL, 12690, 0, 71, '71', 'Stir Fried Rice Wine Ginger Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 14:18:16', 'admin-1504660309-15046786959081687', 1, 1, 'SR', NULL, NULL, NULL),
(45328, '2017-09-06 14:18:29', NULL, NULL, 12690, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 14:18:29', 'admin-1504660309-15046787088982244', 1, 0, '', NULL, NULL, NULL),
(45329, '2017-09-06 14:18:29', NULL, NULL, 12690, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 14:18:29', 'admin-1504660309-15046787088982244', 1, 1, 'SR', NULL, NULL, NULL),
(45330, '2017-09-06 15:52:31', NULL, NULL, 12691, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1504660309', 'admin', '2017-09-06 15:52:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45331, '2017-09-06 15:52:52', NULL, NULL, 12691, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 15:52:52', 'admin-1504660309-15046843727328165', 1, 1, 'SR', NULL, NULL, NULL),
(45332, '2017-09-06 15:52:52', NULL, NULL, 12691, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 15:52:52', 'admin-1504660309-15046843727328165', 1, 0, '', NULL, NULL, NULL),
(45333, '2017-09-06 15:58:09', NULL, NULL, 12692, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 15:58:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45334, '2017-09-06 15:58:18', NULL, NULL, 12692, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 15:58:18', 'admin-1504660309-15046846980439414', 1, 1, 'SR', NULL, NULL, NULL),
(45335, '2017-09-06 16:22:52', NULL, NULL, 12693, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 16:22:52', 'admin-1504660309-15046861719123691', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(45336, '2017-09-06 09:54:40', NULL, NULL, 12676, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 09:54:40', 'admin-1504660309-1504662880111548', 1, 0, '', NULL, NULL, NULL),
(45337, '2017-09-06 09:54:40', NULL, NULL, 12676, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 09:54:40', 'admin-1504660309-1504662880111548', 1, 0, '', NULL, NULL, NULL),
(45338, '2017-09-06 09:54:47', NULL, NULL, 12676, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 09:54:47', 'admin-1504660309-15046628873727297', 1, 1, 'SR', NULL, NULL, NULL),
(45339, '2017-09-06 09:54:47', NULL, NULL, 12676, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 09:54:47', 'admin-1504660309-15046628873727297', 1, 1, 'SR', NULL, NULL, NULL),
(45340, '2017-09-06 16:22:48', NULL, NULL, 12693, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1504660309', 'admin', '2017-09-06 16:22:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45341, '2017-09-06 13:00:35', NULL, NULL, 12687, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 13:00:35', 'admin-1504660309-15046740352529065', 1, 0, '', NULL, NULL, NULL),
(45342, '2017-09-06 13:08:25', NULL, NULL, 12688, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1504660309', 'admin', '2017-09-06 13:08:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45343, '2017-09-06 13:28:21', NULL, NULL, 12689, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1504660309', 'admin', '2017-09-06 13:28:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45344, '2017-09-06 13:00:31', NULL, NULL, 12687, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1504660309', 'admin', '2017-09-06 13:00:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45345, '2017-09-06 13:21:56', NULL, NULL, 12685, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 13:21:56', 'admin-1504660309-1504675316627185', 1, 1, 'SR', NULL, NULL, '10.0'),
(45346, '2017-09-06 12:48:48', NULL, NULL, 12685, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 12:48:48', 'admin-1504660309-15046733282714269', 1, 0, '', NULL, NULL, '10.0'),
(45347, '2017-09-06 12:48:29', NULL, NULL, 12685, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1504660309', 'admin', '2017-09-06 12:48:29', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(45348, '2017-09-06 12:48:48', NULL, NULL, 12685, 0, 181, '116', 'Open Food ', 'Black Pork', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 12:48:48', 'admin-1504660309-15046733282714269', 1, 0, '', NULL, NULL, '10.0'),
(45349, '2017-09-06 13:29:17', NULL, NULL, 12689, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 13:29:17', 'admin-1504660309-1504675757188697', 1, 0, '', NULL, NULL, NULL),
(45350, '2017-09-06 13:29:17', NULL, NULL, 12689, 0, 211, '145', 'Stir Fried Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 13:29:17', 'admin-1504660309-1504675757188697', 1, 0, '', NULL, NULL, NULL),
(45351, '2017-09-06 13:29:17', NULL, NULL, 12689, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 13:29:17', 'admin-1504660309-1504675757188697', 1, 1, 'SR', NULL, NULL, NULL),
(45352, '2017-09-06 12:02:53', NULL, NULL, 12682, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1504660309', 'admin', '2017-09-06 12:02:53', 'admin-1504660309-15046705733181230', 1, 0, '', NULL, NULL, NULL),
(45353, '2017-09-06 11:25:35', NULL, NULL, 12679, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 11:25:35', 'admin-1504660309-15046683355989139', 1, 1, 'SR', NULL, NULL, NULL),
(45354, '2017-09-06 12:02:39', NULL, NULL, 12682, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.35, 0.0000, 0.0000, 1.35, 1, '27', 1, '1504660309', 'admin', '2017-09-06 12:02:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45355, '2017-09-06 11:54:33', NULL, NULL, 12681, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 11:54:33', 'admin-1504660309-15046700736805612', 1, 0, '', NULL, NULL, '10.0'),
(45356, '2017-09-06 11:54:20', NULL, NULL, 12681, 0, 70, '70', 'Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 11:54:20', 'admin-1504660309-15046700602133229', 1, 1, 'SR', NULL, NULL, '10.0'),
(45357, '2017-09-06 11:54:20', NULL, NULL, 12681, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 11:54:20', 'admin-1504660309-15046700602133229', 1, 0, '', NULL, NULL, '10.0'),
(45358, '2017-09-06 11:53:43', NULL, NULL, 12681, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1504660309', 'admin', '2017-09-06 11:53:43', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(45359, '2017-09-06 11:27:01', NULL, NULL, 12680, 0, 182, '117', 'Open Drinks ', 'banana', 'Cold Drinks', 'Fresh Juice', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 11:27:01', 'admin-1504660309-15046684211717781', 1, 0, '', 1, NULL, NULL),
(45360, '2017-09-06 11:25:29', NULL, NULL, 12679, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1504660309', 'admin', '2017-09-06 11:25:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45361, '2017-09-06 10:46:31', NULL, NULL, 12678, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 10:46:31', 'admin-1504660309-15046659909206328', 1, 1, 'SR', NULL, NULL, NULL),
(45362, '2017-09-06 10:46:27', NULL, NULL, 12678, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1504660309', 'admin', '2017-09-06 10:46:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45363, '2017-09-06 10:31:23', NULL, NULL, 12677, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 10:31:23', 'admin-1504660309-15046650835628618', 1, 1, 'SR', NULL, NULL, NULL),
(45364, '2017-09-06 10:31:23', NULL, NULL, 12677, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 10:31:23', 'admin-1504660309-15046650835628618', 1, 1, 'SR', NULL, NULL, NULL),
(45365, '2017-09-06 10:31:23', NULL, NULL, 12677, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 10:31:23', 'admin-1504660309-15046650835628618', 1, 0, '', NULL, NULL, NULL),
(45366, '2017-09-06 10:31:23', NULL, NULL, 12677, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 10:31:23', 'admin-1504660309-15046650835628618', 1, 0, '', NULL, NULL, NULL),
(45367, '2017-09-06 10:31:16', NULL, NULL, 12677, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1504660309', 'admin', '2017-09-06 10:31:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45368, '2017-09-06 10:20:13', NULL, NULL, 12676, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504660309', 'admin', '2017-09-06 10:20:13', 'admin-1504660309-15046644137049330', 1, 1, 'SR', NULL, NULL, NULL),
(45369, '2017-09-06 09:54:32', NULL, NULL, 12676, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1504660309', 'admin', '2017-09-06 09:54:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45370, '2017-09-07 13:50:49', NULL, NULL, 12706, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 13:50:49', 'admin-1504761354-15047634490107092', 1, 0, '', 1, NULL, NULL),
(45371, '2017-09-07 14:03:36', NULL, NULL, 12707, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1504761354', 'admin', '2017-09-07 14:03:36', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(45372, '2017-09-07 14:03:53', NULL, NULL, 12707, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 14:03:53', 'admin-1504761354-15047642337396851', 1, 1, 'SR', NULL, NULL, '10.0'),
(45373, '2017-09-07 14:03:53', NULL, NULL, 12707, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 14:03:53', 'admin-1504761354-15047642337396851', 1, 1, 'SR', NULL, NULL, '10.0'),
(45374, '2017-09-07 14:03:53', NULL, NULL, 12707, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 14:03:53', 'admin-1504761354-15047642337396851', 1, 0, '', NULL, NULL, '10.0'),
(45375, '2017-09-07 14:03:53', NULL, NULL, 12707, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 14:03:53', 'admin-1504761354-15047642337396851', 1, 0, '', NULL, NULL, '10.0'),
(45376, '2017-09-07 14:36:33', NULL, NULL, 12708, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 14:36:33', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(45377, '2017-09-07 14:36:39', NULL, NULL, 12708, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 14:36:39', 'admin-1504761354-15047661994171299', 1, 1, 'SR', NULL, NULL, '10.0'),
(45378, '2017-09-07 14:41:54', NULL, NULL, 12709, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1504761354', 'admin', '2017-09-07 14:41:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45379, '2017-09-07 14:42:09', NULL, NULL, 12709, 0, 181, '116', 'Open Food ', 'Soup Noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 14:42:09', 'admin-1504761354-1504766529277434', 1, 0, '', NULL, NULL, NULL),
(45380, '2017-09-07 14:42:09', NULL, NULL, 12709, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 14:42:09', 'admin-1504761354-1504766529277434', 1, 1, 'SR', NULL, NULL, NULL),
(45381, '2017-09-07 15:48:00', NULL, NULL, 12709, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 15:48:00', 'admin-1504761354-1504770479978631', 1, 1, 'SR', NULL, NULL, NULL),
(45382, '2017-09-07 16:52:54', NULL, NULL, 12710, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1504761354', 'admin', '2017-09-07 16:52:54', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(45383, '2017-09-07 16:53:03', NULL, NULL, 12710, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 16:53:03', 'admin-1504761354-15047743836341729', 1, 1, 'SR', NULL, NULL, '10.0'),
(45384, '2017-09-07 12:24:41', NULL, NULL, 12699, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 12:24:41', 'admin-1504746280-1504758281089842', 1, 0, '', NULL, NULL, NULL),
(45385, '2017-09-07 12:14:54', NULL, NULL, 12695, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 12:14:54', 'admin-1504746280-1504757694624585', 1, 1, 'SR', NULL, NULL, NULL),
(45386, '2017-09-07 13:46:43', NULL, NULL, 12705, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 13:46:43', 'admin-1504761354-15047632032101831', 1, 1, 'SR', NULL, NULL, '10.0'),
(45387, '2017-09-07 12:59:01', NULL, NULL, 12703, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 12:59:02', 'admin-1504746280-1504760341827637', 1, 1, 'SR', NULL, NULL, NULL),
(45388, '2017-09-07 12:59:12', NULL, NULL, 12703, 0, 159, '93', 'Fruits & Yogurt Granola', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 12:59:12', 'admin-1504746280-15047603521288458', 1, 0, '', NULL, NULL, NULL),
(45389, '2017-09-07 12:59:12', NULL, NULL, 12703, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 12:59:12', 'admin-1504746280-15047603521288458', 1, 1, 'SR', NULL, NULL, NULL),
(45390, '2017-09-07 13:00:10', NULL, NULL, 12703, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 13:00:10', 'admin-1504746280-15047604105674070', 1, 1, 'SR', NULL, NULL, NULL),
(45391, '2017-09-07 13:10:01', NULL, NULL, 12704, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1504761354', 'admin', '2017-09-07 13:10:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45392, '2017-09-07 13:10:11', NULL, NULL, 12704, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 13:10:11', 'admin-1504746280-15047610111623971', 1, 1, 'SR', NULL, NULL, NULL),
(45393, '2017-09-07 13:10:11', NULL, NULL, 12704, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 13:10:11', 'admin-1504746280-15047610111623971', 1, 1, 'SR', NULL, NULL, NULL),
(45394, '2017-09-07 13:19:56', NULL, NULL, 12705, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1504761354', 'admin', '2017-09-07 13:19:56', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(45395, '2017-09-07 13:20:07', NULL, NULL, 12705, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 13:20:07', 'admin-1504761354-15047616075554553', 1, 1, 'SR', NULL, NULL, '10.0'),
(45396, '2017-09-07 13:20:07', NULL, NULL, 12705, 0, 192, '127', 'Stir Fried Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 13:20:07', 'admin-1504761354-15047616075554553', 1, 0, '', NULL, NULL, '10.0'),
(45397, '2017-09-07 16:53:03', NULL, NULL, 12710, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 16:53:03', 'admin-1504761354-15047743836341729', 1, 0, '', NULL, NULL, '10.0'),
(45398, '2017-09-07 13:46:43', NULL, NULL, 12705, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 13:46:43', 'admin-1504761354-15047632032101831', 1, 1, 'SR', NULL, NULL, '10.0'),
(45399, '2017-09-07 13:46:43', NULL, NULL, 12705, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 13:46:43', 'admin-1504761354-15047632032101831', 1, 1, 'SR', NULL, NULL, '10.0'),
(45400, '2017-09-07 09:14:33', NULL, NULL, 12695, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 09:14:33', 'admin-1504746280-1504746873497962', 1, 1, 'SR', NULL, NULL, NULL),
(45401, '2017-09-07 09:45:56', NULL, NULL, 12696, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1504761354', 'admin', '2017-09-07 09:45:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45402, '2017-09-07 09:47:28', NULL, NULL, 12696, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 09:47:28', 'admin-1504746280-1504748848707765', 1, 0, '', NULL, NULL, NULL),
(45403, '2017-09-07 09:47:28', NULL, NULL, 12696, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 09:47:28', 'admin-1504746280-1504748848707765', 1, 0, '', NULL, NULL, NULL),
(45404, '2017-09-07 12:24:41', NULL, NULL, 12699, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 12:24:41', 'admin-1504746280-1504758281089842', 1, 0, '', NULL, NULL, NULL),
(45405, '2017-09-07 12:24:41', NULL, NULL, 12699, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 12:24:41', 'admin-1504746280-1504758281089842', 1, 1, 'SR', NULL, NULL, NULL),
(45406, '2017-09-07 12:29:56', NULL, NULL, 12702, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 12:29:56', 'admin-1504746280-15047585962706870', 1, 1, 'SR', NULL, NULL, '10.0'),
(45407, '2017-09-07 12:47:20', NULL, NULL, 12701, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 12:47:20', 'admin-1504746280-1504759640296256', 1, 1, 'SR', NULL, NULL, NULL),
(45408, '2017-09-07 12:58:44', NULL, NULL, 12703, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1504761354', 'admin', '2017-09-07 12:58:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45409, '2017-09-07 13:15:46', NULL, NULL, 12703, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 13:15:46', 'admin-1504746280-15047613461311745', 1, 0, '', NULL, NULL, NULL),
(45410, '2017-09-07 12:59:01', NULL, NULL, 12703, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 12:59:01', 'admin-1504746280-1504760341827637', 1, 1, 'SR', NULL, NULL, NULL),
(45411, '2017-09-07 10:45:24', NULL, NULL, 12698, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 10:45:24', 'admin-1504746280-15047523246527934', 1, 0, '', NULL, NULL, NULL),
(45412, '2017-09-07 12:29:48', NULL, NULL, 12702, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1504761354', 'admin', '2017-09-07 12:29:48', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(45413, '2017-09-07 11:30:25', NULL, NULL, 12700, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 11:30:25', 'admin-1504746280-15047550254714560', 1, 1, 'SR', NULL, NULL, NULL),
(45414, '2017-09-07 11:30:25', NULL, NULL, 12700, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 11:30:25', 'admin-1504746280-15047550254714560', 1, 1, 'SR', NULL, NULL, NULL),
(45415, '2017-09-07 11:37:32', NULL, NULL, 12697, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 11:37:32', 'admin-1504746280-15047554519258725', 1, 1, 'SR', NULL, NULL, NULL),
(45416, '2017-09-07 12:14:31', NULL, NULL, 12701, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1504761354', 'admin', '2017-09-07 12:14:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45417, '2017-09-07 12:14:38', NULL, NULL, 12701, 0, 72, '72', 'Stir Fried Chicken with Mushroom ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 12:14:38', 'admin-1504746280-15047576779246815', 1, 1, 'SR', NULL, NULL, NULL),
(45418, '2017-09-07 11:29:00', NULL, NULL, 12700, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1504761354', 'admin', '2017-09-07 11:29:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45419, '2017-09-07 12:29:56', NULL, NULL, 12702, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 12:29:56', 'admin-1504746280-15047585962706870', 1, 1, 'SR', NULL, NULL, '10.0'),
(45420, '2017-09-07 12:14:38', NULL, NULL, 12701, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 12:14:38', 'admin-1504746280-15047576779246815', 1, 1, 'SR', NULL, NULL, NULL),
(45421, '2017-09-07 11:28:49', NULL, NULL, 12699, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1504761354', 'admin', '2017-09-07 11:28:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45422, '2017-09-07 10:45:24', NULL, NULL, 12698, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 10:45:24', 'admin-1504746280-15047523246527934', 1, 1, 'SR', NULL, NULL, NULL),
(45423, '2017-09-07 10:45:18', NULL, NULL, 12698, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 10:45:18', 'admin-1504746280-15047523178602647', 1, 0, '', NULL, NULL, NULL),
(45424, '2017-09-07 10:45:18', NULL, NULL, 12698, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 10:45:18', 'admin-1504746280-15047523178602647', 1, 0, '', NULL, NULL, NULL),
(45425, '2017-09-07 10:45:08', NULL, NULL, 12698, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 10:45:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45426, '2017-09-07 10:00:47', NULL, NULL, 12697, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 10:00:47', 'admin-1504746280-15047496467902111', 1, 0, '', NULL, NULL, NULL),
(45427, '2017-09-07 10:00:42', NULL, NULL, 12697, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 10:00:42', 'admin-1504746280-15047496423416343', 1, 0, '', NULL, NULL, NULL),
(45428, '2017-09-07 10:00:03', NULL, NULL, 12697, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1504761354', 'admin', '2017-09-07 10:00:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45429, '2017-09-07 09:47:35', NULL, NULL, 12696, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 09:47:35', 'admin-1504746280-15047488555376912', 1, 1, 'SR', NULL, NULL, NULL),
(45430, '2017-09-07 09:47:35', NULL, NULL, 12696, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 09:47:35', 'admin-1504746280-15047488555376912', 1, 1, 'SR', NULL, NULL, NULL),
(45431, '2017-09-07 09:14:28', NULL, NULL, 12695, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1504761354', 'admin', '2017-09-07 09:14:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45432, '2017-09-07 09:05:00', NULL, NULL, 12694, 0, 181, '116', 'Open Food ', 'junior BLT', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 09:05:00', 'admin-1504746280-1504746300045370', 1, 0, '', NULL, NULL, NULL),
(45433, '2017-09-07 09:05:04', NULL, NULL, 12694, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504761354', 'admin', '2017-09-07 09:05:04', 'admin-1504746280-15047463047125389', 1, 1, 'SR', NULL, NULL, NULL),
(45434, '2017-09-07 09:04:47', NULL, NULL, 12694, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1504761354', 'admin', '2017-09-07 09:04:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45435, '2017-09-08 12:36:14', NULL, NULL, 12716, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1504831437', 'admin', '2017-09-08 12:36:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45436, '2017-09-08 12:36:29', NULL, NULL, 12716, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 12:36:29', 'admin-1504831437-15048453892231520', 1, 0, '', NULL, NULL, NULL),
(45437, '2017-09-08 12:36:29', NULL, NULL, 12716, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 12:36:29', 'admin-1504831437-15048453892231520', 1, 1, 'SR', NULL, NULL, NULL),
(45438, '2017-09-08 13:04:50', NULL, NULL, 12719, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1504831437', 'admin', '2017-09-08 13:04:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45439, '2017-09-08 11:32:24', NULL, NULL, 12715, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1504831437', 'admin', '2017-09-08 11:32:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45440, '2017-09-08 11:33:01', NULL, NULL, 12715, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 11:33:01', 'admin-1504831437-150484158119734', 1, 1, 'SR', NULL, NULL, NULL),
(45441, '2017-09-08 13:26:30', NULL, NULL, 12720, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1504831437', 'admin', '2017-09-08 13:26:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45442, '2017-09-08 13:26:37', NULL, NULL, 12720, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 13:26:37', 'admin-1504831437-15048483970615890', 1, 0, '', NULL, NULL, NULL),
(45443, '2017-09-08 13:26:37', NULL, NULL, 12720, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 13:26:37', 'admin-1504831437-15048483970615890', 1, 1, 'SR', NULL, NULL, NULL),
(45444, '2017-09-08 14:12:11', NULL, NULL, 12721, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1504831437', 'admin', '2017-09-08 14:12:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45445, '2017-09-08 14:12:21', NULL, NULL, 12721, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 14:12:21', 'admin-1504831437-15048511415304640', 1, 0, '', NULL, NULL, NULL),
(45446, '2017-09-08 14:12:21', NULL, NULL, 12721, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 14:12:21', 'admin-1504831437-15048511415304640', 1, 1, 'SR', NULL, NULL, NULL),
(45447, '2017-09-08 14:12:21', NULL, NULL, 12721, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 14:12:21', 'admin-1504831437-15048511415304640', 1, 1, 'SR', NULL, NULL, NULL),
(45448, '2017-09-08 15:02:10', NULL, NULL, 12722, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1504831437', 'admin', '2017-09-08 15:02:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45449, '2017-09-08 15:02:20', NULL, NULL, 12722, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 15:02:20', 'admin-1504831437-15048541403171270', 1, 1, 'SR', NULL, NULL, NULL),
(45450, '2017-09-08 15:02:20', NULL, NULL, 12722, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 15:02:20', 'admin-1504831437-15048541403171270', 1, 1, 'SR', NULL, NULL, NULL),
(45451, '2017-09-08 17:12:05', NULL, NULL, 12725, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1504831437', 'admin', '2017-09-08 17:12:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45452, '2017-09-08 17:17:31', NULL, NULL, 12725, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 17:17:31', 'admin-1504831437-1504862251709385', 1, 1, 'SR', NULL, NULL, NULL),
(45453, '2017-09-08 15:28:30', NULL, NULL, 12722, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 15:28:30', 'admin-1504831437-15048557105273756', 1, 0, '', NULL, NULL, NULL),
(45454, '2017-09-08 15:25:15', NULL, NULL, 12723, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 15:25:15', 'admin-1504831437-15048555154513254', 1, 1, 'SR', NULL, NULL, NULL),
(45455, '2017-09-08 15:25:15', NULL, NULL, 12723, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 15:25:15', 'admin-1504831437-15048555154513254', 1, 1, 'SR', NULL, NULL, NULL),
(45456, '2017-09-08 15:22:55', NULL, NULL, 12723, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 15:22:55', 'admin-1504831437-1504855374909783', 1, 1, 'SR', NULL, NULL, NULL),
(45457, '2017-09-08 15:22:55', NULL, NULL, 12723, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 15:22:55', 'admin-1504831437-1504855374909783', 1, 1, 'SR', NULL, NULL, NULL),
(45458, '2017-09-08 15:22:50', NULL, NULL, 12723, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1504831437', 'admin', '2017-09-08 15:22:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45459, '2017-09-08 12:47:01', NULL, NULL, 12717, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 12:47:01', 'admin-1504831437-15048460211214229', 1, 1, 'SR', NULL, NULL, NULL),
(45460, '2017-09-08 11:33:01', NULL, NULL, 12715, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 11:33:01', 'admin-1504831437-150484158119734', 1, 0, '', NULL, NULL, NULL),
(45461, '2017-09-08 13:04:55', NULL, NULL, 12719, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 13:04:55', 'admin-1504831437-15048470950475017', 1, 1, 'SR', NULL, NULL, NULL),
(45462, '2017-09-08 13:04:55', NULL, NULL, 12719, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 13:04:55', 'admin-1504831437-15048470950475017', 1, 1, 'SR', NULL, NULL, NULL),
(45463, '2017-09-08 11:22:45', NULL, NULL, 12714, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 11:22:45', 'admin-1504831437-15048409652408919', 1, 1, 'SR', NULL, NULL, NULL),
(45464, '2017-09-08 11:22:45', NULL, NULL, 12714, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 11:22:45', 'admin-1504831437-15048409652408919', 1, 1, 'SR', NULL, NULL, NULL),
(45465, '2017-09-08 12:47:01', NULL, NULL, 12717, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 12:47:01', 'admin-1504831437-15048460211214229', 1, 0, '', NULL, NULL, NULL),
(45466, '2017-09-08 12:46:48', NULL, NULL, 12717, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1504831437', 'admin', '2017-09-08 12:46:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45467, '2017-09-08 12:36:29', NULL, NULL, 12716, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 12:36:29', 'admin-1504831437-15048453892231520', 1, 1, 'SR', NULL, NULL, NULL),
(45468, '2017-09-08 11:33:01', NULL, NULL, 12715, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 11:33:01', 'admin-1504831437-150484158119734', 1, 1, 'SR', NULL, NULL, NULL),
(45469, '2017-09-08 12:49:17', NULL, NULL, 12718, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 12:49:17', 'admin-1504831437-15048461568515864', 1, 0, '', 1, NULL, NULL),
(45470, '2017-09-08 11:33:01', NULL, NULL, 12715, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 11:33:01', 'admin-1504831437-150484158119734', 1, 1, 'SR', NULL, NULL, NULL),
(45471, '2017-09-08 11:22:39', NULL, NULL, 12714, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1504831437', 'admin', '2017-09-08 11:22:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45472, '2017-09-08 11:15:09', NULL, NULL, 12713, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1504831437', 'admin', '2017-09-08 11:15:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45473, '2017-09-08 11:17:17', NULL, NULL, 12713, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 11:17:17', 'admin-1504831437-15048406371885044', 1, 0, '', NULL, NULL, NULL),
(45474, '2017-09-08 11:17:25', NULL, NULL, 12713, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 11:17:25', 'admin-1504831437-1504840645131269', 1, 1, 'SR', NULL, NULL, NULL),
(45475, '2017-09-08 11:17:17', NULL, NULL, 12713, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 11:17:17', 'admin-1504831437-15048406371885044', 1, 0, '', NULL, NULL, NULL),
(45476, '2017-09-08 11:07:45', NULL, NULL, 12712, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 11:07:45', 'admin-1504831437-15048400650728991', 1, 1, 'SR', NULL, NULL, NULL),
(45477, '2017-09-08 10:58:02', NULL, NULL, 12711, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 10:58:02', 'admin-1504831437-15048394818054099', 1, 1, 'SR', NULL, NULL, NULL),
(45478, '2017-09-08 11:07:45', NULL, NULL, 12712, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 11:07:45', 'admin-1504831437-15048400650728991', 1, 1, 'SR', NULL, NULL, NULL),
(45479, '2017-09-08 11:07:31', NULL, NULL, 12712, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1504831437', 'admin', '2017-09-08 11:07:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45480, '2017-09-08 11:00:40', NULL, NULL, 12711, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 11:00:40', 'admin-1504831437-15048396405197063', 1, 0, '', NULL, NULL, NULL),
(45481, '2017-09-08 11:00:40', NULL, NULL, 12711, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 11:00:40', 'admin-1504831437-15048396405197063', 1, 0, '', NULL, NULL, NULL),
(45482, '2017-09-08 11:00:40', NULL, NULL, 12711, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 11:00:40', 'admin-1504831437-15048396405197063', 1, 0, '', NULL, NULL, NULL),
(45483, '2017-09-08 10:58:02', NULL, NULL, 12711, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504831437', 'admin', '2017-09-08 10:58:02', 'admin-1504831437-15048394818054099', 1, 1, 'SR', NULL, NULL, NULL),
(45484, '2017-09-08 10:57:54', NULL, NULL, 12711, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1504831437', 'admin', '2017-09-08 10:57:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45485, '2017-09-09 14:29:44', NULL, NULL, 12763, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1504949053', 'admin', '2017-09-09 14:29:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45486, '2017-09-09 10:33:12', NULL, NULL, 12739, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:33:12', 'admin-1504922410-15049243925047461', 1, 1, 'SR', NULL, NULL, NULL),
(45487, '2017-09-09 13:29:04', NULL, NULL, 12760, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 13:29:04', 'admin-1504933524-15049349438953517', 1, 0, '', NULL, NULL, NULL),
(45488, '2017-09-09 13:29:04', NULL, NULL, 12760, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 13:29:04', 'admin-1504933524-15049349438953517', 1, 1, 'SR', NULL, NULL, NULL),
(45489, '2017-09-09 13:29:04', NULL, NULL, 12760, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 13:29:04', 'admin-1504933524-15049349438953517', 1, 1, 'SR', NULL, NULL, NULL),
(45490, '2017-09-09 13:29:33', NULL, NULL, 12760, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 13:29:33', 'admin-1504933524-15049349731947232', 1, 0, '', NULL, NULL, NULL),
(45491, '2017-09-09 12:54:54', NULL, NULL, 12756, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:54:54', 'admin-1504928998-1504932894239274', 1, 0, '', NULL, NULL, NULL),
(45492, '2017-09-09 12:54:54', NULL, NULL, 12756, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:54:54', 'admin-1504928998-1504932894239274', 1, 1, 'SR', NULL, NULL, NULL),
(45493, '2017-09-09 12:54:54', NULL, NULL, 12756, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:54:54', 'admin-1504928998-1504932894239274', 1, 1, 'SR', NULL, NULL, NULL),
(45494, '2017-09-09 13:03:14', NULL, NULL, 12754, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 13:03:14', 'admin-1504928998-15049333944916081', 1, 1, 'SR', NULL, NULL, NULL),
(45495, '2017-09-09 13:05:08', NULL, NULL, 12757, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1504949053', 'admin', '2017-09-09 13:05:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45496, '2017-09-09 13:05:16', NULL, NULL, 12757, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 13:05:16', 'admin-1504928998-15049335163158633', 1, 1, 'SR', NULL, NULL, NULL),
(45497, '2017-09-09 13:05:34', NULL, NULL, 12757, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 13:05:34', 'admin-1504933524-15049335340009222', 1, 1, 'SR', NULL, NULL, NULL),
(45498, '2017-09-09 13:24:34', NULL, NULL, 12759, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 13:24:34', 'admin-1504933524-15049346747382743', 1, 1, 'SR', NULL, NULL, NULL),
(45499, '2017-09-09 13:28:19', NULL, NULL, 12760, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1504949053', 'admin', '2017-09-09 13:28:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45500, '2017-09-09 12:54:54', NULL, NULL, 12756, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:54:54', 'admin-1504928998-1504932894239274', 1, 0, '', NULL, NULL, NULL),
(45501, '2017-09-09 11:25:56', NULL, NULL, 12744, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:25:56', 'admin-1504925273-15049275558177324', 1, 0, '', NULL, NULL, NULL),
(45502, '2017-09-09 11:25:56', NULL, NULL, 12744, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:25:56', 'admin-1504925273-15049275558177324', 1, 1, 'SR', NULL, NULL, NULL),
(45503, '2017-09-09 17:05:21', NULL, NULL, 12769, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 17:05:21', 'admin-1504933524-15049479212132659', 1, 1, 'SR', NULL, NULL, NULL),
(45504, '2017-09-09 17:05:55', NULL, NULL, 12769, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 17:05:56', 'admin-1504933524-1504947955850668', 1, 0, '', NULL, NULL, NULL),
(45505, '2017-09-09 12:54:32', NULL, NULL, 12756, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:54:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45506, '2017-09-09 12:53:03', NULL, NULL, 12755, 0, 182, '117', 'Open Drinks ', 'banana', 'Cold Drinks', 'Fresh Juice', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:53:03', 'admin-1504928998-15049327834132651', 1, 0, '', NULL, NULL, NULL),
(45507, '2017-09-09 12:53:03', NULL, NULL, 12755, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:53:03', 'admin-1504928998-15049327834132651', 1, 1, 'SR', NULL, NULL, NULL),
(45508, '2017-09-09 13:28:31', NULL, NULL, 12760, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 13:28:31', 'admin-1504933524-15049349113899555', 1, 1, 'SR', NULL, NULL, NULL),
(45509, '2017-09-09 13:28:26', NULL, NULL, 12760, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 13:28:26', 'admin-1504933524-15049349059741537', 1, 0, '', NULL, NULL, NULL),
(45510, '2017-09-09 11:12:58', NULL, NULL, 12743, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:12:58', 'admin-1504925273-15049267782357728', 1, 0, '', NULL, NULL, NULL),
(45511, '2017-09-09 11:12:58', NULL, NULL, 12743, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:12:58', 'admin-1504925273-15049267782357728', 1, 1, 'SR', NULL, NULL, NULL),
(45512, '2017-09-09 11:12:58', NULL, NULL, 12743, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:12:58', 'admin-1504925273-15049267782357728', 1, 1, 'SR', NULL, NULL, NULL),
(45513, '2017-09-09 11:12:58', NULL, NULL, 12743, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:12:58', 'admin-1504925273-15049267782357728', 1, 1, 'SR', NULL, NULL, NULL),
(45514, '2017-09-09 12:52:04', NULL, NULL, 12755, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.55, 0.0000, 0.0000, 2.55, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:52:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45515, '2017-09-09 12:46:34', NULL, NULL, 12753, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:46:34', 'admin-1504928998-1504932394498319', 1, 0, '', NULL, NULL, NULL),
(45516, '2017-09-09 11:30:47', NULL, NULL, 12745, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:30:47', 'admin-1504925273-15049278477181242', 1, 1, 'SR', NULL, NULL, NULL),
(45517, '2017-09-09 12:39:55', NULL, NULL, 12753, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:39:55', 'admin-1504928998-15049319947854330', 1, 0, '', NULL, NULL, NULL),
(45518, '2017-09-09 12:37:17', NULL, NULL, 12754, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:37:17', 'admin-1504928998-15049318368921423', 1, 1, 'SR', NULL, NULL, NULL),
(45519, '2017-09-09 10:22:02', NULL, NULL, 12737, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:22:02', 'admin-1504922410-15049237221954752', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(45520, '2017-09-09 10:22:02', NULL, NULL, 12737, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:22:02', 'admin-1504922410-15049237221954752', 1, 0, '', NULL, NULL, NULL),
(45521, '2017-09-09 10:22:02', NULL, NULL, 12737, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:22:02', 'admin-1504922410-15049237221954752', 1, 0, '', NULL, NULL, NULL),
(45522, '2017-09-09 10:21:42', NULL, NULL, 12737, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:21:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45523, '2017-09-09 10:19:37', NULL, NULL, 12736, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:19:37', 'admin-1504922410-15049235772992965', 1, 1, 'SR', NULL, NULL, NULL),
(45524, '2017-09-09 10:19:37', NULL, NULL, 12736, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:19:37', 'admin-1504922410-15049235772992965', 1, 1, 'SR', NULL, NULL, NULL),
(45525, '2017-09-09 10:19:37', NULL, NULL, 12736, 0, 207, '142', 'Cheesy Bacon Toast', 'change cjips to sunny side', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:19:37', 'admin-1504922410-15049235772992965', 1, 0, '', NULL, NULL, NULL),
(45526, '2017-09-09 10:19:37', NULL, NULL, 12736, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:19:37', 'admin-1504922410-15049235772992965', 1, 0, '', NULL, NULL, NULL),
(45527, '2017-09-09 10:19:02', NULL, NULL, 12736, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:19:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45528, '2017-09-09 10:18:57', NULL, NULL, 12733, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:18:57', 'admin-1504922410-15049235368318614', 1, 1, 'SR', NULL, NULL, NULL),
(45529, '2017-09-09 10:18:57', NULL, NULL, 12733, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:18:57', 'admin-1504922410-15049235368318614', 1, 0, '', NULL, NULL, NULL),
(45530, '2017-09-09 10:17:50', NULL, NULL, 12735, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:17:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45531, '2017-09-09 10:03:24', NULL, NULL, 12732, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:03:24', 'admin-1504922410-15049226038471584', 1, 1, 'SR', NULL, NULL, NULL),
(45532, '2017-09-09 10:03:02', NULL, NULL, 12732, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:03:02', 'admin-1504922410-15049225827818577', 1, 1, 'SR', NULL, NULL, NULL),
(45533, '2017-09-09 17:04:34', NULL, NULL, 12769, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 17:04:34', 'admin-1504933524-15049478744856995', 1, 1, 'SR', NULL, NULL, NULL),
(45534, '2017-09-09 13:24:34', NULL, NULL, 12759, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 13:24:34', 'admin-1504933524-15049346747382743', 1, 0, '', NULL, NULL, NULL),
(45535, '2017-09-09 12:37:17', NULL, NULL, 12754, 0, 154, '88', 'Daily Dose BLT', 'sunny side to scramble egg', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:37:17', 'admin-1504928998-15049318368921423', 1, 0, '', NULL, NULL, NULL),
(45536, '2017-09-09 13:28:26', NULL, NULL, 12760, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 13:28:26', 'admin-1504933524-15049349059741537', 1, 1, 'SR', NULL, NULL, NULL),
(45537, '2017-09-09 13:24:24', NULL, NULL, 12759, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 13:24:24', 'admin-1504933524-1504934664261169', 1, 0, '', NULL, NULL, NULL),
(45538, '2017-09-09 13:24:24', NULL, NULL, 12759, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 13:24:24', 'admin-1504933524-1504934664261169', 1, 0, '', NULL, NULL, NULL),
(45539, '2017-09-09 13:24:00', NULL, NULL, 12759, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1504949053', 'admin', '2017-09-09 13:24:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45540, '2017-09-09 13:18:54', NULL, NULL, 12758, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 13:18:54', 'admin-1504933524-15049343345568542', 1, 1, 'SR', NULL, NULL, NULL),
(45541, '2017-09-09 13:18:54', NULL, NULL, 12758, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 13:18:54', 'admin-1504933524-15049343345568542', 1, 1, 'SR', NULL, NULL, NULL),
(45542, '2017-09-09 12:36:30', NULL, NULL, 12754, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:36:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45543, '2017-09-09 17:04:28', NULL, NULL, 12769, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1504949053', 'admin', '2017-09-09 17:04:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45544, '2017-09-09 16:34:17', NULL, NULL, 12768, 0, 266, '200', 'Tiger Beer Bucket', '', 'Cold Drinks', 'Soda & Beer', 1, 48.00, 48.0000, 0.0000, 48.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 16:34:17', 'admin-1504933524-15049460572661522', 1, 0, '', NULL, NULL, NULL),
(45545, '2017-09-09 16:32:29', NULL, NULL, 12768, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1504949053', 'admin', '2017-09-09 16:32:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45546, '2017-09-09 12:34:59', NULL, NULL, 12753, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:34:59', 'admin-1504928998-15049316988013239', 1, 0, '', NULL, NULL, NULL),
(45547, '2017-09-09 15:33:53', NULL, NULL, 12767, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1504949053', 'admin', '2017-09-09 15:33:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45548, '2017-09-09 15:34:01', NULL, NULL, 12767, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 15:34:01', 'admin-1504933524-15049424414885881', 1, 1, 'SR', NULL, NULL, NULL),
(45549, '2017-09-09 15:17:40', NULL, NULL, 12765, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 15:17:40', 'admin-1504933524-15049414605566857', 1, 1, 'SR', NULL, NULL, NULL),
(45550, '2017-09-09 15:17:40', NULL, NULL, 12765, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 15:17:40', 'admin-1504933524-15049414605566857', 1, 1, 'SR', NULL, NULL, NULL),
(45551, '2017-09-09 12:34:59', NULL, NULL, 12753, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:34:59', 'admin-1504928998-15049316988013239', 1, 1, 'SR', NULL, NULL, NULL),
(45552, '2017-09-09 15:32:19', NULL, NULL, 12766, 0, 182, '117', 'Open Drinks ', 'americano', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 15:32:19', 'admin-1504933524-15049423393297819', 1, 0, '', 1, NULL, NULL),
(45553, '2017-09-09 13:18:54', NULL, NULL, 12758, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 13:18:54', 'admin-1504933524-15049343345568542', 1, 0, '', NULL, NULL, NULL),
(45554, '2017-09-09 11:42:22', NULL, NULL, 12747, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:42:22', 'admin-1504925273-1504928542102421', 1, 0, '', NULL, NULL, NULL),
(45555, '2017-09-09 11:39:09', NULL, NULL, 12747, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:39:09', 'admin-1504925273-15049283490745161', 1, 1, 'SR', NULL, NULL, NULL),
(45556, '2017-09-09 10:22:17', NULL, NULL, 12732, 0, 182, '117', 'Open Drinks ', 'banana', 'Cold Drinks', 'Fresh Juice', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:22:17', 'admin-1504922410-15049237370824262', 1, 0, '', NULL, NULL, NULL),
(45557, '2017-09-09 15:12:17', NULL, NULL, 12764, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 15:12:17', 'admin-1504933524-15049411371213168', 1, 0, '', NULL, NULL, NULL),
(45558, '2017-09-09 15:12:09', NULL, NULL, 12764, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1504949053', 'admin', '2017-09-09 15:12:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45559, '2017-09-09 14:29:50', NULL, NULL, 12763, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 14:29:50', 'admin-1504933524-15049385902534764', 1, 1, 'SR', NULL, NULL, NULL),
(45560, '2017-09-09 14:29:50', NULL, NULL, 12763, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 14:29:50', 'admin-1504933524-15049385902534764', 1, 0, '', NULL, NULL, NULL),
(45561, '2017-09-09 14:25:30', NULL, NULL, 12762, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1504949053', 'admin', '2017-09-09 14:25:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45562, '2017-09-09 14:25:26', NULL, NULL, 12761, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 14:25:26', 'admin-1504933524-15049383262514472', 1, 0, '', NULL, NULL, '20.0'),
(45563, '2017-09-09 14:25:26', NULL, NULL, 12761, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 14:25:26', 'admin-1504933524-15049383262514472', 1, 0, '', NULL, NULL, '20.0'),
(45564, '2017-09-09 13:18:35', NULL, NULL, 12758, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 13:18:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45565, '2017-09-09 12:05:05', NULL, NULL, 12749, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:05:05', 'admin-1504928998-15049299057096416', 1, 1, 'SR', NULL, NULL, NULL),
(45566, '2017-09-09 12:27:54', NULL, NULL, 12751, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:27:54', 'admin-1504928998-15049312739883115', 1, 0, '', NULL, NULL, NULL),
(45567, '2017-09-09 12:27:54', NULL, NULL, 12751, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:27:54', 'admin-1504928998-15049312739883115', 1, 1, 'SR', NULL, NULL, NULL),
(45568, '2017-09-09 15:17:26', NULL, NULL, 12765, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1504949053', 'admin', '2017-09-09 15:17:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45569, '2017-09-09 12:29:57', NULL, NULL, 12752, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:29:57', 'admin-1504928998-15049313973135575', 1, 0, '', NULL, NULL, NULL),
(45570, '2017-09-09 11:26:56', NULL, NULL, 12746, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:26:56', 'admin-1504925273-15049276167363642', 1, 1, 'SR', NULL, NULL, '10.0'),
(45571, '2017-09-09 12:29:49', NULL, NULL, 12752, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:29:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45572, '2017-09-09 12:27:54', NULL, NULL, 12751, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:27:54', 'admin-1504928998-15049312739883115', 1, 0, '', NULL, NULL, NULL),
(45573, '2017-09-09 11:02:31', NULL, NULL, 12741, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:02:31', 'admin-1504925273-1504926151823294', 1, 0, '', NULL, NULL, NULL),
(45574, '2017-09-09 10:33:12', NULL, NULL, 12739, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:33:12', 'admin-1504922410-15049243925047461', 1, 0, '', NULL, NULL, NULL),
(45575, '2017-09-09 14:25:39', NULL, NULL, 12762, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 14:25:39', 'admin-1504933524-15049383392258189', 1, 1, 'SR', NULL, NULL, NULL),
(45576, '2017-09-09 11:49:28', NULL, NULL, 12748, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:49:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45577, '2017-09-09 11:49:40', NULL, NULL, 12748, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:49:40', 'admin-1504925273-1504928980506251', 1, 1, 'SR', NULL, NULL, NULL),
(45578, '2017-09-09 11:49:40', NULL, NULL, 12748, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:49:40', 'admin-1504925273-1504928980506251', 1, 0, '', NULL, NULL, NULL),
(45579, '2017-09-09 11:49:40', NULL, NULL, 12748, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:49:40', 'admin-1504925273-1504928980506251', 1, 1, 'SR', NULL, NULL, NULL),
(45580, '2017-09-09 11:49:40', NULL, NULL, 12748, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:49:40', 'admin-1504925273-1504928980506251', 1, 1, 'SR', NULL, NULL, NULL),
(45581, '2017-09-09 12:39:55', NULL, NULL, 12753, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:39:55', 'admin-1504928998-15049319947854330', 1, 0, '', NULL, NULL, NULL),
(45582, '2017-09-09 12:09:16', NULL, NULL, 12735, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:09:16', 'admin-1504928998-15049301562131665', 1, 1, 'SR', NULL, NULL, NULL),
(45583, '2017-09-09 12:07:39', NULL, NULL, 12750, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:07:39', 'admin-1504928998-15049300596106769', 1, 1, 'SR', NULL, NULL, NULL),
(45584, '2017-09-09 12:09:16', NULL, NULL, 12735, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:09:16', 'admin-1504928998-15049301562131665', 1, 1, 'SR', NULL, NULL, NULL),
(45585, '2017-09-09 12:27:16', NULL, NULL, 12751, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:27:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45586, '2017-09-09 11:49:40', NULL, NULL, 12748, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:49:40', 'admin-1504925273-1504928980506251', 1, 1, 'SR', NULL, NULL, NULL),
(45587, '2017-09-09 12:04:31', NULL, NULL, 12749, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:04:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45588, '2017-09-09 12:05:05', NULL, NULL, 12749, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:05:05', 'admin-1504928998-15049299057096416', 1, 0, '', NULL, NULL, NULL),
(45589, '2017-09-09 12:05:05', NULL, NULL, 12749, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:05:05', 'admin-1504928998-15049299057096416', 1, 0, '', NULL, NULL, NULL),
(45590, '2017-09-09 11:39:09', NULL, NULL, 12747, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:39:09', 'admin-1504925273-15049283490745161', 1, 0, '', NULL, NULL, NULL),
(45591, '2017-09-09 10:34:35', NULL, NULL, 12740, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:34:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45592, '2017-09-09 10:33:12', NULL, NULL, 12739, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:33:12', 'admin-1504922410-15049243925047461', 1, 0, '', NULL, NULL, NULL),
(45593, '2017-09-09 09:11:52', NULL, NULL, 12727, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:11:52', 'admin-1504917608-15049195120354115', 1, 0, '', NULL, NULL, NULL),
(45594, '2017-09-09 09:11:52', NULL, NULL, 12727, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:11:52', 'admin-1504917608-15049195120354115', 1, 0, '', NULL, NULL, NULL),
(45595, '2017-09-09 11:34:19', NULL, NULL, 12741, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:34:19', 'admin-1504925273-15049280589612741', 1, 0, '', NULL, NULL, NULL),
(45596, '2017-09-09 11:38:52', NULL, NULL, 12747, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:38:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45597, '2017-09-09 11:30:47', NULL, NULL, 12745, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:30:47', 'admin-1504925273-15049278477181242', 1, 0, '', NULL, NULL, NULL),
(45598, '2017-09-09 11:30:47', NULL, NULL, 12745, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:30:47', 'admin-1504925273-15049278477181242', 1, 1, 'SR', NULL, NULL, NULL),
(45599, '2017-09-09 11:30:47', NULL, NULL, 12745, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:30:47', 'admin-1504925273-15049278477181242', 1, 0, '', NULL, NULL, NULL),
(45600, '2017-09-09 11:29:15', NULL, NULL, 12746, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:29:15', 'admin-1504925273-15049277557109585', 1, 0, '', NULL, NULL, '10.0'),
(45601, '2017-09-09 11:26:56', NULL, NULL, 12746, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:26:56', 'admin-1504925273-15049276167363642', 1, 1, 'SR', NULL, NULL, '10.0'),
(45602, '2017-09-09 11:26:53', NULL, NULL, 12746, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:26:53', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(45603, '2017-09-09 11:26:10', NULL, NULL, 12744, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:26:10', 'admin-1504925273-15049275698878355', 1, 1, 'SR', NULL, NULL, NULL),
(45604, '2017-09-09 11:26:41', NULL, NULL, 12745, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:26:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45605, '2017-09-09 11:01:28', NULL, NULL, 12741, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:01:29', 'admin-1504925273-15049260887987026', 1, 0, '', NULL, NULL, NULL),
(45606, '2017-09-09 11:01:29', NULL, NULL, 12741, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:01:29', 'admin-1504925273-15049260887987026', 1, 0, '', NULL, NULL, NULL),
(45607, '2017-09-09 11:01:30', NULL, NULL, 12742, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:01:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45608, '2017-09-09 11:01:36', NULL, NULL, 12742, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:01:36', 'admin-1504925273-15049260958835711', 1, 0, '', NULL, NULL, NULL),
(45609, '2017-09-09 11:01:41', NULL, NULL, 12742, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:01:41', 'admin-1504925273-1504926100953764', 1, 0, '', NULL, NULL, NULL),
(45610, '2017-09-09 11:02:23', NULL, NULL, 12741, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:02:23', 'admin-1504925273-15049261430098315', 1, 1, 'SR', NULL, NULL, NULL),
(45611, '2017-09-09 10:33:12', NULL, NULL, 12739, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:33:12', 'admin-1504922410-15049243925047461', 1, 0, '', NULL, NULL, NULL),
(45612, '2017-09-09 11:25:56', NULL, NULL, 12744, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:25:56', 'admin-1504925273-15049275558177324', 1, 0, '', NULL, NULL, NULL),
(45613, '2017-09-09 11:16:26', NULL, NULL, 12737, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:16:26', 'admin-1504925273-15049269858504623', 1, 0, '', NULL, NULL, NULL),
(45614, '2017-09-09 11:25:48', NULL, NULL, 12744, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:25:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45615, '2017-09-09 17:05:21', NULL, NULL, 12769, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 17:05:21', 'admin-1504933524-15049479212132659', 1, 0, '', NULL, NULL, NULL),
(45616, '2017-09-09 11:11:40', NULL, NULL, 12743, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:11:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45617, '2017-09-09 11:02:23', NULL, NULL, 12741, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:02:23', 'admin-1504925273-15049261430098315', 1, 1, 'SR', NULL, NULL, NULL),
(45618, '2017-09-09 10:18:57', NULL, NULL, 12733, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:18:57', 'admin-1504922410-15049235368318614', 1, 0, '', NULL, NULL, NULL),
(45619, '2017-09-09 09:43:29', NULL, NULL, 12731, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:43:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45620, '2017-09-09 09:43:40', NULL, NULL, 12731, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:43:40', 'admin-1504917608-15049214208397116', 1, 0, '', NULL, NULL, NULL),
(45621, '2017-09-09 09:43:46', NULL, NULL, 12731, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:43:46', 'admin-1504917608-15049214261527713', 1, 1, 'SR', NULL, NULL, NULL),
(45622, '2017-09-09 09:51:45', NULL, NULL, 12730, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:51:45', 'admin-1504917608-15049219055781761', 1, 0, '', NULL, NULL, NULL),
(45623, '2017-09-09 09:57:14', NULL, NULL, 12731, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:57:14', 'admin-1504917608-15049222342945940', 1, 0, '', NULL, NULL, NULL),
(45624, '2017-09-09 09:57:14', NULL, NULL, 12731, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:57:14', 'admin-1504917608-15049222342945940', 1, 1, 'SR', NULL, NULL, NULL),
(45625, '2017-09-09 09:58:32', NULL, NULL, 12732, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.75, 0.0000, 0.0000, 16.75, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:58:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45626, '2017-09-09 09:58:48', NULL, NULL, 12732, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:58:48', 'admin-1504917608-15049223282906763', 1, 0, '', NULL, NULL, NULL),
(45627, '2017-09-09 09:58:48', NULL, NULL, 12732, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:58:48', 'admin-1504917608-15049223282906763', 1, 0, '', NULL, NULL, NULL),
(45628, '2017-09-09 09:58:48', NULL, NULL, 12732, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:58:48', 'admin-1504917608-15049223282906763', 1, 0, '', NULL, NULL, NULL),
(45629, '2017-09-09 09:58:48', NULL, NULL, 12732, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:58:48', 'admin-1504917608-15049223282906763', 1, 0, '', NULL, NULL, NULL),
(45630, '2017-09-09 12:34:49', NULL, NULL, 12753, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:34:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45631, '2017-09-09 10:34:50', NULL, NULL, 12740, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:34:50', 'admin-1504922410-1504924490074149', 1, 0, '', NULL, NULL, NULL),
(45632, '2017-09-09 10:34:50', NULL, NULL, 12740, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:34:50', 'admin-1504922410-1504924490074149', 1, 0, '', NULL, NULL, NULL),
(45633, '2017-09-09 11:30:47', NULL, NULL, 12745, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:30:47', 'admin-1504925273-15049278477181242', 1, 0, '', NULL, NULL, NULL),
(45634, '2017-09-09 10:33:12', NULL, NULL, 12739, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:33:12', 'admin-1504922410-15049243925047461', 1, 1, 'SR', NULL, NULL, NULL),
(45635, '2017-09-09 15:34:01', NULL, NULL, 12767, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 15:34:01', 'admin-1504933524-15049424414885881', 1, 0, '', NULL, NULL, NULL),
(45636, '2017-09-09 13:18:54', NULL, NULL, 12758, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 13:18:54', 'admin-1504933524-15049343345568542', 1, 0, '', NULL, NULL, NULL),
(45637, '2017-09-09 10:02:42', NULL, NULL, 12734, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:02:42', 'admin-1504922410-15049225627522991', 1, 1, 'SR', NULL, NULL, NULL),
(45638, '2017-09-09 10:02:42', NULL, NULL, 12734, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:02:42', 'admin-1504922410-15049225627522991', 1, 0, '', NULL, NULL, NULL),
(45639, '2017-09-09 10:02:42', NULL, NULL, 12734, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:02:42', 'admin-1504922410-15049225627522991', 1, 0, '', NULL, NULL, NULL),
(45640, '2017-09-09 10:02:42', NULL, NULL, 12734, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:02:42', 'admin-1504922410-15049225627522991', 1, 1, 'SR', NULL, NULL, NULL),
(45641, '2017-09-09 12:07:31', NULL, NULL, 12750, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:07:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45642, '2017-09-09 11:01:20', NULL, NULL, 12741, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 11:01:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45643, '2017-09-09 14:23:04', NULL, NULL, 12761, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1504949053', 'admin', '2017-09-09 14:23:04', '0', 1, 1, 'SR', NULL, NULL, '20.0'),
(45644, '2017-09-09 12:37:17', NULL, NULL, 12754, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 12:37:17', 'admin-1504928998-15049318368921423', 1, 0, '', NULL, NULL, NULL),
(45645, '2017-09-09 10:33:12', NULL, NULL, 12739, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:33:12', 'admin-1504922410-15049243925047461', 1, 0, '', NULL, NULL, NULL),
(45646, '2017-09-09 10:33:12', NULL, NULL, 12739, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:33:12', 'admin-1504922410-15049243925047461', 1, 0, '', NULL, NULL, NULL),
(45647, '2017-09-09 10:33:12', NULL, NULL, 12739, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:33:12', 'admin-1504922410-15049243925047461', 1, 0, '', NULL, NULL, NULL),
(45648, '2017-09-09 10:33:12', NULL, NULL, 12739, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:33:12', 'admin-1504922410-15049243925047461', 1, 0, '', NULL, NULL, NULL),
(45649, '2017-09-09 10:32:35', NULL, NULL, 12739, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.20, 0.0000, 0.0000, 15.20, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:32:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45650, '2017-09-09 10:30:54', NULL, NULL, 12738, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:30:54', 'admin-1504922410-1504924254153599', 1, 0, '', NULL, NULL, NULL),
(45651, '2017-09-09 10:30:54', NULL, NULL, 12738, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:30:54', 'admin-1504922410-1504924254153599', 1, 0, '', NULL, NULL, NULL),
(45652, '2017-09-09 10:30:41', NULL, NULL, 12738, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:30:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45653, '2017-09-09 10:30:54', NULL, NULL, 12738, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:30:54', 'admin-1504922410-1504924254153599', 1, 1, 'SR', NULL, NULL, NULL),
(45654, '2017-09-09 10:22:02', NULL, NULL, 12737, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:22:02', 'admin-1504922410-15049237221954752', 1, 0, '', NULL, NULL, NULL),
(45655, '2017-09-09 10:22:02', NULL, NULL, 12737, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:22:02', 'admin-1504922410-15049237221954752', 1, 1, 'SR', NULL, NULL, NULL),
(45656, '2017-09-09 10:18:57', NULL, NULL, 12733, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:18:57', 'admin-1504922410-15049235368318614', 1, 0, '', NULL, NULL, NULL),
(45657, '2017-09-09 10:01:55', NULL, NULL, 12733, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:01:55', 'admin-1504922410-15049225157463794', 1, 0, '', NULL, NULL, NULL),
(45658, '2017-09-09 10:01:55', NULL, NULL, 12733, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:01:55', 'admin-1504922410-15049225157463794', 1, 0, '', NULL, NULL, NULL),
(45659, '2017-09-09 10:01:55', NULL, NULL, 12733, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:01:55', 'admin-1504922410-15049225157463794', 1, 0, '', NULL, NULL, NULL),
(45660, '2017-09-09 10:01:55', NULL, NULL, 12733, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:01:55', 'admin-1504922410-15049225157463794', 1, 1, 'SR', NULL, NULL, NULL),
(45661, '2017-09-09 10:34:50', NULL, NULL, 12740, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:34:50', 'admin-1504922410-1504924490074149', 1, 1, 'SR', NULL, NULL, NULL),
(45662, '2017-09-09 10:18:57', NULL, NULL, 12733, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:18:57', 'admin-1504922410-15049235368318614', 1, 0, '', NULL, NULL, NULL),
(45663, '2017-09-09 10:02:42', NULL, NULL, 12734, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:02:42', 'admin-1504922410-15049225627522991', 1, 0, '', NULL, NULL, NULL),
(45664, '2017-09-09 10:01:55', NULL, NULL, 12733, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:01:55', 'admin-1504922410-15049225157463794', 1, 1, 'SR', NULL, NULL, NULL),
(45665, '2017-09-09 10:02:02', NULL, NULL, 12734, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:02:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45666, '2017-09-09 10:01:28', NULL, NULL, 12733, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.70, 0.0000, 0.0000, 12.70, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:01:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45667, '2017-09-09 10:00:56', NULL, NULL, 12732, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:00:56', 'admin-1504922410-1504922456509232', 1, 0, '', NULL, NULL, NULL),
(45668, '2017-09-09 10:03:02', NULL, NULL, 12732, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:03:02', 'admin-1504922410-15049225827818577', 1, 0, '', NULL, NULL, NULL),
(45669, '2017-09-09 10:00:01', NULL, NULL, 12732, 0, 296, '232', 'Classic Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 10:00:01', 'admin-1504917608-15049223999697539', 1, 0, '', NULL, NULL, NULL),
(45670, '2017-09-09 09:58:48', NULL, NULL, 12732, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:58:48', 'admin-1504917608-15049223282906763', 1, 1, 'SR', NULL, NULL, NULL),
(45671, '2017-09-09 09:29:07', NULL, NULL, 12730, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:29:07', 'admin-1504917608-15049205468372077', 1, 1, 'SR', NULL, NULL, NULL),
(45672, '2017-09-09 09:32:54', NULL, NULL, 12730, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:32:54', 'admin-1504917608-15049207742515745', 1, 0, '', NULL, NULL, NULL),
(45673, '2017-09-09 09:32:54', NULL, NULL, 12730, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:32:54', 'admin-1504917608-15049207742515745', 1, 0, '', NULL, NULL, NULL),
(45674, '2017-09-09 09:29:07', NULL, NULL, 12730, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:29:07', 'admin-1504917608-15049205468372077', 1, 0, '', NULL, NULL, NULL),
(45675, '2017-09-09 09:29:07', NULL, NULL, 12730, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:29:07', 'admin-1504917608-15049205468372077', 1, 1, 'SR', NULL, NULL, NULL),
(45676, '2017-09-09 09:18:39', NULL, NULL, 12728, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:18:39', 'admin-1504917608-15049199192469725', 1, 1, 'SR', NULL, NULL, NULL),
(45677, '2017-09-09 09:24:24', NULL, NULL, 12729, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:24:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45678, '2017-09-09 09:24:48', NULL, NULL, 12729, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:24:48', 'admin-1504917608-15049202886173214', 1, 0, '', NULL, NULL, NULL),
(45679, '2017-09-09 09:24:48', NULL, NULL, 12729, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:24:48', 'admin-1504917608-15049202886173214', 1, 0, '', NULL, NULL, NULL),
(45680, '2017-09-09 09:24:48', NULL, NULL, 12729, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:24:48', 'admin-1504917608-15049202886173214', 1, 1, 'SR', NULL, NULL, NULL),
(45681, '2017-09-09 09:24:48', NULL, NULL, 12729, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:24:48', 'admin-1504917608-15049202886173214', 1, 0, '', NULL, NULL, NULL),
(45682, '2017-09-09 09:29:06', NULL, NULL, 12730, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:29:06', 'admin-1504917608-15049205468372077', 1, 0, '', NULL, NULL, NULL),
(45683, '2017-09-09 09:29:07', NULL, NULL, 12730, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:29:07', 'admin-1504917608-15049205468372077', 1, 0, '', NULL, NULL, NULL),
(45684, '2017-09-09 09:28:24', NULL, NULL, 12730, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.30, 0.0000, 0.0000, 10.30, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:28:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45685, '2017-09-09 09:18:39', NULL, NULL, 12728, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:18:39', 'admin-1504917608-15049199192469725', 1, 1, 'SR', NULL, NULL, NULL),
(45686, '2017-09-09 09:18:39', NULL, NULL, 12728, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:18:39', 'admin-1504917608-15049199192469725', 1, 1, 'SR', NULL, NULL, NULL),
(45687, '2017-09-09 09:18:39', NULL, NULL, 12728, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:18:39', 'admin-1504917608-15049199192469725', 1, 0, '', NULL, NULL, NULL),
(45688, '2017-09-09 09:18:39', NULL, NULL, 12728, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:18:39', 'admin-1504917608-15049199192469725', 1, 0, '', NULL, NULL, NULL),
(45689, '2017-09-09 09:18:39', NULL, NULL, 12728, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:18:39', 'admin-1504917608-15049199192469725', 1, 0, '', NULL, NULL, NULL),
(45690, '2017-09-09 09:18:16', NULL, NULL, 12728, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:18:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45691, '2017-09-09 09:11:52', NULL, NULL, 12727, 0, 296, '232', 'Classic Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:11:52', 'admin-1504917608-15049195120354115', 1, 0, '', NULL, NULL, NULL),
(45692, '2017-09-09 09:11:52', NULL, NULL, 12727, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:11:52', 'admin-1504917608-15049195120354115', 1, 0, '', NULL, NULL, NULL),
(45693, '2017-09-09 09:11:35', NULL, NULL, 12727, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1504949053', 'admin', '2017-09-09 09:11:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45694, '2017-09-10 13:23:18', NULL, NULL, 12797, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:23:18', 'admin-1505015850-15050209983097289', 1, 1, 'SR', NULL, NULL, NULL),
(45695, '2017-09-10 12:20:51', NULL, NULL, 12793, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:20:51', 'admin-1505015850-15050172508989024', 1, 0, '', NULL, NULL, NULL),
(45696, '2017-09-10 11:35:10', NULL, NULL, 12787, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:35:10', 'admin-1505011244-15050145102464653', 1, 1, 'SR', NULL, NULL, NULL),
(45697, '2017-09-10 17:11:15', NULL, NULL, 12809, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 17:11:15', 'admin-1505025773-15050346750164791', 1, 1, 'SR', NULL, NULL, NULL),
(45698, '2017-09-10 11:35:44', NULL, NULL, 12788, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:35:44', 'admin-1505011244-15050145444315255', 1, 1, 'SR', NULL, NULL, NULL),
(45699, '2017-09-10 17:10:50', NULL, NULL, 12809, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 17:10:50', 'admin-1505025773-1505034649962207', 1, 1, 'SR', NULL, NULL, NULL),
(45700, '2017-09-10 17:10:45', NULL, NULL, 12809, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1505025773', 'admin', '2017-09-10 17:10:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45701, '2017-09-10 11:57:45', NULL, NULL, 12789, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:57:45', 'admin-1505015850-15050158653804787', 1, 1, 'SR', NULL, NULL, NULL),
(45702, '2017-09-10 11:57:45', NULL, NULL, 12789, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:57:45', 'admin-1505015850-15050158653804787', 1, 1, 'SR', NULL, NULL, NULL),
(45703, '2017-09-10 13:03:55', NULL, NULL, 12795, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:03:55', 'admin-1505015850-15050198351612560', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(45704, '2017-09-10 16:23:29', NULL, NULL, 12808, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 16:23:29', 'admin-1505025773-15050318097447158', 1, 0, '', NULL, NULL, NULL),
(45705, '2017-09-10 14:33:34', NULL, NULL, 12800, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 14:33:34', 'admin-1505015850-15050252146454894', 1, 0, '', NULL, NULL, NULL),
(45706, '2017-09-10 14:27:03', NULL, NULL, 12800, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 14:27:03', 'admin-1505015850-15050248232395949', 1, 1, 'SR', NULL, NULL, NULL),
(45707, '2017-09-10 16:17:47', NULL, NULL, 12808, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 16:17:47', 'admin-1505025773-15050314671029878', 1, 1, 'SR', NULL, NULL, NULL),
(45708, '2017-09-10 16:17:47', NULL, NULL, 12808, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 16:17:47', 'admin-1505025773-15050314671029878', 1, 0, '', NULL, NULL, NULL),
(45709, '2017-09-10 16:17:47', NULL, NULL, 12808, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 16:17:47', 'admin-1505025773-15050314671029878', 1, 1, 'SR', NULL, NULL, NULL),
(45710, '2017-09-10 16:34:32', NULL, NULL, 12808, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 16:34:32', 'admin-1505025773-15050324728216059', 1, 1, 'SR', NULL, NULL, NULL),
(45711, '2017-09-10 16:16:57', NULL, NULL, 12808, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1505025773', 'admin', '2017-09-10 16:16:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45712, '2017-09-10 16:04:45', NULL, NULL, 12807, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 16:04:45', 'admin-1505025773-15050306851168364', 1, 0, '', NULL, NULL, NULL),
(45713, '2017-09-10 13:23:44', NULL, NULL, 12797, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:23:44', 'admin-1505015850-1505021024236532', 1, 1, 'SR', NULL, NULL, NULL),
(45714, '2017-09-10 13:23:18', NULL, NULL, 12797, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:23:18', 'admin-1505015850-15050209983097289', 1, 1, 'SR', NULL, NULL, NULL),
(45715, '2017-09-10 13:23:18', NULL, NULL, 12797, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:23:18', 'admin-1505015850-15050209983097289', 1, 1, 'SR', NULL, NULL, NULL),
(45716, '2017-09-10 15:32:56', NULL, NULL, 12804, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:32:56', 'admin-1505025773-15050287765631895', 1, 1, 'SR', NULL, NULL, NULL),
(45717, '2017-09-10 16:03:58', NULL, NULL, 12807, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 16:03:58', 'admin-1505025773-1505030638734108', 1, 0, '', NULL, NULL, NULL),
(45718, '2017-09-10 15:40:59', NULL, NULL, 12805, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:40:59', 'admin-1505025773-15050292593176077', 1, 0, '', NULL, NULL, NULL),
(45719, '2017-09-10 12:20:51', NULL, NULL, 12793, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:20:51', 'admin-1505015850-15050172508989024', 1, 0, '', NULL, NULL, NULL),
(45720, '2017-09-10 16:03:58', NULL, NULL, 12807, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 16:03:58', 'admin-1505025773-1505030638734108', 1, 1, 'SR', NULL, NULL, NULL),
(45721, '2017-09-10 16:03:58', NULL, NULL, 12807, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 16:03:58', 'admin-1505025773-1505030638734108', 1, 1, 'SR', NULL, NULL, NULL),
(45722, '2017-09-10 16:03:50', NULL, NULL, 12807, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1505025773', 'admin', '2017-09-10 16:03:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45723, '2017-09-10 15:54:16', NULL, NULL, 12806, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:54:16', 'admin-1505025773-15050300558264267', 1, 0, '', NULL, NULL, NULL),
(45724, '2017-09-10 15:54:16', NULL, NULL, 12806, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:54:16', 'admin-1505025773-15050300558264267', 1, 0, '', NULL, NULL, NULL),
(45725, '2017-09-10 15:53:51', NULL, NULL, 12806, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:53:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45726, '2017-09-10 15:42:01', NULL, NULL, 12805, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:42:01', 'admin-1505025773-15050293211713151', 1, 1, 'SR', NULL, NULL, NULL),
(45727, '2017-09-10 15:42:01', NULL, NULL, 12805, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:42:01', 'admin-1505025773-15050293211713151', 1, 1, 'SR', NULL, NULL, NULL),
(45728, '2017-09-10 10:29:53', NULL, NULL, 12778, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:29:53', 'admin-1505005586-15050105931312142', 1, 0, '', NULL, NULL, NULL),
(45729, '2017-09-10 15:42:01', NULL, NULL, 12805, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:42:01', 'admin-1505025773-15050293211713151', 1, 1, 'SR', NULL, NULL, NULL),
(45730, '2017-09-10 09:49:23', NULL, NULL, 12776, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:49:23', 'admin-1505005586-15050081635377821', 1, 0, '', NULL, NULL, NULL),
(45731, '2017-09-10 15:40:59', NULL, NULL, 12805, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:40:59', 'admin-1505025773-15050292593176077', 1, 0, '', NULL, NULL, NULL),
(45732, '2017-09-10 15:40:27', NULL, NULL, 12805, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:40:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45733, '2017-09-10 15:32:56', NULL, NULL, 12804, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:32:56', 'admin-1505025773-15050287765631895', 1, 0, '', NULL, NULL, NULL),
(45734, '2017-09-10 15:33:10', NULL, NULL, 12804, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:33:10', 'admin-1505025773-15050287898791317', 1, 1, 'SR', NULL, NULL, NULL),
(45735, '2017-09-10 15:33:10', NULL, NULL, 12804, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:33:10', 'admin-1505025773-15050287898791317', 1, 0, '', NULL, NULL, NULL),
(45736, '2017-09-10 15:32:56', NULL, NULL, 12804, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:32:56', 'admin-1505025773-15050287765631895', 1, 0, '', NULL, NULL, NULL),
(45737, '2017-09-10 15:32:56', NULL, NULL, 12804, 0, 181, '116', 'Open Food ', 'add bacon', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:32:56', 'admin-1505025773-15050287765631895', 1, 0, '', NULL, NULL, NULL),
(45738, '2017-09-10 11:34:40', NULL, NULL, 12787, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:34:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45739, '2017-09-10 11:35:10', NULL, NULL, 12787, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:35:10', 'admin-1505011244-15050145102464653', 1, 0, '', NULL, NULL, NULL),
(45740, '2017-09-10 15:32:19', NULL, NULL, 12804, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:32:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45741, '2017-09-10 11:35:10', NULL, NULL, 12787, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:35:10', 'admin-1505011244-15050145102464653', 1, 0, '', NULL, NULL, NULL),
(45742, '2017-09-10 15:29:31', NULL, NULL, 12803, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:29:31', 'admin-1505025773-15050285713447278', 1, 1, 'SR', NULL, NULL, NULL),
(45743, '2017-09-10 11:27:51', NULL, NULL, 12785, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:27:51', 'admin-1505011244-15050140712389387', 1, 0, '', NULL, NULL, NULL),
(45744, '2017-09-10 15:29:31', NULL, NULL, 12803, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:29:31', 'admin-1505025773-15050285713447278', 1, 1, 'SR', NULL, NULL, NULL),
(45745, '2017-09-10 13:44:46', NULL, NULL, 12797, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:44:46', 'admin-1505015850-15050222864545079', 1, 0, '', NULL, NULL, NULL),
(45746, '2017-09-10 14:26:48', NULL, NULL, 12800, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 14:26:48', 'admin-1505015850-15050248086777959', 1, 1, 'SR', NULL, NULL, NULL),
(45747, '2017-09-10 14:24:48', NULL, NULL, 12800, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1505025773', 'admin', '2017-09-10 14:24:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45748, '2017-09-10 11:35:44', NULL, NULL, 12788, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:35:44', 'admin-1505011244-15050145444315255', 1, 1, 'SR', NULL, NULL, NULL),
(45749, '2017-09-10 11:56:47', NULL, NULL, 12789, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:56:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45750, '2017-09-10 15:29:19', NULL, NULL, 12803, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:29:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45751, '2017-09-10 13:59:38', NULL, NULL, 12791, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 2, 15.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:59:38', 'admin-1505015850-1505023178676525', 1, 0, '', NULL, NULL, NULL),
(45752, '2017-09-10 13:08:09', NULL, NULL, 12796, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:08:09', 'admin-1505015850-15050200890195138', 1, 0, '', NULL, NULL, NULL),
(45753, '2017-09-10 10:53:48', NULL, NULL, 12782, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:53:48', 'admin-1505011244-15050120285129581', 1, 0, '', NULL, NULL, NULL),
(45754, '2017-09-10 15:04:05', NULL, NULL, 12802, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:04:05', 'admin-1505025773-15050270455521553', 1, 1, 'SR', NULL, NULL, NULL),
(45755, '2017-09-10 15:04:05', NULL, NULL, 12802, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:04:05', 'admin-1505025773-15050270455521553', 1, 1, 'SR', NULL, NULL, NULL),
(45756, '2017-09-10 14:39:57', NULL, NULL, 12800, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 14:39:57', 'admin-1505015850-1505025597784492', 1, 0, '', NULL, NULL, NULL),
(45757, '2017-09-10 14:55:26', NULL, NULL, 12801, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 14:55:26', 'admin-1505025773-15050265260342972', 1, 1, 'SR', 1, NULL, '10.0'),
(45758, '2017-09-10 15:03:52', NULL, NULL, 12802, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:03:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45759, '2017-09-10 14:43:20', NULL, NULL, 12800, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 14:43:20', 'admin-1505025773-15050258000512356', 1, 1, 'SR', NULL, NULL, NULL),
(45760, '2017-09-10 14:33:34', NULL, NULL, 12800, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 14:33:34', 'admin-1505015850-15050252146454894', 1, 0, '', NULL, NULL, NULL),
(45761, '2017-09-10 13:59:38', NULL, NULL, 12791, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:59:38', 'admin-1505015850-1505023178676525', 1, 1, 'SR', NULL, NULL, NULL),
(45762, '2017-09-10 13:59:38', NULL, NULL, 12791, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:59:38', 'admin-1505015850-1505023178676525', 1, 1, 'SR', NULL, NULL, NULL),
(45763, '2017-09-10 13:04:08', NULL, NULL, 12795, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:04:08', 'admin-1505015850-1505019847965755', 1, 0, '', NULL, NULL, NULL),
(45764, '2017-09-10 13:04:08', NULL, NULL, 12795, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:04:08', 'admin-1505015850-1505019847965755', 1, 1, 'SR', NULL, NULL, NULL),
(45765, '2017-09-10 13:08:03', NULL, NULL, 12796, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:08:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45766, '2017-09-10 13:23:44', NULL, NULL, 12797, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:23:44', 'admin-1505015850-1505021024236532', 1, 1, 'SR', NULL, NULL, NULL),
(45767, '2017-09-10 13:44:46', NULL, NULL, 12797, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:44:46', 'admin-1505015850-15050222864545079', 1, 1, 'SR', NULL, NULL, NULL),
(45768, '2017-09-10 13:23:44', NULL, NULL, 12797, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:23:44', 'admin-1505015850-1505021024236532', 1, 1, 'SR', NULL, NULL, NULL),
(45769, '2017-09-10 13:23:44', NULL, NULL, 12797, 0, 266, '200', 'Tiger Beer Bucket', '', 'Cold Drinks', 'Soda & Beer', 1, 48.00, 48.0000, 0.0000, 48.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:23:44', 'admin-1505015850-1505021024236532', 1, 0, '', NULL, NULL, NULL),
(45770, '2017-09-10 13:26:57', NULL, NULL, 12797, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:26:57', 'admin-1505015850-15050212170731443', 1, 0, '', NULL, NULL, NULL),
(45771, '2017-09-10 13:23:18', NULL, NULL, 12797, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:23:18', 'admin-1505015850-15050209983097289', 1, 0, '', NULL, NULL, NULL),
(45772, '2017-09-10 10:21:13', NULL, NULL, 12777, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:21:13', 'admin-1505005586-15050100728568172', 1, 1, 'SR', NULL, NULL, NULL),
(45773, '2017-09-10 09:49:23', NULL, NULL, 12776, 0, 153, '87', 'Wake Me Up!', ' change to corn,no baked beans', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:49:23', 'admin-1505005586-15050081635377821', 1, 0, '', NULL, NULL, NULL),
(45774, '2017-09-10 13:23:18', NULL, NULL, 12797, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:23:18', 'admin-1505015850-15050209983097289', 1, 1, 'SR', NULL, NULL, NULL),
(45775, '2017-09-10 13:23:18', NULL, NULL, 12797, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:23:18', 'admin-1505015850-15050209983097289', 1, 1, 'SR', NULL, NULL, NULL),
(45776, '2017-09-10 13:23:18', NULL, NULL, 12797, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:23:18', 'admin-1505015850-15050209983097289', 1, 1, 'SR', NULL, NULL, NULL),
(45777, '2017-09-10 13:23:18', NULL, NULL, 12797, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:23:18', 'admin-1505015850-15050209983097289', 1, 1, 'SR', NULL, NULL, NULL),
(45778, '2017-09-10 13:22:44', NULL, NULL, 12797, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 23.00, 0.0000, 0.0000, 23.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:22:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45779, '2017-09-10 13:08:16', NULL, NULL, 12796, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:08:16', 'admin-1505015850-15050200960782772', 1, 1, 'SR', NULL, NULL, NULL),
(45780, '2017-09-10 14:18:56', NULL, NULL, 12799, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 14:18:56', 'admin-1505015850-15050243366242766', 1, 0, '', 1, NULL, NULL),
(45781, '2017-09-10 12:04:06', NULL, NULL, 12790, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:04:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45782, '2017-09-10 13:03:55', NULL, NULL, 12795, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:03:55', 'admin-1505015850-15050198351612560', 1, 1, 'SR', NULL, NULL, NULL),
(45783, '2017-09-10 13:03:33', NULL, NULL, 12795, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1505025773', 'admin', '2017-09-10 13:03:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45784, '2017-09-10 12:54:13', NULL, NULL, 12794, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:54:13', 'admin-1505015850-15050192535726521', 1, 0, '', NULL, NULL, NULL),
(45785, '2017-09-10 12:53:55', NULL, NULL, 12794, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:53:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45786, '2017-09-10 12:54:13', NULL, NULL, 12794, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:54:13', 'admin-1505015850-15050192535726521', 1, 1, 'SR', NULL, NULL, NULL),
(45787, '2017-09-10 09:48:53', NULL, NULL, 12776, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:48:53', 'admin-1505005586-15050081337333546', 1, 1, 'SR', NULL, NULL, NULL),
(45788, '2017-09-10 09:49:23', NULL, NULL, 12776, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:49:23', 'admin-1505005586-15050081635377821', 1, 0, '', NULL, NULL, NULL),
(45789, '2017-09-10 09:49:23', NULL, NULL, 12776, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:49:23', 'admin-1505005586-15050081635377821', 1, 0, '', NULL, NULL, NULL),
(45790, '2017-09-10 09:06:43', NULL, NULL, 12770, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:06:43', 'admin-1505005586-1505005603469409', 1, 0, '', NULL, NULL, NULL),
(45791, '2017-09-10 09:06:51', NULL, NULL, 12770, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:06:51', 'admin-1505005586-15050056113002184', 1, 0, '', NULL, NULL, NULL),
(45792, '2017-09-10 11:35:44', NULL, NULL, 12788, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:35:44', 'admin-1505011244-15050145444315255', 1, 0, '', NULL, NULL, NULL),
(45793, '2017-09-10 11:33:15', NULL, NULL, 12786, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:33:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45794, '2017-09-10 11:33:25', NULL, NULL, 12786, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:33:25', 'admin-1505011244-15050144051297254', 1, 0, '', NULL, NULL, NULL),
(45795, '2017-09-10 12:20:34', NULL, NULL, 12793, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:20:34', 'admin-1505015850-1505017233958648', 1, 1, 'SR', NULL, NULL, NULL),
(45796, '2017-09-10 12:20:34', NULL, NULL, 12793, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:20:34', 'admin-1505015850-1505017233958648', 1, 1, 'SR', NULL, NULL, NULL),
(45797, '2017-09-10 12:19:44', NULL, NULL, 12793, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:19:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45798, '2017-09-10 12:20:34', NULL, NULL, 12793, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:20:34', 'admin-1505015850-1505017233958648', 1, 0, '', NULL, NULL, NULL),
(45799, '2017-09-10 12:08:11', NULL, NULL, 12792, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:08:11', 'admin-1505015850-15050164917325088', 1, 0, '', NULL, NULL, NULL),
(45800, '2017-09-10 12:08:11', NULL, NULL, 12792, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:08:11', 'admin-1505015850-15050164917325088', 1, 0, '', NULL, NULL, NULL),
(45801, '2017-09-10 11:33:25', NULL, NULL, 12786, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:33:25', 'admin-1505011244-15050144051297254', 1, 0, '', NULL, NULL, NULL),
(45802, '2017-09-10 12:08:02', NULL, NULL, 12792, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:08:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45803, '2017-09-10 12:06:15', NULL, NULL, 12791, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:06:15', 'admin-1505015850-15050163750608555', 1, 1, 'SR', NULL, NULL, NULL),
(45804, '2017-09-10 12:06:15', NULL, NULL, 12791, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:06:15', 'admin-1505015850-15050163750608555', 1, 0, '', NULL, NULL, NULL),
(45805, '2017-09-10 12:06:15', NULL, NULL, 12791, 0, 77, '77', 'Sarawak Kolomee', 'no vegetables', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:06:15', 'admin-1505015850-15050163750608555', 1, 1, 'SR', NULL, NULL, NULL),
(45806, '2017-09-10 11:16:14', NULL, NULL, 12784, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:16:14', 'admin-1505011244-15050133739924344', 1, 0, '', NULL, NULL, NULL),
(45807, '2017-09-10 12:04:42', NULL, NULL, 12790, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:04:42', 'admin-1505015850-15050162827324843', 1, 1, 'SR', NULL, NULL, NULL),
(45808, '2017-09-10 12:04:42', NULL, NULL, 12790, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:04:42', 'admin-1505015850-15050162827324843', 1, 0, '', NULL, NULL, NULL),
(45809, '2017-09-10 12:04:42', NULL, NULL, 12790, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:04:42', 'admin-1505015850-15050162827324843', 1, 0, '', NULL, NULL, NULL),
(45810, '2017-09-10 11:57:24', NULL, NULL, 12789, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:57:24', 'admin-1505011244-1505015843911975', 1, 0, '', NULL, NULL, NULL),
(45811, '2017-09-10 11:57:24', NULL, NULL, 12789, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:57:24', 'admin-1505011244-1505015843911975', 1, 1, 'SR', NULL, NULL, NULL),
(45812, '2017-09-10 11:33:45', NULL, NULL, 12786, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:33:45', 'admin-1505011244-15050144252735561', 1, 0, '', NULL, NULL, NULL),
(45813, '2017-09-10 10:30:54', NULL, NULL, 12779, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:30:54', 'admin-1505005586-15050106542866949', 1, 0, '', NULL, NULL, NULL),
(45814, '2017-09-10 12:20:51', NULL, NULL, 12793, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:20:51', 'admin-1505015850-15050172508989024', 1, 0, '', NULL, NULL, NULL),
(45815, '2017-09-10 10:35:33', NULL, NULL, 12780, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.80, 0.0000, 0.0000, 13.80, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:35:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45816, '2017-09-10 10:35:49', NULL, NULL, 12780, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:35:49', 'admin-1505005586-15050109490007769', 1, 0, '', NULL, NULL, NULL),
(45817, '2017-09-10 10:35:49', NULL, NULL, 12780, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:35:49', 'admin-1505005586-15050109490007769', 1, 0, '', NULL, NULL, NULL),
(45818, '2017-09-10 10:35:49', NULL, NULL, 12780, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:35:49', 'admin-1505005586-15050109490007769', 1, 0, '', NULL, NULL, NULL),
(45819, '2017-09-10 10:35:49', NULL, NULL, 12780, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:35:49', 'admin-1505005586-15050109490007769', 1, 0, '', NULL, NULL, NULL),
(45820, '2017-09-10 10:35:49', NULL, NULL, 12780, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:35:49', 'admin-1505005586-15050109490007769', 1, 0, '', NULL, NULL, NULL),
(45821, '2017-09-10 10:35:49', NULL, NULL, 12780, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:35:49', 'admin-1505005586-15050109490007769', 1, 1, 'SR', NULL, NULL, NULL),
(45822, '2017-09-10 10:35:49', NULL, NULL, 12780, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:35:49', 'admin-1505005586-15050109490007769', 1, 1, 'SR', NULL, NULL, NULL),
(45823, '2017-09-10 10:35:49', NULL, NULL, 12780, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:35:49', 'admin-1505005586-15050109490007769', 1, 1, 'SR', NULL, NULL, NULL),
(45824, '2017-09-10 10:35:49', NULL, NULL, 12780, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:35:49', 'admin-1505005586-15050109490007769', 1, 1, 'SR', NULL, NULL, NULL),
(45825, '2017-09-10 10:51:10', NULL, NULL, 12781, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:51:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45826, '2017-09-10 10:51:24', NULL, NULL, 12781, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:51:24', 'admin-1505011244-15050118840545752', 1, 0, '', NULL, NULL, NULL),
(45827, '2017-09-10 11:08:29', NULL, NULL, 12783, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:08:29', 'admin-1505011244-15050129089645665', 1, 1, 'SR', NULL, NULL, NULL),
(45828, '2017-09-10 11:15:48', NULL, NULL, 12784, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:15:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45829, '2017-09-10 11:16:14', NULL, NULL, 12784, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:16:14', 'admin-1505011244-15050133739924344', 1, 0, '', NULL, NULL, NULL),
(45830, '2017-09-10 11:35:44', NULL, NULL, 12788, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:35:44', 'admin-1505011244-15050145444315255', 1, 1, 'SR', NULL, NULL, NULL),
(45831, '2017-09-10 11:35:10', NULL, NULL, 12787, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:35:10', 'admin-1505011244-15050145102464653', 1, 1, 'SR', NULL, NULL, NULL),
(45832, '2017-09-10 11:35:13', NULL, NULL, 12788, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:35:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45833, '2017-09-10 12:04:51', NULL, NULL, 12790, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:04:51', 'admin-1505015850-1505016291555289', 1, 1, 'SR', NULL, NULL, NULL),
(45834, '2017-09-10 12:04:57', NULL, NULL, 12791, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:04:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45835, '2017-09-10 10:29:53', NULL, NULL, 12778, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:29:53', 'admin-1505005586-15050105931312142', 1, 1, 'SR', NULL, NULL, NULL),
(45836, '2017-09-10 10:29:53', NULL, NULL, 12778, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:29:53', 'admin-1505005586-15050105931312142', 1, 1, 'SR', NULL, NULL, NULL),
(45837, '2017-09-10 10:30:27', NULL, NULL, 12779, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:30:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45838, '2017-09-10 10:30:46', NULL, NULL, 12779, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:30:46', 'admin-1505005586-15050106467937986', 1, 0, '', NULL, NULL, NULL),
(45839, '2017-09-10 10:30:46', NULL, NULL, 12779, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:30:46', 'admin-1505005586-15050106467937986', 1, 1, 'SR', NULL, NULL, NULL),
(45840, '2017-09-10 11:33:45', NULL, NULL, 12786, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:33:45', 'admin-1505011244-15050144252735561', 1, 1, 'SR', NULL, NULL, NULL),
(45841, '2017-09-10 11:27:51', NULL, NULL, 12785, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:27:51', 'admin-1505011244-15050140712389387', 1, 0, '', NULL, NULL, NULL),
(45842, '2017-09-10 11:16:14', NULL, NULL, 12784, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:16:14', 'admin-1505011244-15050133739924344', 1, 0, '', NULL, NULL, NULL),
(45843, '2017-09-10 11:27:27', NULL, NULL, 12785, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:27:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45844, '2017-09-10 11:08:21', NULL, NULL, 12783, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:08:21', 'admin-1505011244-15050129014453172', 1, 1, 'SR', NULL, NULL, NULL),
(45845, '2017-09-10 11:08:10', NULL, NULL, 12783, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:08:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45846, '2017-09-10 11:08:21', NULL, NULL, 12783, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 11:08:21', 'admin-1505011244-15050129014453172', 1, 0, '', NULL, NULL, NULL),
(45847, '2017-09-10 10:53:48', NULL, NULL, 12782, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:53:48', 'admin-1505011244-15050120285129581', 1, 0, '', NULL, NULL, NULL),
(45848, '2017-09-10 10:53:48', NULL, NULL, 12782, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:53:48', 'admin-1505011244-15050120285129581', 1, 1, 'SR', NULL, NULL, NULL),
(45849, '2017-09-10 10:53:48', NULL, NULL, 12782, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:53:48', 'admin-1505011244-15050120285129581', 1, 1, 'SR', NULL, NULL, NULL),
(45850, '2017-09-10 15:40:59', NULL, NULL, 12805, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 15:40:59', 'admin-1505025773-15050292593176077', 1, 0, '', NULL, NULL, NULL),
(45851, '2017-09-10 10:53:48', NULL, NULL, 12782, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:53:48', 'admin-1505011244-15050120285129581', 1, 0, '', NULL, NULL, NULL),
(45852, '2017-09-10 10:51:24', NULL, NULL, 12781, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:51:24', 'admin-1505011244-15050118840545752', 1, 1, 'SR', NULL, NULL, NULL),
(45853, '2017-09-10 10:52:30', NULL, NULL, 12782, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.90, 0.0000, 0.0000, 9.90, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:52:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45854, '2017-09-10 10:53:48', NULL, NULL, 12782, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:53:48', 'admin-1505011244-15050120285129581', 1, 0, '', NULL, NULL, NULL),
(45855, '2017-09-10 10:51:24', NULL, NULL, 12781, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:51:24', 'admin-1505011244-15050118840545752', 1, 1, 'SR', NULL, NULL, NULL),
(45856, '2017-09-10 09:51:28', NULL, NULL, 12773, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:51:28', 'admin-1505005586-15050082884756363', 1, 1, 'SR', NULL, NULL, NULL),
(45857, '2017-09-10 10:20:59', NULL, NULL, 12777, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:20:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45858, '2017-09-10 10:21:13', NULL, NULL, 12777, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:21:13', 'admin-1505005586-15050100728568172', 1, 0, '', NULL, NULL, NULL),
(45859, '2017-09-10 10:21:13', NULL, NULL, 12777, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:21:13', 'admin-1505005586-15050100728568172', 1, 0, '', NULL, NULL, NULL),
(45860, '2017-09-10 12:20:34', NULL, NULL, 12793, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 12:20:34', 'admin-1505015850-1505017233958648', 1, 0, '', NULL, NULL, NULL),
(45861, '2017-09-10 10:21:13', NULL, NULL, 12777, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:21:13', 'admin-1505005586-15050100728568172', 1, 0, '', NULL, NULL, NULL),
(45862, '2017-09-10 10:29:33', NULL, NULL, 12778, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:29:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45863, '2017-09-10 10:29:53', NULL, NULL, 12778, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 10:29:53', 'admin-1505005586-15050105931312142', 1, 0, '', NULL, NULL, NULL),
(45864, '2017-09-10 09:49:23', NULL, NULL, 12776, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:49:23', 'admin-1505005586-15050081635377821', 1, 0, '', NULL, NULL, NULL),
(45865, '2017-09-10 09:29:53', NULL, NULL, 12774, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:29:53', 'admin-1505005586-15050069929188027', 1, 1, 'SR', NULL, NULL, NULL),
(45866, '2017-09-10 09:36:14', NULL, NULL, 12771, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:36:14', 'admin-1505005586-1505007374773667', 1, 1, 'SR', NULL, NULL, NULL),
(45867, '2017-09-10 09:45:02', NULL, NULL, 12775, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:45:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45868, '2017-09-10 09:45:18', NULL, NULL, 12775, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:45:18', 'admin-1505005586-15050079182522275', 1, 0, '', NULL, NULL, NULL),
(45869, '2017-09-10 09:45:18', NULL, NULL, 12775, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:45:18', 'admin-1505005586-15050079182522275', 1, 0, '', NULL, NULL, NULL),
(45870, '2017-09-10 09:48:47', NULL, NULL, 12776, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.50, 0.0000, 0.0000, 14.50, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:48:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45871, '2017-09-10 09:48:53', NULL, NULL, 12776, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:48:53', 'admin-1505005586-15050081337333546', 1, 1, 'SR', NULL, NULL, NULL),
(45872, '2017-09-10 09:48:53', NULL, NULL, 12776, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:48:53', 'admin-1505005586-15050081337333546', 1, 1, 'SR', NULL, NULL, NULL),
(45873, '2017-09-10 09:48:53', NULL, NULL, 12776, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:48:53', 'admin-1505005586-15050081337333546', 1, 1, 'SR', NULL, NULL, NULL),
(45874, '2017-09-10 09:26:58', NULL, NULL, 12773, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:26:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45875, '2017-09-10 09:27:06', NULL, NULL, 12773, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:27:06', 'admin-1505005586-15050068266045583', 1, 0, '', NULL, NULL, NULL),
(45876, '2017-09-10 09:27:06', NULL, NULL, 12773, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:27:06', 'admin-1505005586-15050068266045583', 1, 0, '', NULL, NULL, NULL),
(45877, '2017-09-10 09:27:06', NULL, NULL, 12773, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:27:06', 'admin-1505005586-15050068266045583', 1, 1, 'SR', NULL, NULL, NULL),
(45878, '2017-09-10 09:29:39', NULL, NULL, 12774, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:29:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45879, '2017-09-10 09:29:53', NULL, NULL, 12774, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:29:53', 'admin-1505005586-15050069929188027', 1, 0, '', NULL, NULL, NULL),
(45880, '2017-09-10 09:29:53', NULL, NULL, 12774, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:29:53', 'admin-1505005586-15050069929188027', 1, 0, '', NULL, NULL, NULL),
(45881, '2017-09-10 09:48:53', NULL, NULL, 12776, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:48:53', 'admin-1505005586-15050081337333546', 1, 1, 'SR', NULL, NULL, NULL),
(45882, '2017-09-10 09:29:53', NULL, NULL, 12774, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:29:53', 'admin-1505005586-15050069929188027', 1, 1, 'SR', NULL, NULL, NULL),
(45883, '2017-09-10 09:26:13', NULL, NULL, 12772, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:26:13', 'admin-1505005586-15050067738131839', 1, 1, 'SR', NULL, NULL, NULL),
(45884, '2017-09-10 09:26:13', NULL, NULL, 12772, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:26:13', 'admin-1505005586-15050067738131839', 1, 0, '', NULL, NULL, NULL),
(45885, '2017-09-10 09:18:49', NULL, NULL, 12771, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:18:49', 'admin-1505005586-15050063294699551', 1, 1, 'SR', NULL, NULL, NULL),
(45886, '2017-09-10 09:18:49', NULL, NULL, 12771, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:18:49', 'admin-1505005586-15050063294699551', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(45887, '2017-09-10 09:25:53', NULL, NULL, 12772, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:25:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45888, '2017-09-10 09:26:13', NULL, NULL, 12772, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:26:13', 'admin-1505005586-15050067738131839', 1, 0, '', NULL, NULL, NULL),
(45889, '2017-09-10 09:26:13', NULL, NULL, 12772, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:26:13', 'admin-1505005586-15050067738131839', 1, 0, '', NULL, NULL, NULL),
(45890, '2017-09-10 09:18:49', NULL, NULL, 12771, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:18:49', 'admin-1505005586-15050063294699551', 1, 1, 'SR', NULL, NULL, NULL),
(45891, '2017-09-10 09:18:36', NULL, NULL, 12771, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:18:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45892, '2017-09-10 09:06:34', NULL, NULL, 12770, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1505025773', 'admin', '2017-09-10 09:06:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45893, '2017-09-11 14:46:27', NULL, NULL, 12842, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 14:46:27', 'admin-1505109385-15051123870315581', 1, 1, 'SR', NULL, NULL, NULL),
(45894, '2017-09-11 12:25:18', NULL, NULL, 12828, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:25:18', 'admin-1505102471-15051039178606052', 1, 1, 'SR', NULL, NULL, NULL),
(45895, '2017-09-11 11:19:14', NULL, NULL, 12817, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:19:14', 'admin-1505099080-15050999543551679', 1, 0, '', NULL, NULL, NULL),
(45896, '2017-09-11 11:25:03', NULL, NULL, 12823, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:25:03', 'admin-1505099080-15051003038108976', 1, 1, 'SR', NULL, NULL, NULL),
(45897, '2017-09-11 11:25:03', NULL, NULL, 12823, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:25:03', 'admin-1505099080-15051003038108976', 1, 1, 'SR', NULL, NULL, NULL),
(45898, '2017-09-11 13:24:54', NULL, NULL, 12837, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:24:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45899, '2017-09-11 13:11:57', NULL, NULL, 12833, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:11:57', 'admin-1505102471-1505106717095887', 1, 0, '', NULL, NULL, '10.0'),
(45900, '2017-09-11 13:20:45', NULL, NULL, 12834, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:20:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45901, '2017-09-11 13:21:10', NULL, NULL, 12834, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:21:10', 'admin-1505106729-15051072707666666', 1, 0, '', NULL, NULL, NULL),
(45902, '2017-09-11 13:49:55', NULL, NULL, 12835, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:49:55', 'admin-1505106729-1505108995631806', 1, 1, 'SR', NULL, NULL, NULL),
(45903, '2017-09-11 13:50:55', NULL, NULL, 12829, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:50:55', 'admin-1505106729-15051090551263166', 1, 1, 'SR', NULL, NULL, NULL),
(45904, '2017-09-11 13:56:20', NULL, NULL, 12834, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:56:20', 'admin-1505106729-15051093802624494', 1, 0, '', NULL, NULL, NULL),
(45905, '2017-09-11 11:31:49', NULL, NULL, 12823, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:31:49', 'admin-1505099080-1505100709783477', 1, 0, '', NULL, NULL, NULL),
(45906, '2017-09-11 12:46:38', NULL, NULL, 12830, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:46:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45907, '2017-09-11 12:46:53', NULL, NULL, 12830, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:46:53', 'admin-1505102471-15051052137273324', 1, 0, '', NULL, NULL, NULL),
(45908, '2017-09-11 13:06:53', NULL, NULL, 12830, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:06:53', 'admin-1505102471-15051064136875255', 1, 0, '', NULL, NULL, NULL),
(45909, '2017-09-11 12:46:53', NULL, NULL, 12830, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:46:53', 'admin-1505102471-15051052137273324', 1, 1, 'SR', NULL, NULL, NULL),
(45910, '2017-09-11 12:46:53', NULL, NULL, 12830, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:46:53', 'admin-1505102471-15051052137273324', 1, 1, 'SR', NULL, NULL, NULL),
(45911, '2017-09-11 12:49:23', NULL, NULL, 12831, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:49:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45912, '2017-09-11 12:49:44', NULL, NULL, 12831, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:49:44', 'admin-1505102471-1505105384210986', 1, 1, 'SR', NULL, NULL, NULL),
(45913, '2017-09-11 12:49:44', NULL, NULL, 12831, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:49:44', 'admin-1505102471-1505105384210986', 1, 0, '', NULL, NULL, NULL),
(45914, '2017-09-11 12:50:17', NULL, NULL, 12831, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:50:17', 'admin-1505102471-15051054173426290', 1, 1, 'SR', NULL, NULL, NULL),
(45915, '2017-09-11 12:50:17', NULL, NULL, 12831, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:50:17', 'admin-1505102471-15051054173426290', 1, 1, 'SR', NULL, NULL, NULL),
(45916, '2017-09-11 12:51:38', NULL, NULL, 12832, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:51:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45917, '2017-09-11 10:07:34', NULL, NULL, 12815, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:07:34', 'lois-1505091452-15050956547493554', 1, 1, 'SR', NULL, NULL, NULL),
(45918, '2017-09-11 09:15:07', NULL, NULL, 12810, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:15:07', 'lois-1505091452-1505092506774656', 1, 1, 'SR', NULL, NULL, NULL),
(45919, '2017-09-11 09:17:42', NULL, NULL, 12811, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:17:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45920, '2017-09-11 09:17:53', NULL, NULL, 12811, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:17:53', 'lois-1505091452-1505092673654720', 1, 1, 'SR', NULL, NULL, NULL),
(45921, '2017-09-11 09:17:53', NULL, NULL, 12811, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:17:53', 'lois-1505091452-1505092673654720', 1, 1, 'SR', NULL, NULL, NULL),
(45922, '2017-09-11 10:57:30', NULL, NULL, 12820, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:57:30', 'lois-1505091452-15050986505965364', 1, 0, '', NULL, NULL, NULL),
(45923, '2017-09-11 11:04:22', NULL, NULL, 12822, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 11:04:22', 'lois-1505091452-15050990623702847', 1, 0, '', NULL, NULL, NULL),
(45924, '2017-09-11 11:04:22', NULL, NULL, 12822, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 11:04:22', 'lois-1505091452-15050990623702847', 1, 1, 'SR', NULL, NULL, NULL),
(45925, '2017-09-11 14:46:10', NULL, NULL, 12842, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1505109385', 'admin', '2017-09-11 14:46:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45926, '2017-09-11 14:46:27', NULL, NULL, 12842, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 14:46:27', 'admin-1505109385-15051123870315581', 1, 1, 'SR', NULL, NULL, NULL),
(45927, '2017-09-11 14:46:27', NULL, NULL, 12842, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 14:46:27', 'admin-1505109385-15051123870315581', 1, 1, 'SR', NULL, NULL, NULL),
(45928, '2017-09-11 11:46:45', NULL, NULL, 12825, 0, 155, '89', 'Cheesy Chicken Gratin', ' change to mashed potato,No salad', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:46:45', 'admin-1505099080-15051016054628174', 1, 0, '', NULL, NULL, NULL),
(45929, '2017-09-11 14:46:51', NULL, NULL, 12843, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 14:46:51', 'admin-1505109385-15051124110158190', 1, 1, 'SR', NULL, NULL, NULL),
(45930, '2017-09-11 14:46:51', NULL, NULL, 12843, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 14:46:51', 'admin-1505109385-15051124110158190', 1, 0, '', NULL, NULL, NULL),
(45931, '2017-09-11 15:05:55', NULL, NULL, 12844, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1505109385', 'admin', '2017-09-11 15:05:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45932, '2017-09-11 15:06:07', NULL, NULL, 12844, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 15:06:07', 'admin-1505109385-15051135669033199', 1, 0, '', NULL, NULL, NULL),
(45933, '2017-09-11 11:31:49', NULL, NULL, 12823, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:31:49', 'admin-1505099080-1505100709783477', 1, 1, 'SR', NULL, NULL, NULL),
(45934, '2017-09-11 13:46:48', NULL, NULL, 12839, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:46:48', 'admin-1505106729-15051088086648526', 1, 0, '', NULL, NULL, NULL),
(45935, '2017-09-11 13:46:48', NULL, NULL, 12839, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:46:48', 'admin-1505106729-15051088086648526', 1, 0, '', NULL, NULL, NULL),
(45936, '2017-09-11 11:14:14', NULL, NULL, 12822, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:14:14', 'admin-1505099080-15050996540881986', 1, 0, '', NULL, NULL, NULL),
(45937, '2017-09-11 10:59:15', NULL, NULL, 12821, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:59:15', 'lois-1505091452-1505098755384271', 1, 1, 'SR', NULL, NULL, NULL),
(45938, '2017-09-11 16:43:50', NULL, NULL, 12847, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1505109385', 'admin', '2017-09-11 16:43:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45939, '2017-09-11 16:43:54', NULL, NULL, 12847, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 16:43:54', 'admin-1505109385-1505119433897219', 1, 1, 'SR', NULL, NULL, NULL),
(45940, '2017-09-11 16:23:36', NULL, NULL, 12846, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 16:23:36', 'admin-1505109385-15051182158705958', 1, 1, 'SR', NULL, NULL, NULL),
(45941, '2017-09-11 15:36:27', NULL, NULL, 12846, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1505109385', 'admin', '2017-09-11 15:36:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45942, '2017-09-11 15:36:34', NULL, NULL, 12846, 0, 162, '96', 'Homemade Chicken Bite ', '', 'Meals', 'Snacks ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 15:36:34', 'admin-1505109385-15051153946072399', 1, 0, '', NULL, NULL, NULL),
(45943, '2017-09-11 15:36:34', NULL, NULL, 12846, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 15:36:34', 'admin-1505109385-15051153946072399', 1, 1, 'SR', NULL, NULL, NULL),
(45944, '2017-09-11 15:26:25', NULL, NULL, 12835, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 15:26:25', 'admin-1505109385-15051147853009674', 1, 0, '', NULL, NULL, NULL),
(45945, '2017-09-11 15:15:58', NULL, NULL, 12845, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 3.50, 3.5000, 0.0000, 3.50, 1, '27', 1, '1505109385', 'admin', '2017-09-11 15:15:58', 'admin-1505109385-15051141585053725', 1, 0, '', 1, NULL, NULL),
(45946, '2017-09-11 15:15:58', NULL, NULL, 12845, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 3.50, 3.5000, 0.0000, 3.50, 1, '27', 1, '1505109385', 'admin', '2017-09-11 15:15:58', 'admin-1505109385-15051141585053725', 1, 0, '', 1, NULL, NULL),
(45947, '2017-09-11 13:41:08', NULL, NULL, 12832, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:41:08', 'admin-1505106729-1505108468352951', 1, 1, 'SR', NULL, NULL, NULL),
(45948, '2017-09-11 13:40:31', NULL, NULL, 12835, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:40:31', 'admin-1505106729-1505108430819232', 1, 0, '', NULL, NULL, NULL),
(45949, '2017-09-11 15:06:28', NULL, NULL, 12835, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 15:06:28', 'admin-1505109385-1505113588231792', 1, 0, '', NULL, NULL, NULL),
(45950, '2017-09-11 15:06:07', NULL, NULL, 12844, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 15:06:07', 'admin-1505109385-15051135669033199', 1, 1, 'SR', NULL, NULL, NULL),
(45951, '2017-09-11 14:14:40', NULL, NULL, 12840, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1505109385', 'admin', '2017-09-11 14:14:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45952, '2017-09-11 14:14:49', NULL, NULL, 12840, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 14:14:49', 'admin-1505109385-1505110488973655', 1, 1, 'SR', NULL, NULL, NULL),
(45953, '2017-09-11 14:14:49', NULL, NULL, 12840, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 14:14:49', 'admin-1505109385-1505110488973655', 1, 1, 'SR', NULL, NULL, NULL),
(45954, '2017-09-11 14:15:22', NULL, NULL, 12841, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1505109385', 'admin', '2017-09-11 14:15:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45955, '2017-09-11 14:46:29', NULL, NULL, 12843, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1505109385', 'admin', '2017-09-11 14:46:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45956, '2017-09-11 14:46:51', NULL, NULL, 12843, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 14:46:51', 'admin-1505109385-15051124110158190', 1, 1, 'SR', NULL, NULL, NULL),
(45957, '2017-09-11 11:46:51', NULL, NULL, 12825, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:46:51', 'admin-1505099080-15051016117088023', 1, 1, 'SR', NULL, NULL, NULL),
(45958, '2017-09-11 10:53:41', NULL, NULL, 12818, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:53:41', 'lois-1505091452-15050984208889033', 1, 0, '', NULL, NULL, NULL),
(45959, '2017-09-11 14:46:27', NULL, NULL, 12842, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 14:46:27', 'admin-1505109385-15051123870315581', 1, 1, 'SR', NULL, NULL, NULL),
(45960, '2017-09-11 14:15:28', NULL, NULL, 12841, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 14:15:28', 'admin-1505109385-15051105279546936', 1, 0, '', NULL, NULL, NULL),
(45961, '2017-09-11 14:15:28', NULL, NULL, 12841, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 14:15:28', 'admin-1505109385-15051105279546936', 1, 1, 'SR', NULL, NULL, NULL),
(45962, '2017-09-11 13:25:33', NULL, NULL, 12837, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:25:33', 'admin-1505106729-15051075330669075', 1, 0, '', NULL, NULL, NULL),
(45963, '2017-09-11 13:21:10', NULL, NULL, 12834, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:21:10', 'admin-1505106729-15051072707666666', 1, 0, '', NULL, NULL, NULL),
(45964, '2017-09-11 13:49:55', NULL, NULL, 12835, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:49:55', 'admin-1505106729-1505108995631806', 1, 1, 'SR', NULL, NULL, NULL),
(45965, '2017-09-11 13:46:39', NULL, NULL, 12839, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:46:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45966, '2017-09-11 13:44:06', NULL, NULL, 12829, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:44:06', 'admin-1505106729-15051086467408395', 1, 1, 'SR', NULL, NULL, NULL),
(45967, '2017-09-11 13:44:06', NULL, NULL, 12829, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:44:06', 'admin-1505106729-15051086467408395', 1, 1, 'SR', NULL, NULL, NULL),
(45968, '2017-09-11 13:34:43', NULL, NULL, 12833, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:34:43', 'admin-1505106729-15051080830379799', 1, 0, '', NULL, NULL, '10.0'),
(45969, '2017-09-11 13:36:24', NULL, NULL, 12835, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:36:24', 'admin-1505106729-1505108184588623', 1, 0, '', NULL, NULL, NULL),
(45970, '2017-09-11 13:34:47', NULL, NULL, 12833, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:34:48', 'admin-1505106729-15051080878199673', 1, 1, 'SR', NULL, NULL, '10.0'),
(45971, '2017-09-11 13:33:23', NULL, NULL, 12838, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:33:23', 'admin-1505106729-1505108003490554', 1, 1, 'SR', NULL, NULL, NULL),
(45972, '2017-09-11 13:33:16', NULL, NULL, 12838, 0, 156, '90', 'House Cheddar Omelet', 'add bacon', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:33:16', 'admin-1505106729-15051079964195275', 1, 0, '', NULL, NULL, NULL),
(45973, '2017-09-11 13:33:04', NULL, NULL, 12838, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:33:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45974, '2017-09-11 11:41:02', NULL, NULL, 12824, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:41:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45975, '2017-09-11 11:41:33', NULL, NULL, 12824, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:41:33', 'admin-1505099080-15051012934117622', 1, 0, '', NULL, NULL, NULL),
(45976, '2017-09-11 11:41:33', NULL, NULL, 12824, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:41:33', 'admin-1505099080-15051012934117622', 1, 0, '', NULL, NULL, NULL),
(45977, '2017-09-11 11:44:44', NULL, NULL, 12824, 0, 181, '116', 'Open Food ', 'breakfast potato', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:44:44', 'admin-1505099080-15051014841596553', 1, 0, '', NULL, NULL, NULL),
(45978, '2017-09-11 11:41:38', NULL, NULL, 12824, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:41:38', 'admin-1505099080-15051012984049647', 1, 1, 'SR', NULL, NULL, NULL),
(45979, '2017-09-11 11:45:34', NULL, NULL, 12825, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:45:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45980, '2017-09-11 11:45:41', NULL, NULL, 12825, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:45:41', 'admin-1505099080-15051015414512660', 1, 0, '', NULL, NULL, NULL),
(45981, '2017-09-11 13:11:12', NULL, NULL, 12833, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:11:12', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(45982, '2017-09-11 13:23:20', NULL, NULL, 12836, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:23:20', 'admin-1505106729-15051073999303267', 1, 1, 'SR', NULL, NULL, '10.0'),
(45983, '2017-09-11 12:51:43', NULL, NULL, 12832, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:51:43', 'admin-1505102471-1505105503217523', 1, 1, 'SR', NULL, NULL, NULL),
(45984, '2017-09-11 13:23:10', NULL, NULL, 12836, 0, 73, '73', 'Marmite Chicken ', 'Pasta', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:23:10', 'admin-1505106729-15051073905987570', 1, 1, 'SR', NULL, NULL, '10.0'),
(45985, '2017-09-11 13:23:03', NULL, NULL, 12836, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:23:03', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(45986, '2017-09-11 13:21:18', NULL, NULL, 12835, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:21:18', 'admin-1505106729-15051072783882011', 1, 0, '', NULL, NULL, NULL),
(45987, '2017-09-11 11:52:35', NULL, NULL, 12826, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:52:35', 'admin-1505099080-15051019554256848', 1, 0, '', NULL, NULL, NULL),
(45988, '2017-09-11 11:52:35', NULL, NULL, 12826, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:52:35', 'admin-1505099080-15051019554256848', 1, 1, 'SR', NULL, NULL, NULL),
(45989, '2017-09-11 11:52:35', NULL, NULL, 12826, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:52:35', 'admin-1505099080-15051019554256848', 1, 1, 'SR', NULL, NULL, NULL),
(45990, '2017-09-11 14:46:27', NULL, NULL, 12842, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 14:46:27', 'admin-1505109385-15051123870315581', 1, 1, 'SR', NULL, NULL, NULL),
(45991, '2017-09-11 13:21:15', NULL, NULL, 12835, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:21:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45992, '2017-09-11 13:21:10', NULL, NULL, 12834, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:21:10', 'admin-1505106729-15051072707666666', 1, 0, '', NULL, NULL, NULL),
(45993, '2017-09-11 13:11:31', NULL, NULL, 12833, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:11:31', 'admin-1505102471-15051066915795959', 1, 0, '', NULL, NULL, '10.0'),
(45994, '2017-09-11 13:11:31', NULL, NULL, 12833, NULL, 65, '65', 'Pineapple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:11:31', 'admin-1505102471-15051066915795959', 1, 1, 'SR', NULL, NULL, '10.0'),
(45995, '2017-09-11 11:49:45', NULL, NULL, 12826, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.50, 0.0000, 0.0000, 12.50, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:49:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(45996, '2017-09-11 12:46:02', NULL, NULL, 12829, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:46:02', 'admin-1505102471-15051051618997990', 1, 0, '', NULL, NULL, NULL),
(45997, '2017-09-11 12:46:02', NULL, NULL, 12829, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:46:02', 'admin-1505102471-15051051618997990', 1, 1, 'SR', NULL, NULL, NULL),
(45998, '2017-09-11 12:46:02', NULL, NULL, 12829, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:46:02', 'admin-1505102471-15051051618997990', 1, 1, 'SR', NULL, NULL, NULL),
(45999, '2017-09-11 12:46:02', NULL, NULL, 12829, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:46:02', 'admin-1505102471-15051051618997990', 1, 0, '', NULL, NULL, NULL),
(46000, '2017-09-11 12:46:02', NULL, NULL, 12829, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:46:02', 'admin-1505102471-15051051618997990', 1, 1, 'SR', NULL, NULL, NULL),
(46001, '2017-09-11 12:45:12', NULL, NULL, 12829, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.80, 0.0000, 0.0000, 9.80, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:45:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46002, '2017-09-11 12:39:25', NULL, NULL, 12828, 0, 75, '75', 'Meatless Aglio Olio ', 'Takeaway,extra spicy', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:39:25', 'admin-1505102471-15051047654507729', 1, 0, '', NULL, NULL, NULL),
(46003, '2017-09-11 12:25:23', NULL, NULL, 12828, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:25:23', 'admin-1505102471-15051039233295961', 1, 1, 'SR', NULL, NULL, NULL),
(46004, '2017-09-11 12:25:23', NULL, NULL, 12828, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:25:23', 'admin-1505102471-15051039233295961', 1, 1, 'SR', NULL, NULL, NULL),
(46005, '2017-09-11 10:49:35', NULL, NULL, 12817, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:49:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46006, '2017-09-11 10:07:34', NULL, NULL, 12815, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:07:34', 'lois-1505091452-15050956547493554', 1, 0, '', NULL, NULL, NULL),
(46007, '2017-09-11 11:18:26', NULL, NULL, 12821, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:18:26', 'admin-1505099080-15050999060852922', 1, 0, '', NULL, NULL, NULL),
(46008, '2017-09-11 11:18:26', NULL, NULL, 12821, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:18:26', 'admin-1505099080-15050999060852922', 1, 0, '', NULL, NULL, NULL),
(46009, '2017-09-11 11:18:26', NULL, NULL, 12821, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:18:26', 'admin-1505099080-15050999060852922', 1, 1, 'SR', NULL, NULL, NULL),
(46010, '2017-09-11 12:25:18', NULL, NULL, 12828, 0, 75, '75', 'Meatless Aglio Olio ', 'extra spicy', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:25:18', 'admin-1505102471-15051039178606052', 1, 0, '', NULL, NULL, NULL),
(46011, '2017-09-11 12:25:00', NULL, NULL, 12828, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:25:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46012, '2017-09-11 12:08:50', NULL, NULL, 12826, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 2, 17.00, 34.0000, 0.0000, 34.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:08:50', 'admin-1505102471-15051029307799850', 1, 0, '', NULL, NULL, NULL),
(46013, '2017-09-11 00:00:00', NULL, NULL, 12827, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, NULL, NULL, 1.50, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:19:33', 'admin-1505099080-15050999731452058', 1, 0, '', NULL, NULL, NULL),
(46014, '2017-09-11 11:50:07', NULL, NULL, 12826, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:50:07', 'admin-1505099080-15051018075523837', 1, 1, 'SR', NULL, NULL, NULL),
(46015, '2017-09-11 11:50:07', NULL, NULL, 12826, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:50:07', 'admin-1505099080-15051018075523837', 1, 0, '', NULL, NULL, NULL),
(46016, '2017-09-11 11:50:07', NULL, NULL, 12826, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:50:07', 'admin-1505099080-15051018075523837', 1, 0, '', NULL, NULL, NULL),
(46017, '2017-09-11 11:50:07', NULL, NULL, 12826, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:50:07', 'admin-1505099080-15051018075523837', 1, 0, '', NULL, NULL, NULL),
(46018, '2017-09-11 11:04:12', NULL, NULL, 12822, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1505109385', 'lois', '2017-09-11 11:04:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46019, '2017-09-11 13:04:48', NULL, NULL, 12830, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:04:48', 'admin-1505102471-1505106288203591', 1, 0, '', NULL, NULL, NULL),
(46020, '2017-09-11 11:45:41', NULL, NULL, 12825, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:45:41', 'admin-1505099080-15051015414512660', 1, 0, '', NULL, NULL, NULL),
(46021, '2017-09-11 10:59:15', NULL, NULL, 12821, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:59:15', 'lois-1505091452-1505098755384271', 1, 1, 'SR', NULL, NULL, NULL),
(46022, '2017-09-11 11:14:14', NULL, NULL, 12822, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:14:14', 'admin-1505099080-15050996540881986', 1, 0, '', NULL, NULL, NULL),
(46023, '2017-09-11 10:54:19', NULL, NULL, 12819, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:54:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46024, '2017-09-11 10:54:28', NULL, NULL, 12819, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:54:28', 'lois-1505091452-15050984683437217', 1, 1, 'SR', NULL, NULL, NULL),
(46025, '2017-09-11 12:01:21', NULL, NULL, 12827, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.25, 0.0000, 0.0000, 1.25, 1, '27', 1, '1505109385', 'admin', '2017-09-11 12:01:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46026, '2017-09-11 11:13:23', NULL, NULL, 12821, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:13:23', 'admin-1505099080-15050996034871683', 1, 1, 'SR', NULL, NULL, NULL),
(46027, '2017-09-11 00:00:00', NULL, NULL, 12827, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 11:04:37', 'lois-1505091452-15050990732814989', 1, 1, 'SR', NULL, NULL, NULL),
(46028, '2017-09-11 11:24:52', NULL, NULL, 12823, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:24:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46029, '2017-09-11 10:58:41', NULL, NULL, 12821, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.10, 0.0000, 0.0000, 13.10, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:58:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46030, '2017-09-11 10:59:15', NULL, NULL, 12821, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:59:15', 'lois-1505091452-1505098755384271', 1, 0, '', NULL, NULL, NULL),
(46031, '2017-09-11 10:59:15', NULL, NULL, 12821, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:59:15', 'lois-1505091452-1505098755384271', 1, 0, '', NULL, NULL, NULL),
(46032, '2017-09-11 10:59:15', NULL, NULL, 12821, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:59:15', 'lois-1505091452-1505098755384271', 1, 1, 'SR', NULL, NULL, NULL),
(46033, '2017-09-11 10:50:05', NULL, NULL, 12817, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:50:05', 'lois-1505091452-15050982050676338', 1, 0, '', NULL, NULL, NULL),
(46034, '2017-09-11 10:53:34', NULL, NULL, 12818, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:53:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46035, '2017-09-11 09:52:59', NULL, NULL, 12814, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:52:59', 'lois-1505091452-15050947788022623', 1, 1, 'SR', NULL, NULL, NULL),
(46036, '2017-09-11 10:07:25', NULL, NULL, 12815, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:07:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46037, '2017-09-11 10:07:34', NULL, NULL, 12815, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:07:34', 'lois-1505091452-15050956547493554', 1, 0, '', NULL, NULL, NULL),
(46038, '2017-09-11 13:25:33', NULL, NULL, 12837, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 13:25:33', 'admin-1505106729-15051075330669075', 1, 0, '', NULL, NULL, NULL),
(46039, '2017-09-11 10:57:30', NULL, NULL, 12820, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:57:30', 'lois-1505091452-15050986505965364', 1, 1, 'SR', NULL, NULL, NULL),
(46040, '2017-09-11 10:57:30', NULL, NULL, 12820, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:57:30', 'lois-1505091452-15050986505965364', 1, 1, 'SR', NULL, NULL, NULL),
(46041, '2017-09-11 10:57:30', NULL, NULL, 12820, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:57:30', 'lois-1505091452-15050986505965364', 1, 0, '', NULL, NULL, NULL),
(46042, '2017-09-11 10:56:55', NULL, NULL, 12820, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:56:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46043, '2017-09-11 10:50:05', NULL, NULL, 12817, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:50:05', 'lois-1505091452-15050982050676338', 1, 1, 'SR', NULL, NULL, NULL),
(46044, '2017-09-11 11:48:15', NULL, NULL, 12822, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505109385', 'admin', '2017-09-11 11:48:15', 'admin-1505099080-15051016949278160', 1, 0, '', NULL, NULL, NULL),
(46045, '2017-09-11 10:49:48', NULL, NULL, 12817, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:49:48', 'lois-1505091452-1505098188361164', 1, 0, '', NULL, NULL, NULL),
(46046, '2017-09-11 09:15:07', NULL, NULL, 12810, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:15:07', 'lois-1505091452-1505092506774656', 1, 0, '', NULL, NULL, NULL),
(46047, '2017-09-11 10:49:48', NULL, NULL, 12817, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:49:48', 'lois-1505091452-1505098188361164', 1, 0, '', NULL, NULL, NULL),
(46048, '2017-09-11 10:49:48', NULL, NULL, 12817, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:49:48', 'lois-1505091452-1505098188361164', 1, 0, '', NULL, NULL, NULL),
(46049, '2017-09-11 10:22:01', NULL, NULL, 12816, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:22:01', 'lois-1505091452-15050965213203693', 1, 0, '', NULL, NULL, NULL),
(46050, '2017-09-11 10:22:01', NULL, NULL, 12816, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:22:01', 'lois-1505091452-15050965213203693', 1, 0, '', NULL, NULL, NULL),
(46051, '2017-09-11 10:21:57', NULL, NULL, 12816, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1505109385', 'lois', '2017-09-11 10:21:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46052, '2017-09-11 09:23:26', NULL, NULL, 12812, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:23:26', 'lois-1505091452-15050930064248735', 1, 0, '', NULL, NULL, NULL),
(46053, '2017-09-11 09:27:19', NULL, NULL, 12813, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:27:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46054, '2017-09-11 09:27:27', NULL, NULL, 12813, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:27:27', 'lois-1505091452-15050932474467151', 1, 0, '', NULL, NULL, NULL),
(46055, '2017-09-11 09:27:27', NULL, NULL, 12813, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:27:27', 'lois-1505091452-15050932474467151', 1, 0, '', NULL, NULL, NULL),
(46056, '2017-09-11 09:27:40', NULL, NULL, 12813, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:27:40', 'lois-1505091452-15050932601908463', 1, 1, 'SR', NULL, NULL, NULL),
(46057, '2017-09-11 09:27:40', NULL, NULL, 12813, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:27:40', 'lois-1505091452-15050932601908463', 1, 1, 'SR', NULL, NULL, NULL),
(46058, '2017-09-11 09:52:44', NULL, NULL, 12814, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:52:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46059, '2017-09-11 09:52:58', NULL, NULL, 12814, 0, 296, '232', 'Classic Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:52:58', 'lois-1505091452-15050947788022623', 1, 0, '', NULL, NULL, NULL),
(46060, '2017-09-11 09:17:53', NULL, NULL, 12811, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:17:53', 'lois-1505091452-1505092673654720', 1, 0, '', NULL, NULL, NULL),
(46061, '2017-09-11 09:17:53', NULL, NULL, 12811, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:17:53', 'lois-1505091452-1505092673654720', 1, 1, 'SR', NULL, NULL, NULL),
(46062, '2017-09-11 09:23:12', NULL, NULL, 12812, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:23:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46063, '2017-09-11 09:23:26', NULL, NULL, 12812, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:23:26', 'lois-1505091452-15050930064248735', 1, 0, '', NULL, NULL, NULL),
(46064, '2017-09-11 09:23:26', NULL, NULL, 12812, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:23:26', 'lois-1505091452-15050930064248735', 1, 0, '', NULL, NULL, NULL),
(46065, '2017-09-11 09:23:26', NULL, NULL, 12812, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:23:26', 'lois-1505091452-15050930064248735', 1, 1, 'SR', NULL, NULL, NULL),
(46066, '2017-09-11 09:15:07', NULL, NULL, 12810, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:15:07', 'lois-1505091452-1505092506774656', 1, 0, '', NULL, NULL, NULL),
(46067, '2017-09-11 09:15:07', NULL, NULL, 12810, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:15:07', 'lois-1505091452-1505092506774656', 1, 1, 'SR', NULL, NULL, NULL),
(46068, '2017-09-11 09:14:49', NULL, NULL, 12810, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1505109385', 'lois', '2017-09-11 09:14:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46069, '2017-09-13 11:00:43', NULL, NULL, 12853, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 11:00:43', 'admin-1505264071-15052716433166823', 1, 1, 'SR', NULL, NULL, NULL),
(46070, '2017-09-13 12:22:19', NULL, NULL, 12857, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 12:22:19', 'admin-1505264071-15052765388323771', 1, 0, '', NULL, NULL, NULL),
(46071, '2017-09-13 17:20:20', NULL, NULL, 12866, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 17:20:20', 'admin-1505276547-15052944203501713', 1, 0, '', NULL, NULL, '10.0');
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(46072, '2017-09-13 17:22:35', NULL, NULL, 12867, 0, 182, '117', 'Open Drinks ', 'Ginger Cucumber Lemon Soda', 'Cold Drinks', 'Fresh Juice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 17:22:35', 'admin-1505276547-1505294555737324', 1, 0, '', NULL, NULL, NULL),
(46073, '2017-09-13 11:40:02', NULL, NULL, 12856, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 11:40:02', 'admin-1505264071-1505274002357150', 1, 1, 'SR', NULL, NULL, NULL),
(46074, '2017-09-13 13:12:22', NULL, NULL, 12860, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1505276547', 'admin', '2017-09-13 13:12:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46075, '2017-09-13 13:12:25', NULL, NULL, 12860, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 13:12:25', 'admin-1505276547-15052795455406869', 1, 0, '', NULL, NULL, NULL),
(46076, '2017-09-13 13:23:10', NULL, NULL, 12860, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 13:23:10', 'admin-1505276547-15052801903146124', 1, 0, '', NULL, NULL, NULL),
(46077, '2017-09-13 13:50:36', NULL, NULL, 12860, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 13:50:36', 'admin-1505276547-15052818360373455', 1, 0, '', NULL, NULL, NULL),
(46078, '2017-09-13 14:44:58', NULL, NULL, 12863, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 14:44:58', 'admin-1505276547-15052850986672724', 1, 1, 'SR', NULL, NULL, NULL),
(46079, '2017-09-13 14:01:04', NULL, NULL, 12862, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 14:01:04', 'admin-1505276547-1505282464124350', 1, 1, 'SR', 1, NULL, NULL),
(46080, '2017-09-13 14:12:09', NULL, NULL, 12860, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 14:12:09', 'admin-1505276547-15052831293009477', 1, 1, 'SR', NULL, NULL, NULL),
(46081, '2017-09-13 14:12:09', NULL, NULL, 12860, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 14:12:09', 'admin-1505276547-15052831293009477', 1, 1, 'SR', NULL, NULL, NULL),
(46082, '2017-09-13 14:15:02', NULL, NULL, 12860, 0, 181, '116', 'Open Food ', 'croissant', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 14:15:02', 'admin-1505276547-15052833026849592', 1, 0, '', NULL, NULL, NULL),
(46083, '2017-09-13 14:41:51', NULL, NULL, 12863, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1505276547', 'admin', '2017-09-13 14:41:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46084, '2017-09-13 14:44:58', NULL, NULL, 12863, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 14:44:58', 'admin-1505276547-15052850986672724', 1, 1, 'SR', NULL, NULL, NULL),
(46085, '2017-09-13 14:44:58', NULL, NULL, 12863, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 14:44:58', 'admin-1505276547-15052850986672724', 1, 1, 'SR', NULL, NULL, NULL),
(46086, '2017-09-13 14:44:58', NULL, NULL, 12863, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 14:44:58', 'admin-1505276547-15052850986672724', 1, 0, '', NULL, NULL, NULL),
(46087, '2017-09-13 14:44:58', NULL, NULL, 12863, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 14:44:58', 'admin-1505276547-15052850986672724', 1, 0, '', NULL, NULL, NULL),
(46088, '2017-09-13 12:31:47', NULL, NULL, 12858, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1505276547', 'admin', '2017-09-13 12:31:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46089, '2017-09-13 12:42:41', NULL, NULL, 12858, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 12:42:41', 'admin-1505276547-15052777609898532', 1, 1, 'SR', NULL, NULL, NULL),
(46090, '2017-09-13 12:31:58', NULL, NULL, 12858, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 12:31:58', 'admin-1505276547-1505277118534123', 1, 0, '', NULL, NULL, NULL),
(46091, '2017-09-13 11:00:43', NULL, NULL, 12853, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 11:00:43', 'admin-1505264071-15052716433166823', 1, 0, '', NULL, NULL, NULL),
(46092, '2017-09-13 12:21:21', NULL, NULL, 12857, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 12:21:21', 'admin-1505264071-15052764811766392', 1, 0, '', NULL, NULL, NULL),
(46093, '2017-09-13 16:08:43', NULL, NULL, 12866, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 16:08:43', 'admin-1505276547-15052901234341376', 1, 0, '', NULL, NULL, '10.0'),
(46094, '2017-09-13 12:20:34', NULL, NULL, 12857, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.80, 0.0000, 0.0000, 15.80, 1, '27', 1, '1505276547', 'admin', '2017-09-13 12:20:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46095, '2017-09-13 15:18:30', NULL, NULL, 12866, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 15:18:30', 'admin-1505276547-15052871105479455', 1, 0, '', NULL, NULL, '10.0'),
(46096, '2017-09-13 12:22:19', NULL, NULL, 12857, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 12:22:19', 'admin-1505264071-15052765388323771', 1, 1, 'SR', NULL, NULL, NULL),
(46097, '2017-09-13 12:46:36', NULL, NULL, 12859, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 12:46:36', 'admin-1505276547-15052779966807897', 1, 1, 'SR', NULL, NULL, NULL),
(46098, '2017-09-13 12:46:36', NULL, NULL, 12859, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 12:46:36', 'admin-1505276547-15052779966807897', 1, 1, 'SR', NULL, NULL, NULL),
(46099, '2017-09-13 17:22:35', NULL, NULL, 12867, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 17:22:35', 'admin-1505276547-1505294555737324', 1, 0, '', NULL, NULL, NULL),
(46100, '2017-09-13 15:18:30', NULL, NULL, 12866, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 15:18:30', 'admin-1505276547-15052871105479455', 1, 0, '', NULL, NULL, '10.0'),
(46101, '2017-09-13 12:21:21', NULL, NULL, 12857, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 12:21:21', 'admin-1505264071-15052764811766392', 1, 0, '', NULL, NULL, NULL),
(46102, '2017-09-13 17:20:20', NULL, NULL, 12866, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 17:20:20', 'admin-1505276547-15052944203501713', 1, 0, '', NULL, NULL, '10.0'),
(46103, '2017-09-13 17:20:20', NULL, NULL, 12866, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 17:20:20', 'admin-1505276547-15052944203501713', 1, 0, '', NULL, NULL, '10.0'),
(46104, '2017-09-13 16:30:28', NULL, NULL, 12867, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 16:30:28', 'admin-1505276547-15052914287038883', 1, 0, '', NULL, NULL, NULL),
(46105, '2017-09-13 16:08:43', NULL, NULL, 12866, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 16:08:43', 'admin-1505276547-15052901234341376', 1, 0, '', NULL, NULL, '10.0'),
(46106, '2017-09-13 16:30:07', NULL, NULL, 12867, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1505276547', 'admin', '2017-09-13 16:30:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46107, '2017-09-13 16:08:43', NULL, NULL, 12866, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 16:08:43', 'admin-1505276547-15052901234341376', 1, 0, '', NULL, NULL, '10.0'),
(46108, '2017-09-13 16:08:43', NULL, NULL, 12866, 0, 181, '116', 'Open Food ', 'Cocktail sausage', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 16:08:43', 'admin-1505276547-15052901234341376', 1, 0, '', NULL, NULL, '10.0'),
(46109, '2017-09-13 16:08:43', NULL, NULL, 12866, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 16:08:43', 'admin-1505276547-15052901234341376', 1, 0, '', NULL, NULL, '10.0'),
(46110, '2017-09-13 16:08:43', NULL, NULL, 12866, 0, 181, '116', 'Open Food ', 'Cris cut fries', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 16:08:43', 'admin-1505276547-15052901234341376', 1, 0, '', NULL, NULL, '10.0'),
(46111, '2017-09-13 16:08:43', NULL, NULL, 12866, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 16:08:43', 'admin-1505276547-15052901234341376', 1, 0, '', NULL, NULL, '10.0'),
(46112, '2017-09-13 15:18:30', NULL, NULL, 12866, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 15:18:30', 'admin-1505276547-15052871105479455', 1, 0, '', NULL, NULL, '10.0'),
(46113, '2017-09-13 15:18:30', NULL, NULL, 12866, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 15:18:30', 'admin-1505276547-15052871105479455', 1, 0, '', NULL, NULL, '10.0'),
(46114, '2017-09-13 11:39:33', NULL, NULL, 12856, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1505276547', 'admin', '2017-09-13 11:39:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46115, '2017-09-13 15:16:52', NULL, NULL, 12866, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 28.40, 0.0000, 0.0000, 28.40, 1, '27', 1, '1505276547', 'admin', '2017-09-13 15:16:52', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(46116, '2017-09-13 15:08:44', NULL, NULL, 12865, 0, 182, '117', 'Open Drinks ', 'Craft Beer', 'Cold Drinks', 'Fresh Juice', 1, 907.20, 907.2000, 0.0000, 907.20, 1, '27', 1, '1505276547', 'admin', '2017-09-13 15:08:44', 'admin-1505276547-15052865239531782', 1, 0, '', NULL, NULL, NULL),
(46117, '2017-09-13 14:45:53', NULL, NULL, 12864, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 14:45:53', 'admin-1505276547-15052851530338024', 1, 1, 'SR', NULL, NULL, NULL),
(46118, '2017-09-13 14:45:53', NULL, NULL, 12864, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 14:45:53', 'admin-1505276547-15052851530338024', 1, 0, '', NULL, NULL, NULL),
(46119, '2017-09-13 14:45:26', NULL, NULL, 12864, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1505276547', 'admin', '2017-09-13 14:45:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46120, '2017-09-13 14:45:53', NULL, NULL, 12864, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 14:45:53', 'admin-1505276547-15052851530338024', 1, 0, '', NULL, NULL, NULL),
(46121, '2017-09-13 10:22:11', NULL, NULL, 12850, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:22:11', 'admin-1505264071-1505269331037164', 1, 0, '', NULL, NULL, NULL),
(46122, '2017-09-13 12:46:31', NULL, NULL, 12859, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1505276547', 'admin', '2017-09-13 12:46:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46123, '2017-09-13 17:20:20', NULL, NULL, 12866, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 17:20:20', 'admin-1505276547-15052944203501713', 1, 0, '', NULL, NULL, '10.0'),
(46124, '2017-09-13 12:32:07', NULL, NULL, 12858, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 12:32:07', 'admin-1505276547-15052771275559098', 1, 1, 'SR', NULL, NULL, NULL),
(46125, '2017-09-13 12:31:58', NULL, NULL, 12858, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 12:31:58', 'admin-1505276547-1505277118534123', 1, 0, '', NULL, NULL, NULL),
(46126, '2017-09-13 12:24:19', NULL, NULL, 12857, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 12:24:19', 'admin-1505276547-15052766590183724', 1, 1, 'SR', NULL, NULL, NULL),
(46127, '2017-09-13 12:24:05', NULL, NULL, 12857, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 12:24:05', 'admin-1505276547-15052766451121727', 1, 0, '', NULL, NULL, NULL),
(46128, '2017-09-13 12:24:19', NULL, NULL, 12857, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 12:24:19', 'admin-1505276547-15052766590183724', 1, 1, 'SR', NULL, NULL, NULL),
(46129, '2017-09-13 09:35:17', NULL, NULL, 12848, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 09:35:17', 'admin-1505264071-1505266516835633', 1, 1, 'SR', NULL, NULL, NULL),
(46130, '2017-09-13 12:24:19', NULL, NULL, 12857, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 12:24:19', 'admin-1505276547-15052766590183724', 1, 1, 'SR', NULL, NULL, NULL),
(46131, '2017-09-13 12:24:19', NULL, NULL, 12857, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 12:24:19', 'admin-1505276547-15052766590183724', 1, 0, '', NULL, NULL, NULL),
(46132, '2017-09-13 12:24:05', NULL, NULL, 12857, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 12:24:05', 'admin-1505276547-15052766451121727', 1, 0, '', NULL, NULL, NULL),
(46133, '2017-09-13 11:12:57', NULL, NULL, 12852, 0, 181, '116', 'Open Food ', 'Cocktail sausage 5 pcs', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 11:12:57', 'admin-1505264071-15052723774868840', 1, 0, '', NULL, NULL, NULL),
(46134, '2017-09-13 11:15:06', NULL, NULL, 12854, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1505276547', 'admin', '2017-09-13 11:15:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46135, '2017-09-13 11:15:09', NULL, NULL, 12854, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 11:15:09', 'admin-1505264071-1505272509497256', 1, 1, 'SR', NULL, NULL, NULL),
(46136, '2017-09-13 11:39:15', NULL, NULL, 12855, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1505276547', 'admin', '2017-09-13 11:39:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46137, '2017-09-13 11:39:29', NULL, NULL, 12855, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 11:39:29', 'admin-1505264071-15052739693708964', 1, 0, '', NULL, NULL, NULL),
(46138, '2017-09-13 10:48:52', NULL, NULL, 12851, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:48:52', 'admin-1505264071-15052709322369065', 1, 0, '', NULL, NULL, NULL),
(46139, '2017-09-13 10:15:43', NULL, NULL, 12849, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:15:43', 'admin-1505264071-15052689436526886', 1, 0, '', NULL, NULL, NULL),
(46140, '2017-09-13 10:15:56', NULL, NULL, 12849, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:15:56', 'admin-1505264071-15052689562494843', 1, 1, 'SR', NULL, NULL, NULL),
(46141, '2017-09-13 10:15:56', NULL, NULL, 12849, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:15:56', 'admin-1505264071-15052689562494843', 1, 1, 'SR', NULL, NULL, NULL),
(46142, '2017-09-13 11:39:29', NULL, NULL, 12855, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 11:39:29', 'admin-1505264071-15052739693708964', 1, 1, 'SR', NULL, NULL, NULL),
(46143, '2017-09-13 11:00:43', NULL, NULL, 12853, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 11:00:43', 'admin-1505264071-15052716433166823', 1, 1, 'SR', NULL, NULL, NULL),
(46144, '2017-09-13 11:00:43', NULL, NULL, 12853, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 11:00:43', 'admin-1505264071-15052716433166823', 1, 0, '', NULL, NULL, NULL),
(46145, '2017-09-13 11:00:43', NULL, NULL, 12853, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 11:00:43', 'admin-1505264071-15052716433166823', 1, 0, '', NULL, NULL, NULL),
(46146, '2017-09-13 11:00:43', NULL, NULL, 12853, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 11:00:43', 'admin-1505264071-15052716433166823', 1, 0, '', NULL, NULL, NULL),
(46147, '2017-09-13 10:59:45', NULL, NULL, 12853, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:59:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46148, '2017-09-13 10:49:45', NULL, NULL, 12852, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:49:45', 'admin-1505264071-15052709853827339', 1, 1, 'SR', NULL, NULL, NULL),
(46149, '2017-09-13 10:49:45', NULL, NULL, 12852, 0, 296, '232', 'Classic Egg Sandwich', '', 'Meals', 'Morning Bites ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:49:45', 'admin-1505264071-15052709853827339', 1, 0, '', NULL, NULL, NULL),
(46150, '2017-09-13 10:49:45', NULL, NULL, 12852, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:49:45', 'admin-1505264071-15052709853827339', 1, 0, '', NULL, NULL, NULL),
(46151, '2017-09-13 10:49:45', NULL, NULL, 12852, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:49:45', 'admin-1505264071-15052709853827339', 1, 1, 'SR', NULL, NULL, NULL),
(46152, '2017-09-13 10:49:33', NULL, NULL, 12852, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:49:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46153, '2017-09-13 10:48:52', NULL, NULL, 12851, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:48:52', 'admin-1505264071-15052709322369065', 1, 0, '', NULL, NULL, NULL),
(46154, '2017-09-13 10:48:52', NULL, NULL, 12851, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:48:52', 'admin-1505264071-15052709322369065', 1, 1, 'SR', NULL, NULL, NULL),
(46155, '2017-09-13 10:48:52', NULL, NULL, 12851, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:48:52', 'admin-1505264071-15052709322369065', 1, 0, '', NULL, NULL, NULL),
(46156, '2017-09-13 10:46:10', NULL, NULL, 12851, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:46:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46157, '2017-09-13 10:22:19', NULL, NULL, 12850, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:22:19', 'admin-1505264071-15052693397402711', 1, 1, 'SR', NULL, NULL, NULL),
(46158, '2017-09-13 10:22:19', NULL, NULL, 12850, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:22:19', 'admin-1505264071-15052693397402711', 1, 0, '', NULL, NULL, NULL),
(46159, '2017-09-13 10:22:11', NULL, NULL, 12850, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:22:11', 'admin-1505264071-1505269331037164', 1, 0, '', NULL, NULL, NULL),
(46160, '2017-09-13 10:22:02', NULL, NULL, 12850, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:22:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46161, '2017-09-13 11:40:02', NULL, NULL, 12856, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 11:40:02', 'admin-1505264071-1505274002357150', 1, 1, 'SR', NULL, NULL, NULL),
(46162, '2017-09-13 10:21:59', NULL, NULL, 12848, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:21:59', 'admin-1505264071-15052693191584154', 1, 1, 'SR', NULL, NULL, NULL),
(46163, '2017-09-13 10:15:56', NULL, NULL, 12849, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:15:56', 'admin-1505264071-15052689562494843', 1, 0, '', NULL, NULL, NULL),
(46164, '2017-09-13 10:15:56', NULL, NULL, 12849, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:15:56', 'admin-1505264071-15052689562494843', 1, 0, '', NULL, NULL, NULL),
(46165, '2017-09-13 10:15:56', NULL, NULL, 12849, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:15:56', 'admin-1505264071-15052689562494843', 1, 0, '', NULL, NULL, NULL),
(46166, '2017-09-13 10:15:56', NULL, NULL, 12849, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:15:56', 'admin-1505264071-15052689562494843', 1, 0, '', NULL, NULL, NULL),
(46167, '2017-09-13 10:15:38', NULL, NULL, 12849, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1505276547', 'admin', '2017-09-13 10:15:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46168, '2017-09-13 09:33:50', NULL, NULL, 12848, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1505276547', 'admin', '2017-09-13 09:33:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46169, '2017-09-14 14:07:53', NULL, NULL, 12892, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 14:07:53', 'admin-1505366253-15053692733753247', 1, 1, 'SR', NULL, NULL, NULL),
(46170, '2017-09-14 15:12:59', NULL, NULL, 12894, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:12:59', 'admin-1505366253-15053731795906441', 1, 0, '', NULL, NULL, NULL),
(46171, '2017-09-14 13:55:58', NULL, NULL, 12883, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:55:58', 'admin-1505366253-15053685587749741', 1, 1, 'SR', NULL, NULL, NULL),
(46172, '2017-09-14 13:56:00', NULL, NULL, 12891, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.79, 0.0000, 0.0000, 4.79, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:56:00', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(46173, '2017-09-14 10:15:19', NULL, NULL, 12870, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:15:19', 'admin-1505351129-15053553197656761', 1, 1, 'SR', NULL, NULL, NULL),
(46174, '2017-09-14 12:46:25', NULL, NULL, 12882, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 12:46:25', 'admin-1505359937-15053643855815334', 1, 1, 'SR', NULL, NULL, NULL),
(46175, '2017-09-14 12:53:21', NULL, NULL, 12883, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1505366253', 'admin', '2017-09-14 12:53:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46176, '2017-09-14 12:53:32', NULL, NULL, 12883, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 12:53:32', 'admin-1505359937-15053648126012342', 1, 0, '', NULL, NULL, NULL),
(46177, '2017-09-14 14:04:31', NULL, NULL, 12891, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 14:04:31', 'admin-1505366253-15053690708481067', 1, 1, 'SR', NULL, NULL, '10.0'),
(46178, '2017-09-14 13:46:01', NULL, NULL, 12890, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:46:01', 'admin-1505366253-1505367960980460', 1, 1, 'SR', NULL, NULL, NULL),
(46179, '2017-09-14 12:33:54', NULL, NULL, 12880, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 12:33:54', 'admin-1505359937-15053636339564684', 1, 0, '', NULL, NULL, NULL),
(46180, '2017-09-14 11:31:20', NULL, NULL, 12877, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1505366253', 'admin', '2017-09-14 11:31:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46181, '2017-09-14 11:31:24', NULL, NULL, 12877, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 11:31:24', 'admin-1505359355-1505359883925882', 1, 1, 'SR', NULL, NULL, NULL),
(46182, '2017-09-14 11:36:44', NULL, NULL, 12878, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1505366253', 'admin', '2017-09-14 11:36:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46183, '2017-09-14 11:36:51', NULL, NULL, 12878, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 11:36:51', 'admin-1505359937-15053602112011815', 1, 1, 'SR', NULL, NULL, NULL),
(46184, '2017-09-14 11:47:14', NULL, NULL, 12879, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1505366253', 'admin', '2017-09-14 11:47:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46185, '2017-09-14 11:47:26', NULL, NULL, 12879, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 11:47:26', 'admin-1505359937-1505360846488768', 1, 0, '', NULL, NULL, NULL),
(46186, '2017-09-14 11:47:26', NULL, NULL, 12879, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 11:47:26', 'admin-1505359937-1505360846488768', 1, 0, '', NULL, NULL, NULL),
(46187, '2017-09-14 11:47:26', NULL, NULL, 12879, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 11:47:26', 'admin-1505359937-1505360846488768', 1, 1, 'SR', NULL, NULL, NULL),
(46188, '2017-09-14 11:47:26', NULL, NULL, 12879, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 11:47:26', 'admin-1505359937-1505360846488768', 1, 1, 'SR', NULL, NULL, NULL),
(46189, '2017-09-14 11:55:00', NULL, NULL, 12879, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 11:55:00', 'admin-1505359937-1505361299907247', 1, 1, 'SR', NULL, NULL, NULL),
(46190, '2017-09-14 12:10:25', NULL, NULL, 12880, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1505366253', 'admin', '2017-09-14 12:10:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46191, '2017-09-14 12:11:49', NULL, NULL, 12880, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 12:11:49', 'admin-1505359937-15053623090467732', 1, 0, '', NULL, NULL, NULL),
(46192, '2017-09-14 12:11:49', NULL, NULL, 12880, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 12:11:49', 'admin-1505359937-15053623090467732', 1, 1, 'SR', NULL, NULL, NULL),
(46193, '2017-09-14 12:11:54', NULL, NULL, 12880, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 12:11:54', 'admin-1505359937-15053623143901315', 1, 1, 'SR', NULL, NULL, NULL),
(46194, '2017-09-14 13:56:07', NULL, NULL, 12891, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:56:07', 'admin-1505366253-1505368567490762', 1, 1, 'SR', NULL, NULL, '10.0'),
(46195, '2017-09-14 12:46:18', NULL, NULL, 12882, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1505366253', 'admin', '2017-09-14 12:46:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46196, '2017-09-14 12:46:25', NULL, NULL, 12882, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 12:46:25', 'admin-1505359937-15053643855815334', 1, 1, 'SR', NULL, NULL, NULL),
(46197, '2017-09-14 12:45:37', NULL, NULL, 12881, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1505366253', 'admin', '2017-09-14 12:45:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46198, '2017-09-14 12:45:49', NULL, NULL, 12881, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 12:45:49', 'admin-1505359937-15053643489363491', 1, 0, '', NULL, NULL, NULL),
(46199, '2017-09-14 13:10:07', NULL, NULL, 12887, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:10:07', 'admin-1505359937-15053658072971191', 1, 0, '', NULL, NULL, NULL),
(46200, '2017-09-14 13:46:01', NULL, NULL, 12890, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:46:01', 'admin-1505366253-1505367960980460', 1, 0, '', NULL, NULL, NULL),
(46201, '2017-09-14 13:46:01', NULL, NULL, 12890, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:46:01', 'admin-1505366253-1505367960980460', 1, 1, 'SR', NULL, NULL, NULL),
(46202, '2017-09-14 10:50:36', NULL, NULL, 12873, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:50:36', 'admin-1505351129-1505357436155850', 1, 0, '', NULL, NULL, NULL),
(46203, '2017-09-14 15:12:59', NULL, NULL, 12894, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:12:59', 'admin-1505366253-15053731795906441', 1, 1, 'SR', NULL, NULL, NULL),
(46204, '2017-09-14 15:12:59', NULL, NULL, 12894, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:12:59', 'admin-1505366253-15053731795906441', 1, 1, 'SR', NULL, NULL, NULL),
(46205, '2017-09-14 15:17:39', NULL, NULL, 12895, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:17:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46206, '2017-09-14 15:20:16', NULL, NULL, 12896, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:20:16', 'admin-1505366253-15053736162579068', 1, 0, '', NULL, NULL, NULL),
(46207, '2017-09-14 15:39:55', NULL, NULL, 12898, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:39:55', 'admin-1505366253-15053747952355553', 1, 1, 'SR', NULL, NULL, NULL),
(46208, '2017-09-14 16:07:26', NULL, NULL, 12897, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 16:07:26', 'admin-1505366253-15053764464831742', 1, 1, 'SR', NULL, NULL, NULL),
(46209, '2017-09-14 15:39:55', NULL, NULL, 12898, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:39:55', 'admin-1505366253-15053747952355553', 1, 1, 'SR', NULL, NULL, NULL),
(46210, '2017-09-14 15:39:50', NULL, NULL, 12898, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:39:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46211, '2017-09-14 15:39:15', NULL, NULL, 12897, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:39:15', 'admin-1505366253-15053747550243146', 1, 0, '', NULL, NULL, NULL),
(46212, '2017-09-14 15:39:15', NULL, NULL, 12897, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:39:15', 'admin-1505366253-15053747550243146', 1, 1, 'SR', NULL, NULL, NULL),
(46213, '2017-09-14 15:39:15', NULL, NULL, 12897, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:39:15', 'admin-1505366253-15053747550243146', 1, 1, 'SR', NULL, NULL, NULL),
(46214, '2017-09-14 15:39:15', NULL, NULL, 12897, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:39:15', 'admin-1505366253-15053747550243146', 1, 0, '', NULL, NULL, NULL),
(46215, '2017-09-14 10:48:59', NULL, NULL, 12874, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:48:59', 'admin-1505351129-15053573389251797', 1, 0, '', NULL, NULL, NULL),
(46216, '2017-09-14 13:08:48', NULL, NULL, 12886, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:08:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46217, '2017-09-14 15:38:54', NULL, NULL, 12897, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:38:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46218, '2017-09-14 15:36:12', NULL, NULL, 12891, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:36:12', 'admin-1505366253-1505374571962696', 1, 0, '', NULL, NULL, '10.0'),
(46219, '2017-09-14 15:20:22', NULL, NULL, 12896, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:20:22', 'admin-1505366253-15053736222476433', 1, 1, 'SR', NULL, NULL, NULL),
(46220, '2017-09-14 15:20:22', NULL, NULL, 12896, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:20:22', 'admin-1505366253-15053736222476433', 1, 1, 'SR', NULL, NULL, NULL),
(46221, '2017-09-14 15:20:16', NULL, NULL, 12896, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:20:16', 'admin-1505366253-15053736162579068', 1, 0, '', NULL, NULL, NULL),
(46222, '2017-09-14 13:46:01', NULL, NULL, 12890, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:46:01', 'admin-1505366253-1505367960980460', 1, 1, 'SR', NULL, NULL, NULL),
(46223, '2017-09-14 15:19:06', NULL, NULL, 12895, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:19:06', 'admin-1505366253-15053735465007746', 1, 1, 'SR', NULL, NULL, NULL),
(46224, '2017-09-14 15:19:06', NULL, NULL, 12895, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:19:06', 'admin-1505366253-15053735465007746', 1, 1, 'SR', NULL, NULL, NULL),
(46225, '2017-09-14 15:19:55', NULL, NULL, 12896, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:19:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46226, '2017-09-14 14:26:15', NULL, NULL, 12887, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 14:26:15', 'admin-1505366253-15053703755411295', 1, 0, '', NULL, NULL, NULL),
(46227, '2017-09-14 14:33:52', NULL, NULL, 12893, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1505366253', 'admin', '2017-09-14 14:33:52', 'admin-1505366253-15053708327057017', 1, 0, '', 1, NULL, NULL),
(46228, '2017-09-14 15:12:51', NULL, NULL, 12894, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:12:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46229, '2017-09-14 15:17:48', NULL, NULL, 12895, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:17:48', 'admin-1505366253-1505373468466375', 1, 0, '', NULL, NULL, NULL),
(46230, '2017-09-14 14:07:47', NULL, NULL, 12892, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1505366253', 'admin', '2017-09-14 14:07:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46231, '2017-09-14 13:46:01', NULL, NULL, 12890, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:46:01', 'admin-1505366253-1505367960980460', 1, 1, 'SR', NULL, NULL, NULL),
(46232, '2017-09-14 13:16:50', NULL, NULL, 12888, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:16:50', 'admin-1505359937-1505366210086393', 1, 1, 'SR', 1, NULL, '10.0'),
(46233, '2017-09-14 13:08:54', NULL, NULL, 12886, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:08:54', 'admin-1505359937-15053657342719278', 1, 0, '', NULL, NULL, NULL),
(46234, '2017-09-14 13:10:00', NULL, NULL, 12887, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:10:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46235, '2017-09-14 13:46:01', NULL, NULL, 12890, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 3, 18.00, 54.0000, 0.0000, 54.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:46:01', 'admin-1505366253-1505367960980460', 1, 1, 'SR', NULL, NULL, NULL),
(46236, '2017-09-14 13:45:33', NULL, NULL, 12890, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.20, 0.0000, 0.0000, 11.20, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:45:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46237, '2017-09-14 13:31:17', NULL, NULL, 12884, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:31:17', 'admin-1505366253-15053670770785675', 1, 1, 'SR', NULL, NULL, '10.0'),
(46238, '2017-09-14 13:44:27', NULL, NULL, 12886, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:44:27', 'admin-1505366253-15053678672788615', 1, 1, 'SR', NULL, NULL, NULL),
(46239, '2017-09-14 13:28:29', NULL, NULL, 12889, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:28:29', 'admin-1505366253-15053669094037518', 1, 0, '', NULL, NULL, NULL),
(46240, '2017-09-14 13:28:25', NULL, NULL, 12889, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:28:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46241, '2017-09-14 10:50:36', NULL, NULL, 12873, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:50:36', 'admin-1505351129-1505357436155850', 1, 1, 'SR', NULL, NULL, NULL),
(46242, '2017-09-14 11:07:20', NULL, NULL, 12872, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 11:07:20', 'admin-1505351129-15053584406768786', 1, 1, 'SR', NULL, NULL, NULL),
(46243, '2017-09-14 11:14:18', NULL, NULL, 12875, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 11:14:18', 'admin-1505351129-1505358858537472', 1, 0, '', 1, NULL, NULL),
(46244, '2017-09-14 11:14:18', NULL, NULL, 12875, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 11:14:18', 'admin-1505351129-1505358858537472', 1, 1, 'SR', 1, NULL, NULL),
(46245, '2017-09-14 11:21:36', NULL, NULL, 12876, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1505366253', 'admin', '2017-09-14 11:21:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46246, '2017-09-14 13:22:20', NULL, NULL, 12877, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:22:20', 'admin-1505366253-15053665406684891', 1, 1, 'SR', NULL, NULL, NULL),
(46247, '2017-09-14 14:04:25', NULL, NULL, 12891, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 14:04:25', 'admin-1505366253-15053690657485194', 1, 0, '', NULL, NULL, '10.0'),
(46248, '2017-09-14 13:10:07', NULL, NULL, 12887, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:10:07', 'admin-1505359937-15053658072971191', 1, 1, 'SR', NULL, NULL, NULL),
(46249, '2017-09-14 13:08:54', NULL, NULL, 12886, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:08:54', 'admin-1505359937-15053657342719278', 1, 0, '', NULL, NULL, NULL),
(46250, '2017-09-14 15:17:48', NULL, NULL, 12895, 0, 291, '225', 'Smoked Duck Red Pasta', '', 'Meals', 'Perfect Meals', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 15:17:48', 'admin-1505366253-1505373468466375', 1, 0, '', NULL, NULL, NULL),
(46251, '2017-09-14 13:56:04', NULL, NULL, 12891, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:56:04', 'admin-1505366253-15053685640356570', 1, 0, '', NULL, NULL, '10.0'),
(46252, '2017-09-14 13:06:10', NULL, NULL, 12872, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:06:10', 'admin-1505359937-15053655707743978', 1, 0, '', NULL, NULL, NULL),
(46253, '2017-09-14 12:56:03', NULL, NULL, 12884, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1505366253', 'admin', '2017-09-14 12:56:03', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(46254, '2017-09-14 12:56:13', NULL, NULL, 12884, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 12:56:13', 'admin-1505359937-15053649728578860', 1, 0, '', NULL, NULL, '10.0');
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(46255, '2017-09-14 12:56:13', NULL, NULL, 12884, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 12:56:13', 'admin-1505359937-15053649728578860', 1, 0, '', NULL, NULL, '10.0'),
(46256, '2017-09-14 13:00:49', NULL, NULL, 12884, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 13:00:49', 'admin-1505359937-15053652492142165', 1, 1, 'SR', NULL, NULL, '10.0'),
(46257, '2017-09-14 12:53:32', NULL, NULL, 12883, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 12:53:32', 'admin-1505359937-15053648126012342', 1, 0, '', NULL, NULL, NULL),
(46258, '2017-09-14 12:55:50', NULL, NULL, 12883, 0, 181, '116', 'Open Food ', 'double fried pork', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 12:55:50', 'admin-1505359937-1505364950046416', 1, 0, '', NULL, NULL, NULL),
(46259, '2017-09-14 12:45:49', NULL, NULL, 12881, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 12:45:49', 'admin-1505359937-15053643489363491', 1, 0, '', NULL, NULL, NULL),
(46260, '2017-09-14 12:33:54', NULL, NULL, 12880, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 12:33:54', 'admin-1505359937-15053636339564684', 1, 1, 'SR', NULL, NULL, NULL),
(46261, '2017-09-14 11:21:45', NULL, NULL, 12876, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 11:21:45', 'admin-1505351129-1505359305748538', 1, 0, '', NULL, NULL, NULL),
(46262, '2017-09-14 11:21:45', NULL, NULL, 12876, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 11:21:45', 'admin-1505351129-1505359305748538', 1, 1, 'SR', NULL, NULL, NULL),
(46263, '2017-09-14 11:22:59', NULL, NULL, 12868, 0, 222, '156', 'Seasoned Chicken Aglio Olio', 'Takeaway', 'Meals', 'Perfect Meals', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 11:22:59', 'admin-1505359355-15053593793115063', 1, 0, '', NULL, NULL, NULL),
(46264, '2017-09-14 10:42:42', NULL, NULL, 12873, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:42:42', 'admin-1505351129-15053569625712698', 1, 0, '', NULL, NULL, NULL),
(46265, '2017-09-14 10:42:42', NULL, NULL, 12873, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:42:42', 'admin-1505351129-15053569625712698', 1, 0, '', NULL, NULL, NULL),
(46266, '2017-09-14 10:42:42', NULL, NULL, 12873, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:42:42', 'admin-1505351129-15053569625712698', 1, 0, '', NULL, NULL, NULL),
(46267, '2017-09-14 10:42:42', NULL, NULL, 12873, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:42:42', 'admin-1505351129-15053569625712698', 1, 1, 'SR', NULL, NULL, NULL),
(46268, '2017-09-14 09:40:43', NULL, NULL, 12868, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 09:40:43', 'admin-1505351129-1505353242993342', 1, 1, 'SR', NULL, NULL, NULL),
(46269, '2017-09-14 09:40:43', NULL, NULL, 12868, 0, 182, '117', 'Open Drinks ', 'Honey Latte', 'Cold Drinks', 'Fresh Juice', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 09:40:43', 'admin-1505351129-1505353242993342', 1, 0, '', NULL, NULL, NULL),
(46270, '2017-09-14 10:13:07', NULL, NULL, 12869, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:13:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46271, '2017-09-14 10:48:59', NULL, NULL, 12874, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:48:59', 'admin-1505351129-15053573389251797', 1, 1, 'SR', NULL, NULL, NULL),
(46272, '2017-09-14 10:48:59', NULL, NULL, 12874, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:48:59', 'admin-1505351129-15053573389251797', 1, 0, '', NULL, NULL, NULL),
(46273, '2017-09-14 10:48:52', NULL, NULL, 12874, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:48:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46274, '2017-09-14 10:48:19', NULL, NULL, 12873, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:48:19', 'admin-1505351129-15053572989984892', 1, 1, 'SR', NULL, NULL, NULL),
(46275, '2017-09-14 10:48:13', NULL, NULL, 12873, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:48:13', 'admin-1505351129-15053572933166195', 1, 0, '', NULL, NULL, NULL),
(46276, '2017-09-14 10:42:29', NULL, NULL, 12873, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.70, 0.0000, 0.0000, 12.70, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:42:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46277, '2017-09-14 10:22:22', NULL, NULL, 12872, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:22:22', 'admin-1505351129-1505355742829285', 1, 1, 'SR', NULL, NULL, NULL),
(46278, '2017-09-14 10:22:23', NULL, NULL, 12872, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:22:23', 'admin-1505351129-1505355742829285', 1, 1, 'SR', NULL, NULL, NULL),
(46279, '2017-09-14 10:42:21', NULL, NULL, 12868, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:42:21', 'admin-1505351129-15053569415193495', 1, 0, '', NULL, NULL, NULL),
(46280, '2017-09-14 10:42:21', NULL, NULL, 12868, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:42:21', 'admin-1505351129-15053569415193495', 1, 1, 'SR', NULL, NULL, NULL),
(46281, '2017-09-14 10:22:15', NULL, NULL, 12871, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:22:15', 'admin-1505351129-15053557356288154', 1, 1, 'SR', NULL, NULL, NULL),
(46282, '2017-09-14 10:22:18', NULL, NULL, 12872, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:22:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46283, '2017-09-14 10:22:00', NULL, NULL, 12871, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:22:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46284, '2017-09-14 10:22:10', NULL, NULL, 12871, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:22:10', 'admin-1505351129-1505355729846776', 1, 0, '', NULL, NULL, NULL),
(46285, '2017-09-14 10:22:10', NULL, NULL, 12871, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:22:10', 'admin-1505351129-1505355729846776', 1, 0, '', NULL, NULL, NULL),
(46286, '2017-09-14 10:13:32', NULL, NULL, 12869, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:13:32', 'admin-1505351129-1505355212651262', 1, 1, 'SR', NULL, NULL, NULL),
(46287, '2017-09-14 10:13:32', NULL, NULL, 12869, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:13:32', 'admin-1505351129-1505355212651262', 1, 1, 'SR', NULL, NULL, NULL),
(46288, '2017-09-14 10:13:32', NULL, NULL, 12869, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:13:32', 'admin-1505351129-1505355212651262', 1, 0, '', NULL, NULL, NULL),
(46289, '2017-09-14 10:15:03', NULL, NULL, 12869, 0, 182, '117', 'Open Drinks ', 'fruits', 'Cold Drinks', 'Fresh Juice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:15:03', 'admin-1505351129-15053553030554130', 1, 0, '', NULL, NULL, NULL),
(46290, '2017-09-14 10:15:19', NULL, NULL, 12870, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:15:19', 'admin-1505351129-15053553197656761', 1, 0, '', NULL, NULL, NULL),
(46291, '2017-09-14 10:15:19', NULL, NULL, 12870, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:15:19', 'admin-1505351129-15053553197656761', 1, 0, '', NULL, NULL, NULL),
(46292, '2017-09-14 10:15:19', NULL, NULL, 12870, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:15:19', 'admin-1505351129-15053553197656761', 1, 1, 'SR', NULL, NULL, NULL),
(46293, '2017-09-14 10:15:11', NULL, NULL, 12870, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1505366253', 'admin', '2017-09-14 10:15:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46294, '2017-09-14 09:40:43', NULL, NULL, 12868, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 09:40:43', 'admin-1505351129-1505353242993342', 1, 1, 'SR', NULL, NULL, NULL),
(46295, '2017-09-14 09:40:43', NULL, NULL, 12868, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 09:40:43', 'admin-1505351129-1505353242993342', 1, 1, 'SR', NULL, NULL, NULL),
(46296, '2017-09-14 09:40:43', NULL, NULL, 12868, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 09:40:43', 'admin-1505351129-1505353242993342', 1, 0, '', NULL, NULL, NULL),
(46297, '2017-09-14 09:40:43', NULL, NULL, 12868, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 09:40:43', 'admin-1505351129-1505353242993342', 1, 0, '', NULL, NULL, NULL),
(46298, '2017-09-14 09:37:31', NULL, NULL, 12868, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 09:37:31', 'admin-1505351129-15053530508551716', 1, 0, '', NULL, NULL, NULL),
(46299, '2017-09-14 09:40:43', NULL, NULL, 12868, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505366253', 'admin', '2017-09-14 09:40:43', 'admin-1505351129-1505353242993342', 1, 0, '', NULL, NULL, NULL),
(46300, '2017-09-14 09:37:25', NULL, NULL, 12868, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 17.50, 0.0000, 0.0000, 17.50, 1, '27', 1, '1505366253', 'admin', '2017-09-14 09:37:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46301, '2017-09-15 12:37:57', NULL, NULL, 12905, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 12:37:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46302, '2017-09-15 12:38:09', NULL, NULL, 12905, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 12:38:09', 'admin-1505444587-15054502894908119', 1, 0, '', NULL, NULL, NULL),
(46303, '2017-09-15 11:03:23', NULL, NULL, 12899, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:03:23', 'admin-1505444587-15054446031851449', 1, 0, '', NULL, NULL, NULL),
(46304, '2017-09-15 11:03:23', NULL, NULL, 12899, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:03:23', 'admin-1505444587-15054446031851449', 1, 0, '', NULL, NULL, NULL),
(46305, '2017-09-15 11:03:23', NULL, NULL, 12899, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:03:23', 'admin-1505444587-15054446031851449', 1, 1, 'SR', NULL, NULL, NULL),
(46306, '2017-09-15 11:03:23', NULL, NULL, 12899, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:03:23', 'admin-1505444587-15054446031851449', 1, 1, 'SR', NULL, NULL, NULL),
(46307, '2017-09-15 13:28:23', NULL, NULL, 12901, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 13:28:23', 'admin-1505444587-15054533031197912', 1, 1, 'SR', NULL, NULL, NULL),
(46308, '2017-09-15 13:28:23', NULL, NULL, 12901, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 13:28:23', 'admin-1505444587-15054533031197912', 1, 0, '', NULL, NULL, NULL),
(46309, '2017-09-15 13:28:23', NULL, NULL, 12901, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 13:28:23', 'admin-1505444587-15054533031197912', 1, 1, 'SR', NULL, NULL, NULL),
(46310, '2017-09-15 13:28:23', NULL, NULL, 12901, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 13:28:23', 'admin-1505444587-15054533031197912', 1, 1, 'SR', NULL, NULL, NULL),
(46311, '2017-09-15 14:55:53', NULL, NULL, 12910, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1505458856', 'admin', '2017-09-15 14:55:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46312, '2017-09-15 14:55:57', NULL, NULL, 12910, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 14:55:57', 'admin-1505444587-15054585573729997', 1, 1, 'SR', NULL, NULL, NULL),
(46313, '2017-09-15 15:00:44', NULL, NULL, 12911, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1505458856', 'admin', '2017-09-15 15:00:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46314, '2017-09-15 15:00:50', NULL, NULL, 12911, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 15:00:50', 'admin-1505444587-15054588507032012', 1, 0, '', NULL, NULL, NULL),
(46315, '2017-09-15 15:52:59', NULL, NULL, 12914, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1505458856', 'admin', '2017-09-15 15:52:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46316, '2017-09-15 15:53:05', NULL, NULL, 12914, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 15:53:05', 'admin-1505458856-15054619857927127', 1, 1, 'SR', NULL, NULL, NULL),
(46317, '2017-09-15 16:01:22', NULL, NULL, 12913, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 16:01:22', 'admin-1505458856-15054624824337579', 1, 0, '', NULL, NULL, NULL),
(46318, '2017-09-15 16:09:41', NULL, NULL, 12913, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 16:09:41', 'admin-1505458856-1505462981639343', 1, 1, 'SR', NULL, NULL, NULL),
(46319, '2017-09-15 11:44:13', NULL, NULL, 12900, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:44:13', 'admin-1505444587-150544705361179', 1, 1, 'SR', NULL, NULL, NULL),
(46320, '2017-09-15 11:58:51', NULL, NULL, 12903, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:58:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46321, '2017-09-15 11:59:10', NULL, NULL, 12903, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:59:10', 'admin-1505444587-15054479501447543', 1, 1, 'SR', NULL, NULL, NULL),
(46322, '2017-09-15 15:39:24', NULL, NULL, 12913, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 15:39:24', 'admin-1505458856-15054611646358247', 1, 1, 'SR', NULL, NULL, NULL),
(46323, '2017-09-15 15:39:24', NULL, NULL, 12913, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 15:39:24', 'admin-1505458856-15054611646358247', 1, 1, 'SR', NULL, NULL, NULL),
(46324, '2017-09-15 15:39:24', NULL, NULL, 12913, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 15:39:24', 'admin-1505458856-15054611646358247', 1, 1, 'SR', NULL, NULL, NULL),
(46325, '2017-09-15 15:30:02', NULL, NULL, 12913, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.50, 0.0000, 0.0000, 11.50, 1, '27', 1, '1505458856', 'admin', '2017-09-15 15:30:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46326, '2017-09-15 15:30:24', NULL, NULL, 12913, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 15:30:24', 'admin-1505458856-15054606248043069', 1, 1, 'SR', NULL, NULL, NULL),
(46327, '2017-09-15 15:30:24', NULL, NULL, 12913, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 15:30:24', 'admin-1505458856-15054606248043069', 1, 1, 'SR', NULL, NULL, NULL),
(46328, '2017-09-15 15:33:10', NULL, NULL, 12913, 0, 215, '149', 'Thai Fish Sauce Garlic Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 15:33:10', 'admin-1505458856-15054607903874666', 1, 0, '', NULL, NULL, NULL),
(46329, '2017-09-15 15:33:10', NULL, NULL, 12913, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 15:33:10', 'admin-1505458856-15054607903874666', 1, 0, '', NULL, NULL, NULL),
(46330, '2017-09-15 15:12:51', NULL, NULL, 12912, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 15:12:51', 'admin-1505458856-1505459570779181', 1, 0, '', 1, NULL, '10.0'),
(46331, '2017-09-15 14:46:57', NULL, NULL, 12909, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 14:46:57', 'admin-1505444587-15054580168857439', 1, 0, '', NULL, NULL, NULL),
(46332, '2017-09-15 14:46:49', NULL, NULL, 12909, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1505458856', 'admin', '2017-09-15 14:46:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46333, '2017-09-15 14:46:57', NULL, NULL, 12909, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 14:46:57', 'admin-1505444587-15054580168857439', 1, 1, 'SR', NULL, NULL, NULL),
(46334, '2017-09-15 14:45:15', NULL, NULL, 12908, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 14:45:15', 'admin-1505444587-15054579151349559', 1, 1, 'SR', NULL, NULL, NULL),
(46335, '2017-09-15 12:39:15', NULL, NULL, 12906, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 12:39:15', 'admin-1505444587-15054503549185757', 1, 1, 'SR', NULL, NULL, NULL),
(46336, '2017-09-15 13:37:49', NULL, NULL, 12905, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 13:37:49', 'admin-1505444587-15054538694017298', 1, 0, '', NULL, NULL, NULL),
(46337, '2017-09-15 14:18:00', NULL, NULL, 12907, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1505458856', 'admin', '2017-09-15 14:18:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46338, '2017-09-15 12:20:14', NULL, NULL, 12902, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 12:20:14', 'admin-1505444587-15054492140682386', 1, 0, '', NULL, NULL, NULL),
(46339, '2017-09-15 11:31:31', NULL, NULL, 12902, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:31:31', 'admin-1505444587-15054462909715896', 1, 1, 'SR', NULL, NULL, NULL),
(46340, '2017-09-15 11:44:13', NULL, NULL, 12900, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:44:13', 'admin-1505444587-150544705361179', 1, 1, 'SR', NULL, NULL, NULL),
(46341, '2017-09-15 11:44:13', NULL, NULL, 12900, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:44:13', 'admin-1505444587-150544705361179', 1, 1, 'SR', NULL, NULL, NULL),
(46342, '2017-09-15 14:45:06', NULL, NULL, 12908, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1505458856', 'admin', '2017-09-15 14:45:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46343, '2017-09-15 14:45:15', NULL, NULL, 12908, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 14:45:15', 'admin-1505444587-15054579151349559', 1, 1, 'SR', NULL, NULL, NULL),
(46344, '2017-09-15 14:18:18', NULL, NULL, 12907, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 14:18:18', 'admin-1505444587-15054562987574319', 1, 1, 'SR', NULL, NULL, NULL),
(46345, '2017-09-15 14:42:32', NULL, NULL, 12902, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 14:42:32', 'admin-1505444587-15054577527788352', 1, 1, 'SR', NULL, NULL, NULL),
(46346, '2017-09-15 14:18:18', NULL, NULL, 12907, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 14:18:18', 'admin-1505444587-15054562987574319', 1, 1, 'SR', NULL, NULL, NULL),
(46347, '2017-09-15 14:22:09', NULL, NULL, 12907, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 14:22:09', 'admin-1505444587-15054565289027149', 1, 0, '', NULL, NULL, NULL),
(46348, '2017-09-15 14:18:11', NULL, NULL, 12907, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 14:18:11', 'admin-1505444587-1505456291301141', 1, 1, 'SR', NULL, NULL, NULL),
(46349, '2017-09-15 12:39:15', NULL, NULL, 12906, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 12:39:15', 'admin-1505444587-15054503549185757', 1, 0, '', NULL, NULL, NULL),
(46350, '2017-09-15 12:38:09', NULL, NULL, 12905, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 12:38:09', 'admin-1505444587-15054502894908119', 1, 1, 'SR', NULL, NULL, NULL),
(46351, '2017-09-15 12:38:09', NULL, NULL, 12905, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 12:38:09', 'admin-1505444587-15054502894908119', 1, 0, '', NULL, NULL, NULL),
(46352, '2017-09-15 12:38:20', NULL, NULL, 12905, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 12:38:20', 'admin-1505444587-1505450300360605', 1, 1, 'SR', NULL, NULL, NULL),
(46353, '2017-09-15 12:38:20', NULL, NULL, 12905, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 12:38:20', 'admin-1505444587-1505450300360605', 1, 1, 'SR', NULL, NULL, NULL),
(46354, '2017-09-15 12:38:20', NULL, NULL, 12905, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 12:38:20', 'admin-1505444587-1505450300360605', 1, 0, '', NULL, NULL, NULL),
(46355, '2017-09-15 12:39:02', NULL, NULL, 12906, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1505458856', 'admin', '2017-09-15 12:39:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46356, '2017-09-15 11:59:10', NULL, NULL, 12903, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:59:10', 'admin-1505444587-15054479501447543', 1, 0, '', NULL, NULL, NULL),
(46357, '2017-09-15 11:59:17', NULL, NULL, 12903, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:59:17', 'admin-1505444587-15054479576796944', 1, 1, 'SR', NULL, NULL, NULL),
(46358, '2017-09-15 11:59:17', NULL, NULL, 12903, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:59:17', 'admin-1505444587-15054479576796944', 1, 1, 'SR', NULL, NULL, NULL),
(46359, '2017-09-15 12:10:35', NULL, NULL, 12904, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1505458856', 'admin', '2017-09-15 12:10:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46360, '2017-09-15 12:10:48', NULL, NULL, 12904, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 12:10:48', 'admin-1505444587-15054486487893215', 1, 1, 'SR', NULL, NULL, NULL),
(46361, '2017-09-15 12:10:48', NULL, NULL, 12904, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 12:10:48', 'admin-1505444587-15054486487893215', 1, 1, 'SR', NULL, NULL, NULL),
(46362, '2017-09-15 12:10:48', NULL, NULL, 12904, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 12:10:48', 'admin-1505444587-15054486487893215', 1, 1, 'SR', NULL, NULL, NULL),
(46363, '2017-09-15 12:20:08', NULL, NULL, 12902, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 12:20:08', 'admin-1505444587-15054492079501421', 1, 0, '', NULL, NULL, NULL),
(46364, '2017-09-15 11:59:10', NULL, NULL, 12903, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:59:10', 'admin-1505444587-15054479501447543', 1, 0, '', NULL, NULL, NULL),
(46365, '2017-09-15 11:59:10', NULL, NULL, 12903, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:59:10', 'admin-1505444587-15054479501447543', 1, 1, 'SR', NULL, NULL, NULL),
(46366, '2017-09-15 11:44:13', NULL, NULL, 12900, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:44:13', 'admin-1505444587-150544705361179', 1, 1, 'SR', NULL, NULL, NULL),
(46367, '2017-09-15 11:31:28', NULL, NULL, 12902, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:31:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46368, '2017-09-15 11:20:39', NULL, NULL, 12900, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:20:39', 'admin-1505444587-15054456395665245', 1, 1, 'SR', NULL, NULL, NULL),
(46369, '2017-09-15 11:30:08', NULL, NULL, 12901, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:30:08', 'admin-1505444587-15054462085098523', 1, 1, 'SR', NULL, NULL, NULL),
(46370, '2017-09-15 11:30:01', NULL, NULL, 12901, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:30:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46371, '2017-09-15 11:19:43', NULL, NULL, 12900, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:19:43', 'admin-1505444587-15054455832292718', 1, 1, 'SR', NULL, NULL, NULL),
(46372, '2017-09-15 11:19:38', NULL, NULL, 12900, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:19:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46373, '2017-09-15 11:03:14', NULL, NULL, 12899, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1505458856', 'admin', '2017-09-15 11:03:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46374, '2017-09-16 15:36:24', NULL, NULL, 12949, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:36:24', 'admin-1505546718-15055473839178254', 1, 0, '', NULL, NULL, NULL),
(46375, '2017-09-16 14:06:33', NULL, NULL, 12945, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:06:33', 'admin-1505541957-1505541993129474', 1, 0, '', NULL, NULL, NULL),
(46376, '2017-09-16 15:09:47', NULL, NULL, 12949, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:09:47', 'admin-1505541957-15055457868768154', 1, 1, 'SR', NULL, NULL, NULL),
(46377, '2017-09-16 16:52:20', NULL, NULL, 12953, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 16:52:20', 'admin-1505546718-15055519402438534', 1, 0, '', 1, NULL, '10.0'),
(46378, '2017-09-16 14:06:33', NULL, NULL, 12945, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:06:33', 'admin-1505541957-1505541993129474', 1, 0, '', NULL, NULL, NULL),
(46379, '2017-09-16 13:19:49', NULL, NULL, 12940, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:19:49', 'admin-1505535925-15055391890925227', 1, 0, '', NULL, NULL, NULL),
(46380, '2017-09-16 13:22:23', NULL, NULL, 12940, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:22:23', 'admin-1505535925-15055393433581563', 1, 1, 'SR', NULL, NULL, NULL),
(46381, '2017-09-16 12:24:56', NULL, NULL, 12936, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 12:24:56', 'admin-1505529213-15055358965993598', 1, 0, '', NULL, NULL, NULL),
(46382, '2017-09-16 12:24:56', NULL, NULL, 12936, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 12:24:56', 'admin-1505529213-15055358965993598', 1, 1, 'SR', NULL, NULL, NULL),
(46383, '2017-09-16 15:36:24', NULL, NULL, 12949, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:36:24', 'admin-1505546718-15055473839178254', 1, 0, '', NULL, NULL, NULL),
(46384, '2017-09-16 13:52:50', NULL, NULL, 12944, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:52:50', 'admin-1505535925-15055411702453076', 1, 1, 'SR', NULL, NULL, NULL),
(46385, '2017-09-16 14:05:11', NULL, NULL, 12945, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:05:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46386, '2017-09-16 14:16:22', NULL, NULL, 12946, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:16:22', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(46387, '2017-09-16 14:16:30', NULL, NULL, 12946, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:16:30', 'admin-1505541957-15055425899773444', 1, 0, '', NULL, NULL, '10.0'),
(46388, '2017-09-16 14:17:34', NULL, NULL, 12946, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:17:34', 'admin-1505541957-15055426540351787', 1, 1, 'SR', NULL, NULL, '10.0'),
(46389, '2017-09-16 14:17:34', NULL, NULL, 12946, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:17:34', 'admin-1505541957-15055426540351787', 1, 1, 'SR', NULL, NULL, '10.0'),
(46390, '2017-09-16 15:30:35', NULL, NULL, 12951, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:30:35', 'admin-1505546718-15055470357282625', 1, 1, 'SR', NULL, NULL, NULL),
(46391, '2017-09-16 14:06:33', NULL, NULL, 12945, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:06:33', 'admin-1505541957-1505541993129474', 1, 0, '', NULL, NULL, NULL),
(46392, '2017-09-16 09:46:36', NULL, NULL, 12918, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:46:36', 'admin-1505524105-15055263967004578', 1, 0, '', NULL, NULL, NULL),
(46393, '2017-09-16 10:46:08', NULL, NULL, 12928, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:46:08', 'admin-1505529213-15055299680166838', 1, 0, '', NULL, NULL, NULL),
(46394, '2017-09-16 10:47:17', NULL, NULL, 12929, 0, 182, '117', 'Open Drinks ', 'Americano set', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:47:17', 'admin-1505529213-15055300368975644', 1, 0, '', 1, NULL, NULL),
(46395, '2017-09-16 10:46:08', NULL, NULL, 12928, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:46:08', 'admin-1505529213-15055299680166838', 1, 1, 'SR', NULL, NULL, NULL),
(46396, '2017-09-16 10:46:08', NULL, NULL, 12928, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:46:08', 'admin-1505529213-15055299680166838', 1, 0, '', NULL, NULL, NULL),
(46397, '2017-09-16 10:47:34', NULL, NULL, 12928, 0, 181, '116', 'Open Food ', 'Macadamia Scones', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:47:34', 'admin-1505529213-15055300542701156', 1, 0, '', NULL, NULL, NULL),
(46398, '2017-09-16 11:03:43', NULL, NULL, 12930, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 11:03:43', 'admin-1505529213-15055310233779763', 1, 0, '', 1, NULL, NULL),
(46399, '2017-09-16 10:30:20', NULL, NULL, 12922, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:30:20', 'admin-1505524105-15055290203208933', 1, 1, 'SR', NULL, NULL, NULL),
(46400, '2017-09-16 10:45:54', NULL, NULL, 12928, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:45:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46401, '2017-09-16 10:29:59', NULL, NULL, 12922, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:29:59', 'admin-1505524105-15055289990178022', 1, 0, '', NULL, NULL, NULL),
(46402, '2017-09-16 10:30:20', NULL, NULL, 12922, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:30:20', 'admin-1505524105-15055290203208933', 1, 1, 'SR', NULL, NULL, NULL),
(46403, '2017-09-16 10:30:20', NULL, NULL, 12922, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:30:20', 'admin-1505524105-15055290203208933', 1, 1, 'SR', NULL, NULL, NULL),
(46404, '2017-09-16 15:30:35', NULL, NULL, 12951, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:30:35', 'admin-1505546718-15055470357282625', 1, 1, 'SR', NULL, NULL, NULL),
(46405, '2017-09-16 16:54:25', NULL, NULL, 12954, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1505546718', 'admin', '2017-09-16 16:54:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46406, '2017-09-16 16:54:34', NULL, NULL, 12954, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 16:54:34', 'admin-1505546718-15055520742997388', 1, 0, '', NULL, NULL, NULL),
(46407, '2017-09-16 15:58:20', NULL, NULL, 12952, 0, 181, '116', 'Open Food ', 'Summer salad', 'Meals', 'Perfect Meals', 1, 12.75, 12.7500, 0.0000, 12.75, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:58:20', 'admin-1505546718-15055486999028386', 1, 0, '', NULL, NULL, NULL),
(46408, '2017-09-16 15:29:36', NULL, NULL, 12951, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:29:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46409, '2017-09-16 15:58:20', NULL, NULL, 12952, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:58:20', 'admin-1505546718-15055486999028386', 1, 0, '', NULL, NULL, NULL),
(46410, '2017-09-16 14:05:49', NULL, NULL, 12945, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:05:49', 'admin-1505535925-15055419496397631', 1, 0, '', NULL, NULL, NULL),
(46411, '2017-09-16 10:39:51', NULL, NULL, 12927, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:39:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46412, '2017-09-16 10:39:55', NULL, NULL, 12927, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:39:55', 'admin-1505529213-15055295955587047', 1, 0, '', NULL, NULL, NULL),
(46413, '2017-09-16 10:40:02', NULL, NULL, 12927, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:40:02', 'admin-1505529213-15055296022906754', 1, 0, '', NULL, NULL, NULL),
(46414, '2017-09-16 10:40:02', NULL, NULL, 12927, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:40:02', 'admin-1505529213-15055296022906754', 1, 0, '', NULL, NULL, NULL),
(46415, '2017-09-16 14:32:48', NULL, NULL, 12948, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:32:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46416, '2017-09-16 14:33:33', NULL, NULL, 12948, 0, 291, '225', 'Smoked Duck Red Pasta', '', 'Meals', 'Perfect Meals', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:33:33', 'admin-1505541957-15055436134194053', 1, 0, '', NULL, NULL, NULL),
(46417, '2017-09-16 15:36:24', NULL, NULL, 12949, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:36:24', 'admin-1505546718-15055473839178254', 1, 0, '', NULL, NULL, NULL),
(46418, '2017-09-16 15:30:35', NULL, NULL, 12951, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:30:35', 'admin-1505546718-15055470357282625', 1, 1, 'SR', NULL, NULL, NULL),
(46419, '2017-09-16 12:18:04', NULL, NULL, 12935, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 12:18:04', 'admin-1505529213-15055354844585070', 1, 0, '', NULL, NULL, NULL),
(46420, '2017-09-16 15:58:20', NULL, NULL, 12952, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:58:20', 'admin-1505546718-15055486999028386', 1, 1, 'SR', NULL, NULL, NULL),
(46421, '2017-09-16 14:07:41', NULL, NULL, 12941, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:07:41', 'admin-1505541957-15055420610894339', 1, 1, 'SR', NULL, NULL, NULL),
(46422, '2017-09-16 14:14:18', NULL, NULL, 12942, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:14:18', 'admin-1505541957-15055424578409911', 1, 1, 'SR', NULL, NULL, NULL),
(46423, '2017-09-16 15:58:20', NULL, NULL, 12952, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:58:20', 'admin-1505546718-15055486999028386', 1, 0, '', NULL, NULL, NULL),
(46424, '2017-09-16 15:58:20', NULL, NULL, 12952, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:58:20', 'admin-1505546718-15055486999028386', 1, 1, 'SR', NULL, NULL, NULL),
(46425, '2017-09-16 15:46:22', NULL, NULL, 12949, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:46:22', 'admin-1505546718-15055479826975699', 1, 0, '', NULL, NULL, NULL),
(46426, '2017-09-16 12:49:13', NULL, NULL, 12938, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 12:49:13', 'admin-1505535925-15055373537107637', 1, 1, 'SR', NULL, NULL, NULL),
(46427, '2017-09-16 15:10:15', NULL, NULL, 12949, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:10:15', 'admin-1505541957-1505545815253376', 1, 1, 'SR', NULL, NULL, NULL),
(46428, '2017-09-16 15:58:20', NULL, NULL, 12952, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:58:20', 'admin-1505546718-15055486999028386', 1, 0, '', NULL, NULL, NULL),
(46429, '2017-09-16 15:10:15', NULL, NULL, 12949, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:10:15', 'admin-1505541957-1505545815253376', 1, 1, 'SR', NULL, NULL, NULL),
(46430, '2017-09-16 15:10:15', NULL, NULL, 12949, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:10:15', 'admin-1505541957-1505545815253376', 1, 1, 'SR', NULL, NULL, NULL),
(46431, '2017-09-16 15:10:15', NULL, NULL, 12949, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:10:15', 'admin-1505541957-1505545815253376', 1, 1, 'SR', NULL, NULL, NULL),
(46432, '2017-09-16 15:09:47', NULL, NULL, 12949, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:09:47', 'admin-1505541957-15055457868768154', 1, 1, 'SR', NULL, NULL, NULL),
(46433, '2017-09-16 15:09:47', NULL, NULL, 12949, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:09:47', 'admin-1505541957-15055457868768154', 1, 0, '', NULL, NULL, NULL),
(46434, '2017-09-16 11:42:59', NULL, NULL, 12934, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1505546718', 'admin', '2017-09-16 11:42:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46435, '2017-09-16 15:09:47', NULL, NULL, 12949, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:09:47', 'admin-1505541957-15055457868768154', 1, 0, '', NULL, NULL, NULL),
(46436, '2017-09-16 15:57:19', NULL, NULL, 12952, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.28, 0.0000, 0.0000, 9.28, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:57:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46437, '2017-09-16 14:49:50', NULL, NULL, 12945, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:49:50', 'admin-1505541957-1505544590141539', 1, 0, '', NULL, NULL, NULL),
(46438, '2017-09-16 14:33:33', NULL, NULL, 12948, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:33:33', 'admin-1505541957-15055436134194053', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(46439, '2017-09-16 14:45:41', NULL, NULL, 12947, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:45:41', 'admin-1505541957-15055443416886140', 1, 1, 'SR', NULL, NULL, NULL),
(46440, '2017-09-16 14:35:32', NULL, NULL, 12948, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:35:32', 'admin-1505541957-1505543732751882', 1, 0, '', NULL, NULL, NULL),
(46441, '2017-09-16 14:33:33', NULL, NULL, 12948, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:33:33', 'admin-1505541957-15055436134194053', 1, 1, 'SR', NULL, NULL, NULL),
(46442, '2017-09-16 14:17:34', NULL, NULL, 12946, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:17:34', 'admin-1505541957-15055426540351787', 1, 0, '', NULL, NULL, '10.0'),
(46443, '2017-09-16 14:19:32', NULL, NULL, 12947, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:19:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46444, '2017-09-16 13:52:33', NULL, NULL, 12944, 0, 291, '225', 'Smoked Duck Red Pasta', '', 'Meals', 'Perfect Meals', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:52:33', 'admin-1505535925-15055411529117046', 1, 0, '', NULL, NULL, NULL),
(46445, '2017-09-16 15:09:35', NULL, NULL, 12949, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.50, 0.0000, 0.0000, 12.50, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:09:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46446, '2017-09-16 13:52:33', NULL, NULL, 12944, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:52:33', 'admin-1505535925-15055411529117046', 1, 0, '', NULL, NULL, NULL),
(46447, '2017-09-16 13:52:08', NULL, NULL, 12944, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:52:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46448, '2017-09-16 13:51:29', NULL, NULL, 12943, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:51:29', 'admin-1505535925-15055410896567167', 1, 1, 'SR', NULL, NULL, NULL),
(46449, '2017-09-16 13:51:29', NULL, NULL, 12943, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:51:29', 'admin-1505535925-15055410896567167', 1, 0, '', NULL, NULL, NULL),
(46450, '2017-09-16 13:51:29', NULL, NULL, 12943, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:51:29', 'admin-1505535925-15055410896567167', 1, 0, '', NULL, NULL, NULL),
(46451, '2017-09-16 13:43:47', NULL, NULL, 12942, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:43:47', 'admin-1505535925-15055406270658122', 1, 1, 'SR', NULL, NULL, NULL),
(46452, '2017-09-16 14:17:34', NULL, NULL, 12946, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:17:34', 'admin-1505541957-15055426540351787', 1, 0, '', NULL, NULL, '10.0'),
(46453, '2017-09-16 13:51:29', NULL, NULL, 12943, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:51:29', 'admin-1505535925-15055410896567167', 1, 1, 'SR', NULL, NULL, NULL),
(46454, '2017-09-16 15:58:20', NULL, NULL, 12952, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:58:20', 'admin-1505546718-15055486999028386', 1, 0, '', NULL, NULL, NULL),
(46455, '2017-09-16 13:51:29', NULL, NULL, 12943, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:51:29', 'admin-1505535925-15055410896567167', 1, 1, 'SR', NULL, NULL, NULL),
(46456, '2017-09-16 13:39:27', NULL, NULL, 12941, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:39:27', 'admin-1505535925-15055403673092356', 1, 0, '', NULL, NULL, NULL),
(46457, '2017-09-16 13:40:40', NULL, NULL, 12940, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:40:40', 'admin-1505535925-15055404407336744', 1, 0, '', NULL, NULL, NULL),
(46458, '2017-09-16 13:43:00', NULL, NULL, 12942, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.90, 0.0000, 0.0000, 9.90, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:43:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46459, '2017-09-16 13:51:29', NULL, NULL, 12943, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:51:29', 'admin-1505535925-15055410896567167', 1, 0, '', NULL, NULL, NULL),
(46460, '2017-09-16 13:50:49', NULL, NULL, 12943, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:50:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46461, '2017-09-16 13:43:47', NULL, NULL, 12942, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:43:47', 'admin-1505535925-15055406270658122', 1, 1, 'SR', NULL, NULL, NULL),
(46462, '2017-09-16 13:43:47', NULL, NULL, 12942, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:43:47', 'admin-1505535925-15055406270658122', 1, 1, 'SR', NULL, NULL, NULL),
(46463, '2017-09-16 13:43:47', NULL, NULL, 12942, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:43:47', 'admin-1505535925-15055406270658122', 1, 1, 'SR', NULL, NULL, NULL),
(46464, '2017-09-16 13:43:47', NULL, NULL, 12942, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:43:47', 'admin-1505535925-15055406270658122', 1, 1, 'SR', NULL, NULL, NULL),
(46465, '2017-09-16 13:13:34', NULL, NULL, 12939, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:13:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46466, '2017-09-16 13:14:07', NULL, NULL, 12939, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:14:07', 'admin-1505535925-15055388475224637', 1, 0, '', NULL, NULL, NULL),
(46467, '2017-09-16 12:48:47', NULL, NULL, 12938, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 12:48:47', 'admin-1505535925-15055373273101981', 1, 1, 'SR', NULL, NULL, NULL),
(46468, '2017-09-16 12:48:47', NULL, NULL, 12938, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 12:48:47', 'admin-1505535925-15055373273101981', 1, 0, '', NULL, NULL, NULL),
(46469, '2017-09-16 12:48:47', NULL, NULL, 12938, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 12:48:47', 'admin-1505535925-15055373273101981', 1, 0, '', NULL, NULL, NULL),
(46470, '2017-09-16 12:48:58', NULL, NULL, 12938, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 12:48:58', 'admin-1505535925-15055373386556452', 1, 1, 'SR', NULL, NULL, NULL),
(46471, '2017-09-16 13:43:47', NULL, NULL, 12942, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:43:47', 'admin-1505535925-15055406270658122', 1, 1, 'SR', NULL, NULL, NULL),
(46472, '2017-09-16 13:43:47', NULL, NULL, 12942, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:43:47', 'admin-1505535925-15055406270658122', 1, 1, 'SR', NULL, NULL, NULL),
(46473, '2017-09-16 13:43:47', NULL, NULL, 12942, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:43:47', 'admin-1505535925-15055406270658122', 1, 1, 'SR', NULL, NULL, NULL),
(46474, '2017-09-16 13:39:18', NULL, NULL, 12941, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:39:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46475, '2017-09-16 11:51:50', NULL, NULL, 12920, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 11:51:50', 'admin-1505529213-15055339101415859', 1, 0, '', NULL, NULL, NULL),
(46476, '2017-09-16 12:17:51', NULL, NULL, 12935, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1505546718', 'admin', '2017-09-16 12:17:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46477, '2017-09-16 12:18:04', NULL, NULL, 12935, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 12:18:04', 'admin-1505529213-15055354844585070', 1, 0, '', NULL, NULL, NULL),
(46478, '2017-09-16 13:19:39', NULL, NULL, 12940, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:19:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46479, '2017-09-16 13:14:07', NULL, NULL, 12939, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:14:07', 'admin-1505535925-15055388475224637', 1, 0, '', NULL, NULL, NULL),
(46480, '2017-09-16 12:24:56', NULL, NULL, 12936, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 12:24:56', 'admin-1505529213-15055358965993598', 1, 0, '', NULL, NULL, NULL),
(46481, '2017-09-16 12:49:13', NULL, NULL, 12938, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 12:49:13', 'admin-1505535925-15055373537107637', 1, 1, 'SR', NULL, NULL, NULL),
(46482, '2017-09-16 12:49:13', NULL, NULL, 12938, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 12:49:13', 'admin-1505535925-15055373537107637', 1, 1, 'SR', NULL, NULL, NULL),
(46483, '2017-09-16 15:30:35', NULL, NULL, 12951, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 15:30:35', 'admin-1505546718-15055470357282625', 1, 1, 'SR', NULL, NULL, NULL),
(46484, '2017-09-16 14:06:33', NULL, NULL, 12945, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:06:33', 'admin-1505541957-1505541993129474', 1, 0, '', NULL, NULL, NULL),
(46485, '2017-09-16 13:52:50', NULL, NULL, 12944, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:52:50', 'admin-1505535925-15055411702453076', 1, 0, '', NULL, NULL, NULL),
(46486, '2017-09-16 12:48:11', NULL, NULL, 12938, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1505546718', 'admin', '2017-09-16 12:48:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46487, '2017-09-16 12:42:54', NULL, NULL, 12937, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 12:42:54', 'admin-1505535925-1505536973926598', 1, 0, '', NULL, NULL, NULL),
(46488, '2017-09-16 12:42:45', NULL, NULL, 12937, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1505546718', 'admin', '2017-09-16 12:42:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46489, '2017-09-16 12:42:54', NULL, NULL, 12937, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 12:42:54', 'admin-1505535925-1505536973926598', 1, 0, '', NULL, NULL, NULL),
(46490, '2017-09-16 11:05:28', NULL, NULL, 12931, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 11:05:28', 'admin-1505529213-1505531128106389', 1, 0, '', NULL, NULL, NULL),
(46491, '2017-09-16 11:05:39', NULL, NULL, 12931, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 11:05:39', 'admin-1505529213-1505531139176268', 1, 1, 'SR', NULL, NULL, NULL),
(46492, '2017-09-16 11:05:39', NULL, NULL, 12931, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 11:05:39', 'admin-1505529213-1505531139176268', 1, 1, 'SR', NULL, NULL, NULL),
(46493, '2017-09-16 09:35:58', NULL, NULL, 12917, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:35:58', 'admin-1505524105-15055257581335122', 1, 0, '', NULL, NULL, NULL),
(46494, '2017-09-16 09:46:22', NULL, NULL, 12918, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:46:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46495, '2017-09-16 09:46:26', NULL, NULL, 12918, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:46:26', 'admin-1505524105-15055263858525789', 1, 0, '', NULL, NULL, NULL),
(46496, '2017-09-16 11:33:56', NULL, NULL, 12933, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 11:33:56', 'admin-1505529213-15055328364572667', 1, 0, '', NULL, NULL, NULL),
(46497, '2017-09-16 11:34:48', NULL, NULL, 12933, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 11:34:48', 'admin-1505529213-15055328885817440', 1, 1, 'SR', NULL, NULL, NULL),
(46498, '2017-09-16 11:34:48', NULL, NULL, 12933, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 11:34:48', 'admin-1505529213-15055328885817440', 1, 0, '', NULL, NULL, NULL),
(46499, '2017-09-16 12:24:56', NULL, NULL, 12936, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 12:24:56', 'admin-1505529213-15055358965993598', 1, 0, '', NULL, NULL, NULL),
(46500, '2017-09-16 12:18:04', NULL, NULL, 12935, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 12:18:04', 'admin-1505529213-15055354844585070', 1, 1, 'SR', NULL, NULL, NULL),
(46501, '2017-09-16 12:18:04', NULL, NULL, 12935, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 12:18:04', 'admin-1505529213-15055354844585070', 1, 0, '', NULL, NULL, NULL),
(46502, '2017-09-16 16:52:20', NULL, NULL, 12953, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 16:52:20', 'admin-1505546718-15055519402438534', 1, 1, 'SR', 1, NULL, '10.0'),
(46503, '2017-09-16 13:14:07', NULL, NULL, 12939, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 13:14:07', 'admin-1505535925-15055388475224637', 1, 1, 'SR', NULL, NULL, NULL),
(46504, '2017-09-16 11:43:04', NULL, NULL, 12934, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 11:43:04', 'admin-1505529213-1505533384039826', 1, 1, 'SR', NULL, NULL, NULL),
(46505, '2017-09-16 11:33:56', NULL, NULL, 12933, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 11:33:56', 'admin-1505529213-15055328364572667', 1, 0, '', NULL, NULL, NULL),
(46506, '2017-09-16 11:06:39', NULL, NULL, 12932, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 11:06:39', 'admin-1505529213-1505531198848794', 1, 0, '', NULL, NULL, NULL),
(46507, '2017-09-16 11:06:46', NULL, NULL, 12932, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 11:06:46', 'admin-1505529213-15055312058832418', 1, 1, 'SR', NULL, NULL, NULL),
(46508, '2017-09-16 11:06:46', NULL, NULL, 12932, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 11:06:46', 'admin-1505529213-15055312058832418', 1, 1, 'SR', NULL, NULL, NULL),
(46509, '2017-09-16 14:19:36', NULL, NULL, 12947, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:19:36', 'admin-1505541957-15055427758558177', 1, 1, 'SR', NULL, NULL, NULL),
(46510, '2017-09-16 11:33:56', NULL, NULL, 12933, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 11:33:56', 'admin-1505529213-15055328364572667', 1, 0, '', NULL, NULL, NULL),
(46511, '2017-09-16 11:33:44', NULL, NULL, 12933, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.20, 0.0000, 0.0000, 9.20, 1, '27', 1, '1505546718', 'admin', '2017-09-16 11:33:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46512, '2017-09-16 14:05:49', NULL, NULL, 12945, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 14:05:49', 'admin-1505535925-15055419496397631', 1, 1, 'SR', NULL, NULL, NULL),
(46513, '2017-09-16 11:34:48', NULL, NULL, 12933, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 11:34:48', 'admin-1505529213-15055328885817440', 1, 0, '', NULL, NULL, NULL),
(46514, '2017-09-16 10:37:24', NULL, NULL, 12920, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:37:24', 'admin-1505529213-15055294444458318', 1, 1, 'SR', NULL, NULL, NULL),
(46515, '2017-09-16 11:06:32', NULL, NULL, 12932, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1505546718', 'admin', '2017-09-16 11:06:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46516, '2017-09-16 10:37:24', NULL, NULL, 12920, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:37:24', 'admin-1505529213-15055294444458318', 1, 1, 'SR', NULL, NULL, NULL),
(46517, '2017-09-16 11:06:39', NULL, NULL, 12932, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 11:06:39', 'admin-1505529213-1505531198848794', 1, 0, '', NULL, NULL, NULL),
(46518, '2017-09-16 11:05:16', NULL, NULL, 12931, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1505546718', 'admin', '2017-09-16 11:05:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46519, '2017-09-16 10:34:12', NULL, NULL, 12926, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:34:12', 'admin-1505529213-1505529252273783', 1, 1, 'SR', NULL, NULL, NULL),
(46520, '2017-09-16 10:29:59', NULL, NULL, 12922, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:29:59', 'admin-1505524105-15055289990178022', 1, 0, '', NULL, NULL, NULL),
(46521, '2017-09-16 10:29:59', NULL, NULL, 12922, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:29:59', 'admin-1505524105-15055289990178022', 1, 0, '', NULL, NULL, NULL),
(46522, '2017-09-16 10:20:08', NULL, NULL, 12921, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:20:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46523, '2017-09-16 10:20:29', NULL, NULL, 12921, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:20:29', 'admin-1505524105-15055284297497586', 1, 0, '', NULL, NULL, NULL),
(46524, '2017-09-16 10:20:29', NULL, NULL, 12921, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:20:29', 'admin-1505524105-15055284297497586', 1, 0, '', NULL, NULL, NULL),
(46525, '2017-09-16 10:20:29', NULL, NULL, 12921, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:20:29', 'admin-1505524105-15055284297497586', 1, 1, 'SR', NULL, NULL, NULL),
(46526, '2017-09-16 09:35:47', NULL, NULL, 12917, 0, 156, '90', 'House Cheddar Omelet', 'no toast', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:35:47', 'admin-1505524105-15055257477012734', 1, 0, '', NULL, NULL, NULL),
(46527, '2017-09-16 09:35:47', NULL, NULL, 12917, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:35:47', 'admin-1505524105-15055257477012734', 1, 0, '', NULL, NULL, NULL),
(46528, '2017-09-16 09:35:58', NULL, NULL, 12917, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:35:58', 'admin-1505524105-15055257581335122', 1, 1, 'SR', NULL, NULL, NULL),
(46529, '2017-09-16 12:24:12', NULL, NULL, 12936, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 12:24:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46530, '2017-09-16 10:34:12', NULL, NULL, 12926, 0, 153, '87', 'Wake Me Up!', 'no toast', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:34:12', 'admin-1505529213-1505529252273783', 1, 0, '', NULL, NULL, NULL),
(46531, '2017-09-16 10:33:29', NULL, NULL, 12926, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:33:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46532, '2017-09-16 10:32:39', NULL, NULL, 12922, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:32:39', 'admin-1505524105-15055291593198065', 1, 0, '', NULL, NULL, NULL),
(46533, '2017-09-16 09:14:31', NULL, NULL, 12916, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:14:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46534, '2017-09-16 09:14:55', NULL, NULL, 12916, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:14:55', 'admin-1505524105-15055244954364469', 1, 0, '', NULL, NULL, NULL),
(46535, '2017-09-16 09:55:57', NULL, NULL, 12919, 0, 181, '116', 'Open Food ', 'Toast scrambled egg', 'Meals', 'Perfect Meals', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:55:57', 'admin-1505524105-15055269569817551', 1, 0, '', NULL, NULL, NULL),
(46536, '2017-09-16 09:55:57', NULL, NULL, 12919, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:55:57', 'admin-1505524105-15055269569817551', 1, 0, '', NULL, NULL, NULL),
(46537, '2017-09-16 09:55:57', NULL, NULL, 12919, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:55:57', 'admin-1505524105-15055269569817551', 1, 1, 'SR', NULL, NULL, NULL),
(46538, '2017-09-16 09:55:57', NULL, NULL, 12919, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:55:57', 'admin-1505524105-15055269569817551', 1, 0, '', NULL, NULL, NULL),
(46539, '2017-09-16 09:55:57', NULL, NULL, 12919, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:55:57', 'admin-1505524105-15055269569817551', 1, 0, '', NULL, NULL, NULL),
(46540, '2017-09-16 10:01:15', NULL, NULL, 12917, 0, 181, '116', 'Open Food ', 'corn', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:01:15', 'admin-1505524105-15055272751891614', 1, 0, '', NULL, NULL, NULL),
(46541, '2017-09-16 10:01:15', NULL, NULL, 12917, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:01:15', 'admin-1505524105-15055272751891614', 1, 0, '', NULL, NULL, NULL),
(46542, '2017-09-16 10:29:39', NULL, NULL, 12922, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.10, 0.0000, 0.0000, 10.10, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:29:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46543, '2017-09-16 10:24:18', NULL, NULL, 12919, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:24:18', 'admin-1505524105-15055286584277271', 1, 1, 'SR', NULL, NULL, NULL),
(46544, '2017-09-16 10:20:29', NULL, NULL, 12921, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:20:29', 'admin-1505524105-15055284297497586', 1, 0, '', NULL, NULL, NULL),
(46545, '2017-09-16 10:18:46', NULL, NULL, 12920, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:18:46', 'admin-1505524105-15055283259955551', 1, 1, 'SR', NULL, NULL, NULL),
(46546, '2017-09-16 10:18:40', NULL, NULL, 12920, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1505546718', 'admin', '2017-09-16 10:18:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46547, '2017-09-16 09:52:06', NULL, NULL, 12919, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:52:06', 'admin-1505524105-15055267265015481', 1, 1, 'SR', NULL, NULL, NULL),
(46548, '2017-09-16 09:34:43', NULL, NULL, 12917, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:34:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46549, '2017-09-16 09:35:47', NULL, NULL, 12917, 0, 153, '87', 'Wake Me Up!', 'baked bean,no potato,toast', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:35:47', 'admin-1505524105-15055257477012734', 1, 0, '', NULL, NULL, NULL),
(46550, '2017-09-16 09:46:36', NULL, NULL, 12918, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:46:36', 'admin-1505524105-15055263967004578', 1, 1, 'SR', NULL, NULL, NULL),
(46551, '2017-09-16 09:52:03', NULL, NULL, 12919, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:52:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46552, '2017-09-16 09:46:26', NULL, NULL, 12918, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:46:26', 'admin-1505524105-15055263858525789', 1, 0, '', NULL, NULL, NULL),
(46553, '2017-09-16 09:14:55', NULL, NULL, 12916, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:14:55', 'admin-1505524105-15055244954364469', 1, 1, 'SR', NULL, NULL, NULL),
(46554, '2017-09-16 09:14:55', NULL, NULL, 12916, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:14:55', 'admin-1505524105-15055244954364469', 1, 0, '', NULL, NULL, NULL),
(46555, '2017-09-16 09:14:55', NULL, NULL, 12916, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:14:55', 'admin-1505524105-15055244954364469', 1, 1, 'SR', NULL, NULL, NULL),
(46556, '2017-09-16 09:14:55', NULL, NULL, 12916, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:14:55', 'admin-1505524105-15055244954364469', 1, 1, 'SR', NULL, NULL, NULL),
(46557, '2017-09-16 09:14:28', NULL, NULL, 12915, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:14:28', 'admin-1505524105-15055244686673895', 1, 0, '', NULL, NULL, NULL),
(46558, '2017-09-16 09:11:57', NULL, NULL, 12915, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:11:57', 'admin-1505524105-15055243170959595', 1, 1, 'SR', NULL, NULL, NULL),
(46559, '2017-09-16 09:11:54', NULL, NULL, 12915, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1505546718', 'admin', '2017-09-16 09:11:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46560, '2017-09-17 15:59:48', NULL, NULL, 13011, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:59:48', 'admin-1505629426-15056351881893697', 1, 1, 'SR', NULL, NULL, NULL),
(46561, '2017-09-17 15:28:07', NULL, NULL, 13007, 0, 181, '116', 'Open Food ', 'cheesy sticks', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:28:07', 'admin-1505629426-15056332873556672', 1, 0, '', 1, NULL, NULL),
(46562, '2017-09-17 15:33:18', NULL, NULL, 13008, 0, 181, '116', 'Open Food ', 'cockies', 'Meals', 'Perfect Meals', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:33:18', 'admin-1505629426-15056335978254398', 1, 0, '', 1, NULL, NULL),
(46563, '2017-09-17 15:39:01', NULL, NULL, 13009, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:39:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46564, '2017-09-17 15:39:08', NULL, NULL, 13009, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:39:08', 'admin-1505629426-15056339484658061', 1, 1, 'SR', NULL, NULL, NULL),
(46565, '2017-09-17 15:40:15', NULL, NULL, 13010, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:40:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46566, '2017-09-17 15:40:20', NULL, NULL, 13010, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:40:20', 'admin-1505629426-15056340203408233', 1, 1, 'SR', NULL, NULL, NULL),
(46567, '2017-09-17 15:59:18', NULL, NULL, 13011, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:59:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46568, '2017-09-17 15:59:29', NULL, NULL, 13011, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:59:29', 'admin-1505629426-15056351695314293', 1, 1, 'SR', NULL, NULL, NULL),
(46569, '2017-09-17 13:07:53', NULL, NULL, 12987, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:07:53', 'admin-1505622616-15056248729378646', 1, 1, 'SR', NULL, NULL, NULL),
(46570, '2017-09-17 17:11:10', NULL, NULL, 13013, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 17:11:10', 'admin-1505629426-15056394701206323', 1, 1, 'SR', NULL, NULL, NULL),
(46571, '2017-09-17 14:22:39', NULL, NULL, 12994, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 14:22:39', 'admin-1505625561-150562935925532', 1, 0, '', NULL, NULL, NULL),
(46572, '2017-09-17 14:04:36', NULL, NULL, 12996, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 14:04:36', 'admin-1505625561-15056282763722846', 1, 1, 'SR', NULL, NULL, NULL),
(46573, '2017-09-17 14:05:41', NULL, NULL, 12996, 0, 192, '127', 'Flaming Hot & Spicy Pork', 'replace lemony', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 14:05:41', 'admin-1505625561-15056283409305878', 1, 0, '', NULL, NULL, NULL),
(46574, '2017-09-17 13:50:45', NULL, NULL, 12979, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:50:45', 'admin-1505625561-15056274454165241', 1, 1, 'SR', NULL, NULL, '10.0'),
(46575, '2017-09-17 13:50:30', NULL, NULL, 12979, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:50:30', 'admin-1505625561-15056274299118378', 1, 1, 'SR', NULL, NULL, '10.0'),
(46576, '2017-09-17 13:50:30', NULL, NULL, 12979, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:50:30', 'admin-1505625561-15056274299118378', 1, 1, 'SR', NULL, NULL, '10.0'),
(46577, '2017-09-17 14:35:39', NULL, NULL, 13000, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1505629426', 'admin', '2017-09-17 14:35:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46578, '2017-09-17 14:36:12', NULL, NULL, 13000, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 14:36:12', 'admin-1505629426-15056301722836016', 1, 1, 'SR', NULL, NULL, NULL),
(46579, '2017-09-17 14:23:41', NULL, NULL, 12999, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 14:23:41', 'admin-1505625561-15056294216548068', 1, 0, '', NULL, NULL, NULL),
(46580, '2017-09-17 14:23:41', NULL, NULL, 12999, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 14:23:41', 'admin-1505625561-15056294216548068', 1, 0, '', NULL, NULL, NULL),
(46581, '2017-09-17 15:24:39', NULL, NULL, 13005, 0, 182, '117', 'Open Drinks ', 'scones', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:24:39', 'admin-1505629426-15056330792153396', 1, 0, '', NULL, NULL, NULL),
(46582, '2017-09-17 14:23:15', NULL, NULL, 12999, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1505629426', 'admin', '2017-09-17 14:23:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46583, '2017-09-17 13:49:37', NULL, NULL, 12988, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:49:37', 'admin-1505625561-15056273774716672', 1, 0, '', NULL, NULL, NULL),
(46584, '2017-09-17 13:00:29', NULL, NULL, 12986, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:00:29', 'admin-1505622616-150562442903569', 1, 0, '', NULL, NULL, NULL),
(46585, '2017-09-17 13:04:03', NULL, NULL, 12979, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:04:03', 'admin-1505622616-15056246433653693', 1, 0, '', NULL, NULL, '10.0'),
(46586, '2017-09-17 11:39:50', NULL, NULL, 12973, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:39:50', 'admin-1505614815-15056195898716635', 1, 1, 'SR', NULL, NULL, NULL),
(46587, '2017-09-17 11:49:04', NULL, NULL, 12974, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:49:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46588, '2017-09-17 11:29:27', NULL, NULL, 12971, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:29:27', 'admin-1505614815-15056189676975383', 1, 1, 'SR', NULL, NULL, NULL),
(46589, '2017-09-17 11:29:27', NULL, NULL, 12971, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:29:27', 'admin-1505614815-15056189676975383', 1, 1, 'SR', NULL, NULL, NULL),
(46590, '2017-09-17 15:24:06', NULL, NULL, 13005, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:24:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46591, '2017-09-17 15:23:17', NULL, NULL, 13004, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:23:17', 'admin-1505629426-15056329977308053', 1, 1, 'SR', NULL, NULL, NULL),
(46592, '2017-09-17 15:23:17', NULL, NULL, 13004, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:23:17', 'admin-1505629426-15056329977308053', 1, 0, '', NULL, NULL, NULL),
(46593, '2017-09-17 13:50:30', NULL, NULL, 12979, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:50:30', 'admin-1505625561-15056274299118378', 1, 1, 'SR', NULL, NULL, '10.0'),
(46594, '2017-09-17 13:50:30', NULL, NULL, 12979, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:50:30', 'admin-1505625561-15056274299118378', 1, 1, 'SR', NULL, NULL, '10.0'),
(46595, '2017-09-17 13:48:10', NULL, NULL, 12994, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:48:10', 'admin-1505625561-15056272903614276', 1, 0, '', NULL, NULL, NULL),
(46596, '2017-09-17 14:04:36', NULL, NULL, 12996, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 14:04:36', 'admin-1505625561-15056282763722846', 1, 1, 'SR', NULL, NULL, NULL),
(46597, '2017-09-17 14:04:36', NULL, NULL, 12996, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 14:04:36', 'admin-1505625561-15056282763722846', 1, 0, '', NULL, NULL, NULL),
(46598, '2017-09-17 15:22:56', NULL, NULL, 13004, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:22:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46599, '2017-09-17 15:15:11', NULL, NULL, 13003, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:15:11', 'admin-1505629426-15056325115145773', 1, 0, '', NULL, NULL, NULL),
(46600, '2017-09-17 13:20:00', NULL, NULL, 12987, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:20:00', 'admin-1505625561-1505625600551734', 1, 1, 'SR', NULL, NULL, NULL),
(46601, '2017-09-17 11:50:09', NULL, NULL, 12975, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:50:09', 'admin-1505614815-15056202087234061', 1, 1, 'SR', NULL, NULL, NULL),
(46602, '2017-09-17 14:12:44', NULL, NULL, 12994, 0, 181, '116', 'Open Food ', 'Scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 14:12:44', 'admin-1505625561-15056287647706272', 1, 0, '', NULL, NULL, NULL),
(46603, '2017-09-17 13:46:37', NULL, NULL, 12995, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:46:37', 'admin-1505625561-15056271970651333', 1, 1, 'SR', NULL, NULL, '10.0'),
(46604, '2017-09-17 13:46:37', NULL, NULL, 12995, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:46:37', 'admin-1505625561-15056271970651333', 1, 1, 'SR', NULL, NULL, '10.0'),
(46605, '2017-09-17 13:46:22', NULL, NULL, 12995, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:46:22', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(46606, '2017-09-17 13:43:57', NULL, NULL, 12994, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:43:57', 'admin-1505625561-15056270368494139', 1, 0, '', NULL, NULL, NULL),
(46607, '2017-09-17 13:43:57', NULL, NULL, 12994, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:43:57', 'admin-1505625561-15056270368494139', 1, 0, '', NULL, NULL, NULL),
(46608, '2017-09-17 15:02:03', NULL, NULL, 13002, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:02:03', 'admin-1505629426-15056317232187047', 1, 0, '', NULL, NULL, NULL),
(46609, '2017-09-17 15:02:03', NULL, NULL, 13002, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:02:03', 'admin-1505629426-15056317232187047', 1, 1, 'SR', NULL, NULL, NULL),
(46610, '2017-09-17 14:59:37', NULL, NULL, 13001, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 14:59:37', 'admin-1505629426-15056315769614296', 1, 0, '', NULL, NULL, NULL),
(46611, '2017-09-17 15:01:46', NULL, NULL, 13002, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:01:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46612, '2017-09-17 14:59:37', NULL, NULL, 13001, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 14:59:37', 'admin-1505629426-15056315769614296', 1, 0, '', NULL, NULL, NULL),
(46613, '2017-09-17 14:59:21', NULL, NULL, 13001, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1505629426', 'admin', '2017-09-17 14:59:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46614, '2017-09-17 13:44:19', NULL, NULL, 12994, 0, 181, '116', 'Open Food ', 'pork bacon aglio olio both less spicy', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:44:19', 'admin-1505625561-1505627059744406', 1, 0, '', NULL, NULL, NULL),
(46615, '2017-09-17 13:43:57', NULL, NULL, 12994, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:43:57', 'admin-1505625561-15056270368494139', 1, 1, 'SR', NULL, NULL, NULL),
(46616, '2017-09-17 13:43:57', NULL, NULL, 12994, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:43:57', 'admin-1505625561-15056270368494139', 1, 0, '', NULL, NULL, NULL),
(46617, '2017-09-17 13:46:37', NULL, NULL, 12995, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:46:37', 'admin-1505625561-15056271970651333', 1, 1, 'SR', NULL, NULL, '10.0'),
(46618, '2017-09-17 13:28:30', NULL, NULL, 12991, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:28:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46619, '2017-09-17 13:19:55', NULL, NULL, 12987, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:19:55', 'admin-1505625561-1505625595008846', 1, 0, '', NULL, NULL, NULL),
(46620, '2017-09-17 13:18:31', NULL, NULL, 12985, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:18:31', 'admin-1505622616-15056255109517574', 1, 0, '', NULL, NULL, NULL),
(46621, '2017-09-17 13:15:15', NULL, NULL, 12990, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:15:15', 'admin-1505622616-15056253149428596', 1, 1, 'SR', NULL, NULL, NULL),
(46622, '2017-09-17 14:36:12', NULL, NULL, 13000, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 14:36:12', 'admin-1505629426-15056301722836016', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(46623, '2017-09-17 13:28:39', NULL, NULL, 12991, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:28:39', 'admin-1505625561-15056261196262123', 1, 1, 'SR', NULL, NULL, NULL),
(46624, '2017-09-17 11:49:09', NULL, NULL, 12974, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:49:09', 'admin-1505614815-15056201489855812', 1, 1, 'SR', NULL, NULL, NULL),
(46625, '2017-09-17 15:15:03', NULL, NULL, 13003, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:15:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46626, '2017-09-17 12:48:09', NULL, NULL, 12983, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:48:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46627, '2017-09-17 10:18:11', NULL, NULL, 12962, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:18:11', 'admin-1505608753-15056146912253041', 1, 1, 'SR', NULL, NULL, NULL),
(46628, '2017-09-17 09:51:18', NULL, NULL, 12958, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:51:18', 'admin-1505608753-15056130786456642', 1, 1, 'SR', NULL, NULL, NULL),
(46629, '2017-09-17 10:28:42', NULL, NULL, 12965, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:28:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46630, '2017-09-17 10:29:13', NULL, NULL, 12965, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:29:13', 'admin-1505614815-15056153533867371', 1, 0, '', NULL, NULL, NULL),
(46631, '2017-09-17 10:29:13', NULL, NULL, 12965, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:29:13', 'admin-1505614815-15056153533867371', 1, 0, '', NULL, NULL, NULL),
(46632, '2017-09-17 10:29:13', NULL, NULL, 12965, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:29:13', 'admin-1505614815-15056153533867371', 1, 0, '', NULL, NULL, NULL),
(46633, '2017-09-17 10:29:13', NULL, NULL, 12965, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:29:13', 'admin-1505614815-15056153533867371', 1, 0, '', NULL, NULL, NULL),
(46634, '2017-09-17 10:29:22', NULL, NULL, 12965, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:29:22', 'admin-1505614815-1505615362416523', 1, 1, 'SR', NULL, NULL, NULL),
(46635, '2017-09-17 10:30:08', NULL, NULL, 12957, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:30:08', 'admin-1505614815-15056154085188030', 1, 0, '', NULL, NULL, NULL),
(46636, '2017-09-17 10:21:10', NULL, NULL, 12964, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:21:10', 'admin-1505614815-15056148700768377', 1, 1, 'SR', NULL, NULL, NULL),
(46637, '2017-09-17 09:57:03', NULL, NULL, 12960, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:57:03', 'admin-1505608753-15056134229753516', 1, 0, '', NULL, NULL, NULL),
(46638, '2017-09-17 09:57:03', NULL, NULL, 12960, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:57:03', 'admin-1505608753-15056134229753516', 1, 1, 'SR', NULL, NULL, NULL),
(46639, '2017-09-17 09:57:03', NULL, NULL, 12960, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:57:03', 'admin-1505608753-15056134229753516', 1, 1, 'SR', NULL, NULL, NULL),
(46640, '2017-09-17 10:07:51', NULL, NULL, 12961, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:07:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46641, '2017-09-17 17:11:10', NULL, NULL, 13013, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 17:11:10', 'admin-1505629426-15056394701206323', 1, 1, 'SR', NULL, NULL, NULL),
(46642, '2017-09-17 16:50:04', NULL, NULL, 13011, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 16:50:04', 'admin-1505629426-15056382040835297', 1, 0, '', NULL, NULL, NULL),
(46643, '2017-09-17 16:58:12', NULL, NULL, 13012, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 16:58:12', 'admin-1505629426-15056386926152869', 1, 0, '', 1, NULL, NULL),
(46644, '2017-09-17 00:00:00', NULL, NULL, 12992, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:40:08', 'admin-1505622616-15056232086093315', 1, 0, '', NULL, NULL, NULL),
(46645, '2017-09-17 13:12:32', NULL, NULL, 12989, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:12:32', 'admin-1505622616-1505625152387522', 1, 1, 'SR', NULL, NULL, NULL),
(46646, '2017-09-17 11:29:02', NULL, NULL, 12971, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:29:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46647, '2017-09-17 11:29:27', NULL, NULL, 12971, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:29:27', 'admin-1505614815-15056189676975383', 1, 0, '', NULL, NULL, NULL),
(46648, '2017-09-17 11:29:27', NULL, NULL, 12971, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:29:27', 'admin-1505614815-15056189676975383', 1, 0, '', NULL, NULL, NULL),
(46649, '2017-09-17 13:12:12', NULL, NULL, 12989, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:12:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46650, '2017-09-17 13:09:31', NULL, NULL, 12988, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:09:31', 'admin-1505622616-15056249711834822', 1, 0, '', NULL, NULL, NULL),
(46651, '2017-09-17 11:04:39', NULL, NULL, 12968, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:04:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46652, '2017-09-17 11:05:22', NULL, NULL, 12968, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:05:22', 'admin-1505614815-15056175218502013', 1, 0, '', NULL, NULL, NULL),
(46653, '2017-09-17 11:05:22', NULL, NULL, 12968, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:05:22', 'admin-1505614815-15056175218502013', 1, 0, '', NULL, NULL, NULL),
(46654, '2017-09-17 11:05:22', NULL, NULL, 12968, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:05:22', 'admin-1505614815-15056175218502013', 1, 0, '', NULL, NULL, NULL),
(46655, '2017-09-17 11:22:01', NULL, NULL, 12970, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:22:01', 'admin-1505614815-15056185208856647', 1, 1, 'SR', NULL, NULL, NULL),
(46656, '2017-09-17 13:09:15', NULL, NULL, 12988, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:09:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46657, '2017-09-17 12:45:29', NULL, NULL, 12982, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:45:29', 'admin-1505622616-15056235293554623', 1, 1, 'SR', NULL, NULL, NULL),
(46658, '2017-09-17 13:49:37', NULL, NULL, 12988, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:49:37', 'admin-1505625561-15056273774716672', 1, 1, 'SR', NULL, NULL, NULL),
(46659, '2017-09-17 13:07:53', NULL, NULL, 12987, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:07:53', 'admin-1505622616-15056248729378646', 1, 0, '', NULL, NULL, NULL),
(46660, '2017-09-17 13:04:20', NULL, NULL, 12979, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:04:20', 'admin-1505622616-15056246607294896', 1, 0, '', NULL, NULL, '10.0'),
(46661, '2017-09-17 12:30:10', NULL, NULL, 12978, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:30:10', 'admin-1505614815-15056226107273139', 1, 0, '', NULL, NULL, NULL),
(46662, '2017-09-17 12:29:05', NULL, NULL, 12978, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:29:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46663, '2017-09-17 12:29:37', NULL, NULL, 12978, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:29:37', 'admin-1505614815-15056225777766378', 1, 0, '', NULL, NULL, NULL),
(46664, '2017-09-17 12:29:37', NULL, NULL, 12978, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:29:38', 'admin-1505614815-15056225777766378', 1, 0, '', NULL, NULL, NULL),
(46665, '2017-09-17 12:29:38', NULL, NULL, 12978, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:29:38', 'admin-1505614815-15056225777766378', 1, 1, 'SR', NULL, NULL, NULL),
(46666, '2017-09-17 15:02:03', NULL, NULL, 13002, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:02:03', 'admin-1505629426-15056317232187047', 1, 1, 'SR', NULL, NULL, NULL),
(46667, '2017-09-17 13:00:29', NULL, NULL, 12986, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:00:29', 'admin-1505622616-150562442903569', 1, 1, 'SR', NULL, NULL, NULL),
(46668, '2017-09-17 11:50:08', NULL, NULL, 12975, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:50:08', 'admin-1505614815-15056202087234061', 1, 0, '', NULL, NULL, NULL),
(46669, '2017-09-17 15:15:11', NULL, NULL, 13003, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:15:11', 'admin-1505629426-15056325115145773', 1, 1, 'SR', NULL, NULL, NULL),
(46670, '2017-09-17 13:00:29', NULL, NULL, 12986, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:00:29', 'admin-1505622616-150562442903569', 1, 1, 'SR', NULL, NULL, NULL),
(46671, '2017-09-17 12:31:12', NULL, NULL, 12979, 0, 73, '73', 'Marmite Chicken ', 'ex rice', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:31:12', 'admin-1505622616-15056226722463453', 1, 1, 'SR', NULL, NULL, '10.0'),
(46672, '2017-09-17 12:39:15', NULL, NULL, 12980, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:39:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46673, '2017-09-17 12:39:22', NULL, NULL, 12980, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:39:22', 'admin-1505622616-15056231620294117', 1, 1, 'SR', NULL, NULL, NULL),
(46674, '2017-09-17 12:39:22', NULL, NULL, 12980, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:39:22', 'admin-1505622616-15056231620294117', 1, 1, 'SR', NULL, NULL, NULL),
(46675, '2017-09-17 15:24:39', NULL, NULL, 13005, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:24:39', 'admin-1505629426-15056330792153396', 1, 1, 'SR', NULL, NULL, NULL),
(46676, '2017-09-17 15:26:48', NULL, NULL, 13006, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:26:48', 'admin-1505629426-15056332081699527', 1, 1, 'SR', 1, NULL, '10.0'),
(46677, '2017-09-17 15:24:39', NULL, NULL, 13005, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:24:39', 'admin-1505629426-15056330792153396', 1, 1, 'SR', NULL, NULL, NULL),
(46678, '2017-09-17 12:59:33', NULL, NULL, 12986, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:59:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46679, '2017-09-17 13:09:31', NULL, NULL, 12988, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:09:31', 'admin-1505622616-15056249711834822', 1, 0, '', NULL, NULL, NULL),
(46680, '2017-09-17 12:53:14', NULL, NULL, 12985, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:53:14', 'admin-1505622616-15056239944127771', 1, 0, '', NULL, NULL, NULL),
(46681, '2017-09-17 12:18:26', NULL, NULL, 12976, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.45, 0.0000, 0.0000, 4.45, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:18:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46682, '2017-09-17 14:04:19', NULL, NULL, 12996, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 14:04:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46683, '2017-09-17 13:20:31', NULL, NULL, 12984, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:20:31', 'admin-1505625561-15056256313354734', 1, 1, 'SR', NULL, NULL, NULL),
(46684, '2017-09-17 12:53:14', NULL, NULL, 12985, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:53:14', 'admin-1505622616-15056239944127771', 1, 1, 'SR', NULL, NULL, NULL),
(46685, '2017-09-17 13:50:30', NULL, NULL, 12979, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:50:30', 'admin-1505625561-15056274299118378', 1, 1, 'SR', NULL, NULL, '10.0'),
(46686, '2017-09-17 12:50:01', NULL, NULL, 12984, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:50:01', 'admin-1505622616-15056238010253234', 1, 1, 'SR', NULL, NULL, NULL),
(46687, '2017-09-17 12:52:54', NULL, NULL, 12985, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:52:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46688, '2017-09-17 12:53:14', NULL, NULL, 12985, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:53:14', 'admin-1505622616-15056239944127771', 1, 0, '', NULL, NULL, NULL),
(46689, '2017-09-17 12:49:58', NULL, NULL, 12984, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:49:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46690, '2017-09-17 12:48:14', NULL, NULL, 12983, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:48:14', 'admin-1505622616-1505623693980313', 1, 1, 'SR', NULL, NULL, NULL),
(46691, '2017-09-17 12:48:14', NULL, NULL, 12983, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:48:14', 'admin-1505622616-1505623693980313', 1, 1, 'SR', NULL, NULL, NULL),
(46692, '2017-09-17 13:41:20', NULL, NULL, 12992, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:41:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46693, '2017-09-17 00:00:00', NULL, NULL, 12992, 0, 156, '90', 'House Cheddar Omelet', 'add bacon', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:40:02', 'admin-1505622616-1505623202765903', 1, 0, '', NULL, NULL, NULL),
(46694, '2017-09-17 12:45:12', NULL, NULL, 12982, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:45:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46695, '2017-09-17 12:45:20', NULL, NULL, 12982, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:45:20', 'admin-1505622616-1505623520566917', 1, 1, 'SR', NULL, NULL, NULL),
(46696, '2017-09-17 00:00:00', NULL, NULL, 12993, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:40:02', 'admin-1505622616-1505623202765903', 1, 0, '', NULL, NULL, NULL),
(46697, '2017-09-17 12:45:29', NULL, NULL, 12982, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:45:29', 'admin-1505622616-15056235293554623', 1, 0, '', NULL, NULL, NULL),
(46698, '2017-09-17 12:45:20', NULL, NULL, 12982, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:45:20', 'admin-1505622616-1505623520566917', 1, 0, '', NULL, NULL, NULL),
(46699, '2017-09-17 00:00:00', NULL, NULL, 12993, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, NULL, NULL, 1.60, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:39:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46700, '2017-09-17 12:30:10', NULL, NULL, 12978, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:30:10', 'admin-1505614815-15056226107273139', 1, 0, '', NULL, NULL, NULL),
(46701, '2017-09-17 12:30:10', NULL, NULL, 12978, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:30:10', 'admin-1505614815-15056226107273139', 1, 1, 'SR', NULL, NULL, NULL),
(46702, '2017-09-17 12:28:33', NULL, NULL, 12977, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:28:33', 'admin-1505614815-15056225130067078', 1, 0, '', NULL, NULL, NULL),
(46703, '2017-09-17 12:28:33', NULL, NULL, 12977, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:28:33', 'admin-1505614815-15056225130067078', 1, 0, '', NULL, NULL, NULL),
(46704, '2017-09-17 13:43:23', NULL, NULL, 12994, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:43:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46705, '2017-09-17 12:31:12', NULL, NULL, 12979, 0, 73, '73', 'Marmite Chicken ', 'ex rice', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:31:12', 'admin-1505622616-15056226722463453', 1, 1, 'SR', NULL, NULL, '10.0'),
(46706, '2017-09-17 12:19:00', NULL, NULL, 12976, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:19:00', 'admin-1505614815-15056219405503122', 1, 0, '', NULL, NULL, NULL),
(46707, '2017-09-17 12:19:00', NULL, NULL, 12976, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:19:00', 'admin-1505614815-15056219405503122', 1, 1, 'SR', NULL, NULL, NULL),
(46708, '2017-09-17 12:19:00', NULL, NULL, 12976, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:19:00', 'admin-1505614815-15056219405503122', 1, 0, '', NULL, NULL, NULL),
(46709, '2017-09-17 12:22:02', NULL, NULL, 12976, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:22:02', 'admin-1505614815-1505622122013513', 1, 0, '', NULL, NULL, NULL),
(46710, '2017-09-17 11:50:40', NULL, NULL, 12975, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:50:40', 'admin-1505614815-15056202405673383', 1, 1, 'SR', NULL, NULL, NULL),
(46711, '2017-09-17 11:50:40', NULL, NULL, 12975, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:50:40', 'admin-1505614815-15056202405673383', 1, 1, 'SR', NULL, NULL, NULL),
(46712, '2017-09-17 11:51:25', NULL, NULL, 12975, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:51:25', 'admin-1505614815-15056202855019335', 1, 1, 'SR', NULL, NULL, NULL),
(46713, '2017-09-17 11:51:25', NULL, NULL, 12975, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:51:25', 'admin-1505614815-15056202855019335', 1, 1, 'SR', NULL, NULL, NULL),
(46714, '2017-09-17 11:55:30', NULL, NULL, 12972, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:55:30', 'admin-1505614815-1505620530103233', 1, 0, '', NULL, NULL, NULL),
(46715, '2017-09-17 12:28:56', NULL, NULL, 12977, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:28:56', 'admin-1505614815-15056225364922162', 1, 1, 'SR', NULL, NULL, NULL),
(46716, '2017-09-17 11:05:22', NULL, NULL, 12968, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:05:22', 'admin-1505614815-15056175218502013', 1, 0, '', NULL, NULL, NULL),
(46717, '2017-09-17 11:05:22', NULL, NULL, 12968, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:05:22', 'admin-1505614815-15056175218502013', 1, 0, '', NULL, NULL, NULL),
(46718, '2017-09-17 11:05:22', NULL, NULL, 12968, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:05:22', 'admin-1505614815-15056175218502013', 1, 1, 'SR', NULL, NULL, NULL),
(46719, '2017-09-17 11:05:22', NULL, NULL, 12968, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:05:22', 'admin-1505614815-15056175218502013', 1, 1, 'SR', NULL, NULL, NULL),
(46720, '2017-09-17 11:16:27', NULL, NULL, 12969, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:16:27', 'admin-1505614815-15056181874562480', 1, 1, 'SR', NULL, NULL, NULL),
(46721, '2017-09-17 11:16:27', NULL, NULL, 12969, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:16:27', 'admin-1505614815-15056181874562480', 1, 0, '', NULL, NULL, NULL),
(46722, '2017-09-17 11:16:27', NULL, NULL, 12969, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:16:27', 'admin-1505614815-15056181874562480', 1, 0, '', NULL, NULL, NULL),
(46723, '2017-09-17 14:36:12', NULL, NULL, 13000, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 14:36:12', 'admin-1505629426-15056301722836016', 1, 1, 'SR', NULL, NULL, NULL),
(46724, '2017-09-17 13:46:37', NULL, NULL, 12995, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:46:37', 'admin-1505625561-15056271970651333', 1, 1, 'SR', NULL, NULL, '10.0'),
(46725, '2017-09-17 12:28:48', NULL, NULL, 12977, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:28:48', 'admin-1505614815-15056225286767796', 1, 1, 'SR', NULL, NULL, NULL),
(46726, '2017-09-17 12:28:25', NULL, NULL, 12977, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:28:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46727, '2017-09-17 11:39:50', NULL, NULL, 12973, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:39:50', 'admin-1505614815-15056195898716635', 1, 1, 'SR', NULL, NULL, NULL),
(46728, '2017-09-17 11:22:01', NULL, NULL, 12970, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:22:01', 'admin-1505614815-15056185208856647', 1, 1, 'SR', NULL, NULL, NULL),
(46729, '2017-09-17 12:15:19', NULL, NULL, 12973, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:15:19', 'admin-1505614815-15056217195328073', 1, 1, 'SR', NULL, NULL, NULL),
(46730, '2017-09-17 10:55:16', NULL, NULL, 12967, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:55:16', 'admin-1505614815-15056169159286994', 1, 1, 'SR', NULL, NULL, NULL),
(46731, '2017-09-17 10:07:59', NULL, NULL, 12961, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:07:59', 'admin-1505608753-1505614079760585', 1, 1, 'SR', NULL, NULL, NULL),
(46732, '2017-09-17 10:07:59', NULL, NULL, 12961, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:07:59', 'admin-1505608753-1505614079760585', 1, 1, 'SR', NULL, NULL, NULL),
(46733, '2017-09-17 11:22:01', NULL, NULL, 12970, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:22:01', 'admin-1505614815-15056185208856647', 1, 1, 'SR', NULL, NULL, NULL),
(46734, '2017-09-17 13:15:04', NULL, NULL, 12990, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:15:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46735, '2017-09-17 11:50:40', NULL, NULL, 12975, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:50:40', 'admin-1505614815-15056202405673383', 1, 0, '', NULL, NULL, NULL),
(46736, '2017-09-17 12:30:58', NULL, NULL, 12979, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 18.20, 0.0000, 0.0000, 18.20, 1, '27', 1, '1505629426', 'admin', '2017-09-17 12:30:58', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(46737, '2017-09-17 11:50:09', NULL, NULL, 12975, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:50:09', 'admin-1505614815-15056202087234061', 1, 0, '', NULL, NULL, NULL),
(46738, '2017-09-17 11:49:13', NULL, NULL, 12975, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.40, 0.0000, 0.0000, 13.40, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:49:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46739, '2017-09-17 11:50:08', NULL, NULL, 12975, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:50:08', 'admin-1505614815-15056202087234061', 1, 0, '', NULL, NULL, NULL),
(46740, '2017-09-17 11:49:09', NULL, NULL, 12974, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:49:09', 'admin-1505614815-15056201489855812', 1, 1, 'SR', NULL, NULL, NULL),
(46741, '2017-09-17 11:39:50', NULL, NULL, 12973, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:39:50', 'admin-1505614815-15056195898716635', 1, 0, '', NULL, NULL, NULL),
(46742, '2017-09-17 11:39:34', NULL, NULL, 12973, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:39:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46743, '2017-09-17 11:34:29', NULL, NULL, 12972, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:34:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46744, '2017-09-17 11:34:40', NULL, NULL, 12972, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:34:40', 'admin-1505614815-1505619279874368', 1, 0, '', NULL, NULL, NULL),
(46745, '2017-09-17 11:34:40', NULL, NULL, 12972, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:34:40', 'admin-1505614815-1505619279874368', 1, 1, 'SR', NULL, NULL, NULL),
(46746, '2017-09-17 10:40:17', NULL, NULL, 12962, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:40:17', 'admin-1505614815-15056160174427342', 1, 0, '', NULL, NULL, NULL),
(46747, '2017-09-17 10:40:17', NULL, NULL, 12962, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:40:17', 'admin-1505614815-15056160174427342', 1, 0, '', NULL, NULL, NULL),
(46748, '2017-09-17 10:47:49', NULL, NULL, 12966, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:47:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46749, '2017-09-17 10:20:27', NULL, NULL, 12958, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:20:27', 'admin-1505614815-15056148268504385', 1, 0, '', NULL, NULL, NULL),
(46750, '2017-09-17 10:20:58', NULL, NULL, 12964, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:20:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46751, '2017-09-17 10:21:10', NULL, NULL, 12964, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:21:10', 'admin-1505614815-15056148700768377', 1, 0, '', NULL, NULL, NULL),
(46752, '2017-09-17 10:21:10', NULL, NULL, 12964, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:21:10', 'admin-1505614815-15056148700768377', 1, 0, '', NULL, NULL, NULL),
(46753, '2017-09-17 13:04:03', NULL, NULL, 12979, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:04:03', 'admin-1505622616-15056246433653693', 1, 0, '', NULL, NULL, '10.0'),
(46754, '2017-09-17 11:22:01', NULL, NULL, 12970, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:22:01', 'admin-1505614815-15056185208856647', 1, 1, 'SR', NULL, NULL, NULL),
(46755, '2017-09-17 11:22:01', NULL, NULL, 12970, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:22:01', 'admin-1505614815-15056185208856647', 1, 1, 'SR', NULL, NULL, NULL),
(46756, '2017-09-17 11:22:01', NULL, NULL, 12970, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:22:01', 'admin-1505614815-15056185208856647', 1, 1, 'SR', NULL, NULL, NULL),
(46757, '2017-09-17 10:19:23', NULL, NULL, 12963, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:19:23', 'admin-1505608753-15056147633738186', 1, 1, 'SR', NULL, NULL, NULL),
(46758, '2017-09-17 13:20:31', NULL, NULL, 12984, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:20:31', 'admin-1505625561-15056256313354734', 1, 0, '', NULL, NULL, NULL),
(46759, '2017-09-17 11:22:01', NULL, NULL, 12970, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:22:01', 'admin-1505614815-15056185208856647', 1, 1, 'SR', NULL, NULL, NULL),
(46760, '2017-09-17 10:47:55', NULL, NULL, 12966, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:47:55', 'admin-1505614815-15056164755524959', 1, 0, '', NULL, NULL, NULL),
(46761, '2017-09-17 10:47:55', NULL, NULL, 12966, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:47:55', 'admin-1505614815-15056164755524959', 1, 0, '', NULL, NULL, NULL),
(46762, '2017-09-17 10:47:55', NULL, NULL, 12966, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:47:55', 'admin-1505614815-15056164755524959', 1, 0, '', NULL, NULL, NULL),
(46763, '2017-09-17 11:22:01', NULL, NULL, 12970, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:22:01', 'admin-1505614815-15056185208856647', 1, 1, 'SR', NULL, NULL, NULL),
(46764, '2017-09-17 13:04:03', NULL, NULL, 12979, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:04:03', 'admin-1505622616-15056246433653693', 1, 0, '', NULL, NULL, '10.0'),
(46765, '2017-09-17 10:40:17', NULL, NULL, 12962, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:40:17', 'admin-1505614815-15056160174427342', 1, 0, '', NULL, NULL, NULL),
(46766, '2017-09-17 15:23:17', NULL, NULL, 13004, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 15:23:17', 'admin-1505629426-15056329977308053', 1, 0, '', NULL, NULL, NULL),
(46767, '2017-09-17 14:36:12', NULL, NULL, 13000, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 14:36:12', 'admin-1505629426-15056301722836016', 1, 0, '', NULL, NULL, NULL),
(46768, '2017-09-17 11:16:27', NULL, NULL, 12969, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:16:27', 'admin-1505614815-15056181874562480', 1, 0, '', NULL, NULL, NULL),
(46769, '2017-09-17 10:55:09', NULL, NULL, 12967, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:55:09', 'admin-1505614815-15056169094105179', 1, 0, '', NULL, NULL, NULL),
(46770, '2017-09-17 11:29:43', NULL, NULL, 12962, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:29:43', 'admin-1505614815-15056189832172431', 1, 0, '', NULL, NULL, NULL),
(46771, '2017-09-17 10:55:09', NULL, NULL, 12967, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:55:09', 'admin-1505614815-15056169094105179', 1, 0, '', NULL, NULL, NULL),
(46772, '2017-09-17 11:21:11', NULL, NULL, 12970, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:21:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46773, '2017-09-17 10:54:45', NULL, NULL, 12967, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:54:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46774, '2017-09-17 13:12:20', NULL, NULL, 12989, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:12:20', 'admin-1505622616-15056251407563927', 1, 1, 'SR', NULL, NULL, NULL),
(46775, '2017-09-17 11:22:01', NULL, NULL, 12970, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:22:01', 'admin-1505614815-15056185208856647', 1, 1, 'SR', NULL, NULL, NULL),
(46776, '2017-09-17 17:10:56', NULL, NULL, 13013, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1505629426', 'admin', '2017-09-17 17:10:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46777, '2017-09-17 10:18:11', NULL, NULL, 12962, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:18:11', 'admin-1505608753-15056146912253041', 1, 1, 'SR', NULL, NULL, NULL),
(46778, '2017-09-17 10:19:05', NULL, NULL, 12963, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:19:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46779, '2017-09-17 10:19:23', NULL, NULL, 12963, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:19:23', 'admin-1505608753-15056147633738186', 1, 0, '', NULL, NULL, NULL),
(46780, '2017-09-17 10:17:52', NULL, NULL, 12962, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.40, 0.0000, 0.0000, 13.40, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:17:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46781, '2017-09-17 10:18:01', NULL, NULL, 12962, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:18:01', 'admin-1505608753-15056146816917530', 1, 0, '', NULL, NULL, NULL),
(46782, '2017-09-17 10:18:01', NULL, NULL, 12962, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:18:01', 'admin-1505608753-15056146816917530', 1, 0, '', NULL, NULL, NULL),
(46783, '2017-09-17 09:54:01', NULL, NULL, 12959, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:54:01', 'admin-1505608753-1505613241745347', 1, 0, '', NULL, NULL, NULL),
(46784, '2017-09-17 09:56:52', NULL, NULL, 12960, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:56:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46785, '2017-09-17 09:57:03', NULL, NULL, 12960, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:57:03', 'admin-1505608753-15056134229753516', 1, 0, '', NULL, NULL, NULL),
(46786, '2017-09-17 11:15:59', NULL, NULL, 12969, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1505629426', 'admin', '2017-09-17 11:15:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46787, '2017-09-17 10:18:01', NULL, NULL, 12962, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:18:01', 'admin-1505608753-15056146816917530', 1, 0, '', NULL, NULL, NULL),
(46788, '2017-09-17 10:18:01', NULL, NULL, 12962, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:18:01', 'admin-1505608753-15056146816917530', 1, 0, '', NULL, NULL, NULL),
(46789, '2017-09-17 10:18:11', NULL, NULL, 12962, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 10:18:11', 'admin-1505608753-15056146912253041', 1, 1, 'SR', NULL, NULL, NULL),
(46790, '2017-09-17 09:13:57', NULL, NULL, 12955, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:13:57', 'admin-1505608753-15056108369044312', 1, 0, '', NULL, NULL, NULL),
(46791, '2017-09-17 09:13:57', NULL, NULL, 12955, 0, 153, '87', 'Wake Me Up!', ' ex sausage,no bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:13:57', 'admin-1505608753-15056108369044312', 1, 0, '', NULL, NULL, NULL),
(46792, '2017-09-17 09:14:17', NULL, NULL, 12955, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:14:17', 'admin-1505608753-15056108577531224', 1, 1, 'SR', NULL, NULL, NULL),
(46793, '2017-09-17 09:14:17', NULL, NULL, 12955, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:14:17', 'admin-1505608753-15056108577531224', 1, 1, 'SR', NULL, NULL, NULL),
(46794, '2017-09-17 09:14:17', NULL, NULL, 12955, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:14:17', 'admin-1505608753-15056108577531224', 1, 0, '', NULL, NULL, NULL),
(46795, '2017-09-17 09:14:17', NULL, NULL, 12955, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:14:17', 'admin-1505608753-15056108577531224', 1, 1, 'SR', NULL, NULL, NULL),
(46796, '2017-09-17 09:29:07', NULL, NULL, 12956, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:29:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46797, '2017-09-17 09:29:31', NULL, NULL, 12956, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:29:31', 'admin-1505608753-15056117713984781', 1, 0, '', NULL, NULL, NULL),
(46798, '2017-09-17 09:29:31', NULL, NULL, 12956, 0, 155, '89', 'Cheesy Chicken Gratin', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:29:31', 'admin-1505608753-15056117713984781', 1, 0, '', NULL, NULL, NULL),
(46799, '2017-09-17 09:29:31', NULL, NULL, 12956, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:29:31', 'admin-1505608753-15056117713984781', 1, 0, '', NULL, NULL, NULL),
(46800, '2017-09-17 09:31:30', NULL, NULL, 12956, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:31:30', 'admin-1505608753-15056118899007120', 1, 1, 'SR', NULL, NULL, NULL),
(46801, '2017-09-17 09:31:30', NULL, NULL, 12956, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:31:30', 'admin-1505608753-15056118899007120', 1, 1, 'SR', NULL, NULL, NULL),
(46802, '2017-09-17 09:31:30', NULL, NULL, 12956, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:31:30', 'admin-1505608753-15056118899007120', 1, 0, '', NULL, NULL, NULL),
(46803, '2017-09-17 09:33:41', NULL, NULL, 12957, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:33:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46804, '2017-09-17 09:33:52', NULL, NULL, 12957, 0, 153, '87', 'Wake Me Up!', 'sunny side up', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:33:52', 'admin-1505608753-15056120321641541', 1, 0, '', NULL, NULL, NULL),
(46805, '2017-09-17 09:34:06', NULL, NULL, 12957, 0, 153, '87', 'Wake Me Up!', 'sunny side up', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:34:06', 'admin-1505608753-15056120463941954', 1, 0, '', NULL, NULL, NULL),
(46806, '2017-09-17 09:34:12', NULL, NULL, 12957, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:34:12', 'admin-1505608753-15056120520718744', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(46807, '2017-09-17 09:34:12', NULL, NULL, 12957, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:34:12', 'admin-1505608753-15056120520718744', 1, 1, 'SR', NULL, NULL, NULL),
(46808, '2017-09-17 13:07:11', NULL, NULL, 12987, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 13:07:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46809, '2017-09-17 09:54:01', NULL, NULL, 12959, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:54:01', 'admin-1505608753-1505613241745347', 1, 0, '', NULL, NULL, NULL),
(46810, '2017-09-17 09:54:01', NULL, NULL, 12959, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:54:01', 'admin-1505608753-1505613241745347', 1, 0, '', NULL, NULL, NULL),
(46811, '2017-09-17 09:53:49', NULL, NULL, 12959, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:53:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46812, '2017-09-17 09:50:25', NULL, NULL, 12958, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:50:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46813, '2017-09-17 09:51:00', NULL, NULL, 12958, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:51:00', 'admin-1505608753-15056130603558313', 1, 1, 'SR', NULL, NULL, NULL),
(46814, '2017-09-17 09:51:18', NULL, NULL, 12958, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:51:18', 'admin-1505608753-15056130786456642', 1, 1, 'SR', NULL, NULL, NULL),
(46815, '2017-09-17 09:51:00', NULL, NULL, 12958, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:51:00', 'admin-1505608753-15056130603558313', 1, 1, 'SR', NULL, NULL, NULL),
(46816, '2017-09-17 09:13:57', NULL, NULL, 12955, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:13:57', 'admin-1505608753-15056108369044312', 1, 0, '', NULL, NULL, NULL),
(46817, '2017-09-17 09:13:57', NULL, NULL, 12955, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:13:57', 'admin-1505608753-15056108369044312', 1, 0, '', NULL, NULL, NULL),
(46818, '2017-09-17 09:08:56', NULL, NULL, 12955, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.20, 0.0000, 0.0000, 11.20, 1, '27', 1, '1505629426', 'admin', '2017-09-17 09:08:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46819, '2017-09-18 13:41:19', NULL, NULL, 13032, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 13:41:19', 'admin-1505708590-15057132797393076', 1, 1, 'SR', 1, NULL, '10.0'),
(46820, '2017-09-18 13:55:23', NULL, NULL, 13033, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1505708590', 'admin', '2017-09-18 13:55:23', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(46821, '2017-09-18 13:55:43', NULL, NULL, 13033, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 13:55:43', 'admin-1505708590-15057141435179639', 1, 0, '', NULL, NULL, '10.0'),
(46822, '2017-09-18 12:57:20', NULL, NULL, 13025, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:57:20', 'admin-1505708590-15057106407122859', 1, 1, 'SR', NULL, NULL, NULL),
(46823, '2017-09-18 12:57:20', NULL, NULL, 13025, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:57:20', 'admin-1505708590-15057106407122859', 1, 1, 'SR', NULL, NULL, NULL),
(46824, '2017-09-18 12:59:39', NULL, NULL, 13026, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:59:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46825, '2017-09-18 09:25:05', NULL, NULL, 13015, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 09:25:05', 'admin-1505696771-15056979053897157', 1, 0, '', NULL, NULL, NULL),
(46826, '2017-09-18 09:25:05', NULL, NULL, 13015, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 09:25:05', 'admin-1505696771-15056979053897157', 1, 0, '', NULL, NULL, NULL),
(46827, '2017-09-18 09:25:15', NULL, NULL, 13015, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 09:25:15', 'admin-1505696771-15056979149001818', 1, 1, 'SR', NULL, NULL, NULL),
(46828, '2017-09-18 09:25:15', NULL, NULL, 13015, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 09:25:15', 'admin-1505696771-15056979149001818', 1, 1, 'SR', NULL, NULL, NULL),
(46829, '2017-09-18 09:25:15', NULL, NULL, 13015, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 09:25:15', 'admin-1505696771-15056979149001818', 1, 1, 'SR', NULL, NULL, NULL),
(46830, '2017-09-18 09:25:15', NULL, NULL, 13015, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 09:25:15', 'admin-1505696771-15056979149001818', 1, 0, '', NULL, NULL, NULL),
(46831, '2017-09-18 09:28:13', NULL, NULL, 13015, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 09:28:13', 'admin-1505696771-15056980933765113', 1, 1, 'SR', NULL, NULL, NULL),
(46832, '2017-09-18 09:48:41', NULL, NULL, 13016, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.30, 0.0000, 0.0000, 11.30, 1, '27', 1, '1505708590', 'admin', '2017-09-18 09:48:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46833, '2017-09-18 09:49:02', NULL, NULL, 13016, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 09:49:02', 'admin-1505696771-15056993423381090', 1, 0, '', NULL, NULL, NULL),
(46834, '2017-09-18 09:49:02', NULL, NULL, 13016, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 09:49:02', 'admin-1505696771-15056993423381090', 1, 0, '', NULL, NULL, NULL),
(46835, '2017-09-18 09:49:02', NULL, NULL, 13016, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 09:49:02', 'admin-1505696771-15056993423381090', 1, 0, '', NULL, NULL, NULL),
(46836, '2017-09-18 09:49:02', NULL, NULL, 13016, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 09:49:02', 'admin-1505696771-15056993423381090', 1, 1, 'SR', NULL, NULL, NULL),
(46837, '2017-09-18 09:49:02', NULL, NULL, 13016, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 09:49:02', 'admin-1505696771-15056993423381090', 1, 1, 'SR', NULL, NULL, NULL),
(46838, '2017-09-18 09:49:02', NULL, NULL, 13016, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 09:49:02', 'admin-1505696771-15056993423381090', 1, 1, 'SR', NULL, NULL, NULL),
(46839, '2017-09-18 09:24:54', NULL, NULL, 13015, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.90, 0.0000, 0.0000, 12.90, 1, '27', 1, '1505708590', 'admin', '2017-09-18 09:24:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46840, '2017-09-18 13:00:12', NULL, NULL, 13026, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 13:00:12', 'admin-1505708590-15057108127312210', 1, 0, '', NULL, NULL, NULL),
(46841, '2017-09-18 13:02:08', NULL, NULL, 13026, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 13:02:08', 'admin-1505708590-15057109283978453', 1, 0, '', NULL, NULL, NULL),
(46842, '2017-09-18 00:00:00', NULL, NULL, 13029, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 13:05:26', 'admin-1505708590-15057111264943846', 1, 0, '', NULL, NULL, NULL),
(46843, '2017-09-18 00:00:00', NULL, NULL, 13030, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 13:05:26', 'admin-1505708590-15057111264943846', 1, 0, '', NULL, NULL, NULL),
(46844, '2017-09-18 13:33:29', NULL, NULL, 13031, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 13:33:29', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(46845, '2017-09-18 13:33:43', NULL, NULL, 13031, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 13:33:43', 'admin-1505708590-15057128236829194', 1, 0, '', NULL, NULL, '10.0'),
(46846, '2017-09-18 15:57:49', NULL, NULL, 13034, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1505708590', 'admin', '2017-09-18 15:57:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46847, '2017-09-18 00:00:00', NULL, NULL, 13029, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:44:17', 'admin-1505708590-15057098572472938', 1, 0, '', NULL, NULL, NULL),
(46848, '2017-09-18 10:11:52', NULL, NULL, 13017, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 10:11:52', 'admin-1505696771-15057007122605665', 1, 0, '', NULL, NULL, NULL),
(46849, '2017-09-18 13:24:37', NULL, NULL, 13028, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1505708590', 'admin', '2017-09-18 13:24:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46850, '2017-09-18 00:00:00', NULL, NULL, 13028, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:44:17', 'admin-1505708590-15057098572472938', 1, 0, '', NULL, NULL, NULL),
(46851, '2017-09-18 13:25:12', NULL, NULL, 13029, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1505708590', 'admin', '2017-09-18 13:25:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46852, '2017-09-18 17:16:20', NULL, NULL, 13036, 0, 182, '117', 'Open Drinks ', 'coffee beans', 'Cold Drinks', 'Fresh Juice', 1, 38.00, 38.0000, 0.0000, 38.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 17:16:20', 'admin-1505708590-1505726180734388', 1, 0, '', 1, NULL, NULL),
(46853, '2017-09-18 12:24:07', NULL, NULL, 13023, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:24:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46854, '2017-09-18 12:24:12', NULL, NULL, 13023, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:24:12', 'admin-1505708590-15057086527394838', 1, 0, '', NULL, NULL, NULL),
(46855, '2017-09-18 12:25:23', NULL, NULL, 13023, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:25:23', 'admin-1505708590-1505708723263316', 1, 0, '', NULL, NULL, NULL),
(46856, '2017-09-18 12:25:23', NULL, NULL, 13023, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:25:23', 'admin-1505708590-1505708723263316', 1, 0, '', NULL, NULL, NULL),
(46857, '2017-09-18 12:25:23', NULL, NULL, 13023, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:25:23', 'admin-1505708590-1505708723263316', 1, 1, 'SR', NULL, NULL, NULL),
(46858, '2017-09-18 12:25:23', NULL, NULL, 13023, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:25:23', 'admin-1505708590-1505708723263316', 1, 1, 'SR', NULL, NULL, NULL),
(46859, '2017-09-18 12:27:20', NULL, NULL, 13023, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:27:20', 'admin-1505708590-15057088402171614', 1, 1, 'SR', NULL, NULL, NULL),
(46860, '2017-09-18 12:27:20', NULL, NULL, 13023, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:27:20', 'admin-1505708590-15057088402171614', 1, 1, 'SR', NULL, NULL, NULL),
(46861, '2017-09-18 12:27:20', NULL, NULL, 13023, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:27:20', 'admin-1505708590-15057088402171614', 1, 1, 'SR', NULL, NULL, NULL),
(46862, '2017-09-18 00:00:00', NULL, NULL, 13029, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:44:35', 'admin-1505708590-15057098749156513', 1, 1, 'SR', NULL, NULL, NULL),
(46863, '2017-09-18 00:00:00', NULL, NULL, 13028, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:44:35', 'admin-1505708590-15057098749156513', 1, 1, 'SR', NULL, NULL, NULL),
(46864, '2017-09-18 13:21:09', NULL, NULL, 13027, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1505708590', 'admin', '2017-09-18 13:21:09', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(46865, '2017-09-18 00:00:00', NULL, NULL, 13028, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:44:17', 'admin-1505708590-15057098572472938', 1, 0, '', NULL, NULL, NULL),
(46866, '2017-09-18 12:56:18', NULL, NULL, 13025, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:56:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46867, '2017-09-18 12:56:56', NULL, NULL, 13025, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:56:56', 'admin-1505708590-1505710615790537', 1, 0, '', NULL, NULL, NULL),
(46868, '2017-09-18 00:00:00', NULL, NULL, 13030, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, NULL, NULL, 3.10, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:43:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46869, '2017-09-18 13:21:18', NULL, NULL, 13027, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 13:21:18', 'admin-1505708590-15057120781735789', 1, 0, '', NULL, NULL, '10.0'),
(46870, '2017-09-18 13:21:18', NULL, NULL, 13027, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 13:21:18', 'admin-1505708590-15057120781735789', 1, 1, 'SR', NULL, NULL, '10.0'),
(46871, '2017-09-18 00:00:00', NULL, NULL, 13028, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 13:05:26', 'admin-1505708590-15057111264943846', 1, 0, '', NULL, NULL, NULL),
(46872, '2017-09-18 10:49:06', NULL, NULL, 13019, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 10:49:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46873, '2017-09-18 15:57:53', NULL, NULL, 13034, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 15:57:53', 'admin-1505708590-15057214728217920', 1, 1, 'SR', NULL, NULL, NULL),
(46874, '2017-09-18 16:23:48', NULL, NULL, 13035, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1505708590', 'admin', '2017-09-18 16:23:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46875, '2017-09-18 16:23:51', NULL, NULL, 13035, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 16:23:51', 'admin-1505708590-15057230312536281', 1, 1, 'SR', NULL, NULL, NULL),
(46876, '2017-09-18 13:55:43', NULL, NULL, 13033, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 13:55:43', 'admin-1505708590-15057141435179639', 1, 0, '', NULL, NULL, '10.0'),
(46877, '2017-09-18 13:33:43', NULL, NULL, 13031, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 13:33:43', 'admin-1505708590-15057128236829194', 1, 0, '', NULL, NULL, '10.0'),
(46878, '2017-09-18 00:00:00', NULL, NULL, 13030, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:44:35', 'admin-1505708590-15057098749156513', 1, 0, '', NULL, NULL, NULL),
(46879, '2017-09-18 12:57:20', NULL, NULL, 13025, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:57:20', 'admin-1505708590-15057106407122859', 1, 1, 'SR', NULL, NULL, NULL),
(46880, '2017-09-18 12:56:56', NULL, NULL, 13025, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:56:56', 'admin-1505708590-1505710615790537', 1, 1, 'SR', NULL, NULL, NULL),
(46881, '2017-09-18 12:56:56', NULL, NULL, 13025, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:56:56', 'admin-1505708590-1505710615790537', 1, 1, 'SR', NULL, NULL, NULL),
(46882, '2017-09-18 00:00:00', NULL, NULL, 13030, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:44:17', 'admin-1505708590-15057098572472938', 1, 0, '', NULL, NULL, NULL),
(46883, '2017-09-18 00:00:00', NULL, NULL, 13028, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:44:35', 'admin-1505708590-15057098749156513', 1, 1, 'SR', NULL, NULL, NULL),
(46884, '2017-09-18 10:11:52', NULL, NULL, 13017, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 10:11:52', 'admin-1505696771-15057007122605665', 1, 0, '', NULL, NULL, NULL),
(46885, '2017-09-18 10:11:52', NULL, NULL, 13017, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 10:11:52', 'admin-1505696771-15057007122605665', 1, 1, 'SR', NULL, NULL, NULL),
(46886, '2017-09-18 10:11:52', NULL, NULL, 13017, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 10:11:52', 'admin-1505696771-15057007122605665', 1, 0, '', NULL, NULL, NULL),
(46887, '2017-09-18 12:09:38', NULL, NULL, 13022, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:09:38', 'admin-1505696771-15057077783435334', 1, 1, 'SR', NULL, NULL, NULL),
(46888, '2017-09-18 12:09:38', NULL, NULL, 13022, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:09:38', 'admin-1505696771-15057077783435334', 1, 1, 'SR', NULL, NULL, NULL),
(46889, '2017-09-18 12:09:38', NULL, NULL, 13022, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:09:38', 'admin-1505696771-15057077783435334', 1, 1, 'SR', NULL, NULL, NULL),
(46890, '2017-09-18 09:17:03', NULL, NULL, 13014, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 09:17:03', 'admin-1505696771-15056974229012084', 1, 0, '', NULL, NULL, NULL),
(46891, '2017-09-18 12:09:38', NULL, NULL, 13022, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:09:38', 'admin-1505696771-15057077783435334', 1, 0, '', NULL, NULL, NULL),
(46892, '2017-09-18 12:09:18', NULL, NULL, 13022, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:09:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46893, '2017-09-18 12:07:11', NULL, NULL, 13021, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:07:11', 'admin-1505696771-15057076316452833', 1, 1, 'SR', NULL, NULL, NULL),
(46894, '2017-09-18 12:06:55', NULL, NULL, 13021, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:06:55', 'admin-1505696771-15057076152677446', 1, 0, '', NULL, NULL, NULL),
(46895, '2017-09-18 12:06:45', NULL, NULL, 13021, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1505708590', 'admin', '2017-09-18 12:06:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46896, '2017-09-18 11:27:35', NULL, NULL, 13020, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 11:27:35', 'admin-1505696771-1505705254824937', 1, 1, 'SR', NULL, NULL, NULL),
(46897, '2017-09-18 11:27:34', NULL, NULL, 13020, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 11:27:35', 'admin-1505696771-1505705254824937', 1, 0, '', NULL, NULL, NULL),
(46898, '2017-09-18 11:27:34', NULL, NULL, 13020, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 11:27:34', 'admin-1505696771-1505705254824937', 1, 0, '', NULL, NULL, NULL),
(46899, '2017-09-18 11:27:22', NULL, NULL, 13020, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1505708590', 'admin', '2017-09-18 11:27:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46900, '2017-09-18 10:49:19', NULL, NULL, 13019, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 10:49:19', 'admin-1505696771-15057029590119495', 1, 1, 'SR', NULL, NULL, NULL),
(46901, '2017-09-18 10:49:19', NULL, NULL, 13019, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 10:49:19', 'admin-1505696771-15057029590119495', 1, 0, '', NULL, NULL, NULL),
(46902, '2017-09-18 10:49:19', NULL, NULL, 13019, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 10:49:19', 'admin-1505696771-15057029590119495', 1, 0, '', NULL, NULL, NULL),
(46903, '2017-09-18 10:21:19', NULL, NULL, 13018, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 10:21:19', 'admin-1505696771-1505701279607738', 1, 1, 'SR', NULL, NULL, NULL),
(46904, '2017-09-18 10:21:19', NULL, NULL, 13018, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 10:21:19', 'admin-1505696771-1505701279607738', 1, 1, 'SR', NULL, NULL, NULL),
(46905, '2017-09-18 10:21:14', NULL, NULL, 13018, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 10:21:14', 'admin-1505696771-15057012744254360', 1, 0, '', NULL, NULL, NULL),
(46906, '2017-09-18 10:21:14', NULL, NULL, 13018, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 10:21:14', 'admin-1505696771-15057012744254360', 1, 0, '', NULL, NULL, NULL),
(46907, '2017-09-18 13:33:43', NULL, NULL, 13031, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 13:33:43', 'admin-1505708590-15057128236829194', 1, 0, '', NULL, NULL, '10.0'),
(46908, '2017-09-18 10:21:03', NULL, NULL, 13018, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1505708590', 'admin', '2017-09-18 10:21:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46909, '2017-09-18 10:19:32', NULL, NULL, 13016, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 10:19:32', 'admin-1505696771-15057011724046658', 1, 1, 'SR', NULL, NULL, NULL),
(46910, '2017-09-18 10:11:32', NULL, NULL, 13017, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1505708590', 'admin', '2017-09-18 10:11:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46911, '2017-09-18 09:25:05', NULL, NULL, 13015, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 09:25:05', 'admin-1505696771-15056979053897157', 1, 0, '', NULL, NULL, NULL),
(46912, '2017-09-18 09:25:05', NULL, NULL, 13015, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 09:25:05', 'admin-1505696771-15056979053897157', 1, 0, '', NULL, NULL, NULL),
(46913, '2017-09-18 09:17:03', NULL, NULL, 13014, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505708590', 'admin', '2017-09-18 09:17:03', 'admin-1505696771-15056974229012084', 1, 1, 'SR', NULL, NULL, NULL),
(46914, '2017-09-18 09:16:57', NULL, NULL, 13014, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1505708590', 'admin', '2017-09-18 09:16:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46915, '2017-09-20 13:09:35', NULL, NULL, 13050, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 13:09:35', 'admin-1505873825-15058841749139212', 1, 1, 'SR', NULL, NULL, NULL),
(46916, '2017-09-20 13:09:35', NULL, NULL, 13050, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 13:09:35', 'admin-1505873825-15058841749139212', 1, 1, 'SR', NULL, NULL, NULL),
(46917, '2017-09-20 13:09:35', NULL, NULL, 13050, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 13:09:35', 'admin-1505873825-15058841749139212', 1, 1, 'SR', NULL, NULL, NULL),
(46918, '2017-09-20 12:44:07', NULL, NULL, 13048, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1505893878', 'admin', '2017-09-20 12:44:07', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(46919, '2017-09-20 12:44:17', NULL, NULL, 13048, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 12:44:17', 'admin-1505873825-15058826574696550', 1, 0, '', NULL, NULL, '10.0'),
(46920, '2017-09-20 09:47:10', NULL, NULL, 13039, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:47:10', 'admin-1505869259-15058720305646177', 1, 0, '', NULL, NULL, NULL),
(46921, '2017-09-20 17:18:25', NULL, NULL, 13052, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 17:18:25', 'admin-1505893878-1505899104842392', 1, 0, '', NULL, NULL, NULL),
(46922, '2017-09-20 17:05:03', NULL, NULL, 13058, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 17:05:03', 'admin-1505893878-15058983034614736', 1, 1, 'SR', NULL, NULL, NULL),
(46923, '2017-09-20 17:05:03', NULL, NULL, 13058, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 17:05:03', 'admin-1505893878-15058983034614736', 1, 1, 'SR', NULL, NULL, NULL),
(46924, '2017-09-20 17:04:17', NULL, NULL, 13058, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1505893878', 'admin', '2017-09-20 17:04:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46925, '2017-09-20 15:45:11', NULL, NULL, 13057, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 15:45:11', 'admin-1505873825-15058935109263995', 1, 1, 'SR', NULL, NULL, NULL),
(46926, '2017-09-20 15:45:11', NULL, NULL, 13057, 0, 181, '116', 'Open Food ', 'Scones', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 15:45:11', 'admin-1505873825-15058935109263995', 1, 0, '', NULL, NULL, NULL),
(46927, '2017-09-20 15:44:55', NULL, NULL, 13057, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1505893878', 'admin', '2017-09-20 15:44:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46928, '2017-09-20 15:29:33', NULL, NULL, 13056, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 15:29:33', 'admin-1505873825-15058925728512832', 1, 1, 'SR', NULL, NULL, NULL),
(46929, '2017-09-20 12:52:07', NULL, NULL, 13048, 0, 154, '88', 'Daily Dose BLT', 'bacon change sausage', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 12:52:07', 'admin-1505873825-15058831270866981', 1, 0, '', NULL, NULL, '10.0'),
(46930, '2017-09-20 11:50:01', NULL, NULL, 13047, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1505893878', 'admin', '2017-09-20 11:50:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46931, '2017-09-20 11:50:29', NULL, NULL, 13047, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 11:50:29', 'admin-1505873825-1505879429109861', 1, 0, '', NULL, NULL, NULL),
(46932, '2017-09-20 11:50:29', NULL, NULL, 13047, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 11:50:29', 'admin-1505873825-1505879429109861', 1, 0, '', NULL, NULL, NULL),
(46933, '2017-09-20 11:50:29', NULL, NULL, 13047, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 11:50:29', 'admin-1505873825-1505879429109861', 1, 1, 'SR', NULL, NULL, NULL),
(46934, '2017-09-20 11:50:29', NULL, NULL, 13047, 0, 181, '116', 'Open Food ', 'Salted Pork w/o rice', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 11:50:29', 'admin-1505873825-1505879429109861', 1, 0, '', NULL, NULL, NULL),
(46935, '2017-09-20 15:29:33', NULL, NULL, 13056, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 15:29:33', 'admin-1505873825-15058925728512832', 1, 1, 'SR', NULL, NULL, NULL),
(46936, '2017-09-20 13:09:35', NULL, NULL, 13050, 0, 76, '76', 'Meatless Pesto Pasta', 'no cheese', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 13:09:35', 'admin-1505873825-15058841749139212', 1, 1, 'SR', NULL, NULL, NULL),
(46937, '2017-09-20 15:28:26', NULL, NULL, 13056, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1505893878', 'admin', '2017-09-20 15:28:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46938, '2017-09-20 14:57:16', NULL, NULL, 13055, 0, 181, '116', 'Open Food ', 'cheese stick', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 14:57:16', 'admin-1505873825-15058906366668972', 1, 0, '', NULL, NULL, '10.0'),
(46939, '2017-09-20 14:56:52', NULL, NULL, 13055, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1505893878', 'admin', '2017-09-20 14:56:52', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(46940, '2017-09-20 13:09:35', NULL, NULL, 13050, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 13:09:35', 'admin-1505873825-15058841749139212', 1, 1, 'SR', NULL, NULL, NULL),
(46941, '2017-09-20 13:36:20', NULL, NULL, 13050, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 13:36:20', 'admin-1505873825-15058857797292368', 1, 1, 'SR', NULL, NULL, NULL),
(46942, '2017-09-20 14:48:30', NULL, NULL, 13053, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 14:48:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46943, '2017-09-20 11:30:49', NULL, NULL, 13045, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1505893878', 'admin', '2017-09-20 11:30:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46944, '2017-09-20 11:31:07', NULL, NULL, 13045, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 11:31:07', 'admin-1505873825-15058782674108796', 1, 1, 'SR', NULL, NULL, NULL),
(46945, '2017-09-20 11:31:07', NULL, NULL, 13045, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 11:31:07', 'admin-1505873825-15058782674108796', 1, 0, '', NULL, NULL, NULL),
(46946, '2017-09-20 11:32:54', NULL, NULL, 13046, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1505893878', 'admin', '2017-09-20 11:32:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46947, '2017-09-20 11:33:33', NULL, NULL, 13046, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 11:33:33', 'admin-1505873825-15058784130049188', 1, 0, '', NULL, NULL, NULL),
(46948, '2017-09-20 09:57:42', NULL, NULL, 13042, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:57:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46949, '2017-09-20 09:57:51', NULL, NULL, 13042, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:57:51', 'admin-1505869259-15058726717023460', 1, 0, '', NULL, NULL, NULL),
(46950, '2017-09-20 09:57:51', NULL, NULL, 13042, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:57:51', 'admin-1505869259-15058726717023460', 1, 0, '', NULL, NULL, NULL),
(46951, '2017-09-20 13:36:19', NULL, NULL, 13050, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 13:36:19', 'admin-1505873825-15058857797292368', 1, 1, 'SR', NULL, NULL, NULL),
(46952, '2017-09-20 13:31:17', NULL, NULL, 13052, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 13:31:17', 'admin-1505873825-1505885477351137', 1, 1, 'SR', NULL, NULL, NULL),
(46953, '2017-09-20 13:31:15', NULL, NULL, 13052, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 13:31:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46954, '2017-09-20 13:02:58', NULL, NULL, 13049, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 13:02:58', 'admin-1505873825-15058837787885229', 1, 1, 'SR', NULL, NULL, NULL),
(46955, '2017-09-20 13:02:58', NULL, NULL, 13049, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 13:02:58', 'admin-1505873825-15058837787885229', 1, 1, 'SR', NULL, NULL, NULL),
(46956, '2017-09-20 13:02:58', NULL, NULL, 13049, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 13:02:58', 'admin-1505873825-15058837787885229', 1, 1, 'SR', NULL, NULL, NULL),
(46957, '2017-09-20 13:07:39', NULL, NULL, 13050, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.90, 0.0000, 0.0000, 11.90, 1, '27', 1, '1505893878', 'admin', '2017-09-20 13:07:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46958, '2017-09-20 09:54:12', NULL, NULL, 13041, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:54:12', 'admin-1505869259-15058724518352844', 1, 1, 'SR', NULL, NULL, NULL),
(46959, '2017-09-20 13:09:35', NULL, NULL, 13050, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 13:09:35', 'admin-1505873825-15058841749139212', 1, 1, 'SR', NULL, NULL, NULL),
(46960, '2017-09-20 13:09:35', NULL, NULL, 13050, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 13:09:35', 'admin-1505873825-15058841749139212', 1, 0, '', NULL, NULL, NULL),
(46961, '2017-09-20 12:52:13', NULL, NULL, 13048, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 12:52:13', 'admin-1505873825-1505883132983813', 1, 1, 'SR', NULL, NULL, '10.0'),
(46962, '2017-09-20 13:02:39', NULL, NULL, 13049, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1505893878', 'admin', '2017-09-20 13:02:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46963, '2017-09-20 09:47:10', NULL, NULL, 13039, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:47:10', 'admin-1505869259-15058720305646177', 1, 0, '', NULL, NULL, NULL),
(46964, '2017-09-20 13:09:35', NULL, NULL, 13050, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 13:09:35', 'admin-1505873825-15058841749139212', 1, 0, '', NULL, NULL, NULL),
(46965, '2017-09-20 11:50:37', NULL, NULL, 13047, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 11:50:37', 'admin-1505873825-15058794376697320', 1, 0, '', NULL, NULL, NULL),
(46966, '2017-09-20 11:50:48', NULL, NULL, 13047, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 11:50:48', 'admin-1505873825-15058794481497959', 1, 0, '', NULL, NULL, NULL),
(46967, '2017-09-20 11:50:37', NULL, NULL, 13047, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 11:50:37', 'admin-1505873825-15058794376697320', 1, 0, '', NULL, NULL, NULL),
(46968, '2017-09-20 11:50:29', NULL, NULL, 13047, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 11:50:29', 'admin-1505873825-1505879429109861', 1, 1, 'SR', NULL, NULL, NULL),
(46969, '2017-09-20 11:50:29', NULL, NULL, 13047, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 11:50:29', 'admin-1505873825-1505879429109861', 1, 1, 'SR', NULL, NULL, NULL),
(46970, '2017-09-20 11:33:33', NULL, NULL, 13046, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 11:33:33', 'admin-1505873825-15058784130049188', 1, 1, 'SR', NULL, NULL, NULL),
(46971, '2017-09-20 11:33:33', NULL, NULL, 13046, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 11:33:33', 'admin-1505873825-15058784130049188', 1, 0, '', NULL, NULL, NULL),
(46972, '2017-09-20 11:33:33', NULL, NULL, 13046, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 11:33:33', 'admin-1505873825-15058784130049188', 1, 0, '', NULL, NULL, NULL),
(46973, '2017-09-20 13:29:02', NULL, NULL, 13051, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 13:29:02', 'admin-1505873825-15058853423027843', 1, 1, 'SR', 1, NULL, NULL),
(46974, '2017-09-20 10:35:16', NULL, NULL, 13043, 0, 182, '117', 'Open Drinks ', 'banana', 'Cold Drinks', 'Fresh Juice', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1505893878', 'admin', '2017-09-20 10:35:16', 'admin-1505873825-15058749160009476', 1, 0, '', NULL, NULL, NULL),
(46975, '2017-09-20 10:18:35', NULL, NULL, 13044, 0, 298, '234', 'Salted Caramel Machiato', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 10:18:35', 'admin-1505873825-15058739157113545', 1, 0, '', NULL, NULL, NULL),
(46976, '2017-09-20 10:16:41', NULL, NULL, 13044, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1505893878', 'admin', '2017-09-20 10:16:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46977, '2017-09-20 10:16:45', NULL, NULL, 13044, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 10:16:45', 'admin-1505869259-1505873805409298', 1, 0, '', NULL, NULL, NULL),
(46978, '2017-09-20 10:23:52', NULL, NULL, 13042, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 10:23:52', 'admin-1505873825-15058742322626032', 1, 0, '', NULL, NULL, NULL),
(46979, '2017-09-20 10:12:55', NULL, NULL, 13043, 0, 271, '205', 'Take It Easy', ' more salad,No yogurt', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 10:12:55', 'admin-1505869259-15058735752456399', 1, 0, '', NULL, NULL, NULL),
(46980, '2017-09-20 10:09:12', NULL, NULL, 13043, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 10:09:12', 'admin-1505869259-1505873352246289', 1, 1, 'SR', NULL, NULL, NULL),
(46981, '2017-09-20 10:09:09', NULL, NULL, 13043, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.55, 0.0000, 0.0000, 2.55, 1, '27', 1, '1505893878', 'admin', '2017-09-20 10:09:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46982, '2017-09-20 10:08:42', NULL, NULL, 13037, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 10:08:42', 'admin-1505869259-15058733227603278', 1, 1, 'SR', NULL, NULL, NULL),
(46983, '2017-09-20 09:53:38', NULL, NULL, 13040, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:53:38', 'admin-1505869259-15058724185713251', 1, 1, 'SR', NULL, NULL, NULL),
(46984, '2017-09-20 09:56:03', NULL, NULL, 13039, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:56:03', 'admin-1505869259-15058725638099380', 1, 0, '', NULL, NULL, NULL),
(46985, '2017-09-20 09:54:05', NULL, NULL, 13041, 0, 153, '87', 'Wake Me Up!', 'add scramble eggs', 'Meals', 'Morning Bites ', 1, 24.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:54:05', 'admin-1505869259-15058724457934799', 1, 0, '', NULL, NULL, NULL),
(46986, '2017-09-20 09:53:45', NULL, NULL, 13041, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:53:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46987, '2017-09-20 09:43:02', NULL, NULL, 13038, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:43:02', 'admin-1505869259-15058717825909918', 1, 1, 'SR', NULL, NULL, NULL),
(46988, '2017-09-20 09:53:38', NULL, NULL, 13040, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:53:38', 'admin-1505869259-15058724185713251', 1, 1, 'SR', NULL, NULL, NULL),
(46989, '2017-09-20 09:53:38', NULL, NULL, 13040, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:53:38', 'admin-1505869259-15058724185713251', 1, 0, '', NULL, NULL, NULL),
(46990, '2017-09-20 09:53:38', NULL, NULL, 13040, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:53:38', 'admin-1505869259-15058724185713251', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(46991, '2017-09-20 09:53:27', NULL, NULL, 13040, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:53:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46992, '2017-09-20 09:05:40', NULL, NULL, 13037, 0, 181, '116', 'Open Food ', 'junior blt', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:05:40', 'admin-1505869259-1505869540130390', 1, 0, '', NULL, NULL, NULL),
(46993, '2017-09-20 09:05:48', NULL, NULL, 13037, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:05:48', 'admin-1505869259-1505869548352724', 1, 1, 'SR', NULL, NULL, NULL),
(46994, '2017-09-20 09:42:43', NULL, NULL, 13038, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:42:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46995, '2017-09-20 09:42:52', NULL, NULL, 13038, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:42:52', 'admin-1505869259-1505871772293721', 1, 0, '', NULL, NULL, NULL),
(46996, '2017-09-20 09:46:40', NULL, NULL, 13039, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:46:40', 'admin-1505869259-15058719998452983', 1, 0, '', NULL, NULL, NULL),
(46997, '2017-09-20 09:46:25', NULL, NULL, 13039, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:46:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(46998, '2017-09-20 09:46:40', NULL, NULL, 13039, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:46:40', 'admin-1505869259-15058719998452983', 1, 0, '', NULL, NULL, NULL),
(46999, '2017-09-20 09:43:02', NULL, NULL, 13038, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:43:02', 'admin-1505869259-15058717825909918', 1, 1, 'SR', NULL, NULL, NULL),
(47000, '2017-09-20 09:43:02', NULL, NULL, 13038, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:43:02', 'admin-1505869259-15058717825909918', 1, 0, '', NULL, NULL, NULL),
(47001, '2017-09-20 09:42:52', NULL, NULL, 13038, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:42:52', 'admin-1505869259-1505871772293721', 1, 0, '', NULL, NULL, NULL),
(47002, '2017-09-20 09:43:02', NULL, NULL, 13038, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:43:02', 'admin-1505869259-15058717825909918', 1, 1, 'SR', NULL, NULL, NULL),
(47003, '2017-09-20 09:42:52', NULL, NULL, 13038, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:42:52', 'admin-1505869259-1505871772293721', 1, 0, '', NULL, NULL, NULL),
(47004, '2017-09-20 09:05:22', NULL, NULL, 13037, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1505893878', 'admin', '2017-09-20 09:05:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47005, '2017-09-21 10:50:19', NULL, NULL, 13064, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1505975619', 'admin', '2017-09-21 10:50:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47006, '2017-09-21 10:50:50', NULL, NULL, 13064, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 10:50:50', 'admin-1505956814-15059622499131141', 1, 1, 'SR', NULL, NULL, NULL),
(47007, '2017-09-21 10:50:50', NULL, NULL, 13064, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 10:50:50', 'admin-1505956814-15059622499131141', 1, 1, 'SR', NULL, NULL, NULL),
(47008, '2017-09-21 12:36:33', NULL, NULL, 13069, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 12:36:33', 'admin-1505965162-15059685935217656', 1, 0, '', NULL, NULL, NULL),
(47009, '2017-09-21 00:00:00', NULL, NULL, 13070, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 11:50:42', 'admin-1505965162-15059658426335436', 1, 1, 'SR', NULL, NULL, NULL),
(47010, '2017-09-21 00:00:00', NULL, NULL, 13071, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 12:02:44', 'admin-1505965162-15059665639414639', 1, 1, 'SR', NULL, NULL, NULL),
(47011, '2017-09-21 17:27:54', NULL, NULL, 13080, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 17:27:54', 'admin-1505975619-1505986074634189', 1, 0, '', NULL, NULL, NULL),
(47012, '2017-09-21 16:26:10', NULL, NULL, 13079, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 16:26:10', 'admin-1505975619-1505982370567433', 1, 1, 'SR', NULL, NULL, NULL),
(47013, '2017-09-21 16:26:28', NULL, NULL, 13079, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 16:26:28', 'admin-1505975619-15059823881693587', 1, 1, 'SR', NULL, NULL, NULL),
(47014, '2017-09-21 14:06:56', NULL, NULL, 13072, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 14:06:56', 'admin-1505965162-15059740161562937', 1, 0, '', NULL, NULL, NULL),
(47015, '2017-09-21 17:27:50', NULL, NULL, 13080, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1505975619', 'admin', '2017-09-21 17:27:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47016, '2017-09-21 16:30:57', NULL, NULL, 13079, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 16:30:57', 'admin-1505975619-1505982657489210', 1, 0, '', NULL, NULL, NULL),
(47017, '2017-09-21 15:14:20', NULL, NULL, 13078, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 15:14:20', 'admin-1505975619-15059780607111588', 1, 1, 'SR', NULL, NULL, NULL),
(47018, '2017-09-21 16:25:15', NULL, NULL, 13079, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1505975619', 'admin', '2017-09-21 16:25:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47019, '2017-09-21 15:14:20', NULL, NULL, 13078, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 15:14:20', 'admin-1505975619-15059780607111588', 1, 1, 'SR', NULL, NULL, NULL),
(47020, '2017-09-21 14:53:47', NULL, NULL, 13077, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 9.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 14:53:47', 'admin-1505975619-15059768274324094', 1, 1, 'SR', 1, '10.0', NULL),
(47021, '2017-09-21 12:28:41', NULL, NULL, 13068, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 12:28:41', 'admin-1505965162-15059681209723665', 1, 1, 'SR', NULL, NULL, NULL),
(47022, '2017-09-21 15:11:01', NULL, NULL, 13078, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 15:11:01', 'admin-1505975619-15059778610504662', 1, 1, 'SR', NULL, NULL, NULL),
(47023, '2017-09-21 15:13:01', NULL, NULL, 13078, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 15:13:01', 'admin-1505975619-1505977981438316', 1, 0, '', NULL, NULL, NULL),
(47024, '2017-09-21 15:10:49', NULL, NULL, 13078, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1505975619', 'admin', '2017-09-21 15:10:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47025, '2017-09-21 15:13:01', NULL, NULL, 13078, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 15:13:01', 'admin-1505975619-1505977981438316', 1, 0, '', NULL, NULL, NULL),
(47026, '2017-09-21 13:26:33', NULL, NULL, 13072, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 13:26:33', 'admin-1505965162-15059715928759969', 1, 0, '', NULL, NULL, NULL),
(47027, '2017-09-21 14:39:26', NULL, NULL, 13076, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1505975619', 'admin', '2017-09-21 14:39:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47028, '2017-09-21 14:23:33', NULL, NULL, 13075, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1505975619', 'admin', '2017-09-21 14:23:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47029, '2017-09-21 14:23:38', NULL, NULL, 13075, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 14:23:38', 'admin-1505965162-15059750178294068', 1, 0, '', NULL, NULL, NULL),
(47030, '2017-09-21 14:33:54', NULL, NULL, 13074, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 14:33:54', 'admin-1505975619-15059756347389582', 1, 0, '', NULL, NULL, '10.0'),
(47031, '2017-09-21 12:27:59', NULL, NULL, 13068, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1505975619', 'admin', '2017-09-21 12:27:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47032, '2017-09-21 12:44:27', NULL, NULL, 13070, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1505975619', 'admin', '2017-09-21 12:44:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47033, '2017-09-21 00:00:00', NULL, NULL, 13070, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 11:50:42', 'admin-1505965162-15059658426335436', 1, 0, '', NULL, NULL, NULL),
(47034, '2017-09-21 12:45:30', NULL, NULL, 13071, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 12:45:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47035, '2017-09-21 00:00:00', NULL, NULL, 13071, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 12:02:36', 'admin-1505965162-1505966556756126', 1, 0, '', NULL, NULL, NULL),
(47036, '2017-09-21 11:00:12', NULL, NULL, 13065, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 11:00:12', 'admin-1505956814-15059628122068034', 1, 1, 'SR', NULL, NULL, NULL),
(47037, '2017-09-21 11:00:12', NULL, NULL, 13065, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 11:00:12', 'admin-1505956814-15059628122068034', 1, 1, 'SR', NULL, NULL, NULL),
(47038, '2017-09-21 11:00:22', NULL, NULL, 13062, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 11:00:22', 'admin-1505956814-15059628224834820', 1, 1, 'SR', NULL, NULL, NULL),
(47039, '2017-09-21 14:39:29', NULL, NULL, 13076, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 14:39:29', 'admin-1505975619-1505975969627136', 1, 1, 'SR', NULL, NULL, NULL),
(47040, '2017-09-21 14:16:43', NULL, NULL, 13074, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 14:16:43', 'admin-1505965162-15059746032148185', 1, 1, 'SR', NULL, NULL, '10.0'),
(47041, '2017-09-21 14:15:52', NULL, NULL, 13074, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 14:15:52', 'admin-1505965162-15059745519774291', 1, 0, '', NULL, NULL, '10.0'),
(47042, '2017-09-21 10:46:58', NULL, NULL, 13063, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 10:46:58', 'admin-1505956814-1505962018305502', 1, 1, 'SR', NULL, NULL, NULL),
(47043, '2017-09-21 14:15:42', NULL, NULL, 13074, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1505975619', 'admin', '2017-09-21 14:15:42', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(47044, '2017-09-21 12:28:31', NULL, NULL, 13068, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 12:28:31', 'admin-1505965162-15059681115456547', 1, 0, '', NULL, NULL, NULL),
(47045, '2017-09-21 12:28:31', NULL, NULL, 13068, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 12:28:31', 'admin-1505965162-15059681115456547', 1, 0, '', NULL, NULL, NULL),
(47046, '2017-09-21 13:58:17', NULL, NULL, 13073, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1505975619', 'admin', '2017-09-21 13:58:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47047, '2017-09-21 14:03:33', NULL, NULL, 13073, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 14:03:33', 'admin-1505965162-15059738137112157', 1, 0, '', NULL, NULL, NULL),
(47048, '2017-09-21 14:03:33', NULL, NULL, 13073, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 14:03:33', 'admin-1505965162-15059738137112157', 1, 1, 'SR', NULL, NULL, NULL),
(47049, '2017-09-21 13:32:22', NULL, NULL, 13072, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 13:32:22', 'admin-1505965162-15059719422081768', 1, 0, '', NULL, NULL, NULL),
(47050, '2017-09-21 10:59:33', NULL, NULL, 13065, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1505975619', 'admin', '2017-09-21 10:59:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47051, '2017-09-21 14:03:33', NULL, NULL, 13073, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 14:03:33', 'admin-1505965162-15059738137112157', 1, 1, 'SR', NULL, NULL, NULL),
(47052, '2017-09-21 14:06:56', NULL, NULL, 13072, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 14:06:56', 'admin-1505965162-15059740161562937', 1, 0, '', NULL, NULL, NULL),
(47053, '2017-09-21 14:03:33', NULL, NULL, 13073, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 14:03:33', 'admin-1505965162-15059738137112157', 1, 1, 'SR', NULL, NULL, NULL),
(47054, '2017-09-21 14:03:33', NULL, NULL, 13073, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 14:03:33', 'admin-1505965162-15059738137112157', 1, 0, '', NULL, NULL, NULL),
(47055, '2017-09-21 14:03:33', NULL, NULL, 13073, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 14:03:33', 'admin-1505965162-15059738137112157', 1, 1, 'SR', NULL, NULL, NULL),
(47056, '2017-09-21 13:32:22', NULL, NULL, 13072, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 13:32:22', 'admin-1505965162-15059719422081768', 1, 0, '', NULL, NULL, NULL),
(47057, '2017-09-21 15:14:20', NULL, NULL, 13078, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 15:14:20', 'admin-1505975619-15059780607111588', 1, 1, 'SR', NULL, NULL, NULL),
(47058, '2017-09-21 13:26:33', NULL, NULL, 13072, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 13:26:33', 'admin-1505965162-15059715928759969', 1, 0, '', NULL, NULL, NULL),
(47059, '2017-09-21 13:26:25', NULL, NULL, 13072, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1505975619', 'admin', '2017-09-21 13:26:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47060, '2017-09-21 12:30:27', NULL, NULL, 13069, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 12:30:27', 'admin-1505965162-15059682270878160', 1, 0, '', NULL, NULL, NULL),
(47061, '2017-09-21 12:30:20', NULL, NULL, 13069, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 12:30:20', 'admin-1505965162-15059682204105820', 1, 0, '', NULL, NULL, NULL),
(47062, '2017-09-21 12:30:20', NULL, NULL, 13069, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 12:30:20', 'admin-1505965162-15059682204105820', 1, 1, 'SR', NULL, NULL, NULL),
(47063, '2017-09-21 12:30:03', NULL, NULL, 13069, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1505975619', 'admin', '2017-09-21 12:30:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47064, '2017-09-21 12:28:41', NULL, NULL, 13068, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 12:28:41', 'admin-1505965162-15059681209723665', 1, 1, 'SR', NULL, NULL, NULL),
(47065, '2017-09-21 12:28:31', NULL, NULL, 13068, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 12:28:31', 'admin-1505965162-15059681115456547', 1, 0, '', NULL, NULL, NULL),
(47066, '2017-09-21 11:49:02', NULL, NULL, 13066, 0, 181, '116', 'Open Food ', '1 cookie', 'Meals', 'Perfect Meals', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1505975619', 'admin', '2017-09-21 11:49:02', 'admin-1505965162-1505965742458953', 1, 0, '', NULL, NULL, NULL),
(47067, '2017-09-21 11:34:35', NULL, NULL, 13067, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1505975619', 'admin', '2017-09-21 11:34:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47068, '2017-09-21 11:34:43', NULL, NULL, 13067, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 11:34:43', 'admin-1505956814-15059648832693819', 1, 0, '', NULL, NULL, NULL),
(47069, '2017-09-21 11:34:43', NULL, NULL, 13067, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 11:34:43', 'admin-1505956814-15059648832693819', 1, 1, 'SR', NULL, NULL, NULL),
(47070, '2017-09-21 11:37:52', NULL, NULL, 13066, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 11:37:52', 'admin-1505956814-15059650728177050', 1, 0, '', NULL, NULL, NULL),
(47071, '2017-09-21 11:37:52', NULL, NULL, 13066, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 11:37:52', 'admin-1505956814-15059650728177050', 1, 0, '', NULL, NULL, NULL),
(47072, '2017-09-21 11:39:19', NULL, NULL, 13066, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 11:39:19', 'admin-1505956814-15059651574948649', 1, 0, '', NULL, NULL, NULL),
(47073, '2017-09-21 11:00:12', NULL, NULL, 13065, 0, 153, '87', 'Wake Me Up!', 'scramble egg to sunny side up', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 11:00:12', 'admin-1505956814-15059628122068034', 1, 0, '', NULL, NULL, NULL),
(47074, '2017-09-21 11:00:12', NULL, NULL, 13065, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 11:00:12', 'admin-1505956814-15059628122068034', 1, 0, '', NULL, NULL, NULL),
(47075, '2017-09-21 11:34:27', NULL, NULL, 13066, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.59, 0.0000, 0.0000, 5.59, 1, '27', 1, '1505975619', 'admin', '2017-09-21 11:34:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47076, '2017-09-21 10:50:50', NULL, NULL, 13064, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 10:50:50', 'admin-1505956814-15059622499131141', 1, 0, '', NULL, NULL, NULL),
(47077, '2017-09-21 10:50:50', NULL, NULL, 13064, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 10:50:50', 'admin-1505956814-15059622499131141', 1, 0, '', NULL, NULL, NULL),
(47078, '2017-09-21 10:05:26', NULL, NULL, 13060, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1505975619', 'admin', '2017-09-21 10:05:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47079, '2017-09-21 10:05:29', NULL, NULL, 13060, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 10:05:29', 'admin-1505956814-15059595291945257', 1, 1, 'SR', NULL, NULL, NULL),
(47080, '2017-09-21 10:12:28', NULL, NULL, 13061, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1505975619', 'admin', '2017-09-21 10:12:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47081, '2017-09-21 10:13:49', NULL, NULL, 13061, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 10:13:49', 'admin-1505956814-15059600296721020', 1, 0, '', NULL, NULL, NULL),
(47082, '2017-09-21 10:13:54', NULL, NULL, 13061, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 10:13:54', 'admin-1505956814-15059600341046719', 1, 1, 'SR', NULL, NULL, NULL),
(47083, '2017-09-21 10:36:42', NULL, NULL, 13062, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1505975619', 'admin', '2017-09-21 10:36:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47084, '2017-09-21 10:37:12', NULL, NULL, 13062, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 10:37:12', 'admin-1505956814-15059614323258881', 1, 1, 'SR', NULL, NULL, NULL),
(47085, '2017-09-21 10:37:12', NULL, NULL, 13062, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 10:37:12', 'admin-1505956814-15059614323258881', 1, 1, 'SR', NULL, NULL, NULL),
(47086, '2017-09-21 10:37:12', NULL, NULL, 13062, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 10:37:12', 'admin-1505956814-15059614323258881', 1, 0, '', NULL, NULL, NULL),
(47087, '2017-09-21 10:46:58', NULL, NULL, 13063, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 10:46:58', 'admin-1505956814-1505962018305502', 1, 1, 'SR', NULL, NULL, NULL),
(47088, '2017-09-21 15:14:02', NULL, NULL, 13078, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 15:14:02', 'admin-1505975619-15059780418592326', 1, 1, 'SR', NULL, NULL, NULL),
(47089, '2017-09-21 10:37:49', NULL, NULL, 13062, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 10:37:49', 'admin-1505956814-1505961469752866', 1, 0, '', NULL, NULL, NULL),
(47090, '2017-09-21 10:37:49', NULL, NULL, 13062, 0, 181, '116', 'Open Food ', 'Omelet add bacon', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 10:37:49', 'admin-1505956814-1505961469752866', 1, 0, '', NULL, NULL, NULL),
(47091, '2017-09-21 10:46:38', NULL, NULL, 13063, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1505975619', 'admin', '2017-09-21 10:46:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47092, '2017-09-21 10:46:43', NULL, NULL, 13063, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 10:46:43', 'admin-1505956814-1505962002870863', 1, 0, '', NULL, NULL, NULL),
(47093, '2017-09-21 09:55:31', NULL, NULL, 13059, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 09:55:31', 'admin-1505956814-15059589317151997', 1, 0, '', NULL, NULL, NULL),
(47094, '2017-09-21 09:55:31', NULL, NULL, 13059, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 09:55:31', 'admin-1505956814-15059589317151997', 1, 1, 'SR', NULL, NULL, NULL),
(47095, '2017-09-21 09:55:31', NULL, NULL, 13059, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 09:55:31', 'admin-1505956814-15059589317151997', 1, 1, 'SR', NULL, NULL, NULL),
(47096, '2017-09-21 09:55:31', NULL, NULL, 13059, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1505975619', 'admin', '2017-09-21 09:55:31', 'admin-1505956814-15059589317151997', 1, 0, '', NULL, NULL, NULL),
(47097, '2017-09-21 09:54:50', NULL, NULL, 13059, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1505975619', 'admin', '2017-09-21 09:54:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47098, '2017-09-22 16:23:49', NULL, NULL, 13119, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 16:23:49', 'admin-1506055637-15060686293859976', 1, 0, '', NULL, NULL, NULL),
(47099, '2017-09-22 16:24:00', NULL, NULL, 13119, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 16:24:00', 'admin-1506055637-15060686406405176', 1, 1, 'SR', NULL, NULL, NULL),
(47100, '2017-09-22 15:03:10', NULL, NULL, 13116, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 15:03:10', 'admin-1506055637-1506063789883482', 1, 0, '', NULL, NULL, NULL),
(47101, '2017-09-22 15:05:10', NULL, NULL, 13113, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 15:05:10', 'admin-1506055637-15060639098301976', 1, 0, '', NULL, NULL, NULL),
(47102, '2017-09-22 15:09:23', NULL, NULL, 13117, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1506069153', 'admin', '2017-09-22 15:09:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47103, '2017-09-22 12:35:57', NULL, NULL, 13104, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:35:57', 'admin-1506049672-15060549576624826', 1, 1, 'SR', NULL, NULL, NULL),
(47104, '2017-09-22 11:07:48', NULL, NULL, 13092, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:07:48', 'admin-1506042971-15060494560296878', 1, 1, 'SR', NULL, NULL, NULL),
(47105, '2017-09-22 11:07:48', NULL, NULL, 13092, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:07:48', 'admin-1506042971-15060494560296878', 1, 1, 'SR', NULL, NULL, NULL),
(47106, '2017-09-22 11:07:48', NULL, NULL, 13094, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:07:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47107, '2017-09-22 11:08:13', NULL, NULL, 13094, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:08:13', 'admin-1506049672-15060496934483591', 1, 0, '', NULL, NULL, NULL),
(47108, '2017-09-22 13:13:59', NULL, NULL, 13107, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 13:13:59', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(47109, '2017-09-22 11:55:15', NULL, NULL, 13099, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:55:15', 'admin-1506049672-15060525157305517', 1, 1, 'SR', NULL, NULL, NULL),
(47110, '2017-09-22 14:08:30', NULL, NULL, 13107, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 14:08:30', 'admin-1506055637-15060605099132589', 1, 1, 'SR', NULL, NULL, '10.0'),
(47111, '2017-09-22 14:11:26', NULL, NULL, 13112, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 14:11:26', 'admin-1506055637-15060606864641232', 1, 1, 'SR', NULL, NULL, NULL),
(47112, '2017-09-22 12:00:14', NULL, NULL, 13100, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:00:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47113, '2017-09-22 12:00:34', NULL, NULL, 13100, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:00:34', 'admin-1506049672-15060528345181412', 1, 0, '', NULL, NULL, NULL),
(47114, '2017-09-22 12:46:39', NULL, NULL, 13106, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.70, 0.0000, 0.0000, 9.70, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:46:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47115, '2017-09-22 14:11:26', NULL, NULL, 13112, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 14:11:26', 'admin-1506055637-15060606864641232', 1, 0, '', NULL, NULL, NULL),
(47116, '2017-09-22 12:47:11', NULL, NULL, 13106, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:47:11', 'admin-1506049672-15060556309805564', 1, 0, '', NULL, NULL, NULL),
(47117, '2017-09-22 13:46:41', NULL, NULL, 13111, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1506069153', 'admin', '2017-09-22 13:46:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47118, '2017-09-22 13:46:53', NULL, NULL, 13111, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 13:46:53', 'admin-1506055637-15060592133341262', 1, 0, '', NULL, NULL, NULL),
(47119, '2017-09-22 13:46:53', NULL, NULL, 13111, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 13:46:53', 'admin-1506055637-15060592133341262', 1, 1, 'SR', NULL, NULL, NULL),
(47120, '2017-09-22 11:53:38', NULL, NULL, 13098, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:53:38', 'admin-1506049672-15060524183926053', 1, 1, 'SR', NULL, NULL, NULL),
(47121, '2017-09-22 11:53:38', NULL, NULL, 13098, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:53:38', 'admin-1506049672-15060524183926053', 1, 0, '', NULL, NULL, NULL),
(47122, '2017-09-22 12:47:11', NULL, NULL, 13106, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:47:11', 'admin-1506049672-15060556309805564', 1, 0, '', NULL, NULL, NULL),
(47123, '2017-09-22 12:47:29', NULL, NULL, 13106, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:47:29', 'admin-1506055637-15060556490562658', 1, 1, 'SR', NULL, NULL, NULL),
(47124, '2017-09-22 12:47:29', NULL, NULL, 13106, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:47:29', 'admin-1506055637-15060556490562658', 1, 1, 'SR', NULL, NULL, NULL),
(47125, '2017-09-22 15:09:32', NULL, NULL, 13117, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 15:09:32', 'admin-1506055637-15060641720334161', 1, 0, '', NULL, NULL, NULL),
(47126, '2017-09-22 12:33:25', NULL, NULL, 13103, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:33:25', 'admin-1506049672-1506054805568513', 1, 1, 'SR', NULL, NULL, '10.0'),
(47127, '2017-09-22 12:33:25', NULL, NULL, 13103, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:33:25', 'admin-1506049672-1506054805568513', 1, 1, 'SR', NULL, NULL, '10.0'),
(47128, '2017-09-22 12:33:25', NULL, NULL, 13103, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:33:25', 'admin-1506049672-1506054805568513', 1, 0, '', NULL, NULL, '10.0'),
(47129, '2017-09-22 12:36:51', NULL, NULL, 13105, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:36:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47130, '2017-09-22 11:54:58', NULL, NULL, 13099, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:54:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47131, '2017-09-22 11:53:38', NULL, NULL, 13098, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:53:38', 'admin-1506049672-15060524183926053', 1, 1, 'SR', NULL, NULL, NULL),
(47132, '2017-09-22 11:53:38', NULL, NULL, 13098, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:53:38', 'admin-1506049672-15060524183926053', 1, 0, '', NULL, NULL, NULL),
(47133, '2017-09-22 12:00:43', NULL, NULL, 13101, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:00:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47134, '2017-09-22 11:33:09', NULL, NULL, 13097, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:33:09', 'admin-1506049672-15060511893739125', 1, 1, 'SR', NULL, NULL, NULL),
(47135, '2017-09-22 11:50:24', NULL, NULL, 13087, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:50:24', 'admin-1506049672-15060522247499332', 1, 0, '', NULL, NULL, NULL),
(47136, '2017-09-22 11:51:20', NULL, NULL, 13098, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:51:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47137, '2017-09-22 11:07:48', NULL, NULL, 13092, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:07:48', 'admin-1506042971-15060494560296878', 1, 1, 'SR', NULL, NULL, NULL),
(47138, '2017-09-22 11:20:33', NULL, NULL, 13095, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:20:33', 'admin-1506049672-15060504330103139', 1, 1, 'SR', NULL, NULL, NULL),
(47139, '2017-09-22 11:53:38', NULL, NULL, 13098, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:53:38', 'admin-1506049672-15060524183926053', 1, 0, '', NULL, NULL, NULL),
(47140, '2017-09-22 11:25:46', NULL, NULL, 13096, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:25:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47141, '2017-09-22 10:50:31', NULL, NULL, 13090, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:50:31', 'admin-1506042971-15060486318168857', 1, 0, '', NULL, NULL, NULL),
(47142, '2017-09-22 11:55:15', NULL, NULL, 13099, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:55:15', 'admin-1506049672-15060525157305517', 1, 0, '', NULL, NULL, NULL),
(47143, '2017-09-22 11:03:21', NULL, NULL, 13092, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:03:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47144, '2017-09-22 11:03:29', NULL, NULL, 13093, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:03:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47145, '2017-09-22 11:03:53', NULL, NULL, 13093, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:03:53', 'admin-1506042971-15060494329423350', 1, 0, '', NULL, NULL, NULL),
(47146, '2017-09-22 11:55:15', NULL, NULL, 13099, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:55:15', 'admin-1506049672-15060525157305517', 1, 0, '', NULL, NULL, NULL),
(47147, '2017-09-22 13:14:51', NULL, NULL, 13107, 0, 73, '73', 'Marmite Chicken ', 'add rice', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 13:14:51', 'admin-1506055637-15060572916482510', 1, 1, 'SR', NULL, NULL, '10.0'),
(47148, '2017-09-22 11:25:50', NULL, NULL, 13096, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:25:50', 'admin-1506049672-1506050750429262', 1, 1, 'SR', NULL, NULL, NULL),
(47149, '2017-09-22 11:31:05', NULL, NULL, 13097, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:31:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47150, '2017-09-22 11:31:10', NULL, NULL, 13097, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:31:10', 'admin-1506049672-1506051069840160', 1, 1, 'SR', NULL, NULL, NULL),
(47151, '2017-09-22 12:12:26', NULL, NULL, 13102, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:12:26', 'admin-1506049672-15060535460859175', 1, 1, 'SR', NULL, NULL, NULL),
(47152, '2017-09-22 12:31:48', NULL, NULL, 13098, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:31:48', 'admin-1506049672-1506054708189415', 1, 0, '', NULL, NULL, NULL),
(47153, '2017-09-22 12:32:45', NULL, NULL, 13103, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:32:45', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(47154, '2017-09-22 12:33:25', NULL, NULL, 13103, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:33:25', 'admin-1506049672-1506054805568513', 1, 0, '', NULL, NULL, '10.0'),
(47155, '2017-09-22 12:00:34', NULL, NULL, 13100, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:00:34', 'admin-1506049672-15060528345181412', 1, 1, 'SR', NULL, NULL, NULL),
(47156, '2017-09-22 14:25:32', NULL, NULL, 13113, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 14:25:32', 'admin-1506055637-15060615327932616', 1, 1, 'SR', NULL, NULL, NULL),
(47157, '2017-09-22 14:25:46', NULL, NULL, 13114, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 14:25:46', 'admin-1506055637-15060615459878741', 1, 1, 'SR', 1, NULL, NULL),
(47158, '2017-09-22 14:34:10', NULL, NULL, 13115, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1506069153', 'admin', '2017-09-22 14:34:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47159, '2017-09-22 14:34:34', NULL, NULL, 13115, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 14:34:34', 'admin-1506055637-1506062074619247', 1, 1, 'SR', NULL, NULL, NULL),
(47160, '2017-09-22 14:34:34', NULL, NULL, 13115, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 14:34:34', 'admin-1506055637-1506062074619247', 1, 1, 'SR', NULL, NULL, NULL),
(47161, '2017-09-22 16:23:44', NULL, NULL, 13119, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1506069153', 'admin', '2017-09-22 16:23:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47162, '2017-09-22 12:36:55', NULL, NULL, 13105, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:36:55', 'admin-1506049672-15060550154473648', 1, 0, '', NULL, NULL, NULL),
(47163, '2017-09-22 14:34:34', NULL, NULL, 13115, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 14:34:34', 'admin-1506055637-1506062074619247', 1, 0, '', NULL, NULL, NULL),
(47164, '2017-09-22 15:02:39', NULL, NULL, 13116, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1506069153', 'admin', '2017-09-22 15:02:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47165, '2017-09-22 15:02:57', NULL, NULL, 13116, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 15:02:57', 'admin-1506055637-1506063777682695', 1, 1, 'SR', NULL, NULL, NULL),
(47166, '2017-09-22 15:02:57', NULL, NULL, 13116, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 15:02:57', 'admin-1506055637-1506063777682695', 1, 0, '', NULL, NULL, NULL),
(47167, '2017-09-22 12:47:11', NULL, NULL, 13106, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:47:11', 'admin-1506049672-15060556309805564', 1, 1, 'SR', NULL, NULL, NULL),
(47168, '2017-09-22 13:29:04', NULL, NULL, 13103, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 13:29:04', 'admin-1506055637-15060581445718652', 1, 1, 'SR', NULL, NULL, '10.0'),
(47169, '2017-09-22 11:19:53', NULL, NULL, 13095, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:19:53', 'admin-1506049672-15060503931301274', 1, 0, '', NULL, NULL, NULL),
(47170, '2017-09-22 16:36:28', NULL, NULL, 13120, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 16:36:28', 'admin-1506069153-15060693882543128', 1, 1, 'SR', NULL, NULL, NULL),
(47171, '2017-09-22 16:56:34', NULL, NULL, 13121, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1506069153', 'admin', '2017-09-22 16:56:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47172, '2017-09-22 16:56:37', NULL, NULL, 13121, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 16:56:37', 'admin-1506069153-15060705973061654', 1, 1, 'SR', NULL, NULL, NULL),
(47173, '2017-09-22 16:36:28', NULL, NULL, 13120, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 16:36:28', 'admin-1506069153-15060693882543128', 1, 1, 'SR', NULL, NULL, NULL),
(47174, '2017-09-22 16:36:28', NULL, NULL, 13120, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 16:36:28', 'admin-1506069153-15060693882543128', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(47175, '2017-09-22 16:35:22', NULL, NULL, 13120, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1506069153', 'admin', '2017-09-22 16:35:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47176, '2017-09-22 16:29:30', NULL, NULL, 13119, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 16:29:30', 'admin-1506055637-15060689700395154', 1, 1, 'SR', NULL, NULL, NULL),
(47177, '2017-09-22 15:26:58', NULL, NULL, 13118, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 15:26:58', 'admin-1506055637-15060652180695749', 1, 0, '', NULL, NULL, NULL),
(47178, '2017-09-22 15:18:29', NULL, NULL, 13118, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 15:18:29', 'admin-1506055637-15060647093458980', 1, 1, 'SR', NULL, NULL, NULL),
(47179, '2017-09-22 15:18:18', NULL, NULL, 13118, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1506069153', 'admin', '2017-09-22 15:18:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47180, '2017-09-22 14:07:12', NULL, NULL, 13112, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1506069153', 'admin', '2017-09-22 14:07:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47181, '2017-09-22 13:45:06', NULL, NULL, 13110, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 13:45:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47182, '2017-09-22 15:09:32', NULL, NULL, 13117, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 15:09:32', 'admin-1506055637-15060641720334161', 1, 0, '', NULL, NULL, NULL),
(47183, '2017-09-22 13:29:04', NULL, NULL, 13103, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 13:29:04', 'admin-1506055637-15060581445718652', 1, 1, 'SR', NULL, NULL, '10.0'),
(47184, '2017-09-22 15:18:29', NULL, NULL, 13118, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 15:18:29', 'admin-1506055637-15060647093458980', 1, 0, '', NULL, NULL, NULL),
(47185, '2017-09-22 12:50:15', NULL, NULL, 13106, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:50:15', 'admin-1506055637-15060558155943630', 1, 0, '', NULL, NULL, NULL),
(47186, '2017-09-22 12:59:46', NULL, NULL, 13104, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:59:46', 'admin-1506055637-1506056386142726', 1, 1, 'SR', NULL, NULL, NULL),
(47187, '2017-09-22 13:14:51', NULL, NULL, 13107, 0, 73, '73', 'Marmite Chicken ', 'add rice', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 13:14:51', 'admin-1506055637-15060572916482510', 1, 1, 'SR', NULL, NULL, '10.0'),
(47188, '2017-09-22 13:14:51', NULL, NULL, 13107, 0, 215, '149', 'Thai Fish Sauce Garlic Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 13:14:51', 'admin-1506055637-15060572916482510', 1, 0, '', NULL, NULL, '10.0'),
(47189, '2017-09-22 13:14:51', NULL, NULL, 13107, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 13:14:51', 'admin-1506055637-15060572916482510', 1, 0, '', NULL, NULL, '10.0'),
(47190, '2017-09-22 13:14:51', NULL, NULL, 13107, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 13:14:51', 'admin-1506055637-15060572916482510', 1, 0, '', NULL, NULL, '10.0'),
(47191, '2017-09-22 13:14:59', NULL, NULL, 13108, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1506069153', 'admin', '2017-09-22 13:14:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47192, '2017-09-22 13:15:13', NULL, NULL, 13108, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 13:15:13', 'admin-1506055637-1506057313579324', 1, 1, 'SR', NULL, NULL, NULL),
(47193, '2017-09-22 13:15:22', NULL, NULL, 13108, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 13:15:22', 'admin-1506055637-15060573221518848', 1, 1, 'SR', NULL, NULL, NULL),
(47194, '2017-09-22 10:59:43', NULL, NULL, 13091, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:59:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47195, '2017-09-22 10:59:48', NULL, NULL, 13091, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:59:48', 'admin-1506042971-15060491880706355', 1, 1, 'SR', NULL, NULL, NULL),
(47196, '2017-09-22 14:22:03', NULL, NULL, 13113, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 14:22:03', 'admin-1506055637-1506061323311531', 1, 1, 'SR', NULL, NULL, NULL),
(47197, '2017-09-22 14:22:03', NULL, NULL, 13113, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 14:22:03', 'admin-1506055637-1506061323311531', 1, 1, 'SR', NULL, NULL, NULL),
(47198, '2017-09-22 14:21:22', NULL, NULL, 13113, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1506069153', 'admin', '2017-09-22 14:21:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47199, '2017-09-22 14:24:59', NULL, NULL, 13112, 0, 181, '116', 'Open Food ', 'scone', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 14:24:59', 'admin-1506055637-1506061499114911', 1, 0, '', NULL, NULL, NULL),
(47200, '2017-09-22 14:11:26', NULL, NULL, 13112, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 14:11:26', 'admin-1506055637-15060606864641232', 1, 0, '', NULL, NULL, NULL),
(47201, '2017-09-22 14:11:26', NULL, NULL, 13112, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 14:11:26', 'admin-1506055637-15060606864641232', 1, 0, '', NULL, NULL, NULL),
(47202, '2017-09-22 11:20:33', NULL, NULL, 13095, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:20:33', 'admin-1506049672-15060504330103139', 1, 1, 'SR', NULL, NULL, NULL),
(47203, '2017-09-22 11:19:53', NULL, NULL, 13095, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:19:53', 'admin-1506049672-15060503931301274', 1, 0, '', NULL, NULL, NULL),
(47204, '2017-09-22 12:00:34', NULL, NULL, 13100, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:00:34', 'admin-1506049672-15060528345181412', 1, 1, 'SR', NULL, NULL, NULL),
(47205, '2017-09-22 14:11:26', NULL, NULL, 13112, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 14:11:26', 'admin-1506055637-15060606864641232', 1, 1, 'SR', NULL, NULL, NULL),
(47206, '2017-09-22 13:45:11', NULL, NULL, 13110, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 13:45:11', 'admin-1506055637-15060591112384245', 1, 1, 'SR', NULL, NULL, NULL),
(47207, '2017-09-22 13:45:11', NULL, NULL, 13110, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 13:45:11', 'admin-1506055637-15060591112384245', 1, 1, 'SR', NULL, NULL, NULL),
(47208, '2017-09-22 12:35:57', NULL, NULL, 13104, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:35:57', 'admin-1506049672-15060549576624826', 1, 1, 'SR', NULL, NULL, NULL),
(47209, '2017-09-22 12:35:57', NULL, NULL, 13104, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:35:57', 'admin-1506049672-15060549576624826', 1, 1, 'SR', NULL, NULL, NULL),
(47210, '2017-09-22 11:20:33', NULL, NULL, 13095, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:20:33', 'admin-1506049672-15060504330103139', 1, 1, 'SR', NULL, NULL, NULL),
(47211, '2017-09-22 11:07:48', NULL, NULL, 13092, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:07:48', 'admin-1506042971-15060494560296878', 1, 0, '', NULL, NULL, NULL),
(47212, '2017-09-22 12:12:26', NULL, NULL, 13102, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:12:26', 'admin-1506049672-15060535460859175', 1, 1, 'SR', NULL, NULL, NULL),
(47213, '2017-09-22 13:29:04', NULL, NULL, 13103, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 13:29:04', 'admin-1506055637-15060581445718652', 1, 1, 'SR', NULL, NULL, '10.0'),
(47214, '2017-09-22 13:22:41', NULL, NULL, 13102, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 2, 11.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 13:22:41', 'admin-1506055637-15060577615291533', 1, 1, 'SR', NULL, NULL, NULL),
(47215, '2017-09-22 12:47:11', NULL, NULL, 13106, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:47:11', 'admin-1506049672-15060556309805564', 1, 0, '', NULL, NULL, NULL),
(47216, '2017-09-22 12:47:11', NULL, NULL, 13106, 0, 70, '70', 'Borneo Pepper Pork', 'no rice', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:47:11', 'admin-1506049672-15060556309805564', 1, 1, 'SR', NULL, NULL, NULL),
(47217, '2017-09-22 12:35:57', NULL, NULL, 13104, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:35:57', 'admin-1506049672-15060549576624826', 1, 0, '', NULL, NULL, NULL),
(47218, '2017-09-22 10:29:11', NULL, NULL, 13085, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:29:11', 'admin-1506042971-1506047350989791', 1, 1, 'SR', NULL, NULL, NULL),
(47219, '2017-09-22 10:16:37', NULL, NULL, 13084, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:16:37', 'admin-1506042971-15060465970139238', 1, 0, '', NULL, NULL, NULL),
(47220, '2017-09-22 10:16:37', NULL, NULL, 13084, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:16:37', 'admin-1506042971-15060465970139238', 1, 0, '', NULL, NULL, NULL),
(47221, '2017-09-22 10:16:37', NULL, NULL, 13084, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:16:37', 'admin-1506042971-15060465970139238', 1, 0, '', NULL, NULL, NULL),
(47222, '2017-09-22 10:16:37', NULL, NULL, 13084, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:16:37', 'admin-1506042971-15060465970139238', 1, 0, '', NULL, NULL, NULL),
(47223, '2017-09-22 10:16:37', NULL, NULL, 13084, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:16:37', 'admin-1506042971-15060465970139238', 1, 0, '', NULL, NULL, NULL),
(47224, '2017-09-22 10:16:37', NULL, NULL, 13084, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:16:37', 'admin-1506042971-15060465970139238', 1, 1, 'SR', NULL, NULL, NULL),
(47225, '2017-09-22 10:24:35', NULL, NULL, 13084, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:24:35', 'admin-1506042971-15060470757853614', 1, 0, '', NULL, NULL, NULL),
(47226, '2017-09-22 10:28:55', NULL, NULL, 13085, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:28:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47227, '2017-09-22 10:29:05', NULL, NULL, 13085, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:29:05', 'admin-1506042971-15060473451133857', 1, 0, '', NULL, NULL, NULL),
(47228, '2017-09-22 11:20:33', NULL, NULL, 13095, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:20:33', 'admin-1506049672-15060504330103139', 1, 1, 'SR', NULL, NULL, NULL),
(47229, '2017-09-22 11:20:33', NULL, NULL, 13095, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:20:33', 'admin-1506049672-15060504330103139', 1, 1, 'SR', NULL, NULL, NULL),
(47230, '2017-09-22 12:35:47', NULL, NULL, 13104, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:35:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47231, '2017-09-22 11:19:53', NULL, NULL, 13095, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:19:53', 'admin-1506049672-15060503931301274', 1, 0, '', NULL, NULL, NULL),
(47232, '2017-09-22 11:19:53', NULL, NULL, 13095, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:19:53', 'admin-1506049672-15060503931301274', 1, 0, '', NULL, NULL, NULL),
(47233, '2017-09-22 10:43:50', NULL, NULL, 13087, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:43:50', 'admin-1506042971-15060482297924959', 1, 0, '', NULL, NULL, NULL),
(47234, '2017-09-22 11:19:38', NULL, NULL, 13095, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.80, 0.0000, 0.0000, 11.80, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:19:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47235, '2017-09-22 11:08:13', NULL, NULL, 13094, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:08:13', 'admin-1506049672-15060496934483591', 1, 1, 'SR', NULL, NULL, NULL),
(47236, '2017-09-22 12:00:34', NULL, NULL, 13100, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:00:34', 'admin-1506049672-15060528345181412', 1, 1, 'SR', NULL, NULL, NULL),
(47237, '2017-09-22 00:00:00', NULL, NULL, 13101, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:33:09', 'admin-1506049672-15060511893739125', 1, 1, 'SR', NULL, NULL, NULL),
(47238, '2017-09-22 11:08:13', NULL, NULL, 13094, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:08:13', 'admin-1506049672-15060496934483591', 1, 0, '', NULL, NULL, NULL),
(47239, '2017-09-22 10:46:00', NULL, NULL, 13088, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:46:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47240, '2017-09-22 10:46:03', NULL, NULL, 13088, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:46:03', 'admin-1506042971-1506048363334477', 1, 1, 'SR', NULL, NULL, NULL),
(47241, '2017-09-22 10:46:03', NULL, NULL, 13088, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:46:03', 'admin-1506042971-1506048363334477', 1, 1, 'SR', NULL, NULL, NULL),
(47242, '2017-09-22 10:47:26', NULL, NULL, 13089, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:47:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47243, '2017-09-22 12:12:19', NULL, NULL, 13102, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1506069153', 'admin', '2017-09-22 12:12:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47244, '2017-09-22 10:29:05', NULL, NULL, 13085, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:29:05', 'admin-1506042971-15060473451133857', 1, 0, '', NULL, NULL, NULL),
(47245, '2017-09-22 11:55:15', NULL, NULL, 13099, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:55:15', 'admin-1506049672-15060525157305517', 1, 1, 'SR', NULL, NULL, NULL),
(47246, '2017-09-22 11:08:13', NULL, NULL, 13094, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:08:13', 'admin-1506049672-15060496934483591', 1, 0, '', NULL, NULL, NULL),
(47247, '2017-09-22 11:07:48', NULL, NULL, 13092, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:07:48', 'admin-1506042971-15060494560296878', 1, 0, '', NULL, NULL, NULL),
(47248, '2017-09-22 11:03:53', NULL, NULL, 13093, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:03:53', 'admin-1506042971-15060494329423350', 1, 1, 'SR', NULL, NULL, NULL),
(47249, '2017-09-22 11:03:53', NULL, NULL, 13093, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:03:53', 'admin-1506042971-15060494329423350', 1, 0, '', NULL, NULL, NULL),
(47250, '2017-09-22 10:50:31', NULL, NULL, 13090, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:50:31', 'admin-1506042971-15060486318168857', 1, 1, 'SR', NULL, NULL, NULL),
(47251, '2017-09-22 10:50:31', NULL, NULL, 13090, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:50:31', 'admin-1506042971-15060486318168857', 1, 0, '', NULL, NULL, NULL),
(47252, '2017-09-22 10:50:31', NULL, NULL, 13090, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:50:31', 'admin-1506042971-15060486318168857', 1, 0, '', NULL, NULL, NULL),
(47253, '2017-09-22 10:47:53', NULL, NULL, 13089, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:47:53', 'admin-1506042971-15060484737169310', 1, 0, '', NULL, NULL, NULL),
(47254, '2017-09-22 10:47:54', NULL, NULL, 13089, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:47:54', 'admin-1506042971-15060484737169310', 1, 0, '', NULL, NULL, NULL),
(47255, '2017-09-22 10:47:53', NULL, NULL, 13089, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:47:53', 'admin-1506042971-15060484737169310', 1, 0, '', NULL, NULL, NULL),
(47256, '2017-09-22 10:47:53', NULL, NULL, 13089, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:47:53', 'admin-1506042971-15060484737169310', 1, 1, 'SR', NULL, NULL, NULL),
(47257, '2017-09-22 11:53:38', NULL, NULL, 13098, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 11:53:38', 'admin-1506049672-15060524183926053', 1, 0, '', NULL, NULL, NULL),
(47258, '2017-09-22 10:47:53', NULL, NULL, 13089, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:47:53', 'admin-1506042971-15060484737169310', 1, 0, '', NULL, NULL, NULL),
(47259, '2017-09-22 10:47:53', NULL, NULL, 13089, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:47:53', 'admin-1506042971-15060484737169310', 1, 0, '', NULL, NULL, NULL),
(47260, '2017-09-22 10:29:11', NULL, NULL, 13085, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:29:11', 'admin-1506042971-1506047350989791', 1, 1, 'SR', NULL, NULL, NULL),
(47261, '2017-09-22 10:50:16', NULL, NULL, 13090, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:50:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47262, '2017-09-22 10:49:42', NULL, NULL, 13083, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:49:42', 'admin-1506042971-15060485821657628', 1, 1, 'SR', NULL, NULL, NULL),
(47263, '2017-09-22 10:49:42', NULL, NULL, 13083, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:49:42', 'admin-1506042971-15060485821657628', 1, 1, 'SR', NULL, NULL, NULL),
(47264, '2017-09-22 10:43:35', NULL, NULL, 13087, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:43:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47265, '2017-09-22 10:43:50', NULL, NULL, 13087, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:43:50', 'admin-1506042971-15060482297924959', 1, 0, '', NULL, NULL, NULL),
(47266, '2017-09-22 10:00:16', NULL, NULL, 13083, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:00:16', 'admin-1506042971-15060456164014497', 1, 0, '', NULL, NULL, NULL),
(47267, '2017-09-22 10:43:50', NULL, NULL, 13087, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:43:50', 'admin-1506042971-15060482297924959', 1, 1, 'SR', NULL, NULL, NULL),
(47268, '2017-09-22 10:43:50', NULL, NULL, 13087, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:43:50', 'admin-1506042971-15060482297924959', 1, 0, '', NULL, NULL, NULL),
(47269, '2017-09-22 10:29:11', NULL, NULL, 13085, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:29:11', 'admin-1506042971-1506047350989791', 1, 1, 'SR', NULL, NULL, NULL),
(47270, '2017-09-22 10:29:05', NULL, NULL, 13085, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:29:05', 'admin-1506042971-15060473451133857', 1, 0, '', NULL, NULL, NULL),
(47271, '2017-09-22 09:33:28', NULL, NULL, 13081, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 09:33:28', 'admin-1506042971-15060440081084619', 1, 1, 'SR', NULL, NULL, NULL),
(47272, '2017-09-22 09:34:13', NULL, NULL, 13081, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 09:34:13', 'admin-1506042971-15060440528638343', 1, 1, 'SR', NULL, NULL, NULL),
(47273, '2017-09-22 09:35:42', NULL, NULL, 13081, 0, 244, '178', 'Macadamia Scones', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 09:35:42', 'admin-1506042971-15060441426635676', 1, 0, '', NULL, NULL, NULL),
(47274, '2017-09-22 09:37:09', NULL, NULL, 13081, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 09:37:09', 'admin-1506042971-15060442296114220', 1, 1, 'SR', NULL, NULL, NULL),
(47275, '2017-09-22 09:37:09', NULL, NULL, 13081, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 09:37:09', 'admin-1506042971-15060442296114220', 1, 1, 'SR', NULL, NULL, NULL),
(47276, '2017-09-22 09:43:09', NULL, NULL, 13082, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1506069153', 'admin', '2017-09-22 09:43:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47277, '2017-09-22 09:43:34', NULL, NULL, 13082, 0, 153, '87', 'Wake Me Up!', ',x bacon add cheddar', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 09:43:34', 'admin-1506042971-15060446144212152', 1, 0, '', NULL, NULL, NULL),
(47278, '2017-09-22 09:43:34', NULL, NULL, 13082, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 09:43:34', 'admin-1506042971-15060446144212152', 1, 0, '', NULL, NULL, NULL),
(47279, '2017-09-22 09:43:34', NULL, NULL, 13082, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 09:43:34', 'admin-1506042971-15060446144212152', 1, 0, '', NULL, NULL, NULL),
(47280, '2017-09-22 09:43:34', NULL, NULL, 13082, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 09:43:34', 'admin-1506042971-15060446144212152', 1, 1, 'SR', NULL, NULL, NULL),
(47281, '2017-09-22 10:00:16', NULL, NULL, 13083, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:00:16', 'admin-1506042971-15060456164014497', 1, 0, '', NULL, NULL, NULL),
(47282, '2017-09-22 10:16:08', NULL, NULL, 13084, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.40, 0.0000, 0.0000, 13.40, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:16:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47283, '2017-09-22 10:06:50', NULL, NULL, 13083, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:06:50', 'admin-1506042971-1506046010057939', 1, 0, '', NULL, NULL, NULL),
(47284, '2017-09-22 10:00:16', NULL, NULL, 13083, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:00:16', 'admin-1506042971-15060456164014497', 1, 0, '', NULL, NULL, NULL),
(47285, '2017-09-22 10:00:16', NULL, NULL, 13083, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:00:16', 'admin-1506042971-15060456164014497', 1, 0, '', NULL, NULL, NULL),
(47286, '2017-09-22 10:00:16', NULL, NULL, 13083, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:00:16', 'admin-1506042971-15060456164014497', 1, 0, '', NULL, NULL, NULL),
(47287, '2017-09-22 10:00:16', NULL, NULL, 13083, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:00:16', 'admin-1506042971-15060456164014497', 1, 0, '', NULL, NULL, NULL),
(47288, '2017-09-22 10:00:03', NULL, NULL, 13083, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.30, 0.0000, 0.0000, 13.30, 1, '27', 1, '1506069153', 'admin', '2017-09-22 10:00:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47289, '2017-09-22 09:33:23', NULL, NULL, 13081, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1506069153', 'admin', '2017-09-22 09:33:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47290, '2017-09-23 15:41:10', NULL, NULL, 13153, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 15:41:10', 'admin-1506152110-15061524705676338', 1, 0, '', NULL, NULL, NULL),
(47291, '2017-09-23 15:41:10', NULL, NULL, 13153, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 15:41:10', 'admin-1506152110-15061524705676338', 1, 1, 'SR', NULL, NULL, NULL),
(47292, '2017-09-23 15:16:33', NULL, NULL, 13153, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 15:16:33', 'admin-1506150067-15061509929903841', 1, 0, '', NULL, NULL, NULL),
(47293, '2017-09-23 14:46:39', NULL, NULL, 13151, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 14:46:39', 'admin-1506141352-15061491992143691', 1, 0, '', NULL, NULL, NULL),
(47294, '2017-09-23 14:46:55', NULL, NULL, 13151, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 14:46:55', 'admin-1506141352-15061492156667386', 1, 1, 'SR', NULL, NULL, NULL),
(47295, '2017-09-23 14:46:55', NULL, NULL, 13151, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 14:46:55', 'admin-1506141352-15061492156667386', 1, 0, '', NULL, NULL, NULL),
(47296, '2017-09-23 14:48:50', NULL, NULL, 13152, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1506152110', 'admin', '2017-09-23 14:48:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47297, '2017-09-23 14:49:02', NULL, NULL, 13152, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 14:49:02', 'admin-1506141352-15061493422184185', 1, 0, '', NULL, NULL, NULL),
(47298, '2017-09-23 12:27:24', NULL, NULL, 13143, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:27:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47299, '2017-09-23 12:28:04', NULL, NULL, 13143, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:28:04', 'admin-1506135454-15061408845987772', 1, 0, '', NULL, NULL, NULL),
(47300, '2017-09-23 12:28:04', NULL, NULL, 13143, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:28:04', 'admin-1506135454-15061408845987772', 1, 1, 'SR', NULL, NULL, NULL),
(47301, '2017-09-23 12:28:04', NULL, NULL, 13143, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:28:04', 'admin-1506135454-15061408845987772', 1, 1, 'SR', NULL, NULL, NULL),
(47302, '2017-09-23 12:28:04', NULL, NULL, 13143, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:28:04', 'admin-1506135454-15061408845987772', 1, 1, 'SR', NULL, NULL, NULL),
(47303, '2017-09-23 13:40:27', NULL, NULL, 13148, 0, 153, '87', 'Wake Me Up!', 'scramble egg to reploace potato', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 13:40:27', 'admin-1506141352-15061452273827335', 1, 0, '', NULL, NULL, NULL),
(47304, '2017-09-23 12:43:10', NULL, NULL, 13145, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:43:10', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(47305, '2017-09-23 12:43:23', NULL, NULL, 13145, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:43:23', 'admin-1506141352-1506141803385459', 1, 1, 'SR', NULL, NULL, '10.0'),
(47306, '2017-09-23 12:41:59', NULL, NULL, 13144, 0, 153, '87', 'Wake Me Up!', 'potato change to bacon and sausage', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:41:59', 'admin-1506141352-15061417196984992', 1, 0, '', NULL, NULL, NULL),
(47307, '2017-09-23 13:11:32', NULL, NULL, 13146, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1506152110', 'admin', '2017-09-23 13:11:32', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(47308, '2017-09-23 12:41:59', NULL, NULL, 13144, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:41:59', 'admin-1506141352-15061417196984992', 1, 1, 'SR', NULL, NULL, NULL),
(47309, '2017-09-23 10:58:45', NULL, NULL, 13132, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:58:45', 'admin-1506135454-15061355256207617', 1, 0, '', NULL, NULL, NULL),
(47310, '2017-09-23 12:11:34', NULL, NULL, 13137, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:11:34', 'admin-1506135454-15061398945649016', 1, 1, 'SR', NULL, NULL, NULL),
(47311, '2017-09-23 12:11:57', NULL, NULL, 13140, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:11:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47312, '2017-09-23 12:12:01', NULL, NULL, 13140, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:12:01', 'admin-1506135454-150613992139943', 1, 1, 'SR', NULL, NULL, NULL),
(47313, '2017-09-23 12:13:13', NULL, NULL, 13141, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:13:13', 'admin-1506135454-15061399935722851', 1, 1, 'SR', NULL, NULL, NULL),
(47314, '2017-09-23 12:06:54', NULL, NULL, 13137, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:06:54', 'admin-1506135454-15061396141884115', 1, 0, '', NULL, NULL, NULL),
(47315, '2017-09-23 13:34:32', NULL, NULL, 13146, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 13:34:32', 'admin-1506141352-15061448724814342', 1, 0, '', NULL, NULL, '10.0'),
(47316, '2017-09-23 10:41:51', NULL, NULL, 13130, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:41:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47317, '2017-09-23 10:52:45', NULL, NULL, 13131, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:52:45', 'admin-1506129025-15061351650992582', 1, 0, '', NULL, NULL, NULL),
(47318, '2017-09-23 10:52:45', NULL, NULL, 13131, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:52:45', 'admin-1506129025-15061351650992582', 1, 1, 'SR', NULL, NULL, NULL),
(47319, '2017-09-23 10:52:45', NULL, NULL, 13131, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:52:45', 'admin-1506129025-15061351650992582', 1, 1, 'SR', NULL, NULL, NULL),
(47320, '2017-09-23 10:58:28', NULL, NULL, 13132, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.80, 0.0000, 0.0000, 10.80, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:58:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47321, '2017-09-23 10:58:45', NULL, NULL, 13132, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:58:45', 'admin-1506135454-15061355256207617', 1, 0, '', NULL, NULL, NULL),
(47322, '2017-09-23 10:52:39', NULL, NULL, 13131, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:52:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47323, '2017-09-23 10:52:45', NULL, NULL, 13131, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:52:45', 'admin-1506129025-15061351650992582', 1, 0, '', NULL, NULL, NULL),
(47324, '2017-09-23 13:34:02', NULL, NULL, 13147, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1506152110', 'admin', '2017-09-23 13:34:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47325, '2017-09-23 13:34:08', NULL, NULL, 13147, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 13:34:08', 'admin-1506141352-15061448482688051', 1, 0, '', NULL, NULL, NULL),
(47326, '2017-09-23 12:13:13', NULL, NULL, 13141, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:13:13', 'admin-1506135454-15061399935722851', 1, 1, 'SR', NULL, NULL, NULL),
(47327, '2017-09-23 12:21:53', NULL, NULL, 13142, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:21:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47328, '2017-09-23 12:21:58', NULL, NULL, 13142, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:21:58', 'admin-1506135454-15061405183972211', 1, 0, '', NULL, NULL, NULL),
(47329, '2017-09-23 12:21:58', NULL, NULL, 13142, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:21:58', 'admin-1506135454-15061405183972211', 1, 0, '', NULL, NULL, NULL),
(47330, '2017-09-23 15:16:42', NULL, NULL, 13153, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 15:16:42', 'admin-1506150067-15061510026389611', 1, 0, '', NULL, NULL, NULL),
(47331, '2017-09-23 15:16:42', NULL, NULL, 13153, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 15:16:42', 'admin-1506150067-15061510026389611', 1, 1, 'SR', NULL, NULL, NULL),
(47332, '2017-09-23 15:34:22', NULL, NULL, 13154, 0, 182, '117', 'Open Drinks ', 'americano promo', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 15:34:22', 'admin-1506150067-150615206237334', 1, 0, '', 1, NULL, NULL),
(47333, '2017-09-23 15:34:47', NULL, NULL, 13155, 0, 182, '117', 'Open Drinks ', 'americano promo', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 15:34:47', 'admin-1506150067-15061520875986734', 1, 0, '', 1, NULL, NULL),
(47334, '2017-09-23 14:16:02', NULL, NULL, 13150, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 14:16:02', 'admin-1506141352-15061473627236524', 1, 1, 'SR', NULL, NULL, NULL),
(47335, '2017-09-23 14:16:02', NULL, NULL, 13150, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 14:16:02', 'admin-1506141352-15061473627236524', 1, 0, '', NULL, NULL, NULL),
(47336, '2017-09-23 14:16:02', NULL, NULL, 13150, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 14:16:02', 'admin-1506141352-15061473627236524', 1, 1, 'SR', NULL, NULL, NULL),
(47337, '2017-09-23 15:58:55', NULL, NULL, 13149, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 15:58:55', 'admin-1506152110-15061535351246636', 1, 0, '', NULL, NULL, '10.0'),
(47338, '2017-09-23 15:35:04', NULL, NULL, 13156, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 15:35:04', 'admin-1506150067-15061521046288761', 1, 1, 'SR', NULL, NULL, NULL),
(47339, '2017-09-23 13:12:10', NULL, NULL, 13146, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 13:12:10', 'admin-1506141352-15061435302868963', 1, 1, 'SR', NULL, NULL, '10.0'),
(47340, '2017-09-23 13:12:10', NULL, NULL, 13146, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 13:12:10', 'admin-1506141352-15061435302868963', 1, 0, '', NULL, NULL, '10.0'),
(47341, '2017-09-23 12:47:23', NULL, NULL, 13144, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:47:23', 'admin-1506141352-1506142043679527', 1, 1, 'SR', NULL, NULL, NULL),
(47342, '2017-09-23 12:47:56', NULL, NULL, 13143, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:47:56', 'admin-1506141352-15061420762122765', 1, 1, 'SR', NULL, NULL, NULL),
(47343, '2017-09-23 12:22:08', NULL, NULL, 13142, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:22:08', 'admin-1506135454-15061405286709242', 1, 1, 'SR', NULL, NULL, NULL),
(47344, '2017-09-23 15:34:55', NULL, NULL, 13156, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1506152110', 'admin', '2017-09-23 15:34:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47345, '2017-09-23 15:16:16', NULL, NULL, 13153, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1506152110', 'admin', '2017-09-23 15:16:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47346, '2017-09-23 15:16:33', NULL, NULL, 13153, 0, 207, '142', 'Cheesy Bacon Toast', 'no bacon', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 15:16:33', 'admin-1506150067-15061509929903841', 1, 0, '', NULL, NULL, NULL),
(47347, '2017-09-23 14:49:02', NULL, NULL, 13152, 0, 242, '176', 'Citrus Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 14:49:02', 'admin-1506141352-15061493422184185', 1, 0, '', NULL, NULL, NULL),
(47348, '2017-09-23 14:49:02', NULL, NULL, 13152, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 14:49:02', 'admin-1506141352-15061493422184185', 1, 1, 'SR', NULL, NULL, NULL),
(47349, '2017-09-23 14:46:31', NULL, NULL, 13151, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1506152110', 'admin', '2017-09-23 14:46:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47350, '2017-09-23 14:46:39', NULL, NULL, 13151, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 14:46:39', 'admin-1506141352-15061491992143691', 1, 1, 'SR', NULL, NULL, NULL),
(47351, '2017-09-23 14:16:02', NULL, NULL, 13150, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 14:16:02', 'admin-1506141352-15061473627236524', 1, 1, 'SR', NULL, NULL, NULL),
(47352, '2017-09-23 13:55:59', NULL, NULL, 13149, 0, 181, '116', 'Open Food ', 'Noodle 2 no meat', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 13:55:59', 'admin-1506141352-15061461594524368', 1, 0, '', NULL, NULL, '10.0'),
(47353, '2017-09-23 14:14:31', NULL, NULL, 13150, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1506152110', 'admin', '2017-09-23 14:14:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47354, '2017-09-23 11:23:55', NULL, NULL, 13135, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.30, 0.0000, 0.0000, 14.30, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:23:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47355, '2017-09-23 11:24:28', NULL, NULL, 13135, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:24:28', 'admin-1506135454-15061370686824014', 1, 0, '', NULL, NULL, NULL),
(47356, '2017-09-23 14:15:07', NULL, NULL, 13150, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 14:15:07', 'admin-1506141352-15061473068983838', 1, 1, 'SR', NULL, NULL, NULL),
(47357, '2017-09-23 12:13:13', NULL, NULL, 13141, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:13:13', 'admin-1506135454-15061399935722851', 1, 1, 'SR', NULL, NULL, NULL),
(47358, '2017-09-23 13:55:59', NULL, NULL, 13149, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 13:55:59', 'admin-1506141352-15061461594524368', 1, 0, '', NULL, NULL, '10.0');
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(47359, '2017-09-23 13:55:44', NULL, NULL, 13149, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1506152110', 'admin', '2017-09-23 13:55:44', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(47360, '2017-09-23 13:55:59', NULL, NULL, 13149, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 13:55:59', 'admin-1506141352-15061461594524368', 1, 0, '', NULL, NULL, '10.0'),
(47361, '2017-09-23 13:50:19', NULL, NULL, 13137, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 13:50:19', 'admin-1506141352-15061458196874519', 1, 1, 'SR', NULL, NULL, NULL),
(47362, '2017-09-23 13:50:19', NULL, NULL, 13137, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 13:50:19', 'admin-1506141352-15061458196874519', 1, 1, 'SR', NULL, NULL, NULL),
(47363, '2017-09-23 13:40:27', NULL, NULL, 13148, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 13:40:27', 'admin-1506141352-15061452273827335', 1, 1, 'SR', NULL, NULL, NULL),
(47364, '2017-09-23 13:40:27', NULL, NULL, 13148, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 13:40:27', 'admin-1506141352-15061452273827335', 1, 0, '', NULL, NULL, NULL),
(47365, '2017-09-23 13:39:32', NULL, NULL, 13148, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1506152110', 'admin', '2017-09-23 13:39:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47366, '2017-09-23 13:37:26', NULL, NULL, 13146, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 13:37:26', 'admin-1506141352-15061450458462010', 1, 1, 'SR', NULL, NULL, '10.0'),
(47367, '2017-09-23 13:34:08', NULL, NULL, 13147, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 13:34:08', 'admin-1506141352-15061448482688051', 1, 0, '', NULL, NULL, NULL),
(47368, '2017-09-23 13:22:49', NULL, NULL, 13146, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 13:22:49', 'admin-1506141352-1506144169306807', 1, 1, 'SR', NULL, NULL, '10.0'),
(47369, '2017-09-23 13:15:06', NULL, NULL, 13146, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 13:15:06', 'admin-1506141352-1506143705814774', 1, 1, 'SR', NULL, NULL, '10.0'),
(47370, '2017-09-23 13:15:21', NULL, NULL, 13146, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 13:15:21', 'admin-1506141352-15061437210556042', 1, 1, 'SR', NULL, NULL, '10.0'),
(47371, '2017-09-23 13:12:10', NULL, NULL, 13146, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 13:12:10', 'admin-1506141352-15061435302868963', 1, 1, 'SR', NULL, NULL, '10.0'),
(47372, '2017-09-23 11:44:24', NULL, NULL, 13137, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:44:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47373, '2017-09-23 11:39:35', NULL, NULL, 13136, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:39:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47374, '2017-09-23 12:43:23', NULL, NULL, 13145, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:43:23', 'admin-1506141352-1506141803385459', 1, 0, '', NULL, NULL, '10.0'),
(47375, '2017-09-23 12:43:23', NULL, NULL, 13145, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:43:23', 'admin-1506141352-1506141803385459', 1, 1, 'SR', NULL, NULL, '10.0'),
(47376, '2017-09-23 12:41:59', NULL, NULL, 13144, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:41:59', 'admin-1506141352-15061417196984992', 1, 0, '', NULL, NULL, NULL),
(47377, '2017-09-23 12:39:11', NULL, NULL, 13144, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:39:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47378, '2017-09-23 12:41:59', NULL, NULL, 13144, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:41:59', 'admin-1506141352-15061417196984992', 1, 0, '', NULL, NULL, NULL),
(47379, '2017-09-23 11:39:42', NULL, NULL, 13136, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:39:42', 'admin-1506135454-15061379823759044', 1, 1, 'SR', NULL, NULL, NULL),
(47380, '2017-09-23 11:39:55', NULL, NULL, 13124, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:39:55', 'admin-1506135454-15061379954059937', 1, 1, 'SR', NULL, NULL, NULL),
(47381, '2017-09-23 11:23:41', NULL, NULL, 13134, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:23:41', 'admin-1506135454-1506137021299879', 1, 0, '', NULL, NULL, NULL),
(47382, '2017-09-23 11:24:28', NULL, NULL, 13135, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:24:28', 'admin-1506135454-15061370686824014', 1, 0, '', NULL, NULL, NULL),
(47383, '2017-09-23 14:15:07', NULL, NULL, 13150, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 14:15:07', 'admin-1506141352-15061473068983838', 1, 0, '', NULL, NULL, NULL),
(47384, '2017-09-23 12:13:13', NULL, NULL, 13141, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:13:13', 'admin-1506135454-15061399935722851', 1, 0, '', NULL, NULL, NULL),
(47385, '2017-09-23 12:12:01', NULL, NULL, 13140, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:12:01', 'admin-1506135454-150613992139943', 1, 0, '', NULL, NULL, NULL),
(47386, '2017-09-23 12:12:58', NULL, NULL, 13141, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:12:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47387, '2017-09-23 12:06:54', NULL, NULL, 13137, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:06:54', 'admin-1506135454-15061396141884115', 1, 0, '', NULL, NULL, NULL),
(47388, '2017-09-23 10:24:28', NULL, NULL, 13128, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:24:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47389, '2017-09-23 10:09:14', NULL, NULL, 13124, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:09:14', 'admin-1506129025-15061325539207198', 1, 1, 'SR', NULL, NULL, NULL),
(47390, '2017-09-23 12:06:54', NULL, NULL, 13137, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:06:54', 'admin-1506135454-15061396141884115', 1, 0, '', NULL, NULL, NULL),
(47391, '2017-09-23 11:59:20', NULL, NULL, 13139, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:59:20', 'admin-1506135454-15061391599182881', 1, 0, '', NULL, NULL, NULL),
(47392, '2017-09-23 11:59:20', NULL, NULL, 13139, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:59:20', 'admin-1506135454-15061391599182881', 1, 0, '', NULL, NULL, NULL),
(47393, '2017-09-23 11:59:20', NULL, NULL, 13139, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:59:20', 'admin-1506135454-15061391599182881', 1, 1, 'SR', NULL, NULL, NULL),
(47394, '2017-09-23 11:59:20', NULL, NULL, 13139, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:59:20', 'admin-1506135454-15061391599182881', 1, 1, 'SR', NULL, NULL, NULL),
(47395, '2017-09-23 11:59:01', NULL, NULL, 13139, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:59:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47396, '2017-09-23 11:56:26', NULL, NULL, 13138, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:56:26', 'admin-1506135454-1506138986754289', 1, 1, 'SR', NULL, NULL, NULL),
(47397, '2017-09-23 11:53:51', NULL, NULL, 13138, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:53:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47398, '2017-09-23 11:24:28', NULL, NULL, 13135, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:24:28', 'admin-1506135454-15061370686824014', 1, 1, 'SR', NULL, NULL, NULL),
(47399, '2017-09-23 11:24:28', NULL, NULL, 13135, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:24:28', 'admin-1506135454-15061370686824014', 1, 1, 'SR', NULL, NULL, NULL),
(47400, '2017-09-23 10:24:51', NULL, NULL, 13128, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:24:51', 'admin-1506129025-15061334908788251', 1, 0, '', NULL, NULL, NULL),
(47401, '2017-09-23 11:39:42', NULL, NULL, 13136, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:39:42', 'admin-1506135454-15061379823759044', 1, 1, 'SR', NULL, NULL, NULL),
(47402, '2017-09-23 11:24:28', NULL, NULL, 13135, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:24:28', 'admin-1506135454-15061370686824014', 1, 1, 'SR', NULL, NULL, NULL),
(47403, '2017-09-23 11:24:28', NULL, NULL, 13135, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:24:28', 'admin-1506135454-15061370686824014', 1, 1, 'SR', NULL, NULL, NULL),
(47404, '2017-09-23 09:31:51', NULL, NULL, 13122, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 09:31:51', 'admin-1506129025-15061303109957810', 1, 0, '', NULL, NULL, NULL),
(47405, '2017-09-23 11:24:28', NULL, NULL, 13135, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:24:28', 'admin-1506135454-15061370686824014', 1, 0, '', NULL, NULL, NULL),
(47406, '2017-09-23 10:24:51', NULL, NULL, 13128, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:24:51', 'admin-1506129025-15061334908788251', 1, 0, '', NULL, NULL, NULL),
(47407, '2017-09-23 10:31:12', NULL, NULL, 13129, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:31:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47408, '2017-09-23 10:31:34', NULL, NULL, 13129, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:31:34', 'admin-1506129025-15061338940797781', 1, 0, '', NULL, NULL, NULL),
(47409, '2017-09-23 10:31:34', NULL, NULL, 13129, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:31:34', 'admin-1506129025-15061338940797781', 1, 0, '', NULL, NULL, NULL),
(47410, '2017-09-23 11:24:28', NULL, NULL, 13135, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:24:28', 'admin-1506135454-15061370686824014', 1, 0, '', NULL, NULL, NULL),
(47411, '2017-09-23 11:24:28', NULL, NULL, 13135, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:24:28', 'admin-1506135454-15061370686824014', 1, 0, '', NULL, NULL, NULL),
(47412, '2017-09-23 12:43:23', NULL, NULL, 13145, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:43:23', 'admin-1506141352-1506141803385459', 1, 0, '', NULL, NULL, '10.0'),
(47413, '2017-09-23 11:23:41', NULL, NULL, 13134, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:23:41', 'admin-1506135454-1506137021299879', 1, 1, 'SR', NULL, NULL, NULL),
(47414, '2017-09-23 11:23:41', NULL, NULL, 13134, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:23:41', 'admin-1506135454-1506137021299879', 1, 1, 'SR', NULL, NULL, NULL),
(47415, '2017-09-23 11:23:41', NULL, NULL, 13134, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:23:41', 'admin-1506135454-1506137021299879', 1, 1, 'SR', NULL, NULL, NULL),
(47416, '2017-09-23 11:23:41', NULL, NULL, 13134, 0, 207, '142', 'Cheesy Bacon Toast', 'add 2 scrambled egg', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:23:41', 'admin-1506135454-1506137021299879', 1, 0, '', NULL, NULL, NULL),
(47417, '2017-09-23 12:22:08', NULL, NULL, 13142, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 12:22:08', 'admin-1506135454-15061405286709242', 1, 0, '', NULL, NULL, NULL),
(47418, '2017-09-23 11:23:15', NULL, NULL, 13134, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:23:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47419, '2017-09-23 10:12:06', NULL, NULL, 13125, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:12:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47420, '2017-09-23 11:56:26', NULL, NULL, 13138, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:56:26', 'admin-1506135454-1506138986754289', 1, 1, 'SR', NULL, NULL, NULL),
(47421, '2017-09-23 11:02:54', NULL, NULL, 13133, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:02:54', 'admin-1506135454-15061357744437887', 1, 0, '', NULL, NULL, NULL),
(47422, '2017-09-23 11:02:54', NULL, NULL, 13133, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:02:54', 'admin-1506135454-15061357744437887', 1, 0, '', NULL, NULL, NULL),
(47423, '2017-09-23 11:02:54', NULL, NULL, 13133, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:02:54', 'admin-1506135454-15061357744437887', 1, 0, '', NULL, NULL, NULL),
(47424, '2017-09-23 10:58:45', NULL, NULL, 13132, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:58:45', 'admin-1506135454-15061355256207617', 1, 1, 'SR', NULL, NULL, NULL),
(47425, '2017-09-23 10:58:45', NULL, NULL, 13132, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:58:45', 'admin-1506135454-15061355256207617', 1, 0, '', NULL, NULL, NULL),
(47426, '2017-09-23 10:58:45', NULL, NULL, 13132, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:58:45', 'admin-1506135454-15061355256207617', 1, 1, 'SR', NULL, NULL, NULL),
(47427, '2017-09-23 11:00:31', NULL, NULL, 13133, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1506152110', 'admin', '2017-09-23 11:00:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47428, '2017-09-23 10:58:45', NULL, NULL, 13132, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:58:45', 'admin-1506135454-15061355256207617', 1, 0, '', NULL, NULL, NULL),
(47429, '2017-09-23 10:58:45', NULL, NULL, 13132, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:58:45', 'admin-1506135454-15061355256207617', 1, 1, 'SR', NULL, NULL, NULL),
(47430, '2017-09-23 10:58:45', NULL, NULL, 13132, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:58:45', 'admin-1506135454-15061355256207617', 1, 0, '', NULL, NULL, NULL),
(47431, '2017-09-23 10:42:35', NULL, NULL, 13130, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:42:35', 'admin-1506129025-15061345549162093', 1, 0, '', NULL, NULL, NULL),
(47432, '2017-09-23 10:15:31', NULL, NULL, 13126, 0, 181, '116', 'Open Food ', 'bacon,scramble egg,sosej', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:15:31', 'admin-1506129025-15061329313528513', 1, 0, '', 1, NULL, NULL),
(47433, '2017-09-23 10:42:02', NULL, NULL, 13130, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:42:02', 'admin-1506129025-15061345222448723', 1, 0, '', NULL, NULL, NULL),
(47434, '2017-09-23 10:42:02', NULL, NULL, 13130, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:42:02', 'admin-1506129025-15061345222448723', 1, 0, '', NULL, NULL, NULL),
(47435, '2017-09-23 10:42:02', NULL, NULL, 13130, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:42:02', 'admin-1506129025-15061345222448723', 1, 0, '', NULL, NULL, NULL),
(47436, '2017-09-23 10:31:34', NULL, NULL, 13129, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:31:34', 'admin-1506129025-15061338940797781', 1, 1, 'SR', NULL, NULL, NULL),
(47437, '2017-09-23 10:31:34', NULL, NULL, 13129, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:31:34', 'admin-1506129025-15061338940797781', 1, 1, 'SR', NULL, NULL, NULL),
(47438, '2017-09-23 10:24:51', NULL, NULL, 13128, 0, 153, '87', 'Wake Me Up!', ' change to sosej,No bacon', 'Meals', 'Morning Bites ', 2, 21.00, 42.0000, 0.0000, 42.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:24:51', 'admin-1506129025-15061334908788251', 1, 0, '', NULL, NULL, NULL),
(47439, '2017-09-23 10:16:08', NULL, NULL, 13127, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:16:08', 'admin-1506129025-15061329685868977', 1, 1, 'SR', NULL, NULL, NULL),
(47440, '2017-09-23 10:16:08', NULL, NULL, 13127, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:16:08', 'admin-1506129025-15061329685868977', 1, 0, '', NULL, NULL, NULL),
(47441, '2017-09-23 10:16:08', NULL, NULL, 13127, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:16:08', 'admin-1506129025-15061329685868977', 1, 0, '', NULL, NULL, NULL),
(47442, '2017-09-23 10:16:08', NULL, NULL, 13127, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:16:08', 'admin-1506129025-15061329685868977', 1, 1, 'SR', NULL, NULL, NULL),
(47443, '2017-09-23 10:16:08', NULL, NULL, 13127, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:16:08', 'admin-1506129025-15061329685868977', 1, 1, 'SR', NULL, NULL, NULL),
(47444, '2017-09-23 10:16:08', NULL, NULL, 13127, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:16:08', 'admin-1506129025-15061329685868977', 1, 0, '', NULL, NULL, NULL),
(47445, '2017-09-23 10:16:08', NULL, NULL, 13127, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 2, 15.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:16:08', 'admin-1506129025-15061329685868977', 1, 0, '', NULL, NULL, NULL),
(47446, '2017-09-23 10:15:39', NULL, NULL, 13127, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.80, 0.0000, 0.0000, 10.80, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:15:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47447, '2017-09-23 10:12:17', NULL, NULL, 13125, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:12:17', 'admin-1506129025-15061327373414263', 1, 0, '', NULL, NULL, NULL),
(47448, '2017-09-23 10:12:17', NULL, NULL, 13125, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:12:17', 'admin-1506129025-15061327373414263', 1, 0, '', NULL, NULL, NULL),
(47449, '2017-09-23 10:12:17', NULL, NULL, 13125, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:12:17', 'admin-1506129025-15061327373414263', 1, 1, 'SR', NULL, NULL, NULL),
(47450, '2017-09-23 09:46:53', NULL, NULL, 13123, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 09:46:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47451, '2017-09-23 10:09:14', NULL, NULL, 13124, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:09:14', 'admin-1506129025-15061325539207198', 1, 0, '', NULL, NULL, NULL),
(47452, '2017-09-23 09:47:03', NULL, NULL, 13123, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 09:47:03', 'admin-1506129025-15061312232217960', 1, 1, 'SR', NULL, NULL, NULL),
(47453, '2017-09-23 10:09:09', NULL, NULL, 13124, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1506152110', 'admin', '2017-09-23 10:09:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47454, '2017-09-23 09:47:03', NULL, NULL, 13123, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 09:47:03', 'admin-1506129025-15061312232217960', 1, 0, '', NULL, NULL, NULL),
(47455, '2017-09-23 09:31:51', NULL, NULL, 13122, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 09:31:51', 'admin-1506129025-15061303109957810', 1, 1, 'SR', NULL, NULL, NULL),
(47456, '2017-09-23 09:31:51', NULL, NULL, 13122, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 09:31:51', 'admin-1506129025-15061303109957810', 1, 0, '', NULL, NULL, NULL),
(47457, '2017-09-23 09:31:51', NULL, NULL, 13122, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506152110', 'admin', '2017-09-23 09:31:51', 'admin-1506129025-15061303109957810', 1, 0, '', NULL, NULL, NULL),
(47458, '2017-09-23 09:30:26', NULL, NULL, 13122, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1506152110', 'admin', '2017-09-23 09:30:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47459, '2017-09-24 14:12:47', NULL, NULL, 13214, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:12:47', 'admin-1506229681-1506233567320879', 1, 1, 'SR', NULL, NULL, NULL),
(47460, '2017-09-24 14:12:47', NULL, NULL, 13214, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:12:47', 'admin-1506229681-1506233567320879', 1, 0, '', NULL, NULL, NULL),
(47461, '2017-09-24 14:07:40', NULL, NULL, 13213, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:07:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47462, '2017-09-24 14:07:44', NULL, NULL, 13213, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:07:44', 'admin-1506229681-15062332645894216', 1, 1, 'SR', NULL, NULL, NULL),
(47463, '2017-09-24 13:23:21', NULL, NULL, 13208, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:23:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47464, '2017-09-24 13:23:29', NULL, NULL, 13208, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:23:29', 'admin-1506229681-1506230609711225', 1, 1, 'SR', NULL, NULL, NULL),
(47465, '2017-09-24 13:25:02', NULL, NULL, 13209, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:25:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47466, '2017-09-24 13:25:12', NULL, NULL, 13209, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:25:12', 'admin-1506229681-15062307126193691', 1, 0, '', NULL, NULL, NULL),
(47467, '2017-09-24 13:25:12', NULL, NULL, 13209, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:25:12', 'admin-1506229681-15062307126193691', 1, 0, '', NULL, NULL, NULL),
(47468, '2017-09-24 13:25:12', NULL, NULL, 13209, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:25:12', 'admin-1506229681-15062307126193691', 1, 0, '', NULL, NULL, NULL),
(47469, '2017-09-24 12:56:55', NULL, NULL, 13204, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:56:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47470, '2017-09-24 11:17:33', NULL, NULL, 13190, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:17:33', 'admin-1506220539-15062230527743071', 1, 1, 'SR', NULL, NULL, NULL),
(47471, '2017-09-24 11:17:47', NULL, NULL, 13192, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:17:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47472, '2017-09-24 16:59:15', NULL, NULL, 13222, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 16:59:15', 'admin-1506229681-15062435557489860', 1, 1, 'SR', NULL, NULL, NULL),
(47473, '2017-09-24 16:59:15', NULL, NULL, 13222, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 16:59:15', 'admin-1506229681-15062435557489860', 1, 1, 'SR', NULL, NULL, NULL),
(47474, '2017-09-24 14:24:37', NULL, NULL, 13217, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:24:37', 'admin-1506229681-15062342777007555', 1, 1, 'SR', NULL, NULL, NULL),
(47475, '2017-09-24 13:15:33', NULL, NULL, 13206, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:15:33', 'admin-1506229681-15062301328155054', 1, 1, 'SR', NULL, NULL, NULL),
(47476, '2017-09-24 11:03:41', NULL, NULL, 13190, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 18.60, 0.0000, 0.0000, 18.60, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:03:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47477, '2017-09-24 11:03:55', NULL, NULL, 13190, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:03:55', 'admin-1506220539-15062222348718744', 1, 1, 'SR', NULL, NULL, NULL),
(47478, '2017-09-24 11:03:55', NULL, NULL, 13190, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:03:55', 'admin-1506220539-15062222348718744', 1, 1, 'SR', NULL, NULL, NULL),
(47479, '2017-09-24 11:03:55', NULL, NULL, 13190, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:03:55', 'admin-1506220539-15062222348718744', 1, 1, 'SR', NULL, NULL, NULL),
(47480, '2017-09-24 14:12:47', NULL, NULL, 13214, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:12:47', 'admin-1506229681-1506233567320879', 1, 0, '', NULL, NULL, NULL),
(47481, '2017-09-24 12:46:42', NULL, NULL, 13203, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:46:42', 'admin-1506223104-1506228402642468', 1, 0, '', NULL, NULL, NULL),
(47482, '2017-09-24 12:46:42', NULL, NULL, 13203, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:46:42', 'admin-1506223104-1506228402642468', 1, 0, '', NULL, NULL, NULL),
(47483, '2017-09-24 14:22:45', NULL, NULL, 13217, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:22:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47484, '2017-09-24 14:07:37', NULL, NULL, 13212, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:07:37', 'admin-1506229681-15062332572428934', 1, 1, 'SR', NULL, NULL, NULL),
(47485, '2017-09-24 16:54:15', NULL, NULL, 13223, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 16:54:15', 'admin-1506229681-15062432549309842', 1, 1, 'SR', NULL, NULL, NULL),
(47486, '2017-09-24 16:54:15', NULL, NULL, 13223, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 16:54:15', 'admin-1506229681-15062432549309842', 1, 1, 'SR', NULL, NULL, NULL),
(47487, '2017-09-24 12:25:25', NULL, NULL, 13200, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:25:25', 'admin-1506223104-15062271257843328', 1, 0, '', NULL, NULL, NULL),
(47488, '2017-09-24 12:28:29', NULL, NULL, 13201, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:28:29', 'admin-1506223104-15062273090094192', 1, 1, 'SR', 1, NULL, NULL),
(47489, '2017-09-24 13:56:50', NULL, NULL, 13211, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:56:50', 'admin-1506229681-15062326101936725', 1, 1, 'SR', NULL, NULL, NULL),
(47490, '2017-09-24 13:56:50', NULL, NULL, 13211, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:56:50', 'admin-1506229681-15062326101936725', 1, 0, '', NULL, NULL, NULL),
(47491, '2017-09-24 11:17:32', NULL, NULL, 13190, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:17:32', 'admin-1506220539-15062230527743071', 1, 0, '', NULL, NULL, NULL),
(47492, '2017-09-24 11:17:32', NULL, NULL, 13190, 0, 153, '87', 'Wake Me Up!', 'NO BACON', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:17:32', 'admin-1506220539-15062230527743071', 1, 0, '', NULL, NULL, NULL),
(47493, '2017-09-24 11:17:32', NULL, NULL, 13190, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:17:32', 'admin-1506220539-15062230527743071', 1, 0, '', NULL, NULL, NULL),
(47494, '2017-09-24 11:17:32', NULL, NULL, 13190, 0, 158, '92', 'Banana Stuffed Nutella Toast ', 'NO BANANA', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:17:32', 'admin-1506220539-15062230527743071', 1, 0, '', NULL, NULL, NULL),
(47495, '2017-09-24 11:17:32', NULL, NULL, 13190, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:17:32', 'admin-1506220539-15062230527743071', 1, 0, '', NULL, NULL, NULL),
(47496, '2017-09-24 16:25:32', NULL, NULL, 13221, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 16:25:32', 'admin-1506229681-15062415327126868', 1, 0, '', NULL, NULL, NULL),
(47497, '2017-09-24 16:28:47', NULL, NULL, 13222, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 16:28:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47498, '2017-09-24 16:28:53', NULL, NULL, 13222, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 16:28:53', 'admin-1506229681-15062417335673321', 1, 1, 'SR', NULL, NULL, NULL),
(47499, '2017-09-24 16:28:53', NULL, NULL, 13222, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 16:28:53', 'admin-1506229681-15062417335673321', 1, 1, 'SR', NULL, NULL, NULL),
(47500, '2017-09-24 16:53:32', NULL, NULL, 13223, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1506229681', 'admin', '2017-09-24 16:53:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47501, '2017-09-24 13:56:50', NULL, NULL, 13211, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:56:50', 'admin-1506229681-15062326101936725', 1, 0, '', NULL, NULL, NULL),
(47502, '2017-09-24 14:07:30', NULL, NULL, 13212, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:07:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47503, '2017-09-24 14:33:40', NULL, NULL, 13218, 0, 72, '72', 'Shimeji Mushroom with Chicken ', 'no spicy', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:33:40', 'admin-1506229681-15062348203716866', 1, 1, 'SR', NULL, NULL, NULL),
(47504, '2017-09-24 14:33:40', NULL, NULL, 13218, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:33:40', 'admin-1506229681-15062348203716866', 1, 1, 'SR', NULL, NULL, NULL),
(47505, '2017-09-24 13:57:06', NULL, NULL, 13211, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:57:06', 'admin-1506229681-150623262587766', 1, 1, 'SR', NULL, NULL, NULL),
(47506, '2017-09-24 13:15:33', NULL, NULL, 13206, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:15:33', 'admin-1506229681-15062301328155054', 1, 1, 'SR', NULL, NULL, NULL),
(47507, '2017-09-24 13:07:54', NULL, NULL, 13205, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:07:54', 'admin-1506223104-15062296741464550', 1, 0, '', NULL, NULL, NULL),
(47508, '2017-09-24 14:12:47', NULL, NULL, 13214, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:12:47', 'admin-1506229681-1506233567320879', 1, 0, '', NULL, NULL, NULL),
(47509, '2017-09-24 15:24:42', NULL, NULL, 13218, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 15:24:42', 'admin-1506229681-15062378824369556', 1, 0, '', NULL, NULL, NULL),
(47510, '2017-09-24 14:16:11', NULL, NULL, 13215, 0, 181, '116', 'Open Food ', 'weekend promo', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:16:11', 'admin-1506229681-15062337713541161', 1, 0, '', 1, NULL, NULL),
(47511, '2017-09-24 12:41:50', NULL, NULL, 13202, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:41:50', 'admin-1506223104-15062281106968587', 1, 1, 'SR', NULL, NULL, NULL),
(47512, '2017-09-24 12:41:50', NULL, NULL, 13202, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 4, 12.00, 48.0000, 0.0000, 48.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:41:50', 'admin-1506223104-15062281106968587', 1, 1, 'SR', NULL, NULL, NULL),
(47513, '2017-09-24 12:41:36', NULL, NULL, 13202, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.40, 0.0000, 0.0000, 15.40, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:41:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47514, '2017-09-24 12:47:18', NULL, NULL, 13200, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:47:18', 'admin-1506223104-15062284380032045', 1, 0, '', NULL, NULL, NULL),
(47515, '2017-09-24 12:47:18', NULL, NULL, 13200, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:47:18', 'admin-1506223104-15062284380032045', 1, 0, '', NULL, NULL, NULL),
(47516, '2017-09-24 12:59:17', NULL, NULL, 13204, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:59:17', 'admin-1506223104-15062291574356038', 1, 1, 'SR', NULL, NULL, NULL),
(47517, '2017-09-24 12:13:38', NULL, NULL, 13199, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:13:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47518, '2017-09-24 11:22:50', NULL, NULL, 13194, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:22:50', 'admin-1506223104-15062233704207559', 1, 1, 'SR', NULL, NULL, NULL),
(47519, '2017-09-24 10:36:59', NULL, NULL, 13182, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:36:59', 'admin-1506220539-15062206189604134', 1, 1, 'SR', NULL, NULL, NULL),
(47520, '2017-09-24 12:46:42', NULL, NULL, 13203, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:46:42', 'admin-1506223104-1506228402642468', 1, 1, 'SR', NULL, NULL, NULL),
(47521, '2017-09-24 12:46:42', NULL, NULL, 13203, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:46:42', 'admin-1506223104-1506228402642468', 1, 0, '', NULL, NULL, NULL),
(47522, '2017-09-24 10:36:39', NULL, NULL, 13182, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:36:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47523, '2017-09-24 10:18:15', NULL, NULL, 13177, 0, 269, '203', 'Espresso Con Panna', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:18:15', 'admin-1506214529-15062194952298255', 1, 0, '', NULL, NULL, NULL),
(47524, '2017-09-24 10:17:24', NULL, NULL, 13176, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:17:24', 'admin-1506214529-15062194442018279', 1, 0, '', NULL, NULL, NULL),
(47525, '2017-09-24 11:22:20', NULL, NULL, 13194, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:22:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47526, '2017-09-24 12:25:01', NULL, NULL, 13200, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:25:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47527, '2017-09-24 09:42:40', NULL, NULL, 13168, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:42:40', 'admin-1506214529-1506217359972273', 1, 0, '', NULL, NULL, NULL),
(47528, '2017-09-24 14:18:20', NULL, NULL, 13216, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:18:20', 'admin-1506229681-15062339004652170', 1, 1, 'SR', NULL, NULL, NULL),
(47529, '2017-09-24 16:54:15', NULL, NULL, 13223, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 16:54:15', 'admin-1506229681-15062432549309842', 1, 0, '', NULL, NULL, NULL),
(47530, '2017-09-24 16:25:10', NULL, NULL, 13221, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1506229681', 'admin', '2017-09-24 16:25:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47531, '2017-09-24 13:07:54', NULL, NULL, 13205, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:07:54', 'admin-1506223104-15062296741464550', 1, 0, '', NULL, NULL, NULL),
(47532, '2017-09-24 13:41:13', NULL, NULL, 13210, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:41:13', 'admin-1506229681-15062316733161225', 1, 1, 'SR', NULL, NULL, NULL),
(47533, '2017-09-24 13:39:38', NULL, NULL, 13210, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:39:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47534, '2017-09-24 13:38:35', NULL, NULL, 13206, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:38:35', 'admin-1506229681-15062315157578652', 1, 1, 'SR', NULL, NULL, NULL),
(47535, '2017-09-24 14:39:57', NULL, NULL, 13219, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:39:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47536, '2017-09-24 14:40:01', NULL, NULL, 13219, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:40:01', 'admin-1506229681-15062352014172611', 1, 1, 'SR', NULL, NULL, NULL),
(47537, '2017-09-24 15:24:42', NULL, NULL, 13218, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 15:24:42', 'admin-1506229681-15062378824369556', 1, 0, '', NULL, NULL, NULL),
(47538, '2017-09-24 16:03:40', NULL, NULL, 13220, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 16:03:40', 'admin-1506229681-15062402206843224', 1, 1, 'SR', 1, NULL, NULL),
(47539, '2017-09-24 16:54:15', NULL, NULL, 13223, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 16:54:15', 'admin-1506229681-15062432549309842', 1, 1, 'SR', NULL, NULL, NULL),
(47540, '2017-09-24 16:25:32', NULL, NULL, 13221, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 16:25:32', 'admin-1506229681-15062415327126868', 1, 1, 'SR', NULL, NULL, NULL),
(47541, '2017-09-24 13:20:51', NULL, NULL, 13207, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:20:51', 'admin-1506229681-15062304515883425', 1, 0, '', NULL, NULL, NULL),
(47542, '2017-09-24 10:17:41', NULL, NULL, 13177, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:17:41', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(47543, '2017-09-24 10:18:15', NULL, NULL, 13177, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:18:15', 'admin-1506214529-15062194952298255', 1, 0, '', NULL, NULL, NULL),
(47544, '2017-09-24 10:18:15', NULL, NULL, 13177, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:18:15', 'admin-1506214529-15062194952298255', 1, 1, 'SR', NULL, NULL, NULL),
(47545, '2017-09-24 16:25:32', NULL, NULL, 13221, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 16:25:32', 'admin-1506229681-15062415327126868', 1, 0, '', NULL, NULL, NULL),
(47546, '2017-09-24 14:33:52', NULL, NULL, 13218, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:33:52', 'admin-1506229681-15062348322065313', 1, 1, 'SR', NULL, NULL, NULL),
(47547, '2017-09-24 13:20:51', NULL, NULL, 13207, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:20:51', 'admin-1506229681-15062304515883425', 1, 0, '', NULL, NULL, NULL),
(47548, '2017-09-24 13:20:51', NULL, NULL, 13207, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:20:51', 'admin-1506229681-15062304515883425', 1, 1, 'SR', NULL, NULL, NULL),
(47549, '2017-09-24 13:20:51', NULL, NULL, 13207, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:20:51', 'admin-1506229681-15062304515883425', 1, 1, 'SR', NULL, NULL, NULL),
(47550, '2017-09-24 00:00:00', NULL, NULL, 13199, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:22:50', 'admin-1506223104-15062233704207559', 1, 0, '', NULL, NULL, NULL),
(47551, '2017-09-24 13:56:20', NULL, NULL, 13211, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:56:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47552, '2017-09-24 00:00:00', NULL, NULL, 13198, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:22:50', 'admin-1506223104-15062233704207559', 1, 1, 'SR', NULL, NULL, NULL),
(47553, '2017-09-24 11:53:14', NULL, NULL, 13197, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:53:14', 'admin-1506223104-15062251942313386', 1, 1, 'SR', NULL, NULL, NULL),
(47554, '2017-09-24 11:54:48', NULL, NULL, 13187, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:54:48', 'admin-1506223104-15062252884152833', 1, 0, '', NULL, NULL, NULL),
(47555, '2017-09-24 14:32:51', NULL, NULL, 13218, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:32:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47556, '2017-09-24 12:25:25', NULL, NULL, 13200, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:25:25', 'admin-1506223104-15062271257843328', 1, 0, '', NULL, NULL, NULL),
(47557, '2017-09-24 13:20:51', NULL, NULL, 13207, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:20:51', 'admin-1506229681-15062304515883425', 1, 0, '', NULL, NULL, NULL),
(47558, '2017-09-24 13:20:51', NULL, NULL, 13207, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:20:51', 'admin-1506229681-15062304515883425', 1, 0, '', NULL, NULL, NULL),
(47559, '2017-09-24 11:20:32', NULL, NULL, 13193, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:20:32', 'admin-1506223104-15062232318952833', 1, 0, '', NULL, NULL, NULL),
(47560, '2017-09-24 11:53:14', NULL, NULL, 13197, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:53:14', 'admin-1506223104-15062251942313386', 1, 1, 'SR', NULL, NULL, NULL),
(47561, '2017-09-24 11:53:14', NULL, NULL, 13197, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:53:14', 'admin-1506223104-15062251942313386', 1, 0, '', NULL, NULL, NULL),
(47562, '2017-09-24 11:53:14', NULL, NULL, 13197, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:53:14', 'admin-1506223104-15062251942313386', 1, 0, '', NULL, NULL, NULL),
(47563, '2017-09-24 11:46:18', NULL, NULL, 13196, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:46:18', 'admin-1506223104-15062247782207283', 1, 1, 'SR', NULL, NULL, NULL),
(47564, '2017-09-24 11:52:59', NULL, NULL, 13197, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:52:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47565, '2017-09-24 10:41:34', NULL, NULL, 13185, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:41:34', 'admin-1506220539-15062208945196616', 1, 1, 'SR', NULL, NULL, NULL),
(47566, '2017-09-24 10:41:34', NULL, NULL, 13185, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:41:34', 'admin-1506220539-15062208945196616', 1, 1, 'SR', NULL, NULL, NULL),
(47567, '2017-09-24 10:41:34', NULL, NULL, 13185, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:41:34', 'admin-1506220539-15062208945196616', 1, 1, 'SR', NULL, NULL, NULL),
(47568, '2017-09-24 10:44:51', NULL, NULL, 13186, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:44:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47569, '2017-09-24 10:45:28', NULL, NULL, 13186, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:45:28', 'admin-1506220539-15062211284863999', 1, 0, '', NULL, NULL, NULL),
(47570, '2017-09-24 10:45:28', NULL, NULL, 13186, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:45:28', 'admin-1506220539-15062211284863999', 1, 0, '', NULL, NULL, NULL),
(47571, '2017-09-24 09:41:24', NULL, NULL, 13167, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:41:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47572, '2017-09-24 09:31:24', NULL, NULL, 13163, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:31:24', 'admin-1506214529-15062166842935247', 1, 1, 'SR', NULL, NULL, NULL),
(47573, '2017-09-24 14:18:13', NULL, NULL, 13216, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:18:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47574, '2017-09-24 11:46:18', NULL, NULL, 13196, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:46:18', 'admin-1506223104-15062247782207283', 1, 1, 'SR', NULL, NULL, NULL),
(47575, '2017-09-24 10:41:34', NULL, NULL, 13185, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:41:34', 'admin-1506220539-15062208945196616', 1, 0, '', NULL, NULL, NULL),
(47576, '2017-09-24 11:20:13', NULL, NULL, 13193, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:20:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47577, '2017-09-24 12:57:51', NULL, NULL, 13204, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:57:51', 'admin-1506223104-15062290712343181', 1, 1, 'SR', NULL, NULL, NULL),
(47578, '2017-09-24 12:57:51', NULL, NULL, 13204, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:57:51', 'admin-1506223104-15062290712343181', 1, 0, '', NULL, NULL, NULL),
(47579, '2017-09-24 11:44:20', NULL, NULL, 13195, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:44:20', 'admin-1506223104-15062246602673445', 1, 1, 'SR', NULL, NULL, NULL),
(47580, '2017-09-24 13:15:33', NULL, NULL, 13206, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:15:33', 'admin-1506229681-15062301328155054', 1, 1, 'SR', NULL, NULL, NULL),
(47581, '2017-09-24 13:15:33', NULL, NULL, 13206, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:15:33', 'admin-1506229681-15062301328155054', 1, 1, 'SR', NULL, NULL, NULL),
(47582, '2017-09-24 13:15:33', NULL, NULL, 13206, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:15:33', 'admin-1506229681-15062301328155054', 1, 0, '', NULL, NULL, NULL),
(47583, '2017-09-24 13:15:33', NULL, NULL, 13206, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:15:33', 'admin-1506229681-15062301328155054', 1, 0, '', NULL, NULL, NULL),
(47584, '2017-09-24 13:15:33', NULL, NULL, 13206, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:15:33', 'admin-1506229681-15062301328155054', 1, 0, '', NULL, NULL, NULL),
(47585, '2017-09-24 12:46:42', NULL, NULL, 13203, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:46:42', 'admin-1506223104-1506228402642468', 1, 1, 'SR', NULL, NULL, NULL),
(47586, '2017-09-24 11:44:20', NULL, NULL, 13195, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:44:20', 'admin-1506223104-15062246602673445', 1, 0, '', NULL, NULL, NULL),
(47587, '2017-09-24 11:44:10', NULL, NULL, 13195, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:44:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47588, '2017-09-24 00:00:00', NULL, NULL, 13199, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:22:50', 'admin-1506223104-15062233704207559', 1, 1, 'SR', NULL, NULL, NULL),
(47589, '2017-09-24 14:12:47', NULL, NULL, 13214, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:12:47', 'admin-1506229681-1506233567320879', 1, 0, '', NULL, NULL, NULL),
(47590, '2017-09-24 11:20:08', NULL, NULL, 13190, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:20:08', 'admin-1506223104-15062232081801613', 1, 0, '', NULL, NULL, NULL),
(47591, '2017-09-24 10:00:25', NULL, NULL, 13164, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:00:25', 'admin-1506214529-15062184257938147', 1, 1, 'SR', NULL, NULL, NULL),
(47592, '2017-09-24 10:00:33', NULL, NULL, 13173, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.10, 0.0000, 0.0000, 13.10, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:00:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47593, '2017-09-24 10:01:39', NULL, NULL, 13173, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:01:39', 'admin-1506214529-1506218499495941', 1, 0, '', NULL, NULL, NULL),
(47594, '2017-09-24 13:15:33', NULL, NULL, 13206, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:15:33', 'admin-1506229681-15062301328155054', 1, 0, '', NULL, NULL, NULL),
(47595, '2017-09-24 14:33:52', NULL, NULL, 13218, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:33:52', 'admin-1506229681-15062348322065313', 1, 1, 'SR', NULL, NULL, NULL),
(47596, '2017-09-24 11:18:09', NULL, NULL, 13192, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:18:09', 'admin-1506220539-15062230895483888', 1, 0, '', NULL, NULL, NULL),
(47597, '2017-09-24 12:13:07', NULL, NULL, 13198, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:13:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47598, '2017-09-24 11:18:09', NULL, NULL, 13192, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:18:09', 'admin-1506220539-15062230895483888', 1, 1, 'SR', NULL, NULL, NULL),
(47599, '2017-09-24 11:18:09', NULL, NULL, 13192, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:18:09', 'admin-1506220539-15062230895483888', 1, 1, 'SR', NULL, NULL, NULL),
(47600, '2017-09-24 11:03:55', NULL, NULL, 13190, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:03:55', 'admin-1506220539-15062222348718744', 1, 1, 'SR', NULL, NULL, NULL),
(47601, '2017-09-24 11:03:55', NULL, NULL, 13190, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:03:55', 'admin-1506220539-15062222348718744', 1, 1, 'SR', NULL, NULL, NULL),
(47602, '2017-09-24 13:07:30', NULL, NULL, 13205, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:07:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47603, '2017-09-24 12:57:51', NULL, NULL, 13204, 0, 181, '116', 'Open Food ', 'Add pork', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:57:51', 'admin-1506223104-15062290712343181', 1, 0, '', NULL, NULL, NULL),
(47604, '2017-09-24 11:18:09', NULL, NULL, 13192, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:18:09', 'admin-1506220539-15062230895483888', 1, 1, 'SR', NULL, NULL, NULL),
(47605, '2017-09-24 11:18:09', NULL, NULL, 13192, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:18:09', 'admin-1506220539-15062230895483888', 1, 0, '', NULL, NULL, NULL),
(47606, '2017-09-24 11:18:09', NULL, NULL, 13192, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:18:09', 'admin-1506220539-15062230895483888', 1, 0, '', NULL, NULL, NULL),
(47607, '2017-09-24 13:19:26', NULL, NULL, 13207, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:19:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47608, '2017-09-24 12:46:42', NULL, NULL, 13203, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:46:42', 'admin-1506223104-1506228402642468', 1, 1, 'SR', NULL, NULL, NULL),
(47609, '2017-09-24 11:16:37', NULL, NULL, 13191, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:16:37', 'admin-1506220539-15062229972071773', 1, 0, '', NULL, NULL, NULL),
(47610, '2017-09-24 11:16:37', NULL, NULL, 13191, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:16:37', 'admin-1506220539-15062229972071773', 1, 0, '', NULL, NULL, NULL),
(47611, '2017-09-24 10:37:25', NULL, NULL, 13183, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:37:25', 'admin-1506220539-15062206449655285', 1, 1, 'SR', NULL, NULL, NULL),
(47612, '2017-09-24 10:37:59', NULL, NULL, 13184, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:37:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47613, '2017-09-24 10:38:19', NULL, NULL, 13184, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:38:19', 'admin-1506220539-15062206997472550', 1, 0, '', NULL, NULL, NULL),
(47614, '2017-09-24 10:01:39', NULL, NULL, 13173, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:01:39', 'admin-1506214529-1506218499495941', 1, 0, '', NULL, NULL, NULL),
(47615, '2017-09-24 14:24:37', NULL, NULL, 13217, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:24:37', 'admin-1506229681-15062342777007555', 1, 0, '', NULL, NULL, NULL),
(47616, '2017-09-24 12:42:19', NULL, NULL, 13202, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:42:19', 'admin-1506223104-1506228139054138', 1, 0, '', NULL, NULL, NULL),
(47617, '2017-09-24 11:17:32', NULL, NULL, 13190, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:17:32', 'admin-1506220539-15062230527743071', 1, 0, '', NULL, NULL, NULL),
(47618, '2017-09-24 14:07:37', NULL, NULL, 13212, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:07:37', 'admin-1506229681-15062332572428934', 1, 0, '', NULL, NULL, NULL),
(47619, '2017-09-24 12:46:42', NULL, NULL, 13203, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:46:42', 'admin-1506223104-1506228402642468', 1, 0, '', NULL, NULL, NULL),
(47620, '2017-09-24 12:45:13', NULL, NULL, 13203, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.10, 0.0000, 0.0000, 12.10, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:45:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47621, '2017-09-24 14:12:26', NULL, NULL, 13214, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:12:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47622, '2017-09-24 13:57:14', NULL, NULL, 13211, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:57:14', 'admin-1506229681-15062326345003462', 1, 0, '', NULL, NULL, NULL),
(47623, '2017-09-24 12:42:19', NULL, NULL, 13202, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:42:19', 'admin-1506223104-1506228139054138', 1, 1, 'SR', NULL, NULL, NULL),
(47624, '2017-09-24 12:42:19', NULL, NULL, 13202, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 3, 12.00, 36.0000, 0.0000, 36.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:42:19', 'admin-1506223104-1506228139054138', 1, 1, 'SR', NULL, NULL, NULL),
(47625, '2017-09-24 12:42:19', NULL, NULL, 13202, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:42:19', 'admin-1506223104-1506228139054138', 1, 0, '', NULL, NULL, NULL),
(47626, '2017-09-24 11:16:37', NULL, NULL, 13191, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:16:37', 'admin-1506220539-15062229972071773', 1, 0, '', NULL, NULL, NULL),
(47627, '2017-09-24 10:56:41', NULL, NULL, 13189, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:56:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47628, '2017-09-24 10:56:56', NULL, NULL, 13189, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:56:56', 'admin-1506220539-15062218158225685', 1, 1, 'SR', NULL, NULL, NULL),
(47629, '2017-09-24 10:56:56', NULL, NULL, 13189, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:56:56', 'admin-1506220539-15062218158225685', 1, 0, '', NULL, NULL, NULL),
(47630, '2017-09-24 11:16:21', NULL, NULL, 13191, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:16:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47631, '2017-09-24 11:43:19', NULL, NULL, 13186, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:43:19', 'admin-1506223104-15062245992275588', 1, 0, '', NULL, NULL, NULL),
(47632, '2017-09-24 11:03:55', NULL, NULL, 13190, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:03:55', 'admin-1506220539-15062222348718744', 1, 1, 'SR', NULL, NULL, NULL),
(47633, '2017-09-24 13:14:38', NULL, NULL, 13206, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.40, 0.0000, 0.0000, 12.40, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:14:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47634, '2017-09-24 00:00:00', NULL, NULL, 13179, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:46:27', 'admin-1506214529-15062175868517060', 1, 0, '', NULL, NULL, NULL),
(47635, '2017-09-24 10:01:39', NULL, NULL, 13173, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:01:39', 'admin-1506214529-1506218499495941', 1, 0, '', NULL, NULL, NULL),
(47636, '2017-09-24 14:12:47', NULL, NULL, 13214, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:12:47', 'admin-1506229681-1506233567320879', 1, 0, '', NULL, NULL, NULL),
(47637, '2017-09-24 10:34:08', NULL, NULL, 13181, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:34:08', 'admin-1506219774-1506220448326618', 1, 0, '', NULL, NULL, NULL),
(47638, '2017-09-24 10:56:31', NULL, NULL, 13188, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:56:31', 'admin-1506220539-15062217908252010', 1, 1, 'SR', NULL, NULL, NULL),
(47639, '2017-09-24 10:30:19', NULL, NULL, 13178, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:30:19', 'admin-1506219774-15062202190836847', 1, 1, 'SR', NULL, NULL, NULL),
(47640, '2017-09-24 10:56:31', NULL, NULL, 13188, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:56:31', 'admin-1506220539-15062217908252010', 1, 0, '', NULL, NULL, NULL),
(47641, '2017-09-24 10:56:31', NULL, NULL, 13188, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:56:31', 'admin-1506220539-15062217908252010', 1, 1, 'SR', NULL, NULL, NULL),
(47642, '2017-09-24 10:56:07', NULL, NULL, 13188, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:56:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47643, '2017-09-24 10:46:02', NULL, NULL, 13187, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:46:02', 'admin-1506220539-1506221162496289', 1, 0, '', NULL, NULL, NULL),
(47644, '2017-09-24 10:46:02', NULL, NULL, 13187, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:46:02', 'admin-1506220539-1506221162496289', 1, 0, '', NULL, NULL, NULL),
(47645, '2017-09-24 10:45:28', NULL, NULL, 13186, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:45:28', 'admin-1506220539-15062211284863999', 1, 1, 'SR', NULL, NULL, NULL),
(47646, '2017-09-24 10:38:19', NULL, NULL, 13184, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:38:19', 'admin-1506220539-15062206997472550', 1, 1, 'SR', NULL, NULL, NULL),
(47647, '2017-09-24 10:45:43', NULL, NULL, 13187, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:45:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47648, '2017-09-24 10:46:02', NULL, NULL, 13187, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:46:02', 'admin-1506220539-1506221162496289', 1, 0, '', NULL, NULL, NULL),
(47649, '2017-09-24 10:36:59', NULL, NULL, 13182, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:36:59', 'admin-1506220539-15062206189604134', 1, 0, '', NULL, NULL, NULL),
(47650, '2017-09-24 14:18:20', NULL, NULL, 13216, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:18:20', 'admin-1506229681-15062339004652170', 1, 0, '', NULL, NULL, NULL),
(47651, '2017-09-24 11:20:32', NULL, NULL, 13193, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:20:32', 'admin-1506223104-15062232318952833', 1, 0, '', NULL, NULL, NULL),
(47652, '2017-09-24 10:45:28', NULL, NULL, 13186, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:45:28', 'admin-1506220539-15062211284863999', 1, 1, 'SR', NULL, NULL, NULL),
(47653, '2017-09-24 10:41:34', NULL, NULL, 13185, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:41:34', 'admin-1506220539-15062208945196616', 1, 0, '', NULL, NULL, NULL),
(47654, '2017-09-24 10:41:34', NULL, NULL, 13185, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:41:34', 'admin-1506220539-15062208945196616', 1, 0, '', NULL, NULL, NULL),
(47655, '2017-09-24 10:40:50', NULL, NULL, 13185, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.30, 0.0000, 0.0000, 11.30, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:40:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47656, '2017-09-24 10:41:34', NULL, NULL, 13185, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:41:34', 'admin-1506220539-15062208945196616', 1, 0, '', NULL, NULL, NULL),
(47657, '2017-09-24 10:41:34', NULL, NULL, 13185, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:41:34', 'admin-1506220539-15062208945196616', 1, 0, '', NULL, NULL, NULL),
(47658, '2017-09-24 10:38:19', NULL, NULL, 13184, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:38:20', 'admin-1506220539-15062206997472550', 1, 1, 'SR', NULL, NULL, NULL),
(47659, '2017-09-24 09:33:21', NULL, NULL, 13165, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:33:21', 'admin-1506214529-15062168016435058', 1, 0, '', NULL, NULL, '10.0'),
(47660, '2017-09-24 09:33:21', NULL, NULL, 13165, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:33:21', 'admin-1506214529-15062168016435058', 1, 1, 'SR', NULL, NULL, '10.0'),
(47661, '2017-09-24 09:33:21', NULL, NULL, 13165, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:33:21', 'admin-1506214529-15062168016435058', 1, 1, 'SR', NULL, NULL, '10.0'),
(47662, '2017-09-24 10:01:39', NULL, NULL, 13173, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:01:39', 'admin-1506214529-1506218499495941', 1, 1, 'SR', NULL, NULL, NULL),
(47663, '2017-09-24 10:37:25', NULL, NULL, 13183, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:37:25', 'admin-1506220539-15062206449655285', 1, 0, '', NULL, NULL, NULL),
(47664, '2017-09-24 10:37:25', NULL, NULL, 13183, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:37:25', 'admin-1506220539-15062206449655285', 1, 0, '', NULL, NULL, NULL),
(47665, '2017-09-24 10:37:08', NULL, NULL, 13183, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:37:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47666, '2017-09-24 10:36:59', NULL, NULL, 13182, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:36:59', 'admin-1506220539-15062206189604134', 1, 0, '', NULL, NULL, NULL),
(47667, '2017-09-24 10:16:53', NULL, NULL, 13176, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.75, 0.0000, 0.0000, 8.75, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:16:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47668, '2017-09-24 10:17:24', NULL, NULL, 13176, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:17:24', 'admin-1506214529-15062194442018279', 1, 0, '', NULL, NULL, NULL),
(47669, '2017-09-24 10:17:24', NULL, NULL, 13176, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:17:24', 'admin-1506214529-15062194442018279', 1, 0, '', NULL, NULL, NULL),
(47670, '2017-09-24 10:01:39', NULL, NULL, 13173, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:01:39', 'admin-1506214529-1506218499495941', 1, 0, '', NULL, NULL, NULL),
(47671, '2017-09-24 10:34:08', NULL, NULL, 13181, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:34:08', 'admin-1506219774-1506220448326618', 1, 1, 'SR', NULL, NULL, NULL),
(47672, '2017-09-24 10:34:08', NULL, NULL, 13181, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:34:08', 'admin-1506219774-1506220448326618', 1, 0, '', NULL, NULL, NULL),
(47673, '2017-09-24 10:30:09', NULL, NULL, 13178, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:30:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47674, '2017-09-24 10:30:19', NULL, NULL, 13178, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:30:19', 'admin-1506219774-15062202190836847', 1, 1, 'SR', NULL, NULL, NULL),
(47675, '2017-09-24 13:20:51', NULL, NULL, 13207, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:20:51', 'admin-1506229681-15062304515883425', 1, 0, '', NULL, NULL, NULL),
(47676, '2017-09-24 09:26:25', NULL, NULL, 13161, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:26:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47677, '2017-09-24 09:27:11', NULL, NULL, 13161, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:27:11', 'admin-1506214529-15062164313708177', 1, 0, '', NULL, NULL, NULL),
(47678, '2017-09-24 09:27:11', NULL, NULL, 13161, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:27:11', 'admin-1506214529-15062164313708177', 1, 0, '', NULL, NULL, NULL),
(47679, '2017-09-24 09:27:19', NULL, NULL, 13161, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:27:19', 'admin-1506214529-15062164392744894', 1, 1, 'SR', NULL, NULL, NULL),
(47680, '2017-09-24 09:27:19', NULL, NULL, 13161, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:27:19', 'admin-1506214529-15062164392744894', 1, 1, 'SR', NULL, NULL, NULL),
(47681, '2017-09-24 09:28:08', NULL, NULL, 13162, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:28:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47682, '2017-09-24 09:28:20', NULL, NULL, 13162, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:28:20', 'admin-1506214529-1506216500138291', 1, 0, '', NULL, NULL, NULL),
(47683, '2017-09-24 09:28:20', NULL, NULL, 13162, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:28:20', 'admin-1506214529-1506216500138291', 1, 0, '', NULL, NULL, NULL),
(47684, '2017-09-24 10:11:17', NULL, NULL, 13162, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:11:17', 'admin-1506214529-15062190773713144', 1, 1, 'SR', NULL, NULL, NULL),
(47685, '2017-09-24 09:28:42', NULL, NULL, 13162, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:28:42', 'admin-1506214529-15062165220767786', 1, 1, 'SR', NULL, NULL, NULL),
(47686, '2017-09-24 09:48:50', NULL, NULL, 13170, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:48:50', 'admin-1506214529-1506217730196417', 1, 1, 'SR', NULL, NULL, NULL),
(47687, '2017-09-24 09:48:50', NULL, NULL, 13170, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:48:50', 'admin-1506214529-1506217730196417', 1, 0, '', NULL, NULL, NULL),
(47688, '2017-09-24 10:17:24', NULL, NULL, 13176, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:17:24', 'admin-1506214529-15062194442018279', 1, 1, 'SR', NULL, NULL, NULL),
(47689, '2017-09-24 10:17:24', NULL, NULL, 13176, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:17:24', 'admin-1506214529-15062194442018279', 1, 1, 'SR', NULL, NULL, NULL),
(47690, '2017-09-24 09:41:36', NULL, NULL, 13167, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:41:36', 'admin-1506214529-150621729590755', 1, 1, 'SR', NULL, NULL, NULL),
(47691, '2017-09-24 10:17:24', NULL, NULL, 13176, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:17:24', 'admin-1506214529-15062194442018279', 1, 0, '', NULL, NULL, NULL),
(47692, '2017-09-24 10:01:57', NULL, NULL, 13174, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:01:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47693, '2017-09-24 10:02:10', NULL, NULL, 13174, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:02:10', 'admin-1506214529-15062185306082160', 1, 0, '', NULL, NULL, NULL),
(47694, '2017-09-24 10:02:10', NULL, NULL, 13174, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:02:10', 'admin-1506214529-15062185306082160', 1, 1, 'SR', NULL, NULL, NULL),
(47695, '2017-09-24 10:08:26', NULL, NULL, 13175, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:08:26', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(47696, '2017-09-24 10:08:39', NULL, NULL, 13175, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:08:39', 'admin-1506214529-1506218919653937', 1, 0, '', NULL, NULL, '10.0'),
(47697, '2017-09-24 14:12:47', NULL, NULL, 13214, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 14:12:47', 'admin-1506229681-1506233567320879', 1, 1, 'SR', NULL, NULL, NULL),
(47698, '2017-09-24 10:08:39', NULL, NULL, 13175, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:08:39', 'admin-1506214529-1506218919653937', 1, 1, 'SR', NULL, NULL, '10.0'),
(47699, '2017-09-24 10:09:32', NULL, NULL, 13175, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:09:32', 'admin-1506214529-1506218972568146', 1, 0, '', NULL, NULL, '10.0'),
(47700, '2017-09-24 10:01:39', NULL, NULL, 13173, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:01:39', 'admin-1506214529-1506218499495941', 1, 0, '', NULL, NULL, NULL),
(47701, '2017-09-24 10:01:39', NULL, NULL, 13173, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:01:39', 'admin-1506214529-1506218499495941', 1, 1, 'SR', NULL, NULL, NULL),
(47702, '2017-09-24 10:01:39', NULL, NULL, 13173, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:01:39', 'admin-1506214529-1506218499495941', 1, 0, '', NULL, NULL, NULL),
(47703, '2017-09-24 10:01:39', NULL, NULL, 13173, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:01:39', 'admin-1506214529-1506218499495941', 1, 0, '', NULL, NULL, NULL),
(47704, '2017-09-24 12:41:50', NULL, NULL, 13202, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:41:50', 'admin-1506223104-15062281106968587', 1, 1, 'SR', NULL, NULL, NULL),
(47705, '2017-09-24 10:01:39', NULL, NULL, 13173, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:01:39', 'admin-1506214529-1506218499495941', 1, 0, '', NULL, NULL, NULL),
(47706, '2017-09-24 00:00:00', NULL, NULL, 13172, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:58:39', 'admin-1506214529-15062183194116118', 1, 1, 'SR', NULL, NULL, NULL),
(47707, '2017-09-24 09:42:26', NULL, NULL, 13168, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:42:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47708, '2017-09-24 11:46:07', NULL, NULL, 13196, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:46:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47709, '2017-09-24 09:15:56', NULL, NULL, 13160, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:15:56', 'admin-1506214529-15062157566531187', 1, 1, 'SR', NULL, NULL, NULL),
(47710, '2017-09-24 12:46:42', NULL, NULL, 13203, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 12:46:42', 'admin-1506223104-1506228402642468', 1, 0, '', NULL, NULL, NULL),
(47711, '2017-09-24 10:17:24', NULL, NULL, 13176, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:17:24', 'admin-1506214529-15062194442018279', 1, 1, 'SR', NULL, NULL, NULL),
(47712, '2017-09-24 00:00:00', NULL, NULL, 13172, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:12:28', 'admin-1506214529-15062155481894283', 1, 1, 'SR', NULL, NULL, NULL),
(47713, '2017-09-24 00:00:00', NULL, NULL, 13171, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:12:28', 'admin-1506214529-15062155481894283', 1, 0, '', NULL, NULL, NULL),
(47714, '2017-09-24 00:00:00', NULL, NULL, 13171, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:58:39', 'admin-1506214529-15062183194116118', 1, 1, 'SR', NULL, NULL, NULL),
(47715, '2017-09-24 09:43:47', NULL, NULL, 13168, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:43:47', 'admin-1506214529-15062174272022918', 1, 1, 'SR', NULL, NULL, NULL),
(47716, '2017-09-24 09:43:47', NULL, NULL, 13168, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:43:47', 'admin-1506214529-15062174272022918', 1, 1, 'SR', NULL, NULL, NULL),
(47717, '2017-09-24 09:43:47', NULL, NULL, 13168, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:43:47', 'admin-1506214529-15062174272022918', 1, 1, 'SR', NULL, NULL, NULL),
(47718, '2017-09-24 09:43:47', NULL, NULL, 13168, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:43:47', 'admin-1506214529-15062174272022918', 1, 1, 'SR', NULL, NULL, NULL),
(47719, '2017-09-24 11:20:32', NULL, NULL, 13193, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 11:20:32', 'admin-1506223104-15062232318952833', 1, 1, 'SR', NULL, NULL, NULL),
(47720, '2017-09-24 00:00:00', NULL, NULL, 13180, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:46:27', 'admin-1506214529-15062175868517060', 1, 0, '', NULL, NULL, NULL),
(47721, '2017-09-24 09:48:39', NULL, NULL, 13170, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:48:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47722, '2017-09-24 09:42:40', NULL, NULL, 13168, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:42:40', 'admin-1506214529-1506217359972273', 1, 0, '', NULL, NULL, NULL),
(47723, '2017-09-24 09:42:40', NULL, NULL, 13168, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:42:40', 'admin-1506214529-1506217359972273', 1, 0, '', NULL, NULL, NULL),
(47724, '2017-09-24 10:30:48', NULL, NULL, 13179, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:30:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47725, '2017-09-24 00:00:00', NULL, NULL, 13180, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, NULL, NULL, 2.90, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:45:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47726, '2017-09-24 10:33:55', NULL, NULL, 13181, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:33:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47727, '2017-09-24 00:00:00', NULL, NULL, 13180, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:46:27', 'admin-1506214529-15062175868517060', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(47728, '2017-09-24 09:33:21', NULL, NULL, 13165, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:33:21', 'admin-1506214529-15062168016435058', 1, 0, '', NULL, NULL, '10.0'),
(47729, '2017-09-24 09:33:02', NULL, NULL, 13165, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:33:02', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(47730, '2017-09-24 09:32:41', NULL, NULL, 13164, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:32:41', 'admin-1506214529-15062167616589615', 1, 1, 'SR', NULL, NULL, NULL),
(47731, '2017-09-24 09:32:41', NULL, NULL, 13164, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:32:41', 'admin-1506214529-15062167616589615', 1, 1, 'SR', NULL, NULL, NULL),
(47732, '2017-09-24 09:32:41', NULL, NULL, 13164, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:32:41', 'admin-1506214529-15062167616589615', 1, 1, 'SR', NULL, NULL, NULL),
(47733, '2017-09-24 09:32:30', NULL, NULL, 13164, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:32:30', 'admin-1506214529-15062167501095777', 1, 0, '', NULL, NULL, NULL),
(47734, '2017-09-24 09:32:30', NULL, NULL, 13164, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:32:30', 'admin-1506214529-15062167501095777', 1, 0, '', NULL, NULL, NULL),
(47735, '2017-09-24 09:32:30', NULL, NULL, 13164, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:32:30', 'admin-1506214529-15062167501095777', 1, 0, '', NULL, NULL, NULL),
(47736, '2017-09-24 09:32:30', NULL, NULL, 13164, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:32:30', 'admin-1506214529-15062167501095777', 1, 0, '', NULL, NULL, NULL),
(47737, '2017-09-24 09:32:17', NULL, NULL, 13164, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.60, 0.0000, 0.0000, 13.60, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:32:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47738, '2017-09-24 09:31:24', NULL, NULL, 13163, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:31:24', 'admin-1506214529-15062166842935247', 1, 0, '', NULL, NULL, NULL),
(47739, '2017-09-24 09:31:11', NULL, NULL, 13163, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:31:11', 'admin-1506214529-15062166711077973', 1, 1, 'SR', NULL, NULL, NULL),
(47740, '2017-09-24 09:30:12', NULL, NULL, 13163, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:30:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47741, '2017-09-24 09:31:11', NULL, NULL, 13163, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:31:11', 'admin-1506214529-15062166711077973', 1, 0, '', NULL, NULL, NULL),
(47742, '2017-09-24 13:07:54', NULL, NULL, 13205, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 13:07:54', 'admin-1506223104-15062296741464550', 1, 1, 'SR', NULL, NULL, NULL),
(47743, '2017-09-24 09:15:56', NULL, NULL, 13160, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:15:56', 'admin-1506214529-15062157566531187', 1, 0, '', NULL, NULL, NULL),
(47744, '2017-09-24 09:15:56', NULL, NULL, 13160, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:15:56', 'admin-1506214529-15062157566531187', 1, 1, 'SR', NULL, NULL, NULL),
(47745, '2017-09-24 09:15:41', NULL, NULL, 13160, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:15:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47746, '2017-09-24 00:00:00', NULL, NULL, 13172, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, NULL, NULL, 2.90, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:12:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47747, '2017-09-24 00:00:00', NULL, NULL, 13172, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:12:28', 'admin-1506214529-15062155481894283', 1, 0, '', NULL, NULL, NULL),
(47748, '2017-09-24 09:08:36', NULL, NULL, 13158, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:08:36', 'admin-1506214529-15062153163763390', 1, 0, '', NULL, NULL, NULL),
(47749, '2017-09-24 09:58:51', NULL, NULL, 13171, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:58:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47750, '2017-09-24 10:00:25', NULL, NULL, 13164, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506229681', 'admin', '2017-09-24 10:00:25', 'admin-1506214529-15062184257938147', 1, 0, '', NULL, NULL, NULL),
(47751, '2017-09-24 09:08:32', NULL, NULL, 13158, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1506229681', 'admin', '2017-09-24 09:08:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47752, '2017-09-25 16:23:05', NULL, NULL, 13237, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 16:23:05', 'admin-1506314121-15063277856126369', 1, 1, 'SR', NULL, NULL, NULL),
(47753, '2017-09-25 16:37:52', NULL, NULL, 13246, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1506314121', 'admin', '2017-09-25 16:37:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47754, '2017-09-25 16:37:57', NULL, NULL, 13246, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 16:37:57', 'admin-1506314121-15063286772778039', 1, 1, 'SR', NULL, NULL, NULL),
(47755, '2017-09-25 17:02:20', NULL, NULL, 13244, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 17:02:20', 'admin-1506314121-15063301400991697', 1, 1, 'SR', NULL, NULL, NULL),
(47756, '2017-09-25 14:33:01', NULL, NULL, 13241, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 14:33:01', 'admin-1506314121-15063211809897568', 1, 0, '', NULL, NULL, NULL),
(47757, '2017-09-25 14:33:01', NULL, NULL, 13241, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 14:33:01', 'admin-1506314121-15063211809897568', 1, 1, 'SR', NULL, NULL, NULL),
(47758, '2017-09-25 14:35:35', NULL, NULL, 13242, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1506314121', 'admin', '2017-09-25 14:35:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47759, '2017-09-25 14:35:51', NULL, NULL, 13242, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 14:35:51', 'admin-1506314121-15063213517615912', 1, 0, '', NULL, NULL, NULL),
(47760, '2017-09-25 14:35:52', NULL, NULL, 13242, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 14:35:52', 'admin-1506314121-15063213517615912', 1, 0, '', NULL, NULL, NULL),
(47761, '2017-09-25 10:32:30', NULL, NULL, 13230, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 10:32:30', 'admin-1506301454-15063067498357218', 1, 0, '', NULL, NULL, '10.0'),
(47762, '2017-09-25 10:50:51', NULL, NULL, 13231, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1506314121', 'admin', '2017-09-25 10:50:51', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(47763, '2017-09-25 10:50:56', NULL, NULL, 13231, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 10:50:56', 'admin-1506301454-1506307856331475', 1, 0, '', NULL, NULL, '10.0'),
(47764, '2017-09-25 14:02:40', NULL, NULL, 13237, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 14:02:40', 'admin-1506314121-15063193601551953', 1, 1, 'SR', NULL, NULL, NULL),
(47765, '2017-09-25 14:48:58', NULL, NULL, 13239, 0, 182, '117', 'Open Drinks ', 'addtional ice', 'Cold Drinks', 'Fresh Juice', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 14:48:58', 'admin-1506314121-15063221380644120', 1, 0, '', NULL, NULL, NULL),
(47766, '2017-09-25 13:57:32', NULL, NULL, 13239, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 13:57:32', 'admin-1506314121-15063190519592017', 1, 1, 'SR', NULL, NULL, NULL),
(47767, '2017-09-25 14:25:46', NULL, NULL, 13238, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 14:25:46', 'admin-1506314121-15063207459712662', 1, 0, '', NULL, NULL, NULL),
(47768, '2017-09-25 15:08:16', NULL, NULL, 13243, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1506314121', 'admin', '2017-09-25 15:08:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47769, '2017-09-25 15:08:22', NULL, NULL, 13243, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 15:08:22', 'admin-1506314121-15063233024288246', 1, 1, 'SR', NULL, NULL, NULL),
(47770, '2017-09-25 15:08:22', NULL, NULL, 13243, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 15:08:22', 'admin-1506314121-15063233024288246', 1, 1, 'SR', NULL, NULL, NULL),
(47771, '2017-09-25 15:08:38', NULL, NULL, 13244, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1506314121', 'admin', '2017-09-25 15:08:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47772, '2017-09-25 15:08:41', NULL, NULL, 13244, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 15:08:41', 'admin-1506314121-15063233208843960', 1, 0, '', NULL, NULL, NULL),
(47773, '2017-09-25 15:42:38', NULL, NULL, 13243, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 15:42:38', 'admin-1506314121-1506325358785764', 1, 0, '', NULL, NULL, NULL),
(47774, '2017-09-25 15:42:40', NULL, NULL, 13245, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1506314121', 'admin', '2017-09-25 15:42:40', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(47775, '2017-09-25 12:18:35', NULL, NULL, 13233, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 12:18:35', 'admin-1506301454-15063131158105721', 1, 1, 'SR', NULL, NULL, NULL),
(47776, '2017-09-25 12:34:53', NULL, NULL, 13234, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1506314121', 'admin', '2017-09-25 12:34:53', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(47777, '2017-09-25 14:32:39', NULL, NULL, 13241, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1506314121', 'admin', '2017-09-25 14:32:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47778, '2017-09-25 10:51:24', NULL, NULL, 13231, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 10:51:24', 'admin-1506301454-15063078843127716', 1, 1, 'SR', NULL, NULL, '10.0'),
(47779, '2017-09-25 10:51:24', NULL, NULL, 13231, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 10:51:24', 'admin-1506301454-15063078843127716', 1, 1, 'SR', NULL, NULL, '10.0'),
(47780, '2017-09-25 12:12:14', NULL, NULL, 13232, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1506314121', 'admin', '2017-09-25 12:12:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47781, '2017-09-25 12:12:20', NULL, NULL, 13232, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 12:12:20', 'admin-1506301454-15063127402072225', 1, 1, 'SR', NULL, NULL, NULL),
(47782, '2017-09-25 14:35:52', NULL, NULL, 13242, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 14:35:52', 'admin-1506314121-15063213517615912', 1, 0, '', NULL, NULL, NULL),
(47783, '2017-09-25 14:35:52', NULL, NULL, 13242, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 14:35:52', 'admin-1506314121-15063213517615912', 1, 1, 'SR', NULL, NULL, NULL),
(47784, '2017-09-25 13:46:16', NULL, NULL, 13238, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 13:46:16', 'admin-1506314121-1506318376234164', 1, 1, 'SR', NULL, NULL, NULL),
(47785, '2017-09-25 13:46:04', NULL, NULL, 13238, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 13:46:04', 'admin-1506314121-15063183646428971', 1, 0, '', NULL, NULL, NULL),
(47786, '2017-09-25 13:46:04', NULL, NULL, 13238, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 13:46:04', 'admin-1506314121-15063183646428971', 1, 0, '', NULL, NULL, NULL),
(47787, '2017-09-25 13:46:16', NULL, NULL, 13238, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 13:46:16', 'admin-1506314121-1506318376234164', 1, 0, '', NULL, NULL, NULL),
(47788, '2017-09-25 13:46:04', NULL, NULL, 13238, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 13:46:04', 'admin-1506314121-15063183646428971', 1, 0, '', NULL, NULL, NULL),
(47789, '2017-09-25 12:35:03', NULL, NULL, 13234, 0, 73, '73', 'Marmite Chicken ', 'Pasta', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 12:35:03', 'admin-1506301454-1506314102900953', 1, 1, 'SR', NULL, NULL, '10.0'),
(47790, '2017-09-25 12:35:14', NULL, NULL, 13234, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 12:35:14', 'admin-1506301454-15063141128009767', 1, 1, 'SR', NULL, NULL, '10.0'),
(47791, '2017-09-25 12:46:19', NULL, NULL, 13235, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1506314121', 'admin', '2017-09-25 12:46:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47792, '2017-09-25 12:46:30', NULL, NULL, 13235, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 12:46:30', 'admin-1506314121-15063147905823121', 1, 0, '', NULL, NULL, NULL),
(47793, '2017-09-25 12:46:30', NULL, NULL, 13235, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 12:46:30', 'admin-1506314121-15063147905823121', 1, 0, '', NULL, NULL, NULL),
(47794, '2017-09-25 12:46:30', NULL, NULL, 13235, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 12:46:30', 'admin-1506314121-15063147905823121', 1, 0, '', NULL, NULL, NULL),
(47795, '2017-09-25 16:06:52', NULL, NULL, 13244, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 16:06:52', 'admin-1506314121-1506326812266670', 1, 0, '', NULL, NULL, NULL),
(47796, '2017-09-25 13:57:32', NULL, NULL, 13239, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 13:57:32', 'admin-1506314121-15063190519592017', 1, 0, '', NULL, NULL, NULL),
(47797, '2017-09-25 10:19:37', NULL, NULL, 13229, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1506314121', 'admin', '2017-09-25 10:19:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47798, '2017-09-25 10:20:40', NULL, NULL, 13229, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 10:20:40', 'admin-1506301454-15063060406177971', 1, 0, '', NULL, NULL, NULL),
(47799, '2017-09-25 10:20:40', NULL, NULL, 13229, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 10:20:40', 'admin-1506301454-15063060406177971', 1, 0, '', NULL, NULL, NULL),
(47800, '2017-09-25 10:20:40', NULL, NULL, 13229, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 10:20:40', 'admin-1506301454-15063060406177971', 1, 1, 'SR', NULL, NULL, NULL),
(47801, '2017-09-25 10:20:40', NULL, NULL, 13229, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 10:20:40', 'admin-1506301454-15063060406177971', 1, 1, 'SR', NULL, NULL, NULL),
(47802, '2017-09-25 10:27:46', NULL, NULL, 13230, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1506314121', 'admin', '2017-09-25 10:27:46', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(47803, '2017-09-25 10:28:09', NULL, NULL, 13230, 0, 181, '116', 'Open Food ', 'half boiled egg toast', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 10:28:09', 'admin-1506301454-15063064892542141', 1, 0, '', NULL, NULL, '10.0'),
(47804, '2017-09-25 10:32:30', NULL, NULL, 13230, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 10:32:30', 'admin-1506301454-15063067498357218', 1, 1, 'SR', NULL, NULL, '10.0'),
(47805, '2017-09-25 10:32:30', NULL, NULL, 13230, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 10:32:30', 'admin-1506301454-15063067498357218', 1, 1, 'SR', NULL, NULL, '10.0'),
(47806, '2017-09-25 10:32:30', NULL, NULL, 13230, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 10:32:30', 'admin-1506301454-15063067498357218', 1, 0, '', NULL, NULL, '10.0'),
(47807, '2017-09-25 14:00:25', NULL, NULL, 13240, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1506314121', 'admin', '2017-09-25 14:00:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47808, '2017-09-25 14:00:33', NULL, NULL, 13240, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 14:00:33', 'admin-1506314121-15063192335624425', 1, 0, '', NULL, NULL, NULL),
(47809, '2017-09-25 14:00:33', NULL, NULL, 13240, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 14:00:33', 'admin-1506314121-15063192335624425', 1, 1, 'SR', NULL, NULL, NULL),
(47810, '2017-09-25 14:00:33', NULL, NULL, 13240, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 14:00:33', 'admin-1506314121-15063192335624425', 1, 1, 'SR', NULL, NULL, NULL),
(47811, '2017-09-25 10:50:56', NULL, NULL, 13231, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 10:50:56', 'admin-1506301454-1506307856331475', 1, 0, '', NULL, NULL, '10.0'),
(47812, '2017-09-25 16:23:05', NULL, NULL, 13237, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 16:23:05', 'admin-1506314121-15063277856126369', 1, 1, 'SR', NULL, NULL, NULL),
(47813, '2017-09-25 15:42:43', NULL, NULL, 13245, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 15:42:43', 'admin-1506314121-15063253635907550', 1, 1, 'SR', NULL, NULL, '10.0'),
(47814, '2017-09-25 14:41:04', NULL, NULL, 13238, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 14:41:04', 'admin-1506314121-15063216637999560', 1, 0, '', NULL, NULL, NULL),
(47815, '2017-09-25 14:32:47', NULL, NULL, 13241, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 14:32:47', 'admin-1506314121-15063211672183848', 1, 0, '', NULL, NULL, NULL),
(47816, '2017-09-25 09:50:32', NULL, NULL, 13227, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 09:50:32', 'admin-1506301454-15063042324583011', 1, 0, '', NULL, NULL, NULL),
(47817, '2017-09-25 09:06:06', NULL, NULL, 13224, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 09:06:06', 'admin-1506301454-15063015659827126', 1, 1, 'SR', NULL, NULL, '10.0'),
(47818, '2017-09-25 09:26:17', NULL, NULL, 13225, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1506314121', 'admin', '2017-09-25 09:26:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47819, '2017-09-25 09:26:19', NULL, NULL, 13225, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 09:26:19', 'admin-1506301454-15063027793981199', 1, 1, 'SR', NULL, NULL, NULL),
(47820, '2017-09-25 09:33:20', NULL, NULL, 13226, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1506314121', 'admin', '2017-09-25 09:33:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47821, '2017-09-25 09:33:26', NULL, NULL, 13226, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 09:33:26', 'admin-1506301454-15063032058858275', 1, 0, '', NULL, NULL, NULL),
(47822, '2017-09-25 09:33:26', NULL, NULL, 13226, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 09:33:26', 'admin-1506301454-15063032058858275', 1, 1, 'SR', NULL, NULL, NULL),
(47823, '2017-09-25 09:49:49', NULL, NULL, 13227, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1506314121', 'admin', '2017-09-25 09:49:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47824, '2017-09-25 09:50:32', NULL, NULL, 13227, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 09:50:32', 'admin-1506301454-15063042324583011', 1, 0, '', NULL, NULL, NULL),
(47825, '2017-09-25 14:02:40', NULL, NULL, 13237, 0, 73, '73', 'Marmite Chicken ', 'half rice', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 14:02:40', 'admin-1506314121-15063193601551953', 1, 1, 'SR', NULL, NULL, NULL),
(47826, '2017-09-25 13:57:32', NULL, NULL, 13239, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 13:57:32', 'admin-1506314121-15063190519592017', 1, 0, '', NULL, NULL, NULL),
(47827, '2017-09-25 13:57:32', NULL, NULL, 13239, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 13:57:32', 'admin-1506314121-15063190519592017', 1, 0, '', NULL, NULL, NULL),
(47828, '2017-09-25 13:57:32', NULL, NULL, 13239, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 13:57:32', 'admin-1506314121-15063190519592017', 1, 0, '', NULL, NULL, NULL),
(47829, '2017-09-25 13:57:32', NULL, NULL, 13239, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 13:57:32', 'admin-1506314121-15063190519592017', 1, 0, '', NULL, NULL, NULL),
(47830, '2017-09-25 13:57:20', NULL, NULL, 13239, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.60, 0.0000, 0.0000, 10.60, 1, '27', 1, '1506314121', 'admin', '2017-09-25 13:57:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47831, '2017-09-25 13:42:50', NULL, NULL, 13238, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1506314121', 'admin', '2017-09-25 13:42:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47832, '2017-09-25 13:40:44', NULL, NULL, 13237, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 13:40:44', 'admin-1506314121-15063180444008122', 1, 1, 'SR', NULL, NULL, NULL),
(47833, '2017-09-25 13:40:44', NULL, NULL, 13237, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 13:40:44', 'admin-1506314121-15063180444008122', 1, 1, 'SR', NULL, NULL, NULL),
(47834, '2017-09-25 13:40:39', NULL, NULL, 13237, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1506314121', 'admin', '2017-09-25 13:40:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47835, '2017-09-25 13:34:17', NULL, NULL, 13234, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 13:34:17', 'admin-1506314121-15063176575683641', 1, 1, 'SR', NULL, NULL, '10.0'),
(47836, '2017-09-25 13:32:05', NULL, NULL, 13236, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 13:32:05', 'admin-1506314121-15063175253429072', 1, 1, 'SR', NULL, NULL, NULL),
(47837, '2017-09-25 13:32:05', NULL, NULL, 13236, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 13:32:05', 'admin-1506314121-15063175253429072', 1, 0, '', NULL, NULL, NULL),
(47838, '2017-09-25 13:31:59', NULL, NULL, 13236, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1506314121', 'admin', '2017-09-25 13:31:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47839, '2017-09-25 12:52:16', NULL, NULL, 13234, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 12:52:16', 'admin-1506314121-15063151361324472', 1, 1, 'SR', NULL, NULL, '10.0'),
(47840, '2017-09-25 12:50:01', NULL, NULL, 13235, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 12:50:01', 'admin-1506314121-15063150012007840', 1, 1, 'SR', NULL, NULL, NULL),
(47841, '2017-09-25 12:18:35', NULL, NULL, 13233, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 12:18:35', 'admin-1506301454-15063131158105721', 1, 0, '', NULL, NULL, NULL),
(47842, '2017-09-25 12:18:28', NULL, NULL, 13233, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 12:18:28', 'admin-1506301454-1506313108312911', 1, 0, '', NULL, NULL, NULL),
(47843, '2017-09-25 12:18:28', NULL, NULL, 13233, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 12:18:28', 'admin-1506301454-1506313108312911', 1, 0, '', NULL, NULL, NULL),
(47844, '2017-09-25 12:14:18', NULL, NULL, 13233, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1506314121', 'admin', '2017-09-25 12:14:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47845, '2017-09-25 12:18:28', NULL, NULL, 13233, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 12:18:28', 'admin-1506301454-1506313108312911', 1, 0, '', NULL, NULL, NULL),
(47846, '2017-09-25 09:06:02', NULL, NULL, 13224, 0, 156, '90', 'House Cheddar Omelet', 'no toast', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 09:06:02', 'admin-1506301454-15063015620744686', 1, 0, '', NULL, NULL, '10.0'),
(47847, '2017-09-25 10:10:20', NULL, NULL, 13228, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 10:10:21', 'admin-1506301454-15063054208128860', 1, 1, 'SR', NULL, NULL, NULL),
(47848, '2017-09-25 10:10:20', NULL, NULL, 13228, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 10:10:20', 'admin-1506301454-15063054208128860', 1, 0, '', NULL, NULL, NULL),
(47849, '2017-09-25 10:10:20', NULL, NULL, 13228, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 10:10:20', 'admin-1506301454-15063054208128860', 1, 0, '', NULL, NULL, NULL),
(47850, '2017-09-25 10:10:11', NULL, NULL, 13228, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1506314121', 'admin', '2017-09-25 10:10:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47851, '2017-09-25 09:50:38', NULL, NULL, 13227, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 09:50:38', 'admin-1506301454-15063042383344899', 1, 1, 'SR', NULL, NULL, NULL),
(47852, '2017-09-25 09:50:32', NULL, NULL, 13227, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 09:50:32', 'admin-1506301454-15063042324583011', 1, 1, 'SR', NULL, NULL, NULL),
(47853, '2017-09-25 09:05:50', NULL, NULL, 13224, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1506314121', 'admin', '2017-09-25 09:05:50', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(47854, '2017-09-27 16:53:20', NULL, NULL, 13263, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 16:53:20', 'admin-1506489928-15065024007784540', 1, 1, 'SR', NULL, NULL, NULL),
(47855, '2017-09-27 14:56:40', NULL, NULL, 13260, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 14:56:40', 'admin-1506489928-15064954005326536', 1, 1, 'SR', NULL, NULL, NULL),
(47856, '2017-09-27 13:38:59', NULL, NULL, 13257, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1506489928', 'admin', '2017-09-27 13:38:59', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(47857, '2017-09-27 00:00:00', NULL, NULL, 13259, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 13:25:38', 'admin-1506489928-15064899379944829', 1, 1, 'SR', NULL, NULL, NULL),
(47858, '2017-09-27 10:07:54', NULL, NULL, 13247, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 10:07:54', 'admin-1506475268-15064780741682234', 1, 1, 'SR', NULL, NULL, NULL),
(47859, '2017-09-27 10:43:01', NULL, NULL, 13248, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1506489928', 'admin', '2017-09-27 10:43:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47860, '2017-09-27 10:43:07', NULL, NULL, 13248, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 10:43:07', 'admin-1506475268-15064801869044542', 1, 1, 'SR', NULL, NULL, NULL),
(47861, '2017-09-27 15:10:59', NULL, NULL, 13261, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1506489928', 'admin', '2017-09-27 15:10:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47862, '2017-09-27 14:56:40', NULL, NULL, 13260, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 14:56:40', 'admin-1506489928-15064954005326536', 1, 0, '', NULL, NULL, NULL),
(47863, '2017-09-27 14:56:40', NULL, NULL, 13260, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 14:56:40', 'admin-1506489928-15064954005326536', 1, 0, '', NULL, NULL, NULL),
(47864, '2017-09-27 14:10:44', NULL, NULL, 13258, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1506489928', 'admin', '2017-09-27 14:10:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47865, '2017-09-27 11:12:17', NULL, NULL, 13249, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 11:12:17', 'admin-1506475268-15064819374559581', 1, 1, 'SR', NULL, NULL, NULL),
(47866, '2017-09-27 11:15:21', NULL, NULL, 13247, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 11:15:21', 'admin-1506475268-15064821213085648', 1, 1, 'SR', NULL, NULL, NULL),
(47867, '2017-09-27 11:15:21', NULL, NULL, 13247, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 11:15:21', 'admin-1506475268-15064821213085648', 1, 1, 'SR', NULL, NULL, NULL),
(47868, '2017-09-27 11:29:04', NULL, NULL, 13250, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1506489928', 'admin', '2017-09-27 11:29:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47869, '2017-09-27 11:29:09', NULL, NULL, 13250, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 11:29:09', 'admin-1506475268-15064829495404824', 1, 0, '', NULL, NULL, NULL),
(47870, '2017-09-27 11:29:19', NULL, NULL, 13250, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 11:29:19', 'admin-1506475268-15064829589101463', 1, 0, '', NULL, NULL, NULL),
(47871, '2017-09-27 11:29:19', NULL, NULL, 13250, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 11:29:19', 'admin-1506475268-15064829589101463', 1, 0, '', NULL, NULL, NULL),
(47872, '2017-09-27 11:44:32', NULL, NULL, 13251, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1506489928', 'admin', '2017-09-27 11:44:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47873, '2017-09-27 11:44:35', NULL, NULL, 13251, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 11:44:35', 'admin-1506475268-1506483875661246', 1, 1, 'SR', NULL, NULL, NULL),
(47874, '2017-09-27 12:34:17', NULL, NULL, 13253, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1506489928', 'admin', '2017-09-27 12:34:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47875, '2017-09-27 14:56:40', NULL, NULL, 13260, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 14:56:40', 'admin-1506489928-15064954005326536', 1, 0, '', NULL, NULL, NULL),
(47876, '2017-09-27 16:53:20', NULL, NULL, 13263, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 2, 14.00, 28.0000, 0.0000, 28.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 16:53:20', 'admin-1506489928-15065024007784540', 1, 1, 'SR', NULL, NULL, NULL),
(47877, '2017-09-27 16:53:20', NULL, NULL, 13263, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 16:53:20', 'admin-1506489928-15065024007784540', 1, 0, '', NULL, NULL, NULL),
(47878, '2017-09-27 16:53:10', NULL, NULL, 13263, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 16:53:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47879, '2017-09-27 15:18:20', NULL, NULL, 13262, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 15:18:20', 'admin-1506489928-15064967008097592', 1, 0, '', NULL, NULL, NULL),
(47880, '2017-09-27 15:16:03', NULL, NULL, 13262, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 15:16:03', 'admin-1506489928-15064965636493673', 1, 1, 'SR', NULL, NULL, NULL),
(47881, '2017-09-27 15:16:03', NULL, NULL, 13262, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 15:16:03', 'admin-1506489928-15064965636493673', 1, 1, 'SR', NULL, NULL, NULL),
(47882, '2017-09-27 15:16:00', NULL, NULL, 13262, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1506489928', 'admin', '2017-09-27 15:16:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47883, '2017-09-27 15:11:02', NULL, NULL, 13261, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 15:11:02', 'admin-1506489928-15064962618647327', 1, 1, 'SR', NULL, NULL, NULL),
(47884, '2017-09-27 15:11:02', NULL, NULL, 13261, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 15:11:02', 'admin-1506489928-15064962618647327', 1, 0, '', NULL, NULL, NULL),
(47885, '2017-09-27 14:10:55', NULL, NULL, 13258, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', 'Takeaway', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 14:10:55', 'admin-1506489928-15064926554978113', 1, 0, '', NULL, NULL, NULL),
(47886, '2017-09-27 14:10:55', NULL, NULL, 13258, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', 'Takeaway', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 14:10:55', 'admin-1506489928-15064926554978113', 1, 0, '', NULL, NULL, NULL),
(47887, '2017-09-27 13:39:20', NULL, NULL, 13257, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 13:39:20', 'admin-1506489928-1506490759863793', 1, 0, '', NULL, NULL, '10.0'),
(47888, '2017-09-27 13:39:20', NULL, NULL, 13257, 0, 192, '127', 'Flaming Hot & Spicy Pork', 'add rice', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 13:39:20', 'admin-1506489928-1506490759863793', 1, 0, '', NULL, NULL, '10.0'),
(47889, '2017-09-27 00:00:00', NULL, NULL, 13259, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 13:25:21', 'admin-1506475268-15064899213687853', 1, 0, '', NULL, NULL, NULL),
(47890, '2017-09-27 14:19:25', NULL, NULL, 13259, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1506489928', 'admin', '2017-09-27 14:19:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47891, '2017-09-27 14:56:08', NULL, NULL, 13260, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1506489928', 'admin', '2017-09-27 14:56:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47892, '2017-09-27 14:31:12', NULL, NULL, 13257, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 14:31:12', 'admin-1506489928-15064938721533892', 1, 1, 'SR', NULL, NULL, '10.0'),
(47893, '2017-09-27 12:52:08', NULL, NULL, 13255, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 12:52:08', 'admin-1506475268-15064879286459997', 1, 1, 'SR', NULL, NULL, NULL),
(47894, '2017-09-27 12:52:00', NULL, NULL, 13255, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1506489928', 'admin', '2017-09-27 12:52:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47895, '2017-09-27 12:40:09', NULL, NULL, 13254, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1506489928', 'admin', '2017-09-27 12:40:09', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(47896, '2017-09-27 12:40:18', NULL, NULL, 13254, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 12:40:18', 'admin-1506475268-15064872184269424', 1, 1, 'SR', NULL, NULL, '10.0'),
(47897, '2017-09-27 12:41:12', NULL, NULL, 13254, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 12:41:12', 'admin-1506475268-15064872722319340', 1, 0, '', NULL, NULL, '10.0'),
(47898, '2017-09-27 12:43:28', NULL, NULL, 13254, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 12:43:28', 'admin-1506475268-15064874086284277', 1, 1, 'SR', NULL, NULL, '10.0'),
(47899, '2017-09-27 12:43:38', NULL, NULL, 13254, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 12:43:38', 'admin-1506475268-15064874183638592', 1, 0, '', NULL, NULL, '10.0'),
(47900, '2017-09-27 12:34:35', NULL, NULL, 13253, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 12:34:35', 'admin-1506475268-15064868751137818', 1, 0, '', NULL, NULL, NULL),
(47901, '2017-09-27 12:34:35', NULL, NULL, 13253, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 12:34:35', 'admin-1506475268-15064868751137818', 1, 1, 'SR', NULL, NULL, NULL),
(47902, '2017-09-27 12:49:01', NULL, NULL, 13254, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 12:49:01', 'admin-1506475268-15064877408621760', 1, 1, 'SR', NULL, NULL, '10.0'),
(47903, '2017-09-27 12:34:35', NULL, NULL, 13253, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 12:34:35', 'admin-1506475268-15064868751137818', 1, 0, '', NULL, NULL, NULL),
(47904, '2017-09-27 11:12:12', NULL, NULL, 13249, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1506489928', 'admin', '2017-09-27 11:12:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47905, '2017-09-27 11:12:17', NULL, NULL, 13249, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 11:12:17', 'admin-1506475268-15064819374559581', 1, 0, '', NULL, NULL, NULL),
(47906, '2017-09-27 10:07:39', NULL, NULL, 13247, 0, 181, '116', 'Open Food ', 'junior blt', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 10:07:39', 'admin-1506475268-15064780590854784', 1, 0, '', NULL, NULL, NULL),
(47907, '2017-09-27 09:41:51', NULL, NULL, 13247, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 09:41:51', 'admin-1506475268-1506476510868179', 1, 1, 'SR', NULL, NULL, NULL),
(47908, '2017-09-27 09:41:56', NULL, NULL, 13247, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1506489928', 'admin', '2017-09-27 09:41:56', 'admin-1506475268-15064765164112025', 1, 1, 'SR', NULL, NULL, NULL),
(47909, '2017-09-27 09:39:59', NULL, NULL, 13247, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1506489928', 'admin', '2017-09-27 09:39:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47910, '2017-09-28 13:43:40', NULL, NULL, 13279, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 13:43:40', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(47911, '2017-09-28 13:43:46', NULL, NULL, 13279, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 13:43:46', 'admin-1506562404-1506577426195939', 1, 1, 'SR', NULL, NULL, '10.0'),
(47912, '2017-09-28 13:56:00', NULL, NULL, 13280, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1506562404', 'admin', '2017-09-28 13:56:00', '0', 1, 1, 'SR', NULL, NULL, '10.0');
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(47913, '2017-09-28 12:32:30', NULL, NULL, 13276, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 12:32:30', 'admin-1506562404-15065731507776743', 1, 1, 'SR', NULL, NULL, '10.0'),
(47914, '2017-09-28 12:41:42', NULL, NULL, 13277, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1506562404', 'admin', '2017-09-28 12:41:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47915, '2017-09-28 12:41:46', NULL, NULL, 13277, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 12:41:46', 'admin-1506562404-1506573706641682', 1, 1, 'SR', NULL, NULL, NULL),
(47916, '2017-09-28 12:44:28', NULL, NULL, 13277, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 12:44:28', 'admin-1506562404-15065738686929590', 1, 1, 'SR', NULL, NULL, NULL),
(47917, '2017-09-28 12:44:28', NULL, NULL, 13277, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 12:44:28', 'admin-1506562404-15065738686929590', 1, 1, 'SR', NULL, NULL, NULL),
(47918, '2017-09-28 15:25:41', NULL, NULL, 13282, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1506562404', 'admin', '2017-09-28 15:25:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47919, '2017-09-28 15:25:46', NULL, NULL, 13282, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 15:25:46', 'admin-1506562404-15065835459407172', 1, 1, 'SR', NULL, NULL, NULL),
(47920, '2017-09-28 15:25:46', NULL, NULL, 13282, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 15:25:46', 'admin-1506562404-15065835459407172', 1, 1, 'SR', NULL, NULL, NULL),
(47921, '2017-09-28 12:26:23', NULL, NULL, 13276, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 12:26:23', 'admin-1506562404-15065727836135554', 1, 0, '', NULL, NULL, '10.0'),
(47922, '2017-09-28 12:26:23', NULL, NULL, 13276, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 12:26:23', 'admin-1506562404-15065727836135554', 1, 1, 'SR', NULL, NULL, '10.0'),
(47923, '2017-09-28 14:35:38', NULL, NULL, 13281, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 14:35:38', 'admin-1506562404-15065805383274623', 1, 0, '', 1, NULL, '10.0'),
(47924, '2017-09-28 13:56:12', NULL, NULL, 13280, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 13:56:12', 'admin-1506562404-15065781723081217', 1, 1, 'SR', NULL, NULL, '10.0'),
(47925, '2017-09-28 13:56:12', NULL, NULL, 13280, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 13:56:12', 'admin-1506562404-15065781723081217', 1, 1, 'SR', NULL, NULL, '10.0'),
(47926, '2017-09-28 00:00:00', NULL, NULL, 13286, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, NULL, NULL, 2.10, 1, '27', 1, '1506562404', 'admin', '2017-09-28 15:25:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47927, '2017-09-28 12:26:14', NULL, NULL, 13276, 0, 160, '94', 'Signature Dumpling (5 Pcs)', 'Takeaway', 'Meals', 'Snacks ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 12:26:14', 'admin-1506562404-1506572774296625', 1, 0, '', NULL, NULL, '10.0'),
(47928, '2017-09-28 12:26:14', NULL, NULL, 13276, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 12:26:14', 'admin-1506562404-1506572774296625', 1, 0, '', NULL, NULL, '10.0'),
(47929, '2017-09-28 12:26:07', NULL, NULL, 13276, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1506562404', 'admin', '2017-09-28 12:26:07', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(47930, '2017-09-28 10:50:56', NULL, NULL, 13270, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1506562404', 'admin', '2017-09-28 10:50:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47931, '2017-09-28 10:04:02', NULL, NULL, 13268, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1506562404', 'admin', '2017-09-28 10:04:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47932, '2017-09-28 09:44:29', NULL, NULL, 13267, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1506562404', 'admin', '2017-09-28 09:44:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47933, '2017-09-28 00:00:00', NULL, NULL, 13286, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 15:25:54', 'admin-1506562404-15065835545654536', 1, 0, '', NULL, NULL, NULL),
(47934, '2017-09-28 00:00:00', NULL, NULL, 13285, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 15:25:54', 'admin-1506562404-15065835545654536', 1, 1, 'SR', NULL, NULL, NULL),
(47935, '2017-09-28 16:07:53', NULL, NULL, 13284, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 16:07:53', 'admin-1506562404-15065860728603856', 1, 1, 'SR', 1, NULL, NULL),
(47936, '2017-09-28 16:07:53', NULL, NULL, 13284, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 16:07:53', 'admin-1506562404-15065860728603856', 1, 1, 'SR', 1, NULL, NULL),
(47937, '2017-09-28 16:07:53', NULL, NULL, 13284, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 16:07:53', 'admin-1506562404-15065860728603856', 1, 1, 'SR', 1, NULL, NULL),
(47938, '2017-09-28 16:16:59', NULL, NULL, 13285, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1506562404', 'admin', '2017-09-28 16:16:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47939, '2017-09-28 11:24:05', NULL, NULL, 13273, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1506562404', 'admin', '2017-09-28 11:24:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47940, '2017-09-28 11:24:22', NULL, NULL, 13273, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 11:24:22', 'admin-1506562404-1506569061832874', 1, 0, '', NULL, NULL, NULL),
(47941, '2017-09-28 11:24:33', NULL, NULL, 13273, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 11:24:33', 'admin-1506562404-15065690728674394', 1, 1, 'SR', NULL, NULL, NULL),
(47942, '2017-09-28 11:33:06', NULL, NULL, 13274, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1506562404', 'admin', '2017-09-28 11:33:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47943, '2017-09-28 11:33:12', NULL, NULL, 13274, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 11:33:12', 'admin-1506562404-15065695924741020', 1, 0, '', NULL, NULL, NULL),
(47944, '2017-09-28 11:33:12', NULL, NULL, 13274, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 11:33:12', 'admin-1506562404-15065695924741020', 1, 1, 'SR', NULL, NULL, NULL),
(47945, '2017-09-28 12:21:43', NULL, NULL, 13275, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1506562404', 'admin', '2017-09-28 12:21:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47946, '2017-09-28 12:21:50', NULL, NULL, 13275, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 12:21:50', 'admin-1506562404-15065725104444341', 1, 0, '', NULL, NULL, NULL),
(47947, '2017-09-28 09:32:47', NULL, NULL, 13265, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1506562404', 'admin', '2017-09-28 09:32:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47948, '2017-09-28 09:33:35', NULL, NULL, 13265, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 09:33:35', 'admin-1506562404-1506562415591439', 1, 1, 'SR', NULL, NULL, NULL),
(47949, '2017-09-28 13:56:12', NULL, NULL, 13280, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 13:56:12', 'admin-1506562404-15065781723081217', 1, 0, '', NULL, NULL, '10.0'),
(47950, '2017-09-28 13:56:12', NULL, NULL, 13280, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 13:56:12', 'admin-1506562404-15065781723081217', 1, 0, '', NULL, NULL, '10.0'),
(47951, '2017-09-28 10:04:09', NULL, NULL, 13268, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 10:04:09', 'admin-1506562404-150656424887159', 1, 1, 'SR', NULL, NULL, NULL),
(47952, '2017-09-28 12:54:30', NULL, NULL, 13278, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 12:54:30', 'admin-1506562404-150657447065849', 1, 0, '', NULL, NULL, NULL),
(47953, '2017-09-28 12:54:24', NULL, NULL, 13278, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1506562404', 'admin', '2017-09-28 12:54:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47954, '2017-09-28 12:44:28', NULL, NULL, 13277, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 12:44:28', 'admin-1506562404-15065738686929590', 1, 1, 'SR', NULL, NULL, NULL),
(47955, '2017-09-28 11:03:04', NULL, NULL, 13272, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 11:03:04', 'admin-1506562404-15065677841329437', 1, 1, 'SR', NULL, NULL, NULL),
(47956, '2017-09-28 11:03:04', NULL, NULL, 13272, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 11:03:04', 'admin-1506562404-15065677841329437', 1, 1, 'SR', NULL, NULL, NULL),
(47957, '2017-09-28 11:03:04', NULL, NULL, 13272, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 11:03:04', 'admin-1506562404-15065677841329437', 1, 1, 'SR', NULL, NULL, NULL),
(47958, '2017-09-28 10:23:51', NULL, NULL, 13269, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 10:23:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47959, '2017-09-28 10:24:06', NULL, NULL, 13269, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 10:24:06', 'admin-1506562404-15065654462054713', 1, 0, '', NULL, NULL, NULL),
(47960, '2017-09-28 10:24:06', NULL, NULL, 13269, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 10:24:06', 'admin-1506562404-15065654462054713', 1, 0, '', NULL, NULL, NULL),
(47961, '2017-09-28 10:24:06', NULL, NULL, 13269, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 10:24:06', 'admin-1506562404-15065654462054713', 1, 0, '', NULL, NULL, NULL),
(47962, '2017-09-28 11:01:30', NULL, NULL, 13271, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 11:01:30', 'admin-1506562404-1506567690144997', 1, 1, 'SR', NULL, NULL, NULL),
(47963, '2017-09-28 11:02:50', NULL, NULL, 13272, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1506562404', 'admin', '2017-09-28 11:02:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47964, '2017-09-28 11:03:04', NULL, NULL, 13272, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 11:03:04', 'admin-1506562404-15065677841329437', 1, 1, 'SR', NULL, NULL, NULL),
(47965, '2017-09-28 11:03:04', NULL, NULL, 13272, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 11:03:04', 'admin-1506562404-15065677841329437', 1, 1, 'SR', NULL, NULL, NULL),
(47966, '2017-09-28 11:01:30', NULL, NULL, 13271, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 11:01:30', 'admin-1506562404-1506567690144997', 1, 0, '', NULL, NULL, NULL),
(47967, '2017-09-28 11:01:30', NULL, NULL, 13271, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 11:01:30', 'admin-1506562404-1506567690144997', 1, 0, '', NULL, NULL, NULL),
(47968, '2017-09-28 11:01:30', NULL, NULL, 13271, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 11:01:30', 'admin-1506562404-1506567690144997', 1, 1, 'SR', NULL, NULL, NULL),
(47969, '2017-09-28 10:58:42', NULL, NULL, 13271, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1506562404', 'admin', '2017-09-28 10:58:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47970, '2017-09-28 10:50:59', NULL, NULL, 13270, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 10:50:59', 'admin-1506562404-15065670588805791', 1, 1, 'SR', NULL, NULL, NULL),
(47971, '2017-09-28 10:31:07', NULL, NULL, 13268, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 10:31:07', 'admin-1506562404-15065658675231044', 1, 1, 'SR', NULL, NULL, NULL),
(47972, '2017-09-28 10:24:06', NULL, NULL, 13269, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 10:24:06', 'admin-1506562404-15065654462054713', 1, 1, 'SR', NULL, NULL, NULL),
(47973, '2017-09-28 10:24:06', NULL, NULL, 13269, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 10:24:06', 'admin-1506562404-15065654462054713', 1, 1, 'SR', NULL, NULL, NULL),
(47974, '2017-09-28 10:04:09', NULL, NULL, 13268, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 10:04:09', 'admin-1506562404-150656424887159', 1, 0, '', NULL, NULL, NULL),
(47975, '2017-09-28 10:04:09', NULL, NULL, 13268, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 10:04:09', 'admin-1506562404-150656424887159', 1, 0, '', NULL, NULL, NULL),
(47976, '2017-09-28 09:44:45', NULL, NULL, 13267, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 09:44:45', 'admin-1506562404-15065630849959597', 1, 1, 'SR', NULL, NULL, NULL),
(47977, '2017-09-28 09:44:45', NULL, NULL, 13267, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 09:44:45', 'admin-1506562404-15065630849959597', 1, 1, 'SR', NULL, NULL, NULL),
(47978, '2017-09-28 09:44:36', NULL, NULL, 13267, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 09:44:36', 'admin-1506562404-15065630765825292', 1, 0, '', NULL, NULL, NULL),
(47979, '2017-09-28 09:44:36', NULL, NULL, 13267, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 09:44:36', 'admin-1506562404-15065630765825292', 1, 0, '', NULL, NULL, NULL),
(47980, '2017-09-28 09:33:48', NULL, NULL, 13265, 0, 181, '116', 'Open Food ', 'eggs', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 09:33:48', 'admin-1506562404-15065624285351558', 1, 0, '', NULL, NULL, NULL),
(47981, '2017-09-28 09:39:10', NULL, NULL, 13266, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 09:39:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47982, '2017-09-28 09:39:17', NULL, NULL, 13266, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 09:39:17', 'admin-1506562404-15065627577456186', 1, 1, 'SR', NULL, NULL, NULL),
(47983, '2017-09-28 12:21:50', NULL, NULL, 13275, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 12:21:50', 'admin-1506562404-15065725104444341', 1, 1, 'SR', NULL, NULL, NULL),
(47984, '2017-09-28 09:39:17', NULL, NULL, 13266, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 2, 15.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 09:39:17', 'admin-1506562404-15065627577456186', 1, 0, '', NULL, NULL, NULL),
(47985, '2017-09-28 09:16:13', NULL, NULL, 13264, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 09:16:13', 'admin-1506561336-15065613730757418', 1, 1, 'SR', NULL, NULL, NULL),
(47986, '2017-09-28 09:33:35', NULL, NULL, 13265, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 09:33:35', 'admin-1506562404-1506562415591439', 1, 0, '', NULL, NULL, NULL),
(47987, '2017-09-28 09:16:06', NULL, NULL, 13264, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 09:16:06', 'admin-1506561336-15065613667908833', 1, 1, 'SR', NULL, NULL, NULL),
(47988, '2017-09-28 09:15:58', NULL, NULL, 13264, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 09:15:58', 'admin-1506561336-15065613582721819', 1, 0, '', NULL, NULL, NULL),
(47989, '2017-09-28 09:16:06', NULL, NULL, 13264, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 09:16:06', 'admin-1506561336-15065613667908833', 1, 1, 'SR', NULL, NULL, NULL),
(47990, '2017-09-28 09:15:58', NULL, NULL, 13264, 0, 154, '88', 'Daily Dose BLT', 'add sausage', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506562404', 'admin', '2017-09-28 09:15:58', 'admin-1506561336-15065613582721819', 1, 0, '', NULL, NULL, NULL),
(47991, '2017-09-28 09:15:44', NULL, NULL, 13264, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1506562404', 'admin', '2017-09-28 09:15:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47992, '2017-09-29 13:08:46', NULL, NULL, 13302, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:08:46', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(47993, '2017-09-29 13:12:32', NULL, NULL, 13302, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:12:32', 'admin-1506658325-1506661951770802', 1, 1, 'SR', NULL, NULL, '10.0'),
(47994, '2017-09-29 14:26:48', NULL, NULL, 13306, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1506664852', 'admin', '2017-09-29 14:26:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47995, '2017-09-29 14:35:26', NULL, NULL, 13307, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 14:35:26', 'admin-1506664852-15066669263778517', 1, 1, 'SR', NULL, NULL, '10.0'),
(47996, '2017-09-29 14:36:30', NULL, NULL, 13307, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 14:36:30', 'admin-1506664852-15066669902425369', 1, 1, 'SR', NULL, NULL, '10.0'),
(47997, '2017-09-29 14:36:30', NULL, NULL, 13307, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 14:36:30', 'admin-1506664852-15066669902425369', 1, 1, 'SR', NULL, NULL, '10.0'),
(47998, '2017-09-29 14:41:54', NULL, NULL, 13308, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1506664852', 'admin', '2017-09-29 14:41:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(47999, '2017-09-29 14:42:06', NULL, NULL, 13308, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 14:42:06', 'admin-1506664852-15066673263818544', 1, 1, 'SR', NULL, NULL, NULL),
(48000, '2017-09-29 14:42:06', NULL, NULL, 13308, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 14:42:06', 'admin-1506664852-15066673263818544', 1, 0, '', NULL, NULL, NULL),
(48001, '2017-09-29 14:42:06', NULL, NULL, 13308, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 14:42:06', 'admin-1506664852-15066673263818544', 1, 1, 'SR', NULL, NULL, NULL),
(48002, '2017-09-29 14:42:06', NULL, NULL, 13308, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 14:42:06', 'admin-1506664852-15066673263818544', 1, 1, 'SR', NULL, NULL, NULL),
(48003, '2017-09-29 14:26:53', NULL, NULL, 13306, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 14:26:53', 'admin-1506664852-1506666413208506', 1, 1, 'SR', NULL, NULL, NULL),
(48004, '2017-09-29 14:29:49', NULL, NULL, 13307, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1506664852', 'admin', '2017-09-29 14:29:49', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48005, '2017-09-29 17:32:45', NULL, NULL, 13312, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 17:32:45', 'admin-1506664852-1506677565750670', 1, 1, 'SR', NULL, NULL, NULL),
(48006, '2017-09-29 10:04:28', NULL, NULL, 13290, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 10:04:28', 'admin-1506647044-15066506681852768', 1, 1, 'SR', NULL, NULL, NULL),
(48007, '2017-09-29 16:31:39', NULL, NULL, 13310, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1506664852', 'admin', '2017-09-29 16:31:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48008, '2017-09-29 16:33:23', NULL, NULL, 13310, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 16:33:23', 'admin-1506664852-15066740030362449', 1, 0, '', NULL, NULL, NULL),
(48009, '2017-09-29 16:33:23', NULL, NULL, 13310, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 16:33:23', 'admin-1506664852-15066740030362449', 1, 1, 'SR', NULL, NULL, NULL),
(48010, '2017-09-29 17:30:58', NULL, NULL, 13311, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 17:30:58', 'admin-1506664852-15066774584606981', 1, 0, '', 1, NULL, NULL),
(48011, '2017-09-29 17:30:58', NULL, NULL, 13311, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 17:30:58', 'admin-1506664852-15066774584606981', 1, 0, '', 1, NULL, NULL),
(48012, '2017-09-29 17:30:58', NULL, NULL, 13311, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 17:30:58', 'admin-1506664852-15066774584606981', 1, 0, '', 1, NULL, NULL),
(48013, '2017-09-29 17:32:42', NULL, NULL, 13312, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1506664852', 'admin', '2017-09-29 17:32:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48014, '2017-09-29 17:32:45', NULL, NULL, 13312, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 17:32:45', 'admin-1506664852-1506677565750670', 1, 0, '', NULL, NULL, NULL),
(48015, '2017-09-29 14:30:05', NULL, NULL, 13307, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 14:30:05', 'admin-1506664852-15066666054195411', 1, 0, '', NULL, NULL, '10.0'),
(48016, '2017-09-29 14:30:05', NULL, NULL, 13307, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 14:30:05', 'admin-1506664852-15066666054195411', 1, 0, '', NULL, NULL, '10.0'),
(48017, '2017-09-29 13:40:20', NULL, NULL, 13303, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:40:20', 'admin-1506658325-15066636200403885', 1, 1, 'SR', NULL, NULL, NULL),
(48018, '2017-09-29 13:40:20', NULL, NULL, 13303, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:40:20', 'admin-1506658325-15066636200403885', 1, 0, '', NULL, NULL, NULL),
(48019, '2017-09-29 13:40:20', NULL, NULL, 13303, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:40:20', 'admin-1506658325-15066636200403885', 1, 1, 'SR', NULL, NULL, NULL),
(48020, '2017-09-29 15:48:30', NULL, NULL, 13309, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 15:48:30', 'admin-1506664852-15066713108045194', 1, 0, '', NULL, NULL, NULL),
(48021, '2017-09-29 15:48:30', NULL, NULL, 13309, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 15:48:30', 'admin-1506664852-15066713108045194', 1, 0, '', NULL, NULL, NULL),
(48022, '2017-09-29 13:55:24', NULL, NULL, 13305, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:55:24', 'admin-1506658325-15066645242561848', 1, 1, 'SR', NULL, NULL, NULL),
(48023, '2017-09-29 13:55:15', NULL, NULL, 13305, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:55:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48024, '2017-09-29 13:55:24', NULL, NULL, 13305, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:55:24', 'admin-1506658325-15066645242561848', 1, 0, '', NULL, NULL, NULL),
(48025, '2017-09-29 15:48:28', NULL, NULL, 13309, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1506664852', 'admin', '2017-09-29 15:48:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48026, '2017-09-29 14:45:59', NULL, NULL, 13300, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 14:45:59', 'admin-1506664852-15066675594384781', 1, 1, 'SR', NULL, NULL, NULL),
(48027, '2017-09-29 11:04:54', NULL, NULL, 13292, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 11:04:54', 'admin-1506647044-15066542942525661', 1, 0, '', NULL, NULL, NULL),
(48028, '2017-09-29 13:54:52', NULL, NULL, 13304, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:54:52', 'admin-1506658325-15066644921465330', 1, 1, 'SR', NULL, NULL, NULL),
(48029, '2017-09-29 13:49:52', NULL, NULL, 13304, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:49:52', 'admin-1506658325-1506664192125794', 1, 0, '', NULL, NULL, NULL),
(48030, '2017-09-29 13:49:52', NULL, NULL, 13304, 0, 73, '73', 'Marmite Chicken ', 'change to pasta', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:49:52', 'admin-1506658325-1506664192125794', 1, 1, 'SR', NULL, NULL, NULL),
(48031, '2017-09-29 13:49:33', NULL, NULL, 13304, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:49:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48032, '2017-09-29 13:16:08', NULL, NULL, 13299, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:16:08', 'admin-1506658325-15066621686055273', 1, 0, '', NULL, NULL, NULL),
(48033, '2017-09-29 12:19:58', NULL, NULL, 13300, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1506664852', 'admin', '2017-09-29 12:19:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48034, '2017-09-29 13:40:20', NULL, NULL, 13303, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:40:20', 'admin-1506658325-15066636200403885', 1, 0, '', NULL, NULL, NULL),
(48035, '2017-09-29 13:40:07', NULL, NULL, 13303, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:40:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48036, '2017-09-29 12:09:33', NULL, NULL, 13295, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1506664852', 'admin', '2017-09-29 12:09:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48037, '2017-09-29 11:27:11', NULL, NULL, 13294, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 11:27:11', 'admin-1506647044-15066556313769334', 1, 0, '', NULL, NULL, NULL),
(48038, '2017-09-29 11:27:19', NULL, NULL, 13294, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 11:27:19', 'admin-1506647044-15066556395207224', 1, 1, 'SR', NULL, NULL, NULL),
(48039, '2017-09-29 11:27:19', NULL, NULL, 13294, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 11:27:19', 'admin-1506647044-15066556395207224', 1, 1, 'SR', NULL, NULL, NULL),
(48040, '2017-09-29 12:10:18', NULL, NULL, 13295, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 12:10:18', 'admin-1506647044-15066582182798361', 1, 0, '', NULL, NULL, NULL),
(48041, '2017-09-29 10:03:35', NULL, NULL, 13289, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 10:03:35', 'admin-1506647044-15066506148045364', 1, 1, 'SR', NULL, NULL, NULL),
(48042, '2017-09-29 10:04:13', NULL, NULL, 13290, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1506664852', 'admin', '2017-09-29 10:04:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48043, '2017-09-29 10:04:22', NULL, NULL, 13290, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 10:04:22', 'admin-1506647044-15066506623859021', 1, 0, '', NULL, NULL, NULL),
(48044, '2017-09-29 14:30:21', NULL, NULL, 13307, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 14:30:21', 'admin-1506664852-15066666211143348', 1, 0, '', NULL, NULL, '10.0'),
(48045, '2017-09-29 13:30:53', NULL, NULL, 13302, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:30:53', 'admin-1506658325-15066630536492812', 1, 0, '', NULL, NULL, '10.0'),
(48046, '2017-09-29 13:12:31', NULL, NULL, 13302, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:12:31', 'admin-1506658325-1506661951770802', 1, 0, '', NULL, NULL, '10.0'),
(48047, '2017-09-29 13:08:52', NULL, NULL, 13302, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:08:52', 'admin-1506658325-1506661732671746', 1, 0, '', NULL, NULL, '10.0'),
(48048, '2017-09-29 13:15:00', NULL, NULL, 13299, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:15:00', 'admin-1506658325-1506662100391209', 1, 0, '', NULL, NULL, NULL),
(48049, '2017-09-29 11:15:47', NULL, NULL, 13293, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 11:15:47', 'admin-1506647044-15066549477496987', 1, 0, '', NULL, NULL, '10.0'),
(48050, '2017-09-29 13:08:40', NULL, NULL, 13301, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:08:40', 'admin-1506658325-15066617201349264', 1, 1, 'SR', NULL, NULL, NULL),
(48051, '2017-09-29 13:08:40', NULL, NULL, 13301, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:08:40', 'admin-1506658325-15066617201349264', 1, 1, 'SR', NULL, NULL, NULL),
(48052, '2017-09-29 13:07:01', NULL, NULL, 13301, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.80, 0.0000, 0.0000, 9.80, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:07:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48053, '2017-09-29 13:08:17', NULL, NULL, 13301, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:08:17', 'admin-1506658325-15066616977957013', 1, 1, 'SR', NULL, NULL, NULL),
(48054, '2017-09-29 13:08:17', NULL, NULL, 13301, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:08:17', 'admin-1506658325-15066616977957013', 1, 0, '', NULL, NULL, NULL),
(48055, '2017-09-29 13:08:17', NULL, NULL, 13301, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:08:17', 'admin-1506658325-15066616977957013', 1, 0, '', NULL, NULL, NULL),
(48056, '2017-09-29 13:08:17', NULL, NULL, 13301, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:08:17', 'admin-1506658325-15066616977957013', 1, 0, '', NULL, NULL, NULL),
(48057, '2017-09-29 13:08:40', NULL, NULL, 13301, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 13:08:40', 'admin-1506658325-15066617201349264', 1, 1, 'SR', NULL, NULL, NULL),
(48058, '2017-09-29 12:30:35', NULL, NULL, 13293, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 12:30:35', 'admin-1506658325-15066594357595439', 1, 1, 'SR', NULL, NULL, '10.0'),
(48059, '2017-09-29 12:30:35', NULL, NULL, 13293, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 12:30:35', 'admin-1506658325-15066594357595439', 1, 0, '', NULL, NULL, '10.0'),
(48060, '2017-09-29 12:20:01', NULL, NULL, 13300, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 12:20:01', 'admin-1506658325-1506658801048173', 1, 1, 'SR', NULL, NULL, NULL),
(48061, '2017-09-29 12:12:17', NULL, NULL, 13298, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 12:12:17', 'admin-1506658325-15066583371261878', 1, 1, 'SR', NULL, NULL, NULL),
(48062, '2017-09-29 12:12:17', NULL, NULL, 13298, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 12:12:17', 'admin-1506658325-15066583371261878', 1, 1, 'SR', NULL, NULL, NULL),
(48063, '2017-09-29 12:15:30', NULL, NULL, 13299, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 12:15:30', 'admin-1506658325-15066585298273537', 1, 1, 'SR', NULL, NULL, NULL),
(48064, '2017-09-29 12:15:26', NULL, NULL, 13299, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1506664852', 'admin', '2017-09-29 12:15:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48065, '2017-09-29 12:12:10', NULL, NULL, 13298, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 12:12:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48066, '2017-09-29 12:12:45', NULL, NULL, 13295, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 12:12:45', 'admin-1506658325-15066583654726164', 1, 1, 'SR', NULL, NULL, NULL),
(48067, '2017-09-29 11:22:45', NULL, NULL, 13294, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1506664852', 'admin', '2017-09-29 11:22:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48068, '2017-09-29 11:27:11', NULL, NULL, 13294, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 11:27:11', 'admin-1506647044-15066556313769334', 1, 0, '', NULL, NULL, NULL),
(48069, '2017-09-29 10:19:29', NULL, NULL, 13288, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 10:19:29', 'admin-1506647044-15066515694235238', 1, 0, '', NULL, NULL, NULL),
(48070, '2017-09-29 11:15:47', NULL, NULL, 13293, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 11:15:47', 'admin-1506647044-15066549477496987', 1, 0, '', NULL, NULL, '10.0'),
(48071, '2017-09-29 11:15:53', NULL, NULL, 13293, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 11:15:53', 'admin-1506647044-15066549537406165', 1, 1, 'SR', NULL, NULL, '10.0'),
(48072, '2017-09-29 11:04:54', NULL, NULL, 13292, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 11:04:54', 'admin-1506647044-15066542942525661', 1, 1, 'SR', NULL, NULL, NULL),
(48073, '2017-09-29 11:15:39', NULL, NULL, 13293, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1506664852', 'admin', '2017-09-29 11:15:39', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48074, '2017-09-29 11:04:48', NULL, NULL, 13292, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1506664852', 'admin', '2017-09-29 11:04:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48075, '2017-09-29 11:02:48', NULL, NULL, 13291, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 11:02:48', 'admin-1506647044-15066541678164576', 1, 0, '', NULL, NULL, NULL),
(48076, '2017-09-29 11:02:48', NULL, NULL, 13291, 0, 153, '87', 'Wake Me Up!', 'No vege', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 11:02:48', 'admin-1506647044-15066541678164576', 1, 0, '', NULL, NULL, NULL),
(48077, '2017-09-29 11:01:50', NULL, NULL, 13291, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1506664852', 'admin', '2017-09-29 11:01:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48078, '2017-09-29 11:02:48', NULL, NULL, 13291, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 11:02:48', 'admin-1506647044-15066541678164576', 1, 0, '', NULL, NULL, NULL),
(48079, '2017-09-29 10:03:26', NULL, NULL, 13289, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 10:03:26', 'admin-1506647044-15066506060705111', 1, 0, '', NULL, NULL, NULL),
(48080, '2017-09-29 10:03:34', NULL, NULL, 13289, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 10:03:34', 'admin-1506647044-15066506148045364', 1, 1, 'SR', NULL, NULL, NULL),
(48081, '2017-09-29 10:04:22', NULL, NULL, 13290, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 10:04:22', 'admin-1506647044-15066506623859021', 1, 0, '', NULL, NULL, NULL),
(48082, '2017-09-29 10:04:28', NULL, NULL, 13290, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 10:04:28', 'admin-1506647044-15066506681852768', 1, 1, 'SR', NULL, NULL, NULL),
(48083, '2017-09-29 10:03:26', NULL, NULL, 13289, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 10:03:26', 'admin-1506647044-15066506060705111', 1, 0, '', NULL, NULL, NULL),
(48084, '2017-09-29 10:02:43', NULL, NULL, 13289, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1506664852', 'admin', '2017-09-29 10:02:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48085, '2017-09-29 09:33:36', NULL, NULL, 13288, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 09:33:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48086, '2017-09-29 09:33:42', NULL, NULL, 13288, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 09:33:42', 'admin-1506647044-15066488218739452', 1, 1, 'SR', NULL, NULL, NULL),
(48087, '2017-09-29 09:27:21', NULL, NULL, 13287, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 09:27:21', 'admin-1506647044-15066484413711797', 1, 0, '', NULL, NULL, NULL),
(48088, '2017-09-29 09:27:26', NULL, NULL, 13287, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506664852', 'admin', '2017-09-29 09:27:26', 'admin-1506647044-1506648446403353', 1, 1, 'SR', NULL, NULL, NULL),
(48089, '2017-09-29 09:27:15', NULL, NULL, 13287, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1506664852', 'admin', '2017-09-29 09:27:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48090, '2017-09-30 13:18:18', NULL, NULL, 13336, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 13:18:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48091, '2017-09-30 13:19:02', NULL, NULL, 13336, 0, 181, '116', 'Open Food ', 'mushroom french toast', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 13:19:02', 'sanni-1506743997-1506748742259416', 1, 0, '', NULL, NULL, NULL),
(48092, '2017-09-30 13:19:02', NULL, NULL, 13336, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 13:19:02', 'sanni-1506743997-1506748742259416', 1, 0, '', NULL, NULL, NULL),
(48093, '2017-09-30 13:19:02', NULL, NULL, 13336, 0, 181, '116', 'Open Food ', 'Panfried Dumpling', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 13:19:02', 'sanni-1506743997-1506748742259416', 1, 0, '', NULL, NULL, NULL),
(48094, '2017-09-30 13:48:34', NULL, NULL, 13337, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.20, 0.0000, 0.0000, 10.20, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 13:48:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48095, '2017-09-30 13:49:42', NULL, NULL, 13337, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 13:49:42', 'sanni-1506743997-1506750582128664', 1, 1, 'SR', NULL, NULL, NULL),
(48096, '2017-09-30 13:49:42', NULL, NULL, 13337, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 13:49:42', 'sanni-1506743997-1506750582128664', 1, 0, '', NULL, NULL, NULL),
(48097, '2017-09-30 13:49:42', NULL, NULL, 13337, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 13:49:42', 'sanni-1506743997-1506750582128664', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(48098, '2017-09-30 12:53:13', NULL, NULL, 13334, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:53:13', 'sanni-1506743997-15067471935895398', 1, 0, '', NULL, NULL, NULL),
(48099, '2017-09-30 11:04:29', NULL, NULL, 13321, 0, 181, '116', 'Open Food ', '2 sunny side up', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:04:29', 'admin-1506739636-15067406693116359', 1, 0, '', NULL, NULL, NULL),
(48100, '2017-09-30 10:58:14', NULL, NULL, 13324, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:58:14', 'admin-1506739636-15067402940795776', 1, 0, '', NULL, NULL, NULL),
(48101, '2017-09-30 12:01:12', NULL, NULL, 13330, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:01:12', 'sanni-1506743997-15067440721207410', 1, 1, 'SR', NULL, NULL, '10.0'),
(48102, '2017-09-30 12:03:30', NULL, NULL, 13331, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:03:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48103, '2017-09-30 12:04:02', NULL, NULL, 13331, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:04:02', 'sanni-1506743997-15067442420711320', 1, 0, '', NULL, NULL, NULL),
(48104, '2017-09-30 11:03:12', NULL, NULL, 13326, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:03:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48105, '2017-09-30 11:01:59', NULL, NULL, 13325, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:01:59', 'admin-1506739636-15067405197141316', 1, 0, '', NULL, NULL, NULL),
(48106, '2017-09-30 11:01:59', NULL, NULL, 13325, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:01:59', 'admin-1506739636-15067405197141316', 1, 0, '', NULL, NULL, NULL),
(48107, '2017-09-30 11:01:59', NULL, NULL, 13325, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:01:59', 'admin-1506739636-15067405197141316', 1, 0, '', NULL, NULL, NULL),
(48108, '2017-09-30 11:01:59', NULL, NULL, 13325, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:01:59', 'admin-1506739636-15067405197141316', 1, 0, '', NULL, NULL, NULL),
(48109, '2017-09-30 11:03:27', NULL, NULL, 13326, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:03:27', 'admin-1506739636-15067406069319038', 1, 0, '', NULL, NULL, NULL),
(48110, '2017-09-30 12:52:40', NULL, NULL, 13334, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.20, 0.0000, 0.0000, 15.20, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:52:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48111, '2017-09-30 12:18:33', NULL, NULL, 13333, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:18:33', 'sanni-1506743997-15067451136316490', 1, 0, '', NULL, NULL, NULL),
(48112, '2017-09-30 10:58:14', NULL, NULL, 13324, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:58:14', 'admin-1506739636-15067402940795776', 1, 0, '', NULL, NULL, NULL),
(48113, '2017-09-30 10:58:14', NULL, NULL, 13324, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:58:14', 'admin-1506739636-15067402940795776', 1, 0, '', NULL, NULL, NULL),
(48114, '2017-09-30 12:01:12', NULL, NULL, 13330, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:01:12', 'sanni-1506743997-15067440721207410', 1, 1, 'SR', NULL, NULL, '10.0'),
(48115, '2017-09-30 12:53:13', NULL, NULL, 13334, 0, 181, '116', 'Open Food ', 'double fri pork no rice', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:53:13', 'sanni-1506743997-15067471935895398', 1, 0, '', NULL, NULL, NULL),
(48116, '2017-09-30 14:10:29', NULL, NULL, 13339, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 14:10:29', 'admin-1506750592-15067518296213388', 1, 0, '', NULL, NULL, NULL),
(48117, '2017-09-30 14:10:29', NULL, NULL, 13339, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 14:10:29', 'admin-1506750592-15067518296213388', 1, 0, '', NULL, NULL, NULL),
(48118, '2017-09-30 12:18:22', NULL, NULL, 13333, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:18:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48119, '2017-09-30 12:05:25', NULL, NULL, 13328, 0, 71, '71', 'Chinese  Rice Wine Pork', 'Takeaway', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:05:25', 'sanni-1506743997-15067443250133833', 1, 1, 'SR', NULL, NULL, NULL),
(48120, '2017-09-30 12:04:02', NULL, NULL, 13331, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:04:02', 'sanni-1506743997-15067442420711320', 1, 1, 'SR', NULL, NULL, NULL),
(48121, '2017-09-30 12:04:02', NULL, NULL, 13331, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:04:02', 'sanni-1506743997-15067442420711320', 1, 1, 'SR', NULL, NULL, NULL),
(48122, '2017-09-30 12:04:02', NULL, NULL, 13331, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:04:02', 'sanni-1506743997-15067442420711320', 1, 1, 'SR', NULL, NULL, NULL),
(48123, '2017-09-30 12:04:02', NULL, NULL, 13331, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:04:02', 'sanni-1506743997-15067442420711320', 1, 0, '', NULL, NULL, NULL),
(48124, '2017-09-30 12:01:12', NULL, NULL, 13330, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:01:12', 'sanni-1506743997-15067440721207410', 1, 1, 'SR', NULL, NULL, '10.0'),
(48125, '2017-09-30 16:49:15', NULL, NULL, 13347, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1506750592', 'admin', '2017-09-30 16:49:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48126, '2017-09-30 16:49:17', NULL, NULL, 13347, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 16:49:17', 'admin-1506750592-15067613574324547', 1, 1, 'SR', NULL, NULL, NULL),
(48127, '2017-09-30 13:54:52', NULL, NULL, 13338, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 13:54:52', 'admin-1506750592-1506750892489966', 1, 1, 'SR', NULL, NULL, NULL),
(48128, '2017-09-30 11:03:27', NULL, NULL, 13326, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:03:27', 'admin-1506739636-15067406069319038', 1, 0, '', NULL, NULL, NULL),
(48129, '2017-09-30 14:13:31', NULL, NULL, 13340, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1506750592', 'admin', '2017-09-30 14:13:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48130, '2017-09-30 14:07:59', NULL, NULL, 13336, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 14:07:59', 'admin-1506750592-15067516790931878', 1, 0, '', NULL, NULL, NULL),
(48131, '2017-09-30 12:00:33', NULL, NULL, 13330, 0, 181, '116', 'Open Food ', 'toast', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:00:33', 'sanni-1506743997-15067440327133819', 1, 0, '', NULL, NULL, '10.0'),
(48132, '2017-09-30 12:18:33', NULL, NULL, 13333, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:18:33', 'sanni-1506743997-15067451136316490', 1, 1, 'SR', NULL, NULL, NULL),
(48133, '2017-09-30 11:03:27', NULL, NULL, 13326, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:03:27', 'admin-1506739636-15067406069319038', 1, 1, 'SR', NULL, NULL, NULL),
(48134, '2017-09-30 11:05:13', NULL, NULL, 13327, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:05:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48135, '2017-09-30 11:05:17', NULL, NULL, 13327, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:05:17', 'admin-1506739636-15067407169402573', 1, 1, 'SR', NULL, NULL, NULL),
(48136, '2017-09-30 15:51:47', NULL, NULL, 13345, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 15:51:47', 'admin-1506750592-15067579071958893', 1, 0, '', NULL, NULL, NULL),
(48137, '2017-09-30 15:51:47', NULL, NULL, 13345, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 15:51:47', 'admin-1506750592-15067579071958893', 1, 1, 'SR', NULL, NULL, NULL),
(48138, '2017-09-30 15:51:47', NULL, NULL, 13345, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 15:51:47', 'admin-1506750592-15067579071958893', 1, 1, 'SR', NULL, NULL, NULL),
(48139, '2017-09-30 15:33:20', NULL, NULL, 13343, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 15:33:20', 'admin-1506750592-15067567999335915', 1, 1, 'SR', NULL, NULL, NULL),
(48140, '2017-09-30 12:00:33', NULL, NULL, 13330, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:00:33', 'sanni-1506743997-15067440327133819', 1, 0, '', NULL, NULL, '10.0'),
(48141, '2017-09-30 11:53:26', NULL, NULL, 13329, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:53:26', 'admin-1506742277-15067436063147412', 1, 1, 'SR', NULL, NULL, NULL),
(48142, '2017-09-30 11:53:32', NULL, NULL, 13330, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.45, 0.0000, 0.0000, 8.45, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:53:32', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48143, '2017-09-30 13:49:42', NULL, NULL, 13337, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 13:49:42', 'sanni-1506743997-1506750582128664', 1, 1, 'SR', NULL, NULL, NULL),
(48144, '2017-09-30 12:00:32', NULL, NULL, 13330, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:00:32', 'sanni-1506743997-15067440327133819', 1, 0, '', NULL, NULL, '10.0'),
(48145, '2017-09-30 12:00:32', NULL, NULL, 13330, 0, 73, '73', 'Marmite Chicken ', 'Pasta', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:00:32', 'sanni-1506743997-15067440327133819', 1, 1, 'SR', NULL, NULL, '10.0'),
(48146, '2017-09-30 14:52:15', NULL, NULL, 13341, 0, 181, '116', 'Open Food ', 'Rainbowl Rice', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 14:52:15', 'admin-1506750592-15067543349351946', 1, 0, '', 1, NULL, NULL),
(48147, '2017-09-30 11:53:11', NULL, NULL, 13329, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:53:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48148, '2017-09-30 11:53:18', NULL, NULL, 13329, 0, 215, '149', 'Thai Fish Sauce Garlic Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:53:18', 'admin-1506742277-15067435980162652', 1, 0, '', NULL, NULL, NULL),
(48149, '2017-09-30 12:00:32', NULL, NULL, 13330, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:00:32', 'sanni-1506743997-15067440327133819', 1, 0, '', NULL, NULL, '10.0'),
(48150, '2017-09-30 11:01:24', NULL, NULL, 13325, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:01:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48151, '2017-09-30 16:30:50', NULL, NULL, 13346, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1506750592', 'admin', '2017-09-30 16:30:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48152, '2017-09-30 16:30:58', NULL, NULL, 13346, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 16:30:58', 'admin-1506750592-15067602579214068', 1, 1, 'SR', NULL, NULL, NULL),
(48153, '2017-09-30 16:30:58', NULL, NULL, 13346, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 16:30:58', 'admin-1506750592-15067602579214068', 1, 1, 'SR', NULL, NULL, NULL),
(48154, '2017-09-30 15:43:09', NULL, NULL, 13344, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1506750592', 'admin', '2017-09-30 15:43:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48155, '2017-09-30 12:18:33', NULL, NULL, 13333, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:18:33', 'sanni-1506743997-15067451136316490', 1, 1, 'SR', NULL, NULL, NULL),
(48156, '2017-09-30 11:42:54', NULL, NULL, 13328, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:42:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48157, '2017-09-30 11:43:03', NULL, NULL, 13328, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:43:03', 'admin-1506742277-15067429837401024', 1, 0, '', NULL, NULL, NULL),
(48158, '2017-09-30 11:43:03', NULL, NULL, 13328, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:43:03', 'admin-1506742277-15067429837401024', 1, 0, '', NULL, NULL, NULL),
(48159, '2017-09-30 11:43:10', NULL, NULL, 13328, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:43:10', 'admin-1506742277-15067429904131745', 1, 1, 'SR', NULL, NULL, NULL),
(48160, '2017-09-30 15:43:27', NULL, NULL, 13344, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 15:43:27', 'admin-1506750592-15067574073665286', 1, 0, '', NULL, NULL, NULL),
(48161, '2017-09-30 15:43:27', NULL, NULL, 13344, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 15:43:27', 'admin-1506750592-15067574073665286', 1, 1, 'SR', NULL, NULL, NULL),
(48162, '2017-09-30 15:43:27', NULL, NULL, 13344, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 15:43:27', 'admin-1506750592-15067574073665286', 1, 0, '', NULL, NULL, NULL),
(48163, '2017-09-30 15:43:27', NULL, NULL, 13344, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 15:43:27', 'admin-1506750592-15067574073665286', 1, 1, 'SR', NULL, NULL, NULL),
(48164, '2017-09-30 12:53:35', NULL, NULL, 13334, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:53:35', 'sanni-1506743997-15067472150664894', 1, 1, 'SR', NULL, NULL, NULL),
(48165, '2017-09-30 13:12:29', NULL, NULL, 13335, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 13:12:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48166, '2017-09-30 13:12:34', NULL, NULL, 13335, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 13:12:34', 'sanni-1506743997-15067483539813419', 1, 1, 'SR', NULL, NULL, NULL),
(48167, '2017-09-30 14:52:48', NULL, NULL, 13342, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 14:52:48', 'admin-1506750592-15067543678174243', 1, 1, 'SR', 1, NULL, '10.0'),
(48168, '2017-09-30 15:32:21', NULL, NULL, 13343, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1506750592', 'admin', '2017-09-30 15:32:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48169, '2017-09-30 11:43:10', NULL, NULL, 13328, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:43:10', 'admin-1506742277-15067429904131745', 1, 1, 'SR', NULL, NULL, NULL),
(48170, '2017-09-30 14:13:38', NULL, NULL, 13340, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 14:13:38', 'admin-1506750592-15067520177863637', 1, 1, 'SR', NULL, NULL, NULL),
(48171, '2017-09-30 11:03:27', NULL, NULL, 13326, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:03:27', 'admin-1506739636-15067406069319038', 1, 1, 'SR', NULL, NULL, NULL),
(48172, '2017-09-30 12:18:01', NULL, NULL, 13332, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:18:01', 'sanni-1506743997-150674508120812', 1, 0, '', NULL, NULL, NULL),
(48173, '2017-09-30 10:27:37', NULL, NULL, 13319, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:27:37', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48174, '2017-09-30 10:27:44', NULL, NULL, 13319, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:27:44', 'admin-1506732936-15067384644504726', 1, 1, 'SR', NULL, NULL, '10.0'),
(48175, '2017-09-30 10:27:44', NULL, NULL, 13319, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:27:44', 'admin-1506732936-15067384644504726', 1, 0, '', NULL, NULL, '10.0'),
(48176, '2017-09-30 10:27:44', NULL, NULL, 13319, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:27:44', 'admin-1506732936-15067384644504726', 1, 0, '', NULL, NULL, '10.0'),
(48177, '2017-09-30 10:30:58', NULL, NULL, 13320, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:30:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48178, '2017-09-30 10:31:14', NULL, NULL, 13320, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:31:14', 'admin-1506732936-15067386740398143', 1, 0, '', NULL, NULL, NULL),
(48179, '2017-09-30 10:31:14', NULL, NULL, 13320, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:31:14', 'admin-1506732936-15067386740398143', 1, 0, '', NULL, NULL, NULL),
(48180, '2017-09-30 10:31:14', NULL, NULL, 13320, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:31:14', 'admin-1506732936-15067386740398143', 1, 1, 'SR', NULL, NULL, NULL),
(48181, '2017-09-30 10:58:14', NULL, NULL, 13324, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:58:14', 'admin-1506739636-15067402940795776', 1, 1, 'SR', NULL, NULL, NULL),
(48182, '2017-09-30 10:58:14', NULL, NULL, 13324, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:58:14', 'admin-1506739636-15067402940795776', 1, 1, 'SR', NULL, NULL, NULL),
(48183, '2017-09-30 10:58:14', NULL, NULL, 13324, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:58:14', 'admin-1506739636-15067402940795776', 1, 1, 'SR', NULL, NULL, NULL),
(48184, '2017-09-30 14:09:58', NULL, NULL, 13339, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 14:09:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48185, '2017-09-30 13:54:52', NULL, NULL, 13338, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 13:54:52', 'admin-1506750592-1506750892489966', 1, 0, '', NULL, NULL, NULL),
(48186, '2017-09-30 13:54:52', NULL, NULL, 13338, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 13:54:52', 'admin-1506750592-1506750892489966', 1, 0, '', NULL, NULL, NULL),
(48187, '2017-09-30 15:33:20', NULL, NULL, 13343, 0, 181, '116', 'Open Food ', 'Scone', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 15:33:20', 'admin-1506750592-15067567999335915', 1, 0, '', NULL, NULL, NULL),
(48188, '2017-09-30 13:54:36', NULL, NULL, 13338, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1506750592', 'admin', '2017-09-30 13:54:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48189, '2017-09-30 13:49:42', NULL, NULL, 13337, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 13:49:42', 'sanni-1506743997-1506750582128664', 1, 1, 'SR', NULL, NULL, NULL),
(48190, '2017-09-30 13:49:42', NULL, NULL, 13337, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 13:49:42', 'sanni-1506743997-1506750582128664', 1, 1, 'SR', NULL, NULL, NULL),
(48191, '2017-09-30 13:49:42', NULL, NULL, 13337, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 13:49:42', 'sanni-1506743997-1506750582128664', 1, 1, 'SR', NULL, NULL, NULL),
(48192, '2017-09-30 13:49:42', NULL, NULL, 13337, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 13:49:42', 'sanni-1506743997-1506750582128664', 1, 1, 'SR', NULL, NULL, NULL),
(48193, '2017-09-30 13:12:34', NULL, NULL, 13335, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 13:12:34', 'sanni-1506743997-15067483539813419', 1, 1, 'SR', NULL, NULL, NULL),
(48194, '2017-09-30 12:53:13', NULL, NULL, 13334, 0, 77, '77', 'Sarawak Kolomee', 'add vege', 'Meals', 'Non-Rice', 3, 12.00, 36.0000, 0.0000, 36.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:53:13', 'sanni-1506743997-15067471935895398', 1, 1, 'SR', NULL, NULL, NULL),
(48195, '2017-09-30 12:01:12', NULL, NULL, 13330, 0, 181, '116', 'Open Food ', 'sunny side up', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:01:12', 'sanni-1506743997-15067440721207410', 1, 0, '', NULL, NULL, '10.0'),
(48196, '2017-09-30 12:53:35', NULL, NULL, 13334, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:53:35', 'sanni-1506743997-15067472150664894', 1, 1, 'SR', NULL, NULL, NULL),
(48197, '2017-09-30 15:51:38', NULL, NULL, 13345, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 15:51:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48198, '2017-09-30 12:53:35', NULL, NULL, 13334, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:53:35', 'sanni-1506743997-15067472150664894', 1, 1, 'SR', NULL, NULL, NULL),
(48199, '2017-09-30 12:53:35', NULL, NULL, 13334, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:53:35', 'sanni-1506743997-15067472150664894', 1, 0, '', NULL, NULL, NULL),
(48200, '2017-09-30 12:53:35', NULL, NULL, 13334, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:53:35', 'sanni-1506743997-15067472150664894', 1, 0, '', NULL, NULL, NULL),
(48201, '2017-09-30 12:53:35', NULL, NULL, 13334, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:53:35', 'sanni-1506743997-15067472150664894', 1, 0, '', NULL, NULL, NULL),
(48202, '2017-09-30 10:17:10', NULL, NULL, 13317, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:17:10', 'admin-1506732936-150673783001976', 1, 0, '', NULL, NULL, NULL),
(48203, '2017-09-30 10:17:10', NULL, NULL, 13317, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:17:10', 'admin-1506732936-150673783001976', 1, 1, 'SR', NULL, NULL, NULL),
(48204, '2017-09-30 10:58:14', NULL, NULL, 13324, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:58:14', 'admin-1506739636-15067402940795776', 1, 0, '', NULL, NULL, NULL),
(48205, '2017-09-30 10:43:38', NULL, NULL, 13323, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:43:38', 'admin-1506732936-15067394179519841', 1, 1, 'SR', NULL, NULL, NULL),
(48206, '2017-09-30 10:43:38', NULL, NULL, 13323, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:43:38', 'admin-1506732936-15067394179519841', 1, 0, '', NULL, NULL, NULL),
(48207, '2017-09-30 10:55:11', NULL, NULL, 13324, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.20, 0.0000, 0.0000, 10.20, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:55:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48208, '2017-09-30 10:54:30', NULL, NULL, 13321, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:54:30', 'admin-1506739636-1506740069890211', 1, 0, '', NULL, NULL, NULL),
(48209, '2017-09-30 10:47:44', NULL, NULL, 13317, 0, 181, '116', 'Open Food ', 'yogurt', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:47:44', 'admin-1506739636-15067396642391215', 1, 0, '', NULL, NULL, NULL),
(48210, '2017-09-30 10:43:38', NULL, NULL, 13323, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:43:38', 'admin-1506732936-15067394179519841', 1, 0, '', NULL, NULL, NULL),
(48211, '2017-09-30 10:43:30', NULL, NULL, 13323, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:43:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48212, '2017-09-30 10:35:39', NULL, NULL, 13321, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:35:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48213, '2017-09-30 10:35:45', NULL, NULL, 13321, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:35:45', 'admin-1506732936-15067389453447527', 1, 0, '', NULL, NULL, NULL),
(48214, '2017-09-30 10:37:53', NULL, NULL, 13322, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:37:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48215, '2017-09-30 10:38:08', NULL, NULL, 13322, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:38:08', 'admin-1506732936-15067390878294076', 1, 0, '', NULL, NULL, NULL),
(48216, '2017-09-30 09:54:05', NULL, NULL, 13314, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 09:54:05', 'admin-1506732936-15067364452863549', 1, 0, '', NULL, NULL, NULL),
(48217, '2017-09-30 10:38:08', NULL, NULL, 13322, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:38:08', 'admin-1506732936-15067390878294076', 1, 1, 'SR', NULL, NULL, NULL),
(48218, '2017-09-30 10:38:08', NULL, NULL, 13322, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:38:08', 'admin-1506732936-15067390878294076', 1, 0, '', NULL, NULL, NULL),
(48219, '2017-09-30 10:31:22', NULL, NULL, 13320, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:31:22', 'admin-1506732936-15067386822705126', 1, 1, 'SR', NULL, NULL, NULL),
(48220, '2017-09-30 10:31:22', NULL, NULL, 13320, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:31:22', 'admin-1506732936-15067386822705126', 1, 1, 'SR', NULL, NULL, NULL),
(48221, '2017-09-30 12:18:01', NULL, NULL, 13332, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:18:01', 'sanni-1506743997-150674508120812', 1, 0, '', NULL, NULL, NULL),
(48222, '2017-09-30 12:16:58', NULL, NULL, 13332, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:16:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48223, '2017-09-30 12:18:01', NULL, NULL, 13332, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 2, 14.00, 28.0000, 0.0000, 28.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:18:01', 'sanni-1506743997-150674508120812', 1, 1, 'SR', NULL, NULL, NULL),
(48224, '2017-09-30 12:18:01', NULL, NULL, 13332, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:18:01', 'sanni-1506743997-150674508120812', 1, 1, 'SR', NULL, NULL, NULL),
(48225, '2017-09-30 10:17:10', NULL, NULL, 13317, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:17:10', 'admin-1506732936-150673783001976', 1, 1, 'SR', NULL, NULL, NULL),
(48226, '2017-09-30 10:17:00', NULL, NULL, 13317, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:17:00', 'admin-1506732936-15067378203411915', 1, 0, '', NULL, NULL, NULL),
(48227, '2017-09-30 10:16:54', NULL, NULL, 13317, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1506750592', 'admin', '2017-09-30 10:16:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48228, '2017-09-30 09:56:02', NULL, NULL, 13316, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 09:56:02', 'admin-1506732936-15067365619559684', 1, 0, '', NULL, NULL, NULL),
(48229, '2017-09-30 09:55:51', NULL, NULL, 13316, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1506750592', 'admin', '2017-09-30 09:55:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48230, '2017-09-30 09:55:14', NULL, NULL, 13315, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 09:55:14', 'admin-1506732936-1506736513956144', 1, 1, 'SR', NULL, NULL, NULL),
(48231, '2017-09-30 09:55:14', NULL, NULL, 13315, 0, 181, '116', 'Open Food ', ' replace egg,no sausage', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 09:55:14', 'admin-1506732936-1506736513956144', 1, 0, '', NULL, NULL, NULL),
(48232, '2017-09-30 09:54:30', NULL, NULL, 13315, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1506750592', 'admin', '2017-09-30 09:54:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48233, '2017-09-30 09:55:14', NULL, NULL, 13315, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 09:55:14', 'admin-1506732936-1506736513956144', 1, 0, '', NULL, NULL, NULL),
(48234, '2017-09-30 09:54:05', NULL, NULL, 13314, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 09:54:05', 'admin-1506732936-15067364452863549', 1, 1, 'SR', NULL, NULL, NULL),
(48235, '2017-09-30 12:18:33', NULL, NULL, 13333, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506750592', 'sanni', '2017-09-30 12:18:33', 'sanni-1506743997-15067451136316490', 1, 0, '', NULL, NULL, NULL),
(48236, '2017-09-30 09:54:05', NULL, NULL, 13314, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 09:54:05', 'admin-1506732936-15067364452863549', 1, 1, 'SR', NULL, NULL, NULL),
(48237, '2017-09-30 09:53:52', NULL, NULL, 13314, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 09:53:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48238, '2017-09-30 09:54:05', NULL, NULL, 13314, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 09:54:05', 'admin-1506732936-15067364452863549', 1, 0, '', NULL, NULL, NULL),
(48239, '2017-09-30 09:12:16', NULL, NULL, 13313, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 09:12:16', 'admin-1506732936-15067339366073683', 1, 0, '', NULL, NULL, NULL),
(48240, '2017-09-30 09:12:16', NULL, NULL, 13313, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 09:12:16', 'admin-1506732936-15067339366073683', 1, 0, '', NULL, NULL, NULL),
(48241, '2017-09-30 11:03:27', NULL, NULL, 13326, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 11:03:27', 'admin-1506739636-15067406069319038', 1, 1, 'SR', NULL, NULL, NULL),
(48242, '2017-09-30 09:12:36', NULL, NULL, 13313, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506750592', 'admin', '2017-09-30 09:12:36', 'admin-1506732936-15067339558283574', 1, 1, 'SR', NULL, NULL, NULL),
(48243, '2017-09-30 09:12:08', NULL, NULL, 13313, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1506750592', 'admin', '2017-09-30 09:12:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48244, '2017-10-01 11:14:00', NULL, NULL, 13367, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:14:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48245, '2017-10-01 11:07:28', NULL, NULL, 13365, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:07:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48246, '2017-10-01 11:07:45', NULL, NULL, 13365, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:07:45', 'admin-1506825944-15068272650253611', 1, 0, '', NULL, NULL, NULL),
(48247, '2017-10-01 11:07:45', NULL, NULL, 13365, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:07:45', 'admin-1506825944-15068272650253611', 1, 0, '', NULL, NULL, NULL),
(48248, '2017-10-01 11:08:11', NULL, NULL, 13365, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:08:11', 'admin-1506825944-15068272912265191', 1, 1, 'SR', NULL, NULL, NULL),
(48249, '2017-10-01 13:46:17', NULL, NULL, 13375, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:46:17', 'admin-1506835110-1506836777178140', 1, 1, 'SR', NULL, NULL, '10.0'),
(48250, '2017-10-01 13:48:29', NULL, NULL, 13381, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.60, 0.0000, 0.0000, 13.60, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:48:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48251, '2017-10-01 13:49:32', NULL, NULL, 13381, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:49:32', 'admin-1506835110-15068369719007176', 1, 0, '', NULL, NULL, NULL),
(48252, '2017-10-01 13:50:04', NULL, NULL, 13381, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:50:04', 'admin-1506835110-15068370045953359', 1, 1, 'SR', NULL, NULL, NULL),
(48253, '2017-10-01 09:52:45', NULL, NULL, 13353, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:52:45', 'admin-1506818470-1506822765795597', 1, 1, 'SR', NULL, NULL, NULL),
(48254, '2017-10-01 09:55:27', NULL, NULL, 13353, 0, 182, '117', 'Open Drinks ', 'Fresh fruits', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:55:27', 'admin-1506818470-15068229271516733', 1, 0, '', NULL, NULL, NULL),
(48255, '2017-10-01 14:34:57', NULL, NULL, 13384, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 14:34:57', 'admin-1506837768-15068396974443458', 1, 0, '', NULL, NULL, NULL),
(48256, '2017-10-01 15:58:30', NULL, NULL, 13389, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 15:58:30', 'admin-1506837768-15068447103154490', 1, 1, 'SR', 1, NULL, NULL),
(48257, '2017-10-01 16:09:32', NULL, NULL, 13385, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 16:09:32', 'admin-1506837768-15068453720945790', 1, 0, '', NULL, NULL, NULL),
(48258, '2017-10-01 13:29:21', NULL, NULL, 13380, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:29:21', 'admin-1506835110-15068357611127488', 1, 0, '', NULL, NULL, NULL),
(48259, '2017-10-01 13:29:21', NULL, NULL, 13380, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:29:21', 'admin-1506835110-15068357611127488', 1, 0, '', NULL, NULL, NULL),
(48260, '2017-10-01 13:29:41', NULL, NULL, 13380, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:29:41', 'admin-1506835110-15068357810055477', 1, 1, 'SR', NULL, NULL, NULL),
(48261, '2017-10-01 13:59:14', NULL, NULL, 13383, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:59:14', 'admin-1506835110-15068375546804798', 1, 1, 'SR', NULL, NULL, NULL),
(48262, '2017-10-01 13:58:23', NULL, NULL, 13383, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:58:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48263, '2017-10-01 13:50:43', NULL, NULL, 13382, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:50:43', 'admin-1506835110-15068370437408489', 1, 0, '', NULL, NULL, NULL),
(48264, '2017-10-01 13:50:27', NULL, NULL, 13382, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:50:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48265, '2017-10-01 13:50:04', NULL, NULL, 13381, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:50:04', 'admin-1506835110-15068370045953359', 1, 1, 'SR', NULL, NULL, NULL),
(48266, '2017-10-01 13:50:04', NULL, NULL, 13381, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:50:04', 'admin-1506835110-15068370045953359', 1, 1, 'SR', NULL, NULL, NULL),
(48267, '2017-10-01 14:08:10', NULL, NULL, 13384, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 14:08:10', 'admin-1506837768-15068380905842184', 1, 1, 'SR', NULL, NULL, NULL),
(48268, '2017-10-01 14:08:17', NULL, NULL, 13385, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1506837768', 'admin', '2017-10-01 14:08:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48269, '2017-10-01 12:30:37', NULL, NULL, 13373, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 12:30:37', 'admin-1506828994-15068322373171696', 1, 0, '', NULL, NULL, NULL),
(48270, '2017-10-01 13:03:50', NULL, NULL, 13375, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:03:50', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48271, '2017-10-01 13:04:27', NULL, NULL, 13375, 0, 153, '87', 'Wake Me Up!', 'no vegetables', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:04:27', 'admin-1506828994-15068342672799171', 1, 0, '', NULL, NULL, '10.0'),
(48272, '2017-10-01 13:49:32', NULL, NULL, 13381, 0, 153, '87', 'Wake Me Up!', 'fried egg', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:49:32', 'admin-1506835110-15068369719007176', 1, 0, '', NULL, NULL, NULL),
(48273, '2017-10-01 14:08:41', NULL, NULL, 13386, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1506837768', 'admin', '2017-10-01 14:08:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48274, '2017-10-01 14:08:47', NULL, NULL, 13386, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 14:08:47', 'admin-1506837768-15068381276298489', 1, 0, '', NULL, NULL, NULL),
(48275, '2017-10-01 14:08:47', NULL, NULL, 13386, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 14:08:47', 'admin-1506837768-15068381276298489', 1, 1, 'SR', NULL, NULL, NULL),
(48276, '2017-10-01 16:09:32', NULL, NULL, 13385, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 16:09:32', 'admin-1506837768-15068453720945790', 1, 0, '', NULL, NULL, NULL),
(48277, '2017-10-01 11:40:56', NULL, NULL, 13370, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:40:56', 'admin-1506828994-15068292566335364', 1, 0, '', NULL, NULL, NULL),
(48278, '2017-10-01 13:49:32', NULL, NULL, 13381, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:49:32', 'admin-1506835110-15068369719007176', 1, 0, '', NULL, NULL, NULL),
(48279, '2017-10-01 13:46:09', NULL, NULL, 13375, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:46:09', 'admin-1506835110-15068367691962494', 1, 1, 'SR', NULL, NULL, '10.0'),
(48280, '2017-10-01 13:29:41', NULL, NULL, 13380, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:29:41', 'admin-1506835110-15068357810055477', 1, 0, '', NULL, NULL, NULL),
(48281, '2017-10-01 13:08:35', NULL, NULL, 13376, 0, 182, '117', 'Open Drinks ', 'americano', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:08:35', 'admin-1506828994-1506834515712919', 1, 0, '', 1, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(48282, '2017-10-01 13:15:41', NULL, NULL, 13377, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:15:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48283, '2017-10-01 13:16:27', NULL, NULL, 13377, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:16:27', 'admin-1506828994-15068349871793825', 1, 0, '', NULL, NULL, NULL),
(48284, '2017-10-01 13:16:27', NULL, NULL, 13377, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:16:27', 'admin-1506828994-15068349871793825', 1, 0, '', NULL, NULL, NULL),
(48285, '2017-10-01 13:16:27', NULL, NULL, 13377, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:16:27', 'admin-1506828994-15068349871793825', 1, 0, '', NULL, NULL, NULL),
(48286, '2017-10-01 14:07:49', NULL, NULL, 13384, 0, 291, '225', 'Smoked Duck Red Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 14:07:49', 'admin-1506837768-1506838069403641', 1, 0, '', NULL, NULL, NULL),
(48287, '2017-10-01 11:00:07', NULL, NULL, 13363, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:00:07', 'admin-1506825944-15068268071545454', 1, 0, '', NULL, NULL, NULL),
(48288, '2017-10-01 11:00:07', NULL, NULL, 13363, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:00:07', 'admin-1506825944-15068268071545454', 1, 0, '', NULL, NULL, NULL),
(48289, '2017-10-01 17:24:17', NULL, NULL, 13390, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1506837768', 'admin', '2017-10-01 17:24:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48290, '2017-10-01 11:38:50', NULL, NULL, 13369, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:38:50', 'admin-1506828994-15068291299536588', 1, 1, 'SR', NULL, NULL, NULL),
(48291, '2017-10-01 13:29:21', NULL, NULL, 13380, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:29:21', 'admin-1506835110-15068357611127488', 1, 0, '', NULL, NULL, NULL),
(48292, '2017-10-01 13:28:43', NULL, NULL, 13380, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:28:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48293, '2017-10-01 13:27:42', NULL, NULL, 13379, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:27:42', 'admin-1506835110-1506835662505776', 1, 1, 'SR', NULL, NULL, NULL),
(48294, '2017-10-01 16:09:32', NULL, NULL, 13385, 0, 182, '117', 'Open Drinks ', 'scones', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 16:09:32', 'admin-1506837768-15068453720945790', 1, 0, '', NULL, NULL, NULL),
(48295, '2017-10-01 13:27:37', NULL, NULL, 13379, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:27:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48296, '2017-10-01 12:55:29', NULL, NULL, 13374, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 12:55:29', 'admin-1506828994-15068337292691139', 1, 0, '', NULL, NULL, NULL),
(48297, '2017-10-01 12:00:17', NULL, NULL, 13371, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1506837768', 'admin', '2017-10-01 12:00:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48298, '2017-10-01 11:09:21', NULL, NULL, 13366, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:09:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48299, '2017-10-01 11:09:32', NULL, NULL, 13366, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:09:32', 'admin-1506825944-15068273720748929', 1, 1, 'SR', NULL, NULL, NULL),
(48300, '2017-10-01 11:11:32', NULL, NULL, 13362, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:11:32', 'admin-1506825944-15068274923822792', 1, 1, 'SR', NULL, NULL, NULL),
(48301, '2017-10-01 14:21:15', NULL, NULL, 13385, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 14:21:15', 'admin-1506837768-15068388752919541', 1, 1, 'SR', NULL, NULL, NULL),
(48302, '2017-10-01 11:00:07', NULL, NULL, 13363, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:00:07', 'admin-1506825944-15068268071545454', 1, 0, '', NULL, NULL, NULL),
(48303, '2017-10-01 11:00:22', NULL, NULL, 13363, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:00:22', 'admin-1506825944-1506826822424317', 1, 1, 'SR', NULL, NULL, NULL),
(48304, '2017-10-01 11:00:22', NULL, NULL, 13363, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:00:22', 'admin-1506825944-1506826822424317', 1, 1, 'SR', NULL, NULL, NULL),
(48305, '2017-10-01 13:27:35', NULL, NULL, 13378, 0, 181, '116', 'Open Food ', 'Pan Fry Dumpling', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:27:35', 'admin-1506835110-15068356550855642', 1, 0, '', NULL, NULL, '10.0'),
(48306, '2017-10-01 13:04:27', NULL, NULL, 13375, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:04:27', 'admin-1506828994-15068342672799171', 1, 1, 'SR', NULL, NULL, '10.0'),
(48307, '2017-10-01 13:06:57', NULL, NULL, 13369, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:06:57', 'admin-1506828994-15068344174142461', 1, 0, '', NULL, NULL, NULL),
(48308, '2017-10-01 17:24:22', NULL, NULL, 13390, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 17:24:22', 'admin-1506837768-15068498623676888', 1, 1, 'SR', NULL, NULL, NULL),
(48309, '2017-10-01 11:21:06', NULL, NULL, 13368, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:21:06', 'admin-1506825944-15068280666788559', 1, 1, 'SR', 1, NULL, '10.0'),
(48310, '2017-10-01 13:26:51', NULL, NULL, 13378, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:26:51', 'admin-1506835110-15068356110888671', 1, 1, 'SR', NULL, NULL, '10.0'),
(48311, '2017-10-01 13:26:18', NULL, NULL, 13378, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:26:18', 'admin-1506835110-15068355779073994', 1, 0, '', NULL, NULL, '10.0'),
(48312, '2017-10-01 16:15:32', NULL, NULL, 13381, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 16:15:32', 'admin-1506837768-15068457323621819', 1, 1, 'SR', NULL, NULL, NULL),
(48313, '2017-10-01 13:24:26', NULL, NULL, 13378, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:24:26', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48314, '2017-10-01 13:24:32', NULL, NULL, 13378, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:24:32', 'admin-1506835110-15068354724376215', 1, 1, 'SR', NULL, NULL, '10.0'),
(48315, '2017-10-01 13:18:45', NULL, NULL, 13363, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:18:45', 'admin-1506835110-15068351254904875', 1, 1, 'SR', NULL, NULL, NULL),
(48316, '2017-10-01 13:18:27', NULL, NULL, 13377, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:18:27', 'admin-1506828994-15068350737977947', 1, 0, '', NULL, NULL, NULL),
(48317, '2017-10-01 13:06:32', NULL, NULL, 13375, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:06:32', 'admin-1506828994-15068343919918855', 1, 0, '', NULL, NULL, '10.0'),
(48318, '2017-10-01 13:04:27', NULL, NULL, 13375, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:04:27', 'admin-1506828994-15068342672799171', 1, 0, '', NULL, NULL, '10.0'),
(48319, '2017-10-01 12:06:28', NULL, NULL, 13372, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 12:06:28', 'admin-1506828994-15068307879153244', 1, 0, '', NULL, NULL, NULL),
(48320, '2017-10-01 11:40:56', NULL, NULL, 13370, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:40:56', 'admin-1506828994-15068292566335364', 1, 1, 'SR', NULL, NULL, NULL),
(48321, '2017-10-01 14:21:15', NULL, NULL, 13385, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 14:21:15', 'admin-1506837768-15068388752919541', 1, 0, '', NULL, NULL, NULL),
(48322, '2017-10-01 14:21:15', NULL, NULL, 13385, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 14:21:15', 'admin-1506837768-15068388752919541', 1, 0, '', NULL, NULL, NULL),
(48323, '2017-10-01 14:21:15', NULL, NULL, 13385, 0, 153, '87', 'Wake Me Up!', ' change to salad,No baked bean', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 14:21:15', 'admin-1506837768-15068388752919541', 1, 0, '', NULL, NULL, NULL),
(48324, '2017-10-01 14:08:25', NULL, NULL, 13385, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 14:08:25', 'admin-1506837768-15068381053083667', 1, 0, '', NULL, NULL, NULL),
(48325, '2017-10-01 12:55:29', NULL, NULL, 13374, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 12:55:29', 'admin-1506828994-15068337292691139', 1, 0, '', NULL, NULL, NULL),
(48326, '2017-10-01 12:55:36', NULL, NULL, 13374, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 12:55:36', 'admin-1506828994-1506833735922387', 1, 1, 'SR', NULL, NULL, NULL),
(48327, '2017-10-01 11:38:50', NULL, NULL, 13369, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:38:50', 'admin-1506828994-15068291299536588', 1, 1, 'SR', NULL, NULL, NULL),
(48328, '2017-10-01 14:07:49', NULL, NULL, 13384, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 14:07:49', 'admin-1506837768-1506838069403641', 1, 1, 'SR', NULL, NULL, NULL),
(48329, '2017-10-01 14:07:49', NULL, NULL, 13384, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 14:07:49', 'admin-1506837768-1506838069403641', 1, 0, '', NULL, NULL, NULL),
(48330, '2017-10-01 14:05:48', NULL, NULL, 13384, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1506837768', 'admin', '2017-10-01 14:05:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48331, '2017-10-01 12:30:37', NULL, NULL, 13373, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 12:30:37', 'admin-1506828994-15068322373171696', 1, 1, 'SR', NULL, NULL, NULL),
(48332, '2017-10-01 12:30:01', NULL, NULL, 13373, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1506837768', 'admin', '2017-10-01 12:30:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48333, '2017-10-01 10:38:53', NULL, NULL, 13358, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:38:53', 'admin-1506818470-15068255335023381', 1, 0, '', NULL, NULL, NULL),
(48334, '2017-10-01 12:02:14', NULL, NULL, 13371, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 12:02:14', 'admin-1506828994-15068305344442248', 1, 0, '', NULL, NULL, NULL),
(48335, '2017-10-01 12:05:55', NULL, NULL, 13372, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 12:05:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48336, '2017-10-01 12:06:28', NULL, NULL, 13372, 0, 215, '149', 'Thai Fish Sauce Garlic Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 12:06:28', 'admin-1506828994-15068307879153244', 1, 0, '', NULL, NULL, NULL),
(48337, '2017-10-01 10:38:41', NULL, NULL, 13358, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:38:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48338, '2017-10-01 10:59:51', NULL, NULL, 13363, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.40, 0.0000, 0.0000, 11.40, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:59:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48339, '2017-10-01 12:54:54', NULL, NULL, 13374, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1506837768', 'admin', '2017-10-01 12:54:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48340, '2017-10-01 12:38:53', NULL, NULL, 13369, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 12:38:53', 'admin-1506828994-15068327332441310', 1, 1, 'SR', NULL, NULL, NULL),
(48341, '2017-10-01 12:48:24', NULL, NULL, 13372, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 12:48:24', 'admin-1506828994-15068333046703269', 1, 0, '', NULL, NULL, NULL),
(48342, '2017-10-01 11:04:29', NULL, NULL, 13363, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:04:29', 'admin-1506825944-15068270692866636', 1, 0, '', NULL, NULL, NULL),
(48343, '2017-10-01 11:05:23', NULL, NULL, 13364, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:05:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48344, '2017-10-01 11:05:47', NULL, NULL, 13364, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:05:47', 'admin-1506825944-15068271478239086', 1, 1, 'SR', NULL, NULL, NULL),
(48345, '2017-10-01 12:30:56', NULL, NULL, 13373, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 12:30:56', 'admin-1506828994-15068322561499846', 1, 1, 'SR', NULL, NULL, NULL),
(48346, '2017-10-01 14:29:03', NULL, NULL, 13381, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 14:29:03', 'admin-1506837768-1506839343235946', 1, 0, '', NULL, NULL, NULL),
(48347, '2017-10-01 12:30:56', NULL, NULL, 13373, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 12:30:56', 'admin-1506828994-15068322561499846', 1, 1, 'SR', NULL, NULL, NULL),
(48348, '2017-10-01 14:29:03', NULL, NULL, 13381, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 14:29:03', 'admin-1506837768-1506839343235946', 1, 1, 'SR', NULL, NULL, NULL),
(48349, '2017-10-01 13:26:51', NULL, NULL, 13378, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:26:51', 'admin-1506835110-15068356110888671', 1, 1, 'SR', NULL, NULL, '10.0'),
(48350, '2017-10-01 12:06:55', NULL, NULL, 13372, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 12:06:55', 'admin-1506828994-15068308152288452', 1, 0, '', NULL, NULL, NULL),
(48351, '2017-10-01 12:11:19', NULL, NULL, 13372, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 12:11:19', 'admin-1506828994-15068310790402047', 1, 1, 'SR', NULL, NULL, NULL),
(48352, '2017-10-01 13:04:27', NULL, NULL, 13375, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:04:27', 'admin-1506828994-15068342672799171', 1, 0, '', NULL, NULL, '10.0'),
(48353, '2017-10-01 09:11:44', NULL, NULL, 13349, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:11:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48354, '2017-10-01 09:11:53', NULL, NULL, 13349, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:11:53', 'admin-1506818470-1506820313726980', 1, 0, '', NULL, NULL, NULL),
(48355, '2017-10-01 09:11:53', NULL, NULL, 13349, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:11:53', 'admin-1506818470-1506820313726980', 1, 0, '', NULL, NULL, NULL),
(48356, '2017-10-01 09:13:01', NULL, NULL, 13350, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:13:01', 'admin-1506818470-15068203811835642', 1, 1, 'SR', 1, NULL, NULL),
(48357, '2017-10-01 09:16:20', NULL, NULL, 13351, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:16:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48358, '2017-10-01 09:16:50', NULL, NULL, 13351, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:16:50', 'admin-1506818470-15068206106592092', 1, 0, '', NULL, NULL, NULL),
(48359, '2017-10-01 09:16:50', NULL, NULL, 13351, 0, 207, '142', 'Cheesy Bacon Toast', 'no salad', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:16:50', 'admin-1506818470-15068206106592092', 1, 0, '', NULL, NULL, NULL),
(48360, '2017-10-01 09:16:50', NULL, NULL, 13351, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:16:50', 'admin-1506818470-15068206106592092', 1, 0, '', NULL, NULL, NULL),
(48361, '2017-10-01 09:16:50', NULL, NULL, 13351, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:16:50', 'admin-1506818470-15068206106592092', 1, 1, 'SR', NULL, NULL, NULL),
(48362, '2017-10-01 11:08:11', NULL, NULL, 13365, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:08:11', 'admin-1506825944-15068272912265191', 1, 1, 'SR', NULL, NULL, NULL),
(48363, '2017-10-01 12:00:48', NULL, NULL, 13371, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 12:00:48', 'admin-1506828994-1506830448478815', 1, 0, '', NULL, NULL, NULL),
(48364, '2017-10-01 12:02:14', NULL, NULL, 13371, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 12:02:14', 'admin-1506828994-15068305344442248', 1, 0, '', NULL, NULL, NULL),
(48365, '2017-10-01 12:00:48', NULL, NULL, 13371, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 12:00:48', 'admin-1506828994-1506830448478815', 1, 0, '', NULL, NULL, NULL),
(48366, '2017-10-01 11:38:45', NULL, NULL, 13369, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:38:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48367, '2017-10-01 11:40:48', NULL, NULL, 13370, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:40:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48368, '2017-10-01 11:40:56', NULL, NULL, 13370, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:40:56', 'admin-1506828994-15068292566335364', 1, 0, '', NULL, NULL, NULL),
(48369, '2017-10-01 11:38:50', NULL, NULL, 13369, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:38:50', 'admin-1506828994-15068291299536588', 1, 1, 'SR', NULL, NULL, NULL),
(48370, '2017-10-01 11:18:29', NULL, NULL, 13367, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:18:29', 'admin-1506825944-15068279089854238', 1, 0, '', NULL, NULL, NULL),
(48371, '2017-10-01 11:14:06', NULL, NULL, 13367, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:14:06', 'admin-1506825944-15068276459401498', 1, 1, 'SR', NULL, NULL, NULL),
(48372, '2017-10-01 11:14:06', NULL, NULL, 13367, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:14:06', 'admin-1506825944-15068276459401498', 1, 1, 'SR', NULL, NULL, NULL),
(48373, '2017-10-01 11:14:06', NULL, NULL, 13367, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:14:06', 'admin-1506825944-15068276459401498', 1, 0, '', NULL, NULL, NULL),
(48374, '2017-10-01 11:13:42', NULL, NULL, 13359, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:13:42', 'admin-1506825944-15068276220278347', 1, 1, 'SR', NULL, NULL, '10.0'),
(48375, '2017-10-01 11:40:56', NULL, NULL, 13370, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:40:56', 'admin-1506828994-15068292566335364', 1, 0, '', NULL, NULL, NULL),
(48376, '2017-10-01 11:05:47', NULL, NULL, 13364, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:05:47', 'admin-1506825944-15068271478239086', 1, 1, 'SR', NULL, NULL, NULL),
(48377, '2017-10-01 11:00:22', NULL, NULL, 13363, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 11:00:22', 'admin-1506825944-1506826822424317', 1, 0, '', NULL, NULL, NULL),
(48378, '2017-10-01 10:50:24', NULL, NULL, 13362, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:50:24', 'admin-1506825944-15068262241912521', 1, 1, 'SR', NULL, NULL, NULL),
(48379, '2017-10-01 10:50:24', NULL, NULL, 13362, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:50:24', 'admin-1506825944-15068262241912521', 1, 1, 'SR', NULL, NULL, NULL),
(48380, '2017-10-01 10:50:16', NULL, NULL, 13362, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:50:16', 'admin-1506825944-1506826216376389', 1, 0, '', NULL, NULL, NULL),
(48381, '2017-10-01 10:50:16', NULL, NULL, 13362, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:50:16', 'admin-1506825944-1506826216376389', 1, 1, 'SR', NULL, NULL, NULL),
(48382, '2017-10-01 10:13:34', NULL, NULL, 13355, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:13:34', 'admin-1506818470-15068240146177930', 1, 0, '', NULL, NULL, NULL),
(48383, '2017-10-01 10:49:58', NULL, NULL, 13362, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:49:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48384, '2017-10-01 10:12:46', NULL, NULL, 13355, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:12:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48385, '2017-10-01 15:58:30', NULL, NULL, 13389, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 15:58:30', 'admin-1506837768-15068447103154490', 1, 1, 'SR', 1, NULL, NULL),
(48386, '2017-10-01 15:10:56', NULL, NULL, 13388, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 15:10:56', 'admin-1506837768-15068418567628726', 1, 0, '', NULL, NULL, '10.0'),
(48387, '2017-10-01 14:45:35', NULL, NULL, 13387, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 14:45:35', 'admin-1506837768-15068403352834733', 1, 0, '', NULL, NULL, NULL),
(48388, '2017-10-01 14:45:31', NULL, NULL, 13387, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1506837768', 'admin', '2017-10-01 14:45:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48389, '2017-10-01 10:44:54', NULL, NULL, 13360, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:44:54', 'admin-1506818470-15068258946305919', 1, 0, '', NULL, NULL, NULL),
(48390, '2017-10-01 10:46:03', NULL, NULL, 13360, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:46:03', 'admin-1506825944-15068259637935391', 1, 0, '', NULL, NULL, NULL),
(48391, '2017-10-01 10:44:54', NULL, NULL, 13360, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:44:54', 'admin-1506818470-15068258946305919', 1, 0, '', NULL, NULL, NULL),
(48392, '2017-10-01 10:44:27', NULL, NULL, 13360, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:44:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48393, '2017-10-01 10:38:53', NULL, NULL, 13358, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:38:53', 'admin-1506818470-15068255335023381', 1, 0, '', NULL, NULL, NULL),
(48394, '2017-10-01 15:10:50', NULL, NULL, 13388, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1506837768', 'admin', '2017-10-01 15:10:50', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48395, '2017-10-01 13:59:14', NULL, NULL, 13383, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 13:59:14', 'admin-1506835110-15068375546804798', 1, 0, '', NULL, NULL, NULL),
(48396, '2017-10-01 09:39:17', NULL, NULL, 13352, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:39:17', 'admin-1506818470-15068219573975742', 1, 1, 'SR', NULL, NULL, NULL),
(48397, '2017-10-01 10:42:22', NULL, NULL, 13359, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:42:22', 'admin-1506818470-15068257426787299', 1, 1, 'SR', NULL, NULL, '10.0'),
(48398, '2017-10-01 09:26:07', NULL, NULL, 13348, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:26:07', 'admin-1506818470-15068211672139680', 1, 0, '', NULL, NULL, NULL),
(48399, '2017-10-01 09:52:38', NULL, NULL, 13353, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:52:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48400, '2017-10-01 10:36:42', NULL, NULL, 13357, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:36:42', 'admin-1506818470-15068254023321243', 1, 0, '', NULL, NULL, NULL),
(48401, '2017-10-01 10:42:17', NULL, NULL, 13359, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:42:17', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48402, '2017-10-01 10:36:42', NULL, NULL, 13357, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:36:42', 'admin-1506818470-15068254023321243', 1, 0, '', NULL, NULL, NULL),
(48403, '2017-10-01 10:13:34', NULL, NULL, 13355, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:13:34', 'admin-1506818470-15068240146177930', 1, 1, 'SR', NULL, NULL, NULL),
(48404, '2017-10-01 10:13:34', NULL, NULL, 13355, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:13:34', 'admin-1506818470-15068240146177930', 1, 0, '', NULL, NULL, NULL),
(48405, '2017-10-01 10:24:08', NULL, NULL, 13356, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:24:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48406, '2017-10-01 10:24:16', NULL, NULL, 13356, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:24:16', 'admin-1506818470-15068246558055866', 1, 1, 'SR', NULL, NULL, NULL),
(48407, '2017-10-01 10:13:34', NULL, NULL, 13355, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:13:34', 'admin-1506818470-15068240146177930', 1, 0, '', NULL, NULL, NULL),
(48408, '2017-10-01 10:36:23', NULL, NULL, 13357, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1506837768', 'admin', '2017-10-01 10:36:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48409, '2017-10-01 09:52:45', NULL, NULL, 13353, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:52:45', 'admin-1506818470-1506822765795597', 1, 1, 'SR', NULL, NULL, NULL),
(48410, '2017-10-01 09:52:45', NULL, NULL, 13353, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:52:45', 'admin-1506818470-1506822765795597', 1, 0, '', NULL, NULL, NULL),
(48411, '2017-10-01 09:39:17', NULL, NULL, 13352, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:39:17', 'admin-1506818470-15068219573975742', 1, 1, 'SR', NULL, NULL, NULL),
(48412, '2017-10-01 09:39:17', NULL, NULL, 13352, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:39:17', 'admin-1506818470-15068219573975742', 1, 1, 'SR', NULL, NULL, NULL),
(48413, '2017-10-01 09:38:47', NULL, NULL, 13352, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:38:47', 'admin-1506818470-15068219277566751', 1, 0, '', NULL, NULL, NULL),
(48414, '2017-10-01 09:38:47', NULL, NULL, 13352, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:38:47', 'admin-1506818470-15068219277566751', 1, 0, '', NULL, NULL, NULL),
(48415, '2017-10-01 09:38:47', NULL, NULL, 13352, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:38:47', 'admin-1506818470-15068219277566751', 1, 0, '', NULL, NULL, NULL),
(48416, '2017-10-01 09:26:07', NULL, NULL, 13348, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:26:07', 'admin-1506818470-15068211672139680', 1, 0, '', NULL, NULL, NULL),
(48417, '2017-10-01 09:38:37', NULL, NULL, 13352, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:38:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48418, '2017-10-01 09:26:07', NULL, NULL, 13348, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:26:07', 'admin-1506818470-15068211672139680', 1, 1, 'SR', NULL, NULL, NULL),
(48419, '2017-10-01 09:26:07', NULL, NULL, 13348, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:26:07', 'admin-1506818470-15068211672139680', 1, 1, 'SR', NULL, NULL, NULL),
(48420, '2017-10-01 09:26:07', NULL, NULL, 13348, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:26:07', 'admin-1506818470-15068211672139680', 1, 0, '', NULL, NULL, NULL),
(48421, '2017-10-01 09:26:07', NULL, NULL, 13348, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:26:07', 'admin-1506818470-15068211672139680', 1, 0, '', NULL, NULL, NULL),
(48422, '2017-10-01 09:08:39', NULL, NULL, 13348, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:08:39', 'admin-1506818470-15068201196905210', 1, 0, '', NULL, NULL, NULL),
(48423, '2017-10-01 09:08:39', NULL, NULL, 13348, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:08:39', 'admin-1506818470-15068201196905210', 1, 1, 'SR', NULL, NULL, NULL),
(48424, '2017-10-01 09:08:26', NULL, NULL, 13348, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.70, 0.0000, 0.0000, 9.70, 1, '27', 1, '1506837768', 'admin', '2017-10-01 09:08:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48425, '2017-10-02 11:54:19', NULL, NULL, 13401, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:54:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48426, '2017-10-02 11:54:53', NULL, NULL, 13401, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:54:53', 'admin-1506916470-1506916493432686', 1, 1, 'SR', NULL, NULL, NULL),
(48427, '2017-10-02 11:54:53', NULL, NULL, 13401, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:54:53', 'admin-1506916470-1506916493432686', 1, 1, 'SR', NULL, NULL, NULL),
(48428, '2017-10-02 11:54:53', NULL, NULL, 13401, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:54:53', 'admin-1506916470-1506916493432686', 1, 1, 'SR', NULL, NULL, NULL),
(48429, '2017-10-02 11:58:45', NULL, NULL, 13402, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:58:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48430, '2017-10-02 11:58:52', NULL, NULL, 13402, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:58:52', 'admin-1506916470-15069167319843057', 1, 0, '', NULL, NULL, NULL),
(48431, '2017-10-02 13:56:40', NULL, NULL, 13414, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:56:40', 'admin-1506916470-15069237999527739', 1, 1, 'SR', NULL, NULL, NULL),
(48432, '2017-10-02 11:07:39', NULL, NULL, 13397, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:07:39', 'admin-1506906865-15069136593145377', 1, 0, '', NULL, NULL, NULL),
(48433, '2017-10-02 11:07:39', NULL, NULL, 13397, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:07:39', 'admin-1506906865-15069136593145377', 1, 0, '', NULL, NULL, NULL),
(48434, '2017-10-02 11:07:45', NULL, NULL, 13397, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:07:45', 'admin-1506906865-1506913664842338', 1, 0, '', NULL, NULL, NULL),
(48435, '2017-10-02 14:28:57', NULL, NULL, 13417, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:28:57', 'admin-1506916470-1506925737648532', 1, 1, 'SR', NULL, NULL, NULL),
(48436, '2017-10-02 14:28:57', NULL, NULL, 13417, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:28:57', 'admin-1506916470-1506925737648532', 1, 1, 'SR', NULL, NULL, NULL),
(48437, '2017-10-02 12:25:18', NULL, NULL, 13406, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:25:18', 'admin-1506916470-15069183183622348', 1, 1, 'SR', NULL, NULL, NULL),
(48438, '2017-10-02 12:25:18', NULL, NULL, 13406, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:25:18', 'admin-1506916470-15069183183622348', 1, 0, '', NULL, NULL, NULL),
(48439, '2017-10-02 12:07:17', NULL, NULL, 13403, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:07:17', 'admin-1506916470-15069172377074480', 1, 1, 'SR', NULL, NULL, NULL),
(48440, '2017-10-02 12:10:47', NULL, NULL, 13404, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 4, 12.00, 48.0000, 0.0000, 48.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:10:47', 'admin-1506916470-15069174477394861', 1, 1, 'SR', NULL, NULL, NULL),
(48441, '2017-10-02 12:10:47', NULL, NULL, 13404, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:10:47', 'admin-1506916470-15069174477394861', 1, 0, '', NULL, NULL, NULL),
(48442, '2017-10-02 12:10:47', NULL, NULL, 13404, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:10:47', 'admin-1506916470-15069174477394861', 1, 1, 'SR', NULL, NULL, NULL),
(48443, '2017-10-02 14:32:33', NULL, NULL, 13418, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:32:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48444, '2017-10-02 11:36:30', NULL, NULL, 13399, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:36:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48445, '2017-10-02 11:36:39', NULL, NULL, 13399, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:36:39', 'admin-1506906865-15069153995865099', 1, 0, '', NULL, NULL, NULL),
(48446, '2017-10-02 14:35:56', NULL, NULL, 13411, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:35:56', 'admin-1506916470-15069261566669399', 1, 1, 'SR', NULL, NULL, NULL),
(48447, '2017-10-02 14:53:25', NULL, NULL, 13420, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:53:25', 'admin-1506916470-15069272049815650', 1, 1, 'SR', NULL, NULL, NULL),
(48448, '2017-10-02 15:58:09', NULL, NULL, 13421, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1506916470', 'admin', '2017-10-02 15:58:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48449, '2017-10-02 15:58:24', NULL, NULL, 13421, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 15:58:24', 'admin-1506916470-15069311038247462', 1, 1, 'SR', NULL, NULL, NULL),
(48450, '2017-10-02 15:58:24', NULL, NULL, 13421, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 15:58:24', 'admin-1506916470-15069311038247462', 1, 0, '', NULL, NULL, NULL),
(48451, '2017-10-02 15:58:24', NULL, NULL, 13421, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 15:58:24', 'admin-1506916470-15069311038247462', 1, 0, '', NULL, NULL, NULL),
(48452, '2017-10-02 16:05:29', NULL, NULL, 13422, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1506916470', 'admin', '2017-10-02 16:05:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48453, '2017-10-02 16:05:34', NULL, NULL, 13422, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 16:05:34', 'admin-1506916470-15069315344612084', 1, 1, 'SR', NULL, NULL, NULL),
(48454, '2017-10-02 16:05:34', NULL, NULL, 13422, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 16:05:34', 'admin-1506916470-15069315344612084', 1, 1, 'SR', NULL, NULL, NULL),
(48455, '2017-10-02 14:32:42', NULL, NULL, 13418, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:32:42', 'admin-1506916470-15069259619514692', 1, 0, '', NULL, NULL, NULL),
(48456, '2017-10-02 14:32:42', NULL, NULL, 13418, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:32:42', 'admin-1506916470-15069259619514692', 1, 0, '', NULL, NULL, NULL),
(48457, '2017-10-02 14:41:22', NULL, NULL, 13419, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:41:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48458, '2017-10-02 14:29:19', NULL, NULL, 13415, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:29:19', 'admin-1506916470-15069257588453122', 1, 0, '', NULL, NULL, NULL),
(48459, '2017-10-02 14:53:11', NULL, NULL, 13420, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:53:11', 'admin-1506916470-15069271908492519', 1, 0, '', NULL, NULL, NULL),
(48460, '2017-10-02 14:53:25', NULL, NULL, 13420, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:53:25', 'admin-1506916470-15069272049815650', 1, 0, '', NULL, NULL, NULL),
(48461, '2017-10-02 14:53:25', NULL, NULL, 13420, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:53:25', 'admin-1506916470-15069272049815650', 1, 1, 'SR', NULL, NULL, NULL),
(48462, '2017-10-02 14:19:29', NULL, NULL, 13415, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:19:29', 'admin-1506916470-15069251697262152', 1, 0, '', NULL, NULL, NULL),
(48463, '2017-10-02 14:41:28', NULL, NULL, 13419, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:41:28', 'admin-1506916470-15069264884412594', 1, 1, 'SR', NULL, NULL, NULL),
(48464, '2017-10-02 14:26:41', NULL, NULL, 13416, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:26:41', 'admin-1506916470-15069256015691926', 1, 1, 'SR', NULL, NULL, NULL),
(48465, '2017-10-02 14:26:41', NULL, NULL, 13416, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:26:41', 'admin-1506916470-15069256015691926', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(48466, '2017-10-02 14:28:47', NULL, NULL, 13417, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:28:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48467, '2017-10-02 14:28:57', NULL, NULL, 13417, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:28:57', 'admin-1506916470-1506925737648532', 1, 0, '', NULL, NULL, NULL),
(48468, '2017-10-02 17:14:45', NULL, NULL, 13423, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1506916470', 'admin', '2017-10-02 17:14:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48469, '2017-10-02 14:53:11', NULL, NULL, 13420, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:53:11', 'admin-1506916470-15069271908492519', 1, 0, '', NULL, NULL, NULL),
(48470, '2017-10-02 14:53:11', NULL, NULL, 13420, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:53:11', 'admin-1506916470-15069271908492519', 1, 0, '', NULL, NULL, NULL),
(48471, '2017-10-02 14:41:28', NULL, NULL, 13419, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:41:28', 'admin-1506916470-15069264884412594', 1, 1, 'SR', NULL, NULL, NULL),
(48472, '2017-10-02 14:53:03', NULL, NULL, 13420, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:53:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48473, '2017-10-02 13:54:22', NULL, NULL, 13413, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:54:22', 'admin-1506916470-15069236626415065', 1, 0, '', NULL, NULL, '10.0'),
(48474, '2017-10-02 13:56:02', NULL, NULL, 13414, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:56:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48475, '2017-10-02 13:56:30', NULL, NULL, 13414, 0, 215, '149', 'Thai Fish Sauce Garlic Pork', 'pasta', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:56:30', 'admin-1506916470-15069237902996138', 1, 0, '', NULL, NULL, NULL),
(48476, '2017-10-02 13:56:30', NULL, NULL, 13414, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:56:30', 'admin-1506916470-15069237902996138', 1, 0, '', NULL, NULL, NULL),
(48477, '2017-10-02 13:56:40', NULL, NULL, 13414, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:56:40', 'admin-1506916470-15069237999527739', 1, 1, 'SR', NULL, NULL, NULL),
(48478, '2017-10-02 13:54:14', NULL, NULL, 13413, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:54:14', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48479, '2017-10-02 14:35:56', NULL, NULL, 13411, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:35:56', 'admin-1506916470-15069261566669399', 1, 1, 'SR', NULL, NULL, NULL),
(48480, '2017-10-02 14:35:56', NULL, NULL, 13411, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:35:56', 'admin-1506916470-15069261566669399', 1, 1, 'SR', NULL, NULL, NULL),
(48481, '2017-10-02 14:19:29', NULL, NULL, 13415, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:19:29', 'admin-1506916470-15069251697262152', 1, 1, 'SR', NULL, NULL, NULL),
(48482, '2017-10-02 13:46:55', NULL, NULL, 13412, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:46:55', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48483, '2017-10-02 11:54:53', NULL, NULL, 13401, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:54:53', 'admin-1506916470-1506916493432686', 1, 1, 'SR', NULL, NULL, NULL),
(48484, '2017-10-02 11:54:24', NULL, NULL, 13401, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:54:24', 'admin-1506906865-15069164644582916', 1, 0, '', NULL, NULL, NULL),
(48485, '2017-10-02 11:58:52', NULL, NULL, 13402, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:58:52', 'admin-1506916470-15069167319843057', 1, 0, '', NULL, NULL, NULL),
(48486, '2017-10-02 12:00:43', NULL, NULL, 13400, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:00:43', 'admin-1506916470-15069168433466990', 1, 0, '', NULL, NULL, '10.0'),
(48487, '2017-10-02 12:00:43', NULL, NULL, 13400, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:00:43', 'admin-1506916470-15069168433466990', 1, 0, '', NULL, NULL, '10.0'),
(48488, '2017-10-02 12:07:09', NULL, NULL, 13403, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:07:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48489, '2017-10-02 12:39:52', NULL, NULL, 13408, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:39:52', 'admin-1506916470-15069191924321013', 1, 1, 'SR', NULL, NULL, NULL),
(48490, '2017-10-02 14:32:42', NULL, NULL, 13418, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:32:42', 'admin-1506916470-15069259619514692', 1, 1, 'SR', NULL, NULL, NULL),
(48491, '2017-10-02 14:29:19', NULL, NULL, 13415, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:29:19', 'admin-1506916470-15069257588453122', 1, 1, 'SR', NULL, NULL, NULL),
(48492, '2017-10-02 13:54:22', NULL, NULL, 13413, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:54:22', 'admin-1506916470-15069236626415065', 1, 1, 'SR', NULL, NULL, '10.0'),
(48493, '2017-10-02 13:54:22', NULL, NULL, 13413, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:54:22', 'admin-1506916470-15069236626415065', 1, 1, 'SR', NULL, NULL, '10.0'),
(48494, '2017-10-02 13:14:19', NULL, NULL, 13410, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:14:19', 'admin-1506916470-15069212597294611', 1, 1, 'SR', NULL, NULL, NULL),
(48495, '2017-10-02 13:14:19', NULL, NULL, 13410, 0, 291, '225', 'Smoked Duck Red Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:14:19', 'admin-1506916470-15069212597294611', 1, 0, '', NULL, NULL, NULL),
(48496, '2017-10-02 13:09:58', NULL, NULL, 13409, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:09:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48497, '2017-10-02 13:10:03', NULL, NULL, 13409, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:10:03', 'admin-1506916470-1506921002805333', 1, 1, 'SR', NULL, NULL, NULL),
(48498, '2017-10-02 14:28:57', NULL, NULL, 13417, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:28:57', 'admin-1506916470-1506925737648532', 1, 0, '', NULL, NULL, NULL),
(48499, '2017-10-02 14:19:51', NULL, NULL, 13416, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:19:51', 'admin-1506916470-15069251911263832', 1, 1, 'SR', NULL, NULL, NULL),
(48500, '2017-10-02 14:19:29', NULL, NULL, 13415, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:19:29', 'admin-1506916470-15069251697262152', 1, 1, 'SR', NULL, NULL, NULL),
(48501, '2017-10-02 17:14:49', NULL, NULL, 13423, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 17:14:49', 'admin-1506916470-15069356887836088', 1, 1, 'SR', NULL, NULL, NULL),
(48502, '2017-10-02 14:19:29', NULL, NULL, 13415, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:19:29', 'admin-1506916470-15069251697262152', 1, 1, 'SR', NULL, NULL, NULL),
(48503, '2017-10-02 09:14:43', NULL, NULL, 13391, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:14:43', 'admin-1506906865-15069068831075325', 1, 0, '', NULL, NULL, '10.0'),
(48504, '2017-10-02 09:14:43', NULL, NULL, 13391, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:14:43', 'admin-1506906865-15069068831075325', 1, 0, '', NULL, NULL, '10.0'),
(48505, '2017-10-02 09:14:59', NULL, NULL, 13391, 0, 298, '234', 'Salted Caramel Machiato', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:14:59', 'admin-1506906865-15069068989364672', 1, 0, '', NULL, NULL, '10.0'),
(48506, '2017-10-02 09:15:07', NULL, NULL, 13391, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:15:07', 'admin-1506906865-15069069077112713', 1, 1, 'SR', NULL, NULL, '10.0'),
(48507, '2017-10-02 09:22:30', NULL, NULL, 13392, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:22:30', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48508, '2017-10-02 09:22:47', NULL, NULL, 13392, 0, 181, '116', 'Open Food ', 'junior blt', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:22:47', 'admin-1506906865-15069073670424626', 1, 0, '', NULL, NULL, '10.0'),
(48509, '2017-10-02 09:22:47', NULL, NULL, 13392, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:22:47', 'admin-1506906865-15069073670424626', 1, 1, 'SR', NULL, NULL, '10.0'),
(48510, '2017-10-02 09:25:07', NULL, NULL, 13393, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:25:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48511, '2017-10-02 09:25:14', NULL, NULL, 13393, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:25:14', 'admin-1506906865-1506907514774909', 1, 0, '', NULL, NULL, NULL),
(48512, '2017-10-02 09:25:19', NULL, NULL, 13393, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:25:19', 'admin-1506906865-1506907519581427', 1, 1, 'SR', NULL, NULL, NULL),
(48513, '2017-10-02 14:19:29', NULL, NULL, 13415, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:19:29', 'admin-1506916470-15069251697262152', 1, 1, 'SR', NULL, NULL, NULL),
(48514, '2017-10-02 14:19:11', NULL, NULL, 13415, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:19:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48515, '2017-10-02 13:54:22', NULL, NULL, 13413, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:54:22', 'admin-1506916470-15069236626415065', 1, 0, '', NULL, NULL, '10.0'),
(48516, '2017-10-02 13:17:14', NULL, NULL, 13407, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:17:14', 'admin-1506916470-15069214344709382', 1, 0, '', NULL, NULL, NULL),
(48517, '2017-10-02 13:33:37', NULL, NULL, 13411, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:33:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48518, '2017-10-02 13:47:02', NULL, NULL, 13412, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:47:02', 'admin-1506916470-15069232219503524', 1, 0, '', NULL, NULL, '10.0'),
(48519, '2017-10-02 13:33:47', NULL, NULL, 13411, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:33:47', 'admin-1506916470-15069224274648328', 1, 0, '', NULL, NULL, NULL),
(48520, '2017-10-02 13:34:20', NULL, NULL, 13411, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:34:20', 'admin-1506916470-15069224600696842', 1, 0, '', NULL, NULL, NULL),
(48521, '2017-10-02 13:33:47', NULL, NULL, 13411, 0, 194, '129', 'Deep Fried Chicken Wings', '', 'Meals', 'Snacks ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:33:47', 'admin-1506916470-15069224274648328', 1, 0, '', NULL, NULL, NULL),
(48522, '2017-10-02 13:21:48', NULL, NULL, 13408, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:21:48', 'admin-1506916470-15069217087729817', 1, 0, '', NULL, NULL, NULL),
(48523, '2017-10-02 14:29:19', NULL, NULL, 13415, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:29:19', 'admin-1506916470-15069257588453122', 1, 1, 'SR', NULL, NULL, NULL),
(48524, '2017-10-02 13:14:10', NULL, NULL, 13410, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1506916470', 'admin', '2017-10-02 13:14:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48525, '2017-10-02 12:31:39', NULL, NULL, 13407, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:31:39', 'admin-1506916470-15069186997402215', 1, 1, 'SR', NULL, NULL, NULL),
(48526, '2017-10-02 12:39:41', NULL, NULL, 13408, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:39:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48527, '2017-10-02 12:39:52', NULL, NULL, 13408, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:39:52', 'admin-1506916470-15069191924321013', 1, 1, 'SR', NULL, NULL, NULL),
(48528, '2017-10-02 12:31:32', NULL, NULL, 13407, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:31:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48529, '2017-10-02 12:31:39', NULL, NULL, 13407, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:31:39', 'admin-1506916470-15069186997402215', 1, 0, '', NULL, NULL, NULL),
(48530, '2017-10-02 12:31:39', NULL, NULL, 13407, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:31:39', 'admin-1506916470-15069186997402215', 1, 1, 'SR', NULL, NULL, NULL),
(48531, '2017-10-02 12:25:06', NULL, NULL, 13406, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:25:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48532, '2017-10-02 12:17:51', NULL, NULL, 13398, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:17:51', 'admin-1506916470-15069178713638181', 1, 1, 'SR', NULL, NULL, '10.0'),
(48533, '2017-10-02 12:17:51', NULL, NULL, 13398, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:17:51', 'admin-1506916470-15069178713638181', 1, 1, 'SR', NULL, NULL, '10.0'),
(48534, '2017-10-02 12:21:31', NULL, NULL, 13405, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:21:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48535, '2017-10-02 12:21:45', NULL, NULL, 13405, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:21:45', 'admin-1506916470-15069181057235992', 1, 0, '', NULL, NULL, NULL),
(48536, '2017-10-02 12:21:45', NULL, NULL, 13405, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:21:45', 'admin-1506916470-15069181057235992', 1, 0, '', NULL, NULL, NULL),
(48537, '2017-10-02 12:21:45', NULL, NULL, 13405, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:21:45', 'admin-1506916470-15069181057235992', 1, 1, 'SR', NULL, NULL, NULL),
(48538, '2017-10-02 12:21:45', NULL, NULL, 13405, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:21:45', 'admin-1506916470-15069181057235992', 1, 1, 'SR', NULL, NULL, NULL),
(48539, '2017-10-02 12:22:01', NULL, NULL, 13405, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:22:01', 'admin-1506916470-15069181218083590', 1, 0, '', NULL, NULL, NULL),
(48540, '2017-10-02 12:22:01', NULL, NULL, 13405, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:22:01', 'admin-1506916470-15069181218083590', 1, 0, '', NULL, NULL, NULL),
(48541, '2017-10-02 12:22:01', NULL, NULL, 13405, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:22:01', 'admin-1506916470-15069181218083590', 1, 1, 'SR', NULL, NULL, NULL),
(48542, '2017-10-02 12:10:30', NULL, NULL, 13404, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:10:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48543, '2017-10-02 12:07:17', NULL, NULL, 13403, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 12:07:17', 'admin-1506916470-15069172377074480', 1, 1, 'SR', NULL, NULL, NULL),
(48544, '2017-10-02 11:38:26', NULL, NULL, 13399, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:38:26', 'admin-1506906865-15069155067445971', 1, 0, '', NULL, NULL, NULL),
(48545, '2017-10-02 11:48:54', NULL, NULL, 13400, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:48:54', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48546, '2017-10-02 11:36:39', NULL, NULL, 13399, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:36:39', 'admin-1506906865-15069153995865099', 1, 1, 'SR', NULL, NULL, NULL),
(48547, '2017-10-02 11:38:26', NULL, NULL, 13399, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:38:26', 'admin-1506906865-15069155067445971', 1, 0, '', NULL, NULL, NULL),
(48548, '2017-10-02 11:48:59', NULL, NULL, 13400, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:48:59', 'admin-1506906865-15069161391011053', 1, 1, 'SR', NULL, NULL, '10.0'),
(48549, '2017-10-02 11:48:59', NULL, NULL, 13400, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:48:59', 'admin-1506906865-15069161391011053', 1, 1, 'SR', NULL, NULL, '10.0'),
(48550, '2017-10-02 11:23:22', NULL, NULL, 13398, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:23:22', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48551, '2017-10-02 11:23:29', NULL, NULL, 13398, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:23:29', 'admin-1506906865-1506914609055153', 1, 0, '', NULL, NULL, '10.0'),
(48552, '2017-10-02 11:23:29', NULL, NULL, 13398, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:23:29', 'admin-1506906865-1506914609055153', 1, 0, '', NULL, NULL, '10.0'),
(48553, '2017-10-02 11:31:07', NULL, NULL, 13397, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:31:07', 'admin-1506906865-15069150678083288', 1, 0, '', NULL, NULL, NULL),
(48554, '2017-10-02 09:58:37', NULL, NULL, 13395, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:58:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48555, '2017-10-02 09:58:43', NULL, NULL, 13395, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:58:43', 'admin-1506906865-1506909523135538', 1, 1, 'SR', NULL, NULL, NULL),
(48556, '2017-10-02 09:52:35', NULL, NULL, 13392, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:52:35', 'admin-1506906865-15069091557243078', 1, 1, 'SR', NULL, NULL, '10.0'),
(48557, '2017-10-02 10:07:30', NULL, NULL, 13396, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 10:07:30', 'admin-1506906865-1506910050380532', 1, 1, 'SR', NULL, NULL, NULL),
(48558, '2017-10-02 10:37:04', NULL, NULL, 13396, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 10:37:04', 'admin-1506906865-15069118242538284', 1, 1, 'SR', NULL, NULL, NULL),
(48559, '2017-10-02 11:07:28', NULL, NULL, 13397, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1506916470', 'admin', '2017-10-02 11:07:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48560, '2017-10-02 09:57:47', NULL, NULL, 13394, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:57:47', 'admin-1506906865-15069094677446986', 1, 1, 'SR', NULL, NULL, NULL),
(48561, '2017-10-02 09:57:48', NULL, NULL, 13394, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:57:48', 'admin-1506906865-15069094677446986', 1, 0, '', NULL, NULL, NULL),
(48562, '2017-10-02 14:19:35', NULL, NULL, 13416, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1506916470', 'admin', '2017-10-02 14:19:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48563, '2017-10-02 09:57:47', NULL, NULL, 13394, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:57:47', 'admin-1506906865-15069094677446986', 1, 1, 'SR', NULL, NULL, NULL),
(48564, '2017-10-02 09:57:47', NULL, NULL, 13394, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:57:47', 'admin-1506906865-15069094677446986', 1, 1, 'SR', NULL, NULL, NULL),
(48565, '2017-10-02 09:57:47', NULL, NULL, 13394, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:57:47', 'admin-1506906865-15069094677446986', 1, 1, 'SR', NULL, NULL, NULL),
(48566, '2017-10-02 09:57:25', NULL, NULL, 13394, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:57:25', 'admin-1506906865-15069094458004749', 1, 0, '', NULL, NULL, NULL),
(48567, '2017-10-02 09:57:25', NULL, NULL, 13394, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:57:25', 'admin-1506906865-15069094458004749', 1, 0, '', NULL, NULL, NULL),
(48568, '2017-10-02 09:57:25', NULL, NULL, 13394, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:57:25', 'admin-1506906865-15069094458004749', 1, 0, '', NULL, NULL, NULL),
(48569, '2017-10-02 09:57:17', NULL, NULL, 13394, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.20, 0.0000, 0.0000, 11.20, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:57:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48570, '2017-10-02 10:07:27', NULL, NULL, 13396, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1506916470', 'admin', '2017-10-02 10:07:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48571, '2017-10-02 09:52:35', NULL, NULL, 13392, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:52:35', 'admin-1506906865-15069091557243078', 1, 1, 'SR', NULL, NULL, '10.0'),
(48572, '2017-10-02 09:52:35', NULL, NULL, 13392, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:52:35', 'admin-1506906865-15069091557243078', 1, 1, 'SR', NULL, NULL, '10.0'),
(48573, '2017-10-02 09:14:38', NULL, NULL, 13391, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1506916470', 'admin', '2017-10-02 09:14:38', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48574, '2017-10-04 11:29:26', NULL, NULL, 13425, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 1, 'SR', NULL, NULL, NULL),
(48575, '2017-10-04 11:29:26', NULL, NULL, 13425, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 1, 'SR', NULL, NULL, NULL),
(48576, '2017-10-04 11:29:26', NULL, NULL, 13425, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 1, 'SR', NULL, NULL, NULL),
(48577, '2017-10-04 11:29:26', NULL, NULL, 13425, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 0, '', NULL, NULL, NULL),
(48578, '2017-10-04 11:29:26', NULL, NULL, 13425, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 0, '', NULL, NULL, NULL),
(48579, '2017-10-04 11:29:26', NULL, NULL, 13425, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 0, '', NULL, NULL, NULL),
(48580, '2017-10-04 11:29:26', NULL, NULL, 13425, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 0, '', NULL, NULL, NULL),
(48581, '2017-10-04 11:29:26', NULL, NULL, 13425, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 0, '', NULL, NULL, NULL),
(48582, '2017-10-04 11:29:26', NULL, NULL, 13425, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 0, '', NULL, NULL, NULL),
(48583, '2017-10-04 17:06:10', NULL, NULL, 13451, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1507107061', 'admin', '2017-10-04 17:06:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48584, '2017-10-04 14:57:35', NULL, NULL, 13448, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:57:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48585, '2017-10-04 11:44:57', NULL, NULL, 13429, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:44:57', 'admin-1507079160-15070886970095860', 1, 1, 'SR', NULL, NULL, NULL),
(48586, '2017-10-04 10:27:22', NULL, NULL, 13425, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:22', 'admin-1507079160-15070840422326910', 1, 1, 'SR', NULL, NULL, NULL),
(48587, '2017-10-04 10:27:36', NULL, NULL, 13426, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.90, 0.0000, 0.0000, 11.90, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48588, '2017-10-04 10:28:06', NULL, NULL, 13426, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:28:06', 'admin-1507079160-15070840867983153', 1, 0, '', NULL, NULL, NULL),
(48589, '2017-10-04 13:26:23', NULL, NULL, 13440, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:26:24', 'admin-1507094760-15070947837376894', 1, 1, 'SR', NULL, NULL, NULL),
(48590, '2017-10-04 11:28:30', NULL, NULL, 13428, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:28:30', 'admin-1507079160-15070877101677848', 1, 0, '', NULL, NULL, NULL),
(48591, '2017-10-04 16:56:29', NULL, NULL, 13450, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 16:56:29', 'admin-1507107061-15071073894768217', 1, 0, '', NULL, NULL, NULL),
(48592, '2017-10-04 14:20:52', NULL, NULL, 13445, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:20:52', 'admin-1507094760-15070980524245026', 1, 1, 'SR', NULL, NULL, NULL),
(48593, '2017-10-04 14:20:52', NULL, NULL, 13445, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:20:52', 'admin-1507094760-15070980524245026', 1, 1, 'SR', NULL, NULL, NULL),
(48594, '2017-10-04 14:21:45', NULL, NULL, 13445, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:21:45', 'admin-1507094760-15070981049984186', 1, 0, '', NULL, NULL, NULL),
(48595, '2017-10-04 10:32:16', NULL, NULL, 13427, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:32:16', 'admin-1507079160-15070843358151185', 1, 1, 'SR', NULL, NULL, NULL),
(48596, '2017-10-04 10:32:16', NULL, NULL, 13427, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:32:16', 'admin-1507079160-15070843358151185', 1, 0, '', NULL, NULL, NULL),
(48597, '2017-10-04 10:32:16', NULL, NULL, 13427, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:32:16', 'admin-1507079160-15070843358151185', 1, 1, 'SR', NULL, NULL, NULL),
(48598, '2017-10-04 10:38:18', NULL, NULL, 13427, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:38:18', 'admin-1507079160-15070846983275431', 1, 0, '', NULL, NULL, NULL),
(48599, '2017-10-04 10:38:18', NULL, NULL, 13427, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:38:18', 'admin-1507079160-15070846983275431', 1, 0, '', NULL, NULL, NULL),
(48600, '2017-10-04 15:54:03', NULL, NULL, 13449, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 15:54:03', 'admin-1507094760-15071036432688587', 1, 1, 'SR', NULL, NULL, NULL),
(48601, '2017-10-04 14:57:40', NULL, NULL, 13448, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:57:40', 'admin-1507094760-15071002604985923', 1, 1, 'SR', NULL, NULL, NULL),
(48602, '2017-10-04 13:26:23', NULL, NULL, 13440, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:26:23', 'admin-1507094760-15070947837376894', 1, 0, '', NULL, NULL, NULL),
(48603, '2017-10-04 13:26:23', NULL, NULL, 13440, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:26:23', 'admin-1507094760-15070947837376894', 1, 0, '', NULL, NULL, NULL),
(48604, '2017-10-04 13:25:56', NULL, NULL, 13440, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:25:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48605, '2017-10-04 14:46:51', NULL, NULL, 13443, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:46:51', 'admin-1507094760-1507099611463233', 1, 0, '', NULL, NULL, NULL),
(48606, '2017-10-04 14:35:42', NULL, NULL, 13447, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:35:42', 'admin-1507094760-15070989421402264', 1, 1, 'SR', NULL, NULL, NULL),
(48607, '2017-10-04 14:35:42', NULL, NULL, 13447, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:35:42', 'admin-1507094760-15070989421402264', 1, 1, 'SR', NULL, NULL, NULL),
(48608, '2017-10-04 14:35:42', NULL, NULL, 13447, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:35:42', 'admin-1507094760-15070989421402264', 1, 1, 'SR', NULL, NULL, NULL),
(48609, '2017-10-04 10:27:22', NULL, NULL, 13425, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:22', 'admin-1507079160-15070840422326910', 1, 1, 'SR', NULL, NULL, NULL),
(48610, '2017-10-04 14:04:58', NULL, NULL, 13437, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:04:58', 'admin-1507094760-15070970980495066', 1, 0, '', NULL, NULL, NULL),
(48611, '2017-10-04 14:04:58', NULL, NULL, 13437, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:04:58', 'admin-1507094760-15070970980495066', 1, 0, '', NULL, NULL, NULL),
(48612, '2017-10-04 14:07:02', NULL, NULL, 13442, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:07:02', 'admin-1507094760-15070972226734267', 1, 0, '', NULL, NULL, '10.0'),
(48613, '2017-10-04 17:06:13', NULL, NULL, 13451, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 17:06:13', 'admin-1507107061-15071079734674012', 1, 1, 'SR', NULL, NULL, NULL),
(48614, '2017-10-04 14:35:23', NULL, NULL, 13447, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:35:23', 'admin-1507094760-15070989234269042', 1, 0, '', NULL, NULL, NULL),
(48615, '2017-10-04 10:27:22', NULL, NULL, 13425, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:22', 'admin-1507079160-15070840422326910', 1, 1, 'SR', NULL, NULL, NULL),
(48616, '2017-10-04 13:25:47', NULL, NULL, 13439, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:25:47', 'admin-1507079160-15070947475469530', 1, 1, 'SR', NULL, NULL, NULL),
(48617, '2017-10-04 13:25:47', NULL, NULL, 13439, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:25:47', 'admin-1507079160-15070947475469530', 1, 0, '', NULL, NULL, NULL),
(48618, '2017-10-04 13:25:47', NULL, NULL, 13439, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:25:47', 'admin-1507079160-15070947475469530', 1, 0, '', NULL, NULL, NULL),
(48619, '2017-10-04 13:25:16', NULL, NULL, 13439, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:25:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48620, '2017-10-04 13:24:39', NULL, NULL, 13437, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:24:39', 'admin-1507079160-15070946791901138', 1, 0, '', NULL, NULL, NULL),
(48621, '2017-10-04 13:24:39', NULL, NULL, 13437, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:24:39', 'admin-1507079160-15070946791901138', 1, 0, '', NULL, NULL, NULL),
(48622, '2017-10-04 14:02:33', NULL, NULL, 13435, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:02:33', 'admin-1507094760-15070969528798245', 1, 1, 'SR', NULL, NULL, NULL),
(48623, '2017-10-04 13:24:39', NULL, NULL, 13437, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:24:39', 'admin-1507079160-15070946791901138', 1, 0, '', NULL, NULL, NULL),
(48624, '2017-10-04 13:24:39', NULL, NULL, 13437, 0, 226, '160', 'Cheesy Shepherd Pie', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:24:39', 'admin-1507079160-15070946791901138', 1, 0, '', NULL, NULL, NULL),
(48625, '2017-10-04 14:28:28', NULL, NULL, 13446, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:28:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48626, '2017-10-04 14:28:35', NULL, NULL, 13446, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:28:35', 'admin-1507094760-15070985152822637', 1, 1, 'SR', NULL, NULL, NULL),
(48627, '2017-10-04 13:25:47', NULL, NULL, 13439, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:25:47', 'admin-1507079160-15070947475469530', 1, 1, 'SR', NULL, NULL, NULL),
(48628, '2017-10-04 14:20:43', NULL, NULL, 13445, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.39, 0.0000, 0.0000, 2.39, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:20:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48629, '2017-10-04 14:04:58', NULL, NULL, 13437, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:04:58', 'admin-1507094760-15070970980495066', 1, 1, 'SR', NULL, NULL, NULL),
(48630, '2017-10-04 14:16:16', NULL, NULL, 13444, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:16:16', 'admin-1507094760-15070977761823210', 1, 1, 'SR', NULL, NULL, '10.0'),
(48631, '2017-10-04 14:02:05', NULL, NULL, 13443, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:02:05', 'admin-1507094760-15070969253789550', 1, 0, '', NULL, NULL, NULL),
(48632, '2017-10-04 13:22:38', NULL, NULL, 13438, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:22:38', 'admin-1507079160-15070945582916585', 1, 1, 'SR', NULL, NULL, NULL),
(48633, '2017-10-04 13:22:57', NULL, NULL, 13438, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:22:57', 'admin-1507079160-15070945769707476', 1, 1, 'SR', NULL, NULL, NULL),
(48634, '2017-10-04 13:24:39', NULL, NULL, 13437, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:24:39', 'admin-1507079160-15070946791901138', 1, 1, 'SR', NULL, NULL, NULL),
(48635, '2017-10-04 13:24:39', NULL, NULL, 13437, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:24:39', 'admin-1507079160-15070946791901138', 1, 0, '', NULL, NULL, NULL),
(48636, '2017-10-04 13:20:05', NULL, NULL, 13438, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:20:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48637, '2017-10-04 13:22:38', NULL, NULL, 13438, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:22:38', 'admin-1507079160-15070945582916585', 1, 1, 'SR', NULL, NULL, NULL),
(48638, '2017-10-04 13:22:38', NULL, NULL, 13438, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:22:38', 'admin-1507079160-15070945582916585', 1, 1, 'SR', NULL, NULL, NULL),
(48639, '2017-10-04 13:22:38', NULL, NULL, 13438, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:22:38', 'admin-1507079160-15070945582916585', 1, 1, 'SR', NULL, NULL, NULL),
(48640, '2017-10-04 14:01:24', NULL, NULL, 13443, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.19, 0.0000, 0.0000, 1.19, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:01:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48641, '2017-10-04 13:35:07', NULL, NULL, 13441, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:35:07', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48642, '2017-10-04 15:56:42', NULL, NULL, 13449, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 15:56:42', 'admin-1507094760-15071038018484785', 1, 0, '', NULL, NULL, NULL),
(48643, '2017-10-04 15:58:52', NULL, NULL, 13449, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 15:58:52', 'admin-1507094760-15071039321719223', 1, 1, 'SR', NULL, NULL, NULL),
(48644, '2017-10-04 15:48:30', NULL, NULL, 13444, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 15:48:30', 'admin-1507094760-15071033101668883', 1, 1, 'SR', NULL, NULL, '10.0'),
(48645, '2017-10-04 16:56:29', NULL, NULL, 13450, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 16:56:29', 'admin-1507107061-15071073894768217', 1, 1, 'SR', NULL, NULL, NULL),
(48646, '2017-10-04 15:53:58', NULL, NULL, 13449, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1507107061', 'admin', '2017-10-04 15:53:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48647, '2017-10-04 15:54:03', NULL, NULL, 13449, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 15:54:03', 'admin-1507094760-15071036432688587', 1, 0, '', NULL, NULL, NULL),
(48648, '2017-10-04 13:59:21', NULL, NULL, 13442, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:59:21', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48649, '2017-10-04 13:59:33', NULL, NULL, 13442, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:59:33', 'admin-1507094760-15070967733531080', 1, 1, 'SR', NULL, NULL, '10.0');
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(48650, '2017-10-04 13:59:33', NULL, NULL, 13442, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:59:33', 'admin-1507094760-15070967733531080', 1, 1, 'SR', NULL, NULL, '10.0'),
(48651, '2017-10-04 16:56:23', NULL, NULL, 13450, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 16:56:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48652, '2017-10-04 13:58:10', NULL, NULL, 13437, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:58:10', 'admin-1507094760-15070966898859851', 1, 0, '', NULL, NULL, NULL),
(48653, '2017-10-04 13:36:16', NULL, NULL, 13441, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:36:16', 'admin-1507094760-15070953761151564', 1, 1, 'SR', NULL, NULL, '10.0'),
(48654, '2017-10-04 13:36:16', NULL, NULL, 13441, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:36:16', 'admin-1507094760-15070953761151564', 1, 0, '', NULL, NULL, '10.0'),
(48655, '2017-10-04 13:36:16', NULL, NULL, 13441, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:36:16', 'admin-1507094760-15070953761151564', 1, 0, '', NULL, NULL, '10.0'),
(48656, '2017-10-04 14:16:13', NULL, NULL, 13444, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:16:13', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48657, '2017-10-04 12:30:53', NULL, NULL, 13432, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 12:30:53', 'admin-1507079160-15070914537799584', 1, 0, '', NULL, NULL, NULL),
(48658, '2017-10-04 12:30:53', NULL, NULL, 13432, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 12:30:53', 'admin-1507079160-15070914537799584', 1, 1, 'SR', NULL, NULL, NULL),
(48659, '2017-10-04 12:30:53', NULL, NULL, 13432, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 12:30:53', 'admin-1507079160-15070914537799584', 1, 1, 'SR', NULL, NULL, NULL),
(48660, '2017-10-04 12:30:53', NULL, NULL, 13432, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 12:30:53', 'admin-1507079160-15070914537799584', 1, 1, 'SR', NULL, NULL, NULL),
(48661, '2017-10-04 13:04:22', NULL, NULL, 13435, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:04:22', 'admin-1507079160-1507093462742825', 1, 1, 'SR', NULL, NULL, NULL),
(48662, '2017-10-04 13:04:10', NULL, NULL, 13435, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:04:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48663, '2017-10-04 12:57:04', NULL, NULL, 13431, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 12:57:04', 'admin-1507079160-1507093024508289', 1, 1, 'SR', NULL, NULL, NULL),
(48664, '2017-10-04 15:41:22', NULL, NULL, 13448, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 15:41:22', 'admin-1507094760-15071028818387648', 1, 0, '', NULL, NULL, NULL),
(48665, '2017-10-04 13:13:26', NULL, NULL, 13437, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:13:26', 'admin-1507079160-15070940063735489', 1, 1, 'SR', NULL, NULL, NULL),
(48666, '2017-10-04 13:13:26', NULL, NULL, 13437, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:13:26', 'admin-1507079160-15070940063735489', 1, 0, '', NULL, NULL, NULL),
(48667, '2017-10-04 13:16:12', NULL, NULL, 13436, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:16:12', 'admin-1507079160-15070941718045233', 1, 1, 'SR', NULL, NULL, NULL),
(48668, '2017-10-04 13:13:26', NULL, NULL, 13437, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:13:26', 'admin-1507079160-15070940063735489', 1, 1, 'SR', NULL, NULL, NULL),
(48669, '2017-10-04 11:29:26', NULL, NULL, 13425, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 0, '', NULL, NULL, NULL),
(48670, '2017-10-04 11:29:26', NULL, NULL, 13425, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 1, 'SR', NULL, NULL, NULL),
(48671, '2017-10-04 11:29:26', NULL, NULL, 13425, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 1, 'SR', NULL, NULL, NULL),
(48672, '2017-10-04 11:29:26', NULL, NULL, 13425, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 1, 'SR', NULL, NULL, NULL),
(48673, '2017-10-04 11:29:26', NULL, NULL, 13425, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 1, 'SR', NULL, NULL, NULL),
(48674, '2017-10-04 13:10:23', NULL, NULL, 13432, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:10:23', 'admin-1507079160-15070938234159744', 1, 1, 'SR', NULL, NULL, NULL),
(48675, '2017-10-04 13:13:26', NULL, NULL, 13437, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:13:26', 'admin-1507079160-15070940063735489', 1, 1, 'SR', NULL, NULL, NULL),
(48676, '2017-10-04 13:13:04', NULL, NULL, 13437, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.70, 0.0000, 0.0000, 13.70, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:13:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48677, '2017-10-04 13:05:18', NULL, NULL, 13436, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:05:18', 'admin-1507079160-15070935187844211', 1, 1, 'SR', NULL, NULL, NULL),
(48678, '2017-10-04 11:29:26', NULL, NULL, 13425, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 0, '', NULL, NULL, NULL),
(48679, '2017-10-04 11:40:27', NULL, NULL, 13428, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:40:27', 'admin-1507079160-1507088427639599', 1, 0, '', NULL, NULL, NULL),
(48680, '2017-10-04 11:44:09', NULL, NULL, 13429, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:44:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48681, '2017-10-04 11:44:41', NULL, NULL, 13429, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:44:41', 'admin-1507079160-15070886811068753', 1, 1, 'SR', NULL, NULL, NULL),
(48682, '2017-10-04 11:44:41', NULL, NULL, 13429, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:44:41', 'admin-1507079160-15070886811068753', 1, 1, 'SR', NULL, NULL, NULL),
(48683, '2017-10-04 10:27:22', NULL, NULL, 13425, 0, 75, '75', 'Meatless Aglio Olio ', 'no garlic', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:22', 'admin-1507079160-15070840422326910', 1, 0, '', NULL, NULL, NULL),
(48684, '2017-10-04 13:04:30', NULL, NULL, 13436, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:04:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48685, '2017-10-04 13:01:05', NULL, NULL, 13434, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:01:05', 'admin-1507079160-15070932653229583', 1, 1, 'SR', NULL, NULL, NULL),
(48686, '2017-10-04 12:45:39', NULL, NULL, 13431, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 12:45:39', 'admin-1507079160-15070923393447573', 1, 0, '', NULL, NULL, NULL),
(48687, '2017-10-04 11:28:30', NULL, NULL, 13428, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:28:30', 'admin-1507079160-15070877101677848', 1, 1, 'SR', NULL, NULL, NULL),
(48688, '2017-10-04 10:38:18', NULL, NULL, 13427, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:38:18', 'admin-1507079160-15070846983275431', 1, 1, 'SR', NULL, NULL, NULL),
(48689, '2017-10-04 12:30:54', NULL, NULL, 13432, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 12:30:54', 'admin-1507079160-15070914537799584', 1, 1, 'SR', NULL, NULL, NULL),
(48690, '2017-10-04 10:27:22', NULL, NULL, 13425, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:22', 'admin-1507079160-15070840422326910', 1, 1, 'SR', NULL, NULL, NULL),
(48691, '2017-10-04 10:27:22', NULL, NULL, 13425, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:22', 'admin-1507079160-15070840422326910', 1, 1, 'SR', NULL, NULL, NULL),
(48692, '2017-10-04 10:27:22', NULL, NULL, 13425, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:22', 'admin-1507079160-15070840422326910', 1, 0, '', NULL, NULL, NULL),
(48693, '2017-10-04 10:27:22', NULL, NULL, 13425, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:22', 'admin-1507079160-15070840422326910', 1, 0, '', NULL, NULL, NULL),
(48694, '2017-10-04 13:22:38', NULL, NULL, 13438, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:22:38', 'admin-1507079160-15070945582916585', 1, 0, '', NULL, NULL, NULL),
(48695, '2017-10-04 12:30:22', NULL, NULL, 13432, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.30, 0.0000, 0.0000, 10.30, 1, '27', 1, '1507107061', 'admin', '2017-10-04 12:30:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48696, '2017-10-04 12:30:53', NULL, NULL, 13432, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 12:30:53', 'admin-1507079160-15070914537799584', 1, 0, '', NULL, NULL, NULL),
(48697, '2017-10-04 12:22:25', NULL, NULL, 13430, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 12:22:25', 'admin-1507079160-15070909451097644', 1, 1, 'SR', NULL, NULL, NULL),
(48698, '2017-10-04 12:22:25', NULL, NULL, 13430, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 12:22:25', 'admin-1507079160-15070909451097644', 1, 0, '', NULL, NULL, NULL),
(48699, '2017-10-04 12:22:25', NULL, NULL, 13430, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 12:22:25', 'admin-1507079160-15070909451097644', 1, 1, 'SR', NULL, NULL, NULL),
(48700, '2017-10-04 12:21:56', NULL, NULL, 13431, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 12:21:56', 'admin-1507079160-15070909165357182', 1, 1, 'SR', NULL, NULL, NULL),
(48701, '2017-10-04 12:21:52', NULL, NULL, 13431, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1507107061', 'admin', '2017-10-04 12:21:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48702, '2017-10-04 12:21:39', NULL, NULL, 13430, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 12:21:39', 'admin-1507079160-15070908989569541', 1, 1, 'SR', NULL, NULL, NULL),
(48703, '2017-10-04 12:21:39', NULL, NULL, 13430, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 12:21:39', 'admin-1507079160-15070908989569541', 1, 0, '', NULL, NULL, NULL),
(48704, '2017-10-04 12:21:39', NULL, NULL, 13430, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 12:21:39', 'admin-1507079160-15070908989569541', 1, 1, 'SR', NULL, NULL, NULL),
(48705, '2017-10-04 12:20:51', NULL, NULL, 13430, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1507107061', 'admin', '2017-10-04 12:20:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48706, '2017-10-04 14:35:18', NULL, NULL, 13447, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 14:35:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48707, '2017-10-04 11:56:22', NULL, NULL, 13428, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:56:22', 'admin-1507079160-15070893827446331', 1, 1, 'SR', NULL, NULL, NULL),
(48708, '2017-10-04 11:56:22', NULL, NULL, 13428, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:56:23', 'admin-1507079160-15070893827446331', 1, 1, 'SR', NULL, NULL, NULL),
(48709, '2017-10-04 13:22:38', NULL, NULL, 13438, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:22:38', 'admin-1507079160-15070945582916585', 1, 0, '', NULL, NULL, NULL),
(48710, '2017-10-04 13:26:24', NULL, NULL, 13440, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:26:24', 'admin-1507094760-15070947837376894', 1, 0, '', NULL, NULL, NULL),
(48711, '2017-10-04 11:44:41', NULL, NULL, 13429, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:44:41', 'admin-1507079160-15070886811068753', 1, 0, '', NULL, NULL, NULL),
(48712, '2017-10-04 11:29:26', NULL, NULL, 13425, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 1, 'SR', NULL, NULL, NULL),
(48713, '2017-10-04 13:00:58', NULL, NULL, 13434, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:00:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48714, '2017-10-04 12:48:48', NULL, NULL, 13430, 0, 75, '75', 'Meatless Aglio Olio ', 'Takeaway', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 12:48:48', 'admin-1507079160-1507092528015617', 1, 0, '', NULL, NULL, NULL),
(48715, '2017-10-04 11:29:26', NULL, NULL, 13425, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 0, '', NULL, NULL, NULL),
(48716, '2017-10-04 11:29:26', NULL, NULL, 13425, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 1, 'SR', NULL, NULL, NULL),
(48717, '2017-10-04 11:29:26', NULL, NULL, 13425, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 0, '', NULL, NULL, NULL),
(48718, '2017-10-04 13:05:09', NULL, NULL, 13436, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 13:05:09', 'admin-1507079160-15070935092816513', 1, 1, 'SR', NULL, NULL, NULL),
(48719, '2017-10-04 11:29:26', NULL, NULL, 13425, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 1, 'SR', NULL, NULL, NULL),
(48720, '2017-10-04 11:27:22', NULL, NULL, 13428, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:27:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48721, '2017-10-04 11:29:26', NULL, NULL, 13425, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 1, 'SR', NULL, NULL, NULL),
(48722, '2017-10-04 11:29:26', NULL, NULL, 13425, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 1, 'SR', NULL, NULL, NULL),
(48723, '2017-10-04 11:29:26', NULL, NULL, 13425, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 1, 'SR', NULL, NULL, NULL),
(48724, '2017-10-04 11:29:26', NULL, NULL, 13425, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 1, 'SR', NULL, NULL, NULL),
(48725, '2017-10-04 11:29:26', NULL, NULL, 13425, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 0, '', NULL, NULL, NULL),
(48726, '2017-10-04 11:29:26', NULL, NULL, 13425, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 0, '', NULL, NULL, NULL),
(48727, '2017-10-04 11:29:26', NULL, NULL, 13425, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 1, 'SR', NULL, NULL, NULL),
(48728, '2017-10-04 11:29:26', NULL, NULL, 13425, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 1, 'SR', NULL, NULL, NULL),
(48729, '2017-10-04 11:28:30', NULL, NULL, 13428, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:28:30', 'admin-1507079160-15070877101677848', 1, 1, 'SR', NULL, NULL, NULL),
(48730, '2017-10-04 11:28:30', NULL, NULL, 13428, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:28:30', 'admin-1507079160-15070877101677848', 1, 1, 'SR', NULL, NULL, NULL),
(48731, '2017-10-04 11:29:26', NULL, NULL, 13425, 0, 269, '203', 'Espresso Con Panna', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:29:26', 'admin-1507079160-15070877660046149', 1, 0, '', NULL, NULL, NULL),
(48732, '2017-10-04 11:28:30', NULL, NULL, 13428, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:28:30', 'admin-1507079160-15070877101677848', 1, 1, 'SR', NULL, NULL, NULL),
(48733, '2017-10-04 11:26:08', NULL, NULL, 13427, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:26:08', 'admin-1507079160-15070875684745495', 1, 0, '', NULL, NULL, NULL),
(48734, '2017-10-04 11:12:58', NULL, NULL, 13426, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:12:58', 'admin-1507079160-15070867786592312', 1, 0, '', NULL, NULL, NULL),
(48735, '2017-10-04 11:06:48', NULL, NULL, 13425, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 11:06:48', 'admin-1507079160-15070864086064697', 1, 0, '', NULL, NULL, NULL),
(48736, '2017-10-04 10:38:18', NULL, NULL, 13427, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:38:18', 'admin-1507079160-15070846983275431', 1, 0, '', NULL, NULL, NULL),
(48737, '2017-10-04 10:38:18', NULL, NULL, 13427, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:38:18', 'admin-1507079160-15070846983275431', 1, 0, '', NULL, NULL, NULL),
(48738, '2017-10-04 10:38:18', NULL, NULL, 13427, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:38:18', 'admin-1507079160-15070846983275431', 1, 1, 'SR', NULL, NULL, NULL),
(48739, '2017-10-04 10:38:18', NULL, NULL, 13427, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:38:18', 'admin-1507079160-15070846983275431', 1, 1, 'SR', NULL, NULL, NULL),
(48740, '2017-10-04 10:32:15', NULL, NULL, 13427, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:32:15', 'admin-1507079160-15070843358151185', 1, 0, '', NULL, NULL, NULL),
(48741, '2017-10-04 10:32:16', NULL, NULL, 13427, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:32:16', 'admin-1507079160-15070843358151185', 1, 0, '', NULL, NULL, NULL),
(48742, '2017-10-04 10:32:16', NULL, NULL, 13427, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:32:16', 'admin-1507079160-15070843358151185', 1, 0, '', NULL, NULL, NULL),
(48743, '2017-10-04 10:32:16', NULL, NULL, 13427, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:32:16', 'admin-1507079160-15070843358151185', 1, 1, 'SR', NULL, NULL, NULL),
(48744, '2017-10-04 10:31:14', NULL, NULL, 13427, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 21.80, 0.0000, 0.0000, 21.80, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:31:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48745, '2017-10-04 10:28:26', NULL, NULL, 13426, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:28:26', 'admin-1507079160-15070841063947569', 1, 0, '', NULL, NULL, NULL),
(48746, '2017-10-04 10:28:26', NULL, NULL, 13426, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:28:26', 'admin-1507079160-15070841063947569', 1, 1, 'SR', NULL, NULL, NULL),
(48747, '2017-10-04 10:28:26', NULL, NULL, 13426, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:28:26', 'admin-1507079160-15070841063947569', 1, 0, '', NULL, NULL, NULL),
(48748, '2017-10-04 10:28:07', NULL, NULL, 13426, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:28:07', 'admin-1507079160-15070840867983153', 1, 0, '', NULL, NULL, NULL),
(48749, '2017-10-04 10:28:06', NULL, NULL, 13426, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:28:06', 'admin-1507079160-15070840867983153', 1, 0, '', NULL, NULL, NULL),
(48750, '2017-10-04 10:28:06', NULL, NULL, 13426, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:28:06', 'admin-1507079160-15070840867983153', 1, 0, '', NULL, NULL, NULL),
(48751, '2017-10-04 10:27:22', NULL, NULL, 13425, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:22', 'admin-1507079160-15070840422326910', 1, 0, '', NULL, NULL, NULL),
(48752, '2017-10-04 10:27:22', NULL, NULL, 13425, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:22', 'admin-1507079160-15070840422326910', 1, 0, '', NULL, NULL, NULL),
(48753, '2017-10-04 10:25:42', NULL, NULL, 13425, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 67.80, 0.0000, 0.0000, 67.80, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:25:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48754, '2017-10-04 10:27:22', NULL, NULL, 13425, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:22', 'admin-1507079160-15070840422326910', 1, 0, '', NULL, NULL, NULL),
(48755, '2017-10-04 10:27:22', NULL, NULL, 13425, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:22', 'admin-1507079160-15070840422326910', 1, 0, '', NULL, NULL, NULL),
(48756, '2017-10-04 10:27:22', NULL, NULL, 13425, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:22', 'admin-1507079160-15070840422326910', 1, 0, '', NULL, NULL, NULL),
(48757, '2017-10-04 10:27:22', NULL, NULL, 13425, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:22', 'admin-1507079160-15070840422326910', 1, 0, '', NULL, NULL, NULL),
(48758, '2017-10-04 10:27:22', NULL, NULL, 13425, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:22', 'admin-1507079160-15070840422326910', 1, 0, '', NULL, NULL, NULL),
(48759, '2017-10-04 10:27:22', NULL, NULL, 13425, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:22', 'admin-1507079160-15070840422326910', 1, 0, '', NULL, NULL, NULL),
(48760, '2017-10-04 10:27:22', NULL, NULL, 13425, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:22', 'admin-1507079160-15070840422326910', 1, 1, 'SR', NULL, NULL, NULL),
(48761, '2017-10-04 10:27:22', NULL, NULL, 13425, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:22', 'admin-1507079160-15070840422326910', 1, 0, '', NULL, NULL, NULL),
(48762, '2017-10-04 10:27:22', NULL, NULL, 13425, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:22', 'admin-1507079160-15070840422326910', 1, 0, '', NULL, NULL, NULL),
(48763, '2017-10-04 10:27:22', NULL, NULL, 13425, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:22', 'admin-1507079160-15070840422326910', 1, 0, '', NULL, NULL, NULL),
(48764, '2017-10-04 10:27:22', NULL, NULL, 13425, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:22', 'admin-1507079160-15070840422326910', 1, 0, '', NULL, NULL, NULL),
(48765, '2017-10-04 10:27:22', NULL, NULL, 13425, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 10:27:22', 'admin-1507079160-15070840422326910', 1, 0, '', NULL, NULL, NULL),
(48766, '2017-10-04 09:46:01', NULL, NULL, 13424, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 09:46:01', 'admin-1507079160-1507081561323420', 1, 1, 'SR', NULL, NULL, NULL),
(48767, '2017-10-04 09:46:01', NULL, NULL, 13424, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507107061', 'admin', '2017-10-04 09:46:01', 'admin-1507079160-1507081561323420', 1, 1, 'SR', NULL, NULL, NULL),
(48768, '2017-10-04 09:45:56', NULL, NULL, 13424, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1507107061', 'admin', '2017-10-04 09:45:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48769, '2017-10-05 12:12:24', NULL, NULL, 13465, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 12:12:24', 'admin-1507175503-15071767447351027', 1, 1, 'SR', NULL, NULL, '10.0'),
(48770, '2017-10-05 12:12:24', NULL, NULL, 13465, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 12:12:24', 'admin-1507175503-15071767447351027', 1, 1, 'SR', NULL, NULL, '10.0'),
(48771, '2017-10-05 12:37:40', NULL, NULL, 13466, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.70, 0.0000, 0.0000, 11.70, 1, '27', 1, '1507182289', 'admin', '2017-10-05 12:37:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48772, '2017-10-05 12:38:18', NULL, NULL, 13466, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 12:38:18', 'admin-1507175503-1507178298542390', 1, 1, 'SR', NULL, NULL, NULL),
(48773, '2017-10-05 12:38:18', NULL, NULL, 13466, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 12:38:18', 'admin-1507175503-1507178298542390', 1, 1, 'SR', NULL, NULL, NULL),
(48774, '2017-10-05 12:38:18', NULL, NULL, 13466, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 12:38:18', 'admin-1507175503-1507178298542390', 1, 0, '', NULL, NULL, NULL),
(48775, '2017-10-05 12:38:18', NULL, NULL, 13466, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 12:38:18', 'admin-1507175503-1507178298542390', 1, 0, '', NULL, NULL, NULL),
(48776, '2017-10-05 12:38:18', NULL, NULL, 13466, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 12:38:18', 'admin-1507175503-1507178298542390', 1, 1, 'SR', NULL, NULL, NULL),
(48777, '2017-10-05 12:38:18', NULL, NULL, 13466, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 12:38:18', 'admin-1507175503-1507178298542390', 1, 1, 'SR', NULL, NULL, NULL),
(48778, '2017-10-05 16:52:41', NULL, NULL, 13478, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1507182289', 'admin', '2017-10-05 16:52:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48779, '2017-10-05 16:52:46', NULL, NULL, 13478, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 16:52:46', 'admin-1507182289-15071935660745633', 1, 1, 'SR', NULL, NULL, NULL),
(48780, '2017-10-05 16:52:04', NULL, NULL, 13477, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 16:52:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48781, '2017-10-05 16:52:13', NULL, NULL, 13477, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 16:52:13', 'admin-1507182289-15071935328454146', 1, 1, 'SR', NULL, NULL, NULL),
(48782, '2017-10-05 10:08:57', NULL, NULL, 13456, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:08:57', 'admin-1507167722-15071693375992268', 1, 1, 'SR', NULL, NULL, NULL),
(48783, '2017-10-05 10:24:21', NULL, NULL, 13457, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.60, 0.0000, 0.0000, 14.60, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:24:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48784, '2017-10-05 10:24:31', NULL, NULL, 13457, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:24:31', 'admin-1507167722-15071702717832914', 1, 0, '', NULL, NULL, NULL),
(48785, '2017-10-05 10:24:31', NULL, NULL, 13457, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:24:31', 'admin-1507167722-15071702717832914', 1, 0, '', NULL, NULL, NULL),
(48786, '2017-10-05 10:24:31', NULL, NULL, 13457, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:24:31', 'admin-1507167722-15071702717832914', 1, 0, '', NULL, NULL, NULL),
(48787, '2017-10-05 10:24:31', NULL, NULL, 13457, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:24:31', 'admin-1507167722-15071702717832914', 1, 0, '', NULL, NULL, NULL),
(48788, '2017-10-05 10:28:22', NULL, NULL, 13457, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:28:22', 'admin-1507167722-1507170502476418', 1, 1, 'SR', NULL, NULL, NULL),
(48789, '2017-10-05 10:27:10', NULL, NULL, 13457, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:27:10', 'admin-1507167722-1507170429867224', 1, 1, 'SR', NULL, NULL, NULL),
(48790, '2017-10-05 13:25:32', NULL, NULL, 13471, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:25:32', 'admin-1507175503-15071811326233042', 1, 1, 'SR', NULL, NULL, NULL),
(48791, '2017-10-05 11:39:17', NULL, NULL, 13460, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 11:39:17', 'admin-1507167722-15071747571516569', 1, 0, '', NULL, NULL, NULL),
(48792, '2017-10-05 11:39:30', NULL, NULL, 13460, 0, 182, '117', 'Open Drinks ', 'scone', 'Cold Drinks', 'Fresh Juice', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 11:39:30', 'admin-1507167722-15071747706127272', 1, 0, '', NULL, NULL, NULL),
(48793, '2017-10-05 11:40:58', NULL, NULL, 13463, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1507182289', 'admin', '2017-10-05 11:40:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48794, '2017-10-05 11:41:14', NULL, NULL, 13463, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 11:41:14', 'admin-1507167722-15071748742838197', 1, 1, 'SR', NULL, NULL, NULL),
(48795, '2017-10-05 11:41:14', NULL, NULL, 13463, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 11:41:14', 'admin-1507167722-15071748742838197', 1, 1, 'SR', NULL, NULL, NULL),
(48796, '2017-10-05 11:50:49', NULL, NULL, 13464, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1507182289', 'admin', '2017-10-05 11:50:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48797, '2017-10-05 11:52:31', NULL, NULL, 13464, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 11:52:31', 'admin-1507175503-15071755513165381', 1, 1, 'SR', NULL, NULL, NULL),
(48798, '2017-10-05 12:50:45', NULL, NULL, 13467, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 12:50:45', 'admin-1507175503-15071790448254458', 1, 0, '', NULL, NULL, NULL),
(48799, '2017-10-05 14:07:28', NULL, NULL, 13475, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 14:07:28', 'admin-1507182289-15071836487021694', 1, 1, 'SR', NULL, NULL, NULL),
(48800, '2017-10-05 13:47:49', NULL, NULL, 13473, 0, 181, '116', 'Open Food ', 'pan fried dumnpling 5s', 'Meals', 'Perfect Meals', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:47:49', 'admin-1507182289-15071824689641168', 1, 0, '', NULL, NULL, '10.0'),
(48801, '2017-10-05 13:15:17', NULL, NULL, 13468, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:15:17', 'admin-1507175503-15071805177787827', 1, 0, '', NULL, NULL, '10.0'),
(48802, '2017-10-05 13:12:33', NULL, NULL, 13469, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:12:33', 'admin-1507175503-1507180352930856', 1, 1, 'SR', NULL, NULL, NULL),
(48803, '2017-10-05 13:18:13', NULL, NULL, 13470, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:18:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48804, '2017-10-05 13:19:41', NULL, NULL, 13470, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:19:41', 'admin-1507175503-15071807817228667', 1, 1, 'SR', NULL, NULL, NULL),
(48805, '2017-10-05 13:19:41', NULL, NULL, 13470, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:19:41', 'admin-1507175503-15071807817228667', 1, 0, '', NULL, NULL, NULL),
(48806, '2017-10-05 13:19:41', NULL, NULL, 13470, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 2, 11.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:19:41', 'admin-1507175503-15071807817228667', 1, 0, '', NULL, NULL, NULL),
(48807, '2017-10-05 14:02:12', NULL, NULL, 13474, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 14:02:12', 'admin-1507182289-15071833322244765', 1, 1, 'SR', 1, NULL, NULL),
(48808, '2017-10-05 13:26:07', NULL, NULL, 13472, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:26:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48809, '2017-10-05 13:26:10', NULL, NULL, 13472, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:26:10', 'admin-1507175503-15071811703062020', 1, 0, '', NULL, NULL, NULL),
(48810, '2017-10-05 10:31:35', NULL, NULL, 13458, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:31:35', 'admin-1507167722-15071706953931319', 1, 0, '', NULL, NULL, NULL),
(48811, '2017-10-05 10:48:33', NULL, NULL, 13459, 0, 181, '116', 'Open Food ', ' bacon sausage,scrambled egg', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:48:33', 'admin-1507167722-1507171712852738', 1, 0, '', NULL, NULL, '10.0'),
(48812, '2017-10-05 10:57:44', NULL, NULL, 13460, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:57:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48813, '2017-10-05 10:57:57', NULL, NULL, 13460, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:57:57', 'admin-1507167722-15071722770797399', 1, 1, 'SR', NULL, NULL, NULL),
(48814, '2017-10-05 12:38:18', NULL, NULL, 13466, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 12:38:18', 'admin-1507175503-1507178298542390', 1, 1, 'SR', NULL, NULL, NULL),
(48815, '2017-10-05 12:38:18', NULL, NULL, 13466, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 12:38:18', 'admin-1507175503-1507178298542390', 1, 1, 'SR', NULL, NULL, NULL),
(48816, '2017-10-05 11:21:34', NULL, NULL, 13462, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 11:21:34', 'admin-1507167722-1507173694343757', 1, 1, 'SR', NULL, NULL, NULL),
(48817, '2017-10-05 09:17:56', NULL, NULL, 13453, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:17:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48818, '2017-10-05 09:18:01', NULL, NULL, 13453, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:18:01', 'admin-1507164843-1507166281507329', 1, 1, 'SR', NULL, NULL, NULL),
(48819, '2017-10-05 09:38:48', NULL, NULL, 13453, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:38:48', 'admin-1507164843-1507167528465345', 1, 0, '', NULL, NULL, NULL),
(48820, '2017-10-05 09:38:50', NULL, NULL, 13454, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 27.10, 0.0000, 0.0000, 27.10, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:38:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48821, '2017-10-05 16:52:13', NULL, NULL, 13477, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 16:52:13', 'admin-1507182289-15071935328454146', 1, 1, 'SR', NULL, NULL, NULL),
(48822, '2017-10-05 14:51:26', NULL, NULL, 13476, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 14:51:26', 'admin-1507182289-15071862867223666', 1, 1, 'SR', NULL, NULL, '10.0'),
(48823, '2017-10-05 09:16:55', NULL, NULL, 13452, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.00, 0.0000, 0.0000, 14.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:16:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48824, '2017-10-05 09:17:03', NULL, NULL, 13452, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:17:03', 'admin-1507164843-15071662232253479', 1, 0, '', NULL, NULL, NULL),
(48825, '2017-10-05 09:17:03', NULL, NULL, 13452, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:17:03', 'admin-1507164843-15071662232253479', 1, 0, '', NULL, NULL, NULL),
(48826, '2017-10-05 09:17:03', NULL, NULL, 13452, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:17:03', 'admin-1507164843-15071662232253479', 1, 0, '', NULL, NULL, NULL),
(48827, '2017-10-05 09:17:03', NULL, NULL, 13452, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:17:03', 'admin-1507164843-15071662232253479', 1, 0, '', NULL, NULL, NULL),
(48828, '2017-10-05 14:52:54', NULL, NULL, 13476, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 14:52:54', 'admin-1507182289-15071863742342790', 1, 1, 'SR', NULL, NULL, '10.0'),
(48829, '2017-10-05 14:07:28', NULL, NULL, 13475, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 14:07:28', 'admin-1507182289-15071836487021694', 1, 0, '', NULL, NULL, NULL),
(48830, '2017-10-05 14:07:28', NULL, NULL, 13475, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 14:07:28', 'admin-1507182289-15071836487021694', 1, 0, '', NULL, NULL, NULL),
(48831, '2017-10-05 14:07:28', NULL, NULL, 13475, 0, 270, '204', 'Homemade Savoury Pancake', 'pancake change toast', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 14:07:28', 'admin-1507182289-15071836487021694', 1, 0, '', NULL, NULL, NULL),
(48832, '2017-10-05 14:51:21', NULL, NULL, 13476, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1507182289', 'admin', '2017-10-05 14:51:21', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48833, '2017-10-05 14:07:06', NULL, NULL, 13475, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1507182289', 'admin', '2017-10-05 14:07:06', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(48834, '2017-10-05 13:54:55', NULL, NULL, 13468, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:54:55', 'admin-1507182289-15071828957249383', 1, 1, 'SR', NULL, NULL, '10.0'),
(48835, '2017-10-05 13:47:54', NULL, NULL, 13473, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:47:54', 'admin-1507182289-15071824747359248', 1, 1, 'SR', NULL, NULL, '10.0'),
(48836, '2017-10-05 13:47:49', NULL, NULL, 13473, 0, 272, '206', 'Genius in The Bowl', 'add chili', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:47:49', 'admin-1507182289-15071824689641168', 1, 0, '', NULL, NULL, '10.0'),
(48837, '2017-10-05 13:47:49', NULL, NULL, 13473, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:47:49', 'admin-1507182289-15071824689641168', 1, 1, 'SR', NULL, NULL, '10.0'),
(48838, '2017-10-05 13:39:53', NULL, NULL, 13473, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:39:53', 'admin-1507175503-15071819937151250', 1, 1, 'SR', NULL, NULL, '10.0'),
(48839, '2017-10-05 13:39:47', NULL, NULL, 13473, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:39:47', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48840, '2017-10-05 10:31:19', NULL, NULL, 13458, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.10, 0.0000, 0.0000, 10.10, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:31:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48841, '2017-10-05 09:39:51', NULL, NULL, 13454, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:39:51', 'admin-1507164843-15071675914762220', 1, 1, 'SR', NULL, NULL, NULL),
(48842, '2017-10-05 09:45:06', NULL, NULL, 13453, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:45:06', 'admin-1507167722-15071679064813050', 1, 1, 'SR', NULL, NULL, NULL),
(48843, '2017-10-05 09:45:06', NULL, NULL, 13453, 0, 153, '87', 'Wake Me Up!', 'ex bacon,no sausage', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:45:06', 'admin-1507167722-15071679064813050', 1, 0, '', NULL, NULL, NULL),
(48844, '2017-10-05 14:07:28', NULL, NULL, 13475, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 14:07:28', 'admin-1507182289-15071836487021694', 1, 0, '', NULL, NULL, NULL),
(48845, '2017-10-05 13:25:28', NULL, NULL, 13471, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:25:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48846, '2017-10-05 13:12:47', NULL, NULL, 13468, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:12:47', 'admin-1507175503-15071803669593619', 1, 1, 'SR', NULL, NULL, '10.0'),
(48847, '2017-10-05 13:12:28', NULL, NULL, 13469, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:12:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48848, '2017-10-05 13:08:00', NULL, NULL, 13468, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:08:00', 'admin-1507175503-15071800802673951', 1, 1, 'SR', NULL, NULL, '10.0'),
(48849, '2017-10-05 14:30:49', NULL, NULL, 13475, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 14:30:49', 'admin-1507182289-15071850492204265', 1, 0, '', NULL, NULL, NULL),
(48850, '2017-10-05 13:08:00', NULL, NULL, 13468, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:08:00', 'admin-1507175503-15071800802673951', 1, 1, 'SR', NULL, NULL, '10.0'),
(48851, '2017-10-05 12:49:30', NULL, NULL, 13467, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1507182289', 'admin', '2017-10-05 12:49:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48852, '2017-10-05 12:50:45', NULL, NULL, 13467, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 12:50:45', 'admin-1507175503-15071790448254458', 1, 1, 'SR', NULL, NULL, NULL),
(48853, '2017-10-05 12:38:18', NULL, NULL, 13466, 0, 181, '116', 'Open Food ', 'scones', 'Meals', 'Perfect Meals', 1, 24.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 12:38:18', 'admin-1507175503-1507178298542390', 1, 0, '', NULL, NULL, NULL),
(48854, '2017-10-05 12:08:49', NULL, NULL, 13465, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 12:08:49', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48855, '2017-10-05 10:31:35', NULL, NULL, 13458, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:31:35', 'admin-1507167722-15071706953931319', 1, 1, 'SR', NULL, NULL, NULL),
(48856, '2017-10-05 13:08:00', NULL, NULL, 13468, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:08:00', 'admin-1507175503-15071800802673951', 1, 0, '', NULL, NULL, '10.0'),
(48857, '2017-10-05 11:51:36', NULL, NULL, 13464, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 11:51:36', 'admin-1507167722-15071754926769496', 1, 0, '', NULL, NULL, NULL),
(48858, '2017-10-05 11:21:06', NULL, NULL, 13462, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1507182289', 'admin', '2017-10-05 11:21:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48859, '2017-10-05 11:21:34', NULL, NULL, 13462, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 11:21:34', 'admin-1507167722-1507173694343757', 1, 0, '', NULL, NULL, NULL),
(48860, '2017-10-05 10:31:35', NULL, NULL, 13458, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:31:35', 'admin-1507167722-15071706953931319', 1, 1, 'SR', NULL, NULL, NULL),
(48861, '2017-10-05 13:07:45', NULL, NULL, 13468, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:07:45', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48862, '2017-10-05 13:08:00', NULL, NULL, 13468, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 13:08:00', 'admin-1507175503-15071800802673951', 1, 1, 'SR', NULL, NULL, '10.0'),
(48863, '2017-10-05 10:31:35', NULL, NULL, 13458, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:31:35', 'admin-1507167722-15071706953931319', 1, 1, 'SR', NULL, NULL, NULL),
(48864, '2017-10-05 10:27:10', NULL, NULL, 13457, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:27:10', 'admin-1507167722-1507170429867224', 1, 1, 'SR', NULL, NULL, NULL),
(48865, '2017-10-05 10:31:35', NULL, NULL, 13458, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:31:35', 'admin-1507167722-15071706953931319', 1, 1, 'SR', NULL, NULL, NULL),
(48866, '2017-10-05 10:31:35', NULL, NULL, 13458, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:31:35', 'admin-1507167722-15071706953931319', 1, 0, '', NULL, NULL, NULL),
(48867, '2017-10-05 10:31:35', NULL, NULL, 13458, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:31:35', 'admin-1507167722-15071706953931319', 1, 0, '', NULL, NULL, NULL),
(48868, '2017-10-05 10:31:35', NULL, NULL, 13458, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:31:35', 'admin-1507167722-15071706953931319', 1, 0, '', NULL, NULL, NULL),
(48869, '2017-10-05 10:27:10', NULL, NULL, 13457, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:27:10', 'admin-1507167722-1507170429867224', 1, 0, '', NULL, NULL, NULL),
(48870, '2017-10-05 10:27:10', NULL, NULL, 13457, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:27:10', 'admin-1507167722-1507170429867224', 1, 0, '', NULL, NULL, NULL),
(48871, '2017-10-05 10:27:10', NULL, NULL, 13457, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:27:10', 'admin-1507167722-1507170429867224', 1, 0, '', NULL, NULL, NULL),
(48872, '2017-10-05 10:27:10', NULL, NULL, 13457, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:27:10', 'admin-1507167722-1507170429867224', 1, 1, 'SR', NULL, NULL, NULL),
(48873, '2017-10-05 09:39:22', NULL, NULL, 13454, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:39:22', 'admin-1507164843-15071675626888825', 1, 0, '', NULL, NULL, NULL),
(48874, '2017-10-05 10:07:32', NULL, NULL, 13454, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:07:32', 'admin-1507167722-15071692526959675', 1, 0, '', NULL, NULL, NULL),
(48875, '2017-10-05 10:08:54', NULL, NULL, 13456, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:08:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48876, '2017-10-05 10:08:57', NULL, NULL, 13456, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:08:57', 'admin-1507167722-15071693375992268', 1, 1, 'SR', NULL, NULL, NULL),
(48877, '2017-10-05 10:08:57', NULL, NULL, 13456, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:08:57', 'admin-1507167722-15071693375992268', 1, 1, 'SR', NULL, NULL, NULL),
(48878, '2017-10-05 09:59:58', NULL, NULL, 13455, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:59:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48879, '2017-10-05 10:03:31', NULL, NULL, 13455, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:03:31', 'admin-1507167722-15071690116021640', 1, 0, '', NULL, NULL, NULL),
(48880, '2017-10-05 10:00:08', NULL, NULL, 13455, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:00:08', 'admin-1507167722-15071688085053847', 1, 1, 'SR', NULL, NULL, NULL),
(48881, '2017-10-05 10:00:05', NULL, NULL, 13455, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:00:05', 'admin-1507167722-15071688050275426', 1, 0, '', NULL, NULL, NULL),
(48882, '2017-10-05 09:39:51', NULL, NULL, 13454, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:39:51', 'admin-1507164843-15071675914762220', 1, 1, 'SR', NULL, NULL, NULL),
(48883, '2017-10-05 09:39:51', NULL, NULL, 13454, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:39:51', 'admin-1507164843-15071675914762220', 1, 1, 'SR', NULL, NULL, NULL),
(48884, '2017-10-05 09:39:51', NULL, NULL, 13454, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:39:51', 'admin-1507164843-15071675914762220', 1, 1, 'SR', NULL, NULL, NULL),
(48885, '2017-10-05 09:39:51', NULL, NULL, 13454, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:39:51', 'admin-1507164843-15071675914762220', 1, 0, '', NULL, NULL, NULL),
(48886, '2017-10-05 09:39:51', NULL, NULL, 13454, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:39:51', 'admin-1507164843-15071675914762220', 1, 1, 'SR', NULL, NULL, NULL),
(48887, '2017-10-05 09:39:51', NULL, NULL, 13454, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:39:51', 'admin-1507164843-15071675914762220', 1, 1, 'SR', NULL, NULL, NULL),
(48888, '2017-10-05 09:39:22', NULL, NULL, 13454, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:39:22', 'admin-1507164843-15071675626888825', 1, 1, 'SR', NULL, NULL, NULL),
(48889, '2017-10-05 09:39:22', NULL, NULL, 13454, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:39:22', 'admin-1507164843-15071675626888825', 1, 1, 'SR', NULL, NULL, NULL),
(48890, '2017-10-05 09:39:22', NULL, NULL, 13454, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:39:22', 'admin-1507164843-15071675626888825', 1, 0, '', NULL, NULL, NULL),
(48891, '2017-10-05 09:39:22', NULL, NULL, 13454, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:39:22', 'admin-1507164843-15071675626888825', 1, 0, '', NULL, NULL, NULL),
(48892, '2017-10-05 09:39:22', NULL, NULL, 13454, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:39:22', 'admin-1507164843-15071675626888825', 1, 0, '', NULL, NULL, NULL),
(48893, '2017-10-05 09:39:22', NULL, NULL, 13454, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:39:22', 'admin-1507164843-15071675626888825', 1, 0, '', NULL, NULL, NULL),
(48894, '2017-10-05 09:39:22', NULL, NULL, 13454, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:39:22', 'admin-1507164843-15071675626888825', 1, 0, '', NULL, NULL, NULL),
(48895, '2017-10-05 09:39:22', NULL, NULL, 13454, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:39:22', 'admin-1507164843-15071675626888825', 1, 0, '', NULL, NULL, NULL),
(48896, '2017-10-05 09:17:36', NULL, NULL, 13452, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:17:36', 'admin-1507164843-15071662561817647', 1, 0, '', NULL, NULL, NULL),
(48897, '2017-10-05 09:17:36', NULL, NULL, 13452, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:17:36', 'admin-1507164843-15071662561817647', 1, 1, 'SR', NULL, NULL, NULL),
(48898, '2017-10-05 09:17:51', NULL, NULL, 13452, 0, 182, '117', 'Open Drinks ', 'scone', 'Cold Drinks', 'Fresh Juice', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:17:51', 'admin-1507164843-15071662710999880', 1, 0, '', NULL, NULL, NULL),
(48899, '2017-10-05 10:48:15', NULL, NULL, 13459, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1507182289', 'admin', '2017-10-05 10:48:15', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48900, '2017-10-05 09:17:36', NULL, NULL, 13452, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:17:36', 'admin-1507164843-15071662561817647', 1, 1, 'SR', NULL, NULL, NULL),
(48901, '2017-10-05 09:17:36', NULL, NULL, 13452, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:17:36', 'admin-1507164843-15071662561817647', 1, 1, 'SR', NULL, NULL, NULL),
(48902, '2017-10-05 09:17:36', NULL, NULL, 13452, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:17:36', 'admin-1507164843-15071662561817647', 1, 1, 'SR', NULL, NULL, NULL),
(48903, '2017-10-05 09:17:03', NULL, NULL, 13452, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507182289', 'admin', '2017-10-05 09:17:03', 'admin-1507164843-15071662232253479', 1, 0, '', NULL, NULL, NULL),
(48904, '2017-10-06 14:22:20', NULL, NULL, 13495, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1507269351', 'admin', '2017-10-06 14:22:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48905, '2017-10-06 14:22:26', NULL, NULL, 13495, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 14:22:26', 'admin-1507269351-15072709457759755', 1, 1, 'SR', NULL, NULL, NULL),
(48906, '2017-10-06 14:22:26', NULL, NULL, 13495, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 14:22:26', 'admin-1507269351-15072709457759755', 1, 1, 'SR', NULL, NULL, NULL),
(48907, '2017-10-06 00:00:00', NULL, NULL, 13496, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:49:24', 'admin-1507257843-15072689646812054', 1, 0, '', NULL, NULL, NULL),
(48908, '2017-10-06 00:00:00', NULL, NULL, 13497, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, NULL, NULL, 6.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:14:07', 'admin-1507257843-15072668474812615', 1, 1, 'SR', NULL, NULL, NULL),
(48909, '2017-10-06 00:00:00', NULL, NULL, 13498, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:49:24', 'admin-1507257843-15072689646812054', 1, 1, 'SR', NULL, NULL, NULL),
(48910, '2017-10-06 00:00:00', NULL, NULL, 13499, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:49:24', 'admin-1507257843-15072689646812054', 1, 0, '', NULL, NULL, NULL),
(48911, '2017-10-06 00:00:00', NULL, NULL, 13500, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:49:24', 'admin-1507257843-15072689646812054', 1, 1, 'SR', NULL, NULL, NULL),
(48912, '2017-10-06 15:20:26', NULL, NULL, 13501, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 15:20:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48913, '2017-10-06 11:54:39', NULL, NULL, 13488, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 11:54:39', 'admin-1507257843-15072620795214749', 1, 1, 'SR', NULL, NULL, NULL),
(48914, '2017-10-06 11:54:39', NULL, NULL, 13488, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 11:54:39', 'admin-1507257843-15072620795214749', 1, 1, 'SR', NULL, NULL, NULL),
(48915, '2017-10-06 12:45:59', NULL, NULL, 13489, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 12:45:59', 'admin-1507257843-15072651590012965', 1, 1, 'SR', 1, NULL, NULL),
(48916, '2017-10-06 15:50:05', NULL, NULL, 13504, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 15:50:05', 'admin-1507269351-15072762051877538', 1, 0, '', NULL, NULL, NULL),
(48917, '2017-10-06 13:54:47', NULL, NULL, 13493, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:54:47', 'admin-1507257843-15072692872371656', 1, 1, 'SR', NULL, NULL, NULL),
(48918, '2017-10-06 13:33:10', NULL, NULL, 13491, 0, 211, '145', 'Asian Spicy Lemony Chicken', 'less spicy', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:33:10', 'admin-1507257843-15072679907838919', 1, 0, '', NULL, NULL, NULL),
(48919, '2017-10-06 13:33:24', NULL, NULL, 13491, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:33:24', 'admin-1507257843-15072680043591491', 1, 1, 'SR', NULL, NULL, NULL),
(48920, '2017-10-06 13:33:24', NULL, NULL, 13491, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:33:24', 'admin-1507257843-15072680043591491', 1, 1, 'SR', NULL, NULL, NULL),
(48921, '2017-10-06 13:42:20', NULL, NULL, 13492, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:42:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48922, '2017-10-06 13:42:28', NULL, NULL, 13492, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:42:28', 'admin-1507257843-15072685485644934', 1, 0, '', NULL, NULL, NULL),
(48923, '2017-10-06 13:42:28', NULL, NULL, 13492, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:42:28', 'admin-1507257843-15072685485644934', 1, 1, 'SR', NULL, NULL, NULL),
(48924, '2017-10-06 13:42:28', NULL, NULL, 13492, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:42:28', 'admin-1507257843-15072685485644934', 1, 1, 'SR', NULL, NULL, NULL),
(48925, '2017-10-06 15:20:30', NULL, NULL, 13501, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 15:20:30', 'admin-1507269351-15072744304975291', 1, 1, 'SR', NULL, NULL, NULL),
(48926, '2017-10-06 15:20:30', NULL, NULL, 13501, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 15:20:30', 'admin-1507269351-15072744304975291', 1, 1, 'SR', NULL, NULL, NULL),
(48927, '2017-10-06 15:39:58', NULL, NULL, 13503, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 15:39:58', 'admin-1507269351-15072755984865217', 1, 0, '', NULL, NULL, NULL),
(48928, '2017-10-06 15:39:58', NULL, NULL, 13503, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 15:39:58', 'admin-1507269351-15072755984865217', 1, 1, 'SR', NULL, NULL, NULL),
(48929, '2017-10-06 15:32:56', NULL, NULL, 13502, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 15:32:56', 'admin-1507269351-15072751763812384', 1, 1, 'SR', NULL, NULL, NULL),
(48930, '2017-10-06 15:39:51', NULL, NULL, 13503, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1507269351', 'admin', '2017-10-06 15:39:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48931, '2017-10-06 15:39:58', NULL, NULL, 13503, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 15:39:58', 'admin-1507269351-15072755984865217', 1, 0, '', NULL, NULL, NULL),
(48932, '2017-10-06 00:00:00', NULL, NULL, 13496, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:30:07', 'admin-1507257843-15072678072237864', 1, 0, '', NULL, NULL, NULL),
(48933, '2017-10-06 00:00:00', NULL, NULL, 13500, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, NULL, NULL, 2.60, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:14:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48934, '2017-10-06 11:54:32', NULL, NULL, 13488, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1507269351', 'admin', '2017-10-06 11:54:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48935, '2017-10-06 09:42:58', NULL, NULL, 13482, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 09:42:58', 'admin-1507197410-15072541783482391', 1, 0, '', NULL, NULL, NULL),
(48936, '2017-10-06 09:42:58', NULL, NULL, 13482, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 09:42:58', 'admin-1507197410-15072541783482391', 1, 1, 'SR', NULL, NULL, NULL),
(48937, '2017-10-06 10:08:57', NULL, NULL, 13483, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1507269351', 'admin', '2017-10-06 10:08:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48938, '2017-10-06 10:18:37', NULL, NULL, 13485, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 10:18:37', 'admin-1507197410-15072563173272447', 1, 1, 'SR', NULL, NULL, NULL),
(48939, '2017-10-06 10:18:37', NULL, NULL, 13485, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 10:18:37', 'admin-1507197410-15072563173272447', 1, 1, 'SR', NULL, NULL, NULL),
(48940, '2017-10-06 10:18:37', NULL, NULL, 13485, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 10:18:37', 'admin-1507197410-15072563173272447', 1, 0, '', NULL, NULL, NULL),
(48941, '2017-10-06 10:40:55', NULL, NULL, 13486, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.90, 0.0000, 0.0000, 12.90, 1, '27', 1, '1507269351', 'admin', '2017-10-06 10:40:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48942, '2017-10-06 09:40:28', NULL, NULL, 13481, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 09:40:28', 'admin-1507197410-15072540284857759', 1, 1, 'SR', NULL, NULL, NULL),
(48943, '2017-10-06 09:40:28', NULL, NULL, 13481, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 09:40:28', 'admin-1507197410-15072540284857759', 1, 0, '', NULL, NULL, NULL),
(48944, '2017-10-06 09:40:28', NULL, NULL, 13481, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 09:40:28', 'admin-1507197410-15072540284857759', 1, 0, '', NULL, NULL, NULL),
(48945, '2017-10-06 09:42:46', NULL, NULL, 13482, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1507269351', 'admin', '2017-10-06 09:42:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48946, '2017-10-06 09:42:58', NULL, NULL, 13482, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 09:42:58', 'admin-1507197410-15072541783482391', 1, 0, '', NULL, NULL, NULL),
(48947, '2017-10-06 09:42:58', NULL, NULL, 13482, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 09:42:58', 'admin-1507197410-15072541783482391', 1, 0, '', NULL, NULL, NULL),
(48948, '2017-10-06 09:42:58', NULL, NULL, 13482, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 09:42:58', 'admin-1507197410-15072541783482391', 1, 0, '', NULL, NULL, NULL),
(48949, '2017-10-06 16:25:02', NULL, NULL, 13505, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1507269351', 'admin', '2017-10-06 16:25:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48950, '2017-10-06 16:25:06', NULL, NULL, 13505, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 16:25:06', 'admin-1507269351-150727830671167', 1, 1, 'SR', NULL, NULL, NULL),
(48951, '2017-10-06 16:38:03', NULL, NULL, 13504, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 16:38:03', 'admin-1507269351-15072790832868346', 1, 1, 'SR', NULL, NULL, NULL),
(48952, '2017-10-06 15:50:01', NULL, NULL, 13504, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1507269351', 'admin', '2017-10-06 15:50:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48953, '2017-10-06 10:44:26', NULL, NULL, 13486, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 10:44:26', 'admin-1507257843-15072578663022837', 1, 1, 'SR', NULL, NULL, NULL),
(48954, '2017-10-06 10:44:26', NULL, NULL, 13486, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 10:44:26', 'admin-1507257843-15072578663022837', 1, 0, '', NULL, NULL, NULL),
(48955, '2017-10-06 10:44:26', NULL, NULL, 13486, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 10:44:26', 'admin-1507257843-15072578663022837', 1, 1, 'SR', NULL, NULL, NULL),
(48956, '2017-10-06 15:45:33', NULL, NULL, 13502, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 15:45:33', 'admin-1507269351-15072759329092524', 1, 1, 'SR', NULL, NULL, NULL),
(48957, '2017-10-06 15:32:52', NULL, NULL, 13502, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1507269351', 'admin', '2017-10-06 15:32:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48958, '2017-10-06 15:32:56', NULL, NULL, 13502, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 15:32:56', 'admin-1507269351-15072751763812384', 1, 1, 'SR', NULL, NULL, NULL),
(48959, '2017-10-06 00:00:00', NULL, NULL, 13498, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:49:24', 'admin-1507257843-15072689646812054', 1, 0, '', NULL, NULL, NULL),
(48960, '2017-10-06 00:00:00', NULL, NULL, 13499, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:49:24', 'admin-1507257843-15072689646812054', 1, 1, 'SR', NULL, NULL, NULL),
(48961, '2017-10-06 00:00:00', NULL, NULL, 13500, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:49:24', 'admin-1507257843-15072689646812054', 1, 1, 'SR', NULL, NULL, NULL),
(48962, '2017-10-06 13:52:13', NULL, NULL, 13493, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:52:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48963, '2017-10-06 13:52:47', NULL, NULL, 13493, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:52:47', 'admin-1507257843-15072691673597822', 1, 0, '', NULL, NULL, NULL),
(48964, '2017-10-06 13:52:47', NULL, NULL, 13493, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:52:47', 'admin-1507257843-15072691673597822', 1, 1, 'SR', NULL, NULL, NULL),
(48965, '2017-10-06 13:54:47', NULL, NULL, 13493, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:54:47', 'admin-1507257843-15072692872371656', 1, 1, 'SR', NULL, NULL, NULL),
(48966, '2017-10-06 13:55:31', NULL, NULL, 13494, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:55:31', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(48967, '2017-10-06 13:55:46', NULL, NULL, 13494, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:55:46', 'admin-1507257843-1507269346687192', 1, 0, '', NULL, NULL, '10.0'),
(48968, '2017-10-06 13:55:46', NULL, NULL, 13494, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:55:46', 'admin-1507257843-1507269346687192', 1, 0, '', NULL, NULL, '10.0'),
(48969, '2017-10-06 13:52:59', NULL, NULL, 13493, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:52:59', 'admin-1507257843-1507269179291671', 1, 0, '', NULL, NULL, NULL),
(48970, '2017-10-06 14:29:40', NULL, NULL, 13498, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1507269351', 'admin', '2017-10-06 14:29:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48971, '2017-10-06 13:52:59', NULL, NULL, 13493, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:52:59', 'admin-1507257843-1507269179291671', 1, 0, '', NULL, NULL, NULL),
(48972, '2017-10-06 13:52:47', NULL, NULL, 13493, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:52:47', 'admin-1507257843-15072691673597822', 1, 1, 'SR', NULL, NULL, NULL),
(48973, '2017-10-06 16:25:06', NULL, NULL, 13505, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 16:25:06', 'admin-1507269351-150727830671167', 1, 1, 'SR', NULL, NULL, NULL),
(48974, '2017-10-06 13:42:45', NULL, NULL, 13492, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:42:45', 'admin-1507257843-1507268565190381', 1, 1, 'SR', NULL, NULL, NULL),
(48975, '2017-10-06 13:42:45', NULL, NULL, 13492, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:42:45', 'admin-1507257843-1507268565190381', 1, 1, 'SR', NULL, NULL, NULL),
(48976, '2017-10-06 13:33:10', NULL, NULL, 13491, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:33:10', 'admin-1507257843-15072679907838919', 1, 1, 'SR', NULL, NULL, NULL),
(48977, '2017-10-06 14:28:45', NULL, NULL, 13496, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1507269351', 'admin', '2017-10-06 14:28:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48978, '2017-10-06 13:32:46', NULL, NULL, 13491, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:32:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48979, '2017-10-06 13:33:10', NULL, NULL, 13491, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:33:10', 'admin-1507257843-15072679907838919', 1, 1, 'SR', NULL, NULL, NULL),
(48980, '2017-10-06 00:00:00', NULL, NULL, 13496, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:30:07', 'admin-1507257843-15072678072237864', 1, 1, 'SR', NULL, NULL, NULL),
(48981, '2017-10-06 00:00:00', NULL, NULL, 13497, 0, 215, '149', 'Thai Fish Sauce Garlic Pork', '', 'Meals', 'Rice', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:14:07', 'admin-1507257843-15072668474812615', 1, 0, '', NULL, NULL, NULL),
(48982, '2017-10-06 13:42:45', NULL, NULL, 13492, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 13:42:45', 'admin-1507257843-1507268565190381', 1, 0, '', NULL, NULL, NULL),
(48983, '2017-10-06 14:30:07', NULL, NULL, 13499, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1507269351', 'admin', '2017-10-06 14:30:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48984, '2017-10-06 11:47:31', NULL, NULL, 13487, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1507269351', 'admin', '2017-10-06 11:47:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(48985, '2017-10-06 11:47:52', NULL, NULL, 13487, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 11:47:52', 'admin-1507257843-15072616725795315', 1, 1, 'SR', NULL, NULL, NULL),
(48986, '2017-10-06 11:47:52', NULL, NULL, 13487, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 11:47:52', 'admin-1507257843-15072616725795315', 1, 0, '', NULL, NULL, NULL),
(48987, '2017-10-06 11:47:59', NULL, NULL, 13487, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 11:47:59', 'admin-1507257843-1507261678943174', 1, 1, 'SR', NULL, NULL, NULL),
(48988, '2017-10-06 11:50:04', NULL, NULL, 13487, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 11:50:04', 'admin-1507257843-15072618043865242', 1, 1, 'SR', NULL, NULL, NULL),
(48989, '2017-10-06 10:44:26', NULL, NULL, 13486, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 10:44:26', 'admin-1507257843-15072578663022837', 1, 1, 'SR', NULL, NULL, NULL),
(48990, '2017-10-06 11:01:26', NULL, NULL, 13485, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 11:01:26', 'admin-1507257843-1507258886073686', 1, 1, 'SR', NULL, NULL, NULL),
(48991, '2017-10-06 10:45:05', NULL, NULL, 13486, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 10:45:05', 'admin-1507257843-15072579056875371', 1, 0, '', NULL, NULL, NULL),
(48992, '2017-10-06 10:43:39', NULL, NULL, 13486, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 10:43:39', 'admin-1507197410-1507257819563613', 1, 0, '', NULL, NULL, NULL),
(48993, '2017-10-06 10:43:39', NULL, NULL, 13486, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 10:43:39', 'admin-1507197410-1507257819563613', 1, 0, '', NULL, NULL, NULL),
(48994, '2017-10-06 10:43:39', NULL, NULL, 13486, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 10:43:39', 'admin-1507197410-1507257819563613', 1, 0, '', NULL, NULL, NULL),
(48995, '2017-10-06 10:40:59', NULL, NULL, 13486, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 10:40:59', 'admin-1507197410-15072576588804316', 1, 0, '', NULL, NULL, NULL),
(48996, '2017-10-06 10:18:30', NULL, NULL, 13485, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 10:18:30', 'admin-1507197410-15072563106819119', 1, 1, 'SR', NULL, NULL, NULL),
(48997, '2017-10-06 10:18:30', NULL, NULL, 13485, 0, 153, '87', 'Wake Me Up!', 'sunnysideup', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 10:18:30', 'admin-1507197410-15072563106819119', 1, 0, '', NULL, NULL, NULL),
(48998, '2017-10-06 10:18:30', NULL, NULL, 13485, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 10:18:30', 'admin-1507197410-15072563106819119', 1, 0, '', NULL, NULL, NULL),
(48999, '2017-10-06 10:18:05', NULL, NULL, 13485, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.20, 0.0000, 0.0000, 10.20, 1, '27', 1, '1507269351', 'admin', '2017-10-06 10:18:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49000, '2017-10-06 10:12:20', NULL, NULL, 13484, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 10:12:20', 'admin-1507197410-15072559404331469', 1, 1, 'SR', NULL, NULL, NULL),
(49001, '2017-10-06 10:12:17', NULL, NULL, 13484, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1507269351', 'admin', '2017-10-06 10:12:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49002, '2017-10-06 10:09:04', NULL, NULL, 13483, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 10:09:04', 'admin-1507197410-15072557440693936', 1, 0, '', NULL, NULL, NULL),
(49003, '2017-10-06 14:29:11', NULL, NULL, 13497, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1507269351', 'admin', '2017-10-06 14:29:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49004, '2017-10-06 10:09:04', NULL, NULL, 13483, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 10:09:04', 'admin-1507197410-15072557440693936', 1, 1, 'SR', NULL, NULL, NULL),
(49005, '2017-10-06 09:25:11', NULL, NULL, 13480, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1507269351', 'admin', '2017-10-06 09:25:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49006, '2017-10-06 09:25:23', NULL, NULL, 13480, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 09:25:23', 'admin-1507197410-15072531235101565', 1, 0, '', NULL, NULL, NULL),
(49007, '2017-10-06 09:25:23', NULL, NULL, 13480, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 09:25:23', 'admin-1507197410-15072531235101565', 1, 1, 'SR', NULL, NULL, NULL),
(49008, '2017-10-06 09:25:23', NULL, NULL, 13480, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 09:25:23', 'admin-1507197410-15072531235101565', 1, 1, 'SR', NULL, NULL, NULL),
(49009, '2017-10-06 09:25:23', NULL, NULL, 13480, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 09:25:23', 'admin-1507197410-15072531235101565', 1, 0, '', NULL, NULL, NULL),
(49010, '2017-10-06 09:29:01', NULL, NULL, 13480, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 09:29:01', 'admin-1507197410-1507253341673774', 1, 0, '', NULL, NULL, NULL),
(49011, '2017-10-06 09:29:01', NULL, NULL, 13480, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 09:29:01', 'admin-1507197410-1507253341673774', 1, 1, 'SR', NULL, NULL, NULL),
(49012, '2017-10-06 09:40:20', NULL, NULL, 13481, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1507269351', 'admin', '2017-10-06 09:40:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49013, '2017-10-06 09:18:58', NULL, NULL, 13479, 0, 153, '87', 'Wake Me Up!', 'Takeaway', 'Meals', 'Morning Bites ', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1507269351', 'admin', '2017-10-06 09:18:58', 'admin-1507197410-15072527382217096', 1, 0, '', NULL, NULL, NULL),
(49014, '2017-10-07 10:58:36', NULL, NULL, 13516, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:58:36', 'admin-1507338062-15073451166134711', 1, 0, '', NULL, NULL, NULL),
(49015, '2017-10-07 11:15:49', NULL, NULL, 13517, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1507357676', 'admin', '2017-10-07 11:15:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49016, '2017-10-07 11:16:10', NULL, NULL, 13517, 0, 153, '87', 'Wake Me Up!', 'sunnysideup', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 11:16:10', 'admin-1507345210-15073461707676947', 1, 0, '', NULL, NULL, NULL),
(49017, '2017-10-07 11:16:10', NULL, NULL, 13517, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 11:16:10', 'admin-1507345210-15073461707676947', 1, 0, '', NULL, NULL, NULL),
(49018, '2017-10-07 11:16:26', NULL, NULL, 13517, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 11:16:26', 'admin-1507345210-15073461862806841', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(49019, '2017-10-07 09:27:10', NULL, NULL, 13507, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:27:10', 'admin-1507338062-1507339629976223', 1, 1, 'SR', NULL, NULL, NULL),
(49020, '2017-10-07 09:39:52', NULL, NULL, 13508, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:39:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49021, '2017-10-07 09:39:58', NULL, NULL, 13508, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:39:58', 'admin-1507338062-1507340398529660', 1, 0, '', NULL, NULL, NULL),
(49022, '2017-10-07 14:27:51', NULL, NULL, 13530, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:27:51', 'admin-1507353045-1507357671171134', 1, 0, '', NULL, NULL, NULL),
(49023, '2017-10-07 14:28:03', NULL, NULL, 13534, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:28:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49024, '2017-10-07 14:07:37', NULL, NULL, 13531, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:07:37', 'admin-1507353045-1507356457065788', 1, 0, '', NULL, NULL, NULL),
(49025, '2017-10-07 14:07:37', NULL, NULL, 13531, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:07:37', 'admin-1507353045-1507356457065788', 1, 0, '', NULL, NULL, NULL),
(49026, '2017-10-07 14:07:52', NULL, NULL, 13531, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:07:52', 'admin-1507353045-15073564722295033', 1, 1, 'SR', NULL, NULL, NULL),
(49027, '2017-10-07 14:04:44', NULL, NULL, 13530, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:04:44', 'admin-1507353045-15073562847282335', 1, 1, 'SR', NULL, NULL, NULL),
(49028, '2017-10-07 14:04:44', NULL, NULL, 13530, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:04:44', 'admin-1507353045-15073562847282335', 1, 1, 'SR', NULL, NULL, NULL),
(49029, '2017-10-07 14:45:26', NULL, NULL, 13538, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:45:26', 'admin-1507357676-15073587265586812', 1, 1, 'SR', NULL, NULL, NULL),
(49030, '2017-10-07 14:45:26', NULL, NULL, 13538, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:45:26', 'admin-1507357676-15073587265586812', 1, 0, '', NULL, NULL, NULL),
(49031, '2017-10-07 15:35:44', NULL, NULL, 13543, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:35:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49032, '2017-10-07 15:36:09', NULL, NULL, 13543, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:36:09', 'admin-1507357676-15073617688907723', 1, 0, '', NULL, NULL, NULL),
(49033, '2017-10-07 15:36:09', NULL, NULL, 13543, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:36:09', 'admin-1507357676-15073617688907723', 1, 0, '', NULL, NULL, NULL),
(49034, '2017-10-07 13:24:04', NULL, NULL, 13525, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:24:04', 'admin-1507353045-15073538438673380', 1, 1, 'SR', NULL, NULL, NULL),
(49035, '2017-10-07 13:24:04', NULL, NULL, 13525, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:24:04', 'admin-1507353045-15073538438673380', 1, 1, 'SR', NULL, NULL, NULL),
(49036, '2017-10-07 10:35:19', NULL, NULL, 13514, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:35:19', 'admin-1507338062-1507343719497439', 1, 0, '', NULL, NULL, NULL),
(49037, '2017-10-07 10:35:19', NULL, NULL, 13514, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:35:19', 'admin-1507338062-1507343719497439', 1, 1, 'SR', NULL, NULL, NULL),
(49038, '2017-10-07 10:58:36', NULL, NULL, 13516, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:58:36', 'admin-1507338062-15073451166134711', 1, 0, '', NULL, NULL, NULL),
(49039, '2017-10-07 15:16:57', NULL, NULL, 13534, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:16:57', 'admin-1507357676-15073606169413630', 1, 1, 'SR', NULL, NULL, NULL),
(49040, '2017-10-07 15:52:03', NULL, NULL, 13545, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:52:03', 'admin-1507357676-15073627234325678', 1, 1, 'SR', NULL, NULL, NULL),
(49041, '2017-10-07 15:36:09', NULL, NULL, 13543, 0, 181, '116', 'Open Food ', 'Fruit Platter', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:36:09', 'admin-1507357676-15073617688907723', 1, 0, '', NULL, NULL, NULL),
(49042, '2017-10-07 14:32:04', NULL, NULL, 13535, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:32:04', 'admin-1507357676-15073579240124357', 1, 1, 'SR', NULL, NULL, NULL),
(49043, '2017-10-07 15:19:39', NULL, NULL, 13542, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:19:39', 'admin-1507357676-15073607788253017', 1, 0, '', NULL, NULL, NULL),
(49044, '2017-10-07 15:19:39', NULL, NULL, 13542, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:19:39', 'admin-1507357676-15073607788253017', 1, 1, 'SR', NULL, NULL, NULL),
(49045, '2017-10-07 14:31:47', NULL, NULL, 13535, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:31:47', 'admin-1507357676-15073579070057790', 1, 0, '', NULL, NULL, NULL),
(49046, '2017-10-07 14:31:47', NULL, NULL, 13535, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:31:47', 'admin-1507357676-15073579070057790', 1, 0, '', NULL, NULL, NULL),
(49047, '2017-10-07 15:52:03', NULL, NULL, 13545, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:52:03', 'admin-1507357676-15073627234325678', 1, 1, 'SR', NULL, NULL, NULL),
(49048, '2017-10-07 15:43:23', NULL, NULL, 13544, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:43:23', 'admin-1507357676-1507362203761166', 1, 1, 'SR', NULL, NULL, NULL),
(49049, '2017-10-07 15:52:03', NULL, NULL, 13545, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:52:03', 'admin-1507357676-15073627234325678', 1, 1, 'SR', NULL, NULL, NULL),
(49050, '2017-10-07 13:10:40', NULL, NULL, 13523, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:10:40', 'admin-1507345210-1507353040028971', 1, 0, '', NULL, NULL, NULL),
(49051, '2017-10-07 13:10:40', NULL, NULL, 13523, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:10:40', 'admin-1507345210-1507353040028971', 1, 1, 'SR', NULL, NULL, NULL),
(49052, '2017-10-07 13:06:40', NULL, NULL, 13521, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:06:40', 'admin-1507345210-15073528004528815', 1, 0, '', NULL, NULL, NULL),
(49053, '2017-10-07 11:16:26', NULL, NULL, 13517, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 11:16:26', 'admin-1507345210-15073461862806841', 1, 0, '', NULL, NULL, NULL),
(49054, '2017-10-07 11:40:40', NULL, NULL, 13518, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1507357676', 'admin', '2017-10-07 11:40:40', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(49055, '2017-10-07 11:41:08', NULL, NULL, 13518, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 11:41:08', 'admin-1507345210-15073476687324754', 1, 1, 'SR', NULL, NULL, '10.0'),
(49056, '2017-10-07 11:41:08', NULL, NULL, 13518, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 11:41:08', 'admin-1507345210-15073476687324754', 1, 1, 'SR', NULL, NULL, '10.0'),
(49057, '2017-10-07 11:41:08', NULL, NULL, 13518, 0, 70, '70', 'Borneo Pepper Pork', 'ex rice', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 11:41:08', 'admin-1507345210-15073476687324754', 1, 1, 'SR', NULL, NULL, '10.0'),
(49058, '2017-10-07 11:41:08', NULL, NULL, 13518, 0, 73, '73', 'Marmite Chicken ', 'ex rice', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 11:41:08', 'admin-1507345210-15073476687324754', 1, 1, 'SR', NULL, NULL, '10.0'),
(49059, '2017-10-07 15:30:35', NULL, NULL, 13534, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:30:35', 'admin-1507357676-15073614356415035', 1, 0, '', NULL, NULL, NULL),
(49060, '2017-10-07 15:38:00', NULL, NULL, 13544, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:38:00', 'admin-1507357676-15073618804533957', 1, 1, 'SR', NULL, NULL, NULL),
(49061, '2017-10-07 15:15:54', NULL, NULL, 13541, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:15:54', 'admin-1507357676-15073605547034996', 1, 1, 'SR', NULL, NULL, NULL),
(49062, '2017-10-07 15:38:00', NULL, NULL, 13544, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:38:00', 'admin-1507357676-15073618804533957', 1, 1, 'SR', NULL, NULL, NULL),
(49063, '2017-10-07 13:59:29', NULL, NULL, 13529, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:59:29', 'admin-1507353045-1507355968958546', 1, 0, '', NULL, NULL, NULL),
(49064, '2017-10-07 15:15:54', NULL, NULL, 13541, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:15:54', 'admin-1507357676-15073605547034996', 1, 1, 'SR', NULL, NULL, NULL),
(49065, '2017-10-07 15:19:39', NULL, NULL, 13542, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:19:39', 'admin-1507357676-15073607788253017', 1, 1, 'SR', NULL, NULL, NULL),
(49066, '2017-10-07 14:32:21', NULL, NULL, 13536, 0, 182, '117', 'Open Drinks ', 'americano promo', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:32:21', 'admin-1507357676-15073579412363217', 1, 0, '', 1, NULL, NULL),
(49067, '2017-10-07 13:59:24', NULL, NULL, 13529, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:59:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49068, '2017-10-07 15:19:25', NULL, NULL, 13542, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:19:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49069, '2017-10-07 15:10:50', NULL, NULL, 13540, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:10:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49070, '2017-10-07 15:10:56', NULL, NULL, 13540, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:10:56', 'admin-1507357676-15073602559332448', 1, 1, 'SR', NULL, NULL, NULL),
(49071, '2017-10-07 15:10:56', NULL, NULL, 13540, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:10:56', 'admin-1507357676-15073602559332448', 1, 1, 'SR', NULL, NULL, NULL),
(49072, '2017-10-07 15:15:48', NULL, NULL, 13541, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:15:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49073, '2017-10-07 15:51:54', NULL, NULL, 13545, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:51:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49074, '2017-10-07 12:05:49', NULL, NULL, 13519, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 12:05:49', 'admin-1507345210-15073491497228614', 1, 1, 'SR', NULL, NULL, NULL),
(49075, '2017-10-07 12:05:49', NULL, NULL, 13519, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 12:05:49', 'admin-1507345210-15073491497228614', 1, 0, '', NULL, NULL, NULL),
(49076, '2017-10-07 12:05:49', NULL, NULL, 13519, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 12:05:49', 'admin-1507345210-15073491497228614', 1, 0, '', NULL, NULL, NULL),
(49077, '2017-10-07 13:39:40', NULL, NULL, 13527, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:39:40', 'admin-1507353045-15073547800368967', 1, 1, 'SR', 1, NULL, '10.0'),
(49078, '2017-10-07 13:42:51', NULL, NULL, 13528, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:42:51', 'admin-1507353045-15073549712756878', 1, 0, '', 1, NULL, '10.0'),
(49079, '2017-10-07 15:01:04', NULL, NULL, 13532, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:01:04', 'admin-1507357676-15073596645309257', 1, 0, '', NULL, NULL, NULL),
(49080, '2017-10-07 14:45:59', NULL, NULL, 13539, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:45:59', 'admin-1507357676-15073587595437544', 1, 1, 'SR', 1, NULL, NULL),
(49081, '2017-10-07 14:32:04', NULL, NULL, 13535, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:32:04', 'admin-1507357676-15073579240124357', 1, 0, '', NULL, NULL, NULL),
(49082, '2017-10-07 14:45:14', NULL, NULL, 13538, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:45:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49083, '2017-10-07 14:37:36', NULL, NULL, 13534, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:37:36', 'admin-1507357676-1507358256516538', 1, 1, 'SR', NULL, NULL, NULL),
(49084, '2017-10-07 14:32:46', NULL, NULL, 13537, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:32:46', 'admin-1507357676-15073579663923266', 1, 1, 'SR', NULL, NULL, NULL),
(49085, '2017-10-07 14:32:40', NULL, NULL, 13537, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:32:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49086, '2017-10-07 14:32:04', NULL, NULL, 13535, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:32:04', 'admin-1507357676-15073579240124357', 1, 1, 'SR', NULL, NULL, NULL),
(49087, '2017-10-07 14:31:37', NULL, NULL, 13535, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:31:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49088, '2017-10-07 14:30:48', NULL, NULL, 13534, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:30:48', 'admin-1507357676-15073578481285876', 1, 0, '', NULL, NULL, NULL),
(49089, '2017-10-07 14:28:35', NULL, NULL, 13534, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:28:35', 'admin-1507357676-1507357715743289', 1, 1, 'SR', NULL, NULL, NULL),
(49090, '2017-10-07 14:17:49', NULL, NULL, 13532, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:17:49', 'admin-1507353045-1507357069712761', 1, 1, 'SR', NULL, NULL, NULL),
(49091, '2017-10-07 13:06:40', NULL, NULL, 13521, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:06:40', 'admin-1507345210-15073528004528815', 1, 0, '', NULL, NULL, NULL),
(49092, '2017-10-07 13:06:40', NULL, NULL, 13521, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:06:40', 'admin-1507345210-15073528004528815', 1, 0, '', NULL, NULL, NULL),
(49093, '2017-10-07 13:09:12', NULL, NULL, 13522, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:09:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49094, '2017-10-07 14:17:06', NULL, NULL, 13532, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.30, 0.0000, 0.0000, 10.30, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:17:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49095, '2017-10-07 14:07:52', NULL, NULL, 13531, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:07:52', 'admin-1507353045-15073564722295033', 1, 1, 'SR', NULL, NULL, NULL),
(49096, '2017-10-07 14:04:44', NULL, NULL, 13530, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:04:44', 'admin-1507353045-15073562847282335', 1, 0, '', NULL, NULL, NULL),
(49097, '2017-10-07 14:18:16', NULL, NULL, 13532, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:18:16', 'admin-1507353045-15073570960697312', 1, 1, 'SR', NULL, NULL, NULL),
(49098, '2017-10-07 14:22:45', NULL, NULL, 13533, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:22:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49099, '2017-10-07 14:22:55', NULL, NULL, 13533, 0, 15, '15', 'Iced Latte ', 'Flavoured Syrup', 'Cold Drinks', 'Coffee', 2, 13.00, 26.0000, 0.0000, 26.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:22:55', 'admin-1507353045-15073573757547479', 1, 1, 'SR', NULL, NULL, NULL),
(49100, '2017-10-07 14:22:55', NULL, NULL, 13533, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 2, 15.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:22:55', 'admin-1507353045-15073573757547479', 1, 1, 'SR', NULL, NULL, NULL),
(49101, '2017-10-07 14:18:16', NULL, NULL, 13532, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:18:16', 'admin-1507353045-15073570960697312', 1, 1, 'SR', NULL, NULL, NULL),
(49102, '2017-10-07 13:29:25', NULL, NULL, 13526, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:29:25', 'admin-1507353045-15073541652121788', 1, 1, 'SR', NULL, NULL, NULL),
(49103, '2017-10-07 13:29:20', NULL, NULL, 13526, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:29:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49104, '2017-10-07 13:17:32', NULL, NULL, 13524, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:17:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49105, '2017-10-07 13:17:41', NULL, NULL, 13524, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:17:41', 'admin-1507353045-15073534610316845', 1, 0, '', NULL, NULL, NULL),
(49106, '2017-10-07 13:17:41', NULL, NULL, 13524, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:17:41', 'admin-1507353045-15073534610316845', 1, 0, '', NULL, NULL, NULL),
(49107, '2017-10-07 15:37:53', NULL, NULL, 13544, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:37:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49108, '2017-10-07 14:17:49', NULL, NULL, 13532, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:17:49', 'admin-1507353045-1507357069712761', 1, 0, '', NULL, NULL, NULL),
(49109, '2017-10-07 14:18:16', NULL, NULL, 13532, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:18:16', 'admin-1507353045-15073570960697312', 1, 1, 'SR', NULL, NULL, NULL),
(49110, '2017-10-07 14:18:16', NULL, NULL, 13532, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:18:16', 'admin-1507353045-15073570960697312', 1, 1, 'SR', NULL, NULL, NULL),
(49111, '2017-10-07 14:07:52', NULL, NULL, 13531, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:07:52', 'admin-1507353045-15073564722295033', 1, 0, '', NULL, NULL, NULL),
(49112, '2017-10-07 10:01:01', NULL, NULL, 13511, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:01:01', 'admin-1507338062-15073416613061442', 1, 0, '', NULL, NULL, NULL),
(49113, '2017-10-07 10:03:07', NULL, NULL, 13512, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:03:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49114, '2017-10-07 10:03:13', NULL, NULL, 13512, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:03:13', 'admin-1507338062-15073417928048037', 1, 1, 'SR', NULL, NULL, NULL),
(49115, '2017-10-07 10:03:13', NULL, NULL, 13512, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:03:13', 'admin-1507338062-15073417928048037', 1, 1, 'SR', NULL, NULL, NULL),
(49116, '2017-10-07 14:06:03', NULL, NULL, 13525, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:06:03', 'admin-1507353045-15073563631685039', 1, 0, '', NULL, NULL, NULL),
(49117, '2017-10-07 13:23:44', NULL, NULL, 13525, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:23:44', 'admin-1507353045-15073538243118339', 1, 0, '', NULL, NULL, NULL),
(49118, '2017-10-07 13:23:44', NULL, NULL, 13525, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:23:44', 'admin-1507353045-15073538243118339', 1, 1, 'SR', NULL, NULL, NULL),
(49119, '2017-10-07 13:23:44', NULL, NULL, 13525, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:23:44', 'admin-1507353045-15073538243118339', 1, 0, '', NULL, NULL, NULL),
(49120, '2017-10-07 13:23:44', NULL, NULL, 13525, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:23:44', 'admin-1507353045-15073538243118339', 1, 0, '', NULL, NULL, NULL),
(49121, '2017-10-07 13:23:16', NULL, NULL, 13525, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.50, 0.0000, 0.0000, 9.50, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:23:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49122, '2017-10-07 13:17:53', NULL, NULL, 13524, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:17:53', 'admin-1507353045-15073534734329671', 1, 1, 'SR', NULL, NULL, NULL),
(49123, '2017-10-07 14:07:20', NULL, NULL, 13531, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:07:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49124, '2017-10-07 14:07:37', NULL, NULL, 13531, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:07:37', 'admin-1507353045-1507356457065788', 1, 1, 'SR', NULL, NULL, NULL),
(49125, '2017-10-07 15:43:23', NULL, NULL, 13544, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 15:43:23', 'admin-1507357676-1507362203761166', 1, 1, 'SR', NULL, NULL, NULL),
(49126, '2017-10-07 13:09:27', NULL, NULL, 13522, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:09:27', 'admin-1507345210-15073529670032423', 1, 0, '', NULL, NULL, NULL),
(49127, '2017-10-07 13:13:43', NULL, NULL, 13521, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:13:43', 'admin-1507353045-15073532229838710', 1, 1, 'SR', NULL, NULL, NULL),
(49128, '2017-10-07 13:13:43', NULL, NULL, 13521, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:13:43', 'admin-1507353045-15073532229838710', 1, 0, '', NULL, NULL, NULL),
(49129, '2017-10-07 14:04:44', NULL, NULL, 13530, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:04:44', 'admin-1507353045-15073562847282335', 1, 1, 'SR', NULL, NULL, NULL),
(49130, '2017-10-07 14:17:49', NULL, NULL, 13532, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:17:49', 'admin-1507353045-1507357069712761', 1, 1, 'SR', NULL, NULL, NULL),
(49131, '2017-10-07 14:04:11', NULL, NULL, 13530, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:04:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49132, '2017-10-07 14:04:15', NULL, NULL, 13530, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:04:15', 'admin-1507353045-15073562557266426', 1, 0, '', NULL, NULL, NULL),
(49133, '2017-10-07 14:03:10', NULL, NULL, 13529, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:03:10', 'admin-1507353045-15073561898535410', 1, 1, 'SR', NULL, NULL, NULL),
(49134, '2017-10-07 12:23:48', NULL, NULL, 13520, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 12:23:48', 'admin-1507345210-15073502281312187', 1, 1, 'SR', NULL, NULL, NULL),
(49135, '2017-10-07 12:23:48', NULL, NULL, 13520, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 12:23:48', 'admin-1507345210-15073502281312187', 1, 1, 'SR', NULL, NULL, NULL),
(49136, '2017-10-07 12:23:56', NULL, NULL, 13517, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 12:23:56', 'admin-1507345210-15073502362256461', 1, 0, '', NULL, NULL, NULL),
(49137, '2017-10-07 13:13:33', NULL, NULL, 13517, 0, 215, '149', 'Thai Fish Sauce Garlic Pork', ' put aside,Celery dont cook,Takeaway', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:13:33', 'admin-1507353045-1507353213328898', 1, 0, '', NULL, NULL, NULL),
(49138, '2017-10-07 13:09:27', NULL, NULL, 13522, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:09:27', 'admin-1507345210-15073529670032423', 1, 0, '', NULL, NULL, NULL),
(49139, '2017-10-07 13:10:32', NULL, NULL, 13523, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:10:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49140, '2017-10-07 13:09:35', NULL, NULL, 13522, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:09:35', 'admin-1507345210-150735297529645', 1, 1, 'SR', NULL, NULL, NULL),
(49141, '2017-10-07 13:09:35', NULL, NULL, 13522, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:09:35', 'admin-1507345210-150735297529645', 1, 0, '', NULL, NULL, NULL),
(49142, '2017-10-07 13:09:27', NULL, NULL, 13522, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:09:27', 'admin-1507345210-15073529670032423', 1, 0, '', NULL, NULL, NULL),
(49143, '2017-10-07 14:28:35', NULL, NULL, 13534, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:28:35', 'admin-1507357676-1507357715743289', 1, 0, '', NULL, NULL, NULL),
(49144, '2017-10-07 12:06:09', NULL, NULL, 13519, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 12:06:09', 'admin-1507345210-15073491695958039', 1, 1, 'SR', NULL, NULL, NULL),
(49145, '2017-10-07 12:06:09', NULL, NULL, 13519, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 12:06:09', 'admin-1507345210-15073491695958039', 1, 1, 'SR', NULL, NULL, NULL),
(49146, '2017-10-07 12:06:09', NULL, NULL, 13519, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 12:06:09', 'admin-1507345210-15073491695958039', 1, 1, 'SR', NULL, NULL, NULL),
(49147, '2017-10-07 12:06:09', NULL, NULL, 13519, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 12:06:09', 'admin-1507345210-15073491695958039', 1, 0, '', NULL, NULL, NULL),
(49148, '2017-10-07 12:23:14', NULL, NULL, 13520, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.90, 0.0000, 0.0000, 10.90, 1, '27', 1, '1507357676', 'admin', '2017-10-07 12:23:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49149, '2017-10-07 14:07:52', NULL, NULL, 13531, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:07:52', 'admin-1507353045-15073564722295033', 1, 0, '', NULL, NULL, NULL),
(49150, '2017-10-07 13:06:29', NULL, NULL, 13521, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1507357676', 'admin', '2017-10-07 13:06:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49151, '2017-10-07 12:33:59', NULL, NULL, 13520, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 12:33:59', 'admin-1507345210-1507350839768814', 1, 0, '', NULL, NULL, NULL),
(49152, '2017-10-07 12:33:59', NULL, NULL, 13520, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 12:33:59', 'admin-1507345210-1507350839768814', 1, 0, '', NULL, NULL, NULL),
(49153, '2017-10-07 12:55:11', NULL, NULL, 13518, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 12:55:11', 'admin-1507345210-15073521112551675', 1, 1, 'SR', NULL, NULL, '10.0'),
(49154, '2017-10-07 12:23:29', NULL, NULL, 13520, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 12:23:29', 'admin-1507345210-15073502092138787', 1, 0, '', NULL, NULL, NULL),
(49155, '2017-10-07 12:23:29', NULL, NULL, 13520, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 12:23:29', 'admin-1507345210-15073502092138787', 1, 1, 'SR', NULL, NULL, NULL),
(49156, '2017-10-07 10:38:48', NULL, NULL, 13513, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:38:48', 'admin-1507338062-15073439281466223', 1, 0, '', NULL, NULL, NULL),
(49157, '2017-10-07 12:23:29', NULL, NULL, 13520, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 12:23:29', 'admin-1507345210-15073502092138787', 1, 0, '', NULL, NULL, NULL),
(49158, '2017-10-07 12:05:49', NULL, NULL, 13519, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 12:05:49', 'admin-1507345210-15073491497228614', 1, 0, '', NULL, NULL, NULL),
(49159, '2017-10-07 12:05:49', NULL, NULL, 13519, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 12:05:49', 'admin-1507345210-15073491497228614', 1, 0, '', NULL, NULL, NULL),
(49160, '2017-10-07 14:17:49', NULL, NULL, 13532, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:17:49', 'admin-1507353045-1507357069712761', 1, 1, 'SR', NULL, NULL, NULL),
(49161, '2017-10-07 12:05:49', NULL, NULL, 13519, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 12:05:49', 'admin-1507345210-15073491497228614', 1, 1, 'SR', NULL, NULL, NULL),
(49162, '2017-10-07 11:41:08', NULL, NULL, 13518, 0, 73, '73', 'Marmite Chicken ', 'ex rice', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 11:41:08', 'admin-1507345210-15073476687324754', 1, 1, 'SR', NULL, NULL, '10.0'),
(49163, '2017-10-07 12:05:24', NULL, NULL, 13519, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.60, 0.0000, 0.0000, 11.60, 1, '27', 1, '1507357676', 'admin', '2017-10-07 12:05:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49164, '2017-10-07 10:47:26', NULL, NULL, 13515, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:47:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49165, '2017-10-07 10:47:43', NULL, NULL, 13515, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:47:43', 'admin-1507338062-1507344463267639', 1, 0, '', NULL, NULL, NULL),
(49166, '2017-10-07 10:47:43', NULL, NULL, 13515, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:47:43', 'admin-1507338062-1507344463267639', 1, 0, '', NULL, NULL, NULL),
(49167, '2017-10-07 10:47:43', NULL, NULL, 13515, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:47:43', 'admin-1507338062-1507344463267639', 1, 0, '', NULL, NULL, NULL),
(49168, '2017-10-07 10:47:43', NULL, NULL, 13515, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:47:43', 'admin-1507338062-1507344463267639', 1, 0, '', NULL, NULL, NULL),
(49169, '2017-10-07 10:58:27', NULL, NULL, 13516, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:58:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49170, '2017-10-07 10:58:36', NULL, NULL, 13516, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:58:36', 'admin-1507338062-15073451166134711', 1, 1, 'SR', NULL, NULL, NULL),
(49171, '2017-10-07 10:13:23', NULL, NULL, 13513, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:13:23', 'admin-1507338062-15073424031535259', 1, 1, 'SR', NULL, NULL, NULL),
(49172, '2017-10-07 09:47:53', NULL, NULL, 13509, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:47:53', 'admin-1507338062-15073408729621057', 1, 0, '', NULL, NULL, NULL),
(49173, '2017-10-07 09:47:53', NULL, NULL, 13509, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:47:53', 'admin-1507338062-15073408729621057', 1, 0, '', NULL, NULL, NULL),
(49174, '2017-10-07 09:48:15', NULL, NULL, 13510, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:48:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49175, '2017-10-07 09:48:27', NULL, NULL, 13510, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:48:27', 'admin-1507338062-15073409071117122', 1, 0, '', NULL, NULL, NULL),
(49176, '2017-10-07 10:35:19', NULL, NULL, 13514, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:35:19', 'admin-1507338062-1507343719497439', 1, 0, '', NULL, NULL, NULL),
(49177, '2017-10-07 10:35:01', NULL, NULL, 13514, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:35:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49178, '2017-10-07 10:13:23', NULL, NULL, 13513, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:13:23', 'admin-1507338062-15073424031535259', 1, 1, 'SR', NULL, NULL, NULL),
(49179, '2017-10-07 10:13:13', NULL, NULL, 13513, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:13:13', 'admin-1507338062-15073423935184055', 1, 0, '', NULL, NULL, NULL),
(49180, '2017-10-07 10:10:41', NULL, NULL, 13508, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:10:41', 'admin-1507338062-15073422411133978', 1, 0, '', NULL, NULL, NULL),
(49181, '2017-10-07 10:10:46', NULL, NULL, 13508, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:10:46', 'admin-1507338062-1507342246096338', 1, 1, 'SR', NULL, NULL, NULL),
(49182, '2017-10-07 10:13:02', NULL, NULL, 13513, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:13:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49183, '2017-10-07 10:13:13', NULL, NULL, 13513, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:13:13', 'admin-1507338062-15073423935184055', 1, 0, '', NULL, NULL, NULL),
(49184, '2017-10-07 09:27:10', NULL, NULL, 13507, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:27:10', 'admin-1507338062-1507339629976223', 1, 1, 'SR', NULL, NULL, NULL),
(49185, '2017-10-07 10:00:57', NULL, NULL, 13511, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:00:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49186, '2017-10-07 10:01:01', NULL, NULL, 13511, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 10:01:01', 'admin-1507338062-15073416613061442', 1, 1, 'SR', NULL, NULL, NULL),
(49187, '2017-10-07 09:48:27', NULL, NULL, 13510, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:48:27', 'admin-1507338062-15073409071117122', 1, 0, '', NULL, NULL, NULL),
(49188, '2017-10-07 09:47:53', NULL, NULL, 13509, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:47:53', 'admin-1507338062-15073408729621057', 1, 0, '', NULL, NULL, NULL),
(49189, '2017-10-07 09:47:53', NULL, NULL, 13509, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:47:53', 'admin-1507338062-15073408729621057', 1, 0, '', NULL, NULL, NULL),
(49190, '2017-10-07 09:27:10', NULL, NULL, 13507, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:27:10', 'admin-1507338062-1507339629976223', 1, 0, '', NULL, NULL, NULL),
(49191, '2017-10-07 14:17:49', NULL, NULL, 13532, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 14:17:49', 'admin-1507353045-1507357069712761', 1, 1, 'SR', NULL, NULL, NULL),
(49192, '2017-10-07 09:47:44', NULL, NULL, 13509, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:47:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49193, '2017-10-07 09:27:10', NULL, NULL, 13507, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:27:10', 'admin-1507338062-1507339629976223', 1, 1, 'SR', NULL, NULL, NULL),
(49194, '2017-10-07 09:27:10', NULL, NULL, 13507, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:27:10', 'admin-1507338062-1507339629976223', 1, 1, 'SR', NULL, NULL, NULL),
(49195, '2017-10-07 09:26:47', NULL, NULL, 13507, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:26:47', 'admin-1507338062-15073396069643938', 1, 0, '', NULL, NULL, NULL),
(49196, '2017-10-07 09:26:47', NULL, NULL, 13507, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:26:47', 'admin-1507338062-15073396069643938', 1, 0, '', NULL, NULL, NULL),
(49197, '2017-10-07 09:26:47', NULL, NULL, 13507, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:26:47', 'admin-1507338062-15073396069643938', 1, 0, '', NULL, NULL, NULL),
(49198, '2017-10-07 09:26:47', NULL, NULL, 13507, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:26:47', 'admin-1507338062-15073396069643938', 1, 0, '', NULL, NULL, NULL),
(49199, '2017-10-07 09:26:47', NULL, NULL, 13507, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:26:47', 'admin-1507338062-15073396069643938', 1, 0, '', NULL, NULL, NULL),
(49200, '2017-10-07 09:42:31', NULL, NULL, 13508, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:42:31', 'admin-1507338062-15073405512018721', 1, 0, '', NULL, NULL, NULL),
(49201, '2017-10-07 09:21:13', NULL, NULL, 13507, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.70, 0.0000, 0.0000, 14.70, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:21:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49202, '2017-10-07 09:17:50', NULL, NULL, 13506, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:17:50', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(49203, '2017-10-07 09:17:59', NULL, NULL, 13506, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507357676', 'admin', '2017-10-07 09:17:59', 'admin-1507338062-15073390790093784', 1, 0, '', NULL, NULL, NULL),
(49204, '2017-10-08 11:12:54', NULL, NULL, 13566, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:12:54', 'admin-1507432281-15074323739151062', 1, 1, 'SR', NULL, NULL, NULL),
(49205, '2017-10-08 11:12:54', NULL, NULL, 13566, 0, 153, '87', 'Wake Me Up!', 'sunny side up', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:12:54', 'admin-1507432281-15074323739151062', 1, 0, '', NULL, NULL, NULL),
(49206, '2017-10-08 10:20:57', NULL, NULL, 13557, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:20:57', 'admin-1507424713-15074292568609717', 1, 1, 'SR', NULL, NULL, NULL),
(49207, '2017-10-08 10:22:10', NULL, NULL, 13558, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:22:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49208, '2017-10-08 10:22:17', NULL, NULL, 13558, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:22:17', 'admin-1507424713-15074293374243844', 1, 0, '', NULL, NULL, NULL),
(49209, '2017-10-08 10:25:54', NULL, NULL, 13550, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:25:54', 'admin-1507424713-15074295545109067', 1, 1, 'SR', NULL, NULL, NULL),
(49210, '2017-10-08 09:27:00', NULL, NULL, 13548, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:27:00', 'admin-1507424713-1507426020465550', 1, 1, 'SR', NULL, NULL, NULL),
(49211, '2017-10-08 09:27:00', NULL, NULL, 13548, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:27:00', 'admin-1507424713-1507426020465550', 1, 1, 'SR', NULL, NULL, NULL),
(49212, '2017-10-08 09:27:00', NULL, NULL, 13548, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:27:00', 'admin-1507424713-1507426020465550', 1, 0, '', NULL, NULL, NULL),
(49213, '2017-10-08 09:27:00', NULL, NULL, 13548, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:27:00', 'admin-1507424713-1507426020465550', 1, 0, '', NULL, NULL, NULL),
(49214, '2017-10-08 14:13:36', NULL, NULL, 13588, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 14:13:36', 'admin-1507442048-15074432159552946', 1, 0, '', NULL, NULL, NULL),
(49215, '2017-10-08 16:50:41', NULL, NULL, 13595, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 16:50:41', 'admin-1507442048-15074526409581551', 1, 1, 'SR', NULL, NULL, NULL),
(49216, '2017-10-08 16:40:28', NULL, NULL, 13595, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 16:40:28', 'admin-1507442048-1507452027968325', 1, 0, '', NULL, NULL, NULL),
(49217, '2017-10-08 16:33:38', NULL, NULL, 13595, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 16:33:38', 'admin-1507442048-15074516181016567', 1, 0, '', NULL, NULL, NULL),
(49218, '2017-10-08 12:58:52', NULL, NULL, 13578, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:58:52', 'admin-1507438407-15074387319722311', 1, 1, 'SR', NULL, NULL, NULL),
(49219, '2017-10-08 12:58:52', NULL, NULL, 13578, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:58:52', 'admin-1507438407-15074387319722311', 1, 1, 'SR', NULL, NULL, NULL),
(49220, '2017-10-08 11:44:43', NULL, NULL, 13571, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:44:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49221, '2017-10-08 11:45:37', NULL, NULL, 13571, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:45:37', 'admin-1507432281-15074343373208555', 1, 1, 'SR', NULL, NULL, NULL),
(49222, '2017-10-08 11:45:37', NULL, NULL, 13571, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:45:37', 'admin-1507432281-15074343373208555', 1, 1, 'SR', NULL, NULL, NULL),
(49223, '2017-10-08 14:08:01', NULL, NULL, 13584, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 14:08:01', 'admin-1507442048-15074428813854534', 1, 0, '', NULL, NULL, NULL),
(49224, '2017-10-08 11:32:48', NULL, NULL, 13569, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:32:48', 'admin-1507432281-15074335687574350', 1, 0, '', NULL, NULL, NULL),
(49225, '2017-10-08 11:32:48', NULL, NULL, 13569, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:32:48', 'admin-1507432281-15074335687574350', 1, 0, '', NULL, NULL, NULL),
(49226, '2017-10-08 13:55:39', NULL, NULL, 13586, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:55:39', 'admin-1507442048-1507442139282165', 1, 0, '', NULL, NULL, NULL),
(49227, '2017-10-08 13:42:00', NULL, NULL, 13584, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:42:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49228, '2017-10-08 13:42:12', NULL, NULL, 13584, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:42:12', 'admin-1507438407-15074413323854269', 1, 0, '', NULL, NULL, NULL),
(49229, '2017-10-08 13:42:12', NULL, NULL, 13584, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:42:12', 'admin-1507438407-15074413323854269', 1, 1, 'SR', NULL, NULL, NULL),
(49230, '2017-10-08 12:25:53', NULL, NULL, 13574, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:25:53', 'admin-1507432281-15074367534354267', 1, 1, 'SR', NULL, NULL, NULL),
(49231, '2017-10-08 12:25:53', NULL, NULL, 13574, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:25:53', 'admin-1507432281-15074367534354267', 1, 0, '', NULL, NULL, NULL),
(49232, '2017-10-08 12:25:53', NULL, NULL, 13574, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:25:53', 'admin-1507432281-15074367534354267', 1, 1, 'SR', NULL, NULL, NULL),
(49233, '2017-10-08 10:26:56', NULL, NULL, 13555, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:26:56', 'admin-1507424713-1507429615812967', 1, 1, 'SR', NULL, NULL, NULL),
(49234, '2017-10-08 14:07:14', NULL, NULL, 13587, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 14:07:14', 'admin-1507442048-15074428344174585', 1, 0, '', NULL, NULL, NULL),
(49235, '2017-10-08 14:07:14', NULL, NULL, 13587, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 14:07:14', 'admin-1507442048-15074428344174585', 1, 0, '', NULL, NULL, NULL),
(49236, '2017-10-08 14:12:36', NULL, NULL, 13588, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1507452888', 'admin', '2017-10-08 14:12:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49237, '2017-10-08 14:07:14', NULL, NULL, 13587, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 14:07:14', 'admin-1507442048-15074428344174585', 1, 1, 'SR', NULL, NULL, NULL),
(49238, '2017-10-08 14:06:48', NULL, NULL, 13587, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1507452888', 'admin', '2017-10-08 14:06:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49239, '2017-10-08 13:56:55', NULL, NULL, 13585, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:56:55', 'admin-1507442048-15074422150223271', 1, 0, '', NULL, NULL, NULL),
(49240, '2017-10-08 15:06:00', NULL, NULL, 13591, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 15:06:00', 'admin-1507442048-15074463599972518', 1, 1, 'SR', NULL, NULL, NULL),
(49241, '2017-10-08 15:13:47', NULL, NULL, 13592, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1507452888', 'admin', '2017-10-08 15:13:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49242, '2017-10-08 13:16:20', NULL, NULL, 13578, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:16:20', 'admin-1507438407-15074397799285551', 1, 0, '', NULL, NULL, NULL),
(49243, '2017-10-08 13:19:45', NULL, NULL, 13581, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:19:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49244, '2017-10-08 13:20:04', NULL, NULL, 13581, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:20:04', 'admin-1507438407-15074400043572625', 1, 0, '', NULL, NULL, NULL),
(49245, '2017-10-08 14:57:53', NULL, NULL, 13590, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1507452888', 'admin', '2017-10-08 14:57:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49246, '2017-10-08 13:51:57', NULL, NULL, 13585, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:51:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49247, '2017-10-08 13:55:28', NULL, NULL, 13586, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:55:28', 'admin-1507442048-15074421284894328', 1, 1, 'SR', NULL, NULL, NULL),
(49248, '2017-10-08 13:13:45', NULL, NULL, 13580, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:13:45', 'admin-1507438407-1507439625753937', 1, 1, 'SR', NULL, NULL, NULL),
(49249, '2017-10-08 16:40:28', NULL, NULL, 13595, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 16:40:28', 'admin-1507442048-1507452027968325', 1, 0, '', NULL, NULL, NULL),
(49250, '2017-10-08 16:40:28', NULL, NULL, 13595, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 16:40:28', 'admin-1507442048-1507452027968325', 1, 1, 'SR', NULL, NULL, NULL),
(49251, '2017-10-08 15:21:50', NULL, NULL, 13593, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 15:21:50', 'admin-1507442048-15074473101423665', 1, 0, '', NULL, NULL, '10.0'),
(49252, '2017-10-08 15:21:50', NULL, NULL, 13593, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 15:21:50', 'admin-1507442048-15074473101423665', 1, 1, 'SR', NULL, NULL, '10.0'),
(49253, '2017-10-08 15:21:50', NULL, NULL, 13593, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 15:21:50', 'admin-1507442048-15074473101423665', 1, 1, 'SR', NULL, NULL, '10.0'),
(49254, '2017-10-08 15:23:04', NULL, NULL, 13593, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 15:23:04', 'admin-1507442048-15074473841019568', 1, 0, '', NULL, NULL, '10.0'),
(49255, '2017-10-08 15:23:06', NULL, NULL, 13594, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1507452888', 'admin', '2017-10-08 15:23:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49256, '2017-10-08 15:23:13', NULL, NULL, 13594, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 15:23:13', 'admin-1507442048-15074473927943373', 1, 0, '', NULL, NULL, NULL),
(49257, '2017-10-08 13:55:28', NULL, NULL, 13586, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:55:28', 'admin-1507442048-15074421284894328', 1, 0, '', NULL, NULL, NULL),
(49258, '2017-10-08 13:54:05', NULL, NULL, 13586, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:54:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49259, '2017-10-08 13:13:45', NULL, NULL, 13580, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:13:45', 'admin-1507438407-1507439625753937', 1, 0, '', NULL, NULL, NULL),
(49260, '2017-10-08 13:52:08', NULL, NULL, 13585, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:52:08', 'admin-1507438407-15074419279005412', 1, 0, '', NULL, NULL, NULL),
(49261, '2017-10-08 11:42:02', NULL, NULL, 13570, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:42:02', 'admin-1507432281-15074341226233957', 1, 0, '', NULL, NULL, NULL),
(49262, '2017-10-08 11:28:43', NULL, NULL, 13559, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:28:43', 'admin-1507432281-15074333236895267', 1, 1, 'SR', NULL, NULL, NULL),
(49263, '2017-10-08 14:28:09', NULL, NULL, 13586, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 14:28:09', 'admin-1507442048-15074440896611927', 1, 1, 'SR', NULL, NULL, NULL),
(49264, '2017-10-08 14:35:22', NULL, NULL, 13589, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1507452888', 'admin', '2017-10-08 14:35:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49265, '2017-10-08 14:35:27', NULL, NULL, 13589, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 14:35:27', 'admin-1507442048-15074445270754327', 1, 1, 'SR', NULL, NULL, NULL),
(49266, '2017-10-08 14:37:33', NULL, NULL, 13585, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 14:37:33', 'admin-1507442048-15074446532983759', 1, 1, 'SR', NULL, NULL, NULL),
(49267, '2017-10-08 14:58:02', NULL, NULL, 13590, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 14:58:02', 'admin-1507442048-15074458821974449', 1, 0, '', NULL, NULL, NULL),
(49268, '2017-10-08 14:58:26', NULL, NULL, 13590, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 14:58:26', 'admin-1507442048-150744590645887', 1, 0, '', NULL, NULL, NULL),
(49269, '2017-10-08 13:42:19', NULL, NULL, 13584, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:42:19', 'admin-1507438407-15074413389765321', 1, 1, 'SR', NULL, NULL, NULL),
(49270, '2017-10-08 11:12:54', NULL, NULL, 13566, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:12:54', 'admin-1507432281-15074323739151062', 1, 0, '', NULL, NULL, NULL),
(49271, '2017-10-08 11:18:19', NULL, NULL, 13562, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:18:19', 'admin-1507432281-15074326997487858', 1, 1, 'SR', NULL, NULL, NULL),
(49272, '2017-10-08 10:29:56', NULL, NULL, 13560, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:29:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49273, '2017-10-08 10:30:10', NULL, NULL, 13560, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:30:10', 'admin-1507424713-15074298103436661', 1, 0, '', NULL, NULL, NULL),
(49274, '2017-10-08 10:30:10', NULL, NULL, 13560, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:30:10', 'admin-1507424713-15074298103436661', 1, 0, '', NULL, NULL, NULL),
(49275, '2017-10-08 10:30:56', NULL, NULL, 13560, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:30:56', 'admin-1507424713-15074298563886747', 1, 1, 'SR', NULL, NULL, NULL),
(49276, '2017-10-08 10:30:56', NULL, NULL, 13560, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:30:56', 'admin-1507424713-15074298563886747', 1, 1, 'SR', NULL, NULL, NULL),
(49277, '2017-10-08 16:40:28', NULL, NULL, 13595, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 16:40:28', 'admin-1507442048-1507452027968325', 1, 1, 'SR', NULL, NULL, NULL),
(49278, '2017-10-08 13:38:41', NULL, NULL, 13583, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:38:41', 'admin-1507438407-15074411211653261', 1, 1, 'SR', NULL, NULL, NULL),
(49279, '2017-10-08 13:38:34', NULL, NULL, 13583, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:38:34', 'admin-1507438407-15074411139661863', 1, 0, '', NULL, NULL, NULL),
(49280, '2017-10-08 16:40:28', NULL, NULL, 13595, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 16:40:28', 'admin-1507442048-1507452027968325', 1, 1, 'SR', NULL, NULL, NULL),
(49281, '2017-10-08 16:37:53', NULL, NULL, 13597, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 16:37:53', 'admin-1507442048-15074518736634056', 1, 1, 'SR', NULL, NULL, NULL),
(49282, '2017-10-08 16:37:53', NULL, NULL, 13597, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 16:37:53', 'admin-1507442048-15074518736634056', 1, 1, 'SR', NULL, NULL, NULL),
(49283, '2017-10-08 16:37:36', NULL, NULL, 13597, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1507452888', 'admin', '2017-10-08 16:37:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49284, '2017-10-08 16:32:09', NULL, NULL, 13596, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 16:32:09', 'admin-1507442048-15074515292317555', 1, 0, '', NULL, NULL, NULL),
(49285, '2017-10-08 16:31:40', NULL, NULL, 13596, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 16:31:40', 'admin-1507442048-1507451500281121', 1, 1, 'SR', NULL, NULL, NULL),
(49286, '2017-10-08 16:31:40', NULL, NULL, 13596, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 16:31:40', 'admin-1507442048-1507451500281121', 1, 1, 'SR', NULL, NULL, NULL),
(49287, '2017-10-08 16:16:40', NULL, NULL, 13595, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 16:16:40', 'admin-1507442048-1507450600300541', 1, 1, 'SR', NULL, NULL, NULL),
(49288, '2017-10-08 16:31:30', NULL, NULL, 13596, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1507452888', 'admin', '2017-10-08 16:31:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49289, '2017-10-08 16:16:40', NULL, NULL, 13595, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 16:16:40', 'admin-1507442048-1507450600300541', 1, 0, '', NULL, NULL, NULL),
(49290, '2017-10-08 12:40:34', NULL, NULL, 13577, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:40:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49291, '2017-10-08 15:21:43', NULL, NULL, 13593, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1507452888', 'admin', '2017-10-08 15:21:43', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(49292, '2017-10-08 13:38:34', NULL, NULL, 13583, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:38:34', 'admin-1507438407-15074411139661863', 1, 0, '', NULL, NULL, NULL),
(49293, '2017-10-08 13:38:18', NULL, NULL, 13583, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:38:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49294, '2017-10-08 13:31:28', NULL, NULL, 13582, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:31:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49295, '2017-10-08 15:23:13', NULL, NULL, 13594, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 15:23:13', 'admin-1507442048-15074473927943373', 1, 1, 'SR', NULL, NULL, NULL),
(49296, '2017-10-08 13:55:28', NULL, NULL, 13586, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:55:28', 'admin-1507442048-15074421284894328', 1, 0, '', NULL, NULL, NULL),
(49297, '2017-10-08 13:38:34', NULL, NULL, 13583, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:38:34', 'admin-1507438407-15074411139661863', 1, 0, '', NULL, NULL, NULL),
(49298, '2017-10-08 12:19:18', NULL, NULL, 13573, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.00, 0.0000, 0.0000, 10.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:19:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49299, '2017-10-08 12:20:09', NULL, NULL, 13573, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:20:09', 'admin-1507432281-15074364091044164', 1, 1, 'SR', NULL, NULL, NULL),
(49300, '2017-10-08 12:20:09', NULL, NULL, 13573, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:20:09', 'admin-1507432281-15074364091044164', 1, 0, '', NULL, NULL, NULL),
(49301, '2017-10-08 15:13:50', NULL, NULL, 13592, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 15:13:50', 'admin-1507442048-1507446830357427', 1, 0, '', NULL, NULL, NULL),
(49302, '2017-10-08 15:01:04', NULL, NULL, 13591, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1507452888', 'admin', '2017-10-08 15:01:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49303, '2017-10-08 15:01:08', NULL, NULL, 13591, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 15:01:08', 'admin-1507442048-1507446068667577', 1, 1, 'SR', NULL, NULL, NULL),
(49304, '2017-10-08 14:59:37', NULL, NULL, 13582, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 14:59:37', 'admin-1507442048-15074459772081023', 1, 1, 'SR', NULL, NULL, NULL),
(49305, '2017-10-08 14:59:37', NULL, NULL, 13582, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 14:59:37', 'admin-1507442048-15074459772081023', 1, 1, 'SR', NULL, NULL, NULL),
(49306, '2017-10-08 14:15:41', NULL, NULL, 13581, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 14:15:41', 'admin-1507442048-15074433409968042', 1, 0, '', NULL, NULL, NULL),
(49307, '2017-10-08 14:14:00', NULL, NULL, 13588, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 14:14:00', 'admin-1507442048-15074432402657248', 1, 0, '', NULL, NULL, NULL),
(49308, '2017-10-08 10:44:45', NULL, NULL, 13561, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:44:45', 'admin-1507424713-15074306857727937', 1, 0, '', 1, NULL, NULL),
(49309, '2017-10-08 10:48:18', NULL, NULL, 13559, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:48:18', 'admin-1507424713-15074308984405297', 1, 1, 'SR', NULL, NULL, NULL),
(49310, '2017-10-08 10:48:18', NULL, NULL, 13559, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:48:18', 'admin-1507424713-15074308984405297', 1, 1, 'SR', NULL, NULL, NULL),
(49311, '2017-10-08 13:31:43', NULL, NULL, 13582, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:31:43', 'admin-1507438407-15074407036957098', 1, 1, 'SR', NULL, NULL, NULL),
(49312, '2017-10-08 12:29:53', NULL, NULL, 13575, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:29:53', 'admin-1507432281-15074369935347885', 1, 0, '', NULL, NULL, NULL),
(49313, '2017-10-08 11:12:10', NULL, NULL, 13564, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:12:10', 'admin-1507432281-15074323299029576', 1, 1, 'SR', NULL, NULL, NULL),
(49314, '2017-10-08 13:34:48', NULL, NULL, 13578, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:34:48', 'admin-1507438407-1507440887920281', 1, 0, '', NULL, NULL, NULL),
(49315, '2017-10-08 13:13:45', NULL, NULL, 13580, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:13:45', 'admin-1507438407-1507439625753937', 1, 1, 'SR', NULL, NULL, NULL),
(49316, '2017-10-08 11:33:18', NULL, NULL, 13569, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:33:18', 'admin-1507432281-15074335981222811', 1, 1, 'SR', NULL, NULL, NULL),
(49317, '2017-10-08 13:55:28', NULL, NULL, 13586, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:55:28', 'admin-1507442048-15074421284894328', 1, 0, '', NULL, NULL, NULL),
(49318, '2017-10-08 13:31:43', NULL, NULL, 13582, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:31:43', 'admin-1507438407-15074407036957098', 1, 0, '', NULL, NULL, NULL),
(49319, '2017-10-08 13:20:16', NULL, NULL, 13581, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:20:16', 'admin-1507438407-15074400164743236', 1, 1, 'SR', NULL, NULL, NULL),
(49320, '2017-10-08 13:20:16', NULL, NULL, 13581, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:20:16', 'admin-1507438407-15074400164743236', 1, 1, 'SR', NULL, NULL, NULL),
(49321, '2017-10-08 11:12:54', NULL, NULL, 13566, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:12:54', 'admin-1507432281-15074323739151062', 1, 0, '', NULL, NULL, NULL),
(49322, '2017-10-08 12:05:41', NULL, NULL, 13572, 0, 182, '117', 'Open Drinks ', 'americano promo', 'Cold Drinks', 'Fresh Juice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:05:41', 'admin-1507432281-15074355414409491', 1, 0, '', 1, NULL, NULL),
(49323, '2017-10-08 13:20:04', NULL, NULL, 13581, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:20:04', 'admin-1507438407-15074400043572625', 1, 1, 'SR', NULL, NULL, NULL),
(49324, '2017-10-08 13:13:45', NULL, NULL, 13580, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:13:45', 'admin-1507438407-1507439625753937', 1, 0, '', NULL, NULL, NULL),
(49325, '2017-10-08 13:00:25', NULL, NULL, 13579, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:00:25', 'admin-1507438407-15074388248756494', 1, 0, '', NULL, NULL, NULL),
(49326, '2017-10-08 13:06:26', NULL, NULL, 13578, 0, 181, '116', 'Open Food ', 'Soup', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:06:26', 'admin-1507438407-15074391860539731', 1, 0, '', NULL, NULL, NULL),
(49327, '2017-10-08 13:13:31', NULL, NULL, 13580, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:13:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49328, '2017-10-08 13:55:39', NULL, NULL, 13586, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:55:39', 'admin-1507442048-1507442139282165', 1, 1, 'SR', NULL, NULL, NULL),
(49329, '2017-10-08 11:28:43', NULL, NULL, 13559, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:28:43', 'admin-1507432281-15074333236895267', 1, 1, 'SR', NULL, NULL, NULL),
(49330, '2017-10-08 11:53:50', NULL, NULL, 13566, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:53:50', 'admin-1507432281-15074348300748463', 1, 0, '', NULL, NULL, NULL),
(49331, '2017-10-08 09:46:56', NULL, NULL, 13549, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:46:56', 'admin-1507424713-15074272162992279', 1, 0, '', NULL, NULL, NULL),
(49332, '2017-10-08 09:46:56', NULL, NULL, 13549, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:46:56', 'admin-1507424713-15074272162992279', 1, 1, 'SR', NULL, NULL, NULL),
(49333, '2017-10-08 10:01:34', NULL, NULL, 13552, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:01:34', 'admin-1507424713-15074280947183398', 1, 1, 'SR', NULL, NULL, NULL),
(49334, '2017-10-08 12:59:56', NULL, NULL, 13579, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:59:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49335, '2017-10-08 13:00:25', NULL, NULL, 13579, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:00:25', 'admin-1507438407-15074388248756494', 1, 1, 'SR', NULL, NULL, NULL),
(49336, '2017-10-08 11:33:18', NULL, NULL, 13569, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:33:18', 'admin-1507432281-15074335981222811', 1, 1, 'SR', NULL, NULL, NULL),
(49337, '2017-10-08 13:38:34', NULL, NULL, 13583, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:38:34', 'admin-1507438407-15074411139661863', 1, 0, '', NULL, NULL, NULL),
(49338, '2017-10-08 12:53:15', NULL, NULL, 13578, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:53:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49339, '2017-10-08 12:53:21', NULL, NULL, 13578, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:53:21', 'admin-1507432281-15074384012074224', 1, 0, '', NULL, NULL, NULL),
(49340, '2017-10-08 12:58:43', NULL, NULL, 13578, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:58:43', 'admin-1507438407-15074387228379277', 1, 0, '', NULL, NULL, NULL),
(49341, '2017-10-08 12:58:43', NULL, NULL, 13578, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:58:43', 'admin-1507438407-15074387228379277', 1, 0, '', NULL, NULL, NULL),
(49342, '2017-10-08 12:40:07', NULL, NULL, 13576, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:40:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49343, '2017-10-08 12:40:14', NULL, NULL, 13576, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:40:14', 'admin-1507432281-15074376139325888', 1, 0, '', NULL, NULL, NULL),
(49344, '2017-10-08 12:40:14', NULL, NULL, 13576, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:40:14', 'admin-1507432281-15074376139325888', 1, 1, 'SR', NULL, NULL, NULL),
(49345, '2017-10-08 11:38:59', NULL, NULL, 13555, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:38:59', 'admin-1507432281-15074339389497659', 1, 0, '', NULL, NULL, NULL),
(49346, '2017-10-08 11:41:48', NULL, NULL, 13570, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:41:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49347, '2017-10-08 11:42:02', NULL, NULL, 13570, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:42:02', 'admin-1507432281-15074341226233957', 1, 0, '', NULL, NULL, NULL),
(49348, '2017-10-08 12:42:50', NULL, NULL, 13577, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:42:50', 'admin-1507432281-15074377699582563', 1, 1, 'SR', NULL, NULL, NULL),
(49349, '2017-10-08 12:41:38', NULL, NULL, 13577, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:41:38', 'admin-1507432281-15074376985457960', 1, 1, 'SR', NULL, NULL, NULL),
(49350, '2017-10-08 10:48:18', NULL, NULL, 13559, 0, 300, '236', 'Special Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:48:18', 'admin-1507424713-15074308984405297', 1, 0, '', NULL, NULL, NULL),
(49351, '2017-10-08 12:29:53', NULL, NULL, 13575, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:29:53', 'admin-1507432281-15074369935347885', 1, 1, 'SR', NULL, NULL, NULL),
(49352, '2017-10-08 12:29:53', NULL, NULL, 13575, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:29:53', 'admin-1507432281-15074369935347885', 1, 1, 'SR', NULL, NULL, NULL),
(49353, '2017-10-08 12:29:53', NULL, NULL, 13575, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:29:53', 'admin-1507432281-15074369935347885', 1, 0, '', NULL, NULL, NULL),
(49354, '2017-10-08 11:23:21', NULL, NULL, 13567, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:23:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49355, '2017-10-08 11:23:34', NULL, NULL, 13567, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:23:34', 'admin-1507432281-15074330145439580', 1, 0, '', NULL, NULL, NULL),
(49356, '2017-10-08 11:23:34', NULL, NULL, 13567, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:23:34', 'admin-1507432281-15074330145439580', 1, 0, '', NULL, NULL, NULL),
(49357, '2017-10-08 11:24:03', NULL, NULL, 13567, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:24:03', 'admin-1507432281-15074330429138969', 1, 1, 'SR', NULL, NULL, NULL),
(49358, '2017-10-08 11:24:03', NULL, NULL, 13567, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:24:03', 'admin-1507432281-15074330429138969', 1, 1, 'SR', NULL, NULL, NULL),
(49359, '2017-10-08 10:48:18', NULL, NULL, 13559, 0, 300, '236', 'Special Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:48:18', 'admin-1507424713-15074308984405297', 1, 0, '', NULL, NULL, NULL),
(49360, '2017-10-08 12:29:37', NULL, NULL, 13575, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:29:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49361, '2017-10-08 12:25:41', NULL, NULL, 13574, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:25:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49362, '2017-10-08 12:20:37', NULL, NULL, 13573, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:20:37', 'admin-1507432281-15074364368707824', 1, 1, 'SR', NULL, NULL, NULL),
(49363, '2017-10-08 12:20:37', NULL, NULL, 13573, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:20:37', 'admin-1507432281-15074364368707824', 1, 1, 'SR', NULL, NULL, NULL),
(49364, '2017-10-08 12:20:37', NULL, NULL, 13573, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:20:37', 'admin-1507432281-15074364368707824', 1, 1, 'SR', NULL, NULL, NULL),
(49365, '2017-10-08 12:20:09', NULL, NULL, 13573, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:20:09', 'admin-1507432281-15074364091044164', 1, 0, '', NULL, NULL, NULL),
(49366, '2017-10-08 12:20:09', NULL, NULL, 13573, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 12:20:09', 'admin-1507432281-15074364091044164', 1, 0, '', NULL, NULL, NULL),
(49367, '2017-10-08 11:28:43', NULL, NULL, 13559, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:28:43', 'admin-1507432281-15074333236895267', 1, 1, 'SR', NULL, NULL, NULL),
(49368, '2017-10-08 11:45:37', NULL, NULL, 13571, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:45:37', 'admin-1507432281-15074343373208555', 1, 1, 'SR', NULL, NULL, NULL),
(49369, '2017-10-08 13:38:41', NULL, NULL, 13583, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:38:41', 'admin-1507438407-15074411211653261', 1, 1, 'SR', NULL, NULL, NULL),
(49370, '2017-10-08 11:42:38', NULL, NULL, 13570, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:42:38', 'admin-1507432281-15074341583368517', 1, 1, 'SR', NULL, NULL, NULL),
(49371, '2017-10-08 11:38:59', NULL, NULL, 13555, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:38:59', 'admin-1507432281-15074339389497659', 1, 0, '', NULL, NULL, NULL),
(49372, '2017-10-08 11:38:59', NULL, NULL, 13555, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:38:59', 'admin-1507432281-15074339389497659', 1, 0, '', NULL, NULL, NULL),
(49373, '2017-10-08 11:33:18', NULL, NULL, 13569, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:33:18', 'admin-1507432281-15074335981222811', 1, 1, 'SR', NULL, NULL, NULL),
(49374, '2017-10-08 11:32:33', NULL, NULL, 13569, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:32:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49375, '2017-10-08 11:32:48', NULL, NULL, 13569, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:32:48', 'admin-1507432281-15074335687574350', 1, 0, '', NULL, NULL, NULL),
(49376, '2017-10-08 11:04:41', NULL, NULL, 13559, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 2, 17.00, 34.0000, 0.0000, 34.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:04:41', 'admin-1507424713-15074318817685766', 1, 0, '', NULL, NULL, NULL),
(49377, '2017-10-08 11:04:41', NULL, NULL, 13559, 0, 156, '90', 'House Cheddar Omelet', 'add bacon', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:04:41', 'admin-1507424713-15074318817685766', 1, 0, '', NULL, NULL, NULL),
(49378, '2017-10-08 11:07:05', NULL, NULL, 13563, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:07:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49379, '2017-10-08 11:07:10', NULL, NULL, 13563, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:07:10', 'admin-1507424713-15074320300818569', 1, 1, 'SR', NULL, NULL, NULL),
(49380, '2017-10-08 11:08:59', NULL, NULL, 13564, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.70, 0.0000, 0.0000, 11.70, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:08:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49381, '2017-10-08 11:09:36', NULL, NULL, 13564, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:09:36', 'admin-1507424713-15074321766087731', 1, 0, '', NULL, NULL, NULL),
(49382, '2017-10-08 11:09:36', NULL, NULL, 13564, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 3, 16.00, 48.0000, 0.0000, 48.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:09:36', 'admin-1507424713-15074321766087731', 1, 0, '', NULL, NULL, NULL),
(49383, '2017-10-08 09:15:10', NULL, NULL, 13546, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:15:10', 'admin-1507424713-15074253107167418', 1, 0, '', NULL, NULL, NULL),
(49384, '2017-10-08 13:52:08', NULL, NULL, 13585, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 13:52:08', 'admin-1507438407-15074419279005412', 1, 0, '', NULL, NULL, NULL),
(49385, '2017-10-08 11:28:49', NULL, NULL, 13568, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:28:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49386, '2017-10-08 11:28:43', NULL, NULL, 13559, 0, 300, '236', 'Special Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:28:43', 'admin-1507432281-15074333236895267', 1, 0, '', NULL, NULL, NULL),
(49387, '2017-10-08 11:30:18', NULL, NULL, 13568, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:30:18', 'admin-1507432281-15074334180933830', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(49388, '2017-10-08 11:28:43', NULL, NULL, 13559, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:28:43', 'admin-1507432281-15074333236895267', 1, 1, 'SR', NULL, NULL, NULL),
(49389, '2017-10-08 11:28:43', NULL, NULL, 13559, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:28:43', 'admin-1507432281-15074333236895267', 1, 1, 'SR', NULL, NULL, NULL),
(49390, '2017-10-08 10:48:18', NULL, NULL, 13559, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:48:18', 'admin-1507424713-15074308984405297', 1, 1, 'SR', NULL, NULL, NULL),
(49391, '2017-10-08 10:48:42', NULL, NULL, 13562, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:48:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49392, '2017-10-08 10:48:48', NULL, NULL, 13562, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:48:48', 'admin-1507424713-15074309286108421', 1, 0, '', NULL, NULL, NULL),
(49393, '2017-10-08 10:48:48', NULL, NULL, 13562, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:48:48', 'admin-1507424713-15074309286108421', 1, 0, '', NULL, NULL, NULL),
(49394, '2017-10-08 10:58:51', NULL, NULL, 13555, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:58:51', 'admin-1507424713-15074315317844637', 1, 1, 'SR', NULL, NULL, NULL),
(49395, '2017-10-08 11:02:29', NULL, NULL, 13555, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:02:29', 'admin-1507424713-15074317493274698', 1, 0, '', NULL, NULL, NULL),
(49396, '2017-10-08 10:40:07', NULL, NULL, 13559, 0, 300, '236', 'Special Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:40:07', 'admin-1507424713-1507430406872441', 1, 0, '', NULL, NULL, NULL),
(49397, '2017-10-08 11:12:37', NULL, NULL, 13566, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:12:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49398, '2017-10-08 11:12:54', NULL, NULL, 13566, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:12:54', 'admin-1507432281-15074323739151062', 1, 0, '', NULL, NULL, NULL),
(49399, '2017-10-08 11:12:10', NULL, NULL, 13564, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:12:10', 'admin-1507432281-15074323299029576', 1, 1, 'SR', NULL, NULL, NULL),
(49400, '2017-10-08 11:12:10', NULL, NULL, 13564, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:12:10', 'admin-1507432281-15074323299029576', 1, 1, 'SR', NULL, NULL, NULL),
(49401, '2017-10-08 11:12:10', NULL, NULL, 13564, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:12:10', 'admin-1507432281-15074323299029576', 1, 1, 'SR', NULL, NULL, NULL),
(49402, '2017-10-08 11:12:10', NULL, NULL, 13564, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:12:10', 'admin-1507432281-15074323299029576', 1, 0, '', NULL, NULL, NULL),
(49403, '2017-10-08 11:04:41', NULL, NULL, 13559, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 3, 16.00, 48.0000, 0.0000, 48.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:04:41', 'admin-1507424713-15074318817685766', 1, 0, '', NULL, NULL, NULL),
(49404, '2017-10-08 11:30:18', NULL, NULL, 13568, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 11:30:18', 'admin-1507432281-15074334180933830', 1, 1, 'SR', NULL, NULL, NULL),
(49405, '2017-10-08 16:16:33', NULL, NULL, 13595, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.90, 0.0000, 0.0000, 11.90, 1, '27', 1, '1507452888', 'admin', '2017-10-08 16:16:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49406, '2017-10-08 10:44:12', NULL, NULL, 13556, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:44:12', 'admin-1507424713-15074306520626057', 1, 1, 'SR', NULL, NULL, NULL),
(49407, '2017-10-08 10:44:32', NULL, NULL, 13561, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:44:32', 'admin-1507424713-15074306725401813', 1, 0, '', 1, NULL, NULL),
(49408, '2017-10-08 10:28:43', NULL, NULL, 13559, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:28:43', 'admin-1507424713-1507429723709376', 1, 1, 'SR', NULL, NULL, NULL),
(49409, '2017-10-08 10:20:03', NULL, NULL, 13557, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:20:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49410, '2017-10-08 10:04:28', NULL, NULL, 13550, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:04:28', 'admin-1507424713-15074282681504953', 1, 1, 'SR', NULL, NULL, NULL),
(49411, '2017-10-08 10:07:15', NULL, NULL, 13554, 0, 182, '117', 'Open Drinks ', 'americano', 'Cold Drinks', 'Fresh Juice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:07:15', 'admin-1507424713-1507428435652405', 1, 0, '', 1, NULL, NULL),
(49412, '2017-10-08 10:15:35', NULL, NULL, 13555, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.89, 0.0000, 0.0000, 4.89, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:15:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49413, '2017-10-08 10:15:46', NULL, NULL, 13555, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:15:46', 'admin-1507424713-15074289460741265', 1, 1, 'SR', NULL, NULL, NULL),
(49414, '2017-10-08 10:16:25', NULL, NULL, 13556, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:16:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49415, '2017-10-08 10:16:33', NULL, NULL, 13556, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:16:33', 'admin-1507424713-1507428992961619', 1, 1, 'SR', NULL, NULL, NULL),
(49416, '2017-10-08 10:20:57', NULL, NULL, 13557, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:20:57', 'admin-1507424713-15074292568609717', 1, 1, 'SR', NULL, NULL, NULL),
(49417, '2017-10-08 10:02:34', NULL, NULL, 13553, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:02:34', 'admin-1507424713-15074281544443143', 1, 0, '', NULL, NULL, NULL),
(49418, '2017-10-08 10:02:34', NULL, NULL, 13553, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:02:34', 'admin-1507424713-15074281544443143', 1, 0, '', NULL, NULL, NULL),
(49419, '2017-10-08 10:02:34', NULL, NULL, 13553, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:02:34', 'admin-1507424713-15074281544443143', 1, 1, 'SR', NULL, NULL, NULL),
(49420, '2017-10-08 10:28:43', NULL, NULL, 13559, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:28:43', 'admin-1507424713-1507429723709376', 1, 1, 'SR', NULL, NULL, NULL),
(49421, '2017-10-08 10:28:32', NULL, NULL, 13559, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 26.00, 0.0000, 0.0000, 26.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:28:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49422, '2017-10-08 10:20:57', NULL, NULL, 13557, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:20:57', 'admin-1507424713-15074292568609717', 1, 0, '', NULL, NULL, NULL),
(49423, '2017-10-08 10:04:28', NULL, NULL, 13550, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:04:28', 'admin-1507424713-15074282681504953', 1, 1, 'SR', NULL, NULL, NULL),
(49424, '2017-10-08 09:17:52', NULL, NULL, 13547, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.10, 0.0000, 0.0000, 13.10, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:17:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49425, '2017-10-08 09:20:04', NULL, NULL, 13547, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:20:04', 'admin-1507424713-15074256046125379', 1, 0, '', NULL, NULL, NULL),
(49426, '2017-10-08 09:57:30', NULL, NULL, 13550, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:57:30', 'admin-1507424713-1507427850054448', 1, 0, '', NULL, NULL, NULL),
(49427, '2017-10-08 09:57:30', NULL, NULL, 13550, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:57:30', 'admin-1507424713-1507427850054448', 1, 1, 'SR', NULL, NULL, NULL),
(49428, '2017-10-08 09:57:30', NULL, NULL, 13550, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:57:30', 'admin-1507424713-1507427850054448', 1, 1, 'SR', NULL, NULL, NULL),
(49429, '2017-10-08 09:57:30', NULL, NULL, 13550, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:57:30', 'admin-1507424713-1507427850054448', 1, 1, 'SR', NULL, NULL, NULL),
(49430, '2017-10-08 09:59:58', NULL, NULL, 13552, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:59:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49431, '2017-10-08 10:01:22', NULL, NULL, 13552, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:01:22', 'admin-1507424713-15074280821236745', 1, 0, '', NULL, NULL, NULL),
(49432, '2017-10-08 10:01:22', NULL, NULL, 13552, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:01:22', 'admin-1507424713-15074280821236745', 1, 0, '', NULL, NULL, NULL),
(49433, '2017-10-08 09:24:01', NULL, NULL, 13548, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:24:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49434, '2017-10-08 09:27:00', NULL, NULL, 13548, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:27:00', 'admin-1507424713-1507426020465550', 1, 0, '', NULL, NULL, NULL),
(49435, '2017-10-08 10:02:06', NULL, NULL, 13553, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:02:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49436, '2017-10-08 09:46:36', NULL, NULL, 13549, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:46:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49437, '2017-10-08 10:02:34', NULL, NULL, 13553, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 10:02:34', 'admin-1507424713-15074281544443143', 1, 1, 'SR', NULL, NULL, NULL),
(49438, '2017-10-08 09:20:39', NULL, NULL, 13547, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:20:39', 'admin-1507424713-1507425639155905', 1, 1, 'SR', NULL, NULL, NULL),
(49439, '2017-10-08 09:20:39', NULL, NULL, 13547, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:20:39', 'admin-1507424713-1507425639155905', 1, 1, 'SR', NULL, NULL, NULL),
(49440, '2017-10-08 09:20:39', NULL, NULL, 13547, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:20:39', 'admin-1507424713-1507425639155905', 1, 0, '', NULL, NULL, NULL),
(49441, '2017-10-08 09:20:04', NULL, NULL, 13547, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:20:04', 'admin-1507424713-15074256046125379', 1, 0, '', NULL, NULL, NULL),
(49442, '2017-10-08 09:57:20', NULL, NULL, 13550, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:57:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49443, '2017-10-08 09:20:04', NULL, NULL, 13547, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:20:04', 'admin-1507424713-15074256046125379', 1, 0, '', NULL, NULL, NULL),
(49444, '2017-10-08 09:20:04', NULL, NULL, 13547, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:20:04', 'admin-1507424713-15074256046125379', 1, 0, '', NULL, NULL, NULL),
(49445, '2017-10-08 09:20:04', NULL, NULL, 13547, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:20:04', 'admin-1507424713-15074256046125379', 1, 0, '', NULL, NULL, NULL),
(49446, '2017-10-08 09:15:16', NULL, NULL, 13546, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:15:16', 'admin-1507424713-15074253157476442', 1, 1, 'SR', NULL, NULL, NULL),
(49447, '2017-10-08 09:15:01', NULL, NULL, 13546, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1507452888', 'admin', '2017-10-08 09:15:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49448, '2017-10-09 13:49:35', NULL, NULL, 13614, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1507535722', 'admin', '2017-10-09 13:49:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49449, '2017-10-09 00:00:00', NULL, NULL, 13614, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:08:21', 'admin-1507511191-1507522101446145', 1, 0, '', NULL, NULL, NULL),
(49450, '2017-10-09 00:00:00', NULL, NULL, 13615, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:08:21', 'admin-1507511191-1507522101446145', 1, 1, 'SR', NULL, NULL, NULL),
(49451, '2017-10-09 11:27:14', NULL, NULL, 13605, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 11:27:14', 'admin-1507511191-15075196343198326', 1, 1, 'SR', NULL, NULL, NULL),
(49452, '2017-10-09 11:51:55', NULL, NULL, 13606, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1507535722', 'admin', '2017-10-09 11:51:55', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(49453, '2017-10-09 11:52:05', NULL, NULL, 13606, 0, 73, '73', 'Marmite Chicken ', 'Less chicken', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 11:52:05', 'admin-1507511191-15075211252613856', 1, 1, 'SR', NULL, NULL, '10.0'),
(49454, '2017-10-09 11:59:34', NULL, NULL, 13606, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 11:59:34', 'admin-1507511191-15075215740986562', 1, 1, 'SR', NULL, NULL, '10.0'),
(49455, '2017-10-09 12:38:12', NULL, NULL, 13610, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:38:12', 'admin-1507522881-15075238920644372', 1, 0, '', NULL, NULL, '10.0'),
(49456, '2017-10-09 12:38:12', NULL, NULL, 13610, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:38:12', 'admin-1507522881-15075238920644372', 1, 0, '', NULL, NULL, '10.0'),
(49457, '2017-10-09 12:38:12', NULL, NULL, 13610, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:38:12', 'admin-1507522881-15075238920644372', 1, 1, 'SR', NULL, NULL, '10.0'),
(49458, '2017-10-09 09:58:23', NULL, NULL, 13601, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 09:58:23', 'admin-1507511191-15075143028968836', 1, 1, 'SR', NULL, NULL, NULL),
(49459, '2017-10-09 16:06:27', NULL, NULL, 13621, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 16:06:27', 'admin-1507535722-15075363869642835', 1, 1, 'SR', NULL, NULL, NULL),
(49460, '2017-10-09 16:06:27', NULL, NULL, 13621, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 16:06:27', 'admin-1507535722-15075363869642835', 1, 1, 'SR', NULL, NULL, NULL),
(49461, '2017-10-09 17:01:02', NULL, NULL, 13622, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 17:01:02', 'admin-1507535722-15075396625438284', 1, 1, 'SR', 1, NULL, '10.0'),
(49462, '2017-10-09 14:00:14', NULL, NULL, 13616, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 14:00:14', 'admin-1507522881-15075288145741476', 1, 1, 'SR', NULL, NULL, NULL),
(49463, '2017-10-09 14:06:21', NULL, NULL, 13617, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1507535722', 'admin', '2017-10-09 14:06:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49464, '2017-10-09 12:21:17', NULL, NULL, 13609, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:21:17', 'admin-1507511191-1507522876998813', 1, 1, 'SR', NULL, NULL, NULL),
(49465, '2017-10-09 12:21:17', NULL, NULL, 13609, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:21:17', 'admin-1507511191-1507522876998813', 1, 1, 'SR', NULL, NULL, NULL),
(49466, '2017-10-09 12:21:51', NULL, NULL, 13609, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:21:51', 'admin-1507522881-15075229117954026', 1, 1, 'SR', NULL, NULL, NULL),
(49467, '2017-10-09 12:21:51', NULL, NULL, 13609, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:21:51', 'admin-1507522881-15075229117954026', 1, 1, 'SR', NULL, NULL, NULL),
(49468, '2017-10-09 12:38:12', NULL, NULL, 13610, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', 'fried', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:38:12', 'admin-1507522881-15075238920644372', 1, 0, '', NULL, NULL, '10.0'),
(49469, '2017-10-09 12:38:12', NULL, NULL, 13610, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:38:12', 'admin-1507522881-15075238920644372', 1, 0, '', NULL, NULL, '10.0'),
(49470, '2017-10-09 12:38:33', NULL, NULL, 13610, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:38:33', 'admin-1507522881-15075239130168446', 1, 1, 'SR', NULL, NULL, '10.0'),
(49471, '2017-10-09 12:39:35', NULL, NULL, 13611, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:39:35', 'admin-1507522881-15075239751532219', 1, 0, '', NULL, NULL, NULL),
(49472, '2017-10-09 12:21:51', NULL, NULL, 13609, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:21:51', 'admin-1507522881-15075229117954026', 1, 1, 'SR', NULL, NULL, NULL),
(49473, '2017-10-09 12:21:51', NULL, NULL, 13609, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:21:51', 'admin-1507522881-15075229117954026', 1, 0, '', NULL, NULL, NULL),
(49474, '2017-10-09 12:37:45', NULL, NULL, 13610, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.60, 0.0000, 0.0000, 10.60, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:37:45', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(49475, '2017-10-09 13:08:54', NULL, NULL, 13610, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 13:08:54', 'admin-1507522881-1507525734758929', 1, 1, 'SR', NULL, NULL, '10.0'),
(49476, '2017-10-09 13:14:35', NULL, NULL, 13613, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1507535722', 'admin', '2017-10-09 13:14:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49477, '2017-10-09 16:06:21', NULL, NULL, 13621, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 16:06:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49478, '2017-10-09 10:10:15', NULL, NULL, 13602, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 10:10:15', 'admin-1507511191-15075150155874559', 1, 1, 'SR', NULL, NULL, NULL),
(49479, '2017-10-09 10:55:33', NULL, NULL, 13603, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1507535722', 'admin', '2017-10-09 10:55:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49480, '2017-10-09 10:55:42', NULL, NULL, 13603, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 10:55:42', 'admin-1507511191-15075177421949416', 1, 1, 'SR', NULL, NULL, NULL),
(49481, '2017-10-09 10:55:42', NULL, NULL, 13603, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 2, 11.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 10:55:42', 'admin-1507511191-15075177421949416', 1, 1, 'SR', NULL, NULL, NULL),
(49482, '2017-10-09 12:20:11', NULL, NULL, 13609, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:20:11', 'admin-1507511191-15075228115059629', 1, 0, '', NULL, NULL, NULL),
(49483, '2017-10-09 09:58:08', NULL, NULL, 13601, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 09:58:08', 'admin-1507511191-15075142886719871', 1, 0, '', NULL, NULL, NULL),
(49484, '2017-10-09 12:39:35', NULL, NULL, 13611, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:39:35', 'admin-1507522881-15075239751532219', 1, 0, '', NULL, NULL, NULL),
(49485, '2017-10-09 12:39:35', NULL, NULL, 13611, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:39:35', 'admin-1507522881-15075239751532219', 1, 1, 'SR', NULL, NULL, NULL),
(49486, '2017-10-09 12:39:35', NULL, NULL, 13611, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:39:35', 'admin-1507522881-15075239751532219', 1, 1, 'SR', NULL, NULL, NULL),
(49487, '2017-10-09 12:39:35', NULL, NULL, 13611, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:39:35', 'admin-1507522881-15075239751532219', 1, 1, 'SR', NULL, NULL, NULL),
(49488, '2017-10-09 12:55:59', NULL, NULL, 13612, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:55:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49489, '2017-10-09 12:56:11', NULL, NULL, 13612, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:56:11', 'admin-1507522881-15075249714666551', 1, 0, '', NULL, NULL, NULL),
(49490, '2017-10-09 11:59:34', NULL, NULL, 13606, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 11:59:34', 'admin-1507511191-15075215740986562', 1, 0, '', NULL, NULL, '10.0'),
(49491, '2017-10-09 17:01:02', NULL, NULL, 13622, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 17:01:02', 'admin-1507535722-15075396625438284', 1, 1, 'SR', 1, NULL, '10.0'),
(49492, '2017-10-09 14:55:02', NULL, NULL, 13620, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 14:55:02', 'admin-1507522881-15075321025361092', 1, 1, 'SR', NULL, NULL, NULL),
(49493, '2017-10-09 12:18:43', NULL, NULL, 13609, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 20.00, 0.0000, 0.0000, 20.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:18:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49494, '2017-10-09 12:20:11', NULL, NULL, 13609, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:20:11', 'admin-1507511191-15075228115059629', 1, 0, '', NULL, NULL, NULL),
(49495, '2017-10-09 12:39:15', NULL, NULL, 13611, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:39:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49496, '2017-10-09 14:55:02', NULL, NULL, 13620, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 14:55:02', 'admin-1507522881-15075321025361092', 1, 0, '', NULL, NULL, NULL),
(49497, '2017-10-09 14:54:37', NULL, NULL, 13620, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1507535722', 'admin', '2017-10-09 14:54:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49498, '2017-10-09 14:24:47', NULL, NULL, 13619, 0, 182, '117', 'Open Drinks ', 'CRaft beer', 'Cold Drinks', 'Fresh Juice', 1, 151.20, 151.2000, 0.0000, 151.20, 1, '27', 1, '1507535722', 'admin', '2017-10-09 14:24:47', 'admin-1507522881-15075302876908698', 1, 0, '', NULL, NULL, NULL),
(49499, '2017-10-09 14:54:50', NULL, NULL, 13620, 0, 181, '116', 'Open Food ', 'fries', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 14:54:50', 'admin-1507522881-15075320906376614', 1, 0, '', NULL, NULL, NULL),
(49500, '2017-10-09 14:14:18', NULL, NULL, 13617, 0, 181, '116', 'Open Food ', 'crossaint', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 14:14:18', 'admin-1507522881-15075296579109530', 1, 0, '', NULL, NULL, NULL),
(49501, '2017-10-09 14:06:32', NULL, NULL, 13617, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 14:06:32', 'admin-1507522881-1507529191886846', 1, 1, 'SR', NULL, NULL, NULL),
(49502, '2017-10-09 14:06:32', NULL, NULL, 13617, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 14:06:32', 'admin-1507522881-1507529191886846', 1, 1, 'SR', NULL, NULL, NULL),
(49503, '2017-10-09 00:00:00', NULL, NULL, 13615, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:08:21', 'admin-1507511191-1507522101446145', 1, 0, '', NULL, NULL, NULL),
(49504, '2017-10-09 14:06:25', NULL, NULL, 13617, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 14:06:25', 'admin-1507522881-15075291856959768', 1, 0, '', NULL, NULL, NULL),
(49505, '2017-10-09 00:00:00', NULL, NULL, 13614, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:08:21', 'admin-1507511191-1507522101446145', 1, 1, 'SR', NULL, NULL, NULL),
(49506, '2017-10-09 13:14:38', NULL, NULL, 13613, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 13:14:38', 'admin-1507522881-15075260784278516', 1, 1, 'SR', NULL, NULL, NULL),
(49507, '2017-10-09 13:08:39', NULL, NULL, 13611, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 13:08:39', 'admin-1507522881-1507525719741314', 1, 1, 'SR', NULL, NULL, NULL),
(49508, '2017-10-09 12:56:11', NULL, NULL, 13612, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:56:11', 'admin-1507522881-15075249714666551', 1, 0, '', NULL, NULL, NULL),
(49509, '2017-10-09 12:56:18', NULL, NULL, 13612, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 2, 11.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:56:18', 'admin-1507522881-15075249781522219', 1, 1, 'SR', NULL, NULL, NULL),
(49510, '2017-10-09 12:39:35', NULL, NULL, 13611, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:39:35', 'admin-1507522881-15075239751532219', 1, 0, '', NULL, NULL, NULL),
(49511, '2017-10-09 10:57:02', NULL, NULL, 13604, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 10:57:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49512, '2017-10-09 10:57:06', NULL, NULL, 13604, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 10:57:06', 'admin-1507511191-15075178259936226', 1, 0, '', NULL, NULL, NULL),
(49513, '2017-10-09 12:20:11', NULL, NULL, 13609, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:20:11', 'admin-1507511191-15075228115059629', 1, 1, 'SR', NULL, NULL, NULL),
(49514, '2017-10-09 11:59:40', NULL, NULL, 13606, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 11:59:40', 'admin-1507511191-15075215805438432', 1, 0, '', NULL, NULL, '10.0'),
(49515, '2017-10-09 00:00:00', NULL, NULL, 13615, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, NULL, NULL, 3.30, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:04:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49516, '2017-10-09 14:00:10', NULL, NULL, 13616, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 14:00:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49517, '2017-10-09 10:07:29', NULL, NULL, 13602, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 10:07:29', 'admin-1507511191-15075148488852440', 1, 0, '', NULL, NULL, NULL),
(49518, '2017-10-09 12:20:11', NULL, NULL, 13609, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:20:11', 'admin-1507511191-15075228115059629', 1, 0, '', NULL, NULL, NULL),
(49519, '2017-10-09 12:20:11', NULL, NULL, 13609, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:20:11', 'admin-1507511191-15075228115059629', 1, 0, '', NULL, NULL, NULL),
(49520, '2017-10-09 12:20:11', NULL, NULL, 13609, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:20:11', 'admin-1507511191-15075228115059629', 1, 0, '', NULL, NULL, NULL),
(49521, '2017-10-09 12:20:11', NULL, NULL, 13609, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:20:11', 'admin-1507511191-15075228115059629', 1, 0, '', NULL, NULL, NULL),
(49522, '2017-10-09 10:57:06', NULL, NULL, 13604, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 10:57:06', 'admin-1507511191-15075178259936226', 1, 0, '', NULL, NULL, NULL),
(49523, '2017-10-09 10:57:15', NULL, NULL, 13604, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 10:57:15', 'admin-1507511191-15075178356603041', 1, 1, 'SR', NULL, NULL, NULL),
(49524, '2017-10-09 10:57:15', NULL, NULL, 13604, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 10:57:15', 'admin-1507511191-15075178356603041', 1, 1, 'SR', NULL, NULL, NULL),
(49525, '2017-10-09 11:27:10', NULL, NULL, 13605, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 11:27:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49526, '2017-10-09 12:13:32', NULL, NULL, 13608, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:13:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49527, '2017-10-09 12:13:37', NULL, NULL, 13608, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:13:37', 'admin-1507511191-15075224175668787', 1, 1, 'SR', NULL, NULL, NULL),
(49528, '2017-10-09 12:13:37', NULL, NULL, 13608, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:13:37', 'admin-1507511191-15075224175668787', 1, 1, 'SR', NULL, NULL, NULL),
(49529, '2017-10-09 10:07:23', NULL, NULL, 13602, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 10:07:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49530, '2017-10-09 09:19:38', NULL, NULL, 13598, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 09:19:38', 'admin-1507511191-1507511978617676', 1, 0, '', NULL, NULL, NULL),
(49531, '2017-10-09 09:19:38', NULL, NULL, 13598, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 09:19:38', 'admin-1507511191-1507511978617676', 1, 0, '', NULL, NULL, NULL),
(49532, '2017-10-09 09:20:25', NULL, NULL, 13598, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 09:20:25', 'admin-1507511191-15075120254941770', 1, 1, 'SR', NULL, NULL, NULL),
(49533, '2017-10-09 09:20:25', NULL, NULL, 13598, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 09:20:25', 'admin-1507511191-15075120254941770', 1, 0, '', NULL, NULL, NULL),
(49534, '2017-10-09 09:20:25', NULL, NULL, 13598, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 09:20:25', 'admin-1507511191-15075120254941770', 1, 1, 'SR', NULL, NULL, NULL),
(49535, '2017-10-09 09:46:24', NULL, NULL, 13599, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1507535722', 'admin', '2017-10-09 09:46:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49536, '2017-10-09 09:46:35', NULL, NULL, 13599, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 09:46:35', 'admin-1507511191-15075135951069455', 1, 0, '', NULL, NULL, NULL),
(49537, '2017-10-09 09:46:35', NULL, NULL, 13599, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 09:46:35', 'admin-1507511191-15075135951069455', 1, 0, '', NULL, NULL, NULL),
(49538, '2017-10-09 09:46:35', NULL, NULL, 13599, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 09:46:35', 'admin-1507511191-15075135951069455', 1, 1, 'SR', NULL, NULL, NULL),
(49539, '2017-10-09 09:46:35', NULL, NULL, 13599, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 09:46:35', 'admin-1507511191-15075135951069455', 1, 1, 'SR', NULL, NULL, NULL),
(49540, '2017-10-09 09:47:57', NULL, NULL, 13600, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1507535722', 'admin', '2017-10-09 09:47:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49541, '2017-10-09 09:48:00', NULL, NULL, 13600, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 09:48:00', 'admin-1507511191-15075136802635046', 1, 1, 'SR', NULL, NULL, NULL),
(49542, '2017-10-09 10:55:42', NULL, NULL, 13603, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 10:55:42', 'admin-1507511191-15075177421949416', 1, 1, 'SR', NULL, NULL, NULL),
(49543, '2017-10-09 12:20:11', NULL, NULL, 13609, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 12:20:11', 'admin-1507511191-15075228115059629', 1, 0, '', NULL, NULL, NULL),
(49544, '2017-10-09 09:58:26', NULL, NULL, 13601, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 09:58:26', 'admin-1507511191-15075143066206118', 1, 1, 'SR', NULL, NULL, NULL),
(49545, '2017-10-09 09:58:23', NULL, NULL, 13601, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 09:58:23', 'admin-1507511191-15075143028968836', 1, 1, 'SR', NULL, NULL, NULL),
(49546, '2017-10-09 09:58:23', NULL, NULL, 13601, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 09:58:23', 'admin-1507511191-15075143028968836', 1, 1, 'SR', NULL, NULL, NULL),
(49547, '2017-10-09 09:58:08', NULL, NULL, 13601, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 09:58:08', 'admin-1507511191-15075142886719871', 1, 0, '', NULL, NULL, NULL),
(49548, '2017-10-09 09:57:59', NULL, NULL, 13601, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.00, 0.0000, 0.0000, 11.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 09:57:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49549, '2017-10-09 09:58:08', NULL, NULL, 13601, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 09:58:08', 'admin-1507511191-15075142886719871', 1, 0, '', NULL, NULL, NULL),
(49550, '2017-10-09 09:58:08', NULL, NULL, 13601, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507535722', 'admin', '2017-10-09 09:58:08', 'admin-1507511191-15075142886719871', 1, 0, '', NULL, NULL, NULL),
(49551, '2017-10-09 09:17:14', NULL, NULL, 13598, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1507535722', 'admin', '2017-10-09 09:17:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49552, '2017-10-11 15:38:37', NULL, NULL, 13647, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 15:38:37', 'admin-1507689985-15077075174413055', 1, 1, 'SR', NULL, NULL, NULL),
(49553, '2017-10-11 15:31:24', NULL, NULL, 13643, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 15:31:24', 'admin-1507689985-1507707083795462', 1, 1, 'SR', NULL, NULL, '10.0'),
(49554, '2017-10-11 15:38:33', NULL, NULL, 13647, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 15:38:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49555, '2017-10-11 10:44:54', NULL, NULL, 13632, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 10:44:54', 'admin-1507684036-15076898941855541', 1, 0, '', NULL, NULL, NULL),
(49556, '2017-10-11 10:44:54', NULL, NULL, 13632, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 10:44:54', 'admin-1507684036-15076898941855541', 1, 0, '', NULL, NULL, NULL),
(49557, '2017-10-11 10:44:54', NULL, NULL, 13632, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 10:44:54', 'admin-1507684036-15076898941855541', 1, 0, '', NULL, NULL, NULL),
(49558, '2017-10-11 10:44:54', NULL, NULL, 13632, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 10:44:54', 'admin-1507684036-15076898941855541', 1, 1, 'SR', NULL, NULL, NULL),
(49559, '2017-10-11 16:03:06', NULL, NULL, 13649, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1507715050', 'admin', '2017-10-11 16:03:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49560, '2017-10-11 16:03:09', NULL, NULL, 13649, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 16:03:09', 'admin-1507689985-1507708989547235', 1, 1, 'SR', NULL, NULL, NULL),
(49561, '2017-10-11 16:19:54', NULL, NULL, 13643, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 16:19:54', 'admin-1507689985-1507709994708259', 1, 0, '', NULL, NULL, '10.0'),
(49562, '2017-10-11 14:17:14', NULL, NULL, 13642, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.95, 0.0000, 0.0000, 1.95, 1, '27', 1, '1507715050', 'admin', '2017-10-11 14:17:14', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(49563, '2017-10-11 14:17:20', NULL, NULL, 13642, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 14:17:20', 'admin-1507689985-1507702640216843', 1, 0, '', NULL, NULL, '10.0'),
(49564, '2017-10-11 14:22:18', NULL, NULL, 13642, 0, 181, '116', 'Open Food ', 'Egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1507715050', 'admin', '2017-10-11 14:22:18', 'admin-1507689985-1507702938007164', 1, 0, '', NULL, NULL, '10.0'),
(49565, '2017-10-11 09:22:33', NULL, NULL, 13624, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:22:33', 'admin-1507684036-15076849530362975', 1, 0, '', NULL, NULL, NULL),
(49566, '2017-10-11 10:24:56', NULL, NULL, 13631, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1507715050', 'admin', '2017-10-11 10:24:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49567, '2017-10-11 12:26:14', NULL, NULL, 13641, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1507715050', 'admin', '2017-10-11 12:26:14', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(49568, '2017-10-11 12:26:36', NULL, NULL, 13641, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 12:26:36', 'admin-1507689985-1507695996487639', 1, 1, 'SR', NULL, NULL, '10.0'),
(49569, '2017-10-11 12:26:36', NULL, NULL, 13641, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 12:26:36', 'admin-1507689985-1507695996487639', 1, 1, 'SR', NULL, NULL, '10.0'),
(49570, '2017-10-11 11:25:29', NULL, NULL, 13637, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:25:29', 'admin-1507689985-15076923289464093', 1, 0, '', NULL, NULL, NULL),
(49571, '2017-10-11 11:25:29', NULL, NULL, 13637, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:25:29', 'admin-1507689985-15076923289464093', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(49572, '2017-10-11 10:46:21', NULL, NULL, 13633, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1507715050', 'admin', '2017-10-11 10:46:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49573, '2017-10-11 10:46:36', NULL, NULL, 13633, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 10:46:36', 'admin-1507689985-1507689996117435', 1, 0, '', NULL, NULL, NULL),
(49574, '2017-10-11 10:46:36', NULL, NULL, 13633, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 10:46:36', 'admin-1507689985-1507689996117435', 1, 0, '', NULL, NULL, NULL),
(49575, '2017-10-11 10:49:28', NULL, NULL, 13634, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1507715050', 'admin', '2017-10-11 10:49:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49576, '2017-10-11 10:49:32', NULL, NULL, 13634, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 10:49:32', 'admin-1507689985-15076901724871280', 1, 0, '', NULL, NULL, NULL),
(49577, '2017-10-11 15:18:32', NULL, NULL, 13644, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 15:18:32', 'admin-1507689985-15077063118617214', 1, 1, 'SR', NULL, NULL, NULL),
(49578, '2017-10-11 15:18:32', NULL, NULL, 13644, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 15:18:32', 'admin-1507689985-15077063118617214', 1, 1, 'SR', NULL, NULL, NULL),
(49579, '2017-10-11 15:11:08', NULL, NULL, 13643, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 15:11:08', 'admin-1507689985-15077058679611099', 1, 1, 'SR', NULL, NULL, '10.0'),
(49580, '2017-10-11 15:18:00', NULL, NULL, 13644, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1507715050', 'admin', '2017-10-11 15:18:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49581, '2017-10-11 11:37:19', NULL, NULL, 13636, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:37:19', 'admin-1507689985-15076930388748588', 1, 0, '', NULL, NULL, '10.0'),
(49582, '2017-10-11 12:00:12', NULL, NULL, 13638, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 12:00:12', 'admin-1507689985-15076944122338051', 1, 0, '', NULL, NULL, NULL),
(49583, '2017-10-11 12:06:00', NULL, NULL, 13639, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1507715050', 'admin', '2017-10-11 12:06:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49584, '2017-10-11 12:06:05', NULL, NULL, 13639, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 12:06:05', 'admin-1507689985-15076947656804883', 1, 0, '', NULL, NULL, NULL),
(49585, '2017-10-11 16:24:19', NULL, NULL, 13650, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1507715050', 'admin', '2017-10-11 16:24:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49586, '2017-10-11 16:25:29', NULL, NULL, 13650, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 16:25:29', 'admin-1507689985-1507710329259269', 1, 0, '', NULL, NULL, NULL),
(49587, '2017-10-11 15:11:02', NULL, NULL, 13643, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1507715050', 'admin', '2017-10-11 15:11:02', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(49588, '2017-10-11 14:53:16', NULL, NULL, 13642, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 14:53:16', 'admin-1507689985-15077047962027079', 1, 1, 'SR', NULL, NULL, '10.0'),
(49589, '2017-10-11 15:31:04', NULL, NULL, 13646, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 15:31:04', 'admin-1507689985-15077070644773185', 1, 0, '', 1, NULL, NULL),
(49590, '2017-10-11 11:17:26', NULL, NULL, 13636, 0, 298, '234', 'Salted Caramel Machiato', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:17:26', 'admin-1507689985-15076918466891047', 1, 0, '', NULL, NULL, '10.0'),
(49591, '2017-10-11 09:09:47', NULL, NULL, 13623, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:09:47', 'admin-1507684036-15076841876243283', 1, 0, '', NULL, NULL, NULL),
(49592, '2017-10-11 12:09:34', NULL, NULL, 13640, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 12:09:34', 'admin-1507689985-15076949745647934', 1, 1, 'SR', NULL, NULL, NULL),
(49593, '2017-10-11 12:09:30', NULL, NULL, 13640, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1507715050', 'admin', '2017-10-11 12:09:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49594, '2017-10-11 15:31:04', NULL, NULL, 13646, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 15:31:04', 'admin-1507689985-15077070644773185', 1, 0, '', 1, NULL, NULL),
(49595, '2017-10-11 15:53:26', NULL, NULL, 13648, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1507715050', 'admin', '2017-10-11 15:53:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49596, '2017-10-11 15:53:34', NULL, NULL, 13648, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 15:53:34', 'admin-1507689985-15077084143339912', 1, 1, 'SR', NULL, NULL, NULL),
(49597, '2017-10-11 10:25:24', NULL, NULL, 13631, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 10:25:24', 'admin-1507684036-15076887242819888', 1, 0, '', NULL, NULL, NULL),
(49598, '2017-10-11 16:19:54', NULL, NULL, 13643, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 16:19:54', 'admin-1507689985-1507709994708259', 1, 0, '', NULL, NULL, '10.0'),
(49599, '2017-10-11 15:54:08', NULL, NULL, 13648, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 15:54:08', 'admin-1507689985-15077084478422584', 1, 1, 'SR', NULL, NULL, NULL),
(49600, '2017-10-11 11:01:54', NULL, NULL, 13635, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.40, 0.0000, 0.0000, 0.40, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:01:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49601, '2017-10-11 11:02:12', NULL, NULL, 13635, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:02:12', 'admin-1507689985-15076909322027065', 1, 0, '', NULL, NULL, NULL),
(49602, '2017-10-11 11:07:06', NULL, NULL, 13634, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:07:06', 'admin-1507689985-15076912263087149', 1, 0, '', NULL, NULL, NULL),
(49603, '2017-10-11 11:07:06', NULL, NULL, 13634, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:07:06', 'admin-1507689985-15076912263087149', 1, 0, '', NULL, NULL, NULL),
(49604, '2017-10-11 11:07:06', NULL, NULL, 13634, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:07:06', 'admin-1507689985-15076912263087149', 1, 0, '', NULL, NULL, NULL),
(49605, '2017-10-11 11:07:20', NULL, NULL, 13634, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:07:20', 'admin-1507689985-1507691240651428', 1, 1, 'SR', NULL, NULL, NULL),
(49606, '2017-10-11 11:07:20', NULL, NULL, 13634, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:07:20', 'admin-1507689985-1507691240651428', 1, 0, '', NULL, NULL, NULL),
(49607, '2017-10-11 11:14:21', NULL, NULL, 13636, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.60, 0.0000, 0.0000, 9.60, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:14:21', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(49608, '2017-10-11 11:15:09', NULL, NULL, 13636, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:15:09', 'admin-1507689985-15076917092495959', 1, 0, '', NULL, NULL, '10.0'),
(49609, '2017-10-11 11:15:28', NULL, NULL, 13636, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:15:28', 'admin-1507689985-15076917284853877', 1, 0, '', NULL, NULL, '10.0'),
(49610, '2017-10-11 12:07:07', NULL, NULL, 13639, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 12:07:07', 'admin-1507689985-1507694827518697', 1, 1, 'SR', NULL, NULL, NULL),
(49611, '2017-10-11 09:57:01', NULL, NULL, 13629, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:57:01', 'admin-1507684036-15076870208591680', 1, 0, '', NULL, NULL, NULL),
(49612, '2017-10-11 09:57:34', NULL, NULL, 13629, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:57:34', 'admin-1507684036-15076870546201085', 1, 0, '', NULL, NULL, NULL),
(49613, '2017-10-11 09:57:34', NULL, NULL, 13629, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:57:34', 'admin-1507684036-15076870546201085', 1, 1, 'SR', NULL, NULL, NULL),
(49614, '2017-10-11 12:06:48', NULL, NULL, 13639, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 12:06:48', 'admin-1507689985-15076948079442061', 1, 0, '', NULL, NULL, NULL),
(49615, '2017-10-11 11:36:03', NULL, NULL, 13638, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:36:03', 'admin-1507689985-15076929630192833', 1, 1, 'SR', NULL, NULL, NULL),
(49616, '2017-10-11 11:36:03', NULL, NULL, 13638, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:36:03', 'admin-1507689985-15076929630192833', 1, 1, 'SR', NULL, NULL, NULL),
(49617, '2017-10-11 11:36:03', NULL, NULL, 13638, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:36:03', 'admin-1507689985-15076929630192833', 1, 0, '', NULL, NULL, NULL),
(49618, '2017-10-11 11:36:03', NULL, NULL, 13638, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:36:03', 'admin-1507689985-15076929630192833', 1, 1, 'SR', NULL, NULL, NULL),
(49619, '2017-10-11 11:36:03', NULL, NULL, 13638, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:36:03', 'admin-1507689985-15076929630192833', 1, 1, 'SR', NULL, NULL, NULL),
(49620, '2017-10-11 11:36:03', NULL, NULL, 13638, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:36:03', 'admin-1507689985-15076929630192833', 1, 1, 'SR', NULL, NULL, NULL),
(49621, '2017-10-11 11:36:03', NULL, NULL, 13638, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:36:03', 'admin-1507689985-15076929630192833', 1, 0, '', NULL, NULL, NULL),
(49622, '2017-10-11 11:36:03', NULL, NULL, 13638, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:36:03', 'admin-1507689985-15076929630192833', 1, 0, '', NULL, NULL, NULL),
(49623, '2017-10-11 11:36:03', NULL, NULL, 13638, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:36:03', 'admin-1507689985-15076929630192833', 1, 1, 'SR', NULL, NULL, NULL),
(49624, '2017-10-11 11:35:29', NULL, NULL, 13638, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.90, 0.0000, 0.0000, 13.90, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:35:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49625, '2017-10-11 11:25:00', NULL, NULL, 13637, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:25:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49626, '2017-10-11 11:15:53', NULL, NULL, 13636, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:15:53', 'admin-1507689985-15076917535955962', 1, 0, '', NULL, NULL, '10.0'),
(49627, '2017-10-11 11:17:07', NULL, NULL, 13636, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:17:07', 'admin-1507689985-15076918270382579', 1, 1, 'SR', NULL, NULL, '10.0'),
(49628, '2017-10-11 11:16:36', NULL, NULL, 13636, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:16:36', 'admin-1507689985-1507691796282371', 1, 1, 'SR', NULL, NULL, '10.0'),
(49629, '2017-10-11 11:36:03', NULL, NULL, 13638, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 11:36:03', 'admin-1507689985-15076929630192833', 1, 0, '', NULL, NULL, NULL),
(49630, '2017-10-11 09:56:48', NULL, NULL, 13629, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.30, 0.0000, 0.0000, 11.30, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:56:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49631, '2017-10-11 09:57:01', NULL, NULL, 13629, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:57:01', 'admin-1507684036-15076870208591680', 1, 0, '', NULL, NULL, NULL),
(49632, '2017-10-11 10:44:54', NULL, NULL, 13632, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 10:44:54', 'admin-1507684036-15076898941855541', 1, 0, '', NULL, NULL, NULL),
(49633, '2017-10-11 10:44:54', NULL, NULL, 13632, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 10:44:54', 'admin-1507684036-15076898941855541', 1, 0, '', NULL, NULL, NULL),
(49634, '2017-10-11 10:44:22', NULL, NULL, 13632, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1507715050', 'admin', '2017-10-11 10:44:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49635, '2017-10-11 10:25:24', NULL, NULL, 13631, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 10:25:24', 'admin-1507684036-15076887242819888', 1, 0, '', NULL, NULL, NULL),
(49636, '2017-10-11 10:25:24', NULL, NULL, 13631, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 10:25:24', 'admin-1507684036-15076887242819888', 1, 0, '', NULL, NULL, NULL),
(49637, '2017-10-11 10:21:32', NULL, NULL, 13630, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 10:21:32', 'admin-1507684036-1507688492305312', 1, 0, '', 1, NULL, '10.0'),
(49638, '2017-10-11 12:06:48', NULL, NULL, 13639, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 12:06:48', 'admin-1507689985-15076948079442061', 1, 1, 'SR', NULL, NULL, NULL),
(49639, '2017-10-11 15:23:08', NULL, NULL, 13643, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 15:23:08', 'admin-1507689985-15077065879799733', 1, 0, '', NULL, NULL, '10.0'),
(49640, '2017-10-11 09:54:13', NULL, NULL, 13628, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:54:13', 'admin-1507684036-15076868535233426', 1, 0, '', NULL, NULL, NULL),
(49641, '2017-10-11 09:54:13', NULL, NULL, 13628, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:54:13', 'admin-1507684036-15076868535233426', 1, 0, '', NULL, NULL, NULL),
(49642, '2017-10-11 09:54:13', NULL, NULL, 13628, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:54:13', 'admin-1507684036-15076868535233426', 1, 1, 'SR', NULL, NULL, NULL),
(49643, '2017-10-11 09:54:13', NULL, NULL, 13628, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:54:13', 'admin-1507684036-15076868535233426', 1, 1, 'SR', NULL, NULL, NULL),
(49644, '2017-10-11 09:57:34', NULL, NULL, 13629, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:57:34', 'admin-1507684036-15076870546201085', 1, 1, 'SR', NULL, NULL, NULL),
(49645, '2017-10-11 09:57:34', NULL, NULL, 13629, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:57:34', 'admin-1507684036-15076870546201085', 1, 1, 'SR', NULL, NULL, NULL),
(49646, '2017-10-11 09:57:34', NULL, NULL, 13629, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:57:34', 'admin-1507684036-15076870546201085', 1, 1, 'SR', NULL, NULL, NULL),
(49647, '2017-10-11 09:24:11', NULL, NULL, 13625, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:24:11', 'admin-1507684036-15076850509935727', 1, 1, 'SR', NULL, NULL, NULL),
(49648, '2017-10-11 09:38:43', NULL, NULL, 13626, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:38:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49649, '2017-10-11 09:38:56', NULL, NULL, 13626, 0, 153, '87', 'Wake Me Up!', 'sunny', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:38:56', 'admin-1507684036-15076859359097621', 1, 0, '', NULL, NULL, NULL),
(49650, '2017-10-11 09:38:56', NULL, NULL, 13626, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:38:56', 'admin-1507684036-15076859359097621', 1, 0, '', NULL, NULL, NULL),
(49651, '2017-10-11 09:39:01', NULL, NULL, 13626, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:39:01', 'admin-1507684036-1507685941333948', 1, 1, 'SR', NULL, NULL, NULL),
(49652, '2017-10-11 09:39:01', NULL, NULL, 13626, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:39:01', 'admin-1507684036-1507685941333948', 1, 1, 'SR', NULL, NULL, NULL),
(49653, '2017-10-11 09:46:06', NULL, NULL, 13627, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:46:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49654, '2017-10-11 09:46:15', NULL, NULL, 13627, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:46:15', 'admin-1507684036-1507686375503203', 1, 0, '', NULL, NULL, NULL),
(49655, '2017-10-11 09:46:15', NULL, NULL, 13627, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:46:15', 'admin-1507684036-1507686375503203', 1, 0, '', NULL, NULL, NULL),
(49656, '2017-10-11 09:46:37', NULL, NULL, 13627, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:46:37', 'admin-1507684036-15076863974933682', 1, 1, 'SR', NULL, NULL, NULL),
(49657, '2017-10-11 09:46:37', NULL, NULL, 13627, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:46:37', 'admin-1507684036-15076863974933682', 1, 1, 'SR', NULL, NULL, NULL),
(49658, '2017-10-11 09:53:46', NULL, NULL, 13628, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:53:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49659, '2017-10-11 09:54:13', NULL, NULL, 13628, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:54:13', 'admin-1507684036-15076868535233426', 1, 0, '', NULL, NULL, NULL),
(49660, '2017-10-11 09:57:01', NULL, NULL, 13629, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:57:01', 'admin-1507684036-15076870208591680', 1, 0, '', NULL, NULL, NULL),
(49661, '2017-10-11 09:54:13', NULL, NULL, 13628, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:54:13', 'admin-1507684036-15076868535233426', 1, 1, 'SR', NULL, NULL, NULL),
(49662, '2017-10-11 09:24:11', NULL, NULL, 13625, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:24:11', 'admin-1507684036-15076850509935727', 1, 0, '', NULL, NULL, NULL),
(49663, '2017-10-11 09:22:33', NULL, NULL, 13624, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:22:33', 'admin-1507684036-15076849530362975', 1, 1, 'SR', NULL, NULL, NULL),
(49664, '2017-10-11 09:23:32', NULL, NULL, 13625, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:23:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49665, '2017-10-11 09:24:11', NULL, NULL, 13625, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:24:11', 'admin-1507684036-15076850509935727', 1, 0, '', NULL, NULL, NULL),
(49666, '2017-10-11 09:09:47', NULL, NULL, 13623, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:09:47', 'admin-1507684036-15076841876243283', 1, 0, '', NULL, NULL, NULL),
(49667, '2017-10-11 09:22:23', NULL, NULL, 13624, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:22:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49668, '2017-10-11 09:09:57', NULL, NULL, 13623, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:09:57', 'admin-1507684036-15076841969688999', 1, 1, 'SR', NULL, NULL, NULL),
(49669, '2017-10-11 09:09:57', NULL, NULL, 13623, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:09:57', 'admin-1507684036-15076841969688999', 1, 1, 'SR', NULL, NULL, NULL),
(49670, '2017-10-11 09:09:32', NULL, NULL, 13623, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1507715050', 'admin', '2017-10-11 09:09:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49671, '2017-10-12 11:19:49', NULL, NULL, 13661, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:19:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49672, '2017-10-12 11:40:13', NULL, NULL, 13663, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:40:13', 'admin-1507769350-15077796136832046', 1, 0, '', NULL, NULL, NULL),
(49673, '2017-10-12 11:40:13', NULL, NULL, 13663, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:40:13', 'admin-1507769350-15077796136832046', 1, 1, 'SR', NULL, NULL, NULL),
(49674, '2017-10-12 11:40:13', NULL, NULL, 13663, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:40:13', 'admin-1507769350-15077796136832046', 1, 0, '', NULL, NULL, NULL),
(49675, '2017-10-12 11:46:13', NULL, NULL, 13664, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:46:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49676, '2017-10-12 09:56:44', NULL, NULL, 13652, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 09:56:44', 'admin-1507769350-15077734043171729', 1, 1, 'SR', NULL, NULL, NULL),
(49677, '2017-10-12 11:40:13', NULL, NULL, 13663, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:40:13', 'admin-1507769350-15077796136832046', 1, 0, '', NULL, NULL, NULL),
(49678, '2017-10-12 12:48:33', NULL, NULL, 13667, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1507781947', 'admin', '2017-10-12 12:48:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49679, '2017-10-12 12:48:39', NULL, NULL, 13667, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 12:48:39', 'admin-1507781947-15077837196135714', 1, 0, '', NULL, NULL, NULL),
(49680, '2017-10-12 11:46:19', NULL, NULL, 13664, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:46:19', 'admin-1507769350-15077799792727765', 1, 0, '', NULL, NULL, NULL),
(49681, '2017-10-12 11:46:19', NULL, NULL, 13664, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:46:19', 'admin-1507769350-15077799792727765', 1, 0, '', NULL, NULL, NULL),
(49682, '2017-10-12 11:48:16', NULL, NULL, 13665, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:48:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49683, '2017-10-12 11:48:27', NULL, NULL, 13665, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:48:27', 'admin-1507769350-15077801077578275', 1, 1, 'SR', NULL, NULL, NULL),
(49684, '2017-10-12 11:48:27', NULL, NULL, 13665, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:48:27', 'admin-1507769350-15077801077578275', 1, 1, 'SR', NULL, NULL, NULL),
(49685, '2017-10-12 11:48:27', NULL, NULL, 13665, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:48:27', 'admin-1507769350-15077801077578275', 1, 1, 'SR', NULL, NULL, NULL),
(49686, '2017-10-12 13:03:11', NULL, NULL, 13668, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 13:03:11', 'admin-1507781947-15077845913859471', 1, 1, 'SR', NULL, NULL, NULL),
(49687, '2017-10-12 13:17:36', NULL, NULL, 13667, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 13:17:36', 'admin-1507781947-15077854563251576', 1, 0, '', NULL, NULL, NULL),
(49688, '2017-10-12 13:38:10', NULL, NULL, 13669, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 13:38:10', 'admin-1507781947-15077866903719448', 1, 1, 'SR', 1, NULL, NULL),
(49689, '2017-10-12 13:41:06', NULL, NULL, 13670, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1507781947', 'admin', '2017-10-12 13:41:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49690, '2017-10-12 13:41:09', NULL, NULL, 13670, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 13:41:09', 'admin-1507781947-15077868691971220', 1, 1, 'SR', NULL, NULL, NULL),
(49691, '2017-10-12 11:29:00', NULL, NULL, 13662, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:29:00', 'admin-1507769350-15077789403367398', 1, 0, '', NULL, NULL, NULL),
(49692, '2017-10-12 10:54:35', NULL, NULL, 13657, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 10:54:35', 'admin-1507769350-1507776875059918', 1, 0, '', NULL, NULL, NULL),
(49693, '2017-10-12 14:00:25', NULL, NULL, 13671, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1507781947', 'admin', '2017-10-12 14:00:25', 'admin-1507781947-15077880251057194', 1, 0, '', NULL, NULL, NULL),
(49694, '2017-10-12 09:56:34', NULL, NULL, 13652, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 09:56:34', 'admin-1507769350-15077733945559119', 1, 0, '', NULL, NULL, NULL),
(49695, '2017-10-12 09:56:34', NULL, NULL, 13652, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 09:56:34', 'admin-1507769350-15077733945559119', 1, 0, '', NULL, NULL, NULL),
(49696, '2017-10-12 09:56:34', NULL, NULL, 13652, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 09:56:34', 'admin-1507769350-15077733945559119', 1, 0, '', NULL, NULL, NULL),
(49697, '2017-10-12 11:39:57', NULL, NULL, 13663, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:39:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49698, '2017-10-12 00:00:00', NULL, NULL, 13675, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 15:27:38', 'admin-1507781947-15077932580394951', 1, 1, 'SR', NULL, NULL, NULL),
(49699, '2017-10-12 00:00:00', NULL, NULL, 13675, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 15:27:38', 'admin-1507781947-15077932580394951', 1, 1, 'SR', NULL, NULL, NULL),
(49700, '2017-10-12 00:00:00', NULL, NULL, 13675, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 15:27:38', 'admin-1507781947-15077932580394951', 1, 1, 'SR', NULL, NULL, NULL),
(49701, '2017-10-12 00:00:00', NULL, NULL, 13675, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, NULL, NULL, 3.80, 1, '27', 1, '1507781947', 'admin', '2017-10-12 15:23:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49702, '2017-10-12 14:25:51', NULL, NULL, 13673, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 14:25:51', 'admin-1507781947-15077895512503985', 1, 0, '', NULL, NULL, NULL),
(49703, '2017-10-12 14:25:51', NULL, NULL, 13673, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 14:25:51', 'admin-1507781947-15077895512503985', 1, 0, '', NULL, NULL, NULL),
(49704, '2017-10-12 11:19:56', NULL, NULL, 13661, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:19:56', 'admin-1507769350-15077783967413720', 1, 1, 'SR', NULL, NULL, NULL),
(49705, '2017-10-12 11:19:56', NULL, NULL, 13661, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:19:56', 'admin-1507769350-15077783967413720', 1, 1, 'SR', NULL, NULL, NULL),
(49706, '2017-10-12 11:22:14', NULL, NULL, 13661, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:22:14', 'admin-1507769350-15077785339953341', 1, 1, 'SR', NULL, NULL, NULL),
(49707, '2017-10-12 11:29:00', NULL, NULL, 13662, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:29:00', 'admin-1507769350-15077789403367398', 1, 1, 'SR', NULL, NULL, NULL),
(49708, '2017-10-12 14:25:47', NULL, NULL, 13673, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1507781947', 'admin', '2017-10-12 14:25:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49709, '2017-10-12 13:56:58', NULL, NULL, 13672, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 13:56:58', 'admin-1507781947-15077878178465261', 1, 1, 'SR', 1, NULL, NULL),
(49710, '2017-10-12 13:56:58', NULL, NULL, 13672, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 13:56:58', 'admin-1507781947-15077878178465261', 1, 0, '', 1, NULL, NULL),
(49711, '2017-10-12 13:56:58', NULL, NULL, 13672, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 13:56:58', 'admin-1507781947-15077878178465261', 1, 0, '', 1, NULL, NULL),
(49712, '2017-10-12 13:56:58', NULL, NULL, 13672, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 13:56:58', 'admin-1507781947-15077878178465261', 1, 1, 'SR', 1, NULL, NULL),
(49713, '2017-10-12 13:48:16', NULL, NULL, 13671, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 13:48:16', 'admin-1507781947-15077872963251941', 1, 0, '', NULL, NULL, NULL),
(49714, '2017-10-12 13:48:12', NULL, NULL, 13671, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.89, 0.0000, 0.0000, 1.89, 1, '27', 1, '1507781947', 'admin', '2017-10-12 13:48:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49715, '2017-10-12 11:50:09', NULL, NULL, 13661, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:50:09', 'admin-1507769350-15077802090478262', 1, 0, '', NULL, NULL, NULL),
(49716, '2017-10-12 12:58:46', NULL, NULL, 13668, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 12:58:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49717, '2017-10-12 12:48:39', NULL, NULL, 13667, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 12:48:39', 'admin-1507781947-15077837196135714', 1, 1, 'SR', NULL, NULL, NULL),
(49718, '2017-10-12 12:58:52', NULL, NULL, 13668, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 12:58:52', 'admin-1507781947-1507784332353868', 1, 0, '', NULL, NULL, NULL),
(49719, '2017-10-12 12:58:52', NULL, NULL, 13668, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 12:58:52', 'admin-1507781947-1507784332353868', 1, 1, 'SR', NULL, NULL, NULL),
(49720, '2017-10-12 13:03:11', NULL, NULL, 13668, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 13:03:11', 'admin-1507781947-15077845913859471', 1, 1, 'SR', NULL, NULL, NULL),
(49721, '2017-10-12 10:45:30', NULL, NULL, 13656, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 10:45:30', 'admin-1507769350-15077763302682854', 1, 1, 'SR', NULL, NULL, NULL),
(49722, '2017-10-12 10:54:28', NULL, NULL, 13657, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 10:54:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49723, '2017-10-12 10:54:35', NULL, NULL, 13657, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 10:54:35', 'admin-1507769350-1507776875059918', 1, 0, '', NULL, NULL, NULL),
(49724, '2017-10-12 11:07:22', NULL, NULL, 13658, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:07:22', 'admin-1507769350-15077776426952477', 1, 1, 'SR', NULL, NULL, NULL),
(49725, '2017-10-12 11:07:28', NULL, NULL, 13658, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:07:28', 'admin-1507769350-15077776482056111', 1, 0, '', NULL, NULL, NULL),
(49726, '2017-10-12 11:08:21', NULL, NULL, 13659, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:08:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49727, '2017-10-12 09:56:34', NULL, NULL, 13652, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 09:56:34', 'admin-1507769350-15077733945559119', 1, 0, '', NULL, NULL, NULL),
(49728, '2017-10-12 11:29:00', NULL, NULL, 13662, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:29:00', 'admin-1507769350-15077789403367398', 1, 0, '', NULL, NULL, NULL),
(49729, '2017-10-12 10:54:59', NULL, NULL, 13657, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 10:54:59', 'admin-1507769350-15077768990422073', 1, 1, 'SR', NULL, NULL, NULL),
(49730, '2017-10-12 10:55:21', NULL, NULL, 13657, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 10:55:21', 'admin-1507769350-15077769217505884', 1, 0, '', NULL, NULL, NULL),
(49731, '2017-10-12 11:07:00', NULL, NULL, 13658, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:07:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49732, '2017-10-12 11:07:22', NULL, NULL, 13658, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:07:22', 'admin-1507769350-15077776426952477', 1, 0, '', NULL, NULL, NULL),
(49733, '2017-10-12 11:28:52', NULL, NULL, 13662, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:28:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49734, '2017-10-12 11:08:46', NULL, NULL, 13659, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:08:46', 'admin-1507769350-1507777726026213', 1, 1, 'SR', NULL, NULL, NULL),
(49735, '2017-10-12 11:08:46', NULL, NULL, 13659, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:08:46', 'admin-1507769350-1507777726026213', 1, 1, 'SR', NULL, NULL, NULL),
(49736, '2017-10-12 10:02:45', NULL, NULL, 13653, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 10:02:45', 'admin-1507769350-15077737649629559', 1, 1, 'SR', NULL, NULL, NULL),
(49737, '2017-10-12 10:02:45', NULL, NULL, 13653, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 10:02:45', 'admin-1507769350-15077737649629559', 1, 1, 'SR', NULL, NULL, NULL),
(49738, '2017-10-12 10:15:18', NULL, NULL, 13654, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1507781947', 'admin', '2017-10-12 10:15:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49739, '2017-10-12 10:15:23', NULL, NULL, 13654, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 10:15:23', 'admin-1507769350-15077745238286720', 1, 1, 'SR', NULL, NULL, NULL),
(49740, '2017-10-12 10:15:23', NULL, NULL, 13654, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 10:15:23', 'admin-1507769350-15077745238286720', 1, 1, 'SR', NULL, NULL, NULL),
(49741, '2017-10-12 10:17:29', NULL, NULL, 13654, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 10:17:29', 'admin-1507769350-15077746495602579', 1, 0, '', NULL, NULL, NULL),
(49742, '2017-10-12 10:17:29', NULL, NULL, 13654, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 10:17:29', 'admin-1507769350-15077746495602579', 1, 0, '', NULL, NULL, NULL),
(49743, '2017-10-12 10:17:31', NULL, NULL, 13655, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 10:17:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49744, '2017-10-12 10:17:41', NULL, NULL, 13655, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 10:17:41', 'admin-1507769350-15077746611895250', 1, 1, 'SR', NULL, NULL, NULL),
(49745, '2017-10-12 10:17:41', NULL, NULL, 13655, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 10:17:41', 'admin-1507769350-15077746611895250', 1, 1, 'SR', NULL, NULL, NULL),
(49746, '2017-10-12 10:17:41', NULL, NULL, 13655, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 10:17:41', 'admin-1507769350-15077746611895250', 1, 0, '', NULL, NULL, NULL),
(49747, '2017-10-12 10:45:22', NULL, NULL, 13656, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1507781947', 'admin', '2017-10-12 10:45:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49748, '2017-10-12 10:45:30', NULL, NULL, 13656, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 10:45:30', 'admin-1507769350-15077763302682854', 1, 1, 'SR', NULL, NULL, NULL),
(49749, '2017-10-12 11:29:00', NULL, NULL, 13662, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 11:29:00', 'admin-1507769350-15077789403367398', 1, 0, '', NULL, NULL, NULL),
(49750, '2017-10-12 10:02:45', NULL, NULL, 13653, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 10:02:45', 'admin-1507769350-15077737649629559', 1, 1, 'SR', NULL, NULL, NULL),
(49751, '2017-10-12 09:56:44', NULL, NULL, 13652, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 09:56:44', 'admin-1507769350-15077734043171729', 1, 1, 'SR', NULL, NULL, NULL),
(49752, '2017-10-12 09:56:44', NULL, NULL, 13652, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 09:56:44', 'admin-1507769350-15077734043171729', 1, 1, 'SR', NULL, NULL, NULL),
(49753, '2017-10-12 10:02:33', NULL, NULL, 13653, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1507781947', 'admin', '2017-10-12 10:02:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49754, '2017-10-12 10:02:45', NULL, NULL, 13653, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 10:02:45', 'admin-1507769350-15077737649629559', 1, 0, '', NULL, NULL, NULL),
(49755, '2017-10-12 09:56:44', NULL, NULL, 13652, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 09:56:44', 'admin-1507769350-15077734043171729', 1, 1, 'SR', NULL, NULL, NULL),
(49756, '2017-10-12 09:56:26', NULL, NULL, 13652, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.30, 0.0000, 0.0000, 10.30, 1, '27', 1, '1507781947', 'admin', '2017-10-12 09:56:26', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(49757, '2017-10-12 09:27:32', NULL, NULL, 13651, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 09:27:32', 'admin-1507769350-15077716522925576', 1, 0, '', NULL, NULL, NULL),
(49758, '2017-10-12 09:27:32', NULL, NULL, 13651, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507781947', 'admin', '2017-10-12 09:27:32', 'admin-1507769350-15077716522925576', 1, 1, 'SR', NULL, NULL, NULL),
(49759, '2017-10-12 09:24:22', NULL, NULL, 13651, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1507781947', 'admin', '2017-10-12 09:24:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49760, '2017-10-13 16:31:16', NULL, NULL, 13698, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 16:31:16', 'admin-1507880716-15078834763897095', 1, 1, 'SR', NULL, NULL, NULL),
(49761, '2017-10-13 16:51:42', NULL, NULL, 13699, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 16:51:42', 'admin-1507880716-1507884702073256', 1, 1, 'SR', 1, NULL, '10.0'),
(49762, '2017-10-13 12:51:51', NULL, NULL, 13688, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 12:51:51', 'admin-1507867671-1507870310954342', 1, 1, 'SR', NULL, NULL, NULL),
(49763, '2017-10-13 12:51:51', NULL, NULL, 13688, 0, 215, '149', 'Thai Fish Sauce Garlic Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 12:51:51', 'admin-1507867671-1507870310954342', 1, 0, '', NULL, NULL, NULL),
(49764, '2017-10-13 13:33:48', NULL, NULL, 13691, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 13:33:48', 'admin-1507867671-15078728286479880', 1, 0, '', NULL, NULL, NULL),
(49765, '2017-10-13 12:51:51', NULL, NULL, 13688, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 12:51:51', 'admin-1507867671-1507870310954342', 1, 1, 'SR', NULL, NULL, NULL),
(49766, '2017-10-13 11:49:45', NULL, NULL, 13684, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1507880716', 'admin', '2017-10-13 11:49:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49767, '2017-10-13 11:49:49', NULL, NULL, 13684, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 11:49:49', 'admin-1507856206-15078665889729621', 1, 1, 'SR', NULL, NULL, NULL),
(49768, '2017-10-13 12:07:05', NULL, NULL, 13685, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1507880716', 'admin', '2017-10-13 12:07:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49769, '2017-10-13 12:07:21', NULL, NULL, 13685, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 12:07:21', 'admin-1507856206-1507867641830121', 1, 0, '', NULL, NULL, NULL),
(49770, '2017-10-13 12:07:21', NULL, NULL, 13685, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 12:07:21', 'admin-1507856206-1507867641830121', 1, 0, '', NULL, NULL, NULL),
(49771, '2017-10-13 12:07:22', NULL, NULL, 13685, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 12:07:22', 'admin-1507856206-1507867641830121', 1, 1, 'SR', NULL, NULL, NULL),
(49772, '2017-10-13 12:07:22', NULL, NULL, 13685, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 12:07:22', 'admin-1507856206-1507867641830121', 1, 1, 'SR', NULL, NULL, NULL),
(49773, '2017-10-13 13:32:23', NULL, NULL, 13690, 0, 181, '116', 'Open Food ', 'croissant', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 13:32:23', 'admin-1507867671-15078727431269214', 1, 0, '', NULL, NULL, NULL),
(49774, '2017-10-13 10:33:33', NULL, NULL, 13678, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 10:33:33', 'admin-1507856206-15078620134927561', 1, 0, '', NULL, NULL, NULL),
(49775, '2017-10-13 10:33:33', NULL, NULL, 13678, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 10:33:33', 'admin-1507856206-15078620134927561', 1, 0, '', NULL, NULL, NULL),
(49776, '2017-10-13 10:58:42', NULL, NULL, 13679, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1507880716', 'admin', '2017-10-13 10:58:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49777, '2017-10-13 10:59:06', NULL, NULL, 13679, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 10:59:06', 'admin-1507856206-1507863546615498', 1, 1, 'SR', NULL, NULL, NULL),
(49778, '2017-10-13 11:32:21', NULL, NULL, 13682, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 11:32:21', 'admin-1507856206-15078655417311975', 1, 0, '', NULL, NULL, NULL),
(49779, '2017-10-13 15:11:07', NULL, NULL, 13696, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 15:11:07', 'admin-1507867671-15078786670763668', 1, 1, 'SR', NULL, NULL, NULL),
(49780, '2017-10-13 15:05:18', NULL, NULL, 13695, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1507880716', 'admin', '2017-10-13 15:05:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49781, '2017-10-13 09:29:53', NULL, NULL, 13677, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 09:29:53', 'admin-1507856206-1507858193541441', 1, 0, '', NULL, NULL, NULL),
(49782, '2017-10-13 09:29:53', NULL, NULL, 13677, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 09:29:53', 'admin-1507856206-1507858193541441', 1, 0, '', NULL, NULL, NULL),
(49783, '2017-10-13 09:30:00', NULL, NULL, 13677, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 09:30:00', 'admin-1507856206-15078581998273271', 1, 1, 'SR', NULL, NULL, NULL),
(49784, '2017-10-13 12:32:33', NULL, NULL, 13685, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 12:32:33', 'admin-1507867671-15078691536951156', 1, 1, 'SR', NULL, NULL, NULL),
(49785, '2017-10-13 15:20:54', NULL, NULL, 13697, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 15:20:54', 'admin-1507867671-15078792540287138', 1, 0, '', NULL, NULL, NULL),
(49786, '2017-10-13 15:20:54', NULL, NULL, 13697, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 15:20:54', 'admin-1507867671-15078792540287138', 1, 1, 'SR', NULL, NULL, NULL),
(49787, '2017-10-13 15:20:54', NULL, NULL, 13697, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 15:20:54', 'admin-1507867671-15078792540287138', 1, 0, '', NULL, NULL, NULL),
(49788, '2017-10-13 15:20:45', NULL, NULL, 13697, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1507880716', 'admin', '2017-10-13 15:20:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49789, '2017-10-13 15:11:07', NULL, NULL, 13696, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 15:11:07', 'admin-1507867671-15078786670763668', 1, 1, 'SR', NULL, NULL, NULL),
(49790, '2017-10-13 15:11:07', NULL, NULL, 13696, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 15:11:07', 'admin-1507867671-15078786670763668', 1, 1, 'SR', NULL, NULL, NULL),
(49791, '2017-10-13 15:08:07', NULL, NULL, 13695, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 15:08:07', 'admin-1507867671-1507878487290395', 1, 0, '', NULL, NULL, NULL),
(49792, '2017-10-13 15:05:27', NULL, NULL, 13695, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 15:05:27', 'admin-1507867671-15078783270764629', 1, 0, '', NULL, NULL, NULL),
(49793, '2017-10-13 15:05:27', NULL, NULL, 13695, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 15:05:27', 'admin-1507867671-15078783270764629', 1, 0, '', NULL, NULL, NULL),
(49794, '2017-10-13 13:36:56', NULL, NULL, 13692, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 13:36:56', 'admin-1507867671-15078730165411564', 1, 1, 'SR', NULL, NULL, NULL),
(49795, '2017-10-13 13:39:24', NULL, NULL, 13693, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 13:39:24', 'admin-1507867671-15078731645561484', 1, 1, 'SR', NULL, NULL, NULL),
(49796, '2017-10-13 13:39:15', NULL, NULL, 13693, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1507880716', 'admin', '2017-10-13 13:39:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49797, '2017-10-13 13:39:24', NULL, NULL, 13693, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 13:39:24', 'admin-1507867671-15078731645561484', 1, 0, '', NULL, NULL, NULL),
(49798, '2017-10-13 13:39:24', NULL, NULL, 13693, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 13:39:24', 'admin-1507867671-15078731645561484', 1, 1, 'SR', NULL, NULL, NULL),
(49799, '2017-10-13 13:37:23', NULL, NULL, 13688, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 13:37:23', 'admin-1507867671-15078730435384646', 1, 0, '', NULL, NULL, NULL),
(49800, '2017-10-13 16:31:12', NULL, NULL, 13698, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1507880716', 'admin', '2017-10-13 16:31:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49801, '2017-10-13 13:54:30', NULL, NULL, 13694, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 13:54:30', 'admin-1507867671-15078740698442970', 1, 1, 'SR', 1, NULL, '10.0'),
(49802, '2017-10-13 16:31:16', NULL, NULL, 13698, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 16:31:16', 'admin-1507880716-15078834763897095', 1, 1, 'SR', NULL, NULL, NULL),
(49803, '2017-10-13 13:32:08', NULL, NULL, 13690, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.20, 0.0000, 0.0000, 0.20, 1, '27', 1, '1507880716', 'admin', '2017-10-13 13:32:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49804, '2017-10-13 12:30:41', NULL, NULL, 13686, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 12:30:41', 'admin-1507867671-1507869041022704', 1, 1, 'SR', NULL, NULL, NULL),
(49805, '2017-10-13 12:30:41', NULL, NULL, 13686, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 12:30:41', 'admin-1507867671-1507869041022704', 1, 0, '', NULL, NULL, NULL),
(49806, '2017-10-13 13:36:56', NULL, NULL, 13692, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 13:36:56', 'admin-1507867671-15078730165411564', 1, 0, '', NULL, NULL, NULL),
(49807, '2017-10-13 13:36:45', NULL, NULL, 13692, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1507880716', 'admin', '2017-10-13 13:36:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49808, '2017-10-13 13:33:53', NULL, NULL, 13691, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 13:33:53', 'admin-1507867671-15078728333763019', 1, 1, 'SR', NULL, NULL, NULL),
(49809, '2017-10-13 13:33:43', NULL, NULL, 13691, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1507880716', 'admin', '2017-10-13 13:33:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49810, '2017-10-13 11:01:24', NULL, NULL, 13680, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 11:01:24', 'admin-1507856206-15078636839798249', 1, 0, '', NULL, NULL, NULL),
(49811, '2017-10-13 11:19:29', NULL, NULL, 13681, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1507880716', 'admin', '2017-10-13 11:19:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49812, '2017-10-13 11:19:34', NULL, NULL, 13681, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 11:19:34', 'admin-1507856206-15078647748105866', 1, 0, '', NULL, NULL, NULL),
(49813, '2017-10-13 13:09:24', NULL, NULL, 13686, 0, 181, '116', 'Open Food ', 'Croisant', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 13:09:24', 'admin-1507867671-15078713642406978', 1, 0, '', NULL, NULL, NULL),
(49814, '2017-10-13 11:45:38', NULL, NULL, 13683, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 11:45:38', 'admin-1507856206-15078663385158067', 1, 1, 'SR', NULL, NULL, NULL),
(49815, '2017-10-13 15:11:00', NULL, NULL, 13696, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1507880716', 'admin', '2017-10-13 15:11:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49816, '2017-10-13 12:51:51', NULL, NULL, 13688, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 12:51:51', 'admin-1507867671-1507870310954342', 1, 1, 'SR', NULL, NULL, NULL),
(49817, '2017-10-13 12:51:30', NULL, NULL, 13688, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1507880716', 'admin', '2017-10-13 12:51:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49818, '2017-10-13 12:39:50', NULL, NULL, 13685, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 12:39:50', 'admin-1507867671-15078695897637493', 1, 0, '', NULL, NULL, NULL),
(49819, '2017-10-13 12:31:06', NULL, NULL, 13687, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 12:31:06', 'admin-1507867671-15078690663909371', 1, 0, '', 1, NULL, NULL),
(49820, '2017-10-13 12:30:41', NULL, NULL, 13686, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 12:30:41', 'admin-1507867671-1507869041022704', 1, 1, 'SR', NULL, NULL, NULL),
(49821, '2017-10-13 12:30:41', NULL, NULL, 13686, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 12:30:41', 'admin-1507867671-1507869041022704', 1, 0, '', NULL, NULL, NULL),
(49822, '2017-10-13 12:30:13', NULL, NULL, 13686, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1507880716', 'admin', '2017-10-13 12:30:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49823, '2017-10-13 10:59:06', NULL, NULL, 13679, 0, 153, '87', 'Wake Me Up!', ' add bread,no bean', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 10:59:06', 'admin-1507856206-1507863546615498', 1, 0, '', NULL, NULL, NULL),
(49824, '2017-10-13 11:45:51', NULL, NULL, 13683, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 11:45:51', 'admin-1507856206-15078663514484677', 1, 1, 'SR', NULL, NULL, NULL),
(49825, '2017-10-13 11:45:51', NULL, NULL, 13683, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 11:45:51', 'admin-1507856206-15078663514484677', 1, 1, 'SR', NULL, NULL, NULL),
(49826, '2017-10-13 11:45:38', NULL, NULL, 13683, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 11:45:38', 'admin-1507856206-15078663385158067', 1, 0, '', NULL, NULL, NULL),
(49827, '2017-10-13 11:45:26', NULL, NULL, 13683, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1507880716', 'admin', '2017-10-13 11:45:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49828, '2017-10-13 11:29:15', NULL, NULL, 13682, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 11:29:15', 'admin-1507856206-15078653554863930', 1, 1, 'SR', NULL, NULL, NULL),
(49829, '2017-10-13 11:27:51', NULL, NULL, 13682, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 11:27:51', 'admin-1507856206-15078652715884356', 1, 1, 'SR', NULL, NULL, NULL),
(49830, '2017-10-13 11:27:49', NULL, NULL, 13682, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 11:27:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49831, '2017-10-13 11:19:45', NULL, NULL, 13681, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 11:19:45', 'admin-1507856206-15078647849198019', 1, 0, '', NULL, NULL, NULL),
(49832, '2017-10-13 09:08:06', NULL, NULL, 13676, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 09:08:06', 'admin-1507856206-15078568864114027', 1, 1, 'SR', NULL, NULL, NULL),
(49833, '2017-10-13 11:01:20', NULL, NULL, 13680, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1507880716', 'admin', '2017-10-13 11:01:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49834, '2017-10-13 10:33:33', NULL, NULL, 13678, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 10:33:33', 'admin-1507856206-15078620134927561', 1, 0, '', NULL, NULL, NULL),
(49835, '2017-10-13 13:31:44', NULL, NULL, 13689, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 13:31:44', 'admin-1507867671-15078727042203469', 1, 0, '', 1, NULL, NULL),
(49836, '2017-10-13 09:30:00', NULL, NULL, 13677, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 09:30:00', 'admin-1507856206-15078581998273271', 1, 1, 'SR', NULL, NULL, NULL),
(49837, '2017-10-13 10:33:03', NULL, NULL, 13678, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.90, 0.0000, 0.0000, 9.90, 1, '27', 1, '1507880716', 'admin', '2017-10-13 10:33:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49838, '2017-10-13 10:33:33', NULL, NULL, 13678, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 10:33:33', 'admin-1507856206-15078620134927561', 1, 0, '', NULL, NULL, NULL),
(49839, '2017-10-13 10:33:33', NULL, NULL, 13678, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 10:33:33', 'admin-1507856206-15078620134927561', 1, 0, '', NULL, NULL, NULL),
(49840, '2017-10-13 10:33:33', NULL, NULL, 13678, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 10:33:33', 'admin-1507856206-15078620134927561', 1, 0, '', NULL, NULL, NULL),
(49841, '2017-10-13 09:07:58', NULL, NULL, 13676, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 09:07:58', 'admin-1507856206-15078568781559585', 1, 0, '', NULL, NULL, NULL),
(49842, '2017-10-13 09:29:45', NULL, NULL, 13677, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1507880716', 'admin', '2017-10-13 09:29:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49843, '2017-10-13 09:08:06', NULL, NULL, 13676, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507880716', 'admin', '2017-10-13 09:08:06', 'admin-1507856206-15078568864114027', 1, 1, 'SR', NULL, NULL, NULL),
(49844, '2017-10-13 09:07:53', NULL, NULL, 13676, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1507880716', 'admin', '2017-10-13 09:07:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49845, '2017-10-14 13:04:10', NULL, NULL, 13724, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:04:10', 'admin-1507955619-1507957450234147', 1, 0, '', NULL, NULL, NULL),
(49846, '2017-10-14 13:04:36', NULL, NULL, 13729, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:04:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49847, '2017-10-14 12:18:28', NULL, NULL, 13720, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1507967892', 'admin', '2017-10-14 12:18:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49848, '2017-10-14 11:23:03', NULL, NULL, 13716, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:23:03', 'admin-1507948472-150795138291973', 1, 0, '', NULL, NULL, NULL),
(49849, '2017-10-14 11:23:03', NULL, NULL, 13716, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 2, 21.00, 42.0000, 0.0000, 42.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:23:03', 'admin-1507948472-150795138291973', 1, 0, '', NULL, NULL, NULL),
(49850, '2017-10-14 11:23:23', NULL, NULL, 13716, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:23:23', 'admin-1507948472-15079514028609426', 1, 1, 'SR', NULL, NULL, NULL),
(49851, '2017-10-14 11:23:23', NULL, NULL, 13716, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:23:23', 'admin-1507948472-15079514028609426', 1, 0, '', NULL, NULL, NULL),
(49852, '2017-10-14 14:02:25', NULL, NULL, 13733, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 14:02:25', 'admin-1507955619-15079609455484889', 1, 0, '', NULL, NULL, NULL),
(49853, '2017-10-14 14:07:09', NULL, NULL, 13738, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1507967892', 'admin', '2017-10-14 14:07:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49854, '2017-10-14 13:01:06', NULL, NULL, 13728, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:01:06', 'admin-1507955619-15079572666978353', 1, 1, 'SR', NULL, NULL, NULL),
(49855, '2017-10-14 12:52:24', NULL, NULL, 13726, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 12:52:24', 'admin-1507955619-15079567441865022', 1, 0, '', 1, NULL, '10.0'),
(49856, '2017-10-14 16:48:13', NULL, NULL, 13747, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 16:48:13', 'admin-1507967892-15079708930884676', 1, 0, '', NULL, NULL, NULL),
(49857, '2017-10-14 12:33:36', NULL, NULL, 13724, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 12:33:36', 'admin-1507948472-15079555445069173', 1, 1, 'SR', NULL, NULL, NULL),
(49858, '2017-10-14 12:33:36', NULL, NULL, 13724, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 12:33:36', 'admin-1507948472-15079555445069173', 1, 0, '', NULL, NULL, NULL),
(49859, '2017-10-14 12:33:45', NULL, NULL, 13725, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 12:33:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49860, '2017-10-14 13:33:24', NULL, NULL, 13733, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:33:24', 'admin-1507955619-15079592039762578', 1, 0, '', NULL, NULL, NULL),
(49861, '2017-10-14 13:08:49', NULL, NULL, 13729, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:08:49', 'admin-1507955619-15079577295045565', 1, 1, 'SR', NULL, NULL, NULL),
(49862, '2017-10-14 14:59:08', NULL, NULL, 13740, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 14:59:08', 'admin-1507955619-15079643485118122', 1, 0, '', NULL, NULL, NULL),
(49863, '2017-10-14 11:52:44', NULL, NULL, 13719, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:52:44', 'admin-1507948472-15079531646116136', 1, 1, 'SR', NULL, NULL, NULL),
(49864, '2017-10-14 14:32:48', NULL, NULL, 13739, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 14:32:48', 'admin-1507955619-15079627685778566', 1, 1, 'SR', NULL, NULL, NULL),
(49865, '2017-10-14 11:07:35', NULL, NULL, 13711, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:07:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49866, '2017-10-14 13:57:09', NULL, NULL, 13736, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:57:09', 'admin-1507955619-15079606295774190', 1, 1, 'SR', NULL, NULL, NULL),
(49867, '2017-10-14 13:57:09', NULL, NULL, 13736, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:57:09', 'admin-1507955619-15079606295774190', 1, 1, 'SR', NULL, NULL, NULL),
(49868, '2017-10-14 17:06:25', NULL, NULL, 13748, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 17:06:25', 'admin-1507967892-15079719848278065', 1, 1, 'SR', NULL, NULL, NULL),
(49869, '2017-10-14 17:06:25', NULL, NULL, 13748, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 17:06:25', 'admin-1507967892-15079719848278065', 1, 1, 'SR', NULL, NULL, NULL),
(49870, '2017-10-14 14:37:50', NULL, NULL, 13739, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 14:37:50', 'admin-1507955619-1507963070423212', 1, 1, 'SR', NULL, NULL, NULL),
(49871, '2017-10-14 16:48:13', NULL, NULL, 13747, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 16:48:13', 'admin-1507967892-15079708930884676', 1, 0, '', NULL, NULL, NULL),
(49872, '2017-10-14 13:04:10', NULL, NULL, 13724, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:04:10', 'admin-1507955619-1507957450234147', 1, 1, 'SR', NULL, NULL, NULL),
(49873, '2017-10-14 13:04:10', NULL, NULL, 13724, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:04:10', 'admin-1507955619-1507957450234147', 1, 0, '', NULL, NULL, NULL),
(49874, '2017-10-14 14:58:43', NULL, NULL, 13740, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1507967892', 'admin', '2017-10-14 14:58:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49875, '2017-10-14 14:58:57', NULL, NULL, 13740, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 14:58:57', 'admin-1507955619-15079643375389128', 1, 1, 'SR', NULL, NULL, NULL),
(49876, '2017-10-14 15:29:58', NULL, NULL, 13745, 0, 182, '117', 'Open Drinks ', 'americano promo', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 15:29:58', 'admin-1507955619-15079661983495869', 1, 0, '', 1, NULL, NULL),
(49877, '2017-10-14 15:53:20', NULL, NULL, 13746, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 15:53:20', 'admin-1507955619-15079676006384260', 1, 1, 'SR', NULL, NULL, NULL),
(49878, '2017-10-14 15:53:20', NULL, NULL, 13746, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 15:53:20', 'admin-1507955619-15079676006384260', 1, 1, 'SR', NULL, NULL, NULL),
(49879, '2017-10-14 15:57:52', NULL, NULL, 13747, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.50, 0.0000, 0.0000, 12.50, 1, '27', 1, '1507967892', 'admin', '2017-10-14 15:57:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49880, '2017-10-14 15:58:06', NULL, NULL, 13747, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 15:58:06', 'admin-1507955619-15079678858861598', 1, 0, '', NULL, NULL, NULL),
(49881, '2017-10-14 15:58:06', NULL, NULL, 13747, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 15:58:06', 'admin-1507955619-15079678858861598', 1, 0, '', NULL, NULL, NULL),
(49882, '2017-10-14 10:29:23', NULL, NULL, 13708, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 10:29:23', 'admin-1507942523-15079481637297979', 1, 0, '', NULL, NULL, NULL),
(49883, '2017-10-14 09:40:44', NULL, NULL, 13702, 0, 153, '87', 'Wake Me Up!', 'sunny side', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:40:44', 'admin-1507942523-15079452439069396', 1, 0, '', NULL, NULL, NULL),
(49884, '2017-10-14 09:40:44', NULL, NULL, 13702, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:40:44', 'admin-1507942523-15079452439069396', 1, 1, 'SR', NULL, NULL, NULL),
(49885, '2017-10-14 09:40:44', NULL, NULL, 13702, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:40:44', 'admin-1507942523-15079452439069396', 1, 1, 'SR', NULL, NULL, NULL),
(49886, '2017-10-14 09:40:44', NULL, NULL, 13702, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:40:44', 'admin-1507942523-15079452439069396', 1, 0, '', NULL, NULL, NULL),
(49887, '2017-10-14 09:40:44', NULL, NULL, 13702, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:40:44', 'admin-1507942523-15079452439069396', 1, 1, 'SR', NULL, NULL, NULL),
(49888, '2017-10-14 09:41:00', NULL, NULL, 13703, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:41:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49889, '2017-10-14 09:41:07', NULL, NULL, 13703, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:41:07', 'admin-1507942523-15079452671372217', 1, 0, '', NULL, NULL, NULL),
(49890, '2017-10-14 14:22:33', NULL, NULL, 13733, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 14:22:33', 'admin-1507955619-15079621532276998', 1, 1, 'SR', NULL, NULL, NULL),
(49891, '2017-10-14 14:32:32', NULL, NULL, 13739, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1507967892', 'admin', '2017-10-14 14:32:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49892, '2017-10-14 13:03:27', NULL, NULL, 13724, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:03:27', 'admin-1507955619-15079574073596860', 1, 1, 'SR', NULL, NULL, NULL),
(49893, '2017-10-14 13:01:24', NULL, NULL, 13728, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:01:24', 'admin-1507955619-15079572844944610', 1, 1, 'SR', NULL, NULL, NULL),
(49894, '2017-10-14 13:01:06', NULL, NULL, 13728, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:01:06', 'admin-1507955619-15079572666978353', 1, 0, '', NULL, NULL, NULL),
(49895, '2017-10-14 13:01:24', NULL, NULL, 13728, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:01:24', 'admin-1507955619-15079572844944610', 1, 0, '', NULL, NULL, NULL),
(49896, '2017-10-14 11:52:37', NULL, NULL, 13719, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:52:37', 'admin-1507948472-15079531575564527', 1, 0, '', NULL, NULL, NULL),
(49897, '2017-10-14 09:58:16', NULL, NULL, 13705, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:58:16', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(49898, '2017-10-14 09:58:20', NULL, NULL, 13705, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:58:20', 'admin-1507942523-1507946300589595', 1, 0, '', NULL, NULL, '10.0'),
(49899, '2017-10-14 09:58:20', NULL, NULL, 13705, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:58:20', 'admin-1507942523-1507946300589595', 1, 0, '', NULL, NULL, '10.0'),
(49900, '2017-10-14 12:30:23', NULL, NULL, 13724, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.80, 0.0000, 0.0000, 13.80, 1, '27', 1, '1507967892', 'admin', '2017-10-14 12:30:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49901, '2017-10-14 12:38:59', NULL, NULL, 13726, 0, 181, '116', 'Open Food ', 'bacon,egg,sausage', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 12:38:59', 'admin-1507955619-15079559395606772', 1, 0, '', 1, NULL, '10.0'),
(49902, '2017-10-14 12:25:00', NULL, NULL, 13723, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1507967892', 'admin', '2017-10-14 12:25:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49903, '2017-10-14 13:01:06', NULL, NULL, 13728, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:01:06', 'admin-1507955619-15079572666978353', 1, 1, 'SR', NULL, NULL, NULL),
(49904, '2017-10-14 13:01:06', NULL, NULL, 13728, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:01:06', 'admin-1507955619-15079572666978353', 1, 0, '', NULL, NULL, NULL),
(49905, '2017-10-14 11:52:37', NULL, NULL, 13719, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:52:37', 'admin-1507948472-15079531575564527', 1, 0, '', NULL, NULL, NULL),
(49906, '2017-10-14 17:06:11', NULL, NULL, 13748, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1507967892', 'admin', '2017-10-14 17:06:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49907, '2017-10-14 17:06:25', NULL, NULL, 13748, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 17:06:25', 'admin-1507967892-15079719848278065', 1, 0, '', NULL, NULL, NULL),
(49908, '2017-10-14 17:06:25', NULL, NULL, 13748, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 17:06:25', 'admin-1507967892-15079719848278065', 1, 1, 'SR', NULL, NULL, NULL),
(49909, '2017-10-14 14:37:50', NULL, NULL, 13739, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 14:37:50', 'admin-1507955619-1507963070423212', 1, 1, 'SR', NULL, NULL, NULL),
(49910, '2017-10-14 15:58:32', NULL, NULL, 13747, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 15:58:32', 'admin-1507967892-15079679121559280', 1, 1, 'SR', NULL, NULL, NULL),
(49911, '2017-10-14 16:48:13', NULL, NULL, 13747, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 16:48:13', 'admin-1507967892-15079708930884676', 1, 1, 'SR', NULL, NULL, NULL),
(49912, '2017-10-14 15:58:32', NULL, NULL, 13747, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 15:58:32', 'admin-1507967892-15079679121559280', 1, 1, 'SR', NULL, NULL, NULL),
(49913, '2017-10-14 15:58:06', NULL, NULL, 13747, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 15:58:06', 'admin-1507955619-15079678858861598', 1, 0, '', NULL, NULL, NULL),
(49914, '2017-10-14 15:58:25', NULL, NULL, 13747, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 15:58:25', 'admin-1507967892-15079679048527668', 1, 1, 'SR', NULL, NULL, NULL),
(49915, '2017-10-14 13:06:08', NULL, NULL, 13729, 0, 212, '146', 'Pork Bacon Salad', 'less salty', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:06:08', 'admin-1507955619-15079575682802624', 1, 0, '', NULL, NULL, NULL),
(49916, '2017-10-14 12:33:50', NULL, NULL, 13725, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 12:33:50', 'admin-1507955619-15079556304848329', 1, 1, 'SR', NULL, NULL, NULL),
(49917, '2017-10-14 15:40:05', NULL, NULL, 13739, 0, 181, '116', 'Open Food ', 'pancake', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 15:40:05', 'admin-1507955619-15079668054948643', 1, 0, '', NULL, NULL, NULL),
(49918, '2017-10-14 15:09:18', NULL, NULL, 13743, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 15:09:18', 'admin-1507955619-15079649584116045', 1, 0, '', 1, NULL, NULL),
(49919, '2017-10-14 15:53:11', NULL, NULL, 13746, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1507967892', 'admin', '2017-10-14 15:53:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49920, '2017-10-14 14:32:48', NULL, NULL, 13739, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 14:32:48', 'admin-1507955619-15079627685778566', 1, 0, '', NULL, NULL, NULL),
(49921, '2017-10-14 12:33:50', NULL, NULL, 13725, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 12:33:50', 'admin-1507955619-15079556304848329', 1, 1, 'SR', NULL, NULL, NULL),
(49922, '2017-10-14 11:13:07', NULL, NULL, 13713, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:13:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49923, '2017-10-14 11:13:19', NULL, NULL, 13713, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:13:19', 'admin-1507948472-15079507994981465', 1, 1, 'SR', NULL, NULL, NULL),
(49924, '2017-10-14 09:06:07', NULL, NULL, 13700, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:06:07', 'admin-1507942523-15079431668679337', 1, 1, 'SR', NULL, NULL, NULL),
(49925, '2017-10-14 13:55:39', NULL, NULL, 13735, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:55:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49926, '2017-10-14 13:55:43', NULL, NULL, 13735, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:55:43', 'admin-1507955619-15079605437015530', 1, 1, 'SR', NULL, NULL, NULL),
(49927, '2017-10-14 14:58:57', NULL, NULL, 13740, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 14:58:57', 'admin-1507955619-15079643375389128', 1, 0, '', NULL, NULL, NULL),
(49928, '2017-10-14 14:07:25', NULL, NULL, 13738, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 14:07:25', 'admin-1507955619-1507961245602606', 1, 1, 'SR', NULL, NULL, NULL),
(49929, '2017-10-14 14:07:25', NULL, NULL, 13738, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 14:07:25', 'admin-1507955619-1507961245602606', 1, 1, 'SR', NULL, NULL, NULL),
(49930, '2017-10-14 14:07:25', NULL, NULL, 13738, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 14:07:25', 'admin-1507955619-1507961245602606', 1, 1, 'SR', NULL, NULL, NULL),
(49931, '2017-10-14 14:07:25', NULL, NULL, 13738, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 14:07:25', 'admin-1507955619-1507961245602606', 1, 1, 'SR', NULL, NULL, NULL),
(49932, '2017-10-14 13:46:21', NULL, NULL, 13734, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:46:21', 'admin-1507955619-15079599812692332', 1, 1, 'SR', NULL, NULL, NULL),
(49933, '2017-10-14 14:02:11', NULL, NULL, 13737, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 14:02:11', 'admin-1507955619-15079609313839271', 1, 1, 'SR', NULL, NULL, NULL),
(49934, '2017-10-14 14:02:11', NULL, NULL, 13737, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 14:02:11', 'admin-1507955619-15079609313839271', 1, 1, 'SR', NULL, NULL, NULL),
(49935, '2017-10-14 12:33:36', NULL, NULL, 13724, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 3, 12.00, 36.0000, 0.0000, 36.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 12:33:36', 'admin-1507948472-15079555445069173', 1, 1, 'SR', NULL, NULL, NULL),
(49936, '2017-10-14 13:56:55', NULL, NULL, 13736, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:56:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49937, '2017-10-14 13:33:24', NULL, NULL, 13733, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:33:24', 'admin-1507955619-15079592039762578', 1, 0, '', NULL, NULL, NULL),
(49938, '2017-10-14 13:33:24', NULL, NULL, 13733, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:33:24', 'admin-1507955619-15079592039762578', 1, 1, 'SR', NULL, NULL, NULL),
(49939, '2017-10-14 13:46:06', NULL, NULL, 13734, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:46:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49940, '2017-10-14 13:46:21', NULL, NULL, 13734, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:46:21', 'admin-1507955619-15079599812692332', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(49941, '2017-10-14 13:33:07', NULL, NULL, 13733, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:33:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49942, '2017-10-14 13:25:46', NULL, NULL, 13732, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:25:46', 'admin-1507955619-1507958746198564', 1, 1, 'SR', 1, NULL, '10.0'),
(49943, '2017-10-14 14:59:08', NULL, NULL, 13740, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 14:59:08', 'admin-1507955619-15079643485118122', 1, 1, 'SR', NULL, NULL, NULL),
(49944, '2017-10-14 11:23:23', NULL, NULL, 13716, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:23:23', 'admin-1507948472-15079514028609426', 1, 1, 'SR', NULL, NULL, NULL),
(49945, '2017-10-14 13:08:49', NULL, NULL, 13729, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:08:49', 'admin-1507955619-15079577295045565', 1, 1, 'SR', NULL, NULL, NULL),
(49946, '2017-10-14 13:07:32', NULL, NULL, 13730, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:07:32', 'admin-1507955619-15079576524533547', 1, 0, '', NULL, NULL, NULL),
(49947, '2017-10-14 13:07:32', NULL, NULL, 13730, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:07:32', 'admin-1507955619-15079576524533547', 1, 0, '', NULL, NULL, NULL),
(49948, '2017-10-14 13:06:08', NULL, NULL, 13729, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:06:08', 'admin-1507955619-15079575682802624', 1, 0, '', NULL, NULL, NULL),
(49949, '2017-10-14 13:06:35', NULL, NULL, 13729, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:06:35', 'admin-1507955619-1507957595267233', 1, 1, 'SR', NULL, NULL, NULL),
(49950, '2017-10-14 13:07:24', NULL, NULL, 13730, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:07:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49951, '2017-10-14 13:06:08', NULL, NULL, 13729, 0, 215, '149', 'Thai Fish Sauce Garlic Pork', 'less salty', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:06:08', 'admin-1507955619-15079575682802624', 1, 0, '', NULL, NULL, NULL),
(49952, '2017-10-14 12:25:08', NULL, NULL, 13723, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 12:25:08', 'admin-1507948472-15079551085298350', 1, 1, 'SR', NULL, NULL, NULL),
(49953, '2017-10-14 12:25:08', NULL, NULL, 13723, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 12:25:08', 'admin-1507948472-15079551085298350', 1, 1, 'SR', NULL, NULL, NULL),
(49954, '2017-10-14 13:00:29', NULL, NULL, 13728, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:00:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49955, '2017-10-14 12:24:47', NULL, NULL, 13722, 0, 182, '117', 'Open Drinks ', 'americano promo', 'Cold Drinks', 'Fresh Juice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 12:24:47', 'admin-1507948472-15079550873092556', 1, 0, '', 1, NULL, NULL),
(49956, '2017-10-14 14:01:39', NULL, NULL, 13737, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1507967892', 'admin', '2017-10-14 14:01:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49957, '2017-10-14 14:32:48', NULL, NULL, 13739, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 14:32:48', 'admin-1507955619-15079627685778566', 1, 0, '', NULL, NULL, NULL),
(49958, '2017-10-14 12:33:36', NULL, NULL, 13724, 0, 70, '70', 'Borneo Pepper Pork', 'no rice', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 12:33:36', 'admin-1507948472-15079555445069173', 1, 1, 'SR', NULL, NULL, NULL),
(49959, '2017-10-14 12:18:40', NULL, NULL, 13720, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 12:18:40', 'admin-1507948472-15079547202029920', 1, 1, 'SR', NULL, NULL, NULL),
(49960, '2017-10-14 12:18:40', NULL, NULL, 13720, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 12:18:40', 'admin-1507948472-15079547202029920', 1, 0, '', NULL, NULL, NULL),
(49961, '2017-10-14 11:46:56', NULL, NULL, 13718, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:46:56', 'admin-1507948472-15079528159468714', 1, 1, 'SR', NULL, NULL, NULL),
(49962, '2017-10-14 11:46:56', NULL, NULL, 13718, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:46:56', 'admin-1507948472-15079528159468714', 1, 1, 'SR', NULL, NULL, NULL),
(49963, '2017-10-14 11:46:56', NULL, NULL, 13718, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:46:56', 'admin-1507948472-15079528159468714', 1, 0, '', NULL, NULL, NULL),
(49964, '2017-10-14 11:46:56', NULL, NULL, 13718, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:46:56', 'admin-1507948472-15079528159468714', 1, 1, 'SR', NULL, NULL, NULL),
(49965, '2017-10-14 11:52:20', NULL, NULL, 13719, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:52:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49966, '2017-10-14 11:46:38', NULL, NULL, 13718, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:46:38', 'admin-1507948472-15079527978078394', 1, 0, '', NULL, NULL, NULL),
(49967, '2017-10-14 11:46:38', NULL, NULL, 13718, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:46:38', 'admin-1507948472-15079527978078394', 1, 0, '', NULL, NULL, NULL),
(49968, '2017-10-14 00:00:00', NULL, NULL, 13711, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, NULL, NULL, 6.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:04:22', 'admin-1507948472-15079502619949783', 1, 1, 'SR', NULL, NULL, NULL),
(49969, '2017-10-14 11:46:38', NULL, NULL, 13718, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:46:38', 'admin-1507948472-15079527978078394', 1, 0, '', NULL, NULL, NULL),
(49970, '2017-10-14 11:18:05', NULL, NULL, 13715, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:18:05', 'admin-1507948472-15079510855134599', 1, 0, '', NULL, NULL, NULL),
(49971, '2017-10-14 11:18:05', NULL, NULL, 13715, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:18:05', 'admin-1507948472-15079510855134599', 1, 0, '', NULL, NULL, NULL),
(49972, '2017-10-14 11:18:05', NULL, NULL, 13715, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:18:05', 'admin-1507948472-15079510855134599', 1, 1, 'SR', NULL, NULL, NULL),
(49973, '2017-10-14 11:43:06', NULL, NULL, 13717, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:43:06', 'admin-1507948472-15079525866018431', 1, 0, '', NULL, NULL, '10.0'),
(49974, '2017-10-14 11:18:05', NULL, NULL, 13715, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:18:05', 'admin-1507948472-15079510855134599', 1, 0, '', NULL, NULL, NULL),
(49975, '2017-10-14 13:03:27', NULL, NULL, 13724, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 13:03:27', 'admin-1507955619-15079574073596860', 1, 1, 'SR', NULL, NULL, NULL),
(49976, '2017-10-14 11:46:37', NULL, NULL, 13718, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:46:37', 'admin-1507948472-15079527978078394', 1, 0, '', NULL, NULL, NULL),
(49977, '2017-10-14 11:43:06', NULL, NULL, 13717, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:43:06', 'admin-1507948472-15079525866018431', 1, 0, '', NULL, NULL, '10.0'),
(49978, '2017-10-14 11:43:06', NULL, NULL, 13717, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:43:06', 'admin-1507948472-15079525866018431', 1, 0, '', NULL, NULL, '10.0'),
(49979, '2017-10-14 11:42:53', NULL, NULL, 13717, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:42:53', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(49980, '2017-10-14 11:43:06', NULL, NULL, 13717, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:43:06', 'admin-1507948472-15079525866018431', 1, 1, 'SR', NULL, NULL, '10.0'),
(49981, '2017-10-14 09:54:05', NULL, NULL, 13704, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:54:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49982, '2017-10-14 09:54:18', NULL, NULL, 13704, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:54:18', 'admin-1507942523-15079460585282354', 1, 0, '', NULL, NULL, NULL),
(49983, '2017-10-14 09:54:18', NULL, NULL, 13704, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:54:18', 'admin-1507942523-15079460585282354', 1, 0, '', NULL, NULL, NULL),
(49984, '2017-10-14 11:15:49', NULL, NULL, 13714, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:15:49', 'admin-1507948472-15079509491614862', 1, 0, '', NULL, NULL, NULL),
(49985, '2017-10-14 11:17:52', NULL, NULL, 13715, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:17:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49986, '2017-10-14 11:46:27', NULL, NULL, 13718, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.00, 0.0000, 0.0000, 12.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:46:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49987, '2017-10-14 11:15:41', NULL, NULL, 13714, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:15:41', 'admin-1507948472-15079509411495596', 1, 0, '', NULL, NULL, NULL),
(49988, '2017-10-14 09:58:35', NULL, NULL, 13706, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.99, 0.0000, 0.0000, 0.99, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:58:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49989, '2017-10-14 09:58:47', NULL, NULL, 13706, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:58:47', 'admin-1507942523-15079463273673612', 1, 1, 'SR', NULL, NULL, NULL),
(49990, '2017-10-14 09:58:47', NULL, NULL, 13706, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:58:47', 'admin-1507942523-15079463273673612', 1, 0, '', NULL, NULL, NULL),
(49991, '2017-10-14 10:02:50', NULL, NULL, 13705, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 10:02:50', 'admin-1507942523-1507946570525305', 1, 1, 'SR', NULL, NULL, '10.0'),
(49992, '2017-10-14 12:01:38', NULL, NULL, 13718, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 12:01:38', 'admin-1507948472-15079536985469247', 1, 0, '', NULL, NULL, NULL),
(49993, '2017-10-14 11:15:31', NULL, NULL, 13714, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:15:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(49994, '2017-10-14 11:15:41', NULL, NULL, 13714, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:15:41', 'admin-1507948472-15079509411495596', 1, 0, '', NULL, NULL, NULL),
(49995, '2017-10-14 11:15:11', NULL, NULL, 13713, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:15:11', 'admin-1507948472-15079509111644485', 1, 0, '', NULL, NULL, NULL),
(49996, '2017-10-14 00:00:00', NULL, NULL, 13711, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:07:25', 'admin-1507948472-1507950445559712', 1, 1, 'SR', NULL, NULL, NULL),
(49997, '2017-10-14 00:00:00', NULL, NULL, 13712, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 10:53:40', 'admin-1507948472-15079496206463275', 1, 1, 'SR', NULL, NULL, NULL),
(49998, '2017-10-14 00:00:00', NULL, NULL, 13712, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 10:53:40', 'admin-1507948472-15079496206463275', 1, 1, 'SR', NULL, NULL, NULL),
(49999, '2017-10-14 00:00:00', NULL, NULL, 13712, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, NULL, NULL, 1.80, 1, '27', 1, '1507967892', 'admin', '2017-10-14 10:53:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50000, '2017-10-14 10:32:25', NULL, NULL, 13709, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 10:32:25', 'admin-1507942523-15079483448922483', 1, 0, '', NULL, NULL, NULL),
(50001, '2017-10-14 11:22:47', NULL, NULL, 13716, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.70, 0.0000, 0.0000, 9.70, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:22:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50002, '2017-10-14 10:32:25', NULL, NULL, 13709, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 10:32:25', 'admin-1507942523-15079483448922483', 1, 0, '', NULL, NULL, NULL),
(50003, '2017-10-14 10:32:15', NULL, NULL, 13709, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1507967892', 'admin', '2017-10-14 10:32:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50004, '2017-10-14 10:29:23', NULL, NULL, 13708, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 10:29:23', 'admin-1507942523-15079481637297979', 1, 1, 'SR', NULL, NULL, NULL),
(50005, '2017-10-14 10:29:07', NULL, NULL, 13708, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1507967892', 'admin', '2017-10-14 10:29:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50006, '2017-10-14 10:29:23', NULL, NULL, 13708, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 10:29:23', 'admin-1507942523-15079481637297979', 1, 0, '', NULL, NULL, NULL),
(50007, '2017-10-14 10:06:28', NULL, NULL, 13707, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 10:06:28', 'admin-1507942523-1507946788188445', 1, 1, 'SR', NULL, NULL, NULL),
(50008, '2017-10-14 10:14:31', NULL, NULL, 13702, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 10:14:31', 'admin-1507942523-15079472716917851', 1, 0, '', NULL, NULL, NULL),
(50009, '2017-10-14 10:06:28', NULL, NULL, 13707, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 10:06:28', 'admin-1507942523-1507946788188445', 1, 1, 'SR', NULL, NULL, NULL),
(50010, '2017-10-14 10:06:28', NULL, NULL, 13707, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 10:06:28', 'admin-1507942523-1507946788188445', 1, 0, '', NULL, NULL, NULL),
(50011, '2017-10-14 10:06:28', NULL, NULL, 13707, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 10:06:28', 'admin-1507942523-1507946788188445', 1, 0, '', NULL, NULL, NULL),
(50012, '2017-10-14 10:02:50', NULL, NULL, 13705, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 10:02:50', 'admin-1507942523-1507946570525305', 1, 0, '', NULL, NULL, '10.0'),
(50013, '2017-10-14 10:06:15', NULL, NULL, 13707, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1507967892', 'admin', '2017-10-14 10:06:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50014, '2017-10-14 09:05:35', NULL, NULL, 13700, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:05:35', 'admin-1507942523-15079431356068873', 1, 0, '', NULL, NULL, NULL),
(50015, '2017-10-14 09:05:35', NULL, NULL, 13700, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:05:35', 'admin-1507942523-15079431356068873', 1, 0, '', NULL, NULL, NULL),
(50016, '2017-10-14 09:54:18', NULL, NULL, 13704, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:54:18', 'admin-1507942523-15079460585282354', 1, 1, 'SR', NULL, NULL, NULL),
(50017, '2017-10-14 09:41:12', NULL, NULL, 13703, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:41:12', 'admin-1507942523-15079452724666172', 1, 1, 'SR', NULL, NULL, NULL),
(50018, '2017-10-14 09:41:07', NULL, NULL, 13703, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:41:07', 'admin-1507942523-15079452671372217', 1, 0, '', NULL, NULL, NULL),
(50019, '2017-10-14 09:40:44', NULL, NULL, 13702, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:40:44', 'admin-1507942523-15079452439069396', 1, 0, '', NULL, NULL, NULL),
(50020, '2017-10-14 09:40:15', NULL, NULL, 13702, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.50, 0.0000, 0.0000, 10.50, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:40:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50021, '2017-10-14 11:53:46', NULL, NULL, 13716, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 11:53:46', 'admin-1507948472-15079532262882067', 1, 1, 'SR', NULL, NULL, NULL),
(50022, '2017-10-14 09:16:03', NULL, NULL, 13701, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:16:03', 'admin-1507942523-15079437629185618', 1, 0, '', NULL, NULL, NULL),
(50023, '2017-10-14 09:15:48', NULL, NULL, 13701, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:15:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50024, '2017-10-14 09:16:03', NULL, NULL, 13701, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:16:03', 'admin-1507942523-15079437629185618', 1, 0, '', NULL, NULL, NULL),
(50025, '2017-10-14 09:06:07', NULL, NULL, 13700, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:06:07', 'admin-1507942523-15079431668679337', 1, 1, 'SR', NULL, NULL, NULL),
(50026, '2017-10-14 09:05:30', NULL, NULL, 13700, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1507967892', 'admin', '2017-10-14 09:05:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50027, '2017-10-15 14:31:48', NULL, NULL, 13799, 0, 182, '117', 'Open Drinks ', 'americano', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 14:31:48', 'admin-1508045791-1508049108483916', 1, 0, '', 1, NULL, NULL),
(50028, '2017-10-15 14:32:12', NULL, NULL, 13800, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 14:32:12', 'admin-1508045791-1508049132619692', 1, 1, 'SR', 1, NULL, '10.0'),
(50029, '2017-10-15 13:28:11', NULL, NULL, 13794, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:28:11', 'admin-1508042465-15080452917253955', 1, 1, 'SR', NULL, NULL, NULL),
(50030, '2017-10-15 13:28:11', NULL, NULL, 13794, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:28:11', 'admin-1508042465-15080452917253955', 1, 1, 'SR', NULL, NULL, NULL),
(50031, '2017-10-15 12:43:44', NULL, NULL, 13786, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:43:44', 'admin-1508042465-15080426242257818', 1, 1, 'SR', NULL, NULL, NULL),
(50032, '2017-10-15 12:42:45', NULL, NULL, 13786, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:42:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50033, '2017-10-15 10:04:41', NULL, NULL, 13756, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:04:41', 'admin-1508028344-15080330808865058', 1, 1, 'SR', NULL, NULL, NULL),
(50034, '2017-10-15 10:04:41', NULL, NULL, 13756, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:04:41', 'admin-1508028344-15080330808865058', 1, 1, 'SR', NULL, NULL, NULL),
(50035, '2017-10-15 10:06:45', NULL, NULL, 13757, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:06:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50036, '2017-10-15 10:06:45', NULL, NULL, 13758, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:06:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50037, '2017-10-15 10:07:12', NULL, NULL, 13757, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:07:12', 'admin-1508033215-15080332323831262', 1, 0, '', NULL, NULL, NULL),
(50038, '2017-10-15 16:55:08', NULL, NULL, 13810, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 16:55:08', 'admin-1508052010-15080577085263160', 1, 1, 'SR', NULL, NULL, NULL),
(50039, '2017-10-15 16:55:08', NULL, NULL, 13810, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 16:55:08', 'admin-1508052010-15080577085263160', 1, 1, 'SR', NULL, NULL, NULL),
(50040, '2017-10-15 16:54:48', NULL, NULL, 13810, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1508052010', 'admin', '2017-10-15 16:54:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50041, '2017-10-15 15:44:57', NULL, NULL, 13805, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 15:44:57', 'admin-1508052010-15080534970824596', 1, 1, 'SR', NULL, NULL, NULL),
(50042, '2017-10-15 15:44:37', NULL, NULL, 13805, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.79, 0.0000, 0.0000, 2.79, 1, '27', 1, '1508052010', 'admin', '2017-10-15 15:44:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50043, '2017-10-15 15:36:33', NULL, NULL, 13804, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 15:36:33', 'admin-1508052010-15080529929422532', 1, 1, 'SR', NULL, NULL, NULL),
(50044, '2017-10-15 13:27:39', NULL, NULL, 13794, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:27:39', 'admin-1508042465-15080452593967657', 1, 0, '', NULL, NULL, NULL),
(50045, '2017-10-15 13:13:02', NULL, NULL, 13792, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:13:02', 'admin-1508042465-15080443818997458', 1, 1, 'SR', NULL, NULL, NULL),
(50046, '2017-10-15 13:05:58', NULL, NULL, 13790, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:05:58', 'admin-1508042465-15080439579466992', 1, 0, '', NULL, NULL, NULL),
(50047, '2017-10-15 13:27:39', NULL, NULL, 13794, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:27:39', 'admin-1508042465-15080452593967657', 1, 0, '', NULL, NULL, NULL),
(50048, '2017-10-15 11:47:53', NULL, NULL, 13779, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:47:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50049, '2017-10-15 10:39:31', NULL, NULL, 13766, 0, 32, '32', 'Tea By Pot ', 'chamomile', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:39:31', 'admin-1508034832-15080351714607119', 1, 1, 'SR', NULL, NULL, NULL),
(50050, '2017-10-15 10:45:08', NULL, NULL, 13768, 0, 182, '117', 'Open Drinks ', 'americano promo', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:45:08', 'admin-1508034832-15080355084245542', 1, 0, '', 1, NULL, NULL),
(50051, '2017-10-15 10:45:28', NULL, NULL, 13758, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:45:28', 'admin-1508034832-15080355279784227', 1, 1, 'SR', NULL, NULL, NULL),
(50052, '2017-10-15 15:22:05', NULL, NULL, 13803, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 15:22:05', 'admin-1508052010-15080521250752374', 1, 1, 'SR', NULL, NULL, NULL),
(50053, '2017-10-15 15:22:05', NULL, NULL, 13803, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 15:22:05', 'admin-1508052010-15080521250752374', 1, 1, 'SR', NULL, NULL, NULL),
(50054, '2017-10-15 13:27:39', NULL, NULL, 13794, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:27:39', 'admin-1508042465-15080452593967657', 1, 1, 'SR', NULL, NULL, NULL),
(50055, '2017-10-15 13:16:31', NULL, NULL, 13793, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:16:31', 'admin-1508042465-15080445916015053', 1, 1, 'SR', NULL, NULL, NULL),
(50056, '2017-10-15 13:23:06', NULL, NULL, 13783, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:23:06', 'admin-1508042465-15080449858485249', 1, 1, 'SR', NULL, NULL, NULL),
(50057, '2017-10-15 15:36:22', NULL, NULL, 13804, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 15:36:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50058, '2017-10-15 13:16:19', NULL, NULL, 13793, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:16:19', 'admin-1508042465-15080445793081641', 1, 0, '', NULL, NULL, NULL),
(50059, '2017-10-15 12:13:16', NULL, NULL, 13782, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:13:16', 'admin-1508038896-1508040796749196', 1, 0, '', NULL, NULL, NULL),
(50060, '2017-10-15 16:30:16', NULL, NULL, 13809, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 16:30:16', 'admin-1508052010-15080562167218755', 1, 1, 'SR', NULL, NULL, NULL),
(50061, '2017-10-15 10:49:44', NULL, NULL, 13752, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:49:44', 'admin-1508034832-15080357845233669', 1, 1, 'SR', NULL, NULL, NULL),
(50062, '2017-10-15 10:49:50', NULL, NULL, 13752, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:49:50', 'admin-1508034832-15080357903315756', 1, 0, '', NULL, NULL, NULL),
(50063, '2017-10-15 10:50:44', NULL, NULL, 13760, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:50:44', 'admin-1508034832-15080358442801132', 1, 0, '', NULL, NULL, NULL),
(50064, '2017-10-15 16:20:50', NULL, NULL, 13808, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 16:20:50', 'admin-1508052010-15080556498759450', 1, 1, 'SR', NULL, NULL, NULL),
(50065, '2017-10-15 16:30:08', NULL, NULL, 13809, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1508052010', 'admin', '2017-10-15 16:30:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50066, '2017-10-15 16:30:16', NULL, NULL, 13809, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 16:30:16', 'admin-1508052010-15080562167218755', 1, 1, 'SR', NULL, NULL, NULL),
(50067, '2017-10-15 11:32:13', NULL, NULL, 13760, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:32:13', 'admin-1508034832-15080383335318462', 1, 1, 'SR', NULL, NULL, NULL),
(50068, '2017-10-15 11:37:36', NULL, NULL, 13776, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:37:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50069, '2017-10-15 10:25:52', NULL, NULL, 13762, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:25:52', 'admin-1508033215-15080343527197926', 1, 0, '', NULL, NULL, NULL),
(50070, '2017-10-15 11:24:53', NULL, NULL, 13774, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:24:53', 'admin-1508034832-1508037892996782', 1, 1, 'SR', NULL, NULL, NULL),
(50071, '2017-10-15 14:03:20', NULL, NULL, 13797, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 14:03:20', 'admin-1508045791-15080473999794364', 1, 0, '', NULL, NULL, NULL),
(50072, '2017-10-15 14:16:31', NULL, NULL, 13798, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1508052010', 'admin', '2017-10-15 14:16:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50073, '2017-10-15 14:16:40', NULL, NULL, 13798, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 14:16:40', 'admin-1508045791-15080482007751320', 1, 1, 'SR', NULL, NULL, NULL),
(50074, '2017-10-15 14:16:40', NULL, NULL, 13798, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 14:16:40', 'admin-1508045791-15080482007751320', 1, 0, '', NULL, NULL, NULL),
(50075, '2017-10-15 14:30:00', NULL, NULL, 13797, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 14:30:00', 'admin-1508045791-1508048999867948', 1, 1, 'SR', NULL, NULL, NULL),
(50076, '2017-10-15 13:23:06', NULL, NULL, 13783, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:23:06', 'admin-1508042465-15080449858485249', 1, 1, 'SR', NULL, NULL, NULL),
(50077, '2017-10-15 13:26:33', NULL, NULL, 13794, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.00, 0.0000, 0.0000, 15.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:26:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50078, '2017-10-15 13:36:11', NULL, NULL, 13795, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:36:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50079, '2017-10-15 13:36:25', NULL, NULL, 13795, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:36:25', 'admin-1508042465-15080457856676515', 1, 0, '', NULL, NULL, NULL),
(50080, '2017-10-15 13:36:25', NULL, NULL, 13795, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:36:25', 'admin-1508042465-15080457856676515', 1, 0, '', NULL, NULL, NULL),
(50081, '2017-10-15 13:36:25', NULL, NULL, 13795, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:36:25', 'admin-1508042465-15080457856676515', 1, 0, '', NULL, NULL, NULL),
(50082, '2017-10-15 13:02:04', NULL, NULL, 13789, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:02:04', 'admin-1508042465-15080437240065822', 1, 1, 'SR', NULL, NULL, NULL),
(50083, '2017-10-15 13:02:04', NULL, NULL, 13789, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:02:04', 'admin-1508042465-15080437240065822', 1, 1, 'SR', NULL, NULL, NULL),
(50084, '2017-10-15 11:48:16', NULL, NULL, 13779, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:48:16', 'admin-1508038896-15080392961481962', 1, 1, 'SR', NULL, NULL, NULL),
(50085, '2017-10-15 16:20:50', NULL, NULL, 13808, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 16:20:50', 'admin-1508052010-15080556498759450', 1, 1, 'SR', NULL, NULL, NULL),
(50086, '2017-10-15 16:04:53', NULL, NULL, 13806, 0, 181, '116', 'Open Food ', 'egg', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 16:04:53', 'admin-1508052010-15080546937272429', 1, 0, '', NULL, NULL, NULL),
(50087, '2017-10-15 16:20:35', NULL, NULL, 13808, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1508052010', 'admin', '2017-10-15 16:20:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50088, '2017-10-15 15:58:19', NULL, NULL, 13806, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 15:58:19', 'admin-1508052010-15080542990642868', 1, 0, '', NULL, NULL, NULL),
(50089, '2017-10-15 13:12:49', NULL, NULL, 13792, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:12:49', 'admin-1508042465-15080443695169567', 1, 1, 'SR', NULL, NULL, NULL),
(50090, '2017-10-15 13:58:50', NULL, NULL, 13797, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:58:50', 'admin-1508045791-15080471306534359', 1, 1, 'SR', NULL, NULL, NULL),
(50091, '2017-10-15 14:03:09', NULL, NULL, 13797, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 14:03:09', 'admin-1508045791-15080473888993673', 1, 0, '', NULL, NULL, NULL),
(50092, '2017-10-15 12:45:17', NULL, NULL, 13787, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:45:17', 'admin-1508042465-15080427176176989', 1, 0, '', NULL, NULL, NULL),
(50093, '2017-10-15 12:45:30', NULL, NULL, 13787, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:45:30', 'admin-1508042465-15080427304463267', 1, 1, 'SR', NULL, NULL, NULL),
(50094, '2017-10-15 10:59:55', NULL, NULL, 13769, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:59:55', 'admin-1508034832-15080363954725357', 1, 0, '', NULL, NULL, NULL),
(50095, '2017-10-15 16:55:38', NULL, NULL, 13810, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 16:55:38', 'admin-1508052010-1508057737801517', 1, 1, 'SR', NULL, NULL, NULL),
(50096, '2017-10-15 11:41:52', NULL, NULL, 13777, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:41:52', 'admin-1508038896-15080389123834757', 1, 0, '', NULL, NULL, NULL),
(50097, '2017-10-15 11:37:43', NULL, NULL, 13776, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:37:43', 'admin-1508034832-15080386633366429', 1, 1, 'SR', NULL, NULL, NULL),
(50098, '2017-10-15 11:41:32', NULL, NULL, 13777, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:41:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50099, '2017-10-15 12:17:42', NULL, NULL, 13776, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:17:42', 'admin-1508038896-15080410620945672', 1, 1, 'SR', NULL, NULL, NULL),
(50100, '2017-10-15 12:17:57', NULL, NULL, 13783, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 19.20, 0.0000, 0.0000, 19.20, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:17:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50101, '2017-10-15 12:18:53', NULL, NULL, 13783, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:18:53', 'admin-1508038896-15080411336041879', 1, 1, 'SR', NULL, NULL, NULL),
(50102, '2017-10-15 13:00:54', NULL, NULL, 13789, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:00:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50103, '2017-10-15 15:22:05', NULL, NULL, 13803, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 15:22:05', 'admin-1508052010-15080521250752374', 1, 1, 'SR', NULL, NULL, NULL),
(50104, '2017-10-15 13:13:28', NULL, NULL, 13790, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:13:28', 'admin-1508042465-15080444079536356', 1, 1, 'SR', NULL, NULL, NULL),
(50105, '2017-10-15 13:16:10', NULL, NULL, 13793, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:16:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50106, '2017-10-15 16:55:08', NULL, NULL, 13810, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 16:55:08', 'admin-1508052010-15080577085263160', 1, 0, '', NULL, NULL, NULL),
(50107, '2017-10-15 15:14:50', NULL, NULL, 13803, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1508052010', 'admin', '2017-10-15 15:14:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50108, '2017-10-15 14:52:23', NULL, NULL, 13801, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 14:52:23', 'admin-1508045791-1508050342847881', 1, 0, '', NULL, NULL, NULL),
(50109, '2017-10-15 14:52:23', NULL, NULL, 13801, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 14:52:23', 'admin-1508045791-1508050342847881', 1, 1, 'SR', NULL, NULL, NULL),
(50110, '2017-10-15 14:52:18', NULL, NULL, 13801, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1508052010', 'admin', '2017-10-15 14:52:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50111, '2017-10-15 14:52:23', NULL, NULL, 13801, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 14:52:23', 'admin-1508045791-1508050342847881', 1, 0, '', NULL, NULL, NULL),
(50112, '2017-10-15 13:11:12', NULL, NULL, 13783, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:11:12', 'admin-1508042465-15080442726677048', 1, 0, '', NULL, NULL, NULL),
(50113, '2017-10-15 13:45:46', NULL, NULL, 13796, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:45:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50114, '2017-10-15 13:45:57', NULL, NULL, 13796, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:45:57', 'admin-1508045791-15080463577222347', 1, 0, '', NULL, NULL, NULL),
(50115, '2017-10-15 13:45:57', NULL, NULL, 13796, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:45:57', 'admin-1508045791-15080463577222347', 1, 1, 'SR', NULL, NULL, NULL),
(50116, '2017-10-15 13:54:59', NULL, NULL, 13797, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:54:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50117, '2017-10-15 13:55:07', NULL, NULL, 13797, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:55:07', 'admin-1508045791-15080469077472760', 1, 0, '', NULL, NULL, NULL),
(50118, '2017-10-15 13:05:58', NULL, NULL, 13790, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:05:58', 'admin-1508042465-15080439579466992', 1, 0, '', NULL, NULL, NULL),
(50119, '2017-10-15 13:05:58', NULL, NULL, 13790, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:05:58', 'admin-1508042465-15080439579466992', 1, 0, '', NULL, NULL, NULL),
(50120, '2017-10-15 13:05:58', NULL, NULL, 13790, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:05:58', 'admin-1508042465-15080439579466992', 1, 0, '', NULL, NULL, NULL),
(50121, '2017-10-15 13:05:58', NULL, NULL, 13790, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:05:58', 'admin-1508042465-15080439579466992', 1, 1, 'SR', NULL, NULL, NULL),
(50122, '2017-10-15 13:05:58', NULL, NULL, 13790, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:05:58', 'admin-1508042465-15080439579466992', 1, 0, '', NULL, NULL, NULL),
(50123, '2017-10-15 13:05:58', NULL, NULL, 13790, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:05:58', 'admin-1508042465-15080439579466992', 1, 0, '', NULL, NULL, NULL),
(50124, '2017-10-15 13:02:04', NULL, NULL, 13789, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:02:04', 'admin-1508042465-15080437240065822', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(50125, '2017-10-15 13:04:52', NULL, NULL, 13790, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 19.10, 0.0000, 0.0000, 19.10, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:04:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50126, '2017-10-15 12:33:21', NULL, NULL, 13785, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:33:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50127, '2017-10-15 12:33:34', NULL, NULL, 13785, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:33:34', 'admin-1508038896-15080420146862514', 1, 1, 'SR', NULL, NULL, NULL),
(50128, '2017-10-15 10:28:15', NULL, NULL, 13763, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:28:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50129, '2017-10-15 12:43:44', NULL, NULL, 13786, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:43:44', 'admin-1508042465-15080426242257818', 1, 1, 'SR', NULL, NULL, NULL),
(50130, '2017-10-15 13:13:02', NULL, NULL, 13792, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:13:02', 'admin-1508042465-15080443818997458', 1, 1, 'SR', NULL, NULL, NULL),
(50131, '2017-10-15 12:28:41', NULL, NULL, 13784, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:28:41', 'admin-1508038896-15080417211468232', 1, 0, '', NULL, NULL, NULL),
(50132, '2017-10-15 12:28:41', NULL, NULL, 13784, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:28:41', 'admin-1508038896-15080417211468232', 1, 1, 'SR', NULL, NULL, NULL),
(50133, '2017-10-15 13:16:31', NULL, NULL, 13793, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:16:31', 'admin-1508042465-15080445916015053', 1, 1, 'SR', NULL, NULL, NULL),
(50134, '2017-10-15 12:43:44', NULL, NULL, 13786, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:43:44', 'admin-1508042465-15080426242257818', 1, 1, 'SR', NULL, NULL, NULL),
(50135, '2017-10-15 11:59:07', NULL, NULL, 13762, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:59:07', 'admin-1508038896-1508039947611644', 1, 0, '', NULL, NULL, NULL),
(50136, '2017-10-15 11:48:16', NULL, NULL, 13779, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:48:16', 'admin-1508038896-15080392961481962', 1, 1, 'SR', NULL, NULL, NULL),
(50137, '2017-10-15 11:48:16', NULL, NULL, 13779, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:48:16', 'admin-1508038896-15080392961481962', 1, 1, 'SR', NULL, NULL, NULL),
(50138, '2017-10-15 11:57:17', NULL, NULL, 13780, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:57:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50139, '2017-10-15 11:57:32', NULL, NULL, 13780, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:57:32', 'admin-1508038896-15080398525546917', 1, 1, 'SR', NULL, NULL, NULL),
(50140, '2017-10-15 11:57:32', NULL, NULL, 13780, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:57:32', 'admin-1508038896-15080398525546917', 1, 0, '', NULL, NULL, NULL),
(50141, '2017-10-15 11:57:32', NULL, NULL, 13780, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:57:32', 'admin-1508038896-15080398525546917', 1, 0, '', NULL, NULL, NULL),
(50142, '2017-10-15 09:21:01', NULL, NULL, 13750, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:21:01', 'admin-1508028344-15080304609848729', 1, 1, 'SR', NULL, NULL, NULL),
(50143, '2017-10-15 09:24:05', NULL, NULL, 13751, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:24:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50144, '2017-10-15 09:36:20', NULL, NULL, 13751, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:36:20', 'admin-1508028344-15080313799218686', 1, 0, '', NULL, NULL, NULL),
(50145, '2017-10-15 09:24:12', NULL, NULL, 13751, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:24:12', 'admin-1508028344-15080306525194492', 1, 0, '', NULL, NULL, NULL),
(50146, '2017-10-15 09:24:12', NULL, NULL, 13751, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:24:12', 'admin-1508028344-15080306525194492', 1, 1, 'SR', NULL, NULL, NULL),
(50147, '2017-10-15 09:24:12', NULL, NULL, 13751, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:24:12', 'admin-1508028344-15080306525194492', 1, 1, 'SR', NULL, NULL, NULL),
(50148, '2017-10-15 12:28:41', NULL, NULL, 13784, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:28:41', 'admin-1508038896-15080417211468232', 1, 0, '', NULL, NULL, NULL),
(50149, '2017-10-15 13:12:00', NULL, NULL, 13783, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:12:00', 'admin-1508042465-15080443202002784', 1, 0, '', NULL, NULL, NULL),
(50150, '2017-10-15 11:47:24', NULL, NULL, 13778, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:47:24', 'admin-1508038896-15080392440685029', 1, 0, '', NULL, NULL, NULL),
(50151, '2017-10-15 13:12:33', NULL, NULL, 13792, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:12:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50152, '2017-10-15 13:09:22', NULL, NULL, 13791, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:09:22', 'admin-1508042465-15080441621073922', 1, 1, 'SR', NULL, NULL, NULL),
(50153, '2017-10-15 13:09:22', NULL, NULL, 13791, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:09:22', 'admin-1508042465-15080441621073922', 1, 1, 'SR', NULL, NULL, NULL),
(50154, '2017-10-15 13:09:22', NULL, NULL, 13791, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:09:22', 'admin-1508042465-15080441621073922', 1, 0, '', NULL, NULL, NULL),
(50155, '2017-10-15 13:06:38', NULL, NULL, 13790, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:06:38', 'admin-1508042465-15080439984377143', 1, 1, 'SR', NULL, NULL, NULL),
(50156, '2017-10-15 13:05:58', NULL, NULL, 13790, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:05:58', 'admin-1508042465-15080439579466992', 1, 1, 'SR', NULL, NULL, NULL),
(50157, '2017-10-15 13:06:38', NULL, NULL, 13790, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:06:38', 'admin-1508042465-15080439984377143', 1, 1, 'SR', NULL, NULL, NULL),
(50158, '2017-10-15 13:06:38', NULL, NULL, 13790, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:06:38', 'admin-1508042465-15080439984377143', 1, 1, 'SR', NULL, NULL, NULL),
(50159, '2017-10-15 12:28:41', NULL, NULL, 13784, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:28:41', 'admin-1508038896-15080417211468232', 1, 0, '', NULL, NULL, NULL),
(50160, '2017-10-15 12:18:53', NULL, NULL, 13783, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:18:53', 'admin-1508038896-15080411336041879', 1, 0, '', NULL, NULL, NULL),
(50161, '2017-10-15 12:18:53', NULL, NULL, 13783, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:18:53', 'admin-1508038896-15080411336041879', 1, 0, '', NULL, NULL, NULL),
(50162, '2017-10-15 12:18:53', NULL, NULL, 13783, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:18:53', 'admin-1508038896-15080411336041879', 1, 1, 'SR', NULL, NULL, NULL),
(50163, '2017-10-15 09:42:46', NULL, NULL, 13753, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:42:46', 'admin-1508028344-1508031765917478', 1, 0, '', NULL, NULL, NULL),
(50164, '2017-10-15 09:43:04', NULL, NULL, 13753, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:43:04', 'admin-1508028344-1508031783997148', 1, 0, '', NULL, NULL, NULL),
(50165, '2017-10-15 09:43:04', NULL, NULL, 13753, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:43:04', 'admin-1508028344-1508031783997148', 1, 1, 'SR', NULL, NULL, NULL),
(50166, '2017-10-15 12:52:11', NULL, NULL, 13788, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:52:11', 'admin-1508042465-15080431315905793', 1, 0, '', NULL, NULL, NULL),
(50167, '2017-10-15 13:36:25', NULL, NULL, 13795, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:36:25', 'admin-1508042465-15080457856676515', 1, 0, '', NULL, NULL, NULL),
(50168, '2017-10-15 13:02:04', NULL, NULL, 13789, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:02:04', 'admin-1508042465-15080437240065822', 1, 1, 'SR', NULL, NULL, NULL),
(50169, '2017-10-15 13:28:57', NULL, NULL, 13794, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:28:57', 'admin-1508042465-15080453372816966', 1, 0, '', NULL, NULL, NULL),
(50170, '2017-10-15 11:06:34', NULL, NULL, 13773, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:06:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50171, '2017-10-15 11:06:47', NULL, NULL, 13773, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:06:47', 'admin-1508034832-15080368075265438', 1, 0, '', NULL, NULL, NULL),
(50172, '2017-10-15 11:06:47', NULL, NULL, 13773, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:06:47', 'admin-1508034832-15080368075265438', 1, 0, '', NULL, NULL, NULL),
(50173, '2017-10-15 11:04:05', NULL, NULL, 13771, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:04:05', 'admin-1508034832-15080366449249581', 1, 1, 'SR', NULL, NULL, NULL),
(50174, '2017-10-15 12:52:11', NULL, NULL, 13788, 0, 299, '235', 'Iced Salted Caramel Machiato', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:52:11', 'admin-1508042465-15080431315905793', 1, 0, '', NULL, NULL, NULL),
(50175, '2017-10-15 15:21:52', NULL, NULL, 13803, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 15:21:52', 'admin-1508052010-15080521118288932', 1, 1, 'SR', NULL, NULL, NULL),
(50176, '2017-10-15 12:51:45', NULL, NULL, 13788, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:51:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50177, '2017-10-15 12:45:03', NULL, NULL, 13787, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:45:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50178, '2017-10-15 12:45:17', NULL, NULL, 13787, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:45:17', 'admin-1508042465-15080427176176989', 1, 0, '', NULL, NULL, NULL),
(50179, '2017-10-15 13:09:14', NULL, NULL, 13791, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:09:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50180, '2017-10-15 12:43:44', NULL, NULL, 13786, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:43:44', 'admin-1508042465-15080426242257818', 1, 1, 'SR', NULL, NULL, NULL),
(50181, '2017-10-15 12:18:53', NULL, NULL, 13783, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:18:53', 'admin-1508038896-15080411336041879', 1, 0, '', NULL, NULL, NULL),
(50182, '2017-10-15 12:18:53', NULL, NULL, 13783, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:18:53', 'admin-1508038896-15080411336041879', 1, 0, '', NULL, NULL, NULL),
(50183, '2017-10-15 12:18:53', NULL, NULL, 13783, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:18:53', 'admin-1508038896-15080411336041879', 1, 0, '', NULL, NULL, NULL),
(50184, '2017-10-15 10:37:27', NULL, NULL, 13765, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:37:27', 'admin-1508034832-15080350470136421', 1, 1, 'SR', NULL, NULL, '10.0'),
(50185, '2017-10-15 16:20:50', NULL, NULL, 13808, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 16:20:50', 'admin-1508052010-15080556498759450', 1, 1, 'SR', NULL, NULL, NULL),
(50186, '2017-10-15 12:18:53', NULL, NULL, 13783, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:18:53', 'admin-1508038896-15080411336041879', 1, 0, '', NULL, NULL, NULL),
(50187, '2017-10-15 12:05:40', NULL, NULL, 13781, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:05:40', 'admin-1508038896-1508040340186288', 1, 1, 'SR', NULL, NULL, NULL),
(50188, '2017-10-15 12:12:29', NULL, NULL, 13782, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:12:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50189, '2017-10-15 11:24:53', NULL, NULL, 13774, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:24:53', 'admin-1508034832-1508037892996782', 1, 1, 'SR', NULL, NULL, NULL),
(50190, '2017-10-15 15:44:57', NULL, NULL, 13805, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1508052010', 'admin', '2017-10-15 15:44:57', 'admin-1508052010-15080534970824596', 1, 0, '', NULL, NULL, NULL),
(50191, '2017-10-15 13:27:39', NULL, NULL, 13794, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:27:39', 'admin-1508042465-15080452593967657', 1, 0, '', NULL, NULL, NULL),
(50192, '2017-10-15 13:16:19', NULL, NULL, 13793, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:16:19', 'admin-1508042465-15080445793081641', 1, 0, '', NULL, NULL, NULL),
(50193, '2017-10-15 12:33:34', NULL, NULL, 13785, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:33:34', 'admin-1508038896-15080420146862514', 1, 1, 'SR', NULL, NULL, NULL),
(50194, '2017-10-15 11:48:16', NULL, NULL, 13779, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:48:16', 'admin-1508038896-15080392961481962', 1, 0, '', NULL, NULL, NULL),
(50195, '2017-10-15 12:17:42', NULL, NULL, 13776, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:17:42', 'admin-1508038896-15080410620945672', 1, 1, 'SR', NULL, NULL, NULL),
(50196, '2017-10-15 12:13:16', NULL, NULL, 13782, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:13:16', 'admin-1508038896-1508040796749196', 1, 1, 'SR', NULL, NULL, NULL),
(50197, '2017-10-15 12:12:57', NULL, NULL, 13782, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:12:57', 'admin-1508038896-15080407776015819', 1, 0, '', NULL, NULL, NULL),
(50198, '2017-10-15 12:05:40', NULL, NULL, 13781, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:05:40', 'admin-1508038896-1508040340186288', 1, 0, '', NULL, NULL, NULL),
(50199, '2017-10-15 12:05:13', NULL, NULL, 13781, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:05:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50200, '2017-10-15 11:48:16', NULL, NULL, 13779, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:48:16', 'admin-1508038896-15080392961481962', 1, 0, '', NULL, NULL, NULL),
(50201, '2017-10-15 12:12:57', NULL, NULL, 13782, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:12:57', 'admin-1508038896-15080407776015819', 1, 0, '', NULL, NULL, NULL),
(50202, '2017-10-15 12:04:58', NULL, NULL, 13780, 0, 77, '77', 'Sarawak Kolomee', 'Less salty', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:04:58', 'admin-1508038896-15080402977821443', 1, 1, 'SR', NULL, NULL, NULL),
(50203, '2017-10-15 12:04:58', NULL, NULL, 13780, 0, 77, '77', 'Sarawak Kolomee', 'Less salty', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:04:58', 'admin-1508038896-15080402977821443', 1, 1, 'SR', NULL, NULL, NULL),
(50204, '2017-10-15 11:32:13', NULL, NULL, 13760, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:32:13', 'admin-1508034832-15080383335318462', 1, 0, '', NULL, NULL, NULL),
(50205, '2017-10-15 10:25:17', NULL, NULL, 13762, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:25:17', 'admin-1508033215-15080343175292754', 1, 0, '', NULL, NULL, NULL),
(50206, '2017-10-15 10:59:44', NULL, NULL, 13769, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:59:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50207, '2017-10-15 10:59:55', NULL, NULL, 13769, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:59:55', 'admin-1508034832-15080363954725357', 1, 0, '', NULL, NULL, NULL),
(50208, '2017-10-15 10:30:54', NULL, NULL, 13764, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:30:54', 'admin-1508033215-15080346546541115', 1, 0, '', NULL, NULL, NULL),
(50209, '2017-10-15 10:07:34', NULL, NULL, 13757, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:07:34', 'admin-1508033215-15080332540247235', 1, 0, '', NULL, NULL, NULL),
(50210, '2017-10-15 09:47:30', NULL, NULL, 13754, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:47:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50211, '2017-10-15 11:00:02', NULL, NULL, 13769, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:00:02', 'admin-1508034832-15080364027898633', 1, 1, 'SR', NULL, NULL, NULL),
(50212, '2017-10-15 11:00:40', NULL, NULL, 13770, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:00:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50213, '2017-10-15 12:28:41', NULL, NULL, 13784, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:28:41', 'admin-1508038896-15080417211468232', 1, 0, '', NULL, NULL, NULL),
(50214, '2017-10-15 11:46:42', NULL, NULL, 13778, 0, 271, '205', 'Take It Easy', 'don wan salad', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:46:42', 'admin-1508038896-15080392020866581', 1, 0, '', NULL, NULL, NULL),
(50215, '2017-10-15 11:46:17', NULL, NULL, 13778, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:46:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50216, '2017-10-15 11:46:42', NULL, NULL, 13778, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:46:42', 'admin-1508038896-15080392020866581', 1, 0, '', NULL, NULL, NULL),
(50217, '2017-10-15 11:37:43', NULL, NULL, 13776, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:37:43', 'admin-1508034832-15080386633366429', 1, 0, '', NULL, NULL, NULL),
(50218, '2017-10-15 11:24:53', NULL, NULL, 13774, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:24:53', 'admin-1508034832-1508037892996782', 1, 0, '', NULL, NULL, NULL),
(50219, '2017-10-15 11:30:57', NULL, NULL, 13760, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:30:57', 'admin-1508034832-1508038256861598', 1, 1, 'SR', NULL, NULL, NULL),
(50220, '2017-10-15 11:03:39', NULL, NULL, 13771, 0, 156, '90', 'House Cheddar Omelet', 'add 1 toast', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:03:39', 'admin-1508034832-15080366193129147', 1, 0, '', NULL, NULL, NULL),
(50221, '2017-10-15 11:04:05', NULL, NULL, 13771, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:04:05', 'admin-1508034832-15080366449249581', 1, 1, 'SR', NULL, NULL, NULL),
(50222, '2017-10-15 10:04:41', NULL, NULL, 13756, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:04:41', 'admin-1508028344-15080330808865058', 1, 0, '', NULL, NULL, NULL),
(50223, '2017-10-15 11:47:24', NULL, NULL, 13778, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:47:24', 'admin-1508038896-15080392440685029', 1, 1, 'SR', NULL, NULL, NULL),
(50224, '2017-10-15 11:41:52', NULL, NULL, 13777, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:41:52', 'admin-1508038896-15080389123834757', 1, 0, '', NULL, NULL, NULL),
(50225, '2017-10-15 11:37:43', NULL, NULL, 13776, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:37:43', 'admin-1508034832-15080386633366429', 1, 1, 'SR', NULL, NULL, NULL),
(50226, '2017-10-15 11:37:43', NULL, NULL, 13776, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:37:43', 'admin-1508034832-15080386633366429', 1, 0, '', NULL, NULL, NULL),
(50227, '2017-10-15 11:04:05', NULL, NULL, 13771, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:04:05', 'admin-1508034832-15080366449249581', 1, 0, '', NULL, NULL, NULL),
(50228, '2017-10-15 11:05:08', NULL, NULL, 13772, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 5, 8.00, 40.0000, 0.0000, 40.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:05:08', 'admin-1508034832-15080367079566087', 1, 0, '', 1, NULL, NULL),
(50229, '2017-10-15 11:05:08', NULL, NULL, 13772, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:05:08', 'admin-1508034832-15080367079566087', 1, 1, 'SR', 1, NULL, NULL),
(50230, '2017-10-15 10:37:27', NULL, NULL, 13765, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:37:27', 'admin-1508034832-15080350470136421', 1, 0, '', NULL, NULL, '10.0'),
(50231, '2017-10-15 10:25:52', NULL, NULL, 13762, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:25:52', 'admin-1508033215-15080343527197926', 1, 1, 'SR', NULL, NULL, NULL),
(50232, '2017-10-15 15:44:57', NULL, NULL, 13805, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 15:44:57', 'admin-1508052010-15080534970824596', 1, 1, 'SR', NULL, NULL, NULL),
(50233, '2017-10-15 13:27:39', NULL, NULL, 13794, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:27:39', 'admin-1508042465-15080452593967657', 1, 0, '', NULL, NULL, NULL),
(50234, '2017-10-15 11:22:06', NULL, NULL, 13771, 0, 181, '116', 'Open Food ', 'toast', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:22:06', 'admin-1508034832-15080377266396234', 1, 0, '', NULL, NULL, NULL),
(50235, '2017-10-15 11:24:24', NULL, NULL, 13774, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:24:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50236, '2017-10-15 11:24:28', NULL, NULL, 13774, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:24:28', 'admin-1508034832-15080378683705312', 1, 0, '', NULL, NULL, NULL),
(50237, '2017-10-15 11:07:08', NULL, NULL, 13773, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:07:08', 'admin-1508034832-15080368278319760', 1, 1, 'SR', NULL, NULL, NULL),
(50238, '2017-10-15 11:27:56', NULL, NULL, 13775, 0, 182, '117', 'Open Drinks ', 'americano', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:27:56', 'admin-1508034832-15080380766954116', 1, 0, '', 1, NULL, NULL),
(50239, '2017-10-15 11:08:03', NULL, NULL, 13766, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:08:03', 'admin-1508034832-15080368834908451', 1, 1, 'SR', NULL, NULL, NULL),
(50240, '2017-10-15 12:04:58', NULL, NULL, 13780, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:04:58', 'admin-1508038896-15080402977821443', 1, 0, '', NULL, NULL, NULL),
(50241, '2017-10-15 11:06:47', NULL, NULL, 13773, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:06:47', 'admin-1508034832-15080368075265438', 1, 0, '', NULL, NULL, NULL),
(50242, '2017-10-15 11:03:20', NULL, NULL, 13771, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:03:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50243, '2017-10-15 11:00:52', NULL, NULL, 13770, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:00:52', 'admin-1508034832-15080364527243347', 1, 1, 'SR', NULL, NULL, NULL),
(50244, '2017-10-15 10:38:17', NULL, NULL, 13764, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:38:17', 'admin-1508034832-15080350974641230', 1, 1, 'SR', NULL, NULL, NULL),
(50245, '2017-10-15 10:39:03', NULL, NULL, 13766, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:39:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50246, '2017-10-15 10:38:17', NULL, NULL, 13764, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:38:17', 'admin-1508034832-15080350974641230', 1, 1, 'SR', NULL, NULL, NULL),
(50247, '2017-10-15 10:38:17', NULL, NULL, 13764, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:38:17', 'admin-1508034832-15080350974641230', 1, 1, 'SR', NULL, NULL, NULL),
(50248, '2017-10-15 10:37:21', NULL, NULL, 13765, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:37:21', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(50249, '2017-10-15 10:37:27', NULL, NULL, 13765, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:37:27', 'admin-1508034832-15080350470136421', 1, 0, '', NULL, NULL, '10.0'),
(50250, '2017-10-15 10:38:17', NULL, NULL, 13764, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:38:17', 'admin-1508034832-15080350974641230', 1, 0, '', NULL, NULL, NULL),
(50251, '2017-10-15 10:30:24', NULL, NULL, 13764, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:30:24', 'admin-1508033215-15080346238154552', 1, 0, '', NULL, NULL, NULL),
(50252, '2017-10-15 10:30:54', NULL, NULL, 13764, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:30:54', 'admin-1508033215-15080346546541115', 1, 0, '', NULL, NULL, NULL),
(50253, '2017-10-15 10:24:19', NULL, NULL, 13761, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:24:19', 'admin-1508033215-15080342593584515', 1, 1, 'SR', NULL, NULL, NULL),
(50254, '2017-10-15 10:24:19', NULL, NULL, 13761, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:24:19', 'admin-1508033215-15080342593584515', 1, 1, 'SR', NULL, NULL, NULL),
(50255, '2017-10-15 10:25:10', NULL, NULL, 13762, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:25:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50256, '2017-10-15 13:27:39', NULL, NULL, 13794, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:27:39', 'admin-1508042465-15080452593967657', 1, 0, '', NULL, NULL, NULL),
(50257, '2017-10-15 12:28:29', NULL, NULL, 13784, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:28:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50258, '2017-10-15 10:28:20', NULL, NULL, 13763, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:28:20', 'admin-1508033215-15080345000667410', 1, 0, '', NULL, NULL, NULL),
(50259, '2017-10-15 10:30:24', NULL, NULL, 13764, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:30:24', 'admin-1508033215-15080346238154552', 1, 0, '', NULL, NULL, NULL),
(50260, '2017-10-15 10:30:13', NULL, NULL, 13764, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.40, 0.0000, 0.0000, 11.40, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:30:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50261, '2017-10-15 09:52:51', NULL, NULL, 13752, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:52:51', 'admin-1508028344-15080323716162454', 1, 0, '', NULL, NULL, NULL),
(50262, '2017-10-15 10:24:01', NULL, NULL, 13761, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:24:01', 'admin-1508033215-1508034241455792', 1, 0, '', NULL, NULL, NULL),
(50263, '2017-10-15 10:24:01', NULL, NULL, 13761, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:24:01', 'admin-1508033215-1508034241455792', 1, 0, '', NULL, NULL, NULL),
(50264, '2017-10-15 10:24:01', NULL, NULL, 13761, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:24:01', 'admin-1508033215-1508034241455792', 1, 0, '', NULL, NULL, NULL),
(50265, '2017-10-15 10:24:01', NULL, NULL, 13761, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:24:01', 'admin-1508033215-1508034241455792', 1, 0, '', NULL, NULL, NULL),
(50266, '2017-10-15 10:24:19', NULL, NULL, 13761, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:24:19', 'admin-1508033215-15080342593584515', 1, 1, 'SR', NULL, NULL, NULL),
(50267, '2017-10-15 10:14:16', NULL, NULL, 13759, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:14:16', 'admin-1508033215-15080336558438946', 1, 0, '', NULL, NULL, NULL),
(50268, '2017-10-15 13:12:49', NULL, NULL, 13792, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 13:12:49', 'admin-1508042465-15080443695169567', 1, 1, 'SR', NULL, NULL, NULL),
(50269, '2017-10-15 12:45:30', NULL, NULL, 13787, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:45:30', 'admin-1508042465-15080427304463267', 1, 1, 'SR', NULL, NULL, NULL),
(50270, '2017-10-15 11:24:53', NULL, NULL, 13774, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:24:53', 'admin-1508034832-1508037892996782', 1, 1, 'SR', NULL, NULL, NULL),
(50271, '2017-10-15 09:53:28', NULL, NULL, 13755, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:53:28', 'admin-1508028344-15080324081064371', 1, 0, '', NULL, NULL, NULL),
(50272, '2017-10-15 09:31:48', NULL, NULL, 13752, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:31:48', 'admin-1508028344-15080311083238687', 1, 0, '', NULL, NULL, NULL),
(50273, '2017-10-15 09:31:48', NULL, NULL, 13752, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:31:48', 'admin-1508028344-15080311083238687', 1, 1, 'SR', NULL, NULL, NULL),
(50274, '2017-10-15 09:42:37', NULL, NULL, 13753, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:42:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50275, '2017-10-15 09:42:46', NULL, NULL, 13753, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:42:46', 'admin-1508028344-1508031765917478', 1, 0, '', NULL, NULL, NULL),
(50276, '2017-10-15 11:47:58', NULL, NULL, 13779, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 11:47:58', 'admin-1508038896-1508039278625442', 1, 0, '', NULL, NULL, NULL),
(50277, '2017-10-15 10:14:46', NULL, NULL, 13760, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:14:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50278, '2017-10-15 10:14:54', NULL, NULL, 13760, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:14:54', 'admin-1508033215-15080336941585333', 1, 0, '', NULL, NULL, NULL),
(50279, '2017-10-15 10:04:30', NULL, NULL, 13756, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:04:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50280, '2017-10-15 10:24:01', NULL, NULL, 13761, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:24:01', 'admin-1508033215-1508034241455792', 1, 0, '', NULL, NULL, NULL),
(50281, '2017-10-15 10:22:52', NULL, NULL, 13761, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.50, 0.0000, 0.0000, 12.50, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:22:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50282, '2017-10-15 10:14:54', NULL, NULL, 13760, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:14:54', 'admin-1508033215-15080336941585333', 1, 0, '', NULL, NULL, NULL),
(50283, '2017-10-15 10:14:54', NULL, NULL, 13760, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:14:54', 'admin-1508033215-15080336941585333', 1, 1, 'SR', NULL, NULL, NULL),
(50284, '2017-10-15 09:14:30', NULL, NULL, 13749, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:14:30', 'admin-1508028344-15080300702734054', 1, 1, 'SR', NULL, NULL, NULL),
(50285, '2017-10-15 10:14:16', NULL, NULL, 13759, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:14:16', 'admin-1508033215-15080336558438946', 1, 0, '', NULL, NULL, NULL),
(50286, '2017-10-15 10:14:16', NULL, NULL, 13759, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:14:16', 'admin-1508033215-15080336558438946', 1, 0, '', NULL, NULL, NULL),
(50287, '2017-10-15 10:14:16', NULL, NULL, 13759, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:14:16', 'admin-1508033215-15080336558438946', 1, 0, '', NULL, NULL, NULL),
(50288, '2017-10-15 10:14:16', NULL, NULL, 13759, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:14:16', 'admin-1508033215-15080336558438946', 1, 0, '', NULL, NULL, NULL),
(50289, '2017-10-15 10:25:17', NULL, NULL, 13762, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:25:17', 'admin-1508033215-15080343175292754', 1, 0, '', NULL, NULL, NULL),
(50290, '2017-10-15 10:14:27', NULL, NULL, 13759, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:14:27', 'admin-1508033215-15080336672533042', 1, 1, 'SR', NULL, NULL, NULL),
(50291, '2017-10-15 10:07:34', NULL, NULL, 13757, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:07:34', 'admin-1508033215-15080332540247235', 1, 1, 'SR', NULL, NULL, NULL),
(50292, '2017-10-15 10:04:41', NULL, NULL, 13756, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:04:41', 'admin-1508028344-15080330808865058', 1, 0, '', NULL, NULL, NULL),
(50293, '2017-10-15 10:07:12', NULL, NULL, 13757, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:07:12', 'admin-1508033215-15080332323831262', 1, 0, '', NULL, NULL, NULL),
(50294, '2017-10-15 09:53:36', NULL, NULL, 13755, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:53:36', 'admin-1508028344-15080324166156934', 1, 1, 'SR', NULL, NULL, NULL),
(50295, '2017-10-15 09:48:13', NULL, NULL, 13754, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:48:13', 'admin-1508028344-15080320930612594', 1, 0, '', NULL, NULL, NULL),
(50296, '2017-10-15 09:48:13', NULL, NULL, 13754, 0, 38, '38', 'Mixed Berries Smoothie', 'no cream', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:48:13', 'admin-1508028344-15080320930612594', 1, 1, 'SR', NULL, NULL, NULL),
(50297, '2017-10-15 09:53:28', NULL, NULL, 13755, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:53:28', 'admin-1508028344-15080324081064371', 1, 0, '', NULL, NULL, NULL),
(50298, '2017-10-15 09:53:06', NULL, NULL, 13755, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:53:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50299, '2017-10-15 09:53:28', NULL, NULL, 13755, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:53:28', 'admin-1508028344-15080324081064371', 1, 0, '', NULL, NULL, NULL),
(50300, '2017-10-15 09:52:51', NULL, NULL, 13752, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:52:51', 'admin-1508028344-15080323716162454', 1, 0, '', NULL, NULL, NULL),
(50301, '2017-10-15 09:52:51', NULL, NULL, 13752, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:52:51', 'admin-1508028344-15080323716162454', 1, 1, 'SR', NULL, NULL, NULL),
(50302, '2017-10-15 09:52:51', NULL, NULL, 13752, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:52:51', 'admin-1508028344-15080323716162454', 1, 0, '', NULL, NULL, NULL),
(50303, '2017-10-15 09:52:51', NULL, NULL, 13752, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:52:51', 'admin-1508028344-15080323716162454', 1, 0, '', NULL, NULL, NULL),
(50304, '2017-10-15 09:47:38', NULL, NULL, 13754, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:47:38', 'admin-1508028344-15080320585205957', 1, 0, '', NULL, NULL, NULL),
(50305, '2017-10-15 09:47:38', NULL, NULL, 13754, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:47:38', 'admin-1508028344-15080320585205957', 1, 0, '', NULL, NULL, NULL),
(50306, '2017-10-15 12:18:53', NULL, NULL, 13783, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 12:18:53', 'admin-1508038896-15080411336041879', 1, 1, 'SR', NULL, NULL, NULL),
(50307, '2017-10-15 09:14:06', NULL, NULL, 13749, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:14:06', 'admin-1508028344-15080300460684990', 1, 0, '', NULL, NULL, NULL),
(50308, '2017-10-15 09:30:58', NULL, NULL, 13752, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.20, 0.0000, 0.0000, 11.20, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:30:58', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(50309, '2017-10-15 09:31:48', NULL, NULL, 13752, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:31:48', 'admin-1508028344-15080311083238687', 1, 1, 'SR', NULL, NULL, NULL),
(50310, '2017-10-15 09:21:01', NULL, NULL, 13750, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:21:01', 'admin-1508028344-15080304609848729', 1, 0, '', NULL, NULL, NULL),
(50311, '2017-10-15 09:14:30', NULL, NULL, 13749, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:14:30', 'admin-1508028344-15080300702734054', 1, 1, 'SR', NULL, NULL, NULL),
(50312, '2017-10-15 10:13:55', NULL, NULL, 13759, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.70, 0.0000, 0.0000, 9.70, 1, '27', 1, '1508052010', 'admin', '2017-10-15 10:13:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50313, '2017-10-15 09:20:56', NULL, NULL, 13750, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:20:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50314, '2017-10-15 09:14:06', NULL, NULL, 13749, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:14:06', 'admin-1508028344-15080300460684990', 1, 0, '', NULL, NULL, NULL),
(50315, '2017-10-15 09:14:06', NULL, NULL, 13749, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:14:06', 'admin-1508028344-15080300460684990', 1, 0, '', NULL, NULL, NULL),
(50316, '2017-10-15 09:14:06', NULL, NULL, 13749, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:14:06', 'admin-1508028344-15080300460684990', 1, 0, '', NULL, NULL, NULL),
(50317, '2017-10-15 09:13:36', NULL, NULL, 13749, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1508052010', 'admin', '2017-10-15 09:13:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50318, '2017-10-16 12:28:08', NULL, NULL, 13828, 0, 73, '73', 'Marmite Chicken ', 'Pasta', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:28:08', 'admin-1508125905-15081280880081899', 1, 1, 'SR', NULL, NULL, '10.0'),
(50319, '2017-10-16 12:28:23', NULL, NULL, 13828, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:28:23', 'admin-1508125905-15081281033673255', 1, 1, 'SR', NULL, NULL, '10.0'),
(50320, '2017-10-16 12:28:37', NULL, NULL, 13828, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:28:37', 'admin-1508125905-15081281172145378', 1, 1, 'SR', NULL, NULL, '10.0'),
(50321, '2017-10-16 12:33:38', NULL, NULL, 13829, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:33:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50322, '2017-10-16 12:33:49', NULL, NULL, 13829, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:33:49', 'admin-1508125905-15081284289613546', 1, 0, '', NULL, NULL, NULL),
(50323, '2017-10-16 13:08:26', NULL, NULL, 13834, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:08:26', 'admin-1508125905-1508130506061449', 1, 1, 'SR', NULL, NULL, NULL),
(50324, '2017-10-16 13:08:26', NULL, NULL, 13834, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:08:26', 'admin-1508125905-1508130506061449', 1, 1, 'SR', NULL, NULL, NULL),
(50325, '2017-10-16 15:25:52', NULL, NULL, 13844, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 15:25:52', 'admin-1508130625-1508138752272115', 1, 0, '', NULL, NULL, NULL),
(50326, '2017-10-16 13:22:40', NULL, NULL, 13836, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:22:40', 'admin-1508130625-15081313605473566', 1, 0, '', NULL, NULL, NULL),
(50327, '2017-10-16 13:22:40', NULL, NULL, 13836, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:22:40', 'admin-1508130625-15081313605473566', 1, 1, 'SR', NULL, NULL, NULL),
(50328, '2017-10-16 16:18:45', NULL, NULL, 13849, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 16:18:45', 'admin-1508130625-15081419254277529', 1, 1, 'SR', NULL, NULL, NULL),
(50329, '2017-10-16 00:00:00', NULL, NULL, 13843, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 14:27:03', 'admin-1508130625-15081352229673350', 1, 0, '', NULL, NULL, '10.0'),
(50330, '2017-10-16 00:00:00', NULL, NULL, 13843, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 15:23:27', 'admin-1508130625-15081386075706382', 1, 1, 'SR', NULL, NULL, '10.0'),
(50331, '2017-10-16 15:25:40', NULL, NULL, 13844, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 15:25:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50332, '2017-10-16 12:47:08', NULL, NULL, 13830, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:47:08', 'admin-1508125905-15081292286887515', 1, 1, 'SR', NULL, NULL, NULL),
(50333, '2017-10-16 12:47:44', NULL, NULL, 13831, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:47:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50334, '2017-10-16 00:00:00', NULL, NULL, 13847, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:54:37', 'admin-1508130625-1508133277274639', 1, 1, 'SR', NULL, NULL, NULL),
(50335, '2017-10-16 15:58:21', NULL, NULL, 13848, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 15:58:21', 'admin-1508130625-15081407016508119', 1, 1, 'SR', NULL, NULL, NULL),
(50336, '2017-10-16 15:00:09', NULL, NULL, 13841, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 15:00:09', 'admin-1508130625-15081372088426439', 1, 0, '', NULL, NULL, '10.0'),
(50337, '2017-10-16 15:36:44', NULL, NULL, 13845, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1508130625', 'admin', '2017-10-16 15:36:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50338, '2017-10-16 00:00:00', NULL, NULL, 13846, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:54:37', 'admin-1508130625-1508133277274639', 1, 1, 'SR', NULL, NULL, NULL),
(50339, '2017-10-16 13:43:41', NULL, NULL, 13838, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:43:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50340, '2017-10-16 13:44:36', NULL, NULL, 13838, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:44:36', 'admin-1508130625-15081326764796495', 1, 1, 'SR', NULL, NULL, NULL),
(50341, '2017-10-16 12:57:45', NULL, NULL, 13833, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:57:45', 'admin-1508125905-15081298655251759', 1, 1, 'SR', NULL, NULL, '10.0'),
(50342, '2017-10-16 12:57:45', NULL, NULL, 13833, 0, 73, '73', 'Marmite Chicken ', 'add rice', 'Meals', 'Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:57:45', 'admin-1508125905-15081298655251759', 1, 1, 'SR', NULL, NULL, '10.0'),
(50343, '2017-10-16 12:57:45', NULL, NULL, 13833, 0, 192, '127', 'Flaming Hot & Spicy Pork', 'add rice', 'Meals', 'Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:57:45', 'admin-1508125905-15081298655251759', 1, 0, '', NULL, NULL, '10.0'),
(50344, '2017-10-16 13:07:50', NULL, NULL, 13834, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.20, 0.0000, 0.0000, 9.20, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:07:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50345, '2017-10-16 13:08:26', NULL, NULL, 13834, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:08:26', 'admin-1508125905-1508130506061449', 1, 0, '', NULL, NULL, NULL),
(50346, '2017-10-16 11:25:43', NULL, NULL, 13821, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:25:43', 'admin-1508122963-15081243430002261', 1, 0, '', NULL, NULL, NULL),
(50347, '2017-10-16 11:25:43', NULL, NULL, 13821, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:25:43', 'admin-1508122963-15081243430002261', 1, 1, 'SR', NULL, NULL, NULL),
(50348, '2017-10-16 11:28:22', NULL, NULL, 13822, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:28:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50349, '2017-10-16 11:28:26', NULL, NULL, 13822, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:28:26', 'admin-1508122963-1508124506590726', 1, 1, 'SR', NULL, NULL, NULL),
(50350, '2017-10-16 11:40:17', NULL, NULL, 13823, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.70, 0.0000, 0.0000, 13.70, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:40:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50351, '2017-10-16 11:40:25', NULL, NULL, 13823, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:40:25', 'admin-1508122963-15081252257758980', 1, 0, '', NULL, NULL, NULL),
(50352, '2017-10-16 11:40:25', NULL, NULL, 13823, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:40:25', 'admin-1508122963-15081252257758980', 1, 0, '', NULL, NULL, NULL),
(50353, '2017-10-16 11:42:11', NULL, NULL, 13823, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:42:11', 'admin-1508122963-1508125331468829', 1, 1, 'SR', NULL, NULL, NULL),
(50354, '2017-10-16 11:42:11', NULL, NULL, 13823, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:42:11', 'admin-1508122963-1508125331468829', 1, 1, 'SR', NULL, NULL, NULL),
(50355, '2017-10-16 11:42:11', NULL, NULL, 13823, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:42:11', 'admin-1508122963-1508125331468829', 1, 1, 'SR', NULL, NULL, NULL),
(50356, '2017-10-16 11:48:15', NULL, NULL, 13823, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:48:15', 'admin-1508122963-15081256953088129', 1, 1, 'SR', NULL, NULL, NULL),
(50357, '2017-10-16 11:48:15', NULL, NULL, 13823, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:48:15', 'admin-1508122963-15081256953088129', 1, 1, 'SR', NULL, NULL, NULL),
(50358, '2017-10-16 11:48:15', NULL, NULL, 13823, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:48:15', 'admin-1508122963-15081256953088129', 1, 1, 'SR', NULL, NULL, NULL),
(50359, '2017-10-16 11:48:15', NULL, NULL, 13823, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:48:15', 'admin-1508122963-15081256953088129', 1, 0, '', NULL, NULL, NULL),
(50360, '2017-10-16 15:37:00', NULL, NULL, 13846, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1508130625', 'admin', '2017-10-16 15:37:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50361, '2017-10-16 13:55:47', NULL, NULL, 13838, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:55:47', 'admin-1508130625-15081333471564475', 1, 0, '', NULL, NULL, NULL),
(50362, '2017-10-16 13:08:26', NULL, NULL, 13834, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:08:26', 'admin-1508125905-1508130506061449', 1, 1, 'SR', NULL, NULL, NULL),
(50363, '2017-10-16 10:44:11', NULL, NULL, 13816, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 10:44:11', 'admin-1508116368-15081218509742267', 1, 0, '', NULL, NULL, NULL),
(50364, '2017-10-16 10:44:18', NULL, NULL, 13816, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 10:44:18', 'admin-1508116368-1508121858419246', 1, 1, 'SR', NULL, NULL, NULL),
(50365, '2017-10-16 10:44:18', NULL, NULL, 13816, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 10:44:18', 'admin-1508116368-1508121858419246', 1, 1, 'SR', NULL, NULL, NULL),
(50366, '2017-10-16 12:33:49', NULL, NULL, 13829, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:33:49', 'admin-1508125905-15081284289613546', 1, 1, 'SR', NULL, NULL, NULL),
(50367, '2017-10-16 12:33:49', NULL, NULL, 13829, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:33:49', 'admin-1508125905-15081284289613546', 1, 0, '', NULL, NULL, NULL),
(50368, '2017-10-16 12:46:19', NULL, NULL, 13830, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:46:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50369, '2017-10-16 13:44:36', NULL, NULL, 13838, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:44:36', 'admin-1508130625-15081326764796495', 1, 1, 'SR', NULL, NULL, NULL),
(50370, '2017-10-16 13:51:42', NULL, NULL, 13839, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:51:42', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(50371, '2017-10-16 12:48:10', NULL, NULL, 13831, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:48:10', 'admin-1508125905-15081292898599184', 1, 1, 'SR', NULL, NULL, NULL),
(50372, '2017-10-16 12:48:10', NULL, NULL, 13831, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:48:10', 'admin-1508125905-15081292898599184', 1, 0, '', NULL, NULL, NULL),
(50373, '2017-10-16 12:48:10', NULL, NULL, 13831, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:48:10', 'admin-1508125905-15081292898599184', 1, 0, '', NULL, NULL, NULL),
(50374, '2017-10-16 12:49:33', NULL, NULL, 13832, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:49:33', 'admin-1508125905-15081293733836384', 1, 0, '', NULL, NULL, NULL),
(50375, '2017-10-16 16:42:05', NULL, NULL, 13850, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 16:42:05', 'admin-1508130625-15081433251067031', 1, 1, 'SR', NULL, NULL, NULL),
(50376, '2017-10-16 13:44:36', NULL, NULL, 13838, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:44:36', 'admin-1508130625-15081326764796495', 1, 1, 'SR', NULL, NULL, NULL),
(50377, '2017-10-16 13:33:46', NULL, NULL, 13837, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:33:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50378, '2017-10-16 16:09:57', NULL, NULL, 13844, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 16:09:57', 'admin-1508130625-15081413975744943', 1, 1, 'SR', NULL, NULL, NULL),
(50379, '2017-10-16 16:09:57', NULL, NULL, 13844, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 16:09:57', 'admin-1508130625-15081413975744943', 1, 1, 'SR', NULL, NULL, NULL),
(50380, '2017-10-16 16:18:36', NULL, NULL, 13849, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1508130625', 'admin', '2017-10-16 16:18:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50381, '2017-10-16 13:33:58', NULL, NULL, 13837, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:33:58', 'admin-1508130625-1508132038685418', 1, 1, 'SR', NULL, NULL, NULL),
(50382, '2017-10-16 16:18:45', NULL, NULL, 13849, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 16:18:45', 'admin-1508130625-15081419254277529', 1, 1, 'SR', NULL, NULL, NULL),
(50383, '2017-10-16 16:18:45', NULL, NULL, 13849, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 16:18:45', 'admin-1508130625-15081419254277529', 1, 1, 'SR', NULL, NULL, NULL),
(50384, '2017-10-16 16:09:57', NULL, NULL, 13844, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 16:09:57', 'admin-1508130625-15081413975744943', 1, 0, '', NULL, NULL, NULL),
(50385, '2017-10-16 12:33:49', NULL, NULL, 13829, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:33:49', 'admin-1508125905-15081284289613546', 1, 0, '', NULL, NULL, NULL),
(50386, '2017-10-16 12:33:49', NULL, NULL, 13829, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:33:49', 'admin-1508125905-15081284289613546', 1, 0, '', NULL, NULL, NULL),
(50387, '2017-10-16 15:25:59', NULL, NULL, 13844, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 15:25:59', 'admin-1508130625-15081387596692484', 1, 1, 'SR', NULL, NULL, NULL),
(50388, '2017-10-16 15:25:59', NULL, NULL, 13844, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 15:25:59', 'admin-1508130625-15081387596692484', 1, 1, 'SR', NULL, NULL, NULL),
(50389, '2017-10-16 15:58:18', NULL, NULL, 13848, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1508130625', 'admin', '2017-10-16 15:58:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50390, '2017-10-16 15:25:52', NULL, NULL, 13844, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 15:25:52', 'admin-1508130625-1508138752272115', 1, 0, '', NULL, NULL, NULL),
(50391, '2017-10-16 13:31:55', NULL, NULL, 13831, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:31:55', 'admin-1508130625-15081319151919364', 1, 0, '', NULL, NULL, NULL),
(50392, '2017-10-16 13:10:43', NULL, NULL, 13835, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:10:43', 'admin-1508130625-15081306429439827', 1, 1, 'SR', NULL, NULL, NULL),
(50393, '2017-10-16 11:05:27', NULL, NULL, 13818, 0, 156, '90', 'House Cheddar Omelet', 'bacon', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:05:27', 'admin-1508122963-15081231277027352', 1, 0, '', NULL, NULL, NULL),
(50394, '2017-10-16 11:13:29', NULL, NULL, 13820, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:13:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50395, '2017-10-16 11:13:32', NULL, NULL, 13820, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:13:32', 'admin-1508122963-15081236119072688', 1, 1, 'SR', NULL, NULL, NULL),
(50396, '2017-10-16 14:54:08', NULL, NULL, 13842, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 14:54:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50397, '2017-10-16 12:49:33', NULL, NULL, 13832, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:49:33', 'admin-1508125905-15081293733836384', 1, 0, '', NULL, NULL, NULL),
(50398, '2017-10-16 00:00:00', NULL, NULL, 13845, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 14:21:13', 'admin-1508130625-15081348735772274', 1, 0, '', NULL, NULL, NULL),
(50399, '2017-10-16 00:00:00', NULL, NULL, 13843, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 14:27:03', 'admin-1508130625-15081352229673350', 1, 1, 'SR', NULL, NULL, '10.0'),
(50400, '2017-10-16 14:32:53', NULL, NULL, 13833, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 14:32:53', 'admin-1508130625-15081355728286132', 1, 1, 'SR', NULL, NULL, '10.0'),
(50401, '2017-10-16 00:00:00', NULL, NULL, 13845, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:54:37', 'admin-1508130625-1508133277274639', 1, 1, 'SR', NULL, NULL, NULL),
(50402, '2017-10-16 14:26:55', NULL, NULL, 13841, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 14:26:55', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(50403, '2017-10-16 14:05:55', NULL, NULL, 13833, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 14:05:55', 'admin-1508130625-15081339557037331', 1, 0, '', NULL, NULL, '10.0'),
(50404, '2017-10-16 13:22:40', NULL, NULL, 13836, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:22:40', 'admin-1508130625-15081313605473566', 1, 0, '', NULL, NULL, NULL),
(50405, '2017-10-16 13:22:40', NULL, NULL, 13836, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:22:40', 'admin-1508130625-15081313605473566', 1, 0, '', NULL, NULL, NULL),
(50406, '2017-10-16 11:05:27', NULL, NULL, 13818, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:05:27', 'admin-1508122963-15081231277027352', 1, 0, '', NULL, NULL, NULL),
(50407, '2017-10-16 13:58:55', NULL, NULL, 13835, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:58:55', 'admin-1508130625-150813353528347', 1, 1, 'SR', NULL, NULL, NULL),
(50408, '2017-10-16 00:00:00', NULL, NULL, 13847, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, NULL, NULL, 1.20, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:53:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50409, '2017-10-16 13:52:14', NULL, NULL, 13839, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:52:14', 'admin-1508130625-15081331340572016', 1, 0, '', NULL, NULL, '10.0'),
(50410, '2017-10-16 13:52:14', NULL, NULL, 13839, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:52:14', 'admin-1508130625-15081331340572016', 1, 0, '', NULL, NULL, '10.0'),
(50411, '2017-10-16 13:52:14', NULL, NULL, 13839, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:52:14', 'admin-1508130625-15081331340572016', 1, 1, 'SR', NULL, NULL, '10.0'),
(50412, '2017-10-16 13:52:14', NULL, NULL, 13839, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:52:14', 'admin-1508130625-15081331340572016', 1, 1, 'SR', NULL, NULL, '10.0'),
(50413, '2017-10-16 13:10:43', NULL, NULL, 13835, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:10:43', 'admin-1508130625-15081306429439827', 1, 1, 'SR', NULL, NULL, NULL),
(50414, '2017-10-16 13:10:43', NULL, NULL, 13835, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:10:43', 'admin-1508130625-15081306429439827', 1, 1, 'SR', NULL, NULL, NULL),
(50415, '2017-10-16 13:10:20', NULL, NULL, 13835, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:10:20', 'admin-1508125905-15081306207694898', 1, 0, '', NULL, NULL, NULL),
(50416, '2017-10-16 13:44:36', NULL, NULL, 13838, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:44:36', 'admin-1508130625-15081326764796495', 1, 0, '', NULL, NULL, NULL),
(50417, '2017-10-16 13:33:58', NULL, NULL, 13837, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:33:58', 'admin-1508130625-1508132038685418', 1, 1, 'SR', NULL, NULL, NULL),
(50418, '2017-10-16 09:35:55', NULL, NULL, 13812, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 09:35:55', 'admin-1508116368-15081177555043482', 1, 1, 'SR', NULL, NULL, NULL),
(50419, '2017-10-16 09:45:21', NULL, NULL, 13813, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1508130625', 'admin', '2017-10-16 09:45:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50420, '2017-10-16 09:45:30', NULL, NULL, 13813, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 09:45:30', 'admin-1508116368-15081183306612867', 1, 0, '', NULL, NULL, NULL),
(50421, '2017-10-16 09:45:30', NULL, NULL, 13813, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 09:45:30', 'admin-1508116368-15081183306612867', 1, 0, '', NULL, NULL, NULL),
(50422, '2017-10-16 09:45:30', NULL, NULL, 13813, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 09:45:30', 'admin-1508116368-15081183306612867', 1, 1, 'SR', NULL, NULL, NULL),
(50423, '2017-10-16 09:45:30', NULL, NULL, 13813, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 09:45:30', 'admin-1508116368-15081183306612867', 1, 1, 'SR', NULL, NULL, NULL),
(50424, '2017-10-16 13:08:26', NULL, NULL, 13834, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:08:26', 'admin-1508125905-1508130506061449', 1, 0, '', NULL, NULL, NULL),
(50425, '2017-10-16 13:09:53', NULL, NULL, 13835, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:09:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50426, '2017-10-16 13:10:20', NULL, NULL, 13835, 0, 215, '149', 'Thai Fish Sauce Garlic Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:10:20', 'admin-1508125905-15081306207694898', 1, 0, '', NULL, NULL, NULL),
(50427, '2017-10-16 12:21:18', NULL, NULL, 13826, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:21:18', 'admin-1508125905-15081276782478545', 1, 0, '', NULL, NULL, NULL),
(50428, '2017-10-16 16:42:01', NULL, NULL, 13850, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1508130625', 'admin', '2017-10-16 16:42:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50429, '2017-10-16 13:32:47', NULL, NULL, 13829, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:32:47', 'admin-1508130625-15081319670971466', 1, 1, 'SR', NULL, NULL, NULL),
(50430, '2017-10-16 12:21:18', NULL, NULL, 13826, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:21:18', 'admin-1508125905-15081276782478545', 1, 1, 'SR', NULL, NULL, NULL),
(50431, '2017-10-16 12:23:04', NULL, NULL, 13827, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:23:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50432, '2017-10-16 12:23:25', NULL, NULL, 13827, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:23:25', 'admin-1508125905-15081278055675452', 1, 1, 'SR', NULL, NULL, NULL),
(50433, '2017-10-16 12:24:07', NULL, NULL, 13828, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:24:07', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(50434, '2017-10-16 12:28:08', NULL, NULL, 13828, 0, 73, '73', 'Marmite Chicken ', 'Pasta', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:28:08', 'admin-1508125905-15081280880081899', 1, 1, 'SR', NULL, NULL, '10.0'),
(50435, '2017-10-16 11:04:03', NULL, NULL, 13819, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:04:03', 'admin-1508122963-15081230429786650', 1, 1, 'SR', NULL, NULL, NULL),
(50436, '2017-10-16 11:04:03', NULL, NULL, 13819, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:04:03', 'admin-1508122963-15081230429786650', 1, 1, 'SR', NULL, NULL, NULL),
(50437, '2017-10-16 13:22:24', NULL, NULL, 13836, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:22:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50438, '2017-10-16 14:54:13', NULL, NULL, 13842, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 14:54:13', 'admin-1508130625-15081368530602687', 1, 1, 'SR', NULL, NULL, NULL),
(50439, '2017-10-16 13:10:20', NULL, NULL, 13835, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:10:20', 'admin-1508125905-15081306207694898', 1, 0, '', NULL, NULL, NULL),
(50440, '2017-10-16 12:57:45', NULL, NULL, 13833, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:57:45', 'admin-1508125905-15081298655251759', 1, 0, '', NULL, NULL, '10.0'),
(50441, '2017-10-16 15:24:05', NULL, NULL, 13843, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 15:24:05', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(50442, '2017-10-16 11:48:15', NULL, NULL, 13823, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:48:15', 'admin-1508122963-15081256953088129', 1, 0, '', NULL, NULL, NULL),
(50443, '2017-10-16 11:50:42', NULL, NULL, 13824, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:50:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50444, '2017-10-16 11:50:54', NULL, NULL, 13824, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:50:54', 'admin-1508122963-15081258542817816', 1, 0, '', NULL, NULL, NULL),
(50445, '2017-10-16 13:08:26', NULL, NULL, 13834, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:08:26', 'admin-1508125905-1508130506061449', 1, 1, 'SR', NULL, NULL, NULL),
(50446, '2017-10-16 12:57:45', NULL, NULL, 13833, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:57:45', 'admin-1508125905-15081298655251759', 1, 0, '', NULL, NULL, '10.0'),
(50447, '2017-10-16 12:57:14', NULL, NULL, 13833, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:57:14', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(50448, '2017-10-16 12:09:08', NULL, NULL, 13825, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:09:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50449, '2017-10-16 12:09:14', NULL, NULL, 13825, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:09:14', 'admin-1508125905-15081269542855366', 1, 1, 'SR', NULL, NULL, NULL),
(50450, '2017-10-16 12:09:14', NULL, NULL, 13825, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:09:14', 'admin-1508125905-15081269542855366', 1, 0, '', NULL, NULL, NULL),
(50451, '2017-10-16 12:17:22', NULL, NULL, 13820, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:17:22', 'admin-1508125905-1508127442505947', 1, 0, '', NULL, NULL, NULL),
(50452, '2017-10-16 12:21:12', NULL, NULL, 13826, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:21:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50453, '2017-10-16 12:49:39', NULL, NULL, 13832, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:49:39', 'admin-1508125905-15081293793903053', 1, 0, '', NULL, NULL, NULL),
(50454, '2017-10-16 12:49:25', NULL, NULL, 13832, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:49:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50455, '2017-10-16 10:23:36', NULL, NULL, 13815, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 10:23:36', 'admin-1508116368-15081206166328843', 1, 0, '', NULL, NULL, NULL),
(50456, '2017-10-16 10:23:36', NULL, NULL, 13815, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 10:23:36', 'admin-1508116368-15081206166328843', 1, 0, '', NULL, NULL, NULL),
(50457, '2017-10-16 10:23:52', NULL, NULL, 13815, 0, 181, '116', 'Open Food ', '1 WMU with welldone york', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 10:23:52', 'admin-1508116368-15081206327229387', 1, 0, '', NULL, NULL, NULL),
(50458, '2017-10-16 11:25:34', NULL, NULL, 13821, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:25:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50459, '2017-10-16 11:25:43', NULL, NULL, 13821, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:25:43', 'admin-1508122963-15081243430002261', 1, 0, '', NULL, NULL, NULL),
(50460, '2017-10-16 11:51:37', NULL, NULL, 13824, 0, 181, '116', 'Open Food ', 'WMU sunny side up', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:51:37', 'admin-1508122963-15081258974678623', 1, 0, '', NULL, NULL, NULL),
(50461, '2017-10-16 11:51:20', NULL, NULL, 13824, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:51:20', 'admin-1508122963-15081258806227750', 1, 1, 'SR', NULL, NULL, NULL),
(50462, '2017-10-16 11:50:54', NULL, NULL, 13824, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:50:54', 'admin-1508122963-15081258542817816', 1, 1, 'SR', NULL, NULL, NULL),
(50463, '2017-10-16 11:50:54', NULL, NULL, 13824, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:50:54', 'admin-1508122963-15081258542817816', 1, 0, '', NULL, NULL, NULL),
(50464, '2017-10-16 10:02:45', NULL, NULL, 13814, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1508130625', 'admin', '2017-10-16 10:02:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50465, '2017-10-16 10:02:48', NULL, NULL, 13814, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 10:02:48', 'admin-1508116368-15081193687122779', 1, 0, '', NULL, NULL, NULL),
(50466, '2017-10-16 10:06:07', NULL, NULL, 13814, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 10:06:07', 'admin-1508116368-15081195671001285', 1, 0, '', NULL, NULL, NULL),
(50467, '2017-10-16 10:23:26', NULL, NULL, 13815, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1508130625', 'admin', '2017-10-16 10:23:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50468, '2017-10-16 11:50:54', NULL, NULL, 13824, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:50:54', 'admin-1508122963-15081258542817816', 1, 0, '', NULL, NULL, NULL),
(50469, '2017-10-16 11:25:43', NULL, NULL, 13821, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:25:43', 'admin-1508122963-15081243430002261', 1, 0, '', NULL, NULL, NULL),
(50470, '2017-10-16 11:04:03', NULL, NULL, 13819, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:04:03', 'admin-1508122963-15081230429786650', 1, 1, 'SR', NULL, NULL, NULL),
(50471, '2017-10-16 11:04:03', NULL, NULL, 13819, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:04:03', 'admin-1508122963-15081230429786650', 1, 1, 'SR', NULL, NULL, NULL),
(50472, '2017-10-16 12:47:08', NULL, NULL, 13830, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 12:47:08', 'admin-1508125905-15081292286887515', 1, 1, 'SR', NULL, NULL, NULL),
(50473, '2017-10-16 11:04:03', NULL, NULL, 13819, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:04:03', 'admin-1508122963-15081230429786650', 1, 0, '', NULL, NULL, NULL),
(50474, '2017-10-16 10:59:47', NULL, NULL, 13814, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 10:59:47', 'admin-1508116368-15081227872383963', 1, 1, 'SR', NULL, NULL, NULL),
(50475, '2017-10-16 10:59:50', NULL, NULL, 13818, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 10:59:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50476, '2017-10-16 10:59:58', NULL, NULL, 13818, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 10:59:58', 'admin-1508116368-15081227986737958', 1, 1, 'SR', NULL, NULL, NULL),
(50477, '2017-10-16 10:59:58', NULL, NULL, 13818, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 10:59:58', 'admin-1508116368-15081227986737958', 1, 1, 'SR', NULL, NULL, NULL),
(50478, '2017-10-16 10:59:58', NULL, NULL, 13818, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 10:59:58', 'admin-1508116368-15081227986737958', 1, 1, 'SR', NULL, NULL, NULL),
(50479, '2017-10-16 11:03:28', NULL, NULL, 13819, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.70, 0.0000, 0.0000, 16.70, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:03:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50480, '2017-10-16 11:03:47', NULL, NULL, 13819, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:03:47', 'admin-1508122963-15081230271351674', 1, 0, '', NULL, NULL, NULL),
(50481, '2017-10-16 11:03:47', NULL, NULL, 13819, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:03:47', 'admin-1508122963-15081230271351674', 1, 0, '', NULL, NULL, NULL),
(50482, '2017-10-16 11:03:47', NULL, NULL, 13819, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:03:47', 'admin-1508122963-15081230271351674', 1, 0, '', NULL, NULL, NULL),
(50483, '2017-10-16 11:03:47', NULL, NULL, 13819, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:03:47', 'admin-1508122963-15081230271351674', 1, 0, '', NULL, NULL, NULL),
(50484, '2017-10-16 11:03:47', NULL, NULL, 13819, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:03:47', 'admin-1508122963-15081230271351674', 1, 0, '', NULL, NULL, NULL),
(50485, '2017-10-16 11:03:47', NULL, NULL, 13819, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:03:47', 'admin-1508122963-15081230271351674', 1, 0, '', NULL, NULL, NULL),
(50486, '2017-10-16 10:44:54', NULL, NULL, 13817, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 10:44:54', 'admin-1508116368-15081218940089039', 1, 1, 'SR', 1, NULL, '10.0'),
(50487, '2017-10-16 09:27:44', NULL, NULL, 13811, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 09:27:44', 'admin-1508116368-15081172645986180', 1, 0, '', NULL, NULL, NULL),
(50488, '2017-10-16 13:44:36', NULL, NULL, 13838, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 13:44:36', 'admin-1508130625-15081326764796495', 1, 1, 'SR', NULL, NULL, NULL),
(50489, '2017-10-16 11:04:03', NULL, NULL, 13819, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 11:04:03', 'admin-1508122963-15081230429786650', 1, 1, 'SR', NULL, NULL, NULL),
(50490, '2017-10-16 10:44:11', NULL, NULL, 13816, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 10:44:11', 'admin-1508116368-15081218509742267', 1, 0, '', NULL, NULL, NULL),
(50491, '2017-10-16 10:44:03', NULL, NULL, 13816, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1508130625', 'admin', '2017-10-16 10:44:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50492, '2017-10-16 10:23:36', NULL, NULL, 13815, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 10:23:36', 'admin-1508116368-15081206166328843', 1, 0, '', NULL, NULL, NULL),
(50493, '2017-10-16 09:35:50', NULL, NULL, 13812, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 09:35:50', 'admin-1508116368-1508117750356225', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(50494, '2017-10-16 10:23:36', NULL, NULL, 13815, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 10:23:36', 'admin-1508116368-15081206166328843', 1, 0, '', NULL, NULL, NULL),
(50495, '2017-10-16 09:35:55', NULL, NULL, 13812, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 09:35:55', 'admin-1508116368-15081177555043482', 1, 1, 'SR', NULL, NULL, NULL),
(50496, '2017-10-16 09:35:50', NULL, NULL, 13812, 0, 270, '204', 'Homemade Savoury Pancake', 'no bacon', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 09:35:50', 'admin-1508116368-1508117750356225', 1, 0, '', NULL, NULL, NULL),
(50497, '2017-10-16 09:35:39', NULL, NULL, 13812, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1508130625', 'admin', '2017-10-16 09:35:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50498, '2017-10-16 09:27:51', NULL, NULL, 13811, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508130625', 'admin', '2017-10-16 09:27:51', 'admin-1508116368-15081172715696023', 1, 1, 'SR', NULL, NULL, NULL),
(50499, '2017-10-16 09:27:24', NULL, NULL, 13811, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1508130625', 'admin', '2017-10-16 09:27:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50500, '2017-10-18 12:57:11', NULL, NULL, 13881, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:57:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50501, '2017-10-18 00:00:00', NULL, NULL, 13882, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:21:42', 'admin-1508297123-15083005023396971', 1, 1, 'SR', NULL, NULL, NULL),
(50502, '2017-10-18 00:00:00', NULL, NULL, 13881, 0, 153, '87', 'Wake Me Up!', ' no sausage,no bacon', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:02:51', 'admin-1508297123-15082993711397431', 1, 0, '', NULL, NULL, NULL),
(50503, '2017-10-18 12:58:39', NULL, NULL, 13882, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:58:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50504, '2017-10-18 00:00:00', NULL, NULL, 13881, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:03:30', 'admin-1508297123-1508299410445841', 1, 0, '', NULL, NULL, NULL),
(50505, '2017-10-18 17:14:05', NULL, NULL, 13905, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1508315138', 'admin', '2017-10-18 17:14:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50506, '2017-10-18 17:14:08', NULL, NULL, 13905, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 17:14:08', 'admin-1508315138-15083180484084850', 1, 0, '', NULL, NULL, NULL),
(50507, '2017-10-18 11:44:49', NULL, NULL, 13870, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.30, 0.0000, 0.0000, 13.30, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:44:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50508, '2017-10-18 11:00:08', NULL, NULL, 13865, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:00:08', 'admin-1508292997-15082956083525850', 1, 0, '', NULL, NULL, NULL),
(50509, '2017-10-18 11:00:08', NULL, NULL, 13865, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:00:08', 'admin-1508292997-15082956083525850', 1, 0, '', NULL, NULL, NULL),
(50510, '2017-10-18 11:00:25', NULL, NULL, 13865, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:00:25', 'admin-1508292997-15082956258002638', 1, 1, 'SR', NULL, NULL, NULL),
(50511, '2017-10-18 11:00:25', NULL, NULL, 13865, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:00:25', 'admin-1508292997-15082956258002638', 1, 1, 'SR', NULL, NULL, NULL),
(50512, '2017-10-18 14:08:35', NULL, NULL, 13893, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:08:35', 'admin-1508305602-15083069154116266', 1, 0, '', NULL, NULL, NULL),
(50513, '2017-10-18 14:08:35', NULL, NULL, 13893, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:08:35', 'admin-1508305602-15083069154116266', 1, 0, '', NULL, NULL, NULL),
(50514, '2017-10-18 14:07:55', NULL, NULL, 13893, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:07:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50515, '2017-10-18 00:00:00', NULL, NULL, 13887, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:13:47', 'admin-1508297123-15083000271916518', 1, 1, 'SR', NULL, NULL, NULL),
(50516, '2017-10-18 00:00:00', NULL, NULL, 13881, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:04:21', 'admin-1508297123-15082994608671542', 1, 1, 'SR', NULL, NULL, NULL),
(50517, '2017-10-18 16:37:08', NULL, NULL, 13902, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1508315138', 'admin', '2017-10-18 16:37:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50518, '2017-10-18 14:45:27', NULL, NULL, 13895, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:45:27', 'admin-1508308195-15083091272919366', 1, 0, '', NULL, NULL, NULL),
(50519, '2017-10-18 13:55:27', NULL, NULL, 13891, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:55:27', 'admin-1508305602-15083061276827881', 1, 1, 'SR', NULL, NULL, NULL),
(50520, '2017-10-18 13:50:55', NULL, NULL, 13890, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:50:55', 'admin-1508305602-15083058549671299', 1, 1, 'SR', NULL, NULL, NULL),
(50521, '2017-10-18 11:45:19', NULL, NULL, 13870, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:45:19', 'admin-1508297123-15082983193208069', 1, 0, '', NULL, NULL, NULL),
(50522, '2017-10-18 11:45:45', NULL, NULL, 13870, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:45:45', 'admin-1508297123-15082983448091153', 1, 1, 'SR', NULL, NULL, NULL),
(50523, '2017-10-18 11:45:45', NULL, NULL, 13870, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:45:45', 'admin-1508297123-15082983448091153', 1, 1, 'SR', NULL, NULL, NULL),
(50524, '2017-10-18 16:37:11', NULL, NULL, 13902, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 16:37:11', 'admin-1508315138-15083158316603416', 1, 1, 'SR', NULL, NULL, NULL),
(50525, '2017-10-18 15:21:58', NULL, NULL, 13897, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1508315138', 'admin', '2017-10-18 15:21:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50526, '2017-10-18 15:22:11', NULL, NULL, 13897, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 15:22:11', 'admin-1508308195-1508311331119646', 1, 0, '', NULL, NULL, NULL),
(50527, '2017-10-18 15:22:11', NULL, NULL, 13897, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 15:22:11', 'admin-1508308195-1508311331119646', 1, 0, '', NULL, NULL, NULL),
(50528, '2017-10-18 15:22:29', NULL, NULL, 13897, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 15:22:29', 'admin-1508308195-15083113489459242', 1, 1, 'SR', NULL, NULL, NULL),
(50529, '2017-10-18 15:22:29', NULL, NULL, 13897, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 15:22:29', 'admin-1508308195-15083113489459242', 1, 1, 'SR', NULL, NULL, NULL),
(50530, '2017-10-18 15:22:45', NULL, NULL, 13896, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 15:22:45', 'admin-1508308195-15083113652063132', 1, 0, '', NULL, NULL, NULL),
(50531, '2017-10-18 14:12:30', NULL, NULL, 13894, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:12:30', 'admin-1508305602-15083071506955864', 1, 1, 'SR', NULL, NULL, NULL),
(50532, '2017-10-18 14:12:30', NULL, NULL, 13894, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:12:30', 'admin-1508305602-15083071506955864', 1, 1, 'SR', NULL, NULL, NULL),
(50533, '2017-10-18 14:12:30', NULL, NULL, 13894, 0, 160, '94', 'Signature Dumpling (5 Pcs)', 'Takeaway,more sauce', 'Meals', 'Snacks ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:12:30', 'admin-1508305602-15083071506955864', 1, 0, '', NULL, NULL, NULL),
(50534, '2017-10-18 14:12:44', NULL, NULL, 13894, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:12:44', 'admin-1508305602-15083071640216891', 1, 0, '', NULL, NULL, NULL),
(50535, '2017-10-18 14:12:44', NULL, NULL, 13894, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:12:44', 'admin-1508305602-15083071640216891', 1, 1, 'SR', NULL, NULL, NULL),
(50536, '2017-10-18 13:50:48', NULL, NULL, 13890, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:50:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50537, '2017-10-18 14:02:19', NULL, NULL, 13892, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:02:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50538, '2017-10-18 14:03:13', NULL, NULL, 13892, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:03:13', 'admin-1508305602-1508306593481325', 1, 0, '', NULL, NULL, NULL),
(50539, '2017-10-18 15:37:09', NULL, NULL, 13898, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1508315138', 'admin', '2017-10-18 15:37:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50540, '2017-10-18 16:03:49', NULL, NULL, 13901, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1508315138', 'admin', '2017-10-18 16:03:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50541, '2017-10-18 16:03:54', NULL, NULL, 13901, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 16:03:54', 'admin-1508308195-15083138346146086', 1, 0, '', NULL, NULL, NULL),
(50542, '2017-10-18 14:06:51', NULL, NULL, 13892, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:06:51', 'admin-1508305602-15083068116946929', 1, 0, '', NULL, NULL, NULL),
(50543, '2017-10-18 14:07:31', NULL, NULL, 13892, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:07:31', 'admin-1508305602-15083068516509955', 1, 1, 'SR', NULL, NULL, NULL),
(50544, '2017-10-18 16:15:05', NULL, NULL, 13900, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 16:15:05', 'admin-1508308195-15083145051757953', 1, 0, '', NULL, NULL, NULL),
(50545, '2017-10-18 14:34:05', NULL, NULL, 13891, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:34:05', 'admin-1508308195-15083084455348531', 1, 1, 'SR', NULL, NULL, NULL),
(50546, '2017-10-18 14:00:20', NULL, NULL, 13889, 0, 70, '70', 'Borneo Pepper Pork', 'Takeaway', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:00:20', 'admin-1508305602-15083064207305959', 1, 1, 'SR', NULL, NULL, NULL),
(50547, '2017-10-18 13:38:21', NULL, NULL, 13889, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:38:21', 'admin-1508300693-15083051016598033', 1, 1, 'SR', NULL, NULL, NULL),
(50548, '2017-10-18 16:50:10', NULL, NULL, 13904, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 16:50:10', 'admin-1508315138-15083166102045078', 1, 1, 'SR', NULL, NULL, NULL),
(50549, '2017-10-18 16:50:05', NULL, NULL, 13904, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1508315138', 'admin', '2017-10-18 16:50:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50550, '2017-10-18 16:49:53', NULL, NULL, 13903, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 16:49:53', 'admin-1508315138-15083165929269922', 1, 1, 'SR', 1, NULL, NULL),
(50551, '2017-10-18 14:08:35', NULL, NULL, 13893, 0, 222, '156', 'Seasoned Chicken Aglio Olio', 'no chili', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:08:35', 'admin-1508305602-15083069154116266', 1, 0, '', NULL, NULL, NULL),
(50552, '2017-10-18 16:04:19', NULL, NULL, 13901, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 16:04:19', 'admin-1508308195-15083138597752887', 1, 1, 'SR', NULL, NULL, NULL),
(50553, '2017-10-18 16:04:19', NULL, NULL, 13901, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 16:04:19', 'admin-1508308195-15083138597752887', 1, 1, 'SR', NULL, NULL, NULL),
(50554, '2017-10-18 16:04:19', NULL, NULL, 13901, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 16:04:19', 'admin-1508308195-15083138597752887', 1, 1, 'SR', NULL, NULL, NULL),
(50555, '2017-10-18 16:04:19', NULL, NULL, 13901, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 16:04:19', 'admin-1508308195-15083138597752887', 1, 0, '', NULL, NULL, NULL),
(50556, '2017-10-18 13:19:49', NULL, NULL, 13875, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:19:49', 'admin-1508300693-15083039891449388', 1, 1, 'SR', NULL, NULL, NULL),
(50557, '2017-10-18 13:19:49', NULL, NULL, 13875, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:19:49', 'admin-1508300693-15083039891449388', 1, 1, 'SR', NULL, NULL, NULL),
(50558, '2017-10-18 13:23:26', NULL, NULL, 13888, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:23:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50559, '2017-10-18 13:24:13', NULL, NULL, 13888, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:24:13', 'admin-1508300693-15083042530655063', 1, 1, 'SR', NULL, NULL, NULL),
(50560, '2017-10-18 14:03:13', NULL, NULL, 13892, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:03:13', 'admin-1508305602-1508306593481325', 1, 0, '', NULL, NULL, NULL),
(50561, '2017-10-18 11:29:01', NULL, NULL, 13869, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:29:01', 'admin-1508297123-15082973408448064', 1, 0, '', NULL, NULL, NULL),
(50562, '2017-10-18 11:29:01', NULL, NULL, 13869, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:29:01', 'admin-1508297123-15082973408448064', 1, 0, '', NULL, NULL, NULL),
(50563, '2017-10-18 11:29:12', NULL, NULL, 13869, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:29:12', 'admin-1508297123-1508297352063213', 1, 1, 'SR', NULL, NULL, NULL),
(50564, '2017-10-18 11:29:12', NULL, NULL, 13869, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:29:12', 'admin-1508297123-1508297352063213', 1, 1, 'SR', NULL, NULL, NULL),
(50565, '2017-10-18 11:09:59', NULL, NULL, 13867, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:09:59', 'admin-1508292997-15082961998267280', 1, 1, 'SR', NULL, NULL, NULL),
(50566, '2017-10-18 11:10:05', NULL, NULL, 13868, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:10:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50567, '2017-10-18 15:39:43', NULL, NULL, 13899, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 15:39:43', 'admin-1508308195-15083123832935062', 1, 0, '', NULL, NULL, NULL),
(50568, '2017-10-18 15:39:43', NULL, NULL, 13899, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 15:39:43', 'admin-1508308195-15083123832935062', 1, 0, '', NULL, NULL, NULL),
(50569, '2017-10-18 15:39:55', NULL, NULL, 13899, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 15:39:55', 'admin-1508308195-15083123957595760', 1, 1, 'SR', NULL, NULL, NULL),
(50570, '2017-10-18 15:39:55', NULL, NULL, 13899, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 15:39:55', 'admin-1508308195-15083123957595760', 1, 1, 'SR', NULL, NULL, NULL),
(50571, '2017-10-18 16:02:09', NULL, NULL, 13900, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1508315138', 'admin', '2017-10-18 16:02:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50572, '2017-10-18 16:02:15', NULL, NULL, 13900, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 16:02:15', 'admin-1508308195-15083137349493542', 1, 1, 'SR', NULL, NULL, NULL),
(50573, '2017-10-18 15:39:30', NULL, NULL, 13899, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1508315138', 'admin', '2017-10-18 15:39:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50574, '2017-10-18 14:26:26', NULL, NULL, 13895, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:26:26', 'admin-1508305602-1508307985795819', 1, 1, 'SR', NULL, NULL, NULL),
(50575, '2017-10-18 14:26:26', NULL, NULL, 13895, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:26:26', 'admin-1508305602-1508307985795819', 1, 1, 'SR', NULL, NULL, NULL),
(50576, '2017-10-18 15:37:46', NULL, NULL, 13898, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 15:37:46', 'admin-1508308195-15083122662924990', 1, 1, 'SR', NULL, NULL, NULL),
(50577, '2017-10-18 15:37:46', NULL, NULL, 13898, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 15:37:46', 'admin-1508308195-15083122662924990', 1, 1, 'SR', NULL, NULL, NULL),
(50578, '2017-10-18 14:12:30', NULL, NULL, 13894, 0, 160, '94', 'Signature Dumpling (5 Pcs)', 'more sauce', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:12:30', 'admin-1508305602-15083071506955864', 1, 0, '', NULL, NULL, NULL),
(50579, '2017-10-18 15:20:49', NULL, NULL, 13896, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1508315138', 'admin', '2017-10-18 15:20:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50580, '2017-10-18 15:37:46', NULL, NULL, 13898, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 15:37:46', 'admin-1508308195-15083122662924990', 1, 0, '', NULL, NULL, NULL),
(50581, '2017-10-18 15:37:28', NULL, NULL, 13898, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 15:37:28', 'admin-1508308195-15083122484793028', 1, 1, 'SR', NULL, NULL, NULL),
(50582, '2017-10-18 11:25:18', NULL, NULL, 13862, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:25:18', 'admin-1508292997-1508297118178197', 1, 0, '', NULL, NULL, NULL),
(50583, '2017-10-18 11:28:49', NULL, NULL, 13869, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:28:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50584, '2017-10-18 10:46:27', NULL, NULL, 13861, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:46:27', 'admin-1508292997-15082947869193818', 1, 1, 'SR', NULL, NULL, NULL),
(50585, '2017-10-18 10:49:07', NULL, NULL, 13860, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:49:07', 'admin-1508292997-15082949468207472', 1, 1, 'SR', NULL, NULL, NULL),
(50586, '2017-10-18 10:50:32', NULL, NULL, 13862, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:50:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50587, '2017-10-18 10:50:49', NULL, NULL, 13862, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:50:49', 'admin-1508292997-15082950495736228', 1, 1, 'SR', NULL, NULL, NULL),
(50588, '2017-10-18 10:50:49', NULL, NULL, 13862, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:50:49', 'admin-1508292997-15082950495736228', 1, 1, 'SR', NULL, NULL, NULL),
(50589, '2017-10-18 10:50:49', NULL, NULL, 13862, 0, 75, '75', 'Meatless Aglio Olio ', 'extra spicy', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:50:49', 'admin-1508292997-15082950495736228', 1, 0, '', NULL, NULL, NULL),
(50590, '2017-10-18 00:00:00', NULL, NULL, 13863, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:28:07', 'admin-1508287842-1508290087266349', 1, 1, 'SR', NULL, NULL, NULL),
(50591, '2017-10-18 00:00:00', NULL, NULL, 13864, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:28:07', 'admin-1508287842-1508290087266349', 1, 1, 'SR', NULL, NULL, NULL),
(50592, '2017-10-18 10:16:23', NULL, NULL, 13858, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:16:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50593, '2017-10-18 10:16:28', NULL, NULL, 13858, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:16:28', 'admin-1508287842-15082929883096947', 1, 0, '', NULL, NULL, NULL),
(50594, '2017-10-18 10:16:51', NULL, NULL, 13858, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:16:51', 'admin-1508292997-15082930117736629', 1, 1, 'SR', NULL, NULL, NULL),
(50595, '2017-10-18 10:16:59', NULL, NULL, 13858, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:16:59', 'admin-1508292997-15082930194383465', 1, 1, 'SR', NULL, NULL, NULL),
(50596, '2017-10-18 16:25:32', NULL, NULL, 13901, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 16:25:32', 'admin-1508308195-15083151324135442', 1, 0, '', NULL, NULL, NULL),
(50597, '2017-10-18 13:38:21', NULL, NULL, 13889, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:38:21', 'admin-1508300693-15083051016598033', 1, 1, 'SR', NULL, NULL, NULL),
(50598, '2017-10-18 13:37:57', NULL, NULL, 13889, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:37:57', 'admin-1508300693-15083050774447330', 1, 0, '', NULL, NULL, NULL),
(50599, '2017-10-18 00:00:00', NULL, NULL, 13883, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:02:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50600, '2017-10-18 15:20:57', NULL, NULL, 13896, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 15:20:57', 'admin-1508308195-15083112575813867', 1, 1, 'SR', NULL, NULL, NULL),
(50601, '2017-10-18 15:20:57', NULL, NULL, 13896, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 15:20:57', 'admin-1508308195-15083112575813867', 1, 1, 'SR', NULL, NULL, NULL),
(50602, '2017-10-18 14:23:29', NULL, NULL, 13895, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:23:29', 'admin-1508305602-15083078095893823', 1, 0, '', NULL, NULL, NULL),
(50603, '2017-10-18 14:45:27', NULL, NULL, 13895, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:45:27', 'admin-1508308195-15083091272919366', 1, 1, 'SR', NULL, NULL, NULL),
(50604, '2017-10-18 14:46:07', NULL, NULL, 13893, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:46:07', 'admin-1508308195-1508309167468973', 1, 0, '', NULL, NULL, NULL),
(50605, '2017-10-18 14:26:26', NULL, NULL, 13895, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:26:26', 'admin-1508305602-1508307985795819', 1, 0, '', NULL, NULL, NULL),
(50606, '2017-10-18 13:37:57', NULL, NULL, 13889, 0, 77, '77', 'Sarawak Kolomee', 'no meat', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:37:57', 'admin-1508300693-15083050774447330', 1, 1, 'SR', NULL, NULL, NULL),
(50607, '2017-10-18 09:32:46', NULL, NULL, 13853, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:32:46', 'admin-1508287842-15082903659243867', 1, 0, '', NULL, NULL, NULL),
(50608, '2017-10-18 09:36:04', NULL, NULL, 13854, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:36:04', 'admin-1508287842-15082905645286078', 1, 0, '', NULL, NULL, NULL),
(50609, '2017-10-18 14:23:29', NULL, NULL, 13895, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:23:29', 'admin-1508305602-15083078095893823', 1, 1, 'SR', NULL, NULL, NULL),
(50610, '2017-10-18 13:06:29', NULL, NULL, 13885, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:06:29', 'admin-1508300693-15083031896337087', 1, 0, '', NULL, NULL, NULL),
(50611, '2017-10-18 13:06:50', NULL, NULL, 13885, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:06:50', 'admin-1508300693-15083032099918296', 1, 0, '', NULL, NULL, NULL),
(50612, '2017-10-18 11:10:15', NULL, NULL, 13868, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:10:15', 'admin-1508292997-1508296215375371', 1, 1, 'SR', NULL, NULL, NULL),
(50613, '2017-10-18 14:23:29', NULL, NULL, 13895, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:23:29', 'admin-1508305602-15083078095893823', 1, 1, 'SR', NULL, NULL, NULL),
(50614, '2017-10-18 15:07:20', NULL, NULL, 13895, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 15:07:20', 'admin-1508308195-15083104399004084', 1, 1, 'SR', NULL, NULL, NULL),
(50615, '2017-10-18 13:36:09', NULL, NULL, 13880, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:36:10', 'admin-1508300693-15083049698274982', 1, 1, 'SR', NULL, NULL, NULL),
(50616, '2017-10-18 13:37:35', NULL, NULL, 13889, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:37:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50617, '2017-10-18 13:37:57', NULL, NULL, 13889, 0, 77, '77', 'Sarawak Kolomee', 'no meat', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:37:57', 'admin-1508300693-15083050774447330', 1, 1, 'SR', NULL, NULL, NULL),
(50618, '2017-10-18 13:09:57', NULL, NULL, 13887, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:09:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50619, '2017-10-18 13:33:35', NULL, NULL, 13880, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:33:35', 'admin-1508300693-15083048152101647', 1, 1, 'SR', NULL, NULL, NULL),
(50620, '2017-10-18 13:33:35', NULL, NULL, 13880, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:33:35', 'admin-1508300693-15083048152101647', 1, 0, '', NULL, NULL, NULL),
(50621, '2017-10-18 13:01:08', NULL, NULL, 13884, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:01:08', 'admin-1508300693-15083028684227843', 1, 1, 'SR', 1, NULL, NULL),
(50622, '2017-10-18 13:01:43', NULL, NULL, 13876, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:01:43', 'admin-1508300693-15083029037693998', 1, 1, 'SR', NULL, NULL, NULL),
(50623, '2017-10-18 12:15:37', NULL, NULL, 13876, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:15:37', 'admin-1508297123-15083001371848975', 1, 1, 'SR', NULL, NULL, NULL),
(50624, '2017-10-18 00:00:00', NULL, NULL, 13887, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:13:47', 'admin-1508297123-15083000271916518', 1, 0, '', NULL, NULL, NULL),
(50625, '2017-10-18 00:00:00', NULL, NULL, 13886, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:13:47', 'admin-1508297123-15083000271916518', 1, 0, '', NULL, NULL, NULL),
(50626, '2017-10-18 00:00:00', NULL, NULL, 13886, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:13:47', 'admin-1508297123-15083000271916518', 1, 0, '', NULL, NULL, NULL),
(50627, '2017-10-18 12:14:42', NULL, NULL, 13876, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:14:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50628, '2017-10-18 12:15:07', NULL, NULL, 13876, 0, 211, '145', 'Asian Spicy Lemony Chicken', 'less spicy', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:15:07', 'admin-1508297123-15083001077711713', 1, 0, '', NULL, NULL, NULL),
(50629, '2017-10-18 14:03:13', NULL, NULL, 13892, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:03:13', 'admin-1508305602-1508306593481325', 1, 0, '', NULL, NULL, NULL),
(50630, '2017-10-18 14:01:37', NULL, NULL, 13889, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:01:37', 'admin-1508305602-15083064968563194', 1, 0, '', NULL, NULL, NULL),
(50631, '2017-10-18 13:33:35', NULL, NULL, 13880, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:33:35', 'admin-1508300693-15083048152101647', 1, 0, '', NULL, NULL, NULL),
(50632, '2017-10-18 13:06:50', NULL, NULL, 13885, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:06:50', 'admin-1508300693-15083032099918296', 1, 1, 'SR', NULL, NULL, NULL),
(50633, '2017-10-18 13:06:50', NULL, NULL, 13885, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:06:50', 'admin-1508300693-15083032099918296', 1, 1, 'SR', NULL, NULL, NULL),
(50634, '2017-10-18 00:00:00', NULL, NULL, 13886, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:13:53', 'admin-1508297123-15083000335031947', 1, 1, 'SR', NULL, NULL, NULL),
(50635, '2017-10-18 00:00:00', NULL, NULL, 13883, 0, 271, '205', 'Take It Easy', 'egg to sunny side up', 'Meals', 'Morning Bites ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:21:01', 'admin-1508297123-15083004610865770', 1, 0, '', NULL, NULL, NULL),
(50636, '2017-10-18 12:22:36', NULL, NULL, 13878, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:22:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50637, '2017-10-18 13:55:27', NULL, NULL, 13891, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:55:27', 'admin-1508305602-15083061276827881', 1, 0, '', NULL, NULL, NULL),
(50638, '2017-10-18 13:19:15', NULL, NULL, 13875, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:19:15', 'admin-1508300693-15083039555813234', 1, 1, 'SR', NULL, NULL, NULL),
(50639, '2017-10-18 13:19:15', NULL, NULL, 13875, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:19:15', 'admin-1508300693-15083039555813234', 1, 0, '', NULL, NULL, NULL),
(50640, '2017-10-18 13:19:15', NULL, NULL, 13875, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:19:15', 'admin-1508300693-15083039555813234', 1, 0, '', NULL, NULL, NULL),
(50641, '2017-10-18 13:39:02', NULL, NULL, 13889, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:39:02', 'admin-1508300693-15083051426168676', 1, 1, 'SR', NULL, NULL, NULL),
(50642, '2017-10-18 00:00:00', NULL, NULL, 13887, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:50:35', 'admin-1508300693-15083022348858429', 1, 1, 'SR', NULL, NULL, NULL),
(50643, '2017-10-18 13:06:50', NULL, NULL, 13885, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:06:50', 'admin-1508300693-15083032099918296', 1, 0, '', NULL, NULL, NULL),
(50644, '2017-10-18 00:00:00', NULL, NULL, 13883, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:21:42', 'admin-1508297123-15083005023396971', 1, 1, 'SR', NULL, NULL, NULL),
(50645, '2017-10-18 13:55:07', NULL, NULL, 13891, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:55:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50646, '2017-10-18 13:06:29', NULL, NULL, 13885, 0, 215, '149', 'Thai Fish Sauce Garlic Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:06:29', 'admin-1508300693-15083031896337087', 1, 0, '', NULL, NULL, NULL),
(50647, '2017-10-18 13:06:29', NULL, NULL, 13885, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:06:29', 'admin-1508300693-15083031896337087', 1, 1, 'SR', NULL, NULL, NULL),
(50648, '2017-10-18 11:51:10', NULL, NULL, 13871, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:51:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50649, '2017-10-18 11:51:30', NULL, NULL, 13871, 0, 153, '87', 'Wake Me Up!', ' no bacon,no sausage', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:51:30', 'admin-1508297123-15082986908321672', 1, 0, '', NULL, NULL, NULL),
(50650, '2017-10-18 09:30:49', NULL, NULL, 13853, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:30:49', 'admin-1508287842-15082902491954020', 1, 1, 'SR', NULL, NULL, NULL),
(50651, '2017-10-18 14:12:44', NULL, NULL, 13894, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:12:44', 'admin-1508305602-15083071640216891', 1, 1, 'SR', NULL, NULL, NULL),
(50652, '2017-10-18 13:06:29', NULL, NULL, 13885, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:06:29', 'admin-1508300693-15083031896337087', 1, 0, '', NULL, NULL, NULL),
(50653, '2017-10-18 11:07:26', NULL, NULL, 13852, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:07:26', 'admin-1508292997-15082960460334878', 1, 1, 'SR', NULL, NULL, NULL),
(50654, '2017-10-18 15:37:28', NULL, NULL, 13898, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 15:37:28', 'admin-1508308195-15083122484793028', 1, 0, '', NULL, NULL, NULL),
(50655, '2017-10-18 00:00:00', NULL, NULL, 13882, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:02:51', 'admin-1508297123-15082993711397431', 1, 0, '', NULL, NULL, NULL),
(50656, '2017-10-18 14:23:13', NULL, NULL, 13895, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 18.10, 0.0000, 0.0000, 18.10, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:23:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50657, '2017-10-18 12:44:13', NULL, NULL, 13880, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:44:13', 'admin-1508300693-1508301853358428', 1, 1, 'SR', NULL, NULL, NULL),
(50658, '2017-10-18 12:44:13', NULL, NULL, 13880, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:44:13', 'admin-1508300693-1508301853358428', 1, 1, 'SR', NULL, NULL, NULL),
(50659, '2017-10-18 11:45:45', NULL, NULL, 13870, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:45:45', 'admin-1508297123-15082983448091153', 1, 1, 'SR', NULL, NULL, NULL),
(50660, '2017-10-18 12:44:01', NULL, NULL, 13880, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:44:01', 'admin-1508300693-1508301841303821', 1, 0, '', NULL, NULL, NULL),
(50661, '2017-10-18 12:35:12', NULL, NULL, 13878, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:35:12', 'admin-1508300693-15083013127897978', 1, 0, '', NULL, NULL, NULL),
(50662, '2017-10-18 12:23:06', NULL, NULL, 13878, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:23:07', 'admin-1508297123-15083005867887444', 1, 1, 'SR', NULL, NULL, NULL),
(50663, '2017-10-18 12:23:07', NULL, NULL, 13878, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:23:07', 'admin-1508297123-15083005867887444', 1, 0, '', NULL, NULL, NULL),
(50664, '2017-10-18 10:33:35', NULL, NULL, 13859, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:33:35', 'admin-1508292997-15082940148391894', 1, 1, 'SR', NULL, NULL, NULL),
(50665, '2017-10-18 12:44:01', NULL, NULL, 13880, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:44:01', 'admin-1508300693-1508301841303821', 1, 0, '', NULL, NULL, NULL),
(50666, '2017-10-18 12:43:44', NULL, NULL, 13880, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.80, 0.0000, 0.0000, 10.80, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:43:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50667, '2017-10-18 12:42:54', NULL, NULL, 13879, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:42:54', 'admin-1508300693-1508301774104729', 1, 1, 'SR', NULL, NULL, NULL),
(50668, '2017-10-18 12:40:15', NULL, NULL, 13879, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:40:15', 'admin-1508300693-15083016156958885', 1, 1, 'SR', NULL, NULL, NULL),
(50669, '2017-10-18 12:40:15', NULL, NULL, 13879, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:40:15', 'admin-1508300693-15083016156958885', 1, 0, '', NULL, NULL, NULL),
(50670, '2017-10-18 12:39:45', NULL, NULL, 13879, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:39:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50671, '2017-10-18 12:40:15', NULL, NULL, 13879, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:40:15', 'admin-1508300693-15083016156958885', 1, 0, '', NULL, NULL, NULL),
(50672, '2017-10-18 12:33:26', NULL, NULL, 13878, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:33:26', 'admin-1508300693-15083012065039395', 1, 0, '', NULL, NULL, NULL),
(50673, '2017-10-18 12:19:47', NULL, NULL, 13877, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:19:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50674, '2017-10-18 12:20:03', NULL, NULL, 13877, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:20:03', 'admin-1508297123-15083004032597146', 1, 0, '', NULL, NULL, NULL),
(50675, '2017-10-18 16:02:15', NULL, NULL, 13900, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 16:02:15', 'admin-1508308195-15083137349493542', 1, 0, '', NULL, NULL, NULL),
(50676, '2017-10-18 09:36:04', NULL, NULL, 13854, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:36:04', 'admin-1508287842-15082905645286078', 1, 0, '', NULL, NULL, NULL),
(50677, '2017-10-18 10:46:27', NULL, NULL, 13861, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:46:27', 'admin-1508292997-15082947869193818', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(50678, '2017-10-18 10:46:27', NULL, NULL, 13861, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:46:27', 'admin-1508292997-15082947869193818', 1, 0, '', NULL, NULL, NULL),
(50679, '2017-10-18 10:46:27', NULL, NULL, 13861, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:46:27', 'admin-1508292997-15082947869193818', 1, 0, '', NULL, NULL, NULL),
(50680, '2017-10-18 10:46:27', NULL, NULL, 13861, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:46:27', 'admin-1508292997-15082947869193818', 1, 0, '', NULL, NULL, NULL),
(50681, '2017-10-18 13:06:06', NULL, NULL, 13885, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.30, 0.0000, 0.0000, 11.30, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:06:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50682, '2017-10-18 00:00:00', NULL, NULL, 13882, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:03:30', 'admin-1508297123-1508299410445841', 1, 0, '', NULL, NULL, NULL),
(50683, '2017-10-18 14:46:07', NULL, NULL, 13893, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:46:07', 'admin-1508308195-1508309167468973', 1, 0, '', NULL, NULL, NULL),
(50684, '2017-10-18 14:11:53', NULL, NULL, 13894, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:11:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50685, '2017-10-18 13:06:29', NULL, NULL, 13885, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:06:29', 'admin-1508300693-15083031896337087', 1, 1, 'SR', NULL, NULL, NULL),
(50686, '2017-10-18 14:26:26', NULL, NULL, 13895, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:26:26', 'admin-1508305602-1508307985795819', 1, 1, 'SR', NULL, NULL, NULL),
(50687, '2017-10-18 14:23:29', NULL, NULL, 13895, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:23:29', 'admin-1508305602-15083078095893823', 1, 0, '', NULL, NULL, NULL),
(50688, '2017-10-18 12:20:03', NULL, NULL, 13877, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:20:03', 'admin-1508297123-15083004032597146', 1, 1, 'SR', NULL, NULL, NULL),
(50689, '2017-10-18 11:10:15', NULL, NULL, 13868, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:10:15', 'admin-1508292997-1508296215375371', 1, 0, '', NULL, NULL, NULL),
(50690, '2017-10-18 13:09:09', NULL, NULL, 13886, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:09:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50691, '2017-10-18 12:13:06', NULL, NULL, 13875, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:13:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50692, '2017-10-18 12:12:08', NULL, NULL, 13874, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:12:08', 'admin-1508297123-15082999283596535', 1, 1, 'SR', NULL, NULL, NULL),
(50693, '2017-10-18 12:12:05', NULL, NULL, 13874, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:12:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50694, '2017-10-18 09:36:21', NULL, NULL, 13854, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:36:21', 'admin-1508287842-15082905815605425', 1, 0, '', NULL, NULL, NULL),
(50695, '2017-10-18 09:37:44', NULL, NULL, 13855, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:37:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50696, '2017-10-18 11:51:39', NULL, NULL, 13871, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:51:39', 'admin-1508297123-15082986995767588', 1, 0, '', NULL, NULL, NULL),
(50697, '2017-10-18 11:29:00', NULL, NULL, 13869, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:29:00', 'admin-1508297123-15082973408448064', 1, 0, '', NULL, NULL, NULL),
(50698, '2017-10-18 11:54:29', NULL, NULL, 13872, 0, 215, '149', 'Thai Fish Sauce Garlic Pork', 'more spring onion', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:54:29', 'admin-1508297123-15082988694651383', 1, 0, '', 1, NULL, NULL),
(50699, '2017-10-18 11:45:45', NULL, NULL, 13870, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:45:45', 'admin-1508297123-15082983448091153', 1, 1, 'SR', NULL, NULL, NULL),
(50700, '2017-10-18 11:45:19', NULL, NULL, 13870, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:45:19', 'admin-1508297123-15082983193208069', 1, 0, '', NULL, NULL, NULL),
(50701, '2017-10-18 11:45:19', NULL, NULL, 13870, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:45:19', 'admin-1508297123-15082983193208069', 1, 0, '', NULL, NULL, NULL),
(50702, '2017-10-18 12:20:03', NULL, NULL, 13877, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 12:20:03', 'admin-1508297123-15083004032597146', 1, 0, '', NULL, NULL, NULL),
(50703, '2017-10-18 11:29:12', NULL, NULL, 13869, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:29:12', 'admin-1508297123-1508297352063213', 1, 1, 'SR', NULL, NULL, NULL),
(50704, '2017-10-18 11:45:19', NULL, NULL, 13870, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:45:19', 'admin-1508297123-15082983193208069', 1, 0, '', NULL, NULL, NULL),
(50705, '2017-10-18 11:09:59', NULL, NULL, 13867, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:09:59', 'admin-1508292997-15082961998267280', 1, 0, '', NULL, NULL, NULL),
(50706, '2017-10-18 09:55:42', NULL, NULL, 13856, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:55:42', 'admin-1508287842-1508291741786548', 1, 0, '', NULL, NULL, NULL),
(50707, '2017-10-18 11:06:28', NULL, NULL, 13866, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:06:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50708, '2017-10-18 11:06:58', NULL, NULL, 13866, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:06:58', 'admin-1508292997-15082960181113071', 1, 1, 'SR', NULL, NULL, NULL),
(50709, '2017-10-18 11:06:58', NULL, NULL, 13866, 0, 299, '235', 'Iced Salted Caramel Machiato', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:06:58', 'admin-1508292997-15082960181113071', 1, 0, '', NULL, NULL, NULL),
(50710, '2017-10-18 11:06:58', NULL, NULL, 13866, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:06:58', 'admin-1508292997-15082960181113071', 1, 1, 'SR', NULL, NULL, NULL),
(50711, '2017-10-18 11:09:49', NULL, NULL, 13867, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:09:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50712, '2017-10-18 10:33:35', NULL, NULL, 13859, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:33:35', 'admin-1508292997-15082940148391894', 1, 0, '', NULL, NULL, NULL),
(50713, '2017-10-18 09:30:31', NULL, NULL, 13853, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:30:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50714, '2017-10-18 09:35:38', NULL, NULL, 13854, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.70, 0.0000, 0.0000, 12.70, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:35:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50715, '2017-10-18 09:36:04', NULL, NULL, 13854, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:36:04', 'admin-1508287842-15082905645286078', 1, 0, '', NULL, NULL, NULL),
(50716, '2017-10-18 09:36:04', NULL, NULL, 13854, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:36:04', 'admin-1508287842-15082905645286078', 1, 0, '', NULL, NULL, NULL),
(50717, '2017-10-18 09:30:49', NULL, NULL, 13853, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:30:49', 'admin-1508287842-15082902491954020', 1, 1, 'SR', NULL, NULL, NULL),
(50718, '2017-10-18 11:07:26', NULL, NULL, 13852, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:07:26', 'admin-1508292997-15082960460334878', 1, 1, 'SR', NULL, NULL, NULL),
(50719, '2017-10-18 11:07:26', NULL, NULL, 13852, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:07:26', 'admin-1508292997-15082960460334878', 1, 1, 'SR', NULL, NULL, NULL),
(50720, '2017-10-18 15:37:28', NULL, NULL, 13898, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 15:37:28', 'admin-1508308195-15083122484793028', 1, 0, '', NULL, NULL, NULL),
(50721, '2017-10-18 11:07:26', NULL, NULL, 13852, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:07:26', 'admin-1508292997-15082960460334878', 1, 1, 'SR', NULL, NULL, NULL),
(50722, '2017-10-18 11:07:26', NULL, NULL, 13852, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:07:26', 'admin-1508292997-15082960460334878', 1, 0, '', NULL, NULL, NULL),
(50723, '2017-10-18 11:06:58', NULL, NULL, 13866, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:06:58', 'admin-1508292997-15082960181113071', 1, 0, '', NULL, NULL, NULL),
(50724, '2017-10-18 11:00:08', NULL, NULL, 13865, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:00:08', 'admin-1508292997-15082956083525850', 1, 0, '', NULL, NULL, NULL),
(50725, '2017-10-18 10:37:55', NULL, NULL, 13860, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:37:55', 'admin-1508292997-15082942750311069', 1, 0, '', NULL, NULL, NULL),
(50726, '2017-10-18 10:38:01', NULL, NULL, 13860, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:38:01', 'admin-1508292997-15082942809193826', 1, 1, 'SR', NULL, NULL, NULL),
(50727, '2017-10-18 10:46:10', NULL, NULL, 13861, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.10, 0.0000, 0.0000, 11.10, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:46:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50728, '2017-10-18 10:46:27', NULL, NULL, 13861, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:46:27', 'admin-1508292997-15082947869193818', 1, 0, '', NULL, NULL, NULL),
(50729, '2017-10-18 10:46:27', NULL, NULL, 13861, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:46:27', 'admin-1508292997-15082947869193818', 1, 0, '', NULL, NULL, NULL),
(50730, '2017-10-18 13:24:13', NULL, NULL, 13888, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 13:24:13', 'admin-1508300693-15083042530655063', 1, 1, 'SR', NULL, NULL, NULL),
(50731, '2017-10-18 14:23:29', NULL, NULL, 13895, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:23:29', 'admin-1508305602-15083078095893823', 1, 0, '', NULL, NULL, NULL),
(50732, '2017-10-18 11:45:19', NULL, NULL, 13870, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 11:45:19', 'admin-1508297123-15082983193208069', 1, 0, '', NULL, NULL, NULL),
(50733, '2017-10-18 10:46:27', NULL, NULL, 13861, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:46:27', 'admin-1508292997-15082947869193818', 1, 1, 'SR', NULL, NULL, NULL),
(50734, '2017-10-18 10:37:55', NULL, NULL, 13860, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:37:55', 'admin-1508292997-15082942750311069', 1, 0, '', NULL, NULL, NULL),
(50735, '2017-10-18 10:33:34', NULL, NULL, 13859, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:33:35', 'admin-1508292997-15082940148391894', 1, 0, '', NULL, NULL, NULL),
(50736, '2017-10-18 10:33:35', NULL, NULL, 13859, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:33:35', 'admin-1508292997-15082940148391894', 1, 0, '', NULL, NULL, NULL),
(50737, '2017-10-18 10:37:49', NULL, NULL, 13860, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:37:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50738, '2017-10-18 09:36:04', NULL, NULL, 13854, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:36:04', 'admin-1508287842-15082905645286078', 1, 0, '', NULL, NULL, NULL),
(50739, '2017-10-18 10:33:10', NULL, NULL, 13859, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:33:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50740, '2017-10-18 10:01:02', NULL, NULL, 13857, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:01:02', 'admin-1508287842-15082920620124056', 1, 0, '', NULL, NULL, NULL),
(50741, '2017-10-18 10:00:25', NULL, NULL, 13857, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:00:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50742, '2017-10-18 09:55:42', NULL, NULL, 13856, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:55:42', 'admin-1508287842-1508291741786548', 1, 1, 'SR', NULL, NULL, NULL),
(50743, '2017-10-18 09:55:42', NULL, NULL, 13856, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:55:42', 'admin-1508287842-1508291741786548', 1, 1, 'SR', NULL, NULL, NULL),
(50744, '2017-10-18 09:55:42', NULL, NULL, 13856, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:55:42', 'admin-1508287842-1508291741786548', 1, 0, '', NULL, NULL, NULL),
(50745, '2017-10-18 09:55:33', NULL, NULL, 13856, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:55:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50746, '2017-10-18 09:38:02', NULL, NULL, 13855, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:38:02', 'admin-1508287842-1508290682441275', 1, 1, 'SR', NULL, NULL, NULL),
(50747, '2017-10-18 09:38:02', NULL, NULL, 13855, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:38:02', 'admin-1508287842-1508290682441275', 1, 0, '', NULL, NULL, NULL),
(50748, '2017-10-18 09:38:02', NULL, NULL, 13855, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:38:02', 'admin-1508287842-1508290682441275', 1, 0, '', NULL, NULL, NULL),
(50749, '2017-10-18 09:36:21', NULL, NULL, 13854, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:36:21', 'admin-1508287842-15082905815605425', 1, 1, 'SR', NULL, NULL, NULL),
(50750, '2017-10-18 10:59:48', NULL, NULL, 13865, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:59:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50751, '2017-10-18 14:08:35', NULL, NULL, 13893, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 14:08:35', 'admin-1508305602-15083069154116266', 1, 0, '', NULL, NULL, NULL),
(50752, '2017-10-18 09:36:21', NULL, NULL, 13854, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:36:21', 'admin-1508287842-15082905815605425', 1, 1, 'SR', NULL, NULL, NULL),
(50753, '2017-10-18 09:36:21', NULL, NULL, 13854, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:36:21', 'admin-1508287842-15082905815605425', 1, 1, 'SR', NULL, NULL, NULL),
(50754, '2017-10-18 09:32:36', NULL, NULL, 13853, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:32:36', 'admin-1508287842-15082903561037156', 1, 0, '', NULL, NULL, NULL),
(50755, '2017-10-18 09:32:46', NULL, NULL, 13853, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:32:46', 'admin-1508287842-15082903659243867', 1, 0, '', NULL, NULL, NULL),
(50756, '2017-10-18 00:00:00', NULL, NULL, 13864, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:28:07', 'admin-1508287842-1508290087266349', 1, 0, '', NULL, NULL, NULL),
(50757, '2017-10-18 09:27:28', NULL, NULL, 13852, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:27:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50758, '2017-10-18 00:00:00', NULL, NULL, 13863, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:28:07', 'admin-1508287842-1508290087266349', 1, 0, '', NULL, NULL, NULL),
(50759, '2017-10-18 10:56:56', NULL, NULL, 13863, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:56:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50760, '2017-10-18 10:57:46', NULL, NULL, 13864, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1508315138', 'admin', '2017-10-18 10:57:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50761, '2017-10-18 09:12:15', NULL, NULL, 13851, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:12:15', 'admin-1508287842-15082891356817627', 1, 0, '', NULL, NULL, NULL),
(50762, '2017-10-18 09:12:15', NULL, NULL, 13851, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:12:15', 'admin-1508287842-15082891356817627', 1, 1, 'SR', NULL, NULL, NULL),
(50763, '2017-10-18 09:12:02', NULL, NULL, 13851, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1508315138', 'admin', '2017-10-18 09:12:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50764, '2017-10-19 10:32:04', NULL, NULL, 13915, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 10:32:04', 'admin-1508373476-15083803241729052', 1, 0, '', NULL, NULL, '10.0'),
(50765, '2017-10-19 12:31:48', NULL, NULL, 13922, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:31:48', 'admin-1508381954-15083875080357265', 1, 0, '', NULL, NULL, NULL),
(50766, '2017-10-19 12:42:10', NULL, NULL, 13923, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:42:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50767, '2017-10-19 12:42:13', NULL, NULL, 13923, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:42:13', 'admin-1508381954-15083881337858848', 1, 1, 'SR', NULL, NULL, NULL),
(50768, '2017-10-19 12:53:28', NULL, NULL, 13919, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:53:28', 'admin-1508381954-1508388808075283', 1, 0, '', NULL, NULL, '10.0'),
(50769, '2017-10-19 12:53:28', NULL, NULL, 13919, 0, 298, '234', 'Salted Caramel Machiato', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:53:28', 'admin-1508381954-1508388808075283', 1, 0, '', NULL, NULL, '10.0'),
(50770, '2017-10-19 09:47:14', NULL, NULL, 13910, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:47:14', 'admin-1508373476-15083776341259226', 1, 0, '', NULL, NULL, NULL),
(50771, '2017-10-19 10:30:42', NULL, NULL, 13914, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 10:30:42', 'admin-1508373476-15083802426003278', 1, 0, '', NULL, NULL, NULL),
(50772, '2017-10-19 12:26:24', NULL, NULL, 13921, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:26:24', 'admin-1508381954-15083871839057976', 1, 1, 'SR', NULL, NULL, NULL),
(50773, '2017-10-19 14:35:03', NULL, NULL, 13932, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:35:03', 'admin-1508392949-15083949036627882', 1, 1, 'SR', NULL, NULL, NULL),
(50774, '2017-10-19 14:37:25', NULL, NULL, 13932, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:37:25', 'admin-1508392949-15083950449919177', 1, 1, 'SR', NULL, NULL, NULL),
(50775, '2017-10-19 14:37:25', NULL, NULL, 13932, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:37:25', 'admin-1508392949-15083950449919177', 1, 0, '', NULL, NULL, NULL),
(50776, '2017-10-19 14:44:53', NULL, NULL, 13927, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:44:53', 'admin-1508392949-15083954930935090', 1, 0, '', NULL, NULL, NULL),
(50777, '2017-10-19 14:20:34', NULL, NULL, 13930, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:20:34', 'admin-1508392949-15083940342943413', 1, 0, '', NULL, NULL, NULL),
(50778, '2017-10-19 16:37:38', NULL, NULL, 13938, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 16:37:38', 'admin-1508392949-15084022583927077', 1, 1, 'SR', NULL, NULL, NULL),
(50779, '2017-10-19 15:56:17', NULL, NULL, 13937, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 3, 12.00, 36.0000, 0.0000, 36.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 15:56:17', 'admin-1508392949-15083997776104531', 1, 1, 'SR', 1, NULL, '10.0'),
(50780, '2017-10-19 13:23:54', NULL, NULL, 13924, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 13:23:54', 'admin-1508381954-15083906345377490', 1, 0, '', NULL, NULL, NULL),
(50781, '2017-10-19 11:50:49', NULL, NULL, 13919, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1508392949', 'admin', '2017-10-19 11:50:49', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(50782, '2017-10-19 11:52:07', NULL, NULL, 13919, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 11:52:07', 'admin-1508381954-15083851269315166', 1, 1, 'SR', NULL, NULL, '10.0'),
(50783, '2017-10-19 11:52:07', NULL, NULL, 13919, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 11:52:07', 'admin-1508381954-15083851269315166', 1, 1, 'SR', NULL, NULL, '10.0'),
(50784, '2017-10-19 11:52:18', NULL, NULL, 13919, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 11:52:18', 'admin-1508381954-15083851381215494', 1, 0, '', NULL, NULL, '10.0'),
(50785, '2017-10-19 12:08:02', NULL, NULL, 13920, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:08:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50786, '2017-10-19 12:08:26', NULL, NULL, 13920, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:08:26', 'admin-1508381954-1508386106773282', 1, 0, '', NULL, NULL, NULL),
(50787, '2017-10-19 12:08:26', NULL, NULL, 13920, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:08:26', 'admin-1508381954-1508386106773282', 1, 1, 'SR', NULL, NULL, NULL),
(50788, '2017-10-19 12:08:26', NULL, NULL, 13920, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:08:26', 'admin-1508381954-1508386106773282', 1, 0, '', NULL, NULL, NULL),
(50789, '2017-10-19 12:08:26', NULL, NULL, 13920, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:08:26', 'admin-1508381954-1508386106773282', 1, 0, '', NULL, NULL, NULL),
(50790, '2017-10-19 12:24:20', NULL, NULL, 13921, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.70, 0.0000, 0.0000, 16.70, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:24:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50791, '2017-10-19 12:26:24', NULL, NULL, 13921, 0, 70, '70', 'Borneo Pepper Pork', 'half rice', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:26:24', 'admin-1508381954-15083871839057976', 1, 1, 'SR', NULL, NULL, NULL),
(50792, '2017-10-19 12:26:24', NULL, NULL, 13921, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:26:24', 'admin-1508381954-15083871839057976', 1, 0, '', NULL, NULL, NULL),
(50793, '2017-10-19 12:37:52', NULL, NULL, 13921, 0, 71, '71', 'Chinese  Rice Wine Pork', 'half rice', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:37:52', 'admin-1508381954-15083878718188771', 1, 1, 'SR', NULL, NULL, NULL),
(50794, '2017-10-19 12:26:24', NULL, NULL, 13921, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:26:24', 'admin-1508381954-15083871839057976', 1, 0, '', NULL, NULL, NULL),
(50795, '2017-10-19 09:42:09', NULL, NULL, 13908, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:42:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50796, '2017-10-19 09:42:15', NULL, NULL, 13908, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:42:15', 'admin-1508373476-15083773357144639', 1, 1, 'SR', NULL, NULL, NULL),
(50797, '2017-10-19 09:42:15', NULL, NULL, 13908, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:42:15', 'admin-1508373476-15083773357144639', 1, 0, '', NULL, NULL, NULL),
(50798, '2017-10-19 15:41:36', NULL, NULL, 13936, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 15:41:36', 'admin-1508392949-15083988959144971', 1, 1, 'SR', NULL, NULL, NULL),
(50799, '2017-10-19 16:37:32', NULL, NULL, 13938, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 16:37:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50800, '2017-10-19 00:00:00', NULL, NULL, 13929, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, NULL, NULL, 2.50, 1, '27', 1, '1508392949', 'admin', '2017-10-19 13:28:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50801, '2017-10-19 10:30:26', NULL, NULL, 13914, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1508392949', 'admin', '2017-10-19 10:30:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50802, '2017-10-19 10:30:42', NULL, NULL, 13914, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 10:30:42', 'admin-1508373476-15083802426003278', 1, 0, '', NULL, NULL, NULL),
(50803, '2017-10-19 10:30:42', NULL, NULL, 13914, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 10:30:42', 'admin-1508373476-15083802426003278', 1, 0, '', NULL, NULL, NULL),
(50804, '2017-10-19 00:00:00', NULL, NULL, 13929, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 13:28:57', 'admin-1508381954-15083909368993699', 1, 1, 'SR', NULL, NULL, NULL),
(50805, '2017-10-19 14:20:59', NULL, NULL, 13931, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:20:59', 'admin-1508392949-15083940590745370', 1, 0, '', NULL, NULL, NULL),
(50806, '2017-10-19 14:13:55', NULL, NULL, 13928, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:13:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50807, '2017-10-19 00:00:00', NULL, NULL, 13929, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 13:28:57', 'admin-1508381954-15083909368993699', 1, 0, '', NULL, NULL, NULL),
(50808, '2017-10-19 14:02:11', NULL, NULL, 13927, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.10, 0.0000, 0.0000, 10.10, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:02:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50809, '2017-10-19 14:02:23', NULL, NULL, 13927, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:02:23', 'admin-1508381954-15083929436581044', 1, 1, 'SR', NULL, NULL, NULL),
(50810, '2017-10-19 14:02:23', NULL, NULL, 13927, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:02:23', 'admin-1508381954-15083929436581044', 1, 1, 'SR', NULL, NULL, NULL),
(50811, '2017-10-19 14:02:23', NULL, NULL, 13927, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:02:23', 'admin-1508381954-15083929436581044', 1, 1, 'SR', NULL, NULL, NULL),
(50812, '2017-10-19 14:02:44', NULL, NULL, 13927, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:02:44', 'admin-1508392949-15083929642648524', 1, 1, 'SR', NULL, NULL, NULL),
(50813, '2017-10-19 11:02:41', NULL, NULL, 13917, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 11:02:41', 'admin-1508381954-1508382161664764', 1, 1, 'SR', NULL, NULL, NULL),
(50814, '2017-10-19 15:11:56', NULL, NULL, 13934, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 15:11:56', 'admin-1508392949-15083971159794025', 1, 1, 'SR', 1, NULL, '10.0'),
(50815, '2017-10-19 12:26:24', NULL, NULL, 13921, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:26:24', 'admin-1508381954-15083871839057976', 1, 0, '', NULL, NULL, NULL),
(50816, '2017-10-19 12:26:24', NULL, NULL, 13921, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:26:24', 'admin-1508381954-15083871839057976', 1, 0, '', NULL, NULL, NULL),
(50817, '2017-10-19 12:26:35', NULL, NULL, 13921, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:26:35', 'admin-1508381954-15083871953064976', 1, 1, 'SR', NULL, NULL, NULL),
(50818, '2017-10-19 12:26:35', NULL, NULL, 13921, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:26:35', 'admin-1508381954-15083871953064976', 1, 0, '', NULL, NULL, NULL),
(50819, '2017-10-19 12:31:28', NULL, NULL, 13922, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:31:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50820, '2017-10-19 12:31:48', NULL, NULL, 13922, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:31:48', 'admin-1508381954-15083875080357265', 1, 0, '', NULL, NULL, NULL),
(50821, '2017-10-19 09:46:58', NULL, NULL, 13910, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:46:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50822, '2017-10-19 16:37:38', NULL, NULL, 13938, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 16:37:38', 'admin-1508392949-15084022583927077', 1, 0, '', NULL, NULL, NULL),
(50823, '2017-10-19 15:41:36', NULL, NULL, 13936, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 15:41:36', 'admin-1508392949-15083988959144971', 1, 0, '', NULL, NULL, NULL),
(50824, '2017-10-19 14:20:59', NULL, NULL, 13931, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:20:59', 'admin-1508392949-15083940590745370', 1, 0, '', NULL, NULL, NULL),
(50825, '2017-10-19 15:41:36', NULL, NULL, 13936, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 15:41:36', 'admin-1508392949-15083988959144971', 1, 1, 'SR', NULL, NULL, NULL),
(50826, '2017-10-19 15:41:20', NULL, NULL, 13936, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1508392949', 'admin', '2017-10-19 15:41:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50827, '2017-10-19 15:41:36', NULL, NULL, 13936, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 15:41:36', 'admin-1508392949-15083988959144971', 1, 1, 'SR', NULL, NULL, NULL),
(50828, '2017-10-19 00:00:00', NULL, NULL, 13935, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:20:34', 'admin-1508392949-15083940342943413', 1, 1, 'SR', NULL, NULL, NULL),
(50829, '2017-10-19 09:47:50', NULL, NULL, 13911, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:47:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50830, '2017-10-19 09:47:57', NULL, NULL, 13911, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:47:57', 'admin-1508373476-15083776777723557', 1, 1, 'SR', NULL, NULL, NULL),
(50831, '2017-10-19 14:44:53', NULL, NULL, 13927, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:44:53', 'admin-1508392949-15083954930935090', 1, 0, '', NULL, NULL, NULL),
(50832, '2017-10-19 14:44:53', NULL, NULL, 13927, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:44:53', 'admin-1508392949-15083954930935090', 1, 0, '', NULL, NULL, NULL),
(50833, '2017-10-19 14:38:10', NULL, NULL, 13933, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:38:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50834, '2017-10-19 14:38:12', NULL, NULL, 13933, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:38:12', 'admin-1508392949-15083950927476864', 1, 0, '', NULL, NULL, NULL),
(50835, '2017-10-19 14:20:59', NULL, NULL, 13931, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:20:59', 'admin-1508392949-15083940590745370', 1, 1, 'SR', NULL, NULL, NULL),
(50836, '2017-10-19 14:34:59', NULL, NULL, 13932, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:34:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50837, '2017-10-19 14:20:41', NULL, NULL, 13931, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:20:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50838, '2017-10-19 00:00:00', NULL, NULL, 13935, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, NULL, NULL, 22.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:20:34', 'admin-1508392949-15083940342943413', 1, 0, '', NULL, NULL, NULL),
(50839, '2017-10-19 14:20:34', NULL, NULL, 13930, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:20:34', 'admin-1508392949-15083940342943413', 1, 1, 'SR', NULL, NULL, NULL),
(50840, '2017-10-19 10:20:51', NULL, NULL, 13913, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 10:20:51', 'admin-1508373476-15083796516164279', 1, 1, 'SR', NULL, NULL, NULL),
(50841, '2017-10-19 10:20:51', NULL, NULL, 13913, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 10:20:51', 'admin-1508373476-15083796516164279', 1, 1, 'SR', NULL, NULL, NULL),
(50842, '2017-10-19 10:20:51', NULL, NULL, 13913, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 10:20:51', 'admin-1508373476-15083796516164279', 1, 0, '', NULL, NULL, NULL),
(50843, '2017-10-19 10:20:51', NULL, NULL, 13913, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 10:20:51', 'admin-1508373476-15083796516164279', 1, 0, '', NULL, NULL, NULL),
(50844, '2017-10-19 15:15:50', NULL, NULL, 13935, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1508392949', 'admin', '2017-10-19 15:15:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50845, '2017-10-19 09:25:47', NULL, NULL, 13906, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:25:47', 'admin-1508373476-15083763473281855', 1, 1, 'SR', NULL, NULL, NULL),
(50846, '2017-10-19 00:00:00', NULL, NULL, 13929, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 13:37:30', 'admin-1508381954-15083914507302534', 1, 0, '', NULL, NULL, NULL),
(50847, '2017-10-19 00:00:00', NULL, NULL, 13928, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 13:28:57', 'admin-1508381954-15083909368993699', 1, 1, 'SR', NULL, NULL, NULL),
(50848, '2017-10-19 14:02:44', NULL, NULL, 13927, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:02:44', 'admin-1508392949-15083929642648524', 1, 1, 'SR', NULL, NULL, NULL),
(50849, '2017-10-19 14:02:44', NULL, NULL, 13927, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:02:44', 'admin-1508392949-15083929642648524', 1, 1, 'SR', NULL, NULL, NULL),
(50850, '2017-10-19 00:00:00', NULL, NULL, 13928, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 13:37:30', 'admin-1508381954-15083914507302534', 1, 0, '', NULL, NULL, NULL),
(50851, '2017-10-19 14:19:55', NULL, NULL, 13930, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1508392949', 'admin', '2017-10-19 14:19:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50852, '2017-10-19 13:23:54', NULL, NULL, 13924, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 13:23:54', 'admin-1508381954-15083906345377490', 1, 1, 'SR', NULL, NULL, NULL),
(50853, '2017-10-19 13:23:54', NULL, NULL, 13924, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 13:23:54', 'admin-1508381954-15083906345377490', 1, 0, '', NULL, NULL, NULL),
(50854, '2017-10-19 13:33:13', NULL, NULL, 13926, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 13:33:13', 'admin-1508381954-15083911928249785', 1, 1, 'SR', 1, NULL, NULL),
(50855, '2017-10-19 12:26:24', NULL, NULL, 13921, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:26:24', 'admin-1508381954-15083871839057976', 1, 1, 'SR', NULL, NULL, NULL),
(50856, '2017-10-19 13:23:54', NULL, NULL, 13924, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 13:23:54', 'admin-1508381954-15083906345377490', 1, 1, 'SR', NULL, NULL, NULL),
(50857, '2017-10-19 13:23:29', NULL, NULL, 13924, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1508392949', 'admin', '2017-10-19 13:23:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50858, '2017-10-19 09:47:14', NULL, NULL, 13910, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:47:14', 'admin-1508373476-15083776341259226', 1, 1, 'SR', NULL, NULL, NULL),
(50859, '2017-10-19 11:02:41', NULL, NULL, 13917, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 11:02:41', 'admin-1508381954-1508382161664764', 1, 0, '', NULL, NULL, NULL),
(50860, '2017-10-19 11:02:41', NULL, NULL, 13917, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 11:02:41', 'admin-1508381954-1508382161664764', 1, 1, 'SR', NULL, NULL, NULL),
(50861, '2017-10-19 11:41:21', NULL, NULL, 13918, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 11:41:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50862, '2017-10-19 11:41:31', NULL, NULL, 13918, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 11:41:31', 'admin-1508381954-15083844916952241', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(50863, '2017-10-19 12:26:24', NULL, NULL, 13921, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:26:24', 'admin-1508381954-15083871839057976', 1, 1, 'SR', NULL, NULL, NULL),
(50864, '2017-10-19 12:26:24', NULL, NULL, 13921, 0, 71, '71', 'Chinese  Rice Wine Pork', 'half rice', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 12:26:24', 'admin-1508381954-15083871839057976', 1, 1, 'SR', NULL, NULL, NULL),
(50865, '2017-10-19 10:57:51', NULL, NULL, 13917, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1508392949', 'admin', '2017-10-19 10:57:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50866, '2017-10-19 10:57:37', NULL, NULL, 13916, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 10:57:37', 'admin-1508373476-1508381857652989', 1, 0, '', NULL, NULL, NULL),
(50867, '2017-10-19 10:32:04', NULL, NULL, 13915, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 10:32:04', 'admin-1508373476-15083803241729052', 1, 0, '', NULL, NULL, '10.0'),
(50868, '2017-10-19 10:57:46', NULL, NULL, 13916, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 10:57:46', 'admin-1508373476-15083818664716922', 1, 1, 'SR', NULL, NULL, NULL),
(50869, '2017-10-19 11:02:41', NULL, NULL, 13917, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 11:02:41', 'admin-1508381954-1508382161664764', 1, 0, '', NULL, NULL, NULL),
(50870, '2017-10-19 10:57:46', NULL, NULL, 13916, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 10:57:46', 'admin-1508373476-15083818664716922', 1, 1, 'SR', NULL, NULL, NULL),
(50871, '2017-10-19 09:47:57', NULL, NULL, 13911, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:47:57', 'admin-1508373476-15083776777723557', 1, 0, '', NULL, NULL, NULL),
(50872, '2017-10-19 10:32:04', NULL, NULL, 13915, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 10:32:04', 'admin-1508373476-15083803241729052', 1, 1, 'SR', NULL, NULL, '10.0'),
(50873, '2017-10-19 10:32:04', NULL, NULL, 13915, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 10:32:04', 'admin-1508373476-15083803241729052', 1, 1, 'SR', NULL, NULL, '10.0'),
(50874, '2017-10-19 10:30:42', NULL, NULL, 13914, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 10:30:42', 'admin-1508373476-15083802426003278', 1, 1, 'SR', NULL, NULL, NULL),
(50875, '2017-10-19 10:31:52', NULL, NULL, 13915, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1508392949', 'admin', '2017-10-19 10:31:52', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(50876, '2017-10-19 10:20:42', NULL, NULL, 13913, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1508392949', 'admin', '2017-10-19 10:20:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50877, '2017-10-19 09:59:44', NULL, NULL, 13912, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:59:44', 'admin-1508373476-1508378383859730', 1, 0, '', NULL, NULL, NULL),
(50878, '2017-10-19 09:57:49', NULL, NULL, 13912, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:57:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50879, '2017-10-19 10:57:35', NULL, NULL, 13916, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1508392949', 'admin', '2017-10-19 10:57:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50880, '2017-10-19 09:46:56', NULL, NULL, 13909, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:46:56', 'admin-1508373476-15083776158625062', 1, 1, 'SR', NULL, NULL, NULL),
(50881, '2017-10-19 09:47:14', NULL, NULL, 13910, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:47:14', 'admin-1508373476-15083776341259226', 1, 1, 'SR', NULL, NULL, NULL),
(50882, '2017-10-19 09:46:56', NULL, NULL, 13909, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:46:56', 'admin-1508373476-15083776158625062', 1, 0, '', NULL, NULL, NULL),
(50883, '2017-10-19 09:46:56', NULL, NULL, 13909, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:46:56', 'admin-1508373476-15083776158625062', 1, 1, 'SR', NULL, NULL, NULL),
(50884, '2017-10-19 09:46:56', NULL, NULL, 13909, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:46:56', 'admin-1508373476-15083776158625062', 1, 1, 'SR', NULL, NULL, NULL),
(50885, '2017-10-19 09:46:56', NULL, NULL, 13909, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:46:56', 'admin-1508373476-15083776158625062', 1, 0, '', NULL, NULL, NULL),
(50886, '2017-10-19 09:46:19', NULL, NULL, 13909, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:46:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50887, '2017-10-19 09:25:47', NULL, NULL, 13906, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:25:47', 'admin-1508373476-15083763473281855', 1, 0, '', NULL, NULL, NULL),
(50888, '2017-10-19 09:25:47', NULL, NULL, 13906, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:25:47', 'admin-1508373476-15083763473281855', 1, 0, '', NULL, NULL, NULL),
(50889, '2017-10-19 09:36:32', NULL, NULL, 13907, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:36:32', 'admin-1508373476-15083769919471434', 1, 1, 'SR', NULL, NULL, NULL),
(50890, '2017-10-19 09:36:23', NULL, NULL, 13907, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:36:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50891, '2017-10-19 09:36:32', NULL, NULL, 13907, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:36:32', 'admin-1508373476-15083769919471434', 1, 1, 'SR', NULL, NULL, NULL),
(50892, '2017-10-19 09:25:47', NULL, NULL, 13906, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:25:47', 'admin-1508373476-15083763473281855', 1, 1, 'SR', NULL, NULL, NULL),
(50893, '2017-10-19 09:25:33', NULL, NULL, 13906, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1508392949', 'admin', '2017-10-19 09:25:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50894, '2017-10-20 14:49:39', NULL, NULL, 13960, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 14:49:39', 'admin-1508476012-15084821795316381', 1, 0, '', NULL, NULL, NULL),
(50895, '2017-10-20 00:00:00', NULL, NULL, 13954, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 13:10:29', 'admin-1508476012-15084762294566141', 1, 1, 'SR', NULL, NULL, NULL),
(50896, '2017-10-20 13:15:51', NULL, NULL, 13953, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 13:15:51', 'admin-1508476012-1508476551299352', 1, 1, 'SR', 1, NULL, NULL),
(50897, '2017-10-20 14:48:52', NULL, NULL, 13960, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1508476012', 'admin', '2017-10-20 14:48:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50898, '2017-10-20 14:35:22', NULL, NULL, 13959, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1508476012', 'admin', '2017-10-20 14:35:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50899, '2017-10-20 14:35:56', NULL, NULL, 13959, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 14:35:56', 'admin-1508476012-15084813563143215', 1, 0, '', NULL, NULL, NULL),
(50900, '2017-10-20 14:08:14', NULL, NULL, 13956, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 14:08:14', 'admin-1508476012-15084796947099211', 1, 0, '', NULL, NULL, NULL),
(50901, '2017-10-20 14:35:56', NULL, NULL, 13959, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 14:35:56', 'admin-1508476012-15084813563143215', 1, 1, 'SR', NULL, NULL, NULL),
(50902, '2017-10-20 11:35:10', NULL, NULL, 13946, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1508476012', 'admin', '2017-10-20 11:35:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50903, '2017-10-20 11:35:18', NULL, NULL, 13946, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 11:35:18', 'admin-1508461080-1508470518249185', 1, 1, 'SR', NULL, NULL, NULL),
(50904, '2017-10-20 11:35:18', NULL, NULL, 13946, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 11:35:18', 'admin-1508461080-1508470518249185', 1, 1, 'SR', NULL, NULL, NULL),
(50905, '2017-10-20 11:35:32', NULL, NULL, 13946, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 11:35:32', 'admin-1508461080-15084705320428790', 1, 0, '', NULL, NULL, NULL),
(50906, '2017-10-20 11:35:32', NULL, NULL, 13946, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 11:35:32', 'admin-1508461080-15084705320428790', 1, 0, '', NULL, NULL, NULL),
(50907, '2017-10-20 12:03:36', NULL, NULL, 13947, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:03:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50908, '2017-10-20 12:06:29', NULL, NULL, 13947, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:06:29', 'admin-1508461080-15084723892476263', 1, 1, 'SR', NULL, NULL, NULL),
(50909, '2017-10-20 12:06:29', NULL, NULL, 13947, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:06:29', 'admin-1508461080-15084723892476263', 1, 1, 'SR', NULL, NULL, NULL),
(50910, '2017-10-20 12:06:29', NULL, NULL, 13947, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:06:29', 'admin-1508461080-15084723892476263', 1, 0, '', NULL, NULL, NULL),
(50911, '2017-10-20 12:06:39', NULL, NULL, 13947, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:06:39', 'admin-1508461080-15084723995415844', 1, 0, '', NULL, NULL, NULL),
(50912, '2017-10-20 09:48:18', NULL, NULL, 13940, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 09:48:18', 'admin-1508461080-1508464098166910', 1, 1, 'SR', NULL, NULL, NULL),
(50913, '2017-10-20 09:58:16', NULL, NULL, 13939, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 09:58:16', 'admin-1508461080-1508464696748157', 1, 1, 'SR', NULL, NULL, NULL),
(50914, '2017-10-20 09:58:16', NULL, NULL, 13939, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 09:58:16', 'admin-1508461080-1508464696748157', 1, 1, 'SR', NULL, NULL, NULL),
(50915, '2017-10-20 14:49:19', NULL, NULL, 13960, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 14:49:19', 'admin-1508476012-15084821590681274', 1, 0, '', NULL, NULL, NULL),
(50916, '2017-10-20 11:07:29', NULL, NULL, 13943, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 11:07:29', 'admin-1508461080-15084688488985368', 1, 1, 'SR', NULL, NULL, NULL),
(50917, '2017-10-20 11:07:29', NULL, NULL, 13943, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 11:07:29', 'admin-1508461080-15084688488985368', 1, 1, 'SR', NULL, NULL, NULL),
(50918, '2017-10-20 11:20:41', NULL, NULL, 13944, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 11:20:41', 'admin-1508461080-15084696418064384', 1, 1, 'SR', 1, NULL, '10.0'),
(50919, '2017-10-20 13:54:44', NULL, NULL, 13955, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1508476012', 'admin', '2017-10-20 13:54:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50920, '2017-10-20 00:00:00', NULL, NULL, 13955, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:57:30', 'admin-1508461080-1508475449781738', 1, 0, '', NULL, NULL, NULL),
(50921, '2017-10-20 12:57:30', NULL, NULL, 13951, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:57:30', 'admin-1508461080-1508475449781738', 1, 1, 'SR', NULL, NULL, NULL),
(50922, '2017-10-20 13:06:49', NULL, NULL, 13952, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1508476012', 'admin', '2017-10-20 13:06:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50923, '2017-10-20 13:07:09', NULL, NULL, 13952, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 13:07:09', 'admin-1508476012-15084760295739670', 1, 1, 'SR', NULL, NULL, NULL),
(50924, '2017-10-20 13:07:15', NULL, NULL, 13952, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 13:07:15', 'admin-1508476012-15084760357596579', 1, 1, 'SR', NULL, NULL, NULL),
(50925, '2017-10-20 13:09:09', NULL, NULL, 13950, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 13:09:09', 'admin-1508476012-15084761495354767', 1, 1, 'SR', NULL, NULL, NULL),
(50926, '2017-10-20 13:54:00', NULL, NULL, 13954, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1508476012', 'admin', '2017-10-20 13:54:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50927, '2017-10-20 00:00:00', NULL, NULL, 13954, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 13:10:29', 'admin-1508476012-15084762294566141', 1, 0, '', NULL, NULL, NULL),
(50928, '2017-10-20 12:55:47', NULL, NULL, 13950, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:55:47', 'admin-1508461080-15084753470568339', 1, 1, 'SR', NULL, NULL, NULL),
(50929, '2017-10-20 12:57:12', NULL, NULL, 13951, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.39, 0.0000, 0.0000, 3.39, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:57:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50930, '2017-10-20 11:22:50', NULL, NULL, 13945, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 11:22:50', 'admin-1508461080-15084697705333938', 1, 0, '', NULL, NULL, NULL),
(50931, '2017-10-20 11:22:50', NULL, NULL, 13945, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 11:22:50', 'admin-1508461080-15084697705333938', 1, 1, 'SR', NULL, NULL, NULL),
(50932, '2017-10-20 14:19:19', NULL, NULL, 13958, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 14:19:19', 'admin-1508476012-15084803594048126', 1, 0, '', 1, NULL, NULL),
(50933, '2017-10-20 15:18:26', NULL, NULL, 13961, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 15:18:26', 'admin-1508476012-15084839061451956', 1, 0, '', 1, NULL, NULL),
(50934, '2017-10-20 14:49:39', NULL, NULL, 13960, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 14:49:39', 'admin-1508476012-15084821795316381', 1, 1, 'SR', NULL, NULL, NULL),
(50935, '2017-10-20 14:49:39', NULL, NULL, 13960, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 14:49:39', 'admin-1508476012-15084821795316381', 1, 0, '', NULL, NULL, NULL),
(50936, '2017-10-20 12:54:14', NULL, NULL, 13950, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.00, 0.0000, 0.0000, 10.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:54:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50937, '2017-10-20 13:09:09', NULL, NULL, 13950, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 13:09:09', 'admin-1508476012-15084761495354767', 1, 0, '', NULL, NULL, NULL),
(50938, '2017-10-20 12:55:47', NULL, NULL, 13950, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:55:47', 'admin-1508461080-15084753470568339', 1, 1, 'SR', NULL, NULL, NULL),
(50939, '2017-10-20 12:55:47', NULL, NULL, 13950, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:55:47', 'admin-1508461080-15084753470568339', 1, 0, '', NULL, NULL, NULL),
(50940, '2017-10-20 14:49:19', NULL, NULL, 13960, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 14:49:19', 'admin-1508476012-15084821590681274', 1, 0, '', NULL, NULL, NULL),
(50941, '2017-10-20 14:35:56', NULL, NULL, 13959, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 14:35:56', 'admin-1508476012-15084813563143215', 1, 1, 'SR', NULL, NULL, NULL),
(50942, '2017-10-20 14:35:56', NULL, NULL, 13959, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 14:35:56', 'admin-1508476012-15084813563143215', 1, 0, '', NULL, NULL, NULL),
(50943, '2017-10-20 14:35:56', NULL, NULL, 13959, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 14:35:56', 'admin-1508476012-15084813563143215', 1, 0, '', NULL, NULL, NULL),
(50944, '2017-10-20 14:08:14', NULL, NULL, 13956, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 14:08:14', 'admin-1508476012-15084796947099211', 1, 1, 'SR', NULL, NULL, NULL),
(50945, '2017-10-20 14:08:14', NULL, NULL, 13956, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 14:08:14', 'admin-1508476012-15084796947099211', 1, 1, 'SR', NULL, NULL, NULL),
(50946, '2017-10-20 14:08:14', NULL, NULL, 13956, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 14:08:14', 'admin-1508476012-15084796947099211', 1, 1, 'SR', NULL, NULL, NULL),
(50947, '2017-10-20 13:55:14', NULL, NULL, 13951, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1508476012', 'admin', '2017-10-20 13:55:14', 'admin-1508476012-1508478914783802', 1, 0, '', NULL, NULL, NULL),
(50948, '2017-10-20 14:07:28', NULL, NULL, 13956, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1508476012', 'admin', '2017-10-20 14:07:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50949, '2017-10-20 14:08:14', NULL, NULL, 13956, 0, 72, '72', 'Shimeji Mushroom with Chicken ', 'no rice', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 14:08:14', 'admin-1508476012-15084796947099211', 1, 1, 'SR', NULL, NULL, NULL),
(50950, '2017-10-20 00:00:00', NULL, NULL, 13955, 0, 300, '236', 'Special Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:57:30', 'admin-1508461080-1508475449781738', 1, 0, '', NULL, NULL, NULL),
(50951, '2017-10-20 00:00:00', NULL, NULL, 13954, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 13:10:29', 'admin-1508476012-15084762294566141', 1, 1, 'SR', NULL, NULL, NULL),
(50952, '2017-10-20 13:30:27', NULL, NULL, 13949, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 13:30:27', 'admin-1508476012-15084774274747170', 1, 0, '', NULL, NULL, NULL),
(50953, '2017-10-20 11:02:46', NULL, NULL, 13942, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 11:02:46', 'admin-1508461080-15084685666856476', 1, 1, 'SR', NULL, NULL, NULL),
(50954, '2017-10-20 13:29:09', NULL, NULL, 13950, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 13:29:09', 'admin-1508476012-15084773492767292', 1, 1, 'SR', NULL, NULL, NULL),
(50955, '2017-10-20 12:55:47', NULL, NULL, 13950, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:55:47', 'admin-1508461080-15084753470568339', 1, 1, 'SR', NULL, NULL, NULL),
(50956, '2017-10-20 12:57:29', NULL, NULL, 13951, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:57:29', 'admin-1508461080-1508475449781738', 1, 0, '', NULL, NULL, NULL),
(50957, '2017-10-20 14:49:19', NULL, NULL, 13960, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 14:49:19', 'admin-1508476012-15084821590681274', 1, 0, '', NULL, NULL, NULL),
(50958, '2017-10-20 12:14:27', NULL, NULL, 13948, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:14:27', 'admin-1508461080-15084728669692883', 1, 1, 'SR', NULL, NULL, NULL),
(50959, '2017-10-20 12:14:27', NULL, NULL, 13948, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:14:27', 'admin-1508461080-15084728669692883', 1, 1, 'SR', NULL, NULL, NULL),
(50960, '2017-10-20 12:41:56', NULL, NULL, 13949, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:41:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50961, '2017-10-20 12:42:08', NULL, NULL, 13949, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:42:08', 'admin-1508461080-15084745285254450', 1, 0, '', NULL, NULL, NULL),
(50962, '2017-10-20 12:42:08', NULL, NULL, 13949, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:42:08', 'admin-1508461080-15084745285254450', 1, 1, 'SR', NULL, NULL, NULL),
(50963, '2017-10-20 12:42:08', NULL, NULL, 13949, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:42:08', 'admin-1508461080-15084745285254450', 1, 0, '', NULL, NULL, NULL),
(50964, '2017-10-20 12:42:15', NULL, NULL, 13949, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:42:15', 'admin-1508461080-15084745348873982', 1, 0, '', NULL, NULL, NULL),
(50965, '2017-10-20 10:18:00', NULL, NULL, 13941, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 10:18:00', 'admin-1508461080-15084658799081064', 1, 0, '', NULL, NULL, NULL),
(50966, '2017-10-20 11:02:33', NULL, NULL, 13942, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1508476012', 'admin', '2017-10-20 11:02:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50967, '2017-10-20 12:06:39', NULL, NULL, 13947, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:06:39', 'admin-1508461080-15084723995415844', 1, 1, 'SR', NULL, NULL, NULL),
(50968, '2017-10-20 12:06:39', NULL, NULL, 13947, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:06:39', 'admin-1508461080-15084723995415844', 1, 0, '', NULL, NULL, NULL),
(50969, '2017-10-20 12:14:18', NULL, NULL, 13948, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1508476012', 'admin', '2017-10-20 12:14:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50970, '2017-10-20 11:02:46', NULL, NULL, 13942, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 11:02:46', 'admin-1508461080-15084685666856476', 1, 1, 'SR', NULL, NULL, NULL),
(50971, '2017-10-20 11:22:42', NULL, NULL, 13945, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1508476012', 'admin', '2017-10-20 11:22:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50972, '2017-10-20 11:06:47', NULL, NULL, 13943, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1508476012', 'admin', '2017-10-20 11:06:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50973, '2017-10-20 11:07:29', NULL, NULL, 13943, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 11:07:29', 'admin-1508461080-15084688488985368', 1, 1, 'SR', NULL, NULL, NULL),
(50974, '2017-10-20 11:02:46', NULL, NULL, 13942, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 11:02:46', 'admin-1508461080-15084685666856476', 1, 1, 'SR', NULL, NULL, NULL),
(50975, '2017-10-20 10:18:00', NULL, NULL, 13941, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 10:18:00', 'admin-1508461080-15084658799081064', 1, 1, 'SR', NULL, NULL, NULL),
(50976, '2017-10-20 10:18:00', NULL, NULL, 13941, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 10:18:00', 'admin-1508461080-15084658799081064', 1, 1, 'SR', NULL, NULL, NULL),
(50977, '2017-10-20 10:16:26', NULL, NULL, 13941, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1508476012', 'admin', '2017-10-20 10:16:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50978, '2017-10-20 09:14:03', NULL, NULL, 13939, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 09:14:03', 'admin-1508461080-15084620437625032', 1, 1, 'SR', NULL, NULL, NULL),
(50979, '2017-10-20 09:14:03', NULL, NULL, 13939, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 09:14:03', 'admin-1508461080-15084620437625032', 1, 1, 'SR', NULL, NULL, NULL),
(50980, '2017-10-20 09:48:18', NULL, NULL, 13940, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 09:48:18', 'admin-1508461080-1508464098166910', 1, 1, 'SR', NULL, NULL, NULL),
(50981, '2017-10-20 09:48:13', NULL, NULL, 13940, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1508476012', 'admin', '2017-10-20 09:48:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50982, '2017-10-20 09:14:03', NULL, NULL, 13939, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 09:14:03', 'admin-1508461080-15084620437625032', 1, 0, '', NULL, NULL, NULL),
(50983, '2017-10-20 09:14:03', NULL, NULL, 13939, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508476012', 'admin', '2017-10-20 09:14:03', 'admin-1508461080-15084620437625032', 1, 0, '', NULL, NULL, NULL),
(50984, '2017-10-20 09:13:56', NULL, NULL, 13939, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1508476012', 'admin', '2017-10-20 09:13:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50985, '2017-10-21 11:12:01', NULL, NULL, 13978, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:12:01', 'admin-1508553952-15085555214364777', 1, 0, '', NULL, NULL, NULL),
(50986, '2017-10-21 12:47:07', NULL, NULL, 13987, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 12:47:07', 'admin-1508556031-15085612271492447', 1, 1, 'SR', NULL, NULL, '10.0'),
(50987, '2017-10-21 12:47:07', NULL, NULL, 13987, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 12:47:07', 'admin-1508556031-15085612271492447', 1, 0, '', NULL, NULL, '10.0'),
(50988, '2017-10-21 12:47:07', NULL, NULL, 13987, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 12:47:07', 'admin-1508556031-15085612271492447', 1, 0, '', NULL, NULL, '10.0'),
(50989, '2017-10-21 12:47:07', NULL, NULL, 13987, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 12:47:07', 'admin-1508556031-15085612271492447', 1, 0, '', NULL, NULL, '10.0'),
(50990, '2017-10-21 13:03:54', NULL, NULL, 13989, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1508562284', 'admin', '2017-10-21 13:03:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50991, '2017-10-21 11:16:55', NULL, NULL, 13975, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:16:55', 'admin-1508553952-15085558154564747', 1, 0, '', NULL, NULL, NULL),
(50992, '2017-10-21 14:49:40', NULL, NULL, 13998, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:49:40', 'admin-1508562284-1508568580326669', 1, 1, 'SR', NULL, NULL, NULL),
(50993, '2017-10-21 11:16:55', NULL, NULL, 13975, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:16:55', 'admin-1508553952-15085558154564747', 1, 0, '', NULL, NULL, NULL),
(50994, '2017-10-21 11:17:10', NULL, NULL, 13975, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:17:10', 'admin-1508553952-15085558304228694', 1, 1, 'SR', NULL, NULL, NULL),
(50995, '2017-10-21 11:17:30', NULL, NULL, 13981, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:17:30', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(50996, '2017-10-21 13:04:35', NULL, NULL, 13989, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 13:04:35', 'admin-1508556031-15085622701001010', 1, 1, 'SR', NULL, NULL, NULL),
(50997, '2017-10-21 13:18:16', NULL, NULL, 13990, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.90, 0.0000, 0.0000, 12.90, 1, '27', 1, '1508562284', 'admin', '2017-10-21 13:18:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(50998, '2017-10-21 13:18:24', NULL, NULL, 13990, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 13:18:24', 'admin-1508562284-15085631039857794', 1, 0, '', NULL, NULL, NULL),
(50999, '2017-10-21 13:18:24', NULL, NULL, 13990, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 13:18:24', 'admin-1508562284-15085631039857794', 1, 1, 'SR', NULL, NULL, NULL),
(51000, '2017-10-21 13:04:10', NULL, NULL, 13989, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 13:04:10', 'admin-1508556031-15085622501816157', 1, 0, '', NULL, NULL, NULL),
(51001, '2017-10-21 13:04:35', NULL, NULL, 13989, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 13:04:35', 'admin-1508556031-15085622701001010', 1, 1, 'SR', NULL, NULL, NULL),
(51002, '2017-10-21 15:31:55', NULL, NULL, 14000, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 15:31:55', 'admin-1508562284-15085711148323531', 1, 1, 'SR', NULL, NULL, NULL),
(51003, '2017-10-21 15:41:01', NULL, NULL, 14002, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1508562284', 'admin', '2017-10-21 15:41:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51004, '2017-10-21 15:41:25', NULL, NULL, 14002, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 15:41:25', 'admin-1508562284-15085716848011558', 1, 1, 'SR', NULL, NULL, NULL),
(51005, '2017-10-21 15:48:53', NULL, NULL, 13997, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 15:48:53', 'admin-1508562284-15085721330821875', 1, 0, '', NULL, NULL, NULL),
(51006, '2017-10-21 16:00:05', NULL, NULL, 14003, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1508562284', 'admin', '2017-10-21 16:00:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51007, '2017-10-21 13:18:24', NULL, NULL, 13990, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 13:18:24', 'admin-1508562284-15085631039857794', 1, 1, 'SR', NULL, NULL, NULL),
(51008, '2017-10-21 13:21:23', NULL, NULL, 13990, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 13:21:23', 'admin-1508562284-15085632829884923', 1, 1, 'SR', NULL, NULL, NULL),
(51009, '2017-10-21 13:26:33', NULL, NULL, 13991, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 13:26:33', 'admin-1508562284-15085635930039573', 1, 1, 'SR', 1, NULL, NULL),
(51010, '2017-10-21 14:24:37', NULL, NULL, 13992, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:24:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51011, '2017-10-21 14:25:08', NULL, NULL, 13992, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:25:08', 'admin-1508562284-15085671083709664', 1, 1, 'SR', NULL, NULL, NULL),
(51012, '2017-10-21 11:34:48', NULL, NULL, 13975, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:34:48', 'admin-1508556031-15085568886229281', 1, 0, '', NULL, NULL, NULL),
(51013, '2017-10-21 14:37:29', NULL, NULL, 13995, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:37:29', 'admin-1508562284-15085678490325057', 1, 1, 'SR', NULL, NULL, NULL),
(51014, '2017-10-21 11:12:17', NULL, NULL, 13978, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:12:17', 'admin-1508553952-15085555372256916', 1, 1, 'SR', NULL, NULL, NULL),
(51015, '2017-10-21 11:12:17', NULL, NULL, 13978, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:12:17', 'admin-1508553952-15085555372256916', 1, 0, '', NULL, NULL, NULL),
(51016, '2017-10-21 12:39:32', NULL, NULL, 13981, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 12:39:32', 'admin-1508556031-15085607721132645', 1, 1, 'SR', NULL, NULL, '10.0'),
(51017, '2017-10-21 12:39:32', NULL, NULL, 13981, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 12:39:32', 'admin-1508556031-15085607721132645', 1, 0, '', NULL, NULL, '10.0'),
(51018, '2017-10-21 12:46:38', NULL, NULL, 13987, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.00, 0.0000, 0.0000, 13.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 12:46:38', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(51019, '2017-10-21 11:02:51', NULL, NULL, 13977, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:02:51', 'admin-1508553952-1508554971686333', 1, 0, '', NULL, NULL, NULL),
(51020, '2017-10-21 11:02:51', NULL, NULL, 13977, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:02:51', 'admin-1508553952-1508554971686333', 1, 0, '', NULL, NULL, NULL),
(51021, '2017-10-21 10:49:08', NULL, NULL, 13974, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:49:08', 'admin-1508553952-1508554148190556', 1, 0, '', NULL, NULL, NULL),
(51022, '2017-10-21 10:49:08', NULL, NULL, 13974, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:49:08', 'admin-1508553952-1508554148190556', 1, 0, '', NULL, NULL, NULL),
(51023, '2017-10-21 10:50:14', NULL, NULL, 13974, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:50:14', 'admin-1508553952-1508554213923637', 1, 1, 'SR', NULL, NULL, NULL),
(51024, '2017-10-21 10:50:17', NULL, NULL, 13975, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.40, 0.0000, 0.0000, 15.40, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:50:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51025, '2017-10-21 10:50:25', NULL, NULL, 13975, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:50:25', 'admin-1508553952-15085542249893776', 1, 0, '', NULL, NULL, NULL),
(51026, '2017-10-21 10:50:25', NULL, NULL, 13975, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:50:25', 'admin-1508553952-15085542249893776', 1, 1, 'SR', NULL, NULL, NULL),
(51027, '2017-10-21 10:27:58', NULL, NULL, 13969, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:27:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51028, '2017-10-21 10:28:09', NULL, NULL, 13969, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:28:09', 'admin-1508546067-1508552888933654', 1, 0, '', NULL, NULL, NULL),
(51029, '2017-10-21 10:28:09', NULL, NULL, 13969, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:28:09', 'admin-1508546067-1508552888933654', 1, 0, '', NULL, NULL, NULL),
(51030, '2017-10-21 10:28:17', NULL, NULL, 13969, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:28:17', 'admin-1508546067-15085528975696362', 1, 0, '', NULL, NULL, NULL),
(51031, '2017-10-21 10:30:18', NULL, NULL, 13970, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:30:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51032, '2017-10-21 10:30:25', NULL, NULL, 13970, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:30:25', 'admin-1508546067-15085530257449389', 1, 0, '', NULL, NULL, NULL),
(51033, '2017-10-21 14:46:25', NULL, NULL, 13997, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:46:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51034, '2017-10-21 14:46:37', NULL, NULL, 13997, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:46:37', 'admin-1508562284-15085683975608556', 1, 0, '', NULL, NULL, NULL),
(51035, '2017-10-21 12:47:29', NULL, NULL, 13987, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 12:47:29', 'admin-1508556031-15085612495655672', 1, 1, 'SR', NULL, NULL, '10.0'),
(51036, '2017-10-21 12:47:29', NULL, NULL, 13987, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 12:47:29', 'admin-1508556031-15085612495655672', 1, 1, 'SR', NULL, NULL, '10.0'),
(51037, '2017-10-21 13:20:06', NULL, NULL, 13990, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 13:20:06', 'admin-1508562284-15085632065291381', 1, 1, 'SR', NULL, NULL, NULL),
(51038, '2017-10-21 13:20:06', NULL, NULL, 13990, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 13:20:06', 'admin-1508562284-15085632065291381', 1, 0, '', NULL, NULL, NULL),
(51039, '2017-10-21 09:59:15', NULL, NULL, 13965, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 09:59:15', 'admin-1508546067-15085511547946137', 1, 0, '', NULL, NULL, NULL),
(51040, '2017-10-21 09:59:15', NULL, NULL, 13965, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 09:59:15', 'admin-1508546067-15085511547946137', 1, 0, '', NULL, NULL, NULL),
(51041, '2017-10-21 09:59:15', NULL, NULL, 13965, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 09:59:15', 'admin-1508546067-15085511547946137', 1, 0, '', NULL, NULL, NULL),
(51042, '2017-10-21 13:04:10', NULL, NULL, 13989, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 13:04:10', 'admin-1508556031-15085622501816157', 1, 1, 'SR', NULL, NULL, NULL),
(51043, '2017-10-21 13:04:10', NULL, NULL, 13989, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 13:04:10', 'admin-1508556031-15085622501816157', 1, 0, '', NULL, NULL, NULL),
(51044, '2017-10-21 12:47:29', NULL, NULL, 13987, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 12:47:29', 'admin-1508556031-15085612495655672', 1, 1, 'SR', NULL, NULL, '10.0'),
(51045, '2017-10-21 12:00:40', NULL, NULL, 13986, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1508562284', 'admin', '2017-10-21 12:00:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51046, '2017-10-21 14:25:37', NULL, NULL, 13993, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:25:37', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(51047, '2017-10-21 15:36:52', NULL, NULL, 13995, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 15:36:52', 'admin-1508562284-15085714121934675', 1, 1, 'SR', NULL, NULL, NULL),
(51048, '2017-10-21 10:52:29', NULL, NULL, 13976, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:52:29', 'admin-1508553952-1508554348977810', 1, 0, '', NULL, NULL, NULL),
(51049, '2017-10-21 10:52:29', NULL, NULL, 13976, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:52:29', 'admin-1508553952-1508554348977810', 1, 1, 'SR', NULL, NULL, NULL),
(51050, '2017-10-21 16:00:18', NULL, NULL, 14003, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 16:00:18', 'admin-1508562284-15085728183122746', 1, 1, 'SR', NULL, NULL, NULL),
(51051, '2017-10-21 16:07:38', NULL, NULL, 14004, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1508562284', 'admin', '2017-10-21 16:07:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51052, '2017-10-21 16:07:43', NULL, NULL, 14004, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 16:07:43', 'admin-1508562284-15085732628698996', 1, 1, 'SR', NULL, NULL, NULL),
(51053, '2017-10-21 16:07:43', NULL, NULL, 14004, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 16:07:43', 'admin-1508562284-15085732628698996', 1, 1, 'SR', NULL, NULL, NULL),
(51054, '2017-10-21 16:00:18', NULL, NULL, 14003, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 16:00:18', 'admin-1508562284-15085728183122746', 1, 1, 'SR', NULL, NULL, NULL),
(51055, '2017-10-21 16:00:18', NULL, NULL, 14003, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 3, 12.00, 36.0000, 0.0000, 36.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 16:00:18', 'admin-1508562284-15085728183122746', 1, 1, 'SR', NULL, NULL, NULL),
(51056, '2017-10-21 14:28:16', NULL, NULL, 13994, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:28:16', 'admin-1508562284-15085672967311848', 1, 1, 'SR', NULL, NULL, NULL),
(51057, '2017-10-21 15:34:11', NULL, NULL, 13999, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 15:34:11', 'admin-1508562284-1508571250865176', 1, 1, 'SR', NULL, NULL, NULL),
(51058, '2017-10-21 15:32:11', NULL, NULL, 14001, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 15:32:11', 'admin-1508562284-1508571131341334', 1, 0, '', NULL, NULL, NULL),
(51059, '2017-10-21 15:31:46', NULL, NULL, 14000, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1508562284', 'admin', '2017-10-21 15:31:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51060, '2017-10-21 12:59:33', NULL, NULL, 13988, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1508562284', 'admin', '2017-10-21 12:59:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51061, '2017-10-21 14:48:48', NULL, NULL, 13996, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:48:48', 'admin-1508562284-15085685279506351', 1, 0, '', NULL, NULL, NULL),
(51062, '2017-10-21 14:49:33', NULL, NULL, 13998, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:49:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51063, '2017-10-21 14:49:40', NULL, NULL, 13998, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:49:40', 'admin-1508562284-1508568580326669', 1, 1, 'SR', NULL, NULL, NULL),
(51064, '2017-10-21 15:30:49', NULL, NULL, 13999, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 15:30:49', 'admin-1508562284-15085710488421388', 1, 1, 'SR', NULL, NULL, NULL),
(51065, '2017-10-21 15:30:49', NULL, NULL, 13999, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 15:30:49', 'admin-1508562284-15085710488421388', 1, 1, 'SR', NULL, NULL, NULL),
(51066, '2017-10-21 15:30:38', NULL, NULL, 13999, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1508562284', 'admin', '2017-10-21 15:30:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51067, '2017-10-21 15:30:48', NULL, NULL, 13999, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 15:30:48', 'admin-1508562284-15085710488421388', 1, 0, '', NULL, NULL, NULL),
(51068, '2017-10-21 14:40:50', NULL, NULL, 13996, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:40:50', 'admin-1508562284-15085680499562054', 1, 1, 'SR', NULL, NULL, NULL),
(51069, '2017-10-21 14:40:50', NULL, NULL, 13996, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:40:50', 'admin-1508562284-15085680499562054', 1, 1, 'SR', NULL, NULL, NULL),
(51070, '2017-10-21 14:46:37', NULL, NULL, 13997, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:46:37', 'admin-1508562284-15085683975608556', 1, 1, 'SR', NULL, NULL, NULL),
(51071, '2017-10-21 10:24:20', NULL, NULL, 13967, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:24:20', 'admin-1508546067-15085526605503211', 1, 0, '', NULL, NULL, NULL),
(51072, '2017-10-21 10:24:42', NULL, NULL, 13967, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:24:42', 'admin-1508546067-15085526819421481', 1, 1, 'SR', NULL, NULL, NULL),
(51073, '2017-10-21 10:24:42', NULL, NULL, 13967, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:24:42', 'admin-1508546067-15085526819421481', 1, 1, 'SR', NULL, NULL, NULL),
(51074, '2017-10-21 13:21:23', NULL, NULL, 13990, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 13:21:23', 'admin-1508562284-15085632829884923', 1, 1, 'SR', NULL, NULL, NULL),
(51075, '2017-10-21 12:07:51', NULL, NULL, 13984, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 12:07:51', 'admin-1508556031-15085588714991910', 1, 1, 'SR', NULL, NULL, NULL),
(51076, '2017-10-21 14:46:37', NULL, NULL, 13997, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:46:37', 'admin-1508562284-15085683975608556', 1, 1, 'SR', NULL, NULL, NULL),
(51077, '2017-10-21 14:44:04', NULL, NULL, 13994, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:44:04', 'admin-1508562284-15085682438158245', 1, 0, '', NULL, NULL, NULL),
(51078, '2017-10-21 14:40:50', NULL, NULL, 13996, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:40:50', 'admin-1508562284-15085680499562054', 1, 1, 'SR', NULL, NULL, NULL),
(51079, '2017-10-21 14:40:26', NULL, NULL, 13996, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:40:26', 'admin-1508562284-15085680263165775', 1, 0, '', NULL, NULL, NULL),
(51080, '2017-10-21 14:25:51', NULL, NULL, 13993, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:25:51', 'admin-1508562284-15085671517872974', 1, 1, 'SR', NULL, NULL, NULL),
(51081, '2017-10-21 14:24:53', NULL, NULL, 13992, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:24:53', 'admin-1508562284-15085670932933791', 1, 1, 'SR', NULL, NULL, NULL),
(51082, '2017-10-21 11:13:11', NULL, NULL, 13979, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:13:11', 'admin-1508553952-15085555917386013', 1, 1, 'SR', NULL, NULL, NULL),
(51083, '2017-10-21 11:13:11', NULL, NULL, 13979, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:13:11', 'admin-1508553952-15085555917386013', 1, 1, 'SR', NULL, NULL, NULL),
(51084, '2017-10-21 11:13:05', NULL, NULL, 13979, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:13:05', 'admin-1508553952-15085555856241884', 1, 0, '', NULL, NULL, NULL),
(51085, '2017-10-21 11:13:05', NULL, NULL, 13979, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:13:05', 'admin-1508553952-15085555856241884', 1, 0, '', NULL, NULL, NULL),
(51086, '2017-10-21 11:13:00', NULL, NULL, 13979, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:13:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51087, '2017-10-21 11:12:17', NULL, NULL, 13978, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:12:17', 'admin-1508553952-15085555372256916', 1, 1, 'SR', NULL, NULL, NULL),
(51088, '2017-10-21 11:12:17', NULL, NULL, 13978, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:12:17', 'admin-1508553952-15085555372256916', 1, 1, 'SR', NULL, NULL, NULL),
(51089, '2017-10-21 14:37:21', NULL, NULL, 13995, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:37:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51090, '2017-10-21 14:40:21', NULL, NULL, 13996, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:40:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51091, '2017-10-21 14:28:07', NULL, NULL, 13994, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:28:07', 'admin-1508562284-15085672877789147', 1, 0, '', NULL, NULL, NULL),
(51092, '2017-10-21 14:27:46', NULL, NULL, 13994, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:27:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51093, '2017-10-21 14:28:07', NULL, NULL, 13994, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:28:07', 'admin-1508562284-15085672877789147', 1, 0, '', NULL, NULL, NULL),
(51094, '2017-10-21 14:28:07', NULL, NULL, 13994, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:28:07', 'admin-1508562284-15085672877789147', 1, 0, '', NULL, NULL, NULL),
(51095, '2017-10-21 14:25:51', NULL, NULL, 13993, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:25:51', 'admin-1508562284-15085671517872974', 1, 1, 'SR', NULL, NULL, NULL),
(51096, '2017-10-21 13:27:00', NULL, NULL, 13990, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 13:27:00', 'admin-1508562284-15085636200614873', 1, 1, 'SR', NULL, NULL, NULL),
(51097, '2017-10-21 15:32:08', NULL, NULL, 14001, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 15:32:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51098, '2017-10-21 11:39:02', NULL, NULL, 13984, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:39:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51099, '2017-10-21 11:39:21', NULL, NULL, 13984, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:39:21', 'admin-1508556031-15085571616286561', 1, 0, '', NULL, NULL, NULL),
(51100, '2017-10-21 11:39:21', NULL, NULL, 13984, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:39:21', 'admin-1508556031-15085571616286561', 1, 1, 'SR', NULL, NULL, NULL),
(51101, '2017-10-21 11:39:21', NULL, NULL, 13984, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:39:21', 'admin-1508556031-15085571616286561', 1, 1, 'SR', NULL, NULL, NULL),
(51102, '2017-10-21 11:44:23', NULL, NULL, 13985, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:44:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51103, '2017-10-21 11:44:29', NULL, NULL, 13985, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:44:29', 'admin-1508556031-15085574691549475', 1, 1, 'SR', NULL, NULL, NULL),
(51104, '2017-10-21 11:47:51', NULL, NULL, 13966, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:47:51', 'admin-1508556031-15085576713228259', 1, 0, '', NULL, NULL, NULL),
(51105, '2017-10-21 11:48:37', NULL, NULL, 13966, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:48:37', 'admin-1508556031-1508557717326833', 1, 1, 'SR', NULL, NULL, NULL),
(51106, '2017-10-21 13:21:23', NULL, NULL, 13990, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 13:21:23', 'admin-1508562284-15085632829884923', 1, 1, 'SR', NULL, NULL, NULL),
(51107, '2017-10-21 13:21:11', NULL, NULL, 13990, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 13:21:11', 'admin-1508562284-15085632714284274', 1, 1, 'SR', NULL, NULL, NULL),
(51108, '2017-10-21 10:26:01', NULL, NULL, 13968, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:26:01', 'admin-1508546067-15085527608824463', 1, 0, '', NULL, NULL, NULL),
(51109, '2017-10-21 10:26:01', NULL, NULL, 13968, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:26:01', 'admin-1508546067-15085527608824463', 1, 1, 'SR', NULL, NULL, NULL),
(51110, '2017-10-21 12:47:07', NULL, NULL, 13987, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 12:47:07', 'admin-1508556031-15085612271492447', 1, 1, 'SR', NULL, NULL, '10.0'),
(51111, '2017-10-21 12:35:05', NULL, NULL, 13981, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 12:35:05', 'admin-1508556031-15085605053809626', 1, 1, 'SR', NULL, NULL, '10.0'),
(51112, '2017-10-21 12:07:51', NULL, NULL, 13984, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 12:07:51', 'admin-1508556031-15085588714991910', 1, 0, '', NULL, NULL, NULL),
(51113, '2017-10-21 12:00:49', NULL, NULL, 13986, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 12:00:49', 'admin-1508556031-15085584495136235', 1, 1, 'SR', NULL, NULL, NULL),
(51114, '2017-10-21 11:48:58', NULL, NULL, 13966, 0, 181, '116', 'Open Food ', 'additional salted pork', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:48:58', 'admin-1508556031-15085577378494326', 1, 0, '', NULL, NULL, NULL),
(51115, '2017-10-21 11:03:05', NULL, NULL, 13977, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:03:05', 'admin-1508553952-15085549848768017', 1, 1, 'SR', NULL, NULL, NULL),
(51116, '2017-10-21 11:03:05', NULL, NULL, 13977, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:03:05', 'admin-1508553952-15085549848768017', 1, 1, 'SR', NULL, NULL, NULL),
(51117, '2017-10-21 11:08:39', NULL, NULL, 13975, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:08:39', 'admin-1508553952-15085553191542780', 1, 0, '', NULL, NULL, NULL),
(51118, '2017-10-21 11:20:13', NULL, NULL, 13981, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:20:14', 'admin-1508553952-15085560138282985', 1, 0, '', NULL, NULL, '10.0'),
(51119, '2017-10-21 12:59:40', NULL, NULL, 13988, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 12:59:40', 'admin-1508556031-15085619800426937', 1, 1, 'SR', NULL, NULL, NULL),
(51120, '2017-10-21 00:00:00', NULL, NULL, 13983, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:37:44', 'admin-1508546067-15085534639525682', 1, 0, '', NULL, NULL, NULL),
(51121, '2017-10-21 00:00:00', NULL, NULL, 13982, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:37:44', 'admin-1508546067-15085534639525682', 1, 1, 'SR', NULL, NULL, NULL),
(51122, '2017-10-21 11:12:17', NULL, NULL, 13978, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:12:17', 'admin-1508553952-15085555372256916', 1, 0, '', NULL, NULL, NULL),
(51123, '2017-10-21 11:17:37', NULL, NULL, 13981, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:17:37', 'admin-1508553952-15085558571009612', 1, 0, '', NULL, NULL, '10.0'),
(51124, '2017-10-21 11:01:02', NULL, NULL, 13975, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:01:02', 'admin-1508553952-1508554861811445', 1, 0, '', NULL, NULL, NULL),
(51125, '2017-10-21 11:12:01', NULL, NULL, 13978, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:12:01', 'admin-1508553952-15085555214364777', 1, 0, '', NULL, NULL, NULL),
(51126, '2017-10-21 15:31:55', NULL, NULL, 14000, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 15:31:55', 'admin-1508562284-15085711148323531', 1, 0, '', NULL, NULL, NULL),
(51127, '2017-10-21 11:12:01', NULL, NULL, 13978, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:12:01', 'admin-1508553952-15085555214364777', 1, 0, '', NULL, NULL, NULL),
(51128, '2017-10-21 10:41:11', NULL, NULL, 13972, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:41:11', 'admin-1508546067-1508553671558867', 1, 0, '', NULL, NULL, NULL),
(51129, '2017-10-21 10:24:42', NULL, NULL, 13967, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:24:42', 'admin-1508546067-15085526819421481', 1, 1, 'SR', NULL, NULL, NULL),
(51130, '2017-10-21 10:25:35', NULL, NULL, 13968, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:25:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51131, '2017-10-21 10:26:01', NULL, NULL, 13968, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:26:01', 'admin-1508546067-15085527608824463', 1, 0, '', NULL, NULL, NULL),
(51132, '2017-10-21 11:12:01', NULL, NULL, 13978, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:12:01', 'admin-1508553952-15085555214364777', 1, 0, '', NULL, NULL, NULL),
(51133, '2017-10-21 11:16:55', NULL, NULL, 13975, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:16:55', 'admin-1508553952-15085558154564747', 1, 0, '', NULL, NULL, NULL),
(51134, '2017-10-21 11:09:56', NULL, NULL, 13978, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:09:56', 'admin-1508553952-15085553959352658', 1, 0, '', NULL, NULL, NULL),
(51135, '2017-10-21 11:08:39', NULL, NULL, 13975, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:08:39', 'admin-1508553952-15085553191542780', 1, 0, '', NULL, NULL, NULL),
(51136, '2017-10-21 11:08:39', NULL, NULL, 13975, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:08:39', 'admin-1508553952-15085553191542780', 1, 0, '', NULL, NULL, NULL),
(51137, '2017-10-21 14:46:37', NULL, NULL, 13997, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 14:46:37', 'admin-1508562284-15085683975608556', 1, 1, 'SR', NULL, NULL, NULL),
(51138, '2017-10-21 11:09:52', NULL, NULL, 13978, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.00, 0.0000, 0.0000, 16.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:09:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51139, '2017-10-21 11:03:05', NULL, NULL, 13977, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:03:05', 'admin-1508553952-15085549848768017', 1, 1, 'SR', NULL, NULL, NULL),
(51140, '2017-10-21 11:02:51', NULL, NULL, 13977, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:02:51', 'admin-1508553952-1508554971686333', 1, 0, '', NULL, NULL, NULL),
(51141, '2017-10-21 11:02:33', NULL, NULL, 13977, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:02:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51142, '2017-10-21 10:52:29', NULL, NULL, 13976, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:52:29', 'admin-1508553952-1508554348977810', 1, 1, 'SR', NULL, NULL, NULL),
(51143, '2017-10-21 12:47:29', NULL, NULL, 13987, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 12:47:29', 'admin-1508556031-15085612495655672', 1, 1, 'SR', NULL, NULL, '10.0'),
(51144, '2017-10-21 10:52:29', NULL, NULL, 13976, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:52:29', 'admin-1508553952-1508554348977810', 1, 0, '', NULL, NULL, NULL),
(51145, '2017-10-21 11:12:01', NULL, NULL, 13978, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:12:01', 'admin-1508553952-15085555214364777', 1, 0, '', NULL, NULL, NULL),
(51146, '2017-10-21 10:52:29', NULL, NULL, 13976, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:52:29', 'admin-1508553952-1508554348977810', 1, 1, 'SR', NULL, NULL, NULL),
(51147, '2017-10-21 10:48:53', NULL, NULL, 13974, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:48:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51148, '2017-10-21 09:59:15', NULL, NULL, 13965, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 09:59:15', 'admin-1508546067-15085511547946137', 1, 0, '', NULL, NULL, NULL),
(51149, '2017-10-21 10:19:48', NULL, NULL, 13966, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:19:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51150, '2017-10-21 12:47:29', NULL, NULL, 13987, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 12:47:29', 'admin-1508556031-15085612495655672', 1, 1, 'SR', NULL, NULL, '10.0'),
(51151, '2017-10-21 10:52:29', NULL, NULL, 13976, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:52:29', 'admin-1508553952-1508554348977810', 1, 1, 'SR', NULL, NULL, NULL),
(51152, '2017-10-21 10:52:12', NULL, NULL, 13976, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:52:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51153, '2017-10-21 10:47:19', NULL, NULL, 13973, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:47:19', 'admin-1508553952-1508554039535787', 1, 1, 'SR', NULL, NULL, NULL),
(51154, '2017-10-21 10:47:09', NULL, NULL, 13973, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:47:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51155, '2017-10-21 10:47:19', NULL, NULL, 13973, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:47:19', 'admin-1508553952-1508554039535787', 1, 1, 'SR', NULL, NULL, NULL),
(51156, '2017-10-21 10:30:35', NULL, NULL, 13970, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:30:35', 'admin-1508546067-15085530354895260', 1, 1, 'SR', NULL, NULL, NULL),
(51157, '2017-10-21 10:30:35', NULL, NULL, 13970, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:30:35', 'admin-1508546067-15085530354895260', 1, 1, 'SR', NULL, NULL, NULL),
(51158, '2017-10-21 10:41:11', NULL, NULL, 13972, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:41:11', 'admin-1508546067-1508553671558867', 1, 1, 'SR', NULL, NULL, NULL),
(51159, '2017-10-21 10:41:11', NULL, NULL, 13972, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:41:11', 'admin-1508546067-1508553671558867', 1, 0, '', NULL, NULL, NULL),
(51160, '2017-10-21 10:41:11', NULL, NULL, 13972, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:41:11', 'admin-1508546067-1508553671558867', 1, 0, '', NULL, NULL, NULL),
(51161, '2017-10-21 00:00:00', NULL, NULL, 13983, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, NULL, NULL, 0.80, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:37:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51162, '2017-10-21 10:41:01', NULL, NULL, 13972, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:41:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51163, '2017-10-21 11:22:15', NULL, NULL, 13982, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1508562284', 'admin', '2017-10-21 11:22:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51164, '2017-10-21 09:38:36', NULL, NULL, 13963, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 09:38:36', 'admin-1508546067-1508549915790383', 1, 1, 'SR', NULL, NULL, NULL),
(51165, '2017-10-21 09:38:36', NULL, NULL, 13963, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 09:38:36', 'admin-1508546067-1508549915790383', 1, 0, '', NULL, NULL, NULL),
(51166, '2017-10-21 09:50:28', NULL, NULL, 13964, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1508562284', 'admin', '2017-10-21 09:50:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51167, '2017-10-21 09:50:34', NULL, NULL, 13964, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 09:50:34', 'admin-1508546067-15085506341561640', 1, 1, 'SR', NULL, NULL, NULL),
(51168, '2017-10-21 09:58:53', NULL, NULL, 13965, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1508562284', 'admin', '2017-10-21 09:58:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51169, '2017-10-21 10:26:01', NULL, NULL, 13968, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:26:01', 'admin-1508546067-15085527608824463', 1, 0, '', NULL, NULL, NULL),
(51170, '2017-10-21 10:24:42', NULL, NULL, 13967, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:24:42', 'admin-1508546067-15085526819421481', 1, 1, 'SR', NULL, NULL, NULL),
(51171, '2017-10-21 10:24:12', NULL, NULL, 13967, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:24:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51172, '2017-10-21 10:24:20', NULL, NULL, 13967, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:24:20', 'admin-1508546067-15085526605503211', 1, 0, '', NULL, NULL, NULL),
(51173, '2017-10-21 10:19:51', NULL, NULL, 13966, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:19:51', 'admin-1508546067-1508552391814984', 1, 0, '', NULL, NULL, NULL),
(51174, '2017-10-21 10:19:56', NULL, NULL, 13966, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 10:19:56', 'admin-1508546067-15085523963663515', 1, 1, 'SR', NULL, NULL, NULL),
(51175, '2017-10-21 09:28:13', NULL, NULL, 13962, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 09:28:13', 'admin-1508546067-15085492933648760', 1, 0, '', NULL, NULL, NULL),
(51176, '2017-10-21 09:28:13', NULL, NULL, 13962, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 09:28:13', 'admin-1508546067-15085492933648760', 1, 0, '', NULL, NULL, NULL),
(51177, '2017-10-21 09:28:22', NULL, NULL, 13962, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 09:28:22', 'admin-1508546067-15085493019105561', 1, 1, 'SR', NULL, NULL, NULL),
(51178, '2017-10-21 09:38:21', NULL, NULL, 13963, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1508562284', 'admin', '2017-10-21 09:38:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51179, '2017-10-21 09:38:35', NULL, NULL, 13963, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 09:38:35', 'admin-1508546067-1508549915790383', 1, 0, '', NULL, NULL, NULL),
(51180, '2017-10-21 09:38:35', NULL, NULL, 13963, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508562284', 'admin', '2017-10-21 09:38:36', 'admin-1508546067-1508549915790383', 1, 0, '', NULL, NULL, NULL),
(51181, '2017-10-21 09:28:05', NULL, NULL, 13962, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1508562284', 'admin', '2017-10-21 09:28:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51182, '2017-10-22 10:13:29', NULL, NULL, 14013, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:13:29', 'admin-1508637777-15086384097211196', 1, 0, '', NULL, NULL, NULL),
(51183, '2017-10-22 10:13:29', NULL, NULL, 14013, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:13:29', 'admin-1508637777-15086384097211196', 1, 0, '', NULL, NULL, NULL),
(51184, '2017-10-22 11:45:13', NULL, NULL, 14022, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:45:13', 'admin-1508640114-15086439132741275', 1, 1, 'SR', NULL, NULL, NULL),
(51185, '2017-10-22 11:51:15', NULL, NULL, 14023, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:51:15', 'admin-1508640114-15086442749458658', 1, 1, 'SR', 1, NULL, '10.0'),
(51186, '2017-10-22 11:55:11', NULL, NULL, 14024, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:55:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51187, '2017-10-22 11:55:16', NULL, NULL, 14024, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:55:16', 'admin-1508640114-15086445163674780', 1, 0, '', NULL, NULL, NULL),
(51188, '2017-10-22 11:55:16', NULL, NULL, 14024, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:55:16', 'admin-1508640114-15086445163674780', 1, 0, '', NULL, NULL, NULL),
(51189, '2017-10-22 11:19:58', NULL, NULL, 14020, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:19:58', 'admin-1508640114-15086423981167189', 1, 0, '', NULL, NULL, NULL),
(51190, '2017-10-22 15:36:34', NULL, NULL, 14041, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1508644954', 'admin', '2017-10-22 15:36:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51191, '2017-10-22 11:08:32', NULL, NULL, 14018, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:08:32', 'admin-1508640114-15086417118317065', 1, 0, '', NULL, NULL, NULL),
(51192, '2017-10-22 13:42:31', NULL, NULL, 14031, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:42:31', 'admin-1508644954-15086509517263640', 1, 0, '', NULL, NULL, NULL),
(51193, '2017-10-22 13:42:31', NULL, NULL, 14031, 0, 160, '94', 'Signature Dumpling (5 Pcs)', 'Takeaway', 'Meals', 'Snacks ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:42:31', 'admin-1508644954-15086509517263640', 1, 0, '', NULL, NULL, NULL),
(51194, '2017-10-22 13:45:15', NULL, NULL, 14032, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:45:15', 'admin-1508644954-15086511158051682', 1, 1, 'SR', 1, NULL, '10.0'),
(51195, '2017-10-22 13:45:15', NULL, NULL, 14032, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:45:16', 'admin-1508644954-15086511158051682', 1, 1, 'SR', 1, NULL, '10.0'),
(51196, '2017-10-22 13:45:16', NULL, NULL, 14032, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:45:16', 'admin-1508644954-15086511158051682', 1, 1, 'SR', 1, NULL, '10.0'),
(51197, '2017-10-22 11:20:15', NULL, NULL, 14020, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:20:15', 'admin-1508640114-1508642415363516', 1, 1, 'SR', NULL, NULL, NULL),
(51198, '2017-10-22 11:20:15', NULL, NULL, 14020, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:20:15', 'admin-1508640114-1508642415363516', 1, 1, 'SR', NULL, NULL, NULL),
(51199, '2017-10-22 14:25:12', NULL, NULL, 14036, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:25:12', 'admin-1508644954-15086535117896848', 1, 1, 'SR', NULL, NULL, NULL),
(51200, '2017-10-22 14:25:44', NULL, NULL, 14037, 0, 182, '117', 'Open Drinks ', 'Sodaespresso', 'Cold Drinks', 'Fresh Juice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:25:44', 'admin-1508644954-15086535445135855', 1, 0, '', NULL, NULL, '10.0'),
(51201, '2017-10-22 14:32:05', NULL, NULL, 14036, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:32:05', 'admin-1508644954-15086539250652915', 1, 0, '', NULL, NULL, NULL),
(51202, '2017-10-22 13:42:31', NULL, NULL, 14031, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:42:31', 'admin-1508644954-15086509517263640', 1, 1, 'SR', NULL, NULL, NULL),
(51203, '2017-10-22 14:22:29', NULL, NULL, 14036, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:22:29', 'admin-1508644954-15086533489227347', 1, 1, 'SR', NULL, NULL, NULL),
(51204, '2017-10-22 14:23:53', NULL, NULL, 14037, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:23:53', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(51205, '2017-10-22 14:24:08', NULL, NULL, 14037, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:24:08', 'admin-1508644954-15086534481132180', 1, 1, 'SR', NULL, NULL, '10.0'),
(51206, '2017-10-22 13:28:59', NULL, NULL, 14030, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:28:59', 'admin-1508644954-15086501393591917', 1, 0, '', NULL, NULL, NULL),
(51207, '2017-10-22 13:28:59', NULL, NULL, 14030, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:28:59', 'admin-1508644954-15086501393591917', 1, 0, '', NULL, NULL, NULL),
(51208, '2017-10-22 13:30:42', NULL, NULL, 14030, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:30:42', 'admin-1508644954-15086502424777843', 1, 0, '', NULL, NULL, NULL),
(51209, '2017-10-22 13:28:41', NULL, NULL, 14030, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:28:41', 'admin-1508644954-1508650121244589', 1, 0, '', NULL, NULL, NULL),
(51210, '2017-10-22 12:00:31', NULL, NULL, 14020, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:00:31', 'admin-1508640114-15086448311739128', 1, 1, 'SR', NULL, NULL, NULL),
(51211, '2017-10-22 12:21:18', NULL, NULL, 14020, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:21:18', 'admin-1508644954-1508646078275499', 1, 0, '', NULL, NULL, NULL),
(51212, '2017-10-22 12:21:18', NULL, NULL, 14020, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:21:18', 'admin-1508644954-1508646078275499', 1, 0, '', NULL, NULL, NULL),
(51213, '2017-10-22 11:19:45', NULL, NULL, 14020, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 18.90, 0.0000, 0.0000, 18.90, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:19:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51214, '2017-10-22 11:19:58', NULL, NULL, 14020, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:19:58', 'admin-1508640114-15086423981167189', 1, 0, '', NULL, NULL, NULL),
(51215, '2017-10-22 15:15:03', NULL, NULL, 14040, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 15:15:03', 'admin-1508644954-15086565037429338', 1, 1, 'SR', NULL, NULL, NULL),
(51216, '2017-10-22 11:15:53', NULL, NULL, 14019, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:15:53', 'admin-1508640114-15086421530092299', 1, 0, '', NULL, NULL, NULL),
(51217, '2017-10-22 11:16:04', NULL, NULL, 14019, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:16:04', 'admin-1508640114-1508642164068701', 1, 1, 'SR', NULL, NULL, NULL),
(51218, '2017-10-22 13:06:21', NULL, NULL, 14029, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:06:21', 'admin-1508644954-15086487816509724', 1, 1, 'SR', NULL, NULL, NULL),
(51219, '2017-10-22 11:36:59', NULL, NULL, 14021, 0, 153, '87', 'Wake Me Up!', 'no bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:36:59', 'admin-1508640114-15086434190066222', 1, 0, '', NULL, NULL, NULL),
(51220, '2017-10-22 11:45:05', NULL, NULL, 14022, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:45:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51221, '2017-10-22 11:45:13', NULL, NULL, 14022, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:45:13', 'admin-1508640114-15086439132741275', 1, 0, '', NULL, NULL, NULL),
(51222, '2017-10-22 11:45:13', NULL, NULL, 14022, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:45:13', 'admin-1508640114-15086439132741275', 1, 0, '', NULL, NULL, NULL),
(51223, '2017-10-22 12:53:44', NULL, NULL, 14027, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:53:44', 'admin-1508644954-1508648024054210', 1, 0, '', NULL, NULL, NULL),
(51224, '2017-10-22 15:44:17', NULL, NULL, 14042, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 15:44:17', 'admin-1508644954-1508658257721343', 1, 0, '', NULL, NULL, NULL),
(51225, '2017-10-22 13:45:16', NULL, NULL, 14032, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:45:16', 'admin-1508644954-15086511158051682', 1, 1, 'SR', 1, NULL, '10.0'),
(51226, '2017-10-22 10:23:55', NULL, NULL, 14014, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:23:55', 'admin-1508637777-15086390348628115', 1, 1, 'SR', NULL, NULL, NULL),
(51227, '2017-10-22 10:41:37', NULL, NULL, 14015, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:41:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51228, '2017-10-22 10:11:31', NULL, NULL, 14012, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:11:31', 'admin-1508637777-15086382913632239', 1, 1, 'SR', NULL, NULL, NULL),
(51229, '2017-10-22 10:11:31', NULL, NULL, 14012, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 3, 11.00, 33.0000, 0.0000, 33.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:11:31', 'admin-1508637777-15086382913632239', 1, 0, '', NULL, NULL, NULL),
(51230, '2017-10-22 10:11:31', NULL, NULL, 14012, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:11:31', 'admin-1508637777-15086382913632239', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(51231, '2017-10-22 10:11:31', NULL, NULL, 14012, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:11:31', 'admin-1508637777-15086382913632239', 1, 1, 'SR', NULL, NULL, NULL),
(51232, '2017-10-22 15:14:58', NULL, NULL, 14040, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1508644954', 'admin', '2017-10-22 15:14:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51233, '2017-10-22 15:03:09', NULL, NULL, 14039, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 15:03:09', 'admin-1508644954-15086557896935091', 1, 0, '', NULL, NULL, NULL),
(51234, '2017-10-22 15:02:54', NULL, NULL, 14039, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 15:02:54', 'admin-1508644954-15086557740403628', 1, 1, 'SR', NULL, NULL, NULL),
(51235, '2017-10-22 15:02:32', NULL, NULL, 14039, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1508644954', 'admin', '2017-10-22 15:02:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51236, '2017-10-22 15:02:54', NULL, NULL, 14039, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 15:02:54', 'admin-1508644954-15086557740403628', 1, 0, '', NULL, NULL, NULL),
(51237, '2017-10-22 14:53:46', NULL, NULL, 14038, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:53:46', 'admin-1508644954-1508655226054163', 1, 0, '', NULL, NULL, NULL),
(51238, '2017-10-22 13:47:31', NULL, NULL, 14033, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:47:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51239, '2017-10-22 14:03:51', NULL, NULL, 14034, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:03:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51240, '2017-10-22 14:52:50', NULL, NULL, 14038, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:52:50', 'admin-1508644954-15086551704041891', 1, 1, 'SR', NULL, NULL, NULL),
(51241, '2017-10-22 14:35:29', NULL, NULL, 14036, 0, 222, '156', 'Seasoned Chicken Aglio Olio', 'No chili', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:35:29', 'admin-1508644954-15086541288607494', 1, 0, '', NULL, NULL, NULL),
(51242, '2017-10-22 14:35:29', NULL, NULL, 14036, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:35:29', 'admin-1508644954-15086541288607494', 1, 1, 'SR', NULL, NULL, NULL),
(51243, '2017-10-22 14:52:27', NULL, NULL, 14038, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:52:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51244, '2017-10-22 14:35:29', NULL, NULL, 14036, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:35:29', 'admin-1508644954-15086541288607494', 1, 1, 'SR', NULL, NULL, NULL),
(51245, '2017-10-22 09:34:55', NULL, NULL, 14007, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:34:55', 'admin-1508633280-15086360949242788', 1, 0, '', NULL, NULL, NULL),
(51246, '2017-10-22 09:34:55', NULL, NULL, 14007, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:34:55', 'admin-1508633280-15086360949242788', 1, 0, '', NULL, NULL, NULL),
(51247, '2017-10-22 09:35:32', NULL, NULL, 14007, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:35:32', 'admin-1508633280-15086361322932394', 1, 1, 'SR', NULL, NULL, NULL),
(51248, '2017-10-22 15:57:22', NULL, NULL, 14043, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1508644954', 'admin', '2017-10-22 15:57:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51249, '2017-10-22 14:32:05', NULL, NULL, 14036, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:32:05', 'admin-1508644954-15086539250652915', 1, 0, '', NULL, NULL, NULL),
(51250, '2017-10-22 14:25:12', NULL, NULL, 14036, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:25:12', 'admin-1508644954-15086535117896848', 1, 1, 'SR', NULL, NULL, NULL),
(51251, '2017-10-22 15:57:53', NULL, NULL, 14043, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 15:57:53', 'admin-1508644954-15086590733381588', 1, 1, 'SR', NULL, NULL, NULL),
(51252, '2017-10-22 15:44:17', NULL, NULL, 14042, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 15:44:17', 'admin-1508644954-1508658257721343', 1, 0, '', NULL, NULL, NULL),
(51253, '2017-10-22 15:44:17', NULL, NULL, 14042, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 15:44:17', 'admin-1508644954-1508658257721343', 1, 1, 'SR', NULL, NULL, NULL),
(51254, '2017-10-22 15:44:03', NULL, NULL, 14042, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1508644954', 'admin', '2017-10-22 15:44:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51255, '2017-10-22 14:25:12', NULL, NULL, 14036, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:25:12', 'admin-1508644954-15086535117896848', 1, 1, 'SR', NULL, NULL, NULL),
(51256, '2017-10-22 14:24:08', NULL, NULL, 14037, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:24:08', 'admin-1508644954-15086534481132180', 1, 0, '', NULL, NULL, '10.0'),
(51257, '2017-10-22 10:13:29', NULL, NULL, 14013, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:13:29', 'admin-1508637777-15086384097211196', 1, 0, '', NULL, NULL, NULL),
(51258, '2017-10-22 10:13:43', NULL, NULL, 14013, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:13:43', 'admin-1508637777-15086384235663548', 1, 1, 'SR', NULL, NULL, NULL),
(51259, '2017-10-22 10:13:43', NULL, NULL, 14013, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:13:43', 'admin-1508637777-15086384235663548', 1, 1, 'SR', NULL, NULL, NULL),
(51260, '2017-10-22 15:36:44', NULL, NULL, 14041, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 15:36:44', 'admin-1508644954-15086578043315720', 1, 0, '', NULL, NULL, NULL),
(51261, '2017-10-22 14:22:24', NULL, NULL, 14036, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.80, 0.0000, 0.0000, 11.80, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:22:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51262, '2017-10-22 14:16:23', NULL, NULL, 14030, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:16:23', 'admin-1508644954-15086529829768467', 1, 0, '', NULL, NULL, NULL),
(51263, '2017-10-22 14:10:52', NULL, NULL, 14030, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:10:52', 'admin-1508644954-15086526521141754', 1, 0, '', NULL, NULL, NULL),
(51264, '2017-10-22 14:10:26', NULL, NULL, 14030, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:10:26', 'admin-1508644954-15086526263679530', 1, 0, '', NULL, NULL, NULL),
(51265, '2017-10-22 14:10:26', NULL, NULL, 14030, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:10:26', 'admin-1508644954-15086526263679530', 1, 0, '', NULL, NULL, NULL),
(51266, '2017-10-22 15:29:40', NULL, NULL, 14037, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 15:29:40', 'admin-1508644954-15086573806054430', 1, 1, 'SR', NULL, NULL, '10.0'),
(51267, '2017-10-22 14:10:26', NULL, NULL, 14030, 0, 153, '87', 'Wake Me Up!', 'no baked bean', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:10:26', 'admin-1508644954-15086526263679530', 1, 0, '', NULL, NULL, NULL),
(51268, '2017-10-22 14:04:14', NULL, NULL, 14035, 0, 181, '116', 'Open Food ', 'Americano Set', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:04:14', 'admin-1508644954-1508652253921966', 1, 0, '', 1, NULL, NULL),
(51269, '2017-10-22 00:00:00', NULL, NULL, 14033, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:07:18', 'admin-1508644954-15086488380197728', 1, 0, '', NULL, NULL, NULL),
(51270, '2017-10-22 12:28:12', NULL, NULL, 14025, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:28:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51271, '2017-10-22 11:08:55', NULL, NULL, 14018, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:08:55', 'admin-1508640114-1508641735097923', 1, 1, 'SR', NULL, NULL, NULL),
(51272, '2017-10-22 13:28:41', NULL, NULL, 14030, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:28:41', 'admin-1508644954-1508650121244589', 1, 0, '', NULL, NULL, NULL),
(51273, '2017-10-22 10:43:55', NULL, NULL, 14016, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:43:55', 'admin-1508640114-15086402356796119', 1, 1, 'SR', NULL, NULL, NULL),
(51274, '2017-10-22 10:50:09', NULL, NULL, 14012, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:50:09', 'admin-1508640114-15086406097272291', 1, 0, '', NULL, NULL, NULL),
(51275, '2017-10-22 13:28:59', NULL, NULL, 14030, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:28:59', 'admin-1508644954-15086501393591917', 1, 0, '', NULL, NULL, NULL),
(51276, '2017-10-22 13:28:41', NULL, NULL, 14030, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:28:41', 'admin-1508644954-1508650121244589', 1, 1, 'SR', NULL, NULL, NULL),
(51277, '2017-10-22 13:28:41', NULL, NULL, 14030, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:28:41', 'admin-1508644954-1508650121244589', 1, 0, '', NULL, NULL, NULL),
(51278, '2017-10-22 00:00:00', NULL, NULL, 14033, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:06:36', 'admin-1508644954-15086487961961989', 1, 0, '', NULL, NULL, NULL),
(51279, '2017-10-22 00:00:00', NULL, NULL, 14033, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:07:08', 'admin-1508644954-15086488283846711', 1, 0, '', NULL, NULL, NULL),
(51280, '2017-10-22 09:08:20', NULL, NULL, 14007, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:08:20', 'admin-1508633280-15086344999401471', 1, 0, '', NULL, NULL, NULL),
(51281, '2017-10-22 09:08:20', NULL, NULL, 14007, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:08:20', 'admin-1508633280-15086344999401471', 1, 1, 'SR', NULL, NULL, NULL),
(51282, '2017-10-22 09:08:20', NULL, NULL, 14007, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:08:20', 'admin-1508633280-15086344999401471', 1, 1, 'SR', NULL, NULL, NULL),
(51283, '2017-10-22 09:13:47', NULL, NULL, 14008, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:13:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51284, '2017-10-22 10:53:59', NULL, NULL, 14017, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:53:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51285, '2017-10-22 10:54:04', NULL, NULL, 14017, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:54:04', 'admin-1508640114-15086408444329799', 1, 1, 'SR', NULL, NULL, NULL),
(51286, '2017-10-22 13:28:05', NULL, NULL, 14030, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 17.70, 0.0000, 0.0000, 17.70, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:28:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51287, '2017-10-22 14:03:58', NULL, NULL, 14034, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:03:58', 'admin-1508644954-15086522381911351', 1, 0, '', NULL, NULL, NULL),
(51288, '2017-10-22 13:06:18', NULL, NULL, 14029, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:06:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51289, '2017-10-22 12:54:07', NULL, NULL, 14028, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:54:07', 'admin-1508644954-1508648046710335', 1, 1, 'SR', NULL, NULL, NULL),
(51290, '2017-10-22 12:54:07', NULL, NULL, 14028, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:54:07', 'admin-1508644954-1508648046710335', 1, 1, 'SR', NULL, NULL, NULL),
(51291, '2017-10-22 12:56:15', NULL, NULL, 14028, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:56:15', 'admin-1508644954-15086481751219825', 1, 0, '', NULL, NULL, NULL),
(51292, '2017-10-22 12:54:06', NULL, NULL, 14028, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:54:07', 'admin-1508644954-1508648046710335', 1, 1, 'SR', NULL, NULL, NULL),
(51293, '2017-10-22 12:54:06', NULL, NULL, 14028, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:54:06', 'admin-1508644954-1508648046710335', 1, 0, '', NULL, NULL, NULL),
(51294, '2017-10-22 12:53:46', NULL, NULL, 14028, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.70, 0.0000, 0.0000, 9.70, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:53:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51295, '2017-10-22 12:54:06', NULL, NULL, 14028, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:54:06', 'admin-1508644954-1508648046710335', 1, 0, '', NULL, NULL, NULL),
(51296, '2017-10-22 13:42:11', NULL, NULL, 14031, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:42:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51297, '2017-10-22 12:53:44', NULL, NULL, 14027, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:53:44', 'admin-1508644954-1508648024054210', 1, 1, 'SR', NULL, NULL, NULL),
(51298, '2017-10-22 12:53:44', NULL, NULL, 14027, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:53:44', 'admin-1508644954-1508648024054210', 1, 0, '', NULL, NULL, NULL),
(51299, '2017-10-22 12:53:30', NULL, NULL, 14027, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:53:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51300, '2017-10-22 12:37:46', NULL, NULL, 14026, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:37:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51301, '2017-10-22 12:37:52', NULL, NULL, 14026, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:37:52', 'admin-1508644954-15086470720265145', 1, 1, 'SR', NULL, NULL, NULL),
(51302, '2017-10-22 12:37:52', NULL, NULL, 14026, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:37:52', 'admin-1508644954-15086470720265145', 1, 1, 'SR', NULL, NULL, NULL),
(51303, '2017-10-22 12:28:28', NULL, NULL, 14025, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:28:28', 'admin-1508644954-15086465087348088', 1, 1, 'SR', NULL, NULL, NULL),
(51304, '2017-10-22 12:28:28', NULL, NULL, 14025, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:28:28', 'admin-1508644954-15086465087348088', 1, 1, 'SR', NULL, NULL, NULL),
(51305, '2017-10-22 12:21:27', NULL, NULL, 14020, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:21:27', 'admin-1508644954-1508646087251205', 1, 0, '', NULL, NULL, NULL),
(51306, '2017-10-22 12:21:27', NULL, NULL, 14020, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:21:27', 'admin-1508644954-1508646087251205', 1, 1, 'SR', NULL, NULL, NULL),
(51307, '2017-10-22 12:21:18', NULL, NULL, 14020, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:21:18', 'admin-1508644954-1508646078275499', 1, 0, '', NULL, NULL, NULL),
(51308, '2017-10-22 12:21:18', NULL, NULL, 14020, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:21:18', 'admin-1508644954-1508646078275499', 1, 1, 'SR', NULL, NULL, NULL),
(51309, '2017-10-22 10:23:38', NULL, NULL, 14014, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:23:38', 'admin-1508637777-15086390181859019', 1, 0, '', NULL, NULL, NULL),
(51310, '2017-10-22 10:23:38', NULL, NULL, 14014, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:23:38', 'admin-1508637777-15086390181859019', 1, 0, '', NULL, NULL, NULL),
(51311, '2017-10-22 12:00:31', NULL, NULL, 14020, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:00:31', 'admin-1508640114-15086448311739128', 1, 1, 'SR', NULL, NULL, NULL),
(51312, '2017-10-22 12:00:31', NULL, NULL, 14020, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:00:31', 'admin-1508640114-15086448311739128', 1, 0, '', NULL, NULL, NULL),
(51313, '2017-10-22 11:55:25', NULL, NULL, 14024, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:55:25', 'admin-1508640114-15086445253373452', 1, 1, 'SR', NULL, NULL, NULL),
(51314, '2017-10-22 15:36:44', NULL, NULL, 14041, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 15:36:44', 'admin-1508644954-15086578043315720', 1, 1, 'SR', NULL, NULL, NULL),
(51315, '2017-10-22 10:13:43', NULL, NULL, 14013, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:13:43', 'admin-1508637777-15086384235663548', 1, 0, '', NULL, NULL, NULL),
(51316, '2017-10-22 11:36:34', NULL, NULL, 14021, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:36:34', 'admin-1508640114-15086433944877261', 1, 0, '', NULL, NULL, NULL),
(51317, '2017-10-22 11:36:34', NULL, NULL, 14021, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:36:34', 'admin-1508640114-15086433944877261', 1, 1, 'SR', NULL, NULL, NULL),
(51318, '2017-10-22 11:16:04', NULL, NULL, 14019, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:16:04', 'admin-1508640114-1508642164068701', 1, 1, 'SR', NULL, NULL, NULL),
(51319, '2017-10-22 12:27:39', NULL, NULL, 14020, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 12:27:39', 'admin-1508644954-15086464594725758', 1, 1, 'SR', NULL, NULL, NULL),
(51320, '2017-10-22 11:32:23', NULL, NULL, 14021, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:32:23', 'admin-1508640114-15086431431146734', 1, 0, '', NULL, NULL, NULL),
(51321, '2017-10-22 10:43:50', NULL, NULL, 14016, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:43:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51322, '2017-10-22 10:41:45', NULL, NULL, 14015, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:41:45', 'admin-1508637777-15086401053255582', 1, 0, '', NULL, NULL, NULL),
(51323, '2017-10-22 10:41:45', NULL, NULL, 14015, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:41:45', 'admin-1508637777-15086401053255582', 1, 1, 'SR', NULL, NULL, NULL),
(51324, '2017-10-22 10:02:52', NULL, NULL, 14011, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:02:52', 'admin-1508633280-15086377676919060', 1, 1, 'SR', NULL, NULL, NULL),
(51325, '2017-10-22 10:23:55', NULL, NULL, 14014, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:23:55', 'admin-1508637777-15086390348628115', 1, 1, 'SR', NULL, NULL, NULL),
(51326, '2017-10-22 11:32:09', NULL, NULL, 14021, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:32:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51327, '2017-10-22 11:32:23', NULL, NULL, 14021, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:32:23', 'admin-1508640114-15086431431146734', 1, 0, '', NULL, NULL, NULL),
(51328, '2017-10-22 11:15:48', NULL, NULL, 14019, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:15:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51329, '2017-10-22 11:15:53', NULL, NULL, 14019, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:15:53', 'admin-1508640114-15086421530092299', 1, 0, '', NULL, NULL, NULL),
(51330, '2017-10-22 11:08:55', NULL, NULL, 14018, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:08:55', 'admin-1508640114-1508641735097923', 1, 1, 'SR', NULL, NULL, NULL),
(51331, '2017-10-22 11:08:55', NULL, NULL, 14018, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:08:55', 'admin-1508640114-1508641735097923', 1, 0, '', NULL, NULL, NULL),
(51332, '2017-10-22 11:08:55', NULL, NULL, 14018, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:08:55', 'admin-1508640114-1508641735097923', 1, 1, 'SR', NULL, NULL, NULL),
(51333, '2017-10-22 10:02:28', NULL, NULL, 14011, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:02:28', 'admin-1508633280-15086377485635516', 1, 0, '', NULL, NULL, NULL),
(51334, '2017-10-22 10:02:28', NULL, NULL, 14011, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:02:28', 'admin-1508633280-15086377485635516', 1, 0, '', NULL, NULL, NULL),
(51335, '2017-10-22 09:24:51', NULL, NULL, 14009, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:24:51', 'admin-1508633280-15086354916072516', 1, 0, '', NULL, NULL, NULL),
(51336, '2017-10-22 09:24:59', NULL, NULL, 14009, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:24:59', 'admin-1508633280-15086354988861962', 1, 1, 'SR', NULL, NULL, NULL),
(51337, '2017-10-22 09:26:14', NULL, NULL, 14010, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:26:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51338, '2017-10-22 09:26:52', NULL, NULL, 14010, 0, 153, '87', 'Wake Me Up!', 'no baked bean', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:26:52', 'admin-1508633280-15086356120326516', 1, 0, '', NULL, NULL, NULL),
(51339, '2017-10-22 11:08:32', NULL, NULL, 14018, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:08:32', 'admin-1508640114-15086417118317065', 1, 0, '', NULL, NULL, NULL),
(51340, '2017-10-22 14:52:50', NULL, NULL, 14038, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 14:52:50', 'admin-1508644954-15086551704041891', 1, 1, 'SR', NULL, NULL, NULL),
(51341, '2017-10-22 10:10:43', NULL, NULL, 14012, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:10:43', 'admin-1508637777-15086382430674580', 1, 0, '', NULL, NULL, NULL),
(51342, '2017-10-22 10:10:43', NULL, NULL, 14012, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:10:43', 'admin-1508637777-15086382430674580', 1, 0, '', NULL, NULL, NULL),
(51343, '2017-10-22 10:10:43', NULL, NULL, 14012, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:10:43', 'admin-1508637777-15086382430674580', 1, 0, '', NULL, NULL, NULL),
(51344, '2017-10-22 10:10:43', NULL, NULL, 14012, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:10:43', 'admin-1508637777-15086382430674580', 1, 0, '', NULL, NULL, NULL),
(51345, '2017-10-22 11:08:14', NULL, NULL, 14018, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.10, 0.0000, 0.0000, 11.10, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:08:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51346, '2017-10-22 10:43:55', NULL, NULL, 14016, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:43:55', 'admin-1508640114-15086402356796119', 1, 0, '', NULL, NULL, NULL),
(51347, '2017-10-22 10:41:45', NULL, NULL, 14015, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:41:45', 'admin-1508637777-15086401053255582', 1, 1, 'SR', NULL, NULL, NULL),
(51348, '2017-10-22 13:06:21', NULL, NULL, 14029, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 13:06:21', 'admin-1508644954-15086487816509724', 1, 0, '', NULL, NULL, NULL),
(51349, '2017-10-22 10:11:31', NULL, NULL, 14012, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:11:31', 'admin-1508637777-15086382913632239', 1, 1, 'SR', NULL, NULL, NULL),
(51350, '2017-10-22 10:11:31', NULL, NULL, 14012, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:11:31', 'admin-1508637777-15086382913632239', 1, 1, 'SR', NULL, NULL, NULL),
(51351, '2017-10-22 10:13:19', NULL, NULL, 14013, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:13:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51352, '2017-10-22 10:10:43', NULL, NULL, 14012, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:10:43', 'admin-1508637777-15086382430674580', 1, 0, '', NULL, NULL, NULL),
(51353, '2017-10-22 10:10:43', NULL, NULL, 14012, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:10:43', 'admin-1508637777-15086382430674580', 1, 0, '', NULL, NULL, NULL),
(51354, '2017-10-22 10:23:29', NULL, NULL, 14014, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:23:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51355, '2017-10-22 10:08:48', NULL, NULL, 14012, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 26.20, 0.0000, 0.0000, 26.20, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:08:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51356, '2017-10-22 10:10:43', NULL, NULL, 14012, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:10:43', 'admin-1508637777-15086382430674580', 1, 1, 'SR', NULL, NULL, NULL),
(51357, '2017-10-22 10:10:43', NULL, NULL, 14012, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:10:43', 'admin-1508637777-15086382430674580', 1, 0, '', NULL, NULL, NULL),
(51358, '2017-10-22 10:11:31', NULL, NULL, 14012, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:11:31', 'admin-1508637777-15086382913632239', 1, 1, 'SR', NULL, NULL, NULL),
(51359, '2017-10-22 10:02:52', NULL, NULL, 14011, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:02:52', 'admin-1508633280-15086377676919060', 1, 0, '', NULL, NULL, NULL),
(51360, '2017-10-22 11:08:32', NULL, NULL, 14018, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:08:32', 'admin-1508640114-15086417118317065', 1, 0, '', NULL, NULL, NULL),
(51361, '2017-10-22 10:36:14', NULL, NULL, 14012, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:36:14', 'admin-1508637777-15086397740462021', 1, 0, '', NULL, NULL, NULL),
(51362, '2017-10-22 11:08:32', NULL, NULL, 14018, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 11:08:32', 'admin-1508640114-15086417118317065', 1, 0, '', NULL, NULL, NULL),
(51363, '2017-10-22 09:13:53', NULL, NULL, 14008, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:13:53', 'admin-1508633280-15086348335608830', 1, 0, '', NULL, NULL, NULL),
(51364, '2017-10-22 09:13:53', NULL, NULL, 14008, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:13:53', 'admin-1508633280-15086348335608830', 1, 0, '', NULL, NULL, NULL),
(51365, '2017-10-22 09:14:00', NULL, NULL, 14008, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:14:00', 'admin-1508633280-15086348402454993', 1, 1, 'SR', NULL, NULL, NULL),
(51366, '2017-10-22 09:14:00', NULL, NULL, 14008, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:14:00', 'admin-1508633280-15086348402454993', 1, 1, 'SR', NULL, NULL, NULL),
(51367, '2017-10-22 09:19:32', NULL, NULL, 14007, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:19:32', 'admin-1508633280-15086351721147874', 1, 0, '', NULL, NULL, NULL),
(51368, '2017-10-22 09:24:44', NULL, NULL, 14009, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:24:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51369, '2017-10-22 09:24:51', NULL, NULL, 14009, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:24:51', 'admin-1508633280-15086354916072516', 1, 0, '', NULL, NULL, NULL),
(51370, '2017-10-22 10:02:19', NULL, NULL, 14011, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1508644954', 'admin', '2017-10-22 10:02:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51371, '2017-10-22 09:07:32', NULL, NULL, 14005, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:07:32', 'admin-1508633280-15086344526844924', 1, 0, '', NULL, NULL, NULL),
(51372, '2017-10-22 09:07:32', NULL, NULL, 14005, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:07:32', 'admin-1508633280-15086344526844924', 1, 0, '', NULL, NULL, NULL),
(51373, '2017-10-22 09:07:45', NULL, NULL, 14005, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:07:45', 'admin-1508633280-15086344656802410', 1, 1, 'SR', NULL, NULL, NULL),
(51374, '2017-10-22 09:35:32', NULL, NULL, 14007, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:35:32', 'admin-1508633280-15086361322932394', 1, 1, 'SR', NULL, NULL, NULL),
(51375, '2017-10-22 09:49:31', NULL, NULL, 14009, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:49:31', 'admin-1508633280-15086369712092335', 1, 1, 'SR', NULL, NULL, NULL),
(51376, '2017-10-22 09:26:52', NULL, NULL, 14010, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:26:52', 'admin-1508633280-15086356120326516', 1, 1, 'SR', NULL, NULL, NULL),
(51377, '2017-10-22 09:07:53', NULL, NULL, 14006, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:07:53', 'admin-1508633280-15086344732551143', 1, 0, '', NULL, NULL, NULL),
(51378, '2017-10-22 09:08:20', NULL, NULL, 14007, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:08:20', 'admin-1508633280-15086344999401471', 1, 0, '', NULL, NULL, NULL),
(51379, '2017-10-22 09:07:58', NULL, NULL, 14006, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:07:58', 'admin-1508633280-15086344779336878', 1, 1, 'SR', NULL, NULL, NULL),
(51380, '2017-10-22 09:08:13', NULL, NULL, 14007, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.10, 0.0000, 0.0000, 13.10, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:08:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51381, '2017-10-22 09:07:49', NULL, NULL, 14006, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:07:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51382, '2017-10-22 09:07:45', NULL, NULL, 14005, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:07:45', 'admin-1508633280-15086344656802410', 1, 1, 'SR', NULL, NULL, NULL),
(51383, '2017-10-22 09:07:45', NULL, NULL, 14005, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:07:45', 'admin-1508633280-15086344656802410', 1, 0, '', NULL, NULL, NULL),
(51384, '2017-10-22 09:07:45', NULL, NULL, 14005, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:07:45', 'admin-1508633280-15086344656802410', 1, 1, 'SR', NULL, NULL, NULL),
(51385, '2017-10-22 09:07:45', NULL, NULL, 14005, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:07:45', 'admin-1508633280-15086344656802410', 1, 1, 'SR', NULL, NULL, NULL),
(51386, '2017-10-22 09:07:45', NULL, NULL, 14005, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:07:45', 'admin-1508633280-15086344656802410', 1, 1, 'SR', NULL, NULL, NULL),
(51387, '2017-10-22 09:07:14', NULL, NULL, 14005, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.25, 0.0000, 0.0000, 8.25, 1, '27', 1, '1508644954', 'admin', '2017-10-22 09:07:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51388, '2017-10-23 15:11:47', NULL, NULL, 14062, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 15:11:47', 'admin-1508732585-1508742707272144', 1, 1, 'SR', NULL, NULL, NULL),
(51389, '2017-10-23 16:40:28', NULL, NULL, 14062, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 16:40:28', 'admin-1508732585-1508748028329832', 1, 0, '', NULL, NULL, NULL),
(51390, '2017-10-23 15:09:46', NULL, NULL, 14061, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1508732585', 'admin', '2017-10-23 15:09:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51391, '2017-10-23 15:09:50', NULL, NULL, 14061, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 15:09:50', 'admin-1508732585-1508742590681878', 1, 1, 'SR', NULL, NULL, NULL),
(51392, '2017-10-23 15:09:50', NULL, NULL, 14061, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 15:09:50', 'admin-1508732585-1508742590681878', 1, 1, 'SR', NULL, NULL, NULL),
(51393, '2017-10-23 15:11:43', NULL, NULL, 14062, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1508732585', 'admin', '2017-10-23 15:11:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51394, '2017-10-23 12:15:26', NULL, NULL, 14054, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 12:15:26', 'admin-1508720150-15087321259987433', 1, 1, 'SR', NULL, NULL, NULL),
(51395, '2017-10-23 12:20:17', NULL, NULL, 14052, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 12:20:17', 'admin-1508720150-15087324177167321', 1, 1, 'SR', NULL, NULL, NULL),
(51396, '2017-10-23 12:21:48', NULL, NULL, 14055, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1508732585', 'admin', '2017-10-23 12:21:48', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(51397, '2017-10-23 12:21:58', NULL, NULL, 14055, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 12:21:58', 'admin-1508720150-15087325185451845', 1, 0, '', NULL, NULL, '10.0'),
(51398, '2017-10-23 12:23:27', NULL, NULL, 14055, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 12:23:27', 'admin-1508732585-15087326075898464', 1, 1, 'SR', NULL, NULL, '10.0'),
(51399, '2017-10-23 12:28:59', NULL, NULL, 14055, 0, 181, '116', 'Open Food ', 'cocktail sausage', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 12:28:59', 'admin-1508732585-15087329388808276', 1, 0, '', NULL, NULL, '10.0'),
(51400, '2017-10-23 12:46:44', NULL, NULL, 14054, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 12:46:44', 'admin-1508732585-15087340044216338', 1, 1, 'SR', NULL, NULL, NULL),
(51401, '2017-10-23 11:03:59', NULL, NULL, 14051, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 11:03:59', 'admin-1508720150-1508727839461682', 1, 1, 'SR', 1, NULL, NULL),
(51402, '2017-10-23 11:15:00', NULL, NULL, 14052, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.30, 0.0000, 0.0000, 11.30, 1, '27', 1, '1508732585', 'admin', '2017-10-23 11:15:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51403, '2017-10-23 10:13:37', NULL, NULL, 14047, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1508732585', 'admin', '2017-10-23 10:13:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51404, '2017-10-23 10:40:10', NULL, NULL, 14050, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1508732585', 'admin', '2017-10-23 10:40:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51405, '2017-10-23 10:18:15', NULL, NULL, 14048, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1508732585', 'admin', '2017-10-23 10:18:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51406, '2017-10-23 10:18:18', NULL, NULL, 14048, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 10:18:18', 'admin-1508720150-15087250987144138', 1, 1, 'SR', NULL, NULL, NULL),
(51407, '2017-10-23 14:06:12', NULL, NULL, 14059, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1508732585', 'admin', '2017-10-23 14:06:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51408, '2017-10-23 14:06:53', NULL, NULL, 14059, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 14:06:53', 'admin-1508732585-15087388132944811', 1, 1, 'SR', NULL, NULL, NULL),
(51409, '2017-10-23 12:50:46', NULL, NULL, 14056, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 12:50:46', 'admin-1508732585-15087342465597453', 1, 0, '', NULL, NULL, NULL),
(51410, '2017-10-23 12:50:46', NULL, NULL, 14056, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 12:50:46', 'admin-1508732585-15087342465597453', 1, 0, '', NULL, NULL, NULL),
(51411, '2017-10-23 12:50:46', NULL, NULL, 14056, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 12:50:46', 'admin-1508732585-15087342465597453', 1, 0, '', NULL, NULL, NULL),
(51412, '2017-10-23 13:17:34', NULL, NULL, 14057, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1508732585', 'admin', '2017-10-23 13:17:34', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(51413, '2017-10-23 13:17:56', NULL, NULL, 14057, 0, 298, '234', 'Salted Caramel Machiato', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 13:17:56', 'admin-1508732585-1508735876694892', 1, 0, '', NULL, NULL, '10.0'),
(51414, '2017-10-23 13:18:24', NULL, NULL, 14057, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 13:18:24', 'admin-1508732585-15087359040719468', 1, 1, 'SR', NULL, NULL, '10.0'),
(51415, '2017-10-23 13:27:26', NULL, NULL, 14058, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1508732585', 'admin', '2017-10-23 13:27:26', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(51416, '2017-10-23 13:27:37', NULL, NULL, 14058, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 13:27:37', 'admin-1508732585-15087364569731844', 1, 0, '', NULL, NULL, NULL),
(51417, '2017-10-23 14:06:53', NULL, NULL, 14059, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 14:06:53', 'admin-1508732585-15087388132944811', 1, 1, 'SR', NULL, NULL, NULL),
(51418, '2017-10-23 12:15:16', NULL, NULL, 14054, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 12:15:16', 'admin-1508720150-1508732116791897', 1, 1, 'SR', NULL, NULL, NULL),
(51419, '2017-10-23 14:51:35', NULL, NULL, 14060, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 14:51:35', 'admin-1508732585-15087414954933170', 1, 1, 'SR', NULL, NULL, NULL),
(51420, '2017-10-23 11:45:36', NULL, NULL, 14053, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 11:45:36', 'admin-1508720150-15087303365399042', 1, 0, '', NULL, NULL, NULL),
(51421, '2017-10-23 12:46:44', NULL, NULL, 14054, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 12:46:44', 'admin-1508732585-15087340044216338', 1, 1, 'SR', NULL, NULL, NULL),
(51422, '2017-10-23 09:27:02', NULL, NULL, 14045, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 09:27:02', 'admin-1508720150-15087220223391020', 1, 1, 'SR', NULL, NULL, NULL),
(51423, '2017-10-23 09:27:02', NULL, NULL, 14045, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 09:27:02', 'admin-1508720150-15087220223391020', 1, 0, '', NULL, NULL, NULL),
(51424, '2017-10-23 13:27:37', NULL, NULL, 14058, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 13:27:37', 'admin-1508732585-15087364569731844', 1, 1, 'SR', NULL, NULL, NULL),
(51425, '2017-10-23 14:51:20', NULL, NULL, 14060, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1508732585', 'admin', '2017-10-23 14:51:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51426, '2017-10-23 12:50:20', NULL, NULL, 14056, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1508732585', 'admin', '2017-10-23 12:50:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51427, '2017-10-23 12:15:26', NULL, NULL, 14054, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 12:15:26', 'admin-1508720150-15087321259987433', 1, 1, 'SR', NULL, NULL, NULL),
(51428, '2017-10-23 11:45:53', NULL, NULL, 14053, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 11:45:53', 'admin-1508720150-1508730353148572', 1, 1, 'SR', NULL, NULL, NULL),
(51429, '2017-10-23 12:15:16', NULL, NULL, 14054, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 12:15:16', 'admin-1508720150-1508732116791897', 1, 1, 'SR', NULL, NULL, NULL),
(51430, '2017-10-23 12:09:36', NULL, NULL, 14052, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 12:09:36', 'admin-1508720150-15087317761861824', 1, 1, 'SR', NULL, NULL, NULL),
(51431, '2017-10-23 12:08:57', NULL, NULL, 14054, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1508732585', 'admin', '2017-10-23 12:08:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51432, '2017-10-23 11:47:09', NULL, NULL, 14053, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 11:47:09', 'admin-1508720150-15087304292193548', 1, 0, '', NULL, NULL, NULL),
(51433, '2017-10-23 11:45:53', NULL, NULL, 14053, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 11:45:53', 'admin-1508720150-1508730353148572', 1, 1, 'SR', NULL, NULL, NULL),
(51434, '2017-10-23 11:45:53', NULL, NULL, 14053, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 11:45:53', 'admin-1508720150-1508730353148572', 1, 1, 'SR', NULL, NULL, NULL),
(51435, '2017-10-23 11:45:36', NULL, NULL, 14053, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 11:45:36', 'admin-1508720150-15087303365399042', 1, 0, '', NULL, NULL, NULL),
(51436, '2017-10-23 11:15:15', NULL, NULL, 14052, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 11:15:15', 'admin-1508720150-15087285153587352', 1, 1, 'SR', NULL, NULL, NULL),
(51437, '2017-10-23 11:45:22', NULL, NULL, 14053, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1508732585', 'admin', '2017-10-23 11:45:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51438, '2017-10-23 11:37:41', NULL, NULL, 14052, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 11:37:41', 'admin-1508720150-15087298616784233', 1, 0, '', NULL, NULL, NULL),
(51439, '2017-10-23 11:37:41', NULL, NULL, 14052, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 11:37:41', 'admin-1508720150-15087298616784233', 1, 0, '', NULL, NULL, NULL),
(51440, '2017-10-23 11:19:10', NULL, NULL, 14052, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 11:19:10', 'admin-1508720150-15087287504145916', 1, 1, 'SR', NULL, NULL, NULL),
(51441, '2017-10-23 11:19:10', NULL, NULL, 14052, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 11:19:10', 'admin-1508720150-15087287504145916', 1, 0, '', NULL, NULL, NULL),
(51442, '2017-10-23 11:15:15', NULL, NULL, 14052, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 11:15:15', 'admin-1508720150-15087285153587352', 1, 0, '', NULL, NULL, NULL),
(51443, '2017-10-23 10:56:06', NULL, NULL, 14051, 0, 181, '116', 'Open Food ', 'Freda Special', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 10:56:06', 'admin-1508720150-1508727366123988', 1, 0, '', 1, NULL, NULL),
(51444, '2017-10-23 10:46:29', NULL, NULL, 14050, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 10:46:29', 'admin-1508720150-15087267889453165', 1, 1, 'SR', NULL, NULL, NULL),
(51445, '2017-10-23 10:40:14', NULL, NULL, 14050, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 10:40:14', 'admin-1508720150-15087264139985271', 1, 0, '', NULL, NULL, NULL),
(51446, '2017-10-23 10:16:48', NULL, NULL, 14047, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 10:16:48', 'admin-1508720150-15087250083757010', 1, 1, 'SR', NULL, NULL, NULL),
(51447, '2017-10-23 10:13:44', NULL, NULL, 14047, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 10:13:44', 'admin-1508720150-15087248239124672', 1, 1, 'SR', NULL, NULL, NULL),
(51448, '2017-10-23 10:13:44', NULL, NULL, 14047, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 10:13:44', 'admin-1508720150-15087248239124672', 1, 0, '', NULL, NULL, NULL),
(51449, '2017-10-23 09:27:02', NULL, NULL, 14045, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 09:27:02', 'admin-1508720150-15087220223391020', 1, 1, 'SR', NULL, NULL, NULL),
(51450, '2017-10-23 09:27:02', NULL, NULL, 14045, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 09:27:02', 'admin-1508720150-15087220223391020', 1, 0, '', NULL, NULL, NULL),
(51451, '2017-10-23 09:26:51', NULL, NULL, 14045, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1508732585', 'admin', '2017-10-23 09:26:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51452, '2017-10-23 09:01:38', NULL, NULL, 14044, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 09:01:38', 'admin-1508720150-15087204987469989', 1, 0, '', NULL, NULL, NULL),
(51453, '2017-10-23 09:01:38', NULL, NULL, 14044, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508732585', 'admin', '2017-10-23 09:01:38', 'admin-1508720150-15087204987469989', 1, 0, '', NULL, NULL, NULL),
(51454, '2017-10-23 09:01:19', NULL, NULL, 14044, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1508732585', 'admin', '2017-10-23 09:01:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51455, '2017-10-25 13:05:44', NULL, NULL, 14079, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 13:05:44', 'admin-1508892781-15089079438356493', 1, 1, 'SR', NULL, NULL, NULL),
(51456, '2017-10-25 13:17:44', NULL, NULL, 14080, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1508909330', 'admin', '2017-10-25 13:17:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51457, '2017-10-25 12:58:43', NULL, NULL, 14075, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 12:58:43', 'admin-1508892781-15089075232923934', 1, 0, '', NULL, NULL, NULL),
(51458, '2017-10-25 12:49:23', NULL, NULL, 14075, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 12:49:23', 'admin-1508892781-15089069633322633', 1, 1, 'SR', NULL, NULL, NULL),
(51459, '2017-10-25 12:52:10', NULL, NULL, 14076, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1508909330', 'admin', '2017-10-25 12:52:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51460, '2017-10-25 12:52:24', NULL, NULL, 14076, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 12:52:24', 'admin-1508892781-15089071439962677', 1, 1, 'SR', NULL, NULL, NULL),
(51461, '2017-10-25 16:45:19', NULL, NULL, 14083, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1508909330', 'admin', '2017-10-25 16:45:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51462, '2017-10-25 13:05:44', NULL, NULL, 14079, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 13:05:44', 'admin-1508892781-15089079438356493', 1, 0, '', NULL, NULL, NULL),
(51463, '2017-10-25 11:09:03', NULL, NULL, 14069, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 11:09:03', 'admin-1508892781-15089009429628692', 1, 1, 'SR', NULL, NULL, NULL),
(51464, '2017-10-25 11:42:35', NULL, NULL, 14070, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 11:42:35', 'admin-1508892781-15089029558035552', 1, 0, '', NULL, NULL, NULL),
(51465, '2017-10-25 11:42:35', NULL, NULL, 14070, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 11:42:35', 'admin-1508892781-15089029558035552', 1, 1, 'SR', NULL, NULL, NULL),
(51466, '2017-10-25 11:42:36', NULL, NULL, 14070, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 11:42:36', 'admin-1508892781-15089029558035552', 1, 1, 'SR', NULL, NULL, NULL),
(51467, '2017-10-25 11:46:15', NULL, NULL, 14071, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1508909330', 'admin', '2017-10-25 11:46:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51468, '2017-10-25 11:46:27', NULL, NULL, 14071, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 11:46:27', 'admin-1508892781-15089031873572796', 1, 0, '', NULL, NULL, NULL),
(51469, '2017-10-25 14:10:15', NULL, NULL, 14073, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 14:10:15', 'admin-1508909330-15089118154115730', 1, 1, 'SR', NULL, NULL, NULL),
(51470, '2017-10-25 09:09:22', NULL, NULL, 14064, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 09:09:22', 'admin-1508892781-15088937623481414', 1, 0, '', NULL, NULL, NULL),
(51471, '2017-10-25 09:09:22', NULL, NULL, 14064, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 09:09:22', 'admin-1508892781-15088937623481414', 1, 1, 'SR', NULL, NULL, NULL),
(51472, '2017-10-25 09:09:22', NULL, NULL, 14064, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 09:09:22', 'admin-1508892781-15088937623481414', 1, 0, '', NULL, NULL, NULL),
(51473, '2017-10-25 13:28:59', NULL, NULL, 14075, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 13:28:59', 'admin-1508909330-15089093396196868', 1, 0, '', NULL, NULL, NULL),
(51474, '2017-10-25 12:55:15', NULL, NULL, 14078, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Rice', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 12:55:15', 'admin-1508892781-15089073152802649', 1, 0, '', NULL, NULL, '10.0'),
(51475, '2017-10-25 12:55:15', NULL, NULL, 14078, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 12:55:15', 'admin-1508892781-15089073152802649', 1, 0, '', NULL, NULL, '10.0'),
(51476, '2017-10-25 12:55:15', NULL, NULL, 14078, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 12:55:15', 'admin-1508892781-15089073152802649', 1, 0, '', NULL, NULL, '10.0'),
(51477, '2017-10-25 09:08:58', NULL, NULL, 14064, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 09:08:58', 'admin-1508892781-15088937381766566', 1, 0, '', NULL, NULL, NULL),
(51478, '2017-10-25 09:09:22', NULL, NULL, 14064, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 09:09:22', 'admin-1508892781-15088937623481414', 1, 1, 'SR', NULL, NULL, NULL),
(51479, '2017-10-25 12:55:00', NULL, NULL, 14078, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1508909330', 'admin', '2017-10-25 12:55:00', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(51480, '2017-10-25 11:00:34', NULL, NULL, 14068, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 11:00:34', 'admin-1508892781-15089004346113935', 1, 0, '', NULL, NULL, NULL),
(51481, '2017-10-25 11:42:35', NULL, NULL, 14070, 0, 271, '205', 'Take It Easy', 'add bacon', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 11:42:35', 'admin-1508892781-15089029558035552', 1, 0, '', NULL, NULL, NULL),
(51482, '2017-10-25 13:18:19', NULL, NULL, 14080, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 13:18:19', 'admin-1508892781-1508908699741413', 1, 0, '', NULL, NULL, NULL),
(51483, '2017-10-25 13:18:19', NULL, NULL, 14080, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 13:18:19', 'admin-1508892781-1508908699741413', 1, 0, '', NULL, NULL, NULL),
(51484, '2017-10-25 13:20:59', NULL, NULL, 14080, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 13:20:59', 'admin-1508892781-15089088596482232', 1, 0, '', NULL, NULL, NULL),
(51485, '2017-10-25 13:21:15', NULL, NULL, 14081, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.29, 0.0000, 0.0000, 5.29, 1, '27', 1, '1508909330', 'admin', '2017-10-25 13:21:15', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(51486, '2017-10-25 13:21:30', NULL, NULL, 14081, 0, 73, '73', 'Marmite Chicken ', 'Pasta', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 13:21:30', 'admin-1508892781-15089088900809077', 1, 1, 'SR', NULL, NULL, '10.0'),
(51487, '2017-10-25 11:49:17', NULL, NULL, 14072, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 11:49:17', 'admin-1508892781-15089033577038518', 1, 1, 'SR', NULL, NULL, NULL),
(51488, '2017-10-25 12:45:44', NULL, NULL, 14073, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1508909330', 'admin', '2017-10-25 12:45:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51489, '2017-10-25 12:45:51', NULL, NULL, 14073, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 12:45:51', 'admin-1508892781-15089067514215464', 1, 1, 'SR', NULL, NULL, NULL),
(51490, '2017-10-25 12:48:53', NULL, NULL, 14074, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1508909330', 'admin', '2017-10-25 12:48:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51491, '2017-10-25 12:48:57', NULL, NULL, 14074, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 12:48:57', 'admin-1508892781-15089069375904512', 1, 0, '', NULL, NULL, NULL),
(51492, '2017-10-25 12:49:13', NULL, NULL, 14075, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 12:49:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51493, '2017-10-25 11:49:09', NULL, NULL, 14072, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1508909330', 'admin', '2017-10-25 11:49:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51494, '2017-10-25 11:49:17', NULL, NULL, 14072, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 11:49:17', 'admin-1508892781-15089033577038518', 1, 1, 'SR', NULL, NULL, NULL),
(51495, '2017-10-25 13:22:43', NULL, NULL, 14077, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 13:22:43', 'admin-1508892781-15089089633643168', 1, 1, 'SR', NULL, NULL, NULL),
(51496, '2017-10-25 13:23:58', NULL, NULL, 14078, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 13:23:58', 'admin-1508892781-1508909037971876', 1, 1, 'SR', NULL, NULL, '10.0'),
(51497, '2017-10-25 13:26:03', NULL, NULL, 14081, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 13:26:03', 'admin-1508892781-15089091636253023', 1, 1, 'SR', NULL, NULL, '10.0'),
(51498, '2017-10-25 12:54:58', NULL, NULL, 14077, 0, 181, '116', 'Open Food ', 'Fried dumpling', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 12:54:58', 'admin-1508892781-15089072980886038', 1, 0, '', NULL, NULL, NULL),
(51499, '2017-10-25 11:07:07', NULL, NULL, 14069, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 11:07:07', 'admin-1508892781-15089008270461060', 1, 0, '', NULL, NULL, NULL),
(51500, '2017-10-25 17:09:11', NULL, NULL, 14085, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 17:09:11', 'admin-1508909330-15089225511263775', 1, 0, '', NULL, NULL, NULL),
(51501, '2017-10-25 17:09:07', NULL, NULL, 14085, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1508909330', 'admin', '2017-10-25 17:09:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51502, '2017-10-25 16:46:38', NULL, NULL, 14084, 0, 301, '237', 'Black Bomb', '', 'Cold Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 16:46:38', 'admin-1508909330-15089211981659130', 1, 0, '', NULL, NULL, NULL),
(51503, '2017-10-25 16:45:31', NULL, NULL, 14084, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 16:45:31', 'admin-1508909330-15089211310843124', 1, 0, '', NULL, NULL, NULL),
(51504, '2017-10-25 16:45:25', NULL, NULL, 14084, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1508909330', 'admin', '2017-10-25 16:45:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51505, '2017-10-25 16:45:23', NULL, NULL, 14083, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 16:45:23', 'admin-1508909330-15089211230454371', 1, 1, 'SR', NULL, NULL, NULL),
(51506, '2017-10-25 13:40:36', NULL, NULL, 14082, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1508909330', 'admin', '2017-10-25 13:40:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51507, '2017-10-25 14:03:44', NULL, NULL, 14081, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1508909330', 'admin', '2017-10-25 14:03:44', 'admin-1508909330-15089114243629974', 1, 0, '', NULL, NULL, '10.0'),
(51508, '2017-10-25 13:40:48', NULL, NULL, 14082, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 13:40:48', 'admin-1508909330-15089100485439980', 1, 0, '', NULL, NULL, NULL),
(51509, '2017-10-25 13:40:44', NULL, NULL, 14082, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 13:40:44', 'admin-1508909330-15089100442905980', 1, 0, '', NULL, NULL, NULL),
(51510, '2017-10-25 13:37:43', NULL, NULL, 14078, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 13:37:43', 'admin-1508909330-15089098633182466', 1, 1, 'SR', NULL, NULL, '10.0'),
(51511, '2017-10-25 13:26:03', NULL, NULL, 14081, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 13:26:03', 'admin-1508892781-15089091636253023', 1, 0, '', NULL, NULL, '10.0'),
(51512, '2017-10-25 13:21:30', NULL, NULL, 14081, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 13:21:30', 'admin-1508892781-15089088900809077', 1, 1, 'SR', NULL, NULL, '10.0'),
(51513, '2017-10-25 09:08:58', NULL, NULL, 14064, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 09:08:58', 'admin-1508892781-15088937381766566', 1, 0, '', NULL, NULL, NULL),
(51514, '2017-10-25 13:17:56', NULL, NULL, 14080, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 13:17:56', 'admin-1508892781-15089086766126791', 1, 1, 'SR', NULL, NULL, NULL),
(51515, '2017-10-25 13:17:56', NULL, NULL, 14080, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 13:17:56', 'admin-1508892781-15089086766126791', 1, 0, '', NULL, NULL, NULL),
(51516, '2017-10-25 12:59:32', NULL, NULL, 14077, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 12:59:32', 'admin-1508892781-1508907572770682', 1, 0, '', NULL, NULL, NULL),
(51517, '2017-10-25 12:54:58', NULL, NULL, 14077, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 12:54:58', 'admin-1508892781-15089072980886038', 1, 1, 'SR', NULL, NULL, NULL),
(51518, '2017-10-25 12:54:34', NULL, NULL, 14077, 0, 181, '116', 'Open Food ', 'Garlic Fried Rice', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 12:54:34', 'admin-1508892781-1508907274060987', 1, 0, '', NULL, NULL, NULL),
(51519, '2017-10-25 12:54:10', NULL, NULL, 14077, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1508909330', 'admin', '2017-10-25 12:54:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51520, '2017-10-25 12:54:03', NULL, NULL, 14076, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 12:54:03', 'admin-1508892781-15089072430704563', 1, 1, 'SR', NULL, NULL, NULL),
(51521, '2017-10-25 12:52:24', NULL, NULL, 14076, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 12:52:24', 'admin-1508892781-15089071439962677', 1, 1, 'SR', NULL, NULL, NULL),
(51522, '2017-10-25 13:05:31', NULL, NULL, 14079, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1508909330', 'admin', '2017-10-25 13:05:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51523, '2017-10-25 10:12:57', NULL, NULL, 14066, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 10:12:57', 'admin-1508892781-15088975769843766', 1, 0, '', NULL, NULL, NULL),
(51524, '2017-10-25 11:46:27', NULL, NULL, 14071, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 11:46:27', 'admin-1508892781-15089031873572796', 1, 1, 'SR', NULL, NULL, NULL),
(51525, '2017-10-25 11:07:02', NULL, NULL, 14069, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1508909330', 'admin', '2017-10-25 11:07:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51526, '2017-10-25 11:42:03', NULL, NULL, 14070, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1508909330', 'admin', '2017-10-25 11:42:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51527, '2017-10-25 11:00:34', NULL, NULL, 14068, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 11:00:34', 'admin-1508892781-15089004346113935', 1, 1, 'SR', NULL, NULL, NULL),
(51528, '2017-10-25 11:00:17', NULL, NULL, 14068, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1508909330', 'admin', '2017-10-25 11:00:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51529, '2017-10-25 10:15:39', NULL, NULL, 14067, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 10:15:39', 'admin-1508892781-15088977396286442', 1, 0, '', NULL, NULL, NULL),
(51530, '2017-10-25 10:35:33', NULL, NULL, 14067, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 10:35:33', 'admin-1508892781-15088989335574751', 1, 1, 'SR', NULL, NULL, NULL),
(51531, '2017-10-25 10:15:34', NULL, NULL, 14067, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1508909330', 'admin', '2017-10-25 10:15:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51532, '2017-10-25 09:09:22', NULL, NULL, 14064, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 09:09:22', 'admin-1508892781-15088937623481414', 1, 1, 'SR', NULL, NULL, NULL),
(51533, '2017-10-25 10:12:57', NULL, NULL, 14066, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 10:12:57', 'admin-1508892781-15088975769843766', 1, 0, '', NULL, NULL, NULL),
(51534, '2017-10-25 10:12:41', NULL, NULL, 14066, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1508909330', 'admin', '2017-10-25 10:12:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51535, '2017-10-25 09:58:41', NULL, NULL, 14065, 0, 181, '116', 'Open Food ', 'Pancake ice cream', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 09:58:41', 'admin-1508892781-15088967215433299', 1, 0, '', NULL, NULL, NULL),
(51536, '2017-10-25 09:21:36', NULL, NULL, 14065, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 09:21:36', 'admin-1508892781-15088944962167975', 1, 0, '', NULL, NULL, NULL),
(51537, '2017-10-25 09:11:48', NULL, NULL, 14065, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 09:11:48', 'admin-1508892781-15088939083024611', 1, 0, '', NULL, NULL, NULL),
(51538, '2017-10-25 09:11:48', NULL, NULL, 14065, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 09:11:48', 'admin-1508892781-15088939083024611', 1, 0, '', NULL, NULL, NULL),
(51539, '2017-10-25 09:11:42', NULL, NULL, 14065, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1508909330', 'admin', '2017-10-25 09:11:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51540, '2017-10-25 09:09:22', NULL, NULL, 14064, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 09:09:22', 'admin-1508892781-15088937623481414', 1, 1, 'SR', NULL, NULL, NULL),
(51541, '2017-10-25 09:08:58', NULL, NULL, 14064, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 09:08:58', 'admin-1508892781-15088937381766566', 1, 1, 'SR', NULL, NULL, NULL),
(51542, '2017-10-25 09:08:58', NULL, NULL, 14064, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 09:08:58', 'admin-1508892781-15088937381766566', 1, 0, '', NULL, NULL, NULL),
(51543, '2017-10-25 09:08:58', NULL, NULL, 14064, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 09:08:58', 'admin-1508892781-15088937381766566', 1, 0, '', NULL, NULL, NULL),
(51544, '2017-10-25 09:08:58', NULL, NULL, 14064, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 09:08:58', 'admin-1508892781-15088937381766566', 1, 0, '', NULL, NULL, NULL),
(51545, '2017-10-25 09:02:01', NULL, NULL, 14063, 0, 181, '116', 'Open Food ', 'junior blt', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 09:02:01', 'admin-1508892781-1508893321713790', 1, 0, '', NULL, NULL, NULL),
(51546, '2017-10-25 09:08:34', NULL, NULL, 14064, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 17.30, 0.0000, 0.0000, 17.30, 1, '27', 1, '1508909330', 'admin', '2017-10-25 09:08:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51547, '2017-10-25 09:02:47', NULL, NULL, 14063, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508909330', 'admin', '2017-10-25 09:02:47', 'admin-1508892781-1508893367213247', 1, 1, 'SR', NULL, NULL, NULL),
(51548, '2017-10-25 09:01:43', NULL, NULL, 14063, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1508909330', 'admin', '2017-10-25 09:01:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51549, '2017-10-26 15:49:55', NULL, NULL, 14105, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 15:49:55', 'admin-1508993224-15090041949102231', 1, 1, 'SR', NULL, NULL, NULL),
(51550, '2017-10-26 15:49:55', NULL, NULL, 14105, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 15:49:55', 'admin-1508993224-15090041949102231', 1, 1, 'SR', NULL, NULL, NULL),
(51551, '2017-10-26 12:39:56', NULL, NULL, 14094, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:39:56', 'admin-1508978592-15089927958732164', 1, 0, '', NULL, NULL, NULL),
(51552, '2017-10-26 12:46:12', NULL, NULL, 14095, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:46:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51553, '2017-10-26 12:46:42', NULL, NULL, 14095, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:46:42', 'admin-1508978592-1508993202489888', 1, 0, '', NULL, NULL, NULL),
(51554, '2017-10-26 12:46:42', NULL, NULL, 14095, 0, 223, '226', 'Smoked Duck Aglio Olio', 'more garlic', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:46:42', 'admin-1508978592-1508993202489888', 1, 0, '', NULL, NULL, NULL),
(51555, '2017-10-26 14:56:37', NULL, NULL, 14104, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1508993224', 'admin', '2017-10-26 14:56:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51556, '2017-10-26 12:36:23', NULL, NULL, 14094, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:36:23', 'admin-1508978592-15089925831888040', 1, 0, '', NULL, NULL, NULL),
(51557, '2017-10-26 14:06:11', NULL, NULL, 14101, 0, 192, '127', 'Flaming Hot & Spicy Pork', 'ah mo spicy,no garlic', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 14:06:11', 'admin-1508993224-15089979708972630', 1, 0, '', NULL, NULL, NULL),
(51558, '2017-10-26 14:06:11', NULL, NULL, 14101, 0, 215, '149', 'Thai Fish Sauce Garlic Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 14:06:11', 'admin-1508993224-15089979708972630', 1, 0, '', NULL, NULL, NULL),
(51559, '2017-10-26 14:06:11', NULL, NULL, 14101, 0, 215, '149', 'Thai Fish Sauce Garlic Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 14:06:11', 'admin-1508993224-15089979708972630', 1, 0, '', NULL, NULL, NULL),
(51560, '2017-10-26 14:06:11', NULL, NULL, 14101, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 14:06:11', 'admin-1508993224-15089979708972630', 1, 0, '', NULL, NULL, NULL),
(51561, '2017-10-26 14:06:11', NULL, NULL, 14101, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 14:06:11', 'admin-1508993224-15089979708972630', 1, 1, 'SR', NULL, NULL, NULL),
(51562, '2017-10-26 14:06:11', NULL, NULL, 14101, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 14:06:11', 'admin-1508993224-15089979708972630', 1, 1, 'SR', NULL, NULL, NULL),
(51563, '2017-10-26 14:06:11', NULL, NULL, 14101, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 14:06:11', 'admin-1508993224-15089979708972630', 1, 0, '', NULL, NULL, NULL),
(51564, '2017-10-26 13:13:14', NULL, NULL, 14098, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 13:13:14', 'admin-1508993224-15089947940943777', 1, 0, '', NULL, NULL, NULL),
(51565, '2017-10-26 10:57:06', NULL, NULL, 14091, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 10:57:06', 'admin-1508978592-15089866265849283', 1, 0, '', NULL, NULL, NULL),
(51566, '2017-10-26 10:57:06', NULL, NULL, 14091, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 10:57:06', 'admin-1508978592-15089866265849283', 1, 0, '', NULL, NULL, NULL),
(51567, '2017-10-26 10:57:06', NULL, NULL, 14091, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 10:57:06', 'admin-1508978592-15089866265849283', 1, 0, '', NULL, NULL, NULL),
(51568, '2017-10-26 13:39:04', NULL, NULL, 14099, 0, 181, '116', 'Open Food ', '1 bowl of soup', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 13:39:04', 'admin-1508993224-15089963442938224', 1, 0, '', NULL, NULL, NULL),
(51569, '2017-10-26 12:54:36', NULL, NULL, 14097, 0, 181, '116', 'Open Food ', 'garlic fried rice', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:54:36', 'admin-1508993224-15089936766284668', 1, 0, '', NULL, NULL, '10.0'),
(51570, '2017-10-26 13:10:29', NULL, NULL, 14098, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1508993224', 'admin', '2017-10-26 13:10:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51571, '2017-10-26 15:44:53', NULL, NULL, 14107, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 15:44:53', 'admin-1508993224-15090038936199068', 1, 0, '', NULL, NULL, NULL),
(51572, '2017-10-26 15:44:53', NULL, NULL, 14107, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 15:44:53', 'admin-1508993224-15090038936199068', 1, 1, 'SR', NULL, NULL, NULL),
(51573, '2017-10-26 09:48:44', NULL, NULL, 14086, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 09:48:44', 'admin-1508978592-15089825247676096', 1, 0, '', NULL, NULL, NULL),
(51574, '2017-10-26 09:48:45', NULL, NULL, 14086, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 09:48:45', 'admin-1508978592-15089825247676096', 1, 1, 'SR', NULL, NULL, NULL),
(51575, '2017-10-26 13:16:09', NULL, NULL, 14095, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 13:16:09', 'admin-1508993224-15089949697316824', 1, 1, 'SR', NULL, NULL, NULL),
(51576, '2017-10-26 13:20:37', NULL, NULL, 14099, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1508993224', 'admin', '2017-10-26 13:20:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51577, '2017-10-26 11:52:57', NULL, NULL, 14092, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 11:52:57', 'admin-1508978592-15089899775092246', 1, 0, '', NULL, NULL, NULL),
(51578, '2017-10-26 15:44:53', NULL, NULL, 14107, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 15:44:53', 'admin-1508993224-15090038936199068', 1, 0, '', NULL, NULL, NULL),
(51579, '2017-10-26 15:44:36', NULL, NULL, 14107, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1508993224', 'admin', '2017-10-26 15:44:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51580, '2017-10-26 15:42:55', NULL, NULL, 14106, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 15:42:55', 'admin-1508993224-15090037755717450', 1, 1, 'SR', NULL, NULL, NULL),
(51581, '2017-10-26 14:56:41', NULL, NULL, 14104, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 14:56:41', 'admin-1508993224-15090010014722639', 1, 1, 'SR', NULL, NULL, NULL),
(51582, '2017-10-26 15:03:12', NULL, NULL, 14104, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 15:03:12', 'admin-1508993224-15090013927169426', 1, 0, '', NULL, NULL, NULL),
(51583, '2017-10-26 15:17:34', NULL, NULL, 14105, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 15:17:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51584, '2017-10-26 15:17:40', NULL, NULL, 14105, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 15:17:40', 'admin-1508993224-15090022603622547', 1, 1, 'SR', NULL, NULL, NULL),
(51585, '2017-10-26 15:17:40', NULL, NULL, 14105, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 15:17:40', 'admin-1508993224-15090022603622547', 1, 1, 'SR', NULL, NULL, NULL),
(51586, '2017-10-26 15:42:49', NULL, NULL, 14106, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1508993224', 'admin', '2017-10-26 15:42:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51587, '2017-10-26 12:50:20', NULL, NULL, 14097, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.55, 0.0000, 0.0000, 4.55, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:50:20', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(51588, '2017-10-26 12:47:16', NULL, NULL, 14096, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:47:16', 'admin-1508993224-15089932362411580', 1, 1, 'SR', NULL, NULL, NULL),
(51589, '2017-10-26 14:06:19', NULL, NULL, 14101, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 14:06:19', 'admin-1508993224-1508997979368104', 1, 0, '', NULL, NULL, NULL),
(51590, '2017-10-26 14:18:47', NULL, NULL, 14102, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 14:18:47', 'admin-1508993224-15089987277324623', 1, 0, '', 1, NULL, NULL),
(51591, '2017-10-26 11:51:36', NULL, NULL, 14092, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1508993224', 'admin', '2017-10-26 11:51:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51592, '2017-10-26 12:27:30', NULL, NULL, 14093, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:27:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51593, '2017-10-26 11:51:48', NULL, NULL, 14092, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 11:51:48', 'admin-1508978592-15089899080182011', 1, 0, '', NULL, NULL, NULL),
(51594, '2017-10-26 14:29:54', NULL, NULL, 14103, 0, 301, '237', 'Black Jack', '', 'Cold Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 14:29:54', 'admin-1508993224-15089993947523955', 1, 0, '', 1, NULL, NULL),
(51595, '2017-10-26 12:27:49', NULL, NULL, 14093, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:27:49', 'admin-1508978592-15089920687484510', 1, 1, 'SR', NULL, NULL, NULL),
(51596, '2017-10-26 12:36:07', NULL, NULL, 14094, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 18.00, 0.0000, 0.0000, 18.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:36:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51597, '2017-10-26 13:47:52', NULL, NULL, 14097, 0, 181, '116', 'Open Food ', 'Fried egg', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1508993224', 'admin', '2017-10-26 13:47:52', 'admin-1508993224-15089968724562662', 1, 0, '', NULL, NULL, '10.0'),
(51598, '2017-10-26 12:51:05', NULL, NULL, 14097, 0, 75, '75', 'Meatless Aglio Olio ', 'less spicy', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:51:05', 'admin-1508993224-1508993465302551', 1, 0, '', NULL, NULL, '10.0'),
(51599, '2017-10-26 12:27:35', NULL, NULL, 14093, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:27:35', 'admin-1508978592-15089920550206577', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(51600, '2017-10-26 12:27:48', NULL, NULL, 14093, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:27:48', 'admin-1508978592-15089920687484510', 1, 0, '', NULL, NULL, NULL),
(51601, '2017-10-26 12:27:48', NULL, NULL, 14093, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:27:48', 'admin-1508978592-15089920687484510', 1, 1, 'SR', NULL, NULL, NULL),
(51602, '2017-10-26 15:44:53', NULL, NULL, 14107, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 15:44:53', 'admin-1508993224-15090038936199068', 1, 0, '', NULL, NULL, NULL),
(51603, '2017-10-26 12:39:56', NULL, NULL, 14094, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:39:56', 'admin-1508978592-15089927958732164', 1, 0, '', NULL, NULL, NULL),
(51604, '2017-10-26 12:27:49', NULL, NULL, 14093, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:27:49', 'admin-1508978592-15089920687484510', 1, 1, 'SR', NULL, NULL, NULL),
(51605, '2017-10-26 13:23:54', NULL, NULL, 14100, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 13:23:54', 'admin-1508993224-15089954345962475', 1, 1, 'SR', 1, NULL, NULL),
(51606, '2017-10-26 13:24:26', NULL, NULL, 14099, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 13:24:26', 'admin-1508993224-1508995466224755', 1, 0, '', NULL, NULL, NULL),
(51607, '2017-10-26 13:23:54', NULL, NULL, 14100, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 13:23:54', 'admin-1508993224-15089954345962475', 1, 1, 'SR', 1, NULL, NULL),
(51608, '2017-10-26 14:00:29', NULL, NULL, 14101, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.60, 0.0000, 0.0000, 10.60, 1, '27', 1, '1508993224', 'admin', '2017-10-26 14:00:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51609, '2017-10-26 13:13:14', NULL, NULL, 14098, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 13:13:14', 'admin-1508993224-15089947940943777', 1, 0, '', NULL, NULL, NULL),
(51610, '2017-10-26 13:20:45', NULL, NULL, 14099, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 13:20:45', 'admin-1508993224-15089952453329597', 1, 1, 'SR', NULL, NULL, NULL),
(51611, '2017-10-26 13:46:13', NULL, NULL, 14097, 0, 301, '237', 'Black Jack', '', 'Cold Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 13:46:13', 'admin-1508993224-15089967735986694', 1, 0, '', NULL, NULL, '10.0'),
(51612, '2017-10-26 12:39:56', NULL, NULL, 14094, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:39:56', 'admin-1508978592-15089927958732164', 1, 1, 'SR', NULL, NULL, NULL),
(51613, '2017-10-26 13:46:13', NULL, NULL, 14097, 0, 301, '237', 'Black Jack', '', 'Cold Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 13:46:13', 'admin-1508993224-15089967735986694', 1, 0, '', NULL, NULL, '10.0'),
(51614, '2017-10-26 13:10:45', NULL, NULL, 14098, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 13:10:45', 'admin-1508993224-15089946454162142', 1, 1, 'SR', NULL, NULL, NULL),
(51615, '2017-10-26 12:46:42', NULL, NULL, 14095, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:46:42', 'admin-1508978592-1508993202489888', 1, 0, '', NULL, NULL, NULL),
(51616, '2017-10-26 12:46:42', NULL, NULL, 14095, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:46:42', 'admin-1508978592-1508993202489888', 1, 1, 'SR', NULL, NULL, NULL),
(51617, '2017-10-26 12:47:00', NULL, NULL, 14096, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:47:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51618, '2017-10-26 12:39:56', NULL, NULL, 14094, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:39:56', 'admin-1508978592-15089927958732164', 1, 0, '', NULL, NULL, NULL),
(51619, '2017-10-26 12:39:56', NULL, NULL, 14094, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:39:56', 'admin-1508978592-15089927958732164', 1, 1, 'SR', NULL, NULL, NULL),
(51620, '2017-10-26 12:36:23', NULL, NULL, 14094, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:36:23', 'admin-1508978592-15089925831888040', 1, 0, '', NULL, NULL, NULL),
(51621, '2017-10-26 12:36:23', NULL, NULL, 14094, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:36:23', 'admin-1508978592-15089925831888040', 1, 0, '', NULL, NULL, NULL),
(51622, '2017-10-26 12:39:56', NULL, NULL, 14094, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:39:56', 'admin-1508978592-15089927958732164', 1, 1, 'SR', NULL, NULL, NULL),
(51623, '2017-10-26 12:36:23', NULL, NULL, 14094, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:36:23', 'admin-1508978592-15089925831888040', 1, 0, '', NULL, NULL, NULL),
(51624, '2017-10-26 12:36:23', NULL, NULL, 14094, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:36:23', 'admin-1508978592-15089925831888040', 1, 0, '', NULL, NULL, NULL),
(51625, '2017-10-26 10:36:49', NULL, NULL, 14089, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 10:36:49', 'admin-1508978592-15089854091416290', 1, 0, '', NULL, NULL, NULL),
(51626, '2017-10-26 15:45:52', NULL, NULL, 14107, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 15:45:52', 'admin-1508993224-15090039520192253', 1, 0, '', NULL, NULL, NULL),
(51627, '2017-10-26 10:57:28', NULL, NULL, 14091, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 10:57:28', 'admin-1508978592-1508986648222872', 1, 1, 'SR', NULL, NULL, NULL),
(51628, '2017-10-26 10:57:28', NULL, NULL, 14091, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 10:57:28', 'admin-1508978592-1508986648222872', 1, 1, 'SR', NULL, NULL, NULL),
(51629, '2017-10-26 10:57:28', NULL, NULL, 14091, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 10:57:28', 'admin-1508978592-1508986648222872', 1, 1, 'SR', NULL, NULL, NULL),
(51630, '2017-10-26 10:57:28', NULL, NULL, 14091, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 10:57:28', 'admin-1508978592-1508986648222872', 1, 1, 'SR', NULL, NULL, NULL),
(51631, '2017-10-26 10:36:56', NULL, NULL, 14090, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1508993224', 'admin', '2017-10-26 10:36:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51632, '2017-10-26 10:37:09', NULL, NULL, 14090, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 10:37:09', 'admin-1508978592-1508985429195357', 1, 1, 'SR', NULL, NULL, NULL),
(51633, '2017-10-26 12:36:23', NULL, NULL, 14094, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 12:36:23', 'admin-1508978592-15089925831888040', 1, 0, '', NULL, NULL, NULL),
(51634, '2017-10-26 10:56:57', NULL, NULL, 14091, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.10, 0.0000, 0.0000, 10.10, 1, '27', 1, '1508993224', 'admin', '2017-10-26 10:56:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51635, '2017-10-26 10:36:49', NULL, NULL, 14089, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 10:36:49', 'admin-1508978592-15089854091416290', 1, 1, 'SR', NULL, NULL, NULL),
(51636, '2017-10-26 10:31:00', NULL, NULL, 14088, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 10:31:00', 'admin-1508978592-15089850598557721', 1, 1, 'SR', 1, NULL, '10.0'),
(51637, '2017-10-26 10:31:00', NULL, NULL, 14088, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1508993224', 'admin', '2017-10-26 10:31:00', 'admin-1508978592-15089850598557721', 1, 0, '', 1, NULL, '10.0'),
(51638, '2017-10-26 10:36:32', NULL, NULL, 14089, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 10:36:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51639, '2017-10-26 10:36:37', NULL, NULL, 14089, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 10:36:37', 'admin-1508978592-15089853977197045', 1, 0, '', NULL, NULL, NULL),
(51640, '2017-10-26 09:45:08', NULL, NULL, 14087, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 09:45:08', 'admin-1508978592-1508982308434181', 1, 0, '', NULL, NULL, NULL),
(51641, '2017-10-26 09:48:45', NULL, NULL, 14086, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 09:48:45', 'admin-1508978592-15089825247676096', 1, 1, 'SR', NULL, NULL, NULL),
(51642, '2017-10-26 09:48:29', NULL, NULL, 14086, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 09:48:29', 'admin-1508978592-1508982509767973', 1, 0, '', NULL, NULL, NULL),
(51643, '2017-10-26 09:48:44', NULL, NULL, 14086, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 09:48:44', 'admin-1508978592-15089825247676096', 1, 0, '', NULL, NULL, NULL),
(51644, '2017-10-26 09:48:44', NULL, NULL, 14086, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 09:48:44', 'admin-1508978592-15089825247676096', 1, 0, '', NULL, NULL, NULL),
(51645, '2017-10-26 09:45:17', NULL, NULL, 14087, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 09:45:17', 'admin-1508978592-15089823176356255', 1, 0, '', NULL, NULL, NULL),
(51646, '2017-10-26 09:48:29', NULL, NULL, 14086, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 09:48:29', 'admin-1508978592-1508982509767973', 1, 0, '', NULL, NULL, NULL),
(51647, '2017-10-26 09:45:17', NULL, NULL, 14087, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 09:45:17', 'admin-1508978592-15089823176356255', 1, 1, 'SR', NULL, NULL, NULL),
(51648, '2017-10-26 09:45:03', NULL, NULL, 14087, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1508993224', 'admin', '2017-10-26 09:45:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51649, '2017-10-26 09:45:08', NULL, NULL, 14087, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1508993224', 'admin', '2017-10-26 09:45:08', 'admin-1508978592-1508982308434181', 1, 0, '', NULL, NULL, NULL),
(51650, '2017-10-26 09:42:27', NULL, NULL, 14086, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.10, 0.0000, 0.0000, 11.10, 1, '27', 1, '1508993224', 'admin', '2017-10-26 09:42:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51651, '2017-10-27 12:23:42', NULL, NULL, 14113, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 12:23:42', 'admin-1509065731-1509078221835732', 1, 1, 'SR', NULL, NULL, NULL),
(51652, '2017-10-27 12:32:34', NULL, NULL, 14115, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 12:32:34', 'admin-1509065731-15090787547409671', 1, 0, '', NULL, NULL, '10.0'),
(51653, '2017-10-27 12:32:34', NULL, NULL, 14115, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 12:32:34', 'admin-1509065731-15090787547409671', 1, 0, '', NULL, NULL, '10.0'),
(51654, '2017-10-27 12:51:46', NULL, NULL, 14116, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1509065731', 'admin', '2017-10-27 12:51:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51655, '2017-10-27 12:51:49', NULL, NULL, 14116, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 12:51:49', 'admin-1509065731-1509079908939367', 1, 0, '', NULL, NULL, NULL),
(51656, '2017-10-27 13:29:10', NULL, NULL, 14115, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 13:29:10', 'admin-1509065731-1509082150261795', 1, 1, 'SR', NULL, NULL, '10.0'),
(51657, '2017-10-27 11:47:36', NULL, NULL, 14112, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 11:47:36', 'admin-1509065731-15090760567919647', 1, 1, 'SR', NULL, NULL, NULL),
(51658, '2017-10-27 11:47:36', NULL, NULL, 14112, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 11:47:36', 'admin-1509065731-15090760567919647', 1, 1, 'SR', NULL, NULL, NULL),
(51659, '2017-10-27 13:55:09', NULL, NULL, 14117, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 13:55:09', 'admin-1509065731-15090837088925983', 1, 0, '', NULL, NULL, NULL),
(51660, '2017-10-27 10:36:08', NULL, NULL, 14110, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 10:36:08', 'admin-1509065731-15090717683586077', 1, 1, 'SR', NULL, NULL, NULL),
(51661, '2017-10-27 10:36:22', NULL, NULL, 14110, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 10:36:22', 'admin-1509065731-1509071782487781', 1, 1, 'SR', NULL, NULL, NULL),
(51662, '2017-10-27 13:48:56', NULL, NULL, 14119, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 13:48:56', 'admin-1509065731-15090833364362329', 1, 1, 'SR', NULL, NULL, NULL),
(51663, '2017-10-27 13:48:56', NULL, NULL, 14119, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 13:48:56', 'admin-1509065731-15090833364362329', 1, 1, 'SR', NULL, NULL, NULL),
(51664, '2017-10-27 13:48:56', NULL, NULL, 14119, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 13:48:56', 'admin-1509065731-15090833364362329', 1, 1, 'SR', NULL, NULL, NULL),
(51665, '2017-10-27 12:23:24', NULL, NULL, 14113, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 12:23:24', 'admin-1509065731-1509078203811918', 1, 1, 'SR', NULL, NULL, NULL),
(51666, '2017-10-27 12:23:24', NULL, NULL, 14113, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 12:23:24', 'admin-1509065731-1509078203811918', 1, 0, '', NULL, NULL, NULL),
(51667, '2017-10-27 12:23:24', NULL, NULL, 14113, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 12:23:24', 'admin-1509065731-1509078203811918', 1, 1, 'SR', NULL, NULL, NULL),
(51668, '2017-10-27 13:25:02', NULL, NULL, 14117, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 13:25:02', 'admin-1509065731-15090819018741594', 1, 1, 'SR', NULL, NULL, NULL),
(51669, '2017-10-27 15:03:09', NULL, NULL, 14120, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 15:03:09', 'admin-1509065731-1509087788992784', 1, 0, '', NULL, NULL, NULL),
(51670, '2017-10-27 15:03:09', NULL, NULL, 14120, 0, 301, '237', 'Black Jack', '', 'Cold Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 15:03:09', 'admin-1509065731-1509087788992784', 1, 0, '', NULL, NULL, NULL),
(51671, '2017-10-27 15:03:01', NULL, NULL, 14120, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1509065731', 'admin', '2017-10-27 15:03:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51672, '2017-10-27 13:42:39', NULL, NULL, 14118, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 13:42:39', 'admin-1509065731-15090829594567852', 1, 1, 'SR', NULL, NULL, NULL),
(51673, '2017-10-27 13:48:24', NULL, NULL, 14119, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1509065731', 'admin', '2017-10-27 13:48:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51674, '2017-10-27 13:48:38', NULL, NULL, 14119, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 13:48:38', 'admin-1509065731-15090833186206149', 1, 0, '', NULL, NULL, NULL),
(51675, '2017-10-27 13:48:38', NULL, NULL, 14119, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 13:48:38', 'admin-1509065731-15090833186206149', 1, 0, '', NULL, NULL, NULL),
(51676, '2017-10-27 13:48:38', NULL, NULL, 14119, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 13:48:38', 'admin-1509065731-15090833186206149', 1, 0, '', NULL, NULL, NULL),
(51677, '2017-10-27 13:25:43', NULL, NULL, 14117, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 13:25:43', 'admin-1509065731-15090819431523226', 1, 0, '', NULL, NULL, NULL),
(51678, '2017-10-27 13:42:39', NULL, NULL, 14118, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 13:42:39', 'admin-1509065731-15090829594567852', 1, 0, '', NULL, NULL, NULL),
(51679, '2017-10-27 12:23:50', NULL, NULL, 14113, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 12:23:50', 'admin-1509065731-15090782307364119', 1, 0, '', NULL, NULL, NULL),
(51680, '2017-10-27 12:30:02', NULL, NULL, 14114, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1509065731', 'admin', '2017-10-27 12:30:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51681, '2017-10-27 13:29:10', NULL, NULL, 14115, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 13:29:10', 'admin-1509065731-1509082150261795', 1, 1, 'SR', NULL, NULL, '10.0'),
(51682, '2017-10-27 13:42:29', NULL, NULL, 14118, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1509065731', 'admin', '2017-10-27 13:42:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51683, '2017-10-27 13:25:02', NULL, NULL, 14117, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 13:25:02', 'admin-1509065731-15090819018741594', 1, 0, '', NULL, NULL, NULL),
(51684, '2017-10-27 13:25:02', NULL, NULL, 14117, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 13:25:02', 'admin-1509065731-15090819018741594', 1, 0, '', NULL, NULL, NULL),
(51685, '2017-10-27 13:25:02', NULL, NULL, 14117, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 13:25:02', 'admin-1509065731-15090819018741594', 1, 0, '', NULL, NULL, NULL),
(51686, '2017-10-27 12:32:16', NULL, NULL, 14115, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1509065731', 'admin', '2017-10-27 12:32:16', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(51687, '2017-10-27 12:32:34', NULL, NULL, 14115, 0, 79, '79', 'Summer Salad ', 'no dressing', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 12:32:34', 'admin-1509065731-15090787547409671', 1, 1, 'SR', NULL, NULL, '10.0'),
(51688, '2017-10-27 12:30:19', NULL, NULL, 14114, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 12:30:19', 'admin-1509065731-15090786191797818', 1, 1, 'SR', NULL, NULL, NULL),
(51689, '2017-10-27 12:30:19', NULL, NULL, 14114, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 12:30:19', 'admin-1509065731-15090786191797818', 1, 1, 'SR', NULL, NULL, NULL),
(51690, '2017-10-27 12:23:42', NULL, NULL, 14113, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 12:23:42', 'admin-1509065731-1509078221835732', 1, 1, 'SR', NULL, NULL, NULL),
(51691, '2017-10-27 12:23:24', NULL, NULL, 14113, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 12:23:24', 'admin-1509065731-1509078203811918', 1, 0, '', NULL, NULL, NULL),
(51692, '2017-10-27 12:23:42', NULL, NULL, 14113, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 12:23:42', 'admin-1509065731-1509078221835732', 1, 1, 'SR', NULL, NULL, NULL),
(51693, '2017-10-27 13:24:41', NULL, NULL, 14117, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1509065731', 'admin', '2017-10-27 13:24:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51694, '2017-10-27 12:23:42', NULL, NULL, 14113, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 12:23:42', 'admin-1509065731-1509078221835732', 1, 1, 'SR', NULL, NULL, NULL),
(51695, '2017-10-27 12:23:42', NULL, NULL, 14113, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 12:23:42', 'admin-1509065731-1509078221835732', 1, 1, 'SR', NULL, NULL, NULL),
(51696, '2017-10-27 12:23:24', NULL, NULL, 14113, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 12:23:24', 'admin-1509065731-1509078203811918', 1, 0, '', NULL, NULL, NULL),
(51697, '2017-10-27 13:23:26', NULL, NULL, 14114, 0, 181, '116', 'Open Food ', 'Fried dumpling', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 13:23:26', 'admin-1509065731-15090818066914710', 1, 0, '', NULL, NULL, NULL),
(51698, '2017-10-27 11:10:29', NULL, NULL, 14111, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 11:10:29', 'admin-1509065731-15090738297984466', 1, 0, '', NULL, NULL, NULL),
(51699, '2017-10-27 11:11:00', NULL, NULL, 14111, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 11:11:00', 'admin-1509065731-15090738606124526', 1, 1, 'SR', NULL, NULL, NULL),
(51700, '2017-10-27 11:11:00', NULL, NULL, 14111, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 11:11:00', 'admin-1509065731-15090738606124526', 1, 0, '', NULL, NULL, NULL),
(51701, '2017-10-27 11:11:00', NULL, NULL, 14111, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 11:11:00', 'admin-1509065731-15090738606124526', 1, 1, 'SR', NULL, NULL, NULL),
(51702, '2017-10-27 11:47:14', NULL, NULL, 14112, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1509065731', 'admin', '2017-10-27 11:47:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51703, '2017-10-27 11:47:18', NULL, NULL, 14112, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 11:47:18', 'admin-1509065731-15090760384453273', 1, 0, '', NULL, NULL, NULL),
(51704, '2017-10-27 12:22:45', NULL, NULL, 14113, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.40, 0.0000, 0.0000, 14.40, 1, '27', 1, '1509065731', 'admin', '2017-10-27 12:22:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51705, '2017-10-27 11:47:18', NULL, NULL, 14112, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 11:47:18', 'admin-1509065731-15090760384453273', 1, 0, '', NULL, NULL, NULL),
(51706, '2017-10-27 09:38:36', NULL, NULL, 14109, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1509065731', 'admin', '2017-10-27 09:38:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51707, '2017-10-27 09:41:07', NULL, NULL, 14109, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 09:41:07', 'admin-1509065731-15090684671512438', 1, 0, '', NULL, NULL, NULL),
(51708, '2017-10-27 09:41:31', NULL, NULL, 14109, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 09:41:31', 'admin-1509065731-15090684914717956', 1, 0, '', NULL, NULL, NULL),
(51709, '2017-10-27 09:41:31', NULL, NULL, 14109, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 09:41:31', 'admin-1509065731-15090684914717956', 1, 1, 'SR', NULL, NULL, NULL),
(51710, '2017-10-27 09:24:37', NULL, NULL, 14108, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 09:24:37', 'admin-1509065731-15090674768489158', 1, 0, '', NULL, NULL, NULL),
(51711, '2017-10-27 11:10:22', NULL, NULL, 14111, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1509065731', 'admin', '2017-10-27 11:10:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51712, '2017-10-27 10:36:22', NULL, NULL, 14110, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 10:36:22', 'admin-1509065731-1509071782487781', 1, 0, '', NULL, NULL, NULL),
(51713, '2017-10-27 10:36:22', NULL, NULL, 14110, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 10:36:22', 'admin-1509065731-1509071782487781', 1, 1, 'SR', NULL, NULL, NULL),
(51714, '2017-10-27 10:36:08', NULL, NULL, 14110, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 10:36:08', 'admin-1509065731-15090717683586077', 1, 0, '', NULL, NULL, NULL),
(51715, '2017-10-27 10:36:08', NULL, NULL, 14110, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 10:36:08', 'admin-1509065731-15090717683586077', 1, 0, '', NULL, NULL, NULL),
(51716, '2017-10-27 10:35:53', NULL, NULL, 14110, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1509065731', 'admin', '2017-10-27 10:35:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51717, '2017-10-27 09:41:31', NULL, NULL, 14109, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 09:41:31', 'admin-1509065731-15090684914717956', 1, 0, '', NULL, NULL, NULL),
(51718, '2017-10-27 09:24:37', NULL, NULL, 14108, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509065731', 'admin', '2017-10-27 09:24:37', 'admin-1509065731-15090674768489158', 1, 1, 'SR', NULL, NULL, NULL),
(51719, '2017-10-27 09:23:45', NULL, NULL, 14108, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1509065731', 'admin', '2017-10-27 09:23:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51720, '2017-10-28 11:32:39', NULL, NULL, 14142, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:32:39', 'admin-1509158038-15091615598043229', 1, 1, 'SR', NULL, NULL, NULL),
(51721, '2017-10-28 11:08:20', NULL, NULL, 14135, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:08:20', 'admin-1509158038-15091600999717287', 1, 0, '', NULL, NULL, NULL),
(51722, '2017-10-28 15:55:29', NULL, NULL, 14160, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 15:55:29', 'admin-1509173804-15091773289004785', 1, 0, '', NULL, NULL, NULL),
(51723, '2017-10-28 10:23:52', NULL, NULL, 14128, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:23:52', 'admin-1509151411-15091574323973457', 1, 0, '', NULL, NULL, NULL),
(51724, '2017-10-28 10:24:03', NULL, NULL, 14128, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:24:03', 'admin-1509151411-15091574435126231', 1, 1, 'SR', NULL, NULL, NULL),
(51725, '2017-10-28 10:24:03', NULL, NULL, 14128, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:24:03', 'admin-1509151411-15091574435126231', 1, 0, '', NULL, NULL, NULL),
(51726, '2017-10-28 15:00:16', NULL, NULL, 14159, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 15:00:16', 'admin-1509173804-15091740167382894', 1, 0, '', NULL, NULL, NULL),
(51727, '2017-10-28 15:55:29', NULL, NULL, 14160, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 15:55:29', 'admin-1509173804-15091773289004785', 1, 1, 'SR', NULL, NULL, NULL),
(51728, '2017-10-28 15:55:29', NULL, NULL, 14160, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 15:55:29', 'admin-1509173804-15091773289004785', 1, 0, '', NULL, NULL, NULL),
(51729, '2017-10-28 15:55:08', NULL, NULL, 14160, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 15:55:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51730, '2017-10-28 15:40:36', NULL, NULL, 14159, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 15:40:36', 'admin-1509173804-1509176436332573', 1, 1, 'SR', NULL, NULL, NULL),
(51731, '2017-10-28 15:40:36', NULL, NULL, 14159, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 15:40:36', 'admin-1509173804-1509176436332573', 1, 1, 'SR', NULL, NULL, NULL),
(51732, '2017-10-28 16:44:03', NULL, NULL, 14162, 0, 182, '117', 'Open Drinks ', 'latte', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 16:44:03', 'admin-1509173804-150918024379228', 1, 0, '', 1, NULL, NULL),
(51733, '2017-10-28 16:45:08', NULL, NULL, 14163, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 16:45:08', 'admin-1509173804-15091803085918295', 1, 0, '', 1, NULL, NULL),
(51734, '2017-10-28 17:05:55', NULL, NULL, 14165, 0, 182, '117', 'Open Drinks ', 'BROMO', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 17:05:55', 'admin-1509173804-15091815557477634', 1, 0, '', 1, NULL, NULL),
(51735, '2017-10-28 13:46:15', NULL, NULL, 14154, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:46:15', 'admin-1509162920-15091695753296863', 1, 1, 'SR', NULL, NULL, NULL),
(51736, '2017-10-28 13:46:15', NULL, NULL, 14154, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:46:15', 'admin-1509162920-15091695753296863', 1, 1, 'SR', NULL, NULL, NULL),
(51737, '2017-10-28 13:47:38', NULL, NULL, 14155, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.95, 0.0000, 0.0000, 6.95, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:47:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51738, '2017-10-28 13:47:46', NULL, NULL, 14155, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:47:46', 'admin-1509162920-15091696664296365', 1, 1, 'SR', NULL, NULL, NULL),
(51739, '2017-10-28 13:47:46', NULL, NULL, 14155, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:47:46', 'admin-1509162920-15091696664296365', 1, 1, 'SR', NULL, NULL, NULL),
(51740, '2017-10-28 13:47:46', NULL, NULL, 14155, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:47:46', 'admin-1509162920-15091696664296365', 1, 1, 'SR', NULL, NULL, NULL),
(51741, '2017-10-28 13:58:51', NULL, NULL, 14155, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:58:51', 'admin-1509162920-15091703316886311', 1, 1, 'SR', NULL, NULL, NULL),
(51742, '2017-10-28 14:00:06', NULL, NULL, 14152, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:00:06', 'admin-1509162920-1509170406174688', 1, 0, '', NULL, NULL, NULL),
(51743, '2017-10-28 14:08:03', NULL, NULL, 14156, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:08:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51744, '2017-10-28 14:08:25', NULL, NULL, 14156, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:08:25', 'admin-1509162920-15091709049753121', 1, 1, 'SR', NULL, NULL, NULL),
(51745, '2017-10-28 13:24:51', NULL, NULL, 14153, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:24:51', 'admin-1509162920-15091682911143344', 1, 0, '', NULL, NULL, NULL),
(51746, '2017-10-28 13:26:29', NULL, NULL, 14153, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:26:29', 'admin-1509162920-15091683894149656', 1, 1, 'SR', NULL, NULL, NULL),
(51747, '2017-10-28 12:35:52', NULL, NULL, 14151, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1509173804', 'admin', '2017-10-28 12:35:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51748, '2017-10-28 12:36:27', NULL, NULL, 14151, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 12:36:27', 'admin-1509162920-15091653877775346', 1, 1, 'SR', NULL, NULL, NULL),
(51749, '2017-10-28 11:58:15', NULL, NULL, 14140, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:58:15', 'admin-1509162920-1509163095168647', 1, 1, 'SR', NULL, NULL, NULL),
(51750, '2017-10-28 12:04:48', NULL, NULL, 14147, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1509173804', 'admin', '2017-10-28 12:04:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51751, '2017-10-28 12:05:00', NULL, NULL, 14147, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 12:05:00', 'admin-1509162920-1509163500083662', 1, 1, 'SR', NULL, NULL, NULL),
(51752, '2017-10-28 12:05:00', NULL, NULL, 14147, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 12:05:00', 'admin-1509162920-1509163500083662', 1, 1, 'SR', NULL, NULL, NULL),
(51753, '2017-10-28 11:36:32', NULL, NULL, 14143, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:36:32', 'admin-1509158038-15091617925249732', 1, 1, 'SR', NULL, NULL, NULL),
(51754, '2017-10-28 11:36:32', NULL, NULL, 14143, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:36:32', 'admin-1509158038-15091617925249732', 1, 1, 'SR', NULL, NULL, NULL),
(51755, '2017-10-28 15:00:16', NULL, NULL, 14159, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 15:00:16', 'admin-1509173804-15091740167382894', 1, 1, 'SR', NULL, NULL, NULL),
(51756, '2017-10-28 15:00:16', NULL, NULL, 14159, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 15:00:16', 'admin-1509173804-15091740167382894', 1, 1, 'SR', NULL, NULL, NULL),
(51757, '2017-10-28 12:36:28', NULL, NULL, 14151, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 12:36:28', 'admin-1509162920-15091653877775346', 1, 1, 'SR', NULL, NULL, NULL),
(51758, '2017-10-28 12:36:28', NULL, NULL, 14151, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 12:36:28', 'admin-1509162920-15091653877775346', 1, 1, 'SR', NULL, NULL, NULL),
(51759, '2017-10-28 14:16:24', NULL, NULL, 14157, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:16:24', 'admin-1509170912-15091713843883738', 1, 0, '', NULL, NULL, NULL),
(51760, '2017-10-28 11:32:23', NULL, NULL, 14142, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:32:23', 'admin-1509158038-15091615435818477', 1, 0, '', NULL, NULL, NULL),
(51761, '2017-10-28 11:32:08', NULL, NULL, 14142, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:32:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51762, '2017-10-28 11:32:23', NULL, NULL, 14142, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:32:23', 'admin-1509158038-15091615435818477', 1, 0, '', NULL, NULL, NULL),
(51763, '2017-10-28 11:31:53', NULL, NULL, 14137, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:31:53', 'admin-1509158038-15091615128341361', 1, 0, '', NULL, NULL, '10.0'),
(51764, '2017-10-28 11:29:43', NULL, NULL, 14141, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:29:43', 'admin-1509158038-1509161383288252', 1, 1, 'SR', NULL, NULL, NULL),
(51765, '2017-10-28 11:29:43', NULL, NULL, 14141, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:29:43', 'admin-1509158038-1509161383288252', 1, 1, 'SR', NULL, NULL, NULL),
(51766, '2017-10-28 11:29:33', NULL, NULL, 14141, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:29:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51767, '2017-10-28 14:48:13', NULL, NULL, 14158, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:48:13', 'admin-1509170912-15091732934491133', 1, 1, 'SR', NULL, NULL, NULL),
(51768, '2017-10-28 14:38:11', NULL, NULL, 14152, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:38:11', 'admin-1509170912-15091726915388243', 1, 0, '', NULL, NULL, NULL),
(51769, '2017-10-28 14:38:11', NULL, NULL, 14152, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:38:11', 'admin-1509170912-15091726915388243', 1, 0, '', NULL, NULL, NULL),
(51770, '2017-10-28 14:32:31', NULL, NULL, 14157, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:32:31', 'admin-1509170912-15091723513201392', 1, 1, 'SR', NULL, NULL, NULL),
(51771, '2017-10-28 10:45:40', NULL, NULL, 14132, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:45:40', 'admin-1509158038-15091587407577082', 1, 0, '', NULL, NULL, NULL),
(51772, '2017-10-28 14:23:25', NULL, NULL, 14157, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:23:25', 'admin-1509170912-1509171805471444', 1, 1, 'SR', NULL, NULL, NULL),
(51773, '2017-10-28 12:18:41', NULL, NULL, 14150, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 12:18:41', 'admin-1509162920-15091643210055252', 1, 0, '', NULL, NULL, NULL),
(51774, '2017-10-28 12:19:06', NULL, NULL, 14150, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 12:19:06', 'admin-1509162920-15091643466633835', 1, 1, 'SR', NULL, NULL, NULL),
(51775, '2017-10-28 14:23:25', NULL, NULL, 14157, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:23:25', 'admin-1509170912-1509171805471444', 1, 0, '', NULL, NULL, NULL),
(51776, '2017-10-28 15:00:16', NULL, NULL, 14159, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 15:00:16', 'admin-1509173804-15091740167382894', 1, 1, 'SR', NULL, NULL, NULL),
(51777, '2017-10-28 13:58:51', NULL, NULL, 14155, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:58:51', 'admin-1509162920-15091703316886311', 1, 0, '', NULL, NULL, NULL),
(51778, '2017-10-28 13:58:51', NULL, NULL, 14155, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:58:51', 'admin-1509162920-15091703316886311', 1, 1, 'SR', NULL, NULL, NULL),
(51779, '2017-10-28 13:58:51', NULL, NULL, 14155, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:58:51', 'admin-1509162920-15091703316886311', 1, 0, '', NULL, NULL, NULL),
(51780, '2017-10-28 14:23:25', NULL, NULL, 14157, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:23:25', 'admin-1509170912-1509171805471444', 1, 0, '', NULL, NULL, NULL),
(51781, '2017-10-28 09:41:09', NULL, NULL, 14124, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:41:09', 'admin-1509151411-15091548695419666', 1, 0, '', NULL, NULL, NULL),
(51782, '2017-10-28 09:41:09', NULL, NULL, 14124, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:41:09', 'admin-1509151411-15091548695419666', 1, 0, '', NULL, NULL, NULL),
(51783, '2017-10-28 09:41:09', NULL, NULL, 14124, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:41:09', 'admin-1509151411-15091548695419666', 1, 1, 'SR', NULL, NULL, NULL),
(51784, '2017-10-28 14:21:09', NULL, NULL, 14158, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:21:09', 'admin-1509170912-15091716696076558', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(51785, '2017-10-28 14:21:09', NULL, NULL, 14158, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:21:09', 'admin-1509170912-15091716696076558', 1, 0, '', NULL, NULL, NULL),
(51786, '2017-10-28 14:20:49', NULL, NULL, 14158, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:20:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51787, '2017-10-28 14:21:09', NULL, NULL, 14158, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:21:09', 'admin-1509170912-15091716696076558', 1, 0, '', NULL, NULL, NULL),
(51788, '2017-10-28 14:16:04', NULL, NULL, 14157, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.40, 0.0000, 0.0000, 11.40, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:16:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51789, '2017-10-28 11:40:50', NULL, NULL, 14144, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:40:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51790, '2017-10-28 15:00:03', NULL, NULL, 14159, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 15:00:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51791, '2017-10-28 14:16:24', NULL, NULL, 14157, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:16:24', 'admin-1509170912-15091713843883738', 1, 1, 'SR', NULL, NULL, NULL),
(51792, '2017-10-28 14:16:24', NULL, NULL, 14157, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:16:24', 'admin-1509170912-15091713843883738', 1, 1, 'SR', NULL, NULL, NULL),
(51793, '2017-10-28 14:16:24', NULL, NULL, 14157, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:16:24', 'admin-1509170912-15091713843883738', 1, 1, 'SR', NULL, NULL, NULL),
(51794, '2017-10-28 14:08:53', NULL, NULL, 14156, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:08:53', 'admin-1509170912-15091709333182050', 1, 1, 'SR', NULL, NULL, NULL),
(51795, '2017-10-28 14:08:53', NULL, NULL, 14156, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:08:53', 'admin-1509170912-15091709333182050', 1, 1, 'SR', NULL, NULL, NULL),
(51796, '2017-10-28 14:08:25', NULL, NULL, 14156, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:08:25', 'admin-1509162920-15091709049753121', 1, 0, '', NULL, NULL, NULL),
(51797, '2017-10-28 14:08:25', NULL, NULL, 14156, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:08:25', 'admin-1509162920-15091709049753121', 1, 0, '', NULL, NULL, NULL),
(51798, '2017-10-28 14:08:25', NULL, NULL, 14156, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:08:25', 'admin-1509162920-15091709049753121', 1, 1, 'SR', NULL, NULL, NULL),
(51799, '2017-10-28 11:52:36', NULL, NULL, 14145, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:52:36', 'admin-1509158038-15091627565827224', 1, 1, 'SR', NULL, NULL, NULL),
(51800, '2017-10-28 11:52:41', NULL, NULL, 14146, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.00, 0.0000, 0.0000, 14.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:52:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51801, '2017-10-28 11:53:09', NULL, NULL, 14146, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:53:09', 'admin-1509158038-15091627896693991', 1, 0, '', NULL, NULL, NULL),
(51802, '2017-10-28 11:53:09', NULL, NULL, 14146, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:53:09', 'admin-1509158038-15091627896693991', 1, 0, '', NULL, NULL, NULL),
(51803, '2017-10-28 11:53:09', NULL, NULL, 14146, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:53:09', 'admin-1509158038-15091627896693991', 1, 1, 'SR', NULL, NULL, NULL),
(51804, '2017-10-28 11:53:09', NULL, NULL, 14146, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:53:09', 'admin-1509158038-15091627896693991', 1, 0, '', NULL, NULL, NULL),
(51805, '2017-10-28 13:46:15', NULL, NULL, 14154, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:46:15', 'admin-1509162920-15091695753296863', 1, 0, '', NULL, NULL, NULL),
(51806, '2017-10-28 12:19:06', NULL, NULL, 14150, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 12:19:06', 'admin-1509162920-15091643466633835', 1, 1, 'SR', NULL, NULL, NULL),
(51807, '2017-10-28 12:24:47', NULL, NULL, 14146, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 12:24:47', 'admin-1509162920-1509164687683936', 1, 0, '', NULL, NULL, NULL),
(51808, '2017-10-28 11:51:07', NULL, NULL, 14145, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:51:07', 'admin-1509158038-15091626674476954', 1, 0, '', NULL, NULL, NULL),
(51809, '2017-10-28 13:26:29', NULL, NULL, 14153, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:26:29', 'admin-1509162920-15091683894149656', 1, 1, 'SR', NULL, NULL, NULL),
(51810, '2017-10-28 10:23:52', NULL, NULL, 14128, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:23:52', 'admin-1509151411-15091574323973457', 1, 0, '', NULL, NULL, NULL),
(51811, '2017-10-28 13:21:53', NULL, NULL, 14152, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:21:53', 'admin-1509162920-15091681135997735', 1, 1, 'SR', NULL, NULL, NULL),
(51812, '2017-10-28 11:08:20', NULL, NULL, 14135, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:08:20', 'admin-1509158038-15091600999717287', 1, 1, 'SR', NULL, NULL, NULL),
(51813, '2017-10-28 11:08:20', NULL, NULL, 14135, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:08:20', 'admin-1509158038-15091600999717287', 1, 1, 'SR', NULL, NULL, NULL),
(51814, '2017-10-28 13:23:27', NULL, NULL, 14152, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:23:27', 'admin-1509162920-15091682075808475', 1, 1, 'SR', NULL, NULL, NULL),
(51815, '2017-10-28 13:24:35', NULL, NULL, 14153, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:24:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51816, '2017-10-28 13:24:51', NULL, NULL, 14153, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:24:51', 'admin-1509162920-15091682911143344', 1, 1, 'SR', NULL, NULL, NULL),
(51817, '2017-10-28 13:21:53', NULL, NULL, 14152, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:21:53', 'admin-1509162920-15091681135997735', 1, 0, '', NULL, NULL, NULL),
(51818, '2017-10-28 13:21:53', NULL, NULL, 14152, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:21:53', 'admin-1509162920-15091681135997735', 1, 1, 'SR', NULL, NULL, NULL),
(51819, '2017-10-28 11:40:33', NULL, NULL, 14143, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:40:33', 'admin-1509158038-15091620331639393', 1, 0, '', NULL, NULL, NULL),
(51820, '2017-10-28 11:22:08', NULL, NULL, 14140, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:22:08', 'admin-1509158038-15091609284108293', 1, 0, '', NULL, NULL, NULL),
(51821, '2017-10-28 11:22:08', NULL, NULL, 14140, 0, 271, '205', 'Take It Easy', 'egg to suuny side up', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:22:08', 'admin-1509158038-15091609284108293', 1, 0, '', NULL, NULL, NULL),
(51822, '2017-10-28 09:40:00', NULL, NULL, 14123, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:40:00', 'admin-1509151411-15091548004242212', 1, 0, '', NULL, NULL, NULL),
(51823, '2017-10-28 09:40:00', NULL, NULL, 14123, 0, 271, '205', 'Take It Easy', 'croissant chnage to toast', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:40:00', 'admin-1509151411-15091548004242212', 1, 0, '', NULL, NULL, NULL),
(51824, '2017-10-28 11:19:41', NULL, NULL, 14139, 0, 153, '87', 'Wake Me Up!', 'no baked bean', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:19:41', 'admin-1509158038-15091607811886960', 1, 0, '', NULL, NULL, NULL),
(51825, '2017-10-28 11:19:25', NULL, NULL, 14139, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:19:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51826, '2017-10-28 12:36:27', NULL, NULL, 14151, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 12:36:28', 'admin-1509162920-15091653877775346', 1, 1, 'SR', NULL, NULL, NULL),
(51827, '2017-10-28 15:26:24', NULL, NULL, 14159, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 15:26:24', 'admin-1509173804-15091755840602033', 1, 0, '', NULL, NULL, NULL),
(51828, '2017-10-28 13:21:41', NULL, NULL, 14152, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:21:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51829, '2017-10-28 11:32:39', NULL, NULL, 14142, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:32:39', 'admin-1509158038-15091615598043229', 1, 1, 'SR', NULL, NULL, NULL),
(51830, '2017-10-28 11:18:00', NULL, NULL, 14138, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:18:00', 'admin-1509158038-15091606799996914', 1, 1, 'SR', NULL, NULL, NULL),
(51831, '2017-10-28 11:17:33', NULL, NULL, 14138, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:17:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51832, '2017-10-28 11:10:26', NULL, NULL, 14136, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:10:26', 'admin-1509158038-15091602262606412', 1, 1, 'SR', NULL, NULL, NULL),
(51833, '2017-10-28 11:15:44', NULL, NULL, 14137, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:15:44', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(51834, '2017-10-28 11:15:52', NULL, NULL, 14137, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:15:52', 'admin-1509158038-15091605525276246', 1, 1, 'SR', NULL, NULL, '10.0'),
(51835, '2017-10-28 11:15:52', NULL, NULL, 14137, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:15:52', 'admin-1509158038-15091605525276246', 1, 1, 'SR', NULL, NULL, '10.0'),
(51836, '2017-10-28 11:16:37', NULL, NULL, 14137, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:16:37', 'admin-1509158038-15091605973142343', 1, 0, '', NULL, NULL, '10.0'),
(51837, '2017-10-28 11:16:37', NULL, NULL, 14137, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:16:37', 'admin-1509158038-15091605973142343', 1, 0, '', NULL, NULL, '10.0'),
(51838, '2017-10-28 11:10:26', NULL, NULL, 14136, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:10:26', 'admin-1509158038-15091602262606412', 1, 0, '', NULL, NULL, NULL),
(51839, '2017-10-28 11:10:26', NULL, NULL, 14136, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:10:26', 'admin-1509158038-15091602262606412', 1, 1, 'SR', NULL, NULL, NULL),
(51840, '2017-10-28 12:18:20', NULL, NULL, 14150, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1509173804', 'admin', '2017-10-28 12:18:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51841, '2017-10-28 12:18:41', NULL, NULL, 14150, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 12:18:41', 'admin-1509162920-15091643210055252', 1, 0, '', NULL, NULL, NULL),
(51842, '2017-10-28 13:45:49', NULL, NULL, 14154, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:45:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51843, '2017-10-28 12:10:58', NULL, NULL, 14149, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 12:10:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51844, '2017-10-28 12:11:59', NULL, NULL, 14146, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 12:11:59', 'admin-1509162920-15091639194006266', 1, 0, '', NULL, NULL, NULL),
(51845, '2017-10-28 12:11:20', NULL, NULL, 14149, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 12:11:20', 'admin-1509162920-15091638804655865', 1, 1, 'SR', NULL, NULL, NULL),
(51846, '2017-10-28 12:11:59', NULL, NULL, 14146, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 12:11:59', 'admin-1509162920-15091639194006266', 1, 0, '', NULL, NULL, NULL),
(51847, '2017-10-28 12:11:20', NULL, NULL, 14149, 0, 223, '226', 'Smoked Duck Aglio Olio', 'no cheese', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 12:11:20', 'admin-1509162920-15091638804655865', 1, 0, '', NULL, NULL, NULL),
(51848, '2017-10-28 10:45:41', NULL, NULL, 14132, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:45:41', 'admin-1509158038-15091587407577082', 1, 0, '', NULL, NULL, NULL),
(51849, '2017-10-28 10:45:49', NULL, NULL, 14132, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:45:49', 'admin-1509158038-15091587491794952', 1, 0, '', NULL, NULL, NULL),
(51850, '2017-10-28 10:46:36', NULL, NULL, 14131, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:46:36', 'admin-1509158038-15091587962188252', 1, 1, 'SR', NULL, NULL, NULL),
(51851, '2017-10-28 10:46:36', NULL, NULL, 14131, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:46:36', 'admin-1509158038-15091587962188252', 1, 1, 'SR', NULL, NULL, NULL),
(51852, '2017-10-28 10:11:00', NULL, NULL, 14127, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:11:00', 'admin-1509151411-1509156660213970', 1, 0, '', NULL, NULL, NULL),
(51853, '2017-10-28 10:11:00', NULL, NULL, 14127, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:11:00', 'admin-1509151411-1509156660213970', 1, 0, '', NULL, NULL, NULL),
(51854, '2017-10-28 10:11:00', NULL, NULL, 14127, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:11:00', 'admin-1509151411-1509156660213970', 1, 0, '', NULL, NULL, NULL),
(51855, '2017-10-28 10:11:00', NULL, NULL, 14127, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:11:00', 'admin-1509151411-1509156660213970', 1, 0, '', NULL, NULL, NULL),
(51856, '2017-10-28 10:10:41', NULL, NULL, 14127, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.00, 0.0000, 0.0000, 10.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:10:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51857, '2017-10-28 11:53:20', NULL, NULL, 14146, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:53:20', 'admin-1509158038-15091628006749278', 1, 0, '', NULL, NULL, NULL),
(51858, '2017-10-28 11:55:10', NULL, NULL, 14146, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:55:10', 'admin-1509158038-15091629108591496', 1, 0, '', NULL, NULL, NULL),
(51859, '2017-10-28 11:52:36', NULL, NULL, 14145, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:52:36', 'admin-1509158038-15091627565827224', 1, 1, 'SR', NULL, NULL, NULL),
(51860, '2017-10-28 11:40:54', NULL, NULL, 14144, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:40:54', 'admin-1509158038-1509162054740262', 1, 1, 'SR', NULL, NULL, NULL),
(51861, '2017-10-28 11:47:17', NULL, NULL, 14141, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:47:17', 'admin-1509158038-15091624369376718', 1, 1, 'SR', NULL, NULL, NULL),
(51862, '2017-10-28 11:50:57', NULL, NULL, 14145, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:50:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51863, '2017-10-28 14:18:54', NULL, NULL, 14152, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:18:54', 'admin-1509170912-15091715344696346', 1, 1, 'SR', NULL, NULL, NULL),
(51864, '2017-10-28 11:40:33', NULL, NULL, 14143, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:40:33', 'admin-1509158038-15091620331639393', 1, 0, '', NULL, NULL, NULL),
(51865, '2017-10-28 11:08:20', NULL, NULL, 14135, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:08:20', 'admin-1509158038-15091600999717287', 1, 0, '', NULL, NULL, NULL),
(51866, '2017-10-28 10:58:08', NULL, NULL, 14133, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:58:08', 'admin-1509158038-15091594884809859', 1, 1, 'SR', NULL, NULL, NULL),
(51867, '2017-10-28 13:46:15', NULL, NULL, 14154, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 13:46:15', 'admin-1509162920-15091695753296863', 1, 0, '', NULL, NULL, NULL),
(51868, '2017-10-28 11:06:07', NULL, NULL, 14132, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:06:07', 'admin-1509158038-15091599671595899', 1, 1, 'SR', NULL, NULL, NULL),
(51869, '2017-10-28 10:49:07', NULL, NULL, 14133, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:49:07', 'admin-1509158038-15091589476436019', 1, 1, 'SR', NULL, NULL, NULL),
(51870, '2017-10-28 11:18:00', NULL, NULL, 14138, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:18:00', 'admin-1509158038-15091606799996914', 1, 0, '', NULL, NULL, NULL),
(51871, '2017-10-28 10:49:07', NULL, NULL, 14133, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:49:07', 'admin-1509158038-15091589476436019', 1, 0, '', NULL, NULL, NULL),
(51872, '2017-10-28 11:36:22', NULL, NULL, 14143, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:36:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51873, '2017-10-28 11:01:12', NULL, NULL, 14134, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:01:12', 'admin-1509158038-15091596722294997', 1, 1, 'SR', 1, NULL, NULL),
(51874, '2017-10-28 10:43:39', NULL, NULL, 14131, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:43:39', 'admin-1509158038-15091586195675150', 1, 0, '', NULL, NULL, NULL),
(51875, '2017-10-28 11:22:08', NULL, NULL, 14140, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:22:08', 'admin-1509158038-15091609284108293', 1, 1, 'SR', NULL, NULL, NULL),
(51876, '2017-10-28 11:07:52', NULL, NULL, 14135, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:07:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51877, '2017-10-28 10:45:25', NULL, NULL, 14130, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:45:25', 'admin-1509158038-15091587254713498', 1, 1, 'SR', NULL, NULL, NULL),
(51878, '2017-10-28 10:49:07', NULL, NULL, 14133, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:49:07', 'admin-1509158038-15091589476436019', 1, 0, '', NULL, NULL, NULL),
(51879, '2017-10-28 10:48:43', NULL, NULL, 14133, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:48:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51880, '2017-10-28 10:46:36', NULL, NULL, 14131, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:46:36', 'admin-1509158038-15091587962188252', 1, 0, '', NULL, NULL, NULL),
(51881, '2017-10-28 10:43:31', NULL, NULL, 14131, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:43:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51882, '2017-10-28 14:23:25', NULL, NULL, 14157, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 14:23:25', 'admin-1509170912-1509171805471444', 1, 0, '', NULL, NULL, NULL),
(51883, '2017-10-28 09:50:20', NULL, NULL, 14125, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:50:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51884, '2017-10-28 09:50:26', NULL, NULL, 14125, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:50:26', 'admin-1509151411-1509155425941317', 1, 0, '', NULL, NULL, NULL),
(51885, '2017-10-28 09:50:26', NULL, NULL, 14125, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:50:26', 'admin-1509151411-1509155425941317', 1, 0, '', NULL, NULL, NULL),
(51886, '2017-10-28 11:22:08', NULL, NULL, 14140, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:22:08', 'admin-1509158038-15091609284108293', 1, 1, 'SR', NULL, NULL, NULL),
(51887, '2017-10-28 10:44:53', NULL, NULL, 14132, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:44:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51888, '2017-10-28 10:43:39', NULL, NULL, 14131, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:43:39', 'admin-1509158038-15091586195675150', 1, 0, '', NULL, NULL, NULL),
(51889, '2017-10-28 11:10:09', NULL, NULL, 14136, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:10:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51890, '2017-10-28 11:10:26', NULL, NULL, 14136, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:10:26', 'admin-1509158038-15091602262606412', 1, 0, '', NULL, NULL, NULL),
(51891, '2017-10-28 10:33:51', NULL, NULL, 14130, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:33:51', 'admin-1509151411-15091580314367017', 1, 0, '', NULL, NULL, NULL),
(51892, '2017-10-28 10:33:44', NULL, NULL, 14130, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:33:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51893, '2017-10-28 10:33:51', NULL, NULL, 14130, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:33:51', 'admin-1509151411-15091580314367017', 1, 0, '', NULL, NULL, NULL),
(51894, '2017-10-28 10:26:39', NULL, NULL, 14129, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:26:39', 'admin-1509151411-15091575993768532', 1, 0, '', NULL, NULL, NULL),
(51895, '2017-10-28 10:26:39', NULL, NULL, 14129, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:26:39', 'admin-1509151411-15091575993768532', 1, 1, 'SR', NULL, NULL, NULL),
(51896, '2017-10-28 10:26:30', NULL, NULL, 14129, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:26:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51897, '2017-10-28 10:11:11', NULL, NULL, 14127, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:11:11', 'admin-1509151411-15091566717914435', 1, 1, 'SR', NULL, NULL, NULL),
(51898, '2017-10-28 10:23:47', NULL, NULL, 14128, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:23:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51899, '2017-10-28 11:22:08', NULL, NULL, 14140, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:22:08', 'admin-1509158038-15091609284108293', 1, 0, '', NULL, NULL, NULL),
(51900, '2017-10-28 09:51:10', NULL, NULL, 14126, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:51:10', 'admin-1509151411-15091554706051897', 1, 1, 'SR', NULL, NULL, NULL),
(51901, '2017-10-28 10:01:37', NULL, NULL, 14123, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:01:37', 'admin-1509151411-15091560975612716', 1, 1, 'SR', NULL, NULL, NULL),
(51902, '2017-10-28 10:11:11', NULL, NULL, 14127, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 10:11:11', 'admin-1509151411-15091566717914435', 1, 1, 'SR', NULL, NULL, NULL),
(51903, '2017-10-28 09:50:54', NULL, NULL, 14126, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:50:54', 'admin-1509151411-1509155454581208', 1, 0, '', NULL, NULL, NULL),
(51904, '2017-10-28 09:50:36', NULL, NULL, 14126, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:50:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51905, '2017-10-28 09:50:54', NULL, NULL, 14126, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:50:54', 'admin-1509151411-1509155454581208', 1, 0, '', NULL, NULL, NULL),
(51906, '2017-10-28 09:40:42', NULL, NULL, 14123, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:40:42', 'admin-1509151411-15091548418143724', 1, 0, '', NULL, NULL, NULL),
(51907, '2017-10-28 09:40:42', NULL, NULL, 14123, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:40:42', 'admin-1509151411-15091548418143724', 1, 1, 'SR', NULL, NULL, NULL),
(51908, '2017-10-28 09:40:42', NULL, NULL, 14123, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:40:42', 'admin-1509151411-15091548418143724', 1, 1, 'SR', NULL, NULL, NULL),
(51909, '2017-10-28 09:40:47', NULL, NULL, 14123, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:40:47', 'admin-1509151411-15091548470183212', 1, 0, '', NULL, NULL, NULL),
(51910, '2017-10-28 09:40:00', NULL, NULL, 14123, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:40:00', 'admin-1509151411-15091548004242212', 1, 1, 'SR', NULL, NULL, NULL),
(51911, '2017-10-28 09:40:41', NULL, NULL, 14123, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:40:41', 'admin-1509151411-15091548418143724', 1, 1, 'SR', NULL, NULL, NULL),
(51912, '2017-10-28 09:41:09', NULL, NULL, 14124, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:41:09', 'admin-1509151411-15091548695419666', 1, 1, 'SR', NULL, NULL, NULL),
(51913, '2017-10-28 09:14:36', NULL, NULL, 14121, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:14:36', 'admin-1509151411-15091532763086969', 1, 0, '', NULL, NULL, NULL),
(51914, '2017-10-28 09:14:36', NULL, NULL, 14121, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:14:36', 'admin-1509151411-15091532763086969', 1, 0, '', NULL, NULL, NULL),
(51915, '2017-10-28 09:14:40', NULL, NULL, 14121, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:14:40', 'admin-1509151411-15091532806914339', 1, 1, 'SR', NULL, NULL, NULL),
(51916, '2017-10-28 09:14:40', NULL, NULL, 14121, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:14:40', 'admin-1509151411-15091532806914339', 1, 1, 'SR', NULL, NULL, NULL),
(51917, '2017-10-28 09:21:57', NULL, NULL, 14122, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:21:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51918, '2017-10-28 15:55:29', NULL, NULL, 14160, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 15:55:29', 'admin-1509173804-15091773289004785', 1, 1, 'SR', NULL, NULL, NULL),
(51919, '2017-10-28 09:40:57', NULL, NULL, 14124, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:40:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51920, '2017-10-28 11:21:32', NULL, NULL, 14140, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1509173804', 'admin', '2017-10-28 11:21:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51921, '2017-10-28 09:22:32', NULL, NULL, 14122, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:22:32', 'admin-1509151411-15091537520856150', 1, 1, 'SR', NULL, NULL, NULL),
(51922, '2017-10-28 09:22:32', NULL, NULL, 14122, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:22:32', 'admin-1509151411-15091537520856150', 1, 1, 'SR', NULL, NULL, NULL),
(51923, '2017-10-28 09:22:32', NULL, NULL, 14122, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:22:32', 'admin-1509151411-15091537520856150', 1, 1, 'SR', NULL, NULL, NULL),
(51924, '2017-10-28 09:22:32', NULL, NULL, 14122, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:22:32', 'admin-1509151411-15091537520856150', 1, 0, '', NULL, NULL, NULL),
(51925, '2017-10-28 09:39:28', NULL, NULL, 14123, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.60, 0.0000, 0.0000, 13.60, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:39:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51926, '2017-10-28 09:40:00', NULL, NULL, 14123, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:40:00', 'admin-1509151411-15091548004242212', 1, 0, '', NULL, NULL, NULL),
(51927, '2017-10-28 09:22:08', NULL, NULL, 14122, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:22:08', 'admin-1509151411-15091537283636938', 1, 0, '', NULL, NULL, NULL),
(51928, '2017-10-28 09:22:08', NULL, NULL, 14122, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:22:08', 'admin-1509151411-15091537283636938', 1, 0, '', NULL, NULL, NULL),
(51929, '2017-10-28 09:14:31', NULL, NULL, 14121, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1509173804', 'admin', '2017-10-28 09:14:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51930, '2017-10-29 15:18:22', NULL, NULL, 14213, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1509260716', 'admin', '2017-10-29 15:18:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51931, '2017-10-29 14:39:12', NULL, NULL, 14207, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:39:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51932, '2017-10-29 11:49:26', NULL, NULL, 14190, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:49:26', 'admin-1509246111-15092489659915551', 1, 1, 'SR', NULL, NULL, NULL),
(51933, '2017-10-29 10:06:02', NULL, NULL, 14170, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:06:02', 'admin-1509238833-15092427625694079', 1, 0, '', NULL, NULL, NULL),
(51934, '2017-10-29 10:08:52', NULL, NULL, 14171, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:08:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51935, '2017-10-29 10:09:13', NULL, NULL, 14171, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:09:13', 'admin-1509238833-15092429533903667', 1, 0, '', NULL, NULL, NULL),
(51936, '2017-10-29 10:09:13', NULL, NULL, 14171, 0, 181, '116', 'Open Food ', 'croissant', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:09:13', 'admin-1509238833-15092429533903667', 1, 0, '', NULL, NULL, NULL),
(51937, '2017-10-29 13:35:59', NULL, NULL, 14199, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:35:59', 'admin-1509249892-15092553590504442', 1, 0, '', NULL, NULL, NULL),
(51938, '2017-10-29 14:39:48', NULL, NULL, 14208, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:39:48', 'admin-1509257350-15092591882938633', 1, 1, 'SR', NULL, NULL, '10.0'),
(51939, '2017-10-29 14:39:48', NULL, NULL, 14208, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:39:48', 'admin-1509257350-15092591882938633', 1, 0, '', NULL, NULL, '10.0'),
(51940, '2017-10-29 14:17:22', NULL, NULL, 14203, 0, 215, '149', 'Thai Fish Sauce Garlic Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:17:22', 'admin-1509257350-15092578420438434', 1, 0, '', NULL, NULL, NULL),
(51941, '2017-10-29 15:15:58', NULL, NULL, 14207, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 15:15:58', 'admin-1509260716-15092613586702438', 1, 1, 'SR', NULL, NULL, NULL),
(51942, '2017-10-29 14:24:23', NULL, NULL, 14206, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:24:23', 'admin-1509257350-15092582632769328', 1, 0, '', NULL, NULL, NULL),
(51943, '2017-10-29 14:16:33', NULL, NULL, 14202, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:16:33', 'admin-1509257350-15092577935187633', 1, 0, '', NULL, NULL, NULL),
(51944, '2017-10-29 13:24:11', NULL, NULL, 14197, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:24:11', 'admin-1509249892-1509254651300480', 1, 0, '', NULL, NULL, NULL),
(51945, '2017-10-29 13:24:11', NULL, NULL, 14197, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:24:11', 'admin-1509249892-1509254651300480', 1, 1, 'SR', NULL, NULL, NULL),
(51946, '2017-10-29 13:24:11', NULL, NULL, 14197, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:24:11', 'admin-1509249892-1509254651300480', 1, 1, 'SR', NULL, NULL, NULL),
(51947, '2017-10-29 14:24:08', NULL, NULL, 14206, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:24:08', 'admin-1509257350-15092582480238826', 1, 0, '', NULL, NULL, NULL),
(51948, '2017-10-29 14:18:44', NULL, NULL, 14205, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:18:44', 'admin-1509257350-1509257924239791', 1, 1, 'SR', 1, NULL, NULL),
(51949, '2017-10-29 14:20:23', NULL, NULL, 14204, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:20:23', 'admin-1509257350-15092580236068265', 1, 1, 'SR', NULL, NULL, NULL),
(51950, '2017-10-29 14:22:47', NULL, NULL, 14206, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:22:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51951, '2017-10-29 12:19:50', NULL, NULL, 14194, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 12:19:50', 'admin-1509249892-15092507904461286', 1, 0, '', NULL, NULL, NULL),
(51952, '2017-10-29 12:26:27', NULL, NULL, 14193, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 12:26:27', 'admin-1509249892-15092511873526464', 1, 0, '', NULL, NULL, NULL),
(51953, '2017-10-29 12:58:54', NULL, NULL, 14180, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 12:58:54', 'admin-1509249892-15092531343996287', 1, 0, '', NULL, NULL, NULL),
(51954, '2017-10-29 13:09:11', NULL, NULL, 14195, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:09:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51955, '2017-10-29 13:09:30', NULL, NULL, 14195, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:09:30', 'admin-1509249892-15092537702292260', 1, 1, 'SR', NULL, NULL, NULL),
(51956, '2017-10-29 12:15:49', NULL, NULL, 14193, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 12:15:49', 'admin-1509249892-1509250549144116', 1, 0, '', NULL, NULL, NULL),
(51957, '2017-10-29 13:33:50', NULL, NULL, 14199, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:33:50', 'admin-1509249892-15092552303875654', 1, 0, '', NULL, NULL, NULL),
(51958, '2017-10-29 13:33:50', NULL, NULL, 14199, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:33:50', 'admin-1509249892-15092552303875654', 1, 0, '', NULL, NULL, NULL),
(51959, '2017-10-29 13:33:50', NULL, NULL, 14199, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:33:50', 'admin-1509249892-15092552303875654', 1, 1, 'SR', NULL, NULL, NULL),
(51960, '2017-10-29 12:15:10', NULL, NULL, 14193, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 12:15:10', 'admin-1509249892-1509250510699903', 1, 0, '', NULL, NULL, NULL),
(51961, '2017-10-29 14:18:28', NULL, NULL, 14204, 0, 153, '87', 'Wake Me Up!', 'black plate', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:18:28', 'admin-1509257350-15092579080103524', 1, 0, '', NULL, NULL, NULL),
(51962, '2017-10-29 14:18:28', NULL, NULL, 14204, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:18:28', 'admin-1509257350-15092579080103524', 1, 0, '', NULL, NULL, NULL),
(51963, '2017-10-29 14:18:06', NULL, NULL, 14204, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:18:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51964, '2017-10-29 11:49:26', NULL, NULL, 14190, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:49:26', 'admin-1509246111-15092489659915551', 1, 0, '', NULL, NULL, NULL),
(51965, '2017-10-29 10:46:29', NULL, NULL, 14177, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:46:29', 'admin-1509243968-15092451893688144', 1, 0, '', NULL, NULL, NULL),
(51966, '2017-10-29 10:46:29', NULL, NULL, 14177, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:46:29', 'admin-1509243968-15092451893688144', 1, 1, 'SR', NULL, NULL, NULL),
(51967, '2017-10-29 16:23:34', NULL, NULL, 14216, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 16:23:34', 'admin-1509260716-15092654147306357', 1, 1, 'SR', 1, NULL, NULL),
(51968, '2017-10-29 16:03:39', NULL, NULL, 14215, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 16:03:39', 'admin-1509260716-15092642195697191', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(51969, '2017-10-29 16:03:23', NULL, NULL, 14215, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1509260716', 'admin', '2017-10-29 16:03:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51970, '2017-10-29 16:03:39', NULL, NULL, 14215, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 16:03:39', 'admin-1509260716-15092642195697191', 1, 1, 'SR', NULL, NULL, NULL),
(51971, '2017-10-29 16:03:39', NULL, NULL, 14215, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 16:03:39', 'admin-1509260716-15092642195697191', 1, 1, 'SR', NULL, NULL, NULL),
(51972, '2017-10-29 15:58:47', NULL, NULL, 14214, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 15:58:47', 'admin-1509260716-15092639277551423', 1, 1, 'SR', NULL, NULL, NULL),
(51973, '2017-10-29 15:58:42', NULL, NULL, 14214, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1509260716', 'admin', '2017-10-29 15:58:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51974, '2017-10-29 15:19:14', NULL, NULL, 14213, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 15:19:14', 'admin-1509260716-15092615541735688', 1, 1, 'SR', NULL, NULL, NULL),
(51975, '2017-10-29 12:15:49', NULL, NULL, 14193, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 12:15:49', 'admin-1509249892-1509250549144116', 1, 1, 'SR', NULL, NULL, NULL),
(51976, '2017-10-29 15:19:14', NULL, NULL, 14213, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 15:19:14', 'admin-1509260716-15092615541735688', 1, 1, 'SR', NULL, NULL, NULL),
(51977, '2017-10-29 15:19:14', NULL, NULL, 14213, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 15:19:14', 'admin-1509260716-15092615541735688', 1, 0, '', NULL, NULL, NULL),
(51978, '2017-10-29 15:19:14', NULL, NULL, 14213, 0, 211, '145', 'Asian Spicy Lemony Chicken', 'less spicy', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 15:19:14', 'admin-1509260716-15092615541735688', 1, 0, '', NULL, NULL, NULL),
(51979, '2017-10-29 10:52:13', NULL, NULL, 14179, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:52:13', 'admin-1509243968-1509245532897394', 1, 0, '', NULL, NULL, NULL),
(51980, '2017-10-29 10:52:13', NULL, NULL, 14179, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:52:13', 'admin-1509243968-1509245532897394', 1, 0, '', NULL, NULL, NULL),
(51981, '2017-10-29 15:05:03', NULL, NULL, 14211, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1509260716', 'admin', '2017-10-29 15:05:03', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(51982, '2017-10-29 15:05:09', NULL, NULL, 14211, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 15:05:09', 'admin-1509257350-15092607093134973', 1, 0, '', NULL, NULL, '10.0'),
(51983, '2017-10-29 15:17:50', NULL, NULL, 14212, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1509260716', 'admin', '2017-10-29 15:17:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51984, '2017-10-29 15:18:07', NULL, NULL, 14212, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 15:18:07', 'admin-1509260716-15092614870876083', 1, 0, '', NULL, NULL, NULL),
(51985, '2017-10-29 14:17:22', NULL, NULL, 14203, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:17:22', 'admin-1509257350-15092578420438434', 1, 0, '', NULL, NULL, NULL),
(51986, '2017-10-29 13:24:11', NULL, NULL, 14197, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:24:11', 'admin-1509249892-1509254651300480', 1, 1, 'SR', NULL, NULL, NULL),
(51987, '2017-10-29 12:04:05', NULL, NULL, 14191, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1509260716', 'admin', '2017-10-29 12:04:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51988, '2017-10-29 12:04:20', NULL, NULL, 14191, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 12:04:20', 'admin-1509246111-15092498600336942', 1, 0, '', NULL, NULL, NULL),
(51989, '2017-10-29 12:13:10', NULL, NULL, 14192, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1509260716', 'admin', '2017-10-29 12:13:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51990, '2017-10-29 12:13:18', NULL, NULL, 14192, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 12:13:18', 'admin-1509249892-15092503979575891', 1, 0, '', NULL, NULL, NULL),
(51991, '2017-10-29 14:39:48', NULL, NULL, 14208, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:39:48', 'admin-1509257350-15092591882938633', 1, 1, 'SR', NULL, NULL, '10.0'),
(51992, '2017-10-29 14:58:52', NULL, NULL, 14210, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:58:52', 'admin-1509257350-15092603324669289', 1, 1, 'SR', 1, NULL, NULL),
(51993, '2017-10-29 14:59:39', NULL, NULL, 14209, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:59:39', 'admin-1509257350-15092603788812213', 1, 0, '', NULL, NULL, NULL),
(51994, '2017-10-29 14:58:52', NULL, NULL, 14210, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:58:52', 'admin-1509257350-15092603324669289', 1, 1, 'SR', 1, NULL, NULL),
(51995, '2017-10-29 13:23:19', NULL, NULL, 14197, 0, 181, '116', 'Open Food ', 'smoked duck salad no nuts', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:23:19', 'admin-1509249892-15092545992264957', 1, 0, '', NULL, NULL, NULL),
(51996, '2017-10-29 14:56:42', NULL, NULL, 14209, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:56:42', 'admin-1509257350-1509260202434816', 1, 1, 'SR', NULL, NULL, NULL),
(51997, '2017-10-29 13:58:35', NULL, NULL, 14201, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:58:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(51998, '2017-10-29 12:13:18', NULL, NULL, 14192, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 12:13:18', 'admin-1509249892-15092503979575891', 1, 0, '', NULL, NULL, NULL),
(51999, '2017-10-29 14:17:09', NULL, NULL, 14203, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:17:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52000, '2017-10-29 14:04:00', NULL, NULL, 14201, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:04:00', 'admin-1509249892-15092570398238323', 1, 1, 'SR', NULL, NULL, NULL),
(52001, '2017-10-29 14:04:00', NULL, NULL, 14201, 0, 181, '116', 'Open Food ', 'banana is on fire', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:04:00', 'admin-1509249892-15092570398238323', 1, 0, '', NULL, NULL, NULL),
(52002, '2017-10-29 14:03:59', NULL, NULL, 14201, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:03:59', 'admin-1509249892-15092570398238323', 1, 0, '', NULL, NULL, NULL),
(52003, '2017-10-29 13:58:44', NULL, NULL, 14201, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:58:44', 'admin-1509249892-15092567238945884', 1, 1, 'SR', NULL, NULL, NULL),
(52004, '2017-10-29 10:25:47', NULL, NULL, 14173, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:25:47', 'admin-1509238833-15092439472189222', 1, 0, '', NULL, NULL, NULL),
(52005, '2017-10-29 13:45:55', NULL, NULL, 14195, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:45:55', 'admin-1509249892-15092559555065636', 1, 1, 'SR', NULL, NULL, NULL),
(52006, '2017-10-29 13:47:55', NULL, NULL, 14197, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:47:55', 'admin-1509249892-15092560752577131', 1, 0, '', NULL, NULL, NULL),
(52007, '2017-10-29 13:39:15', NULL, NULL, 14200, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:39:15', 'admin-1509249892-1509255555313954', 1, 0, '', NULL, NULL, NULL),
(52008, '2017-10-29 10:46:06', NULL, NULL, 14177, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:46:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52009, '2017-10-29 10:46:29', NULL, NULL, 14177, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:46:29', 'admin-1509243968-15092451893688144', 1, 0, '', NULL, NULL, NULL),
(52010, '2017-10-29 10:44:04', NULL, NULL, 14176, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:44:04', 'admin-1509243968-1509245044295172', 1, 0, '', NULL, NULL, NULL),
(52011, '2017-10-29 11:40:02', NULL, NULL, 14186, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:40:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52012, '2017-10-29 14:56:30', NULL, NULL, 14209, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.59, 0.0000, 0.0000, 1.59, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:56:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52013, '2017-10-29 14:39:31', NULL, NULL, 14208, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:39:31', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(52014, '2017-10-29 14:25:33', NULL, NULL, 14204, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:25:33', 'admin-1509257350-15092583336537861', 1, 0, '', NULL, NULL, NULL),
(52015, '2017-10-29 14:25:33', NULL, NULL, 14204, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:25:33', 'admin-1509257350-15092583336537861', 1, 0, '', NULL, NULL, NULL),
(52016, '2017-10-29 13:33:07', NULL, NULL, 14199, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.70, 0.0000, 0.0000, 9.70, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:33:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52017, '2017-10-29 11:46:42', NULL, NULL, 14189, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:46:42', 'admin-1509246111-15092488020898011', 1, 0, '', NULL, NULL, NULL),
(52018, '2017-10-29 13:39:15', NULL, NULL, 14200, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:39:15', 'admin-1509249892-1509255555313954', 1, 0, '', NULL, NULL, NULL),
(52019, '2017-10-29 13:33:50', NULL, NULL, 14199, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:33:50', 'admin-1509249892-15092552303875654', 1, 1, 'SR', NULL, NULL, NULL),
(52020, '2017-10-29 13:33:50', NULL, NULL, 14199, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:33:50', 'admin-1509249892-15092552303875654', 1, 1, 'SR', NULL, NULL, NULL),
(52021, '2017-10-29 10:06:02', NULL, NULL, 14170, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:06:02', 'admin-1509238833-15092427625694079', 1, 0, '', NULL, NULL, NULL),
(52022, '2017-10-29 10:06:02', NULL, NULL, 14170, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:06:02', 'admin-1509238833-15092427625694079', 1, 0, '', NULL, NULL, NULL),
(52023, '2017-10-29 10:06:02', NULL, NULL, 14170, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:06:02', 'admin-1509238833-15092427625694079', 1, 0, '', NULL, NULL, NULL),
(52024, '2017-10-29 13:20:57', NULL, NULL, 14196, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:20:57', 'admin-1509249892-15092544570725440', 1, 0, '', NULL, NULL, NULL),
(52025, '2017-10-29 14:34:07', NULL, NULL, 14206, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:34:07', 'admin-1509257350-15092588471071286', 1, 0, '', NULL, NULL, NULL),
(52026, '2017-10-29 14:16:26', NULL, NULL, 14202, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:16:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52027, '2017-10-29 13:22:13', NULL, NULL, 14197, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.70, 0.0000, 0.0000, 11.70, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:22:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52028, '2017-10-29 11:09:54', NULL, NULL, 14182, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:09:54', 'admin-1509246111-15092465946095544', 1, 1, 'SR', NULL, NULL, NULL),
(52029, '2017-10-29 12:04:45', NULL, NULL, 14191, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 12:04:45', 'admin-1509246111-15092498852278025', 1, 0, '', NULL, NULL, NULL),
(52030, '2017-10-29 13:23:19', NULL, NULL, 14197, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:23:19', 'admin-1509249892-15092545992264957', 1, 0, '', NULL, NULL, NULL),
(52031, '2017-10-29 13:23:19', NULL, NULL, 14197, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:23:19', 'admin-1509249892-15092545992264957', 1, 0, '', NULL, NULL, NULL),
(52032, '2017-10-29 13:23:19', NULL, NULL, 14197, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:23:19', 'admin-1509249892-15092545992264957', 1, 0, '', NULL, NULL, NULL),
(52033, '2017-10-29 13:20:57', NULL, NULL, 14196, 0, 181, '116', 'Open Food ', 'banana on fire', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:20:57', 'admin-1509249892-15092544570725440', 1, 0, '', NULL, NULL, NULL),
(52034, '2017-10-29 13:23:19', NULL, NULL, 14197, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:23:19', 'admin-1509249892-15092545992264957', 1, 0, '', NULL, NULL, NULL),
(52035, '2017-10-29 13:20:57', NULL, NULL, 14196, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:20:57', 'admin-1509249892-15092544570725440', 1, 1, 'SR', NULL, NULL, NULL),
(52036, '2017-10-29 13:19:21', NULL, NULL, 14196, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:19:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52037, '2017-10-29 13:09:36', NULL, NULL, 14195, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:09:36', 'admin-1509249892-15092537767837841', 1, 1, 'SR', NULL, NULL, NULL),
(52038, '2017-10-29 13:33:50', NULL, NULL, 14199, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:33:50', 'admin-1509249892-15092552303875654', 1, 0, '', NULL, NULL, NULL),
(52039, '2017-10-29 11:11:14', NULL, NULL, 14183, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:11:14', 'admin-1509246111-15092466738525473', 1, 0, '', NULL, NULL, NULL),
(52040, '2017-10-29 11:23:25', NULL, NULL, 14184, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:23:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52041, '2017-10-29 11:23:38', NULL, NULL, 14184, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:23:38', 'admin-1509246111-15092474179267968', 1, 0, '', NULL, NULL, NULL),
(52042, '2017-10-29 11:23:38', NULL, NULL, 14184, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:23:38', 'admin-1509246111-15092474179267968', 1, 0, '', NULL, NULL, NULL),
(52043, '2017-10-29 11:23:38', NULL, NULL, 14184, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:23:38', 'admin-1509246111-15092474179267968', 1, 1, 'SR', NULL, NULL, NULL),
(52044, '2017-10-29 11:23:38', NULL, NULL, 14184, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:23:38', 'admin-1509246111-15092474179267968', 1, 1, 'SR', NULL, NULL, NULL),
(52045, '2017-10-29 11:09:54', NULL, NULL, 14182, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:09:54', 'admin-1509246111-15092465946095544', 1, 0, '', NULL, NULL, NULL),
(52046, '2017-10-29 11:40:53', NULL, NULL, 14187, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:40:53', 'admin-1509246111-15092484529742729', 1, 1, 'SR', NULL, NULL, NULL),
(52047, '2017-10-29 12:19:50', NULL, NULL, 14194, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 12:19:50', 'admin-1509249892-15092507904461286', 1, 0, '', NULL, NULL, NULL),
(52048, '2017-10-29 12:15:49', NULL, NULL, 14193, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 12:15:49', 'admin-1509249892-1509250549144116', 1, 0, '', NULL, NULL, NULL),
(52049, '2017-10-29 11:09:21', NULL, NULL, 14182, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:09:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52050, '2017-10-29 11:09:54', NULL, NULL, 14182, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:09:54', 'admin-1509246111-15092465946095544', 1, 0, '', NULL, NULL, NULL),
(52051, '2017-10-29 11:09:54', NULL, NULL, 14182, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:09:54', 'admin-1509246111-15092465946095544', 1, 0, '', NULL, NULL, NULL),
(52052, '2017-10-29 12:15:49', NULL, NULL, 14193, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 12:15:49', 'admin-1509249892-1509250549144116', 1, 1, 'SR', NULL, NULL, NULL),
(52053, '2017-10-29 12:15:49', NULL, NULL, 14193, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 12:15:49', 'admin-1509249892-1509250549144116', 1, 0, '', NULL, NULL, NULL),
(52054, '2017-10-29 14:39:27', NULL, NULL, 14207, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:39:27', 'admin-1509257350-15092591669032443', 1, 1, 'SR', NULL, NULL, NULL),
(52055, '2017-10-29 14:39:27', NULL, NULL, 14207, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:39:27', 'admin-1509257350-15092591669032443', 1, 0, '', NULL, NULL, NULL),
(52056, '2017-10-29 12:14:56', NULL, NULL, 14193, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.80, 0.0000, 0.0000, 10.80, 1, '27', 1, '1509260716', 'admin', '2017-10-29 12:14:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52057, '2017-10-29 11:54:29', NULL, NULL, 14185, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:54:29', 'admin-1509246111-15092492694182882', 1, 1, 'SR', NULL, NULL, NULL),
(52058, '2017-10-29 10:04:17', NULL, NULL, 14169, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:04:17', 'admin-1509238833-15092426571006345', 1, 0, '', NULL, NULL, NULL),
(52059, '2017-10-29 10:04:28', NULL, NULL, 14169, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:04:28', 'admin-1509238833-15092426681792917', 1, 1, 'SR', NULL, NULL, NULL),
(52060, '2017-10-29 10:04:28', NULL, NULL, 14169, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:04:28', 'admin-1509238833-15092426681792917', 1, 1, 'SR', NULL, NULL, NULL),
(52061, '2017-10-29 09:21:52', NULL, NULL, 14168, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 09:21:52', 'admin-1509238833-1509240111904665', 1, 0, '', NULL, NULL, '10.0'),
(52062, '2017-10-29 09:21:52', NULL, NULL, 14168, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 09:21:52', 'admin-1509238833-1509240111904665', 1, 0, '', NULL, NULL, '10.0'),
(52063, '2017-10-29 12:15:49', NULL, NULL, 14193, 0, 301, '237', 'Black Jack', '', 'Cold Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 12:15:49', 'admin-1509249892-1509250549144116', 1, 0, '', NULL, NULL, NULL),
(52064, '2017-10-29 12:04:20', NULL, NULL, 14191, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 12:04:20', 'admin-1509246111-15092498600336942', 1, 1, 'SR', NULL, NULL, NULL),
(52065, '2017-10-29 12:04:20', NULL, NULL, 14191, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 12:04:20', 'admin-1509246111-15092498600336942', 1, 1, 'SR', NULL, NULL, NULL),
(52066, '2017-10-29 11:49:26', NULL, NULL, 14190, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:49:26', 'admin-1509246111-15092489659915551', 1, 1, 'SR', NULL, NULL, NULL),
(52067, '2017-10-29 11:36:57', NULL, NULL, 14181, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:36:57', 'admin-1509246111-15092482176528522', 1, 1, 'SR', NULL, NULL, NULL),
(52068, '2017-10-29 10:44:04', NULL, NULL, 14176, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:44:04', 'admin-1509243968-1509245044295172', 1, 0, '', NULL, NULL, NULL),
(52069, '2017-10-29 11:54:29', NULL, NULL, 14185, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:54:29', 'admin-1509246111-15092492694182882', 1, 0, '', NULL, NULL, NULL),
(52070, '2017-10-29 12:19:50', NULL, NULL, 14194, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 12:19:50', 'admin-1509249892-15092507904461286', 1, 0, '', NULL, NULL, NULL),
(52071, '2017-10-29 10:57:01', NULL, NULL, 14180, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:57:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52072, '2017-10-29 10:57:32', NULL, NULL, 14180, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:57:32', 'admin-1509243968-15092458523877250', 1, 0, '', NULL, NULL, NULL),
(52073, '2017-10-29 10:57:32', NULL, NULL, 14180, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:57:32', 'admin-1509243968-15092458523877250', 1, 0, '', NULL, NULL, NULL),
(52074, '2017-10-29 10:57:32', NULL, NULL, 14180, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:57:32', 'admin-1509243968-15092458523877250', 1, 1, 'SR', NULL, NULL, NULL),
(52075, '2017-10-29 10:57:32', NULL, NULL, 14180, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:57:32', 'admin-1509243968-15092458523877250', 1, 1, 'SR', NULL, NULL, NULL),
(52076, '2017-10-29 11:01:10', NULL, NULL, 14181, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:01:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52077, '2017-10-29 11:01:45', NULL, NULL, 14181, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:01:45', 'admin-1509243968-15092461053309782', 1, 0, '', NULL, NULL, NULL),
(52078, '2017-10-29 11:01:45', NULL, NULL, 14181, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:01:45', 'admin-1509243968-15092461053309782', 1, 0, '', NULL, NULL, NULL),
(52079, '2017-10-29 11:01:45', NULL, NULL, 14181, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:01:45', 'admin-1509243968-15092461053309782', 1, 1, 'SR', NULL, NULL, NULL),
(52080, '2017-10-29 11:49:26', NULL, NULL, 14190, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:49:26', 'admin-1509246111-15092489659915551', 1, 0, '', NULL, NULL, NULL),
(52081, '2017-10-29 11:49:06', NULL, NULL, 14190, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:49:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52082, '2017-10-29 11:46:42', NULL, NULL, 14189, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:46:42', 'admin-1509246111-15092488020898011', 1, 1, 'SR', NULL, NULL, NULL),
(52083, '2017-10-29 11:42:58', NULL, NULL, 14188, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:42:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52084, '2017-10-29 11:33:46', NULL, NULL, 14185, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:33:47', 'admin-1509246111-15092480268155192', 1, 0, '', NULL, NULL, NULL),
(52085, '2017-10-29 11:43:04', NULL, NULL, 14188, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:43:04', 'admin-1509246111-15092485839758439', 1, 0, '', NULL, NULL, NULL),
(52086, '2017-10-29 11:40:33', NULL, NULL, 14187, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:40:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52087, '2017-10-29 11:40:53', NULL, NULL, 14187, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:40:53', 'admin-1509246111-15092484529742729', 1, 1, 'SR', NULL, NULL, NULL),
(52088, '2017-10-29 11:40:24', NULL, NULL, 14186, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:40:24', 'admin-1509246111-15092484242684744', 1, 1, 'SR', NULL, NULL, NULL),
(52089, '2017-10-29 11:40:24', NULL, NULL, 14186, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:40:24', 'admin-1509246111-15092484242684744', 1, 1, 'SR', NULL, NULL, NULL),
(52090, '2017-10-29 11:40:24', NULL, NULL, 14186, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:40:24', 'admin-1509246111-15092484242684744', 1, 0, '', NULL, NULL, NULL),
(52091, '2017-10-29 11:40:24', NULL, NULL, 14186, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:40:24', 'admin-1509246111-15092484242684744', 1, 0, '', NULL, NULL, NULL),
(52092, '2017-10-29 11:33:47', NULL, NULL, 14185, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:33:47', 'admin-1509246111-15092480268155192', 1, 0, '', NULL, NULL, NULL),
(52093, '2017-10-29 11:33:47', NULL, NULL, 14185, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:33:47', 'admin-1509246111-15092480268155192', 1, 1, 'SR', NULL, NULL, NULL),
(52094, '2017-10-29 09:14:35', NULL, NULL, 14166, 0, 158, '92', 'Banana Stuffed Nutella Toast ', ' no honey,no cream', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 09:14:35', 'admin-1509238833-15092396753526778', 1, 0, '', NULL, NULL, NULL),
(52095, '2017-10-29 11:33:30', NULL, NULL, 14185, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:33:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52096, '2017-10-29 11:33:47', NULL, NULL, 14185, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:33:47', 'admin-1509246111-15092480268155192', 1, 0, '', NULL, NULL, NULL),
(52097, '2017-10-29 13:09:30', NULL, NULL, 14195, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:09:30', 'admin-1509249892-15092537702292260', 1, 0, '', NULL, NULL, NULL),
(52098, '2017-10-29 11:11:14', NULL, NULL, 14183, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:11:14', 'admin-1509246111-15092466738525473', 1, 1, 'SR', NULL, NULL, NULL),
(52099, '2017-10-29 11:11:14', NULL, NULL, 14183, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:11:14', 'admin-1509246111-15092466738525473', 1, 0, '', NULL, NULL, NULL),
(52100, '2017-10-29 11:11:14', NULL, NULL, 14183, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:11:14', 'admin-1509246111-15092466738525473', 1, 0, '', NULL, NULL, NULL),
(52101, '2017-10-29 13:09:30', NULL, NULL, 14195, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:09:30', 'admin-1509249892-15092537702292260', 1, 0, '', NULL, NULL, NULL),
(52102, '2017-10-29 11:09:54', NULL, NULL, 14182, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:09:54', 'admin-1509246111-15092465946095544', 1, 0, '', NULL, NULL, NULL),
(52103, '2017-10-29 10:29:26', NULL, NULL, 14174, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:29:26', 'admin-1509243968-15092441659351854', 1, 1, 'SR', NULL, NULL, NULL),
(52104, '2017-10-29 11:09:54', NULL, NULL, 14182, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:09:54', 'admin-1509246111-15092465946095544', 1, 1, 'SR', NULL, NULL, NULL),
(52105, '2017-10-29 10:31:15', NULL, NULL, 14172, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:31:15', 'admin-1509243968-15092442751225188', 1, 0, '', NULL, NULL, NULL),
(52106, '2017-10-29 11:01:45', NULL, NULL, 14181, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:01:45', 'admin-1509243968-15092461053309782', 1, 0, '', NULL, NULL, NULL),
(52107, '2017-10-29 10:05:18', NULL, NULL, 14170, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.50, 0.0000, 0.0000, 9.50, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:05:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52108, '2017-10-29 11:09:54', NULL, NULL, 14182, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:09:54', 'admin-1509246111-15092465946095544', 1, 0, '', NULL, NULL, NULL),
(52109, '2017-10-29 14:39:48', NULL, NULL, 14208, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:39:48', 'admin-1509257350-15092591882938633', 1, 1, 'SR', NULL, NULL, '10.0'),
(52110, '2017-10-29 13:39:00', NULL, NULL, 14200, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1509260716', 'admin', '2017-10-29 13:39:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52111, '2017-10-29 14:17:22', NULL, NULL, 14203, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:17:22', 'admin-1509257350-15092578420438434', 1, 1, 'SR', NULL, NULL, NULL),
(52112, '2017-10-29 12:19:36', NULL, NULL, 14194, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1509260716', 'admin', '2017-10-29 12:19:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52113, '2017-10-29 10:44:04', NULL, NULL, 14176, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:44:04', 'admin-1509243968-1509245044295172', 1, 0, '', NULL, NULL, NULL),
(52114, '2017-10-29 15:19:14', NULL, NULL, 14213, 0, 192, '127', 'Flaming Hot & Spicy Pork', 'less spicy', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 15:19:14', 'admin-1509260716-15092615541735688', 1, 0, '', NULL, NULL, NULL),
(52115, '2017-10-29 10:52:13', NULL, NULL, 14179, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:52:13', 'admin-1509243968-1509245532897394', 1, 0, '', NULL, NULL, NULL),
(52116, '2017-10-29 10:51:54', NULL, NULL, 14179, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:51:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52117, '2017-10-29 10:25:47', NULL, NULL, 14173, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:25:47', 'admin-1509238833-15092439472189222', 1, 0, '', NULL, NULL, NULL),
(52118, '2017-10-29 10:42:48', NULL, NULL, 14175, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:42:48', 'admin-1509243968-15092449681753588', 1, 0, '', NULL, NULL, NULL),
(52119, '2017-10-29 10:42:48', NULL, NULL, 14175, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:42:48', 'admin-1509243968-15092449681753588', 1, 0, '', NULL, NULL, NULL),
(52120, '2017-10-29 10:43:02', NULL, NULL, 14175, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:43:02', 'admin-1509243968-15092449824413165', 1, 1, 'SR', NULL, NULL, NULL),
(52121, '2017-10-29 10:43:02', NULL, NULL, 14175, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:43:02', 'admin-1509243968-15092449824413165', 1, 1, 'SR', NULL, NULL, NULL),
(52122, '2017-10-29 10:29:26', NULL, NULL, 14174, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:29:26', 'admin-1509243968-15092441659351854', 1, 1, 'SR', NULL, NULL, NULL),
(52123, '2017-10-29 10:44:04', NULL, NULL, 14176, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:44:04', 'admin-1509243968-1509245044295172', 1, 1, 'SR', NULL, NULL, NULL),
(52124, '2017-10-29 10:10:33', NULL, NULL, 14171, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:10:33', 'admin-1509238833-15092430327945457', 1, 1, 'SR', NULL, NULL, NULL),
(52125, '2017-10-29 10:15:16', NULL, NULL, 14172, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 17.50, 0.0000, 0.0000, 17.50, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:15:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52126, '2017-10-29 10:16:07', NULL, NULL, 14172, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:16:07', 'admin-1509238833-15092433678171199', 1, 0, '', NULL, NULL, NULL),
(52127, '2017-10-29 10:42:43', NULL, NULL, 14175, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:42:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52128, '2017-10-29 15:18:07', NULL, NULL, 14212, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 15:18:07', 'admin-1509260716-15092614870876083', 1, 0, '', NULL, NULL, NULL),
(52129, '2017-10-29 11:10:57', NULL, NULL, 14183, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:10:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52130, '2017-10-29 14:18:44', NULL, NULL, 14205, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:18:44', 'admin-1509257350-1509257924239791', 1, 1, 'SR', 1, NULL, NULL),
(52131, '2017-10-29 11:46:33', NULL, NULL, 14189, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1509260716', 'admin', '2017-10-29 11:46:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52132, '2017-10-29 10:31:22', NULL, NULL, 14171, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:31:22', 'admin-1509243968-15092442822276320', 1, 0, '', NULL, NULL, NULL),
(52133, '2017-10-29 10:29:26', NULL, NULL, 14174, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:29:26', 'admin-1509243968-15092441659351854', 1, 0, '', NULL, NULL, NULL),
(52134, '2017-10-29 10:19:48', NULL, NULL, 14172, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:19:48', 'admin-1509238833-15092435881324028', 1, 0, '', NULL, NULL, NULL),
(52135, '2017-10-29 10:48:28', NULL, NULL, 14169, 0, 207, '142', 'Cheesy Bacon Toast', 'Takeaway', 'Meals', 'Morning Bites ', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:48:28', 'admin-1509243968-15092453080061790', 1, 0, '', NULL, NULL, NULL),
(52136, '2017-10-29 10:29:26', NULL, NULL, 14174, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:29:26', 'admin-1509243968-15092441659351854', 1, 0, '', NULL, NULL, NULL),
(52137, '2017-10-29 10:29:12', NULL, NULL, 14174, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:29:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52138, '2017-10-29 10:27:48', NULL, NULL, 14170, 0, 181, '116', 'Open Food ', 'banana is on fire', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:27:48', 'admin-1509243968-15092440683921536', 1, 0, '', NULL, NULL, NULL),
(52139, '2017-10-29 10:26:05', NULL, NULL, 14173, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:26:05', 'admin-1509238833-1509243962464494', 1, 1, 'SR', NULL, NULL, NULL),
(52140, '2017-10-29 10:26:05', NULL, NULL, 14173, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:26:05', 'admin-1509238833-1509243962464494', 1, 1, 'SR', NULL, NULL, NULL),
(52141, '2017-10-29 10:43:48', NULL, NULL, 14176, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:43:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52142, '2017-10-29 10:26:05', NULL, NULL, 14173, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:26:05', 'admin-1509238833-1509243962464494', 1, 1, 'SR', NULL, NULL, NULL),
(52143, '2017-10-29 10:19:54', NULL, NULL, 14172, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:19:54', 'admin-1509238833-15092435939844368', 1, 0, '', NULL, NULL, NULL),
(52144, '2017-10-29 10:25:39', NULL, NULL, 14173, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.10, 0.0000, 0.0000, 11.10, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:25:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52145, '2017-10-29 10:25:47', NULL, NULL, 14173, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:25:47', 'admin-1509238833-15092439472189222', 1, 0, '', NULL, NULL, NULL),
(52146, '2017-10-29 10:16:08', NULL, NULL, 14172, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:16:08', 'admin-1509238833-15092433678171199', 1, 1, 'SR', NULL, NULL, NULL),
(52147, '2017-10-29 10:16:08', NULL, NULL, 14172, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:16:08', 'admin-1509238833-15092433678171199', 1, 1, 'SR', NULL, NULL, NULL),
(52148, '2017-10-29 10:16:08', NULL, NULL, 14172, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:16:08', 'admin-1509238833-15092433678171199', 1, 0, '', NULL, NULL, NULL),
(52149, '2017-10-29 10:16:07', NULL, NULL, 14172, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:16:07', 'admin-1509238833-15092433678171199', 1, 0, '', NULL, NULL, NULL),
(52150, '2017-10-29 10:16:07', NULL, NULL, 14172, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:16:08', 'admin-1509238833-15092433678171199', 1, 0, '', NULL, NULL, NULL),
(52151, '2017-10-29 10:16:08', NULL, NULL, 14172, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:16:08', 'admin-1509238833-15092433678171199', 1, 0, '', NULL, NULL, NULL),
(52152, '2017-10-29 10:16:08', NULL, NULL, 14172, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:16:08', 'admin-1509238833-15092433678171199', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(52153, '2017-10-29 10:16:08', NULL, NULL, 14172, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:16:08', 'admin-1509238833-15092433678171199', 1, 0, '', NULL, NULL, NULL),
(52154, '2017-10-29 10:16:08', NULL, NULL, 14172, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:16:08', 'admin-1509238833-15092433678171199', 1, 0, '', NULL, NULL, NULL),
(52155, '2017-10-29 10:25:47', NULL, NULL, 14173, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:25:47', 'admin-1509238833-15092439472189222', 1, 0, '', NULL, NULL, NULL),
(52156, '2017-10-29 09:16:42', NULL, NULL, 14167, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 09:16:42', 'admin-1509238833-1509239801926347', 1, 0, '', NULL, NULL, NULL),
(52157, '2017-10-29 09:16:42', NULL, NULL, 14167, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 09:16:42', 'admin-1509238833-1509239801926347', 1, 1, 'SR', NULL, NULL, NULL),
(52158, '2017-10-29 09:21:27', NULL, NULL, 14168, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.50, 0.0000, 0.0000, 10.50, 1, '27', 1, '1509260716', 'admin', '2017-10-29 09:21:27', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(52159, '2017-10-29 09:21:52', NULL, NULL, 14168, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 09:21:52', 'admin-1509238833-1509240111904665', 1, 0, '', NULL, NULL, '10.0'),
(52160, '2017-10-29 09:21:52', NULL, NULL, 14168, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 09:21:52', 'admin-1509238833-1509240111904665', 1, 0, '', NULL, NULL, '10.0'),
(52161, '2017-10-29 14:24:23', NULL, NULL, 14206, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 14:24:23', 'admin-1509257350-15092582632769328', 1, 1, 'SR', NULL, NULL, NULL),
(52162, '2017-10-29 10:10:32', NULL, NULL, 14171, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:10:33', 'admin-1509238833-15092430327945457', 1, 1, 'SR', NULL, NULL, NULL),
(52163, '2017-10-29 10:06:02', NULL, NULL, 14170, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:06:02', 'admin-1509238833-15092427625694079', 1, 0, '', NULL, NULL, NULL),
(52164, '2017-10-29 10:04:28', NULL, NULL, 14169, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:04:28', 'admin-1509238833-15092426681792917', 1, 0, '', NULL, NULL, NULL),
(52165, '2017-10-29 10:04:17', NULL, NULL, 14169, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:04:17', 'admin-1509238833-15092426571006345', 1, 1, 'SR', NULL, NULL, NULL),
(52166, '2017-10-29 10:04:17', NULL, NULL, 14169, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:04:17', 'admin-1509238833-15092426571006345', 1, 0, '', NULL, NULL, NULL),
(52167, '2017-10-29 10:04:02', NULL, NULL, 14169, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:04:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52168, '2017-10-29 09:21:52', NULL, NULL, 14168, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 09:21:52', 'admin-1509238833-1509240111904665', 1, 1, 'SR', NULL, NULL, '10.0'),
(52169, '2017-10-29 10:10:32', NULL, NULL, 14171, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 10:10:32', 'admin-1509238833-15092430327945457', 1, 0, '', NULL, NULL, NULL),
(52170, '2017-10-29 09:21:52', NULL, NULL, 14168, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 09:21:52', 'admin-1509238833-1509240111904665', 1, 1, 'SR', NULL, NULL, '10.0'),
(52171, '2017-10-29 09:21:52', NULL, NULL, 14168, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 09:21:52', 'admin-1509238833-1509240111904665', 1, 0, '', NULL, NULL, '10.0'),
(52172, '2017-10-29 09:14:42', NULL, NULL, 14166, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509260716', 'admin', '2017-10-29 09:14:42', 'admin-1509238833-15092396827442342', 1, 1, 'SR', NULL, NULL, NULL),
(52173, '2017-10-29 09:16:35', NULL, NULL, 14167, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1509260716', 'admin', '2017-10-29 09:16:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52174, '2017-10-29 09:14:20', NULL, NULL, 14166, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1509260716', 'admin', '2017-10-29 09:14:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52175, '2017-10-30 10:58:21', NULL, NULL, 14222, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 10:58:21', 'admin-1509324952-15093323010019723', 1, 1, 'SR', NULL, NULL, NULL),
(52176, '2017-10-30 10:58:21', NULL, NULL, 14222, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 10:58:21', 'admin-1509324952-15093323010019723', 1, 1, 'SR', NULL, NULL, NULL),
(52177, '2017-10-30 11:08:43', NULL, NULL, 14223, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1509334527', 'admin', '2017-10-30 11:08:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52178, '2017-10-30 11:08:51', NULL, NULL, 14223, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 11:08:51', 'admin-1509324952-15093329315883043', 1, 1, 'SR', NULL, NULL, NULL),
(52179, '2017-10-30 11:08:51', NULL, NULL, 14223, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 11:08:51', 'admin-1509324952-15093329315883043', 1, 1, 'SR', NULL, NULL, NULL),
(52180, '2017-10-30 14:31:45', NULL, NULL, 14230, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 14:31:45', 'admin-1509334527-1509345105170962', 1, 0, '', NULL, NULL, '10.0'),
(52181, '2017-10-30 14:33:51', NULL, NULL, 14231, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1509334527', 'admin', '2017-10-30 14:33:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52182, '2017-10-30 11:14:02', NULL, NULL, 14224, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 11:14:02', 'admin-1509324952-15093332420915740', 1, 1, 'SR', NULL, NULL, NULL),
(52183, '2017-10-30 14:37:48', NULL, NULL, 14232, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 14:37:48', 'admin-1509334527-15093454680714633', 1, 1, 'SR', NULL, NULL, NULL),
(52184, '2017-10-30 10:08:51', NULL, NULL, 14220, 0, 181, '116', 'Open Food ', '2 slices of toast', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 10:08:51', 'admin-1509324952-15093293316551397', 1, 0, '', NULL, NULL, NULL),
(52185, '2017-10-30 10:40:22', NULL, NULL, 14221, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 10:40:22', 'admin-1509324952-15093312218427417', 1, 0, '', NULL, NULL, NULL),
(52186, '2017-10-30 10:40:30', NULL, NULL, 14221, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 10:40:30', 'admin-1509324952-15093312306594424', 1, 1, 'SR', NULL, NULL, NULL),
(52187, '2017-10-30 11:20:07', NULL, NULL, 14225, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1509334527', 'admin', '2017-10-30 11:20:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52188, '2017-10-30 11:20:30', NULL, NULL, 14225, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 11:20:30', 'admin-1509324952-15093336300891845', 1, 0, '', NULL, NULL, NULL),
(52189, '2017-10-30 10:38:57', NULL, NULL, 14221, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1509334527', 'admin', '2017-10-30 10:38:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52190, '2017-10-30 10:08:28', NULL, NULL, 14220, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1509334527', 'admin', '2017-10-30 10:08:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52191, '2017-10-30 12:12:15', NULL, NULL, 14226, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1509334527', 'admin', '2017-10-30 12:12:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52192, '2017-10-30 12:12:39', NULL, NULL, 14226, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 12:12:39', 'admin-1509334527-15093367596462245', 1, 0, '', NULL, NULL, NULL),
(52193, '2017-10-30 12:12:39', NULL, NULL, 14226, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 12:12:39', 'admin-1509334527-15093367596462245', 1, 0, '', NULL, NULL, NULL),
(52194, '2017-10-30 12:12:39', NULL, NULL, 14226, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 12:12:39', 'admin-1509334527-15093367596462245', 1, 0, '', NULL, NULL, NULL),
(52195, '2017-10-30 10:40:30', NULL, NULL, 14221, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 10:40:30', 'admin-1509324952-15093312306594424', 1, 1, 'SR', NULL, NULL, NULL),
(52196, '2017-10-30 14:35:05', NULL, NULL, 14231, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 14:35:05', 'admin-1509334527-1509345305649870', 1, 1, 'SR', NULL, NULL, NULL),
(52197, '2017-10-30 11:14:20', NULL, NULL, 14224, 0, 181, '116', 'Open Food ', 'banana', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1509334527', 'admin', '2017-10-30 11:14:20', 'admin-1509324952-1509333260482524', 1, 0, '', NULL, NULL, NULL),
(52198, '2017-10-30 14:35:00', NULL, NULL, 14231, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 14:35:00', 'admin-1509334527-15093453004886056', 1, 1, 'SR', NULL, NULL, NULL),
(52199, '2017-10-30 11:08:51', NULL, NULL, 14223, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 11:08:51', 'admin-1509324952-15093329315883043', 1, 0, '', NULL, NULL, NULL),
(52200, '2017-10-30 11:13:37', NULL, NULL, 14224, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1509334527', 'admin', '2017-10-30 11:13:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52201, '2017-10-30 11:14:02', NULL, NULL, 14224, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 11:14:02', 'admin-1509324952-15093332420915740', 1, 1, 'SR', NULL, NULL, NULL),
(52202, '2017-10-30 14:37:48', NULL, NULL, 14232, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 14:37:48', 'admin-1509334527-15093454680714633', 1, 1, 'SR', NULL, NULL, NULL),
(52203, '2017-10-30 14:37:48', NULL, NULL, 14232, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 14:37:48', 'admin-1509334527-15093454680714633', 1, 0, '', NULL, NULL, NULL),
(52204, '2017-10-30 15:36:45', NULL, NULL, 14233, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 15:36:45', 'admin-1509334527-15093490051209977', 1, 1, 'SR', NULL, NULL, NULL),
(52205, '2017-10-30 15:36:38', NULL, NULL, 14233, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1509334527', 'admin', '2017-10-30 15:36:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52206, '2017-10-30 15:22:18', NULL, NULL, 14230, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 15:22:18', 'admin-1509334527-15093481381887874', 1, 1, 'SR', NULL, NULL, '10.0'),
(52207, '2017-10-30 10:07:39', NULL, NULL, 14219, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1509334527', 'admin', '2017-10-30 10:07:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52208, '2017-10-30 12:12:39', NULL, NULL, 14226, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 12:12:39', 'admin-1509334527-15093367596462245', 1, 0, '', NULL, NULL, NULL),
(52209, '2017-10-30 14:37:32', NULL, NULL, 14232, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1509334527', 'admin', '2017-10-30 14:37:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52210, '2017-10-30 09:23:15', NULL, NULL, 14217, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 09:23:15', 'admin-1509324952-15093265952924078', 1, 0, '', NULL, NULL, NULL),
(52211, '2017-10-30 12:12:53', NULL, NULL, 14226, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 12:12:53', 'admin-1509334527-15093367729525669', 1, 1, 'SR', NULL, NULL, NULL),
(52212, '2017-10-30 12:12:53', NULL, NULL, 14226, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 12:12:53', 'admin-1509334527-15093367729525669', 1, 1, 'SR', NULL, NULL, NULL),
(52213, '2017-10-30 12:12:53', NULL, NULL, 14226, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 12:12:53', 'admin-1509334527-15093367729525669', 1, 1, 'SR', NULL, NULL, NULL),
(52214, '2017-10-30 14:08:09', NULL, NULL, 14228, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 14:08:09', 'admin-1509334527-15093436891925780', 1, 1, 'SR', NULL, NULL, NULL),
(52215, '2017-10-30 12:19:41', NULL, NULL, 14228, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1509334527', 'admin', '2017-10-30 12:19:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52216, '2017-10-30 12:19:52', NULL, NULL, 14228, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 12:19:52', 'admin-1509334527-15093371924904355', 1, 0, '', NULL, NULL, NULL),
(52217, '2017-10-30 14:24:48', NULL, NULL, 14229, 0, 181, '116', 'Open Food ', 'bacon,egg,sosej', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 14:24:48', 'admin-1509334527-15093446883538271', 1, 0, '', 1, NULL, NULL),
(52218, '2017-10-30 14:31:19', NULL, NULL, 14230, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1509334527', 'admin', '2017-10-30 14:31:19', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(52219, '2017-10-30 09:23:15', NULL, NULL, 14217, 0, 154, '88', 'Daily Dose BLT', 'no bacon', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 09:23:15', 'admin-1509324952-15093265952924078', 1, 0, '', NULL, NULL, NULL),
(52220, '2017-10-30 09:23:26', NULL, NULL, 14217, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 09:23:26', 'admin-1509324952-15093266066597334', 1, 1, 'SR', NULL, NULL, NULL),
(52221, '2017-10-30 09:23:26', NULL, NULL, 14217, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 09:23:26', 'admin-1509324952-15093266066597334', 1, 1, 'SR', NULL, NULL, NULL),
(52222, '2017-10-30 11:20:30', NULL, NULL, 14225, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 11:20:30', 'admin-1509324952-15093336300891845', 1, 0, '', NULL, NULL, NULL),
(52223, '2017-10-30 11:14:20', NULL, NULL, 14224, 0, 181, '116', 'Open Food ', 'banana', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1509334527', 'admin', '2017-10-30 11:14:20', 'admin-1509324952-1509333260482524', 1, 0, '', NULL, NULL, NULL),
(52224, '2017-10-30 11:14:02', NULL, NULL, 14224, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 11:14:02', 'admin-1509324952-15093332420915740', 1, 1, 'SR', NULL, NULL, NULL),
(52225, '2017-10-30 10:58:12', NULL, NULL, 14222, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1509334527', 'admin', '2017-10-30 10:58:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52226, '2017-10-30 10:40:22', NULL, NULL, 14221, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 10:40:22', 'admin-1509324952-15093312218427417', 1, 0, '', NULL, NULL, NULL),
(52227, '2017-10-30 10:40:22', NULL, NULL, 14221, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 10:40:22', 'admin-1509324952-15093312218427417', 1, 0, '', NULL, NULL, NULL),
(52228, '2017-10-30 10:08:51', NULL, NULL, 14220, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 10:08:51', 'admin-1509324952-15093293316551397', 1, 1, 'SR', NULL, NULL, NULL),
(52229, '2017-10-30 10:07:48', NULL, NULL, 14219, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 10:07:48', 'admin-1509324952-15093292685935967', 1, 1, 'SR', NULL, NULL, NULL),
(52230, '2017-10-30 10:07:48', NULL, NULL, 14219, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 10:07:48', 'admin-1509324952-15093292685935967', 1, 0, '', NULL, NULL, NULL),
(52231, '2017-10-30 10:07:48', NULL, NULL, 14219, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 10:07:48', 'admin-1509324952-15093292685935967', 1, 0, '', NULL, NULL, NULL),
(52232, '2017-10-30 09:32:07', NULL, NULL, 14218, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1509334527', 'admin', '2017-10-30 09:32:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52233, '2017-10-30 09:32:10', NULL, NULL, 14218, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509334527', 'admin', '2017-10-30 09:32:10', 'admin-1509324952-15093271307603447', 1, 1, 'SR', NULL, NULL, NULL),
(52234, '2017-10-30 09:23:01', NULL, NULL, 14217, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1509334527', 'admin', '2017-10-30 09:23:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52235, '2017-11-01 09:22:40', NULL, NULL, 14234, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 09:22:40', 'admin-1509498256-15094993600904374', 1, 0, '', NULL, NULL, NULL),
(52236, '2017-11-01 09:22:40', NULL, NULL, 14234, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 09:22:40', 'admin-1509498256-15094993600904374', 1, 0, '', NULL, NULL, NULL),
(52237, '2017-11-01 10:15:33', NULL, NULL, 14235, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 10:15:33', 'admin-1509498256-15095025328133350', 1, 0, '', NULL, NULL, NULL),
(52238, '2017-11-01 10:15:33', NULL, NULL, 14235, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 10:15:33', 'admin-1509498256-15095025328133350', 1, 1, 'SR', NULL, NULL, NULL),
(52239, '2017-11-01 12:21:59', NULL, NULL, 14241, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 12:21:59', 'admin-1509498256-15095101197291644', 1, 0, '', NULL, NULL, NULL),
(52240, '2017-11-01 10:54:41', NULL, NULL, 14236, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1509513230', 'admin', '2017-11-01 10:54:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52241, '2017-11-01 09:23:04', NULL, NULL, 14234, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 09:23:04', 'admin-1509498256-15094993842104341', 1, 0, '', NULL, NULL, NULL),
(52242, '2017-11-01 09:25:23', NULL, NULL, 14234, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 09:25:23', 'admin-1509498256-15094995233281064', 1, 0, '', NULL, NULL, NULL),
(52243, '2017-11-01 09:58:19', NULL, NULL, 14234, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 09:58:19', 'admin-1509498256-1509501498804576', 1, 0, '', NULL, NULL, NULL),
(52244, '2017-11-01 10:15:21', NULL, NULL, 14235, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1509513230', 'admin', '2017-11-01 10:15:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52245, '2017-11-01 10:15:32', NULL, NULL, 14235, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 10:15:32', 'admin-1509498256-15095025328133350', 1, 0, '', NULL, NULL, NULL),
(52246, '2017-11-01 09:22:54', NULL, NULL, 14234, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 09:22:54', 'admin-1509498256-15094993743056518', 1, 0, '', NULL, NULL, NULL),
(52247, '2017-11-01 10:54:58', NULL, NULL, 14236, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 10:54:58', 'admin-1509498256-15095048983145976', 1, 0, '', NULL, NULL, NULL),
(52248, '2017-11-01 10:54:58', NULL, NULL, 14236, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 10:54:58', 'admin-1509498256-15095048983145976', 1, 0, '', NULL, NULL, NULL),
(52249, '2017-11-01 10:54:58', NULL, NULL, 14236, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 10:54:58', 'admin-1509498256-15095048983145976', 1, 1, 'SR', NULL, NULL, NULL),
(52250, '2017-11-01 10:54:58', NULL, NULL, 14236, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 10:54:58', 'admin-1509498256-15095048983145976', 1, 1, 'SR', NULL, NULL, NULL),
(52251, '2017-11-01 10:54:58', NULL, NULL, 14236, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 10:54:58', 'admin-1509498256-15095048983145976', 1, 1, 'SR', NULL, NULL, NULL),
(52252, '2017-11-01 11:25:13', NULL, NULL, 14237, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1509513230', 'admin', '2017-11-01 11:25:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52253, '2017-11-01 11:25:19', NULL, NULL, 14237, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 11:25:19', 'admin-1509498256-15095067194782010', 1, 1, 'SR', NULL, NULL, NULL),
(52254, '2017-11-01 13:44:21', NULL, NULL, 14242, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 13:44:21', 'admin-1509513230-1509515061360951', 1, 0, '', NULL, NULL, '10.0'),
(52255, '2017-11-01 13:44:21', NULL, NULL, 14242, 0, 181, '116', 'Open Food ', 'BLT add nachos', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 13:44:21', 'admin-1509513230-1509515061360951', 1, 0, '', NULL, NULL, '10.0'),
(52256, '2017-11-01 13:44:26', NULL, NULL, 14242, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 13:44:26', 'admin-1509513230-15095150660573173', 1, 1, 'SR', NULL, NULL, '10.0'),
(52257, '2017-11-01 13:45:03', NULL, NULL, 14242, 0, 181, '116', 'Open Food ', 'BLT egg well done', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 13:45:03', 'admin-1509513230-15095151035477476', 1, 0, '', NULL, NULL, '10.0'),
(52258, '2017-11-01 14:09:23', NULL, NULL, 14243, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1509513230', 'admin', '2017-11-01 14:09:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52259, '2017-11-01 14:09:27', NULL, NULL, 14243, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 14:09:27', 'admin-1509513230-15095165670184130', 1, 0, '', NULL, NULL, NULL),
(52260, '2017-11-01 15:23:00', NULL, NULL, 14245, 0, 269, '203', 'Espresso Con Panna', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 15:23:00', 'admin-1509513230-15095209804752781', 1, 0, '', NULL, NULL, NULL),
(52261, '2017-11-01 15:43:37', NULL, NULL, 14246, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1509513230', 'admin', '2017-11-01 15:43:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52262, '2017-11-01 15:43:40', NULL, NULL, 14246, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 15:43:40', 'admin-1509513230-15095222201816716', 1, 1, 'SR', NULL, NULL, NULL),
(52263, '2017-11-01 15:59:48', NULL, NULL, 14246, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 15:59:48', 'admin-1509513230-15095231882515248', 1, 0, '', NULL, NULL, NULL),
(52264, '2017-11-01 15:23:00', NULL, NULL, 14245, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 15:23:00', 'admin-1509513230-15095209804752781', 1, 0, '', NULL, NULL, NULL),
(52265, '2017-11-01 15:22:51', NULL, NULL, 14245, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1509513230', 'admin', '2017-11-01 15:22:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52266, '2017-11-01 14:27:45', NULL, NULL, 14244, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 14:27:45', 'admin-1509513230-15095176656995280', 1, 1, 'SR', 1, NULL, NULL),
(52267, '2017-11-01 13:43:15', NULL, NULL, 14242, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 13:43:15', 'admin-1509513230-15095149952974155', 1, 1, 'SR', NULL, NULL, '10.0'),
(52268, '2017-11-01 13:16:39', NULL, NULL, 14242, 0, 181, '116', 'Open Food ', 'T1 change to T2', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 13:16:39', 'admin-1509513230-15095133994613840', 1, 0, '', NULL, NULL, '10.0'),
(52269, '2017-11-01 13:10:08', NULL, NULL, 14242, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 13:10:08', 'admin-1509498256-1509513008561671', 1, 0, '', NULL, NULL, '10.0'),
(52270, '2017-11-01 13:13:22', NULL, NULL, 14242, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 13:13:22', 'admin-1509498256-15095132026538980', 1, 0, '', NULL, NULL, '10.0'),
(52271, '2017-11-01 12:21:59', NULL, NULL, 14241, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 12:21:59', 'admin-1509498256-15095101197291644', 1, 1, 'SR', NULL, NULL, NULL),
(52272, '2017-11-01 09:22:40', NULL, NULL, 14234, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 09:22:40', 'admin-1509498256-15094993600904374', 1, 0, '', NULL, NULL, NULL),
(52273, '2017-11-01 09:22:40', NULL, NULL, 14234, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 09:22:40', 'admin-1509498256-15094993600904374', 1, 0, '', NULL, NULL, NULL),
(52274, '2017-11-01 12:21:59', NULL, NULL, 14241, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 12:21:59', 'admin-1509498256-15095101197291644', 1, 0, '', NULL, NULL, NULL),
(52275, '2017-11-01 11:34:24', NULL, NULL, 14238, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1509513230', 'admin', '2017-11-01 11:34:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52276, '2017-11-01 12:21:59', NULL, NULL, 14241, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 12:21:59', 'admin-1509498256-15095101197291644', 1, 0, '', NULL, NULL, NULL),
(52277, '2017-11-01 12:21:51', NULL, NULL, 14241, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1509513230', 'admin', '2017-11-01 12:21:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52278, '2017-11-01 12:15:02', NULL, NULL, 14240, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 12:15:02', 'admin-1509498256-15095097020783568', 1, 0, '', NULL, NULL, NULL),
(52279, '2017-11-01 12:15:02', NULL, NULL, 14240, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 12:15:02', 'admin-1509498256-15095097020783568', 1, 0, '', NULL, NULL, NULL),
(52280, '2017-11-01 13:10:05', NULL, NULL, 14242, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1509513230', 'admin', '2017-11-01 13:10:05', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(52281, '2017-11-01 12:14:55', NULL, NULL, 14240, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1509513230', 'admin', '2017-11-01 12:14:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52282, '2017-11-01 11:53:36', NULL, NULL, 14239, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 11:53:36', 'admin-1509498256-15095084162724428', 1, 1, 'SR', NULL, NULL, NULL),
(52283, '2017-11-01 12:00:14', NULL, NULL, 14238, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 12:00:14', 'admin-1509498256-15095088143654044', 1, 0, '', NULL, NULL, NULL),
(52284, '2017-11-01 11:53:04', NULL, NULL, 14239, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 11:53:04', 'admin-1509498256-15095083841633710', 1, 1, 'SR', NULL, NULL, NULL),
(52285, '2017-11-01 12:21:59', NULL, NULL, 14241, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 12:21:59', 'admin-1509498256-15095101197291644', 1, 1, 'SR', NULL, NULL, NULL),
(52286, '2017-11-01 11:34:35', NULL, NULL, 14238, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 11:34:35', 'admin-1509498256-15095072749155975', 1, 1, 'SR', NULL, NULL, NULL),
(52287, '2017-11-01 11:34:35', NULL, NULL, 14238, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 11:34:35', 'admin-1509498256-15095072749155975', 1, 1, 'SR', NULL, NULL, NULL),
(52288, '2017-11-01 11:34:35', NULL, NULL, 14238, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 11:34:35', 'admin-1509498256-15095072749155975', 1, 0, '', NULL, NULL, NULL),
(52289, '2017-11-01 11:53:01', NULL, NULL, 14239, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 11:53:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52290, '2017-11-01 11:34:35', NULL, NULL, 14238, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 11:34:35', 'admin-1509498256-15095072749155975', 1, 0, '', NULL, NULL, NULL),
(52291, '2017-11-01 10:15:33', NULL, NULL, 14235, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 10:15:33', 'admin-1509498256-15095025328133350', 1, 1, 'SR', NULL, NULL, NULL),
(52292, '2017-11-01 09:22:54', NULL, NULL, 14234, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 09:22:54', 'admin-1509498256-15094993743056518', 1, 1, 'SR', NULL, NULL, NULL),
(52293, '2017-11-01 09:22:54', NULL, NULL, 14234, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 09:22:54', 'admin-1509498256-15094993743056518', 1, 1, 'SR', NULL, NULL, NULL),
(52294, '2017-11-01 09:22:54', NULL, NULL, 14234, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 09:22:54', 'admin-1509498256-15094993743056518', 1, 0, '', NULL, NULL, NULL),
(52295, '2017-11-01 09:22:40', NULL, NULL, 14234, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 09:22:40', 'admin-1509498256-15094993600904374', 1, 0, '', NULL, NULL, NULL),
(52296, '2017-11-01 11:27:52', NULL, NULL, 14237, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 11:27:52', 'admin-1509498256-15095068721021468', 1, 0, '', NULL, NULL, NULL),
(52297, '2017-11-01 09:22:40', NULL, NULL, 14234, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 09:22:40', 'admin-1509498256-15094993600904374', 1, 1, 'SR', NULL, NULL, NULL),
(52298, '2017-11-01 09:22:40', NULL, NULL, 14234, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 09:22:40', 'admin-1509498256-15094993600904374', 1, 0, '', NULL, NULL, NULL),
(52299, '2017-11-01 09:22:40', NULL, NULL, 14234, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509513230', 'admin', '2017-11-01 09:22:40', 'admin-1509498256-15094993600904374', 1, 0, '', NULL, NULL, NULL),
(52300, '2017-11-01 09:17:42', NULL, NULL, 14234, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 19.50, 0.0000, 0.0000, 19.50, 1, '27', 1, '1509513230', 'admin', '2017-11-01 09:17:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52301, '2017-11-02 13:46:02', NULL, NULL, 14263, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 13:46:02', 'admin-1509595522-15096015619841757', 1, 1, 'SR', NULL, NULL, NULL),
(52302, '2017-11-02 13:59:51', NULL, NULL, 14266, 0, 153, '87', 'Wake Me Up!', 'sunnyside up', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 13:59:51', 'admin-1509595522-15096023912805671', 1, 0, '', NULL, NULL, NULL),
(52303, '2017-11-02 12:57:13', NULL, NULL, 14261, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:57:13', 'admin-1509595522-1509598633208979', 1, 0, '', NULL, NULL, NULL),
(52304, '2017-11-02 12:57:02', NULL, NULL, 14261, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:57:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52305, '2017-11-02 09:43:06', NULL, NULL, 14248, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 09:43:06', 'admin-1509583757-1509586986757941', 1, 0, '', NULL, NULL, NULL),
(52306, '2017-11-02 09:43:06', NULL, NULL, 14248, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 09:43:06', 'admin-1509583757-1509586986757941', 1, 0, '', NULL, NULL, NULL),
(52307, '2017-11-02 09:43:06', NULL, NULL, 14248, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 09:43:06', 'admin-1509583757-1509586986757941', 1, 0, '', NULL, NULL, NULL),
(52308, '2017-11-02 13:54:30', NULL, NULL, 14265, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 13:54:30', 'admin-1509595522-15096020707573993', 1, 1, 'SR', 1, NULL, '10.0'),
(52309, '2017-11-02 13:59:19', NULL, NULL, 14266, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1509595522', 'admin', '2017-11-02 13:59:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52310, '2017-11-02 13:59:51', NULL, NULL, 14266, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 13:59:51', 'admin-1509595522-15096023912805671', 1, 1, 'SR', NULL, NULL, NULL),
(52311, '2017-11-02 15:36:54', NULL, NULL, 14269, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1509595522', 'admin', '2017-11-02 15:36:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52312, '2017-11-02 15:37:05', NULL, NULL, 14269, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 15:37:05', 'admin-1509595522-15096082255879864', 1, 0, '', NULL, NULL, NULL),
(52313, '2017-11-02 15:37:05', NULL, NULL, 14269, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 15:37:05', 'admin-1509595522-15096082255879864', 1, 1, 'SR', NULL, NULL, NULL),
(52314, '2017-11-02 16:13:15', NULL, NULL, 14270, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 16:13:15', 'admin-1509595522-15096103956003949', 1, 1, 'SR', NULL, NULL, NULL),
(52315, '2017-11-02 15:12:09', NULL, NULL, 14268, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 15:12:09', 'admin-1509595522-15096067294492945', 1, 1, 'SR', NULL, NULL, NULL),
(52316, '2017-11-02 15:12:09', NULL, NULL, 14268, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 2, 9.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 15:12:09', 'admin-1509595522-15096067294492945', 1, 1, 'SR', NULL, NULL, NULL),
(52317, '2017-11-02 15:12:09', NULL, NULL, 14268, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 15:12:09', 'admin-1509595522-15096067294492945', 1, 1, 'SR', NULL, NULL, NULL),
(52318, '2017-11-02 12:56:58', NULL, NULL, 14260, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:56:58', 'admin-1509595522-15095986186573777', 1, 1, 'SR', NULL, NULL, NULL),
(52319, '2017-11-02 12:56:03', NULL, NULL, 14259, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:56:03', 'admin-1509595522-15095985636676344', 1, 0, '', NULL, NULL, NULL),
(52320, '2017-11-02 12:56:03', NULL, NULL, 14259, 0, 301, '237', 'Black Jack', '', 'Cold Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:56:03', 'admin-1509595522-15095985636676344', 1, 0, '', NULL, NULL, NULL),
(52321, '2017-11-02 13:59:51', NULL, NULL, 14266, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 13:59:51', 'admin-1509595522-15096023912805671', 1, 0, '', NULL, NULL, NULL),
(52322, '2017-11-02 13:03:14', NULL, NULL, 14262, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 13:03:14', 'admin-1509595522-1509598993829713', 1, 1, 'SR', NULL, NULL, NULL),
(52323, '2017-11-02 12:55:50', NULL, NULL, 14259, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:55:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52324, '2017-11-02 12:55:45', NULL, NULL, 14258, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:55:45', 'admin-1509595522-15095985449321827', 1, 0, '', NULL, NULL, NULL),
(52325, '2017-11-02 12:48:10', NULL, NULL, 14258, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:48:10', 'admin-1509595522-15095980908392418', 1, 1, 'SR', NULL, NULL, NULL),
(52326, '2017-11-02 15:37:05', NULL, NULL, 14269, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 15:37:05', 'admin-1509595522-15096082255879864', 1, 0, '', NULL, NULL, NULL),
(52327, '2017-11-02 12:47:49', NULL, NULL, 14258, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:47:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52328, '2017-11-02 12:48:04', NULL, NULL, 14258, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:48:04', 'admin-1509595522-15095980844653680', 1, 1, 'SR', NULL, NULL, NULL),
(52329, '2017-11-02 12:42:26', NULL, NULL, 14257, 0, 182, '117', 'Open Drinks ', 'coffee beans', 'Cold Drinks', 'Fresh Juice', 1, 38.00, 38.0000, 0.0000, 38.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:42:26', 'admin-1509595522-15095977458029720', 1, 0, '', 1, NULL, NULL),
(52330, '2017-11-02 12:27:43', NULL, NULL, 14256, 0, 301, '237', 'Black Jack', '', 'Cold Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:27:43', 'admin-1509595522-15095968633588564', 1, 0, '', NULL, NULL, '10.0'),
(52331, '2017-11-02 12:27:08', NULL, NULL, 14256, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:27:08', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(52332, '2017-11-02 12:27:30', NULL, NULL, 14256, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:27:30', 'admin-1509595522-15095968504933496', 1, 1, 'SR', NULL, NULL, '10.0'),
(52333, '2017-11-02 12:08:46', NULL, NULL, 14255, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:08:46', 'admin-1509595522-15095957264681060', 1, 1, 'SR', NULL, NULL, NULL),
(52334, '2017-11-02 12:08:46', NULL, NULL, 14255, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:08:46', 'admin-1509595522-15095957264681060', 1, 1, 'SR', NULL, NULL, NULL),
(52335, '2017-11-02 11:20:59', NULL, NULL, 14253, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 11:20:59', 'admin-1509583757-1509592859388931', 1, 0, '', NULL, NULL, NULL),
(52336, '2017-11-02 11:21:40', NULL, NULL, 14254, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 11:21:40', 'admin-1509583757-15095929000426194', 1, 0, '', 1, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(52337, '2017-11-02 11:59:59', NULL, NULL, 14255, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.60, 0.0000, 0.0000, 16.60, 1, '27', 1, '1509595522', 'admin', '2017-11-02 11:59:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52338, '2017-11-02 12:00:02', NULL, NULL, 14255, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:00:02', 'admin-1509583757-15095952025877482', 1, 0, '', NULL, NULL, NULL),
(52339, '2017-11-02 12:05:15', NULL, NULL, 14255, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:05:15', 'admin-1509583757-15095955157117864', 1, 0, '', NULL, NULL, NULL),
(52340, '2017-11-02 14:00:00', NULL, NULL, 14266, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 14:00:00', 'admin-1509595522-1509602400347738', 1, 1, 'SR', NULL, NULL, NULL),
(52341, '2017-11-02 12:57:13', NULL, NULL, 14261, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:57:13', 'admin-1509595522-1509598633208979', 1, 1, 'SR', NULL, NULL, NULL),
(52342, '2017-11-02 13:51:12', NULL, NULL, 14264, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1509595522', 'admin', '2017-11-02 13:51:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52343, '2017-11-02 13:51:17', NULL, NULL, 14264, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 13:51:17', 'admin-1509595522-1509601876932992', 1, 1, 'SR', NULL, NULL, NULL),
(52344, '2017-11-02 14:00:03', NULL, NULL, 14267, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1509595522', 'admin', '2017-11-02 14:00:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52345, '2017-11-02 14:00:10', NULL, NULL, 14267, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 14:00:10', 'admin-1509595522-15096024101624440', 1, 1, 'SR', NULL, NULL, NULL),
(52346, '2017-11-02 14:00:10', NULL, NULL, 14267, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 14:00:10', 'admin-1509595522-15096024101624440', 1, 1, 'SR', NULL, NULL, NULL),
(52347, '2017-11-02 12:08:46', NULL, NULL, 14255, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:08:46', 'admin-1509595522-15095957264681060', 1, 1, 'SR', NULL, NULL, NULL),
(52348, '2017-11-02 12:24:06', NULL, NULL, 14255, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:24:06', 'admin-1509595522-15095966460088783', 1, 0, '', NULL, NULL, NULL),
(52349, '2017-11-02 12:05:15', NULL, NULL, 14255, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:05:15', 'admin-1509583757-15095955157117864', 1, 0, '', NULL, NULL, NULL),
(52350, '2017-11-02 12:05:15', NULL, NULL, 14255, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:05:15', 'admin-1509583757-15095955157117864', 1, 0, '', NULL, NULL, NULL),
(52351, '2017-11-02 12:08:46', NULL, NULL, 14255, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:08:46', 'admin-1509595522-15095957264681060', 1, 1, 'SR', NULL, NULL, NULL),
(52352, '2017-11-02 12:08:46', NULL, NULL, 14255, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:08:46', 'admin-1509595522-15095957264681060', 1, 1, 'SR', NULL, NULL, NULL),
(52353, '2017-11-02 12:56:58', NULL, NULL, 14260, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:56:58', 'admin-1509595522-15095986186573777', 1, 1, 'SR', NULL, NULL, NULL),
(52354, '2017-11-02 12:08:46', NULL, NULL, 14255, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:08:46', 'admin-1509595522-15095957264681060', 1, 1, 'SR', NULL, NULL, NULL),
(52355, '2017-11-02 13:44:30', NULL, NULL, 14263, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1509595522', 'admin', '2017-11-02 13:44:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52356, '2017-11-02 13:44:36', NULL, NULL, 14263, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 13:44:36', 'admin-1509595522-15096014764661079', 1, 0, '', NULL, NULL, NULL),
(52357, '2017-11-02 13:44:36', NULL, NULL, 14263, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 13:44:36', 'admin-1509595522-15096014764661079', 1, 0, '', NULL, NULL, NULL),
(52358, '2017-11-02 13:44:42', NULL, NULL, 14263, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 13:44:42', 'admin-1509595522-1509601482631454', 1, 1, 'SR', NULL, NULL, NULL),
(52359, '2017-11-02 14:00:10', NULL, NULL, 14267, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 14:00:10', 'admin-1509595522-15096024101624440', 1, 0, '', NULL, NULL, NULL),
(52360, '2017-11-02 16:13:12', NULL, NULL, 14270, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1509595522', 'admin', '2017-11-02 16:13:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52361, '2017-11-02 15:11:52', NULL, NULL, 14268, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1509595522', 'admin', '2017-11-02 15:11:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52362, '2017-11-02 12:05:15', NULL, NULL, 14255, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:05:15', 'admin-1509583757-15095955157117864', 1, 1, 'SR', NULL, NULL, NULL),
(52363, '2017-11-02 12:05:15', NULL, NULL, 14255, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:05:15', 'admin-1509583757-15095955157117864', 1, 0, '', NULL, NULL, NULL),
(52364, '2017-11-02 12:56:54', NULL, NULL, 14260, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:56:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52365, '2017-11-02 10:33:41', NULL, NULL, 14253, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:33:41', 'admin-1509583757-15095900216976758', 1, 1, 'SR', NULL, NULL, NULL),
(52366, '2017-11-02 10:27:06', NULL, NULL, 14252, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:27:06', 'admin-1509583757-15095896260178322', 1, 0, '', NULL, NULL, NULL),
(52367, '2017-11-02 14:00:00', NULL, NULL, 14266, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 14:00:00', 'admin-1509595522-1509602400347738', 1, 1, 'SR', NULL, NULL, NULL),
(52368, '2017-11-02 13:51:21', NULL, NULL, 14264, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 13:51:21', 'admin-1509595522-15096018811644297', 1, 1, 'SR', NULL, NULL, NULL),
(52369, '2017-11-02 13:54:30', NULL, NULL, 14265, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 13:54:30', 'admin-1509595522-15096020707573993', 1, 1, 'SR', 1, NULL, '10.0'),
(52370, '2017-11-02 13:02:53', NULL, NULL, 14262, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1509595522', 'admin', '2017-11-02 13:02:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52371, '2017-11-02 10:33:41', NULL, NULL, 14253, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:33:41', 'admin-1509583757-15095900216976758', 1, 1, 'SR', NULL, NULL, NULL),
(52372, '2017-11-02 10:33:41', NULL, NULL, 14253, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:33:41', 'admin-1509583757-15095900216976758', 1, 0, '', NULL, NULL, NULL),
(52373, '2017-11-02 12:57:13', NULL, NULL, 14261, 0, 301, '237', 'Black Jack', '', 'Cold Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:57:13', 'admin-1509595522-1509598633208979', 1, 0, '', NULL, NULL, NULL),
(52374, '2017-11-02 10:25:25', NULL, NULL, 14251, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:25:25', 'admin-1509583757-15095895250365258', 1, 0, '', NULL, NULL, NULL),
(52375, '2017-11-02 10:25:32', NULL, NULL, 14251, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:25:32', 'admin-1509583757-15095895318414078', 1, 1, 'SR', NULL, NULL, NULL),
(52376, '2017-11-02 10:25:32', NULL, NULL, 14251, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:25:32', 'admin-1509583757-15095895318414078', 1, 1, 'SR', NULL, NULL, NULL),
(52377, '2017-11-02 10:27:06', NULL, NULL, 14252, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:27:06', 'admin-1509583757-15095896260178322', 1, 0, '', NULL, NULL, NULL),
(52378, '2017-11-02 10:27:06', NULL, NULL, 14252, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:27:06', 'admin-1509583757-15095896260178322', 1, 0, '', NULL, NULL, NULL),
(52379, '2017-11-02 09:43:16', NULL, NULL, 14248, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 09:43:16', 'admin-1509583757-15095869958575582', 1, 1, 'SR', NULL, NULL, NULL),
(52380, '2017-11-02 09:43:16', NULL, NULL, 14248, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 09:43:16', 'admin-1509583757-15095869958575582', 1, 1, 'SR', NULL, NULL, NULL),
(52381, '2017-11-02 10:33:27', NULL, NULL, 14253, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:33:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52382, '2017-11-02 10:33:41', NULL, NULL, 14253, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:33:41', 'admin-1509583757-15095900216976758', 1, 0, '', NULL, NULL, NULL),
(52383, '2017-11-02 10:31:17', NULL, NULL, 14252, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:31:17', 'admin-1509583757-15095898773763919', 1, 0, '', NULL, NULL, NULL),
(52384, '2017-11-02 10:31:17', NULL, NULL, 14252, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:31:17', 'admin-1509583757-15095898773763919', 1, 0, '', NULL, NULL, NULL),
(52385, '2017-11-02 10:27:06', NULL, NULL, 14252, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:27:06', 'admin-1509583757-15095896260178322', 1, 1, 'SR', NULL, NULL, NULL),
(52386, '2017-11-02 10:18:40', NULL, NULL, 14250, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:18:40', 'admin-1509583757-1509589119873442', 1, 1, 'SR', NULL, NULL, NULL),
(52387, '2017-11-02 10:27:06', NULL, NULL, 14252, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:27:06', 'admin-1509583757-15095896260178322', 1, 1, 'SR', NULL, NULL, NULL),
(52388, '2017-11-02 10:26:41', NULL, NULL, 14252, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.90, 0.0000, 0.0000, 10.90, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:26:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52389, '2017-11-02 10:27:06', NULL, NULL, 14252, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:27:06', 'admin-1509583757-15095896260178322', 1, 0, '', NULL, NULL, NULL),
(52390, '2017-11-02 10:25:15', NULL, NULL, 14251, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:25:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52391, '2017-11-02 10:25:25', NULL, NULL, 14251, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:25:25', 'admin-1509583757-15095895250365258', 1, 0, '', NULL, NULL, NULL),
(52392, '2017-11-02 10:18:40', NULL, NULL, 14250, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:18:40', 'admin-1509583757-1509589119873442', 1, 1, 'SR', NULL, NULL, NULL),
(52393, '2017-11-02 10:18:24', NULL, NULL, 14250, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:18:24', 'admin-1509583757-15095891046741993', 1, 0, '', NULL, NULL, NULL),
(52394, '2017-11-02 10:18:40', NULL, NULL, 14250, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:18:40', 'admin-1509583757-1509589119873442', 1, 1, 'SR', NULL, NULL, NULL),
(52395, '2017-11-02 10:18:19', NULL, NULL, 14250, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:18:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52396, '2017-11-02 10:18:24', NULL, NULL, 14250, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:18:24', 'admin-1509583757-15095891046741993', 1, 0, '', NULL, NULL, NULL),
(52397, '2017-11-02 12:48:04', NULL, NULL, 14258, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 12:48:04', 'admin-1509595522-15095980844653680', 1, 0, '', NULL, NULL, NULL),
(52398, '2017-11-02 09:47:22', NULL, NULL, 14249, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 09:47:22', 'admin-1509583757-15095872424193637', 1, 0, '', NULL, NULL, NULL),
(52399, '2017-11-02 09:47:22', NULL, NULL, 14249, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 09:47:22', 'admin-1509583757-15095872424193637', 1, 1, 'SR', NULL, NULL, NULL),
(52400, '2017-11-02 10:14:26', NULL, NULL, 14247, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 10:14:26', 'admin-1509583757-15095888662925816', 1, 0, '', NULL, NULL, NULL),
(52401, '2017-11-02 09:47:13', NULL, NULL, 14249, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1509595522', 'admin', '2017-11-02 09:47:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52402, '2017-11-02 09:43:16', NULL, NULL, 14248, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 09:43:16', 'admin-1509583757-15095869958575582', 1, 1, 'SR', NULL, NULL, NULL),
(52403, '2017-11-02 09:03:35', NULL, NULL, 14247, 0, 181, '116', 'Open Food ', 'junior blt', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 09:03:35', 'admin-1509583757-1509584615247651', 1, 0, '', NULL, NULL, NULL),
(52404, '2017-11-02 09:03:41', NULL, NULL, 14247, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509595522', 'admin', '2017-11-02 09:03:41', 'admin-1509583757-15095846212151682', 1, 1, 'SR', NULL, NULL, NULL),
(52405, '2017-11-02 09:42:55', NULL, NULL, 14248, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1509595522', 'admin', '2017-11-02 09:42:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52406, '2017-11-02 09:03:25', NULL, NULL, 14247, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1509595522', 'admin', '2017-11-02 09:03:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52407, '2017-11-03 11:42:35', NULL, NULL, 14281, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 11:42:35', 'admin-1509613823-15096805552638169', 1, 0, '', NULL, NULL, NULL),
(52408, '2017-11-03 11:47:57', NULL, NULL, 14279, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 11:47:57', 'admin-1509613823-15096808777225627', 1, 0, '', NULL, NULL, NULL),
(52409, '2017-11-03 11:53:50', NULL, NULL, 14282, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1509613823', 'admin', '2017-11-03 11:53:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52410, '2017-11-03 12:54:02', NULL, NULL, 14285, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1509613823', 'admin', '2017-11-03 12:54:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52411, '2017-11-03 12:54:07', NULL, NULL, 14285, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 12:54:07', 'admin-1509613823-15096848468644671', 1, 1, 'SR', NULL, NULL, NULL),
(52412, '2017-11-03 12:57:47', NULL, NULL, 14285, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 12:57:47', 'admin-1509613823-15096850677408017', 1, 1, 'SR', NULL, NULL, NULL),
(52413, '2017-11-03 12:57:47', NULL, NULL, 14285, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 12:57:47', 'admin-1509613823-15096850677408017', 1, 1, 'SR', NULL, NULL, NULL),
(52414, '2017-11-03 16:42:20', NULL, NULL, 14290, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 16:42:20', 'admin-1509613823-1509698540422263', 1, 1, 'SR', 1, NULL, NULL),
(52415, '2017-11-03 16:48:52', NULL, NULL, 14291, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 16:48:52', 'admin-1509613823-15096989327058770', 1, 1, 'SR', 1, NULL, '10.0'),
(52416, '2017-11-03 13:01:00', NULL, NULL, 14286, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1509613823', 'admin', '2017-11-03 13:01:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52417, '2017-11-03 10:14:03', NULL, NULL, 14274, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 10:14:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52418, '2017-11-03 00:00:00', NULL, NULL, 14278, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 10:25:06', 'admin-1509613823-1509675906072379', 1, 1, 'SR', NULL, NULL, NULL),
(52419, '2017-11-03 10:14:16', NULL, NULL, 14272, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 10:14:16', 'admin-1509613823-1509675256671467', 1, 0, '', NULL, NULL, NULL),
(52420, '2017-11-03 10:14:09', NULL, NULL, 14274, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 10:14:09', 'admin-1509613823-15096752494631792', 1, 1, 'SR', NULL, NULL, NULL),
(52421, '2017-11-03 12:29:21', NULL, NULL, 14283, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 12:29:21', 'admin-1509613823-15096833616175361', 1, 1, 'SR', NULL, NULL, NULL),
(52422, '2017-11-03 12:29:21', NULL, NULL, 14283, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 12:29:21', 'admin-1509613823-15096833616175361', 1, 0, '', NULL, NULL, NULL),
(52423, '2017-11-03 12:29:37', NULL, NULL, 14283, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 12:29:37', 'admin-1509613823-1509683377017366', 1, 1, 'SR', NULL, NULL, NULL),
(52424, '2017-11-03 12:29:37', NULL, NULL, 14283, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 12:29:37', 'admin-1509613823-1509683377017366', 1, 1, 'SR', NULL, NULL, NULL),
(52425, '2017-11-03 12:29:37', NULL, NULL, 14283, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 12:29:37', 'admin-1509613823-1509683377017366', 1, 1, 'SR', NULL, NULL, NULL),
(52426, '2017-11-03 12:30:38', NULL, NULL, 14284, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1509613823', 'admin', '2017-11-03 12:30:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52427, '2017-11-03 12:31:14', NULL, NULL, 14284, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 12:31:14', 'admin-1509613823-15096834748064624', 1, 1, 'SR', NULL, NULL, NULL),
(52428, '2017-11-03 12:31:14', NULL, NULL, 14284, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 12:31:15', 'admin-1509613823-15096834748064624', 1, 0, '', NULL, NULL, NULL),
(52429, '2017-11-03 12:31:15', NULL, NULL, 14284, 0, 181, '116', 'Open Food ', 'double salted pork', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 12:31:15', 'admin-1509613823-15096834748064624', 1, 0, '', NULL, NULL, NULL),
(52430, '2017-11-03 11:16:23', NULL, NULL, 14279, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1509613823', 'admin', '2017-11-03 11:16:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52431, '2017-11-03 00:00:00', NULL, NULL, 14278, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 10:24:59', 'admin-1509613823-15096758988814839', 1, 0, '', NULL, NULL, NULL),
(52432, '2017-11-03 10:35:37', NULL, NULL, 14274, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 10:35:37', 'admin-1509613823-15096765370907420', 1, 1, 'SR', NULL, NULL, NULL),
(52433, '2017-11-03 10:35:37', NULL, NULL, 14274, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 10:35:37', 'admin-1509613823-15096765370907420', 1, 1, 'SR', NULL, NULL, NULL),
(52434, '2017-11-03 13:49:35', NULL, NULL, 14288, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 13:49:35', 'admin-1509613823-15096881753737491', 1, 0, '', NULL, NULL, NULL),
(52435, '2017-11-03 13:50:16', NULL, NULL, 14288, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 13:50:16', 'admin-1509613823-15096882165212322', 1, 1, 'SR', NULL, NULL, NULL),
(52436, '2017-11-03 13:08:17', NULL, NULL, 14287, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1509613823', 'admin', '2017-11-03 13:08:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52437, '2017-11-03 13:08:22', NULL, NULL, 14287, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 13:08:22', 'admin-1509613823-1509685701956234', 1, 1, 'SR', NULL, NULL, NULL),
(52438, '2017-11-03 13:38:24', NULL, NULL, 14284, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 13:38:24', 'admin-1509613823-15096875043933663', 1, 1, 'SR', NULL, NULL, NULL),
(52439, '2017-11-03 13:49:21', NULL, NULL, 14288, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1509613823', 'admin', '2017-11-03 13:49:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52440, '2017-11-03 13:50:16', NULL, NULL, 14288, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 13:50:16', 'admin-1509613823-15096882165212322', 1, 0, '', NULL, NULL, NULL),
(52441, '2017-11-03 13:57:15', NULL, NULL, 14284, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 13:57:15', 'admin-1509613823-15096886356368657', 1, 1, 'SR', NULL, NULL, NULL),
(52442, '2017-11-03 15:12:18', NULL, NULL, 14289, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 15:12:18', 'admin-1509613823-15096931382411193', 1, 1, 'SR', NULL, NULL, NULL),
(52443, '2017-11-03 15:12:07', NULL, NULL, 14289, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1509613823', 'admin', '2017-11-03 15:12:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52444, '2017-11-03 12:29:21', NULL, NULL, 14283, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 12:29:21', 'admin-1509613823-15096833616175361', 1, 1, 'SR', NULL, NULL, NULL),
(52445, '2017-11-03 11:21:35', NULL, NULL, 14280, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 11:21:35', 'admin-1509613823-15096792953562887', 1, 0, '', NULL, NULL, NULL),
(52446, '2017-11-03 13:49:35', NULL, NULL, 14288, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 13:49:35', 'admin-1509613823-15096881753737491', 1, 0, '', NULL, NULL, NULL),
(52447, '2017-11-03 13:01:03', NULL, NULL, 14286, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 13:01:03', 'admin-1509613823-15096852630795066', 1, 1, 'SR', NULL, NULL, NULL),
(52448, '2017-11-03 12:18:27', NULL, NULL, 14282, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 12:18:27', 'admin-1509613823-15096827071894492', 1, 0, '', NULL, NULL, NULL),
(52449, '2017-11-03 12:18:27', NULL, NULL, 14282, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 12:18:27', 'admin-1509613823-15096827071894492', 1, 1, 'SR', NULL, NULL, NULL),
(52450, '2017-11-03 11:42:12', NULL, NULL, 14281, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1509613823', 'admin', '2017-11-03 11:42:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52451, '2017-11-03 11:21:47', NULL, NULL, 14279, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 11:21:47', 'admin-1509613823-15096793075305627', 1, 1, 'SR', NULL, NULL, NULL),
(52452, '2017-11-03 12:29:02', NULL, NULL, 14283, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1509613823', 'admin', '2017-11-03 12:29:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52453, '2017-11-03 10:53:57', NULL, NULL, 14276, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 10:53:57', 'admin-1509613823-15096776372244986', 1, 1, 'SR', NULL, NULL, NULL),
(52454, '2017-11-03 10:53:57', NULL, NULL, 14276, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 10:53:57', 'admin-1509613823-15096776372244986', 1, 1, 'SR', NULL, NULL, NULL),
(52455, '2017-11-03 10:53:57', NULL, NULL, 14276, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 10:53:57', 'admin-1509613823-15096776372244986', 1, 1, 'SR', NULL, NULL, NULL),
(52456, '2017-11-03 11:21:02', NULL, NULL, 14279, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 11:21:02', 'admin-1509613823-15096792618563688', 1, 0, '', NULL, NULL, NULL),
(52457, '2017-11-03 11:21:29', NULL, NULL, 14280, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1509613823', 'admin', '2017-11-03 11:21:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52458, '2017-11-03 09:59:42', NULL, NULL, 14272, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1509613823', 'admin', '2017-11-03 09:59:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52459, '2017-11-03 11:42:35', NULL, NULL, 14281, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 11:42:35', 'admin-1509613823-15096805552638169', 1, 1, 'SR', NULL, NULL, NULL),
(52460, '2017-11-03 11:21:47', NULL, NULL, 14279, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 11:21:47', 'admin-1509613823-15096793075305627', 1, 1, 'SR', NULL, NULL, NULL),
(52461, '2017-11-03 11:21:59', NULL, NULL, 14280, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 11:21:59', 'admin-1509613823-15096793196067646', 1, 0, '', NULL, NULL, NULL),
(52462, '2017-11-03 11:21:59', NULL, NULL, 14280, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 11:21:59', 'admin-1509613823-15096793196067646', 1, 1, 'SR', NULL, NULL, NULL),
(52463, '2017-11-03 11:21:47', NULL, NULL, 14279, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 11:21:47', 'admin-1509613823-15096793075305627', 1, 1, 'SR', NULL, NULL, NULL),
(52464, '2017-11-03 11:21:47', NULL, NULL, 14279, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 11:21:47', 'admin-1509613823-15096793075305627', 1, 0, '', NULL, NULL, NULL),
(52465, '2017-11-03 11:21:35', NULL, NULL, 14280, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 11:21:35', 'admin-1509613823-15096792953562887', 1, 0, '', NULL, NULL, NULL),
(52466, '2017-11-03 00:00:00', NULL, NULL, 14277, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 10:25:06', 'admin-1509613823-1509675906072379', 1, 1, 'SR', NULL, NULL, NULL),
(52467, '2017-11-03 11:21:02', NULL, NULL, 14279, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 11:21:02', 'admin-1509613823-15096792618563688', 1, 0, '', NULL, NULL, NULL),
(52468, '2017-11-03 10:53:57', NULL, NULL, 14276, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 10:53:57', 'admin-1509613823-15096776372244986', 1, 0, '', NULL, NULL, NULL),
(52469, '2017-11-03 10:59:48', NULL, NULL, 14277, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1509613823', 'admin', '2017-11-03 10:59:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52470, '2017-11-03 00:00:00', NULL, NULL, 14278, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, NULL, NULL, 2.20, 1, '27', 1, '1509613823', 'admin', '2017-11-03 10:24:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52471, '2017-11-03 10:53:40', NULL, NULL, 14276, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1509613823', 'admin', '2017-11-03 10:53:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52472, '2017-11-03 00:00:00', NULL, NULL, 14277, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 10:24:59', 'admin-1509613823-15096758988814839', 1, 0, '', NULL, NULL, NULL),
(52473, '2017-11-03 10:14:09', NULL, NULL, 14274, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 10:14:09', 'admin-1509613823-15096752494631792', 1, 1, 'SR', NULL, NULL, NULL),
(52474, '2017-11-03 10:13:23', NULL, NULL, 14273, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1509613823', 'admin', '2017-11-03 10:13:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52475, '2017-11-03 10:13:27', NULL, NULL, 14273, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 10:13:27', 'admin-1509613823-15096752074766333', 1, 0, '', NULL, NULL, NULL),
(52476, '2017-11-03 10:13:58', NULL, NULL, 14273, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 10:13:58', 'admin-1509613823-15096752384744617', 1, 0, '', NULL, NULL, NULL),
(52477, '2017-11-03 10:13:58', NULL, NULL, 14273, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 10:13:58', 'admin-1509613823-15096752384744617', 1, 1, 'SR', NULL, NULL, NULL),
(52478, '2017-11-03 09:45:02', NULL, NULL, 14271, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 09:45:02', 'admin-1509613823-15096735027574437', 1, 0, '', NULL, NULL, NULL),
(52479, '2017-11-03 10:03:49', NULL, NULL, 14272, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 10:03:49', 'admin-1509613823-1509674629262462', 1, 0, '', NULL, NULL, NULL),
(52480, '2017-11-03 09:45:12', NULL, NULL, 14271, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 09:45:12', 'admin-1509613823-15096735118459828', 1, 0, '', NULL, NULL, NULL),
(52481, '2017-11-03 09:45:12', NULL, NULL, 14271, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 09:45:12', 'admin-1509613823-15096735118459828', 1, 1, 'SR', NULL, NULL, NULL),
(52482, '2017-11-03 09:45:03', NULL, NULL, 14271, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 09:45:03', 'admin-1509613823-15096735027574437', 1, 0, '', NULL, NULL, NULL),
(52483, '2017-11-03 09:43:34', NULL, NULL, 14271, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1509613823', 'admin', '2017-11-03 09:43:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52484, '2017-11-04 11:29:35', NULL, NULL, 14308, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:29:35', 'admin-1509763941-15097661755198530', 1, 0, '', NULL, NULL, NULL),
(52485, '2017-11-04 11:29:35', NULL, NULL, 14308, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:29:35', 'admin-1509763941-15097661755198530', 1, 0, '', NULL, NULL, NULL),
(52486, '2017-11-04 11:29:35', NULL, NULL, 14308, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:29:35', 'admin-1509763941-15097661755198530', 1, 0, '', NULL, NULL, NULL),
(52487, '2017-11-04 11:35:55', NULL, NULL, 14310, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:35:55', 'admin-1509763941-15097665549255192', 1, 0, '', NULL, NULL, NULL),
(52488, '2017-11-04 11:32:16', NULL, NULL, 14309, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:32:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52489, '2017-11-04 10:23:24', NULL, NULL, 14298, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:23:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52490, '2017-11-04 10:23:29', NULL, NULL, 14298, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:23:29', 'admin-1509761400-15097622095508377', 1, 1, 'SR', NULL, NULL, NULL),
(52491, '2017-11-04 10:23:29', NULL, NULL, 14298, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:23:29', 'admin-1509761400-15097622095508377', 1, 1, 'SR', NULL, NULL, NULL),
(52492, '2017-11-04 14:35:44', NULL, NULL, 14322, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 14:35:44', 'admin-1509769719-15097773446063080', 1, 1, 'SR', NULL, NULL, NULL),
(52493, '2017-11-04 14:14:11', NULL, NULL, 14321, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1509769719', 'admin', '2017-11-04 14:14:11', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(52494, '2017-11-04 14:14:18', NULL, NULL, 14321, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 14:14:18', 'admin-1509769719-1509776057771567', 1, 1, 'SR', NULL, NULL, '10.0'),
(52495, '2017-11-04 10:52:17', NULL, NULL, 14304, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:52:17', 'admin-1509761400-15097639341163612', 1, 1, 'SR', NULL, NULL, NULL),
(52496, '2017-11-04 10:52:17', NULL, NULL, 14304, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:52:17', 'admin-1509761400-15097639341163612', 1, 1, 'SR', NULL, NULL, NULL),
(52497, '2017-11-04 10:52:17', NULL, NULL, 14304, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:52:17', 'admin-1509761400-15097639341163612', 1, 0, '', NULL, NULL, NULL),
(52498, '2017-11-04 12:33:12', NULL, NULL, 14317, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 12:33:12', 'admin-1509769719-15097699921856231', 1, 0, '', NULL, NULL, NULL),
(52499, '2017-11-04 12:45:41', NULL, NULL, 14318, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1509769719', 'admin', '2017-11-04 12:45:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52500, '2017-11-04 11:32:31', NULL, NULL, 14309, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:32:31', 'admin-1509763941-15097663511792286', 1, 1, 'SR', NULL, NULL, NULL),
(52501, '2017-11-04 11:32:31', NULL, NULL, 14309, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:32:31', 'admin-1509763941-15097663511792286', 1, 0, '', NULL, NULL, NULL),
(52502, '2017-11-04 11:32:31', NULL, NULL, 14309, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:32:31', 'admin-1509763941-15097663511792286', 1, 0, '', NULL, NULL, NULL),
(52503, '2017-11-04 11:18:11', NULL, NULL, 14305, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:18:11', 'admin-1509763941-15097654914599725', 1, 1, 'SR', NULL, NULL, NULL),
(52504, '2017-11-04 11:17:47', NULL, NULL, 14305, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:17:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52505, '2017-11-04 11:18:11', NULL, NULL, 14305, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:18:11', 'admin-1509763941-15097654914599725', 1, 0, '', NULL, NULL, NULL),
(52506, '2017-11-04 11:18:11', NULL, NULL, 14305, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:18:11', 'admin-1509763941-15097654914599725', 1, 0, '', NULL, NULL, NULL),
(52507, '2017-11-04 10:42:25', NULL, NULL, 14302, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:42:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52508, '2017-11-04 10:42:38', NULL, NULL, 14302, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:42:38', 'admin-1509761400-15097633583027458', 1, 1, 'SR', NULL, NULL, NULL),
(52509, '2017-11-04 10:42:38', NULL, NULL, 14302, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:42:38', 'admin-1509761400-15097633583027458', 1, 1, 'SR', NULL, NULL, NULL),
(52510, '2017-11-04 12:33:12', NULL, NULL, 14317, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 12:33:12', 'admin-1509769719-15097699921856231', 1, 0, '', NULL, NULL, NULL),
(52511, '2017-11-04 11:23:34', NULL, NULL, 14306, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.00, 0.0000, 0.0000, 14.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:23:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52512, '2017-11-04 11:23:55', NULL, NULL, 14306, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:23:55', 'admin-1509763941-15097658352659383', 1, 0, '', NULL, NULL, NULL),
(52513, '2017-11-04 14:11:12', NULL, NULL, 14320, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 14:11:12', 'admin-1509769719-15097758724909662', 1, 0, '', NULL, NULL, NULL),
(52514, '2017-11-04 14:11:12', NULL, NULL, 14320, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 14:11:12', 'admin-1509769719-15097758724909662', 1, 1, 'SR', NULL, NULL, NULL),
(52515, '2017-11-04 11:35:55', NULL, NULL, 14310, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:35:55', 'admin-1509763941-15097665549255192', 1, 1, 'SR', NULL, NULL, NULL),
(52516, '2017-11-04 11:31:55', NULL, NULL, 14308, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:31:55', 'admin-1509763941-15097663157129179', 1, 1, 'SR', NULL, NULL, NULL),
(52517, '2017-11-04 11:46:03', NULL, NULL, 14312, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:46:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52518, '2017-11-04 11:46:06', NULL, NULL, 14312, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:46:06', 'admin-1509763941-15097671668138557', 1, 1, 'SR', NULL, NULL, NULL),
(52519, '2017-11-04 12:46:21', NULL, NULL, 14318, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 12:46:21', 'admin-1509769719-1509770781596824', 1, 1, 'SR', NULL, NULL, NULL),
(52520, '2017-11-04 11:53:39', NULL, NULL, 14314, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:53:39', 'admin-1509763941-1509767619324311', 1, 1, 'SR', NULL, NULL, NULL),
(52521, '2017-11-04 11:56:00', NULL, NULL, 14308, 0, 181, '116', 'Open Food ', '1 bread - not too hard,1 bread - not too hard', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:56:00', 'admin-1509763941-15097677605219159', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(52522, '2017-11-04 12:14:32', NULL, NULL, 14315, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1509769719', 'admin', '2017-11-04 12:14:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52523, '2017-11-04 12:14:54', NULL, NULL, 14315, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 12:14:54', 'admin-1509763941-1509768893873994', 1, 1, 'SR', NULL, NULL, NULL),
(52524, '2017-11-04 12:14:54', NULL, NULL, 14315, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 12:14:54', 'admin-1509763941-1509768893873994', 1, 1, 'SR', NULL, NULL, NULL),
(52525, '2017-11-04 12:14:54', NULL, NULL, 14315, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 12:14:54', 'admin-1509763941-1509768893873994', 1, 0, '', NULL, NULL, NULL),
(52526, '2017-11-04 14:35:44', NULL, NULL, 14322, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 14:35:44', 'admin-1509769719-15097773446063080', 1, 1, 'SR', NULL, NULL, NULL),
(52527, '2017-11-04 11:31:55', NULL, NULL, 14308, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:31:55', 'admin-1509763941-15097663157129179', 1, 1, 'SR', NULL, NULL, NULL),
(52528, '2017-11-04 11:53:20', NULL, NULL, 14314, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:53:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52529, '2017-11-04 11:50:27', NULL, NULL, 14313, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:50:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52530, '2017-11-04 11:50:36', NULL, NULL, 14313, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:50:36', 'admin-1509763941-15097674362408348', 1, 1, 'SR', NULL, NULL, NULL),
(52531, '2017-11-04 14:35:44', NULL, NULL, 14322, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 14:35:44', 'admin-1509769719-15097773446063080', 1, 1, 'SR', NULL, NULL, NULL),
(52532, '2017-11-04 14:35:44', NULL, NULL, 14322, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 14:35:44', 'admin-1509769719-15097773446063080', 1, 0, '', NULL, NULL, NULL),
(52533, '2017-11-04 14:35:07', NULL, NULL, 14322, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1509769719', 'admin', '2017-11-04 14:35:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52534, '2017-11-04 14:35:44', NULL, NULL, 14322, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 14:35:44', 'admin-1509769719-15097773446063080', 1, 1, 'SR', NULL, NULL, NULL),
(52535, '2017-11-04 14:10:57', NULL, NULL, 14320, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1509769719', 'admin', '2017-11-04 14:10:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52536, '2017-11-04 14:11:12', NULL, NULL, 14320, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 14:11:12', 'admin-1509769719-15097758724909662', 1, 0, '', NULL, NULL, NULL),
(52537, '2017-11-04 11:31:55', NULL, NULL, 14308, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:31:55', 'admin-1509763941-15097663157129179', 1, 1, 'SR', NULL, NULL, NULL),
(52538, '2017-11-04 12:46:21', NULL, NULL, 14318, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 12:46:21', 'admin-1509769719-1509770781596824', 1, 0, '', NULL, NULL, NULL),
(52539, '2017-11-04 10:51:39', NULL, NULL, 14304, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:51:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52540, '2017-11-04 10:51:34', NULL, NULL, 14303, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:51:34', 'admin-1509761400-1509763893961967', 1, 1, 'SR', NULL, NULL, NULL),
(52541, '2017-11-04 09:38:35', NULL, NULL, 14295, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:38:35', 'admin-1509758427-1509759515668310', 1, 1, 'SR', NULL, NULL, NULL),
(52542, '2017-11-04 10:51:34', NULL, NULL, 14303, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:51:34', 'admin-1509761400-1509763893961967', 1, 1, 'SR', NULL, NULL, NULL),
(52543, '2017-11-04 13:06:37', NULL, NULL, 14319, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 13:06:37', 'admin-1509769719-15097719976405616', 1, 0, '', NULL, NULL, NULL),
(52544, '2017-11-04 13:06:24', NULL, NULL, 14319, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 13:06:24', 'admin-1509769719-150977198392091', 1, 1, 'SR', NULL, NULL, NULL),
(52545, '2017-11-04 12:46:38', NULL, NULL, 14317, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 12:46:38', 'admin-1509769719-15097707981329519', 1, 1, 'SR', NULL, NULL, NULL),
(52546, '2017-11-04 11:29:35', NULL, NULL, 14308, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:29:35', 'admin-1509763941-15097661755198530', 1, 0, '', NULL, NULL, NULL),
(52547, '2017-11-04 11:18:11', NULL, NULL, 14305, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:18:11', 'admin-1509763941-15097654914599725', 1, 1, 'SR', NULL, NULL, NULL),
(52548, '2017-11-04 10:25:32', NULL, NULL, 14299, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:25:32', 'admin-1509761400-1509762332823295', 1, 0, '', NULL, NULL, '10.0'),
(52549, '2017-11-04 10:25:33', NULL, NULL, 14299, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:25:33', 'admin-1509761400-1509762332823295', 1, 0, '', NULL, NULL, '10.0'),
(52550, '2017-11-04 10:25:33', NULL, NULL, 14299, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:25:33', 'admin-1509761400-1509762332823295', 1, 1, 'SR', NULL, NULL, '10.0'),
(52551, '2017-11-04 10:25:33', NULL, NULL, 14299, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:25:33', 'admin-1509761400-1509762332823295', 1, 0, '', NULL, NULL, '10.0'),
(52552, '2017-11-04 10:27:21', NULL, NULL, 14300, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:27:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52553, '2017-11-04 10:31:39', NULL, NULL, 14296, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:31:39', 'admin-1509761400-15097626993574738', 1, 1, 'SR', NULL, NULL, NULL),
(52554, '2017-11-04 10:27:39', NULL, NULL, 14300, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:27:39', 'admin-1509761400-15097624588814487', 1, 0, '', NULL, NULL, NULL),
(52555, '2017-11-04 10:27:39', NULL, NULL, 14300, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:27:39', 'admin-1509761400-15097624588814487', 1, 1, 'SR', NULL, NULL, NULL),
(52556, '2017-11-04 10:27:39', NULL, NULL, 14300, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:27:39', 'admin-1509761400-15097624588814487', 1, 1, 'SR', NULL, NULL, NULL),
(52557, '2017-11-04 12:46:21', NULL, NULL, 14318, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 12:46:21', 'admin-1509769719-1509770781596824', 1, 0, '', NULL, NULL, NULL),
(52558, '2017-11-04 13:06:13', NULL, NULL, 14319, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1509769719', 'admin', '2017-11-04 13:06:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52559, '2017-11-04 13:06:24', NULL, NULL, 14319, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 13:06:24', 'admin-1509769719-150977198392091', 1, 0, '', NULL, NULL, NULL),
(52560, '2017-11-04 12:33:32', NULL, NULL, 14317, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 12:33:32', 'admin-1509769719-15097700120878524', 1, 1, 'SR', NULL, NULL, NULL),
(52561, '2017-11-04 10:28:30', NULL, NULL, 14301, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:28:30', 'admin-1509761400-15097625108351950', 1, 1, 'SR', NULL, NULL, NULL),
(52562, '2017-11-04 09:18:36', NULL, NULL, 14293, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:18:36', 'admin-1509757301-15097583160729859', 1, 1, 'SR', NULL, NULL, NULL),
(52563, '2017-11-04 09:18:36', NULL, NULL, 14293, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:18:36', 'admin-1509757301-15097583160729859', 1, 1, 'SR', NULL, NULL, NULL),
(52564, '2017-11-04 09:19:56', NULL, NULL, 14294, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:19:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52565, '2017-11-04 09:20:40', NULL, NULL, 14294, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:20:40', 'admin-1509758427-15097584400126984', 1, 1, 'SR', NULL, NULL, NULL),
(52566, '2017-11-04 09:20:40', NULL, NULL, 14294, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:20:40', 'admin-1509758427-15097584400126984', 1, 1, 'SR', NULL, NULL, NULL),
(52567, '2017-11-04 09:20:40', NULL, NULL, 14294, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:20:40', 'admin-1509758427-15097584400126984', 1, 1, 'SR', NULL, NULL, NULL),
(52568, '2017-11-04 11:29:35', NULL, NULL, 14308, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:29:35', 'admin-1509763941-15097661755198530', 1, 0, '', NULL, NULL, NULL),
(52569, '2017-11-04 12:33:12', NULL, NULL, 14317, 0, 192, '127', 'Flaming Hot & Spicy Pork', 'less spicy', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 12:33:12', 'admin-1509769719-15097699921856231', 1, 0, '', NULL, NULL, NULL),
(52570, '2017-11-04 12:32:24', NULL, NULL, 14317, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1509769719', 'admin', '2017-11-04 12:32:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52571, '2017-11-04 12:25:46', NULL, NULL, 14316, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 12:25:46', 'admin-1509763941-1509769546650708', 1, 0, '', NULL, NULL, NULL),
(52572, '2017-11-04 12:25:46', NULL, NULL, 14316, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 12:25:46', 'admin-1509763941-1509769546650708', 1, 1, 'SR', NULL, NULL, NULL),
(52573, '2017-11-04 12:25:46', NULL, NULL, 14316, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 12:25:46', 'admin-1509763941-1509769546650708', 1, 0, '', NULL, NULL, NULL),
(52574, '2017-11-04 12:25:36', NULL, NULL, 14316, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1509769719', 'admin', '2017-11-04 12:25:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52575, '2017-11-04 11:29:16', NULL, NULL, 14308, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.00, 0.0000, 0.0000, 12.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:29:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52576, '2017-11-04 11:53:39', NULL, NULL, 14314, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:53:39', 'admin-1509763941-1509767619324311', 1, 1, 'SR', NULL, NULL, NULL),
(52577, '2017-11-04 12:20:39', NULL, NULL, 14310, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 12:20:39', 'admin-1509763941-15097692388781853', 1, 1, 'SR', NULL, NULL, NULL),
(52578, '2017-11-04 12:15:06', NULL, NULL, 14315, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 12:15:06', 'admin-1509763941-1509768906224934', 1, 0, '', NULL, NULL, NULL),
(52579, '2017-11-04 11:24:57', NULL, NULL, 14307, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:24:57', 'admin-1509763941-15097658972856727', 1, 0, '', NULL, NULL, NULL),
(52580, '2017-11-04 11:24:57', NULL, NULL, 14307, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:24:57', 'admin-1509763941-15097658972856727', 1, 1, 'SR', NULL, NULL, NULL),
(52581, '2017-11-04 12:15:06', NULL, NULL, 14315, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 12:15:06', 'admin-1509763941-1509768906224934', 1, 1, 'SR', NULL, NULL, NULL),
(52582, '2017-11-04 11:53:39', NULL, NULL, 14314, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:53:39', 'admin-1509763941-1509767619324311', 1, 0, '', NULL, NULL, NULL),
(52583, '2017-11-04 11:53:39', NULL, NULL, 14314, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:53:39', 'admin-1509763941-1509767619324311', 1, 0, '', NULL, NULL, NULL),
(52584, '2017-11-04 11:24:25', NULL, NULL, 14307, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:24:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52585, '2017-11-04 11:24:20', NULL, NULL, 14306, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:24:20', 'admin-1509763941-15097658601627431', 1, 1, 'SR', NULL, NULL, NULL),
(52586, '2017-11-04 11:24:20', NULL, NULL, 14306, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:24:20', 'admin-1509763941-15097658601627431', 1, 1, 'SR', NULL, NULL, NULL),
(52587, '2017-11-04 11:24:20', NULL, NULL, 14306, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:24:20', 'admin-1509763941-15097658601627431', 1, 1, 'SR', NULL, NULL, NULL),
(52588, '2017-11-04 11:24:20', NULL, NULL, 14306, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:24:20', 'admin-1509763941-15097658601627431', 1, 1, 'SR', NULL, NULL, NULL),
(52589, '2017-11-04 11:50:36', NULL, NULL, 14313, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:50:36', 'admin-1509763941-15097674362408348', 1, 1, 'SR', NULL, NULL, NULL),
(52590, '2017-11-04 11:23:55', NULL, NULL, 14306, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:23:55', 'admin-1509763941-15097658352659383', 1, 0, '', NULL, NULL, NULL),
(52591, '2017-11-04 15:28:49', NULL, NULL, 14321, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 15:28:49', 'admin-1509769719-15097805292912918', 1, 1, 'SR', NULL, NULL, '10.0'),
(52592, '2017-11-04 11:23:55', NULL, NULL, 14306, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:23:55', 'admin-1509763941-15097658352659383', 1, 0, '', NULL, NULL, NULL),
(52593, '2017-11-04 11:23:55', NULL, NULL, 14306, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:23:55', 'admin-1509763941-15097658352659383', 1, 0, '', NULL, NULL, NULL),
(52594, '2017-11-04 11:23:55', NULL, NULL, 14306, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:23:55', 'admin-1509763941-15097658352659383', 1, 0, '', NULL, NULL, NULL),
(52595, '2017-11-04 10:51:08', NULL, NULL, 14303, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:51:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52596, '2017-11-04 10:51:20', NULL, NULL, 14303, 0, 153, '87', 'Wake Me Up!', 'sunny side up', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:51:20', 'admin-1509761400-15097638800656591', 1, 0, '', NULL, NULL, NULL),
(52597, '2017-11-04 10:51:20', NULL, NULL, 14303, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:51:20', 'admin-1509761400-15097638800656591', 1, 0, '', NULL, NULL, NULL),
(52598, '2017-11-04 10:42:38', NULL, NULL, 14302, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:42:38', 'admin-1509761400-15097633583027458', 1, 1, 'SR', NULL, NULL, NULL),
(52599, '2017-11-04 10:28:31', NULL, NULL, 14301, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:28:31', 'admin-1509761400-15097625108351950', 1, 1, 'SR', NULL, NULL, NULL),
(52600, '2017-11-04 10:28:31', NULL, NULL, 14301, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:28:31', 'admin-1509761400-15097625108351950', 1, 0, '', NULL, NULL, NULL),
(52601, '2017-11-04 10:29:05', NULL, NULL, 14300, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:29:05', 'admin-1509761400-15097625454972754', 1, 0, '', NULL, NULL, NULL),
(52602, '2017-11-04 11:35:39', NULL, NULL, 14310, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:35:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52603, '2017-11-04 10:28:30', NULL, NULL, 14301, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:28:30', 'admin-1509761400-15097625108351950', 1, 1, 'SR', NULL, NULL, NULL),
(52604, '2017-11-04 13:06:37', NULL, NULL, 14319, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 13:06:37', 'admin-1509769719-15097719976405616', 1, 1, 'SR', NULL, NULL, NULL),
(52605, '2017-11-04 10:43:03', NULL, NULL, 14302, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:43:03', 'admin-1509761400-15097633832937469', 1, 0, '', NULL, NULL, NULL),
(52606, '2017-11-04 10:43:03', NULL, NULL, 14302, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:43:03', 'admin-1509761400-15097633832937469', 1, 0, '', NULL, NULL, NULL),
(52607, '2017-11-04 10:42:38', NULL, NULL, 14302, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:42:38', 'admin-1509761400-15097633583027458', 1, 1, 'SR', NULL, NULL, NULL),
(52608, '2017-11-04 10:27:52', NULL, NULL, 14301, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.30, 0.0000, 0.0000, 13.30, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:27:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52609, '2017-11-04 10:28:07', NULL, NULL, 14301, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:28:07', 'admin-1509761400-15097624868393540', 1, 0, '', NULL, NULL, NULL),
(52610, '2017-11-04 10:51:52', NULL, NULL, 14304, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:51:52', 'admin-1509761400-15097639124897631', 1, 0, '', NULL, NULL, NULL),
(52611, '2017-11-04 10:51:52', NULL, NULL, 14304, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:51:52', 'admin-1509761400-15097639124897631', 1, 0, '', NULL, NULL, NULL),
(52612, '2017-11-04 10:28:07', NULL, NULL, 14301, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:28:07', 'admin-1509761400-15097624868393540', 1, 0, '', NULL, NULL, NULL),
(52613, '2017-11-04 10:28:07', NULL, NULL, 14301, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:28:07', 'admin-1509761400-15097624868393540', 1, 0, '', NULL, NULL, NULL),
(52614, '2017-11-04 11:35:55', NULL, NULL, 14310, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 11:35:55', 'admin-1509763941-15097665549255192', 1, 0, '', NULL, NULL, NULL),
(52615, '2017-11-04 09:38:35', NULL, NULL, 14295, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:38:35', 'admin-1509758427-1509759515668310', 1, 1, 'SR', NULL, NULL, NULL),
(52616, '2017-11-04 09:38:35', NULL, NULL, 14295, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:38:35', 'admin-1509758427-1509759515668310', 1, 1, 'SR', NULL, NULL, NULL),
(52617, '2017-11-04 10:07:23', NULL, NULL, 14296, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:07:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52618, '2017-11-04 10:28:07', NULL, NULL, 14301, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:28:07', 'admin-1509761400-15097624868393540', 1, 0, '', NULL, NULL, NULL),
(52619, '2017-11-04 10:07:44', NULL, NULL, 14296, 0, 153, '87', 'Wake Me Up!', 'change to sunny side up', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:07:44', 'admin-1509758427-15097612644628215', 1, 0, '', NULL, NULL, NULL),
(52620, '2017-11-04 10:10:13', NULL, NULL, 14296, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:10:13', 'admin-1509761400-1509761413759913', 1, 0, '', NULL, NULL, NULL),
(52621, '2017-11-04 12:15:06', NULL, NULL, 14315, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 12:15:06', 'admin-1509763941-1509768906224934', 1, 0, '', NULL, NULL, NULL),
(52622, '2017-11-04 09:11:28', NULL, NULL, 14292, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:11:28', 'admin-1509757301-15097578878499983', 1, 0, '', NULL, NULL, NULL),
(52623, '2017-11-04 09:12:08', NULL, NULL, 14292, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:12:08', 'admin-1509757301-15097579286629568', 1, 1, 'SR', NULL, NULL, NULL),
(52624, '2017-11-04 10:28:07', NULL, NULL, 14301, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:28:07', 'admin-1509761400-15097624868393540', 1, 0, '', NULL, NULL, NULL),
(52625, '2017-11-04 10:22:34', NULL, NULL, 14297, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:22:34', 'admin-1509761400-15097621547051728', 1, 0, '', NULL, NULL, NULL),
(52626, '2017-11-04 10:22:24', NULL, NULL, 14297, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:22:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52627, '2017-11-04 10:22:34', NULL, NULL, 14297, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:22:34', 'admin-1509761400-15097621547051728', 1, 0, '', NULL, NULL, NULL),
(52628, '2017-11-04 10:10:45', NULL, NULL, 14296, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:10:45', 'admin-1509761400-15097614457307271', 1, 1, 'SR', NULL, NULL, NULL),
(52629, '2017-11-04 10:10:45', NULL, NULL, 14296, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:10:45', 'admin-1509761400-15097614457307271', 1, 1, 'SR', NULL, NULL, NULL),
(52630, '2017-11-04 10:10:45', NULL, NULL, 14296, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:10:45', 'admin-1509761400-15097614457307271', 1, 1, 'SR', NULL, NULL, NULL),
(52631, '2017-11-04 10:10:45', NULL, NULL, 14296, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:10:45', 'admin-1509761400-15097614457307271', 1, 1, 'SR', NULL, NULL, NULL),
(52632, '2017-11-04 10:10:45', NULL, NULL, 14296, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:10:45', 'admin-1509761400-15097614457307271', 1, 1, 'SR', NULL, NULL, NULL),
(52633, '2017-11-04 10:10:31', NULL, NULL, 14296, 0, 181, '116', 'Open Food ', 'pancake butter', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:10:31', 'admin-1509761400-15097614317036091', 1, 0, '', NULL, NULL, NULL),
(52634, '2017-11-04 09:38:11', NULL, NULL, 14295, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:38:11', 'admin-1509758427-15097594915959311', 1, 0, '', NULL, NULL, NULL),
(52635, '2017-11-04 09:38:11', NULL, NULL, 14295, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:38:11', 'admin-1509758427-15097594915959311', 1, 0, '', NULL, NULL, NULL),
(52636, '2017-11-04 09:38:03', NULL, NULL, 14295, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:38:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52637, '2017-11-04 09:20:40', NULL, NULL, 14294, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:20:40', 'admin-1509758427-15097584400126984', 1, 1, 'SR', NULL, NULL, NULL),
(52638, '2017-11-04 09:21:02', NULL, NULL, 14294, 0, 181, '116', 'Open Food ', 'toast butter', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:21:02', 'admin-1509758427-15097584626413338', 1, 0, '', NULL, NULL, NULL),
(52639, '2017-11-04 09:24:15', NULL, NULL, 14293, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:24:15', 'admin-1509758427-1509758654828354', 1, 0, '', NULL, NULL, NULL),
(52640, '2017-11-04 09:15:29', NULL, NULL, 14292, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:15:29', 'admin-1509757301-15097581295988189', 1, 0, '', NULL, NULL, NULL),
(52641, '2017-11-04 09:18:26', NULL, NULL, 14293, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:18:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52642, '2017-11-04 09:18:31', NULL, NULL, 14293, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:18:31', 'admin-1509757301-150975831179653', 1, 0, '', NULL, NULL, NULL),
(52643, '2017-11-04 09:18:31', NULL, NULL, 14293, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:18:31', 'admin-1509757301-150975831179653', 1, 0, '', NULL, NULL, NULL),
(52644, '2017-11-04 10:25:13', NULL, NULL, 14299, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 10:25:13', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(52645, '2017-11-04 09:11:21', NULL, NULL, 14292, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:11:21', 'admin-1509757301-1509757881771328', 1, 0, '', NULL, NULL, NULL),
(52646, '2017-11-04 09:11:21', NULL, NULL, 14292, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:11:21', 'admin-1509757301-1509757881771328', 1, 0, '', NULL, NULL, NULL),
(52647, '2017-11-04 09:11:21', NULL, NULL, 14292, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:11:21', 'admin-1509757301-1509757881771328', 1, 0, '', NULL, NULL, NULL),
(52648, '2017-11-04 09:07:24', NULL, NULL, 14292, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1509769719', 'admin', '2017-11-04 09:07:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52649, '2017-11-05 10:54:51', NULL, NULL, 14331, 0, 181, '116', 'Open Food ', ' 1 toast, scrambled egg,potato', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:54:51', 'admin-1509850038-15098504910787025', 1, 0, '', NULL, NULL, NULL),
(52650, '2017-11-05 11:50:17', NULL, NULL, 14334, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 11:50:17', 'admin-1509850038-15098538175915290', 1, 1, 'SR', NULL, NULL, NULL),
(52651, '2017-11-05 11:50:17', NULL, NULL, 14334, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 11:50:17', 'admin-1509850038-15098538175915290', 1, 0, '', NULL, NULL, NULL),
(52652, '2017-11-05 10:31:24', NULL, NULL, 14329, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:31:24', 'admin-1509842535-15098490847776033', 1, 1, 'SR', NULL, NULL, NULL),
(52653, '2017-11-05 10:34:24', NULL, NULL, 14325, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:34:24', 'admin-1509842535-15098492638635512', 1, 1, 'SR', NULL, NULL, NULL),
(52654, '2017-11-05 10:36:24', NULL, NULL, 14330, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:36:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52655, '2017-11-05 11:15:08', NULL, NULL, 14333, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 11:15:08', 'admin-1509850038-15098517080165061', 1, 0, '', NULL, NULL, NULL),
(52656, '2017-11-05 11:50:17', NULL, NULL, 14334, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 11:50:17', 'admin-1509850038-15098538175915290', 1, 1, 'SR', NULL, NULL, NULL),
(52657, '2017-11-05 13:45:01', NULL, NULL, 14344, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1509863774', 'admin', '2017-11-05 13:45:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52658, '2017-11-05 13:45:11', NULL, NULL, 14344, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 13:45:11', 'admin-1509855311-15098607115028440', 1, 1, 'SR', NULL, NULL, NULL),
(52659, '2017-11-05 13:47:09', NULL, NULL, 14344, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 13:47:09', 'admin-1509855311-1509860828865142', 1, 1, 'SR', NULL, NULL, NULL),
(52660, '2017-11-05 11:50:07', NULL, NULL, 14334, 0, 153, '87', 'Wake Me Up!', 'no baked bean', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 11:50:07', 'admin-1509850038-15098538073721820', 1, 0, '', NULL, NULL, NULL),
(52661, '2017-11-05 13:22:20', NULL, NULL, 14343, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 13:22:20', 'admin-1509855311-15098593399517435', 1, 1, 'SR', NULL, NULL, NULL),
(52662, '2017-11-05 12:01:53', NULL, NULL, 14336, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:01:53', 'admin-1509850038-1509854513461172', 1, 0, '', NULL, NULL, NULL),
(52663, '2017-11-05 12:01:53', NULL, NULL, 14336, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:01:53', 'admin-1509850038-1509854513461172', 1, 0, '', NULL, NULL, NULL),
(52664, '2017-11-05 12:01:53', NULL, NULL, 14336, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:01:53', 'admin-1509850038-1509854513461172', 1, 0, '', NULL, NULL, NULL),
(52665, '2017-11-05 12:10:34', NULL, NULL, 14338, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:10:34', 'admin-1509850038-15098550343642394', 1, 0, '', NULL, NULL, NULL),
(52666, '2017-11-05 12:13:38', NULL, NULL, 14334, 0, 181, '116', 'Open Food ', '1 slice of toast', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:13:38', 'admin-1509850038-15098552178782577', 1, 0, '', NULL, NULL, NULL),
(52667, '2017-11-05 12:15:09', NULL, NULL, 14339, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:15:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52668, '2017-11-05 12:15:28', NULL, NULL, 14339, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:15:28', 'admin-1509855311-15098553280859029', 1, 1, 'SR', NULL, NULL, NULL),
(52669, '2017-11-05 12:15:28', NULL, NULL, 14339, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:15:28', 'admin-1509855311-15098553280859029', 1, 1, 'SR', NULL, NULL, NULL),
(52670, '2017-11-05 12:15:43', NULL, NULL, 14339, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:15:43', 'admin-1509855311-15098553436324261', 1, 1, 'SR', NULL, NULL, NULL),
(52671, '2017-11-05 12:26:05', NULL, NULL, 14340, 0, 70, '70', 'Borneo Pepper Pork', 'Takeaway', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:26:05', 'admin-1509855311-150985596491872', 1, 1, 'SR', NULL, NULL, '10.0'),
(52672, '2017-11-05 10:31:24', NULL, NULL, 14329, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:31:24', 'admin-1509842535-15098490847776033', 1, 1, 'SR', NULL, NULL, NULL),
(52673, '2017-11-05 11:50:07', NULL, NULL, 14334, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 11:50:07', 'admin-1509850038-15098538073721820', 1, 0, '', NULL, NULL, NULL),
(52674, '2017-11-05 10:30:13', NULL, NULL, 14328, 0, 271, '205', 'Take It Easy', 'sunny side up)', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:30:13', 'admin-1509842535-1509849013586112', 1, 0, '', NULL, NULL, NULL),
(52675, '2017-11-05 10:30:24', NULL, NULL, 14328, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:30:24', 'admin-1509842535-15098490243535371', 1, 0, '', NULL, NULL, NULL),
(52676, '2017-11-05 10:01:28', NULL, NULL, 14324, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:01:28', 'admin-1509842535-15098472883644415', 1, 1, 'SR', NULL, NULL, NULL),
(52677, '2017-11-05 10:01:28', NULL, NULL, 14324, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:01:28', 'admin-1509842535-15098472883644415', 1, 1, 'SR', NULL, NULL, NULL),
(52678, '2017-11-05 10:05:30', NULL, NULL, 14325, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:05:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52679, '2017-11-05 10:05:40', NULL, NULL, 14325, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:05:40', 'admin-1509842535-15098475400274154', 1, 0, '', NULL, NULL, NULL),
(52680, '2017-11-05 10:05:40', NULL, NULL, 14325, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:05:40', 'admin-1509842535-15098475400274154', 1, 0, '', NULL, NULL, NULL),
(52681, '2017-11-05 10:05:57', NULL, NULL, 14325, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:05:57', 'admin-1509842535-1509847557383719', 1, 1, 'SR', NULL, NULL, NULL),
(52682, '2017-11-05 10:05:57', NULL, NULL, 14325, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:05:57', 'admin-1509842535-1509847557383719', 1, 1, 'SR', NULL, NULL, NULL),
(52683, '2017-11-05 10:05:57', NULL, NULL, 14325, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:05:57', 'admin-1509842535-1509847557383719', 1, 1, 'SR', NULL, NULL, NULL),
(52684, '2017-11-05 10:10:13', NULL, NULL, 14326, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.20, 0.0000, 0.0000, 12.20, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:10:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52685, '2017-11-05 10:10:25', NULL, NULL, 14326, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:10:25', 'admin-1509842535-15098478257813315', 1, 0, '', NULL, NULL, NULL),
(52686, '2017-11-05 13:03:18', NULL, NULL, 14342, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1509863774', 'admin', '2017-11-05 13:03:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52687, '2017-11-05 13:03:38', NULL, NULL, 14342, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 13:03:38', 'admin-1509855311-15098582188198055', 1, 1, 'SR', NULL, NULL, NULL),
(52688, '2017-11-05 13:03:38', NULL, NULL, 14342, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 13:03:38', 'admin-1509855311-15098582188198055', 1, 1, 'SR', NULL, NULL, NULL),
(52689, '2017-11-05 13:22:01', NULL, NULL, 14343, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1509863774', 'admin', '2017-11-05 13:22:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52690, '2017-11-05 13:22:20', NULL, NULL, 14343, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 13:22:20', 'admin-1509855311-15098593399517435', 1, 1, 'SR', NULL, NULL, NULL),
(52691, '2017-11-05 14:25:56', NULL, NULL, 14347, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 14:25:56', 'admin-1509855311-15098631564655215', 1, 1, 'SR', NULL, NULL, NULL),
(52692, '2017-11-05 14:25:56', NULL, NULL, 14347, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 14:25:56', 'admin-1509855311-15098631564655215', 1, 0, '', NULL, NULL, NULL),
(52693, '2017-11-05 10:45:51', NULL, NULL, 14331, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:45:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52694, '2017-11-05 14:20:22', NULL, NULL, 14346, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 14:20:22', 'admin-1509855311-15098628218961867', 1, 0, '', NULL, NULL, NULL),
(52695, '2017-11-05 14:25:51', NULL, NULL, 14347, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1509863774', 'admin', '2017-11-05 14:25:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52696, '2017-11-05 14:25:56', NULL, NULL, 14347, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 14:25:56', 'admin-1509855311-15098631564655215', 1, 1, 'SR', NULL, NULL, NULL),
(52697, '2017-11-05 14:20:22', NULL, NULL, 14346, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 14:20:22', 'admin-1509855311-15098628218961867', 1, 0, '', NULL, NULL, NULL),
(52698, '2017-11-05 14:20:22', NULL, NULL, 14346, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 14:20:22', 'admin-1509855311-15098628218961867', 1, 1, 'SR', NULL, NULL, NULL),
(52699, '2017-11-05 14:20:22', NULL, NULL, 14346, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 14:20:22', 'admin-1509855311-15098628218961867', 1, 1, 'SR', NULL, NULL, NULL),
(52700, '2017-11-05 12:37:11', NULL, NULL, 14334, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:37:11', 'admin-1509855311-1509856631635195', 1, 0, '', NULL, NULL, NULL),
(52701, '2017-11-05 12:35:27', NULL, NULL, 14341, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:35:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52702, '2017-11-05 12:35:41', NULL, NULL, 14341, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:35:41', 'admin-1509855311-15098565416741818', 1, 1, 'SR', NULL, NULL, NULL),
(52703, '2017-11-05 12:15:43', NULL, NULL, 14339, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:15:43', 'admin-1509855311-15098553436324261', 1, 1, 'SR', NULL, NULL, NULL),
(52704, '2017-11-05 12:25:43', NULL, NULL, 14340, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:25:43', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(52705, '2017-11-05 12:10:34', NULL, NULL, 14338, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:10:34', 'admin-1509850038-15098550343642394', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(52706, '2017-11-05 12:10:34', NULL, NULL, 14338, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:10:34', 'admin-1509850038-15098550343642394', 1, 0, '', NULL, NULL, NULL),
(52707, '2017-11-05 12:10:07', NULL, NULL, 14338, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:10:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52708, '2017-11-05 12:10:34', NULL, NULL, 14338, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:10:34', 'admin-1509850038-15098550343642394', 1, 1, 'SR', NULL, NULL, NULL),
(52709, '2017-11-05 12:08:29', NULL, NULL, 14337, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:08:29', 'admin-1509850038-15098549097627488', 1, 1, 'SR', NULL, NULL, NULL),
(52710, '2017-11-05 12:08:37', NULL, NULL, 14337, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:08:37', 'admin-1509850038-15098549176019236', 1, 1, 'SR', NULL, NULL, NULL),
(52711, '2017-11-05 12:08:10', NULL, NULL, 14337, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:08:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52712, '2017-11-05 12:01:38', NULL, NULL, 14336, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:01:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52713, '2017-11-05 11:55:53', NULL, NULL, 14335, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 11:55:53', 'admin-1509850038-15098541533673838', 1, 1, 'SR', NULL, NULL, NULL),
(52714, '2017-11-05 11:55:48', NULL, NULL, 14335, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1509863774', 'admin', '2017-11-05 11:55:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52715, '2017-11-05 10:48:13', NULL, NULL, 14332, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:48:13', 'admin-1509850038-15098500935244420', 1, 1, 'SR', NULL, NULL, NULL),
(52716, '2017-11-05 10:31:24', NULL, NULL, 14329, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:31:24', 'admin-1509842535-15098490847776033', 1, 1, 'SR', NULL, NULL, NULL),
(52717, '2017-11-05 14:20:03', NULL, NULL, 14346, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1509863774', 'admin', '2017-11-05 14:20:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52718, '2017-11-05 12:08:37', NULL, NULL, 14337, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:08:37', 'admin-1509850038-15098549176019236', 1, 1, 'SR', NULL, NULL, NULL),
(52719, '2017-11-05 10:56:43', NULL, NULL, 14330, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:56:43', 'admin-1509850038-1509850603158752', 1, 0, '', NULL, NULL, NULL),
(52720, '2017-11-05 11:50:07', NULL, NULL, 14334, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 11:50:07', 'admin-1509850038-15098538073721820', 1, 0, '', NULL, NULL, NULL),
(52721, '2017-11-05 14:18:59', NULL, NULL, 14345, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1509863774', 'admin', '2017-11-05 14:18:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52722, '2017-11-05 11:49:47', NULL, NULL, 14334, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1509863774', 'admin', '2017-11-05 11:49:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52723, '2017-11-05 11:50:07', NULL, NULL, 14334, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 11:50:07', 'admin-1509850038-15098538073721820', 1, 0, '', NULL, NULL, NULL),
(52724, '2017-11-05 11:15:15', NULL, NULL, 14333, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 11:15:15', 'admin-1509850038-1509851714884412', 1, 1, 'SR', NULL, NULL, NULL),
(52725, '2017-11-05 10:46:12', NULL, NULL, 14331, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:46:12', 'admin-1509842535-15098499724108781', 1, 1, 'SR', NULL, NULL, NULL),
(52726, '2017-11-05 14:19:03', NULL, NULL, 14345, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 14:19:03', 'admin-1509855311-15098627428128998', 1, 1, 'SR', NULL, NULL, NULL),
(52727, '2017-11-05 11:15:08', NULL, NULL, 14333, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 11:15:08', 'admin-1509850038-15098517080165061', 1, 0, '', NULL, NULL, NULL),
(52728, '2017-11-05 12:08:29', NULL, NULL, 14337, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 12:08:29', 'admin-1509850038-15098549097627488', 1, 1, 'SR', NULL, NULL, NULL),
(52729, '2017-11-05 10:56:43', NULL, NULL, 14330, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:56:43', 'admin-1509850038-1509850603158752', 1, 0, '', NULL, NULL, NULL),
(52730, '2017-11-05 10:36:31', NULL, NULL, 14330, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:36:31', 'admin-1509842535-15098493912101785', 1, 1, 'SR', NULL, NULL, NULL),
(52731, '2017-11-05 10:36:31', NULL, NULL, 14330, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:36:31', 'admin-1509842535-15098493912101785', 1, 1, 'SR', NULL, NULL, NULL),
(52732, '2017-11-05 11:15:01', NULL, NULL, 14333, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1509863774', 'admin', '2017-11-05 11:15:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52733, '2017-11-05 10:48:05', NULL, NULL, 14332, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:48:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52734, '2017-11-05 10:48:13', NULL, NULL, 14332, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:48:13', 'admin-1509850038-15098500935244420', 1, 0, '', NULL, NULL, NULL),
(52735, '2017-11-05 10:48:13', NULL, NULL, 14332, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:48:13', 'admin-1509850038-15098500935244420', 1, 0, '', NULL, NULL, NULL),
(52736, '2017-11-05 10:48:13', NULL, NULL, 14332, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:48:13', 'admin-1509850038-15098500935244420', 1, 1, 'SR', NULL, NULL, NULL),
(52737, '2017-11-05 10:46:12', NULL, NULL, 14331, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:46:12', 'admin-1509842535-15098499724108781', 1, 1, 'SR', NULL, NULL, NULL),
(52738, '2017-11-05 10:01:21', NULL, NULL, 14324, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:01:21', 'admin-1509842535-15098472816589645', 1, 0, '', NULL, NULL, NULL),
(52739, '2017-11-05 10:01:28', NULL, NULL, 14324, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:01:28', 'admin-1509842535-15098472883644415', 1, 1, 'SR', NULL, NULL, NULL),
(52740, '2017-11-05 10:10:25', NULL, NULL, 14326, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:10:25', 'admin-1509842535-15098478257813315', 1, 0, '', NULL, NULL, NULL),
(52741, '2017-11-05 10:10:25', NULL, NULL, 14326, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:10:25', 'admin-1509842535-15098478257813315', 1, 0, '', NULL, NULL, NULL),
(52742, '2017-11-05 10:10:25', NULL, NULL, 14326, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:10:25', 'admin-1509842535-15098478257813315', 1, 0, '', NULL, NULL, NULL),
(52743, '2017-11-05 10:10:37', NULL, NULL, 14326, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:10:37', 'admin-1509842535-15098478371706544', 1, 0, '', NULL, NULL, NULL),
(52744, '2017-11-05 10:10:37', NULL, NULL, 14326, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:10:37', 'admin-1509842535-15098478371706544', 1, 0, '', NULL, NULL, NULL),
(52745, '2017-11-05 10:31:12', NULL, NULL, 14329, 0, 181, '116', 'Open Food ', 'scramble eggs', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:31:12', 'admin-1509842535-15098490718876318', 1, 0, '', NULL, NULL, NULL),
(52746, '2017-11-05 10:31:24', NULL, NULL, 14329, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:31:24', 'admin-1509842535-15098490847776033', 1, 1, 'SR', NULL, NULL, NULL),
(52747, '2017-11-05 10:31:12', NULL, NULL, 14329, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:31:12', 'admin-1509842535-15098490718876318', 1, 0, '', NULL, NULL, NULL),
(52748, '2017-11-05 10:46:06', NULL, NULL, 14331, 0, 153, '87', 'Wake Me Up!', ' no bacon,no sausage', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:46:06', 'admin-1509842535-15098499663072655', 1, 0, '', NULL, NULL, NULL),
(52749, '2017-11-05 10:31:12', NULL, NULL, 14329, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:31:12', 'admin-1509842535-15098490718876318', 1, 0, '', NULL, NULL, NULL),
(52750, '2017-11-05 10:30:43', NULL, NULL, 14328, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:30:43', 'admin-1509842535-15098490437811649', 1, 1, 'SR', NULL, NULL, NULL),
(52751, '2017-11-05 10:30:43', NULL, NULL, 14328, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:30:43', 'admin-1509842535-15098490437811649', 1, 0, '', NULL, NULL, NULL),
(52752, '2017-11-05 10:30:49', NULL, NULL, 14329, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:30:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52753, '2017-11-05 10:30:43', NULL, NULL, 14328, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:30:43', 'admin-1509842535-15098490437811649', 1, 1, 'SR', NULL, NULL, NULL),
(52754, '2017-11-05 10:29:55', NULL, NULL, 14328, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:29:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52755, '2017-11-05 10:18:00', NULL, NULL, 14327, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:18:00', 'admin-1509842535-15098482800642844', 1, 0, '', 1, NULL, '10.0'),
(52756, '2017-11-05 10:18:00', NULL, NULL, 14327, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:18:00', 'admin-1509842535-15098482800642844', 1, 1, 'SR', 1, NULL, '10.0'),
(52757, '2017-11-05 10:10:37', NULL, NULL, 14326, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:10:37', 'admin-1509842535-15098478371706544', 1, 1, 'SR', NULL, NULL, NULL),
(52758, '2017-11-05 10:10:37', NULL, NULL, 14326, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:10:37', 'admin-1509842535-15098478371706544', 1, 1, 'SR', NULL, NULL, NULL),
(52759, '2017-11-05 10:01:21', NULL, NULL, 14324, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:01:21', 'admin-1509842535-15098472816589645', 1, 0, '', NULL, NULL, NULL),
(52760, '2017-11-05 10:01:21', NULL, NULL, 14324, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:01:21', 'admin-1509842535-15098472816589645', 1, 0, '', NULL, NULL, NULL),
(52761, '2017-11-05 10:01:21', NULL, NULL, 14324, 0, 154, '88', 'Daily Dose BLT', 'well done egg', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:01:21', 'admin-1509842535-15098472816589645', 1, 0, '', NULL, NULL, NULL),
(52762, '2017-11-05 10:01:05', NULL, NULL, 14324, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.10, 0.0000, 0.0000, 11.10, 1, '27', 1, '1509863774', 'admin', '2017-11-05 10:01:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52763, '2017-11-06 13:44:04', NULL, NULL, 14375, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 13:44:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52764, '2017-11-06 13:29:34', NULL, NULL, 14374, 0, 181, '116', 'Open Food ', 'summer salad small size', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 13:29:34', 'admin-1509929750-15099461741611348', 1, 0, '', NULL, NULL, NULL),
(52765, '2017-11-06 14:11:24', NULL, NULL, 14374, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 14:11:24', 'admin-1509929750-1509948684193620', 1, 0, '', NULL, NULL, NULL),
(52766, '2017-11-06 13:48:21', NULL, NULL, 14376, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1509954235', 'admin', '2017-11-06 13:48:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52767, '2017-11-06 13:44:11', NULL, NULL, 14375, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 13:44:11', 'admin-1509929750-15099470517809119', 1, 1, 'SR', NULL, NULL, NULL),
(52768, '2017-11-06 10:50:02', NULL, NULL, 14352, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 10:50:02', 'admin-1509929750-15099366027806777', 1, 1, 'SR', NULL, NULL, '10.0'),
(52769, '2017-11-06 13:29:34', NULL, NULL, 14374, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 13:29:34', 'admin-1509929750-15099461741611348', 1, 1, 'SR', NULL, NULL, NULL),
(52770, '2017-11-06 13:28:07', NULL, NULL, 14374, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1509954235', 'admin', '2017-11-06 13:28:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52771, '2017-11-06 13:08:33', NULL, NULL, 14369, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1509954235', 'admin', '2017-11-06 13:08:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52772, '2017-11-06 13:09:36', NULL, NULL, 14369, 0, 302, '238', 'Ice on the cake', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 13:09:36', 'admin-1509929750-15099449762178363', 1, 0, '', NULL, NULL, NULL),
(52773, '2017-11-06 13:09:50', NULL, NULL, 14369, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 13:09:50', 'admin-1509929750-15099449904619854', 1, 1, 'SR', NULL, NULL, NULL),
(52774, '2017-11-06 13:09:50', NULL, NULL, 14369, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 13:09:50', 'admin-1509929750-15099449904619854', 1, 1, 'SR', NULL, NULL, NULL),
(52775, '2017-11-06 13:09:50', NULL, NULL, 14369, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 13:09:50', 'admin-1509929750-15099449904619854', 1, 0, '', NULL, NULL, NULL),
(52776, '2017-11-06 13:25:08', NULL, NULL, 14373, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 10.80, 1, '27', 1, '1509954235', 'admin', '2017-11-06 13:25:08', 'admin-1509929750-15099459086613560', 1, 1, 'SR', 1, '10.0', NULL),
(52777, '2017-11-06 13:22:01', NULL, NULL, 14371, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 10.80, 1, '27', 1, '1509954235', 'admin', '2017-11-06 13:22:01', 'admin-1509929750-15099457217702632', 1, 1, 'SR', 1, '10.0', NULL),
(52778, '2017-11-06 11:40:44', NULL, NULL, 14364, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1509954235', 'admin', '2017-11-06 11:40:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52779, '2017-11-06 11:40:48', NULL, NULL, 14364, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 11:40:48', 'admin-1509929750-15099396481306672', 1, 1, 'SR', NULL, NULL, NULL),
(52780, '2017-11-06 14:20:48', NULL, NULL, 14379, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 14:20:48', 'admin-1509929750-15099492485722159', 1, 1, 'SR', 1, NULL, NULL),
(52781, '2017-11-06 12:45:44', NULL, NULL, 14368, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 12:45:44', 'admin-1509929750-1509943544313658', 1, 1, 'SR', NULL, NULL, NULL),
(52782, '2017-11-06 14:00:33', NULL, NULL, 14378, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1509954235', 'admin', '2017-11-06 14:00:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52783, '2017-11-06 12:41:30', NULL, NULL, 14368, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1509954235', 'admin', '2017-11-06 12:41:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52784, '2017-11-06 12:45:33', NULL, NULL, 14368, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 12:45:33', 'admin-1509929750-15099435335178563', 1, 1, 'SR', NULL, NULL, NULL),
(52785, '2017-11-06 12:45:44', NULL, NULL, 14368, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 12:45:44', 'admin-1509929750-1509943544313658', 1, 1, 'SR', NULL, NULL, NULL),
(52786, '2017-11-06 14:00:44', NULL, NULL, 14378, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 14:00:44', 'admin-1509929750-15099480441793012', 1, 1, 'SR', NULL, NULL, NULL),
(52787, '2017-11-06 11:50:49', NULL, NULL, 14367, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 11:50:49', 'admin-1509929750-15099402490468353', 1, 0, '', NULL, NULL, NULL),
(52788, '2017-11-06 11:50:55', NULL, NULL, 14367, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 11:50:55', 'admin-1509929750-15099402549526419', 1, 1, 'SR', NULL, NULL, NULL),
(52789, '2017-11-06 09:59:48', NULL, NULL, 14351, 0, 153, '87', 'Wake Me Up!', 'Takeaway', 'Meals', 'Morning Bites ', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 09:59:48', 'admin-1509929750-15099335880334384', 1, 0, '', 1, NULL, NULL),
(52790, '2017-11-06 13:52:07', NULL, NULL, 14377, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 13:52:07', 'admin-1509929750-15099475277441872', 1, 1, 'SR', NULL, NULL, NULL),
(52791, '2017-11-06 13:29:34', NULL, NULL, 14374, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 13:29:34', 'admin-1509929750-15099461741611348', 1, 0, '', NULL, NULL, NULL),
(52792, '2017-11-06 14:00:44', NULL, NULL, 14378, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 14:00:44', 'admin-1509929750-15099480441793012', 1, 1, 'SR', NULL, NULL, NULL),
(52793, '2017-11-06 13:52:01', NULL, NULL, 14377, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1509954235', 'admin', '2017-11-06 13:52:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52794, '2017-11-06 12:45:33', NULL, NULL, 14368, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 12:45:33', 'admin-1509929750-15099435335178563', 1, 0, '', NULL, NULL, NULL),
(52795, '2017-11-06 11:50:49', NULL, NULL, 14367, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 11:50:49', 'admin-1509929750-15099402490468353', 1, 0, '', NULL, NULL, NULL),
(52796, '2017-11-06 11:50:19', NULL, NULL, 14366, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1509954235', 'admin', '2017-11-06 11:50:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52797, '2017-11-06 11:50:22', NULL, NULL, 14366, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 11:50:22', 'admin-1509929750-15099402224586974', 1, 1, 'SR', NULL, NULL, NULL),
(52798, '2017-11-06 12:45:33', NULL, NULL, 14368, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 12:45:33', 'admin-1509929750-15099435335178563', 1, 0, '', NULL, NULL, NULL),
(52799, '2017-11-06 11:50:29', NULL, NULL, 14367, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1509954235', 'admin', '2017-11-06 11:50:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52800, '2017-11-06 11:50:49', NULL, NULL, 14367, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 11:50:49', 'admin-1509929750-15099402490468353', 1, 0, '', NULL, NULL, NULL),
(52801, '2017-11-06 13:48:32', NULL, NULL, 14376, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 13:48:32', 'admin-1509929750-15099473125764556', 1, 0, '', NULL, NULL, NULL),
(52802, '2017-11-06 09:20:23', NULL, NULL, 14348, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 09:20:23', 'admin-1509929750-15099312236047978', 1, 0, '', NULL, NULL, NULL),
(52803, '2017-11-06 09:20:23', NULL, NULL, 14348, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 09:20:23', 'admin-1509929750-15099312236047978', 1, 0, '', NULL, NULL, NULL),
(52804, '2017-11-06 13:52:07', NULL, NULL, 14377, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 13:52:07', 'admin-1509929750-15099475277441872', 1, 1, 'SR', NULL, NULL, NULL),
(52805, '2017-11-06 15:20:56', NULL, NULL, 14383, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 15:20:56', 'admin-1509929750-15099528562079077', 1, 1, 'SR', NULL, NULL, NULL),
(52806, '2017-11-06 15:20:52', NULL, NULL, 14383, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1509954235', 'admin', '2017-11-06 15:20:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52807, '2017-11-06 14:43:49', NULL, NULL, 14382, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1509954235', 'admin', '2017-11-06 14:43:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52808, '2017-11-06 14:43:55', NULL, NULL, 14382, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 14:43:55', 'admin-1509929750-15099506353786870', 1, 1, 'SR', NULL, NULL, NULL),
(52809, '2017-11-06 14:29:27', NULL, NULL, 14380, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 14:29:27', 'admin-1509929750-15099497675701547', 1, 1, 'SR', NULL, NULL, '0.0'),
(52810, '2017-11-06 14:29:24', NULL, NULL, 14380, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1509954235', 'admin', '2017-11-06 14:29:24', '0', 1, 1, 'SR', NULL, NULL, '0.0'),
(52811, '2017-11-06 13:44:11', NULL, NULL, 14375, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 13:44:11', 'admin-1509929750-15099470517809119', 1, 0, '', NULL, NULL, NULL),
(52812, '2017-11-06 13:48:32', NULL, NULL, 14376, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 13:48:32', 'admin-1509929750-15099473125764556', 1, 1, 'SR', NULL, NULL, NULL),
(52813, '2017-11-06 10:50:02', NULL, NULL, 14352, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 10:50:02', 'admin-1509929750-15099366027806777', 1, 0, '', NULL, NULL, '10.0'),
(52814, '2017-11-06 10:50:02', NULL, NULL, 14352, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 10:50:02', 'admin-1509929750-15099366027806777', 1, 0, '', NULL, NULL, '10.0'),
(52815, '2017-11-06 10:50:02', NULL, NULL, 14352, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 10:50:02', 'admin-1509929750-15099366027806777', 1, 1, 'SR', NULL, NULL, '10.0'),
(52816, '2017-11-06 10:49:53', NULL, NULL, 14352, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1509954235', 'admin', '2017-11-06 10:49:53', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(52817, '2017-11-06 09:54:12', NULL, NULL, 14349, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 09:54:12', 'admin-1509929750-1509933251945591', 1, 0, '', NULL, NULL, NULL),
(52818, '2017-11-06 09:53:23', NULL, NULL, 14349, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1509954235', 'admin', '2017-11-06 09:53:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52819, '2017-11-06 09:54:12', NULL, NULL, 14349, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 09:54:12', 'admin-1509929750-1509933251945591', 1, 0, '', NULL, NULL, NULL),
(52820, '2017-11-06 09:20:23', NULL, NULL, 14348, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 09:20:23', 'admin-1509929750-15099312236047978', 1, 1, 'SR', NULL, NULL, NULL),
(52821, '2017-11-06 09:20:23', NULL, NULL, 14348, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1509954235', 'admin', '2017-11-06 09:20:23', 'admin-1509929750-15099312236047978', 1, 1, 'SR', NULL, NULL, NULL),
(52822, '2017-11-06 09:15:34', NULL, NULL, 14348, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1509954235', 'admin', '2017-11-06 09:15:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52823, '2017-11-08 14:51:27', NULL, NULL, 14400, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1510103209', 'admin', '2017-11-08 14:51:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52824, '2017-11-08 14:51:33', NULL, NULL, 14400, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 14:51:33', 'admin-1510103209-15101238928419532', 1, 1, 'SR', NULL, NULL, NULL),
(52825, '2017-11-08 14:54:45', NULL, NULL, 14401, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1510103209', 'admin', '2017-11-08 14:54:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52826, '2017-11-08 14:54:48', NULL, NULL, 14401, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 14:54:48', 'admin-1510103209-15101240881743246', 1, 1, 'SR', NULL, NULL, NULL),
(52827, '2017-11-08 14:54:48', NULL, NULL, 14401, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 14:54:48', 'admin-1510103209-15101240881743246', 1, 0, '', NULL, NULL, NULL),
(52828, '2017-11-08 14:13:26', NULL, NULL, 14399, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 14:13:26', 'admin-1510103209-15101216066211761', 1, 1, 'SR', NULL, NULL, NULL),
(52829, '2017-11-08 10:38:39', NULL, NULL, 14390, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 10:38:39', 'admin-1510103209-15101087196111745', 1, 0, '', NULL, NULL, NULL),
(52830, '2017-11-08 14:13:26', NULL, NULL, 14399, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 14:13:26', 'admin-1510103209-15101216066211761', 1, 1, 'SR', NULL, NULL, NULL),
(52831, '2017-11-08 14:13:26', NULL, NULL, 14399, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 14:13:26', 'admin-1510103209-15101216066211761', 1, 0, '', NULL, NULL, NULL),
(52832, '2017-11-08 12:07:05', NULL, NULL, 14394, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1510103209', 'admin', '2017-11-08 12:07:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52833, '2017-11-08 12:10:21', NULL, NULL, 14394, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 12:10:21', 'admin-1510103209-15101142212022332', 1, 1, 'SR', NULL, NULL, NULL),
(52834, '2017-11-08 12:10:21', NULL, NULL, 14394, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 12:10:21', 'admin-1510103209-15101142212022332', 1, 0, '', NULL, NULL, NULL),
(52835, '2017-11-08 12:10:21', NULL, NULL, 14394, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 12:10:21', 'admin-1510103209-15101142212022332', 1, 1, 'SR', NULL, NULL, NULL),
(52836, '2017-11-08 12:23:42', NULL, NULL, 14395, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1510103209', 'admin', '2017-11-08 12:23:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52837, '2017-11-08 12:24:01', NULL, NULL, 14395, 0, 77, '77', 'Sarawak Kolomee', 'no chili', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 12:24:01', 'admin-1510103209-15101150416603089', 1, 1, 'SR', NULL, NULL, NULL),
(52838, '2017-11-08 12:24:01', NULL, NULL, 14395, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 12:24:01', 'admin-1510103209-15101150416603089', 1, 0, '', NULL, NULL, NULL),
(52839, '2017-11-08 12:55:47', NULL, NULL, 14396, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 12:55:47', 'admin-1510103209-15101169471448598', 1, 0, '', NULL, NULL, NULL),
(52840, '2017-11-08 12:55:47', NULL, NULL, 14396, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 12:55:47', 'admin-1510103209-15101169471448598', 1, 0, '', NULL, NULL, NULL),
(52841, '2017-11-08 12:55:47', NULL, NULL, 14396, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 12:55:47', 'admin-1510103209-15101169471448598', 1, 1, 'SR', NULL, NULL, NULL),
(52842, '2017-11-08 13:29:23', NULL, NULL, 14397, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1510103209', 'admin', '2017-11-08 13:29:23', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(52843, '2017-11-08 13:29:31', NULL, NULL, 14397, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 3, 8.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 13:29:31', 'admin-1510103209-15101189714962128', 1, 0, '', NULL, NULL, '10.0'),
(52844, '2017-11-08 13:33:42', NULL, NULL, 14398, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1510103209', 'admin', '2017-11-08 13:33:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52845, '2017-11-08 13:58:39', NULL, NULL, 14398, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 13:58:39', 'admin-1510103209-15101207188084257', 1, 1, 'SR', NULL, NULL, NULL),
(52846, '2017-11-08 13:33:50', NULL, NULL, 14398, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 13:33:50', 'admin-1510103209-15101192298604524', 1, 1, 'SR', NULL, NULL, NULL),
(52847, '2017-11-08 14:58:01', NULL, NULL, 14401, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 14:58:01', 'admin-1510103209-15101242814834329', 1, 0, '', NULL, NULL, NULL),
(52848, '2017-11-08 14:12:50', NULL, NULL, 14399, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1510103209', 'admin', '2017-11-08 14:12:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52849, '2017-11-08 12:48:59', NULL, NULL, 14394, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 12:48:59', 'admin-1510103209-15101165388025719', 1, 0, '', NULL, NULL, NULL),
(52850, '2017-11-08 13:35:20', NULL, NULL, 14397, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 13:35:20', 'admin-1510103209-15101193205142228', 1, 0, '', NULL, NULL, '10.0'),
(52851, '2017-11-08 12:24:21', NULL, NULL, 14395, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 12:24:21', 'admin-1510103209-15101150609792470', 1, 1, 'SR', NULL, NULL, NULL),
(52852, '2017-11-08 12:48:59', NULL, NULL, 14394, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 12:48:59', 'admin-1510103209-15101165388025719', 1, 1, 'SR', NULL, NULL, NULL),
(52853, '2017-11-08 12:48:59', NULL, NULL, 14394, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 12:48:59', 'admin-1510103209-15101165388025719', 1, 0, '', NULL, NULL, NULL),
(52854, '2017-11-08 14:58:01', NULL, NULL, 14401, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 14:58:01', 'admin-1510103209-15101242814834329', 1, 0, '', NULL, NULL, NULL),
(52855, '2017-11-08 13:35:20', NULL, NULL, 14397, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 13:35:20', 'admin-1510103209-15101193205142228', 1, 1, 'SR', NULL, NULL, '10.0'),
(52856, '2017-11-08 12:24:21', NULL, NULL, 14395, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 12:24:21', 'admin-1510103209-15101150609792470', 1, 1, 'SR', NULL, NULL, NULL),
(52857, '2017-11-08 13:32:22', NULL, NULL, 14397, 0, 181, '116', 'Open Food ', 'shimeji mushroom no chicken', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 13:32:22', 'admin-1510103209-15101191419001277', 1, 0, '', NULL, NULL, '10.0'),
(52858, '2017-11-08 12:55:11', NULL, NULL, 14396, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1510103209', 'admin', '2017-11-08 12:55:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52859, '2017-11-08 12:55:47', NULL, NULL, 14396, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 12:55:47', 'admin-1510103209-15101169471448598', 1, 0, '', NULL, NULL, NULL),
(52860, '2017-11-08 12:55:47', NULL, NULL, 14396, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 12:55:47', 'admin-1510103209-15101169471448598', 1, 0, '', NULL, NULL, NULL),
(52861, '2017-11-08 11:04:38', NULL, NULL, 14391, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1510103209', 'admin', '2017-11-08 11:04:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52862, '2017-11-08 11:12:49', NULL, NULL, 14392, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 11:12:49', 'admin-1510103209-15101107695555337', 1, 0, '', NULL, NULL, NULL),
(52863, '2017-11-08 11:12:49', NULL, NULL, 14392, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 11:12:49', 'admin-1510103209-15101107695555337', 1, 1, 'SR', NULL, NULL, NULL),
(52864, '2017-11-08 11:12:49', NULL, NULL, 14392, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 11:12:49', 'admin-1510103209-15101107695555337', 1, 0, '', NULL, NULL, NULL),
(52865, '2017-11-08 11:20:54', NULL, NULL, 14393, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1510103209', 'admin', '2017-11-08 11:20:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52866, '2017-11-08 12:24:21', NULL, NULL, 14395, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 12:24:21', 'admin-1510103209-15101150609792470', 1, 1, 'SR', NULL, NULL, NULL),
(52867, '2017-11-08 11:21:20', NULL, NULL, 14393, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 11:21:20', 'admin-1510103209-15101112798687987', 1, 1, 'SR', NULL, NULL, NULL),
(52868, '2017-11-08 11:21:20', NULL, NULL, 14393, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 11:21:20', 'admin-1510103209-15101112798687987', 1, 1, 'SR', NULL, NULL, NULL),
(52869, '2017-11-08 11:21:20', NULL, NULL, 14393, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 11:21:20', 'admin-1510103209-15101112798687987', 1, 0, '', NULL, NULL, NULL),
(52870, '2017-11-08 11:11:18', NULL, NULL, 14392, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1510103209', 'admin', '2017-11-08 11:11:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52871, '2017-11-08 11:04:48', NULL, NULL, 14391, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 11:04:48', 'admin-1510103209-15101102885877649', 1, 0, '', NULL, NULL, NULL),
(52872, '2017-11-08 11:04:48', NULL, NULL, 14391, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 11:04:48', 'admin-1510103209-15101102885877649', 1, 0, '', NULL, NULL, NULL),
(52873, '2017-11-08 10:38:39', NULL, NULL, 14390, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 10:38:39', 'admin-1510103209-15101087196111745', 1, 0, '', NULL, NULL, NULL),
(52874, '2017-11-08 10:38:55', NULL, NULL, 14390, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 10:38:55', 'admin-1510103209-15101087357258516', 1, 1, 'SR', NULL, NULL, NULL),
(52875, '2017-11-08 10:09:40', NULL, NULL, 14389, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 10:09:40', 'admin-1510103209-15101069802084319', 1, 0, '', NULL, NULL, NULL),
(52876, '2017-11-08 10:38:39', NULL, NULL, 14390, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 10:38:39', 'admin-1510103209-15101087196111745', 1, 0, '', NULL, NULL, NULL),
(52877, '2017-11-08 10:38:39', NULL, NULL, 14390, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 10:38:39', 'admin-1510103209-15101087196111745', 1, 0, '', NULL, NULL, NULL),
(52878, '2017-11-08 10:38:16', NULL, NULL, 14390, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1510103209', 'admin', '2017-11-08 10:38:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52879, '2017-11-08 09:45:11', NULL, NULL, 14388, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 09:45:11', 'admin-1510103209-15101055115263655', 1, 1, 'SR', NULL, NULL, NULL),
(52880, '2017-11-08 14:13:26', NULL, NULL, 14399, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 14:13:26', 'admin-1510103209-15101216066211761', 1, 1, 'SR', NULL, NULL, NULL),
(52881, '2017-11-08 10:38:39', NULL, NULL, 14390, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 10:38:39', 'admin-1510103209-15101087196111745', 1, 0, '', NULL, NULL, NULL),
(52882, '2017-11-08 10:09:40', NULL, NULL, 14389, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 10:09:40', 'admin-1510103209-15101069802084319', 1, 1, 'SR', NULL, NULL, NULL),
(52883, '2017-11-08 10:09:34', NULL, NULL, 14389, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1510103209', 'admin', '2017-11-08 10:09:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52884, '2017-11-08 09:45:11', NULL, NULL, 14388, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 09:45:11', 'admin-1510103209-15101055115263655', 1, 1, 'SR', NULL, NULL, NULL),
(52885, '2017-11-08 09:10:17', NULL, NULL, 14387, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 09:10:17', 'admin-1510103209-15101034176317970', 1, 0, '', NULL, NULL, NULL),
(52886, '2017-11-08 09:10:17', NULL, NULL, 14387, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 09:10:17', 'admin-1510103209-15101034176317970', 1, 1, 'SR', NULL, NULL, NULL),
(52887, '2017-11-08 09:43:01', NULL, NULL, 14388, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1510103209', 'admin', '2017-11-08 09:43:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52888, '2017-11-08 09:10:07', NULL, NULL, 14387, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1510103209', 'admin', '2017-11-08 09:10:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52889, '2017-11-08 09:09:21', NULL, NULL, 14386, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 09:09:21', 'admin-1510103209-15101033614889411', 1, 0, '', NULL, NULL, NULL),
(52890, '2017-11-08 09:09:21', NULL, NULL, 14386, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510103209', 'admin', '2017-11-08 09:09:21', 'admin-1510103209-15101033614889411', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(52891, '2017-11-08 09:09:13', NULL, NULL, 14386, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1510103209', 'admin', '2017-11-08 09:09:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52892, '2017-11-09 14:30:52', NULL, NULL, 14417, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 14:30:52', 'admin-1510195264-15102090526858099', 1, 1, 'SR', NULL, NULL, NULL),
(52893, '2017-11-09 14:30:52', NULL, NULL, 14417, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 14:30:52', 'admin-1510195264-15102090526858099', 1, 1, 'SR', NULL, NULL, NULL),
(52894, '2017-11-09 14:30:52', NULL, NULL, 14417, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 14:30:52', 'admin-1510195264-15102090526858099', 1, 1, 'SR', NULL, NULL, NULL),
(52895, '2017-11-09 14:30:44', NULL, NULL, 14417, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1510195264', 'admin', '2017-11-09 14:30:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52896, '2017-11-09 15:05:16', NULL, NULL, 14418, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 15:05:16', 'admin-1510195264-15102111166167364', 1, 0, '', NULL, NULL, NULL),
(52897, '2017-11-09 15:33:50', NULL, NULL, 14421, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1510195264', 'admin', '2017-11-09 15:33:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52898, '2017-11-09 15:33:57', NULL, NULL, 14421, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 15:33:57', 'admin-1510195264-1510212836907399', 1, 1, 'SR', NULL, NULL, NULL),
(52899, '2017-11-09 15:33:57', NULL, NULL, 14421, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 15:33:57', 'admin-1510195264-1510212836907399', 1, 1, 'SR', NULL, NULL, NULL),
(52900, '2017-11-09 12:33:49', NULL, NULL, 14414, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 12:33:49', 'admin-1510195264-1510202029354459', 1, 1, 'SR', NULL, NULL, NULL),
(52901, '2017-11-09 14:05:55', NULL, NULL, 14416, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 14:05:55', 'admin-1510195264-15102075551123457', 1, 1, 'SR', 1, NULL, '10.0'),
(52902, '2017-11-09 09:57:04', NULL, NULL, 14406, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 09:57:04', 'admin-1510189207-15101926238571747', 1, 1, 'SR', NULL, NULL, NULL),
(52903, '2017-11-09 09:57:04', NULL, NULL, 14406, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 09:57:04', 'admin-1510189207-15101926238571747', 1, 0, '', NULL, NULL, NULL),
(52904, '2017-11-09 09:19:26', NULL, NULL, 14403, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 09:19:26', 'admin-1510189207-15101903662981834', 1, 1, 'SR', NULL, NULL, NULL),
(52905, '2017-11-09 13:23:07', NULL, NULL, 14411, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 13:23:07', 'admin-1510195264-15102049875766038', 1, 1, 'SR', NULL, NULL, '10.0'),
(52906, '2017-11-09 13:23:43', NULL, NULL, 14415, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1510195264', 'admin', '2017-11-09 13:23:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52907, '2017-11-09 13:23:53', NULL, NULL, 14415, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 13:23:53', 'admin-1510195264-15102050337217265', 1, 1, 'SR', NULL, NULL, NULL),
(52908, '2017-11-09 09:57:04', NULL, NULL, 14406, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 09:57:04', 'admin-1510189207-15101926238571747', 1, 0, '', NULL, NULL, NULL),
(52909, '2017-11-09 10:06:12', NULL, NULL, 14407, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 10:06:12', 'admin-1510189207-15101931726156327', 1, 1, 'SR', NULL, NULL, NULL),
(52910, '2017-11-09 10:11:27', NULL, NULL, 14402, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 10:11:27', 'admin-1510189207-15101934870206936', 1, 1, 'SR', NULL, NULL, NULL),
(52911, '2017-11-09 10:11:27', NULL, NULL, 14402, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 10:11:27', 'admin-1510189207-15101934870206936', 1, 1, 'SR', NULL, NULL, NULL),
(52912, '2017-11-09 10:11:27', NULL, NULL, 14402, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 10:11:27', 'admin-1510189207-15101934870206936', 1, 0, '', NULL, NULL, NULL),
(52913, '2017-11-09 00:00:00', NULL, NULL, 14408, 0, 181, '116', 'Open Food ', 'junior BLT', 'Meals', 'Perfect Meals', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 09:06:10', 'admin-1510189207-15101895705568176', 1, 0, '', NULL, NULL, NULL),
(52914, '2017-11-09 10:37:40', NULL, NULL, 14409, 0, 181, '116', 'Open Food ', 'bacon,scramble egg', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 10:37:40', 'admin-1510189207-15101950598709441', 1, 0, '', 1, NULL, '10.0'),
(52915, '2017-11-09 11:02:47', NULL, NULL, 14410, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1510195264', 'admin', '2017-11-09 11:02:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52916, '2017-11-09 11:39:57', NULL, NULL, 14411, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 11:39:57', 'admin-1510195264-15101987973946523', 1, 0, '', NULL, NULL, '10.0'),
(52917, '2017-11-09 11:47:31', NULL, NULL, 14403, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 11:47:31', 'admin-1510195264-15101992516468438', 1, 1, 'SR', NULL, NULL, NULL),
(52918, '2017-11-09 11:48:59', NULL, NULL, 14412, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1510195264', 'admin', '2017-11-09 11:48:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52919, '2017-11-09 11:49:40', NULL, NULL, 14412, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 11:49:40', 'admin-1510195264-15101993799906229', 1, 0, '', NULL, NULL, NULL),
(52920, '2017-11-09 12:27:51', NULL, NULL, 14413, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1510195264', 'admin', '2017-11-09 12:27:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52921, '2017-11-09 12:27:55', NULL, NULL, 14413, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 12:27:55', 'admin-1510195264-15102016755883717', 1, 1, 'SR', NULL, NULL, NULL),
(52922, '2017-11-09 11:49:48', NULL, NULL, 14412, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 11:49:48', 'admin-1510195264-1510199388277213', 1, 1, 'SR', NULL, NULL, NULL),
(52923, '2017-11-09 16:56:44', NULL, NULL, 14423, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1510195264', 'admin', '2017-11-09 16:56:44', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(52924, '2017-11-09 16:56:57', NULL, NULL, 14423, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 16:56:57', 'admin-1510195264-15102178172958545', 1, 1, 'SR', NULL, NULL, '10.0'),
(52925, '2017-11-09 12:28:02', NULL, NULL, 14413, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 12:28:02', 'admin-1510195264-15102016824446384', 1, 1, 'SR', NULL, NULL, NULL),
(52926, '2017-11-09 16:38:09', NULL, NULL, 14422, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 16:38:09', 'admin-1510195264-15102166893638466', 1, 1, 'SR', NULL, NULL, NULL),
(52927, '2017-11-09 16:38:09', NULL, NULL, 14422, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 16:38:09', 'admin-1510195264-15102166893638466', 1, 0, '', NULL, NULL, NULL),
(52928, '2017-11-09 13:37:47', NULL, NULL, 14413, 0, 181, '116', 'Open Food ', 'mushroom rice', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 13:37:47', 'admin-1510195264-15102058668461155', 1, 0, '', NULL, NULL, NULL),
(52929, '2017-11-09 16:37:30', NULL, NULL, 14422, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1510195264', 'admin', '2017-11-09 16:37:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52930, '2017-11-09 16:37:33', NULL, NULL, 14422, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 16:37:33', 'admin-1510195264-15102166530631576', 1, 0, '', NULL, NULL, NULL),
(52931, '2017-11-09 16:18:21', NULL, NULL, 14418, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 16:18:21', 'admin-1510195264-15102155015109847', 1, 0, '', NULL, NULL, NULL),
(52932, '2017-11-09 16:17:08', NULL, NULL, 14418, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 16:17:08', 'admin-1510195264-15102154278399645', 1, 0, '', NULL, NULL, NULL),
(52933, '2017-11-09 16:17:08', NULL, NULL, 14418, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 16:17:08', 'admin-1510195264-15102154278399645', 1, 0, '', NULL, NULL, NULL),
(52934, '2017-11-09 15:38:14', NULL, NULL, 14419, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 15:38:14', 'admin-1510195264-15102130943567668', 1, 0, '', NULL, NULL, NULL),
(52935, '2017-11-09 15:49:07', NULL, NULL, 14418, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 15:49:07', 'admin-1510195264-1510213747517591', 1, 0, '', NULL, NULL, NULL),
(52936, '2017-11-09 15:38:14', NULL, NULL, 14419, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 15:38:14', 'admin-1510195264-15102130943567668', 1, 0, '', NULL, NULL, NULL),
(52937, '2017-11-09 15:05:16', NULL, NULL, 14418, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 15:05:16', 'admin-1510195264-15102111166167364', 1, 0, '', NULL, NULL, NULL),
(52938, '2017-11-09 14:39:34', NULL, NULL, 14419, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 14:39:34', 'admin-1510195264-15102095741731869', 1, 1, 'SR', NULL, NULL, NULL),
(52939, '2017-11-09 12:46:26', NULL, NULL, 14414, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 12:46:26', 'admin-1510195264-15102027857834127', 1, 1, 'SR', NULL, NULL, NULL),
(52940, '2017-11-09 14:31:08', NULL, NULL, 14418, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 14:31:08', 'admin-1510195264-15102090684136062', 1, 0, '', NULL, NULL, NULL),
(52941, '2017-11-09 14:39:34', NULL, NULL, 14419, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 14:39:34', 'admin-1510195264-15102095741731869', 1, 1, 'SR', NULL, NULL, NULL),
(52942, '2017-11-09 14:39:29', NULL, NULL, 14419, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1510195264', 'admin', '2017-11-09 14:39:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52943, '2017-11-09 14:31:08', NULL, NULL, 14418, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 14:31:08', 'admin-1510195264-15102090684136062', 1, 1, 'SR', NULL, NULL, NULL),
(52944, '2017-11-09 14:31:08', NULL, NULL, 14418, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 14:31:08', 'admin-1510195264-15102090684136062', 1, 0, '', NULL, NULL, NULL),
(52945, '2017-11-09 14:31:08', NULL, NULL, 14418, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 14:31:08', 'admin-1510195264-15102090684136062', 1, 1, 'SR', NULL, NULL, NULL),
(52946, '2017-11-09 14:30:56', NULL, NULL, 14418, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 18.70, 0.0000, 0.0000, 18.70, 1, '27', 1, '1510195264', 'admin', '2017-11-09 14:30:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52947, '2017-11-09 12:51:42', NULL, NULL, 14414, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 12:51:42', 'admin-1510195264-15102031019081277', 1, 1, 'SR', NULL, NULL, NULL),
(52948, '2017-11-09 12:59:10', NULL, NULL, 14403, 0, 215, '149', 'Thai Fish Sauce Garlic Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 12:59:10', 'admin-1510195264-15102035503054969', 1, 0, '', NULL, NULL, NULL),
(52949, '2017-11-09 11:38:47', NULL, NULL, 14411, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1510195264', 'admin', '2017-11-09 11:38:47', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(52950, '2017-11-09 11:39:57', NULL, NULL, 14411, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 11:39:57', 'admin-1510195264-15101987973946523', 1, 1, 'SR', NULL, NULL, '10.0'),
(52951, '2017-11-09 12:51:42', NULL, NULL, 14414, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 12:51:42', 'admin-1510195264-15102031019081277', 1, 1, 'SR', NULL, NULL, NULL),
(52952, '2017-11-09 12:33:49', NULL, NULL, 14414, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 12:33:49', 'admin-1510195264-1510202029354459', 1, 0, '', NULL, NULL, NULL),
(52953, '2017-11-09 12:46:26', NULL, NULL, 14414, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 12:46:26', 'admin-1510195264-15102027857834127', 1, 1, 'SR', NULL, NULL, NULL),
(52954, '2017-11-09 12:33:38', NULL, NULL, 14414, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.70, 0.0000, 0.0000, 9.70, 1, '27', 1, '1510195264', 'admin', '2017-11-09 12:33:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52955, '2017-11-09 13:19:49', NULL, NULL, 14414, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 13:19:49', 'admin-1510195264-15102047896449735', 1, 1, 'SR', NULL, NULL, NULL),
(52956, '2017-11-09 12:28:02', NULL, NULL, 14413, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 12:28:02', 'admin-1510195264-15102016824446384', 1, 1, 'SR', NULL, NULL, NULL),
(52957, '2017-11-09 12:06:21', NULL, NULL, 14412, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 12:06:21', 'admin-1510195264-15102003812441222', 1, 0, '', NULL, NULL, NULL),
(52958, '2017-11-09 09:43:10', NULL, NULL, 14405, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1510195264', 'admin', '2017-11-09 09:43:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52959, '2017-11-09 11:03:10', NULL, NULL, 14410, 0, 153, '87', 'Wake Me Up!', 'Change to sunny side up', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 11:03:10', 'admin-1510195264-1510196590760656', 1, 0, '', NULL, NULL, NULL),
(52960, '2017-11-09 11:03:10', NULL, NULL, 14410, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 11:03:10', 'admin-1510195264-1510196590760656', 1, 0, '', NULL, NULL, NULL),
(52961, '2017-11-09 11:03:10', NULL, NULL, 14410, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 11:03:10', 'admin-1510195264-1510196590760656', 1, 1, 'SR', NULL, NULL, NULL),
(52962, '2017-11-09 11:39:57', NULL, NULL, 14411, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 11:39:57', 'admin-1510195264-15101987973946523', 1, 0, '', NULL, NULL, '10.0'),
(52963, '2017-11-09 11:39:57', NULL, NULL, 14411, 0, 181, '116', 'Open Food ', 'double fry pork', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 11:39:57', 'admin-1510195264-15101987973946523', 1, 0, '', NULL, NULL, '10.0'),
(52964, '2017-11-09 11:18:52', NULL, NULL, 14410, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 11:18:52', 'admin-1510195264-1510197532062675', 1, 1, 'SR', NULL, NULL, NULL),
(52965, '2017-11-09 11:18:52', NULL, NULL, 14410, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 11:18:52', 'admin-1510195264-1510197532062675', 1, 0, '', NULL, NULL, NULL),
(52966, '2017-11-09 11:03:11', NULL, NULL, 14410, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 11:03:11', 'admin-1510195264-1510196590760656', 1, 1, 'SR', NULL, NULL, NULL),
(52967, '2017-11-09 10:06:12', NULL, NULL, 14407, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 10:06:12', 'admin-1510189207-15101931726156327', 1, 0, '', NULL, NULL, NULL),
(52968, '2017-11-09 10:06:12', NULL, NULL, 14407, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 10:06:12', 'admin-1510189207-15101931726156327', 1, 1, 'SR', NULL, NULL, NULL),
(52969, '2017-11-09 10:05:56', NULL, NULL, 14407, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1510195264', 'admin', '2017-11-09 10:05:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52970, '2017-11-09 10:06:12', NULL, NULL, 14407, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 10:06:12', 'admin-1510189207-15101931726156327', 1, 0, '', NULL, NULL, NULL),
(52971, '2017-11-09 09:53:19', NULL, NULL, 14406, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1510195264', 'admin', '2017-11-09 09:53:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52972, '2017-11-09 09:44:06', NULL, NULL, 14405, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 09:44:06', 'admin-1510189207-15101918466557868', 1, 0, '', NULL, NULL, NULL),
(52973, '2017-11-09 09:57:04', NULL, NULL, 14406, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 09:57:04', 'admin-1510189207-15101926238571747', 1, 1, 'SR', NULL, NULL, NULL),
(52974, '2017-11-09 09:44:06', NULL, NULL, 14405, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 09:44:06', 'admin-1510189207-15101918466557868', 1, 1, 'SR', NULL, NULL, NULL),
(52975, '2017-11-09 09:44:29', NULL, NULL, 14405, 0, 182, '117', 'Open Drinks ', 'milk', 'Cold Drinks', 'Fresh Juice', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 09:44:29', 'admin-1510189207-15101918692943989', 1, 0, '', NULL, NULL, NULL),
(52976, '2017-11-09 09:57:04', NULL, NULL, 14406, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 09:57:04', 'admin-1510189207-15101926238571747', 1, 0, '', NULL, NULL, NULL),
(52977, '2017-11-09 09:57:04', NULL, NULL, 14406, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 09:57:04', 'admin-1510189207-15101926238571747', 1, 0, '', NULL, NULL, NULL),
(52978, '2017-11-09 09:44:06', NULL, NULL, 14405, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 09:44:06', 'admin-1510189207-15101918466557868', 1, 0, '', NULL, NULL, NULL),
(52979, '2017-11-09 09:24:54', NULL, NULL, 14404, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 09:24:55', 'admin-1510189207-15101906948193876', 1, 1, 'SR', NULL, NULL, NULL),
(52980, '2017-11-09 09:19:26', NULL, NULL, 14403, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 09:19:26', 'admin-1510189207-15101903662981834', 1, 1, 'SR', NULL, NULL, NULL),
(52981, '2017-11-09 09:24:48', NULL, NULL, 14404, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1510195264', 'admin', '2017-11-09 09:24:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52982, '2017-11-09 09:24:55', NULL, NULL, 14404, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 09:24:55', 'admin-1510189207-15101906948193876', 1, 0, '', NULL, NULL, NULL),
(52983, '2017-11-09 00:00:00', NULL, NULL, 14408, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1510195264', 'admin', '2017-11-09 09:06:10', 'admin-1510189207-15101895705568176', 1, 1, 'SR', NULL, NULL, NULL),
(52984, '2017-11-09 10:16:50', NULL, NULL, 14408, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1510195264', 'admin', '2017-11-09 10:16:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52985, '2017-11-09 09:17:20', NULL, NULL, 14403, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1510195264', 'admin', '2017-11-09 09:17:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52986, '2017-11-09 09:05:53', NULL, NULL, 14402, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1510195264', 'admin', '2017-11-09 09:05:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52987, '2017-11-10 14:01:12', NULL, NULL, 14442, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1510276265', 'admin', '2017-11-10 14:01:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(52988, '2017-11-10 14:15:53', NULL, NULL, 14443, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 14:15:53', 'admin-1510276265-15102945530711843', 1, 0, '', NULL, NULL, NULL),
(52989, '2017-11-10 14:15:53', NULL, NULL, 14443, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 14:15:53', 'admin-1510276265-15102945530711843', 1, 1, 'SR', NULL, NULL, NULL),
(52990, '2017-11-10 14:20:27', NULL, NULL, 14443, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 14:20:27', 'admin-1510276265-15102948274312623', 1, 0, '', NULL, NULL, NULL),
(52991, '2017-11-10 14:20:27', NULL, NULL, 14443, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 14:20:27', 'admin-1510276265-15102948274312623', 1, 0, '', NULL, NULL, NULL),
(52992, '2017-11-10 14:20:27', NULL, NULL, 14443, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 14:20:27', 'admin-1510276265-15102948274312623', 1, 0, '', NULL, NULL, NULL),
(52993, '2017-11-10 14:21:00', NULL, NULL, 14443, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 14:21:00', 'admin-1510276265-15102948599011969', 1, 1, 'SR', NULL, NULL, NULL),
(52994, '2017-11-10 14:21:00', NULL, NULL, 14443, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 14:21:00', 'admin-1510276265-15102948599011969', 1, 1, 'SR', NULL, NULL, NULL),
(52995, '2017-11-10 13:39:53', NULL, NULL, 14439, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 13:39:53', 'admin-1510276265-1510292393207489', 1, 1, 'SR', NULL, NULL, NULL),
(52996, '2017-11-10 10:45:02', NULL, NULL, 14429, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:45:02', 'admin-1510276265-15102819021037751', 1, 1, 'SR', NULL, NULL, NULL),
(52997, '2017-11-10 10:57:43', NULL, NULL, 14430, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:57:43', 'admin-1510276265-15102826628485946', 1, 1, 'SR', NULL, NULL, NULL),
(52998, '2017-11-10 11:02:36', NULL, NULL, 14430, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 11:02:36', 'admin-1510276265-15102829560208333', 1, 0, '', NULL, NULL, NULL),
(52999, '2017-11-10 11:02:36', NULL, NULL, 14430, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 11:02:36', 'admin-1510276265-15102829560208333', 1, 0, '', NULL, NULL, NULL),
(53000, '2017-11-10 11:39:41', NULL, NULL, 14431, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.55, 0.0000, 0.0000, 3.55, 1, '27', 1, '1510276265', 'admin', '2017-11-10 11:39:41', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(53001, '2017-11-10 11:40:07', NULL, NULL, 14431, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 11:40:07', 'admin-1510276265-15102852077501686', 1, 1, 'SR', NULL, NULL, '10.0'),
(53002, '2017-11-10 10:45:02', NULL, NULL, 14429, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:45:02', 'admin-1510276265-15102819021037751', 1, 0, '', NULL, NULL, NULL),
(53003, '2017-11-10 10:45:02', NULL, NULL, 14429, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:45:02', 'admin-1510276265-15102819021037751', 1, 1, 'SR', NULL, NULL, NULL),
(53004, '2017-11-10 12:16:16', NULL, NULL, 14433, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1510276265', 'admin', '2017-11-10 12:16:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53005, '2017-11-10 12:16:19', NULL, NULL, 14433, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 12:16:19', 'admin-1510276265-1510287379564821', 1, 1, 'SR', NULL, NULL, NULL),
(53006, '2017-11-10 12:29:46', NULL, NULL, 14434, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 12:29:46', 'admin-1510276265-15102881862066239', 1, 1, 'SR', NULL, NULL, NULL),
(53007, '2017-11-10 12:30:10', NULL, NULL, 14431, 0, 298, '234', 'Salted Caramel Machiato', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 12:30:10', 'admin-1510276265-15102882103513135', 1, 0, '', NULL, NULL, '10.0'),
(53008, '2017-11-10 12:50:42', NULL, NULL, 14436, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 12:50:42', 'admin-1510276265-1510289442369823', 1, 1, 'SR', NULL, NULL, NULL),
(53009, '2017-11-10 16:46:39', NULL, NULL, 14445, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 16:46:39', 'admin-1510276265-15103035997144662', 1, 1, 'SR', NULL, NULL, NULL),
(53010, '2017-11-10 16:46:39', NULL, NULL, 14445, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 16:46:39', 'admin-1510276265-15103035997144662', 1, 1, 'SR', NULL, NULL, NULL),
(53011, '2017-11-10 14:07:58', NULL, NULL, 14442, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 14:07:58', 'admin-1510276265-15102940783044955', 1, 1, 'SR', NULL, NULL, NULL),
(53012, '2017-11-10 14:07:58', NULL, NULL, 14442, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 14:07:58', 'admin-1510276265-15102940783044955', 1, 1, 'SR', NULL, NULL, NULL),
(53013, '2017-11-10 15:08:01', NULL, NULL, 14439, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 15:08:01', 'admin-1510276265-1510297681032362', 1, 0, '', NULL, NULL, NULL),
(53014, '2017-11-10 15:08:01', NULL, NULL, 14439, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 15:08:01', 'admin-1510276265-1510297681032362', 1, 0, '', NULL, NULL, NULL),
(53015, '2017-11-10 15:45:00', NULL, NULL, 14444, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 15:45:00', 'admin-1510276265-1510299900272644', 1, 0, '', 1, NULL, NULL),
(53016, '2017-11-10 14:55:39', NULL, NULL, 14439, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 14:55:39', 'admin-1510276265-15102969397537941', 1, 1, 'SR', NULL, NULL, NULL),
(53017, '2017-11-10 14:21:00', NULL, NULL, 14443, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 14:21:00', 'admin-1510276265-15102948599011969', 1, 1, 'SR', NULL, NULL, NULL),
(53018, '2017-11-10 14:15:30', NULL, NULL, 14443, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.90, 0.0000, 0.0000, 13.90, 1, '27', 1, '1510276265', 'admin', '2017-11-10 14:15:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53019, '2017-11-10 14:15:53', NULL, NULL, 14443, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 14:15:53', 'admin-1510276265-15102945530711843', 1, 0, '', NULL, NULL, NULL),
(53020, '2017-11-10 14:15:53', NULL, NULL, 14443, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 14:15:53', 'admin-1510276265-15102945530711843', 1, 1, 'SR', NULL, NULL, NULL),
(53021, '2017-11-10 12:50:01', NULL, NULL, 14436, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1510276265', 'admin', '2017-11-10 12:50:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53022, '2017-11-10 12:50:42', NULL, NULL, 14436, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 12:50:42', 'admin-1510276265-1510289442369823', 1, 0, '', NULL, NULL, NULL),
(53023, '2017-11-10 14:07:58', NULL, NULL, 14442, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 14:07:58', 'admin-1510276265-15102940783044955', 1, 1, 'SR', NULL, NULL, NULL),
(53024, '2017-11-10 09:45:03', NULL, NULL, 14424, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 09:45:03', 'admin-1510276265-15102783030656897', 1, 0, '', NULL, NULL, NULL),
(53025, '2017-11-10 10:28:24', NULL, NULL, 14427, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:28:24', 'admin-1510276265-15102809039319798', 1, 1, 'SR', NULL, NULL, NULL),
(53026, '2017-11-10 10:35:40', NULL, NULL, 14427, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:35:40', 'admin-1510276265-15102813398157641', 1, 1, 'SR', NULL, NULL, NULL),
(53027, '2017-11-10 10:35:48', NULL, NULL, 14428, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:35:48', 'admin-1510276265-15102813479411212', 1, 1, 'SR', 1, NULL, '1.0'),
(53028, '2017-11-10 14:07:58', NULL, NULL, 14442, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 14:07:58', 'admin-1510276265-15102940783044955', 1, 0, '', NULL, NULL, NULL),
(53029, '2017-11-10 14:07:58', NULL, NULL, 14442, 0, 181, '116', 'Open Food ', 'tomato pasta', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 14:07:58', 'admin-1510276265-15102940783044955', 1, 0, '', NULL, NULL, NULL),
(53030, '2017-11-10 16:46:35', NULL, NULL, 14445, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1510276265', 'admin', '2017-11-10 16:46:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53031, '2017-11-10 09:48:26', NULL, NULL, 14425, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 09:48:26', 'admin-1510276265-15102785067224927', 1, 0, '', NULL, NULL, NULL),
(53032, '2017-11-10 10:09:31', NULL, NULL, 14426, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:09:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53033, '2017-11-10 13:49:28', NULL, NULL, 14440, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 13:49:28', 'admin-1510276265-1510292968169925', 1, 0, '', 1, NULL, NULL),
(53034, '2017-11-10 13:54:11', NULL, NULL, 14441, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 13:54:11', 'admin-1510276265-15102932514384797', 1, 1, 'SR', 1, NULL, '10.0'),
(53035, '2017-11-10 14:10:15', NULL, NULL, 14438, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 14:10:15', 'admin-1510276265-15102942152919326', 1, 1, 'SR', NULL, NULL, '10.0'),
(53036, '2017-11-10 13:39:46', NULL, NULL, 14439, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1510276265', 'admin', '2017-11-10 13:39:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53037, '2017-11-10 13:31:36', NULL, NULL, 14438, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1510276265', 'admin', '2017-11-10 13:31:36', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(53038, '2017-11-10 11:58:07', NULL, NULL, 14432, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1510276265', 'admin', '2017-11-10 11:58:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53039, '2017-11-10 11:58:22', NULL, NULL, 14432, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 11:58:22', 'admin-1510276265-15102863023989673', 1, 0, '', NULL, NULL, NULL),
(53040, '2017-11-10 11:58:22', NULL, NULL, 14432, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 11:58:22', 'admin-1510276265-15102863023989673', 1, 1, 'SR', NULL, NULL, NULL),
(53041, '2017-11-10 12:34:32', NULL, NULL, 14435, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 12:34:32', 'admin-1510276265-15102884721924285', 1, 1, 'SR', NULL, NULL, '10.0'),
(53042, '2017-11-10 12:32:30', NULL, NULL, 14435, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 12:32:30', 'admin-1510276265-15102883503601112', 1, 1, 'SR', NULL, NULL, '10.0'),
(53043, '2017-11-10 10:10:41', NULL, NULL, 14426, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:10:41', 'admin-1510276265-15102798410085257', 1, 1, 'SR', NULL, NULL, NULL),
(53044, '2017-11-10 13:31:54', NULL, NULL, 14438, 0, 181, '116', 'Open Food ', ' no chicken,Shimeji mushroom', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 13:31:54', 'admin-1510276265-15102919146124092', 1, 0, '', NULL, NULL, '10.0'),
(53045, '2017-11-10 12:32:30', NULL, NULL, 14435, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 12:32:30', 'admin-1510276265-15102883503601112', 1, 1, 'SR', NULL, NULL, '10.0'),
(53046, '2017-11-10 11:58:22', NULL, NULL, 14432, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 11:58:22', 'admin-1510276265-15102863023989673', 1, 1, 'SR', NULL, NULL, NULL),
(53047, '2017-11-10 10:57:43', NULL, NULL, 14430, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:57:43', 'admin-1510276265-15102826628485946', 1, 0, '', NULL, NULL, NULL),
(53048, '2017-11-10 12:32:11', NULL, NULL, 14435, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1510276265', 'admin', '2017-11-10 12:32:11', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(53049, '2017-11-10 12:29:29', NULL, NULL, 14434, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1510276265', 'admin', '2017-11-10 12:29:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53050, '2017-11-10 12:29:46', NULL, NULL, 14434, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 12:29:46', 'admin-1510276265-15102881862066239', 1, 1, 'SR', NULL, NULL, NULL),
(53051, '2017-11-10 11:40:07', NULL, NULL, 14431, 0, 272, '206', 'Genius in The Bowl', 'Add fried egg', 'Meals', 'Non-Rice', 1, 9.50, 9.5000, 0.0000, 9.50, 1, '27', 1, '1510276265', 'admin', '2017-11-10 11:40:07', 'admin-1510276265-15102852077501686', 1, 0, '', NULL, NULL, '10.0'),
(53052, '2017-11-10 10:57:43', NULL, NULL, 14430, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:57:43', 'admin-1510276265-15102826628485946', 1, 0, '', NULL, NULL, NULL),
(53053, '2017-11-10 10:57:43', NULL, NULL, 14430, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:57:43', 'admin-1510276265-15102826628485946', 1, 0, '', NULL, NULL, NULL),
(53054, '2017-11-10 10:57:43', NULL, NULL, 14430, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:57:43', 'admin-1510276265-15102826628485946', 1, 0, '', NULL, NULL, NULL),
(53055, '2017-11-10 10:57:20', NULL, NULL, 14430, 0, 181, '116', 'Open Food ', 'toast   1 sunny egg', 'Meals', 'Perfect Meals', 1, 2.50, 2.5000, 0.0000, 2.50, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:57:20', 'admin-1510276265-15102826398612486', 1, 0, '', NULL, NULL, NULL),
(53056, '2017-11-10 10:57:43', NULL, NULL, 14430, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:57:43', 'admin-1510276265-15102826628485946', 1, 0, '', NULL, NULL, NULL),
(53057, '2017-11-10 10:57:43', NULL, NULL, 14430, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:57:43', 'admin-1510276265-15102826628485946', 1, 0, '', NULL, NULL, NULL),
(53058, '2017-11-10 13:30:50', NULL, NULL, 14437, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 13:30:50', 'admin-1510276265-15102918504929486', 1, 1, 'SR', 1, NULL, NULL),
(53059, '2017-11-10 10:57:43', NULL, NULL, 14430, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:57:43', 'admin-1510276265-15102826628485946', 1, 0, '', NULL, NULL, NULL),
(53060, '2017-11-10 10:44:52', NULL, NULL, 14429, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:44:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53061, '2017-11-10 10:45:02', NULL, NULL, 14429, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:45:02', 'admin-1510276265-15102819021037751', 1, 0, '', NULL, NULL, NULL),
(53062, '2017-11-10 09:48:21', NULL, NULL, 14425, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1510276265', 'admin', '2017-11-10 09:48:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53063, '2017-11-10 10:56:43', NULL, NULL, 14430, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.95, 0.0000, 0.0000, 14.95, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:56:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53064, '2017-11-10 10:10:41', NULL, NULL, 14426, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:10:41', 'admin-1510276265-15102798410085257', 1, 0, '', NULL, NULL, NULL),
(53065, '2017-11-10 10:10:41', NULL, NULL, 14426, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:10:41', 'admin-1510276265-15102798410085257', 1, 0, '', NULL, NULL, NULL),
(53066, '2017-11-10 09:48:26', NULL, NULL, 14425, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 09:48:26', 'admin-1510276265-15102785067224927', 1, 0, '', NULL, NULL, NULL),
(53067, '2017-11-10 10:28:21', NULL, NULL, 14427, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1510276265', 'admin', '2017-11-10 10:28:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53068, '2017-11-10 09:45:03', NULL, NULL, 14424, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 09:45:03', 'admin-1510276265-15102783030656897', 1, 1, 'SR', NULL, NULL, NULL),
(53069, '2017-11-10 09:45:03', NULL, NULL, 14424, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510276265', 'admin', '2017-11-10 09:45:03', 'admin-1510276265-15102783030656897', 1, 0, '', NULL, NULL, NULL),
(53070, '2017-11-10 09:44:10', NULL, NULL, 14424, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1510276265', 'admin', '2017-11-10 09:44:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53071, '2017-11-11 14:21:47', NULL, NULL, 14467, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:21:47', 'admin-1510362498-15103813071585559', 1, 1, 'SR', NULL, NULL, NULL),
(53072, '2017-11-11 14:21:47', NULL, NULL, 14467, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:21:47', 'admin-1510362498-15103813071585559', 1, 1, 'SR', NULL, NULL, NULL),
(53073, '2017-11-11 14:16:02', NULL, NULL, 14466, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:16:02', 'admin-1510362498-15103809621435021', 1, 0, '', NULL, NULL, NULL),
(53074, '2017-11-11 14:16:02', NULL, NULL, 14466, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:16:02', 'admin-1510362498-15103809621435021', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(53075, '2017-11-11 13:04:17', NULL, NULL, 14464, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 13:04:17', 'admin-1510362498-15103766572342363', 1, 1, 'SR', NULL, NULL, NULL),
(53076, '2017-11-11 11:01:09', NULL, NULL, 14456, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 11:01:09', 'admin-1510362498-15103692691561439', 1, 1, 'SR', NULL, NULL, NULL),
(53077, '2017-11-11 14:57:37', NULL, NULL, 14467, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:57:37', 'admin-1510362498-1510383457079885', 1, 0, '', NULL, NULL, NULL),
(53078, '2017-11-11 14:09:02', NULL, NULL, 14465, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:09:02', 'admin-1510362498-1510380542359594', 1, 0, '', NULL, NULL, '10.0'),
(53079, '2017-11-11 13:43:50', NULL, NULL, 14465, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 13:43:50', 'admin-1510362498-15103790303946411', 1, 0, '', NULL, NULL, '10.0'),
(53080, '2017-11-11 13:43:31', NULL, NULL, 14465, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1510385859', 'admin', '2017-11-11 13:43:31', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(53081, '2017-11-11 15:28:43', NULL, NULL, 14469, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 15:28:43', 'admin-1510362498-15103853231916285', 1, 1, 'SR', NULL, NULL, NULL),
(53082, '2017-11-11 14:20:57', NULL, NULL, 14467, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.30, 0.0000, 0.0000, 11.30, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:20:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53083, '2017-11-11 14:21:47', NULL, NULL, 14467, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:21:47', 'admin-1510362498-15103813071585559', 1, 1, 'SR', NULL, NULL, NULL),
(53084, '2017-11-11 14:12:12', NULL, NULL, 14465, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:12:12', 'admin-1510362498-1510380732118649', 1, 0, '', NULL, NULL, '10.0'),
(53085, '2017-11-11 14:21:47', NULL, NULL, 14467, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:21:47', 'admin-1510362498-15103813071585559', 1, 0, '', NULL, NULL, NULL),
(53086, '2017-11-11 14:21:47', NULL, NULL, 14467, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:21:47', 'admin-1510362498-15103813071585559', 1, 0, '', NULL, NULL, NULL),
(53087, '2017-11-11 14:21:47', NULL, NULL, 14467, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:21:47', 'admin-1510362498-15103813071585559', 1, 0, '', NULL, NULL, NULL),
(53088, '2017-11-11 16:19:05', NULL, NULL, 14470, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1510385859', 'admin', '2017-11-11 16:19:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53089, '2017-11-11 15:06:38', NULL, NULL, 14468, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 15:06:38', 'admin-1510362498-15103839985458043', 1, 0, '', NULL, NULL, NULL),
(53090, '2017-11-11 12:02:54', NULL, NULL, 14459, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:02:54', 'admin-1510362498-15103729744839183', 1, 0, '', NULL, NULL, NULL),
(53091, '2017-11-11 12:02:54', NULL, NULL, 14459, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:02:54', 'admin-1510362498-15103729744839183', 1, 1, 'SR', NULL, NULL, NULL),
(53092, '2017-11-11 12:02:54', NULL, NULL, 14459, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:02:54', 'admin-1510362498-15103729744839183', 1, 1, 'SR', NULL, NULL, NULL),
(53093, '2017-11-11 12:02:54', NULL, NULL, 14459, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:02:54', 'admin-1510362498-15103729744839183', 1, 1, 'SR', NULL, NULL, NULL),
(53094, '2017-11-11 12:44:13', NULL, NULL, 14460, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:44:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53095, '2017-11-11 12:44:21', NULL, NULL, 14460, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:44:21', 'admin-1510362498-1510375461060718', 1, 1, 'SR', NULL, NULL, NULL),
(53096, '2017-11-11 14:16:02', NULL, NULL, 14466, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:16:02', 'admin-1510362498-15103809621435021', 1, 0, '', NULL, NULL, NULL),
(53097, '2017-11-11 10:44:18', NULL, NULL, 14455, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:44:18', 'admin-1510362498-15103682578553467', 1, 0, '', NULL, NULL, NULL),
(53098, '2017-11-11 12:47:11', NULL, NULL, 14461, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:47:11', 'admin-1510362498-15103756315788421', 1, 0, '', NULL, NULL, NULL),
(53099, '2017-11-11 16:19:14', NULL, NULL, 14470, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 16:19:14', 'admin-1510385859-15103883538931329', 1, 1, 'SR', NULL, NULL, NULL),
(53100, '2017-11-11 15:18:12', NULL, NULL, 14469, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 15:18:12', 'admin-1510362498-15103846920212982', 1, 0, '', NULL, NULL, NULL),
(53101, '2017-11-11 16:19:32', NULL, NULL, 14470, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 16:19:32', 'admin-1510385859-15103883726114689', 1, 0, '', NULL, NULL, NULL),
(53102, '2017-11-11 15:44:22', NULL, NULL, 14469, 0, 304, '240', 'Banana is On Fire', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 15:44:22', 'admin-1510385859-1510386262481127', 1, 0, '', NULL, NULL, NULL),
(53103, '2017-11-11 13:10:48', NULL, NULL, 14464, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 13:10:48', 'admin-1510362498-15103770484874270', 1, 1, 'SR', NULL, NULL, NULL),
(53104, '2017-11-11 12:47:11', NULL, NULL, 14461, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:47:11', 'admin-1510362498-15103756315788421', 1, 1, 'SR', NULL, NULL, NULL),
(53105, '2017-11-11 14:47:50', NULL, NULL, 14468, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:47:50', 'admin-1510362498-15103828699753596', 1, 1, 'SR', NULL, NULL, NULL),
(53106, '2017-11-11 14:47:50', NULL, NULL, 14468, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:47:50', 'admin-1510362498-15103828699753596', 1, 1, 'SR', NULL, NULL, NULL),
(53107, '2017-11-11 14:50:06', NULL, NULL, 14468, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:50:06', 'admin-1510362498-15103830060384216', 1, 0, '', NULL, NULL, NULL),
(53108, '2017-11-11 13:04:17', NULL, NULL, 14464, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 13:04:17', 'admin-1510362498-15103766572342363', 1, 1, 'SR', NULL, NULL, NULL),
(53109, '2017-11-11 13:03:43', NULL, NULL, 14464, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1510385859', 'admin', '2017-11-11 13:03:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53110, '2017-11-11 12:47:48', NULL, NULL, 14462, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:47:48', 'admin-1510362498-15103756680311581', 1, 1, 'SR', NULL, NULL, NULL),
(53111, '2017-11-11 12:47:48', NULL, NULL, 14462, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:47:48', 'admin-1510362498-15103756680311581', 1, 1, 'SR', NULL, NULL, NULL),
(53112, '2017-11-11 09:37:35', NULL, NULL, 14446, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:37:35', 'admin-1510362498-15103642550264872', 1, 1, 'SR', NULL, NULL, NULL),
(53113, '2017-11-11 09:37:35', NULL, NULL, 14446, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:37:35', 'admin-1510362498-15103642550264872', 1, 1, 'SR', NULL, NULL, NULL),
(53114, '2017-11-11 09:37:35', NULL, NULL, 14446, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:37:35', 'admin-1510362498-15103642550264872', 1, 0, '', NULL, NULL, NULL),
(53115, '2017-11-11 15:24:06', NULL, NULL, 14468, 0, 304, '240', 'Banana is On Fire', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 15:24:06', 'admin-1510362498-15103850462366062', 1, 0, '', NULL, NULL, NULL),
(53116, '2017-11-11 15:18:12', NULL, NULL, 14469, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 15:18:12', 'admin-1510362498-15103846920212982', 1, 1, 'SR', NULL, NULL, NULL),
(53117, '2017-11-11 15:18:02', NULL, NULL, 14469, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1510385859', 'admin', '2017-11-11 15:18:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53118, '2017-11-11 10:35:05', NULL, NULL, 14453, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:35:05', 'admin-1510362498-15103677048774197', 1, 0, '', NULL, NULL, NULL),
(53119, '2017-11-11 10:35:05', NULL, NULL, 14453, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:35:05', 'admin-1510362498-15103677048774197', 1, 1, 'SR', NULL, NULL, NULL),
(53120, '2017-11-11 09:44:50', NULL, NULL, 14448, 0, 2, '2', 'Espresso Macchiato ', '1 scoop of foam', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:44:50', 'admin-1510362498-15103646906053854', 1, 1, 'SR', NULL, NULL, NULL),
(53121, '2017-11-11 09:44:50', NULL, NULL, 14448, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:44:50', 'admin-1510362498-15103646906053854', 1, 1, 'SR', NULL, NULL, NULL),
(53122, '2017-11-11 09:44:50', NULL, NULL, 14448, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:44:50', 'admin-1510362498-15103646906053854', 1, 1, 'SR', NULL, NULL, NULL),
(53123, '2017-11-11 09:47:46', NULL, NULL, 14449, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:47:46', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(53124, '2017-11-11 14:46:57', NULL, NULL, 14468, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.50, 0.0000, 0.0000, 16.50, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:46:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53125, '2017-11-11 14:50:06', NULL, NULL, 14468, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:50:06', 'admin-1510362498-15103830060384216', 1, 1, 'SR', NULL, NULL, NULL),
(53126, '2017-11-11 14:25:45', NULL, NULL, 14460, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:25:45', 'admin-1510362498-15103815456315616', 1, 1, 'SR', NULL, NULL, NULL),
(53127, '2017-11-11 14:47:50', NULL, NULL, 14468, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:47:50', 'admin-1510362498-15103828699753596', 1, 1, 'SR', NULL, NULL, NULL),
(53128, '2017-11-11 14:47:50', NULL, NULL, 14468, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:47:50', 'admin-1510362498-15103828699753596', 1, 0, '', NULL, NULL, NULL),
(53129, '2017-11-11 14:47:50', NULL, NULL, 14468, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:47:50', 'admin-1510362498-15103828699753596', 1, 0, '', NULL, NULL, NULL),
(53130, '2017-11-11 14:47:50', NULL, NULL, 14468, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:47:50', 'admin-1510362498-15103828699753596', 1, 0, '', NULL, NULL, NULL),
(53131, '2017-11-11 14:09:02', NULL, NULL, 14465, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:09:02', 'admin-1510362498-1510380542359594', 1, 1, 'SR', NULL, NULL, '10.0'),
(53132, '2017-11-11 12:50:21', NULL, NULL, 14463, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:50:21', 'admin-1510362498-15103758215573258', 1, 1, 'SR', NULL, NULL, NULL),
(53133, '2017-11-11 12:50:21', NULL, NULL, 14463, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:50:21', 'admin-1510362498-15103758215573258', 1, 1, 'SR', NULL, NULL, NULL),
(53134, '2017-11-11 12:02:54', NULL, NULL, 14459, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:02:54', 'admin-1510362498-15103729744839183', 1, 0, '', NULL, NULL, NULL),
(53135, '2017-11-11 12:47:11', NULL, NULL, 14461, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:47:11', 'admin-1510362498-15103756315788421', 1, 1, 'SR', NULL, NULL, NULL),
(53136, '2017-11-11 11:05:19', NULL, NULL, 14457, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1510385859', 'admin', '2017-11-11 11:05:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53137, '2017-11-11 11:05:28', NULL, NULL, 14457, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 11:05:28', 'admin-1510362498-15103695282502211', 1, 0, '', NULL, NULL, NULL),
(53138, '2017-11-11 12:50:21', NULL, NULL, 14463, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:50:21', 'admin-1510362498-15103758215573258', 1, 0, '', NULL, NULL, NULL),
(53139, '2017-11-11 11:05:28', NULL, NULL, 14457, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 11:05:28', 'admin-1510362498-15103695282502211', 1, 0, '', NULL, NULL, NULL),
(53140, '2017-11-11 11:17:17', NULL, NULL, 14458, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 11:17:17', 'admin-1510362498-15103702369723756', 1, 0, '', NULL, NULL, NULL),
(53141, '2017-11-11 11:17:17', NULL, NULL, 14458, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 11:17:17', 'admin-1510362498-15103702369723756', 1, 1, 'SR', NULL, NULL, NULL),
(53142, '2017-11-11 10:37:57', NULL, NULL, 14452, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:37:57', 'admin-1510362498-15103678774966499', 1, 0, '', NULL, NULL, NULL),
(53143, '2017-11-11 10:28:53', NULL, NULL, 14452, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:28:53', 'admin-1510362498-15103673328894133', 1, 0, '', NULL, NULL, NULL),
(53144, '2017-11-11 10:28:53', NULL, NULL, 14452, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:28:53', 'admin-1510362498-15103673328894133', 1, 0, '', NULL, NULL, NULL),
(53145, '2017-11-11 14:21:47', NULL, NULL, 14467, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:21:47', 'admin-1510362498-15103813071585559', 1, 1, 'SR', NULL, NULL, NULL),
(53146, '2017-11-11 12:47:11', NULL, NULL, 14461, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:47:11', 'admin-1510362498-15103756315788421', 1, 0, '', NULL, NULL, NULL),
(53147, '2017-11-11 12:44:21', NULL, NULL, 14460, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:44:21', 'admin-1510362498-1510375461060718', 1, 0, '', NULL, NULL, NULL),
(53148, '2017-11-11 10:52:06', NULL, NULL, 14454, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:52:06', 'admin-1510362498-15103687261766534', 1, 1, 'SR', NULL, NULL, NULL),
(53149, '2017-11-11 11:00:53', NULL, NULL, 14456, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1510385859', 'admin', '2017-11-11 11:00:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53150, '2017-11-11 10:44:18', NULL, NULL, 14455, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:44:18', 'admin-1510362498-15103682578553467', 1, 0, '', NULL, NULL, NULL),
(53151, '2017-11-11 10:44:18', NULL, NULL, 14455, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:44:18', 'admin-1510362498-15103682578553467', 1, 0, '', NULL, NULL, NULL),
(53152, '2017-11-11 12:46:45', NULL, NULL, 14461, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:46:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53153, '2017-11-11 12:50:21', NULL, NULL, 14463, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:50:21', 'admin-1510362498-15103758215573258', 1, 1, 'SR', NULL, NULL, NULL),
(53154, '2017-11-11 12:02:54', NULL, NULL, 14459, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:02:54', 'admin-1510362498-15103729744839183', 1, 0, '', NULL, NULL, NULL),
(53155, '2017-11-11 12:02:54', NULL, NULL, 14459, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:02:54', 'admin-1510362498-15103729744839183', 1, 0, '', NULL, NULL, NULL),
(53156, '2017-11-11 11:42:08', NULL, NULL, 14446, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 11:42:08', 'admin-1510362498-15103717282367468', 1, 0, '', NULL, NULL, NULL),
(53157, '2017-11-11 09:34:07', NULL, NULL, 14446, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:34:07', 'admin-1510362498-15103640469057748', 1, 0, '', NULL, NULL, NULL),
(53158, '2017-11-11 09:29:55', NULL, NULL, 14446, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:29:55', 'admin-1510362498-1510363795555411', 1, 1, 'SR', NULL, NULL, NULL),
(53159, '2017-11-11 09:30:05', NULL, NULL, 14447, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:30:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53160, '2017-11-11 09:30:22', NULL, NULL, 14447, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:30:22', 'admin-1510362498-15103638221876622', 1, 1, 'SR', NULL, NULL, NULL),
(53161, '2017-11-11 13:55:52', NULL, NULL, 14465, 0, 301, '237', 'Black Jack', '', 'Cold Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 13:55:52', 'admin-1510362498-15103797521437731', 1, 0, '', NULL, NULL, '10.0'),
(53162, '2017-11-11 12:02:20', NULL, NULL, 14459, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:02:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53163, '2017-11-11 11:16:40', NULL, NULL, 14458, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1510385859', 'admin', '2017-11-11 11:16:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53164, '2017-11-11 10:41:09', NULL, NULL, 14454, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:41:09', 'admin-1510362498-1510368069703439', 1, 0, '', NULL, NULL, NULL),
(53165, '2017-11-11 09:30:22', NULL, NULL, 14447, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:30:22', 'admin-1510362498-15103638221876622', 1, 1, 'SR', NULL, NULL, NULL),
(53166, '2017-11-11 11:01:09', NULL, NULL, 14456, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 11:01:09', 'admin-1510362498-15103692691561439', 1, 0, '', NULL, NULL, NULL),
(53167, '2017-11-11 11:01:09', NULL, NULL, 14456, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 11:01:09', 'admin-1510362498-15103692691561439', 1, 0, '', NULL, NULL, NULL),
(53168, '2017-11-11 14:47:50', NULL, NULL, 14468, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:47:50', 'admin-1510362498-15103828699753596', 1, 0, '', NULL, NULL, NULL),
(53169, '2017-11-11 12:50:21', NULL, NULL, 14463, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:50:21', 'admin-1510362498-15103758215573258', 1, 1, 'SR', NULL, NULL, NULL),
(53170, '2017-11-11 10:44:18', NULL, NULL, 14455, 0, 32, '32', 'Tea By Pot ', 'earl grey', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:44:18', 'admin-1510362498-15103682578553467', 1, 1, 'SR', NULL, NULL, NULL),
(53171, '2017-11-11 10:44:18', NULL, NULL, 14455, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:44:18', 'admin-1510362498-15103682578553467', 1, 0, '', NULL, NULL, NULL),
(53172, '2017-11-11 10:44:18', NULL, NULL, 14455, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:44:18', 'admin-1510362498-15103682578553467', 1, 0, '', NULL, NULL, NULL),
(53173, '2017-11-11 10:52:06', NULL, NULL, 14454, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:52:06', 'admin-1510362498-15103687261766534', 1, 1, 'SR', NULL, NULL, NULL),
(53174, '2017-11-11 10:43:45', NULL, NULL, 14455, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.60, 0.0000, 0.0000, 10.60, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:43:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53175, '2017-11-11 10:41:09', NULL, NULL, 14454, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:41:09', 'admin-1510362498-1510368069703439', 1, 0, '', NULL, NULL, NULL),
(53176, '2017-11-11 10:40:47', NULL, NULL, 14454, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:40:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53177, '2017-11-11 10:35:05', NULL, NULL, 14453, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:35:05', 'admin-1510362498-15103677048774197', 1, 1, 'SR', NULL, NULL, NULL),
(53178, '2017-11-11 10:28:29', NULL, NULL, 14452, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:28:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53179, '2017-11-11 12:47:32', NULL, NULL, 14462, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:47:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53180, '2017-11-11 10:35:05', NULL, NULL, 14453, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:35:05', 'admin-1510362498-15103677048774197', 1, 0, '', NULL, NULL, NULL),
(53181, '2017-11-11 10:28:53', NULL, NULL, 14452, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:28:53', 'admin-1510362498-15103673328894133', 1, 1, 'SR', NULL, NULL, NULL),
(53182, '2017-11-11 09:56:17', NULL, NULL, 14450, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:56:17', 'admin-1510362498-15103653770556949', 1, 1, 'SR', NULL, NULL, NULL),
(53183, '2017-11-11 09:48:15', NULL, NULL, 14449, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:48:15', 'admin-1510362498-15103648948967046', 1, 0, '', NULL, NULL, '10.0'),
(53184, '2017-11-11 09:37:35', NULL, NULL, 14446, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:37:35', 'admin-1510362498-15103642550264872', 1, 1, 'SR', NULL, NULL, NULL),
(53185, '2017-11-11 09:41:13', NULL, NULL, 14446, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:41:13', 'admin-1510362498-15103644737373213', 1, 1, 'SR', NULL, NULL, NULL),
(53186, '2017-11-11 10:17:10', NULL, NULL, 14451, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:17:10', 'admin-1510362498-15103666307767867', 1, 1, 'SR', 1, NULL, '10.0'),
(53187, '2017-11-11 10:34:44', NULL, NULL, 14453, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1510385859', 'admin', '2017-11-11 10:34:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53188, '2017-11-11 09:56:08', NULL, NULL, 14450, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:56:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53189, '2017-11-11 09:56:17', NULL, NULL, 14450, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:56:17', 'admin-1510362498-15103653770556949', 1, 0, '', NULL, NULL, NULL),
(53190, '2017-11-11 09:48:15', NULL, NULL, 14449, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:48:15', 'admin-1510362498-15103648948967046', 1, 1, 'SR', NULL, NULL, '10.0'),
(53191, '2017-11-11 09:48:15', NULL, NULL, 14449, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:48:15', 'admin-1510362498-15103648948967046', 1, 1, 'SR', NULL, NULL, '10.0'),
(53192, '2017-11-11 09:44:05', NULL, NULL, 14448, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:44:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53193, '2017-11-11 12:50:02', NULL, NULL, 14463, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1510385859', 'admin', '2017-11-11 12:50:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53194, '2017-11-11 09:37:13', NULL, NULL, 14446, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:37:13', 'admin-1510362498-15103642337025722', 1, 0, '', NULL, NULL, NULL),
(53195, '2017-11-11 14:15:45', NULL, NULL, 14466, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 14:15:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53196, '2017-11-11 13:04:17', NULL, NULL, 14464, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 13:04:17', 'admin-1510362498-15103766572342363', 1, 0, '', NULL, NULL, NULL),
(53197, '2017-11-11 09:44:50', NULL, NULL, 14448, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:44:50', 'admin-1510362498-15103646906053854', 1, 1, 'SR', NULL, NULL, NULL),
(53198, '2017-11-11 09:37:13', NULL, NULL, 14446, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:37:13', 'admin-1510362498-15103642337025722', 1, 0, '', NULL, NULL, NULL),
(53199, '2017-11-11 09:37:13', NULL, NULL, 14446, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:37:13', 'admin-1510362498-15103642337025722', 1, 0, '', NULL, NULL, NULL),
(53200, '2017-11-11 09:37:35', NULL, NULL, 14446, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:37:35', 'admin-1510362498-15103642550264872', 1, 0, '', NULL, NULL, NULL),
(53201, '2017-11-11 09:37:13', NULL, NULL, 14446, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:37:13', 'admin-1510362498-15103642337025722', 1, 0, '', NULL, NULL, NULL),
(53202, '2017-11-11 09:30:22', NULL, NULL, 14447, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:30:22', 'admin-1510362498-15103638221876622', 1, 1, 'SR', NULL, NULL, NULL),
(53203, '2017-11-11 09:28:01', NULL, NULL, 14446, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:28:01', 'admin-1510362498-15103636809439529', 1, 0, '', NULL, NULL, NULL),
(53204, '2017-11-11 09:28:01', NULL, NULL, 14446, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:28:01', 'admin-1510362498-15103636809439529', 1, 0, '', NULL, NULL, NULL),
(53205, '2017-11-11 09:27:28', NULL, NULL, 14446, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 21.10, 0.0000, 0.0000, 21.10, 1, '27', 1, '1510385859', 'admin', '2017-11-11 09:27:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53206, '2017-11-12 12:39:00', NULL, NULL, 14496, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:39:00', 'admin-1510449408-15104615407052034', 1, 1, 'SR', NULL, NULL, NULL),
(53207, '2017-11-12 14:03:40', NULL, NULL, 14504, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 14:03:40', 'admin-1510449408-15104666203989924', 1, 1, 'SR', NULL, NULL, NULL),
(53208, '2017-11-12 14:03:40', NULL, NULL, 14504, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 14:03:40', 'admin-1510449408-15104666203989924', 1, 0, '', NULL, NULL, NULL),
(53209, '2017-11-12 14:03:40', NULL, NULL, 14504, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 14:03:40', 'admin-1510449408-15104666203989924', 1, 0, '', NULL, NULL, NULL),
(53210, '2017-11-12 12:26:47', NULL, NULL, 14495, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:26:47', 'admin-1510449408-15104608069377788', 1, 1, 'SR', NULL, NULL, NULL),
(53211, '2017-11-12 12:26:47', NULL, NULL, 14495, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:26:47', 'admin-1510449408-15104608069377788', 1, 0, '', NULL, NULL, NULL),
(53212, '2017-11-12 12:14:45', NULL, NULL, 14484, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:14:45', 'admin-1510449408-15104600851232217', 1, 0, '', NULL, NULL, NULL),
(53213, '2017-11-12 12:23:32', NULL, NULL, 14494, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:23:32', 'admin-1510449408-15104606120032278', 1, 0, '', NULL, NULL, NULL),
(53214, '2017-11-12 12:23:32', NULL, NULL, 14494, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:23:32', 'admin-1510449408-15104606120032278', 1, 0, '', NULL, NULL, NULL),
(53215, '2017-11-12 12:49:25', NULL, NULL, 14499, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:49:25', 'admin-1510449408-15104621648336070', 1, 1, 'SR', NULL, NULL, NULL),
(53216, '2017-11-12 15:37:20', NULL, NULL, 14512, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 15:37:20', 'admin-1510449408-1510472239935165', 1, 0, '', NULL, NULL, NULL),
(53217, '2017-11-12 15:45:12', NULL, NULL, 14513, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1510449408', 'admin', '2017-11-12 15:45:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53218, '2017-11-12 15:45:21', NULL, NULL, 14513, 0, 302, '238', 'Ice on the cake', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 15:45:21', 'admin-1510449408-15104727213984595', 1, 0, '', NULL, NULL, NULL),
(53219, '2017-11-12 15:45:21', NULL, NULL, 14513, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 15:45:21', 'admin-1510449408-15104727213984595', 1, 0, '', NULL, NULL, NULL),
(53220, '2017-11-12 13:04:15', NULL, NULL, 14500, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 13:04:15', 'admin-1510449408-15104630549134370', 1, 1, 'SR', NULL, NULL, NULL),
(53221, '2017-11-12 13:04:15', NULL, NULL, 14500, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 13:04:15', 'admin-1510449408-15104630549134370', 1, 1, 'SR', NULL, NULL, NULL),
(53222, '2017-11-12 13:04:15', NULL, NULL, 14500, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 13:04:15', 'admin-1510449408-15104630549134370', 1, 1, 'SR', NULL, NULL, NULL),
(53223, '2017-11-12 13:06:04', NULL, NULL, 14501, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 13:06:04', 'admin-1510449408-15104631638963664', 1, 0, '', 1, NULL, NULL),
(53224, '2017-11-12 13:18:26', NULL, NULL, 14502, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1510449408', 'admin', '2017-11-12 13:18:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53225, '2017-11-12 12:23:07', NULL, NULL, 14494, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:23:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53226, '2017-11-12 12:03:41', NULL, NULL, 14493, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:03:41', 'admin-1510449408-15104594213101183', 1, 0, '', NULL, NULL, NULL),
(53227, '2017-11-12 11:10:38', NULL, NULL, 14485, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:10:38', 'admin-1510449408-15104562381837822', 1, 1, 'SR', NULL, NULL, NULL),
(53228, '2017-11-12 11:13:42', NULL, NULL, 14486, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:13:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53229, '2017-11-12 12:39:00', NULL, NULL, 14496, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:39:00', 'admin-1510449408-15104615407052034', 1, 0, '', NULL, NULL, NULL),
(53230, '2017-11-12 10:49:01', NULL, NULL, 14482, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:49:01', 'admin-1510449408-15104549415353471', 1, 0, '', NULL, NULL, NULL),
(53231, '2017-11-12 10:58:00', NULL, NULL, 14483, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:58:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53232, '2017-11-12 11:08:33', NULL, NULL, 14484, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:08:33', 'admin-1510449408-15104561134853280', 1, 0, '', NULL, NULL, NULL),
(53233, '2017-11-12 14:24:56', NULL, NULL, 14497, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 14:24:56', 'admin-1510449408-1510467896391819', 1, 1, 'SR', 1, NULL, NULL),
(53234, '2017-11-12 14:24:56', NULL, NULL, 14497, 0, 181, '116', 'Open Food ', 'add 2 eggs', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 14:24:56', 'admin-1510449408-1510467896391819', 1, 0, '', 1, NULL, NULL),
(53235, '2017-11-12 14:39:50', NULL, NULL, 14505, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1510449408', 'admin', '2017-11-12 14:39:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53236, '2017-11-12 14:39:55', NULL, NULL, 14505, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 14:39:55', 'admin-1510449408-15104687949602296', 1, 1, 'SR', NULL, NULL, NULL),
(53237, '2017-11-12 14:42:45', NULL, NULL, 14506, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1510449408', 'admin', '2017-11-12 14:42:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53238, '2017-11-12 13:32:50', NULL, NULL, 14503, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 13:32:50', 'admin-1510449408-1510464770669974', 1, 1, 'SR', NULL, NULL, NULL),
(53239, '2017-11-12 12:39:00', NULL, NULL, 14496, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:39:00', 'admin-1510449408-15104615407052034', 1, 0, '', NULL, NULL, NULL),
(53240, '2017-11-12 12:39:00', NULL, NULL, 14496, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:39:00', 'admin-1510449408-15104615407052034', 1, 1, 'SR', NULL, NULL, NULL),
(53241, '2017-11-12 11:23:46', NULL, NULL, 14488, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:23:46', 'admin-1510449408-15104570257771080', 1, 0, '', NULL, NULL, NULL),
(53242, '2017-11-12 11:33:18', NULL, NULL, 14489, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:33:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53243, '2017-11-12 12:26:35', NULL, NULL, 14495, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:26:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53244, '2017-11-12 11:20:16', NULL, NULL, 14487, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:20:16', 'admin-1510449408-15104568163637713', 1, 1, 'SR', NULL, NULL, NULL),
(53245, '2017-11-12 15:37:20', NULL, NULL, 14512, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 15:37:20', 'admin-1510449408-1510472239935165', 1, 0, '', NULL, NULL, NULL),
(53246, '2017-11-12 14:43:33', NULL, NULL, 14506, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 14:43:33', 'admin-1510449408-15104690128145396', 1, 0, '', NULL, NULL, NULL),
(53247, '2017-11-12 14:43:33', NULL, NULL, 14506, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 14:43:33', 'admin-1510449408-15104690128145396', 1, 1, 'SR', NULL, NULL, NULL),
(53248, '2017-11-12 13:32:45', NULL, NULL, 14503, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1510449408', 'admin', '2017-11-12 13:32:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53249, '2017-11-12 17:27:26', NULL, NULL, 14509, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 17:27:26', 'admin-1510449408-15104788466921279', 1, 1, 'SR', NULL, NULL, NULL),
(53250, '2017-11-12 15:21:02', NULL, NULL, 14508, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 15:21:02', 'admin-1510449408-1510471261837329', 1, 0, '', NULL, NULL, NULL),
(53251, '2017-11-12 15:21:02', NULL, NULL, 14508, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 15:21:02', 'admin-1510449408-1510471261837329', 1, 0, '', NULL, NULL, NULL),
(53252, '2017-11-12 15:34:59', NULL, NULL, 14509, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1510449408', 'admin', '2017-11-12 15:34:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53253, '2017-11-12 15:35:04', NULL, NULL, 14509, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 15:35:04', 'admin-1510449408-15104721039647621', 1, 1, 'SR', NULL, NULL, NULL),
(53254, '2017-11-12 15:35:37', NULL, NULL, 14510, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 15:35:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53255, '2017-11-12 13:18:31', NULL, NULL, 14502, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 13:18:31', 'admin-1510449408-15104639114958655', 1, 0, '', NULL, NULL, NULL),
(53256, '2017-11-12 17:05:16', NULL, NULL, 14515, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 17:05:16', 'admin-1510449408-1510477516152938', 1, 0, '', NULL, NULL, NULL),
(53257, '2017-11-12 16:29:27', NULL, NULL, 14514, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 16:29:27', 'admin-1510449408-15104753670581369', 1, 0, '', NULL, NULL, NULL),
(53258, '2017-11-12 17:05:09', NULL, NULL, 14515, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1510449408', 'admin', '2017-11-12 17:05:09', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(53259, '2017-11-12 15:35:50', NULL, NULL, 14510, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 15:35:50', 'admin-1510449408-15104721501447676', 1, 1, 'SR', NULL, NULL, NULL),
(53260, '2017-11-12 15:35:50', NULL, NULL, 14510, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 15:35:50', 'admin-1510449408-15104721501447676', 1, 1, 'SR', NULL, NULL, NULL),
(53261, '2017-11-12 15:51:52', NULL, NULL, 14511, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 15:51:52', 'admin-1510449408-15104731120553135', 1, 1, 'SR', NULL, NULL, NULL),
(53262, '2017-11-12 12:04:28', NULL, NULL, 14493, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:04:28', 'admin-1510449408-15104594681364412', 1, 1, 'SR', NULL, NULL, NULL),
(53263, '2017-11-12 12:39:00', NULL, NULL, 14496, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:39:00', 'admin-1510449408-15104615407052034', 1, 1, 'SR', NULL, NULL, NULL),
(53264, '2017-11-12 16:29:20', NULL, NULL, 14514, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1510449408', 'admin', '2017-11-12 16:29:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53265, '2017-11-12 15:37:14', NULL, NULL, 14512, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1510449408', 'admin', '2017-11-12 15:37:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53266, '2017-11-12 15:36:25', NULL, NULL, 14511, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1510449408', 'admin', '2017-11-12 15:36:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53267, '2017-11-12 11:08:33', NULL, NULL, 14484, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:08:33', 'admin-1510449408-15104561134853280', 1, 1, 'SR', NULL, NULL, NULL),
(53268, '2017-11-12 11:08:33', NULL, NULL, 14484, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:08:33', 'admin-1510449408-15104561134853280', 1, 1, 'SR', NULL, NULL, NULL),
(53269, '2017-11-12 11:08:33', NULL, NULL, 14484, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:08:33', 'admin-1510449408-15104561134853280', 1, 1, 'SR', NULL, NULL, NULL),
(53270, '2017-11-12 11:10:01', NULL, NULL, 14485, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:10:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53271, '2017-11-12 11:10:28', NULL, NULL, 14485, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:10:28', 'admin-1510449408-1510456227994192', 1, 0, '', NULL, NULL, NULL),
(53272, '2017-11-12 11:08:33', NULL, NULL, 14484, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:08:33', 'admin-1510449408-15104561134853280', 1, 1, 'SR', NULL, NULL, NULL),
(53273, '2017-11-12 14:43:33', NULL, NULL, 14506, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 14:43:33', 'admin-1510449408-15104690128145396', 1, 1, 'SR', NULL, NULL, NULL),
(53274, '2017-11-12 13:04:15', NULL, NULL, 14500, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 13:04:15', 'admin-1510449408-15104630549134370', 1, 1, 'SR', NULL, NULL, NULL),
(53275, '2017-11-12 13:04:15', NULL, NULL, 14500, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 13:04:15', 'admin-1510449408-15104630549134370', 1, 1, 'SR', NULL, NULL, NULL),
(53276, '2017-11-12 12:49:09', NULL, NULL, 14499, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:49:09', 'admin-1510449408-15104621494331621', 1, 1, 'SR', NULL, NULL, NULL),
(53277, '2017-11-12 15:03:34', NULL, NULL, 14507, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1510449408', 'admin', '2017-11-12 15:03:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53278, '2017-11-12 15:03:43', NULL, NULL, 14507, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 15:03:43', 'admin-1510449408-15104702236622251', 1, 1, 'SR', NULL, NULL, NULL),
(53279, '2017-11-12 15:03:43', NULL, NULL, 14507, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 15:03:43', 'admin-1510449408-15104702236622251', 1, 0, '', NULL, NULL, NULL),
(53280, '2017-11-12 15:20:46', NULL, NULL, 14508, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1510449408', 'admin', '2017-11-12 15:20:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53281, '2017-11-12 12:39:47', NULL, NULL, 14496, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:39:47', 'admin-1510449408-15104615877216920', 1, 1, 'SR', NULL, NULL, NULL),
(53282, '2017-11-12 12:39:47', NULL, NULL, 14496, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:39:47', 'admin-1510449408-15104615877216920', 1, 0, '', NULL, NULL, NULL),
(53283, '2017-11-12 14:43:33', NULL, NULL, 14506, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 14:43:33', 'admin-1510449408-15104690128145396', 1, 1, 'SR', NULL, NULL, NULL),
(53284, '2017-11-12 14:43:33', NULL, NULL, 14506, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 14:43:33', 'admin-1510449408-15104690128145396', 1, 0, '', NULL, NULL, NULL),
(53285, '2017-11-12 13:03:05', NULL, NULL, 14500, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 13:03:05', 'admin-1510449408-15104629851964047', 1, 0, '', NULL, NULL, NULL),
(53286, '2017-11-12 13:03:05', NULL, NULL, 14500, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 13:03:05', 'admin-1510449408-15104629851964047', 1, 1, 'SR', NULL, NULL, NULL),
(53287, '2017-11-12 13:03:05', NULL, NULL, 14500, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 13:03:05', 'admin-1510449408-15104629851964047', 1, 1, 'SR', NULL, NULL, NULL),
(53288, '2017-11-12 13:03:05', NULL, NULL, 14500, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 13:03:05', 'admin-1510449408-15104629851964047', 1, 1, 'SR', NULL, NULL, NULL),
(53289, '2017-11-12 13:03:05', NULL, NULL, 14500, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 13:03:05', 'admin-1510449408-15104629851964047', 1, 0, '', NULL, NULL, NULL),
(53290, '2017-11-12 13:02:22', NULL, NULL, 14500, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.80, 0.0000, 0.0000, 15.80, 1, '27', 1, '1510449408', 'admin', '2017-11-12 13:02:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53291, '2017-11-12 12:39:47', NULL, NULL, 14496, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:39:47', 'admin-1510449408-15104615877216920', 1, 1, 'SR', NULL, NULL, NULL),
(53292, '2017-11-12 14:03:40', NULL, NULL, 14504, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 14:03:40', 'admin-1510449408-15104666203989924', 1, 1, 'SR', NULL, NULL, NULL),
(53293, '2017-11-12 14:03:14', NULL, NULL, 14504, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1510449408', 'admin', '2017-11-12 14:03:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53294, '2017-11-12 14:03:40', NULL, NULL, 14504, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 14:03:40', 'admin-1510449408-15104666203989924', 1, 0, '', NULL, NULL, NULL),
(53295, '2017-11-12 10:19:05', NULL, NULL, 14478, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:19:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53296, '2017-11-12 09:39:59', NULL, NULL, 14473, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:39:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53297, '2017-11-12 12:41:29', NULL, NULL, 14495, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:41:29', 'admin-1510449408-1510461688842563', 1, 0, '', NULL, NULL, NULL),
(53298, '2017-11-12 12:49:03', NULL, NULL, 14499, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:49:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53299, '2017-11-12 12:45:42', NULL, NULL, 14498, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:45:42', 'admin-1510449408-1510461942037939', 1, 1, 'SR', 1, NULL, '1.0'),
(53300, '2017-11-12 12:39:00', NULL, NULL, 14496, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:39:00', 'admin-1510449408-15104615407052034', 1, 1, 'SR', NULL, NULL, NULL),
(53301, '2017-11-12 12:39:47', NULL, NULL, 14496, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:39:47', 'admin-1510449408-15104615877216920', 1, 1, 'SR', NULL, NULL, NULL),
(53302, '2017-11-12 12:10:06', NULL, NULL, 14493, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:10:06', 'admin-1510449408-15104598063805020', 1, 0, '', NULL, NULL, NULL),
(53303, '2017-11-12 13:03:05', NULL, NULL, 14500, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 13:03:05', 'admin-1510449408-15104629851964047', 1, 0, '', NULL, NULL, NULL),
(53304, '2017-11-12 12:03:24', NULL, NULL, 14493, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:03:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53305, '2017-11-12 11:56:09', NULL, NULL, 14492, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:56:09', 'admin-1510449408-1510458969147966', 1, 0, '', 1, NULL, '10.0'),
(53306, '2017-11-12 09:27:47', NULL, NULL, 14472, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:27:47', 'admin-1510449408-15104500670826641', 1, 1, 'SR', NULL, NULL, NULL),
(53307, '2017-11-12 09:27:47', NULL, NULL, 14472, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:27:47', 'admin-1510449408-15104500670826641', 1, 1, 'SR', NULL, NULL, NULL),
(53308, '2017-11-12 11:33:59', NULL, NULL, 14490, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:33:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53309, '2017-11-12 11:34:06', NULL, NULL, 14490, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:34:06', 'admin-1510449408-15104576466997444', 1, 1, 'SR', NULL, NULL, NULL),
(53310, '2017-11-12 12:38:25', NULL, NULL, 14496, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.70, 0.0000, 0.0000, 13.70, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:38:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53311, '2017-11-12 12:23:32', NULL, NULL, 14494, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:23:32', 'admin-1510449408-15104606120032278', 1, 1, 'SR', NULL, NULL, NULL),
(53312, '2017-11-12 11:39:35', NULL, NULL, 14491, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:39:35', 'admin-1510449408-15104579750666744', 1, 0, '', NULL, NULL, NULL),
(53313, '2017-11-12 11:39:35', NULL, NULL, 14491, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:39:35', 'admin-1510449408-15104579750666744', 1, 0, '', NULL, NULL, NULL),
(53314, '2017-11-12 11:39:35', NULL, NULL, 14491, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:39:35', 'admin-1510449408-15104579750666744', 1, 0, '', NULL, NULL, NULL),
(53315, '2017-11-12 11:39:35', NULL, NULL, 14491, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:39:35', 'admin-1510449408-15104579750666744', 1, 1, 'SR', NULL, NULL, NULL),
(53316, '2017-11-12 11:39:35', NULL, NULL, 14491, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:39:35', 'admin-1510449408-15104579750666744', 1, 1, 'SR', NULL, NULL, NULL),
(53317, '2017-11-12 11:39:44', NULL, NULL, 14491, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:39:44', 'admin-1510449408-1510457984573125', 1, 1, 'SR', NULL, NULL, NULL),
(53318, '2017-11-12 10:09:18', NULL, NULL, 14475, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:09:18', 'admin-1510449408-15104525587024683', 1, 0, '', NULL, NULL, NULL),
(53319, '2017-11-12 00:00:00', NULL, NULL, 14481, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:17:38', 'admin-1510449408-15104494583636623', 1, 1, 'SR', NULL, NULL, NULL),
(53320, '2017-11-12 00:00:00', NULL, NULL, 14480, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:19:28', 'admin-1510449408-15104495678333788', 1, 1, 'SR', NULL, NULL, NULL),
(53321, '2017-11-12 00:00:00', NULL, NULL, 14477, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:19:28', 'admin-1510449408-15104495678333788', 1, 0, '', NULL, NULL, NULL),
(53322, '2017-11-12 11:13:55', NULL, NULL, 14486, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:13:55', 'admin-1510449408-15104564348712213', 1, 0, '', NULL, NULL, NULL),
(53323, '2017-11-12 12:04:28', NULL, NULL, 14493, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:04:28', 'admin-1510449408-15104594681364412', 1, 1, 'SR', NULL, NULL, NULL),
(53324, '2017-11-12 09:58:36', NULL, NULL, 14474, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:58:36', 'admin-1510449408-15104519162033617', 1, 0, '', NULL, NULL, NULL),
(53325, '2017-11-12 09:58:36', NULL, NULL, 14474, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:58:36', 'admin-1510449408-15104519162033617', 1, 0, '', NULL, NULL, NULL),
(53326, '2017-11-12 09:58:36', NULL, NULL, 14474, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:58:36', 'admin-1510449408-15104519162033617', 1, 1, 'SR', NULL, NULL, NULL),
(53327, '2017-11-12 09:58:36', NULL, NULL, 14474, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:58:36', 'admin-1510449408-15104519162033617', 1, 1, 'SR', NULL, NULL, NULL),
(53328, '2017-11-12 10:00:37', NULL, NULL, 14474, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:00:37', 'admin-1510449408-15104520376604654', 1, 1, 'SR', NULL, NULL, NULL),
(53329, '2017-11-12 00:00:00', NULL, NULL, 14480, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:30:04', 'admin-1510449408-15104502039396164', 1, 1, 'SR', NULL, NULL, NULL),
(53330, '2017-11-12 11:39:58', NULL, NULL, 14491, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:39:58', 'admin-1510449408-15104579978218871', 1, 1, 'SR', NULL, NULL, NULL),
(53331, '2017-11-12 11:39:06', NULL, NULL, 14491, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.90, 0.0000, 0.0000, 9.90, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:39:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53332, '2017-11-12 11:33:32', NULL, NULL, 14489, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:33:32', 'admin-1510449408-1510457612162546', 1, 0, '', NULL, NULL, NULL),
(53333, '2017-11-12 11:33:32', NULL, NULL, 14489, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:33:32', 'admin-1510449408-1510457612162546', 1, 0, '', NULL, NULL, NULL),
(53334, '2017-11-12 11:33:32', NULL, NULL, 14489, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:33:32', 'admin-1510449408-1510457612162546', 1, 0, '', NULL, NULL, NULL),
(53335, '2017-11-12 10:24:19', NULL, NULL, 14479, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:24:19', 'admin-1510449408-15104534592078257', 1, 1, 'SR', NULL, NULL, NULL),
(53336, '2017-11-12 10:24:19', NULL, NULL, 14479, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:24:19', 'admin-1510449408-15104534592078257', 1, 1, 'SR', NULL, NULL, NULL),
(53337, '2017-11-12 10:24:19', NULL, NULL, 14479, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:24:19', 'admin-1510449408-15104534592078257', 1, 0, '', NULL, NULL, NULL),
(53338, '2017-11-12 13:03:05', NULL, NULL, 14500, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 13:03:05', 'admin-1510449408-15104629851964047', 1, 0, '', NULL, NULL, NULL),
(53339, '2017-11-12 12:04:28', NULL, NULL, 14493, 0, 32, '32', 'Tea By Pot ', 'EARL GREY', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:04:28', 'admin-1510449408-15104594681364412', 1, 1, 'SR', NULL, NULL, NULL),
(53340, '2017-11-12 00:00:00', NULL, NULL, 14478, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:37:08', 'admin-1510449408-15104506278651677', 1, 1, 'SR', NULL, NULL, NULL),
(53341, '2017-11-12 10:24:08', NULL, NULL, 14479, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:24:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53342, '2017-11-12 11:23:46', NULL, NULL, 14488, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:23:46', 'admin-1510449408-15104570257771080', 1, 0, '', NULL, NULL, NULL),
(53343, '2017-11-12 11:23:46', NULL, NULL, 14488, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:23:46', 'admin-1510449408-15104570257771080', 1, 0, '', NULL, NULL, NULL),
(53344, '2017-11-12 00:00:00', NULL, NULL, 14481, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:17:38', 'admin-1510449408-15104494583636623', 1, 1, 'SR', NULL, NULL, NULL),
(53345, '2017-11-12 15:21:02', NULL, NULL, 14508, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 15:21:02', 'admin-1510449408-1510471261837329', 1, 1, 'SR', NULL, NULL, NULL),
(53346, '2017-11-12 11:23:45', NULL, NULL, 14488, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:23:45', 'admin-1510449408-15104570257771080', 1, 0, '', NULL, NULL, NULL),
(53347, '2017-11-12 11:23:45', NULL, NULL, 14488, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:23:45', 'admin-1510449408-15104570257771080', 1, 0, '', NULL, NULL, NULL),
(53348, '2017-11-12 11:23:15', NULL, NULL, 14488, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:23:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53349, '2017-11-12 11:20:16', NULL, NULL, 14487, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:20:16', 'admin-1510449408-15104568163637713', 1, 1, 'SR', NULL, NULL, NULL),
(53350, '2017-11-12 10:09:18', NULL, NULL, 14475, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:09:18', 'admin-1510449408-15104525587024683', 1, 0, '', NULL, NULL, NULL),
(53351, '2017-11-12 11:08:33', NULL, NULL, 14484, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:08:33', 'admin-1510449408-15104561134853280', 1, 0, '', NULL, NULL, NULL),
(53352, '2017-11-12 11:08:33', NULL, NULL, 14484, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:08:33', 'admin-1510449408-15104561134853280', 1, 1, 'SR', NULL, NULL, NULL),
(53353, '2017-11-12 11:13:55', NULL, NULL, 14486, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:13:55', 'admin-1510449408-15104564348712213', 1, 0, '', NULL, NULL, NULL),
(53354, '2017-11-12 11:20:16', NULL, NULL, 14487, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:20:16', 'admin-1510449408-15104568163637713', 1, 0, '', NULL, NULL, NULL),
(53355, '2017-11-12 11:20:16', NULL, NULL, 14487, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:20:16', 'admin-1510449408-15104568163637713', 1, 0, '', NULL, NULL, NULL),
(53356, '2017-11-12 11:19:26', NULL, NULL, 14484, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:19:26', 'admin-1510449408-15104567665623281', 1, 0, '', NULL, NULL, NULL),
(53357, '2017-11-12 10:48:57', NULL, NULL, 14482, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:48:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53358, '2017-11-12 11:10:38', NULL, NULL, 14485, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:10:38', 'admin-1510449408-15104562381837822', 1, 1, 'SR', NULL, NULL, NULL),
(53359, '2017-11-12 11:19:54', NULL, NULL, 14487, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:19:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53360, '2017-11-12 10:49:01', NULL, NULL, 14482, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:49:01', 'admin-1510449408-15104549415353471', 1, 0, '', NULL, NULL, NULL),
(53361, '2017-11-12 10:33:00', NULL, NULL, 14475, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:33:00', 'admin-1510449408-15104539803756114', 1, 0, '', NULL, NULL, NULL),
(53362, '2017-11-12 10:58:22', NULL, NULL, 14483, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:58:22', 'admin-1510449408-15104555021492077', 1, 1, 'SR', NULL, NULL, NULL),
(53363, '2017-11-12 10:58:22', NULL, NULL, 14483, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:58:22', 'admin-1510449408-15104555021492077', 1, 1, 'SR', NULL, NULL, NULL),
(53364, '2017-11-12 10:58:22', NULL, NULL, 14483, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:58:22', 'admin-1510449408-15104555021492077', 1, 0, '', NULL, NULL, NULL),
(53365, '2017-11-12 10:58:22', NULL, NULL, 14483, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:58:22', 'admin-1510449408-15104555021492077', 1, 0, '', NULL, NULL, NULL),
(53366, '2017-11-12 00:00:00', NULL, NULL, 14480, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:19:28', 'admin-1510449408-15104495678333788', 1, 0, '', NULL, NULL, NULL),
(53367, '2017-11-12 11:07:51', NULL, NULL, 14484, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.40, 0.0000, 0.0000, 12.40, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:07:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53368, '2017-11-12 10:09:18', NULL, NULL, 14475, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:09:18', 'admin-1510449408-15104525587024683', 1, 0, '', NULL, NULL, NULL),
(53369, '2017-11-12 00:00:00', NULL, NULL, 14481, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:17:38', 'admin-1510449408-15104494583636623', 1, 0, '', NULL, NULL, NULL),
(53370, '2017-11-12 00:00:00', NULL, NULL, 14481, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:17:38', 'admin-1510449408-15104494583636623', 1, 0, '', NULL, NULL, NULL),
(53371, '2017-11-12 00:00:00', NULL, NULL, 14478, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:30:04', 'admin-1510449408-15104502039396164', 1, 0, '', NULL, NULL, NULL),
(53372, '2017-11-12 09:40:08', NULL, NULL, 14473, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:40:08', 'admin-1510449408-1510450807889963', 1, 1, 'SR', NULL, NULL, NULL),
(53373, '2017-11-12 09:51:54', NULL, NULL, 14474, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 22.40, 0.0000, 0.0000, 22.40, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:51:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53374, '2017-11-12 00:00:00', NULL, NULL, 14480, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:04:08', 'admin-1510449408-15104522480507743', 1, 1, 'SR', NULL, NULL, NULL),
(53375, '2017-11-12 11:15:59', NULL, NULL, 14485, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:15:59', 'admin-1510449408-1510456559726175', 1, 0, '', NULL, NULL, NULL),
(53376, '2017-11-12 10:09:48', NULL, NULL, 14476, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:09:48', 'admin-1510449408-1510452588161876', 1, 1, 'SR', NULL, NULL, NULL),
(53377, '2017-11-12 10:09:48', NULL, NULL, 14476, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:09:48', 'admin-1510449408-1510452588161876', 1, 0, '', NULL, NULL, NULL),
(53378, '2017-11-12 10:09:48', NULL, NULL, 14476, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:09:48', 'admin-1510449408-1510452588161876', 1, 0, '', NULL, NULL, NULL),
(53379, '2017-11-12 10:09:39', NULL, NULL, 14476, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:09:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53380, '2017-11-12 10:09:18', NULL, NULL, 14475, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:09:18', 'admin-1510449408-15104525587024683', 1, 1, 'SR', NULL, NULL, NULL),
(53381, '2017-11-12 10:09:18', NULL, NULL, 14475, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:09:18', 'admin-1510449408-15104525587024683', 1, 1, 'SR', NULL, NULL, NULL),
(53382, '2017-11-12 10:09:18', NULL, NULL, 14475, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:09:18', 'admin-1510449408-15104525587024683', 1, 0, '', NULL, NULL, NULL),
(53383, '2017-11-12 09:52:14', NULL, NULL, 14474, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:52:14', 'admin-1510449408-1510451534314894', 1, 1, 'SR', NULL, NULL, NULL),
(53384, '2017-11-12 09:52:14', NULL, NULL, 14474, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:52:14', 'admin-1510449408-1510451534314894', 1, 1, 'SR', NULL, NULL, NULL),
(53385, '2017-11-12 09:52:14', NULL, NULL, 14474, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:52:14', 'admin-1510449408-1510451534314894', 1, 1, 'SR', NULL, NULL, NULL),
(53386, '2017-11-12 10:08:05', NULL, NULL, 14475, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.40, 0.0000, 0.0000, 11.40, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:08:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53387, '2017-11-12 10:09:18', NULL, NULL, 14475, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:09:18', 'admin-1510449408-15104525587024683', 1, 0, '', NULL, NULL, NULL),
(53388, '2017-11-12 09:58:36', NULL, NULL, 14474, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:58:36', 'admin-1510449408-15104519162033617', 1, 0, '', NULL, NULL, NULL),
(53389, '2017-11-12 09:52:14', NULL, NULL, 14474, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:52:14', 'admin-1510449408-1510451534314894', 1, 1, 'SR', NULL, NULL, NULL),
(53390, '2017-11-12 09:52:14', NULL, NULL, 14474, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:52:14', 'admin-1510449408-1510451534314894', 1, 1, 'SR', NULL, NULL, NULL),
(53391, '2017-11-12 10:24:46', NULL, NULL, 14480, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:24:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53392, '2017-11-12 10:18:35', NULL, NULL, 14477, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1510449408', 'admin', '2017-11-12 10:18:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53393, '2017-11-12 09:27:21', NULL, NULL, 14472, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:27:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53394, '2017-11-12 09:27:47', NULL, NULL, 14472, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:27:47', 'admin-1510449408-15104500670826641', 1, 0, '', NULL, NULL, NULL),
(53395, '2017-11-12 09:27:47', NULL, NULL, 14472, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:27:47', 'admin-1510449408-15104500670826641', 1, 0, '', NULL, NULL, NULL),
(53396, '2017-11-12 12:23:32', NULL, NULL, 14494, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 12:23:32', 'admin-1510449408-15104606120032278', 1, 1, 'SR', NULL, NULL, NULL),
(53397, '2017-11-12 09:52:14', NULL, NULL, 14474, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:52:14', 'admin-1510449408-1510451534314894', 1, 0, '', NULL, NULL, NULL),
(53398, '2017-11-12 09:52:14', NULL, NULL, 14474, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:52:14', 'admin-1510449408-1510451534314894', 1, 0, '', NULL, NULL, NULL),
(53399, '2017-11-12 09:52:14', NULL, NULL, 14474, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:52:14', 'admin-1510449408-1510451534314894', 1, 0, '', NULL, NULL, NULL),
(53400, '2017-11-12 09:52:14', NULL, NULL, 14474, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:52:14', 'admin-1510449408-1510451534314894', 1, 0, '', NULL, NULL, NULL),
(53401, '2017-11-12 09:27:47', NULL, NULL, 14472, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:27:47', 'admin-1510449408-15104500670826641', 1, 0, '', NULL, NULL, NULL),
(53402, '2017-11-12 11:23:46', NULL, NULL, 14488, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 11:23:46', 'admin-1510449408-15104570257771080', 1, 0, '', NULL, NULL, NULL),
(53403, '2017-11-12 09:52:14', NULL, NULL, 14474, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:52:14', 'admin-1510449408-1510451534314894', 1, 0, '', NULL, NULL, NULL),
(53404, '2017-11-12 00:00:00', NULL, NULL, 14477, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:19:28', 'admin-1510449408-15104495678333788', 1, 0, '', NULL, NULL, NULL),
(53405, '2017-11-12 00:00:00', NULL, NULL, 14480, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:30:04', 'admin-1510449408-15104502039396164', 1, 1, 'SR', NULL, NULL, NULL),
(53406, '2017-11-12 09:27:47', NULL, NULL, 14472, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:27:47', 'admin-1510449408-15104500670826641', 1, 1, 'SR', NULL, NULL, NULL),
(53407, '2017-11-12 00:00:00', NULL, NULL, 14481, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:17:38', 'admin-1510449408-15104494583636623', 1, 1, 'SR', NULL, NULL, NULL),
(53408, '2017-11-12 00:00:00', NULL, NULL, 14481, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:17:38', 'admin-1510449408-15104494583636623', 1, 1, 'SR', NULL, NULL, NULL),
(53409, '2017-11-12 00:00:00', NULL, NULL, 14481, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:17:38', 'admin-1510449408-15104494583636623', 1, 1, 'SR', NULL, NULL, NULL),
(53410, '2017-11-12 00:00:00', NULL, NULL, 14481, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:17:38', 'admin-1510449408-15104494583636623', 1, 1, 'SR', NULL, NULL, NULL),
(53411, '2017-11-12 00:00:00', NULL, NULL, 14481, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.60, NULL, NULL, 11.60, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:16:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53412, '2017-11-12 00:00:00', NULL, NULL, 14481, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1510449408', 'admin', '2017-11-12 09:17:38', 'admin-1510449408-15104494583636623', 1, 0, '', NULL, NULL, NULL),
(53413, '2017-11-13 13:48:53', NULL, NULL, 14524, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1510535091', 'admin', '2017-11-13 13:48:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53414, '2017-11-13 09:31:54', NULL, NULL, 14517, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 09:31:54', 'admin-1510535091-15105367141025120', 1, 0, '', NULL, NULL, NULL),
(53415, '2017-11-13 13:55:53', NULL, NULL, 14525, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 13:55:53', 'admin-1510535091-1510552553021110', 1, 1, 'SR', NULL, NULL, NULL),
(53416, '2017-11-13 13:55:53', NULL, NULL, 14525, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 13:55:53', 'admin-1510535091-1510552553021110', 1, 0, '', NULL, NULL, NULL),
(53417, '2017-11-13 15:32:53', NULL, NULL, 14527, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 15:32:53', 'admin-1510535091-15105583736147191', 1, 1, 'SR', NULL, NULL, NULL),
(53418, '2017-11-13 13:55:29', NULL, NULL, 14525, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1510535091', 'admin', '2017-11-13 13:55:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53419, '2017-11-13 11:03:13', NULL, NULL, 14520, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1510535091', 'admin', '2017-11-13 11:03:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53420, '2017-11-13 11:03:19', NULL, NULL, 14520, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 11:03:19', 'admin-1510535091-15105421994881693', 1, 1, 'SR', NULL, NULL, NULL),
(53421, '2017-11-13 10:49:22', NULL, NULL, 14518, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 10:49:22', 'admin-1510535091-15105413622239149', 1, 1, 'SR', NULL, NULL, NULL),
(53422, '2017-11-13 13:48:58', NULL, NULL, 14524, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 13:48:58', 'admin-1510535091-15105521378949352', 1, 1, 'SR', NULL, NULL, NULL),
(53423, '2017-11-13 13:48:58', NULL, NULL, 14524, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 13:48:58', 'admin-1510535091-15105521378949352', 1, 1, 'SR', NULL, NULL, NULL),
(53424, '2017-11-13 14:39:19', NULL, NULL, 14524, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 14:39:19', 'admin-1510535091-15105551592364170', 1, 0, '', NULL, NULL, NULL),
(53425, '2017-11-13 14:39:25', NULL, NULL, 14524, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 14:39:25', 'admin-1510535091-15105551655559422', 1, 0, '', NULL, NULL, NULL),
(53426, '2017-11-13 15:32:50', NULL, NULL, 14527, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1510535091', 'admin', '2017-11-13 15:32:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53427, '2017-11-13 14:22:55', NULL, NULL, 14523, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 14:22:55', 'admin-1510535091-15105541748584872', 1, 1, 'SR', NULL, NULL, NULL),
(53428, '2017-11-13 11:26:44', NULL, NULL, 14521, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1510535091', 'admin', '2017-11-13 11:26:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53429, '2017-11-13 11:27:43', NULL, NULL, 14521, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 11:27:43', 'admin-1510535091-15105436629252552', 1, 0, '', NULL, NULL, NULL),
(53430, '2017-11-13 11:27:43', NULL, NULL, 14521, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 11:27:43', 'admin-1510535091-15105436629252552', 1, 0, '', NULL, NULL, NULL),
(53431, '2017-11-13 11:27:43', NULL, NULL, 14521, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 11:27:43', 'admin-1510535091-15105436629252552', 1, 1, 'SR', NULL, NULL, NULL),
(53432, '2017-11-13 11:27:43', NULL, NULL, 14521, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 11:27:43', 'admin-1510535091-15105436629252552', 1, 1, 'SR', NULL, NULL, NULL),
(53433, '2017-11-13 12:20:45', NULL, NULL, 14522, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1510535091', 'admin', '2017-11-13 12:20:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53434, '2017-11-13 12:20:55', NULL, NULL, 14522, 0, 75, '75', 'Meatless Aglio Olio ', 'No garlic', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 12:20:55', 'admin-1510535091-15105468555056568', 1, 0, '', NULL, NULL, NULL),
(53435, '2017-11-13 13:38:01', NULL, NULL, 14523, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 50.76, 0.0000, 0.0000, 50.76, 1, '27', 1, '1510535091', 'admin', '2017-11-13 13:38:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53436, '2017-11-13 13:38:17', NULL, NULL, 14523, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 13:38:17', 'admin-1510535091-15105514976996770', 1, 0, '', NULL, NULL, NULL),
(53437, '2017-11-13 14:22:55', NULL, NULL, 14523, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 14:22:55', 'admin-1510535091-15105541748584872', 1, 1, 'SR', NULL, NULL, NULL),
(53438, '2017-11-13 14:02:08', NULL, NULL, 14526, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 14:02:08', 'admin-1510535091-15105529286708166', 1, 1, 'SR', 1, NULL, '1.0'),
(53439, '2017-11-13 13:55:53', NULL, NULL, 14525, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 13:55:53', 'admin-1510535091-1510552553021110', 1, 1, 'SR', NULL, NULL, NULL),
(53440, '2017-11-13 13:55:53', NULL, NULL, 14525, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 13:55:53', 'admin-1510535091-1510552553021110', 1, 1, 'SR', NULL, NULL, NULL),
(53441, '2017-11-13 13:55:53', NULL, NULL, 14525, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 13:55:53', 'admin-1510535091-1510552553021110', 1, 0, '', NULL, NULL, NULL),
(53442, '2017-11-13 14:37:59', NULL, NULL, 14523, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 14:37:59', 'admin-1510535091-15105550793586095', 1, 0, '', NULL, NULL, NULL),
(53443, '2017-11-13 13:38:52', NULL, NULL, 14523, 0, 182, '117', 'Open Drinks ', 'AMLT 24Cans', 'Cold Drinks', 'Fresh Juice', 1, 453.60, 453.6000, 0.0000, 453.60, 1, '27', 1, '1510535091', 'admin', '2017-11-13 13:38:52', 'admin-1510535091-15105515326464128', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(53444, '2017-11-13 10:53:59', NULL, NULL, 14519, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 10:53:59', 'admin-1510535091-15105416396988827', 1, 1, 'SR', 1, NULL, '10.0'),
(53445, '2017-11-13 10:49:19', NULL, NULL, 14518, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1510535091', 'admin', '2017-11-13 10:49:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53446, '2017-11-13 09:31:54', NULL, NULL, 14517, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 09:31:54', 'admin-1510535091-15105367141025120', 1, 1, 'SR', NULL, NULL, NULL),
(53447, '2017-11-13 09:30:57', NULL, NULL, 14517, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 09:30:57', 'admin-1510535091-15105366574274960', 1, 0, '', NULL, NULL, NULL),
(53448, '2017-11-13 09:30:53', NULL, NULL, 14517, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1510535091', 'admin', '2017-11-13 09:30:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53449, '2017-11-13 09:30:57', NULL, NULL, 14517, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 09:30:57', 'admin-1510535091-15105366574274960', 1, 0, '', NULL, NULL, NULL),
(53450, '2017-11-13 09:05:29', NULL, NULL, 14516, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1510535091', 'admin', '2017-11-13 09:05:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53451, '2017-11-13 09:06:31', NULL, NULL, 14516, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 09:06:31', 'admin-1510535091-15105351915211215', 1, 0, '', NULL, NULL, NULL),
(53452, '2017-11-13 09:06:31', NULL, NULL, 14516, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510535091', 'admin', '2017-11-13 09:06:31', 'admin-1510535091-15105351915211215', 1, 1, 'SR', NULL, NULL, NULL),
(53453, '2017-11-15 11:53:25', NULL, NULL, 14531, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1510707861', 'admin', '2017-11-15 11:53:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53454, '2017-11-15 11:54:30', NULL, NULL, 14531, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 11:54:30', 'admin-1510707861-15107180704192959', 1, 0, '', NULL, NULL, NULL),
(53455, '2017-11-15 11:58:36', NULL, NULL, 14532, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 11:58:36', 'admin-1510707861-15107183157747741', 1, 0, '', NULL, NULL, NULL),
(53456, '2017-11-15 12:39:18', NULL, NULL, 14536, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:39:18', 'admin-1510707861-15107207577933781', 1, 1, 'SR', NULL, NULL, NULL),
(53457, '2017-11-15 16:48:01', NULL, NULL, 14543, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 16:48:01', 'admin-1510707861-15107356812146590', 1, 0, '', NULL, NULL, NULL),
(53458, '2017-11-15 16:48:01', NULL, NULL, 14543, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 16:48:01', 'admin-1510707861-15107356812146590', 1, 0, '', NULL, NULL, NULL),
(53459, '2017-11-15 15:38:56', NULL, NULL, 14542, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 15:38:56', 'admin-1510707861-15107315366427934', 1, 0, '', NULL, NULL, NULL),
(53460, '2017-11-15 11:54:30', NULL, NULL, 14531, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 11:54:30', 'admin-1510707861-15107180704192959', 1, 0, '', NULL, NULL, NULL),
(53461, '2017-11-15 11:54:30', NULL, NULL, 14531, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 11:54:30', 'admin-1510707861-15107180704192959', 1, 1, 'SR', NULL, NULL, NULL),
(53462, '2017-11-15 12:39:18', NULL, NULL, 14536, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:39:18', 'admin-1510707861-15107207577933781', 1, 0, '', NULL, NULL, NULL),
(53463, '2017-11-15 12:41:49', NULL, NULL, 14537, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:41:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53464, '2017-11-15 12:42:10', NULL, NULL, 14537, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:42:10', 'admin-1510707861-1510720930547744', 1, 0, '', NULL, NULL, NULL),
(53465, '2017-11-15 12:42:10', NULL, NULL, 14537, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:42:10', 'admin-1510707861-1510720930547744', 1, 0, '', NULL, NULL, NULL),
(53466, '2017-11-15 12:32:38', NULL, NULL, 14535, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:32:38', 'admin-1510707861-15107203579974265', 1, 1, 'SR', NULL, NULL, NULL),
(53467, '2017-11-15 12:32:38', NULL, NULL, 14535, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:32:38', 'admin-1510707861-15107203579974265', 1, 0, '', NULL, NULL, NULL),
(53468, '2017-11-15 12:28:15', NULL, NULL, 14534, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:28:15', 'admin-1510707861-15107200948298453', 1, 1, 'SR', NULL, NULL, NULL),
(53469, '2017-11-15 12:28:15', NULL, NULL, 14534, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:28:15', 'admin-1510707861-15107200948298453', 1, 1, 'SR', NULL, NULL, NULL),
(53470, '2017-11-15 12:31:44', NULL, NULL, 14535, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.39, 0.0000, 0.0000, 8.39, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:31:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53471, '2017-11-15 12:32:38', NULL, NULL, 14535, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:32:38', 'admin-1510707861-15107203579974265', 1, 0, '', NULL, NULL, NULL),
(53472, '2017-11-15 10:29:41', NULL, NULL, 14530, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 10:29:41', 'admin-1510707861-15107129816917731', 1, 1, 'SR', NULL, NULL, NULL),
(53473, '2017-11-15 10:29:41', NULL, NULL, 14530, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 10:29:41', 'admin-1510707861-15107129816917731', 1, 0, '', NULL, NULL, NULL),
(53474, '2017-11-15 13:48:11', NULL, NULL, 14540, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 13:48:11', 'admin-1510707861-15107248910861069', 1, 0, '', 1, NULL, NULL),
(53475, '2017-11-15 10:29:41', NULL, NULL, 14530, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 10:29:41', 'admin-1510707861-15107129816917731', 1, 0, '', NULL, NULL, NULL),
(53476, '2017-11-15 13:13:18', NULL, NULL, 14535, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 13:13:18', 'admin-1510707861-15107227985141188', 1, 1, 'SR', NULL, NULL, NULL),
(53477, '2017-11-15 11:58:36', NULL, NULL, 14532, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 11:58:36', 'admin-1510707861-15107183157747741', 1, 0, '', NULL, NULL, NULL),
(53478, '2017-11-15 15:10:11', NULL, NULL, 14541, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 15:10:11', 'admin-1510707861-15107298114997963', 1, 0, '', NULL, NULL, NULL),
(53479, '2017-11-15 15:38:48', NULL, NULL, 14542, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 15:38:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53480, '2017-11-15 13:28:12', NULL, NULL, 14539, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 13:28:12', 'admin-1510707861-15107236920018649', 1, 1, 'SR', NULL, NULL, NULL),
(53481, '2017-11-15 12:43:36', NULL, NULL, 14535, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:43:36', 'admin-1510707861-15107210160053262', 1, 0, '', NULL, NULL, NULL),
(53482, '2017-11-15 12:51:04', NULL, NULL, 14536, 0, 301, '237', 'Black Jack', '', 'Cold Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:51:04', 'admin-1510707861-15107214639269721', 1, 0, '', NULL, NULL, NULL),
(53483, '2017-11-15 12:59:21', NULL, NULL, 14538, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:59:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53484, '2017-11-15 12:59:40', NULL, NULL, 14538, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:59:40', 'admin-1510707861-15107219800516038', 1, 1, 'SR', NULL, NULL, NULL),
(53485, '2017-11-15 12:59:40', NULL, NULL, 14538, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:59:40', 'admin-1510707861-15107219800516038', 1, 0, '', NULL, NULL, NULL),
(53486, '2017-11-15 16:47:54', NULL, NULL, 14543, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 16:47:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53487, '2017-11-15 15:38:56', NULL, NULL, 14542, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 15:38:56', 'admin-1510707861-15107315366427934', 1, 1, 'SR', NULL, NULL, NULL),
(53488, '2017-11-15 12:39:10', NULL, NULL, 14536, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:39:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53489, '2017-11-15 12:32:38', NULL, NULL, 14535, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:32:38', 'admin-1510707861-15107203579974265', 1, 1, 'SR', NULL, NULL, NULL),
(53490, '2017-11-15 12:32:38', NULL, NULL, 14535, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:32:38', 'admin-1510707861-15107203579974265', 1, 1, 'SR', NULL, NULL, NULL),
(53491, '2017-11-15 09:41:55', NULL, NULL, 14529, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1510707861', 'admin', '2017-11-15 09:41:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53492, '2017-11-15 14:32:36', NULL, NULL, 14541, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1510707861', 'admin', '2017-11-15 14:32:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53493, '2017-11-15 14:32:41', NULL, NULL, 14541, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 14:32:41', 'admin-1510707861-15107275608252869', 1, 0, '', NULL, NULL, NULL),
(53494, '2017-11-15 13:28:03', NULL, NULL, 14539, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1510707861', 'admin', '2017-11-15 13:28:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53495, '2017-11-15 13:01:04', NULL, NULL, 14538, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 13:01:04', 'admin-1510707861-15107220639156589', 1, 1, 'SR', NULL, NULL, NULL),
(53496, '2017-11-15 13:08:49', NULL, NULL, 14538, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 13:08:49', 'admin-1510707861-15107225296881297', 1, 0, '', NULL, NULL, NULL),
(53497, '2017-11-15 12:28:15', NULL, NULL, 14534, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:28:15', 'admin-1510707861-15107200948298453', 1, 1, 'SR', NULL, NULL, NULL),
(53498, '2017-11-15 12:03:36', NULL, NULL, 14533, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:03:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53499, '2017-11-15 12:03:51', NULL, NULL, 14533, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:03:51', 'admin-1510707861-15107186317424064', 1, 0, '', NULL, NULL, NULL),
(53500, '2017-11-15 12:03:51', NULL, NULL, 14533, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:03:51', 'admin-1510707861-15107186317424064', 1, 0, '', NULL, NULL, NULL),
(53501, '2017-11-15 13:00:55', NULL, NULL, 14538, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 13:00:55', 'admin-1510707861-15107220550173324', 1, 1, 'SR', NULL, NULL, NULL),
(53502, '2017-11-15 12:28:15', NULL, NULL, 14534, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:28:15', 'admin-1510707861-15107200948298453', 1, 1, 'SR', NULL, NULL, NULL),
(53503, '2017-11-15 09:04:32', NULL, NULL, 14528, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1510707861', 'admin', '2017-11-15 09:04:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53504, '2017-11-15 12:42:10', NULL, NULL, 14537, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:42:10', 'admin-1510707861-1510720930547744', 1, 1, 'SR', NULL, NULL, NULL),
(53505, '2017-11-15 12:28:14', NULL, NULL, 14534, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:28:14', 'admin-1510707861-15107200948298453', 1, 0, '', NULL, NULL, NULL),
(53506, '2017-11-15 12:27:43', NULL, NULL, 14534, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:27:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53507, '2017-11-15 12:03:51', NULL, NULL, 14533, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:03:51', 'admin-1510707861-15107186317424064', 1, 0, '', NULL, NULL, NULL),
(53508, '2017-11-15 09:42:02', NULL, NULL, 14529, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 09:42:02', 'admin-1510707861-1510710122404564', 1, 0, '', NULL, NULL, NULL),
(53509, '2017-11-15 09:42:02', NULL, NULL, 14529, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 09:42:02', 'admin-1510707861-1510710122404564', 1, 1, 'SR', NULL, NULL, NULL),
(53510, '2017-11-15 10:29:14', NULL, NULL, 14530, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1510707861', 'admin', '2017-11-15 10:29:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53511, '2017-11-15 11:58:36', NULL, NULL, 14532, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 11:58:36', 'admin-1510707861-15107183157747741', 1, 0, '', NULL, NULL, NULL),
(53512, '2017-11-15 11:54:30', NULL, NULL, 14531, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 11:54:30', 'admin-1510707861-15107180704192959', 1, 1, 'SR', NULL, NULL, NULL),
(53513, '2017-11-15 11:58:24', NULL, NULL, 14532, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1510707861', 'admin', '2017-11-15 11:58:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53514, '2017-11-15 11:58:35', NULL, NULL, 14532, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 11:58:35', 'admin-1510707861-15107183157747741', 1, 0, '', NULL, NULL, NULL),
(53515, '2017-11-15 12:39:18', NULL, NULL, 14536, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 12:39:18', 'admin-1510707861-15107207577933781', 1, 0, '', NULL, NULL, NULL),
(53516, '2017-11-15 10:33:32', NULL, NULL, 14530, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 10:33:32', 'admin-1510707861-15107132120327645', 1, 1, 'SR', NULL, NULL, NULL),
(53517, '2017-11-15 10:33:32', NULL, NULL, 14530, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 10:33:32', 'admin-1510707861-15107132120327645', 1, 1, 'SR', NULL, NULL, NULL),
(53518, '2017-11-15 09:30:43', NULL, NULL, 14528, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 09:30:43', 'admin-1510707861-15107094432052388', 1, 0, '', NULL, NULL, NULL),
(53519, '2017-11-15 09:30:43', NULL, NULL, 14528, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 09:30:43', 'admin-1510707861-15107094432052388', 1, 1, 'SR', NULL, NULL, NULL),
(53520, '2017-11-15 09:04:54', NULL, NULL, 14528, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 09:04:54', 'admin-1510707861-15107078940353998', 1, 0, '', NULL, NULL, NULL),
(53521, '2017-11-15 09:07:12', NULL, NULL, 14528, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 09:07:12', 'admin-1510707861-15107080327944053', 1, 0, '', NULL, NULL, NULL),
(53522, '2017-11-15 09:07:12', NULL, NULL, 14528, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 09:07:12', 'admin-1510707861-15107080327944053', 1, 0, '', NULL, NULL, NULL),
(53523, '2017-11-15 09:04:54', NULL, NULL, 14528, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 09:04:54', 'admin-1510707861-15107078940353998', 1, 0, '', NULL, NULL, NULL),
(53524, '2017-11-15 09:04:54', NULL, NULL, 14528, 0, 181, '116', 'Open Food ', 'junior blt', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 09:04:54', 'admin-1510707861-15107078940353998', 1, 0, '', NULL, NULL, NULL),
(53525, '2017-11-15 09:04:54', NULL, NULL, 14528, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510707861', 'admin', '2017-11-15 09:04:54', 'admin-1510707861-15107078940353998', 1, 1, 'SR', NULL, NULL, NULL),
(53526, '2017-11-16 14:48:22', NULL, NULL, 14554, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 14:48:22', 'admin-1510794028-1510814902062358', 1, 0, '', NULL, NULL, NULL),
(53527, '2017-11-16 14:48:22', NULL, NULL, 14554, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 14:48:22', 'admin-1510794028-1510814902062358', 1, 1, 'SR', NULL, NULL, NULL),
(53528, '2017-11-16 16:08:03', NULL, NULL, 14555, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1510794028', 'admin', '2017-11-16 16:08:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53529, '2017-11-16 16:08:10', NULL, NULL, 14555, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 16:08:10', 'admin-1510794028-15108196904072321', 1, 1, 'SR', NULL, NULL, NULL),
(53530, '2017-11-16 16:08:10', NULL, NULL, 14555, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 16:08:10', 'admin-1510794028-15108196904072321', 1, 1, 'SR', NULL, NULL, NULL),
(53531, '2017-11-16 11:54:58', NULL, NULL, 14549, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 11:54:58', 'admin-1510794028-15108044981847930', 1, 1, 'SR', NULL, NULL, NULL),
(53532, '2017-11-16 10:27:31', NULL, NULL, 14547, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 10:27:31', 'admin-1510794028-15107992517449776', 1, 0, '', NULL, NULL, NULL),
(53533, '2017-11-16 10:27:31', NULL, NULL, 14547, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 10:27:31', 'admin-1510794028-15107992517449776', 1, 0, '', NULL, NULL, NULL),
(53534, '2017-11-16 13:25:43', NULL, NULL, 14551, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 13:25:43', 'admin-1510794028-15108099438123822', 1, 1, 'SR', NULL, NULL, NULL),
(53535, '2017-11-16 13:25:44', NULL, NULL, 14551, 0, 181, '116', 'Open Food ', 'fried dumpling 5pcs', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 13:25:44', 'admin-1510794028-15108099438123822', 1, 0, '', NULL, NULL, NULL),
(53536, '2017-11-16 13:25:44', NULL, NULL, 14551, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 13:25:44', 'admin-1510794028-15108099438123822', 1, 0, '', NULL, NULL, NULL),
(53537, '2017-11-16 13:25:44', NULL, NULL, 14551, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 13:25:44', 'admin-1510794028-15108099438123822', 1, 1, 'SR', NULL, NULL, NULL),
(53538, '2017-11-16 10:29:53', NULL, NULL, 14546, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 10:29:53', 'admin-1510794028-15107993934308151', 1, 0, '', NULL, NULL, NULL),
(53539, '2017-11-16 16:47:30', NULL, NULL, 14556, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1510794028', 'admin', '2017-11-16 16:47:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53540, '2017-11-16 14:01:54', NULL, NULL, 14553, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 14:01:54', 'admin-1510794028-1510812114265876', 1, 1, 'SR', NULL, NULL, NULL),
(53541, '2017-11-16 14:48:15', NULL, NULL, 14554, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1510794028', 'admin', '2017-11-16 14:48:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53542, '2017-11-16 14:48:22', NULL, NULL, 14554, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 14:48:22', 'admin-1510794028-1510814902062358', 1, 0, '', NULL, NULL, NULL),
(53543, '2017-11-16 11:09:27', NULL, NULL, 14547, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 11:09:27', 'admin-1510794028-15108017671043752', 1, 1, 'SR', NULL, NULL, NULL),
(53544, '2017-11-16 11:09:35', NULL, NULL, 14547, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 11:09:35', 'admin-1510794028-15108017756547054', 1, 0, '', NULL, NULL, NULL),
(53545, '2017-11-16 11:09:35', NULL, NULL, 14547, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 11:09:35', 'admin-1510794028-15108017756547054', 1, 0, '', NULL, NULL, NULL),
(53546, '2017-11-16 11:53:31', NULL, NULL, 14549, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1510794028', 'admin', '2017-11-16 11:53:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53547, '2017-11-16 16:47:36', NULL, NULL, 14556, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 16:47:36', 'admin-1510794028-15108220558886694', 1, 1, 'SR', NULL, NULL, NULL),
(53548, '2017-11-16 16:54:21', NULL, NULL, 14557, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1510794028', 'admin', '2017-11-16 16:54:21', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(53549, '2017-11-16 16:54:28', NULL, NULL, 14557, 0, 301, '237', 'Black Jack', '', 'Cold Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 16:54:28', 'admin-1510794028-1510822468534482', 1, 0, '', NULL, NULL, '10.0'),
(53550, '2017-11-16 12:23:43', NULL, NULL, 14549, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 12:23:43', 'admin-1510794028-15108062238802160', 1, 1, 'SR', NULL, NULL, NULL),
(53551, '2017-11-16 14:01:54', NULL, NULL, 14553, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 14:01:54', 'admin-1510794028-1510812114265876', 1, 1, 'SR', NULL, NULL, NULL),
(53552, '2017-11-16 14:01:54', NULL, NULL, 14553, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 14:01:54', 'admin-1510794028-1510812114265876', 1, 1, 'SR', NULL, NULL, NULL),
(53553, '2017-11-16 14:01:43', NULL, NULL, 14553, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1510794028', 'admin', '2017-11-16 14:01:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53554, '2017-11-16 13:35:25', NULL, NULL, 14552, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 13:35:25', 'admin-1510794028-15108105253454742', 1, 1, 'SR', NULL, NULL, NULL),
(53555, '2017-11-16 13:35:25', NULL, NULL, 14552, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 13:35:25', 'admin-1510794028-15108105253454742', 1, 1, 'SR', NULL, NULL, NULL),
(53556, '2017-11-16 13:35:13', NULL, NULL, 14552, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1510794028', 'admin', '2017-11-16 13:35:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53557, '2017-11-16 13:35:25', NULL, NULL, 14552, 0, 215, '149', 'Thai Fish Sauce Garlic Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 13:35:25', 'admin-1510794028-15108105253454742', 1, 0, '', NULL, NULL, NULL),
(53558, '2017-11-16 13:25:44', NULL, NULL, 14551, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 13:25:44', 'admin-1510794028-15108099438123822', 1, 1, 'SR', NULL, NULL, NULL),
(53559, '2017-11-16 09:46:26', NULL, NULL, 14544, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 09:46:26', 'admin-1510794028-1510796786513651', 1, 0, '', NULL, NULL, NULL),
(53560, '2017-11-16 13:23:03', NULL, NULL, 14551, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 13:23:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53561, '2017-11-16 13:25:43', NULL, NULL, 14551, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 13:25:43', 'admin-1510794028-15108099438123822', 1, 1, 'SR', NULL, NULL, NULL),
(53562, '2017-11-16 12:04:42', NULL, NULL, 14550, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 12:04:42', 'admin-1510794028-15108050823512662', 1, 1, 'SR', NULL, NULL, NULL),
(53563, '2017-11-16 12:04:42', NULL, NULL, 14550, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 12:04:42', 'admin-1510794028-15108050823512662', 1, 0, '', NULL, NULL, NULL),
(53564, '2017-11-16 12:04:42', NULL, NULL, 14550, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 12:04:42', 'admin-1510794028-15108050823512662', 1, 1, 'SR', NULL, NULL, NULL),
(53565, '2017-11-16 12:04:21', NULL, NULL, 14550, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1510794028', 'admin', '2017-11-16 12:04:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53566, '2017-11-16 12:04:42', NULL, NULL, 14550, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 12:04:42', 'admin-1510794028-15108050823512662', 1, 0, '', NULL, NULL, NULL),
(53567, '2017-11-16 11:54:58', NULL, NULL, 14549, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 11:54:58', 'admin-1510794028-15108044981847930', 1, 1, 'SR', NULL, NULL, NULL),
(53568, '2017-11-16 10:29:53', NULL, NULL, 14546, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 10:29:53', 'admin-1510794028-15107993934308151', 1, 0, '', NULL, NULL, NULL),
(53569, '2017-11-16 10:29:53', NULL, NULL, 14546, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 10:29:53', 'admin-1510794028-15107993934308151', 1, 1, 'SR', NULL, NULL, NULL),
(53570, '2017-11-16 10:39:28', NULL, NULL, 14548, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 10:39:28', 'admin-1510794028-1510799968468571', 1, 1, 'SR', 1, NULL, '1.0'),
(53571, '2017-11-16 11:09:27', NULL, NULL, 14547, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 11:09:27', 'admin-1510794028-15108017671043752', 1, 0, '', NULL, NULL, NULL),
(53572, '2017-11-16 10:27:31', NULL, NULL, 14547, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 10:27:31', 'admin-1510794028-15107992517449776', 1, 0, '', NULL, NULL, NULL),
(53573, '2017-11-16 10:27:31', NULL, NULL, 14547, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 10:27:31', 'admin-1510794028-15107992517449776', 1, 0, '', NULL, NULL, NULL),
(53574, '2017-11-16 12:23:44', NULL, NULL, 14549, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 12:23:44', 'admin-1510794028-15108062238802160', 1, 1, 'SR', NULL, NULL, NULL),
(53575, '2017-11-16 10:09:47', NULL, NULL, 14545, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 10:09:47', 'admin-1510794028-1510798187796611', 1, 0, '', NULL, NULL, NULL),
(53576, '2017-11-16 10:27:02', NULL, NULL, 14547, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.10, 0.0000, 0.0000, 10.10, 1, '27', 1, '1510794028', 'admin', '2017-11-16 10:27:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53577, '2017-11-16 09:45:38', NULL, NULL, 14544, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 09:45:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53578, '2017-11-16 09:46:26', NULL, NULL, 14544, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 09:46:26', 'admin-1510794028-1510796786513651', 1, 0, '', NULL, NULL, NULL),
(53579, '2017-11-16 10:24:05', NULL, NULL, 14546, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1510794028', 'admin', '2017-11-16 10:24:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53580, '2017-11-16 10:09:47', NULL, NULL, 14545, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 10:09:47', 'admin-1510794028-1510798187796611', 1, 0, '', NULL, NULL, NULL),
(53581, '2017-11-16 10:07:46', NULL, NULL, 14545, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1510794028', 'admin', '2017-11-16 10:07:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53582, '2017-11-16 09:46:26', NULL, NULL, 14544, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 09:46:26', 'admin-1510794028-1510796786513651', 1, 1, 'SR', NULL, NULL, NULL),
(53583, '2017-11-16 09:46:26', NULL, NULL, 14544, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510794028', 'admin', '2017-11-16 09:46:26', 'admin-1510794028-1510796786513651', 1, 1, 'SR', NULL, NULL, NULL),
(53584, '2017-11-17 10:56:12', NULL, NULL, 14564, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:56:12', 'admin-1510880695-15108873724999247', 1, 0, '', NULL, NULL, NULL),
(53585, '2017-11-17 10:56:12', NULL, NULL, 14564, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:56:12', 'admin-1510880695-15108873724999247', 1, 1, 'SR', NULL, NULL, NULL),
(53586, '2017-11-17 10:38:22', NULL, NULL, 14561, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:38:22', 'admin-1510880695-1510886302834592', 1, 1, 'SR', NULL, NULL, NULL),
(53587, '2017-11-17 10:38:22', NULL, NULL, 14561, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:38:22', 'admin-1510880695-1510886302834592', 1, 1, 'SR', NULL, NULL, NULL),
(53588, '2017-11-17 12:42:41', NULL, NULL, 14568, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 12:42:41', 'admin-1510880695-15108937614553267', 1, 1, 'SR', NULL, NULL, NULL),
(53589, '2017-11-17 00:00:00', NULL, NULL, 14574, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 13:15:28', 'admin-1510880695-15108957283724694', 1, 0, '', NULL, NULL, NULL),
(53590, '2017-11-17 10:56:12', NULL, NULL, 14564, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:56:12', 'admin-1510880695-15108873724999247', 1, 0, '', NULL, NULL, NULL),
(53591, '2017-11-17 10:56:12', NULL, NULL, 14564, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:56:12', 'admin-1510880695-15108873724999247', 1, 0, '', NULL, NULL, NULL),
(53592, '2017-11-17 10:57:48', NULL, NULL, 14565, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:57:48', 'admin-1510880695-15108874688327612', 1, 0, '', NULL, NULL, NULL),
(53593, '2017-11-17 10:57:48', NULL, NULL, 14565, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:57:48', 'admin-1510880695-15108874688327612', 1, 0, '', NULL, NULL, NULL),
(53594, '2017-11-17 13:44:30', NULL, NULL, 14572, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 13:44:30', 'admin-1510880695-1510897470224927', 1, 0, '', NULL, NULL, NULL),
(53595, '2017-11-17 13:44:22', NULL, NULL, 14572, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1510880695', 'admin', '2017-11-17 13:44:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53596, '2017-11-17 11:17:51', NULL, NULL, 14566, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 11:17:51', 'admin-1510880695-15108886717015091', 1, 0, '', 1, NULL, NULL),
(53597, '2017-11-17 13:54:52', NULL, NULL, 14573, 0, 181, '116', 'Open Food ', ',add 4 cocktail sausage', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 13:54:53', 'admin-1510880695-15108980928521290', 1, 0, '', NULL, NULL, NULL),
(53598, '2017-11-17 09:12:51', NULL, NULL, 14559, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:12:51', 'admin-1510880695-15108811717355435', 1, 1, 'SR', NULL, NULL, NULL),
(53599, '2017-11-17 09:26:40', NULL, NULL, 14560, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.60, 0.0000, 0.0000, 11.60, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:26:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53600, '2017-11-17 09:26:57', NULL, NULL, 14560, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:26:57', 'admin-1510880695-15108820174229968', 1, 0, '', NULL, NULL, NULL),
(53601, '2017-11-17 14:38:13', NULL, NULL, 14576, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 14:38:13', 'admin-1510880695-15109006936359873', 1, 0, '', NULL, NULL, NULL),
(53602, '2017-11-17 14:38:13', NULL, NULL, 14576, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 14:38:13', 'admin-1510880695-15109006936359873', 1, 0, '', NULL, NULL, NULL),
(53603, '2017-11-17 14:38:13', NULL, NULL, 14576, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 14:38:13', 'admin-1510880695-15109006936359873', 1, 1, 'SR', NULL, NULL, NULL),
(53604, '2017-11-17 17:12:50', NULL, NULL, 14579, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 17:12:50', 'admin-1510880695-15109099701981786', 1, 1, 'SR', NULL, NULL, NULL),
(53605, '2017-11-17 17:11:42', NULL, NULL, 14579, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 17:11:42', 'admin-1510880695-15109099020403337', 1, 1, 'SR', NULL, NULL, NULL),
(53606, '2017-11-17 17:11:42', NULL, NULL, 14579, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 17:11:42', 'admin-1510880695-15109099020403337', 1, 1, 'SR', NULL, NULL, NULL),
(53607, '2017-11-17 17:10:35', NULL, NULL, 14579, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1510880695', 'admin', '2017-11-17 17:10:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53608, '2017-11-17 17:11:42', NULL, NULL, 14579, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 17:11:42', 'admin-1510880695-15109099020403337', 1, 0, '', NULL, NULL, NULL),
(53609, '2017-11-17 12:08:21', NULL, NULL, 14568, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1510880695', 'admin', '2017-11-17 12:08:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53610, '2017-11-17 11:41:55', NULL, NULL, 14567, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 11:41:55', 'admin-1510880695-1510890115010425', 1, 1, 'SR', NULL, NULL, NULL),
(53611, '2017-11-17 11:41:55', NULL, NULL, 14567, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 11:41:55', 'admin-1510880695-1510890115010425', 1, 1, 'SR', NULL, NULL, NULL),
(53612, '2017-11-17 17:05:43', NULL, NULL, 14578, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1510880695', 'admin', '2017-11-17 17:05:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53613, '2017-11-17 11:41:55', NULL, NULL, 14567, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 11:41:55', 'admin-1510880695-1510890115010425', 1, 1, 'SR', NULL, NULL, NULL),
(53614, '2017-11-17 09:48:45', NULL, NULL, 14559, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:48:45', 'admin-1510880695-15108833250596974', 1, 1, 'SR', NULL, NULL, NULL),
(53615, '2017-11-17 09:50:49', NULL, NULL, 14559, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:50:49', 'admin-1510880695-15108834496354244', 1, 1, 'SR', NULL, NULL, NULL),
(53616, '2017-11-17 10:02:10', NULL, NULL, 14559, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:02:10', 'admin-1510880695-1510884130701113', 1, 1, 'SR', NULL, NULL, NULL),
(53617, '2017-11-17 10:04:30', NULL, NULL, 14558, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:04:30', 'admin-1510880695-15108842707149910', 1, 1, 'SR', NULL, NULL, NULL),
(53618, '2017-11-17 10:06:06', NULL, NULL, 14558, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:06:06', 'admin-1510880695-15108843661484140', 1, 0, '', NULL, NULL, NULL),
(53619, '2017-11-17 00:00:00', NULL, NULL, 14571, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 12:08:42', 'admin-1510880695-1510891722787989', 1, 1, 'SR', NULL, NULL, NULL),
(53620, '2017-11-17 16:05:06', NULL, NULL, 14577, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 16:05:06', 'admin-1510880695-1510905905927806', 1, 1, 'SR', NULL, NULL, NULL),
(53621, '2017-11-17 14:37:58', NULL, NULL, 14576, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1510880695', 'admin', '2017-11-17 14:37:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53622, '2017-11-17 14:05:56', NULL, NULL, 14573, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 14:05:56', 'admin-1510880695-1510898756296913', 1, 1, 'SR', NULL, NULL, NULL),
(53623, '2017-11-17 00:00:00', NULL, NULL, 14575, 0, 302, '238', 'Ice on the cake', '', 'Desserts', '0', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 13:36:43', 'admin-1510880695-1510897002967413', 1, 0, '', NULL, NULL, NULL),
(53624, '2017-11-17 00:00:00', NULL, NULL, 14575, 0, 302, '238', 'Ice on the cake', '', 'Desserts', '0', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 13:47:11', 'admin-1510880695-15108976308888927', 1, 0, '', NULL, NULL, NULL),
(53625, '2017-11-17 13:53:26', NULL, NULL, 14573, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1510880695', 'admin', '2017-11-17 13:53:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53626, '2017-11-17 11:41:55', NULL, NULL, 14567, 0, 153, '87', 'Wake Me Up!', 'sunnyside up', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 11:41:55', 'admin-1510880695-1510890115010425', 1, 0, '', NULL, NULL, NULL),
(53627, '2017-11-17 11:41:55', NULL, NULL, 14567, 0, 153, '87', 'Wake Me Up!', 'sunnyside up', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 11:41:55', 'admin-1510880695-1510890115010425', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(53628, '2017-11-17 00:00:00', NULL, NULL, 14575, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 13:16:39', 'admin-1510880695-15108957995918635', 1, 1, 'SR', NULL, NULL, NULL),
(53629, '2017-11-17 00:00:00', NULL, NULL, 14575, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 13:16:39', 'admin-1510880695-15108957995918635', 1, 0, '', NULL, NULL, NULL),
(53630, '2017-11-17 00:00:00', NULL, NULL, 14571, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 13:11:58', 'admin-1510880695-15108955183367934', 1, 0, '', NULL, NULL, NULL),
(53631, '2017-11-17 11:41:22', NULL, NULL, 14567, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1510880695', 'admin', '2017-11-17 11:41:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53632, '2017-11-17 00:00:00', NULL, NULL, 14575, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 13:16:39', 'admin-1510880695-15108957995918635', 1, 1, 'SR', NULL, NULL, NULL),
(53633, '2017-11-17 13:59:57', NULL, NULL, 14574, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 13:59:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53634, '2017-11-17 00:00:00', NULL, NULL, 14574, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 13:16:39', 'admin-1510880695-15108957995918635', 1, 1, 'SR', NULL, NULL, NULL),
(53635, '2017-11-17 00:00:00', NULL, NULL, 14574, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 13:15:28', 'admin-1510880695-15108957283724694', 1, 0, '', NULL, NULL, NULL),
(53636, '2017-11-17 10:55:41', NULL, NULL, 14563, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:55:41', 'admin-1510880695-15108873410415976', 1, 1, 'SR', NULL, NULL, NULL),
(53637, '2017-11-17 17:05:46', NULL, NULL, 14578, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 17:05:46', 'admin-1510880695-15109095463713533', 1, 1, 'SR', NULL, NULL, NULL),
(53638, '2017-11-17 00:00:00', NULL, NULL, 14575, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, NULL, NULL, 8.70, 1, '27', 1, '1510880695', 'admin', '2017-11-17 13:15:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53639, '2017-11-17 00:00:00', NULL, NULL, 14574, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 13:16:39', 'admin-1510880695-15108957995918635', 1, 0, '', NULL, NULL, NULL),
(53640, '2017-11-17 00:00:00', NULL, NULL, 14574, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 13:16:39', 'admin-1510880695-15108957995918635', 1, 1, 'SR', NULL, NULL, NULL),
(53641, '2017-11-17 12:54:39', NULL, NULL, 14569, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1510880695', 'admin', '2017-11-17 12:54:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53642, '2017-11-17 12:54:43', NULL, NULL, 14569, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 12:54:43', 'admin-1510880695-15108944838024619', 1, 1, 'SR', NULL, NULL, NULL),
(53643, '2017-11-17 13:11:58', NULL, NULL, 14568, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 13:11:58', 'admin-1510880695-15108955183367934', 1, 1, 'SR', NULL, NULL, NULL),
(53644, '2017-11-17 10:55:41', NULL, NULL, 14563, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:55:41', 'admin-1510880695-15108873410415976', 1, 1, 'SR', NULL, NULL, NULL),
(53645, '2017-11-17 12:08:42', NULL, NULL, 14568, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 12:08:42', 'admin-1510880695-1510891722787989', 1, 1, 'SR', NULL, NULL, NULL),
(53646, '2017-11-17 09:26:57', NULL, NULL, 14560, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:26:57', 'admin-1510880695-15108820174229968', 1, 0, '', NULL, NULL, NULL),
(53647, '2017-11-17 09:26:57', NULL, NULL, 14560, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:26:57', 'admin-1510880695-15108820174229968', 1, 0, '', NULL, NULL, NULL),
(53648, '2017-11-17 09:26:57', NULL, NULL, 14560, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:26:57', 'admin-1510880695-15108820174229968', 1, 0, '', NULL, NULL, NULL),
(53649, '2017-11-17 09:26:57', NULL, NULL, 14560, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:26:57', 'admin-1510880695-15108820174229968', 1, 1, 'SR', NULL, NULL, NULL),
(53650, '2017-11-17 10:57:31', NULL, NULL, 14565, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:57:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53651, '2017-11-17 13:37:08', NULL, NULL, 14571, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1510880695', 'admin', '2017-11-17 13:37:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53652, '2017-11-17 10:57:48', NULL, NULL, 14565, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 2, 16.00, 32.0000, 0.0000, 32.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:57:48', 'admin-1510880695-15108874688327612', 1, 0, '', NULL, NULL, NULL),
(53653, '2017-11-17 10:55:41', NULL, NULL, 14563, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:55:41', 'admin-1510880695-15108873410415976', 1, 1, 'SR', NULL, NULL, NULL),
(53654, '2017-11-17 10:55:41', NULL, NULL, 14563, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:55:41', 'admin-1510880695-15108873410415976', 1, 0, '', NULL, NULL, NULL),
(53655, '2017-11-17 10:55:41', NULL, NULL, 14563, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:55:41', 'admin-1510880695-15108873410415976', 1, 0, '', NULL, NULL, NULL),
(53656, '2017-11-17 10:54:32', NULL, NULL, 14561, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:54:32', 'admin-1510880695-15108872720913391', 1, 1, 'SR', NULL, NULL, NULL),
(53657, '2017-11-17 10:55:29', NULL, NULL, 14563, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:55:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53658, '2017-11-17 09:12:10', NULL, NULL, 14558, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:12:10', 'admin-1510880695-15108811302537022', 1, 1, 'SR', NULL, NULL, NULL),
(53659, '2017-11-17 09:48:29', NULL, NULL, 14560, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:48:29', 'admin-1510880695-15108833096255665', 1, 0, '', NULL, NULL, NULL),
(53660, '2017-11-17 16:05:02', NULL, NULL, 14577, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1510880695', 'admin', '2017-11-17 16:05:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53661, '2017-11-17 00:00:00', NULL, NULL, 14575, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, NULL, NULL, 6.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 13:48:15', 'admin-1510880695-15108976953827527', 1, 1, 'SR', NULL, NULL, NULL),
(53662, '2017-11-17 11:41:55', NULL, NULL, 14567, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 11:41:55', 'admin-1510880695-1510890115010425', 1, 0, '', NULL, NULL, NULL),
(53663, '2017-11-17 13:53:30', NULL, NULL, 14573, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 13:53:30', 'admin-1510880695-15108980106835817', 1, 0, '', NULL, NULL, NULL),
(53664, '2017-11-17 10:57:49', NULL, NULL, 14565, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:57:49', 'admin-1510880695-15108874688327612', 1, 1, 'SR', NULL, NULL, NULL),
(53665, '2017-11-17 10:49:44', NULL, NULL, 14562, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:49:44', 'admin-1510880695-15108869842578046', 1, 0, '', NULL, NULL, NULL),
(53666, '2017-11-17 10:48:18', NULL, NULL, 14562, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:48:18', 'admin-1510880695-15108868987447516', 1, 0, '', NULL, NULL, NULL),
(53667, '2017-11-17 10:49:44', NULL, NULL, 14562, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:49:44', 'admin-1510880695-15108869842578046', 1, 0, '', NULL, NULL, NULL),
(53668, '2017-11-17 10:48:18', NULL, NULL, 14562, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:48:18', 'admin-1510880695-15108868987447516', 1, 0, '', NULL, NULL, NULL),
(53669, '2017-11-17 10:47:11', NULL, NULL, 14562, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:47:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53670, '2017-11-17 10:30:20', NULL, NULL, 14561, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:30:20', 'admin-1510880695-15108858199706740', 1, 0, '', NULL, NULL, NULL),
(53671, '2017-11-17 13:44:30', NULL, NULL, 14572, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 13:44:30', 'admin-1510880695-1510897470224927', 1, 1, 'SR', NULL, NULL, NULL),
(53672, '2017-11-17 10:30:11', NULL, NULL, 14561, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:30:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53673, '2017-11-17 10:30:20', NULL, NULL, 14561, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:30:20', 'admin-1510880695-15108858199706740', 1, 0, '', NULL, NULL, NULL),
(53674, '2017-11-17 10:06:06', NULL, NULL, 14558, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:06:06', 'admin-1510880695-15108843661484140', 1, 1, 'SR', NULL, NULL, NULL),
(53675, '2017-11-17 17:05:46', NULL, NULL, 14578, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 17:05:46', 'admin-1510880695-15109095463713533', 1, 1, 'SR', NULL, NULL, NULL),
(53676, '2017-11-17 10:06:06', NULL, NULL, 14558, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:06:06', 'admin-1510880695-15108843661484140', 1, 0, '', NULL, NULL, NULL),
(53677, '2017-11-17 09:12:15', NULL, NULL, 14559, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.20, 0.0000, 0.0000, 12.20, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:12:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53678, '2017-11-17 09:12:51', NULL, NULL, 14559, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:12:51', 'admin-1510880695-15108811717355435', 1, 0, '', NULL, NULL, NULL),
(53679, '2017-11-17 09:12:51', NULL, NULL, 14559, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:12:51', 'admin-1510880695-15108811717355435', 1, 0, '', NULL, NULL, NULL),
(53680, '2017-11-17 09:12:51', NULL, NULL, 14559, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:12:51', 'admin-1510880695-15108811717355435', 1, 0, '', NULL, NULL, NULL),
(53681, '2017-11-17 09:12:51', NULL, NULL, 14559, 0, 154, '88', 'Daily Dose BLT', 'Change to sausage', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:12:51', 'admin-1510880695-15108811717355435', 1, 0, '', NULL, NULL, NULL),
(53682, '2017-11-17 09:12:51', NULL, NULL, 14559, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:12:51', 'admin-1510880695-15108811717355435', 1, 0, '', NULL, NULL, NULL),
(53683, '2017-11-17 09:12:51', NULL, NULL, 14559, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:12:51', 'admin-1510880695-15108811717355435', 1, 1, 'SR', NULL, NULL, NULL),
(53684, '2017-11-17 10:57:49', NULL, NULL, 14565, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:57:49', 'admin-1510880695-15108874688327612', 1, 1, 'SR', NULL, NULL, NULL),
(53685, '2017-11-17 09:48:29', NULL, NULL, 14560, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:48:29', 'admin-1510880695-15108833096255665', 1, 1, 'SR', NULL, NULL, NULL),
(53686, '2017-11-17 09:31:01', NULL, NULL, 14558, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:31:01', 'admin-1510880695-1510882261155525', 1, 1, 'SR', NULL, NULL, NULL),
(53687, '2017-11-17 09:26:57', NULL, NULL, 14560, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:26:57', 'admin-1510880695-15108820174229968', 1, 0, '', NULL, NULL, NULL),
(53688, '2017-11-17 10:55:51', NULL, NULL, 14564, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1510880695', 'admin', '2017-11-17 10:55:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53689, '2017-11-17 09:12:10', NULL, NULL, 14558, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:12:10', 'admin-1510880695-15108811302537022', 1, 1, 'SR', NULL, NULL, NULL),
(53690, '2017-11-17 09:12:51', NULL, NULL, 14559, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:12:51', 'admin-1510880695-15108811717355435', 1, 1, 'SR', NULL, NULL, NULL),
(53691, '2017-11-17 09:12:10', NULL, NULL, 14558, 0, 270, '204', 'Homemade Savoury Pancake', 'No bacon', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:12:10', 'admin-1510880695-15108811302537022', 1, 0, '', NULL, NULL, NULL),
(53692, '2017-11-17 09:12:10', NULL, NULL, 14558, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:12:10', 'admin-1510880695-15108811302537022', 1, 0, '', NULL, NULL, NULL),
(53693, '2017-11-17 09:12:10', NULL, NULL, 14558, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:12:10', 'admin-1510880695-15108811302537022', 1, 1, 'SR', NULL, NULL, NULL),
(53694, '2017-11-17 09:12:10', NULL, NULL, 14558, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:12:10', 'admin-1510880695-15108811302537022', 1, 1, 'SR', NULL, NULL, NULL),
(53695, '2017-11-17 09:12:10', NULL, NULL, 14558, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:12:10', 'admin-1510880695-15108811302537022', 1, 1, 'SR', NULL, NULL, NULL),
(53696, '2017-11-17 09:12:10', NULL, NULL, 14558, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:12:10', 'admin-1510880695-15108811302537022', 1, 0, '', NULL, NULL, NULL),
(53697, '2017-11-17 09:11:36', NULL, NULL, 14558, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.50, 0.0000, 0.0000, 16.50, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:11:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53698, '2017-11-17 09:12:10', NULL, NULL, 14558, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510880695', 'admin', '2017-11-17 09:12:10', 'admin-1510880695-15108811302537022', 1, 0, '', NULL, NULL, NULL),
(53699, '2017-11-18 14:11:42', NULL, NULL, 14609, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:11:42', 'admin-1510967819-15109855019331859', 1, 1, 'SR', NULL, NULL, NULL),
(53700, '2017-11-18 14:11:42', NULL, NULL, 14609, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:11:42', 'admin-1510967819-15109855019331859', 1, 0, '', NULL, NULL, NULL),
(53701, '2017-11-18 14:11:42', NULL, NULL, 14609, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:11:42', 'admin-1510967819-15109855019331859', 1, 0, '', NULL, NULL, NULL),
(53702, '2017-11-18 14:08:24', NULL, NULL, 14608, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:08:24', 'admin-1510967819-15109853047225886', 1, 0, '', NULL, NULL, NULL),
(53703, '2017-11-18 13:56:51', NULL, NULL, 14607, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:56:51', 'admin-1510967819-15109846114009339', 1, 1, 'SR', NULL, NULL, '10.0'),
(53704, '2017-11-18 11:26:33', NULL, NULL, 14590, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:26:33', 'admin-1510967819-15109755936646916', 1, 0, '', NULL, NULL, NULL),
(53705, '2017-11-18 09:33:57', NULL, NULL, 14581, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 09:33:57', 'admin-1510967819-15109688376695514', 1, 0, '', NULL, NULL, NULL),
(53706, '2017-11-18 09:35:50', NULL, NULL, 14582, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 09:35:50', 'admin-1510967819-15109689498677861', 1, 0, '', NULL, NULL, NULL),
(53707, '2017-11-18 14:49:58', NULL, NULL, 14614, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:49:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53708, '2017-11-18 14:42:39', NULL, NULL, 14606, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:42:39', 'admin-1510967819-1510987359767721', 1, 1, 'SR', NULL, NULL, NULL),
(53709, '2017-11-18 14:42:39', NULL, NULL, 14606, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:42:39', 'admin-1510967819-1510987359767721', 1, 1, 'SR', NULL, NULL, NULL),
(53710, '2017-11-18 14:42:39', NULL, NULL, 14606, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:42:39', 'admin-1510967819-1510987359767721', 1, 1, 'SR', NULL, NULL, NULL),
(53711, '2017-11-18 14:11:10', NULL, NULL, 14609, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:11:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53712, '2017-11-18 14:08:17', NULL, NULL, 14608, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:08:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53713, '2017-11-18 00:00:00', NULL, NULL, 14602, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:41:13', 'admin-1510967819-151098007365328', 1, 1, 'SR', NULL, NULL, NULL),
(53714, '2017-11-18 13:01:21', NULL, NULL, 14599, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:01:21', 'admin-1510967819-15109812814175330', 1, 0, '', NULL, NULL, NULL),
(53715, '2017-11-18 13:47:29', NULL, NULL, 14606, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:47:29', 'admin-1510967819-15109840496358824', 1, 0, '', NULL, NULL, NULL),
(53716, '2017-11-18 13:38:15', NULL, NULL, 14605, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:38:15', 'admin-1510967819-15109834954146014', 1, 0, '', 1, NULL, '1.0'),
(53717, '2017-11-18 00:00:00', NULL, NULL, 14601, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:41:13', 'admin-1510967819-151098007365328', 1, 1, 'SR', NULL, NULL, NULL),
(53718, '2017-11-18 15:12:18', NULL, NULL, 14606, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 15:12:18', 'admin-1510967819-15109891382266233', 1, 1, 'SR', NULL, NULL, NULL),
(53719, '2017-11-18 15:34:28', NULL, NULL, 14614, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 15:34:28', 'admin-1510967819-15109904687578831', 1, 1, 'SR', NULL, NULL, NULL),
(53720, '2017-11-18 12:40:54', NULL, NULL, 14599, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:40:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53721, '2017-11-18 11:47:31', NULL, NULL, 14594, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Rice', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:47:31', 'admin-1510967819-15109768516482727', 1, 0, '', NULL, NULL, NULL),
(53722, '2017-11-18 12:13:30', NULL, NULL, 14596, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:13:30', 'admin-1510967819-15109784103225658', 1, 0, '', NULL, NULL, NULL),
(53723, '2017-11-18 12:13:30', NULL, NULL, 14596, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:13:30', 'admin-1510967819-15109784103225658', 1, 1, 'SR', NULL, NULL, NULL),
(53724, '2017-11-18 16:02:03', NULL, NULL, 14616, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 16:02:03', 'admin-1510967819-1510992123501944', 1, 0, '', NULL, NULL, NULL),
(53725, '2017-11-18 16:02:03', NULL, NULL, 14616, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 16:02:03', 'admin-1510967819-1510992123501944', 1, 0, '', NULL, NULL, NULL),
(53726, '2017-11-18 14:26:09', NULL, NULL, 14610, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:26:09', 'admin-1510967819-15109863692012788', 1, 1, 'SR', 1, NULL, NULL),
(53727, '2017-11-18 14:26:09', NULL, NULL, 14610, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:26:09', 'admin-1510967819-15109863692012788', 1, 0, '', 1, NULL, NULL),
(53728, '2017-11-18 14:34:28', NULL, NULL, 14611, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:34:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53729, '2017-11-18 13:55:23', NULL, NULL, 14607, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:55:23', 'admin-1510967819-15109845235832938', 1, 1, 'SR', NULL, NULL, '10.0'),
(53730, '2017-11-18 14:42:49', NULL, NULL, 14613, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:42:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53731, '2017-11-18 14:43:00', NULL, NULL, 14613, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:43:00', 'admin-1510967819-15109873808311462', 1, 0, '', NULL, NULL, NULL),
(53732, '2017-11-18 16:02:03', NULL, NULL, 14616, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 16:02:03', 'admin-1510967819-1510992123501944', 1, 1, 'SR', NULL, NULL, NULL),
(53733, '2017-11-18 16:02:03', NULL, NULL, 14616, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 16:02:03', 'admin-1510967819-1510992123501944', 1, 1, 'SR', NULL, NULL, NULL),
(53734, '2017-11-18 14:37:04', NULL, NULL, 14612, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:37:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53735, '2017-11-18 16:02:03', NULL, NULL, 14616, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 16:02:03', 'admin-1510967819-1510992123501944', 1, 0, '', NULL, NULL, NULL),
(53736, '2017-11-18 14:34:41', NULL, NULL, 14611, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:34:41', 'admin-1510967819-1510986881025447', 1, 1, 'SR', NULL, NULL, NULL),
(53737, '2017-11-18 15:59:29', NULL, NULL, 14616, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1510967819', 'admin', '2017-11-18 15:59:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53738, '2017-11-18 14:58:40', NULL, NULL, 14615, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:58:40', 'admin-1510967819-151098832049461', 1, 0, '', NULL, NULL, NULL),
(53739, '2017-11-18 14:53:50', NULL, NULL, 14615, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:53:50', 'admin-1510967819-15109880300072532', 1, 1, 'SR', NULL, NULL, NULL),
(53740, '2017-11-18 14:53:50', NULL, NULL, 14615, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:53:50', 'admin-1510967819-15109880300072532', 1, 1, 'SR', NULL, NULL, NULL),
(53741, '2017-11-18 14:53:50', NULL, NULL, 14615, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:53:50', 'admin-1510967819-15109880300072532', 1, 0, '', NULL, NULL, NULL),
(53742, '2017-11-18 14:50:12', NULL, NULL, 14614, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:50:12', 'admin-1510967819-15109878124483753', 1, 0, '', NULL, NULL, NULL),
(53743, '2017-11-18 14:53:29', NULL, NULL, 14615, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:53:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53744, '2017-11-18 14:50:12', NULL, NULL, 14614, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:50:12', 'admin-1510967819-15109878124483753', 1, 1, 'SR', NULL, NULL, NULL),
(53745, '2017-11-18 14:50:12', NULL, NULL, 14614, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:50:12', 'admin-1510967819-15109878124483753', 1, 1, 'SR', NULL, NULL, NULL),
(53746, '2017-11-18 00:00:00', NULL, NULL, 14603, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:05:40', 'admin-1510967819-15109815407959478', 1, 1, 'SR', NULL, NULL, NULL),
(53747, '2017-11-18 00:00:00', NULL, NULL, 14604, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:11:12', 'admin-1510967819-15109818720931366', 1, 0, '', NULL, NULL, NULL),
(53748, '2017-11-18 00:00:00', NULL, NULL, 14600, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:52:21', 'admin-1510967819-15109807416977015', 1, 0, '', NULL, NULL, NULL),
(53749, '2017-11-18 14:11:55', NULL, NULL, 14608, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:11:55', 'admin-1510967819-15109855154424257', 1, 1, 'SR', NULL, NULL, NULL),
(53750, '2017-11-18 14:43:00', NULL, NULL, 14613, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:43:00', 'admin-1510967819-15109873808311462', 1, 1, 'SR', NULL, NULL, NULL),
(53751, '2017-11-18 14:43:00', NULL, NULL, 14613, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:43:00', 'admin-1510967819-15109873808311462', 1, 1, 'SR', NULL, NULL, NULL),
(53752, '2017-11-18 14:37:16', NULL, NULL, 14612, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:37:16', 'admin-1510967819-15109870364888572', 1, 1, 'SR', NULL, NULL, NULL),
(53753, '2017-11-18 13:55:23', NULL, NULL, 14607, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:55:23', 'admin-1510967819-15109845235832938', 1, 0, '', NULL, NULL, '10.0'),
(53754, '2017-11-18 16:02:03', NULL, NULL, 14616, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 16:02:03', 'admin-1510967819-1510992123501944', 1, 1, 'SR', NULL, NULL, NULL),
(53755, '2017-11-18 14:37:16', NULL, NULL, 14612, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:37:16', 'admin-1510967819-15109870364888572', 1, 0, '', NULL, NULL, NULL),
(53756, '2017-11-18 14:34:41', NULL, NULL, 14611, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:34:41', 'admin-1510967819-1510986881025447', 1, 0, '', NULL, NULL, NULL),
(53757, '2017-11-18 14:11:55', NULL, NULL, 14608, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:11:55', 'admin-1510967819-15109855154424257', 1, 1, 'SR', NULL, NULL, NULL),
(53758, '2017-11-18 14:14:47', NULL, NULL, 14608, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:14:47', 'admin-1510967819-15109856874798928', 1, 1, 'SR', NULL, NULL, NULL),
(53759, '2017-11-18 11:38:08', NULL, NULL, 14592, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:38:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53760, '2017-11-18 13:55:23', NULL, NULL, 14607, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:55:23', 'admin-1510967819-15109845235832938', 1, 1, 'SR', NULL, NULL, '10.0'),
(53761, '2017-11-18 13:54:56', NULL, NULL, 14607, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:54:56', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(53762, '2017-11-18 13:47:29', NULL, NULL, 14606, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:47:29', 'admin-1510967819-15109840496358824', 1, 1, 'SR', NULL, NULL, NULL),
(53763, '2017-11-18 13:47:29', NULL, NULL, 14606, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:47:29', 'admin-1510967819-15109840496358824', 1, 1, 'SR', NULL, NULL, NULL),
(53764, '2017-11-18 13:47:29', NULL, NULL, 14606, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:47:29', 'admin-1510967819-15109840496358824', 1, 1, 'SR', NULL, NULL, NULL),
(53765, '2017-11-18 14:09:19', NULL, NULL, 14608, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:09:19', 'admin-1510967819-15109853589692641', 1, 0, '', NULL, NULL, NULL),
(53766, '2017-11-18 13:47:18', NULL, NULL, 14606, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.20, 0.0000, 0.0000, 10.20, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:47:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53767, '2017-11-18 13:39:54', NULL, NULL, 14593, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:39:54', 'admin-1510967819-15109835940725177', 1, 0, '', NULL, NULL, NULL),
(53768, '2017-11-18 13:35:43', NULL, NULL, 14595, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:35:43', 'admin-1510967819-15109833431365724', 1, 1, 'SR', NULL, NULL, NULL),
(53769, '2017-11-18 10:38:34', NULL, NULL, 14586, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 10:38:34', 'admin-1510967819-15109727144968861', 1, 0, '', NULL, NULL, NULL),
(53770, '2017-11-18 10:39:17', NULL, NULL, 14587, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1510967819', 'admin', '2017-11-18 10:39:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53771, '2017-11-18 10:39:26', NULL, NULL, 14587, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 10:39:26', 'admin-1510967819-15109727658835149', 1, 0, '', NULL, NULL, NULL),
(53772, '2017-11-18 10:39:26', NULL, NULL, 14587, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 10:39:26', 'admin-1510967819-15109727658835149', 1, 0, '', NULL, NULL, NULL),
(53773, '2017-11-18 10:39:33', NULL, NULL, 14587, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 10:39:33', 'admin-1510967819-15109727734675212', 1, 1, 'SR', NULL, NULL, NULL),
(53774, '2017-11-18 11:47:31', NULL, NULL, 14594, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:47:31', 'admin-1510967819-15109768516482727', 1, 0, '', NULL, NULL, NULL),
(53775, '2017-11-18 11:38:15', NULL, NULL, 14592, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:38:15', 'admin-1510967819-1510976295413172', 1, 1, 'SR', NULL, NULL, NULL),
(53776, '2017-11-18 11:41:33', NULL, NULL, 14593, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:41:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53777, '2017-11-18 11:41:51', NULL, NULL, 14593, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:41:51', 'admin-1510967819-15109765113253073', 1, 0, '', NULL, NULL, NULL),
(53778, '2017-11-18 11:41:51', NULL, NULL, 14593, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:41:51', 'admin-1510967819-15109765113253073', 1, 1, 'SR', NULL, NULL, NULL),
(53779, '2017-11-18 11:41:51', NULL, NULL, 14593, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:41:51', 'admin-1510967819-15109765113253073', 1, 0, '', NULL, NULL, NULL),
(53780, '2017-11-18 11:46:45', NULL, NULL, 14594, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:46:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53781, '2017-11-18 11:47:31', NULL, NULL, 14594, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:47:31', 'admin-1510967819-15109768516482727', 1, 1, 'SR', NULL, NULL, NULL),
(53782, '2017-11-18 00:00:00', NULL, NULL, 14604, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:11:12', 'admin-1510967819-15109818720931366', 1, 1, 'SR', NULL, NULL, NULL),
(53783, '2017-11-18 12:13:30', NULL, NULL, 14596, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:13:30', 'admin-1510967819-15109784103225658', 1, 1, 'SR', NULL, NULL, NULL),
(53784, '2017-11-18 10:45:33', NULL, NULL, 14588, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.85, 0.0000, 0.0000, 0.85, 1, '27', 1, '1510967819', 'admin', '2017-11-18 10:45:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53785, '2017-11-18 10:45:41', NULL, NULL, 14588, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 10:45:41', 'admin-1510967819-15109731408378384', 1, 1, 'SR', NULL, NULL, NULL),
(53786, '2017-11-18 10:45:41', NULL, NULL, 14588, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1510967819', 'admin', '2017-11-18 10:45:41', 'admin-1510967819-15109731408378384', 1, 0, '', NULL, NULL, NULL),
(53787, '2017-11-18 11:01:49', NULL, NULL, 14589, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:01:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53788, '2017-11-18 11:02:06', NULL, NULL, 14589, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:02:06', 'admin-1510967819-15109741266702040', 1, 0, '', NULL, NULL, NULL),
(53789, '2017-11-18 11:02:06', NULL, NULL, 14589, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:02:06', 'admin-1510967819-15109741266702040', 1, 0, '', NULL, NULL, NULL),
(53790, '2017-11-18 11:02:06', NULL, NULL, 14589, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:02:06', 'admin-1510967819-15109741266702040', 1, 1, 'SR', NULL, NULL, NULL),
(53791, '2017-11-18 11:02:06', NULL, NULL, 14589, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:02:06', 'admin-1510967819-15109741266702040', 1, 1, 'SR', NULL, NULL, NULL),
(53792, '2017-11-18 13:28:45', NULL, NULL, 14602, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:28:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53793, '2017-11-18 10:34:51', NULL, NULL, 14585, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1510967819', 'admin', '2017-11-18 10:34:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53794, '2017-11-18 00:00:00', NULL, NULL, 14603, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:52:21', 'admin-1510967819-15109807416977015', 1, 0, '', NULL, NULL, NULL),
(53795, '2017-11-18 13:30:06', NULL, NULL, 14604, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:30:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53796, '2017-11-18 00:00:00', NULL, NULL, 14601, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:41:13', 'admin-1510967819-151098007365328', 1, 0, '', NULL, NULL, NULL),
(53797, '2017-11-18 10:35:12', NULL, NULL, 14585, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 10:35:12', 'admin-1510967819-15109725124472228', 1, 0, '', NULL, NULL, NULL),
(53798, '2017-11-18 11:37:29', NULL, NULL, 14591, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:37:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53799, '2017-11-18 11:56:29', NULL, NULL, 14595, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:56:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53800, '2017-11-18 13:29:08', NULL, NULL, 14603, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:29:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53801, '2017-11-18 13:26:49', NULL, NULL, 14600, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:26:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53802, '2017-11-18 12:41:53', NULL, NULL, 14592, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:41:53', 'admin-1510967819-15109801132425535', 1, 1, 'SR', NULL, NULL, NULL),
(53803, '2017-11-18 13:28:14', NULL, NULL, 14601, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:28:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53804, '2017-11-18 00:00:00', NULL, NULL, 14602, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:41:13', 'admin-1510967819-151098007365328', 1, 0, '', NULL, NULL, NULL),
(53805, '2017-11-18 12:30:25', NULL, NULL, 14593, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:30:25', 'admin-1510967819-1510979425573863', 1, 0, '', NULL, NULL, NULL),
(53806, '2017-11-18 12:29:38', NULL, NULL, 14598, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:29:38', 'admin-1510967819-15109793784464865', 1, 0, '', NULL, NULL, NULL),
(53807, '2017-11-18 14:43:13', NULL, NULL, 14613, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:43:13', 'admin-1510967819-15109873938395539', 1, 1, 'SR', NULL, NULL, NULL),
(53808, '2017-11-18 14:43:13', NULL, NULL, 14613, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 14:43:13', 'admin-1510967819-15109873938395539', 1, 1, 'SR', NULL, NULL, NULL),
(53809, '2017-11-18 12:29:23', NULL, NULL, 14598, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:29:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53810, '2017-11-18 12:29:38', NULL, NULL, 14598, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:29:38', 'admin-1510967819-15109793784464865', 1, 0, '', NULL, NULL, NULL),
(53811, '2017-11-18 12:23:39', NULL, NULL, 14597, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:23:39', 'admin-1510967819-15109790195678857', 1, 1, 'SR', NULL, NULL, NULL),
(53812, '2017-11-18 12:23:39', NULL, NULL, 14597, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:23:39', 'admin-1510967819-15109790195678857', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(53813, '2017-11-18 12:23:39', NULL, NULL, 14597, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:23:39', 'admin-1510967819-15109790195678857', 1, 0, '', NULL, NULL, NULL),
(53814, '2017-11-18 12:23:39', NULL, NULL, 14597, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:23:39', 'admin-1510967819-15109790195678857', 1, 1, 'SR', NULL, NULL, NULL),
(53815, '2017-11-18 12:46:39', NULL, NULL, 14598, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:46:39', 'admin-1510967819-15109803997558584', 1, 0, '', NULL, NULL, NULL),
(53816, '2017-11-18 12:22:55', NULL, NULL, 14597, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:22:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53817, '2017-11-18 12:13:30', NULL, NULL, 14596, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:13:30', 'admin-1510967819-15109784103225658', 1, 1, 'SR', NULL, NULL, NULL),
(53818, '2017-11-18 12:12:51', NULL, NULL, 14596, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:12:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53819, '2017-11-18 11:56:37', NULL, NULL, 14595, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:56:37', 'admin-1510967819-15109773978135063', 1, 0, '', NULL, NULL, NULL),
(53820, '2017-11-18 11:56:37', NULL, NULL, 14595, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:56:37', 'admin-1510967819-15109773978135063', 1, 1, 'SR', NULL, NULL, NULL),
(53821, '2017-11-18 11:26:45', NULL, NULL, 14590, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:26:45', 'admin-1510967819-15109756053973855', 1, 1, 'SR', NULL, NULL, NULL),
(53822, '2017-11-18 11:51:10', NULL, NULL, 14594, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:51:10', 'admin-1510967819-1510977069889968', 1, 1, 'SR', NULL, NULL, NULL),
(53823, '2017-11-18 11:26:22', NULL, NULL, 14590, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:26:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53824, '2017-11-18 11:38:03', NULL, NULL, 14591, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:38:03', 'admin-1510967819-1510976283332579', 1, 1, 'SR', NULL, NULL, NULL),
(53825, '2017-11-18 11:37:40', NULL, NULL, 14591, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:37:40', 'admin-1510967819-15109762606805266', 1, 0, '', NULL, NULL, NULL),
(53826, '2017-11-18 11:38:03', NULL, NULL, 14591, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:38:03', 'admin-1510967819-1510976283332579', 1, 1, 'SR', NULL, NULL, NULL),
(53827, '2017-11-18 12:29:38', NULL, NULL, 14598, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 12:29:38', 'admin-1510967819-15109793784464865', 1, 0, '', NULL, NULL, NULL),
(53828, '2017-11-18 11:26:45', NULL, NULL, 14590, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:26:45', 'admin-1510967819-15109756053973855', 1, 1, 'SR', NULL, NULL, NULL),
(53829, '2017-11-18 10:35:12', NULL, NULL, 14585, 0, 154, '88', 'Daily Dose BLT', 'change to sausage', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 10:35:12', 'admin-1510967819-15109725124472228', 1, 0, '', NULL, NULL, NULL),
(53830, '2017-11-18 11:37:40', NULL, NULL, 14591, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:37:40', 'admin-1510967819-15109762606805266', 1, 0, '', NULL, NULL, NULL),
(53831, '2017-11-18 11:26:33', NULL, NULL, 14590, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:26:33', 'admin-1510967819-15109755936646916', 1, 0, '', NULL, NULL, NULL),
(53832, '2017-11-18 11:04:55', NULL, NULL, 14585, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:04:55', 'admin-1510967819-15109742957722932', 1, 0, '', NULL, NULL, NULL),
(53833, '2017-11-18 10:38:34', NULL, NULL, 14586, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 10:38:34', 'admin-1510967819-15109727144968861', 1, 0, '', NULL, NULL, NULL),
(53834, '2017-11-18 09:33:57', NULL, NULL, 14581, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 09:33:57', 'admin-1510967819-15109688376695514', 1, 0, '', NULL, NULL, NULL),
(53835, '2017-11-18 10:38:34', NULL, NULL, 14586, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 10:38:34', 'admin-1510967819-15109727144968861', 1, 0, '', NULL, NULL, NULL),
(53836, '2017-11-18 10:38:34', NULL, NULL, 14586, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 10:38:34', 'admin-1510967819-15109727144968861', 1, 1, 'SR', NULL, NULL, NULL),
(53837, '2017-11-18 09:48:05', NULL, NULL, 14583, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 09:48:05', 'admin-1510967819-15109696851144929', 1, 0, '', NULL, NULL, NULL),
(53838, '2017-11-18 09:48:05', NULL, NULL, 14583, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 09:48:05', 'admin-1510967819-15109696851144929', 1, 0, '', NULL, NULL, NULL),
(53839, '2017-11-18 09:48:05', NULL, NULL, 14583, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 09:48:05', 'admin-1510967819-15109696851144929', 1, 1, 'SR', NULL, NULL, NULL),
(53840, '2017-11-18 09:50:52', NULL, NULL, 14584, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1510967819', 'admin', '2017-11-18 09:50:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53841, '2017-11-18 09:51:03', NULL, NULL, 14584, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 09:51:03', 'admin-1510967819-15109698630277585', 1, 1, 'SR', NULL, NULL, NULL),
(53842, '2017-11-18 09:51:13', NULL, NULL, 14582, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 09:51:13', 'admin-1510967819-15109698728577912', 1, 0, '', NULL, NULL, NULL),
(53843, '2017-11-18 13:55:23', NULL, NULL, 14607, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 13:55:23', 'admin-1510967819-15109845235832938', 1, 0, '', NULL, NULL, '10.0'),
(53844, '2017-11-18 10:35:12', NULL, NULL, 14585, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 10:35:12', 'admin-1510967819-15109725124472228', 1, 1, 'SR', NULL, NULL, NULL),
(53845, '2017-11-18 10:35:12', NULL, NULL, 14585, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 10:35:12', 'admin-1510967819-15109725124472228', 1, 0, '', NULL, NULL, NULL),
(53846, '2017-11-18 09:35:37', NULL, NULL, 14582, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1510967819', 'admin', '2017-11-18 09:35:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53847, '2017-11-18 09:33:57', NULL, NULL, 14581, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 09:33:57', 'admin-1510967819-15109688376695514', 1, 0, '', NULL, NULL, NULL),
(53848, '2017-11-18 09:35:49', NULL, NULL, 14582, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 09:35:49', 'admin-1510967819-15109689498677861', 1, 0, '', NULL, NULL, NULL),
(53849, '2017-11-18 11:38:03', NULL, NULL, 14591, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:38:03', 'admin-1510967819-1510976283332579', 1, 1, 'SR', NULL, NULL, NULL),
(53850, '2017-11-18 09:47:03', NULL, NULL, 14583, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1510967819', 'admin', '2017-11-18 09:47:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53851, '2017-11-18 09:35:50', NULL, NULL, 14582, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 09:35:50', 'admin-1510967819-15109689498677861', 1, 1, 'SR', NULL, NULL, NULL),
(53852, '2017-11-18 09:35:50', NULL, NULL, 14582, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 09:35:50', 'admin-1510967819-15109689498677861', 1, 0, '', NULL, NULL, NULL),
(53853, '2017-11-18 09:33:57', NULL, NULL, 14581, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 09:33:57', 'admin-1510967819-15109688376695514', 1, 1, 'SR', NULL, NULL, NULL),
(53854, '2017-11-18 11:47:31', NULL, NULL, 14594, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 11:47:31', 'admin-1510967819-15109768516482727', 1, 0, '', NULL, NULL, NULL),
(53855, '2017-11-18 10:38:25', NULL, NULL, 14586, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1510967819', 'admin', '2017-11-18 10:38:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53856, '2017-11-18 09:33:05', NULL, NULL, 14580, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1510967819', 'admin', '2017-11-18 09:33:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53857, '2017-11-18 09:33:49', NULL, NULL, 14581, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1510967819', 'admin', '2017-11-18 09:33:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53858, '2017-11-18 09:33:09', NULL, NULL, 14580, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1510967819', 'admin', '2017-11-18 09:33:09', 'admin-1510967819-15109687895762988', 1, 0, '', NULL, NULL, NULL),
(53859, '2017-11-19 13:24:29', NULL, NULL, 14652, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1511052202', 'admin', '2017-11-19 13:24:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53860, '2017-11-19 13:21:08', NULL, NULL, 14650, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 13:21:08', 'admin-1511052202-15110688680924064', 1, 1, 'SR', NULL, NULL, NULL),
(53861, '2017-11-19 13:21:08', NULL, NULL, 14650, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 13:21:08', 'admin-1511052202-15110688680924064', 1, 0, '', NULL, NULL, NULL),
(53862, '2017-11-19 13:52:22', NULL, NULL, 14649, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 13:52:22', 'admin-1511052202-15110707418982526', 1, 1, 'SR', NULL, NULL, NULL),
(53863, '2017-11-19 13:52:22', NULL, NULL, 14649, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 13:52:22', 'admin-1511052202-15110707418982526', 1, 1, 'SR', NULL, NULL, NULL),
(53864, '2017-11-19 15:24:16', NULL, NULL, 14658, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 15:24:16', 'admin-1511052202-15110762561246965', 1, 1, 'SR', NULL, NULL, NULL),
(53865, '2017-11-19 15:24:06', NULL, NULL, 14658, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1511052202', 'admin', '2017-11-19 15:24:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53866, '2017-11-19 15:21:27', NULL, NULL, 14657, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 15:21:27', 'admin-1511052202-15110760878576837', 1, 0, '', NULL, NULL, NULL),
(53867, '2017-11-19 15:20:11', NULL, NULL, 14654, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 15:20:11', 'admin-1511052202-15110760117617467', 1, 1, 'SR', NULL, NULL, NULL),
(53868, '2017-11-19 15:01:13', NULL, NULL, 14657, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 15:01:13', 'admin-1511052202-15110748734698798', 1, 1, 'SR', NULL, NULL, NULL),
(53869, '2017-11-19 14:30:53', NULL, NULL, 14655, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 14:30:53', 'admin-1511052202-1511073053522378', 1, 0, '', NULL, NULL, NULL),
(53870, '2017-11-19 13:20:17', NULL, NULL, 14651, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 13:20:17', 'admin-1511052202-15110688176931964', 1, 0, '', NULL, NULL, NULL),
(53871, '2017-11-19 12:50:56', NULL, NULL, 14648, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:50:56', 'admin-1511052202-15110670567546618', 1, 0, '', NULL, NULL, NULL),
(53872, '2017-11-19 12:51:02', NULL, NULL, 14648, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:51:02', 'admin-1511052202-15110670625724597', 1, 1, 'SR', NULL, NULL, NULL),
(53873, '2017-11-19 09:06:16', NULL, NULL, 14617, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 09:06:16', 'admin-1511052202-15110535765994486', 1, 0, '', NULL, NULL, NULL),
(53874, '2017-11-19 09:06:16', NULL, NULL, 14617, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 09:06:16', 'admin-1511052202-15110535765994486', 1, 0, '', NULL, NULL, NULL),
(53875, '2017-11-19 13:20:17', NULL, NULL, 14651, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 13:20:17', 'admin-1511052202-15110688176931964', 1, 1, 'SR', NULL, NULL, NULL),
(53876, '2017-11-19 11:11:17', NULL, NULL, 14629, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:11:17', 'admin-1511052202-15110610768727231', 1, 0, '', NULL, NULL, NULL),
(53877, '2017-11-19 13:20:17', NULL, NULL, 14651, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 13:20:17', 'admin-1511052202-15110688176931964', 1, 1, 'SR', NULL, NULL, NULL),
(53878, '2017-11-19 13:20:17', NULL, NULL, 14651, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 13:20:17', 'admin-1511052202-15110688176931964', 1, 0, '', NULL, NULL, NULL),
(53879, '2017-11-19 13:20:17', NULL, NULL, 14651, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 13:20:17', 'admin-1511052202-15110688176931964', 1, 1, 'SR', NULL, NULL, NULL),
(53880, '2017-11-19 13:20:17', NULL, NULL, 14651, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 13:20:17', 'admin-1511052202-15110688176931964', 1, 1, 'SR', NULL, NULL, NULL),
(53881, '2017-11-19 14:39:08', NULL, NULL, 14656, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 14:39:08', 'admin-1511052202-1511073548192765', 1, 1, 'SR', NULL, NULL, NULL),
(53882, '2017-11-19 14:39:08', NULL, NULL, 14656, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 14:39:08', 'admin-1511052202-1511073548192765', 1, 0, '', NULL, NULL, NULL),
(53883, '2017-11-19 11:36:38', NULL, NULL, 14635, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:36:38', 'admin-1511052202-15110625988116176', 1, 1, 'SR', NULL, NULL, NULL),
(53884, '2017-11-19 11:36:31', NULL, NULL, 14635, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:36:31', 'admin-1511052202-15110625914613830', 1, 0, '', NULL, NULL, NULL),
(53885, '2017-11-19 11:36:31', NULL, NULL, 14635, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:36:31', 'admin-1511052202-15110625914613830', 1, 0, '', NULL, NULL, NULL),
(53886, '2017-11-19 15:01:13', NULL, NULL, 14657, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 15:01:13', 'admin-1511052202-15110748734698798', 1, 0, '', NULL, NULL, NULL),
(53887, '2017-11-19 13:19:17', NULL, NULL, 14650, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1511052202', 'admin', '2017-11-19 13:19:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53888, '2017-11-19 11:27:44', NULL, NULL, 14634, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:27:44', 'admin-1511052202-15110620647797754', 1, 1, 'SR', NULL, NULL, NULL),
(53889, '2017-11-19 14:04:53', NULL, NULL, 14653, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 14:04:53', 'admin-1511052202-15110714934244067', 1, 0, '', 1, NULL, NULL),
(53890, '2017-11-19 14:05:13', NULL, NULL, 14654, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1511052202', 'admin', '2017-11-19 14:05:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53891, '2017-11-19 14:05:19', NULL, NULL, 14654, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 14:05:19', 'admin-1511052202-15110715192211421', 1, 1, 'SR', NULL, NULL, NULL),
(53892, '2017-11-19 14:07:56', NULL, NULL, 14654, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 14:07:56', 'admin-1511052202-15110716766099584', 1, 1, 'SR', NULL, NULL, NULL),
(53893, '2017-11-19 13:10:29', NULL, NULL, 14649, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1511052202', 'admin', '2017-11-19 13:10:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53894, '2017-11-19 00:00:00', NULL, NULL, 14644, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:00:58', 'admin-1511052202-15110640579765796', 1, 0, '', NULL, NULL, NULL),
(53895, '2017-11-19 14:39:08', NULL, NULL, 14656, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 14:39:08', 'admin-1511052202-1511073548192765', 1, 0, '', NULL, NULL, NULL),
(53896, '2017-11-19 14:30:53', NULL, NULL, 14655, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 14:30:53', 'admin-1511052202-1511073053522378', 1, 1, 'SR', NULL, NULL, NULL),
(53897, '2017-11-19 14:30:53', NULL, NULL, 14655, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 14:30:53', 'admin-1511052202-1511073053522378', 1, 1, 'SR', NULL, NULL, NULL),
(53898, '2017-11-19 14:30:53', NULL, NULL, 14655, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 14:30:53', 'admin-1511052202-1511073053522378', 1, 0, '', NULL, NULL, NULL),
(53899, '2017-11-19 14:30:53', NULL, NULL, 14655, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 14:30:53', 'admin-1511052202-1511073053522378', 1, 0, '', NULL, NULL, NULL),
(53900, '2017-11-19 14:30:53', NULL, NULL, 14655, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 14:30:53', 'admin-1511052202-1511073053522378', 1, 1, 'SR', NULL, NULL, NULL),
(53901, '2017-11-19 14:33:32', NULL, NULL, 14655, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 14:33:32', 'admin-1511052202-1511073212190885', 1, 1, 'SR', NULL, NULL, NULL),
(53902, '2017-11-19 14:37:27', NULL, NULL, 14656, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1511052202', 'admin', '2017-11-19 14:37:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53903, '2017-11-19 14:33:32', NULL, NULL, 14655, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 14:33:32', 'admin-1511052202-1511073212190885', 1, 1, 'SR', NULL, NULL, NULL),
(53904, '2017-11-19 14:28:58', NULL, NULL, 14655, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.30, 0.0000, 0.0000, 16.30, 1, '27', 1, '1511052202', 'admin', '2017-11-19 14:28:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53905, '2017-11-19 14:30:53', NULL, NULL, 14655, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 14:30:53', 'admin-1511052202-1511073053522378', 1, 1, 'SR', NULL, NULL, NULL),
(53906, '2017-11-19 14:30:53', NULL, NULL, 14655, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 14:30:53', 'admin-1511052202-1511073053522378', 1, 1, 'SR', NULL, NULL, NULL),
(53907, '2017-11-19 14:30:53', NULL, NULL, 14655, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 14:30:53', 'admin-1511052202-1511073053522378', 1, 1, 'SR', NULL, NULL, NULL),
(53908, '2017-11-19 09:57:25', NULL, NULL, 14619, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 09:57:25', 'admin-1511052202-15110566455281217', 1, 0, '', NULL, NULL, NULL),
(53909, '2017-11-19 09:57:25', NULL, NULL, 14619, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 09:57:25', 'admin-1511052202-15110566455281217', 1, 0, '', NULL, NULL, NULL),
(53910, '2017-11-19 14:30:53', NULL, NULL, 14655, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 14:30:53', 'admin-1511052202-1511073053522378', 1, 1, 'SR', NULL, NULL, NULL),
(53911, '2017-11-19 12:51:02', NULL, NULL, 14648, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:51:02', 'admin-1511052202-15110670625724597', 1, 1, 'SR', NULL, NULL, NULL),
(53912, '2017-11-19 12:31:02', NULL, NULL, 14646, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:31:02', 'admin-1511052202-15110658626294435', 1, 1, 'SR', NULL, NULL, NULL),
(53913, '2017-11-19 13:24:58', NULL, NULL, 14652, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 13:24:58', 'admin-1511052202-1511069097944142', 1, 0, '', NULL, NULL, NULL),
(53914, '2017-11-19 13:25:04', NULL, NULL, 14652, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 13:25:04', 'admin-1511052202-15110691045405842', 1, 1, 'SR', NULL, NULL, NULL),
(53915, '2017-11-19 13:51:45', NULL, NULL, 14649, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 13:51:45', 'admin-1511052202-15110707056893389', 1, 0, '', NULL, NULL, NULL),
(53916, '2017-11-19 13:51:45', NULL, NULL, 14649, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 13:51:45', 'admin-1511052202-15110707056893389', 1, 0, '', NULL, NULL, NULL),
(53917, '2017-11-19 11:26:33', NULL, NULL, 14633, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.90, 0.0000, 0.0000, 9.90, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:26:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53918, '2017-11-19 11:26:57', NULL, NULL, 14633, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:26:57', 'admin-1511052202-15110620173705312', 1, 0, '', NULL, NULL, NULL),
(53919, '2017-11-19 12:31:02', NULL, NULL, 14646, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:31:02', 'admin-1511052202-15110658626294435', 1, 0, '', NULL, NULL, NULL),
(53920, '2017-11-19 12:31:11', NULL, NULL, 14646, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:31:11', 'admin-1511052202-15110658715193615', 1, 0, '', NULL, NULL, NULL),
(53921, '2017-11-19 12:33:47', NULL, NULL, 14647, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:33:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53922, '2017-11-19 12:34:22', NULL, NULL, 14647, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:34:22', 'admin-1511052202-15110660627423238', 1, 0, '', NULL, NULL, NULL),
(53923, '2017-11-19 12:34:22', NULL, NULL, 14647, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:34:22', 'admin-1511052202-15110660627423238', 1, 0, '', NULL, NULL, NULL),
(53924, '2017-11-19 12:27:00', NULL, NULL, 14642, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:27:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53925, '2017-11-19 12:50:56', NULL, NULL, 14648, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:50:56', 'admin-1511052202-15110670567546618', 1, 0, '', NULL, NULL, NULL),
(53926, '2017-11-19 13:24:58', NULL, NULL, 14652, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 13:24:58', 'admin-1511052202-1511069097944142', 1, 0, '', NULL, NULL, NULL),
(53927, '2017-11-19 12:34:59', NULL, NULL, 14647, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:34:59', 'admin-1511052202-15110660992582030', 1, 1, 'SR', NULL, NULL, NULL),
(53928, '2017-11-19 12:27:28', NULL, NULL, 14643, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:27:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53929, '2017-11-19 00:00:00', NULL, NULL, 14642, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:00:58', 'admin-1511052202-15110640579765796', 1, 0, '', NULL, NULL, NULL),
(53930, '2017-11-19 12:34:59', NULL, NULL, 14647, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:34:59', 'admin-1511052202-15110660992582030', 1, 1, 'SR', NULL, NULL, NULL),
(53931, '2017-11-19 12:34:22', NULL, NULL, 14647, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:34:22', 'admin-1511052202-15110660627423238', 1, 0, '', NULL, NULL, NULL),
(53932, '2017-11-19 11:36:26', NULL, NULL, 14635, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:36:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53933, '2017-11-19 12:30:02', NULL, NULL, 14645, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:30:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53934, '2017-11-19 12:30:09', NULL, NULL, 14645, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:30:09', 'admin-1511052202-15110658091038796', 1, 0, '', NULL, NULL, NULL),
(53935, '2017-11-19 12:30:26', NULL, NULL, 14645, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:30:26', 'admin-1511052202-15110658264702230', 1, 1, 'SR', NULL, NULL, NULL),
(53936, '2017-11-19 12:30:26', NULL, NULL, 14645, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:30:26', 'admin-1511052202-15110658264702230', 1, 1, 'SR', NULL, NULL, NULL),
(53937, '2017-11-19 00:00:00', NULL, NULL, 14642, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:00:49', 'admin-1511052202-15110640493845583', 1, 0, '', NULL, NULL, NULL),
(53938, '2017-11-19 00:00:00', NULL, NULL, 14643, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:00:49', 'admin-1511052202-15110640493845583', 1, 0, '', NULL, NULL, NULL),
(53939, '2017-11-19 00:00:00', NULL, NULL, 14641, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:00:32', 'admin-1511052202-1511064032498512', 1, 0, '', NULL, NULL, NULL),
(53940, '2017-11-19 11:13:23', NULL, NULL, 14631, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:13:23', 'admin-1511052202-15110612034234522', 1, 1, 'SR', NULL, NULL, '10.0'),
(53941, '2017-11-19 10:22:58', NULL, NULL, 14624, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:22:58', 'admin-1511052202-15110581785633911', 1, 1, 'SR', NULL, NULL, NULL),
(53942, '2017-11-19 11:11:17', NULL, NULL, 14629, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:11:17', 'admin-1511052202-15110610768727231', 1, 0, '', NULL, NULL, NULL),
(53943, '2017-11-19 00:00:00', NULL, NULL, 14640, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:00:32', 'admin-1511052202-1511064032498512', 1, 0, '', NULL, NULL, NULL),
(53944, '2017-11-19 10:22:58', NULL, NULL, 14624, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:22:58', 'admin-1511052202-15110581785633911', 1, 0, '', NULL, NULL, NULL),
(53945, '2017-11-19 11:57:36', NULL, NULL, 14637, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:57:36', 'admin-1511052202-15110638566801182', 1, 1, 'SR', NULL, NULL, NULL),
(53946, '2017-11-19 12:50:43', NULL, NULL, 14648, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:50:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53947, '2017-11-19 12:24:41', NULL, NULL, 14639, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:24:41', 'admin-1511052202-15110654812774845', 1, 1, 'SR', NULL, NULL, NULL),
(53948, '2017-11-19 12:26:42', NULL, NULL, 14641, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:26:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53949, '2017-11-19 12:25:37', NULL, NULL, 14640, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:25:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53950, '2017-11-19 11:57:36', NULL, NULL, 14637, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:57:36', 'admin-1511052202-15110638566801182', 1, 1, 'SR', NULL, NULL, NULL),
(53951, '2017-11-19 11:49:38', NULL, NULL, 14636, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:49:38', 'admin-1511052202-15110633781061448', 1, 0, '', NULL, NULL, NULL),
(53952, '2017-11-19 12:24:41', NULL, NULL, 14639, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:24:41', 'admin-1511052202-15110654812774845', 1, 1, 'SR', NULL, NULL, NULL),
(53953, '2017-11-19 11:57:26', NULL, NULL, 14637, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:57:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53954, '2017-11-19 11:27:44', NULL, NULL, 14634, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:27:44', 'admin-1511052202-15110620647797754', 1, 0, '', NULL, NULL, NULL),
(53955, '2017-11-19 10:33:40', NULL, NULL, 14625, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:33:40', 'admin-1511052202-1511058820523326', 1, 1, 'SR', NULL, NULL, NULL),
(53956, '2017-11-19 11:49:38', NULL, NULL, 14636, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:49:38', 'admin-1511052202-15110633781061448', 1, 0, '', NULL, NULL, NULL),
(53957, '2017-11-19 11:49:29', NULL, NULL, 14636, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:49:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53958, '2017-11-19 11:36:38', NULL, NULL, 14635, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:36:38', 'admin-1511052202-15110625988116176', 1, 0, '', NULL, NULL, NULL),
(53959, '2017-11-19 12:30:46', NULL, NULL, 14646, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:30:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53960, '2017-11-19 12:30:38', NULL, NULL, 14645, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:30:38', 'admin-1511052202-15110658388205920', 1, 0, '', NULL, NULL, NULL),
(53961, '2017-11-19 13:19:23', NULL, NULL, 14651, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.90, 0.0000, 0.0000, 9.90, 1, '27', 1, '1511052202', 'admin', '2017-11-19 13:19:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53962, '2017-11-19 11:11:50', NULL, NULL, 14630, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:11:50', 'admin-1511052202-15110611100603020', 1, 0, '', NULL, NULL, NULL),
(53963, '2017-11-19 11:26:57', NULL, NULL, 14633, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:26:57', 'admin-1511052202-15110620173705312', 1, 0, '', NULL, NULL, NULL),
(53964, '2017-11-19 11:26:57', NULL, NULL, 14633, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:26:57', 'admin-1511052202-15110620173705312', 1, 1, 'SR', NULL, NULL, NULL),
(53965, '2017-11-19 10:18:40', NULL, NULL, 14623, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:18:40', 'admin-1511052202-15110579204086115', 1, 0, '', NULL, NULL, NULL),
(53966, '2017-11-19 10:18:56', NULL, NULL, 14623, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:18:56', 'admin-1511052202-15110579365558357', 1, 1, 'SR', NULL, NULL, NULL),
(53967, '2017-11-19 10:18:56', NULL, NULL, 14623, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:18:56', 'admin-1511052202-15110579365558357', 1, 0, '', NULL, NULL, NULL),
(53968, '2017-11-19 10:21:58', NULL, NULL, 14624, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.50, 0.0000, 0.0000, 12.50, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:21:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53969, '2017-11-19 10:22:20', NULL, NULL, 14624, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:22:20', 'admin-1511052202-15110581399452329', 1, 0, '', NULL, NULL, NULL),
(53970, '2017-11-19 10:22:20', NULL, NULL, 14624, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:22:20', 'admin-1511052202-15110581399452329', 1, 0, '', NULL, NULL, NULL),
(53971, '2017-11-19 15:01:13', NULL, NULL, 14657, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 15:01:13', 'admin-1511052202-15110748734698798', 1, 0, '', NULL, NULL, NULL),
(53972, '2017-11-19 13:24:58', NULL, NULL, 14652, 0, 70, '70', 'Borneo Pepper Pork', 'less pepper', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 13:24:58', 'admin-1511052202-1511069097944142', 1, 1, 'SR', NULL, NULL, NULL),
(53973, '2017-11-19 11:11:50', NULL, NULL, 14630, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:11:50', 'admin-1511052202-15110611100603020', 1, 1, 'SR', NULL, NULL, NULL),
(53974, '2017-11-19 14:39:08', NULL, NULL, 14656, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 14:39:08', 'admin-1511052202-1511073548192765', 1, 1, 'SR', NULL, NULL, NULL),
(53975, '2017-11-19 11:27:10', NULL, NULL, 14633, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:27:10', 'admin-1511052202-15110620302935414', 1, 1, 'SR', NULL, NULL, NULL),
(53976, '2017-11-19 11:27:10', NULL, NULL, 14633, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:27:10', 'admin-1511052202-15110620302935414', 1, 1, 'SR', NULL, NULL, NULL),
(53977, '2017-11-19 11:27:44', NULL, NULL, 14634, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:27:44', 'admin-1511052202-15110620647797754', 1, 1, 'SR', NULL, NULL, NULL),
(53978, '2017-11-19 11:27:44', NULL, NULL, 14634, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:27:44', 'admin-1511052202-15110620647797754', 1, 0, '', NULL, NULL, NULL),
(53979, '2017-11-19 11:27:44', NULL, NULL, 14634, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:27:44', 'admin-1511052202-15110620647797754', 1, 0, '', NULL, NULL, NULL),
(53980, '2017-11-19 11:27:15', NULL, NULL, 14634, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:27:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53981, '2017-11-19 11:27:10', NULL, NULL, 14633, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:27:10', 'admin-1511052202-15110620302935414', 1, 1, 'SR', NULL, NULL, NULL),
(53982, '2017-11-19 10:18:07', NULL, NULL, 14619, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:18:07', 'admin-1511052202-15110578868201296', 1, 0, '', NULL, NULL, NULL),
(53983, '2017-11-19 10:18:07', NULL, NULL, 14619, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:18:07', 'admin-1511052202-15110578868201296', 1, 0, '', NULL, NULL, NULL),
(53984, '2017-11-19 10:18:23', NULL, NULL, 14619, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:18:23', 'admin-1511052202-1511057903804243', 1, 1, 'SR', NULL, NULL, NULL),
(53985, '2017-11-19 10:18:23', NULL, NULL, 14619, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:18:23', 'admin-1511052202-1511057903804243', 1, 1, 'SR', NULL, NULL, NULL),
(53986, '2017-11-19 10:18:23', NULL, NULL, 14619, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:18:23', 'admin-1511052202-1511057903804243', 1, 1, 'SR', NULL, NULL, NULL),
(53987, '2017-11-19 10:18:32', NULL, NULL, 14623, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:18:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53988, '2017-11-19 10:18:40', NULL, NULL, 14623, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:18:40', 'admin-1511052202-15110579204086115', 1, 0, '', NULL, NULL, NULL),
(53989, '2017-11-19 11:25:31', NULL, NULL, 14632, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:25:31', 'admin-1511052202-15110619312191997', 1, 1, 'SR', NULL, NULL, NULL),
(53990, '2017-11-19 11:11:17', NULL, NULL, 14629, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:11:17', 'admin-1511052202-15110610768727231', 1, 0, '', NULL, NULL, NULL),
(53991, '2017-11-19 11:14:49', NULL, NULL, 14631, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:14:49', 'admin-1511052202-15110612898182030', 1, 0, '', NULL, NULL, '10.0'),
(53992, '2017-11-19 11:25:31', NULL, NULL, 14632, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:25:31', 'admin-1511052202-15110619312191997', 1, 0, '', NULL, NULL, NULL),
(53993, '2017-11-19 11:25:24', NULL, NULL, 14632, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:25:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53994, '2017-11-19 11:14:49', NULL, NULL, 14631, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:14:49', 'admin-1511052202-15110612898182030', 1, 0, '', NULL, NULL, '10.0'),
(53995, '2017-11-19 00:00:00', NULL, NULL, 14644, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, NULL, NULL, 1.50, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:00:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53996, '2017-11-19 10:56:47', NULL, NULL, 14627, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:56:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(53997, '2017-11-19 10:56:53', NULL, NULL, 14627, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:56:53', 'admin-1511052202-15110602131245333', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(53998, '2017-11-19 11:13:18', NULL, NULL, 14631, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:13:18', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(53999, '2017-11-19 10:58:04', NULL, NULL, 14628, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:58:04', 'admin-1511052202-15110602846123571', 1, 1, 'SR', NULL, NULL, NULL),
(54000, '2017-11-19 10:56:58', NULL, NULL, 14627, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:56:58', 'admin-1511052202-15110602181504220', 1, 1, 'SR', NULL, NULL, NULL),
(54001, '2017-11-19 10:57:36', NULL, NULL, 14628, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:57:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54002, '2017-11-19 10:57:42', NULL, NULL, 14628, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:57:42', 'admin-1511052202-15110602625937340', 1, 0, '', NULL, NULL, NULL),
(54003, '2017-11-19 15:00:55', NULL, NULL, 14657, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1511052202', 'admin', '2017-11-19 15:00:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54004, '2017-11-19 11:11:35', NULL, NULL, 14630, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:11:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54005, '2017-11-19 13:10:31', NULL, NULL, 14649, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 13:10:31', 'admin-1511052202-1511068231659830', 1, 1, 'SR', NULL, NULL, NULL),
(54006, '2017-11-19 11:11:29', NULL, NULL, 14629, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:11:29', 'admin-1511052202-1511061089766249', 1, 1, 'SR', NULL, NULL, NULL),
(54007, '2017-11-19 11:11:29', NULL, NULL, 14629, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:11:29', 'admin-1511052202-1511061089766249', 1, 1, 'SR', NULL, NULL, NULL),
(54008, '2017-11-19 13:20:17', NULL, NULL, 14651, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 13:20:17', 'admin-1511052202-15110688176931964', 1, 1, 'SR', NULL, NULL, NULL),
(54009, '2017-11-19 12:24:22', NULL, NULL, 14639, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1511052202', 'admin', '2017-11-19 12:24:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54010, '2017-11-19 11:11:29', NULL, NULL, 14629, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:11:29', 'admin-1511052202-1511061089766249', 1, 0, '', NULL, NULL, NULL),
(54011, '2017-11-19 10:33:30', NULL, NULL, 14625, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.19, 0.0000, 0.0000, 5.19, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:33:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54012, '2017-11-19 10:56:53', NULL, NULL, 14627, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:56:53', 'admin-1511052202-15110602131245333', 1, 0, '', NULL, NULL, NULL),
(54013, '2017-11-19 11:11:07', NULL, NULL, 14629, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:11:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54014, '2017-11-19 11:01:49', NULL, NULL, 14625, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:01:49', 'admin-1511052202-15110605092646613', 1, 0, '', NULL, NULL, NULL),
(54015, '2017-11-19 10:58:04', NULL, NULL, 14628, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:58:04', 'admin-1511052202-15110602846123571', 1, 1, 'SR', NULL, NULL, NULL),
(54016, '2017-11-19 10:57:42', NULL, NULL, 14628, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:57:42', 'admin-1511052202-15110602625937340', 1, 0, '', NULL, NULL, NULL),
(54017, '2017-11-19 10:56:58', NULL, NULL, 14627, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:56:58', 'admin-1511052202-15110602181504220', 1, 1, 'SR', NULL, NULL, NULL),
(54018, '2017-11-19 10:55:37', NULL, NULL, 14619, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:55:37', 'admin-1511052202-15110601373542051', 1, 0, '', NULL, NULL, NULL),
(54019, '2017-11-19 11:26:57', NULL, NULL, 14633, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:26:57', 'admin-1511052202-15110620173705312', 1, 0, '', NULL, NULL, NULL),
(54020, '2017-11-19 10:51:19', NULL, NULL, 14626, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:51:19', 'admin-1511052202-15110598797422040', 1, 0, '', NULL, NULL, NULL),
(54021, '2017-11-19 10:51:19', NULL, NULL, 14626, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:51:19', 'admin-1511052202-15110598797422040', 1, 1, 'SR', NULL, NULL, NULL),
(54022, '2017-11-19 10:51:19', NULL, NULL, 14626, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:51:19', 'admin-1511052202-15110598797422040', 1, 0, '', NULL, NULL, NULL),
(54023, '2017-11-19 10:51:19', NULL, NULL, 14626, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:51:19', 'admin-1511052202-15110598797422040', 1, 0, '', NULL, NULL, NULL),
(54024, '2017-11-19 10:33:35', NULL, NULL, 14625, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:33:35', 'admin-1511052202-1511058815576849', 1, 0, '', NULL, NULL, NULL),
(54025, '2017-11-19 10:17:22', NULL, NULL, 14622, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:17:22', 'admin-1511052202-1511057841863393', 1, 0, '', NULL, NULL, NULL),
(54026, '2017-11-19 09:40:01', NULL, NULL, 14618, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 09:40:01', 'admin-1511052202-15110556017287659', 1, 0, '', NULL, NULL, NULL),
(54027, '2017-11-19 10:11:24', NULL, NULL, 14621, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:11:24', 'admin-1511052202-15110574844978773', 1, 0, '', NULL, NULL, NULL),
(54028, '2017-11-19 10:17:14', NULL, NULL, 14622, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:17:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54029, '2017-11-19 10:17:22', NULL, NULL, 14622, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:17:22', 'admin-1511052202-1511057841863393', 1, 0, '', NULL, NULL, NULL),
(54030, '2017-11-19 10:22:58', NULL, NULL, 14624, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:22:58', 'admin-1511052202-15110581785633911', 1, 0, '', NULL, NULL, NULL),
(54031, '2017-11-19 10:22:58', NULL, NULL, 14624, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:22:58', 'admin-1511052202-15110581785633911', 1, 1, 'SR', NULL, NULL, NULL),
(54032, '2017-11-19 10:50:58', NULL, NULL, 14626, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:50:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54033, '2017-11-19 10:22:58', NULL, NULL, 14624, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:22:58', 'admin-1511052202-15110581785633911', 1, 1, 'SR', NULL, NULL, NULL),
(54034, '2017-11-19 10:22:20', NULL, NULL, 14624, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:22:20', 'admin-1511052202-15110581399452329', 1, 0, '', NULL, NULL, NULL),
(54035, '2017-11-19 09:40:01', NULL, NULL, 14618, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 09:40:01', 'admin-1511052202-15110556017287659', 1, 0, '', NULL, NULL, NULL),
(54036, '2017-11-19 10:22:20', NULL, NULL, 14624, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:22:20', 'admin-1511052202-15110581399452329', 1, 0, '', NULL, NULL, NULL),
(54037, '2017-11-19 10:05:24', NULL, NULL, 14620, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:05:24', 'admin-1511052202-15110571248181831', 1, 0, '', NULL, NULL, NULL),
(54038, '2017-11-19 10:05:24', NULL, NULL, 14620, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:05:24', 'admin-1511052202-15110571248181831', 1, 1, 'SR', NULL, NULL, NULL),
(54039, '2017-11-19 10:05:24', NULL, NULL, 14620, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:05:25', 'admin-1511052202-15110571248181831', 1, 1, 'SR', NULL, NULL, NULL),
(54040, '2017-11-19 10:05:25', NULL, NULL, 14620, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:05:25', 'admin-1511052202-15110571248181831', 1, 1, 'SR', NULL, NULL, NULL),
(54041, '2017-11-19 10:05:25', NULL, NULL, 14620, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:05:25', 'admin-1511052202-15110571248181831', 1, 1, 'SR', NULL, NULL, NULL),
(54042, '2017-11-19 10:11:09', NULL, NULL, 14621, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:11:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54043, '2017-11-19 10:11:24', NULL, NULL, 14621, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:11:24', 'admin-1511052202-15110574844978773', 1, 0, '', NULL, NULL, NULL),
(54044, '2017-11-19 10:18:06', NULL, NULL, 14619, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:18:06', 'admin-1511052202-15110578868201296', 1, 0, '', NULL, NULL, NULL),
(54045, '2017-11-19 09:40:01', NULL, NULL, 14618, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 09:40:01', 'admin-1511052202-15110556017287659', 1, 0, '', NULL, NULL, NULL),
(54046, '2017-11-19 09:40:01', NULL, NULL, 14618, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 09:40:01', 'admin-1511052202-15110556017287659', 1, 0, '', NULL, NULL, NULL),
(54047, '2017-11-19 09:40:21', NULL, NULL, 14618, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 09:40:21', 'admin-1511052202-1511055621110838', 1, 1, 'SR', NULL, NULL, NULL),
(54048, '2017-11-19 09:40:21', NULL, NULL, 14618, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 09:40:21', 'admin-1511052202-1511055621110838', 1, 1, 'SR', NULL, NULL, NULL),
(54049, '2017-11-19 09:40:21', NULL, NULL, 14618, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 09:40:21', 'admin-1511052202-1511055621110838', 1, 1, 'SR', NULL, NULL, NULL),
(54050, '2017-11-19 11:25:31', NULL, NULL, 14632, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 11:25:31', 'admin-1511052202-15110619312191997', 1, 1, 'SR', NULL, NULL, NULL),
(54051, '2017-11-19 10:18:06', NULL, NULL, 14619, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:18:06', 'admin-1511052202-15110578868201296', 1, 0, '', NULL, NULL, NULL),
(54052, '2017-11-19 10:33:35', NULL, NULL, 14625, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:33:35', 'admin-1511052202-1511058815576849', 1, 0, '', NULL, NULL, NULL),
(54053, '2017-11-19 09:57:36', NULL, NULL, 14619, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 09:57:36', 'admin-1511052202-15110566564071738', 1, 1, 'SR', NULL, NULL, NULL),
(54054, '2017-11-19 10:01:05', NULL, NULL, 14620, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:01:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54055, '2017-11-19 10:05:24', NULL, NULL, 14620, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 10:05:24', 'admin-1511052202-15110571248181831', 1, 0, '', NULL, NULL, NULL),
(54056, '2017-11-19 09:57:36', NULL, NULL, 14619, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 09:57:36', 'admin-1511052202-15110566564071738', 1, 1, 'SR', NULL, NULL, NULL),
(54057, '2017-11-19 09:57:18', NULL, NULL, 14619, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.80, 0.0000, 0.0000, 16.80, 1, '27', 1, '1511052202', 'admin', '2017-11-19 09:57:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54058, '2017-11-19 09:39:46', NULL, NULL, 14618, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.00, 0.0000, 0.0000, 11.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 09:39:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54059, '2017-11-19 09:06:09', NULL, NULL, 14617, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1511052202', 'admin', '2017-11-19 09:06:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54060, '2017-11-19 09:06:22', NULL, NULL, 14617, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511052202', 'admin', '2017-11-19 09:06:22', 'admin-1511052202-15110535819924096', 1, 1, 'SR', NULL, NULL, NULL),
(54061, '2017-11-20 14:32:12', NULL, NULL, 14678, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 14:32:12', 'admin-1511139560-15111595318785670', 1, 1, 'SR', NULL, NULL, NULL),
(54062, '2017-11-20 14:36:59', NULL, NULL, 14678, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 14:36:59', 'admin-1511139560-15111598197898919', 1, 0, '', NULL, NULL, NULL),
(54063, '2017-11-20 14:48:35', NULL, NULL, 14679, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1511139560', 'admin', '2017-11-20 14:48:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54064, '2017-11-20 13:41:37', NULL, NULL, 14676, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:41:37', 'admin-1511139560-1511156497797985', 1, 1, 'SR', NULL, NULL, NULL),
(54065, '2017-11-20 13:41:37', NULL, NULL, 14676, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:41:37', 'admin-1511139560-1511156497797985', 1, 0, '', NULL, NULL, NULL),
(54066, '2017-11-20 13:41:37', NULL, NULL, 14676, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:41:38', 'admin-1511139560-1511156497797985', 1, 0, '', NULL, NULL, NULL),
(54067, '2017-11-20 13:42:38', NULL, NULL, 14676, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:42:38', 'admin-1511139560-15111565581432878', 1, 1, 'SR', NULL, NULL, NULL),
(54068, '2017-11-20 13:42:38', NULL, NULL, 14676, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:42:38', 'admin-1511139560-15111565581432878', 1, 1, 'SR', NULL, NULL, NULL),
(54069, '2017-11-20 14:48:44', NULL, NULL, 14679, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 14:48:44', 'admin-1511139560-15111605240345849', 1, 0, '', NULL, NULL, NULL),
(54070, '2017-11-20 13:54:42', NULL, NULL, 14677, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:54:42', 'admin-1511139560-15111572826155023', 1, 1, 'SR', 1, NULL, '10.0'),
(54071, '2017-11-20 13:37:38', NULL, NULL, 14675, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:37:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54072, '2017-11-20 12:27:57', NULL, NULL, 14669, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:27:57', 'admin-1511139560-15111520771992475', 1, 1, 'SR', NULL, NULL, NULL),
(54073, '2017-11-20 12:27:57', NULL, NULL, 14669, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:27:57', 'admin-1511139560-15111520771992475', 1, 1, 'SR', NULL, NULL, NULL),
(54074, '2017-11-20 09:31:49', NULL, NULL, 14659, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 09:31:49', 'admin-1511139560-15111415091204681', 1, 0, '', NULL, NULL, NULL),
(54075, '2017-11-20 09:34:24', NULL, NULL, 14661, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1511139560', 'admin', '2017-11-20 09:34:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54076, '2017-11-20 13:37:44', NULL, NULL, 14675, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:37:44', 'admin-1511139560-15111562645319329', 1, 1, 'SR', NULL, NULL, NULL),
(54077, '2017-11-20 11:00:47', NULL, NULL, 14664, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 11:00:47', 'admin-1511139560-15111468478046891', 1, 1, 'SR', NULL, NULL, NULL),
(54078, '2017-11-20 10:37:22', NULL, NULL, 14663, 0, 154, '88', 'Daily Dose BLT', 'change to sausage', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 10:37:22', 'admin-1511139560-15111454427303642', 1, 0, '', NULL, NULL, NULL),
(54079, '2017-11-20 13:14:46', NULL, NULL, 14674, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:14:46', 'admin-1511139560-15111548862046429', 1, 0, '', NULL, NULL, NULL),
(54080, '2017-11-20 09:31:49', NULL, NULL, 14659, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 09:31:49', 'admin-1511139560-15111415091204681', 1, 1, 'SR', NULL, NULL, NULL),
(54081, '2017-11-20 14:48:44', NULL, NULL, 14679, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 14:48:44', 'admin-1511139560-15111605240345849', 1, 1, 'SR', NULL, NULL, NULL),
(54082, '2017-11-20 14:48:44', NULL, NULL, 14679, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 14:48:44', 'admin-1511139560-15111605240345849', 1, 1, 'SR', NULL, NULL, NULL),
(54083, '2017-11-20 12:59:47', NULL, NULL, 14672, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:59:47', 'admin-1511139560-15111539874036390', 1, 1, 'SR', NULL, NULL, NULL),
(54084, '2017-11-20 13:00:11', NULL, NULL, 14671, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:00:11', 'admin-1511139560-15111540113003795', 1, 0, '', NULL, NULL, NULL),
(54085, '2017-11-20 13:00:11', NULL, NULL, 14671, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:00:11', 'admin-1511139560-15111540113003795', 1, 1, 'SR', NULL, NULL, NULL),
(54086, '2017-11-20 11:18:10', NULL, NULL, 14666, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1511139560', 'admin', '2017-11-20 11:18:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54087, '2017-11-20 11:19:40', NULL, NULL, 14666, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 2, 16.00, 32.0000, 0.0000, 32.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 11:19:40', 'admin-1511139560-15111479802978934', 1, 0, '', NULL, NULL, NULL),
(54088, '2017-11-20 11:19:40', NULL, NULL, 14666, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 11:19:40', 'admin-1511139560-15111479802978934', 1, 1, 'SR', NULL, NULL, NULL),
(54089, '2017-11-20 11:19:40', NULL, NULL, 14666, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 11:19:40', 'admin-1511139560-15111479802978934', 1, 1, 'SR', NULL, NULL, NULL),
(54090, '2017-11-20 12:15:06', NULL, NULL, 14667, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:15:06', 'admin-1511139560-15111513060199882', 1, 1, 'SR', NULL, NULL, NULL),
(54091, '2017-11-20 12:15:06', NULL, NULL, 14667, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:15:06', 'admin-1511139560-15111513060199882', 1, 1, 'SR', NULL, NULL, NULL),
(54092, '2017-11-20 12:15:06', NULL, NULL, 14667, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:15:06', 'admin-1511139560-15111513060199882', 1, 0, '', NULL, NULL, NULL),
(54093, '2017-11-20 13:14:46', NULL, NULL, 14674, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:14:46', 'admin-1511139560-15111548862046429', 1, 1, 'SR', NULL, NULL, NULL),
(54094, '2017-11-20 12:38:33', NULL, NULL, 14671, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:38:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54095, '2017-11-20 14:32:04', NULL, NULL, 14678, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1511139560', 'admin', '2017-11-20 14:32:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54096, '2017-11-20 14:32:12', NULL, NULL, 14678, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 14:32:12', 'admin-1511139560-15111595318785670', 1, 0, '', NULL, NULL, NULL),
(54097, '2017-11-20 12:18:02', NULL, NULL, 14668, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:18:02', 'admin-1511139560-1511151482454407', 1, 1, 'SR', NULL, NULL, NULL),
(54098, '2017-11-20 13:13:40', NULL, NULL, 14674, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.90, 0.0000, 0.0000, 13.90, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:13:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54099, '2017-11-20 13:14:46', NULL, NULL, 14674, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:14:46', 'admin-1511139560-15111548862046429', 1, 0, '', NULL, NULL, NULL),
(54100, '2017-11-20 13:00:11', NULL, NULL, 14671, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:00:11', 'admin-1511139560-15111540113003795', 1, 1, 'SR', NULL, NULL, NULL),
(54101, '2017-11-20 13:00:27', NULL, NULL, 14673, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:00:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54102, '2017-11-20 13:00:40', NULL, NULL, 14673, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:00:40', 'admin-1511139560-15111540406507182', 1, 0, '', NULL, NULL, NULL),
(54103, '2017-11-20 14:01:12', NULL, NULL, 14675, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 14:01:12', 'admin-1511139560-15111576727669970', 1, 1, 'SR', NULL, NULL, NULL),
(54104, '2017-11-20 12:14:50', NULL, NULL, 14667, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:14:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54105, '2017-11-20 11:00:47', NULL, NULL, 14664, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 11:00:47', 'admin-1511139560-15111468478046891', 1, 1, 'SR', NULL, NULL, NULL),
(54106, '2017-11-20 11:00:47', NULL, NULL, 14664, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 11:00:47', 'admin-1511139560-15111468478046891', 1, 0, '', NULL, NULL, NULL),
(54107, '2017-11-20 11:00:48', NULL, NULL, 14664, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 11:00:48', 'admin-1511139560-15111468478046891', 1, 0, '', NULL, NULL, NULL),
(54108, '2017-11-20 13:41:30', NULL, NULL, 14676, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:41:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54109, '2017-11-20 13:14:46', NULL, NULL, 14674, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:14:46', 'admin-1511139560-15111548862046429', 1, 1, 'SR', NULL, NULL, NULL),
(54110, '2017-11-20 13:14:46', NULL, NULL, 14674, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:14:46', 'admin-1511139560-15111548862046429', 1, 1, 'SR', NULL, NULL, NULL),
(54111, '2017-11-20 13:14:46', NULL, NULL, 14674, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:14:46', 'admin-1511139560-15111548862046429', 1, 0, '', NULL, NULL, NULL),
(54112, '2017-11-20 13:14:46', NULL, NULL, 14674, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:14:46', 'admin-1511139560-15111548862046429', 1, 0, '', NULL, NULL, NULL),
(54113, '2017-11-20 13:14:46', NULL, NULL, 14674, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:14:46', 'admin-1511139560-15111548862046429', 1, 0, '', NULL, NULL, NULL),
(54114, '2017-11-20 14:48:44', NULL, NULL, 14679, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 14:48:44', 'admin-1511139560-15111605240345849', 1, 1, 'SR', NULL, NULL, NULL),
(54115, '2017-11-20 13:00:40', NULL, NULL, 14673, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:00:40', 'admin-1511139560-15111540406507182', 1, 0, '', NULL, NULL, NULL),
(54116, '2017-11-20 12:59:37', NULL, NULL, 14672, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:59:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54117, '2017-11-20 12:53:06', NULL, NULL, 14671, 0, 181, '116', 'Open Food ', 'lemony chicken', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:53:06', 'admin-1511139560-15111535866756776', 1, 0, '', NULL, NULL, NULL),
(54118, '2017-11-20 12:52:01', NULL, NULL, 14669, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:52:01', 'admin-1511139560-1511153521793693', 1, 0, '', NULL, NULL, NULL),
(54119, '2017-11-20 12:38:41', NULL, NULL, 14671, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:38:41', 'admin-1511139560-15111527214857233', 1, 0, '', NULL, NULL, NULL),
(54120, '2017-11-20 10:37:22', NULL, NULL, 14663, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 10:37:22', 'admin-1511139560-15111454427303642', 1, 0, '', NULL, NULL, NULL),
(54121, '2017-11-20 10:37:22', NULL, NULL, 14663, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 10:37:22', 'admin-1511139560-15111454427303642', 1, 1, 'SR', NULL, NULL, NULL),
(54122, '2017-11-20 12:15:06', NULL, NULL, 14667, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:15:06', 'admin-1511139560-15111513060199882', 1, 1, 'SR', NULL, NULL, NULL),
(54123, '2017-11-20 12:15:06', NULL, NULL, 14667, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:15:06', 'admin-1511139560-15111513060199882', 1, 1, 'SR', NULL, NULL, NULL),
(54124, '2017-11-20 12:17:47', NULL, NULL, 14668, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:17:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54125, '2017-11-20 12:18:02', NULL, NULL, 14668, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:18:02', 'admin-1511139560-1511151482454407', 1, 1, 'SR', NULL, NULL, NULL),
(54126, '2017-11-20 13:14:46', NULL, NULL, 14674, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 13:14:46', 'admin-1511139560-15111548862046429', 1, 1, 'SR', NULL, NULL, NULL),
(54127, '2017-11-20 12:33:24', NULL, NULL, 14670, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:33:24', 'admin-1511139560-15111524044869125', 1, 1, 'SR', NULL, NULL, NULL),
(54128, '2017-11-20 12:27:49', NULL, NULL, 14669, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.19, 0.0000, 0.0000, 4.19, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:27:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54129, '2017-11-20 12:27:57', NULL, NULL, 14669, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:27:57', 'admin-1511139560-15111520771992475', 1, 0, '', NULL, NULL, NULL),
(54130, '2017-11-20 12:33:06', NULL, NULL, 14670, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:33:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54131, '2017-11-20 12:33:24', NULL, NULL, 14670, 0, 73, '73', 'Marmite Chicken ', 'change to olio pasta', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:33:24', 'admin-1511139560-15111524044869125', 1, 1, 'SR', NULL, NULL, NULL),
(54132, '2017-11-20 12:18:02', NULL, NULL, 14668, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:18:02', 'admin-1511139560-1511151482454407', 1, 1, 'SR', NULL, NULL, NULL),
(54133, '2017-11-20 12:38:41', NULL, NULL, 14671, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:38:41', 'admin-1511139560-15111527214857233', 1, 0, '', NULL, NULL, NULL),
(54134, '2017-11-20 09:16:20', NULL, NULL, 14659, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1511139560', 'admin', '2017-11-20 09:16:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54135, '2017-11-20 12:18:02', NULL, NULL, 14668, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:18:02', 'admin-1511139560-1511151482454407', 1, 0, '', NULL, NULL, NULL),
(54136, '2017-11-20 10:16:35', NULL, NULL, 14662, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 10:16:35', 'admin-1511139560-15111441950353326', 1, 1, 'SR', NULL, NULL, NULL),
(54137, '2017-11-20 10:16:35', NULL, NULL, 14662, 0, 156, '90', 'House Cheddar Omelet', 'add potato', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 10:16:35', 'admin-1511139560-15111441950353326', 1, 0, '', NULL, NULL, NULL),
(54138, '2017-11-20 10:18:03', NULL, NULL, 14660, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1511139560', 'admin', '2017-11-20 10:18:03', 'admin-1511139560-15111442836953828', 1, 0, '', NULL, NULL, NULL),
(54139, '2017-11-20 10:19:42', NULL, NULL, 14661, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 10:19:42', 'admin-1511139560-15111443822366228', 1, 1, 'SR', NULL, NULL, NULL),
(54140, '2017-11-20 10:19:42', NULL, NULL, 14661, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 10:19:42', 'admin-1511139560-15111443822366228', 1, 0, '', NULL, NULL, NULL),
(54141, '2017-11-20 10:37:05', NULL, NULL, 14663, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1511139560', 'admin', '2017-11-20 10:37:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54142, '2017-11-20 10:37:22', NULL, NULL, 14663, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 10:37:22', 'admin-1511139560-15111454427303642', 1, 1, 'SR', NULL, NULL, NULL),
(54143, '2017-11-20 11:11:44', NULL, NULL, 14665, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 11:11:44', 'admin-1511139560-15111475041512463', 1, 0, '', NULL, NULL, NULL),
(54144, '2017-11-20 09:17:54', NULL, NULL, 14660, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.19, 0.0000, 0.0000, 3.19, 1, '27', 1, '1511139560', 'admin', '2017-11-20 09:17:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54145, '2017-11-20 09:19:36', NULL, NULL, 14660, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 09:19:36', 'admin-1511139560-15111407761998684', 1, 0, '', NULL, NULL, NULL),
(54146, '2017-11-20 09:19:36', NULL, NULL, 14660, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 09:19:36', 'admin-1511139560-15111407761998684', 1, 1, 'SR', NULL, NULL, NULL),
(54147, '2017-11-20 11:10:54', NULL, NULL, 14665, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1511139560', 'admin', '2017-11-20 11:10:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54148, '2017-11-20 11:00:30', NULL, NULL, 14664, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1511139560', 'admin', '2017-11-20 11:00:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54149, '2017-11-20 12:18:02', NULL, NULL, 14668, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 12:18:02', 'admin-1511139560-1511151482454407', 1, 1, 'SR', NULL, NULL, NULL),
(54150, '2017-11-20 09:36:46', NULL, NULL, 14661, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 09:36:46', 'admin-1511139560-1511141806508546', 1, 0, '', NULL, NULL, NULL),
(54151, '2017-11-20 09:36:46', NULL, NULL, 14661, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 09:36:46', 'admin-1511139560-1511141806508546', 1, 0, '', NULL, NULL, NULL),
(54152, '2017-11-20 09:36:46', NULL, NULL, 14661, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 09:36:46', 'admin-1511139560-1511141806508546', 1, 0, '', NULL, NULL, NULL),
(54153, '2017-11-20 10:15:30', NULL, NULL, 14662, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1511139560', 'admin', '2017-11-20 10:15:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54154, '2017-11-20 11:11:44', NULL, NULL, 14665, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 11:11:44', 'admin-1511139560-15111475041512463', 1, 0, '', NULL, NULL, NULL),
(54155, '2017-11-20 09:36:46', NULL, NULL, 14661, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 09:36:46', 'admin-1511139560-1511141806508546', 1, 1, 'SR', NULL, NULL, NULL),
(54156, '2017-11-20 09:16:29', NULL, NULL, 14659, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 09:16:29', 'admin-1511139560-15111405896722010', 1, 1, 'SR', NULL, NULL, NULL),
(54157, '2017-11-20 09:16:29', NULL, NULL, 14659, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511139560', 'admin', '2017-11-20 09:16:29', 'admin-1511139560-15111405896722010', 1, 0, '', NULL, NULL, NULL),
(54158, '2017-11-22 14:13:38', NULL, NULL, 14689, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511322682', 'admin', '2017-11-22 14:13:38', 'admin-1511322682-15113312178798758', 1, 1, 'SR', 1, NULL, '10.0'),
(54159, '2017-11-22 14:17:57', NULL, NULL, 14690, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511322682', 'admin', '2017-11-22 14:17:57', 'admin-1511322682-15113314776348043', 1, 0, '', NULL, NULL, NULL),
(54160, '2017-11-22 14:17:57', NULL, NULL, 14690, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511322682', 'admin', '2017-11-22 14:17:57', 'admin-1511322682-15113314776348043', 1, 1, 'SR', NULL, NULL, NULL),
(54161, '2017-11-22 13:00:32', NULL, NULL, 14685, 0, 73, '73', 'Marmite Chicken ', 'Pasta', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1511322682', 'admin', '2017-11-22 13:00:32', 'admin-1511322682-15113268323734110', 1, 1, 'SR', NULL, NULL, '10.0'),
(54162, '2017-11-22 13:00:32', NULL, NULL, 14685, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511322682', 'admin', '2017-11-22 13:00:32', 'admin-1511322682-15113268323734110', 1, 1, 'SR', NULL, NULL, '10.0'),
(54163, '2017-11-22 13:19:54', NULL, NULL, 14688, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511322682', 'admin', '2017-11-22 13:19:54', 'admin-1511322682-15113279948011718', 1, 1, 'SR', NULL, NULL, NULL),
(54164, '2017-11-22 13:17:41', NULL, NULL, 14687, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511322682', 'admin', '2017-11-22 13:17:41', 'admin-1511322682-15113278608948272', 1, 1, 'SR', NULL, NULL, '10.0'),
(54165, '2017-11-22 13:00:15', NULL, NULL, 14685, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1511322682', 'admin', '2017-11-22 13:00:15', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(54166, '2017-11-22 12:11:01', NULL, NULL, 14684, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511322682', 'admin', '2017-11-22 12:11:01', 'admin-1511322682-15113238608976298', 1, 0, '', NULL, NULL, '10.0'),
(54167, '2017-11-22 12:11:01', NULL, NULL, 14684, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511322682', 'admin', '2017-11-22 12:11:01', 'admin-1511322682-15113238608976298', 1, 1, 'SR', NULL, NULL, '10.0'),
(54168, '2017-11-22 13:01:50', NULL, NULL, 14685, 0, 301, '237', 'Black Jack', '', 'Cold Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511322682', 'admin', '2017-11-22 13:01:50', 'admin-1511322682-15113269099176659', 1, 0, '', NULL, NULL, '10.0'),
(54169, '2017-11-22 13:15:21', NULL, NULL, 14686, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1511322682', 'admin', '2017-11-22 13:15:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54170, '2017-11-22 13:15:27', NULL, NULL, 14686, 0, 192, '127', 'Flaming Hot & Spicy Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511322682', 'admin', '2017-11-22 13:15:27', 'admin-1511322682-15113277273945655', 1, 0, '', NULL, NULL, NULL),
(54171, '2017-11-22 13:15:27', NULL, NULL, 14686, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511322682', 'admin', '2017-11-22 13:15:27', 'admin-1511322682-15113277273945655', 1, 1, 'SR', NULL, NULL, NULL),
(54172, '2017-11-22 13:17:37', NULL, NULL, 14687, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1511322682', 'admin', '2017-11-22 13:17:37', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(54173, '2017-11-22 14:17:49', NULL, NULL, 14690, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1511322682', 'admin', '2017-11-22 14:17:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54174, '2017-11-22 11:53:10', NULL, NULL, 14683, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511322682', 'admin', '2017-11-22 11:53:10', 'admin-1511322682-1511322790118595', 1, 1, 'SR', 1, NULL, '10.0'),
(54175, '2017-11-22 14:24:44', NULL, NULL, 14691, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511322682', 'admin', '2017-11-22 14:24:44', 'admin-1511322682-15113318839655210', 1, 0, '', NULL, NULL, NULL),
(54176, '2017-11-22 14:24:16', NULL, NULL, 14691, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1511322682', 'admin', '2017-11-22 14:24:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54177, '2017-11-22 13:19:39', NULL, NULL, 14688, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1511322682', 'admin', '2017-11-22 13:19:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54178, '2017-11-22 11:41:45', NULL, NULL, 14681, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1511322682', 'admin', '2017-11-22 11:41:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54179, '2017-11-22 11:42:03', NULL, NULL, 14681, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511322682', 'admin', '2017-11-22 11:42:03', 'admin-1511312483-15113221237477260', 1, 0, '', NULL, NULL, NULL),
(54180, '2017-11-22 11:42:03', NULL, NULL, 14681, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1511322682', 'admin', '2017-11-22 11:42:03', 'admin-1511312483-15113221237477260', 1, 0, '', NULL, NULL, NULL),
(54181, '2017-11-22 12:10:29', NULL, NULL, 14684, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1511322682', 'admin', '2017-11-22 12:10:29', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(54182, '2017-11-22 12:11:01', NULL, NULL, 14684, 0, 73, '73', 'Marmite Chicken ', 'Pasta', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1511322682', 'admin', '2017-11-22 12:11:01', 'admin-1511322682-15113238608976298', 1, 1, 'SR', NULL, NULL, '10.0');
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(54183, '2017-11-22 11:14:20', NULL, NULL, 14680, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1511322682', 'admin', '2017-11-22 11:14:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54184, '2017-11-22 11:14:24', NULL, NULL, 14680, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511322682', 'admin', '2017-11-22 11:14:24', 'admin-1511312483-15113204641133224', 1, 0, '', NULL, NULL, NULL),
(54185, '2017-11-22 11:14:31', NULL, NULL, 14680, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511322682', 'admin', '2017-11-22 11:14:31', 'admin-1511312483-15113204711572155', 1, 0, '', NULL, NULL, NULL),
(54186, '2017-11-23 15:15:48', NULL, NULL, 14703, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 15:15:48', 'admin-1511400080-15114213487528516', 1, 0, '', NULL, NULL, NULL),
(54187, '2017-11-23 15:06:35', NULL, NULL, 14703, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1511400080', 'admin', '2017-11-23 15:06:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54188, '2017-11-23 15:15:48', NULL, NULL, 14703, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 15:15:48', 'admin-1511400080-15114213487528516', 1, 1, 'SR', NULL, NULL, NULL),
(54189, '2017-11-23 15:29:15', NULL, NULL, 14704, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 15:29:15', 'admin-1511400080-1511422155582467', 1, 1, 'SR', 1, NULL, '10.0'),
(54190, '2017-11-23 13:00:15', NULL, NULL, 14697, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 13:00:15', 'admin-1511400080-15114132157245551', 1, 0, '', NULL, NULL, NULL),
(54191, '2017-11-23 13:00:15', NULL, NULL, 14697, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 13:00:15', 'admin-1511400080-15114132157245551', 1, 1, 'SR', NULL, NULL, NULL),
(54192, '2017-11-23 15:40:46', NULL, NULL, 14705, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 15:40:46', 'admin-1511400080-15114228466624482', 1, 1, 'SR', NULL, NULL, NULL),
(54193, '2017-11-23 13:16:20', NULL, NULL, 14700, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1511400080', 'admin', '2017-11-23 13:16:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54194, '2017-11-23 13:14:32', NULL, NULL, 14699, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 13:14:32', 'admin-1511400080-15114140722822740', 1, 1, 'SR', NULL, NULL, NULL),
(54195, '2017-11-23 10:49:02', NULL, NULL, 14693, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 10:49:02', 'admin-1511400080-15114053421421670', 1, 1, 'SR', NULL, NULL, NULL),
(54196, '2017-11-23 12:01:28', NULL, NULL, 14694, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1511400080', 'admin', '2017-11-23 12:01:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54197, '2017-11-23 12:01:44', NULL, NULL, 14694, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 12:01:44', 'admin-1511400080-1511409704068824', 1, 0, '', NULL, NULL, NULL),
(54198, '2017-11-23 16:01:51', NULL, NULL, 14710, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1511400080', 'admin', '2017-11-23 16:01:51', '0', 1, 1, 'SR', NULL, NULL, '1.0'),
(54199, '2017-11-23 16:01:54', NULL, NULL, 14710, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 16:01:54', 'admin-1511400080-15114241140479682', 1, 1, 'SR', NULL, NULL, '1.0'),
(54200, '2017-11-23 12:01:44', NULL, NULL, 14694, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 12:01:44', 'admin-1511400080-1511409704068824', 1, 1, 'SR', NULL, NULL, NULL),
(54201, '2017-11-23 12:01:44', NULL, NULL, 14694, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 12:01:44', 'admin-1511400080-1511409704068824', 1, 1, 'SR', NULL, NULL, NULL),
(54202, '2017-11-23 12:53:35', NULL, NULL, 14695, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1511400080', 'admin', '2017-11-23 12:53:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54203, '2017-11-23 15:40:39', NULL, NULL, 14705, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1511400080', 'admin', '2017-11-23 15:40:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54204, '2017-11-23 15:40:46', NULL, NULL, 14705, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 15:40:46', 'admin-1511400080-15114228466624482', 1, 0, '', NULL, NULL, NULL),
(54205, '2017-11-23 15:02:39', NULL, NULL, 14702, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1511400080', 'admin', '2017-11-23 15:02:39', 'admin-1511400080-15114205596154631', 1, 0, '', NULL, NULL, '10.0'),
(54206, '2017-11-23 15:02:39', NULL, NULL, 14702, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 15:02:39', 'admin-1511400080-15114205596154631', 1, 0, '', NULL, NULL, '10.0'),
(54207, '2017-11-23 16:01:48', NULL, NULL, 14703, 0, 182, '117', 'Open Drinks ', 'Heineken', 'Cold Drinks', 'Fresh Juice', 1, 50.00, 50.0000, 0.0000, 50.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 16:01:48', 'admin-1511400080-15114241083199048', 1, 0, '', NULL, NULL, NULL),
(54208, '2017-11-23 15:54:59', NULL, NULL, 14708, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 15:54:59', 'admin-1511400080-15114236991379614', 1, 1, 'SR', NULL, NULL, NULL),
(54209, '2017-11-23 15:54:59', NULL, NULL, 14708, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 15:54:59', 'admin-1511400080-15114236991379614', 1, 0, '', NULL, NULL, NULL),
(54210, '2017-11-23 15:56:42', NULL, NULL, 14709, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1511400080', 'admin', '2017-11-23 15:56:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54211, '2017-11-23 15:56:46', NULL, NULL, 14709, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 15:56:46', 'admin-1511400080-15114238060036340', 1, 1, 'SR', NULL, NULL, NULL),
(54212, '2017-11-23 15:54:47', NULL, NULL, 14708, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 15:54:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54213, '2017-11-23 15:45:24', NULL, NULL, 14706, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 15:45:24', 'admin-1511400080-15114231242311953', 1, 0, '', 1, NULL, NULL),
(54214, '2017-11-23 15:40:46', NULL, NULL, 14705, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 15:40:46', 'admin-1511400080-15114228466624482', 1, 1, 'SR', NULL, NULL, NULL),
(54215, '2017-11-23 14:49:00', NULL, NULL, 14702, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.69, 0.0000, 0.0000, 4.69, 1, '27', 1, '1511400080', 'admin', '2017-11-23 14:49:00', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(54216, '2017-11-23 14:50:14', NULL, NULL, 14702, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 14:50:14', 'admin-1511400080-15114198138786176', 1, 1, 'SR', NULL, NULL, '10.0'),
(54217, '2017-11-23 15:02:39', NULL, NULL, 14702, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 15:02:39', 'admin-1511400080-15114205596154631', 1, 1, 'SR', NULL, NULL, '10.0'),
(54218, '2017-11-23 14:50:14', NULL, NULL, 14702, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 14:50:14', 'admin-1511400080-15114198138786176', 1, 1, 'SR', NULL, NULL, '10.0'),
(54219, '2017-11-23 14:50:14', NULL, NULL, 14702, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 14:50:14', 'admin-1511400080-15114198138786176', 1, 0, '', NULL, NULL, '10.0'),
(54220, '2017-11-23 13:51:39', NULL, NULL, 14701, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 13:51:39', 'admin-1511400080-15114162993897992', 1, 1, 'SR', NULL, NULL, NULL),
(54221, '2017-11-23 13:14:28', NULL, NULL, 14699, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1511400080', 'admin', '2017-11-23 13:14:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54222, '2017-11-23 13:51:39', NULL, NULL, 14701, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 13:51:39', 'admin-1511400080-15114162993897992', 1, 1, 'SR', NULL, NULL, NULL),
(54223, '2017-11-23 13:49:17', NULL, NULL, 14701, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1511400080', 'admin', '2017-11-23 13:49:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54224, '2017-11-23 13:07:09', NULL, NULL, 14698, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 13:07:09', 'admin-1511400080-15114136292311084', 1, 1, 'SR', NULL, NULL, NULL),
(54225, '2017-11-23 13:07:09', NULL, NULL, 14698, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 13:07:09', 'admin-1511400080-15114136292311084', 1, 0, '', NULL, NULL, NULL),
(54226, '2017-11-23 12:01:44', NULL, NULL, 14694, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 12:01:44', 'admin-1511400080-1511409704068824', 1, 0, '', NULL, NULL, NULL),
(54227, '2017-11-23 13:06:30', NULL, NULL, 14698, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1511400080', 'admin', '2017-11-23 13:06:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54228, '2017-11-23 13:00:09', NULL, NULL, 14697, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1511400080', 'admin', '2017-11-23 13:00:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54229, '2017-11-23 13:00:03', NULL, NULL, 14696, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 13:00:03', 'admin-1511400080-15114132028777569', 1, 0, '', NULL, NULL, NULL),
(54230, '2017-11-23 13:16:25', NULL, NULL, 14700, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 13:16:25', 'admin-1511400080-15114141858199160', 1, 1, 'SR', NULL, NULL, NULL),
(54231, '2017-11-23 13:00:03', NULL, NULL, 14696, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 13:00:03', 'admin-1511400080-15114132028777569', 1, 0, '', NULL, NULL, NULL),
(54232, '2017-11-23 13:00:03', NULL, NULL, 14696, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 13:00:03', 'admin-1511400080-15114132028777569', 1, 0, '', NULL, NULL, NULL),
(54233, '2017-11-23 12:53:42', NULL, NULL, 14695, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 12:53:42', 'admin-1511400080-15114128223491258', 1, 1, 'SR', NULL, NULL, NULL),
(54234, '2017-11-23 12:53:42', NULL, NULL, 14695, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 12:53:42', 'admin-1511400080-15114128223491258', 1, 1, 'SR', NULL, NULL, NULL),
(54235, '2017-11-23 13:00:03', NULL, NULL, 14696, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 13:00:03', 'admin-1511400080-15114132028777569', 1, 0, '', NULL, NULL, NULL),
(54236, '2017-11-23 15:45:41', NULL, NULL, 14707, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 15:45:41', 'admin-1511400080-15114231412951948', 1, 0, '', 1, NULL, '10.0'),
(54237, '2017-11-23 09:43:49', NULL, NULL, 14692, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1511400080', 'admin', '2017-11-23 09:43:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54238, '2017-11-23 09:43:58', NULL, NULL, 14692, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 09:43:58', 'admin-1511400080-15114014383016279', 1, 0, '', NULL, NULL, NULL),
(54239, '2017-11-23 09:43:58', NULL, NULL, 14692, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 09:43:58', 'admin-1511400080-15114014383016279', 1, 0, '', NULL, NULL, NULL),
(54240, '2017-11-23 10:01:41', NULL, NULL, 14692, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 10:01:41', 'admin-1511400080-15114025013908444', 1, 0, '', NULL, NULL, NULL),
(54241, '2017-11-23 10:46:39', NULL, NULL, 14693, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1511400080', 'admin', '2017-11-23 10:46:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54242, '2017-11-23 12:59:41', NULL, NULL, 14696, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1511400080', 'admin', '2017-11-23 12:59:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54243, '2017-11-23 12:01:44', NULL, NULL, 14694, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 12:01:44', 'admin-1511400080-1511409704068824', 1, 0, '', NULL, NULL, NULL),
(54244, '2017-11-23 10:49:02', NULL, NULL, 14693, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 10:49:02', 'admin-1511400080-15114053421421670', 1, 0, '', NULL, NULL, NULL),
(54245, '2017-11-23 10:49:02', NULL, NULL, 14693, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511400080', 'admin', '2017-11-23 10:49:02', 'admin-1511400080-15114053421421670', 1, 0, '', NULL, NULL, NULL),
(54246, '2017-11-24 00:00:00', NULL, NULL, 14720, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 13:04:03', 'admin-1511485303-15114998430897034', 1, 1, 'SR', NULL, NULL, NULL),
(54247, '2017-11-24 12:37:45', NULL, NULL, 14716, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 12:37:45', 'admin-1511485303-15114982651465112', 1, 0, '', NULL, NULL, NULL),
(54248, '2017-11-24 11:14:41', NULL, NULL, 14711, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 11:14:41', 'admin-1511485303-15114932810513492', 1, 0, '', NULL, NULL, NULL),
(54249, '2017-11-24 11:14:41', NULL, NULL, 14711, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 11:14:41', 'admin-1511485303-15114932810513492', 1, 0, '', NULL, NULL, NULL),
(54250, '2017-11-24 13:15:31', NULL, NULL, 14716, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 13:15:31', 'admin-1511485303-1511500531450223', 1, 1, 'SR', NULL, NULL, NULL),
(54251, '2017-11-24 11:11:09', NULL, NULL, 14712, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 11:11:09', 'admin-1511485303-15114930696468950', 1, 0, '', NULL, NULL, NULL),
(54252, '2017-11-24 11:11:09', NULL, NULL, 14712, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 11:11:09', 'admin-1511485303-15114930696468950', 1, 0, '', NULL, NULL, NULL),
(54253, '2017-11-24 11:11:09', NULL, NULL, 14712, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 11:11:09', 'admin-1511485303-15114930696468950', 1, 0, '', NULL, NULL, NULL),
(54254, '2017-11-24 11:11:09', NULL, NULL, 14712, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 11:11:09', 'admin-1511485303-15114930696468950', 1, 1, 'SR', NULL, NULL, NULL),
(54255, '2017-11-24 11:11:09', NULL, NULL, 14712, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 11:11:09', 'admin-1511485303-15114930696468950', 1, 1, 'SR', NULL, NULL, NULL),
(54256, '2017-11-24 11:11:09', NULL, NULL, 14712, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 11:11:09', 'admin-1511485303-15114930696468950', 1, 1, 'SR', NULL, NULL, NULL),
(54257, '2017-11-24 12:03:36', NULL, NULL, 14714, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1511485303', 'admin', '2017-11-24 12:03:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54258, '2017-11-24 14:16:06', NULL, NULL, 14719, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 14:16:06', 'admin-1511485303-15115041667431715', 1, 0, '', NULL, NULL, NULL),
(54259, '2017-11-24 13:25:59', NULL, NULL, 14721, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1511485303', 'admin', '2017-11-24 13:25:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54260, '2017-11-24 13:25:33', NULL, NULL, 14720, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1511485303', 'admin', '2017-11-24 13:25:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54261, '2017-11-24 00:00:00', NULL, NULL, 14721, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 13:03:56', 'admin-1511485303-15114998358981575', 1, 0, '', NULL, NULL, NULL),
(54262, '2017-11-24 16:11:14', NULL, NULL, 14723, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 16:11:14', 'admin-1511485303-1511511074553907', 1, 1, 'SR', NULL, NULL, NULL),
(54263, '2017-11-24 16:11:14', NULL, NULL, 14723, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 16:11:14', 'admin-1511485303-1511511074553907', 1, 0, '', NULL, NULL, NULL),
(54264, '2017-11-24 16:11:07', NULL, NULL, 14723, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1511485303', 'admin', '2017-11-24 16:11:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54265, '2017-11-24 13:28:09', NULL, NULL, 14722, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 13:28:09', 'admin-1511485303-1511501289060892', 1, 1, 'SR', NULL, NULL, NULL),
(54266, '2017-11-24 13:28:09', NULL, NULL, 14722, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 13:28:09', 'admin-1511485303-1511501289060892', 1, 1, 'SR', NULL, NULL, NULL),
(54267, '2017-11-24 11:59:12', NULL, NULL, 14713, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 11:59:12', 'admin-1511485303-15114959522811260', 1, 0, '', NULL, NULL, '10.0'),
(54268, '2017-11-24 11:59:12', NULL, NULL, 14713, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 11:59:12', 'admin-1511485303-15114959522811260', 1, 1, 'SR', NULL, NULL, '10.0'),
(54269, '2017-11-24 13:27:44', NULL, NULL, 14722, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1511485303', 'admin', '2017-11-24 13:27:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54270, '2017-11-24 13:18:59', NULL, NULL, 14719, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 13:18:59', 'admin-1511485303-15115007390575466', 1, 1, 'SR', NULL, NULL, NULL),
(54271, '2017-11-24 00:00:00', NULL, NULL, 14720, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, NULL, NULL, 6.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 13:03:56', 'admin-1511485303-15114998358981575', 1, 1, 'SR', NULL, NULL, NULL),
(54272, '2017-11-24 13:03:46', NULL, NULL, 14719, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1511485303', 'admin', '2017-11-24 13:03:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54273, '2017-11-24 13:15:31', NULL, NULL, 14716, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 13:15:31', 'admin-1511485303-1511500531450223', 1, 1, 'SR', NULL, NULL, NULL),
(54274, '2017-11-24 00:00:00', NULL, NULL, 14720, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 13:03:56', 'admin-1511485303-15114998358981575', 1, 0, '', NULL, NULL, NULL),
(54275, '2017-11-24 12:58:27', NULL, NULL, 14717, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1511485303', 'admin', '2017-11-24 12:58:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54276, '2017-11-24 12:58:43', NULL, NULL, 14717, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 12:58:43', 'admin-1511485303-15114995229594568', 1, 1, 'SR', NULL, NULL, NULL),
(54277, '2017-11-24 12:58:43', NULL, NULL, 14717, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 12:58:43', 'admin-1511485303-15114995229594568', 1, 0, '', NULL, NULL, NULL),
(54278, '2017-11-24 12:37:45', NULL, NULL, 14716, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 12:37:45', 'admin-1511485303-15114982651465112', 1, 1, 'SR', NULL, NULL, NULL),
(54279, '2017-11-24 12:37:45', NULL, NULL, 14716, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 12:37:45', 'admin-1511485303-15114982651465112', 1, 0, '', NULL, NULL, NULL),
(54280, '2017-11-24 12:21:25', NULL, NULL, 14715, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 12:21:25', 'admin-1511485303-15114972852072138', 1, 0, '', NULL, NULL, NULL),
(54281, '2017-11-24 12:37:32', NULL, NULL, 14716, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1511485303', 'admin', '2017-11-24 12:37:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54282, '2017-11-24 11:59:12', NULL, NULL, 14713, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 11:59:12', 'admin-1511485303-15114959522811260', 1, 1, 'SR', NULL, NULL, '10.0'),
(54283, '2017-11-24 11:59:12', NULL, NULL, 14713, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 11:59:12', 'admin-1511485303-15114959522811260', 1, 1, 'SR', NULL, NULL, '10.0'),
(54284, '2017-11-24 11:59:12', NULL, NULL, 14713, 0, 77, '77', 'Sarawak Kolomee', 'add sunny side up', 'Meals', 'Non-Rice', 1, 13.50, 13.5000, 0.0000, 13.50, 1, '27', 1, '1511485303', 'admin', '2017-11-24 11:59:12', 'admin-1511485303-15114959522811260', 1, 1, 'SR', NULL, NULL, '10.0'),
(54285, '2017-11-24 12:21:20', NULL, NULL, 14715, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1511485303', 'admin', '2017-11-24 12:21:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54286, '2017-11-24 12:05:42', NULL, NULL, 14713, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 12:05:42', 'admin-1511485303-15114963422303652', 1, 1, 'SR', NULL, NULL, '10.0'),
(54287, '2017-11-24 12:05:42', NULL, NULL, 14713, 0, 301, '237', 'Black Jack', '', 'Cold Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 12:05:42', 'admin-1511485303-15114963422303652', 1, 0, '', NULL, NULL, '10.0'),
(54288, '2017-11-24 12:03:53', NULL, NULL, 14714, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 12:03:53', 'admin-1511485303-15114962337793083', 1, 0, '', NULL, NULL, NULL),
(54289, '2017-11-24 12:03:53', NULL, NULL, 14714, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 12:03:53', 'admin-1511485303-15114962337793083', 1, 0, '', NULL, NULL, NULL),
(54290, '2017-11-24 12:03:53', NULL, NULL, 14714, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 12:03:53', 'admin-1511485303-15114962337793083', 1, 0, '', NULL, NULL, NULL),
(54291, '2017-11-24 12:03:53', NULL, NULL, 14714, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 12:03:53', 'admin-1511485303-15114962337793083', 1, 0, '', NULL, NULL, NULL),
(54292, '2017-11-24 11:58:45', NULL, NULL, 14713, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.05, 0.0000, 0.0000, 9.05, 1, '27', 1, '1511485303', 'admin', '2017-11-24 11:58:45', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(54293, '2017-11-24 11:01:56', NULL, NULL, 14711, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1511485303', 'admin', '2017-11-24 11:01:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54294, '2017-11-24 11:04:11', NULL, NULL, 14711, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511485303', 'admin', '2017-11-24 11:04:11', 'admin-1511485303-15114926512936510', 1, 1, 'SR', NULL, NULL, NULL),
(54295, '2017-11-24 11:07:17', NULL, NULL, 14712, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1511485303', 'admin', '2017-11-24 11:07:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54296, '2017-11-25 10:53:16', NULL, NULL, 14739, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:53:16', 'admin-1511570825-15115783965445133', 1, 0, '', NULL, NULL, NULL),
(54297, '2017-11-25 10:53:28', NULL, NULL, 14739, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:53:28', 'admin-1511570825-15115784080753865', 1, 1, 'SR', NULL, NULL, NULL),
(54298, '2017-11-25 10:53:28', NULL, NULL, 14739, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:53:28', 'admin-1511570825-15115784080753865', 1, 1, 'SR', NULL, NULL, NULL),
(54299, '2017-11-25 14:41:59', NULL, NULL, 14758, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:41:59', 'admin-1511570825-15115921188807926', 1, 0, '', NULL, NULL, NULL),
(54300, '2017-11-25 14:49:33', NULL, NULL, 14759, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:49:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54301, '2017-11-25 14:49:40', NULL, NULL, 14759, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:49:40', 'admin-1511570825-15115925808053037', 1, 1, 'SR', NULL, NULL, NULL),
(54302, '2017-11-25 14:49:40', NULL, NULL, 14759, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:49:40', 'admin-1511570825-15115925808053037', 1, 1, 'SR', NULL, NULL, NULL),
(54303, '2017-11-25 13:04:39', NULL, NULL, 14749, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.70, 0.0000, 0.0000, 9.70, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:04:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54304, '2017-11-25 10:54:16', NULL, NULL, 14740, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.60, 0.0000, 0.0000, 9.60, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:54:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54305, '2017-11-25 10:54:22', NULL, NULL, 14740, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:54:22', 'admin-1511570825-15115784627284942', 1, 0, '', NULL, NULL, NULL),
(54306, '2017-11-25 10:54:22', NULL, NULL, 14740, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:54:22', 'admin-1511570825-15115784627284942', 1, 0, '', NULL, NULL, NULL),
(54307, '2017-11-25 10:54:22', NULL, NULL, 14740, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:54:22', 'admin-1511570825-15115784627284942', 1, 0, '', NULL, NULL, NULL),
(54308, '2017-11-25 10:54:29', NULL, NULL, 14740, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:54:29', 'admin-1511570825-15115784694037417', 1, 1, 'SR', NULL, NULL, NULL),
(54309, '2017-11-25 12:42:32', NULL, NULL, 14746, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 12:42:32', 'admin-1511570825-15115849518639659', 1, 0, '', NULL, NULL, NULL),
(54310, '2017-11-25 12:42:32', NULL, NULL, 14746, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 12:42:32', 'admin-1511570825-15115849518639659', 1, 1, 'SR', NULL, NULL, NULL),
(54311, '2017-11-25 12:42:32', NULL, NULL, 14746, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 12:42:32', 'admin-1511570825-15115849518639659', 1, 0, '', NULL, NULL, NULL),
(54312, '2017-11-25 12:52:18', NULL, NULL, 14747, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.59, 0.0000, 0.0000, 7.59, 1, '27', 1, '1511570825', 'admin', '2017-11-25 12:52:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54313, '2017-11-25 12:52:36', NULL, NULL, 14747, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 12:52:36', 'admin-1511570825-15115855568187634', 1, 0, '', NULL, NULL, NULL),
(54314, '2017-11-25 12:52:36', NULL, NULL, 14747, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 12:52:36', 'admin-1511570825-15115855568187634', 1, 0, '', NULL, NULL, NULL),
(54315, '2017-11-25 11:54:26', NULL, NULL, 14743, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 11:54:26', 'admin-1511570825-15115820666022010', 1, 1, 'SR', NULL, NULL, NULL),
(54316, '2017-11-25 10:41:08', NULL, NULL, 14736, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:41:08', 'admin-1511570825-15115776678978133', 1, 1, 'SR', NULL, NULL, NULL),
(54317, '2017-11-25 10:41:08', NULL, NULL, 14736, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:41:08', 'admin-1511570825-15115776678978133', 1, 1, 'SR', NULL, NULL, NULL),
(54318, '2017-11-25 15:32:42', NULL, NULL, 14762, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 15:32:42', 'admin-1511570825-15115951627029858', 1, 1, 'SR', NULL, NULL, NULL),
(54319, '2017-11-25 15:32:42', NULL, NULL, 14762, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 15:32:42', 'admin-1511570825-15115951627029858', 1, 1, 'SR', NULL, NULL, NULL),
(54320, '2017-11-25 15:32:33', NULL, NULL, 14762, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1511570825', 'admin', '2017-11-25 15:32:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54321, '2017-11-25 10:21:23', NULL, NULL, 14732, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:21:23', 'admin-1511570825-15115764832899693', 1, 1, 'SR', NULL, NULL, NULL),
(54322, '2017-11-25 00:00:00', NULL, NULL, 14761, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:34:37', 'admin-1511570825-15115880777685989', 1, 1, 'SR', NULL, NULL, NULL),
(54323, '2017-11-25 14:29:39', NULL, NULL, 14757, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:29:39', 'admin-1511570825-15115913796412360', 1, 0, '', NULL, NULL, NULL),
(54324, '2017-11-25 15:01:41', NULL, NULL, 14755, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 15:01:41', 'admin-1511570825-15115933013723588', 1, 1, 'SR', NULL, NULL, '10.0'),
(54325, '2017-11-25 15:01:41', NULL, NULL, 14755, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 15:01:41', 'admin-1511570825-15115933013723588', 1, 0, '', NULL, NULL, '10.0'),
(54326, '2017-11-25 14:53:02', NULL, NULL, 14760, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:53:02', 'admin-1511570825-15115927818598917', 1, 0, '', NULL, NULL, NULL),
(54327, '2017-11-25 14:53:02', NULL, NULL, 14760, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:53:02', 'admin-1511570825-15115927818598917', 1, 1, 'SR', NULL, NULL, NULL),
(54328, '2017-11-25 14:53:02', NULL, NULL, 14760, 0, 73, '73', 'Marmite Chicken ', 'less rice more sauce', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:53:02', 'admin-1511570825-15115927818598917', 1, 1, 'SR', NULL, NULL, NULL),
(54329, '2017-11-25 14:52:13', NULL, NULL, 14760, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:52:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54330, '2017-11-25 14:53:02', NULL, NULL, 14760, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:53:02', 'admin-1511570825-15115927818598917', 1, 1, 'SR', NULL, NULL, NULL),
(54331, '2017-11-25 14:41:41', NULL, NULL, 14758, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:41:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54332, '2017-11-25 14:41:59', NULL, NULL, 14758, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:41:59', 'admin-1511570825-15115921188807926', 1, 0, '', NULL, NULL, NULL),
(54333, '2017-11-25 14:41:59', NULL, NULL, 14758, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:41:59', 'admin-1511570825-15115921188807926', 1, 0, '', NULL, NULL, NULL),
(54334, '2017-11-25 14:41:59', NULL, NULL, 14758, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:41:59', 'admin-1511570825-15115921188807926', 1, 1, 'SR', NULL, NULL, NULL),
(54335, '2017-11-25 14:29:39', NULL, NULL, 14757, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:29:39', 'admin-1511570825-15115913796412360', 1, 1, 'SR', NULL, NULL, NULL),
(54336, '2017-11-25 11:54:26', NULL, NULL, 14743, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 11:54:26', 'admin-1511570825-15115820666022010', 1, 1, 'SR', NULL, NULL, NULL),
(54337, '2017-11-25 11:54:26', NULL, NULL, 14743, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 11:54:26', 'admin-1511570825-15115820666022010', 1, 1, 'SR', NULL, NULL, NULL),
(54338, '2017-11-25 12:52:36', NULL, NULL, 14747, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 12:52:36', 'admin-1511570825-15115855568187634', 1, 0, '', NULL, NULL, NULL),
(54339, '2017-11-25 13:07:39', NULL, NULL, 14750, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:07:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54340, '2017-11-25 13:07:46', NULL, NULL, 14750, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:07:46', 'admin-1511570825-15115864665691573', 1, 1, 'SR', NULL, NULL, NULL),
(54341, '2017-11-25 12:58:31', NULL, NULL, 14748, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1511570825', 'admin', '2017-11-25 12:58:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54342, '2017-11-25 12:58:45', NULL, NULL, 14748, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 12:58:45', 'admin-1511570825-15115859253944964', 1, 1, 'SR', NULL, NULL, NULL),
(54343, '2017-11-25 12:58:45', NULL, NULL, 14748, 0, 215, '149', 'Thai Fish Sauce Garlic Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 12:58:45', 'admin-1511570825-15115859253944964', 1, 0, '', NULL, NULL, NULL),
(54344, '2017-11-25 13:01:24', NULL, NULL, 14747, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:01:24', 'admin-1511570825-15115860840968497', 1, 1, 'SR', NULL, NULL, NULL),
(54345, '2017-11-25 11:55:39', NULL, NULL, 14744, 0, 73, '73', 'Marmite Chicken ', 'Pasta', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 11:55:39', 'admin-1511570825-15115821391506033', 1, 1, 'SR', NULL, NULL, NULL),
(54346, '2017-11-25 12:18:30', NULL, NULL, 14745, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1511570825', 'admin', '2017-11-25 12:18:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54347, '2017-11-25 14:29:39', NULL, NULL, 14757, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:29:39', 'admin-1511570825-15115913796412360', 1, 1, 'SR', NULL, NULL, NULL),
(54348, '2017-11-25 14:29:39', NULL, NULL, 14757, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:29:39', 'admin-1511570825-15115913796412360', 1, 1, 'SR', NULL, NULL, NULL),
(54349, '2017-11-25 14:29:26', NULL, NULL, 14757, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:29:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54350, '2017-11-25 14:21:35', NULL, NULL, 14755, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:21:35', 'admin-1511570825-15115908949542212', 1, 1, 'SR', NULL, NULL, '10.0'),
(54351, '2017-11-25 14:21:35', NULL, NULL, 14755, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:21:35', 'admin-1511570825-15115908949542212', 1, 1, 'SR', NULL, NULL, '10.0'),
(54352, '2017-11-25 14:21:35', NULL, NULL, 14755, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:21:35', 'admin-1511570825-15115908949542212', 1, 1, 'SR', NULL, NULL, '10.0'),
(54353, '2017-11-25 14:21:13', NULL, NULL, 14755, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:21:13', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(54354, '2017-11-25 14:20:23', NULL, NULL, 14752, 0, 305, '241', 'Sprite', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:20:23', 'admin-1511570825-1511590823752822', 1, 0, '', NULL, NULL, NULL),
(54355, '2017-11-25 14:20:23', NULL, NULL, 14752, 0, 305, '241', 'Sprite', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:20:23', 'admin-1511570825-1511590823752822', 1, 0, '', NULL, NULL, NULL),
(54356, '2017-11-25 13:10:12', NULL, NULL, 14748, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:10:12', 'admin-1511570825-15115866119382450', 1, 1, 'SR', NULL, NULL, NULL),
(54357, '2017-11-25 13:13:37', NULL, NULL, 14749, 0, 229, '163', 'Mummy''s Pasta', 'no spicy', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:13:37', 'admin-1511570825-1511586817003943', 1, 0, '', NULL, NULL, NULL),
(54358, '2017-11-25 13:28:33', NULL, NULL, 14748, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:28:33', 'admin-1511570825-1511587713753138', 1, 1, 'SR', NULL, NULL, NULL),
(54359, '2017-11-25 13:05:25', NULL, NULL, 14749, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:05:25', 'admin-1511570825-15115863250962450', 1, 0, '', NULL, NULL, NULL),
(54360, '2017-11-25 13:19:07', NULL, NULL, 14749, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:19:07', 'admin-1511570825-1511587147015591', 1, 1, 'SR', NULL, NULL, NULL),
(54361, '2017-11-25 13:59:22', NULL, NULL, 14753, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:59:22', 'admin-1511570825-15115895624874171', 1, 0, '', NULL, NULL, '10.0'),
(54362, '2017-11-25 13:59:22', NULL, NULL, 14753, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:59:22', 'admin-1511570825-15115895624874171', 1, 0, '', NULL, NULL, '10.0'),
(54363, '2017-11-25 13:59:22', NULL, NULL, 14753, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:59:22', 'admin-1511570825-15115895624874171', 1, 1, 'SR', NULL, NULL, '10.0'),
(54364, '2017-11-25 15:08:44', NULL, NULL, 14761, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1511570825', 'admin', '2017-11-25 15:08:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54365, '2017-11-25 13:45:02', NULL, NULL, 14748, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:45:02', 'admin-1511570825-15115887020248483', 1, 0, '', NULL, NULL, NULL),
(54366, '2017-11-25 13:59:05', NULL, NULL, 14753, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:59:05', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(54367, '2017-11-25 11:54:26', NULL, NULL, 14743, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 11:54:26', 'admin-1511570825-15115820666022010', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(54368, '2017-11-25 11:55:28', NULL, NULL, 14744, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1511570825', 'admin', '2017-11-25 11:55:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54369, '2017-11-25 10:18:32', NULL, NULL, 14731, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:18:32', 'admin-1511570825-15115763118924159', 1, 0, '', NULL, NULL, NULL),
(54370, '2017-11-25 13:10:12', NULL, NULL, 14748, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:10:12', 'admin-1511570825-15115866119382450', 1, 1, 'SR', NULL, NULL, NULL),
(54371, '2017-11-25 11:54:26', NULL, NULL, 14743, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 11:54:26', 'admin-1511570825-15115820666022010', 1, 1, 'SR', NULL, NULL, NULL),
(54372, '2017-11-25 11:06:54', NULL, NULL, 14741, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 11:06:54', 'admin-1511570825-15115792143395933', 1, 0, '', NULL, NULL, NULL),
(54373, '2017-11-25 11:06:54', NULL, NULL, 14741, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 11:06:54', 'admin-1511570825-15115792143395933', 1, 0, '', NULL, NULL, NULL),
(54374, '2017-11-25 13:34:34', NULL, NULL, 14752, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:34:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54375, '2017-11-25 13:28:33', NULL, NULL, 14748, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:28:33', 'admin-1511570825-1511587713753138', 1, 1, 'SR', NULL, NULL, NULL),
(54376, '2017-11-25 13:28:33', NULL, NULL, 14748, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:28:33', 'admin-1511570825-1511587713753138', 1, 1, 'SR', NULL, NULL, NULL),
(54377, '2017-11-25 13:10:28', NULL, NULL, 14751, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:10:28', 'admin-1511570825-15115866287063045', 1, 0, '', 1, NULL, NULL),
(54378, '2017-11-25 14:19:27', NULL, NULL, 14754, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:19:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54379, '2017-11-25 14:19:30', NULL, NULL, 14754, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:19:30', 'admin-1511570825-151159077006874', 1, 1, 'SR', NULL, NULL, NULL),
(54380, '2017-11-25 13:10:12', NULL, NULL, 14748, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:10:12', 'admin-1511570825-15115866119382450', 1, 1, 'SR', NULL, NULL, NULL),
(54381, '2017-11-25 09:11:06', NULL, NULL, 14724, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1511570825', 'admin', '2017-11-25 09:11:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54382, '2017-11-25 09:11:12', NULL, NULL, 14724, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 09:11:12', 'admin-1511570825-15115722722355311', 1, 0, '', NULL, NULL, NULL),
(54383, '2017-11-25 09:11:12', NULL, NULL, 14724, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 09:11:12', 'admin-1511570825-15115722722355311', 1, 0, '', NULL, NULL, NULL),
(54384, '2017-11-25 13:07:51', NULL, NULL, 14750, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:07:51', 'admin-1511570825-1511586471549558', 1, 0, '', NULL, NULL, NULL),
(54385, '2017-11-25 10:34:11', NULL, NULL, 14734, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:34:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54386, '2017-11-25 10:41:03', NULL, NULL, 14736, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:41:03', 'admin-1511570825-15115776630181698', 1, 0, '', NULL, NULL, NULL),
(54387, '2017-11-25 10:18:32', NULL, NULL, 14731, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:18:32', 'admin-1511570825-15115763118924159', 1, 0, '', NULL, NULL, NULL),
(54388, '2017-11-25 13:05:16', NULL, NULL, 14749, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:05:16', 'admin-1511570825-15115863164242076', 1, 1, 'SR', NULL, NULL, NULL),
(54389, '2017-11-25 13:05:34', NULL, NULL, 14749, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:05:34', 'admin-1511570825-1511586334488357', 1, 1, 'SR', NULL, NULL, NULL),
(54390, '2017-11-25 12:19:41', NULL, NULL, 14745, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 12:19:41', 'admin-1511570825-15115835814571210', 1, 1, 'SR', NULL, NULL, NULL),
(54391, '2017-11-25 10:47:41', NULL, NULL, 14737, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:47:41', 'admin-1511570825-15115780611291494', 1, 0, '', NULL, NULL, NULL),
(54392, '2017-11-25 10:47:52', NULL, NULL, 14737, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:47:52', 'admin-1511570825-1511578072382873', 1, 1, 'SR', NULL, NULL, NULL),
(54393, '2017-11-25 10:47:52', NULL, NULL, 14737, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:47:52', 'admin-1511570825-1511578072382873', 1, 1, 'SR', NULL, NULL, NULL),
(54394, '2017-11-25 10:52:40', NULL, NULL, 14738, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:52:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54395, '2017-11-25 10:52:55', NULL, NULL, 14738, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:52:55', 'admin-1511570825-15115783755594660', 1, 1, 'SR', NULL, NULL, NULL),
(54396, '2017-11-25 10:52:55', NULL, NULL, 14738, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:52:55', 'admin-1511570825-15115783755594660', 1, 1, 'SR', NULL, NULL, NULL),
(54397, '2017-11-25 10:53:04', NULL, NULL, 14739, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:53:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54398, '2017-11-25 10:53:16', NULL, NULL, 14739, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:53:16', 'admin-1511570825-15115783965445133', 1, 0, '', NULL, NULL, NULL),
(54399, '2017-11-25 13:01:24', NULL, NULL, 14747, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:01:24', 'admin-1511570825-15115860840968497', 1, 0, '', NULL, NULL, NULL),
(54400, '2017-11-25 12:52:41', NULL, NULL, 14747, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 12:52:41', 'admin-1511570825-15115855611099367', 1, 1, 'SR', NULL, NULL, NULL),
(54401, '2017-11-25 13:05:16', NULL, NULL, 14749, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:05:16', 'admin-1511570825-15115863164242076', 1, 0, '', NULL, NULL, NULL),
(54402, '2017-11-25 12:42:31', NULL, NULL, 14746, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 12:42:32', 'admin-1511570825-15115849518639659', 1, 0, '', NULL, NULL, NULL),
(54403, '2017-11-25 12:19:41', NULL, NULL, 14745, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 12:19:41', 'admin-1511570825-15115835814571210', 1, 1, 'SR', NULL, NULL, NULL),
(54404, '2017-11-25 12:19:34', NULL, NULL, 14745, 0, 181, '116', 'Open Food ', 'char sao fan', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 12:19:34', 'admin-1511570825-15115835744087034', 1, 0, '', NULL, NULL, NULL),
(54405, '2017-11-25 12:19:34', NULL, NULL, 14745, 0, 75, '75', 'Meatless Aglio Olio ', 'no cili', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 12:19:34', 'admin-1511570825-15115835744087034', 1, 0, '', NULL, NULL, NULL),
(54406, '2017-11-25 12:19:34', NULL, NULL, 14745, 0, 75, '75', 'Meatless Aglio Olio ', 'no cili', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 12:19:34', 'admin-1511570825-15115835744087034', 1, 0, '', NULL, NULL, NULL),
(54407, '2017-11-25 11:20:06', NULL, NULL, 14741, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 11:20:06', 'admin-1511570825-1511580006199236', 1, 1, 'SR', NULL, NULL, NULL),
(54408, '2017-11-25 11:09:20', NULL, NULL, 14742, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 11:09:20', 'admin-1511570825-15115793601617730', 1, 1, 'SR', NULL, NULL, NULL),
(54409, '2017-11-25 11:09:20', NULL, NULL, 14742, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 11:09:20', 'admin-1511570825-15115793601617730', 1, 0, '', NULL, NULL, NULL),
(54410, '2017-11-25 09:16:32', NULL, NULL, 14725, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1511570825', 'admin', '2017-11-25 09:16:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54411, '2017-11-25 09:16:43', NULL, NULL, 14725, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 09:16:43', 'admin-1511570825-15115726036501326', 1, 0, '', NULL, NULL, NULL),
(54412, '2017-11-25 09:16:43', NULL, NULL, 14725, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 09:16:43', 'admin-1511570825-15115726036501326', 1, 0, '', NULL, NULL, NULL),
(54413, '2017-11-25 12:19:34', NULL, NULL, 14745, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 12:19:34', 'admin-1511570825-15115835744087034', 1, 0, '', NULL, NULL, NULL),
(54414, '2017-11-25 11:09:10', NULL, NULL, 14742, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1511570825', 'admin', '2017-11-25 11:09:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54415, '2017-11-25 11:54:26', NULL, NULL, 14743, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 11:54:26', 'admin-1511570825-15115820666022010', 1, 0, '', NULL, NULL, NULL),
(54416, '2017-11-25 11:07:00', NULL, NULL, 14741, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 11:07:00', 'admin-1511570825-1511579220043159', 1, 1, 'SR', NULL, NULL, NULL),
(54417, '2017-11-25 11:06:45', NULL, NULL, 14741, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1511570825', 'admin', '2017-11-25 11:06:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54418, '2017-11-25 11:53:38', NULL, NULL, 14743, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.30, 0.0000, 0.0000, 10.30, 1, '27', 1, '1511570825', 'admin', '2017-11-25 11:53:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54419, '2017-11-25 10:40:56', NULL, NULL, 14736, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:40:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54420, '2017-11-25 10:39:23', NULL, NULL, 14735, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:39:23', 'admin-1511570825-15115775638305421', 1, 1, 'SR', 1, NULL, NULL),
(54421, '2017-11-25 10:19:46', NULL, NULL, 14731, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:19:46', 'admin-1511570825-15115763865513864', 1, 1, 'SR', NULL, NULL, NULL),
(54422, '2017-11-25 10:18:32', NULL, NULL, 14731, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:18:32', 'admin-1511570825-15115763118924159', 1, 0, '', NULL, NULL, NULL),
(54423, '2017-11-25 11:54:26', NULL, NULL, 14743, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 11:54:26', 'admin-1511570825-15115820666022010', 1, 1, 'SR', NULL, NULL, NULL),
(54424, '2017-11-25 11:29:30', NULL, NULL, 14740, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 11:29:30', 'admin-1511570825-15115805699176866', 1, 1, 'SR', NULL, NULL, NULL),
(54425, '2017-11-25 11:54:26', NULL, NULL, 14743, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 11:54:26', 'admin-1511570825-15115820666022010', 1, 1, 'SR', NULL, NULL, NULL),
(54426, '2017-11-25 13:59:22', NULL, NULL, 14753, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:59:22', 'admin-1511570825-15115895624874171', 1, 1, 'SR', NULL, NULL, '10.0'),
(54427, '2017-11-25 10:21:17', NULL, NULL, 14732, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:21:17', 'admin-1511570825-1511576477636964', 1, 0, '', NULL, NULL, NULL),
(54428, '2017-11-25 10:21:10', NULL, NULL, 14732, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:21:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54429, '2017-11-25 10:19:46', NULL, NULL, 14731, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:19:46', 'admin-1511570825-15115763865513864', 1, 0, '', NULL, NULL, NULL),
(54430, '2017-11-25 13:05:34', NULL, NULL, 14749, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:05:34', 'admin-1511570825-1511586334488357', 1, 1, 'SR', NULL, NULL, NULL),
(54431, '2017-11-25 11:54:26', NULL, NULL, 14743, NULL, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 11:54:26', 'admin-1511570825-15115820666022010', 1, 1, 'SR', NULL, NULL, NULL),
(54432, '2017-11-25 10:54:29', NULL, NULL, 14740, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:54:29', 'admin-1511570825-15115784694037417', 1, 1, 'SR', NULL, NULL, NULL),
(54433, '2017-11-25 10:41:03', NULL, NULL, 14736, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:41:03', 'admin-1511570825-15115776630181698', 1, 0, '', NULL, NULL, NULL),
(54434, '2017-11-25 10:34:17', NULL, NULL, 14734, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:34:17', 'admin-1511570825-15115772572466386', 1, 1, 'SR', NULL, NULL, NULL),
(54435, '2017-11-25 10:33:20', NULL, NULL, 14733, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:33:20', 'admin-1511570825-15115771998471363', 1, 1, 'SR', NULL, NULL, NULL),
(54436, '2017-11-25 10:47:35', NULL, NULL, 14737, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:47:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54437, '2017-11-25 10:47:41', NULL, NULL, 14737, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:47:41', 'admin-1511570825-15115780611291494', 1, 0, '', NULL, NULL, NULL),
(54438, '2017-11-25 10:45:37', NULL, NULL, 14735, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:45:37', 'admin-1511570825-15115779370445294', 1, 1, 'SR', 1, NULL, NULL),
(54439, '2017-11-25 10:19:46', NULL, NULL, 14731, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:19:46', 'admin-1511570825-15115763865513864', 1, 0, '', NULL, NULL, NULL),
(54440, '2017-11-25 10:19:46', NULL, NULL, 14731, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:19:46', 'admin-1511570825-15115763865513864', 1, 1, 'SR', NULL, NULL, NULL),
(54441, '2017-11-25 10:19:46', NULL, NULL, 14731, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:19:46', 'admin-1511570825-15115763865513864', 1, 1, 'SR', NULL, NULL, NULL),
(54442, '2017-11-25 10:33:19', NULL, NULL, 14733, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:33:19', 'admin-1511570825-15115771998471363', 1, 1, 'SR', NULL, NULL, NULL),
(54443, '2017-11-25 10:19:46', NULL, NULL, 14731, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:19:46', 'admin-1511570825-15115763865513864', 1, 1, 'SR', NULL, NULL, NULL),
(54444, '2017-11-25 10:33:13', NULL, NULL, 14733, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:33:13', 'admin-1511570825-15115771930316031', 1, 0, '', NULL, NULL, NULL),
(54445, '2017-11-25 10:33:13', NULL, NULL, 14733, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:33:13', 'admin-1511570825-15115771930316031', 1, 0, '', NULL, NULL, NULL),
(54446, '2017-11-25 10:33:07', NULL, NULL, 14733, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:33:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54447, '2017-11-25 10:19:46', NULL, NULL, 14731, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:19:46', 'admin-1511570825-15115763865513864', 1, 1, 'SR', NULL, NULL, NULL),
(54448, '2017-11-25 11:54:26', NULL, NULL, 14743, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 11:54:26', 'admin-1511570825-15115820666022010', 1, 1, 'SR', NULL, NULL, NULL),
(54449, '2017-11-25 10:11:02', NULL, NULL, 14730, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:11:02', 'admin-1511570825-15115758622272078', 1, 1, 'SR', NULL, NULL, NULL),
(54450, '2017-11-25 13:59:22', NULL, NULL, 14753, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 13:59:22', 'admin-1511570825-15115895624874171', 1, 1, 'SR', NULL, NULL, '10.0'),
(54451, '2017-11-25 12:42:13', NULL, NULL, 14746, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1511570825', 'admin', '2017-11-25 12:42:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54452, '2017-11-25 09:22:22', NULL, NULL, 14724, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 09:22:22', 'admin-1511570825-15115729423616612', 1, 1, 'SR', NULL, NULL, NULL),
(54453, '2017-11-25 09:31:45', NULL, NULL, 14726, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 09:31:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54454, '2017-11-25 09:36:18', NULL, NULL, 14727, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 09:36:18', 'admin-1511570825-15115737779803429', 1, 0, '', NULL, NULL, NULL),
(54455, '2017-11-25 09:36:24', NULL, NULL, 14727, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 09:36:24', 'admin-1511570825-15115737843442878', 1, 1, 'SR', NULL, NULL, NULL),
(54456, '2017-11-25 10:18:32', NULL, NULL, 14731, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:18:32', 'admin-1511570825-15115763118924159', 1, 0, '', NULL, NULL, NULL),
(54457, '2017-11-25 10:18:32', NULL, NULL, 14731, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:18:32', 'admin-1511570825-15115763118924159', 1, 0, '', NULL, NULL, NULL),
(54458, '2017-11-25 10:18:32', NULL, NULL, 14731, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:18:32', 'admin-1511570825-15115763118924159', 1, 0, '', NULL, NULL, NULL),
(54459, '2017-11-25 10:21:17', NULL, NULL, 14732, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:21:17', 'admin-1511570825-1511576477636964', 1, 0, '', NULL, NULL, NULL),
(54460, '2017-11-25 09:40:45', NULL, NULL, 14728, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1511570825', 'admin', '2017-11-25 09:40:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54461, '2017-11-25 10:18:32', NULL, NULL, 14731, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:18:32', 'admin-1511570825-15115763118924159', 1, 0, '', NULL, NULL, NULL),
(54462, '2017-11-25 10:18:32', NULL, NULL, 14731, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:18:32', 'admin-1511570825-15115763118924159', 1, 0, '', NULL, NULL, NULL),
(54463, '2017-11-25 10:18:32', NULL, NULL, 14731, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:18:32', 'admin-1511570825-15115763118924159', 1, 0, '', NULL, NULL, NULL),
(54464, '2017-11-25 09:40:52', NULL, NULL, 14728, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 09:40:52', 'admin-1511570825-15115740519155459', 1, 1, 'SR', NULL, NULL, NULL),
(54465, '2017-11-25 09:34:21', NULL, NULL, 14726, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 09:34:21', 'admin-1511570825-1511573660938767', 1, 0, '', NULL, NULL, NULL),
(54466, '2017-11-25 09:34:40', NULL, NULL, 14726, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 09:34:40', 'admin-1511570825-15115736800699225', 1, 1, 'SR', NULL, NULL, NULL),
(54467, '2017-11-25 09:34:40', NULL, NULL, 14726, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 09:34:40', 'admin-1511570825-15115736800699225', 1, 0, '', NULL, NULL, NULL),
(54468, '2017-11-25 09:36:07', NULL, NULL, 14727, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1511570825', 'admin', '2017-11-25 09:36:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54469, '2017-11-25 09:36:18', NULL, NULL, 14727, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 09:36:18', 'admin-1511570825-15115737779803429', 1, 0, '', NULL, NULL, NULL),
(54470, '2017-11-25 10:05:30', NULL, NULL, 14729, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:05:30', 'admin-1511570825-15115755301681561', 1, 1, 'SR', NULL, NULL, NULL),
(54471, '2017-11-25 10:17:46', NULL, NULL, 14731, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 21.20, 0.0000, 0.0000, 21.20, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:17:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54472, '2017-11-25 10:10:54', NULL, NULL, 14730, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:10:54', 'admin-1511570825-15115758540124073', 1, 0, '', NULL, NULL, NULL),
(54473, '2017-11-25 10:10:54', NULL, NULL, 14730, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:10:54', 'admin-1511570825-15115758540124073', 1, 0, '', NULL, NULL, NULL),
(54474, '2017-11-25 10:10:43', NULL, NULL, 14730, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:10:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54475, '2017-11-25 10:04:33', NULL, NULL, 14729, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:04:33', 'admin-1511570825-15115754735038511', 1, 0, '', NULL, NULL, NULL),
(54476, '2017-11-25 10:05:30', NULL, NULL, 14729, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:05:30', 'admin-1511570825-15115755301681561', 1, 1, 'SR', NULL, NULL, NULL),
(54477, '2017-11-25 10:04:27', NULL, NULL, 14729, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:04:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54478, '2017-11-25 10:04:33', NULL, NULL, 14729, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 10:04:33', 'admin-1511570825-15115754735038511', 1, 0, '', NULL, NULL, NULL),
(54479, '2017-11-25 09:40:52', NULL, NULL, 14728, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 09:40:52', 'admin-1511570825-15115740519155459', 1, 0, '', NULL, NULL, NULL),
(54480, '2017-11-25 14:38:14', NULL, NULL, 14752, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 14:38:14', 'admin-1511570825-15115918948233610', 1, 0, '', NULL, NULL, NULL),
(54481, '2017-11-25 09:36:24', NULL, NULL, 14727, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 09:36:24', 'admin-1511570825-15115737843442878', 1, 1, 'SR', NULL, NULL, NULL),
(54482, '2017-11-25 09:34:21', NULL, NULL, 14726, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 09:34:21', 'admin-1511570825-1511573660938767', 1, 0, '', NULL, NULL, NULL),
(54483, '2017-11-25 09:16:53', NULL, NULL, 14725, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 09:16:53', 'admin-1511570825-15115726137962596', 1, 1, 'SR', NULL, NULL, NULL),
(54484, '2017-11-25 09:16:53', NULL, NULL, 14725, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511570825', 'admin', '2017-11-25 09:16:53', 'admin-1511570825-15115726137962596', 1, 1, 'SR', NULL, NULL, NULL),
(54485, '2017-11-26 16:56:31', NULL, NULL, 14813, 0, 182, '117', 'Open Drinks ', 'coffee beans', 'Cold Drinks', 'Fresh Juice', 1, 38.00, 38.0000, 0.0000, 38.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 16:56:31', 'admin-1511656639-15116865913632941', 1, 0, '', 1, NULL, NULL),
(54486, '2017-11-26 13:52:58', NULL, NULL, 14799, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:52:58', 'admin-1511656639-15116755782124520', 1, 0, '', NULL, NULL, NULL),
(54487, '2017-11-26 13:52:58', NULL, NULL, 14799, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:52:58', 'admin-1511656639-15116755782124520', 1, 1, 'SR', NULL, NULL, NULL),
(54488, '2017-11-26 13:52:58', NULL, NULL, 14799, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:52:58', 'admin-1511656639-15116755782124520', 1, 1, 'SR', NULL, NULL, NULL),
(54489, '2017-11-26 13:50:56', NULL, NULL, 14801, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.50, 0.0000, 0.0000, 10.50, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:50:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54490, '2017-11-26 13:50:45', NULL, NULL, 14800, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:50:45', 'admin-1511656639-15116754451243021', 1, 1, 'SR', NULL, NULL, NULL),
(54491, '2017-11-26 13:50:45', NULL, NULL, 14800, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:50:45', 'admin-1511656639-15116754451243021', 1, 0, '', NULL, NULL, NULL),
(54492, '2017-11-26 10:49:09', NULL, NULL, 14777, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:49:09', 'admin-1511656639-15116645496597550', 1, 1, 'SR', NULL, NULL, NULL),
(54493, '2017-11-26 10:50:54', NULL, NULL, 14778, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:50:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54494, '2017-11-26 10:51:10', NULL, NULL, 14778, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:51:10', 'admin-1511656639-15116646699568158', 1, 1, 'SR', NULL, NULL, NULL),
(54495, '2017-11-26 16:03:08', NULL, NULL, 14810, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1511689231', 'admin', '2017-11-26 16:03:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54496, '2017-11-26 13:59:11', NULL, NULL, 14802, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:59:11', 'admin-1511656639-15116759511685440', 1, 1, 'SR', NULL, NULL, NULL),
(54497, '2017-11-26 13:59:11', NULL, NULL, 14802, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:59:11', 'admin-1511656639-15116759511685440', 1, 0, '', NULL, NULL, NULL),
(54498, '2017-11-26 14:09:10', NULL, NULL, 14799, 0, 182, '117', 'Open Drinks ', 'Heineken', 'Cold Drinks', 'Fresh Juice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 14:09:10', 'admin-1511656639-151167655026413', 1, 0, '', NULL, NULL, NULL),
(54499, '2017-11-26 12:43:16', NULL, NULL, 14793, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:43:16', 'admin-1511656639-15116713965236246', 1, 0, '', NULL, NULL, NULL),
(54500, '2017-11-26 12:43:16', NULL, NULL, 14793, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:43:16', 'admin-1511656639-15116713965236246', 1, 0, '', NULL, NULL, NULL),
(54501, '2017-11-26 12:43:16', NULL, NULL, 14793, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:43:16', 'admin-1511656639-15116713965236246', 1, 1, 'SR', NULL, NULL, NULL),
(54502, '2017-11-26 11:20:43', NULL, NULL, 14784, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:20:43', 'admin-1511656639-15116664431451016', 1, 1, 'SR', NULL, NULL, NULL),
(54503, '2017-11-26 15:21:42', NULL, NULL, 14808, 0, 295, '231', 'Chinese Ginger Garlic Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 15:21:42', 'admin-1511656639-1511680902563229', 1, 0, '', NULL, NULL, NULL),
(54504, '2017-11-26 15:17:29', NULL, NULL, 14809, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 15:17:29', 'admin-1511656639-15116806497758579', 1, 0, '', NULL, NULL, NULL),
(54505, '2017-11-26 13:49:57', NULL, NULL, 14799, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:49:57', 'admin-1511656639-1511675397331120', 1, 0, '', NULL, NULL, NULL),
(54506, '2017-11-26 13:49:46', NULL, NULL, 14799, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.00, 0.0000, 0.0000, 13.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:49:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54507, '2017-11-26 13:34:38', NULL, NULL, 14798, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:34:38', 'admin-1511656639-1511674477922914', 1, 0, '', NULL, NULL, NULL),
(54508, '2017-11-26 13:34:38', NULL, NULL, 14798, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:34:38', 'admin-1511656639-1511674477922914', 1, 0, '', NULL, NULL, NULL),
(54509, '2017-11-26 13:34:38', NULL, NULL, 14798, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:34:38', 'admin-1511656639-1511674477922914', 1, 0, '', NULL, NULL, NULL),
(54510, '2017-11-26 13:50:45', NULL, NULL, 14800, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:50:45', 'admin-1511656639-15116754451243021', 1, 1, 'SR', NULL, NULL, NULL),
(54511, '2017-11-26 13:50:45', NULL, NULL, 14800, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:50:45', 'admin-1511656639-15116754451243021', 1, 0, '', NULL, NULL, NULL),
(54512, '2017-11-26 13:49:57', NULL, NULL, 14799, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:49:57', 'admin-1511656639-1511675397331120', 1, 0, '', NULL, NULL, NULL),
(54513, '2017-11-26 13:49:57', NULL, NULL, 14799, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:49:57', 'admin-1511656639-1511675397331120', 1, 1, 'SR', NULL, NULL, NULL),
(54514, '2017-11-26 13:50:17', NULL, NULL, 14800, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:50:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54515, '2017-11-26 13:50:45', NULL, NULL, 14800, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:50:45', 'admin-1511656639-15116754451243021', 1, 1, 'SR', NULL, NULL, NULL),
(54516, '2017-11-26 15:17:17', NULL, NULL, 14809, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1511689231', 'admin', '2017-11-26 15:17:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54517, '2017-11-26 11:09:22', NULL, NULL, 14782, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:09:22', 'admin-1511656639-15116657623753770', 1, 1, 'SR', NULL, NULL, NULL),
(54518, '2017-11-26 11:09:22', NULL, NULL, 14782, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:09:22', 'admin-1511656639-15116657623753770', 1, 0, '', NULL, NULL, NULL),
(54519, '2017-11-26 11:12:24', NULL, NULL, 14783, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:12:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54520, '2017-11-26 11:12:51', NULL, NULL, 14783, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:12:51', 'admin-1511656639-15116659712716046', 1, 0, '', NULL, NULL, NULL),
(54521, '2017-11-26 11:12:51', NULL, NULL, 14783, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:12:51', 'admin-1511656639-15116659712716046', 1, 0, '', NULL, NULL, NULL),
(54522, '2017-11-26 15:10:04', NULL, NULL, 14807, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 15:10:04', 'admin-1511656639-1511680204231427', 1, 0, '', NULL, NULL, NULL),
(54523, '2017-11-26 16:57:13', NULL, NULL, 14814, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 16:57:13', 'admin-1511656639-15116866329185167', 1, 1, 'SR', NULL, NULL, NULL),
(54524, '2017-11-26 16:48:44', NULL, NULL, 14812, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 16:48:44', 'admin-1511656639-1511686124596557', 1, 0, '', NULL, NULL, NULL),
(54525, '2017-11-26 16:48:44', NULL, NULL, 14812, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 16:48:44', 'admin-1511656639-1511686124596557', 1, 1, 'SR', NULL, NULL, NULL),
(54526, '2017-11-26 14:12:23', NULL, NULL, 14801, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 14:12:23', 'admin-1511656639-15116767435254296', 1, 0, '', NULL, NULL, NULL),
(54527, '2017-11-26 16:57:02', NULL, NULL, 14814, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1511689231', 'admin', '2017-11-26 16:57:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54528, '2017-11-26 16:48:38', NULL, NULL, 14812, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1511689231', 'admin', '2017-11-26 16:48:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54529, '2017-11-26 14:48:41', NULL, NULL, 14807, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 14:48:41', 'admin-1511656639-15116789213252224', 1, 0, '', NULL, NULL, NULL),
(54530, '2017-11-26 14:56:51', NULL, NULL, 14808, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1511689231', 'admin', '2017-11-26 14:56:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54531, '2017-11-26 14:56:59', NULL, NULL, 14808, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 14:56:59', 'admin-1511656639-15116794189023840', 1, 1, 'SR', NULL, NULL, NULL),
(54532, '2017-11-26 14:56:59', NULL, NULL, 14808, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 14:56:59', 'admin-1511656639-15116794189023840', 1, 1, 'SR', NULL, NULL, NULL),
(54533, '2017-11-26 14:48:33', NULL, NULL, 14807, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1511689231', 'admin', '2017-11-26 14:48:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54534, '2017-11-26 14:46:56', NULL, NULL, 14805, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 14:46:56', 'admin-1511656639-15116788167018542', 1, 1, 'SR', NULL, NULL, NULL),
(54535, '2017-11-26 14:46:56', NULL, NULL, 14805, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 14:46:56', 'admin-1511656639-15116788167018542', 1, 0, '', NULL, NULL, NULL),
(54536, '2017-11-26 14:46:56', NULL, NULL, 14805, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 14:46:56', 'admin-1511656639-15116788167018542', 1, 0, '', NULL, NULL, NULL),
(54537, '2017-11-26 13:50:45', NULL, NULL, 14800, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:50:45', 'admin-1511656639-15116754451243021', 1, 1, 'SR', NULL, NULL, NULL),
(54538, '2017-11-26 14:46:06', NULL, NULL, 14805, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1511689231', 'admin', '2017-11-26 14:46:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54539, '2017-11-26 14:46:56', NULL, NULL, 14805, 0, 294, '230', 'Double Fry Salted Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 14:46:56', 'admin-1511656639-15116788167018542', 1, 0, '', NULL, NULL, NULL),
(54540, '2017-11-26 10:55:10', NULL, NULL, 14779, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:55:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54541, '2017-11-26 10:49:09', NULL, NULL, 14777, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:49:09', 'admin-1511656639-15116645496597550', 1, 0, '', NULL, NULL, NULL),
(54542, '2017-11-26 10:40:59', NULL, NULL, 14775, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:40:59', 'admin-1511656639-15116640590025085', 1, 1, 'SR', NULL, NULL, NULL),
(54543, '2017-11-26 14:34:48', NULL, NULL, 14804, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 14:34:48', 'admin-1511656639-1511678088672538', 1, 0, '', 1, NULL, NULL),
(54544, '2017-11-26 14:30:55', NULL, NULL, 14799, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 14:30:55', 'admin-1511656639-15116778557093678', 1, 1, 'SR', NULL, NULL, NULL),
(54545, '2017-11-26 13:24:03', NULL, NULL, 14797, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:24:03', 'admin-1511656639-15116738430234722', 1, 0, '', NULL, NULL, NULL),
(54546, '2017-11-26 13:24:03', NULL, NULL, 14797, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:24:03', 'admin-1511656639-15116738430234722', 1, 0, '', NULL, NULL, NULL),
(54547, '2017-11-26 13:23:50', NULL, NULL, 14797, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:23:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54548, '2017-11-26 14:15:26', NULL, NULL, 14803, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 14:15:26', 'admin-1511656639-15116769260112325', 1, 1, 'SR', NULL, NULL, NULL),
(54549, '2017-11-26 14:14:14', NULL, NULL, 14803, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 14:14:14', 'admin-1511656639-15116768548693482', 1, 1, 'SR', NULL, NULL, NULL),
(54550, '2017-11-26 14:12:41', NULL, NULL, 14801, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 14:12:41', 'admin-1511656639-1511676761157393', 1, 1, 'SR', NULL, NULL, NULL),
(54551, '2017-11-26 14:12:41', NULL, NULL, 14801, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 14:12:41', 'admin-1511656639-1511676761157393', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(54552, '2017-11-26 14:13:33', NULL, NULL, 14803, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 14:13:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54553, '2017-11-26 11:21:58', NULL, NULL, 14785, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:21:58', 'admin-1511656639-15116665180963330', 1, 1, 'SR', NULL, NULL, NULL),
(54554, '2017-11-26 10:30:42', NULL, NULL, 14771, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:30:42', 'admin-1511656639-15116634421844936', 1, 0, '', NULL, NULL, NULL),
(54555, '2017-11-26 14:12:23', NULL, NULL, 14801, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 14:12:23', 'admin-1511656639-15116767435254296', 1, 0, '', NULL, NULL, NULL),
(54556, '2017-11-26 13:15:25', NULL, NULL, 14796, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:15:25', 'admin-1511656639-15116733250348154', 1, 0, '', NULL, NULL, NULL),
(54557, '2017-11-26 13:15:14', NULL, NULL, 14796, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:15:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54558, '2017-11-26 12:44:00', NULL, NULL, 14795, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:44:00', 'admin-1511656639-151167144079149', 1, 1, 'SR', NULL, NULL, NULL),
(54559, '2017-11-26 12:44:00', NULL, NULL, 14795, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:44:00', 'admin-1511656639-151167144079149', 1, 1, 'SR', NULL, NULL, NULL),
(54560, '2017-11-26 12:43:52', NULL, NULL, 14795, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:43:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54561, '2017-11-26 12:43:16', NULL, NULL, 14793, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:43:16', 'admin-1511656639-15116713965236246', 1, 1, 'SR', NULL, NULL, NULL),
(54562, '2017-11-26 09:14:48', NULL, NULL, 14765, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:14:48', 'admin-1511656639-15116588886916179', 1, 0, '', NULL, NULL, NULL),
(54563, '2017-11-26 09:14:48', NULL, NULL, 14765, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:14:48', 'admin-1511656639-15116588886916179', 1, 1, 'SR', NULL, NULL, NULL),
(54564, '2017-11-26 09:17:04', NULL, NULL, 14766, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.70, 0.0000, 0.0000, 9.70, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:17:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54565, '2017-11-26 09:17:31', NULL, NULL, 14766, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:17:31', 'admin-1511656639-1511659050916266', 1, 0, '', NULL, NULL, NULL),
(54566, '2017-11-26 12:41:31', NULL, NULL, 14793, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.60, 0.0000, 0.0000, 9.60, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:41:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54567, '2017-11-26 12:41:48', NULL, NULL, 14794, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:41:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54568, '2017-11-26 12:42:20', NULL, NULL, 14794, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:42:20', 'admin-1511656639-15116713403735889', 1, 0, '', NULL, NULL, NULL),
(54569, '2017-11-26 12:17:59', NULL, NULL, 14789, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:17:59', 'admin-1511656639-15116698798083085', 1, 0, '', NULL, NULL, NULL),
(54570, '2017-11-26 13:34:12', NULL, NULL, 14798, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:34:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54571, '2017-11-26 12:42:20', NULL, NULL, 14794, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:42:20', 'admin-1511656639-15116713403735889', 1, 1, 'SR', NULL, NULL, NULL),
(54572, '2017-11-26 09:17:31', NULL, NULL, 14766, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:17:31', 'admin-1511656639-1511659050916266', 1, 0, '', NULL, NULL, NULL),
(54573, '2017-11-26 13:15:25', NULL, NULL, 14796, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:15:25', 'admin-1511656639-15116733250348154', 1, 0, '', NULL, NULL, NULL),
(54574, '2017-11-26 11:32:26', NULL, NULL, 14776, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:32:26', 'admin-1511656639-1511667146765853', 1, 1, 'SR', NULL, NULL, '10.0'),
(54575, '2017-11-26 11:12:51', NULL, NULL, 14783, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:12:51', 'admin-1511656639-15116659712716046', 1, 0, '', NULL, NULL, NULL),
(54576, '2017-11-26 11:12:51', NULL, NULL, 14783, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:12:51', 'admin-1511656639-15116659712716046', 1, 1, 'SR', NULL, NULL, NULL),
(54577, '2017-11-26 11:12:51', NULL, NULL, 14783, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:12:51', 'admin-1511656639-15116659712716046', 1, 1, 'SR', NULL, NULL, NULL),
(54578, '2017-11-26 11:12:51', NULL, NULL, 14783, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:12:51', 'admin-1511656639-15116659712716046', 1, 0, '', NULL, NULL, NULL),
(54579, '2017-11-26 11:20:14', NULL, NULL, 14784, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:20:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54580, '2017-11-26 11:20:43', NULL, NULL, 14784, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:20:43', 'admin-1511656639-15116664431451016', 1, 1, 'SR', NULL, NULL, NULL),
(54581, '2017-11-26 12:32:57', NULL, NULL, 14792, 0, 153, '87', 'Wake Me Up!', 'no bread', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:32:57', 'admin-1511656639-15116707777585083', 1, 0, '', NULL, NULL, NULL),
(54582, '2017-11-26 12:32:51', NULL, NULL, 14792, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:32:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54583, '2017-11-26 12:31:03', NULL, NULL, 14785, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:31:03', 'admin-1511656639-15116706635933778', 1, 1, 'SR', NULL, NULL, NULL),
(54584, '2017-11-26 12:31:03', NULL, NULL, 14785, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:31:03', 'admin-1511656639-15116706635933778', 1, 1, 'SR', NULL, NULL, NULL),
(54585, '2017-11-26 12:05:05', NULL, NULL, 14787, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:05:05', 'admin-1511656639-15116691056823267', 1, 0, '', 1, NULL, NULL),
(54586, '2017-11-26 13:51:10', NULL, NULL, 14801, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:51:10', 'admin-1511656639-15116754706224196', 1, 0, '', NULL, NULL, NULL),
(54587, '2017-11-26 12:31:03', NULL, NULL, 14785, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:31:03', 'admin-1511656639-15116706635933778', 1, 1, 'SR', NULL, NULL, NULL),
(54588, '2017-11-26 12:23:30', NULL, NULL, 14791, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:23:30', 'admin-1511656639-1511670210694269', 1, 0, '', 1, NULL, NULL),
(54589, '2017-11-26 11:45:11', NULL, NULL, 14785, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:45:11', 'admin-1511656639-15116679109976715', 1, 1, 'SR', NULL, NULL, NULL),
(54590, '2017-11-26 11:28:27', NULL, NULL, 14786, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:28:27', 'admin-1511656639-1511666907287531', 1, 1, 'SR', NULL, NULL, NULL),
(54591, '2017-11-26 11:28:27', NULL, NULL, 14786, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:28:27', 'admin-1511656639-1511666907287531', 1, 1, 'SR', NULL, NULL, NULL),
(54592, '2017-11-26 17:41:02', NULL, NULL, 14815, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 17:41:02', 'admin-1511689231-1511689262574910', 1, 1, 'SR', NULL, NULL, NULL),
(54593, '2017-11-26 12:21:34', NULL, NULL, 14790, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:21:34', 'admin-1511656639-15116700948286499', 1, 1, 'SR', NULL, NULL, NULL),
(54594, '2017-11-26 12:21:34', NULL, NULL, 14790, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:21:34', 'admin-1511656639-15116700948286499', 1, 0, '', NULL, NULL, NULL),
(54595, '2017-11-26 12:25:08', NULL, NULL, 14790, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:25:08', 'admin-1511656639-15116703086183190', 1, 0, '', NULL, NULL, NULL),
(54596, '2017-11-26 12:21:24', NULL, NULL, 14790, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:21:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54597, '2017-11-26 10:13:57', NULL, NULL, 14771, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 17.90, 0.0000, 0.0000, 17.90, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:13:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54598, '2017-11-26 10:14:06', NULL, NULL, 14771, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:14:06', 'admin-1511656639-15116624459337621', 1, 0, '', NULL, NULL, NULL),
(54599, '2017-11-26 10:14:06', NULL, NULL, 14771, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:14:06', 'admin-1511656639-15116624459337621', 1, 0, '', NULL, NULL, NULL),
(54600, '2017-11-26 10:18:47', NULL, NULL, 14766, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:18:47', 'admin-1511656639-15116627274812333', 1, 1, 'SR', NULL, NULL, NULL),
(54601, '2017-11-26 10:18:47', NULL, NULL, 14766, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:18:47', 'admin-1511656639-15116627274812333', 1, 1, 'SR', NULL, NULL, NULL),
(54602, '2017-11-26 13:59:00', NULL, NULL, 14802, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:59:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54603, '2017-11-26 12:17:44', NULL, NULL, 14789, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:17:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54604, '2017-11-26 13:52:58', NULL, NULL, 14799, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:52:58', 'admin-1511656639-15116755782124520', 1, 1, 'SR', NULL, NULL, NULL),
(54605, '2017-11-26 12:18:00', NULL, NULL, 14789, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:18:00', 'admin-1511656639-15116698798083085', 1, 0, '', NULL, NULL, NULL),
(54606, '2017-11-26 12:17:59', NULL, NULL, 14789, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:17:59', 'admin-1511656639-15116698798083085', 1, 0, '', NULL, NULL, NULL),
(54607, '2017-11-26 12:18:00', NULL, NULL, 14789, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:18:00', 'admin-1511656639-15116698798083085', 1, 1, 'SR', NULL, NULL, NULL),
(54608, '2017-11-26 17:40:59', NULL, NULL, 14815, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1511689231', 'admin', '2017-11-26 17:40:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54609, '2017-11-26 11:21:58', NULL, NULL, 14785, 0, 32, '32', 'Tea By Pot ', 'english bfast', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:21:58', 'admin-1511656639-15116665180963330', 1, 1, 'SR', NULL, NULL, NULL),
(54610, '2017-11-26 10:44:07', NULL, NULL, 14771, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:44:07', 'admin-1511656639-15116642471249715', 1, 0, '', NULL, NULL, NULL),
(54611, '2017-11-26 10:30:42', NULL, NULL, 14771, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:30:42', 'admin-1511656639-15116634421844936', 1, 0, '', NULL, NULL, NULL),
(54612, '2017-11-26 10:30:42', NULL, NULL, 14771, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:30:42', 'admin-1511656639-15116634421844936', 1, 0, '', NULL, NULL, NULL),
(54613, '2017-11-26 13:24:03', NULL, NULL, 14797, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:24:03', 'admin-1511656639-15116738430234722', 1, 1, 'SR', NULL, NULL, NULL),
(54614, '2017-11-26 12:10:22', NULL, NULL, 14788, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:10:22', 'admin-1511656639-15116694220077110', 1, 1, 'SR', NULL, NULL, NULL),
(54615, '2017-11-26 12:10:15', NULL, NULL, 14788, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:10:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54616, '2017-11-26 10:30:42', NULL, NULL, 14771, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:30:42', 'admin-1511656639-15116634421844936', 1, 0, '', NULL, NULL, NULL),
(54617, '2017-11-26 11:45:11', NULL, NULL, 14785, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:45:11', 'admin-1511656639-15116679109976715', 1, 0, '', NULL, NULL, NULL),
(54618, '2017-11-26 11:28:27', NULL, NULL, 14786, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:28:27', 'admin-1511656639-1511666907287531', 1, 0, '', NULL, NULL, NULL),
(54619, '2017-11-26 11:28:27', NULL, NULL, 14786, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:28:27', 'admin-1511656639-1511666907287531', 1, 0, '', NULL, NULL, NULL),
(54620, '2017-11-26 11:28:15', NULL, NULL, 14786, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:28:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54621, '2017-11-26 11:28:05', NULL, NULL, 14782, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:28:05', 'admin-1511656639-15116668854152482', 1, 0, '', NULL, NULL, NULL),
(54622, '2017-11-26 10:40:59', NULL, NULL, 14775, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:40:59', 'admin-1511656639-15116640590025085', 1, 0, '', NULL, NULL, NULL),
(54623, '2017-11-26 10:40:59', NULL, NULL, 14775, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:40:59', 'admin-1511656639-15116640590025085', 1, 1, 'SR', NULL, NULL, NULL),
(54624, '2017-11-26 12:42:20', NULL, NULL, 14794, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:42:20', 'admin-1511656639-15116713403735889', 1, 0, '', NULL, NULL, NULL),
(54625, '2017-11-26 10:55:28', NULL, NULL, 14779, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:55:28', 'admin-1511656639-15116649282348050', 1, 1, 'SR', NULL, NULL, NULL),
(54626, '2017-11-26 10:55:28', NULL, NULL, 14779, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:55:28', 'admin-1511656639-15116649282348050', 1, 1, 'SR', NULL, NULL, NULL),
(54627, '2017-11-26 10:46:19', NULL, NULL, 14776, 0, 181, '116', 'Open Food ', 'sunny side up', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:46:19', 'admin-1511656639-1511664378896781', 1, 0, '', NULL, NULL, '10.0'),
(54628, '2017-11-26 10:48:16', NULL, NULL, 14777, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.90, 0.0000, 0.0000, 15.90, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:48:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54629, '2017-11-26 10:48:58', NULL, NULL, 14777, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:48:58', 'admin-1511656639-15116645380075033', 1, 0, '', NULL, NULL, NULL),
(54630, '2017-11-26 10:35:20', NULL, NULL, 14773, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:35:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54631, '2017-11-26 10:35:32', NULL, NULL, 14773, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:35:32', 'admin-1511656639-15116637325512266', 1, 0, '', NULL, NULL, NULL),
(54632, '2017-11-26 10:35:32', NULL, NULL, 14773, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:35:32', 'admin-1511656639-15116637325512266', 1, 0, '', NULL, NULL, NULL),
(54633, '2017-11-26 10:35:37', NULL, NULL, 14774, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:35:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54634, '2017-11-26 10:36:16', NULL, NULL, 14774, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:36:16', 'admin-1511656639-15116637765409899', 1, 1, 'SR', NULL, NULL, NULL),
(54635, '2017-11-26 10:36:16', NULL, NULL, 14774, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:36:16', 'admin-1511656639-15116637765409899', 1, 0, '', NULL, NULL, NULL),
(54636, '2017-11-26 10:36:16', NULL, NULL, 14774, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:36:16', 'admin-1511656639-15116637765409899', 1, 0, '', NULL, NULL, NULL),
(54637, '2017-11-26 10:40:34', NULL, NULL, 14775, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.50, 0.0000, 0.0000, 11.50, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:40:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54638, '2017-11-26 11:21:58', NULL, NULL, 14785, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:21:58', 'admin-1511656639-15116665180963330', 1, 0, '', NULL, NULL, NULL),
(54639, '2017-11-26 11:20:43', NULL, NULL, 14784, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:20:43', 'admin-1511656639-15116664431451016', 1, 0, '', NULL, NULL, NULL),
(54640, '2017-11-26 09:49:52', NULL, NULL, 14770, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:49:52', 'admin-1511656639-15116609919692747', 1, 0, '', NULL, NULL, NULL),
(54641, '2017-11-26 09:49:52', NULL, NULL, 14770, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:49:52', 'admin-1511656639-15116609919692747', 1, 0, '', NULL, NULL, NULL),
(54642, '2017-11-26 11:21:58', NULL, NULL, 14785, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:21:58', 'admin-1511656639-15116665180963330', 1, 0, '', NULL, NULL, NULL),
(54643, '2017-11-26 11:09:22', NULL, NULL, 14782, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:09:22', 'admin-1511656639-15116657623753770', 1, 1, 'SR', NULL, NULL, NULL),
(54644, '2017-11-26 11:09:09', NULL, NULL, 14782, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:09:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54645, '2017-11-26 11:06:17', NULL, NULL, 14777, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:06:17', 'admin-1511656639-1511665577413704', 1, 1, 'SR', NULL, NULL, NULL),
(54646, '2017-11-26 11:01:27', NULL, NULL, 14781, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:01:27', 'admin-1511656639-15116652876002325', 1, 0, '', NULL, NULL, NULL),
(54647, '2017-11-26 11:01:27', NULL, NULL, 14781, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:01:27', 'admin-1511656639-15116652876002325', 1, 1, 'SR', NULL, NULL, NULL),
(54648, '2017-11-26 11:01:27', NULL, NULL, 14781, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:01:27', 'admin-1511656639-15116652876002325', 1, 0, '', NULL, NULL, NULL),
(54649, '2017-11-26 10:32:00', NULL, NULL, 14771, 0, 181, '116', 'Open Food ', 'nutella spread', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:32:00', 'admin-1511656639-1511663520684441', 1, 0, '', NULL, NULL, NULL),
(54650, '2017-11-26 15:17:29', NULL, NULL, 14809, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 15:17:29', 'admin-1511656639-15116806497758579', 1, 0, '', NULL, NULL, NULL),
(54651, '2017-11-26 13:50:45', NULL, NULL, 14800, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:50:45', 'admin-1511656639-15116754451243021', 1, 1, 'SR', NULL, NULL, NULL),
(54652, '2017-11-26 11:06:17', NULL, NULL, 14777, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:06:17', 'admin-1511656639-1511665577413704', 1, 0, '', NULL, NULL, NULL),
(54653, '2017-11-26 10:40:59', NULL, NULL, 14775, 0, 153, '87', 'Wake Me Up!', 'sunny side up', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:40:59', 'admin-1511656639-15116640590025085', 1, 0, '', NULL, NULL, NULL),
(54654, '2017-11-26 10:40:59', NULL, NULL, 14775, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:40:59', 'admin-1511656639-15116640590025085', 1, 0, '', NULL, NULL, NULL),
(54655, '2017-11-26 11:06:17', NULL, NULL, 14777, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:06:17', 'admin-1511656639-1511665577413704', 1, 0, '', NULL, NULL, NULL),
(54656, '2017-11-26 11:06:17', NULL, NULL, 14777, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:06:17', 'admin-1511656639-1511665577413704', 1, 0, '', NULL, NULL, NULL),
(54657, '2017-11-26 11:03:27', NULL, NULL, 14771, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:03:27', 'admin-1511656639-1511665406841887', 1, 0, '', NULL, NULL, NULL),
(54658, '2017-11-26 11:02:53', NULL, NULL, 14774, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:02:53', 'admin-1511656639-15116653736991612', 1, 0, '', NULL, NULL, NULL),
(54659, '2017-11-26 09:49:26', NULL, NULL, 14770, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:49:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54660, '2017-11-26 11:01:27', NULL, NULL, 14781, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:01:27', 'admin-1511656639-15116652876002325', 1, 0, '', NULL, NULL, NULL),
(54661, '2017-11-26 11:47:19', NULL, NULL, 14780, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:47:19', 'admin-1511656639-15116680396614221', 1, 1, 'SR', NULL, NULL, NULL),
(54662, '2017-11-26 10:55:54', NULL, NULL, 14780, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:55:54', 'admin-1511656639-15116649541452075', 1, 1, 'SR', NULL, NULL, NULL),
(54663, '2017-11-26 11:00:58', NULL, NULL, 14781, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:00:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54664, '2017-11-26 10:55:37', NULL, NULL, 14780, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:55:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54665, '2017-11-26 10:45:40', NULL, NULL, 14776, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:45:40', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(54666, '2017-11-26 10:45:59', NULL, NULL, 14776, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:45:59', 'admin-1511656639-15116643592026687', 1, 1, 'SR', NULL, NULL, '10.0'),
(54667, '2017-11-26 10:40:59', NULL, NULL, 14775, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:40:59', 'admin-1511656639-15116640590025085', 1, 0, '', NULL, NULL, NULL),
(54668, '2017-11-26 09:49:18', NULL, NULL, 14769, 0, 182, '117', 'Open Drinks ', 'milk', 'Cold Drinks', 'Fresh Juice', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:49:18', 'admin-1511656639-15116609582699628', 1, 0, '', NULL, NULL, NULL),
(54669, '2017-11-26 14:15:05', NULL, NULL, 14801, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 14:15:05', 'admin-1511656639-15116769050373013', 1, 0, '', NULL, NULL, NULL),
(54670, '2017-11-26 09:49:52', NULL, NULL, 14770, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:49:52', 'admin-1511656639-15116609919692747', 1, 1, 'SR', NULL, NULL, NULL),
(54671, '2017-11-26 10:51:10', NULL, NULL, 14778, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:51:10', 'admin-1511656639-15116646699568158', 1, 0, '', NULL, NULL, NULL),
(54672, '2017-11-26 12:43:16', NULL, NULL, 14793, 0, 215, '149', 'Thai Fish Sauce Garlic Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:43:16', 'admin-1511656639-15116713965236246', 1, 0, '', NULL, NULL, NULL),
(54673, '2017-11-26 10:48:58', NULL, NULL, 14777, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:48:58', 'admin-1511656639-15116645380075033', 1, 0, '', NULL, NULL, NULL),
(54674, '2017-11-26 10:48:58', NULL, NULL, 14777, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:48:58', 'admin-1511656639-15116645380075033', 1, 0, '', NULL, NULL, NULL),
(54675, '2017-11-26 10:48:58', NULL, NULL, 14777, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:48:58', 'admin-1511656639-15116645380075033', 1, 0, '', NULL, NULL, NULL),
(54676, '2017-11-26 10:45:59', NULL, NULL, 14776, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:45:59', 'admin-1511656639-15116643592026687', 1, 1, 'SR', NULL, NULL, '10.0'),
(54677, '2017-11-26 10:40:59', NULL, NULL, 14775, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:40:59', 'admin-1511656639-15116640590025085', 1, 1, 'SR', NULL, NULL, NULL),
(54678, '2017-11-26 12:43:16', NULL, NULL, 14793, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:43:16', 'admin-1511656639-15116713965236246', 1, 1, 'SR', NULL, NULL, NULL),
(54679, '2017-11-26 16:57:13', NULL, NULL, 14814, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 16:57:13', 'admin-1511656639-15116866329185167', 1, 1, 'SR', NULL, NULL, NULL),
(54680, '2017-11-26 10:33:38', NULL, NULL, 14772, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:33:38', 'admin-1511656639-15116636179372811', 1, 0, '', NULL, NULL, NULL),
(54681, '2017-11-26 10:33:38', NULL, NULL, 14772, 0, 32, '32', 'Tea By Pot ', 'earl grey', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:33:38', 'admin-1511656639-15116636179372811', 1, 1, 'SR', NULL, NULL, NULL),
(54682, '2017-11-26 10:33:15', NULL, NULL, 14772, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:33:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54683, '2017-11-26 10:33:38', NULL, NULL, 14772, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:33:38', 'admin-1511656639-15116636179372811', 1, 0, '', NULL, NULL, NULL),
(54684, '2017-11-26 13:24:03', NULL, NULL, 14797, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:24:03', 'admin-1511656639-15116738430234722', 1, 1, 'SR', NULL, NULL, NULL),
(54685, '2017-11-26 09:23:33', NULL, NULL, 14767, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:23:33', 'admin-1511656639-15116594128919314', 1, 1, 'SR', NULL, NULL, NULL),
(54686, '2017-11-26 10:30:58', NULL, NULL, 14771, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:30:58', 'admin-1511656639-15116634580692336', 1, 1, 'SR', NULL, NULL, NULL),
(54687, '2017-11-26 10:30:42', NULL, NULL, 14771, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:30:42', 'admin-1511656639-15116634421844936', 1, 1, 'SR', NULL, NULL, NULL),
(54688, '2017-11-26 10:30:42', NULL, NULL, 14771, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:30:42', 'admin-1511656639-15116634421844936', 1, 0, '', NULL, NULL, NULL),
(54689, '2017-11-26 10:30:42', NULL, NULL, 14771, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:30:42', 'admin-1511656639-15116634421844936', 1, 1, 'SR', NULL, NULL, NULL),
(54690, '2017-11-26 10:45:59', NULL, NULL, 14776, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:45:59', 'admin-1511656639-15116643592026687', 1, 0, '', NULL, NULL, '10.0'),
(54691, '2017-11-26 10:30:42', NULL, NULL, 14771, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:30:42', 'admin-1511656639-15116634421844936', 1, 0, '', NULL, NULL, NULL),
(54692, '2017-11-26 09:23:33', NULL, NULL, 14767, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:23:33', 'admin-1511656639-15116594128919314', 1, 1, 'SR', NULL, NULL, NULL),
(54693, '2017-11-26 09:26:28', NULL, NULL, 14768, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:26:28', 'admin-1511656639-15116595884737433', 1, 0, '', NULL, NULL, NULL),
(54694, '2017-11-26 09:49:18', NULL, NULL, 14769, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:49:18', 'admin-1511656639-15116609582699628', 1, 0, '', NULL, NULL, NULL),
(54695, '2017-11-26 09:04:33', NULL, NULL, 14763, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:04:33', 'admin-1511656639-15116582734992085', 1, 1, 'SR', NULL, NULL, NULL),
(54696, '2017-11-26 09:07:01', NULL, NULL, 14764, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.60, 0.0000, 0.0000, 9.60, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:07:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54697, '2017-11-26 09:08:57', NULL, NULL, 14764, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:08:57', 'admin-1511656639-15116585370851214', 1, 0, '', NULL, NULL, NULL),
(54698, '2017-11-26 13:51:10', NULL, NULL, 14801, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 13:51:10', 'admin-1511656639-15116754706224196', 1, 1, 'SR', NULL, NULL, NULL),
(54699, '2017-11-26 11:21:34', NULL, NULL, 14785, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.40, 0.0000, 0.0000, 11.40, 1, '27', 1, '1511689231', 'admin', '2017-11-26 11:21:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54700, '2017-11-26 09:26:28', NULL, NULL, 14768, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:26:28', 'admin-1511656639-15116595884737433', 1, 1, 'SR', NULL, NULL, NULL),
(54701, '2017-11-26 09:26:28', NULL, NULL, 14768, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:26:28', 'admin-1511656639-15116595884737433', 1, 1, 'SR', NULL, NULL, NULL),
(54702, '2017-11-26 09:26:28', NULL, NULL, 14768, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:26:28', 'admin-1511656639-15116595884737433', 1, 0, '', NULL, NULL, NULL),
(54703, '2017-11-26 09:49:18', NULL, NULL, 14769, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:49:18', 'admin-1511656639-15116609582699628', 1, 0, '', NULL, NULL, NULL),
(54704, '2017-11-26 09:49:18', NULL, NULL, 14769, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:49:18', 'admin-1511656639-15116609582699628', 1, 0, '', NULL, NULL, NULL),
(54705, '2017-11-26 09:48:34', NULL, NULL, 14769, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:48:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54706, '2017-11-26 09:08:57', NULL, NULL, 14764, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:08:57', 'admin-1511656639-15116585370851214', 1, 1, 'SR', NULL, NULL, NULL),
(54707, '2017-11-26 12:42:20', NULL, NULL, 14794, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 12:42:20', 'admin-1511656639-15116713403735889', 1, 0, '', NULL, NULL, NULL),
(54708, '2017-11-26 09:25:58', NULL, NULL, 14768, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:25:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54709, '2017-11-26 09:26:28', NULL, NULL, 14768, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:26:28', 'admin-1511656639-15116595884737433', 1, 0, '', NULL, NULL, NULL),
(54710, '2017-11-26 09:17:31', NULL, NULL, 14766, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:17:31', 'admin-1511656639-1511659050916266', 1, 0, '', NULL, NULL, NULL),
(54711, '2017-11-26 09:08:57', NULL, NULL, 14764, 0, 181, '116', 'Open Food ', 'toast,toast 4', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:08:57', 'admin-1511656639-15116585370851214', 1, 0, '', NULL, NULL, NULL),
(54712, '2017-11-26 09:08:57', NULL, NULL, 14764, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:08:57', 'admin-1511656639-15116585370851214', 1, 0, '', NULL, NULL, NULL),
(54713, '2017-11-26 09:08:57', NULL, NULL, 14764, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:08:57', 'admin-1511656639-15116585370851214', 1, 0, '', NULL, NULL, NULL),
(54714, '2017-11-26 09:08:57', NULL, NULL, 14764, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:08:57', 'admin-1511656639-15116585370851214', 1, 1, 'SR', NULL, NULL, NULL),
(54715, '2017-11-26 09:08:57', NULL, NULL, 14764, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:08:57', 'admin-1511656639-15116585370851214', 1, 1, 'SR', NULL, NULL, NULL),
(54716, '2017-11-26 16:03:13', NULL, NULL, 14810, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 16:03:13', 'admin-1511656639-15116833931263544', 1, 1, 'SR', NULL, NULL, NULL),
(54717, '2017-11-26 09:23:33', NULL, NULL, 14767, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:23:33', 'admin-1511656639-15116594128919314', 1, 0, '', NULL, NULL, NULL),
(54718, '2017-11-26 09:23:33', NULL, NULL, 14767, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:23:33', 'admin-1511656639-15116594128919314', 1, 1, 'SR', NULL, NULL, NULL),
(54719, '2017-11-26 09:23:33', NULL, NULL, 14767, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:23:33', 'admin-1511656639-15116594128919314', 1, 0, '', NULL, NULL, NULL),
(54720, '2017-11-26 09:23:33', NULL, NULL, 14767, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:23:33', 'admin-1511656639-15116594128919314', 1, 0, '', NULL, NULL, NULL),
(54721, '2017-11-26 10:30:42', NULL, NULL, 14771, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 10:30:42', 'admin-1511656639-15116634421844936', 1, 0, '', NULL, NULL, NULL),
(54722, '2017-11-26 09:23:33', NULL, NULL, 14767, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:23:33', 'admin-1511656639-15116594128919314', 1, 0, '', NULL, NULL, NULL),
(54723, '2017-11-26 09:23:33', NULL, NULL, 14767, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:23:33', 'admin-1511656639-15116594128919314', 1, 0, '', NULL, NULL, NULL),
(54724, '2017-11-26 09:23:33', NULL, NULL, 14767, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:23:33', 'admin-1511656639-15116594128919314', 1, 0, '', NULL, NULL, NULL),
(54725, '2017-11-26 09:17:31', NULL, NULL, 14766, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:17:31', 'admin-1511656639-1511659050916266', 1, 1, 'SR', NULL, NULL, NULL),
(54726, '2017-11-26 09:17:31', NULL, NULL, 14766, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:17:31', 'admin-1511656639-1511659050916266', 1, 1, 'SR', NULL, NULL, NULL),
(54727, '2017-11-26 09:17:31', NULL, NULL, 14766, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:17:31', 'admin-1511656639-1511659050916266', 1, 1, 'SR', NULL, NULL, NULL),
(54728, '2017-11-26 09:22:59', NULL, NULL, 14767, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.90, 0.0000, 0.0000, 12.90, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:22:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54729, '2017-11-26 09:14:37', NULL, NULL, 14765, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:14:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54730, '2017-11-26 09:04:16', NULL, NULL, 14763, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:04:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54731, '2017-11-26 09:04:33', NULL, NULL, 14763, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511689231', 'admin', '2017-11-26 09:04:33', 'admin-1511656639-15116582734992085', 1, 0, '', NULL, NULL, NULL),
(54732, '2017-11-27 13:26:27', NULL, NULL, 14836, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:26:27', 'admin-1511744410-1511760387245998', 1, 0, '', NULL, NULL, NULL),
(54733, '2017-11-27 13:26:27', NULL, NULL, 14836, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:26:27', 'admin-1511744410-1511760387245998', 1, 0, '', NULL, NULL, NULL),
(54734, '2017-11-27 13:26:27', NULL, NULL, 14836, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:26:27', 'admin-1511744410-1511760387245998', 1, 0, '', NULL, NULL, NULL),
(54735, '2017-11-27 13:26:27', NULL, NULL, 14836, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:26:27', 'admin-1511744410-1511760387245998', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(54736, '2017-11-27 12:36:44', NULL, NULL, 14833, 0, 75, '75', 'Meatless Aglio Olio ', 'extra chili', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 12:36:44', 'admin-1511744410-15117574038876493', 1, 0, '', NULL, NULL, NULL),
(54737, '2017-11-27 13:20:33', NULL, NULL, 14836, 0, 181, '116', 'Open Food ', 'Empty noodle', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:20:33', 'admin-1511744410-15117600335849763', 1, 0, '', NULL, NULL, NULL),
(54738, '2017-11-27 13:24:32', NULL, NULL, 14837, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.00, 0.0000, 0.0000, 15.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:24:32', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(54739, '2017-11-27 13:25:06', NULL, NULL, 14837, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:25:06', 'admin-1511744410-15117603062268829', 1, 0, '', NULL, NULL, '10.0'),
(54740, '2017-11-27 10:10:10', NULL, NULL, 14822, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1511744410', 'admin', '2017-11-27 10:10:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54741, '2017-11-27 14:33:02', NULL, NULL, 14840, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:33:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54742, '2017-11-27 14:33:06', NULL, NULL, 14840, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:33:06', 'admin-1511744410-15117643868409893', 1, 0, '', NULL, NULL, NULL),
(54743, '2017-11-27 14:38:32', NULL, NULL, 14840, 0, 75, '75', 'Meatless Aglio Olio ', 'marmite', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:38:32', 'admin-1511744410-15117647121524797', 1, 0, '', NULL, NULL, NULL),
(54744, '2017-11-27 14:38:32', NULL, NULL, 14840, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', 'takeaway', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:38:32', 'admin-1511744410-15117647121524797', 1, 0, '', NULL, NULL, NULL),
(54745, '2017-11-27 14:38:32', NULL, NULL, 14840, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:38:32', 'admin-1511744410-15117647121524797', 1, 0, '', NULL, NULL, NULL),
(54746, '2017-11-27 17:26:07', NULL, NULL, 14847, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 17:26:07', 'admin-1511744410-1511774767031204', 1, 0, '', 1, NULL, NULL),
(54747, '2017-11-27 11:12:10', NULL, NULL, 14826, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 11:12:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54748, '2017-11-27 13:25:06', NULL, NULL, 14837, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:25:06', 'admin-1511744410-15117603062268829', 1, 1, 'SR', NULL, NULL, '10.0'),
(54749, '2017-11-27 15:03:38', NULL, NULL, 14842, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1511744410', 'admin', '2017-11-27 15:03:38', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(54750, '2017-11-27 15:03:51', NULL, NULL, 14842, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 15:03:51', 'admin-1511744410-15117662309023852', 1, 1, 'SR', NULL, NULL, '10.0'),
(54751, '2017-11-27 13:54:19', NULL, NULL, 14838, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:54:19', 'admin-1511744410-15117620588891443', 1, 1, 'SR', NULL, NULL, NULL),
(54752, '2017-11-27 13:54:12', NULL, NULL, 14838, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:54:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54753, '2017-11-27 15:27:20', NULL, NULL, 14844, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 15:27:20', 'admin-1511744410-15117676400153522', 1, 1, 'SR', NULL, NULL, NULL),
(54754, '2017-11-27 15:27:20', NULL, NULL, 14844, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 15:27:20', 'admin-1511744410-15117676400153522', 1, 0, '', NULL, NULL, NULL),
(54755, '2017-11-27 15:27:51', NULL, NULL, 14845, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1511744410', 'admin', '2017-11-27 15:27:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54756, '2017-11-27 15:27:57', NULL, NULL, 14845, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 15:27:57', 'admin-1511744410-1511767677334573', 1, 0, '', NULL, NULL, NULL),
(54757, '2017-11-27 15:27:57', NULL, NULL, 14845, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 15:27:57', 'admin-1511744410-1511767677334573', 1, 1, 'SR', NULL, NULL, NULL),
(54758, '2017-11-27 10:10:14', NULL, NULL, 14822, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 10:10:14', 'admin-1511744410-1511748614047423', 1, 1, 'SR', NULL, NULL, NULL),
(54759, '2017-11-27 00:00:00', NULL, NULL, 14828, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, NULL, NULL, 3.30, 1, '27', 1, '1511744410', 'admin', '2017-11-27 10:27:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54760, '2017-11-27 11:12:19', NULL, NULL, 14827, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 11:12:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54761, '2017-11-27 12:36:44', NULL, NULL, 14833, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 12:36:44', 'admin-1511744410-15117574038876493', 1, 1, 'SR', NULL, NULL, NULL),
(54762, '2017-11-27 12:19:40', NULL, NULL, 14831, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1511744410', 'admin', '2017-11-27 12:19:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54763, '2017-11-27 12:19:47', NULL, NULL, 14831, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 12:19:47', 'admin-1511744410-15117563871246913', 1, 1, 'SR', NULL, NULL, NULL),
(54764, '2017-11-27 12:19:47', NULL, NULL, 14831, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 12:19:47', 'admin-1511744410-15117563871246913', 1, 1, 'SR', NULL, NULL, NULL),
(54765, '2017-11-27 12:27:10', NULL, NULL, 14832, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1511744410', 'admin', '2017-11-27 12:27:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54766, '2017-11-27 12:27:15', NULL, NULL, 14832, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 12:27:15', 'admin-1511744410-15117568351865665', 1, 1, 'SR', NULL, NULL, NULL),
(54767, '2017-11-27 12:34:15', NULL, NULL, 14833, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1511744410', 'admin', '2017-11-27 12:34:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54768, '2017-11-27 13:26:27', NULL, NULL, 14836, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:26:27', 'admin-1511744410-1511760387245998', 1, 1, 'SR', NULL, NULL, NULL),
(54769, '2017-11-27 09:27:51', NULL, NULL, 14818, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:27:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54770, '2017-11-27 09:28:03', NULL, NULL, 14818, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:28:03', 'admin-1511744410-15117460832491595', 1, 0, '', NULL, NULL, NULL),
(54771, '2017-11-27 09:28:03', NULL, NULL, 14818, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:28:03', 'admin-1511744410-15117460832491595', 1, 1, 'SR', NULL, NULL, NULL),
(54772, '2017-11-27 09:28:03', NULL, NULL, 14818, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:28:03', 'admin-1511744410-15117460832491595', 1, 1, 'SR', NULL, NULL, NULL),
(54773, '2017-11-27 13:25:06', NULL, NULL, 14837, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:25:06', 'admin-1511744410-15117603062268829', 1, 1, 'SR', NULL, NULL, '10.0'),
(54774, '2017-11-27 14:52:44', NULL, NULL, 14840, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:52:44', 'admin-1511744410-15117655644779925', 1, 1, 'SR', NULL, NULL, NULL),
(54775, '2017-11-27 12:46:16', NULL, NULL, 14834, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 12:46:16', 'admin-1511744410-15117579759803642', 1, 0, '', NULL, NULL, NULL),
(54776, '2017-11-27 12:46:16', NULL, NULL, 14834, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 12:46:16', 'admin-1511744410-15117579759803642', 1, 0, '', NULL, NULL, NULL),
(54777, '2017-11-27 13:19:59', NULL, NULL, 14836, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.30, 0.0000, 0.0000, 14.30, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:19:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54778, '2017-11-27 11:10:19', NULL, NULL, 14825, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 11:10:19', 'admin-1511744410-15117522189695439', 1, 1, 'SR', NULL, NULL, NULL),
(54779, '2017-11-27 11:10:19', NULL, NULL, 14825, 0, 182, '117', 'Open Drinks ', 'Fruits', 'Cold Drinks', 'Fresh Juice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 11:10:19', 'admin-1511744410-15117522189695439', 1, 0, '', NULL, NULL, NULL),
(54780, '2017-11-27 00:00:00', NULL, NULL, 14826, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 10:27:26', 'admin-1511744410-15117496466443624', 1, 1, 'SR', NULL, NULL, NULL),
(54781, '2017-11-27 00:00:00', NULL, NULL, 14826, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 10:27:26', 'admin-1511744410-15117496466443624', 1, 0, '', NULL, NULL, NULL),
(54782, '2017-11-27 15:50:58', NULL, NULL, 14846, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 15:50:58', 'admin-1511744410-15117690582684693', 1, 1, 'SR', NULL, NULL, NULL),
(54783, '2017-11-27 15:50:45', NULL, NULL, 14846, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1511744410', 'admin', '2017-11-27 15:50:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54784, '2017-11-27 17:26:07', NULL, NULL, 14847, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 17:26:07', 'admin-1511744410-1511774767031204', 1, 0, '', 1, NULL, NULL),
(54785, '2017-11-27 11:34:02', NULL, NULL, 14829, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1511744410', 'admin', '2017-11-27 11:34:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54786, '2017-11-27 15:18:25', NULL, NULL, 14843, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 15:18:25', 'admin-1511744410-15117671052978322', 1, 1, 'SR', NULL, NULL, NULL),
(54787, '2017-11-27 14:44:10', NULL, NULL, 14841, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:44:10', 'admin-1511744410-15117650507103466', 1, 1, 'SR', NULL, NULL, NULL),
(54788, '2017-11-27 14:43:53', NULL, NULL, 14841, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:43:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54789, '2017-11-27 00:00:00', NULL, NULL, 14827, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 10:27:26', 'admin-1511744410-15117496466443624', 1, 1, 'SR', NULL, NULL, NULL),
(54790, '2017-11-27 00:00:00', NULL, NULL, 14828, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 10:27:26', 'admin-1511744410-15117496466443624', 1, 0, '', NULL, NULL, NULL),
(54791, '2017-11-27 14:44:10', NULL, NULL, 14841, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:44:10', 'admin-1511744410-15117650507103466', 1, 1, 'SR', NULL, NULL, NULL),
(54792, '2017-11-27 14:20:25', NULL, NULL, 14839, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:20:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54793, '2017-11-27 14:22:59', NULL, NULL, 14839, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:22:59', 'admin-1511744410-15117637796236649', 1, 0, '', NULL, NULL, NULL),
(54794, '2017-11-27 14:22:59', NULL, NULL, 14839, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:22:59', 'admin-1511744410-15117637796236649', 1, 1, 'SR', NULL, NULL, NULL),
(54795, '2017-11-27 14:22:59', NULL, NULL, 14839, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:22:59', 'admin-1511744410-15117637796236649', 1, 0, '', NULL, NULL, NULL),
(54796, '2017-11-27 14:22:59', NULL, NULL, 14839, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:22:59', 'admin-1511744410-15117637796236649', 1, 1, 'SR', NULL, NULL, NULL),
(54797, '2017-11-27 14:22:59', NULL, NULL, 14839, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:22:59', 'admin-1511744410-15117637796236649', 1, 1, 'SR', NULL, NULL, NULL),
(54798, '2017-11-27 14:24:48', NULL, NULL, 14839, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:24:48', 'admin-1511744410-15117638882483874', 1, 1, 'SR', NULL, NULL, NULL),
(54799, '2017-11-27 14:23:13', NULL, NULL, 14838, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:23:13', 'admin-1511744410-15117637938106752', 1, 1, 'SR', NULL, NULL, NULL),
(54800, '2017-11-27 11:34:16', NULL, NULL, 14829, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 11:34:16', 'admin-1511744410-15117536564093274', 1, 0, '', NULL, NULL, NULL),
(54801, '2017-11-27 15:27:20', NULL, NULL, 14844, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 15:27:20', 'admin-1511744410-15117676400153522', 1, 0, '', NULL, NULL, NULL),
(54802, '2017-11-27 16:28:13', NULL, NULL, 14846, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 16:28:13', 'admin-1511744410-1511771293099396', 1, 1, 'SR', NULL, NULL, NULL),
(54803, '2017-11-27 15:50:58', NULL, NULL, 14846, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 15:50:58', 'admin-1511744410-15117690582684693', 1, 1, 'SR', NULL, NULL, NULL),
(54804, '2017-11-27 15:50:58', NULL, NULL, 14846, NULL, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 15:50:58', 'admin-1511744410-15117690582684693', 1, 1, 'SR', NULL, NULL, NULL),
(54805, '2017-11-27 15:27:20', NULL, NULL, 14844, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 15:27:20', 'admin-1511744410-15117676400153522', 1, 1, 'SR', NULL, NULL, NULL),
(54806, '2017-11-27 15:27:20', NULL, NULL, 14844, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 15:27:20', 'admin-1511744410-15117676400153522', 1, 0, '', NULL, NULL, NULL),
(54807, '2017-11-27 15:27:20', NULL, NULL, 14844, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 15:27:20', 'admin-1511744410-15117676400153522', 1, 1, 'SR', NULL, NULL, NULL),
(54808, '2017-11-27 15:18:59', NULL, NULL, 14842, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 15:18:59', 'admin-1511744410-15117671393401388', 1, 1, 'SR', NULL, NULL, '10.0'),
(54809, '2017-11-27 15:23:03', NULL, NULL, 14844, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1511744410', 'admin', '2017-11-27 15:23:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54810, '2017-11-27 15:18:25', NULL, NULL, 14843, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 15:18:25', 'admin-1511744410-15117671052978322', 1, 1, 'SR', NULL, NULL, NULL),
(54811, '2017-11-27 15:18:25', NULL, NULL, 14843, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 15:18:25', 'admin-1511744410-15117671052978322', 1, 0, '', NULL, NULL, NULL),
(54812, '2017-11-27 14:44:10', NULL, NULL, 14841, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:44:10', 'admin-1511744410-15117650507103466', 1, 1, 'SR', NULL, NULL, NULL),
(54813, '2017-11-27 13:25:06', NULL, NULL, 14837, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:25:06', 'admin-1511744410-15117603062268829', 1, 1, 'SR', NULL, NULL, '10.0'),
(54814, '2017-11-27 14:51:46', NULL, NULL, 14837, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:51:46', 'admin-1511744410-15117655058733744', 1, 1, 'SR', NULL, NULL, '10.0'),
(54815, '2017-11-27 15:18:15', NULL, NULL, 14843, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1511744410', 'admin', '2017-11-27 15:18:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54816, '2017-11-27 09:54:15', NULL, NULL, 14819, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:54:15', 'admin-1511744410-1511747655074841', 1, 0, '', NULL, NULL, NULL),
(54817, '2017-11-27 12:36:44', NULL, NULL, 14833, 0, 153, '87', 'Wake Me Up!', 'only sausage', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 12:36:44', 'admin-1511744410-15117574038876493', 1, 0, '', NULL, NULL, NULL),
(54818, '2017-11-27 13:20:33', NULL, NULL, 14836, 0, 211, '145', 'Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:20:33', 'admin-1511744410-15117600335849763', 1, 0, '', NULL, NULL, NULL),
(54819, '2017-11-27 13:20:33', NULL, NULL, 14836, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:20:33', 'admin-1511744410-15117600335849763', 1, 1, 'SR', NULL, NULL, NULL),
(54820, '2017-11-27 13:20:33', NULL, NULL, 14836, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:20:33', 'admin-1511744410-15117600335849763', 1, 1, 'SR', NULL, NULL, NULL),
(54821, '2017-11-27 12:36:44', NULL, NULL, 14833, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 12:36:44', 'admin-1511744410-15117574038876493', 1, 1, 'SR', NULL, NULL, NULL),
(54822, '2017-11-27 12:36:44', NULL, NULL, 14833, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 12:36:44', 'admin-1511744410-15117574038876493', 1, 1, 'SR', NULL, NULL, NULL),
(54823, '2017-11-27 14:44:10', NULL, NULL, 14841, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:44:10', 'admin-1511744410-15117650507103466', 1, 1, 'SR', NULL, NULL, NULL),
(54824, '2017-11-27 14:10:13', NULL, NULL, 14837, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:10:13', 'admin-1511744410-15117630137193924', 1, 0, '', NULL, NULL, '10.0'),
(54825, '2017-11-27 14:10:13', NULL, NULL, 14837, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:10:13', 'admin-1511744410-15117630137193924', 1, 1, 'SR', NULL, NULL, '10.0'),
(54826, '2017-11-27 14:10:13', NULL, NULL, 14837, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:10:13', 'admin-1511744410-15117630137193924', 1, 0, '', NULL, NULL, '10.0'),
(54827, '2017-11-27 14:10:13', NULL, NULL, 14837, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:10:13', 'admin-1511744410-15117630137193924', 1, 1, 'SR', NULL, NULL, '10.0'),
(54828, '2017-11-27 14:10:13', NULL, NULL, 14837, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 14:10:13', 'admin-1511744410-15117630137193924', 1, 1, 'SR', NULL, NULL, '10.0'),
(54829, '2017-11-27 13:54:19', NULL, NULL, 14838, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:54:19', 'admin-1511744410-15117620588891443', 1, 1, 'SR', NULL, NULL, NULL),
(54830, '2017-11-27 13:26:27', NULL, NULL, 14836, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:26:27', 'admin-1511744410-1511760387245998', 1, 1, 'SR', NULL, NULL, NULL),
(54831, '2017-11-27 13:25:06', NULL, NULL, 14837, 0, 77, '77', 'Sarawak Kolomee', 'spicy', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:25:06', 'admin-1511744410-15117603062268829', 1, 1, 'SR', NULL, NULL, '10.0'),
(54832, '2017-11-27 13:25:06', NULL, NULL, 14837, 0, 77, '77', 'Sarawak Kolomee', 'spicy', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:25:06', 'admin-1511744410-15117603062268829', 1, 1, 'SR', NULL, NULL, '10.0'),
(54833, '2017-11-27 13:25:06', NULL, NULL, 14837, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:25:06', 'admin-1511744410-15117603062268829', 1, 1, 'SR', NULL, NULL, '10.0'),
(54834, '2017-11-27 13:25:06', NULL, NULL, 14837, NULL, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:25:06', 'admin-1511744410-15117603062268829', 1, 1, 'SR', NULL, NULL, '10.0'),
(54835, '2017-11-27 13:25:06', NULL, NULL, 14837, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 13:25:06', 'admin-1511744410-15117603062268829', 1, 1, 'SR', NULL, NULL, '10.0'),
(54836, '2017-11-27 12:36:44', NULL, NULL, 14833, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 12:36:44', 'admin-1511744410-15117574038876493', 1, 1, 'SR', NULL, NULL, NULL),
(54837, '2017-11-27 12:56:13', NULL, NULL, 14835, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 12:56:13', 'admin-1511744410-15117585729868659', 1, 1, 'SR', 1, NULL, NULL),
(54838, '2017-11-27 12:36:44', NULL, NULL, 14833, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 12:36:44', 'admin-1511744410-15117574038876493', 1, 1, 'SR', NULL, NULL, NULL),
(54839, '2017-11-27 12:56:13', NULL, NULL, 14835, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 12:56:13', 'admin-1511744410-15117585729868659', 1, 1, 'SR', 1, NULL, NULL),
(54840, '2017-11-27 12:47:13', NULL, NULL, 14834, 0, 181, '116', 'Open Food ', 'chili flakes', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 12:47:13', 'admin-1511744410-15117580329306679', 1, 0, '', NULL, NULL, NULL),
(54841, '2017-11-27 10:05:55', NULL, NULL, 14821, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 10:05:55', 'admin-1511744410-15117483552901576', 1, 0, '', NULL, NULL, NULL),
(54842, '2017-11-27 12:46:16', NULL, NULL, 14834, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 12:46:16', 'admin-1511744410-15117579759803642', 1, 1, 'SR', NULL, NULL, NULL),
(54843, '2017-11-27 12:44:58', NULL, NULL, 14834, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 12:44:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54844, '2017-11-27 10:05:55', NULL, NULL, 14821, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 10:05:55', 'admin-1511744410-15117483552901576', 1, 0, '', NULL, NULL, NULL),
(54845, '2017-11-27 11:34:16', NULL, NULL, 14829, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 11:34:16', 'admin-1511744410-15117536564093274', 1, 0, '', NULL, NULL, NULL),
(54846, '2017-11-27 09:08:03', NULL, NULL, 14816, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:08:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54847, '2017-11-27 09:08:23', NULL, NULL, 14816, 0, 181, '116', 'Open Food ', 'junior BLT', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:08:23', 'admin-1511744410-15117449038472870', 1, 0, '', NULL, NULL, NULL),
(54848, '2017-11-27 10:05:44', NULL, NULL, 14821, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1511744410', 'admin', '2017-11-27 10:05:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54849, '2017-11-27 12:36:44', NULL, NULL, 14833, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 12:36:44', 'admin-1511744410-15117574038876493', 1, 0, '', NULL, NULL, NULL),
(54850, '2017-11-27 11:57:15', NULL, NULL, 14830, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 11:57:15', 'admin-1511744410-15117550353573893', 1, 0, '', NULL, NULL, NULL),
(54851, '2017-11-27 11:52:26', NULL, NULL, 14830, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 11:52:26', 'admin-1511744410-1511754746756882', 1, 1, 'SR', NULL, NULL, NULL),
(54852, '2017-11-27 11:34:16', NULL, NULL, 14829, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 11:34:16', 'admin-1511744410-15117536564093274', 1, 0, '', NULL, NULL, NULL),
(54853, '2017-11-27 11:52:23', NULL, NULL, 14830, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 11:52:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54854, '2017-11-27 09:24:41', NULL, NULL, 14817, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:24:41', 'admin-1511744410-15117458809625884', 1, 1, 'SR', NULL, NULL, NULL),
(54855, '2017-11-27 09:24:41', NULL, NULL, 14817, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:24:41', 'admin-1511744410-15117458809625884', 1, 1, 'SR', NULL, NULL, NULL),
(54856, '2017-11-27 09:24:41', NULL, NULL, 14817, 0, 75, '75', 'Meatless Aglio Olio ', 'extra spicy', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:24:41', 'admin-1511744410-15117458809625884', 1, 0, '', NULL, NULL, NULL),
(54857, '2017-11-27 11:09:33', NULL, NULL, 14825, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1511744410', 'admin', '2017-11-27 11:09:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54858, '2017-11-27 11:10:19', NULL, NULL, 14825, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 11:10:19', 'admin-1511744410-15117522189695439', 1, 0, '', NULL, NULL, NULL),
(54859, '2017-11-27 10:38:11', NULL, NULL, 14824, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 10:38:11', 'admin-1511744410-15117502914871779', 1, 1, 'SR', NULL, NULL, NULL),
(54860, '2017-11-27 10:38:11', NULL, NULL, 14824, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 10:38:11', 'admin-1511744410-15117502914871779', 1, 1, 'SR', NULL, NULL, NULL),
(54861, '2017-11-27 10:38:11', NULL, NULL, 14824, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 2, 16.00, 32.0000, 0.0000, 32.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 10:38:11', 'admin-1511744410-15117502914871779', 1, 0, '', NULL, NULL, NULL),
(54862, '2017-11-27 10:38:03', NULL, NULL, 14824, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1511744410', 'admin', '2017-11-27 10:38:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54863, '2017-11-27 00:00:00', NULL, NULL, 14827, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 10:27:26', 'admin-1511744410-15117496466443624', 1, 0, '', NULL, NULL, NULL),
(54864, '2017-11-27 00:00:00', NULL, NULL, 14828, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 10:27:26', 'admin-1511744410-15117496466443624', 1, 0, '', NULL, NULL, NULL),
(54865, '2017-11-27 10:05:55', NULL, NULL, 14821, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 10:05:55', 'admin-1511744410-15117483552901576', 1, 0, '', NULL, NULL, NULL),
(54866, '2017-11-27 09:58:34', NULL, NULL, 14820, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:58:34', 'admin-1511744410-15117479146071321', 1, 1, 'SR', NULL, NULL, NULL),
(54867, '2017-11-27 09:58:34', NULL, NULL, 14820, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:58:34', 'admin-1511744410-15117479146071321', 1, 1, 'SR', NULL, NULL, NULL),
(54868, '2017-11-27 09:58:34', NULL, NULL, 14820, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:58:34', 'admin-1511744410-15117479146071321', 1, 1, 'SR', NULL, NULL, NULL),
(54869, '2017-11-27 10:05:55', NULL, NULL, 14821, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 10:05:55', 'admin-1511744410-15117483552901576', 1, 0, '', NULL, NULL, NULL),
(54870, '2017-11-27 09:58:34', NULL, NULL, 14820, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:58:34', 'admin-1511744410-15117479146071321', 1, 0, '', NULL, NULL, NULL),
(54871, '2017-11-27 09:58:34', NULL, NULL, 14820, 0, 181, '116', 'Open Food ', 'bacon,eggs,tomato', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:58:34', 'admin-1511744410-15117479146071321', 1, 0, '', NULL, NULL, NULL),
(54872, '2017-11-27 09:58:34', NULL, NULL, 14820, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:58:34', 'admin-1511744410-15117479146071321', 1, 0, '', NULL, NULL, NULL),
(54873, '2017-11-27 09:56:40', NULL, NULL, 14820, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:56:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54874, '2017-11-27 09:54:15', NULL, NULL, 14819, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:54:15', 'admin-1511744410-1511747655074841', 1, 1, 'SR', NULL, NULL, NULL),
(54875, '2017-11-27 09:54:15', NULL, NULL, 14819, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:54:15', 'admin-1511744410-1511747655074841', 1, 0, '', NULL, NULL, NULL),
(54876, '2017-11-27 09:53:58', NULL, NULL, 14819, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:53:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54877, '2017-11-27 09:54:15', NULL, NULL, 14819, 0, 153, '87', 'Wake Me Up!', 'No sausage', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:54:15', 'admin-1511744410-1511747655074841', 1, 0, '', NULL, NULL, NULL),
(54878, '2017-11-27 09:24:41', NULL, NULL, 14817, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:24:41', 'admin-1511744410-15117458809625884', 1, 1, 'SR', NULL, NULL, NULL),
(54879, '2017-11-27 09:23:57', NULL, NULL, 14817, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1511744410', 'admin', '2017-11-27 09:23:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54880, '2017-11-29 13:47:38', NULL, NULL, 14864, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 13:47:38', 'admin-1511917899-1511934458515575', 1, 1, 'SR', NULL, NULL, NULL),
(54881, '2017-11-29 13:47:38', NULL, NULL, 14864, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 13:47:38', 'admin-1511917899-1511934458515575', 1, 1, 'SR', NULL, NULL, NULL),
(54882, '2017-11-29 12:56:14', NULL, NULL, 14863, 0, 71, '71', 'Chinese  Rice Wine Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 12:56:14', 'admin-1511917899-15119313748069060', 1, 1, 'SR', NULL, NULL, NULL),
(54883, '2017-11-29 12:56:14', NULL, NULL, 14863, 0, 73, '73', 'Marmite Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 12:56:14', 'admin-1511917899-15119313748069060', 1, 1, 'SR', NULL, NULL, NULL),
(54884, '2017-11-29 13:05:17', NULL, NULL, 14863, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 13:05:17', 'admin-1511917899-15119319170114875', 1, 0, '', NULL, NULL, NULL),
(54885, '2017-11-29 13:05:52', NULL, NULL, 14861, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 13:05:52', 'admin-1511917899-15119319519454147', 1, 1, 'SR', NULL, NULL, '10.0'),
(54886, '2017-11-29 13:26:12', NULL, NULL, 14863, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 13:26:12', 'admin-1511917899-15119331718607910', 1, 1, 'SR', NULL, NULL, NULL),
(54887, '2017-11-29 12:28:49', NULL, NULL, 14862, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 12:28:49', 'admin-1511917899-1511929729335894', 1, 0, '', NULL, NULL, NULL),
(54888, '2017-11-29 12:28:49', NULL, NULL, 14862, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 12:28:49', 'admin-1511917899-1511929729335894', 1, 0, '', NULL, NULL, NULL),
(54889, '2017-11-29 12:28:22', NULL, NULL, 14862, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1511917899', 'admin', '2017-11-29 12:28:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54890, '2017-11-29 12:28:49', NULL, NULL, 14862, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 12:28:49', 'admin-1511917899-1511929729335894', 1, 0, '', NULL, NULL, NULL),
(54891, '2017-11-29 10:57:08', NULL, NULL, 14854, NULL, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:57:08', 'admin-1511917899-15119242282181691', 1, 1, 'SR', NULL, NULL, NULL),
(54892, '2017-11-29 10:57:08', NULL, NULL, 14854, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:57:08', 'admin-1511917899-15119242282181691', 1, 0, '', NULL, NULL, NULL),
(54893, '2017-11-29 10:57:08', NULL, NULL, 14854, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:57:08', 'admin-1511917899-15119242282181691', 1, 0, '', NULL, NULL, NULL),
(54894, '2017-11-29 10:59:53', NULL, NULL, 14855, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:59:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54895, '2017-11-29 11:09:08', NULL, NULL, 14857, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:09:08', 'admin-1511917899-15119249482319318', 1, 1, 'SR', NULL, NULL, NULL),
(54896, '2017-11-29 14:26:36', NULL, NULL, 14865, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 14:26:36', 'admin-1511917899-15119367960358715', 1, 1, 'SR', NULL, NULL, NULL),
(54897, '2017-11-29 10:57:08', NULL, NULL, 14854, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:57:08', 'admin-1511917899-15119242282181691', 1, 0, '', NULL, NULL, NULL),
(54898, '2017-11-29 10:57:08', NULL, NULL, 14854, 0, 156, '90', 'House Cheddar Omelet', 'no sala,no salad and toast . with fruits', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:57:08', 'admin-1511917899-15119242282181691', 1, 0, '', NULL, NULL, NULL),
(54899, '2017-11-29 10:57:08', NULL, NULL, 14854, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:57:08', 'admin-1511917899-15119242282181691', 1, 0, '', NULL, NULL, NULL),
(54900, '2017-11-29 10:57:08', NULL, NULL, 14854, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:57:08', 'admin-1511917899-15119242282181691', 1, 1, 'SR', NULL, NULL, NULL),
(54901, '2017-11-29 10:57:08', NULL, NULL, 14854, 0, 300, '236', 'Special Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:57:08', 'admin-1511917899-15119242282181691', 1, 0, '', NULL, NULL, NULL),
(54902, '2017-11-29 15:49:32', NULL, NULL, 14866, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 15:49:32', 'admin-1511917899-1511941772423274', 1, 1, 'SR', NULL, NULL, NULL),
(54903, '2017-11-29 09:34:17', NULL, NULL, 14850, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 09:34:17', 'admin-1511917899-15119192569848662', 1, 1, 'SR', NULL, NULL, '10.0'),
(54904, '2017-11-29 10:55:06', NULL, NULL, 14854, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.40, 0.0000, 0.0000, 11.40, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:55:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54905, '2017-11-29 11:00:59', NULL, NULL, 14855, 0, 207, '142', 'Cheesy Bacon Toast', 'no chips', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:00:59', 'admin-1511917899-15119244595773840', 1, 0, '', NULL, NULL, NULL),
(54906, '2017-11-29 15:49:32', NULL, NULL, 14866, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 15:49:32', 'admin-1511917899-1511941772423274', 1, 0, '', NULL, NULL, NULL),
(54907, '2017-11-29 17:07:10', NULL, NULL, 14867, 0, 181, '116', 'Open Food ', 'Vanilla ice cream', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 17:07:10', 'admin-1511917899-15119464298622526', 1, 0, '', 1, NULL, NULL),
(54908, '2017-11-29 11:34:22', NULL, NULL, 14854, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:34:22', 'admin-1511917899-15119264621546898', 1, 1, 'SR', NULL, NULL, NULL),
(54909, '2017-11-29 11:48:51', NULL, NULL, 14860, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:48:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54910, '2017-11-29 14:26:57', NULL, NULL, 14865, 0, 302, '238', 'Ice on the cake', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 14:26:57', 'admin-1511917899-15119368177366924', 1, 0, '', NULL, NULL, NULL),
(54911, '2017-11-29 14:26:33', NULL, NULL, 14865, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1511917899', 'admin', '2017-11-29 14:26:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54912, '2017-11-29 15:49:26', NULL, NULL, 14866, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1511917899', 'admin', '2017-11-29 15:49:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54913, '2017-11-29 10:17:42', NULL, NULL, 14852, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:17:42', 'admin-1511917899-15119218627177358', 1, 1, 'SR', NULL, NULL, NULL),
(54914, '2017-11-29 11:43:19', NULL, NULL, 14859, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:43:19', 'admin-1511917899-15119269988692586', 1, 1, 'SR', 1, NULL, NULL),
(54915, '2017-11-29 11:48:59', NULL, NULL, 14860, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:48:59', 'admin-1511917899-1511927339191418', 1, 1, 'SR', NULL, NULL, NULL),
(54916, '2017-11-29 11:48:59', NULL, NULL, 14860, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:48:59', 'admin-1511917899-1511927339191418', 1, 1, 'SR', NULL, NULL, NULL),
(54917, '2017-11-29 11:58:07', NULL, NULL, 14860, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:58:07', 'admin-1511917899-15119278875285586', 1, 0, '', NULL, NULL, NULL),
(54918, '2017-11-29 11:38:10', NULL, NULL, 14858, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:38:10', 'admin-1511917899-15119266904892793', 1, 1, 'SR', NULL, NULL, NULL),
(54919, '2017-11-29 11:01:20', NULL, NULL, 14856, NULL, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:01:20', 'admin-1511917899-15119244800532083', 1, 1, 'SR', NULL, NULL, NULL),
(54920, '2017-11-29 11:09:04', NULL, NULL, 14857, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.70, 0.0000, 0.0000, 0.70, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:09:04', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(54921, '2017-11-29 13:26:12', NULL, NULL, 14863, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 13:26:12', 'admin-1511917899-15119331718607910', 1, 1, 'SR', NULL, NULL, NULL),
(54922, '2017-11-29 13:47:17', NULL, NULL, 14864, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1511917899', 'admin', '2017-11-29 13:47:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54923, '2017-11-29 12:52:59', NULL, NULL, 14863, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 12:52:59', 'admin-1511917899-15119311795031328', 1, 0, '', NULL, NULL, NULL),
(54924, '2017-11-29 12:52:39', NULL, NULL, 14863, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1511917899', 'admin', '2017-11-29 12:52:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54925, '2017-11-29 12:28:49', NULL, NULL, 14862, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 12:28:49', 'admin-1511917899-1511929729335894', 1, 1, 'SR', NULL, NULL, NULL),
(54926, '2017-11-29 12:02:44', NULL, NULL, 14858, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 12:02:44', 'admin-1511917899-15119281645584226', 1, 0, '', NULL, NULL, NULL),
(54927, '2017-11-29 12:28:49', NULL, NULL, 14862, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 12:28:49', 'admin-1511917899-1511929729335894', 1, 1, 'SR', NULL, NULL, NULL),
(54928, '2017-11-29 12:14:43', NULL, NULL, 14861, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 12:14:43', 'admin-1511917899-15119288835309438', 1, 1, 'SR', NULL, NULL, '10.0'),
(54929, '2017-11-29 12:14:43', NULL, NULL, 14861, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 12:14:43', 'admin-1511917899-15119288835309438', 1, 0, '', NULL, NULL, '10.0'),
(54930, '2017-11-29 12:14:43', NULL, NULL, 14861, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 12:14:43', 'admin-1511917899-15119288835309438', 1, 0, '', NULL, NULL, '10.0'),
(54931, '2017-11-29 12:14:43', NULL, NULL, 14861, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 12:14:43', 'admin-1511917899-15119288835309438', 1, 0, '', NULL, NULL, '10.0'),
(54932, '2017-11-29 11:58:19', NULL, NULL, 14861, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:58:19', 'admin-1511917899-1511927899722635', 1, 0, '', NULL, NULL, '10.0'),
(54933, '2017-11-29 11:58:13', NULL, NULL, 14861, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:58:13', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(54934, '2017-11-29 11:34:22', NULL, NULL, 14854, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:34:22', 'admin-1511917899-15119264621546898', 1, 1, 'SR', NULL, NULL, NULL),
(54935, '2017-11-29 11:30:04', NULL, NULL, 14858, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:30:04', 'admin-1511917899-15119262046396699', 1, 1, 'SR', NULL, NULL, NULL),
(54936, '2017-11-29 10:17:42', NULL, NULL, 14852, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:17:42', 'admin-1511917899-15119218627177358', 1, 0, '', NULL, NULL, NULL),
(54937, '2017-11-29 11:29:59', NULL, NULL, 14858, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:29:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54938, '2017-11-29 11:30:04', NULL, NULL, 14858, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:30:04', 'admin-1511917899-15119262046396699', 1, 0, '', NULL, NULL, NULL),
(54939, '2017-11-29 10:17:25', NULL, NULL, 14852, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:17:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54940, '2017-11-29 11:01:20', NULL, NULL, 14856, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:01:20', 'admin-1511917899-15119244800532083', 1, 1, 'SR', NULL, NULL, NULL),
(54941, '2017-11-29 11:01:20', NULL, NULL, 14856, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:01:20', 'admin-1511917899-15119244800532083', 1, 0, '', NULL, NULL, NULL),
(54942, '2017-11-29 11:01:20', NULL, NULL, 14856, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:01:20', 'admin-1511917899-15119244800532083', 1, 0, '', NULL, NULL, NULL),
(54943, '2017-11-29 09:11:46', NULL, NULL, 14848, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 09:11:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54944, '2017-11-29 11:00:59', NULL, NULL, 14855, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:00:59', 'admin-1511917899-15119244595773840', 1, 1, 'SR', NULL, NULL, NULL),
(54945, '2017-11-29 11:01:04', NULL, NULL, 14856, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:01:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54946, '2017-11-29 10:57:08', NULL, NULL, 14854, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:57:08', 'admin-1511917899-15119242282181691', 1, 1, 'SR', NULL, NULL, NULL),
(54947, '2017-11-29 11:00:59', NULL, NULL, 14855, 0, 157, '91', 'French Toast with Fruits', 'no honey', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:00:59', 'admin-1511917899-15119244595773840', 1, 0, '', NULL, NULL, NULL),
(54948, '2017-11-29 11:00:59', NULL, NULL, 14855, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:00:59', 'admin-1511917899-15119244595773840', 1, 0, '', NULL, NULL, NULL),
(54949, '2017-11-29 11:00:59', NULL, NULL, 14855, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 11:00:59', 'admin-1511917899-15119244595773840', 1, 0, '', NULL, NULL, NULL),
(54950, '2017-11-29 09:34:17', NULL, NULL, 14850, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 09:34:17', 'admin-1511917899-15119192569848662', 1, 0, '', NULL, NULL, '10.0'),
(54951, '2017-11-29 09:34:17', NULL, NULL, 14850, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 09:34:17', 'admin-1511917899-15119192569848662', 1, 1, 'SR', NULL, NULL, '10.0'),
(54952, '2017-11-29 09:11:58', NULL, NULL, 14848, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 09:11:58', 'admin-1511917899-15119179186218599', 1, 0, '', NULL, NULL, NULL),
(54953, '2017-11-29 09:11:58', NULL, NULL, 14848, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 09:11:58', 'admin-1511917899-15119179186218599', 1, 0, '', NULL, NULL, NULL),
(54954, '2017-11-29 09:14:42', NULL, NULL, 14848, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 09:14:42', 'admin-1511917899-15119180821149996', 1, 1, 'SR', NULL, NULL, NULL),
(54955, '2017-11-29 09:14:42', NULL, NULL, 14848, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 09:14:42', 'admin-1511917899-15119180821149996', 1, 0, '', NULL, NULL, NULL),
(54956, '2017-11-29 09:26:13', NULL, NULL, 14849, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1511917899', 'admin', '2017-11-29 09:26:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54957, '2017-11-29 09:26:15', NULL, NULL, 14849, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 09:26:15', 'admin-1511917899-15119187757246258', 1, 0, '', NULL, NULL, NULL),
(54958, '2017-11-29 09:33:53', NULL, NULL, 14850, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.30, 0.0000, 0.0000, 11.30, 1, '27', 1, '1511917899', 'admin', '2017-11-29 09:33:53', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(54959, '2017-11-29 09:34:17', NULL, NULL, 14850, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 09:34:17', 'admin-1511917899-15119192569848662', 1, 0, '', NULL, NULL, '10.0'),
(54960, '2017-11-29 09:34:17', NULL, NULL, 14850, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 09:34:17', 'admin-1511917899-15119192569848662', 1, 0, '', NULL, NULL, '10.0'),
(54961, '2017-11-29 10:53:37', NULL, NULL, 14853, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:53:37', 'admin-1511917899-15119240174902536', 1, 1, 'SR', NULL, NULL, NULL),
(54962, '2017-11-29 10:53:37', NULL, NULL, 14853, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:53:37', 'admin-1511917899-15119240174902536', 1, 1, 'SR', NULL, NULL, NULL),
(54963, '2017-11-29 10:53:34', NULL, NULL, 14853, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:53:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54964, '2017-11-29 10:17:42', NULL, NULL, 14852, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:17:42', 'admin-1511917899-15119218627177358', 1, 1, 'SR', NULL, NULL, NULL),
(54965, '2017-11-29 10:17:42', NULL, NULL, 14852, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:17:42', 'admin-1511917899-15119218627177358', 1, 0, '', NULL, NULL, NULL),
(54966, '2017-11-29 10:09:03', NULL, NULL, 14848, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:09:03', 'admin-1511917899-15119213435359836', 1, 1, 'SR', NULL, NULL, NULL),
(54967, '2017-11-29 10:09:03', NULL, NULL, 14848, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:09:03', 'admin-1511917899-15119213435359836', 1, 0, '', NULL, NULL, NULL),
(54968, '2017-11-29 10:03:29', NULL, NULL, 14851, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:03:29', 'admin-1511917899-1511921008892962', 1, 1, 'SR', NULL, NULL, NULL),
(54969, '2017-11-29 10:03:29', NULL, NULL, 14851, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:03:29', 'admin-1511917899-1511921008892962', 1, 1, 'SR', NULL, NULL, NULL),
(54970, '2017-11-29 10:03:20', NULL, NULL, 14851, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:03:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54971, '2017-11-29 10:03:29', NULL, NULL, 14851, 0, 157, '91', 'French Toast with Fruits', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 10:03:29', 'admin-1511917899-1511921008892962', 1, 0, '', NULL, NULL, NULL),
(54972, '2017-11-29 09:34:17', NULL, NULL, 14850, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 09:34:17', 'admin-1511917899-15119192569848662', 1, 0, '', NULL, NULL, '10.0'),
(54973, '2017-11-29 09:34:17', NULL, NULL, 14850, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1511917899', 'admin', '2017-11-29 09:34:17', 'admin-1511917899-15119192569848662', 1, 0, '', NULL, NULL, '10.0'),
(54974, '2017-11-30 00:00:00', NULL, NULL, 14884, 0, 307, '243', 'AA Set - Flaming Hot & spicy Pork', '', 'Meals', 'Rice', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:12:48', 'admin-1512004065-15120151681093648', 1, 0, '', NULL, NULL, NULL),
(54975, '2017-11-30 12:55:03', NULL, NULL, 14876, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:55:03', 'admin-1512017420-15120177028734795', 1, 0, '', NULL, NULL, NULL),
(54976, '2017-11-30 12:55:03', NULL, NULL, 14876, 0, 307, '243', 'AA Set - Flaming Hot & spicy Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:55:03', 'admin-1512017420-15120177028734795', 1, 0, '', NULL, NULL, NULL),
(54977, '2017-11-30 15:30:39', NULL, NULL, 14889, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 2, 9.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 15:30:39', 'admin-1512017420-1512027039227575', 1, 1, 'SR', NULL, NULL, NULL),
(54978, '2017-11-30 14:16:58', NULL, NULL, 14885, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1512017420', 'admin', '2017-11-30 14:16:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54979, '2017-11-30 13:51:47', NULL, NULL, 14881, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1512017420', 'admin', '2017-11-30 13:51:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54980, '2017-11-30 15:30:24', NULL, NULL, 14889, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1512017420', 'admin', '2017-11-30 15:30:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54981, '2017-11-30 12:50:38', NULL, NULL, 14878, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:50:38', 'admin-1512017420-15120174380934479', 1, 0, '', NULL, NULL, NULL),
(54982, '2017-11-30 15:17:15', NULL, NULL, 14887, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 15:17:15', 'admin-1512017420-15120262348481650', 1, 1, 'SR', NULL, NULL, NULL),
(54983, '2017-11-30 15:01:23', NULL, NULL, 14888, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 15:01:23', 'admin-1512017420-15120252835685716', 1, 1, 'SR', NULL, NULL, NULL),
(54984, '2017-11-30 15:01:23', NULL, NULL, 14888, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 15:01:23', 'admin-1512017420-15120252835685716', 1, 1, 'SR', NULL, NULL, NULL),
(54985, '2017-11-30 15:01:17', NULL, NULL, 14888, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1512017420', 'admin', '2017-11-30 15:01:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54986, '2017-11-30 12:50:38', NULL, NULL, 14878, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:50:38', 'admin-1512017420-15120174380934479', 1, 0, '', NULL, NULL, NULL),
(54987, '2017-11-30 13:45:45', NULL, NULL, 14876, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 13:45:45', 'admin-1512017420-15120207450545837', 1, 1, 'SR', NULL, NULL, NULL),
(54988, '2017-11-30 12:43:54', NULL, NULL, 14875, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:43:54', 'admin-1512004065-15120170343979749', 1, 0, '', NULL, NULL, '10.0'),
(54989, '2017-11-30 12:35:11', NULL, NULL, 14876, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:35:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54990, '2017-11-30 12:35:22', NULL, NULL, 14876, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:35:22', 'admin-1512004065-15120165222525081', 1, 0, '', NULL, NULL, NULL),
(54991, '2017-11-30 12:35:22', NULL, NULL, 14876, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:35:22', 'admin-1512004065-15120165222525081', 1, 1, 'SR', NULL, NULL, NULL),
(54992, '2017-11-30 12:42:46', NULL, NULL, 14877, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:42:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54993, '2017-11-30 12:43:16', NULL, NULL, 14877, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:43:16', 'admin-1512004065-15120169960427059', 1, 0, '', NULL, NULL, NULL),
(54994, '2017-11-30 09:09:47', NULL, NULL, 14868, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1512017420', 'admin', '2017-11-30 09:09:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54995, '2017-11-30 14:40:35', NULL, NULL, 14887, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1512017420', 'admin', '2017-11-30 14:40:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(54996, '2017-11-30 15:50:22', NULL, NULL, 14890, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 15:50:22', 'admin-1512017420-15120282218737640', 1, 1, 'SR', 1, NULL, '10.0'),
(54997, '2017-11-30 16:02:50', NULL, NULL, 14891, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 16:02:50', 'admin-1512017420-15120289702373270', 1, 0, '', 1, NULL, NULL),
(54998, '2017-11-30 16:02:50', NULL, NULL, 14891, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 16:02:50', 'admin-1512017420-15120289702373270', 1, 0, '', 1, NULL, NULL),
(54999, '2017-11-30 14:23:46', NULL, NULL, 14886, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 14:23:46', 'admin-1512017420-1512023026372514', 1, 1, 'SR', 1, NULL, '10.0'),
(55000, '2017-11-30 13:48:04', NULL, NULL, 14876, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 13:48:04', 'admin-1512017420-1512020883913173', 1, 1, 'SR', NULL, NULL, NULL),
(55001, '2017-11-30 00:00:00', NULL, NULL, 14880, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:52:58', 'admin-1512017420-1512017578545528', 1, 0, '', NULL, NULL, NULL),
(55002, '2017-11-30 00:00:00', NULL, NULL, 14881, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:52:58', 'admin-1512017420-1512017578545528', 1, 1, 'SR', NULL, NULL, NULL),
(55003, '2017-11-30 14:17:37', NULL, NULL, 14885, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 14:17:37', 'admin-1512017420-15120226574014490', 1, 0, '', NULL, NULL, NULL),
(55004, '2017-11-30 14:17:37', NULL, NULL, 14885, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 14:17:37', 'admin-1512017420-15120226574014490', 1, 0, '', NULL, NULL, NULL),
(55005, '2017-11-30 00:00:00', NULL, NULL, 14884, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:52:58', 'admin-1512017420-1512017578545528', 1, 1, 'SR', NULL, NULL, NULL),
(55006, '2017-11-30 00:00:00', NULL, NULL, 14883, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:52:58', 'admin-1512017420-1512017578545528', 1, 0, '', NULL, NULL, NULL),
(55007, '2017-11-30 00:00:00', NULL, NULL, 14882, 0, 308, '244', 'AA Set - Chinese Ginger Garlic chicken', '', 'Meals', 'Rice', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:12:48', 'admin-1512004065-15120151681093648', 1, 0, '', NULL, NULL, NULL),
(55008, '2017-11-30 12:43:16', NULL, NULL, 14877, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:43:16', 'admin-1512004065-15120169960427059', 1, 1, 'SR', NULL, NULL, NULL),
(55009, '2017-11-30 13:15:08', NULL, NULL, 14878, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 13:15:08', 'admin-1512017420-15120189081088774', 1, 0, '', NULL, NULL, NULL),
(55010, '2017-11-30 13:15:08', NULL, NULL, 14878, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 13:15:08', 'admin-1512017420-15120189081088774', 1, 0, '', NULL, NULL, NULL),
(55011, '2017-11-30 13:15:08', NULL, NULL, 14878, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 13:15:08', 'admin-1512017420-15120189081088774', 1, 0, '', NULL, NULL, NULL),
(55012, '2017-11-30 13:03:59', NULL, NULL, 14879, 0, 156, '90', 'House Cheddar Omelet', 'salad no dressing', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 13:03:59', 'admin-1512017420-1512018239533866', 1, 0, '', NULL, NULL, NULL),
(55013, '2017-11-30 12:43:16', NULL, NULL, 14877, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:43:16', 'admin-1512004065-15120169960427059', 1, 0, '', NULL, NULL, NULL),
(55014, '2017-11-30 12:43:16', NULL, NULL, 14877, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:43:16', 'admin-1512004065-15120169960427059', 1, 0, '', NULL, NULL, NULL),
(55015, '2017-11-30 15:30:39', NULL, NULL, 14889, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 15:30:39', 'admin-1512017420-1512027039227575', 1, 0, '', NULL, NULL, NULL),
(55016, '2017-11-30 12:55:49', NULL, NULL, 14878, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:55:49', 'admin-1512017420-1512017748885398', 1, 1, 'SR', NULL, NULL, NULL),
(55017, '2017-11-30 00:00:00', NULL, NULL, 14883, 0, 308, '244', 'AA Set - Chinese Ginger Garlic chicken', '', 'Meals', 'Rice', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:12:48', 'admin-1512004065-15120151681093648', 1, 0, '', NULL, NULL, NULL),
(55018, '2017-11-30 00:00:00', NULL, NULL, 14880, 0, 306, '242', 'AA Set - Chinese Rice Wine Pork', '', 'Meals', 'Rice', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:12:48', 'admin-1512004065-15120151681093648', 1, 0, '', NULL, NULL, NULL),
(55019, '2017-11-30 13:52:18', NULL, NULL, 14882, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1512017420', 'admin', '2017-11-30 13:52:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55020, '2017-11-30 00:00:00', NULL, NULL, 14881, 0, 308, '244', 'AA Set - Chinese Ginger Garlic chicken', '', 'Meals', 'Rice', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:12:48', 'admin-1512004065-15120151681093648', 1, 0, '', NULL, NULL, NULL),
(55021, '2017-11-30 15:30:39', NULL, NULL, 14889, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 15:30:39', 'admin-1512017420-1512027039227575', 1, 0, '', NULL, NULL, NULL),
(55022, '2017-11-30 12:50:38', NULL, NULL, 14878, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:50:38', 'admin-1512017420-15120174380934479', 1, 0, '', NULL, NULL, NULL),
(55023, '2017-11-30 12:50:38', NULL, NULL, 14878, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:50:38', 'admin-1512017420-15120174380934479', 1, 0, '', NULL, NULL, NULL),
(55024, '2017-11-30 13:50:58', NULL, NULL, 14880, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1512017420', 'admin', '2017-11-30 13:50:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55025, '2017-11-30 13:53:21', NULL, NULL, 14884, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 13:53:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55026, '2017-11-30 12:28:23', NULL, NULL, 14875, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:28:23', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(55027, '2017-11-30 14:42:34', NULL, NULL, 14887, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 14:42:34', 'admin-1512017420-1512024153933261', 1, 0, '', NULL, NULL, NULL),
(55028, '2017-11-30 12:50:38', NULL, NULL, 14878, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:50:38', 'admin-1512017420-15120174380934479', 1, 0, '', NULL, NULL, NULL),
(55029, '2017-11-30 12:50:38', NULL, NULL, 14878, 0, 328, '264', 'Basic Blueberries Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:50:38', 'admin-1512017420-15120174380934479', 1, 0, '', NULL, NULL, NULL),
(55030, '2017-11-30 12:43:16', NULL, NULL, 14877, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:43:16', 'admin-1512004065-15120169960427059', 1, 1, 'SR', NULL, NULL, NULL),
(55031, '2017-11-30 09:38:55', NULL, NULL, 14869, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 09:38:55', 'admin-1512004065-15120059349597671', 1, 0, '', NULL, NULL, NULL),
(55032, '2017-11-30 09:38:55', NULL, NULL, 14869, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 09:38:55', 'admin-1512004065-15120059349597671', 1, 1, 'SR', NULL, NULL, NULL),
(55033, '2017-11-30 12:48:03', NULL, NULL, 14878, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.50, 0.0000, 0.0000, 13.50, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:48:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55034, '2017-11-30 09:40:30', NULL, NULL, 14869, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 09:40:30', 'admin-1512004065-15120060306691271', 1, 0, '', NULL, NULL, NULL),
(55035, '2017-11-30 12:28:48', NULL, NULL, 14875, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:28:48', 'admin-1512004065-15120161279104196', 1, 0, '', NULL, NULL, '10.0'),
(55036, '2017-11-30 13:52:50', NULL, NULL, 14883, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1512017420', 'admin', '2017-11-30 13:52:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55037, '2017-11-30 00:00:00', NULL, NULL, 14882, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:52:58', 'admin-1512017420-1512017578545528', 1, 0, '', NULL, NULL, NULL),
(55038, '2017-11-30 11:12:01', NULL, NULL, 14873, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 11:12:01', 'admin-1512004065-15120115210832069', 1, 0, '', NULL, NULL, NULL),
(55039, '2017-11-30 11:12:01', NULL, NULL, 14873, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 11:12:01', 'admin-1512004065-15120115210832069', 1, 1, 'SR', NULL, NULL, NULL),
(55040, '2017-11-30 11:12:01', NULL, NULL, 14873, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 11:12:01', 'admin-1512004065-15120115210832069', 1, 1, 'SR', NULL, NULL, NULL),
(55041, '2017-11-30 11:12:01', NULL, NULL, 14873, 0, 335, '271', 'Iced Honey Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 11:12:01', 'admin-1512004065-15120115210832069', 1, 0, '', NULL, NULL, NULL),
(55042, '2017-11-30 12:50:38', NULL, NULL, 14878, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:50:38', 'admin-1512017420-15120174380934479', 1, 0, '', NULL, NULL, NULL),
(55043, '2017-11-30 11:11:40', NULL, NULL, 14873, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.10, 0.0000, 0.0000, 13.10, 1, '27', 1, '1512017420', 'admin', '2017-11-30 11:11:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55044, '2017-11-30 11:12:01', NULL, NULL, 14873, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 4, 21.00, 84.0000, 0.0000, 84.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 11:12:01', 'admin-1512004065-15120115210832069', 1, 0, '', NULL, NULL, NULL),
(55045, '2017-11-30 10:50:14', NULL, NULL, 14872, 0, 298, '234', 'Salted Caramel Machiato', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 10:50:14', 'admin-1512004065-15120102141526047', 1, 0, '', NULL, NULL, NULL),
(55046, '2017-11-30 10:50:14', NULL, NULL, 14872, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 10:50:14', 'admin-1512004065-15120102141526047', 1, 0, '', NULL, NULL, NULL),
(55047, '2017-11-30 10:50:14', NULL, NULL, 14872, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 10:50:14', 'admin-1512004065-15120102141526047', 1, 0, '', NULL, NULL, NULL),
(55048, '2017-11-30 10:49:59', NULL, NULL, 14872, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1512017420', 'admin', '2017-11-30 10:49:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55049, '2017-11-30 10:45:14', NULL, NULL, 14870, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 10:45:14', 'admin-1512004065-15120099144569488', 1, 0, '', NULL, NULL, '10.0'),
(55050, '2017-11-30 10:25:09', NULL, NULL, 14871, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1512017420', 'admin', '2017-11-30 10:25:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55051, '2017-11-30 10:26:34', NULL, NULL, 14871, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 10:26:34', 'admin-1512004065-15120087945771022', 1, 1, 'SR', NULL, NULL, NULL),
(55052, '2017-11-30 10:15:40', NULL, NULL, 14870, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 10:15:40', 'admin-1512004065-15120081404799059', 1, 1, 'SR', NULL, NULL, '10.0'),
(55053, '2017-11-30 10:15:40', NULL, NULL, 14870, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 10:15:40', 'admin-1512004065-15120081404799059', 1, 1, 'SR', NULL, NULL, '10.0'),
(55054, '2017-11-30 12:43:16', NULL, NULL, 14877, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 12:43:16', 'admin-1512004065-15120169960427059', 1, 1, 'SR', NULL, NULL, NULL),
(55055, '2017-11-30 10:15:40', NULL, NULL, 14870, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 10:15:40', 'admin-1512004065-15120081404799059', 1, 1, 'SR', NULL, NULL, '10.0'),
(55056, '2017-11-30 10:15:40', NULL, NULL, 14870, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 10:15:40', 'admin-1512004065-15120081404799059', 1, 0, '', NULL, NULL, '10.0'),
(55057, '2017-11-30 10:13:39', NULL, NULL, 14870, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1512017420', 'admin', '2017-11-30 10:13:39', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(55058, '2017-11-30 09:38:31', NULL, NULL, 14869, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1512017420', 'admin', '2017-11-30 09:38:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55059, '2017-11-30 09:38:55', NULL, NULL, 14869, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 09:38:55', 'admin-1512004065-15120059349597671', 1, 1, 'SR', NULL, NULL, NULL),
(55060, '2017-11-30 09:38:55', NULL, NULL, 14869, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 09:38:55', 'admin-1512004065-15120059349597671', 1, 1, 'SR', NULL, NULL, NULL),
(55061, '2017-11-30 09:38:55', NULL, NULL, 14869, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 09:38:55', 'admin-1512004065-15120059349597671', 1, 0, '', NULL, NULL, NULL),
(55062, '2017-11-30 09:38:55', NULL, NULL, 14869, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 09:38:55', 'admin-1512004065-15120059349597671', 1, 0, '', NULL, NULL, NULL),
(55063, '2017-11-30 09:38:55', NULL, NULL, 14869, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 09:38:55', 'admin-1512004065-15120059349597671', 1, 0, '', NULL, NULL, NULL),
(55064, '2017-11-30 09:12:09', NULL, NULL, 14868, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 09:12:09', 'admin-1512004065-15120043289719527', 1, 0, '', NULL, NULL, NULL),
(55065, '2017-11-30 09:12:09', NULL, NULL, 14868, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 09:12:09', 'admin-1512004065-15120043289719527', 1, 0, '', NULL, NULL, NULL),
(55066, '2017-11-30 09:12:09', NULL, NULL, 14868, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 09:12:09', 'admin-1512004065-15120043289719527', 1, 1, 'SR', NULL, NULL, NULL),
(55067, '2017-11-30 14:42:34', NULL, NULL, 14887, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 14:42:34', 'admin-1512017420-1512024153933261', 1, 1, 'SR', NULL, NULL, NULL),
(55068, '2017-11-30 09:12:09', NULL, NULL, 14868, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 09:12:09', 'admin-1512004065-15120043289719527', 1, 0, '', NULL, NULL, NULL),
(55069, '2017-11-30 09:12:09', NULL, NULL, 14868, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512017420', 'admin', '2017-11-30 09:12:09', 'admin-1512004065-15120043289719527', 1, 0, '', NULL, NULL, NULL),
(55070, '2017-12-01 14:53:40', NULL, NULL, 14913, 0, 308, '244', 'AA Set - Chinese Ginger Garlic chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 14:53:40', 'admin-1512090445-15121112207542825', 1, 0, '', NULL, NULL, NULL),
(55071, '2017-12-01 14:53:36', NULL, NULL, 14913, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 14:53:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55072, '2017-12-01 12:23:09', NULL, NULL, 14907, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 12:23:09', 'admin-1512090445-15121021890618689', 1, 0, '', NULL, NULL, NULL),
(55073, '2017-12-01 11:25:32', NULL, NULL, 14903, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:25:32', 'admin-1512090445-1512098732787699', 1, 0, '', NULL, NULL, NULL),
(55074, '2017-12-01 11:07:56', NULL, NULL, 14901, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:07:56', 'admin-1512090445-15120976758944810', 1, 1, 'SR', NULL, NULL, NULL),
(55075, '2017-12-01 11:13:27', NULL, NULL, 14902, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:13:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55076, '2017-12-01 11:15:16', NULL, NULL, 14902, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:15:16', 'admin-1512090445-15120981160471374', 1, 0, '', NULL, NULL, NULL),
(55077, '2017-12-01 16:31:06', NULL, NULL, 14919, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 16:31:06', 'admin-1512090445-15121170659568272', 1, 0, '', NULL, NULL, NULL),
(55078, '2017-12-01 16:40:28', NULL, NULL, 14920, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1512090445', 'admin', '2017-12-01 16:40:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55079, '2017-12-01 16:41:44', NULL, NULL, 14920, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 16:41:44', 'admin-1512090445-15121177038544340', 1, 0, '', NULL, NULL, NULL),
(55080, '2017-12-01 16:41:44', NULL, NULL, 14920, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 16:41:44', 'admin-1512090445-15121177038544340', 1, 1, 'SR', NULL, NULL, NULL),
(55081, '2017-12-01 15:30:51', NULL, NULL, 14916, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1512090445', 'admin', '2017-12-01 15:30:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55082, '2017-12-01 14:19:52', NULL, NULL, 14912, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1512090445', 'admin', '2017-12-01 14:19:52', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(55083, '2017-12-01 14:20:03', NULL, NULL, 14912, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 14:20:03', 'admin-1512090445-15121092028913844', 1, 0, '', NULL, NULL, '10.0'),
(55084, '2017-12-01 14:20:03', NULL, NULL, 14912, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 14:20:03', 'admin-1512090445-15121092028913844', 1, 1, 'SR', NULL, NULL, '10.0'),
(55085, '2017-12-01 12:07:44', NULL, NULL, 14906, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1512090445', 'admin', '2017-12-01 12:07:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55086, '2017-12-01 17:00:24', NULL, NULL, 14921, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 17:00:24', 'admin-1512090445-15121188239808073', 1, 1, 'SR', NULL, NULL, NULL),
(55087, '2017-12-01 10:04:59', NULL, NULL, 14897, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 10:04:59', 'admin-1512090445-15120938989974642', 1, 0, '', NULL, NULL, NULL),
(55088, '2017-12-01 17:26:53', NULL, NULL, 14922, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 17:26:53', 'admin-1512090445-15121204137378068', 1, 1, 'SR', NULL, NULL, NULL),
(55089, '2017-12-01 17:26:53', NULL, NULL, 14922, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 17:26:53', 'admin-1512090445-15121204137378068', 1, 0, '', NULL, NULL, NULL),
(55090, '2017-12-01 17:26:53', NULL, NULL, 14922, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 17:26:53', 'admin-1512090445-15121204137378068', 1, 1, 'SR', NULL, NULL, NULL),
(55091, '2017-12-01 14:19:50', NULL, NULL, 14911, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 14:19:50', 'admin-1512090445-15121091903097239', 1, 0, '', NULL, NULL, '10.0'),
(55092, '2017-12-01 14:19:39', NULL, NULL, 14911, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.09, 0.0000, 0.0000, 2.09, 1, '27', 1, '1512090445', 'admin', '2017-12-01 14:19:39', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(55093, '2017-12-01 14:14:06', NULL, NULL, 14910, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 14:14:06', 'admin-1512090445-15121088467158961', 1, 1, 'SR', NULL, NULL, '10.0'),
(55094, '2017-12-01 11:34:34', NULL, NULL, 14904, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:34:34', 'admin-1512090445-15120992744638886', 1, 1, 'SR', NULL, NULL, NULL),
(55095, '2017-12-01 17:00:24', NULL, NULL, 14921, 0, 298, '234', 'Salted Caramel Machiato', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 17:00:24', 'admin-1512090445-15121188239808073', 1, 0, '', NULL, NULL, NULL),
(55096, '2017-12-01 14:06:13', NULL, NULL, 14910, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 14:06:13', 'admin-1512090445-15121083731135474', 1, 0, '', NULL, NULL, '10.0'),
(55097, '2017-12-01 14:06:13', NULL, NULL, 14910, 0, 307, '243', 'AA Set - Flaming Hot & spicy Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 14:06:13', 'admin-1512090445-15121083731135474', 1, 0, '', NULL, NULL, '10.0'),
(55098, '2017-12-01 11:34:34', NULL, NULL, 14904, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:34:34', 'admin-1512090445-15120992744638886', 1, 0, '', NULL, NULL, NULL),
(55099, '2017-12-01 14:06:13', NULL, NULL, 14910, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 14:06:13', 'admin-1512090445-15121083731135474', 1, 0, '', NULL, NULL, '10.0'),
(55100, '2017-12-01 14:05:54', NULL, NULL, 14910, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1512090445', 'admin', '2017-12-01 14:05:54', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(55101, '2017-12-01 14:03:16', NULL, NULL, 14909, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 14:03:16', 'admin-1512090445-15121081967844962', 1, 0, '', NULL, NULL, NULL),
(55102, '2017-12-01 14:02:52', NULL, NULL, 14909, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 14:02:52', 'admin-1512090445-15121081721728487', 1, 0, '', NULL, NULL, NULL),
(55103, '2017-12-01 16:48:37', NULL, NULL, 14911, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1512090445', 'admin', '2017-12-01 16:48:37', 'admin-1512090445-15121181170807325', 1, 0, '', NULL, NULL, '10.0'),
(55104, '2017-12-01 11:47:01', NULL, NULL, 14905, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:47:01', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(55105, '2017-12-01 16:05:34', NULL, NULL, 14918, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 16:05:34', 'admin-1512090445-15121155347656056', 1, 1, 'SR', NULL, NULL, NULL),
(55106, '2017-12-01 16:05:34', NULL, NULL, 14918, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 16:05:34', 'admin-1512090445-15121155347656056', 1, 1, 'SR', NULL, NULL, NULL),
(55107, '2017-12-01 16:05:34', NULL, NULL, 14918, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 16:05:34', 'admin-1512090445-15121155347656056', 1, 0, '', NULL, NULL, NULL),
(55108, '2017-12-01 16:31:02', NULL, NULL, 14919, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 16:31:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55109, '2017-12-01 17:25:46', NULL, NULL, 14922, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1512090445', 'admin', '2017-12-01 17:25:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55110, '2017-12-01 15:59:37', NULL, NULL, 14917, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 15:59:37', 'admin-1512090445-15121151771355719', 1, 1, 'SR', NULL, NULL, NULL),
(55111, '2017-12-01 15:59:32', NULL, NULL, 14917, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1512090445', 'admin', '2017-12-01 15:59:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55112, '2017-12-01 15:51:56', NULL, NULL, 14911, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 15:51:56', 'admin-1512090445-15121147168559251', 1, 1, 'SR', NULL, NULL, '10.0'),
(55113, '2017-12-01 15:31:07', NULL, NULL, 14916, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 15:31:07', 'admin-1512090445-1512113466892391', 1, 1, 'SR', NULL, NULL, NULL),
(55114, '2017-12-01 15:31:07', NULL, NULL, 14916, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 15:31:07', 'admin-1512090445-1512113466892391', 1, 0, '', NULL, NULL, NULL),
(55115, '2017-12-01 15:31:07', NULL, NULL, 14916, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 15:31:07', 'admin-1512090445-1512113466892391', 1, 0, '', NULL, NULL, NULL),
(55116, '2017-12-01 15:24:22', NULL, NULL, 14915, 0, 307, '243', 'AA Set - Flaming Hot & spicy Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 15:24:22', 'admin-1512090445-15121130625451340', 1, 0, '', NULL, NULL, NULL),
(55117, '2017-12-01 12:54:24', NULL, NULL, 14908, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 12:54:24', 'admin-1512090445-15121040638519929', 1, 0, '', NULL, NULL, NULL),
(55118, '2017-12-01 16:41:44', NULL, NULL, 14920, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 16:41:44', 'admin-1512090445-15121177038544340', 1, 1, 'SR', NULL, NULL, NULL),
(55119, '2017-12-01 15:24:08', NULL, NULL, 14915, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1512090445', 'admin', '2017-12-01 15:24:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55120, '2017-12-01 15:24:22', NULL, NULL, 14915, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 15:24:22', 'admin-1512090445-15121130625451340', 1, 0, '', NULL, NULL, NULL),
(55121, '2017-12-01 13:54:31', NULL, NULL, 14909, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 13:54:31', 'admin-1512090445-15121076715896648', 1, 0, '', NULL, NULL, NULL),
(55122, '2017-12-01 13:54:31', NULL, NULL, 14909, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 13:54:31', 'admin-1512090445-15121076715896648', 1, 0, '', NULL, NULL, NULL),
(55123, '2017-12-01 15:20:18', NULL, NULL, 14914, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1512090445', 'admin', '2017-12-01 15:20:18', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(55124, '2017-12-01 15:20:23', NULL, NULL, 14914, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 15:20:23', 'admin-1512090445-15121128231152872', 1, 0, '', NULL, NULL, '10.0'),
(55125, '2017-12-01 14:54:32', NULL, NULL, 14913, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 14:54:32', 'admin-1512090445-15121112719066727', 1, 1, 'SR', NULL, NULL, NULL),
(55126, '2017-12-01 13:54:21', NULL, NULL, 14909, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1512090445', 'admin', '2017-12-01 13:54:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55127, '2017-12-01 13:16:09', NULL, NULL, 14908, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 13:16:09', 'admin-1512090445-15121053689023837', 1, 1, 'SR', NULL, NULL, NULL),
(55128, '2017-12-01 09:46:52', NULL, NULL, 14893, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1512090445', 'admin', '2017-12-01 09:46:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55129, '2017-12-01 09:47:03', NULL, NULL, 14893, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 09:47:03', 'admin-1512090445-15120928237889428', 1, 0, '', NULL, NULL, NULL),
(55130, '2017-12-01 09:47:03', NULL, NULL, 14893, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 09:47:03', 'admin-1512090445-15120928237889428', 1, 0, '', NULL, NULL, NULL),
(55131, '2017-12-01 09:47:03', NULL, NULL, 14893, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 09:47:03', 'admin-1512090445-15120928237889428', 1, 1, 'SR', NULL, NULL, NULL),
(55132, '2017-12-01 09:47:03', NULL, NULL, 14893, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 09:47:03', 'admin-1512090445-15120928237889428', 1, 0, '', NULL, NULL, NULL),
(55133, '2017-12-01 12:54:23', NULL, NULL, 14908, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 12:54:23', 'admin-1512090445-15121040638519929', 1, 0, '', NULL, NULL, NULL),
(55134, '2017-12-01 11:47:19', NULL, NULL, 14905, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:47:19', 'admin-1512090445-15121000391171677', 1, 0, '', NULL, NULL, NULL),
(55135, '2017-12-01 12:43:01', NULL, NULL, 14908, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 12:43:01', 'admin-1512090445-15121033812624692', 1, 1, 'SR', NULL, NULL, NULL),
(55136, '2017-12-01 12:08:07', NULL, NULL, 14906, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 12:08:07', 'admin-1512090445-15121012878475354', 1, 0, '', NULL, NULL, NULL),
(55137, '2017-12-01 11:34:34', NULL, NULL, 14904, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:34:34', 'admin-1512090445-15120992744638886', 1, 0, '', NULL, NULL, NULL),
(55138, '2017-12-01 12:43:01', NULL, NULL, 14908, 0, 306, '242', 'AA Set - Chinese Rice Wine Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 12:43:01', 'admin-1512090445-15121033812624692', 1, 0, '', NULL, NULL, NULL),
(55139, '2017-12-01 12:43:01', NULL, NULL, 14908, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 12:43:01', 'admin-1512090445-15121033812624692', 1, 0, '', NULL, NULL, NULL),
(55140, '2017-12-01 12:43:01', NULL, NULL, 14908, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 12:43:01', 'admin-1512090445-15121033812624692', 1, 0, '', NULL, NULL, NULL),
(55141, '2017-12-01 12:43:01', NULL, NULL, 14908, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 12:43:01', 'admin-1512090445-15121033812624692', 1, 0, '', NULL, NULL, NULL),
(55142, '2017-12-01 12:23:09', NULL, NULL, 14907, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 12:23:09', 'admin-1512090445-15121021890618689', 1, 1, 'SR', NULL, NULL, NULL),
(55143, '2017-12-01 12:42:33', NULL, NULL, 14908, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1512090445', 'admin', '2017-12-01 12:42:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55144, '2017-12-01 12:23:09', NULL, NULL, 14907, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 12:23:09', 'admin-1512090445-15121021890618689', 1, 1, 'SR', NULL, NULL, NULL),
(55145, '2017-12-01 16:05:22', NULL, NULL, 14918, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1512090445', 'admin', '2017-12-01 16:05:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55146, '2017-12-01 11:59:52', NULL, NULL, 14899, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:59:52', 'admin-1512090445-15121007926493940', 1, 0, '', NULL, NULL, NULL),
(55147, '2017-12-01 12:22:46', NULL, NULL, 14907, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1512090445', 'admin', '2017-12-01 12:22:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55148, '2017-12-01 12:08:08', NULL, NULL, 14906, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 12:08:08', 'admin-1512090445-15121012878475354', 1, 1, 'SR', NULL, NULL, NULL),
(55149, '2017-12-01 12:08:08', NULL, NULL, 14906, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 12:08:08', 'admin-1512090445-15121012878475354', 1, 1, 'SR', NULL, NULL, NULL),
(55150, '2017-12-01 11:34:34', NULL, NULL, 14904, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:34:34', 'admin-1512090445-15120992744638886', 1, 1, 'SR', NULL, NULL, NULL),
(55151, '2017-12-01 17:00:24', NULL, NULL, 14921, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 17:00:24', 'admin-1512090445-15121188239808073', 1, 0, '', NULL, NULL, NULL),
(55152, '2017-12-01 12:08:07', NULL, NULL, 14906, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 12:08:07', 'admin-1512090445-15121012878475354', 1, 1, 'SR', NULL, NULL, NULL),
(55153, '2017-12-01 12:08:07', NULL, NULL, 14906, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 12:08:07', 'admin-1512090445-15121012878475354', 1, 0, '', NULL, NULL, NULL),
(55154, '2017-12-01 17:00:06', NULL, NULL, 14921, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 17:00:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55155, '2017-12-01 11:47:19', NULL, NULL, 14905, 0, 298, '234', 'Salted Caramel Machiato', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:47:19', 'admin-1512090445-15121000391171677', 1, 0, '', NULL, NULL, NULL),
(55156, '2017-12-01 11:34:34', NULL, NULL, 14904, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:34:34', 'admin-1512090445-15120992744638886', 1, 1, 'SR', NULL, NULL, NULL),
(55157, '2017-12-01 11:47:19', NULL, NULL, 14905, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:47:19', 'admin-1512090445-15121000391171677', 1, 1, 'SR', NULL, NULL, NULL),
(55158, '2017-12-01 11:47:19', NULL, NULL, 14905, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:47:19', 'admin-1512090445-15121000391171677', 1, 0, '', NULL, NULL, NULL),
(55159, '2017-12-01 11:15:16', NULL, NULL, 14902, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:15:16', 'admin-1512090445-15120981160471374', 1, 1, 'SR', NULL, NULL, NULL),
(55160, '2017-12-01 11:25:18', NULL, NULL, 14903, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:25:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55161, '2017-12-01 10:01:20', NULL, NULL, 14896, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 10:01:20', 'admin-1512090445-15120936798541267', 1, 1, 'SR', NULL, NULL, NULL),
(55162, '2017-12-01 10:04:54', NULL, NULL, 14897, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1512090445', 'admin', '2017-12-01 10:04:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55163, '2017-12-01 10:04:59', NULL, NULL, 14897, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 10:04:59', 'admin-1512090445-15120938989974642', 1, 0, '', NULL, NULL, NULL),
(55164, '2017-12-01 09:53:06', NULL, NULL, 14895, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 09:53:06', 'admin-1512090445-15120931863185724', 1, 0, '', NULL, NULL, NULL),
(55165, '2017-12-01 12:23:09', NULL, NULL, 14907, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 12:23:09', 'admin-1512090445-15121021890618689', 1, 1, 'SR', NULL, NULL, NULL),
(55166, '2017-12-01 14:20:03', NULL, NULL, 14912, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 14:20:03', 'admin-1512090445-15121092028913844', 1, 0, '', NULL, NULL, '10.0'),
(55167, '2017-12-01 11:34:06', NULL, NULL, 14904, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:34:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55168, '2017-12-01 11:25:32', NULL, NULL, 14903, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:25:32', 'admin-1512090445-1512098732787699', 1, 0, '', NULL, NULL, NULL),
(55169, '2017-12-01 11:25:32', NULL, NULL, 14903, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:25:32', 'admin-1512090445-1512098732787699', 1, 1, 'SR', NULL, NULL, NULL),
(55170, '2017-12-01 10:49:05', NULL, NULL, 14900, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 10:49:05', 'admin-1512090445-15120965452083390', 1, 1, 'SR', NULL, NULL, NULL),
(55171, '2017-12-01 11:07:39', NULL, NULL, 14901, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:07:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55172, '2017-12-01 11:07:56', NULL, NULL, 14901, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:07:56', 'admin-1512090445-15120976758944810', 1, 0, '', NULL, NULL, NULL),
(55173, '2017-12-01 11:07:56', NULL, NULL, 14901, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:07:56', 'admin-1512090445-15120976758944810', 1, 0, '', NULL, NULL, NULL),
(55174, '2017-12-01 11:25:32', NULL, NULL, 14903, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 11:25:32', 'admin-1512090445-1512098732787699', 1, 0, '', NULL, NULL, NULL),
(55175, '2017-12-01 09:53:06', NULL, NULL, 14895, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 09:53:06', 'admin-1512090445-15120931863185724', 1, 1, 'SR', NULL, NULL, NULL),
(55176, '2017-12-01 10:49:05', NULL, NULL, 14900, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 10:49:05', 'admin-1512090445-15120965452083390', 1, 1, 'SR', NULL, NULL, NULL),
(55177, '2017-12-01 10:48:58', NULL, NULL, 14900, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1512090445', 'admin', '2017-12-01 10:48:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55178, '2017-12-01 10:46:21', NULL, NULL, 14899, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 10:46:21', 'admin-1512090445-15120963815079919', 1, 1, 'SR', NULL, NULL, NULL),
(55179, '2017-12-01 10:46:21', NULL, NULL, 14899, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 10:46:21', 'admin-1512090445-15120963815079919', 1, 0, '', NULL, NULL, NULL),
(55180, '2017-12-01 10:24:53', NULL, NULL, 14898, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 10:24:53', 'admin-1512090445-15120950935078260', 1, 0, '', NULL, NULL, NULL),
(55181, '2017-12-01 10:45:52', NULL, NULL, 14899, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1512090445', 'admin', '2017-12-01 10:45:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55182, '2017-12-01 10:46:21', NULL, NULL, 14899, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 10:46:21', 'admin-1512090445-15120963815079919', 1, 0, '', NULL, NULL, NULL),
(55183, '2017-12-01 10:24:53', NULL, NULL, 14898, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 10:24:53', 'admin-1512090445-15120950935078260', 1, 1, 'SR', NULL, NULL, NULL),
(55184, '2017-12-01 10:24:47', NULL, NULL, 14898, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1512090445', 'admin', '2017-12-01 10:24:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55185, '2017-12-01 10:01:19', NULL, NULL, 14896, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 10:01:19', 'admin-1512090445-15120936798541267', 1, 0, '', NULL, NULL, NULL),
(55186, '2017-12-01 10:01:20', NULL, NULL, 14896, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 10:01:20', 'admin-1512090445-15120936798541267', 1, 1, 'SR', NULL, NULL, NULL),
(55187, '2017-12-01 10:01:20', NULL, NULL, 14896, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 10:01:20', 'admin-1512090445-15120936798541267', 1, 0, '', NULL, NULL, NULL),
(55188, '2017-12-01 10:01:13', NULL, NULL, 14896, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1512090445', 'admin', '2017-12-01 10:01:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55189, '2017-12-01 09:51:43', NULL, NULL, 14894, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 09:51:43', 'admin-1512090445-15120931036335233', 1, 0, '', NULL, NULL, NULL),
(55190, '2017-12-01 09:53:06', NULL, NULL, 14895, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 09:53:06', 'admin-1512090445-15120931863185724', 1, 1, 'SR', NULL, NULL, NULL),
(55191, '2017-12-01 09:51:43', NULL, NULL, 14894, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 09:51:43', 'admin-1512090445-15120931036335233', 1, 0, '', NULL, NULL, NULL),
(55192, '2017-12-01 09:52:51', NULL, NULL, 14895, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1512090445', 'admin', '2017-12-01 09:52:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55193, '2017-12-01 09:53:06', NULL, NULL, 14895, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 09:53:06', 'admin-1512090445-15120931863185724', 1, 0, '', NULL, NULL, NULL),
(55194, '2017-12-01 09:51:43', NULL, NULL, 14894, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 09:51:43', 'admin-1512090445-15120931036335233', 1, 1, 'SR', NULL, NULL, NULL),
(55195, '2017-12-01 09:51:43', NULL, NULL, 14894, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 09:51:43', 'admin-1512090445-15120931036335233', 1, 0, '', NULL, NULL, NULL),
(55196, '2017-12-01 09:15:42', NULL, NULL, 14892, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1512090445', 'admin', '2017-12-01 09:15:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55197, '2017-12-01 09:15:58', NULL, NULL, 14892, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 09:15:58', 'admin-1512090445-15120909587583363', 1, 0, '', NULL, NULL, NULL),
(55198, '2017-12-01 09:15:58', NULL, NULL, 14892, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 09:15:58', 'admin-1512090445-15120909587583363', 1, 0, '', NULL, NULL, NULL),
(55199, '2017-12-01 09:50:47', NULL, NULL, 14894, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1512090445', 'admin', '2017-12-01 09:50:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55200, '2017-12-01 09:15:58', NULL, NULL, 14892, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512090445', 'admin', '2017-12-01 09:15:58', 'admin-1512090445-15120909587583363', 1, 1, 'SR', NULL, NULL, NULL),
(55201, '2017-12-02 14:21:36', NULL, NULL, 14961, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:21:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55202, '2017-12-02 00:00:00', NULL, NULL, 14962, 0, 306, '242', 'AA Set - Chinese Rice Wine Pork', '', 'Meals', 'Rice', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:13:02', 'admin-1512176007-15121951825055999', 1, 0, '', NULL, NULL, NULL),
(55203, '2017-12-02 14:40:42', NULL, NULL, 14962, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:40:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55204, '2017-12-02 14:12:57', NULL, NULL, 14960, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:12:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55205, '2017-12-02 14:13:02', NULL, NULL, 14960, 0, 308, '244', 'AA Set - Chinese Ginger Garlic chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:13:02', 'admin-1512176007-15121951825055999', 1, 0, '', NULL, NULL, NULL),
(55206, '2017-12-02 11:14:20', NULL, NULL, 14937, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:14:20', 'admin-1512176007-1512184460197446', 1, 1, 'SR', NULL, NULL, NULL),
(55207, '2017-12-02 14:05:58', NULL, NULL, 14948, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:05:58', 'admin-1512176007-15121947588469465', 1, 1, 'SR', NULL, NULL, NULL),
(55208, '2017-12-02 14:55:16', NULL, NULL, 14966, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:55:16', 'admin-1512176007-15121977162348788', 1, 1, 'SR', NULL, NULL, NULL),
(55209, '2017-12-02 14:55:16', NULL, NULL, 14966, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:55:16', 'admin-1512176007-15121977162348788', 1, 1, 'SR', NULL, NULL, NULL),
(55210, '2017-12-02 16:01:19', NULL, NULL, 14969, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 16:01:19', 'admin-1512176007-15122016797788144', 1, 1, 'SR', NULL, NULL, NULL),
(55211, '2017-12-02 16:37:44', NULL, NULL, 14970, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 16:37:44', 'admin-1512176007-15122038641325168', 1, 0, '', 1, NULL, NULL),
(55212, '2017-12-02 00:00:00', NULL, NULL, 14956, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:22:10', 'admin-1512176007-15121885300375434', 1, 0, '', NULL, NULL, NULL),
(55213, '2017-12-02 00:00:00', NULL, NULL, 14953, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:22:10', 'admin-1512176007-15121885300375434', 1, 0, '', NULL, NULL, NULL),
(55214, '2017-12-02 11:56:20', NULL, NULL, 14942, 0, 331, '267', 'Yuzu Marmalade Pancake', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:56:20', 'admin-1512176007-15121869807822879', 1, 0, '', NULL, NULL, '10.0'),
(55215, '2017-12-02 00:00:00', NULL, NULL, 14934, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:13:09', 'admin-1512176007-15121807893761380', 1, 0, '', NULL, NULL, NULL),
(55216, '2017-12-02 00:00:00', NULL, NULL, 14935, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:13:09', 'admin-1512176007-15121807893761380', 1, 1, 'SR', NULL, NULL, NULL),
(55217, '2017-12-02 11:13:14', NULL, NULL, 14936, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:13:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55218, '2017-12-02 14:05:30', NULL, NULL, 14959, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:05:30', 'admin-1512176007-15121947307136683', 1, 1, 'SR', NULL, NULL, NULL),
(55219, '2017-12-02 00:00:00', NULL, NULL, 14954, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:22:10', 'admin-1512176007-15121885300375434', 1, 1, 'SR', NULL, NULL, NULL),
(55220, '2017-12-02 11:56:20', NULL, NULL, 14942, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:56:20', 'admin-1512176007-15121869807822879', 1, 1, 'SR', NULL, NULL, '10.0'),
(55221, '2017-12-02 11:56:20', NULL, NULL, 14942, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:56:20', 'admin-1512176007-15121869807822879', 1, 0, '', NULL, NULL, '10.0'),
(55222, '2017-12-02 11:56:28', NULL, NULL, 14943, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:56:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55223, '2017-12-02 14:05:30', NULL, NULL, 14959, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:05:30', 'admin-1512176007-15121947307136683', 1, 0, '', NULL, NULL, NULL),
(55224, '2017-12-02 14:05:30', NULL, NULL, 14959, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:05:30', 'admin-1512176007-15121947307136683', 1, 0, '', NULL, NULL, NULL),
(55225, '2017-12-02 11:52:25', NULL, NULL, 14941, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:52:25', 'admin-1512176007-15121867454702428', 1, 0, '', NULL, NULL, NULL),
(55226, '2017-12-02 11:52:25', NULL, NULL, 14941, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:52:25', 'admin-1512176007-15121867454702428', 1, 1, 'SR', NULL, NULL, NULL),
(55227, '2017-12-02 15:02:54', NULL, NULL, 14967, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 15:02:54', 'admin-1512176007-15121981741532485', 1, 1, 'SR', NULL, NULL, NULL),
(55228, '2017-12-02 15:02:54', NULL, NULL, 14967, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 15:02:54', 'admin-1512176007-15121981741532485', 1, 1, 'SR', NULL, NULL, NULL),
(55229, '2017-12-02 15:08:25', NULL, NULL, 14968, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1512176007', 'admin', '2017-12-02 15:08:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55230, '2017-12-02 15:09:00', NULL, NULL, 14968, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 15:09:00', 'admin-1512176007-15121985405917688', 1, 1, 'SR', NULL, NULL, NULL),
(55231, '2017-12-02 13:09:18', NULL, NULL, 14952, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 13:09:18', 'admin-1512176007-15121913584761845', 1, 0, '', NULL, NULL, NULL),
(55232, '2017-12-02 13:09:18', NULL, NULL, 14952, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 13:09:18', 'admin-1512176007-15121913584761845', 1, 0, '', NULL, NULL, NULL),
(55233, '2017-12-02 13:09:18', NULL, NULL, 14952, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 13:09:18', 'admin-1512176007-15121913584761845', 1, 1, 'SR', NULL, NULL, NULL),
(55234, '2017-12-02 14:05:30', NULL, NULL, 14959, 0, 307, '243', 'AA Set - Flaming Hot & spicy Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:05:30', 'admin-1512176007-15121947307136683', 1, 0, '', NULL, NULL, NULL),
(55235, '2017-12-02 14:03:00', NULL, NULL, 14959, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:03:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55236, '2017-12-02 13:54:17', NULL, NULL, 14958, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 13:54:17', 'admin-1512176007-15121940571401441', 1, 0, '', NULL, NULL, NULL),
(55237, '2017-12-02 13:54:17', NULL, NULL, 14958, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 13:54:17', 'admin-1512176007-15121940571401441', 1, 0, '', NULL, NULL, NULL),
(55238, '2017-12-02 13:22:23', NULL, NULL, 14948, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 13:22:23', 'admin-1512176007-15121921433662331', 1, 0, '', NULL, NULL, NULL),
(55239, '2017-12-02 13:54:17', NULL, NULL, 14958, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 13:54:17', 'admin-1512176007-15121940571401441', 1, 0, '', NULL, NULL, NULL),
(55240, '2017-12-02 13:54:00', NULL, NULL, 14958, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1512176007', 'admin', '2017-12-02 13:54:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55241, '2017-12-02 15:02:54', NULL, NULL, 14967, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 15:02:54', 'admin-1512176007-15121981741532485', 1, 0, '', NULL, NULL, NULL),
(55242, '2017-12-02 13:48:16', NULL, NULL, 14957, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 13:48:16', 'admin-1512176007-15121936965116617', 1, 1, 'SR', NULL, NULL, NULL),
(55243, '2017-12-02 13:48:16', NULL, NULL, 14957, 0, 306, '242', 'AA Set - Chinese Rice Wine Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 13:48:16', 'admin-1512176007-15121936965116617', 1, 0, '', NULL, NULL, NULL),
(55244, '2017-12-02 11:34:33', NULL, NULL, 14939, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:34:33', 'admin-1512176007-15121856735876434', 1, 1, 'SR', NULL, NULL, NULL),
(55245, '2017-12-02 11:34:33', NULL, NULL, 14939, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:34:33', 'admin-1512176007-15121856735876434', 1, 1, 'SR', NULL, NULL, NULL),
(55246, '2017-12-02 12:51:39', NULL, NULL, 14949, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:51:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55247, '2017-12-02 13:01:32', NULL, NULL, 14938, 0, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 13:01:32', 'admin-1512176007-15121908926118156', 1, 1, 'SR', NULL, NULL, NULL),
(55248, '2017-12-02 13:01:35', NULL, NULL, 14951, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1512176007', 'admin', '2017-12-02 13:01:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55249, '2017-12-02 13:02:06', NULL, NULL, 14951, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 13:02:06', 'admin-1512176007-15121909261691461', 1, 0, '', NULL, NULL, NULL),
(55250, '2017-12-02 16:01:19', NULL, NULL, 14969, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 16:01:19', 'admin-1512176007-15122016797788144', 1, 0, '', NULL, NULL, NULL),
(55251, '2017-12-02 14:42:29', NULL, NULL, 14963, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:42:29', 'admin-1512176007-15121969488982756', 1, 0, '', NULL, NULL, NULL),
(55252, '2017-12-02 14:42:29', NULL, NULL, 14963, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:42:29', 'admin-1512176007-15121969488982756', 1, 1, 'SR', NULL, NULL, NULL),
(55253, '2017-12-02 11:52:01', NULL, NULL, 14941, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:52:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55254, '2017-12-02 11:52:25', NULL, NULL, 14941, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:52:25', 'admin-1512176007-15121867454702428', 1, 0, '', NULL, NULL, NULL),
(55255, '2017-12-02 11:46:05', NULL, NULL, 14936, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:46:05', 'admin-1512176007-1512186365464122', 1, 0, '', NULL, NULL, NULL),
(55256, '2017-12-02 11:14:20', NULL, NULL, 14937, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:14:20', 'admin-1512176007-1512184460197446', 1, 0, '', NULL, NULL, NULL),
(55257, '2017-12-02 11:56:43', NULL, NULL, 14943, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:56:43', 'admin-1512176007-15121870032325832', 1, 0, '', NULL, NULL, NULL),
(55258, '2017-12-02 14:53:19', NULL, NULL, 14965, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:53:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55259, '2017-12-02 14:54:58', NULL, NULL, 14964, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:54:58', 'admin-1512176007-15121976981065766', 1, 0, '', NULL, NULL, NULL),
(55260, '2017-12-02 14:49:05', NULL, NULL, 14964, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:49:05', 'admin-1512176007-1512197344998224', 1, 0, '', NULL, NULL, NULL),
(55261, '2017-12-02 14:49:05', NULL, NULL, 14964, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:49:05', 'admin-1512176007-1512197344998224', 1, 0, '', NULL, NULL, NULL),
(55262, '2017-12-02 14:42:13', NULL, NULL, 14963, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:42:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55263, '2017-12-02 14:21:47', NULL, NULL, 14961, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:21:47', 'admin-1512176007-15121957071449375', 1, 1, 'SR', NULL, NULL, NULL),
(55264, '2017-12-02 11:45:55', NULL, NULL, 14936, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:45:55', 'admin-1512176007-15121863548734031', 1, 1, 'SR', NULL, NULL, NULL),
(55265, '2017-12-02 13:02:06', NULL, NULL, 14951, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 13:02:06', 'admin-1512176007-15121909261691461', 1, 1, 'SR', NULL, NULL, NULL),
(55266, '2017-12-02 13:02:06', NULL, NULL, 14951, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 13:02:06', 'admin-1512176007-15121909261691461', 1, 1, 'SR', NULL, NULL, NULL),
(55267, '2017-12-02 12:35:57', NULL, NULL, 14947, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:35:57', 'admin-1512176007-15121893569455670', 1, 0, '', NULL, NULL, NULL),
(55268, '2017-12-02 14:54:02', NULL, NULL, 14965, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:54:02', 'admin-1512176007-15121976423253169', 1, 1, 'SR', NULL, NULL, NULL),
(55269, '2017-12-02 12:48:45', NULL, NULL, 14948, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.50, 0.0000, 0.0000, 9.50, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:48:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55270, '2017-12-02 12:49:01', NULL, NULL, 14948, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:49:01', 'admin-1512176007-15121901413919387', 1, 0, '', NULL, NULL, NULL),
(55271, '2017-12-02 15:09:00', NULL, NULL, 14968, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 15:09:00', 'admin-1512176007-15121985405917688', 1, 0, '', NULL, NULL, NULL),
(55272, '2017-12-02 14:25:39', NULL, NULL, 14961, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:25:39', 'admin-1512176007-15121959391939318', 1, 0, '', NULL, NULL, NULL),
(55273, '2017-12-02 13:02:06', NULL, NULL, 14951, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 13:02:06', 'admin-1512176007-15121909261691461', 1, 0, '', NULL, NULL, NULL),
(55274, '2017-12-02 14:54:02', NULL, NULL, 14965, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:54:02', 'admin-1512176007-15121976423253169', 1, 0, '', NULL, NULL, NULL),
(55275, '2017-12-02 14:54:02', NULL, NULL, 14965, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:54:02', 'admin-1512176007-15121976423253169', 1, 0, '', NULL, NULL, NULL),
(55276, '2017-12-02 15:02:12', NULL, NULL, 14967, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1512176007', 'admin', '2017-12-02 15:02:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55277, '2017-12-02 14:54:02', NULL, NULL, 14965, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:54:02', 'admin-1512176007-15121976423253169', 1, 1, 'SR', NULL, NULL, NULL),
(55278, '2017-12-02 14:48:25', NULL, NULL, 14964, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:48:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55279, '2017-12-02 11:56:43', NULL, NULL, 14943, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:56:43', 'admin-1512176007-15121870032325832', 1, 0, '', NULL, NULL, NULL),
(55280, '2017-12-02 11:56:43', NULL, NULL, 14943, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:56:43', 'admin-1512176007-15121870032325832', 1, 0, '', NULL, NULL, NULL),
(55281, '2017-12-02 11:56:43', NULL, NULL, 14943, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:56:43', 'admin-1512176007-15121870032325832', 1, 1, 'SR', NULL, NULL, NULL),
(55282, '2017-12-02 14:42:29', NULL, NULL, 14963, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:42:29', 'admin-1512176007-15121969488982756', 1, 1, 'SR', NULL, NULL, NULL),
(55283, '2017-12-02 12:51:49', NULL, NULL, 14949, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:51:49', 'admin-1512176007-15121903093901518', 1, 1, 'SR', NULL, NULL, NULL),
(55284, '2017-12-02 14:42:29', NULL, NULL, 14963, 0, 301, '237', 'Black Jack', '', 'Cold Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:42:29', 'admin-1512176007-15121969488982756', 1, 0, '', NULL, NULL, NULL),
(55285, '2017-12-02 14:42:29', NULL, NULL, 14963, 0, 307, '243', 'AA Set - Flaming Hot & spicy Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:42:29', 'admin-1512176007-15121969488982756', 1, 0, '', NULL, NULL, NULL),
(55286, '2017-12-02 14:42:29', NULL, NULL, 14963, 0, 306, '242', 'AA Set - Chinese Rice Wine Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:42:29', 'admin-1512176007-15121969488982756', 1, 0, '', NULL, NULL, NULL),
(55287, '2017-12-02 12:52:14', NULL, NULL, 14950, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:52:14', 'admin-1512176007-15121903347753174', 1, 0, '', 1, NULL, NULL),
(55288, '2017-12-02 12:51:49', NULL, NULL, 14949, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:51:49', 'admin-1512176007-15121903093901518', 1, 0, '', NULL, NULL, NULL),
(55289, '2017-12-02 12:49:01', NULL, NULL, 14948, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:49:01', 'admin-1512176007-15121901413919387', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(55290, '2017-12-02 12:49:01', NULL, NULL, 14948, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:49:01', 'admin-1512176007-15121901413919387', 1, 1, 'SR', NULL, NULL, NULL),
(55291, '2017-12-02 12:49:01', NULL, NULL, 14948, 0, 308, '244', 'AA Set - Chinese Ginger Garlic chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:49:01', 'admin-1512176007-15121901413919387', 1, 0, '', NULL, NULL, NULL),
(55292, '2017-12-02 13:26:55', NULL, NULL, 14953, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1512176007', 'admin', '2017-12-02 13:26:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55293, '2017-12-02 00:00:00', NULL, NULL, 14953, 0, 291, '225', 'Smoked Duck Red Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, NULL, NULL, 23.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:22:10', 'admin-1512176007-15121885300375434', 1, 0, '', NULL, NULL, NULL),
(55294, '2017-12-02 00:00:00', NULL, NULL, 14954, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:22:10', 'admin-1512176007-15121885300375434', 1, 0, '', NULL, NULL, NULL),
(55295, '2017-12-02 12:35:41', NULL, NULL, 14947, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:35:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55296, '2017-12-02 12:35:57', NULL, NULL, 14947, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:35:57', 'admin-1512176007-15121893569455670', 1, 0, '', NULL, NULL, NULL),
(55297, '2017-12-02 12:35:57', NULL, NULL, 14947, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:35:57', 'admin-1512176007-15121893569455670', 1, 1, 'SR', NULL, NULL, NULL),
(55298, '2017-12-02 12:35:57', NULL, NULL, 14947, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:35:57', 'admin-1512176007-15121893569455670', 1, 0, '', NULL, NULL, NULL),
(55299, '2017-12-02 14:21:47', NULL, NULL, 14961, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:21:47', 'admin-1512176007-15121957071449375', 1, 1, 'SR', NULL, NULL, NULL),
(55300, '2017-12-02 14:25:39', NULL, NULL, 14961, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:25:39', 'admin-1512176007-15121959391939318', 1, 0, '', NULL, NULL, NULL),
(55301, '2017-12-02 14:22:40', NULL, NULL, 14948, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:22:40', 'admin-1512176007-1512195760426218', 1, 0, '', NULL, NULL, NULL),
(55302, '2017-12-02 14:55:04', NULL, NULL, 14966, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:55:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55303, '2017-12-02 13:29:08', NULL, NULL, 14955, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1512176007', 'admin', '2017-12-02 13:29:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55304, '2017-12-02 13:28:21', NULL, NULL, 14954, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1512176007', 'admin', '2017-12-02 13:28:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55305, '2017-12-02 12:10:40', NULL, NULL, 14945, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:10:40', 'admin-1512176007-15121878401344211', 1, 1, 'SR', NULL, NULL, NULL),
(55306, '2017-12-02 00:00:00', NULL, NULL, 14956, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, NULL, NULL, 1.70, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:21:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55307, '2017-12-02 12:10:40', NULL, NULL, 14945, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:10:40', 'admin-1512176007-15121878401344211', 1, 1, 'SR', NULL, NULL, NULL),
(55308, '2017-12-02 11:58:57', NULL, NULL, 14944, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:58:57', 'admin-1512176007-15121871369123063', 1, 0, '', NULL, NULL, NULL),
(55309, '2017-12-02 11:56:02', NULL, NULL, 14942, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:56:02', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(55310, '2017-12-02 11:56:20', NULL, NULL, 14942, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:56:20', 'admin-1512176007-15121869807822879', 1, 0, '', NULL, NULL, '10.0'),
(55311, '2017-12-02 09:17:37', NULL, NULL, 14923, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1512176007', 'admin', '2017-12-02 09:17:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55312, '2017-12-02 09:18:59', NULL, NULL, 14923, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 09:18:59', 'admin-1512176007-15121775393323731', 1, 0, '', NULL, NULL, NULL),
(55313, '2017-12-02 09:18:59', NULL, NULL, 14923, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 09:18:59', 'admin-1512176007-15121775393323731', 1, 0, '', NULL, NULL, NULL),
(55314, '2017-12-02 09:19:08', NULL, NULL, 14923, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 09:19:08', 'admin-1512176007-15121775478647566', 1, 1, 'SR', NULL, NULL, NULL),
(55315, '2017-12-02 09:19:08', NULL, NULL, 14923, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 09:19:08', 'admin-1512176007-15121775478647566', 1, 1, 'SR', NULL, NULL, NULL),
(55316, '2017-12-02 12:10:40', NULL, NULL, 14945, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:10:40', 'admin-1512176007-15121878401344211', 1, 0, '', NULL, NULL, NULL),
(55317, '2017-12-02 12:10:40', NULL, NULL, 14945, 0, 308, '244', 'AA Set - Chinese Ginger Garlic chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:10:40', 'admin-1512176007-15121878401344211', 1, 0, '', NULL, NULL, NULL),
(55318, '2017-12-02 12:10:40', NULL, NULL, 14945, 0, 308, '244', 'AA Set - Chinese Ginger Garlic chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:10:40', 'admin-1512176007-15121878401344211', 1, 0, '', NULL, NULL, NULL),
(55319, '2017-12-02 11:52:25', NULL, NULL, 14941, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:52:25', 'admin-1512176007-15121867454702428', 1, 1, 'SR', NULL, NULL, NULL),
(55320, '2017-12-02 11:13:24', NULL, NULL, 14936, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:13:24', 'admin-1512176007-15121844044878561', 1, 1, 'SR', NULL, NULL, NULL),
(55321, '2017-12-02 11:13:24', NULL, NULL, 14936, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:13:24', 'admin-1512176007-15121844044878561', 1, 1, 'SR', NULL, NULL, NULL),
(55322, '2017-12-02 13:02:06', NULL, NULL, 14951, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 13:02:06', 'admin-1512176007-15121909261691461', 1, 1, 'SR', NULL, NULL, NULL),
(55323, '2017-12-02 12:10:23', NULL, NULL, 14945, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:10:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55324, '2017-12-02 11:58:57', NULL, NULL, 14944, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:58:57', 'admin-1512176007-15121871369123063', 1, 1, 'SR', NULL, NULL, NULL),
(55325, '2017-12-02 11:58:57', NULL, NULL, 14944, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:58:57', 'admin-1512176007-15121871369123063', 1, 0, '', NULL, NULL, NULL),
(55326, '2017-12-02 11:56:43', NULL, NULL, 14943, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:56:43', 'admin-1512176007-15121870032325832', 1, 1, 'SR', NULL, NULL, NULL),
(55327, '2017-12-02 11:58:37', NULL, NULL, 14944, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:58:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55328, '2017-12-02 11:56:20', NULL, NULL, 14942, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:56:20', 'admin-1512176007-15121869807822879', 1, 0, '', NULL, NULL, '10.0'),
(55329, '2017-12-02 00:00:00', NULL, NULL, 14955, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 12:22:10', 'admin-1512176007-15121885300375434', 1, 0, '', NULL, NULL, NULL),
(55330, '2017-12-02 11:40:57', NULL, NULL, 14940, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:40:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55331, '2017-12-02 11:41:18', NULL, NULL, 14940, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:41:18', 'admin-1512176007-15121860784576713', 1, 0, '', NULL, NULL, NULL),
(55332, '2017-12-02 11:41:18', NULL, NULL, 14940, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:41:18', 'admin-1512176007-15121860784576713', 1, 0, '', NULL, NULL, NULL),
(55333, '2017-12-02 11:45:55', NULL, NULL, 14936, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:45:55', 'admin-1512176007-15121863548734031', 1, 1, 'SR', NULL, NULL, NULL),
(55334, '2017-12-02 11:45:55', NULL, NULL, 14936, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:45:55', 'admin-1512176007-15121863548734031', 1, 1, 'SR', NULL, NULL, NULL),
(55335, '2017-12-02 11:34:17', NULL, NULL, 14939, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:34:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55336, '2017-12-02 10:42:25', NULL, NULL, 14932, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:42:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55337, '2017-12-02 10:42:50', NULL, NULL, 14932, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:42:50', 'admin-1512176007-15121825705488842', 1, 0, '', NULL, NULL, NULL),
(55338, '2017-12-02 10:42:50', NULL, NULL, 14932, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:42:50', 'admin-1512176007-15121825705488842', 1, 0, '', NULL, NULL, NULL),
(55339, '2017-12-02 10:42:50', NULL, NULL, 14932, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:42:50', 'admin-1512176007-15121825705488842', 1, 0, '', NULL, NULL, NULL),
(55340, '2017-12-02 10:48:21', NULL, NULL, 14933, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:48:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55341, '2017-12-02 00:00:00', NULL, NULL, 14962, 0, 307, '243', 'AA Set - Flaming Hot & spicy Pork', '', 'Meals', 'Rice', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 14:13:02', 'admin-1512176007-15121951825055999', 1, 0, '', NULL, NULL, NULL),
(55342, '2017-12-02 11:21:25', NULL, NULL, 14938, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:21:25', 'admin-1512176007-1512184884986299', 1, 1, 'SR', NULL, NULL, NULL),
(55343, '2017-12-02 10:54:44', NULL, NULL, 14934, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:54:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55344, '2017-12-02 10:16:03', NULL, NULL, 14929, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:16:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55345, '2017-12-02 10:16:26', NULL, NULL, 14929, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:16:26', 'admin-1512176007-15121809864129335', 1, 0, '', NULL, NULL, NULL),
(55346, '2017-12-02 10:16:26', NULL, NULL, 14929, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:16:26', 'admin-1512176007-15121809864129335', 1, 0, '', NULL, NULL, NULL),
(55347, '2017-12-02 11:41:18', NULL, NULL, 14940, 0, 298, '234', 'Salted Caramel Machiato', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:41:18', 'admin-1512176007-15121860784576713', 1, 0, '', NULL, NULL, NULL),
(55348, '2017-12-02 10:07:25', NULL, NULL, 14926, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:07:25', 'admin-1512176007-15121804451782531', 1, 0, '', NULL, NULL, NULL),
(55349, '2017-12-02 10:09:01', NULL, NULL, 14927, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:09:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55350, '2017-12-02 11:18:19', NULL, NULL, 14933, 0, 331, '267', 'Yuzu Marmalade Pancake', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:18:19', 'admin-1512176007-15121846997503610', 1, 0, '', NULL, NULL, NULL),
(55351, '2017-12-02 11:13:24', NULL, NULL, 14936, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:13:24', 'admin-1512176007-15121844044878561', 1, 1, 'SR', NULL, NULL, NULL),
(55352, '2017-12-02 11:14:20', NULL, NULL, 14937, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:14:20', 'admin-1512176007-1512184460197446', 1, 0, '', NULL, NULL, NULL),
(55353, '2017-12-02 11:14:10', NULL, NULL, 14937, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:14:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55354, '2017-12-02 10:48:49', NULL, NULL, 14933, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:48:49', 'admin-1512176007-15121829293847138', 1, 1, 'SR', NULL, NULL, NULL),
(55355, '2017-12-02 10:09:14', NULL, NULL, 14927, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:09:14', 'admin-1512176007-15121805544767149', 1, 0, '', NULL, NULL, NULL),
(55356, '2017-12-02 10:09:14', NULL, NULL, 14927, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:09:14', 'admin-1512176007-15121805544767149', 1, 0, '', NULL, NULL, NULL),
(55357, '2017-12-02 10:10:10', NULL, NULL, 14927, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:10:10', 'admin-1512176007-15121806105216573', 1, 1, 'SR', NULL, NULL, NULL),
(55358, '2017-12-02 16:01:11', NULL, NULL, 14969, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 16:01:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55359, '2017-12-02 10:48:49', NULL, NULL, 14933, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:48:49', 'admin-1512176007-15121829293847138', 1, 0, '', NULL, NULL, NULL),
(55360, '2017-12-02 10:16:26', NULL, NULL, 14929, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:16:26', 'admin-1512176007-15121809864129335', 1, 1, 'SR', NULL, NULL, NULL),
(55361, '2017-12-02 10:16:26', NULL, NULL, 14929, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:16:26', 'admin-1512176007-15121809864129335', 1, 1, 'SR', NULL, NULL, NULL),
(55362, '2017-12-02 10:48:49', NULL, NULL, 14933, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:48:49', 'admin-1512176007-15121829293847138', 1, 0, '', NULL, NULL, NULL),
(55363, '2017-12-02 10:48:49', NULL, NULL, 14933, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:48:49', 'admin-1512176007-15121829293847138', 1, 0, '', NULL, NULL, NULL),
(55364, '2017-12-02 11:21:25', NULL, NULL, 14938, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:21:25', 'admin-1512176007-1512184884986299', 1, 1, 'SR', NULL, NULL, NULL),
(55365, '2017-12-02 10:41:50', NULL, NULL, 14931, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:41:50', 'admin-1512176007-1512182510572117', 1, 0, '', NULL, NULL, NULL),
(55366, '2017-12-02 10:41:50', NULL, NULL, 14931, 0, 153, '87', 'Wake Me Up!', 'no toast', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:41:50', 'admin-1512176007-1512182510572117', 1, 0, '', NULL, NULL, NULL),
(55367, '2017-12-02 10:37:48', NULL, NULL, 14930, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:37:48', 'admin-1512176007-15121822681356868', 1, 0, '', NULL, NULL, NULL),
(55368, '2017-12-02 10:37:13', NULL, NULL, 14930, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:37:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55369, '2017-12-02 10:41:35', NULL, NULL, 14931, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:41:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55370, '2017-12-02 10:37:48', NULL, NULL, 14930, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:37:48', 'admin-1512176007-15121822681356868', 1, 0, '', NULL, NULL, NULL),
(55371, '2017-12-02 10:37:48', NULL, NULL, 14930, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:37:48', 'admin-1512176007-15121822681356868', 1, 0, '', NULL, NULL, NULL),
(55372, '2017-12-02 13:48:02', NULL, NULL, 14957, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 13:48:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55373, '2017-12-02 10:55:09', NULL, NULL, 14935, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:55:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55374, '2017-12-02 10:10:10', NULL, NULL, 14927, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:10:10', 'admin-1512176007-15121806105216573', 1, 1, 'SR', NULL, NULL, NULL),
(55375, '2017-12-02 10:10:10', NULL, NULL, 14927, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:10:10', 'admin-1512176007-15121806105216573', 1, 1, 'SR', NULL, NULL, NULL),
(55376, '2017-12-02 11:21:14', NULL, NULL, 14938, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1512176007', 'admin', '2017-12-02 11:21:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55377, '2017-12-02 10:04:33', NULL, NULL, 14925, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:04:33', 'admin-1512176007-15121802735488353', 1, 0, '', NULL, NULL, '10.0'),
(55378, '2017-12-02 10:07:25', NULL, NULL, 14926, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:07:25', 'admin-1512176007-15121804451782531', 1, 0, '', NULL, NULL, NULL),
(55379, '2017-12-02 09:58:32', NULL, NULL, 14924, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 09:58:32', 'admin-1512176007-15121799119667152', 1, 1, 'SR', NULL, NULL, NULL),
(55380, '2017-12-02 10:06:58', NULL, NULL, 14926, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:06:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55381, '2017-12-02 10:04:33', NULL, NULL, 14925, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:04:33', 'admin-1512176007-15121802735488353', 1, 1, 'SR', NULL, NULL, '10.0'),
(55382, '2017-12-02 10:04:26', NULL, NULL, 14925, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1512176007', 'admin', '2017-12-02 10:04:26', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(55383, '2017-12-02 13:09:07', NULL, NULL, 14952, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1512176007', 'admin', '2017-12-02 13:09:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55384, '2017-12-02 09:58:57', NULL, NULL, 14924, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 09:58:57', 'admin-1512176007-15121799378173729', 1, 1, 'SR', NULL, NULL, NULL),
(55385, '2017-12-02 09:58:32', NULL, NULL, 14924, 0, 298, '234', 'Salted Caramel Machiato', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512176007', 'admin', '2017-12-02 09:58:32', 'admin-1512176007-15121799119667152', 1, 0, '', NULL, NULL, NULL),
(55386, '2017-12-02 09:58:23', NULL, NULL, 14924, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1512176007', 'admin', '2017-12-02 09:58:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55387, '2017-12-03 17:26:35', NULL, NULL, 15019, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 17:26:35', 'admin-1512276983-15122931951359410', 1, 0, '', NULL, NULL, NULL),
(55388, '2017-12-03 17:26:35', NULL, NULL, 15019, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 17:26:35', 'admin-1512276983-15122931951359410', 1, 0, '', NULL, NULL, NULL),
(55389, '2017-12-03 15:48:27', NULL, NULL, 15014, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 15:48:27', 'admin-1512276983-15122873075757981', 1, 0, '', NULL, NULL, NULL),
(55390, '2017-12-03 15:48:27', NULL, NULL, 15014, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 15:48:27', 'admin-1512276983-15122873075757981', 1, 0, '', NULL, NULL, NULL),
(55391, '2017-12-03 10:33:41', NULL, NULL, 14975, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:33:41', 'admin-1512262587-15122684215003491', 1, 1, 'SR', NULL, NULL, NULL),
(55392, '2017-12-03 10:33:41', NULL, NULL, 14975, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:33:41', 'admin-1512262587-15122684215003491', 1, 0, '', NULL, NULL, NULL),
(55393, '2017-12-03 10:33:41', NULL, NULL, 14975, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:33:41', 'admin-1512262587-15122684215003491', 1, 0, '', NULL, NULL, NULL),
(55394, '2017-12-03 10:38:02', NULL, NULL, 14975, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:38:02', 'admin-1512262587-151226868220173', 1, 1, 'SR', NULL, NULL, NULL),
(55395, '2017-12-03 17:17:46', NULL, NULL, 15020, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 17:17:46', 'admin-1512276983-15122926666648573', 1, 1, 'SR', NULL, NULL, NULL),
(55396, '2017-12-03 17:17:24', NULL, NULL, 15020, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1512276983', 'admin', '2017-12-03 17:17:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55397, '2017-12-03 13:48:23', NULL, NULL, 15001, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:48:23', 'admin-1512276983-15122801034528242', 1, 1, 'SR', NULL, NULL, NULL),
(55398, '2017-12-03 11:31:09', NULL, NULL, 14984, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:31:09', 'admin-1512262587-15122718690153084', 1, 0, '', NULL, NULL, NULL),
(55399, '2017-12-03 12:29:44', NULL, NULL, 14987, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:29:44', 'admin-1512262587-15122753840091529', 1, 0, '', NULL, NULL, NULL),
(55400, '2017-12-03 10:59:04', NULL, NULL, 14980, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:59:04', 'admin-1512262587-15122699443905427', 1, 1, 'SR', NULL, NULL, NULL),
(55401, '2017-12-03 17:17:46', NULL, NULL, 15020, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 17:17:46', 'admin-1512276983-15122926666648573', 1, 1, 'SR', NULL, NULL, NULL),
(55402, '2017-12-03 13:34:42', NULL, NULL, 15000, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:34:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55403, '2017-12-03 12:37:08', NULL, NULL, 14971, 0, 307, '243', 'AA Set - Flaming Hot & spicy Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:37:08', 'admin-1512262587-15122758282198860', 1, 0, '', NULL, NULL, NULL),
(55404, '2017-12-03 12:39:43', NULL, NULL, 14990, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:39:43', 'admin-1512262587-1512275983178836', 1, 0, '', NULL, NULL, NULL),
(55405, '2017-12-03 12:39:43', NULL, NULL, 14990, 0, 157, '91', 'Classic French Toast', 'add bacon', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:39:43', 'admin-1512262587-1512275983178836', 1, 0, '', NULL, NULL, NULL),
(55406, '2017-12-03 15:13:45', NULL, NULL, 15014, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1512276983', 'admin', '2017-12-03 15:13:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55407, '2017-12-03 13:48:13', NULL, NULL, 15001, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:48:13', 'admin-1512276983-15122800935292286', 1, 0, '', NULL, NULL, NULL),
(55408, '2017-12-03 12:34:34', NULL, NULL, 14989, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:34:34', 'admin-1512262587-15122756745623047', 1, 1, 'SR', NULL, NULL, NULL),
(55409, '2017-12-03 17:17:46', NULL, NULL, 15020, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 17:17:46', 'admin-1512276983-15122926666648573', 1, 0, '', NULL, NULL, NULL),
(55410, '2017-12-03 13:48:08', NULL, NULL, 15001, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:48:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55411, '2017-12-03 13:45:12', NULL, NULL, 14988, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:45:12', 'admin-1512276983-15122799127122413', 1, 0, '', NULL, NULL, NULL),
(55412, '2017-12-03 12:12:49', NULL, NULL, 14987, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:12:49', 'admin-1512262587-15122743696223590', 1, 0, '', NULL, NULL, NULL),
(55413, '2017-12-03 10:49:43', NULL, NULL, 14978, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:49:43', 'admin-1512262587-15122693837796373', 1, 0, '', NULL, NULL, NULL),
(55414, '2017-12-03 10:25:40', NULL, NULL, 14975, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:25:40', 'admin-1512262587-15122679403422974', 1, 1, 'SR', NULL, NULL, NULL),
(55415, '2017-12-03 13:35:06', NULL, NULL, 15000, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:35:06', 'admin-1512276983-15122793063887122', 1, 1, 'SR', NULL, NULL, NULL),
(55416, '2017-12-03 11:01:55', NULL, NULL, 14982, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:01:55', 'admin-1512262587-15122701154073310', 1, 0, '', NULL, NULL, NULL),
(55417, '2017-12-03 16:20:22', NULL, NULL, 15019, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 16:20:22', 'admin-1512276983-15122892224542854', 1, 0, '', NULL, NULL, NULL),
(55418, '2017-12-03 16:20:22', NULL, NULL, 15019, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 16:20:22', 'admin-1512276983-15122892224542854', 1, 1, 'SR', NULL, NULL, NULL),
(55419, '2017-12-03 16:20:22', NULL, NULL, 15019, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 16:20:22', 'admin-1512276983-15122892224542854', 1, 1, 'SR', NULL, NULL, NULL),
(55420, '2017-12-03 16:20:22', NULL, NULL, 15019, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 16:20:22', 'admin-1512276983-15122892224542854', 1, 1, 'SR', NULL, NULL, NULL),
(55421, '2017-12-03 16:19:58', NULL, NULL, 15019, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.80, 0.0000, 0.0000, 9.80, 1, '27', 1, '1512276983', 'admin', '2017-12-03 16:19:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55422, '2017-12-03 14:19:28', NULL, NULL, 15006, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 14:19:28', 'admin-1512276983-15122819681031423', 1, 1, 'SR', NULL, NULL, NULL),
(55423, '2017-12-03 15:13:56', NULL, NULL, 15014, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 15:13:56', 'admin-1512276983-1512285236589396', 1, 1, 'SR', NULL, NULL, NULL),
(55424, '2017-12-03 15:16:38', NULL, NULL, 15015, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1512276983', 'admin', '2017-12-03 15:16:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55425, '2017-12-03 15:16:57', NULL, NULL, 15015, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 15:16:57', 'admin-1512276983-15122854171488593', 1, 0, '', NULL, NULL, NULL),
(55426, '2017-12-03 15:16:57', NULL, NULL, 15015, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 15:16:57', 'admin-1512276983-15122854171488593', 1, 0, '', NULL, NULL, NULL),
(55427, '2017-12-03 15:16:57', NULL, NULL, 15015, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 15:16:57', 'admin-1512276983-15122854171488593', 1, 0, '', NULL, NULL, NULL),
(55428, '2017-12-03 15:48:27', NULL, NULL, 15014, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 15:48:27', 'admin-1512276983-15122873075757981', 1, 1, 'SR', NULL, NULL, NULL),
(55429, '2017-12-03 00:00:00', NULL, NULL, 15008, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:27:14', 'admin-1512276983-15122788347688852', 1, 0, '', NULL, NULL, NULL),
(55430, '2017-12-03 13:31:37', NULL, NULL, 14997, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:31:37', 'admin-1512276983-15122790969339718', 1, 1, 'SR', NULL, NULL, NULL),
(55431, '2017-12-03 11:33:15', NULL, NULL, 14984, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:33:15', 'admin-1512262587-15122719956868693', 1, 0, '', NULL, NULL, NULL),
(55432, '2017-12-03 11:43:25', NULL, NULL, 14985, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:43:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55433, '2017-12-03 15:24:39', NULL, NULL, 15016, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1512276983', 'admin', '2017-12-03 15:24:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55434, '2017-12-03 15:38:13', NULL, NULL, 15018, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 15:38:13', 'admin-1512276983-15122866931588222', 1, 0, '', 1, NULL, NULL),
(55435, '2017-12-03 00:00:00', NULL, NULL, 15008, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.69, NULL, NULL, 5.69, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:26:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55436, '2017-12-03 13:22:57', NULL, NULL, 14996, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:22:57', 'admin-1512276983-1512278577147552', 1, 0, '', NULL, NULL, NULL),
(55437, '2017-12-03 17:26:35', NULL, NULL, 15019, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 17:26:35', 'admin-1512276983-15122931951359410', 1, 1, 'SR', NULL, NULL, NULL),
(55438, '2017-12-03 15:29:29', NULL, NULL, 15017, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 15:29:29', 'admin-1512276983-1512286169674527', 1, 0, '', 1, NULL, NULL),
(55439, '2017-12-03 14:11:33', NULL, NULL, 15007, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1512276983', 'admin', '2017-12-03 14:11:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55440, '2017-12-03 00:00:00', NULL, NULL, 15008, 0, 307, '243', 'AA Set - Flaming Hot & spicy Pork', '', 'Meals', 'Rice', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:27:14', 'admin-1512276983-15122788347688852', 1, 0, '', NULL, NULL, NULL),
(55441, '2017-12-03 00:00:00', NULL, NULL, 15008, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:27:14', 'admin-1512276983-15122788347688852', 1, 0, '', NULL, NULL, NULL),
(55442, '2017-12-03 13:57:48', NULL, NULL, 15004, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:57:48', 'admin-1512276983-15122806680031311', 1, 0, '', NULL, NULL, NULL),
(55443, '2017-12-03 13:57:48', NULL, NULL, 15004, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:57:48', 'admin-1512276983-15122806680031311', 1, 1, 'SR', NULL, NULL, NULL),
(55444, '2017-12-03 13:57:48', NULL, NULL, 15004, 0, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:57:48', 'admin-1512276983-15122806680031311', 1, 1, 'SR', NULL, NULL, NULL),
(55445, '2017-12-03 14:26:33', NULL, NULL, 15012, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 14:26:33', 'admin-1512276983-15122823937282194', 1, 0, '', NULL, NULL, NULL),
(55446, '2017-12-03 15:16:57', NULL, NULL, 15015, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 15:16:57', 'admin-1512276983-15122854171488593', 1, 1, 'SR', NULL, NULL, NULL),
(55447, '2017-12-03 15:13:56', NULL, NULL, 15014, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 15:13:56', 'admin-1512276983-1512285236589396', 1, 0, '', NULL, NULL, NULL),
(55448, '2017-12-03 15:03:02', NULL, NULL, 15013, 0, 323, '259', 'Ginger Cucumber Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 15:03:02', 'admin-1512276983-15122845822539654', 1, 0, '', NULL, NULL, NULL),
(55449, '2017-12-03 10:57:20', NULL, NULL, 14979, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:57:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55450, '2017-12-03 10:08:26', NULL, NULL, 14973, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:08:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55451, '2017-12-03 10:08:45', NULL, NULL, 14973, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:08:45', 'admin-1512262587-15122669251027785', 1, 0, '', NULL, NULL, NULL),
(55452, '2017-12-03 10:08:45', NULL, NULL, 14973, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:08:45', 'admin-1512262587-15122669251027785', 1, 0, '', NULL, NULL, NULL),
(55453, '2017-12-03 14:16:23', NULL, NULL, 15010, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1512276983', 'admin', '2017-12-03 14:16:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55454, '2017-12-03 00:00:00', NULL, NULL, 15007, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:27:14', 'admin-1512276983-15122788347688852', 1, 1, 'SR', NULL, NULL, NULL),
(55455, '2017-12-03 09:34:47', NULL, NULL, 14972, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 09:34:47', 'admin-1512262587-15122648875083090', 1, 0, '', NULL, NULL, NULL),
(55456, '2017-12-03 10:57:35', NULL, NULL, 14979, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:57:35', 'admin-1512262587-15122698557463441', 1, 0, '', NULL, NULL, NULL),
(55457, '2017-12-03 12:37:44', NULL, NULL, 14971, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:37:44', 'admin-1512262587-15122758642026849', 1, 0, '', NULL, NULL, NULL),
(55458, '2017-12-03 11:56:34', NULL, NULL, 14971, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:56:34', 'admin-1512262587-15122733944823520', 1, 0, '', NULL, NULL, NULL),
(55459, '2017-12-03 13:25:47', NULL, NULL, 14998, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:25:47', 'admin-1512276983-15122787473994454', 1, 1, 'SR', 1, NULL, NULL),
(55460, '2017-12-03 14:30:06', NULL, NULL, 15012, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 14:30:06', 'admin-1512276983-1512282606560629', 1, 0, '', NULL, NULL, NULL),
(55461, '2017-12-03 12:55:09', NULL, NULL, 14994, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:55:09', 'admin-1512262587-15122769095983536', 1, 0, '', NULL, NULL, NULL),
(55462, '2017-12-03 12:55:09', NULL, NULL, 14994, 0, 270, '204', 'Homemade Savoury Pancake', 'sunny side up', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:55:09', 'admin-1512262587-15122769095983536', 1, 0, '', NULL, NULL, NULL),
(55463, '2017-12-03 15:02:39', NULL, NULL, 15013, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1512276983', 'admin', '2017-12-03 15:02:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55464, '2017-12-03 14:26:33', NULL, NULL, 15012, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 14:26:33', 'admin-1512276983-15122823937282194', 1, 1, 'SR', NULL, NULL, NULL),
(55465, '2017-12-03 13:48:30', NULL, NULL, 15002, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:48:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55466, '2017-12-03 10:51:20', NULL, NULL, 14974, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:51:20', 'admin-1512262587-1512269480105769', 1, 0, '', NULL, NULL, NULL),
(55467, '2017-12-03 12:39:18', NULL, NULL, 14990, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:39:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55468, '2017-12-03 11:01:55', NULL, NULL, 14982, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:01:55', 'admin-1512262587-15122701154073310', 1, 0, '', NULL, NULL, NULL),
(55469, '2017-12-03 11:02:03', NULL, NULL, 14982, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:02:03', 'admin-1512262587-15122701231587596', 1, 1, 'SR', NULL, NULL, NULL),
(55470, '2017-12-03 11:02:03', NULL, NULL, 14982, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:02:03', 'admin-1512262587-15122701231587596', 1, 1, 'SR', NULL, NULL, NULL),
(55471, '2017-12-03 13:23:49', NULL, NULL, 14997, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:23:49', 'admin-1512276983-15122786298196743', 1, 1, 'SR', NULL, NULL, NULL),
(55472, '2017-12-03 12:49:05', NULL, NULL, 14992, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:49:05', 'admin-1512262587-15122765450666747', 1, 1, 'SR', NULL, NULL, NULL),
(55473, '2017-12-03 10:58:39', NULL, NULL, 14979, 0, 300, '236', 'Special Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:58:39', 'admin-1512262587-15122699196451256', 1, 0, '', NULL, NULL, NULL),
(55474, '2017-12-03 10:58:44', NULL, NULL, 14980, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:58:44', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(55475, '2017-12-03 13:57:26', NULL, NULL, 15004, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:57:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55476, '2017-12-03 13:57:48', NULL, NULL, 15004, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:57:48', 'admin-1512276983-15122806680031311', 1, 0, '', NULL, NULL, NULL),
(55477, '2017-12-03 13:23:39', NULL, NULL, 14991, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:23:39', 'admin-1512276983-15122786192045458', 1, 1, 'SR', NULL, NULL, NULL),
(55478, '2017-12-03 14:25:51', NULL, NULL, 15011, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1512276983', 'admin', '2017-12-03 14:25:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55479, '2017-12-03 12:52:10', NULL, NULL, 14991, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:52:10', 'admin-1512262587-15122767299434838', 1, 0, '', NULL, NULL, NULL),
(55480, '2017-12-03 12:52:15', NULL, NULL, 14993, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:52:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55481, '2017-12-03 14:16:26', NULL, NULL, 15010, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 14:16:26', 'admin-1512276983-15122817866028390', 1, 0, '', NULL, NULL, NULL),
(55482, '2017-12-03 13:58:36', NULL, NULL, 15005, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:58:36', 'admin-1512276983-15122807168238852', 1, 1, 'SR', NULL, NULL, NULL),
(55483, '2017-12-03 15:48:27', NULL, NULL, 15014, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 15:48:27', 'admin-1512276983-15122873075757981', 1, 1, 'SR', NULL, NULL, NULL),
(55484, '2017-12-03 14:16:18', NULL, NULL, 15009, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 14:16:18', 'admin-1512276983-15122817780325999', 1, 1, 'SR', NULL, NULL, NULL),
(55485, '2017-12-03 14:16:18', NULL, NULL, 15009, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 14:16:18', 'admin-1512276983-15122817780325999', 1, 1, 'SR', NULL, NULL, NULL),
(55486, '2017-12-03 14:16:18', NULL, NULL, 15009, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 14:16:18', 'admin-1512276983-15122817780325999', 1, 0, '', NULL, NULL, NULL),
(55487, '2017-12-03 14:15:55', NULL, NULL, 15009, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1512276983', 'admin', '2017-12-03 14:15:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55488, '2017-12-03 13:23:08', NULL, NULL, 14996, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:23:08', 'admin-1512276983-15122785883343045', 1, 1, 'SR', NULL, NULL, NULL),
(55489, '2017-12-03 13:23:08', NULL, NULL, 14996, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:23:08', 'admin-1512276983-15122785883343045', 1, 1, 'SR', NULL, NULL, NULL),
(55490, '2017-12-03 11:31:09', NULL, NULL, 14984, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:31:09', 'admin-1512262587-15122718690153084', 1, 0, '', NULL, NULL, NULL),
(55491, '2017-12-03 14:26:05', NULL, NULL, 15011, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 14:26:05', 'admin-1512276983-15122823657398660', 1, 1, 'SR', NULL, NULL, NULL),
(55492, '2017-12-03 00:00:00', NULL, NULL, 15008, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, NULL, NULL, 3.90, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:27:14', 'admin-1512276983-15122788347688852', 1, 0, '', NULL, NULL, NULL),
(55493, '2017-12-03 00:00:00', NULL, NULL, 15007, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:27:14', 'admin-1512276983-15122788347688852', 1, 0, '', NULL, NULL, NULL),
(55494, '2017-12-03 14:02:31', NULL, NULL, 15006, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1512276983', 'admin', '2017-12-03 14:02:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55495, '2017-12-03 13:58:36', NULL, NULL, 15005, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:58:36', 'admin-1512276983-15122807168238852', 1, 1, 'SR', NULL, NULL, NULL),
(55496, '2017-12-03 13:59:43', NULL, NULL, 14997, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:59:43', 'admin-1512276983-15122807837773159', 1, 0, '', NULL, NULL, NULL),
(55497, '2017-12-03 10:49:08', NULL, NULL, 14977, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:49:08', 'admin-1512262587-15122693482393097', 1, 0, '', NULL, NULL, NULL),
(55498, '2017-12-03 14:02:43', NULL, NULL, 15006, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 14:02:43', 'admin-1512276983-15122809631333254', 1, 1, 'SR', NULL, NULL, NULL),
(55499, '2017-12-03 13:48:38', NULL, NULL, 15002, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:48:38', 'admin-1512276983-15122801179825831', 1, 0, '', NULL, NULL, NULL),
(55500, '2017-12-03 13:20:03', NULL, NULL, 14995, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:20:03', 'admin-1512276983-1512278403463382', 1, 1, 'SR', NULL, NULL, NULL),
(55501, '2017-12-03 13:19:59', NULL, NULL, 14995, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:19:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55502, '2017-12-03 13:58:24', NULL, NULL, 15005, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:58:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55503, '2017-12-03 13:53:22', NULL, NULL, 15003, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:53:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55504, '2017-12-03 10:11:20', NULL, NULL, 14974, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:11:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55505, '2017-12-03 13:53:32', NULL, NULL, 15003, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:53:32', 'admin-1512276983-1512280412085918', 1, 0, '', NULL, NULL, NULL),
(55506, '2017-12-03 13:53:32', NULL, NULL, 15003, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:53:32', 'admin-1512276983-1512280412085918', 1, 1, 'SR', NULL, NULL, NULL),
(55507, '2017-12-03 13:48:43', NULL, NULL, 15002, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:48:43', 'admin-1512276983-15122801235115927', 1, 1, 'SR', NULL, NULL, NULL),
(55508, '2017-12-03 11:01:55', NULL, NULL, 14982, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:01:55', 'admin-1512262587-15122701154073310', 1, 0, '', NULL, NULL, NULL),
(55509, '2017-12-03 12:59:52', NULL, NULL, 14994, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:59:52', 'admin-1512276983-15122771923917434', 1, 1, 'SR', NULL, NULL, NULL),
(55510, '2017-12-03 11:00:18', NULL, NULL, 14981, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:00:18', 'admin-1512262587-15122700178723882', 1, 0, '', NULL, NULL, NULL),
(55511, '2017-12-03 11:00:18', NULL, NULL, 14981, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:00:18', 'admin-1512262587-15122700178723882', 1, 0, '', NULL, NULL, NULL),
(55512, '2017-12-03 11:00:18', NULL, NULL, 14981, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:00:18', 'admin-1512262587-15122700178723882', 1, 0, '', NULL, NULL, NULL),
(55513, '2017-12-03 11:00:18', NULL, NULL, 14981, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:00:18', 'admin-1512262587-15122700178723882', 1, 1, 'SR', NULL, NULL, NULL),
(55514, '2017-12-03 11:00:18', NULL, NULL, 14981, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:00:18', 'admin-1512262587-15122700178723882', 1, 0, '', NULL, NULL, NULL),
(55515, '2017-12-03 12:59:52', NULL, NULL, 14994, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:59:52', 'admin-1512276983-15122771923917434', 1, 1, 'SR', NULL, NULL, NULL),
(55516, '2017-12-03 12:59:52', NULL, NULL, 14994, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:59:52', 'admin-1512276983-15122771923917434', 1, 1, 'SR', NULL, NULL, NULL),
(55517, '2017-12-03 15:03:02', NULL, NULL, 15013, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 15:03:02', 'admin-1512276983-15122845822539654', 1, 0, '', NULL, NULL, NULL),
(55518, '2017-12-03 12:59:52', NULL, NULL, 14994, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:59:52', 'admin-1512276983-15122771923917434', 1, 1, 'SR', NULL, NULL, NULL),
(55519, '2017-12-03 12:59:52', NULL, NULL, 14994, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:59:52', 'admin-1512276983-15122771923917434', 1, 1, 'SR', NULL, NULL, NULL),
(55520, '2017-12-03 12:44:11', NULL, NULL, 14991, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:44:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55521, '2017-12-03 12:44:24', NULL, NULL, 14991, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:44:24', 'admin-1512262587-15122762639467140', 1, 0, '', NULL, NULL, NULL),
(55522, '2017-12-03 13:22:39', NULL, NULL, 14996, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:22:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55523, '2017-12-03 12:59:52', NULL, NULL, 14994, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:59:52', 'admin-1512276983-15122771923917434', 1, 1, 'SR', NULL, NULL, NULL),
(55524, '2017-12-03 12:55:09', NULL, NULL, 14994, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:55:09', 'admin-1512262587-15122769095983536', 1, 0, '', NULL, NULL, NULL),
(55525, '2017-12-03 12:55:09', NULL, NULL, 14994, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:55:09', 'admin-1512262587-15122769095983536', 1, 0, '', NULL, NULL, NULL),
(55526, '2017-12-03 12:53:58', NULL, NULL, 14994, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 23.70, 0.0000, 0.0000, 23.70, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:53:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55527, '2017-12-03 13:32:15', NULL, NULL, 14997, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', 'add pasta', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:32:15', 'admin-1512276983-15122791349589853', 1, 0, '', NULL, NULL, NULL),
(55528, '2017-12-03 12:55:09', NULL, NULL, 14994, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:55:09', 'admin-1512262587-15122769095983536', 1, 0, '', NULL, NULL, NULL),
(55529, '2017-12-03 12:55:09', NULL, NULL, 14994, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:55:09', 'admin-1512262587-15122769095983536', 1, 1, 'SR', NULL, NULL, NULL),
(55530, '2017-12-03 12:55:09', NULL, NULL, 14994, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:55:09', 'admin-1512262587-15122769095983536', 1, 0, '', NULL, NULL, NULL),
(55531, '2017-12-03 12:55:09', NULL, NULL, 14994, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:55:09', 'admin-1512262587-15122769095983536', 1, 0, '', NULL, NULL, NULL),
(55532, '2017-12-03 12:52:19', NULL, NULL, 14993, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:52:19', 'admin-1512262587-1512276739670287', 1, 0, '', NULL, NULL, NULL),
(55533, '2017-12-03 12:52:19', NULL, NULL, 14993, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:52:19', 'admin-1512262587-1512276739670287', 1, 0, '', NULL, NULL, NULL),
(55534, '2017-12-03 00:00:00', NULL, NULL, 15008, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:27:14', 'admin-1512276983-15122788347688852', 1, 1, 'SR', NULL, NULL, NULL),
(55535, '2017-12-03 12:49:05', NULL, NULL, 14992, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:49:05', 'admin-1512262587-15122765450666747', 1, 0, '', NULL, NULL, NULL),
(55536, '2017-12-03 12:52:10', NULL, NULL, 14991, 0, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:52:10', 'admin-1512262587-15122767299434838', 1, 1, 'SR', NULL, NULL, NULL),
(55537, '2017-12-03 12:52:10', NULL, NULL, 14991, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:52:10', 'admin-1512262587-15122767299434838', 1, 1, 'SR', NULL, NULL, NULL),
(55538, '2017-12-03 13:25:47', NULL, NULL, 14998, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:25:47', 'admin-1512276983-15122787473994454', 1, 1, 'SR', 1, NULL, NULL),
(55539, '2017-12-03 12:59:52', NULL, NULL, 14994, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:59:52', 'admin-1512276983-15122771923917434', 1, 1, 'SR', NULL, NULL, NULL),
(55540, '2017-12-03 14:26:16', NULL, NULL, 15012, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1512276983', 'admin', '2017-12-03 14:26:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55541, '2017-12-03 14:26:05', NULL, NULL, 15011, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 14:26:05', 'admin-1512276983-15122823657398660', 1, 0, '', NULL, NULL, NULL),
(55542, '2017-12-03 12:49:05', NULL, NULL, 14992, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:49:05', 'admin-1512262587-15122765450666747', 1, 1, 'SR', NULL, NULL, NULL),
(55543, '2017-12-03 11:31:09', NULL, NULL, 14984, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:31:09', 'admin-1512262587-15122718690153084', 1, 0, '', NULL, NULL, NULL),
(55544, '2017-12-03 12:49:05', NULL, NULL, 14992, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:49:05', 'admin-1512262587-15122765450666747', 1, 1, 'SR', NULL, NULL, NULL),
(55545, '2017-12-03 12:48:51', NULL, NULL, 14992, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:48:51', 'admin-1512262587-15122765310658879', 1, 0, '', NULL, NULL, NULL),
(55546, '2017-12-03 12:48:51', NULL, NULL, 14992, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:48:51', 'admin-1512262587-15122765310658879', 1, 0, '', NULL, NULL, NULL),
(55547, '2017-12-03 12:48:51', NULL, NULL, 14992, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:48:51', 'admin-1512262587-15122765310658879', 1, 0, '', NULL, NULL, NULL),
(55548, '2017-12-03 11:13:54', NULL, NULL, 14982, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:13:54', 'admin-1512262587-15122708345505425', 1, 0, '', NULL, NULL, NULL),
(55549, '2017-12-03 11:20:35', NULL, NULL, 14983, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:20:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55550, '2017-12-03 11:20:45', NULL, NULL, 14983, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:20:45', 'admin-1512262587-1512271245612177', 1, 0, '', NULL, NULL, NULL),
(55551, '2017-12-03 11:20:45', NULL, NULL, 14983, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:20:45', 'admin-1512262587-1512271245612177', 1, 1, 'SR', NULL, NULL, NULL),
(55552, '2017-12-03 12:44:24', NULL, NULL, 14991, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:44:24', 'admin-1512262587-15122762639467140', 1, 1, 'SR', NULL, NULL, NULL),
(55553, '2017-12-03 12:39:43', NULL, NULL, 14990, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:39:43', 'admin-1512262587-1512275983178836', 1, 1, 'SR', NULL, NULL, NULL),
(55554, '2017-12-03 12:39:43', NULL, NULL, 14990, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:39:43', 'admin-1512262587-1512275983178836', 1, 1, 'SR', NULL, NULL, NULL),
(55555, '2017-12-03 12:48:20', NULL, NULL, 14992, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.00, 0.0000, 0.0000, 11.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:48:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55556, '2017-12-03 12:34:34', NULL, NULL, 14989, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:34:34', 'admin-1512262587-15122756745623047', 1, 0, '', NULL, NULL, NULL),
(55557, '2017-12-03 12:34:34', NULL, NULL, 14989, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:34:34', 'admin-1512262587-15122756745623047', 1, 1, 'SR', NULL, NULL, NULL),
(55558, '2017-12-03 12:34:34', NULL, NULL, 14989, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:34:34', 'admin-1512262587-15122756745623047', 1, 0, '', NULL, NULL, NULL),
(55559, '2017-12-03 12:48:51', NULL, NULL, 14992, 0, 153, '87', 'Wake Me Up!', 'egg to sunny side up', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:48:51', 'admin-1512262587-15122765310658879', 1, 0, '', NULL, NULL, NULL),
(55560, '2017-12-03 12:34:34', NULL, NULL, 14989, 0, 153, '87', 'Wake Me Up!', 'no pork', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:34:34', 'admin-1512262587-15122756745623047', 1, 0, '', NULL, NULL, NULL),
(55561, '2017-12-03 12:33:07', NULL, NULL, 14989, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:33:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55562, '2017-12-03 11:44:38', NULL, NULL, 14986, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:44:38', 'admin-1512262587-1512272678577343', 1, 1, 'SR', NULL, NULL, NULL),
(55563, '2017-12-03 11:44:38', NULL, NULL, 14986, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:44:38', 'admin-1512262587-1512272678577343', 1, 1, 'SR', NULL, NULL, NULL),
(55564, '2017-12-03 12:13:51', NULL, NULL, 14988, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:13:51', 'admin-1512262587-15122744310053267', 1, 1, 'SR', NULL, NULL, NULL),
(55565, '2017-12-03 12:13:45', NULL, NULL, 14988, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:13:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55566, '2017-12-03 12:12:49', NULL, NULL, 14987, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:12:49', 'admin-1512262587-15122743696223590', 1, 0, '', NULL, NULL, NULL),
(55567, '2017-12-03 12:12:49', NULL, NULL, 14987, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:12:49', 'admin-1512262587-15122743696223590', 1, 1, 'SR', NULL, NULL, NULL),
(55568, '2017-12-03 12:12:49', NULL, NULL, 14987, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:12:49', 'admin-1512262587-15122743696223590', 1, 0, '', NULL, NULL, NULL),
(55569, '2017-12-03 12:12:49', NULL, NULL, 14987, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:12:49', 'admin-1512262587-15122743696223590', 1, 0, '', NULL, NULL, NULL),
(55570, '2017-12-03 12:12:49', NULL, NULL, 14987, 0, 308, '244', 'AA Set - Chinese Ginger Garlic chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:12:49', 'admin-1512262587-15122743696223590', 1, 0, '', NULL, NULL, NULL),
(55571, '2017-12-03 12:12:49', NULL, NULL, 14987, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:12:49', 'admin-1512262587-15122743696223590', 1, 0, '', NULL, NULL, NULL),
(55572, '2017-12-03 11:53:42', NULL, NULL, 14982, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:53:42', 'admin-1512262587-15122732226046192', 1, 1, 'SR', NULL, NULL, NULL),
(55573, '2017-12-03 11:43:35', NULL, NULL, 14985, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:43:35', 'admin-1512262587-15122726155485637', 1, 0, '', NULL, NULL, NULL),
(55574, '2017-12-03 11:43:42', NULL, NULL, 14985, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:43:42', 'admin-1512262587-15122726221888728', 1, 0, '', NULL, NULL, NULL),
(55575, '2017-12-03 11:44:27', NULL, NULL, 14986, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:44:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55576, '2017-12-03 11:44:38', NULL, NULL, 14986, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:44:38', 'admin-1512262587-1512272678577343', 1, 0, '', NULL, NULL, NULL),
(55577, '2017-12-03 13:22:57', NULL, NULL, 14996, 0, 306, '242', 'AA Set - Chinese Rice Wine Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:22:57', 'admin-1512276983-1512278577147552', 1, 0, '', NULL, NULL, NULL),
(55578, '2017-12-03 11:43:35', NULL, NULL, 14985, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:43:35', 'admin-1512262587-15122726155485637', 1, 0, '', NULL, NULL, NULL),
(55579, '2017-12-03 13:34:53', NULL, NULL, 15000, 0, 306, '242', 'AA Set - Chinese Rice Wine Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:34:53', 'admin-1512276983-15122792937698294', 1, 0, '', NULL, NULL, NULL),
(55580, '2017-12-03 11:33:15', NULL, NULL, 14984, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:33:15', 'admin-1512262587-15122719956868693', 1, 0, '', NULL, NULL, NULL),
(55581, '2017-12-03 10:57:35', NULL, NULL, 14979, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:57:35', 'admin-1512262587-15122698557463441', 1, 0, '', NULL, NULL, NULL),
(55582, '2017-12-03 10:58:39', NULL, NULL, 14979, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:58:39', 'admin-1512262587-15122699196451256', 1, 1, 'SR', NULL, NULL, NULL),
(55583, '2017-12-03 10:58:39', NULL, NULL, 14979, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:58:39', 'admin-1512262587-15122699196451256', 1, 1, 'SR', NULL, NULL, NULL),
(55584, '2017-12-03 11:01:55', NULL, NULL, 14982, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:01:55', 'admin-1512262587-15122701154073310', 1, 0, '', NULL, NULL, NULL),
(55585, '2017-12-03 15:25:01', NULL, NULL, 15016, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 15:25:01', 'admin-1512276983-1512285901429915', 1, 1, 'SR', NULL, NULL, NULL),
(55586, '2017-12-03 11:30:57', NULL, NULL, 14984, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:30:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55587, '2017-12-03 10:48:28', NULL, NULL, 14977, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:48:28', 'admin-1512262587-15122693078788292', 1, 0, '', NULL, NULL, NULL),
(55588, '2017-12-03 10:49:08', NULL, NULL, 14977, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:49:08', 'admin-1512262587-15122693482393097', 1, 0, '', NULL, NULL, NULL),
(55589, '2017-12-03 10:48:28', NULL, NULL, 14977, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:48:28', 'admin-1512262587-15122693078788292', 1, 0, '', NULL, NULL, NULL),
(55590, '2017-12-03 10:48:28', NULL, NULL, 14977, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:48:28', 'admin-1512262587-15122693078788292', 1, 0, '', NULL, NULL, NULL),
(55591, '2017-12-03 10:48:28', NULL, NULL, 14977, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:48:28', 'admin-1512262587-15122693078788292', 1, 0, '', NULL, NULL, NULL),
(55592, '2017-12-03 10:49:08', NULL, NULL, 14977, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:49:08', 'admin-1512262587-15122693482393097', 1, 1, 'SR', NULL, NULL, NULL),
(55593, '2017-12-03 10:49:08', NULL, NULL, 14977, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:49:08', 'admin-1512262587-15122693482393097', 1, 1, 'SR', NULL, NULL, NULL),
(55594, '2017-12-03 12:55:09', NULL, NULL, 14994, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:55:09', 'admin-1512262587-15122769095983536', 1, 0, '', NULL, NULL, NULL),
(55595, '2017-12-03 10:49:08', NULL, NULL, 14977, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:49:08', 'admin-1512262587-15122693482393097', 1, 1, 'SR', NULL, NULL, NULL),
(55596, '2017-12-03 12:10:55', NULL, NULL, 14987, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.80, 0.0000, 0.0000, 15.80, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:10:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55597, '2017-12-03 10:32:28', NULL, NULL, 14975, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:32:28', 'admin-1512262587-15122683486489666', 1, 0, '', NULL, NULL, NULL),
(55598, '2017-12-03 10:32:28', NULL, NULL, 14975, 0, 154, '88', 'Daily Dose BLT', 'egg well done', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:32:28', 'admin-1512262587-15122683486489666', 1, 0, '', NULL, NULL, NULL),
(55599, '2017-12-03 10:32:28', NULL, NULL, 14975, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:32:28', 'admin-1512262587-15122683486489666', 1, 0, '', NULL, NULL, NULL),
(55600, '2017-12-03 10:32:28', NULL, NULL, 14975, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:32:28', 'admin-1512262587-15122683486489666', 1, 0, '', NULL, NULL, NULL),
(55601, '2017-12-03 11:01:16', NULL, NULL, 14982, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1512276983', 'admin', '2017-12-03 11:01:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55602, '2017-12-03 10:25:33', NULL, NULL, 14975, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.30, 0.0000, 0.0000, 16.30, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:25:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55603, '2017-12-03 10:59:55', NULL, NULL, 14981, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:59:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55604, '2017-12-03 10:59:45', NULL, NULL, 14975, 0, 181, '116', 'Open Food ', 'Toast with gula melaka', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:59:45', 'admin-1512262587-15122699849223263', 1, 0, '', NULL, NULL, NULL),
(55605, '2017-12-03 12:12:49', NULL, NULL, 14987, 0, 307, '243', 'AA Set - Flaming Hot & spicy Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 12:12:49', 'admin-1512262587-15122743696223590', 1, 0, '', NULL, NULL, NULL),
(55606, '2017-12-03 10:59:04', NULL, NULL, 14980, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:59:04', 'admin-1512262587-15122699443905427', 1, 1, 'SR', NULL, NULL, NULL),
(55607, '2017-12-03 10:58:53', NULL, NULL, 14980, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:58:53', 'admin-1512262587-15122699329669162', 1, 0, '', NULL, NULL, NULL),
(55608, '2017-12-03 14:26:33', NULL, NULL, 15012, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 14:26:33', 'admin-1512276983-15122823937282194', 1, 0, '', NULL, NULL, NULL),
(55609, '2017-12-03 10:49:21', NULL, NULL, 14978, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.80, 0.0000, 0.0000, 9.80, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:49:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55610, '2017-12-03 10:49:43', NULL, NULL, 14978, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:49:43', 'admin-1512262587-15122693837796373', 1, 0, '', NULL, NULL, NULL),
(55611, '2017-12-03 10:49:43', NULL, NULL, 14978, 0, 154, '88', 'Daily Dose BLT', 'scrambled egg', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:49:43', 'admin-1512262587-15122693837796373', 1, 0, '', NULL, NULL, NULL),
(55612, '2017-12-03 10:49:43', NULL, NULL, 14978, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:49:43', 'admin-1512262587-15122693837796373', 1, 0, '', NULL, NULL, NULL),
(55613, '2017-12-03 10:57:35', NULL, NULL, 14979, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:57:35', 'admin-1512262587-15122698557463441', 1, 1, 'SR', NULL, NULL, NULL),
(55614, '2017-12-03 10:49:43', NULL, NULL, 14978, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:49:43', 'admin-1512262587-15122693837796373', 1, 0, '', NULL, NULL, NULL),
(55615, '2017-12-03 10:49:43', NULL, NULL, 14978, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:49:43', 'admin-1512262587-15122693837796373', 1, 0, '', NULL, NULL, NULL),
(55616, '2017-12-03 10:48:28', NULL, NULL, 14977, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:48:28', 'admin-1512262587-15122693078788292', 1, 0, '', NULL, NULL, NULL),
(55617, '2017-12-03 10:48:01', NULL, NULL, 14977, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.80, 0.0000, 0.0000, 16.80, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:48:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55618, '2017-12-03 10:48:28', NULL, NULL, 14977, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:48:28', 'admin-1512262587-15122693078788292', 1, 0, '', NULL, NULL, NULL),
(55619, '2017-12-03 09:19:24', NULL, NULL, 14971, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1512276983', 'admin', '2017-12-03 09:19:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55620, '2017-12-03 09:21:45', NULL, NULL, 14971, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 09:21:45', 'admin-1512262587-15122641049849722', 1, 1, 'SR', NULL, NULL, NULL),
(55621, '2017-12-03 10:42:17', NULL, NULL, 14976, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:42:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55622, '2017-12-03 10:42:21', NULL, NULL, 14976, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:42:21', 'admin-1512262587-15122689412517770', 1, 1, 'SR', NULL, NULL, NULL),
(55623, '2017-12-03 13:23:45', NULL, NULL, 14997, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.69, 0.0000, 0.0000, 4.69, 1, '27', 1, '1512276983', 'admin', '2017-12-03 13:23:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55624, '2017-12-03 10:33:41', NULL, NULL, 14975, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:33:41', 'admin-1512262587-15122684215003491', 1, 1, 'SR', NULL, NULL, NULL),
(55625, '2017-12-03 10:33:41', NULL, NULL, 14975, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:33:41', 'admin-1512262587-15122684215003491', 1, 1, 'SR', NULL, NULL, NULL),
(55626, '2017-12-03 10:33:41', NULL, NULL, 14975, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:33:41', 'admin-1512262587-15122684215003491', 1, 0, '', NULL, NULL, NULL),
(55627, '2017-12-03 10:33:41', NULL, NULL, 14975, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:33:41', 'admin-1512262587-15122684215003491', 1, 1, 'SR', NULL, NULL, NULL),
(55628, '2017-12-03 10:11:27', NULL, NULL, 14974, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:11:27', 'admin-1512262587-15122670877598081', 1, 0, '', NULL, NULL, NULL),
(55629, '2017-12-03 10:13:02', NULL, NULL, 14974, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:13:02', 'admin-1512262587-15122671820516215', 1, 0, '', NULL, NULL, NULL),
(55630, '2017-12-03 09:21:45', NULL, NULL, 14971, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 09:21:45', 'admin-1512262587-15122641049849722', 1, 0, '', NULL, NULL, NULL),
(55631, '2017-12-03 09:21:35', NULL, NULL, 14971, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 09:21:35', 'admin-1512262587-1512264095027955', 1, 0, '', NULL, NULL, NULL),
(55632, '2017-12-03 09:21:45', NULL, NULL, 14971, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 09:21:45', 'admin-1512262587-15122641049849722', 1, 1, 'SR', NULL, NULL, NULL),
(55633, '2017-12-03 09:21:45', NULL, NULL, 14971, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 09:21:45', 'admin-1512262587-15122641049849722', 1, 0, '', NULL, NULL, NULL),
(55634, '2017-12-03 09:33:49', NULL, NULL, 14972, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1512276983', 'admin', '2017-12-03 09:33:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55635, '2017-12-03 09:34:47', NULL, NULL, 14972, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 09:34:47', 'admin-1512262587-15122648875083090', 1, 0, '', NULL, NULL, NULL),
(55636, '2017-12-03 10:11:27', NULL, NULL, 14974, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 10:11:27', 'admin-1512262587-15122670877598081', 1, 0, '', NULL, NULL, NULL),
(55637, '2017-12-03 09:34:47', NULL, NULL, 14972, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 09:34:47', 'admin-1512262587-15122648875083090', 1, 1, 'SR', NULL, NULL, NULL),
(55638, '2017-12-03 09:34:47', NULL, NULL, 14972, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512276983', 'admin', '2017-12-03 09:34:47', 'admin-1512262587-15122648875083090', 1, 0, '', NULL, NULL, NULL),
(55639, '2017-12-04 10:28:09', NULL, NULL, 15026, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 10:28:09', 'admin-1512348404-15123544892006115', 1, 0, '', NULL, NULL, '10.0'),
(55640, '2017-12-04 10:33:33', NULL, NULL, 15027, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1512348404', 'admin', '2017-12-04 10:33:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55641, '2017-12-04 10:33:50', NULL, NULL, 15027, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 10:33:50', 'admin-1512348404-15123548302546037', 1, 0, '', NULL, NULL, NULL),
(55642, '2017-12-04 14:31:14', NULL, NULL, 15043, 0, 181, '116', 'Open Food ', 'nO EGG NO SOUP', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:31:14', 'admin-1512348404-15123690741821276', 1, 0, '', NULL, NULL, NULL),
(55643, '2017-12-04 12:18:34', NULL, NULL, 15036, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1512348404', 'admin', '2017-12-04 12:18:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55644, '2017-12-04 14:18:38', NULL, NULL, 15040, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:18:38', 'admin-1512348404-15123683186464535', 1, 1, 'SR', NULL, NULL, NULL),
(55645, '2017-12-04 14:25:30', NULL, NULL, 15041, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:25:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55646, '2017-12-04 14:26:01', NULL, NULL, 15041, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:26:01', 'admin-1512348404-1512368761375439', 1, 0, '', NULL, NULL, NULL),
(55647, '2017-12-04 14:26:01', NULL, NULL, 15041, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:26:01', 'admin-1512348404-1512368761375439', 1, 0, '', NULL, NULL, NULL),
(55648, '2017-12-04 14:26:01', NULL, NULL, 15041, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:26:01', 'admin-1512348404-1512368761375439', 1, 0, '', NULL, NULL, NULL),
(55649, '2017-12-04 14:26:01', NULL, NULL, 15041, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:26:01', 'admin-1512348404-1512368761375439', 1, 0, '', NULL, NULL, NULL),
(55650, '2017-12-04 14:26:01', NULL, NULL, 15041, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:26:01', 'admin-1512348404-1512368761375439', 1, 1, 'SR', NULL, NULL, NULL),
(55651, '2017-12-04 14:57:43', NULL, NULL, 15042, 0, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:57:43', 'admin-1512348404-15123706631023984', 1, 1, 'SR', NULL, NULL, NULL),
(55652, '2017-12-04 14:30:54', NULL, NULL, 15043, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:30:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55653, '2017-12-04 14:31:14', NULL, NULL, 15043, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:31:14', 'admin-1512348404-15123690741821276', 1, 0, '', NULL, NULL, NULL),
(55654, '2017-12-04 11:01:55', NULL, NULL, 15029, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:01:55', 'admin-1512348404-15123565148093448', 1, 0, '', NULL, NULL, NULL),
(55655, '2017-12-04 14:31:19', NULL, NULL, 15034, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:31:19', 'admin-1512348404-15123690790031177', 1, 0, '', NULL, NULL, NULL),
(55656, '2017-12-04 14:43:41', NULL, NULL, 15044, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:43:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55657, '2017-12-04 14:26:01', NULL, NULL, 15041, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:26:01', 'admin-1512348404-1512368761375439', 1, 1, 'SR', NULL, NULL, NULL),
(55658, '2017-12-04 09:14:27', NULL, NULL, 15022, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 09:14:27', 'admin-1512348404-15123500675032852', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(55659, '2017-12-04 09:27:15', NULL, NULL, 15023, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1512348404', 'admin', '2017-12-04 09:27:15', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(55660, '2017-12-04 09:27:23', NULL, NULL, 15023, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 09:27:23', 'admin-1512348404-15123508433755126', 1, 0, '', NULL, NULL, '10.0'),
(55661, '2017-12-04 12:02:11', NULL, NULL, 15034, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 12:02:11', 'admin-1512348404-15123601310323132', 1, 1, 'SR', NULL, NULL, NULL),
(55662, '2017-12-04 11:42:46', NULL, NULL, 15032, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:42:46', 'admin-1512348404-15123589664984076', 1, 1, 'SR', NULL, NULL, NULL),
(55663, '2017-12-04 11:42:46', NULL, NULL, 15032, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:42:46', 'admin-1512348404-15123589664984076', 1, 1, 'SR', NULL, NULL, NULL),
(55664, '2017-12-04 11:42:46', NULL, NULL, 15032, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:42:46', 'admin-1512348404-15123589664984076', 1, 1, 'SR', NULL, NULL, NULL),
(55665, '2017-12-04 11:42:46', NULL, NULL, 15032, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:42:46', 'admin-1512348404-15123589664984076', 1, 1, 'SR', NULL, NULL, NULL),
(55666, '2017-12-04 11:43:04', NULL, NULL, 15032, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:43:04', 'admin-1512348404-15123589841893239', 1, 1, 'SR', NULL, NULL, NULL),
(55667, '2017-12-04 10:33:50', NULL, NULL, 15027, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 10:33:50', 'admin-1512348404-15123548302546037', 1, 0, '', NULL, NULL, NULL),
(55668, '2017-12-04 11:16:44', NULL, NULL, 15030, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:16:44', 'admin-1512348404-15123574039536733', 1, 0, '', NULL, NULL, NULL),
(55669, '2017-12-04 10:33:50', NULL, NULL, 15027, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 10:33:50', 'admin-1512348404-15123548302546037', 1, 0, '', NULL, NULL, NULL),
(55670, '2017-12-04 10:33:50', NULL, NULL, 15027, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 10:33:50', 'admin-1512348404-15123548302546037', 1, 1, 'SR', NULL, NULL, NULL),
(55671, '2017-12-04 13:41:15', NULL, NULL, 15038, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 13:41:15', 'admin-1512348404-1512366075471230', 1, 0, '', NULL, NULL, '10.0'),
(55672, '2017-12-04 13:40:46', NULL, NULL, 15038, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1512348404', 'admin', '2017-12-04 13:40:46', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(55673, '2017-12-04 12:02:11', NULL, NULL, 15034, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 12:02:11', 'admin-1512348404-15123601310323132', 1, 1, 'SR', NULL, NULL, NULL),
(55674, '2017-12-04 12:17:19', NULL, NULL, 15035, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1512348404', 'admin', '2017-12-04 12:17:19', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(55675, '2017-12-04 12:18:29', NULL, NULL, 15035, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 12:18:29', 'admin-1512348404-15123611093851515', 1, 0, '', NULL, NULL, '10.0'),
(55676, '2017-12-04 12:18:29', NULL, NULL, 15035, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 12:18:29', 'admin-1512348404-15123611093851515', 1, 0, '', NULL, NULL, '10.0'),
(55677, '2017-12-04 12:18:29', NULL, NULL, 15035, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 12:18:29', 'admin-1512348404-15123611093851515', 1, 1, 'SR', NULL, NULL, '10.0'),
(55678, '2017-12-04 12:18:29', NULL, NULL, 15035, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 12:18:29', 'admin-1512348404-15123611093851515', 1, 1, 'SR', NULL, NULL, '10.0'),
(55679, '2017-12-04 12:57:41', NULL, NULL, 15037, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 12:57:41', 'admin-1512348404-15123634613272870', 1, 1, 'SR', NULL, NULL, NULL),
(55680, '2017-12-04 13:41:15', NULL, NULL, 15038, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 13:41:15', 'admin-1512348404-1512366075471230', 1, 1, 'SR', NULL, NULL, '10.0'),
(55681, '2017-12-04 17:16:49', NULL, NULL, 15047, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 17:16:49', 'admin-1512348404-15123790095768346', 1, 1, 'SR', NULL, NULL, NULL),
(55682, '2017-12-04 17:16:44', NULL, NULL, 15047, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1512348404', 'admin', '2017-12-04 17:16:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55683, '2017-12-04 15:18:58', NULL, NULL, 15046, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 15:18:58', 'admin-1512348404-15123719387905760', 1, 1, 'SR', NULL, NULL, NULL),
(55684, '2017-12-04 15:18:56', NULL, NULL, 15046, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1512348404', 'admin', '2017-12-04 15:18:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55685, '2017-12-04 15:18:53', NULL, NULL, 15045, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 15:18:53', 'admin-1512348404-15123719334943675', 1, 1, 'SR', NULL, NULL, NULL),
(55686, '2017-12-04 15:16:30', NULL, NULL, 15045, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1512348404', 'admin', '2017-12-04 15:16:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55687, '2017-12-04 15:16:35', NULL, NULL, 15045, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 15:16:35', 'admin-1512348404-1512371795749278', 1, 0, '', NULL, NULL, NULL),
(55688, '2017-12-04 14:43:48', NULL, NULL, 15044, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:43:48', 'admin-1512348404-15123698286493329', 1, 0, '', NULL, NULL, NULL),
(55689, '2017-12-04 14:43:48', NULL, NULL, 15044, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:43:48', 'admin-1512348404-15123698286493329', 1, 1, 'SR', NULL, NULL, NULL),
(55690, '2017-12-04 11:46:24', NULL, NULL, 15033, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:46:24', 'admin-1512348404-15123591838698491', 1, 0, '', NULL, NULL, NULL),
(55691, '2017-12-04 11:32:32', NULL, NULL, 15031, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:32:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55692, '2017-12-04 11:32:38', NULL, NULL, 15031, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:32:38', 'admin-1512348404-1512358358100110', 1, 1, 'SR', NULL, NULL, NULL),
(55693, '2017-12-04 11:32:38', NULL, NULL, 15031, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:32:38', 'admin-1512348404-1512358358100110', 1, 0, '', NULL, NULL, NULL),
(55694, '2017-12-04 11:42:14', NULL, NULL, 15032, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 19.90, 0.0000, 0.0000, 19.90, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:42:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55695, '2017-12-04 11:42:46', NULL, NULL, 15032, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:42:46', 'admin-1512348404-15123589664984076', 1, 0, '', NULL, NULL, NULL),
(55696, '2017-12-04 11:42:46', NULL, NULL, 15032, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:42:46', 'admin-1512348404-15123589664984076', 1, 0, '', NULL, NULL, NULL),
(55697, '2017-12-04 14:18:35', NULL, NULL, 15040, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:18:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55698, '2017-12-04 11:02:13', NULL, NULL, 15030, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:02:13', 'admin-1512348404-15123565328963258', 1, 1, 'SR', NULL, NULL, NULL),
(55699, '2017-12-04 11:42:46', NULL, NULL, 15032, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:42:46', 'admin-1512348404-15123589664984076', 1, 0, '', NULL, NULL, NULL),
(55700, '2017-12-04 11:42:46', NULL, NULL, 15032, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:42:46', 'admin-1512348404-15123589664984076', 1, 0, '', NULL, NULL, NULL),
(55701, '2017-12-04 13:41:15', NULL, NULL, 15038, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 13:41:15', 'admin-1512348404-1512366075471230', 1, 0, '', NULL, NULL, '10.0'),
(55702, '2017-12-04 14:28:26', NULL, NULL, 15042, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:28:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55703, '2017-12-04 14:28:32', NULL, NULL, 15042, 0, 299, '235', 'Iced Salted Caramel Machiato', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:28:32', 'admin-1512348404-1512368912363835', 1, 0, '', NULL, NULL, NULL),
(55704, '2017-12-04 12:02:04', NULL, NULL, 15034, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1512348404', 'admin', '2017-12-04 12:02:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55705, '2017-12-04 14:04:06', NULL, NULL, 15039, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:04:06', 'admin-1512348404-15123674460941515', 1, 1, 'SR', NULL, NULL, NULL),
(55706, '2017-12-04 14:04:06', NULL, NULL, 15039, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:04:06', 'admin-1512348404-15123674460941515', 1, 0, '', NULL, NULL, NULL),
(55707, '2017-12-04 14:03:57', NULL, NULL, 15039, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:03:57', 'admin-1512348404-15123674378146676', 1, 0, '', NULL, NULL, NULL),
(55708, '2017-12-04 14:02:13', NULL, NULL, 15039, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:02:13', 'admin-1512348404-15123673334719471', 1, 0, '', NULL, NULL, NULL),
(55709, '2017-12-04 14:02:13', NULL, NULL, 15039, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:02:13', 'admin-1512348404-15123673334719471', 1, 0, '', NULL, NULL, NULL),
(55710, '2017-12-04 14:00:55', NULL, NULL, 15039, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:00:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55711, '2017-12-04 12:57:41', NULL, NULL, 15037, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 12:57:41', 'admin-1512348404-15123634613272870', 1, 1, 'SR', NULL, NULL, NULL),
(55712, '2017-12-04 12:18:43', NULL, NULL, 15036, 0, 335, '271', 'Iced Honey Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 12:18:43', 'admin-1512348404-15123611230714240', 1, 0, '', NULL, NULL, NULL),
(55713, '2017-12-04 12:18:43', NULL, NULL, 15036, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 12:18:43', 'admin-1512348404-15123611230714240', 1, 0, '', NULL, NULL, NULL),
(55714, '2017-12-04 09:33:28', NULL, NULL, 15025, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 09:33:28', 'admin-1512348404-15123512079477869', 1, 1, 'SR', NULL, NULL, NULL),
(55715, '2017-12-04 09:59:06', NULL, NULL, 15024, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 09:59:06', 'admin-1512348404-15123527459175755', 1, 1, 'SR', NULL, NULL, NULL),
(55716, '2017-12-04 11:46:23', NULL, NULL, 15033, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:46:23', 'admin-1512348404-15123591838698491', 1, 0, '', NULL, NULL, NULL),
(55717, '2017-12-04 14:31:14', NULL, NULL, 15043, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 14:31:14', 'admin-1512348404-15123690741821276', 1, 1, 'SR', NULL, NULL, NULL),
(55718, '2017-12-04 12:57:35', NULL, NULL, 15037, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1512348404', 'admin', '2017-12-04 12:57:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55719, '2017-12-04 11:46:18', NULL, NULL, 15033, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:46:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55720, '2017-12-04 11:43:20', NULL, NULL, 15032, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:43:20', 'admin-1512348404-15123590001016478', 1, 0, '', NULL, NULL, NULL),
(55721, '2017-12-04 11:42:46', NULL, NULL, 15032, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:42:46', 'admin-1512348404-15123589664984076', 1, 1, 'SR', NULL, NULL, NULL),
(55722, '2017-12-04 11:42:46', NULL, NULL, 15032, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:42:46', 'admin-1512348404-15123589664984076', 1, 0, '', NULL, NULL, NULL),
(55723, '2017-12-04 11:42:46', NULL, NULL, 15032, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:42:46', 'admin-1512348404-15123589664984076', 1, 0, '', NULL, NULL, NULL),
(55724, '2017-12-04 11:42:46', NULL, NULL, 15032, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:42:46', 'admin-1512348404-15123589664984076', 1, 0, '', NULL, NULL, NULL),
(55725, '2017-12-04 11:02:08', NULL, NULL, 15030, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:02:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55726, '2017-12-04 11:01:54', NULL, NULL, 15029, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:01:54', 'admin-1512348404-15123565148093448', 1, 1, 'SR', NULL, NULL, NULL),
(55727, '2017-12-04 10:33:50', NULL, NULL, 15027, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 10:33:50', 'admin-1512348404-15123548302546037', 1, 1, 'SR', NULL, NULL, NULL),
(55728, '2017-12-04 11:01:18', NULL, NULL, 15028, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:01:18', 'admin-1512348404-15123564787077450', 1, 1, 'SR', NULL, NULL, NULL),
(55729, '2017-12-04 11:01:45', NULL, NULL, 15029, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:01:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55730, '2017-12-04 11:01:12', NULL, NULL, 15028, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1512348404', 'admin', '2017-12-04 11:01:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55731, '2017-12-04 10:33:50', NULL, NULL, 15027, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 10:33:50', 'admin-1512348404-15123548302546037', 1, 1, 'SR', NULL, NULL, NULL),
(55732, '2017-12-04 09:33:28', NULL, NULL, 15025, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 09:33:28', 'admin-1512348404-15123512079477869', 1, 0, '', NULL, NULL, NULL),
(55733, '2017-12-04 09:33:28', NULL, NULL, 15025, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 09:33:28', 'admin-1512348404-15123512079477869', 1, 0, '', NULL, NULL, NULL),
(55734, '2017-12-04 09:33:28', NULL, NULL, 15025, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 09:33:28', 'admin-1512348404-15123512079477869', 1, 0, '', NULL, NULL, NULL),
(55735, '2017-12-04 09:33:28', NULL, NULL, 15025, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 09:33:28', 'admin-1512348404-15123512079477869', 1, 0, '', NULL, NULL, NULL),
(55736, '2017-12-04 10:33:50', NULL, NULL, 15027, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 10:33:50', 'admin-1512348404-15123548302546037', 1, 0, '', NULL, NULL, NULL),
(55737, '2017-12-04 10:28:09', NULL, NULL, 15026, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 10:28:09', 'admin-1512348404-15123544892006115', 1, 0, '', NULL, NULL, '10.0'),
(55738, '2017-12-04 10:28:09', NULL, NULL, 15026, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 10:28:09', 'admin-1512348404-15123544892006115', 1, 1, 'SR', NULL, NULL, '10.0'),
(55739, '2017-12-04 10:27:57', NULL, NULL, 15026, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1512348404', 'admin', '2017-12-04 10:27:57', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(55740, '2017-12-04 10:28:09', NULL, NULL, 15026, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 10:28:09', 'admin-1512348404-15123544892006115', 1, 0, '', NULL, NULL, '10.0'),
(55741, '2017-12-04 10:28:09', NULL, NULL, 15026, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 10:28:09', 'admin-1512348404-15123544892006115', 1, 0, '', NULL, NULL, '10.0'),
(55742, '2017-12-04 09:14:20', NULL, NULL, 15022, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 09:14:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55743, '2017-12-04 09:33:09', NULL, NULL, 15025, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1512348404', 'admin', '2017-12-04 09:33:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55744, '2017-12-04 09:28:40', NULL, NULL, 15024, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 09:28:40', 'admin-1512348404-15123509205211824', 1, 1, 'SR', NULL, NULL, NULL),
(55745, '2017-12-04 09:28:37', NULL, NULL, 15024, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1512348404', 'admin', '2017-12-04 09:28:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55746, '2017-12-04 09:27:23', NULL, NULL, 15023, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 09:27:23', 'admin-1512348404-15123508433755126', 1, 1, 'SR', NULL, NULL, '10.0'),
(55747, '2017-12-04 09:14:27', NULL, NULL, 15022, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 09:14:27', 'admin-1512348404-15123500675032852', 1, 0, '', NULL, NULL, NULL),
(55748, '2017-12-04 09:14:01', NULL, NULL, 15021, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 09:14:01', 'admin-1512348404-1512350040872493', 1, 1, 'SR', NULL, NULL, NULL),
(55749, '2017-12-04 09:13:11', NULL, NULL, 15021, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1512348404', 'admin', '2017-12-04 09:13:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55750, '2017-12-04 09:14:01', NULL, NULL, 15021, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512348404', 'admin', '2017-12-04 09:14:01', 'admin-1512348404-1512350040872493', 1, 0, '', NULL, NULL, NULL),
(55751, '2017-12-06 10:08:59', NULL, NULL, 15051, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 10:08:59', 'admin-1512522216-15125261395342861', 1, 1, 'SR', NULL, NULL, NULL),
(55752, '2017-12-06 10:08:59', NULL, NULL, 15051, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 10:08:59', 'admin-1512522216-15125261395342861', 1, 0, '', NULL, NULL, NULL),
(55753, '2017-12-06 09:24:25', NULL, NULL, 15050, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 09:24:25', 'admin-1512522216-15125234656969451', 1, 1, 'SR', NULL, NULL, NULL),
(55754, '2017-12-06 14:42:29', NULL, NULL, 15070, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 14:42:29', 'admin-1512522216-15125425488786436', 1, 1, 'SR', NULL, NULL, NULL),
(55755, '2017-12-06 14:26:48', NULL, NULL, 15069, 0, 181, '116', 'Open Food ', 'fried noodle', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 14:26:48', 'admin-1512522216-15125416085223515', 1, 0, '', NULL, NULL, '10.0'),
(55756, '2017-12-06 14:26:48', NULL, NULL, 15069, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 14:26:48', 'admin-1512522216-15125416085223515', 1, 0, '', NULL, NULL, '10.0'),
(55757, '2017-12-06 14:38:16', NULL, NULL, 15070, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1512522216', 'admin', '2017-12-06 14:38:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55758, '2017-12-06 14:42:29', NULL, NULL, 15070, 0, 212, '146', 'Pork Bacon Salad', 'no corn', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 14:42:29', 'admin-1512522216-15125425488786436', 1, 0, '', NULL, NULL, NULL),
(55759, '2017-12-06 14:42:29', NULL, NULL, 15070, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 14:42:29', 'admin-1512522216-15125425488786436', 1, 1, 'SR', NULL, NULL, NULL),
(55760, '2017-12-06 00:00:00', NULL, NULL, 15065, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 11:57:16', 'admin-1512522216-15125326360144342', 1, 0, '', NULL, NULL, NULL),
(55761, '2017-12-06 11:59:35', NULL, NULL, 15057, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1512522216', 'admin', '2017-12-06 11:59:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55762, '2017-12-06 13:11:18', NULL, NULL, 15061, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1512522216', 'admin', '2017-12-06 13:11:18', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(55763, '2017-12-06 13:11:24', NULL, NULL, 15061, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 13:11:24', 'admin-1512522216-15125370841139513', 1, 0, '', NULL, NULL, '10.0'),
(55764, '2017-12-06 09:21:42', NULL, NULL, 15049, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1512522216', 'admin', '2017-12-06 09:21:42', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(55765, '2017-12-06 09:24:05', NULL, NULL, 15049, 0, 181, '116', 'Open Food ', 'junior blt', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 09:24:05', 'admin-1512522216-1512523445155691', 1, 0, '', NULL, NULL, '10.0'),
(55766, '2017-12-06 09:21:53', NULL, NULL, 15049, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 09:21:53', 'admin-1512522216-1512523313635995', 1, 1, 'SR', NULL, NULL, '10.0'),
(55767, '2017-12-06 00:00:00', NULL, NULL, 15065, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 11:57:16', 'admin-1512522216-15125326360144342', 1, 1, 'SR', NULL, NULL, NULL),
(55768, '2017-12-06 13:31:07', NULL, NULL, 15066, 0, 322, '258', 'Yuzu Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 13:31:07', 'admin-1512522216-15125382667962132', 1, 0, '', NULL, NULL, NULL),
(55769, '2017-12-06 13:31:07', NULL, NULL, 15066, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 13:31:07', 'admin-1512522216-15125382667962132', 1, 1, 'SR', NULL, NULL, NULL),
(55770, '2017-12-06 13:40:51', NULL, NULL, 15061, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 13:40:51', 'admin-1512522216-1512538851431727', 1, 1, 'SR', NULL, NULL, '10.0'),
(55771, '2017-12-06 12:00:14', NULL, NULL, 15057, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 12:00:14', 'admin-1512522216-15125328138878547', 1, 0, '', NULL, NULL, NULL),
(55772, '2017-12-06 11:56:55', NULL, NULL, 15056, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1512522216', 'admin', '2017-12-06 11:56:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55773, '2017-12-06 10:24:24', NULL, NULL, 15052, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 10:24:24', 'admin-1512522216-15125270646203566', 1, 1, 'SR', 1, NULL, NULL),
(55774, '2017-12-06 10:36:25', NULL, NULL, 15053, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1512522216', 'admin', '2017-12-06 10:36:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55775, '2017-12-06 10:36:33', NULL, NULL, 15053, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 10:36:33', 'admin-1512522216-15125277933289685', 1, 0, '', NULL, NULL, NULL),
(55776, '2017-12-06 10:36:33', NULL, NULL, 15053, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 10:36:33', 'admin-1512522216-15125277933289685', 1, 0, '', NULL, NULL, NULL),
(55777, '2017-12-06 13:31:06', NULL, NULL, 15066, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 13:31:07', 'admin-1512522216-15125382667962132', 1, 0, '', NULL, NULL, NULL),
(55778, '2017-12-06 12:15:05', NULL, NULL, 15058, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 12:15:05', 'admin-1512522216-15125337050957159', 1, 1, 'SR', NULL, NULL, NULL),
(55779, '2017-12-06 12:19:34', NULL, NULL, 15059, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1512522216', 'admin', '2017-12-06 12:19:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55780, '2017-12-06 12:24:02', NULL, NULL, 15059, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 12:24:02', 'admin-1512522216-15125342421779457', 1, 0, '', NULL, NULL, NULL),
(55781, '2017-12-06 12:24:02', NULL, NULL, 15059, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 12:24:02', 'admin-1512522216-15125342421779457', 1, 0, '', NULL, NULL, NULL),
(55782, '2017-12-06 12:24:02', NULL, NULL, 15059, 0, 325, '261', 'Strawberry Chocolate Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 12:24:02', 'admin-1512522216-15125342421779457', 1, 0, '', NULL, NULL, NULL),
(55783, '2017-12-06 12:44:40', NULL, NULL, 15060, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1512522216', 'admin', '2017-12-06 12:44:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55784, '2017-12-06 12:44:52', NULL, NULL, 15060, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 12:44:52', 'admin-1512522216-15125354920339965', 1, 1, 'SR', NULL, NULL, NULL),
(55785, '2017-12-06 13:30:50', NULL, NULL, 15066, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1512522216', 'admin', '2017-12-06 13:30:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55786, '2017-12-06 13:31:06', NULL, NULL, 15066, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 13:31:06', 'admin-1512522216-15125382667962132', 1, 0, '', NULL, NULL, NULL),
(55787, '2017-12-06 00:00:00', NULL, NULL, 15064, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 11:57:16', 'admin-1512522216-15125326360144342', 1, 0, '', NULL, NULL, NULL),
(55788, '2017-12-06 15:51:51', NULL, NULL, 15072, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 15:51:51', 'admin-1512522216-1512546711343166', 1, 1, 'SR', NULL, NULL, NULL),
(55789, '2017-12-06 15:51:51', NULL, NULL, 15072, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 15:51:51', 'admin-1512522216-1512546711343166', 1, 1, 'SR', NULL, NULL, NULL),
(55790, '2017-12-06 15:51:44', NULL, NULL, 15072, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1512522216', 'admin', '2017-12-06 15:51:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55791, '2017-12-06 15:43:40', NULL, NULL, 15071, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 15:43:40', 'admin-1512522216-15125462199022714', 1, 0, '', NULL, NULL, '10.0'),
(55792, '2017-12-06 15:43:36', NULL, NULL, 15071, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1512522216', 'admin', '2017-12-06 15:43:36', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(55793, '2017-12-06 13:11:47', NULL, NULL, 15062, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1512522216', 'admin', '2017-12-06 13:11:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55794, '2017-12-06 14:26:12', NULL, NULL, 15069, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1512522216', 'admin', '2017-12-06 14:26:12', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(55795, '2017-12-06 14:14:47', NULL, NULL, 15068, 0, 154, '88', 'Daily Dose BLT', 'Takeaway', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 14:14:47', 'admin-1512522216-15125408874377392', 1, 0, '', 1, NULL, NULL),
(55796, '2017-12-06 13:44:45', NULL, NULL, 15061, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 13:44:45', 'admin-1512522216-15125390850254141', 1, 0, '', NULL, NULL, '10.0'),
(55797, '2017-12-06 13:31:06', NULL, NULL, 15066, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 13:31:06', 'admin-1512522216-15125382667962132', 1, 0, '', NULL, NULL, NULL),
(55798, '2017-12-06 13:12:21', NULL, NULL, 15062, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 13:12:21', 'admin-1512522216-15125371414379251', 1, 1, 'SR', NULL, NULL, NULL),
(55799, '2017-12-06 13:13:44', NULL, NULL, 15063, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1512522216', 'admin', '2017-12-06 13:13:44', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(55800, '2017-12-06 13:13:50', NULL, NULL, 15063, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 13:13:50', 'admin-1512522216-15125372305371536', 1, 0, '', NULL, NULL, '10.0'),
(55801, '2017-12-06 13:13:50', NULL, NULL, 15063, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 13:13:50', 'admin-1512522216-15125372305371536', 1, 1, 'SR', NULL, NULL, '10.0'),
(55802, '2017-12-06 13:14:25', NULL, NULL, 15062, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 13:14:25', 'admin-1512522216-15125372654574792', 1, 1, 'SR', NULL, NULL, NULL),
(55803, '2017-12-06 13:14:25', NULL, NULL, 15062, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 13:14:25', 'admin-1512522216-15125372654574792', 1, 1, 'SR', NULL, NULL, NULL),
(55804, '2017-12-06 13:14:25', NULL, NULL, 15062, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 13:14:25', 'admin-1512522216-15125372654574792', 1, 0, '', NULL, NULL, NULL),
(55805, '2017-12-06 12:44:52', NULL, NULL, 15060, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 12:44:52', 'admin-1512522216-15125354920339965', 1, 1, 'SR', NULL, NULL, NULL),
(55806, '2017-12-06 12:03:33', NULL, NULL, 15057, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 12:03:33', 'admin-1512522216-15125330138352539', 1, 1, 'SR', NULL, NULL, NULL),
(55807, '2017-12-06 13:12:21', NULL, NULL, 15062, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 13:12:21', 'admin-1512522216-15125371414379251', 1, 0, '', NULL, NULL, NULL),
(55808, '2017-12-06 12:15:01', NULL, NULL, 15058, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1512522216', 'admin', '2017-12-06 12:15:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55809, '2017-12-06 10:08:59', NULL, NULL, 15051, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 10:08:59', 'admin-1512522216-15125261395342861', 1, 1, 'SR', NULL, NULL, NULL),
(55810, '2017-12-06 09:35:43', NULL, NULL, 15050, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 09:35:43', 'admin-1512522216-15125241437817544', 1, 0, '', NULL, NULL, NULL),
(55811, '2017-12-06 11:28:32', NULL, NULL, 15055, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1512522216', 'admin', '2017-12-06 11:28:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55812, '2017-12-06 12:03:33', NULL, NULL, 15057, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 12:03:33', 'admin-1512522216-15125330138352539', 1, 0, '', NULL, NULL, NULL),
(55813, '2017-12-06 12:01:57', NULL, NULL, 15057, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 12:01:57', 'admin-1512522216-15125329176418643', 1, 1, 'SR', NULL, NULL, NULL),
(55814, '2017-12-06 00:00:00', NULL, NULL, 15064, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 11:57:16', 'admin-1512522216-15125326360144342', 1, 0, '', NULL, NULL, NULL),
(55815, '2017-12-06 11:57:16', NULL, NULL, 15056, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 11:57:16', 'admin-1512522216-15125326360144342', 1, 1, 'SR', NULL, NULL, NULL),
(55816, '2017-12-06 13:15:14', NULL, NULL, 15064, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1512522216', 'admin', '2017-12-06 13:15:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55817, '2017-12-06 13:16:25', NULL, NULL, 15065, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1512522216', 'admin', '2017-12-06 13:16:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55818, '2017-12-06 11:57:16', NULL, NULL, 15056, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 11:57:16', 'admin-1512522216-15125326360144342', 1, 0, '', NULL, NULL, NULL),
(55819, '2017-12-06 11:28:35', NULL, NULL, 15055, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 11:28:35', 'admin-1512522216-15125309153677432', 1, 1, 'SR', NULL, NULL, NULL),
(55820, '2017-12-06 11:13:13', NULL, NULL, 15054, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 11:13:13', 'admin-1512522216-15125299929432215', 1, 1, 'SR', NULL, NULL, NULL),
(55821, '2017-12-06 11:13:13', NULL, NULL, 15054, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 11:13:13', 'admin-1512522216-15125299929432215', 1, 1, 'SR', NULL, NULL, NULL),
(55822, '2017-12-06 11:13:13', NULL, NULL, 15054, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 11:13:13', 'admin-1512522216-15125299929432215', 1, 0, '', NULL, NULL, NULL),
(55823, '2017-12-06 11:12:59', NULL, NULL, 15054, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1512522216', 'admin', '2017-12-06 11:12:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55824, '2017-12-06 10:08:59', NULL, NULL, 15051, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 10:08:59', 'admin-1512522216-15125261395342861', 1, 0, '', NULL, NULL, NULL),
(55825, '2017-12-06 10:08:36', NULL, NULL, 15051, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1512522216', 'admin', '2017-12-06 10:08:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55826, '2017-12-06 09:53:13', NULL, NULL, 15050, 0, 156, '90', 'House Cheddar Omelet', 'add bacon', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 09:53:13', 'admin-1512522216-15125251929661174', 1, 0, '', NULL, NULL, NULL),
(55827, '2017-12-06 09:09:47', NULL, NULL, 15048, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 09:09:47', 'admin-1512522216-15125225869546386', 1, 1, 'SR', NULL, NULL, NULL),
(55828, '2017-12-06 13:12:21', NULL, NULL, 15062, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 13:12:21', 'admin-1512522216-15125371414379251', 1, 0, '', NULL, NULL, NULL),
(55829, '2017-12-06 10:36:33', NULL, NULL, 15053, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 10:36:33', 'admin-1512522216-15125277933289685', 1, 1, 'SR', NULL, NULL, NULL),
(55830, '2017-12-06 09:35:43', NULL, NULL, 15050, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 09:35:43', 'admin-1512522216-15125241437817544', 1, 0, '', NULL, NULL, NULL),
(55831, '2017-12-06 09:35:43', NULL, NULL, 15050, 0, 328, '264', 'Basic Blueberries Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 09:35:43', 'admin-1512522216-15125241437817544', 1, 0, '', NULL, NULL, NULL),
(55832, '2017-12-06 09:24:25', NULL, NULL, 15050, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 09:24:25', 'admin-1512522216-15125234656969451', 1, 1, 'SR', NULL, NULL, NULL),
(55833, '2017-12-06 09:24:25', NULL, NULL, 15050, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 09:24:25', 'admin-1512522216-15125234656969451', 1, 1, 'SR', NULL, NULL, NULL),
(55834, '2017-12-06 09:24:12', NULL, NULL, 15050, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.80, 0.0000, 0.0000, 9.80, 1, '27', 1, '1512522216', 'admin', '2017-12-06 09:24:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55835, '2017-12-06 09:09:39', NULL, NULL, 15048, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1512522216', 'admin', '2017-12-06 09:09:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55836, '2017-12-06 09:09:47', NULL, NULL, 15048, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 09:09:47', 'admin-1512522216-15125225869546386', 1, 0, '', NULL, NULL, NULL),
(55837, '2017-12-06 09:09:47', NULL, NULL, 15048, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512522216', 'admin', '2017-12-06 09:09:47', 'admin-1512522216-15125225869546386', 1, 0, '', NULL, NULL, NULL),
(55838, '2017-12-07 14:18:09', NULL, NULL, 15089, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 14:18:09', 'admin-1512607716-15126274890593284', 1, 0, '', NULL, NULL, NULL),
(55839, '2017-12-07 14:18:09', NULL, NULL, 15089, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 14:18:09', 'admin-1512607716-15126274890593284', 1, 0, '', NULL, NULL, NULL),
(55840, '2017-12-07 14:18:09', NULL, NULL, 15089, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 14:18:09', 'admin-1512607716-15126274890593284', 1, 0, '', NULL, NULL, NULL),
(55841, '2017-12-07 14:18:09', NULL, NULL, 15089, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 14:18:09', 'admin-1512607716-15126274890593284', 1, 0, '', NULL, NULL, NULL),
(55842, '2017-12-07 14:20:33', NULL, NULL, 15086, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 14:20:33', 'admin-1512607716-15126276330512635', 1, 1, 'SR', NULL, NULL, '10.0');
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(55843, '2017-12-07 12:43:23', NULL, NULL, 15085, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1512607716', 'admin', '2017-12-07 12:43:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55844, '2017-12-07 12:49:28', NULL, NULL, 15085, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 12:49:28', 'admin-1512607716-15126221688163280', 1, 0, '', NULL, NULL, NULL),
(55845, '2017-12-07 10:04:55', NULL, NULL, 15076, 0, 328, '264', 'Basic Blueberries Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 10:04:55', 'admin-1512607716-15126122957539549', 1, 0, '', NULL, NULL, NULL),
(55846, '2017-12-07 10:04:55', NULL, NULL, 15076, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 10:04:55', 'admin-1512607716-15126122957539549', 1, 1, 'SR', NULL, NULL, NULL),
(55847, '2017-12-07 10:15:59', NULL, NULL, 15077, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1512607716', 'admin', '2017-12-07 10:15:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55848, '2017-12-07 11:13:47', NULL, NULL, 15081, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 11:13:47', 'admin-1512607716-1512616427015943', 1, 0, '', NULL, NULL, NULL),
(55849, '2017-12-07 10:33:46', NULL, NULL, 15079, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 10:33:46', 'admin-1512607716-1512614025904698', 1, 0, '', NULL, NULL, NULL),
(55850, '2017-12-07 10:33:46', NULL, NULL, 15079, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 10:33:46', 'admin-1512607716-1512614025904698', 1, 0, '', NULL, NULL, NULL),
(55851, '2017-12-07 10:33:46', NULL, NULL, 15079, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 10:33:46', 'admin-1512607716-1512614025904698', 1, 1, 'SR', NULL, NULL, NULL),
(55852, '2017-12-07 14:13:27', NULL, NULL, 15088, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 14:13:27', 'admin-1512607716-15126272070344765', 1, 1, 'SR', NULL, NULL, NULL),
(55853, '2017-12-07 12:49:28', NULL, NULL, 15085, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 12:49:28', 'admin-1512607716-15126221688163280', 1, 0, '', NULL, NULL, NULL),
(55854, '2017-12-07 13:12:12', NULL, NULL, 15085, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 13:12:12', 'admin-1512607716-15126235328398280', 1, 0, '', NULL, NULL, NULL),
(55855, '2017-12-07 13:12:12', NULL, NULL, 15085, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 13:12:12', 'admin-1512607716-15126235328398280', 1, 0, '', NULL, NULL, NULL),
(55856, '2017-12-07 13:19:40', NULL, NULL, 15086, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1512607716', 'admin', '2017-12-07 13:19:40', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(55857, '2017-12-07 13:19:49', NULL, NULL, 15086, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 13:19:49', 'admin-1512607716-15126239891934762', 1, 0, '', NULL, NULL, '10.0'),
(55858, '2017-12-07 11:52:21', NULL, NULL, 15083, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 11:52:21', 'admin-1512607716-15126187414402344', 1, 1, 'SR', NULL, NULL, NULL),
(55859, '2017-12-07 14:12:27', NULL, NULL, 15088, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1512607716', 'admin', '2017-12-07 14:12:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55860, '2017-12-07 14:46:41', NULL, NULL, 15090, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1512607716', 'admin', '2017-12-07 14:46:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55861, '2017-12-07 14:56:59', NULL, NULL, 15089, 0, 182, '117', 'Open Drinks ', 'Rootbeer', 'Cold Drinks', 'Fresh Juice', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 14:56:59', 'admin-1512607716-15126298195006127', 1, 0, '', NULL, NULL, NULL),
(55862, '2017-12-07 15:43:38', NULL, NULL, 15091, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1512607716', 'admin', '2017-12-07 15:43:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55863, '2017-12-07 15:43:48', NULL, NULL, 15091, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 15:43:48', 'admin-1512607716-15126326284971021', 1, 1, 'SR', NULL, NULL, NULL),
(55864, '2017-12-07 15:43:48', NULL, NULL, 15091, 0, 181, '116', 'Open Food ', 'apple', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 15:43:48', 'admin-1512607716-15126326284971021', 1, 0, '', NULL, NULL, NULL),
(55865, '2017-12-07 14:46:47', NULL, NULL, 15090, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 14:46:47', 'admin-1512607716-15126292076816420', 1, 0, '', NULL, NULL, NULL),
(55866, '2017-12-07 14:13:27', NULL, NULL, 15088, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 14:13:27', 'admin-1512607716-15126272070344765', 1, 1, 'SR', NULL, NULL, NULL),
(55867, '2017-12-07 14:16:41', NULL, NULL, 15089, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1512607716', 'admin', '2017-12-07 14:16:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55868, '2017-12-07 14:13:27', NULL, NULL, 15088, 0, 153, '87', 'Wake Me Up!', 'No vege', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 14:13:27', 'admin-1512607716-15126272070344765', 1, 0, '', NULL, NULL, NULL),
(55869, '2017-12-07 14:13:27', NULL, NULL, 15088, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 14:13:27', 'admin-1512607716-15126272070344765', 1, 1, 'SR', NULL, NULL, NULL),
(55870, '2017-12-07 14:13:27', NULL, NULL, 15088, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 14:13:27', 'admin-1512607716-15126272070344765', 1, 1, 'SR', NULL, NULL, NULL),
(55871, '2017-12-07 13:26:40', NULL, NULL, 15086, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 13:26:40', 'admin-1512607716-15126243999608171', 1, 0, '', NULL, NULL, '10.0'),
(55872, '2017-12-07 13:54:09', NULL, NULL, 15087, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 13:54:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55873, '2017-12-07 13:54:23', NULL, NULL, 15087, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 13:54:23', 'admin-1512607716-15126260638498629', 1, 1, 'SR', NULL, NULL, NULL),
(55874, '2017-12-07 13:54:23', NULL, NULL, 15087, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 13:54:24', 'admin-1512607716-15126260638498629', 1, 1, 'SR', NULL, NULL, NULL),
(55875, '2017-12-07 13:54:24', NULL, NULL, 15087, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 13:54:24', 'admin-1512607716-15126260638498629', 1, 0, '', NULL, NULL, NULL),
(55876, '2017-12-07 14:13:27', NULL, NULL, 15088, 0, 181, '116', 'Open Food ', 'pepperpork takeaway', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 14:13:27', 'admin-1512607716-15126272070344765', 1, 0, '', NULL, NULL, NULL),
(55877, '2017-12-07 14:13:27', NULL, NULL, 15088, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 14:13:27', 'admin-1512607716-15126272070344765', 1, 0, '', NULL, NULL, NULL),
(55878, '2017-12-07 13:54:24', NULL, NULL, 15087, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 13:54:24', 'admin-1512607716-15126260638498629', 1, 0, '', NULL, NULL, NULL),
(55879, '2017-12-07 11:52:15', NULL, NULL, 15083, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1512607716', 'admin', '2017-12-07 11:52:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55880, '2017-12-07 11:52:21', NULL, NULL, 15083, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 11:52:21', 'admin-1512607716-15126187414402344', 1, 1, 'SR', NULL, NULL, NULL),
(55881, '2017-12-07 10:03:14', NULL, NULL, 15076, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1512607716', 'admin', '2017-12-07 10:03:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55882, '2017-12-07 12:05:02', NULL, NULL, 15084, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 12:05:02', 'admin-1512607716-15126195018815770', 1, 0, '', NULL, NULL, NULL),
(55883, '2017-12-07 09:55:49', NULL, NULL, 15075, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 09:55:49', 'admin-1512607716-15126117497002222', 1, 0, '', NULL, NULL, NULL),
(55884, '2017-12-07 12:04:46', NULL, NULL, 15084, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 12:04:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55885, '2017-12-07 12:05:02', NULL, NULL, 15084, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 12:05:02', 'admin-1512607716-15126195018815770', 1, 1, 'SR', NULL, NULL, NULL),
(55886, '2017-12-07 11:43:09', NULL, NULL, 15082, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1512607716', 'admin', '2017-12-07 11:43:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55887, '2017-12-07 11:43:22', NULL, NULL, 15082, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 11:43:22', 'admin-1512607716-15126182020051774', 1, 1, 'SR', NULL, NULL, NULL),
(55888, '2017-12-07 11:13:47', NULL, NULL, 15081, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 11:13:47', 'admin-1512607716-1512616427015943', 1, 1, 'SR', NULL, NULL, NULL),
(55889, '2017-12-07 10:36:53', NULL, NULL, 15080, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 10:36:53', 'admin-1512607716-15126142129512450', 1, 1, 'SR', NULL, NULL, '10.0'),
(55890, '2017-12-07 11:13:35', NULL, NULL, 15081, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1512607716', 'admin', '2017-12-07 11:13:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55891, '2017-12-07 10:33:46', NULL, NULL, 15079, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 10:33:46', 'admin-1512607716-1512614025904698', 1, 1, 'SR', NULL, NULL, NULL),
(55892, '2017-12-07 10:33:46', NULL, NULL, 15079, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 10:33:46', 'admin-1512607716-1512614025904698', 1, 1, 'SR', NULL, NULL, NULL),
(55893, '2017-12-07 10:33:10', NULL, NULL, 15079, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 10:33:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55894, '2017-12-07 10:36:53', NULL, NULL, 15080, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 10:36:53', 'admin-1512607716-15126142129512450', 1, 0, '', NULL, NULL, '10.0'),
(55895, '2017-12-07 10:36:45', NULL, NULL, 15080, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1512607716', 'admin', '2017-12-07 10:36:45', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(55896, '2017-12-07 10:32:39', NULL, NULL, 15078, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 10:32:39', 'admin-1512607716-15126139591077565', 1, 1, 'SR', NULL, NULL, NULL),
(55897, '2017-12-07 09:55:49', NULL, NULL, 15075, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 09:55:49', 'admin-1512607716-15126117497002222', 1, 0, '', NULL, NULL, NULL),
(55898, '2017-12-07 10:32:39', NULL, NULL, 15078, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 10:32:39', 'admin-1512607716-15126139591077565', 1, 0, '', NULL, NULL, NULL),
(55899, '2017-12-07 10:31:57', NULL, NULL, 15078, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1512607716', 'admin', '2017-12-07 10:31:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55900, '2017-12-07 10:32:39', NULL, NULL, 15078, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 10:32:39', 'admin-1512607716-15126139591077565', 1, 0, '', NULL, NULL, NULL),
(55901, '2017-12-07 10:16:15', NULL, NULL, 15077, 0, 153, '87', 'Wake Me Up!', 'no bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 10:16:15', 'admin-1512607716-1512612975507299', 1, 0, '', NULL, NULL, NULL),
(55902, '2017-12-07 10:16:15', NULL, NULL, 15077, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 10:16:15', 'admin-1512607716-1512612975507299', 1, 1, 'SR', NULL, NULL, NULL),
(55903, '2017-12-07 09:55:49', NULL, NULL, 15075, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 09:55:49', 'admin-1512607716-15126117497002222', 1, 0, '', NULL, NULL, NULL),
(55904, '2017-12-07 09:55:49', NULL, NULL, 15075, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 09:55:49', 'admin-1512607716-15126117497002222', 1, 1, 'SR', NULL, NULL, NULL),
(55905, '2017-12-07 09:18:29', NULL, NULL, 15074, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 09:18:29', 'admin-1512607716-15126095094591295', 1, 0, '', NULL, NULL, NULL),
(55906, '2017-12-07 09:18:29', NULL, NULL, 15074, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 09:18:29', 'admin-1512607716-15126095094591295', 1, 0, '', NULL, NULL, NULL),
(55907, '2017-12-07 09:18:29', NULL, NULL, 15074, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 09:18:29', 'admin-1512607716-15126095094591295', 1, 1, 'SR', NULL, NULL, NULL),
(55908, '2017-12-07 09:55:49', NULL, NULL, 15075, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 09:55:49', 'admin-1512607716-15126117497002222', 1, 0, '', NULL, NULL, NULL),
(55909, '2017-12-07 09:18:06', NULL, NULL, 15074, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1512607716', 'admin', '2017-12-07 09:18:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55910, '2017-12-07 09:54:40', NULL, NULL, 15075, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.70, 0.0000, 0.0000, 9.70, 1, '27', 1, '1512607716', 'admin', '2017-12-07 09:54:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55911, '2017-12-07 09:55:49', NULL, NULL, 15075, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512607716', 'admin', '2017-12-07 09:55:49', 'admin-1512607716-15126117497002222', 1, 0, '', NULL, NULL, NULL),
(55912, '2017-12-08 14:05:09', NULL, NULL, 15114, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:05:09', 'admin-1512694546-1512713108790899', 1, 1, 'SR', NULL, NULL, NULL),
(55913, '2017-12-08 14:05:08', NULL, NULL, 15114, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:05:08', 'admin-1512694546-1512713108790899', 1, 0, '', NULL, NULL, NULL),
(55914, '2017-12-08 14:05:08', NULL, NULL, 15114, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:05:08', 'admin-1512694546-1512713108790899', 1, 0, '', NULL, NULL, NULL),
(55915, '2017-12-08 14:05:08', NULL, NULL, 15114, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:05:08', 'admin-1512694546-1512713108790899', 1, 0, '', NULL, NULL, NULL),
(55916, '2017-12-08 14:37:14', NULL, NULL, 15116, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:37:14', 'admin-1512694546-151271503432639', 1, 0, '', NULL, NULL, NULL),
(55917, '2017-12-08 14:37:14', NULL, NULL, 15116, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:37:14', 'admin-1512694546-151271503432639', 1, 0, '', NULL, NULL, NULL),
(55918, '2017-12-08 14:37:14', NULL, NULL, 15116, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:37:14', 'admin-1512694546-151271503432639', 1, 0, '', NULL, NULL, NULL),
(55919, '2017-12-08 14:37:14', NULL, NULL, 15116, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:37:14', 'admin-1512694546-151271503432639', 1, 1, 'SR', NULL, NULL, NULL),
(55920, '2017-12-08 14:05:08', NULL, NULL, 15114, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:05:08', 'admin-1512694546-1512713108790899', 1, 0, '', NULL, NULL, NULL),
(55921, '2017-12-08 12:59:10', NULL, NULL, 15107, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 12:59:10', 'admin-1512694546-15127091503356993', 1, 0, '', NULL, NULL, NULL),
(55922, '2017-12-08 13:04:42', NULL, NULL, 15107, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 13:04:42', 'admin-1512694546-15127094822228184', 1, 0, '', NULL, NULL, NULL),
(55923, '2017-12-08 13:07:01', NULL, NULL, 15108, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1512694546', 'admin', '2017-12-08 13:07:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55924, '2017-12-08 13:07:41', NULL, NULL, 15108, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 13:07:41', 'admin-1512694546-15127096610555766', 1, 0, '', NULL, NULL, NULL),
(55925, '2017-12-08 13:07:41', NULL, NULL, 15108, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 13:07:41', 'admin-1512694546-15127096610555766', 1, 0, '', NULL, NULL, NULL),
(55926, '2017-12-08 14:05:08', NULL, NULL, 15114, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:05:08', 'admin-1512694546-1512713108790899', 1, 1, 'SR', NULL, NULL, NULL),
(55927, '2017-12-08 10:46:12', NULL, NULL, 15098, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:46:12', 'admin-1512694546-15127011719657412', 1, 1, 'SR', NULL, NULL, NULL),
(55928, '2017-12-08 12:53:14', NULL, NULL, 15106, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 12:53:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55929, '2017-12-08 11:47:03', NULL, NULL, 15100, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 11:47:03', 'admin-1512694546-15127048237513579', 1, 0, '', NULL, NULL, NULL),
(55930, '2017-12-08 09:39:40', NULL, NULL, 15094, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1512694546', 'admin', '2017-12-08 09:39:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55931, '2017-12-08 13:37:43', NULL, NULL, 15112, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1512694546', 'admin', '2017-12-08 13:37:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55932, '2017-12-08 13:37:50', NULL, NULL, 15112, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 13:37:50', 'admin-1512694546-15127114704414055', 1, 1, 'SR', NULL, NULL, NULL),
(55933, '2017-12-08 13:46:52', NULL, NULL, 15111, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 13:46:52', 'admin-1512694546-15127120128012036', 1, 0, '', NULL, NULL, NULL),
(55934, '2017-12-08 14:05:08', NULL, NULL, 15114, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:05:08', 'admin-1512694546-1512713108790899', 1, 0, '', NULL, NULL, NULL),
(55935, '2017-12-08 14:01:09', NULL, NULL, 15106, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:01:09', 'admin-1512694546-15127128697075776', 1, 1, 'SR', NULL, NULL, NULL),
(55936, '2017-12-08 14:56:13', NULL, NULL, 15118, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:56:13', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(55937, '2017-12-08 14:56:18', NULL, NULL, 15118, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:56:18', 'admin-1512694546-15127161784738215', 1, 0, '', NULL, NULL, '10.0'),
(55938, '2017-12-08 15:00:37', NULL, NULL, 15118, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 15:00:37', 'admin-1512694546-15127164368779940', 1, 0, '', NULL, NULL, '10.0'),
(55939, '2017-12-08 15:11:33', NULL, NULL, 15116, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 15:11:33', 'admin-1512694546-15127170933089339', 1, 1, 'SR', NULL, NULL, NULL),
(55940, '2017-12-08 15:19:50', NULL, NULL, 15119, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 15:19:50', 'admin-1512694546-15127175908045277', 1, 1, 'SR', 1, NULL, NULL),
(55941, '2017-12-08 14:45:08', NULL, NULL, 15117, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:45:08', 'admin-1512694546-15127155088585399', 1, 1, 'SR', NULL, NULL, NULL),
(55942, '2017-12-08 10:46:12', NULL, NULL, 15098, 0, 299, '235', 'Iced Salted Caramel Machiato', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:46:12', 'admin-1512694546-15127011719657412', 1, 0, '', NULL, NULL, NULL),
(55943, '2017-12-08 10:58:11', NULL, NULL, 15099, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:58:11', 'admin-1512694546-15127018909157681', 1, 0, '', NULL, NULL, NULL),
(55944, '2017-12-08 10:58:11', NULL, NULL, 15099, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:58:11', 'admin-1512694546-15127018909157681', 1, 0, '', NULL, NULL, NULL),
(55945, '2017-12-08 13:36:08', NULL, NULL, 15111, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 13:36:08', 'admin-1512694546-15127113683021433', 1, 1, 'SR', NULL, NULL, NULL),
(55946, '2017-12-08 13:37:50', NULL, NULL, 15112, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 13:37:50', 'admin-1512694546-15127114704414055', 1, 0, '', NULL, NULL, NULL),
(55947, '2017-12-08 13:36:08', NULL, NULL, 15111, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 13:36:08', 'admin-1512694546-15127113683021433', 1, 0, '', NULL, NULL, NULL),
(55948, '2017-12-08 13:36:08', NULL, NULL, 15111, 0, 318, '254', 'AA Set - Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 13:36:08', 'admin-1512694546-15127113683021433', 1, 0, '', NULL, NULL, NULL),
(55949, '2017-12-08 13:36:08', NULL, NULL, 15111, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 13:36:08', 'admin-1512694546-15127113683021433', 1, 0, '', NULL, NULL, NULL),
(55950, '2017-12-08 11:29:32', NULL, NULL, 15100, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1512694546', 'admin', '2017-12-08 11:29:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55951, '2017-12-08 11:29:53', NULL, NULL, 15100, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 11:29:53', 'admin-1512694546-15127037933071769', 1, 1, 'SR', NULL, NULL, NULL),
(55952, '2017-12-08 11:57:51', NULL, NULL, 15102, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 11:57:51', 'admin-1512694546-15127054714974113', 1, 0, '', NULL, NULL, NULL),
(55953, '2017-12-08 13:35:12', NULL, NULL, 15111, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1512694546', 'admin', '2017-12-08 13:35:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55954, '2017-12-08 14:37:14', NULL, NULL, 15116, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:37:14', 'admin-1512694546-151271503432639', 1, 1, 'SR', NULL, NULL, NULL),
(55955, '2017-12-08 14:01:09', NULL, NULL, 15106, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:01:09', 'admin-1512694546-15127128697075776', 1, 1, 'SR', NULL, NULL, NULL),
(55956, '2017-12-08 14:01:09', NULL, NULL, 15106, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:01:09', 'admin-1512694546-15127128697075776', 1, 0, '', NULL, NULL, NULL),
(55957, '2017-12-08 13:52:49', NULL, NULL, 15113, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 13:52:49', 'admin-1512694546-15127123692996621', 1, 1, 'SR', NULL, NULL, NULL),
(55958, '2017-12-08 14:28:40', NULL, NULL, 15115, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:28:40', 'admin-1512694546-15127145205458592', 1, 0, '', NULL, NULL, NULL),
(55959, '2017-12-08 14:28:32', NULL, NULL, 15115, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:28:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55960, '2017-12-08 14:34:21', NULL, NULL, 15116, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:34:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55961, '2017-12-08 14:28:40', NULL, NULL, 15115, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:28:40', 'admin-1512694546-15127145205458592', 1, 0, '', NULL, NULL, NULL),
(55962, '2017-12-08 14:28:40', NULL, NULL, 15115, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:28:40', 'admin-1512694546-15127145205458592', 1, 0, '', NULL, NULL, NULL),
(55963, '2017-12-08 14:28:40', NULL, NULL, 15115, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:28:40', 'admin-1512694546-15127145205458592', 1, 0, '', NULL, NULL, NULL),
(55964, '2017-12-08 14:18:06', NULL, NULL, 15114, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:18:06', 'admin-1512694546-1512713886677184', 1, 0, '', NULL, NULL, NULL),
(55965, '2017-12-08 11:57:51', NULL, NULL, 15102, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 11:57:51', 'admin-1512694546-15127054714974113', 1, 1, 'SR', NULL, NULL, NULL),
(55966, '2017-12-08 13:21:46', NULL, NULL, 15110, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 13:21:46', 'admin-1512694546-15127105063234675', 1, 1, 'SR', NULL, NULL, NULL),
(55967, '2017-12-08 13:21:38', NULL, NULL, 15110, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1512694546', 'admin', '2017-12-08 13:21:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55968, '2017-12-08 13:20:19', NULL, NULL, 15109, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 13:20:19', 'admin-1512694546-151271041889099', 1, 1, 'SR', NULL, NULL, NULL),
(55969, '2017-12-08 13:19:53', NULL, NULL, 15109, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1512694546', 'admin', '2017-12-08 13:19:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55970, '2017-12-08 13:20:19', NULL, NULL, 15109, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 13:20:19', 'admin-1512694546-151271041889099', 1, 0, '', NULL, NULL, NULL),
(55971, '2017-12-08 13:07:41', NULL, NULL, 15108, 0, 322, '258', 'Yuzu Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 13:07:41', 'admin-1512694546-15127096610555766', 1, 0, '', NULL, NULL, NULL),
(55972, '2017-12-08 00:00:00', NULL, NULL, 15105, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, NULL, NULL, 2.90, 1, '27', 1, '1512694546', 'admin', '2017-12-08 11:57:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55973, '2017-12-08 12:53:17', NULL, NULL, 15106, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 12:53:17', 'admin-1512694546-1512708797483289', 1, 0, '', NULL, NULL, NULL),
(55974, '2017-12-08 12:38:14', NULL, NULL, 15104, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1512694546', 'admin', '2017-12-08 12:38:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55975, '2017-12-08 13:52:37', NULL, NULL, 15113, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1512694546', 'admin', '2017-12-08 13:52:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55976, '2017-12-08 12:59:10', NULL, NULL, 15107, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 12:59:10', 'admin-1512694546-15127091503356993', 1, 0, '', NULL, NULL, NULL),
(55977, '2017-12-08 12:59:10', NULL, NULL, 15107, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 12:59:10', 'admin-1512694546-15127091503356993', 1, 0, '', NULL, NULL, NULL),
(55978, '2017-12-08 12:59:04', NULL, NULL, 15107, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1512694546', 'admin', '2017-12-08 12:59:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55979, '2017-12-08 00:00:00', NULL, NULL, 15105, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 11:58:56', 'admin-1512694546-15127055360408217', 1, 1, 'SR', NULL, NULL, NULL),
(55980, '2017-12-08 00:00:00', NULL, NULL, 15105, 0, 331, '267', 'Yuzu Marmalade Pancake', '', 'Meals', 'Morning Bites ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 11:58:56', 'admin-1512694546-15127055360408217', 1, 0, '', NULL, NULL, NULL),
(55981, '2017-12-08 00:00:00', NULL, NULL, 15104, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 11:58:56', 'admin-1512694546-15127055360408217', 1, 1, 'SR', NULL, NULL, NULL),
(55982, '2017-12-08 00:00:00', NULL, NULL, 15104, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 11:58:56', 'admin-1512694546-15127055360408217', 1, 1, 'SR', NULL, NULL, NULL),
(55983, '2017-12-08 00:00:00', NULL, NULL, 15104, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 11:58:56', 'admin-1512694546-15127055360408217', 1, 0, '', NULL, NULL, NULL),
(55984, '2017-12-08 11:57:51', NULL, NULL, 15102, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 11:57:51', 'admin-1512694546-15127054714974113', 1, 1, 'SR', NULL, NULL, NULL),
(55985, '2017-12-08 11:38:36', NULL, NULL, 15100, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 11:38:36', 'admin-1512694546-1512704316013132', 1, 0, '', NULL, NULL, NULL),
(55986, '2017-12-08 10:34:42', NULL, NULL, 15097, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:34:42', 'admin-1512694546-15127004827282896', 1, 1, 'SR', NULL, NULL, NULL),
(55987, '2017-12-08 14:44:59', NULL, NULL, 15117, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:44:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55988, '2017-12-08 10:58:43', NULL, NULL, 15096, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:58:43', 'admin-1512694546-15127019232882633', 1, 1, 'SR', NULL, NULL, NULL),
(55989, '2017-12-08 11:17:38', NULL, NULL, 15096, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 11:17:38', 'admin-1512694546-15127030580043675', 1, 1, 'SR', NULL, NULL, NULL),
(55990, '2017-12-08 11:56:35', NULL, NULL, 15102, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1512694546', 'admin', '2017-12-08 11:56:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55991, '2017-12-08 09:20:52', NULL, NULL, 15092, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 09:20:52', 'admin-1512694546-15126960521129438', 1, 1, 'SR', NULL, NULL, NULL),
(55992, '2017-12-08 09:32:28', NULL, NULL, 15093, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1512694546', 'admin', '2017-12-08 09:32:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55993, '2017-12-08 09:32:43', NULL, NULL, 15093, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 09:32:43', 'admin-1512694546-15126967634428962', 1, 1, 'SR', NULL, NULL, NULL),
(55994, '2017-12-08 14:03:57', NULL, NULL, 15114, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.50, 0.0000, 0.0000, 11.50, 1, '27', 1, '1512694546', 'admin', '2017-12-08 14:03:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55995, '2017-12-08 10:58:43', NULL, NULL, 15096, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:58:43', 'admin-1512694546-15127019232882633', 1, 0, '', NULL, NULL, NULL),
(55996, '2017-12-08 10:58:11', NULL, NULL, 15099, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:58:11', 'admin-1512694546-15127018909157681', 1, 1, 'SR', NULL, NULL, NULL),
(55997, '2017-12-08 10:58:11', NULL, NULL, 15099, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:58:11', 'admin-1512694546-15127018909157681', 1, 1, 'SR', NULL, NULL, NULL),
(55998, '2017-12-08 10:44:20', NULL, NULL, 15098, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:44:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(55999, '2017-12-08 10:57:54', NULL, NULL, 15099, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:57:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56000, '2017-12-08 10:46:12', NULL, NULL, 15098, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:46:12', 'admin-1512694546-15127011719657412', 1, 0, '', NULL, NULL, NULL),
(56001, '2017-12-08 10:46:12', NULL, NULL, 15098, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:46:12', 'admin-1512694546-15127011719657412', 1, 0, '', NULL, NULL, NULL),
(56002, '2017-12-08 10:34:42', NULL, NULL, 15097, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:34:42', 'admin-1512694546-15127004827282896', 1, 1, 'SR', NULL, NULL, NULL),
(56003, '2017-12-08 10:33:22', NULL, NULL, 15097, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:33:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56004, '2017-12-08 10:34:42', NULL, NULL, 15097, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:34:42', 'admin-1512694546-15127004827282896', 1, 0, '', NULL, NULL, NULL),
(56005, '2017-12-08 10:34:42', NULL, NULL, 15097, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:34:42', 'admin-1512694546-15127004827282896', 1, 0, '', NULL, NULL, NULL),
(56006, '2017-12-08 10:31:37', NULL, NULL, 15096, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:31:37', 'admin-1512694546-15127002976137337', 1, 1, 'SR', NULL, NULL, NULL),
(56007, '2017-12-08 10:31:23', NULL, NULL, 15096, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:31:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56008, '2017-12-08 10:31:37', NULL, NULL, 15096, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:31:37', 'admin-1512694546-15127002976137337', 1, 0, '', NULL, NULL, NULL),
(56009, '2017-12-08 10:31:37', NULL, NULL, 15096, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:31:37', 'admin-1512694546-15127002976137337', 1, 0, '', NULL, NULL, NULL),
(56010, '2017-12-08 10:31:37', NULL, NULL, 15096, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:31:37', 'admin-1512694546-15127002976137337', 1, 0, '', NULL, NULL, NULL),
(56011, '2017-12-08 09:20:16', NULL, NULL, 15092, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1512694546', 'admin', '2017-12-08 09:20:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56012, '2017-12-08 11:57:51', NULL, NULL, 15102, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 11:57:51', 'admin-1512694546-15127054714974113', 1, 0, '', NULL, NULL, NULL),
(56013, '2017-12-08 10:04:15', NULL, NULL, 15094, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 10:04:15', 'admin-1512694546-15126986554763490', 1, 1, 'SR', NULL, NULL, NULL),
(56014, '2017-12-08 09:39:47', NULL, NULL, 15094, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 09:39:47', 'admin-1512694546-1512697187570816', 1, 1, 'SR', NULL, NULL, NULL),
(56015, '2017-12-08 09:44:06', NULL, NULL, 15095, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1512694546', 'admin', '2017-12-08 09:44:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56016, '2017-12-08 09:45:17', NULL, NULL, 15095, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 09:45:17', 'admin-1512694546-15126975172054928', 1, 0, '', NULL, NULL, NULL),
(56017, '2017-12-08 09:45:17', NULL, NULL, 15095, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 09:45:17', 'admin-1512694546-15126975172054928', 1, 1, 'SR', NULL, NULL, NULL),
(56018, '2017-12-08 09:20:52', NULL, NULL, 15092, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 09:20:52', 'admin-1512694546-15126960521129438', 1, 0, '', NULL, NULL, NULL),
(56019, '2017-12-08 09:32:43', NULL, NULL, 15093, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 09:32:43', 'admin-1512694546-15126967634428962', 1, 0, '', NULL, NULL, NULL),
(56020, '2017-12-08 09:20:52', NULL, NULL, 15092, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512694546', 'admin', '2017-12-08 09:20:52', 'admin-1512694546-15126960521129438', 1, 0, '', NULL, NULL, NULL),
(56021, '2017-12-09 12:38:23', NULL, NULL, 15144, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:38:23', 'admin-1512781827-1512794303612478', 1, 0, '', NULL, NULL, NULL),
(56022, '2017-12-09 12:30:18', NULL, NULL, 15143, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:30:18', 'admin-1512781827-15127938182308216', 1, 1, 'SR', NULL, NULL, NULL),
(56023, '2017-12-09 12:30:18', NULL, NULL, 15143, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:30:18', 'admin-1512781827-15127938182308216', 1, 1, 'SR', NULL, NULL, NULL),
(56024, '2017-12-09 15:21:30', NULL, NULL, 15159, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:21:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56025, '2017-12-09 15:21:45', NULL, NULL, 15159, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:21:45', 'admin-1512802134-15128041053144264', 1, 0, '', NULL, NULL, NULL),
(56026, '2017-12-09 14:26:58', NULL, NULL, 15155, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:26:58', 'admin-1512781827-1512800818277382', 1, 1, 'SR', NULL, NULL, NULL),
(56027, '2017-12-09 13:50:11', NULL, NULL, 15152, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 13:50:11', 'admin-1512781827-15127986117671528', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(56028, '2017-12-09 13:50:11', NULL, NULL, 15152, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 13:50:11', 'admin-1512781827-15127986117671528', 1, 0, '', NULL, NULL, NULL),
(56029, '2017-12-09 13:41:53', NULL, NULL, 15151, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 13:41:53', 'admin-1512781827-15127981132701283', 1, 0, '', NULL, NULL, NULL),
(56030, '2017-12-09 12:52:56', NULL, NULL, 15148, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:52:56', 'admin-1512781827-15127951767521061', 1, 0, '', NULL, NULL, NULL),
(56031, '2017-12-09 14:43:32', NULL, NULL, 15155, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:43:32', 'admin-1512781827-15128018120203792', 1, 0, '', NULL, NULL, NULL),
(56032, '2017-12-09 14:41:14', NULL, NULL, 15155, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:41:14', 'admin-1512781827-15128016740091198', 1, 0, '', NULL, NULL, NULL),
(56033, '2017-12-09 12:38:23', NULL, NULL, 15144, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:38:23', 'admin-1512781827-1512794303612478', 1, 1, 'SR', NULL, NULL, NULL),
(56034, '2017-12-09 12:38:23', NULL, NULL, 15144, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:38:23', 'admin-1512781827-1512794303612478', 1, 0, '', NULL, NULL, NULL),
(56035, '2017-12-09 12:38:23', NULL, NULL, 15144, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:38:23', 'admin-1512781827-1512794303612478', 1, 1, 'SR', NULL, NULL, NULL),
(56036, '2017-12-09 12:37:52', NULL, NULL, 15144, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:37:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56037, '2017-12-09 12:29:43', NULL, NULL, 15143, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:29:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56038, '2017-12-09 11:21:02', NULL, NULL, 15133, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:21:02', 'admin-1512781827-1512789662326473', 1, 1, 'SR', NULL, NULL, NULL),
(56039, '2017-12-09 11:21:40', NULL, NULL, 15134, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:21:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56040, '2017-12-09 11:21:53', NULL, NULL, 15134, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:21:53', 'admin-1512781827-15127897136151270', 1, 0, '', NULL, NULL, NULL),
(56041, '2017-12-09 11:21:53', NULL, NULL, 15134, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:21:53', 'admin-1512781827-15127897136151270', 1, 0, '', NULL, NULL, NULL),
(56042, '2017-12-09 11:21:53', NULL, NULL, 15134, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:21:53', 'admin-1512781827-15127897136151270', 1, 0, '', NULL, NULL, NULL),
(56043, '2017-12-09 16:09:50', NULL, NULL, 15165, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 16:09:50', 'admin-1512802134-15128069908376169', 1, 1, 'SR', NULL, NULL, NULL),
(56044, '2017-12-09 16:09:51', NULL, NULL, 15165, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 16:09:51', 'admin-1512802134-15128069908376169', 1, 1, 'SR', NULL, NULL, NULL),
(56045, '2017-12-09 16:16:23', NULL, NULL, 15165, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 16:16:23', 'admin-1512802134-1512807383276952', 1, 0, '', NULL, NULL, NULL),
(56046, '2017-12-09 15:38:24', NULL, NULL, 15160, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:38:24', 'admin-1512802134-1512805104561419', 1, 0, '', NULL, NULL, NULL),
(56047, '2017-12-09 15:38:24', NULL, NULL, 15160, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:38:24', 'admin-1512802134-1512805104561419', 1, 1, 'SR', NULL, NULL, NULL),
(56048, '2017-12-09 12:52:56', NULL, NULL, 15148, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:52:56', 'admin-1512781827-15127951767521061', 1, 1, 'SR', NULL, NULL, NULL),
(56049, '2017-12-09 12:48:41', NULL, NULL, 15146, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:48:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56050, '2017-12-09 12:18:46', NULL, NULL, 15142, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:18:46', 'admin-1512781827-15127931259977381', 1, 1, 'SR', NULL, NULL, NULL),
(56051, '2017-12-09 14:46:21', NULL, NULL, 15156, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:46:21', 'admin-1512781827-15128019815487587', 1, 0, '', NULL, NULL, '10.0'),
(56052, '2017-12-09 09:51:42', NULL, NULL, 15123, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 09:51:42', 'admin-1512781827-15127843021573977', 1, 1, 'SR', NULL, NULL, NULL),
(56053, '2017-12-09 12:47:10', NULL, NULL, 15145, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:47:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56054, '2017-12-09 14:26:58', NULL, NULL, 15155, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:26:58', 'admin-1512781827-1512800818277382', 1, 0, '', NULL, NULL, NULL),
(56055, '2017-12-09 14:26:58', NULL, NULL, 15155, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:26:58', 'admin-1512781827-1512800818277382', 1, 0, '', NULL, NULL, NULL),
(56056, '2017-12-09 14:26:58', NULL, NULL, 15155, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:26:58', 'admin-1512781827-1512800818277382', 1, 0, '', NULL, NULL, NULL),
(56057, '2017-12-09 15:41:58', NULL, NULL, 15161, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:41:58', 'admin-1512802134-15128053185141423', 1, 0, '', NULL, NULL, NULL),
(56058, '2017-12-09 15:44:03', NULL, NULL, 15162, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:44:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56059, '2017-12-09 15:44:17', NULL, NULL, 15162, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:44:17', 'admin-1512802134-15128054576052222', 1, 0, '', NULL, NULL, NULL),
(56060, '2017-12-09 13:50:55', NULL, NULL, 15152, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 13:50:55', 'admin-1512781827-15127986557051340', 1, 1, 'SR', NULL, NULL, NULL),
(56061, '2017-12-09 15:46:55', NULL, NULL, 15164, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:46:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56062, '2017-12-09 12:18:46', NULL, NULL, 15142, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:18:46', 'admin-1512781827-15127931259977381', 1, 0, '', NULL, NULL, NULL),
(56063, '2017-12-09 09:31:36', NULL, NULL, 15121, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1512802134', 'admin', '2017-12-09 09:31:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56064, '2017-12-09 15:49:02', NULL, NULL, 15164, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:49:02', 'admin-1512802134-15128057425939610', 1, 1, 'SR', NULL, NULL, NULL),
(56065, '2017-12-09 15:21:45', NULL, NULL, 15159, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:21:45', 'admin-1512802134-15128041053144264', 1, 1, 'SR', NULL, NULL, NULL),
(56066, '2017-12-09 15:21:45', NULL, NULL, 15159, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:21:45', 'admin-1512802134-15128041053144264', 1, 1, 'SR', NULL, NULL, NULL),
(56067, '2017-12-09 16:04:46', NULL, NULL, 15165, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 16:04:46', 'admin-1512802134-15128066867368698', 1, 0, '', NULL, NULL, NULL),
(56068, '2017-12-09 16:04:13', NULL, NULL, 15165, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 16:04:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56069, '2017-12-09 16:04:46', NULL, NULL, 15165, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 16:04:46', 'admin-1512802134-15128066867368698', 1, 1, 'SR', NULL, NULL, NULL),
(56070, '2017-12-09 14:46:21', NULL, NULL, 15156, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:46:21', 'admin-1512781827-15128019815487587', 1, 0, '', NULL, NULL, '10.0'),
(56071, '2017-12-09 14:12:17', NULL, NULL, 15154, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:12:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56072, '2017-12-09 15:46:19', NULL, NULL, 15163, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:46:19', 'admin-1512802134-15128055790467710', 1, 1, 'SR', NULL, NULL, NULL),
(56073, '2017-12-09 15:49:02', NULL, NULL, 15164, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:49:02', 'admin-1512802134-15128057425939610', 1, 0, '', NULL, NULL, NULL),
(56074, '2017-12-09 15:49:02', NULL, NULL, 15164, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:49:02', 'admin-1512802134-15128057425939610', 1, 0, '', NULL, NULL, NULL),
(56075, '2017-12-09 12:03:41', NULL, NULL, 15140, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:03:41', 'admin-1512781827-15127922214033094', 1, 0, '', NULL, NULL, NULL),
(56076, '2017-12-09 12:03:41', NULL, NULL, 15140, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:03:41', 'admin-1512781827-15127922214033094', 1, 0, '', NULL, NULL, NULL),
(56077, '2017-12-09 11:23:38', NULL, NULL, 15131, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:23:38', 'admin-1512781827-15127898185654833', 1, 0, '', NULL, NULL, NULL),
(56078, '2017-12-09 12:18:18', NULL, NULL, 15142, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:18:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56079, '2017-12-09 14:58:52', NULL, NULL, 15158, 0, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:58:52', 'admin-1512802134-15128027320147174', 1, 1, 'SR', NULL, NULL, NULL),
(56080, '2017-12-09 12:16:54', NULL, NULL, 15141, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:16:54', 'admin-1512781827-15127930140584671', 1, 0, '', NULL, NULL, NULL),
(56081, '2017-12-09 12:16:54', NULL, NULL, 15141, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:16:54', 'admin-1512781827-15127930140584671', 1, 0, '', NULL, NULL, NULL),
(56082, '2017-12-09 12:16:54', NULL, NULL, 15141, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:16:54', 'admin-1512781827-15127930140584671', 1, 0, '', NULL, NULL, NULL),
(56083, '2017-12-09 12:16:54', NULL, NULL, 15141, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:16:54', 'admin-1512781827-15127930140584671', 1, 1, 'SR', NULL, NULL, NULL),
(56084, '2017-12-09 12:16:54', NULL, NULL, 15141, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:16:54', 'admin-1512781827-15127930140584671', 1, 1, 'SR', NULL, NULL, NULL),
(56085, '2017-12-09 11:34:59', NULL, NULL, 15138, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:34:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56086, '2017-12-09 11:29:17', NULL, NULL, 15136, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:29:17', 'admin-1512781827-15127901573262654', 1, 0, '', NULL, NULL, NULL),
(56087, '2017-12-09 11:29:17', NULL, NULL, 15136, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:29:17', 'admin-1512781827-15127901573262654', 1, 0, '', NULL, NULL, NULL),
(56088, '2017-12-09 12:15:50', NULL, NULL, 15141, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:15:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56089, '2017-12-09 12:16:54', NULL, NULL, 15141, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:16:54', 'admin-1512781827-15127930140584671', 1, 0, '', NULL, NULL, NULL),
(56090, '2017-12-09 12:10:24', NULL, NULL, 15140, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:10:24', 'admin-1512781827-15127926239872781', 1, 0, '', NULL, NULL, NULL),
(56091, '2017-12-09 12:03:41', NULL, NULL, 15140, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:03:41', 'admin-1512781827-15127922214033094', 1, 1, 'SR', NULL, NULL, NULL),
(56092, '2017-12-09 12:49:12', NULL, NULL, 15146, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:49:12', 'admin-1512781827-15127949525221756', 1, 0, '', NULL, NULL, NULL),
(56093, '2017-12-09 14:51:03', NULL, NULL, 15157, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:51:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56094, '2017-12-09 14:57:43', NULL, NULL, 15157, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:57:43', 'admin-1512802134-15128026635133233', 1, 0, '', NULL, NULL, NULL),
(56095, '2017-12-09 14:53:30', NULL, NULL, 15157, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:53:30', 'admin-1512802134-15128024103289411', 1, 1, 'SR', NULL, NULL, NULL),
(56096, '2017-12-09 14:17:02', NULL, NULL, 15154, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:17:02', 'admin-1512781827-15128002223348432', 1, 0, '', NULL, NULL, NULL),
(56097, '2017-12-09 14:17:02', NULL, NULL, 15154, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:17:02', 'admin-1512781827-15128002223348432', 1, 1, 'SR', NULL, NULL, NULL),
(56098, '2017-12-09 15:38:56', NULL, NULL, 15155, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:38:56', 'admin-1512802134-15128051360239063', 1, 0, '', NULL, NULL, NULL),
(56099, '2017-12-09 14:46:21', NULL, NULL, 15156, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:46:21', 'admin-1512781827-15128019815487587', 1, 0, '', NULL, NULL, '10.0'),
(56100, '2017-12-09 15:41:35', NULL, NULL, 15161, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:41:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56101, '2017-12-09 14:54:06', NULL, NULL, 15155, 0, 181, '116', 'Open Food ', 'soup', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:54:06', 'admin-1512802134-1512802445994388', 1, 0, '', NULL, NULL, NULL),
(56102, '2017-12-09 15:41:58', NULL, NULL, 15161, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:41:58', 'admin-1512802134-15128053185141423', 1, 0, '', NULL, NULL, NULL),
(56103, '2017-12-09 15:38:24', NULL, NULL, 15160, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:38:24', 'admin-1512802134-1512805104561419', 1, 0, '', NULL, NULL, NULL),
(56104, '2017-12-09 15:26:45', NULL, NULL, 15156, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:26:45', 'admin-1512802134-15128044055298626', 1, 1, 'SR', NULL, NULL, '10.0'),
(56105, '2017-12-09 15:21:45', NULL, NULL, 15159, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:21:45', 'admin-1512802134-15128041053144264', 1, 0, '', NULL, NULL, NULL),
(56106, '2017-12-09 15:21:45', NULL, NULL, 15159, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:21:45', 'admin-1512802134-15128041053144264', 1, 1, 'SR', NULL, NULL, NULL),
(56107, '2017-12-09 15:03:25', NULL, NULL, 15155, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:03:25', 'admin-1512802134-15128030054539488', 1, 1, 'SR', NULL, NULL, NULL),
(56108, '2017-12-09 14:58:52', NULL, NULL, 15158, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:58:52', 'admin-1512802134-15128027320147174', 1, 1, 'SR', NULL, NULL, NULL),
(56109, '2017-12-09 14:58:52', NULL, NULL, 15158, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:58:52', 'admin-1512802134-15128027320147174', 1, 1, 'SR', NULL, NULL, NULL),
(56110, '2017-12-09 14:58:52', NULL, NULL, 15158, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:58:52', 'admin-1512802134-15128027320147174', 1, 1, 'SR', NULL, NULL, NULL),
(56111, '2017-12-09 14:26:58', NULL, NULL, 15155, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:26:58', 'admin-1512781827-1512800818277382', 1, 0, '', NULL, NULL, NULL),
(56112, '2017-12-09 12:03:41', NULL, NULL, 15140, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:03:41', 'admin-1512781827-15127922214033094', 1, 1, 'SR', NULL, NULL, NULL),
(56113, '2017-12-09 14:58:21', NULL, NULL, 15158, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:58:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56114, '2017-12-09 14:26:58', NULL, NULL, 15155, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:26:58', 'admin-1512781827-1512800818277382', 1, 1, 'SR', NULL, NULL, NULL),
(56115, '2017-12-09 14:28:14', NULL, NULL, 15155, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:28:14', 'admin-1512781827-15128008941631316', 1, 0, '', NULL, NULL, NULL),
(56116, '2017-12-09 13:57:36', NULL, NULL, 15153, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1512802134', 'admin', '2017-12-09 13:57:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56117, '2017-12-09 14:57:20', NULL, NULL, 15157, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:57:20', 'admin-1512802134-15128026406403559', 1, 1, 'SR', NULL, NULL, NULL),
(56118, '2017-12-09 14:53:30', NULL, NULL, 15157, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:53:30', 'admin-1512802134-15128024103289411', 1, 0, '', NULL, NULL, NULL),
(56119, '2017-12-09 16:04:46', NULL, NULL, 15165, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 16:04:46', 'admin-1512802134-15128066867368698', 1, 0, '', NULL, NULL, NULL),
(56120, '2017-12-09 14:53:30', NULL, NULL, 15157, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:53:30', 'admin-1512802134-15128024103289411', 1, 0, '', NULL, NULL, NULL),
(56121, '2017-12-09 14:46:21', NULL, NULL, 15156, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:46:21', 'admin-1512781827-15128019815487587', 1, 1, 'SR', NULL, NULL, '10.0'),
(56122, '2017-12-09 14:26:58', NULL, NULL, 15155, 0, 322, '258', 'Yuzu Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:26:58', 'admin-1512781827-1512800818277382', 1, 0, '', NULL, NULL, NULL),
(56123, '2017-12-09 12:18:46', NULL, NULL, 15142, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:18:46', 'admin-1512781827-15127931259977381', 1, 0, '', NULL, NULL, NULL),
(56124, '2017-12-09 12:03:02', NULL, NULL, 15140, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:03:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56125, '2017-12-09 12:00:29', NULL, NULL, 15139, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:00:29', 'admin-1512781827-1512792029849854', 1, 0, '', NULL, NULL, NULL),
(56126, '2017-12-09 12:00:29', NULL, NULL, 15139, 0, 337, '273', 'Hot yuzu', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:00:29', 'admin-1512781827-1512792029849854', 1, 0, '', NULL, NULL, NULL),
(56127, '2017-12-09 12:00:21', NULL, NULL, 15139, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:00:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56128, '2017-12-09 12:47:58', NULL, NULL, 15129, 0, 181, '116', 'Open Food ', 'double salted pork', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:47:58', 'admin-1512781827-1512794878519376', 1, 0, '', NULL, NULL, NULL),
(56129, '2017-12-09 10:57:46', NULL, NULL, 15130, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:57:46', 'admin-1512781827-15127882660619763', 1, 0, '', NULL, NULL, NULL),
(56130, '2017-12-09 11:09:43', NULL, NULL, 15131, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:09:43', 'admin-1512781827-15127889831338163', 1, 1, 'SR', NULL, NULL, NULL),
(56131, '2017-12-09 14:26:58', NULL, NULL, 15155, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:26:58', 'admin-1512781827-1512800818277382', 1, 0, '', NULL, NULL, NULL),
(56132, '2017-12-09 14:45:56', NULL, NULL, 15156, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.80, 0.0000, 0.0000, 11.80, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:45:56', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(56133, '2017-12-09 12:59:12', NULL, NULL, 15128, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:59:12', 'admin-1512781827-15127955523877250', 1, 0, '', NULL, NULL, NULL),
(56134, '2017-12-09 14:58:07', NULL, NULL, 15156, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:58:07', 'admin-1512802134-15128026876006462', 1, 0, '', NULL, NULL, '10.0'),
(56135, '2017-12-09 14:26:58', NULL, NULL, 15155, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:26:58', 'admin-1512781827-1512800818277382', 1, 1, 'SR', NULL, NULL, NULL),
(56136, '2017-12-09 14:46:21', NULL, NULL, 15156, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:46:21', 'admin-1512781827-15128019815487587', 1, 0, '', NULL, NULL, '10.0'),
(56137, '2017-12-09 11:32:54', NULL, NULL, 15137, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:32:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56138, '2017-12-09 11:32:58', NULL, NULL, 15137, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:32:58', 'admin-1512781827-15127903786836329', 1, 1, 'SR', NULL, NULL, NULL),
(56139, '2017-12-09 11:36:27', NULL, NULL, 15138, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:36:27', 'admin-1512781827-15127905869608762', 1, 1, 'SR', NULL, NULL, NULL),
(56140, '2017-12-09 14:26:58', NULL, NULL, 15155, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:26:58', 'admin-1512781827-1512800818277382', 1, 0, '', NULL, NULL, NULL),
(56141, '2017-12-09 14:26:58', NULL, NULL, 15155, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:26:58', 'admin-1512781827-1512800818277382', 1, 0, '', NULL, NULL, NULL),
(56142, '2017-12-09 13:58:10', NULL, NULL, 15153, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 13:58:10', 'admin-1512781827-15127990899074616', 1, 1, 'SR', NULL, NULL, NULL),
(56143, '2017-12-09 14:26:58', NULL, NULL, 15155, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:26:58', 'admin-1512781827-1512800818277382', 1, 0, '', NULL, NULL, NULL),
(56144, '2017-12-09 13:39:52', NULL, NULL, 15151, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 13:39:52', 'admin-1512781827-15127979918556855', 1, 1, 'SR', NULL, NULL, NULL),
(56145, '2017-12-09 14:26:58', NULL, NULL, 15155, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:26:58', 'admin-1512781827-1512800818277382', 1, 0, '', NULL, NULL, NULL),
(56146, '2017-12-09 14:25:22', NULL, NULL, 15155, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 31.10, 0.0000, 0.0000, 31.10, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:25:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56147, '2017-12-09 13:58:10', NULL, NULL, 15153, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 13:58:10', 'admin-1512781827-15127990899074616', 1, 1, 'SR', NULL, NULL, NULL),
(56148, '2017-12-09 13:49:38', NULL, NULL, 15152, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1512802134', 'admin', '2017-12-09 13:49:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56149, '2017-12-09 13:39:52', NULL, NULL, 15151, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 13:39:52', 'admin-1512781827-15127979918556855', 1, 1, 'SR', NULL, NULL, NULL),
(56150, '2017-12-09 13:39:52', NULL, NULL, 15151, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 13:39:52', 'admin-1512781827-15127979918556855', 1, 1, 'SR', NULL, NULL, NULL),
(56151, '2017-12-09 13:37:29', NULL, NULL, 15151, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1512802134', 'admin', '2017-12-09 13:37:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56152, '2017-12-09 13:39:52', NULL, NULL, 15151, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 13:39:52', 'admin-1512781827-15127979918556855', 1, 0, '', NULL, NULL, NULL),
(56153, '2017-12-09 12:49:45', NULL, NULL, 15139, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:49:45', 'admin-1512781827-15127949851859720', 1, 0, '', NULL, NULL, NULL),
(56154, '2017-12-09 13:23:15', NULL, NULL, 15148, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Rice', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 13:23:15', 'admin-1512781827-15127969952305223', 1, 0, '', NULL, NULL, NULL),
(56155, '2017-12-09 13:18:15', NULL, NULL, 15148, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 13:18:15', 'admin-1512781827-1512796695775974', 1, 0, '', NULL, NULL, NULL),
(56156, '2017-12-09 13:14:10', NULL, NULL, 15150, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1512802134', 'admin', '2017-12-09 13:14:10', 'admin-1512781827-15127964506755010', 1, 0, '', 1, NULL, NULL),
(56157, '2017-12-09 13:08:44', NULL, NULL, 15149, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 13:08:44', 'admin-1512781827-15127961238315498', 1, 0, '', 1, NULL, '10.0'),
(56158, '2017-12-09 15:03:25', NULL, NULL, 15155, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:03:25', 'admin-1512802134-15128030054539488', 1, 1, 'SR', NULL, NULL, NULL),
(56159, '2017-12-09 14:46:21', NULL, NULL, 15156, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:46:21', 'admin-1512781827-15128019815487587', 1, 1, 'SR', NULL, NULL, '10.0'),
(56160, '2017-12-09 13:04:20', NULL, NULL, 15142, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 13:04:20', 'admin-1512781827-1512795860544437', 1, 0, '', NULL, NULL, NULL),
(56161, '2017-12-09 12:52:56', NULL, NULL, 15148, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:52:56', 'admin-1512781827-15127951767521061', 1, 1, 'SR', NULL, NULL, NULL),
(56162, '2017-12-09 12:52:56', NULL, NULL, 15148, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:52:56', 'admin-1512781827-15127951767521061', 1, 0, '', NULL, NULL, NULL),
(56163, '2017-12-09 12:52:33', NULL, NULL, 15148, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:52:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56164, '2017-12-09 12:49:18', NULL, NULL, 15147, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:49:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56165, '2017-12-09 12:49:25', NULL, NULL, 15147, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:49:25', 'admin-1512781827-15127949653944869', 1, 0, '', NULL, NULL, NULL),
(56166, '2017-12-09 15:46:19', NULL, NULL, 15163, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:46:19', 'admin-1512802134-15128055790467710', 1, 1, 'SR', NULL, NULL, NULL),
(56167, '2017-12-09 12:49:45', NULL, NULL, 15139, 0, 318, '254', 'AA Set - Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:49:45', 'admin-1512781827-15127949851859720', 1, 0, '', NULL, NULL, NULL),
(56168, '2017-12-09 12:57:02', NULL, NULL, 15146, 0, 304, '240', 'Banana is On Fire', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:57:02', 'admin-1512781827-15127954223041597', 1, 0, '', NULL, NULL, NULL),
(56169, '2017-12-09 11:36:27', NULL, NULL, 15138, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:36:27', 'admin-1512781827-15127905869608762', 1, 0, '', NULL, NULL, NULL),
(56170, '2017-12-09 11:36:27', NULL, NULL, 15138, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:36:27', 'admin-1512781827-15127905869608762', 1, 0, '', NULL, NULL, NULL),
(56171, '2017-12-09 11:32:50', NULL, NULL, 15132, 0, 328, '264', 'Basic Blueberries Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:32:50', 'admin-1512781827-15127903702421372', 1, 0, '', NULL, NULL, NULL),
(56172, '2017-12-09 11:29:17', NULL, NULL, 15136, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:29:17', 'admin-1512781827-15127901573262654', 1, 0, '', NULL, NULL, NULL),
(56173, '2017-12-09 09:51:42', NULL, NULL, 15123, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 09:51:42', 'admin-1512781827-15127843021573977', 1, 0, '', NULL, NULL, NULL),
(56174, '2017-12-09 09:51:42', NULL, NULL, 15123, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 09:51:42', 'admin-1512781827-15127843021573977', 1, 0, '', NULL, NULL, NULL),
(56175, '2017-12-09 11:28:56', NULL, NULL, 15136, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:28:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56176, '2017-12-09 10:56:57', NULL, NULL, 15129, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:56:57', 'admin-1512781827-15127882177282911', 1, 1, 'SR', NULL, NULL, NULL),
(56177, '2017-12-09 11:26:12', NULL, NULL, 15135, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:26:12', 'admin-1512781827-1512789972127501', 1, 0, '', NULL, NULL, NULL),
(56178, '2017-12-09 10:57:46', NULL, NULL, 15130, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:57:46', 'admin-1512781827-15127882660619763', 1, 1, 'SR', NULL, NULL, NULL),
(56179, '2017-12-09 10:57:46', NULL, NULL, 15130, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:57:46', 'admin-1512781827-15127882660619763', 1, 1, 'SR', NULL, NULL, NULL),
(56180, '2017-12-09 11:08:04', NULL, NULL, 15131, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.80, 0.0000, 0.0000, 11.80, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:08:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56181, '2017-12-09 11:09:43', NULL, NULL, 15131, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:09:43', 'admin-1512781827-15127889831338163', 1, 0, '', NULL, NULL, NULL),
(56182, '2017-12-09 11:09:43', NULL, NULL, 15131, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:09:43', 'admin-1512781827-15127889831338163', 1, 0, '', NULL, NULL, NULL),
(56183, '2017-12-09 11:09:43', NULL, NULL, 15131, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:09:43', 'admin-1512781827-15127889831338163', 1, 0, '', NULL, NULL, NULL),
(56184, '2017-12-09 10:56:57', NULL, NULL, 15129, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:56:57', 'admin-1512781827-15127882177282911', 1, 1, 'SR', NULL, NULL, NULL),
(56185, '2017-12-09 12:49:12', NULL, NULL, 15146, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:49:12', 'admin-1512781827-15127949525221756', 1, 0, '', NULL, NULL, NULL),
(56186, '2017-12-09 11:22:18', NULL, NULL, 15135, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:22:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56187, '2017-12-09 11:09:43', NULL, NULL, 15131, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:09:43', 'admin-1512781827-15127889831338163', 1, 1, 'SR', NULL, NULL, NULL),
(56188, '2017-12-09 11:36:27', NULL, NULL, 15138, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:36:27', 'admin-1512781827-15127905869608762', 1, 1, 'SR', NULL, NULL, NULL),
(56189, '2017-12-09 11:22:11', NULL, NULL, 15134, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:22:11', 'admin-1512781827-15127897318192988', 1, 0, '', NULL, NULL, NULL),
(56190, '2017-12-09 11:20:52', NULL, NULL, 15133, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:20:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56191, '2017-12-09 11:18:08', NULL, NULL, 15132, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:18:08', 'admin-1512781827-1512789488106136', 1, 1, 'SR', NULL, NULL, NULL),
(56192, '2017-12-09 16:03:46', NULL, NULL, 15155, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 16:03:46', 'admin-1512802134-15128066263664850', 1, 0, '', NULL, NULL, NULL),
(56193, '2017-12-09 11:22:11', NULL, NULL, 15134, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:22:11', 'admin-1512781827-15127897318192988', 1, 1, 'SR', NULL, NULL, NULL),
(56194, '2017-12-09 11:18:08', NULL, NULL, 15132, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:18:08', 'admin-1512781827-1512789488106136', 1, 1, 'SR', NULL, NULL, NULL),
(56195, '2017-12-09 11:18:08', NULL, NULL, 15132, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:18:08', 'admin-1512781827-1512789488106136', 1, 0, '', NULL, NULL, NULL),
(56196, '2017-12-09 11:09:43', NULL, NULL, 15131, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:09:43', 'admin-1512781827-15127889831338163', 1, 0, '', NULL, NULL, NULL),
(56197, '2017-12-09 11:13:26', NULL, NULL, 15131, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:13:26', 'admin-1512781827-15127892058769152', 1, 0, '', NULL, NULL, NULL),
(56198, '2017-12-09 11:17:41', NULL, NULL, 15132, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:17:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56199, '2017-12-09 14:26:58', NULL, NULL, 15155, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:26:58', 'admin-1512781827-1512800818277382', 1, 0, '', NULL, NULL, NULL),
(56200, '2017-12-09 11:22:11', NULL, NULL, 15134, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:22:11', 'admin-1512781827-15127897318192988', 1, 1, 'SR', NULL, NULL, NULL),
(56201, '2017-12-09 10:56:40', NULL, NULL, 15129, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:56:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56202, '2017-12-09 10:56:57', NULL, NULL, 15129, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:56:57', 'admin-1512781827-15127882177282911', 1, 0, '', NULL, NULL, NULL),
(56203, '2017-12-09 10:54:49', NULL, NULL, 15128, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:54:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56204, '2017-12-09 09:46:22', NULL, NULL, 15122, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1512802134', 'admin', '2017-12-09 09:46:22', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(56205, '2017-12-09 14:26:58', NULL, NULL, 15155, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:26:58', 'admin-1512781827-1512800818277382', 1, 0, '', NULL, NULL, NULL),
(56206, '2017-12-09 11:09:43', NULL, NULL, 15131, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:09:43', 'admin-1512781827-15127889831338163', 1, 0, '', NULL, NULL, NULL),
(56207, '2017-12-09 11:48:40', NULL, NULL, 15129, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:48:40', 'admin-1512781827-15127913201044361', 1, 0, '', NULL, NULL, NULL),
(56208, '2017-12-09 15:37:03', NULL, NULL, 15160, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:37:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56209, '2017-12-09 10:02:27', NULL, NULL, 15124, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:02:27', 'admin-1512781827-15127849474111847', 1, 0, '', NULL, NULL, NULL),
(56210, '2017-12-09 10:02:27', NULL, NULL, 15124, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:02:27', 'admin-1512781827-15127849474111847', 1, 0, '', NULL, NULL, NULL),
(56211, '2017-12-09 10:57:46', NULL, NULL, 15130, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:57:46', 'admin-1512781827-15127882660619763', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(56212, '2017-12-09 09:26:49', NULL, NULL, 15120, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1512802134', 'admin', '2017-12-09 09:26:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56213, '2017-12-09 09:27:39', NULL, NULL, 15120, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 09:27:39', 'admin-1512781827-15127828598038727', 1, 0, '', NULL, NULL, NULL),
(56214, '2017-12-09 09:27:39', NULL, NULL, 15120, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 09:27:40', 'admin-1512781827-15127828598038727', 1, 0, '', NULL, NULL, NULL),
(56215, '2017-12-09 09:27:40', NULL, NULL, 15120, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 09:27:40', 'admin-1512781827-15127828598038727', 1, 1, 'SR', NULL, NULL, NULL),
(56216, '2017-12-09 12:47:15', NULL, NULL, 15145, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 12:47:15', 'admin-1512781827-15127948352187651', 1, 0, '', NULL, NULL, NULL),
(56217, '2017-12-09 10:55:04', NULL, NULL, 15128, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:55:04', 'admin-1512781827-15127881040935173', 1, 1, 'SR', NULL, NULL, NULL),
(56218, '2017-12-09 15:46:14', NULL, NULL, 15163, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:46:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56219, '2017-12-09 10:57:08', NULL, NULL, 15130, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:57:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56220, '2017-12-09 10:55:04', NULL, NULL, 15128, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:55:04', 'admin-1512781827-15127881040935173', 1, 1, 'SR', NULL, NULL, NULL),
(56221, '2017-12-09 11:48:40', NULL, NULL, 15129, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:48:40', 'admin-1512781827-15127913201044361', 1, 0, '', NULL, NULL, NULL),
(56222, '2017-12-09 10:20:11', NULL, NULL, 15126, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:20:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56223, '2017-12-09 10:20:15', NULL, NULL, 15126, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:20:15', 'admin-1512781827-1512786014903267', 1, 1, 'SR', NULL, NULL, NULL),
(56224, '2017-12-09 10:55:04', NULL, NULL, 15128, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:55:04', 'admin-1512781827-15127881040935173', 1, 0, '', NULL, NULL, NULL),
(56225, '2017-12-09 10:55:04', NULL, NULL, 15128, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:55:04', 'admin-1512781827-15127881040935173', 1, 0, '', NULL, NULL, NULL),
(56226, '2017-12-09 10:09:15', NULL, NULL, 15125, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:09:15', 'admin-1512781827-15127853551459055', 1, 1, 'SR', NULL, NULL, NULL),
(56227, '2017-12-09 10:09:15', NULL, NULL, 15125, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 2, 21.00, 42.0000, 0.0000, 42.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:09:15', 'admin-1512781827-15127853551459055', 1, 0, '', NULL, NULL, NULL),
(56228, '2017-12-09 10:09:15', NULL, NULL, 15125, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:09:15', 'admin-1512781827-15127853551459055', 1, 0, '', NULL, NULL, NULL),
(56229, '2017-12-09 15:41:58', NULL, NULL, 15161, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 15:41:58', 'admin-1512802134-15128053185141423', 1, 1, 'SR', NULL, NULL, NULL),
(56230, '2017-12-09 10:02:27', NULL, NULL, 15124, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:02:27', 'admin-1512781827-15127849474111847', 1, 0, '', NULL, NULL, NULL),
(56231, '2017-12-09 10:09:15', NULL, NULL, 15125, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:09:15', 'admin-1512781827-15127853551459055', 1, 1, 'SR', NULL, NULL, NULL),
(56232, '2017-12-09 10:08:45', NULL, NULL, 15125, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:08:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56233, '2017-12-09 10:02:27', NULL, NULL, 15124, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:02:27', 'admin-1512781827-15127849474111847', 1, 0, '', NULL, NULL, NULL),
(56234, '2017-12-09 10:02:27', NULL, NULL, 15124, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:02:27', 'admin-1512781827-15127849474111847', 1, 0, '', NULL, NULL, NULL),
(56235, '2017-12-09 11:22:24', NULL, NULL, 15135, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 11:22:24', 'admin-1512781827-1512789744065327', 1, 1, 'SR', NULL, NULL, NULL),
(56236, '2017-12-09 10:01:17', NULL, NULL, 15124, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1512802134', 'admin', '2017-12-09 10:01:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56237, '2017-12-09 09:46:46', NULL, NULL, 15122, 0, 207, '142', 'Cheesy Bacon Toast', 'no bacon add scramble egg', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 09:46:46', 'admin-1512781827-15127840064267468', 1, 0, '', NULL, NULL, '10.0'),
(56238, '2017-12-09 09:31:47', NULL, NULL, 15121, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 09:31:47', 'admin-1512781827-15127831073854618', 1, 1, 'SR', NULL, NULL, NULL),
(56239, '2017-12-09 09:31:47', NULL, NULL, 15121, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 09:31:47', 'admin-1512781827-15127831073854618', 1, 0, '', NULL, NULL, NULL),
(56240, '2017-12-09 14:53:30', NULL, NULL, 15157, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 14:53:30', 'admin-1512802134-15128024103289411', 1, 0, '', NULL, NULL, NULL),
(56241, '2017-12-09 09:51:26', NULL, NULL, 15123, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1512802134', 'admin', '2017-12-09 09:51:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56242, '2017-12-09 09:31:47', NULL, NULL, 15121, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 09:31:47', 'admin-1512781827-15127831073854618', 1, 0, '', NULL, NULL, NULL),
(56243, '2017-12-09 09:31:47', NULL, NULL, 15121, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512802134', 'admin', '2017-12-09 09:31:47', 'admin-1512781827-15127831073854618', 1, 0, '', NULL, NULL, NULL),
(56244, '2017-12-10 13:34:38', NULL, NULL, 15193, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:34:38', 'admin-1512867626-15128840784524966', 1, 0, '', NULL, NULL, NULL),
(56245, '2017-12-10 13:20:38', NULL, NULL, 15187, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:20:38', 'admin-1512867626-15128832385339835', 1, 0, '', NULL, NULL, NULL),
(56246, '2017-12-10 14:15:00', NULL, NULL, 15198, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 14:15:00', 'admin-1512867626-15128865006985930', 1, 1, 'SR', NULL, NULL, NULL),
(56247, '2017-12-10 14:16:33', NULL, NULL, 15199, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 14:16:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56248, '2017-12-10 13:57:49', NULL, NULL, 15197, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:57:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56249, '2017-12-10 13:57:52', NULL, NULL, 15197, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:57:52', 'admin-1512867626-15128854726218329', 1, 0, '', NULL, NULL, NULL),
(56250, '2017-12-10 13:28:17', NULL, NULL, 15191, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:28:17', 'admin-1512867626-15128836972431929', 1, 0, '', NULL, NULL, NULL),
(56251, '2017-12-10 12:17:34', NULL, NULL, 15183, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Rice', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:17:34', 'admin-1512867626-15128794539973717', 1, 0, '', NULL, NULL, NULL),
(56252, '2017-12-10 12:33:44', NULL, NULL, 15186, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:33:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56253, '2017-12-10 12:34:03', NULL, NULL, 15186, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:34:03', 'admin-1512867626-15128804430622354', 1, 0, '', NULL, NULL, NULL),
(56254, '2017-12-10 12:34:03', NULL, NULL, 15186, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:34:03', 'admin-1512867626-15128804430622354', 1, 0, '', NULL, NULL, NULL),
(56255, '2017-12-10 12:34:03', NULL, NULL, 15186, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:34:03', 'admin-1512867626-15128804430622354', 1, 1, 'SR', NULL, NULL, NULL),
(56256, '2017-12-10 12:40:54', NULL, NULL, 15187, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:40:55', 'admin-1512867626-15128808548209017', 1, 0, '', NULL, NULL, NULL),
(56257, '2017-12-10 12:34:03', NULL, NULL, 15186, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:34:03', 'admin-1512867626-15128804430622354', 1, 1, 'SR', NULL, NULL, NULL),
(56258, '2017-12-10 12:39:29', NULL, NULL, 15187, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 20.70, 0.0000, 0.0000, 20.70, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:39:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56259, '2017-12-10 12:40:54', NULL, NULL, 15187, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:40:54', 'admin-1512867626-15128808548209017', 1, 0, '', NULL, NULL, NULL),
(56260, '2017-12-10 12:40:54', NULL, NULL, 15187, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:40:54', 'admin-1512867626-15128808548209017', 1, 0, '', NULL, NULL, NULL),
(56261, '2017-12-10 12:40:54', NULL, NULL, 15187, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:40:54', 'admin-1512867626-15128808548209017', 1, 0, '', NULL, NULL, NULL),
(56262, '2017-12-10 12:40:54', NULL, NULL, 15187, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:40:54', 'admin-1512867626-15128808548209017', 1, 0, '', NULL, NULL, NULL),
(56263, '2017-12-10 10:50:54', NULL, NULL, 15177, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:50:54', 'admin-1512867626-15128742543105265', 1, 0, '', NULL, NULL, NULL),
(56264, '2017-12-10 13:08:58', NULL, NULL, 15189, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:08:58', 'admin-1512867626-15128825385594348', 1, 0, '', NULL, NULL, NULL),
(56265, '2017-12-10 10:26:09', NULL, NULL, 15175, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:26:09', 'admin-1512867626-15128727690324969', 1, 1, 'SR', NULL, NULL, NULL),
(56266, '2017-12-10 15:09:48', NULL, NULL, 15201, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 15:09:48', 'admin-1512867626-15128897881297425', 1, 0, '', NULL, NULL, NULL),
(56267, '2017-12-10 15:33:32', NULL, NULL, 15202, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1512867626', 'admin', '2017-12-10 15:33:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56268, '2017-12-10 10:17:18', NULL, NULL, 15174, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:17:18', 'admin-1512867626-15128722382688515', 1, 0, '', NULL, NULL, NULL),
(56269, '2017-12-10 10:17:18', NULL, NULL, 15174, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:17:18', 'admin-1512867626-15128722382688515', 1, 1, 'SR', NULL, NULL, NULL),
(56270, '2017-12-10 10:17:18', NULL, NULL, 15174, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:17:18', 'admin-1512867626-15128722382688515', 1, 0, '', NULL, NULL, NULL),
(56271, '2017-12-10 14:07:19', NULL, NULL, 15197, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 14:07:19', 'admin-1512867626-1512886039149242', 1, 0, '', NULL, NULL, NULL),
(56272, '2017-12-10 14:05:48', NULL, NULL, 15197, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 14:05:48', 'admin-1512867626-15128859485633264', 1, 1, 'SR', NULL, NULL, NULL),
(56273, '2017-12-10 10:10:27', NULL, NULL, 15173, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.70, 0.0000, 0.0000, 15.70, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:10:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56274, '2017-12-10 10:11:24', NULL, NULL, 15173, 0, 181, '116', 'Open Food ', 'toast with butter x 6', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:11:24', 'admin-1512867626-15128718840476830', 1, 0, '', NULL, NULL, NULL),
(56275, '2017-12-10 10:11:24', NULL, NULL, 15173, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:11:24', 'admin-1512867626-15128718840476830', 1, 0, '', NULL, NULL, NULL),
(56276, '2017-12-10 10:11:24', NULL, NULL, 15173, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:11:24', 'admin-1512867626-15128718840476830', 1, 0, '', NULL, NULL, NULL),
(56277, '2017-12-10 10:11:24', NULL, NULL, 15173, 0, 328, '264', 'Basic Blueberries Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:11:24', 'admin-1512867626-15128718840476830', 1, 0, '', NULL, NULL, NULL),
(56278, '2017-12-10 13:12:26', NULL, NULL, 15187, 0, 300, '236', 'Special Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:12:26', 'admin-1512867626-1512882746001699', 1, 0, '', NULL, NULL, NULL),
(56279, '2017-12-10 10:17:18', NULL, NULL, 15174, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:17:18', 'admin-1512867626-15128722382688515', 1, 0, '', NULL, NULL, NULL),
(56280, '2017-12-10 11:00:18', NULL, NULL, 15178, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:00:18', 'admin-1512867626-15128748184774797', 1, 0, '', NULL, NULL, NULL),
(56281, '2017-12-10 11:00:18', NULL, NULL, 15178, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:00:18', 'admin-1512867626-15128748184774797', 1, 0, '', NULL, NULL, NULL),
(56282, '2017-12-10 14:16:58', NULL, NULL, 15199, 0, 323, '259', 'Ginger Cucumber Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 14:16:58', 'admin-1512867626-15128866182323071', 1, 0, '', NULL, NULL, NULL),
(56283, '2017-12-10 14:00:30', NULL, NULL, 15197, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 14:00:30', 'admin-1512867626-15128856306526166', 1, 0, '', NULL, NULL, NULL),
(56284, '2017-12-10 10:23:19', NULL, NULL, 15174, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:23:19', 'admin-1512867626-15128725989536627', 1, 0, '', NULL, NULL, NULL),
(56285, '2017-12-10 09:38:44', NULL, NULL, 15170, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 09:38:44', 'admin-1512867626-15128699243747725', 1, 0, '', NULL, NULL, NULL),
(56286, '2017-12-10 12:54:54', NULL, NULL, 15188, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:54:54', 'admin-1512867626-15128816939136625', 1, 1, 'SR', NULL, NULL, NULL),
(56287, '2017-12-10 13:48:51', NULL, NULL, 15195, 0, 302, '238', 'Ice on the cake', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:48:51', 'admin-1512867626-15128849313511254', 1, 0, '', NULL, NULL, NULL),
(56288, '2017-12-10 13:51:34', NULL, NULL, 15187, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:51:34', 'admin-1512867626-15128850947048424', 1, 0, '', NULL, NULL, NULL),
(56289, '2017-12-10 10:59:22', NULL, NULL, 15178, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:59:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56290, '2017-12-10 11:07:24', NULL, NULL, 15179, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:07:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56291, '2017-12-10 11:00:18', NULL, NULL, 15178, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:00:18', 'admin-1512867626-15128748184774797', 1, 1, 'SR', NULL, NULL, NULL),
(56292, '2017-12-10 11:55:22', NULL, NULL, 15182, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:55:22', 'admin-1512867626-1512878121949942', 1, 0, '', NULL, NULL, NULL),
(56293, '2017-12-10 13:34:38', NULL, NULL, 15193, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:34:38', 'admin-1512867626-15128840784524966', 1, 0, '', NULL, NULL, NULL),
(56294, '2017-12-10 13:34:38', NULL, NULL, 15193, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:34:38', 'admin-1512867626-15128840784524966', 1, 1, 'SR', NULL, NULL, NULL),
(56295, '2017-12-10 13:40:50', NULL, NULL, 15187, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:40:50', 'admin-1512867626-1512884450506184', 1, 1, 'SR', NULL, NULL, NULL),
(56296, '2017-12-10 13:40:50', NULL, NULL, 15187, 0, 323, '259', 'Ginger Cucumber Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:40:50', 'admin-1512867626-1512884450506184', 1, 0, '', NULL, NULL, NULL),
(56297, '2017-12-10 15:41:46', NULL, NULL, 15203, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1512867626', 'admin', '2017-12-10 15:41:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56298, '2017-12-10 10:24:47', NULL, NULL, 15173, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:24:47', 'admin-1512867626-15128726875096844', 1, 0, '', NULL, NULL, NULL),
(56299, '2017-12-10 10:11:24', NULL, NULL, 15173, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:11:24', 'admin-1512867626-15128718840476830', 1, 1, 'SR', NULL, NULL, NULL),
(56300, '2017-12-10 13:33:49', NULL, NULL, 15192, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:33:49', 'admin-1512867626-15128840294197640', 1, 0, '', NULL, NULL, NULL),
(56301, '2017-12-10 15:00:36', NULL, NULL, 15200, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1512867626', 'admin', '2017-12-10 15:00:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56302, '2017-12-10 00:00:00', NULL, NULL, 15203, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 15:00:47', 'admin-1512867626-15128892470998920', 1, 0, '', NULL, NULL, NULL),
(56303, '2017-12-10 15:34:35', NULL, NULL, 15202, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 15:34:35', 'admin-1512867626-15128912754346424', 1, 0, '', NULL, NULL, NULL),
(56304, '2017-12-10 15:34:35', NULL, NULL, 15202, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 15:34:35', 'admin-1512867626-15128912754346424', 1, 1, 'SR', NULL, NULL, NULL),
(56305, '2017-12-10 13:28:17', NULL, NULL, 15191, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:28:17', 'admin-1512867626-15128836972431929', 1, 0, '', NULL, NULL, NULL),
(56306, '2017-12-10 15:01:13', NULL, NULL, 15200, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 15:01:13', 'admin-1512867626-15128892733228460', 1, 1, 'SR', NULL, NULL, NULL),
(56307, '2017-12-10 15:09:43', NULL, NULL, 15201, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1512867626', 'admin', '2017-12-10 15:09:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56308, '2017-12-10 15:00:47', NULL, NULL, 15200, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 15:00:47', 'admin-1512867626-15128892470998920', 1, 0, '', NULL, NULL, NULL),
(56309, '2017-12-10 15:42:00', NULL, NULL, 15203, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 15:42:00', 'admin-1512867626-15128917206631033', 1, 1, 'SR', NULL, NULL, NULL),
(56310, '2017-12-10 14:16:58', NULL, NULL, 15199, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 14:16:58', 'admin-1512867626-15128866182323071', 1, 1, 'SR', NULL, NULL, NULL),
(56311, '2017-12-10 14:16:58', NULL, NULL, 15199, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 14:16:58', 'admin-1512867626-15128866182323071', 1, 0, '', NULL, NULL, NULL),
(56312, '2017-12-10 12:40:55', NULL, NULL, 15187, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:40:55', 'admin-1512867626-15128808548209017', 1, 0, '', NULL, NULL, NULL),
(56313, '2017-12-10 11:09:14', NULL, NULL, 15179, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:09:14', 'admin-1512867626-15128753540663879', 1, 0, '', NULL, NULL, NULL),
(56314, '2017-12-10 11:09:39', NULL, NULL, 15180, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:09:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56315, '2017-12-10 11:09:46', NULL, NULL, 15180, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:09:46', 'admin-1512867626-15128753866457585', 1, 0, '', NULL, NULL, NULL),
(56316, '2017-12-10 11:09:14', NULL, NULL, 15179, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:09:14', 'admin-1512867626-15128753540663879', 1, 0, '', NULL, NULL, NULL),
(56317, '2017-12-10 11:09:14', NULL, NULL, 15179, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:09:14', 'admin-1512867626-15128753540663879', 1, 0, '', NULL, NULL, NULL),
(56318, '2017-12-10 14:15:00', NULL, NULL, 15198, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 14:15:00', 'admin-1512867626-15128865006985930', 1, 0, '', NULL, NULL, NULL),
(56319, '2017-12-10 14:14:48', NULL, NULL, 15198, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1512867626', 'admin', '2017-12-10 14:14:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56320, '2017-12-10 14:15:00', NULL, NULL, 15198, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 14:15:00', 'admin-1512867626-15128865006985930', 1, 1, 'SR', NULL, NULL, NULL),
(56321, '2017-12-10 14:02:32', NULL, NULL, 15193, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 14:02:32', 'admin-1512867626-15128857523381530', 1, 0, '', NULL, NULL, NULL),
(56322, '2017-12-10 11:17:34', NULL, NULL, 15181, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:17:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56323, '2017-12-10 11:18:13', NULL, NULL, 15181, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:18:13', 'admin-1512867626-1512875893442312', 1, 0, '', NULL, NULL, NULL),
(56324, '2017-12-10 11:18:13', NULL, NULL, 15181, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:18:13', 'admin-1512867626-1512875893442312', 1, 0, '', NULL, NULL, NULL),
(56325, '2017-12-10 11:18:13', NULL, NULL, 15181, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:18:13', 'admin-1512867626-1512875893442312', 1, 1, 'SR', NULL, NULL, NULL),
(56326, '2017-12-10 11:18:13', NULL, NULL, 15181, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:18:13', 'admin-1512867626-1512875893442312', 1, 1, 'SR', NULL, NULL, NULL),
(56327, '2017-12-10 11:18:13', NULL, NULL, 15181, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:18:13', 'admin-1512867626-1512875893442312', 1, 1, 'SR', NULL, NULL, NULL),
(56328, '2017-12-10 11:55:08', NULL, NULL, 15182, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:55:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56329, '2017-12-10 13:42:42', NULL, NULL, 15195, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:42:42', 'admin-1512867626-1512884562623581', 1, 1, 'SR', NULL, NULL, NULL),
(56330, '2017-12-10 13:42:42', NULL, NULL, 15195, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:42:42', 'admin-1512867626-1512884562623581', 1, 0, '', NULL, NULL, NULL),
(56331, '2017-12-10 13:42:18', NULL, NULL, 15195, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:42:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56332, '2017-12-10 13:40:58', NULL, NULL, 15194, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:40:58', 'admin-1512867626-15128844582253237', 1, 1, 'SR', 1, NULL, NULL),
(56333, '2017-12-10 13:20:09', NULL, NULL, 15187, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:20:09', 'admin-1512867626-15128832092663715', 1, 1, 'SR', NULL, NULL, NULL),
(56334, '2017-12-10 13:34:27', NULL, NULL, 15193, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:34:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56335, '2017-12-10 13:46:30', NULL, NULL, 15196, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:46:30', 'admin-1512867626-1512884790607533', 1, 1, 'SR', 1, NULL, NULL),
(56336, '2017-12-10 13:33:44', NULL, NULL, 15192, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:33:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56337, '2017-12-10 13:27:56', NULL, NULL, 15191, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:27:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56338, '2017-12-10 13:04:09', NULL, NULL, 15190, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:04:09', 'admin-1512867626-15128822496985967', 1, 0, '', NULL, NULL, NULL),
(56339, '2017-12-10 13:03:28', NULL, NULL, 15190, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:03:28', 'admin-1512867626-15128822085867470', 1, 0, '', NULL, NULL, NULL),
(56340, '2017-12-10 13:03:28', NULL, NULL, 15190, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:03:28', 'admin-1512867626-15128822085867470', 1, 1, 'SR', NULL, NULL, NULL),
(56341, '2017-12-10 13:01:52', NULL, NULL, 15189, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:01:52', 'admin-1512867626-15128821125486335', 1, 1, 'SR', NULL, NULL, NULL),
(56342, '2017-12-10 13:01:47', NULL, NULL, 15189, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:01:47', 'admin-1512867626-15128821078499122', 1, 0, '', NULL, NULL, NULL),
(56343, '2017-12-10 13:01:47', NULL, NULL, 15189, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:01:47', 'admin-1512867626-15128821078499122', 1, 0, '', NULL, NULL, NULL),
(56344, '2017-12-10 13:01:35', NULL, NULL, 15189, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:01:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56345, '2017-12-10 12:08:11', NULL, NULL, 15184, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:08:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56346, '2017-12-10 11:55:22', NULL, NULL, 15182, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:55:22', 'admin-1512867626-1512878121949942', 1, 0, '', NULL, NULL, NULL),
(56347, '2017-12-10 11:55:22', NULL, NULL, 15182, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:55:22', 'admin-1512867626-1512878121949942', 1, 1, 'SR', NULL, NULL, NULL),
(56348, '2017-12-10 13:22:34', NULL, NULL, 15187, 0, 338, '274', 'Chocolate Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:22:34', 'admin-1512867626-1512883354569514', 1, 0, '', NULL, NULL, NULL),
(56349, '2017-12-10 12:54:31', NULL, NULL, 15188, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:54:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56350, '2017-12-10 12:54:45', NULL, NULL, 15188, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:54:45', 'admin-1512867626-15128816855901770', 1, 0, '', NULL, NULL, NULL),
(56351, '2017-12-10 12:54:45', NULL, NULL, 15188, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:54:45', 'admin-1512867626-15128816855901770', 1, 0, '', NULL, NULL, NULL),
(56352, '2017-12-10 12:40:55', NULL, NULL, 15187, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:40:55', 'admin-1512867626-15128808548209017', 1, 1, 'SR', NULL, NULL, NULL),
(56353, '2017-12-10 10:34:43', NULL, NULL, 15176, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:34:43', 'admin-1512867626-15128732834343862', 1, 1, 'SR', NULL, NULL, NULL),
(56354, '2017-12-10 10:50:30', NULL, NULL, 15177, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.50, 0.0000, 0.0000, 9.50, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:50:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56355, '2017-12-10 10:50:54', NULL, NULL, 15177, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:50:54', 'admin-1512867626-15128742543105265', 1, 0, '', NULL, NULL, NULL),
(56356, '2017-12-10 10:50:54', NULL, NULL, 15177, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:50:54', 'admin-1512867626-15128742543105265', 1, 0, '', NULL, NULL, NULL),
(56357, '2017-12-10 10:50:54', NULL, NULL, 15177, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:50:54', 'admin-1512867626-15128742543105265', 1, 0, '', NULL, NULL, NULL),
(56358, '2017-12-10 10:50:54', NULL, NULL, 15177, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:50:54', 'admin-1512867626-15128742543105265', 1, 1, 'SR', NULL, NULL, NULL),
(56359, '2017-12-10 12:14:05', NULL, NULL, 15185, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:14:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56360, '2017-12-10 12:14:31', NULL, NULL, 15185, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:14:31', 'admin-1512867626-15128792716481110', 1, 0, '', NULL, NULL, NULL),
(56361, '2017-12-10 12:40:55', NULL, NULL, 15187, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:40:55', 'admin-1512867626-15128808548209017', 1, 1, 'SR', NULL, NULL, NULL),
(56362, '2017-12-10 12:09:14', NULL, NULL, 15184, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:09:14', 'admin-1512867626-1512878954067914', 1, 0, '', NULL, NULL, NULL),
(56363, '2017-12-10 12:14:31', NULL, NULL, 15185, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:14:31', 'admin-1512867626-15128792716481110', 1, 0, '', NULL, NULL, NULL),
(56364, '2017-12-10 12:10:28', NULL, NULL, 15184, 0, 336, '272', 'iced Yuzu', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:10:28', 'admin-1512867626-15128790280983423', 1, 0, '', NULL, NULL, NULL),
(56365, '2017-12-10 12:01:37', NULL, NULL, 15183, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:01:37', 'admin-1512867626-15128784978324761', 1, 0, '', NULL, NULL, NULL),
(56366, '2017-12-10 12:01:37', NULL, NULL, 15183, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:01:37', 'admin-1512867626-15128784978324761', 1, 0, '', NULL, NULL, NULL),
(56367, '2017-12-10 12:05:03', NULL, NULL, 15183, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:05:03', 'admin-1512867626-15128787034685997', 1, 0, '', NULL, NULL, NULL),
(56368, '2017-12-10 12:01:38', NULL, NULL, 15183, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:01:38', 'admin-1512867626-15128784978324761', 1, 0, '', NULL, NULL, NULL),
(56369, '2017-12-10 12:01:00', NULL, NULL, 15183, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:01:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56370, '2017-12-10 10:26:09', NULL, NULL, 15175, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:26:09', 'admin-1512867626-15128727690324969', 1, 0, '', NULL, NULL, NULL),
(56371, '2017-12-10 13:02:51', NULL, NULL, 15190, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1512867626', 'admin', '2017-12-10 13:02:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56372, '2017-12-10 11:32:12', NULL, NULL, 15181, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:32:12', 'admin-1512867626-1512876731978962', 1, 0, '', NULL, NULL, NULL),
(56373, '2017-12-10 11:09:14', NULL, NULL, 15179, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:09:14', 'admin-1512867626-15128753540663879', 1, 1, 'SR', NULL, NULL, NULL),
(56374, '2017-12-10 11:09:14', NULL, NULL, 15179, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:09:14', 'admin-1512867626-15128753540663879', 1, 0, '', NULL, NULL, NULL),
(56375, '2017-12-10 09:38:02', NULL, NULL, 15169, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 09:38:02', 'admin-1512867626-15128698823069980', 1, 1, 'SR', NULL, NULL, NULL),
(56376, '2017-12-10 09:08:47', NULL, NULL, 15167, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 09:08:47', 'admin-1512867626-15128681268459417', 1, 1, 'SR', NULL, NULL, NULL),
(56377, '2017-12-10 10:11:24', NULL, NULL, 15173, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:11:24', 'admin-1512867626-15128718840476830', 1, 1, 'SR', NULL, NULL, NULL),
(56378, '2017-12-10 11:26:54', NULL, NULL, 15177, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 11:26:54', 'admin-1512867626-1512876414160783', 1, 1, 'SR', NULL, NULL, NULL),
(56379, '2017-12-10 15:34:35', NULL, NULL, 15202, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 15:34:35', 'admin-1512867626-15128912754346424', 1, 1, 'SR', NULL, NULL, NULL),
(56380, '2017-12-10 14:15:00', NULL, NULL, 15198, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 14:15:00', 'admin-1512867626-15128865006985930', 1, 0, '', NULL, NULL, NULL),
(56381, '2017-12-10 09:38:44', NULL, NULL, 15170, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 09:38:44', 'admin-1512867626-15128699243747725', 1, 1, 'SR', NULL, NULL, NULL),
(56382, '2017-12-10 09:41:56', NULL, NULL, 15171, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1512867626', 'admin', '2017-12-10 09:41:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56383, '2017-12-10 09:42:54', NULL, NULL, 15171, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 09:42:54', 'admin-1512867626-15128701742173441', 1, 0, '', NULL, NULL, NULL),
(56384, '2017-12-10 15:34:35', NULL, NULL, 15202, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 15:34:35', 'admin-1512867626-15128912754346424', 1, 1, 'SR', NULL, NULL, NULL),
(56385, '2017-12-10 10:34:43', NULL, NULL, 15176, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:34:43', 'admin-1512867626-15128732834343862', 1, 1, 'SR', NULL, NULL, NULL),
(56386, '2017-12-10 10:34:43', NULL, NULL, 15176, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:34:43', 'admin-1512867626-15128732834343862', 1, 0, '', NULL, NULL, NULL),
(56387, '2017-12-10 10:34:43', NULL, NULL, 15176, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:34:43', 'admin-1512867626-15128732834343862', 1, 0, '', NULL, NULL, NULL),
(56388, '2017-12-10 10:34:24', NULL, NULL, 15176, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:34:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56389, '2017-12-10 10:26:09', NULL, NULL, 15175, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:26:09', 'admin-1512867626-15128727690324969', 1, 0, '', NULL, NULL, NULL),
(56390, '2017-12-10 10:25:54', NULL, NULL, 15175, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:25:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56391, '2017-12-10 10:16:53', NULL, NULL, 15174, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:16:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56392, '2017-12-10 09:08:47', NULL, NULL, 15167, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 09:08:47', 'admin-1512867626-15128681268459417', 1, 0, '', NULL, NULL, NULL),
(56393, '2017-12-10 10:11:24', NULL, NULL, 15173, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 3, 12.00, 36.0000, 0.0000, 36.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:11:24', 'admin-1512867626-15128718840476830', 1, 1, 'SR', NULL, NULL, NULL),
(56394, '2017-12-10 10:11:24', NULL, NULL, 15173, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:11:24', 'admin-1512867626-15128718840476830', 1, 0, '', NULL, NULL, NULL),
(56395, '2017-12-10 09:42:54', NULL, NULL, 15171, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 09:42:54', 'admin-1512867626-15128701742173441', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(56396, '2017-12-10 10:04:52', NULL, NULL, 15172, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:04:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56397, '2017-12-10 10:05:11', NULL, NULL, 15172, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:05:11', 'admin-1512867626-15128715115908132', 1, 0, '', NULL, NULL, NULL),
(56398, '2017-12-10 10:11:24', NULL, NULL, 15173, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:11:24', 'admin-1512867626-15128718840476830', 1, 0, '', NULL, NULL, NULL),
(56399, '2017-12-10 10:05:19', NULL, NULL, 15168, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:05:19', 'admin-1512867626-15128715196129876', 1, 1, 'SR', NULL, NULL, NULL),
(56400, '2017-12-10 10:05:11', NULL, NULL, 15172, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 10:05:11', 'admin-1512867626-15128715115908132', 1, 0, '', NULL, NULL, NULL),
(56401, '2017-12-10 09:42:54', NULL, NULL, 15171, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 09:42:54', 'admin-1512867626-15128701742173441', 1, 0, '', NULL, NULL, NULL),
(56402, '2017-12-10 09:42:54', NULL, NULL, 15171, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 09:42:54', 'admin-1512867626-15128701742173441', 1, 1, 'SR', NULL, NULL, NULL),
(56403, '2017-12-10 09:38:02', NULL, NULL, 15169, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 09:38:02', 'admin-1512867626-15128698823069980', 1, 1, 'SR', NULL, NULL, NULL),
(56404, '2017-12-10 12:40:55', NULL, NULL, 15187, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 12:40:55', 'admin-1512867626-15128808548209017', 1, 1, 'SR', NULL, NULL, NULL),
(56405, '2017-12-10 09:38:36', NULL, NULL, 15170, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1512867626', 'admin', '2017-12-10 09:38:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56406, '2017-12-10 09:29:41', NULL, NULL, 15168, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1512867626', 'admin', '2017-12-10 09:29:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56407, '2017-12-10 09:29:49', NULL, NULL, 15168, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 09:29:49', 'admin-1512867626-15128693891724249', 1, 0, '', NULL, NULL, NULL),
(56408, '2017-12-10 09:29:49', NULL, NULL, 15168, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 09:29:49', 'admin-1512867626-15128693891724249', 1, 1, 'SR', NULL, NULL, NULL),
(56409, '2017-12-10 09:37:40', NULL, NULL, 15169, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1512867626', 'admin', '2017-12-10 09:37:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56410, '2017-12-10 09:38:02', NULL, NULL, 15169, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 09:38:02', 'admin-1512867626-15128698823069980', 1, 0, '', NULL, NULL, NULL),
(56411, '2017-12-10 09:38:02', NULL, NULL, 15169, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 09:38:02', 'admin-1512867626-15128698823069980', 1, 0, '', NULL, NULL, NULL),
(56412, '2017-12-10 09:08:33', NULL, NULL, 15167, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1512867626', 'admin', '2017-12-10 09:08:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56413, '2017-12-10 09:08:46', NULL, NULL, 15167, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512867626', 'admin', '2017-12-10 09:08:46', 'admin-1512867626-15128681268459417', 1, 0, '', NULL, NULL, NULL),
(56414, '2017-12-11 10:39:20', NULL, NULL, 15210, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:39:20', 'admin-1512954184-15129599604077617', 1, 1, 'SR', NULL, NULL, NULL),
(56415, '2017-12-11 10:39:20', NULL, NULL, 15210, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:39:20', 'admin-1512954184-15129599604077617', 1, 1, 'SR', NULL, NULL, NULL),
(56416, '2017-12-11 10:39:20', NULL, NULL, 15210, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:39:20', 'admin-1512954184-15129599604077617', 1, 1, 'SR', NULL, NULL, NULL),
(56417, '2017-12-11 10:45:42', NULL, NULL, 15211, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:45:42', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(56418, '2017-12-11 11:15:36', NULL, NULL, 15214, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 11:15:36', 'admin-1512954184-15129621358451799', 1, 1, 'SR', NULL, NULL, NULL),
(56419, '2017-12-11 10:58:16', NULL, NULL, 15213, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:58:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56420, '2017-12-11 10:58:52', NULL, NULL, 15213, 0, 153, '87', 'Wake Me Up!', 'add sunny side up', 'Meals', 'Morning Bites ', 1, 24.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:58:52', 'admin-1512954184-15129611321341198', 1, 0, '', NULL, NULL, NULL),
(56421, '2017-12-11 10:58:52', NULL, NULL, 15213, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:58:52', 'admin-1512954184-15129611321341198', 1, 0, '', NULL, NULL, NULL),
(56422, '2017-12-11 10:58:52', NULL, NULL, 15213, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:58:52', 'admin-1512954184-15129611321341198', 1, 0, '', NULL, NULL, NULL),
(56423, '2017-12-11 11:10:01', NULL, NULL, 15214, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 11:10:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56424, '2017-12-11 13:14:33', NULL, NULL, 15223, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 13:14:33', 'admin-1512954184-1512969273156687', 1, 0, '', NULL, NULL, NULL),
(56425, '2017-12-11 11:15:36', NULL, NULL, 15214, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 11:15:36', 'admin-1512954184-15129621358451799', 1, 1, 'SR', NULL, NULL, NULL),
(56426, '2017-12-11 10:39:20', NULL, NULL, 15210, 0, 158, '92', 'Banana Stuffed Nutella Toast ', 'banana put aside', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:39:20', 'admin-1512954184-15129599604077617', 1, 0, '', NULL, NULL, NULL),
(56427, '2017-12-11 13:22:56', NULL, NULL, 15224, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 13:22:56', 'admin-1512954184-15129697760638036', 1, 1, 'SR', NULL, NULL, NULL),
(56428, '2017-12-11 13:27:19', NULL, NULL, 15222, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 13:27:19', 'admin-1512954184-15129700389495395', 1, 0, '', NULL, NULL, NULL),
(56429, '2017-12-11 09:05:58', NULL, NULL, 15204, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 09:05:58', 'admin-1512954184-15129543587158185', 1, 1, 'SR', NULL, NULL, NULL),
(56430, '2017-12-11 12:34:19', NULL, NULL, 15219, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 12:34:19', 'admin-1512954184-15129668590053464', 1, 1, 'SR', NULL, NULL, NULL),
(56431, '2017-12-11 12:41:26', NULL, NULL, 15220, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1512954184', 'admin', '2017-12-11 12:41:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56432, '2017-12-11 13:22:47', NULL, NULL, 15224, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1512954184', 'admin', '2017-12-11 13:22:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56433, '2017-12-11 13:14:23', NULL, NULL, 15223, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1512954184', 'admin', '2017-12-11 13:14:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56434, '2017-12-11 13:33:00', NULL, NULL, 15220, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 13:33:00', 'admin-1512954184-1512970380218715', 1, 0, '', NULL, NULL, NULL),
(56435, '2017-12-11 13:50:54', NULL, NULL, 15225, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1512954184', 'admin', '2017-12-11 13:50:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56436, '2017-12-11 11:32:22', NULL, NULL, 15216, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1512954184', 'admin', '2017-12-11 11:32:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56437, '2017-12-11 11:32:30', NULL, NULL, 15216, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 11:32:30', 'admin-1512954184-15129631506275276', 1, 1, 'SR', NULL, NULL, NULL),
(56438, '2017-12-11 11:32:30', NULL, NULL, 15216, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 11:32:30', 'admin-1512954184-15129631506275276', 1, 1, 'SR', NULL, NULL, NULL),
(56439, '2017-12-11 13:51:00', NULL, NULL, 15225, 0, 316, '252', 'AA Set - Sesame Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 13:51:00', 'admin-1512954184-15129714608044820', 1, 0, '', NULL, NULL, NULL),
(56440, '2017-12-11 13:51:00', NULL, NULL, 15225, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 13:51:00', 'admin-1512954184-15129714608044820', 1, 0, '', NULL, NULL, NULL),
(56441, '2017-12-11 15:41:39', NULL, NULL, 15229, 0, 339, '275', '100+', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 15:41:39', 'admin-1512954184-15129780998472993', 1, 0, '', 1, NULL, NULL),
(56442, '2017-12-11 15:41:48', NULL, NULL, 15230, 0, 339, '275', '100+', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 15:41:48', 'admin-1512954184-15129781079449858', 1, 0, '', 1, NULL, NULL),
(56443, '2017-12-11 10:45:51', NULL, NULL, 15211, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:45:51', 'admin-1512954184-15129603516851114', 1, 1, 'SR', NULL, NULL, '10.0'),
(56444, '2017-12-11 11:17:20', NULL, NULL, 15215, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 11:17:20', 'admin-1512954184-15129622403378929', 1, 0, '', NULL, NULL, NULL),
(56445, '2017-12-11 12:31:49', NULL, NULL, 15218, 0, 319, '255', 'AA Set - Spicy Shrimp Macaroni', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 12:31:49', 'admin-1512954184-15129667092264151', 1, 0, '', 1, NULL, '10.0'),
(56446, '2017-12-11 11:15:36', NULL, NULL, 15214, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 11:15:36', 'admin-1512954184-15129621358451799', 1, 0, '', NULL, NULL, NULL),
(56447, '2017-12-11 12:55:45', NULL, NULL, 15221, 0, 181, '116', 'Open Food ', 'bacon,egg', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 12:55:45', 'admin-1512954184-1512968145504528', 1, 0, '', 1, NULL, NULL),
(56448, '2017-12-11 12:55:52', NULL, NULL, 15222, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1512954184', 'admin', '2017-12-11 12:55:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56449, '2017-12-11 12:55:57', NULL, NULL, 15222, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 12:55:57', 'admin-1512954184-1512968157087432', 1, 1, 'SR', NULL, NULL, NULL),
(56450, '2017-12-11 13:09:41', NULL, NULL, 15220, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 13:09:41', 'admin-1512954184-15129689818386635', 1, 1, 'SR', NULL, NULL, NULL),
(56451, '2017-12-11 13:09:42', NULL, NULL, 15220, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 13:09:42', 'admin-1512954184-15129689818386635', 1, 1, 'SR', NULL, NULL, NULL),
(56452, '2017-12-11 11:17:20', NULL, NULL, 15215, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 11:17:20', 'admin-1512954184-15129622403378929', 1, 1, 'SR', NULL, NULL, NULL),
(56453, '2017-12-11 12:07:38', NULL, NULL, 15217, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1512954184', 'admin', '2017-12-11 12:07:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56454, '2017-12-11 12:07:49', NULL, NULL, 15217, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 12:07:49', 'admin-1512954184-1512965269562781', 1, 0, '', NULL, NULL, NULL),
(56455, '2017-12-11 12:07:49', NULL, NULL, 15217, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 12:07:49', 'admin-1512954184-1512965269562781', 1, 1, 'SR', NULL, NULL, NULL),
(56456, '2017-12-11 09:30:50', NULL, NULL, 15205, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1512954184', 'admin', '2017-12-11 09:30:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56457, '2017-12-11 09:30:52', NULL, NULL, 15205, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 09:30:52', 'admin-1512954184-151295585250256', 1, 1, 'SR', NULL, NULL, NULL),
(56458, '2017-12-11 13:22:56', NULL, NULL, 15224, 0, 331, '267', 'Yuzu Marmalade Pancake', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 13:22:56', 'admin-1512954184-15129697760638036', 1, 0, '', NULL, NULL, NULL),
(56459, '2017-12-11 12:41:33', NULL, NULL, 15220, 0, 314, '250', 'AA Set - Thai Styled Garlic Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 12:41:33', 'admin-1512954184-15129672936962040', 1, 0, '', NULL, NULL, NULL),
(56460, '2017-12-11 13:14:33', NULL, NULL, 15223, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 13:14:33', 'admin-1512954184-1512969273156687', 1, 1, 'SR', NULL, NULL, NULL),
(56461, '2017-12-11 12:41:33', NULL, NULL, 15220, 0, 314, '250', 'AA Set - Thai Styled Garlic Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 12:41:33', 'admin-1512954184-15129672936962040', 1, 0, '', NULL, NULL, NULL),
(56462, '2017-12-11 12:34:15', NULL, NULL, 15219, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1512954184', 'admin', '2017-12-11 12:34:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56463, '2017-12-11 11:33:29', NULL, NULL, 15213, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 11:33:29', 'admin-1512954184-15129632096442048', 1, 1, 'SR', NULL, NULL, NULL),
(56464, '2017-12-11 11:17:11', NULL, NULL, 15215, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1512954184', 'admin', '2017-12-11 11:17:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56465, '2017-12-11 10:45:51', NULL, NULL, 15211, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:45:51', 'admin-1512954184-15129603516851114', 1, 0, '', NULL, NULL, '10.0'),
(56466, '2017-12-11 11:15:35', NULL, NULL, 15214, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 11:15:35', 'admin-1512954184-15129621358451799', 1, 0, '', NULL, NULL, NULL),
(56467, '2017-12-11 10:02:03', NULL, NULL, 15206, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:02:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56468, '2017-12-11 10:02:22', NULL, NULL, 15206, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:02:22', 'admin-1512954184-1512957742735337', 1, 0, '', NULL, NULL, NULL),
(56469, '2017-12-11 10:02:22', NULL, NULL, 15206, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:02:22', 'admin-1512954184-1512957742735337', 1, 1, 'SR', NULL, NULL, NULL),
(56470, '2017-12-11 10:04:32', NULL, NULL, 15207, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:04:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56471, '2017-12-11 10:04:51', NULL, NULL, 15207, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 3, 8.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:04:51', 'admin-1512954184-15129578916707295', 1, 1, 'SR', NULL, NULL, NULL),
(56472, '2017-12-11 10:04:51', NULL, NULL, 15207, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:04:51', 'admin-1512954184-15129578916707295', 1, 1, 'SR', NULL, NULL, NULL),
(56473, '2017-12-11 10:04:51', NULL, NULL, 15207, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:04:51', 'admin-1512954184-15129578916707295', 1, 1, 'SR', NULL, NULL, NULL),
(56474, '2017-12-11 10:46:28', NULL, NULL, 15212, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:46:28', 'admin-1512954184-15129603886673885', 1, 0, '', NULL, NULL, NULL),
(56475, '2017-12-11 10:46:28', NULL, NULL, 15212, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:46:28', 'admin-1512954184-15129603886673885', 1, 1, 'SR', NULL, NULL, NULL),
(56476, '2017-12-11 10:45:51', NULL, NULL, 15211, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:45:51', 'admin-1512954184-15129603516851114', 1, 0, '', NULL, NULL, '10.0'),
(56477, '2017-12-11 10:46:22', NULL, NULL, 15212, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:46:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56478, '2017-12-11 10:45:51', NULL, NULL, 15211, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:45:51', 'admin-1512954184-15129603516851114', 1, 1, 'SR', NULL, NULL, '10.0'),
(56479, '2017-12-11 10:39:20', NULL, NULL, 15210, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:39:20', 'admin-1512954184-15129599604077617', 1, 1, 'SR', NULL, NULL, NULL),
(56480, '2017-12-11 10:39:00', NULL, NULL, 15210, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:39:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56481, '2017-12-11 10:08:26', NULL, NULL, 15208, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:08:26', 'admin-1512954184-15129581065606213', 1, 1, 'SR', NULL, NULL, NULL),
(56482, '2017-12-11 10:08:20', NULL, NULL, 15208, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:08:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56483, '2017-12-11 10:04:51', NULL, NULL, 15207, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 10:04:51', 'admin-1512954184-15129578916707295', 1, 1, 'SR', NULL, NULL, NULL),
(56484, '2017-12-11 09:05:51', NULL, NULL, 15204, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1512954184', 'admin', '2017-12-11 09:05:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56485, '2017-12-11 09:05:58', NULL, NULL, 15204, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1512954184', 'admin', '2017-12-11 09:05:58', 'admin-1512954184-15129543587158185', 1, 0, '', NULL, NULL, NULL),
(56486, '2017-12-13 11:08:11', NULL, NULL, 15234, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1513127221', 'admin', '2017-12-13 11:08:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56487, '2017-12-13 11:08:19', NULL, NULL, 15234, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 11:08:19', 'admin-1513127221-15131344994433573', 1, 0, '', NULL, NULL, NULL),
(56488, '2017-12-13 11:08:19', NULL, NULL, 15234, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 11:08:19', 'admin-1513127221-15131344994433573', 1, 1, 'SR', NULL, NULL, NULL),
(56489, '2017-12-13 11:13:32', NULL, NULL, 15235, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1513127221', 'admin', '2017-12-13 11:13:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56490, '2017-12-13 12:45:26', NULL, NULL, 15237, 0, 314, '250', 'AA Set - Thai Styled Garlic Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 12:45:26', 'admin-1513127221-15131403267927128', 1, 0, '', NULL, NULL, NULL),
(56491, '2017-12-13 13:09:24', NULL, NULL, 15236, 0, 181, '116', 'Open Food ', 'scramble eggs', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 13:09:24', 'admin-1513127221-1513141764485993', 1, 0, '', NULL, NULL, NULL),
(56492, '2017-12-13 12:57:08', NULL, NULL, 15236, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 12:57:08', 'admin-1513127221-15131410287836059', 1, 0, '', NULL, NULL, NULL),
(56493, '2017-12-13 12:55:46', NULL, NULL, 15236, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 12:55:46', 'admin-1513127221-15131409458342484', 1, 1, 'SR', NULL, NULL, NULL),
(56494, '2017-12-13 12:57:08', NULL, NULL, 15236, 0, 319, '255', 'AA Set - Spicy Shrimp Macaroni', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 12:57:08', 'admin-1513127221-15131410287836059', 1, 0, '', NULL, NULL, NULL),
(56495, '2017-12-13 13:30:46', NULL, NULL, 15240, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 13:30:46', 'admin-1513127221-15131430466812933', 1, 1, 'SR', NULL, NULL, NULL),
(56496, '2017-12-13 15:40:56', NULL, NULL, 15243, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1513127221', 'admin', '2017-12-13 15:40:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56497, '2017-12-13 15:41:05', NULL, NULL, 15243, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 15:41:05', 'admin-1513127221-15131508655419848', 1, 1, 'SR', NULL, NULL, NULL),
(56498, '2017-12-13 13:43:42', NULL, NULL, 15240, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 13:43:42', 'admin-1513127221-15131438227601139', 1, 1, 'SR', NULL, NULL, NULL),
(56499, '2017-12-13 13:30:23', NULL, NULL, 15240, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.20, 0.0000, 0.0000, 13.20, 1, '27', 1, '1513127221', 'admin', '2017-12-13 13:30:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56500, '2017-12-13 13:30:46', NULL, NULL, 15240, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 13:30:46', 'admin-1513127221-15131430466812933', 1, 0, '', NULL, NULL, NULL),
(56501, '2017-12-13 13:28:47', NULL, NULL, 15239, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 13:28:47', 'admin-1513127221-15131429276278044', 1, 0, '', NULL, NULL, '10.0'),
(56502, '2017-12-13 13:28:47', NULL, NULL, 15239, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 13:28:47', 'admin-1513127221-15131429276278044', 1, 0, '', NULL, NULL, '10.0'),
(56503, '2017-12-13 16:55:30', NULL, NULL, 15247, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 16:55:30', 'admin-1513127221-15131553301669236', 1, 1, 'SR', NULL, NULL, NULL),
(56504, '2017-12-13 16:55:24', NULL, NULL, 15247, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1513127221', 'admin', '2017-12-13 16:55:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56505, '2017-12-13 16:04:30', NULL, NULL, 15246, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 16:04:30', 'admin-1513127221-15131522706902176', 1, 0, '', 1, NULL, '10.0'),
(56506, '2017-12-13 16:04:30', NULL, NULL, 15246, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 16:04:30', 'admin-1513127221-15131522706902176', 1, 0, '', 1, NULL, '10.0'),
(56507, '2017-12-13 16:45:10', NULL, NULL, 15244, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 16:45:10', 'admin-1513127221-15131547104703914', 1, 1, 'SR', NULL, NULL, NULL),
(56508, '2017-12-13 16:45:10', NULL, NULL, 15244, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 16:45:10', 'admin-1513127221-15131547104703914', 1, 0, '', NULL, NULL, NULL),
(56509, '2017-12-13 16:55:30', NULL, NULL, 15247, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 16:55:30', 'admin-1513127221-15131553301669236', 1, 1, 'SR', NULL, NULL, NULL),
(56510, '2017-12-13 15:43:19', NULL, NULL, 15245, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 15:43:19', 'admin-1513127221-15131509993638795', 1, 0, '', 1, NULL, NULL),
(56511, '2017-12-13 15:43:19', NULL, NULL, 15245, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 15:43:19', 'admin-1513127221-15131509993638795', 1, 0, '', 1, NULL, NULL),
(56512, '2017-12-13 15:43:19', NULL, NULL, 15245, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 15:43:19', 'admin-1513127221-15131509993638795', 1, 0, '', 1, NULL, NULL),
(56513, '2017-12-13 15:43:19', NULL, NULL, 15245, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 15:43:19', 'admin-1513127221-15131509993638795', 1, 0, '', 1, NULL, NULL),
(56514, '2017-12-13 15:43:19', NULL, NULL, 15245, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 15:43:19', 'admin-1513127221-15131509993638795', 1, 0, '', 1, NULL, NULL),
(56515, '2017-12-13 15:43:19', NULL, NULL, 15245, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 15:43:19', 'admin-1513127221-15131509993638795', 1, 0, '', 1, NULL, NULL),
(56516, '2017-12-13 15:42:36', NULL, NULL, 15244, 0, 316, '252', 'AA Set - Sesame Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 15:42:36', 'admin-1513127221-15131509560389587', 1, 0, '', NULL, NULL, NULL),
(56517, '2017-12-13 13:26:32', NULL, NULL, 15238, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 13:26:32', 'admin-1513127221-15131427922396875', 1, 1, 'SR', NULL, NULL, NULL),
(56518, '2017-12-13 14:09:23', NULL, NULL, 15239, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 14:09:23', 'admin-1513127221-15131453628727540', 1, 1, 'SR', NULL, NULL, '10.0'),
(56519, '2017-12-13 14:38:18', NULL, NULL, 15241, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1513127221', 'admin', '2017-12-13 14:38:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56520, '2017-12-13 15:29:39', NULL, NULL, 15242, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 15:29:39', 'admin-1513127221-15131501796263322', 1, 1, 'SR', 1, NULL, NULL),
(56521, '2017-12-13 14:38:42', NULL, NULL, 15241, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 14:38:42', 'admin-1513127221-15131471227969035', 1, 1, 'SR', NULL, NULL, NULL),
(56522, '2017-12-13 14:38:42', NULL, NULL, 15241, 0, 319, '255', 'AA Set - Spicy Shrimp Macaroni', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 14:38:42', 'admin-1513127221-15131471227969035', 1, 0, '', NULL, NULL, NULL),
(56523, '2017-12-13 13:52:51', NULL, NULL, 15238, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 13:52:51', 'admin-1513127221-15131443712359947', 1, 1, 'SR', NULL, NULL, NULL),
(56524, '2017-12-13 13:44:34', NULL, NULL, 15240, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 13:44:34', 'admin-1513127221-15131438739168995', 1, 1, 'SR', NULL, NULL, NULL),
(56525, '2017-12-13 13:48:12', NULL, NULL, 15240, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 13:48:12', 'admin-1513127221-15131440926019743', 1, 0, '', NULL, NULL, NULL),
(56526, '2017-12-13 13:30:46', NULL, NULL, 15240, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 13:30:46', 'admin-1513127221-15131430466812933', 1, 1, 'SR', NULL, NULL, NULL),
(56527, '2017-12-13 13:30:46', NULL, NULL, 15240, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 13:30:46', 'admin-1513127221-15131430466812933', 1, 0, '', NULL, NULL, NULL),
(56528, '2017-12-13 13:30:46', NULL, NULL, 15240, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 13:30:46', 'admin-1513127221-15131430466812933', 1, 1, 'SR', NULL, NULL, NULL),
(56529, '2017-12-13 13:30:46', NULL, NULL, 15240, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 13:30:46', 'admin-1513127221-15131430466812933', 1, 0, '', NULL, NULL, NULL),
(56530, '2017-12-13 14:38:42', NULL, NULL, 15241, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 14:38:42', 'admin-1513127221-15131471227969035', 1, 0, '', NULL, NULL, NULL),
(56531, '2017-12-13 13:28:47', NULL, NULL, 15239, 0, 319, '255', 'AA Set - Spicy Shrimp Macaroni', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 13:28:47', 'admin-1513127221-15131429276278044', 1, 0, '', NULL, NULL, '10.0'),
(56532, '2017-12-13 14:01:12', NULL, NULL, 15240, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 14:01:12', 'admin-1513127221-15131448724314264', 1, 0, '', NULL, NULL, NULL),
(56533, '2017-12-13 13:28:24', NULL, NULL, 15239, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 13:28:24', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(56534, '2017-12-13 15:42:28', NULL, NULL, 15244, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1513127221', 'admin', '2017-12-13 15:42:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56535, '2017-12-13 13:26:32', NULL, NULL, 15238, 0, 314, '250', 'AA Set - Thai Styled Garlic Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 13:26:32', 'admin-1513127221-15131427922396875', 1, 0, '', NULL, NULL, NULL),
(56536, '2017-12-13 10:22:03', NULL, NULL, 15232, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1513127221', 'admin', '2017-12-13 10:22:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56537, '2017-12-13 10:22:09', NULL, NULL, 15232, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 10:22:09', 'admin-1513127221-15131317297819037', 1, 0, '', NULL, NULL, NULL),
(56538, '2017-12-13 10:22:09', NULL, NULL, 15232, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 10:22:09', 'admin-1513127221-15131317297819037', 1, 1, 'SR', NULL, NULL, NULL),
(56539, '2017-12-13 10:25:48', NULL, NULL, 15233, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.00, 0.0000, 0.0000, 10.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 10:25:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56540, '2017-12-13 10:26:15', NULL, NULL, 15233, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 10:26:15', 'admin-1513127221-15131319758424730', 1, 0, '', NULL, NULL, NULL),
(56541, '2017-12-13 10:26:16', NULL, NULL, 15233, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 10:26:16', 'admin-1513127221-15131319758424730', 1, 0, '', NULL, NULL, NULL),
(56542, '2017-12-13 13:24:09', NULL, NULL, 15238, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1513127221', 'admin', '2017-12-13 13:24:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56543, '2017-12-13 12:13:59', NULL, NULL, 15236, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1513127221', 'admin', '2017-12-13 12:13:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56544, '2017-12-13 12:14:05', NULL, NULL, 15236, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 12:14:05', 'admin-1513127221-15131384453233485', 1, 1, 'SR', NULL, NULL, NULL),
(56545, '2017-12-13 12:45:17', NULL, NULL, 15237, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1513127221', 'admin', '2017-12-13 12:45:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56546, '2017-12-13 12:45:26', NULL, NULL, 15237, 0, 316, '252', 'AA Set - Sesame Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 12:45:26', 'admin-1513127221-15131403267927128', 1, 0, '', NULL, NULL, NULL),
(56547, '2017-12-13 11:13:45', NULL, NULL, 15235, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 11:13:45', 'admin-1513127221-15131348256042513', 1, 1, 'SR', NULL, NULL, NULL),
(56548, '2017-12-13 15:42:36', NULL, NULL, 15244, 0, 316, '252', 'AA Set - Sesame Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 15:42:36', 'admin-1513127221-15131509560389587', 1, 0, '', NULL, NULL, NULL),
(56549, '2017-12-13 11:13:45', NULL, NULL, 15235, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 11:13:45', 'admin-1513127221-15131348256042513', 1, 1, 'SR', NULL, NULL, NULL),
(56550, '2017-12-13 10:27:00', NULL, NULL, 15233, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 10:27:00', 'admin-1513127221-15131320199303881', 1, 0, '', NULL, NULL, NULL),
(56551, '2017-12-13 10:26:16', NULL, NULL, 15233, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 10:26:16', 'admin-1513127221-15131319758424730', 1, 1, 'SR', NULL, NULL, NULL),
(56552, '2017-12-13 10:26:16', NULL, NULL, 15233, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 10:26:16', 'admin-1513127221-15131319758424730', 1, 1, 'SR', NULL, NULL, NULL),
(56553, '2017-12-13 10:26:16', NULL, NULL, 15233, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 10:26:16', 'admin-1513127221-15131319758424730', 1, 1, 'SR', NULL, NULL, NULL),
(56554, '2017-12-13 10:26:16', NULL, NULL, 15233, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 10:26:16', 'admin-1513127221-15131319758424730', 1, 1, 'SR', NULL, NULL, NULL),
(56555, '2017-12-13 09:47:26', NULL, NULL, 15231, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1513127221', 'admin', '2017-12-13 09:47:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56556, '2017-12-13 09:47:36', NULL, NULL, 15231, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 09:47:36', 'admin-1513127221-15131296561733326', 1, 0, '', NULL, NULL, NULL),
(56557, '2017-12-13 09:47:36', NULL, NULL, 15231, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513127221', 'admin', '2017-12-13 09:47:36', 'admin-1513127221-15131296561733326', 1, 0, '', NULL, NULL, NULL),
(56558, '2017-12-14 09:39:17', NULL, NULL, 15249, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 09:39:17', 'admin-1513212408-15132155570883359', 1, 0, '', NULL, NULL, NULL),
(56559, '2017-12-14 10:37:23', NULL, NULL, 15250, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1513212408', 'admin', '2017-12-14 10:37:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56560, '2017-12-14 10:37:37', NULL, NULL, 15250, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 10:37:37', 'admin-1513212408-15132190571206195', 1, 0, '', NULL, NULL, NULL),
(56561, '2017-12-14 10:37:37', NULL, NULL, 15250, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 10:37:37', 'admin-1513212408-15132190571206195', 1, 0, '', NULL, NULL, NULL),
(56562, '2017-12-14 12:21:53', NULL, NULL, 15254, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 12:21:53', 'admin-1513212408-15132253134124162', 1, 1, 'SR', NULL, NULL, NULL),
(56563, '2017-12-14 12:34:52', NULL, NULL, 15255, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1513212408', 'admin', '2017-12-14 12:34:52', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(56564, '2017-12-14 12:35:08', NULL, NULL, 15255, 0, 319, '255', 'AA Set - Spicy Shrimp Macaroni', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 12:35:08', 'admin-1513212408-15132261086452024', 1, 0, '', NULL, NULL, '10.0'),
(56565, '2017-12-14 12:35:08', NULL, NULL, 15255, 0, 319, '255', 'AA Set - Spicy Shrimp Macaroni', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 12:35:08', 'admin-1513212408-15132261086452024', 1, 0, '', NULL, NULL, '10.0'),
(56566, '2017-12-14 12:35:08', NULL, NULL, 15255, 0, 336, '272', 'iced Yuzu', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 12:35:08', 'admin-1513212408-15132261086452024', 1, 0, '', NULL, NULL, '10.0'),
(56567, '2017-12-14 13:40:51', NULL, NULL, 15259, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 13:40:51', 'admin-1513212408-15132300516605924', 1, 1, 'SR', NULL, NULL, NULL),
(56568, '2017-12-14 13:40:51', NULL, NULL, 15259, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 13:40:51', 'admin-1513212408-15132300516605924', 1, 1, 'SR', NULL, NULL, NULL),
(56569, '2017-12-14 14:41:44', NULL, NULL, 15261, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1513212408', 'admin', '2017-12-14 14:41:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56570, '2017-12-14 14:41:53', NULL, NULL, 15261, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 14:41:53', 'admin-1513212408-15132337133022877', 1, 0, '', NULL, NULL, NULL),
(56571, '2017-12-14 15:53:00', NULL, NULL, 15262, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 15:53:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56572, '2017-12-14 15:53:10', NULL, NULL, 15262, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 15:53:10', 'admin-1513212408-15132379901341766', 1, 0, '', NULL, NULL, NULL),
(56573, '2017-12-14 15:53:10', NULL, NULL, 15262, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 15:53:10', 'admin-1513212408-15132379901341766', 1, 0, '', NULL, NULL, NULL),
(56574, '2017-12-14 12:19:46', NULL, NULL, 15254, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1513212408', 'admin', '2017-12-14 12:19:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56575, '2017-12-14 12:21:53', NULL, NULL, 15254, 0, 316, '252', 'AA Set - Sesame Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 12:21:53', 'admin-1513212408-15132253134124162', 1, 0, '', NULL, NULL, NULL),
(56576, '2017-12-14 12:21:53', NULL, NULL, 15254, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 12:21:53', 'admin-1513212408-15132253134124162', 1, 0, '', NULL, NULL, NULL),
(56577, '2017-12-14 13:24:14', NULL, NULL, 15257, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 13:24:14', 'admin-1513212408-15132290543718322', 1, 1, 'SR', NULL, NULL, '10.0'),
(56578, '2017-12-14 13:26:51', NULL, NULL, 15258, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1513212408', 'admin', '2017-12-14 13:26:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56579, '2017-12-14 13:26:55', NULL, NULL, 15258, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 13:26:55', 'admin-1513212408-15132292148977222', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(56580, '2017-12-14 13:39:48', NULL, NULL, 15259, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1513212408', 'admin', '2017-12-14 13:39:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56581, '2017-12-14 13:06:15', NULL, NULL, 15257, 0, 319, '255', 'AA Set - Spicy Shrimp Macaroni', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 13:06:15', 'admin-1513212408-15132279753392162', 1, 0, '', NULL, NULL, '10.0'),
(56582, '2017-12-14 13:40:10', NULL, NULL, 15259, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 13:40:10', 'admin-1513212408-15132300099435857', 1, 0, '', NULL, NULL, NULL),
(56583, '2017-12-14 14:41:53', NULL, NULL, 15261, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 14:41:53', 'admin-1513212408-15132337133022877', 1, 1, 'SR', NULL, NULL, NULL),
(56584, '2017-12-14 14:41:53', NULL, NULL, 15261, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 14:41:53', 'admin-1513212408-15132337133022877', 1, 1, 'SR', NULL, NULL, NULL),
(56585, '2017-12-14 13:44:11', NULL, NULL, 15259, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 13:44:11', 'admin-1513212408-15132302512677720', 1, 1, 'SR', NULL, NULL, NULL),
(56586, '2017-12-14 14:09:23', NULL, NULL, 15260, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1513212408', 'admin', '2017-12-14 14:09:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56587, '2017-12-14 14:09:30', NULL, NULL, 15260, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 14:09:30', 'admin-1513212408-15132317702226954', 1, 1, 'SR', NULL, NULL, NULL),
(56588, '2017-12-14 14:09:30', NULL, NULL, 15260, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 14:09:30', 'admin-1513212408-15132317702226954', 1, 0, '', NULL, NULL, NULL),
(56589, '2017-12-14 11:57:24', NULL, NULL, 15252, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 11:57:24', 'admin-1513212408-15132238439951078', 1, 1, 'SR', 1, NULL, NULL),
(56590, '2017-12-14 11:59:16', NULL, NULL, 15253, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1513212408', 'admin', '2017-12-14 11:59:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56591, '2017-12-14 12:03:38', NULL, NULL, 15253, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 12:03:38', 'admin-1513212408-15132242186344762', 1, 0, '', NULL, NULL, NULL),
(56592, '2017-12-14 13:06:10', NULL, NULL, 15257, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1513212408', 'admin', '2017-12-14 13:06:10', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(56593, '2017-12-14 13:40:10', NULL, NULL, 15259, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 2, 21.00, 42.0000, 0.0000, 42.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 13:40:10', 'admin-1513212408-15132300099435857', 1, 0, '', NULL, NULL, NULL),
(56594, '2017-12-14 13:03:56', NULL, NULL, 15256, 0, 316, '252', 'AA Set - Sesame Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 13:03:56', 'admin-1513212408-15132278365147169', 1, 0, '', NULL, NULL, NULL),
(56595, '2017-12-14 09:08:11', NULL, NULL, 15248, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1513212408', 'admin', '2017-12-14 09:08:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56596, '2017-12-14 09:08:20', NULL, NULL, 15248, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 09:08:20', 'admin-1513212408-1513213700307326', 1, 0, '', NULL, NULL, NULL),
(56597, '2017-12-14 09:08:20', NULL, NULL, 15248, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 09:08:20', 'admin-1513212408-1513213700307326', 1, 0, '', NULL, NULL, NULL),
(56598, '2017-12-14 09:08:20', NULL, NULL, 15248, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 09:08:20', 'admin-1513212408-1513213700307326', 1, 1, 'SR', NULL, NULL, NULL),
(56599, '2017-12-14 09:12:22', NULL, NULL, 15249, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1513212408', 'admin', '2017-12-14 09:12:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56600, '2017-12-14 09:12:40', NULL, NULL, 15249, 0, 181, '116', 'Open Food ', 'junior blt', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 09:12:40', 'admin-1513212408-15132139603058724', 1, 0, '', NULL, NULL, NULL),
(56601, '2017-12-14 09:12:40', NULL, NULL, 15249, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 09:12:40', 'admin-1513212408-15132139603058724', 1, 1, 'SR', NULL, NULL, NULL),
(56602, '2017-12-14 12:21:53', NULL, NULL, 15254, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 12:21:53', 'admin-1513212408-15132253134124162', 1, 1, 'SR', NULL, NULL, NULL),
(56603, '2017-12-14 13:03:56', NULL, NULL, 15256, 0, 316, '252', 'AA Set - Sesame Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 13:03:56', 'admin-1513212408-15132278365147169', 1, 0, '', NULL, NULL, NULL),
(56604, '2017-12-14 13:03:51', NULL, NULL, 15256, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1513212408', 'admin', '2017-12-14 13:03:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56605, '2017-12-14 12:35:08', NULL, NULL, 15255, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 12:35:08', 'admin-1513212408-15132261086452024', 1, 1, 'SR', NULL, NULL, '10.0'),
(56606, '2017-12-14 12:03:38', NULL, NULL, 15253, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 12:03:38', 'admin-1513212408-15132242186344762', 1, 0, '', NULL, NULL, NULL),
(56607, '2017-12-14 12:21:53', NULL, NULL, 15254, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 12:21:53', 'admin-1513212408-15132253134124162', 1, 0, '', NULL, NULL, NULL),
(56608, '2017-12-14 12:03:38', NULL, NULL, 15253, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 12:03:38', 'admin-1513212408-15132242186344762', 1, 0, '', NULL, NULL, NULL),
(56609, '2017-12-14 12:03:38', NULL, NULL, 15253, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 12:03:38', 'admin-1513212408-15132242186344762', 1, 0, '', NULL, NULL, NULL),
(56610, '2017-12-14 10:37:37', NULL, NULL, 15250, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 10:37:37', 'admin-1513212408-15132190571206195', 1, 1, 'SR', NULL, NULL, NULL),
(56611, '2017-12-14 10:46:47', NULL, NULL, 15251, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 10:46:47', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(56612, '2017-12-14 10:46:50', NULL, NULL, 15251, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 10:46:50', 'admin-1513212408-1513219610388797', 1, 0, '', NULL, NULL, '10.0'),
(56613, '2017-12-14 10:37:37', NULL, NULL, 15250, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 10:37:37', 'admin-1513212408-15132190571206195', 1, 1, 'SR', NULL, NULL, NULL),
(56614, '2017-12-14 09:39:17', NULL, NULL, 15249, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513212408', 'admin', '2017-12-14 09:39:17', 'admin-1513212408-15132155570883359', 1, 1, 'SR', NULL, NULL, NULL),
(56615, '2017-12-15 12:14:22', NULL, NULL, 15272, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 12:14:22', 'admin-1513299774-15133112621437794', 1, 1, 'SR', NULL, NULL, NULL),
(56616, '2017-12-15 11:37:53', NULL, NULL, 15270, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1513299774', 'admin', '2017-12-15 11:37:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56617, '2017-12-15 11:37:59', NULL, NULL, 15270, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 11:37:59', 'admin-1513299774-15133090794729547', 1, 0, '', NULL, NULL, NULL),
(56618, '2017-12-15 13:59:45', NULL, NULL, 15280, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 13:59:45', 'admin-1513299774-15133175856553427', 1, 0, '', NULL, NULL, NULL),
(56619, '2017-12-15 13:01:04', NULL, NULL, 15277, 0, 314, '250', 'AA Set - Thai Styled Garlic Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 13:01:04', 'admin-1513299774-15133140643407943', 1, 0, '', NULL, NULL, NULL),
(56620, '2017-12-15 10:53:06', NULL, NULL, 15267, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 10:53:06', 'admin-1513299774-15133063861682744', 1, 1, 'SR', 1, NULL, '10.0'),
(56621, '2017-12-15 11:20:34', NULL, NULL, 15268, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1513299774', 'admin', '2017-12-15 11:20:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56622, '2017-12-15 11:20:53', NULL, NULL, 15268, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 11:20:53', 'admin-1513299774-15133080535555074', 1, 0, '', NULL, NULL, NULL),
(56623, '2017-12-15 13:01:04', NULL, NULL, 15277, 0, 315, '251', 'AA Set - Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 13:01:04', 'admin-1513299774-15133140643407943', 1, 0, '', NULL, NULL, NULL),
(56624, '2017-12-15 13:00:40', NULL, NULL, 15277, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.30, 0.0000, 0.0000, 14.30, 1, '27', 1, '1513299774', 'admin', '2017-12-15 13:00:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56625, '2017-12-15 12:26:46', NULL, NULL, 15272, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 12:26:46', 'admin-1513299774-15133120058993142', 1, 0, '', NULL, NULL, NULL),
(56626, '2017-12-15 12:26:46', NULL, NULL, 15272, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 12:26:46', 'admin-1513299774-15133120058993142', 1, 1, 'SR', NULL, NULL, NULL),
(56627, '2017-12-15 14:00:06', NULL, NULL, 15280, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 14:00:06', 'admin-1513299774-15133176067168891', 1, 1, 'SR', NULL, NULL, NULL),
(56628, '2017-12-15 13:22:12', NULL, NULL, 15276, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 13:22:12', 'admin-1513299774-15133153324729118', 1, 1, 'SR', NULL, NULL, NULL),
(56629, '2017-12-15 13:23:20', NULL, NULL, 15278, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1513299774', 'admin', '2017-12-15 13:23:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56630, '2017-12-15 13:23:33', NULL, NULL, 15278, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 13:23:33', 'admin-1513299774-15133154129191242', 1, 0, '', NULL, NULL, NULL),
(56631, '2017-12-15 13:23:33', NULL, NULL, 15278, 0, 319, '255', 'AA Set - Spicy Shrimp Macaroni', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 13:23:33', 'admin-1513299774-15133154129191242', 1, 0, '', NULL, NULL, NULL),
(56632, '2017-12-15 13:01:04', NULL, NULL, 15277, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 13:01:04', 'admin-1513299774-15133140643407943', 1, 0, '', NULL, NULL, NULL),
(56633, '2017-12-15 13:01:04', NULL, NULL, 15277, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 13:01:04', 'admin-1513299774-15133140643407943', 1, 1, 'SR', NULL, NULL, NULL),
(56634, '2017-12-15 13:01:04', NULL, NULL, 15277, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 13:01:04', 'admin-1513299774-15133140643407943', 1, 0, '', NULL, NULL, NULL),
(56635, '2017-12-15 12:59:41', NULL, NULL, 15276, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 12:59:41', 'admin-1513299774-15133139812409519', 1, 0, '', NULL, NULL, NULL),
(56636, '2017-12-15 12:59:41', NULL, NULL, 15276, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 12:59:41', 'admin-1513299774-15133139812409519', 1, 1, 'SR', NULL, NULL, NULL),
(56637, '2017-12-15 12:59:41', NULL, NULL, 15276, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 12:59:41', 'admin-1513299774-15133139812409519', 1, 0, '', NULL, NULL, NULL),
(56638, '2017-12-15 13:01:04', NULL, NULL, 15277, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 13:01:04', 'admin-1513299774-15133140643407943', 1, 1, 'SR', NULL, NULL, NULL),
(56639, '2017-12-15 13:01:04', NULL, NULL, 15277, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 13:01:04', 'admin-1513299774-15133140643407943', 1, 0, '', NULL, NULL, NULL),
(56640, '2017-12-15 09:58:44', NULL, NULL, 15265, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 09:58:44', 'admin-1513299774-15133031238015336', 1, 1, 'SR', NULL, NULL, NULL),
(56641, '2017-12-15 10:16:03', NULL, NULL, 15266, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1513299774', 'admin', '2017-12-15 10:16:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56642, '2017-12-15 10:16:31', NULL, NULL, 15266, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 10:16:31', 'admin-1513299774-1513304191743378', 1, 1, 'SR', NULL, NULL, NULL),
(56643, '2017-12-15 10:16:31', NULL, NULL, 15266, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 10:16:31', 'admin-1513299774-1513304191743378', 1, 0, '', NULL, NULL, NULL),
(56644, '2017-12-15 12:59:41', NULL, NULL, 15276, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 12:59:41', 'admin-1513299774-15133139812409519', 1, 0, '', NULL, NULL, NULL),
(56645, '2017-12-15 15:54:28', NULL, NULL, 15282, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 15:54:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56646, '2017-12-15 15:54:36', NULL, NULL, 15282, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 15:54:36', 'admin-1513299774-15133244760768214', 1, 1, 'SR', NULL, NULL, NULL),
(56647, '2017-12-15 13:01:04', NULL, NULL, 15277, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 13:01:04', 'admin-1513299774-15133140643407943', 1, 1, 'SR', NULL, NULL, NULL),
(56648, '2017-12-15 11:44:24', NULL, NULL, 15271, 0, 315, '251', 'AA Set - Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 11:44:24', 'admin-1513299774-15133094646117419', 1, 0, '', NULL, NULL, NULL),
(56649, '2017-12-15 12:59:31', NULL, NULL, 15276, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1513299774', 'admin', '2017-12-15 12:59:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56650, '2017-12-15 00:00:00', NULL, NULL, 15279, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 12:37:36', 'admin-1513299774-15133126560812329', 1, 0, '', NULL, NULL, '10.0'),
(56651, '2017-12-15 12:48:24', NULL, NULL, 15275, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 12:48:24', 'admin-1513299774-15133133044603272', 1, 1, 'SR', 1, NULL, NULL),
(56652, '2017-12-15 13:38:26', NULL, NULL, 15279, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1513299774', 'admin', '2017-12-15 13:38:26', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(56653, '2017-12-15 11:20:53', NULL, NULL, 15268, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 11:20:53', 'admin-1513299774-15133080535555074', 1, 1, 'SR', NULL, NULL, NULL),
(56654, '2017-12-15 15:54:36', NULL, NULL, 15282, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 15:54:36', 'admin-1513299774-15133244760768214', 1, 1, 'SR', NULL, NULL, NULL),
(56655, '2017-12-15 17:12:01', NULL, NULL, 15283, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1513299774', 'admin', '2017-12-15 17:12:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56656, '2017-12-15 17:12:04', NULL, NULL, 15283, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 17:12:04', 'admin-1513299774-15133291246195749', 1, 1, 'SR', NULL, NULL, NULL),
(56657, '2017-12-15 14:42:49', NULL, NULL, 15281, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 14:42:49', 'admin-1513299774-15133201691104237', 1, 0, '', NULL, NULL, NULL),
(56658, '2017-12-15 14:42:40', NULL, NULL, 15281, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1513299774', 'admin', '2017-12-15 14:42:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56659, '2017-12-15 14:42:49', NULL, NULL, 15281, 0, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 14:42:49', 'admin-1513299774-15133201691104237', 1, 1, 'SR', NULL, NULL, NULL),
(56660, '2017-12-15 14:00:06', NULL, NULL, 15280, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 14:00:06', 'admin-1513299774-15133176067168891', 1, 1, 'SR', NULL, NULL, NULL),
(56661, '2017-12-15 14:25:23', NULL, NULL, 15280, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 14:25:23', 'admin-1513299774-15133191232374042', 1, 1, 'SR', NULL, NULL, NULL),
(56662, '2017-12-15 13:01:04', NULL, NULL, 15277, 0, 314, '250', 'AA Set - Thai Styled Garlic Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 13:01:04', 'admin-1513299774-15133140643407943', 1, 0, '', NULL, NULL, NULL),
(56663, '2017-12-15 13:59:45', NULL, NULL, 15280, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 13:59:45', 'admin-1513299774-15133175856553427', 1, 1, 'SR', NULL, NULL, NULL),
(56664, '2017-12-15 13:01:04', NULL, NULL, 15277, 0, 314, '250', 'AA Set - Thai Styled Garlic Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 13:01:04', 'admin-1513299774-15133140643407943', 1, 0, '', NULL, NULL, NULL),
(56665, '2017-12-15 12:14:05', NULL, NULL, 15272, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1513299774', 'admin', '2017-12-15 12:14:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56666, '2017-12-15 12:14:22', NULL, NULL, 15272, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 12:14:22', 'admin-1513299774-15133112621437794', 1, 0, '', NULL, NULL, NULL),
(56667, '2017-12-15 12:27:07', NULL, NULL, 15274, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 12:27:07', 'admin-1513299774-15133120270462896', 1, 0, '', 1, NULL, NULL),
(56668, '2017-12-15 13:01:04', NULL, NULL, 15277, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 13:01:04', 'admin-1513299774-15133140643407943', 1, 0, '', NULL, NULL, NULL),
(56669, '2017-12-15 13:58:54', NULL, NULL, 15280, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1513299774', 'admin', '2017-12-15 13:58:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56670, '2017-12-15 12:27:07', NULL, NULL, 15274, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 12:27:07', 'admin-1513299774-15133120270462896', 1, 0, '', 1, NULL, NULL),
(56671, '2017-12-15 12:27:07', NULL, NULL, 15274, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 12:27:07', 'admin-1513299774-15133120270462896', 1, 0, '', 1, NULL, NULL),
(56672, '2017-12-15 12:14:22', NULL, NULL, 15272, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 12:14:22', 'admin-1513299774-15133112621437794', 1, 0, '', NULL, NULL, NULL),
(56673, '2017-12-15 12:17:33', NULL, NULL, 15273, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1513299774', 'admin', '2017-12-15 12:17:33', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(56674, '2017-12-15 12:17:37', NULL, NULL, 15273, 0, 316, '252', 'AA Set - Sesame Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 12:17:37', 'admin-1513299774-1513311457134957', 1, 0, '', NULL, NULL, '10.0'),
(56675, '2017-12-15 12:21:22', NULL, NULL, 15273, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 12:21:22', 'admin-1513299774-1513311681860132', 1, 1, 'SR', NULL, NULL, '10.0'),
(56676, '2017-12-15 09:58:33', NULL, NULL, 15265, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1513299774', 'admin', '2017-12-15 09:58:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56677, '2017-12-15 09:58:43', NULL, NULL, 15265, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 09:58:43', 'admin-1513299774-15133031238015336', 1, 0, '', NULL, NULL, NULL),
(56678, '2017-12-15 11:20:53', NULL, NULL, 15268, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 11:20:53', 'admin-1513299774-15133080535555074', 1, 0, '', NULL, NULL, NULL),
(56679, '2017-12-15 11:20:53', NULL, NULL, 15268, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 11:20:53', 'admin-1513299774-15133080535555074', 1, 0, '', NULL, NULL, NULL),
(56680, '2017-12-15 13:23:33', NULL, NULL, 15278, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 13:23:33', 'admin-1513299774-15133154129191242', 1, 0, '', NULL, NULL, NULL),
(56681, '2017-12-15 11:44:24', NULL, NULL, 15271, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 11:44:24', 'admin-1513299774-15133094646117419', 1, 1, 'SR', NULL, NULL, NULL),
(56682, '2017-12-15 11:44:16', NULL, NULL, 15271, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 11:44:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56683, '2017-12-15 11:35:33', NULL, NULL, 15269, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 11:35:33', 'admin-1513299774-15133089337895776', 1, 1, 'SR', NULL, NULL, NULL),
(56684, '2017-12-15 11:30:33', NULL, NULL, 15269, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 11:30:33', 'admin-1513299774-1513308633407654', 1, 1, 'SR', NULL, NULL, NULL),
(56685, '2017-12-15 11:30:33', NULL, NULL, 15269, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 11:30:33', 'admin-1513299774-1513308633407654', 1, 0, '', NULL, NULL, NULL),
(56686, '2017-12-15 11:30:33', NULL, NULL, 15269, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 11:30:33', 'admin-1513299774-1513308633407654', 1, 0, '', NULL, NULL, NULL),
(56687, '2017-12-15 11:30:33', NULL, NULL, 15269, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 11:30:33', 'admin-1513299774-1513308633407654', 1, 0, '', NULL, NULL, NULL),
(56688, '2017-12-15 11:30:20', NULL, NULL, 15269, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1513299774', 'admin', '2017-12-15 11:30:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56689, '2017-12-15 10:16:31', NULL, NULL, 15266, 0, 325, '261', 'Strawberry Chocolate Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 10:16:31', 'admin-1513299774-1513304191743378', 1, 0, '', NULL, NULL, NULL),
(56690, '2017-12-15 10:23:32', NULL, NULL, 15266, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 10:23:32', 'admin-1513299774-15133046125503515', 1, 1, 'SR', NULL, NULL, NULL),
(56691, '2017-12-15 10:40:23', NULL, NULL, 15266, 0, 335, '271', 'Iced Honey Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 10:40:23', 'admin-1513299774-15133056237761830', 1, 0, '', NULL, NULL, NULL),
(56692, '2017-12-15 10:53:06', NULL, NULL, 15267, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 10:53:06', 'admin-1513299774-15133063861682744', 1, 1, 'SR', 1, NULL, '10.0'),
(56693, '2017-12-15 09:58:43', NULL, NULL, 15265, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 09:58:43', 'admin-1513299774-15133031238015336', 1, 0, '', NULL, NULL, NULL),
(56694, '2017-12-15 09:58:43', NULL, NULL, 15265, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 09:58:43', 'admin-1513299774-15133031238015336', 1, 1, 'SR', NULL, NULL, NULL),
(56695, '2017-12-15 09:15:16', NULL, NULL, 15263, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 09:15:16', 'admin-1513299774-15133005165402150', 1, 0, '', NULL, NULL, NULL),
(56696, '2017-12-15 09:27:50', NULL, NULL, 15264, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1513299774', 'admin', '2017-12-15 09:27:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56697, '2017-12-15 00:00:00', NULL, NULL, 15279, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 12:37:36', 'admin-1513299774-15133126560812329', 1, 0, '', NULL, NULL, '10.0'),
(56698, '2017-12-15 09:30:01', NULL, NULL, 15264, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 09:30:01', 'admin-1513299774-15133014017665945', 1, 0, '', NULL, NULL, NULL),
(56699, '2017-12-15 09:30:01', NULL, NULL, 15264, 0, 328, '264', 'Basic Blueberries Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 09:30:01', 'admin-1513299774-15133014017665945', 1, 0, '', NULL, NULL, NULL),
(56700, '2017-12-15 09:15:07', NULL, NULL, 15263, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1513299774', 'admin', '2017-12-15 09:15:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56701, '2017-12-15 09:15:16', NULL, NULL, 15263, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513299774', 'admin', '2017-12-15 09:15:16', 'admin-1513299774-15133005165402150', 1, 0, '', NULL, NULL, NULL),
(56702, '2017-12-16 13:24:21', NULL, NULL, 15297, 0, 316, '252', 'AA Set - Sesame Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:24:21', 'admin-1513386801-15134018614314780', 1, 0, '', NULL, NULL, NULL),
(56703, '2017-12-16 13:38:41', NULL, NULL, 15307, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:38:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56704, '2017-12-16 15:13:27', NULL, NULL, 15314, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 15:13:27', 'admin-1513386801-1513408407261959', 1, 1, 'SR', NULL, NULL, NULL),
(56705, '2017-12-16 13:20:55', NULL, NULL, 15297, 0, 316, '252', 'AA Set - Sesame Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:20:55', 'admin-1513386801-15134016550474123', 1, 0, '', NULL, NULL, NULL),
(56706, '2017-12-16 16:10:55', NULL, NULL, 15320, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1513386801', 'admin', '2017-12-16 16:10:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56707, '2017-12-16 13:20:55', NULL, NULL, 15297, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:20:55', 'admin-1513386801-15134016550474123', 1, 0, '', NULL, NULL, NULL),
(56708, '2017-12-16 13:20:55', NULL, NULL, 15297, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:20:55', 'admin-1513386801-15134016550474123', 1, 0, '', NULL, NULL, NULL),
(56709, '2017-12-16 16:07:16', NULL, NULL, 15319, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 16:07:16', 'admin-1513386801-15134116359749194', 1, 1, 'SR', NULL, NULL, NULL),
(56710, '2017-12-16 11:54:43', NULL, NULL, 15298, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 11:54:43', 'admin-1513386801-15133964830855074', 1, 1, 'SR', NULL, NULL, NULL),
(56711, '2017-12-16 11:47:17', NULL, NULL, 15296, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 11:47:17', 'admin-1513386801-15133960370686379', 1, 0, '', NULL, NULL, NULL),
(56712, '2017-12-16 11:47:23', NULL, NULL, 15296, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 11:47:23', 'admin-1513386801-15133960431967047', 1, 1, 'SR', NULL, NULL, NULL),
(56713, '2017-12-16 11:47:23', NULL, NULL, 15296, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 11:47:23', 'admin-1513386801-15133960431967047', 1, 1, 'SR', NULL, NULL, NULL),
(56714, '2017-12-16 15:29:58', NULL, NULL, 15316, 0, 315, '251', 'AA Set - Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 15:29:58', 'admin-1513386801-15134093984478779', 1, 0, '', NULL, NULL, NULL),
(56715, '2017-12-16 15:42:24', NULL, NULL, 15317, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 15:42:24', 'admin-1513386801-15134101444223890', 1, 1, 'SR', 1, NULL, NULL),
(56716, '2017-12-16 15:52:06', NULL, NULL, 15318, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1513386801', 'admin', '2017-12-16 15:52:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56717, '2017-12-16 15:52:31', NULL, NULL, 15318, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 15:52:31', 'admin-1513386801-15134107511151410', 1, 1, 'SR', NULL, NULL, NULL),
(56718, '2017-12-16 16:07:03', NULL, NULL, 15319, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1513386801', 'admin', '2017-12-16 16:07:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56719, '2017-12-16 12:24:47', NULL, NULL, 15301, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:24:47', 'admin-1513386801-15133982875175126', 1, 1, 'SR', NULL, NULL, NULL),
(56720, '2017-12-16 12:24:47', NULL, NULL, 15301, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:24:47', 'admin-1513386801-15133982875175126', 1, 0, '', NULL, NULL, NULL),
(56721, '2017-12-16 12:24:14', NULL, NULL, 15301, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:24:14', 'admin-1513386801-15133982541725765', 1, 0, '', NULL, NULL, NULL),
(56722, '2017-12-16 09:51:16', NULL, NULL, 15289, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:51:16', 'admin-1513386801-15133890767552476', 1, 1, 'SR', NULL, NULL, NULL),
(56723, '2017-12-16 09:51:16', NULL, NULL, 15289, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:51:16', 'admin-1513386801-15133890767552476', 1, 1, 'SR', NULL, NULL, NULL),
(56724, '2017-12-16 14:39:19', NULL, NULL, 15313, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 14:39:19', 'admin-1513386801-15134063590562931', 1, 0, '', NULL, NULL, NULL),
(56725, '2017-12-16 14:39:19', NULL, NULL, 15313, 0, 319, '255', 'AA Set - Spicy Shrimp Macaroni', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 14:39:19', 'admin-1513386801-15134063590562931', 1, 0, '', NULL, NULL, NULL),
(56726, '2017-12-16 15:28:08', NULL, NULL, 15315, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 15:28:08', 'admin-1513386801-15134092884561611', 1, 1, 'SR', NULL, NULL, NULL),
(56727, '2017-12-16 15:29:38', NULL, NULL, 15316, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1513386801', 'admin', '2017-12-16 15:29:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56728, '2017-12-16 12:22:12', NULL, NULL, 15302, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:22:12', 'admin-1513386801-1513398132303563', 1, 1, 'SR', NULL, NULL, NULL),
(56729, '2017-12-16 13:40:53', NULL, NULL, 15308, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:40:53', 'admin-1513386801-15134028536539768', 1, 1, 'SR', NULL, NULL, NULL),
(56730, '2017-12-16 13:42:51', NULL, NULL, 15309, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:42:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56731, '2017-12-16 13:43:46', NULL, NULL, 15309, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:43:46', 'admin-1513386801-1513403025911155', 1, 0, '', NULL, NULL, NULL),
(56732, '2017-12-16 12:15:22', NULL, NULL, 15301, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:15:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56733, '2017-12-16 12:22:05', NULL, NULL, 15302, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:22:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56734, '2017-12-16 09:27:12', NULL, NULL, 15287, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:27:12', 'admin-1513386801-15133876321965857', 1, 1, 'SR', NULL, NULL, NULL),
(56735, '2017-12-16 09:36:32', NULL, NULL, 15288, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:36:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56736, '2017-12-16 09:20:53', NULL, NULL, 15286, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:20:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56737, '2017-12-16 09:21:26', NULL, NULL, 15286, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:21:26', 'admin-1513386801-15133872865568532', 1, 0, '', NULL, NULL, NULL),
(56738, '2017-12-16 15:28:08', NULL, NULL, 15315, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 15:28:08', 'admin-1513386801-15134092884561611', 1, 1, 'SR', NULL, NULL, NULL),
(56739, '2017-12-16 15:28:08', NULL, NULL, 15315, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 15:28:08', 'admin-1513386801-15134092884561611', 1, 0, '', NULL, NULL, NULL),
(56740, '2017-12-16 15:28:08', NULL, NULL, 15315, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 15:28:08', 'admin-1513386801-15134092884561611', 1, 1, 'SR', NULL, NULL, NULL),
(56741, '2017-12-16 12:11:16', NULL, NULL, 15297, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:11:16', 'admin-1513386801-1513397476169799', 1, 1, 'SR', NULL, NULL, NULL),
(56742, '2017-12-16 14:02:14', NULL, NULL, 15311, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 14:02:14', 'admin-1513386801-15134041339455692', 1, 0, '', NULL, NULL, NULL),
(56743, '2017-12-16 14:02:26', NULL, NULL, 15306, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 14:02:26', 'admin-1513386801-15134041467825293', 1, 0, '', NULL, NULL, NULL),
(56744, '2017-12-16 15:13:27', NULL, NULL, 15314, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 15:13:27', 'admin-1513386801-1513408407261959', 1, 0, '', NULL, NULL, NULL),
(56745, '2017-12-16 15:27:47', NULL, NULL, 15315, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1513386801', 'admin', '2017-12-16 15:27:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56746, '2017-12-16 12:11:16', NULL, NULL, 15297, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:11:16', 'admin-1513386801-1513397476169799', 1, 1, 'SR', NULL, NULL, NULL),
(56747, '2017-12-16 14:24:17', NULL, NULL, 15310, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 14:24:17', 'admin-1513386801-15134054574756431', 1, 0, '', NULL, NULL, NULL),
(56748, '2017-12-16 14:24:17', NULL, NULL, 15310, 0, 319, '255', 'AA Set - Spicy Shrimp Macaroni', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 14:24:17', 'admin-1513386801-15134054574756431', 1, 0, '', NULL, NULL, NULL),
(56749, '2017-12-16 10:16:58', NULL, NULL, 15293, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:16:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56750, '2017-12-16 10:16:46', NULL, NULL, 15292, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:16:46', 'admin-1513386801-15133906067676423', 1, 0, '', NULL, NULL, NULL),
(56751, '2017-12-16 12:24:14', NULL, NULL, 15301, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:24:14', 'admin-1513386801-15133982541725765', 1, 0, '', NULL, NULL, NULL),
(56752, '2017-12-16 13:20:55', NULL, NULL, 15297, 0, 291, '225', 'Smoked Duck Red Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:20:55', 'admin-1513386801-15134016550474123', 1, 0, '', NULL, NULL, NULL),
(56753, '2017-12-16 12:24:47', NULL, NULL, 15301, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:24:47', 'admin-1513386801-15133982875175126', 1, 1, 'SR', NULL, NULL, NULL),
(56754, '2017-12-16 12:25:48', NULL, NULL, 15303, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:25:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56755, '2017-12-16 12:25:53', NULL, NULL, 15303, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:25:53', 'admin-1513386801-15133983536441845', 1, 0, '', NULL, NULL, NULL),
(56756, '2017-12-16 15:13:04', NULL, NULL, 15314, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 15:13:04', 'admin-1513386801-15134083842394268', 1, 0, '', NULL, NULL, NULL),
(56757, '2017-12-16 10:04:28', NULL, NULL, 15290, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:04:28', 'admin-1513386801-15133898684649549', 1, 1, 'SR', NULL, NULL, NULL),
(56758, '2017-12-16 15:13:04', NULL, NULL, 15314, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 15:13:04', 'admin-1513386801-15134083842394268', 1, 0, '', NULL, NULL, NULL),
(56759, '2017-12-16 15:12:54', NULL, NULL, 15314, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 15:12:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56760, '2017-12-16 12:39:35', NULL, NULL, 15305, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:39:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56761, '2017-12-16 12:39:40', NULL, NULL, 15305, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:39:40', 'admin-1513386801-15133991808046789', 1, 1, 'SR', NULL, NULL, NULL),
(56762, '2017-12-16 14:51:57', NULL, NULL, 15301, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 14:51:57', 'admin-1513386801-1513407117013121', 1, 0, '', NULL, NULL, NULL),
(56763, '2017-12-16 14:30:52', NULL, NULL, 15312, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 14:30:52', 'admin-1513386801-15134058525038443', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(56764, '2017-12-16 14:38:56', NULL, NULL, 15313, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1513386801', 'admin', '2017-12-16 14:38:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56765, '2017-12-16 14:39:19', NULL, NULL, 15313, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 14:39:19', 'admin-1513386801-15134063590562931', 1, 1, 'SR', NULL, NULL, NULL),
(56766, '2017-12-16 09:26:55', NULL, NULL, 15287, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:26:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56767, '2017-12-16 14:51:23', NULL, NULL, 15310, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 14:51:23', 'admin-1513386801-15134070835171337', 1, 1, 'SR', NULL, NULL, NULL),
(56768, '2017-12-16 13:43:59', NULL, NULL, 15309, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:43:59', 'admin-1513386801-15134030389853112', 1, 1, 'SR', NULL, NULL, NULL),
(56769, '2017-12-16 14:29:11', NULL, NULL, 15312, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1513386801', 'admin', '2017-12-16 14:29:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56770, '2017-12-16 14:29:27', NULL, NULL, 15312, 0, 314, '250', 'AA Set - Thai Styled Garlic Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 14:29:27', 'admin-1513386801-15134057669851769', 1, 0, '', NULL, NULL, NULL),
(56771, '2017-12-16 14:29:27', NULL, NULL, 15312, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 14:29:27', 'admin-1513386801-15134057669851769', 1, 0, '', NULL, NULL, NULL),
(56772, '2017-12-16 10:12:43', NULL, NULL, 15291, 0, 181, '116', 'Open Food ', 'Joyous sausage put aside', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:12:43', 'admin-1513386801-15133903636617530', 1, 0, '', NULL, NULL, NULL),
(56773, '2017-12-16 15:13:27', NULL, NULL, 15314, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 15:13:27', 'admin-1513386801-1513408407261959', 1, 1, 'SR', NULL, NULL, NULL),
(56774, '2017-12-16 15:29:58', NULL, NULL, 15316, 0, 80, '80', 'Oriental Chicken Salad', 'sauce apart', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 15:29:58', 'admin-1513386801-15134093984478779', 1, 1, 'SR', NULL, NULL, NULL),
(56775, '2017-12-16 14:51:23', NULL, NULL, 15310, 0, 316, '252', 'AA Set - Sesame Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 14:51:23', 'admin-1513386801-15134070835171337', 1, 0, '', NULL, NULL, NULL),
(56776, '2017-12-16 14:39:33', NULL, NULL, 15313, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 14:39:33', 'admin-1513386801-15134063737612396', 1, 1, 'SR', NULL, NULL, NULL),
(56777, '2017-12-16 14:39:33', NULL, NULL, 15313, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 14:39:33', 'admin-1513386801-15134063737612396', 1, 1, 'SR', NULL, NULL, NULL),
(56778, '2017-12-16 14:30:52', NULL, NULL, 15312, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 14:30:52', 'admin-1513386801-15134058525038443', 1, 1, 'SR', NULL, NULL, NULL),
(56779, '2017-12-16 12:37:07', NULL, NULL, 15304, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:37:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56780, '2017-12-16 12:37:14', NULL, NULL, 15304, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:37:14', 'admin-1513386801-15133990342598259', 1, 0, '', NULL, NULL, NULL),
(56781, '2017-12-16 13:57:41', NULL, NULL, 15310, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:57:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56782, '2017-12-16 13:57:44', NULL, NULL, 15310, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:57:44', 'admin-1513386801-15134038644611854', 1, 1, 'SR', NULL, NULL, NULL),
(56783, '2017-12-16 14:01:48', NULL, NULL, 15311, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1513386801', 'admin', '2017-12-16 14:01:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56784, '2017-12-16 14:02:14', NULL, NULL, 15311, 0, 301, '237', 'Black Jack', '', 'Cold Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 14:02:14', 'admin-1513386801-15134041339455692', 1, 0, '', NULL, NULL, NULL),
(56785, '2017-12-16 13:43:46', NULL, NULL, 15309, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:43:46', 'admin-1513386801-1513403025911155', 1, 0, '', NULL, NULL, NULL),
(56786, '2017-12-16 12:08:14', NULL, NULL, 15300, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:08:14', 'admin-1513386801-15133972944251171', 1, 1, 'SR', NULL, NULL, NULL),
(56787, '2017-12-16 12:08:14', NULL, NULL, 15300, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:08:14', 'admin-1513386801-15133972944251171', 1, 1, 'SR', NULL, NULL, NULL),
(56788, '2017-12-16 12:08:14', NULL, NULL, 15300, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:08:14', 'admin-1513386801-15133972944251171', 1, 1, 'SR', NULL, NULL, NULL),
(56789, '2017-12-16 13:43:59', NULL, NULL, 15309, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:43:59', 'admin-1513386801-15134030389853112', 1, 1, 'SR', NULL, NULL, NULL),
(56790, '2017-12-16 14:02:14', NULL, NULL, 15311, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 14:02:14', 'admin-1513386801-15134041339455692', 1, 1, 'SR', NULL, NULL, NULL),
(56791, '2017-12-16 10:16:46', NULL, NULL, 15292, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:16:46', 'admin-1513386801-15133906067676423', 1, 0, '', NULL, NULL, NULL),
(56792, '2017-12-16 10:17:08', NULL, NULL, 15293, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:17:08', 'admin-1513386801-1513390627911626', 1, 0, '', NULL, NULL, NULL),
(56793, '2017-12-16 10:19:10', NULL, NULL, 15292, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:19:10', 'admin-1513386801-1513390750724417', 1, 1, 'SR', NULL, NULL, NULL),
(56794, '2017-12-16 10:19:10', NULL, NULL, 15292, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:19:10', 'admin-1513386801-1513390750724417', 1, 0, '', NULL, NULL, NULL),
(56795, '2017-12-16 13:38:58', NULL, NULL, 15307, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:38:58', 'admin-1513386801-1513402738866494', 1, 1, 'SR', NULL, NULL, NULL),
(56796, '2017-12-16 13:38:52', NULL, NULL, 15307, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', 'Takeaway', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:38:52', 'admin-1513386801-15134027325003929', 1, 0, '', NULL, NULL, NULL),
(56797, '2017-12-16 10:19:50', NULL, NULL, 15292, 0, 181, '116', 'Open Food ', 'add mushroom', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:19:50', 'admin-1513386801-15133907906599360', 1, 0, '', NULL, NULL, NULL),
(56798, '2017-12-16 13:38:52', NULL, NULL, 15307, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:38:52', 'admin-1513386801-15134027325003929', 1, 0, '', NULL, NULL, NULL),
(56799, '2017-12-16 13:20:55', NULL, NULL, 15297, 0, 314, '250', 'AA Set - Thai Styled Garlic Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:20:55', 'admin-1513386801-15134016550474123', 1, 0, '', NULL, NULL, NULL),
(56800, '2017-12-16 13:21:04', NULL, NULL, 15297, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:21:04', 'admin-1513386801-15134016647105386', 1, 1, 'SR', NULL, NULL, NULL),
(56801, '2017-12-16 13:21:04', NULL, NULL, 15297, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:21:04', 'admin-1513386801-15134016647105386', 1, 1, 'SR', NULL, NULL, NULL),
(56802, '2017-12-16 13:20:55', NULL, NULL, 15297, 0, 314, '250', 'AA Set - Thai Styled Garlic Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:20:55', 'admin-1513386801-15134016550474123', 1, 0, '', NULL, NULL, NULL),
(56803, '2017-12-16 13:13:19', NULL, NULL, 15297, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:13:19', 'admin-1513386801-15134011992005318', 1, 0, '', NULL, NULL, NULL),
(56804, '2017-12-16 12:45:07', NULL, NULL, 15304, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:45:07', 'admin-1513386801-15133995076815197', 1, 1, 'SR', NULL, NULL, NULL),
(56805, '2017-12-16 12:07:53', NULL, NULL, 15300, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:07:53', 'admin-1513386801-15133972730526682', 1, 0, '', NULL, NULL, NULL),
(56806, '2017-12-16 12:08:14', NULL, NULL, 15300, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:08:14', 'admin-1513386801-15133972944251171', 1, 1, 'SR', NULL, NULL, NULL),
(56807, '2017-12-16 12:07:53', NULL, NULL, 15300, 0, 315, '251', 'AA Set - Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:07:53', 'admin-1513386801-15133972730526682', 1, 0, '', NULL, NULL, NULL),
(56808, '2017-12-16 11:02:44', NULL, NULL, 15295, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 11:02:44', 'admin-1513386801-15133933644501353', 1, 0, '', NULL, NULL, NULL),
(56809, '2017-12-16 11:03:54', NULL, NULL, 15294, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 11:03:54', 'admin-1513386801-15133934342551696', 1, 0, '', NULL, NULL, NULL),
(56810, '2017-12-16 11:03:54', NULL, NULL, 15294, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 11:03:54', 'admin-1513386801-15133934342551696', 1, 0, '', NULL, NULL, NULL),
(56811, '2017-12-16 11:47:01', NULL, NULL, 15296, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1513386801', 'admin', '2017-12-16 11:47:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56812, '2017-12-16 13:40:47', NULL, NULL, 15308, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1513386801', 'admin', '2017-12-16 13:40:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56813, '2017-12-16 12:40:22', NULL, NULL, 15306, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:40:22', 'admin-1513386801-15133992224031125', 1, 0, '', NULL, NULL, NULL),
(56814, '2017-12-16 11:55:20', NULL, NULL, 15297, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 11:55:20', 'admin-1513386801-15133965205453953', 1, 1, 'SR', NULL, NULL, NULL),
(56815, '2017-12-16 12:07:53', NULL, NULL, 15300, 0, 315, '251', 'AA Set - Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:07:53', 'admin-1513386801-15133972730526682', 1, 0, '', NULL, NULL, NULL),
(56816, '2017-12-16 12:37:14', NULL, NULL, 15304, 0, 319, '255', 'AA Set - Spicy Shrimp Macaroni', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:37:14', 'admin-1513386801-15133990342598259', 1, 0, '', NULL, NULL, NULL),
(56817, '2017-12-16 12:07:53', NULL, NULL, 15300, 0, 314, '250', 'AA Set - Thai Styled Garlic Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:07:53', 'admin-1513386801-15133972730526682', 1, 0, '', NULL, NULL, NULL),
(56818, '2017-12-16 09:51:16', NULL, NULL, 15289, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:51:16', 'admin-1513386801-15133890767552476', 1, 1, 'SR', NULL, NULL, NULL),
(56819, '2017-12-16 10:49:51', NULL, NULL, 15295, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:49:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56820, '2017-12-16 10:49:56', NULL, NULL, 15295, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:49:56', 'admin-1513386801-15133925960737129', 1, 1, 'SR', NULL, NULL, NULL),
(56821, '2017-12-16 10:04:20', NULL, NULL, 15290, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:04:20', 'admin-1513386801-15133898599129595', 1, 0, '', NULL, NULL, NULL),
(56822, '2017-12-16 10:04:28', NULL, NULL, 15290, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:04:28', 'admin-1513386801-15133898684649549', 1, 1, 'SR', NULL, NULL, NULL),
(56823, '2017-12-16 12:39:50', NULL, NULL, 15306, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:39:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56824, '2017-12-16 12:40:22', NULL, NULL, 15306, 0, 301, '237', 'Black Jack', '', 'Cold Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:40:22', 'admin-1513386801-15133992224031125', 1, 0, '', NULL, NULL, NULL),
(56825, '2017-12-16 12:07:00', NULL, NULL, 15299, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:07:00', 'admin-1513386801-1513397220735724', 1, 0, '', NULL, NULL, NULL),
(56826, '2017-12-16 12:06:54', NULL, NULL, 15299, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:06:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56827, '2017-12-16 12:40:22', NULL, NULL, 15306, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:40:22', 'admin-1513386801-15133992224031125', 1, 1, 'SR', NULL, NULL, NULL),
(56828, '2017-12-16 12:24:14', NULL, NULL, 15301, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:24:14', 'admin-1513386801-15133982541725765', 1, 0, '', NULL, NULL, NULL),
(56829, '2017-12-16 12:24:47', NULL, NULL, 15301, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:24:47', 'admin-1513386801-15133982875175126', 1, 1, 'SR', NULL, NULL, NULL),
(56830, '2017-12-16 11:58:38', NULL, NULL, 15297, 0, 32, '32', 'Tea By Pot ', 'englisg breakfast', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 11:58:38', 'admin-1513386801-15133967185623241', 1, 1, 'SR', NULL, NULL, NULL),
(56831, '2017-12-16 11:54:25', NULL, NULL, 15298, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1513386801', 'admin', '2017-12-16 11:54:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56832, '2017-12-16 11:54:43', NULL, NULL, 15298, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 11:54:43', 'admin-1513386801-15133964830855074', 1, 1, 'SR', NULL, NULL, NULL),
(56833, '2017-12-16 11:52:59', NULL, NULL, 15297, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 22.50, 0.0000, 0.0000, 22.50, 1, '27', 1, '1513386801', 'admin', '2017-12-16 11:52:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56834, '2017-12-16 11:53:04', NULL, NULL, 15297, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 11:53:04', 'admin-1513386801-15133963842882052', 1, 1, 'SR', NULL, NULL, NULL),
(56835, '2017-12-16 12:07:25', NULL, NULL, 15300, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.70, 0.0000, 0.0000, 11.70, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:07:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56836, '2017-12-16 12:11:16', NULL, NULL, 15297, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 12:11:16', 'admin-1513386801-1513397476169799', 1, 1, 'SR', NULL, NULL, NULL),
(56837, '2017-12-16 16:11:00', NULL, NULL, 15320, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 16:11:00', 'admin-1513386801-1513411859940346', 1, 1, 'SR', NULL, NULL, NULL),
(56838, '2017-12-16 11:03:54', NULL, NULL, 15294, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 11:03:54', 'admin-1513386801-15133934342551696', 1, 0, '', NULL, NULL, NULL),
(56839, '2017-12-16 11:03:54', NULL, NULL, 15294, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 11:03:54', 'admin-1513386801-15133934342551696', 1, 0, '', NULL, NULL, NULL),
(56840, '2017-12-16 09:45:32', NULL, NULL, 15288, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:45:32', 'admin-1513386801-15133887320089778', 1, 0, '', NULL, NULL, NULL),
(56841, '2017-12-16 10:29:06', NULL, NULL, 15294, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:29:06', 'admin-1513386801-15133913464129094', 1, 0, '', NULL, NULL, NULL),
(56842, '2017-12-16 16:07:16', NULL, NULL, 15319, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 16:07:16', 'admin-1513386801-15134116359749194', 1, 0, '', NULL, NULL, NULL),
(56843, '2017-12-16 10:29:06', NULL, NULL, 15294, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:29:06', 'admin-1513386801-15133913464129094', 1, 0, '', NULL, NULL, NULL),
(56844, '2017-12-16 10:28:49', NULL, NULL, 15294, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:28:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56845, '2017-12-16 10:12:43', NULL, NULL, 15291, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:12:43', 'admin-1513386801-15133903636617530', 1, 1, 'SR', NULL, NULL, NULL),
(56846, '2017-12-16 10:14:28', NULL, NULL, 15292, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:14:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56847, '2017-12-16 10:17:08', NULL, NULL, 15293, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:17:08', 'admin-1513386801-1513390627911626', 1, 1, 'SR', NULL, NULL, NULL),
(56848, '2017-12-16 10:12:43', NULL, NULL, 15291, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:12:43', 'admin-1513386801-15133903636617530', 1, 1, 'SR', NULL, NULL, NULL),
(56849, '2017-12-16 10:12:43', NULL, NULL, 15291, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:12:43', 'admin-1513386801-15133903636617530', 1, 0, '', NULL, NULL, NULL),
(56850, '2017-12-16 10:12:43', NULL, NULL, 15291, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:12:43', 'admin-1513386801-15133903636617530', 1, 0, '', NULL, NULL, NULL),
(56851, '2017-12-16 10:12:18', NULL, NULL, 15291, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:12:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56852, '2017-12-16 09:21:38', NULL, NULL, 15286, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:21:38', 'admin-1513386801-15133872981819353', 1, 1, 'SR', NULL, NULL, NULL),
(56853, '2017-12-16 09:21:38', NULL, NULL, 15286, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:21:38', 'admin-1513386801-15133872981819353', 1, 1, 'SR', NULL, NULL, NULL),
(56854, '2017-12-16 10:04:20', NULL, NULL, 15290, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:04:20', 'admin-1513386801-15133898599129595', 1, 0, '', NULL, NULL, NULL),
(56855, '2017-12-16 10:29:06', NULL, NULL, 15294, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:29:06', 'admin-1513386801-15133913464129094', 1, 0, '', NULL, NULL, NULL),
(56856, '2017-12-16 10:04:20', NULL, NULL, 15290, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:04:20', 'admin-1513386801-15133898599129595', 1, 0, '', NULL, NULL, NULL),
(56857, '2017-12-16 10:04:10', NULL, NULL, 15290, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1513386801', 'admin', '2017-12-16 10:04:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56858, '2017-12-16 09:55:56', NULL, NULL, 15289, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:55:56', 'admin-1513386801-15133893567986910', 1, 1, 'SR', NULL, NULL, NULL),
(56859, '2017-12-16 09:51:16', NULL, NULL, 15289, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:51:16', 'admin-1513386801-15133890767552476', 1, 0, '', NULL, NULL, NULL),
(56860, '2017-12-16 09:51:16', NULL, NULL, 15289, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:51:16', 'admin-1513386801-15133890767552476', 1, 0, '', NULL, NULL, NULL),
(56861, '2017-12-16 09:51:16', NULL, NULL, 15289, 0, 153, '87', 'Wake Me Up!', 'sunnysideup', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:51:16', 'admin-1513386801-15133890767552476', 1, 0, '', NULL, NULL, NULL),
(56862, '2017-12-16 09:51:16', NULL, NULL, 15289, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:51:16', 'admin-1513386801-15133890767552476', 1, 0, '', NULL, NULL, NULL),
(56863, '2017-12-16 09:50:28', NULL, NULL, 15289, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.80, 0.0000, 0.0000, 13.80, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:50:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56864, '2017-12-16 09:51:16', NULL, NULL, 15289, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:51:16', 'admin-1513386801-15133890767552476', 1, 0, '', NULL, NULL, NULL),
(56865, '2017-12-16 09:36:41', NULL, NULL, 15288, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:36:41', 'admin-1513386801-15133882016602994', 1, 1, 'SR', NULL, NULL, NULL),
(56866, '2017-12-16 09:36:41', NULL, NULL, 15288, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:36:41', 'admin-1513386801-15133882016602994', 1, 1, 'SR', NULL, NULL, NULL),
(56867, '2017-12-16 09:17:33', NULL, NULL, 15284, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:17:33', 'admin-1513386801-15133870527678061', 1, 1, 'SR', NULL, NULL, NULL),
(56868, '2017-12-16 09:17:52', NULL, NULL, 15285, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:17:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56869, '2017-12-16 11:47:17', NULL, NULL, 15296, 0, 153, '87', 'Wake Me Up!', 'sunny sid up', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 11:47:17', 'admin-1513386801-15133960370686379', 1, 0, '', NULL, NULL, NULL),
(56870, '2017-12-16 09:27:08', NULL, NULL, 15287, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:27:08', 'admin-1513386801-15133876280794568', 1, 0, '', NULL, NULL, NULL),
(56871, '2017-12-16 09:27:08', NULL, NULL, 15287, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:27:08', 'admin-1513386801-15133876280794568', 1, 0, '', NULL, NULL, NULL),
(56872, '2017-12-16 09:17:19', NULL, NULL, 15284, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:17:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56873, '2017-12-16 09:17:32', NULL, NULL, 15284, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:17:32', 'admin-1513386801-15133870527678061', 1, 0, '', NULL, NULL, NULL),
(56874, '2017-12-16 09:17:33', NULL, NULL, 15284, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:17:33', 'admin-1513386801-15133870527678061', 1, 0, '', NULL, NULL, NULL),
(56875, '2017-12-16 09:22:35', NULL, NULL, 15286, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:22:35', 'admin-1513386801-1513387355511184', 1, 0, '', NULL, NULL, NULL),
(56876, '2017-12-16 09:21:26', NULL, NULL, 15286, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:21:26', 'admin-1513386801-15133872865568532', 1, 0, '', NULL, NULL, NULL),
(56877, '2017-12-16 09:17:56', NULL, NULL, 15285, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513386801', 'admin', '2017-12-16 09:17:56', 'admin-1513386801-15133870763959169', 1, 1, 'SR', NULL, NULL, NULL),
(56878, '2017-12-17 10:01:18', NULL, NULL, 15327, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:01:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56879, '2017-12-17 10:07:56', NULL, NULL, 15328, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:07:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56880, '2017-12-16 16:41:11', NULL, NULL, 15321, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1513470685', 'admin', '2017-12-16 16:41:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56881, '2017-12-17 14:59:37', NULL, NULL, 15356, 0, 316, '252', 'AA Set - Sesame Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:59:37', 'admin-1513470685-15134939769546065', 1, 0, '', NULL, NULL, NULL),
(56882, '2017-12-17 14:11:35', NULL, NULL, 15354, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:11:35', 'admin-1513470685-1513491095191253', 1, 1, 'SR', NULL, NULL, NULL),
(56883, '2017-12-17 15:16:08', NULL, NULL, 15358, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1513470685', 'admin', '2017-12-17 15:16:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56884, '2017-12-17 15:16:18', NULL, NULL, 15358, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 15:16:18', 'admin-1513470685-1513494978155536', 1, 0, '', NULL, NULL, NULL),
(56885, '2017-12-17 11:24:04', NULL, NULL, 15335, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 11:24:04', 'admin-1513470685-15134810443808640', 1, 0, '', NULL, NULL, NULL),
(56886, '2017-12-17 09:34:34', NULL, NULL, 15324, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:34:34', 'admin-1513470685-1513474474572704', 1, 1, 'SR', NULL, NULL, NULL),
(56887, '2017-12-17 09:34:34', NULL, NULL, 15324, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:34:34', 'admin-1513470685-1513474474572704', 1, 1, 'SR', NULL, NULL, NULL),
(56888, '2017-12-17 09:35:23', NULL, NULL, 15325, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:35:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56889, '2017-12-17 09:35:29', NULL, NULL, 15325, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:35:29', 'admin-1513470685-15134745291483632', 1, 0, '', NULL, NULL, NULL),
(56890, '2017-12-17 12:03:43', NULL, NULL, 15338, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:03:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56891, '2017-12-17 12:03:47', NULL, NULL, 15338, 0, 319, '255', 'AA Set - Spicy Shrimp Macaroni', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:03:47', 'admin-1513470685-15134834276854889', 1, 0, '', NULL, NULL, NULL),
(56892, '2017-12-17 14:10:33', NULL, NULL, 15353, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:10:33', 'admin-1513470685-15134910333268670', 1, 1, 'SR', NULL, NULL, NULL),
(56893, '2017-12-17 13:42:34', NULL, NULL, 15347, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:42:34', 'admin-1513470685-15134893545183184', 1, 1, 'SR', 1, NULL, NULL),
(56894, '2017-12-17 13:46:21', NULL, NULL, 15348, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:46:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56895, '2017-12-17 13:46:30', NULL, NULL, 15348, 0, 314, '250', 'AA Set - Thai Styled Garlic Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:46:30', 'admin-1513470685-15134895907301575', 1, 0, '', NULL, NULL, NULL),
(56896, '2017-12-17 12:24:22', NULL, NULL, 15341, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:24:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56897, '2017-12-17 12:24:42', NULL, NULL, 15341, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:24:42', 'admin-1513470685-15134846827175851', 1, 1, 'SR', NULL, NULL, NULL),
(56898, '2017-12-17 12:24:42', NULL, NULL, 15341, 0, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:24:42', 'admin-1513470685-15134846827175851', 1, 1, 'SR', NULL, NULL, NULL),
(56899, '2017-12-17 10:22:08', NULL, NULL, 15329, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:22:08', 'admin-1513470685-15134773281804577', 1, 0, '', NULL, NULL, NULL),
(56900, '2017-12-17 10:22:13', NULL, NULL, 15329, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:22:13', 'admin-1513470685-15134773331892426', 1, 1, 'SR', NULL, NULL, NULL),
(56901, '2017-12-17 10:37:00', NULL, NULL, 15330, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:37:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56902, '2017-12-17 16:21:02', NULL, NULL, 15360, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1513470685', 'admin', '2017-12-17 16:21:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56903, '2017-12-17 16:21:06', NULL, NULL, 15360, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 16:21:06', 'admin-1513470685-1513498866145807', 1, 1, 'SR', NULL, NULL, NULL),
(56904, '2017-12-17 13:46:30', NULL, NULL, 15348, 0, 314, '250', 'AA Set - Thai Styled Garlic Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:46:30', 'admin-1513470685-15134895907301575', 1, 0, '', NULL, NULL, NULL),
(56905, '2017-12-17 13:46:37', NULL, NULL, 15348, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:46:37', 'admin-1513470685-15134895970882017', 1, 1, 'SR', NULL, NULL, NULL),
(56906, '2017-12-17 13:46:37', NULL, NULL, 15348, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:46:37', 'admin-1513470685-15134895970882017', 1, 1, 'SR', NULL, NULL, NULL),
(56907, '2017-12-17 09:34:27', NULL, NULL, 15324, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:34:27', 'admin-1513470685-15134744673818549', 1, 0, '', NULL, NULL, NULL),
(56908, '2017-12-17 09:34:34', NULL, NULL, 15324, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:34:34', 'admin-1513470685-1513474474572704', 1, 1, 'SR', NULL, NULL, NULL),
(56909, '2017-12-17 09:05:00', NULL, NULL, 15322, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:05:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56910, '2017-12-17 09:05:15', NULL, NULL, 15322, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:05:15', 'admin-1513470685-15134727155696493', 1, 1, 'SR', NULL, NULL, NULL),
(56911, '2017-12-17 15:50:46', NULL, NULL, 15359, 0, 182, '117', 'Open Drinks ', 'apple,apple', 'Cold Drinks', 'Fresh Juice', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 15:50:46', 'admin-1513470685-15134970458372712', 1, 0, '', 1, NULL, NULL),
(56912, '2017-12-17 15:16:18', NULL, NULL, 15358, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 15:16:18', 'admin-1513470685-1513494978155536', 1, 1, 'SR', NULL, NULL, NULL),
(56913, '2017-12-17 15:16:37', NULL, NULL, 15358, 0, 338, '274', 'Chocolate Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 15:16:37', 'admin-1513470685-1513494997290932', 1, 0, '', NULL, NULL, NULL),
(56914, '2017-12-17 15:16:37', NULL, NULL, 15358, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 15:16:37', 'admin-1513470685-1513494997290932', 1, 1, 'SR', NULL, NULL, NULL),
(56915, '2017-12-17 13:49:05', NULL, NULL, 15349, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:49:05', 'admin-1513470685-15134897449733394', 1, 1, 'SR', NULL, NULL, NULL),
(56916, '2017-12-17 15:09:34', NULL, NULL, 15357, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 15:09:34', 'admin-1513470685-15134945745683151', 1, 1, 'SR', NULL, NULL, NULL),
(56917, '2017-12-17 15:09:34', NULL, NULL, 15357, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 15:09:34', 'admin-1513470685-15134945745683151', 1, 1, 'SR', NULL, NULL, NULL),
(56918, '2017-12-17 13:39:33', NULL, NULL, 15346, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:39:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56919, '2017-12-17 12:38:43', NULL, NULL, 15342, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:38:43', 'admin-1513470685-1513485523849472', 1, 0, '', NULL, NULL, NULL),
(56920, '2017-12-17 12:38:48', NULL, NULL, 15342, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:38:48', 'admin-1513470685-15134855285686771', 1, 1, 'SR', NULL, NULL, NULL),
(56921, '2017-12-17 13:49:05', NULL, NULL, 15349, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:49:05', 'admin-1513470685-15134897449733394', 1, 0, '', NULL, NULL, NULL),
(56922, '2017-12-17 15:09:34', NULL, NULL, 15357, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 15:09:34', 'admin-1513470685-15134945745683151', 1, 1, 'SR', NULL, NULL, NULL),
(56923, '2017-12-17 15:09:06', NULL, NULL, 15357, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 15:09:06', 'admin-1513470685-15134945461569168', 1, 0, '', NULL, NULL, NULL),
(56924, '2017-12-17 15:09:06', NULL, NULL, 15357, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 15:09:06', 'admin-1513470685-15134945461569168', 1, 0, '', NULL, NULL, NULL),
(56925, '2017-12-17 13:26:59', NULL, NULL, 15345, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:26:59', 'admin-1513470685-1513488419782338', 1, 0, '', NULL, NULL, NULL),
(56926, '2017-12-17 09:25:20', NULL, NULL, 15323, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:25:20', 'admin-1513470685-15134739207672319', 1, 0, '', NULL, NULL, NULL),
(56927, '2017-12-17 09:34:06', NULL, NULL, 15324, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.90, 0.0000, 0.0000, 10.90, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:34:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56928, '2017-12-17 09:34:13', NULL, NULL, 15324, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:34:13', 'admin-1513470685-1513474453081183', 1, 0, '', NULL, NULL, NULL),
(56929, '2017-12-17 09:34:13', NULL, NULL, 15324, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:34:13', 'admin-1513470685-1513474453081183', 1, 0, '', NULL, NULL, NULL),
(56930, '2017-12-17 09:34:27', NULL, NULL, 15324, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:34:27', 'admin-1513470685-15134744673818549', 1, 0, '', NULL, NULL, NULL),
(56931, '2017-12-17 15:08:58', NULL, NULL, 15357, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1513470685', 'admin', '2017-12-17 15:08:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56932, '2017-12-17 14:59:27', NULL, NULL, 15356, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:59:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56933, '2017-12-17 13:08:26', NULL, NULL, 15344, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:08:26', 'admin-1513470685-15134873068499292', 1, 1, 'SR', NULL, NULL, NULL),
(56934, '2017-12-17 13:26:52', NULL, NULL, 15345, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:26:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56935, '2017-12-17 09:15:03', NULL, NULL, 15323, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:15:03', 'admin-1513470685-15134733030507125', 1, 0, '', NULL, NULL, NULL),
(56936, '2017-12-17 14:52:26', NULL, NULL, 15354, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:52:26', 'admin-1513470685-15134935459406737', 1, 0, '', NULL, NULL, NULL),
(56937, '2017-12-17 14:55:38', NULL, NULL, 15354, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:55:38', 'admin-1513470685-15134937380535412', 1, 1, 'SR', NULL, NULL, NULL),
(56938, '2017-12-17 09:56:18', NULL, NULL, 15326, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:56:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56939, '2017-12-17 09:56:37', NULL, NULL, 15326, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:56:37', 'admin-1513470685-15134757975053034', 1, 1, 'SR', NULL, NULL, NULL),
(56940, '2017-12-17 09:56:37', NULL, NULL, 15326, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:56:37', 'admin-1513470685-15134757975053034', 1, 0, '', NULL, NULL, NULL),
(56941, '2017-12-17 09:56:37', NULL, NULL, 15326, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:56:37', 'admin-1513470685-15134757975053034', 1, 0, '', NULL, NULL, NULL),
(56942, '2017-12-17 09:56:42', NULL, NULL, 15326, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:56:42', 'admin-1513470685-15134758026254034', 1, 1, 'SR', NULL, NULL, NULL),
(56943, '2017-12-17 10:57:49', NULL, NULL, 15333, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:57:49', 'admin-1513470685-15134794689217210', 1, 0, '', NULL, NULL, NULL),
(56944, '2017-12-17 14:59:44', NULL, NULL, 15356, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:59:44', 'admin-1513470685-15134939841366151', 1, 0, '', NULL, NULL, NULL),
(56945, '2017-12-17 14:59:37', NULL, NULL, 15356, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:59:37', 'admin-1513470685-15134939769546065', 1, 0, '', NULL, NULL, NULL),
(56946, '2017-12-17 14:24:26', NULL, NULL, 15350, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:24:26', 'admin-1513470685-15134918665877473', 1, 1, 'SR', NULL, NULL, NULL),
(56947, '2017-12-17 14:20:35', NULL, NULL, 15355, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:20:35', 'admin-1513470685-15134916354083176', 1, 0, '', 1, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(56948, '2017-12-17 14:23:44', NULL, NULL, 15352, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:23:44', 'admin-1513470685-15134918240614096', 1, 0, '', NULL, NULL, NULL),
(56949, '2017-12-17 14:11:48', NULL, NULL, 15354, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:11:48', 'admin-1513470685-15134911078779097', 1, 1, 'SR', NULL, NULL, NULL),
(56950, '2017-12-17 14:55:38', NULL, NULL, 15354, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:55:38', 'admin-1513470685-15134937380535412', 1, 1, 'SR', NULL, NULL, NULL),
(56951, '2017-12-17 14:05:11', NULL, NULL, 15351, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:05:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56952, '2017-12-17 14:05:24', NULL, NULL, 15351, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:05:24', 'admin-1513470685-15134907241544926', 1, 1, 'SR', NULL, NULL, NULL),
(56953, '2017-12-17 14:11:48', NULL, NULL, 15354, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:11:48', 'admin-1513470685-15134911078779097', 1, 1, 'SR', NULL, NULL, NULL),
(56954, '2017-12-17 14:11:35', NULL, NULL, 15354, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:11:35', 'admin-1513470685-1513491095191253', 1, 1, 'SR', NULL, NULL, NULL),
(56955, '2017-12-17 14:11:24', NULL, NULL, 15354, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:11:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56956, '2017-12-17 14:05:54', NULL, NULL, 15351, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:05:54', 'admin-1513470685-15134907541869846', 1, 0, '', NULL, NULL, NULL),
(56957, '2017-12-17 14:07:47', NULL, NULL, 15352, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:07:47', 'admin-1513470685-15134908669372075', 1, 0, '', NULL, NULL, NULL),
(56958, '2017-12-17 14:05:54', NULL, NULL, 15351, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:05:54', 'admin-1513470685-15134907541869846', 1, 1, 'SR', NULL, NULL, NULL),
(56959, '2017-12-17 12:14:23', NULL, NULL, 15339, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.30, 0.0000, 0.0000, 10.30, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:14:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56960, '2017-12-17 15:16:37', NULL, NULL, 15358, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 15:16:37', 'admin-1513470685-1513494997290932', 1, 1, 'SR', NULL, NULL, NULL),
(56961, '2017-12-17 14:07:47', NULL, NULL, 15352, 0, 315, '251', 'AA Set - Asian Spicy Lemony Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:07:47', 'admin-1513470685-15134908669372075', 1, 0, '', NULL, NULL, NULL),
(56962, '2017-12-17 14:07:35', NULL, NULL, 15352, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:07:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56963, '2017-12-17 11:57:06', NULL, NULL, 15337, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1513470685', 'admin', '2017-12-17 11:57:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56964, '2017-12-17 11:57:14', NULL, NULL, 15337, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 11:57:14', 'admin-1513470685-1513483034045804', 1, 1, 'SR', NULL, NULL, NULL),
(56965, '2017-12-17 10:57:49', NULL, NULL, 15333, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:57:49', 'admin-1513470685-15134794689217210', 1, 1, 'SR', NULL, NULL, NULL),
(56966, '2017-12-17 10:59:05', NULL, NULL, 15334, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.59, 0.0000, 0.0000, 1.59, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:59:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56967, '2017-12-17 10:59:11', NULL, NULL, 15334, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:59:11', 'admin-1513470685-15134795513276584', 1, 0, '', NULL, NULL, NULL),
(56968, '2017-12-17 11:07:45', NULL, NULL, 15334, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1513470685', 'admin', '2017-12-17 11:07:45', 'admin-1513470685-15134800655413631', 1, 0, '', NULL, NULL, NULL),
(56969, '2017-12-17 11:07:45', NULL, NULL, 15334, 0, 262, '196', 'Cheesy Sticks', '', 'Desserts', '0', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 11:07:45', 'admin-1513470685-15134800655413631', 1, 0, '', NULL, NULL, NULL),
(56970, '2017-12-17 13:59:41', NULL, NULL, 15350, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:59:41', 'admin-1513470685-15134903818019151', 1, 1, 'SR', NULL, NULL, NULL),
(56971, '2017-12-17 13:59:22', NULL, NULL, 15350, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:59:22', 'admin-1513470685-15134903624544296', 1, 0, '', NULL, NULL, NULL),
(56972, '2017-12-17 13:59:22', NULL, NULL, 15350, 0, 291, '225', 'Smoked Duck Red Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:59:22', 'admin-1513470685-15134903624544296', 1, 0, '', NULL, NULL, NULL),
(56973, '2017-12-17 13:59:22', NULL, NULL, 15350, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:59:22', 'admin-1513470685-15134903624544296', 1, 0, '', NULL, NULL, NULL),
(56974, '2017-12-17 13:59:22', NULL, NULL, 15350, 0, 314, '250', 'AA Set - Thai Styled Garlic Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:59:22', 'admin-1513470685-15134903624544296', 1, 0, '', NULL, NULL, NULL),
(56975, '2017-12-17 13:59:22', NULL, NULL, 15350, 0, 314, '250', 'AA Set - Thai Styled Garlic Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:59:22', 'admin-1513470685-15134903624544296', 1, 0, '', NULL, NULL, NULL),
(56976, '2017-12-17 13:58:52', NULL, NULL, 15350, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.90, 0.0000, 0.0000, 15.90, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:58:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56977, '2017-12-17 12:15:38', NULL, NULL, 15339, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:15:38', 'admin-1513470685-15134841387043821', 1, 1, 'SR', NULL, NULL, NULL),
(56978, '2017-12-17 12:18:57', NULL, NULL, 15340, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:18:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56979, '2017-12-17 12:50:55', NULL, NULL, 15341, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:50:55', 'admin-1513470685-15134862554546927', 1, 0, '', NULL, NULL, NULL),
(56980, '2017-12-17 12:50:55', NULL, NULL, 15341, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:50:55', 'admin-1513470685-15134862554546927', 1, 1, 'SR', NULL, NULL, NULL),
(56981, '2017-12-17 12:53:36', NULL, NULL, 15343, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:53:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56982, '2017-12-17 11:30:05', NULL, NULL, 15336, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 11:30:05', 'admin-1513470685-15134814056871764', 1, 0, '', NULL, NULL, NULL),
(56983, '2017-12-17 11:30:14', NULL, NULL, 15336, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 11:30:14', 'admin-1513470685-15134814142033733', 1, 1, 'SR', NULL, NULL, NULL),
(56984, '2017-12-17 11:30:14', NULL, NULL, 15336, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 11:30:14', 'admin-1513470685-15134814142033733', 1, 1, 'SR', NULL, NULL, NULL),
(56985, '2017-12-17 12:15:19', NULL, NULL, 15339, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:15:19', 'admin-1513470685-15134841195745174', 1, 0, '', NULL, NULL, NULL),
(56986, '2017-12-17 13:08:26', NULL, NULL, 15344, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:08:26', 'admin-1513470685-15134873068499292', 1, 0, '', NULL, NULL, NULL),
(56987, '2017-12-17 12:34:08', NULL, NULL, 15340, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:34:08', 'admin-1513470685-15134852478633176', 1, 0, '', NULL, NULL, NULL),
(56988, '2017-12-17 12:38:33', NULL, NULL, 15342, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:38:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56989, '2017-12-17 12:38:43', NULL, NULL, 15342, 0, 319, '255', 'AA Set - Spicy Shrimp Macaroni', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:38:43', 'admin-1513470685-1513485523849472', 1, 0, '', NULL, NULL, NULL),
(56990, '2017-12-17 13:39:46', NULL, NULL, 15346, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:39:46', 'admin-1513470685-15134891864458960', 1, 0, '', NULL, NULL, NULL),
(56991, '2017-12-17 13:08:15', NULL, NULL, 15344, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:08:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56992, '2017-12-17 12:15:19', NULL, NULL, 15339, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:15:19', 'admin-1513470685-15134841195745174', 1, 0, '', NULL, NULL, NULL),
(56993, '2017-12-17 10:37:11', NULL, NULL, 15330, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:37:11', 'admin-1513470685-1513478231091774', 1, 0, '', NULL, NULL, NULL),
(56994, '2017-12-17 10:37:21', NULL, NULL, 15330, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:37:21', 'admin-1513470685-15134782412601513', 1, 1, 'SR', NULL, NULL, NULL),
(56995, '2017-12-17 10:37:21', NULL, NULL, 15330, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:37:21', 'admin-1513470685-15134782412601513', 1, 0, '', NULL, NULL, NULL),
(56996, '2017-12-17 10:40:07', NULL, NULL, 15331, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:40:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(56997, '2017-12-17 13:26:59', NULL, NULL, 15345, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:26:59', 'admin-1513470685-1513488419782338', 1, 1, 'SR', NULL, NULL, NULL),
(56998, '2017-12-17 12:54:15', NULL, NULL, 15343, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:54:15', 'admin-1513470685-15134864553213868', 1, 0, '', NULL, NULL, NULL),
(56999, '2017-12-17 12:19:06', NULL, NULL, 15340, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:19:06', 'admin-1513470685-15134843465644073', 1, 0, '', NULL, NULL, NULL),
(57000, '2017-12-17 12:19:06', NULL, NULL, 15340, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:19:06', 'admin-1513470685-15134843465644073', 1, 1, 'SR', NULL, NULL, NULL),
(57001, '2017-12-17 13:59:41', NULL, NULL, 15350, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:59:41', 'admin-1513470685-15134903818019151', 1, 1, 'SR', NULL, NULL, NULL),
(57002, '2017-12-17 12:54:15', NULL, NULL, 15343, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:54:15', 'admin-1513470685-15134864553213868', 1, 1, 'SR', NULL, NULL, NULL),
(57003, '2017-12-17 11:29:59', NULL, NULL, 15336, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1513470685', 'admin', '2017-12-17 11:29:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57004, '2017-12-17 12:15:19', NULL, NULL, 15339, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:15:19', 'admin-1513470685-15134841195745174', 1, 0, '', NULL, NULL, NULL),
(57005, '2017-12-17 12:15:19', NULL, NULL, 15339, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:15:19', 'admin-1513470685-15134841195745174', 1, 0, '', NULL, NULL, NULL),
(57006, '2017-12-17 12:15:38', NULL, NULL, 15339, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:15:38', 'admin-1513470685-15134841387043821', 1, 1, 'SR', NULL, NULL, NULL),
(57007, '2017-12-17 12:15:38', NULL, NULL, 15339, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:15:38', 'admin-1513470685-15134841387043821', 1, 0, '', NULL, NULL, NULL),
(57008, '2017-12-17 13:59:41', NULL, NULL, 15350, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:59:41', 'admin-1513470685-15134903818019151', 1, 1, 'SR', NULL, NULL, NULL),
(57009, '2017-12-17 14:10:30', NULL, NULL, 15353, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:10:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57010, '2017-12-17 12:54:15', NULL, NULL, 15343, 0, 319, '255', 'AA Set - Spicy Shrimp Macaroni', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 12:54:15', 'admin-1513470685-15134864553213868', 1, 0, '', NULL, NULL, NULL),
(57011, '2017-12-17 11:57:14', NULL, NULL, 15337, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 11:57:14', 'admin-1513470685-1513483034045804', 1, 1, 'SR', NULL, NULL, NULL),
(57012, '2017-12-17 10:40:46', NULL, NULL, 15331, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:40:46', 'admin-1513470685-1513478446005559', 1, 1, 'SR', NULL, NULL, NULL),
(57013, '2017-12-17 10:40:46', NULL, NULL, 15331, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:40:46', 'admin-1513470685-1513478446005559', 1, 1, 'SR', NULL, NULL, NULL),
(57014, '2017-12-17 11:30:05', NULL, NULL, 15336, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 11:30:05', 'admin-1513470685-15134814056871764', 1, 0, '', NULL, NULL, NULL),
(57015, '2017-12-17 11:24:04', NULL, NULL, 15335, 0, 302, '238', 'Ice on the cake', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 11:24:04', 'admin-1513470685-15134810443808640', 1, 0, '', NULL, NULL, NULL),
(57016, '2017-12-17 11:24:04', NULL, NULL, 15335, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 11:24:04', 'admin-1513470685-15134810443808640', 1, 1, 'SR', NULL, NULL, NULL),
(57017, '2017-12-17 10:57:31', NULL, NULL, 15333, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:57:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57018, '2017-12-17 15:09:56', NULL, NULL, 15357, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 15:09:56', 'admin-1513470685-15134945968615921', 1, 0, '', NULL, NULL, NULL),
(57019, '2017-12-17 11:24:04', NULL, NULL, 15335, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 11:24:04', 'admin-1513470685-15134810443808640', 1, 0, '', NULL, NULL, NULL),
(57020, '2017-12-17 11:23:35', NULL, NULL, 15335, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1513470685', 'admin', '2017-12-17 11:23:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57021, '2017-12-17 10:57:49', NULL, NULL, 15333, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:57:49', 'admin-1513470685-15134794689217210', 1, 0, '', NULL, NULL, NULL),
(57022, '2017-12-17 10:48:33', NULL, NULL, 15332, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:48:33', 'admin-1513470685-15134789135188090', 1, 1, 'SR', NULL, NULL, NULL),
(57023, '2017-12-17 10:48:33', NULL, NULL, 15332, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:48:33', 'admin-1513470685-15134789135188090', 1, 1, 'SR', NULL, NULL, NULL),
(57024, '2017-12-17 09:35:33', NULL, NULL, 15325, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:35:33', 'admin-1513470685-15134745331071830', 1, 1, 'SR', NULL, NULL, NULL),
(57025, '2017-12-17 09:14:46', NULL, NULL, 15323, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:14:46', 'admin-1513470685-1513473286120336', 1, 0, '', NULL, NULL, NULL),
(57026, '2017-12-17 09:14:46', NULL, NULL, 15323, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:14:46', 'admin-1513470685-1513473286120336', 1, 0, '', NULL, NULL, NULL),
(57027, '2017-12-17 09:14:46', NULL, NULL, 15323, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:14:46', 'admin-1513470685-1513473286120336', 1, 0, '', NULL, NULL, NULL),
(57028, '2017-12-17 13:48:55', NULL, NULL, 15349, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:48:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57029, '2017-12-17 10:40:46', NULL, NULL, 15331, 0, 322, '258', 'Yuzu Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:40:46', 'admin-1513470685-1513478446005559', 1, 0, '', NULL, NULL, NULL),
(57030, '2017-12-17 10:48:22', NULL, NULL, 15332, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:48:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57031, '2017-12-17 10:48:27', NULL, NULL, 15332, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:48:27', 'admin-1513470685-15134789075346011', 1, 0, '', NULL, NULL, NULL),
(57032, '2017-12-17 10:37:11', NULL, NULL, 15330, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:37:11', 'admin-1513470685-1513478231091774', 1, 0, '', NULL, NULL, NULL),
(57033, '2017-12-17 10:40:14', NULL, NULL, 15331, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:40:14', 'admin-1513470685-15134784146263316', 1, 0, '', NULL, NULL, NULL),
(57034, '2017-12-17 10:08:07', NULL, NULL, 15328, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:08:07', 'admin-1513470685-15134764874339274', 1, 0, '', NULL, NULL, NULL),
(57035, '2017-12-17 10:40:14', NULL, NULL, 15331, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:40:14', 'admin-1513470685-15134784146263316', 1, 0, '', NULL, NULL, NULL),
(57036, '2017-12-17 10:22:03', NULL, NULL, 15329, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:22:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57037, '2017-12-17 10:08:07', NULL, NULL, 15328, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:08:07', 'admin-1513470685-15134764874339274', 1, 1, 'SR', NULL, NULL, NULL),
(57038, '2017-12-17 09:16:43', NULL, NULL, 15322, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:16:43', 'admin-1513470685-15134734033919021', 1, 1, 'SR', NULL, NULL, NULL),
(57039, '2017-12-17 09:16:43', NULL, NULL, 15322, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:16:43', 'admin-1513470685-15134734033919021', 1, 1, 'SR', NULL, NULL, NULL),
(57040, '2017-12-17 13:41:06', NULL, NULL, 15346, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 13:41:06', 'admin-1513470685-151348926683473', 1, 1, 'SR', NULL, NULL, NULL),
(57041, '2017-12-17 10:02:24', NULL, NULL, 15327, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:02:24', 'admin-1513470685-15134761440888864', 1, 1, 'SR', NULL, NULL, NULL),
(57042, '2017-12-17 10:01:27', NULL, NULL, 15327, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 10:01:27', 'admin-1513470685-15134760872164743', 1, 1, 'SR', NULL, NULL, NULL),
(57043, '2017-12-17 09:15:03', NULL, NULL, 15323, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:15:03', 'admin-1513470685-15134733030507125', 1, 1, 'SR', NULL, NULL, NULL),
(57044, '2017-12-17 14:05:24', NULL, NULL, 15351, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 14:05:24', 'admin-1513470685-15134907241544926', 1, 0, '', NULL, NULL, NULL),
(57045, '2017-12-17 09:35:29', NULL, NULL, 15325, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:35:29', 'admin-1513470685-15134745291483632', 1, 0, '', NULL, NULL, NULL),
(57046, '2017-12-17 09:21:13', NULL, NULL, 15321, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:21:13', 'admin-1513470685-15134736729707476', 1, 0, '', NULL, NULL, NULL),
(57047, '2017-12-17 09:16:33', NULL, NULL, 15322, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:16:33', 'admin-1513470685-15134733933048895', 1, 0, '', NULL, NULL, NULL),
(57048, '2017-12-17 09:16:33', NULL, NULL, 15322, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:16:33', 'admin-1513470685-15134733933048895', 1, 0, '', NULL, NULL, NULL),
(57049, '2017-12-17 09:15:03', NULL, NULL, 15323, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:15:03', 'admin-1513470685-15134733030507125', 1, 1, 'SR', NULL, NULL, NULL),
(57050, '2017-12-17 09:14:37', NULL, NULL, 15323, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.40, 0.0000, 0.0000, 11.40, 1, '27', 1, '1513470685', 'admin', '2017-12-17 09:14:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57051, '2017-12-18 13:36:45', NULL, NULL, 15376, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 9.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 13:36:45', 'admin-1513559204-15135754055361363', 1, 0, '', NULL, NULL, NULL),
(57052, '2017-12-18 13:50:48', NULL, NULL, 15375, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 16.0000, 0.0000, 8.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 13:50:48', 'admin-1513559204-1513576248435762', 1, 1, 'SR', NULL, NULL, NULL),
(57053, '2017-12-18 09:51:44', NULL, NULL, 15365, 0, 331, '267', 'Yuzu Marmalade Pancake', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:51:44', 'admin-1513559204-15135619044062058', 1, 0, '', NULL, NULL, NULL),
(57054, '2017-12-18 09:51:44', NULL, NULL, 15365, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:51:44', 'admin-1513559204-15135619044062058', 1, 0, '', NULL, NULL, NULL),
(57055, '2017-12-18 09:51:44', NULL, NULL, 15365, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:51:44', 'admin-1513559204-15135619044062058', 1, 1, 'SR', NULL, NULL, NULL),
(57056, '2017-12-18 16:05:49', NULL, NULL, 15385, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 16:05:49', 'admin-1513559204-15135843490738556', 1, 0, '', NULL, NULL, NULL),
(57057, '2017-12-18 17:32:43', NULL, NULL, 15388, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1513591586', 'admin', '2017-12-18 17:32:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57058, '2017-12-18 12:29:30', NULL, NULL, 15370, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 12:29:30', 'admin-1513559204-15135713704503523', 1, 0, '', NULL, NULL, NULL),
(57059, '2017-12-18 12:35:53', NULL, NULL, 15371, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 12:35:53', 'admin-1513559204-1513571752987173', 1, 0, '', NULL, NULL, NULL),
(57060, '2017-12-18 12:35:53', NULL, NULL, 15371, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 12:35:53', 'admin-1513559204-1513571752987173', 1, 0, '', NULL, NULL, NULL),
(57061, '2017-12-18 12:35:53', NULL, NULL, 15371, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 12:35:53', 'admin-1513559204-1513571752987173', 1, 1, 'SR', NULL, NULL, NULL),
(57062, '2017-12-18 13:12:36', NULL, NULL, 15371, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 13:12:36', 'admin-1513559204-15135739560098856', 1, 0, '', NULL, NULL, NULL),
(57063, '2017-12-18 16:36:51', NULL, NULL, 15387, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1513591586', 'admin', '2017-12-18 16:36:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57064, '2017-12-18 16:38:32', NULL, NULL, 15387, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 16:38:32', 'admin-1513559204-15135863125999684', 1, 0, '', NULL, NULL, NULL),
(57065, '2017-12-18 15:56:26', NULL, NULL, 15384, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 15:56:26', 'admin-1513559204-15135837868547724', 1, 0, '', NULL, NULL, NULL),
(57066, '2017-12-18 15:56:27', NULL, NULL, 15384, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 15:56:27', 'admin-1513559204-15135837868547724', 1, 1, 'SR', NULL, NULL, NULL),
(57067, '2017-12-18 16:05:41', NULL, NULL, 15385, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1513591586', 'admin', '2017-12-18 16:05:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57068, '2017-12-18 09:06:53', NULL, NULL, 15361, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:06:53', 'admin-1513559204-15135592138485264', 1, 1, 'SR', 1, NULL, NULL),
(57069, '2017-12-18 14:13:52', NULL, NULL, 15375, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.19, 0.0000, 0.0000, 1.19, 1, '27', 1, '1513591586', 'admin', '2017-12-18 14:13:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57070, '2017-12-18 10:04:05', NULL, NULL, 15366, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1513591586', 'admin', '2017-12-18 10:04:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57071, '2017-12-18 16:33:16', NULL, NULL, 15386, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 16:33:16', 'admin-1513559204-1513585996767472', 1, 0, '', NULL, NULL, NULL),
(57072, '2017-12-18 14:41:11', NULL, NULL, 15380, 0, 182, '117', 'Open Drinks ', 'Banana', 'Cold Drinks', 'Fresh Juice', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1513591586', 'admin', '2017-12-18 14:41:11', 'admin-1513559204-1513579271791931', 1, 0, '', 1, NULL, NULL),
(57073, '2017-12-18 09:42:34', NULL, NULL, 15364, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:42:34', 'admin-1513559204-15135613539113173', 1, 0, '', NULL, NULL, NULL),
(57074, '2017-12-18 10:32:20', NULL, NULL, 15367, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 10:32:20', 'admin-1513559204-15135643404326696', 1, 1, 'SR', NULL, NULL, NULL),
(57075, '2017-12-18 11:30:45', NULL, NULL, 15368, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1513591586', 'admin', '2017-12-18 11:30:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57076, '2017-12-18 11:33:55', NULL, NULL, 15368, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 11:33:55', 'admin-1513559204-1513568035295497', 1, 0, '', NULL, NULL, NULL),
(57077, '2017-12-18 11:33:55', NULL, NULL, 15368, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 11:33:55', 'admin-1513559204-1513568035295497', 1, 0, '', NULL, NULL, NULL),
(57078, '2017-12-18 11:33:55', NULL, NULL, 15368, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 11:33:55', 'admin-1513559204-1513568035295497', 1, 1, 'SR', NULL, NULL, NULL),
(57079, '2017-12-18 14:06:56', NULL, NULL, 15375, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1513591586', 'admin', '2017-12-18 14:06:56', 'admin-1513559204-15135772166675249', 1, 0, '', NULL, NULL, NULL),
(57080, '2017-12-18 00:00:00', NULL, NULL, 15378, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 13:50:48', 'admin-1513559204-1513576248435762', 1, 1, 'SR', NULL, NULL, NULL),
(57081, '2017-12-18 00:00:00', NULL, NULL, 15378, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 13:14:58', 'admin-1513559204-15135740986342067', 1, 1, 'SR', NULL, NULL, NULL),
(57082, '2017-12-18 15:52:44', NULL, NULL, 15384, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1513591586', 'admin', '2017-12-18 15:52:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57083, '2017-12-18 15:56:26', NULL, NULL, 15384, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 15:56:26', 'admin-1513559204-15135837868547724', 1, 0, '', NULL, NULL, NULL),
(57084, '2017-12-18 14:19:02', NULL, NULL, 15379, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 14:19:02', 'admin-1513559204-15135779426868339', 1, 0, '', NULL, NULL, NULL),
(57085, '2017-12-18 00:00:00', NULL, NULL, 15388, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 16:05:49', 'admin-1513559204-15135843490738556', 1, 1, 'SR', NULL, NULL, NULL),
(57086, '2017-12-18 18:05:08', NULL, NULL, 15389, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 18:05:08', 'admin-1513559204-15135915078597484', 1, 1, 'SR', NULL, NULL, NULL),
(57087, '2017-12-18 13:15:47', NULL, NULL, 15374, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 13:15:47', 'admin-1513559204-15135741473364217', 1, 1, 'SR', NULL, NULL, '10.0'),
(57088, '2017-12-18 13:15:47', NULL, NULL, 15374, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 13:15:47', 'admin-1513559204-15135741473364217', 1, 1, 'SR', NULL, NULL, '10.0'),
(57089, '2017-12-18 13:19:57', NULL, NULL, 15373, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Rice', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 13:19:57', 'admin-1513559204-15135743974288652', 1, 0, '', NULL, NULL, NULL),
(57090, '2017-12-18 13:36:41', NULL, NULL, 15376, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1513591586', 'admin', '2017-12-18 13:36:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57091, '2017-12-18 16:33:16', NULL, NULL, 15386, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 16:33:16', 'admin-1513559204-1513585996767472', 1, 0, '', NULL, NULL, NULL),
(57092, '2017-12-18 18:06:38', NULL, NULL, 15390, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 18:06:38', 'admin-1513591586-15135915982355344', 1, 0, '', 1, NULL, NULL),
(57093, '2017-12-18 18:06:38', NULL, NULL, 15390, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 18:06:38', 'admin-1513591586-15135915982355344', 1, 0, '', 1, NULL, NULL),
(57094, '2017-12-18 16:38:32', NULL, NULL, 15387, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 16:38:32', 'admin-1513559204-15135863125999684', 1, 0, '', NULL, NULL, NULL),
(57095, '2017-12-18 10:04:19', NULL, NULL, 15366, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 10:04:19', 'admin-1513559204-15135626594609537', 1, 0, '', NULL, NULL, NULL),
(57096, '2017-12-18 11:33:55', NULL, NULL, 15368, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 11:33:55', 'admin-1513559204-1513568035295497', 1, 1, 'SR', NULL, NULL, NULL),
(57097, '2017-12-18 11:35:59', NULL, NULL, 15369, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1513591586', 'admin', '2017-12-18 11:35:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57098, '2017-12-18 11:36:15', NULL, NULL, 15369, 0, 308, '244', 'AA Set - Chinese Ginger Garlic chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 11:36:15', 'admin-1513559204-15135681756887714', 1, 0, '', NULL, NULL, NULL),
(57099, '2017-12-18 12:35:53', NULL, NULL, 15371, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 12:35:53', 'admin-1513559204-1513571752987173', 1, 0, '', NULL, NULL, NULL),
(57100, '2017-12-18 12:47:53', NULL, NULL, 15373, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1513591586', 'admin', '2017-12-18 12:47:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57101, '2017-12-18 12:50:41', NULL, NULL, 15373, 0, 317, '253', 'AA Set - Japanese Curry Rice', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 12:50:41', 'admin-1513559204-15135726417326059', 1, 0, '', NULL, NULL, NULL),
(57102, '2017-12-18 09:51:44', NULL, NULL, 15365, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:51:44', 'admin-1513559204-15135619044062058', 1, 1, 'SR', NULL, NULL, NULL),
(57103, '2017-12-18 09:51:44', NULL, NULL, 15365, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:51:44', 'admin-1513559204-15135619044062058', 1, 1, 'SR', NULL, NULL, NULL),
(57104, '2017-12-18 13:11:56', NULL, NULL, 15374, 0, 317, '253', 'AA Set - Japanese Curry Rice', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 13:11:56', 'admin-1513559204-15135739160422652', 1, 0, '', NULL, NULL, '10.0'),
(57105, '2017-12-18 12:08:36', NULL, NULL, 15370, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 12:08:36', 'admin-1513559204-1513570115909690', 1, 0, '', NULL, NULL, NULL),
(57106, '2017-12-18 18:06:38', NULL, NULL, 15390, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 18:06:38', 'admin-1513591586-15135915982355344', 1, 0, '', 1, NULL, NULL),
(57107, '2017-12-18 16:33:07', NULL, NULL, 15386, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1513591586', 'admin', '2017-12-18 16:33:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57108, '2017-12-18 15:09:10', NULL, NULL, 15383, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1513591586', 'admin', '2017-12-18 15:09:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57109, '2017-12-18 14:58:02', NULL, NULL, 15382, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 14:58:02', 'admin-1513559204-15135802826885386', 1, 1, 'SR', 1, NULL, NULL),
(57110, '2017-12-18 14:50:45', NULL, NULL, 15381, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 14:50:45', 'admin-1513559204-15135798453582339', 1, 1, 'SR', NULL, NULL, NULL),
(57111, '2017-12-18 14:50:42', NULL, NULL, 15381, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1513591586', 'admin', '2017-12-18 14:50:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57112, '2017-12-18 14:19:02', NULL, NULL, 15379, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 14:19:02', 'admin-1513559204-15135779426868339', 1, 0, '', NULL, NULL, NULL),
(57113, '2017-12-18 13:40:36', NULL, NULL, 15377, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 13:40:36', 'admin-1513559204-15135756366994938', 1, 1, 'SR', NULL, NULL, NULL),
(57114, '2017-12-18 13:40:31', NULL, NULL, 15377, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1513591586', 'admin', '2017-12-18 13:40:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57115, '2017-12-18 12:26:54', NULL, NULL, 15371, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1513591586', 'admin', '2017-12-18 12:26:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57116, '2017-12-18 12:27:54', NULL, NULL, 15372, 0, 317, '253', 'AA Set - Japanese Curry Rice', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 12:27:54', 'admin-1513559204-15135712746689294', 1, 0, '', 1, NULL, '10.0'),
(57117, '2017-12-18 15:09:13', NULL, NULL, 15383, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 15:09:13', 'admin-1513559204-15135809537568590', 1, 1, 'SR', NULL, NULL, NULL),
(57118, '2017-12-18 00:00:00', NULL, NULL, 15378, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 13:14:58', 'admin-1513559204-15135740986342067', 1, 1, 'SR', NULL, NULL, NULL),
(57119, '2017-12-18 00:00:00', NULL, NULL, 15378, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, NULL, NULL, 3.80, 1, '27', 1, '1513591586', 'admin', '2017-12-18 13:14:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57120, '2017-12-18 12:50:41', NULL, NULL, 15373, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 12:50:41', 'admin-1513559204-15135726417326059', 1, 1, 'SR', NULL, NULL, NULL),
(57121, '2017-12-18 13:12:36', NULL, NULL, 15371, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 13:12:36', 'admin-1513559204-15135739560098856', 1, 0, '', NULL, NULL, NULL),
(57122, '2017-12-18 13:11:56', NULL, NULL, 15374, 0, 181, '116', 'Open Food ', 'Studio 11 special', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 13:11:56', 'admin-1513559204-15135739160422652', 1, 0, '', NULL, NULL, '10.0'),
(57123, '2017-12-18 13:11:56', NULL, NULL, 15374, 0, 181, '116', 'Open Food ', 'Studio 11 special', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 13:11:56', 'admin-1513559204-15135739160422652', 1, 0, '', NULL, NULL, '10.0'),
(57124, '2017-12-18 13:10:48', NULL, NULL, 15374, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1513591586', 'admin', '2017-12-18 13:10:48', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(57125, '2017-12-18 11:36:15', NULL, NULL, 15369, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 11:36:15', 'admin-1513559204-15135681756887714', 1, 1, 'SR', NULL, NULL, NULL),
(57126, '2017-12-18 11:36:15', NULL, NULL, 15369, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 11:36:15', 'admin-1513559204-15135681756887714', 1, 1, 'SR', NULL, NULL, NULL),
(57127, '2017-12-18 09:07:12', NULL, NULL, 15362, 0, 182, '117', 'Open Drinks ', 'Apple', 'Cold Drinks', 'Fresh Juice', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:07:12', 'admin-1513559204-15135592324473086', 1, 0, '', 1, NULL, NULL),
(57128, '2017-12-18 12:50:41', NULL, NULL, 15373, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 12:50:41', 'admin-1513559204-15135726417326059', 1, 0, '', NULL, NULL, NULL),
(57129, '2017-12-18 10:04:19', NULL, NULL, 15366, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 10:04:19', 'admin-1513559204-15135626594609537', 1, 0, '', NULL, NULL, NULL),
(57130, '2017-12-18 14:18:13', NULL, NULL, 15379, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1513591586', 'admin', '2017-12-18 14:18:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57131, '2017-12-18 12:08:36', NULL, NULL, 15370, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 12:08:36', 'admin-1513559204-1513570115909690', 1, 1, 'SR', NULL, NULL, NULL),
(57132, '2017-12-18 10:04:19', NULL, NULL, 15366, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 10:04:19', 'admin-1513559204-15135626594609537', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(57133, '2017-12-18 10:04:19', NULL, NULL, 15366, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 10:04:19', 'admin-1513559204-15135626594609537', 1, 0, '', NULL, NULL, NULL),
(57134, '2017-12-18 09:52:11', NULL, NULL, 15365, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:52:11', 'admin-1513559204-15135619312025874', 1, 0, '', NULL, NULL, NULL),
(57135, '2017-12-18 09:51:44', NULL, NULL, 15365, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:51:44', 'admin-1513559204-15135619044062058', 1, 1, 'SR', NULL, NULL, NULL),
(57136, '2017-12-18 09:51:44', NULL, NULL, 15365, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:51:44', 'admin-1513559204-15135619044062058', 1, 0, '', NULL, NULL, NULL),
(57137, '2017-12-18 09:36:35', NULL, NULL, 15363, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:36:35', 'admin-1513559204-15135609949222122', 1, 1, 'SR', NULL, NULL, NULL),
(57138, '2017-12-18 09:36:35', NULL, NULL, 15363, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:36:35', 'admin-1513559204-15135609949222122', 1, 1, 'SR', NULL, NULL, NULL),
(57139, '2017-12-18 09:42:34', NULL, NULL, 15364, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:42:34', 'admin-1513559204-15135613539113173', 1, 1, 'SR', NULL, NULL, NULL),
(57140, '2017-12-18 09:50:23', NULL, NULL, 15365, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.80, 0.0000, 0.0000, 10.80, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:50:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57141, '2017-12-18 09:08:30', NULL, NULL, 15363, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:08:30', 'admin-1513559204-15135593105404188', 1, 0, '', NULL, NULL, NULL),
(57142, '2017-12-18 09:08:30', NULL, NULL, 15363, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:08:30', 'admin-1513559204-15135593105404188', 1, 0, '', NULL, NULL, NULL),
(57143, '2017-12-18 10:32:16', NULL, NULL, 15367, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1513591586', 'admin', '2017-12-18 10:32:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57144, '2017-12-18 09:42:34', NULL, NULL, 15364, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:42:34', 'admin-1513559204-15135613539113173', 1, 1, 'SR', NULL, NULL, NULL),
(57145, '2017-12-18 09:42:34', NULL, NULL, 15364, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:42:34', 'admin-1513559204-15135613539113173', 1, 0, '', NULL, NULL, NULL),
(57146, '2017-12-18 09:42:34', NULL, NULL, 15364, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:42:34', 'admin-1513559204-15135613539113173', 1, 0, '', NULL, NULL, NULL),
(57147, '2017-12-18 09:42:18', NULL, NULL, 15364, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:42:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57148, '2017-12-18 09:51:44', NULL, NULL, 15365, 0, 301, '237', 'Black Jack', '', 'Cold Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:51:44', 'admin-1513559204-15135619044062058', 1, 0, '', NULL, NULL, NULL),
(57149, '2017-12-18 09:08:30', NULL, NULL, 15363, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:08:30', 'admin-1513559204-15135593105404188', 1, 1, 'SR', NULL, NULL, NULL),
(57150, '2017-12-18 12:07:42', NULL, NULL, 15370, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1513591586', 'admin', '2017-12-18 12:07:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57151, '2017-12-18 09:08:30', NULL, NULL, 15363, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:08:30', 'admin-1513559204-15135593105404188', 1, 1, 'SR', NULL, NULL, NULL),
(57152, '2017-12-18 09:08:12', NULL, NULL, 15363, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1513591586', 'admin', '2017-12-18 09:08:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57153, '2017-12-20 15:01:04', NULL, NULL, 15408, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 15:01:04', 'admin-1513731387-15137532642476858', 1, 1, 'SR', NULL, NULL, NULL),
(57154, '2017-12-20 15:03:18', NULL, NULL, 15409, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1513731387', 'admin', '2017-12-20 15:03:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57155, '2017-12-20 13:17:07', NULL, NULL, 15401, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 13:17:07', 'admin-1513731387-1513747027184511', 1, 1, 'SR', NULL, NULL, NULL),
(57156, '2017-12-20 12:13:51', NULL, NULL, 15399, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 12:13:51', 'admin-1513731387-15137432309761657', 1, 0, '', NULL, NULL, NULL),
(57157, '2017-12-20 10:09:05', NULL, NULL, 15395, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 10:09:05', 'admin-1513731387-15137357451214273', 1, 1, 'SR', NULL, NULL, NULL),
(57158, '2017-12-20 10:19:08', NULL, NULL, 15396, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1513731387', 'admin', '2017-12-20 10:19:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57159, '2017-12-20 14:34:41', NULL, NULL, 15407, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1513731387', 'admin', '2017-12-20 14:34:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57160, '2017-12-20 14:34:49', NULL, NULL, 15407, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 14:34:49', 'admin-1513731387-15137516892006854', 1, 0, '', NULL, NULL, NULL),
(57161, '2017-12-20 14:34:49', NULL, NULL, 15407, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 14:34:49', 'admin-1513731387-15137516892006854', 1, 1, 'SR', NULL, NULL, NULL),
(57162, '2017-12-20 15:00:47', NULL, NULL, 15408, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1513731387', 'admin', '2017-12-20 15:00:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57163, '2017-12-20 12:36:32', NULL, NULL, 15401, 0, 181, '116', 'Open Food ', 'panfried dumpling', 'Meals', 'Perfect Meals', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 12:36:32', 'admin-1513731387-15137445928689132', 1, 0, '', NULL, NULL, NULL),
(57164, '2017-12-20 12:36:32', NULL, NULL, 15401, 0, 306, '242', 'AA Set - Chinese Rice Wine Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 12:36:32', 'admin-1513731387-15137445928689132', 1, 0, '', NULL, NULL, NULL),
(57165, '2017-12-20 12:36:33', NULL, NULL, 15401, 0, 317, '253', 'AA Set - Japanese Curry Rice', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 12:36:33', 'admin-1513731387-15137445928689132', 1, 0, '', NULL, NULL, NULL),
(57166, '2017-12-20 00:00:00', NULL, NULL, 15402, 0, 324, '260', 'Blueberry Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 12:13:51', 'admin-1513731387-15137432309761657', 1, 0, '', NULL, NULL, NULL),
(57167, '2017-12-20 12:46:24', NULL, NULL, 15400, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 12:46:24', 'admin-1513731387-15137451847372949', 1, 0, '', NULL, NULL, NULL),
(57168, '2017-12-20 12:29:26', NULL, NULL, 15400, 0, 306, '242', 'AA Set - Chinese Rice Wine Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 12:29:26', 'admin-1513731387-15137441661685810', 1, 0, '', NULL, NULL, NULL),
(57169, '2017-12-20 13:17:51', NULL, NULL, 15403, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 13:17:51', 'admin-1513731387-15137470716769352', 1, 0, '', NULL, NULL, NULL),
(57170, '2017-12-20 09:33:12', NULL, NULL, 15393, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 09:33:12', 'admin-1513731387-15137335925503345', 1, 1, 'SR', NULL, NULL, NULL),
(57171, '2017-12-20 09:41:45', NULL, NULL, 15394, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1513731387', 'admin', '2017-12-20 09:41:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57172, '2017-12-20 09:41:54', NULL, NULL, 15394, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 09:41:54', 'admin-1513731387-15137341141491495', 1, 0, '', NULL, NULL, NULL),
(57173, '2017-12-20 09:41:54', NULL, NULL, 15394, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 09:41:54', 'admin-1513731387-15137341141491495', 1, 1, 'SR', NULL, NULL, NULL),
(57174, '2017-12-20 09:41:54', NULL, NULL, 15394, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 2, 15.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 09:41:54', 'admin-1513731387-15137341141491495', 1, 0, '', NULL, NULL, NULL),
(57175, '2017-12-20 10:09:05', NULL, NULL, 15395, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 10:09:05', 'admin-1513731387-15137357451214273', 1, 0, '', NULL, NULL, NULL),
(57176, '2017-12-20 15:01:04', NULL, NULL, 15408, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 15:01:04', 'admin-1513731387-15137532642476858', 1, 1, 'SR', NULL, NULL, NULL),
(57177, '2017-12-20 15:25:33', NULL, NULL, 15410, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 15:25:33', 'admin-1513731387-15137547334322966', 1, 0, '', NULL, NULL, NULL),
(57178, '2017-12-20 13:17:51', NULL, NULL, 15403, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 13:17:51', 'admin-1513731387-15137470716769352', 1, 1, 'SR', NULL, NULL, NULL),
(57179, '2017-12-20 13:27:40', NULL, NULL, 15404, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 13:27:40', 'admin-1513731387-15137476601642677', 1, 0, '', NULL, NULL, NULL),
(57180, '2017-12-20 12:29:26', NULL, NULL, 15400, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 12:29:26', 'admin-1513731387-15137441661685810', 1, 0, '', NULL, NULL, NULL),
(57181, '2017-12-20 14:04:05', NULL, NULL, 15405, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1513731387', 'admin', '2017-12-20 14:04:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57182, '2017-12-20 14:04:09', NULL, NULL, 15405, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 14:04:09', 'admin-1513731387-15137498491575420', 1, 1, 'SR', NULL, NULL, NULL),
(57183, '2017-12-20 15:25:33', NULL, NULL, 15410, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 15:25:33', 'admin-1513731387-15137547334322966', 1, 0, '', NULL, NULL, NULL),
(57184, '2017-12-20 15:03:31', NULL, NULL, 15409, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 15:03:31', 'admin-1513731387-15137534117858535', 1, 1, 'SR', NULL, NULL, NULL),
(57185, '2017-12-20 15:03:31', NULL, NULL, 15409, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 15:03:31', 'admin-1513731387-15137534117858535', 1, 0, '', NULL, NULL, NULL),
(57186, '2017-12-20 13:17:07', NULL, NULL, 15401, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 13:17:07', 'admin-1513731387-1513747027184511', 1, 1, 'SR', NULL, NULL, NULL),
(57187, '2017-12-20 15:01:04', NULL, NULL, 15408, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 15:01:04', 'admin-1513731387-15137532642476858', 1, 0, '', NULL, NULL, NULL),
(57188, '2017-12-20 14:04:09', NULL, NULL, 15405, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 14:04:09', 'admin-1513731387-15137498491575420', 1, 1, 'SR', NULL, NULL, NULL),
(57189, '2017-12-20 15:01:04', NULL, NULL, 15408, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 15:01:04', 'admin-1513731387-15137532642476858', 1, 0, '', NULL, NULL, NULL),
(57190, '2017-12-20 14:06:27', NULL, NULL, 15406, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 14:06:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57191, '2017-12-20 14:11:09', NULL, NULL, 15406, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 14:11:09', 'admin-1513731387-15137502688857247', 1, 1, 'SR', NULL, NULL, NULL),
(57192, '2017-12-20 15:25:20', NULL, NULL, 15410, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 15:25:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57193, '2017-12-20 15:01:04', NULL, NULL, 15408, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 15:01:04', 'admin-1513731387-15137532642476858', 1, 0, '', NULL, NULL, NULL),
(57194, '2017-12-20 10:33:40', NULL, NULL, 15396, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 10:33:40', 'admin-1513731387-15137372208384515', 1, 1, 'SR', NULL, NULL, NULL),
(57195, '2017-12-20 11:11:33', NULL, NULL, 15397, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1513731387', 'admin', '2017-12-20 11:11:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57196, '2017-12-20 11:16:09', NULL, NULL, 15397, 0, 336, '272', 'iced Yuzu', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 11:16:09', 'admin-1513731387-15137397693173410', 1, 0, '', NULL, NULL, NULL),
(57197, '2017-12-20 11:16:09', NULL, NULL, 15397, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 11:16:09', 'admin-1513731387-15137397693173410', 1, 1, 'SR', NULL, NULL, NULL),
(57198, '2017-12-20 14:11:09', NULL, NULL, 15406, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 14:11:09', 'admin-1513731387-15137502688857247', 1, 0, '', NULL, NULL, NULL),
(57199, '2017-12-20 14:11:09', NULL, NULL, 15406, 0, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 14:11:09', 'admin-1513731387-15137502688857247', 1, 1, 'SR', NULL, NULL, NULL),
(57200, '2017-12-20 13:27:40', NULL, NULL, 15404, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 13:27:40', 'admin-1513731387-15137476601642677', 1, 0, '', NULL, NULL, NULL),
(57201, '2017-12-20 13:27:28', NULL, NULL, 15404, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1513731387', 'admin', '2017-12-20 13:27:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57202, '2017-12-20 13:27:40', NULL, NULL, 15404, 0, 306, '242', 'AA Set - Chinese Rice Wine Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 13:27:40', 'admin-1513731387-15137476601642677', 1, 0, '', NULL, NULL, NULL),
(57203, '2017-12-20 13:27:40', NULL, NULL, 15404, 0, 317, '253', 'AA Set - Japanese Curry Rice', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 13:27:40', 'admin-1513731387-15137476601642677', 1, 0, '', NULL, NULL, NULL),
(57204, '2017-12-20 13:17:51', NULL, NULL, 15403, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 13:17:51', 'admin-1513731387-15137470716769352', 1, 0, '', NULL, NULL, NULL),
(57205, '2017-12-20 11:20:14', NULL, NULL, 15398, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 11:20:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57206, '2017-12-20 11:20:43', NULL, NULL, 15398, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 11:20:43', 'admin-1513731387-1513740043258652', 1, 0, '', NULL, NULL, NULL),
(57207, '2017-12-20 11:20:43', NULL, NULL, 15398, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 11:20:43', 'admin-1513731387-1513740043258652', 1, 0, '', NULL, NULL, NULL),
(57208, '2017-12-20 12:35:45', NULL, NULL, 15401, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 12:35:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57209, '2017-12-20 11:20:43', NULL, NULL, 15398, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 11:20:43', 'admin-1513731387-1513740043258652', 1, 1, 'SR', NULL, NULL, NULL),
(57210, '2017-12-20 12:22:09', NULL, NULL, 15400, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 12:22:09', 'admin-1513731387-15137437297697290', 1, 1, 'SR', NULL, NULL, NULL),
(57211, '2017-12-20 12:22:02', NULL, NULL, 15400, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1513731387', 'admin', '2017-12-20 12:22:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57212, '2017-12-20 12:22:09', NULL, NULL, 15400, 0, 308, '244', 'AA Set - Chinese Ginger Garlic chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 12:22:09', 'admin-1513731387-15137437297697290', 1, 0, '', NULL, NULL, NULL),
(57213, '2017-12-20 09:11:33', NULL, NULL, 15392, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 09:11:33', 'admin-1513731387-15137322936186873', 1, 0, '', NULL, NULL, NULL),
(57214, '2017-12-20 12:41:06', NULL, NULL, 15402, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1513731387', 'admin', '2017-12-20 12:41:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57215, '2017-12-20 12:41:40', NULL, NULL, 15399, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 12:41:40', 'admin-1513731387-15137449000412736', 1, 0, '', NULL, NULL, NULL),
(57216, '2017-12-20 12:13:42', NULL, NULL, 15399, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1513731387', 'admin', '2017-12-20 12:13:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57217, '2017-12-20 11:20:43', NULL, NULL, 15398, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 11:20:43', 'admin-1513731387-1513740043258652', 1, 0, '', NULL, NULL, NULL),
(57218, '2017-12-20 14:11:09', NULL, NULL, 15406, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 14:11:09', 'admin-1513731387-15137502688857247', 1, 1, 'SR', NULL, NULL, NULL),
(57219, '2017-12-20 10:19:15', NULL, NULL, 15396, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 10:19:15', 'admin-1513731387-1513736355670376', 1, 0, '', NULL, NULL, NULL),
(57220, '2017-12-20 11:20:43', NULL, NULL, 15398, 0, 75, '75', 'Meatless Aglio Olio ', 'for kids,no chili', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 11:20:43', 'admin-1513731387-1513740043258652', 1, 0, '', NULL, NULL, NULL),
(57221, '2017-12-20 13:14:11', NULL, NULL, 15403, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1513731387', 'admin', '2017-12-20 13:14:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57222, '2017-12-20 10:19:15', NULL, NULL, 15396, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 10:19:15', 'admin-1513731387-1513736355670376', 1, 1, 'SR', NULL, NULL, NULL),
(57223, '2017-12-20 10:19:15', NULL, NULL, 15396, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 10:19:15', 'admin-1513731387-1513736355670376', 1, 0, '', NULL, NULL, NULL),
(57224, '2017-12-20 09:11:33', NULL, NULL, 15392, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 09:11:33', 'admin-1513731387-15137322936186873', 1, 1, 'SR', NULL, NULL, NULL),
(57225, '2017-12-20 09:32:55', NULL, NULL, 15393, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1513731387', 'admin', '2017-12-20 09:32:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57226, '2017-12-20 09:06:20', NULL, NULL, 15391, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1513731387', 'admin', '2017-12-20 09:06:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57227, '2017-12-20 09:58:47', NULL, NULL, 15394, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 09:58:47', 'admin-1513731387-15137351270721047', 1, 1, 'SR', NULL, NULL, NULL),
(57228, '2017-12-20 10:08:49', NULL, NULL, 15395, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1513731387', 'admin', '2017-12-20 10:08:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57229, '2017-12-20 09:11:33', NULL, NULL, 15392, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 09:11:33', 'admin-1513731387-15137322936186873', 1, 0, '', NULL, NULL, NULL),
(57230, '2017-12-20 10:09:05', NULL, NULL, 15395, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 10:09:05', 'admin-1513731387-15137357451214273', 1, 0, '', NULL, NULL, NULL),
(57231, '2017-12-20 09:33:12', NULL, NULL, 15393, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 09:33:12', 'admin-1513731387-15137335925503345', 1, 0, '', NULL, NULL, NULL),
(57232, '2017-12-20 09:06:42', NULL, NULL, 15391, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 09:06:42', 'admin-1513731387-15137320026526367', 1, 0, '', NULL, NULL, NULL),
(57233, '2017-12-20 09:06:42', NULL, NULL, 15391, 0, 181, '116', 'Open Food ', 'scramble eggs', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 09:06:42', 'admin-1513731387-15137320026526367', 1, 0, '', NULL, NULL, NULL),
(57234, '2017-12-20 10:09:05', NULL, NULL, 15395, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 10:09:05', 'admin-1513731387-15137357451214273', 1, 0, '', NULL, NULL, NULL),
(57235, '2017-12-20 10:09:05', NULL, NULL, 15395, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 10:09:05', 'admin-1513731387-15137357451214273', 1, 0, '', NULL, NULL, NULL),
(57236, '2017-12-20 09:33:12', NULL, NULL, 15393, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 09:33:12', 'admin-1513731387-15137335925503345', 1, 0, '', NULL, NULL, NULL),
(57237, '2017-12-20 09:33:12', NULL, NULL, 15393, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 09:33:12', 'admin-1513731387-15137335925503345', 1, 1, 'SR', NULL, NULL, NULL),
(57238, '2017-12-20 09:33:12', NULL, NULL, 15393, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 09:33:12', 'admin-1513731387-15137335925503345', 1, 0, '', NULL, NULL, NULL),
(57239, '2017-12-20 09:11:13', NULL, NULL, 15392, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 09:11:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57240, '2017-12-20 09:11:33', NULL, NULL, 15392, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 09:11:33', 'admin-1513731387-15137322936186873', 1, 0, '', NULL, NULL, NULL),
(57241, '2017-12-20 09:11:33', NULL, NULL, 15392, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 09:11:33', 'admin-1513731387-15137322936186873', 1, 0, '', NULL, NULL, NULL),
(57242, '2017-12-20 09:06:42', NULL, NULL, 15391, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513731387', 'admin', '2017-12-20 09:06:42', 'admin-1513731387-15137320026526367', 1, 1, 'SR', NULL, NULL, NULL),
(57243, '2017-12-21 16:22:59', NULL, NULL, 15413, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513843309', 'admin', '2017-12-21 16:22:59', 'admin-1513843309-15138445792905972', 1, 1, 'SR', NULL, NULL, NULL),
(57244, '2017-12-21 17:33:01', NULL, NULL, 15414, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1513843309', 'admin', '2017-12-21 17:33:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57245, '2017-12-21 17:33:07', NULL, NULL, 15414, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513843309', 'admin', '2017-12-21 17:33:07', 'admin-1513843309-15138487871499275', 1, 1, 'SR', NULL, NULL, NULL),
(57246, '2017-12-21 11:10:18', NULL, NULL, 15412, 0, 181, '116', 'Open Food ', 'Farlim Christmas catering', 'Meals', 'Perfect Meals', 1, 1050.00, 1050.0000, 0.0000, 1050.00, 1, '27', 1, '1513843309', 'lois', '2017-12-21 11:10:18', 'lois-1513825690-15138258186499429', 1, 0, '', 1, NULL, NULL),
(57247, '2017-12-21 16:22:55', NULL, NULL, 15413, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1513843309', 'admin', '2017-12-21 16:22:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57248, '2017-12-22 13:35:09', NULL, NULL, 15434, 0, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 13:35:09', 'admin-1513903960-1513920909051311', 1, 1, 'SR', NULL, NULL, NULL),
(57249, '2017-12-22 12:34:42', NULL, NULL, 15431, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 12:34:42', 'admin-1513903960-15139172824123323', 1, 1, 'SR', NULL, NULL, NULL),
(57250, '2017-12-22 10:23:06', NULL, NULL, 15420, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:23:06', 'admin-1513903960-15139093868059444', 1, 0, '', NULL, NULL, NULL),
(57251, '2017-12-22 10:35:08', NULL, NULL, 15421, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:35:08', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(57252, '2017-12-22 10:35:51', NULL, NULL, 15421, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:35:51', 'admin-1513903960-15139101511483031', 1, 1, 'SR', NULL, NULL, '10.0'),
(57253, '2017-12-22 09:46:58', NULL, NULL, 15417, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 09:46:58', 'admin-1513903960-15139072185392385', 1, 1, 'SR', NULL, NULL, NULL),
(57254, '2017-12-22 15:09:44', NULL, NULL, 15436, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1513903960', 'admin', '2017-12-22 15:09:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57255, '2017-12-22 15:09:50', NULL, NULL, 15436, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 15:09:50', 'admin-1513903960-15139265900521416', 1, 0, '', NULL, NULL, NULL),
(57256, '2017-12-22 15:09:50', NULL, NULL, 15436, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 15:09:50', 'admin-1513903960-15139265900521416', 1, 1, 'SR', NULL, NULL, NULL),
(57257, '2017-12-22 13:16:43', NULL, NULL, 15433, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 13:16:43', 'admin-1513903960-1513919802853708', 1, 0, '', NULL, NULL, NULL),
(57258, '2017-12-22 13:34:52', NULL, NULL, 15434, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1513903960', 'admin', '2017-12-22 13:34:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57259, '2017-12-22 13:35:09', NULL, NULL, 15434, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 13:35:09', 'admin-1513903960-1513920909051311', 1, 0, '', NULL, NULL, NULL),
(57260, '2017-12-22 12:43:56', NULL, NULL, 15432, 0, 306, '242', 'AA Set - Chinese Rice Wine Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 12:43:56', 'admin-1513903960-1513917836621503', 1, 0, '', NULL, NULL, NULL),
(57261, '2017-12-22 13:35:09', NULL, NULL, 15434, 0, 328, '264', 'Basic Blueberries Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 13:35:09', 'admin-1513903960-1513920909051311', 1, 0, '', NULL, NULL, NULL),
(57262, '2017-12-22 15:18:19', NULL, NULL, 15437, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1513903960', 'admin', '2017-12-22 15:18:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57263, '2017-12-22 14:04:24', NULL, NULL, 15435, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1513903960', 'admin', '2017-12-22 14:04:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57264, '2017-12-22 14:07:08', NULL, NULL, 15435, 0, 307, '243', 'AA Set - Flaming Hot & spicy Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 14:07:08', 'admin-1513903960-15139228287503536', 1, 0, '', NULL, NULL, NULL),
(57265, '2017-12-22 11:45:34', NULL, NULL, 15426, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:45:34', 'admin-1513903960-1513914334568901', 1, 0, '', NULL, NULL, NULL),
(57266, '2017-12-22 11:50:25', NULL, NULL, 15427, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.09, 0.0000, 0.0000, 5.09, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:50:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57267, '2017-12-22 11:50:39', NULL, NULL, 15427, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:50:39', 'admin-1513903960-15139146391476112', 1, 0, '', NULL, NULL, NULL),
(57268, '2017-12-22 11:50:39', NULL, NULL, 15427, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:50:39', 'admin-1513903960-15139146391476112', 1, 0, '', NULL, NULL, NULL),
(57269, '2017-12-22 14:07:08', NULL, NULL, 15435, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 14:07:08', 'admin-1513903960-15139228287503536', 1, 0, '', NULL, NULL, NULL),
(57270, '2017-12-22 14:07:08', NULL, NULL, 15435, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 14:07:08', 'admin-1513903960-15139228287503536', 1, 1, 'SR', NULL, NULL, NULL),
(57271, '2017-12-22 14:09:19', NULL, NULL, 15435, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 14:09:19', 'admin-1513903960-15139229591552317', 1, 1, 'SR', NULL, NULL, NULL),
(57272, '2017-12-22 14:09:19', NULL, NULL, 15435, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 14:09:19', 'admin-1513903960-15139229591552317', 1, 1, 'SR', NULL, NULL, NULL),
(57273, '2017-12-22 11:45:27', NULL, NULL, 15426, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:45:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57274, '2017-12-22 14:07:08', NULL, NULL, 15435, 0, 306, '242', 'AA Set - Chinese Rice Wine Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 14:07:08', 'admin-1513903960-15139228287503536', 1, 0, '', NULL, NULL, NULL),
(57275, '2017-12-22 13:16:42', NULL, NULL, 15433, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 13:16:42', 'admin-1513903960-1513919802853708', 1, 0, '', NULL, NULL, NULL),
(57276, '2017-12-22 15:18:24', NULL, NULL, 15437, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 15:18:24', 'admin-1513903960-15139271040676327', 1, 1, 'SR', NULL, NULL, NULL),
(57277, '2017-12-22 15:21:22', NULL, NULL, 15436, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 15:21:22', 'admin-1513903960-1513927282047199', 1, 0, '', NULL, NULL, NULL),
(57278, '2017-12-22 10:10:46', NULL, NULL, 15418, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:10:46', 'admin-1513903960-15139086460502829', 1, 0, '', NULL, NULL, NULL),
(57279, '2017-12-22 10:10:46', NULL, NULL, 15418, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:10:46', 'admin-1513903960-15139086460502829', 1, 0, '', NULL, NULL, NULL),
(57280, '2017-12-22 09:20:43', NULL, NULL, 15416, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 09:20:43', 'admin-1513903960-15139056435633210', 1, 1, 'SR', NULL, NULL, NULL),
(57281, '2017-12-22 09:46:00', NULL, NULL, 15417, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1513903960', 'admin', '2017-12-22 09:46:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57282, '2017-12-22 09:46:58', NULL, NULL, 15417, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 09:46:58', 'admin-1513903960-15139072185392385', 1, 1, 'SR', NULL, NULL, NULL),
(57283, '2017-12-22 09:46:58', NULL, NULL, 15417, 0, 153, '87', 'Wake Me Up!', 'no chickpeas', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 09:46:58', 'admin-1513903960-15139072185392385', 1, 0, '', NULL, NULL, NULL),
(57284, '2017-12-22 09:46:58', NULL, NULL, 15417, 0, 153, '87', 'Wake Me Up!', 'no chickpeas', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 09:46:58', 'admin-1513903960-15139072185392385', 1, 0, '', NULL, NULL, NULL),
(57285, '2017-12-22 13:16:26', NULL, NULL, 15433, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1513903960', 'admin', '2017-12-22 13:16:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57286, '2017-12-22 13:16:42', NULL, NULL, 15433, 0, 306, '242', 'AA Set - Chinese Rice Wine Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 13:16:42', 'admin-1513903960-1513919802853708', 1, 0, '', NULL, NULL, NULL),
(57287, '2017-12-22 12:34:42', NULL, NULL, 15431, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 12:34:42', 'admin-1513903960-15139172824123323', 1, 1, 'SR', NULL, NULL, NULL),
(57288, '2017-12-22 16:22:23', NULL, NULL, 15438, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1513903960', 'admin', '2017-12-22 16:22:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57289, '2017-12-22 16:22:34', NULL, NULL, 15438, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 16:22:34', 'admin-1513903960-15139309545129034', 1, 0, '', NULL, NULL, NULL),
(57290, '2017-12-22 16:22:34', NULL, NULL, 15438, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 16:22:34', 'admin-1513903960-15139309545129034', 1, 0, '', NULL, NULL, NULL),
(57291, '2017-12-22 12:43:56', NULL, NULL, 15432, 0, 317, '253', 'AA Set - Japanese Curry Rice', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 12:43:56', 'admin-1513903960-1513917836621503', 1, 0, '', NULL, NULL, NULL),
(57292, '2017-12-22 12:43:56', NULL, NULL, 15432, 0, 307, '243', 'AA Set - Flaming Hot & spicy Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 12:43:56', 'admin-1513903960-1513917836621503', 1, 0, '', NULL, NULL, NULL),
(57293, '2017-12-22 15:10:54', NULL, NULL, 15436, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 15:10:54', 'admin-1513903960-15139266543435343', 1, 1, 'SR', NULL, NULL, NULL),
(57294, '2017-12-22 11:56:52', NULL, NULL, 15428, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:56:52', 'admin-1513903960-1513915012342405', 1, 1, 'SR', NULL, NULL, NULL),
(57295, '2017-12-22 12:22:40', NULL, NULL, 15429, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 12:22:40', 'admin-1513903960-15139165603734484', 1, 1, 'SR', NULL, NULL, '10.0'),
(57296, '2017-12-22 11:28:07', NULL, NULL, 15425, 0, 153, '87', 'Wake Me Up!', 'add potato', 'Meals', 'Morning Bites ', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:28:07', 'admin-1513903960-15139132874834692', 1, 0, '', NULL, NULL, NULL),
(57297, '2017-12-22 11:28:07', NULL, NULL, 15425, 0, 153, '87', 'Wake Me Up!', 'add potato', 'Meals', 'Morning Bites ', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:28:07', 'admin-1513903960-15139132874834692', 1, 0, '', NULL, NULL, NULL),
(57298, '2017-12-22 12:34:35', NULL, NULL, 15431, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1513903960', 'admin', '2017-12-22 12:34:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57299, '2017-12-22 12:43:50', NULL, NULL, 15432, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1513903960', 'admin', '2017-12-22 12:43:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57300, '2017-12-22 12:32:33', NULL, NULL, 15427, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1513903960', 'admin', '2017-12-22 12:32:33', 'admin-1513903960-15139171536831354', 1, 0, '', NULL, NULL, NULL),
(57301, '2017-12-22 12:27:29', NULL, NULL, 15430, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 12:27:29', 'admin-1513903960-15139168496748833', 1, 0, '', NULL, NULL, NULL),
(57302, '2017-12-22 12:22:40', NULL, NULL, 15429, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 12:22:40', 'admin-1513903960-15139165603734484', 1, 1, 'SR', NULL, NULL, '10.0'),
(57303, '2017-12-22 12:22:40', NULL, NULL, 15429, 0, 317, '253', 'AA Set - Japanese Curry Rice', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 12:22:40', 'admin-1513903960-15139165603734484', 1, 0, '', NULL, NULL, '10.0'),
(57304, '2017-12-22 10:39:32', NULL, NULL, 15422, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:39:32', 'admin-1513903960-15139103727254437', 1, 0, '', NULL, NULL, NULL),
(57305, '2017-12-22 10:39:32', NULL, NULL, 15422, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:39:32', 'admin-1513903960-15139103727254437', 1, 1, 'SR', NULL, NULL, NULL),
(57306, '2017-12-22 10:38:58', NULL, NULL, 15422, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.20, 0.0000, 0.0000, 11.20, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:38:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57307, '2017-12-22 10:39:32', NULL, NULL, 15422, 0, 153, '87', 'Wake Me Up!', ' add sosej,no bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:39:32', 'admin-1513903960-15139103727254437', 1, 0, '', NULL, NULL, NULL),
(57308, '2017-12-22 10:39:32', NULL, NULL, 15422, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:39:32', 'admin-1513903960-15139103727254437', 1, 0, '', NULL, NULL, NULL),
(57309, '2017-12-22 10:59:51', NULL, NULL, 15423, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:59:51', 'admin-1513903960-15139115911853271', 1, 0, '', NULL, NULL, NULL),
(57310, '2017-12-22 16:22:34', NULL, NULL, 15438, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 16:22:34', 'admin-1513903960-15139309545129034', 1, 1, 'SR', NULL, NULL, NULL),
(57311, '2017-12-22 12:22:26', NULL, NULL, 15429, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1513903960', 'admin', '2017-12-22 12:22:26', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(57312, '2017-12-22 12:22:40', NULL, NULL, 15429, 0, 317, '253', 'AA Set - Japanese Curry Rice', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 12:22:40', 'admin-1513903960-15139165603734484', 1, 0, '', NULL, NULL, '10.0'),
(57313, '2017-12-22 12:27:21', NULL, NULL, 15430, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1513903960', 'admin', '2017-12-22 12:27:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57314, '2017-12-22 11:45:34', NULL, NULL, 15426, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:45:34', 'admin-1513903960-1513914334568901', 1, 0, '', NULL, NULL, NULL),
(57315, '2017-12-22 11:08:35', NULL, NULL, 15424, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:08:35', 'admin-1513903960-15139121154038745', 1, 1, 'SR', NULL, NULL, NULL),
(57316, '2017-12-22 12:27:29', NULL, NULL, 15430, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 12:27:29', 'admin-1513903960-15139168496748833', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(57317, '2017-12-22 11:45:34', NULL, NULL, 15426, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:45:34', 'admin-1513903960-1513914334568901', 1, 0, '', NULL, NULL, NULL),
(57318, '2017-12-22 11:45:34', NULL, NULL, 15426, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:45:34', 'admin-1513903960-1513914334568901', 1, 0, '', NULL, NULL, NULL),
(57319, '2017-12-22 11:56:52', NULL, NULL, 15428, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:56:52', 'admin-1513903960-1513915012342405', 1, 1, 'SR', NULL, NULL, NULL),
(57320, '2017-12-22 10:59:51', NULL, NULL, 15423, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:59:51', 'admin-1513903960-15139115911853271', 1, 0, '', NULL, NULL, NULL),
(57321, '2017-12-22 13:35:09', NULL, NULL, 15434, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 13:35:09', 'admin-1513903960-1513920909051311', 1, 0, '', NULL, NULL, NULL),
(57322, '2017-12-22 11:56:52', NULL, NULL, 15428, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:56:52', 'admin-1513903960-1513915012342405', 1, 1, 'SR', NULL, NULL, NULL),
(57323, '2017-12-22 11:55:55', NULL, NULL, 15428, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:55:55', 'admin-1513903960-15139149556151648', 1, 0, '', NULL, NULL, NULL),
(57324, '2017-12-22 11:55:55', NULL, NULL, 15428, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:55:55', 'admin-1513903960-15139149556151648', 1, 1, 'SR', NULL, NULL, NULL),
(57325, '2017-12-22 11:50:39', NULL, NULL, 15427, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:50:39', 'admin-1513903960-15139146391476112', 1, 0, '', NULL, NULL, NULL),
(57326, '2017-12-22 11:56:52', NULL, NULL, 15428, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:56:52', 'admin-1513903960-1513915012342405', 1, 1, 'SR', NULL, NULL, NULL),
(57327, '2017-12-22 10:39:32', NULL, NULL, 15422, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:39:32', 'admin-1513903960-15139103727254437', 1, 0, '', NULL, NULL, NULL),
(57328, '2017-12-22 13:16:43', NULL, NULL, 15433, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 13:16:43', 'admin-1513903960-1513919802853708', 1, 1, 'SR', NULL, NULL, NULL),
(57329, '2017-12-22 11:08:35', NULL, NULL, 15424, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:08:35', 'admin-1513903960-15139121154038745', 1, 1, 'SR', NULL, NULL, NULL),
(57330, '2017-12-22 11:27:51', NULL, NULL, 15425, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:27:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57331, '2017-12-22 09:06:37', NULL, NULL, 15415, 0, 181, '116', 'Open Food ', 'junior BLT', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 09:06:37', 'admin-1513903960-15139047969605658', 1, 0, '', NULL, NULL, NULL),
(57332, '2017-12-22 11:08:35', NULL, NULL, 15424, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:08:35', 'admin-1513903960-15139121154038745', 1, 0, '', NULL, NULL, NULL),
(57333, '2017-12-22 10:59:51', NULL, NULL, 15423, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:59:51', 'admin-1513903960-15139115911853271', 1, 1, 'SR', NULL, NULL, NULL),
(57334, '2017-12-22 11:08:25', NULL, NULL, 15424, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:08:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57335, '2017-12-22 10:59:51', NULL, NULL, 15423, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:59:51', 'admin-1513903960-15139115911853271', 1, 1, 'SR', NULL, NULL, NULL),
(57336, '2017-12-22 10:39:32', NULL, NULL, 15422, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:39:32', 'admin-1513903960-15139103727254437', 1, 0, '', NULL, NULL, NULL),
(57337, '2017-12-22 11:55:42', NULL, NULL, 15428, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:55:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57338, '2017-12-22 10:58:48', NULL, NULL, 15423, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:58:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57339, '2017-12-22 11:08:35', NULL, NULL, 15424, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 11:08:35', 'admin-1513903960-15139121154038745', 1, 0, '', NULL, NULL, NULL),
(57340, '2017-12-22 10:39:32', NULL, NULL, 15422, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:39:32', 'admin-1513903960-15139103727254437', 1, 0, '', NULL, NULL, NULL),
(57341, '2017-12-22 10:39:32', NULL, NULL, 15422, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:39:32', 'admin-1513903960-15139103727254437', 1, 1, 'SR', NULL, NULL, NULL),
(57342, '2017-12-22 09:20:43', NULL, NULL, 15416, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 09:20:43', 'admin-1513903960-15139056435633210', 1, 1, 'SR', NULL, NULL, NULL),
(57343, '2017-12-22 09:19:28', NULL, NULL, 15416, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1513903960', 'admin', '2017-12-22 09:19:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57344, '2017-12-22 09:20:43', NULL, NULL, 15416, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 09:20:43', 'admin-1513903960-15139056435633210', 1, 0, '', NULL, NULL, NULL),
(57345, '2017-12-22 09:20:43', NULL, NULL, 15416, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 09:20:43', 'admin-1513903960-15139056435633210', 1, 0, '', NULL, NULL, NULL),
(57346, '2017-12-22 09:20:43', NULL, NULL, 15416, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 09:20:43', 'admin-1513903960-15139056435633210', 1, 1, 'SR', NULL, NULL, NULL),
(57347, '2017-12-22 10:35:51', NULL, NULL, 15421, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:35:51', 'admin-1513903960-15139101511483031', 1, 1, 'SR', NULL, NULL, '10.0'),
(57348, '2017-12-22 10:18:27', NULL, NULL, 15419, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:18:27', 'admin-1513903960-15139091068953799', 1, 1, 'SR', NULL, NULL, NULL),
(57349, '2017-12-22 10:22:59', NULL, NULL, 15420, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:22:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57350, '2017-12-22 10:23:06', NULL, NULL, 15420, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:23:06', 'admin-1513903960-15139093868059444', 1, 0, '', NULL, NULL, NULL),
(57351, '2017-12-22 10:18:21', NULL, NULL, 15419, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:18:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57352, '2017-12-22 10:18:27', NULL, NULL, 15419, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:18:27', 'admin-1513903960-15139091068953799', 1, 1, 'SR', NULL, NULL, NULL),
(57353, '2017-12-22 10:10:46', NULL, NULL, 15418, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:10:46', 'admin-1513903960-15139086460502829', 1, 1, 'SR', NULL, NULL, NULL),
(57354, '2017-12-22 10:10:35', NULL, NULL, 15418, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1513903960', 'admin', '2017-12-22 10:10:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57355, '2017-12-22 09:06:37', NULL, NULL, 15415, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 09:06:37', 'admin-1513903960-15139047969605658', 1, 1, 'SR', NULL, NULL, NULL),
(57356, '2017-12-22 09:20:43', NULL, NULL, 15416, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513903960', 'admin', '2017-12-22 09:20:43', 'admin-1513903960-15139056435633210', 1, 1, 'SR', NULL, NULL, NULL),
(57357, '2017-12-22 09:06:22', NULL, NULL, 15415, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1513903960', 'admin', '2017-12-22 09:06:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57358, '2017-12-23 10:57:46', NULL, NULL, 15448, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:57:46', 'admin-1513991686-15139978658604520', 1, 0, '', NULL, NULL, NULL),
(57359, '2017-12-23 10:57:46', NULL, NULL, 15448, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:57:46', 'admin-1513991686-15139978658604520', 1, 0, '', NULL, NULL, NULL),
(57360, '2017-12-23 13:29:48', NULL, NULL, 15453, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:29:48', 'admin-1513991686-15140069879841681', 1, 1, 'SR', NULL, NULL, '10.0'),
(57361, '2017-12-23 13:39:26', NULL, NULL, 15453, 0, 317, '253', 'AA Set - Japanese Curry Rice', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:39:26', 'admin-1513991686-15140075664973997', 1, 0, '', NULL, NULL, '10.0'),
(57362, '2017-12-23 13:26:53', NULL, NULL, 15462, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:26:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57363, '2017-12-23 12:10:49', NULL, NULL, 15453, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:10:49', 'admin-1513991686-15140022493066138', 1, 0, '', NULL, NULL, '10.0'),
(57364, '2017-12-23 12:10:49', NULL, NULL, 15453, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:10:49', 'admin-1513991686-15140022493066138', 1, 0, '', NULL, NULL, '10.0'),
(57365, '2017-12-23 12:10:49', NULL, NULL, 15453, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:10:49', 'admin-1513991686-15140022493066138', 1, 1, 'SR', NULL, NULL, '10.0'),
(57366, '2017-12-23 12:10:49', NULL, NULL, 15453, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:10:49', 'admin-1513991686-15140022493066138', 1, 1, 'SR', NULL, NULL, '10.0'),
(57367, '2017-12-23 13:07:28', NULL, NULL, 15459, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:07:28', 'admin-1513991686-1514005648554267', 1, 1, 'SR', NULL, NULL, NULL),
(57368, '2017-12-23 13:07:28', NULL, NULL, 15459, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:07:28', 'admin-1513991686-1514005648554267', 1, 1, 'SR', NULL, NULL, NULL),
(57369, '2017-12-23 13:07:19', NULL, NULL, 15459, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:07:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57370, '2017-12-23 15:08:59', NULL, NULL, 15464, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 15:08:59', 'admin-1513991686-15140129391728542', 1, 1, 'SR', NULL, NULL, NULL),
(57371, '2017-12-23 15:08:59', NULL, NULL, 15464, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 15:08:59', 'admin-1513991686-15140129391728542', 1, 1, 'SR', NULL, NULL, NULL),
(57372, '2017-12-23 15:28:18', NULL, NULL, 15465, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 15:28:18', 'admin-1513991686-15140140979734071', 1, 1, 'SR', 1, NULL, NULL),
(57373, '2017-12-23 15:59:59', NULL, NULL, 15466, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1513991686', 'admin', '2017-12-23 15:59:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57374, '2017-12-23 10:47:23', NULL, NULL, 15447, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 19.20, 0.0000, 0.0000, 19.20, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:47:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57375, '2017-12-23 10:48:27', NULL, NULL, 15447, 0, 154, '88', 'Daily Dose BLT', 'one BLT welldone sunny', 'Meals', 'Morning Bites ', 4, 16.00, 64.0000, 0.0000, 64.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:48:27', 'admin-1513991686-1513997307044326', 1, 0, '', NULL, NULL, NULL),
(57376, '2017-12-23 10:48:27', NULL, NULL, 15447, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:48:27', 'admin-1513991686-1513997307044326', 1, 0, '', NULL, NULL, NULL),
(57377, '2017-12-23 10:48:27', NULL, NULL, 15447, 0, 328, '264', 'Basic Blueberries Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:48:27', 'admin-1513991686-1513997307044326', 1, 0, '', NULL, NULL, NULL),
(57378, '2017-12-23 10:48:27', NULL, NULL, 15447, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:48:27', 'admin-1513991686-1513997307044326', 1, 0, '', NULL, NULL, NULL),
(57379, '2017-12-23 13:16:06', NULL, NULL, 15460, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:16:06', 'admin-1513991686-15140061661016417', 1, 1, 'SR', NULL, NULL, NULL),
(57380, '2017-12-23 12:55:50', NULL, NULL, 15456, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:55:50', 'admin-1513991686-15140049505812267', 1, 1, 'SR', NULL, NULL, NULL),
(57381, '2017-12-23 15:08:59', NULL, NULL, 15464, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 15:08:59', 'admin-1513991686-15140129391728542', 1, 1, 'SR', NULL, NULL, NULL),
(57382, '2017-12-23 12:10:49', NULL, NULL, 15453, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:10:49', 'admin-1513991686-15140022493066138', 1, 0, '', NULL, NULL, '10.0'),
(57383, '2017-12-23 16:00:04', NULL, NULL, 15466, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 16:00:04', 'admin-1513991686-15140160040938551', 1, 0, '', NULL, NULL, NULL),
(57384, '2017-12-23 12:55:02', NULL, NULL, 15458, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:55:02', 'admin-1513991686-15140049021897651', 1, 1, 'SR', NULL, NULL, NULL),
(57385, '2017-12-23 12:54:47', NULL, NULL, 15458, 0, 307, '243', 'AA Set - Flaming Hot & spicy Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:54:47', 'admin-1513991686-15140048873168461', 1, 0, '', NULL, NULL, NULL),
(57386, '2017-12-23 12:54:47', NULL, NULL, 15458, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:54:47', 'admin-1513991686-15140048873168461', 1, 0, '', NULL, NULL, NULL),
(57387, '2017-12-23 13:58:53', NULL, NULL, 15463, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:58:53', 'admin-1513991686-15140087330707738', 1, 1, 'SR', NULL, NULL, NULL),
(57388, '2017-12-23 13:58:53', NULL, NULL, 15463, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:58:53', 'admin-1513991686-15140087330707738', 1, 0, '', NULL, NULL, NULL),
(57389, '2017-12-23 12:41:43', NULL, NULL, 15457, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:41:43', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(57390, '2017-12-23 12:41:46', NULL, NULL, 15457, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:41:46', 'admin-1513991686-15140041060874154', 1, 1, 'SR', NULL, NULL, '10.0'),
(57391, '2017-12-23 12:42:19', NULL, NULL, 15457, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:42:19', 'admin-1513991686-15140041396658515', 1, 1, 'SR', NULL, NULL, '10.0'),
(57392, '2017-12-23 12:43:59', NULL, NULL, 15457, 0, 317, '253', 'AA Set - Japanese Curry Rice', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:43:59', 'admin-1513991686-1514004239014720', 1, 0, '', NULL, NULL, '10.0'),
(57393, '2017-12-23 12:43:59', NULL, NULL, 15457, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:43:59', 'admin-1513991686-1514004239014720', 1, 0, '', NULL, NULL, '10.0'),
(57394, '2017-12-23 10:03:27', NULL, NULL, 15442, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:03:27', 'admin-1513991686-15139946076777938', 1, 1, 'SR', NULL, NULL, NULL),
(57395, '2017-12-23 12:54:32', NULL, NULL, 15458, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:54:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57396, '2017-12-23 13:29:33', NULL, NULL, 15453, 0, 306, '242', 'AA Set - Chinese Rice Wine Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:29:33', 'admin-1513991686-15140069737018872', 1, 0, '', NULL, NULL, '10.0'),
(57397, '2017-12-23 13:29:48', NULL, NULL, 15453, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:29:48', 'admin-1513991686-15140069879841681', 1, 1, 'SR', NULL, NULL, '10.0'),
(57398, '2017-12-23 13:29:33', NULL, NULL, 15453, 0, 308, '244', 'AA Set - Chinese Ginger Garlic chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:29:33', 'admin-1513991686-15140069737018872', 1, 0, '', NULL, NULL, '10.0'),
(57399, '2017-12-23 13:29:33', NULL, NULL, 15453, 0, 306, '242', 'AA Set - Chinese Rice Wine Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:29:33', 'admin-1513991686-15140069737018872', 1, 0, '', NULL, NULL, '10.0'),
(57400, '2017-12-23 13:58:53', NULL, NULL, 15463, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:58:53', 'admin-1513991686-15140087330707738', 1, 0, '', NULL, NULL, NULL),
(57401, '2017-12-23 13:29:33', NULL, NULL, 15453, 0, 317, '253', 'AA Set - Japanese Curry Rice', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:29:33', 'admin-1513991686-15140069737018872', 1, 0, '', NULL, NULL, '10.0'),
(57402, '2017-12-23 13:27:44', NULL, NULL, 15462, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:27:44', 'admin-1513991686-1514006864790610', 1, 1, 'SR', NULL, NULL, NULL),
(57403, '2017-12-23 13:27:44', NULL, NULL, 15462, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:27:44', 'admin-1513991686-1514006864790610', 1, 1, 'SR', NULL, NULL, NULL),
(57404, '2017-12-23 13:27:04', NULL, NULL, 15462, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:27:04', 'admin-1513991686-15140068247562826', 1, 0, '', NULL, NULL, NULL),
(57405, '2017-12-23 13:21:41', NULL, NULL, 15458, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:21:41', 'admin-1513991686-15140065017253061', 1, 1, 'SR', NULL, NULL, NULL),
(57406, '2017-12-23 12:27:54', NULL, NULL, 15456, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:27:54', 'admin-1513991686-15140032740226450', 1, 0, '', NULL, NULL, NULL),
(57407, '2017-12-23 12:29:16', NULL, NULL, 15450, 0, 307, '243', 'AA Set - Flaming Hot & spicy Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:29:16', 'admin-1513991686-15140033559397854', 1, 0, '', NULL, NULL, '10.0'),
(57408, '2017-12-23 13:07:28', NULL, NULL, 15459, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:07:28', 'admin-1513991686-1514005648554267', 1, 1, 'SR', NULL, NULL, NULL),
(57409, '2017-12-23 13:21:41', NULL, NULL, 15458, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:21:41', 'admin-1513991686-15140065017253061', 1, 1, 'SR', NULL, NULL, NULL),
(57410, '2017-12-23 12:23:10', NULL, NULL, 15455, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:23:10', 'admin-1513991686-15140029903791790', 1, 0, '', NULL, NULL, NULL),
(57411, '2017-12-23 13:16:02', NULL, NULL, 15460, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:16:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57412, '2017-12-23 09:57:11', NULL, NULL, 15440, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 09:57:11', 'admin-1513991686-15139942309827184', 1, 1, 'SR', NULL, NULL, NULL),
(57413, '2017-12-23 10:19:22', NULL, NULL, 15443, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:19:22', 'admin-1513991686-15139955623215461', 1, 1, 'SR', NULL, NULL, NULL),
(57414, '2017-12-23 10:19:22', NULL, NULL, 15443, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:19:22', 'admin-1513991686-15139955623215461', 1, 1, 'SR', NULL, NULL, NULL),
(57415, '2017-12-23 10:32:25', NULL, NULL, 15444, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:32:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57416, '2017-12-23 10:32:32', NULL, NULL, 15444, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:32:32', 'admin-1513991686-15139963519729052', 1, 0, '', NULL, NULL, NULL),
(57417, '2017-12-23 10:32:32', NULL, NULL, 15444, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:32:32', 'admin-1513991686-15139963519729052', 1, 0, '', NULL, NULL, NULL),
(57418, '2017-12-23 12:05:23', NULL, NULL, 15452, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:05:23', 'admin-1513991686-15140019235979137', 1, 1, 'SR', NULL, NULL, NULL),
(57419, '2017-12-23 11:10:47', NULL, NULL, 15449, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 11:10:47', 'admin-1513991686-15139986469957987', 1, 1, 'SR', NULL, NULL, NULL),
(57420, '2017-12-23 11:45:12', NULL, NULL, 15451, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1513991686', 'admin', '2017-12-23 11:45:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57421, '2017-12-23 12:28:21', NULL, NULL, 15454, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:28:21', 'admin-1513991686-15140033016535976', 1, 0, '', NULL, NULL, NULL),
(57422, '2017-12-23 13:58:33', NULL, NULL, 15463, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:58:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57423, '2017-12-23 12:27:50', NULL, NULL, 15456, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:27:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57424, '2017-12-23 12:22:21', NULL, NULL, 15455, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:22:21', 'admin-1513991686-15140029417797338', 1, 0, '', NULL, NULL, NULL),
(57425, '2017-12-23 12:22:21', NULL, NULL, 15455, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:22:21', 'admin-1513991686-15140029417797338', 1, 0, '', NULL, NULL, NULL),
(57426, '2017-12-23 12:22:05', NULL, NULL, 15455, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:22:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57427, '2017-12-23 12:22:21', NULL, NULL, 15455, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:22:21', 'admin-1513991686-15140029417797338', 1, 0, '', NULL, NULL, NULL),
(57428, '2017-12-23 12:23:10', NULL, NULL, 15455, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:23:10', 'admin-1513991686-15140029903791790', 1, 1, 'SR', NULL, NULL, NULL),
(57429, '2017-12-23 10:57:55', NULL, NULL, 15448, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:57:55', 'admin-1513991686-15139978756738852', 1, 1, 'SR', NULL, NULL, NULL),
(57430, '2017-12-23 12:05:19', NULL, NULL, 15452, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:05:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57431, '2017-12-23 10:46:13', NULL, NULL, 15446, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:46:13', 'admin-1513991686-15139971736499263', 1, 1, 'SR', NULL, NULL, NULL),
(57432, '2017-12-23 10:46:13', NULL, NULL, 15446, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:46:13', 'admin-1513991686-15139971736499263', 1, 1, 'SR', NULL, NULL, NULL),
(57433, '2017-12-23 10:32:36', NULL, NULL, 15444, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:32:36', 'admin-1513991686-15139963567244065', 1, 1, 'SR', NULL, NULL, NULL),
(57434, '2017-12-23 12:17:41', NULL, NULL, 15454, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:17:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57435, '2017-12-23 12:10:49', NULL, NULL, 15453, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:10:49', 'admin-1513991686-15140022493066138', 1, 0, '', NULL, NULL, '10.0'),
(57436, '2017-12-23 15:08:53', NULL, NULL, 15464, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1513991686', 'admin', '2017-12-23 15:08:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57437, '2017-12-23 12:10:14', NULL, NULL, 15453, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 20.10, 0.0000, 0.0000, 20.10, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:10:14', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(57438, '2017-12-23 10:46:13', NULL, NULL, 15446, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:46:13', 'admin-1513991686-15139971736499263', 1, 1, 'SR', NULL, NULL, NULL),
(57439, '2017-12-23 10:46:13', NULL, NULL, 15446, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:46:13', 'admin-1513991686-15139971736499263', 1, 1, 'SR', NULL, NULL, NULL),
(57440, '2017-12-23 10:45:44', NULL, NULL, 15446, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:45:44', 'admin-1513991686-15139971438501938', 1, 0, '', NULL, NULL, NULL),
(57441, '2017-12-23 11:45:19', NULL, NULL, 15451, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 11:45:19', 'admin-1513991686-15140007196985649', 1, 1, 'SR', NULL, NULL, NULL),
(57442, '2017-12-23 11:45:19', NULL, NULL, 15451, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 11:45:19', 'admin-1513991686-15140007196985649', 1, 1, 'SR', NULL, NULL, NULL),
(57443, '2017-12-23 15:08:59', NULL, NULL, 15464, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 15:08:59', 'admin-1513991686-15140129391728542', 1, 1, 'SR', NULL, NULL, NULL),
(57444, '2017-12-23 12:55:02', NULL, NULL, 15458, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:55:02', 'admin-1513991686-15140049021897651', 1, 1, 'SR', NULL, NULL, NULL),
(57445, '2017-12-23 10:32:36', NULL, NULL, 15444, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:32:36', 'admin-1513991686-15139963567244065', 1, 1, 'SR', NULL, NULL, NULL),
(57446, '2017-12-23 10:33:35', NULL, NULL, 15445, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:33:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57447, '2017-12-23 11:45:19', NULL, NULL, 15451, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 11:45:19', 'admin-1513991686-15140007196985649', 1, 0, '', NULL, NULL, NULL),
(57448, '2017-12-23 12:55:50', NULL, NULL, 15456, 0, 322, '258', 'Yuzu Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:55:50', 'admin-1513991686-15140049505812267', 1, 0, '', NULL, NULL, NULL),
(57449, '2017-12-23 11:21:08', NULL, NULL, 15450, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 11:21:08', 'admin-1513991686-15139992680761511', 1, 1, 'SR', NULL, NULL, '10.0'),
(57450, '2017-12-23 11:21:04', NULL, NULL, 15450, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1513991686', 'admin', '2017-12-23 11:21:04', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(57451, '2017-12-23 11:10:47', NULL, NULL, 15449, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 11:10:47', 'admin-1513991686-15139986469957987', 1, 0, '', NULL, NULL, NULL),
(57452, '2017-12-23 10:57:55', NULL, NULL, 15448, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:57:55', 'admin-1513991686-15139978756738852', 1, 1, 'SR', NULL, NULL, NULL),
(57453, '2017-12-23 10:48:27', NULL, NULL, 15447, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:48:27', 'admin-1513991686-1513997307044326', 1, 1, 'SR', NULL, NULL, NULL),
(57454, '2017-12-23 10:48:27', NULL, NULL, 15447, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:48:27', 'admin-1513991686-1513997307044326', 1, 1, 'SR', NULL, NULL, NULL),
(57455, '2017-12-23 10:48:27', NULL, NULL, 15447, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:48:27', 'admin-1513991686-1513997307044326', 1, 0, '', NULL, NULL, NULL),
(57456, '2017-12-23 10:48:27', NULL, NULL, 15447, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:48:27', 'admin-1513991686-1513997307044326', 1, 1, 'SR', NULL, NULL, NULL),
(57457, '2017-12-23 13:16:18', NULL, NULL, 15461, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 13:16:18', 'admin-1513991686-1514006178814117', 1, 1, 'SR', 1, NULL, '10.0'),
(57458, '2017-12-23 10:57:37', NULL, NULL, 15448, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:57:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57459, '2017-12-23 10:48:27', NULL, NULL, 15447, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:48:27', 'admin-1513991686-1513997307044326', 1, 1, 'SR', NULL, NULL, NULL),
(57460, '2017-12-23 10:48:27', NULL, NULL, 15447, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:48:27', 'admin-1513991686-1513997307044326', 1, 1, 'SR', NULL, NULL, NULL),
(57461, '2017-12-23 10:48:27', NULL, NULL, 15447, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:48:27', 'admin-1513991686-1513997307044326', 1, 1, 'SR', NULL, NULL, NULL),
(57462, '2017-12-23 10:48:27', NULL, NULL, 15447, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:48:27', 'admin-1513991686-1513997307044326', 1, 1, 'SR', NULL, NULL, NULL),
(57463, '2017-12-23 12:17:49', NULL, NULL, 15454, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:17:49', 'admin-1513991686-15140026690498373', 1, 1, 'SR', NULL, NULL, NULL),
(57464, '2017-12-23 11:10:37', NULL, NULL, 15449, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1513991686', 'admin', '2017-12-23 11:10:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57465, '2017-12-23 10:46:13', NULL, NULL, 15446, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:46:13', 'admin-1513991686-15139971736499263', 1, 1, 'SR', NULL, NULL, NULL),
(57466, '2017-12-23 10:03:21', NULL, NULL, 15442, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:03:21', 'admin-1513991686-15139946010887154', 1, 0, '', NULL, NULL, NULL),
(57467, '2017-12-23 09:35:40', NULL, NULL, 15439, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 09:35:40', 'admin-1513991686-1513992940543295', 1, 0, '', NULL, NULL, NULL),
(57468, '2017-12-23 12:32:58', NULL, NULL, 15452, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:32:58', 'admin-1513991686-15140035783613748', 1, 1, 'SR', NULL, NULL, NULL),
(57469, '2017-12-23 10:33:54', NULL, NULL, 15445, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:33:54', 'admin-1513991686-15139964340557965', 1, 1, 'SR', NULL, NULL, NULL),
(57470, '2017-12-23 10:45:44', NULL, NULL, 15446, 0, 328, '264', 'Basic Blueberries Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:45:44', 'admin-1513991686-15139971438501938', 1, 0, '', NULL, NULL, NULL),
(57471, '2017-12-23 10:46:13', NULL, NULL, 15446, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:46:13', 'admin-1513991686-15139971736499263', 1, 1, 'SR', NULL, NULL, NULL),
(57472, '2017-12-23 10:46:13', NULL, NULL, 15446, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:46:13', 'admin-1513991686-15139971736499263', 1, 1, 'SR', NULL, NULL, NULL),
(57473, '2017-12-23 10:57:46', NULL, NULL, 15448, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:57:46', 'admin-1513991686-15139978658604520', 1, 0, '', NULL, NULL, NULL),
(57474, '2017-12-23 10:45:44', NULL, NULL, 15446, 0, 154, '88', 'Daily Dose BLT', 'scramble egg', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:45:44', 'admin-1513991686-15139971438501938', 1, 0, '', NULL, NULL, NULL),
(57475, '2017-12-23 10:45:44', NULL, NULL, 15446, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:45:44', 'admin-1513991686-15139971438501938', 1, 0, '', NULL, NULL, NULL),
(57476, '2017-12-23 10:45:17', NULL, NULL, 15446, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.30, 0.0000, 0.0000, 14.30, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:45:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57477, '2017-12-23 10:35:41', NULL, NULL, 15440, 0, 331, '267', 'Yuzu Marmalade Pancake', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:35:41', 'admin-1513991686-15139965413942161', 1, 0, '', NULL, NULL, NULL),
(57478, '2017-12-23 10:33:43', NULL, NULL, 15445, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:33:43', 'admin-1513991686-1513996423235266', 1, 0, '', NULL, NULL, NULL),
(57479, '2017-12-23 10:33:54', NULL, NULL, 15445, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:33:54', 'admin-1513991686-15139964340557965', 1, 1, 'SR', NULL, NULL, NULL),
(57480, '2017-12-23 10:33:43', NULL, NULL, 15445, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:33:43', 'admin-1513991686-1513996423235266', 1, 0, '', NULL, NULL, NULL),
(57481, '2017-12-23 09:35:54', NULL, NULL, 15439, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 09:35:54', 'admin-1513991686-15139929542715838', 1, 0, '', NULL, NULL, NULL),
(57482, '2017-12-23 10:12:23', NULL, NULL, 15440, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:12:23', 'admin-1513991686-1513995143633878', 1, 0, '', NULL, NULL, NULL),
(57483, '2017-12-23 10:12:23', NULL, NULL, 15440, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:12:23', 'admin-1513991686-1513995143633878', 1, 1, 'SR', NULL, NULL, NULL),
(57484, '2017-12-23 10:19:18', NULL, NULL, 15443, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:19:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57485, '2017-12-23 10:03:27', NULL, NULL, 15442, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:03:27', 'admin-1513991686-15139946076777938', 1, 0, '', NULL, NULL, NULL),
(57486, '2017-12-23 12:17:49', NULL, NULL, 15454, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 12:17:49', 'admin-1513991686-15140026690498373', 1, 1, 'SR', NULL, NULL, NULL),
(57487, '2017-12-23 10:02:16', NULL, NULL, 15441, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:02:16', 'admin-1513991686-15139945362961842', 1, 1, 'SR', NULL, NULL, NULL),
(57488, '2017-12-23 10:03:08', NULL, NULL, 15442, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:03:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57489, '2017-12-23 10:03:21', NULL, NULL, 15442, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:03:21', 'admin-1513991686-15139946010887154', 1, 0, '', NULL, NULL, NULL),
(57490, '2017-12-23 09:56:47', NULL, NULL, 15440, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1513991686', 'admin', '2017-12-23 09:56:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57491, '2017-12-23 09:35:32', NULL, NULL, 15439, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1513991686', 'admin', '2017-12-23 09:35:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57492, '2017-12-23 09:35:40', NULL, NULL, 15439, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 09:35:40', 'admin-1513991686-1513992940543295', 1, 0, '', NULL, NULL, NULL),
(57493, '2017-12-23 10:02:16', NULL, NULL, 15441, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:02:16', 'admin-1513991686-15139945362961842', 1, 0, '', NULL, NULL, NULL),
(57494, '2017-12-23 10:02:16', NULL, NULL, 15441, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:02:16', 'admin-1513991686-15139945362961842', 1, 0, '', NULL, NULL, NULL),
(57495, '2017-12-23 10:02:16', NULL, NULL, 15441, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:02:16', 'admin-1513991686-15139945362961842', 1, 0, '', NULL, NULL, NULL),
(57496, '2017-12-23 10:02:06', NULL, NULL, 15441, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1513991686', 'admin', '2017-12-23 10:02:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57497, '2017-12-23 09:57:03', NULL, NULL, 15440, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 09:57:03', 'admin-1513991686-1513994223274951', 1, 0, '', NULL, NULL, NULL),
(57498, '2017-12-23 09:57:11', NULL, NULL, 15440, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 09:57:11', 'admin-1513991686-15139942309827184', 1, 1, 'SR', NULL, NULL, NULL),
(57499, '2017-12-23 09:35:54', NULL, NULL, 15439, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1513991686', 'admin', '2017-12-23 09:35:54', 'admin-1513991686-15139929542715838', 1, 1, 'SR', NULL, NULL, NULL),
(57500, '2017-12-24 10:29:13', NULL, NULL, 15479, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.55, 0.0000, 0.0000, 7.55, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:29:13', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(57501, '2017-12-24 10:30:17', NULL, NULL, 15479, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:30:17', 'admin-1514076984-15140826174512048', 1, 1, 'SR', NULL, NULL, NULL),
(57502, '2017-12-24 11:36:34', NULL, NULL, 15487, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1514076984', 'admin', '2017-12-24 11:36:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57503, '2017-12-24 11:36:37', NULL, NULL, 15487, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 11:36:37', 'admin-1514076984-15140865974387718', 1, 1, 'SR', NULL, NULL, NULL),
(57504, '2017-12-24 11:36:37', NULL, NULL, 15487, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 11:36:37', 'admin-1514076984-15140865974387718', 1, 1, 'SR', NULL, NULL, NULL),
(57505, '2017-12-24 11:37:08', NULL, NULL, 15488, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1514076984', 'admin', '2017-12-24 11:37:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57506, '2017-12-24 12:13:45', NULL, NULL, 15491, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 12:13:45', 'admin-1514076984-15140888255489156', 1, 1, 'SR', NULL, NULL, NULL),
(57507, '2017-12-24 12:21:16', NULL, NULL, 15492, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 12:21:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57508, '2017-12-24 12:21:26', NULL, NULL, 15492, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 12:21:26', 'admin-1514076984-1514089286526855', 1, 0, '', NULL, NULL, NULL),
(57509, '2017-12-24 12:21:26', NULL, NULL, 15492, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 12:21:26', 'admin-1514076984-1514089286526855', 1, 1, 'SR', NULL, NULL, NULL),
(57510, '2017-12-24 14:55:55', NULL, NULL, 15498, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 14:55:55', 'admin-1514076984-15140985557909271', 1, 1, 'SR', NULL, NULL, NULL),
(57511, '2017-12-24 14:55:55', NULL, NULL, 15498, 0, 307, '243', 'AA Set - Flaming Hot & spicy Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 14:55:55', 'admin-1514076984-15140985557909271', 1, 0, '', NULL, NULL, NULL),
(57512, '2017-12-24 09:27:19', NULL, NULL, 15471, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:27:19', 'admin-1514076984-1514078839552632', 1, 0, '', NULL, NULL, NULL),
(57513, '2017-12-24 16:23:17', NULL, NULL, 15502, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 16:23:17', 'admin-1514076984-15141037973269081', 1, 0, '', NULL, NULL, NULL),
(57514, '2017-12-24 16:23:12', NULL, NULL, 15503, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 16:23:12', 'admin-1514076984-15141037919276852', 1, 1, 'SR', NULL, NULL, NULL),
(57515, '2017-12-24 15:31:27', NULL, NULL, 15501, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 15:31:27', 'admin-1514076984-1514100687396584', 1, 1, 'SR', NULL, NULL, NULL),
(57516, '2017-12-24 15:31:27', NULL, NULL, 15501, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 15:31:27', 'admin-1514076984-1514100687396584', 1, 1, 'SR', NULL, NULL, NULL),
(57517, '2017-12-24 11:37:16', NULL, NULL, 15488, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 11:37:16', 'admin-1514076984-15140866365375446', 1, 0, '', NULL, NULL, NULL),
(57518, '2017-12-24 16:23:00', NULL, NULL, 15503, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1514076984', 'admin', '2017-12-24 16:23:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57519, '2017-12-24 16:19:28', NULL, NULL, 15502, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1514076984', 'admin', '2017-12-24 16:19:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57520, '2017-12-24 16:19:32', NULL, NULL, 15502, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 16:19:32', 'admin-1514076984-15141035719171189', 1, 1, 'SR', NULL, NULL, NULL),
(57521, '2017-12-24 11:06:11', NULL, NULL, 15483, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 11:06:11', 'admin-1514076984-1514084771826960', 1, 1, 'SR', NULL, NULL, NULL),
(57522, '2017-12-24 11:31:59', NULL, NULL, 15486, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 11:31:59', 'admin-1514076984-15140863195591379', 1, 1, 'SR', NULL, NULL, NULL),
(57523, '2017-12-24 14:36:01', NULL, NULL, 15498, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 14:36:01', 'admin-1514076984-15140973608403333', 1, 1, 'SR', NULL, NULL, NULL),
(57524, '2017-12-24 14:36:01', NULL, NULL, 15498, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 14:36:01', 'admin-1514076984-15140973608403333', 1, 0, '', NULL, NULL, NULL),
(57525, '2017-12-24 14:36:01', NULL, NULL, 15498, 0, 337, '273', 'Hot yuzu', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 14:36:01', 'admin-1514076984-15140973608403333', 1, 0, '', NULL, NULL, NULL),
(57526, '2017-12-24 14:36:00', NULL, NULL, 15498, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 14:36:00', 'admin-1514076984-15140973608403333', 1, 1, 'SR', NULL, NULL, NULL),
(57527, '2017-12-24 12:55:40', NULL, NULL, 15493, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 12:55:40', 'admin-1514076984-15140913398706535', 1, 0, '', NULL, NULL, NULL),
(57528, '2017-12-24 14:36:00', NULL, NULL, 15498, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 14:36:00', 'admin-1514076984-15140973608403333', 1, 0, '', NULL, NULL, NULL),
(57529, '2017-12-24 10:54:44', NULL, NULL, 15482, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:54:44', 'admin-1514076984-15140840842922669', 1, 1, 'SR', NULL, NULL, NULL),
(57530, '2017-12-24 15:16:19', NULL, NULL, 15499, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 15:16:19', 'admin-1514076984-15140997789384781', 1, 0, '', NULL, NULL, NULL),
(57531, '2017-12-24 15:16:23', NULL, NULL, 15500, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1514076984', 'admin', '2017-12-24 15:16:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57532, '2017-12-24 14:35:27', NULL, NULL, 15498, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 14:35:27', 'admin-1514076984-1514097327628459', 1, 0, '', NULL, NULL, NULL),
(57533, '2017-12-24 15:31:22', NULL, NULL, 15501, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 15:31:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57534, '2017-12-24 15:16:34', NULL, NULL, 15500, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 15:16:34', 'admin-1514076984-15140997947824290', 1, 0, '', NULL, NULL, NULL),
(57535, '2017-12-24 15:16:34', NULL, NULL, 15500, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 15:16:34', 'admin-1514076984-15140997947824290', 1, 0, '', NULL, NULL, NULL),
(57536, '2017-12-24 15:16:34', NULL, NULL, 15500, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 15:16:34', 'admin-1514076984-15140997947824290', 1, 0, '', NULL, NULL, NULL),
(57537, '2017-12-24 15:12:16', NULL, NULL, 15499, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 15:12:16', 'admin-1514076984-15140995358675159', 1, 1, 'SR', NULL, NULL, NULL),
(57538, '2017-12-24 14:35:27', NULL, NULL, 15498, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 14:35:27', 'admin-1514076984-1514097327628459', 1, 0, '', NULL, NULL, NULL),
(57539, '2017-12-24 12:55:39', NULL, NULL, 15493, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 12:55:39', 'admin-1514076984-15140913398706535', 1, 0, '', NULL, NULL, NULL),
(57540, '2017-12-24 12:55:12', NULL, NULL, 15493, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.80, 0.0000, 0.0000, 16.80, 1, '27', 1, '1514076984', 'admin', '2017-12-24 12:55:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57541, '2017-12-24 15:12:16', NULL, NULL, 15499, 0, 307, '243', 'AA Set - Flaming Hot & spicy Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 15:12:16', 'admin-1514076984-15140995358675159', 1, 0, '', NULL, NULL, NULL),
(57542, '2017-12-24 15:11:54', NULL, NULL, 15499, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1514076984', 'admin', '2017-12-24 15:11:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57543, '2017-12-24 14:34:53', NULL, NULL, 15498, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.00, 0.0000, 0.0000, 14.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 14:34:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57544, '2017-12-24 14:35:27', NULL, NULL, 15498, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 14:35:27', 'admin-1514076984-1514097327628459', 1, 0, '', NULL, NULL, NULL),
(57545, '2017-12-24 11:06:03', NULL, NULL, 15483, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1514076984', 'admin', '2017-12-24 11:06:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57546, '2017-12-24 11:06:11', NULL, NULL, 15483, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 11:06:11', 'admin-1514076984-1514084771826960', 1, 0, '', NULL, NULL, NULL),
(57547, '2017-12-24 11:06:11', NULL, NULL, 15483, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 11:06:11', 'admin-1514076984-1514084771826960', 1, 0, '', NULL, NULL, NULL),
(57548, '2017-12-24 14:29:36', NULL, NULL, 15497, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 14:29:36', 'admin-1514076984-15140969764216865', 1, 0, '', NULL, NULL, NULL),
(57549, '2017-12-24 14:13:06', NULL, NULL, 15493, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 14:13:06', 'admin-1514076984-15140959862264926', 1, 0, '', NULL, NULL, NULL),
(57550, '2017-12-24 13:29:52', NULL, NULL, 15495, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 13:29:52', 'admin-1514076984-15140933920214482', 1, 0, '', NULL, NULL, NULL),
(57551, '2017-12-24 14:27:40', NULL, NULL, 15493, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 14:27:40', 'admin-1514076984-15140968605555821', 1, 0, '', NULL, NULL, NULL),
(57552, '2017-12-24 14:27:29', NULL, NULL, 15497, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 14:27:29', 'admin-1514076984-15140968495969947', 1, 0, '', NULL, NULL, NULL),
(57553, '2017-12-24 14:27:18', NULL, NULL, 15497, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 14:27:18', 'admin-1514076984-15140968386778791', 1, 0, '', NULL, NULL, NULL),
(57554, '2017-12-24 14:27:18', NULL, NULL, 15497, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 14:27:18', 'admin-1514076984-15140968386778791', 1, 0, '', NULL, NULL, NULL),
(57555, '2017-12-24 09:27:19', NULL, NULL, 15471, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:27:19', 'admin-1514076984-1514078839552632', 1, 1, 'SR', NULL, NULL, NULL),
(57556, '2017-12-24 09:27:19', NULL, NULL, 15471, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:27:19', 'admin-1514076984-1514078839552632', 1, 0, '', NULL, NULL, NULL),
(57557, '2017-12-24 14:27:08', NULL, NULL, 15497, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1514076984', 'admin', '2017-12-24 14:27:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57558, '2017-12-24 16:23:12', NULL, NULL, 15503, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 16:23:12', 'admin-1514076984-15141037919276852', 1, 0, '', NULL, NULL, NULL),
(57559, '2017-12-24 13:32:58', NULL, NULL, 15495, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 13:32:58', 'admin-1514076984-15140935785741026', 1, 1, 'SR', NULL, NULL, NULL),
(57560, '2017-12-24 14:08:29', NULL, NULL, 15496, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.39, 0.0000, 0.0000, 0.39, 1, '27', 1, '1514076984', 'admin', '2017-12-24 14:08:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57561, '2017-12-24 14:08:35', NULL, NULL, 15496, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1514076984', 'admin', '2017-12-24 14:08:35', 'admin-1514076984-15140957150204435', 1, 0, '', NULL, NULL, NULL),
(57562, '2017-12-24 13:26:22', NULL, NULL, 15495, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 13:26:22', 'admin-1514076984-1514093181918218', 1, 1, 'SR', NULL, NULL, NULL),
(57563, '2017-12-24 13:26:22', NULL, NULL, 15495, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 13:26:22', 'admin-1514076984-1514093181918218', 1, 0, '', NULL, NULL, NULL),
(57564, '2017-12-24 13:25:48', NULL, NULL, 15494, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 13:25:48', 'admin-1514076984-15140931484635220', 1, 1, 'SR', NULL, NULL, NULL),
(57565, '2017-12-24 13:26:11', NULL, NULL, 15495, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1514076984', 'admin', '2017-12-24 13:26:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57566, '2017-12-24 13:25:44', NULL, NULL, 15494, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1514076984', 'admin', '2017-12-24 13:25:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57567, '2017-12-24 12:56:23', NULL, NULL, 15493, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 12:56:23', 'admin-1514076984-15140913835294310', 1, 1, 'SR', NULL, NULL, NULL),
(57568, '2017-12-24 12:13:45', NULL, NULL, 15491, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 12:13:45', 'admin-1514076984-15140888255489156', 1, 0, '', NULL, NULL, NULL),
(57569, '2017-12-24 14:27:29', NULL, NULL, 15497, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 14:27:29', 'admin-1514076984-15140968495969947', 1, 1, 'SR', NULL, NULL, NULL),
(57570, '2017-12-24 12:56:23', NULL, NULL, 15493, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 12:56:23', 'admin-1514076984-15140913835294310', 1, 1, 'SR', NULL, NULL, NULL),
(57571, '2017-12-24 12:56:23', NULL, NULL, 15493, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 12:56:23', 'admin-1514076984-15140913835294310', 1, 1, 'SR', NULL, NULL, NULL),
(57572, '2017-12-24 10:30:17', NULL, NULL, 15479, 0, 76, '76', 'Meatless Pesto Pasta', 'Add 1 egg', 'Meals', 'Non-Rice', 1, 18.50, 18.5000, 0.0000, 18.50, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:30:17', 'admin-1514076984-15140826174512048', 1, 1, 'SR', NULL, NULL, NULL),
(57573, '2017-12-24 12:56:23', NULL, NULL, 15493, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 12:56:23', 'admin-1514076984-15140913835294310', 1, 1, 'SR', NULL, NULL, NULL),
(57574, '2017-12-24 09:10:26', NULL, NULL, 15468, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:10:26', 'admin-1514076984-15140778263896054', 1, 0, '', NULL, NULL, NULL),
(57575, '2017-12-24 09:10:36', NULL, NULL, 15467, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:10:36', 'admin-1514076984-15140778362553260', 1, 1, 'SR', NULL, NULL, NULL),
(57576, '2017-12-24 09:10:36', NULL, NULL, 15467, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:10:36', 'admin-1514076984-15140778362553260', 1, 0, '', NULL, NULL, NULL),
(57577, '2017-12-24 09:10:44', NULL, NULL, 15468, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:10:44', 'admin-1514076984-1514077844430870', 1, 1, 'SR', NULL, NULL, NULL),
(57578, '2017-12-24 09:10:44', NULL, NULL, 15468, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:10:44', 'admin-1514076984-1514077844430870', 1, 1, 'SR', NULL, NULL, NULL),
(57579, '2017-12-24 09:12:48', NULL, NULL, 15469, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:12:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57580, '2017-12-24 10:54:32', NULL, NULL, 15482, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:54:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57581, '2017-12-24 10:21:04', NULL, NULL, 15478, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:21:04', 'admin-1514076984-15140820641702741', 1, 1, 'SR', NULL, NULL, NULL),
(57582, '2017-12-24 10:21:04', NULL, NULL, 15478, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:21:04', 'admin-1514076984-15140820641702741', 1, 0, '', NULL, NULL, NULL),
(57583, '2017-12-24 09:58:42', NULL, NULL, 15475, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:58:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57584, '2017-12-24 12:55:40', NULL, NULL, 15493, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 12:55:40', 'admin-1514076984-15140913398706535', 1, 0, '', NULL, NULL, NULL),
(57585, '2017-12-24 12:13:35', NULL, NULL, 15491, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1514076984', 'admin', '2017-12-24 12:13:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57586, '2017-12-24 12:06:58', NULL, NULL, 15490, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1514076984', 'admin', '2017-12-24 12:06:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57587, '2017-12-24 12:07:55', NULL, NULL, 15490, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 12:07:55', 'admin-1514076984-15140884754217668', 1, 1, 'SR', NULL, NULL, NULL),
(57588, '2017-12-24 12:07:55', NULL, NULL, 15490, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 12:07:55', 'admin-1514076984-15140884754217668', 1, 0, '', NULL, NULL, NULL),
(57589, '2017-12-24 09:27:19', NULL, NULL, 15471, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:27:19', 'admin-1514076984-1514078839552632', 1, 1, 'SR', NULL, NULL, NULL),
(57590, '2017-12-24 10:54:44', NULL, NULL, 15482, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:54:44', 'admin-1514076984-15140840842922669', 1, 1, 'SR', NULL, NULL, NULL),
(57591, '2017-12-24 09:27:35', NULL, NULL, 15468, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:27:35', 'admin-1514076984-15140788557118752', 1, 1, 'SR', NULL, NULL, NULL),
(57592, '2017-12-24 10:06:05', NULL, NULL, 15476, 0, 182, '117', 'Open Drinks ', 'juice 4 types', 'Cold Drinks', 'Fresh Juice', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:06:05', 'admin-1514076984-1514081165348132', 1, 0, '', NULL, NULL, NULL),
(57593, '2017-12-24 11:31:48', NULL, NULL, 15486, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1514076984', 'admin', '2017-12-24 11:31:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57594, '2017-12-24 11:08:24', NULL, NULL, 15485, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 11:08:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57595, '2017-12-24 11:08:33', NULL, NULL, 15485, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 11:08:33', 'admin-1514076984-15140849132112324', 1, 0, '', NULL, NULL, NULL),
(57596, '2017-12-24 11:08:33', NULL, NULL, 15485, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 11:08:33', 'admin-1514076984-15140849132112324', 1, 1, 'SR', NULL, NULL, NULL),
(57597, '2017-12-24 11:56:35', NULL, NULL, 15487, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 11:56:35', 'admin-1514076984-15140877958038921', 1, 1, 'SR', NULL, NULL, NULL),
(57598, '2017-12-24 11:37:16', NULL, NULL, 15488, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 11:37:16', 'admin-1514076984-15140866365375446', 1, 0, '', NULL, NULL, NULL),
(57599, '2017-12-24 10:11:10', NULL, NULL, 15477, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:11:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57600, '2017-12-24 10:11:26', NULL, NULL, 15477, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:11:26', 'admin-1514076984-1514081485885492', 1, 0, '', NULL, NULL, NULL),
(57601, '2017-12-24 12:55:40', NULL, NULL, 15493, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 12:55:40', 'admin-1514076984-15140913398706535', 1, 0, '', NULL, NULL, NULL),
(57602, '2017-12-24 10:36:23', NULL, NULL, 15480, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:36:23', 'admin-1514076984-15140829837092187', 1, 1, 'SR', NULL, NULL, NULL),
(57603, '2017-12-24 10:36:23', NULL, NULL, 15480, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:36:23', 'admin-1514076984-15140829837092187', 1, 0, '', NULL, NULL, NULL),
(57604, '2017-12-24 10:53:37', NULL, NULL, 15481, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:53:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57605, '2017-12-24 10:53:45', NULL, NULL, 15481, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:53:45', 'admin-1514076984-15140840257252898', 1, 0, '', NULL, NULL, NULL),
(57606, '2017-12-24 10:53:45', NULL, NULL, 15481, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:53:45', 'admin-1514076984-15140840257252898', 1, 0, '', NULL, NULL, NULL),
(57607, '2017-12-24 11:31:59', NULL, NULL, 15486, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 11:31:59', 'admin-1514076984-15140863195591379', 1, 0, '', NULL, NULL, NULL),
(57608, '2017-12-24 11:06:11', NULL, NULL, 15483, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 11:06:11', 'admin-1514076984-1514084771826960', 1, 1, 'SR', NULL, NULL, NULL),
(57609, '2017-12-24 09:29:55', NULL, NULL, 15473, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:29:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57610, '2017-12-24 09:30:04', NULL, NULL, 15473, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:30:04', 'admin-1514076984-1514079004453957', 1, 0, '', NULL, NULL, NULL),
(57611, '2017-12-24 09:30:04', NULL, NULL, 15473, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:30:04', 'admin-1514076984-1514079004453957', 1, 0, '', NULL, NULL, NULL),
(57612, '2017-12-24 10:11:26', NULL, NULL, 15477, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:11:26', 'admin-1514076984-1514081485885492', 1, 0, '', NULL, NULL, NULL),
(57613, '2017-12-24 10:21:04', NULL, NULL, 15478, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:21:04', 'admin-1514076984-15140820641702741', 1, 1, 'SR', NULL, NULL, NULL),
(57614, '2017-12-24 10:36:23', NULL, NULL, 15480, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:36:23', 'admin-1514076984-15140829837092187', 1, 0, '', NULL, NULL, NULL),
(57615, '2017-12-24 10:36:23', NULL, NULL, 15480, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:36:23', 'admin-1514076984-15140829837092187', 1, 0, '', NULL, NULL, NULL),
(57616, '2017-12-24 10:35:59', NULL, NULL, 15480, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:35:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57617, '2017-12-24 10:30:17', NULL, NULL, 15479, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:30:17', 'admin-1514076984-15140826174512048', 1, 1, 'SR', NULL, NULL, NULL),
(57618, '2017-12-24 10:30:17', NULL, NULL, 15479, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:30:17', 'admin-1514076984-15140826174512048', 1, 1, 'SR', NULL, NULL, NULL),
(57619, '2017-12-24 10:30:17', NULL, NULL, 15479, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:30:17', 'admin-1514076984-15140826174512048', 1, 0, '', NULL, NULL, NULL),
(57620, '2017-12-24 10:54:44', NULL, NULL, 15482, 0, 304, '240', 'Banana is On Fire', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:54:44', 'admin-1514076984-15140840842922669', 1, 0, '', NULL, NULL, NULL),
(57621, '2017-12-24 09:16:08', NULL, NULL, 15468, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:16:08', 'admin-1514076984-15140781685318082', 1, 1, 'SR', NULL, NULL, NULL),
(57622, '2017-12-24 09:23:01', NULL, NULL, 15468, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:23:01', 'admin-1514076984-15140785815834555', 1, 0, '', NULL, NULL, NULL),
(57623, '2017-12-24 09:24:47', NULL, NULL, 15470, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.80, 0.0000, 0.0000, 11.80, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:24:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57624, '2017-12-24 10:53:45', NULL, NULL, 15481, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:53:45', 'admin-1514076984-15140840257252898', 1, 1, 'SR', NULL, NULL, NULL),
(57625, '2017-12-24 10:26:03', NULL, NULL, 15477, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:26:03', 'admin-1514076984-15140823634571945', 1, 1, 'SR', NULL, NULL, NULL),
(57626, '2017-12-24 10:21:04', NULL, NULL, 15478, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:21:04', 'admin-1514076984-15140820641702741', 1, 0, '', NULL, NULL, NULL),
(57627, '2017-12-24 10:21:04', NULL, NULL, 15478, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:21:04', 'admin-1514076984-15140820641702741', 1, 1, 'SR', NULL, NULL, NULL),
(57628, '2017-12-24 09:29:00', NULL, NULL, 15472, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:29:00', 'admin-1514076984-15140789404394197', 1, 0, '', NULL, NULL, NULL),
(57629, '2017-12-24 10:21:04', NULL, NULL, 15478, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:21:04', 'admin-1514076984-15140820641702741', 1, 1, 'SR', NULL, NULL, NULL),
(57630, '2017-12-24 10:21:04', NULL, NULL, 15478, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:21:04', 'admin-1514076984-15140820641702741', 1, 1, 'SR', NULL, NULL, NULL),
(57631, '2017-12-24 10:21:04', NULL, NULL, 15478, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:21:04', 'admin-1514076984-15140820641702741', 1, 0, '', NULL, NULL, NULL),
(57632, '2017-12-24 09:26:55', NULL, NULL, 15471, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:26:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57633, '2017-12-24 10:20:25', NULL, NULL, 15478, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:20:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57634, '2017-12-24 10:11:26', NULL, NULL, 15477, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:11:26', 'admin-1514076984-1514081485885492', 1, 0, '', NULL, NULL, NULL),
(57635, '2017-12-24 09:58:49', NULL, NULL, 15475, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:58:49', 'admin-1514076984-15140807293424265', 1, 0, '', NULL, NULL, NULL),
(57636, '2017-12-24 09:50:41', NULL, NULL, 15474, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:50:41', 'admin-1514076984-15140802411298536', 1, 1, 'SR', NULL, NULL, NULL),
(57637, '2017-12-24 10:05:43', NULL, NULL, 15476, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1514076984', 'admin', '2017-12-24 10:05:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57638, '2017-12-24 09:58:49', NULL, NULL, 15475, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:58:49', 'admin-1514076984-15140807293424265', 1, 0, '', NULL, NULL, NULL),
(57639, '2017-12-24 09:50:41', NULL, NULL, 15474, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:50:41', 'admin-1514076984-15140802411298536', 1, 0, '', NULL, NULL, NULL),
(57640, '2017-12-24 09:50:31', NULL, NULL, 15474, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:50:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57641, '2017-12-24 09:29:00', NULL, NULL, 15472, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:29:00', 'admin-1514076984-15140789404394197', 1, 0, '', NULL, NULL, NULL),
(57642, '2017-12-24 09:10:03', NULL, NULL, 15467, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:10:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57643, '2017-12-24 09:10:14', NULL, NULL, 15467, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:10:14', 'admin-1514076984-15140778148523713', 1, 0, '', NULL, NULL, NULL),
(57644, '2017-12-24 09:10:15', NULL, NULL, 15467, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:10:15', 'admin-1514076984-15140778148523713', 1, 0, '', NULL, NULL, NULL),
(57645, '2017-12-24 09:28:53', NULL, NULL, 15472, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:28:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57646, '2017-12-24 09:27:35', NULL, NULL, 15468, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:27:35', 'admin-1514076984-15140788557118752', 1, 0, '', NULL, NULL, NULL),
(57647, '2017-12-24 09:25:05', NULL, NULL, 15470, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:25:05', 'admin-1514076984-15140787049355832', 1, 1, 'SR', NULL, NULL, NULL),
(57648, '2017-12-24 09:25:05', NULL, NULL, 15470, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:25:05', 'admin-1514076984-15140787049355832', 1, 1, 'SR', NULL, NULL, NULL),
(57649, '2017-12-24 09:25:05', NULL, NULL, 15470, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:25:05', 'admin-1514076984-15140787049355832', 1, 1, 'SR', NULL, NULL, NULL),
(57650, '2017-12-24 09:25:05', NULL, NULL, 15470, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:25:05', 'admin-1514076984-15140787049355832', 1, 1, 'SR', NULL, NULL, NULL),
(57651, '2017-12-24 09:27:19', NULL, NULL, 15471, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:27:19', 'admin-1514076984-1514078839552632', 1, 0, '', NULL, NULL, NULL),
(57652, '2017-12-24 09:24:54', NULL, NULL, 15470, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:24:54', 'admin-1514076984-15140786941117228', 1, 0, '', NULL, NULL, NULL),
(57653, '2017-12-24 09:24:54', NULL, NULL, 15470, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:24:54', 'admin-1514076984-15140786941117228', 1, 0, '', NULL, NULL, NULL),
(57654, '2017-12-24 09:24:54', NULL, NULL, 15470, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:24:54', 'admin-1514076984-15140786941117228', 1, 0, '', NULL, NULL, NULL),
(57655, '2017-12-24 09:24:54', NULL, NULL, 15470, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:24:54', 'admin-1514076984-15140786941117228', 1, 0, '', NULL, NULL, NULL),
(57656, '2017-12-24 09:16:08', NULL, NULL, 15468, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:16:08', 'admin-1514076984-15140781685318082', 1, 0, '', NULL, NULL, NULL),
(57657, '2017-12-24 12:55:40', NULL, NULL, 15493, 0, 306, '242', 'AA Set - Chinese Rice Wine Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 12:55:40', 'admin-1514076984-15140913398706535', 1, 0, '', NULL, NULL, NULL),
(57658, '2017-12-24 09:50:41', NULL, NULL, 15474, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:50:41', 'admin-1514076984-15140802411298536', 1, 0, '', NULL, NULL, NULL),
(57659, '2017-12-24 09:12:52', NULL, NULL, 15469, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:12:52', 'admin-1514076984-15140779720232098', 1, 1, 'SR', NULL, NULL, NULL),
(57660, '2017-12-24 09:10:18', NULL, NULL, 15468, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.60, 0.0000, 0.0000, 13.60, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:10:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57661, '2017-12-24 09:10:26', NULL, NULL, 15468, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514076984', 'admin', '2017-12-24 09:10:26', 'admin-1514076984-15140778263896054', 1, 0, '', NULL, NULL, NULL),
(57662, '2017-12-25 16:04:53', NULL, NULL, 15558, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 16:04:53', 'admin-1514162528-15141890933975036', 1, 0, '', NULL, NULL, NULL),
(57663, '2017-12-25 16:04:53', NULL, NULL, 15558, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 16:04:53', 'admin-1514162528-15141890933975036', 1, 0, '', NULL, NULL, NULL),
(57664, '2017-12-25 16:04:53', NULL, NULL, 15558, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 16:04:53', 'admin-1514162528-15141890933975036', 1, 0, '', NULL, NULL, NULL),
(57665, '2017-12-25 16:04:34', NULL, NULL, 15558, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1514162528', 'admin', '2017-12-25 16:04:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57666, '2017-12-25 16:02:09', NULL, NULL, 15556, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 16:02:09', 'admin-1514162528-15141889291312031', 1, 0, '', NULL, '25.0', NULL),
(57667, '2017-12-25 14:35:42', NULL, NULL, 15553, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:35:42', 'admin-1514162528-1514183742165598', 1, 1, 'SR', NULL, NULL, NULL),
(57668, '2017-12-25 14:32:43', NULL, NULL, 15552, 0, 181, '116', 'Open Food ', 'fruits plate', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:32:43', 'admin-1514162528-15141835630147313', 1, 0, '', NULL, NULL, NULL),
(57669, '2017-12-25 14:33:13', NULL, NULL, 15549, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:33:13', 'admin-1514162528-1514183593189350', 1, 0, '', NULL, NULL, NULL),
(57670, '2017-12-25 14:35:25', NULL, NULL, 15553, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:35:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57671, '2017-12-25 14:00:25', NULL, NULL, 15549, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:00:25', 'admin-1514162528-15141816253254642', 1, 0, '', NULL, '25.0', NULL),
(57672, '2017-12-25 16:01:07', NULL, NULL, 15557, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1514162528', 'admin', '2017-12-25 16:01:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57673, '2017-12-25 16:01:42', NULL, NULL, 15557, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 16:01:42', 'admin-1514162528-15141889025984946', 1, 1, 'SR', NULL, NULL, NULL),
(57674, '2017-12-25 14:00:25', NULL, NULL, 15549, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:00:25', 'admin-1514162528-15141816253254642', 1, 0, '', NULL, NULL, NULL),
(57675, '2017-12-25 14:02:22', NULL, NULL, 15541, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:02:22', 'admin-1514162528-15141817420279072', 1, 1, 'SR', NULL, NULL, NULL),
(57676, '2017-12-25 13:47:41', NULL, NULL, 15548, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:47:41', 'admin-1514162528-15141808615022527', 1, 1, 'SR', NULL, NULL, NULL),
(57677, '2017-12-25 15:35:22', NULL, NULL, 15555, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Rice', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 15:35:22', 'admin-1514162528-15141873225449416', 1, 0, '', NULL, NULL, NULL),
(57678, '2017-12-25 14:07:10', NULL, NULL, 15547, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:07:10', 'admin-1514162528-15141820307878491', 1, 0, '', NULL, '25.0', NULL),
(57679, '2017-12-25 14:12:25', NULL, NULL, 15550, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:12:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57680, '2017-12-25 14:12:29', NULL, NULL, 15550, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:12:29', 'admin-1514162528-15141823495442466', 1, 0, '', NULL, NULL, NULL),
(57681, '2017-12-25 12:26:24', NULL, NULL, 15537, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:26:24', 'admin-1514162528-15141759842533082', 1, 0, '', NULL, NULL, NULL),
(57682, '2017-12-25 14:35:42', NULL, NULL, 15553, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:35:42', 'admin-1514162528-1514183742165598', 1, 0, '', NULL, NULL, NULL),
(57683, '2017-12-25 14:32:43', NULL, NULL, 15552, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:32:43', 'admin-1514162528-15141835630147313', 1, 0, '', NULL, NULL, NULL),
(57684, '2017-12-25 15:21:50', NULL, NULL, 15556, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 15:21:50', 'admin-1514162528-15141865106155370', 1, 1, 'SR', NULL, NULL, NULL),
(57685, '2017-12-25 15:21:50', NULL, NULL, 15556, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 15:21:50', 'admin-1514162528-15141865106155370', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(57686, '2017-12-25 10:28:06', NULL, NULL, 15517, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:28:06', 'admin-1514162528-1514168885985846', 1, 1, 'SR', NULL, NULL, NULL),
(57687, '2017-12-25 14:32:43', NULL, NULL, 15552, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:32:43', 'admin-1514162528-15141835630147313', 1, 1, 'SR', NULL, NULL, NULL),
(57688, '2017-12-25 14:32:43', NULL, NULL, 15552, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:32:43', 'admin-1514162528-15141835630147313', 1, 1, 'SR', NULL, NULL, NULL),
(57689, '2017-12-25 14:28:01', NULL, NULL, 15551, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:28:01', 'admin-1514162528-15141832816046568', 1, 1, 'SR', NULL, NULL, NULL),
(57690, '2017-12-25 15:12:54', NULL, NULL, 15555, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 15:12:54', 'admin-1514162528-1514185974023493', 1, 0, '', NULL, NULL, NULL),
(57691, '2017-12-25 15:21:25', NULL, NULL, 15556, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 15:21:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57692, '2017-12-25 14:47:09', NULL, NULL, 15554, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:47:09', 'admin-1514162528-15141844293465678', 1, 0, '', NULL, NULL, NULL),
(57693, '2017-12-25 14:47:09', NULL, NULL, 15554, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:47:09', 'admin-1514162528-15141844293465678', 1, 1, 'SR', NULL, NULL, NULL),
(57694, '2017-12-25 14:50:11', NULL, NULL, 15554, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:50:11', 'admin-1514162528-15141846112858425', 1, 0, '', NULL, NULL, NULL),
(57695, '2017-12-25 16:50:43', NULL, NULL, 15560, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1514162528', 'admin', '2017-12-25 16:50:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57696, '2017-12-25 16:51:15', NULL, NULL, 15560, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 16:51:15', 'admin-1514162528-15141918753719295', 1, 0, '', NULL, NULL, NULL),
(57697, '2017-12-25 16:51:15', NULL, NULL, 15560, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 16:51:15', 'admin-1514162528-15141918753719295', 1, 0, '', NULL, NULL, NULL),
(57698, '2017-12-25 16:51:15', NULL, NULL, 15560, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 16:51:15', 'admin-1514162528-15141918753719295', 1, 0, '', NULL, '25.0', NULL),
(57699, '2017-12-25 15:12:54', NULL, NULL, 15555, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 15:12:54', 'admin-1514162528-1514185974023493', 1, 0, '', NULL, NULL, NULL),
(57700, '2017-12-25 15:12:54', NULL, NULL, 15555, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 15:12:54', 'admin-1514162528-1514185974023493', 1, 0, '', NULL, '25.0', NULL),
(57701, '2017-12-25 10:21:19', NULL, NULL, 15514, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:21:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57702, '2017-12-25 10:22:21', NULL, NULL, 15515, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:22:21', 'admin-1514162528-15141685418116424', 1, 0, '', NULL, NULL, NULL),
(57703, '2017-12-25 10:22:21', NULL, NULL, 15515, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:22:21', 'admin-1514162528-15141685418116424', 1, 0, '', NULL, NULL, NULL),
(57704, '2017-12-25 10:22:21', NULL, NULL, 15515, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:22:21', 'admin-1514162528-15141685418116424', 1, 0, '', NULL, NULL, NULL),
(57705, '2017-12-25 14:31:53', NULL, NULL, 15552, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:31:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57706, '2017-12-25 14:35:42', NULL, NULL, 15553, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:35:42', 'admin-1514162528-1514183742165598', 1, 1, 'SR', NULL, NULL, NULL),
(57707, '2017-12-25 13:55:32', NULL, NULL, 15548, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:55:32', 'admin-1514162528-15141813327585477', 1, 0, '', NULL, NULL, NULL),
(57708, '2017-12-25 12:26:13', NULL, NULL, 15537, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:26:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57709, '2017-12-25 12:26:24', NULL, NULL, 15537, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:26:24', 'admin-1514162528-15141759842533082', 1, 0, '', NULL, NULL, NULL),
(57710, '2017-12-25 12:25:12', NULL, NULL, 15536, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:25:12', 'admin-1514162528-15141759127682811', 1, 1, 'SR', NULL, NULL, NULL),
(57711, '2017-12-25 12:25:12', NULL, NULL, 15536, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:25:12', 'admin-1514162528-15141759127682811', 1, 1, 'SR', NULL, NULL, NULL),
(57712, '2017-12-25 12:25:12', NULL, NULL, 15536, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:25:12', 'admin-1514162528-15141759127682811', 1, 1, 'SR', NULL, NULL, NULL),
(57713, '2017-12-25 14:27:47', NULL, NULL, 15551, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:27:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57714, '2017-12-25 12:25:12', NULL, NULL, 15536, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:25:12', 'admin-1514162528-15141759127682811', 1, 0, '', NULL, NULL, NULL),
(57715, '2017-12-25 11:32:43', NULL, NULL, 15527, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:32:43', 'admin-1514162528-15141727631838665', 1, 1, 'SR', NULL, NULL, NULL),
(57716, '2017-12-25 11:36:14', NULL, NULL, 15528, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:36:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57717, '2017-12-25 11:36:28', NULL, NULL, 15528, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:36:28', 'admin-1514162528-15141729880259265', 1, 0, '', NULL, NULL, NULL),
(57718, '2017-12-25 11:36:28', NULL, NULL, 15528, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:36:28', 'admin-1514162528-15141729880259265', 1, 0, '', NULL, NULL, NULL),
(57719, '2017-12-25 14:12:29', NULL, NULL, 15550, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:12:29', 'admin-1514162528-15141823495442466', 1, 0, '', NULL, NULL, NULL),
(57720, '2017-12-25 12:32:13', NULL, NULL, 15540, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:32:13', 'admin-1514162528-1514176333392651', 1, 0, '', NULL, NULL, NULL),
(57721, '2017-12-25 12:32:13', NULL, NULL, 15540, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:32:13', 'admin-1514162528-1514176333392651', 1, 1, 'SR', NULL, NULL, NULL),
(57722, '2017-12-25 12:25:12', NULL, NULL, 15536, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:25:12', 'admin-1514162528-15141759127682811', 1, 0, '', NULL, NULL, NULL),
(57723, '2017-12-25 12:18:28', NULL, NULL, 15535, 0, 271, '205', 'Take It Easy', 'hard boil egg', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:18:28', 'admin-1514162528-1514175508517507', 1, 0, '', NULL, NULL, NULL),
(57724, '2017-12-25 10:13:37', NULL, NULL, 15512, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:13:37', 'admin-1514162528-15141680175106678', 1, 0, '', NULL, NULL, NULL),
(57725, '2017-12-25 13:05:48', NULL, NULL, 15544, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:05:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57726, '2017-12-25 12:27:57', NULL, NULL, 15538, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:27:57', 'admin-1514162528-15141760775674866', 1, 0, '', 1, NULL, NULL),
(57727, '2017-12-25 12:24:45', NULL, NULL, 15536, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.00, 0.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:24:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57728, '2017-12-25 12:07:45', NULL, NULL, 15534, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:07:45', 'admin-1514162528-15141748649015595', 1, 1, 'SR', NULL, NULL, NULL),
(57729, '2017-12-25 11:39:55', NULL, NULL, 15530, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:39:55', 'admin-1514162528-1514173195736214', 1, 1, 'SR', NULL, NULL, NULL),
(57730, '2017-12-25 13:57:47', NULL, NULL, 15549, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:57:47', 'admin-1514162528-15141814669929026', 1, 0, '', NULL, NULL, NULL),
(57731, '2017-12-25 12:36:04', NULL, NULL, 15541, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:36:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57732, '2017-12-25 12:27:57', NULL, NULL, 15538, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:27:57', 'admin-1514162528-15141760775674866', 1, 0, '', 1, NULL, NULL),
(57733, '2017-12-25 12:27:57', NULL, NULL, 15538, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:27:57', 'admin-1514162528-15141760775674866', 1, 0, '', 1, NULL, NULL),
(57734, '2017-12-25 14:00:25', NULL, NULL, 15549, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:00:25', 'admin-1514162528-15141816253254642', 1, 1, 'SR', NULL, NULL, NULL),
(57735, '2017-12-25 10:57:09', NULL, NULL, 15521, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:57:09', 'admin-1514162528-15141706293695961', 1, 0, '', NULL, NULL, NULL),
(57736, '2017-12-25 16:04:53', NULL, NULL, 15558, 0, 276, '210', 'Penang Craft Beer', '', 'Cold Drinks', 'Soda & Beer', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 16:04:53', 'admin-1514162528-15141890933975036', 1, 0, '', NULL, NULL, NULL),
(57737, '2017-12-25 13:47:41', NULL, NULL, 15548, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:47:41', 'admin-1514162528-15141808615022527', 1, 1, 'SR', NULL, NULL, NULL),
(57738, '2017-12-25 12:18:28', NULL, NULL, 15535, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:18:28', 'admin-1514162528-1514175508517507', 1, 1, 'SR', NULL, NULL, NULL),
(57739, '2017-12-25 16:01:42', NULL, NULL, 15557, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 16:01:42', 'admin-1514162528-15141889025984946', 1, 1, 'SR', NULL, NULL, NULL),
(57740, '2017-12-25 12:18:28', NULL, NULL, 15535, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:18:28', 'admin-1514162528-1514175508517507', 1, 1, 'SR', NULL, NULL, NULL),
(57741, '2017-12-25 12:18:28', NULL, NULL, 15535, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:18:28', 'admin-1514162528-1514175508517507', 1, 0, '', NULL, NULL, NULL),
(57742, '2017-12-25 12:18:28', NULL, NULL, 15535, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:18:28', 'admin-1514162528-1514175508517507', 1, 1, 'SR', NULL, NULL, NULL),
(57743, '2017-12-25 12:26:24', NULL, NULL, 15537, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:26:24', 'admin-1514162528-15141759842533082', 1, 0, '', NULL, NULL, NULL),
(57744, '2017-12-25 10:49:07', NULL, NULL, 15520, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:49:07', 'admin-1514162528-1514170147066543', 1, 0, '', NULL, NULL, NULL),
(57745, '2017-12-25 10:49:07', NULL, NULL, 15520, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:49:07', 'admin-1514162528-1514170147066543', 1, 0, '', NULL, NULL, NULL),
(57746, '2017-12-25 10:49:07', NULL, NULL, 15520, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:49:07', 'admin-1514162528-1514170147066543', 1, 1, 'SR', NULL, NULL, NULL),
(57747, '2017-12-25 13:57:41', NULL, NULL, 15549, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:57:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57748, '2017-12-25 13:55:32', NULL, NULL, 15548, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:55:32', 'admin-1514162528-15141813327585477', 1, 1, 'SR', NULL, NULL, NULL),
(57749, '2017-12-25 12:17:47', NULL, NULL, 15535, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:17:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57750, '2017-12-25 12:18:28', NULL, NULL, 15535, 0, 153, '87', 'Wake Me Up!', 'sunny side up', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:18:28', 'admin-1514162528-1514175508517507', 1, 0, '', NULL, NULL, NULL),
(57751, '2017-12-25 12:07:45', NULL, NULL, 15534, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 7.50, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:07:45', 'admin-1514162528-15141748649015595', 1, 0, '', NULL, '25.0', NULL),
(57752, '2017-12-25 12:07:45', NULL, NULL, 15534, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:07:45', 'admin-1514162528-15141748649015595', 1, 1, 'SR', NULL, NULL, NULL),
(57753, '2017-12-25 15:21:50', NULL, NULL, 15556, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 15:21:50', 'admin-1514162528-15141865106155370', 1, 0, '', NULL, NULL, NULL),
(57754, '2017-12-25 13:22:17', NULL, NULL, 15547, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:22:17', 'admin-1514162528-15141793376609524', 1, 1, 'SR', NULL, NULL, NULL),
(57755, '2017-12-25 13:06:27', NULL, NULL, 15544, 0, 312, '248', 'AA Set - Salted Chicken w Garlic & Spring Onion', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:06:27', 'admin-1514162528-1514178387865576', 1, 0, '', NULL, NULL, NULL),
(57756, '2017-12-25 13:01:07', NULL, NULL, 15543, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:01:07', 'admin-1514162528-15141780675237495', 1, 0, '', NULL, NULL, NULL),
(57757, '2017-12-25 13:01:07', NULL, NULL, 15543, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:01:07', 'admin-1514162528-15141780675237495', 1, 1, 'SR', NULL, NULL, NULL),
(57758, '2017-12-25 13:22:17', NULL, NULL, 15547, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:22:17', 'admin-1514162528-15141793376609524', 1, 0, '', NULL, NULL, NULL),
(57759, '2017-12-25 13:24:06', NULL, NULL, 15536, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:24:06', 'admin-1514162528-15141794467074417', 1, 1, 'SR', NULL, NULL, NULL),
(57760, '2017-12-25 13:31:37', NULL, NULL, 15536, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:31:37', 'admin-1514162528-15141798976427457', 1, 0, '', NULL, '25.0', NULL),
(57761, '2017-12-25 10:56:49', NULL, NULL, 15521, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:56:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57762, '2017-12-25 11:55:02', NULL, NULL, 15529, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:55:02', 'admin-1514162528-1514174102770707', 1, 1, 'SR', NULL, NULL, NULL),
(57763, '2017-12-25 12:07:20', NULL, NULL, 15534, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.15, 0.0000, 0.0000, 4.15, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:07:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57764, '2017-12-25 13:22:17', NULL, NULL, 15547, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:22:17', 'admin-1514162528-15141793376609524', 1, 1, 'SR', NULL, NULL, NULL),
(57765, '2017-12-25 13:22:17', NULL, NULL, 15547, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:22:17', 'admin-1514162528-15141793376609524', 1, 1, 'SR', NULL, NULL, NULL),
(57766, '2017-12-25 11:51:12', NULL, NULL, 15533, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:51:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57767, '2017-12-25 11:51:29', NULL, NULL, 15533, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:51:29', 'admin-1514162528-15141738891598730', 1, 0, '', NULL, NULL, NULL),
(57768, '2017-12-25 10:27:20', NULL, NULL, 15511, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:27:20', 'admin-1514162528-15141688404757143', 1, 0, '', NULL, NULL, NULL),
(57769, '2017-12-25 13:47:41', NULL, NULL, 15548, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:47:41', 'admin-1514162528-15141808615022527', 1, 0, '', NULL, NULL, NULL),
(57770, '2017-12-25 13:22:17', NULL, NULL, 15547, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:22:17', 'admin-1514162528-15141793376609524', 1, 1, 'SR', NULL, NULL, NULL),
(57771, '2017-12-25 13:31:37', NULL, NULL, 15536, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:31:37', 'admin-1514162528-15141798976427457', 1, 0, '', NULL, '25.0', NULL),
(57772, '2017-12-25 13:00:57', NULL, NULL, 15543, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:00:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57773, '2017-12-25 13:13:25', NULL, NULL, 15545, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:13:25', 'admin-1514162528-15141788051369881', 1, 0, '', NULL, '25.0', NULL),
(57774, '2017-12-25 13:15:08', NULL, NULL, 15546, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:15:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57775, '2017-12-25 13:15:25', NULL, NULL, 15546, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:15:25', 'admin-1514162528-15141789258122299', 1, 0, '', NULL, NULL, NULL),
(57776, '2017-12-25 13:15:25', NULL, NULL, 15546, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:15:25', 'admin-1514162528-15141789258122299', 1, 0, '', NULL, NULL, NULL),
(57777, '2017-12-25 13:15:25', NULL, NULL, 15546, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:15:25', 'admin-1514162528-15141789258122299', 1, 1, 'SR', NULL, NULL, NULL),
(57778, '2017-12-25 13:22:17', NULL, NULL, 15547, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:22:17', 'admin-1514162528-15141793376609524', 1, 0, '', NULL, NULL, NULL),
(57779, '2017-12-25 13:22:17', NULL, NULL, 15547, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:22:17', 'admin-1514162528-15141793376609524', 1, 0, '', NULL, NULL, NULL),
(57780, '2017-12-25 13:21:31', NULL, NULL, 15547, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.60, 0.0000, 0.0000, 11.60, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:21:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57781, '2017-12-25 13:13:25', NULL, NULL, 15545, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:13:25', 'admin-1514162528-15141788051369881', 1, 1, 'SR', NULL, NULL, NULL),
(57782, '2017-12-25 14:46:55', NULL, NULL, 15554, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:46:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57783, '2017-12-25 13:13:25', NULL, NULL, 15545, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:13:25', 'admin-1514162528-15141788051369881', 1, 1, 'SR', NULL, NULL, NULL),
(57784, '2017-12-25 13:13:25', NULL, NULL, 15545, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:13:25', 'admin-1514162528-15141788051369881', 1, 0, '', NULL, NULL, NULL),
(57785, '2017-12-25 13:13:02', NULL, NULL, 15545, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:13:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57786, '2017-12-25 13:47:41', NULL, NULL, 15548, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:47:41', 'admin-1514162528-15141808615022527', 1, 1, 'SR', NULL, NULL, NULL),
(57787, '2017-12-25 11:51:29', NULL, NULL, 15533, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:51:29', 'admin-1514162528-15141738891598730', 1, 0, '', NULL, NULL, NULL),
(57788, '2017-12-25 10:42:44', NULL, NULL, 15519, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:42:44', 'admin-1514162528-15141697639978337', 1, 1, 'SR', NULL, NULL, NULL),
(57789, '2017-12-25 13:06:28', NULL, NULL, 15544, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:06:28', 'admin-1514162528-1514178387865576', 1, 0, '', NULL, '25.0', NULL),
(57790, '2017-12-25 13:06:28', NULL, NULL, 15544, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:06:28', 'admin-1514162528-1514178387865576', 1, 1, 'SR', NULL, NULL, NULL),
(57791, '2017-12-25 16:39:03', NULL, NULL, 15559, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1514162528', 'admin', '2017-12-25 16:39:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57792, '2017-12-25 13:06:27', NULL, NULL, 15544, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:06:28', 'admin-1514162528-1514178387865576', 1, 0, '', NULL, NULL, NULL),
(57793, '2017-12-25 13:06:28', NULL, NULL, 15544, 0, 222, '156', 'Seasoned Chicken Aglio Olio', 'no spicy', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:06:28', 'admin-1514162528-1514178387865576', 1, 0, '', NULL, NULL, NULL),
(57794, '2017-12-25 12:07:45', NULL, NULL, 15534, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:07:45', 'admin-1514162528-15141748649015595', 1, 0, '', NULL, NULL, NULL),
(57795, '2017-12-25 11:51:29', NULL, NULL, 15533, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:51:29', 'admin-1514162528-15141738891598730', 1, 1, 'SR', NULL, NULL, NULL),
(57796, '2017-12-25 11:45:32', NULL, NULL, 15532, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:45:32', 'admin-1514162528-15141735323206898', 1, 1, 'SR', NULL, NULL, NULL),
(57797, '2017-12-25 11:45:32', NULL, NULL, 15532, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:45:32', 'admin-1514162528-15141735323206898', 1, 1, 'SR', NULL, NULL, NULL),
(57798, '2017-12-25 11:45:05', NULL, NULL, 15532, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:45:05', 'admin-1514162528-1514173505530935', 1, 0, '', NULL, NULL, NULL),
(57799, '2017-12-25 11:45:05', NULL, NULL, 15532, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:45:05', 'admin-1514162528-1514173505530935', 1, 0, '', NULL, NULL, NULL),
(57800, '2017-12-25 11:45:32', NULL, NULL, 15532, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:45:32', 'admin-1514162528-15141735323206898', 1, 1, 'SR', NULL, NULL, NULL),
(57801, '2017-12-25 09:43:25', NULL, NULL, 15509, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:43:25', 'admin-1514162528-15141662056793762', 1, 0, '', NULL, NULL, '10.0'),
(57802, '2017-12-25 09:43:25', NULL, NULL, 15509, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:43:25', 'admin-1514162528-15141662056793762', 1, 0, '', NULL, NULL, '10.0'),
(57803, '2017-12-25 10:01:53', NULL, NULL, 15510, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:01:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57804, '2017-12-25 10:21:32', NULL, NULL, 15514, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:21:32', 'admin-1514162528-1514168492383309', 1, 0, '', NULL, NULL, NULL),
(57805, '2017-12-25 10:21:32', NULL, NULL, 15514, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:21:32', 'admin-1514162528-1514168492383309', 1, 0, '', NULL, NULL, NULL),
(57806, '2017-12-25 15:12:54', NULL, NULL, 15555, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 15:12:54', 'admin-1514162528-1514185974023493', 1, 1, 'SR', NULL, NULL, NULL),
(57807, '2017-12-25 16:39:21', NULL, NULL, 15559, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 16:39:21', 'admin-1514162528-15141911613662571', 1, 1, 'SR', NULL, NULL, NULL),
(57808, '2017-12-25 12:32:07', NULL, NULL, 15540, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:32:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57809, '2017-12-25 11:39:37', NULL, NULL, 15530, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.55, 0.0000, 0.0000, 5.55, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:39:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57810, '2017-12-25 11:23:13', NULL, NULL, 15526, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:23:13', 'admin-1514162528-15141721933284531', 1, 0, '', NULL, '25.0', NULL),
(57811, '2017-12-25 11:32:25', NULL, NULL, 15527, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:32:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57812, '2017-12-25 11:32:43', NULL, NULL, 15527, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:32:43', 'admin-1514162528-15141727631838665', 1, 0, '', NULL, NULL, NULL),
(57813, '2017-12-25 11:32:43', NULL, NULL, 15527, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:32:43', 'admin-1514162528-15141727631838665', 1, 0, '', NULL, NULL, NULL),
(57814, '2017-12-25 11:44:43', NULL, NULL, 15532, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.80, 0.0000, 0.0000, 13.80, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:44:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57815, '2017-12-25 14:28:01', NULL, NULL, 15551, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:28:01', 'admin-1514162528-15141832816046568', 1, 1, 'SR', NULL, NULL, NULL),
(57816, '2017-12-25 12:21:48', NULL, NULL, 15530, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:21:48', 'admin-1514162528-15141757086174572', 1, 1, 'SR', NULL, NULL, NULL),
(57817, '2017-12-25 11:45:32', NULL, NULL, 15532, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:45:32', 'admin-1514162528-15141735323206898', 1, 1, 'SR', NULL, NULL, NULL),
(57818, '2017-12-25 16:39:21', NULL, NULL, 15559, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 16:39:21', 'admin-1514162528-15141911613662571', 1, 0, '', NULL, NULL, NULL),
(57819, '2017-12-25 15:12:41', NULL, NULL, 15555, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1514162528', 'admin', '2017-12-25 15:12:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57820, '2017-12-25 11:45:05', NULL, NULL, 15532, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:45:05', 'admin-1514162528-1514173505530935', 1, 0, '', NULL, NULL, NULL),
(57821, '2017-12-25 11:41:30', NULL, NULL, 15531, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:41:30', 'admin-1514162528-15141732905097744', 1, 0, '', 1, NULL, NULL),
(57822, '2017-12-25 13:06:28', NULL, NULL, 15544, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:06:28', 'admin-1514162528-1514178387865576', 1, 1, 'SR', NULL, NULL, NULL),
(57823, '2017-12-25 13:55:32', NULL, NULL, 15548, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:55:32', 'admin-1514162528-15141813327585477', 1, 0, '', NULL, NULL, NULL),
(57824, '2017-12-25 11:39:55', NULL, NULL, 15530, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 7.50, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:39:55', 'admin-1514162528-1514173195736214', 1, 0, '', NULL, '25.0', NULL),
(57825, '2017-12-25 11:45:05', NULL, NULL, 15532, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:45:05', 'admin-1514162528-1514173505530935', 1, 0, '', NULL, NULL, NULL),
(57826, '2017-12-25 10:48:53', NULL, NULL, 15520, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:48:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57827, '2017-12-25 11:45:05', NULL, NULL, 15532, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:45:05', 'admin-1514162528-1514173505530935', 1, 0, '', NULL, NULL, NULL),
(57828, '2017-12-25 11:39:29', NULL, NULL, 15529, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:39:29', 'admin-1514162528-15141731692929015', 1, 1, 'SR', NULL, NULL, NULL),
(57829, '2017-12-25 12:30:21', NULL, NULL, 15539, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:30:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57830, '2017-12-25 11:39:29', NULL, NULL, 15529, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:39:29', 'admin-1514162528-15141731692929015', 1, 1, 'SR', NULL, NULL, NULL),
(57831, '2017-12-25 11:39:29', NULL, NULL, 15529, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:39:29', 'admin-1514162528-15141731692929015', 1, 1, 'SR', NULL, NULL, NULL),
(57832, '2017-12-25 11:39:13', NULL, NULL, 15529, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:39:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57833, '2017-12-25 11:39:29', NULL, NULL, 15529, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:39:29', 'admin-1514162528-15141731692929015', 1, 1, 'SR', NULL, NULL, NULL),
(57834, '2017-12-25 14:07:10', NULL, NULL, 15547, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:07:10', 'admin-1514162528-15141820307878491', 1, 0, '', NULL, '25.0', NULL),
(57835, '2017-12-25 11:39:29', NULL, NULL, 15529, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:39:29', 'admin-1514162528-15141731692929015', 1, 1, 'SR', NULL, NULL, NULL),
(57836, '2017-12-25 11:37:27', NULL, NULL, 15525, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:37:27', 'admin-1514162528-15141730473373338', 1, 0, '', NULL, NULL, NULL),
(57837, '2017-12-25 11:36:28', NULL, NULL, 15528, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:36:28', 'admin-1514162528-15141729880259265', 1, 1, 'SR', NULL, NULL, NULL),
(57838, '2017-12-25 12:36:21', NULL, NULL, 15541, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:36:21', 'admin-1514162528-151417658115521', 1, 1, 'SR', NULL, NULL, NULL),
(57839, '2017-12-25 12:36:39', NULL, NULL, 15542, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:36:39', 'admin-1514162528-15141765997065549', 1, 1, 'SR', 1, NULL, NULL),
(57840, '2017-12-25 12:26:24', NULL, NULL, 15537, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:26:24', 'admin-1514162528-15141759842533082', 1, 0, '', NULL, NULL, NULL),
(57841, '2017-12-25 11:32:43', NULL, NULL, 15527, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:32:43', 'admin-1514162528-15141727631838665', 1, 0, '', NULL, NULL, NULL),
(57842, '2017-12-25 11:23:13', NULL, NULL, 15526, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:23:13', 'admin-1514162528-15141721933284531', 1, 1, 'SR', NULL, NULL, NULL),
(57843, '2017-12-25 13:47:41', NULL, NULL, 15548, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:47:41', 'admin-1514162528-15141808615022527', 1, 0, '', NULL, NULL, NULL),
(57844, '2017-12-25 12:25:12', NULL, NULL, 15536, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:25:12', 'admin-1514162528-15141759127682811', 1, 1, 'SR', NULL, NULL, NULL),
(57845, '2017-12-25 11:23:13', NULL, NULL, 15526, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:23:13', 'admin-1514162528-15141721933284531', 1, 1, 'SR', NULL, NULL, NULL),
(57846, '2017-12-25 11:22:59', NULL, NULL, 15526, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:22:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57847, '2017-12-25 11:17:40', NULL, NULL, 15525, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:17:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57848, '2017-12-25 09:12:52', NULL, NULL, 15505, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:12:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57849, '2017-12-25 09:13:14', NULL, NULL, 15505, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:13:14', 'admin-1514162528-15141643944983445', 1, 0, '', NULL, NULL, NULL),
(57850, '2017-12-25 09:13:14', NULL, NULL, 15505, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:13:14', 'admin-1514162528-15141643944983445', 1, 0, '', NULL, NULL, NULL),
(57851, '2017-12-25 09:13:14', NULL, NULL, 15505, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:13:14', 'admin-1514162528-15141643944983445', 1, 1, 'SR', NULL, NULL, NULL),
(57852, '2017-12-25 09:13:14', NULL, NULL, 15505, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:13:14', 'admin-1514162528-15141643944983445', 1, 0, '', NULL, NULL, NULL),
(57853, '2017-12-25 09:18:00', NULL, NULL, 15506, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:18:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57854, '2017-12-25 09:18:12', NULL, NULL, 15506, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:18:12', 'admin-1514162528-1514164692121874', 1, 0, '', NULL, NULL, NULL),
(57855, '2017-12-25 10:42:44', NULL, NULL, 15519, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:42:44', 'admin-1514162528-15141697639978337', 1, 0, '', NULL, NULL, NULL),
(57856, '2017-12-25 10:42:44', NULL, NULL, 15519, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:42:44', 'admin-1514162528-15141697639978337', 1, 1, 'SR', NULL, NULL, NULL),
(57857, '2017-12-25 16:39:21', NULL, NULL, 15559, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 16:39:21', 'admin-1514162528-15141911613662571', 1, 0, '', NULL, '25.0', NULL),
(57858, '2017-12-25 11:17:49', NULL, NULL, 15525, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:17:49', 'admin-1514162528-15141718690023126', 1, 1, 'SR', NULL, NULL, NULL),
(57859, '2017-12-25 11:17:49', NULL, NULL, 15525, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:17:49', 'admin-1514162528-15141718690023126', 1, 1, 'SR', NULL, NULL, NULL),
(57860, '2017-12-25 10:28:06', NULL, NULL, 15517, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:28:06', 'admin-1514162528-1514168885985846', 1, 0, '', NULL, NULL, NULL),
(57861, '2017-12-25 11:39:55', NULL, NULL, 15530, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:39:55', 'admin-1514162528-1514173195736214', 1, 1, 'SR', NULL, NULL, NULL),
(57862, '2017-12-25 10:02:00', NULL, NULL, 15510, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:02:00', 'admin-1514162528-1514167319902219', 1, 0, '', NULL, NULL, NULL),
(57863, '2017-12-25 14:51:37', NULL, NULL, 15552, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:51:37', 'admin-1514162528-15141846970118792', 1, 1, 'SR', NULL, NULL, NULL),
(57864, '2017-12-25 14:32:43', NULL, NULL, 15552, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:32:43', 'admin-1514162528-15141835630147313', 1, 1, 'SR', NULL, NULL, NULL),
(57865, '2017-12-25 11:09:08', NULL, NULL, 15524, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:09:08', 'admin-1514162528-15141713485821816', 1, 1, 'SR', NULL, NULL, NULL),
(57866, '2017-12-25 11:09:08', NULL, NULL, 15524, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:09:08', 'admin-1514162528-15141713485821816', 1, 1, 'SR', NULL, NULL, NULL),
(57867, '2017-12-25 13:47:41', NULL, NULL, 15548, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:47:41', 'admin-1514162528-15141808615022527', 1, 0, '', NULL, NULL, NULL),
(57868, '2017-12-25 11:17:49', NULL, NULL, 15525, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:17:49', 'admin-1514162528-15141718690023126', 1, 1, 'SR', NULL, NULL, NULL),
(57869, '2017-12-25 11:09:08', NULL, NULL, 15524, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:09:08', 'admin-1514162528-15141713485821816', 1, 0, '', NULL, NULL, NULL),
(57870, '2017-12-25 11:09:08', NULL, NULL, 15524, 0, 75, '75', 'Meatless Aglio Olio ', 'for kids no cili', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:09:08', 'admin-1514162528-15141713485821816', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(57871, '2017-12-25 10:20:57', NULL, NULL, 15513, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:20:57', 'admin-1514162528-151416845724968', 1, 0, '', NULL, NULL, NULL),
(57872, '2017-12-25 11:08:35', NULL, NULL, 15524, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:08:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57873, '2017-12-25 11:01:17', NULL, NULL, 15523, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:01:17', 'admin-1514162528-15141708769336486', 1, 1, 'SR', NULL, NULL, NULL),
(57874, '2017-12-25 11:01:13', NULL, NULL, 15523, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:01:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57875, '2017-12-25 11:00:44', NULL, NULL, 15522, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:00:44', 'admin-1514162528-15141708440858299', 1, 0, '', NULL, '25.0', NULL),
(57876, '2017-12-25 10:57:09', NULL, NULL, 15521, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:57:09', 'admin-1514162528-15141706293695961', 1, 0, '', NULL, NULL, NULL),
(57877, '2017-12-25 11:00:44', NULL, NULL, 15522, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:00:44', 'admin-1514162528-15141708440858299', 1, 1, 'SR', NULL, NULL, NULL),
(57878, '2017-12-25 11:00:44', NULL, NULL, 15522, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:00:44', 'admin-1514162528-15141708440858299', 1, 0, '', NULL, NULL, NULL),
(57879, '2017-12-25 10:50:26', NULL, NULL, 15511, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:50:26', 'admin-1514162528-1514170225863204', 1, 1, 'SR', NULL, NULL, NULL),
(57880, '2017-12-25 10:57:09', NULL, NULL, 15521, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:57:09', 'admin-1514162528-15141706293695961', 1, 0, '', NULL, NULL, NULL),
(57881, '2017-12-25 13:22:17', NULL, NULL, 15547, 0, 75, '75', 'Meatless Aglio Olio ', 'no spicy', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:22:17', 'admin-1514162528-15141793376609524', 1, 0, '', NULL, NULL, NULL),
(57882, '2017-12-25 11:51:29', NULL, NULL, 15533, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:51:29', 'admin-1514162528-15141738891598730', 1, 0, '', NULL, NULL, NULL),
(57883, '2017-12-25 10:42:44', NULL, NULL, 15519, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:42:44', 'admin-1514162528-15141697639978337', 1, 0, '', NULL, NULL, NULL),
(57884, '2017-12-25 10:42:44', NULL, NULL, 15519, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:42:44', 'admin-1514162528-15141697639978337', 1, 0, '', NULL, NULL, NULL),
(57885, '2017-12-25 10:42:44', NULL, NULL, 15519, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:42:44', 'admin-1514162528-15141697639978337', 1, 0, '', NULL, NULL, NULL),
(57886, '2017-12-25 09:18:12', NULL, NULL, 15506, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:18:12', 'admin-1514162528-1514164692121874', 1, 1, 'SR', NULL, NULL, NULL),
(57887, '2017-12-25 09:18:12', NULL, NULL, 15506, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:18:12', 'admin-1514162528-1514164692121874', 1, 1, 'SR', NULL, NULL, NULL),
(57888, '2017-12-25 11:18:13', NULL, NULL, 15515, 0, 153, '87', 'Wake Me Up!', 'Takeaway', 'Meals', 'Morning Bites ', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:18:13', 'admin-1514162528-1514171893784944', 1, 0, '', NULL, NULL, NULL),
(57889, '2017-12-25 10:49:07', NULL, NULL, 15520, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:49:07', 'admin-1514162528-1514170147066543', 1, 1, 'SR', NULL, NULL, NULL),
(57890, '2017-12-25 10:33:15', NULL, NULL, 15518, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:33:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57891, '2017-12-25 10:27:20', NULL, NULL, 15511, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:27:20', 'admin-1514162528-15141688404757143', 1, 0, '', NULL, NULL, NULL),
(57892, '2017-12-25 10:27:48', NULL, NULL, 15517, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:27:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57893, '2017-12-25 10:28:06', NULL, NULL, 15517, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:28:06', 'admin-1514162528-1514168885985846', 1, 0, '', NULL, NULL, NULL),
(57894, '2017-12-25 10:29:29', NULL, NULL, 15516, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:29:29', 'admin-1514162528-15141689694347748', 1, 1, 'SR', NULL, NULL, NULL),
(57895, '2017-12-25 10:24:54', NULL, NULL, 15516, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:24:54', 'admin-1514162528-15141686947476069', 1, 0, '', NULL, NULL, NULL),
(57896, '2017-12-25 10:24:54', NULL, NULL, 15516, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:24:54', 'admin-1514162528-15141686947476069', 1, 0, '', NULL, NULL, NULL),
(57897, '2017-12-25 10:38:46', NULL, NULL, 15518, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:38:46', 'admin-1514162528-15141695265939151', 1, 1, 'SR', NULL, NULL, NULL),
(57898, '2017-12-25 10:33:26', NULL, NULL, 15518, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:33:26', 'admin-1514162528-1514169206836426', 1, 1, 'SR', NULL, NULL, NULL),
(57899, '2017-12-25 10:33:26', NULL, NULL, 15518, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:33:26', 'admin-1514162528-1514169206836426', 1, 0, '', NULL, NULL, NULL),
(57900, '2017-12-25 13:47:13', NULL, NULL, 15548, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.90, 0.0000, 0.0000, 13.90, 1, '27', 1, '1514162528', 'admin', '2017-12-25 13:47:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57901, '2017-12-25 10:02:00', NULL, NULL, 15510, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:02:00', 'admin-1514162528-1514167319902219', 1, 0, '', NULL, NULL, NULL),
(57902, '2017-12-25 10:02:50', NULL, NULL, 15510, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:02:50', 'admin-1514162528-15141673705901058', 1, 1, 'SR', NULL, NULL, NULL),
(57903, '2017-12-25 10:02:50', NULL, NULL, 15510, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:02:50', 'admin-1514162528-15141673705901058', 1, 0, '', NULL, '25.0', NULL),
(57904, '2017-12-25 10:29:29', NULL, NULL, 15516, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:29:29', 'admin-1514162528-15141689694347748', 1, 0, '', NULL, NULL, NULL),
(57905, '2017-12-25 10:28:06', NULL, NULL, 15517, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:28:06', 'admin-1514162528-1514168885985846', 1, 1, 'SR', NULL, NULL, NULL),
(57906, '2017-12-25 10:20:57', NULL, NULL, 15513, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:20:57', 'admin-1514162528-151416845724968', 1, 0, '', NULL, NULL, NULL),
(57907, '2017-12-25 10:42:24', NULL, NULL, 15519, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.20, 0.0000, 0.0000, 9.20, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:42:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57908, '2017-12-25 10:23:57', NULL, NULL, 15516, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:23:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57909, '2017-12-25 10:24:54', NULL, NULL, 15516, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:24:54', 'admin-1514162528-15141686947476069', 1, 0, '', NULL, NULL, NULL),
(57910, '2017-12-25 10:20:37', NULL, NULL, 15513, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.40, 0.0000, 0.0000, 11.40, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:20:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57911, '2017-12-25 10:22:21', NULL, NULL, 15515, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:22:21', 'admin-1514162528-15141685418116424', 1, 1, 'SR', NULL, NULL, NULL),
(57912, '2017-12-25 10:21:37', NULL, NULL, 15515, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:21:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57913, '2017-12-25 10:21:32', NULL, NULL, 15514, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:21:32', 'admin-1514162528-1514168492383309', 1, 0, '', NULL, NULL, NULL),
(57914, '2017-12-25 10:20:57', NULL, NULL, 15513, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:20:57', 'admin-1514162528-151416845724968', 1, 1, 'SR', NULL, NULL, NULL),
(57915, '2017-12-25 10:20:57', NULL, NULL, 15513, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:20:57', 'admin-1514162528-151416845724968', 1, 1, 'SR', NULL, NULL, NULL),
(57916, '2017-12-25 09:39:45', NULL, NULL, 15508, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:39:45', 'admin-1514162528-15141659852444340', 1, 1, 'SR', 1, NULL, NULL),
(57917, '2017-12-25 11:45:32', NULL, NULL, 15532, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:45:32', 'admin-1514162528-15141735323206898', 1, 1, 'SR', NULL, NULL, NULL),
(57918, '2017-12-25 10:20:57', NULL, NULL, 15513, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:20:57', 'admin-1514162528-151416845724968', 1, 0, '', NULL, NULL, NULL),
(57919, '2017-12-25 12:30:23', NULL, NULL, 15539, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 12:30:23', 'admin-1514162528-15141762238491798', 1, 1, 'SR', NULL, NULL, NULL),
(57920, '2017-12-25 10:20:57', NULL, NULL, 15513, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:20:57', 'admin-1514162528-151416845724968', 1, 0, '', NULL, NULL, NULL),
(57921, '2017-12-25 09:42:53', NULL, NULL, 15509, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.30, 0.0000, 0.0000, 13.30, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:42:53', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(57922, '2017-12-25 09:43:25', NULL, NULL, 15509, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:43:25', 'admin-1514162528-15141662056793762', 1, 0, '', NULL, NULL, '10.0'),
(57923, '2017-12-25 09:43:25', NULL, NULL, 15509, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:43:25', 'admin-1514162528-15141662056793762', 1, 0, '', NULL, NULL, '10.0'),
(57924, '2017-12-25 09:43:25', NULL, NULL, 15509, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:43:25', 'admin-1514162528-15141662056793762', 1, 0, '', NULL, NULL, '10.0'),
(57925, '2017-12-25 09:43:25', NULL, NULL, 15509, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:43:25', 'admin-1514162528-15141662056793762', 1, 0, '', NULL, NULL, '10.0'),
(57926, '2017-12-25 09:43:25', NULL, NULL, 15509, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:43:25', 'admin-1514162528-15141662056793762', 1, 0, '', NULL, NULL, '10.0'),
(57927, '2017-12-25 09:43:25', NULL, NULL, 15509, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:43:25', 'admin-1514162528-15141662056793762', 1, 1, 'SR', NULL, NULL, '10.0'),
(57928, '2017-12-25 09:43:25', NULL, NULL, 15509, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:43:25', 'admin-1514162528-15141662056793762', 1, 0, '', NULL, NULL, '10.0'),
(57929, '2017-12-25 10:20:57', NULL, NULL, 15513, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:20:57', 'admin-1514162528-151416845724968', 1, 0, '', NULL, NULL, NULL),
(57930, '2017-12-25 14:35:42', NULL, NULL, 15553, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 14:35:42', 'admin-1514162528-1514183742165598', 1, 0, '', NULL, NULL, NULL),
(57931, '2017-12-25 10:12:52', NULL, NULL, 15511, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:12:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57932, '2017-12-25 10:12:58', NULL, NULL, 15511, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:12:58', 'admin-1514162528-1514167978129155', 1, 1, 'SR', NULL, NULL, NULL),
(57933, '2017-12-25 10:12:58', NULL, NULL, 15511, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:12:58', 'admin-1514162528-1514167978129155', 1, 1, 'SR', NULL, NULL, NULL),
(57934, '2017-12-25 10:13:37', NULL, NULL, 15512, 0, 328, '264', 'Basic Blueberries Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:13:37', 'admin-1514162528-15141680175106678', 1, 0, '', NULL, NULL, NULL),
(57935, '2017-12-25 10:33:12', NULL, NULL, 15513, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:33:12', 'admin-1514162528-1514169192246776', 1, 1, 'SR', NULL, NULL, NULL),
(57936, '2017-12-25 10:13:37', NULL, NULL, 15512, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:13:37', 'admin-1514162528-15141680175106678', 1, 0, '', NULL, NULL, NULL),
(57937, '2017-12-25 10:13:37', NULL, NULL, 15512, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:13:37', 'admin-1514162528-15141680175106678', 1, 0, '', NULL, NULL, NULL),
(57938, '2017-12-25 10:13:24', NULL, NULL, 15512, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:13:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57939, '2017-12-25 10:12:58', NULL, NULL, 15511, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:12:58', 'admin-1514162528-1514167978129155', 1, 1, 'SR', NULL, NULL, NULL),
(57940, '2017-12-25 10:04:01', NULL, NULL, 15510, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 10:04:01', 'admin-1514162528-15141674408851027', 1, 1, 'SR', NULL, NULL, NULL),
(57941, '2017-12-25 11:00:19', NULL, NULL, 15522, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1514162528', 'admin', '2017-12-25 11:00:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57942, '2017-12-25 09:31:59', NULL, NULL, 15507, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:31:59', 'admin-1514162528-15141655188938923', 1, 0, '', NULL, NULL, NULL),
(57943, '2017-12-25 09:31:59', NULL, NULL, 15507, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:31:59', 'admin-1514162528-15141655188938923', 1, 0, '', NULL, NULL, NULL),
(57944, '2017-12-25 09:31:53', NULL, NULL, 15507, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:31:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57945, '2017-12-25 09:18:12', NULL, NULL, 15506, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514162528', 'admin', '2017-12-25 09:18:12', 'admin-1514162528-1514164692121874', 1, 0, '', NULL, NULL, NULL),
(57946, '2017-12-27 10:24:56', NULL, NULL, 15567, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:24:56', 'admin-1514336956-15143414966603535', 1, 1, 'SR', NULL, NULL, NULL),
(57947, '2017-12-27 10:24:56', NULL, NULL, 15567, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:24:56', 'admin-1514336956-15143414966603535', 1, 0, '', NULL, NULL, NULL),
(57948, '2017-12-27 10:27:55', NULL, NULL, 15565, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:27:55', 'admin-1514336956-15143416755818362', 1, 1, 'SR', NULL, NULL, NULL),
(57949, '2017-12-27 10:27:55', NULL, NULL, 15565, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:27:55', 'admin-1514336956-15143416755818362', 1, 0, '', NULL, NULL, NULL),
(57950, '2017-12-27 13:02:10', NULL, NULL, 15572, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:02:10', 'admin-1514336956-15143509303814116', 1, 1, 'SR', NULL, NULL, '10.0'),
(57951, '2017-12-27 13:02:10', NULL, NULL, 15572, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:02:10', 'admin-1514336956-15143509303814116', 1, 0, '', NULL, NULL, '10.0'),
(57952, '2017-12-27 15:09:46', NULL, NULL, 15589, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 15:09:46', 'admin-1514336956-15143585859795553', 1, 0, '', NULL, NULL, NULL),
(57953, '2017-12-27 14:22:10', NULL, NULL, 15589, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:22:10', 'admin-1514336956-15143557305872185', 1, 1, 'SR', NULL, NULL, NULL),
(57954, '2017-12-27 14:29:24', NULL, NULL, 15590, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:29:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57955, '2017-12-27 14:29:41', NULL, NULL, 15590, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:29:41', 'admin-1514336956-15143561816681172', 1, 0, '', NULL, NULL, NULL),
(57956, '2017-12-27 14:29:41', NULL, NULL, 15590, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:29:41', 'admin-1514336956-15143561816681172', 1, 0, '', NULL, NULL, NULL),
(57957, '2017-12-27 10:29:41', NULL, NULL, 15568, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:29:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57958, '2017-12-27 10:30:12', NULL, NULL, 15568, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:30:12', 'admin-1514336956-1514341812179935', 1, 0, '', NULL, NULL, NULL),
(57959, '2017-12-27 10:30:12', NULL, NULL, 15568, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:30:12', 'admin-1514336956-1514341812179935', 1, 0, '', NULL, NULL, NULL),
(57960, '2017-12-27 10:30:12', NULL, NULL, 15568, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:30:12', 'admin-1514336956-1514341812179935', 1, 1, 'SR', NULL, NULL, NULL),
(57961, '2017-12-27 10:46:46', NULL, NULL, 15569, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:46:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57962, '2017-12-27 10:47:02', NULL, NULL, 15569, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:47:02', 'admin-1514336956-15143428218947523', 1, 0, '', NULL, NULL, NULL),
(57963, '2017-12-27 14:13:07', NULL, NULL, 15584, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:13:07', 'admin-1514336956-15143551869856842', 1, 1, 'SR', NULL, NULL, NULL),
(57964, '2017-12-27 12:49:37', NULL, NULL, 15578, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:49:37', 'admin-1514336956-15143501775538751', 1, 0, '', NULL, NULL, NULL),
(57965, '2017-12-27 15:28:38', NULL, NULL, 15597, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.20, 0.0000, 0.0000, 11.20, 1, '27', 1, '1514336956', 'admin', '2017-12-27 15:28:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57966, '2017-12-27 15:29:27', NULL, NULL, 15597, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 15:29:27', 'admin-1514336956-15143597670239577', 1, 0, '', NULL, NULL, NULL),
(57967, '2017-12-27 15:29:27', NULL, NULL, 15597, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 15:29:27', 'admin-1514336956-15143597670239577', 1, 0, '', NULL, NULL, NULL),
(57968, '2017-12-27 00:00:00', NULL, NULL, 15587, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:22:43', 'admin-1514336956-15143485636902226', 1, 0, '', NULL, NULL, NULL),
(57969, '2017-12-27 12:34:30', NULL, NULL, 15576, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:34:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57970, '2017-12-27 00:00:00', NULL, NULL, 15587, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:22:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57971, '2017-12-27 14:21:10', NULL, NULL, 15588, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:21:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57972, '2017-12-27 00:00:00', NULL, NULL, 15587, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:22:43', 'admin-1514336956-15143485636902226', 1, 0, '', NULL, NULL, NULL),
(57973, '2017-12-27 14:14:44', NULL, NULL, 15585, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:14:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57974, '2017-12-27 14:58:21', NULL, NULL, 15594, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:58:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57975, '2017-12-27 14:58:27', NULL, NULL, 15594, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:58:27', 'admin-1514336956-15143579071746771', 1, 1, 'SR', NULL, NULL, NULL),
(57976, '2017-12-27 15:29:27', NULL, NULL, 15597, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 15:29:27', 'admin-1514336956-15143597670239577', 1, 0, '', NULL, NULL, NULL),
(57977, '2017-12-27 15:29:27', NULL, NULL, 15597, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 15:29:27', 'admin-1514336956-15143597670239577', 1, 0, '', NULL, NULL, NULL),
(57978, '2017-12-27 15:29:27', NULL, NULL, 15597, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 15:29:27', 'admin-1514336956-15143597670239577', 1, 0, '', NULL, NULL, NULL),
(57979, '2017-12-27 10:04:40', NULL, NULL, 15565, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:04:40', 'admin-1514336956-15143402802218982', 1, 0, '', NULL, NULL, NULL),
(57980, '2017-12-27 13:34:01', NULL, NULL, 15582, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:34:01', 'admin-1514336956-15143528417626674', 1, 0, '', NULL, NULL, NULL),
(57981, '2017-12-27 13:34:01', NULL, NULL, 15582, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:34:01', 'admin-1514336956-15143528417626674', 1, 1, 'SR', NULL, NULL, NULL),
(57982, '2017-12-27 14:43:53', NULL, NULL, 15592, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:43:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57983, '2017-12-27 15:21:59', NULL, NULL, 15595, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 15:21:59', 'admin-1514336956-1514359319196367', 1, 1, 'SR', NULL, NULL, '10.0'),
(57984, '2017-12-27 15:22:27', NULL, NULL, 15596, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1514336956', 'admin', '2017-12-27 15:22:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57985, '2017-12-27 15:22:34', NULL, NULL, 15596, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 15:22:34', 'admin-1514336956-1514359354290761', 1, 1, 'SR', NULL, NULL, NULL),
(57986, '2017-12-27 15:22:34', NULL, NULL, 15596, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 15:22:34', 'admin-1514336956-1514359354290761', 1, 1, 'SR', NULL, NULL, NULL),
(57987, '2017-12-27 13:28:08', NULL, NULL, 15580, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:28:08', 'admin-1514336956-1514352487952527', 1, 1, 'SR', NULL, NULL, NULL),
(57988, '2017-12-27 13:31:27', NULL, NULL, 15581, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:31:27', 'admin-1514336956-15143526873883951', 1, 0, '', NULL, NULL, '10.0'),
(57989, '2017-12-27 13:28:08', NULL, NULL, 15580, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:28:08', 'admin-1514336956-1514352487952527', 1, 0, '', NULL, NULL, NULL),
(57990, '2017-12-27 13:46:01', NULL, NULL, 15577, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:46:01', 'admin-1514336956-15143535615434026', 1, 0, '', NULL, NULL, NULL),
(57991, '2017-12-27 14:45:44', NULL, NULL, 15592, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:45:44', 'admin-1514336956-15143571441195634', 1, 1, 'SR', NULL, NULL, NULL),
(57992, '2017-12-27 14:13:07', NULL, NULL, 15584, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:13:07', 'admin-1514336956-15143551869856842', 1, 1, 'SR', NULL, NULL, NULL),
(57993, '2017-12-27 14:12:44', NULL, NULL, 15584, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:12:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(57994, '2017-12-27 13:28:08', NULL, NULL, 15580, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:28:08', 'admin-1514336956-1514352487952527', 1, 0, '', NULL, NULL, NULL),
(57995, '2017-12-27 00:00:00', NULL, NULL, 15586, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:27:04', 'admin-1514336956-1514348824362297', 1, 0, '', NULL, NULL, NULL),
(57996, '2017-12-27 00:00:00', NULL, NULL, 15587, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:27:04', 'admin-1514336956-1514348824362297', 1, 1, 'SR', NULL, NULL, NULL),
(57997, '2017-12-27 14:21:22', NULL, NULL, 15588, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:21:22', 'admin-1514336956-15143556827248287', 1, 0, '', NULL, NULL, NULL),
(57998, '2017-12-27 14:21:22', NULL, NULL, 15588, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:21:22', 'admin-1514336956-15143556827248287', 1, 0, '', NULL, NULL, NULL),
(57999, '2017-12-27 14:21:22', NULL, NULL, 15588, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:21:22', 'admin-1514336956-15143556827248287', 1, 0, '', NULL, NULL, NULL),
(58000, '2017-12-27 11:11:55', NULL, NULL, 15565, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 11:11:55', 'admin-1514336956-15143443154431161', 1, 0, '', NULL, NULL, NULL),
(58001, '2017-12-27 11:11:55', NULL, NULL, 15565, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 11:11:55', 'admin-1514336956-15143443154431161', 1, 0, '', NULL, NULL, NULL),
(58002, '2017-12-27 11:28:06', NULL, NULL, 15570, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1514336956', 'admin', '2017-12-27 11:28:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58003, '2017-12-27 13:31:19', NULL, NULL, 15581, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:31:19', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(58004, '2017-12-27 10:47:02', NULL, NULL, 15569, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:47:02', 'admin-1514336956-15143428218947523', 1, 1, 'SR', NULL, NULL, NULL),
(58005, '2017-12-27 10:47:02', NULL, NULL, 15569, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:47:02', 'admin-1514336956-15143428218947523', 1, 1, 'SR', NULL, NULL, NULL),
(58006, '2017-12-27 10:47:02', NULL, NULL, 15569, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:47:02', 'admin-1514336956-15143428218947523', 1, 1, 'SR', NULL, NULL, NULL),
(58007, '2017-12-27 12:03:12', NULL, NULL, 15572, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:03:12', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(58008, '2017-12-27 13:18:08', NULL, NULL, 15579, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:18:08', 'admin-1514336956-15143518885302950', 1, 0, '', NULL, NULL, NULL),
(58009, '2017-12-27 16:00:18', NULL, NULL, 15597, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 16:00:18', 'admin-1514336956-1514361618365123', 1, 1, 'SR', NULL, NULL, NULL),
(58010, '2017-12-27 12:38:39', NULL, NULL, 15574, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Rice', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:38:39', 'admin-1514336956-15143495189051642', 1, 0, '', NULL, NULL, NULL),
(58011, '2017-12-27 12:07:03', NULL, NULL, 15574, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:07:03', 'admin-1514336956-15143476238335422', 1, 0, '', NULL, NULL, NULL),
(58012, '2017-12-27 12:07:03', NULL, NULL, 15574, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:07:03', 'admin-1514336956-15143476238335422', 1, 0, '', NULL, NULL, NULL),
(58013, '2017-12-27 12:07:04', NULL, NULL, 15574, 0, 181, '116', 'Open Food ', 'chickpea', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:07:04', 'admin-1514336956-15143476238335422', 1, 0, '', NULL, NULL, NULL),
(58014, '2017-12-27 14:21:26', NULL, NULL, 15589, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:21:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58015, '2017-12-27 14:09:13', NULL, NULL, 15583, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:09:13', 'admin-1514336956-15143549536331377', 1, 0, '', NULL, NULL, NULL),
(58016, '2017-12-27 14:09:13', NULL, NULL, 15583, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:09:13', 'admin-1514336956-15143549536331377', 1, 1, 'SR', NULL, NULL, NULL),
(58017, '2017-12-27 14:57:47', NULL, NULL, 15593, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:57:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58018, '2017-12-27 14:57:57', NULL, NULL, 15593, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:57:57', 'admin-1514336956-15143578773684675', 1, 0, '', NULL, NULL, NULL),
(58019, '2017-12-27 15:29:27', NULL, NULL, 15597, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 15:29:27', 'admin-1514336956-15143597670239577', 1, 1, 'SR', NULL, NULL, NULL),
(58020, '2017-12-27 14:57:57', NULL, NULL, 15593, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:57:57', 'admin-1514336956-15143578773684675', 1, 1, 'SR', NULL, NULL, NULL),
(58021, '2017-12-27 12:03:58', NULL, NULL, 15573, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:03:58', 'admin-1514336956-15143474383746635', 1, 0, '', NULL, NULL, NULL),
(58022, '2017-12-27 12:03:58', NULL, NULL, 15573, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:03:58', 'admin-1514336956-15143474383746635', 1, 1, 'SR', NULL, NULL, NULL),
(58023, '2017-12-27 14:44:09', NULL, NULL, 15592, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:44:09', 'admin-1514336956-1514357049562515', 1, 1, 'SR', NULL, NULL, NULL),
(58024, '2017-12-27 14:44:09', NULL, NULL, 15592, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:44:09', 'admin-1514336956-1514357049562515', 1, 0, '', NULL, NULL, NULL),
(58025, '2017-12-27 14:44:09', NULL, NULL, 15592, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:44:09', 'admin-1514336956-1514357049562515', 1, 0, '', NULL, NULL, NULL),
(58026, '2017-12-27 14:44:09', NULL, NULL, 15592, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:44:09', 'admin-1514336956-1514357049562515', 1, 0, '', NULL, NULL, NULL),
(58027, '2017-12-27 14:44:09', NULL, NULL, 15592, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:44:09', 'admin-1514336956-1514357049562515', 1, 0, '', NULL, NULL, NULL),
(58028, '2017-12-27 14:36:41', NULL, NULL, 15591, 0, 182, '117', 'Open Drinks ', 'coffee beans', 'Cold Drinks', 'Fresh Juice', 1, 38.00, 38.0000, 0.0000, 38.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:36:41', 'admin-1514336956-1514356601063776', 1, 0, '', 1, NULL, NULL),
(58029, '2017-12-27 13:18:08', NULL, NULL, 15579, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:18:08', 'admin-1514336956-15143518885302950', 1, 0, '', NULL, NULL, NULL),
(58030, '2017-12-27 13:18:08', NULL, NULL, 15579, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:18:08', 'admin-1514336956-15143518885302950', 1, 0, '', NULL, NULL, NULL),
(58031, '2017-12-27 13:18:08', NULL, NULL, 15579, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:18:08', 'admin-1514336956-15143518885302950', 1, 0, '', NULL, NULL, NULL),
(58032, '2017-12-27 13:18:08', NULL, NULL, 15579, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:18:08', 'admin-1514336956-15143518885302950', 1, 1, 'SR', NULL, NULL, NULL),
(58033, '2017-12-27 14:29:41', NULL, NULL, 15590, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:29:41', 'admin-1514336956-15143561816681172', 1, 0, '', NULL, NULL, NULL),
(58034, '2017-12-27 14:21:22', NULL, NULL, 15588, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:21:22', 'admin-1514336956-15143556827248287', 1, 0, '', NULL, NULL, NULL),
(58035, '2017-12-27 15:21:09', NULL, NULL, 15595, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1514336956', 'admin', '2017-12-27 15:21:09', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(58036, '2017-12-27 14:13:07', NULL, NULL, 15584, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:13:07', 'admin-1514336956-15143551869856842', 1, 0, '', NULL, NULL, NULL),
(58037, '2017-12-27 10:08:28', NULL, NULL, 15566, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:08:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58038, '2017-12-27 10:08:37', NULL, NULL, 15566, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:08:37', 'admin-1514336956-15143405174729987', 1, 1, 'SR', NULL, NULL, NULL),
(58039, '2017-12-27 10:08:37', NULL, NULL, 15566, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:08:37', 'admin-1514336956-15143405174729987', 1, 1, 'SR', NULL, NULL, NULL),
(58040, '2017-12-27 00:00:00', NULL, NULL, 15585, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:27:04', 'admin-1514336956-1514348824362297', 1, 0, '', NULL, NULL, NULL),
(58041, '2017-12-27 14:13:07', NULL, NULL, 15584, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:13:07', 'admin-1514336956-15143551869856842', 1, 0, '', NULL, NULL, NULL),
(58042, '2017-12-27 14:09:13', NULL, NULL, 15583, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:09:13', 'admin-1514336956-15143549536331377', 1, 1, 'SR', NULL, NULL, NULL),
(58043, '2017-12-27 14:09:13', NULL, NULL, 15583, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:09:13', 'admin-1514336956-15143549536331377', 1, 0, '', NULL, NULL, NULL),
(58044, '2017-12-27 12:07:03', NULL, NULL, 15574, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:07:03', 'admin-1514336956-15143476238335422', 1, 1, 'SR', NULL, NULL, NULL),
(58045, '2017-12-27 14:04:10', NULL, NULL, 15577, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:04:10', 'admin-1514336956-15143546501706675', 1, 1, 'SR', NULL, NULL, NULL),
(58046, '2017-12-27 13:34:01', NULL, NULL, 15582, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:34:01', 'admin-1514336956-15143528417626674', 1, 0, '', NULL, NULL, NULL),
(58047, '2017-12-27 13:32:19', NULL, NULL, 15582, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:32:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58048, '2017-12-27 13:31:27', NULL, NULL, 15581, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:31:27', 'admin-1514336956-15143526873883951', 1, 1, 'SR', NULL, NULL, '10.0'),
(58049, '2017-12-27 13:27:51', NULL, NULL, 15580, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:27:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58050, '2017-12-27 09:22:42', NULL, NULL, 15563, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 09:22:42', 'admin-1514336956-15143377621673916', 1, 1, 'SR', NULL, NULL, NULL),
(58051, '2017-12-27 09:22:42', NULL, NULL, 15563, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 09:22:42', 'admin-1514336956-15143377621673916', 1, 1, 'SR', NULL, NULL, NULL),
(58052, '2017-12-27 13:31:27', NULL, NULL, 15581, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:31:27', 'admin-1514336956-15143526873883951', 1, 0, '', NULL, NULL, '10.0'),
(58053, '2017-12-27 13:28:08', NULL, NULL, 15580, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:28:08', 'admin-1514336956-1514352487952527', 1, 0, '', NULL, NULL, NULL),
(58054, '2017-12-27 12:48:04', NULL, NULL, 15577, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.40, 0.0000, 0.0000, 9.40, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:48:04', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(58055, '2017-12-27 12:48:14', NULL, NULL, 15577, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:48:14', 'admin-1514336956-1514350094266241', 1, 0, '', NULL, NULL, NULL),
(58056, '2017-12-27 12:48:14', NULL, NULL, 15577, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:48:14', 'admin-1514336956-1514350094266241', 1, 0, '', NULL, NULL, NULL),
(58057, '2017-12-27 09:11:15', NULL, NULL, 15561, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1514336956', 'admin', '2017-12-27 09:11:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58058, '2017-12-27 09:11:22', NULL, NULL, 15561, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 09:11:22', 'admin-1514336956-15143370824734622', 1, 1, 'SR', NULL, NULL, NULL),
(58059, '2017-12-27 09:11:22', NULL, NULL, 15561, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 09:11:22', 'admin-1514336956-15143370824734622', 1, 0, '', NULL, NULL, NULL),
(58060, '2017-12-27 14:08:56', NULL, NULL, 15583, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:08:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58061, '2017-12-27 13:19:22', NULL, NULL, 15577, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:19:22', 'admin-1514336956-15143519620303976', 1, 1, 'SR', NULL, NULL, NULL),
(58062, '2017-12-27 13:18:08', NULL, NULL, 15579, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:18:08', 'admin-1514336956-15143518885302950', 1, 0, '', NULL, NULL, NULL),
(58063, '2017-12-27 13:18:08', NULL, NULL, 15579, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:18:08', 'admin-1514336956-15143518885302950', 1, 1, 'SR', NULL, NULL, NULL),
(58064, '2017-12-27 14:22:10', NULL, NULL, 15589, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:22:10', 'admin-1514336956-15143557305872185', 1, 0, '', NULL, NULL, NULL),
(58065, '2017-12-27 10:04:40', NULL, NULL, 15565, 0, 270, '204', 'Homemade Savoury Pancake', 'change to sunnyside up', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:04:40', 'admin-1514336956-15143402802218982', 1, 0, '', NULL, NULL, NULL),
(58066, '2017-12-27 10:04:40', NULL, NULL, 15565, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:04:40', 'admin-1514336956-15143402802218982', 1, 0, '', NULL, NULL, NULL),
(58067, '2017-12-27 13:19:22', NULL, NULL, 15577, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:19:22', 'admin-1514336956-15143519620303976', 1, 0, '', NULL, NULL, NULL),
(58068, '2017-12-27 14:13:07', NULL, NULL, 15584, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:13:07', 'admin-1514336956-15143551869856842', 1, 0, '', NULL, NULL, NULL),
(58069, '2017-12-27 12:34:39', NULL, NULL, 15576, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:34:39', 'admin-1514336956-15143492794777959', 1, 0, '', NULL, NULL, NULL),
(58070, '2017-12-27 12:34:39', NULL, NULL, 15576, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:34:39', 'admin-1514336956-15143492794777959', 1, 1, 'SR', NULL, NULL, NULL),
(58071, '2017-12-27 12:48:14', NULL, NULL, 15577, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:48:14', 'admin-1514336956-1514350094266241', 1, 0, '', NULL, NULL, NULL),
(58072, '2017-12-27 12:49:19', NULL, NULL, 15578, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:49:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58073, '2017-12-27 12:49:37', NULL, NULL, 15578, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:49:37', 'admin-1514336956-15143501775538751', 1, 0, '', NULL, NULL, NULL),
(58074, '2017-12-27 13:17:21', NULL, NULL, 15579, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:17:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58075, '2017-12-27 12:03:29', NULL, NULL, 15572, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:03:29', 'admin-1514336956-1514347409286627', 1, 0, '', NULL, NULL, '10.0'),
(58076, '2017-12-27 12:49:37', NULL, NULL, 15578, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:49:37', 'admin-1514336956-15143501775538751', 1, 0, '', NULL, NULL, NULL),
(58077, '2017-12-27 12:49:37', NULL, NULL, 15578, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:49:37', 'admin-1514336956-15143501775538751', 1, 1, 'SR', NULL, NULL, NULL),
(58078, '2017-12-27 12:49:37', NULL, NULL, 15578, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:49:37', 'admin-1514336956-15143501775538751', 1, 1, 'SR', NULL, NULL, NULL),
(58079, '2017-12-27 13:08:57', NULL, NULL, 15577, 0, 181, '116', 'Open Food ', 'dumpling sauce', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 13:08:57', 'admin-1514336956-1514351336930850', 1, 0, '', NULL, NULL, NULL),
(58080, '2017-12-27 10:47:02', NULL, NULL, 15569, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:47:02', 'admin-1514336956-15143428218947523', 1, 0, '', NULL, NULL, NULL),
(58081, '2017-12-27 14:15:30', NULL, NULL, 15586, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1514336956', 'admin', '2017-12-27 14:15:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58082, '2017-12-27 00:00:00', NULL, NULL, 15585, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:22:43', 'admin-1514336956-15143485636902226', 1, 0, '', NULL, NULL, NULL),
(58083, '2017-12-27 10:04:40', NULL, NULL, 15565, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:04:40', 'admin-1514336956-15143402802218982', 1, 1, 'SR', NULL, NULL, NULL),
(58084, '2017-12-27 12:07:03', NULL, NULL, 15574, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:07:03', 'admin-1514336956-15143476238335422', 1, 1, 'SR', NULL, NULL, NULL),
(58085, '2017-12-27 11:48:46', NULL, NULL, 15570, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 11:48:46', 'admin-1514336956-15143465265669943', 1, 0, '', NULL, NULL, NULL),
(58086, '2017-12-27 09:22:27', NULL, NULL, 15563, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1514336956', 'admin', '2017-12-27 09:22:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58087, '2017-12-27 12:03:33', NULL, NULL, 15573, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:03:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58088, '2017-12-27 12:03:29', NULL, NULL, 15572, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:03:29', 'admin-1514336956-1514347409286627', 1, 0, '', NULL, NULL, '10.0'),
(58089, '2017-12-27 12:06:38', NULL, NULL, 15574, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:06:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58090, '2017-12-27 11:35:18', NULL, NULL, 15571, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 11:35:18', 'admin-1514336956-15143457184315174', 1, 1, 'SR', NULL, NULL, NULL),
(58091, '2017-12-27 11:35:18', NULL, NULL, 15571, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 11:35:18', 'admin-1514336956-15143457184315174', 1, 1, 'SR', NULL, NULL, NULL),
(58092, '2017-12-27 11:35:10', NULL, NULL, 15571, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1514336956', 'admin', '2017-12-27 11:35:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58093, '2017-12-27 11:29:08', NULL, NULL, 15570, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 11:29:08', 'admin-1514336956-15143453482754819', 1, 0, '', NULL, NULL, NULL),
(58094, '2017-12-27 11:29:08', NULL, NULL, 15570, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 11:29:08', 'admin-1514336956-15143453482754819', 1, 1, 'SR', NULL, NULL, NULL),
(58095, '2017-12-27 11:29:08', NULL, NULL, 15570, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 11:29:08', 'admin-1514336956-15143453482754819', 1, 0, '', NULL, NULL, NULL),
(58096, '2017-12-27 11:29:08', NULL, NULL, 15570, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 11:29:08', 'admin-1514336956-15143453482754819', 1, 0, '', NULL, NULL, NULL),
(58097, '2017-12-27 10:47:02', NULL, NULL, 15569, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:47:02', 'admin-1514336956-15143428218947523', 1, 0, '', NULL, NULL, NULL),
(58098, '2017-12-27 09:22:47', NULL, NULL, 15564, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1514336956', 'admin', '2017-12-27 09:22:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58099, '2017-12-27 10:24:56', NULL, NULL, 15567, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:24:56', 'admin-1514336956-15143414966603535', 1, 1, 'SR', NULL, NULL, NULL),
(58100, '2017-12-27 10:24:46', NULL, NULL, 15567, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:24:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58101, '2017-12-27 10:08:37', NULL, NULL, 15566, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:08:37', 'admin-1514336956-15143405174729987', 1, 0, '', NULL, NULL, NULL),
(58102, '2017-12-27 10:04:40', NULL, NULL, 15565, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:04:40', 'admin-1514336956-15143402802218982', 1, 1, 'SR', NULL, NULL, NULL),
(58103, '2017-12-27 10:04:40', NULL, NULL, 15565, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:04:40', 'admin-1514336956-15143402802218982', 1, 0, '', NULL, NULL, NULL),
(58104, '2017-12-27 10:04:40', NULL, NULL, 15565, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:04:40', 'admin-1514336956-15143402802218982', 1, 0, '', NULL, NULL, NULL),
(58105, '2017-12-27 10:01:17', NULL, NULL, 15565, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 18.90, 0.0000, 0.0000, 18.90, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:01:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58106, '2017-12-27 10:04:40', NULL, NULL, 15565, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 10:04:40', 'admin-1514336956-15143402802218982', 1, 0, '', NULL, NULL, NULL),
(58107, '2017-12-27 09:22:54', NULL, NULL, 15564, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 09:22:54', 'admin-1514336956-15143377739624074', 1, 1, 'SR', NULL, NULL, NULL),
(58108, '2017-12-27 12:03:29', NULL, NULL, 15572, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 12:03:29', 'admin-1514336956-1514347409286627', 1, 0, '', NULL, NULL, '10.0'),
(58109, '2017-12-27 09:22:42', NULL, NULL, 15563, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 09:22:42', 'admin-1514336956-15143377621673916', 1, 0, '', NULL, NULL, NULL),
(58110, '2017-12-27 09:22:42', NULL, NULL, 15563, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 09:22:42', 'admin-1514336956-15143377621673916', 1, 0, '', NULL, NULL, NULL),
(58111, '2017-12-27 09:19:51', NULL, NULL, 15562, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514336956', 'admin', '2017-12-27 09:19:51', 'admin-1514336956-1514337591151622', 1, 1, 'SR', NULL, NULL, NULL),
(58112, '2017-12-27 09:19:47', NULL, NULL, 15562, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1514336956', 'admin', '2017-12-27 09:19:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58113, '2017-12-28 12:18:47', NULL, NULL, 15605, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.20, 0.0000, 0.0000, 11.20, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:18:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58114, '2017-12-28 12:19:40', NULL, NULL, 15605, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:19:40', 'admin-1514421741-1514434780355371', 1, 0, '', NULL, NULL, NULL),
(58115, '2017-12-28 12:19:40', NULL, NULL, 15605, 0, 302, '238', 'Ice on the cake', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:19:40', 'admin-1514421741-1514434780355371', 1, 0, '', NULL, NULL, NULL),
(58116, '2017-12-28 12:19:40', NULL, NULL, 15605, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:19:40', 'admin-1514421741-1514434780355371', 1, 0, '', NULL, NULL, NULL),
(58117, '2017-12-28 12:19:40', NULL, NULL, 15605, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:19:40', 'admin-1514421741-1514434780355371', 1, 0, '', NULL, NULL, NULL),
(58118, '2017-12-28 13:10:01', NULL, NULL, 15608, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 13:10:01', 'admin-1514421741-15144378011778092', 1, 0, '', NULL, NULL, NULL),
(58119, '2017-12-28 14:21:27', NULL, NULL, 15613, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 14:21:27', 'admin-1514421741-15144420874181761', 1, 0, '', NULL, NULL, '10.0'),
(58120, '2017-12-28 14:21:27', NULL, NULL, 15613, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 14:21:27', 'admin-1514421741-15144420874181761', 1, 0, '', NULL, NULL, '10.0'),
(58121, '2017-12-28 10:10:09', NULL, NULL, 15600, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 10:10:09', 'admin-1514421741-15144270092772253', 1, 0, '', NULL, NULL, NULL),
(58122, '2017-12-28 14:49:36', NULL, NULL, 15614, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.99, 0.0000, 0.0000, 2.99, 1, '27', 1, '1514421741', 'admin', '2017-12-28 14:49:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58123, '2017-12-28 14:49:47', NULL, NULL, 15614, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 14:49:47', 'admin-1514421741-15144437871652051', 1, 1, 'SR', NULL, NULL, NULL),
(58124, '2017-12-28 14:49:47', NULL, NULL, 15614, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 14:49:47', 'admin-1514421741-15144437871652051', 1, 1, 'SR', NULL, NULL, NULL),
(58125, '2017-12-28 15:16:43', NULL, NULL, 15615, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 15:16:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58126, '2017-12-28 15:16:52', NULL, NULL, 15615, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 15:16:52', 'admin-1514421741-1514445412577954', 1, 0, '', NULL, NULL, NULL),
(58127, '2017-12-28 12:05:23', NULL, NULL, 15604, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:05:23', 'admin-1514421741-15144339237409012', 1, 0, '', NULL, NULL, NULL),
(58128, '2017-12-28 12:05:23', NULL, NULL, 15604, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:05:23', 'admin-1514421741-15144339237409012', 1, 0, '', NULL, NULL, NULL),
(58129, '2017-12-28 12:05:23', NULL, NULL, 15604, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:05:23', 'admin-1514421741-15144339237409012', 1, 1, 'SR', NULL, NULL, NULL),
(58130, '2017-12-28 14:20:13', NULL, NULL, 15612, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.90, 0.0000, 0.0000, 12.90, 1, '27', 1, '1514421741', 'admin', '2017-12-28 14:20:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58131, '2017-12-28 14:21:13', NULL, NULL, 15612, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 14:21:13', 'admin-1514421741-1514442072929876', 1, 0, '', NULL, NULL, NULL),
(58132, '2017-12-28 14:21:13', NULL, NULL, 15612, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 14:21:13', 'admin-1514421741-1514442072929876', 1, 0, '', NULL, NULL, NULL),
(58133, '2017-12-28 14:21:13', NULL, NULL, 15612, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 14:21:13', 'admin-1514421741-1514442072929876', 1, 0, '', NULL, NULL, NULL),
(58134, '2017-12-28 12:27:14', NULL, NULL, 15606, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:27:14', 'admin-1514421741-1514435234586468', 1, 0, '', NULL, NULL, NULL),
(58135, '2017-12-28 12:27:14', NULL, NULL, 15606, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:27:14', 'admin-1514421741-1514435234586468', 1, 1, 'SR', NULL, NULL, NULL),
(58136, '2017-12-28 12:30:36', NULL, NULL, 15607, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:30:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58137, '2017-12-28 13:28:04', NULL, NULL, 15610, 0, 325, '261', 'Strawberry Chocolate Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 13:28:04', 'admin-1514421741-15144388839781876', 1, 0, '', NULL, NULL, NULL),
(58138, '2017-12-28 13:28:04', NULL, NULL, 15610, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 13:28:04', 'admin-1514421741-15144388839781876', 1, 1, 'SR', NULL, NULL, NULL),
(58139, '2017-12-28 13:42:23', NULL, NULL, 15611, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1514421741', 'admin', '2017-12-28 13:42:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58140, '2017-12-28 14:21:18', NULL, NULL, 15613, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.20, 0.0000, 0.0000, 10.20, 1, '27', 1, '1514421741', 'admin', '2017-12-28 14:21:18', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(58141, '2017-12-28 13:24:15', NULL, NULL, 15609, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 13:24:15', 'admin-1514421741-15144386553982572', 1, 1, 'SR', 1, NULL, '10.0'),
(58142, '2017-12-28 13:27:53', NULL, NULL, 15610, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1514421741', 'admin', '2017-12-28 13:27:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58143, '2017-12-28 15:39:30', NULL, NULL, 15617, 0, 335, '271', 'Iced Honey Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 15:39:30', 'admin-1514421741-15144467702572477', 1, 0, '', NULL, NULL, NULL),
(58144, '2017-12-28 15:39:23', NULL, NULL, 15617, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1514421741', 'admin', '2017-12-28 15:39:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58145, '2017-12-28 15:39:30', NULL, NULL, 15617, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 15:39:30', 'admin-1514421741-15144467702572477', 1, 1, 'SR', NULL, NULL, NULL),
(58146, '2017-12-28 12:05:23', NULL, NULL, 15604, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:05:23', 'admin-1514421741-15144339237409012', 1, 0, '', NULL, NULL, NULL),
(58147, '2017-12-28 11:00:21', NULL, NULL, 15602, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 11:00:21', 'admin-1514421741-1514430021003181', 1, 0, '', NULL, NULL, NULL),
(58148, '2017-12-28 11:00:21', NULL, NULL, 15602, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 11:00:21', 'admin-1514421741-1514430021003181', 1, 1, 'SR', NULL, NULL, NULL),
(58149, '2017-12-28 11:53:53', NULL, NULL, 15603, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1514421741', 'admin', '2017-12-28 11:53:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58150, '2017-12-28 16:59:46', NULL, NULL, 15619, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1514421741', 'admin', '2017-12-28 16:59:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58151, '2017-12-28 13:10:01', NULL, NULL, 15608, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 13:10:01', 'admin-1514421741-15144378011778092', 1, 0, '', NULL, NULL, NULL),
(58152, '2017-12-28 13:10:01', NULL, NULL, 15608, 0, 291, '225', 'Smoked Duck Red Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 13:10:01', 'admin-1514421741-15144378011778092', 1, 0, '', NULL, NULL, NULL),
(58153, '2017-12-28 09:56:44', NULL, NULL, 15599, 0, 156, '90', 'House Cheddar Omelet', 'No cheese', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 09:56:44', 'admin-1514421741-15144262047425952', 1, 0, '', NULL, NULL, NULL),
(58154, '2017-12-28 17:11:32', NULL, NULL, 15620, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 17:11:32', 'admin-1514421741-15144522928439247', 1, 1, 'SR', NULL, NULL, NULL),
(58155, '2017-12-28 17:11:28', NULL, NULL, 15620, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 17:11:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58156, '2017-12-28 16:59:54', NULL, NULL, 15619, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 16:59:54', 'admin-1514421741-1514451594229463', 1, 1, 'SR', NULL, NULL, NULL),
(58157, '2017-12-28 16:59:54', NULL, NULL, 15619, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 16:59:54', 'admin-1514421741-1514451594229463', 1, 1, 'SR', NULL, NULL, NULL),
(58158, '2017-12-28 15:16:52', NULL, NULL, 15615, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 15:16:52', 'admin-1514421741-1514445412577954', 1, 1, 'SR', NULL, NULL, NULL),
(58159, '2017-12-28 15:53:18', NULL, NULL, 15614, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1514421741', 'admin', '2017-12-28 15:53:18', 'admin-1514421741-15144475979677650', 1, 0, '', NULL, NULL, NULL),
(58160, '2017-12-28 15:50:34', NULL, NULL, 15618, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1514421741', 'admin', '2017-12-28 15:50:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58161, '2017-12-28 15:50:45', NULL, NULL, 15618, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 15:50:45', 'admin-1514421741-15144474451101293', 1, 1, 'SR', NULL, NULL, NULL),
(58162, '2017-12-28 15:50:45', NULL, NULL, 15618, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 15:50:45', 'admin-1514421741-15144474451101293', 1, 1, 'SR', NULL, NULL, NULL),
(58163, '2017-12-28 15:35:20', NULL, NULL, 15616, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1514421741', 'admin', '2017-12-28 15:35:20', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(58164, '2017-12-28 15:35:27', NULL, NULL, 15616, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 15:35:27', 'admin-1514421741-15144465271223481', 1, 1, 'SR', NULL, NULL, '10.0'),
(58165, '2017-12-28 14:21:27', NULL, NULL, 15613, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 14:21:27', 'admin-1514421741-15144420874181761', 1, 0, '', NULL, NULL, '10.0'),
(58166, '2017-12-28 14:31:02', NULL, NULL, 15613, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 14:31:02', 'admin-1514421741-15144426621639479', 1, 0, '', NULL, NULL, '10.0'),
(58167, '2017-12-28 14:30:32', NULL, NULL, 15613, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 14:30:32', 'admin-1514421741-15144426324749772', 1, 0, '', NULL, NULL, '10.0'),
(58168, '2017-12-28 14:21:27', NULL, NULL, 15613, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 14:21:27', 'admin-1514421741-15144420874181761', 1, 0, '', NULL, NULL, '10.0'),
(58169, '2017-12-28 13:24:15', NULL, NULL, 15609, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 13:24:15', 'admin-1514421741-15144386553982572', 1, 1, 'SR', 1, NULL, '10.0'),
(58170, '2017-12-28 15:50:45', NULL, NULL, 15618, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 15:50:45', 'admin-1514421741-15144474451101293', 1, 0, '', NULL, NULL, NULL),
(58171, '2017-12-28 14:21:13', NULL, NULL, 15612, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 14:21:13', 'admin-1514421741-1514442072929876', 1, 1, 'SR', NULL, NULL, NULL),
(58172, '2017-12-28 14:21:13', NULL, NULL, 15612, 0, 291, '225', 'Smoked Duck Red Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 14:21:13', 'admin-1514421741-1514442072929876', 1, 0, '', NULL, NULL, NULL),
(58173, '2017-12-28 14:21:13', NULL, NULL, 15612, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 14:21:13', 'admin-1514421741-1514442072929876', 1, 1, 'SR', NULL, NULL, NULL),
(58174, '2017-12-28 14:21:13', NULL, NULL, 15612, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 14:21:13', 'admin-1514421741-1514442072929876', 1, 0, '', NULL, NULL, NULL),
(58175, '2017-12-28 14:21:13', NULL, NULL, 15612, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 14:21:13', 'admin-1514421741-1514442072929876', 1, 0, '', NULL, NULL, NULL),
(58176, '2017-12-28 10:17:25', NULL, NULL, 15601, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1514421741', 'admin', '2017-12-28 10:17:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58177, '2017-12-28 10:17:33', NULL, NULL, 15601, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 10:17:33', 'admin-1514421741-15144274534271534', 1, 0, '', NULL, NULL, NULL),
(58178, '2017-12-28 10:17:33', NULL, NULL, 15601, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 10:17:33', 'admin-1514421741-15144274534271534', 1, 0, '', NULL, NULL, NULL),
(58179, '2017-12-28 10:58:38', NULL, NULL, 15602, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1514421741', 'admin', '2017-12-28 10:58:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58180, '2017-12-28 13:42:26', NULL, NULL, 15611, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 13:42:26', 'admin-1514421741-1514439746448279', 1, 1, 'SR', NULL, NULL, NULL),
(58181, '2017-12-28 13:09:41', NULL, NULL, 15608, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1514421741', 'admin', '2017-12-28 13:09:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58182, '2017-12-28 09:27:09', NULL, NULL, 15598, 0, 271, '205', 'Take It Easy', 'sunnysideup', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 09:27:09', 'admin-1514421741-15144244289546177', 1, 0, '', NULL, NULL, NULL),
(58183, '2017-12-28 13:28:04', NULL, NULL, 15610, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 13:28:04', 'admin-1514421741-15144388839781876', 1, 0, '', NULL, NULL, NULL),
(58184, '2017-12-28 09:56:44', NULL, NULL, 15599, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 09:56:44', 'admin-1514421741-15144262047425952', 1, 1, 'SR', NULL, NULL, NULL),
(58185, '2017-12-28 10:10:01', NULL, NULL, 15600, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1514421741', 'admin', '2017-12-28 10:10:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58186, '2017-12-28 12:32:20', NULL, NULL, 15604, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:32:20', 'admin-1514421741-15144355403551729', 1, 0, '', NULL, NULL, NULL),
(58187, '2017-12-28 12:30:41', NULL, NULL, 15607, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:30:41', 'admin-1514421741-15144354415135050', 1, 0, '', NULL, NULL, NULL),
(58188, '2017-12-28 12:30:41', NULL, NULL, 15607, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:30:41', 'admin-1514421741-15144354415135050', 1, 0, '', NULL, NULL, NULL),
(58189, '2017-12-28 12:27:14', NULL, NULL, 15606, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:27:14', 'admin-1514421741-1514435234586468', 1, 0, '', NULL, NULL, NULL),
(58190, '2017-12-28 12:27:03', NULL, NULL, 15606, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:27:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58191, '2017-12-28 12:19:40', NULL, NULL, 15605, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:19:40', 'admin-1514421741-1514434780355371', 1, 1, 'SR', NULL, NULL, NULL),
(58192, '2017-12-28 12:19:40', NULL, NULL, 15605, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:19:40', 'admin-1514421741-1514434780355371', 1, 1, 'SR', NULL, NULL, NULL),
(58193, '2017-12-28 12:19:40', NULL, NULL, 15605, 0, 322, '258', 'Yuzu Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:19:40', 'admin-1514421741-1514434780355371', 1, 0, '', NULL, NULL, NULL),
(58194, '2017-12-28 12:19:40', NULL, NULL, 15605, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:19:40', 'admin-1514421741-1514434780355371', 1, 1, 'SR', NULL, NULL, NULL),
(58195, '2017-12-28 12:19:40', NULL, NULL, 15605, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:19:40', 'admin-1514421741-1514434780355371', 1, 1, 'SR', NULL, NULL, NULL),
(58196, '2017-12-28 12:05:06', NULL, NULL, 15604, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1514421741', 'admin', '2017-12-28 12:05:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58197, '2017-12-28 11:54:00', NULL, NULL, 15603, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 11:54:00', 'admin-1514421741-15144332407582791', 1, 0, '', NULL, NULL, NULL),
(58198, '2017-12-28 11:00:21', NULL, NULL, 15602, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 11:00:21', 'admin-1514421741-1514430021003181', 1, 1, 'SR', NULL, NULL, NULL),
(58199, '2017-12-28 11:00:21', NULL, NULL, 15602, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 11:00:21', 'admin-1514421741-1514430021003181', 1, 1, 'SR', NULL, NULL, NULL),
(58200, '2017-12-28 10:10:09', NULL, NULL, 15600, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 10:10:09', 'admin-1514421741-15144270092772253', 1, 0, '', NULL, NULL, NULL),
(58201, '2017-12-28 09:26:38', NULL, NULL, 15598, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1514421741', 'admin', '2017-12-28 09:26:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58202, '2017-12-28 09:27:09', NULL, NULL, 15598, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 09:27:09', 'admin-1514421741-15144244289546177', 1, 1, 'SR', NULL, NULL, NULL),
(58203, '2017-12-28 09:27:09', NULL, NULL, 15598, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 09:27:09', 'admin-1514421741-15144244289546177', 1, 1, 'SR', NULL, NULL, NULL),
(58204, '2017-12-28 09:56:23', NULL, NULL, 15599, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1514421741', 'admin', '2017-12-28 09:56:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58205, '2017-12-28 09:27:09', NULL, NULL, 15598, 0, 153, '87', 'Wake Me Up!', 'no sosej', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514421741', 'admin', '2017-12-28 09:27:09', 'admin-1514421741-15144244289546177', 1, 0, '', NULL, NULL, NULL),
(58206, '2017-12-29 12:40:19', NULL, NULL, 15639, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:40:19', 'admin-1514509445-1514522419493989', 1, 0, '', NULL, NULL, NULL),
(58207, '2017-12-29 10:28:51', NULL, NULL, 15629, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:28:51', 'admin-1514509445-15145145312366220', 1, 0, '', NULL, NULL, NULL),
(58208, '2017-12-29 10:28:51', NULL, NULL, 15629, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:28:51', 'admin-1514509445-15145145312366220', 1, 0, '', NULL, NULL, NULL),
(58209, '2017-12-29 10:28:51', NULL, NULL, 15629, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:28:51', 'admin-1514509445-15145145312366220', 1, 1, 'SR', NULL, NULL, NULL),
(58210, '2017-12-29 10:28:51', NULL, NULL, 15629, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:28:51', 'admin-1514509445-15145145312366220', 1, 1, 'SR', NULL, NULL, NULL),
(58211, '2017-12-29 10:28:51', NULL, NULL, 15629, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:28:51', 'admin-1514509445-15145145312366220', 1, 1, 'SR', NULL, NULL, NULL),
(58212, '2017-12-29 10:27:42', NULL, NULL, 15629, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.10, 0.0000, 0.0000, 13.10, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:27:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58213, '2017-12-29 10:28:51', NULL, NULL, 15629, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:28:51', 'admin-1514509445-15145145312366220', 1, 0, '', NULL, NULL, NULL),
(58214, '2017-12-29 12:48:35', NULL, NULL, 15641, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:48:35', 'admin-1514509445-1514522914904867', 1, 0, '', NULL, NULL, NULL),
(58215, '2017-12-29 12:40:19', NULL, NULL, 15639, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:40:19', 'admin-1514509445-1514522419493989', 1, 1, 'SR', NULL, NULL, NULL),
(58216, '2017-12-29 12:40:19', NULL, NULL, 15639, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:40:19', 'admin-1514509445-1514522419493989', 1, 1, 'SR', NULL, NULL, NULL),
(58217, '2017-12-29 13:28:17', NULL, NULL, 15643, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 13:28:17', 'admin-1514509445-15145252974738052', 1, 1, 'SR', NULL, NULL, NULL),
(58218, '2017-12-29 13:28:17', NULL, NULL, 15643, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 13:28:17', 'admin-1514509445-15145252974738052', 1, 0, '', NULL, NULL, NULL),
(58219, '2017-12-29 13:28:17', NULL, NULL, 15643, 0, 269, '203', 'Espresso Con Panna', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 13:28:17', 'admin-1514509445-15145252974738052', 1, 0, '', NULL, NULL, NULL),
(58220, '2017-12-29 16:31:06', NULL, NULL, 15651, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 16:31:06', 'admin-1514509445-1514536265957773', 1, 1, 'SR', 1, NULL, NULL),
(58221, '2017-12-29 16:31:06', NULL, NULL, 15651, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 16:31:06', 'admin-1514509445-1514536265957773', 1, 1, 'SR', 1, NULL, NULL),
(58222, '2017-12-29 16:46:33', NULL, NULL, 15650, 0, 182, '117', 'Open Drinks ', 'milk', 'Cold Drinks', 'Fresh Juice', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 16:46:33', 'admin-1514509445-1514537193811381', 1, 0, '', NULL, NULL, NULL),
(58223, '2017-12-29 16:30:53', NULL, NULL, 15650, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 16:30:53', 'admin-1514509445-15145362534304049', 1, 0, '', NULL, NULL, NULL),
(58224, '2017-12-29 14:52:53', NULL, NULL, 15645, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 8.10, 1, '27', 1, '1514509445', 'admin', '2017-12-29 14:52:53', 'admin-1514509445-15145303730641756', 1, 1, 'SR', NULL, '10.0', '10.0'),
(58225, '2017-12-29 14:57:12', NULL, NULL, 15646, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1514509445', 'admin', '2017-12-29 14:57:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58226, '2017-12-29 15:02:12', NULL, NULL, 15646, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 15:02:12', 'admin-1514509445-15145309321038257', 1, 1, 'SR', NULL, NULL, NULL),
(58227, '2017-12-29 15:02:26', NULL, NULL, 15647, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1514509445', 'admin', '2017-12-29 15:02:26', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(58228, '2017-12-29 15:02:36', NULL, NULL, 15647, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 15:02:36', 'admin-1514509445-1514530956626191', 1, 0, '', NULL, NULL, '10.0'),
(58229, '2017-12-29 16:30:53', NULL, NULL, 15650, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 16:30:53', 'admin-1514509445-15145362534304049', 1, 1, 'SR', NULL, NULL, NULL),
(58230, '2017-12-29 16:30:53', NULL, NULL, 15650, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 16:30:53', 'admin-1514509445-15145362534304049', 1, 1, 'SR', NULL, NULL, NULL),
(58231, '2017-12-29 16:30:09', NULL, NULL, 15650, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1514509445', 'admin', '2017-12-29 16:30:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58232, '2017-12-29 11:08:25', NULL, NULL, 15633, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 11:08:25', 'admin-1514509445-15145169057051968', 1, 0, '', NULL, NULL, NULL),
(58233, '2017-12-29 11:08:25', NULL, NULL, 15633, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 11:08:25', 'admin-1514509445-15145169057051968', 1, 0, '', NULL, NULL, NULL),
(58234, '2017-12-29 11:38:10', NULL, NULL, 15634, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1514509445', 'admin', '2017-12-29 11:38:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58235, '2017-12-29 11:38:21', NULL, NULL, 15634, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 11:38:21', 'admin-1514509445-1514518701030419', 1, 0, '', NULL, NULL, NULL),
(58236, '2017-12-29 11:38:21', NULL, NULL, 15634, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 11:38:21', 'admin-1514509445-1514518701030419', 1, 1, 'SR', NULL, NULL, NULL),
(58237, '2017-12-29 15:20:19', NULL, NULL, 15649, 0, 324, '260', 'Blueberry Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 15:20:19', 'admin-1514509445-15145320197382548', 1, 0, '', NULL, NULL, NULL),
(58238, '2017-12-29 15:20:19', NULL, NULL, 15649, 0, 324, '260', 'Blueberry Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 15:20:19', 'admin-1514509445-15145320197382548', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(58239, '2017-12-29 12:46:46', NULL, NULL, 15641, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.10, 0.0000, 0.0000, 13.10, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:46:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58240, '2017-12-29 15:20:19', NULL, NULL, 15649, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 15:20:19', 'admin-1514509445-15145320197382548', 1, 0, '', NULL, NULL, NULL),
(58241, '2017-12-29 14:21:35', NULL, NULL, 15645, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 14:21:35', 'admin-1514509445-15145284950815132', 1, 0, '', NULL, NULL, '10.0'),
(58242, '2017-12-29 11:53:32', NULL, NULL, 15636, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1514509445', 'admin', '2017-12-29 11:53:32', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(58243, '2017-12-29 15:20:06', NULL, NULL, 15649, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1514509445', 'admin', '2017-12-29 15:20:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58244, '2017-12-29 15:20:19', NULL, NULL, 15649, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 15:20:19', 'admin-1514509445-15145320197382548', 1, 0, '', NULL, NULL, NULL),
(58245, '2017-12-29 12:48:35', NULL, NULL, 15641, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:48:35', 'admin-1514509445-1514522914904867', 1, 0, '', NULL, NULL, NULL),
(58246, '2017-12-29 12:48:35', NULL, NULL, 15641, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:48:35', 'admin-1514509445-1514522914904867', 1, 0, '', NULL, NULL, NULL),
(58247, '2017-12-29 12:48:35', NULL, NULL, 15641, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:48:35', 'admin-1514509445-1514522914904867', 1, 0, '', NULL, NULL, NULL),
(58248, '2017-12-29 15:03:00', NULL, NULL, 15648, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 15:03:00', 'admin-1514509445-15145309801813993', 1, 1, 'SR', NULL, NULL, NULL),
(58249, '2017-12-29 13:06:49', NULL, NULL, 15642, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 13:06:49', 'admin-1514509445-15145240089655036', 1, 0, '', NULL, NULL, '10.0'),
(58250, '2017-12-29 13:06:49', NULL, NULL, 15642, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 13:06:49', 'admin-1514509445-15145240089655036', 1, 0, '', NULL, NULL, '10.0'),
(58251, '2017-12-29 13:06:49', NULL, NULL, 15642, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 13:06:49', 'admin-1514509445-15145240089655036', 1, 1, 'SR', NULL, NULL, '10.0'),
(58252, '2017-12-29 13:06:49', NULL, NULL, 15642, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 13:06:49', 'admin-1514509445-15145240089655036', 1, 1, 'SR', NULL, NULL, '10.0'),
(58253, '2017-12-29 13:27:54', NULL, NULL, 15643, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1514509445', 'admin', '2017-12-29 13:27:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58254, '2017-12-29 15:03:00', NULL, NULL, 15648, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 15:03:00', 'admin-1514509445-15145309801813993', 1, 0, '', NULL, NULL, NULL),
(58255, '2017-12-29 09:42:25', NULL, NULL, 15623, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:42:25', 'admin-1514509445-15145117456626469', 1, 1, 'SR', NULL, NULL, NULL),
(58256, '2017-12-29 09:42:25', NULL, NULL, 15623, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:42:25', 'admin-1514509445-15145117456626469', 1, 1, 'SR', NULL, NULL, NULL),
(58257, '2017-12-29 09:42:25', NULL, NULL, 15623, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:42:25', 'admin-1514509445-15145117456626469', 1, 0, '', NULL, NULL, NULL),
(58258, '2017-12-29 15:03:00', NULL, NULL, 15648, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 15:03:00', 'admin-1514509445-15145309801813993', 1, 1, 'SR', NULL, NULL, NULL),
(58259, '2017-12-29 12:40:19', NULL, NULL, 15639, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:40:19', 'admin-1514509445-1514522419493989', 1, 0, '', NULL, NULL, NULL),
(58260, '2017-12-29 12:40:19', NULL, NULL, 15639, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:40:19', 'admin-1514509445-1514522419493989', 1, 1, 'SR', NULL, NULL, NULL),
(58261, '2017-12-29 12:40:19', NULL, NULL, 15639, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:40:19', 'admin-1514509445-1514522419493989', 1, 0, '', NULL, NULL, NULL),
(58262, '2017-12-29 09:49:53', NULL, NULL, 15624, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:49:53', 'admin-1514509445-15145121935715651', 1, 1, 'SR', NULL, NULL, NULL),
(58263, '2017-12-29 09:59:19', NULL, NULL, 15625, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:59:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58264, '2017-12-29 09:59:24', NULL, NULL, 15625, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:59:24', 'admin-1514509445-15145127640029398', 1, 1, 'SR', NULL, NULL, NULL),
(58265, '2017-12-29 15:03:00', NULL, NULL, 15648, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 15:03:00', 'admin-1514509445-15145309801813993', 1, 1, 'SR', NULL, NULL, NULL),
(58266, '2017-12-29 15:03:00', NULL, NULL, 15648, 0, 305, '241', 'Sprite', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 15:03:00', 'admin-1514509445-15145309801813993', 1, 0, '', NULL, NULL, NULL),
(58267, '2017-12-29 10:17:04', NULL, NULL, 15625, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:17:04', 'admin-1514509445-15145138246569897', 1, 1, 'SR', NULL, NULL, NULL),
(58268, '2017-12-29 10:20:36', NULL, NULL, 15628, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:20:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58269, '2017-12-29 10:20:42', NULL, NULL, 15628, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:20:42', 'admin-1514509445-15145140421208055', 1, 0, '', NULL, NULL, NULL),
(58270, '2017-12-29 10:20:42', NULL, NULL, 15628, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:20:42', 'admin-1514509445-15145140421208055', 1, 1, 'SR', NULL, NULL, NULL),
(58271, '2017-12-29 13:40:13', NULL, NULL, 15644, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1514509445', 'admin', '2017-12-29 13:40:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58272, '2017-12-29 15:03:00', NULL, NULL, 15648, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 15:03:00', 'admin-1514509445-15145309801813993', 1, 0, '', NULL, NULL, NULL),
(58273, '2017-12-29 15:03:00', NULL, NULL, 15648, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 15:03:00', 'admin-1514509445-15145309801813993', 1, 0, '', NULL, NULL, NULL),
(58274, '2017-12-29 15:03:00', NULL, NULL, 15648, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 15:03:00', 'admin-1514509445-15145309801813993', 1, 0, '', NULL, NULL, NULL),
(58275, '2017-12-29 15:02:38', NULL, NULL, 15648, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1514509445', 'admin', '2017-12-29 15:02:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58276, '2017-12-29 10:38:36', NULL, NULL, 15631, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:38:36', 'admin-1514509445-15145151163269775', 1, 1, 'SR', NULL, NULL, NULL),
(58277, '2017-12-29 14:18:48', NULL, NULL, 15645, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 14:18:48', 'admin-1514509445-15145283284072493', 1, 0, '', NULL, NULL, '10.0'),
(58278, '2017-12-29 14:02:35', NULL, NULL, 15645, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 14:02:36', 'admin-1514509445-15145273558625593', 1, 0, '', NULL, NULL, '10.0'),
(58279, '2017-12-29 14:02:35', NULL, NULL, 15645, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 14:02:35', 'admin-1514509445-15145273558625593', 1, 0, '', NULL, NULL, '10.0'),
(58280, '2017-12-29 13:41:09', NULL, NULL, 15636, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 13:41:09', 'admin-1514509445-15145260690472265', 1, 1, 'SR', NULL, NULL, '10.0'),
(58281, '2017-12-29 14:02:23', NULL, NULL, 15645, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.31, 0.0000, 0.0000, 5.31, 1, '27', 1, '1514509445', 'admin', '2017-12-29 14:02:23', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(58282, '2017-12-29 12:48:35', NULL, NULL, 15641, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:48:35', 'admin-1514509445-1514522914904867', 1, 0, '', NULL, NULL, NULL),
(58283, '2017-12-29 13:40:46', NULL, NULL, 15644, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 13:40:46', 'admin-1514509445-15145260464274246', 1, 1, 'SR', NULL, NULL, NULL),
(58284, '2017-12-29 13:40:28', NULL, NULL, 15644, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 13:40:28', 'admin-1514509445-15145260284536537', 1, 1, 'SR', NULL, NULL, NULL),
(58285, '2017-12-29 13:40:28', NULL, NULL, 15644, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 13:40:28', 'admin-1514509445-15145260284536537', 1, 1, 'SR', NULL, NULL, NULL),
(58286, '2017-12-29 13:40:28', NULL, NULL, 15644, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 13:40:28', 'admin-1514509445-15145260284536537', 1, 0, '', NULL, NULL, NULL),
(58287, '2017-12-29 12:40:19', NULL, NULL, 15639, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:40:19', 'admin-1514509445-1514522419493989', 1, 0, '', NULL, NULL, NULL),
(58288, '2017-12-29 15:03:00', NULL, NULL, 15648, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 15:03:00', 'admin-1514509445-15145309801813993', 1, 0, '', NULL, NULL, NULL),
(58289, '2017-12-29 13:40:28', NULL, NULL, 15644, 0, 291, '225', 'Smoked Duck Red Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 13:40:28', 'admin-1514509445-15145260284536537', 1, 0, '', NULL, NULL, NULL),
(58290, '2017-12-29 12:40:19', NULL, NULL, 15639, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:40:19', 'admin-1514509445-1514522419493989', 1, 0, '', NULL, NULL, NULL),
(58291, '2017-12-29 12:37:39', NULL, NULL, 15639, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 15.80, 0.0000, 0.0000, 15.80, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:37:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58292, '2017-12-29 12:36:11', NULL, NULL, 15638, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:36:11', 'admin-1514509445-151452217104874', 1, 0, '', NULL, NULL, NULL),
(58293, '2017-12-29 09:20:56', NULL, NULL, 15622, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:20:56', 'admin-1514509445-15145104561885051', 1, 1, 'SR', NULL, NULL, NULL),
(58294, '2017-12-29 13:28:17', NULL, NULL, 15643, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 13:28:17', 'admin-1514509445-15145252974738052', 1, 0, '', NULL, NULL, NULL),
(58295, '2017-12-29 13:06:14', NULL, NULL, 15642, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1514509445', 'admin', '2017-12-29 13:06:14', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(58296, '2017-12-29 12:36:04', NULL, NULL, 15638, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:36:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58297, '2017-12-29 12:36:11', NULL, NULL, 15638, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:36:11', 'admin-1514509445-151452217104874', 1, 1, 'SR', NULL, NULL, NULL),
(58298, '2017-12-29 12:25:36', NULL, NULL, 15637, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:25:36', 'admin-1514509445-15145215362859072', 1, 0, '', NULL, NULL, NULL),
(58299, '2017-12-29 12:25:36', NULL, NULL, 15637, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:25:36', 'admin-1514509445-15145215362859072', 1, 0, '', NULL, NULL, NULL),
(58300, '2017-12-29 12:25:36', NULL, NULL, 15637, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:25:36', 'admin-1514509445-15145215362859072', 1, 0, '', NULL, NULL, NULL),
(58301, '2017-12-29 12:25:36', NULL, NULL, 15637, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:25:36', 'admin-1514509445-15145215362859072', 1, 0, '', NULL, NULL, NULL),
(58302, '2017-12-29 12:48:35', NULL, NULL, 15641, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:48:35', 'admin-1514509445-1514522914904867', 1, 0, '', NULL, NULL, NULL),
(58303, '2017-12-29 15:20:19', NULL, NULL, 15649, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 15:20:19', 'admin-1514509445-15145320197382548', 1, 0, '', NULL, NULL, NULL),
(58304, '2017-12-29 12:48:35', NULL, NULL, 15641, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:48:35', 'admin-1514509445-1514522914904867', 1, 0, '', NULL, NULL, NULL),
(58305, '2017-12-29 09:18:21', NULL, NULL, 15622, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:18:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58306, '2017-12-29 09:07:58', NULL, NULL, 15621, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:07:58', 'admin-1514509445-15145096782324549', 1, 1, 'SR', NULL, NULL, NULL),
(58307, '2017-12-29 12:48:35', NULL, NULL, 15641, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:48:35', 'admin-1514509445-1514522914904867', 1, 1, 'SR', NULL, NULL, NULL),
(58308, '2017-12-29 12:42:35', NULL, NULL, 15640, 0, 182, '117', 'Open Drinks ', 'banana', 'Cold Drinks', 'Fresh Juice', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:42:35', 'admin-1514509445-15145225552667247', 1, 0, '', 1, NULL, NULL),
(58309, '2017-12-29 15:03:00', NULL, NULL, 15648, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 15:03:00', 'admin-1514509445-15145309801813993', 1, 1, 'SR', NULL, NULL, NULL),
(58310, '2017-12-29 12:40:19', NULL, NULL, 15639, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:40:19', 'admin-1514509445-1514522419493989', 1, 0, '', NULL, NULL, NULL),
(58311, '2017-12-29 12:25:36', NULL, NULL, 15637, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:25:36', 'admin-1514509445-15145215362859072', 1, 1, 'SR', NULL, NULL, NULL),
(58312, '2017-12-29 12:25:36', NULL, NULL, 15637, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:25:36', 'admin-1514509445-15145215362859072', 1, 1, 'SR', NULL, NULL, NULL),
(58313, '2017-12-29 15:02:36', NULL, NULL, 15647, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 15:02:36', 'admin-1514509445-1514530956626191', 1, 1, 'SR', NULL, NULL, '10.0'),
(58314, '2017-12-29 11:40:25', NULL, NULL, 15635, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 11:40:25', 'admin-1514509445-15145188252883318', 1, 1, 'SR', NULL, NULL, NULL),
(58315, '2017-12-29 11:40:25', NULL, NULL, 15635, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 11:40:25', 'admin-1514509445-15145188252883318', 1, 1, 'SR', NULL, NULL, NULL),
(58316, '2017-12-29 11:40:25', NULL, NULL, 15635, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 11:40:25', 'admin-1514509445-15145188252883318', 1, 1, 'SR', NULL, NULL, NULL),
(58317, '2017-12-29 12:40:19', NULL, NULL, 15639, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:40:19', 'admin-1514509445-1514522419493989', 1, 1, 'SR', NULL, NULL, NULL),
(58318, '2017-12-29 12:24:24', NULL, NULL, 15637, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.70, 0.0000, 0.0000, 11.70, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:24:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58319, '2017-12-29 11:40:25', NULL, NULL, 15635, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 11:40:25', 'admin-1514509445-15145188252883318', 1, 1, 'SR', NULL, NULL, NULL),
(58320, '2017-12-29 11:08:25', NULL, NULL, 15633, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 11:08:25', 'admin-1514509445-15145169057051968', 1, 1, 'SR', NULL, NULL, NULL),
(58321, '2017-12-29 10:48:28', NULL, NULL, 15632, 0, 270, '204', 'Homemade Savoury Pancake', 'bacon put aside', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:48:28', 'admin-1514509445-15145157082613457', 1, 0, '', NULL, NULL, NULL),
(58322, '2017-12-29 10:48:28', NULL, NULL, 15632, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:48:28', 'admin-1514509445-15145157082613457', 1, 0, '', NULL, NULL, NULL),
(58323, '2017-12-29 11:08:14', NULL, NULL, 15633, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1514509445', 'admin', '2017-12-29 11:08:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58324, '2017-12-29 10:48:08', NULL, NULL, 15632, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:48:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58325, '2017-12-29 10:38:31', NULL, NULL, 15631, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:38:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58326, '2017-12-29 10:38:36', NULL, NULL, 15631, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:38:36', 'admin-1514509445-15145151163269775', 1, 1, 'SR', NULL, NULL, NULL),
(58327, '2017-12-29 10:34:18', NULL, NULL, 15630, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:34:18', 'admin-1514509445-15145148586219823', 1, 1, 'SR', NULL, NULL, NULL),
(58328, '2017-12-29 10:34:18', NULL, NULL, 15630, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:34:18', 'admin-1514509445-15145148586219823', 1, 1, 'SR', NULL, NULL, NULL),
(58329, '2017-12-29 10:34:18', NULL, NULL, 15630, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:34:18', 'admin-1514509445-15145148586219823', 1, 0, '', NULL, NULL, NULL),
(58330, '2017-12-29 11:53:37', NULL, NULL, 15636, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 11:53:37', 'admin-1514509445-15145196177641460', 1, 0, '', NULL, NULL, '10.0'),
(58331, '2017-12-29 10:34:04', NULL, NULL, 15630, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:34:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58332, '2017-12-29 10:34:18', NULL, NULL, 15630, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:34:18', 'admin-1514509445-15145148586219823', 1, 0, '', NULL, NULL, NULL),
(58333, '2017-12-29 10:07:30', NULL, NULL, 15627, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:07:30', 'admin-1514509445-15145132504783346', 1, 1, 'SR', NULL, NULL, NULL),
(58334, '2017-12-29 09:20:56', NULL, NULL, 15622, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:20:56', 'admin-1514509445-15145104561885051', 1, 0, '', NULL, NULL, NULL),
(58335, '2017-12-29 10:28:51', NULL, NULL, 15629, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:28:51', 'admin-1514509445-15145145312366220', 1, 0, '', NULL, NULL, NULL),
(58336, '2017-12-29 10:28:51', NULL, NULL, 15629, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:28:51', 'admin-1514509445-15145145312366220', 1, 0, '', NULL, NULL, NULL),
(58337, '2017-12-29 09:42:25', NULL, NULL, 15623, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:42:25', 'admin-1514509445-15145117456626469', 1, 0, '', NULL, NULL, NULL),
(58338, '2017-12-29 09:06:08', NULL, NULL, 15621, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:06:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58339, '2017-12-29 09:07:58', NULL, NULL, 15621, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:07:58', 'admin-1514509445-15145096782324549', 1, 0, '', NULL, NULL, NULL),
(58340, '2017-12-29 12:40:19', NULL, NULL, 15639, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:40:19', 'admin-1514509445-1514522419493989', 1, 0, '', NULL, NULL, NULL),
(58341, '2017-12-29 10:26:39', NULL, NULL, 15628, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:26:39', 'admin-1514509445-15145143990443468', 1, 1, 'SR', NULL, NULL, NULL),
(58342, '2017-12-29 12:25:36', NULL, NULL, 15637, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 12:25:36', 'admin-1514509445-15145215362859072', 1, 0, '', NULL, NULL, NULL),
(58343, '2017-12-29 10:07:30', NULL, NULL, 15627, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:07:30', 'admin-1514509445-15145132504783346', 1, 0, '', NULL, NULL, NULL),
(58344, '2017-12-29 10:01:02', NULL, NULL, 15626, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 3.50, 3.5000, 0.0000, 3.50, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:01:02', 'admin-1514509445-15145128626828511', 1, 0, '', 1, NULL, NULL),
(58345, '2017-12-29 10:01:02', NULL, NULL, 15626, 0, 264, '198', 'PostCard', '', 'DISCOUNT ', '0', 1, 3.50, 3.5000, 0.0000, 3.50, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:01:02', 'admin-1514509445-15145128626828511', 1, 0, '', 1, NULL, NULL),
(58346, '2017-12-29 10:07:23', NULL, NULL, 15627, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:07:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58347, '2017-12-29 09:49:53', NULL, NULL, 15624, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:49:53', 'admin-1514509445-15145121935715651', 1, 1, 'SR', NULL, NULL, NULL),
(58348, '2017-12-29 09:49:53', NULL, NULL, 15624, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:49:53', 'admin-1514509445-15145121935715651', 1, 0, '', NULL, NULL, NULL),
(58349, '2017-12-29 09:42:25', NULL, NULL, 15623, 0, 181, '116', 'Open Food ', 'add cheese', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:42:25', 'admin-1514509445-15145117456626469', 1, 0, '', NULL, NULL, NULL),
(58350, '2017-12-29 09:49:53', NULL, NULL, 15624, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:49:53', 'admin-1514509445-15145121935715651', 1, 0, '', NULL, NULL, NULL),
(58351, '2017-12-29 09:49:40', NULL, NULL, 15624, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:49:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58352, '2017-12-29 09:42:25', NULL, NULL, 15623, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:42:25', 'admin-1514509445-15145117456626469', 1, 0, '', NULL, NULL, NULL),
(58353, '2017-12-29 09:42:25', NULL, NULL, 15623, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:42:25', 'admin-1514509445-15145117456626469', 1, 0, '', NULL, NULL, NULL),
(58354, '2017-12-29 09:42:25', NULL, NULL, 15623, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:42:25', 'admin-1514509445-15145117456626469', 1, 1, 'SR', NULL, NULL, NULL),
(58355, '2017-12-29 09:34:49', NULL, NULL, 15623, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.40, 0.0000, 0.0000, 11.40, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:34:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58356, '2017-12-29 10:28:51', NULL, NULL, 15629, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 10:28:51', 'admin-1514509445-15145145312366220', 1, 0, '', NULL, NULL, NULL),
(58357, '2017-12-29 09:42:25', NULL, NULL, 15623, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:42:25', 'admin-1514509445-15145117456626469', 1, 1, 'SR', NULL, NULL, NULL),
(58358, '2017-12-29 11:40:03', NULL, NULL, 15635, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1514509445', 'admin', '2017-12-29 11:40:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58359, '2017-12-29 09:20:56', NULL, NULL, 15622, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:20:56', 'admin-1514509445-15145104561885051', 1, 1, 'SR', NULL, NULL, NULL),
(58360, '2017-12-29 09:20:56', NULL, NULL, 15622, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:20:56', 'admin-1514509445-15145104561885051', 1, 1, 'SR', NULL, NULL, NULL),
(58361, '2017-12-29 09:20:56', NULL, NULL, 15622, 0, 181, '116', 'Open Food ', '2 hard boil egg', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:20:56', 'admin-1514509445-15145104561885051', 1, 0, '', NULL, NULL, NULL),
(58362, '2017-12-29 09:07:58', NULL, NULL, 15621, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:07:58', 'admin-1514509445-15145096782324549', 1, 0, '', NULL, NULL, NULL),
(58363, '2017-12-29 09:20:56', NULL, NULL, 15622, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:20:56', 'admin-1514509445-15145104561885051', 1, 0, '', NULL, NULL, NULL),
(58364, '2017-12-29 09:07:58', NULL, NULL, 15621, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514509445', 'admin', '2017-12-29 09:07:58', 'admin-1514509445-15145096782324549', 1, 0, '', NULL, NULL, NULL),
(58365, '2017-12-30 14:14:07', NULL, NULL, 15681, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:14:07', 'admin-1514595837-15146144477602095', 1, 0, '', NULL, NULL, NULL),
(58366, '2017-12-30 14:14:07', NULL, NULL, 15681, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:14:07', 'admin-1514595837-15146144477602095', 1, 0, '', NULL, NULL, NULL),
(58367, '2017-12-30 14:13:37', NULL, NULL, 15681, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.60, 0.0000, 0.0000, 10.60, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:13:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58368, '2017-12-30 14:06:50', NULL, NULL, 15680, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:06:50', 'admin-1514595837-15146140101951986', 1, 1, 'SR', NULL, NULL, NULL),
(58369, '2017-12-30 14:06:50', NULL, NULL, 15680, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:06:50', 'admin-1514595837-15146140101951986', 1, 1, 'SR', NULL, NULL, NULL),
(58370, '2017-12-30 09:37:31', NULL, NULL, 15660, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:37:31', 'admin-1514595837-15145978512018329', 1, 0, '', NULL, NULL, NULL),
(58371, '2017-12-30 09:37:31', NULL, NULL, 15660, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:37:31', 'admin-1514595837-15145978512018329', 1, 1, 'SR', NULL, NULL, NULL),
(58372, '2017-12-30 14:28:57', NULL, NULL, 15685, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:28:57', 'admin-1514595837-15146153377357416', 1, 0, '', NULL, NULL, NULL),
(58373, '2017-12-30 14:28:31', NULL, NULL, 15685, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:28:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58374, '2017-12-30 14:23:30', NULL, NULL, 15684, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:23:30', 'admin-1514595837-1514615010270674', 1, 0, '', NULL, NULL, NULL),
(58375, '2017-12-30 14:23:30', NULL, NULL, 15684, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:23:30', 'admin-1514595837-1514615010270674', 1, 1, 'SR', NULL, NULL, NULL),
(58376, '2017-12-30 14:23:30', NULL, NULL, 15684, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:23:30', 'admin-1514595837-1514615010270674', 1, 1, 'SR', NULL, NULL, NULL),
(58377, '2017-12-30 14:23:16', NULL, NULL, 15684, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:23:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58378, '2017-12-30 14:22:53', NULL, NULL, 15683, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:22:53', 'admin-1514595837-1514614973006926', 1, 0, '', NULL, NULL, NULL),
(58379, '2017-12-30 14:22:53', NULL, NULL, 15683, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:22:53', 'admin-1514595837-1514614973006926', 1, 0, '', NULL, NULL, NULL),
(58380, '2017-12-30 14:22:45', NULL, NULL, 15683, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:22:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58381, '2017-12-30 14:21:43', NULL, NULL, 15682, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:21:43', 'admin-1514595837-15146149030687376', 1, 1, 'SR', NULL, NULL, NULL),
(58382, '2017-12-30 14:54:41', NULL, NULL, 15683, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:54:41', 'admin-1514595837-15146168813839422', 1, 1, 'SR', NULL, NULL, NULL),
(58383, '2017-12-30 14:54:41', NULL, NULL, 15683, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:54:41', 'admin-1514595837-15146168813839422', 1, 0, '', NULL, NULL, NULL),
(58384, '2017-12-30 15:03:16', NULL, NULL, 15686, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1514595837', 'admin', '2017-12-30 15:03:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58385, '2017-12-30 15:03:22', NULL, NULL, 15686, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 15:03:22', 'admin-1514595837-1514617402679747', 1, 0, '', NULL, NULL, NULL),
(58386, '2017-12-30 15:03:22', NULL, NULL, 15686, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 15:03:22', 'admin-1514595837-1514617402679747', 1, 0, '', NULL, NULL, NULL),
(58387, '2017-12-30 13:24:47', NULL, NULL, 15678, 0, 32, '32', 'Tea By Pot ', 'ginger', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:24:47', 'admin-1514595837-15146114874808741', 1, 1, 'SR', NULL, NULL, NULL),
(58388, '2017-12-30 14:06:50', NULL, NULL, 15680, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:06:50', 'admin-1514595837-15146140101951986', 1, 1, 'SR', NULL, NULL, NULL),
(58389, '2017-12-30 12:57:20', NULL, NULL, 15673, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 12:57:20', 'admin-1514595837-15146098406961562', 1, 0, '', NULL, NULL, NULL),
(58390, '2017-12-30 12:57:20', NULL, NULL, 15673, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 12:57:20', 'admin-1514595837-15146098406961562', 1, 1, 'SR', NULL, NULL, NULL),
(58391, '2017-12-30 12:57:20', NULL, NULL, 15673, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 12:57:20', 'admin-1514595837-15146098406961562', 1, 1, 'SR', NULL, NULL, NULL),
(58392, '2017-12-30 13:10:22', NULL, NULL, 15674, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:10:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58393, '2017-12-30 16:26:37', NULL, NULL, 15692, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 16:26:37', 'admin-1514595837-15146223976977870', 1, 0, '', NULL, NULL, NULL),
(58394, '2017-12-30 16:26:37', NULL, NULL, 15692, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 16:26:37', 'admin-1514595837-15146223976977870', 1, 0, '', NULL, NULL, NULL),
(58395, '2017-12-30 16:33:10', NULL, NULL, 15692, 0, 322, '258', 'Yuzu Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 16:33:10', 'admin-1514595837-15146227899914899', 1, 0, '', NULL, NULL, NULL),
(58396, '2017-12-30 14:06:50', NULL, NULL, 15680, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:06:50', 'admin-1514595837-15146140101951986', 1, 1, 'SR', NULL, NULL, NULL),
(58397, '2017-12-30 14:06:36', NULL, NULL, 15680, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:06:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58398, '2017-12-30 13:52:41', NULL, NULL, 15679, 0, 181, '116', 'Open Food ', '2 toast with butter', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:52:41', 'admin-1514595837-15146131610114689', 1, 0, '', NULL, NULL, NULL),
(58399, '2017-12-30 16:06:54', NULL, NULL, 15691, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1514595837', 'admin', '2017-12-30 16:06:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58400, '2017-12-30 16:08:11', NULL, NULL, 15691, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 16:08:11', 'admin-1514595837-15146212916708830', 1, 0, '', NULL, NULL, NULL),
(58401, '2017-12-30 16:08:11', NULL, NULL, 15691, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 16:08:11', 'admin-1514595837-15146212916708830', 1, 0, '', NULL, NULL, NULL),
(58402, '2017-12-30 15:06:46', NULL, NULL, 15687, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 15:06:46', 'admin-1514595837-15146176066547154', 1, 0, '', NULL, NULL, NULL),
(58403, '2017-12-30 13:25:48', NULL, NULL, 15676, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:25:48', 'admin-1514595837-151461154840284', 1, 0, '', NULL, NULL, '10.0'),
(58404, '2017-12-30 11:04:53', NULL, NULL, 15670, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1514595837', 'admin', '2017-12-30 11:04:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58405, '2017-12-30 11:05:03', NULL, NULL, 15670, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 11:05:03', 'admin-1514595837-15146031037438662', 1, 1, 'SR', NULL, NULL, NULL),
(58406, '2017-12-30 11:05:03', NULL, NULL, 15670, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 11:05:03', 'admin-1514595837-15146031037438662', 1, 1, 'SR', NULL, NULL, NULL),
(58407, '2017-12-30 11:05:22', NULL, NULL, 15671, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 11:05:22', 'admin-1514595837-15146031221409485', 1, 0, '', 1, NULL, NULL),
(58408, '2017-12-30 14:14:07', NULL, NULL, 15681, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:14:07', 'admin-1514595837-15146144477602095', 1, 0, '', NULL, NULL, NULL),
(58409, '2017-12-30 14:14:07', NULL, NULL, 15681, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:14:07', 'admin-1514595837-15146144477602095', 1, 0, '', NULL, NULL, NULL),
(58410, '2017-12-30 14:14:07', NULL, NULL, 15681, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:14:07', 'admin-1514595837-15146144477602095', 1, 0, '', NULL, NULL, NULL),
(58411, '2017-12-30 14:21:35', NULL, NULL, 15682, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:21:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58412, '2017-12-30 14:28:57', NULL, NULL, 15685, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:28:57', 'admin-1514595837-15146153377357416', 1, 0, '', NULL, NULL, NULL),
(58413, '2017-12-30 13:48:36', NULL, NULL, 15679, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:48:36', 'admin-1514595837-15146129163334637', 1, 0, '', NULL, NULL, NULL),
(58414, '2017-12-30 15:30:12', NULL, NULL, 15688, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 15:30:12', 'admin-1514595837-15146190120046922', 1, 1, 'SR', NULL, NULL, NULL),
(58415, '2017-12-30 15:33:38', NULL, NULL, 15689, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1514595837', 'admin', '2017-12-30 15:33:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58416, '2017-12-30 15:33:46', NULL, NULL, 15689, 0, 304, '240', 'Banana is On Fire', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 15:33:46', 'admin-1514595837-15146192264389145', 1, 0, '', NULL, NULL, NULL),
(58417, '2017-12-30 15:33:46', NULL, NULL, 15689, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 15:33:46', 'admin-1514595837-15146192264389145', 1, 0, '', NULL, NULL, NULL),
(58418, '2017-12-30 14:28:57', NULL, NULL, 15685, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:28:57', 'admin-1514595837-15146153377357416', 1, 0, '', NULL, NULL, NULL),
(58419, '2017-12-30 10:03:40', NULL, NULL, 15663, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:03:40', 'admin-1514595837-15145994201808665', 1, 0, '', NULL, NULL, NULL),
(58420, '2017-12-30 10:03:40', NULL, NULL, 15663, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:03:40', 'admin-1514595837-15145994201808665', 1, 1, 'SR', NULL, NULL, NULL),
(58421, '2017-12-30 10:03:40', NULL, NULL, 15663, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:03:40', 'admin-1514595837-15145994201808665', 1, 1, 'SR', NULL, NULL, NULL),
(58422, '2017-12-30 09:33:19', NULL, NULL, 15658, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:33:19', 'admin-1514595837-1514597599544271', 1, 1, 'SR', NULL, NULL, '10.0');
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(58423, '2017-12-30 09:33:19', NULL, NULL, 15658, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:33:19', 'admin-1514595837-1514597599544271', 1, 1, 'SR', NULL, NULL, '10.0'),
(58424, '2017-12-30 09:35:36', NULL, NULL, 15657, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:35:36', 'admin-1514595837-15145977362725295', 1, 0, '', NULL, NULL, NULL),
(58425, '2017-12-30 10:32:17', NULL, NULL, 15667, 0, 338, '274', 'Chocolate Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:32:17', 'admin-1514595837-15146011371183212', 1, 0, '', NULL, NULL, NULL),
(58426, '2017-12-30 10:32:17', NULL, NULL, 15667, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:32:17', 'admin-1514595837-15146011371183212', 1, 1, 'SR', NULL, NULL, NULL),
(58427, '2017-12-30 10:32:17', NULL, NULL, 15667, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:32:17', 'admin-1514595837-15146011371183212', 1, 1, 'SR', NULL, NULL, NULL),
(58428, '2017-12-30 13:25:48', NULL, NULL, 15676, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:25:48', 'admin-1514595837-151461154840284', 1, 0, '', NULL, NULL, '10.0'),
(58429, '2017-12-30 13:24:47', NULL, NULL, 15678, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:24:47', 'admin-1514595837-15146114874808741', 1, 0, '', NULL, NULL, NULL),
(58430, '2017-12-30 13:19:31', NULL, NULL, 15676, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:19:31', 'admin-1514595837-15146111711035039', 1, 0, '', NULL, NULL, '10.0'),
(58431, '2017-12-30 10:03:40', NULL, NULL, 15663, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:03:40', 'admin-1514595837-15145994201808665', 1, 1, 'SR', NULL, NULL, NULL),
(58432, '2017-12-30 16:41:01', NULL, NULL, 15691, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 16:41:01', 'admin-1514595837-15146232616926847', 1, 1, 'SR', NULL, NULL, NULL),
(58433, '2017-12-30 13:34:18', NULL, NULL, 15677, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:34:18', 'admin-1514595837-15146120587647646', 1, 0, '', NULL, NULL, NULL),
(58434, '2017-12-30 13:23:44', NULL, NULL, 15677, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:23:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58435, '2017-12-30 10:15:48', NULL, NULL, 15665, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:15:48', 'admin-1514595837-15146001478792195', 1, 0, '', NULL, NULL, NULL),
(58436, '2017-12-30 13:24:47', NULL, NULL, 15678, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:24:47', 'admin-1514595837-15146114874808741', 1, 0, '', NULL, NULL, NULL),
(58437, '2017-12-30 10:48:34', NULL, NULL, 15668, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:48:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58438, '2017-12-30 10:49:05', NULL, NULL, 15668, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:49:05', 'admin-1514595837-15146021453282270', 1, 0, '', NULL, NULL, NULL),
(58439, '2017-12-30 10:49:05', NULL, NULL, 15668, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:49:05', 'admin-1514595837-15146021453282270', 1, 1, 'SR', NULL, NULL, NULL),
(58440, '2017-12-30 13:24:47', NULL, NULL, 15678, 0, 32, '32', 'Tea By Pot ', 'peppermint', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:24:47', 'admin-1514595837-15146114874808741', 1, 1, 'SR', NULL, NULL, NULL),
(58441, '2017-12-30 11:12:52', NULL, NULL, 15672, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 11:12:52', 'admin-1514595837-15146035727766978', 1, 1, 'SR', 1, NULL, '10.0'),
(58442, '2017-12-30 12:57:01', NULL, NULL, 15673, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1514595837', 'admin', '2017-12-30 12:57:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58443, '2017-12-30 12:57:20', NULL, NULL, 15673, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 12:57:20', 'admin-1514595837-15146098406961562', 1, 0, '', NULL, NULL, NULL),
(58444, '2017-12-30 12:57:20', NULL, NULL, 15673, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 12:57:20', 'admin-1514595837-15146098406961562', 1, 0, '', NULL, NULL, NULL),
(58445, '2017-12-30 12:57:20', NULL, NULL, 15673, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 12:57:20', 'admin-1514595837-15146098406961562', 1, 1, 'SR', NULL, NULL, NULL),
(58446, '2017-12-30 16:41:12', NULL, NULL, 15693, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 16:41:12', 'admin-1514595837-15146232724992342', 1, 1, 'SR', NULL, NULL, NULL),
(58447, '2017-12-30 09:22:12', NULL, NULL, 15655, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:22:12', 'admin-1514595837-15145969324704929', 1, 1, 'SR', NULL, NULL, NULL),
(58448, '2017-12-30 09:22:12', NULL, NULL, 15655, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:22:12', 'admin-1514595837-15145969324704929', 1, 1, 'SR', NULL, NULL, NULL),
(58449, '2017-12-30 16:41:06', NULL, NULL, 15693, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1514595837', 'admin', '2017-12-30 16:41:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58450, '2017-12-30 13:23:55', NULL, NULL, 15677, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:23:55', 'admin-1514595837-15146114353768071', 1, 0, '', NULL, NULL, NULL),
(58451, '2017-12-30 13:10:42', NULL, NULL, 15674, 0, 336, '272', 'iced Yuzu', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:10:42', 'admin-1514595837-15146106421294442', 1, 0, '', NULL, NULL, NULL),
(58452, '2017-12-30 13:14:55', NULL, NULL, 15675, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.60, 0.0000, 0.0000, 13.60, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:14:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58453, '2017-12-30 13:15:45', NULL, NULL, 15675, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:15:45', 'admin-1514595837-1514610944986231', 1, 0, '', NULL, NULL, NULL),
(58454, '2017-12-30 15:30:12', NULL, NULL, 15688, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 15:30:12', 'admin-1514595837-15146190120046922', 1, 1, 'SR', NULL, NULL, NULL),
(58455, '2017-12-30 09:35:36', NULL, NULL, 15657, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:35:36', 'admin-1514595837-15145977362725295', 1, 0, '', NULL, NULL, NULL),
(58456, '2017-12-30 09:35:36', NULL, NULL, 15657, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:35:36', 'admin-1514595837-15145977362725295', 1, 1, 'SR', NULL, NULL, NULL),
(58457, '2017-12-30 09:35:36', NULL, NULL, 15657, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:35:36', 'admin-1514595837-15145977362725295', 1, 1, 'SR', NULL, NULL, NULL),
(58458, '2017-12-30 13:48:36', NULL, NULL, 15679, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:48:36', 'admin-1514595837-15146129163334637', 1, 1, 'SR', NULL, NULL, NULL),
(58459, '2017-12-30 13:23:55', NULL, NULL, 15677, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:23:55', 'admin-1514595837-15146114353768071', 1, 0, '', NULL, NULL, NULL),
(58460, '2017-12-30 10:26:27', NULL, NULL, 15666, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:26:27', 'admin-1514595837-15146007872567275', 1, 0, '', NULL, NULL, NULL),
(58461, '2017-12-30 10:26:27', NULL, NULL, 15666, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:26:27', 'admin-1514595837-15146007872567275', 1, 0, '', NULL, NULL, NULL),
(58462, '2017-12-30 10:27:17', NULL, NULL, 15666, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:27:17', 'admin-1514595837-15146008377883387', 1, 1, 'SR', NULL, NULL, NULL),
(58463, '2017-12-30 10:27:17', NULL, NULL, 15666, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:27:17', 'admin-1514595837-15146008377883387', 1, 0, '', NULL, NULL, NULL),
(58464, '2017-12-30 16:35:42', NULL, NULL, 15692, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 16:35:42', 'admin-1514595837-15146229421097438', 1, 1, 'SR', NULL, NULL, NULL),
(58465, '2017-12-30 16:33:10', NULL, NULL, 15692, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 16:33:10', 'admin-1514595837-15146227899914899', 1, 1, 'SR', NULL, NULL, NULL),
(58466, '2017-12-30 16:26:21', NULL, NULL, 15692, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1514595837', 'admin', '2017-12-30 16:26:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58467, '2017-12-30 16:08:11', NULL, NULL, 15691, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 16:08:11', 'admin-1514595837-15146212916708830', 1, 0, '', NULL, NULL, NULL),
(58468, '2017-12-30 15:30:02', NULL, NULL, 15688, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1514595837', 'admin', '2017-12-30 15:30:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58469, '2017-12-30 09:35:50', NULL, NULL, 15659, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:35:50', 'admin-1514595837-15145977500378410', 1, 0, '', NULL, NULL, NULL),
(58470, '2017-12-30 14:45:38', NULL, NULL, 15680, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:45:38', 'admin-1514595837-1514616338057520', 1, 1, 'SR', NULL, NULL, NULL),
(58471, '2017-12-30 14:50:20', NULL, NULL, 15681, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:50:20', 'admin-1514595837-15146166205189946', 1, 0, '', NULL, NULL, NULL),
(58472, '2017-12-30 14:50:20', NULL, NULL, 15681, 0, 325, '261', 'Strawberry Chocolate Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:50:20', 'admin-1514595837-15146166205189946', 1, 0, '', NULL, NULL, NULL),
(58473, '2017-12-30 15:06:46', NULL, NULL, 15687, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 15:06:46', 'admin-1514595837-15146176066547154', 1, 0, '', NULL, NULL, NULL),
(58474, '2017-12-30 15:06:46', NULL, NULL, 15687, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 15:06:46', 'admin-1514595837-15146176066547154', 1, 1, 'SR', NULL, NULL, NULL),
(58475, '2017-12-30 14:54:41', NULL, NULL, 15683, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:54:41', 'admin-1514595837-15146168813839422', 1, 1, 'SR', NULL, NULL, NULL),
(58476, '2017-12-30 13:19:31', NULL, NULL, 15676, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:19:31', 'admin-1514595837-15146111711035039', 1, 1, 'SR', NULL, NULL, '10.0'),
(58477, '2017-12-30 14:28:57', NULL, NULL, 15685, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:28:57', 'admin-1514595837-15146153377357416', 1, 0, '', NULL, NULL, NULL),
(58478, '2017-12-30 13:19:31', NULL, NULL, 15676, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:19:31', 'admin-1514595837-15146111711035039', 1, 0, '', NULL, NULL, '10.0'),
(58479, '2017-12-30 13:19:31', NULL, NULL, 15676, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:19:31', 'admin-1514595837-15146111711035039', 1, 1, 'SR', NULL, NULL, '10.0'),
(58480, '2017-12-30 14:28:57', NULL, NULL, 15685, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:28:57', 'admin-1514595837-15146153377357416', 1, 1, 'SR', NULL, NULL, NULL),
(58481, '2017-12-30 09:51:50', NULL, NULL, 15661, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:51:50', 'admin-1514595837-15145987101999964', 1, 1, 'SR', NULL, NULL, NULL),
(58482, '2017-12-30 10:02:03', NULL, NULL, 15662, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:02:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58483, '2017-12-30 09:51:50', NULL, NULL, 15661, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:51:50', 'admin-1514595837-15145987101999964', 1, 1, 'SR', NULL, NULL, NULL),
(58484, '2017-12-30 13:19:31', NULL, NULL, 15676, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:19:31', 'admin-1514595837-15146111711035039', 1, 0, '', NULL, NULL, '10.0'),
(58485, '2017-12-30 13:18:53', NULL, NULL, 15676, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.60, 0.0000, 0.0000, 10.60, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:18:53', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(58486, '2017-12-30 13:17:20', NULL, NULL, 15675, 0, 31, '31', 'Iced Matcha Latte', 'less ice', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:17:20', 'admin-1514595837-15146110398617683', 1, 1, 'SR', NULL, NULL, NULL),
(58487, '2017-12-30 13:16:04', NULL, NULL, 15675, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:16:04', 'admin-1514595837-15146109641372218', 1, 0, '', NULL, NULL, NULL),
(58488, '2017-12-30 13:16:04', NULL, NULL, 15675, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:16:04', 'admin-1514595837-15146109641372218', 1, 1, 'SR', NULL, NULL, NULL),
(58489, '2017-12-30 13:16:04', NULL, NULL, 15675, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:16:04', 'admin-1514595837-15146109641372218', 1, 1, 'SR', NULL, NULL, NULL),
(58490, '2017-12-30 13:10:42', NULL, NULL, 15674, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:10:42', 'admin-1514595837-15146106421294442', 1, 0, '', NULL, NULL, NULL),
(58491, '2017-12-30 10:32:17', NULL, NULL, 15667, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:32:17', 'admin-1514595837-15146011371183212', 1, 0, '', NULL, NULL, NULL),
(58492, '2017-12-30 13:15:45', NULL, NULL, 15675, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:15:45', 'admin-1514595837-1514610944986231', 1, 0, '', NULL, NULL, NULL),
(58493, '2017-12-30 13:15:45', NULL, NULL, 15675, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:15:45', 'admin-1514595837-1514610944986231', 1, 0, '', NULL, NULL, NULL),
(58494, '2017-12-30 13:15:45', NULL, NULL, 15675, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:15:45', 'admin-1514595837-1514610944986231', 1, 0, '', NULL, NULL, NULL),
(58495, '2017-12-30 13:10:42', NULL, NULL, 15674, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:10:42', 'admin-1514595837-15146106421294442', 1, 1, 'SR', NULL, NULL, NULL),
(58496, '2017-12-30 13:10:42', NULL, NULL, 15674, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:10:42', 'admin-1514595837-15146106421294442', 1, 1, 'SR', NULL, NULL, NULL),
(58497, '2017-12-30 13:10:42', NULL, NULL, 15674, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:10:42', 'admin-1514595837-15146106421294442', 1, 0, '', NULL, NULL, NULL),
(58498, '2017-12-30 13:10:42', NULL, NULL, 15674, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:10:42', 'admin-1514595837-15146106421294442', 1, 1, 'SR', NULL, NULL, NULL),
(58499, '2017-12-30 13:10:42', NULL, NULL, 15674, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:10:42', 'admin-1514595837-15146106421294442', 1, 1, 'SR', NULL, NULL, NULL),
(58500, '2017-12-30 09:35:50', NULL, NULL, 15659, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:35:50', 'admin-1514595837-15145977500378410', 1, 1, 'SR', NULL, NULL, NULL),
(58501, '2017-12-30 09:37:16', NULL, NULL, 15660, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:37:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58502, '2017-12-30 09:25:51', NULL, NULL, 15656, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:25:51', 'admin-1514595837-15145971509304738', 1, 1, 'SR', NULL, NULL, NULL),
(58503, '2017-12-30 10:03:40', NULL, NULL, 15663, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:03:40', 'admin-1514595837-15145994201808665', 1, 1, 'SR', NULL, NULL, NULL),
(58504, '2017-12-30 09:25:35', NULL, NULL, 15656, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:25:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58505, '2017-12-30 09:22:12', NULL, NULL, 15655, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:22:12', 'admin-1514595837-15145969324704929', 1, 0, '', NULL, NULL, NULL),
(58506, '2017-12-30 09:22:12', NULL, NULL, 15655, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:22:12', 'admin-1514595837-15145969324704929', 1, 0, '', NULL, NULL, NULL),
(58507, '2017-12-30 10:49:05', NULL, NULL, 15668, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:49:05', 'admin-1514595837-15146021453282270', 1, 1, 'SR', NULL, NULL, NULL),
(58508, '2017-12-30 11:03:32', NULL, NULL, 15669, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1514595837', 'admin', '2017-12-30 11:03:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58509, '2017-12-30 11:03:36', NULL, NULL, 15669, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 11:03:36', 'admin-1514595837-15146030163418044', 1, 1, 'SR', NULL, NULL, NULL),
(58510, '2017-12-30 15:34:00', NULL, NULL, 15689, 0, 181, '116', 'Open Food ', ' chocolate,Banana is on fire', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 15:34:00', 'admin-1514595837-15146192398934639', 1, 0, '', NULL, NULL, NULL),
(58511, '2017-12-30 10:32:17', NULL, NULL, 15667, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:32:17', 'admin-1514595837-15146011371183212', 1, 1, 'SR', NULL, NULL, NULL),
(58512, '2017-12-30 10:32:17', NULL, NULL, 15667, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:32:17', 'admin-1514595837-15146011371183212', 1, 0, '', NULL, NULL, NULL),
(58513, '2017-12-30 09:10:22', NULL, NULL, 15653, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:10:22', 'admin-1514595837-15145962222109359', 1, 0, '', NULL, NULL, NULL),
(58514, '2017-12-30 09:17:50', NULL, NULL, 15653, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:17:50', 'admin-1514595837-15145966701324633', 1, 0, '', NULL, NULL, NULL),
(58515, '2017-12-30 10:31:46', NULL, NULL, 15667, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.90, 0.0000, 0.0000, 10.90, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:31:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58516, '2017-12-30 10:28:35', NULL, NULL, 15663, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:28:35', 'admin-1514595837-15146009154684094', 1, 0, '', NULL, NULL, NULL),
(58517, '2017-12-30 10:15:48', NULL, NULL, 15665, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:15:48', 'admin-1514595837-15146001478792195', 1, 0, '', NULL, NULL, NULL),
(58518, '2017-12-30 10:11:37', NULL, NULL, 15662, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:11:37', 'admin-1514595837-15145998972715568', 1, 0, '', NULL, NULL, NULL),
(58519, '2017-12-30 10:11:37', NULL, NULL, 15662, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:11:37', 'admin-1514595837-15145998972715568', 1, 1, 'SR', NULL, NULL, NULL),
(58520, '2017-12-30 10:15:26', NULL, NULL, 15665, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:15:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58521, '2017-12-30 15:06:28', NULL, NULL, 15687, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1514595837', 'admin', '2017-12-30 15:06:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58522, '2017-12-30 10:32:17', NULL, NULL, 15667, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:32:17', 'admin-1514595837-15146011371183212', 1, 0, '', NULL, NULL, NULL),
(58523, '2017-12-30 10:26:18', NULL, NULL, 15666, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:26:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58524, '2017-12-30 10:11:37', NULL, NULL, 15662, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:11:37', 'admin-1514595837-15145998972715568', 1, 0, '', NULL, NULL, NULL),
(58525, '2017-12-30 10:06:29', NULL, NULL, 15663, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:06:29', 'admin-1514595837-1514599589540529', 1, 0, '', NULL, NULL, NULL),
(58526, '2017-12-30 10:05:15', NULL, NULL, 15663, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:05:15', 'admin-1514595837-15145995156741237', 1, 0, '', NULL, NULL, NULL),
(58527, '2017-12-30 16:26:37', NULL, NULL, 15692, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 16:26:37', 'admin-1514595837-15146223976977870', 1, 0, '', NULL, NULL, NULL),
(58528, '2017-12-30 13:48:36', NULL, NULL, 15679, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:48:36', 'admin-1514595837-15146129163334637', 1, 0, '', NULL, NULL, NULL),
(58529, '2017-12-30 10:03:40', NULL, NULL, 15663, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:03:40', 'admin-1514595837-15145994201808665', 1, 1, 'SR', NULL, NULL, NULL),
(58530, '2017-12-30 09:22:12', NULL, NULL, 15655, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:22:12', 'admin-1514595837-15145969324704929', 1, 0, '', NULL, NULL, NULL),
(58531, '2017-12-30 14:06:50', NULL, NULL, 15680, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 14:06:50', 'admin-1514595837-15146140101951986', 1, 1, 'SR', NULL, NULL, NULL),
(58532, '2017-12-30 10:03:40', NULL, NULL, 15663, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:03:40', 'admin-1514595837-15145994201808665', 1, 0, '', NULL, NULL, NULL),
(58533, '2017-12-30 10:03:40', NULL, NULL, 15663, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:03:40', 'admin-1514595837-15145994201808665', 1, 0, '', NULL, NULL, NULL),
(58534, '2017-12-30 10:03:40', NULL, NULL, 15663, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:03:40', 'admin-1514595837-15145994201808665', 1, 0, '', NULL, NULL, NULL),
(58535, '2017-12-30 10:03:40', NULL, NULL, 15663, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:03:40', 'admin-1514595837-15145994201808665', 1, 0, '', NULL, NULL, NULL),
(58536, '2017-12-30 10:03:40', NULL, NULL, 15663, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:03:40', 'admin-1514595837-15145994201808665', 1, 0, '', NULL, NULL, NULL),
(58537, '2017-12-30 10:02:16', NULL, NULL, 15663, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 18.55, 0.0000, 0.0000, 18.55, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:02:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58538, '2017-12-30 09:37:31', NULL, NULL, 15660, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:37:31', 'admin-1514595837-15145978512018329', 1, 0, '', NULL, NULL, NULL),
(58539, '2017-12-30 09:51:50', NULL, NULL, 15661, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:51:50', 'admin-1514595837-15145987101999964', 1, 1, 'SR', NULL, NULL, NULL),
(58540, '2017-12-30 09:51:50', NULL, NULL, 15661, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:51:50', 'admin-1514595837-15145987101999964', 1, 0, '', NULL, NULL, NULL),
(58541, '2017-12-30 09:51:50', NULL, NULL, 15661, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:51:50', 'admin-1514595837-15145987101999964', 1, 0, '', NULL, NULL, NULL),
(58542, '2017-12-30 09:29:28', NULL, NULL, 15657, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:29:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58543, '2017-12-30 09:51:50', NULL, NULL, 15661, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:51:50', 'admin-1514595837-15145987101999964', 1, 0, '', NULL, NULL, NULL),
(58544, '2017-12-30 09:51:50', NULL, NULL, 15661, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:51:50', 'admin-1514595837-15145987101999964', 1, 0, '', NULL, NULL, NULL),
(58545, '2017-12-30 13:24:02', NULL, NULL, 15678, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:24:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58546, '2017-12-30 09:51:50', NULL, NULL, 15661, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:51:50', 'admin-1514595837-15145987101999964', 1, 0, '', NULL, NULL, NULL),
(58547, '2017-12-30 09:51:50', NULL, NULL, 15661, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:51:50', 'admin-1514595837-15145987101999964', 1, 0, '', NULL, NULL, NULL),
(58548, '2017-12-30 09:51:16', NULL, NULL, 15661, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.30, 0.0000, 0.0000, 12.30, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:51:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58549, '2017-12-30 13:53:56', NULL, NULL, 15675, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:53:56', 'admin-1514595837-15146132368084675', 1, 0, '', NULL, NULL, NULL),
(58550, '2017-12-30 13:48:24', NULL, NULL, 15679, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1514595837', 'admin', '2017-12-30 13:48:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58551, '2017-12-30 09:25:51', NULL, NULL, 15656, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:25:51', 'admin-1514595837-15145971509304738', 1, 0, '', NULL, NULL, NULL),
(58552, '2017-12-30 09:17:50', NULL, NULL, 15653, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:17:50', 'admin-1514595837-15145966701324633', 1, 0, '', NULL, NULL, NULL),
(58553, '2017-12-30 09:45:15', NULL, NULL, 15656, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:45:15', 'admin-1514595837-15145983154721240', 1, 0, '', NULL, NULL, NULL),
(58554, '2017-12-30 09:35:36', NULL, NULL, 15657, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:35:36', 'admin-1514595837-15145977362725295', 1, 1, 'SR', NULL, NULL, NULL),
(58555, '2017-12-30 09:35:39', NULL, NULL, 15659, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:35:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58556, '2017-12-30 09:35:50', NULL, NULL, 15659, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:35:50', 'admin-1514595837-15145977500378410', 1, 0, '', NULL, NULL, NULL),
(58557, '2017-12-30 09:07:11', NULL, NULL, 15652, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:07:11', 'admin-1514595837-15145960314658280', 1, 1, 'SR', NULL, NULL, NULL),
(58558, '2017-12-30 09:08:38', NULL, NULL, 15653, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.50, 0.0000, 0.0000, 14.50, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:08:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58559, '2017-12-30 09:08:48', NULL, NULL, 15653, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:08:48', 'admin-1514595837-15145961280643495', 1, 1, 'SR', NULL, NULL, NULL),
(58560, '2017-12-30 09:08:48', NULL, NULL, 15653, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:08:48', 'admin-1514595837-15145961280643495', 1, 1, 'SR', NULL, NULL, NULL),
(58561, '2017-12-30 09:08:48', NULL, NULL, 15653, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:08:48', 'admin-1514595837-15145961280643495', 1, 0, '', NULL, NULL, NULL),
(58562, '2017-12-30 09:08:48', NULL, NULL, 15653, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:08:48', 'admin-1514595837-15145961280643495', 1, 0, '', NULL, NULL, NULL),
(58563, '2017-12-30 09:10:22', NULL, NULL, 15653, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:10:22', 'admin-1514595837-15145962222109359', 1, 1, 'SR', NULL, NULL, NULL),
(58564, '2017-12-30 09:10:22', NULL, NULL, 15653, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:10:22', 'admin-1514595837-15145962222109359', 1, 0, '', NULL, NULL, NULL),
(58565, '2017-12-30 09:33:19', NULL, NULL, 15658, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:33:19', 'admin-1514595837-1514597599544271', 1, 0, '', NULL, NULL, '10.0'),
(58566, '2017-12-30 09:33:19', NULL, NULL, 15658, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:33:19', 'admin-1514595837-1514597599544271', 1, 0, '', NULL, NULL, '10.0'),
(58567, '2017-12-30 09:29:35', NULL, NULL, 15657, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:29:35', 'admin-1514595837-1514597375320299', 1, 1, 'SR', NULL, NULL, NULL),
(58568, '2017-12-30 09:32:51', NULL, NULL, 15658, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:32:51', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(58569, '2017-12-30 09:25:51', NULL, NULL, 15656, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:25:51', 'admin-1514595837-15145971509304738', 1, 1, 'SR', NULL, NULL, NULL),
(58570, '2017-12-30 09:25:51', NULL, NULL, 15656, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:25:51', 'admin-1514595837-15145971509304738', 1, 0, '', NULL, NULL, NULL),
(58571, '2017-12-30 09:21:50', NULL, NULL, 15655, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:21:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58572, '2017-12-30 09:18:02', NULL, NULL, 15654, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:18:02', 'admin-1514595837-15145966823765135', 1, 0, '', NULL, NULL, NULL),
(58573, '2017-12-30 09:18:02', NULL, NULL, 15654, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:18:02', 'admin-1514595837-15145966823765135', 1, 0, '', NULL, NULL, NULL),
(58574, '2017-12-30 09:17:53', NULL, NULL, 15654, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:17:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58575, '2017-12-30 09:06:58', NULL, NULL, 15652, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:06:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58576, '2017-12-30 10:03:40', NULL, NULL, 15663, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 10:03:40', 'admin-1514595837-15145994201808665', 1, 1, 'SR', NULL, NULL, NULL),
(58577, '2017-12-30 09:10:22', NULL, NULL, 15653, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:10:22', 'admin-1514595837-15145962222109359', 1, 0, '', NULL, NULL, NULL),
(58578, '2017-12-30 09:07:11', NULL, NULL, 15652, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514595837', 'admin', '2017-12-30 09:07:11', 'admin-1514595837-15145960314658280', 1, 1, 'SR', NULL, NULL, NULL),
(58579, '2017-12-31 16:25:35', NULL, NULL, 15749, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 16:25:35', 'admin-1514682622-15147087353596619', 1, 0, '', NULL, NULL, NULL),
(58580, '2017-12-31 16:25:35', NULL, NULL, 15749, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 16:25:35', 'admin-1514682622-15147087353596619', 1, 0, '', NULL, NULL, NULL),
(58581, '2017-12-31 16:13:34', NULL, NULL, 15748, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 16:13:34', 'admin-1514682622-15147080144036351', 1, 1, 'SR', NULL, NULL, NULL),
(58582, '2017-12-31 13:20:22', NULL, NULL, 15738, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:20:22', 'admin-1514682622-15146976225098872', 1, 1, 'SR', NULL, NULL, NULL),
(58583, '2017-12-31 13:20:22', NULL, NULL, 15738, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:20:22', 'admin-1514682622-15146976225098872', 1, 0, '', NULL, NULL, NULL),
(58584, '2017-12-31 13:20:22', NULL, NULL, 15738, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:20:22', 'admin-1514682622-15146976225098872', 1, 0, '', NULL, NULL, NULL),
(58585, '2017-12-31 13:14:46', NULL, NULL, 15736, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:14:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58586, '2017-12-31 10:31:04', NULL, NULL, 15708, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:31:04', 'admin-1514682622-15146874646773566', 1, 0, '', NULL, NULL, NULL),
(58587, '2017-12-31 10:31:04', NULL, NULL, 15708, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:31:04', 'admin-1514682622-15146874646773566', 1, 0, '', NULL, NULL, NULL),
(58588, '2017-12-31 13:15:40', NULL, NULL, 15737, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:15:40', 'admin-1514682622-15146973402612763', 1, 0, '', NULL, NULL, NULL),
(58589, '2017-12-31 13:15:40', NULL, NULL, 15737, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:15:40', 'admin-1514682622-15146973402612763', 1, 0, '', NULL, NULL, NULL),
(58590, '2017-12-31 13:15:19', NULL, NULL, 15737, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:15:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58591, '2017-12-31 13:15:11', NULL, NULL, 15736, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:15:11', 'admin-1514682622-15146973113816311', 1, 1, 'SR', NULL, NULL, NULL),
(58592, '2017-12-31 13:15:11', NULL, NULL, 15736, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:15:11', 'admin-1514682622-15146973113816311', 1, 1, 'SR', NULL, NULL, NULL),
(58593, '2017-12-31 14:09:58', NULL, NULL, 15742, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1514682622', 'admin', '2017-12-31 14:09:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58594, '2017-12-31 13:22:25', NULL, NULL, 15740, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:22:25', 'admin-1514682622-15146977453957651', 1, 1, 'SR', 1, NULL, '10.0'),
(58595, '2017-12-31 10:21:02', NULL, NULL, 15705, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:21:02', 'admin-1514682622-15146868621791898', 1, 1, 'SR', NULL, NULL, NULL),
(58596, '2017-12-31 10:21:02', NULL, NULL, 15705, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:21:02', 'admin-1514682622-15146868621791898', 1, 1, 'SR', NULL, NULL, NULL),
(58597, '2017-12-31 10:21:02', NULL, NULL, 15705, 0, 322, '258', 'Yuzu Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:21:02', 'admin-1514682622-15146868621791898', 1, 0, '', NULL, NULL, NULL),
(58598, '2017-12-31 10:21:17', NULL, NULL, 15706, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:21:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58599, '2017-12-31 10:21:35', NULL, NULL, 15706, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:21:35', 'admin-1514682622-15146868955047494', 1, 0, '', NULL, NULL, NULL),
(58600, '2017-12-31 10:21:35', NULL, NULL, 15706, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:21:35', 'admin-1514682622-15146868955047494', 1, 0, '', NULL, NULL, NULL),
(58601, '2017-12-31 10:21:35', NULL, NULL, 15706, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:21:35', 'admin-1514682622-15146868955047494', 1, 1, 'SR', NULL, NULL, NULL),
(58602, '2017-12-31 14:02:27', NULL, NULL, 15735, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 14:02:27', 'admin-1514682622-15147001476295513', 1, 0, '', NULL, NULL, NULL),
(58603, '2017-12-31 11:39:22', NULL, NULL, 15718, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:39:22', 'admin-1514682622-1514691562548613', 1, 1, 'SR', NULL, NULL, NULL),
(58604, '2017-12-31 11:39:22', NULL, NULL, 15718, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:39:22', 'admin-1514682622-1514691562548613', 1, 1, 'SR', NULL, NULL, NULL),
(58605, '2017-12-31 13:15:11', NULL, NULL, 15736, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:15:11', 'admin-1514682622-15146973113816311', 1, 0, '', NULL, NULL, NULL),
(58606, '2017-12-31 13:15:11', NULL, NULL, 15736, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:15:11', 'admin-1514682622-15146973113816311', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(58607, '2017-12-31 12:46:55', NULL, NULL, 15731, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:46:55', 'admin-1514682622-15146956155037491', 1, 1, 'SR', NULL, NULL, '10.0'),
(58608, '2017-12-31 15:34:57', NULL, NULL, 15746, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 15:34:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58609, '2017-12-31 15:35:13', NULL, NULL, 15746, 0, 269, '203', 'Espresso Con Panna', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 15:35:13', 'admin-1514682622-15147057130455070', 1, 0, '', NULL, NULL, NULL),
(58610, '2017-12-31 10:21:02', NULL, NULL, 15705, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:21:02', 'admin-1514682622-15146868621791898', 1, 0, '', NULL, NULL, NULL),
(58611, '2017-12-31 10:21:02', NULL, NULL, 15705, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:21:02', 'admin-1514682622-15146868621791898', 1, 0, '', NULL, NULL, NULL),
(58612, '2017-12-31 12:42:40', NULL, NULL, 15730, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:42:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58613, '2017-12-31 12:43:13', NULL, NULL, 15730, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:43:13', 'admin-1514682622-15146953935292493', 1, 0, '', NULL, NULL, NULL),
(58614, '2017-12-31 12:43:13', NULL, NULL, 15730, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:43:13', 'admin-1514682622-15146953935292493', 1, 0, '', NULL, NULL, NULL),
(58615, '2017-12-31 12:43:13', NULL, NULL, 15730, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:43:13', 'admin-1514682622-15146953935292493', 1, 1, 'SR', NULL, NULL, NULL),
(58616, '2017-12-31 10:21:02', NULL, NULL, 15705, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:21:02', 'admin-1514682622-15146868621791898', 1, 1, 'SR', NULL, NULL, NULL),
(58617, '2017-12-31 10:21:02', NULL, NULL, 15705, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:21:02', 'admin-1514682622-15146868621791898', 1, 1, 'SR', NULL, NULL, NULL),
(58618, '2017-12-31 11:03:12', NULL, NULL, 15704, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 8.28, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:03:12', 'admin-1514682622-15146893927754942', 1, 0, '', NULL, '31.0', NULL),
(58619, '2017-12-31 11:04:25', NULL, NULL, 15713, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:04:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58620, '2017-12-31 09:53:23', NULL, NULL, 15702, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:53:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58621, '2017-12-31 09:53:43', NULL, NULL, 15702, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:53:43', 'admin-1514682622-15146852230824637', 1, 0, '', NULL, NULL, NULL),
(58622, '2017-12-31 10:31:10', NULL, NULL, 15709, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:31:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58623, '2017-12-31 10:31:29', NULL, NULL, 15709, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:31:29', 'admin-1514682622-15146874892914877', 1, 0, '', NULL, NULL, NULL),
(58624, '2017-12-31 11:35:26', NULL, NULL, 15717, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:35:26', 'admin-1514682622-15146913266587088', 1, 0, '', NULL, NULL, NULL),
(58625, '2017-12-31 12:27:37', NULL, NULL, 15727, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:27:37', 'admin-1514682622-15146944578317070', 1, 1, 'SR', 1, NULL, NULL),
(58626, '2017-12-31 12:28:52', NULL, NULL, 15728, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:28:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58627, '2017-12-31 12:29:02', NULL, NULL, 15728, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:29:02', 'admin-1514682622-1514694542461196', 1, 1, 'SR', NULL, NULL, NULL),
(58628, '2017-12-31 10:31:29', NULL, NULL, 15709, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:31:29', 'admin-1514682622-15146874892914877', 1, 1, 'SR', NULL, NULL, NULL),
(58629, '2017-12-31 11:35:26', NULL, NULL, 15717, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:35:26', 'admin-1514682622-15146913266587088', 1, 0, '', NULL, NULL, NULL),
(58630, '2017-12-31 10:58:04', NULL, NULL, 15712, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:58:04', 'admin-1514682622-15146890842008765', 1, 0, '', NULL, NULL, NULL),
(58631, '2017-12-31 10:58:04', NULL, NULL, 15712, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:58:04', 'admin-1514682622-15146890842008765', 1, 0, '', NULL, NULL, NULL),
(58632, '2017-12-31 10:58:04', NULL, NULL, 15712, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:58:04', 'admin-1514682622-15146890842008765', 1, 0, '', NULL, NULL, NULL),
(58633, '2017-12-31 11:55:41', NULL, NULL, 15721, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:55:41', 'admin-1514682622-15146925408684464', 1, 0, '', NULL, NULL, NULL),
(58634, '2017-12-31 11:55:41', NULL, NULL, 15721, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:55:41', 'admin-1514682622-15146925408684464', 1, 0, '', NULL, NULL, NULL),
(58635, '2017-12-31 11:55:41', NULL, NULL, 15721, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:55:41', 'admin-1514682622-15146925408684464', 1, 1, 'SR', NULL, NULL, NULL),
(58636, '2017-12-31 11:55:41', NULL, NULL, 15721, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:55:41', 'admin-1514682622-15146925408684464', 1, 1, 'SR', NULL, NULL, NULL),
(58637, '2017-12-31 15:16:16', NULL, NULL, 15745, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 15:16:16', 'admin-1514682622-15147045763961211', 1, 0, '', NULL, NULL, NULL),
(58638, '2017-12-31 13:02:26', NULL, NULL, 15734, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:02:26', 'admin-1514682622-15146965464734936', 1, 0, '', NULL, NULL, NULL),
(58639, '2017-12-31 13:00:41', NULL, NULL, 15734, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:00:41', 'admin-1514682622-15146964412384255', 1, 1, 'SR', NULL, NULL, NULL),
(58640, '2017-12-31 13:00:08', NULL, NULL, 15734, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.69, 0.0000, 0.0000, 2.69, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:00:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58641, '2017-12-31 16:25:43', NULL, NULL, 15749, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 16:25:43', 'admin-1514682622-1514708743741690', 1, 0, '', NULL, NULL, NULL),
(58642, '2017-12-31 16:25:13', NULL, NULL, 15749, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1514682622', 'admin', '2017-12-31 16:25:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58643, '2017-12-31 11:56:37', NULL, NULL, 15722, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:56:37', 'admin-1514682622-15146925975766184', 1, 1, 'SR', NULL, NULL, NULL),
(58644, '2017-12-31 12:17:49', NULL, NULL, 15724, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:17:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58645, '2017-12-31 13:20:22', NULL, NULL, 15738, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:20:22', 'admin-1514682622-15146976225098872', 1, 1, 'SR', NULL, NULL, NULL),
(58646, '2017-12-31 16:13:29', NULL, NULL, 15748, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1514682622', 'admin', '2017-12-31 16:13:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58647, '2017-12-31 15:43:38', NULL, NULL, 15747, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 15:43:38', 'admin-1514682622-15147062186657681', 1, 0, '', NULL, NULL, NULL),
(58648, '2017-12-31 15:42:33', NULL, NULL, 15747, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 15:42:33', 'admin-1514682622-15147061531138555', 1, 1, 'SR', NULL, NULL, NULL),
(58649, '2017-12-31 14:00:35', NULL, NULL, 15741, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1514682622', 'admin', '2017-12-31 14:00:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58650, '2017-12-31 15:42:24', NULL, NULL, 15747, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1514682622', 'admin', '2017-12-31 15:42:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58651, '2017-12-31 15:42:33', NULL, NULL, 15747, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 15:42:33', 'admin-1514682622-15147061531138555', 1, 1, 'SR', NULL, NULL, NULL),
(58652, '2017-12-31 12:23:00', NULL, NULL, 15725, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:23:00', 'admin-1514682622-15146941802035533', 1, 0, '', NULL, NULL, NULL),
(58653, '2017-12-31 12:24:14', NULL, NULL, 15726, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:24:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58654, '2017-12-31 12:24:20', NULL, NULL, 15726, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:24:20', 'admin-1514682622-15146942598709715', 1, 0, '', NULL, NULL, NULL),
(58655, '2017-12-31 12:57:42', NULL, NULL, 15733, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:57:42', 'admin-1514682622-15146962624796914', 1, 1, 'SR', NULL, NULL, NULL),
(58656, '2017-12-31 12:57:42', NULL, NULL, 15733, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:57:42', 'admin-1514682622-15146962624796914', 1, 1, 'SR', NULL, NULL, NULL),
(58657, '2017-12-31 12:57:42', NULL, NULL, 15733, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:57:42', 'admin-1514682622-15146962624796914', 1, 0, '', NULL, NULL, NULL),
(58658, '2017-12-31 09:50:08', NULL, NULL, 15700, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:50:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58659, '2017-12-31 09:50:22', NULL, NULL, 15700, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:50:22', 'admin-1514682622-1514685022700567', 1, 0, '', NULL, NULL, NULL),
(58660, '2017-12-31 09:50:22', NULL, NULL, 15700, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:50:22', 'admin-1514682622-1514685022700567', 1, 0, '', NULL, NULL, NULL),
(58661, '2017-12-31 15:35:13', NULL, NULL, 15746, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 15:35:13', 'admin-1514682622-15147057130455070', 1, 1, 'SR', NULL, NULL, NULL),
(58662, '2017-12-31 00:00:00', NULL, NULL, 15723, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:16:10', 'admin-1514682622-1514690170665573', 1, 0, '', NULL, NULL, NULL),
(58663, '2017-12-31 00:00:00', NULL, NULL, 15723, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, NULL, NULL, 6.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:16:10', 'admin-1514682622-1514690170665573', 1, 1, 'SR', NULL, NULL, NULL),
(58664, '2017-12-31 11:16:10', NULL, NULL, 15714, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:16:10', 'admin-1514682622-1514690170665573', 1, 1, 'SR', NULL, NULL, NULL),
(58665, '2017-12-31 15:16:16', NULL, NULL, 15745, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 15:16:16', 'admin-1514682622-15147045763961211', 1, 1, 'SR', NULL, NULL, NULL),
(58666, '2017-12-31 15:15:58', NULL, NULL, 15745, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 15:15:58', 'admin-1514682622-1514704558344428', 1, 0, '', NULL, NULL, NULL),
(58667, '2017-12-31 15:15:58', NULL, NULL, 15745, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 15:15:58', 'admin-1514682622-1514704558344428', 1, 0, '', NULL, NULL, NULL),
(58668, '2017-12-31 10:55:51', NULL, NULL, 15710, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:55:51', 'admin-1514682622-15146889508841610', 1, 0, '', NULL, NULL, NULL),
(58669, '2017-12-31 10:56:39', NULL, NULL, 15711, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:56:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58670, '2017-12-31 15:05:18', NULL, NULL, 15744, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 15:05:18', 'admin-1514682622-15147039179782748', 1, 0, '', NULL, NULL, NULL),
(58671, '2017-12-31 15:05:18', NULL, NULL, 15744, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 15:05:18', 'admin-1514682622-15147039179782748', 1, 1, 'SR', NULL, NULL, NULL),
(58672, '2017-12-31 11:56:37', NULL, NULL, 15722, 0, 181, '116', 'Open Food ', 'add cheesee on omellette', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:56:37', 'admin-1514682622-15146925975766184', 1, 0, '', NULL, NULL, NULL),
(58673, '2017-12-31 11:19:07', NULL, NULL, 15716, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:19:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58674, '2017-12-31 11:19:32', NULL, NULL, 15716, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:19:32', 'admin-1514682622-15146903724966983', 1, 0, '', NULL, NULL, NULL),
(58675, '2017-12-31 12:47:15', NULL, NULL, 15732, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:47:15', 'admin-1514682622-15146956355976181', 1, 0, '', NULL, NULL, NULL),
(58676, '2017-12-31 14:50:37', NULL, NULL, 15743, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 8.28, 1, '27', 1, '1514682622', 'admin', '2017-12-31 14:50:37', 'admin-1514682622-15147030369009832', 1, 0, '', NULL, '31.0', NULL),
(58677, '2017-12-31 14:13:59', NULL, NULL, 15735, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 14:13:59', 'admin-1514682622-15147008393099336', 1, 0, '', NULL, NULL, NULL),
(58678, '2017-12-31 14:35:43', NULL, NULL, 15739, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 14:35:43', 'admin-1514682622-15147021435266794', 1, 0, '', 1, NULL, NULL),
(58679, '2017-12-31 14:49:32', NULL, NULL, 15743, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.03, 0.0000, 0.0000, 6.03, 1, '27', 1, '1514682622', 'admin', '2017-12-31 14:49:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58680, '2017-12-31 14:50:37', NULL, NULL, 15743, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 14:50:37', 'admin-1514682622-15147030369009832', 1, 0, '', NULL, NULL, NULL),
(58681, '2017-12-31 14:50:37', NULL, NULL, 15743, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 14:50:37', 'admin-1514682622-15147030369009832', 1, 1, 'SR', NULL, NULL, NULL),
(58682, '2017-12-31 14:50:37', NULL, NULL, 15743, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 14:50:37', 'admin-1514682622-15147030369009832', 1, 1, 'SR', NULL, NULL, NULL),
(58683, '2017-12-31 09:56:06', NULL, NULL, 15703, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:56:06', 'admin-1514682622-15146853660691515', 1, 0, '', NULL, NULL, NULL),
(58684, '2017-12-31 10:55:05', NULL, NULL, 15710, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.59, 0.0000, 0.0000, 8.59, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:55:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58685, '2017-12-31 10:55:51', NULL, NULL, 15710, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:55:51', 'admin-1514682622-15146889508841610', 1, 0, '', NULL, NULL, NULL),
(58686, '2017-12-31 15:05:18', NULL, NULL, 15744, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 8.28, 1, '27', 1, '1514682622', 'admin', '2017-12-31 15:05:18', 'admin-1514682622-15147039179782748', 1, 0, '', NULL, '31.0', NULL),
(58687, '2017-12-31 14:02:27', NULL, NULL, 15735, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 14:02:27', 'admin-1514682622-15147001476295513', 1, 1, 'SR', NULL, NULL, NULL),
(58688, '2017-12-31 14:00:59', NULL, NULL, 15741, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 14:00:59', 'admin-1514682622-1514700058869113', 1, 1, 'SR', NULL, NULL, NULL),
(58689, '2017-12-31 14:00:59', NULL, NULL, 15741, 0, 158, '92', 'Banana Stuffed Nutella Toast ', 'serve after meal', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 14:00:59', 'admin-1514682622-1514700058869113', 1, 0, '', NULL, NULL, NULL),
(58690, '2017-12-31 10:55:51', NULL, NULL, 15710, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:55:51', 'admin-1514682622-15146889508841610', 1, 1, 'SR', NULL, NULL, NULL),
(58691, '2017-12-31 10:56:49', NULL, NULL, 15711, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:56:49', 'admin-1514682622-15146890092588148', 1, 0, '', NULL, NULL, NULL),
(58692, '2017-12-31 14:00:59', NULL, NULL, 15741, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 14:00:59', 'admin-1514682622-1514700058869113', 1, 0, '', NULL, NULL, NULL),
(58693, '2017-12-31 14:10:04', NULL, NULL, 15742, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 14:10:04', 'admin-1514682622-1514700604215999', 1, 1, 'SR', NULL, NULL, NULL),
(58694, '2017-12-31 13:30:02', NULL, NULL, 15737, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:30:02', 'admin-1514682622-15146982018632670', 1, 0, '', NULL, NULL, NULL),
(58695, '2017-12-31 12:46:55', NULL, NULL, 15731, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:46:55', 'admin-1514682622-15146956155037491', 1, 1, 'SR', NULL, NULL, '10.0'),
(58696, '2017-12-31 11:35:22', NULL, NULL, 15717, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.13, 0.0000, 0.0000, 4.13, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:35:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58697, '2017-12-31 09:50:22', NULL, NULL, 15700, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:50:22', 'admin-1514682622-1514685022700567', 1, 1, 'SR', NULL, NULL, NULL),
(58698, '2017-12-31 12:46:55', NULL, NULL, 15731, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:46:55', 'admin-1514682622-15146956155037491', 1, 0, '', NULL, NULL, '10.0'),
(58699, '2017-12-31 12:46:55', NULL, NULL, 15731, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:46:55', 'admin-1514682622-15146956155037491', 1, 0, '', NULL, NULL, '10.0'),
(58700, '2017-12-31 12:46:29', NULL, NULL, 15731, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:46:29', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(58701, '2017-12-31 12:39:13', NULL, NULL, 15729, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:39:13', 'admin-1514682622-15146951538154118', 1, 0, '', NULL, NULL, NULL),
(58702, '2017-12-31 10:21:02', NULL, NULL, 15705, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:21:02', 'admin-1514682622-15146868621791898', 1, 0, '', NULL, NULL, NULL),
(58703, '2017-12-31 10:21:02', NULL, NULL, 15705, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:21:02', 'admin-1514682622-15146868621791898', 1, 0, '', NULL, NULL, NULL),
(58704, '2017-12-31 10:21:02', NULL, NULL, 15705, 0, 181, '116', 'Open Food ', 'toast bread x 6', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:21:02', 'admin-1514682622-15146868621791898', 1, 0, '', NULL, NULL, NULL),
(58705, '2017-12-31 15:15:58', NULL, NULL, 15745, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 15:15:58', 'admin-1514682622-1514704558344428', 1, 0, '', NULL, NULL, NULL),
(58706, '2017-12-31 12:39:13', NULL, NULL, 15729, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:39:13', 'admin-1514682622-15146951538154118', 1, 0, '', NULL, NULL, NULL),
(58707, '2017-12-31 12:39:13', NULL, NULL, 15729, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:39:13', 'admin-1514682622-15146951538154118', 1, 1, 'SR', NULL, NULL, NULL),
(58708, '2017-12-31 11:15:33', NULL, NULL, 15714, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:15:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58709, '2017-12-31 11:59:55', NULL, NULL, 15723, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:59:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58710, '2017-12-31 11:16:10', NULL, NULL, 15714, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:16:10', 'admin-1514682622-1514690170665573', 1, 0, '', NULL, NULL, NULL),
(58711, '2017-12-31 13:20:03', NULL, NULL, 15738, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:20:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58712, '2017-12-31 13:33:50', NULL, NULL, 15735, 0, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:33:50', 'admin-1514682622-15146984308458376', 1, 1, 'SR', NULL, NULL, NULL),
(58713, '2017-12-31 12:57:42', NULL, NULL, 15733, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:57:42', 'admin-1514682622-15146962624796914', 1, 0, '', NULL, NULL, NULL),
(58714, '2017-12-31 12:22:53', NULL, NULL, 15725, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:22:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58715, '2017-12-31 12:18:03', NULL, NULL, 15724, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:18:03', 'admin-1514682622-15146938832578062', 1, 1, 'SR', NULL, NULL, NULL),
(58716, '2017-12-31 12:18:03', NULL, NULL, 15724, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:18:03', 'admin-1514682622-15146938832578062', 1, 0, '', NULL, NULL, NULL),
(58717, '2017-12-31 09:43:59', NULL, NULL, 15698, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:43:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58718, '2017-12-31 09:44:43', NULL, NULL, 15698, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:44:43', 'admin-1514682622-15146846833576870', 1, 0, '', NULL, NULL, NULL),
(58719, '2017-12-31 09:44:43', NULL, NULL, 15698, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:44:43', 'admin-1514682622-15146846833576870', 1, 0, '', NULL, NULL, NULL),
(58720, '2017-12-31 09:44:43', NULL, NULL, 15698, 0, 32, '32', 'Tea By Pot ', 'english breakfsst', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:44:43', 'admin-1514682622-15146846833576870', 1, 1, 'SR', NULL, NULL, NULL),
(58721, '2017-12-31 09:58:37', NULL, NULL, 15704, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:58:37', 'admin-1514682622-15146855172207536', 1, 0, '', NULL, NULL, NULL),
(58722, '2017-12-31 14:00:58', NULL, NULL, 15741, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 14:00:58', 'admin-1514682622-1514700058869113', 1, 0, '', NULL, NULL, NULL),
(58723, '2017-12-31 11:56:37', NULL, NULL, 15722, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:56:37', 'admin-1514682622-15146925975766184', 1, 0, '', NULL, NULL, NULL),
(58724, '2017-12-31 11:55:47', NULL, NULL, 15722, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:55:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58725, '2017-12-31 10:56:49', NULL, NULL, 15711, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:56:49', 'admin-1514682622-15146890092588148', 1, 1, 'SR', NULL, NULL, NULL),
(58726, '2017-12-31 11:55:17', NULL, NULL, 15721, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:55:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58727, '2017-12-31 10:21:02', NULL, NULL, 15705, 0, 32, '32', 'Tea By Pot ', 'charmomile', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:21:02', 'admin-1514682622-15146868621791898', 1, 1, 'SR', NULL, NULL, NULL),
(58728, '2017-12-31 11:55:12', NULL, NULL, 15720, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:55:12', 'admin-1514682622-15146925121045579', 1, 1, 'SR', NULL, NULL, NULL),
(58729, '2017-12-31 11:55:12', NULL, NULL, 15720, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:55:12', 'admin-1514682622-15146925121045579', 1, 1, 'SR', NULL, NULL, NULL),
(58730, '2017-12-31 11:54:54', NULL, NULL, 15720, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:54:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58731, '2017-12-31 15:04:56', NULL, NULL, 15744, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.53, 0.0000, 0.0000, 4.53, 1, '27', 1, '1514682622', 'admin', '2017-12-31 15:04:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58732, '2017-12-31 15:05:18', NULL, NULL, 15744, 0, 304, '240', 'Banana is On Fire', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 15:05:18', 'admin-1514682622-15147039179782748', 1, 0, '', NULL, NULL, NULL),
(58733, '2017-12-31 11:46:13', NULL, NULL, 15719, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:46:13', 'admin-1514682622-15146919735343139', 1, 0, '', 1, NULL, NULL),
(58734, '2017-12-31 11:38:01', NULL, NULL, 15717, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 8.28, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:38:01', 'admin-1514682622-15146914813354050', 1, 0, '', NULL, '31.0', NULL),
(58735, '2017-12-31 11:39:10', NULL, NULL, 15718, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:39:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58736, '2017-12-31 11:39:22', NULL, NULL, 15718, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:39:22', 'admin-1514682622-1514691562548613', 1, 0, '', NULL, NULL, NULL),
(58737, '2017-12-31 11:39:22', NULL, NULL, 15718, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:39:22', 'admin-1514682622-1514691562548613', 1, 1, 'SR', NULL, NULL, NULL),
(58738, '2017-12-31 13:20:22', NULL, NULL, 15738, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:20:22', 'admin-1514682622-15146976225098872', 1, 0, '', NULL, NULL, NULL),
(58739, '2017-12-31 11:39:22', NULL, NULL, 15718, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:39:22', 'admin-1514682622-1514691562548613', 1, 0, '', NULL, NULL, NULL),
(58740, '2017-12-31 13:00:41', NULL, NULL, 15734, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:00:41', 'admin-1514682622-15146964412384255', 1, 0, '', NULL, NULL, NULL),
(58741, '2017-12-31 11:19:32', NULL, NULL, 15716, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:19:32', 'admin-1514682622-15146903724966983', 1, 1, 'SR', NULL, NULL, NULL),
(58742, '2017-12-31 11:19:32', NULL, NULL, 15716, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:19:32', 'admin-1514682622-15146903724966983', 1, 0, '', NULL, NULL, NULL),
(58743, '2017-12-31 09:51:14', NULL, NULL, 15701, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:51:14', 'admin-1514682622-15146850745529270', 1, 0, '', NULL, NULL, NULL),
(58744, '2017-12-31 09:58:13', NULL, NULL, 15704, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.03, 0.0000, 0.0000, 9.03, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:58:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58745, '2017-12-31 09:58:37', NULL, NULL, 15704, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:58:37', 'admin-1514682622-15146855172207536', 1, 0, '', NULL, NULL, NULL),
(58746, '2017-12-31 09:56:06', NULL, NULL, 15703, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:56:06', 'admin-1514682622-15146853660691515', 1, 1, 'SR', NULL, NULL, NULL),
(58747, '2017-12-31 12:57:06', NULL, NULL, 15733, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:57:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58748, '2017-12-31 11:19:32', NULL, NULL, 15716, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:19:32', 'admin-1514682622-15146903724966983', 1, 0, '', NULL, NULL, NULL),
(58749, '2017-12-31 11:18:12', NULL, NULL, 15715, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 6.90, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:18:12', 'admin-1514682622-15146902922949691', 1, 0, '', NULL, '31.0', NULL),
(58750, '2017-12-31 11:17:45', NULL, NULL, 15715, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:17:45', 'admin-1514682622-15146902653272352', 1, 1, 'SR', NULL, NULL, NULL),
(58751, '2017-12-31 11:17:45', NULL, NULL, 15715, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:17:45', 'admin-1514682622-15146902653272352', 1, 1, 'SR', NULL, NULL, NULL),
(58752, '2017-12-31 11:17:45', NULL, NULL, 15715, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:17:45', 'admin-1514682622-15146902653272352', 1, 0, '', NULL, NULL, NULL),
(58753, '2017-12-31 11:17:31', NULL, NULL, 15715, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.89, 0.0000, 0.0000, 4.89, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:17:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58754, '2017-12-31 11:16:10', NULL, NULL, 15714, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:16:10', 'admin-1514682622-1514690170665573', 1, 1, 'SR', NULL, NULL, NULL),
(58755, '2017-12-31 11:16:10', NULL, NULL, 15714, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:16:10', 'admin-1514682622-1514690170665573', 1, 0, '', NULL, NULL, NULL),
(58756, '2017-12-31 00:00:00', NULL, NULL, 15723, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:16:10', 'admin-1514682622-1514690170665573', 1, 0, '', NULL, NULL, NULL),
(58757, '2017-12-31 11:16:10', NULL, NULL, 15714, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:16:10', 'admin-1514682622-1514690170665573', 1, 1, 'SR', NULL, NULL, NULL),
(58758, '2017-12-31 11:04:39', NULL, NULL, 15713, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:04:39', 'admin-1514682622-15146894792803185', 1, 0, '', NULL, NULL, NULL),
(58759, '2017-12-31 11:04:39', NULL, NULL, 15713, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:04:39', 'admin-1514682622-15146894792803185', 1, 0, '', NULL, NULL, NULL),
(58760, '2017-12-31 00:00:00', NULL, NULL, 15723, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:16:10', 'admin-1514682622-1514690170665573', 1, 1, 'SR', NULL, NULL, NULL),
(58761, '2017-12-31 11:04:39', NULL, NULL, 15713, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:04:39', 'admin-1514682622-15146894792803185', 1, 1, 'SR', NULL, NULL, NULL),
(58762, '2017-12-31 11:04:39', NULL, NULL, 15713, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:04:39', 'admin-1514682622-15146894792803185', 1, 1, 'SR', NULL, NULL, NULL),
(58763, '2017-12-31 09:50:22', NULL, NULL, 15700, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:50:22', 'admin-1514682622-1514685022700567', 1, 0, '', NULL, NULL, NULL),
(58764, '2017-12-31 09:50:33', NULL, NULL, 15701, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.30, 0.0000, 0.0000, 13.30, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:50:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58765, '2017-12-31 09:51:14', NULL, NULL, 15701, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:51:14', 'admin-1514682622-15146850745529270', 1, 0, '', NULL, NULL, NULL),
(58766, '2017-12-31 09:38:56', NULL, NULL, 15697, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:38:56', 'admin-1514682622-15146843362346521', 1, 1, 'SR', NULL, NULL, NULL),
(58767, '2017-12-31 14:50:37', NULL, NULL, 15743, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 14:50:37', 'admin-1514682622-15147030369009832', 1, 0, '', NULL, NULL, NULL),
(58768, '2017-12-31 13:07:50', NULL, NULL, 15735, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:07:50', 'admin-1514682622-15146968706476651', 1, 1, 'SR', NULL, NULL, NULL),
(58769, '2017-12-31 10:58:04', NULL, NULL, 15712, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:58:04', 'admin-1514682622-15146890842008765', 1, 0, '', NULL, NULL, NULL),
(58770, '2017-12-31 10:58:04', NULL, NULL, 15712, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:58:04', 'admin-1514682622-15146890842008765', 1, 1, 'SR', NULL, NULL, NULL),
(58771, '2017-12-31 12:46:55', NULL, NULL, 15731, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:46:55', 'admin-1514682622-15146956155037491', 1, 0, '', NULL, NULL, '10.0'),
(58772, '2017-12-31 10:58:04', NULL, NULL, 15712, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:58:04', 'admin-1514682622-15146890842008765', 1, 0, '', NULL, NULL, NULL),
(58773, '2017-12-31 10:19:16', NULL, NULL, 15705, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 24.00, 0.0000, 0.0000, 24.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:19:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58774, '2017-12-31 15:16:16', NULL, NULL, 15745, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 15:16:16', 'admin-1514682622-15147045763961211', 1, 1, 'SR', NULL, NULL, NULL),
(58775, '2017-12-31 10:58:04', NULL, NULL, 15712, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:58:04', 'admin-1514682622-15146890842008765', 1, 0, '', NULL, NULL, NULL),
(58776, '2017-12-31 10:57:21', NULL, NULL, 15712, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.00, 0.0000, 0.0000, 13.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:57:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58777, '2017-12-31 10:58:04', NULL, NULL, 15712, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:58:04', 'admin-1514682622-15146890842008765', 1, 0, '', NULL, NULL, NULL),
(58778, '2017-12-31 10:55:51', NULL, NULL, 15710, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 6.90, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:55:51', 'admin-1514682622-15146889508841610', 1, 0, '', NULL, '31.0', NULL),
(58779, '2017-12-31 10:55:51', NULL, NULL, 15710, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:55:51', 'admin-1514682622-15146889508841610', 1, 0, '', NULL, NULL, NULL),
(58780, '2017-12-31 10:55:51', NULL, NULL, 15710, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:55:51', 'admin-1514682622-15146889508841610', 1, 1, 'SR', NULL, NULL, NULL),
(58781, '2017-12-31 10:31:04', NULL, NULL, 15708, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:31:04', 'admin-1514682622-15146874646773566', 1, 1, 'SR', NULL, NULL, NULL),
(58782, '2017-12-31 10:55:51', NULL, NULL, 15710, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:55:51', 'admin-1514682622-15146889508841610', 1, 1, 'SR', NULL, NULL, NULL),
(58783, '2017-12-31 10:26:11', NULL, NULL, 15707, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:26:11', 'admin-1514682622-15146871716512384', 1, 1, 'SR', NULL, NULL, NULL),
(58784, '2017-12-31 10:26:11', NULL, NULL, 15707, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:26:11', 'admin-1514682622-15146871716512384', 1, 1, 'SR', NULL, NULL, NULL),
(58785, '2017-12-31 10:30:41', NULL, NULL, 15708, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:30:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58786, '2017-12-31 09:38:34', NULL, NULL, 15697, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:38:34', 'admin-1514682622-1514684314678180', 1, 0, '', NULL, NULL, NULL),
(58787, '2017-12-31 10:21:02', NULL, NULL, 15705, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:21:02', 'admin-1514682622-15146868621791898', 1, 0, '', NULL, NULL, NULL),
(58788, '2017-12-31 09:56:06', NULL, NULL, 15703, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:56:06', 'admin-1514682622-15146853660691515', 1, 1, 'SR', NULL, NULL, NULL),
(58789, '2017-12-31 10:31:04', NULL, NULL, 15708, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:31:04', 'admin-1514682622-15146874646773566', 1, 0, '', NULL, NULL, NULL),
(58790, '2017-12-31 10:25:41', NULL, NULL, 15707, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:25:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58791, '2017-12-31 10:26:11', NULL, NULL, 15707, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:26:11', 'admin-1514682622-15146871716512384', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(58792, '2017-12-31 10:26:11', NULL, NULL, 15707, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:26:11', 'admin-1514682622-15146871716512384', 1, 0, '', NULL, NULL, NULL),
(58793, '2017-12-31 10:21:02', NULL, NULL, 15705, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:21:02', 'admin-1514682622-15146868621791898', 1, 1, 'SR', NULL, NULL, NULL),
(58794, '2017-12-31 09:26:21', NULL, NULL, 15695, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:26:21', 'admin-1514682622-15146835817563612', 1, 0, '', NULL, NULL, NULL),
(58795, '2017-12-31 09:58:37', NULL, NULL, 15704, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:58:37', 'admin-1514682622-15146855172207536', 1, 1, 'SR', NULL, NULL, NULL),
(58796, '2017-12-31 10:21:02', NULL, NULL, 15705, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:21:02', 'admin-1514682622-15146868621791898', 1, 0, '', NULL, NULL, NULL),
(58797, '2017-12-31 10:21:02', NULL, NULL, 15705, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:21:02', 'admin-1514682622-15146868621791898', 1, 0, '', NULL, NULL, NULL),
(58798, '2017-12-31 10:21:02', NULL, NULL, 15705, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:21:02', 'admin-1514682622-15146868621791898', 1, 0, '', NULL, NULL, NULL),
(58799, '2017-12-31 09:58:37', NULL, NULL, 15704, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:58:37', 'admin-1514682622-15146855172207536', 1, 1, 'SR', NULL, NULL, NULL),
(58800, '2017-12-31 09:58:37', NULL, NULL, 15704, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:58:37', 'admin-1514682622-15146855172207536', 1, 1, 'SR', NULL, NULL, NULL),
(58801, '2017-12-31 09:58:37', NULL, NULL, 15704, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:58:37', 'admin-1514682622-15146855172207536', 1, 0, '', NULL, NULL, NULL),
(58802, '2017-12-31 09:56:06', NULL, NULL, 15703, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:56:06', 'admin-1514682622-15146853660691515', 1, 0, '', NULL, NULL, NULL),
(58803, '2017-12-31 09:56:06', NULL, NULL, 15703, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:56:06', 'admin-1514682622-15146853660691515', 1, 0, '', NULL, NULL, NULL),
(58804, '2017-12-31 13:07:50', NULL, NULL, 15735, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:07:50', 'admin-1514682622-15146968706476651', 1, 0, '', NULL, NULL, NULL),
(58805, '2017-12-31 09:56:06', NULL, NULL, 15703, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:56:06', 'admin-1514682622-15146853660691515', 1, 1, 'SR', NULL, NULL, NULL),
(58806, '2017-12-31 12:38:41', NULL, NULL, 15729, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:38:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58807, '2017-12-31 09:55:44', NULL, NULL, 15703, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:55:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58808, '2017-12-31 09:53:43', NULL, NULL, 15702, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:53:43', 'admin-1514682622-15146852230824637', 1, 0, '', NULL, NULL, NULL),
(58809, '2017-12-31 09:53:43', NULL, NULL, 15702, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:53:43', 'admin-1514682622-15146852230824637', 1, 0, '', NULL, NULL, NULL),
(58810, '2017-12-31 09:51:14', NULL, NULL, 15701, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:51:14', 'admin-1514682622-15146850745529270', 1, 1, 'SR', NULL, NULL, NULL),
(58811, '2017-12-31 09:51:14', NULL, NULL, 15701, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:51:14', 'admin-1514682622-15146850745529270', 1, 1, 'SR', NULL, NULL, NULL),
(58812, '2017-12-31 09:51:14', NULL, NULL, 15701, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:51:14', 'admin-1514682622-15146850745529270', 1, 0, '', NULL, NULL, NULL),
(58813, '2017-12-31 09:51:14', NULL, NULL, 15701, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:51:14', 'admin-1514682622-15146850745529270', 1, 1, 'SR', NULL, NULL, NULL),
(58814, '2017-12-31 13:07:00', NULL, NULL, 15735, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1514682622', 'admin', '2017-12-31 13:07:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58815, '2017-12-31 09:51:14', NULL, NULL, 15701, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:51:14', 'admin-1514682622-15146850745529270', 1, 0, '', NULL, NULL, NULL),
(58816, '2017-12-31 09:51:14', NULL, NULL, 15701, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:51:14', 'admin-1514682622-15146850745529270', 1, 0, '', NULL, NULL, NULL),
(58817, '2017-12-31 11:39:22', NULL, NULL, 15718, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:39:22', 'admin-1514682622-1514691562548613', 1, 0, '', NULL, NULL, NULL),
(58818, '2017-12-31 09:11:51', NULL, NULL, 15694, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:11:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58819, '2017-12-31 09:12:10', NULL, NULL, 15694, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:12:10', 'admin-1514682622-15146827306704587', 1, 0, '', NULL, NULL, NULL),
(58820, '2017-12-31 09:12:10', NULL, NULL, 15694, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:12:10', 'admin-1514682622-15146827306704587', 1, 0, '', NULL, NULL, NULL),
(58821, '2017-12-31 09:12:10', NULL, NULL, 15694, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:12:10', 'admin-1514682622-15146827306704587', 1, 1, 'SR', NULL, NULL, NULL),
(58822, '2017-12-31 09:12:10', NULL, NULL, 15694, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:12:11', 'admin-1514682622-15146827306704587', 1, 1, 'SR', NULL, NULL, NULL),
(58823, '2017-12-31 09:12:11', NULL, NULL, 15694, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:12:11', 'admin-1514682622-15146827306704587', 1, 1, 'SR', NULL, NULL, NULL),
(58824, '2017-12-31 09:12:11', NULL, NULL, 15694, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:12:11', 'admin-1514682622-15146827306704587', 1, 1, 'SR', NULL, NULL, NULL),
(58825, '2017-12-31 09:25:55', NULL, NULL, 15695, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:25:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58826, '2017-12-31 12:47:05', NULL, NULL, 15732, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1514682622', 'admin', '2017-12-31 12:47:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58827, '2017-12-31 09:51:14', NULL, NULL, 15701, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:51:14', 'admin-1514682622-15146850745529270', 1, 0, '', NULL, NULL, NULL),
(58828, '2017-12-31 09:46:49', NULL, NULL, 15699, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:46:49', 'admin-1514682622-1514684809282763', 1, 1, 'SR', NULL, NULL, NULL),
(58829, '2017-12-31 09:44:43', NULL, NULL, 15698, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:44:43', 'admin-1514682622-15146846833576870', 1, 1, 'SR', NULL, NULL, NULL),
(58830, '2017-12-31 09:46:39', NULL, NULL, 15699, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:46:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58831, '2017-12-31 09:46:49', NULL, NULL, 15699, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:46:49', 'admin-1514682622-1514684809282763', 1, 0, '', NULL, NULL, NULL),
(58832, '2017-12-31 15:15:31', NULL, NULL, 15745, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.00, 0.0000, 0.0000, 10.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 15:15:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58833, '2017-12-31 09:38:56', NULL, NULL, 15697, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:38:56', 'admin-1514682622-15146843362346521', 1, 1, 'SR', NULL, NULL, NULL),
(58834, '2017-12-31 09:38:56', NULL, NULL, 15697, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:38:56', 'admin-1514682622-15146843362346521', 1, 0, '', NULL, NULL, NULL),
(58835, '2017-12-31 00:00:00', NULL, NULL, 15723, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 11:16:10', 'admin-1514682622-1514690170665573', 1, 1, 'SR', NULL, NULL, NULL),
(58836, '2017-12-31 10:21:02', NULL, NULL, 15705, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 10:21:02', 'admin-1514682622-15146868621791898', 1, 0, '', NULL, NULL, NULL),
(58837, '2017-12-31 09:38:34', NULL, NULL, 15697, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:38:34', 'admin-1514682622-1514684314678180', 1, 0, '', NULL, NULL, NULL),
(58838, '2017-12-31 09:38:34', NULL, NULL, 15697, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:38:34', 'admin-1514682622-1514684314678180', 1, 0, '', NULL, NULL, NULL),
(58839, '2017-12-31 09:38:14', NULL, NULL, 15697, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:38:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58840, '2017-12-31 09:33:11', NULL, NULL, 15696, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:33:11', 'admin-1514682622-15146839915235139', 1, 1, 'SR', NULL, NULL, NULL),
(58841, '2017-12-31 09:26:21', NULL, NULL, 15695, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:26:21', 'admin-1514682622-15146835817563612', 1, 1, 'SR', NULL, NULL, NULL),
(58842, '2017-12-31 09:33:03', NULL, NULL, 15696, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:33:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58843, '2017-12-31 09:26:21', NULL, NULL, 15695, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:26:21', 'admin-1514682622-15146835817563612', 1, 0, '', NULL, NULL, NULL),
(58844, '2017-12-31 09:26:21', NULL, NULL, 15695, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514682622', 'admin', '2017-12-31 09:26:21', 'admin-1514682622-15146835817563612', 1, 0, '', NULL, NULL, NULL),
(58845, '2018-01-01 14:41:52', NULL, NULL, 15795, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:41:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58846, '2018-01-01 15:15:01', NULL, NULL, 15799, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:15:01', 'admin-1514768211-15147909018046170', 1, 0, '', NULL, NULL, NULL),
(58847, '2018-01-01 15:15:01', NULL, NULL, 15799, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:15:01', 'admin-1514768211-15147909018046170', 1, 1, 'SR', NULL, NULL, NULL),
(58848, '2018-01-01 15:15:01', NULL, NULL, 15799, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:15:01', 'admin-1514768211-15147909018046170', 1, 1, 'SR', NULL, NULL, NULL),
(58849, '2018-01-01 14:14:27', NULL, NULL, 15792, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:14:28', 'admin-1514768211-15147872678658834', 1, 0, '', NULL, NULL, NULL),
(58850, '2018-01-01 14:26:13', NULL, NULL, 15794, 0, 181, '116', 'Open Food ', 'croissant', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:26:14', 'admin-1514768211-1514787973858939', 1, 0, '', NULL, NULL, NULL),
(58851, '2018-01-01 12:01:54', NULL, NULL, 15775, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:01:54', 'admin-1514768211-15147793138399486', 1, 0, '', 1, NULL, NULL),
(58852, '2018-01-01 12:01:54', NULL, NULL, 15775, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:01:54', 'admin-1514768211-15147793138399486', 1, 0, '', 1, NULL, NULL),
(58853, '2018-01-01 11:25:50', NULL, NULL, 15770, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:25:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58854, '2018-01-01 15:22:50', NULL, NULL, 15796, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:22:50', 'admin-1514768211-15147913708086921', 1, 0, '', NULL, NULL, NULL),
(58855, '2018-01-01 15:31:23', NULL, NULL, 15801, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:31:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58856, '2018-01-01 15:31:36', NULL, NULL, 15801, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:31:36', 'admin-1514768211-15147918963313354', 1, 0, '', NULL, NULL, NULL),
(58857, '2018-01-01 15:31:36', NULL, NULL, 15801, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:31:36', 'admin-1514768211-15147918963313354', 1, 1, 'SR', NULL, NULL, NULL),
(58858, '2018-01-01 15:33:04', NULL, NULL, 15802, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.50, 0.0000, 0.0000, 16.50, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:33:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58859, '2018-01-01 13:47:05', NULL, NULL, 15787, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:47:05', 'admin-1514768211-15147856255979012', 1, 0, '', NULL, NULL, NULL),
(58860, '2018-01-01 12:36:00', NULL, NULL, 15778, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:36:00', 'admin-1514768211-15147813599508341', 1, 0, '', NULL, NULL, NULL),
(58861, '2018-01-01 12:36:00', NULL, NULL, 15778, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:36:00', 'admin-1514768211-15147813599508341', 1, 1, 'SR', NULL, NULL, NULL),
(58862, '2018-01-01 13:28:54', NULL, NULL, 15785, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:28:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58863, '2018-01-01 13:29:31', NULL, NULL, 15785, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:29:31', 'admin-1514768211-15147845712297919', 1, 0, '', NULL, NULL, NULL),
(58864, '2018-01-01 13:29:31', NULL, NULL, 15785, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:29:31', 'admin-1514768211-15147845712297919', 1, 0, '', NULL, NULL, NULL),
(58865, '2018-01-01 13:29:31', NULL, NULL, 15785, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:29:31', 'admin-1514768211-15147845712297919', 1, 0, '', NULL, NULL, NULL),
(58866, '2018-01-01 14:24:47', NULL, NULL, 15794, 0, 153, '87', 'Wake Me Up!', 'toast=croissant', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:24:47', 'admin-1514768211-1514787887450615', 1, 0, '', NULL, NULL, NULL),
(58867, '2018-01-01 13:01:34', NULL, NULL, 15782, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:01:34', 'admin-1514768211-15147828945946295', 1, 0, '', NULL, NULL, NULL),
(58868, '2018-01-01 13:01:34', NULL, NULL, 15782, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:01:34', 'admin-1514768211-15147828945946295', 1, 0, '', NULL, NULL, NULL),
(58869, '2018-01-01 13:01:34', NULL, NULL, 15782, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:01:34', 'admin-1514768211-15147828945946295', 1, 1, 'SR', NULL, NULL, NULL),
(58870, '2018-01-01 13:01:34', NULL, NULL, 15782, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:01:34', 'admin-1514768211-15147828945946295', 1, 1, 'SR', NULL, NULL, NULL),
(58871, '2018-01-01 13:01:34', NULL, NULL, 15782, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:01:34', 'admin-1514768211-15147828945946295', 1, 1, 'SR', NULL, NULL, NULL),
(58872, '2018-01-01 15:35:58', NULL, NULL, 15803, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.79, 0.0000, 0.0000, 3.79, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:35:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58873, '2018-01-01 15:34:23', NULL, NULL, 15802, 0, 154, '88', 'Daily Dose BLT', 'extra bacon', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:34:23', 'admin-1514768211-15147920632345342', 1, 0, '', NULL, NULL, NULL),
(58874, '2018-01-01 15:11:59', NULL, NULL, 15798, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 10.68, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:11:59', 'admin-1514768211-15147907196811663', 1, 0, '', NULL, '11.0', NULL),
(58875, '2018-01-01 14:23:22', NULL, NULL, 15793, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 10.68, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:23:22', 'admin-1514768211-15147878019994015', 1, 0, '', NULL, '11.0', NULL),
(58876, '2018-01-01 12:01:54', NULL, NULL, 15775, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:01:54', 'admin-1514768211-15147793138399486', 1, 0, '', 1, NULL, NULL),
(58877, '2018-01-01 12:09:10', NULL, NULL, 15776, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:09:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58878, '2018-01-01 12:09:24', NULL, NULL, 15776, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:09:24', 'admin-1514768211-15147797643107441', 1, 0, '', NULL, NULL, NULL),
(58879, '2018-01-01 12:09:24', NULL, NULL, 15776, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:09:24', 'admin-1514768211-15147797643107441', 1, 0, '', NULL, NULL, NULL),
(58880, '2018-01-01 15:34:23', NULL, NULL, 15802, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:34:23', 'admin-1514768211-15147920632345342', 1, 0, '', NULL, NULL, NULL),
(58881, '2018-01-01 15:34:23', NULL, NULL, 15802, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:34:23', 'admin-1514768211-15147920632345342', 1, 0, '', NULL, NULL, NULL),
(58882, '2018-01-01 15:15:01', NULL, NULL, 15799, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:15:01', 'admin-1514768211-15147909018046170', 1, 1, 'SR', NULL, NULL, NULL),
(58883, '2018-01-01 13:15:59', NULL, NULL, 15783, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:15:59', 'admin-1514768211-15147837596788571', 1, 0, '', NULL, NULL, NULL),
(58884, '2018-01-01 14:23:22', NULL, NULL, 15793, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 10.68, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:23:22', 'admin-1514768211-15147878019994015', 1, 0, '', NULL, '11.0', NULL),
(58885, '2018-01-01 10:22:47', NULL, NULL, 15757, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:22:47', 'admin-1514768211-15147733673512772', 1, 0, '', NULL, NULL, NULL),
(58886, '2018-01-01 10:26:32', NULL, NULL, 15762, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:26:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58887, '2018-01-01 14:48:39', NULL, NULL, 15796, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:48:39', 'admin-1514768211-1514789318999258', 1, 0, '', NULL, NULL, NULL),
(58888, '2018-01-01 14:48:39', NULL, NULL, 15796, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:48:39', 'admin-1514768211-1514789318999258', 1, 1, 'SR', NULL, NULL, NULL),
(58889, '2018-01-01 15:34:23', NULL, NULL, 15802, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 2, 14.00, 28.0000, 0.0000, 28.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:34:23', 'admin-1514768211-15147920632345342', 1, 1, 'SR', NULL, NULL, NULL),
(58890, '2018-01-01 15:20:21', NULL, NULL, 15800, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:20:21', 'admin-1514768211-15147912215016384', 1, 0, '', NULL, NULL, NULL),
(58891, '2018-01-01 15:20:21', NULL, NULL, 15800, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:20:21', 'admin-1514768211-15147912215016384', 1, 0, '', NULL, NULL, NULL),
(58892, '2018-01-01 15:34:23', NULL, NULL, 15802, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:34:23', 'admin-1514768211-15147920632345342', 1, 1, 'SR', NULL, NULL, NULL),
(58893, '2018-01-01 15:20:21', NULL, NULL, 15800, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:20:21', 'admin-1514768211-15147912215016384', 1, 1, 'SR', NULL, NULL, NULL),
(58894, '2018-01-01 12:55:47', NULL, NULL, 15781, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:55:47', 'admin-1514768211-15147825477044825', 1, 0, '', NULL, NULL, NULL),
(58895, '2018-01-01 12:55:47', NULL, NULL, 15781, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:55:47', 'admin-1514768211-15147825477044825', 1, 0, '', NULL, NULL, NULL),
(58896, '2018-01-01 12:55:47', NULL, NULL, 15781, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:55:47', 'admin-1514768211-15147825477044825', 1, 1, 'SR', NULL, NULL, NULL),
(58897, '2018-01-01 15:15:01', NULL, NULL, 15799, 0, 331, '267', 'Yuzu Marmalade Pancake', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:15:02', 'admin-1514768211-15147909018046170', 1, 0, '', NULL, NULL, NULL),
(58898, '2018-01-01 14:59:02', NULL, NULL, 15797, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:59:02', 'admin-1514768211-1514789942768785', 1, 1, 'SR', NULL, NULL, NULL),
(58899, '2018-01-01 14:59:02', NULL, NULL, 15797, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:59:02', 'admin-1514768211-1514789942768785', 1, 1, 'SR', NULL, NULL, NULL),
(58900, '2018-01-01 14:59:02', NULL, NULL, 15797, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:59:02', 'admin-1514768211-1514789942768785', 1, 0, '', NULL, NULL, NULL),
(58901, '2018-01-01 14:59:02', NULL, NULL, 15797, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:59:02', 'admin-1514768211-1514789942768785', 1, 0, '', NULL, NULL, NULL),
(58902, '2018-01-01 10:26:43', NULL, NULL, 15762, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:26:43', 'admin-1514768211-15147736038012935', 1, 1, 'SR', NULL, NULL, NULL),
(58903, '2018-01-01 10:27:06', NULL, NULL, 15763, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:27:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58904, '2018-01-01 10:27:14', NULL, NULL, 15763, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:27:14', 'admin-1514768211-1514773634492608', 1, 0, '', NULL, NULL, NULL),
(58905, '2018-01-01 09:30:51', NULL, NULL, 15751, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:30:51', 'admin-1514768211-15147702513904744', 1, 1, 'SR', NULL, NULL, NULL),
(58906, '2018-01-01 09:34:09', NULL, NULL, 15752, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:34:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58907, '2018-01-01 09:34:40', NULL, NULL, 15752, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:34:40', 'admin-1514768211-15147704807132830', 1, 0, '', NULL, NULL, NULL),
(58908, '2018-01-01 09:34:40', NULL, NULL, 15752, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:34:40', 'admin-1514768211-15147704807132830', 1, 0, '', NULL, NULL, NULL),
(58909, '2018-01-01 14:58:29', NULL, NULL, 15797, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.57, 0.0000, 0.0000, 6.57, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:58:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58910, '2018-01-01 14:48:39', NULL, NULL, 15796, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:48:39', 'admin-1514768211-1514789318999258', 1, 1, 'SR', NULL, NULL, NULL),
(58911, '2018-01-01 10:07:21', NULL, NULL, 15757, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.20, 0.0000, 0.0000, 14.20, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:07:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58912, '2018-01-01 10:08:03', NULL, NULL, 15757, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:08:03', 'admin-1514768211-15147724833175365', 1, 0, '', NULL, NULL, NULL),
(58913, '2018-01-01 10:08:03', NULL, NULL, 15757, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:08:03', 'admin-1514768211-15147724833175365', 1, 0, '', NULL, NULL, NULL),
(58914, '2018-01-01 10:08:03', NULL, NULL, 15757, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:08:03', 'admin-1514768211-15147724833175365', 1, 0, '', NULL, NULL, NULL),
(58915, '2018-01-01 10:08:03', NULL, NULL, 15757, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:08:03', 'admin-1514768211-15147724833175365', 1, 0, '', NULL, NULL, NULL),
(58916, '2018-01-01 10:08:03', NULL, NULL, 15757, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:08:03', 'admin-1514768211-15147724833175365', 1, 0, '', NULL, NULL, NULL),
(58917, '2018-01-01 14:23:22', NULL, NULL, 15793, 0, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:23:22', 'admin-1514768211-15147878019994015', 1, 1, 'SR', NULL, NULL, NULL),
(58918, '2018-01-01 14:23:22', NULL, NULL, 15793, 0, 331, '267', 'Yuzu Marmalade Pancake', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:23:22', 'admin-1514768211-15147878019994015', 1, 0, '', NULL, NULL, NULL),
(58919, '2018-01-01 10:09:10', NULL, NULL, 15758, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:09:10', 'admin-1514768211-15147725502022895', 1, 1, 'SR', NULL, NULL, NULL),
(58920, '2018-01-01 11:10:57', NULL, NULL, 15766, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:10:57', 'admin-1514768211-15147762576087718', 1, 0, '', 1, NULL, '0.5'),
(58921, '2018-01-01 11:12:54', NULL, NULL, 15767, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:12:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58922, '2018-01-01 11:13:10', NULL, NULL, 15767, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:13:10', 'admin-1514768211-15147763902601995', 1, 0, '', NULL, NULL, NULL),
(58923, '2018-01-01 11:13:10', NULL, NULL, 15767, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:13:10', 'admin-1514768211-15147763902601995', 1, 0, '', NULL, NULL, NULL),
(58924, '2018-01-01 12:55:47', NULL, NULL, 15781, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:55:47', 'admin-1514768211-15147825477044825', 1, 1, 'SR', NULL, NULL, NULL),
(58925, '2018-01-01 12:55:32', NULL, NULL, 15781, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:55:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58926, '2018-01-01 09:47:16', NULL, NULL, 15754, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:47:16', 'admin-1514768211-15147712359996398', 1, 1, 'SR', NULL, NULL, NULL),
(58927, '2018-01-01 09:47:16', NULL, NULL, 15754, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:47:16', 'admin-1514768211-15147712359996398', 1, 1, 'SR', NULL, NULL, NULL),
(58928, '2018-01-01 09:47:16', NULL, NULL, 15754, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:47:16', 'admin-1514768211-15147712359996398', 1, 1, 'SR', NULL, NULL, NULL),
(58929, '2018-01-01 09:51:44', NULL, NULL, 15755, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.60, 0.0000, 0.0000, 9.60, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:51:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58930, '2018-01-01 13:47:05', NULL, NULL, 15787, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:47:05', 'admin-1514768211-15147856255979012', 1, 0, '', NULL, NULL, NULL),
(58931, '2018-01-01 13:47:10', NULL, NULL, 15788, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:47:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58932, '2018-01-01 13:47:53', NULL, NULL, 15788, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:47:53', 'admin-1514768211-15147856733966765', 1, 0, '', NULL, NULL, NULL),
(58933, '2018-01-01 12:01:54', NULL, NULL, 15775, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:01:54', 'admin-1514768211-15147793138399486', 1, 0, '', 1, NULL, NULL),
(58934, '2018-01-01 12:38:01', NULL, NULL, 15779, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:38:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58935, '2018-01-01 14:23:22', NULL, NULL, 15793, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:23:22', 'admin-1514768211-15147878019994015', 1, 1, 'SR', NULL, NULL, NULL),
(58936, '2018-01-01 11:13:44', NULL, NULL, 15768, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:13:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58937, '2018-01-01 14:23:22', NULL, NULL, 15793, 0, 337, '273', 'Hot yuzu', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:23:22', 'admin-1514768211-15147878019994015', 1, 0, '', NULL, NULL, NULL),
(58938, '2018-01-01 14:21:10', NULL, NULL, 15793, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.49, 0.0000, 0.0000, 9.49, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:21:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58939, '2018-01-01 13:35:21', NULL, NULL, 15786, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:35:21', 'admin-1514768211-15147849216909045', 1, 0, '', NULL, NULL, NULL),
(58940, '2018-01-01 13:59:22', NULL, NULL, 15790, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:59:22', 'admin-1514768211-15147863621749072', 1, 0, '', NULL, NULL, NULL),
(58941, '2018-01-01 14:14:28', NULL, NULL, 15792, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:14:28', 'admin-1514768211-15147872678658834', 1, 0, '', NULL, NULL, NULL),
(58942, '2018-01-01 14:14:28', NULL, NULL, 15792, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:14:28', 'admin-1514768211-15147872678658834', 1, 0, '', NULL, NULL, NULL),
(58943, '2018-01-01 12:14:57', NULL, NULL, 15777, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:14:57', 'admin-1514768211-15147800974056995', 1, 0, '', NULL, NULL, NULL),
(58944, '2018-01-01 14:14:12', NULL, NULL, 15792, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:14:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58945, '2018-01-01 14:01:31', NULL, NULL, 15791, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:01:31', 'admin-1514768211-15147864911955195', 1, 1, 'SR', 1, NULL, '10.0'),
(58946, '2018-01-01 14:01:31', NULL, NULL, 15791, 0, 181, '116', 'Open Food ', 'BFF', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:01:31', 'admin-1514768211-15147864911955195', 1, 0, '', 1, NULL, '10.0'),
(58947, '2018-01-01 14:05:35', NULL, NULL, 15788, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:05:35', 'admin-1514768211-15147867358004598', 1, 0, '', NULL, NULL, NULL),
(58948, '2018-01-01 12:46:13', NULL, NULL, 15778, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:46:13', 'admin-1514768211-1514781972962672', 1, 0, '', NULL, NULL, NULL),
(58949, '2018-01-01 12:43:00', NULL, NULL, 15780, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 8.90, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:43:00', 'admin-1514768211-15147817802627597', 1, 0, '', NULL, '11.0', NULL),
(58950, '2018-01-01 12:46:13', NULL, NULL, 15778, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:46:13', 'admin-1514768211-1514781972962672', 1, 0, '', NULL, NULL, NULL),
(58951, '2018-01-01 13:59:22', NULL, NULL, 15790, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 8.90, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:59:22', 'admin-1514768211-15147863621749072', 1, 0, '', NULL, '11.0', NULL),
(58952, '2018-01-01 13:59:15', NULL, NULL, 15790, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.99, 0.0000, 0.0000, 1.99, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:59:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58953, '2018-01-01 12:46:13', NULL, NULL, 15778, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:46:13', 'admin-1514768211-1514781972962672', 1, 0, '', NULL, NULL, NULL),
(58954, '2018-01-01 12:46:13', NULL, NULL, 15778, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:46:13', 'admin-1514768211-1514781972962672', 1, 0, '', NULL, NULL, NULL),
(58955, '2018-01-01 13:51:35', NULL, NULL, 15787, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:51:35', 'admin-1514768211-15147858953113463', 1, 1, 'SR', NULL, NULL, NULL),
(58956, '2018-01-01 13:48:30', NULL, NULL, 15789, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:48:30', 'admin-1514768211-15147857106091368', 1, 1, 'SR', NULL, NULL, NULL),
(58957, '2018-01-01 13:47:53', NULL, NULL, 15788, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:47:53', 'admin-1514768211-15147856733966765', 1, 1, 'SR', NULL, NULL, NULL),
(58958, '2018-01-01 13:47:53', NULL, NULL, 15788, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:47:53', 'admin-1514768211-15147856733966765', 1, 1, 'SR', NULL, NULL, NULL),
(58959, '2018-01-01 13:47:53', NULL, NULL, 15788, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:47:53', 'admin-1514768211-15147856733966765', 1, 0, '', NULL, NULL, NULL),
(58960, '2018-01-01 13:47:05', NULL, NULL, 15787, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:47:05', 'admin-1514768211-15147856255979012', 1, 1, 'SR', NULL, NULL, NULL),
(58961, '2018-01-01 13:47:05', NULL, NULL, 15787, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:47:05', 'admin-1514768211-15147856255979012', 1, 0, '', NULL, NULL, NULL),
(58962, '2018-01-01 10:44:16', NULL, NULL, 15765, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:44:16', 'admin-1514768211-15147746561747978', 1, 0, '', NULL, NULL, NULL),
(58963, '2018-01-01 10:16:24', NULL, NULL, 15760, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:16:24', 'admin-1514768211-15147729840514091', 1, 1, 'SR', NULL, NULL, NULL),
(58964, '2018-01-01 14:24:47', NULL, NULL, 15794, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:24:47', 'admin-1514768211-1514787887450615', 1, 1, 'SR', NULL, NULL, NULL),
(58965, '2018-01-01 13:35:21', NULL, NULL, 15786, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:35:21', 'admin-1514768211-15147849216909045', 1, 0, '', NULL, NULL, NULL),
(58966, '2018-01-01 13:46:30', NULL, NULL, 15787, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:46:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58967, '2018-01-01 11:40:41', NULL, NULL, 15773, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:40:41', 'admin-1514768211-15147780413671754', 1, 0, '', NULL, NULL, NULL),
(58968, '2018-01-01 11:40:41', NULL, NULL, 15773, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:40:41', 'admin-1514768211-15147780413671754', 1, 1, 'SR', NULL, NULL, NULL),
(58969, '2018-01-01 12:46:13', NULL, NULL, 15778, 0, 335, '271', 'Iced Honey Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:46:13', 'admin-1514768211-1514781972962672', 1, 0, '', NULL, NULL, NULL),
(58970, '2018-01-01 11:26:05', NULL, NULL, 15770, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:26:05', 'admin-1514768211-15147771656759429', 1, 0, '', NULL, NULL, NULL),
(58971, '2018-01-01 12:32:52', NULL, NULL, 15774, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:32:52', 'admin-1514768211-15147811720307524', 1, 1, 'SR', NULL, NULL, NULL),
(58972, '2018-01-01 13:34:24', NULL, NULL, 15786, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:34:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58973, '2018-01-01 13:35:21', NULL, NULL, 15786, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:35:21', 'admin-1514768211-15147849216909045', 1, 1, 'SR', NULL, NULL, NULL),
(58974, '2018-01-01 10:09:10', NULL, NULL, 15758, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:09:10', 'admin-1514768211-15147725502022895', 1, 1, 'SR', NULL, NULL, NULL),
(58975, '2018-01-01 10:12:59', NULL, NULL, 15759, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 12.90, 0.0000, 0.0000, 12.90, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:12:59', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(58976, '2018-01-01 10:13:36', NULL, NULL, 15759, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:13:36', 'admin-1514768211-15147728161683287', 1, 0, '', NULL, NULL, NULL),
(58977, '2018-01-01 10:13:36', NULL, NULL, 15759, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:13:36', 'admin-1514768211-15147728161683287', 1, 0, '', NULL, NULL, NULL),
(58978, '2018-01-01 10:13:36', NULL, NULL, 15759, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:13:36', 'admin-1514768211-15147728161683287', 1, 0, '', NULL, NULL, NULL),
(58979, '2018-01-01 10:13:36', NULL, NULL, 15759, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:13:36', 'admin-1514768211-15147728161683287', 1, 0, '', NULL, NULL, NULL),
(58980, '2018-01-01 15:11:59', NULL, NULL, 15798, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 9.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:11:59', 'admin-1514768211-15147907196811663', 1, 0, '', NULL, NULL, NULL),
(58981, '2018-01-01 13:15:59', NULL, NULL, 15783, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:15:59', 'admin-1514768211-15147837596788571', 1, 0, '', NULL, NULL, NULL),
(58982, '2018-01-01 13:15:59', NULL, NULL, 15783, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:15:59', 'admin-1514768211-15147837596788571', 1, 1, 'SR', NULL, NULL, NULL),
(58983, '2018-01-01 13:15:59', NULL, NULL, 15783, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:15:59', 'admin-1514768211-15147837596788571', 1, 0, '', NULL, NULL, NULL),
(58984, '2018-01-01 15:34:23', NULL, NULL, 15802, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:34:23', 'admin-1514768211-15147920632345342', 1, 0, '', NULL, NULL, NULL),
(58985, '2018-01-01 13:29:31', NULL, NULL, 15785, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:29:31', 'admin-1514768211-15147845712297919', 1, 0, '', NULL, NULL, NULL),
(58986, '2018-01-01 13:15:59', NULL, NULL, 15783, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:15:59', 'admin-1514768211-15147837596788571', 1, 1, 'SR', NULL, NULL, NULL),
(58987, '2018-01-01 13:15:59', NULL, NULL, 15783, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:15:59', 'admin-1514768211-15147837596788571', 1, 0, '', NULL, NULL, NULL),
(58988, '2018-01-01 13:24:04', NULL, NULL, 15784, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:24:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58989, '2018-01-01 13:24:23', NULL, NULL, 15784, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:24:23', 'admin-1514768211-15147842630445387', 1, 0, '', NULL, NULL, NULL),
(58990, '2018-01-01 10:06:56', NULL, NULL, 15756, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:06:56', 'admin-1514768211-15147724162142156', 1, 0, '', NULL, NULL, NULL),
(58991, '2018-01-01 10:53:35', NULL, NULL, 15762, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:53:35', 'admin-1514768211-15147752158428444', 1, 0, '', NULL, NULL, NULL),
(58992, '2018-01-01 10:53:35', NULL, NULL, 15762, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:53:35', 'admin-1514768211-15147752158428444', 1, 0, '', NULL, NULL, NULL),
(58993, '2018-01-01 14:23:42', NULL, NULL, 15794, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:23:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(58994, '2018-01-01 13:15:59', NULL, NULL, 15783, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:15:59', 'admin-1514768211-15147837596788571', 1, 1, 'SR', NULL, NULL, NULL),
(58995, '2018-01-01 13:24:23', NULL, NULL, 15784, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:24:23', 'admin-1514768211-15147842630445387', 1, 0, '', NULL, NULL, NULL),
(58996, '2018-01-01 13:15:59', NULL, NULL, 15783, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:15:59', 'admin-1514768211-15147837596788571', 1, 0, '', NULL, NULL, NULL),
(58997, '2018-01-01 13:15:59', NULL, NULL, 15783, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:15:59', 'admin-1514768211-15147837596788571', 1, 0, '', NULL, NULL, NULL),
(58998, '2018-01-01 10:28:16', NULL, NULL, 15764, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:28:16', 'admin-1514768211-15147736961015733', 1, 0, '', NULL, NULL, NULL),
(58999, '2018-01-01 10:28:16', NULL, NULL, 15764, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:28:16', 'admin-1514768211-15147736961015733', 1, 0, '', NULL, NULL, NULL),
(59000, '2018-01-01 10:28:16', NULL, NULL, 15764, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:28:16', 'admin-1514768211-15147736961015733', 1, 0, '', NULL, NULL, NULL),
(59001, '2018-01-01 10:28:16', NULL, NULL, 15764, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:28:16', 'admin-1514768211-15147736961015733', 1, 0, '', NULL, NULL, NULL),
(59002, '2018-01-01 12:52:11', NULL, NULL, 15779, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:52:11', 'admin-1514768211-1514782331096171', 1, 1, 'SR', NULL, NULL, NULL),
(59003, '2018-01-01 11:51:37', NULL, NULL, 15774, 0, 310, '246', 'AA Set - Double Fried Salted Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:51:37', 'admin-1514768211-1514778697471513', 1, 0, '', NULL, NULL, NULL),
(59004, '2018-01-01 11:54:26', NULL, NULL, 15773, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:54:26', 'admin-1514768211-15147788665167343', 1, 0, '', NULL, NULL, NULL),
(59005, '2018-01-01 12:01:54', NULL, NULL, 15775, 0, 265, '199', 'Old Penang PostCard', '', 'DISCOUNT ', '0', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:01:54', 'admin-1514768211-15147793138399486', 1, 0, '', 1, NULL, NULL),
(59006, '2018-01-01 09:47:16', NULL, NULL, 15754, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:47:16', 'admin-1514768211-15147712359996398', 1, 0, '', NULL, NULL, NULL),
(59007, '2018-01-01 13:14:27', NULL, NULL, 15783, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.10, 0.0000, 0.0000, 13.10, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:14:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59008, '2018-01-01 14:23:22', NULL, NULL, 15793, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 8.90, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:23:22', 'admin-1514768211-15147878019994015', 1, 0, '', NULL, '11.0', NULL),
(59009, '2018-01-01 11:30:11', NULL, NULL, 15771, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:30:11', 'admin-1514768211-1514777410867385', 1, 1, 'SR', NULL, NULL, NULL),
(59010, '2018-01-01 10:28:16', NULL, NULL, 15764, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:28:16', 'admin-1514768211-15147736961015733', 1, 0, '', NULL, NULL, NULL),
(59011, '2018-01-01 10:16:24', NULL, NULL, 15760, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:16:24', 'admin-1514768211-15147729840514091', 1, 0, '', NULL, NULL, NULL),
(59012, '2018-01-01 11:09:29', NULL, NULL, 15761, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:09:29', 'admin-1514768211-15147761691473691', 1, 0, '', NULL, NULL, NULL),
(59013, '2018-01-01 11:10:57', NULL, NULL, 15766, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:10:57', 'admin-1514768211-15147762576087718', 1, 0, '', 1, NULL, '0.5'),
(59014, '2018-01-01 12:46:13', NULL, NULL, 15778, 0, 335, '271', 'Iced Honey Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:46:13', 'admin-1514768211-1514781972962672', 1, 0, '', NULL, NULL, NULL),
(59015, '2018-01-01 12:38:11', NULL, NULL, 15779, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:38:11', 'admin-1514768211-15147814917881786', 1, 0, '', NULL, NULL, NULL),
(59016, '2018-01-01 12:43:00', NULL, NULL, 15780, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:43:00', 'admin-1514768211-15147817802627597', 1, 1, 'SR', NULL, NULL, NULL),
(59017, '2018-01-01 12:42:49', NULL, NULL, 15780, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.19, 0.0000, 0.0000, 3.19, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:42:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59018, '2018-01-01 12:43:00', NULL, NULL, 15780, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:43:00', 'admin-1514768211-15147817802627597', 1, 1, 'SR', NULL, NULL, NULL),
(59019, '2018-01-01 14:59:10', NULL, NULL, 15797, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 10.68, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:59:10', 'admin-1514768211-15147899502861489', 1, 0, '', NULL, '11.0', NULL),
(59020, '2018-01-01 11:37:33', NULL, NULL, 15772, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:37:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59021, '2018-01-01 09:44:53', NULL, NULL, 15753, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:44:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59022, '2018-01-01 09:45:06', NULL, NULL, 15753, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:45:06', 'admin-1514768211-15147711064404250', 1, 1, 'SR', NULL, NULL, NULL),
(59023, '2018-01-01 09:45:06', NULL, NULL, 15753, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:45:06', 'admin-1514768211-15147711064404250', 1, 1, 'SR', NULL, NULL, NULL),
(59024, '2018-01-01 09:45:06', NULL, NULL, 15753, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:45:06', 'admin-1514768211-15147711064404250', 1, 0, '', NULL, NULL, NULL),
(59025, '2018-01-01 10:16:00', NULL, NULL, 15760, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:16:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59026, '2018-01-01 13:29:31', NULL, NULL, 15785, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:29:31', 'admin-1514768211-15147845712297919', 1, 1, 'SR', NULL, NULL, NULL),
(59027, '2018-01-01 15:19:54', NULL, NULL, 15800, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:19:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59028, '2018-01-01 13:28:33', NULL, NULL, 15782, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:28:33', 'admin-1514768211-15147845131183386', 1, 0, '', NULL, NULL, NULL),
(59029, '2018-01-01 12:38:11', NULL, NULL, 15779, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:38:11', 'admin-1514768211-15147814917881786', 1, 0, '', NULL, NULL, NULL),
(59030, '2018-01-01 12:38:11', NULL, NULL, 15779, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:38:11', 'admin-1514768211-15147814917881786', 1, 0, '', NULL, NULL, NULL),
(59031, '2018-01-01 12:36:00', NULL, NULL, 15778, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:36:00', 'admin-1514768211-15147813599508341', 1, 0, '', NULL, NULL, NULL),
(59032, '2018-01-01 14:42:08', NULL, NULL, 15795, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:42:08', 'admin-1514768211-15147889281519811', 1, 0, '', NULL, NULL, NULL),
(59033, '2018-01-01 10:44:16', NULL, NULL, 15765, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:44:16', 'admin-1514768211-15147746561747978', 1, 0, '', NULL, NULL, NULL),
(59034, '2018-01-01 12:36:00', NULL, NULL, 15778, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:36:00', 'admin-1514768211-15147813599508341', 1, 0, '', NULL, NULL, NULL),
(59035, '2018-01-01 12:35:44', NULL, NULL, 15778, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 20.70, 0.0000, 0.0000, 20.70, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:35:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59036, '2018-01-01 12:14:57', NULL, NULL, 15777, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:14:57', 'admin-1514768211-15147800974056995', 1, 1, 'SR', NULL, NULL, NULL),
(59037, '2018-01-01 14:48:39', NULL, NULL, 15796, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:48:39', 'admin-1514768211-1514789318999258', 1, 1, 'SR', NULL, NULL, NULL),
(59038, '2018-01-01 12:14:57', NULL, NULL, 15777, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:14:57', 'admin-1514768211-15147800974056995', 1, 0, '', NULL, NULL, NULL),
(59039, '2018-01-01 12:09:24', NULL, NULL, 15776, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:09:24', 'admin-1514768211-15147797643107441', 1, 1, 'SR', NULL, NULL, NULL),
(59040, '2018-01-01 12:14:57', NULL, NULL, 15777, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:14:57', 'admin-1514768211-15147800974056995', 1, 1, 'SR', NULL, NULL, NULL),
(59041, '2018-01-01 12:14:33', NULL, NULL, 15777, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:14:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59042, '2018-01-01 14:23:22', NULL, NULL, 15793, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:23:22', 'admin-1514768211-15147878019994015', 1, 1, 'SR', NULL, NULL, NULL),
(59043, '2018-01-01 12:09:24', NULL, NULL, 15776, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:09:24', 'admin-1514768211-15147797643107441', 1, 1, 'SR', NULL, NULL, NULL),
(59044, '2018-01-01 10:00:40', NULL, NULL, 15756, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:00:40', 'admin-1514768211-15147720402183998', 1, 0, '', NULL, NULL, NULL),
(59045, '2018-01-01 14:42:08', NULL, NULL, 15795, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:42:08', 'admin-1514768211-15147889281519811', 1, 1, 'SR', NULL, NULL, NULL),
(59046, '2018-01-01 12:01:54', NULL, NULL, 15775, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:01:54', 'admin-1514768211-15147793138399486', 1, 0, '', 1, NULL, NULL),
(59047, '2018-01-01 12:01:54', NULL, NULL, 15775, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:01:54', 'admin-1514768211-15147793138399486', 1, 0, '', 1, NULL, NULL),
(59048, '2018-01-01 11:45:06', NULL, NULL, 15774, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:45:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59049, '2018-01-01 10:27:14', NULL, NULL, 15763, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:27:14', 'admin-1514768211-1514773634492608', 1, 0, '', NULL, NULL, NULL),
(59050, '2018-01-01 10:16:29', NULL, NULL, 15761, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:16:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59051, '2018-01-01 11:51:37', NULL, NULL, 15774, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:51:37', 'admin-1514768211-1514778697471513', 1, 0, '', NULL, NULL, NULL),
(59052, '2018-01-01 11:51:37', NULL, NULL, 15774, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:51:37', 'admin-1514768211-1514778697471513', 1, 0, '', NULL, NULL, NULL),
(59053, '2018-01-01 10:44:16', NULL, NULL, 15765, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:44:16', 'admin-1514768211-15147746561747978', 1, 0, '', NULL, NULL, NULL),
(59054, '2018-01-01 13:01:14', NULL, NULL, 15782, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.30, 0.0000, 0.0000, 10.30, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:01:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59055, '2018-01-01 15:36:26', NULL, NULL, 15803, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:36:26', 'admin-1514768211-15147921866739363', 1, 0, '', NULL, NULL, NULL),
(59056, '2018-01-01 13:01:34', NULL, NULL, 15782, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:01:34', 'admin-1514768211-15147828945946295', 1, 0, '', NULL, NULL, NULL),
(59057, '2018-01-01 13:48:21', NULL, NULL, 15789, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:48:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59058, '2018-01-01 11:45:18', NULL, NULL, 15774, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:45:18', 'admin-1514768211-1514778318305628', 1, 1, 'SR', NULL, NULL, NULL),
(59059, '2018-01-01 11:40:25', NULL, NULL, 15773, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:40:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59060, '2018-01-01 11:37:57', NULL, NULL, 15772, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:37:57', 'admin-1514768211-15147778769403652', 1, 0, '', NULL, NULL, NULL),
(59061, '2018-01-01 11:37:57', NULL, NULL, 15772, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:37:57', 'admin-1514768211-15147778769403652', 1, 1, 'SR', NULL, NULL, NULL),
(59062, '2018-01-01 11:37:57', NULL, NULL, 15772, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:37:57', 'admin-1514768211-15147778769403652', 1, 0, '', NULL, NULL, NULL),
(59063, '2018-01-01 11:37:25', NULL, NULL, 15759, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:37:25', 'admin-1514768211-15147778456779921', 1, 1, 'SR', NULL, NULL, NULL),
(59064, '2018-01-01 11:14:17', NULL, NULL, 15768, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:14:17', 'admin-1514768211-15147764573179636', 1, 0, '', NULL, NULL, NULL),
(59065, '2018-01-01 11:19:13', NULL, NULL, 15769, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:19:13', 'admin-1514768211-15147767532251934', 1, 0, '', NULL, NULL, NULL),
(59066, '2018-01-01 11:19:13', NULL, NULL, 15769, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:19:13', 'admin-1514768211-15147767532251934', 1, 0, '', NULL, NULL, NULL),
(59067, '2018-01-01 14:23:22', NULL, NULL, 15793, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 10.68, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:23:22', 'admin-1514768211-15147878019994015', 1, 0, '', NULL, '11.0', NULL),
(59068, '2018-01-01 11:37:25', NULL, NULL, 15759, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:37:25', 'admin-1514768211-15147778456779921', 1, 1, 'SR', NULL, NULL, NULL),
(59069, '2018-01-01 11:37:25', NULL, NULL, 15759, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:37:25', 'admin-1514768211-15147778456779921', 1, 1, 'SR', NULL, NULL, NULL),
(59070, '2018-01-01 11:30:11', NULL, NULL, 15771, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:30:11', 'admin-1514768211-1514777410867385', 1, 1, 'SR', NULL, NULL, NULL),
(59071, '2018-01-01 10:44:16', NULL, NULL, 15765, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:44:16', 'admin-1514768211-15147746561747978', 1, 1, 'SR', NULL, NULL, NULL),
(59072, '2018-01-01 11:30:11', NULL, NULL, 15771, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:30:11', 'admin-1514768211-1514777410867385', 1, 0, '', NULL, NULL, NULL),
(59073, '2018-01-01 11:30:10', NULL, NULL, 15771, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:30:10', 'admin-1514768211-1514777410867385', 1, 0, '', NULL, NULL, NULL),
(59074, '2018-01-01 11:29:48', NULL, NULL, 15771, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:29:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59075, '2018-01-01 10:44:16', NULL, NULL, 15765, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:44:16', 'admin-1514768211-15147746561747978', 1, 1, 'SR', NULL, NULL, NULL),
(59076, '2018-01-01 11:26:05', NULL, NULL, 15770, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:26:05', 'admin-1514768211-15147771656759429', 1, 1, 'SR', NULL, NULL, NULL),
(59077, '2018-01-01 15:36:26', NULL, NULL, 15803, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:36:26', 'admin-1514768211-15147921866739363', 1, 0, '', NULL, NULL, NULL),
(59078, '2018-01-01 11:26:05', NULL, NULL, 15770, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:26:05', 'admin-1514768211-15147771656759429', 1, 0, '', NULL, NULL, NULL),
(59079, '2018-01-01 11:19:13', NULL, NULL, 15769, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:19:13', 'admin-1514768211-15147767532251934', 1, 0, '', NULL, NULL, NULL),
(59080, '2018-01-01 11:14:17', NULL, NULL, 15768, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:14:17', 'admin-1514768211-15147764573179636', 1, 1, 'SR', NULL, NULL, NULL),
(59081, '2018-01-01 11:13:32', NULL, NULL, 15767, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:13:32', 'admin-1514768211-15147764122746783', 1, 0, '', NULL, NULL, NULL),
(59082, '2018-01-01 09:21:20', NULL, NULL, 15751, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.00, 0.0000, 0.0000, 13.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:21:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59083, '2018-01-01 09:21:42', NULL, NULL, 15751, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:21:42', 'admin-1514768211-1514769701884879', 1, 1, 'SR', NULL, NULL, NULL),
(59084, '2018-01-01 11:18:56', NULL, NULL, 15769, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:18:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59085, '2018-01-01 11:14:17', NULL, NULL, 15768, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:14:17', 'admin-1514768211-15147764573179636', 1, 1, 'SR', NULL, NULL, NULL),
(59086, '2018-01-01 11:13:10', NULL, NULL, 15767, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:13:10', 'admin-1514768211-15147763902601995', 1, 1, 'SR', NULL, NULL, NULL),
(59087, '2018-01-01 11:13:10', NULL, NULL, 15767, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:13:10', 'admin-1514768211-15147763902601995', 1, 1, 'SR', NULL, NULL, NULL),
(59088, '2018-01-01 13:35:21', NULL, NULL, 15786, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 13:35:21', 'admin-1514768211-15147849216909045', 1, 1, 'SR', NULL, NULL, NULL),
(59089, '2018-01-01 11:10:57', NULL, NULL, 15766, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:10:57', 'admin-1514768211-15147762576087718', 1, 0, '', 1, NULL, '0.5'),
(59090, '2018-01-01 09:34:40', NULL, NULL, 15752, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:34:40', 'admin-1514768211-15147704807132830', 1, 0, '', NULL, NULL, NULL),
(59091, '2018-01-01 10:34:21', NULL, NULL, 15764, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:34:21', 'admin-1514768211-15147740608785382', 1, 0, '', NULL, NULL, NULL),
(59092, '2018-01-01 10:43:34', NULL, NULL, 15765, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:43:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59093, '2018-01-01 09:47:16', NULL, NULL, 15754, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:47:16', 'admin-1514768211-15147712359996398', 1, 0, '', NULL, NULL, NULL),
(59094, '2018-01-01 09:30:51', NULL, NULL, 15751, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:30:51', 'admin-1514768211-15147702513904744', 1, 1, 'SR', NULL, NULL, NULL),
(59095, '2018-01-01 15:11:44', NULL, NULL, 15798, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.87, 0.0000, 0.0000, 2.87, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:11:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59096, '2018-01-01 10:44:16', NULL, NULL, 15765, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:44:16', 'admin-1514768211-15147746561747978', 1, 0, '', NULL, NULL, NULL),
(59097, '2018-01-01 10:28:16', NULL, NULL, 15764, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:28:16', 'admin-1514768211-15147736961015733', 1, 0, '', NULL, NULL, NULL),
(59098, '2018-01-01 10:27:19', NULL, NULL, 15764, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 13.00, 0.0000, 0.0000, 13.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:27:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59099, '2018-01-01 10:26:43', NULL, NULL, 15762, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:26:43', 'admin-1514768211-15147736038012935', 1, 1, 'SR', NULL, NULL, NULL),
(59100, '2018-01-01 12:36:00', NULL, NULL, 15778, 0, 311, '247', 'AA Set - Shimeji Mushroom with Chicken', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:36:00', 'admin-1514768211-15147813599508341', 1, 0, '', NULL, NULL, NULL),
(59101, '2018-01-01 12:32:52', NULL, NULL, 15774, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:32:52', 'admin-1514768211-15147811720307524', 1, 0, '', NULL, NULL, NULL),
(59102, '2018-01-01 10:16:38', NULL, NULL, 15761, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:16:38', 'admin-1514768211-15147729980567146', 1, 0, '', NULL, NULL, NULL),
(59103, '2018-01-01 10:16:38', NULL, NULL, 15761, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:16:38', 'admin-1514768211-15147729980567146', 1, 0, '', NULL, NULL, NULL),
(59104, '2018-01-01 09:53:43', NULL, NULL, 15755, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:53:43', 'admin-1514768211-1514771622920663', 1, 0, '', NULL, NULL, NULL),
(59105, '2018-01-01 09:53:43', NULL, NULL, 15755, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:53:43', 'admin-1514768211-1514771622920663', 1, 0, '', NULL, NULL, NULL),
(59106, '2018-01-01 09:53:43', NULL, NULL, 15755, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:53:43', 'admin-1514768211-1514771622920663', 1, 0, '', NULL, NULL, NULL),
(59107, '2018-01-01 15:14:26', NULL, NULL, 15799, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:14:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59108, '2018-01-01 10:22:47', NULL, NULL, 15757, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:22:47', 'admin-1514768211-15147733673512772', 1, 1, 'SR', NULL, NULL, NULL),
(59109, '2018-01-01 12:38:11', NULL, NULL, 15779, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:38:11', 'admin-1514768211-15147814917881786', 1, 1, 'SR', NULL, NULL, NULL),
(59110, '2018-01-01 12:46:13', NULL, NULL, 15778, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 12:46:13', 'admin-1514768211-1514781972962672', 1, 0, '', NULL, NULL, NULL),
(59111, '2018-01-01 11:45:18', NULL, NULL, 15774, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 11:45:18', 'admin-1514768211-1514778318305628', 1, 1, 'SR', NULL, NULL, NULL),
(59112, '2018-01-01 10:16:24', NULL, NULL, 15760, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:16:24', 'admin-1514768211-15147729840514091', 1, 0, '', NULL, NULL, NULL),
(59113, '2018-01-01 10:13:36', NULL, NULL, 15759, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:13:36', 'admin-1514768211-15147728161683287', 1, 1, 'SR', NULL, NULL, NULL),
(59114, '2018-01-01 09:21:42', NULL, NULL, 15751, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:21:42', 'admin-1514768211-1514769701884879', 1, 1, 'SR', NULL, NULL, NULL),
(59115, '2018-01-01 10:16:24', NULL, NULL, 15760, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:16:24', 'admin-1514768211-15147729840514091', 1, 0, '', NULL, NULL, NULL),
(59116, '2018-01-01 10:13:36', NULL, NULL, 15759, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:13:36', 'admin-1514768211-15147728161683287', 1, 1, 'SR', NULL, NULL, NULL),
(59117, '2018-01-01 10:09:10', NULL, NULL, 15758, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:09:10', 'admin-1514768211-15147725502022895', 1, 0, '', NULL, NULL, NULL),
(59118, '2018-01-01 10:09:10', NULL, NULL, 15758, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:09:10', 'admin-1514768211-15147725502022895', 1, 0, '', NULL, NULL, NULL),
(59119, '2018-01-01 10:06:56', NULL, NULL, 15756, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:06:56', 'admin-1514768211-15147724162142156', 1, 0, '', NULL, NULL, NULL),
(59120, '2018-01-01 10:08:03', NULL, NULL, 15757, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:08:03', 'admin-1514768211-15147724833175365', 1, 0, '', NULL, NULL, NULL),
(59121, '2018-01-01 10:08:03', NULL, NULL, 15757, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:08:03', 'admin-1514768211-15147724833175365', 1, 1, 'SR', NULL, NULL, NULL),
(59122, '2018-01-01 10:08:43', NULL, NULL, 15758, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:08:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59123, '2018-01-01 10:09:10', NULL, NULL, 15758, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:09:10', 'admin-1514768211-15147725502022895', 1, 0, '', NULL, NULL, NULL),
(59124, '2018-01-01 10:08:03', NULL, NULL, 15757, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:08:03', 'admin-1514768211-15147724833175365', 1, 1, 'SR', NULL, NULL, NULL),
(59125, '2018-01-01 14:48:13', NULL, NULL, 15796, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:48:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59126, '2018-01-01 09:47:16', NULL, NULL, 15754, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:47:16', 'admin-1514768211-15147712359996398', 1, 1, 'SR', NULL, NULL, NULL),
(59127, '2018-01-01 10:00:40', NULL, NULL, 15756, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:00:40', 'admin-1514768211-15147720402183998', 1, 0, '', NULL, NULL, NULL),
(59128, '2018-01-01 10:00:40', NULL, NULL, 15756, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:00:40', 'admin-1514768211-15147720402183998', 1, 0, '', NULL, NULL, NULL),
(59129, '2018-01-01 14:27:44', NULL, NULL, 15794, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 14:27:44', 'admin-1514768211-15147880644276695', 1, 0, '', NULL, NULL, NULL),
(59130, '2018-01-01 10:00:40', NULL, NULL, 15756, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:00:40', 'admin-1514768211-15147720402183998', 1, 1, 'SR', NULL, NULL, NULL),
(59131, '2018-01-01 10:00:40', NULL, NULL, 15756, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:00:40', 'admin-1514768211-15147720402183998', 1, 0, '', NULL, NULL, NULL),
(59132, '2018-01-01 10:00:40', NULL, NULL, 15756, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:00:40', 'admin-1514768211-15147720402183998', 1, 0, '', NULL, NULL, NULL),
(59133, '2018-01-01 09:59:21', NULL, NULL, 15755, 0, 181, '116', 'Open Food ', 'yogurt', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:59:21', 'admin-1514768211-15147719613319966', 1, 0, '', NULL, NULL, NULL),
(59134, '2018-01-01 09:58:23', NULL, NULL, 15754, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:58:23', 'admin-1514768211-15147719034966224', 1, 0, '', NULL, NULL, NULL),
(59135, '2018-01-01 09:57:45', NULL, NULL, 15756, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.50, 0.0000, 0.0000, 11.50, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:57:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59136, '2018-01-01 09:53:43', NULL, NULL, 15755, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:53:43', 'admin-1514768211-1514771622920663', 1, 1, 'SR', NULL, NULL, NULL),
(59137, '2018-01-01 09:53:43', NULL, NULL, 15755, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:53:43', 'admin-1514768211-1514771622920663', 1, 1, 'SR', NULL, NULL, NULL),
(59138, '2018-01-01 09:53:43', NULL, NULL, 15755, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:53:43', 'admin-1514768211-1514771622920663', 1, 1, 'SR', NULL, NULL, NULL),
(59139, '2018-01-01 09:47:16', NULL, NULL, 15754, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:47:16', 'admin-1514768211-15147712359996398', 1, 0, '', NULL, NULL, NULL),
(59140, '2018-01-01 09:47:16', NULL, NULL, 15754, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:47:16', 'admin-1514768211-15147712359996398', 1, 0, '', NULL, NULL, NULL),
(59141, '2018-01-01 09:47:16', NULL, NULL, 15754, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:47:16', 'admin-1514768211-15147712359996398', 1, 0, '', NULL, NULL, NULL),
(59142, '2018-01-01 09:47:16', NULL, NULL, 15754, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:47:16', 'admin-1514768211-15147712359996398', 1, 0, '', NULL, NULL, NULL),
(59143, '2018-01-01 09:45:38', NULL, NULL, 15754, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 16.10, 0.0000, 0.0000, 16.10, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:45:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59144, '2018-01-01 09:45:06', NULL, NULL, 15753, 0, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:45:06', 'admin-1514768211-15147711064404250', 1, 1, 'SR', NULL, NULL, NULL),
(59145, '2018-01-01 10:34:21', NULL, NULL, 15764, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 10:34:21', 'admin-1514768211-15147740608785382', 1, 0, '', NULL, NULL, NULL),
(59146, '2018-01-01 09:34:40', NULL, NULL, 15752, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:34:40', 'admin-1514768211-15147704807132830', 1, 0, '', NULL, NULL, NULL),
(59147, '2018-01-01 09:30:51', NULL, NULL, 15751, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:30:51', 'admin-1514768211-15147702513904744', 1, 0, '', NULL, NULL, NULL),
(59148, '2018-01-01 09:30:51', NULL, NULL, 15751, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:30:51', 'admin-1514768211-15147702513904744', 1, 0, '', NULL, NULL, NULL),
(59149, '2018-01-01 09:30:51', NULL, NULL, 15751, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 2, 16.00, 32.0000, 0.0000, 32.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:30:51', 'admin-1514768211-15147702513904744', 1, 0, '', NULL, NULL, NULL),
(59150, '2018-01-01 09:22:23', NULL, NULL, 15751, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:22:23', 'admin-1514768211-15147697438399483', 1, 1, 'SR', NULL, NULL, NULL),
(59151, '2018-01-01 09:30:51', NULL, NULL, 15751, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:30:51', 'admin-1514768211-15147702513904744', 1, 0, '', NULL, NULL, NULL),
(59152, '2018-01-01 09:15:29', NULL, NULL, 15750, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:15:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59153, '2018-01-01 09:15:35', NULL, NULL, 15750, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 09:15:35', 'admin-1514768211-15147693350399871', 1, 1, 'SR', NULL, NULL, NULL),
(59154, '2018-01-01 15:36:26', NULL, NULL, 15803, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 8.90, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:36:26', 'admin-1514768211-15147921866739363', 1, 0, '', NULL, '11.0', NULL),
(59155, '2018-01-01 15:54:25', NULL, NULL, 15804, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:54:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59156, '2018-01-01 15:54:34', NULL, NULL, 15804, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 15:54:34', 'admin-1514768211-15147932741192214', 1, 1, 'SR', NULL, NULL, NULL),
(59157, '2018-01-01 16:07:13', NULL, NULL, 15802, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:07:13', 'admin-1514768211-15147940334015980', 1, 1, 'SR', NULL, NULL, NULL),
(59158, '2018-01-01 16:08:13', NULL, NULL, 15805, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.26, 0.0000, 0.0000, 9.26, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:08:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59159, '2018-01-01 16:08:58', NULL, NULL, 15805, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:08:58', 'admin-1514768211-151479413866635', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(59160, '2018-01-01 16:08:58', NULL, NULL, 15805, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:08:58', 'admin-1514768211-151479413866635', 1, 1, 'SR', NULL, NULL, NULL),
(59161, '2018-01-01 16:08:58', NULL, NULL, 15805, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:08:58', 'admin-1514768211-151479413866635', 1, 0, '', NULL, NULL, NULL),
(59162, '2018-01-01 16:13:58', NULL, NULL, 15805, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:13:58', 'admin-1514768211-1514794438748356', 1, 0, '', NULL, NULL, NULL),
(59163, '2018-01-01 16:08:58', NULL, NULL, 15805, 0, 304, '240', 'Banana is On Fire', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:08:58', 'admin-1514768211-151479413866635', 1, 0, '', NULL, NULL, NULL),
(59164, '2018-01-01 16:08:58', NULL, NULL, 15805, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:08:58', 'admin-1514768211-151479413866635', 1, 0, '', NULL, NULL, NULL),
(59165, '2018-01-01 16:08:58', NULL, NULL, 15805, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 8.90, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:08:58', 'admin-1514768211-151479413866635', 1, 0, '', NULL, '11.0', NULL),
(59166, '2018-01-01 16:08:58', NULL, NULL, 15805, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 10.68, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:08:58', 'admin-1514768211-151479413866635', 1, 0, '', NULL, '11.0', NULL),
(59167, '2018-01-01 16:09:32', NULL, NULL, 15802, 0, 302, '238', 'Ice on the cake', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:09:32', 'admin-1514768211-15147941725256793', 1, 0, '', NULL, NULL, NULL),
(59168, '2018-01-01 16:09:32', NULL, NULL, 15802, 0, 302, '238', 'Ice on the cake', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:09:32', 'admin-1514768211-15147941725256793', 1, 0, '', NULL, NULL, NULL),
(59169, '2018-01-01 16:10:53', NULL, NULL, 15805, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:10:53', 'admin-1514768211-15147942528772611', 1, 0, '', NULL, NULL, NULL),
(59170, '2018-01-01 16:13:58', NULL, NULL, 15805, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:13:58', 'admin-1514768211-1514794438748356', 1, 0, '', NULL, NULL, NULL),
(59171, '2018-01-01 16:14:37', NULL, NULL, 15802, 0, 181, '116', 'Open Food ', 'sausage', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:14:37', 'admin-1514768211-15147944772405748', 1, 0, '', NULL, NULL, NULL),
(59172, '2018-01-01 16:14:46', NULL, NULL, 15806, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:14:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59173, '2018-01-01 16:14:51', NULL, NULL, 15806, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:14:51', 'admin-1514768211-15147944915419387', 1, 1, 'SR', NULL, NULL, NULL),
(59174, '2018-01-01 16:34:31', NULL, NULL, 15807, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.94, 0.0000, 0.0000, 5.94, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:34:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59175, '2018-01-01 16:35:01', NULL, NULL, 15807, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:35:01', 'admin-1514768211-151479570150976', 1, 1, 'SR', NULL, NULL, NULL),
(59176, '2018-01-01 16:35:01', NULL, NULL, 15807, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:35:01', 'admin-1514768211-151479570150976', 1, 0, '', NULL, NULL, NULL),
(59177, '2018-01-01 16:35:01', NULL, NULL, 15807, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:35:01', 'admin-1514768211-151479570150976', 1, 1, 'SR', NULL, NULL, NULL),
(59178, '2018-01-01 16:35:01', NULL, NULL, 15807, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 10.68, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:35:01', 'admin-1514768211-151479570150976', 1, 0, '', NULL, '11.0', NULL),
(59179, '2018-01-01 16:45:40', NULL, NULL, 15807, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 10.68, 1, '27', 1, '1514768211', 'admin', '2018-01-01 16:45:40', 'admin-1514768211-15147963408127680', 1, 0, '', NULL, '11.0', NULL),
(59180, '2018-01-01 17:21:49', NULL, NULL, 15808, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 17:21:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59181, '2018-01-01 17:22:02', NULL, NULL, 15808, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 17:22:02', 'admin-1514768211-1514798522783966', 1, 1, 'SR', NULL, NULL, NULL),
(59182, '2018-01-01 17:22:02', NULL, NULL, 15808, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 17:22:02', 'admin-1514768211-1514798522783966', 1, 1, 'SR', NULL, NULL, NULL),
(59183, '2018-01-01 17:23:00', NULL, NULL, 15809, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1514768211', 'admin', '2018-01-01 17:23:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59184, '2018-01-01 17:23:06', NULL, NULL, 15809, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 17:23:06', 'admin-1514768211-15147985861464478', 1, 1, 'SR', NULL, NULL, NULL),
(59185, '2018-01-01 17:23:06', NULL, NULL, 15809, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1514768211', 'admin', '2018-01-01 17:23:06', 'admin-1514768211-15147985861464478', 1, 1, 'SR', NULL, NULL, NULL),
(59186, '2018-01-04 16:20:04', NULL, NULL, 15854, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 16:20:04', 'admin-1515027728-15150540038564553', 1, 1, 'SR', NULL, NULL, NULL),
(59187, '2018-01-04 14:14:09', NULL, NULL, 15844, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:14:09', 'admin-1515027728-15150464488301445', 1, 1, 'SR', NULL, NULL, NULL),
(59188, '2018-01-04 14:39:24', NULL, NULL, 15848, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.49, 0.0000, 0.0000, 5.49, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:39:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59189, '2018-01-04 14:40:13', NULL, NULL, 15848, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:40:13', 'admin-1515027728-15150480137741644', 1, 1, 'SR', NULL, NULL, NULL),
(59190, '2018-01-04 14:40:13', NULL, NULL, 15848, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:40:13', 'admin-1515027728-15150480137741644', 1, 1, 'SR', NULL, NULL, NULL),
(59191, '2018-01-04 14:40:13', NULL, NULL, 15848, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:40:13', 'admin-1515027728-15150480137741644', 1, 1, 'SR', NULL, NULL, NULL),
(59192, '2018-01-04 14:43:09', NULL, NULL, 15844, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:43:09', 'admin-1515027728-1515048189251511', 1, 0, '', NULL, NULL, NULL),
(59193, '2018-01-04 13:22:51', NULL, NULL, 15823, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:22:51', 'admin-1515027728-15150433712591741', 1, 1, 'SR', NULL, NULL, NULL),
(59194, '2018-01-04 13:22:51', NULL, NULL, 15823, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:22:51', 'admin-1515027728-15150433712591741', 1, 1, 'SR', NULL, NULL, NULL),
(59195, '2018-01-04 16:21:54', NULL, NULL, 15855, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 16:21:54', 'admin-1515027728-15150541138729081', 1, 1, 'SR', NULL, NULL, NULL),
(59196, '2018-01-04 16:21:54', NULL, NULL, 15855, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 16:21:54', 'admin-1515027728-15150541138729081', 1, 1, 'SR', NULL, NULL, NULL),
(59197, '2018-01-04 16:49:53', NULL, NULL, 15856, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1515027728', 'admin', '2018-01-04 16:49:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59198, '2018-01-04 16:50:02', NULL, NULL, 15856, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 16:50:02', 'admin-1515027728-15150558023636432', 1, 1, 'SR', NULL, NULL, NULL),
(59199, '2018-01-04 16:54:12', NULL, NULL, 15854, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 16:54:12', 'admin-1515027728-15150560522679141', 1, 1, 'SR', NULL, NULL, NULL),
(59200, '2018-01-04 14:50:43', NULL, NULL, 15849, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:50:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59201, '2018-01-04 14:54:19', NULL, NULL, 15850, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:54:19', 'admin-1515027728-15150488590597150', 1, 1, 'SR', NULL, NULL, NULL),
(59202, '2018-01-04 16:09:35', NULL, NULL, 15827, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 16:09:35', 'admin-1515027728-15150533750898460', 1, 0, '', NULL, NULL, NULL),
(59203, '2018-01-04 14:31:03', NULL, NULL, 15841, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:31:03', 'admin-1515027728-15150474634044089', 1, 1, 'SR', NULL, NULL, NULL),
(59204, '2018-01-04 14:35:09', NULL, NULL, 15847, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:35:09', 'admin-1515027728-15150477095475629', 1, 1, 'SR', NULL, NULL, NULL),
(59205, '2018-01-04 13:39:11', NULL, NULL, 15841, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:39:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59206, '2018-01-04 13:42:05', NULL, NULL, 15842, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:42:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59207, '2018-01-04 13:42:19', NULL, NULL, 15842, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:42:19', 'admin-1515027728-1515044539870898', 1, 1, 'SR', NULL, NULL, NULL),
(59208, '2018-01-04 14:19:56', NULL, NULL, 15845, 0, 181, '116', 'Open Food ', 'chicken potato', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:19:56', 'admin-1515027728-1515046796766988', 1, 0, '', NULL, NULL, NULL),
(59209, '2018-01-04 12:24:26', NULL, NULL, 15828, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:24:26', 'admin-1515027728-1515039866446616', 1, 0, '', NULL, NULL, '10.0'),
(59210, '2018-01-04 13:15:28', NULL, NULL, 15838, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:15:28', 'admin-1515027728-1515042928753209', 1, 0, '', NULL, NULL, NULL),
(59211, '2018-01-04 13:17:33', NULL, NULL, 15823, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:17:33', 'admin-1515027728-15150430537102785', 1, 1, 'SR', NULL, NULL, NULL),
(59212, '2018-01-04 16:21:43', NULL, NULL, 15855, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1515027728', 'admin', '2018-01-04 16:21:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59213, '2018-01-04 15:53:59', NULL, NULL, 15846, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 15:53:59', 'admin-1515027728-15150524390911118', 1, 1, 'SR', NULL, NULL, NULL),
(59214, '2018-01-04 15:53:59', NULL, NULL, 15846, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 15:53:59', 'admin-1515027728-15150524390911118', 1, 1, 'SR', NULL, NULL, NULL),
(59215, '2018-01-04 15:56:25', NULL, NULL, 15853, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1515027728', 'admin', '2018-01-04 15:56:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59216, '2018-01-04 14:53:54', NULL, NULL, 15850, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:53:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59217, '2018-01-04 14:19:56', NULL, NULL, 15845, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:19:56', 'admin-1515027728-1515046796766988', 1, 0, '', NULL, NULL, NULL),
(59218, '2018-01-04 15:56:41', NULL, NULL, 15853, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 15:56:41', 'admin-1515027728-15150526016307345', 1, 1, 'SR', NULL, NULL, NULL),
(59219, '2018-01-04 15:56:41', NULL, NULL, 15853, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 15:56:41', 'admin-1515027728-15150526016307345', 1, 1, 'SR', NULL, NULL, NULL),
(59220, '2018-01-04 14:14:08', NULL, NULL, 15844, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:14:08', 'admin-1515027728-15150464488301445', 1, 1, 'SR', NULL, NULL, NULL),
(59221, '2018-01-04 15:42:46', NULL, NULL, 15852, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1515027728', 'admin', '2018-01-04 15:42:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59222, '2018-01-04 15:42:49', NULL, NULL, 15852, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 15:42:49', 'admin-1515027728-15150517697388797', 1, 1, 'SR', NULL, NULL, NULL),
(59223, '2018-01-04 13:43:44', NULL, NULL, 15843, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:43:44', 'admin-1515027728-15150446248204835', 1, 0, '', NULL, NULL, NULL),
(59224, '2018-01-04 13:45:27', NULL, NULL, 15843, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:45:27', 'admin-1515027728-15150447273852648', 1, 1, 'SR', NULL, NULL, NULL),
(59225, '2018-01-04 13:46:56', NULL, NULL, 15841, 0, 181, '116', 'Open Food ', 'chicken potato', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:46:56', 'admin-1515027728-15150448167835935', 1, 0, '', NULL, NULL, NULL),
(59226, '2018-01-04 13:46:56', NULL, NULL, 15841, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:46:56', 'admin-1515027728-15150448167835935', 1, 0, '', NULL, NULL, NULL),
(59227, '2018-01-04 13:46:56', NULL, NULL, 15841, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:46:56', 'admin-1515027728-15150448167835935', 1, 0, '', NULL, NULL, NULL),
(59228, '2018-01-04 16:20:04', NULL, NULL, 15854, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 16:20:04', 'admin-1515027728-15150540038564553', 1, 1, 'SR', NULL, NULL, NULL),
(59229, '2018-01-04 12:38:51', NULL, NULL, 15830, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:38:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59230, '2018-01-04 12:47:40', NULL, NULL, 15831, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:47:40', 'admin-1515027728-15150412599141156', 1, 0, '', NULL, NULL, NULL),
(59231, '2018-01-04 12:49:45', NULL, NULL, 15826, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:49:45', 'admin-1515027728-15150413856877121', 1, 0, '', NULL, NULL, NULL),
(59232, '2018-01-04 13:09:17', NULL, NULL, 15825, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:09:17', 'admin-1515027728-15150425575683679', 1, 1, 'SR', NULL, NULL, NULL),
(59233, '2018-01-04 13:09:17', NULL, NULL, 15825, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:09:17', 'admin-1515027728-15150425575683679', 1, 1, 'SR', NULL, NULL, NULL),
(59234, '2018-01-04 12:06:40', NULL, NULL, 15824, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:06:40', 'admin-1515027728-15150388005111096', 1, 0, '', NULL, NULL, NULL),
(59235, '2018-01-04 10:53:09', NULL, NULL, 15820, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 10:53:09', 'admin-1515027728-15150343889629772', 1, 1, 'SR', 1, NULL, NULL),
(59236, '2018-01-04 11:07:23', NULL, NULL, 15821, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1515027728', 'admin', '2018-01-04 11:07:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59237, '2018-01-04 11:07:33', NULL, NULL, 15821, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 11:07:33', 'admin-1515027728-15150352536017918', 1, 0, '', NULL, NULL, NULL),
(59238, '2018-01-04 11:07:33', NULL, NULL, 15821, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 11:07:33', 'admin-1515027728-15150352536017918', 1, 0, '', NULL, NULL, NULL),
(59239, '2018-01-04 12:44:14', NULL, NULL, 15830, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:44:14', 'admin-1515027728-15150410538943471', 1, 1, 'SR', NULL, NULL, NULL),
(59240, '2018-01-04 12:10:14', NULL, NULL, 15825, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:10:14', 'admin-1515027728-15150390139001366', 1, 0, '', NULL, NULL, NULL),
(59241, '2018-01-04 12:59:59', NULL, NULL, 15835, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:59:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59242, '2018-01-04 13:00:25', NULL, NULL, 15835, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:00:25', 'admin-1515027728-15150420250321795', 1, 0, '', NULL, NULL, NULL),
(59243, '2018-01-04 13:03:14', NULL, NULL, 15835, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:03:14', 'admin-1515027728-15150421945697830', 1, 0, '', NULL, NULL, NULL),
(59244, '2018-01-04 13:00:25', NULL, NULL, 15835, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:00:25', 'admin-1515027728-15150420250321795', 1, 1, 'SR', NULL, NULL, NULL),
(59245, '2018-01-04 13:00:25', NULL, NULL, 15835, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:00:25', 'admin-1515027728-15150420250321795', 1, 1, 'SR', NULL, NULL, NULL),
(59246, '2018-01-04 13:32:36', NULL, NULL, 15823, 0, 181, '116', 'Open Food ', 'chicken potato', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:32:36', 'admin-1515027728-15150439558745664', 1, 0, '', NULL, NULL, NULL),
(59247, '2018-01-04 14:35:09', NULL, NULL, 15847, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:35:09', 'admin-1515027728-15150477095475629', 1, 1, 'SR', NULL, NULL, NULL),
(59248, '2018-01-04 13:22:51', NULL, NULL, 15823, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:22:51', 'admin-1515027728-15150433712591741', 1, 1, 'SR', NULL, NULL, NULL),
(59249, '2018-01-04 15:12:39', NULL, NULL, 15851, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 15:12:39', 'admin-1515027728-15150499593388427', 1, 0, '', 1, NULL, NULL),
(59250, '2018-01-04 15:12:39', NULL, NULL, 15851, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 15:12:39', 'admin-1515027728-15150499593388427', 1, 0, '', 1, NULL, NULL),
(59251, '2018-01-04 12:17:32', NULL, NULL, 15827, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:17:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59252, '2018-01-04 12:17:37', NULL, NULL, 15827, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:17:37', 'admin-1515027728-15150394578339012', 1, 1, 'SR', NULL, NULL, NULL),
(59253, '2018-01-04 13:01:13', NULL, NULL, 15834, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:01:13', 'admin-1515027728-15150420734336532', 1, 0, '', NULL, NULL, NULL),
(59254, '2018-01-04 13:07:28', NULL, NULL, 15836, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:07:28', 'admin-1515027728-15150424482241384', 1, 1, 'SR', NULL, NULL, NULL),
(59255, '2018-01-04 13:07:28', NULL, NULL, 15836, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:07:28', 'admin-1515027728-15150424482241384', 1, 1, 'SR', NULL, NULL, NULL),
(59256, '2018-01-04 13:07:28', NULL, NULL, 15836, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:07:28', 'admin-1515027728-15150424482241384', 1, 1, 'SR', NULL, NULL, NULL),
(59257, '2018-01-04 14:14:08', NULL, NULL, 15844, 0, 181, '116', 'Open Food ', 'pasta with cheese', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:14:08', 'admin-1515027728-15150464488301445', 1, 0, '', NULL, NULL, NULL),
(59258, '2018-01-04 14:27:02', NULL, NULL, 15846, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:27:02', 'admin-1515027728-15150472220248422', 1, 1, 'SR', NULL, NULL, NULL),
(59259, '2018-01-04 14:27:02', NULL, NULL, 15846, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:27:02', 'admin-1515027728-15150472220248422', 1, 1, 'SR', NULL, NULL, NULL),
(59260, '2018-01-04 14:24:53', NULL, NULL, 15846, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:24:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59261, '2018-01-04 14:25:11', NULL, NULL, 15846, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:25:11', 'admin-1515027728-15150471110983982', 1, 0, '', NULL, NULL, NULL),
(59262, '2018-01-04 15:12:39', NULL, NULL, 15851, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 15:12:39', 'admin-1515027728-15150499593388427', 1, 0, '', 1, NULL, NULL),
(59263, '2018-01-04 15:12:39', NULL, NULL, 15851, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 15:12:39', 'admin-1515027728-15150499593388427', 1, 0, '', 1, NULL, NULL),
(59264, '2018-01-04 15:12:39', NULL, NULL, 15851, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 15:12:39', 'admin-1515027728-15150499593388427', 1, 0, '', 1, NULL, NULL),
(59265, '2018-01-04 14:54:19', NULL, NULL, 15850, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:54:19', 'admin-1515027728-15150488590597150', 1, 0, '', NULL, NULL, NULL),
(59266, '2018-01-04 14:54:19', NULL, NULL, 15850, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:54:19', 'admin-1515027728-15150488590597150', 1, 0, '', NULL, NULL, NULL),
(59267, '2018-01-04 14:54:19', NULL, NULL, 15850, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:54:19', 'admin-1515027728-15150488590597150', 1, 1, 'SR', NULL, NULL, NULL),
(59268, '2018-01-04 14:50:56', NULL, NULL, 15849, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:50:56', 'admin-1515027728-1515048656738868', 1, 1, 'SR', NULL, NULL, NULL),
(59269, '2018-01-04 14:50:56', NULL, NULL, 15849, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:50:56', 'admin-1515027728-1515048656738868', 1, 1, 'SR', NULL, NULL, NULL),
(59270, '2018-01-04 14:35:09', NULL, NULL, 15847, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:35:09', 'admin-1515027728-15150477095475629', 1, 1, 'SR', NULL, NULL, NULL),
(59271, '2018-01-04 13:14:03', NULL, NULL, 15838, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:14:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59272, '2018-01-04 13:14:41', NULL, NULL, 15838, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:14:41', 'admin-1515027728-15150428811971081', 1, 1, 'SR', NULL, NULL, NULL),
(59273, '2018-01-04 15:56:41', NULL, NULL, 15853, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 15:56:41', 'admin-1515027728-15150526016307345', 1, 1, 'SR', NULL, NULL, NULL),
(59274, '2018-01-04 14:19:56', NULL, NULL, 15845, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:19:56', 'admin-1515027728-1515046796766988', 1, 1, 'SR', NULL, NULL, NULL),
(59275, '2018-01-04 10:47:13', NULL, NULL, 15819, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 10:47:13', 'admin-1515027728-15150340331177293', 1, 0, '', NULL, NULL, NULL),
(59276, '2018-01-04 10:37:59', NULL, NULL, 15817, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 10:37:59', 'admin-1515027728-1515033479243924', 1, 0, '', NULL, NULL, NULL),
(59277, '2018-01-04 14:25:11', NULL, NULL, 15846, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:25:11', 'admin-1515027728-15150471110983982', 1, 0, '', NULL, NULL, NULL),
(59278, '2018-01-04 14:19:57', NULL, NULL, 15845, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:19:57', 'admin-1515027728-1515046796766988', 1, 1, 'SR', NULL, NULL, NULL),
(59279, '2018-01-04 14:19:56', NULL, NULL, 15845, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:19:56', 'admin-1515027728-1515046796766988', 1, 0, '', NULL, NULL, NULL),
(59280, '2018-01-04 14:19:56', NULL, NULL, 15845, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:19:56', 'admin-1515027728-1515046796766988', 1, 1, 'SR', NULL, NULL, NULL),
(59281, '2018-01-04 15:11:34', NULL, NULL, 15848, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 15:11:34', 'admin-1515027728-15150498939114115', 1, 1, 'SR', NULL, NULL, NULL),
(59282, '2018-01-04 14:19:56', NULL, NULL, 15845, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:19:56', 'admin-1515027728-1515046796766988', 1, 0, '', NULL, NULL, NULL),
(59283, '2018-01-04 14:19:56', NULL, NULL, 15845, 0, 207, '142', 'Cheesy Bacon Toast', 'no salad', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:19:56', 'admin-1515027728-1515046796766988', 1, 0, '', NULL, NULL, NULL),
(59284, '2018-01-04 12:10:14', NULL, NULL, 15825, 0, 271, '205', 'Take It Easy', 'mashed pumkim', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:10:14', 'admin-1515027728-15150390139001366', 1, 0, '', NULL, NULL, NULL),
(59285, '2018-01-04 15:12:39', NULL, NULL, 15851, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 15:12:39', 'admin-1515027728-15150499593388427', 1, 0, '', 1, NULL, NULL),
(59286, '2018-01-04 15:11:34', NULL, NULL, 15848, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1515027728', 'admin', '2018-01-04 15:11:34', 'admin-1515027728-15150498939114115', 1, 0, '', NULL, NULL, NULL),
(59287, '2018-01-04 12:06:11', NULL, NULL, 15824, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:06:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59288, '2018-01-04 14:18:49', NULL, NULL, 15845, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.80, 0.0000, 0.0000, 10.80, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:18:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59289, '2018-01-04 12:06:40', NULL, NULL, 15824, 0, 181, '116', 'Open Food ', 'chicken potato', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:06:40', 'admin-1515027728-15150388005111096', 1, 0, '', NULL, NULL, NULL),
(59290, '2018-01-04 12:06:57', NULL, NULL, 15825, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 17.10, 0.0000, 0.0000, 17.10, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:06:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59291, '2018-01-04 12:10:14', NULL, NULL, 15825, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:10:14', 'admin-1515027728-15150390139001366', 1, 1, 'SR', NULL, NULL, NULL),
(59292, '2018-01-04 14:14:08', NULL, NULL, 15844, 0, 253, '187', 'Cheese Baked Nachos', 'no sauce', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:14:08', 'admin-1515027728-15150464488301445', 1, 0, '', NULL, NULL, NULL),
(59293, '2018-01-04 13:42:20', NULL, NULL, 15842, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:42:20', 'admin-1515027728-1515044539870898', 1, 1, 'SR', NULL, NULL, NULL),
(59294, '2018-01-04 13:43:11', NULL, NULL, 15843, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:43:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59295, '2018-01-04 14:34:44', NULL, NULL, 15847, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:34:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59296, '2018-01-04 13:18:03', NULL, NULL, 15839, 0, 181, '116', 'Open Food ', 'chicken potato', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:18:03', 'admin-1515027728-15150430830644380', 1, 0, '', NULL, NULL, NULL),
(59297, '2018-01-04 14:30:32', NULL, NULL, 15844, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:30:32', 'admin-1515027728-1515047432869642', 1, 0, '', NULL, NULL, NULL),
(59298, '2018-01-04 13:18:03', NULL, NULL, 15839, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:18:03', 'admin-1515027728-15150430830644380', 1, 0, '', NULL, NULL, NULL),
(59299, '2018-01-04 13:18:03', NULL, NULL, 15839, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:18:03', 'admin-1515027728-15150430830644380', 1, 0, '', NULL, NULL, NULL),
(59300, '2018-01-04 13:17:43', NULL, NULL, 15839, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:17:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59301, '2018-01-04 13:14:41', NULL, NULL, 15838, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:14:41', 'admin-1515027728-15150428811971081', 1, 1, 'SR', NULL, NULL, NULL),
(59302, '2018-01-04 13:17:33', NULL, NULL, 15823, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:17:33', 'admin-1515027728-15150430537102785', 1, 1, 'SR', NULL, NULL, NULL),
(59303, '2018-01-04 13:09:17', NULL, NULL, 15825, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:09:17', 'admin-1515027728-15150425575683679', 1, 1, 'SR', NULL, NULL, NULL),
(59304, '2018-01-04 13:09:17', NULL, NULL, 15825, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:09:17', 'admin-1515027728-15150425575683679', 1, 1, 'SR', NULL, NULL, NULL),
(59305, '2018-01-04 14:12:45', NULL, NULL, 15844, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1515027728', 'admin', '2018-01-04 14:12:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59306, '2018-01-04 12:59:16', NULL, NULL, 15834, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:59:16', 'admin-1515027728-1515041956259443', 1, 0, '', NULL, NULL, NULL),
(59307, '2018-01-04 12:59:16', NULL, NULL, 15834, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:59:16', 'admin-1515027728-1515041956259443', 1, 0, '', NULL, NULL, NULL),
(59308, '2018-01-04 12:59:16', NULL, NULL, 15834, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:59:16', 'admin-1515027728-1515041956259443', 1, 1, 'SR', NULL, NULL, NULL),
(59309, '2018-01-04 12:59:16', NULL, NULL, 15834, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:59:16', 'admin-1515027728-1515041956259443', 1, 0, '', NULL, NULL, NULL),
(59310, '2018-01-04 16:20:03', NULL, NULL, 15854, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 16:20:03', 'admin-1515027728-15150540038564553', 1, 0, '', NULL, NULL, NULL),
(59311, '2018-01-04 12:57:26', NULL, NULL, 15834, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:57:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59312, '2018-01-04 12:47:40', NULL, NULL, 15831, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:47:40', 'admin-1515027728-15150412599141156', 1, 1, 'SR', NULL, NULL, NULL),
(59313, '2018-01-04 12:38:39', NULL, NULL, 15829, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:38:39', 'admin-1515027728-1515040719706751', 1, 1, 'SR', 1, NULL, NULL),
(59314, '2018-01-04 12:54:56', NULL, NULL, 15833, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:54:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59315, '2018-01-04 12:47:40', NULL, NULL, 15831, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:47:40', 'admin-1515027728-15150412599141156', 1, 1, 'SR', NULL, NULL, NULL),
(59316, '2018-01-04 13:07:16', NULL, NULL, 15836, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 13:07:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59317, '2018-01-04 12:46:41', NULL, NULL, 15831, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:46:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59318, '2018-01-04 12:47:40', NULL, NULL, 15831, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:47:40', 'admin-1515027728-15150412599141156', 1, 0, '', NULL, NULL, NULL),
(59319, '2018-01-04 12:38:56', NULL, NULL, 15830, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:38:56', 'admin-1515027728-1515040736539887', 1, 1, 'SR', NULL, NULL, NULL),
(59320, '2018-01-04 16:19:47', NULL, NULL, 15854, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 16:19:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59321, '2018-01-04 00:00:00', NULL, NULL, 15833, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:17:37', 'admin-1515027728-15150394578339012', 1, 0, '', NULL, NULL, NULL),
(59322, '2018-01-04 12:23:40', NULL, NULL, 15828, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:23:40', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(59323, '2018-01-04 12:24:26', NULL, NULL, 15828, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:24:26', 'admin-1515027728-1515039866446616', 1, 1, 'SR', NULL, NULL, '10.0'),
(59324, '2018-01-04 12:24:26', NULL, NULL, 15828, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:24:26', 'admin-1515027728-1515039866446616', 1, 0, '', NULL, NULL, '10.0'),
(59325, '2018-01-04 12:11:12', NULL, NULL, 15826, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:11:12', 'admin-1515027728-15150390723235428', 1, 1, 'SR', NULL, NULL, NULL),
(59326, '2018-01-04 12:11:12', NULL, NULL, 15826, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:11:12', 'admin-1515027728-15150390723235428', 1, 1, 'SR', NULL, NULL, NULL),
(59327, '2018-01-04 12:11:12', NULL, NULL, 15826, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:11:12', 'admin-1515027728-15150390723235428', 1, 1, 'SR', NULL, NULL, NULL),
(59328, '2018-01-04 12:11:12', NULL, NULL, 15826, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:11:12', 'admin-1515027728-15150390723235428', 1, 0, '', NULL, NULL, NULL),
(59329, '2018-01-04 12:11:12', NULL, NULL, 15826, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:11:12', 'admin-1515027728-15150390723235428', 1, 0, '', NULL, NULL, NULL),
(59330, '2018-01-04 12:10:53', NULL, NULL, 15826, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:10:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59331, '2018-01-04 12:10:14', NULL, NULL, 15825, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:10:14', 'admin-1515027728-15150390139001366', 1, 1, 'SR', NULL, NULL, NULL),
(59332, '2018-01-04 12:10:14', NULL, NULL, 15825, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:10:14', 'admin-1515027728-15150390139001366', 1, 1, 'SR', NULL, NULL, NULL),
(59333, '2018-01-04 12:10:14', NULL, NULL, 15825, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:10:14', 'admin-1515027728-15150390139001366', 1, 0, '', NULL, NULL, NULL),
(59334, '2018-01-04 12:10:14', NULL, NULL, 15825, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:10:14', 'admin-1515027728-15150390139001366', 1, 1, 'SR', NULL, NULL, NULL),
(59335, '2018-01-04 12:10:14', NULL, NULL, 15825, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:10:14', 'admin-1515027728-15150390139001366', 1, 1, 'SR', NULL, NULL, NULL),
(59336, '2018-01-04 12:10:14', NULL, NULL, 15825, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:10:14', 'admin-1515027728-15150390139001366', 1, 0, '', NULL, NULL, NULL),
(59337, '2018-01-04 12:10:14', NULL, NULL, 15825, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:10:14', 'admin-1515027728-15150390139001366', 1, 0, '', NULL, NULL, NULL),
(59338, '2018-01-04 12:06:40', NULL, NULL, 15824, 0, 337, '273', 'Hot yuzu', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 12:06:40', 'admin-1515027728-15150388005111096', 1, 0, '', NULL, NULL, NULL),
(59339, '2018-01-04 11:55:51', NULL, NULL, 15823, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1515027728', 'admin', '2018-01-04 11:55:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59340, '2018-01-04 11:55:59', NULL, NULL, 15823, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 11:55:59', 'admin-1515027728-1515038159755562', 1, 1, 'SR', NULL, NULL, NULL),
(59341, '2018-01-04 11:10:27', NULL, NULL, 15822, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 11:10:27', 'admin-1515027728-15150354274621584', 1, 1, 'SR', NULL, NULL, NULL),
(59342, '2018-01-04 11:10:27', NULL, NULL, 15822, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 11:10:27', 'admin-1515027728-15150354274621584', 1, 0, '', NULL, NULL, NULL),
(59343, '2018-01-04 11:55:59', NULL, NULL, 15823, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 11:55:59', 'admin-1515027728-1515038159755562', 1, 1, 'SR', NULL, NULL, NULL),
(59344, '2018-01-04 11:09:49', NULL, NULL, 15822, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 11:09:49', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(59345, '2018-01-04 10:30:35', NULL, NULL, 15819, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 10:30:35', 'admin-1515027728-15150330355214273', 1, 0, '', NULL, NULL, NULL),
(59346, '2018-01-04 10:30:35', NULL, NULL, 15819, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 10:30:35', 'admin-1515027728-15150330355214273', 1, 0, '', NULL, NULL, NULL),
(59347, '2018-01-04 10:30:35', NULL, NULL, 15819, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 10:30:35', 'admin-1515027728-15150330355214273', 1, 1, 'SR', NULL, NULL, NULL),
(59348, '2018-01-04 10:29:08', NULL, NULL, 15819, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1515027728', 'admin', '2018-01-04 10:29:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59349, '2018-01-04 10:25:07', NULL, NULL, 15818, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 10:25:07', 'admin-1515027728-15150327071125148', 1, 1, 'SR', 1, NULL, NULL),
(59350, '2018-01-04 10:21:45', NULL, NULL, 15817, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 10:21:45', 'admin-1515027728-15150325057856233', 1, 1, 'SR', NULL, NULL, NULL),
(59351, '2018-01-04 10:21:45', NULL, NULL, 15817, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 10:21:45', 'admin-1515027728-15150325057856233', 1, 1, 'SR', NULL, NULL, NULL),
(59352, '2018-01-04 10:18:53', NULL, NULL, 15816, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 10:18:53', 'admin-1515027728-151503233316129', 1, 1, 'SR', NULL, NULL, NULL),
(59353, '2018-01-04 10:18:27', NULL, NULL, 15816, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1515027728', 'admin', '2018-01-04 10:18:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59354, '2018-01-04 09:50:36', NULL, NULL, 15814, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 09:50:36', 'admin-1515027728-15150306362869965', 1, 1, 'SR', NULL, NULL, NULL),
(59355, '2018-01-04 09:50:36', NULL, NULL, 15814, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 09:50:36', 'admin-1515027728-15150306362869965', 1, 0, '', NULL, NULL, NULL),
(59356, '2018-01-04 09:50:05', NULL, NULL, 15814, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1515027728', 'admin', '2018-01-04 09:50:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59357, '2018-01-04 09:45:21', NULL, NULL, 15813, 0, 337, '273', 'Hot yuzu', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 09:45:21', 'admin-1515027728-15150303215234963', 1, 0, '', NULL, NULL, NULL),
(59358, '2018-01-04 09:45:21', NULL, NULL, 15813, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 09:45:21', 'admin-1515027728-15150303215234963', 1, 1, 'SR', NULL, NULL, NULL),
(59359, '2018-01-04 09:45:21', NULL, NULL, 15813, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 09:45:21', 'admin-1515027728-15150303215234963', 1, 0, '', NULL, NULL, NULL),
(59360, '2018-01-04 09:45:21', NULL, NULL, 15813, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 09:45:21', 'admin-1515027728-15150303215234963', 1, 0, '', NULL, NULL, NULL),
(59361, '2018-01-04 09:44:57', NULL, NULL, 15813, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1515027728', 'admin', '2018-01-04 09:44:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59362, '2018-01-04 09:43:06', NULL, NULL, 15812, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 09:43:06', 'admin-1515027728-1515030186767571', 1, 0, '', NULL, NULL, NULL),
(59363, '2018-01-04 10:17:19', NULL, NULL, 15815, 0, 156, '90', 'House Cheddar Omelet', 'no toast', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 10:17:19', 'admin-1515027728-1515032238951475', 1, 0, '', NULL, NULL, NULL),
(59364, '2018-01-04 10:16:28', NULL, NULL, 15815, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1515027728', 'admin', '2018-01-04 10:16:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59365, '2018-01-04 09:26:08', NULL, NULL, 15811, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 09:26:08', 'admin-1515027728-15150291686964666', 1, 1, 'SR', NULL, NULL, NULL),
(59366, '2018-01-04 10:21:45', NULL, NULL, 15817, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 10:21:45', 'admin-1515027728-15150325057856233', 1, 0, '', NULL, NULL, NULL),
(59367, '2018-01-04 10:21:01', NULL, NULL, 15817, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1515027728', 'admin', '2018-01-04 10:21:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59368, '2018-01-04 10:18:53', NULL, NULL, 15816, 0, 335, '271', 'Iced Honey Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 10:18:53', 'admin-1515027728-151503233316129', 1, 0, '', NULL, NULL, NULL),
(59369, '2018-01-04 10:18:53', NULL, NULL, 15816, 0, 154, '88', 'Daily Dose BLT', 'no eggs', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 10:18:53', 'admin-1515027728-151503233316129', 1, 0, '', NULL, NULL, NULL),
(59370, '2018-01-04 09:26:08', NULL, NULL, 15811, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 09:26:08', 'admin-1515027728-15150291686964666', 1, 0, '', NULL, NULL, NULL),
(59371, '2018-01-04 09:21:12', NULL, NULL, 15810, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 09:21:12', 'admin-1515027728-15150288719302266', 1, 0, '', NULL, NULL, NULL),
(59372, '2018-01-04 09:21:12', NULL, NULL, 15810, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 09:21:12', 'admin-1515027728-15150288719302266', 1, 0, '', NULL, NULL, NULL),
(59373, '2018-01-04 09:21:12', NULL, NULL, 15810, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 09:21:12', 'admin-1515027728-15150288719302266', 1, 0, '', NULL, NULL, NULL),
(59374, '2018-01-04 09:26:01', NULL, NULL, 15811, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 09:26:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59375, '2018-01-04 09:21:12', NULL, NULL, 15810, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515027728', 'admin', '2018-01-04 09:21:12', 'admin-1515027728-15150288719302266', 1, 0, '', NULL, NULL, NULL),
(59376, '2018-01-04 09:40:31', NULL, NULL, 15812, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1515027728', 'admin', '2018-01-04 09:40:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59377, '2018-01-04 09:19:02', NULL, NULL, 15810, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1515027728', 'admin', '2018-01-04 09:19:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59378, '2018-01-05 16:27:43', NULL, NULL, 15875, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1515112353', 'admin', '2018-01-05 16:27:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59379, '2018-01-05 16:27:51', NULL, NULL, 15875, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 16:27:51', 'admin-1515112353-15151408709408198', 1, 1, 'SR', NULL, NULL, NULL),
(59380, '2018-01-05 16:32:06', NULL, NULL, 15876, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1515112353', 'admin', '2018-01-05 16:32:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59381, '2018-01-05 16:32:18', NULL, NULL, 15876, 0, 325, '261', 'Strawberry Chocolate Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 16:32:18', 'admin-1515112353-15151411384551133', 1, 0, '', NULL, NULL, NULL),
(59382, '2018-01-05 00:00:00', NULL, NULL, 15873, 0, 154, '88', 'Daily Dose BLT', 'no bacon', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 14:55:03', 'admin-1515112353-15151353035401628', 1, 0, '', NULL, NULL, NULL),
(59383, '2018-01-05 16:27:32', NULL, NULL, 15874, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1515112353', 'admin', '2018-01-05 16:27:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59384, '2018-01-05 10:44:20', NULL, NULL, 15862, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 10:44:20', 'admin-1515112353-15151202598971435', 1, 0, '', NULL, NULL, NULL),
(59385, '2018-01-05 10:44:20', NULL, NULL, 15862, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 10:44:20', 'admin-1515112353-15151202598971435', 1, 0, '', NULL, NULL, NULL),
(59386, '2018-01-05 10:44:20', NULL, NULL, 15862, 0, 181, '116', 'Open Food ', 'banana', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1515112353', 'admin', '2018-01-05 10:44:20', 'admin-1515112353-15151202598971435', 1, 0, '', NULL, NULL, NULL),
(59387, '2018-01-05 10:44:20', NULL, NULL, 15862, 0, 181, '116', 'Open Food ', 'crossaint', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 10:44:20', 'admin-1515112353-15151202598971435', 1, 0, '', NULL, NULL, NULL),
(59388, '2018-01-05 16:45:36', NULL, NULL, 15878, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 16:45:36', 'admin-1515112353-15151419366572064', 1, 1, 'SR', NULL, NULL, NULL),
(59389, '2018-01-05 15:04:45', NULL, NULL, 15871, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 15:04:45', 'admin-1515112353-15151358850394098', 1, 0, '', NULL, NULL, NULL),
(59390, '2018-01-05 00:00:00', NULL, NULL, 15873, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.60, NULL, NULL, 1.60, 1, '27', 1, '1515112353', 'admin', '2018-01-05 14:52:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59391, '2018-01-05 17:09:56', NULL, NULL, 15879, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 17:09:56', 'admin-1515112353-1515143396722854', 1, 1, 'SR', NULL, NULL, NULL),
(59392, '2018-01-05 17:09:56', NULL, NULL, 15879, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 17:09:56', 'admin-1515112353-1515143396722854', 1, 0, '', NULL, NULL, NULL),
(59393, '2018-01-05 17:09:56', NULL, NULL, 15879, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 17:09:56', 'admin-1515112353-1515143396722854', 1, 1, 'SR', NULL, NULL, NULL),
(59394, '2018-01-05 17:09:56', NULL, NULL, 15879, 0, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 17:09:56', 'admin-1515112353-1515143396722854', 1, 1, 'SR', NULL, NULL, NULL),
(59395, '2018-01-05 13:04:50', NULL, NULL, 15865, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 13:04:50', 'admin-1515112353-15151286905656817', 1, 1, 'SR', NULL, NULL, NULL),
(59396, '2018-01-05 14:24:48', NULL, NULL, 15869, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 14:24:48', 'admin-1515112353-1515133488691217', 1, 1, 'SR', NULL, NULL, NULL),
(59397, '2018-01-05 13:16:38', NULL, NULL, 15867, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 13:16:38', 'admin-1515112353-15151293988559580', 1, 1, 'SR', NULL, NULL, NULL),
(59398, '2018-01-05 15:26:30', NULL, NULL, 15871, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 15:26:30', 'admin-1515112353-15151371906473434', 1, 1, 'SR', NULL, NULL, NULL),
(59399, '2018-01-05 13:41:24', NULL, NULL, 15866, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 13:41:24', 'admin-1515112353-15151308845021024', 1, 1, 'SR', NULL, NULL, NULL),
(59400, '2018-01-05 13:51:32', NULL, NULL, 15868, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1515112353', 'admin', '2018-01-05 13:51:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59401, '2018-01-05 13:52:09', NULL, NULL, 15868, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 13:52:09', 'admin-1515112353-15151315292822946', 1, 1, 'SR', NULL, NULL, NULL),
(59402, '2018-01-05 14:24:33', NULL, NULL, 15869, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1515112353', 'admin', '2018-01-05 14:24:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59403, '2018-01-05 17:09:56', NULL, NULL, 15879, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 17:09:56', 'admin-1515112353-1515143396722854', 1, 0, '', NULL, NULL, NULL),
(59404, '2018-01-05 15:04:45', NULL, NULL, 15871, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 15:04:45', 'admin-1515112353-15151358850394098', 1, 1, 'SR', NULL, NULL, NULL),
(59405, '2018-01-05 16:27:39', NULL, NULL, 15874, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 16:27:39', 'admin-1515112353-1515140858895327', 1, 1, 'SR', NULL, NULL, NULL),
(59406, '2018-01-05 12:16:17', NULL, NULL, 15863, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 12:16:17', 'admin-1515112353-15151257772012260', 1, 0, '', NULL, NULL, NULL),
(59407, '2018-01-05 16:32:18', NULL, NULL, 15876, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 16:32:18', 'admin-1515112353-15151411384551133', 1, 0, '', NULL, NULL, NULL),
(59408, '2018-01-05 16:42:50', NULL, NULL, 15877, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1515112353', 'admin', '2018-01-05 16:42:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59409, '2018-01-05 16:42:54', NULL, NULL, 15877, 0, 337, '273', 'Hot yuzu', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 16:42:54', 'admin-1515112353-1515141774756136', 1, 0, '', NULL, NULL, NULL),
(59410, '2018-01-05 16:45:28', NULL, NULL, 15878, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1515112353', 'admin', '2018-01-05 16:45:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59411, '2018-01-05 17:09:56', NULL, NULL, 15879, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 17:09:56', 'admin-1515112353-1515143396722854', 1, 0, '', NULL, NULL, NULL),
(59412, '2018-01-05 17:09:35', NULL, NULL, 15879, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1515112353', 'admin', '2018-01-05 17:09:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59413, '2018-01-05 16:45:36', NULL, NULL, 15878, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 16:45:36', 'admin-1515112353-15151419366572064', 1, 1, 'SR', NULL, NULL, NULL),
(59414, '2018-01-05 16:32:18', NULL, NULL, 15876, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 16:32:18', 'admin-1515112353-15151411384551133', 1, 1, 'SR', NULL, NULL, NULL),
(59415, '2018-01-05 16:27:39', NULL, NULL, 15874, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 16:27:39', 'admin-1515112353-1515140858895327', 1, 0, '', NULL, NULL, NULL),
(59416, '2018-01-05 00:00:00', NULL, NULL, 15872, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 14:52:41', 'admin-1515112353-1515135161008184', 1, 0, '', NULL, NULL, NULL),
(59417, '2018-01-05 15:04:45', NULL, NULL, 15871, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 15:04:45', 'admin-1515112353-15151358850394098', 1, 1, 'SR', NULL, NULL, NULL),
(59418, '2018-01-05 15:03:05', NULL, NULL, 15871, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1515112353', 'admin', '2018-01-05 15:03:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59419, '2018-01-05 00:00:00', NULL, NULL, 15872, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 14:52:41', 'admin-1515112353-1515135161008184', 1, 1, 'SR', NULL, NULL, NULL),
(59420, '2018-01-05 15:16:01', NULL, NULL, 15872, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1515112353', 'admin', '2018-01-05 15:16:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59421, '2018-01-05 14:47:28', NULL, NULL, 15869, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 14:47:28', 'admin-1515112353-15151348481209727', 1, 0, '', NULL, NULL, NULL),
(59422, '2018-01-05 14:47:28', NULL, NULL, 15869, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 14:47:28', 'admin-1515112353-15151348481209727', 1, 0, '', NULL, NULL, NULL),
(59423, '2018-01-05 14:47:28', NULL, NULL, 15869, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 14:47:28', 'admin-1515112353-15151348481209727', 1, 0, '', NULL, NULL, NULL),
(59424, '2018-01-05 14:47:28', NULL, NULL, 15869, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 14:47:28', 'admin-1515112353-15151348481209727', 1, 0, '', NULL, NULL, NULL),
(59425, '2018-01-05 12:27:54', NULL, NULL, 15864, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 12:27:54', 'admin-1515112353-1515126474668557', 1, 0, '', NULL, NULL, NULL),
(59426, '2018-01-05 13:11:30', NULL, NULL, 15866, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 13:11:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59427, '2018-01-05 13:11:59', NULL, NULL, 15866, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 13:11:59', 'admin-1515112353-15151291191293631', 1, 0, '', NULL, NULL, NULL),
(59428, '2018-01-05 13:11:59', NULL, NULL, 15866, 0, 181, '116', 'Open Food ', 'herbal soup', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 13:11:59', 'admin-1515112353-15151291191293631', 1, 0, '', NULL, NULL, NULL),
(59429, '2018-01-05 13:11:59', NULL, NULL, 15866, 0, 181, '116', 'Open Food ', 'herbal soup', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 13:11:59', 'admin-1515112353-15151291191293631', 1, 0, '', NULL, NULL, NULL),
(59430, '2018-01-05 13:34:50', NULL, NULL, 15866, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 13:34:50', 'admin-1515112353-1515130490821192', 1, 0, '', NULL, NULL, NULL),
(59431, '2018-01-05 13:16:39', NULL, NULL, 15867, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 13:16:39', 'admin-1515112353-15151293988559580', 1, 0, '', NULL, NULL, NULL),
(59432, '2018-01-05 13:16:35', NULL, NULL, 15867, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1515112353', 'admin', '2018-01-05 13:16:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59433, '2018-01-05 12:47:04', NULL, NULL, 15864, 0, 304, '240', 'Banana is On Fire', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 12:47:04', 'admin-1515112353-15151276244805225', 1, 0, '', NULL, NULL, NULL),
(59434, '2018-01-05 13:04:47', NULL, NULL, 15865, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1515112353', 'admin', '2018-01-05 13:04:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59435, '2018-01-05 12:27:54', NULL, NULL, 15864, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 12:27:54', 'admin-1515112353-1515126474668557', 1, 1, 'SR', NULL, NULL, NULL),
(59436, '2018-01-05 12:27:41', NULL, NULL, 15864, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1515112353', 'admin', '2018-01-05 12:27:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59437, '2018-01-05 10:44:20', NULL, NULL, 15862, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 10:44:20', 'admin-1515112353-15151202598971435', 1, 1, 'SR', NULL, NULL, NULL),
(59438, '2018-01-05 12:14:17', NULL, NULL, 15863, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 12:14:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59439, '2018-01-05 12:14:22', NULL, NULL, 15863, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 12:14:22', 'admin-1515112353-15151256626423427', 1, 0, '', NULL, NULL, NULL),
(59440, '2018-01-05 10:44:20', NULL, NULL, 15862, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 10:44:20', 'admin-1515112353-15151202598971435', 1, 0, '', NULL, NULL, NULL),
(59441, '2018-01-05 10:44:20', NULL, NULL, 15862, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 10:44:20', 'admin-1515112353-15151202598971435', 1, 1, 'SR', NULL, NULL, NULL),
(59442, '2018-01-05 10:44:20', NULL, NULL, 15862, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 10:44:20', 'admin-1515112353-15151202598971435', 1, 1, 'SR', NULL, NULL, NULL),
(59443, '2018-01-05 10:14:04', NULL, NULL, 15861, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1515112353', 'admin', '2018-01-05 10:14:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59444, '2018-01-05 10:14:11', NULL, NULL, 15861, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 10:14:11', 'admin-1515112353-15151184511418878', 1, 1, 'SR', NULL, NULL, NULL),
(59445, '2018-01-05 10:14:11', NULL, NULL, 15861, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 10:14:11', 'admin-1515112353-15151184511418878', 1, 0, '', NULL, NULL, NULL),
(59446, '2018-01-05 09:58:00', NULL, NULL, 15859, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 09:58:00', 'admin-1515112353-15151174805307482', 1, 0, '', NULL, NULL, NULL),
(59447, '2018-01-05 09:58:00', NULL, NULL, 15859, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 09:58:00', 'admin-1515112353-15151174805307482', 1, 0, '', NULL, NULL, NULL),
(59448, '2018-01-05 09:58:00', NULL, NULL, 15859, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 09:58:00', 'admin-1515112353-15151174805307482', 1, 1, 'SR', NULL, NULL, NULL),
(59449, '2018-01-05 09:58:50', NULL, NULL, 15860, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1515112353', 'admin', '2018-01-05 09:58:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59450, '2018-01-05 09:59:18', NULL, NULL, 15860, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 09:59:18', 'admin-1515112353-15151175588006337', 1, 0, '', NULL, NULL, NULL),
(59451, '2018-01-05 09:59:18', NULL, NULL, 15860, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 09:59:18', 'admin-1515112353-15151175588006337', 1, 1, 'SR', NULL, NULL, NULL),
(59452, '2018-01-05 09:59:18', NULL, NULL, 15860, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 09:59:18', 'admin-1515112353-15151175588006337', 1, 0, '', NULL, NULL, NULL),
(59453, '2018-01-05 09:27:55', NULL, NULL, 15857, 0, 181, '116', 'Open Food ', 'junior BLT', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 09:27:55', 'admin-1515112353-15151156755427489', 1, 0, '', NULL, NULL, NULL),
(59454, '2018-01-05 09:27:55', NULL, NULL, 15857, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 09:27:55', 'admin-1515112353-15151156755427489', 1, 1, 'SR', NULL, NULL, NULL),
(59455, '2018-01-05 09:44:59', NULL, NULL, 15858, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 09:44:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59456, '2018-01-05 09:45:16', NULL, NULL, 15858, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 09:45:16', 'admin-1515112353-15151167168193898', 1, 0, '', NULL, NULL, NULL),
(59457, '2018-01-05 09:45:16', NULL, NULL, 15858, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 09:45:16', 'admin-1515112353-15151167168193898', 1, 0, '', NULL, NULL, NULL),
(59458, '2018-01-05 10:03:59', NULL, NULL, 15860, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 10:03:59', 'admin-1515112353-15151178395533280', 1, 0, '', NULL, NULL, NULL),
(59459, '2018-01-05 09:59:19', NULL, NULL, 15860, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 09:59:19', 'admin-1515112353-15151175588006337', 1, 1, 'SR', NULL, NULL, NULL),
(59460, '2018-01-05 09:59:18', NULL, NULL, 15860, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 09:59:18', 'admin-1515112353-15151175588006337', 1, 1, 'SR', NULL, NULL, NULL),
(59461, '2018-01-05 09:59:18', NULL, NULL, 15860, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 09:59:18', 'admin-1515112353-15151175588006337', 1, 1, 'SR', NULL, NULL, NULL),
(59462, '2018-01-05 10:38:16', NULL, NULL, 15862, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.95, 0.0000, 0.0000, 6.95, 1, '27', 1, '1515112353', 'admin', '2018-01-05 10:38:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59463, '2018-01-05 09:45:16', NULL, NULL, 15858, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 09:45:16', 'admin-1515112353-15151167168193898', 1, 1, 'SR', NULL, NULL, NULL),
(59464, '2018-01-05 09:45:16', NULL, NULL, 15858, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515112353', 'admin', '2018-01-05 09:45:17', 'admin-1515112353-15151167168193898', 1, 1, 'SR', NULL, NULL, NULL),
(59465, '2018-01-05 09:57:50', NULL, NULL, 15859, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1515112353', 'admin', '2018-01-05 09:57:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59466, '2018-01-05 09:27:34', NULL, NULL, 15857, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1515112353', 'admin', '2018-01-05 09:27:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59467, '2018-01-06 14:06:15', NULL, NULL, 15904, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:06:15', 'admin-1515201712-15152187753541143', 1, 1, 'SR', NULL, NULL, NULL),
(59468, '2018-01-06 14:41:52', NULL, NULL, 15908, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:41:52', 'admin-1515201712-1515220912664299', 1, 1, 'SR', NULL, NULL, NULL),
(59469, '2018-01-06 14:41:52', NULL, NULL, 15908, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:41:52', 'admin-1515201712-1515220912664299', 1, 1, 'SR', NULL, NULL, NULL),
(59470, '2018-01-06 14:41:52', NULL, NULL, 15908, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:41:52', 'admin-1515201712-1515220912664299', 1, 1, 'SR', NULL, NULL, NULL),
(59471, '2018-01-06 14:57:47', NULL, NULL, 15909, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:57:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59472, '2018-01-06 14:59:08', NULL, NULL, 15909, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:59:08', 'admin-1515201712-15152219485108537', 1, 0, '', NULL, NULL, NULL),
(59473, '2018-01-06 14:59:08', NULL, NULL, 15909, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:59:08', 'admin-1515201712-15152219485108537', 1, 0, '', NULL, NULL, NULL),
(59474, '2018-01-06 14:59:08', NULL, NULL, 15909, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:59:08', 'admin-1515201712-15152219485108537', 1, 0, '', NULL, NULL, NULL),
(59475, '2018-01-06 15:50:04', NULL, NULL, 15912, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 15:50:04', 'admin-1515201712-15152250039105271', 1, 0, '', NULL, NULL, NULL),
(59476, '2018-01-06 15:50:04', NULL, NULL, 15912, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 15:50:04', 'admin-1515201712-15152250039105271', 1, 0, '', NULL, NULL, NULL),
(59477, '2018-01-06 15:50:04', NULL, NULL, 15912, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 15:50:04', 'admin-1515201712-15152250039105271', 1, 1, 'SR', NULL, NULL, NULL),
(59478, '2018-01-06 13:10:28', NULL, NULL, 15899, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:10:28', 'admin-1515201712-15152154284404344', 1, 1, 'SR', NULL, NULL, NULL),
(59479, '2018-01-06 14:07:48', NULL, NULL, 15905, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:07:48', 'admin-1515201712-15152188682401456', 1, 1, 'SR', NULL, NULL, NULL),
(59480, '2018-01-06 14:07:48', NULL, NULL, 15905, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:07:48', 'admin-1515201712-15152188682401456', 1, 1, 'SR', NULL, NULL, NULL),
(59481, '2018-01-06 14:12:13', NULL, NULL, 15902, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:12:13', 'admin-1515201712-1515219133566224', 1, 1, 'SR', NULL, NULL, NULL),
(59482, '2018-01-06 13:55:52', NULL, NULL, 15902, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:55:52', 'admin-1515201712-15152181526288066', 1, 0, '', NULL, NULL, NULL),
(59483, '2018-01-06 13:55:52', NULL, NULL, 15902, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:55:52', 'admin-1515201712-15152181526288066', 1, 1, 'SR', NULL, NULL, NULL),
(59484, '2018-01-06 11:42:33', NULL, NULL, 15888, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:42:33', 'admin-1515201712-1515210153013873', 1, 1, 'SR', NULL, NULL, NULL),
(59485, '2018-01-06 11:42:33', NULL, NULL, 15888, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:42:33', 'admin-1515201712-1515210153013873', 1, 0, '', NULL, NULL, NULL),
(59486, '2018-01-06 11:44:05', NULL, NULL, 15889, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:44:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59487, '2018-01-06 11:44:31', NULL, NULL, 15889, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:44:31', 'admin-1515201712-15152102715059052', 1, 1, 'SR', NULL, NULL, NULL),
(59488, '2018-01-06 11:44:31', NULL, NULL, 15889, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:44:31', 'admin-1515201712-15152102715059052', 1, 1, 'SR', NULL, NULL, NULL),
(59489, '2018-01-06 15:39:30', NULL, NULL, 15911, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 15:39:30', 'admin-1515201712-15152243706416845', 1, 0, '', NULL, NULL, NULL),
(59490, '2018-01-06 12:12:23', NULL, NULL, 15893, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 12:12:23', 'admin-1515201712-15152119438268029', 1, 1, 'SR', NULL, NULL, NULL),
(59491, '2018-01-06 12:12:23', NULL, NULL, 15893, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 12:12:23', 'admin-1515201712-15152119438268029', 1, 1, 'SR', NULL, NULL, NULL),
(59492, '2018-01-06 15:52:10', NULL, NULL, 15913, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1515201712', 'admin', '2018-01-06 15:52:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59493, '2018-01-06 15:53:04', NULL, NULL, 15913, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 15:53:04', 'admin-1515201712-15152251839822217', 1, 1, 'SR', NULL, NULL, NULL),
(59494, '2018-01-06 14:59:08', NULL, NULL, 15909, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:59:08', 'admin-1515201712-15152219485108537', 1, 1, 'SR', NULL, NULL, NULL),
(59495, '2018-01-06 14:41:29', NULL, NULL, 15908, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:41:29', 'admin-1515201712-1515220889334453', 1, 0, '', NULL, NULL, NULL),
(59496, '2018-01-06 14:41:52', NULL, NULL, 15908, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:41:52', 'admin-1515201712-1515220912664299', 1, 1, 'SR', NULL, NULL, NULL),
(59497, '2018-01-06 15:39:30', NULL, NULL, 15911, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 15:39:30', 'admin-1515201712-15152243706416845', 1, 0, '', NULL, NULL, NULL),
(59498, '2018-01-06 14:32:53', NULL, NULL, 15907, 0, 322, '258', 'Yuzu Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:32:53', 'admin-1515201712-15152203732763091', 1, 0, '', NULL, NULL, '10.0'),
(59499, '2018-01-06 14:32:53', NULL, NULL, 15907, 0, 322, '258', 'Yuzu Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:32:53', 'admin-1515201712-15152203732763091', 1, 0, '', NULL, NULL, '10.0'),
(59500, '2018-01-06 14:05:50', NULL, NULL, 15904, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.10, 0.0000, 0.0000, 10.10, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:05:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59501, '2018-01-06 14:06:15', NULL, NULL, 15904, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:06:15', 'admin-1515201712-15152187753541143', 1, 0, '', NULL, NULL, NULL),
(59502, '2018-01-06 14:06:15', NULL, NULL, 15904, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:06:15', 'admin-1515201712-15152187753541143', 1, 1, 'SR', NULL, NULL, NULL),
(59503, '2018-01-06 14:06:15', NULL, NULL, 15904, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:06:15', 'admin-1515201712-15152187753541143', 1, 0, '', NULL, NULL, NULL),
(59504, '2018-01-06 14:06:15', NULL, NULL, 15904, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:06:15', 'admin-1515201712-15152187753541143', 1, 0, '', NULL, NULL, NULL),
(59505, '2018-01-06 15:15:32', NULL, NULL, 15907, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 15:15:32', 'admin-1515201712-15152229328208932', 1, 0, '', NULL, NULL, '10.0'),
(59506, '2018-01-06 15:15:32', NULL, NULL, 15907, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 15:15:32', 'admin-1515201712-15152229328208932', 1, 0, '', NULL, NULL, '10.0'),
(59507, '2018-01-06 13:09:05', NULL, NULL, 15899, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.50, 0.0000, 0.0000, 9.50, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:09:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59508, '2018-01-06 13:10:28', NULL, NULL, 15899, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:10:28', 'admin-1515201712-15152154284404344', 1, 0, '', NULL, NULL, NULL),
(59509, '2018-01-06 13:25:27', NULL, NULL, 15900, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:25:27', 'admin-1515201712-15152163278083855', 1, 0, '', 1, NULL, NULL),
(59510, '2018-01-06 14:06:43', NULL, NULL, 15905, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:06:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59511, '2018-01-06 09:45:07', NULL, NULL, 15882, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 2, 21.00, 42.0000, 0.0000, 42.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 09:45:07', 'admin-1515201712-15152031071318266', 1, 0, '', NULL, NULL, NULL),
(59512, '2018-01-06 09:49:18', NULL, NULL, 15883, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1515201712', 'admin', '2018-01-06 09:49:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59513, '2018-01-06 09:50:17', NULL, NULL, 15883, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 09:50:17', 'admin-1515201712-1515203417577339', 1, 0, '', NULL, NULL, NULL),
(59514, '2018-01-06 09:50:17', NULL, NULL, 15883, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 09:50:17', 'admin-1515201712-1515203417577339', 1, 0, '', NULL, NULL, NULL),
(59515, '2018-01-06 12:49:25', NULL, NULL, 15896, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 12:49:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59516, '2018-01-06 12:50:37', NULL, NULL, 15896, 0, 181, '116', 'Open Food ', 'bkt', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 12:50:37', 'admin-1515201712-15152142371874810', 1, 0, '', NULL, NULL, NULL),
(59517, '2018-01-06 15:53:04', NULL, NULL, 15913, 0, 302, '238', 'Ice on the cake', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 15:53:04', 'admin-1515201712-15152251839822217', 1, 0, '', NULL, NULL, NULL),
(59518, '2018-01-06 15:37:12', NULL, NULL, 15911, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1515201712', 'admin', '2018-01-06 15:37:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59519, '2018-01-06 15:47:27', NULL, NULL, 15912, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1515201712', 'admin', '2018-01-06 15:47:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59520, '2018-01-06 13:07:08', NULL, NULL, 15898, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:07:08', 'admin-1515201712-15152152279593781', 1, 1, 'SR', NULL, NULL, NULL),
(59521, '2018-01-06 13:10:28', NULL, NULL, 15899, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:10:28', 'admin-1515201712-15152154284404344', 1, 1, 'SR', NULL, NULL, NULL),
(59522, '2018-01-06 15:50:04', NULL, NULL, 15912, 0, 324, '260', 'Blueberry Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 15:50:04', 'admin-1515201712-15152250039105271', 1, 0, '', NULL, NULL, NULL),
(59523, '2018-01-06 13:06:52', NULL, NULL, 15898, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:06:52', 'admin-1515201712-15152152118826843', 1, 0, '', NULL, NULL, NULL),
(59524, '2018-01-06 13:06:52', NULL, NULL, 15898, 0, 181, '116', 'Open Food ', 'BBQ Pork rice', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:06:52', 'admin-1515201712-15152152118826843', 1, 0, '', NULL, NULL, NULL),
(59525, '2018-01-06 13:06:52', NULL, NULL, 15898, 0, 181, '116', 'Open Food ', '', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:06:52', 'admin-1515201712-15152152118826843', 1, 0, '', NULL, NULL, NULL),
(59526, '2018-01-06 13:06:52', NULL, NULL, 15898, 0, 181, '116', 'Open Food ', 'BKT', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:06:52', 'admin-1515201712-15152152118826843', 1, 0, '', NULL, NULL, NULL),
(59527, '2018-01-06 12:59:07', NULL, NULL, 15894, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 12:59:07', 'admin-1515201712-15152147478313237', 1, 0, '', NULL, NULL, NULL),
(59528, '2018-01-06 14:41:29', NULL, NULL, 15908, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:41:29', 'admin-1515201712-1515220889334453', 1, 0, '', NULL, NULL, NULL),
(59529, '2018-01-06 13:58:03', NULL, NULL, 15903, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:58:03', 'admin-1515201712-15152182832362869', 1, 1, 'SR', 1, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(59530, '2018-01-06 15:26:02', NULL, NULL, 15910, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1515201712', 'admin', '2018-01-06 15:26:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59531, '2018-01-06 15:26:12', NULL, NULL, 15910, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 15:26:12', 'admin-1515201712-15152235722977819', 1, 1, 'SR', NULL, NULL, NULL),
(59532, '2018-01-06 14:39:53', NULL, NULL, 15905, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:39:53', 'admin-1515201712-15152207930405986', 1, 0, '', NULL, NULL, NULL),
(59533, '2018-01-06 15:15:33', NULL, NULL, 15907, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 15:15:33', 'admin-1515201712-15152229328208932', 1, 0, '', NULL, NULL, '10.0'),
(59534, '2018-01-06 15:15:32', NULL, NULL, 15907, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 15:15:32', 'admin-1515201712-15152229328208932', 1, 0, '', NULL, NULL, '10.0'),
(59535, '2018-01-06 13:54:08', NULL, NULL, 15902, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:54:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59536, '2018-01-06 13:11:07', NULL, NULL, 15898, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:11:07', 'admin-1515201712-15152154674439727', 1, 0, '', NULL, NULL, NULL),
(59537, '2018-01-06 13:10:28', NULL, NULL, 15899, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:10:28', 'admin-1515201712-15152154284404344', 1, 0, '', NULL, NULL, NULL),
(59538, '2018-01-06 15:00:01', NULL, NULL, 15909, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 15:00:01', 'admin-1515201712-15152220016136247', 1, 0, '', NULL, NULL, NULL),
(59539, '2018-01-06 14:59:08', NULL, NULL, 15909, 0, 338, '274', 'Chocolate Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:59:08', 'admin-1515201712-15152219485108537', 1, 0, '', NULL, NULL, NULL),
(59540, '2018-01-06 13:55:52', NULL, NULL, 15902, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:55:52', 'admin-1515201712-15152181526288066', 1, 0, '', NULL, NULL, NULL),
(59541, '2018-01-06 13:29:07', NULL, NULL, 15898, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:29:07', 'admin-1515201712-15152165477258066', 1, 1, 'SR', NULL, NULL, NULL),
(59542, '2018-01-06 13:49:25', NULL, NULL, 15901, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:49:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59543, '2018-01-06 14:41:29', NULL, NULL, 15908, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:41:29', 'admin-1515201712-1515220889334453', 1, 0, '', NULL, NULL, NULL),
(59544, '2018-01-06 11:25:40', NULL, NULL, 15887, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:25:40', 'admin-1515201712-15152091406494480', 1, 0, '', NULL, NULL, NULL),
(59545, '2018-01-06 14:41:29', NULL, NULL, 15908, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:41:29', 'admin-1515201712-1515220889334453', 1, 0, '', NULL, NULL, NULL),
(59546, '2018-01-06 14:41:29', NULL, NULL, 15908, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:41:29', 'admin-1515201712-1515220889334453', 1, 0, '', NULL, NULL, NULL),
(59547, '2018-01-06 14:29:31', NULL, NULL, 15907, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:29:31', 'admin-1515201712-15152201718046979', 1, 0, '', NULL, NULL, '10.0'),
(59548, '2018-01-06 14:29:31', NULL, NULL, 15907, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:29:31', 'admin-1515201712-15152201718046979', 1, 1, 'SR', NULL, NULL, '10.0'),
(59549, '2018-01-06 14:40:42', NULL, NULL, 15908, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 14.40, 0.0000, 0.0000, 14.40, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:40:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59550, '2018-01-06 14:29:13', NULL, NULL, 15906, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:29:13', 'admin-1515201712-15152201538152688', 1, 1, 'SR', NULL, NULL, NULL),
(59551, '2018-01-06 14:29:18', NULL, NULL, 15907, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:29:18', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(59552, '2018-01-06 14:23:37', NULL, NULL, 15902, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:23:37', 'admin-1515201712-15152198173478840', 1, 0, '', NULL, NULL, NULL),
(59553, '2018-01-06 11:42:33', NULL, NULL, 15888, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:42:33', 'admin-1515201712-1515210153013873', 1, 1, 'SR', NULL, NULL, NULL),
(59554, '2018-01-06 14:06:23', NULL, NULL, 15904, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:06:23', 'admin-1515201712-15152187835893086', 1, 0, '', NULL, NULL, NULL),
(59555, '2018-01-06 11:42:33', NULL, NULL, 15888, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:42:33', 'admin-1515201712-1515210153013873', 1, 0, '', NULL, NULL, NULL),
(59556, '2018-01-06 13:04:25', NULL, NULL, 15897, 0, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:04:25', 'admin-1515201712-15152150650689073', 1, 1, 'SR', NULL, NULL, NULL),
(59557, '2018-01-06 13:04:25', NULL, NULL, 15897, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:04:25', 'admin-1515201712-15152150650689073', 1, 1, 'SR', NULL, NULL, NULL),
(59558, '2018-01-06 13:04:25', NULL, NULL, 15897, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:04:25', 'admin-1515201712-15152150650689073', 1, 0, '', NULL, NULL, NULL),
(59559, '2018-01-06 14:06:15', NULL, NULL, 15904, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:06:15', 'admin-1515201712-15152187753541143', 1, 1, 'SR', NULL, NULL, NULL),
(59560, '2018-01-06 14:06:15', NULL, NULL, 15904, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:06:15', 'admin-1515201712-15152187753541143', 1, 1, 'SR', NULL, NULL, NULL),
(59561, '2018-01-06 15:53:04', NULL, NULL, 15913, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 15:53:04', 'admin-1515201712-15152251839822217', 1, 1, 'SR', NULL, NULL, NULL),
(59562, '2018-01-06 13:55:52', NULL, NULL, 15902, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:55:52', 'admin-1515201712-15152181526288066', 1, 1, 'SR', NULL, NULL, NULL),
(59563, '2018-01-06 13:51:23', NULL, NULL, 15901, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:51:23', 'admin-1515201712-15152178836199632', 1, 1, 'SR', NULL, NULL, NULL),
(59564, '2018-01-06 13:51:23', NULL, NULL, 15901, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:51:23', 'admin-1515201712-15152178836199632', 1, 1, 'SR', NULL, NULL, NULL),
(59565, '2018-01-06 13:51:23', NULL, NULL, 15901, 0, 181, '116', 'Open Food ', 'bkt', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:51:23', 'admin-1515201712-15152178836199632', 1, 0, '', NULL, NULL, NULL),
(59566, '2018-01-06 13:51:23', NULL, NULL, 15901, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:51:23', 'admin-1515201712-15152178836199632', 1, 0, '', NULL, NULL, NULL),
(59567, '2018-01-06 13:51:23', NULL, NULL, 15901, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:51:23', 'admin-1515201712-15152178836199632', 1, 0, '', NULL, NULL, NULL),
(59568, '2018-01-06 13:25:27', NULL, NULL, 15900, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:25:27', 'admin-1515201712-15152163278083855', 1, 0, '', 1, NULL, NULL),
(59569, '2018-01-06 13:21:42', NULL, NULL, 15897, 0, 322, '258', 'Yuzu Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:21:42', 'admin-1515201712-15152161027026925', 1, 0, '', NULL, NULL, NULL),
(59570, '2018-01-06 13:11:07', NULL, NULL, 15898, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:11:07', 'admin-1515201712-15152154674439727', 1, 1, 'SR', NULL, NULL, NULL),
(59571, '2018-01-06 13:10:28', NULL, NULL, 15899, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:10:28', 'admin-1515201712-15152154284404344', 1, 0, '', NULL, NULL, NULL),
(59572, '2018-01-06 13:10:28', NULL, NULL, 15899, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:10:28', 'admin-1515201712-15152154284404344', 1, 0, '', NULL, NULL, NULL),
(59573, '2018-01-06 13:06:52', NULL, NULL, 15898, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:06:52', 'admin-1515201712-15152152118826843', 1, 0, '', NULL, NULL, NULL),
(59574, '2018-01-06 12:57:46', NULL, NULL, 15894, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 12:57:46', 'admin-1515201712-15152146659281711', 1, 1, 'SR', NULL, NULL, NULL),
(59575, '2018-01-06 11:15:21', NULL, NULL, 15886, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:15:21', 'admin-1515201712-151520852145498', 1, 0, '', NULL, NULL, NULL),
(59576, '2018-01-06 11:15:21', NULL, NULL, 15886, 0, 337, '273', 'Hot yuzu', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:15:21', 'admin-1515201712-151520852145498', 1, 0, '', NULL, NULL, NULL),
(59577, '2018-01-06 12:24:58', NULL, NULL, 15894, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 12:24:58', 'admin-1515201712-15152126980721710', 1, 1, 'SR', NULL, NULL, NULL),
(59578, '2018-01-06 12:37:24', NULL, NULL, 15895, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1515201712', 'admin', '2018-01-06 12:37:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59579, '2018-01-06 12:37:37', NULL, NULL, 15895, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 12:37:37', 'admin-1515201712-15152134571407349', 1, 1, 'SR', NULL, NULL, NULL),
(59580, '2018-01-06 12:39:22', NULL, NULL, 15894, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 12:39:22', 'admin-1515201712-15152135625101728', 1, 1, 'SR', NULL, NULL, NULL),
(59581, '2018-01-06 13:04:25', NULL, NULL, 15897, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:04:25', 'admin-1515201712-15152150650689073', 1, 0, '', NULL, NULL, NULL),
(59582, '2018-01-06 12:59:07', NULL, NULL, 15894, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 12:59:07', 'admin-1515201712-15152147478313237', 1, 0, '', NULL, NULL, NULL),
(59583, '2018-01-06 13:03:10', NULL, NULL, 15897, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.50, 0.0000, 0.0000, 9.50, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:03:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59584, '2018-01-06 15:50:04', NULL, NULL, 15912, 0, 322, '258', 'Yuzu Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 15:50:04', 'admin-1515201712-15152250039105271', 1, 0, '', NULL, NULL, NULL),
(59585, '2018-01-06 12:50:37', NULL, NULL, 15896, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 12:50:37', 'admin-1515201712-15152142371874810', 1, 1, 'SR', NULL, NULL, NULL),
(59586, '2018-01-06 13:04:25', NULL, NULL, 15897, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:04:25', 'admin-1515201712-15152150650689073', 1, 0, '', NULL, NULL, NULL),
(59587, '2018-01-06 12:24:25', NULL, NULL, 15894, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1515201712', 'admin', '2018-01-06 12:24:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59588, '2018-01-06 12:09:42', NULL, NULL, 15892, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 12:09:42', 'admin-1515201712-1515211782352466', 1, 0, '', NULL, NULL, NULL),
(59589, '2018-01-06 12:12:14', NULL, NULL, 15893, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 12:12:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59590, '2018-01-06 12:09:42', NULL, NULL, 15892, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 12:09:42', 'admin-1515201712-1515211782352466', 1, 0, '', NULL, NULL, NULL),
(59591, '2018-01-06 12:09:42', NULL, NULL, 15892, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 12:09:42', 'admin-1515201712-1515211782352466', 1, 1, 'SR', NULL, NULL, NULL),
(59592, '2018-01-06 11:51:00', NULL, NULL, 15890, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:51:00', 'admin-1515201712-15152106605932872', 1, 0, '', NULL, NULL, NULL),
(59593, '2018-01-06 12:09:42', NULL, NULL, 15892, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 12:09:42', 'admin-1515201712-1515211782352466', 1, 0, '', NULL, NULL, NULL),
(59594, '2018-01-06 12:09:42', NULL, NULL, 15892, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 12:09:42', 'admin-1515201712-1515211782352466', 1, 0, '', NULL, NULL, NULL),
(59595, '2018-01-06 14:29:04', NULL, NULL, 15906, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:29:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59596, '2018-01-06 12:08:06', NULL, NULL, 15892, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1515201712', 'admin', '2018-01-06 12:08:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59597, '2018-01-06 11:56:16', NULL, NULL, 15891, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:56:16', 'admin-1515201712-15152109766775686', 1, 1, 'SR', NULL, NULL, NULL),
(59598, '2018-01-06 11:56:06', NULL, NULL, 15891, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:56:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59599, '2018-01-06 11:51:00', NULL, NULL, 15890, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:51:00', 'admin-1515201712-15152106605932872', 1, 1, 'SR', NULL, NULL, NULL),
(59600, '2018-01-06 13:06:19', NULL, NULL, 15898, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.00, 0.0000, 0.0000, 11.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 13:06:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59601, '2018-01-06 14:41:29', NULL, NULL, 15908, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 14:41:29', 'admin-1515201712-1515220889334453', 1, 0, '', NULL, NULL, NULL),
(59602, '2018-01-06 11:51:00', NULL, NULL, 15890, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:51:00', 'admin-1515201712-15152106605932872', 1, 0, '', NULL, NULL, NULL),
(59603, '2018-01-06 11:49:44', NULL, NULL, 15890, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:49:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59604, '2018-01-06 11:41:14', NULL, NULL, 15888, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:41:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59605, '2018-01-06 11:25:26', NULL, NULL, 15887, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:25:26', 'admin-1515201712-1515209126222285', 1, 0, '', NULL, NULL, NULL),
(59606, '2018-01-06 11:25:26', NULL, NULL, 15887, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:25:26', 'admin-1515201712-1515209126222285', 1, 0, '', NULL, NULL, NULL),
(59607, '2018-01-06 11:25:40', NULL, NULL, 15887, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:25:40', 'admin-1515201712-15152091406494480', 1, 0, '', NULL, NULL, NULL),
(59608, '2018-01-06 11:25:40', NULL, NULL, 15887, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:25:40', 'admin-1515201712-15152091406494480', 1, 1, 'SR', NULL, NULL, NULL),
(59609, '2018-01-06 10:21:16', NULL, NULL, 15885, 0, 32, '32', 'Tea By Pot ', 'earl grey', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 10:21:16', 'admin-1515201712-15152052762194189', 1, 1, 'SR', NULL, NULL, NULL),
(59610, '2018-01-06 11:14:25', NULL, NULL, 15886, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:14:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59611, '2018-01-06 11:25:26', NULL, NULL, 15887, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:25:26', 'admin-1515201712-1515209126222285', 1, 0, '', NULL, NULL, NULL),
(59612, '2018-01-06 11:25:02', NULL, NULL, 15887, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:25:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59613, '2018-01-06 11:15:21', NULL, NULL, 15886, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:15:21', 'admin-1515201712-151520852145498', 1, 0, '', NULL, NULL, NULL),
(59614, '2018-01-06 10:49:01', NULL, NULL, 15885, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 10:49:01', 'admin-1515201712-1515206941654335', 1, 0, '', NULL, NULL, NULL),
(59615, '2018-01-06 11:15:21', NULL, NULL, 15886, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 11:15:21', 'admin-1515201712-151520852145498', 1, 0, '', NULL, NULL, NULL),
(59616, '2018-01-06 10:01:22', NULL, NULL, 15884, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 10:01:22', 'admin-1515201712-1515204082077687', 1, 0, '', NULL, NULL, NULL),
(59617, '2018-01-06 10:01:22', NULL, NULL, 15884, 0, 153, '87', 'Wake Me Up!', 'sunny side up egg', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 10:01:22', 'admin-1515201712-1515204082077687', 1, 0, '', NULL, NULL, NULL),
(59618, '2018-01-06 10:01:22', NULL, NULL, 15884, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 10:01:22', 'admin-1515201712-1515204082077687', 1, 1, 'SR', NULL, NULL, NULL),
(59619, '2018-01-06 10:01:22', NULL, NULL, 15884, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 10:01:22', 'admin-1515201712-1515204082077687', 1, 1, 'SR', NULL, NULL, NULL),
(59620, '2018-01-06 09:34:50', NULL, NULL, 15880, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 09:34:50', 'admin-1515201712-15152024900843891', 1, 0, '', NULL, NULL, NULL),
(59621, '2018-01-06 09:34:50', NULL, NULL, 15880, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 09:34:50', 'admin-1515201712-15152024900843891', 1, 0, '', NULL, NULL, NULL),
(59622, '2018-01-06 09:34:50', NULL, NULL, 15880, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 09:34:50', 'admin-1515201712-15152024900843891', 1, 1, 'SR', NULL, NULL, NULL),
(59623, '2018-01-06 09:39:36', NULL, NULL, 15881, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1515201712', 'admin', '2018-01-06 09:39:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59624, '2018-01-06 09:40:06', NULL, NULL, 15881, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 09:40:06', 'admin-1515201712-15152028063004247', 1, 0, '', NULL, NULL, NULL),
(59625, '2018-01-06 09:40:06', NULL, NULL, 15881, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 09:40:06', 'admin-1515201712-15152028063004247', 1, 0, '', NULL, NULL, NULL),
(59626, '2018-01-06 09:40:06', NULL, NULL, 15881, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 09:40:06', 'admin-1515201712-15152028063004247', 1, 0, '', NULL, NULL, NULL),
(59627, '2018-01-06 10:21:16', NULL, NULL, 15885, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 10:21:16', 'admin-1515201712-15152052762194189', 1, 0, '', NULL, NULL, NULL),
(59628, '2018-01-06 10:21:16', NULL, NULL, 15885, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 10:21:16', 'admin-1515201712-15152052762194189', 1, 0, '', NULL, NULL, NULL),
(59629, '2018-01-06 10:20:39', NULL, NULL, 15885, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1515201712', 'admin', '2018-01-06 10:20:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59630, '2018-01-06 10:01:22', NULL, NULL, 15884, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 10:01:22', 'admin-1515201712-1515204082077687', 1, 0, '', NULL, NULL, NULL),
(59631, '2018-01-06 10:01:22', NULL, NULL, 15884, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 10:01:22', 'admin-1515201712-1515204082077687', 1, 0, '', NULL, NULL, NULL),
(59632, '2018-01-06 09:34:50', NULL, NULL, 15880, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 09:34:50', 'admin-1515201712-15152024900843891', 1, 0, '', NULL, NULL, NULL),
(59633, '2018-01-06 09:58:27', NULL, NULL, 15884, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.00, 0.0000, 0.0000, 11.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 09:58:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59634, '2018-01-06 09:50:17', NULL, NULL, 15883, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 09:50:17', 'admin-1515201712-1515203417577339', 1, 0, '', NULL, NULL, NULL),
(59635, '2018-01-06 09:45:07', NULL, NULL, 15882, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 09:45:07', 'admin-1515201712-15152031071318266', 1, 1, 'SR', NULL, NULL, NULL),
(59636, '2018-01-06 09:44:25', NULL, NULL, 15882, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1515201712', 'admin', '2018-01-06 09:44:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59637, '2018-01-06 09:40:06', NULL, NULL, 15881, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 09:40:06', 'admin-1515201712-15152028063004247', 1, 1, 'SR', NULL, NULL, NULL),
(59638, '2018-01-06 10:01:22', NULL, NULL, 15884, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 10:01:22', 'admin-1515201712-1515204082077687', 1, 0, '', NULL, NULL, NULL),
(59639, '2018-01-06 09:40:06', NULL, NULL, 15881, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515201712', 'admin', '2018-01-06 09:40:06', 'admin-1515201712-15152028063004247', 1, 1, 'SR', NULL, NULL, NULL),
(59640, '2018-01-06 09:33:50', NULL, NULL, 15880, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1515201712', 'admin', '2018-01-06 09:33:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59641, '2018-01-07 10:51:10', NULL, NULL, 15930, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:51:10', 'admin-1515286096-1515293470192268', 1, 0, '', NULL, NULL, NULL),
(59642, '2018-01-07 13:55:38', NULL, NULL, 15950, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1515286096', 'admin', '2018-01-07 13:55:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59643, '2018-01-07 13:21:55', NULL, NULL, 15948, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 13:21:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59644, '2018-01-07 13:22:26', NULL, NULL, 15948, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 13:22:26', 'admin-1515286096-15153025461159098', 1, 0, '', NULL, NULL, NULL),
(59645, '2018-01-07 13:22:26', NULL, NULL, 15948, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 13:22:26', 'admin-1515286096-15153025461159098', 1, 0, '', NULL, NULL, NULL),
(59646, '2018-01-07 13:22:26', NULL, NULL, 15948, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 13:22:26', 'admin-1515286096-15153025461159098', 1, 1, 'SR', NULL, NULL, NULL),
(59647, '2018-01-07 10:40:33', NULL, NULL, 15926, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:40:33', 'admin-1515286096-15152928333153496', 1, 0, '', NULL, NULL, NULL),
(59648, '2018-01-07 10:40:33', NULL, NULL, 15926, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:40:33', 'admin-1515286096-15152928333153496', 1, 0, '', NULL, NULL, NULL),
(59649, '2018-01-07 10:40:41', NULL, NULL, 15926, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:40:41', 'admin-1515286096-15152928410093698', 1, 1, 'SR', NULL, NULL, NULL),
(59650, '2018-01-07 10:40:41', NULL, NULL, 15926, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:40:41', 'admin-1515286096-15152928410093698', 1, 1, 'SR', NULL, NULL, NULL),
(59651, '2018-01-07 12:16:50', NULL, NULL, 15943, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 12:16:50', 'admin-1515286096-15152986107527968', 1, 1, 'SR', NULL, NULL, NULL),
(59652, '2018-01-07 12:40:54', NULL, NULL, 15944, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1515286096', 'admin', '2018-01-07 12:40:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59653, '2018-01-07 13:34:26', NULL, NULL, 15949, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 13:34:26', 'admin-1515286096-15153032660027546', 1, 0, '', NULL, NULL, NULL),
(59654, '2018-01-07 13:34:26', NULL, NULL, 15949, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 13:34:26', 'admin-1515286096-15153032660027546', 1, 0, '', NULL, NULL, NULL),
(59655, '2018-01-07 13:33:53', NULL, NULL, 15949, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 13:33:53', 'admin-1515286096-15153032333609167', 1, 1, 'SR', NULL, NULL, NULL),
(59656, '2018-01-07 11:45:18', NULL, NULL, 15941, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:45:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59657, '2018-01-07 11:45:34', NULL, NULL, 15941, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:45:34', 'admin-1515286096-15152967347082385', 1, 0, '', NULL, NULL, NULL),
(59658, '2018-01-07 11:28:58', NULL, NULL, 15936, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:28:58', 'admin-1515286096-1515295738352510', 1, 1, 'SR', NULL, NULL, NULL),
(59659, '2018-01-07 11:28:58', NULL, NULL, 15936, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:28:58', 'admin-1515286096-1515295738352510', 1, 1, 'SR', NULL, NULL, NULL),
(59660, '2018-01-07 11:28:58', NULL, NULL, 15936, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:28:58', 'admin-1515286096-1515295738352510', 1, 1, 'SR', NULL, NULL, NULL),
(59661, '2018-01-07 11:29:13', NULL, NULL, 15937, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:29:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59662, '2018-01-07 11:29:26', NULL, NULL, 15937, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:29:26', 'admin-1515286096-1515295766736667', 1, 1, 'SR', NULL, NULL, NULL),
(59663, '2018-01-07 13:56:02', NULL, NULL, 15950, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 13:56:02', 'admin-1515286096-15153045624306887', 1, 0, '', NULL, NULL, NULL),
(59664, '2018-01-07 13:59:50', NULL, NULL, 15951, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1515286096', 'admin', '2018-01-07 13:59:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59665, '2018-01-07 14:00:09', NULL, NULL, 15951, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 14:00:09', 'admin-1515286096-15153048096124564', 1, 0, '', NULL, NULL, NULL),
(59666, '2018-01-07 14:00:09', NULL, NULL, 15951, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 14:00:09', 'admin-1515286096-15153048096124564', 1, 1, 'SR', NULL, NULL, NULL),
(59667, '2018-01-07 14:00:09', NULL, NULL, 15951, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 14:00:09', 'admin-1515286096-15153048096124564', 1, 1, 'SR', NULL, NULL, NULL),
(59668, '2018-01-07 10:48:01', NULL, NULL, 15928, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:48:01', 'admin-1515286096-15152932811335391', 1, 0, '', NULL, NULL, NULL),
(59669, '2018-01-07 10:48:01', NULL, NULL, 15928, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:48:01', 'admin-1515286096-15152932811335391', 1, 0, '', NULL, NULL, NULL),
(59670, '2018-01-07 10:40:33', NULL, NULL, 15926, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:40:33', 'admin-1515286096-15152928333153496', 1, 0, '', NULL, NULL, NULL),
(59671, '2018-01-07 13:22:26', NULL, NULL, 15948, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 13:22:26', 'admin-1515286096-15153025461159098', 1, 1, 'SR', NULL, NULL, NULL),
(59672, '2018-01-07 13:33:11', NULL, NULL, 15949, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1515286096', 'admin', '2018-01-07 13:33:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59673, '2018-01-07 13:33:53', NULL, NULL, 15949, 0, 297, '233', 'BBQ Pork Soup Noodle', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 13:33:53', 'admin-1515286096-15153032333609167', 1, 0, '', NULL, NULL, NULL),
(59674, '2018-01-07 11:44:42', NULL, NULL, 15938, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:44:42', 'admin-1515286096-1515296682685925', 1, 0, '', NULL, NULL, NULL),
(59675, '2018-01-07 11:30:58', NULL, NULL, 15938, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:30:58', 'admin-1515286096-15152958585385612', 1, 0, '', NULL, NULL, NULL),
(59676, '2018-01-07 11:30:58', NULL, NULL, 15938, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:30:58', 'admin-1515286096-15152958585385612', 1, 1, 'SR', NULL, NULL, NULL),
(59677, '2018-01-07 11:44:42', NULL, NULL, 15938, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:44:42', 'admin-1515286096-1515296682685925', 1, 0, '', NULL, NULL, NULL),
(59678, '2018-01-07 13:21:02', NULL, NULL, 15947, 0, 181, '116', 'Open Food ', 'Flavour butter', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 13:21:02', 'admin-1515286096-1515302462443485', 1, 0, '', 1, NULL, NULL),
(59679, '2018-01-07 13:33:53', NULL, NULL, 15949, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 13:33:53', 'admin-1515286096-15153032333609167', 1, 0, '', NULL, NULL, NULL),
(59680, '2018-01-07 12:56:52', NULL, NULL, 15946, 0, 181, '116', 'Open Food ', 'Potato chicken', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 12:56:52', 'admin-1515286096-15153010120606434', 1, 0, '', NULL, NULL, '10.0'),
(59681, '2018-01-07 10:51:10', NULL, NULL, 15930, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:51:10', 'admin-1515286096-1515293470192268', 1, 1, 'SR', NULL, NULL, NULL),
(59682, '2018-01-07 10:51:10', NULL, NULL, 15930, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:51:10', 'admin-1515286096-1515293470192268', 1, 1, 'SR', NULL, NULL, NULL),
(59683, '2018-01-07 11:00:34', NULL, NULL, 15931, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:00:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59684, '2018-01-07 11:01:00', NULL, NULL, 15931, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:01:00', 'admin-1515286096-1515294060043559', 1, 0, '', NULL, NULL, NULL),
(59685, '2018-01-07 10:33:58', NULL, NULL, 15926, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 19.70, 0.0000, 0.0000, 19.70, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:33:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59686, '2018-01-07 14:00:58', NULL, NULL, 15948, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 14:00:58', 'admin-1515286096-15153048579898658', 1, 0, '', NULL, NULL, NULL),
(59687, '2018-01-07 11:45:34', NULL, NULL, 15941, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:45:34', 'admin-1515286096-15152967347082385', 1, 0, '', NULL, NULL, NULL),
(59688, '2018-01-07 11:51:31', NULL, NULL, 15938, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:51:31', 'admin-1515286096-15152970913058566', 1, 1, 'SR', NULL, NULL, NULL),
(59689, '2018-01-07 12:02:04', NULL, NULL, 15942, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1515286096', 'admin', '2018-01-07 12:02:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59690, '2018-01-07 12:02:10', NULL, NULL, 15942, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 12:02:10', 'admin-1515286096-15152977300968489', 1, 0, '', NULL, NULL, NULL),
(59691, '2018-01-07 12:42:22', NULL, NULL, 15945, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 12:42:22', 'admin-1515286096-1515300142251961', 1, 1, 'SR', NULL, NULL, NULL),
(59692, '2018-01-07 11:29:26', NULL, NULL, 15937, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:29:26', 'admin-1515286096-1515295766736667', 1, 1, 'SR', NULL, NULL, NULL),
(59693, '2018-01-07 09:17:33', NULL, NULL, 15916, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:17:33', 'admin-1515286096-15152878529523593', 1, 1, 'SR', NULL, NULL, NULL),
(59694, '2018-01-07 09:22:23', NULL, NULL, 15916, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:22:23', 'admin-1515286096-15152881431557152', 1, 1, 'SR', NULL, NULL, NULL),
(59695, '2018-01-07 09:27:58', NULL, NULL, 15917, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 11.40, 0.0000, 0.0000, 11.40, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:27:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59696, '2018-01-07 09:29:03', NULL, NULL, 15917, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:29:03', 'admin-1515286096-15152885432842523', 1, 0, '', NULL, NULL, NULL),
(59697, '2018-01-07 12:42:22', NULL, NULL, 15945, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 12:42:22', 'admin-1515286096-1515300142251961', 1, 1, 'SR', NULL, NULL, NULL),
(59698, '2018-01-07 13:56:02', NULL, NULL, 15950, 0, 181, '116', 'Open Food ', 'BKT', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 13:56:02', 'admin-1515286096-15153045624306887', 1, 0, '', NULL, NULL, NULL),
(59699, '2018-01-07 12:42:22', NULL, NULL, 15945, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 12:42:22', 'admin-1515286096-1515300142251961', 1, 0, '', NULL, NULL, NULL),
(59700, '2018-01-07 11:13:59', NULL, NULL, 15935, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:13:59', 'admin-1515286096-15152948391722286', 1, 1, 'SR', NULL, NULL, NULL),
(59701, '2018-01-07 11:13:59', NULL, NULL, 15935, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:13:59', 'admin-1515286096-15152948391722286', 1, 0, '', NULL, NULL, NULL),
(59702, '2018-01-07 12:42:22', NULL, NULL, 15945, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 12:42:22', 'admin-1515286096-1515300142251961', 1, 1, 'SR', NULL, NULL, NULL),
(59703, '2018-01-07 11:30:58', NULL, NULL, 15938, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:30:58', 'admin-1515286096-15152958585385612', 1, 0, '', NULL, NULL, NULL),
(59704, '2018-01-07 11:30:58', NULL, NULL, 15938, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:30:58', 'admin-1515286096-15152958585385612', 1, 0, '', NULL, NULL, NULL),
(59705, '2018-01-07 11:35:00', NULL, NULL, 15940, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:35:00', 'admin-1515286096-1515296100681731', 1, 0, '', NULL, NULL, NULL),
(59706, '2018-01-07 11:35:00', NULL, NULL, 15940, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:35:00', 'admin-1515286096-1515296100681731', 1, 0, '', NULL, NULL, NULL),
(59707, '2018-01-07 12:42:22', NULL, NULL, 15945, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 12:42:22', 'admin-1515286096-1515300142251961', 1, 0, '', NULL, NULL, NULL),
(59708, '2018-01-07 13:56:02', NULL, NULL, 15950, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 13:56:02', 'admin-1515286096-15153045624306887', 1, 0, '', NULL, NULL, NULL),
(59709, '2018-01-07 12:42:22', NULL, NULL, 15945, 0, 181, '116', 'Open Food ', 'BKT', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 12:42:22', 'admin-1515286096-1515300142251961', 1, 0, '', NULL, NULL, NULL),
(59710, '2018-01-07 12:42:22', NULL, NULL, 15945, 0, 181, '116', 'Open Food ', 'BKT', 'Meals', 'Perfect Meals', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 12:42:22', 'admin-1515286096-1515300142251961', 1, 0, '', NULL, NULL, NULL),
(59711, '2018-01-07 12:41:43', NULL, NULL, 15945, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.30, 0.0000, 0.0000, 10.30, 1, '27', 1, '1515286096', 'admin', '2018-01-07 12:41:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59712, '2018-01-07 12:41:05', NULL, NULL, 15944, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 12:41:05', 'admin-1515286096-15153000657035290', 1, 0, '', NULL, NULL, NULL),
(59713, '2018-01-07 11:01:00', NULL, NULL, 15931, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:01:00', 'admin-1515286096-1515294060043559', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(59714, '2018-01-07 11:30:58', NULL, NULL, 15938, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:30:58', 'admin-1515286096-15152958585385612', 1, 0, '', NULL, NULL, NULL),
(59715, '2018-01-07 11:30:58', NULL, NULL, 15938, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:30:58', 'admin-1515286096-15152958585385612', 1, 0, '', NULL, NULL, NULL),
(59716, '2018-01-07 12:41:05', NULL, NULL, 15944, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 12:41:05', 'admin-1515286096-15153000657035290', 1, 1, 'SR', NULL, NULL, NULL),
(59717, '2018-01-07 12:41:05', NULL, NULL, 15944, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 12:41:05', 'admin-1515286096-15153000657035290', 1, 0, '', NULL, NULL, NULL),
(59718, '2018-01-07 12:16:33', NULL, NULL, 15943, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1515286096', 'admin', '2018-01-07 12:16:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59719, '2018-01-07 12:16:50', NULL, NULL, 15943, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 12:16:50', 'admin-1515286096-15152986107527968', 1, 1, 'SR', NULL, NULL, NULL),
(59720, '2018-01-07 12:42:22', NULL, NULL, 15945, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 12:42:22', 'admin-1515286096-1515300142251961', 1, 1, 'SR', NULL, NULL, NULL),
(59721, '2018-01-07 12:56:37', NULL, NULL, 15946, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1515286096', 'admin', '2018-01-07 12:56:37', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(59722, '2018-01-07 12:02:10', NULL, NULL, 15942, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 12:02:10', 'admin-1515286096-15152977300968489', 1, 0, '', NULL, NULL, NULL),
(59723, '2018-01-07 11:30:58', NULL, NULL, 15938, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:30:58', 'admin-1515286096-15152958585385612', 1, 0, '', NULL, NULL, NULL),
(59724, '2018-01-07 11:34:49', NULL, NULL, 15940, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:34:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59725, '2018-01-07 11:35:00', NULL, NULL, 15940, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:35:00', 'admin-1515286096-1515296100681731', 1, 0, '', NULL, NULL, NULL),
(59726, '2018-01-07 11:34:20', NULL, NULL, 15939, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:34:20', 'admin-1515286096-15152960603045515', 1, 1, 'SR', 1, NULL, NULL),
(59727, '2018-01-07 11:12:55', NULL, NULL, 15935, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:12:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59728, '2018-01-07 11:01:00', NULL, NULL, 15931, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:01:00', 'admin-1515286096-1515294060043559', 1, 1, 'SR', NULL, NULL, NULL),
(59729, '2018-01-07 11:30:58', NULL, NULL, 15938, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:30:58', 'admin-1515286096-15152958585385612', 1, 0, '', NULL, NULL, NULL),
(59730, '2018-01-07 00:00:00', NULL, NULL, 15923, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:23:01', 'admin-1515286096-15152917810602783', 1, 0, '', NULL, NULL, NULL),
(59731, '2018-01-07 11:30:58', NULL, NULL, 15938, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:30:58', 'admin-1515286096-15152958585385612', 1, 0, '', NULL, NULL, NULL),
(59732, '2018-01-07 11:30:58', NULL, NULL, 15938, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:30:58', 'admin-1515286096-15152958585385612', 1, 0, '', NULL, NULL, NULL),
(59733, '2018-01-07 10:40:41', NULL, NULL, 15926, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:40:41', 'admin-1515286096-15152928410093698', 1, 1, 'SR', NULL, NULL, NULL),
(59734, '2018-01-07 10:40:41', NULL, NULL, 15926, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:40:41', 'admin-1515286096-15152928410093698', 1, 0, '', NULL, NULL, NULL),
(59735, '2018-01-07 10:34:33', NULL, NULL, 15926, 0, 75, '75', 'Meatless Aglio Olio ', 'no spicy', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:34:33', 'admin-1515286096-15152924736048428', 1, 0, '', NULL, NULL, NULL),
(59736, '2018-01-07 11:29:56', NULL, NULL, 15938, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 20.30, 0.0000, 0.0000, 20.30, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:29:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59737, '2018-01-07 10:28:54', NULL, NULL, 15924, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:28:54', 'admin-1515286096-15152921343583695', 1, 0, '', NULL, NULL, NULL),
(59738, '2018-01-07 11:28:58', NULL, NULL, 15936, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:28:58', 'admin-1515286096-1515295738352510', 1, 0, '', NULL, NULL, NULL),
(59739, '2018-01-07 11:28:58', NULL, NULL, 15936, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:28:58', 'admin-1515286096-1515295738352510', 1, 1, 'SR', NULL, NULL, NULL),
(59740, '2018-01-07 11:28:58', NULL, NULL, 15936, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:28:58', 'admin-1515286096-1515295738352510', 1, 0, '', NULL, NULL, NULL),
(59741, '2018-01-07 11:28:58', NULL, NULL, 15936, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:28:58', 'admin-1515286096-1515295738352510', 1, 0, '', NULL, NULL, NULL),
(59742, '2018-01-07 11:01:00', NULL, NULL, 15931, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:01:00', 'admin-1515286096-1515294060043559', 1, 1, 'SR', NULL, NULL, NULL),
(59743, '2018-01-07 14:34:32', NULL, NULL, 15950, 0, 181, '116', 'Open Food ', 'CNY Dumpling', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 14:34:32', 'admin-1515286096-15153068724159138', 1, 0, '', NULL, NULL, NULL),
(59744, '2018-01-07 11:28:58', NULL, NULL, 15936, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:28:58', 'admin-1515286096-1515295738352510', 1, 0, '', NULL, NULL, NULL),
(59745, '2018-01-07 11:28:18', NULL, NULL, 15936, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:28:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59746, '2018-01-07 11:04:19', NULL, NULL, 15932, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:04:19', 'admin-1515286096-15152942592596666', 1, 1, 'SR', 1, NULL, NULL),
(59747, '2018-01-07 13:33:53', NULL, NULL, 15949, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 13:33:53', 'admin-1515286096-15153032333609167', 1, 0, '', NULL, NULL, NULL),
(59748, '2018-01-07 11:13:59', NULL, NULL, 15935, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:13:59', 'admin-1515286096-15152948391722286', 1, 0, '', NULL, NULL, NULL),
(59749, '2018-01-07 11:11:14', NULL, NULL, 15934, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:11:14', 'admin-1515286096-15152946744592524', 1, 1, 'SR', NULL, NULL, NULL),
(59750, '2018-01-07 11:11:52', NULL, NULL, 15921, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:11:52', 'admin-1515286096-15152947126133035', 1, 0, '', NULL, NULL, NULL),
(59751, '2018-01-07 11:11:07', NULL, NULL, 15934, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:11:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59752, '2018-01-07 11:11:14', NULL, NULL, 15934, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:11:14', 'admin-1515286096-15152946744592524', 1, 0, '', NULL, NULL, NULL),
(59753, '2018-01-07 11:08:12', NULL, NULL, 15933, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:08:12', 'admin-1515286096-15152944923214927', 1, 1, 'SR', NULL, NULL, NULL),
(59754, '2018-01-07 10:48:43', NULL, NULL, 15926, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:48:43', 'admin-1515286096-15152933231621382', 1, 0, '', NULL, NULL, NULL),
(59755, '2018-01-07 10:42:07', NULL, NULL, 15927, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:42:07', 'admin-1515286096-15152929271153434', 1, 1, 'SR', NULL, NULL, NULL),
(59756, '2018-01-07 11:08:12', NULL, NULL, 15933, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:08:12', 'admin-1515286096-15152944923214927', 1, 1, 'SR', NULL, NULL, NULL),
(59757, '2018-01-07 11:08:12', NULL, NULL, 15933, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:08:12', 'admin-1515286096-15152944923214927', 1, 0, '', NULL, NULL, NULL),
(59758, '2018-01-07 11:08:12', NULL, NULL, 15933, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:08:12', 'admin-1515286096-15152944923214927', 1, 1, 'SR', NULL, NULL, NULL),
(59759, '2018-01-07 11:08:12', NULL, NULL, 15933, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:08:12', 'admin-1515286096-15152944923214927', 1, 1, 'SR', NULL, NULL, NULL),
(59760, '2018-01-07 11:08:12', NULL, NULL, 15933, 0, 153, '87', 'Wake Me Up!', 'sunny side up egg', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:08:12', 'admin-1515286096-15152944923214927', 1, 0, '', NULL, NULL, NULL),
(59761, '2018-01-07 11:08:12', NULL, NULL, 15933, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:08:12', 'admin-1515286096-15152944923214927', 1, 0, '', NULL, NULL, NULL),
(59762, '2018-01-07 10:50:29', NULL, NULL, 15930, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:50:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59763, '2018-01-07 10:51:10', NULL, NULL, 15930, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:51:10', 'admin-1515286096-1515293470192268', 1, 0, '', NULL, NULL, NULL),
(59764, '2018-01-07 11:01:54', NULL, NULL, 15922, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:01:54', 'admin-1515286096-15152941145504481', 1, 0, '', NULL, NULL, NULL),
(59765, '2018-01-07 10:42:07', NULL, NULL, 15927, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:42:07', 'admin-1515286096-15152929271153434', 1, 1, 'SR', NULL, NULL, NULL),
(59766, '2018-01-07 10:42:07', NULL, NULL, 15927, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:42:07', 'admin-1515286096-15152929271153434', 1, 1, 'SR', NULL, NULL, NULL),
(59767, '2018-01-07 10:43:04', NULL, NULL, 15921, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:43:04', 'admin-1515286096-15152929843988481', 1, 0, '', NULL, NULL, NULL),
(59768, '2018-01-07 11:06:59', NULL, NULL, 15933, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 9.60, 0.0000, 0.0000, 9.60, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:06:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59769, '2018-01-07 11:01:00', NULL, NULL, 15931, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 11:01:00', 'admin-1515286096-1515294060043559', 1, 0, '', NULL, NULL, NULL),
(59770, '2018-01-07 10:51:10', NULL, NULL, 15930, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:51:10', 'admin-1515286096-1515293470192268', 1, 1, 'SR', NULL, NULL, NULL),
(59771, '2018-01-07 10:51:10', NULL, NULL, 15930, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:51:10', 'admin-1515286096-1515293470192268', 1, 0, '', NULL, NULL, NULL),
(59772, '2018-01-07 10:48:43', NULL, NULL, 15926, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:48:43', 'admin-1515286096-15152933231621382', 1, 0, '', NULL, NULL, NULL),
(59773, '2018-01-07 10:46:25', NULL, NULL, 15929, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:46:25', 'admin-1515286096-15152931857482965', 1, 1, 'SR', 1, NULL, NULL),
(59774, '2018-01-07 10:46:25', NULL, NULL, 15929, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:46:25', 'admin-1515286096-15152931857482965', 1, 1, 'SR', 1, NULL, NULL),
(59775, '2018-01-07 10:43:04', NULL, NULL, 15921, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:43:04', 'admin-1515286096-15152929843988481', 1, 1, 'SR', NULL, NULL, NULL),
(59776, '2018-01-07 10:45:21', NULL, NULL, 15928, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:45:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59777, '2018-01-07 10:42:07', NULL, NULL, 15927, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:42:07', 'admin-1515286096-15152929271153434', 1, 0, '', NULL, NULL, NULL),
(59778, '2018-01-07 10:42:07', NULL, NULL, 15927, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:42:07', 'admin-1515286096-15152929271153434', 1, 0, '', NULL, NULL, NULL),
(59779, '2018-01-07 10:40:58', NULL, NULL, 15927, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:40:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59780, '2018-01-07 10:40:33', NULL, NULL, 15926, 0, 271, '205', 'Take It Easy', 'sunny side up', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:40:33', 'admin-1515286096-15152928333153496', 1, 0, '', NULL, NULL, NULL),
(59781, '2018-01-07 13:56:02', NULL, NULL, 15950, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 13:56:02', 'admin-1515286096-15153045624306887', 1, 1, 'SR', NULL, NULL, NULL),
(59782, '2018-01-07 10:40:33', NULL, NULL, 15926, 0, 153, '87', 'Wake Me Up!', 'sunny side up', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:40:33', 'admin-1515286096-15152928333153496', 1, 0, '', NULL, NULL, NULL),
(59783, '2018-01-07 10:34:33', NULL, NULL, 15926, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:34:33', 'admin-1515286096-15152924736048428', 1, 1, 'SR', NULL, NULL, NULL),
(59784, '2018-01-07 10:34:33', NULL, NULL, 15926, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:34:33', 'admin-1515286096-15152924736048428', 1, 1, 'SR', NULL, NULL, NULL),
(59785, '2018-01-07 10:31:22', NULL, NULL, 15925, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:31:22', 'admin-1515286096-15152922822013854', 1, 0, '', 1, NULL, NULL),
(59786, '2018-01-07 10:28:54', NULL, NULL, 15924, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:28:54', 'admin-1515286096-15152921343583695', 1, 1, 'SR', NULL, NULL, NULL),
(59787, '2018-01-07 10:31:22', NULL, NULL, 15925, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:31:22', 'admin-1515286096-15152922822013854', 1, 1, 'SR', 1, NULL, NULL),
(59788, '2018-01-07 10:28:54', NULL, NULL, 15924, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:28:54', 'admin-1515286096-15152921343583695', 1, 1, 'SR', NULL, NULL, NULL),
(59789, '2018-01-07 10:21:15', NULL, NULL, 15921, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:21:15', 'admin-1515286096-15152916750367145', 1, 1, 'SR', NULL, NULL, NULL),
(59790, '2018-01-07 10:23:24', NULL, NULL, 15922, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:23:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59791, '2018-01-07 10:28:37', NULL, NULL, 15924, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:28:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59792, '2018-01-07 00:00:00', NULL, NULL, 15923, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.30, NULL, NULL, 1.30, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:22:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59793, '2018-01-07 10:23:01', NULL, NULL, 15922, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:23:01', 'admin-1515286096-15152917810602783', 1, 0, '', NULL, NULL, NULL),
(59794, '2018-01-07 09:29:37', NULL, NULL, 15918, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:29:37', 'admin-1515286096-1515288577511957', 1, 1, 'SR', NULL, NULL, NULL),
(59795, '2018-01-07 09:29:37', NULL, NULL, 15918, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:29:37', 'admin-1515286096-1515288577511957', 1, 1, 'SR', NULL, NULL, NULL),
(59796, '2018-01-07 09:30:36', NULL, NULL, 15918, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:30:36', 'admin-1515286096-15152886365957511', 1, 0, '', NULL, NULL, NULL),
(59797, '2018-01-07 09:31:06', NULL, NULL, 15917, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:31:06', 'admin-1515286096-15152886663995272', 1, 0, '', NULL, NULL, NULL),
(59798, '2018-01-07 09:31:06', NULL, NULL, 15917, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:31:06', 'admin-1515286096-15152886663995272', 1, 1, 'SR', NULL, NULL, NULL),
(59799, '2018-01-07 09:33:18', NULL, NULL, 15919, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:33:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59800, '2018-01-07 09:34:15', NULL, NULL, 15919, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:34:15', 'admin-1515286096-15152888555464430', 1, 0, '', NULL, NULL, NULL),
(59801, '2018-01-07 09:29:03', NULL, NULL, 15917, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:29:03', 'admin-1515286096-15152885432842523', 1, 1, 'SR', NULL, NULL, NULL),
(59802, '2018-01-07 09:17:33', NULL, NULL, 15916, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:17:33', 'admin-1515286096-15152878529523593', 1, 1, 'SR', NULL, NULL, NULL),
(59803, '2018-01-07 09:14:12', NULL, NULL, 15915, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:14:12', 'admin-1515286096-15152876523237214', 1, 1, 'SR', NULL, NULL, NULL),
(59804, '2018-01-07 10:18:31', NULL, NULL, 15920, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:18:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59805, '2018-01-07 10:18:42', NULL, NULL, 15920, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:18:42', 'admin-1515286096-15152915220808724', 1, 0, '', NULL, NULL, NULL),
(59806, '2018-01-07 10:18:42', NULL, NULL, 15920, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:18:42', 'admin-1515286096-15152915220808724', 1, 0, '', NULL, NULL, NULL),
(59807, '2018-01-07 10:18:42', NULL, NULL, 15920, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:18:42', 'admin-1515286096-15152915220808724', 1, 1, 'SR', NULL, NULL, NULL),
(59808, '2018-01-07 10:18:42', NULL, NULL, 15920, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:18:42', 'admin-1515286096-15152915220808724', 1, 1, 'SR', NULL, NULL, NULL),
(59809, '2018-01-07 10:21:05', NULL, NULL, 15921, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:21:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59810, '2018-01-07 10:21:15', NULL, NULL, 15921, 0, 302, '238', 'Ice on the cake', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:21:15', 'admin-1515286096-15152916750367145', 1, 0, '', NULL, NULL, NULL),
(59811, '2018-01-07 10:21:15', NULL, NULL, 15921, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 10:21:15', 'admin-1515286096-15152916750367145', 1, 1, 'SR', NULL, NULL, NULL),
(59812, '2018-01-07 09:34:15', NULL, NULL, 15919, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:34:15', 'admin-1515286096-15152888555464430', 1, 0, '', NULL, NULL, NULL),
(59813, '2018-01-07 09:34:15', NULL, NULL, 15919, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:34:15', 'admin-1515286096-15152888555464430', 1, 0, '', NULL, NULL, NULL),
(59814, '2018-01-07 09:34:15', NULL, NULL, 15919, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:34:15', 'admin-1515286096-15152888555464430', 1, 0, '', NULL, NULL, NULL),
(59815, '2018-01-07 09:29:37', NULL, NULL, 15918, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:29:37', 'admin-1515286096-1515288577511957', 1, 0, '', NULL, NULL, NULL),
(59816, '2018-01-07 09:29:28', NULL, NULL, 15918, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:29:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59817, '2018-01-07 09:29:37', NULL, NULL, 15918, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:29:37', 'admin-1515286096-1515288577511957', 1, 0, '', NULL, NULL, NULL),
(59818, '2018-01-07 09:29:03', NULL, NULL, 15917, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:29:03', 'admin-1515286096-15152885432842523', 1, 1, 'SR', NULL, NULL, NULL),
(59819, '2018-01-07 09:29:03', NULL, NULL, 15917, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:29:03', 'admin-1515286096-15152885432842523', 1, 0, '', NULL, NULL, NULL),
(59820, '2018-01-07 09:29:03', NULL, NULL, 15917, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:29:03', 'admin-1515286096-15152885432842523', 1, 0, '', NULL, NULL, NULL),
(59821, '2018-01-07 09:14:12', NULL, NULL, 15915, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:14:12', 'admin-1515286096-15152876523237214', 1, 1, 'SR', NULL, NULL, NULL),
(59822, '2018-01-07 09:17:06', NULL, NULL, 15916, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:17:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59823, '2018-01-07 09:17:33', NULL, NULL, 15916, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:17:33', 'admin-1515286096-15152878529523593', 1, 0, '', NULL, NULL, NULL),
(59824, '2018-01-07 09:17:33', NULL, NULL, 15916, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:17:33', 'admin-1515286096-15152878529523593', 1, 0, '', NULL, NULL, NULL),
(59825, '2018-01-07 09:17:33', NULL, NULL, 15916, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:17:33', 'admin-1515286096-15152878529523593', 1, 1, 'SR', NULL, NULL, NULL),
(59826, '2018-01-07 09:10:15', NULL, NULL, 15915, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:10:15', 'admin-1515286096-1515287415092834', 1, 0, '', NULL, NULL, NULL),
(59827, '2018-01-07 09:14:12', NULL, NULL, 15915, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:14:12', 'admin-1515286096-15152876523237214', 1, 0, '', NULL, NULL, NULL),
(59828, '2018-01-07 09:10:10', NULL, NULL, 15915, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1515286096', 'admin', '2018-01-07 09:10:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59829, '2018-01-08 11:37:01', NULL, NULL, 15961, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:37:01', 'admin-1515371683-15153826213069531', 1, 0, '', NULL, NULL, NULL),
(59830, '2018-01-08 11:37:01', NULL, NULL, 15961, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:37:01', 'admin-1515371683-15153826213069531', 1, 0, '', NULL, NULL, NULL),
(59831, '2018-01-08 14:09:01', NULL, NULL, 15977, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 14:09:01', 'admin-1515371683-1515391741299857', 1, 1, 'SR', NULL, NULL, NULL),
(59832, '2018-01-08 15:28:03', NULL, NULL, 15977, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 15:28:03', 'admin-1515371683-15153964829116168', 1, 1, 'SR', NULL, NULL, NULL),
(59833, '2018-01-08 14:10:10', NULL, NULL, 15978, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1515371683', 'admin', '2018-01-08 14:10:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59834, '2018-01-08 14:10:14', NULL, NULL, 15978, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 14:10:14', 'admin-1515371683-1515391813993534', 1, 1, 'SR', NULL, NULL, NULL),
(59835, '2018-01-08 14:12:30', NULL, NULL, 15979, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 14:12:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59836, '2018-01-08 14:12:40', NULL, NULL, 15979, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 14:12:40', 'admin-1515371683-15153919607123721', 1, 1, 'SR', NULL, NULL, NULL),
(59837, '2018-01-08 14:12:40', NULL, NULL, 15979, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 14:12:40', 'admin-1515371683-15153919607123721', 1, 1, 'SR', NULL, NULL, NULL),
(59838, '2018-01-08 14:12:40', NULL, NULL, 15979, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 14:12:40', 'admin-1515371683-15153919607123721', 1, 0, '', NULL, NULL, NULL),
(59839, '2018-01-08 14:12:40', NULL, NULL, 15979, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 14:12:40', 'admin-1515371683-15153919607123721', 1, 0, '', NULL, NULL, NULL),
(59840, '2018-01-08 12:15:32', NULL, NULL, 15966, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 12:15:32', 'admin-1515371683-15153849326129124', 1, 0, '', NULL, NULL, NULL),
(59841, '2018-01-08 12:15:32', NULL, NULL, 15966, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 12:15:32', 'admin-1515371683-15153849326129124', 1, 1, 'SR', NULL, NULL, NULL),
(59842, '2018-01-08 12:18:47', NULL, NULL, 15967, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1515371683', 'admin', '2018-01-08 12:18:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59843, '2018-01-08 12:20:28', NULL, NULL, 15967, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 12:20:28', 'admin-1515371683-15153852286717362', 1, 1, 'SR', NULL, NULL, NULL),
(59844, '2018-01-08 12:20:28', NULL, NULL, 15967, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 12:20:28', 'admin-1515371683-15153852286717362', 1, 1, 'SR', NULL, NULL, NULL),
(59845, '2018-01-08 12:36:46', NULL, NULL, 15968, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 12:36:46', 'admin-1515371683-15153862067339594', 1, 0, '', NULL, NULL, NULL),
(59846, '2018-01-08 12:36:46', NULL, NULL, 15968, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 12:36:46', 'admin-1515371683-15153862067339594', 1, 1, 'SR', NULL, NULL, NULL),
(59847, '2018-01-08 13:35:28', NULL, NULL, 15974, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:35:28', 'admin-1515371683-15153897285426572', 1, 0, '', NULL, NULL, NULL),
(59848, '2018-01-08 12:59:48', NULL, NULL, 15970, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1515371683', 'admin', '2018-01-08 12:59:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59849, '2018-01-08 13:00:03', NULL, NULL, 15970, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:00:03', 'admin-1515371683-15153876033387426', 1, 0, '', NULL, NULL, NULL),
(59850, '2018-01-08 13:00:03', NULL, NULL, 15970, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:00:03', 'admin-1515371683-15153876033387426', 1, 0, '', NULL, NULL, NULL),
(59851, '2018-01-08 10:24:25', NULL, NULL, 15957, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1515371683', 'admin', '2018-01-08 10:24:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59852, '2018-01-08 13:25:46', NULL, NULL, 15972, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:25:46', 'admin-1515371683-15153891463069718', 1, 0, '', NULL, NULL, NULL),
(59853, '2018-01-08 11:37:01', NULL, NULL, 15961, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:37:01', 'admin-1515371683-15153826213069531', 1, 1, 'SR', NULL, NULL, NULL),
(59854, '2018-01-08 11:37:01', NULL, NULL, 15961, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:37:01', 'admin-1515371683-15153826213069531', 1, 1, 'SR', NULL, NULL, NULL),
(59855, '2018-01-08 11:39:41', NULL, NULL, 15962, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:39:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59856, '2018-01-08 11:40:54', NULL, NULL, 15962, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:40:54', 'admin-1515371683-15153828546666335', 1, 0, '', NULL, NULL, NULL),
(59857, '2018-01-08 12:43:00', NULL, NULL, 15969, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 12:43:00', 'admin-1515371683-15153865805451734', 1, 1, 'SR', NULL, NULL, NULL),
(59858, '2018-01-08 14:09:01', NULL, NULL, 15977, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 14:09:01', 'admin-1515371683-1515391741299857', 1, 0, '', NULL, NULL, NULL),
(59859, '2018-01-08 14:09:01', NULL, NULL, 15977, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 14:09:01', 'admin-1515371683-1515391741299857', 1, 1, 'SR', NULL, NULL, NULL),
(59860, '2018-01-08 14:14:38', NULL, NULL, 15980, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1515371683', 'admin', '2018-01-08 14:14:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59861, '2018-01-08 13:00:03', NULL, NULL, 15970, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:00:03', 'admin-1515371683-15153876033387426', 1, 0, '', NULL, NULL, NULL),
(59862, '2018-01-08 13:00:03', NULL, NULL, 15970, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:00:03', 'admin-1515371683-15153876033387426', 1, 0, '', NULL, NULL, NULL),
(59863, '2018-01-08 13:46:00', NULL, NULL, 15976, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:46:00', 'admin-1515371683-15153903603094946', 1, 0, '', 1, NULL, NULL),
(59864, '2018-01-08 14:08:50', NULL, NULL, 15977, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1515371683', 'admin', '2018-01-08 14:08:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59865, '2018-01-08 12:36:46', NULL, NULL, 15968, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 12:36:46', 'admin-1515371683-15153862067339594', 1, 0, '', NULL, NULL, NULL),
(59866, '2018-01-08 13:35:28', NULL, NULL, 15974, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:35:28', 'admin-1515371683-15153897285426572', 1, 1, 'SR', NULL, NULL, NULL),
(59867, '2018-01-08 11:40:54', NULL, NULL, 15962, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:40:54', 'admin-1515371683-15153828546666335', 1, 1, 'SR', NULL, NULL, NULL),
(59868, '2018-01-08 11:40:54', NULL, NULL, 15962, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:40:54', 'admin-1515371683-15153828546666335', 1, 0, '', NULL, NULL, NULL),
(59869, '2018-01-08 14:14:55', NULL, NULL, 15980, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 14:14:55', 'admin-1515371683-15153920957282026', 1, 0, '', NULL, NULL, NULL),
(59870, '2018-01-08 14:14:55', NULL, NULL, 15980, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 14:14:55', 'admin-1515371683-15153920957282026', 1, 0, '', NULL, NULL, NULL),
(59871, '2018-01-08 14:14:55', NULL, NULL, 15980, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 14:14:55', 'admin-1515371683-15153920957282026', 1, 1, 'SR', NULL, NULL, NULL),
(59872, '2018-01-08 14:14:55', NULL, NULL, 15980, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 14:14:55', 'admin-1515371683-15153920957282026', 1, 0, '', NULL, NULL, NULL),
(59873, '2018-01-08 15:18:03', NULL, NULL, 15977, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 15:18:03', 'admin-1515371683-15153958834386186', 1, 1, 'SR', NULL, NULL, NULL),
(59874, '2018-01-08 16:16:18', NULL, NULL, 15978, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 16:16:18', 'admin-1515371683-15153993783654589', 1, 1, 'SR', NULL, NULL, NULL),
(59875, '2018-01-08 12:15:06', NULL, NULL, 15966, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1515371683', 'admin', '2018-01-08 12:15:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59876, '2018-01-08 12:15:32', NULL, NULL, 15966, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 12:15:32', 'admin-1515371683-15153849326129124', 1, 0, '', NULL, NULL, NULL),
(59877, '2018-01-08 13:42:15', NULL, NULL, 15975, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:42:15', 'admin-1515371683-15153901353794311', 1, 1, 'SR', NULL, NULL, NULL),
(59878, '2018-01-08 13:42:15', NULL, NULL, 15975, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:42:15', 'admin-1515371683-15153901353794311', 1, 1, 'SR', NULL, NULL, NULL),
(59879, '2018-01-08 13:33:54', NULL, NULL, 15973, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:33:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59880, '2018-01-08 13:34:02', NULL, NULL, 15973, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:34:02', 'admin-1515371683-1515389641976333', 1, 1, 'SR', NULL, NULL, NULL),
(59881, '2018-01-08 13:34:02', NULL, NULL, 15973, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:34:02', 'admin-1515371683-1515389641976333', 1, 1, 'SR', NULL, NULL, NULL),
(59882, '2018-01-08 13:35:10', NULL, NULL, 15974, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:35:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59883, '2018-01-08 13:25:46', NULL, NULL, 15972, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:25:46', 'admin-1515371683-15153891463069718', 1, 1, 'SR', NULL, NULL, NULL),
(59884, '2018-01-08 13:25:46', NULL, NULL, 15972, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:25:46', 'admin-1515371683-15153891463069718', 1, 1, 'SR', NULL, NULL, NULL),
(59885, '2018-01-08 13:05:42', NULL, NULL, 15959, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:05:42', 'admin-1515371683-15153879424474178', 1, 1, 'SR', NULL, NULL, NULL),
(59886, '2018-01-08 13:24:31', NULL, NULL, 15972, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:24:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59887, '2018-01-08 13:17:15', NULL, NULL, 15971, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:17:15', 'admin-1515371683-15153886350028457', 1, 0, '', NULL, NULL, NULL),
(59888, '2018-01-08 13:17:15', NULL, NULL, 15971, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:17:15', 'admin-1515371683-15153886350028457', 1, 1, 'SR', NULL, NULL, NULL),
(59889, '2018-01-08 13:35:57', NULL, NULL, 15959, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:35:57', 'admin-1515371683-15153897568767131', 1, 1, 'SR', NULL, NULL, NULL),
(59890, '2018-01-08 13:17:02', NULL, NULL, 15971, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:17:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59891, '2018-01-08 12:42:48', NULL, NULL, 15969, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1515371683', 'admin', '2018-01-08 12:42:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59892, '2018-01-08 12:36:46', NULL, NULL, 15968, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 12:36:46', 'admin-1515371683-15153862067339594', 1, 1, 'SR', NULL, NULL, NULL),
(59893, '2018-01-08 13:38:38', NULL, NULL, 15970, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:38:38', 'admin-1515371683-15153899184652973', 1, 1, 'SR', NULL, NULL, NULL),
(59894, '2018-01-08 13:41:56', NULL, NULL, 15975, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1515371683', 'admin', '2018-01-08 13:41:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59895, '2018-01-08 12:42:55', NULL, NULL, 15969, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 12:42:55', 'admin-1515371683-15153865757515229', 1, 0, '', NULL, NULL, NULL),
(59896, '2018-01-08 11:26:52', NULL, NULL, 15959, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:26:52', 'admin-1515371683-15153820119972521', 1, 1, 'SR', NULL, NULL, NULL),
(59897, '2018-01-08 11:26:52', NULL, NULL, 15959, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:26:52', 'admin-1515371683-15153820119972521', 1, 1, 'SR', NULL, NULL, NULL),
(59898, '2018-01-08 11:26:52', NULL, NULL, 15959, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:26:52', 'admin-1515371683-15153820119972521', 1, 0, '', NULL, NULL, NULL),
(59899, '2018-01-08 11:32:58', NULL, NULL, 15960, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:32:58', 'admin-1515371683-15153823783281883', 1, 1, 'SR', 1, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(59900, '2018-01-08 11:36:17', NULL, NULL, 15961, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:36:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59901, '2018-01-08 12:31:54', NULL, NULL, 15959, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 2, 18.00, 36.0000, 0.0000, 36.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 12:31:54', 'admin-1515371683-15153859144258913', 1, 1, 'SR', NULL, NULL, NULL),
(59902, '2018-01-08 12:36:32', NULL, NULL, 15968, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1515371683', 'admin', '2018-01-08 12:36:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59903, '2018-01-08 12:19:29', NULL, NULL, 15967, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 12:19:29', 'admin-1515371683-1515385168819482', 1, 0, '', NULL, NULL, NULL),
(59904, '2018-01-08 12:19:29', NULL, NULL, 15967, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 12:19:29', 'admin-1515371683-1515385168819482', 1, 0, '', NULL, NULL, NULL),
(59905, '2018-01-08 00:00:00', NULL, NULL, 15965, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', NULL, 1, 3.00, NULL, NULL, 3.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:49:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59906, '2018-01-08 12:19:28', NULL, NULL, 15967, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 12:19:29', 'admin-1515371683-1515385168819482', 1, 1, 'SR', NULL, NULL, NULL),
(59907, '2018-01-08 11:55:56', NULL, NULL, 15959, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:55:56', 'admin-1515371683-15153837566505940', 1, 1, 'SR', NULL, NULL, NULL),
(59908, '2018-01-08 00:00:00', NULL, NULL, 15965, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:50:13', 'admin-1515371683-1515383413817124', 1, 0, '', NULL, NULL, NULL),
(59909, '2018-01-08 11:55:56', NULL, NULL, 15959, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:55:56', 'admin-1515371683-15153837566505940', 1, 1, 'SR', NULL, NULL, NULL),
(59910, '2018-01-08 00:00:00', NULL, NULL, 15965, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:50:13', 'admin-1515371683-1515383413817124', 1, 0, '', NULL, NULL, NULL),
(59911, '2018-01-08 11:50:33', NULL, NULL, 15961, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:50:33', 'admin-1515371683-1515383433493585', 1, 0, '', NULL, NULL, NULL),
(59912, '2018-01-08 11:54:08', NULL, NULL, 15956, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:54:08', 'admin-1515371683-15153836485298783', 1, 1, 'SR', NULL, NULL, NULL),
(59913, '2018-01-08 11:04:17', NULL, NULL, 15958, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:04:17', 'admin-1515371683-15153806577575368', 1, 0, '', NULL, NULL, NULL),
(59914, '2018-01-08 11:26:43', NULL, NULL, 15959, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.80, 0.0000, 0.0000, 9.80, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:26:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59915, '2018-01-08 11:40:54', NULL, NULL, 15962, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:40:54', 'admin-1515371683-15153828546666335', 1, 1, 'SR', NULL, NULL, NULL),
(59916, '2018-01-08 10:24:39', NULL, NULL, 15957, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 10:24:39', 'admin-1515371683-1515378279420771', 1, 0, '', NULL, NULL, NULL),
(59917, '2018-01-08 10:24:39', NULL, NULL, 15957, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 10:24:39', 'admin-1515371683-1515378279420771', 1, 1, 'SR', NULL, NULL, NULL),
(59918, '2018-01-08 10:24:39', NULL, NULL, 15957, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 10:24:39', 'admin-1515371683-1515378279420771', 1, 1, 'SR', NULL, NULL, NULL),
(59919, '2018-01-08 10:42:41', NULL, NULL, 15956, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 10:42:41', 'admin-1515371683-15153793612818025', 1, 0, '', NULL, NULL, NULL),
(59920, '2018-01-08 10:42:41', NULL, NULL, 15956, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 10:42:41', 'admin-1515371683-15153793612818025', 1, 1, 'SR', NULL, NULL, NULL),
(59921, '2018-01-08 11:04:07', NULL, NULL, 15958, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:04:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59922, '2018-01-08 11:04:17', NULL, NULL, 15958, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 11:04:17', 'admin-1515371683-15153806577575368', 1, 1, 'SR', NULL, NULL, NULL),
(59923, '2018-01-08 10:24:39', NULL, NULL, 15957, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 10:24:39', 'admin-1515371683-1515378279420771', 1, 0, '', NULL, NULL, NULL),
(59924, '2018-01-08 10:00:37', NULL, NULL, 15952, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 10:00:37', 'admin-1515371683-1515376836890817', 1, 1, 'SR', NULL, NULL, NULL),
(59925, '2018-01-08 09:05:03', NULL, NULL, 15952, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:05:03', 'admin-1515371683-1515373503715947', 1, 0, '', NULL, NULL, NULL),
(59926, '2018-01-08 09:05:03', NULL, NULL, 15952, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:05:03', 'admin-1515371683-1515373503715947', 1, 0, '', NULL, NULL, NULL),
(59927, '2018-01-08 09:05:03', NULL, NULL, 15952, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:05:03', 'admin-1515371683-1515373503715947', 1, 1, 'SR', NULL, NULL, NULL),
(59928, '2018-01-08 09:05:03', NULL, NULL, 15952, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:05:03', 'admin-1515371683-1515373503715947', 1, 0, '', NULL, NULL, NULL),
(59929, '2018-01-08 09:29:41', NULL, NULL, 15953, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:29:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59930, '2018-01-08 09:29:53', NULL, NULL, 15953, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:29:53', 'admin-1515371683-15153749933618673', 1, 0, '', NULL, NULL, NULL),
(59931, '2018-01-08 09:29:53', NULL, NULL, 15953, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:29:53', 'admin-1515371683-15153749933618673', 1, 0, '', NULL, NULL, NULL),
(59932, '2018-01-08 09:29:53', NULL, NULL, 15953, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:29:53', 'admin-1515371683-15153749933618673', 1, 1, 'SR', NULL, NULL, NULL),
(59933, '2018-01-08 09:32:25', NULL, NULL, 15954, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:32:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59934, '2018-01-08 09:33:03', NULL, NULL, 15954, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:33:03', 'admin-1515371683-15153751828602973', 1, 1, 'SR', NULL, NULL, NULL),
(59935, '2018-01-08 09:33:03', NULL, NULL, 15954, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:33:03', 'admin-1515371683-15153751828602973', 1, 1, 'SR', NULL, NULL, NULL),
(59936, '2018-01-08 09:33:03', NULL, NULL, 15954, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:33:03', 'admin-1515371683-15153751828602973', 1, 0, '', NULL, NULL, NULL),
(59937, '2018-01-08 09:33:03', NULL, NULL, 15954, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:33:03', 'admin-1515371683-15153751828602973', 1, 0, '', NULL, NULL, NULL),
(59938, '2018-01-08 09:47:25', NULL, NULL, 15955, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.60, 0.0000, 0.0000, 10.60, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:47:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59939, '2018-01-08 09:47:43', NULL, NULL, 15955, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:47:43', 'admin-1515371683-15153760630409784', 1, 0, '', NULL, NULL, NULL),
(59940, '2018-01-08 09:47:43', NULL, NULL, 15955, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:47:43', 'admin-1515371683-15153760630409784', 1, 0, '', NULL, NULL, NULL),
(59941, '2018-01-08 09:47:43', NULL, NULL, 15955, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:47:43', 'admin-1515371683-15153760630409784', 1, 0, '', NULL, NULL, NULL),
(59942, '2018-01-08 09:47:43', NULL, NULL, 15955, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:47:43', 'admin-1515371683-15153760630409784', 1, 1, 'SR', NULL, NULL, NULL),
(59943, '2018-01-08 09:47:43', NULL, NULL, 15955, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:47:43', 'admin-1515371683-15153760630409784', 1, 1, 'SR', NULL, NULL, NULL),
(59944, '2018-01-08 09:47:43', NULL, NULL, 15955, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:47:43', 'admin-1515371683-15153760630409784', 1, 0, '', NULL, NULL, NULL),
(59945, '2018-01-08 09:47:43', NULL, NULL, 15955, 0, 335, '271', 'Iced Honey Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:47:43', 'admin-1515371683-15153760630409784', 1, 0, '', NULL, NULL, NULL),
(59946, '2018-01-08 09:57:21', NULL, NULL, 15956, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.20, 0.0000, 0.0000, 10.20, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:57:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59947, '2018-01-08 09:57:46', NULL, NULL, 15956, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:57:46', 'admin-1515371683-15153766660487327', 1, 0, '', NULL, NULL, NULL),
(59948, '2018-01-08 09:57:46', NULL, NULL, 15956, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:57:46', 'admin-1515371683-15153766660487327', 1, 0, '', NULL, NULL, NULL),
(59949, '2018-01-08 09:57:46', NULL, NULL, 15956, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:57:46', 'admin-1515371683-15153766660487327', 1, 1, 'SR', NULL, NULL, NULL),
(59950, '2018-01-08 09:57:46', NULL, NULL, 15956, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:57:46', 'admin-1515371683-15153766660487327', 1, 0, '', NULL, NULL, NULL),
(59951, '2018-01-08 09:04:51', NULL, NULL, 15952, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1515371683', 'admin', '2018-01-08 09:04:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59952, '2018-01-10 13:14:30', NULL, NULL, 15992, 0, 181, '116', 'Open Food ', 'black fungus noddle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 13:14:30', 'admin-1515546225-15155612703703340', 1, 0, '', NULL, NULL, '10.0'),
(59953, '2018-01-10 16:13:13', NULL, NULL, 16002, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 16:13:13', 'admin-1515546225-1515571993436772', 1, 0, '', NULL, NULL, NULL),
(59954, '2018-01-10 14:49:04', NULL, NULL, 15999, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1515546225', 'admin', '2018-01-10 14:49:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59955, '2018-01-10 14:50:16', NULL, NULL, 15999, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 14:50:16', 'admin-1515546225-15155670159918240', 1, 0, '', NULL, NULL, NULL),
(59956, '2018-01-10 14:50:16', NULL, NULL, 15999, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 14:50:16', 'admin-1515546225-15155670159918240', 1, 0, '', NULL, NULL, NULL),
(59957, '2018-01-10 14:50:16', NULL, NULL, 15999, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 14:50:16', 'admin-1515546225-15155670159918240', 1, 1, 'SR', NULL, NULL, NULL),
(59958, '2018-01-10 14:50:16', NULL, NULL, 15999, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 14:50:16', 'admin-1515546225-15155670159918240', 1, 1, 'SR', NULL, NULL, NULL),
(59959, '2018-01-10 12:49:37', NULL, NULL, 15990, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:49:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59960, '2018-01-10 12:02:07', NULL, NULL, 15984, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:02:07', 'admin-1515546225-15155569274586154', 1, 1, 'SR', NULL, NULL, NULL),
(59961, '2018-01-10 13:30:41', NULL, NULL, 15995, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 13:30:41', 'admin-1515546225-15155622416861733', 1, 1, 'SR', NULL, NULL, NULL),
(59962, '2018-01-10 15:40:13', NULL, NULL, 15998, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 15:40:13', 'admin-1515546225-15155700135922912', 1, 1, 'SR', NULL, NULL, NULL),
(59963, '2018-01-10 16:13:13', NULL, NULL, 16002, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 16:13:13', 'admin-1515546225-1515571993436772', 1, 1, 'SR', NULL, NULL, NULL),
(59964, '2018-01-10 13:14:30', NULL, NULL, 15992, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 13:14:30', 'admin-1515546225-15155612703703340', 1, 0, '', NULL, NULL, '10.0'),
(59965, '2018-01-10 13:14:30', NULL, NULL, 15992, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 13:14:30', 'admin-1515546225-15155612703703340', 1, 1, 'SR', NULL, NULL, '10.0'),
(59966, '2018-01-10 15:28:17', NULL, NULL, 16001, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 15:28:17', 'admin-1515546225-1515569297495459', 1, 1, 'SR', NULL, NULL, NULL),
(59967, '2018-01-10 15:28:05', NULL, NULL, 16001, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1515546225', 'admin', '2018-01-10 15:28:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59968, '2018-01-10 14:58:50', NULL, NULL, 16000, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 14:58:50', 'admin-1515546225-15155675302983743', 1, 0, '', NULL, NULL, NULL),
(59969, '2018-01-10 14:58:50', NULL, NULL, 16000, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 14:58:50', 'admin-1515546225-15155675302983743', 1, 1, 'SR', NULL, NULL, NULL),
(59970, '2018-01-10 14:58:50', NULL, NULL, 16000, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 14:58:50', 'admin-1515546225-15155675302983743', 1, 1, 'SR', NULL, NULL, NULL),
(59971, '2018-01-10 14:35:45', NULL, NULL, 15998, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1515546225', 'admin', '2018-01-10 14:35:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59972, '2018-01-10 14:35:49', NULL, NULL, 15998, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 14:35:49', 'admin-1515546225-15155661494683444', 1, 1, 'SR', NULL, NULL, NULL),
(59973, '2018-01-10 14:58:50', NULL, NULL, 16000, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 14:58:50', 'admin-1515546225-15155675302983743', 1, 1, 'SR', NULL, NULL, NULL),
(59974, '2018-01-10 14:58:09', NULL, NULL, 16000, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1515546225', 'admin', '2018-01-10 14:58:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59975, '2018-01-10 15:28:17', NULL, NULL, 16001, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 15:28:17', 'admin-1515546225-1515569297495459', 1, 1, 'SR', NULL, NULL, NULL),
(59976, '2018-01-10 14:29:27', NULL, NULL, 15997, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1515546225', 'admin', '2018-01-10 14:29:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59977, '2018-01-10 14:29:37', NULL, NULL, 15997, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 14:29:37', 'admin-1515546225-15155657771181277', 1, 1, 'SR', NULL, NULL, NULL),
(59978, '2018-01-10 14:29:37', NULL, NULL, 15997, 0, 72, '72', 'Shimeji Mushroom with Chicken ', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 14:29:37', 'admin-1515546225-15155657771181277', 1, 1, 'SR', NULL, NULL, NULL),
(59979, '2018-01-10 13:19:25', NULL, NULL, 15993, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 13:19:25', 'admin-1515546225-1515561565788969', 1, 0, '', NULL, NULL, NULL),
(59980, '2018-01-10 16:12:39', NULL, NULL, 16002, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1515546225', 'admin', '2018-01-10 16:12:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59981, '2018-01-10 13:19:25', NULL, NULL, 15993, 0, 181, '116', 'Open Food ', 'black fungus rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 13:19:25', 'admin-1515546225-1515561565788969', 1, 0, '', NULL, NULL, NULL),
(59982, '2018-01-10 13:41:24', NULL, NULL, 15996, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 13:41:24', 'admin-1515546225-15155628842573615', 1, 0, '', NULL, NULL, NULL),
(59983, '2018-01-10 13:41:24', NULL, NULL, 15996, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 13:41:24', 'admin-1515546225-15155628842573615', 1, 0, '', NULL, NULL, NULL),
(59984, '2018-01-10 13:41:24', NULL, NULL, 15996, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 13:41:24', 'admin-1515546225-15155628842573615', 1, 0, '', NULL, NULL, NULL),
(59985, '2018-01-10 13:41:24', NULL, NULL, 15996, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 13:41:24', 'admin-1515546225-15155628842573615', 1, 1, 'SR', NULL, NULL, NULL),
(59986, '2018-01-10 13:40:28', NULL, NULL, 15996, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1515546225', 'admin', '2018-01-10 13:40:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59987, '2018-01-10 13:30:41', NULL, NULL, 15995, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 13:30:41', 'admin-1515546225-15155622416861733', 1, 1, 'SR', NULL, NULL, NULL),
(59988, '2018-01-10 12:15:45', NULL, NULL, 15984, 0, 181, '116', 'Open Food ', 'black fungus noddle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:15:45', 'admin-1515546225-15155577451222036', 1, 0, '', NULL, NULL, NULL),
(59989, '2018-01-10 12:18:22', NULL, NULL, 15988, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 11.20, 0.0000, 0.0000, 11.20, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:18:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59990, '2018-01-10 13:28:27', NULL, NULL, 15994, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1515546225', 'admin', '2018-01-10 13:28:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59991, '2018-01-10 13:28:31', NULL, NULL, 15994, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 13:28:31', 'admin-1515546225-1515562111650359', 1, 1, 'SR', NULL, NULL, NULL),
(59992, '2018-01-10 13:30:15', NULL, NULL, 15995, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1515546225', 'admin', '2018-01-10 13:30:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59993, '2018-01-10 13:09:05', NULL, NULL, 15985, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 13:09:05', 'admin-1515546225-15155609454309744', 1, 0, '', NULL, NULL, NULL),
(59994, '2018-01-10 13:14:02', NULL, NULL, 15992, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1515546225', 'admin', '2018-01-10 13:14:02', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(59995, '2018-01-10 13:19:25', NULL, NULL, 15993, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 13:19:25', 'admin-1515546225-1515561565788969', 1, 0, '', NULL, NULL, NULL),
(59996, '2018-01-10 13:26:19', NULL, NULL, 15989, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 13:26:19', 'admin-1515546225-15155619789915558', 1, 0, '', NULL, NULL, NULL),
(59997, '2018-01-10 13:19:25', NULL, NULL, 15993, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 13:19:25', 'admin-1515546225-1515561565788969', 1, 1, 'SR', NULL, NULL, NULL),
(59998, '2018-01-10 13:18:09', NULL, NULL, 15993, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1515546225', 'admin', '2018-01-10 13:18:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(59999, '2018-01-10 12:19:23', NULL, NULL, 15988, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:19:23', 'admin-1515546225-15155579637632857', 1, 0, '', NULL, NULL, NULL),
(60000, '2018-01-10 12:19:23', NULL, NULL, 15988, 0, 291, '225', 'Smoked Duck Red Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:19:23', 'admin-1515546225-15155579637632857', 1, 0, '', NULL, NULL, NULL),
(60001, '2018-01-10 12:19:23', NULL, NULL, 15988, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:19:23', 'admin-1515546225-15155579637632857', 1, 0, '', NULL, NULL, NULL),
(60002, '2018-01-10 12:19:23', NULL, NULL, 15988, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:19:23', 'admin-1515546225-15155579637632857', 1, 0, '', NULL, NULL, NULL),
(60003, '2018-01-10 00:00:00', NULL, NULL, 15991, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:04:20', 'admin-1515546225-15155570606219894', 1, 1, 'SR', NULL, NULL, NULL),
(60004, '2018-01-10 13:14:30', NULL, NULL, 15992, 0, 181, '116', 'Open Food ', 'black fungus noddle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 13:14:30', 'admin-1515546225-15155612703703340', 1, 0, '', NULL, NULL, '10.0'),
(60005, '2018-01-10 12:50:12', NULL, NULL, 15990, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:50:12', 'admin-1515546225-15155598125207651', 1, 1, 'SR', NULL, NULL, NULL),
(60006, '2018-01-10 12:50:12', NULL, NULL, 15990, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:50:12', 'admin-1515546225-15155598125207651', 1, 1, 'SR', NULL, NULL, NULL),
(60007, '2018-01-10 12:50:12', NULL, NULL, 15990, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:50:12', 'admin-1515546225-15155598125207651', 1, 1, 'SR', NULL, NULL, NULL),
(60008, '2018-01-10 12:19:23', NULL, NULL, 15988, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:19:23', 'admin-1515546225-15155579637632857', 1, 0, '', NULL, NULL, NULL),
(60009, '2018-01-10 12:34:48', NULL, NULL, 15989, 0, 181, '116', 'Open Food ', 'black fungus noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:34:48', 'admin-1515546225-15155588880134779', 1, 0, '', NULL, NULL, NULL),
(60010, '2018-01-10 12:34:48', NULL, NULL, 15989, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:34:48', 'admin-1515546225-15155588880134779', 1, 0, '', NULL, NULL, NULL),
(60011, '2018-01-10 12:34:48', NULL, NULL, 15989, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:34:48', 'admin-1515546225-15155588880134779', 1, 1, 'SR', NULL, NULL, NULL),
(60012, '2018-01-10 12:32:44', NULL, NULL, 15989, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:32:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60013, '2018-01-10 12:05:34', NULL, NULL, 15987, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:05:34', 'admin-1515546225-15155571344899117', 1, 1, 'SR', NULL, NULL, NULL),
(60014, '2018-01-10 12:06:18', NULL, NULL, 15985, 0, 181, '116', 'Open Food ', 'black fungus rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:06:18', 'admin-1515546225-1515557178575674', 1, 0, '', NULL, NULL, NULL),
(60015, '2018-01-10 12:09:09', NULL, NULL, 15984, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:09:09', 'admin-1515546225-15155573493498552', 1, 1, 'SR', NULL, NULL, NULL),
(60016, '2018-01-10 12:19:23', NULL, NULL, 15988, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:19:23', 'admin-1515546225-15155579637632857', 1, 0, '', NULL, NULL, NULL),
(60017, '2018-01-10 12:05:07', NULL, NULL, 15987, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:05:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60018, '2018-01-10 12:05:34', NULL, NULL, 15987, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:05:34', 'admin-1515546225-15155571344899117', 1, 0, '', NULL, NULL, NULL),
(60019, '2018-01-10 12:05:34', NULL, NULL, 15987, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:05:34', 'admin-1515546225-15155571344899117', 1, 0, '', NULL, NULL, NULL),
(60020, '2018-01-10 12:05:34', NULL, NULL, 15987, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:05:34', 'admin-1515546225-15155571344899117', 1, 1, 'SR', NULL, NULL, NULL),
(60021, '2018-01-10 11:54:36', NULL, NULL, 15983, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1515546225', 'admin', '2018-01-10 11:54:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60022, '2018-01-10 11:55:12', NULL, NULL, 15983, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 11:55:12', 'admin-1515546225-1515556512618585', 1, 0, '', NULL, NULL, NULL),
(60023, '2018-01-10 11:55:12', NULL, NULL, 15983, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 11:55:12', 'admin-1515546225-1515556512618585', 1, 0, '', NULL, NULL, NULL),
(60024, '2018-01-10 00:00:00', NULL, NULL, 15991, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:04:20', 'admin-1515546225-15155570606219894', 1, 1, 'SR', NULL, NULL, NULL),
(60025, '2018-01-10 00:00:00', NULL, NULL, 15991, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:04:20', 'admin-1515546225-15155570606219894', 1, 0, '', NULL, NULL, NULL),
(60026, '2018-01-10 00:00:00', NULL, NULL, 15991, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:04:20', 'admin-1515546225-15155570606219894', 1, 0, '', NULL, NULL, NULL),
(60027, '2018-01-10 00:00:00', NULL, NULL, 15991, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', NULL, 1, 5.40, NULL, NULL, 5.40, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:04:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60028, '2018-01-10 12:02:53', NULL, NULL, 15985, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:02:53', 'admin-1515546225-15155569734968939', 1, 0, '', NULL, NULL, NULL),
(60029, '2018-01-10 12:02:53', NULL, NULL, 15985, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:02:53', 'admin-1515546225-15155569734968939', 1, 0, '', NULL, NULL, NULL),
(60030, '2018-01-10 12:02:53', NULL, NULL, 15985, 0, 181, '116', 'Open Food ', 'black noddle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:02:53', 'admin-1515546225-15155569734968939', 1, 0, '', NULL, NULL, NULL),
(60031, '2018-01-10 12:02:18', NULL, NULL, 15985, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:02:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60032, '2018-01-10 12:02:07', NULL, NULL, 15984, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:02:07', 'admin-1515546225-15155569274586154', 1, 1, 'SR', NULL, NULL, NULL),
(60033, '2018-01-10 12:02:07', NULL, NULL, 15984, 0, 181, '116', 'Open Food ', 'black fungus noddle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:02:07', 'admin-1515546225-15155569274586154', 1, 0, '', NULL, NULL, NULL),
(60034, '2018-01-10 12:01:37', NULL, NULL, 15984, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1515546225', 'admin', '2018-01-10 12:01:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60035, '2018-01-10 11:55:12', NULL, NULL, 15983, 0, 181, '116', 'Open Food ', 'black fungus noddle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 11:55:12', 'admin-1515546225-1515556512618585', 1, 0, '', NULL, NULL, NULL),
(60036, '2018-01-10 11:55:12', NULL, NULL, 15983, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 11:55:12', 'admin-1515546225-1515556512618585', 1, 0, '', NULL, NULL, NULL),
(60037, '2018-01-10 11:29:54', NULL, NULL, 15982, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 11:29:54', 'admin-1515546225-15155549942882246', 1, 1, 'SR', NULL, NULL, NULL),
(60038, '2018-01-10 11:29:54', NULL, NULL, 15982, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 11:29:54', 'admin-1515546225-15155549942882246', 1, 1, 'SR', NULL, NULL, NULL),
(60039, '2018-01-10 11:29:54', NULL, NULL, 15982, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 11:29:54', 'admin-1515546225-15155549942882246', 1, 1, 'SR', NULL, NULL, NULL),
(60040, '2018-01-10 11:29:41', NULL, NULL, 15982, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1515546225', 'admin', '2018-01-10 11:29:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60041, '2018-01-10 11:24:21', NULL, NULL, 15981, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 11:24:21', 'admin-1515546225-1515554661412588', 1, 1, 'SR', NULL, NULL, NULL),
(60042, '2018-01-10 11:24:21', NULL, NULL, 15981, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 11:24:21', 'admin-1515546225-1515554661412588', 1, 1, 'SR', NULL, NULL, NULL),
(60043, '2018-01-10 11:24:21', NULL, NULL, 15981, 0, 181, '116', 'Open Food ', 'black fungus rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 11:24:21', 'admin-1515546225-1515554661412588', 1, 0, '', NULL, NULL, NULL),
(60044, '2018-01-10 11:24:21', NULL, NULL, 15981, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515546225', 'admin', '2018-01-10 11:24:21', 'admin-1515546225-1515554661412588', 1, 0, '', NULL, NULL, NULL),
(60045, '2018-01-10 11:23:36', NULL, NULL, 15981, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1515546225', 'admin', '2018-01-10 11:23:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60046, '2018-01-11 13:51:45', NULL, NULL, 16021, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:51:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60047, '2018-01-11 13:51:55', NULL, NULL, 16021, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:51:55', 'admin-1515581853-15156499156054296', 1, 1, 'SR', NULL, NULL, NULL),
(60048, '2018-01-11 12:24:22', NULL, NULL, 16013, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1515581853', 'admin', '2018-01-11 12:24:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60049, '2018-01-11 11:53:38', NULL, NULL, 16010, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 11:53:38', 'admin-1515581853-15156428178756197', 1, 1, 'SR', 1, NULL, NULL),
(60050, '2018-01-11 14:58:46', NULL, NULL, 16021, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 14:58:46', 'admin-1515581853-15156539265858994', 1, 1, 'SR', NULL, NULL, NULL),
(60051, '2018-01-11 13:52:25', NULL, NULL, 16022, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:52:25', 'admin-1515581853-15156499450219089', 1, 0, '', NULL, NULL, NULL),
(60052, '2018-01-11 13:44:55', NULL, NULL, 16018, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:44:55', 'admin-1515581853-15156494951907395', 1, 1, 'SR', NULL, NULL, NULL),
(60053, '2018-01-11 14:11:11', NULL, NULL, 16017, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 14:11:11', 'admin-1515581853-15156510716364632', 1, 1, 'SR', NULL, NULL, NULL),
(60054, '2018-01-11 14:09:19', NULL, NULL, 16023, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 14:09:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60055, '2018-01-11 13:33:05', NULL, NULL, 16017, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:33:05', 'admin-1515581853-15156487849613490', 1, 0, '', NULL, NULL, NULL),
(60056, '2018-01-11 13:40:57', NULL, NULL, 16018, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:40:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60057, '2018-01-11 14:58:46', NULL, NULL, 16021, 0, 181, '116', 'Open Food ', 'macaroni', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 14:58:46', 'admin-1515581853-15156539265858994', 1, 0, '', NULL, NULL, NULL),
(60058, '2018-01-11 11:21:17', NULL, NULL, 16004, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 11:21:17', 'admin-1515581853-1515640876964475', 1, 0, '', NULL, NULL, NULL),
(60059, '2018-01-11 11:26:07', NULL, NULL, 16005, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1515581853', 'admin', '2018-01-11 11:26:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60060, '2018-01-11 14:10:31', NULL, NULL, 16023, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 14:10:31', 'admin-1515581853-15156510314303196', 1, 1, 'SR', NULL, NULL, NULL),
(60061, '2018-01-11 14:10:31', NULL, NULL, 16023, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 14:10:31', 'admin-1515581853-15156510314303196', 1, 1, 'SR', NULL, NULL, NULL),
(60062, '2018-01-11 14:10:31', NULL, NULL, 16023, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 14:10:31', 'admin-1515581853-15156510314303196', 1, 0, '', NULL, NULL, NULL),
(60063, '2018-01-11 14:10:31', NULL, NULL, 16023, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 14:10:31', 'admin-1515581853-15156510314303196', 1, 0, '', NULL, NULL, NULL),
(60064, '2018-01-11 13:30:56', NULL, NULL, 16017, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:30:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60065, '2018-01-11 13:33:05', NULL, NULL, 16017, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:33:05', 'admin-1515581853-15156487849613490', 1, 0, '', NULL, NULL, NULL),
(60066, '2018-01-11 13:33:05', NULL, NULL, 16017, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:33:05', 'admin-1515581853-15156487849613490', 1, 1, 'SR', NULL, NULL, NULL),
(60067, '2018-01-11 13:33:05', NULL, NULL, 16017, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:33:05', 'admin-1515581853-15156487849613490', 1, 0, '', NULL, NULL, NULL),
(60068, '2018-01-11 13:33:05', NULL, NULL, 16017, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:33:05', 'admin-1515581853-15156487849613490', 1, 1, 'SR', NULL, NULL, NULL),
(60069, '2018-01-11 13:52:25', NULL, NULL, 16022, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:52:25', 'admin-1515581853-15156499450219089', 1, 1, 'SR', NULL, NULL, NULL),
(60070, '2018-01-11 13:52:08', NULL, NULL, 16022, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:52:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60071, '2018-01-11 13:44:55', NULL, NULL, 16018, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:44:55', 'admin-1515581853-15156494951907395', 1, 0, '', NULL, NULL, NULL),
(60072, '2018-01-11 13:44:55', NULL, NULL, 16018, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:44:55', 'admin-1515581853-15156494951907395', 1, 0, '', NULL, NULL, NULL),
(60073, '2018-01-11 13:42:22', NULL, NULL, 16019, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:42:22', 'admin-1515581853-15156493419437779', 1, 1, 'SR', NULL, NULL, NULL),
(60074, '2018-01-11 13:44:55', NULL, NULL, 16018, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:44:55', 'admin-1515581853-15156494951907395', 1, 1, 'SR', NULL, NULL, NULL),
(60075, '2018-01-11 12:48:09', NULL, NULL, 16014, 0, 181, '116', 'Open Food ', 'rice wine RICE', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 12:48:09', 'admin-1515581853-1515646089024528', 1, 0, '', NULL, NULL, NULL),
(60076, '2018-01-11 13:00:02', NULL, NULL, 16012, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:00:02', 'admin-1515581853-15156468020208148', 1, 0, '', NULL, NULL, NULL),
(60077, '2018-01-11 13:42:22', NULL, NULL, 16019, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:42:22', 'admin-1515581853-15156493419437779', 1, 0, '', NULL, NULL, NULL),
(60078, '2018-01-11 13:42:10', NULL, NULL, 16019, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:42:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60079, '2018-01-11 13:41:54', NULL, NULL, 16018, 0, 181, '116', 'Open Food ', 'rice wine pork-rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:41:54', 'admin-1515581853-15156493148518668', 1, 0, '', NULL, NULL, NULL),
(60080, '2018-01-11 13:25:24', NULL, NULL, 16016, 0, 323, '259', 'Ginger Cucumber Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:25:24', 'admin-1515581853-15156483247544198', 1, 0, '', NULL, NULL, NULL),
(60081, '2018-01-11 13:25:08', NULL, NULL, 16016, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:25:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60082, '2018-01-11 13:03:24', NULL, NULL, 16015, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:03:24', 'admin-1515581853-15156470047064463', 1, 0, '', NULL, NULL, NULL),
(60083, '2018-01-11 13:03:24', NULL, NULL, 16015, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:03:24', 'admin-1515581853-15156470047064463', 1, 0, '', NULL, NULL, NULL),
(60084, '2018-01-11 13:02:31', NULL, NULL, 16015, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1515581853', 'admin', '2018-01-11 13:02:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60085, '2018-01-11 12:47:51', NULL, NULL, 16014, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1515581853', 'admin', '2018-01-11 12:47:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60086, '2018-01-11 12:24:34', NULL, NULL, 16013, 0, 181, '116', 'Open Food ', 'rice wine pork', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 12:24:34', 'admin-1515581853-15156446744222425', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(60087, '2018-01-11 12:44:24', NULL, NULL, 16011, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 12:44:24', 'admin-1515581853-1515645864754627', 1, 0, '', NULL, NULL, NULL),
(60088, '2018-01-11 12:18:44', NULL, NULL, 16011, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 12:18:44', 'admin-1515581853-15156443240099890', 1, 1, 'SR', NULL, NULL, NULL),
(60089, '2018-01-11 12:18:44', NULL, NULL, 16011, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 12:18:44', 'admin-1515581853-15156443240099890', 1, 0, '', NULL, NULL, NULL),
(60090, '2018-01-11 14:13:01', NULL, NULL, 16014, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 14:13:01', 'admin-1515581853-15156511812068624', 1, 1, 'SR', NULL, NULL, NULL),
(60091, '2018-01-11 12:18:44', NULL, NULL, 16011, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 12:18:44', 'admin-1515581853-15156443240099890', 1, 0, '', NULL, NULL, NULL),
(60092, '2018-01-11 12:03:50', NULL, NULL, 16005, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 12:03:50', 'admin-1515581853-15156434301547386', 1, 0, '', NULL, NULL, NULL),
(60093, '2018-01-11 11:54:33', NULL, NULL, 16012, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 11:54:33', 'admin-1515581853-15156428734729746', 1, 0, '', NULL, NULL, NULL),
(60094, '2018-01-11 11:54:33', NULL, NULL, 16012, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 11:54:33', 'admin-1515581853-15156428734729746', 1, 0, '', NULL, NULL, NULL),
(60095, '2018-01-11 11:53:59', NULL, NULL, 16011, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1515581853', 'admin', '2018-01-11 11:53:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60096, '2018-01-11 11:54:19', NULL, NULL, 16012, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1515581853', 'admin', '2018-01-11 11:54:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60097, '2018-01-11 11:54:33', NULL, NULL, 16012, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 11:54:33', 'admin-1515581853-15156428734729746', 1, 0, '', NULL, NULL, NULL),
(60098, '2018-01-11 11:38:45', NULL, NULL, 16007, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 11:38:45', 'admin-1515581853-15156419253677669', 1, 1, 'SR', NULL, NULL, NULL),
(60099, '2018-01-11 11:34:11', NULL, NULL, 16006, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 11:34:11', 'admin-1515581853-15156416510008084', 1, 1, 'SR', NULL, NULL, NULL),
(60100, '2018-01-11 11:38:39', NULL, NULL, 16007, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1515581853', 'admin', '2018-01-11 11:38:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60101, '2018-01-11 11:34:11', NULL, NULL, 16006, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 11:34:11', 'admin-1515581853-15156416510008084', 1, 0, '', NULL, NULL, NULL),
(60102, '2018-01-11 11:26:11', NULL, NULL, 16005, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 11:26:11', 'admin-1515581853-15156411717002193', 1, 1, 'SR', NULL, NULL, NULL),
(60103, '2018-01-11 11:34:11', NULL, NULL, 16006, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 11:34:11', 'admin-1515581853-15156416510008084', 1, 0, '', NULL, NULL, NULL),
(60104, '2018-01-11 11:33:19', NULL, NULL, 16006, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1515581853', 'admin', '2018-01-11 11:33:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60105, '2018-01-11 11:14:28', NULL, NULL, 16004, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 11:14:28', 'admin-1515581853-15156404685599988', 1, 0, '', NULL, NULL, NULL),
(60106, '2018-01-11 09:10:55', NULL, NULL, 16003, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 09:10:55', 'admin-1515581853-1515633054960795', 1, 1, 'SR', NULL, NULL, NULL),
(60107, '2018-01-11 11:14:18', NULL, NULL, 16004, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1515581853', 'admin', '2018-01-11 11:14:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60108, '2018-01-11 09:10:55', NULL, NULL, 16003, 0, 181, '116', 'Open Food ', 'junior BLT', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515581853', 'admin', '2018-01-11 09:10:55', 'admin-1515581853-1515633054960795', 1, 0, '', NULL, NULL, NULL),
(60109, '2018-01-11 09:10:42', NULL, NULL, 16003, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1515581853', 'admin', '2018-01-11 09:10:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60110, '2018-01-12 16:37:09', NULL, NULL, 16048, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 16:37:09', 'admin-1515719036-15157462293581481', 1, 0, '', NULL, NULL, NULL),
(60111, '2018-01-12 12:38:39', NULL, NULL, 16036, 0, 181, '116', 'Open Food ', 'rice wine RICE', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:38:39', 'admin-1515719036-1515731919026626', 1, 0, '', NULL, NULL, NULL),
(60112, '2018-01-12 13:30:25', NULL, NULL, 16040, 0, 181, '116', 'Open Food ', 'rice wine RICE', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 13:30:25', 'admin-1515719036-15157350250674097', 1, 0, '', NULL, NULL, NULL),
(60113, '2018-01-12 14:22:35', NULL, NULL, 16044, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1515719036', 'admin', '2018-01-12 14:22:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60114, '2018-01-12 14:23:12', NULL, NULL, 16044, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 14:23:12', 'admin-1515719036-15157381920626093', 1, 0, '', NULL, NULL, NULL),
(60115, '2018-01-12 14:06:08', NULL, NULL, 16040, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 14:06:08', 'admin-1515719036-15157371688419237', 1, 0, '', NULL, NULL, NULL),
(60116, '2018-01-12 13:52:45', NULL, NULL, 16043, 0, 181, '116', 'Open Food ', 'rice wine chicken-noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 13:52:45', 'admin-1515719036-15157363650433083', 1, 0, '', NULL, NULL, NULL),
(60117, '2018-01-12 13:52:45', NULL, NULL, 16043, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 13:52:45', 'admin-1515719036-15157363650433083', 1, 0, '', NULL, NULL, NULL),
(60118, '2018-01-12 13:52:45', NULL, NULL, 16043, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 13:52:45', 'admin-1515719036-15157363650433083', 1, 0, '', NULL, NULL, NULL),
(60119, '2018-01-12 13:51:53', NULL, NULL, 16043, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 13:51:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60120, '2018-01-12 12:52:17', NULL, NULL, 16038, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:52:17', 'admin-1515719036-15157327368999045', 1, 1, 'SR', NULL, NULL, NULL),
(60121, '2018-01-12 13:18:08', NULL, NULL, 16035, 0, 181, '116', 'Open Food ', 'rice wine chicken-rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 13:18:08', 'admin-1515719036-15157342880107934', 1, 0, '', NULL, NULL, NULL),
(60122, '2018-01-12 13:13:20', NULL, NULL, 16040, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 13:13:20', 'admin-1515719036-15157340002898125', 1, 1, 'SR', NULL, NULL, NULL),
(60123, '2018-01-12 13:13:08', NULL, NULL, 16040, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1515719036', 'admin', '2018-01-12 13:13:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60124, '2018-01-12 13:49:56', NULL, NULL, 16042, 0, 181, '116', 'Open Food ', 'rice wine chicken-noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 13:49:56', 'admin-1515719036-15157361966445761', 1, 0, '', NULL, NULL, NULL),
(60125, '2018-01-12 13:49:56', NULL, NULL, 16042, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 13:49:56', 'admin-1515719036-15157361966445761', 1, 0, '', NULL, NULL, NULL),
(60126, '2018-01-12 16:04:09', NULL, NULL, 16047, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1515719036', 'admin', '2018-01-12 16:04:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60127, '2018-01-12 16:04:14', NULL, NULL, 16047, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 16:04:14', 'admin-1515719036-15157442543855494', 1, 1, 'SR', NULL, NULL, NULL),
(60128, '2018-01-12 16:52:06', NULL, NULL, 16049, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 16:52:06', 'admin-1515719036-15157471261233425', 1, 1, 'SR', NULL, NULL, NULL),
(60129, '2018-01-12 13:49:56', NULL, NULL, 16042, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 13:49:56', 'admin-1515719036-15157361966445761', 1, 0, '', NULL, NULL, NULL),
(60130, '2018-01-12 13:48:30', NULL, NULL, 16042, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1515719036', 'admin', '2018-01-12 13:48:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60131, '2018-01-12 12:38:18', NULL, NULL, 16036, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:38:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60132, '2018-01-12 11:15:55', NULL, NULL, 16029, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:15:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60133, '2018-01-12 12:32:21', NULL, NULL, 16035, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:32:21', 'admin-1515719036-15157315412734945', 1, 0, '', NULL, NULL, NULL),
(60134, '2018-01-12 11:41:41', NULL, NULL, 16031, 0, 337, '273', 'Hot yuzu', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:41:41', 'admin-1515719036-15157285009222031', 1, 0, '', NULL, NULL, NULL),
(60135, '2018-01-12 16:37:09', NULL, NULL, 16048, 0, 338, '274', 'Chocolate Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 16:37:09', 'admin-1515719036-15157462293581481', 1, 0, '', NULL, NULL, NULL),
(60136, '2018-01-12 16:37:09', NULL, NULL, 16048, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 16:37:09', 'admin-1515719036-15157462293581481', 1, 1, 'SR', NULL, NULL, NULL),
(60137, '2018-01-12 14:23:12', NULL, NULL, 16044, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 14:23:12', 'admin-1515719036-15157381920626093', 1, 0, '', NULL, NULL, NULL),
(60138, '2018-01-12 13:30:52', NULL, NULL, 16041, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 13:30:52', 'admin-1515719036-15157350519285459', 1, 0, '', NULL, NULL, NULL),
(60139, '2018-01-12 13:32:09', NULL, NULL, 16040, 0, 181, '116', 'Open Food ', 'Rice wine NODDLE', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 13:32:09', 'admin-1515719036-15157351288995469', 1, 0, '', NULL, NULL, NULL),
(60140, '2018-01-12 13:30:45', NULL, NULL, 16041, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1515719036', 'admin', '2018-01-12 13:30:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60141, '2018-01-12 17:41:23', NULL, NULL, 16046, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 17:41:23', 'admin-1515719036-1515750083776252', 1, 0, '', NULL, NULL, NULL),
(60142, '2018-01-12 12:45:20', NULL, NULL, 16037, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:45:20', 'admin-1515719036-15157323202323980', 1, 1, 'SR', NULL, NULL, NULL),
(60143, '2018-01-12 12:45:20', NULL, NULL, 16037, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:45:20', 'admin-1515719036-15157323202323980', 1, 1, 'SR', NULL, NULL, NULL),
(60144, '2018-01-12 15:08:20', NULL, NULL, 16045, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 15:08:20', 'admin-1515719036-15157409006686534', 1, 0, '', NULL, NULL, NULL),
(60145, '2018-01-12 15:08:20', NULL, NULL, 16045, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 15:08:20', 'admin-1515719036-15157409006686534', 1, 0, '', NULL, NULL, NULL),
(60146, '2018-01-12 15:48:50', NULL, NULL, 16046, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.79, 0.0000, 0.0000, 5.79, 1, '27', 1, '1515719036', 'admin', '2018-01-12 15:48:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60147, '2018-01-12 17:24:40', NULL, NULL, 16046, 0, 338, '274', 'Chocolate Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 17:24:40', 'admin-1515719036-15157490804927775', 1, 0, '', NULL, NULL, NULL),
(60148, '2018-01-12 17:04:08', NULL, NULL, 16051, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 17:04:08', 'admin-1515719036-15157478487517683', 1, 1, 'SR', NULL, NULL, NULL),
(60149, '2018-01-12 17:04:02', NULL, NULL, 16051, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1515719036', 'admin', '2018-01-12 17:04:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60150, '2018-01-12 16:52:06', NULL, NULL, 16049, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 16:52:06', 'admin-1515719036-15157471261233425', 1, 1, 'SR', NULL, NULL, NULL),
(60151, '2018-01-12 13:04:10', NULL, NULL, 16039, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 13:04:10', 'admin-1515719036-15157334507062844', 1, 0, '', NULL, NULL, NULL),
(60152, '2018-01-12 12:45:20', NULL, NULL, 16037, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:45:20', 'admin-1515719036-15157323202323980', 1, 0, '', NULL, NULL, NULL),
(60153, '2018-01-12 16:59:51', NULL, NULL, 16050, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 16:59:51', 'admin-1515719036-15157475917713386', 1, 1, 'SR', 1, NULL, NULL),
(60154, '2018-01-12 16:59:51', NULL, NULL, 16050, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 16:59:51', 'admin-1515719036-15157475917713386', 1, 1, 'SR', 1, NULL, NULL),
(60155, '2018-01-12 16:51:56', NULL, NULL, 16049, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1515719036', 'admin', '2018-01-12 16:51:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60156, '2018-01-12 16:36:57', NULL, NULL, 16048, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1515719036', 'admin', '2018-01-12 16:36:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60157, '2018-01-12 15:49:04', NULL, NULL, 16046, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1515719036', 'admin', '2018-01-12 15:49:04', 'admin-1515719036-15157433443502039', 1, 0, '', NULL, NULL, NULL),
(60158, '2018-01-12 15:49:04', NULL, NULL, 16046, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 15:49:04', 'admin-1515719036-15157433443502039', 1, 1, 'SR', NULL, NULL, NULL),
(60159, '2018-01-12 15:49:04', NULL, NULL, 16046, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 15:49:04', 'admin-1515719036-15157433443502039', 1, 1, 'SR', NULL, NULL, NULL),
(60160, '2018-01-12 12:22:40', NULL, NULL, 16034, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:22:40', 'admin-1515719036-15157309604495357', 1, 1, 'SR', NULL, NULL, NULL),
(60161, '2018-01-12 12:22:40', NULL, NULL, 16034, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:22:40', 'admin-1515719036-15157309604495357', 1, 1, 'SR', NULL, NULL, NULL),
(60162, '2018-01-12 15:08:20', NULL, NULL, 16045, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 15:08:20', 'admin-1515719036-15157409006686534', 1, 1, 'SR', NULL, NULL, NULL),
(60163, '2018-01-12 09:19:51', NULL, NULL, 16025, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 09:19:51', 'admin-1515719036-15157199913803881', 1, 0, '', NULL, NULL, NULL),
(60164, '2018-01-12 15:08:07', NULL, NULL, 16045, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1515719036', 'admin', '2018-01-12 15:08:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60165, '2018-01-12 13:03:45', NULL, NULL, 16039, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1515719036', 'admin', '2018-01-12 13:03:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60166, '2018-01-12 14:23:12', NULL, NULL, 16044, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 14:23:12', 'admin-1515719036-15157381920626093', 1, 1, 'SR', NULL, NULL, NULL),
(60167, '2018-01-12 14:23:12', NULL, NULL, 16044, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 14:23:12', 'admin-1515719036-15157381920626093', 1, 1, 'SR', NULL, NULL, NULL),
(60168, '2018-01-12 14:23:12', NULL, NULL, 16044, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 14:23:12', 'admin-1515719036-15157381920626093', 1, 0, '', NULL, NULL, NULL),
(60169, '2018-01-12 14:06:08', NULL, NULL, 16040, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 14:06:08', 'admin-1515719036-15157371688419237', 1, 0, '', NULL, NULL, NULL),
(60170, '2018-01-12 12:52:17', NULL, NULL, 16038, 0, 181, '116', 'Open Food ', 'rice wine pork-noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:52:17', 'admin-1515719036-15157327368999045', 1, 0, '', NULL, NULL, NULL),
(60171, '2018-01-12 12:52:17', NULL, NULL, 16038, 0, 181, '116', 'Open Food ', 'rice wine chicken-rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:52:17', 'admin-1515719036-15157327368999045', 1, 0, '', NULL, NULL, NULL),
(60172, '2018-01-12 12:51:10', NULL, NULL, 16038, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:51:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60173, '2018-01-12 12:38:39', NULL, NULL, 16036, 0, 181, '116', 'Open Food ', 'macaroni', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:38:39', 'admin-1515719036-1515731919026626', 1, 0, '', NULL, NULL, NULL),
(60174, '2018-01-12 12:45:20', NULL, NULL, 16037, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:45:20', 'admin-1515719036-15157323202323980', 1, 0, '', NULL, NULL, NULL),
(60175, '2018-01-12 13:04:10', NULL, NULL, 16039, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 13:04:10', 'admin-1515719036-15157334507062844', 1, 0, '', NULL, NULL, NULL),
(60176, '2018-01-12 13:04:10', NULL, NULL, 16039, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 13:04:10', 'admin-1515719036-15157334507062844', 1, 1, 'SR', NULL, NULL, NULL),
(60177, '2018-01-12 12:47:17', NULL, NULL, 16037, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:47:17', 'admin-1515719036-1515732437127745', 1, 0, '', NULL, NULL, NULL),
(60178, '2018-01-12 12:45:20', NULL, NULL, 16037, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:45:20', 'admin-1515719036-15157323202323980', 1, 0, '', NULL, NULL, NULL),
(60179, '2018-01-12 13:49:56', NULL, NULL, 16042, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 13:49:56', 'admin-1515719036-15157361966445761', 1, 0, '', NULL, NULL, NULL),
(60180, '2018-01-12 12:45:20', NULL, NULL, 16037, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:45:20', 'admin-1515719036-15157323202323980', 1, 1, 'SR', NULL, NULL, NULL),
(60181, '2018-01-12 12:45:20', NULL, NULL, 16037, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:45:20', 'admin-1515719036-15157323202323980', 1, 0, '', NULL, NULL, NULL),
(60182, '2018-01-12 12:45:20', NULL, NULL, 16037, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:45:20', 'admin-1515719036-15157323202323980', 1, 0, '', NULL, NULL, NULL),
(60183, '2018-01-12 12:32:21', NULL, NULL, 16035, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:32:21', 'admin-1515719036-15157315412734945', 1, 0, '', NULL, NULL, NULL),
(60184, '2018-01-12 12:45:20', NULL, NULL, 16037, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:45:20', 'admin-1515719036-15157323202323980', 1, 0, '', NULL, NULL, NULL),
(60185, '2018-01-12 12:45:20', NULL, NULL, 16037, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:45:20', 'admin-1515719036-15157323202323980', 1, 0, '', NULL, NULL, NULL),
(60186, '2018-01-12 12:41:57', NULL, NULL, 16037, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 22.70, 0.0000, 0.0000, 22.70, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:41:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60187, '2018-01-12 12:45:20', NULL, NULL, 16037, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:45:20', 'admin-1515719036-15157323202323980', 1, 0, '', NULL, NULL, NULL),
(60188, '2018-01-12 12:45:20', NULL, NULL, 16037, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:45:20', 'admin-1515719036-15157323202323980', 1, 0, '', NULL, NULL, NULL),
(60189, '2018-01-12 12:45:20', NULL, NULL, 16037, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:45:20', 'admin-1515719036-15157323202323980', 1, 0, '', NULL, NULL, NULL),
(60190, '2018-01-12 12:45:20', NULL, NULL, 16037, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:45:20', 'admin-1515719036-15157323202323980', 1, 0, '', NULL, NULL, NULL),
(60191, '2018-01-12 12:38:39', NULL, NULL, 16036, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:38:39', 'admin-1515719036-1515731919026626', 1, 1, 'SR', NULL, NULL, NULL),
(60192, '2018-01-12 12:21:49', NULL, NULL, 16034, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.30, 0.0000, 0.0000, 8.30, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:21:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60193, '2018-01-12 12:22:40', NULL, NULL, 16034, 0, 181, '116', 'Open Food ', 'macaroni', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:22:40', 'admin-1515719036-15157309604495357', 1, 0, '', NULL, NULL, NULL),
(60194, '2018-01-12 11:46:30', NULL, NULL, 16033, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:46:30', 'admin-1515719036-15157287902649798', 1, 1, 'SR', NULL, NULL, NULL),
(60195, '2018-01-12 10:36:55', NULL, NULL, 16028, 0, 181, '116', 'Open Food ', 'crossaint', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 10:36:55', 'admin-1515719036-15157246152835274', 1, 0, '', NULL, NULL, NULL),
(60196, '2018-01-12 10:36:55', NULL, NULL, 16028, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 10:36:55', 'admin-1515719036-15157246152835274', 1, 1, 'SR', NULL, NULL, NULL),
(60197, '2018-01-12 09:15:40', NULL, NULL, 16025, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1515719036', 'admin', '2018-01-12 09:15:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60198, '2018-01-12 09:19:51', NULL, NULL, 16025, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 09:19:51', 'admin-1515719036-15157199913803881', 1, 0, '', NULL, NULL, NULL),
(60199, '2018-01-12 10:36:55', NULL, NULL, 16028, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 10:36:55', 'admin-1515719036-15157246152835274', 1, 0, '', NULL, NULL, NULL),
(60200, '2018-01-12 10:36:55', NULL, NULL, 16028, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 10:36:55', 'admin-1515719036-15157246152835274', 1, 0, '', NULL, NULL, NULL),
(60201, '2018-01-12 13:30:52', NULL, NULL, 16041, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 13:30:52', 'admin-1515719036-15157350519285459', 1, 1, 'SR', NULL, NULL, NULL),
(60202, '2018-01-12 12:31:35', NULL, NULL, 16035, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:31:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60203, '2018-01-12 12:22:40', NULL, NULL, 16034, 0, 181, '116', 'Open Food ', 'rice wine RICE', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:22:40', 'admin-1515719036-15157309604495357', 1, 0, '', NULL, NULL, NULL),
(60204, '2018-01-12 11:31:23', NULL, NULL, 16030, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:31:23', 'admin-1515719036-1515727883589148', 1, 1, 'SR', NULL, NULL, NULL),
(60205, '2018-01-12 11:31:23', NULL, NULL, 16030, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:31:23', 'admin-1515719036-1515727883589148', 1, 1, 'SR', NULL, NULL, NULL),
(60206, '2018-01-12 11:31:23', NULL, NULL, 16030, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:31:23', 'admin-1515719036-1515727883589148', 1, 1, 'SR', NULL, NULL, NULL),
(60207, '2018-01-12 11:31:23', NULL, NULL, 16030, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:31:23', 'admin-1515719036-1515727883589148', 1, 1, 'SR', NULL, NULL, NULL),
(60208, '2018-01-12 11:31:23', NULL, NULL, 16030, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:31:23', 'admin-1515719036-1515727883589148', 1, 1, 'SR', NULL, NULL, NULL),
(60209, '2018-01-12 12:10:23', NULL, NULL, 16031, 0, 304, '240', 'Banana is On Fire', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:10:23', 'admin-1515719036-15157302237535753', 1, 0, '', NULL, NULL, NULL),
(60210, '2018-01-12 11:46:30', NULL, NULL, 16033, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:46:30', 'admin-1515719036-15157287902649798', 1, 1, 'SR', NULL, NULL, NULL),
(60211, '2018-01-12 11:46:22', NULL, NULL, 16033, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:46:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60212, '2018-01-12 12:32:21', NULL, NULL, 16035, 0, 181, '116', 'Open Food ', 'Rice wine NODDLE', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:32:21', 'admin-1515719036-15157315412734945', 1, 0, '', NULL, NULL, NULL),
(60213, '2018-01-12 11:42:32', NULL, NULL, 16032, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:42:32', 'admin-1515719036-15157285521189912', 1, 1, 'SR', NULL, NULL, NULL),
(60214, '2018-01-12 13:49:56', NULL, NULL, 16042, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 13:49:56', 'admin-1515719036-15157361966445761', 1, 1, 'SR', NULL, NULL, NULL),
(60215, '2018-01-12 11:42:32', NULL, NULL, 16032, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:42:32', 'admin-1515719036-15157285521189912', 1, 1, 'SR', NULL, NULL, NULL),
(60216, '2018-01-12 11:16:09', NULL, NULL, 16029, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:16:09', 'admin-1515719036-1515726968977436', 1, 0, '', NULL, NULL, NULL),
(60217, '2018-01-12 11:26:04', NULL, NULL, 16030, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 11.50, 0.0000, 0.0000, 11.50, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:26:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60218, '2018-01-12 11:31:23', NULL, NULL, 16030, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:31:23', 'admin-1515719036-1515727883589148', 1, 0, '', NULL, NULL, NULL),
(60219, '2018-01-12 11:42:15', NULL, NULL, 16032, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:42:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60220, '2018-01-12 11:41:41', NULL, NULL, 16031, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:41:41', 'admin-1515719036-15157285009222031', 1, 0, '', NULL, NULL, NULL),
(60221, '2018-01-12 12:32:21', NULL, NULL, 16035, 0, 181, '116', 'Open Food ', 'rice wine RICE', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:32:21', 'admin-1515719036-15157315412734945', 1, 0, '', NULL, NULL, NULL),
(60222, '2018-01-12 12:22:40', NULL, NULL, 16034, 0, 181, '116', 'Open Food ', 'macaroni', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 12:22:40', 'admin-1515719036-15157309604495357', 1, 0, '', NULL, NULL, NULL),
(60223, '2018-01-12 11:41:27', NULL, NULL, 16031, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:41:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60224, '2018-01-12 11:31:23', NULL, NULL, 16030, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:31:23', 'admin-1515719036-1515727883589148', 1, 0, '', NULL, NULL, NULL),
(60225, '2018-01-12 11:31:23', NULL, NULL, 16030, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:31:23', 'admin-1515719036-1515727883589148', 1, 0, '', NULL, NULL, NULL),
(60226, '2018-01-12 11:31:23', NULL, NULL, 16030, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:31:23', 'admin-1515719036-1515727883589148', 1, 0, '', NULL, NULL, NULL),
(60227, '2018-01-12 11:16:09', NULL, NULL, 16029, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:16:09', 'admin-1515719036-1515726968977436', 1, 0, '', NULL, NULL, NULL),
(60228, '2018-01-12 10:36:55', NULL, NULL, 16028, 0, 181, '116', 'Open Food ', 'crossaint', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 10:36:55', 'admin-1515719036-15157246152835274', 1, 0, '', NULL, NULL, NULL),
(60229, '2018-01-12 11:16:09', NULL, NULL, 16029, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:16:09', 'admin-1515719036-1515726968977436', 1, 0, '', NULL, NULL, NULL),
(60230, '2018-01-12 11:16:09', NULL, NULL, 16029, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 11:16:09', 'admin-1515719036-1515726968977436', 1, 0, '', NULL, NULL, NULL),
(60231, '2018-01-12 10:33:23', NULL, NULL, 16028, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1515719036', 'admin', '2018-01-12 10:33:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60232, '2018-01-12 10:33:54', NULL, NULL, 16028, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 10:33:54', 'admin-1515719036-15157244339196357', 1, 1, 'SR', NULL, NULL, NULL),
(60233, '2018-01-12 09:54:51', NULL, NULL, 16026, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 09:54:51', 'admin-1515719036-15157220916177398', 1, 0, '', NULL, NULL, NULL),
(60234, '2018-01-12 10:27:25', NULL, NULL, 16027, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 10:27:25', 'admin-1515719036-1515724045112521', 1, 0, '', NULL, NULL, NULL),
(60235, '2018-01-12 10:27:25', NULL, NULL, 16027, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 10:27:25', 'admin-1515719036-1515724045112521', 1, 0, '', NULL, NULL, NULL),
(60236, '2018-01-12 10:27:25', NULL, NULL, 16027, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 10:27:25', 'admin-1515719036-1515724045112521', 1, 0, '', NULL, NULL, NULL),
(60237, '2018-01-12 10:27:25', NULL, NULL, 16027, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 10:27:25', 'admin-1515719036-1515724045112521', 1, 0, '', NULL, NULL, NULL),
(60238, '2018-01-12 10:27:25', NULL, NULL, 16027, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 10:27:25', 'admin-1515719036-1515724045112521', 1, 1, 'SR', NULL, NULL, NULL),
(60239, '2018-01-12 10:27:25', NULL, NULL, 16027, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 10:27:25', 'admin-1515719036-1515724045112521', 1, 1, 'SR', NULL, NULL, NULL),
(60240, '2018-01-12 10:27:25', NULL, NULL, 16027, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 10:27:25', 'admin-1515719036-1515724045112521', 1, 1, 'SR', NULL, NULL, NULL),
(60241, '2018-01-12 10:27:25', NULL, NULL, 16027, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 10:27:25', 'admin-1515719036-1515724045112521', 1, 1, 'SR', NULL, NULL, NULL),
(60242, '2018-01-12 10:26:41', NULL, NULL, 16027, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 11.50, 0.0000, 0.0000, 11.50, 1, '27', 1, '1515719036', 'admin', '2018-01-12 10:26:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60243, '2018-01-12 09:54:51', NULL, NULL, 16026, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 09:54:51', 'admin-1515719036-15157220916177398', 1, 1, 'SR', NULL, NULL, NULL),
(60244, '2018-01-12 09:54:45', NULL, NULL, 16026, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1515719036', 'admin', '2018-01-12 09:54:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60245, '2018-01-12 09:19:51', NULL, NULL, 16025, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 09:19:51', 'admin-1515719036-15157199913803881', 1, 1, 'SR', NULL, NULL, NULL),
(60246, '2018-01-12 09:19:51', NULL, NULL, 16025, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 09:19:51', 'admin-1515719036-15157199913803881', 1, 0, '', NULL, NULL, NULL),
(60247, '2018-01-12 09:09:37', NULL, NULL, 16024, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 09:09:37', 'admin-1515719036-15157193772261464', 1, 0, '', NULL, NULL, NULL),
(60248, '2018-01-12 09:09:37', NULL, NULL, 16024, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515719036', 'admin', '2018-01-12 09:09:37', 'admin-1515719036-15157193772261464', 1, 1, 'SR', NULL, NULL, NULL),
(60249, '2018-01-12 09:09:29', NULL, NULL, 16024, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1515719036', 'admin', '2018-01-12 09:09:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60250, '2018-01-13 15:58:47', NULL, NULL, 16085, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:58:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60251, '2018-01-13 15:58:51', NULL, NULL, 16085, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:58:51', 'admin-1515805892-15158303314245212', 1, 1, 'SR', NULL, NULL, NULL),
(60252, '2018-01-13 16:10:16', NULL, NULL, 16086, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1515805892', 'admin', '2018-01-13 16:10:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60253, '2018-01-13 16:10:28', NULL, NULL, 16086, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 16:10:28', 'admin-1515805892-15158310283287958', 1, 1, 'SR', NULL, NULL, NULL),
(60254, '2018-01-13 16:10:32', NULL, NULL, 16087, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1515805892', 'admin', '2018-01-13 16:10:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60255, '2018-01-13 16:10:38', NULL, NULL, 16087, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 16:10:38', 'admin-1515805892-15158310379415819', 1, 1, 'SR', NULL, NULL, NULL),
(60256, '2018-01-13 14:21:30', NULL, NULL, 16080, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 14:21:30', 'admin-1515805892-15158244908608483', 1, 1, 'SR', NULL, NULL, NULL),
(60257, '2018-01-13 13:40:32', NULL, NULL, 16076, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:40:32', 'admin-1515805892-15158220326088996', 1, 1, 'SR', NULL, NULL, NULL),
(60258, '2018-01-13 13:25:28', NULL, NULL, 16075, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:25:28', 'admin-1515805892-15158211285786832', 1, 1, 'SR', NULL, NULL, NULL),
(60259, '2018-01-13 10:40:11', NULL, NULL, 16060, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.91, 0.0000, 0.0000, 4.91, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:40:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60260, '2018-01-13 10:40:30', NULL, NULL, 16060, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 16.20, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:40:30', 'admin-1515805892-15158112302814026', 1, 0, '', NULL, '10.0', NULL),
(60261, '2018-01-13 15:15:19', NULL, NULL, 16083, 0, 181, '116', 'Open Food ', 'chic rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:15:19', 'admin-1515805892-15158277196597412', 1, 0, '', NULL, NULL, NULL),
(60262, '2018-01-13 15:15:19', NULL, NULL, 16083, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:15:19', 'admin-1515805892-15158277196597412', 1, 1, 'SR', NULL, NULL, NULL),
(60263, '2018-01-13 15:15:19', NULL, NULL, 16083, 0, 331, '267', 'Yuzu Marmalade Pancake', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:15:19', 'admin-1515805892-15158277196597412', 1, 0, '', NULL, NULL, NULL),
(60264, '2018-01-13 15:15:19', NULL, NULL, 16083, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:15:19', 'admin-1515805892-15158277196597412', 1, 0, '', NULL, NULL, NULL),
(60265, '2018-01-13 15:14:12', NULL, NULL, 16083, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 13.70, 0.0000, 0.0000, 13.70, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:14:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60266, '2018-01-13 13:07:53', NULL, NULL, 16074, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.39, 0.0000, 0.0000, 10.39, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:07:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60267, '2018-01-13 13:33:17', NULL, NULL, 16071, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:33:17', 'admin-1515805892-151582159776353', 1, 1, 'SR', NULL, NULL, NULL),
(60268, '2018-01-13 12:43:25', NULL, NULL, 16071, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 12:43:25', 'admin-1515805892-15158186056403393', 1, 0, '', NULL, NULL, NULL),
(60269, '2018-01-13 12:50:18', NULL, NULL, 16071, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 12:50:18', 'admin-1515805892-1515819018249128', 1, 0, '', NULL, NULL, NULL),
(60270, '2018-01-13 13:01:02', NULL, NULL, 16073, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:01:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60271, '2018-01-13 13:01:27', NULL, NULL, 16073, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:01:27', 'admin-1515805892-15158196877861642', 1, 1, 'SR', NULL, NULL, NULL),
(60272, '2018-01-13 15:07:16', NULL, NULL, 16082, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:07:16', 'admin-1515805892-1515827236172369', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(60273, '2018-01-13 15:07:16', NULL, NULL, 16082, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:07:16', 'admin-1515805892-1515827236172369', 1, 0, '', NULL, NULL, NULL),
(60274, '2018-01-13 17:16:49', NULL, NULL, 16088, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 17:16:49', 'admin-1515805892-15158350089943195', 1, 1, 'SR', NULL, NULL, NULL),
(60275, '2018-01-13 17:16:01', NULL, NULL, 16062, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 17:16:01', 'admin-1515805892-15158349612792623', 1, 1, 'SR', 1, NULL, NULL),
(60276, '2018-01-13 16:28:45', NULL, NULL, 16086, 0, 160, '94', 'Signature Dumpling (5 Pcs)', 'Takeaway', 'Meals', 'Snacks ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 16:28:45', 'admin-1515805892-15158321254854061', 1, 0, '', NULL, NULL, NULL),
(60277, '2018-01-13 13:48:23', NULL, NULL, 16077, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:48:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60278, '2018-01-13 15:56:47', NULL, NULL, 16084, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:56:47', 'admin-1515805892-15158302076476153', 1, 1, 'SR', NULL, NULL, NULL),
(60279, '2018-01-13 15:53:19', NULL, NULL, 16084, 0, 182, '117', 'Open Drinks ', 'beer', 'Cold Drinks', 'Fresh Juice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:53:19', 'admin-1515805892-15158299995259090', 1, 0, '', NULL, NULL, NULL),
(60280, '2018-01-13 15:07:16', NULL, NULL, 16082, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:07:16', 'admin-1515805892-1515827236172369', 1, 1, 'SR', NULL, NULL, NULL),
(60281, '2018-01-13 15:07:16', NULL, NULL, 16082, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:07:16', 'admin-1515805892-1515827236172369', 1, 0, '', NULL, NULL, NULL),
(60282, '2018-01-13 10:44:27', NULL, NULL, 16061, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:44:27', 'admin-1515805892-15158114673126117', 1, 1, 'SR', NULL, NULL, NULL),
(60283, '2018-01-13 14:06:06', NULL, NULL, 16079, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 14:06:06', 'admin-1515805892-15158235659944281', 1, 0, '', NULL, NULL, NULL),
(60284, '2018-01-13 15:06:33', NULL, NULL, 16082, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:06:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60285, '2018-01-13 13:25:28', NULL, NULL, 16075, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:25:28', 'admin-1515805892-15158211285786832', 1, 1, 'SR', NULL, NULL, NULL),
(60286, '2018-01-13 11:45:04', NULL, NULL, 16067, 0, 181, '116', 'Open Food ', 'macaroni', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:45:04', 'admin-1515805892-15158151045684856', 1, 0, '', NULL, NULL, NULL),
(60287, '2018-01-13 11:58:41', NULL, NULL, 16068, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:58:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60288, '2018-01-13 15:40:45', NULL, NULL, 16084, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:40:45', 'admin-1515805892-15158292455766410', 1, 1, 'SR', NULL, NULL, NULL),
(60289, '2018-01-13 15:40:45', NULL, NULL, 16084, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:40:45', 'admin-1515805892-15158292455766410', 1, 1, 'SR', NULL, NULL, NULL),
(60290, '2018-01-13 15:40:45', NULL, NULL, 16084, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:40:45', 'admin-1515805892-15158292455766410', 1, 1, 'SR', NULL, NULL, NULL),
(60291, '2018-01-13 12:42:47', NULL, NULL, 16072, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1515805892', 'admin', '2018-01-13 12:42:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60292, '2018-01-13 14:06:06', NULL, NULL, 16079, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 14:06:06', 'admin-1515805892-15158235659944281', 1, 0, '', NULL, NULL, NULL),
(60293, '2018-01-13 14:17:23', NULL, NULL, 16080, 0, 181, '116', 'Open Food ', 'chicken rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 14:17:23', 'admin-1515805892-151582424332854', 1, 0, '', NULL, NULL, NULL),
(60294, '2018-01-13 14:17:23', NULL, NULL, 16080, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 14:17:23', 'admin-1515805892-151582424332854', 1, 0, '', NULL, NULL, NULL),
(60295, '2018-01-13 14:19:05', NULL, NULL, 16081, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1515805892', 'admin', '2018-01-13 14:19:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60296, '2018-01-13 15:32:44', NULL, NULL, 16083, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:32:44', 'admin-1515805892-15158287643343050', 1, 0, '', NULL, NULL, NULL),
(60297, '2018-01-13 15:39:20', NULL, NULL, 16084, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:39:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60298, '2018-01-13 14:17:23', NULL, NULL, 16080, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 14:17:23', 'admin-1515805892-151582424332854', 1, 0, '', NULL, NULL, NULL),
(60299, '2018-01-13 13:01:27', NULL, NULL, 16073, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:01:27', 'admin-1515805892-15158196877861642', 1, 1, 'SR', NULL, NULL, NULL),
(60300, '2018-01-13 13:01:27', NULL, NULL, 16073, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:01:27', 'admin-1515805892-15158196877861642', 1, 1, 'SR', NULL, NULL, NULL),
(60301, '2018-01-13 15:28:59', NULL, NULL, 16083, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:28:59', 'admin-1515805892-15158285388886052', 1, 0, '', NULL, NULL, NULL),
(60302, '2018-01-13 15:28:59', NULL, NULL, 16083, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:28:59', 'admin-1515805892-15158285388886052', 1, 1, 'SR', NULL, NULL, NULL),
(60303, '2018-01-13 13:58:11', NULL, NULL, 16076, 0, 181, '116', 'Open Food ', 'macaroni', 'Meals', 'Perfect Meals', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:58:11', 'admin-1515805892-15158230911713357', 1, 0, '', NULL, NULL, NULL),
(60304, '2018-01-13 13:58:11', NULL, NULL, 16076, 0, 181, '116', 'Open Food ', 'angle hair,spicy angle hair', 'Meals', 'Perfect Meals', 1, 42.00, 42.0000, 0.0000, 42.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:58:11', 'admin-1515805892-15158230911713357', 1, 0, '', NULL, NULL, NULL),
(60305, '2018-01-13 13:58:11', NULL, NULL, 16076, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:58:11', 'admin-1515805892-15158230911713357', 1, 1, 'SR', NULL, NULL, NULL),
(60306, '2018-01-13 13:58:36', NULL, NULL, 16078, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:58:36', 'admin-1515805892-1515823116570423', 1, 0, '', NULL, NULL, NULL),
(60307, '2018-01-13 14:04:59', NULL, NULL, 16079, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1515805892', 'admin', '2018-01-13 14:04:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60308, '2018-01-13 14:06:06', NULL, NULL, 16079, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 14:06:06', 'admin-1515805892-15158235659944281', 1, 0, '', NULL, NULL, NULL),
(60309, '2018-01-13 14:06:06', NULL, NULL, 16079, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 14:06:06', 'admin-1515805892-15158235659944281', 1, 0, '', NULL, NULL, NULL),
(60310, '2018-01-13 11:14:24', NULL, NULL, 16063, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:14:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60311, '2018-01-13 11:15:01', NULL, NULL, 16063, 0, 181, '116', 'Open Food ', 'croissaint', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:15:01', 'admin-1515805892-15158133015475180', 1, 0, '', NULL, NULL, NULL),
(60312, '2018-01-13 15:28:58', NULL, NULL, 16083, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:28:59', 'admin-1515805892-15158285388886052', 1, 1, 'SR', NULL, NULL, NULL),
(60313, '2018-01-13 14:14:46', NULL, NULL, 16080, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1515805892', 'admin', '2018-01-13 14:14:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60314, '2018-01-13 14:16:35', NULL, NULL, 16074, 0, 160, '94', 'Signature Dumpling (5 Pcs)', 'Takeaway', 'Meals', 'Snacks ', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 14:16:35', 'admin-1515805892-15158241957213287', 1, 0, '', NULL, NULL, NULL),
(60315, '2018-01-13 14:06:06', NULL, NULL, 16079, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 14:06:06', 'admin-1515805892-15158235659944281', 1, 1, 'SR', NULL, NULL, NULL),
(60316, '2018-01-13 14:30:54', NULL, NULL, 16080, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 14:30:54', 'admin-1515805892-15158250548167096', 1, 0, '', NULL, NULL, NULL),
(60317, '2018-01-13 14:06:06', NULL, NULL, 16079, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 14:06:06', 'admin-1515805892-15158235659944281', 1, 1, 'SR', NULL, NULL, NULL),
(60318, '2018-01-13 14:06:06', NULL, NULL, 16079, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 14:06:06', 'admin-1515805892-15158235659944281', 1, 0, '', NULL, NULL, NULL),
(60319, '2018-01-13 13:58:11', NULL, NULL, 16076, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:58:11', 'admin-1515805892-15158230911713357', 1, 0, '', NULL, NULL, NULL),
(60320, '2018-01-13 13:58:24', NULL, NULL, 16078, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:58:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60321, '2018-01-13 12:36:15', NULL, NULL, 16071, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1515805892', 'admin', '2018-01-13 12:36:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60322, '2018-01-13 12:37:01', NULL, NULL, 16071, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 12:37:01', 'admin-1515805892-15158182210357890', 1, 0, '', NULL, NULL, NULL),
(60323, '2018-01-13 12:37:01', NULL, NULL, 16071, 0, 181, '116', 'Open Food ', 'chicken rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 12:37:01', 'admin-1515805892-15158182210357890', 1, 0, '', NULL, NULL, NULL),
(60324, '2018-01-13 13:48:41', NULL, NULL, 16077, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:48:41', 'admin-1515805892-15158225218557685', 1, 0, '', NULL, NULL, NULL),
(60325, '2018-01-13 12:42:58', NULL, NULL, 16072, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 12:42:58', 'admin-1515805892-15158185784634973', 1, 0, '', NULL, NULL, NULL),
(60326, '2018-01-13 11:23:19', NULL, NULL, 16064, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:23:19', 'admin-1515805892-15158137995871667', 1, 0, '', NULL, NULL, NULL),
(60327, '2018-01-13 13:58:36', NULL, NULL, 16078, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:58:36', 'admin-1515805892-1515823116570423', 1, 1, 'SR', NULL, NULL, NULL),
(60328, '2018-01-13 13:48:42', NULL, NULL, 16077, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:48:42', 'admin-1515805892-15158225218557685', 1, 1, 'SR', NULL, NULL, NULL),
(60329, '2018-01-13 10:40:30', NULL, NULL, 16060, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:40:30', 'admin-1515805892-15158112302814026', 1, 1, 'SR', NULL, NULL, NULL),
(60330, '2018-01-13 17:16:43', NULL, NULL, 16088, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1515805892', 'admin', '2018-01-13 17:16:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60331, '2018-01-13 15:15:19', NULL, NULL, 16083, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:15:19', 'admin-1515805892-15158277196597412', 1, 0, '', NULL, NULL, NULL),
(60332, '2018-01-13 14:17:23', NULL, NULL, 16080, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 14:17:23', 'admin-1515805892-151582424332854', 1, 0, '', NULL, NULL, NULL),
(60333, '2018-01-13 13:40:32', NULL, NULL, 16076, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:40:32', 'admin-1515805892-15158220326088996', 1, 0, '', NULL, NULL, NULL),
(60334, '2018-01-13 11:44:06', NULL, NULL, 16066, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:44:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60335, '2018-01-13 11:44:12', NULL, NULL, 16066, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:44:12', 'admin-1515805892-15158150522584071', 1, 1, 'SR', NULL, NULL, NULL),
(60336, '2018-01-13 14:19:12', NULL, NULL, 16081, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 14:19:12', 'admin-1515805892-15158243521873880', 1, 1, 'SR', NULL, NULL, NULL),
(60337, '2018-01-13 13:39:38', NULL, NULL, 16076, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 12.10, 0.0000, 0.0000, 12.10, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:39:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60338, '2018-01-13 13:36:24', NULL, NULL, 16074, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:36:24', 'admin-1515805892-15158217846153129', 1, 0, '', NULL, NULL, NULL),
(60339, '2018-01-13 13:33:17', NULL, NULL, 16071, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:33:17', 'admin-1515805892-151582159776353', 1, 1, 'SR', NULL, NULL, NULL),
(60340, '2018-01-13 13:33:17', NULL, NULL, 16071, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:33:17', 'admin-1515805892-151582159776353', 1, 0, '', NULL, NULL, NULL),
(60341, '2018-01-13 13:11:23', NULL, NULL, 16074, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:11:23', 'admin-1515805892-15158202834092985', 1, 1, 'SR', NULL, NULL, NULL),
(60342, '2018-01-13 13:11:23', NULL, NULL, 16074, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:11:23', 'admin-1515805892-15158202834092985', 1, 1, 'SR', NULL, NULL, NULL),
(60343, '2018-01-13 13:08:24', NULL, NULL, 16074, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:08:24', 'admin-1515805892-15158201041815421', 1, 0, '', NULL, NULL, NULL),
(60344, '2018-01-13 13:08:24', NULL, NULL, 16074, 0, 181, '116', 'Open Food ', 'chicken rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:08:24', 'admin-1515805892-15158201041815421', 1, 0, '', NULL, NULL, NULL),
(60345, '2018-01-13 13:14:11', NULL, NULL, 16074, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:14:11', 'admin-1515805892-15158204518342878', 1, 0, '', NULL, NULL, NULL),
(60346, '2018-01-13 12:42:58', NULL, NULL, 16072, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 12:42:58', 'admin-1515805892-15158185784634973', 1, 1, 'SR', NULL, NULL, NULL),
(60347, '2018-01-13 10:29:31', NULL, NULL, 16052, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:29:31', 'admin-1515805892-15158105710613657', 1, 1, 'SR', NULL, NULL, NULL),
(60348, '2018-01-13 15:15:19', NULL, NULL, 16083, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:15:19', 'admin-1515805892-15158277196597412', 1, 0, '', NULL, NULL, NULL),
(60349, '2018-01-13 12:03:04', NULL, NULL, 16069, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 12:03:04', 'admin-1515805892-15158161848359769', 1, 1, 'SR', NULL, NULL, NULL),
(60350, '2018-01-13 12:03:05', NULL, NULL, 16069, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 12:03:05', 'admin-1515805892-15158161848359769', 1, 0, '', NULL, NULL, NULL),
(60351, '2018-01-13 12:28:14', NULL, NULL, 16069, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 12:28:14', 'admin-1515805892-15158176946724234', 1, 1, 'SR', NULL, NULL, NULL),
(60352, '2018-01-13 12:36:02', NULL, NULL, 16070, 0, 181, '116', 'Open Food ', 'chicken rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 12:36:02', 'admin-1515805892-15158181622386250', 1, 0, '', 1, NULL, '10.0'),
(60353, '2018-01-13 15:15:19', NULL, NULL, 16083, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:15:19', 'admin-1515805892-15158277196597412', 1, 1, 'SR', NULL, NULL, NULL),
(60354, '2018-01-13 14:17:23', NULL, NULL, 16080, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 14:17:23', 'admin-1515805892-151582424332854', 1, 0, '', NULL, NULL, NULL),
(60355, '2018-01-13 14:16:35', NULL, NULL, 16074, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', 'Takeaway', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 14:16:35', 'admin-1515805892-15158241957213287', 1, 0, '', NULL, NULL, NULL),
(60356, '2018-01-13 11:44:47', NULL, NULL, 16067, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:44:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60357, '2018-01-13 11:45:04', NULL, NULL, 16067, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:45:04', 'admin-1515805892-15158151045684856', 1, 0, '', NULL, NULL, NULL),
(60358, '2018-01-13 10:44:27', NULL, NULL, 16061, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:44:27', 'admin-1515805892-15158114673126117', 1, 0, '', NULL, NULL, NULL),
(60359, '2018-01-13 12:03:04', NULL, NULL, 16069, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 12:03:04', 'admin-1515805892-15158161848359769', 1, 1, 'SR', NULL, NULL, NULL),
(60360, '2018-01-13 11:58:59', NULL, NULL, 16068, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:58:59', 'admin-1515805892-15158159394055992', 1, 0, '', NULL, NULL, NULL),
(60361, '2018-01-13 12:02:53', NULL, NULL, 16069, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 12:02:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60362, '2018-01-13 11:58:59', NULL, NULL, 16068, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:58:59', 'admin-1515805892-15158159394055992', 1, 0, '', NULL, NULL, NULL),
(60363, '2018-01-13 11:58:59', NULL, NULL, 16068, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:58:59', 'admin-1515805892-15158159394055992', 1, 0, '', NULL, NULL, NULL),
(60364, '2018-01-13 11:58:59', NULL, NULL, 16068, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:58:59', 'admin-1515805892-15158159394055992', 1, 0, '', NULL, NULL, NULL),
(60365, '2018-01-13 12:37:01', NULL, NULL, 16071, 0, 181, '116', 'Open Food ', 'chicken', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 12:37:01', 'admin-1515805892-15158182210357890', 1, 0, '', NULL, NULL, NULL),
(60366, '2018-01-13 11:40:15', NULL, NULL, 16065, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:40:15', 'admin-1515805892-15158148157698842', 1, 1, 'SR', NULL, NULL, NULL),
(60367, '2018-01-13 11:40:15', NULL, NULL, 16065, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:40:15', 'admin-1515805892-15158148157698842', 1, 0, '', NULL, NULL, NULL),
(60368, '2018-01-13 11:40:15', NULL, NULL, 16065, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:40:15', 'admin-1515805892-15158148157698842', 1, 0, '', NULL, NULL, NULL),
(60369, '2018-01-13 11:39:15', NULL, NULL, 16065, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:39:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60370, '2018-01-13 11:23:19', NULL, NULL, 16064, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:23:19', 'admin-1515805892-15158137995871667', 1, 1, 'SR', NULL, NULL, NULL),
(60371, '2018-01-13 12:03:04', NULL, NULL, 16069, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 12:03:04', 'admin-1515805892-15158161848359769', 1, 1, 'SR', NULL, NULL, NULL),
(60372, '2018-01-13 11:23:19', NULL, NULL, 16064, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:23:19', 'admin-1515805892-15158137995871667', 1, 1, 'SR', NULL, NULL, NULL),
(60373, '2018-01-13 10:47:49', NULL, NULL, 16062, 0, 181, '116', 'Open Food ', 'bacon,sausage,scramble egg', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 10.80, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:47:49', 'admin-1515805892-15158116693451483', 1, 0, '', 1, '10.0', NULL),
(60374, '2018-01-13 17:16:49', NULL, NULL, 16088, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 17:16:49', 'admin-1515805892-15158350089943195', 1, 1, 'SR', NULL, NULL, NULL),
(60375, '2018-01-13 15:40:45', NULL, NULL, 16084, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 15:40:45', 'admin-1515805892-15158292455766410', 1, 1, 'SR', NULL, NULL, NULL),
(60376, '2018-01-13 13:25:23', NULL, NULL, 16075, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 13:25:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60377, '2018-01-13 11:23:19', NULL, NULL, 16064, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:23:19', 'admin-1515805892-15158137995871667', 1, 1, 'SR', NULL, NULL, NULL),
(60378, '2018-01-13 10:44:27', NULL, NULL, 16061, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:44:27', 'admin-1515805892-15158114673126117', 1, 0, '', NULL, NULL, NULL),
(60379, '2018-01-13 11:15:01', NULL, NULL, 16063, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:15:01', 'admin-1515805892-15158133015475180', 1, 0, '', NULL, NULL, NULL),
(60380, '2018-01-13 11:22:19', NULL, NULL, 16064, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:22:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60381, '2018-01-13 10:44:27', NULL, NULL, 16061, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:44:27', 'admin-1515805892-15158114673126117', 1, 0, '', NULL, NULL, NULL),
(60382, '2018-01-13 10:36:32', NULL, NULL, 16059, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:36:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60383, '2018-01-13 10:36:42', NULL, NULL, 16059, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:36:42', 'admin-1515805892-15158110025019893', 1, 0, '', NULL, NULL, NULL),
(60384, '2018-01-13 10:36:42', NULL, NULL, 16059, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:36:42', 'admin-1515805892-15158110025019893', 1, 1, 'SR', NULL, NULL, NULL),
(60385, '2018-01-13 11:23:19', NULL, NULL, 16064, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:23:19', 'admin-1515805892-15158137995871667', 1, 0, '', NULL, NULL, NULL),
(60386, '2018-01-13 10:47:49', NULL, NULL, 16062, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:47:49', 'admin-1515805892-15158116693451483', 1, 1, 'SR', 1, NULL, NULL),
(60387, '2018-01-13 10:40:30', NULL, NULL, 16060, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 18.90, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:40:30', 'admin-1515805892-15158112302814026', 1, 0, '', NULL, '10.0', NULL),
(60388, '2018-01-13 11:44:12', NULL, NULL, 16066, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 11:44:12', 'admin-1515805892-15158150522584071', 1, 0, '', NULL, NULL, NULL),
(60389, '2018-01-13 10:43:57', NULL, NULL, 16061, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:43:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60390, '2018-01-13 10:34:49', NULL, NULL, 16057, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:34:49', 'admin-1515805892-15158108893621311', 1, 0, '', NULL, NULL, NULL),
(60391, '2018-01-13 10:34:49', NULL, NULL, 16057, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:34:49', 'admin-1515805892-15158108893621311', 1, 0, '', NULL, NULL, NULL),
(60392, '2018-01-13 10:35:26', NULL, NULL, 16058, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:35:26', 'admin-1515805892-15158109262633541', 1, 0, '', NULL, NULL, NULL),
(60393, '2018-01-13 10:35:26', NULL, NULL, 16058, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:35:26', 'admin-1515805892-15158109262633541', 1, 0, '', NULL, NULL, NULL),
(60394, '2018-01-13 10:35:13', NULL, NULL, 16058, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:35:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60395, '2018-01-13 10:04:30', NULL, NULL, 16054, 0, 153, '87', 'Wake Me Up!', 'no bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:04:30', 'admin-1515805892-15158090703882642', 1, 0, '', NULL, NULL, NULL),
(60396, '2018-01-13 09:52:11', NULL, NULL, 16053, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1515805892', 'admin', '2018-01-13 09:52:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60397, '2018-01-13 09:52:36', NULL, NULL, 16053, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 09:52:36', 'admin-1515805892-15158083561225571', 1, 0, '', NULL, NULL, NULL),
(60398, '2018-01-13 10:34:49', NULL, NULL, 16057, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:34:49', 'admin-1515805892-15158108893621311', 1, 1, 'SR', NULL, NULL, NULL),
(60399, '2018-01-13 10:34:14', NULL, NULL, 16057, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:34:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60400, '2018-01-13 10:04:30', NULL, NULL, 16054, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:04:30', 'admin-1515805892-15158090703882642', 1, 1, 'SR', NULL, NULL, NULL),
(60401, '2018-01-13 10:04:30', NULL, NULL, 16054, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:04:30', 'admin-1515805892-15158090703882642', 1, 0, '', NULL, NULL, NULL),
(60402, '2018-01-13 10:15:19', NULL, NULL, 16055, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:15:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60403, '2018-01-13 10:15:26', NULL, NULL, 16055, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:15:26', 'admin-1515805892-15158097267506918', 1, 0, '', NULL, NULL, NULL),
(60404, '2018-01-13 10:18:02', NULL, NULL, 16056, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:18:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60405, '2018-01-13 10:18:30', NULL, NULL, 16056, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:18:30', 'admin-1515805892-151580991024288', 1, 0, '', NULL, NULL, NULL),
(60406, '2018-01-13 10:18:30', NULL, NULL, 16056, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:18:30', 'admin-1515805892-151580991024288', 1, 0, '', NULL, NULL, NULL),
(60407, '2018-01-13 10:18:30', NULL, NULL, 16056, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:18:30', 'admin-1515805892-151580991024288', 1, 1, 'SR', NULL, NULL, NULL),
(60408, '2018-01-13 10:18:30', NULL, NULL, 16056, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:18:30', 'admin-1515805892-151580991024288', 1, 0, '', NULL, NULL, NULL),
(60409, '2018-01-13 10:04:30', NULL, NULL, 16054, 0, 271, '205', 'Take It Easy', 'no eggs', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:04:30', 'admin-1515805892-15158090703882642', 1, 0, '', NULL, NULL, NULL),
(60410, '2018-01-13 09:28:58', NULL, NULL, 16052, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 09:28:58', 'admin-1515805892-15158069384113553', 1, 0, '', NULL, NULL, NULL),
(60411, '2018-01-13 10:03:46', NULL, NULL, 16054, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1515805892', 'admin', '2018-01-13 10:03:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60412, '2018-01-13 09:52:36', NULL, NULL, 16053, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 09:52:36', 'admin-1515805892-15158083561225571', 1, 0, '', NULL, NULL, NULL),
(60413, '2018-01-13 09:52:36', NULL, NULL, 16053, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 09:52:36', 'admin-1515805892-15158083561225571', 1, 0, '', NULL, NULL, NULL),
(60414, '2018-01-13 09:52:36', NULL, NULL, 16053, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 09:52:36', 'admin-1515805892-15158083561225571', 1, 1, 'SR', NULL, NULL, NULL),
(60415, '2018-01-13 09:28:58', NULL, NULL, 16052, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 09:28:58', 'admin-1515805892-15158069384113553', 1, 0, '', NULL, NULL, NULL),
(60416, '2018-01-13 09:28:58', NULL, NULL, 16052, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 09:28:58', 'admin-1515805892-15158069384113553', 1, 0, '', NULL, NULL, NULL),
(60417, '2018-01-13 09:28:49', NULL, NULL, 16052, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1515805892', 'admin', '2018-01-13 09:28:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60418, '2018-01-14 15:11:35', NULL, NULL, 16121, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 15:11:35', 'admin-1515891016-15159138952142971', 1, 1, 'SR', NULL, NULL, NULL),
(60419, '2018-01-14 14:07:35', NULL, NULL, 16118, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 14:07:35', 'admin-1515891016-15159100557829777', 1, 0, '', NULL, NULL, NULL),
(60420, '2018-01-14 14:07:35', NULL, NULL, 16118, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 14:07:35', 'admin-1515891016-15159100557829777', 1, 1, 'SR', NULL, NULL, NULL),
(60421, '2018-01-14 14:07:35', NULL, NULL, 16118, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 14:07:35', 'admin-1515891016-15159100557829777', 1, 1, 'SR', NULL, NULL, NULL),
(60422, '2018-01-14 14:08:20', NULL, NULL, 16117, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 14:08:20', 'admin-1515891016-15159101002939324', 1, 0, '', NULL, NULL, NULL),
(60423, '2018-01-14 14:08:20', NULL, NULL, 16117, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 14:08:20', 'admin-1515891016-15159101002939324', 1, 0, '', NULL, NULL, NULL),
(60424, '2018-01-14 14:17:15', NULL, NULL, 16119, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1515891016', 'admin', '2018-01-14 14:17:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60425, '2018-01-14 12:31:58', NULL, NULL, 16112, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:31:58', 'admin-1515891016-1515904318185968', 1, 1, 'SR', NULL, NULL, NULL),
(60426, '2018-01-14 14:07:35', NULL, NULL, 16118, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 14:07:35', 'admin-1515891016-15159100557829777', 1, 0, '', NULL, NULL, NULL),
(60427, '2018-01-14 12:31:21', NULL, NULL, 16111, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:31:21', 'admin-1515891016-15159042814966793', 1, 0, '', NULL, NULL, NULL),
(60428, '2018-01-14 12:31:34', NULL, NULL, 16112, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:31:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60429, '2018-01-14 10:54:23', NULL, NULL, 16101, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:54:23', 'admin-1515891016-15158984631227731', 1, 0, '', NULL, NULL, NULL),
(60430, '2018-01-14 15:10:32', NULL, NULL, 16121, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1515891016', 'admin', '2018-01-14 15:10:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60431, '2018-01-14 15:03:27', NULL, NULL, 16120, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 15:03:27', 'admin-1515891016-15159134076797259', 1, 1, 'SR', NULL, NULL, NULL),
(60432, '2018-01-14 09:53:13', NULL, NULL, 16093, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:53:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60433, '2018-01-14 15:03:22', NULL, NULL, 16120, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 15:03:22', 'admin-1515891016-15159134026349488', 1, 0, '', NULL, NULL, NULL),
(60434, '2018-01-14 15:03:18', NULL, NULL, 16120, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1515891016', 'admin', '2018-01-14 15:03:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60435, '2018-01-14 14:28:41', NULL, NULL, 16117, 0, 305, '241', 'Sprite', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 14:28:41', 'admin-1515891016-15159113211023035', 1, 0, '', NULL, NULL, NULL),
(60436, '2018-01-14 14:28:41', NULL, NULL, 16117, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 14:28:41', 'admin-1515891016-15159113211023035', 1, 0, '', NULL, NULL, NULL),
(60437, '2018-01-14 13:04:59', NULL, NULL, 16115, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:04:59', 'admin-1515891016-15159062988818483', 1, 0, '', NULL, NULL, '10.0'),
(60438, '2018-01-14 12:18:21', NULL, NULL, 16108, 0, 291, '225', 'Smoked Duck Red Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:18:21', 'admin-1515891016-15159035016198465', 1, 0, '', NULL, NULL, NULL),
(60439, '2018-01-14 12:14:26', NULL, NULL, 16107, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:14:26', 'admin-1515891016-15159032660244175', 1, 1, 'SR', NULL, NULL, NULL),
(60440, '2018-01-14 12:13:55', NULL, NULL, 16107, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:13:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60441, '2018-01-14 16:34:10', NULL, NULL, 16122, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 16:34:10', 'admin-1515891016-15159188506067226', 1, 1, 'SR', NULL, NULL, NULL),
(60442, '2018-01-14 16:40:03', NULL, NULL, 16122, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 16:40:03', 'admin-1515891016-1515919203735776', 1, 0, '', NULL, NULL, NULL),
(60443, '2018-01-14 13:52:37', NULL, NULL, 16117, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:52:37', 'admin-1515891016-15159091578169120', 1, 1, 'SR', NULL, NULL, NULL),
(60444, '2018-01-14 12:23:07', NULL, NULL, 16105, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:23:07', 'admin-1515891016-1515903787318536', 1, 0, '', NULL, NULL, NULL),
(60445, '2018-01-14 12:23:33', NULL, NULL, 16109, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:23:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60446, '2018-01-14 12:24:03', NULL, NULL, 16109, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:24:03', 'admin-1515891016-15159038438299248', 1, 0, '', NULL, NULL, NULL),
(60447, '2018-01-14 12:24:03', NULL, NULL, 16109, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:24:03', 'admin-1515891016-15159038438299248', 1, 0, '', NULL, NULL, NULL),
(60448, '2018-01-14 12:24:03', NULL, NULL, 16109, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:24:03', 'admin-1515891016-15159038438299248', 1, 1, 'SR', NULL, NULL, NULL),
(60449, '2018-01-14 14:07:03', NULL, NULL, 16118, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1515891016', 'admin', '2018-01-14 14:07:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60450, '2018-01-14 14:07:35', NULL, NULL, 16118, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 14:07:35', 'admin-1515891016-15159100557829777', 1, 0, '', NULL, NULL, NULL),
(60451, '2018-01-14 13:52:38', NULL, NULL, 16117, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:52:38', 'admin-1515891016-15159091578169120', 1, 1, 'SR', NULL, NULL, NULL),
(60452, '2018-01-14 16:27:22', NULL, NULL, 16122, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 16:27:22', 'admin-1515891016-15159184428195229', 1, 1, 'SR', NULL, NULL, NULL),
(60453, '2018-01-14 11:16:01', NULL, NULL, 16102, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 15.40, 0.0000, 0.0000, 15.40, 1, '27', 1, '1515891016', 'admin', '2018-01-14 11:16:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60454, '2018-01-14 11:17:52', NULL, NULL, 16102, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 11:17:52', 'admin-1515891016-15158998722232121', 1, 0, '', NULL, NULL, NULL),
(60455, '2018-01-14 12:35:40', NULL, NULL, 16111, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:35:40', 'admin-1515891016-15159045401614153', 1, 0, '', NULL, NULL, NULL),
(60456, '2018-01-14 15:11:35', NULL, NULL, 16121, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 15:11:35', 'admin-1515891016-15159138952142971', 1, 1, 'SR', NULL, NULL, NULL),
(60457, '2018-01-14 14:17:31', NULL, NULL, 16119, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 14:17:31', 'admin-1515891016-15159106515322537', 1, 0, '', NULL, NULL, NULL),
(60458, '2018-01-14 13:21:20', NULL, NULL, 16116, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:21:20', 'admin-1515891016-15159072805806025', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(60459, '2018-01-14 13:06:41', NULL, NULL, 16112, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:06:41', 'admin-1515891016-15159064017499854', 1, 0, '', NULL, NULL, NULL),
(60460, '2018-01-14 12:50:28', NULL, NULL, 16114, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:50:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60461, '2018-01-14 13:04:59', NULL, NULL, 16115, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:04:59', 'admin-1515891016-15159062988818483', 1, 0, '', NULL, NULL, '10.0'),
(60462, '2018-01-14 12:50:48', NULL, NULL, 16114, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:50:48', 'admin-1515891016-15159054487271813', 1, 1, 'SR', NULL, NULL, NULL),
(60463, '2018-01-14 13:20:46', NULL, NULL, 16116, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:20:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60464, '2018-01-14 12:14:26', NULL, NULL, 16107, 0, 181, '116', 'Open Food ', 'chicken rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:14:26', 'admin-1515891016-15159032660244175', 1, 0, '', NULL, NULL, NULL),
(60465, '2018-01-14 12:17:00', NULL, NULL, 16108, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:17:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60466, '2018-01-14 13:04:59', NULL, NULL, 16115, 0, 181, '116', 'Open Food ', 'CKR', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:04:59', 'admin-1515891016-15159062988818483', 1, 0, '', NULL, NULL, '10.0'),
(60467, '2018-01-14 12:31:21', NULL, NULL, 16111, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:31:21', 'admin-1515891016-15159042814966793', 1, 1, 'SR', NULL, NULL, NULL),
(60468, '2018-01-14 13:52:37', NULL, NULL, 16117, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:52:37', 'admin-1515891016-15159091578169120', 1, 1, 'SR', NULL, NULL, NULL),
(60469, '2018-01-14 13:52:37', NULL, NULL, 16117, 0, 338, '274', 'Chocolate Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:52:37', 'admin-1515891016-15159091578169120', 1, 0, '', NULL, NULL, NULL),
(60470, '2018-01-14 13:52:37', NULL, NULL, 16117, 0, 324, '260', 'Blueberry Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:52:37', 'admin-1515891016-15159091578169120', 1, 0, '', NULL, NULL, NULL),
(60471, '2018-01-14 12:57:04', NULL, NULL, 16105, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:57:04', 'admin-1515891016-15159058238965314', 1, 0, '', NULL, NULL, NULL),
(60472, '2018-01-14 15:03:22', NULL, NULL, 16120, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 15:03:22', 'admin-1515891016-15159134026349488', 1, 0, '', NULL, NULL, NULL),
(60473, '2018-01-14 10:54:23', NULL, NULL, 16101, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:54:23', 'admin-1515891016-15158984631227731', 1, 1, 'SR', NULL, NULL, NULL),
(60474, '2018-01-14 12:04:27', NULL, NULL, 16105, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:04:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60475, '2018-01-14 12:04:39', NULL, NULL, 16105, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:04:39', 'admin-1515891016-15159026794874172', 1, 1, 'SR', NULL, NULL, NULL),
(60476, '2018-01-14 12:04:39', NULL, NULL, 16105, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:04:39', 'admin-1515891016-15159026794874172', 1, 1, 'SR', NULL, NULL, NULL),
(60477, '2018-01-14 12:04:39', NULL, NULL, 16105, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:04:39', 'admin-1515891016-15159026794874172', 1, 0, '', NULL, NULL, NULL),
(60478, '2018-01-14 13:52:37', NULL, NULL, 16117, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:52:37', 'admin-1515891016-15159091578169120', 1, 0, '', NULL, NULL, NULL),
(60479, '2018-01-14 13:51:16', NULL, NULL, 16117, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 13.90, 0.0000, 0.0000, 13.90, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:51:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60480, '2018-01-14 12:18:21', NULL, NULL, 16108, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:18:21', 'admin-1515891016-15159035016198465', 1, 0, '', NULL, NULL, NULL),
(60481, '2018-01-14 13:21:20', NULL, NULL, 16116, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:21:20', 'admin-1515891016-15159072805806025', 1, 1, 'SR', NULL, NULL, NULL),
(60482, '2018-01-14 13:14:18', NULL, NULL, 16106, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:14:18', 'admin-1515891016-15159068579453215', 1, 0, '', NULL, NULL, NULL),
(60483, '2018-01-14 14:17:31', NULL, NULL, 16119, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 14:17:31', 'admin-1515891016-15159106515322537', 1, 1, 'SR', NULL, NULL, NULL),
(60484, '2018-01-14 13:21:20', NULL, NULL, 16116, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:21:20', 'admin-1515891016-15159072805806025', 1, 1, 'SR', NULL, NULL, NULL),
(60485, '2018-01-14 13:21:20', NULL, NULL, 16116, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:21:20', 'admin-1515891016-15159072805806025', 1, 1, 'SR', NULL, NULL, NULL),
(60486, '2018-01-14 13:04:59', NULL, NULL, 16115, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:04:59', 'admin-1515891016-15159062988818483', 1, 1, 'SR', NULL, NULL, '10.0'),
(60487, '2018-01-14 12:31:58', NULL, NULL, 16112, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:31:58', 'admin-1515891016-1515904318185968', 1, 0, '', NULL, NULL, NULL),
(60488, '2018-01-14 12:31:58', NULL, NULL, 16112, 0, 328, '264', 'Basic Blueberries Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:31:58', 'admin-1515891016-1515904318185968', 1, 0, '', NULL, NULL, NULL),
(60489, '2018-01-14 12:21:03', NULL, NULL, 16105, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:21:03', 'admin-1515891016-15159036634236082', 1, 1, 'SR', NULL, NULL, NULL),
(60490, '2018-01-14 12:37:50', NULL, NULL, 16113, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:37:50', 'admin-1515891016-15159046704852478', 1, 0, '', NULL, NULL, NULL),
(60491, '2018-01-14 12:37:50', NULL, NULL, 16113, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:37:50', 'admin-1515891016-15159046704852478', 1, 0, '', NULL, NULL, NULL),
(60492, '2018-01-14 10:54:23', NULL, NULL, 16101, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:54:23', 'admin-1515891016-15158984631227731', 1, 0, '', NULL, NULL, NULL),
(60493, '2018-01-14 13:05:50', NULL, NULL, 16109, 0, 304, '240', 'Banana is On Fire', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:05:50', 'admin-1515891016-15159063500415466', 1, 0, '', NULL, NULL, NULL),
(60494, '2018-01-14 13:04:59', NULL, NULL, 16115, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:04:59', 'admin-1515891016-15159062988818483', 1, 1, 'SR', NULL, NULL, '10.0'),
(60495, '2018-01-14 09:53:07', NULL, NULL, 16092, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:53:07', 'admin-1515891016-1515894786922250', 1, 1, 'SR', NULL, NULL, NULL),
(60496, '2018-01-14 09:53:07', NULL, NULL, 16092, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:53:07', 'admin-1515891016-1515894786922250', 1, 1, 'SR', NULL, NULL, NULL),
(60497, '2018-01-14 13:04:59', NULL, NULL, 16115, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:04:59', 'admin-1515891016-15159062988818483', 1, 1, 'SR', NULL, NULL, '10.0'),
(60498, '2018-01-14 13:04:59', NULL, NULL, 16115, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:04:59', 'admin-1515891016-15159062988818483', 1, 0, '', NULL, NULL, '10.0'),
(60499, '2018-01-14 13:04:59', NULL, NULL, 16115, 0, 181, '116', 'Open Food ', 'CKR', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:04:59', 'admin-1515891016-15159062988818483', 1, 0, '', NULL, NULL, '10.0'),
(60500, '2018-01-14 14:17:31', NULL, NULL, 16119, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 14:17:31', 'admin-1515891016-15159106515322537', 1, 1, 'SR', NULL, NULL, NULL),
(60501, '2018-01-14 13:52:38', NULL, NULL, 16117, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:52:38', 'admin-1515891016-15159091578169120', 1, 1, 'SR', NULL, NULL, NULL),
(60502, '2018-01-14 12:50:48', NULL, NULL, 16114, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:50:48', 'admin-1515891016-15159054487271813', 1, 1, 'SR', NULL, NULL, NULL),
(60503, '2018-01-14 12:50:48', NULL, NULL, 16114, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:50:48', 'admin-1515891016-15159054487271813', 1, 0, '', NULL, NULL, NULL),
(60504, '2018-01-14 12:50:48', NULL, NULL, 16114, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:50:48', 'admin-1515891016-15159054487271813', 1, 0, '', NULL, NULL, NULL),
(60505, '2018-01-14 15:11:35', NULL, NULL, 16121, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 15:11:35', 'admin-1515891016-15159138952142971', 1, 1, 'SR', NULL, NULL, NULL),
(60506, '2018-01-14 12:42:58', NULL, NULL, 16106, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:42:58', 'admin-1515891016-15159049785338531', 1, 0, '', NULL, NULL, NULL),
(60507, '2018-01-14 12:37:22', NULL, NULL, 16113, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:37:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60508, '2018-01-14 11:49:22', NULL, NULL, 16104, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 11:49:22', 'admin-1515891016-15159017620973922', 1, 0, '', NULL, NULL, NULL),
(60509, '2018-01-14 11:17:52', NULL, NULL, 16102, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 11:17:52', 'admin-1515891016-15158998722232121', 1, 0, '', NULL, NULL, NULL),
(60510, '2018-01-14 12:35:40', NULL, NULL, 16111, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:35:40', 'admin-1515891016-15159045401614153', 1, 0, '', NULL, NULL, NULL),
(60511, '2018-01-14 12:31:21', NULL, NULL, 16111, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:31:21', 'admin-1515891016-15159042814966793', 1, 1, 'SR', NULL, NULL, NULL),
(60512, '2018-01-14 11:51:22', NULL, NULL, 16102, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 11:51:22', 'admin-1515891016-15159018821469841', 1, 0, '', NULL, NULL, NULL),
(60513, '2018-01-14 10:09:57', NULL, NULL, 16096, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:09:57', 'admin-1515891016-1515895797524673', 1, 1, 'SR', NULL, NULL, NULL),
(60514, '2018-01-14 10:13:52', NULL, NULL, 16097, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:13:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60515, '2018-01-14 12:31:58', NULL, NULL, 16112, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:31:58', 'admin-1515891016-1515904318185968', 1, 1, 'SR', NULL, NULL, NULL),
(60516, '2018-01-14 12:30:54', NULL, NULL, 16111, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:30:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60517, '2018-01-14 12:29:41', NULL, NULL, 16110, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:29:41', 'admin-1515891016-15159041815661212', 1, 0, '', NULL, NULL, NULL),
(60518, '2018-01-14 12:29:41', NULL, NULL, 16110, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:29:41', 'admin-1515891016-15159041815661212', 1, 0, '', NULL, NULL, NULL),
(60519, '2018-01-14 12:29:41', NULL, NULL, 16110, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:29:41', 'admin-1515891016-15159041815661212', 1, 1, 'SR', NULL, NULL, NULL),
(60520, '2018-01-14 12:28:50', NULL, NULL, 16110, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:28:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60521, '2018-01-14 12:29:41', NULL, NULL, 16110, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:29:41', 'admin-1515891016-15159041815661212', 1, 0, '', NULL, NULL, NULL),
(60522, '2018-01-14 12:29:41', NULL, NULL, 16110, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:29:41', 'admin-1515891016-15159041815661212', 1, 0, '', NULL, NULL, NULL),
(60523, '2018-01-14 12:29:41', NULL, NULL, 16110, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:29:41', 'admin-1515891016-15159041815661212', 1, 0, '', NULL, NULL, NULL),
(60524, '2018-01-14 15:11:35', NULL, NULL, 16121, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 15:11:35', 'admin-1515891016-15159138952142971', 1, 1, 'SR', NULL, NULL, NULL),
(60525, '2018-01-14 13:52:37', NULL, NULL, 16117, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:52:37', 'admin-1515891016-15159091578169120', 1, 1, 'SR', NULL, NULL, NULL),
(60526, '2018-01-14 12:18:21', NULL, NULL, 16108, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:18:21', 'admin-1515891016-15159035016198465', 1, 1, 'SR', NULL, NULL, NULL),
(60527, '2018-01-14 11:17:52', NULL, NULL, 16102, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 11:17:52', 'admin-1515891016-15158998722232121', 1, 0, '', NULL, NULL, NULL),
(60528, '2018-01-14 11:17:52', NULL, NULL, 16102, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 11:17:52', 'admin-1515891016-15158998722232121', 1, 0, '', NULL, NULL, NULL),
(60529, '2018-01-14 11:17:52', NULL, NULL, 16102, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 11:17:52', 'admin-1515891016-15158998722232121', 1, 0, '', NULL, NULL, NULL),
(60530, '2018-01-14 16:27:18', NULL, NULL, 16122, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1515891016', 'admin', '2018-01-14 16:27:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60531, '2018-01-14 10:14:11', NULL, NULL, 16097, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:14:11', 'admin-1515891016-15158960509072033', 1, 1, 'SR', NULL, NULL, NULL),
(60532, '2018-01-14 11:17:52', NULL, NULL, 16102, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 11:17:52', 'admin-1515891016-15158998722232121', 1, 1, 'SR', NULL, NULL, NULL),
(60533, '2018-01-14 11:28:22', NULL, NULL, 16103, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 11:28:22', 'admin-1515891016-15159005024549120', 1, 1, 'SR', 1, NULL, NULL),
(60534, '2018-01-14 11:49:03', NULL, NULL, 16104, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1515891016', 'admin', '2018-01-14 11:49:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60535, '2018-01-14 12:18:21', NULL, NULL, 16108, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:18:21', 'admin-1515891016-15159035016198465', 1, 1, 'SR', NULL, NULL, NULL),
(60536, '2018-01-14 12:21:03', NULL, NULL, 16105, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:21:03', 'admin-1515891016-15159036634236082', 1, 0, '', NULL, NULL, NULL),
(60537, '2018-01-14 12:18:21', NULL, NULL, 16108, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:18:21', 'admin-1515891016-15159035016198465', 1, 1, 'SR', NULL, NULL, NULL),
(60538, '2018-01-14 13:04:15', NULL, NULL, 16115, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 11.00, 0.0000, 0.0000, 11.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 13:04:15', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(60539, '2018-01-14 10:09:57', NULL, NULL, 16096, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:09:57', 'admin-1515891016-1515895797524673', 1, 0, '', NULL, NULL, NULL),
(60540, '2018-01-14 10:09:57', NULL, NULL, 16096, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:09:57', 'admin-1515891016-1515895797524673', 1, 0, '', NULL, NULL, NULL),
(60541, '2018-01-14 10:09:57', NULL, NULL, 16096, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:09:57', 'admin-1515891016-1515895797524673', 1, 1, 'SR', NULL, NULL, NULL),
(60542, '2018-01-14 15:11:35', NULL, NULL, 16121, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 15:11:35', 'admin-1515891016-15159138952142971', 1, 1, 'SR', NULL, NULL, NULL),
(60543, '2018-01-14 11:49:22', NULL, NULL, 16104, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 11:49:22', 'admin-1515891016-15159017620973922', 1, 1, 'SR', NULL, NULL, NULL),
(60544, '2018-01-14 10:30:25', NULL, NULL, 16098, 0, 271, '205', 'Take It Easy', 'sunny side up egg', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:30:25', 'admin-1515891016-15158970254263592', 1, 0, '', NULL, NULL, NULL),
(60545, '2018-01-14 10:30:25', NULL, NULL, 16098, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:30:25', 'admin-1515891016-15158970254263592', 1, 0, '', NULL, NULL, NULL),
(60546, '2018-01-14 10:30:25', NULL, NULL, 16098, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:30:25', 'admin-1515891016-15158970254263592', 1, 1, 'SR', NULL, NULL, NULL),
(60547, '2018-01-14 12:14:26', NULL, NULL, 16107, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:14:26', 'admin-1515891016-15159032660244175', 1, 1, 'SR', NULL, NULL, NULL),
(60548, '2018-01-14 12:05:20', NULL, NULL, 16106, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:05:20', 'admin-1515891016-1515902719924151', 1, 0, '', NULL, NULL, NULL),
(60549, '2018-01-14 12:05:20', NULL, NULL, 16106, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:05:20', 'admin-1515891016-1515902719924151', 1, 0, '', NULL, NULL, NULL),
(60550, '2018-01-14 12:05:20', NULL, NULL, 16106, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:05:20', 'admin-1515891016-1515902719924151', 1, 0, '', NULL, NULL, NULL),
(60551, '2018-01-14 12:04:39', NULL, NULL, 16105, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:04:39', 'admin-1515891016-15159026794874172', 1, 0, '', NULL, NULL, NULL),
(60552, '2018-01-14 12:04:54', NULL, NULL, 16106, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.20, 0.0000, 0.0000, 10.20, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:04:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60553, '2018-01-14 11:51:22', NULL, NULL, 16102, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 11:51:22', 'admin-1515891016-15159018821469841', 1, 1, 'SR', NULL, NULL, NULL),
(60554, '2018-01-14 10:53:14', NULL, NULL, 16100, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:53:14', 'admin-1515891016-15158983941928392', 1, 0, '', NULL, NULL, NULL),
(60555, '2018-01-14 09:53:21', NULL, NULL, 16093, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:53:21', 'admin-1515891016-15158948015518521', 1, 1, 'SR', NULL, NULL, NULL),
(60556, '2018-01-14 11:17:52', NULL, NULL, 16102, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 11:17:52', 'admin-1515891016-15158998722232121', 1, 0, '', NULL, NULL, NULL),
(60557, '2018-01-14 11:17:52', NULL, NULL, 16102, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 11:17:52', 'admin-1515891016-15158998722232121', 1, 0, '', NULL, NULL, NULL),
(60558, '2018-01-14 10:54:23', NULL, NULL, 16101, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:54:23', 'admin-1515891016-15158984631227731', 1, 1, 'SR', NULL, NULL, NULL),
(60559, '2018-01-14 10:54:23', NULL, NULL, 16101, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:54:23', 'admin-1515891016-15158984631227731', 1, 1, 'SR', NULL, NULL, NULL),
(60560, '2018-01-14 10:54:23', NULL, NULL, 16101, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:54:23', 'admin-1515891016-15158984631227731', 1, 0, '', NULL, NULL, NULL),
(60561, '2018-01-14 10:52:53', NULL, NULL, 16100, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:52:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60562, '2018-01-14 10:53:27', NULL, NULL, 16101, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:53:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60563, '2018-01-14 10:53:14', NULL, NULL, 16100, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:53:14', 'admin-1515891016-15158983941928392', 1, 0, '', NULL, NULL, NULL),
(60564, '2018-01-14 12:35:40', NULL, NULL, 16111, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:35:40', 'admin-1515891016-15159045401614153', 1, 0, '', NULL, NULL, NULL),
(60565, '2018-01-14 10:48:31', NULL, NULL, 16099, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:48:31', 'admin-1515891016-15158981116906979', 1, 1, 'SR', 1, NULL, NULL),
(60566, '2018-01-14 10:07:45', NULL, NULL, 16095, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:07:45', 'admin-1515891016-15158956656601940', 1, 0, '', NULL, NULL, NULL),
(60567, '2018-01-14 10:07:45', NULL, NULL, 16095, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:07:45', 'admin-1515891016-15158956656601940', 1, 0, '', NULL, NULL, NULL),
(60568, '2018-01-14 12:42:58', NULL, NULL, 16106, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 12:42:58', 'admin-1515891016-15159049785338531', 1, 0, '', NULL, NULL, NULL),
(60569, '2018-01-14 10:29:43', NULL, NULL, 16098, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:29:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60570, '2018-01-14 10:14:11', NULL, NULL, 16097, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:14:11', 'admin-1515891016-15158960509072033', 1, 1, 'SR', NULL, NULL, NULL),
(60571, '2018-01-14 10:14:11', NULL, NULL, 16097, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:14:11', 'admin-1515891016-15158960509072033', 1, 0, '', NULL, NULL, NULL),
(60572, '2018-01-14 10:09:34', NULL, NULL, 16096, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:09:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60573, '2018-01-14 09:37:26', NULL, NULL, 16091, 0, 331, '267', 'Yuzu Marmalade Pancake', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:37:26', 'admin-1515891016-15158938458825062', 1, 0, '', NULL, NULL, NULL),
(60574, '2018-01-14 09:37:26', NULL, NULL, 16091, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:37:26', 'admin-1515891016-15158938458825062', 1, 1, 'SR', NULL, NULL, NULL),
(60575, '2018-01-14 09:48:49', NULL, NULL, 16090, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:48:49', 'admin-1515891016-15158945291649619', 1, 0, '', NULL, NULL, NULL),
(60576, '2018-01-14 10:14:11', NULL, NULL, 16097, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:14:11', 'admin-1515891016-15158960509072033', 1, 0, '', NULL, NULL, NULL),
(60577, '2018-01-14 10:07:45', NULL, NULL, 16095, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:07:45', 'admin-1515891016-15158956656601940', 1, 1, 'SR', NULL, NULL, NULL),
(60578, '2018-01-14 10:07:45', NULL, NULL, 16095, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:07:45', 'admin-1515891016-15158956656601940', 1, 1, 'SR', NULL, NULL, NULL),
(60579, '2018-01-14 10:05:23', NULL, NULL, 16094, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:05:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60580, '2018-01-14 10:05:58', NULL, NULL, 16094, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:05:58', 'admin-1515891016-15158955584669137', 1, 1, 'SR', NULL, NULL, NULL),
(60581, '2018-01-14 09:37:26', NULL, NULL, 16091, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:37:26', 'admin-1515891016-15158938458825062', 1, 0, '', NULL, NULL, NULL),
(60582, '2018-01-14 10:05:58', NULL, NULL, 16094, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:05:58', 'admin-1515891016-15158955584669137', 1, 0, '', NULL, NULL, NULL),
(60583, '2018-01-14 10:05:58', NULL, NULL, 16094, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:05:58', 'admin-1515891016-15158955584669137', 1, 0, '', NULL, NULL, NULL),
(60584, '2018-01-14 09:34:20', NULL, NULL, 16090, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:34:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60585, '2018-01-14 09:34:34', NULL, NULL, 16090, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:34:34', 'admin-1515891016-15158936738717994', 1, 0, '', NULL, NULL, NULL),
(60586, '2018-01-14 09:34:34', NULL, NULL, 16090, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:34:34', 'admin-1515891016-15158936738717994', 1, 0, '', NULL, NULL, NULL),
(60587, '2018-01-14 09:34:34', NULL, NULL, 16090, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:34:34', 'admin-1515891016-15158936738717994', 1, 1, 'SR', NULL, NULL, NULL),
(60588, '2018-01-14 09:35:56', NULL, NULL, 16091, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:35:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60589, '2018-01-14 09:37:26', NULL, NULL, 16091, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:37:26', 'admin-1515891016-15158938458825062', 1, 0, '', NULL, NULL, NULL),
(60590, '2018-01-14 09:53:07', NULL, NULL, 16092, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:53:07', 'admin-1515891016-1515894786922250', 1, 0, '', NULL, NULL, NULL),
(60591, '2018-01-14 09:53:07', NULL, NULL, 16092, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:53:07', 'admin-1515891016-1515894786922250', 1, 0, '', NULL, NULL, NULL),
(60592, '2018-01-14 10:07:21', NULL, NULL, 16095, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1515891016', 'admin', '2018-01-14 10:07:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60593, '2018-01-14 09:52:37', NULL, NULL, 16092, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:52:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60594, '2018-01-14 09:37:26', NULL, NULL, 16091, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:37:26', 'admin-1515891016-15158938458825062', 1, 0, '', NULL, NULL, NULL),
(60595, '2018-01-14 09:17:13', NULL, NULL, 16089, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:17:13', 'admin-1515891016-15158926330398666', 1, 0, '', NULL, NULL, NULL),
(60596, '2018-01-14 09:17:13', NULL, NULL, 16089, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:17:13', 'admin-1515891016-15158926330398666', 1, 1, 'SR', NULL, NULL, NULL),
(60597, '2018-01-14 09:17:13', NULL, NULL, 16089, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:17:13', 'admin-1515891016-15158926330398666', 1, 0, '', NULL, NULL, NULL),
(60598, '2018-01-14 09:17:13', NULL, NULL, 16089, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:17:13', 'admin-1515891016-15158926330398666', 1, 0, '', NULL, NULL, NULL),
(60599, '2018-01-14 09:17:13', NULL, NULL, 16089, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:17:13', 'admin-1515891016-15158926330398666', 1, 0, '', NULL, NULL, NULL),
(60600, '2018-01-14 09:17:13', NULL, NULL, 16089, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:17:13', 'admin-1515891016-15158926330398666', 1, 0, '', NULL, NULL, NULL),
(60601, '2018-01-14 09:16:39', NULL, NULL, 16089, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1515891016', 'admin', '2018-01-14 09:16:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60602, '2018-01-15 14:48:34', NULL, NULL, 16141, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 14:48:34', 'admin-1515978481-15159989141663819', 1, 0, '', NULL, NULL, NULL),
(60603, '2018-01-15 13:11:15', NULL, NULL, 16137, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 13:11:15', 'admin-1515978481-15159930757352774', 1, 0, '', NULL, NULL, NULL),
(60604, '2018-01-15 16:00:59', NULL, NULL, 16142, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 2, 13.00, 26.0000, 0.0000, 26.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 16:00:59', 'admin-1515978481-15160032588939811', 1, 1, 'SR', NULL, NULL, NULL),
(60605, '2018-01-15 16:00:54', NULL, NULL, 16142, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1515978481', 'admin', '2018-01-15 16:00:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60606, '2018-01-15 10:30:54', NULL, NULL, 16127, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:30:54', 'admin-1515978481-15159834544233885', 1, 1, 'SR', NULL, NULL, NULL),
(60607, '2018-01-15 10:32:54', NULL, NULL, 16128, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:32:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60608, '2018-01-15 10:33:30', NULL, NULL, 16128, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:33:30', 'admin-1515978481-15159836103464410', 1, 0, '', NULL, NULL, NULL),
(60609, '2018-01-15 13:11:15', NULL, NULL, 16137, 0, 181, '116', 'Open Food ', 'chicken rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 13:11:15', 'admin-1515978481-15159930757352774', 1, 0, '', NULL, NULL, NULL),
(60610, '2018-01-15 14:33:54', NULL, NULL, 16140, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1515978481', 'admin', '2018-01-15 14:33:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60611, '2018-01-15 14:14:17', NULL, NULL, 16139, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 14:14:17', 'admin-1515978481-15159968569345698', 1, 1, 'SR', NULL, NULL, NULL),
(60612, '2018-01-15 10:34:49', NULL, NULL, 16129, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:34:49', 'admin-1515978481-15159836888972747', 1, 0, '', NULL, NULL, NULL),
(60613, '2018-01-15 13:38:03', NULL, NULL, 16138, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 13:38:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60614, '2018-01-15 12:14:26', NULL, NULL, 16133, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 17.10, 0.0000, 0.0000, 17.10, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:14:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60615, '2018-01-15 12:22:00', NULL, NULL, 16134, 0, 181, '116', 'Open Food ', 'chicken rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:22:00', 'admin-1515978481-15159901198827856', 1, 0, '', NULL, NULL, NULL),
(60616, '2018-01-15 12:22:00', NULL, NULL, 16134, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:22:00', 'admin-1515978481-15159901198827856', 1, 0, '', NULL, NULL, NULL),
(60617, '2018-01-15 12:22:00', NULL, NULL, 16134, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:22:00', 'admin-1515978481-15159901198827856', 1, 1, 'SR', NULL, NULL, NULL),
(60618, '2018-01-15 13:31:31', NULL, NULL, 16135, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 13:31:31', 'admin-1515978481-15159942909861391', 1, 0, '', NULL, NULL, NULL),
(60619, '2018-01-15 14:48:34', NULL, NULL, 16141, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 14:48:34', 'admin-1515978481-15159989141663819', 1, 0, '', NULL, NULL, NULL),
(60620, '2018-01-15 14:48:34', NULL, NULL, 16141, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 14:48:34', 'admin-1515978481-15159989141663819', 1, 1, 'SR', NULL, NULL, NULL),
(60621, '2018-01-15 11:56:33', NULL, NULL, 16131, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 11:56:33', 'admin-1515978481-1515988592830363', 1, 1, 'SR', NULL, NULL, NULL),
(60622, '2018-01-15 12:23:21', NULL, NULL, 16133, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:23:21', 'admin-1515978481-15159902010652189', 1, 0, '', NULL, NULL, NULL),
(60623, '2018-01-15 13:38:47', NULL, NULL, 16138, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 13:38:47', 'admin-1515978481-15159947271676985', 1, 1, 'SR', NULL, NULL, NULL),
(60624, '2018-01-15 13:38:47', NULL, NULL, 16138, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 13:38:47', 'admin-1515978481-15159947271676985', 1, 1, 'SR', NULL, NULL, NULL),
(60625, '2018-01-15 12:23:21', NULL, NULL, 16133, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:23:21', 'admin-1515978481-15159902010652189', 1, 0, '', NULL, NULL, NULL),
(60626, '2018-01-15 12:29:03', NULL, NULL, 16133, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:29:03', 'admin-1515978481-15159905438241059', 1, 0, '', NULL, NULL, NULL),
(60627, '2018-01-15 11:56:33', NULL, NULL, 16131, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 11:56:33', 'admin-1515978481-1515988592830363', 1, 0, '', NULL, NULL, NULL),
(60628, '2018-01-15 10:34:49', NULL, NULL, 16129, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:34:49', 'admin-1515978481-15159836888972747', 1, 1, 'SR', NULL, NULL, NULL),
(60629, '2018-01-15 14:55:32', NULL, NULL, 16140, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 14:55:32', 'admin-1515978481-15159993323381232', 1, 1, 'SR', NULL, NULL, NULL),
(60630, '2018-01-15 14:48:34', NULL, NULL, 16141, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 14:48:34', 'admin-1515978481-15159989141663819', 1, 1, 'SR', NULL, NULL, NULL),
(60631, '2018-01-15 14:48:34', NULL, NULL, 16141, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 14:48:34', 'admin-1515978481-15159989141663819', 1, 1, 'SR', NULL, NULL, NULL),
(60632, '2018-01-15 14:48:08', NULL, NULL, 16141, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1515978481', 'admin', '2018-01-15 14:48:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60633, '2018-01-15 14:33:58', NULL, NULL, 16140, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 14:33:58', 'admin-1515978481-15159980385686842', 1, 1, 'SR', NULL, NULL, NULL),
(60634, '2018-01-15 13:38:47', NULL, NULL, 16138, 0, 302, '238', 'Ice on the cake', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 13:38:47', 'admin-1515978481-15159947271676985', 1, 0, '', NULL, NULL, NULL),
(60635, '2018-01-15 11:56:33', NULL, NULL, 16131, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 11:56:33', 'admin-1515978481-1515988592830363', 1, 0, '', NULL, NULL, NULL),
(60636, '2018-01-15 11:56:33', NULL, NULL, 16131, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 11:56:33', 'admin-1515978481-1515988592830363', 1, 0, '', NULL, NULL, NULL),
(60637, '2018-01-15 11:56:33', NULL, NULL, 16131, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 11:56:33', 'admin-1515978481-1515988592830363', 1, 0, '', NULL, NULL, NULL),
(60638, '2018-01-15 13:11:15', NULL, NULL, 16137, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 13:11:15', 'admin-1515978481-15159930757352774', 1, 1, 'SR', NULL, NULL, NULL),
(60639, '2018-01-15 13:18:46', NULL, NULL, 16133, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 13:18:46', 'admin-1515978481-15159935264784198', 1, 0, '', NULL, NULL, NULL),
(60640, '2018-01-15 13:10:34', NULL, NULL, 16137, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1515978481', 'admin', '2018-01-15 13:10:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60641, '2018-01-15 12:57:32', NULL, NULL, 16136, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:57:32', 'admin-1515978481-15159922519025028', 1, 1, 'SR', NULL, NULL, NULL),
(60642, '2018-01-15 12:57:32', NULL, NULL, 16136, 0, 181, '116', 'Open Food ', 'chicken rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:57:32', 'admin-1515978481-15159922519025028', 1, 0, '', NULL, NULL, NULL),
(60643, '2018-01-15 12:34:14', NULL, NULL, 16135, 0, 335, '271', 'Iced Honey Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:34:14', 'admin-1515978481-15159908540039440', 1, 0, '', NULL, NULL, NULL),
(60644, '2018-01-15 12:57:17', NULL, NULL, 16136, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:57:17', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(60645, '2018-01-15 12:35:29', NULL, NULL, 16132, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:35:29', 'admin-1515978481-15159909295466034', 1, 1, 'SR', NULL, NULL, NULL),
(60646, '2018-01-15 12:35:29', NULL, NULL, 16132, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:35:29', 'admin-1515978481-15159909295466034', 1, 1, 'SR', NULL, NULL, NULL),
(60647, '2018-01-15 12:33:47', NULL, NULL, 16135, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:33:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60648, '2018-01-15 12:34:14', NULL, NULL, 16135, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:34:14', 'admin-1515978481-15159908540039440', 1, 0, '', NULL, NULL, NULL),
(60649, '2018-01-15 12:32:16', NULL, NULL, 16133, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:32:16', 'admin-1515978481-15159907359091958', 1, 0, '', NULL, NULL, NULL),
(60650, '2018-01-15 12:32:16', NULL, NULL, 16133, 0, 181, '116', 'Open Food ', 'chicken rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:32:16', 'admin-1515978481-15159907359091958', 1, 0, '', NULL, NULL, NULL),
(60651, '2018-01-15 12:23:21', NULL, NULL, 16133, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:23:21', 'admin-1515978481-15159902010652189', 1, 0, '', NULL, NULL, NULL),
(60652, '2018-01-15 12:23:21', NULL, NULL, 16133, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:23:21', 'admin-1515978481-15159902010652189', 1, 0, '', NULL, NULL, NULL),
(60653, '2018-01-15 12:21:19', NULL, NULL, 16134, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:21:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60654, '2018-01-15 12:22:00', NULL, NULL, 16134, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:22:00', 'admin-1515978481-15159901198827856', 1, 0, '', NULL, NULL, NULL),
(60655, '2018-01-15 12:18:01', NULL, NULL, 16133, 0, 337, '273', 'Hot yuzu', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:18:01', 'admin-1515978481-1515989881595437', 1, 0, '', NULL, NULL, NULL),
(60656, '2018-01-15 12:15:22', NULL, NULL, 16133, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:15:22', 'admin-1515978481-15159897220426255', 1, 0, '', NULL, NULL, NULL),
(60657, '2018-01-15 12:18:01', NULL, NULL, 16133, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:18:01', 'admin-1515978481-1515989881595437', 1, 1, 'SR', NULL, NULL, NULL),
(60658, '2018-01-15 12:15:22', NULL, NULL, 16133, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 12:15:22', 'admin-1515978481-15159897220426255', 1, 0, '', NULL, NULL, NULL),
(60659, '2018-01-15 11:56:33', NULL, NULL, 16131, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 11:56:33', 'admin-1515978481-1515988592830363', 1, 1, 'SR', NULL, NULL, NULL),
(60660, '2018-01-15 10:33:30', NULL, NULL, 16128, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:33:30', 'admin-1515978481-15159836103464410', 1, 0, '', NULL, NULL, NULL),
(60661, '2018-01-15 10:34:20', NULL, NULL, 16129, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:34:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60662, '2018-01-15 11:56:33', NULL, NULL, 16131, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 11:56:33', 'admin-1515978481-1515988592830363', 1, 1, 'SR', NULL, NULL, NULL),
(60663, '2018-01-15 11:54:22', NULL, NULL, 16132, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 11:54:22', 'admin-1515978481-1515988462826311', 1, 0, '', NULL, NULL, NULL),
(60664, '2018-01-15 11:54:22', NULL, NULL, 16132, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 11:54:22', 'admin-1515978481-1515988462826311', 1, 1, 'SR', NULL, NULL, NULL),
(60665, '2018-01-15 11:56:33', NULL, NULL, 16131, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 11:56:33', 'admin-1515978481-1515988592830363', 1, 0, '', NULL, NULL, NULL),
(60666, '2018-01-15 10:30:54', NULL, NULL, 16127, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:30:54', 'admin-1515978481-15159834544233885', 1, 0, '', NULL, NULL, NULL),
(60667, '2018-01-15 10:30:54', NULL, NULL, 16127, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:30:54', 'admin-1515978481-15159834544233885', 1, 0, '', NULL, NULL, NULL),
(60668, '2018-01-15 10:30:54', NULL, NULL, 16127, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:30:54', 'admin-1515978481-15159834544233885', 1, 1, 'SR', NULL, NULL, NULL),
(60669, '2018-01-15 11:54:23', NULL, NULL, 16132, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 11:54:23', 'admin-1515978481-1515988462826311', 1, 1, 'SR', NULL, NULL, NULL),
(60670, '2018-01-15 11:54:02', NULL, NULL, 16132, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1515978481', 'admin', '2018-01-15 11:54:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60671, '2018-01-15 11:54:22', NULL, NULL, 16132, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 11:54:22', 'admin-1515978481-1515988462826311', 1, 0, '', NULL, NULL, NULL),
(60672, '2018-01-15 11:49:03', NULL, NULL, 16131, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 13.70, 0.0000, 0.0000, 13.70, 1, '27', 1, '1515978481', 'admin', '2018-01-15 11:49:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60673, '2018-01-15 10:34:49', NULL, NULL, 16129, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:34:49', 'admin-1515978481-15159836888972747', 1, 1, 'SR', NULL, NULL, NULL),
(60674, '2018-01-15 10:38:00', NULL, NULL, 16130, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:38:00', 'admin-1515978481-15159838800147336', 1, 1, 'SR', 1, NULL, NULL),
(60675, '2018-01-15 10:30:54', NULL, NULL, 16127, 0, 153, '87', 'Wake Me Up!', 'sunny side up egg', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:30:54', 'admin-1515978481-15159834544233885', 1, 0, '', NULL, NULL, NULL),
(60676, '2018-01-15 10:02:50', NULL, NULL, 16125, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:02:50', 'admin-1515978481-15159817707437031', 1, 0, '', NULL, NULL, NULL),
(60677, '2018-01-15 10:02:50', NULL, NULL, 16125, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:02:50', 'admin-1515978481-15159817707437031', 1, 0, '', NULL, NULL, NULL),
(60678, '2018-01-15 10:02:50', NULL, NULL, 16125, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:02:50', 'admin-1515978481-15159817707437031', 1, 0, '', NULL, NULL, NULL),
(60679, '2018-01-15 10:24:11', NULL, NULL, 16126, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:24:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60680, '2018-01-15 10:24:32', NULL, NULL, 16126, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:24:32', 'admin-1515978481-1515983072010610', 1, 0, '', NULL, NULL, NULL),
(60681, '2018-01-15 10:24:32', NULL, NULL, 16126, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:24:32', 'admin-1515978481-1515983072010610', 1, 0, '', NULL, NULL, NULL),
(60682, '2018-01-15 10:24:32', NULL, NULL, 16126, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:24:32', 'admin-1515978481-1515983072010610', 1, 1, 'SR', NULL, NULL, NULL),
(60683, '2018-01-15 10:29:52', NULL, NULL, 16127, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:29:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60684, '2018-01-15 10:34:49', NULL, NULL, 16129, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:34:49', 'admin-1515978481-15159836888972747', 1, 1, 'SR', NULL, NULL, NULL),
(60685, '2018-01-15 10:34:49', NULL, NULL, 16129, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:34:49', 'admin-1515978481-15159836888972747', 1, 0, '', NULL, NULL, NULL),
(60686, '2018-01-15 09:08:24', NULL, NULL, 16123, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 09:08:24', 'admin-1515978481-15159785042663246', 1, 1, 'SR', NULL, NULL, NULL),
(60687, '2018-01-15 10:02:50', NULL, NULL, 16125, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:02:50', 'admin-1515978481-15159817707437031', 1, 0, '', NULL, NULL, NULL),
(60688, '2018-01-15 09:12:17', NULL, NULL, 16124, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 09:12:17', 'admin-1515978481-1515978737070203', 1, 1, 'SR', NULL, NULL, NULL),
(60689, '2018-01-15 09:39:46', NULL, NULL, 16124, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 09:39:46', 'admin-1515978481-15159803868245110', 1, 0, '', NULL, NULL, NULL),
(60690, '2018-01-15 10:01:22', NULL, NULL, 16125, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1515978481', 'admin', '2018-01-15 10:01:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60691, '2018-01-15 09:12:14', NULL, NULL, 16124, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1515978481', 'admin', '2018-01-15 09:12:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60692, '2018-01-15 09:08:24', NULL, NULL, 16123, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1515978481', 'admin', '2018-01-15 09:08:24', 'admin-1515978481-15159785042663246', 1, 0, '', NULL, NULL, NULL),
(60693, '2018-01-15 09:08:14', NULL, NULL, 16123, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1515978481', 'admin', '2018-01-15 09:08:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60694, '2018-01-17 13:34:42', NULL, NULL, 16155, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:34:42', 'admin-1516151174-15161672819088111', 1, 1, 'SR', NULL, NULL, NULL),
(60695, '2018-01-17 13:35:02', NULL, NULL, 16156, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:35:02', 'admin-1516151174-15161673028129328', 1, 1, 'SR', NULL, NULL, NULL),
(60696, '2018-01-17 13:00:41', NULL, NULL, 16154, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:00:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60697, '2018-01-17 13:01:13', NULL, NULL, 16154, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:01:13', 'admin-1516151174-15161652735279154', 1, 0, '', NULL, NULL, NULL),
(60698, '2018-01-17 14:01:24', NULL, NULL, 16161, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 14:01:24', 'admin-1516151174-15161688841167098', 1, 1, 'SR', 1, NULL, NULL),
(60699, '2018-01-17 14:05:29', NULL, NULL, 16162, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1516151174', 'admin', '2018-01-17 14:05:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60700, '2018-01-17 11:10:52', NULL, NULL, 16145, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 11:10:52', 'admin-1516151174-15161586522372946', 1, 0, '', NULL, NULL, NULL),
(60701, '2018-01-17 12:56:45', NULL, NULL, 16153, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.80, 0.0000, 0.0000, 9.80, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:56:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60702, '2018-01-17 12:57:42', NULL, NULL, 16153, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:57:42', 'admin-1516151174-1516165062384916', 1, 0, '', NULL, NULL, NULL),
(60703, '2018-01-17 12:57:42', NULL, NULL, 16153, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:57:42', 'admin-1516151174-1516165062384916', 1, 0, '', NULL, NULL, NULL),
(60704, '2018-01-17 12:57:42', NULL, NULL, 16153, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:57:42', 'admin-1516151174-1516165062384916', 1, 0, '', NULL, NULL, NULL),
(60705, '2018-01-17 12:57:42', NULL, NULL, 16153, 0, 304, '240', 'Banana is On Fire', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:57:42', 'admin-1516151174-1516165062384916', 1, 0, '', NULL, NULL, NULL),
(60706, '2018-01-17 12:43:01', NULL, NULL, 16151, 0, 181, '116', 'Open Food ', 'mushroom noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:43:01', 'admin-1516151174-1516164181220218', 1, 0, '', NULL, NULL, NULL),
(60707, '2018-01-17 13:01:13', NULL, NULL, 16154, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:01:13', 'admin-1516151174-15161652735279154', 1, 1, 'SR', NULL, NULL, NULL),
(60708, '2018-01-17 13:37:12', NULL, NULL, 16157, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:37:12', 'admin-1516151174-1516167432113515', 1, 0, '', 1, NULL, NULL),
(60709, '2018-01-17 14:32:33', NULL, NULL, 16163, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 14:32:33', 'admin-1516151174-15161707531132768', 1, 0, '', NULL, NULL, NULL),
(60710, '2018-01-17 14:32:29', NULL, NULL, 16163, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1516151174', 'admin', '2018-01-17 14:32:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60711, '2018-01-17 14:05:42', NULL, NULL, 16162, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 14:05:42', 'admin-1516151174-15161691425371177', 1, 1, 'SR', NULL, NULL, NULL),
(60712, '2018-01-17 13:34:49', NULL, NULL, 16156, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:34:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60713, '2018-01-17 14:05:42', NULL, NULL, 16162, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 14:05:42', 'admin-1516151174-15161691425371177', 1, 0, '', NULL, NULL, NULL),
(60714, '2018-01-17 12:49:48', NULL, NULL, 16152, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:49:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60715, '2018-01-17 13:55:18', NULL, NULL, 16158, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:55:18', 'admin-1516151174-1516168518798543', 1, 1, 'SR', NULL, NULL, NULL),
(60716, '2018-01-17 13:35:02', NULL, NULL, 16156, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:35:02', 'admin-1516151174-15161673028129328', 1, 1, 'SR', NULL, NULL, NULL),
(60717, '2018-01-17 13:55:18', NULL, NULL, 16158, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:55:18', 'admin-1516151174-1516168518798543', 1, 0, '', NULL, NULL, NULL),
(60718, '2018-01-17 13:10:33', NULL, NULL, 16153, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:10:33', 'admin-1516151174-15161658337108581', 1, 0, '', NULL, NULL, NULL),
(60719, '2018-01-17 12:28:35', NULL, NULL, 16150, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:28:35', 'admin-1516151174-15161633152871327', 1, 1, 'SR', NULL, NULL, NULL),
(60720, '2018-01-17 12:23:23', NULL, NULL, 16149, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:23:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60721, '2018-01-17 13:33:56', NULL, NULL, 16155, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:33:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60722, '2018-01-17 13:55:13', NULL, NULL, 16158, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:55:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60723, '2018-01-17 13:34:42', NULL, NULL, 16155, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:34:42', 'admin-1516151174-15161672819088111', 1, 1, 'SR', NULL, NULL, NULL),
(60724, '2018-01-17 11:27:43', NULL, NULL, 16147, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 11:27:43', 'admin-1516151174-15161596630939078', 1, 1, 'SR', NULL, NULL, NULL),
(60725, '2018-01-17 11:40:50', NULL, NULL, 16145, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 11:40:50', 'admin-1516151174-15161604502242821', 1, 0, '', NULL, NULL, NULL),
(60726, '2018-01-17 11:43:20', NULL, NULL, 16145, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 11:43:20', 'admin-1516151174-1516160600409352', 1, 0, '', NULL, NULL, NULL),
(60727, '2018-01-17 13:34:42', NULL, NULL, 16155, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:34:42', 'admin-1516151174-15161672819088111', 1, 1, 'SR', NULL, NULL, NULL),
(60728, '2018-01-17 13:34:42', NULL, NULL, 16155, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:34:42', 'admin-1516151174-15161672819088111', 1, 1, 'SR', NULL, NULL, NULL),
(60729, '2018-01-17 13:13:29', NULL, NULL, 16150, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:13:29', 'admin-1516151174-15161660094784691', 1, 0, '', NULL, NULL, NULL),
(60730, '2018-01-17 13:13:29', NULL, NULL, 16150, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:13:29', 'admin-1516151174-15161660094784691', 1, 0, '', NULL, NULL, NULL),
(60731, '2018-01-17 13:05:54', NULL, NULL, 16150, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:05:54', 'admin-1516151174-15161655546476178', 1, 1, 'SR', NULL, NULL, NULL),
(60732, '2018-01-17 13:02:40', NULL, NULL, 16151, 0, 220, '154', 'Pork Bacon Pesto Pasta', 'Takeaway', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:02:40', 'admin-1516151174-15161653607833769', 1, 0, '', NULL, NULL, NULL),
(60733, '2018-01-17 13:01:13', NULL, NULL, 16154, 0, 322, '258', 'Yuzu Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:01:13', 'admin-1516151174-15161652735279154', 1, 0, '', NULL, NULL, NULL),
(60734, '2018-01-17 13:02:30', NULL, NULL, 16153, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:02:30', 'admin-1516151174-15161653505357724', 1, 1, 'SR', NULL, NULL, NULL),
(60735, '2018-01-17 13:01:13', NULL, NULL, 16154, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 13:01:13', 'admin-1516151174-15161652735279154', 1, 0, '', NULL, NULL, NULL),
(60736, '2018-01-17 12:57:42', NULL, NULL, 16153, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:57:42', 'admin-1516151174-1516165062384916', 1, 1, 'SR', NULL, NULL, NULL),
(60737, '2018-01-17 12:50:42', NULL, NULL, 16152, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:50:42', 'admin-1516151174-1516164642745759', 1, 1, 'SR', NULL, NULL, NULL),
(60738, '2018-01-17 12:50:42', NULL, NULL, 16152, 0, 181, '116', 'Open Food ', 'mushroom noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:50:42', 'admin-1516151174-1516164642745759', 1, 0, '', NULL, NULL, NULL),
(60739, '2018-01-17 12:50:42', NULL, NULL, 16152, 0, 181, '116', 'Open Food ', 'mushroom noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:50:42', 'admin-1516151174-1516164642745759', 1, 0, '', NULL, NULL, NULL),
(60740, '2018-01-17 12:50:42', NULL, NULL, 16152, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:50:42', 'admin-1516151174-1516164642745759', 1, 1, 'SR', NULL, NULL, NULL),
(60741, '2018-01-17 12:43:01', NULL, NULL, 16151, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:43:01', 'admin-1516151174-1516164181220218', 1, 0, '', NULL, NULL, NULL),
(60742, '2018-01-17 12:43:01', NULL, NULL, 16151, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:43:01', 'admin-1516151174-1516164181220218', 1, 0, '', NULL, NULL, NULL),
(60743, '2018-01-17 12:43:01', NULL, NULL, 16151, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:43:01', 'admin-1516151174-1516164181220218', 1, 0, '', NULL, NULL, NULL),
(60744, '2018-01-17 12:43:01', NULL, NULL, 16151, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:43:01', 'admin-1516151174-1516164181220218', 1, 0, '', NULL, NULL, NULL),
(60745, '2018-01-17 12:42:14', NULL, NULL, 16151, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:42:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60746, '2018-01-17 12:24:35', NULL, NULL, 16149, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:24:35', 'admin-1516151174-15161630752988865', 1, 0, '', NULL, NULL, NULL),
(60747, '2018-01-17 12:28:35', NULL, NULL, 16150, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:28:35', 'admin-1516151174-15161633152871327', 1, 1, 'SR', NULL, NULL, NULL),
(60748, '2018-01-17 12:28:29', NULL, NULL, 16150, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:28:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60749, '2018-01-17 12:24:35', NULL, NULL, 16149, 0, 216, '150', 'Chicken In The Blanket', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:24:35', 'admin-1516151174-15161630752988865', 1, 0, '', NULL, NULL, NULL),
(60750, '2018-01-17 12:24:35', NULL, NULL, 16149, 0, 181, '116', 'Open Food ', 'mushroom noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:24:35', 'admin-1516151174-15161630752988865', 1, 0, '', NULL, NULL, NULL),
(60751, '2018-01-17 12:13:06', NULL, NULL, 16148, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:13:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60752, '2018-01-17 12:13:21', NULL, NULL, 16148, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:13:21', 'admin-1516151174-15161624016476858', 1, 1, 'SR', NULL, NULL, NULL),
(60753, '2018-01-17 12:13:21', NULL, NULL, 16148, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 12:13:21', 'admin-1516151174-15161624016476858', 1, 1, 'SR', NULL, NULL, NULL),
(60754, '2018-01-17 11:27:43', NULL, NULL, 16147, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 11:27:43', 'admin-1516151174-15161596630939078', 1, 0, '', NULL, NULL, NULL),
(60755, '2018-01-17 11:11:43', NULL, NULL, 16146, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1516151174', 'admin', '2018-01-17 11:11:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60756, '2018-01-17 11:11:54', NULL, NULL, 16146, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 11:11:54', 'admin-1516151174-15161587145833264', 1, 1, 'SR', NULL, NULL, NULL),
(60757, '2018-01-17 11:27:43', NULL, NULL, 16147, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 11:27:43', 'admin-1516151174-15161596630939078', 1, 0, '', NULL, NULL, NULL),
(60758, '2018-01-17 10:01:31', NULL, NULL, 16144, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 10:01:31', 'admin-1516151174-15161544914895615', 1, 1, 'SR', NULL, NULL, NULL),
(60759, '2018-01-17 11:10:23', NULL, NULL, 16145, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1516151174', 'admin', '2018-01-17 11:10:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60760, '2018-01-17 11:10:52', NULL, NULL, 16145, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 11:10:52', 'admin-1516151174-15161586522372946', 1, 0, '', NULL, NULL, NULL),
(60761, '2018-01-17 09:39:14', NULL, NULL, 16143, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 09:39:14', 'admin-1516151174-15161531540041766', 1, 0, '', NULL, NULL, NULL),
(60762, '2018-01-17 11:27:43', NULL, NULL, 16147, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 11:27:43', 'admin-1516151174-15161596630939078', 1, 0, '', NULL, NULL, NULL),
(60763, '2018-01-17 11:27:17', NULL, NULL, 16147, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1516151174', 'admin', '2018-01-17 11:27:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60764, '2018-01-17 11:16:01', NULL, NULL, 16146, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 11:16:01', 'admin-1516151174-15161589614564381', 1, 0, '', NULL, NULL, NULL),
(60765, '2018-01-17 11:11:54', NULL, NULL, 16146, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 11:11:54', 'admin-1516151174-15161587145833264', 1, 1, 'SR', NULL, NULL, NULL),
(60766, '2018-01-17 11:11:54', NULL, NULL, 16146, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 11:11:54', 'admin-1516151174-15161587145833264', 1, 1, 'SR', NULL, NULL, NULL),
(60767, '2018-01-17 11:10:52', NULL, NULL, 16145, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 11:10:52', 'admin-1516151174-15161586522372946', 1, 1, 'SR', NULL, NULL, NULL),
(60768, '2018-01-17 11:10:52', NULL, NULL, 16145, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 11:10:52', 'admin-1516151174-15161586522372946', 1, 1, 'SR', NULL, NULL, NULL),
(60769, '2018-01-17 10:01:31', NULL, NULL, 16144, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 10:01:31', 'admin-1516151174-15161544914895615', 1, 0, '', NULL, NULL, NULL),
(60770, '2018-01-17 10:01:31', NULL, NULL, 16144, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 10:01:31', 'admin-1516151174-15161544914895615', 1, 0, '', NULL, NULL, NULL),
(60771, '2018-01-17 10:01:31', NULL, NULL, 16144, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 10:01:31', 'admin-1516151174-15161544914895615', 1, 1, 'SR', NULL, NULL, NULL),
(60772, '2018-01-17 09:39:14', NULL, NULL, 16143, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 09:39:14', 'admin-1516151174-15161531540041766', 1, 1, 'SR', NULL, NULL, NULL),
(60773, '2018-01-17 09:39:14', NULL, NULL, 16143, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 09:39:14', 'admin-1516151174-15161531540041766', 1, 0, '', NULL, NULL, NULL),
(60774, '2018-01-17 10:01:14', NULL, NULL, 16144, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1516151174', 'admin', '2018-01-17 10:01:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60775, '2018-01-17 09:39:14', NULL, NULL, 16143, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516151174', 'admin', '2018-01-17 09:39:14', 'admin-1516151174-15161531540041766', 1, 0, '', NULL, NULL, NULL),
(60776, '2018-01-17 09:38:47', NULL, NULL, 16143, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1516151174', 'admin', '2018-01-17 09:38:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60777, '2018-01-18 12:33:46', NULL, NULL, 16177, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:33:46', 'admin-1516237698-15162500261054769', 1, 1, 'SR', NULL, NULL, NULL),
(60778, '2018-01-18 14:58:20', NULL, NULL, 16183, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 13.50, 0.0000, 0.0000, 13.50, 1, '27', 1, '1516237698', 'admin', '2018-01-18 14:58:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60779, '2018-01-18 15:24:30', NULL, NULL, 16185, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:24:30', 'admin-1516237698-15162602704288662', 1, 0, '', NULL, NULL, NULL),
(60780, '2018-01-18 15:24:30', NULL, NULL, 16185, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:24:30', 'admin-1516237698-15162602704288662', 1, 1, 'SR', NULL, NULL, NULL),
(60781, '2018-01-18 15:24:30', NULL, NULL, 16185, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:24:30', 'admin-1516237698-15162602704288662', 1, 1, 'SR', NULL, NULL, NULL),
(60782, '2018-01-18 13:46:54', NULL, NULL, 16175, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 13:46:54', 'admin-1516237698-15162544139277174', 1, 1, 'SR', NULL, NULL, NULL),
(60783, '2018-01-18 14:27:42', NULL, NULL, 16168, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 14:27:42', 'admin-1516237698-15162568621121592', 1, 0, '', NULL, NULL, NULL),
(60784, '2018-01-18 14:15:40', NULL, NULL, 16182, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 14:15:40', 'admin-1516237698-1516256140588180', 1, 0, '', NULL, NULL, NULL),
(60785, '2018-01-18 13:28:16', NULL, NULL, 16181, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 13:28:16', 'admin-1516237698-15162532962866631', 1, 1, 'SR', NULL, NULL, NULL),
(60786, '2018-01-18 13:28:16', NULL, NULL, 16181, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 13:28:16', 'admin-1516237698-15162532962866631', 1, 1, 'SR', NULL, NULL, NULL),
(60787, '2018-01-18 15:33:47', NULL, NULL, 16186, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:33:47', 'admin-1516237698-15162608271452797', 1, 1, 'SR', NULL, NULL, NULL),
(60788, '2018-01-18 13:01:54', NULL, NULL, 16180, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 9.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 13:01:54', 'admin-1516237698-15162517143539145', 1, 0, '', 1, NULL, NULL),
(60789, '2018-01-18 15:05:42', NULL, NULL, 16184, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:05:42', 'admin-1516237698-15162591422897739', 1, 1, 'SR', NULL, NULL, NULL),
(60790, '2018-01-18 15:24:05', NULL, NULL, 16185, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:24:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60791, '2018-01-18 15:24:30', NULL, NULL, 16185, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:24:30', 'admin-1516237698-15162602704288662', 1, 1, 'SR', NULL, NULL, NULL),
(60792, '2018-01-18 15:00:50', NULL, NULL, 16183, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:00:50', 'admin-1516237698-15162588500545060', 1, 1, 'SR', NULL, NULL, NULL),
(60793, '2018-01-18 15:00:50', NULL, NULL, 16183, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:00:50', 'admin-1516237698-15162588500545060', 1, 1, 'SR', NULL, NULL, NULL),
(60794, '2018-01-18 15:00:50', NULL, NULL, 16183, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:00:50', 'admin-1516237698-15162588500545060', 1, 1, 'SR', NULL, NULL, NULL),
(60795, '2018-01-18 14:22:51', NULL, NULL, 16168, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 14:22:51', 'admin-1516237698-15162565710583179', 1, 0, '', NULL, NULL, NULL),
(60796, '2018-01-18 10:06:12', NULL, NULL, 16166, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:06:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60797, '2018-01-18 10:06:22', NULL, NULL, 16166, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:06:22', 'admin-1516237698-1516241182093103', 1, 1, 'SR', NULL, NULL, NULL),
(60798, '2018-01-18 13:50:07', NULL, NULL, 16182, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 13:50:07', 'admin-1516237698-15162546071303534', 1, 0, '', NULL, NULL, NULL),
(60799, '2018-01-18 13:01:54', NULL, NULL, 16180, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 13:01:54', 'admin-1516237698-15162517143539145', 1, 1, 'SR', 1, NULL, NULL),
(60800, '2018-01-18 11:51:06', NULL, NULL, 16174, 0, 181, '116', 'Open Food ', 'Mushroom noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 11:51:06', 'admin-1516237698-15162474659973819', 1, 0, '', NULL, NULL, NULL),
(60801, '2018-01-18 10:19:43', NULL, NULL, 16168, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:19:43', 'admin-1516237698-1516241983658622', 1, 0, '', NULL, NULL, NULL),
(60802, '2018-01-18 13:20:34', NULL, NULL, 16177, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 13:20:34', 'admin-1516237698-15162528340106668', 1, 0, '', NULL, NULL, NULL),
(60803, '2018-01-18 13:01:54', NULL, NULL, 16180, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 13:01:54', 'admin-1516237698-15162517143539145', 1, 0, '', 1, NULL, NULL),
(60804, '2018-01-18 12:54:30', NULL, NULL, 16179, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:54:30', 'admin-1516237698-1516251270676807', 1, 0, '', NULL, NULL, NULL),
(60805, '2018-01-18 13:50:07', NULL, NULL, 16182, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 13:50:07', 'admin-1516237698-15162546071303534', 1, 0, '', NULL, NULL, NULL),
(60806, '2018-01-18 13:49:30', NULL, NULL, 16182, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1516237698', 'admin', '2018-01-18 13:49:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60807, '2018-01-18 00:00:00', NULL, NULL, 16173, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:46:51', 'admin-1516237698-15162436115249728', 1, 0, '', NULL, NULL, NULL),
(60808, '2018-01-18 15:00:50', NULL, NULL, 16183, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:00:50', 'admin-1516237698-15162588500545060', 1, 1, 'SR', NULL, NULL, NULL),
(60809, '2018-01-18 15:00:50', NULL, NULL, 16183, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:00:50', 'admin-1516237698-15162588500545060', 1, 1, 'SR', NULL, NULL, NULL),
(60810, '2018-01-18 15:00:50', NULL, NULL, 16183, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:00:50', 'admin-1516237698-15162588500545060', 1, 1, 'SR', NULL, NULL, NULL),
(60811, '2018-01-18 15:04:10', NULL, NULL, 16184, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:04:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60812, '2018-01-18 12:29:09', NULL, NULL, 16176, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:29:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60813, '2018-01-18 12:29:24', NULL, NULL, 16176, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:29:24', 'admin-1516237698-15162497643132475', 1, 0, '', NULL, NULL, NULL),
(60814, '2018-01-18 15:33:47', NULL, NULL, 16186, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:33:47', 'admin-1516237698-15162608271452797', 1, 0, '', NULL, NULL, NULL),
(60815, '2018-01-18 15:24:30', NULL, NULL, 16185, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:24:30', 'admin-1516237698-15162602704288662', 1, 1, 'SR', NULL, NULL, NULL),
(60816, '2018-01-18 15:33:19', NULL, NULL, 16186, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:33:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60817, '2018-01-18 15:24:30', NULL, NULL, 16185, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:24:30', 'admin-1516237698-15162602704288662', 1, 1, 'SR', NULL, NULL, NULL),
(60818, '2018-01-18 13:38:09', NULL, NULL, 16175, 0, 181, '116', 'Open Food ', 'noddle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 13:38:09', 'admin-1516237698-1516253888930535', 1, 0, '', NULL, NULL, NULL),
(60819, '2018-01-18 12:41:46', NULL, NULL, 16179, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:41:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60820, '2018-01-18 15:05:42', NULL, NULL, 16184, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:05:42', 'admin-1516237698-15162591422897739', 1, 1, 'SR', NULL, NULL, NULL),
(60821, '2018-01-18 15:05:42', NULL, NULL, 16184, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:05:42', 'admin-1516237698-15162591422897739', 1, 0, '', NULL, NULL, NULL),
(60822, '2018-01-18 15:05:42', NULL, NULL, 16184, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:05:42', 'admin-1516237698-15162591422897739', 1, 0, '', NULL, NULL, NULL),
(60823, '2018-01-18 15:05:42', NULL, NULL, 16184, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:05:42', 'admin-1516237698-15162591422897739', 1, 0, '', NULL, NULL, NULL),
(60824, '2018-01-18 12:34:37', NULL, NULL, 16175, 0, 301, '237', 'Black Jack', '', 'Cold Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:34:37', 'admin-1516237698-15162500775644384', 1, 0, '', NULL, NULL, NULL),
(60825, '2018-01-18 12:33:46', NULL, NULL, 16177, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:33:46', 'admin-1516237698-15162500261054769', 1, 1, 'SR', NULL, NULL, NULL),
(60826, '2018-01-18 15:05:42', NULL, NULL, 16184, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:05:42', 'admin-1516237698-15162591422897739', 1, 1, 'SR', NULL, NULL, NULL),
(60827, '2018-01-18 15:00:50', NULL, NULL, 16183, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:00:50', 'admin-1516237698-15162588500545060', 1, 1, 'SR', NULL, NULL, NULL),
(60828, '2018-01-18 15:00:50', NULL, NULL, 16183, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:00:50', 'admin-1516237698-15162588500545060', 1, 1, 'SR', NULL, NULL, NULL),
(60829, '2018-01-18 15:00:50', NULL, NULL, 16183, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:00:50', 'admin-1516237698-15162588500545060', 1, 1, 'SR', NULL, NULL, NULL),
(60830, '2018-01-18 15:00:50', NULL, NULL, 16183, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:00:50', 'admin-1516237698-15162588500545060', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(60831, '2018-01-18 12:34:30', NULL, NULL, 16176, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:34:30', 'admin-1516237698-15162500708289011', 1, 1, 'SR', NULL, NULL, NULL),
(60832, '2018-01-18 13:01:54', NULL, NULL, 16180, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 13:01:54', 'admin-1516237698-15162517143539145', 1, 1, 'SR', 1, NULL, NULL),
(60833, '2018-01-18 13:27:10', NULL, NULL, 16181, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1516237698', 'admin', '2018-01-18 13:27:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60834, '2018-01-18 12:33:46', NULL, NULL, 16177, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:33:46', 'admin-1516237698-15162500261054769', 1, 1, 'SR', NULL, NULL, NULL),
(60835, '2018-01-18 11:51:06', NULL, NULL, 16174, 0, 181, '116', 'Open Food ', 'Mushroom noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 11:51:06', 'admin-1516237698-15162474659973819', 1, 0, '', NULL, NULL, NULL),
(60836, '2018-01-18 12:33:46', NULL, NULL, 16177, 0, 181, '116', 'Open Food ', 'mushroom noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:33:46', 'admin-1516237698-15162500261054769', 1, 0, '', NULL, NULL, NULL),
(60837, '2018-01-18 12:33:46', NULL, NULL, 16177, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:33:46', 'admin-1516237698-15162500261054769', 1, 0, '', NULL, NULL, NULL),
(60838, '2018-01-18 13:50:07', NULL, NULL, 16182, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 13:50:07', 'admin-1516237698-15162546071303534', 1, 0, '', NULL, NULL, NULL),
(60839, '2018-01-18 12:33:46', NULL, NULL, 16177, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:33:46', 'admin-1516237698-15162500261054769', 1, 0, '', NULL, NULL, NULL),
(60840, '2018-01-18 10:28:44', NULL, NULL, 16169, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:28:44', 'admin-1516237698-15162425238961213', 1, 1, 'SR', NULL, NULL, NULL),
(60841, '2018-01-18 10:28:44', NULL, NULL, 16169, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:28:44', 'admin-1516237698-15162425238961213', 1, 0, '', NULL, NULL, NULL),
(60842, '2018-01-18 00:00:00', NULL, NULL, 16173, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', NULL, 1, 0.90, NULL, NULL, 0.90, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:46:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60843, '2018-01-18 10:19:43', NULL, NULL, 16168, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:19:43', 'admin-1516237698-1516241983658622', 1, 1, 'SR', NULL, NULL, NULL),
(60844, '2018-01-18 10:27:26', NULL, NULL, 16169, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 12.30, 0.0000, 0.0000, 12.30, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:27:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60845, '2018-01-18 10:28:44', NULL, NULL, 16169, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:28:44', 'admin-1516237698-15162425238961213', 1, 0, '', NULL, NULL, NULL),
(60846, '2018-01-18 10:28:44', NULL, NULL, 16169, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:28:44', 'admin-1516237698-15162425238961213', 1, 0, '', NULL, NULL, NULL),
(60847, '2018-01-18 12:33:46', NULL, NULL, 16177, 0, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:33:46', 'admin-1516237698-15162500261054769', 1, 1, 'SR', NULL, NULL, NULL),
(60848, '2018-01-18 12:33:46', NULL, NULL, 16177, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:33:46', 'admin-1516237698-15162500261054769', 1, 0, '', NULL, NULL, NULL),
(60849, '2018-01-18 12:33:46', NULL, NULL, 16177, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:33:46', 'admin-1516237698-15162500261054769', 1, 0, '', NULL, NULL, NULL),
(60850, '2018-01-18 12:33:46', NULL, NULL, 16177, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:33:46', 'admin-1516237698-15162500261054769', 1, 0, '', NULL, NULL, NULL),
(60851, '2018-01-18 12:33:46', NULL, NULL, 16177, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:33:46', 'admin-1516237698-15162500261054769', 1, 0, '', NULL, NULL, NULL),
(60852, '2018-01-18 12:33:46', NULL, NULL, 16177, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:33:46', 'admin-1516237698-15162500261054769', 1, 0, '', NULL, NULL, NULL),
(60853, '2018-01-18 12:29:24', NULL, NULL, 16176, 0, 181, '116', 'Open Food ', 'noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:29:24', 'admin-1516237698-15162497643132475', 1, 0, '', NULL, NULL, NULL),
(60854, '2018-01-18 12:30:17', NULL, NULL, 16177, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 21.70, 0.0000, 0.0000, 21.70, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:30:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60855, '2018-01-18 12:33:46', NULL, NULL, 16177, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:33:46', 'admin-1516237698-15162500261054769', 1, 0, '', NULL, NULL, NULL),
(60856, '2018-01-18 12:26:34', NULL, NULL, 16175, 0, 181, '116', 'Open Food ', 'noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:26:34', 'admin-1516237698-15162495941235045', 1, 0, '', NULL, NULL, NULL),
(60857, '2018-01-18 11:51:06', NULL, NULL, 16174, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 11:51:06', 'admin-1516237698-15162474659973819', 1, 1, 'SR', NULL, NULL, NULL),
(60858, '2018-01-18 12:26:34', NULL, NULL, 16175, 0, 181, '116', 'Open Food ', 'noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:26:34', 'admin-1516237698-15162495941235045', 1, 0, '', NULL, NULL, NULL),
(60859, '2018-01-18 12:26:15', NULL, NULL, 16175, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:26:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60860, '2018-01-18 13:50:07', NULL, NULL, 16182, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 13:50:07', 'admin-1516237698-15162546071303534', 1, 1, 'SR', NULL, NULL, NULL),
(60861, '2018-01-18 11:51:06', NULL, NULL, 16174, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 11:51:06', 'admin-1516237698-15162474659973819', 1, 1, 'SR', NULL, NULL, NULL),
(60862, '2018-01-18 11:51:06', NULL, NULL, 16174, 0, 181, '116', 'Open Food ', 'Mushroom noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 11:51:06', 'admin-1516237698-15162474659973819', 1, 0, '', NULL, NULL, NULL),
(60863, '2018-01-18 11:50:32', NULL, NULL, 16174, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1516237698', 'admin', '2018-01-18 11:50:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60864, '2018-01-18 15:33:47', NULL, NULL, 16186, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 15:33:47', 'admin-1516237698-15162608271452797', 1, 0, '', NULL, NULL, NULL),
(60865, '2018-01-18 10:28:44', NULL, NULL, 16169, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:28:44', 'admin-1516237698-15162425238961213', 1, 1, 'SR', NULL, NULL, NULL),
(60866, '2018-01-18 10:28:44', NULL, NULL, 16169, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:28:44', 'admin-1516237698-15162425238961213', 1, 0, '', NULL, NULL, NULL),
(60867, '2018-01-18 10:16:52', NULL, NULL, 16167, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:16:52', 'admin-1516237698-15162418127185536', 1, 1, 'SR', NULL, NULL, NULL),
(60868, '2018-01-18 10:19:11', NULL, NULL, 16168, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 11.30, 0.0000, 0.0000, 11.30, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:19:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60869, '2018-01-18 12:39:05', NULL, NULL, 16178, 0, 181, '116', 'Open Food ', 'noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 12:39:05', 'admin-1516237698-15162503458412963', 1, 0, '', 1, NULL, NULL),
(60870, '2018-01-18 00:00:00', NULL, NULL, 16172, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:46:51', 'admin-1516237698-15162436115249728', 1, 0, '', NULL, NULL, NULL),
(60871, '2018-01-18 11:19:02', NULL, NULL, 16172, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1516237698', 'admin', '2018-01-18 11:19:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60872, '2018-01-18 10:54:17', NULL, NULL, 16171, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:54:17', 'admin-1516237698-15162440577011117', 1, 1, 'SR', 1, NULL, NULL),
(60873, '2018-01-18 11:22:50', NULL, NULL, 16168, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 11:22:50', 'admin-1516237698-1516245770117111', 1, 1, 'SR', NULL, NULL, NULL),
(60874, '2018-01-18 10:28:44', NULL, NULL, 16169, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:28:44', 'admin-1516237698-15162425238961213', 1, 1, 'SR', NULL, NULL, NULL),
(60875, '2018-01-18 10:28:44', NULL, NULL, 16169, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:28:44', 'admin-1516237698-15162425238961213', 1, 1, 'SR', NULL, NULL, NULL),
(60876, '2018-01-18 10:19:43', NULL, NULL, 16168, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:19:43', 'admin-1516237698-1516241983658622', 1, 0, '', NULL, NULL, NULL),
(60877, '2018-01-18 10:06:22', NULL, NULL, 16166, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:06:22', 'admin-1516237698-1516241182093103', 1, 0, '', NULL, NULL, NULL),
(60878, '2018-01-18 10:16:18', NULL, NULL, 16167, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:16:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60879, '2018-01-18 10:16:52', NULL, NULL, 16167, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:16:52', 'admin-1516237698-15162418127185536', 1, 0, '', NULL, NULL, NULL),
(60880, '2018-01-18 10:28:44', NULL, NULL, 16169, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:28:44', 'admin-1516237698-15162425238961213', 1, 0, '', NULL, NULL, NULL),
(60881, '2018-01-18 09:53:01', NULL, NULL, 16165, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 09:53:01', 'admin-1516237698-15162403812259744', 1, 1, 'SR', NULL, NULL, NULL),
(60882, '2018-01-18 09:10:01', NULL, NULL, 16164, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 09:10:01', 'admin-1516237698-15162378014141413', 1, 0, '', NULL, NULL, NULL),
(60883, '2018-01-18 10:19:43', NULL, NULL, 16168, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:19:43', 'admin-1516237698-1516241983658622', 1, 1, 'SR', NULL, NULL, NULL),
(60884, '2018-01-18 10:19:43', NULL, NULL, 16168, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:19:43', 'admin-1516237698-1516241983658622', 1, 0, '', NULL, NULL, NULL),
(60885, '2018-01-18 10:16:52', NULL, NULL, 16167, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:16:52', 'admin-1516237698-15162418127185536', 1, 1, 'SR', NULL, NULL, NULL),
(60886, '2018-01-18 10:18:05', NULL, NULL, 16167, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:18:05', 'admin-1516237698-15162418856004083', 1, 0, '', NULL, NULL, NULL),
(60887, '2018-01-18 10:06:22', NULL, NULL, 16166, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:06:22', 'admin-1516237698-1516241182093103', 1, 0, '', NULL, NULL, NULL),
(60888, '2018-01-18 10:06:22', NULL, NULL, 16166, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 10:06:22', 'admin-1516237698-1516241182093103', 1, 1, 'SR', NULL, NULL, NULL),
(60889, '2018-01-18 09:10:01', NULL, NULL, 16164, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 09:10:01', 'admin-1516237698-15162378014141413', 1, 1, 'SR', NULL, NULL, NULL),
(60890, '2018-01-18 09:10:01', NULL, NULL, 16164, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 09:10:01', 'admin-1516237698-15162378014141413', 1, 0, '', NULL, NULL, NULL),
(60891, '2018-01-18 09:52:51', NULL, NULL, 16165, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1516237698', 'admin', '2018-01-18 09:52:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60892, '2018-01-18 09:53:01', NULL, NULL, 16165, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 09:53:01', 'admin-1516237698-15162403812259744', 1, 0, '', NULL, NULL, NULL),
(60893, '2018-01-18 09:53:01', NULL, NULL, 16165, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 09:53:01', 'admin-1516237698-15162403812259744', 1, 0, '', NULL, NULL, NULL),
(60894, '2018-01-18 09:53:01', NULL, NULL, 16165, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 09:53:01', 'admin-1516237698-15162403812259744', 1, 0, '', NULL, NULL, NULL),
(60895, '2018-01-18 09:10:01', NULL, NULL, 16164, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516237698', 'admin', '2018-01-18 09:10:01', 'admin-1516237698-15162378014141413', 1, 0, '', NULL, NULL, NULL),
(60896, '2018-01-18 09:09:48', NULL, NULL, 16164, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1516237698', 'admin', '2018-01-18 09:09:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60897, '2018-01-19 10:57:07', NULL, NULL, 16190, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 10:57:07', 'admin-1516321469-15163306277495284', 1, 0, '', NULL, NULL, NULL),
(60898, '2018-01-19 13:01:23', NULL, NULL, 16199, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:01:23', 'admin-1516321469-1516338083512427', 1, 1, 'SR', NULL, NULL, NULL),
(60899, '2018-01-19 13:03:14', NULL, NULL, 16196, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:03:14', 'admin-1516321469-15163381944724142', 1, 0, '', NULL, NULL, NULL),
(60900, '2018-01-19 13:59:09', NULL, NULL, 16203, 0, 181, '116', 'Open Food ', 'mushroom noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:59:09', 'admin-1516321469-15163415495005157', 1, 0, '', NULL, NULL, NULL),
(60901, '2018-01-19 14:01:30', NULL, NULL, 16203, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 14:01:30', 'admin-1516321469-15163416902018850', 1, 1, 'SR', NULL, NULL, NULL),
(60902, '2018-01-19 14:36:46', NULL, NULL, 16205, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 14:36:46', 'admin-1516321469-15163438061838896', 1, 1, 'SR', NULL, NULL, NULL),
(60903, '2018-01-19 16:27:11', NULL, NULL, 16206, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1516321469', 'admin', '2018-01-19 16:27:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60904, '2018-01-19 16:27:17', NULL, NULL, 16206, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 16:27:17', 'admin-1516321469-1516350437768226', 1, 1, 'SR', NULL, NULL, NULL),
(60905, '2018-01-19 11:52:32', NULL, NULL, 16195, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1516321469', 'admin', '2018-01-19 11:52:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60906, '2018-01-19 09:42:22', NULL, NULL, 16189, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 09:42:22', 'admin-1516321469-15163261425463782', 1, 0, '', NULL, NULL, NULL),
(60907, '2018-01-19 13:57:25', NULL, NULL, 16203, 0, 181, '116', 'Open Food ', 'stewed pork rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:57:25', 'admin-1516321469-15163414455736277', 1, 0, '', NULL, NULL, NULL),
(60908, '2018-01-19 13:01:06', NULL, NULL, 16199, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:01:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60909, '2018-01-19 13:01:23', NULL, NULL, 16199, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:01:23', 'admin-1516321469-1516338083512427', 1, 0, '', NULL, NULL, NULL),
(60910, '2018-01-19 13:09:44', NULL, NULL, 16200, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:09:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60911, '2018-01-19 12:43:15', NULL, NULL, 16197, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1516321469', 'admin', '2018-01-19 12:43:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60912, '2018-01-19 12:44:01', NULL, NULL, 16197, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 12:44:01', 'admin-1516321469-1516337041680839', 1, 0, '', NULL, NULL, NULL),
(60913, '2018-01-19 12:44:01', NULL, NULL, 16197, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 12:44:01', 'admin-1516321469-1516337041680839', 1, 1, 'SR', NULL, NULL, NULL),
(60914, '2018-01-19 12:44:01', NULL, NULL, 16197, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 12:44:01', 'admin-1516321469-1516337041680839', 1, 0, '', NULL, NULL, NULL),
(60915, '2018-01-19 16:27:17', NULL, NULL, 16206, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 16:27:17', 'admin-1516321469-1516350437768226', 1, 0, '', NULL, NULL, NULL),
(60916, '2018-01-19 16:27:17', NULL, NULL, 16206, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 16:27:17', 'admin-1516321469-1516350437768226', 1, 0, '', NULL, NULL, NULL),
(60917, '2018-01-19 11:06:11', NULL, NULL, 16191, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 11:06:11', 'admin-1516321469-1516331171759528', 1, 1, 'SR', NULL, NULL, NULL),
(60918, '2018-01-19 14:07:49', NULL, NULL, 16204, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1516321469', 'admin', '2018-01-19 14:07:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60919, '2018-01-19 16:27:17', NULL, NULL, 16206, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 16:27:17', 'admin-1516321469-1516350437768226', 1, 1, 'SR', NULL, NULL, NULL),
(60920, '2018-01-19 14:36:42', NULL, NULL, 16205, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1516321469', 'admin', '2018-01-19 14:36:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60921, '2018-01-19 14:08:30', NULL, NULL, 16204, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 14:08:30', 'admin-1516321469-15163421098958649', 1, 0, '', NULL, NULL, NULL),
(60922, '2018-01-19 14:08:30', NULL, NULL, 16204, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 14:08:30', 'admin-1516321469-15163421098958649', 1, 0, '', NULL, NULL, NULL),
(60923, '2018-01-19 13:51:23', NULL, NULL, 16202, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:51:23', 'admin-1516321469-15163410834683496', 1, 1, 'SR', NULL, NULL, NULL),
(60924, '2018-01-19 13:56:58', NULL, NULL, 16203, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:56:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60925, '2018-01-19 14:01:30', NULL, NULL, 16203, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 14:01:30', 'admin-1516321469-15163416902018850', 1, 1, 'SR', NULL, NULL, NULL),
(60926, '2018-01-19 13:57:25', NULL, NULL, 16203, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:57:25', 'admin-1516321469-15163414455736277', 1, 0, '', NULL, NULL, NULL),
(60927, '2018-01-19 13:11:59', NULL, NULL, 16201, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:11:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60928, '2018-01-19 11:52:48', NULL, NULL, 16195, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 11:52:48', 'admin-1516321469-15163339684596042', 1, 1, 'SR', NULL, NULL, NULL),
(60929, '2018-01-19 12:19:58', NULL, NULL, 16196, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1516321469', 'admin', '2018-01-19 12:19:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60930, '2018-01-19 13:01:23', NULL, NULL, 16199, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:01:23', 'admin-1516321469-1516338083512427', 1, 0, '', NULL, NULL, NULL),
(60931, '2018-01-19 11:28:18', NULL, NULL, 16192, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1516321469', 'admin', '2018-01-19 11:28:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60932, '2018-01-19 11:28:35', NULL, NULL, 16192, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 11:28:35', 'admin-1516321469-15163325150648233', 1, 0, '', NULL, NULL, NULL),
(60933, '2018-01-19 11:28:35', NULL, NULL, 16192, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 11:28:35', 'admin-1516321469-15163325150648233', 1, 0, '', NULL, NULL, NULL),
(60934, '2018-01-19 11:46:51', NULL, NULL, 16193, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1516321469', 'admin', '2018-01-19 11:46:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60935, '2018-01-19 13:32:55', NULL, NULL, 16202, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:32:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60936, '2018-01-19 13:28:21', NULL, NULL, 16201, 0, 181, '116', 'Open Food ', 'Additional Pork', 'Meals', 'Perfect Meals', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:28:21', 'admin-1516321469-15163397016553783', 1, 0, '', NULL, NULL, NULL),
(60937, '2018-01-19 12:20:21', NULL, NULL, 16196, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 12:20:21', 'admin-1516321469-1516335621315646', 1, 1, 'SR', NULL, NULL, NULL),
(60938, '2018-01-19 13:26:54', NULL, NULL, 16201, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:26:54', 'admin-1516321469-1516339613857611', 1, 1, 'SR', NULL, NULL, NULL),
(60939, '2018-01-19 13:12:15', NULL, NULL, 16201, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:12:15', 'admin-1516321469-1516338735227972', 1, 1, 'SR', NULL, NULL, NULL),
(60940, '2018-01-19 13:12:15', NULL, NULL, 16201, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:12:15', 'admin-1516321469-1516338735227972', 1, 0, '', NULL, NULL, NULL),
(60941, '2018-01-19 13:12:15', NULL, NULL, 16201, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:12:15', 'admin-1516321469-1516338735227972', 1, 1, 'SR', NULL, NULL, NULL),
(60942, '2018-01-19 11:47:00', NULL, NULL, 16193, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 11:47:00', 'admin-1516321469-15163336200928174', 1, 1, 'SR', NULL, NULL, NULL),
(60943, '2018-01-19 11:48:30', NULL, NULL, 16194, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1516321469', 'admin', '2018-01-19 11:48:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60944, '2018-01-19 11:49:10', NULL, NULL, 16194, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 11:49:10', 'admin-1516321469-15163337502896534', 1, 0, '', NULL, NULL, NULL),
(60945, '2018-01-19 13:12:15', NULL, NULL, 16201, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:12:15', 'admin-1516321469-1516338735227972', 1, 0, '', NULL, NULL, NULL),
(60946, '2018-01-19 14:08:30', NULL, NULL, 16204, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 14:08:30', 'admin-1516321469-15163421098958649', 1, 0, '', NULL, NULL, NULL),
(60947, '2018-01-19 14:08:30', NULL, NULL, 16204, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 14:08:30', 'admin-1516321469-15163421098958649', 1, 0, '', NULL, NULL, NULL),
(60948, '2018-01-19 13:10:09', NULL, NULL, 16200, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:10:09', 'admin-1516321469-1516338609673339', 1, 1, 'SR', NULL, NULL, NULL),
(60949, '2018-01-19 13:10:09', NULL, NULL, 16200, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:10:09', 'admin-1516321469-1516338609673339', 1, 0, '', NULL, NULL, NULL),
(60950, '2018-01-19 13:10:09', NULL, NULL, 16200, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:10:09', 'admin-1516321469-1516338609673339', 1, 0, '', NULL, NULL, NULL),
(60951, '2018-01-19 12:44:01', NULL, NULL, 16197, 0, 181, '116', 'Open Food ', 'stewed pork noddle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 12:44:01', 'admin-1516321469-1516337041680839', 1, 0, '', NULL, NULL, NULL),
(60952, '2018-01-19 12:49:19', NULL, NULL, 16198, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 12:49:19', 'admin-1516321469-15163373593142441', 1, 1, 'SR', 1, NULL, NULL),
(60953, '2018-01-19 11:06:11', NULL, NULL, 16191, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 11:06:11', 'admin-1516321469-1516331171759528', 1, 0, '', NULL, NULL, NULL),
(60954, '2018-01-19 12:20:21', NULL, NULL, 16196, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 12:20:21', 'admin-1516321469-1516335621315646', 1, 1, 'SR', NULL, NULL, NULL),
(60955, '2018-01-19 11:52:48', NULL, NULL, 16195, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 11:52:48', 'admin-1516321469-15163339684596042', 1, 1, 'SR', NULL, NULL, NULL),
(60956, '2018-01-19 11:52:48', NULL, NULL, 16195, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 11:52:48', 'admin-1516321469-15163339684596042', 1, 0, '', NULL, NULL, NULL),
(60957, '2018-01-19 11:49:10', NULL, NULL, 16194, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 11:49:10', 'admin-1516321469-15163337502896534', 1, 1, 'SR', NULL, NULL, NULL),
(60958, '2018-01-19 11:03:34', NULL, NULL, 16190, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 11:03:34', 'admin-1516321469-15163310146424970', 1, 0, '', NULL, NULL, NULL),
(60959, '2018-01-19 11:47:00', NULL, NULL, 16193, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 11:47:00', 'admin-1516321469-15163336200928174', 1, 0, '', NULL, NULL, NULL),
(60960, '2018-01-19 13:33:00', NULL, NULL, 16202, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:33:00', 'admin-1516321469-15163399801424746', 1, 1, 'SR', NULL, NULL, NULL),
(60961, '2018-01-19 11:06:11', NULL, NULL, 16191, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 11:06:11', 'admin-1516321469-1516331171759528', 1, 0, '', NULL, NULL, NULL),
(60962, '2018-01-19 11:06:11', NULL, NULL, 16191, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 11:06:11', 'admin-1516321469-1516331171759528', 1, 1, 'SR', NULL, NULL, NULL),
(60963, '2018-01-19 13:33:40', NULL, NULL, 16200, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 13:33:40', 'admin-1516321469-15163400207899071', 1, 1, 'SR', NULL, NULL, NULL),
(60964, '2018-01-19 11:05:55', NULL, NULL, 16191, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1516321469', 'admin', '2018-01-19 11:05:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60965, '2018-01-19 11:03:34', NULL, NULL, 16190, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 11:03:34', 'admin-1516321469-15163310146424970', 1, 0, '', NULL, NULL, NULL),
(60966, '2018-01-19 09:42:22', NULL, NULL, 16189, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 09:42:22', 'admin-1516321469-15163261425463782', 1, 1, 'SR', NULL, NULL, NULL),
(60967, '2018-01-19 10:56:58', NULL, NULL, 16190, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1516321469', 'admin', '2018-01-19 10:56:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60968, '2018-01-19 09:41:25', NULL, NULL, 16189, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 20.30, 0.0000, 0.0000, 20.30, 1, '27', 1, '1516321469', 'admin', '2018-01-19 09:41:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60969, '2018-01-19 09:41:53', NULL, NULL, 16189, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 09:41:53', 'admin-1516321469-15163261130385640', 1, 0, '', NULL, NULL, NULL),
(60970, '2018-01-19 09:41:53', NULL, NULL, 16189, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 09:41:53', 'admin-1516321469-15163261130385640', 1, 0, '', NULL, NULL, NULL),
(60971, '2018-01-19 09:41:53', NULL, NULL, 16189, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 09:41:53', 'admin-1516321469-15163261130385640', 1, 0, '', NULL, NULL, NULL),
(60972, '2018-01-19 09:41:53', NULL, NULL, 16189, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 09:41:53', 'admin-1516321469-15163261130385640', 1, 0, '', NULL, NULL, NULL),
(60973, '2018-01-19 09:41:53', NULL, NULL, 16189, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 09:41:53', 'admin-1516321469-15163261130385640', 1, 0, '', NULL, NULL, NULL),
(60974, '2018-01-19 09:41:53', NULL, NULL, 16189, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 09:41:53', 'admin-1516321469-15163261130385640', 1, 0, '', NULL, NULL, NULL),
(60975, '2018-01-19 09:41:53', NULL, NULL, 16189, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 09:41:53', 'admin-1516321469-15163261130385640', 1, 0, '', NULL, NULL, NULL),
(60976, '2018-01-19 09:42:22', NULL, NULL, 16189, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 09:42:22', 'admin-1516321469-15163261425463782', 1, 1, 'SR', NULL, NULL, NULL),
(60977, '2018-01-19 10:58:41', NULL, NULL, 16190, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 10:58:41', 'admin-1516321469-15163307212023067', 1, 1, 'SR', NULL, NULL, NULL),
(60978, '2018-01-19 09:42:22', NULL, NULL, 16189, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 09:42:22', 'admin-1516321469-15163261425463782', 1, 1, 'SR', NULL, NULL, NULL),
(60979, '2018-01-19 09:42:22', NULL, NULL, 16189, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 09:42:22', 'admin-1516321469-15163261425463782', 1, 1, 'SR', NULL, NULL, NULL),
(60980, '2018-01-19 09:42:22', NULL, NULL, 16189, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 09:42:22', 'admin-1516321469-15163261425463782', 1, 1, 'SR', NULL, NULL, NULL),
(60981, '2018-01-19 09:42:22', NULL, NULL, 16189, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 09:42:22', 'admin-1516321469-15163261425463782', 1, 1, 'SR', NULL, NULL, NULL),
(60982, '2018-01-19 09:03:34', NULL, NULL, 16188, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 09:03:34', 'admin-1516321469-15163238141062616', 1, 0, '', NULL, NULL, NULL),
(60983, '2018-01-19 09:03:16', NULL, NULL, 16188, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1516321469', 'admin', '2018-01-19 09:03:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60984, '2018-01-19 09:03:34', NULL, NULL, 16188, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 09:03:34', 'admin-1516321469-15163238141062616', 1, 0, '', NULL, NULL, NULL),
(60985, '2018-01-19 09:02:31', NULL, NULL, 16187, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516321469', 'admin', '2018-01-19 09:02:31', 'admin-1516321469-15163237516626352', 1, 0, '', NULL, NULL, NULL),
(60986, '2018-01-19 09:02:27', NULL, NULL, 16187, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1516321469', 'admin', '2018-01-19 09:02:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60987, '2018-01-20 15:51:17', NULL, NULL, 16243, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:51:17', 'admin-1516415730-1516434677346562', 1, 0, '', NULL, '20.0', NULL),
(60988, '2018-01-20 17:52:27', NULL, NULL, 16247, 0, 181, '116', 'Open Food ', 'beans', 'Meals', 'Perfect Meals', 1, 38.00, 38.0000, 0.0000, 38.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 17:52:27', 'admin-1516415730-15164419474668523', 1, 0, '', 1, NULL, NULL),
(60989, '2018-01-20 17:53:28', NULL, NULL, 16248, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 17:53:28', 'admin-1516441999-15164420078503739', 1, 1, 'SR', 1, NULL, NULL),
(60990, '2018-01-20 17:53:57', NULL, NULL, 16249, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 17:53:57', 'admin-1516441999-15164420370202590', 1, 1, 'SR', 1, NULL, NULL),
(60991, '2018-01-20 17:53:57', NULL, NULL, 16249, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 17:53:57', 'admin-1516441999-15164420370202590', 1, 1, 'SR', 1, NULL, NULL),
(60992, '2018-01-20 14:54:27', NULL, NULL, 16238, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:54:27', 'admin-1516415730-15164312671335510', 1, 0, '', NULL, NULL, NULL),
(60993, '2018-01-20 14:54:11', NULL, NULL, 16238, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:54:11', 'admin-1516415730-15164312515153051', 1, 0, '', NULL, NULL, NULL),
(60994, '2018-01-20 13:02:23', NULL, NULL, 16231, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 13:02:23', 'admin-1516415730-15164245430447094', 1, 0, '', NULL, NULL, NULL),
(60995, '2018-01-20 13:02:23', NULL, NULL, 16231, 0, 181, '116', 'Open Food ', 'stewed pork-noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 13:02:23', 'admin-1516415730-15164245430447094', 1, 0, '', NULL, NULL, NULL),
(60996, '2018-01-20 13:02:23', NULL, NULL, 16231, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 13:02:23', 'admin-1516415730-15164245430447094', 1, 0, '', NULL, NULL, NULL),
(60997, '2018-01-20 13:02:23', NULL, NULL, 16231, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 13:02:23', 'admin-1516415730-15164245430447094', 1, 1, 'SR', NULL, NULL, NULL),
(60998, '2018-01-20 13:42:35', NULL, NULL, 16232, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1516441999', 'admin', '2018-01-20 13:42:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(60999, '2018-01-20 13:43:44', NULL, NULL, 16232, 0, 181, '116', 'Open Food ', 'stewed pork-rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 13:43:44', 'admin-1516415730-15164270244871565', 1, 0, '', NULL, NULL, NULL),
(61000, '2018-01-20 16:02:37', NULL, NULL, 16243, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 16:02:37', 'admin-1516415730-15164353571618846', 1, 1, 'SR', NULL, NULL, NULL),
(61001, '2018-01-20 12:15:16', NULL, NULL, 16229, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:15:16', 'admin-1516415730-15164217163591524', 1, 0, '', NULL, NULL, NULL),
(61002, '2018-01-20 12:24:17', NULL, NULL, 16225, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:24:17', 'admin-1516415730-1516422257515277', 1, 1, 'SR', NULL, NULL, NULL),
(61003, '2018-01-20 12:25:57', NULL, NULL, 16230, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.10, 0.0000, 0.0000, 10.10, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:25:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61004, '2018-01-20 15:18:45', NULL, NULL, 16242, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:18:45', 'admin-1516415730-15164327253735850', 1, 1, 'SR', NULL, NULL, NULL),
(61005, '2018-01-20 15:03:18', NULL, NULL, 16240, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 8.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:03:18', 'admin-1516415730-1516431798883977', 1, 0, '', NULL, '20.0', NULL),
(61006, '2018-01-20 14:07:41', NULL, NULL, 16234, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:07:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61007, '2018-01-20 16:29:32', NULL, NULL, 16244, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 8.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 16:29:32', 'admin-1516415730-15164369722963980', 1, 0, '', NULL, '20.0', NULL),
(61008, '2018-01-20 17:14:55', NULL, NULL, 16245, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 17:14:55', 'admin-1516415730-15164396950633095', 1, 1, 'SR', NULL, NULL, NULL),
(61009, '2018-01-20 17:15:31', NULL, NULL, 16246, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1516441999', 'admin', '2018-01-20 17:15:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61010, '2018-01-20 17:15:37', NULL, NULL, 16246, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 17:15:37', 'admin-1516415730-15164397377392285', 1, 1, 'SR', NULL, NULL, NULL),
(61011, '2018-01-20 14:29:45', NULL, NULL, 16235, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:29:45', 'admin-1516415730-15164297851785384', 1, 1, 'SR', NULL, NULL, NULL),
(61012, '2018-01-20 17:14:45', NULL, NULL, 16245, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1516441999', 'admin', '2018-01-20 17:14:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61013, '2018-01-20 16:17:29', NULL, NULL, 16244, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 8.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 16:17:29', 'admin-1516415730-15164362494826724', 1, 0, '', NULL, '20.0', NULL),
(61014, '2018-01-20 15:24:15', NULL, NULL, 16243, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:24:15', 'admin-1516415730-15164330551691014', 1, 1, 'SR', NULL, NULL, NULL),
(61015, '2018-01-20 15:01:22', NULL, NULL, 16239, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:01:22', 'admin-1516415730-15164316821314988', 1, 0, '', NULL, NULL, NULL),
(61016, '2018-01-20 14:52:22', NULL, NULL, 16237, 0, 182, '117', 'Open Drinks ', 'ginger lemongrass', 'Cold Drinks', 'Fresh Juice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:52:22', 'admin-1516415730-15164311421126218', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(61017, '2018-01-20 10:56:58', NULL, NULL, 16218, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:56:58', 'admin-1516415730-15164170184413511', 1, 0, '', NULL, NULL, NULL),
(61018, '2018-01-20 15:24:15', NULL, NULL, 16243, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:24:15', 'admin-1516415730-15164330551691014', 1, 0, '', NULL, NULL, NULL),
(61019, '2018-01-20 15:24:15', NULL, NULL, 16243, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:24:15', 'admin-1516415730-15164330551691014', 1, 0, '', NULL, NULL, NULL),
(61020, '2018-01-20 15:22:37', NULL, NULL, 16243, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 14.76, 0.0000, 0.0000, 14.76, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:22:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61021, '2018-01-20 15:20:32', NULL, NULL, 16239, 0, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:20:32', 'admin-1516415730-15164328324306515', 1, 1, 'SR', NULL, NULL, NULL),
(61022, '2018-01-20 15:20:32', NULL, NULL, 16239, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:20:32', 'admin-1516415730-15164328324306515', 1, 0, '', NULL, NULL, NULL),
(61023, '2018-01-20 15:20:32', NULL, NULL, 16239, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:20:32', 'admin-1516415730-15164328324306515', 1, 1, 'SR', NULL, NULL, NULL),
(61024, '2018-01-20 15:18:45', NULL, NULL, 16242, 0, 305, '241', 'Sprite', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:18:45', 'admin-1516415730-15164327253735850', 1, 0, '', NULL, NULL, NULL),
(61025, '2018-01-20 13:49:09', NULL, NULL, 16233, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1516441999', 'admin', '2018-01-20 13:49:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61026, '2018-01-20 15:18:45', NULL, NULL, 16242, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:18:45', 'admin-1516415730-15164327253735850', 1, 0, '', NULL, NULL, NULL),
(61027, '2018-01-20 16:17:29', NULL, NULL, 16244, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 16:17:29', 'admin-1516415730-15164362494826724', 1, 1, 'SR', NULL, NULL, NULL),
(61028, '2018-01-20 13:43:44', NULL, NULL, 16232, 0, 181, '116', 'Open Food ', 'stewed pork-noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 13:43:44', 'admin-1516415730-15164270244871565', 1, 0, '', NULL, NULL, NULL),
(61029, '2018-01-20 12:04:30', NULL, NULL, 16225, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:04:30', 'admin-1516415730-15164210701436536', 1, 1, 'SR', NULL, NULL, NULL),
(61030, '2018-01-20 13:01:39', NULL, NULL, 16231, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1516441999', 'admin', '2018-01-20 13:01:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61031, '2018-01-20 12:26:31', NULL, NULL, 16230, 0, 181, '116', 'Open Food ', 'Rice set', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:26:31', 'admin-1516415730-15164223917507246', 1, 0, '', NULL, NULL, NULL),
(61032, '2018-01-20 15:30:42', NULL, NULL, 16239, 0, 291, '225', 'Smoked Duck Red Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:30:42', 'admin-1516415730-15164334420511164', 1, 0, '', NULL, NULL, NULL),
(61033, '2018-01-20 15:16:41', NULL, NULL, 16242, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:16:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61034, '2018-01-20 15:03:51', NULL, NULL, 16241, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:03:51', 'admin-1516415730-15164318317074832', 1, 1, 'SR', NULL, NULL, NULL),
(61035, '2018-01-20 15:05:31', NULL, NULL, 16239, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:05:31', 'admin-1516415730-15164319311365896', 1, 0, '', NULL, NULL, NULL),
(61036, '2018-01-20 14:52:22', NULL, NULL, 16237, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:52:22', 'admin-1516415730-15164311421126218', 1, 1, 'SR', NULL, NULL, NULL),
(61037, '2018-01-20 15:18:45', NULL, NULL, 16242, 0, 324, '260', 'Blueberry Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:18:45', 'admin-1516415730-15164327253735850', 1, 0, '', NULL, NULL, NULL),
(61038, '2018-01-20 14:34:36', NULL, NULL, 16236, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.81, 0.0000, 0.0000, 5.81, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:34:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61039, '2018-01-20 14:34:50', NULL, NULL, 16236, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:34:50', 'admin-1516415730-15164300904136698', 1, 0, '', NULL, NULL, NULL),
(61040, '2018-01-20 15:03:43', NULL, NULL, 16241, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:03:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61041, '2018-01-20 14:01:20', NULL, NULL, 16232, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:01:20', 'admin-1516415730-1516428080203367', 1, 0, '', NULL, NULL, NULL),
(61042, '2018-01-20 12:12:20', NULL, NULL, 16229, 0, 328, '264', 'Basic Blueberries Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:12:20', 'admin-1516415730-1516421540200815', 1, 0, '', NULL, NULL, NULL),
(61043, '2018-01-20 12:12:20', NULL, NULL, 16229, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:12:20', 'admin-1516415730-1516421540200815', 1, 0, '', NULL, NULL, NULL),
(61044, '2018-01-20 12:12:20', NULL, NULL, 16229, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:12:20', 'admin-1516415730-1516421540200815', 1, 1, 'SR', NULL, NULL, NULL),
(61045, '2018-01-20 15:03:19', NULL, NULL, 16240, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:03:19', 'admin-1516415730-1516431798883977', 1, 0, '', NULL, NULL, NULL),
(61046, '2018-01-20 11:45:22', NULL, NULL, 16227, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:45:22', 'admin-1516415730-1516419922426267', 1, 1, 'SR', NULL, NULL, NULL),
(61047, '2018-01-20 11:42:43', NULL, NULL, 16225, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:42:43', 'admin-1516415730-15164197632332976', 1, 0, '', NULL, NULL, NULL),
(61048, '2018-01-20 11:06:06', NULL, NULL, 16218, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:06:06', 'admin-1516415730-15164175665201773', 1, 0, '', NULL, NULL, NULL),
(61049, '2018-01-20 11:45:13', NULL, NULL, 16227, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:45:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61050, '2018-01-20 15:03:18', NULL, NULL, 16240, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 8.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:03:18', 'admin-1516415730-1516431798883977', 1, 0, '', NULL, '20.0', NULL),
(61051, '2018-01-20 15:02:56', NULL, NULL, 16240, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:02:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61052, '2018-01-20 15:01:22', NULL, NULL, 16239, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:01:22', 'admin-1516415730-15164316821314988', 1, 1, 'SR', NULL, NULL, NULL),
(61053, '2018-01-20 15:01:22', NULL, NULL, 16239, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:01:22', 'admin-1516415730-15164316821314988', 1, 0, '', NULL, NULL, NULL),
(61054, '2018-01-20 15:01:22', NULL, NULL, 16239, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:01:22', 'admin-1516415730-15164316821314988', 1, 1, 'SR', NULL, NULL, NULL),
(61055, '2018-01-20 15:01:22', NULL, NULL, 16239, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:01:22', 'admin-1516415730-15164316821314988', 1, 0, '', NULL, NULL, NULL),
(61056, '2018-01-20 15:24:15', NULL, NULL, 16243, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:24:15', 'admin-1516415730-15164330551691014', 1, 1, 'SR', NULL, NULL, NULL),
(61057, '2018-01-20 15:01:22', NULL, NULL, 16239, 0, 291, '225', 'Smoked Duck Red Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:01:22', 'admin-1516415730-15164316821314988', 1, 0, '', NULL, NULL, NULL),
(61058, '2018-01-20 15:03:51', NULL, NULL, 16241, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:03:51', 'admin-1516415730-15164318317074832', 1, 1, 'SR', NULL, NULL, NULL),
(61059, '2018-01-20 15:00:08', NULL, NULL, 16239, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 16.60, 0.0000, 0.0000, 16.60, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:00:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61060, '2018-01-20 15:24:15', NULL, NULL, 16243, 0, 153, '87', 'Wake Me Up!', 'sunny side up-egg', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:24:15', 'admin-1516415730-15164330551691014', 1, 0, '', NULL, NULL, NULL),
(61061, '2018-01-20 14:51:44', NULL, NULL, 16237, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:51:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61062, '2018-01-20 14:52:22', NULL, NULL, 16237, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:52:22', 'admin-1516415730-15164311421126218', 1, 1, 'SR', NULL, NULL, NULL),
(61063, '2018-01-20 14:50:27', NULL, NULL, 16236, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:50:27', 'admin-1516415730-1516431027290347', 1, 0, '', NULL, NULL, NULL),
(61064, '2018-01-20 14:46:29', NULL, NULL, 16233, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:46:29', 'admin-1516415730-1516430789287364', 1, 1, 'SR', NULL, NULL, NULL),
(61065, '2018-01-20 14:42:57', NULL, NULL, 16236, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:42:57', 'admin-1516415730-15164305768953061', 1, 1, 'SR', NULL, NULL, NULL),
(61066, '2018-01-20 15:24:15', NULL, NULL, 16243, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:24:15', 'admin-1516415730-15164330551691014', 1, 0, '', NULL, NULL, NULL),
(61067, '2018-01-20 12:05:47', NULL, NULL, 16228, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:05:47', 'admin-1516415730-1516421147027767', 1, 0, '', 1, NULL, NULL),
(61068, '2018-01-20 14:34:50', NULL, NULL, 16236, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:34:50', 'admin-1516415730-15164300904136698', 1, 0, '', NULL, '20.0', NULL),
(61069, '2018-01-20 14:34:50', NULL, NULL, 16236, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:34:50', 'admin-1516415730-15164300904136698', 1, 0, '', NULL, '20.0', NULL),
(61070, '2018-01-20 14:29:45', NULL, NULL, 16235, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:29:45', 'admin-1516415730-15164297851785384', 1, 1, 'SR', NULL, NULL, NULL),
(61071, '2018-01-20 13:43:44', NULL, NULL, 16232, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 13:43:44', 'admin-1516415730-15164270244871565', 1, 1, 'SR', NULL, NULL, NULL),
(61072, '2018-01-20 10:02:57', NULL, NULL, 16213, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:02:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61073, '2018-01-20 09:23:55', NULL, NULL, 16211, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:23:55', 'admin-1516410116-15164114349331165', 1, 0, '', NULL, NULL, NULL),
(61074, '2018-01-20 09:23:55', NULL, NULL, 16211, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:23:55', 'admin-1516410116-15164114349331165', 1, 1, 'SR', NULL, NULL, NULL),
(61075, '2018-01-20 14:08:17', NULL, NULL, 16234, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:08:17', 'admin-1516415730-15164284978538819', 1, 1, 'SR', NULL, NULL, NULL),
(61076, '2018-01-20 14:29:36', NULL, NULL, 16235, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:29:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61077, '2018-01-20 14:08:17', NULL, NULL, 16234, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:08:17', 'admin-1516415730-15164284978538819', 1, 0, '', NULL, NULL, NULL),
(61078, '2018-01-20 14:08:17', NULL, NULL, 16234, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:08:17', 'admin-1516415730-15164284978538819', 1, 1, 'SR', NULL, NULL, NULL),
(61079, '2018-01-20 12:05:47', NULL, NULL, 16228, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:05:47', 'admin-1516415730-1516421147027767', 1, 0, '', 1, NULL, NULL),
(61080, '2018-01-20 11:45:07', NULL, NULL, 16226, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:45:07', 'admin-1516415730-15164199076698525', 1, 1, 'SR', NULL, NULL, NULL),
(61081, '2018-01-20 11:45:07', NULL, NULL, 16226, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:45:07', 'admin-1516415730-15164199076698525', 1, 0, '', NULL, NULL, NULL),
(61082, '2018-01-20 14:54:01', NULL, NULL, 16238, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:54:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61083, '2018-01-20 11:45:07', NULL, NULL, 16226, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:45:07', 'admin-1516415730-15164199076698525', 1, 1, 'SR', NULL, NULL, NULL),
(61084, '2018-01-20 11:18:36', NULL, NULL, 16222, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:18:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61085, '2018-01-20 11:19:25', NULL, NULL, 16222, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:19:25', 'admin-1516415730-1516418365327949', 1, 1, 'SR', NULL, NULL, NULL),
(61086, '2018-01-20 11:19:25', NULL, NULL, 16222, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:19:25', 'admin-1516415730-1516418365327949', 1, 1, 'SR', NULL, NULL, NULL),
(61087, '2018-01-20 12:31:44', NULL, NULL, 16229, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:31:44', 'admin-1516415730-15164227048699217', 1, 0, '', NULL, NULL, NULL),
(61088, '2018-01-20 11:44:00', NULL, NULL, 16224, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:44:00', 'admin-1516415730-15164198406399198', 1, 0, '', NULL, NULL, NULL),
(61089, '2018-01-20 11:44:00', NULL, NULL, 16224, 0, 181, '116', 'Open Food ', 'stewed pork-rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:44:00', 'admin-1516415730-15164198406399198', 1, 0, '', NULL, NULL, NULL),
(61090, '2018-01-20 11:44:57', NULL, NULL, 16226, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:44:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61091, '2018-01-20 12:26:31', NULL, NULL, 16230, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:26:31', 'admin-1516415730-15164223917507246', 1, 1, 'SR', NULL, NULL, NULL),
(61092, '2018-01-20 12:26:31', NULL, NULL, 16230, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:26:31', 'admin-1516415730-15164223917507246', 1, 1, 'SR', NULL, NULL, NULL),
(61093, '2018-01-20 15:03:19', NULL, NULL, 16240, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:03:19', 'admin-1516415730-1516431798883977', 1, 0, '', NULL, NULL, NULL),
(61094, '2018-01-20 12:26:31', NULL, NULL, 16230, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:26:31', 'admin-1516415730-15164223917507246', 1, 0, '', NULL, NULL, NULL),
(61095, '2018-01-20 12:26:31', NULL, NULL, 16230, 0, 181, '116', 'Open Food ', 'Rice set', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:26:31', 'admin-1516415730-15164223917507246', 1, 0, '', NULL, NULL, NULL),
(61096, '2018-01-20 12:12:20', NULL, NULL, 16229, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:12:20', 'admin-1516415730-1516421540200815', 1, 0, '', NULL, NULL, NULL),
(61097, '2018-01-20 10:56:58', NULL, NULL, 16218, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:56:58', 'admin-1516415730-15164170184413511', 1, 0, '', NULL, NULL, NULL),
(61098, '2018-01-20 10:56:58', NULL, NULL, 16218, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:56:58', 'admin-1516415730-15164170184413511', 1, 1, 'SR', NULL, NULL, NULL),
(61099, '2018-01-20 16:02:37', NULL, NULL, 16243, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 16:02:37', 'admin-1516415730-15164353571618846', 1, 0, '', NULL, NULL, NULL),
(61100, '2018-01-20 12:05:47', NULL, NULL, 16228, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:05:47', 'admin-1516415730-1516421147027767', 1, 0, '', 1, NULL, NULL),
(61101, '2018-01-20 16:17:29', NULL, NULL, 16244, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 16:17:29', 'admin-1516415730-15164362494826724', 1, 1, 'SR', NULL, NULL, NULL),
(61102, '2018-01-20 12:12:20', NULL, NULL, 16229, 0, 181, '116', 'Open Food ', 'Rice set', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:12:20', 'admin-1516415730-1516421540200815', 1, 0, '', NULL, NULL, NULL),
(61103, '2018-01-20 12:11:47', NULL, NULL, 16229, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.90, 0.0000, 0.0000, 10.90, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:11:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61104, '2018-01-20 11:40:30', NULL, NULL, 16225, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:40:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61105, '2018-01-20 12:05:47', NULL, NULL, 16228, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:05:47', 'admin-1516415730-1516421147027767', 1, 0, '', 1, NULL, NULL),
(61106, '2018-01-20 12:26:31', NULL, NULL, 16230, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:26:31', 'admin-1516415730-15164223917507246', 1, 0, '', NULL, NULL, NULL),
(61107, '2018-01-20 13:49:41', NULL, NULL, 16233, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 13:49:41', 'admin-1516415730-15164273810791845', 1, 0, '', NULL, NULL, NULL),
(61108, '2018-01-20 16:17:11', NULL, NULL, 16244, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1516441999', 'admin', '2018-01-20 16:17:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61109, '2018-01-20 15:24:15', NULL, NULL, 16243, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 15:24:15', 'admin-1516415730-15164330551691014', 1, 0, '', NULL, NULL, NULL),
(61110, '2018-01-20 12:26:31', NULL, NULL, 16230, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:26:31', 'admin-1516415730-15164223917507246', 1, 0, '', NULL, NULL, NULL),
(61111, '2018-01-20 11:42:43', NULL, NULL, 16225, 0, 181, '116', 'Open Food ', 'stewed pork-noodle', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:42:43', 'admin-1516415730-15164197632332976', 1, 0, '', NULL, NULL, NULL),
(61112, '2018-01-20 10:50:11', NULL, NULL, 16217, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:50:11', 'admin-1516415730-15164166114934265', 1, 0, '', NULL, NULL, NULL),
(61113, '2018-01-20 10:54:50', NULL, NULL, 16217, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:54:50', 'admin-1516415730-15164168905213529', 1, 0, '', NULL, NULL, NULL),
(61114, '2018-01-20 10:03:19', NULL, NULL, 16213, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:03:19', 'admin-1516410116-15164137992133399', 1, 0, '', NULL, NULL, NULL),
(61115, '2018-01-20 12:05:47', NULL, NULL, 16228, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 12:05:47', 'admin-1516415730-1516421147027767', 1, 0, '', 1, NULL, NULL),
(61116, '2018-01-20 14:35:35', NULL, NULL, 16236, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 14:35:35', 'admin-1516415730-15164301354789223', 1, 1, 'SR', NULL, NULL, NULL),
(61117, '2018-01-20 10:57:22', NULL, NULL, 16219, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:57:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61118, '2018-01-20 10:57:56', NULL, NULL, 16219, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:57:56', 'admin-1516415730-15164170764785735', 1, 0, '', NULL, NULL, NULL),
(61119, '2018-01-20 11:42:43', NULL, NULL, 16225, 0, 181, '116', 'Open Food ', 'stewed pork-rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:42:43', 'admin-1516415730-15164197632332976', 1, 0, '', NULL, NULL, NULL),
(61120, '2018-01-20 11:37:20', NULL, NULL, 16224, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:37:20', 'admin-1516415730-15164194402022463', 1, 1, 'SR', NULL, NULL, NULL),
(61121, '2018-01-20 13:49:41', NULL, NULL, 16233, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 13:49:41', 'admin-1516415730-15164273810791845', 1, 0, '', NULL, NULL, NULL),
(61122, '2018-01-20 11:45:07', NULL, NULL, 16226, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:45:07', 'admin-1516415730-15164199076698525', 1, 0, '', NULL, NULL, NULL),
(61123, '2018-01-20 10:50:11', NULL, NULL, 16217, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:50:11', 'admin-1516415730-15164166114934265', 1, 1, 'SR', NULL, NULL, NULL),
(61124, '2018-01-20 10:11:58', NULL, NULL, 16215, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:11:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61125, '2018-01-20 10:12:27', NULL, NULL, 16215, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:12:27', 'admin-1516410116-15164143472293792', 1, 0, '', NULL, NULL, NULL),
(61126, '2018-01-20 11:19:25', NULL, NULL, 16222, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:19:25', 'admin-1516415730-1516418365327949', 1, 1, 'SR', NULL, NULL, NULL),
(61127, '2018-01-20 11:19:25', NULL, NULL, 16222, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:19:25', 'admin-1516415730-1516418365327949', 1, 0, '', NULL, NULL, NULL),
(61128, '2018-01-20 11:12:21', NULL, NULL, 16221, 0, 331, '267', 'Yuzu Marmalade Pancake', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:12:21', 'admin-1516415730-1516417941036363', 1, 0, '', NULL, NULL, NULL),
(61129, '2018-01-20 11:12:21', NULL, NULL, 16221, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:12:21', 'admin-1516415730-1516417941036363', 1, 0, '', NULL, NULL, NULL),
(61130, '2018-01-20 11:12:21', NULL, NULL, 16221, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:12:21', 'admin-1516415730-1516417941036363', 1, 1, 'SR', NULL, NULL, NULL),
(61131, '2018-01-20 11:37:16', NULL, NULL, 16224, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:37:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61132, '2018-01-20 10:59:08', NULL, NULL, 16220, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:59:08', 'admin-1516415730-15164171481377871', 1, 0, '', NULL, NULL, NULL),
(61133, '2018-01-20 11:20:51', NULL, NULL, 16223, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:20:51', 'admin-1516415730-15164184517057534', 1, 1, 'SR', 1, NULL, NULL),
(61134, '2018-01-20 10:59:08', NULL, NULL, 16220, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:59:08', 'admin-1516415730-15164171481377871', 1, 0, '', NULL, NULL, NULL),
(61135, '2018-01-20 10:59:08', NULL, NULL, 16220, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:59:08', 'admin-1516415730-15164171481377871', 1, 0, '', NULL, NULL, NULL),
(61136, '2018-01-20 10:58:26', NULL, NULL, 16220, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:58:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61137, '2018-01-20 10:57:56', NULL, NULL, 16219, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:57:56', 'admin-1516415730-15164170764785735', 1, 1, 'SR', NULL, NULL, NULL),
(61138, '2018-01-20 10:57:56', NULL, NULL, 16219, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:57:56', 'admin-1516415730-15164170764785735', 1, 1, 'SR', NULL, NULL, NULL),
(61139, '2018-01-20 10:03:19', NULL, NULL, 16213, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:03:19', 'admin-1516410116-15164137992133399', 1, 1, 'SR', NULL, NULL, NULL),
(61140, '2018-01-20 10:05:15', NULL, NULL, 16214, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.52, 0.0000, 0.0000, 3.52, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:05:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61141, '2018-01-20 10:05:58', NULL, NULL, 16214, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:05:58', 'admin-1516410116-15164139583614198', 1, 1, 'SR', NULL, NULL, NULL),
(61142, '2018-01-20 13:43:44', NULL, NULL, 16232, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 13:43:44', 'admin-1516415730-15164270244871565', 1, 1, 'SR', NULL, NULL, NULL),
(61143, '2018-01-20 10:56:24', NULL, NULL, 16218, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.69, 0.0000, 0.0000, 4.69, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:56:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61144, '2018-01-20 10:50:11', NULL, NULL, 16217, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:50:11', 'admin-1516415730-15164166114934265', 1, 0, '', NULL, '20.0', NULL),
(61145, '2018-01-20 10:13:14', NULL, NULL, 16216, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:13:14', 'admin-1516410116-1516414394147644', 1, 0, '', NULL, NULL, NULL),
(61146, '2018-01-20 10:13:14', NULL, NULL, 16216, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:13:14', 'admin-1516410116-1516414394147644', 1, 0, '', NULL, NULL, NULL),
(61147, '2018-01-20 10:49:50', NULL, NULL, 16217, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.86, 0.0000, 0.0000, 3.86, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:49:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61148, '2018-01-20 11:19:25', NULL, NULL, 16222, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:19:25', 'admin-1516415730-1516418365327949', 1, 1, 'SR', NULL, NULL, NULL),
(61149, '2018-01-20 10:13:03', NULL, NULL, 16216, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:13:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61150, '2018-01-20 10:12:27', NULL, NULL, 16215, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:12:27', 'admin-1516410116-15164143472293792', 1, 0, '', NULL, NULL, NULL),
(61151, '2018-01-20 09:49:57', NULL, NULL, 16212, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:49:57', 'admin-1516410116-1516412997248144', 1, 0, '', NULL, NULL, NULL),
(61152, '2018-01-20 09:55:26', NULL, NULL, 16212, 0, 271, '205', 'Take It Easy', 'sunny side up egg', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:55:26', 'admin-1516410116-15164133264883774', 1, 0, '', NULL, NULL, NULL),
(61153, '2018-01-20 10:12:27', NULL, NULL, 16215, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:12:27', 'admin-1516410116-15164143472293792', 1, 0, '', NULL, NULL, NULL),
(61154, '2018-01-20 10:12:27', NULL, NULL, 16215, 0, 269, '203', 'Espresso Con Panna', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:12:27', 'admin-1516410116-15164143472293792', 1, 0, '', NULL, NULL, NULL),
(61155, '2018-01-20 10:05:58', NULL, NULL, 16214, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:05:58', 'admin-1516410116-15164139583614198', 1, 0, '', NULL, '20.0', NULL),
(61156, '2018-01-20 10:05:58', NULL, NULL, 16214, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:05:58', 'admin-1516410116-15164139583614198', 1, 0, '', NULL, '20.0', NULL),
(61157, '2018-01-20 10:05:58', NULL, NULL, 16214, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:05:58', 'admin-1516410116-15164139583614198', 1, 1, 'SR', NULL, NULL, NULL),
(61158, '2018-01-20 11:11:54', NULL, NULL, 16221, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1516441999', 'admin', '2018-01-20 11:11:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61159, '2018-01-20 10:03:19', NULL, NULL, 16213, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:03:19', 'admin-1516410116-15164137992133399', 1, 1, 'SR', NULL, NULL, NULL),
(61160, '2018-01-20 10:03:19', NULL, NULL, 16213, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 10:03:19', 'admin-1516410116-15164137992133399', 1, 0, '', NULL, NULL, NULL),
(61161, '2018-01-20 09:49:39', NULL, NULL, 16212, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:49:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61162, '2018-01-20 09:49:57', NULL, NULL, 16212, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:49:57', 'admin-1516410116-1516412997248144', 1, 0, '', NULL, NULL, NULL),
(61163, '2018-01-20 09:49:57', NULL, NULL, 16212, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:49:57', 'admin-1516410116-1516412997248144', 1, 1, 'SR', NULL, NULL, NULL),
(61164, '2018-01-20 09:16:52', NULL, NULL, 16209, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:16:52', 'admin-1516410116-15164110123043467', 1, 0, '', NULL, NULL, NULL),
(61165, '2018-01-20 09:19:42', NULL, NULL, 16210, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:19:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61166, '2018-01-20 09:12:04', NULL, NULL, 16208, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:12:04', 'admin-1516410116-15164107248131662', 1, 0, '', NULL, NULL, NULL),
(61167, '2018-01-20 09:12:04', NULL, NULL, 16208, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:12:04', 'admin-1516410116-15164107248131662', 1, 0, '', NULL, NULL, NULL),
(61168, '2018-01-20 09:11:35', NULL, NULL, 16207, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:11:35', 'admin-1516410116-15164106953975920', 1, 0, '', NULL, NULL, NULL),
(61169, '2018-01-20 09:19:58', NULL, NULL, 16210, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:19:58', 'admin-1516410116-15164111980925638', 1, 0, '', NULL, NULL, NULL),
(61170, '2018-01-20 09:19:58', NULL, NULL, 16210, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:19:58', 'admin-1516410116-15164111980925638', 1, 0, '', NULL, NULL, NULL),
(61171, '2018-01-20 09:19:58', NULL, NULL, 16210, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:19:58', 'admin-1516410116-15164111980925638', 1, 1, 'SR', NULL, NULL, NULL),
(61172, '2018-01-20 09:22:39', NULL, NULL, 16211, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 11.90, 0.0000, 0.0000, 11.90, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:22:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61173, '2018-01-20 09:23:55', NULL, NULL, 16211, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:23:55', 'admin-1516410116-15164114349331165', 1, 0, '', NULL, NULL, NULL),
(61174, '2018-01-20 09:23:55', NULL, NULL, 16211, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:23:55', 'admin-1516410116-15164114349331165', 1, 0, '', NULL, NULL, NULL),
(61175, '2018-01-20 09:23:55', NULL, NULL, 16211, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:23:55', 'admin-1516410116-15164114349331165', 1, 0, '', NULL, NULL, NULL),
(61176, '2018-01-20 09:23:55', NULL, NULL, 16211, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:23:55', 'admin-1516410116-15164114349331165', 1, 0, '', NULL, NULL, NULL),
(61177, '2018-01-20 09:23:55', NULL, NULL, 16211, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:23:55', 'admin-1516410116-15164114349331165', 1, 0, '', NULL, NULL, NULL),
(61178, '2018-01-20 09:23:55', NULL, NULL, 16211, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:23:55', 'admin-1516410116-15164114349331165', 1, 1, 'SR', NULL, NULL, NULL),
(61179, '2018-01-20 09:16:52', NULL, NULL, 16209, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:16:52', 'admin-1516410116-15164110123043467', 1, 1, 'SR', NULL, NULL, NULL),
(61180, '2018-01-20 09:16:44', NULL, NULL, 16209, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:16:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61181, '2018-01-20 09:12:04', NULL, NULL, 16208, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:12:04', 'admin-1516410116-15164107248131662', 1, 1, 'SR', NULL, NULL, NULL),
(61182, '2018-01-20 09:12:04', NULL, NULL, 16208, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:12:04', 'admin-1516410116-15164107248131662', 1, 1, 'SR', NULL, NULL, NULL),
(61183, '2018-01-20 09:11:46', NULL, NULL, 16208, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:11:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61184, '2018-01-20 09:11:35', NULL, NULL, 16207, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:11:35', 'admin-1516410116-15164106953975920', 1, 1, 'SR', NULL, NULL, NULL),
(61185, '2018-01-20 09:11:25', NULL, NULL, 16207, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1516441999', 'admin', '2018-01-20 09:11:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61186, '2018-01-21 14:06:57', NULL, NULL, 16285, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:06:57', 'admin-1516509965-1516514817484378', 1, 0, '', NULL, NULL, NULL),
(61187, '2018-01-21 14:07:54', NULL, NULL, 16285, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:07:54', 'admin-1516509965-1516514874584283', 1, 1, 'SR', NULL, NULL, NULL),
(61188, '2018-01-21 14:28:00', NULL, NULL, 16287, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:28:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61189, '2018-01-21 14:24:39', NULL, NULL, 16285, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Rice', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:24:39', 'admin-1516509965-15165158796632990', 1, 0, '', NULL, NULL, NULL),
(61190, '2018-01-21 14:19:16', NULL, NULL, 16286, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:19:16', 'admin-1516509965-15165155566592733', 1, 0, '', NULL, NULL, NULL),
(61191, '2018-01-21 14:19:16', NULL, NULL, 16286, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:19:16', 'admin-1516509965-15165155566592733', 1, 0, '', NULL, NULL, NULL),
(61192, '2018-01-21 14:19:16', NULL, NULL, 16286, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:19:16', 'admin-1516509965-15165155566592733', 1, 0, '', NULL, NULL, NULL),
(61193, '2018-01-21 11:41:45', NULL, NULL, 16271, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:41:45', 'admin-1516496615-15165061058303225', 1, 0, '', NULL, NULL, NULL),
(61194, '2018-01-21 11:41:45', NULL, NULL, 16271, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:41:45', 'admin-1516496615-15165061058303225', 1, 0, '', NULL, NULL, NULL),
(61195, '2018-01-21 11:41:45', NULL, NULL, 16271, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:41:45', 'admin-1516496615-15165061058303225', 1, 0, '', NULL, NULL, NULL),
(61196, '2018-01-21 11:41:46', NULL, NULL, 16271, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:41:46', 'admin-1516496615-15165061058303225', 1, 0, '', NULL, '20.0', NULL),
(61197, '2018-01-21 11:41:46', NULL, NULL, 16271, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:41:46', 'admin-1516496615-15165061058303225', 1, 1, 'SR', NULL, NULL, NULL),
(61198, '2018-01-21 11:41:46', NULL, NULL, 16271, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:41:46', 'admin-1516496615-15165061058303225', 1, 1, 'SR', NULL, NULL, NULL),
(61199, '2018-01-21 11:42:08', NULL, NULL, 16272, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:42:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61200, '2018-01-21 16:12:57', NULL, NULL, 16296, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 16:12:57', 'admin-1516509965-15165223778517145', 1, 0, '', NULL, NULL, NULL),
(61201, '2018-01-21 16:15:15', NULL, NULL, 16289, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 16:15:15', 'admin-1516509965-1516522515325281', 1, 1, 'SR', NULL, NULL, NULL),
(61202, '2018-01-21 16:44:19', NULL, NULL, 16297, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 16:44:19', 'admin-1516509965-1516524259849875', 1, 1, 'SR', NULL, NULL, NULL),
(61203, '2018-01-21 13:13:17', NULL, NULL, 16281, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 13:13:17', 'admin-1516509965-1516511597359965', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(61204, '2018-01-21 12:49:11', NULL, NULL, 16269, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:49:11', 'admin-1516509965-1516510150927247', 1, 0, '', NULL, NULL, NULL),
(61205, '2018-01-21 11:37:29', NULL, NULL, 16270, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:37:29', 'admin-1516496615-15165058492556047', 1, 0, '', NULL, NULL, NULL),
(61206, '2018-01-21 11:39:03', NULL, NULL, 16270, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:39:03', 'admin-1516496615-1516505943543424', 1, 1, 'SR', NULL, NULL, NULL),
(61207, '2018-01-21 11:39:03', NULL, NULL, 16270, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:39:03', 'admin-1516496615-1516505943543424', 1, 1, 'SR', NULL, NULL, NULL),
(61208, '2018-01-21 11:41:07', NULL, NULL, 16271, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:41:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61209, '2018-01-21 12:51:53', NULL, NULL, 16278, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:51:53', 'admin-1516509965-1516510313240625', 1, 0, '', NULL, NULL, NULL),
(61210, '2018-01-21 12:51:53', NULL, NULL, 16278, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:51:53', 'admin-1516509965-1516510313240625', 1, 0, '', NULL, NULL, NULL),
(61211, '2018-01-21 12:55:52', NULL, NULL, 16279, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:55:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61212, '2018-01-21 11:18:27', NULL, NULL, 16266, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:18:27', 'admin-1516496615-15165047078514949', 1, 0, '', NULL, NULL, NULL),
(61213, '2018-01-21 13:54:22', NULL, NULL, 16284, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 13:54:22', 'admin-1516509965-15165140621599732', 1, 0, '', NULL, NULL, NULL),
(61214, '2018-01-21 11:17:37', NULL, NULL, 16258, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:17:37', 'admin-1516496615-15165046576069347', 1, 1, 'SR', NULL, NULL, NULL),
(61215, '2018-01-21 11:18:14', NULL, NULL, 16266, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:18:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61216, '2018-01-21 12:26:49', NULL, NULL, 16274, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:26:49', 'admin-1516496615-15165088089824471', 1, 0, '', NULL, NULL, NULL),
(61217, '2018-01-21 12:26:49', NULL, NULL, 16274, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:26:49', 'admin-1516496615-15165088089824471', 1, 0, '', NULL, NULL, NULL),
(61218, '2018-01-21 14:05:53', NULL, NULL, 16285, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 11.60, 0.0000, 0.0000, 11.60, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:05:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61219, '2018-01-21 14:06:57', NULL, NULL, 16285, 0, 181, '116', 'Open Food ', 'Curry rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:06:57', 'admin-1516509965-1516514817484378', 1, 0, '', NULL, NULL, NULL),
(61220, '2018-01-21 14:06:57', NULL, NULL, 16285, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:06:57', 'admin-1516509965-1516514817484378', 1, 0, '', NULL, NULL, NULL),
(61221, '2018-01-21 14:08:26', NULL, NULL, 16285, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:08:26', 'admin-1516509965-15165149061283549', 1, 0, '', NULL, NULL, NULL),
(61222, '2018-01-21 14:06:57', NULL, NULL, 16285, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:06:57', 'admin-1516509965-1516514817484378', 1, 0, '', NULL, NULL, NULL),
(61223, '2018-01-21 12:39:55', NULL, NULL, 16276, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:39:55', 'admin-1516496615-15165095949034240', 1, 1, 'SR', 1, NULL, NULL),
(61224, '2018-01-21 12:43:21', NULL, NULL, 16277, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:43:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61225, '2018-01-21 12:45:28', NULL, NULL, 16277, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:45:28', 'admin-1516496615-15165099287972795', 1, 1, 'SR', NULL, NULL, NULL),
(61226, '2018-01-21 12:45:28', NULL, NULL, 16277, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:45:28', 'admin-1516496615-15165099287972795', 1, 1, 'SR', NULL, NULL, NULL),
(61227, '2018-01-21 12:46:58', NULL, NULL, 16277, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:46:58', 'admin-1516509965-15165100181264485', 1, 0, '', NULL, NULL, NULL),
(61228, '2018-01-21 11:18:21', NULL, NULL, 16266, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:18:21', 'admin-1516496615-1516504701058128', 1, 0, '', NULL, NULL, NULL),
(61229, '2018-01-21 11:18:21', NULL, NULL, 16266, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:18:21', 'admin-1516496615-1516504701058128', 1, 0, '', NULL, NULL, NULL),
(61230, '2018-01-21 15:27:12', NULL, NULL, 16287, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:27:12', 'admin-1516509965-15165196323634974', 1, 0, '', NULL, NULL, NULL),
(61231, '2018-01-21 15:46:46', NULL, NULL, 16289, 0, 73, '73', 'Marmite Chicken ', 'Pasta', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:46:46', 'admin-1516509965-15165208065479357', 1, 1, 'SR', NULL, NULL, NULL),
(61232, '2018-01-21 15:48:05', NULL, NULL, 16292, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:48:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61233, '2018-01-21 15:48:10', NULL, NULL, 16292, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:48:10', 'admin-1516509965-1516520890237639', 1, 1, 'SR', NULL, NULL, NULL),
(61234, '2018-01-21 15:52:21', NULL, NULL, 16293, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:52:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61235, '2018-01-21 15:52:26', NULL, NULL, 16293, 0, 339, '275', '100+', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:52:26', 'admin-1516509965-15165211466117675', 1, 0, '', NULL, NULL, NULL),
(61236, '2018-01-21 15:53:52', NULL, NULL, 16294, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:53:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61237, '2018-01-21 15:12:27', NULL, NULL, 16290, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:12:27', 'admin-1516509965-15165187477349191', 1, 0, '', NULL, NULL, NULL),
(61238, '2018-01-21 15:19:43', NULL, NULL, 16291, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:19:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61239, '2018-01-21 15:20:34', NULL, NULL, 16291, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:20:34', 'admin-1516509965-15165192345439475', 1, 0, '', NULL, NULL, NULL),
(61240, '2018-01-21 15:20:34', NULL, NULL, 16291, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:20:34', 'admin-1516509965-15165192345439475', 1, 0, '', NULL, NULL, NULL),
(61241, '2018-01-21 15:20:34', NULL, NULL, 16291, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:20:34', 'admin-1516509965-15165192345439475', 1, 0, '', NULL, NULL, NULL),
(61242, '2018-01-21 13:54:18', NULL, NULL, 16284, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.40, 0.0000, 0.0000, 0.40, 1, '27', 1, '1516509965', 'admin', '2018-01-21 13:54:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61243, '2018-01-21 13:50:04', NULL, NULL, 16283, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 13:50:04', 'admin-1516509965-1516513804804321', 1, 0, '', NULL, NULL, NULL),
(61244, '2018-01-21 13:07:04', NULL, NULL, 16280, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 13:07:04', 'admin-1516509965-15165112243822884', 1, 1, 'SR', NULL, NULL, NULL),
(61245, '2018-01-21 13:07:04', NULL, NULL, 16280, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 13:07:04', 'admin-1516509965-15165112243822884', 1, 0, '', NULL, NULL, NULL),
(61246, '2018-01-21 13:50:04', NULL, NULL, 16283, 0, 291, '225', 'Smoked Duck Red Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 13:50:04', 'admin-1516509965-1516513804804321', 1, 0, '', NULL, NULL, NULL),
(61247, '2018-01-21 13:49:15', NULL, NULL, 16283, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1516509965', 'admin', '2018-01-21 13:49:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61248, '2018-01-21 13:50:04', NULL, NULL, 16283, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 13:50:04', 'admin-1516509965-1516513804804321', 1, 0, '', NULL, NULL, NULL),
(61249, '2018-01-21 15:06:30', NULL, NULL, 16289, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:06:30', 'admin-1516509965-15165183904258047', 1, 1, 'SR', NULL, NULL, NULL),
(61250, '2018-01-21 15:06:30', NULL, NULL, 16289, 0, 181, '116', 'Open Food ', 'curry rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:06:30', 'admin-1516509965-15165183904258047', 1, 0, '', NULL, NULL, NULL),
(61251, '2018-01-21 09:04:18', NULL, NULL, 16250, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:04:18', 'admin-1516496615-15164966587931987', 1, 1, 'SR', NULL, NULL, NULL),
(61252, '2018-01-21 13:08:45', NULL, NULL, 16274, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1516509965', 'admin', '2018-01-21 13:08:45', 'admin-1516509965-15165113256288768', 1, 0, '', NULL, '20.0', NULL),
(61253, '2018-01-21 11:31:04', NULL, NULL, 16268, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:31:04', 'admin-1516496615-15165054641786521', 1, 0, '', NULL, NULL, NULL),
(61254, '2018-01-21 13:15:57', NULL, NULL, 16282, 0, 181, '116', 'Open Food ', 'curry rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 16.20, 1, '27', 1, '1516509965', 'admin', '2018-01-21 13:15:57', 'admin-1516509965-1516511757234110', 1, 0, '', 1, '10.0', NULL),
(61255, '2018-01-21 13:15:57', NULL, NULL, 16282, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 13:15:57', 'admin-1516509965-1516511757234110', 1, 1, 'SR', 1, NULL, NULL),
(61256, '2018-01-21 13:28:53', NULL, NULL, 16280, 0, 291, '225', 'Smoked Duck Red Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 13:28:53', 'admin-1516509965-15165125337356527', 1, 0, '', NULL, NULL, NULL),
(61257, '2018-01-21 11:37:16', NULL, NULL, 16270, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 12.86, 0.0000, 0.0000, 12.86, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:37:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61258, '2018-01-21 10:35:09', NULL, NULL, 16260, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:35:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61259, '2018-01-21 10:35:39', NULL, NULL, 16260, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:35:39', 'admin-1516496615-15165021393399722', 1, 0, '', NULL, NULL, NULL),
(61260, '2018-01-21 13:13:17', NULL, NULL, 16281, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 13:13:17', 'admin-1516509965-1516511597359965', 1, 0, '', NULL, NULL, NULL),
(61261, '2018-01-21 13:13:17', NULL, NULL, 16281, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 13:13:17', 'admin-1516509965-1516511597359965', 1, 1, 'SR', NULL, NULL, NULL),
(61262, '2018-01-21 11:31:04', NULL, NULL, 16268, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:31:04', 'admin-1516496615-15165054641786521', 1, 0, '', NULL, NULL, NULL),
(61263, '2018-01-21 15:57:26', NULL, NULL, 16296, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:57:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61264, '2018-01-21 12:49:11', NULL, NULL, 16269, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:49:11', 'admin-1516509965-1516510150927247', 1, 0, '', NULL, NULL, NULL),
(61265, '2018-01-21 12:50:06', NULL, NULL, 16278, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:50:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61266, '2018-01-21 12:48:55', NULL, NULL, 16275, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:48:55', 'admin-1516509965-15165101350231744', 1, 1, 'SR', NULL, NULL, NULL),
(61267, '2018-01-21 13:28:53', NULL, NULL, 16280, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 13:28:53', 'admin-1516509965-15165125337356527', 1, 0, '', NULL, NULL, NULL),
(61268, '2018-01-21 13:08:45', NULL, NULL, 16274, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 13:08:45', 'admin-1516509965-15165113256288768', 1, 0, '', NULL, NULL, NULL),
(61269, '2018-01-21 12:30:59', NULL, NULL, 16275, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:30:59', 'admin-1516496615-15165090594447580', 1, 0, '', NULL, NULL, NULL),
(61270, '2018-01-21 12:30:59', NULL, NULL, 16275, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:30:59', 'admin-1516496615-15165090594447580', 1, 0, '', NULL, NULL, NULL),
(61271, '2018-01-21 12:30:59', NULL, NULL, 16275, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:30:59', 'admin-1516496615-15165090594447580', 1, 1, 'SR', NULL, NULL, NULL),
(61272, '2018-01-21 11:43:47', NULL, NULL, 16269, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:43:47', 'admin-1516496615-15165062272701797', 1, 0, '', NULL, '20.0', NULL),
(61273, '2018-01-21 13:08:45', NULL, NULL, 16274, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 13:08:45', 'admin-1516509965-15165113256288768', 1, 1, 'SR', NULL, NULL, NULL),
(61274, '2018-01-21 13:07:04', NULL, NULL, 16280, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 13:07:04', 'admin-1516509965-15165112243822884', 1, 0, '', NULL, NULL, NULL),
(61275, '2018-01-21 11:36:02', NULL, NULL, 16269, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.76, 0.0000, 0.0000, 9.76, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:36:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61276, '2018-01-21 11:36:05', NULL, NULL, 16269, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:36:05', 'admin-1516496615-1516505765187183', 1, 1, 'SR', NULL, NULL, NULL),
(61277, '2018-01-21 14:55:07', NULL, NULL, 16288, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.26, 0.0000, 0.0000, 3.26, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:55:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61278, '2018-01-21 14:55:15', NULL, NULL, 16288, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:55:15', 'admin-1516509965-15165177156047583', 1, 1, 'SR', NULL, NULL, NULL),
(61279, '2018-01-21 11:43:47', NULL, NULL, 16269, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:43:47', 'admin-1516496615-15165062272701797', 1, 1, 'SR', NULL, NULL, NULL),
(61280, '2018-01-21 12:57:38', NULL, NULL, 16280, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:57:38', 'admin-1516509965-15165106579184627', 1, 0, '', NULL, NULL, NULL),
(61281, '2018-01-21 12:57:38', NULL, NULL, 16280, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:57:38', 'admin-1516509965-15165106579184627', 1, 0, '', NULL, NULL, NULL),
(61282, '2018-01-21 10:54:28', NULL, NULL, 16262, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.90, 0.0000, 0.0000, 9.90, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:54:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61283, '2018-01-21 10:55:42', NULL, NULL, 16262, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:55:42', 'admin-1516496615-15165033425265458', 1, 0, '', NULL, NULL, NULL),
(61284, '2018-01-21 15:12:04', NULL, NULL, 16290, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:12:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61285, '2018-01-21 15:57:38', NULL, NULL, 16296, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:57:38', 'admin-1516509965-15165214581044697', 1, 1, 'SR', NULL, NULL, NULL),
(61286, '2018-01-21 15:57:38', NULL, NULL, 16296, 0, 337, '273', 'Hot yuzu', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:57:38', 'admin-1516509965-15165214581044697', 1, 0, '', NULL, NULL, NULL),
(61287, '2018-01-21 10:19:20', NULL, NULL, 16253, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:19:20', 'admin-1516496615-15165011606988218', 1, 0, '', NULL, NULL, NULL),
(61288, '2018-01-21 09:51:36', NULL, NULL, 16254, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:51:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61289, '2018-01-21 09:52:24', NULL, NULL, 16254, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:52:24', 'admin-1516496615-15164995441347182', 1, 0, '', NULL, NULL, NULL),
(61290, '2018-01-21 12:57:38', NULL, NULL, 16280, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:57:38', 'admin-1516509965-15165106579184627', 1, 0, '', NULL, NULL, NULL),
(61291, '2018-01-21 12:57:38', NULL, NULL, 16280, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:57:38', 'admin-1516509965-15165106579184627', 1, 0, '', NULL, NULL, NULL),
(61292, '2018-01-21 12:57:11', NULL, NULL, 16280, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 16.60, 0.0000, 0.0000, 16.60, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:57:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61293, '2018-01-21 12:56:13', NULL, NULL, 16279, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:56:13', 'admin-1516509965-15165105732481851', 1, 1, 'SR', NULL, NULL, NULL),
(61294, '2018-01-21 12:56:13', NULL, NULL, 16279, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:56:13', 'admin-1516509965-15165105732481851', 1, 1, 'SR', NULL, NULL, NULL),
(61295, '2018-01-21 11:13:06', NULL, NULL, 16264, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:13:06', 'admin-1516496615-15165043860548331', 1, 0, '', NULL, NULL, NULL),
(61296, '2018-01-21 16:44:15', NULL, NULL, 16297, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 16:44:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61297, '2018-01-21 15:55:57', NULL, NULL, 16295, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:55:57', 'admin-1516509965-15165213572745219', 1, 1, 'SR', NULL, NULL, NULL),
(61298, '2018-01-21 15:55:19', NULL, NULL, 16295, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:55:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61299, '2018-01-21 14:19:16', NULL, NULL, 16286, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:19:16', 'admin-1516509965-15165155566592733', 1, 0, '', NULL, NULL, NULL),
(61300, '2018-01-21 12:48:55', NULL, NULL, 16275, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:48:55', 'admin-1516509965-15165101350231744', 1, 0, '', NULL, NULL, NULL),
(61301, '2018-01-21 12:48:55', NULL, NULL, 16275, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:48:55', 'admin-1516509965-15165101350231744', 1, 0, '', NULL, NULL, NULL),
(61302, '2018-01-21 14:18:59', NULL, NULL, 16286, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:18:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61303, '2018-01-21 15:53:56', NULL, NULL, 16294, 0, 339, '275', '100+', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:53:56', 'admin-1516509965-15165212361132722', 1, 0, '', NULL, NULL, NULL),
(61304, '2018-01-21 15:27:12', NULL, NULL, 16287, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:27:12', 'admin-1516509965-15165196323634974', 1, 0, '', NULL, NULL, NULL),
(61305, '2018-01-21 15:20:34', NULL, NULL, 16291, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:20:34', 'admin-1516509965-15165192345439475', 1, 0, '', NULL, NULL, NULL),
(61306, '2018-01-21 15:12:27', NULL, NULL, 16290, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:12:27', 'admin-1516509965-15165187477349191', 1, 1, 'SR', NULL, NULL, NULL),
(61307, '2018-01-21 12:47:20', NULL, NULL, 16277, 0, 153, '87', 'Wake Me Up!', 'sunny', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:47:20', 'admin-1516509965-15165100399788369', 1, 0, '', NULL, NULL, NULL),
(61308, '2018-01-21 15:06:30', NULL, NULL, 16289, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:06:30', 'admin-1516509965-15165183904258047', 1, 1, 'SR', NULL, NULL, NULL),
(61309, '2018-01-21 14:55:15', NULL, NULL, 16288, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:55:15', 'admin-1516509965-15165177156047583', 1, 0, '', NULL, '20.0', NULL),
(61310, '2018-01-21 15:05:31', NULL, NULL, 16289, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:05:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61311, '2018-01-21 14:55:15', NULL, NULL, 16288, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:55:15', 'admin-1516509965-15165177156047583', 1, 1, 'SR', NULL, NULL, NULL),
(61312, '2018-01-21 11:17:04', NULL, NULL, 16265, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:17:04', 'admin-1516496615-15165046242423072', 1, 0, '', NULL, NULL, NULL),
(61313, '2018-01-21 14:28:11', NULL, NULL, 16287, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:28:11', 'admin-1516509965-15165160917578525', 1, 0, '', NULL, NULL, NULL),
(61314, '2018-01-21 14:36:31', NULL, NULL, 16287, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:36:31', 'admin-1516509965-15165165914071543', 1, 1, 'SR', NULL, NULL, NULL),
(61315, '2018-01-21 14:28:11', NULL, NULL, 16287, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:28:11', 'admin-1516509965-15165160917578525', 1, 0, '', NULL, NULL, NULL),
(61316, '2018-01-21 11:21:12', NULL, NULL, 16267, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:21:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61317, '2018-01-21 11:21:27', NULL, NULL, 16267, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:21:27', 'admin-1516496615-15165048877904824', 1, 0, '', NULL, NULL, NULL),
(61318, '2018-01-21 11:21:27', NULL, NULL, 16267, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:21:27', 'admin-1516496615-15165048877904824', 1, 1, 'SR', NULL, NULL, NULL),
(61319, '2018-01-21 11:29:48', NULL, NULL, 16268, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 15.70, 0.0000, 0.0000, 15.70, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:29:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61320, '2018-01-21 10:25:36', NULL, NULL, 16258, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:25:36', 'admin-1516496615-1516501536357977', 1, 0, '', NULL, NULL, NULL),
(61321, '2018-01-21 09:06:08', NULL, NULL, 16251, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:06:08', 'admin-1516496615-15164967687321853', 1, 1, 'SR', NULL, NULL, NULL),
(61322, '2018-01-21 09:06:08', NULL, NULL, 16251, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:06:08', 'admin-1516496615-15164967687321853', 1, 1, 'SR', NULL, NULL, NULL),
(61323, '2018-01-21 12:51:53', NULL, NULL, 16278, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:51:53', 'admin-1516509965-1516510313240625', 1, 0, '', NULL, NULL, NULL),
(61324, '2018-01-21 12:47:34', NULL, NULL, 16277, 0, 181, '116', 'Open Food ', 'sosej', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:47:34', 'admin-1516509965-15165100540779637', 1, 0, '', NULL, NULL, NULL),
(61325, '2018-01-21 12:19:47', NULL, NULL, 16273, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:19:47', 'admin-1516496615-15165083876453853', 1, 1, 'SR', NULL, NULL, NULL),
(61326, '2018-01-21 12:19:47', NULL, NULL, 16273, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:19:47', 'admin-1516496615-15165083876453853', 1, 1, 'SR', NULL, NULL, NULL),
(61327, '2018-01-21 12:19:38', NULL, NULL, 16273, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:19:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61328, '2018-01-21 12:04:12', NULL, NULL, 16270, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:04:12', 'admin-1516496615-1516507452829857', 1, 0, '', NULL, '20.0', NULL),
(61329, '2018-01-21 12:10:58', NULL, NULL, 16269, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:10:58', 'admin-1516496615-1516507857961271', 1, 0, '', NULL, NULL, NULL),
(61330, '2018-01-21 12:09:22', NULL, NULL, 16269, 0, 181, '116', 'Open Food ', 'curry rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:09:22', 'admin-1516496615-15165077624617199', 1, 0, '', NULL, NULL, NULL),
(61331, '2018-01-21 11:13:06', NULL, NULL, 16264, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:13:06', 'admin-1516496615-15165043860548331', 1, 0, '', NULL, NULL, NULL),
(61332, '2018-01-21 10:55:42', NULL, NULL, 16262, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:55:42', 'admin-1516496615-15165033425265458', 1, 1, 'SR', NULL, NULL, NULL),
(61333, '2018-01-21 10:59:35', NULL, NULL, 16263, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:59:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61334, '2018-01-21 11:00:00', NULL, NULL, 16263, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:00:00', 'admin-1516496615-15165036007776045', 1, 0, '', NULL, NULL, NULL),
(61335, '2018-01-21 10:55:42', NULL, NULL, 16262, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:55:42', 'admin-1516496615-15165033425265458', 1, 0, '', NULL, NULL, NULL),
(61336, '2018-01-21 10:55:42', NULL, NULL, 16262, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:55:42', 'admin-1516496615-15165033425265458', 1, 1, 'SR', NULL, NULL, NULL),
(61337, '2018-01-21 10:55:42', NULL, NULL, 16262, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:55:42', 'admin-1516496615-15165033425265458', 1, 1, 'SR', NULL, NULL, NULL),
(61338, '2018-01-21 12:57:38', NULL, NULL, 16280, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:57:38', 'admin-1516509965-15165106579184627', 1, 1, 'SR', NULL, NULL, NULL),
(61339, '2018-01-21 11:31:04', NULL, NULL, 16268, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:31:04', 'admin-1516496615-15165054641786521', 1, 0, '', NULL, NULL, NULL),
(61340, '2018-01-21 11:31:04', NULL, NULL, 16268, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:31:04', 'admin-1516496615-15165054641786521', 1, 0, '', NULL, NULL, NULL),
(61341, '2018-01-21 11:31:04', NULL, NULL, 16268, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:31:04', 'admin-1516496615-15165054641786521', 1, 0, '', NULL, NULL, NULL),
(61342, '2018-01-21 10:35:39', NULL, NULL, 16260, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:35:39', 'admin-1516496615-15165021393399722', 1, 0, '', NULL, NULL, NULL),
(61343, '2018-01-21 11:43:47', NULL, NULL, 16269, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:43:47', 'admin-1516496615-15165062272701797', 1, 0, '', NULL, NULL, NULL),
(61344, '2018-01-21 11:42:21', NULL, NULL, 16272, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:42:21', 'admin-1516496615-15165061414166229', 1, 0, '', NULL, NULL, NULL),
(61345, '2018-01-21 11:41:45', NULL, NULL, 16271, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:41:45', 'admin-1516496615-15165061058303225', 1, 0, '', NULL, NULL, NULL),
(61346, '2018-01-21 11:39:03', NULL, NULL, 16270, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:39:03', 'admin-1516496615-1516505943543424', 1, 1, 'SR', NULL, NULL, NULL),
(61347, '2018-01-21 14:28:11', NULL, NULL, 16287, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:28:11', 'admin-1516509965-15165160917578525', 1, 0, '', NULL, NULL, NULL),
(61348, '2018-01-21 11:39:03', NULL, NULL, 16270, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:39:03', 'admin-1516496615-1516505943543424', 1, 0, '', NULL, NULL, NULL),
(61349, '2018-01-21 11:37:29', NULL, NULL, 16270, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:37:29', 'admin-1516496615-15165058492556047', 1, 0, '', NULL, NULL, NULL),
(61350, '2018-01-21 11:31:04', NULL, NULL, 16268, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:31:04', 'admin-1516496615-15165054641786521', 1, 0, '', NULL, NULL, NULL),
(61351, '2018-01-21 11:31:04', NULL, NULL, 16268, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:31:04', 'admin-1516496615-15165054641786521', 1, 0, '', NULL, '20.0', NULL),
(61352, '2018-01-21 11:17:04', NULL, NULL, 16265, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:17:04', 'admin-1516496615-15165046242423072', 1, 1, 'SR', NULL, NULL, NULL),
(61353, '2018-01-21 11:13:06', NULL, NULL, 16264, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:13:06', 'admin-1516496615-15165043860548331', 1, 1, 'SR', NULL, NULL, NULL),
(61354, '2018-01-21 10:55:42', NULL, NULL, 16262, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:55:42', 'admin-1516496615-15165033425265458', 1, 0, '', NULL, NULL, NULL),
(61355, '2018-01-21 11:37:29', NULL, NULL, 16270, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:37:29', 'admin-1516496615-15165058492556047', 1, 0, '', NULL, NULL, NULL),
(61356, '2018-01-21 11:31:04', NULL, NULL, 16268, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:31:04', 'admin-1516496615-15165054641786521', 1, 0, '', NULL, NULL, NULL),
(61357, '2018-01-21 14:08:01', NULL, NULL, 16285, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 14:08:01', 'admin-1516509965-15165148810093449', 1, 1, 'SR', NULL, NULL, NULL),
(61358, '2018-01-21 13:12:30', NULL, NULL, 16281, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.56, 0.0000, 0.0000, 4.56, 1, '27', 1, '1516509965', 'admin', '2018-01-21 13:12:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61359, '2018-01-21 11:31:04', NULL, NULL, 16268, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:31:04', 'admin-1516496615-15165054641786521', 1, 1, 'SR', NULL, '0.0', NULL),
(61360, '2018-01-21 11:31:04', NULL, NULL, 16268, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:31:04', 'admin-1516496615-15165054641786521', 1, 0, '', NULL, NULL, NULL),
(61361, '2018-01-21 11:17:04', NULL, NULL, 16265, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:17:04', 'admin-1516496615-15165046242423072', 1, 0, '', NULL, NULL, NULL),
(61362, '2018-01-21 11:17:04', NULL, NULL, 16265, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:17:04', 'admin-1516496615-15165046242423072', 1, 0, '', NULL, '20.0', NULL),
(61363, '2018-01-21 11:00:00', NULL, NULL, 16263, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:00:00', 'admin-1516496615-15165036007776045', 1, 1, 'SR', NULL, NULL, NULL),
(61364, '2018-01-21 11:08:04', NULL, NULL, 16262, 0, 181, '116', 'Open Food ', 'breakfast potato', 'Meals', 'Perfect Meals', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:08:04', 'admin-1516496615-15165040843729010', 1, 0, '', NULL, NULL, NULL),
(61365, '2018-01-21 11:12:46', NULL, NULL, 16264, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:12:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61366, '2018-01-21 12:30:21', NULL, NULL, 16275, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.30, 0.0000, 0.0000, 9.30, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:30:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61367, '2018-01-21 13:13:17', NULL, NULL, 16281, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1516509965', 'admin', '2018-01-21 13:13:17', 'admin-1516509965-1516511597359965', 1, 0, '', NULL, '20.0', NULL),
(61368, '2018-01-21 11:39:03', NULL, NULL, 16270, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:39:03', 'admin-1516496615-1516505943543424', 1, 1, 'SR', NULL, NULL, NULL),
(61369, '2018-01-21 11:17:04', NULL, NULL, 16265, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:17:04', 'admin-1516496615-15165046242423072', 1, 0, '', NULL, NULL, NULL),
(61370, '2018-01-21 11:16:26', NULL, NULL, 16265, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.76, 0.0000, 0.0000, 5.76, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:16:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61371, '2018-01-21 12:57:38', NULL, NULL, 16280, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:57:38', 'admin-1516509965-15165106579184627', 1, 1, 'SR', NULL, NULL, NULL),
(61372, '2018-01-21 11:13:06', NULL, NULL, 16264, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:13:06', 'admin-1516496615-15165043860548331', 1, 1, 'SR', NULL, NULL, NULL),
(61373, '2018-01-21 10:33:32', NULL, NULL, 16259, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:33:32', 'admin-1516496615-15165020127237218', 1, 0, '', NULL, NULL, NULL),
(61374, '2018-01-21 10:20:13', NULL, NULL, 16257, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:20:13', 'admin-1516496615-15165012137134073', 1, 0, '', NULL, NULL, NULL),
(61375, '2018-01-21 10:20:13', NULL, NULL, 16257, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:20:13', 'admin-1516496615-15165012137134073', 1, 0, '', NULL, NULL, NULL),
(61376, '2018-01-21 12:51:53', NULL, NULL, 16278, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:51:53', 'admin-1516509965-1516510313240625', 1, 1, 'SR', NULL, NULL, NULL),
(61377, '2018-01-21 10:32:56', NULL, NULL, 16259, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:32:56', 'admin-1516496615-15165019761349240', 1, 0, '', NULL, NULL, NULL),
(61378, '2018-01-21 10:32:56', NULL, NULL, 16259, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:32:56', 'admin-1516496615-15165019761349240', 1, 0, '', NULL, NULL, NULL),
(61379, '2018-01-21 10:32:56', NULL, NULL, 16259, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:32:56', 'admin-1516496615-15165019761349240', 1, 0, '', NULL, NULL, NULL),
(61380, '2018-01-21 10:33:32', NULL, NULL, 16259, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:33:32', 'admin-1516496615-15165020127237218', 1, 1, 'SR', NULL, NULL, NULL),
(61381, '2018-01-21 15:55:57', NULL, NULL, 16295, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:55:57', 'admin-1516509965-15165213572745219', 1, 1, 'SR', NULL, NULL, NULL),
(61382, '2018-01-21 10:55:42', NULL, NULL, 16262, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:55:42', 'admin-1516496615-15165033425265458', 1, 1, 'SR', NULL, NULL, NULL),
(61383, '2018-01-21 10:46:11', NULL, NULL, 16261, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.56, 0.0000, 0.0000, 3.56, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:46:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61384, '2018-01-21 09:54:27', NULL, NULL, 16255, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:54:27', 'admin-1516496615-15164996671727162', 1, 0, '', NULL, NULL, NULL),
(61385, '2018-01-21 09:54:27', NULL, NULL, 16255, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:54:27', 'admin-1516496615-15164996671727162', 1, 0, '', NULL, NULL, NULL),
(61386, '2018-01-21 15:55:57', NULL, NULL, 16295, 0, 240, '174', 'Chocolate Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 15:55:57', 'admin-1516509965-15165213572745219', 1, 0, '', NULL, NULL, NULL),
(61387, '2018-01-21 10:46:36', NULL, NULL, 16261, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:46:36', 'admin-1516496615-1516502796623163', 1, 0, '', NULL, '20.0', NULL),
(61388, '2018-01-21 10:46:36', NULL, NULL, 16261, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:46:36', 'admin-1516496615-1516502796623163', 1, 1, 'SR', NULL, NULL, NULL),
(61389, '2018-01-21 10:46:36', NULL, NULL, 16261, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:46:36', 'admin-1516496615-1516502796623163', 1, 1, 'SR', NULL, NULL, NULL),
(61390, '2018-01-21 10:35:39', NULL, NULL, 16260, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:35:39', 'admin-1516496615-15165021393399722', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(61391, '2018-01-21 09:53:02', NULL, NULL, 16255, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:53:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61392, '2018-01-21 09:54:27', NULL, NULL, 16255, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:54:27', 'admin-1516496615-15164996671727162', 1, 1, 'SR', NULL, NULL, NULL),
(61393, '2018-01-21 09:54:27', NULL, NULL, 16255, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:54:27', 'admin-1516496615-15164996671727162', 1, 1, 'SR', NULL, NULL, NULL),
(61394, '2018-01-21 10:35:39', NULL, NULL, 16260, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:35:39', 'admin-1516496615-15165021393399722', 1, 1, 'SR', NULL, NULL, NULL),
(61395, '2018-01-21 10:33:32', NULL, NULL, 16259, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:33:32', 'admin-1516496615-15165020127237218', 1, 0, '', NULL, '20.0', NULL),
(61396, '2018-01-21 10:33:32', NULL, NULL, 16259, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:33:32', 'admin-1516496615-15165020127237218', 1, 0, '', NULL, '20.0', NULL),
(61397, '2018-01-21 10:32:56', NULL, NULL, 16259, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:32:56', 'admin-1516496615-15165019761349240', 1, 0, '', NULL, NULL, NULL),
(61398, '2018-01-21 10:20:13', NULL, NULL, 16257, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:20:13', 'admin-1516496615-15165012137134073', 1, 0, '', NULL, NULL, NULL),
(61399, '2018-01-21 10:33:32', NULL, NULL, 16259, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:33:32', 'admin-1516496615-15165020127237218', 1, 1, 'SR', NULL, NULL, NULL),
(61400, '2018-01-21 12:26:42', NULL, NULL, 16274, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.66, 0.0000, 0.0000, 6.66, 1, '27', 1, '1516509965', 'admin', '2018-01-21 12:26:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61401, '2018-01-21 11:00:00', NULL, NULL, 16263, 0, 271, '205', 'Take It Easy', 'sunny side up-egg', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 11:00:00', 'admin-1516496615-15165036007776045', 1, 0, '', NULL, NULL, NULL),
(61402, '2018-01-21 10:33:32', NULL, NULL, 16259, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:33:32', 'admin-1516496615-15165020127237218', 1, 0, '', NULL, NULL, NULL),
(61403, '2018-01-21 10:33:32', NULL, NULL, 16259, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:33:32', 'admin-1516496615-15165020127237218', 1, 1, 'SR', NULL, NULL, NULL),
(61404, '2018-01-21 10:32:33', NULL, NULL, 16259, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 15.46, 0.0000, 0.0000, 15.46, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:32:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61405, '2018-01-21 10:32:56', NULL, NULL, 16259, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:32:56', 'admin-1516496615-15165019761349240', 1, 0, '', NULL, NULL, NULL),
(61406, '2018-01-21 10:26:17', NULL, NULL, 16253, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:26:17', 'admin-1516496615-15165015771006747', 1, 1, 'SR', NULL, NULL, NULL),
(61407, '2018-01-21 09:50:58', NULL, NULL, 16253, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:50:58', 'admin-1516496615-15164994581941866', 1, 1, 'SR', NULL, NULL, NULL),
(61408, '2018-01-21 10:25:29', NULL, NULL, 16258, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:25:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61409, '2018-01-21 10:19:53', NULL, NULL, 16257, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:19:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61410, '2018-01-21 10:06:12', NULL, NULL, 16256, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:06:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61411, '2018-01-21 10:10:14', NULL, NULL, 16256, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 10:10:14', 'admin-1516496615-15165006148671551', 1, 1, 'SR', NULL, NULL, NULL),
(61412, '2018-01-21 09:54:27', NULL, NULL, 16255, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:54:27', 'admin-1516496615-15164996671727162', 1, 1, 'SR', NULL, NULL, NULL),
(61413, '2018-01-21 09:52:24', NULL, NULL, 16254, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:52:24', 'admin-1516496615-15164995441347182', 1, 1, 'SR', NULL, NULL, NULL),
(61414, '2018-01-21 09:52:24', NULL, NULL, 16254, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:52:24', 'admin-1516496615-15164995441347182', 1, 1, 'SR', NULL, NULL, NULL),
(61415, '2018-01-21 09:52:24', NULL, NULL, 16254, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:52:24', 'admin-1516496615-15164995441347182', 1, 0, '', NULL, NULL, NULL),
(61416, '2018-01-21 09:06:08', NULL, NULL, 16251, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:06:08', 'admin-1516496615-15164967687321853', 1, 0, '', NULL, NULL, NULL),
(61417, '2018-01-21 09:50:58', NULL, NULL, 16253, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:50:58', 'admin-1516496615-15164994581941866', 1, 0, '', NULL, NULL, NULL),
(61418, '2018-01-21 09:50:58', NULL, NULL, 16253, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:50:58', 'admin-1516496615-15164994581941866', 1, 1, 'SR', NULL, NULL, NULL),
(61419, '2018-01-21 09:50:39', NULL, NULL, 16253, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:50:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61420, '2018-01-21 09:43:51', NULL, NULL, 16252, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:43:51', 'admin-1516496615-1516499031406301', 1, 1, 'SR', NULL, NULL, NULL),
(61421, '2018-01-21 09:43:51', NULL, NULL, 16252, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:43:51', 'admin-1516496615-1516499031406301', 1, 1, 'SR', NULL, NULL, NULL),
(61422, '2018-01-21 09:43:51', NULL, NULL, 16252, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:43:51', 'admin-1516496615-1516499031406301', 1, 1, 'SR', NULL, NULL, NULL),
(61423, '2018-01-21 09:43:27', NULL, NULL, 16252, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:43:27', 'admin-1516496615-15164990074551758', 1, 0, '', NULL, NULL, NULL),
(61424, '2018-01-21 09:43:27', NULL, NULL, 16252, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:43:27', 'admin-1516496615-15164990074551758', 1, 0, '', NULL, NULL, NULL),
(61425, '2018-01-21 09:43:06', NULL, NULL, 16252, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:43:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61426, '2018-01-21 09:06:08', NULL, NULL, 16251, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:06:08', 'admin-1516496615-15164967687321853', 1, 1, 'SR', NULL, NULL, NULL),
(61427, '2018-01-21 09:06:08', NULL, NULL, 16251, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:06:08', 'admin-1516496615-15164967687321853', 1, 0, '', NULL, NULL, NULL),
(61428, '2018-01-21 09:05:12', NULL, NULL, 16251, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 11.40, 0.0000, 0.0000, 11.40, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:05:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61429, '2018-01-21 09:05:53', NULL, NULL, 16251, 0, 154, '88', 'Daily Dose BLT', 'hard sunny side up', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:05:53', 'admin-1516496615-15164967535904141', 1, 0, '', NULL, NULL, NULL),
(61430, '2018-01-21 09:05:53', NULL, NULL, 16251, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:05:53', 'admin-1516496615-15164967535904141', 1, 0, '', NULL, NULL, NULL),
(61431, '2018-01-21 09:05:53', NULL, NULL, 16251, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:05:53', 'admin-1516496615-15164967535904141', 1, 0, '', NULL, NULL, NULL),
(61432, '2018-01-21 09:05:53', NULL, NULL, 16251, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:05:53', 'admin-1516496615-15164967535904141', 1, 0, '', NULL, NULL, NULL),
(61433, '2018-01-21 09:04:19', NULL, NULL, 16250, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:04:19', 'admin-1516496615-15164966587931987', 1, 1, 'SR', NULL, NULL, NULL),
(61434, '2018-01-21 09:04:19', NULL, NULL, 16250, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:04:19', 'admin-1516496615-15164966587931987', 1, 1, 'SR', NULL, NULL, NULL),
(61435, '2018-01-21 09:04:09', NULL, NULL, 16250, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1516509965', 'admin', '2018-01-21 09:04:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61436, '2018-01-22 15:36:30', NULL, NULL, 16319, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 15:36:30', 'admin-1516583211-15166065906375394', 1, 1, 'SR', 1, NULL, NULL),
(61437, '2018-01-22 15:52:31', NULL, NULL, 16317, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 15:52:31', 'admin-1516583211-1516607551398420', 1, 1, 'SR', NULL, NULL, '10.0'),
(61438, '2018-01-22 16:07:03', NULL, NULL, 16320, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1516583211', 'admin', '2018-01-22 16:07:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61439, '2018-01-22 16:27:06', NULL, NULL, 16321, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 16:27:06', 'admin-1516583211-1516609626453938', 1, 1, 'SR', NULL, NULL, NULL),
(61440, '2018-01-22 16:27:06', NULL, NULL, 16321, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 16:27:06', 'admin-1516583211-1516609626453938', 1, 1, 'SR', NULL, NULL, NULL),
(61441, '2018-01-22 12:09:55', NULL, NULL, 16307, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:09:55', 'admin-1516583211-15165941953098089', 1, 1, 'SR', NULL, NULL, NULL),
(61442, '2018-01-22 13:31:55', NULL, NULL, 16313, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 13:31:55', 'admin-1516583211-15165991149296398', 1, 1, 'SR', NULL, NULL, NULL),
(61443, '2018-01-22 15:16:57', NULL, NULL, 16318, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 15:16:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61444, '2018-01-22 15:17:04', NULL, NULL, 16318, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 15:17:04', 'admin-1516583211-1516605424470251', 1, 1, 'SR', NULL, NULL, NULL),
(61445, '2018-01-22 12:30:48', NULL, NULL, 16310, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:30:48', 'admin-1516583211-15165954480852282', 1, 1, 'SR', NULL, NULL, NULL),
(61446, '2018-01-22 11:09:01', NULL, NULL, 16304, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 11:09:01', 'admin-1516583211-15165905417087671', 1, 1, 'SR', NULL, NULL, NULL),
(61447, '2018-01-22 12:59:46', NULL, NULL, 16306, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:59:46', 'admin-1516583211-15165971861999122', 1, 1, 'SR', NULL, NULL, NULL),
(61448, '2018-01-22 12:59:46', NULL, NULL, 16306, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:59:46', 'admin-1516583211-15165971861999122', 1, 1, 'SR', NULL, NULL, NULL),
(61449, '2018-01-22 12:19:45', NULL, NULL, 16308, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:19:45', 'admin-1516583211-15165947854783083', 1, 1, 'SR', NULL, NULL, NULL),
(61450, '2018-01-22 11:03:10', NULL, NULL, 16303, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 11:03:10', 'admin-1516583211-15165901907953082', 1, 0, '', NULL, NULL, NULL),
(61451, '2018-01-22 13:55:57', NULL, NULL, 16314, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1516583211', 'admin', '2018-01-22 13:55:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61452, '2018-01-22 13:56:03', NULL, NULL, 16314, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 13:56:03', 'admin-1516583211-15166005631735710', 1, 1, 'SR', NULL, NULL, NULL),
(61453, '2018-01-22 15:17:04', NULL, NULL, 16318, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 15:17:04', 'admin-1516583211-1516605424470251', 1, 1, 'SR', NULL, NULL, NULL),
(61454, '2018-01-22 14:02:35', NULL, NULL, 16315, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 14:02:35', 'admin-1516583211-15166009557282631', 1, 0, '', NULL, NULL, NULL),
(61455, '2018-01-22 14:02:35', NULL, NULL, 16315, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 14:02:35', 'admin-1516583211-15166009557282631', 1, 1, 'SR', NULL, NULL, NULL),
(61456, '2018-01-22 14:02:35', NULL, NULL, 16315, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 14:02:35', 'admin-1516583211-15166009557282631', 1, 1, 'SR', NULL, NULL, NULL),
(61457, '2018-01-22 14:02:35', NULL, NULL, 16315, 0, 305, '241', 'Sprite', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 14:02:35', 'admin-1516583211-15166009557282631', 1, 0, '', NULL, NULL, NULL),
(61458, '2018-01-22 10:45:52', NULL, NULL, 16301, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1516583211', 'admin', '2018-01-22 10:45:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61459, '2018-01-22 10:46:20', NULL, NULL, 16301, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 10:46:20', 'admin-1516583211-15165891807025281', 1, 1, 'SR', NULL, NULL, NULL),
(61460, '2018-01-22 12:26:31', NULL, NULL, 16309, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:26:31', 'admin-1516583211-15165951915682288', 1, 1, 'SR', NULL, NULL, NULL),
(61461, '2018-01-22 14:15:43', NULL, NULL, 16316, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1516583211', 'admin', '2018-01-22 14:15:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61462, '2018-01-22 14:15:49', NULL, NULL, 16316, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 14:15:49', 'admin-1516583211-15166017496579759', 1, 1, 'SR', NULL, NULL, NULL),
(61463, '2018-01-22 14:45:58', NULL, NULL, 16317, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1516583211', 'admin', '2018-01-22 14:45:58', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(61464, '2018-01-22 12:30:48', NULL, NULL, 16310, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:30:48', 'admin-1516583211-15165954480852282', 1, 1, 'SR', NULL, NULL, NULL),
(61465, '2018-01-22 12:30:48', NULL, NULL, 16310, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:30:48', 'admin-1516583211-15165954480852282', 1, 1, 'SR', NULL, NULL, NULL),
(61466, '2018-01-22 11:09:01', NULL, NULL, 16304, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 11:09:01', 'admin-1516583211-15165905417087671', 1, 0, '', NULL, NULL, NULL),
(61467, '2018-01-22 16:07:11', NULL, NULL, 16320, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 16:07:11', 'admin-1516583211-15166084314612522', 1, 1, 'SR', NULL, NULL, NULL),
(61468, '2018-01-22 16:26:58', NULL, NULL, 16321, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1516583211', 'admin', '2018-01-22 16:26:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61469, '2018-01-22 16:07:11', NULL, NULL, 16320, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 16:07:11', 'admin-1516583211-15166084314612522', 1, 0, '', NULL, NULL, NULL),
(61470, '2018-01-22 12:19:38', NULL, NULL, 16308, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:19:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61471, '2018-01-22 12:09:55', NULL, NULL, 16307, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:09:55', 'admin-1516583211-15165941953098089', 1, 0, '', NULL, NULL, NULL),
(61472, '2018-01-22 12:09:55', NULL, NULL, 16307, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:09:55', 'admin-1516583211-15165941953098089', 1, 1, 'SR', NULL, NULL, NULL),
(61473, '2018-01-22 12:35:56', NULL, NULL, 16311, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:35:56', 'admin-1516583211-15165957566171173', 1, 0, '', NULL, NULL, NULL),
(61474, '2018-01-22 12:35:56', NULL, NULL, 16311, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:35:56', 'admin-1516583211-15165957566171173', 1, 0, '', NULL, NULL, NULL),
(61475, '2018-01-22 12:50:24', NULL, NULL, 16307, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:50:24', 'admin-1516583211-15165966239396850', 1, 1, 'SR', NULL, NULL, NULL),
(61476, '2018-01-22 14:14:47', NULL, NULL, 16314, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 14:14:47', 'admin-1516583211-15166016877572838', 1, 1, 'SR', NULL, NULL, NULL),
(61477, '2018-01-22 14:02:35', NULL, NULL, 16315, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 14:02:35', 'admin-1516583211-15166009557282631', 1, 1, 'SR', NULL, NULL, NULL),
(61478, '2018-01-22 14:46:09', NULL, NULL, 16317, 0, 73, '73', 'Marmite Chicken ', 'Pasta', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 14:46:09', 'admin-1516583211-1516603569496227', 1, 1, 'SR', NULL, NULL, '10.0'),
(61479, '2018-01-22 13:31:55', NULL, NULL, 16313, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 13:31:55', 'admin-1516583211-15165991149296398', 1, 1, 'SR', NULL, NULL, NULL),
(61480, '2018-01-22 12:35:56', NULL, NULL, 16311, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:35:56', 'admin-1516583211-15165957566171173', 1, 0, '', NULL, NULL, NULL),
(61481, '2018-01-22 13:31:16', NULL, NULL, 16313, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1516583211', 'admin', '2018-01-22 13:31:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61482, '2018-01-22 13:31:55', NULL, NULL, 16313, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 13:31:55', 'admin-1516583211-15165991149296398', 1, 0, '', NULL, NULL, NULL),
(61483, '2018-01-22 13:22:01', NULL, NULL, 16312, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 13:22:01', 'admin-1516583211-15165985211983763', 1, 0, '', NULL, NULL, NULL),
(61484, '2018-01-22 13:22:01', NULL, NULL, 16312, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 13:22:01', 'admin-1516583211-15165985211983763', 1, 0, '', NULL, NULL, NULL),
(61485, '2018-01-22 11:58:58', NULL, NULL, 16306, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 11:58:58', 'admin-1516583211-15165935381517775', 1, 0, '', NULL, NULL, NULL),
(61486, '2018-01-22 11:58:58', NULL, NULL, 16306, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 11:58:58', 'admin-1516583211-15165935381517775', 1, 0, '', NULL, NULL, NULL),
(61487, '2018-01-22 13:21:28', NULL, NULL, 16311, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 13:21:28', 'admin-1516583211-15165984881451026', 1, 1, 'SR', NULL, NULL, NULL),
(61488, '2018-01-22 13:21:28', NULL, NULL, 16311, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 13:21:28', 'admin-1516583211-15165984881451026', 1, 1, 'SR', NULL, NULL, NULL),
(61489, '2018-01-22 12:21:29', NULL, NULL, 16309, 0, 181, '116', 'Open Food ', 'marmite', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:21:29', 'admin-1516583211-15165948889096185', 1, 0, '', NULL, NULL, NULL),
(61490, '2018-01-22 12:22:52', NULL, NULL, 16309, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:22:52', 'admin-1516583211-15165949725436128', 1, 1, 'SR', NULL, NULL, NULL),
(61491, '2018-01-22 12:35:56', NULL, NULL, 16311, 0, 181, '116', 'Open Food ', 'marmite', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:35:56', 'admin-1516583211-15165957566171173', 1, 0, '', NULL, NULL, NULL),
(61492, '2018-01-22 12:35:14', NULL, NULL, 16311, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:35:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61493, '2018-01-22 12:30:48', NULL, NULL, 16310, 0, 222, '156', 'Seasoned Chicken Aglio Olio', 'no spicy', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:30:48', 'admin-1516583211-15165954480852282', 1, 0, '', NULL, NULL, NULL),
(61494, '2018-01-22 12:30:18', NULL, NULL, 16310, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:30:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61495, '2018-01-22 12:21:29', NULL, NULL, 16309, 0, 181, '116', 'Open Food ', 'marmite', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:21:29', 'admin-1516583211-15165948889096185', 1, 0, '', NULL, NULL, NULL),
(61496, '2018-01-22 12:26:31', NULL, NULL, 16309, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:26:31', 'admin-1516583211-15165951915682288', 1, 1, 'SR', NULL, NULL, NULL),
(61497, '2018-01-22 12:19:45', NULL, NULL, 16308, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:19:45', 'admin-1516583211-15165947854783083', 1, 1, 'SR', NULL, NULL, NULL),
(61498, '2018-01-22 12:21:14', NULL, NULL, 16309, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:21:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61499, '2018-01-22 12:09:55', NULL, NULL, 16307, 0, 181, '116', 'Open Food ', 'marmite', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:09:55', 'admin-1516583211-15165941953098089', 1, 0, '', NULL, NULL, NULL),
(61500, '2018-01-22 12:09:22', NULL, NULL, 16307, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:09:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61501, '2018-01-22 14:01:09', NULL, NULL, 16315, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1516583211', 'admin', '2018-01-22 14:01:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61502, '2018-01-22 13:21:38', NULL, NULL, 16312, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1516583211', 'admin', '2018-01-22 13:21:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61503, '2018-01-22 11:58:43', NULL, NULL, 16306, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1516583211', 'admin', '2018-01-22 11:58:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61504, '2018-01-22 11:35:52', NULL, NULL, 16305, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 11:35:52', 'admin-1516583211-15165921528465564', 1, 1, 'SR', 1, NULL, NULL),
(61505, '2018-01-22 11:35:52', NULL, NULL, 16305, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 11:35:52', 'admin-1516583211-15165921528465564', 1, 0, '', 1, NULL, NULL),
(61506, '2018-01-22 10:46:57', NULL, NULL, 16302, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 10:46:57', 'admin-1516583211-15165892177359830', 1, 0, '', NULL, NULL, NULL),
(61507, '2018-01-22 10:46:57', NULL, NULL, 16302, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 10:46:57', 'admin-1516583211-15165892177359830', 1, 0, '', NULL, NULL, NULL),
(61508, '2018-01-22 10:46:57', NULL, NULL, 16302, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 10:46:57', 'admin-1516583211-15165892177359830', 1, 0, '', NULL, NULL, NULL),
(61509, '2018-01-22 12:21:29', NULL, NULL, 16309, 0, 181, '116', 'Open Food ', 'marmite', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 12:21:29', 'admin-1516583211-15165948889096185', 1, 0, '', NULL, NULL, NULL),
(61510, '2018-01-22 11:09:01', NULL, NULL, 16304, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 11:09:01', 'admin-1516583211-15165905417087671', 1, 1, 'SR', NULL, NULL, NULL),
(61511, '2018-01-22 11:09:01', NULL, NULL, 16304, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 11:09:01', 'admin-1516583211-15165905417087671', 1, 0, '', NULL, NULL, NULL),
(61512, '2018-01-22 11:08:39', NULL, NULL, 16304, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1516583211', 'admin', '2018-01-22 11:08:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61513, '2018-01-22 11:03:10', NULL, NULL, 16303, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 11:03:10', 'admin-1516583211-15165901907953082', 1, 0, '', NULL, NULL, NULL),
(61514, '2018-01-22 11:02:55', NULL, NULL, 16303, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1516583211', 'admin', '2018-01-22 11:02:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61515, '2018-01-22 11:03:10', NULL, NULL, 16303, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 11:03:10', 'admin-1516583211-15165901907953082', 1, 1, 'SR', NULL, NULL, NULL),
(61516, '2018-01-22 11:03:10', NULL, NULL, 16303, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 11:03:10', 'admin-1516583211-15165901907953082', 1, 1, 'SR', NULL, NULL, NULL),
(61517, '2018-01-22 10:46:20', NULL, NULL, 16301, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 10:46:20', 'admin-1516583211-15165891807025281', 1, 0, '', NULL, NULL, NULL),
(61518, '2018-01-22 10:46:39', NULL, NULL, 16302, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1516583211', 'admin', '2018-01-22 10:46:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61519, '2018-01-22 10:19:43', NULL, NULL, 16299, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 10:19:43', 'admin-1516583211-15165875835553625', 1, 0, '', NULL, NULL, NULL),
(61520, '2018-01-22 09:29:44', NULL, NULL, 16299, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 09:29:44', 'admin-1516583211-15165845841036289', 1, 0, '', NULL, NULL, NULL),
(61521, '2018-01-22 10:19:19', NULL, NULL, 16300, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1516583211', 'admin', '2018-01-22 10:19:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61522, '2018-01-22 10:19:27', NULL, NULL, 16300, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 10:19:27', 'admin-1516583211-1516587567791718', 1, 1, 'SR', NULL, NULL, NULL),
(61523, '2018-01-22 10:19:43', NULL, NULL, 16299, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 10:19:43', 'admin-1516583211-15165875835553625', 1, 1, 'SR', NULL, NULL, NULL),
(61524, '2018-01-22 09:25:01', NULL, NULL, 16298, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 09:25:01', 'admin-1516583211-15165843009435946', 1, 1, 'SR', NULL, NULL, NULL),
(61525, '2018-01-22 09:29:37', NULL, NULL, 16299, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1516583211', 'admin', '2018-01-22 09:29:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61526, '2018-01-22 09:29:44', NULL, NULL, 16299, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516583211', 'admin', '2018-01-22 09:29:44', 'admin-1516583211-15165845841036289', 1, 1, 'SR', NULL, NULL, NULL),
(61527, '2018-01-22 09:24:58', NULL, NULL, 16298, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1516583211', 'admin', '2018-01-22 09:24:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61528, '2018-01-24 13:50:09', NULL, NULL, 16335, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1516755252', 'admin', '2018-01-24 13:50:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61529, '2018-01-24 13:50:16', NULL, NULL, 16335, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 13:50:16', 'admin-1516755252-15167730168432664', 1, 1, 'SR', NULL, NULL, NULL),
(61530, '2018-01-24 13:50:16', NULL, NULL, 16335, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 13:50:16', 'admin-1516755252-15167730168432664', 1, 1, 'SR', NULL, NULL, NULL),
(61531, '2018-01-24 12:20:22', NULL, NULL, 16329, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 12:20:22', 'admin-1516755252-15167676221988892', 1, 1, 'SR', NULL, NULL, NULL),
(61532, '2018-01-24 14:31:00', NULL, NULL, 16337, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 14:31:00', 'admin-1516755252-15167754608279416', 1, 0, '', 1, NULL, NULL),
(61533, '2018-01-24 14:47:35', NULL, NULL, 16338, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1516755252', 'admin', '2018-01-24 14:47:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61534, '2018-01-24 11:35:20', NULL, NULL, 16328, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 11:35:20', 'admin-1516755252-15167649203061788', 1, 1, 'SR', NULL, NULL, NULL),
(61535, '2018-01-24 11:43:01', NULL, NULL, 16328, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 11:43:01', 'admin-1516755252-15167653809737572', 1, 1, 'SR', NULL, NULL, NULL),
(61536, '2018-01-24 12:30:07', NULL, NULL, 16332, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1516755252', 'admin', '2018-01-24 12:30:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61537, '2018-01-24 11:04:53', NULL, NULL, 16326, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 11:04:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61538, '2018-01-24 11:04:57', NULL, NULL, 16326, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 11:04:57', 'admin-1516755252-15167630971133498', 1, 1, 'SR', NULL, NULL, NULL),
(61539, '2018-01-24 11:44:28', NULL, NULL, 16326, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 11:44:28', 'admin-1516755252-15167654683556376', 1, 1, 'SR', NULL, NULL, NULL),
(61540, '2018-01-24 10:13:57', NULL, NULL, 16324, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 10:13:57', 'admin-1516755252-15167600374387182', 1, 1, 'SR', NULL, NULL, NULL),
(61541, '2018-01-24 11:35:20', NULL, NULL, 16328, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 11:35:20', 'admin-1516755252-15167649203061788', 1, 0, '', NULL, NULL, NULL),
(61542, '2018-01-24 12:30:19', NULL, NULL, 16332, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 12:30:19', 'admin-1516755252-15167682193319392', 1, 0, '', NULL, NULL, NULL),
(61543, '2018-01-24 12:32:40', NULL, NULL, 16332, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 12:32:40', 'admin-1516755252-15167683601901890', 1, 0, '', NULL, NULL, NULL),
(61544, '2018-01-24 12:32:40', NULL, NULL, 16332, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 12:32:40', 'admin-1516755252-15167683601901890', 1, 0, '', NULL, NULL, NULL),
(61545, '2018-01-24 14:47:40', NULL, NULL, 16338, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 14:47:40', 'admin-1516755252-15167764601058161', 1, 1, 'SR', NULL, NULL, NULL),
(61546, '2018-01-24 14:51:49', NULL, NULL, 16339, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1516755252', 'admin', '2018-01-24 14:51:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61547, '2018-01-24 14:51:53', NULL, NULL, 16339, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 14:51:53', 'admin-1516755252-15167767137161967', 1, 1, 'SR', NULL, NULL, NULL),
(61548, '2018-01-24 14:51:53', NULL, NULL, 16339, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 14:51:53', 'admin-1516755252-15167767137161967', 1, 1, 'SR', NULL, NULL, NULL),
(61549, '2018-01-24 09:31:09', NULL, NULL, 16323, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 09:31:09', 'admin-1516755252-15167574692544175', 1, 0, '', NULL, NULL, NULL),
(61550, '2018-01-24 09:31:09', NULL, NULL, 16323, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 09:31:09', 'admin-1516755252-15167574692544175', 1, 0, '', NULL, NULL, NULL),
(61551, '2018-01-24 12:28:25', NULL, NULL, 16331, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 12:28:25', 'admin-1516755252-15167681051471774', 1, 0, '', NULL, NULL, NULL),
(61552, '2018-01-24 14:54:16', NULL, NULL, 16339, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 14:54:16', 'admin-1516755252-1516776856104487', 1, 1, 'SR', NULL, NULL, NULL),
(61553, '2018-01-24 14:54:16', NULL, NULL, 16339, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 14:54:16', 'admin-1516755252-1516776856104487', 1, 1, 'SR', NULL, NULL, NULL),
(61554, '2018-01-24 12:26:35', NULL, NULL, 16330, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1516755252', 'admin', '2018-01-24 12:26:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61555, '2018-01-24 14:20:11', NULL, NULL, 16336, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1516755252', 'admin', '2018-01-24 14:20:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61556, '2018-01-24 14:20:40', NULL, NULL, 16336, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 14:20:40', 'admin-1516755252-15167748402631977', 1, 1, 'SR', NULL, NULL, NULL),
(61557, '2018-01-24 14:20:40', NULL, NULL, 16336, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 14:20:40', 'admin-1516755252-15167748402631977', 1, 0, '', NULL, NULL, NULL),
(61558, '2018-01-24 14:31:00', NULL, NULL, 16337, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 14:31:00', 'admin-1516755252-15167754608279416', 1, 0, '', 1, NULL, NULL),
(61559, '2018-01-24 11:43:01', NULL, NULL, 16328, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 11:43:01', 'admin-1516755252-15167653809737572', 1, 1, 'SR', NULL, NULL, NULL),
(61560, '2018-01-24 13:33:37', NULL, NULL, 16334, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 13:33:37', 'admin-1516755252-1516772016970314', 1, 1, 'SR', 1, NULL, NULL),
(61561, '2018-01-24 13:33:37', NULL, NULL, 16334, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 13:33:37', 'admin-1516755252-1516772016970314', 1, 1, 'SR', 1, NULL, NULL),
(61562, '2018-01-24 13:05:25', NULL, NULL, 16333, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 13:05:25', 'admin-1516755252-15167703254717275', 1, 1, 'SR', NULL, NULL, NULL),
(61563, '2018-01-24 11:35:20', NULL, NULL, 16328, 0, 153, '87', 'Wake Me Up!', 'sunny side up -egg', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 11:35:20', 'admin-1516755252-15167649203061788', 1, 0, '', NULL, NULL, NULL),
(61564, '2018-01-24 12:18:11', NULL, NULL, 16329, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1516755252', 'admin', '2018-01-24 12:18:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61565, '2018-01-24 12:19:07', NULL, NULL, 16329, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 12:19:07', 'admin-1516755252-15167675472875620', 1, 0, '', NULL, NULL, NULL),
(61566, '2018-01-24 12:19:07', NULL, NULL, 16329, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 12:19:07', 'admin-1516755252-15167675472875620', 1, 0, '', NULL, NULL, NULL),
(61567, '2018-01-24 10:42:40', NULL, NULL, 16325, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 10:42:40', 'admin-1516755252-1516761760045529', 1, 0, '', NULL, NULL, NULL),
(61568, '2018-01-24 13:05:25', NULL, NULL, 16333, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 13:05:25', 'admin-1516755252-15167703254717275', 1, 1, 'SR', NULL, NULL, NULL),
(61569, '2018-01-24 12:28:25', NULL, NULL, 16331, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 12:28:25', 'admin-1516755252-15167681051471774', 1, 1, 'SR', NULL, NULL, NULL),
(61570, '2018-01-24 11:34:04', NULL, NULL, 16328, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1516755252', 'admin', '2018-01-24 11:34:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61571, '2018-01-24 11:35:20', NULL, NULL, 16328, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 11:35:20', 'admin-1516755252-15167649203061788', 1, 0, '', NULL, NULL, NULL),
(61572, '2018-01-24 13:05:13', NULL, NULL, 16333, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1516755252', 'admin', '2018-01-24 13:05:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61573, '2018-01-24 13:04:20', NULL, NULL, 16332, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 13:04:20', 'admin-1516755252-15167702603076481', 1, 0, '', NULL, NULL, NULL),
(61574, '2018-01-24 11:25:50', NULL, NULL, 16327, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 11:25:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61575, '2018-01-24 13:05:25', NULL, NULL, 16333, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 13:05:25', 'admin-1516755252-15167703254717275', 1, 0, '', NULL, NULL, NULL),
(61576, '2018-01-24 12:28:25', NULL, NULL, 16331, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 12:28:25', 'admin-1516755252-15167681051471774', 1, 1, 'SR', NULL, NULL, NULL),
(61577, '2018-01-24 12:27:55', NULL, NULL, 16331, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1516755252', 'admin', '2018-01-24 12:27:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61578, '2018-01-24 12:26:39', NULL, NULL, 16330, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 12:26:39', 'admin-1516755252-15167679994335041', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(61579, '2018-01-24 12:20:22', NULL, NULL, 16329, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 12:20:22', 'admin-1516755252-15167676221988892', 1, 0, '', NULL, NULL, NULL),
(61580, '2018-01-24 11:35:20', NULL, NULL, 16328, 0, 181, '116', 'Open Food ', 'bacon sausage', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 11:35:20', 'admin-1516755252-15167649203061788', 1, 0, '', NULL, NULL, NULL),
(61581, '2018-01-24 10:24:26', NULL, NULL, 16324, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 10:24:26', 'admin-1516755252-15167606660728275', 1, 0, '', NULL, NULL, NULL),
(61582, '2018-01-24 11:26:00', NULL, NULL, 16327, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 11:26:00', 'admin-1516755252-1516764360595646', 1, 1, 'SR', NULL, NULL, NULL),
(61583, '2018-01-24 11:26:00', NULL, NULL, 16327, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 11:26:00', 'admin-1516755252-1516764360595646', 1, 1, 'SR', NULL, NULL, NULL),
(61584, '2018-01-24 09:31:09', NULL, NULL, 16323, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 09:31:09', 'admin-1516755252-15167574692544175', 1, 1, 'SR', NULL, NULL, NULL),
(61585, '2018-01-24 09:31:09', NULL, NULL, 16323, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 09:31:09', 'admin-1516755252-15167574692544175', 1, 0, '', NULL, NULL, NULL),
(61586, '2018-01-24 09:56:38', NULL, NULL, 16322, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 09:56:38', 'admin-1516755252-1516758998184881', 1, 0, '', NULL, NULL, NULL),
(61587, '2018-01-24 11:26:00', NULL, NULL, 16327, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 11:26:00', 'admin-1516755252-1516764360595646', 1, 0, '', NULL, NULL, NULL),
(61588, '2018-01-24 10:41:48', NULL, NULL, 16325, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1516755252', 'admin', '2018-01-24 10:41:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61589, '2018-01-24 10:42:40', NULL, NULL, 16325, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 10:42:40', 'admin-1516755252-1516761760045529', 1, 0, '', NULL, NULL, NULL),
(61590, '2018-01-24 10:24:26', NULL, NULL, 16324, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 10:24:26', 'admin-1516755252-15167606660728275', 1, 0, '', NULL, NULL, NULL),
(61591, '2018-01-24 10:13:57', NULL, NULL, 16324, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 10:13:57', 'admin-1516755252-15167600374387182', 1, 1, 'SR', NULL, NULL, NULL),
(61592, '2018-01-24 10:13:57', NULL, NULL, 16324, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 10:13:57', 'admin-1516755252-15167600374387182', 1, 1, 'SR', NULL, NULL, NULL),
(61593, '2018-01-24 10:13:57', NULL, NULL, 16324, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 10:13:57', 'admin-1516755252-15167600374387182', 1, 0, '', NULL, NULL, NULL),
(61594, '2018-01-24 10:13:40', NULL, NULL, 16324, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1516755252', 'admin', '2018-01-24 10:13:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61595, '2018-01-24 09:31:09', NULL, NULL, 16323, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 09:31:09', 'admin-1516755252-15167574692544175', 1, 0, '', NULL, NULL, NULL),
(61596, '2018-01-24 09:13:57', NULL, NULL, 16322, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 09:13:57', 'admin-1516755252-15167564370123095', 1, 0, '', NULL, NULL, NULL),
(61597, '2018-01-24 09:13:57', NULL, NULL, 16322, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 09:13:57', 'admin-1516755252-15167564370123095', 1, 0, '', NULL, NULL, NULL),
(61598, '2018-01-24 09:13:57', NULL, NULL, 16322, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 09:13:57', 'admin-1516755252-15167564370123095', 1, 0, '', NULL, NULL, NULL),
(61599, '2018-01-24 09:13:57', NULL, NULL, 16322, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 09:13:57', 'admin-1516755252-15167564370123095', 1, 1, 'SR', NULL, NULL, NULL),
(61600, '2018-01-24 09:13:57', NULL, NULL, 16322, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 09:13:57', 'admin-1516755252-15167564370123095', 1, 1, 'SR', NULL, NULL, NULL),
(61601, '2018-01-24 09:30:54', NULL, NULL, 16323, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1516755252', 'admin', '2018-01-24 09:30:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61602, '2018-01-24 09:31:09', NULL, NULL, 16323, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516755252', 'admin', '2018-01-24 09:31:09', 'admin-1516755252-15167574692544175', 1, 0, '', NULL, NULL, NULL),
(61603, '2018-01-24 09:13:35', NULL, NULL, 16322, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1516755252', 'admin', '2018-01-24 09:13:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61604, '2018-01-25 13:24:16', NULL, NULL, 16355, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:24:16', 'admin-1516842527-15168578560658115', 1, 0, '', NULL, NULL, NULL),
(61605, '2018-01-25 13:24:16', NULL, NULL, 16355, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:24:16', 'admin-1516842527-15168578560658115', 1, 0, '', NULL, NULL, NULL),
(61606, '2018-01-25 13:25:20', NULL, NULL, 16356, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:25:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61607, '2018-01-25 14:58:20', NULL, NULL, 16361, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 14:58:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61608, '2018-01-25 14:21:50', NULL, NULL, 16357, 0, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 14:21:50', 'admin-1516842527-1516861310422326', 1, 1, 'SR', NULL, NULL, NULL),
(61609, '2018-01-25 14:21:50', NULL, NULL, 16357, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 14:21:50', 'admin-1516842527-1516861310422326', 1, 1, 'SR', NULL, NULL, NULL),
(61610, '2018-01-25 11:22:41', NULL, NULL, 16347, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 11:22:41', 'admin-1516842527-15168505613264938', 1, 1, 'SR', NULL, NULL, NULL),
(61611, '2018-01-25 13:25:51', NULL, NULL, 16356, 0, 181, '116', 'Open Food ', 'stewed pork', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:25:51', 'admin-1516842527-1516857951302913', 1, 0, '', NULL, NULL, NULL),
(61612, '2018-01-25 11:21:48', NULL, NULL, 16347, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.59, 0.0000, 0.0000, 4.59, 1, '27', 1, '1516842527', 'admin', '2018-01-25 11:21:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61613, '2018-01-25 11:22:41', NULL, NULL, 16347, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 11:22:41', 'admin-1516842527-15168505613264938', 1, 0, '', NULL, NULL, NULL),
(61614, '2018-01-25 13:19:50', NULL, NULL, 16354, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:19:50', 'admin-1516842527-15168575903744196', 1, 0, '', NULL, NULL, NULL),
(61615, '2018-01-25 15:28:57', NULL, NULL, 16366, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 15:28:57', 'admin-1516842527-15168653375348856', 1, 0, '', NULL, NULL, NULL),
(61616, '2018-01-25 15:28:57', NULL, NULL, 16366, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 15:28:57', 'admin-1516842527-15168653375348856', 1, 1, 'SR', NULL, NULL, NULL),
(61617, '2018-01-25 15:28:57', NULL, NULL, 16366, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 15:28:57', 'admin-1516842527-15168653375348856', 1, 0, '', NULL, NULL, NULL),
(61618, '2018-01-25 15:22:47', NULL, NULL, 16364, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1516842527', 'admin', '2018-01-25 15:22:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61619, '2018-01-25 15:22:56', NULL, NULL, 16364, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 15:22:56', 'admin-1516842527-15168649768597918', 1, 1, 'SR', NULL, NULL, NULL),
(61620, '2018-01-25 12:22:51', NULL, NULL, 16352, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1516842527', 'admin', '2018-01-25 12:22:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61621, '2018-01-25 12:22:59', NULL, NULL, 16352, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 12:22:59', 'admin-1516842527-15168541791397352', 1, 0, '', NULL, NULL, NULL),
(61622, '2018-01-25 11:40:48', NULL, NULL, 16350, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1516842527', 'admin', '2018-01-25 11:40:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61623, '2018-01-25 00:00:00', NULL, NULL, 16350, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 10:23:15', 'admin-1516842527-15168469952812458', 1, 0, '', NULL, NULL, NULL),
(61624, '2018-01-25 12:55:06', NULL, NULL, 16353, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 12:55:06', 'admin-1516842527-15168561059458960', 1, 0, '', NULL, NULL, NULL),
(61625, '2018-01-25 13:59:18', NULL, NULL, 16358, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:59:18', 'admin-1516842527-15168599580191564', 1, 1, 'SR', NULL, NULL, NULL),
(61626, '2018-01-25 13:59:18', NULL, NULL, 16358, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:59:18', 'admin-1516842527-15168599580191564', 1, 1, 'SR', NULL, NULL, NULL),
(61627, '2018-01-25 13:59:18', NULL, NULL, 16358, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:59:18', 'admin-1516842527-15168599580191564', 1, 1, 'SR', NULL, NULL, NULL),
(61628, '2018-01-25 15:27:29', NULL, NULL, 16363, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 15:27:29', 'admin-1516842527-15168652492631117', 1, 1, 'SR', NULL, NULL, NULL),
(61629, '2018-01-25 13:59:05', NULL, NULL, 16358, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:59:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61630, '2018-01-25 13:50:43', NULL, NULL, 16357, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:50:43', 'admin-1516842527-1516859443499678', 1, 1, 'SR', NULL, NULL, NULL),
(61631, '2018-01-25 13:51:32', NULL, NULL, 16357, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:51:32', 'admin-1516842527-15168594918618779', 1, 1, 'SR', NULL, NULL, NULL),
(61632, '2018-01-25 13:24:16', NULL, NULL, 16355, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:24:16', 'admin-1516842527-15168578560658115', 1, 0, '', NULL, NULL, NULL),
(61633, '2018-01-25 10:20:17', NULL, NULL, 16343, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 10:20:17', 'admin-1516842527-15168468176827836', 1, 1, 'SR', NULL, NULL, NULL),
(61634, '2018-01-25 09:10:39', NULL, NULL, 16340, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 09:10:39', 'admin-1516842527-15168426396331295', 1, 1, 'SR', NULL, NULL, NULL),
(61635, '2018-01-25 09:10:39', NULL, NULL, 16340, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 09:10:39', 'admin-1516842527-15168426396331295', 1, 0, '', NULL, NULL, NULL),
(61636, '2018-01-25 16:18:45', NULL, NULL, 16367, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 16:18:45', 'admin-1516842527-15168683249587213', 1, 0, '', NULL, NULL, NULL),
(61637, '2018-01-25 16:29:37', NULL, NULL, 16366, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 16:29:37', 'admin-1516842527-15168689769787615', 1, 1, 'SR', NULL, NULL, NULL),
(61638, '2018-01-25 13:33:27', NULL, NULL, 16354, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:33:27', 'admin-1516842527-15168584077715166', 1, 0, '', NULL, NULL, NULL),
(61639, '2018-01-25 13:38:17', NULL, NULL, 16353, 0, 181, '116', 'Open Food ', 'dumplings', 'Meals', 'Perfect Meals', 1, 60.00, 60.0000, 0.0000, 60.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:38:17', 'admin-1516842527-15168586970161799', 1, 0, '', NULL, NULL, NULL),
(61640, '2018-01-25 13:50:03', NULL, NULL, 16357, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.29, 0.0000, 0.0000, 10.29, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:50:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61641, '2018-01-25 13:50:43', NULL, NULL, 16357, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:50:43', 'admin-1516842527-1516859443499678', 1, 1, 'SR', NULL, NULL, NULL),
(61642, '2018-01-25 15:28:42', NULL, NULL, 16366, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1516842527', 'admin', '2018-01-25 15:28:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61643, '2018-01-25 15:22:56', NULL, NULL, 16364, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 15:22:56', 'admin-1516842527-15168649768597918', 1, 1, 'SR', NULL, NULL, NULL),
(61644, '2018-01-25 15:12:53', NULL, NULL, 16362, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 15:12:53', 'admin-1516842527-15168643729712223', 1, 0, '', NULL, NULL, NULL),
(61645, '2018-01-25 15:12:53', NULL, NULL, 16362, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 15:12:53', 'admin-1516842527-15168643729712223', 1, 1, 'SR', NULL, NULL, NULL),
(61646, '2018-01-25 13:50:43', NULL, NULL, 16357, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:50:43', 'admin-1516842527-1516859443499678', 1, 0, '', NULL, NULL, NULL),
(61647, '2018-01-25 16:18:40', NULL, NULL, 16367, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1516842527', 'admin', '2018-01-25 16:18:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61648, '2018-01-25 15:43:53', NULL, NULL, 16364, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 15:43:53', 'admin-1516842527-15168662331112035', 1, 0, '', NULL, NULL, NULL),
(61649, '2018-01-25 15:28:57', NULL, NULL, 16366, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 15:28:57', 'admin-1516842527-15168653375348856', 1, 0, '', NULL, NULL, NULL),
(61650, '2018-01-25 15:23:31', NULL, NULL, 16365, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 15:23:31', 'admin-1516842527-15168650116697599', 1, 1, 'SR', NULL, NULL, NULL),
(61651, '2018-01-25 15:12:28', NULL, NULL, 16362, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1516842527', 'admin', '2018-01-25 15:12:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61652, '2018-01-25 14:58:25', NULL, NULL, 16361, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 14:58:25', 'admin-1516842527-15168635056576799', 1, 1, 'SR', NULL, NULL, NULL),
(61653, '2018-01-25 15:12:53', NULL, NULL, 16362, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 15:12:53', 'admin-1516842527-15168643729712223', 1, 0, '', NULL, NULL, NULL),
(61654, '2018-01-25 15:23:31', NULL, NULL, 16365, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 15:23:31', 'admin-1516842527-15168650116697599', 1, 1, 'SR', NULL, NULL, NULL),
(61655, '2018-01-25 14:21:50', NULL, NULL, 16357, 0, 302, '238', 'Ice on the cake', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 14:21:50', 'admin-1516842527-1516861310422326', 1, 0, '', NULL, NULL, NULL),
(61656, '2018-01-25 14:16:11', NULL, NULL, 16360, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 14:16:11', 'admin-1516842527-15168609717663656', 1, 1, 'SR', NULL, NULL, NULL),
(61657, '2018-01-25 14:15:34', NULL, NULL, 16360, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 14:15:34', 'admin-1516842527-15168609339328141', 1, 0, '', NULL, NULL, NULL),
(61658, '2018-01-25 13:28:47', NULL, NULL, 16354, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:28:47', 'admin-1516842527-1516858127714619', 1, 1, 'SR', NULL, NULL, NULL),
(61659, '2018-01-25 13:25:51', NULL, NULL, 16356, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:25:51', 'admin-1516842527-1516857951302913', 1, 1, 'SR', NULL, NULL, NULL),
(61660, '2018-01-25 14:13:41', NULL, NULL, 16359, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 14:13:41', 'admin-1516842527-1516860820915548', 1, 1, 'SR', NULL, NULL, NULL),
(61661, '2018-01-25 14:15:15', NULL, NULL, 16360, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1516842527', 'admin', '2018-01-25 14:15:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61662, '2018-01-25 13:59:18', NULL, NULL, 16358, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:59:18', 'admin-1516842527-15168599580191564', 1, 1, 'SR', NULL, NULL, NULL),
(61663, '2018-01-25 13:25:51', NULL, NULL, 16356, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:25:51', 'admin-1516842527-1516857951302913', 1, 0, '', NULL, NULL, NULL),
(61664, '2018-01-25 13:19:50', NULL, NULL, 16354, 0, 181, '116', 'Open Food ', 'garlic rice', 'Meals', 'Perfect Meals', 1, 15.90, 15.9000, 0.0000, 15.90, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:19:50', 'admin-1516842527-15168575903744196', 1, 0, '', NULL, NULL, NULL),
(61665, '2018-01-25 13:19:50', NULL, NULL, 16354, 0, 181, '116', 'Open Food ', 'garlic rice', 'Meals', 'Perfect Meals', 1, 15.90, 15.9000, 0.0000, 15.90, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:19:50', 'admin-1516842527-15168575903744196', 1, 0, '', NULL, NULL, NULL),
(61666, '2018-01-25 13:23:43', NULL, NULL, 16355, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:23:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61667, '2018-01-25 13:11:56', NULL, NULL, 16353, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:11:56', 'admin-1516842527-15168571163538370', 1, 0, '', NULL, NULL, NULL),
(61668, '2018-01-25 13:19:20', NULL, NULL, 16354, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.68, 0.0000, 0.0000, 6.68, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:19:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61669, '2018-01-25 00:00:00', NULL, NULL, 16351, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 10:04:06', 'admin-1516842527-15168458459126678', 1, 0, '', NULL, NULL, NULL),
(61670, '2018-01-25 11:39:22', NULL, NULL, 16348, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 11:39:22', 'admin-1516842527-15168515622779948', 1, 0, '', NULL, NULL, NULL),
(61671, '2018-01-25 10:45:04', NULL, NULL, 16346, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1516842527', 'admin', '2018-01-25 10:45:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61672, '2018-01-25 10:45:11', NULL, NULL, 16346, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 10:45:11', 'admin-1516842527-15168483110549382', 1, 1, 'SR', NULL, NULL, NULL),
(61673, '2018-01-25 12:31:31', NULL, NULL, 16352, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 12:31:31', 'admin-1516842527-15168546912812170', 1, 0, '', NULL, NULL, NULL),
(61674, '2018-01-25 12:54:59', NULL, NULL, 16353, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.20, 0.0000, 0.0000, 10.20, 1, '27', 1, '1516842527', 'admin', '2018-01-25 12:54:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61675, '2018-01-25 12:55:06', NULL, NULL, 16353, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 12:55:06', 'admin-1516842527-15168561059458960', 1, 0, '', NULL, NULL, NULL),
(61676, '2018-01-25 14:13:28', NULL, NULL, 16359, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1516842527', 'admin', '2018-01-25 14:13:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61677, '2018-01-25 00:00:00', NULL, NULL, 16349, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 10:00:53', 'admin-1516842527-15168456528588554', 1, 1, 'SR', NULL, NULL, NULL),
(61678, '2018-01-25 15:23:20', NULL, NULL, 16365, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1516842527', 'admin', '2018-01-25 15:23:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61679, '2018-01-25 11:22:41', NULL, NULL, 16347, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 11:22:41', 'admin-1516842527-15168505613264938', 1, 0, '', NULL, NULL, NULL),
(61680, '2018-01-25 11:39:09', NULL, NULL, 16348, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1516842527', 'admin', '2018-01-25 11:39:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61681, '2018-01-25 11:39:22', NULL, NULL, 16348, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 11:39:22', 'admin-1516842527-15168515622779948', 1, 1, 'SR', NULL, NULL, NULL),
(61682, '2018-01-25 15:21:05', NULL, NULL, 16363, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1516842527', 'admin', '2018-01-25 15:21:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61683, '2018-01-25 13:25:51', NULL, NULL, 16356, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:25:51', 'admin-1516842527-1516857951302913', 1, 0, '', NULL, NULL, NULL),
(61684, '2018-01-25 11:22:41', NULL, NULL, 16347, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1516842527', 'admin', '2018-01-25 11:22:41', 'admin-1516842527-15168505613264938', 1, 0, '', NULL, NULL, NULL),
(61685, '2018-01-25 10:46:31', NULL, NULL, 16343, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 10:46:31', 'admin-1516842527-1516848390894439', 1, 1, 'SR', NULL, NULL, NULL),
(61686, '2018-01-25 10:30:56', NULL, NULL, 16344, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 10:30:56', 'admin-1516842527-1516847456028714', 1, 1, 'SR', NULL, NULL, NULL),
(61687, '2018-01-25 10:29:21', NULL, NULL, 16344, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 10:29:21', 'admin-1516842527-15168473612186936', 1, 1, 'SR', NULL, NULL, NULL),
(61688, '2018-01-25 00:00:00', NULL, NULL, 16351, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 10:04:06', 'admin-1516842527-15168458459126678', 1, 1, 'SR', NULL, NULL, NULL),
(61689, '2018-01-25 10:19:53', NULL, NULL, 16343, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1516842527', 'admin', '2018-01-25 10:19:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61690, '2018-01-25 10:20:17', NULL, NULL, 16343, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 10:20:17', 'admin-1516842527-15168468176827836', 1, 1, 'SR', NULL, NULL, NULL),
(61691, '2018-01-25 14:15:34', NULL, NULL, 16360, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 14:15:34', 'admin-1516842527-15168609339328141', 1, 1, 'SR', NULL, NULL, NULL),
(61692, '2018-01-25 00:00:00', NULL, NULL, 16345, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 09:52:17', 'admin-1516842527-15168451373551175', 1, 0, '', NULL, NULL, NULL),
(61693, '2018-01-25 10:29:17', NULL, NULL, 16344, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1516842527', 'admin', '2018-01-25 10:29:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61694, '2018-01-25 09:34:03', NULL, NULL, 16341, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 09:34:03', 'admin-1516842527-1516844042882419', 1, 0, '', NULL, NULL, NULL),
(61695, '2018-01-25 09:34:03', NULL, NULL, 16341, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 09:34:03', 'admin-1516842527-1516844042882419', 1, 0, '', NULL, NULL, NULL),
(61696, '2018-01-25 09:34:03', NULL, NULL, 16341, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 09:34:03', 'admin-1516842527-1516844042882419', 1, 1, 'SR', NULL, NULL, NULL),
(61697, '2018-01-25 09:34:03', NULL, NULL, 16341, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 09:34:03', 'admin-1516842527-1516844042882419', 1, 1, 'SR', NULL, NULL, NULL),
(61698, '2018-01-25 09:52:09', NULL, NULL, 16342, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1516842527', 'admin', '2018-01-25 09:52:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61699, '2018-01-25 00:00:00', NULL, NULL, 16345, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 09:52:17', 'admin-1516842527-15168451373551175', 1, 1, 'SR', NULL, NULL, NULL),
(61700, '2018-01-25 13:50:43', NULL, NULL, 16357, 0, 181, '116', 'Open Food ', 'garlic rice', 'Meals', 'Perfect Meals', 1, 15.90, 15.9000, 0.0000, 15.90, 1, '27', 1, '1516842527', 'admin', '2018-01-25 13:50:43', 'admin-1516842527-1516859443499678', 1, 0, '', NULL, NULL, NULL),
(61701, '2018-01-25 11:41:33', NULL, NULL, 16351, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1516842527', 'admin', '2018-01-25 11:41:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61702, '2018-01-25 10:04:06', NULL, NULL, 16342, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 10:04:06', 'admin-1516842527-15168458459126678', 1, 1, 'SR', NULL, NULL, NULL),
(61703, '2018-01-25 10:04:06', NULL, NULL, 16342, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 10:04:06', 'admin-1516842527-15168458459126678', 1, 0, '', NULL, NULL, NULL),
(61704, '2018-01-25 11:40:17', NULL, NULL, 16349, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1516842527', 'admin', '2018-01-25 11:40:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61705, '2018-01-25 00:00:00', NULL, NULL, 16349, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 10:00:53', 'admin-1516842527-15168456528588554', 1, 0, '', NULL, NULL, NULL),
(61706, '2018-01-25 10:42:33', NULL, NULL, 16345, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1516842527', 'admin', '2018-01-25 10:42:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61707, '2018-01-25 00:00:00', NULL, NULL, 16350, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1516842527', 'admin', '2018-01-25 10:23:15', 'admin-1516842527-15168469952812458', 1, 1, 'SR', NULL, NULL, NULL),
(61708, '2018-01-25 09:33:49', NULL, NULL, 16341, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1516842527', 'admin', '2018-01-25 09:33:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61709, '2018-01-25 09:10:32', NULL, NULL, 16340, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1516842527', 'admin', '2018-01-25 09:10:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61710, '2018-01-26 13:19:48', NULL, NULL, 16380, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 13:19:48', 'admin-1516928757-15169439885553949', 1, 0, '', NULL, NULL, NULL),
(61711, '2018-01-26 13:19:48', NULL, NULL, 16380, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 13:19:48', 'admin-1516928757-15169439885553949', 1, 0, '', NULL, NULL, NULL),
(61712, '2018-01-26 12:21:24', NULL, NULL, 16378, 0, 181, '116', 'Open Food ', 'mushroom rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 12:21:24', 'admin-1516928757-15169404839989063', 1, 0, '', NULL, NULL, NULL),
(61713, '2018-01-26 12:25:41', NULL, NULL, 16378, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 12:25:41', 'admin-1516928757-1516940741739657', 1, 1, 'SR', NULL, NULL, NULL),
(61714, '2018-01-26 15:13:55', NULL, NULL, 16387, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 15:13:55', 'admin-1516928757-1516950834870681', 1, 0, '', NULL, NULL, NULL),
(61715, '2018-01-26 15:13:55', NULL, NULL, 16387, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 15:13:55', 'admin-1516928757-1516950834870681', 1, 0, '', NULL, NULL, NULL),
(61716, '2018-01-26 15:13:09', NULL, NULL, 16387, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1516928757', 'admin', '2018-01-26 15:13:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61717, '2018-01-26 15:41:39', NULL, NULL, 16390, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 15:41:39', 'admin-1516928757-15169524998488058', 1, 1, 'SR', NULL, NULL, NULL),
(61718, '2018-01-26 15:41:39', NULL, NULL, 16390, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 15:41:39', 'admin-1516928757-15169524998488058', 1, 1, 'SR', NULL, NULL, NULL),
(61719, '2018-01-26 16:04:10', NULL, NULL, 16391, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1516928757', 'admin', '2018-01-26 16:04:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61720, '2018-01-26 16:04:18', NULL, NULL, 16391, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 16:04:18', 'admin-1516928757-15169538582349614', 1, 1, 'SR', NULL, NULL, NULL),
(61721, '2018-01-26 12:25:47', NULL, NULL, 16378, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 12:25:47', 'admin-1516928757-1516940747438774', 1, 0, '', NULL, NULL, NULL),
(61722, '2018-01-26 14:57:51', NULL, NULL, 16383, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 14:57:51', 'admin-1516928757-15169498718019265', 1, 0, '', NULL, NULL, NULL),
(61723, '2018-01-26 12:00:50', NULL, NULL, 16377, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1516928757', 'admin', '2018-01-26 12:00:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61724, '2018-01-26 13:23:46', NULL, NULL, 16381, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 13:23:46', 'admin-1516928757-15169442260288629', 1, 0, '', NULL, NULL, NULL),
(61725, '2018-01-26 14:28:55', NULL, NULL, 16383, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 14:28:55', 'admin-1516928757-1516948135584828', 1, 1, 'SR', NULL, NULL, NULL),
(61726, '2018-01-26 14:28:55', NULL, NULL, 16383, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 14:28:55', 'admin-1516928757-1516948135584828', 1, 1, 'SR', NULL, NULL, NULL),
(61727, '2018-01-26 14:28:58', NULL, NULL, 16384, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1516928757', 'admin', '2018-01-26 14:28:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61728, '2018-01-26 14:47:07', NULL, NULL, 16386, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 14:47:07', 'admin-1516928757-15169492269745386', 1, 1, 'SR', 1, NULL, NULL),
(61729, '2018-01-26 10:14:51', NULL, NULL, 16372, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 10:14:51', 'admin-1516928757-15169328913714311', 1, 0, '', NULL, NULL, NULL),
(61730, '2018-01-26 14:40:16', NULL, NULL, 16385, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 14:40:16', 'admin-1516928757-15169488166314122', 1, 1, 'SR', NULL, NULL, NULL),
(61731, '2018-01-26 14:40:16', NULL, NULL, 16385, 0, 324, '260', 'Blueberry Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 14:40:16', 'admin-1516928757-15169488166314122', 1, 0, '', NULL, NULL, NULL),
(61732, '2018-01-26 15:20:01', NULL, NULL, 16388, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 15:20:01', 'admin-1516928757-15169512012768718', 1, 1, 'SR', 1, NULL, NULL),
(61733, '2018-01-26 12:25:41', NULL, NULL, 16378, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 12:25:41', 'admin-1516928757-1516940741739657', 1, 1, 'SR', NULL, NULL, NULL),
(61734, '2018-01-26 13:06:10', NULL, NULL, 16379, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1516928757', 'admin', '2018-01-26 13:06:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61735, '2018-01-26 13:24:41', NULL, NULL, 16382, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1516928757', 'admin', '2018-01-26 13:24:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61736, '2018-01-26 13:24:59', NULL, NULL, 16382, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 13:24:59', 'admin-1516928757-15169442994332912', 1, 0, '', NULL, NULL, NULL),
(61737, '2018-01-26 16:44:55', NULL, NULL, 16392, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 16:44:55', 'admin-1516928757-1516956295023912', 1, 1, 'SR', NULL, NULL, NULL),
(61738, '2018-01-26 16:04:18', NULL, NULL, 16391, 0, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 16:04:18', 'admin-1516928757-15169538582349614', 1, 1, 'SR', NULL, NULL, NULL),
(61739, '2018-01-26 15:41:39', NULL, NULL, 16390, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 15:41:39', 'admin-1516928757-15169524998488058', 1, 0, '', NULL, NULL, NULL),
(61740, '2018-01-26 15:40:29', NULL, NULL, 16389, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 15:40:29', 'admin-1516928757-1516952429765901', 1, 0, '', NULL, NULL, NULL),
(61741, '2018-01-26 13:06:48', NULL, NULL, 16379, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 13:06:48', 'admin-1516928757-15169432080681254', 1, 0, '', NULL, NULL, NULL),
(61742, '2018-01-26 15:40:18', NULL, NULL, 16389, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1516928757', 'admin', '2018-01-26 15:40:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61743, '2018-01-26 15:40:29', NULL, NULL, 16389, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 15:40:29', 'admin-1516928757-1516952429765901', 1, 1, 'SR', NULL, NULL, NULL),
(61744, '2018-01-26 15:40:29', NULL, NULL, 16389, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 15:40:29', 'admin-1516928757-1516952429765901', 1, 1, 'SR', NULL, NULL, NULL),
(61745, '2018-01-26 15:20:01', NULL, NULL, 16388, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 15:20:01', 'admin-1516928757-15169512012768718', 1, 1, 'SR', 1, NULL, NULL),
(61746, '2018-01-26 15:18:58', NULL, NULL, 16387, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 15:18:58', 'admin-1516928757-15169511387155447', 1, 0, '', NULL, NULL, NULL),
(61747, '2018-01-26 15:13:55', NULL, NULL, 16387, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 15:13:55', 'admin-1516928757-1516950834870681', 1, 1, 'SR', NULL, NULL, NULL),
(61748, '2018-01-26 10:29:22', NULL, NULL, 16375, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 10:29:22', 'admin-1516928757-1516933762720466', 1, 1, 'SR', 1, NULL, NULL),
(61749, '2018-01-26 11:58:47', NULL, NULL, 16376, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1516928757', 'admin', '2018-01-26 11:58:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61750, '2018-01-26 11:59:06', NULL, NULL, 16376, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 11:59:06', 'admin-1516928757-15169391460479839', 1, 0, '', NULL, NULL, NULL),
(61751, '2018-01-26 11:59:06', NULL, NULL, 16376, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 11:59:06', 'admin-1516928757-15169391460479839', 1, 0, '', NULL, NULL, NULL),
(61752, '2018-01-26 13:48:40', NULL, NULL, 16381, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 13:48:40', 'admin-1516928757-15169457208414347', 1, 0, '', NULL, NULL, NULL),
(61753, '2018-01-26 15:41:17', NULL, NULL, 16390, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1516928757', 'admin', '2018-01-26 15:41:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61754, '2018-01-26 10:29:04', NULL, NULL, 16374, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 10:29:04', 'admin-1516928757-15169337446256477', 1, 1, 'SR', NULL, NULL, NULL),
(61755, '2018-01-26 15:13:55', NULL, NULL, 16387, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 15:13:55', 'admin-1516928757-1516950834870681', 1, 1, 'SR', NULL, NULL, NULL),
(61756, '2018-01-26 15:13:55', NULL, NULL, 16387, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 15:13:55', 'admin-1516928757-1516950834870681', 1, 0, '', NULL, NULL, NULL),
(61757, '2018-01-26 14:57:51', NULL, NULL, 16383, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 14:57:51', 'admin-1516928757-15169498718019265', 1, 0, '', NULL, NULL, NULL),
(61758, '2018-01-26 14:47:07', NULL, NULL, 16386, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 14:47:07', 'admin-1516928757-15169492269745386', 1, 1, 'SR', 1, NULL, NULL),
(61759, '2018-01-26 14:40:05', NULL, NULL, 16385, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1516928757', 'admin', '2018-01-26 14:40:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61760, '2018-01-26 14:29:03', NULL, NULL, 16384, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 14:29:03', 'admin-1516928757-1516948143727653', 1, 1, 'SR', NULL, NULL, NULL),
(61761, '2018-01-26 14:28:55', NULL, NULL, 16383, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 14:28:55', 'admin-1516928757-1516948135584828', 1, 0, '', NULL, NULL, NULL),
(61762, '2018-01-26 14:28:55', NULL, NULL, 16383, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 14:28:55', 'admin-1516928757-1516948135584828', 1, 1, 'SR', NULL, NULL, NULL),
(61763, '2018-01-26 13:19:48', NULL, NULL, 16380, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 13:19:48', 'admin-1516928757-15169439885553949', 1, 0, '', NULL, NULL, NULL),
(61764, '2018-01-26 10:12:45', NULL, NULL, 16371, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 10:12:45', 'admin-1516928757-1516932765582837', 1, 1, 'SR', NULL, NULL, NULL),
(61765, '2018-01-26 10:15:01', NULL, NULL, 16373, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 10:15:01', 'admin-1516928757-15169329013522578', 1, 1, 'SR', NULL, NULL, NULL),
(61766, '2018-01-26 10:28:48', NULL, NULL, 16374, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1516928757', 'admin', '2018-01-26 10:28:48', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(61767, '2018-01-26 10:29:04', NULL, NULL, 16374, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 10:29:04', 'admin-1516928757-15169337446256477', 1, 0, '', NULL, NULL, NULL),
(61768, '2018-01-26 13:24:59', NULL, NULL, 16382, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 13:24:59', 'admin-1516928757-15169442994332912', 1, 1, 'SR', NULL, NULL, NULL),
(61769, '2018-01-26 16:44:55', NULL, NULL, 16392, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 16:44:55', 'admin-1516928757-1516956295023912', 1, 1, 'SR', NULL, NULL, NULL),
(61770, '2018-01-26 13:23:41', NULL, NULL, 16381, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1516928757', 'admin', '2018-01-26 13:23:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61771, '2018-01-26 13:23:46', NULL, NULL, 16381, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 13:23:46', 'admin-1516928757-15169442260288629', 1, 0, '', NULL, NULL, NULL),
(61772, '2018-01-26 14:28:39', NULL, NULL, 16383, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1516928757', 'admin', '2018-01-26 14:28:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61773, '2018-01-26 10:14:57', NULL, NULL, 16373, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1516928757', 'admin', '2018-01-26 10:14:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61774, '2018-01-26 13:19:31', NULL, NULL, 16380, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1516928757', 'admin', '2018-01-26 13:19:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61775, '2018-01-26 13:06:48', NULL, NULL, 16379, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 13:06:48', 'admin-1516928757-15169432080681254', 1, 1, 'SR', NULL, NULL, NULL),
(61776, '2018-01-26 13:06:48', NULL, NULL, 16379, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 13:06:48', 'admin-1516928757-15169432080681254', 1, 1, 'SR', NULL, NULL, NULL),
(61777, '2018-01-26 12:21:24', NULL, NULL, 16378, 0, 181, '116', 'Open Food ', 'mushroom rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 12:21:24', 'admin-1516928757-15169404839989063', 1, 0, '', NULL, NULL, NULL),
(61778, '2018-01-26 12:21:10', NULL, NULL, 16378, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1516928757', 'admin', '2018-01-26 12:21:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61779, '2018-01-26 10:15:01', NULL, NULL, 16373, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 10:15:01', 'admin-1516928757-15169329013522578', 1, 1, 'SR', NULL, NULL, NULL),
(61780, '2018-01-26 12:02:39', NULL, NULL, 16376, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 12:02:39', 'admin-1516928757-151693935896757', 1, 0, '', NULL, NULL, NULL),
(61781, '2018-01-26 12:00:55', NULL, NULL, 16377, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 12:00:55', 'admin-1516928757-15169392550918960', 1, 1, 'SR', NULL, NULL, NULL),
(61782, '2018-01-26 09:57:40', NULL, NULL, 16368, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 09:57:40', 'admin-1516928757-15169318602701756', 1, 0, '', NULL, NULL, NULL),
(61783, '2018-01-26 11:59:06', NULL, NULL, 16376, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 11:59:06', 'admin-1516928757-15169391460479839', 1, 0, '', NULL, NULL, NULL),
(61784, '2018-01-26 12:03:53', NULL, NULL, 16376, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 12:03:53', 'admin-1516928757-15169394335568045', 1, 1, 'SR', NULL, NULL, NULL),
(61785, '2018-01-26 10:15:01', NULL, NULL, 16373, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 10:15:01', 'admin-1516928757-15169329013522578', 1, 1, 'SR', NULL, NULL, NULL),
(61786, '2018-01-26 09:58:35', NULL, NULL, 16369, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1516928757', 'admin', '2018-01-26 09:58:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61787, '2018-01-26 09:58:40', NULL, NULL, 16369, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 09:58:40', 'admin-1516928757-1516931920408440', 1, 1, 'SR', NULL, NULL, NULL),
(61788, '2018-01-26 10:06:52', NULL, NULL, 16370, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1516928757', 'admin', '2018-01-26 10:06:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61789, '2018-01-26 10:07:04', NULL, NULL, 16370, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 10:07:04', 'admin-1516928757-15169324244426688', 1, 1, 'SR', NULL, NULL, NULL),
(61790, '2018-01-26 10:07:04', NULL, NULL, 16370, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 10:07:04', 'admin-1516928757-15169324244426688', 1, 1, 'SR', NULL, NULL, NULL),
(61791, '2018-01-26 10:12:22', NULL, NULL, 16371, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1516928757', 'admin', '2018-01-26 10:12:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61792, '2018-01-26 10:12:45', NULL, NULL, 16371, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 10:12:45', 'admin-1516928757-1516932765582837', 1, 0, '', NULL, NULL, NULL),
(61793, '2018-01-26 10:12:45', NULL, NULL, 16371, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 10:12:45', 'admin-1516928757-1516932765582837', 1, 0, '', NULL, NULL, NULL),
(61794, '2018-01-26 16:44:50', NULL, NULL, 16392, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1516928757', 'admin', '2018-01-26 16:44:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61795, '2018-01-26 10:14:51', NULL, NULL, 16372, 0, 335, '271', 'Iced Honey Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 10:14:51', 'admin-1516928757-15169328913714311', 1, 0, '', NULL, NULL, NULL),
(61796, '2018-01-26 10:14:51', NULL, NULL, 16372, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 10:14:51', 'admin-1516928757-15169328913714311', 1, 0, '', NULL, NULL, NULL),
(61797, '2018-01-26 10:14:51', NULL, NULL, 16372, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 10:14:51', 'admin-1516928757-15169328913714311', 1, 0, '', NULL, NULL, NULL),
(61798, '2018-01-26 10:14:34', NULL, NULL, 16372, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1516928757', 'admin', '2018-01-26 10:14:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61799, '2018-01-26 10:12:45', NULL, NULL, 16371, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 10:12:45', 'admin-1516928757-1516932765582837', 1, 1, 'SR', NULL, NULL, NULL),
(61800, '2018-01-26 10:12:45', NULL, NULL, 16371, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1516928757', 'admin', '2018-01-26 10:12:45', 'admin-1516928757-1516932765582837', 1, 1, 'SR', NULL, NULL, NULL),
(61801, '2018-01-26 09:57:34', NULL, NULL, 16368, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1516928757', 'admin', '2018-01-26 09:57:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61802, '2018-01-27 15:18:15', NULL, NULL, 16426, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 15:18:15', 'admin-1517014911-15170374955735591', 1, 0, '', NULL, NULL, NULL),
(61803, '2018-01-27 15:12:07', NULL, NULL, 16426, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 15:12:07', 'admin-1517014911-15170371270763134', 1, 0, '', NULL, NULL, NULL),
(61804, '2018-01-27 15:12:07', NULL, NULL, 16426, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 15:12:07', 'admin-1517014911-15170371270763134', 1, 1, 'SR', NULL, NULL, NULL),
(61805, '2018-01-27 15:17:56', NULL, NULL, 16426, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 15:17:56', 'admin-1517014911-15170374760683966', 1, 0, '', NULL, NULL, NULL),
(61806, '2018-01-27 15:25:07', NULL, NULL, 16427, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 15:25:07', 'admin-1517014911-15170379075103844', 1, 1, 'SR', 1, NULL, NULL),
(61807, '2018-01-27 15:33:51', NULL, NULL, 16428, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1517014911', 'admin', '2018-01-27 15:33:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61808, '2018-01-27 15:33:59', NULL, NULL, 16428, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 15:33:59', 'admin-1517014911-15170384394991238', 1, 0, '', NULL, NULL, NULL),
(61809, '2018-01-27 16:40:24', NULL, NULL, 16429, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 16:40:24', 'admin-1517014911-15170424244132035', 1, 0, '', NULL, NULL, NULL),
(61810, '2018-01-27 16:54:22', NULL, NULL, 16431, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1517014911', 'admin', '2018-01-27 16:54:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61811, '2018-01-27 16:54:26', NULL, NULL, 16431, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 16:54:26', 'admin-1517014911-15170432667105371', 1, 0, '', NULL, NULL, NULL),
(61812, '2018-01-27 13:24:55', NULL, NULL, 16421, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:24:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61813, '2018-01-27 13:33:49', NULL, NULL, 16411, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:33:49', 'admin-1517014911-15170312289984467', 1, 1, 'SR', NULL, NULL, NULL),
(61814, '2018-01-27 13:33:49', NULL, NULL, 16411, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:33:49', 'admin-1517014911-15170312289984467', 1, 1, 'SR', NULL, NULL, NULL),
(61815, '2018-01-27 13:36:36', NULL, NULL, 16422, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:36:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61816, '2018-01-27 13:37:02', NULL, NULL, 16422, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:37:02', 'admin-1517014911-15170314225915220', 1, 0, '', NULL, NULL, NULL),
(61817, '2018-01-27 13:37:02', NULL, NULL, 16422, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:37:02', 'admin-1517014911-15170314225915220', 1, 0, '', NULL, NULL, NULL),
(61818, '2018-01-27 13:37:02', NULL, NULL, 16422, 0, 321, '257', 'AA Set - Genius In the Bowl', '', 'Meals', 'Non-Rice', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:37:02', 'admin-1517014911-15170314225915220', 1, 0, '', NULL, NULL, NULL),
(61819, '2018-01-27 12:51:58', NULL, NULL, 16417, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:51:58', 'admin-1517014911-1517028718584593', 1, 1, 'SR', NULL, NULL, NULL),
(61820, '2018-01-27 12:59:20', NULL, NULL, 16418, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:59:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61821, '2018-01-27 12:59:39', NULL, NULL, 16418, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:59:39', 'admin-1517014911-15170291792748118', 1, 1, 'SR', NULL, NULL, NULL),
(61822, '2018-01-27 12:59:39', NULL, NULL, 16418, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:59:39', 'admin-1517014911-15170291792748118', 1, 1, 'SR', NULL, NULL, NULL),
(61823, '2018-01-27 13:12:14', NULL, NULL, 16419, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:12:14', 'admin-1517014911-15170299344432330', 1, 0, '', NULL, NULL, NULL),
(61824, '2018-01-27 13:12:46', NULL, NULL, 16418, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:12:46', 'admin-1517014911-15170299666657759', 1, 0, '', NULL, NULL, NULL),
(61825, '2018-01-27 13:12:46', NULL, NULL, 16418, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:12:46', 'admin-1517014911-15170299666657759', 1, 0, '', NULL, NULL, NULL),
(61826, '2018-01-27 15:36:11', NULL, NULL, 16426, 0, 181, '116', 'Open Food ', 'Dumpling 10s', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 15:36:11', 'admin-1517014911-15170385711237748', 1, 0, '', NULL, NULL, NULL),
(61827, '2018-01-27 11:17:35', NULL, NULL, 16408, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:17:35', 'admin-1517014911-15170230553189473', 1, 0, '', NULL, NULL, NULL),
(61828, '2018-01-27 11:17:35', NULL, NULL, 16408, 0, 75, '75', 'Meatless Aglio Olio ', 'less spicy', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:17:35', 'admin-1517014911-15170230553189473', 1, 0, '', NULL, NULL, NULL),
(61829, '2018-01-27 11:17:35', NULL, NULL, 16408, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:17:35', 'admin-1517014911-15170230553189473', 1, 1, 'SR', NULL, NULL, NULL),
(61830, '2018-01-27 10:41:26', NULL, NULL, 16403, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:41:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61831, '2018-01-27 12:43:42', NULL, NULL, 16416, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:43:42', 'admin-1517014911-15170282226237144', 1, 1, 'SR', NULL, NULL, NULL),
(61832, '2018-01-27 11:51:11', NULL, NULL, 16412, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 15.50, 0.0000, 0.0000, 15.50, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:51:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61833, '2018-01-27 11:51:17', NULL, NULL, 16412, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:51:17', 'admin-1517014911-1517025076878430', 1, 1, 'SR', NULL, NULL, NULL),
(61834, '2018-01-27 11:51:17', NULL, NULL, 16412, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:51:17', 'admin-1517014911-1517025076878430', 1, 1, 'SR', NULL, NULL, NULL),
(61835, '2018-01-27 11:50:02', NULL, NULL, 16411, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:50:02', 'admin-1517014911-15170250022444466', 1, 1, 'SR', NULL, NULL, NULL),
(61836, '2018-01-27 11:50:02', NULL, NULL, 16411, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:50:02', 'admin-1517014911-15170250022444466', 1, 1, 'SR', NULL, NULL, NULL),
(61837, '2018-01-27 12:43:42', NULL, NULL, 16416, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:43:42', 'admin-1517014911-15170282226237144', 1, 0, '', NULL, NULL, NULL),
(61838, '2018-01-27 12:43:42', NULL, NULL, 16416, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:43:42', 'admin-1517014911-15170282226237144', 1, 0, '', NULL, NULL, NULL),
(61839, '2018-01-27 11:57:03', NULL, NULL, 16413, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:57:03', 'admin-1517014911-15170254231053576', 1, 0, '', NULL, NULL, NULL),
(61840, '2018-01-27 12:43:17', NULL, NULL, 16416, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:43:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61841, '2018-01-27 13:11:13', NULL, NULL, 16419, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:11:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61842, '2018-01-27 12:11:07', NULL, NULL, 16412, 0, 181, '116', 'Open Food ', 'Dumpling 10''s', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:11:07', 'admin-1517014911-15170262675459652', 1, 0, '', NULL, NULL, NULL),
(61843, '2018-01-27 13:57:55', NULL, NULL, 16424, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:57:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61844, '2018-01-27 13:20:26', NULL, NULL, 16420, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 8.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:20:26', 'admin-1517014911-15170304266522318', 1, 0, '', NULL, '20.0', NULL),
(61845, '2018-01-27 13:22:48', NULL, NULL, 16412, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:22:48', 'admin-1517014911-1517030568841154', 1, 1, 'SR', NULL, NULL, NULL),
(61846, '2018-01-27 17:15:39', NULL, NULL, 16432, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1517014911', 'admin', '2018-01-27 17:15:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61847, '2018-01-27 17:16:39', NULL, NULL, 16432, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 17:16:39', 'admin-1517014911-15170445997608719', 1, 0, '', NULL, NULL, NULL),
(61848, '2018-01-27 17:16:39', NULL, NULL, 16432, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 17:16:39', 'admin-1517014911-15170445997608719', 1, 1, 'SR', NULL, NULL, NULL),
(61849, '2018-01-27 10:38:21', NULL, NULL, 16402, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:38:21', 'admin-1517014911-15170207015731515', 1, 1, 'SR', NULL, NULL, NULL),
(61850, '2018-01-27 10:38:21', NULL, NULL, 16402, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:38:21', 'admin-1517014911-15170207015731515', 1, 1, 'SR', NULL, NULL, NULL),
(61851, '2018-01-27 13:25:14', NULL, NULL, 16421, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:25:14', 'admin-1517014911-15170307144817744', 1, 0, '', NULL, NULL, NULL),
(61852, '2018-01-27 12:59:39', NULL, NULL, 16418, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:59:39', 'admin-1517014911-15170291792748118', 1, 1, 'SR', NULL, NULL, NULL),
(61853, '2018-01-27 16:08:33', NULL, NULL, 16430, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 16:08:33', 'admin-1517014911-15170405134557351', 1, 1, 'SR', NULL, NULL, NULL),
(61854, '2018-01-27 13:22:48', NULL, NULL, 16412, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, 7.0000, 0.0000, 7.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:22:48', 'admin-1517014911-1517030568841154', 1, 0, '', NULL, NULL, NULL),
(61855, '2018-01-27 10:54:13', NULL, NULL, 16406, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:54:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61856, '2018-01-27 16:08:27', NULL, NULL, 16430, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1517014911', 'admin', '2018-01-27 16:08:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61857, '2018-01-27 11:17:35', NULL, NULL, 16408, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:17:35', 'admin-1517014911-15170230553189473', 1, 0, '', NULL, NULL, NULL),
(61858, '2018-01-27 11:26:01', NULL, NULL, 16409, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:26:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61859, '2018-01-27 11:26:12', NULL, NULL, 16409, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:26:12', 'admin-1517014911-1517023572694382', 1, 1, 'SR', NULL, NULL, NULL),
(61860, '2018-01-27 12:59:39', NULL, NULL, 16418, 0, 323, '259', 'Ginger Cucumber Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:59:39', 'admin-1517014911-15170291792748118', 1, 0, '', NULL, NULL, NULL),
(61861, '2018-01-27 17:16:39', NULL, NULL, 16432, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 17:16:39', 'admin-1517014911-15170445997608719', 1, 1, 'SR', NULL, NULL, NULL),
(61862, '2018-01-27 10:54:28', NULL, NULL, 16406, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:54:28', 'admin-1517014911-1517021668639924', 1, 1, 'SR', NULL, NULL, NULL),
(61863, '2018-01-27 14:32:45', NULL, NULL, 16425, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 14:32:45', 'admin-1517014911-1517034765738222', 1, 1, 'SR', NULL, NULL, NULL),
(61864, '2018-01-27 14:32:39', NULL, NULL, 16425, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 14:32:39', 'admin-1517014911-15170347591288516', 1, 0, '', NULL, NULL, NULL),
(61865, '2018-01-27 12:11:07', NULL, NULL, 16412, 0, 181, '116', 'Open Food ', 'Dumpling 10''s', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:11:07', 'admin-1517014911-15170262675459652', 1, 0, '', NULL, NULL, NULL),
(61866, '2018-01-27 12:20:00', NULL, NULL, 16411, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:20:00', 'admin-1517014911-15170267999776515', 1, 0, '', NULL, NULL, NULL),
(61867, '2018-01-27 12:20:00', NULL, NULL, 16411, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:20:00', 'admin-1517014911-15170267999776515', 1, 0, '', NULL, NULL, NULL),
(61868, '2018-01-27 12:11:07', NULL, NULL, 16412, 0, 181, '116', 'Open Food ', 'Dumpling 10''s', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:11:07', 'admin-1517014911-15170262675459652', 1, 0, '', NULL, NULL, NULL),
(61869, '2018-01-27 12:11:07', NULL, NULL, 16412, 0, 181, '116', 'Open Food ', 'Dumpling 10''s', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:11:07', 'admin-1517014911-15170262675459652', 1, 0, '', NULL, NULL, NULL),
(61870, '2018-01-27 11:35:44', NULL, NULL, 16410, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:35:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61871, '2018-01-27 11:35:53', NULL, NULL, 16410, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:35:53', 'admin-1517014911-15170241534619918', 1, 1, 'SR', NULL, NULL, NULL),
(61872, '2018-01-27 16:01:36', NULL, NULL, 16429, 0, 70, '70', 'Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 16:01:36', 'admin-1517014911-15170400963845212', 1, 1, 'SR', NULL, NULL, NULL),
(61873, '2018-01-27 12:02:38', NULL, NULL, 16415, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:02:38', 'admin-1517014911-15170257579307166', 1, 1, 'SR', NULL, NULL, NULL),
(61874, '2018-01-27 12:02:38', NULL, NULL, 16415, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:02:38', 'admin-1517014911-15170257579307166', 1, 0, '', NULL, NULL, NULL),
(61875, '2018-01-27 16:08:33', NULL, NULL, 16430, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 16:08:33', 'admin-1517014911-15170405134557351', 1, 1, 'SR', NULL, NULL, NULL),
(61876, '2018-01-27 16:01:36', NULL, NULL, 16429, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 16:01:36', 'admin-1517014911-15170400963845212', 1, 0, '', NULL, NULL, NULL),
(61877, '2018-01-27 11:57:21', NULL, NULL, 16414, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:57:21', 'admin-1517014911-1517025440968147', 1, 1, 'SR', NULL, NULL, NULL),
(61878, '2018-01-27 16:00:42', NULL, NULL, 16429, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1517014911', 'admin', '2018-01-27 16:00:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61879, '2018-01-27 16:01:36', NULL, NULL, 16429, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 16:01:36', 'admin-1517014911-15170400963845212', 1, 1, 'SR', NULL, NULL, NULL),
(61880, '2018-01-27 16:01:36', NULL, NULL, 16429, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 16:01:36', 'admin-1517014911-15170400963845212', 1, 1, 'SR', NULL, NULL, NULL),
(61881, '2018-01-27 12:51:58', NULL, NULL, 16417, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:51:58', 'admin-1517014911-1517028718584593', 1, 0, '', NULL, NULL, NULL),
(61882, '2018-01-27 12:50:43', NULL, NULL, 16417, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:50:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61883, '2018-01-27 12:05:46', NULL, NULL, 16412, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:05:46', 'admin-1517014911-15170259457858121', 1, 1, 'SR', NULL, NULL, NULL),
(61884, '2018-01-27 13:40:12', NULL, NULL, 16423, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:40:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61885, '2018-01-27 13:40:28', NULL, NULL, 16423, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:40:28', 'admin-1517014911-15170316280349862', 1, 1, 'SR', NULL, NULL, NULL),
(61886, '2018-01-27 13:40:28', NULL, NULL, 16423, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:40:28', 'admin-1517014911-15170316280349862', 1, 1, 'SR', NULL, NULL, NULL),
(61887, '2018-01-27 15:36:11', NULL, NULL, 16426, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 15:36:11', 'admin-1517014911-15170385711237748', 1, 1, 'SR', NULL, NULL, NULL),
(61888, '2018-01-27 13:25:14', NULL, NULL, 16421, 0, 153, '87', 'Wake Me Up!', 'no pork bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:25:14', 'admin-1517014911-15170307144817744', 1, 0, '', NULL, NULL, NULL),
(61889, '2018-01-27 13:25:14', NULL, NULL, 16421, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:25:14', 'admin-1517014911-15170307144817744', 1, 0, '', NULL, NULL, NULL),
(61890, '2018-01-27 13:25:14', NULL, NULL, 16421, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:25:14', 'admin-1517014911-15170307144817744', 1, 0, '', NULL, NULL, NULL),
(61891, '2018-01-27 15:36:11', NULL, NULL, 16426, 0, 181, '116', 'Open Food ', 'Dumpling 10s', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 15:36:11', 'admin-1517014911-15170385711237748', 1, 0, '', NULL, NULL, NULL),
(61892, '2018-01-27 15:36:11', NULL, NULL, 16426, 0, 181, '116', 'Open Food ', 'Dumpling 10s', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 15:36:11', 'admin-1517014911-15170385711237748', 1, 0, '', NULL, NULL, NULL),
(61893, '2018-01-27 15:36:11', NULL, NULL, 16426, 0, 181, '116', 'Open Food ', 'Dumpling 10s', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 15:36:11', 'admin-1517014911-15170385711237748', 1, 0, '', NULL, NULL, NULL),
(61894, '2018-01-27 15:33:59', NULL, NULL, 16428, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 15:33:59', 'admin-1517014911-15170384394991238', 1, 1, 'SR', NULL, NULL, NULL),
(61895, '2018-01-27 12:43:42', NULL, NULL, 16416, 0, 335, '271', 'Iced Honey Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:43:42', 'admin-1517014911-15170282226237144', 1, 0, '', NULL, NULL, NULL),
(61896, '2018-01-27 15:11:58', NULL, NULL, 16426, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 13.80, 0.0000, 0.0000, 13.80, 1, '27', 1, '1517014911', 'admin', '2018-01-27 15:11:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61897, '2018-01-27 14:32:39', NULL, NULL, 16425, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 14:32:39', 'admin-1517014911-15170347591288516', 1, 0, '', NULL, NULL, NULL),
(61898, '2018-01-27 14:32:25', NULL, NULL, 16425, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1517014911', 'admin', '2018-01-27 14:32:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61899, '2018-01-27 13:58:02', NULL, NULL, 16424, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:58:02', 'admin-1517014911-15170326825812847', 1, 0, '', NULL, NULL, NULL),
(61900, '2018-01-27 13:42:26', NULL, NULL, 16419, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Rice', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:42:26', 'admin-1517014911-15170317465225660', 1, 0, '', NULL, NULL, NULL),
(61901, '2018-01-27 13:20:09', NULL, NULL, 16420, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:20:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61902, '2018-01-27 13:20:26', NULL, NULL, 16420, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:20:26', 'admin-1517014911-15170304266522318', 1, 1, 'SR', NULL, NULL, NULL),
(61903, '2018-01-27 09:51:46', NULL, NULL, 16398, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1517014911', 'admin', '2018-01-27 09:51:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61904, '2018-01-27 09:16:10', NULL, NULL, 16393, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 8.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 09:16:10', 'admin-1517014911-15170157700283538', 1, 0, '', NULL, '20.0', NULL),
(61905, '2018-01-27 09:18:03', NULL, NULL, 16396, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 09:18:03', 'admin-1517014911-1517015883400568', 1, 0, '', NULL, NULL, NULL),
(61906, '2018-01-27 09:18:03', NULL, NULL, 16396, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 09:18:03', 'admin-1517014911-1517015883400568', 1, 0, '', NULL, NULL, NULL),
(61907, '2018-01-27 09:17:50', NULL, NULL, 16396, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1517014911', 'admin', '2018-01-27 09:17:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61908, '2018-01-27 13:45:56', NULL, NULL, 16422, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:45:56', 'admin-1517014911-15170319559842229', 1, 0, '', NULL, NULL, NULL),
(61909, '2018-01-27 12:04:22', NULL, NULL, 16412, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:04:22', 'admin-1517014911-15170258625343226', 1, 0, '', NULL, NULL, NULL),
(61910, '2018-01-27 12:02:38', NULL, NULL, 16415, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:02:38', 'admin-1517014911-15170257579307166', 1, 0, '', NULL, NULL, NULL),
(61911, '2018-01-27 10:41:36', NULL, NULL, 16403, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:41:36', 'admin-1517014911-15170208962255771', 1, 0, '', NULL, NULL, NULL),
(61912, '2018-01-27 10:41:36', NULL, NULL, 16403, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:41:36', 'admin-1517014911-15170208962255771', 1, 0, '', NULL, NULL, NULL),
(61913, '2018-01-27 16:59:37', NULL, NULL, 16431, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 16:59:37', 'admin-1517014911-15170435778682511', 1, 0, '', NULL, NULL, NULL),
(61914, '2018-01-27 11:57:03', NULL, NULL, 16413, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:57:03', 'admin-1517014911-15170254231053576', 1, 1, 'SR', NULL, NULL, NULL),
(61915, '2018-01-27 12:02:38', NULL, NULL, 16415, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:02:38', 'admin-1517014911-15170257579307166', 1, 0, '', NULL, NULL, NULL),
(61916, '2018-01-27 12:02:08', NULL, NULL, 16415, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:02:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61917, '2018-01-27 11:57:03', NULL, NULL, 16413, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:57:03', 'admin-1517014911-15170254231053576', 1, 0, '', NULL, NULL, NULL),
(61918, '2018-01-27 11:57:03', NULL, NULL, 16413, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:57:03', 'admin-1517014911-15170254231053576', 1, 0, '', NULL, NULL, NULL),
(61919, '2018-01-27 12:04:22', NULL, NULL, 16412, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:04:22', 'admin-1517014911-15170258625343226', 1, 0, '', NULL, NULL, NULL),
(61920, '2018-01-27 10:38:21', NULL, NULL, 16402, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:38:21', 'admin-1517014911-15170207015731515', 1, 0, '', NULL, '20.0', NULL),
(61921, '2018-01-27 09:35:05', NULL, NULL, 16397, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1517014911', 'admin', '2018-01-27 09:35:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61922, '2018-01-27 10:05:34', NULL, NULL, 16400, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:05:34', 'admin-1517014911-15170187341463157', 1, 0, '', NULL, NULL, NULL),
(61923, '2018-01-27 10:05:34', NULL, NULL, 16400, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:05:34', 'admin-1517014911-15170187341463157', 1, 0, '', NULL, NULL, NULL),
(61924, '2018-01-27 10:58:08', NULL, NULL, 16407, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:58:08', 'admin-1517014911-1517021888005282', 1, 0, '', NULL, NULL, NULL),
(61925, '2018-01-27 11:55:53', NULL, NULL, 16413, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:55:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61926, '2018-01-27 13:12:14', NULL, NULL, 16419, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:12:14', 'admin-1517014911-15170299344432330', 1, 0, '', NULL, NULL, NULL),
(61927, '2018-01-27 11:35:53', NULL, NULL, 16410, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:35:53', 'admin-1517014911-15170241534619918', 1, 1, 'SR', NULL, NULL, NULL),
(61928, '2018-01-27 11:49:56', NULL, NULL, 16411, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:49:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61929, '2018-01-27 11:26:12', NULL, NULL, 16409, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:26:12', 'admin-1517014911-1517023572694382', 1, 1, 'SR', NULL, NULL, NULL),
(61930, '2018-01-27 11:17:35', NULL, NULL, 16408, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:17:35', 'admin-1517014911-15170230553189473', 1, 1, 'SR', NULL, NULL, NULL),
(61931, '2018-01-27 10:43:11', NULL, NULL, 16405, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:43:11', 'admin-1517014911-15170209913227192', 1, 1, 'SR', NULL, NULL, NULL),
(61932, '2018-01-27 09:18:03', NULL, NULL, 16396, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 09:18:03', 'admin-1517014911-1517015883400568', 1, 1, 'SR', NULL, NULL, NULL),
(61933, '2018-01-27 11:57:12', NULL, NULL, 16414, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:57:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61934, '2018-01-27 11:17:35', NULL, NULL, 16408, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:17:35', 'admin-1517014911-15170230553189473', 1, 0, '', NULL, NULL, NULL),
(61935, '2018-01-27 11:17:02', NULL, NULL, 16408, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.50, 0.0000, 0.0000, 9.50, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:17:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61936, '2018-01-27 10:58:08', NULL, NULL, 16407, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:58:08', 'admin-1517014911-1517021888005282', 1, 0, '', NULL, NULL, NULL),
(61937, '2018-01-27 10:58:08', NULL, NULL, 16407, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:58:08', 'admin-1517014911-1517021888005282', 1, 0, '', NULL, NULL, NULL),
(61938, '2018-01-27 10:57:51', NULL, NULL, 16407, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:57:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61939, '2018-01-27 10:42:15', NULL, NULL, 16404, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:42:15', 'admin-1517014911-15170209349751099', 1, 1, 'SR', 1, NULL, NULL),
(61940, '2018-01-27 10:43:11', NULL, NULL, 16405, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:43:11', 'admin-1517014911-15170209913227192', 1, 1, 'SR', NULL, NULL, NULL),
(61941, '2018-01-27 10:43:02', NULL, NULL, 16405, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:43:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61942, '2018-01-27 10:41:36', NULL, NULL, 16403, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:41:36', 'admin-1517014911-15170208962255771', 1, 1, 'SR', NULL, NULL, NULL),
(61943, '2018-01-27 10:41:36', NULL, NULL, 16403, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:41:36', 'admin-1517014911-15170208962255771', 1, 1, 'SR', NULL, NULL, NULL),
(61944, '2018-01-27 12:35:26', NULL, NULL, 16412, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:35:26', 'admin-1517014911-15170277263434348', 1, 0, '', NULL, NULL, NULL),
(61945, '2018-01-27 13:12:14', NULL, NULL, 16419, 0, 320, '256', 'AA Set - Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 13:12:14', 'admin-1517014911-15170299344432330', 1, 0, '', NULL, NULL, NULL),
(61946, '2018-01-27 10:38:21', NULL, NULL, 16402, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:38:21', 'admin-1517014911-15170207015731515', 1, 1, 'SR', NULL, NULL, NULL),
(61947, '2018-01-27 10:30:30', NULL, NULL, 16401, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:30:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61948, '2018-01-27 10:32:10', NULL, NULL, 16401, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:32:10', 'admin-1517014911-15170203300629697', 1, 0, '', NULL, NULL, NULL),
(61949, '2018-01-27 10:30:53', NULL, NULL, 16401, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:30:53', 'admin-1517014911-15170202538196221', 1, 0, '', NULL, NULL, NULL),
(61950, '2018-01-27 10:30:53', NULL, NULL, 16401, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:30:53', 'admin-1517014911-15170202538196221', 1, 1, 'SR', NULL, NULL, NULL),
(61951, '2018-01-27 11:57:21', NULL, NULL, 16414, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 11:57:21', 'admin-1517014911-1517025440968147', 1, 1, 'SR', NULL, NULL, NULL),
(61952, '2018-01-27 10:37:53', NULL, NULL, 16402, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.26, 0.0000, 0.0000, 4.26, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:37:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61953, '2018-01-27 10:05:34', NULL, NULL, 16400, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:05:34', 'admin-1517014911-15170187341463157', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(61954, '2018-01-27 10:05:34', NULL, NULL, 16400, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:05:34', 'admin-1517014911-15170187341463157', 1, 1, 'SR', NULL, NULL, NULL),
(61955, '2018-01-27 10:05:17', NULL, NULL, 16400, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1517014911', 'admin', '2018-01-27 10:05:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61956, '2018-01-27 00:00:00', NULL, NULL, 16398, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 09:14:09', 'admin-1517014911-15170156491551385', 1, 1, 'SR', NULL, NULL, NULL),
(61957, '2018-01-27 09:35:11', NULL, NULL, 16397, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 09:35:11', 'admin-1517014911-15170169114507618', 1, 1, 'SR', NULL, NULL, NULL),
(61958, '2018-01-27 09:35:11', NULL, NULL, 16397, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 09:35:11', 'admin-1517014911-15170169114507618', 1, 0, '', NULL, NULL, NULL),
(61959, '2018-01-27 09:18:03', NULL, NULL, 16396, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 09:18:03', 'admin-1517014911-1517015883400568', 1, 1, 'SR', NULL, NULL, NULL),
(61960, '2018-01-27 12:04:07', NULL, NULL, 16413, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 12:04:07', 'admin-1517014911-15170258473887392', 1, 0, '', NULL, NULL, NULL),
(61961, '2018-01-27 00:00:00', NULL, NULL, 16399, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', NULL, 1, 0.80, NULL, NULL, 0.80, 1, '27', 1, '1517014911', 'admin', '2018-01-27 09:13:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61962, '2018-01-27 00:00:00', NULL, NULL, 16399, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 09:14:09', 'admin-1517014911-15170156491551385', 1, 1, 'SR', NULL, NULL, NULL),
(61963, '2018-01-27 09:09:10', NULL, NULL, 16394, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 09:09:10', 'admin-1517014911-15170153499415231', 1, 0, '', NULL, NULL, NULL),
(61964, '2018-01-27 09:06:48', NULL, NULL, 16394, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 09:06:48', 'admin-1517014911-15170152088007131', 1, 1, 'SR', NULL, NULL, NULL),
(61965, '2018-01-27 09:06:48', NULL, NULL, 16394, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 09:06:48', 'admin-1517014911-15170152088007131', 1, 0, '', NULL, NULL, NULL),
(61966, '2018-01-27 09:03:21', NULL, NULL, 16393, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 09:03:21', 'admin-1517014911-15170150018845890', 1, 1, 'SR', NULL, NULL, NULL),
(61967, '2018-01-27 09:03:22', NULL, NULL, 16393, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 09:03:22', 'admin-1517014911-15170150018845890', 1, 0, '', NULL, NULL, NULL),
(61968, '2018-01-27 09:06:32', NULL, NULL, 16394, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1517014911', 'admin', '2018-01-27 09:06:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61969, '2018-01-27 09:03:16', NULL, NULL, 16393, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1517014911', 'admin', '2018-01-27 09:03:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61970, '2018-01-28 13:09:39', NULL, NULL, 16452, 0, 181, '116', 'Open Food ', 'dumpling 2 pcs', 'Meals', 'Perfect Meals', 1, 0.00, 0.0000, 0.0000, 0.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:09:39', 'admin-1517100387-15171161798051451', 1, 0, '', NULL, NULL, NULL),
(61971, '2018-01-28 13:18:22', NULL, NULL, 16453, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:18:22', 'admin-1517100387-15171167026921543', 1, 0, '', 1, NULL, NULL),
(61972, '2018-01-28 13:21:30', NULL, NULL, 16454, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 15.00, 0.0000, 0.0000, 15.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:21:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61973, '2018-01-28 13:21:49', NULL, NULL, 16454, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:21:49', 'admin-1517100387-15171169098857951', 1, 0, '', NULL, NULL, NULL),
(61974, '2018-01-28 13:21:50', NULL, NULL, 16454, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:21:50', 'admin-1517100387-15171169098857951', 1, 0, '', NULL, NULL, NULL),
(61975, '2018-01-28 13:21:50', NULL, NULL, 16454, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:21:50', 'admin-1517100387-15171169098857951', 1, 0, '', NULL, NULL, NULL),
(61976, '2018-01-28 13:21:50', NULL, NULL, 16454, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:21:50', 'admin-1517100387-15171169098857951', 1, 0, '', NULL, NULL, NULL),
(61977, '2018-01-28 15:00:37', NULL, NULL, 16466, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1517100387', 'admin', '2018-01-28 15:00:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61978, '2018-01-28 14:14:45', NULL, NULL, 16459, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:14:45', 'admin-1517100387-1517120084947714', 1, 1, 'SR', NULL, NULL, NULL),
(61979, '2018-01-28 15:08:12', NULL, NULL, 16458, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 15:08:12', 'admin-1517100387-15171232919503756', 1, 0, '', NULL, NULL, NULL),
(61980, '2018-01-28 15:08:12', NULL, NULL, 16458, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 15:08:12', 'admin-1517100387-15171232919503756', 1, 0, '', NULL, NULL, NULL),
(61981, '2018-01-28 15:08:12', NULL, NULL, 16458, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1517100387', 'admin', '2018-01-28 15:08:12', 'admin-1517100387-15171232919503756', 1, 0, '', NULL, NULL, NULL),
(61982, '2018-01-28 15:08:12', NULL, NULL, 16458, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 15:08:12', 'admin-1517100387-15171232919503756', 1, 1, 'SR', NULL, NULL, NULL),
(61983, '2018-01-28 00:00:00', NULL, NULL, 16468, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:13:43', 'admin-1517100387-1517120023686548', 1, 1, 'SR', NULL, NULL, NULL),
(61984, '2018-01-28 00:00:00', NULL, NULL, 16467, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:13:43', 'admin-1517100387-1517120023686548', 1, 1, 'SR', NULL, NULL, NULL),
(61985, '2018-01-28 00:00:00', NULL, NULL, 16466, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:13:43', 'admin-1517100387-1517120023686548', 1, 1, 'SR', NULL, NULL, NULL),
(61986, '2018-01-28 14:54:43', NULL, NULL, 16465, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:54:43', 'admin-1517100387-15171224832699751', 1, 1, 'SR', 1, NULL, NULL),
(61987, '2018-01-28 14:54:31', NULL, NULL, 16464, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:54:31', 'admin-1517100387-1517122471008535', 1, 1, 'SR', NULL, NULL, NULL),
(61988, '2018-01-28 14:52:39', NULL, NULL, 16464, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:52:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61989, '2018-01-28 14:44:39', NULL, NULL, 16463, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:44:39', 'admin-1517100387-15171218794908719', 1, 1, 'SR', NULL, NULL, NULL),
(61990, '2018-01-28 15:42:30', NULL, NULL, 16458, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 15:42:30', 'admin-1517100387-15171253502332574', 1, 0, '', NULL, NULL, NULL),
(61991, '2018-01-28 15:49:26', NULL, NULL, 16469, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1517100387', 'admin', '2018-01-28 15:49:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61992, '2018-01-28 15:49:32', NULL, NULL, 16469, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 15:49:32', 'admin-1517100387-15171257727719523', 1, 1, 'SR', NULL, NULL, NULL),
(61993, '2018-01-28 13:23:35', NULL, NULL, 16455, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:23:35', 'admin-1517100387-15171170155143350', 1, 1, 'SR', NULL, NULL, NULL),
(61994, '2018-01-28 13:23:35', NULL, NULL, 16455, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:23:35', 'admin-1517100387-15171170155143350', 1, 1, 'SR', NULL, NULL, NULL),
(61995, '2018-01-28 13:23:35', NULL, NULL, 16455, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:23:35', 'admin-1517100387-15171170155143350', 1, 1, 'SR', NULL, NULL, NULL),
(61996, '2018-01-28 13:46:40', NULL, NULL, 16456, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.96, 0.0000, 0.0000, 2.96, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:46:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(61997, '2018-01-28 13:51:16', NULL, NULL, 16456, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:51:16', 'admin-1517100387-15171186764251213', 1, 1, 'SR', NULL, NULL, NULL),
(61998, '2018-01-28 13:51:16', NULL, NULL, 16456, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:51:16', 'admin-1517100387-15171186764251213', 1, 1, 'SR', NULL, NULL, NULL),
(61999, '2018-01-28 13:51:16', NULL, NULL, 16456, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:51:16', 'admin-1517100387-15171186764251213', 1, 0, '', NULL, '20.0', NULL),
(62000, '2018-01-28 13:52:17', NULL, NULL, 16457, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:52:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62001, '2018-01-28 13:52:22', NULL, NULL, 16457, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:52:22', 'admin-1517100387-15171187427926213', 1, 0, '', NULL, NULL, NULL),
(62002, '2018-01-28 13:52:22', NULL, NULL, 16457, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:52:22', 'admin-1517100387-15171187427926213', 1, 0, '', NULL, NULL, NULL),
(62003, '2018-01-28 13:59:59', NULL, NULL, 16454, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 4, 8.00, 32.0000, 0.0000, 32.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:59:59', 'admin-1517100387-15171191996322336', 1, 1, 'SR', NULL, NULL, NULL),
(62004, '2018-01-28 13:59:59', NULL, NULL, 16454, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:59:59', 'admin-1517100387-15171191996322336', 1, 1, 'SR', NULL, NULL, NULL),
(62005, '2018-01-28 16:11:49', NULL, NULL, 16469, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 16:11:49', 'admin-1517100387-15171271090941074', 1, 1, 'SR', NULL, NULL, NULL),
(62006, '2018-01-28 16:16:56', NULL, NULL, 16470, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1517100387', 'admin', '2018-01-28 16:16:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62007, '2018-01-28 16:17:00', NULL, NULL, 16470, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 16:17:00', 'admin-1517100387-1517127420091849', 1, 1, 'SR', NULL, NULL, NULL),
(62008, '2018-01-28 17:06:09', NULL, NULL, 16471, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 17:06:09', 'admin-1517100387-15171303689584639', 1, 1, 'SR', 1, NULL, NULL),
(62009, '2018-01-28 17:06:09', NULL, NULL, 16471, 0, 305, '241', 'Sprite', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 17:06:09', 'admin-1517100387-15171303689584639', 1, 0, '', 1, NULL, NULL),
(62010, '2018-01-28 11:19:28', NULL, NULL, 16444, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 15.26, 0.0000, 0.0000, 15.26, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:19:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62011, '2018-01-28 11:20:14', NULL, NULL, 16444, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:20:14', 'admin-1517100387-15171096147674774', 1, 0, '', NULL, NULL, NULL),
(62012, '2018-01-28 11:20:14', NULL, NULL, 16444, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:20:14', 'admin-1517100387-15171096147674774', 1, 0, '', NULL, NULL, NULL),
(62013, '2018-01-28 11:20:14', NULL, NULL, 16444, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:20:14', 'admin-1517100387-15171096147674774', 1, 0, '', NULL, NULL, NULL),
(62014, '2018-01-28 10:56:46', NULL, NULL, 16440, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 10:56:46', 'admin-1517100387-15171082067802950', 1, 0, '', NULL, NULL, NULL),
(62015, '2018-01-28 11:44:41', NULL, NULL, 16447, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:44:41', 'admin-1517100387-15171110809798653', 1, 0, '', NULL, NULL, NULL),
(62016, '2018-01-28 14:38:51', NULL, NULL, 16460, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:38:51', 'admin-1517100387-15171215314004373', 1, 1, 'SR', NULL, NULL, NULL),
(62017, '2018-01-28 14:10:35', NULL, NULL, 16460, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:10:35', 'admin-1517100387-15171198355135465', 1, 0, '', NULL, NULL, NULL),
(62018, '2018-01-28 11:44:41', NULL, NULL, 16447, 0, 232, '166', 'Candied Spicy Bacon Strips', '', 'Meals', 'Snacks ', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:44:41', 'admin-1517100387-15171110809798653', 1, 0, '', NULL, NULL, NULL),
(62019, '2018-01-28 11:44:41', NULL, NULL, 16447, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:44:41', 'admin-1517100387-15171110809798653', 1, 0, '', NULL, NULL, NULL),
(62020, '2018-01-28 14:33:00', NULL, NULL, 16463, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:33:00', 'admin-1517100387-15171211801061945', 1, 0, '', NULL, NULL, NULL),
(62021, '2018-01-28 14:33:00', NULL, NULL, 16463, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:33:00', 'admin-1517100387-15171211801061945', 1, 1, 'SR', NULL, NULL, NULL),
(62022, '2018-01-28 14:33:00', NULL, NULL, 16463, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:33:00', 'admin-1517100387-15171211801061945', 1, 1, 'SR', NULL, NULL, NULL),
(62023, '2018-01-28 14:33:00', NULL, NULL, 16463, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:33:00', 'admin-1517100387-15171211801061945', 1, 1, 'SR', NULL, NULL, NULL),
(62024, '2018-01-28 14:08:51', NULL, NULL, 16458, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:08:51', 'admin-1517100387-15171197316534950', 1, 1, 'SR', NULL, NULL, NULL),
(62025, '2018-01-28 14:42:55', NULL, NULL, 16463, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:42:55', 'admin-1517100387-15171217751226664', 1, 0, '', NULL, '20.0', NULL),
(62026, '2018-01-28 12:07:27', NULL, NULL, 16448, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 12:07:27', 'admin-1517100387-15171124477553689', 1, 1, 'SR', 1, NULL, NULL),
(62027, '2018-01-28 11:02:02', NULL, NULL, 16441, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:02:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62028, '2018-01-28 11:06:46', NULL, NULL, 16442, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:06:46', 'admin-1517100387-15171088063607360', 1, 0, '', NULL, NULL, NULL),
(62029, '2018-01-28 11:06:46', NULL, NULL, 16442, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:06:46', 'admin-1517100387-15171088063607360', 1, 0, '', NULL, NULL, NULL),
(62030, '2018-01-28 14:29:31', NULL, NULL, 16458, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:29:31', 'admin-1517100387-15171209711425545', 1, 0, '', NULL, NULL, NULL),
(62031, '2018-01-28 12:22:14', NULL, NULL, 16450, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 8.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 12:22:14', 'admin-1517100387-1517113333999782', 1, 0, '', NULL, '20.0', NULL),
(62032, '2018-01-28 10:50:42', NULL, NULL, 16439, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 10:50:42', 'admin-1517100387-15171078420811033', 1, 0, '', NULL, NULL, NULL),
(62033, '2018-01-28 14:24:18', NULL, NULL, 16462, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:24:18', 'admin-1517100387-15171206588387079', 1, 1, 'SR', NULL, NULL, NULL),
(62034, '2018-01-28 14:29:31', NULL, NULL, 16458, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:29:31', 'admin-1517100387-15171209711425545', 1, 0, '', NULL, NULL, NULL),
(62035, '2018-01-28 14:29:50', NULL, NULL, 16457, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:29:50', 'admin-1517100387-15171209908536385', 1, 1, 'SR', NULL, NULL, NULL),
(62036, '2018-01-28 14:23:00', NULL, NULL, 16462, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:23:00', 'admin-1517100387-15171205803054334', 1, 1, 'SR', NULL, NULL, NULL),
(62037, '2018-01-28 11:35:11', NULL, NULL, 16445, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.06, 0.0000, 0.0000, 4.06, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:35:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62038, '2018-01-28 14:14:45', NULL, NULL, 16459, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:14:45', 'admin-1517100387-1517120084947714', 1, 0, '', NULL, NULL, NULL),
(62039, '2018-01-28 11:44:04', NULL, NULL, 16447, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 17.20, 0.0000, 0.0000, 17.20, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:44:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62040, '2018-01-28 11:44:41', NULL, NULL, 16447, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:44:41', 'admin-1517100387-15171110809798653', 1, 0, '', NULL, NULL, NULL),
(62041, '2018-01-28 15:49:32', NULL, NULL, 16469, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 15:49:32', 'admin-1517100387-15171257727719523', 1, 1, 'SR', NULL, NULL, NULL),
(62042, '2018-01-28 15:08:12', NULL, NULL, 16458, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 15:08:12', 'admin-1517100387-15171232919503756', 1, 1, 'SR', NULL, NULL, NULL),
(62043, '2018-01-28 15:14:24', NULL, NULL, 16458, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 15:14:24', 'admin-1517100387-15171236647067131', 1, 0, '', NULL, NULL, NULL),
(62044, '2018-01-28 14:52:44', NULL, NULL, 16464, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:52:44', 'admin-1517100387-15171223643826184', 1, 1, 'SR', NULL, NULL, NULL),
(62045, '2018-01-28 14:25:34', NULL, NULL, 16458, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:25:34', 'admin-1517100387-15171207341838379', 1, 0, '', NULL, NULL, NULL),
(62046, '2018-01-28 14:32:46', NULL, NULL, 16463, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.16, 0.0000, 0.0000, 6.16, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:32:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62047, '2018-01-28 14:23:00', NULL, NULL, 16462, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:23:00', 'admin-1517100387-15171205803054334', 1, 1, 'SR', NULL, NULL, NULL),
(62048, '2018-01-28 14:22:54', NULL, NULL, 16462, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:22:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62049, '2018-01-28 12:57:20', NULL, NULL, 16452, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 12:57:20', 'admin-1517100387-1517115440089519', 1, 1, 'SR', NULL, NULL, NULL),
(62050, '2018-01-28 11:04:37', NULL, NULL, 16442, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:04:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62051, '2018-01-28 11:02:30', NULL, NULL, 16441, 0, 330, '266', 'Sunny Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:02:30', 'admin-1517100387-15171085501426535', 1, 0, '', NULL, NULL, NULL),
(62052, '2018-01-28 11:02:30', NULL, NULL, 16441, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:02:30', 'admin-1517100387-15171085501426535', 1, 1, 'SR', NULL, NULL, NULL),
(62053, '2018-01-28 11:02:30', NULL, NULL, 16441, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:02:30', 'admin-1517100387-15171085501426535', 1, 1, 'SR', NULL, NULL, NULL),
(62054, '2018-01-28 11:02:30', NULL, NULL, 16441, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:02:30', 'admin-1517100387-15171085501426535', 1, 1, 'SR', NULL, NULL, NULL),
(62055, '2018-01-28 11:02:30', NULL, NULL, 16441, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:02:30', 'admin-1517100387-15171085501426535', 1, 1, 'SR', NULL, NULL, NULL),
(62056, '2018-01-28 11:06:46', NULL, NULL, 16442, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:06:46', 'admin-1517100387-15171088063607360', 1, 1, 'SR', NULL, NULL, NULL),
(62057, '2018-01-28 14:29:50', NULL, NULL, 16457, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:29:51', 'admin-1517100387-15171209908536385', 1, 1, 'SR', NULL, NULL, NULL),
(62058, '2018-01-28 15:01:00', NULL, NULL, 16467, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1517100387', 'admin', '2018-01-28 15:01:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62059, '2018-01-28 12:22:14', NULL, NULL, 16450, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 12:22:14', 'admin-1517100387-1517113333999782', 1, 1, 'SR', NULL, NULL, NULL),
(62060, '2018-01-28 14:14:45', NULL, NULL, 16459, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:14:45', 'admin-1517100387-1517120084947714', 1, 0, '', NULL, NULL, NULL),
(62061, '2018-01-28 14:10:35', NULL, NULL, 16460, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:10:35', 'admin-1517100387-15171198355135465', 1, 1, 'SR', NULL, NULL, NULL),
(62062, '2018-01-28 14:10:35', NULL, NULL, 16460, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:10:35', 'admin-1517100387-15171198355135465', 1, 0, '', NULL, NULL, NULL),
(62063, '2018-01-28 00:00:00', NULL, NULL, 16468, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', NULL, 1, 0.90, NULL, NULL, 0.90, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:13:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62064, '2018-01-28 14:10:15', NULL, NULL, 16460, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.06, 0.0000, 0.0000, 6.06, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:10:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62065, '2018-01-28 10:07:56', NULL, NULL, 16436, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1517100387', 'admin', '2018-01-28 10:07:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62066, '2018-01-28 10:08:13', NULL, NULL, 16436, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 10:08:13', 'admin-1517100387-1517105292929678', 1, 0, '', NULL, NULL, NULL),
(62067, '2018-01-28 11:45:13', NULL, NULL, 16447, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:45:13', 'admin-1517100387-15171111133352225', 1, 0, '', NULL, NULL, NULL),
(62068, '2018-01-28 11:45:13', NULL, NULL, 16447, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:45:13', 'admin-1517100387-15171111133352225', 1, 0, '', NULL, NULL, NULL),
(62069, '2018-01-28 14:08:51', NULL, NULL, 16458, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:08:51', 'admin-1517100387-15171197316534950', 1, 0, '', NULL, NULL, NULL),
(62070, '2018-01-28 14:08:51', NULL, NULL, 16458, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:08:51', 'admin-1517100387-15171197316534950', 1, 1, 'SR', NULL, NULL, NULL),
(62071, '2018-01-28 14:08:51', NULL, NULL, 16458, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:08:51', 'admin-1517100387-15171197316534950', 1, 1, 'SR', NULL, NULL, NULL),
(62072, '2018-01-28 14:05:24', NULL, NULL, 16459, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.20, 0.0000, 0.0000, 8.20, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:05:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62073, '2018-01-28 14:02:48', NULL, NULL, 16458, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:02:48', 'admin-1517100387-15171193684146678', 1, 0, '', NULL, NULL, NULL),
(62074, '2018-01-28 14:02:40', NULL, NULL, 16458, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 24.55, 0.0000, 0.0000, 24.55, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:02:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62075, '2018-01-28 13:23:35', NULL, NULL, 16455, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:23:35', 'admin-1517100387-15171170155143350', 1, 0, '', NULL, NULL, NULL),
(62076, '2018-01-28 13:22:42', NULL, NULL, 16455, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:22:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62077, '2018-01-28 13:21:50', NULL, NULL, 16454, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:21:50', 'admin-1517100387-15171169098857951', 1, 0, '', NULL, NULL, NULL),
(62078, '2018-01-28 14:38:51', NULL, NULL, 16460, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:38:51', 'admin-1517100387-15171215314004373', 1, 0, '', NULL, '20.0', NULL),
(62079, '2018-01-28 13:21:50', NULL, NULL, 16454, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 13:21:50', 'admin-1517100387-15171169098857951', 1, 0, '', NULL, NULL, NULL),
(62080, '2018-01-28 12:57:20', NULL, NULL, 16452, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 12:57:20', 'admin-1517100387-1517115440089519', 1, 0, '', NULL, NULL, NULL),
(62081, '2018-01-28 12:57:20', NULL, NULL, 16452, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 12:57:20', 'admin-1517100387-1517115440089519', 1, 1, 'SR', NULL, NULL, NULL),
(62082, '2018-01-28 12:48:05', NULL, NULL, 16451, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 12:48:05', 'admin-1517100387-15171148857126678', 1, 1, 'SR', NULL, NULL, NULL),
(62083, '2018-01-28 12:55:48', NULL, NULL, 16452, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1517100387', 'admin', '2018-01-28 12:55:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62084, '2018-01-28 12:43:07', NULL, NULL, 16451, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 12:43:07', 'admin-1517100387-15171145871639587', 1, 1, 'SR', NULL, NULL, NULL),
(62085, '2018-01-28 12:43:07', NULL, NULL, 16451, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 12:43:07', 'admin-1517100387-15171145871639587', 1, 1, 'SR', NULL, NULL, NULL),
(62086, '2018-01-28 14:02:48', NULL, NULL, 16458, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 2, 18.00, 36.0000, 0.0000, 36.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:02:48', 'admin-1517100387-15171193684146678', 1, 0, '', NULL, NULL, NULL),
(62087, '2018-01-28 11:20:14', NULL, NULL, 16444, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:20:14', 'admin-1517100387-15171096147674774', 1, 0, '', NULL, '20.0', NULL),
(62088, '2018-01-28 14:29:57', NULL, NULL, 16457, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 8.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:29:57', 'admin-1517100387-15171209975563473', 1, 0, '', NULL, '20.0', NULL),
(62089, '2018-01-28 12:48:05', NULL, NULL, 16451, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 12:48:05', 'admin-1517100387-15171148857126678', 1, 1, 'SR', NULL, NULL, NULL),
(62090, '2018-01-28 11:06:46', NULL, NULL, 16442, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:06:46', 'admin-1517100387-15171088063607360', 1, 1, 'SR', NULL, NULL, NULL),
(62091, '2018-01-28 11:06:46', NULL, NULL, 16442, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:06:46', 'admin-1517100387-15171088063607360', 1, 0, '', NULL, NULL, NULL),
(62092, '2018-01-28 11:08:51', NULL, NULL, 16440, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:08:51', 'admin-1517100387-15171089311713473', 1, 0, '', NULL, NULL, NULL),
(62093, '2018-01-28 11:11:28', NULL, NULL, 16443, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:11:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62094, '2018-01-28 11:11:34', NULL, NULL, 16443, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:11:34', 'admin-1517100387-15171090947545795', 1, 1, 'SR', NULL, NULL, NULL),
(62095, '2018-01-28 12:43:07', NULL, NULL, 16451, 0, 154, '88', 'Daily Dose BLT', ',scramble eggs', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 12:43:07', 'admin-1517100387-15171145871639587', 1, 0, '', NULL, NULL, NULL),
(62096, '2018-01-28 11:45:13', NULL, NULL, 16447, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:45:13', 'admin-1517100387-15171111133352225', 1, 0, '', NULL, NULL, NULL),
(62097, '2018-01-28 12:20:48', NULL, NULL, 16449, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.60, 0.0000, 0.0000, 0.60, 1, '27', 1, '1517100387', 'admin', '2018-01-28 12:20:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62098, '2018-01-28 12:20:51', NULL, NULL, 16449, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 12:20:51', 'admin-1517100387-15171132516277392', 1, 1, 'SR', NULL, NULL, NULL),
(62099, '2018-01-28 12:21:56', NULL, NULL, 16450, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1517100387', 'admin', '2018-01-28 12:21:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62100, '2018-01-28 10:08:13', NULL, NULL, 16436, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 10:08:13', 'admin-1517100387-1517105292929678', 1, 0, '', NULL, NULL, NULL),
(62101, '2018-01-28 10:08:13', NULL, NULL, 16436, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 10:08:13', 'admin-1517100387-1517105292929678', 1, 1, 'SR', NULL, NULL, NULL),
(62102, '2018-01-28 12:42:35', NULL, NULL, 16451, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1517100387', 'admin', '2018-01-28 12:42:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62103, '2018-01-28 14:05:36', NULL, NULL, 16459, 0, 188, '123', 'Sarawak Laksa', '', 'Meals', 'Non-Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:05:36', 'admin-1517100387-15171195363866234', 1, 0, '', NULL, NULL, NULL),
(62104, '2018-01-28 14:07:47', NULL, NULL, 16459, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:07:47', 'admin-1517100387-15171196669199836', 1, 1, 'SR', NULL, NULL, NULL),
(62105, '2018-01-28 11:45:13', NULL, NULL, 16447, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:45:13', 'admin-1517100387-15171111133352225', 1, 0, '', NULL, NULL, NULL),
(62106, '2018-01-28 11:30:46', NULL, NULL, 16444, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:30:46', 'admin-1517100387-15171102461084529', 1, 1, 'SR', NULL, NULL, NULL),
(62107, '2018-01-28 11:56:41', NULL, NULL, 16444, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:56:41', 'admin-1517100387-15171118016129676', 1, 0, '', NULL, NULL, NULL),
(62108, '2018-01-28 11:45:13', NULL, NULL, 16447, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:45:13', 'admin-1517100387-15171111133352225', 1, 0, '', NULL, NULL, NULL),
(62109, '2018-01-28 09:39:42', NULL, NULL, 16433, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 09:39:42', 'admin-1517100387-15171035824595360', 1, 0, '', NULL, NULL, NULL),
(62110, '2018-01-28 09:39:42', NULL, NULL, 16433, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 09:39:42', 'admin-1517100387-15171035824595360', 1, 0, '', NULL, NULL, NULL),
(62111, '2018-01-28 09:39:42', NULL, NULL, 16433, 0, 270, '204', 'Homemade Savoury Pancake', '', 'Meals', 'Morning Bites ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 09:39:42', 'admin-1517100387-15171035824595360', 1, 0, '', NULL, NULL, NULL),
(62112, '2018-01-28 11:56:41', NULL, NULL, 16444, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:56:41', 'admin-1517100387-15171118016129676', 1, 0, '', NULL, NULL, NULL),
(62113, '2018-01-28 11:35:34', NULL, NULL, 16445, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:35:34', 'admin-1517100387-1517110534604288', 1, 0, '', NULL, NULL, NULL),
(62114, '2018-01-28 10:55:38', NULL, NULL, 16440, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.66, 0.0000, 0.0000, 10.66, 1, '27', 1, '1517100387', 'admin', '2018-01-28 10:55:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62115, '2018-01-28 10:50:42', NULL, NULL, 16439, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 10:50:42', 'admin-1517100387-15171078420811033', 1, 0, '', NULL, NULL, NULL),
(62116, '2018-01-28 11:56:41', NULL, NULL, 16444, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:56:41', 'admin-1517100387-15171118016129676', 1, 0, '', NULL, NULL, NULL),
(62117, '2018-01-28 11:45:13', NULL, NULL, 16447, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:45:13', 'admin-1517100387-15171111133352225', 1, 0, '', NULL, NULL, NULL),
(62118, '2018-01-28 11:44:41', NULL, NULL, 16447, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:44:41', 'admin-1517100387-15171110809798653', 1, 1, 'SR', NULL, NULL, NULL),
(62119, '2018-01-28 11:44:41', NULL, NULL, 16447, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:44:41', 'admin-1517100387-15171110809798653', 1, 0, '', NULL, NULL, NULL),
(62120, '2018-01-28 10:08:43', NULL, NULL, 16437, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1517100387', 'admin', '2018-01-28 10:08:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62121, '2018-01-28 10:41:04', NULL, NULL, 16438, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1517100387', 'admin', '2018-01-28 10:41:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62122, '2018-01-28 10:41:09', NULL, NULL, 16438, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 10:41:09', 'admin-1517100387-15171072694769485', 1, 1, 'SR', NULL, NULL, NULL),
(62123, '2018-01-28 10:50:30', NULL, NULL, 16439, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1517100387', 'admin', '2018-01-28 10:50:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62124, '2018-01-28 11:40:43', NULL, NULL, 16446, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:40:43', 'admin-1517100387-15171108436913924', 1, 1, 'SR', NULL, NULL, NULL),
(62125, '2018-01-28 11:40:43', NULL, NULL, 16446, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:40:43', 'admin-1517100387-15171108436913924', 1, 0, '', NULL, NULL, NULL),
(62126, '2018-01-28 11:20:14', NULL, NULL, 16444, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:20:14', 'admin-1517100387-15171096147674774', 1, 1, 'SR', NULL, NULL, NULL),
(62127, '2018-01-28 11:35:34', NULL, NULL, 16445, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:35:34', 'admin-1517100387-1517110534604288', 1, 0, '', NULL, NULL, NULL),
(62128, '2018-01-28 11:40:43', NULL, NULL, 16446, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:40:43', 'admin-1517100387-15171108436913924', 1, 1, 'SR', NULL, NULL, NULL),
(62129, '2018-01-28 11:40:27', NULL, NULL, 16446, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:40:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62130, '2018-01-28 11:35:34', NULL, NULL, 16445, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:35:34', 'admin-1517100387-1517110534604288', 1, 1, 'SR', NULL, NULL, NULL),
(62131, '2018-01-28 12:22:14', NULL, NULL, 16450, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 12:22:14', 'admin-1517100387-1517113333999782', 1, 0, '', NULL, NULL, NULL),
(62132, '2018-01-28 11:40:43', NULL, NULL, 16446, 0, 18, '18', 'Iced Dirty Chai', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:40:43', 'admin-1517100387-15171108436913924', 1, 1, 'SR', NULL, NULL, NULL),
(62133, '2018-01-28 10:06:36', NULL, NULL, 16435, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 10:06:36', 'admin-1517100387-15171051963324657', 1, 1, 'SR', NULL, NULL, NULL),
(62134, '2018-01-28 11:35:34', NULL, NULL, 16445, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:35:34', 'admin-1517100387-1517110534604288', 1, 0, '', NULL, '20.0', NULL),
(62135, '2018-01-28 11:30:46', NULL, NULL, 16444, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:30:46', 'admin-1517100387-15171102461084529', 1, 0, '', NULL, NULL, NULL),
(62136, '2018-01-28 11:20:14', NULL, NULL, 16444, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 11:20:14', 'admin-1517100387-15171096147674774', 1, 1, 'SR', NULL, NULL, NULL),
(62137, '2018-01-28 14:35:34', NULL, NULL, 16459, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 14:35:34', 'admin-1517100387-1517121334423340', 1, 0, '', NULL, NULL, NULL),
(62138, '2018-01-28 10:56:46', NULL, NULL, 16440, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 10:56:46', 'admin-1517100387-15171082067802950', 1, 0, '', NULL, NULL, NULL),
(62139, '2018-01-28 10:56:46', NULL, NULL, 16440, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 10:56:46', 'admin-1517100387-15171082067802950', 1, 0, '', NULL, NULL, NULL),
(62140, '2018-01-28 10:56:46', NULL, NULL, 16440, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 10:56:46', 'admin-1517100387-15171082067802950', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(62141, '2018-01-28 10:56:46', NULL, NULL, 16440, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1517100387', 'admin', '2018-01-28 10:56:46', 'admin-1517100387-15171082067802950', 1, 0, '', NULL, '20.0', NULL),
(62142, '2018-01-28 10:56:46', NULL, NULL, 16440, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 10:56:46', 'admin-1517100387-15171082067802950', 1, 0, '', NULL, NULL, NULL),
(62143, '2018-01-28 10:56:46', NULL, NULL, 16440, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 10:56:46', 'admin-1517100387-15171082067802950', 1, 1, 'SR', NULL, NULL, NULL),
(62144, '2018-01-28 10:08:49', NULL, NULL, 16437, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 10:08:49', 'admin-1517100387-15171053294006574', 1, 1, 'SR', NULL, NULL, NULL),
(62145, '2018-01-28 10:08:49', NULL, NULL, 16437, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 10:08:49', 'admin-1517100387-15171053294006574', 1, 1, 'SR', NULL, NULL, NULL),
(62146, '2018-01-28 09:48:32', NULL, NULL, 16434, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 09:48:32', 'admin-1517100387-15171041124444678', 1, 0, '', NULL, NULL, NULL),
(62147, '2018-01-28 09:48:32', NULL, NULL, 16434, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 09:48:32', 'admin-1517100387-15171041124444678', 1, 0, '', NULL, NULL, NULL),
(62148, '2018-01-28 09:48:32', NULL, NULL, 16434, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 09:48:32', 'admin-1517100387-15171041124444678', 1, 0, '', NULL, NULL, NULL),
(62149, '2018-01-28 09:48:32', NULL, NULL, 16434, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 09:48:32', 'admin-1517100387-15171041124444678', 1, 1, 'SR', NULL, NULL, NULL),
(62150, '2018-01-28 09:48:32', NULL, NULL, 16434, 0, 301, '237', 'Black Jack', '', 'Cold Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 09:48:32', 'admin-1517100387-15171041124444678', 1, 0, '', NULL, NULL, NULL),
(62151, '2018-01-28 10:06:30', NULL, NULL, 16435, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1517100387', 'admin', '2018-01-28 10:06:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62152, '2018-01-28 09:48:13', NULL, NULL, 16434, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1517100387', 'admin', '2018-01-28 09:48:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62153, '2018-01-28 09:43:37', NULL, NULL, 16433, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 09:43:37', 'admin-1517100387-15171038174699428', 1, 1, 'SR', NULL, NULL, NULL),
(62154, '2018-01-28 09:39:42', NULL, NULL, 16433, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 09:39:42', 'admin-1517100387-15171035824595360', 1, 0, '', NULL, NULL, NULL),
(62155, '2018-01-28 09:43:37', NULL, NULL, 16433, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 09:43:37', 'admin-1517100387-15171038174699428', 1, 1, 'SR', NULL, NULL, NULL),
(62156, '2018-01-28 09:43:37', NULL, NULL, 16433, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 09:43:37', 'admin-1517100387-15171038174699428', 1, 1, 'SR', NULL, NULL, NULL),
(62157, '2018-01-28 09:43:37', NULL, NULL, 16433, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517100387', 'admin', '2018-01-28 09:43:37', 'admin-1517100387-15171038174699428', 1, 1, 'SR', NULL, NULL, NULL),
(62158, '2018-01-28 09:39:08', NULL, NULL, 16433, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 11.90, 0.0000, 0.0000, 11.90, 1, '27', 1, '1517100387', 'admin', '2018-01-28 09:39:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62159, '2018-01-29 16:19:37', NULL, NULL, 16493, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 16:19:37', 'admin-1517186995-15172139770419215', 1, 1, 'SR', NULL, NULL, NULL),
(62160, '2018-01-29 17:07:00', NULL, NULL, 16496, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1517186995', 'admin', '2018-01-29 17:07:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62161, '2018-01-29 16:26:13', NULL, NULL, 16494, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1517186995', 'admin', '2018-01-29 16:26:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62162, '2018-01-29 16:26:17', NULL, NULL, 16494, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 16:26:17', 'admin-1517186995-15172143774092448', 1, 1, 'SR', NULL, NULL, NULL),
(62163, '2018-01-29 16:31:36', NULL, NULL, 16495, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1517186995', 'admin', '2018-01-29 16:31:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62164, '2018-01-29 16:32:01', NULL, NULL, 16495, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 16:32:01', 'admin-1517186995-15172147214525849', 1, 1, 'SR', NULL, NULL, NULL),
(62165, '2018-01-29 16:32:01', NULL, NULL, 16495, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 16:32:01', 'admin-1517186995-15172147214525849', 1, 0, '', NULL, NULL, NULL),
(62166, '2018-01-29 13:35:29', NULL, NULL, 16490, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 13:35:29', 'admin-1517186995-15172041293458915', 1, 1, 'SR', NULL, NULL, NULL),
(62167, '2018-01-29 13:44:49', NULL, NULL, 16491, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1517186995', 'admin', '2018-01-29 13:44:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62168, '2018-01-29 13:44:57', NULL, NULL, 16491, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 13:44:57', 'admin-1517186995-15172046970286388', 1, 1, 'SR', NULL, NULL, NULL),
(62169, '2018-01-29 09:57:29', NULL, NULL, 16477, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:57:29', 'admin-1517186995-15171910491442120', 1, 1, 'SR', NULL, NULL, NULL),
(62170, '2018-01-29 09:57:49', NULL, NULL, 16478, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:57:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62171, '2018-01-29 09:57:53', NULL, NULL, 16478, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:57:53', 'admin-1517186995-15171910735896873', 1, 1, 'SR', NULL, NULL, NULL),
(62172, '2018-01-29 12:12:54', NULL, NULL, 16484, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:12:54', 'admin-1517186995-15171991741669283', 1, 0, '', NULL, NULL, NULL),
(62173, '2018-01-29 12:12:54', NULL, NULL, 16484, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:12:54', 'admin-1517186995-15171991741669283', 1, 0, '', NULL, NULL, NULL),
(62174, '2018-01-29 10:52:18', NULL, NULL, 16482, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1517186995', 'admin', '2018-01-29 10:52:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62175, '2018-01-29 10:52:23', NULL, NULL, 16482, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 10:52:23', 'admin-1517186995-1517194343506267', 1, 1, 'SR', NULL, NULL, NULL),
(62176, '2018-01-29 12:34:21', NULL, NULL, 16486, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:34:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62177, '2018-01-29 12:34:25', NULL, NULL, 16486, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:34:25', 'admin-1517186995-15172004649349859', 1, 0, '', NULL, NULL, NULL),
(62178, '2018-01-29 14:48:01', NULL, NULL, 16492, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 14:48:01', 'admin-1517186995-1517208481309288', 1, 1, 'SR', NULL, NULL, NULL),
(62179, '2018-01-29 14:48:01', NULL, NULL, 16492, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1517186995', 'admin', '2018-01-29 14:48:01', 'admin-1517186995-1517208481309288', 1, 0, '', NULL, '20.0', NULL),
(62180, '2018-01-29 12:42:20', NULL, NULL, 16487, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:42:20', 'admin-1517186995-15172009398821152', 1, 1, 'SR', NULL, NULL, NULL),
(62181, '2018-01-29 10:36:48', NULL, NULL, 16480, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1517186995', 'admin', '2018-01-29 10:36:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62182, '2018-01-29 10:38:49', NULL, NULL, 16480, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 10:38:49', 'admin-1517186995-15171935296462329', 1, 1, 'SR', NULL, NULL, NULL),
(62183, '2018-01-29 10:45:46', NULL, NULL, 16481, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1517186995', 'admin', '2018-01-29 10:45:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62184, '2018-01-29 10:45:50', NULL, NULL, 16481, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 10:45:50', 'admin-1517186995-15171939504991934', 1, 1, 'SR', NULL, NULL, NULL),
(62185, '2018-01-29 14:30:36', NULL, NULL, 16489, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 14:30:37', 'admin-1517186995-1517207436895705', 1, 1, 'SR', NULL, NULL, NULL),
(62186, '2018-01-29 14:36:26', NULL, NULL, 16492, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 14:36:26', 'admin-1517186995-15172077859273366', 1, 0, '', NULL, NULL, NULL),
(62187, '2018-01-29 16:32:01', NULL, NULL, 16495, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 16:32:01', 'admin-1517186995-15172147214525849', 1, 1, 'SR', NULL, NULL, NULL),
(62188, '2018-01-29 09:57:29', NULL, NULL, 16477, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:57:29', 'admin-1517186995-15171910491442120', 1, 1, 'SR', NULL, NULL, NULL),
(62189, '2018-01-29 12:42:20', NULL, NULL, 16487, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:42:20', 'admin-1517186995-15172009398821152', 1, 1, 'SR', NULL, NULL, NULL),
(62190, '2018-01-29 12:43:49', NULL, NULL, 16487, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:43:49', 'admin-1517186995-15172010297714325', 1, 0, '', NULL, NULL, NULL),
(62191, '2018-01-29 13:10:26', NULL, NULL, 16488, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 13:10:26', 'admin-1517186995-15172026258886732', 1, 1, 'SR', NULL, NULL, NULL),
(62192, '2018-01-29 00:00:00', NULL, NULL, 16496, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 16:19:37', 'admin-1517186995-15172139770419215', 1, 1, 'SR', NULL, NULL, NULL),
(62193, '2018-01-29 14:19:47', NULL, NULL, 16490, 0, 182, '117', 'Open Drinks ', 'fruits platter', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 14:19:47', 'admin-1517186995-15172067876743478', 1, 0, '', NULL, NULL, NULL),
(62194, '2018-01-29 13:10:26', NULL, NULL, 16488, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 13:10:26', 'admin-1517186995-15172026258886732', 1, 1, 'SR', NULL, NULL, NULL),
(62195, '2018-01-29 13:11:15', NULL, NULL, 16489, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1517186995', 'admin', '2018-01-29 13:11:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62196, '2018-01-29 13:11:44', NULL, NULL, 16489, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 13:11:44', 'admin-1517186995-15172027039914090', 1, 0, '', NULL, NULL, NULL),
(62197, '2018-01-29 16:19:29', NULL, NULL, 16493, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1517186995', 'admin', '2018-01-29 16:19:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62198, '2018-01-29 13:35:29', NULL, NULL, 16490, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 13:35:29', 'admin-1517186995-15172041293458915', 1, 0, '', NULL, NULL, NULL),
(62199, '2018-01-29 14:01:59', NULL, NULL, 16492, 0, 323, '259', 'Ginger Cucumber Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 14:01:59', 'admin-1517186995-15172057197709398', 1, 0, '', NULL, NULL, NULL),
(62200, '2018-01-29 14:01:59', NULL, NULL, 16492, 0, 323, '259', 'Ginger Cucumber Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 14:01:59', 'admin-1517186995-15172057197709398', 1, 0, '', NULL, NULL, NULL),
(62201, '2018-01-29 14:01:59', NULL, NULL, 16492, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 14:01:59', 'admin-1517186995-15172057197709398', 1, 0, '', NULL, NULL, NULL),
(62202, '2018-01-29 14:01:59', NULL, NULL, 16492, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 14:01:59', 'admin-1517186995-15172057197709398', 1, 1, 'SR', NULL, NULL, NULL),
(62203, '2018-01-29 14:01:08', NULL, NULL, 16492, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.06, 0.0000, 0.0000, 9.06, 1, '27', 1, '1517186995', 'admin', '2018-01-29 14:01:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62204, '2018-01-29 13:35:29', NULL, NULL, 16490, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 13:35:29', 'admin-1517186995-15172041293458915', 1, 1, 'SR', NULL, NULL, NULL),
(62205, '2018-01-29 12:42:20', NULL, NULL, 16487, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:42:20', 'admin-1517186995-15172009398821152', 1, 0, '', NULL, NULL, NULL),
(62206, '2018-01-29 13:35:29', NULL, NULL, 16490, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 13:35:29', 'admin-1517186995-15172041293458915', 1, 0, '', NULL, NULL, NULL),
(62207, '2018-01-29 13:34:59', NULL, NULL, 16490, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1517186995', 'admin', '2018-01-29 13:34:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62208, '2018-01-29 13:11:44', NULL, NULL, 16489, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 13:11:44', 'admin-1517186995-15172027039914090', 1, 1, 'SR', NULL, NULL, NULL),
(62209, '2018-01-29 13:17:36', NULL, NULL, 16489, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 13:17:36', 'admin-1517186995-15172030564251324', 1, 0, '', NULL, NULL, NULL),
(62210, '2018-01-29 13:11:44', NULL, NULL, 16489, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 13:11:44', 'admin-1517186995-15172027039914090', 1, 0, '', NULL, NULL, NULL),
(62211, '2018-01-29 12:41:51', NULL, NULL, 16487, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:41:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62212, '2018-01-29 10:52:23', NULL, NULL, 16482, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 10:52:23', 'admin-1517186995-1517194343506267', 1, 1, 'SR', NULL, NULL, NULL),
(62213, '2018-01-29 13:10:26', NULL, NULL, 16488, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1517186995', 'admin', '2018-01-29 13:10:26', 'admin-1517186995-15172026258886732', 1, 0, '', NULL, '20.0', NULL),
(62214, '2018-01-29 12:07:09', NULL, NULL, 16484, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:07:09', 'admin-1517186995-15171988298095813', 1, 0, '', NULL, NULL, NULL),
(62215, '2018-01-29 12:07:10', NULL, NULL, 16484, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:07:10', 'admin-1517186995-15171988298095813', 1, 0, '', NULL, NULL, NULL),
(62216, '2018-01-29 12:12:54', NULL, NULL, 16484, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:12:54', 'admin-1517186995-15171991741669283', 1, 0, '', NULL, NULL, NULL),
(62217, '2018-01-29 12:12:59', NULL, NULL, 16485, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:12:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62218, '2018-01-29 12:13:29', NULL, NULL, 16485, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:13:29', 'admin-1517186995-15171992094672139', 1, 0, '', NULL, NULL, NULL),
(62219, '2018-01-29 12:13:29', NULL, NULL, 16485, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:13:29', 'admin-1517186995-15171992094672139', 1, 0, '', NULL, NULL, NULL),
(62220, '2018-01-29 12:42:20', NULL, NULL, 16487, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:42:20', 'admin-1517186995-15172009398821152', 1, 0, '', NULL, NULL, NULL),
(62221, '2018-01-29 11:25:18', NULL, NULL, 16483, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1517186995', 'admin', '2018-01-29 11:25:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62222, '2018-01-29 12:42:20', NULL, NULL, 16487, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:42:20', 'admin-1517186995-15172009398821152', 1, 1, 'SR', NULL, NULL, NULL),
(62223, '2018-01-29 12:13:29', NULL, NULL, 16485, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:13:29', 'admin-1517186995-15171992094672139', 1, 0, '', NULL, NULL, NULL),
(62224, '2018-01-29 12:12:54', NULL, NULL, 16484, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:12:54', 'admin-1517186995-15171991741669283', 1, 0, '', NULL, NULL, NULL),
(62225, '2018-01-29 12:12:54', NULL, NULL, 16484, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:12:54', 'admin-1517186995-15171991741669283', 1, 0, '', NULL, NULL, NULL),
(62226, '2018-01-29 12:12:54', NULL, NULL, 16484, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:12:54', 'admin-1517186995-15171991741669283', 1, 0, '', NULL, NULL, NULL),
(62227, '2018-01-29 09:46:51', NULL, NULL, 16476, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:46:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62228, '2018-01-29 09:47:03', NULL, NULL, 16476, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:47:03', 'admin-1517186995-15171904232131321', 1, 0, '', NULL, NULL, NULL),
(62229, '2018-01-29 09:47:03', NULL, NULL, 16476, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:47:03', 'admin-1517186995-15171904232131321', 1, 0, '', NULL, NULL, NULL),
(62230, '2018-01-29 12:07:10', NULL, NULL, 16484, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:07:10', 'admin-1517186995-15171988298095813', 1, 1, 'SR', NULL, NULL, NULL),
(62231, '2018-01-29 12:02:45', NULL, NULL, 16484, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 18.10, 0.0000, 0.0000, 18.10, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:02:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62232, '2018-01-29 10:10:26', NULL, NULL, 16479, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 10:10:26', 'admin-1517186995-15171918265249476', 1, 1, 'SR', NULL, NULL, NULL),
(62233, '2018-01-29 12:07:09', NULL, NULL, 16484, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:07:09', 'admin-1517186995-15171988298095813', 1, 0, '', NULL, NULL, NULL),
(62234, '2018-01-29 13:09:59', NULL, NULL, 16488, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.06, 0.0000, 0.0000, 5.06, 1, '27', 1, '1517186995', 'admin', '2018-01-29 13:09:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62235, '2018-01-29 09:57:29', NULL, NULL, 16477, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:57:29', 'admin-1517186995-15171910491442120', 1, 1, 'SR', NULL, NULL, NULL),
(62236, '2018-01-29 11:25:23', NULL, NULL, 16483, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 11:25:23', 'admin-1517186995-15171963235365093', 1, 1, 'SR', NULL, NULL, NULL),
(62237, '2018-01-29 10:37:11', NULL, NULL, 16480, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 10:37:11', 'admin-1517186995-15171934311852278', 1, 0, '', NULL, NULL, NULL),
(62238, '2018-01-29 10:37:11', NULL, NULL, 16480, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 10:37:11', 'admin-1517186995-15171934311852278', 1, 0, '', NULL, NULL, NULL),
(62239, '2018-01-29 13:10:25', NULL, NULL, 16488, 0, 309, '245', 'AA Set - Borneo Pepper Pork', '', 'Meals', 'Rice', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 13:10:26', 'admin-1517186995-15172026258886732', 1, 0, '', NULL, NULL, NULL),
(62240, '2018-01-29 10:10:14', NULL, NULL, 16479, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1517186995', 'admin', '2018-01-29 10:10:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62241, '2018-01-29 12:13:29', NULL, NULL, 16485, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 12:13:29', 'admin-1517186995-15171992094672139', 1, 0, '', NULL, NULL, NULL),
(62242, '2018-01-29 09:47:03', NULL, NULL, 16476, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:47:03', 'admin-1517186995-15171904232131321', 1, 1, 'SR', NULL, NULL, NULL),
(62243, '2018-01-29 09:47:03', NULL, NULL, 16476, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:47:03', 'admin-1517186995-15171904232131321', 1, 1, 'SR', NULL, NULL, NULL),
(62244, '2018-01-29 09:57:07', NULL, NULL, 16477, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:57:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62245, '2018-01-29 09:57:29', NULL, NULL, 16477, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:57:29', 'admin-1517186995-15171910491442120', 1, 0, '', NULL, NULL, NULL),
(62246, '2018-01-29 09:57:29', NULL, NULL, 16477, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:57:29', 'admin-1517186995-15171910491442120', 1, 0, '', NULL, NULL, NULL),
(62247, '2018-01-29 09:57:29', NULL, NULL, 16477, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:57:29', 'admin-1517186995-15171910491442120', 1, 1, 'SR', NULL, NULL, NULL),
(62248, '2018-01-29 09:21:17', NULL, NULL, 16473, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:21:17', 'admin-1517186995-1517188877858968', 1, 0, '', NULL, NULL, NULL),
(62249, '2018-01-29 09:21:17', NULL, NULL, 16473, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:21:17', 'admin-1517186995-1517188877858968', 1, 0, '', NULL, NULL, NULL),
(62250, '2018-01-29 09:21:18', NULL, NULL, 16473, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:21:18', 'admin-1517186995-1517188877858968', 1, 0, '', NULL, NULL, NULL),
(62251, '2018-01-29 09:21:18', NULL, NULL, 16473, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:21:18', 'admin-1517186995-1517188877858968', 1, 1, 'SR', NULL, NULL, NULL),
(62252, '2018-01-29 09:22:13', NULL, NULL, 16474, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:22:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62253, '2018-01-29 09:22:20', NULL, NULL, 16474, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:22:20', 'admin-1517186995-151718894022212', 1, 0, '', NULL, NULL, NULL),
(62254, '2018-01-29 09:24:01', NULL, NULL, 16475, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:24:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62255, '2018-01-29 09:24:03', NULL, NULL, 16475, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:24:03', 'admin-1517186995-15171890438128557', 1, 1, 'SR', NULL, NULL, NULL),
(62256, '2018-01-29 10:37:11', NULL, NULL, 16480, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 10:37:11', 'admin-1517186995-15171934311852278', 1, 1, 'SR', NULL, NULL, NULL),
(62257, '2018-01-29 09:24:03', NULL, NULL, 16475, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:24:03', 'admin-1517186995-15171890438128557', 1, 1, 'SR', NULL, NULL, NULL),
(62258, '2018-01-29 09:13:12', NULL, NULL, 16472, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:13:12', 'admin-1517186995-15171883927206540', 1, 1, 'SR', NULL, NULL, NULL),
(62259, '2018-01-29 09:21:06', NULL, NULL, 16473, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:21:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62260, '2018-01-29 09:13:12', NULL, NULL, 16472, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:13:12', 'admin-1517186995-15171883927206540', 1, 1, 'SR', NULL, NULL, NULL),
(62261, '2018-01-29 09:13:12', NULL, NULL, 16472, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:13:12', 'admin-1517186995-15171883927206540', 1, 0, '', NULL, NULL, NULL),
(62262, '2018-01-29 09:13:12', NULL, NULL, 16472, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:13:12', 'admin-1517186995-15171883927206540', 1, 0, '', NULL, NULL, NULL),
(62263, '2018-01-29 09:12:08', NULL, NULL, 16472, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1517186995', 'admin', '2018-01-29 09:12:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62264, '2018-01-31 15:46:24', NULL, NULL, 16527, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 15:46:24', 'admin-1517358393-15173847838959332', 1, 0, '', NULL, NULL, NULL),
(62265, '2018-01-31 13:44:58', NULL, NULL, 16518, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:44:58', 'admin-1517358393-15173774979519458', 1, 1, 'SR', NULL, NULL, NULL),
(62266, '2018-01-31 14:20:32', NULL, NULL, 16520, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:20:32', 'admin-1517358393-15173796328012426', 1, 1, 'SR', NULL, NULL, NULL),
(62267, '2018-01-31 00:00:00', NULL, NULL, 16517, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 12:41:26', 'admin-1517358393-1517373686222221', 1, 1, 'SR', NULL, NULL, NULL),
(62268, '2018-01-31 13:22:27', NULL, NULL, 16515, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:22:27', 'admin-1517358393-15173761477574235', 1, 0, '', NULL, NULL, NULL),
(62269, '2018-01-31 13:23:51', NULL, NULL, 16518, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:23:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62270, '2018-01-31 13:23:56', NULL, NULL, 16518, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:23:56', 'admin-1517358393-15173762359307230', 1, 1, 'SR', NULL, NULL, NULL),
(62271, '2018-01-31 13:23:56', NULL, NULL, 16518, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:23:56', 'admin-1517358393-15173762359307230', 1, 1, 'SR', NULL, NULL, NULL),
(62272, '2018-01-31 13:49:07', NULL, NULL, 16516, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:49:07', 'admin-1517358393-15173777469148489', 1, 1, 'SR', NULL, NULL, NULL),
(62273, '2018-01-31 13:53:43', NULL, NULL, 16516, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:53:43', 'admin-1517358393-15173780231551847', 1, 1, 'SR', NULL, NULL, NULL),
(62274, '2018-01-31 16:28:52', NULL, NULL, 16530, 0, 181, '116', 'Open Food ', 'Dumpling', 'Meals', 'Perfect Meals', 1, 30.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 16:28:52', 'admin-1517358393-15173873324618589', 1, 0, '', 1, NULL, NULL),
(62275, '2018-01-31 15:49:16', NULL, NULL, 16528, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1517358393', 'admin', '2018-01-31 15:49:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62276, '2018-01-31 14:02:12', NULL, NULL, 16522, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:02:12', 'admin-1517358393-15173785323329375', 1, 0, '', NULL, NULL, NULL),
(62277, '2018-01-31 14:02:12', NULL, NULL, 16522, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:02:12', 'admin-1517358393-15173785323329375', 1, 0, '', NULL, NULL, NULL),
(62278, '2018-01-31 14:57:54', NULL, NULL, 16525, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:57:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62279, '2018-01-31 14:58:13', NULL, NULL, 16525, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:58:13', 'admin-1517358393-15173818931244419', 1, 0, '', NULL, NULL, NULL),
(62280, '2018-01-31 14:58:13', NULL, NULL, 16525, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:58:13', 'admin-1517358393-15173818931244419', 1, 0, '', NULL, NULL, NULL),
(62281, '2018-01-31 12:41:26', NULL, NULL, 16513, 0, 291, '225', 'Smoked Duck Red Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 12:41:26', 'admin-1517358393-1517373686222221', 1, 0, '', NULL, NULL, NULL),
(62282, '2018-01-31 13:12:15', NULL, NULL, 16517, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:12:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62283, '2018-01-31 12:41:26', NULL, NULL, 16513, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 12:41:26', 'admin-1517358393-1517373686222221', 1, 1, 'SR', NULL, NULL, NULL),
(62284, '2018-01-31 00:00:00', NULL, NULL, 16517, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 12:41:26', 'admin-1517358393-1517373686222221', 1, 0, '', NULL, NULL, NULL),
(62285, '2018-01-31 13:46:16', NULL, NULL, 16516, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:46:16', 'admin-1517358393-15173775760945620', 1, 0, '', NULL, NULL, NULL),
(62286, '2018-01-31 09:29:47', NULL, NULL, 16501, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:29:47', 'admin-1517358393-15173621877067716', 1, 1, 'SR', NULL, NULL, NULL),
(62287, '2018-01-31 09:29:47', NULL, NULL, 16501, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:29:47', 'admin-1517358393-15173621877067716', 1, 1, 'SR', NULL, NULL, NULL),
(62288, '2018-01-31 09:34:48', NULL, NULL, 16502, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:34:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62289, '2018-01-31 10:24:23', NULL, NULL, 16505, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1517358393', 'admin', '2018-01-31 10:24:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62290, '2018-01-31 10:24:45', NULL, NULL, 16505, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 10:24:45', 'admin-1517358393-15173654851393854', 1, 0, '', NULL, NULL, NULL),
(62291, '2018-01-31 15:50:36', NULL, NULL, 16528, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 15:50:36', 'admin-1517358393-15173850368406611', 1, 1, 'SR', NULL, NULL, NULL),
(62292, '2018-01-31 14:03:43', NULL, NULL, 16521, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:03:43', 'admin-1517358393-15173786235511196', 1, 1, 'SR', NULL, NULL, NULL),
(62293, '2018-01-31 15:46:15', NULL, NULL, 16527, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1517358393', 'admin', '2018-01-31 15:46:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62294, '2018-01-31 15:46:24', NULL, NULL, 16527, 0, 336, '272', 'iced Yuzu', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 15:46:24', 'admin-1517358393-15173847838959332', 1, 0, '', NULL, NULL, NULL),
(62295, '2018-01-31 13:39:36', NULL, NULL, 16520, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:39:36', 'admin-1517358393-15173771758666154', 1, 0, '', NULL, NULL, NULL),
(62296, '2018-01-31 13:43:16', NULL, NULL, 16521, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:43:16', 'admin-1517358393-15173773959861924', 1, 1, 'SR', NULL, NULL, NULL),
(62297, '2018-01-31 13:43:16', NULL, NULL, 16521, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:43:16', 'admin-1517358393-15173773959861924', 1, 1, 'SR', NULL, NULL, NULL),
(62298, '2018-01-31 13:43:16', NULL, NULL, 16521, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:43:16', 'admin-1517358393-15173773959861924', 1, 0, '', NULL, NULL, NULL),
(62299, '2018-01-31 13:38:39', NULL, NULL, 16520, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:38:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62300, '2018-01-31 13:39:35', NULL, NULL, 16520, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:39:35', 'admin-1517358393-15173771758666154', 1, 0, '', NULL, NULL, NULL),
(62301, '2018-01-31 15:50:36', NULL, NULL, 16528, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 15:50:36', 'admin-1517358393-15173850368406611', 1, 1, 'SR', NULL, NULL, NULL),
(62302, '2018-01-31 10:24:45', NULL, NULL, 16505, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 10:24:45', 'admin-1517358393-15173654851393854', 1, 0, '', NULL, NULL, NULL),
(62303, '2018-01-31 14:35:16', NULL, NULL, 16524, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:35:16', 'admin-1517358393-15173805160125463', 1, 0, '', NULL, NULL, NULL),
(62304, '2018-01-31 13:42:49', NULL, NULL, 16521, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:42:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62305, '2018-01-31 09:27:03', NULL, NULL, 16500, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:27:03', 'admin-1517358393-1517362023296719', 1, 0, '', NULL, NULL, NULL),
(62306, '2018-01-31 13:39:35', NULL, NULL, 16520, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:39:35', 'admin-1517358393-15173771758666154', 1, 0, '', NULL, NULL, NULL),
(62307, '2018-01-31 13:11:28', NULL, NULL, 16516, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:11:28', 'admin-1517358393-15173754883699532', 1, 0, '', NULL, NULL, NULL),
(62308, '2018-01-31 12:18:01', NULL, NULL, 16511, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1517358393', 'admin', '2018-01-31 12:18:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62309, '2018-01-31 13:34:50', NULL, NULL, 16518, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:34:50', 'admin-1517358393-15173768901538470', 1, 0, '', NULL, NULL, NULL),
(62310, '2018-01-31 15:43:59', NULL, NULL, 16526, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 15:43:59', 'admin-1517358393-15173846395595664', 1, 1, 'SR', NULL, NULL, NULL),
(62311, '2018-01-31 15:43:59', NULL, NULL, 16526, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 15:43:59', 'admin-1517358393-15173846395595664', 1, 1, 'SR', NULL, NULL, NULL),
(62312, '2018-01-31 15:43:52', NULL, NULL, 16526, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1517358393', 'admin', '2018-01-31 15:43:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62313, '2018-01-31 14:58:13', NULL, NULL, 16525, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:58:13', 'admin-1517358393-15173818931244419', 1, 0, '', NULL, NULL, NULL),
(62314, '2018-01-31 15:15:36', NULL, NULL, 16524, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 15:15:36', 'admin-1517358393-15173829365872336', 1, 0, '', NULL, NULL, NULL),
(62315, '2018-01-31 14:58:13', NULL, NULL, 16525, 0, 322, '258', 'Yuzu Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:58:13', 'admin-1517358393-15173818931244419', 1, 0, '', NULL, NULL, NULL),
(62316, '2018-01-31 14:35:16', NULL, NULL, 16524, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:35:16', 'admin-1517358393-15173805160125463', 1, 1, 'SR', NULL, NULL, NULL),
(62317, '2018-01-31 14:35:16', NULL, NULL, 16524, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:35:16', 'admin-1517358393-15173805160125463', 1, 0, '', NULL, NULL, NULL),
(62318, '2018-01-31 14:35:16', NULL, NULL, 16524, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:35:16', 'admin-1517358393-15173805160125463', 1, 0, '', NULL, NULL, NULL),
(62319, '2018-01-31 14:35:16', NULL, NULL, 16524, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:35:16', 'admin-1517358393-15173805160125463', 1, 0, '', NULL, NULL, NULL),
(62320, '2018-01-31 14:34:38', NULL, NULL, 16524, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:34:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62321, '2018-01-31 14:35:16', NULL, NULL, 16524, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:35:16', 'admin-1517358393-15173805160125463', 1, 0, '', NULL, NULL, NULL),
(62322, '2018-01-31 14:23:34', NULL, NULL, 16516, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:23:34', 'admin-1517358393-15173798146926016', 1, 1, 'SR', NULL, NULL, NULL),
(62323, '2018-01-31 14:09:48', NULL, NULL, 16523, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:09:48', 'admin-1517358393-15173789888526299', 1, 1, 'SR', NULL, NULL, NULL),
(62324, '2018-01-31 14:09:41', NULL, NULL, 16523, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:09:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62325, '2018-01-31 14:02:12', NULL, NULL, 16522, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:02:12', 'admin-1517358393-15173785323329375', 1, 0, '', NULL, NULL, NULL),
(62326, '2018-01-31 14:02:12', NULL, NULL, 16522, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:02:12', 'admin-1517358393-15173785323329375', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(62327, '2018-01-31 13:43:16', NULL, NULL, 16521, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:43:16', 'admin-1517358393-15173773959861924', 1, 0, '', NULL, NULL, NULL),
(62328, '2018-01-31 11:32:38', NULL, NULL, 16508, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 11:32:38', 'admin-1517358393-15173695582019390', 1, 0, '', NULL, NULL, NULL),
(62329, '2018-01-31 09:29:47', NULL, NULL, 16501, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:29:47', 'admin-1517358393-15173621877067716', 1, 0, '', NULL, NULL, NULL),
(62330, '2018-01-31 13:31:58', NULL, NULL, 16519, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:31:58', 'admin-1517358393-1517376718380654', 1, 0, '', NULL, NULL, NULL),
(62331, '2018-01-31 14:01:38', NULL, NULL, 16522, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:01:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62332, '2018-01-31 14:02:12', NULL, NULL, 16522, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:02:12', 'admin-1517358393-15173785323329375', 1, 0, '', NULL, NULL, NULL),
(62333, '2018-01-31 13:53:43', NULL, NULL, 16516, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:53:43', 'admin-1517358393-15173780231551847', 1, 1, 'SR', NULL, NULL, NULL),
(62334, '2018-01-31 13:31:58', NULL, NULL, 16519, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:31:58', 'admin-1517358393-1517376718380654', 1, 1, 'SR', NULL, NULL, NULL),
(62335, '2018-01-31 13:34:42', NULL, NULL, 16519, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:34:42', 'admin-1517358393-15173768823081265', 1, 1, 'SR', NULL, NULL, NULL),
(62336, '2018-01-31 12:57:17', NULL, NULL, 16515, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 12:57:17', 'admin-1517358393-15173746369175684', 1, 1, 'SR', NULL, NULL, NULL),
(62337, '2018-01-31 13:10:47', NULL, NULL, 16516, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:10:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62338, '2018-01-31 09:35:10', NULL, NULL, 16502, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:35:10', 'admin-1517358393-15173625102763078', 1, 1, 'SR', NULL, NULL, NULL),
(62339, '2018-01-31 10:55:41', NULL, NULL, 16508, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 10:55:41', 'admin-1517358393-15173673416061838', 1, 0, '', NULL, NULL, NULL),
(62340, '2018-01-31 14:02:12', NULL, NULL, 16522, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:02:12', 'admin-1517358393-15173785323329375', 1, 0, '', NULL, NULL, NULL),
(62341, '2018-01-31 13:31:42', NULL, NULL, 16519, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:31:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62342, '2018-01-31 13:43:16', NULL, NULL, 16521, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 13:43:16', 'admin-1517358393-15173773959861924', 1, 0, '', NULL, NULL, NULL),
(62343, '2018-01-31 00:00:00', NULL, NULL, 16512, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', NULL, 1, 1.40, NULL, NULL, 1.40, 1, '27', 1, '1517358393', 'admin', '2018-01-31 11:54:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62344, '2018-01-31 00:00:00', NULL, NULL, 16511, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 11:55:00', 'admin-1517358393-1517370900054242', 1, 1, 'SR', NULL, NULL, NULL),
(62345, '2018-01-31 12:53:23', NULL, NULL, 16515, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 12:53:23', 'admin-1517358393-15173744038389768', 1, 1, 'SR', NULL, NULL, NULL),
(62346, '2018-01-31 12:53:23', NULL, NULL, 16515, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 12:53:23', 'admin-1517358393-15173744038389768', 1, 1, 'SR', NULL, NULL, NULL),
(62347, '2018-01-31 12:53:17', NULL, NULL, 16515, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 12:53:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62348, '2018-01-31 12:44:59', NULL, NULL, 16514, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 12:44:59', 'admin-1517358393-1517373899224139', 1, 1, 'SR', 1, NULL, '10.0'),
(62349, '2018-01-31 12:53:23', NULL, NULL, 16515, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 12:53:23', 'admin-1517358393-15173744038389768', 1, 1, 'SR', NULL, NULL, NULL),
(62350, '2018-01-31 12:40:03', NULL, NULL, 16513, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1517358393', 'admin', '2018-01-31 12:40:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62351, '2018-01-31 00:00:00', NULL, NULL, 16512, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 11:55:00', 'admin-1517358393-1517370900054242', 1, 0, '', NULL, NULL, NULL),
(62352, '2018-01-31 10:42:19', NULL, NULL, 16507, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 10:42:19', 'admin-1517358393-15173665390677025', 1, 0, '', NULL, NULL, NULL),
(62353, '2018-01-31 14:09:48', NULL, NULL, 16523, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 14:09:48', 'admin-1517358393-15173789888526299', 1, 1, 'SR', NULL, NULL, NULL),
(62354, '2018-01-31 11:44:50', NULL, NULL, 16509, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 11:44:50', 'admin-1517358393-15173702908449895', 1, 0, '', NULL, NULL, NULL),
(62355, '2018-01-31 11:06:33', NULL, NULL, 16505, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 11:06:33', 'admin-1517358393-15173679929388734', 1, 0, '', NULL, NULL, NULL),
(62356, '2018-01-31 10:42:19', NULL, NULL, 16507, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 10:42:19', 'admin-1517358393-15173665390677025', 1, 0, '', NULL, NULL, NULL),
(62357, '2018-01-31 10:42:19', NULL, NULL, 16507, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 10:42:19', 'admin-1517358393-15173665390677025', 1, 1, 'SR', NULL, NULL, NULL),
(62358, '2018-01-31 11:43:39', NULL, NULL, 16509, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1517358393', 'admin', '2018-01-31 11:43:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62359, '2018-01-31 11:43:45', NULL, NULL, 16509, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 11:43:45', 'admin-1517358393-15173702249162539', 1, 1, 'SR', NULL, NULL, NULL),
(62360, '2018-01-31 10:42:19', NULL, NULL, 16507, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 10:42:19', 'admin-1517358393-15173665390677025', 1, 1, 'SR', NULL, NULL, NULL),
(62361, '2018-01-31 10:42:19', NULL, NULL, 16507, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 10:42:19', 'admin-1517358393-15173665390677025', 1, 0, '', NULL, NULL, NULL),
(62362, '2018-01-31 10:41:49', NULL, NULL, 16507, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1517358393', 'admin', '2018-01-31 10:41:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62363, '2018-01-31 10:25:21', NULL, NULL, 16506, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 10:25:21', 'admin-1517358393-1517365521260354', 1, 0, '', NULL, NULL, NULL),
(62364, '2018-01-31 10:25:21', NULL, NULL, 16506, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 10:25:21', 'admin-1517358393-1517365521260354', 1, 0, '', NULL, NULL, NULL),
(62365, '2018-01-31 10:24:45', NULL, NULL, 16505, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 10:24:45', 'admin-1517358393-15173654851393854', 1, 0, '', NULL, NULL, NULL),
(62366, '2018-01-31 09:27:03', NULL, NULL, 16500, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:27:03', 'admin-1517358393-1517362023296719', 1, 1, 'SR', NULL, NULL, NULL),
(62367, '2018-01-31 10:21:44', NULL, NULL, 16504, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1517358393', 'admin', '2018-01-31 10:21:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62368, '2018-01-31 10:22:08', NULL, NULL, 16504, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 10:22:08', 'admin-1517358393-1517365328749783', 1, 0, '', NULL, NULL, NULL),
(62369, '2018-01-31 10:22:08', NULL, NULL, 16504, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 10:22:08', 'admin-1517358393-1517365328749783', 1, 0, '', NULL, NULL, NULL),
(62370, '2018-01-31 10:16:18', NULL, NULL, 16503, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 10:16:18', 'admin-1517358393-15173649779037053', 1, 1, 'SR', NULL, NULL, NULL),
(62371, '2018-01-31 09:24:59', NULL, NULL, 16499, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:24:59', 'admin-1517358393-15173618994364478', 1, 0, '', NULL, NULL, NULL),
(62372, '2018-01-31 09:24:59', NULL, NULL, 16499, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:24:59', 'admin-1517358393-15173618994364478', 1, 1, 'SR', NULL, NULL, NULL),
(62373, '2018-01-31 09:24:59', NULL, NULL, 16499, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:24:59', 'admin-1517358393-15173618994364478', 1, 0, '', NULL, NULL, NULL),
(62374, '2018-01-31 10:16:18', NULL, NULL, 16503, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 10:16:18', 'admin-1517358393-15173649779037053', 1, 1, 'SR', NULL, NULL, NULL),
(62375, '2018-01-31 09:29:47', NULL, NULL, 16501, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:29:47', 'admin-1517358393-15173621877067716', 1, 1, 'SR', NULL, NULL, NULL),
(62376, '2018-01-31 09:26:33', NULL, NULL, 16500, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:26:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62377, '2018-01-31 09:29:47', NULL, NULL, 16501, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:29:47', 'admin-1517358393-15173621877067716', 1, 0, '', NULL, NULL, NULL),
(62378, '2018-01-31 10:25:07', NULL, NULL, 16506, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1517358393', 'admin', '2018-01-31 10:25:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62379, '2018-01-31 10:16:10', NULL, NULL, 16503, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1517358393', 'admin', '2018-01-31 10:16:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62380, '2018-01-31 10:55:37', NULL, NULL, 16508, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1517358393', 'admin', '2018-01-31 10:55:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62381, '2018-01-31 09:35:10', NULL, NULL, 16502, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:35:10', 'admin-1517358393-15173625102763078', 1, 0, '', NULL, NULL, NULL),
(62382, '2018-01-31 09:29:47', NULL, NULL, 16501, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:29:47', 'admin-1517358393-15173621877067716', 1, 0, '', NULL, NULL, NULL),
(62383, '2018-01-31 09:24:59', NULL, NULL, 16499, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:24:59', 'admin-1517358393-15173618994364478', 1, 1, 'SR', NULL, NULL, NULL),
(62384, '2018-01-31 09:29:47', NULL, NULL, 16501, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:29:47', 'admin-1517358393-15173621877067716', 1, 0, '', NULL, NULL, NULL),
(62385, '2018-01-31 09:29:47', NULL, NULL, 16501, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:29:47', 'admin-1517358393-15173621877067716', 1, 1, 'SR', NULL, NULL, NULL),
(62386, '2018-01-31 10:25:21', NULL, NULL, 16506, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 10:25:21', 'admin-1517358393-1517365521260354', 1, 1, 'SR', NULL, NULL, NULL),
(62387, '2018-01-31 09:27:03', NULL, NULL, 16500, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:27:03', 'admin-1517358393-1517362023296719', 1, 1, 'SR', NULL, NULL, NULL),
(62388, '2018-01-31 09:27:03', NULL, NULL, 16500, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:27:03', 'admin-1517358393-1517362023296719', 1, 0, '', NULL, NULL, NULL),
(62389, '2018-01-31 09:10:12', NULL, NULL, 16497, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:10:12', 'admin-1517358393-15173610119798237', 1, 0, '', NULL, NULL, NULL),
(62390, '2018-01-31 09:10:12', NULL, NULL, 16497, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:10:12', 'admin-1517358393-15173610119798237', 1, 1, 'SR', NULL, NULL, NULL),
(62391, '2018-01-31 09:10:12', NULL, NULL, 16497, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:10:12', 'admin-1517358393-15173610119798237', 1, 1, 'SR', NULL, NULL, NULL),
(62392, '2018-01-31 09:29:15', NULL, NULL, 16501, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:29:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62393, '2018-01-31 09:27:03', NULL, NULL, 16500, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:27:03', 'admin-1517358393-1517362023296719', 1, 0, '', NULL, NULL, NULL),
(62394, '2018-01-31 09:27:03', NULL, NULL, 16500, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:27:03', 'admin-1517358393-1517362023296719', 1, 0, '', NULL, NULL, NULL),
(62395, '2018-01-31 09:20:17', NULL, NULL, 16498, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:20:17', 'admin-1517358393-15173616176093075', 1, 1, 'SR', NULL, NULL, NULL),
(62396, '2018-01-31 09:20:17', NULL, NULL, 16498, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:20:17', 'admin-1517358393-15173616176093075', 1, 1, 'SR', NULL, NULL, NULL),
(62397, '2018-01-31 09:20:17', NULL, NULL, 16498, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:20:17', 'admin-1517358393-15173616176093075', 1, 0, '', NULL, NULL, NULL),
(62398, '2018-01-31 09:20:17', NULL, NULL, 16498, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:20:17', 'admin-1517358393-15173616176093075', 1, 0, '', NULL, NULL, NULL),
(62399, '2018-01-31 09:23:43', NULL, NULL, 16499, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 12.60, 0.0000, 0.0000, 12.60, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:23:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62400, '2018-01-31 09:24:59', NULL, NULL, 16499, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:24:59', 'admin-1517358393-15173618994364478', 1, 0, '', NULL, NULL, NULL),
(62401, '2018-01-31 09:24:59', NULL, NULL, 16499, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:24:59', 'admin-1517358393-15173618994364478', 1, 0, '', NULL, NULL, NULL),
(62402, '2018-01-31 09:24:59', NULL, NULL, 16499, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:24:59', 'admin-1517358393-15173618994364478', 1, 0, '', NULL, NULL, NULL),
(62403, '2018-01-31 09:24:59', NULL, NULL, 16499, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:24:59', 'admin-1517358393-15173618994364478', 1, 0, '', NULL, NULL, NULL),
(62404, '2018-01-31 09:20:17', NULL, NULL, 16498, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:20:17', 'admin-1517358393-15173616176093075', 1, 1, 'SR', NULL, NULL, NULL),
(62405, '2018-01-31 09:20:17', NULL, NULL, 16498, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:20:17', 'admin-1517358393-15173616176093075', 1, 1, 'SR', NULL, NULL, NULL),
(62406, '2018-01-31 09:10:12', NULL, NULL, 16497, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:10:12', 'admin-1517358393-15173610119798237', 1, 0, '', NULL, NULL, NULL),
(62407, '2018-01-31 09:19:52', NULL, NULL, 16498, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:19:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62408, '2018-01-31 09:10:12', NULL, NULL, 16497, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:10:12', 'admin-1517358393-15173610119798237', 1, 0, '', NULL, NULL, NULL),
(62409, '2018-01-31 09:09:46', NULL, NULL, 16497, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1517358393', 'admin', '2018-01-31 09:09:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62410, '2018-02-01 13:58:04', NULL, NULL, 16548, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:58:04', 'admin-1517447169-15174646839638158', 1, 1, 'SR', NULL, NULL, NULL),
(62411, '2018-02-01 14:21:40', NULL, NULL, 16549, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1517447169', 'admin', '2018-02-01 14:21:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62412, '2018-02-01 14:21:51', NULL, NULL, 16549, 0, 181, '116', 'Open Food ', 'CKT', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 14:21:51', 'admin-1517447169-15174661109478031', 1, 0, '', NULL, NULL, NULL),
(62413, '2018-02-01 14:24:59', NULL, NULL, 16549, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 14:24:59', 'admin-1517447169-15174662990648714', 1, 1, 'SR', NULL, NULL, NULL),
(62414, '2018-02-01 13:38:20', NULL, NULL, 16547, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:38:20', 'admin-1517447169-1517463500163714', 1, 0, '', NULL, NULL, '10.0'),
(62415, '2018-02-01 13:38:20', NULL, NULL, 16547, 0, 181, '116', 'Open Food ', 'ckt', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:38:20', 'admin-1517447169-1517463500163714', 1, 0, '', NULL, NULL, '10.0'),
(62416, '2018-02-01 13:42:24', NULL, NULL, 16547, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:42:24', 'admin-1517447169-15174637446937031', 1, 0, '', NULL, NULL, '10.0'),
(62417, '2018-02-01 13:57:55', NULL, NULL, 16548, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:57:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62418, '2018-02-01 13:58:04', NULL, NULL, 16548, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:58:04', 'admin-1517447169-15174646839638158', 1, 1, 'SR', NULL, NULL, NULL),
(62419, '2018-02-01 12:15:31', NULL, NULL, 16542, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 12:15:31', 'admin-1517447169-15174585310621042', 1, 0, '', NULL, NULL, NULL),
(62420, '2018-02-01 12:38:25', NULL, NULL, 16543, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 12:38:25', 'admin-1517447169-15174599054002654', 1, 0, '', NULL, NULL, NULL),
(62421, '2018-02-01 10:24:58', NULL, NULL, 16535, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 10:24:58', 'admin-1517447169-15174518980585155', 1, 0, '', NULL, NULL, NULL),
(62422, '2018-02-01 15:25:49', NULL, NULL, 16549, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 15:25:49', 'admin-1517447169-15174699497219936', 1, 0, '', NULL, NULL, NULL),
(62423, '2018-02-01 15:09:42', NULL, NULL, 16551, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 15:09:42', 'admin-1517447169-15174689826942332', 1, 0, '', NULL, NULL, NULL),
(62424, '2018-02-01 13:00:58', NULL, NULL, 16544, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:00:58', 'admin-1517447169-15174612581296028', 1, 0, '', NULL, NULL, NULL),
(62425, '2018-02-01 16:32:00', NULL, NULL, 16553, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1517447169', 'admin', '2018-02-01 16:32:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62426, '2018-02-01 13:23:31', NULL, NULL, 16546, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:23:31', 'admin-1517447169-15174626114746010', 1, 1, 'SR', NULL, NULL, NULL),
(62427, '2018-02-01 13:37:48', NULL, NULL, 16547, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:37:48', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(62428, '2018-02-01 13:08:59', NULL, NULL, 16545, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:08:59', 'admin-1517447169-15174617394952994', 1, 0, '', NULL, NULL, NULL),
(62429, '2018-02-01 12:15:31', NULL, NULL, 16542, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 12:15:31', 'admin-1517447169-15174585310621042', 1, 0, '', NULL, NULL, NULL),
(62430, '2018-02-01 15:09:42', NULL, NULL, 16551, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 15:09:42', 'admin-1517447169-15174689826942332', 1, 1, 'SR', NULL, NULL, NULL),
(62431, '2018-02-01 16:42:30', NULL, NULL, 16553, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 16:42:30', 'admin-1517447169-15174745506341026', 1, 0, '', NULL, NULL, NULL),
(62432, '2018-02-01 16:32:09', NULL, NULL, 16553, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 16:32:09', 'admin-1517447169-1517473929067275', 1, 1, 'SR', NULL, NULL, NULL),
(62433, '2018-02-01 16:32:09', NULL, NULL, 16553, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 16:32:09', 'admin-1517447169-1517473929067275', 1, 1, 'SR', NULL, NULL, NULL),
(62434, '2018-02-01 11:37:18', NULL, NULL, 16541, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 11:37:18', 'admin-1517447169-15174562386802355', 1, 1, 'SR', NULL, NULL, NULL),
(62435, '2018-02-01 15:25:58', NULL, NULL, 16552, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 15:25:58', 'admin-1517447169-15174699587442299', 1, 1, 'SR', 1, NULL, NULL),
(62436, '2018-02-01 15:09:42', NULL, NULL, 16551, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 15:09:42', 'admin-1517447169-15174689826942332', 1, 1, 'SR', NULL, NULL, NULL),
(62437, '2018-02-01 14:35:02', NULL, NULL, 16550, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 14:35:02', 'admin-1517447169-1517466902055150', 1, 1, 'SR', NULL, NULL, NULL),
(62438, '2018-02-01 11:37:18', NULL, NULL, 16541, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 11:37:18', 'admin-1517447169-15174562386802355', 1, 0, '', NULL, NULL, NULL),
(62439, '2018-02-01 14:35:02', NULL, NULL, 16550, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 14:35:02', 'admin-1517447169-1517466902055150', 1, 1, 'SR', NULL, NULL, NULL),
(62440, '2018-02-01 14:34:55', NULL, NULL, 16550, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1517447169', 'admin', '2018-02-01 14:34:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62441, '2018-02-01 13:23:31', NULL, NULL, 16546, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:23:31', 'admin-1517447169-15174626114746010', 1, 1, 'SR', NULL, NULL, NULL),
(62442, '2018-02-01 15:00:08', NULL, NULL, 16550, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 15:00:08', 'admin-1517447169-1517468407953593', 1, 1, 'SR', NULL, NULL, NULL),
(62443, '2018-02-01 13:58:04', NULL, NULL, 16548, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:58:04', 'admin-1517447169-15174646839638158', 1, 1, 'SR', NULL, NULL, NULL),
(62444, '2018-02-01 15:09:42', NULL, NULL, 16551, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 15:09:42', 'admin-1517447169-15174689826942332', 1, 0, '', NULL, NULL, NULL),
(62445, '2018-02-01 12:15:10', NULL, NULL, 16542, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1517447169', 'admin', '2018-02-01 12:15:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62446, '2018-02-01 13:38:20', NULL, NULL, 16547, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:38:20', 'admin-1517447169-1517463500163714', 1, 0, '', NULL, NULL, '10.0'),
(62447, '2018-02-01 13:20:27', NULL, NULL, 16546, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.70, 0.0000, 0.0000, 9.70, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:20:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62448, '2018-02-01 13:23:31', NULL, NULL, 16546, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:23:31', 'admin-1517447169-15174626114746010', 1, 0, '', NULL, NULL, NULL),
(62449, '2018-02-01 10:53:32', NULL, NULL, 16538, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 10:53:32', 'admin-1517447169-15174536121778751', 1, 1, 'SR', NULL, NULL, NULL),
(62450, '2018-02-01 13:23:31', NULL, NULL, 16546, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:23:31', 'admin-1517447169-15174626114746010', 1, 1, 'SR', NULL, NULL, NULL),
(62451, '2018-02-01 13:23:31', NULL, NULL, 16546, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:23:31', 'admin-1517447169-15174626114746010', 1, 1, 'SR', NULL, NULL, NULL),
(62452, '2018-02-01 13:08:59', NULL, NULL, 16545, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:08:59', 'admin-1517447169-15174617394952994', 1, 0, '', NULL, NULL, NULL),
(62453, '2018-02-01 13:23:31', NULL, NULL, 16546, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:23:31', 'admin-1517447169-15174626114746010', 1, 1, 'SR', NULL, NULL, NULL),
(62454, '2018-02-01 13:08:59', NULL, NULL, 16545, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:08:59', 'admin-1517447169-15174617394952994', 1, 0, '', NULL, NULL, NULL),
(62455, '2018-02-01 13:08:59', NULL, NULL, 16545, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:08:59', 'admin-1517447169-15174617394952994', 1, 1, 'SR', NULL, NULL, NULL),
(62456, '2018-02-01 10:27:45', NULL, NULL, 16536, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1517447169', 'admin', '2018-02-01 10:27:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62457, '2018-02-01 10:28:00', NULL, NULL, 16536, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 10:28:00', 'admin-1517447169-15174520801153659', 1, 1, 'SR', NULL, NULL, NULL),
(62458, '2018-02-01 13:08:22', NULL, NULL, 16545, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:08:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62459, '2018-02-01 13:00:58', NULL, NULL, 16544, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:00:58', 'admin-1517447169-15174612581296028', 1, 1, 'SR', NULL, NULL, NULL),
(62460, '2018-02-01 15:09:26', NULL, NULL, 16551, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1517447169', 'admin', '2018-02-01 15:09:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62461, '2018-02-01 13:00:58', NULL, NULL, 16544, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:00:58', 'admin-1517447169-15174612581296028', 1, 0, '', NULL, NULL, NULL),
(62462, '2018-02-01 13:00:58', NULL, NULL, 16544, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:00:58', 'admin-1517447169-15174612581296028', 1, 0, '', NULL, NULL, NULL),
(62463, '2018-02-01 13:00:19', NULL, NULL, 16544, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:00:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62464, '2018-02-01 11:58:09', NULL, NULL, 16541, 0, 181, '116', 'Open Food ', 'toast', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 11:58:09', 'admin-1517447169-15174574895131953', 1, 0, '', NULL, NULL, NULL),
(62465, '2018-02-01 10:17:40', NULL, NULL, 16534, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 10:17:40', 'admin-1517447169-15174514606014978', 1, 1, 'SR', NULL, NULL, NULL),
(62466, '2018-02-01 10:24:34', NULL, NULL, 16535, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1517447169', 'admin', '2018-02-01 10:24:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62467, '2018-02-01 10:24:58', NULL, NULL, 16535, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 10:24:58', 'admin-1517447169-15174518980585155', 1, 0, '', NULL, NULL, NULL),
(62468, '2018-02-01 12:38:25', NULL, NULL, 16543, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 12:38:25', 'admin-1517447169-15174599054002654', 1, 1, 'SR', NULL, NULL, NULL),
(62469, '2018-02-01 11:35:57', NULL, NULL, 16540, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1517447169', 'admin', '2018-02-01 11:35:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62470, '2018-02-01 10:28:00', NULL, NULL, 16536, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 10:28:00', 'admin-1517447169-15174520801153659', 1, 1, 'SR', NULL, NULL, NULL),
(62471, '2018-02-01 11:37:00', NULL, NULL, 16541, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1517447169', 'admin', '2018-02-01 11:37:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62472, '2018-02-01 11:37:18', NULL, NULL, 16541, 0, 153, '87', 'Wake Me Up!', 'no bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 11:37:18', 'admin-1517447169-15174562386802355', 1, 0, '', NULL, NULL, NULL),
(62473, '2018-02-01 11:36:09', NULL, NULL, 16540, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 11:36:09', 'admin-1517447169-15174561694921178', 1, 1, 'SR', NULL, NULL, NULL),
(62474, '2018-02-01 13:23:31', NULL, NULL, 16546, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 13:23:31', 'admin-1517447169-15174626114746010', 1, 1, 'SR', NULL, NULL, NULL),
(62475, '2018-02-01 11:03:41', NULL, NULL, 16539, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1517447169', 'admin', '2018-02-01 11:03:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62476, '2018-02-01 11:03:45', NULL, NULL, 16539, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 11:03:45', 'admin-1517447169-15174542253867317', 1, 1, 'SR', NULL, NULL, NULL),
(62477, '2018-02-01 11:03:45', NULL, NULL, 16539, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 11:03:45', 'admin-1517447169-15174542253867317', 1, 1, 'SR', NULL, NULL, NULL),
(62478, '2018-02-01 11:37:18', NULL, NULL, 16541, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 11:37:18', 'admin-1517447169-15174562386802355', 1, 1, 'SR', NULL, NULL, NULL),
(62479, '2018-02-01 10:49:06', NULL, NULL, 16537, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 10.80, 1, '27', 1, '1517447169', 'admin', '2018-02-01 10:49:06', 'admin-1517447169-15174533459798930', 1, 1, 'SR', 1, '10.0', NULL),
(62480, '2018-02-01 10:28:09', NULL, NULL, 16536, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 10:28:09', 'admin-1517447169-1517452088918890', 1, 0, '', NULL, NULL, NULL),
(62481, '2018-02-01 10:28:09', NULL, NULL, 16536, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 10:28:09', 'admin-1517447169-1517452088918890', 1, 0, '', NULL, NULL, NULL),
(62482, '2018-02-01 09:12:10', NULL, NULL, 16531, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 09:12:10', 'admin-1517447169-15174475307326667', 1, 0, '', NULL, NULL, NULL),
(62483, '2018-02-01 09:12:10', NULL, NULL, 16531, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 09:12:10', 'admin-1517447169-15174475307326667', 1, 0, '', NULL, NULL, NULL),
(62484, '2018-02-01 09:12:10', NULL, NULL, 16531, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 09:12:10', 'admin-1517447169-15174475307326667', 1, 1, 'SR', NULL, NULL, NULL),
(62485, '2018-02-01 10:24:58', NULL, NULL, 16535, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 10:24:58', 'admin-1517447169-15174518980585155', 1, 0, '', NULL, NULL, NULL),
(62486, '2018-02-01 10:24:58', NULL, NULL, 16535, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 10:24:58', 'admin-1517447169-15174518980585155', 1, 1, 'SR', NULL, NULL, NULL),
(62487, '2018-02-01 09:22:20', NULL, NULL, 16533, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 09:22:20', 'admin-1517447169-15174481401046318', 1, 0, '', NULL, NULL, NULL),
(62488, '2018-02-01 09:22:20', NULL, NULL, 16533, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 09:22:20', 'admin-1517447169-15174481401046318', 1, 0, '', NULL, NULL, NULL),
(62489, '2018-02-01 09:22:20', NULL, NULL, 16533, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 09:22:20', 'admin-1517447169-15174481401046318', 1, 1, 'SR', NULL, NULL, NULL),
(62490, '2018-02-01 09:22:20', NULL, NULL, 16533, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 09:22:20', 'admin-1517447169-15174481401046318', 1, 1, 'SR', NULL, NULL, NULL),
(62491, '2018-02-01 09:25:05', NULL, NULL, 16532, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 09:25:05', 'admin-1517447169-15174483057962212', 1, 1, 'SR', NULL, NULL, NULL),
(62492, '2018-02-01 10:53:21', NULL, NULL, 16538, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1517447169', 'admin', '2018-02-01 10:53:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62493, '2018-02-01 10:53:32', NULL, NULL, 16538, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 10:53:32', 'admin-1517447169-15174536121778751', 1, 0, '', NULL, NULL, NULL),
(62494, '2018-02-01 11:36:09', NULL, NULL, 16540, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 11:36:09', 'admin-1517447169-15174561694921178', 1, 0, '', NULL, NULL, NULL),
(62495, '2018-02-01 12:38:12', NULL, NULL, 16543, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1517447169', 'admin', '2018-02-01 12:38:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62496, '2018-02-01 10:17:36', NULL, NULL, 16534, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1517447169', 'admin', '2018-02-01 10:17:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62497, '2018-02-01 09:12:51', NULL, NULL, 16532, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1517447169', 'admin', '2018-02-01 09:12:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62498, '2018-02-01 09:24:01', NULL, NULL, 16532, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 09:24:01', 'admin-1517447169-151744824119299', 1, 0, '', NULL, NULL, NULL),
(62499, '2018-02-01 09:13:06', NULL, NULL, 16532, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 09:13:06', 'admin-1517447169-15174475863714552', 1, 1, 'SR', NULL, NULL, NULL),
(62500, '2018-02-01 09:22:09', NULL, NULL, 16533, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1517447169', 'admin', '2018-02-01 09:22:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62501, '2018-02-01 09:12:10', NULL, NULL, 16531, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 09:12:10', 'admin-1517447169-15174475307326667', 1, 1, 'SR', NULL, NULL, NULL),
(62502, '2018-02-01 09:12:00', NULL, NULL, 16531, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1517447169', 'admin', '2018-02-01 09:12:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62503, '2018-02-02 15:26:20', NULL, NULL, 16582, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 15:26:20', 'admin-1517534180-15175563806273453', 1, 0, '', NULL, NULL, '10.0'),
(62504, '2018-02-02 14:48:02', NULL, NULL, 16578, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1517534180', 'admin', '2018-02-02 14:48:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62505, '2018-02-02 13:16:19', NULL, NULL, 16572, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:16:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62506, '2018-02-02 13:16:26', NULL, NULL, 16572, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:16:26', 'admin-1517534180-15175485859038067', 1, 1, 'SR', NULL, NULL, NULL),
(62507, '2018-02-02 13:16:26', NULL, NULL, 16572, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:16:26', 'admin-1517534180-15175485859038067', 1, 1, 'SR', NULL, NULL, NULL),
(62508, '2018-02-02 13:21:49', NULL, NULL, 16568, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:21:49', 'admin-1517534180-15175489089485625', 1, 1, 'SR', NULL, NULL, NULL),
(62509, '2018-02-02 13:40:35', NULL, NULL, 16573, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:40:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62510, '2018-02-02 13:41:01', NULL, NULL, 16573, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:41:01', 'admin-1517534180-15175500617727976', 1, 1, 'SR', NULL, NULL, NULL),
(62511, '2018-02-02 13:03:28', NULL, NULL, 16569, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:03:28', 'admin-1517534180-1517547808781733', 1, 1, 'SR', NULL, NULL, NULL),
(62512, '2018-02-02 13:03:28', NULL, NULL, 16569, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:03:28', 'admin-1517534180-1517547808781733', 1, 1, 'SR', NULL, NULL, NULL),
(62513, '2018-02-02 15:57:07', NULL, NULL, 16583, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 15:57:07', 'admin-1517534180-15175582270202793', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(62514, '2018-02-02 16:09:23', NULL, NULL, 16583, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 16:09:23', 'admin-1517534180-15175589633658324', 1, 0, '', NULL, NULL, NULL),
(62515, '2018-02-02 12:36:13', NULL, NULL, 16564, 0, 305, '241', 'Sprite', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 12:36:13', 'admin-1517534180-15175461733759680', 1, 0, '', NULL, NULL, NULL),
(62516, '2018-02-02 12:36:13', NULL, NULL, 16564, 0, 305, '241', 'Sprite', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 12:36:13', 'admin-1517534180-15175461733759680', 1, 0, '', NULL, NULL, NULL),
(62517, '2018-02-02 00:00:00', NULL, NULL, 16578, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, NULL, NULL, 23.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:41:01', 'admin-1517534180-15175500617727976', 1, 0, '', NULL, NULL, NULL),
(62518, '2018-02-02 00:00:00', NULL, NULL, 16578, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:41:01', 'admin-1517534180-15175500617727976', 1, 1, 'SR', NULL, NULL, NULL),
(62519, '2018-02-02 13:41:01', NULL, NULL, 16573, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:41:01', 'admin-1517534180-15175500617727976', 1, 1, 'SR', NULL, NULL, NULL),
(62520, '2018-02-02 12:56:02', NULL, NULL, 16567, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 12:56:02', 'admin-1517534180-15175473621637686', 1, 1, 'SR', NULL, NULL, NULL),
(62521, '2018-02-02 12:25:45', NULL, NULL, 16563, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 12:25:45', 'admin-1517534180-15175455455563679', 1, 0, '', NULL, NULL, NULL),
(62522, '2018-02-02 13:00:49', NULL, NULL, 16568, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:00:49', 'admin-1517534180-15175476489521013', 1, 1, 'SR', NULL, NULL, NULL),
(62523, '2018-02-02 15:08:49', NULL, NULL, 16580, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 15:08:49', 'admin-1517534180-15175553297745917', 1, 1, 'SR', NULL, NULL, NULL),
(62524, '2018-02-02 12:25:45', NULL, NULL, 16563, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 12:25:45', 'admin-1517534180-15175455455563679', 1, 0, '', NULL, NULL, NULL),
(62525, '2018-02-02 12:25:45', NULL, NULL, 16563, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 12:25:45', 'admin-1517534180-15175455455563679', 1, 0, '', NULL, NULL, NULL),
(62526, '2018-02-02 15:08:49', NULL, NULL, 16580, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 15:08:49', 'admin-1517534180-15175553297745917', 1, 1, 'SR', NULL, NULL, NULL),
(62527, '2018-02-02 13:04:10', NULL, NULL, 16570, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:04:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62528, '2018-02-02 15:12:02', NULL, NULL, 16581, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 15:12:02', 'admin-1517534180-1517555522758342', 1, 0, '', 1, NULL, NULL),
(62529, '2018-02-02 15:01:48', NULL, NULL, 16579, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 15:01:48', 'admin-1517534180-15175549086638683', 1, 1, 'SR', NULL, NULL, NULL),
(62530, '2018-02-02 15:08:33', NULL, NULL, 16580, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1517534180', 'admin', '2018-02-02 15:08:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62531, '2018-02-02 15:01:42', NULL, NULL, 16579, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1517534180', 'admin', '2018-02-02 15:01:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62532, '2018-02-02 13:51:31', NULL, NULL, 16577, 0, 181, '116', 'Open Food ', 'CKT', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:51:31', 'admin-1517534180-15175506912551533', 1, 0, '', NULL, NULL, NULL),
(62533, '2018-02-02 13:52:46', NULL, NULL, 16571, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:52:46', 'admin-1517534180-15175507661619882', 1, 0, '', NULL, NULL, NULL),
(62534, '2018-02-02 15:57:01', NULL, NULL, 16583, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1517534180', 'admin', '2018-02-02 15:57:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62535, '2018-02-02 13:42:06', NULL, NULL, 16575, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:42:06', 'admin-1517534180-15175501263532536', 1, 1, 'SR', 1, NULL, NULL),
(62536, '2018-02-02 12:25:45', NULL, NULL, 16563, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 12:25:45', 'admin-1517534180-15175455455563679', 1, 1, 'SR', NULL, NULL, NULL),
(62537, '2018-02-02 13:50:48', NULL, NULL, 16576, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:50:48', 'admin-1517534180-15175506483605077', 1, 1, 'SR', 1, NULL, NULL),
(62538, '2018-02-02 13:51:15', NULL, NULL, 16577, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:51:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62539, '2018-02-02 13:51:31', NULL, NULL, 16577, 0, 181, '116', 'Open Food ', 'CKT', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:51:31', 'admin-1517534180-15175506912551533', 1, 0, '', NULL, NULL, NULL),
(62540, '2018-02-02 13:12:50', NULL, NULL, 16571, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:12:50', 'admin-1517534180-15175483704072993', 1, 1, 'SR', NULL, NULL, NULL),
(62541, '2018-02-02 13:12:50', NULL, NULL, 16571, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:12:50', 'admin-1517534180-15175483704072993', 1, 1, 'SR', NULL, NULL, NULL),
(62542, '2018-02-02 13:42:06', NULL, NULL, 16575, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:42:06', 'admin-1517534180-15175501263532536', 1, 1, 'SR', 1, NULL, NULL),
(62543, '2018-02-02 13:03:00', NULL, NULL, 16569, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:03:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62544, '2018-02-02 12:36:07', NULL, NULL, 16564, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 12:36:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62545, '2018-02-02 13:12:50', NULL, NULL, 16571, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:12:50', 'admin-1517534180-15175483704072993', 1, 1, 'SR', NULL, NULL, NULL),
(62546, '2018-02-02 13:12:50', NULL, NULL, 16571, 0, 181, '116', 'Open Food ', 'CKT', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:12:50', 'admin-1517534180-15175483704072993', 1, 0, '', NULL, NULL, NULL),
(62547, '2018-02-02 13:12:50', NULL, NULL, 16571, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:12:50', 'admin-1517534180-15175483704072993', 1, 1, 'SR', NULL, NULL, NULL),
(62548, '2018-02-02 13:12:50', NULL, NULL, 16571, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:12:50', 'admin-1517534180-15175483704072993', 1, 1, 'SR', NULL, NULL, NULL),
(62549, '2018-02-02 13:11:54', NULL, NULL, 16571, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.30, 0.0000, 0.0000, 10.30, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:11:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62550, '2018-02-02 13:04:16', NULL, NULL, 16570, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:04:16', 'admin-1517534180-15175478565555968', 1, 0, '', NULL, NULL, NULL),
(62551, '2018-02-02 13:12:50', NULL, NULL, 16571, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:12:50', 'admin-1517534180-15175483704072993', 1, 1, 'SR', NULL, NULL, NULL),
(62552, '2018-02-02 13:07:19', NULL, NULL, 16568, 0, 181, '116', 'Open Food ', 'bacon', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:07:19', 'admin-1517534180-15175480396916263', 1, 0, '', NULL, NULL, NULL),
(62553, '2018-02-02 13:06:54', NULL, NULL, 16568, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:06:54', 'admin-1517534180-15175480141555536', 1, 0, '', NULL, NULL, NULL),
(62554, '2018-02-02 11:39:44', NULL, NULL, 16559, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 11:39:44', 'admin-1517534180-15175427843241024', 1, 0, '', NULL, NULL, NULL),
(62555, '2018-02-02 11:51:48', NULL, NULL, 16560, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1517534180', 'admin', '2018-02-02 11:51:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62556, '2018-02-02 13:03:28', NULL, NULL, 16569, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:03:28', 'admin-1517534180-1517547808781733', 1, 0, '', NULL, NULL, NULL),
(62557, '2018-02-02 13:00:44', NULL, NULL, 16568, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:00:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62558, '2018-02-02 13:03:28', NULL, NULL, 16569, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 13:03:28', 'admin-1517534180-1517547808781733', 1, 0, '', NULL, NULL, NULL),
(62559, '2018-02-02 12:56:02', NULL, NULL, 16567, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 12:56:02', 'admin-1517534180-15175473621637686', 1, 1, 'SR', NULL, NULL, NULL),
(62560, '2018-02-02 00:00:00', NULL, NULL, 16566, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 11:36:48', 'admin-1517534180-15175426088105574', 1, 0, '', NULL, NULL, NULL),
(62561, '2018-02-02 12:55:54', NULL, NULL, 16567, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1517534180', 'admin', '2018-02-02 12:55:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62562, '2018-02-02 11:55:13', NULL, NULL, 16562, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 11:55:13', 'admin-1517534180-15175437131072474', 1, 1, 'SR', NULL, NULL, NULL),
(62563, '2018-02-02 09:44:03', NULL, NULL, 16557, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 09:44:03', 'admin-1517534180-15175358435135433', 1, 0, '', NULL, NULL, NULL),
(62564, '2018-02-02 09:44:03', NULL, NULL, 16557, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 09:44:03', 'admin-1517534180-15175358435135433', 1, 0, '', NULL, NULL, NULL),
(62565, '2018-02-02 09:44:03', NULL, NULL, 16557, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 09:44:03', 'admin-1517534180-15175358435135433', 1, 1, 'SR', NULL, NULL, NULL),
(62566, '2018-02-02 12:02:09', NULL, NULL, 16562, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 12:02:09', 'admin-1517534180-15175441295916944', 1, 0, '', NULL, NULL, NULL),
(62567, '2018-02-02 09:33:59', NULL, NULL, 16556, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 09:33:59', 'admin-1517534180-15175352393413470', 1, 1, 'SR', NULL, NULL, NULL),
(62568, '2018-02-02 09:43:54', NULL, NULL, 16557, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1517534180', 'admin', '2018-02-02 09:43:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62569, '2018-02-02 09:16:40', NULL, NULL, 16554, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 09:16:40', 'admin-1517534180-1517534199910602', 1, 0, '', NULL, NULL, NULL),
(62570, '2018-02-02 00:00:00', NULL, NULL, 16565, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 11:36:48', 'admin-1517534180-15175426088105574', 1, 0, '', NULL, NULL, NULL),
(62571, '2018-02-02 12:25:45', NULL, NULL, 16563, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 12:25:45', 'admin-1517534180-15175455455563679', 1, 1, 'SR', NULL, NULL, NULL),
(62572, '2018-02-02 11:55:13', NULL, NULL, 16562, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 11:55:13', 'admin-1517534180-15175437131072474', 1, 0, '', NULL, NULL, NULL),
(62573, '2018-02-02 11:55:13', NULL, NULL, 16562, 0, 153, '87', 'Wake Me Up!', 'no toast', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 11:55:13', 'admin-1517534180-15175437131072474', 1, 0, '', NULL, NULL, NULL),
(62574, '2018-02-02 11:10:59', NULL, NULL, 16556, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 11:10:59', 'admin-1517534180-15175410592857674', 1, 1, 'SR', NULL, NULL, NULL),
(62575, '2018-02-02 12:25:19', NULL, NULL, 16563, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1517534180', 'admin', '2018-02-02 12:25:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62576, '2018-02-02 12:19:22', NULL, NULL, 16560, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 12:19:22', 'admin-1517534180-15175451626918273', 1, 1, 'SR', NULL, NULL, NULL),
(62577, '2018-02-02 11:54:53', NULL, NULL, 16562, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1517534180', 'admin', '2018-02-02 11:54:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62578, '2018-02-02 11:55:13', NULL, NULL, 16562, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 11:55:13', 'admin-1517534180-15175437131072474', 1, 1, 'SR', NULL, NULL, NULL),
(62579, '2018-02-02 11:52:23', NULL, NULL, 16561, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 11:52:23', 'admin-1517534180-15175435435408970', 1, 1, 'SR', NULL, NULL, NULL),
(62580, '2018-02-02 11:52:23', NULL, NULL, 16561, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 11:52:23', 'admin-1517534180-15175435435408970', 1, 1, 'SR', NULL, NULL, NULL),
(62581, '2018-02-02 11:52:18', NULL, NULL, 16561, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1517534180', 'admin', '2018-02-02 11:52:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62582, '2018-02-02 11:52:10', NULL, NULL, 16560, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 11:52:10', 'admin-1517534180-15175435302997341', 1, 1, 'SR', NULL, NULL, NULL),
(62583, '2018-02-02 11:39:10', NULL, NULL, 16559, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1517534180', 'admin', '2018-02-02 11:39:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62584, '2018-02-02 11:39:44', NULL, NULL, 16559, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 11:39:44', 'admin-1517534180-15175427843241024', 1, 0, '', NULL, NULL, NULL),
(62585, '2018-02-02 00:00:00', NULL, NULL, 16566, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 11:36:48', 'admin-1517534180-15175426088105574', 1, 1, 'SR', NULL, NULL, NULL),
(62586, '2018-02-02 00:00:00', NULL, NULL, 16565, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 11:36:48', 'admin-1517534180-15175426088105574', 1, 1, 'SR', NULL, NULL, NULL),
(62587, '2018-02-02 12:37:28', NULL, NULL, 16565, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1517534180', 'admin', '2018-02-02 12:37:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62588, '2018-02-02 00:00:00', NULL, NULL, 16566, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', NULL, 1, 2.30, NULL, NULL, 2.30, 1, '27', 1, '1517534180', 'admin', '2018-02-02 11:35:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62589, '2018-02-02 09:16:40', NULL, NULL, 16554, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 09:16:40', 'admin-1517534180-1517534199910602', 1, 0, '', NULL, NULL, NULL),
(62590, '2018-02-02 09:16:40', NULL, NULL, 16554, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 09:16:40', 'admin-1517534180-1517534199910602', 1, 0, '', NULL, NULL, NULL),
(62591, '2018-02-02 09:30:36', NULL, NULL, 16555, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1517534180', 'admin', '2018-02-02 09:30:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62592, '2018-02-02 09:30:43', NULL, NULL, 16555, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 09:30:43', 'admin-1517534180-15175350434328828', 1, 0, '', NULL, NULL, NULL),
(62593, '2018-02-02 15:26:15', NULL, NULL, 16582, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1517534180', 'admin', '2018-02-02 15:26:15', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(62594, '2018-02-02 09:16:40', NULL, NULL, 16554, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 09:16:40', 'admin-1517534180-1517534199910602', 1, 0, '', NULL, NULL, NULL),
(62595, '2018-02-02 09:33:59', NULL, NULL, 16556, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 09:33:59', 'admin-1517534180-15175352393413470', 1, 1, 'SR', NULL, NULL, NULL),
(62596, '2018-02-02 09:33:56', NULL, NULL, 16556, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1517534180', 'admin', '2018-02-02 09:33:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62597, '2018-02-02 09:30:43', NULL, NULL, 16555, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517534180', 'admin', '2018-02-02 09:30:43', 'admin-1517534180-15175350434328828', 1, 1, 'SR', NULL, NULL, NULL),
(62598, '2018-02-02 09:16:28', NULL, NULL, 16554, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1517534180', 'admin', '2018-02-02 09:16:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62599, '2018-02-03 12:37:31', NULL, NULL, 16610, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 12:37:31', 'admin-1517620364-15176326517394421', 1, 0, '', NULL, NULL, NULL),
(62600, '2018-02-03 12:37:31', NULL, NULL, 16610, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 12:37:31', 'admin-1517620364-15176326517394421', 1, 1, 'SR', NULL, NULL, NULL),
(62601, '2018-02-03 12:00:12', NULL, NULL, 16604, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1517620364', 'admin', '2018-02-03 12:00:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62602, '2018-02-03 11:07:17', NULL, NULL, 16601, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:07:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62603, '2018-02-03 10:45:48', NULL, NULL, 16597, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:45:48', 'admin-1517620364-1517625948796310', 1, 1, 'SR', NULL, NULL, NULL),
(62604, '2018-02-03 10:45:48', NULL, NULL, 16597, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:45:48', 'admin-1517620364-1517625948796310', 1, 0, '', NULL, NULL, NULL),
(62605, '2018-02-03 10:45:48', NULL, NULL, 16597, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:45:48', 'admin-1517620364-1517625948796310', 1, 0, '', NULL, NULL, NULL),
(62606, '2018-02-03 16:53:07', NULL, NULL, 16624, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1517620364', 'admin', '2018-02-03 16:53:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62607, '2018-02-03 16:21:58', NULL, NULL, 16623, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 16:21:58', 'admin-1517620364-15176461180793825', 1, 0, '', NULL, NULL, NULL),
(62608, '2018-02-03 14:10:26', NULL, NULL, 16618, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1517620364', 'admin', '2018-02-03 14:10:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62609, '2018-02-03 16:21:58', NULL, NULL, 16623, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 16:21:58', 'admin-1517620364-15176461180793825', 1, 0, '', NULL, NULL, NULL),
(62610, '2018-02-03 16:21:48', NULL, NULL, 16623, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1517620364', 'admin', '2018-02-03 16:21:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62611, '2018-02-03 15:16:33', NULL, NULL, 16622, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 15:16:33', 'admin-1517620364-15176421937871655', 1, 1, 'SR', NULL, NULL, NULL),
(62612, '2018-02-03 15:16:33', NULL, NULL, 16622, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 15:16:33', 'admin-1517620364-15176421937871655', 1, 1, 'SR', NULL, NULL, NULL),
(62613, '2018-02-03 13:16:56', NULL, NULL, 16611, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:16:56', 'admin-1517620364-15176350167613798', 1, 1, 'SR', NULL, NULL, NULL),
(62614, '2018-02-03 15:15:00', NULL, NULL, 16621, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 15:15:00', 'admin-1517620364-15176421005479769', 1, 0, '', NULL, NULL, NULL),
(62615, '2018-02-03 15:15:00', NULL, NULL, 16621, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 15:15:00', 'admin-1517620364-15176421005479769', 1, 0, '', NULL, NULL, NULL),
(62616, '2018-02-03 13:24:59', NULL, NULL, 16613, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:24:59', 'admin-1517620364-15176354995283152', 1, 0, '', NULL, NULL, NULL),
(62617, '2018-02-03 13:25:31', NULL, NULL, 16613, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:25:31', 'admin-1517620364-15176355309651351', 1, 0, '', NULL, NULL, NULL),
(62618, '2018-02-03 15:14:41', NULL, NULL, 16621, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1517620364', 'admin', '2018-02-03 15:14:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62619, '2018-02-03 11:53:19', NULL, NULL, 16603, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:53:19', 'admin-1517620364-15176299992156391', 1, 0, '', NULL, NULL, NULL),
(62620, '2018-02-03 15:00:58', NULL, NULL, 16620, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 15:00:58', 'admin-1517620364-15176412579054186', 1, 1, 'SR', NULL, NULL, NULL),
(62621, '2018-02-03 14:52:49', NULL, NULL, 16615, 0, 182, '117', 'Open Drinks ', 'esp beans', 'Cold Drinks', 'Fresh Juice', 1, 38.00, 38.0000, 0.0000, 38.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 14:52:49', 'admin-1517620364-1517640769091631', 1, 0, '', NULL, NULL, NULL),
(62622, '2018-02-03 14:34:54', NULL, NULL, 16620, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 14:34:54', 'admin-1517620364-15176396939605313', 1, 0, '', NULL, NULL, NULL),
(62623, '2018-02-03 14:34:54', NULL, NULL, 16620, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 14:34:54', 'admin-1517620364-15176396939605313', 1, 0, '', NULL, NULL, NULL),
(62624, '2018-02-03 14:34:54', NULL, NULL, 16620, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 14:34:54', 'admin-1517620364-15176396939605313', 1, 1, 'SR', NULL, NULL, NULL),
(62625, '2018-02-03 14:34:54', NULL, NULL, 16620, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 14:34:54', 'admin-1517620364-15176396939605313', 1, 1, 'SR', NULL, NULL, NULL),
(62626, '2018-02-03 14:34:45', NULL, NULL, 16620, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1517620364', 'admin', '2018-02-03 14:34:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62627, '2018-02-03 14:33:36', NULL, NULL, 16619, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 14:33:36', 'admin-1517620364-15176396158989953', 1, 1, 'SR', 1, NULL, '10.0'),
(62628, '2018-02-03 14:33:36', NULL, NULL, 16619, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 14:33:36', 'admin-1517620364-15176396158989953', 1, 1, 'SR', 1, NULL, '10.0'),
(62629, '2018-02-03 14:17:43', NULL, NULL, 16616, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 14:17:43', 'admin-1517620364-1517638662996579', 1, 0, '', NULL, NULL, NULL),
(62630, '2018-02-03 14:10:34', NULL, NULL, 16618, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 14:10:34', 'admin-1517620364-15176382346461689', 1, 1, 'SR', NULL, NULL, NULL),
(62631, '2018-02-03 14:10:34', NULL, NULL, 16618, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 14:10:34', 'admin-1517620364-15176382346461689', 1, 1, 'SR', NULL, NULL, NULL),
(62632, '2018-02-03 13:42:49', NULL, NULL, 16614, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:42:49', 'admin-1517620364-1517636569639780', 1, 0, '', NULL, NULL, NULL),
(62633, '2018-02-03 13:42:49', NULL, NULL, 16614, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:42:49', 'admin-1517620364-1517636569639780', 1, 1, 'SR', NULL, NULL, NULL),
(62634, '2018-02-03 13:54:51', NULL, NULL, 16615, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.76, 0.0000, 0.0000, 6.76, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:54:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62635, '2018-02-03 13:24:59', NULL, NULL, 16613, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:24:59', 'admin-1517620364-15176354995283152', 1, 0, '', NULL, NULL, NULL),
(62636, '2018-02-03 13:24:59', NULL, NULL, 16613, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:24:59', 'admin-1517620364-15176354995283152', 1, 0, '', NULL, NULL, NULL),
(62637, '2018-02-03 13:24:59', NULL, NULL, 16613, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:24:59', 'admin-1517620364-15176354995283152', 1, 0, '', NULL, NULL, NULL),
(62638, '2018-02-03 11:29:39', NULL, NULL, 16602, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:29:39', 'admin-1517620364-15176285788795471', 1, 1, 'SR', NULL, NULL, NULL),
(62639, '2018-02-03 11:29:39', NULL, NULL, 16602, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:29:39', 'admin-1517620364-15176285788795471', 1, 1, 'SR', NULL, NULL, NULL),
(62640, '2018-02-03 11:29:29', NULL, NULL, 16602, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:29:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62641, '2018-02-03 10:28:32', NULL, NULL, 16593, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:28:32', 'admin-1517620364-1517624911962486', 1, 0, '', NULL, NULL, NULL),
(62642, '2018-02-03 10:29:50', NULL, NULL, 16594, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:29:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62643, '2018-02-03 13:24:27', NULL, NULL, 16613, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 15.60, 0.0000, 0.0000, 15.60, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:24:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62644, '2018-02-03 11:07:45', NULL, NULL, 16601, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:07:45', 'admin-1517620364-15176272653942544', 1, 0, '', NULL, NULL, NULL),
(62645, '2018-02-03 11:14:40', NULL, NULL, 16594, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:14:40', 'admin-1517620364-15176276803778172', 1, 1, 'SR', NULL, NULL, NULL),
(62646, '2018-02-03 10:34:27', NULL, NULL, 16593, 0, 181, '116', 'Open Food ', 'add bacon', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:34:27', 'admin-1517620364-15176252669711566', 1, 0, '', NULL, NULL, NULL),
(62647, '2018-02-03 10:39:53', NULL, NULL, 16596, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:39:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62648, '2018-02-03 14:03:18', NULL, NULL, 16615, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 14:03:18', 'admin-1517620364-15176377980458934', 1, 1, 'SR', NULL, NULL, NULL),
(62649, '2018-02-03 13:56:43', NULL, NULL, 16615, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:56:43', 'admin-1517620364-15176374037264341', 1, 0, '', NULL, '20.0', NULL),
(62650, '2018-02-03 14:02:42', NULL, NULL, 16617, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1517620364', 'admin', '2018-02-03 14:02:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62651, '2018-02-03 14:02:46', NULL, NULL, 16617, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 14:02:46', 'admin-1517620364-15176377665132497', 1, 1, 'SR', NULL, NULL, NULL),
(62652, '2018-02-03 11:00:39', NULL, NULL, 16598, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:00:39', 'admin-1517620364-15176268390701770', 1, 0, '', NULL, NULL, NULL),
(62653, '2018-02-03 10:14:55', NULL, NULL, 16591, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:14:55', 'admin-1517620364-15176240954101084', 1, 0, '', NULL, NULL, NULL),
(62654, '2018-02-03 13:56:33', NULL, NULL, 16616, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:56:33', 'admin-1517620364-15176373934339754', 1, 1, 'SR', NULL, NULL, NULL),
(62655, '2018-02-03 13:56:33', NULL, NULL, 16616, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:56:33', 'admin-1517620364-15176373934339754', 1, 1, 'SR', NULL, NULL, NULL),
(62656, '2018-02-03 12:25:00', NULL, NULL, 16608, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 12:25:00', 'admin-1517620364-15176319000368023', 1, 0, '', NULL, NULL, NULL),
(62657, '2018-02-03 13:14:34', NULL, NULL, 16612, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:14:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62658, '2018-02-03 13:14:28', NULL, NULL, 16611, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:14:28', 'admin-1517620364-15176348684311390', 1, 1, 'SR', NULL, NULL, NULL),
(62659, '2018-02-03 13:56:15', NULL, NULL, 16616, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:56:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62660, '2018-02-03 11:07:45', NULL, NULL, 16601, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:07:45', 'admin-1517620364-15176272653942544', 1, 0, '', NULL, NULL, NULL),
(62661, '2018-02-03 12:28:44', NULL, NULL, 16609, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1517620364', 'admin', '2018-02-03 12:28:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62662, '2018-02-03 12:28:49', NULL, NULL, 16609, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 12:28:49', 'admin-1517620364-15176321292223125', 1, 0, '', NULL, NULL, NULL),
(62663, '2018-02-03 13:56:33', NULL, NULL, 16616, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:56:33', 'admin-1517620364-15176373934339754', 1, 1, 'SR', NULL, NULL, NULL),
(62664, '2018-02-03 13:56:33', NULL, NULL, 16616, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:56:33', 'admin-1517620364-15176373934339754', 1, 1, 'SR', NULL, NULL, NULL),
(62665, '2018-02-03 10:16:53', NULL, NULL, 16592, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:16:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62666, '2018-02-03 17:02:16', NULL, NULL, 16625, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 17:02:16', 'admin-1517620364-15176485361319956', 1, 0, '', NULL, NULL, NULL),
(62667, '2018-02-03 17:02:16', NULL, NULL, 16625, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 17:02:16', 'admin-1517620364-15176485361319956', 1, 1, 'SR', NULL, NULL, NULL),
(62668, '2018-02-03 17:02:07', NULL, NULL, 16625, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1517620364', 'admin', '2018-02-03 17:02:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62669, '2018-02-03 16:53:14', NULL, NULL, 16624, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 16:53:14', 'admin-1517620364-15176479942322163', 1, 1, 'SR', NULL, NULL, NULL),
(62670, '2018-02-03 16:53:14', NULL, NULL, 16624, 0, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 16:53:14', 'admin-1517620364-15176479942322163', 1, 1, 'SR', NULL, NULL, NULL),
(62671, '2018-02-03 13:07:36', NULL, NULL, 16611, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:07:36', 'admin-1517620364-15176344564881697', 1, 1, 'SR', NULL, NULL, NULL),
(62672, '2018-02-03 13:07:36', NULL, NULL, 16611, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:07:36', 'admin-1517620364-15176344564881697', 1, 0, '', NULL, NULL, NULL),
(62673, '2018-02-03 13:07:36', NULL, NULL, 16611, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:07:36', 'admin-1517620364-15176344564881697', 1, 1, 'SR', NULL, NULL, NULL),
(62674, '2018-02-03 13:07:13', NULL, NULL, 16611, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.20, 0.0000, 0.0000, 10.20, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:07:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62675, '2018-02-03 13:55:33', NULL, NULL, 16615, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:55:33', 'admin-1517620364-15176373335698115', 1, 1, 'SR', NULL, NULL, NULL),
(62676, '2018-02-03 13:42:37', NULL, NULL, 16614, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:42:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62677, '2018-02-03 13:25:31', NULL, NULL, 16613, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:25:31', 'admin-1517620364-15176355309651351', 1, 1, 'SR', NULL, NULL, NULL),
(62678, '2018-02-03 13:25:31', NULL, NULL, 16613, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:25:31', 'admin-1517620364-15176355309651351', 1, 0, '', NULL, NULL, NULL),
(62679, '2018-02-03 13:14:28', NULL, NULL, 16611, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:14:28', 'admin-1517620364-15176348684311390', 1, 0, '', NULL, NULL, NULL),
(62680, '2018-02-03 12:37:31', NULL, NULL, 16610, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 12:37:31', 'admin-1517620364-15176326517394421', 1, 0, '', NULL, NULL, NULL),
(62681, '2018-02-03 13:25:31', NULL, NULL, 16613, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:25:31', 'admin-1517620364-15176355309651351', 1, 1, 'SR', NULL, NULL, NULL),
(62682, '2018-02-03 13:14:41', NULL, NULL, 16612, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:14:41', 'admin-1517620364-1517634881437141', 1, 0, '', NULL, NULL, NULL),
(62683, '2018-02-03 12:36:42', NULL, NULL, 16610, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1517620364', 'admin', '2018-02-03 12:36:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62684, '2018-02-03 13:14:41', NULL, NULL, 16612, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:14:41', 'admin-1517620364-1517634881437141', 1, 1, 'SR', NULL, NULL, NULL),
(62685, '2018-02-03 12:25:00', NULL, NULL, 16608, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 12:25:00', 'admin-1517620364-15176319000368023', 1, 1, 'SR', NULL, NULL, NULL),
(62686, '2018-02-03 12:24:45', NULL, NULL, 16608, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1517620364', 'admin', '2018-02-03 12:24:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62687, '2018-02-03 12:05:39', NULL, NULL, 16606, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 12:05:39', 'admin-1517620364-15176307392965034', 1, 1, 'SR', NULL, NULL, NULL),
(62688, '2018-02-03 12:13:49', NULL, NULL, 16607, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 12:13:49', 'admin-1517620364-15176312295295755', 1, 1, 'SR', NULL, NULL, NULL),
(62689, '2018-02-03 12:11:59', NULL, NULL, 16606, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 12:11:59', 'admin-1517620364-15176311191275131', 1, 1, 'SR', NULL, NULL, NULL),
(62690, '2018-02-03 12:13:40', NULL, NULL, 16607, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1517620364', 'admin', '2018-02-03 12:13:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62691, '2018-02-03 13:05:48', NULL, NULL, 16606, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:05:48', 'admin-1517620364-15176343485739969', 1, 0, '', NULL, NULL, NULL),
(62692, '2018-02-03 12:13:49', NULL, NULL, 16607, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 12:13:49', 'admin-1517620364-15176312295295755', 1, 0, '', NULL, NULL, NULL),
(62693, '2018-02-03 00:00:00', NULL, NULL, 16605, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:05:14', 'admin-1517620364-15176271140321342', 1, 0, '', NULL, NULL, NULL),
(62694, '2018-02-03 12:13:49', NULL, NULL, 16607, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 12:13:49', 'admin-1517620364-15176312295295755', 1, 0, '', NULL, NULL, NULL),
(62695, '2018-02-03 12:07:49', NULL, NULL, 16606, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 12:07:49', 'admin-1517620364-15176308691334972', 1, 1, 'SR', NULL, NULL, NULL),
(62696, '2018-02-03 12:07:49', NULL, NULL, 16606, 0, 181, '116', 'Open Food ', 'Rice', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 12:07:49', 'admin-1517620364-15176308691334972', 1, 0, '', NULL, NULL, NULL),
(62697, '2018-02-03 11:01:06', NULL, NULL, 16599, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:01:06', 'admin-1517620364-15176268665451588', 1, 1, 'SR', NULL, NULL, NULL),
(62698, '2018-02-03 00:00:00', NULL, NULL, 16604, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:05:14', 'admin-1517620364-15176271140321342', 1, 1, 'SR', NULL, NULL, NULL),
(62699, '2018-02-03 12:05:24', NULL, NULL, 16606, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1517620364', 'admin', '2018-02-03 12:05:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62700, '2018-02-03 09:52:07', NULL, NULL, 16589, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:52:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62701, '2018-02-03 09:52:16', NULL, NULL, 16589, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:52:16', 'admin-1517620364-15176227362349924', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(62702, '2018-02-03 09:52:16', NULL, NULL, 16589, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:52:16', 'admin-1517620364-15176227362349924', 1, 0, '', NULL, NULL, NULL),
(62703, '2018-02-03 15:16:17', NULL, NULL, 16622, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1517620364', 'admin', '2018-02-03 15:16:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62704, '2018-02-03 11:53:19', NULL, NULL, 16603, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:53:19', 'admin-1517620364-15176299992156391', 1, 1, 'SR', NULL, NULL, NULL),
(62705, '2018-02-03 11:53:19', NULL, NULL, 16603, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:53:19', 'admin-1517620364-15176299992156391', 1, 0, '', NULL, NULL, NULL),
(62706, '2018-02-03 00:00:00', NULL, NULL, 16605, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', NULL, 1, 1.10, NULL, NULL, 1.10, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:04:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62707, '2018-02-03 10:40:00', NULL, NULL, 16596, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:40:00', 'admin-1517620364-15176256000458259', 1, 0, '', NULL, NULL, NULL),
(62708, '2018-02-03 11:53:19', NULL, NULL, 16603, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:53:19', 'admin-1517620364-15176299992156391', 1, 0, '', NULL, NULL, NULL),
(62709, '2018-02-03 11:29:39', NULL, NULL, 16602, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:29:39', 'admin-1517620364-15176285788795471', 1, 1, 'SR', NULL, NULL, NULL),
(62710, '2018-02-03 11:53:04', NULL, NULL, 16603, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.20, 0.0000, 0.0000, 9.20, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:53:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62711, '2018-02-03 11:53:19', NULL, NULL, 16603, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:53:19', 'admin-1517620364-15176299992156391', 1, 0, '', NULL, NULL, NULL),
(62712, '2018-02-03 13:25:31', NULL, NULL, 16613, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:25:31', 'admin-1517620364-15176355309651351', 1, 1, 'SR', NULL, NULL, NULL),
(62713, '2018-02-03 11:00:39', NULL, NULL, 16598, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:00:39', 'admin-1517620364-15176268390701770', 1, 1, 'SR', NULL, NULL, NULL),
(62714, '2018-02-03 11:01:06', NULL, NULL, 16599, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:01:06', 'admin-1517620364-15176268665451588', 1, 0, '', NULL, NULL, NULL),
(62715, '2018-02-03 11:01:06', NULL, NULL, 16599, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:01:06', 'admin-1517620364-15176268665451588', 1, 0, '', NULL, NULL, NULL),
(62716, '2018-02-03 11:00:52', NULL, NULL, 16599, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:00:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62717, '2018-02-03 10:59:51', NULL, NULL, 16598, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:59:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62718, '2018-02-03 11:00:39', NULL, NULL, 16598, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:00:39', 'admin-1517620364-15176268390701770', 1, 0, '', NULL, NULL, NULL),
(62719, '2018-02-03 11:00:39', NULL, NULL, 16598, 0, 336, '272', 'iced Yuzu', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:00:39', 'admin-1517620364-15176268390701770', 1, 0, '', NULL, NULL, NULL),
(62720, '2018-02-03 09:14:34', NULL, NULL, 16585, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:14:34', 'admin-1517620364-15176204740306785', 1, 1, 'SR', NULL, NULL, NULL),
(62721, '2018-02-03 13:16:56', NULL, NULL, 16611, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:16:56', 'admin-1517620364-15176350167613798', 1, 0, '', NULL, NULL, NULL),
(62722, '2018-02-03 11:07:45', NULL, NULL, 16601, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:07:45', 'admin-1517620364-15176272653942544', 1, 0, '', NULL, NULL, NULL),
(62723, '2018-02-03 11:00:39', NULL, NULL, 16598, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:00:39', 'admin-1517620364-15176268390701770', 1, 1, 'SR', NULL, NULL, NULL),
(62724, '2018-02-03 11:00:39', NULL, NULL, 16598, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:00:39', 'admin-1517620364-15176268390701770', 1, 1, 'SR', NULL, NULL, NULL),
(62725, '2018-02-03 11:00:39', NULL, NULL, 16598, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:00:39', 'admin-1517620364-15176268390701770', 1, 1, 'SR', NULL, NULL, NULL),
(62726, '2018-02-03 10:33:32', NULL, NULL, 16593, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:33:32', 'admin-1517620364-15176252122931974', 1, 1, 'SR', NULL, NULL, NULL),
(62727, '2018-02-03 10:33:32', NULL, NULL, 16593, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:33:32', 'admin-1517620364-15176252122931974', 1, 1, 'SR', NULL, NULL, NULL),
(62728, '2018-02-03 11:29:39', NULL, NULL, 16602, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:29:39', 'admin-1517620364-15176285788795471', 1, 1, 'SR', NULL, NULL, NULL),
(62729, '2018-02-03 10:40:00', NULL, NULL, 16596, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:40:00', 'admin-1517620364-15176256000458259', 1, 0, '', NULL, NULL, NULL),
(62730, '2018-02-03 10:45:30', NULL, NULL, 16597, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:45:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62731, '2018-02-03 10:33:32', NULL, NULL, 16593, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:33:32', 'admin-1517620364-15176252122931974', 1, 0, '', NULL, NULL, NULL),
(62732, '2018-02-03 10:33:32', NULL, NULL, 16593, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:33:32', 'admin-1517620364-15176252122931974', 1, 0, '', NULL, NULL, NULL),
(62733, '2018-02-03 10:33:08', NULL, NULL, 16595, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:33:08', 'admin-1517620364-15176251887702362', 1, 0, '', NULL, NULL, NULL),
(62734, '2018-02-03 13:07:36', NULL, NULL, 16611, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:07:36', 'admin-1517620364-15176344564881697', 1, 1, 'SR', NULL, NULL, NULL),
(62735, '2018-02-03 13:24:59', NULL, NULL, 16613, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 13:24:59', 'admin-1517620364-15176354995283152', 1, 0, '', NULL, NULL, NULL),
(62736, '2018-02-03 10:29:59', NULL, NULL, 16594, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:29:59', 'admin-1517620364-15176249988776441', 1, 1, 'SR', NULL, NULL, NULL),
(62737, '2018-02-03 10:33:08', NULL, NULL, 16595, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:33:08', 'admin-1517620364-15176251887702362', 1, 1, 'SR', NULL, NULL, NULL),
(62738, '2018-02-03 10:32:50', NULL, NULL, 16595, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:32:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62739, '2018-02-03 10:33:08', NULL, NULL, 16595, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:33:08', 'admin-1517620364-15176251887702362', 1, 0, '', NULL, NULL, NULL),
(62740, '2018-02-03 10:29:59', NULL, NULL, 16594, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:29:59', 'admin-1517620364-15176249988776441', 1, 0, '', NULL, NULL, NULL),
(62741, '2018-02-03 09:32:44', NULL, NULL, 16587, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:32:44', 'admin-1517620364-15176215645305242', 1, 0, '', NULL, NULL, NULL),
(62742, '2018-02-03 10:22:33', NULL, NULL, 16587, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:22:33', 'admin-1517620364-15176245536543577', 1, 0, '', NULL, NULL, NULL),
(62743, '2018-02-03 10:17:00', NULL, NULL, 16592, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:17:00', 'admin-1517620364-15176242202507794', 1, 0, '', NULL, NULL, NULL),
(62744, '2018-02-03 10:45:48', NULL, NULL, 16597, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:45:48', 'admin-1517620364-1517625948796310', 1, 1, 'SR', NULL, NULL, NULL),
(62745, '2018-02-03 10:28:26', NULL, NULL, 16593, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:28:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62746, '2018-02-03 10:09:18', NULL, NULL, 16590, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:09:18', 'admin-1517620364-15176237586483321', 1, 1, 'SR', NULL, NULL, NULL),
(62747, '2018-02-03 10:02:18', NULL, NULL, 16590, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:02:18', 'admin-1517620364-15176233379217077', 1, 0, '', NULL, NULL, NULL),
(62748, '2018-02-03 10:09:47', NULL, NULL, 16591, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:09:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62749, '2018-02-03 09:44:04', NULL, NULL, 16588, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:44:04', 'admin-1517620364-15176222447022572', 1, 0, '', NULL, NULL, NULL),
(62750, '2018-02-03 09:44:04', NULL, NULL, 16588, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:44:04', 'admin-1517620364-15176222447022572', 1, 0, '', NULL, NULL, NULL),
(62751, '2018-02-03 10:14:55', NULL, NULL, 16591, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:14:55', 'admin-1517620364-15176240954101084', 1, 0, '', NULL, NULL, NULL),
(62752, '2018-02-03 10:14:55', NULL, NULL, 16591, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:14:55', 'admin-1517620364-15176240954101084', 1, 1, 'SR', NULL, NULL, NULL),
(62753, '2018-02-03 10:10:02', NULL, NULL, 16591, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:10:02', 'admin-1517620364-15176238019986143', 1, 1, 'SR', NULL, NULL, NULL),
(62754, '2018-02-03 09:14:16', NULL, NULL, 16585, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:14:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62755, '2018-02-03 09:14:34', NULL, NULL, 16585, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:14:34', 'admin-1517620364-15176204740306785', 1, 0, '', NULL, NULL, NULL),
(62756, '2018-02-03 10:10:02', NULL, NULL, 16591, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:10:02', 'admin-1517620364-15176238019986143', 1, 0, '', NULL, NULL, NULL),
(62757, '2018-02-03 10:14:55', NULL, NULL, 16591, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:14:55', 'admin-1517620364-15176240954101084', 1, 1, 'SR', NULL, NULL, NULL),
(62758, '2018-02-03 10:02:18', NULL, NULL, 16590, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:02:18', 'admin-1517620364-15176233379217077', 1, 0, '', NULL, NULL, NULL),
(62759, '2018-02-03 10:02:18', NULL, NULL, 16590, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:02:18', 'admin-1517620364-15176233379217077', 1, 0, '', NULL, NULL, NULL),
(62760, '2018-02-03 10:33:08', NULL, NULL, 16595, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:33:08', 'admin-1517620364-15176251887702362', 1, 0, '', NULL, NULL, NULL),
(62761, '2018-02-03 09:44:04', NULL, NULL, 16588, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:44:04', 'admin-1517620364-15176222447022572', 1, 1, 'SR', NULL, NULL, NULL),
(62762, '2018-02-03 09:44:04', NULL, NULL, 16588, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:44:04', 'admin-1517620364-15176222447022572', 1, 0, '', NULL, NULL, NULL),
(62763, '2018-02-03 09:13:17', NULL, NULL, 16584, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 8.80, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:13:17', 'admin-1517620364-15176203968891825', 1, 1, 'SR', NULL, '20.0', NULL),
(62764, '2018-02-03 09:44:04', NULL, NULL, 16588, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:44:04', 'admin-1517620364-15176222447022572', 1, 1, 'SR', NULL, NULL, NULL),
(62765, '2018-02-03 09:44:04', NULL, NULL, 16588, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:44:04', 'admin-1517620364-15176222447022572', 1, 0, '', NULL, NULL, NULL),
(62766, '2018-02-03 09:44:04', NULL, NULL, 16588, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:44:04', 'admin-1517620364-15176222447022572', 1, 0, '', NULL, NULL, NULL),
(62767, '2018-02-03 09:44:04', NULL, NULL, 16588, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:44:04', 'admin-1517620364-15176222447022572', 1, 0, '', NULL, NULL, NULL),
(62768, '2018-02-03 09:43:44', NULL, NULL, 16588, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 13.30, 0.0000, 0.0000, 13.30, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:43:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62769, '2018-02-03 09:32:44', NULL, NULL, 16587, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:32:44', 'admin-1517620364-15176215645305242', 1, 1, 'SR', NULL, NULL, NULL),
(62770, '2018-02-03 09:32:29', NULL, NULL, 16587, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:32:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62771, '2018-02-03 09:32:44', NULL, NULL, 16587, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:32:44', 'admin-1517620364-15176215645305242', 1, 0, '', NULL, NULL, NULL),
(62772, '2018-02-03 09:21:33', NULL, NULL, 16586, 0, 336, '272', 'iced Yuzu', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:21:33', 'admin-1517620364-15176208933855030', 1, 0, '', NULL, NULL, NULL),
(62773, '2018-02-03 09:20:35', NULL, NULL, 16586, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:20:35', 'admin-1517620364-15176208357343258', 1, 0, '', NULL, NULL, NULL),
(62774, '2018-02-03 09:20:35', NULL, NULL, 16586, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:20:35', 'admin-1517620364-15176208357343258', 1, 0, '', NULL, NULL, NULL),
(62775, '2018-02-03 09:20:35', NULL, NULL, 16586, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:20:35', 'admin-1517620364-15176208357343258', 1, 0, '', NULL, NULL, NULL),
(62776, '2018-02-03 09:20:35', NULL, NULL, 16586, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:20:35', 'admin-1517620364-15176208357343258', 1, 0, '', NULL, NULL, NULL),
(62777, '2018-02-03 09:20:17', NULL, NULL, 16586, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:20:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62778, '2018-02-03 11:01:06', NULL, NULL, 16599, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 11:01:06', 'admin-1517620364-15176268665451588', 1, 0, '', NULL, NULL, NULL),
(62779, '2018-02-03 09:14:34', NULL, NULL, 16585, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:14:34', 'admin-1517620364-15176204740306785', 1, 1, 'SR', NULL, NULL, NULL),
(62780, '2018-02-03 10:02:06', NULL, NULL, 16590, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1517620364', 'admin', '2018-02-03 10:02:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62781, '2018-02-03 09:14:34', NULL, NULL, 16585, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:14:34', 'admin-1517620364-15176204740306785', 1, 0, '', NULL, NULL, NULL),
(62782, '2018-02-03 09:13:17', NULL, NULL, 16584, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:13:17', 'admin-1517620364-15176203968891825', 1, 1, 'SR', NULL, NULL, NULL),
(62783, '2018-02-03 09:13:17', NULL, NULL, 16584, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:13:17', 'admin-1517620364-15176203968891825', 1, 0, '', NULL, NULL, NULL),
(62784, '2018-02-03 09:13:17', NULL, NULL, 16584, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:13:17', 'admin-1517620364-15176203968891825', 1, 0, '', NULL, NULL, NULL),
(62785, '2018-02-03 09:13:17', NULL, NULL, 16584, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:13:17', 'admin-1517620364-15176203968891825', 1, 0, '', NULL, NULL, NULL),
(62786, '2018-02-03 09:13:02', NULL, NULL, 16584, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.88, 0.0000, 0.0000, 6.88, 1, '27', 1, '1517620364', 'admin', '2018-02-03 09:13:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62787, '2018-02-04 12:51:33', NULL, NULL, 16649, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:51:33', 'admin-1517707745-15177198930443247', 1, 1, 'SR', NULL, NULL, NULL),
(62788, '2018-02-04 14:55:35', NULL, NULL, 16662, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:55:35', 'admin-1517707745-15177273350355896', 1, 1, 'SR', NULL, NULL, NULL),
(62789, '2018-02-04 14:58:54', NULL, NULL, 16657, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:58:54', 'admin-1517707745-15177275338921781', 1, 0, '', NULL, NULL, NULL),
(62790, '2018-02-04 15:07:53', NULL, NULL, 16663, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1517707745', 'admin', '2018-02-04 15:07:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62791, '2018-02-04 13:24:07', NULL, NULL, 16654, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:24:07', 'admin-1517707745-15177218478168219', 1, 1, 'SR', NULL, NULL, '10.0'),
(62792, '2018-02-04 12:46:28', NULL, NULL, 16648, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:46:28', 'admin-1517707745-1517719587866674', 1, 1, 'SR', NULL, NULL, NULL),
(62793, '2018-02-04 12:49:05', NULL, NULL, 16647, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:49:05', 'admin-1517707745-15177197456217152', 1, 1, 'SR', NULL, NULL, NULL),
(62794, '2018-02-04 12:51:23', NULL, NULL, 16649, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:51:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62795, '2018-02-04 11:09:02', NULL, NULL, 16634, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:09:02', 'admin-1517707745-15177137418361360', 1, 1, 'SR', NULL, NULL, NULL),
(62796, '2018-02-04 11:09:02', NULL, NULL, 16634, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:09:02', 'admin-1517707745-15177137418361360', 1, 1, 'SR', NULL, NULL, NULL),
(62797, '2018-02-04 11:09:02', NULL, NULL, 16634, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:09:02', 'admin-1517707745-15177137418361360', 1, 1, 'SR', NULL, NULL, NULL),
(62798, '2018-02-04 11:09:02', NULL, NULL, 16634, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:09:02', 'admin-1517707745-15177137418361360', 1, 0, '', NULL, NULL, NULL),
(62799, '2018-02-04 14:51:17', NULL, NULL, 16661, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:51:17', 'admin-1517707745-15177270772939733', 1, 1, 'SR', NULL, NULL, NULL),
(62800, '2018-02-04 14:51:32', NULL, NULL, 16660, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:51:32', 'admin-1517707745-15177270920309917', 1, 1, 'SR', NULL, NULL, '10.0'),
(62801, '2018-02-04 12:33:37', NULL, NULL, 16644, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.50, 0.0000, 0.0000, 0.50, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:33:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62802, '2018-02-04 14:51:17', NULL, NULL, 16661, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:51:17', 'admin-1517707745-15177270772939733', 1, 0, '', NULL, NULL, NULL),
(62803, '2018-02-04 14:51:17', NULL, NULL, 16661, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:51:17', 'admin-1517707745-15177270772939733', 1, 0, '', NULL, NULL, NULL),
(62804, '2018-02-04 14:51:17', NULL, NULL, 16661, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:51:17', 'admin-1517707745-15177270772939733', 1, 0, '', NULL, NULL, NULL),
(62805, '2018-02-04 12:23:13', NULL, NULL, 16642, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:23:13', 'admin-1517707745-1517718193418934', 1, 1, 'SR', NULL, NULL, NULL),
(62806, '2018-02-04 11:54:19', NULL, NULL, 16634, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:54:19', 'admin-1517707745-1517716459390675', 1, 1, 'SR', NULL, NULL, NULL),
(62807, '2018-02-04 14:50:33', NULL, NULL, 16661, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:50:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62808, '2018-02-04 14:48:53', NULL, NULL, 16660, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:48:53', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(62809, '2018-02-04 14:49:11', NULL, NULL, 16660, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:49:11', 'admin-1517707745-15177269511082684', 1, 1, 'SR', NULL, NULL, '10.0'),
(62810, '2018-02-04 14:12:08', NULL, NULL, 16658, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:12:08', 'admin-1517707745-15177247280829856', 1, 1, 'SR', NULL, NULL, NULL),
(62811, '2018-02-04 13:56:56', NULL, NULL, 16656, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:56:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62812, '2018-02-04 11:28:21', NULL, NULL, 16636, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:28:21', 'admin-1517707745-1517714901740533', 1, 0, '', NULL, NULL, NULL),
(62813, '2018-02-04 11:28:21', NULL, NULL, 16636, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:28:21', 'admin-1517707745-1517714901740533', 1, 0, '', NULL, NULL, NULL),
(62814, '2018-02-04 16:37:54', NULL, NULL, 16664, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 16:37:54', 'admin-1517707745-15177334741825036', 1, 1, 'SR', 1, NULL, NULL),
(62815, '2018-02-04 15:08:05', NULL, NULL, 16663, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 15:08:05', 'admin-1517707745-15177280854798270', 1, 0, '', NULL, NULL, NULL),
(62816, '2018-02-04 14:44:00', NULL, NULL, 16649, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:44:00', 'admin-1517707745-15177266400182218', 1, 1, 'SR', NULL, NULL, NULL),
(62817, '2018-02-04 14:41:20', NULL, NULL, 16659, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:41:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62818, '2018-02-04 14:41:23', NULL, NULL, 16659, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:41:23', 'admin-1517707745-15177264834564241', 1, 1, 'SR', NULL, NULL, NULL),
(62819, '2018-02-04 14:12:23', NULL, NULL, 16656, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:12:23', 'admin-1517707745-15177247433246146', 1, 0, '', NULL, NULL, NULL),
(62820, '2018-02-04 14:12:23', NULL, NULL, 16656, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:12:23', 'admin-1517707745-15177247433246146', 1, 1, 'SR', NULL, NULL, NULL),
(62821, '2018-02-04 14:12:08', NULL, NULL, 16658, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:12:08', 'admin-1517707745-15177247280829856', 1, 1, 'SR', NULL, NULL, NULL),
(62822, '2018-02-04 14:12:08', NULL, NULL, 16658, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:12:08', 'admin-1517707745-15177247280829856', 1, 0, '', NULL, NULL, NULL),
(62823, '2018-02-04 14:16:52', NULL, NULL, 16658, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:16:52', 'admin-1517707745-15177250125657464', 1, 0, '', NULL, NULL, NULL),
(62824, '2018-02-04 13:28:26', NULL, NULL, 16654, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:28:26', 'admin-1517707745-15177221060243212', 1, 0, '', NULL, NULL, '10.0'),
(62825, '2018-02-04 13:33:15', NULL, NULL, 16649, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:33:15', 'admin-1517707745-15177223951239897', 1, 0, '', NULL, NULL, NULL),
(62826, '2018-02-04 13:11:19', NULL, NULL, 16652, 0, 181, '116', 'Open Food ', 'stamp', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:11:19', 'admin-1517707745-1517721079229131', 1, 0, '', 1, NULL, NULL),
(62827, '2018-02-04 12:53:21', NULL, NULL, 16641, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:53:21', 'admin-1517707745-15177200012563073', 1, 0, '', NULL, NULL, NULL),
(62828, '2018-02-04 12:56:02', NULL, NULL, 16647, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:56:02', 'admin-1517707745-1517720162071428', 1, 1, 'SR', NULL, NULL, NULL),
(62829, '2018-02-04 12:56:02', NULL, NULL, 16647, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:56:02', 'admin-1517707745-1517720162071428', 1, 1, 'SR', NULL, NULL, NULL),
(62830, '2018-02-04 12:59:00', NULL, NULL, 16650, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.16, 0.0000, 0.0000, 6.16, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:59:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62831, '2018-02-04 12:59:18', NULL, NULL, 16650, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:59:18', 'admin-1517707745-15177203585627816', 1, 0, '', NULL, NULL, NULL),
(62832, '2018-02-04 12:59:18', NULL, NULL, 16650, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:59:18', 'admin-1517707745-15177203585627816', 1, 0, '', NULL, NULL, NULL),
(62833, '2018-02-04 14:12:08', NULL, NULL, 16658, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:12:08', 'admin-1517707745-15177247280829856', 1, 0, '', NULL, NULL, NULL),
(62834, '2018-02-04 14:11:50', NULL, NULL, 16658, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:11:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62835, '2018-02-04 11:14:08', NULL, NULL, 16635, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 12.40, 0.0000, 0.0000, 12.40, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:14:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62836, '2018-02-04 11:15:31', NULL, NULL, 16635, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:15:31', 'admin-1517707745-15177141313688597', 1, 0, '', NULL, NULL, NULL),
(62837, '2018-02-04 12:45:47', NULL, NULL, 16648, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.50, 0.0000, 0.0000, 9.50, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:45:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62838, '2018-02-04 11:15:31', NULL, NULL, 16635, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:15:31', 'admin-1517707745-15177141313688597', 1, 1, 'SR', NULL, NULL, NULL),
(62839, '2018-02-04 11:15:31', NULL, NULL, 16635, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:15:31', 'admin-1517707745-15177141313688597', 1, 0, '', NULL, NULL, NULL),
(62840, '2018-02-04 11:44:46', NULL, NULL, 16637, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:44:46', 'admin-1517707745-15177158863842795', 1, 0, '', NULL, NULL, '10.0'),
(62841, '2018-02-04 11:44:46', NULL, NULL, 16637, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:44:46', 'admin-1517707745-15177158863842795', 1, 0, '', NULL, NULL, '10.0'),
(62842, '2018-02-04 14:05:14', NULL, NULL, 16657, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:05:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62843, '2018-02-04 13:57:06', NULL, NULL, 16656, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:57:06', 'admin-1517707745-15177238264381274', 1, 1, 'SR', NULL, NULL, NULL),
(62844, '2018-02-04 12:51:46', NULL, NULL, 16641, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:51:46', 'admin-1517707745-1517719906636579', 1, 1, 'SR', NULL, NULL, NULL),
(62845, '2018-02-04 12:52:34', NULL, NULL, 16647, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:52:34', 'admin-1517707745-15177199542754328', 1, 1, 'SR', NULL, NULL, NULL),
(62846, '2018-02-04 11:28:21', NULL, NULL, 16636, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:28:21', 'admin-1517707745-1517714901740533', 1, 0, '', NULL, NULL, NULL),
(62847, '2018-02-04 11:08:29', NULL, NULL, 16634, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:08:29', 'admin-1517707745-15177137092881595', 1, 0, '', NULL, NULL, NULL),
(62848, '2018-02-04 13:57:06', NULL, NULL, 16656, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:57:06', 'admin-1517707745-15177238264381274', 1, 1, 'SR', NULL, NULL, NULL),
(62849, '2018-02-04 15:08:05', NULL, NULL, 16663, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 15:08:05', 'admin-1517707745-15177280854798270', 1, 1, 'SR', NULL, NULL, NULL),
(62850, '2018-02-04 16:46:16', NULL, NULL, 16659, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 16:46:16', 'admin-1517707745-15177339760635785', 1, 1, 'SR', NULL, NULL, NULL),
(62851, '2018-02-04 13:33:43', NULL, NULL, 16655, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:33:43', 'admin-1517707745-15177224231641741', 1, 0, '', NULL, NULL, NULL),
(62852, '2018-02-04 12:46:27', NULL, NULL, 16648, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:46:28', 'admin-1517707745-1517719587866674', 1, 0, '', NULL, NULL, NULL),
(62853, '2018-02-04 11:28:21', NULL, NULL, 16636, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:28:21', 'admin-1517707745-1517714901740533', 1, 1, 'SR', NULL, NULL, NULL),
(62854, '2018-02-04 11:44:14', NULL, NULL, 16637, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 16.40, 0.0000, 0.0000, 16.40, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:44:14', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(62855, '2018-02-04 11:44:46', NULL, NULL, 16637, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 2, 21.00, 42.0000, 0.0000, 42.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:44:46', 'admin-1517707745-15177158863842795', 1, 0, '', NULL, NULL, '10.0'),
(62856, '2018-02-04 13:01:34', NULL, NULL, 16650, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 9.60, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:01:34', 'admin-1517707745-15177204941452569', 1, 0, '', NULL, '20.0', NULL),
(62857, '2018-02-04 12:59:18', NULL, NULL, 16650, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:59:18', 'admin-1517707745-15177203585627816', 1, 0, '', NULL, NULL, NULL),
(62858, '2018-02-04 13:34:21', NULL, NULL, 16649, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:34:21', 'admin-1517707745-15177224610049959', 1, 1, 'SR', NULL, NULL, NULL),
(62859, '2018-02-04 17:12:14', NULL, NULL, 16665, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 17:12:14', 'admin-1517707745-1517735533922939', 1, 1, 'SR', 1, NULL, '10.0'),
(62860, '2018-02-04 15:17:04', NULL, NULL, 16661, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 15:17:04', 'admin-1517707745-15177286248332839', 1, 1, 'SR', NULL, NULL, NULL),
(62861, '2018-02-04 12:46:28', NULL, NULL, 16648, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:46:28', 'admin-1517707745-1517719587866674', 1, 0, '', NULL, NULL, NULL),
(62862, '2018-02-04 11:28:21', NULL, NULL, 16636, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:28:21', 'admin-1517707745-1517714901740533', 1, 1, 'SR', NULL, NULL, NULL),
(62863, '2018-02-04 14:55:35', NULL, NULL, 16662, 0, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:55:35', 'admin-1517707745-15177273350355896', 1, 1, 'SR', NULL, NULL, NULL),
(62864, '2018-02-04 13:33:43', NULL, NULL, 16655, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:33:43', 'admin-1517707745-15177224231641741', 1, 1, 'SR', NULL, NULL, NULL),
(62865, '2018-02-04 13:24:07', NULL, NULL, 16654, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:24:07', 'admin-1517707745-15177218478168219', 1, 1, 'SR', NULL, NULL, '10.0'),
(62866, '2018-02-04 13:24:07', NULL, NULL, 16654, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:24:07', 'admin-1517707745-15177218478168219', 1, 1, 'SR', NULL, NULL, '10.0'),
(62867, '2018-02-04 13:24:07', NULL, NULL, 16654, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:24:07', 'admin-1517707745-15177218478168219', 1, 0, '', NULL, NULL, '10.0'),
(62868, '2018-02-04 13:24:07', NULL, NULL, 16654, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:24:07', 'admin-1517707745-15177218478168219', 1, 1, 'SR', NULL, NULL, '10.0'),
(62869, '2018-02-04 13:18:14', NULL, NULL, 16640, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:18:14', 'admin-1517707745-15177214946078766', 1, 1, 'SR', NULL, NULL, NULL),
(62870, '2018-02-04 13:18:14', NULL, NULL, 16640, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:18:14', 'admin-1517707745-15177214946078766', 1, 1, 'SR', NULL, NULL, NULL),
(62871, '2018-02-04 13:23:14', NULL, NULL, 16654, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:23:14', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(62872, '2018-02-04 13:12:47', NULL, NULL, 16653, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:12:47', 'admin-1517707745-15177211675295567', 1, 1, 'SR', 1, NULL, NULL),
(62873, '2018-02-04 13:08:02', NULL, NULL, 16651, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:08:02', 'admin-1517707745-15177208827399589', 1, 1, 'SR', NULL, NULL, NULL),
(62874, '2018-02-04 12:41:24', NULL, NULL, 16647, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:41:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62875, '2018-02-04 12:05:59', NULL, NULL, 16639, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:05:59', 'admin-1517707745-15177171597757558', 1, 0, '', NULL, NULL, NULL),
(62876, '2018-02-04 12:18:56', NULL, NULL, 16640, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:18:56', 'admin-1517707745-15177179365875935', 1, 0, '', NULL, NULL, NULL),
(62877, '2018-02-04 12:23:06', NULL, NULL, 16642, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:23:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62878, '2018-02-04 12:51:46', NULL, NULL, 16641, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:51:46', 'admin-1517707745-1517719906636579', 1, 1, 'SR', NULL, NULL, NULL),
(62879, '2018-02-04 12:46:28', NULL, NULL, 16648, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:46:28', 'admin-1517707745-1517719587866674', 1, 1, 'SR', NULL, NULL, NULL),
(62880, '2018-02-04 12:41:36', NULL, NULL, 16647, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:41:36', 'admin-1517707745-15177192960584097', 1, 1, 'SR', NULL, NULL, NULL),
(62881, '2018-02-04 13:07:55', NULL, NULL, 16651, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:07:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62882, '2018-02-04 12:51:33', NULL, NULL, 16649, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:51:33', 'admin-1517707745-15177198930443247', 1, 1, 'SR', NULL, NULL, NULL),
(62883, '2018-02-04 12:12:16', NULL, NULL, 16640, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.80, 0.0000, 0.0000, 9.80, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:12:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62884, '2018-02-04 12:46:27', NULL, NULL, 16648, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:46:27', 'admin-1517707745-1517719587866674', 1, 0, '', NULL, NULL, NULL),
(62885, '2018-02-04 12:46:27', NULL, NULL, 16648, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:46:27', 'admin-1517707745-1517719587866674', 1, 0, '', NULL, NULL, NULL),
(62886, '2018-02-04 12:37:19', NULL, NULL, 16646, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:37:19', 'admin-1517707745-1517719039104695', 1, 0, '', NULL, NULL, NULL),
(62887, '2018-02-04 11:52:00', NULL, NULL, 16636, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:52:00', 'admin-1517707745-15177163201391144', 1, 0, '', NULL, NULL, NULL),
(62888, '2018-02-04 14:05:28', NULL, NULL, 16657, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:05:28', 'admin-1517707745-15177243286959260', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(62889, '2018-02-04 12:41:36', NULL, NULL, 16647, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:41:36', 'admin-1517707745-15177192960584097', 1, 1, 'SR', NULL, NULL, NULL),
(62890, '2018-02-04 12:37:14', NULL, NULL, 16646, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:37:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62891, '2018-02-04 12:37:19', NULL, NULL, 16646, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:37:19', 'admin-1517707745-1517719039104695', 1, 0, '', NULL, NULL, NULL),
(62892, '2018-02-04 12:34:06', NULL, NULL, 16645, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:34:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62893, '2018-02-04 12:34:12', NULL, NULL, 16645, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:34:12', 'admin-1517707745-15177188522897283', 1, 1, 'SR', NULL, NULL, NULL),
(62894, '2018-02-04 09:47:50', NULL, NULL, 16628, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 09:47:50', 'admin-1517707745-15177088708038273', 1, 0, '', NULL, NULL, '10.0'),
(62895, '2018-02-04 12:29:29', NULL, NULL, 16643, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:29:29', 'admin-1517707745-15177185690424350', 1, 0, '', 1, NULL, NULL),
(62896, '2018-02-04 12:05:59', NULL, NULL, 16639, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:05:59', 'admin-1517707745-15177171597757558', 1, 1, 'SR', NULL, NULL, NULL),
(62897, '2018-02-04 12:31:37', NULL, NULL, 16642, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:31:37', 'admin-1517707745-1517718696920489', 1, 1, 'SR', NULL, NULL, NULL),
(62898, '2018-02-04 12:17:18', NULL, NULL, 16641, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:17:18', 'admin-1517707745-1517717838734938', 1, 0, '', NULL, NULL, NULL),
(62899, '2018-02-04 11:15:31', NULL, NULL, 16635, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:15:31', 'admin-1517707745-15177141313688597', 1, 0, '', NULL, NULL, NULL),
(62900, '2018-02-04 13:08:02', NULL, NULL, 16651, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:08:02', 'admin-1517707745-15177208827399589', 1, 1, 'SR', NULL, NULL, NULL),
(62901, '2018-02-04 12:12:29', NULL, NULL, 16640, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:12:29', 'admin-1517707745-15177175493357639', 1, 0, '', NULL, NULL, NULL),
(62902, '2018-02-04 12:17:06', NULL, NULL, 16641, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:17:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62903, '2018-02-04 11:44:46', NULL, NULL, 16637, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:44:46', 'admin-1517707745-15177158863842795', 1, 1, 'SR', NULL, NULL, '10.0'),
(62904, '2018-02-04 14:44:00', NULL, NULL, 16649, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:44:00', 'admin-1517707745-15177266400182218', 1, 1, 'SR', NULL, NULL, NULL),
(62905, '2018-02-04 12:12:29', NULL, NULL, 16640, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 2, 9.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:12:29', 'admin-1517707745-15177175493357639', 1, 1, 'SR', NULL, NULL, NULL),
(62906, '2018-02-04 12:12:29', NULL, NULL, 16640, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 9.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:12:29', 'admin-1517707745-15177175493357639', 1, 0, '', NULL, NULL, NULL),
(62907, '2018-02-04 11:44:46', NULL, NULL, 16637, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:44:46', 'admin-1517707745-15177158863842795', 1, 1, 'SR', NULL, NULL, '10.0'),
(62908, '2018-02-04 11:44:46', NULL, NULL, 16637, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:44:46', 'admin-1517707745-15177158863842795', 1, 1, 'SR', NULL, NULL, '10.0'),
(62909, '2018-02-04 14:55:12', NULL, NULL, 16662, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:55:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62910, '2018-02-04 11:48:09', NULL, NULL, 16638, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:48:09', 'admin-1517707745-151771608896867', 1, 0, '', NULL, NULL, NULL),
(62911, '2018-02-04 12:33:45', NULL, NULL, 16644, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:33:45', 'admin-1517707745-1517718825005588', 1, 1, 'SR', NULL, NULL, NULL),
(62912, '2018-02-04 12:05:59', NULL, NULL, 16639, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:05:59', 'admin-1517707745-15177171597757558', 1, 0, '', NULL, NULL, NULL),
(62913, '2018-02-04 12:05:59', NULL, NULL, 16639, 0, 159, '228', 'Yuzu Marmalade Yogurt Bowl', '', 'Desserts', '0', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:05:59', 'admin-1517707745-15177171597757558', 1, 0, '', NULL, NULL, NULL),
(62914, '2018-02-04 13:06:51', NULL, NULL, 16639, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:06:51', 'admin-1517707745-1517720811314357', 1, 0, '', NULL, NULL, NULL),
(62915, '2018-02-04 10:25:26', NULL, NULL, 16630, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:25:26', 'admin-1517707745-15177111262152284', 1, 1, 'SR', NULL, NULL, NULL),
(62916, '2018-02-04 12:05:34', NULL, NULL, 16639, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:05:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62917, '2018-02-04 11:54:19', NULL, NULL, 16634, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:54:19', 'admin-1517707745-1517716459390675', 1, 0, '', NULL, NULL, NULL),
(62918, '2018-02-04 12:17:18', NULL, NULL, 16641, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:17:18', 'admin-1517707745-1517717838734938', 1, 0, '', NULL, NULL, NULL),
(62919, '2018-02-04 11:54:19', NULL, NULL, 16634, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:54:19', 'admin-1517707745-1517716459390675', 1, 1, 'SR', NULL, NULL, NULL),
(62920, '2018-02-04 11:54:19', NULL, NULL, 16634, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:54:19', 'admin-1517707745-1517716459390675', 1, 1, 'SR', NULL, NULL, NULL),
(62921, '2018-02-04 14:49:11', NULL, NULL, 16660, 0, 181, '116', 'Open Food ', 'CNY Dumpling', 'Meals', 'Perfect Meals', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:49:11', 'admin-1517707745-15177269511082684', 1, 0, '', NULL, NULL, '10.0'),
(62922, '2018-02-04 11:52:41', NULL, NULL, 16638, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:52:41', 'admin-1517707745-15177163609504124', 1, 1, 'SR', NULL, NULL, NULL),
(62923, '2018-02-04 11:48:09', NULL, NULL, 16638, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:48:09', 'admin-1517707745-151771608896867', 1, 1, 'SR', NULL, NULL, NULL),
(62924, '2018-02-04 11:48:09', NULL, NULL, 16638, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:48:09', 'admin-1517707745-151771608896867', 1, 0, '', NULL, NULL, NULL),
(62925, '2018-02-04 11:48:00', NULL, NULL, 16638, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:48:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62926, '2018-02-04 11:54:19', NULL, NULL, 16634, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:54:19', 'admin-1517707745-1517716459390675', 1, 1, 'SR', NULL, NULL, NULL),
(62927, '2018-02-04 14:51:17', NULL, NULL, 16661, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:51:17', 'admin-1517707745-15177270772939733', 1, 1, 'SR', NULL, NULL, NULL),
(62928, '2018-02-04 12:17:18', NULL, NULL, 16641, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:17:18', 'admin-1517707745-1517717838734938', 1, 1, 'SR', NULL, NULL, NULL),
(62929, '2018-02-04 12:46:28', NULL, NULL, 16648, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 12:46:28', 'admin-1517707745-1517719587866674', 1, 1, 'SR', NULL, NULL, NULL),
(62930, '2018-02-04 11:44:46', NULL, NULL, 16637, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:44:46', 'admin-1517707745-15177158863842795', 1, 1, 'SR', NULL, NULL, '10.0'),
(62931, '2018-02-04 11:44:46', NULL, NULL, 16637, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:44:46', 'admin-1517707745-15177158863842795', 1, 0, '', NULL, NULL, '10.0'),
(62932, '2018-02-04 11:44:46', NULL, NULL, 16637, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:44:46', 'admin-1517707745-15177158863842795', 1, 0, '', NULL, NULL, '10.0'),
(62933, '2018-02-04 10:42:51', NULL, NULL, 16632, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:42:51', 'admin-1517707745-15177121709149833', 1, 1, 'SR', NULL, NULL, NULL),
(62934, '2018-02-04 10:42:51', NULL, NULL, 16632, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:42:51', 'admin-1517707745-15177121709149833', 1, 1, 'SR', NULL, NULL, NULL),
(62935, '2018-02-04 10:55:13', NULL, NULL, 16633, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:55:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62936, '2018-02-04 11:27:49', NULL, NULL, 16636, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.60, 0.0000, 0.0000, 9.60, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:27:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62937, '2018-02-04 11:15:31', NULL, NULL, 16635, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:15:31', 'admin-1517707745-15177141313688597', 1, 1, 'SR', NULL, NULL, NULL),
(62938, '2018-02-04 11:15:31', NULL, NULL, 16635, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:15:31', 'admin-1517707745-15177141313688597', 1, 1, 'SR', NULL, NULL, NULL),
(62939, '2018-02-04 11:15:31', NULL, NULL, 16635, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:15:31', 'admin-1517707745-15177141313688597', 1, 0, '', NULL, NULL, NULL),
(62940, '2018-02-04 10:25:26', NULL, NULL, 16630, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:25:26', 'admin-1517707745-15177111262152284', 1, 0, '', NULL, NULL, NULL),
(62941, '2018-02-04 10:25:26', NULL, NULL, 16630, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:25:26', 'admin-1517707745-15177111262152284', 1, 0, '', NULL, NULL, NULL),
(62942, '2018-02-04 11:07:50', NULL, NULL, 16634, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 26.80, 0.0000, 0.0000, 26.80, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:07:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62943, '2018-02-04 11:08:29', NULL, NULL, 16634, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:08:29', 'admin-1517707745-15177137092881595', 1, 0, '', NULL, NULL, NULL),
(62944, '2018-02-04 11:15:31', NULL, NULL, 16635, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:15:31', 'admin-1517707745-15177141313688597', 1, 0, '', NULL, NULL, NULL),
(62945, '2018-02-04 10:42:39', NULL, NULL, 16632, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:42:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62946, '2018-02-04 11:09:02', NULL, NULL, 16634, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:09:02', 'admin-1517707745-15177137418361360', 1, 1, 'SR', NULL, NULL, NULL),
(62947, '2018-02-04 11:09:01', NULL, NULL, 16634, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:09:01', 'admin-1517707745-15177137418361360', 1, 1, 'SR', NULL, NULL, NULL),
(62948, '2018-02-04 10:28:21', NULL, NULL, 16631, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:28:21', 'admin-1517707745-15177113011686796', 1, 0, '', NULL, NULL, NULL),
(62949, '2018-02-04 11:08:29', NULL, NULL, 16634, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:08:29', 'admin-1517707745-15177137092881595', 1, 0, '', NULL, NULL, NULL),
(62950, '2018-02-04 11:09:01', NULL, NULL, 16634, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:09:01', 'admin-1517707745-15177137418361360', 1, 1, 'SR', NULL, NULL, NULL),
(62951, '2018-02-04 11:44:46', NULL, NULL, 16637, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:44:46', 'admin-1517707745-15177158863842795', 1, 1, 'SR', NULL, NULL, '10.0'),
(62952, '2018-02-04 11:08:29', NULL, NULL, 16634, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:08:29', 'admin-1517707745-15177137092881595', 1, 0, '', NULL, NULL, NULL),
(62953, '2018-02-04 11:08:29', NULL, NULL, 16634, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:08:29', 'admin-1517707745-15177137092881595', 1, 0, '', NULL, NULL, NULL),
(62954, '2018-02-04 11:08:29', NULL, NULL, 16634, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:08:29', 'admin-1517707745-15177137092881595', 1, 0, '', NULL, NULL, NULL),
(62955, '2018-02-04 11:08:29', NULL, NULL, 16634, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:08:29', 'admin-1517707745-15177137092881595', 1, 0, '', NULL, NULL, NULL),
(62956, '2018-02-04 11:08:29', NULL, NULL, 16634, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:08:29', 'admin-1517707745-15177137092881595', 1, 0, '', NULL, NULL, NULL),
(62957, '2018-02-04 10:55:16', NULL, NULL, 16633, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:55:16', 'admin-1517707745-15177129164185086', 1, 1, 'SR', NULL, NULL, NULL),
(62958, '2018-02-04 10:55:16', NULL, NULL, 16633, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:55:16', 'admin-1517707745-15177129164185086', 1, 1, 'SR', NULL, NULL, NULL),
(62959, '2018-02-04 09:45:23', NULL, NULL, 16627, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 09:45:23', 'admin-1517707745-1517708722866991', 1, 1, 'SR', NULL, NULL, NULL),
(62960, '2018-02-04 10:42:51', NULL, NULL, 16632, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:42:51', 'admin-1517707745-15177121709149833', 1, 0, '', NULL, NULL, NULL),
(62961, '2018-02-04 09:36:15', NULL, NULL, 16626, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 09:36:15', 'admin-1517707745-15177081753883347', 1, 0, '', NULL, NULL, NULL),
(62962, '2018-02-04 09:36:15', NULL, NULL, 16626, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 09:36:15', 'admin-1517707745-15177081753883347', 1, 0, '', NULL, NULL, NULL),
(62963, '2018-02-04 14:05:28', NULL, NULL, 16657, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 14:05:28', 'admin-1517707745-15177243286959260', 1, 1, 'SR', NULL, NULL, NULL),
(62964, '2018-02-04 11:09:01', NULL, NULL, 16634, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 11:09:01', 'admin-1517707745-15177137418361360', 1, 1, 'SR', NULL, NULL, NULL),
(62965, '2018-02-04 10:28:21', NULL, NULL, 16631, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:28:21', 'admin-1517707745-15177113011686796', 1, 0, '', NULL, NULL, NULL),
(62966, '2018-02-04 10:28:21', NULL, NULL, 16631, 0, 304, '240', 'Banana is On Fire', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:28:21', 'admin-1517707745-15177113011686796', 1, 0, '', NULL, NULL, NULL),
(62967, '2018-02-04 10:28:21', NULL, NULL, 16631, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:28:21', 'admin-1517707745-15177113011686796', 1, 0, '', NULL, NULL, NULL),
(62968, '2018-02-04 10:28:21', NULL, NULL, 16631, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:28:21', 'admin-1517707745-15177113011686796', 1, 0, '', NULL, NULL, NULL),
(62969, '2018-02-04 10:28:21', NULL, NULL, 16631, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:28:21', 'admin-1517707745-15177113011686796', 1, 0, '', NULL, NULL, NULL),
(62970, '2018-02-04 10:28:21', NULL, NULL, 16631, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:28:21', 'admin-1517707745-15177113011686796', 1, 1, 'SR', NULL, NULL, NULL),
(62971, '2018-02-04 10:27:43', NULL, NULL, 16631, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.90, 0.0000, 0.0000, 10.90, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:27:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62972, '2018-02-04 10:28:21', NULL, NULL, 16631, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:28:21', 'admin-1517707745-15177113011686796', 1, 0, '', NULL, NULL, NULL),
(62973, '2018-02-04 10:25:26', NULL, NULL, 16630, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:25:26', 'admin-1517707745-15177111262152284', 1, 0, '', NULL, NULL, NULL),
(62974, '2018-02-04 10:25:26', NULL, NULL, 16630, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:25:26', 'admin-1517707745-15177111262152284', 1, 0, '', NULL, NULL, NULL),
(62975, '2018-02-04 10:14:44', NULL, NULL, 16627, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:14:44', 'admin-1517707745-1517710484633726', 1, 0, '', NULL, NULL, NULL),
(62976, '2018-02-04 10:25:10', NULL, NULL, 16630, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1517707745', 'admin', '2018-02-04 10:25:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62977, '2018-02-04 09:52:12', NULL, NULL, 16629, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 09:52:12', 'admin-1517707745-15177091328362478', 1, 0, '', NULL, NULL, NULL),
(62978, '2018-02-04 09:52:12', NULL, NULL, 16629, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 09:52:12', 'admin-1517707745-15177091328362478', 1, 1, 'SR', NULL, NULL, NULL),
(62979, '2018-02-04 09:52:01', NULL, NULL, 16629, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1517707745', 'admin', '2018-02-04 09:52:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62980, '2018-02-04 09:47:47', NULL, NULL, 16628, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1517707745', 'admin', '2018-02-04 09:47:47', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(62981, '2018-02-04 13:33:22', NULL, NULL, 16655, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1517707745', 'admin', '2018-02-04 13:33:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62982, '2018-02-04 09:51:16', NULL, NULL, 16628, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 09:51:16', 'admin-1517707745-15177090764573175', 1, 1, 'SR', NULL, NULL, '10.0'),
(62983, '2018-02-04 09:45:23', NULL, NULL, 16627, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 09:45:23', 'admin-1517707745-1517708722866991', 1, 0, '', NULL, NULL, NULL),
(62984, '2018-02-04 09:45:23', NULL, NULL, 16627, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 09:45:23', 'admin-1517707745-1517708722866991', 1, 0, '', NULL, NULL, NULL),
(62985, '2018-02-04 09:45:09', NULL, NULL, 16627, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1517707745', 'admin', '2018-02-04 09:45:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62986, '2018-02-04 09:36:15', NULL, NULL, 16626, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1517707745', 'admin', '2018-02-04 09:36:15', 'admin-1517707745-15177081753883347', 1, 1, 'SR', NULL, NULL, NULL),
(62987, '2018-02-04 09:34:06', NULL, NULL, 16626, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1517707745', 'admin', '2018-02-04 09:34:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62988, '2018-02-05 15:22:32', NULL, NULL, 16679, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 15:22:32', 'admin-1517793076-151781535236596', 1, 1, 'SR', NULL, NULL, NULL),
(62989, '2018-02-05 15:22:32', NULL, NULL, 16679, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 15:22:32', 'admin-1517793076-151781535236596', 1, 1, 'SR', NULL, NULL, NULL),
(62990, '2018-02-05 15:45:05', NULL, NULL, 16680, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1517793076', 'admin', '2018-02-05 15:45:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62991, '2018-02-05 15:45:10', NULL, NULL, 16680, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 15:45:10', 'admin-1517793076-15178167105499377', 1, 1, 'SR', NULL, NULL, NULL),
(62992, '2018-02-05 10:47:49', NULL, NULL, 16668, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 10:47:49', 'admin-1517793076-15177988691417918', 1, 0, '', NULL, NULL, NULL),
(62993, '2018-02-05 11:02:12', NULL, NULL, 16669, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 11:02:12', 'admin-1517793076-15177997323891145', 1, 0, '', NULL, NULL, NULL),
(62994, '2018-02-05 16:46:01', NULL, NULL, 16682, 0, 181, '116', 'Open Food ', 'cny DUMPLING', 'Meals', 'Perfect Meals', 1, 60.00, 60.0000, 0.0000, 60.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 16:46:01', 'admin-1517793076-15178203615216857', 1, 0, '', 1, NULL, NULL),
(62995, '2018-02-05 15:45:10', NULL, NULL, 16680, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 15:45:10', 'admin-1517793076-15178167105499377', 1, 1, 'SR', NULL, NULL, NULL),
(62996, '2018-02-05 16:38:14', NULL, NULL, 16681, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1517793076', 'admin', '2018-02-05 16:38:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(62997, '2018-02-05 16:38:17', NULL, NULL, 16681, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 16:38:17', 'admin-1517793076-15178198971881248', 1, 1, 'SR', NULL, NULL, NULL),
(62998, '2018-02-05 11:41:49', NULL, NULL, 16672, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 11:41:49', 'admin-1517793076-1517802109399320', 1, 0, '', NULL, NULL, NULL),
(62999, '2018-02-05 12:57:37', NULL, NULL, 16674, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 12:57:37', 'admin-1517793076-15178066577346050', 1, 1, 'SR', NULL, NULL, NULL),
(63000, '2018-02-05 12:58:09', NULL, NULL, 16675, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 12:58:09', 'admin-1517793076-15178066896368988', 1, 1, 'SR', 1, NULL, NULL),
(63001, '2018-02-05 12:58:09', NULL, NULL, 16675, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 12:58:09', 'admin-1517793076-15178066896368988', 1, 1, 'SR', 1, NULL, NULL),
(63002, '2018-02-05 10:47:49', NULL, NULL, 16668, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 10:47:49', 'admin-1517793076-15177988691417918', 1, 1, 'SR', NULL, NULL, NULL),
(63003, '2018-02-05 09:44:33', NULL, NULL, 16666, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 09:44:33', 'admin-1517793076-15177950728458957', 1, 0, '', NULL, NULL, NULL),
(63004, '2018-02-05 10:34:30', NULL, NULL, 16667, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 10:34:30', 'admin-1517793076-15177980702048859', 1, 1, 'SR', 1, NULL, '10.0'),
(63005, '2018-02-05 13:07:30', NULL, NULL, 16676, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1517793076', 'admin', '2018-02-05 13:07:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63006, '2018-02-05 13:07:33', NULL, NULL, 16676, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 13:07:33', 'admin-1517793076-15178072530157063', 1, 1, 'SR', NULL, NULL, NULL),
(63007, '2018-02-05 13:48:32', NULL, NULL, 16677, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1517793076', 'admin', '2018-02-05 13:48:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63008, '2018-02-05 13:48:35', NULL, NULL, 16677, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 13:48:35', 'admin-1517793076-15178097152789512', 1, 1, 'SR', NULL, NULL, NULL),
(63009, '2018-02-05 14:26:16', NULL, NULL, 16678, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 14:26:16', 'admin-1517793076-1517811976374329', 1, 1, 'SR', NULL, NULL, NULL),
(63010, '2018-02-05 14:26:10', NULL, NULL, 16678, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1517793076', 'admin', '2018-02-05 14:26:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63011, '2018-02-05 14:26:16', NULL, NULL, 16678, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 14:26:16', 'admin-1517793076-1517811976374329', 1, 1, 'SR', NULL, NULL, NULL),
(63012, '2018-02-05 15:22:24', NULL, NULL, 16679, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1517793076', 'admin', '2018-02-05 15:22:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63013, '2018-02-05 12:58:09', NULL, NULL, 16675, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 12:58:09', 'admin-1517793076-15178066896368988', 1, 1, 'SR', 1, NULL, NULL),
(63014, '2018-02-05 12:25:53', NULL, NULL, 16673, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 12:25:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63015, '2018-02-05 12:57:23', NULL, NULL, 16674, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1517793076', 'admin', '2018-02-05 12:57:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63016, '2018-02-05 12:25:58', NULL, NULL, 16673, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 12:25:58', 'admin-1517793076-15178047582546880', 1, 1, 'SR', NULL, NULL, NULL),
(63017, '2018-02-05 12:25:58', NULL, NULL, 16673, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 12:25:58', 'admin-1517793076-15178047582546880', 1, 1, 'SR', NULL, NULL, NULL),
(63018, '2018-02-05 11:31:07', NULL, NULL, 16671, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 11:31:07', 'admin-1517793076-15178014671158385', 1, 0, '', NULL, NULL, NULL),
(63019, '2018-02-05 11:41:39', NULL, NULL, 16672, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 11:41:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63020, '2018-02-05 11:41:49', NULL, NULL, 16672, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 11:41:49', 'admin-1517793076-1517802109399320', 1, 1, 'SR', NULL, NULL, NULL),
(63021, '2018-02-05 11:31:07', NULL, NULL, 16671, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 11:31:07', 'admin-1517793076-15178014671158385', 1, 1, 'SR', NULL, NULL, NULL),
(63022, '2018-02-05 11:03:38', NULL, NULL, 16670, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1517793076', 'admin', '2018-02-05 11:03:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63023, '2018-02-05 11:03:47', NULL, NULL, 16670, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 11:03:47', 'admin-1517793076-15177998278622442', 1, 1, 'SR', NULL, NULL, NULL),
(63024, '2018-02-05 11:03:48', NULL, NULL, 16670, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 11:03:48', 'admin-1517793076-15177998278622442', 1, 0, '', NULL, NULL, NULL),
(63025, '2018-02-05 11:03:48', NULL, NULL, 16670, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 11:03:48', 'admin-1517793076-15177998278622442', 1, 0, '', NULL, NULL, NULL),
(63026, '2018-02-05 11:30:55', NULL, NULL, 16671, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1517793076', 'admin', '2018-02-05 11:30:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63027, '2018-02-05 11:02:12', NULL, NULL, 16669, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 11:02:12', 'admin-1517793076-15177997323891145', 1, 1, 'SR', NULL, NULL, NULL),
(63028, '2018-02-05 11:02:00', NULL, NULL, 16669, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1517793076', 'admin', '2018-02-05 11:02:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63029, '2018-02-05 10:47:49', NULL, NULL, 16668, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 10:47:49', 'admin-1517793076-15177988691417918', 1, 0, '', NULL, NULL, NULL),
(63030, '2018-02-05 10:47:49', NULL, NULL, 16668, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 10:47:49', 'admin-1517793076-15177988691417918', 1, 1, 'SR', NULL, NULL, NULL),
(63031, '2018-02-05 10:46:07', NULL, NULL, 16668, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1517793076', 'admin', '2018-02-05 10:46:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63032, '2018-02-05 09:44:32', NULL, NULL, 16666, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 09:44:32', 'admin-1517793076-15177950728458957', 1, 1, 'SR', NULL, NULL, NULL),
(63033, '2018-02-05 09:44:32', NULL, NULL, 16666, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 09:44:32', 'admin-1517793076-15177950728458957', 1, 1, 'SR', NULL, NULL, NULL),
(63034, '2018-02-05 09:44:33', NULL, NULL, 16666, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517793076', 'admin', '2018-02-05 09:44:33', 'admin-1517793076-15177950728458957', 1, 0, '', NULL, NULL, NULL),
(63035, '2018-02-05 09:44:07', NULL, NULL, 16666, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1517793076', 'admin', '2018-02-05 09:44:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63036, '2018-02-07 11:58:33', NULL, NULL, 16691, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:58:33', 'admin-1517965747-15179759137969046', 1, 0, '', NULL, NULL, NULL),
(63037, '2018-02-07 14:25:03', NULL, NULL, 16700, 0, 322, '258', 'Yuzu Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 14:25:03', 'admin-1517965747-15179847038127070', 1, 0, '', NULL, NULL, NULL),
(63038, '2018-02-07 14:36:14', NULL, NULL, 16702, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 14:36:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63039, '2018-02-07 14:36:40', NULL, NULL, 16702, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 14:36:40', 'admin-1517965747-1517985400258594', 1, 0, '', NULL, NULL, NULL),
(63040, '2018-02-07 12:51:03', NULL, NULL, 16695, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:51:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63041, '2018-02-07 12:51:16', NULL, NULL, 16695, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:51:16', 'admin-1517965747-15179790761358597', 1, 1, 'SR', NULL, NULL, NULL),
(63042, '2018-02-07 12:54:38', NULL, NULL, 16695, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:54:38', 'admin-1517965747-15179792787026049', 1, 0, '', NULL, NULL, NULL),
(63043, '2018-02-07 12:56:02', NULL, NULL, 16696, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:56:02', '0', 1, 1, 'SR', NULL, NULL, '25.0'),
(63044, '2018-02-07 14:41:59', NULL, NULL, 16703, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 14:41:59', 'admin-1517965747-15179857190211497', 1, 1, 'SR', NULL, NULL, NULL),
(63045, '2018-02-07 13:18:45', NULL, NULL, 16697, 0, 181, '116', 'Open Food ', 'dumplings', 'Meals', 'Perfect Meals', 1, 150.00, 150.0000, 0.0000, 150.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 13:18:45', 'admin-1517965747-15179807256716315', 1, 0, '', 1, NULL, NULL),
(63046, '2018-02-07 16:47:05', NULL, NULL, 16705, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 16:47:05', 'admin-1517965747-15179932253995438', 1, 1, 'SR', NULL, NULL, NULL),
(63047, '2018-02-07 16:59:17', NULL, NULL, 16705, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 16:59:17', 'admin-1517965747-15179939575473711', 1, 1, 'SR', NULL, NULL, NULL),
(63048, '2018-02-07 16:47:05', NULL, NULL, 16705, 0, 338, '274', 'Chocolate Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 16:47:05', 'admin-1517965747-15179932253995438', 1, 0, '', NULL, NULL, NULL),
(63049, '2018-02-07 10:47:56', NULL, NULL, 16686, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1517965747', 'admin', '2018-02-07 10:47:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63050, '2018-02-07 10:48:37', NULL, NULL, 16686, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 10:48:37', 'admin-1517965747-1517971717790454', 1, 1, 'SR', NULL, NULL, NULL),
(63051, '2018-02-07 10:48:37', NULL, NULL, 16686, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 10:48:37', 'admin-1517965747-1517971717790454', 1, 0, '', NULL, NULL, NULL),
(63052, '2018-02-07 10:55:45', NULL, NULL, 16687, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.70, 0.0000, 0.0000, 10.70, 1, '27', 1, '1517965747', 'admin', '2018-02-07 10:55:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63053, '2018-02-07 11:22:41', NULL, NULL, 16689, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:22:41', 'admin-1517965747-15179737613647789', 1, 0, '', NULL, NULL, NULL),
(63054, '2018-02-07 11:21:27', NULL, NULL, 16689, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.80, 0.0000, 0.0000, 8.80, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:21:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63055, '2018-02-07 11:22:41', NULL, NULL, 16689, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:22:41', 'admin-1517965747-15179737613647789', 1, 0, '', NULL, NULL, NULL),
(63056, '2018-02-07 11:22:41', NULL, NULL, 16689, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:22:41', 'admin-1517965747-15179737613647789', 1, 0, '', NULL, NULL, NULL),
(63057, '2018-02-07 12:30:39', NULL, NULL, 16694, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:30:39', 'admin-1517965747-15179778394044651', 1, 1, 'SR', NULL, NULL, NULL),
(63058, '2018-02-07 12:30:39', NULL, NULL, 16694, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:30:39', 'admin-1517965747-15179778394044651', 1, 1, 'SR', NULL, NULL, NULL),
(63059, '2018-02-07 11:58:33', NULL, NULL, 16691, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:58:33', 'admin-1517965747-15179759137969046', 1, 0, '', NULL, NULL, NULL),
(63060, '2018-02-07 11:58:33', NULL, NULL, 16691, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:58:33', 'admin-1517965747-15179759137969046', 1, 0, '', NULL, NULL, NULL),
(63061, '2018-02-07 14:04:14', NULL, NULL, 16699, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 14:04:14', 'admin-1517965747-15179834548396370', 1, 0, '', NULL, NULL, NULL),
(63062, '2018-02-07 14:04:15', NULL, NULL, 16699, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 14:04:15', 'admin-1517965747-15179834548396370', 1, 0, '', NULL, NULL, NULL),
(63063, '2018-02-07 12:30:39', NULL, NULL, 16694, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:30:39', 'admin-1517965747-15179778394044651', 1, 1, 'SR', NULL, NULL, NULL),
(63064, '2018-02-07 13:44:00', NULL, NULL, 16698, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1517965747', 'admin', '2018-02-07 13:44:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63065, '2018-02-07 13:44:03', NULL, NULL, 16698, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 13:44:03', 'admin-1517965747-15179822437418917', 1, 1, 'SR', NULL, NULL, NULL),
(63066, '2018-02-07 14:04:00', NULL, NULL, 16699, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1517965747', 'admin', '2018-02-07 14:04:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63067, '2018-02-07 16:59:17', NULL, NULL, 16705, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 16:59:17', 'admin-1517965747-15179939575473711', 1, 1, 'SR', NULL, NULL, NULL),
(63068, '2018-02-07 16:47:05', NULL, NULL, 16705, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 16:47:05', 'admin-1517965747-15179932253995438', 1, 0, '', NULL, NULL, NULL),
(63069, '2018-02-07 12:56:11', NULL, NULL, 16696, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:56:11', 'admin-1517965747-15179793709903264', 1, 0, '', NULL, NULL, '25.0'),
(63070, '2018-02-07 11:05:39', NULL, NULL, 16688, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:05:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63071, '2018-02-07 11:04:39', NULL, NULL, 16687, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:04:39', 'admin-1517965747-15179726796234985', 1, 0, '', NULL, NULL, NULL),
(63072, '2018-02-07 13:02:58', NULL, NULL, 16692, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 13:02:58', 'admin-1517965747-15179797781927966', 1, 0, '', NULL, NULL, NULL),
(63073, '2018-02-07 14:41:59', NULL, NULL, 16703, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 14:41:59', 'admin-1517965747-15179857190211497', 1, 1, 'SR', NULL, NULL, NULL),
(63074, '2018-02-07 14:31:17', NULL, NULL, 16701, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 14:31:17', 'admin-1517965747-1517985077196282', 1, 1, 'SR', 1, NULL, NULL),
(63075, '2018-02-07 13:28:40', NULL, NULL, 16692, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 13:28:40', 'admin-1517965747-15179813203968551', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(63076, '2018-02-07 14:41:59', NULL, NULL, 16703, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 14:41:59', 'admin-1517965747-15179857190211497', 1, 1, 'SR', NULL, NULL, NULL),
(63077, '2018-02-07 12:30:39', NULL, NULL, 16694, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:30:39', 'admin-1517965747-15179778394044651', 1, 0, '', NULL, NULL, NULL),
(63078, '2018-02-07 16:46:51', NULL, NULL, 16705, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1517965747', 'admin', '2018-02-07 16:46:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63079, '2018-02-07 16:47:05', NULL, NULL, 16705, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 16:47:05', 'admin-1517965747-15179932253995438', 1, 1, 'SR', NULL, NULL, NULL),
(63080, '2018-02-07 15:10:44', NULL, NULL, 16704, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1517965747', 'admin', '2018-02-07 15:10:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63081, '2018-02-07 15:11:31', NULL, NULL, 16704, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 15:11:31', 'admin-1517965747-1517987491564448', 1, 1, 'SR', NULL, NULL, NULL),
(63082, '2018-02-07 14:41:44', NULL, NULL, 16703, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1517965747', 'admin', '2018-02-07 14:41:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63083, '2018-02-07 14:36:40', NULL, NULL, 16702, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 14:36:40', 'admin-1517965747-1517985400258594', 1, 1, 'SR', NULL, NULL, NULL),
(63084, '2018-02-07 12:30:39', NULL, NULL, 16694, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 3, 11.00, 33.0000, 0.0000, 33.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:30:39', 'admin-1517965747-15179778394044651', 1, 0, '', NULL, NULL, NULL),
(63085, '2018-02-07 12:26:13', NULL, NULL, 16692, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:26:13', 'admin-1517965747-15179775731436079', 1, 1, 'SR', NULL, NULL, NULL),
(63086, '2018-02-07 12:29:09', NULL, NULL, 16694, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 25.50, 0.0000, 0.0000, 25.50, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:29:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63087, '2018-02-07 13:28:40', NULL, NULL, 16692, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 13:28:40', 'admin-1517965747-15179813203968551', 1, 1, 'SR', NULL, NULL, NULL),
(63088, '2018-02-07 12:30:39', NULL, NULL, 16694, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:30:39', 'admin-1517965747-15179778394044651', 1, 0, '', NULL, NULL, NULL),
(63089, '2018-02-07 12:30:39', NULL, NULL, 16694, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:30:39', 'admin-1517965747-15179778394044651', 1, 0, '', NULL, NULL, NULL),
(63090, '2018-02-07 12:12:16', NULL, NULL, 16693, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:12:16', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(63091, '2018-02-07 12:12:29', NULL, NULL, 16693, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:12:29', 'admin-1517965747-15179767491988642', 1, 1, 'SR', NULL, NULL, '10.0'),
(63092, '2018-02-07 11:48:25', NULL, NULL, 16690, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:48:25', 'admin-1517965747-1517975305569591', 1, 1, 'SR', NULL, NULL, '10.0'),
(63093, '2018-02-07 11:48:25', NULL, NULL, 16690, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:48:25', 'admin-1517965747-1517975305569591', 1, 0, '', NULL, NULL, '10.0'),
(63094, '2018-02-07 11:48:25', NULL, NULL, 16690, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:48:25', 'admin-1517965747-1517975305569591', 1, 0, '', NULL, NULL, '10.0'),
(63095, '2018-02-07 11:48:25', NULL, NULL, 16690, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:48:25', 'admin-1517965747-1517975305569591', 1, 1, 'SR', NULL, NULL, '10.0'),
(63096, '2018-02-07 09:47:24', NULL, NULL, 16683, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 09:47:24', 'admin-1517965747-15179680440752763', 1, 0, '', NULL, NULL, NULL),
(63097, '2018-02-07 09:47:24', NULL, NULL, 16683, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 09:47:24', 'admin-1517965747-15179680440752763', 1, 0, '', NULL, NULL, NULL),
(63098, '2018-02-07 09:55:19', NULL, NULL, 16684, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1517965747', 'admin', '2018-02-07 09:55:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63099, '2018-02-07 12:30:39', NULL, NULL, 16694, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:30:39', 'admin-1517965747-15179778394044651', 1, 1, 'SR', NULL, NULL, NULL),
(63100, '2018-02-07 11:48:15', NULL, NULL, 16690, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:48:15', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(63101, '2018-02-07 11:22:41', NULL, NULL, 16689, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:22:41', 'admin-1517965747-15179737613647789', 1, 0, '', NULL, NULL, NULL),
(63102, '2018-02-07 12:40:10', NULL, NULL, 16692, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:40:10', 'admin-1517965747-15179784104966812', 1, 0, '', NULL, NULL, NULL),
(63103, '2018-02-07 11:57:38', NULL, NULL, 16691, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 12.10, 0.0000, 0.0000, 12.10, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:57:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63104, '2018-02-07 11:58:33', NULL, NULL, 16691, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:58:33', 'admin-1517965747-15179759137969046', 1, 0, '', NULL, NULL, NULL),
(63105, '2018-02-07 11:04:39', NULL, NULL, 16687, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:04:39', 'admin-1517965747-15179726796234985', 1, 0, '', NULL, NULL, NULL),
(63106, '2018-02-07 11:04:39', NULL, NULL, 16687, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:04:39', 'admin-1517965747-15179726796234985', 1, 1, 'SR', NULL, NULL, NULL),
(63107, '2018-02-07 12:31:30', NULL, NULL, 16691, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:31:30', 'admin-1517965747-15179778899303886', 1, 0, '', NULL, NULL, NULL),
(63108, '2018-02-07 12:31:30', NULL, NULL, 16691, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:31:30', 'admin-1517965747-15179778899303886', 1, 0, '', NULL, NULL, NULL),
(63109, '2018-02-07 12:30:39', NULL, NULL, 16694, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:30:39', 'admin-1517965747-15179778394044651', 1, 1, 'SR', NULL, NULL, NULL),
(63110, '2018-02-07 12:30:39', NULL, NULL, 16694, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:30:39', 'admin-1517965747-15179778394044651', 1, 0, '', NULL, NULL, NULL),
(63111, '2018-02-07 12:30:39', NULL, NULL, 16694, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:30:39', 'admin-1517965747-15179778394044651', 1, 1, 'SR', NULL, NULL, NULL),
(63112, '2018-02-07 12:09:59', NULL, NULL, 16692, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:09:59', 'admin-1517965747-15179765992371323', 1, 1, 'SR', NULL, NULL, NULL),
(63113, '2018-02-07 12:30:39', NULL, NULL, 16694, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 3, 21.00, 63.0000, 0.0000, 63.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:30:39', 'admin-1517965747-15179778394044651', 1, 0, '', NULL, NULL, NULL),
(63114, '2018-02-07 14:04:14', NULL, NULL, 16699, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 14:04:14', 'admin-1517965747-15179834548396370', 1, 0, '', NULL, NULL, NULL),
(63115, '2018-02-07 14:25:00', NULL, NULL, 16700, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1517965747', 'admin', '2018-02-07 14:25:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63116, '2018-02-07 12:30:39', NULL, NULL, 16694, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:30:39', 'admin-1517965747-15179778394044651', 1, 0, '', NULL, NULL, NULL),
(63117, '2018-02-07 13:02:58', NULL, NULL, 16692, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 13:02:58', 'admin-1517965747-15179797781927966', 1, 1, 'SR', NULL, NULL, NULL),
(63118, '2018-02-07 12:09:51', NULL, NULL, 16692, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:09:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63119, '2018-02-07 11:58:34', NULL, NULL, 16691, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:58:34', 'admin-1517965747-15179759137969046', 1, 1, 'SR', NULL, NULL, NULL),
(63120, '2018-02-07 11:58:34', NULL, NULL, 16691, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:58:34', 'admin-1517965747-15179759137969046', 1, 1, 'SR', NULL, NULL, NULL),
(63121, '2018-02-07 11:48:25', NULL, NULL, 16690, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:48:25', 'admin-1517965747-1517975305569591', 1, 0, '', NULL, NULL, '10.0'),
(63122, '2018-02-07 11:48:25', NULL, NULL, 16690, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:48:25', 'admin-1517965747-1517975305569591', 1, 0, '', NULL, NULL, '10.0'),
(63123, '2018-02-07 11:05:50', NULL, NULL, 16688, 0, 327, '263', 'Gula Melaka Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:05:50', 'admin-1517965747-15179727503774120', 1, 0, '', NULL, NULL, NULL),
(63124, '2018-02-07 11:05:50', NULL, NULL, 16688, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:05:50', 'admin-1517965747-15179727503774120', 1, 0, '', NULL, NULL, NULL),
(63125, '2018-02-07 11:22:41', NULL, NULL, 16689, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:22:41', 'admin-1517965747-15179737613647789', 1, 1, 'SR', NULL, NULL, NULL),
(63126, '2018-02-07 11:22:41', NULL, NULL, 16689, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:22:41', 'admin-1517965747-15179737613647789', 1, 1, 'SR', NULL, NULL, NULL),
(63127, '2018-02-07 11:04:39', NULL, NULL, 16687, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:04:39', 'admin-1517965747-15179726796234985', 1, 0, '', NULL, NULL, NULL),
(63128, '2018-02-07 11:04:39', NULL, NULL, 16687, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:04:39', 'admin-1517965747-15179726796234985', 1, 1, 'SR', NULL, NULL, NULL),
(63129, '2018-02-07 11:04:39', NULL, NULL, 16687, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:04:39', 'admin-1517965747-15179726796234985', 1, 1, 'SR', NULL, NULL, NULL),
(63130, '2018-02-07 11:04:39', NULL, NULL, 16687, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:04:39', 'admin-1517965747-15179726796234985', 1, 0, '', NULL, NULL, NULL),
(63131, '2018-02-07 11:04:39', NULL, NULL, 16687, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:04:39', 'admin-1517965747-15179726796234985', 1, 0, '', NULL, NULL, NULL),
(63132, '2018-02-07 09:56:33', NULL, NULL, 16684, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 09:56:33', 'admin-1517965747-15179685929608510', 1, 0, '', NULL, NULL, NULL),
(63133, '2018-02-07 11:04:39', NULL, NULL, 16687, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:04:39', 'admin-1517965747-15179726796234985', 1, 0, '', NULL, NULL, NULL),
(63134, '2018-02-07 12:12:29', NULL, NULL, 16693, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 12:12:29', 'admin-1517965747-15179767491988642', 1, 1, 'SR', NULL, NULL, '10.0'),
(63135, '2018-02-07 11:05:50', NULL, NULL, 16688, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 11:05:50', 'admin-1517965747-15179727503774120', 1, 0, '', NULL, NULL, NULL),
(63136, '2018-02-07 09:56:33', NULL, NULL, 16684, 0, 337, '273', 'Hot yuzu', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 09:56:33', 'admin-1517965747-15179685929608510', 1, 0, '', NULL, NULL, NULL),
(63137, '2018-02-07 10:44:39', NULL, NULL, 16685, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 10:44:39', 'admin-1517965747-15179714791926694', 1, 1, 'SR', 1, NULL, NULL),
(63138, '2018-02-07 09:56:33', NULL, NULL, 16684, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 09:56:33', 'admin-1517965747-15179685929608510', 1, 0, '', NULL, NULL, NULL),
(63139, '2018-02-07 09:56:33', NULL, NULL, 16684, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1517965747', 'admin', '2018-02-07 09:56:33', 'admin-1517965747-15179685929608510', 1, 0, '', NULL, NULL, NULL),
(63140, '2018-02-07 09:47:15', NULL, NULL, 16683, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1517965747', 'admin', '2018-02-07 09:47:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63141, '2018-02-08 00:00:00', NULL, NULL, 16720, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:54:25', 'admin-1518051961-15180620654915023', 1, 0, '', NULL, NULL, NULL),
(63142, '2018-02-08 13:48:20', NULL, NULL, 16727, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 13:48:20', 'admin-1518051961-15180689007059877', 1, 1, 'SR', NULL, NULL, NULL),
(63143, '2018-02-08 13:48:20', NULL, NULL, 16727, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 13:48:20', 'admin-1518051961-15180689007059877', 1, 1, 'SR', NULL, NULL, NULL),
(63144, '2018-02-08 13:53:22', NULL, NULL, 16727, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 13:53:22', 'admin-1518051961-15180692025878451', 1, 1, 'SR', NULL, NULL, NULL),
(63145, '2018-02-08 13:55:13', NULL, NULL, 16728, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1518051961', 'admin', '2018-02-08 13:55:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63146, '2018-02-08 16:39:59', NULL, NULL, 16737, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 16:39:59', 'admin-1518051961-15180791993999734', 1, 0, '', NULL, NULL, NULL),
(63147, '2018-02-08 16:40:31', NULL, NULL, 16738, 0, 181, '116', 'Open Food ', 'CNY dumpling', 'Meals', 'Perfect Meals', 1, 45.00, 45.0000, 0.0000, 45.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 16:40:31', 'admin-1518051961-15180792312096422', 1, 0, '', 1, NULL, NULL),
(63148, '2018-02-08 16:41:26', NULL, NULL, 16739, 0, 181, '116', 'Open Food ', 'CNY Dumpling', 'Meals', 'Perfect Meals', 1, 30.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 16:41:26', 'admin-1518051961-15180792860982926', 1, 0, '', 1, NULL, NULL),
(63149, '2018-02-08 11:07:22', NULL, NULL, 16706, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:07:22', 'admin-1518051961-15180592427512436', 1, 0, '', NULL, NULL, NULL),
(63150, '2018-02-08 11:07:23', NULL, NULL, 16706, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:07:23', 'admin-1518051961-15180592427512436', 1, 1, 'SR', NULL, NULL, NULL),
(63151, '2018-02-08 11:16:19', NULL, NULL, 16707, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:16:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63152, '2018-02-08 11:16:32', NULL, NULL, 16707, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:16:32', 'admin-1518051961-15180597921904418', 1, 0, '', NULL, NULL, NULL),
(63153, '2018-02-08 11:16:32', NULL, NULL, 16707, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:16:32', 'admin-1518051961-15180597921904418', 1, 1, 'SR', NULL, NULL, NULL),
(63154, '2018-02-08 00:00:00', NULL, NULL, 16713, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:25:43', 'admin-1518051961-15180603434063793', 1, 1, 'SR', NULL, NULL, NULL),
(63155, '2018-02-08 00:00:00', NULL, NULL, 16714, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', NULL, 1, 2.90, NULL, NULL, 2.90, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:24:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63156, '2018-02-08 12:25:20', NULL, NULL, 16715, 0, 78, '78', 'Cheesy Baked Mashed Potato', '', 'Meals', 'Snacks ', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 12:25:20', 'admin-1518051961-15180639207045128', 1, 1, 'SR', 1, NULL, NULL),
(63157, '2018-02-08 00:00:00', NULL, NULL, 16714, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:25:43', 'admin-1518051961-15180603434063793', 1, 0, '', NULL, NULL, NULL),
(63158, '2018-02-08 13:57:35', NULL, NULL, 16729, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.60, 0.0000, 0.0000, 1.60, 1, '27', 1, '1518051961', 'admin', '2018-02-08 13:57:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63159, '2018-02-08 13:57:51', NULL, NULL, 16729, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 13:57:51', 'admin-1518051961-15180694715565248', 1, 1, 'SR', NULL, NULL, NULL),
(63160, '2018-02-08 13:57:51', NULL, NULL, 16729, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 13:57:51', 'admin-1518051961-15180694715565248', 1, 0, '', NULL, NULL, NULL),
(63161, '2018-02-08 12:47:42', NULL, NULL, 16718, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 12:47:42', 'admin-1518051961-15180652619926648', 1, 0, '', NULL, NULL, NULL),
(63162, '2018-02-08 00:00:00', NULL, NULL, 16719, 0, 322, '258', 'Yuzu Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:54:25', 'admin-1518051961-15180620654915023', 1, 0, '', NULL, NULL, NULL),
(63163, '2018-02-08 12:50:13', NULL, NULL, 16722, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 12:50:13', 'admin-1518051961-15180654134963633', 1, 1, 'SR', NULL, NULL, NULL),
(63164, '2018-02-08 12:51:41', NULL, NULL, 16712, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 12:51:41', 'admin-1518051961-15180655014752815', 1, 1, 'SR', NULL, NULL, NULL),
(63165, '2018-02-08 14:15:07', NULL, NULL, 16727, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 14:15:07', 'admin-1518051961-15180705077514427', 1, 0, '', NULL, NULL, NULL),
(63166, '2018-02-08 14:15:07', NULL, NULL, 16727, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 14:15:07', 'admin-1518051961-15180705077514427', 1, 1, 'SR', NULL, NULL, NULL),
(63167, '2018-02-08 14:20:58', NULL, NULL, 16731, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 14:20:58', 'admin-1518051961-15180708583683266', 1, 1, 'SR', NULL, NULL, NULL),
(63168, '2018-02-08 13:12:13', NULL, NULL, 16724, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 13:12:13', 'admin-1518051961-15180667331414549', 1, 0, '', NULL, NULL, NULL),
(63169, '2018-02-08 13:12:13', NULL, NULL, 16724, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 13:12:13', 'admin-1518051961-15180667331414549', 1, 1, 'SR', NULL, NULL, NULL),
(63170, '2018-02-08 14:38:29', NULL, NULL, 16735, 0, 181, '116', 'Open Food ', 'CNY Dumpling', 'Meals', 'Perfect Meals', 1, 30.00, 30.0000, 0.0000, 30.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 14:38:29', 'admin-1518051961-15180719096031430', 1, 0, '', 1, NULL, NULL),
(63171, '2018-02-08 16:39:59', NULL, NULL, 16737, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 16:39:59', 'admin-1518051961-15180791993999734', 1, 1, 'SR', NULL, NULL, NULL),
(63172, '2018-02-08 00:00:00', NULL, NULL, 16721, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', NULL, 1, 2.60, NULL, NULL, 2.60, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:47:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63173, '2018-02-08 15:46:39', NULL, NULL, 16736, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1518051961', 'admin', '2018-02-08 15:46:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63174, '2018-02-08 15:46:44', NULL, NULL, 16736, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 15:46:44', 'admin-1518051961-15180760042253755', 1, 1, 'SR', NULL, NULL, NULL),
(63175, '2018-02-08 14:40:07', NULL, NULL, 16734, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 14:40:07', 'admin-1518051961-15180720071819376', 1, 0, '', NULL, NULL, NULL),
(63176, '2018-02-08 14:29:10', NULL, NULL, 16733, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 14:29:10', 'admin-1518051961-15180713507198014', 1, 1, 'SR', NULL, NULL, '10.0'),
(63177, '2018-02-08 14:30:52', NULL, NULL, 16730, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 11.70, 1, '27', 1, '1518051961', 'admin', '2018-02-08 14:30:52', 'admin-1518051961-15180714522908018', 1, 1, 'SR', NULL, '10.0', '10.0'),
(63178, '2018-02-08 14:35:42', NULL, NULL, 16734, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1518051961', 'admin', '2018-02-08 14:35:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63179, '2018-02-08 14:35:49', NULL, NULL, 16734, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 14:35:49', 'admin-1518051961-15180717491656143', 1, 0, '', NULL, NULL, NULL),
(63180, '2018-02-08 14:29:07', NULL, NULL, 16733, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1518051961', 'admin', '2018-02-08 14:29:07', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(63181, '2018-02-08 14:23:59', NULL, NULL, 16732, 0, 181, '116', 'Open Food ', 'CNY Dumpling', 'Meals', 'Perfect Meals', 1, 60.00, 60.0000, 0.0000, 60.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 14:23:59', 'admin-1518051961-1518071039005954', 1, 0, '', 1, NULL, NULL),
(63182, '2018-02-08 11:57:47', NULL, NULL, 16711, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:57:47', 'admin-1518051961-15180622676514460', 1, 1, 'SR', NULL, NULL, '10.0'),
(63183, '2018-02-08 00:00:00', NULL, NULL, 16716, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:48:21', 'admin-1518051961-15180617009355956', 1, 1, 'SR', NULL, NULL, NULL),
(63184, '2018-02-08 14:20:55', NULL, NULL, 16731, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1518051961', 'admin', '2018-02-08 14:20:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63185, '2018-02-08 13:12:13', NULL, NULL, 16724, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 13:12:13', 'admin-1518051961-15180667331414549', 1, 1, 'SR', NULL, NULL, NULL),
(63186, '2018-02-08 14:15:07', NULL, NULL, 16727, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 14:15:07', 'admin-1518051961-15180705077514427', 1, 1, 'SR', NULL, NULL, NULL),
(63187, '2018-02-08 14:15:07', NULL, NULL, 16727, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 14:15:07', 'admin-1518051961-15180705077514427', 1, 1, 'SR', NULL, NULL, NULL),
(63188, '2018-02-08 14:00:40', NULL, NULL, 16730, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 14:00:40', 'admin-1518051961-15180696400516934', 1, 0, '', NULL, NULL, '10.0'),
(63189, '2018-02-08 14:00:30', NULL, NULL, 16730, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.07, 0.0000, 0.0000, 3.07, 1, '27', 1, '1518051961', 'admin', '2018-02-08 14:00:30', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(63190, '2018-02-08 14:00:40', NULL, NULL, 16730, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 14:00:40', 'admin-1518051961-15180696400516934', 1, 1, 'SR', NULL, NULL, '10.0'),
(63191, '2018-02-08 12:43:37', NULL, NULL, 16718, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1518051961', 'admin', '2018-02-08 12:43:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63192, '2018-02-08 12:48:13', NULL, NULL, 16719, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1518051961', 'admin', '2018-02-08 12:48:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63193, '2018-02-08 12:48:57', NULL, NULL, 16720, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1518051961', 'admin', '2018-02-08 12:48:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63194, '2018-02-08 13:37:06', NULL, NULL, 16726, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 13:37:06', 'admin-1518051961-15180682267499429', 1, 1, 'SR', NULL, NULL, NULL),
(63195, '2018-02-08 13:47:07', NULL, NULL, 16727, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 13:47:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63196, '2018-02-08 12:44:30', NULL, NULL, 16718, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 12:44:30', 'admin-1518051961-15180650701862575', 1, 1, 'SR', NULL, NULL, NULL),
(63197, '2018-02-08 12:33:13', NULL, NULL, 16716, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1518051961', 'admin', '2018-02-08 12:33:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63198, '2018-02-08 13:36:06', NULL, NULL, 16726, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1518051961', 'admin', '2018-02-08 13:36:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63199, '2018-02-08 12:44:30', NULL, NULL, 16718, 0, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 12:44:30', 'admin-1518051961-15180650701862575', 1, 1, 'SR', NULL, NULL, NULL),
(63200, '2018-02-08 13:14:01', NULL, NULL, 16725, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 13:14:01', 'admin-1518051961-15180668413731521', 1, 1, 'SR', 1, NULL, NULL),
(63201, '2018-02-08 13:08:58', NULL, NULL, 16723, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 13:08:58', 'admin-1518051961-15180665385227297', 1, 1, 'SR', NULL, NULL, '10.0'),
(63202, '2018-02-08 13:37:06', NULL, NULL, 16726, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 13:37:06', 'admin-1518051961-15180682267499429', 1, 1, 'SR', NULL, NULL, NULL),
(63203, '2018-02-08 12:50:00', NULL, NULL, 16722, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1518051961', 'admin', '2018-02-08 12:50:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63204, '2018-02-08 12:50:13', NULL, NULL, 16722, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 12:50:13', 'admin-1518051961-15180654134963633', 1, 1, 'SR', NULL, NULL, NULL),
(63205, '2018-02-08 13:12:02', NULL, NULL, 16724, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 13:12:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63206, '2018-02-08 13:08:58', NULL, NULL, 16723, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 13:08:58', 'admin-1518051961-15180665385227297', 1, 1, 'SR', NULL, NULL, '10.0'),
(63207, '2018-02-08 13:08:21', NULL, NULL, 16723, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1518051961', 'admin', '2018-02-08 13:08:21', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(63208, '2018-02-08 12:44:30', NULL, NULL, 16718, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 12:44:30', 'admin-1518051961-15180650701862575', 1, 1, 'SR', NULL, NULL, NULL),
(63209, '2018-02-08 12:19:04', NULL, NULL, 16712, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 12:19:04', 'admin-1518051961-15180635442094391', 1, 1, 'SR', NULL, NULL, NULL),
(63210, '2018-02-08 00:00:00', NULL, NULL, 16713, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:25:43', 'admin-1518051961-15180603434063793', 1, 0, '', NULL, NULL, NULL),
(63211, '2018-02-08 12:22:14', NULL, NULL, 16713, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 12:22:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63212, '2018-02-08 00:00:00', NULL, NULL, 16714, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:25:43', 'admin-1518051961-15180603434063793', 1, 1, 'SR', NULL, NULL, NULL),
(63213, '2018-02-08 12:19:04', NULL, NULL, 16712, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 12:19:04', 'admin-1518051961-15180635442094391', 1, 0, '', NULL, NULL, NULL),
(63214, '2018-02-08 12:19:04', NULL, NULL, 16712, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 12:19:04', 'admin-1518051961-15180635442094391', 1, 1, 'SR', NULL, NULL, NULL),
(63215, '2018-02-08 11:57:41', NULL, NULL, 16711, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:57:41', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(63216, '2018-02-08 00:00:00', NULL, NULL, 16720, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:54:25', 'admin-1518051961-15180620654915023', 1, 1, 'SR', NULL, NULL, NULL),
(63217, '2018-02-08 15:02:05', NULL, NULL, 16733, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 15:02:05', 'admin-1518051961-15180733258494639', 1, 1, 'SR', NULL, NULL, '10.0'),
(63218, '2018-02-08 13:55:21', NULL, NULL, 16728, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 13:55:21', 'admin-1518051961-15180693215945782', 1, 1, 'SR', NULL, NULL, NULL),
(63219, '2018-02-08 00:00:00', NULL, NULL, 16719, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:48:21', 'admin-1518051961-15180617009355956', 1, 1, 'SR', NULL, NULL, NULL),
(63220, '2018-02-08 00:00:00', NULL, NULL, 16721, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:48:21', 'admin-1518051961-15180617009355956', 1, 1, 'SR', NULL, NULL, NULL),
(63221, '2018-02-08 12:18:54', NULL, NULL, 16712, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1518051961', 'admin', '2018-02-08 12:18:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63222, '2018-02-08 00:00:00', NULL, NULL, 16721, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:56:34', 'admin-1518051961-1518062194704513', 1, 1, 'SR', NULL, NULL, NULL),
(63223, '2018-02-08 00:00:00', NULL, NULL, 16716, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:54:25', 'admin-1518051961-15180620654915023', 1, 1, 'SR', NULL, NULL, NULL),
(63224, '2018-02-08 11:51:17', NULL, NULL, 16710, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:51:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63225, '2018-02-08 11:51:38', NULL, NULL, 16710, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:51:38', 'admin-1518051961-15180618988096571', 1, 1, 'SR', NULL, NULL, NULL),
(63226, '2018-02-08 11:51:38', NULL, NULL, 16710, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:51:38', 'admin-1518051961-15180618988096571', 1, 1, 'SR', NULL, NULL, NULL),
(63227, '2018-02-08 11:51:38', NULL, NULL, 16710, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:51:38', 'admin-1518051961-15180618988096571', 1, 1, 'SR', NULL, NULL, NULL),
(63228, '2018-02-08 11:07:22', NULL, NULL, 16706, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:07:22', 'admin-1518051961-15180592427512436', 1, 1, 'SR', NULL, NULL, NULL),
(63229, '2018-02-08 13:53:22', NULL, NULL, 16727, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 13:53:22', 'admin-1518051961-15180692025878451', 1, 0, '', NULL, NULL, NULL),
(63230, '2018-02-08 11:51:38', NULL, NULL, 16710, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:51:38', 'admin-1518051961-15180618988096571', 1, 1, 'SR', NULL, NULL, NULL),
(63231, '2018-02-08 00:00:00', NULL, NULL, 16714, 0, 181, '116', 'Open Food ', 'bacon', 'Meals', 'Perfect Meals', 1, 4.00, NULL, NULL, 4.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:25:43', 'admin-1518051961-15180603434063793', 1, 0, '', NULL, NULL, NULL),
(63232, '2018-02-08 11:46:41', NULL, NULL, 16706, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:46:41', 'admin-1518051961-1518061601585537', 1, 1, 'SR', NULL, NULL, NULL),
(63233, '2018-02-08 11:07:22', NULL, NULL, 16706, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:07:22', 'admin-1518051961-15180592427512436', 1, 0, '', NULL, NULL, NULL),
(63234, '2018-02-08 11:07:22', NULL, NULL, 16706, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:07:22', 'admin-1518051961-15180592427512436', 1, 0, '', NULL, NULL, NULL),
(63235, '2018-02-08 11:07:22', NULL, NULL, 16706, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:07:22', 'admin-1518051961-15180592427512436', 1, 0, '', NULL, NULL, NULL),
(63236, '2018-02-08 11:07:00', NULL, NULL, 16706, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.10, 0.0000, 0.0000, 10.10, 1, '27', 1, '1518051961', 'admin', '2018-02-08 11:07:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63237, '2018-02-09 13:58:48', NULL, NULL, 16769, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 13:58:48', 'admin-1518135973-15181559283028210', 1, 1, 'SR', NULL, NULL, NULL),
(63238, '2018-02-09 13:58:48', NULL, NULL, 16769, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 13:58:48', 'admin-1518135973-15181559283028210', 1, 1, 'SR', NULL, NULL, NULL),
(63239, '2018-02-09 00:00:00', NULL, NULL, 16750, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:56:29', 'admin-1518135973-15181413894506528', 1, 0, '', NULL, NULL, NULL),
(63240, '2018-02-09 00:00:00', NULL, NULL, 16750, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:56:29', 'admin-1518135973-15181413894506528', 1, 1, 'SR', NULL, NULL, NULL),
(63241, '2018-02-09 10:12:57', NULL, NULL, 16745, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1518135973', 'admin', '2018-02-09 10:12:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63242, '2018-02-09 10:13:08', NULL, NULL, 16745, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 10:13:08', 'admin-1518135973-15181423880474754', 1, 0, '', NULL, NULL, NULL),
(63243, '2018-02-09 10:13:08', NULL, NULL, 16745, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 10:13:08', 'admin-1518135973-15181423880474754', 1, 1, 'SR', NULL, NULL, NULL),
(63244, '2018-02-09 10:28:36', NULL, NULL, 16746, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1518135973', 'admin', '2018-02-09 10:28:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63245, '2018-02-09 10:28:46', NULL, NULL, 16746, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 10:28:46', 'admin-1518135973-1518143326253617', 1, 0, '', NULL, NULL, NULL),
(63246, '2018-02-09 10:28:46', NULL, NULL, 16746, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 10:28:46', 'admin-1518135973-1518143326253617', 1, 0, '', NULL, NULL, NULL),
(63247, '2018-02-09 14:01:55', NULL, NULL, 16770, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 14:01:55', 'admin-1518135973-15181561151928556', 1, 0, '', NULL, NULL, NULL),
(63248, '2018-02-09 13:46:32', NULL, NULL, 16768, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 13:46:32', 'admin-1518135973-15181551920149618', 1, 0, '', NULL, NULL, NULL),
(63249, '2018-02-09 15:26:52', NULL, NULL, 16776, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1518135973', 'admin', '2018-02-09 15:26:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63250, '2018-02-09 15:27:01', NULL, NULL, 16776, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 15:27:01', 'admin-1518135973-15181612214126198', 1, 1, 'SR', NULL, NULL, NULL),
(63251, '2018-02-09 15:11:11', NULL, NULL, 16775, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 15:11:11', 'admin-1518135973-15181602718099643', 1, 1, 'SR', 1, NULL, NULL),
(63252, '2018-02-09 13:59:28', NULL, NULL, 16770, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1518135973', 'admin', '2018-02-09 13:59:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63253, '2018-02-09 13:46:32', NULL, NULL, 16768, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 13:46:32', 'admin-1518135973-15181551920149618', 1, 1, 'SR', NULL, NULL, NULL),
(63254, '2018-02-09 13:46:32', NULL, NULL, 16768, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 13:46:32', 'admin-1518135973-15181551920149618', 1, 1, 'SR', NULL, NULL, NULL),
(63255, '2018-02-09 09:46:58', NULL, NULL, 16742, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:46:58', 'admin-1518135973-15181408180794991', 1, 0, '', NULL, NULL, NULL),
(63256, '2018-02-09 09:46:58', NULL, NULL, 16742, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:46:58', 'admin-1518135973-15181408180794991', 1, 0, '', NULL, NULL, NULL),
(63257, '2018-02-09 09:46:58', NULL, NULL, 16742, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:46:58', 'admin-1518135973-15181408180794991', 1, 1, 'SR', NULL, NULL, NULL),
(63258, '2018-02-09 09:46:58', NULL, NULL, 16742, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:46:58', 'admin-1518135973-15181408180794991', 1, 1, 'SR', NULL, NULL, NULL),
(63259, '2018-02-09 09:48:14', NULL, NULL, 16743, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:48:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63260, '2018-02-09 09:48:23', NULL, NULL, 16743, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:48:23', 'admin-1518135973-1518140902930321', 1, 0, '', NULL, NULL, NULL),
(63261, '2018-02-09 13:46:32', NULL, NULL, 16768, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 13:46:32', 'admin-1518135973-15181551920149618', 1, 1, 'SR', NULL, NULL, NULL),
(63262, '2018-02-09 13:46:14', NULL, NULL, 16768, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.80, 0.0000, 0.0000, 7.80, 1, '27', 1, '1518135973', 'admin', '2018-02-09 13:46:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63263, '2018-02-09 13:29:10', NULL, NULL, 16767, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 13:29:10', 'admin-1518135973-15181541505677327', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(63264, '2018-02-09 00:00:00', NULL, NULL, 16749, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:56:29', 'admin-1518135973-15181413894506528', 1, 0, '', NULL, NULL, NULL),
(63265, '2018-02-09 00:00:00', NULL, NULL, 16750, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:56:29', 'admin-1518135973-15181413894506528', 1, 1, 'SR', NULL, NULL, NULL),
(63266, '2018-02-09 11:05:49', NULL, NULL, 16751, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.80, 0.0000, 0.0000, 9.80, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:05:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63267, '2018-02-09 11:41:54', NULL, NULL, 16757, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:41:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63268, '2018-02-09 11:42:23', NULL, NULL, 16757, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:42:23', 'admin-1518135973-1518147742965311', 1, 0, '', NULL, NULL, NULL),
(63269, '2018-02-09 11:42:23', NULL, NULL, 16757, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:42:23', 'admin-1518135973-1518147742965311', 1, 1, 'SR', NULL, NULL, NULL),
(63270, '2018-02-09 14:51:30', NULL, NULL, 16773, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 14:51:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63271, '2018-02-09 11:16:51', NULL, NULL, 16753, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:16:51', 'admin-1518135973-15181462111721776', 1, 1, 'SR', NULL, NULL, NULL),
(63272, '2018-02-09 11:20:39', NULL, NULL, 16752, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:20:39', 'admin-1518135973-15181464393871430', 1, 0, '', NULL, NULL, NULL),
(63273, '2018-02-09 12:04:16', NULL, NULL, 16759, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 12:04:16', 'admin-1518135973-1518149056418631', 1, 0, '', NULL, NULL, '10.0'),
(63274, '2018-02-09 00:00:00', NULL, NULL, 16761, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:44:19', 'admin-1518135973-1518147859842387', 1, 1, 'SR', NULL, NULL, NULL),
(63275, '2018-02-09 12:07:46', NULL, NULL, 16759, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 12:07:46', 'admin-1518135973-15181492660367437', 1, 1, 'SR', NULL, NULL, '10.0'),
(63276, '2018-02-09 00:00:00', NULL, NULL, 16760, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:44:19', 'admin-1518135973-1518147859842387', 1, 0, '', NULL, NULL, NULL),
(63277, '2018-02-09 13:58:41', NULL, NULL, 16769, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1518135973', 'admin', '2018-02-09 13:58:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63278, '2018-02-09 14:18:33', NULL, NULL, 16771, 0, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 14:18:33', 'admin-1518135973-15181571136412370', 1, 1, 'SR', NULL, NULL, NULL),
(63279, '2018-02-09 13:54:48', NULL, NULL, 16768, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 13:54:48', 'admin-1518135973-15181556880993153', 1, 0, '', NULL, NULL, NULL),
(63280, '2018-02-09 13:24:05', NULL, NULL, 16764, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 13:24:05', 'admin-1518135973-15181538451791023', 1, 1, 'SR', NULL, NULL, NULL),
(63281, '2018-02-09 12:20:45', NULL, NULL, 16762, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 12:20:45', 'admin-1518135973-15181500456783379', 1, 1, 'SR', NULL, NULL, '25.0'),
(63282, '2018-02-09 13:23:50', NULL, NULL, 16764, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1518135973', 'admin', '2018-02-09 13:23:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63283, '2018-02-09 13:21:16', NULL, NULL, 16763, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 13:21:16', 'admin-1518135973-15181536761547831', 1, 1, 'SR', NULL, NULL, NULL),
(63284, '2018-02-09 11:12:26', NULL, NULL, 16752, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:12:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63285, '2018-02-09 14:53:43', NULL, NULL, 16771, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 14:53:43', 'admin-1518135973-15181592235067799', 1, 0, '', NULL, NULL, NULL),
(63286, '2018-02-09 13:58:48', NULL, NULL, 16769, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 13:58:48', 'admin-1518135973-15181559283028210', 1, 0, '', NULL, NULL, NULL),
(63287, '2018-02-09 13:20:57', NULL, NULL, 16763, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1518135973', 'admin', '2018-02-09 13:20:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63288, '2018-02-09 14:50:32', NULL, NULL, 16771, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 14:50:32', 'admin-1518135973-15181590325207620', 1, 0, '', NULL, NULL, NULL),
(63289, '2018-02-09 00:00:00', NULL, NULL, 16773, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, NULL, NULL, 20.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 13:59:45', 'admin-1518135973-15181559857936276', 1, 0, '', NULL, NULL, NULL),
(63290, '2018-02-09 00:00:00', NULL, NULL, 16772, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 13:59:45', 'admin-1518135973-15181559857936276', 1, 1, 'SR', NULL, NULL, NULL),
(63291, '2018-02-09 14:18:33', NULL, NULL, 16771, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 14:18:33', 'admin-1518135973-15181571136412370', 1, 1, 'SR', NULL, NULL, NULL),
(63292, '2018-02-09 14:18:33', NULL, NULL, 16771, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 14:18:33', 'admin-1518135973-15181571136412370', 1, 1, 'SR', NULL, NULL, NULL),
(63293, '2018-02-09 14:18:33', NULL, NULL, 16771, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 14:18:33', 'admin-1518135973-15181571136412370', 1, 0, '', NULL, NULL, NULL),
(63294, '2018-02-09 14:18:33', NULL, NULL, 16771, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 14:18:33', 'admin-1518135973-15181571136412370', 1, 0, '', NULL, NULL, NULL),
(63295, '2018-02-09 14:18:33', NULL, NULL, 16771, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 14:18:33', 'admin-1518135973-15181571136412370', 1, 0, '', NULL, NULL, NULL),
(63296, '2018-02-09 14:48:32', NULL, NULL, 16772, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1518135973', 'admin', '2018-02-09 14:48:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63297, '2018-02-09 14:18:01', NULL, NULL, 16771, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 11.00, 0.0000, 0.0000, 11.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 14:18:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63298, '2018-02-09 13:46:32', NULL, NULL, 16768, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 13:46:32', 'admin-1518135973-15181551920149618', 1, 1, 'SR', NULL, NULL, NULL),
(63299, '2018-02-09 10:47:09', NULL, NULL, 16747, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 10:47:09', 'admin-1518135973-15181444292438558', 1, 0, '', NULL, NULL, NULL),
(63300, '2018-02-09 12:20:04', NULL, NULL, 16762, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 12:20:04', 'admin-1518135973-15181500047126416', 1, 0, '', NULL, NULL, '25.0'),
(63301, '2018-02-09 12:20:04', NULL, NULL, 16762, 0, 272, '206', 'Genius in The Bowl', '', 'Meals', 'Non-Rice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 12:20:04', 'admin-1518135973-15181500047126416', 1, 0, '', NULL, NULL, '25.0'),
(63302, '2018-02-09 12:20:04', NULL, NULL, 16762, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 12:20:04', 'admin-1518135973-15181500047126416', 1, 0, '', NULL, NULL, '25.0'),
(63303, '2018-02-09 00:00:00', NULL, NULL, 16761, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', NULL, 1, 3.20, NULL, NULL, 3.20, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:44:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63304, '2018-02-09 00:00:00', NULL, NULL, 16761, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:44:19', 'admin-1518135973-1518147859842387', 1, 1, 'SR', NULL, NULL, NULL),
(63305, '2018-02-09 12:19:48', NULL, NULL, 16762, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1518135973', 'admin', '2018-02-09 12:19:48', '0', 1, 1, 'SR', NULL, NULL, '25.0'),
(63306, '2018-02-09 00:00:00', NULL, NULL, 16749, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 10:38:19', 'admin-1518135973-15181438997822636', 1, 1, 'SR', NULL, NULL, NULL),
(63307, '2018-02-09 10:43:35', NULL, NULL, 16742, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 10:43:35', 'admin-1518135973-15181442156126299', 1, 0, '', NULL, NULL, NULL),
(63308, '2018-02-09 00:00:00', NULL, NULL, 16755, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', NULL, 1, 1.10, NULL, NULL, 1.10, 1, '27', 1, '1518135973', 'admin', '2018-02-09 10:51:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63309, '2018-02-09 11:29:55', NULL, NULL, 16754, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:29:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63310, '2018-02-09 00:00:00', NULL, NULL, 16749, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 10:38:19', 'admin-1518135973-15181438997822636', 1, 1, 'SR', NULL, NULL, NULL),
(63311, '2018-02-09 12:03:26', NULL, NULL, 16759, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1518135973', 'admin', '2018-02-09 12:03:26', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(63312, '2018-02-09 12:04:16', NULL, NULL, 16759, 0, 229, '163', 'Mummy''s Pasta', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 12:04:16', 'admin-1518135973-1518149056418631', 1, 0, '', NULL, NULL, '10.0'),
(63313, '2018-02-09 12:08:23', NULL, NULL, 16760, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1518135973', 'admin', '2018-02-09 12:08:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63314, '2018-02-09 13:24:05', NULL, NULL, 16764, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 13:24:05', 'admin-1518135973-15181538451791023', 1, 1, 'SR', NULL, NULL, NULL),
(63315, '2018-02-09 11:12:50', NULL, NULL, 16752, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:12:50', 'admin-1518135973-15181459698919444', 1, 1, 'SR', NULL, NULL, NULL),
(63316, '2018-02-09 11:22:34', NULL, NULL, 16752, 0, 181, '116', 'Open Food ', 'croissant', 'Meals', 'Perfect Meals', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:22:34', 'admin-1518135973-15181465545446697', 1, 0, '', NULL, NULL, NULL),
(63317, '2018-02-09 00:00:00', NULL, NULL, 16754, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 10:51:13', 'admin-1518135973-15181446734217881', 1, 1, 'SR', NULL, NULL, NULL),
(63318, '2018-02-09 00:00:00', NULL, NULL, 16755, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 10:51:13', 'admin-1518135973-15181446734217881', 1, 1, 'SR', NULL, NULL, NULL),
(63319, '2018-02-09 09:06:23', NULL, NULL, 16740, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:06:23', 'admin-1518135973-1518138383070979', 1, 1, 'SR', NULL, NULL, NULL),
(63320, '2018-02-09 09:06:23', NULL, NULL, 16740, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:06:23', 'admin-1518135973-1518138383070979', 1, 1, 'SR', NULL, NULL, NULL),
(63321, '2018-02-09 11:42:23', NULL, NULL, 16757, 0, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:42:23', 'admin-1518135973-1518147742965311', 1, 1, 'SR', NULL, NULL, NULL),
(63322, '2018-02-09 11:41:22', NULL, NULL, 16756, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:41:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63323, '2018-02-09 09:06:23', NULL, NULL, 16740, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:06:23', 'admin-1518135973-1518138383070979', 1, 0, '', NULL, NULL, NULL),
(63324, '2018-02-09 11:12:50', NULL, NULL, 16752, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:12:50', 'admin-1518135973-15181459698919444', 1, 1, 'SR', NULL, NULL, NULL),
(63325, '2018-02-09 10:47:09', NULL, NULL, 16747, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 10:47:09', 'admin-1518135973-15181444292438558', 1, 0, '', NULL, NULL, NULL),
(63326, '2018-02-09 11:20:39', NULL, NULL, 16752, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:20:39', 'admin-1518135973-15181464393871430', 1, 0, '', NULL, NULL, NULL),
(63327, '2018-02-09 11:16:51', NULL, NULL, 16753, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:16:51', 'admin-1518135973-15181462111721776', 1, 0, '', NULL, NULL, NULL),
(63328, '2018-02-09 13:29:10', NULL, NULL, 16767, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 13:29:10', 'admin-1518135973-15181541505677327', 1, 1, 'SR', NULL, NULL, NULL),
(63329, '2018-02-09 11:16:40', NULL, NULL, 16753, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:16:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63330, '2018-02-09 11:41:25', NULL, NULL, 16756, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:41:25', 'admin-1518135973-15181476853347582', 1, 1, 'SR', NULL, NULL, NULL),
(63331, '2018-02-09 11:08:44', NULL, NULL, 16751, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:08:44', 'admin-1518135973-15181457241166465', 1, 0, '', NULL, NULL, NULL),
(63332, '2018-02-09 13:28:53', NULL, NULL, 16767, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1518135973', 'admin', '2018-02-09 13:28:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63333, '2018-02-09 11:08:44', NULL, NULL, 16751, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:08:44', 'admin-1518135973-15181457241166465', 1, 0, '', NULL, NULL, NULL),
(63334, '2018-02-09 11:08:44', NULL, NULL, 16751, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:08:44', 'admin-1518135973-15181457241166465', 1, 1, 'SR', NULL, NULL, NULL),
(63335, '2018-02-09 11:08:44', NULL, NULL, 16751, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:08:44', 'admin-1518135973-15181457241166465', 1, 0, '', NULL, NULL, NULL),
(63336, '2018-02-09 11:08:44', NULL, NULL, 16751, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:08:44', 'admin-1518135973-15181457241166465', 1, 0, '', NULL, NULL, NULL),
(63337, '2018-02-09 10:47:09', NULL, NULL, 16747, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 10:47:09', 'admin-1518135973-15181444292438558', 1, 1, 'SR', NULL, NULL, NULL),
(63338, '2018-02-09 11:08:44', NULL, NULL, 16751, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:08:44', 'admin-1518135973-15181457241166465', 1, 1, 'SR', NULL, NULL, NULL),
(63339, '2018-02-09 10:47:09', NULL, NULL, 16747, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 10:47:09', 'admin-1518135973-15181444292438558', 1, 1, 'SR', NULL, NULL, NULL),
(63340, '2018-02-09 10:47:00', NULL, NULL, 16747, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1518135973', 'admin', '2018-02-09 10:47:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63341, '2018-02-09 10:28:46', NULL, NULL, 16746, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 10:28:46', 'admin-1518135973-1518143326253617', 1, 1, 'SR', NULL, NULL, NULL),
(63342, '2018-02-09 10:28:46', NULL, NULL, 16746, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 10:28:46', 'admin-1518135973-1518143326253617', 1, 1, 'SR', NULL, NULL, NULL),
(63343, '2018-02-09 11:02:52', NULL, NULL, 16749, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:02:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63344, '2018-02-09 00:00:00', NULL, NULL, 16750, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', NULL, 1, 3.70, NULL, NULL, 3.70, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:56:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63345, '2018-02-09 09:48:23', NULL, NULL, 16743, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:48:23', 'admin-1518135973-1518140902930321', 1, 1, 'SR', NULL, NULL, NULL),
(63346, '2018-02-09 09:48:23', NULL, NULL, 16743, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:48:23', 'admin-1518135973-1518140902930321', 1, 0, '', NULL, NULL, NULL),
(63347, '2018-02-09 09:03:37', NULL, NULL, 16741, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:03:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63348, '2018-02-09 11:42:23', NULL, NULL, 16757, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 11:42:23', 'admin-1518135973-1518147742965311', 1, 0, '', NULL, NULL, NULL),
(63349, '2018-02-09 09:46:45', NULL, NULL, 16742, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:46:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63350, '2018-02-09 09:06:23', NULL, NULL, 16740, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:06:23', 'admin-1518135973-1518138383070979', 1, 0, '', NULL, NULL, NULL),
(63351, '2018-02-09 09:06:23', NULL, NULL, 16740, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:06:23', 'admin-1518135973-1518138383070979', 1, 0, '', NULL, NULL, NULL),
(63352, '2018-02-09 09:06:23', NULL, NULL, 16740, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:06:23', 'admin-1518135973-1518138383070979', 1, 0, '', NULL, NULL, NULL),
(63353, '2018-02-09 09:03:51', NULL, NULL, 16741, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:03:51', 'admin-1518135973-15181382308953792', 1, 1, 'SR', NULL, NULL, NULL),
(63354, '2018-02-09 09:03:51', NULL, NULL, 16741, 0, 181, '116', 'Open Food ', 'junior BLT', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:03:51', 'admin-1518135973-15181382308953792', 1, 0, '', NULL, NULL, NULL),
(63355, '2018-02-09 09:02:08', NULL, NULL, 16740, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1518135973', 'admin', '2018-02-09 09:02:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63356, '2018-02-20 10:32:22', NULL, NULL, 16779, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1519091919', 'admin', '2018-02-20 10:32:22', 'admin-1519091919-15190939420387253', 1, 0, '', 1, NULL, NULL),
(63357, '2018-02-21 13:48:16', NULL, NULL, 16798, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:48:16', 'admin-1519190124-15191920959356038', 1, 1, 'SR', 1, NULL, NULL),
(63358, '2018-02-21 12:32:48', NULL, NULL, 16790, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:32:48', 'admin-1519173495-15191875687301829', 1, 0, '', NULL, NULL, NULL),
(63359, '2018-02-21 12:32:48', NULL, NULL, 16790, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:32:48', 'admin-1519173495-15191875687301829', 1, 0, '', NULL, NULL, NULL),
(63360, '2018-02-21 11:38:30', NULL, NULL, 16787, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1519190124', 'admin', '2018-02-21 11:38:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63361, '2018-02-21 11:40:24', NULL, NULL, 16787, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 11:40:24', 'admin-1519173495-1519184424014995', 1, 0, '', NULL, NULL, NULL),
(63362, '2018-02-21 11:40:24', NULL, NULL, 16787, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 11:40:24', 'admin-1519173495-1519184424014995', 1, 0, '', NULL, NULL, NULL),
(63363, '2018-02-21 11:40:24', NULL, NULL, 16787, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 11:40:24', 'admin-1519173495-1519184424014995', 1, 0, '', NULL, NULL, NULL),
(63364, '2018-02-21 11:40:24', NULL, NULL, 16787, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 11:40:24', 'admin-1519173495-1519184424014995', 1, 0, '', NULL, NULL, NULL),
(63365, '2018-02-21 11:46:52', NULL, NULL, 16788, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1519190124', 'admin', '2018-02-21 11:46:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63366, '2018-02-21 11:47:17', NULL, NULL, 16788, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 11:47:17', 'admin-1519173495-15191848371637310', 1, 0, '', NULL, NULL, NULL),
(63367, '2018-02-21 15:14:01', NULL, NULL, 16803, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 15:14:01', 'admin-1519190124-15191972418296492', 1, 0, '', NULL, NULL, NULL),
(63368, '2018-02-21 15:05:00', NULL, NULL, 16807, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 15:05:00', 'admin-1519190124-1519196700457715', 1, 0, '', NULL, NULL, NULL),
(63369, '2018-02-21 15:05:00', NULL, NULL, 16807, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 15:05:00', 'admin-1519190124-1519196700457715', 1, 0, '', NULL, NULL, NULL),
(63370, '2018-02-21 15:05:00', NULL, NULL, 16807, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 15:05:00', 'admin-1519190124-1519196700457715', 1, 1, 'SR', NULL, NULL, NULL),
(63371, '2018-02-21 00:00:00', NULL, NULL, 16805, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:39:09', 'admin-1519190124-15191915497414472', 1, 1, 'SR', NULL, NULL, NULL),
(63372, '2018-02-21 15:05:00', NULL, NULL, 16807, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 15:05:00', 'admin-1519190124-1519196700457715', 1, 0, '', NULL, NULL, NULL),
(63373, '2018-02-21 15:05:00', NULL, NULL, 16807, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 15:05:00', 'admin-1519190124-1519196700457715', 1, 0, '', NULL, NULL, NULL),
(63374, '2018-02-21 09:21:25', NULL, NULL, 16782, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:21:25', 'admin-1519173495-15191760850679556', 1, 0, '', NULL, NULL, NULL),
(63375, '2018-02-21 09:21:25', NULL, NULL, 16782, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:21:25', 'admin-1519173495-15191760850679556', 1, 0, '', NULL, NULL, NULL),
(63376, '2018-02-21 09:21:25', NULL, NULL, 16782, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:21:25', 'admin-1519173495-15191760850679556', 1, 1, 'SR', NULL, NULL, NULL),
(63377, '2018-02-21 09:22:53', NULL, NULL, 16783, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:22:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63378, '2018-02-21 09:23:03', NULL, NULL, 16783, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:23:03', 'admin-1519173495-15191761835143890', 1, 1, 'SR', NULL, NULL, NULL),
(63379, '2018-02-21 09:26:01', NULL, NULL, 16784, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:26:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63380, '2018-02-21 15:04:29', NULL, NULL, 16807, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1519190124', 'admin', '2018-02-21 15:04:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63381, '2018-02-21 14:41:02', NULL, NULL, 16806, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 14:41:02', 'admin-1519190124-15191952619374237', 1, 1, 'SR', NULL, NULL, NULL),
(63382, '2018-02-21 00:00:00', NULL, NULL, 16805, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:39:09', 'admin-1519190124-15191915497414472', 1, 0, '', NULL, NULL, NULL),
(63383, '2018-02-21 00:00:00', NULL, NULL, 16804, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:39:09', 'admin-1519190124-15191915497414472', 1, 0, '', NULL, NULL, NULL),
(63384, '2018-02-21 14:32:23', NULL, NULL, 16803, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 14:32:23', 'admin-1519190124-15191947431386123', 1, 0, '', NULL, NULL, NULL),
(63385, '2018-02-21 14:32:15', NULL, NULL, 16803, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1519190124', 'admin', '2018-02-21 14:32:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63386, '2018-02-21 12:36:01', NULL, NULL, 16791, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:36:01', 'admin-1519173495-15191877609534269', 1, 1, 'SR', NULL, NULL, '25.0'),
(63387, '2018-02-21 12:36:01', NULL, NULL, 16791, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:36:01', 'admin-1519173495-15191877609534269', 1, 0, '', NULL, NULL, '25.0'),
(63388, '2018-02-21 13:37:35', NULL, NULL, 16796, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:37:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63389, '2018-02-21 13:06:55', NULL, NULL, 16795, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:06:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63390, '2018-02-21 15:54:41', NULL, NULL, 16809, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1519190124', 'admin', '2018-02-21 15:54:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63391, '2018-02-21 15:54:50', NULL, NULL, 16809, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 15:54:50', 'admin-1519190124-15191996899281355', 1, 1, 'SR', NULL, NULL, NULL),
(63392, '2018-02-21 15:57:31', NULL, NULL, 16810, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1519190124', 'admin', '2018-02-21 15:57:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63393, '2018-02-21 15:57:41', NULL, NULL, 16810, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 15:57:41', 'admin-1519190124-15191998616227028', 1, 1, 'SR', NULL, NULL, NULL),
(63394, '2018-02-21 13:56:52', NULL, NULL, 16802, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:56:52', 'admin-1519190124-15191926122427737', 1, 1, 'SR', NULL, NULL, NULL),
(63395, '2018-02-21 13:56:40', NULL, NULL, 16802, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:56:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63396, '2018-02-21 13:54:35', NULL, NULL, 16801, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:54:35', 'admin-1519190124-15191924750357271', 1, 0, '', NULL, NULL, NULL),
(63397, '2018-02-21 13:44:49', NULL, NULL, 16797, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:44:49', 'admin-1519190124-15191918892827686', 1, 0, '', NULL, NULL, NULL),
(63398, '2018-02-21 13:54:01', NULL, NULL, 16800, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:54:01', 'admin-1519190124-15191924409663292', 1, 0, '', NULL, NULL, NULL),
(63399, '2018-02-21 16:31:15', NULL, NULL, 16812, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 16:31:15', 'admin-1519190124-15192018751472354', 1, 0, '', NULL, NULL, NULL),
(63400, '2018-02-21 16:30:39', NULL, NULL, 16812, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1519190124', 'admin', '2018-02-21 16:30:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63401, '2018-02-21 16:31:15', NULL, NULL, 16812, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 16:31:15', 'admin-1519190124-15192018751472354', 1, 1, 'SR', NULL, NULL, NULL),
(63402, '2018-02-21 15:37:06', NULL, NULL, 16808, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 15:37:06', 'admin-1519190124-1519198626480487', 1, 1, 'SR', NULL, NULL, NULL),
(63403, '2018-02-21 13:49:20', NULL, NULL, 16799, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:49:20', 'admin-1519190124-15191921607739578', 1, 0, '', NULL, NULL, NULL),
(63404, '2018-02-21 16:18:29', NULL, NULL, 16803, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 16:18:29', 'admin-1519190124-15192011096333240', 1, 0, '', NULL, NULL, NULL),
(63405, '2018-02-21 16:18:29', NULL, NULL, 16803, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 16:18:29', 'admin-1519190124-15192011096333240', 1, 0, '', NULL, NULL, NULL),
(63406, '2018-02-21 16:02:42', NULL, NULL, 16811, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 16:02:42', 'admin-1519190124-1519200162858856', 1, 0, '', 1, NULL, NULL),
(63407, '2018-02-21 16:01:49', NULL, NULL, 16810, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 16:01:49', 'admin-1519190124-15192001089088895', 1, 1, 'SR', NULL, NULL, NULL),
(63408, '2018-02-21 13:54:01', NULL, NULL, 16800, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:54:01', 'admin-1519190124-15191924409663292', 1, 0, '', NULL, NULL, NULL),
(63409, '2018-02-21 12:47:42', NULL, NULL, 16793, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:47:42', 'admin-1519173495-15191884625551572', 1, 1, 'SR', NULL, NULL, NULL),
(63410, '2018-02-21 13:56:21', NULL, NULL, 16800, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:56:21', 'admin-1519190124-151919258168488', 1, 0, '', NULL, NULL, NULL),
(63411, '2018-02-21 13:54:01', NULL, NULL, 16800, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:54:01', 'admin-1519190124-15191924409663292', 1, 1, 'SR', NULL, NULL, NULL),
(63412, '2018-02-21 13:50:06', NULL, NULL, 16800, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:50:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63413, '2018-02-21 13:48:53', NULL, NULL, 16799, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:48:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63414, '2018-02-21 13:49:20', NULL, NULL, 16799, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:49:20', 'admin-1519190124-15191921607739578', 1, 0, '', NULL, NULL, NULL),
(63415, '2018-02-21 13:07:44', NULL, NULL, 16795, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:07:44', 'admin-1519173495-1519189664513337', 1, 0, '', NULL, NULL, NULL),
(63416, '2018-02-21 13:49:20', NULL, NULL, 16799, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:49:20', 'admin-1519190124-15191921607739578', 1, 1, 'SR', NULL, NULL, NULL),
(63417, '2018-02-21 13:54:35', NULL, NULL, 16801, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:54:35', 'admin-1519190124-15191924750357271', 1, 0, '', NULL, NULL, NULL),
(63418, '2018-02-21 14:36:43', NULL, NULL, 16805, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1519190124', 'admin', '2018-02-21 14:36:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63419, '2018-02-21 14:36:04', NULL, NULL, 16804, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1519190124', 'admin', '2018-02-21 14:36:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63420, '2018-02-21 00:00:00', NULL, NULL, 16804, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:39:09', 'admin-1519190124-15191915497414472', 1, 1, 'SR', NULL, NULL, NULL),
(63421, '2018-02-21 13:44:25', NULL, NULL, 16797, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:44:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63422, '2018-02-21 13:44:49', NULL, NULL, 16797, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:44:49', 'admin-1519190124-15191918892827686', 1, 0, '', NULL, NULL, NULL),
(63423, '2018-02-21 13:37:49', NULL, NULL, 16796, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:37:49', 'admin-1519190124-15191914688958039', 1, 0, '', NULL, NULL, NULL),
(63424, '2018-02-21 13:11:59', NULL, NULL, 16794, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:11:59', 'admin-1519173495-1519189919507565', 1, 1, 'SR', NULL, NULL, NULL),
(63425, '2018-02-21 13:11:59', NULL, NULL, 16794, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:11:59', 'admin-1519173495-1519189919507565', 1, 1, 'SR', NULL, NULL, NULL),
(63426, '2018-02-21 13:11:59', NULL, NULL, 16794, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:11:59', 'admin-1519173495-1519189919507565', 1, 1, 'SR', NULL, NULL, NULL),
(63427, '2018-02-21 10:18:47', NULL, NULL, 16786, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 10:18:47', 'admin-1519173495-15191795269675384', 1, 0, '', NULL, NULL, NULL),
(63428, '2018-02-21 10:18:47', NULL, NULL, 16786, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 10:18:47', 'admin-1519173495-15191795269675384', 1, 1, 'SR', NULL, NULL, NULL),
(63429, '2018-02-21 13:49:20', NULL, NULL, 16799, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:49:20', 'admin-1519190124-15191921607739578', 1, 1, 'SR', NULL, NULL, NULL),
(63430, '2018-02-21 13:54:10', NULL, NULL, 16801, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:54:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63431, '2018-02-21 09:40:30', NULL, NULL, 16784, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:40:30', 'admin-1519173495-15191772301597074', 1, 1, 'SR', NULL, NULL, NULL),
(63432, '2018-02-21 13:11:59', NULL, NULL, 16794, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:11:59', 'admin-1519173495-1519189919507565', 1, 1, 'SR', NULL, NULL, NULL),
(63433, '2018-02-21 13:07:44', NULL, NULL, 16795, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:07:44', 'admin-1519173495-1519189664513337', 1, 1, 'SR', NULL, NULL, NULL),
(63434, '2018-02-21 14:40:55', NULL, NULL, 16806, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1519190124', 'admin', '2018-02-21 14:40:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63435, '2018-02-21 14:02:07', NULL, NULL, 16793, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 14:02:07', 'admin-1519190124-15191929274953455', 1, 1, 'SR', NULL, NULL, NULL),
(63436, '2018-02-21 12:36:01', NULL, NULL, 16791, 0, 181, '116', 'Open Food ', 'stew pork rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:36:01', 'admin-1519173495-15191877609534269', 1, 0, '', NULL, NULL, '25.0'),
(63437, '2018-02-21 12:22:37', NULL, NULL, 16789, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:22:37', 'admin-1519173495-1519186957793404', 1, 0, '', NULL, NULL, NULL),
(63438, '2018-02-21 12:22:37', NULL, NULL, 16789, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:22:37', 'admin-1519173495-1519186957793404', 1, 0, '', NULL, NULL, NULL),
(63439, '2018-02-21 12:47:42', NULL, NULL, 16793, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:47:42', 'admin-1519173495-15191884625551572', 1, 0, '', NULL, NULL, NULL),
(63440, '2018-02-21 12:47:42', NULL, NULL, 16793, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:47:42', 'admin-1519173495-15191884625551572', 1, 0, '', NULL, NULL, NULL),
(63441, '2018-02-21 12:22:37', NULL, NULL, 16789, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:22:37', 'admin-1519173495-1519186957793404', 1, 0, '', NULL, NULL, NULL),
(63442, '2018-02-21 12:53:49', NULL, NULL, 16794, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:53:49', 'admin-1519173495-15191888289351331', 1, 1, 'SR', NULL, NULL, NULL),
(63443, '2018-02-21 12:53:49', NULL, NULL, 16794, 0, 181, '116', 'Open Food ', 'stewed pork rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:53:49', 'admin-1519173495-15191888289351331', 1, 0, '', NULL, NULL, NULL),
(63444, '2018-02-21 12:53:12', NULL, NULL, 16794, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:53:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63445, '2018-02-21 12:47:42', NULL, NULL, 16793, 0, 301, '237', 'Black Jack', '', 'Cold Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:47:42', 'admin-1519173495-15191884625551572', 1, 0, '', NULL, NULL, NULL),
(63446, '2018-02-21 12:39:24', NULL, NULL, 16790, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:39:24', 'admin-1519173495-15191879645073563', 1, 0, '', NULL, NULL, NULL),
(63447, '2018-02-21 12:40:21', NULL, NULL, 16790, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:40:21', 'admin-1519173495-15191880213703218', 1, 0, '', NULL, NULL, NULL),
(63448, '2018-02-21 12:41:41', NULL, NULL, 16792, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:41:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63449, '2018-02-21 12:42:05', NULL, NULL, 16792, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:42:05', 'admin-1519173495-15191881253477418', 1, 1, 'SR', NULL, NULL, NULL),
(63450, '2018-02-21 09:21:25', NULL, NULL, 16782, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:21:25', 'admin-1519173495-15191760850679556', 1, 0, '', NULL, NULL, NULL),
(63451, '2018-02-21 09:21:25', NULL, NULL, 16782, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:21:25', 'admin-1519173495-15191760850679556', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(63452, '2018-02-21 12:47:42', NULL, NULL, 16793, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:47:42', 'admin-1519173495-15191884625551572', 1, 1, 'SR', NULL, NULL, NULL),
(63453, '2018-02-21 12:47:13', NULL, NULL, 16793, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.80, 0.0000, 0.0000, 10.80, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:47:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63454, '2018-02-21 12:47:42', NULL, NULL, 16793, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:47:42', 'admin-1519173495-15191884625551572', 1, 0, '', NULL, NULL, NULL),
(63455, '2018-02-21 12:34:55', NULL, NULL, 16790, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:34:55', 'admin-1519173495-151918769500065', 1, 1, 'SR', NULL, NULL, NULL),
(63456, '2018-02-21 12:32:48', NULL, NULL, 16790, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:32:48', 'admin-1519173495-15191875687301829', 1, 1, 'SR', NULL, NULL, NULL),
(63457, '2018-02-21 09:26:21', NULL, NULL, 16784, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:26:21', 'admin-1519173495-15191763815879580', 1, 1, 'SR', NULL, NULL, NULL),
(63458, '2018-02-21 12:45:44', NULL, NULL, 16792, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:45:44', 'admin-1519173495-15191883445151530', 1, 1, 'SR', NULL, NULL, NULL),
(63459, '2018-02-21 14:02:07', NULL, NULL, 16793, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 14:02:07', 'admin-1519190124-15191929274953455', 1, 1, 'SR', NULL, NULL, NULL),
(63460, '2018-02-21 12:36:01', NULL, NULL, 16791, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:36:01', 'admin-1519173495-15191877609534269', 1, 1, 'SR', NULL, NULL, '25.0'),
(63461, '2018-02-21 12:35:04', NULL, NULL, 16791, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:35:04', '0', 1, 1, 'SR', NULL, NULL, '25.0'),
(63462, '2018-02-21 15:36:57', NULL, NULL, 16808, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1519190124', 'admin', '2018-02-21 15:36:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63463, '2018-02-21 12:29:34', NULL, NULL, 16790, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:29:34', 'admin-1519173495-15191873743366822', 1, 1, 'SR', NULL, NULL, NULL),
(63464, '2018-02-21 12:29:34', NULL, NULL, 16790, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:29:34', 'admin-1519173495-15191873743366822', 1, 1, 'SR', NULL, NULL, NULL),
(63465, '2018-02-21 13:37:49', NULL, NULL, 16796, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 13:37:49', 'admin-1519190124-15191914688958039', 1, 1, 'SR', NULL, NULL, NULL),
(63466, '2018-02-21 12:29:34', NULL, NULL, 16790, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:29:34', 'admin-1519173495-15191873743366822', 1, 1, 'SR', NULL, NULL, NULL),
(63467, '2018-02-21 12:28:58', NULL, NULL, 16790, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 11.30, 0.0000, 0.0000, 11.30, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:28:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63468, '2018-02-21 12:21:53', NULL, NULL, 16789, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:21:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63469, '2018-02-21 11:47:17', NULL, NULL, 16788, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 11:47:17', 'admin-1519173495-15191848371637310', 1, 0, '', NULL, NULL, NULL),
(63470, '2018-02-21 12:22:37', NULL, NULL, 16789, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 12:22:37', 'admin-1519173495-1519186957793404', 1, 0, '', NULL, NULL, NULL),
(63471, '2018-02-21 11:47:17', NULL, NULL, 16788, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 11:47:17', 'admin-1519173495-15191848371637310', 1, 1, 'SR', NULL, NULL, NULL),
(63472, '2018-02-21 11:47:17', NULL, NULL, 16788, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 11:47:17', 'admin-1519173495-15191848371637310', 1, 0, '', NULL, NULL, NULL),
(63473, '2018-02-21 09:44:52', NULL, NULL, 16785, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:44:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63474, '2018-02-21 09:45:08', NULL, NULL, 16785, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:45:08', 'admin-1519173495-1519177508342922', 1, 0, '', NULL, NULL, NULL),
(63475, '2018-02-21 09:45:08', NULL, NULL, 16785, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:45:08', 'admin-1519173495-1519177508342922', 1, 1, 'SR', NULL, NULL, NULL),
(63476, '2018-02-21 09:58:30', NULL, NULL, 16786, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:58:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63477, '2018-02-21 09:58:37', NULL, NULL, 16786, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:58:37', 'admin-1519173495-15191783177658357', 1, 1, 'SR', NULL, NULL, NULL),
(63478, '2018-02-21 09:26:21', NULL, NULL, 16784, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:26:21', 'admin-1519173495-15191763815879580', 1, 0, '', NULL, NULL, NULL),
(63479, '2018-02-21 09:28:02', NULL, NULL, 16784, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:28:02', 'admin-1519173495-15191764828188741', 1, 1, 'SR', NULL, NULL, NULL),
(63480, '2018-02-21 09:26:21', NULL, NULL, 16784, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:26:21', 'admin-1519173495-15191763815879580', 1, 0, '', NULL, NULL, NULL),
(63481, '2018-02-21 15:05:00', NULL, NULL, 16807, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 15:05:00', 'admin-1519190124-1519196700457715', 1, 1, 'SR', NULL, NULL, NULL),
(63482, '2018-02-21 09:21:25', NULL, NULL, 16782, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:21:25', 'admin-1519173495-15191760850679556', 1, 0, '', NULL, NULL, NULL),
(63483, '2018-02-21 09:15:39', NULL, NULL, 16781, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:15:39', 'admin-1519173495-15191757395379524', 1, 1, 'SR', NULL, NULL, NULL),
(63484, '2018-02-21 09:20:34', NULL, NULL, 16782, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:20:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63485, '2018-02-21 09:11:57', NULL, NULL, 16781, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:11:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63486, '2018-02-21 09:15:39', NULL, NULL, 16781, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:15:39', 'admin-1519173495-15191757395379524', 1, 1, 'SR', NULL, NULL, NULL),
(63487, '2018-02-21 09:40:30', NULL, NULL, 16784, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:40:30', 'admin-1519173495-15191772301597074', 1, 0, '', NULL, NULL, NULL),
(63488, '2018-02-21 09:15:39', NULL, NULL, 16781, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:15:39', 'admin-1519173495-15191757395379524', 1, 0, '', NULL, NULL, NULL),
(63489, '2018-02-21 09:15:39', NULL, NULL, 16781, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519190124', 'admin', '2018-02-21 09:15:39', 'admin-1519173495-15191757395379524', 1, 0, '', NULL, NULL, NULL),
(63490, '2018-02-22 13:04:49', NULL, NULL, 16829, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 13:04:49', 'admin-1519261074-1519275888941886', 1, 1, 'SR', NULL, NULL, NULL),
(63491, '2018-02-22 10:26:01', NULL, NULL, 16816, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 10:26:01', 'admin-1519261074-15192663612443880', 1, 0, '', NULL, NULL, NULL),
(63492, '2018-02-22 10:26:01', NULL, NULL, 16816, 0, 181, '116', 'Open Food ', 'bacon', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 10:26:01', 'admin-1519261074-15192663612443880', 1, 0, '', NULL, NULL, NULL),
(63493, '2018-02-22 10:26:01', NULL, NULL, 16816, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 10:26:01', 'admin-1519261074-15192663612443880', 1, 1, 'SR', NULL, NULL, NULL),
(63494, '2018-02-22 10:26:01', NULL, NULL, 16816, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 10:26:01', 'admin-1519261074-15192663612443880', 1, 1, 'SR', NULL, NULL, NULL),
(63495, '2018-02-22 10:43:48', NULL, NULL, 16817, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1519261074', 'admin', '2018-02-22 10:43:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63496, '2018-02-22 10:44:36', NULL, NULL, 16817, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 10:44:36', 'admin-1519261074-15192674768259064', 1, 0, '', NULL, NULL, NULL),
(63497, '2018-02-22 09:48:14', NULL, NULL, 16814, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 09:48:14', 'admin-1519261074-15192640940653734', 1, 1, 'SR', NULL, NULL, NULL),
(63498, '2018-02-22 10:11:41', NULL, NULL, 16815, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1519261074', 'admin', '2018-02-22 10:11:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63499, '2018-02-22 12:56:12', NULL, NULL, 16827, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:56:12', 'admin-1519261074-1519275372725142', 1, 0, '', NULL, NULL, NULL),
(63500, '2018-02-22 12:13:22', NULL, NULL, 16823, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:13:22', 'admin-1519261074-15192728023048994', 1, 0, '', NULL, NULL, NULL),
(63501, '2018-02-22 12:59:39', NULL, NULL, 16828, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:59:39', 'admin-1519261074-15192755790879382', 1, 1, 'SR', NULL, NULL, NULL),
(63502, '2018-02-22 12:59:39', NULL, NULL, 16828, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:59:39', 'admin-1519261074-15192755790879382', 1, 0, '', NULL, NULL, NULL),
(63503, '2018-02-22 13:19:50', NULL, NULL, 16831, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 13:19:50', 'admin-1519261074-15192767900204258', 1, 1, 'SR', NULL, NULL, NULL),
(63504, '2018-02-22 12:47:40', NULL, NULL, 16826, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:47:40', 'admin-1519261074-15192748598756798', 1, 1, 'SR', NULL, NULL, NULL),
(63505, '2018-02-22 12:55:38', NULL, NULL, 16823, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:55:38', 'admin-1519261074-15192753387845330', 1, 1, 'SR', NULL, NULL, NULL),
(63506, '2018-02-22 12:47:40', NULL, NULL, 16826, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:47:40', 'admin-1519261074-15192748598756798', 1, 0, '', NULL, NULL, NULL),
(63507, '2018-02-22 12:47:40', NULL, NULL, 16826, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:47:40', 'admin-1519261074-15192748598756798', 1, 0, '', NULL, NULL, NULL),
(63508, '2018-02-22 15:39:32', NULL, NULL, 16837, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1519261074', 'admin', '2018-02-22 15:39:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63509, '2018-02-22 15:40:23', NULL, NULL, 16837, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 15:40:23', 'admin-1519261074-1519285222874435', 1, 1, 'SR', NULL, NULL, NULL),
(63510, '2018-02-22 15:40:23', NULL, NULL, 16837, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 15:40:23', 'admin-1519261074-1519285222874435', 1, 1, 'SR', NULL, NULL, NULL),
(63511, '2018-02-22 15:40:23', NULL, NULL, 16837, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 15:40:23', 'admin-1519261074-1519285222874435', 1, 1, 'SR', NULL, NULL, NULL),
(63512, '2018-02-22 12:55:51', NULL, NULL, 16827, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:55:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63513, '2018-02-22 12:56:12', NULL, NULL, 16827, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:56:12', 'admin-1519261074-1519275372725142', 1, 0, '', NULL, NULL, NULL),
(63514, '2018-02-22 12:56:12', NULL, NULL, 16827, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:56:12', 'admin-1519261074-1519275372725142', 1, 0, '', NULL, NULL, NULL),
(63515, '2018-02-22 13:04:11', NULL, NULL, 16829, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1519261074', 'admin', '2018-02-22 13:04:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63516, '2018-02-22 13:04:49', NULL, NULL, 16829, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 13:04:49', 'admin-1519261074-1519275888941886', 1, 1, 'SR', NULL, NULL, NULL),
(63517, '2018-02-22 13:15:07', NULL, NULL, 16830, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 13:15:07', 'admin-1519261074-15192765076667752', 1, 0, '', NULL, NULL, NULL),
(63518, '2018-02-22 13:15:07', NULL, NULL, 16830, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 13:15:07', 'admin-1519261074-15192765076667752', 1, 1, 'SR', NULL, NULL, NULL),
(63519, '2018-02-22 15:40:23', NULL, NULL, 16837, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 15:40:23', 'admin-1519261074-1519285222874435', 1, 1, 'SR', NULL, NULL, NULL),
(63520, '2018-02-22 12:13:22', NULL, NULL, 16823, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:13:22', 'admin-1519261074-15192728023048994', 1, 0, '', NULL, NULL, NULL),
(63521, '2018-02-22 12:27:13', NULL, NULL, 16824, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:27:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63522, '2018-02-22 12:02:32', NULL, NULL, 16822, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:02:32', 'admin-1519261074-15192721518965073', 1, 0, '', NULL, NULL, NULL),
(63523, '2018-02-22 13:41:25', NULL, NULL, 16834, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 13:41:25', 'admin-1519261074-15192780857256260', 1, 1, 'SR', NULL, NULL, NULL),
(63524, '2018-02-22 15:29:03', NULL, NULL, 16835, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 15:29:03', 'admin-1519261074-15192845434349590', 1, 0, '', NULL, NULL, NULL),
(63525, '2018-02-22 12:37:56', NULL, NULL, 16820, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:37:56', 'admin-1519261074-1519274276143442', 1, 1, 'SR', NULL, NULL, '10.0'),
(63526, '2018-02-22 12:39:04', NULL, NULL, 16825, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:39:04', 'admin-1519261074-15192743439591041', 1, 1, 'SR', NULL, NULL, '10.0'),
(63527, '2018-02-22 12:39:04', NULL, NULL, 16825, 0, 181, '116', 'Open Food ', 'pepper pork rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:39:04', 'admin-1519261074-15192743439591041', 1, 0, '', NULL, NULL, '10.0'),
(63528, '2018-02-22 15:28:40', NULL, NULL, 16835, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1519261074', 'admin', '2018-02-22 15:28:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63529, '2018-02-22 00:00:00', NULL, NULL, 16833, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:33:23', 'admin-1519261074-15192740033597960', 1, 0, '', NULL, NULL, '10.0'),
(63530, '2018-02-22 13:41:08', NULL, NULL, 16834, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1519261074', 'admin', '2018-02-22 13:41:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63531, '2018-02-22 13:41:25', NULL, NULL, 16834, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 13:41:25', 'admin-1519261074-15192780857256260', 1, 0, '', NULL, NULL, NULL),
(63532, '2018-02-22 12:13:22', NULL, NULL, 16823, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:13:22', 'admin-1519261074-15192728023048994', 1, 0, '', NULL, NULL, NULL),
(63533, '2018-02-22 13:45:51', NULL, NULL, 16820, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 13:45:51', 'admin-1519261074-15192783515025098', 1, 1, 'SR', NULL, NULL, '10.0'),
(63534, '2018-02-22 12:28:11', NULL, NULL, 16824, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:28:11', 'admin-1519261074-15192736909304513', 1, 0, '', NULL, NULL, NULL),
(63535, '2018-02-22 13:26:20', NULL, NULL, 16832, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 13:26:20', 'admin-1519261074-15192771805345930', 1, 0, '', NULL, NULL, NULL),
(63536, '2018-02-22 13:25:58', NULL, NULL, 16832, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1519261074', 'admin', '2018-02-22 13:25:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63537, '2018-02-22 13:26:20', NULL, NULL, 16832, 0, 181, '116', 'Open Food ', 'pepper pork rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 13:26:20', 'admin-1519261074-15192771805345930', 1, 0, '', NULL, NULL, NULL),
(63538, '2018-02-22 13:49:52', NULL, NULL, 16825, 0, 234, '168', 'Naughty Boy', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 13:49:52', 'admin-1519261074-1519278592253137', 1, 0, '', NULL, NULL, '10.0'),
(63539, '2018-02-22 13:19:50', NULL, NULL, 16831, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 13:19:50', 'admin-1519261074-15192767900204258', 1, 0, '', NULL, NULL, NULL),
(63540, '2018-02-22 13:15:07', NULL, NULL, 16830, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 13:15:07', 'admin-1519261074-15192765076667752', 1, 0, '', NULL, NULL, NULL),
(63541, '2018-02-22 12:02:32', NULL, NULL, 16822, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:02:32', 'admin-1519261074-15192721518965073', 1, 1, 'SR', NULL, NULL, NULL),
(63542, '2018-02-22 00:00:00', NULL, NULL, 16833, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, NULL, NULL, 18.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:05:58', 'admin-1519261074-15192723586238745', 1, 1, 'SR', NULL, NULL, '10.0'),
(63543, '2018-02-22 00:00:00', NULL, NULL, 16833, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 11:41:06', 'admin-1519261074-15192708662622637', 1, 1, 'SR', NULL, NULL, '10.0'),
(63544, '2018-02-22 10:58:42', NULL, NULL, 16818, 0, 338, '274', 'Chocolate Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 10:58:42', 'admin-1519261074-15192683226277748', 1, 0, '', NULL, NULL, '10.0'),
(63545, '2018-02-22 12:59:39', NULL, NULL, 16828, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:59:39', 'admin-1519261074-15192755790879382', 1, 1, 'SR', NULL, NULL, NULL),
(63546, '2018-02-22 00:00:00', NULL, NULL, 16833, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:05:58', 'admin-1519261074-15192723586238745', 1, 1, 'SR', NULL, NULL, '10.0'),
(63547, '2018-02-22 13:14:39', NULL, NULL, 16830, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1519261074', 'admin', '2018-02-22 13:14:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63548, '2018-02-22 12:59:39', NULL, NULL, 16828, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:59:39', 'admin-1519261074-15192755790879382', 1, 1, 'SR', NULL, NULL, NULL),
(63549, '2018-02-22 10:26:01', NULL, NULL, 16816, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 10:26:01', 'admin-1519261074-15192663612443880', 1, 0, '', NULL, NULL, NULL),
(63550, '2018-02-22 12:59:13', NULL, NULL, 16828, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:59:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63551, '2018-02-22 13:37:55', NULL, NULL, 16833, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, '1519261074', 'admin', '2018-02-22 13:37:55', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(63552, '2018-02-22 00:00:00', NULL, NULL, 16833, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 11:41:06', 'admin-1519261074-15192708662622637', 1, 1, 'SR', NULL, NULL, '10.0'),
(63553, '2018-02-22 11:47:56', NULL, NULL, 16821, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1519261074', 'admin', '2018-02-22 11:47:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63554, '2018-02-22 11:48:49', NULL, NULL, 16821, 0, 181, '116', 'Open Food ', 'peppep pork rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 11:48:49', 'admin-1519261074-15192713295589680', 1, 0, '', NULL, NULL, NULL),
(63555, '2018-02-22 12:28:11', NULL, NULL, 16824, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:28:11', 'admin-1519261074-15192736909304513', 1, 1, 'SR', NULL, NULL, NULL),
(63556, '2018-02-22 12:28:11', NULL, NULL, 16824, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:28:11', 'admin-1519261074-15192736909304513', 1, 0, '', NULL, NULL, NULL),
(63557, '2018-02-22 12:02:32', NULL, NULL, 16822, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:02:32', 'admin-1519261074-15192721518965073', 1, 1, 'SR', NULL, NULL, NULL),
(63558, '2018-02-22 12:47:40', NULL, NULL, 16826, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:47:40', 'admin-1519261074-15192748598756798', 1, 1, 'SR', NULL, NULL, NULL),
(63559, '2018-02-22 12:47:40', NULL, NULL, 16826, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:47:40', 'admin-1519261074-15192748598756798', 1, 0, '', NULL, NULL, NULL),
(63560, '2018-02-22 12:47:40', NULL, NULL, 16826, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:47:40', 'admin-1519261074-15192748598756798', 1, 0, '', NULL, NULL, NULL),
(63561, '2018-02-22 12:47:40', NULL, NULL, 16826, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:47:40', 'admin-1519261074-15192748598756798', 1, 0, '', NULL, NULL, NULL),
(63562, '2018-02-22 12:46:54', NULL, NULL, 16826, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 12.40, 0.0000, 0.0000, 12.40, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:46:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63563, '2018-02-22 09:48:14', NULL, NULL, 16814, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 09:48:14', 'admin-1519261074-15192640940653734', 1, 0, '', NULL, NULL, NULL),
(63564, '2018-02-22 09:48:14', NULL, NULL, 16814, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 09:48:14', 'admin-1519261074-15192640940653734', 1, 0, '', NULL, NULL, NULL),
(63565, '2018-02-22 13:19:24', NULL, NULL, 16831, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1519261074', 'admin', '2018-02-22 13:19:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63566, '2018-02-22 12:33:48', NULL, NULL, 16825, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:33:48', 'admin-1519261074-15192740283793891', 1, 0, '', NULL, NULL, '10.0'),
(63567, '2018-02-22 00:00:00', NULL, NULL, 16833, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 2, 8.00, NULL, NULL, 16.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:30:28', 'admin-1519261074-15192738286779391', 1, 1, 'SR', NULL, NULL, '10.0'),
(63568, '2018-02-22 12:33:39', NULL, NULL, 16825, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:33:39', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(63569, '2018-02-22 12:13:22', NULL, NULL, 16823, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:13:22', 'admin-1519261074-15192728023048994', 1, 1, 'SR', NULL, NULL, NULL),
(63570, '2018-02-22 16:24:59', NULL, NULL, 16838, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 16:24:59', 'admin-1519261074-15192878989689665', 1, 1, 'SR', 1, NULL, NULL),
(63571, '2018-02-22 09:24:23', NULL, NULL, 16813, 0, 328, '264', 'Basic Blueberries Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 09:24:23', 'admin-1519261074-15192626634169718', 1, 0, '', NULL, NULL, NULL),
(63572, '2018-02-22 12:13:22', NULL, NULL, 16823, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:13:22', 'admin-1519261074-15192728023048994', 1, 0, '', NULL, NULL, NULL),
(63573, '2018-02-22 12:13:22', NULL, NULL, 16823, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:13:22', 'admin-1519261074-15192728023048994', 1, 0, '', NULL, NULL, NULL),
(63574, '2018-02-22 12:47:40', NULL, NULL, 16826, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:47:40', 'admin-1519261074-15192748598756798', 1, 1, 'SR', NULL, NULL, NULL),
(63575, '2018-02-22 12:13:22', NULL, NULL, 16823, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:13:22', 'admin-1519261074-15192728023048994', 1, 0, '', NULL, NULL, NULL),
(63576, '2018-02-22 12:28:11', NULL, NULL, 16824, 0, 153, '87', 'Wake Me Up!', 'no bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:28:11', 'admin-1519261074-15192736909304513', 1, 0, '', NULL, NULL, NULL),
(63577, '2018-02-22 12:01:02', NULL, NULL, 16822, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:01:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63578, '2018-02-22 12:01:10', NULL, NULL, 16823, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 15.80, 0.0000, 0.0000, 15.80, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:01:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63579, '2018-02-22 12:02:32', NULL, NULL, 16822, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:02:32', 'admin-1519261074-15192721518965073', 1, 1, 'SR', NULL, NULL, NULL),
(63580, '2018-02-22 12:28:11', NULL, NULL, 16824, 0, 153, '87', 'Wake Me Up!', 'no bacon', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:28:11', 'admin-1519261074-15192736909304513', 1, 0, '', NULL, NULL, NULL),
(63581, '2018-02-22 15:33:26', NULL, NULL, 16836, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 15:33:26', 'admin-1519261074-1519284806731317', 1, 0, '', 1, NULL, '10.0'),
(63582, '2018-02-22 12:02:32', NULL, NULL, 16822, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:02:32', 'admin-1519261074-15192721518965073', 1, 1, 'SR', NULL, NULL, NULL),
(63583, '2018-02-22 11:48:49', NULL, NULL, 16821, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 11:48:49', 'admin-1519261074-15192713295589680', 1, 0, '', NULL, NULL, NULL),
(63584, '2018-02-22 11:40:55', NULL, NULL, 16820, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1519261074', 'admin', '2018-02-22 11:40:55', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(63585, '2018-02-22 11:31:44', NULL, NULL, 16819, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1519261074', 'admin', '2018-02-22 11:31:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63586, '2018-02-22 11:32:03', NULL, NULL, 16819, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 11:32:03', 'admin-1519261074-15192703229906160', 1, 1, 'SR', NULL, NULL, NULL),
(63587, '2018-02-22 10:58:42', NULL, NULL, 16818, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 10:58:42', 'admin-1519261074-15192683226277748', 1, 1, 'SR', NULL, NULL, '10.0'),
(63588, '2018-02-22 10:58:42', NULL, NULL, 16818, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 10:58:42', 'admin-1519261074-15192683226277748', 1, 0, '', NULL, NULL, '10.0'),
(63589, '2018-02-22 10:58:42', NULL, NULL, 16818, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 10:58:42', 'admin-1519261074-15192683226277748', 1, 0, '', NULL, NULL, '10.0'),
(63590, '2018-02-22 10:58:15', NULL, NULL, 16818, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1519261074', 'admin', '2018-02-22 10:58:15', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(63591, '2018-02-22 10:11:54', NULL, NULL, 16815, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 10:11:54', 'admin-1519261074-15192655142936760', 1, 0, '', NULL, NULL, NULL),
(63592, '2018-02-22 10:24:52', NULL, NULL, 16816, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 10:24:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63593, '2018-02-22 10:11:54', NULL, NULL, 16815, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 10:11:54', 'admin-1519261074-15192655142936760', 1, 1, 'SR', NULL, NULL, NULL),
(63594, '2018-02-22 12:13:22', NULL, NULL, 16823, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 12:13:22', 'admin-1519261074-15192728023048994', 1, 1, 'SR', NULL, NULL, NULL),
(63595, '2018-02-22 09:48:14', NULL, NULL, 16814, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 09:48:14', 'admin-1519261074-15192640940653734', 1, 1, 'SR', NULL, NULL, NULL),
(63596, '2018-02-22 09:24:23', NULL, NULL, 16813, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 09:24:23', 'admin-1519261074-15192626634169718', 1, 1, 'SR', NULL, NULL, NULL),
(63597, '2018-02-22 09:24:23', NULL, NULL, 16813, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 09:24:23', 'admin-1519261074-15192626634169718', 1, 0, '', NULL, NULL, NULL),
(63598, '2018-02-22 09:24:23', NULL, NULL, 16813, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 09:24:23', 'admin-1519261074-15192626634169718', 1, 1, 'SR', NULL, NULL, NULL),
(63599, '2018-02-22 09:47:41', NULL, NULL, 16814, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1519261074', 'admin', '2018-02-22 09:47:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63600, '2018-02-22 09:24:23', NULL, NULL, 16813, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 09:24:23', 'admin-1519261074-15192626634169718', 1, 0, '', NULL, NULL, NULL),
(63601, '2018-02-22 09:24:23', NULL, NULL, 16813, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519261074', 'admin', '2018-02-22 09:24:23', 'admin-1519261074-15192626634169718', 1, 0, '', NULL, NULL, NULL),
(63602, '2018-02-22 09:23:12', NULL, NULL, 16813, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1519261074', 'admin', '2018-02-22 09:23:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63603, '2018-02-23 13:14:41', NULL, NULL, 16852, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:14:41', 'admin-1519348637-15193628817141230', 1, 1, 'SR', NULL, NULL, '10.0'),
(63604, '2018-02-23 13:14:41', NULL, NULL, 16852, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:14:41', 'admin-1519348637-15193628817141230', 1, 1, 'SR', NULL, NULL, '10.0'),
(63605, '2018-02-23 13:14:41', NULL, NULL, 16852, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:14:41', 'admin-1519348637-15193628817141230', 1, 0, '', NULL, NULL, '10.0'),
(63606, '2018-02-23 14:17:51', NULL, NULL, 16856, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1519348637', 'admin', '2018-02-23 14:17:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63607, '2018-02-23 14:17:56', NULL, NULL, 16856, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 14:17:56', 'admin-1519348637-1519366676105732', 1, 1, 'SR', NULL, NULL, NULL),
(63608, '2018-02-23 14:25:03', NULL, NULL, 16857, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1519348637', 'admin', '2018-02-23 14:25:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63609, '2018-02-23 14:26:00', NULL, NULL, 16857, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 14:26:00', 'admin-1519348637-15193671599808327', 1, 1, 'SR', NULL, NULL, NULL),
(63610, '2018-02-23 14:26:00', NULL, NULL, 16857, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 14:26:00', 'admin-1519348637-15193671599808327', 1, 1, 'SR', NULL, NULL, NULL),
(63611, '2018-02-23 14:26:00', NULL, NULL, 16857, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 14:26:00', 'admin-1519348637-15193671599808327', 1, 0, '', NULL, NULL, NULL),
(63612, '2018-02-23 10:49:24', NULL, NULL, 16843, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 10:49:24', 'admin-1519348637-15193541643059991', 1, 0, '', NULL, NULL, NULL),
(63613, '2018-02-23 12:49:21', NULL, NULL, 16850, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 12:49:21', 'admin-1519348637-15193613611102963', 1, 0, '', NULL, NULL, '10.0'),
(63614, '2018-02-23 14:42:05', NULL, NULL, 16858, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 14:42:05', 'admin-1519348637-1519368124951952', 1, 1, 'SR', NULL, NULL, NULL),
(63615, '2018-02-23 14:14:14', NULL, NULL, 16855, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 14:14:14', 'admin-1519348637-15193664543915992', 1, 0, '', NULL, NULL, NULL),
(63616, '2018-02-23 14:14:14', NULL, NULL, 16855, 0, 181, '116', 'Open Food ', 'pepper', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 14:14:14', 'admin-1519348637-15193664543915992', 1, 0, '', NULL, NULL, NULL),
(63617, '2018-02-23 17:04:36', NULL, NULL, 16865, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 17:04:36', 'admin-1519348637-15193766760829669', 1, 0, '', NULL, NULL, NULL),
(63618, '2018-02-23 15:23:30', NULL, NULL, 16859, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.00, 0.0000, 0.0000, 10.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 15:23:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63619, '2018-02-23 13:08:26', NULL, NULL, 16851, 0, 181, '116', 'Open Food ', 'peppa pork', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:08:26', 'admin-1519348637-15193625066169085', 1, 0, '', NULL, NULL, NULL),
(63620, '2018-02-23 13:08:26', NULL, NULL, 16851, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:08:26', 'admin-1519348637-15193625066169085', 1, 1, 'SR', NULL, NULL, NULL),
(63621, '2018-02-23 16:53:18', NULL, NULL, 16864, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 16:53:18', 'admin-1519348637-15193759979396776', 1, 1, 'SR', NULL, NULL, NULL),
(63622, '2018-02-23 16:53:18', NULL, NULL, 16864, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 16:53:18', 'admin-1519348637-15193759979396776', 1, 0, '', NULL, NULL, NULL),
(63623, '2018-02-23 12:15:10', NULL, NULL, 16848, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 12:15:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63624, '2018-02-23 12:15:25', NULL, NULL, 16848, 0, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 12:15:25', 'admin-1519348637-15193593257173375', 1, 1, 'SR', NULL, NULL, NULL),
(63625, '2018-02-23 12:15:25', NULL, NULL, 16848, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 12:15:25', 'admin-1519348637-15193593257173375', 1, 1, 'SR', NULL, NULL, NULL),
(63626, '2018-02-23 12:28:30', NULL, NULL, 16849, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1519348637', 'admin', '2018-02-23 12:28:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63627, '2018-02-23 16:42:24', NULL, NULL, 16863, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 16:42:24', 'admin-1519348637-15193753440113458', 1, 1, 'SR', NULL, NULL, NULL),
(63628, '2018-02-23 16:42:24', NULL, NULL, 16863, 0, 50, '50', 'Espresso Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 16:42:24', 'admin-1519348637-15193753440113458', 1, 1, 'SR', NULL, NULL, NULL),
(63629, '2018-02-23 15:29:32', NULL, NULL, 16859, 0, 51, '51', 'Chocolate Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 15:29:32', 'admin-1519348637-15193709723854824', 1, 1, 'SR', NULL, NULL, NULL),
(63630, '2018-02-23 14:42:05', NULL, NULL, 16858, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 14:42:05', 'admin-1519348637-1519368124951952', 1, 1, 'SR', NULL, NULL, NULL),
(63631, '2018-02-23 14:49:58', NULL, NULL, 16858, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Rice', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 14:49:58', 'admin-1519348637-15193685982217022', 1, 0, '', NULL, NULL, NULL),
(63632, '2018-02-23 13:14:41', NULL, NULL, 16852, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:14:41', 'admin-1519348637-15193628817141230', 1, 1, 'SR', NULL, NULL, '10.0'),
(63633, '2018-02-23 16:42:03', NULL, NULL, 16862, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 16:42:03', 'admin-1519348637-15193753236632925', 1, 1, 'SR', NULL, NULL, NULL),
(63634, '2018-02-23 13:19:46', NULL, NULL, 16853, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:19:46', 'admin-1519348637-15193631868456649', 1, 0, '', NULL, NULL, NULL),
(63635, '2018-02-23 13:21:51', NULL, NULL, 16851, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:21:51', 'admin-1519348637-15193633112801939', 1, 0, '', NULL, NULL, NULL),
(63636, '2018-02-23 16:08:51', NULL, NULL, 16861, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 16:08:51', 'admin-1519348637-15193733312611589', 1, 0, '', 1, NULL, NULL),
(63637, '2018-02-23 15:55:57', NULL, NULL, 16860, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 2, 16.00, 32.0000, 0.0000, 32.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 15:55:57', 'admin-1519348637-15193725572928767', 1, 0, '', 1, NULL, NULL),
(63638, '2018-02-23 12:13:03', NULL, NULL, 16846, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1519348637', 'admin', '2018-02-23 12:13:03', '0', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(63639, '2018-02-23 12:13:31', NULL, NULL, 16846, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 12:13:31', 'admin-1519348637-15193592115426868', 1, 0, '', NULL, NULL, NULL),
(63640, '2018-02-23 16:08:51', NULL, NULL, 16861, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 16:08:51', 'admin-1519348637-15193733312611589', 1, 1, 'SR', 1, NULL, NULL),
(63641, '2018-02-23 13:42:59', NULL, NULL, 16854, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:42:59', 'admin-1519348637-1519364579254835', 1, 0, '', NULL, NULL, NULL),
(63642, '2018-02-23 15:23:44', NULL, NULL, 16859, 0, 289, '223', 'Pork Bacon Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 15:23:44', 'admin-1519348637-15193706243545386', 1, 0, '', NULL, NULL, NULL),
(63643, '2018-02-23 14:30:21', NULL, NULL, 16854, 0, 233, '167', 'Naugthy Girl', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 14:30:21', 'admin-1519348637-15193674210047927', 1, 0, '', NULL, NULL, NULL),
(63644, '2018-02-23 13:14:41', NULL, NULL, 16852, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:14:41', 'admin-1519348637-15193628817141230', 1, 1, 'SR', NULL, NULL, '10.0'),
(63645, '2018-02-23 16:41:58', NULL, NULL, 16862, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1519348637', 'admin', '2018-02-23 16:41:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63646, '2018-02-23 12:13:31', NULL, NULL, 16846, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 12:13:31', 'admin-1519348637-15193592115426868', 1, 0, '', NULL, NULL, NULL),
(63647, '2018-02-23 14:42:05', NULL, NULL, 16858, 0, 181, '116', 'Open Food ', 'pepper pork rice', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 14:42:05', 'admin-1519348637-1519368124951952', 1, 0, '', NULL, NULL, NULL),
(63648, '2018-02-23 14:08:12', NULL, NULL, 16851, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 14:08:12', 'admin-1519348637-15193660926961854', 1, 1, 'SR', NULL, NULL, NULL),
(63649, '2018-02-23 12:49:21', NULL, NULL, 16850, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 12:49:21', 'admin-1519348637-15193613611102963', 1, 1, 'SR', NULL, NULL, '10.0'),
(63650, '2018-02-23 13:19:33', NULL, NULL, 16853, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:19:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63651, '2018-02-23 15:23:44', NULL, NULL, 16859, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 15:23:44', 'admin-1519348637-15193706243545386', 1, 0, '', NULL, NULL, NULL),
(63652, '2018-02-23 15:23:44', NULL, NULL, 16859, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 15:23:44', 'admin-1519348637-15193706243545386', 1, 0, '', NULL, NULL, NULL),
(63653, '2018-02-23 13:42:59', NULL, NULL, 16854, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:42:59', 'admin-1519348637-1519364579254835', 1, 1, 'SR', NULL, NULL, NULL),
(63654, '2018-02-23 13:42:59', NULL, NULL, 16854, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:42:59', 'admin-1519348637-1519364579254835', 1, 0, '', NULL, NULL, NULL),
(63655, '2018-02-23 12:32:34', NULL, NULL, 16843, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 12:32:34', 'admin-1519348637-15193603538643664', 1, 1, 'SR', NULL, NULL, NULL),
(63656, '2018-02-23 12:13:54', NULL, NULL, 16847, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 12:13:54', 'admin-1519348637-15193592343536377', 1, 1, 'SR', 1, NULL, NULL),
(63657, '2018-02-23 14:26:00', NULL, NULL, 16857, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 14:26:00', 'admin-1519348637-15193671599808327', 1, 0, '', NULL, NULL, NULL),
(63658, '2018-02-23 14:30:21', NULL, NULL, 16854, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 14:30:21', 'admin-1519348637-15193674210047927', 1, 1, 'SR', NULL, NULL, NULL),
(63659, '2018-02-23 13:19:46', NULL, NULL, 16853, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:19:46', 'admin-1519348637-15193631868456649', 1, 0, '', NULL, NULL, NULL),
(63660, '2018-02-23 11:38:03', NULL, NULL, 16844, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 11:38:03', 'admin-1519348637-15193570836957695', 1, 1, 'SR', NULL, NULL, '10.0'),
(63661, '2018-02-23 11:38:03', NULL, NULL, 16844, 0, 181, '116', 'Open Food ', 'pepper', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 11:38:03', 'admin-1519348637-15193570836957695', 1, 0, '', NULL, NULL, '10.0'),
(63662, '2018-02-23 15:29:32', NULL, NULL, 16859, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 15:29:32', 'admin-1519348637-15193709723854824', 1, 1, 'SR', NULL, NULL, NULL),
(63663, '2018-02-23 09:17:38', NULL, NULL, 16839, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 09:17:38', 'admin-1519348637-15193486580201013', 1, 1, 'SR', NULL, NULL, NULL),
(63664, '2018-02-23 14:41:24', NULL, NULL, 16858, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1519348637', 'admin', '2018-02-23 14:41:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63665, '2018-02-23 16:53:09', NULL, NULL, 16864, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1519348637', 'admin', '2018-02-23 16:53:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63666, '2018-02-23 14:14:14', NULL, NULL, 16855, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 14:14:14', 'admin-1519348637-15193664543915992', 1, 1, 'SR', NULL, NULL, NULL),
(63667, '2018-02-23 17:04:24', NULL, NULL, 16865, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1519348637', 'admin', '2018-02-23 17:04:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63668, '2018-02-23 14:13:55', NULL, NULL, 16855, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1519348637', 'admin', '2018-02-23 14:13:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63669, '2018-02-23 13:42:59', NULL, NULL, 16854, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:42:59', 'admin-1519348637-1519364579254835', 1, 1, 'SR', NULL, NULL, NULL),
(63670, '2018-02-23 12:29:27', NULL, NULL, 16849, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 12:29:27', 'admin-1519348637-15193601671864567', 1, 0, '', NULL, NULL, NULL),
(63671, '2018-02-23 12:29:27', NULL, NULL, 16849, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 12:29:27', 'admin-1519348637-15193601671864567', 1, 1, 'SR', NULL, NULL, NULL),
(63672, '2018-02-23 12:29:27', NULL, NULL, 16849, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 12:29:27', 'admin-1519348637-15193601671864567', 1, 1, 'SR', NULL, NULL, NULL),
(63673, '2018-02-23 13:42:59', NULL, NULL, 16854, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:42:59', 'admin-1519348637-1519364579254835', 1, 1, 'SR', NULL, NULL, NULL),
(63674, '2018-02-23 16:42:16', NULL, NULL, 16863, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1519348637', 'admin', '2018-02-23 16:42:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63675, '2018-02-23 16:42:03', NULL, NULL, 16862, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 16:42:03', 'admin-1519348637-15193753236632925', 1, 1, 'SR', NULL, NULL, NULL),
(63676, '2018-02-23 13:42:59', NULL, NULL, 16854, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:42:59', 'admin-1519348637-1519364579254835', 1, 1, 'SR', NULL, NULL, NULL),
(63677, '2018-02-23 13:42:59', NULL, NULL, 16854, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:42:59', 'admin-1519348637-1519364579254835', 1, 0, '', NULL, NULL, NULL),
(63678, '2018-02-23 13:42:59', NULL, NULL, 16854, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:42:59', 'admin-1519348637-1519364579254835', 1, 0, '', NULL, NULL, NULL),
(63679, '2018-02-23 13:42:59', NULL, NULL, 16854, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:42:59', 'admin-1519348637-1519364579254835', 1, 0, '', NULL, NULL, NULL),
(63680, '2018-02-23 13:42:59', NULL, NULL, 16854, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:42:59', 'admin-1519348637-1519364579254835', 1, 0, '', NULL, NULL, NULL),
(63681, '2018-02-23 13:41:23', NULL, NULL, 16854, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 17.30, 0.0000, 0.0000, 17.30, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:41:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63682, '2018-02-23 10:36:10', NULL, NULL, 16841, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 10:36:10', 'admin-1519348637-1519353370668711', 1, 1, 'SR', NULL, NULL, NULL),
(63683, '2018-02-23 10:42:24', NULL, NULL, 16842, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1519348637', 'admin', '2018-02-23 10:42:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63684, '2018-02-23 12:49:02', NULL, NULL, 16850, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1519348637', 'admin', '2018-02-23 12:49:02', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(63685, '2018-02-23 13:14:41', NULL, NULL, 16852, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:14:41', 'admin-1519348637-15193628817141230', 1, 1, 'SR', NULL, NULL, '10.0'),
(63686, '2018-02-23 10:58:34', NULL, NULL, 16842, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 10:58:34', 'admin-1519348637-1519354714742235', 1, 0, '', NULL, NULL, NULL),
(63687, '2018-02-23 09:17:38', NULL, NULL, 16839, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 09:17:38', 'admin-1519348637-15193486580201013', 1, 0, '', NULL, NULL, NULL),
(63688, '2018-02-23 13:08:26', NULL, NULL, 16851, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:08:26', 'admin-1519348637-15193625066169085', 1, 0, '', NULL, NULL, NULL),
(63689, '2018-02-23 15:29:32', NULL, NULL, 16859, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 15:29:32', 'admin-1519348637-15193709723854824', 1, 1, 'SR', NULL, NULL, NULL),
(63690, '2018-02-23 13:08:26', NULL, NULL, 16851, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:08:26', 'admin-1519348637-15193625066169085', 1, 1, 'SR', NULL, NULL, NULL),
(63691, '2018-02-23 14:42:05', NULL, NULL, 16858, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 14:42:05', 'admin-1519348637-1519368124951952', 1, 1, 'SR', NULL, NULL, NULL),
(63692, '2018-02-23 13:06:08', NULL, NULL, 16851, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:06:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63693, '2018-02-23 12:13:31', NULL, NULL, 16846, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 12:13:31', 'admin-1519348637-15193592115426868', 1, 1, 'SR', NULL, NULL, NULL),
(63694, '2018-02-23 12:49:21', NULL, NULL, 16850, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 12:49:21', 'admin-1519348637-15193613611102963', 1, 1, 'SR', NULL, NULL, '10.0'),
(63695, '2018-02-23 12:32:34', NULL, NULL, 16843, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 12:32:34', 'admin-1519348637-15193603538643664', 1, 1, 'SR', NULL, NULL, NULL),
(63696, '2018-02-23 12:29:27', NULL, NULL, 16849, 0, 304, '240', 'Banana is On Fire', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 12:29:27', 'admin-1519348637-15193601671864567', 1, 0, '', NULL, NULL, NULL),
(63697, '2018-02-23 12:13:31', NULL, NULL, 16846, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 12:13:31', 'admin-1519348637-15193592115426868', 1, 1, 'SR', NULL, NULL, NULL),
(63698, '2018-02-23 12:07:04', NULL, NULL, 16844, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1519348637', 'admin', '2018-02-23 12:07:04', 'admin-1519348637-15193588239356968', 1, 0, '', NULL, NULL, '10.0'),
(63699, '2018-02-23 11:38:03', NULL, NULL, 16844, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 11:38:03', 'admin-1519348637-15193570836957695', 1, 1, 'SR', NULL, NULL, '10.0'),
(63700, '2018-02-23 11:38:03', NULL, NULL, 16844, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 11:38:03', 'admin-1519348637-15193570836957695', 1, 1, 'SR', NULL, NULL, '10.0'),
(63701, '2018-02-23 11:56:49', NULL, NULL, 16845, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1519348637', 'admin', '2018-02-23 11:56:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63702, '2018-02-23 11:57:36', NULL, NULL, 16845, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 11:57:36', 'admin-1519348637-1519358256443119', 1, 0, '', NULL, NULL, NULL),
(63703, '2018-02-23 11:57:36', NULL, NULL, 16845, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 11:57:36', 'admin-1519348637-1519358256443119', 1, 0, '', NULL, NULL, NULL),
(63704, '2018-02-23 11:57:36', NULL, NULL, 16845, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 11:57:36', 'admin-1519348637-1519358256443119', 1, 1, 'SR', NULL, NULL, NULL),
(63705, '2018-02-23 11:57:36', NULL, NULL, 16845, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 11:57:36', 'admin-1519348637-1519358256443119', 1, 0, '', NULL, NULL, NULL),
(63706, '2018-02-23 11:36:11', NULL, NULL, 16844, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.39, 0.0000, 0.0000, 7.39, 1, '27', 1, '1519348637', 'admin', '2018-02-23 11:36:11', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(63707, '2018-02-23 11:38:03', NULL, NULL, 16844, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 11:38:03', 'admin-1519348637-15193570836957695', 1, 1, 'SR', NULL, NULL, '10.0'),
(63708, '2018-02-23 10:36:06', NULL, NULL, 16841, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1519348637', 'admin', '2018-02-23 10:36:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63709, '2018-02-23 10:36:10', NULL, NULL, 16841, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 10:36:10', 'admin-1519348637-1519353370668711', 1, 0, '', NULL, NULL, NULL),
(63710, '2018-02-23 17:04:36', NULL, NULL, 16865, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 17:04:36', 'admin-1519348637-15193766760829669', 1, 0, '', NULL, NULL, NULL),
(63711, '2018-02-23 10:49:24', NULL, NULL, 16843, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 10:49:24', 'admin-1519348637-15193541643059991', 1, 0, '', NULL, NULL, NULL),
(63712, '2018-02-23 13:14:18', NULL, NULL, 16852, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1519348637', 'admin', '2018-02-23 13:14:18', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(63713, '2018-02-23 10:49:24', NULL, NULL, 16843, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 10:49:24', 'admin-1519348637-15193541643059991', 1, 1, 'SR', NULL, NULL, NULL),
(63714, '2018-02-23 10:49:24', NULL, NULL, 16843, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 10:49:24', 'admin-1519348637-15193541643059991', 1, 0, '', NULL, NULL, NULL),
(63715, '2018-02-23 10:49:01', NULL, NULL, 16843, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.70, 0.0000, 0.0000, 7.70, 1, '27', 1, '1519348637', 'admin', '2018-02-23 10:49:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63716, '2018-02-23 10:42:50', NULL, NULL, 16842, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 10:42:50', 'admin-1519348637-1519353770136666', 1, 0, '', NULL, NULL, NULL),
(63717, '2018-02-23 10:34:33', NULL, NULL, 16840, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519348637', 'admin', '2018-02-23 10:34:33', 'admin-1519348637-15193532729967496', 1, 1, 'SR', 1, NULL, NULL),
(63718, '2018-02-23 09:17:28', NULL, NULL, 16839, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1519348637', 'admin', '2018-02-23 09:17:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63719, '2018-02-24 13:00:45', NULL, NULL, 16895, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:00:45', 'admin-1519433982-15194484452507437', 1, 0, '', NULL, NULL, NULL),
(63720, '2018-02-24 14:12:35', NULL, NULL, 16902, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:12:35', 'admin-1519433982-1519452755298186', 1, 1, 'SR', NULL, NULL, NULL),
(63721, '2018-02-24 14:12:35', NULL, NULL, 16902, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:12:35', 'admin-1519433982-1519452755298186', 1, 1, 'SR', NULL, NULL, NULL),
(63722, '2018-02-24 14:26:07', NULL, NULL, 16911, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:26:07', 'admin-1519433982-15194535676566945', 1, 0, '', NULL, NULL, NULL),
(63723, '2018-02-24 14:25:43', NULL, NULL, 16911, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.10, 0.0000, 0.0000, 3.10, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:25:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63724, '2018-02-24 13:21:07', NULL, NULL, 16898, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:21:07', 'admin-1519433982-15194496675056593', 1, 0, '', NULL, NULL, NULL),
(63725, '2018-02-24 10:08:55', NULL, NULL, 16868, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:08:55', 'admin-1519433982-15194381356049599', 1, 1, 'SR', NULL, NULL, NULL),
(63726, '2018-02-24 10:08:55', NULL, NULL, 16868, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:08:55', 'admin-1519433982-15194381356049599', 1, 1, 'SR', NULL, NULL, NULL),
(63727, '2018-02-24 10:12:55', NULL, NULL, 16869, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:12:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63728, '2018-02-24 10:24:11', NULL, NULL, 16870, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:24:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63729, '2018-02-24 10:24:33', NULL, NULL, 16870, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:24:33', 'admin-1519433982-15194390731062160', 1, 0, '', NULL, NULL, NULL),
(63730, '2018-02-24 10:46:20', NULL, NULL, 16875, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:46:20', 'admin-1519433982-15194403804144868', 1, 1, 'SR', NULL, NULL, NULL),
(63731, '2018-02-24 10:46:20', NULL, NULL, 16875, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:46:20', 'admin-1519433982-15194403804144868', 1, 1, 'SR', NULL, NULL, NULL),
(63732, '2018-02-24 10:46:20', NULL, NULL, 16875, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:46:20', 'admin-1519433982-15194403804144868', 1, 0, '', NULL, NULL, NULL),
(63733, '2018-02-24 10:49:33', NULL, NULL, 16876, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.50, 0.0000, 0.0000, 7.50, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:49:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63734, '2018-02-24 10:49:51', NULL, NULL, 16876, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:49:51', 'admin-1519433982-15194405914173496', 1, 0, '', NULL, NULL, NULL),
(63735, '2018-02-24 10:49:51', NULL, NULL, 16876, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:49:51', 'admin-1519433982-15194405914173496', 1, 0, '', NULL, NULL, NULL),
(63736, '2018-02-24 13:40:00', NULL, NULL, 16905, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:40:00', 'admin-1519433982-15194508007403310', 1, 1, 'SR', NULL, NULL, NULL),
(63737, '2018-02-24 10:46:20', NULL, NULL, 16875, 0, 181, '116', 'Open Food ', 'bacon', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:46:20', 'admin-1519433982-15194403804144868', 1, 0, '', NULL, NULL, NULL),
(63738, '2018-02-24 16:39:22', NULL, NULL, 16924, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:39:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63739, '2018-02-24 13:40:00', NULL, NULL, 16905, 0, 181, '116', 'Open Food ', 'pepper pork', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:40:00', 'admin-1519433982-15194508007403310', 1, 0, '', NULL, NULL, NULL),
(63740, '2018-02-24 12:30:10', NULL, NULL, 16891, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:30:10', 'admin-1519433982-15194466103953367', 1, 1, 'SR', NULL, NULL, NULL),
(63741, '2018-02-24 12:30:10', NULL, NULL, 16891, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:30:10', 'admin-1519433982-15194466103953367', 1, 0, '', NULL, NULL, NULL),
(63742, '2018-02-24 12:30:10', NULL, NULL, 16891, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:30:10', 'admin-1519433982-15194466103953367', 1, 0, '', NULL, NULL, NULL),
(63743, '2018-02-24 12:29:46', NULL, NULL, 16891, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:29:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63744, '2018-02-24 12:10:54', NULL, NULL, 16890, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:10:54', 'admin-1519433982-15194454540977561', 1, 1, 'SR', NULL, NULL, NULL),
(63745, '2018-02-24 10:08:38', NULL, NULL, 16868, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:08:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63746, '2018-02-24 10:08:55', NULL, NULL, 16868, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:08:55', 'admin-1519433982-15194381356049599', 1, 0, '', NULL, NULL, NULL),
(63747, '2018-02-24 16:34:38', NULL, NULL, 16921, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:34:38', 'admin-1519433982-15194612785732453', 1, 1, 'SR', NULL, NULL, NULL),
(63748, '2018-02-24 16:34:38', NULL, NULL, 16921, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:34:38', 'admin-1519433982-15194612785732453', 1, 0, '', NULL, NULL, NULL),
(63749, '2018-02-24 15:41:26', NULL, NULL, 16914, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 15:41:26', 'admin-1519433982-1519458086782794', 1, 0, '', NULL, NULL, NULL),
(63750, '2018-02-24 14:12:35', NULL, NULL, 16902, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:12:35', 'admin-1519433982-1519452755298186', 1, 1, 'SR', NULL, NULL, NULL),
(63751, '2018-02-24 14:06:54', NULL, NULL, 16910, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:06:54', 'admin-1519433982-15194524146143316', 1, 1, 'SR', NULL, NULL, NULL),
(63752, '2018-02-24 13:38:13', NULL, NULL, 16904, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:38:13', 'admin-1519433982-15194506935557365', 1, 1, 'SR', NULL, NULL, NULL),
(63753, '2018-02-24 13:13:29', NULL, NULL, 16897, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:13:29', 'admin-1519433982-15194492090619647', 1, 0, '', NULL, NULL, NULL),
(63754, '2018-02-24 13:13:29', NULL, NULL, 16897, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:13:29', 'admin-1519433982-15194492090619647', 1, 1, 'SR', NULL, NULL, NULL),
(63755, '2018-02-24 13:38:13', NULL, NULL, 16904, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:38:13', 'admin-1519433982-15194506935557365', 1, 1, 'SR', NULL, NULL, NULL),
(63756, '2018-02-24 14:30:00', NULL, NULL, 16902, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:30:00', 'admin-1519433982-15194538005125745', 1, 0, '', NULL, NULL, NULL),
(63757, '2018-02-24 13:30:18', NULL, NULL, 16896, 0, 181, '116', 'Open Food ', 'pepper pork rice', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:30:18', 'admin-1519433982-1519450218156688', 1, 0, '', NULL, NULL, NULL),
(63758, '2018-02-24 12:10:54', NULL, NULL, 16890, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:10:54', 'admin-1519433982-15194454540977561', 1, 1, 'SR', NULL, NULL, NULL),
(63759, '2018-02-24 12:10:54', NULL, NULL, 16890, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:10:54', 'admin-1519433982-15194454540977561', 1, 1, 'SR', NULL, NULL, NULL),
(63760, '2018-02-24 12:10:54', NULL, NULL, 16890, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:10:54', 'admin-1519433982-15194454540977561', 1, 1, 'SR', NULL, NULL, NULL),
(63761, '2018-02-24 12:10:20', NULL, NULL, 16890, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:10:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63762, '2018-02-24 12:42:39', NULL, NULL, 16888, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:42:39', 'admin-1519433982-15194473588665186', 1, 1, 'SR', NULL, NULL, NULL),
(63763, '2018-02-24 12:39:55', NULL, NULL, 16892, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:39:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63764, '2018-02-24 12:40:15', NULL, NULL, 16892, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:40:15', 'admin-1519433982-15194472149344612', 1, 1, 'SR', NULL, NULL, NULL),
(63765, '2018-02-24 11:05:09', NULL, NULL, 16879, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:05:09', 'admin-1519433982-1519441509784648', 1, 1, 'SR', NULL, NULL, NULL),
(63766, '2018-02-24 11:05:09', NULL, NULL, 16879, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:05:09', 'admin-1519433982-1519441509784648', 1, 1, 'SR', NULL, NULL, NULL),
(63767, '2018-02-24 14:12:35', NULL, NULL, 16902, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:12:35', 'admin-1519433982-1519452755298186', 1, 1, 'SR', NULL, NULL, NULL),
(63768, '2018-02-24 15:08:14', NULL, NULL, 16912, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 15:08:14', 'admin-1519433982-15194560942246122', 1, 1, 'SR', NULL, NULL, NULL),
(63769, '2018-02-24 13:51:25', NULL, NULL, 16907, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:51:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63770, '2018-02-24 13:51:43', NULL, NULL, 16907, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:51:43', 'admin-1519433982-15194515034475033', 1, 1, 'SR', NULL, NULL, NULL),
(63771, '2018-02-24 13:51:43', NULL, NULL, 16907, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:51:43', 'admin-1519433982-15194515034475033', 1, 1, 'SR', NULL, NULL, NULL),
(63772, '2018-02-24 13:51:43', NULL, NULL, 16907, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:51:43', 'admin-1519433982-15194515034475033', 1, 1, 'SR', NULL, NULL, NULL),
(63773, '2018-02-24 13:51:43', NULL, NULL, 16907, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:51:43', 'admin-1519433982-15194515034475033', 1, 1, 'SR', NULL, NULL, NULL),
(63774, '2018-02-24 13:33:00', NULL, NULL, 16902, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:33:00', 'admin-1519433982-15194503805016494', 1, 0, '', NULL, NULL, NULL),
(63775, '2018-02-24 13:34:18', NULL, NULL, 16896, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:34:18', 'admin-1519433982-15194504586107820', 1, 0, '', NULL, NULL, NULL),
(63776, '2018-02-24 13:11:39', NULL, NULL, 16896, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 12.90, 0.0000, 0.0000, 12.90, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:11:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63777, '2018-02-24 13:11:47', NULL, NULL, 16896, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:11:47', 'admin-1519433982-15194491076608281', 1, 0, '', NULL, NULL, NULL),
(63778, '2018-02-24 13:12:57', NULL, NULL, 16897, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:12:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63779, '2018-02-24 13:13:29', NULL, NULL, 16897, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:13:29', 'admin-1519433982-15194492090619647', 1, 0, '', NULL, NULL, NULL),
(63780, '2018-02-24 13:36:46', NULL, NULL, 16904, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:36:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63781, '2018-02-24 13:34:44', NULL, NULL, 16903, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:34:44', 'admin-1519433982-15194504839963948', 1, 1, 'SR', NULL, NULL, NULL),
(63782, '2018-02-24 12:58:10', NULL, NULL, 16894, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:58:10', 'admin-1519433982-15194482905291462', 1, 1, 'SR', NULL, NULL, NULL),
(63783, '2018-02-24 12:08:02', NULL, NULL, 16889, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:08:02', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(63784, '2018-02-24 17:25:40', NULL, NULL, 16931, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1519433982', 'admin', '2018-02-24 17:25:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63785, '2018-02-24 00:00:00', NULL, NULL, 16933, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', NULL, 1, 1.40, NULL, NULL, 1.40, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:45:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63786, '2018-02-24 17:25:18', NULL, NULL, 16930, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1519433982', 'admin', '2018-02-24 17:25:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63787, '2018-02-24 16:52:31', NULL, NULL, 16927, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:52:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63788, '2018-02-24 16:52:39', NULL, NULL, 16927, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 2, 9.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:52:39', 'admin-1519433982-15194623592856639', 1, 0, '', NULL, NULL, NULL),
(63789, '2018-02-24 13:34:39', NULL, NULL, 16903, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:34:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63790, '2018-02-24 12:40:15', NULL, NULL, 16892, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:40:15', 'admin-1519433982-15194472149344612', 1, 1, 'SR', NULL, NULL, NULL),
(63791, '2018-02-24 11:10:13', NULL, NULL, 16881, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 11.70, 0.0000, 0.0000, 11.70, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:10:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63792, '2018-02-24 11:10:44', NULL, NULL, 16881, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:10:44', 'admin-1519433982-15194418442509969', 1, 0, '', NULL, NULL, NULL),
(63793, '2018-02-24 14:01:55', NULL, NULL, 16909, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:01:55', 'admin-1519433982-1519452115620287', 1, 1, 'SR', NULL, NULL, NULL),
(63794, '2018-02-24 10:49:51', NULL, NULL, 16876, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:49:51', 'admin-1519433982-15194405914173496', 1, 0, '', NULL, NULL, NULL),
(63795, '2018-02-24 10:49:51', NULL, NULL, 16876, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:49:51', 'admin-1519433982-15194405914173496', 1, 1, 'SR', NULL, NULL, NULL),
(63796, '2018-02-24 00:00:00', NULL, NULL, 16930, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:52:26', 'admin-1519433982-15194623459307877', 1, 0, '', NULL, NULL, NULL),
(63797, '2018-02-24 00:00:00', NULL, NULL, 16933, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:52:26', 'admin-1519433982-15194623459307877', 1, 1, 'SR', NULL, NULL, NULL),
(63798, '2018-02-24 14:06:54', NULL, NULL, 16910, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:06:54', 'admin-1519433982-15194524146143316', 1, 1, 'SR', NULL, NULL, NULL),
(63799, '2018-02-24 14:06:54', NULL, NULL, 16910, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:06:54', 'admin-1519433982-15194524146143316', 1, 0, '', NULL, NULL, NULL),
(63800, '2018-02-24 13:31:12', NULL, NULL, 16901, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:31:12', 'admin-1519433982-15194502723847082', 1, 1, 'SR', NULL, NULL, NULL),
(63801, '2018-02-24 13:31:12', NULL, NULL, 16901, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:31:12', 'admin-1519433982-15194502723847082', 1, 1, 'SR', NULL, NULL, NULL),
(63802, '2018-02-24 13:00:45', NULL, NULL, 16895, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:00:45', 'admin-1519433982-15194484452507437', 1, 1, 'SR', NULL, NULL, NULL),
(63803, '2018-02-24 13:00:45', NULL, NULL, 16895, 0, 52, '52', 'Pure Vanilla Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:00:45', 'admin-1519433982-15194484452507437', 1, 1, 'SR', NULL, NULL, NULL),
(63804, '2018-02-24 15:41:51', NULL, NULL, 16915, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 15:41:51', 'admin-1519433982-15194581108412635', 1, 1, 'SR', NULL, NULL, NULL),
(63805, '2018-02-24 15:50:43', NULL, NULL, 16916, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1519433982', 'admin', '2018-02-24 15:50:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63806, '2018-02-24 14:36:27', NULL, NULL, 16906, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:36:27', 'admin-1519433982-15194541873243743', 1, 0, '', NULL, NULL, NULL),
(63807, '2018-02-24 14:50:19', NULL, NULL, 16902, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:50:19', 'admin-1519433982-15194550197763037', 1, 1, 'SR', NULL, NULL, NULL),
(63808, '2018-02-24 16:55:12', NULL, NULL, 16928, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:55:12', 'admin-1519433982-15194625124919158', 1, 0, '', NULL, NULL, NULL),
(63809, '2018-02-24 16:56:40', NULL, NULL, 16929, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:56:40', 'admin-1519433982-15194626002316837', 1, 1, 'SR', NULL, NULL, NULL),
(63810, '2018-02-24 16:56:33', NULL, NULL, 16929, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:56:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63811, '2018-02-24 16:55:05', NULL, NULL, 16928, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:55:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63812, '2018-02-24 13:38:13', NULL, NULL, 16904, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:38:13', 'admin-1519433982-15194506935557365', 1, 0, '', NULL, NULL, NULL),
(63813, '2018-02-24 17:26:25', NULL, NULL, 16932, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1519433982', 'admin', '2018-02-24 17:26:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63814, '2018-02-24 14:06:54', NULL, NULL, 16910, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:06:54', 'admin-1519433982-15194524146143316', 1, 0, '', NULL, NULL, NULL),
(63815, '2018-02-24 16:40:15', NULL, NULL, 16925, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:40:15', 'admin-1519433982-15194616151452655', 1, 1, 'SR', NULL, NULL, NULL),
(63816, '2018-02-24 16:39:29', NULL, NULL, 16924, 0, 325, '261', 'Strawberry Chocolate Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:39:29', 'admin-1519433982-15194615689409190', 1, 0, '', NULL, NULL, NULL),
(63817, '2018-02-24 16:40:08', NULL, NULL, 16925, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:40:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63818, '2018-02-24 13:30:32', NULL, NULL, 16901, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:30:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63819, '2018-02-24 13:31:12', NULL, NULL, 16901, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:31:12', 'admin-1519433982-15194502723847082', 1, 0, '', NULL, NULL, NULL),
(63820, '2018-02-24 13:30:18', NULL, NULL, 16896, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:30:18', 'admin-1519433982-1519450218156688', 1, 0, '', NULL, NULL, NULL),
(63821, '2018-02-24 14:04:43', NULL, NULL, 16909, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:04:43', 'admin-1519433982-15194522836064745', 1, 0, '', NULL, NULL, NULL),
(63822, '2018-02-24 14:01:55', NULL, NULL, 16909, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:01:55', 'admin-1519433982-1519452115620287', 1, 0, '', NULL, NULL, NULL),
(63823, '2018-02-24 13:58:51', NULL, NULL, 16908, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:58:51', 'admin-1519433982-15194519313471796', 1, 0, '', NULL, NULL, NULL),
(63824, '2018-02-24 16:38:37', NULL, NULL, 16923, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:38:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63825, '2018-02-24 16:05:46', NULL, NULL, 16918, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:05:46', 'admin-1519433982-1519459546044868', 1, 1, 'SR', 1, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(63826, '2018-02-24 16:06:53', NULL, NULL, 16919, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:06:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63827, '2018-02-24 16:06:59', NULL, NULL, 16919, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:06:59', 'admin-1519433982-15194596189778629', 1, 0, '', NULL, NULL, NULL),
(63828, '2018-02-24 16:19:38', NULL, NULL, 16920, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:19:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63829, '2018-02-24 16:19:56', NULL, NULL, 16920, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:19:56', 'admin-1519433982-15194603963423558', 1, 0, '', NULL, NULL, NULL),
(63830, '2018-02-24 16:19:56', NULL, NULL, 16920, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:19:56', 'admin-1519433982-15194603963423558', 1, 0, '', NULL, NULL, NULL),
(63831, '2018-02-24 16:19:56', NULL, NULL, 16920, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:19:56', 'admin-1519433982-15194603963423558', 1, 0, '', NULL, NULL, NULL),
(63832, '2018-02-24 16:37:36', NULL, NULL, 16922, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:37:36', 'admin-1519433982-1519461456466695', 1, 0, '', NULL, NULL, NULL),
(63833, '2018-02-24 16:37:24', NULL, NULL, 16922, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:37:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63834, '2018-02-24 16:34:38', NULL, NULL, 16921, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:34:38', 'admin-1519433982-15194612785732453', 1, 1, 'SR', NULL, NULL, NULL),
(63835, '2018-02-24 16:33:46', NULL, NULL, 16921, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:33:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63836, '2018-02-24 15:50:54', NULL, NULL, 16916, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 15:50:54', 'admin-1519433982-15194586539944461', 1, 0, '', NULL, NULL, NULL),
(63837, '2018-02-24 15:50:54', NULL, NULL, 16916, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 15:50:54', 'admin-1519433982-15194586539944461', 1, 0, '', NULL, NULL, NULL),
(63838, '2018-02-24 14:01:55', NULL, NULL, 16909, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:01:55', 'admin-1519433982-1519452115620287', 1, 1, 'SR', NULL, NULL, NULL),
(63839, '2018-02-24 14:01:55', NULL, NULL, 16909, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:01:55', 'admin-1519433982-1519452115620287', 1, 1, 'SR', NULL, NULL, NULL),
(63840, '2018-02-24 14:01:30', NULL, NULL, 16909, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:01:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63841, '2018-02-24 15:09:50', NULL, NULL, 16912, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 15:09:50', 'admin-1519433982-15194561906533939', 1, 1, 'SR', NULL, NULL, NULL),
(63842, '2018-02-24 15:41:40', NULL, NULL, 16915, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1519433982', 'admin', '2018-02-24 15:41:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63843, '2018-02-24 15:41:26', NULL, NULL, 16914, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 15:41:26', 'admin-1519433982-1519458086782794', 1, 1, 'SR', NULL, NULL, NULL),
(63844, '2018-02-24 15:09:17', NULL, NULL, 16913, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 15:09:17', 'admin-1519433982-1519456157141876', 1, 0, '', NULL, NULL, NULL),
(63845, '2018-02-24 15:09:17', NULL, NULL, 16913, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 15:09:17', 'admin-1519433982-1519456157141876', 1, 1, 'SR', NULL, NULL, NULL),
(63846, '2018-02-24 13:58:36', NULL, NULL, 16908, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:58:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63847, '2018-02-24 13:39:10', NULL, NULL, 16905, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:39:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63848, '2018-02-24 13:14:26', NULL, NULL, 16898, 0, 53, '53', 'Matcha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:14:26', 'admin-1519433982-15194492662818714', 1, 1, 'SR', NULL, NULL, NULL),
(63849, '2018-02-24 13:00:45', NULL, NULL, 16895, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:00:45', 'admin-1519433982-15194484452507437', 1, 0, '', NULL, NULL, NULL),
(63850, '2018-02-24 13:58:51', NULL, NULL, 16908, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:58:51', 'admin-1519433982-15194519313471796', 1, 1, 'SR', NULL, NULL, NULL),
(63851, '2018-02-24 13:24:14', NULL, NULL, 16899, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.90, 0.0000, 0.0000, 6.90, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:24:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63852, '2018-02-24 13:25:10', NULL, NULL, 16899, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:25:10', 'admin-1519433982-15194499101586463', 1, 0, '', NULL, NULL, NULL),
(63853, '2018-02-24 13:25:10', NULL, NULL, 16899, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:25:10', 'admin-1519433982-15194499101586463', 1, 0, '', NULL, NULL, NULL),
(63854, '2018-02-24 15:41:05', NULL, NULL, 16914, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1519433982', 'admin', '2018-02-24 15:41:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63855, '2018-02-24 15:41:50', NULL, NULL, 16915, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 15:41:50', 'admin-1519433982-15194581108412635', 1, 1, 'SR', NULL, NULL, NULL),
(63856, '2018-02-24 15:09:17', NULL, NULL, 16913, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 15:09:17', 'admin-1519433982-1519456157141876', 1, 0, '', NULL, NULL, NULL),
(63857, '2018-02-24 14:26:07', NULL, NULL, 16911, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:26:07', 'admin-1519433982-15194535676566945', 1, 1, 'SR', NULL, NULL, NULL),
(63858, '2018-02-24 13:49:14', NULL, NULL, 16906, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:49:14', 'admin-1519433982-15194513547783572', 1, 1, 'SR', NULL, NULL, NULL),
(63859, '2018-02-24 13:30:18', NULL, NULL, 16896, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:30:18', 'admin-1519433982-1519450218156688', 1, 0, '', NULL, NULL, NULL),
(63860, '2018-02-24 13:25:55', NULL, NULL, 16900, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:25:55', 'admin-1519433982-15194499552483584', 1, 1, 'SR', NULL, NULL, NULL),
(63861, '2018-02-24 15:08:51', NULL, NULL, 16913, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.50, 0.0000, 0.0000, 4.50, 1, '27', 1, '1519433982', 'admin', '2018-02-24 15:08:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63862, '2018-02-24 13:48:45', NULL, NULL, 16906, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:48:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63863, '2018-02-24 13:49:14', NULL, NULL, 16906, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:49:14', 'admin-1519433982-15194513547783572', 1, 1, 'SR', NULL, NULL, NULL),
(63864, '2018-02-24 13:00:45', NULL, NULL, 16895, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:00:45', 'admin-1519433982-15194484452507437', 1, 0, '', NULL, NULL, NULL),
(63865, '2018-02-24 13:25:55', NULL, NULL, 16900, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:25:55', 'admin-1519433982-15194499552483584', 1, 1, 'SR', NULL, NULL, NULL),
(63866, '2018-02-24 14:12:35', NULL, NULL, 16902, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:12:35', 'admin-1519433982-1519452755298186', 1, 0, '', NULL, NULL, NULL),
(63867, '2018-02-24 13:30:18', NULL, NULL, 16896, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:30:18', 'admin-1519433982-1519450218156688', 1, 1, 'SR', NULL, NULL, NULL),
(63868, '2018-02-24 13:25:55', NULL, NULL, 16900, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:25:55', 'admin-1519433982-15194499552483584', 1, 0, '', NULL, NULL, NULL),
(63869, '2018-02-24 13:25:55', NULL, NULL, 16900, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:25:55', 'admin-1519433982-15194499552483584', 1, 0, '', NULL, NULL, NULL),
(63870, '2018-02-24 13:25:36', NULL, NULL, 16900, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:25:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63871, '2018-02-24 13:30:18', NULL, NULL, 16896, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:30:18', 'admin-1519433982-1519450218156688', 1, 0, '', NULL, NULL, NULL),
(63872, '2018-02-24 14:06:13', NULL, NULL, 16910, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:06:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63873, '2018-02-24 14:26:07', NULL, NULL, 16911, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:26:07', 'admin-1519433982-15194535676566945', 1, 1, 'SR', NULL, NULL, NULL),
(63874, '2018-02-24 00:00:00', NULL, NULL, 16931, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:52:26', 'admin-1519433982-15194623459307877', 1, 1, 'SR', NULL, NULL, NULL),
(63875, '2018-02-24 13:25:10', NULL, NULL, 16899, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:25:10', 'admin-1519433982-15194499101586463', 1, 1, 'SR', NULL, NULL, NULL),
(63876, '2018-02-24 13:25:10', NULL, NULL, 16899, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:25:10', 'admin-1519433982-15194499101586463', 1, 1, 'SR', NULL, NULL, NULL),
(63877, '2018-02-24 12:03:19', NULL, NULL, 16888, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:03:19', 'admin-1519433982-15194449993626998', 1, 0, '', NULL, NULL, NULL),
(63878, '2018-02-24 13:14:26', NULL, NULL, 16898, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:14:26', 'admin-1519433982-15194492662818714', 1, 0, '', NULL, NULL, NULL),
(63879, '2018-02-24 13:14:26', NULL, NULL, 16898, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:14:26', 'admin-1519433982-15194492662818714', 1, 0, '', NULL, NULL, NULL),
(63880, '2018-02-24 13:14:26', NULL, NULL, 16898, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:14:26', 'admin-1519433982-15194492662818714', 1, 1, 'SR', NULL, NULL, NULL),
(63881, '2018-02-24 13:14:26', NULL, NULL, 16898, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:14:26', 'admin-1519433982-15194492662818714', 1, 0, '', NULL, NULL, NULL),
(63882, '2018-02-24 13:14:26', NULL, NULL, 16898, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:14:26', 'admin-1519433982-15194492662818714', 1, 0, '', NULL, NULL, NULL),
(63883, '2018-02-24 13:14:26', NULL, NULL, 16898, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:14:26', 'admin-1519433982-15194492662818714', 1, 0, '', NULL, NULL, NULL),
(63884, '2018-02-24 13:13:43', NULL, NULL, 16898, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 13.40, 0.0000, 0.0000, 13.40, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:13:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63885, '2018-02-24 11:14:23', NULL, NULL, 16882, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:14:23', 'admin-1519433982-15194420635573148', 1, 0, '', NULL, NULL, NULL),
(63886, '2018-02-24 11:14:23', NULL, NULL, 16882, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:14:23', 'admin-1519433982-15194420635573148', 1, 0, '', NULL, NULL, NULL),
(63887, '2018-02-24 11:14:23', NULL, NULL, 16882, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:14:23', 'admin-1519433982-15194420635573148', 1, 1, 'SR', NULL, NULL, NULL),
(63888, '2018-02-24 10:28:23', NULL, NULL, 16871, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:28:23', 'admin-1519433982-1519439303022610', 1, 1, 'SR', NULL, NULL, '10.0'),
(63889, '2018-02-24 13:47:22', NULL, NULL, 16904, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:47:22', 'admin-1519433982-15194512423176720', 1, 1, 'SR', NULL, NULL, NULL),
(63890, '2018-02-24 12:03:19', NULL, NULL, 16888, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:03:19', 'admin-1519433982-15194449993626998', 1, 1, 'SR', NULL, NULL, NULL),
(63891, '2018-02-24 11:54:10', NULL, NULL, 16880, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:54:10', 'admin-1519433982-15194444501192999', 1, 1, 'SR', NULL, NULL, NULL),
(63892, '2018-02-24 11:05:10', NULL, NULL, 16879, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:05:10', 'admin-1519433982-1519441509784648', 1, 1, 'SR', NULL, NULL, NULL),
(63893, '2018-02-24 13:00:45', NULL, NULL, 16895, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:00:45', 'admin-1519433982-15194484452507437', 1, 1, 'SR', NULL, NULL, NULL),
(63894, '2018-02-24 13:00:45', NULL, NULL, 16895, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:00:45', 'admin-1519433982-15194484452507437', 1, 0, '', NULL, NULL, NULL),
(63895, '2018-02-24 13:38:13', NULL, NULL, 16904, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:38:13', 'admin-1519433982-15194506935557365', 1, 0, '', NULL, NULL, NULL),
(63896, '2018-02-24 11:35:47', NULL, NULL, 16885, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:35:47', 'admin-1519433982-15194433474085566', 1, 0, '', 1, NULL, NULL),
(63897, '2018-02-24 13:58:51', NULL, NULL, 16908, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:58:51', 'admin-1519433982-15194519313471796', 1, 0, '', NULL, NULL, NULL),
(63898, '2018-02-24 12:58:54', NULL, NULL, 16895, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.30, 0.0000, 0.0000, 10.30, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:58:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63899, '2018-02-24 12:42:55', NULL, NULL, 16893, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:42:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63900, '2018-02-24 12:43:03', NULL, NULL, 16893, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:43:03', 'admin-1519433982-15194473836178188', 1, 0, '', NULL, NULL, NULL),
(63901, '2018-02-24 11:08:37', NULL, NULL, 16880, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:08:37', 'admin-1519433982-151944171719896', 1, 1, 'SR', NULL, NULL, NULL),
(63902, '2018-02-24 11:08:37', NULL, NULL, 16880, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:08:37', 'admin-1519433982-151944171719896', 1, 1, 'SR', NULL, NULL, NULL),
(63903, '2018-02-24 11:08:37', NULL, NULL, 16880, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:08:37', 'admin-1519433982-151944171719896', 1, 0, '', NULL, NULL, NULL),
(63904, '2018-02-24 12:57:51', NULL, NULL, 16894, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:57:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63905, '2018-02-24 11:35:47', NULL, NULL, 16885, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:35:47', 'admin-1519433982-15194433474085566', 1, 0, '', 1, NULL, NULL),
(63906, '2018-02-24 11:11:39', NULL, NULL, 16875, 0, 181, '116', 'Open Food ', 'BaconX4', 'Meals', 'Perfect Meals', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:11:39', 'admin-1519433982-15194418988975713', 1, 0, '', NULL, NULL, NULL),
(63907, '2018-02-24 11:10:44', NULL, NULL, 16881, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:10:44', 'admin-1519433982-15194418442509969', 1, 1, 'SR', NULL, NULL, NULL),
(63908, '2018-02-24 11:41:30', NULL, NULL, 16887, 0, 182, '117', 'Open Drinks ', 'basket', 'Cold Drinks', 'Fresh Juice', 1, 180.00, 180.0000, 0.0000, 180.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:41:30', 'admin-1519433982-15194436906941033', 1, 0, '', 1, NULL, NULL),
(63909, '2018-02-24 11:48:01', NULL, NULL, 16873, 0, 181, '116', 'Open Food ', 'banana', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:48:01', 'admin-1519433982-15194440809514711', 1, 0, '', NULL, NULL, NULL),
(63910, '2018-02-24 13:31:12', NULL, NULL, 16901, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:31:12', 'admin-1519433982-15194502723847082', 1, 1, 'SR', NULL, NULL, NULL),
(63911, '2018-02-24 10:42:29', NULL, NULL, 16874, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:42:29', 'admin-1519433982-15194401493611613', 1, 0, '', NULL, NULL, NULL),
(63912, '2018-02-24 10:42:29', NULL, NULL, 16874, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:42:29', 'admin-1519433982-15194401493611613', 1, 0, '', NULL, NULL, NULL),
(63913, '2018-02-24 16:03:17', NULL, NULL, 16914, 0, 324, '260', 'Blueberry Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:03:17', 'admin-1519433982-15194593976003354', 1, 0, '', NULL, NULL, NULL),
(63914, '2018-02-24 00:00:00', NULL, NULL, 16883, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, NULL, NULL, 8.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:03:54', 'admin-1519433982-15194414340486967', 1, 1, 'SR', NULL, NULL, NULL),
(63915, '2018-02-24 11:05:10', NULL, NULL, 16879, 0, 324, '260', 'Blueberry Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:05:10', 'admin-1519433982-1519441509784648', 1, 0, '', NULL, NULL, NULL),
(63916, '2018-02-24 13:49:14', NULL, NULL, 16906, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:49:14', 'admin-1519433982-15194513547783572', 1, 0, '', NULL, NULL, NULL),
(63917, '2018-02-24 11:35:47', NULL, NULL, 16885, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:35:47', 'admin-1519433982-15194433474085566', 1, 0, '', 1, NULL, NULL),
(63918, '2018-02-24 00:00:00', NULL, NULL, 16884, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:03:54', 'admin-1519433982-15194414340486967', 1, 1, 'SR', NULL, NULL, NULL),
(63919, '2018-02-24 00:00:00', NULL, NULL, 16883, 0, 274, '208', '2 pcs Cookies', '', 'Desserts', '0', 1, 7.00, NULL, NULL, 7.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:03:54', 'admin-1519433982-15194414340486967', 1, 0, '', NULL, NULL, NULL),
(63920, '2018-02-24 00:00:00', NULL, NULL, 16884, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:03:54', 'admin-1519433982-15194414340486967', 1, 0, '', NULL, NULL, NULL),
(63921, '2018-02-24 11:35:47', NULL, NULL, 16885, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:35:47', 'admin-1519433982-15194433474085566', 1, 0, '', 1, NULL, NULL),
(63922, '2018-02-24 11:10:44', NULL, NULL, 16881, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:10:44', 'admin-1519433982-15194418442509969', 1, 1, 'SR', NULL, NULL, NULL),
(63923, '2018-02-24 13:49:14', NULL, NULL, 16906, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:49:14', 'admin-1519433982-15194513547783572', 1, 1, 'SR', NULL, NULL, NULL),
(63924, '2018-02-24 11:35:47', NULL, NULL, 16885, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:35:47', 'admin-1519433982-15194433474085566', 1, 0, '', 1, NULL, NULL),
(63925, '2018-02-24 00:00:00', NULL, NULL, 16884, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:03:54', 'admin-1519433982-15194414340486967', 1, 0, '', NULL, NULL, NULL),
(63926, '2018-02-24 11:01:26', NULL, NULL, 16877, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:01:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63927, '2018-02-24 11:02:18', NULL, NULL, 16877, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:02:18', 'admin-1519433982-15194413380413153', 1, 0, '', NULL, NULL, NULL),
(63928, '2018-02-24 10:45:21', NULL, NULL, 16875, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.70, 0.0000, 0.0000, 9.70, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:45:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63929, '2018-02-24 10:46:20', NULL, NULL, 16875, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:46:20', 'admin-1519433982-15194403804144868', 1, 0, '', NULL, NULL, NULL),
(63930, '2018-02-24 15:09:17', NULL, NULL, 16913, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 15:09:17', 'admin-1519433982-1519456157141876', 1, 0, '', NULL, NULL, NULL),
(63931, '2018-02-24 10:42:29', NULL, NULL, 16874, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:42:29', 'admin-1519433982-15194401493611613', 1, 1, 'SR', NULL, NULL, NULL),
(63932, '2018-02-24 12:08:43', NULL, NULL, 16889, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:08:43', 'admin-1519433982-15194453235179338', 1, 1, 'SR', NULL, NULL, '10.0'),
(63933, '2018-02-24 12:08:43', NULL, NULL, 16889, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:08:43', 'admin-1519433982-15194453235179338', 1, 1, 'SR', NULL, NULL, '10.0'),
(63934, '2018-02-24 16:38:51', NULL, NULL, 16923, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:38:51', 'admin-1519433982-15194615308848088', 1, 1, 'SR', NULL, NULL, NULL),
(63935, '2018-02-24 11:14:08', NULL, NULL, 16882, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:14:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63936, '2018-02-24 11:10:44', NULL, NULL, 16881, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:10:44', 'admin-1519433982-15194418442509969', 1, 1, 'SR', NULL, NULL, NULL),
(63937, '2018-02-24 10:28:23', NULL, NULL, 16871, 0, 181, '116', 'Open Food ', 'sunny side up', 'Meals', 'Perfect Meals', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:28:23', 'admin-1519433982-1519439303022610', 1, 0, '', NULL, NULL, '10.0'),
(63938, '2018-02-24 10:28:23', NULL, NULL, 16871, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:28:23', 'admin-1519433982-1519439303022610', 1, 1, 'SR', NULL, NULL, '10.0'),
(63939, '2018-02-24 15:08:09', NULL, NULL, 16912, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1519433982', 'admin', '2018-02-24 15:08:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63940, '2018-02-24 13:38:13', NULL, NULL, 16904, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:38:13', 'admin-1519433982-15194506935557365', 1, 0, '', NULL, NULL, NULL),
(63941, '2018-02-24 12:58:10', NULL, NULL, 16894, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:58:10', 'admin-1519433982-15194482905291462', 1, 0, '', NULL, NULL, NULL),
(63942, '2018-02-24 11:10:44', NULL, NULL, 16881, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:10:44', 'admin-1519433982-15194418442509969', 1, 1, 'SR', NULL, NULL, NULL),
(63943, '2018-02-24 11:35:47', NULL, NULL, 16885, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:35:47', 'admin-1519433982-15194433474085566', 1, 0, '', 1, NULL, NULL),
(63944, '2018-02-24 11:54:10', NULL, NULL, 16880, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:54:10', 'admin-1519433982-15194444501192999', 1, 1, 'SR', NULL, NULL, NULL),
(63945, '2018-02-24 11:02:18', NULL, NULL, 16877, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:02:18', 'admin-1519433982-15194413380413153', 1, 0, '', NULL, NULL, NULL),
(63946, '2018-02-24 11:02:18', NULL, NULL, 16877, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:02:18', 'admin-1519433982-15194413380413153', 1, 0, '', NULL, NULL, NULL),
(63947, '2018-02-24 10:08:55', NULL, NULL, 16868, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:08:55', 'admin-1519433982-15194381356049599', 1, 0, '', NULL, NULL, NULL),
(63948, '2018-02-24 11:10:44', NULL, NULL, 16881, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:10:44', 'admin-1519433982-15194418442509969', 1, 0, '', NULL, NULL, NULL),
(63949, '2018-02-24 11:10:44', NULL, NULL, 16881, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:10:44', 'admin-1519433982-15194418442509969', 1, 0, '', NULL, NULL, NULL),
(63950, '2018-02-24 12:03:19', NULL, NULL, 16888, 0, 181, '116', 'Open Food ', 'pepper pork rice', 'Meals', 'Perfect Meals', 1, 19.00, 19.0000, 0.0000, 19.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:03:19', 'admin-1519433982-15194449993626998', 1, 0, '', NULL, NULL, NULL),
(63951, '2018-02-24 11:10:44', NULL, NULL, 16881, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:10:44', 'admin-1519433982-15194418442509969', 1, 0, '', NULL, NULL, NULL),
(63952, '2018-02-24 13:32:54', NULL, NULL, 16902, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.50, 0.0000, 0.0000, 8.50, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:32:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63953, '2018-02-24 11:08:37', NULL, NULL, 16880, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:08:37', 'admin-1519433982-151944171719896', 1, 1, 'SR', NULL, NULL, NULL),
(63954, '2018-02-24 11:07:44', NULL, NULL, 16880, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:07:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63955, '2018-02-24 11:08:37', NULL, NULL, 16880, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:08:37', 'admin-1519433982-151944171719896', 1, 0, '', NULL, NULL, NULL),
(63956, '2018-02-24 11:08:37', NULL, NULL, 16880, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:08:37', 'admin-1519433982-151944171719896', 1, 1, 'SR', NULL, NULL, NULL),
(63957, '2018-02-24 10:42:29', NULL, NULL, 16874, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:42:29', 'admin-1519433982-15194401493611613', 1, 1, 'SR', NULL, NULL, NULL),
(63958, '2018-02-24 10:42:29', NULL, NULL, 16874, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:42:29', 'admin-1519433982-15194401493611613', 1, 0, '', NULL, NULL, NULL),
(63959, '2018-02-24 10:45:08', NULL, NULL, 16873, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:45:08', 'admin-1519433982-15194403084832428', 1, 1, 'SR', NULL, NULL, NULL),
(63960, '2018-02-24 11:05:09', NULL, NULL, 16879, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:05:09', 'admin-1519433982-1519441509784648', 1, 0, '', NULL, NULL, NULL),
(63961, '2018-02-24 11:05:09', NULL, NULL, 16879, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:05:10', 'admin-1519433982-1519441509784648', 1, 1, 'SR', NULL, NULL, NULL),
(63962, '2018-02-24 11:05:09', NULL, NULL, 16879, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:05:09', 'admin-1519433982-1519441509784648', 1, 0, '', NULL, NULL, NULL),
(63963, '2018-02-24 11:05:09', NULL, NULL, 16879, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:05:09', 'admin-1519433982-1519441509784648', 1, 0, '', NULL, NULL, NULL),
(63964, '2018-02-24 13:34:18', NULL, NULL, 16896, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:34:18', 'admin-1519433982-15194504586107820', 1, 1, 'SR', NULL, NULL, NULL),
(63965, '2018-02-24 12:41:41', NULL, NULL, 16876, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:41:41', 'admin-1519433982-15194473011922229', 1, 0, '', NULL, NULL, NULL),
(63966, '2018-02-24 00:00:00', NULL, NULL, 16884, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:03:54', 'admin-1519433982-15194414340486967', 1, 0, '', NULL, NULL, NULL),
(63967, '2018-02-24 11:32:24', NULL, NULL, 16883, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:32:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63968, '2018-02-24 11:04:21', NULL, NULL, 16879, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 13.40, 0.0000, 0.0000, 13.40, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:04:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63969, '2018-02-24 11:05:09', NULL, NULL, 16879, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:05:09', 'admin-1519433982-1519441509784648', 1, 0, '', NULL, NULL, NULL),
(63970, '2018-02-24 10:24:33', NULL, NULL, 16870, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:24:33', 'admin-1519433982-15194390731062160', 1, 0, '', NULL, NULL, NULL),
(63971, '2018-02-24 10:24:33', NULL, NULL, 16870, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:24:33', 'admin-1519433982-15194390731062160', 1, 1, 'SR', NULL, NULL, NULL),
(63972, '2018-02-24 13:21:07', NULL, NULL, 16898, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:21:07', 'admin-1519433982-15194496675056593', 1, 1, 'SR', NULL, NULL, NULL),
(63973, '2018-02-24 11:02:18', NULL, NULL, 16877, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:02:18', 'admin-1519433982-15194413380413153', 1, 1, 'SR', NULL, NULL, NULL),
(63974, '2018-02-24 00:00:00', NULL, NULL, 16884, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, NULL, NULL, 6.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:03:54', 'admin-1519433982-15194414340486967', 1, 1, 'SR', NULL, NULL, NULL),
(63975, '2018-02-24 10:13:02', NULL, NULL, 16869, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:13:02', 'admin-1519433982-15194383819695975', 1, 1, 'SR', NULL, NULL, NULL),
(63976, '2018-02-24 12:08:43', NULL, NULL, 16889, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:08:43', 'admin-1519433982-15194453235179338', 1, 1, 'SR', NULL, NULL, '10.0'),
(63977, '2018-02-24 00:00:00', NULL, NULL, 16884, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', NULL, 1, 6.60, NULL, NULL, 6.60, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:02:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63978, '2018-02-24 00:00:00', NULL, NULL, 16932, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 16:45:53', 'admin-1519433982-1519461952879160', 1, 1, 'SR', NULL, NULL, NULL),
(63979, '2018-02-24 11:02:18', NULL, NULL, 16877, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:02:18', 'admin-1519433982-15194413380413153', 1, 1, 'SR', NULL, NULL, NULL),
(63980, '2018-02-24 12:02:31', NULL, NULL, 16888, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 12:02:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63981, '2018-02-24 13:47:22', NULL, NULL, 16904, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:47:22', 'admin-1519433982-15194512423176720', 1, 1, 'SR', NULL, NULL, NULL),
(63982, '2018-02-24 13:40:00', NULL, NULL, 16905, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 13:40:00', 'admin-1519433982-15194508007403310', 1, 1, 'SR', NULL, NULL, NULL),
(63983, '2018-02-24 10:46:20', NULL, NULL, 16875, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:46:20', 'admin-1519433982-15194403804144868', 1, 0, '', NULL, NULL, NULL),
(63984, '2018-02-24 10:46:20', NULL, NULL, 16875, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:46:20', 'admin-1519433982-15194403804144868', 1, 0, '', NULL, NULL, NULL),
(63985, '2018-02-24 11:14:23', NULL, NULL, 16882, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:14:23', 'admin-1519433982-15194420635573148', 1, 1, 'SR', NULL, NULL, NULL),
(63986, '2018-02-24 10:45:08', NULL, NULL, 16873, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:45:08', 'admin-1519433982-15194403084832428', 1, 1, 'SR', NULL, NULL, NULL),
(63987, '2018-02-24 10:44:28', NULL, NULL, 16873, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:44:28', 'admin-1519433982-15194402681636428', 1, 0, '', NULL, NULL, NULL),
(63988, '2018-02-24 10:41:57', NULL, NULL, 16874, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.00, 0.0000, 0.0000, 9.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:41:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63989, '2018-02-24 10:40:37', NULL, NULL, 16873, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:40:37', 'admin-1519433982-1519440037758715', 1, 0, '', NULL, NULL, NULL),
(63990, '2018-02-24 11:35:47', NULL, NULL, 16885, 0, 265, '199', 'Old Penang PostCard', '', 'DISCOUNT ', '0', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:35:47', 'admin-1519433982-15194433474085566', 1, 0, '', 1, NULL, NULL),
(63991, '2018-02-24 10:42:29', NULL, NULL, 16874, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:42:29', 'admin-1519433982-15194401493611613', 1, 0, '', NULL, NULL, NULL),
(63992, '2018-02-24 10:31:41', NULL, NULL, 16872, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:31:41', 'admin-1519433982-15194395016336920', 1, 1, 'SR', NULL, NULL, NULL),
(63993, '2018-02-24 10:31:41', NULL, NULL, 16872, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:31:41', 'admin-1519433982-15194395016336920', 1, 1, 'SR', NULL, NULL, NULL),
(63994, '2018-02-24 10:39:53', NULL, NULL, 16873, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.25, 0.0000, 0.0000, 6.25, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:39:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63995, '2018-02-24 10:31:36', NULL, NULL, 16872, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:31:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(63996, '2018-02-24 10:28:23', NULL, NULL, 16871, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:28:23', 'admin-1519433982-1519439303022610', 1, 0, '', NULL, NULL, '10.0'),
(63997, '2018-02-24 09:46:02', NULL, NULL, 16866, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 09:46:02', 'admin-1519433982-15194367625406943', 1, 0, '', NULL, NULL, NULL),
(63998, '2018-02-24 10:27:53', NULL, NULL, 16871, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:27:53', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(63999, '2018-02-24 14:06:54', NULL, NULL, 16910, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 14:06:54', 'admin-1519433982-15194524146143316', 1, 0, '', NULL, NULL, NULL),
(64000, '2018-02-24 00:00:00', NULL, NULL, 16884, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 11:03:54', 'admin-1519433982-15194414340486967', 1, 1, 'SR', NULL, NULL, NULL),
(64001, '2018-02-24 10:13:02', NULL, NULL, 16869, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 10:13:02', 'admin-1519433982-15194383819695975', 1, 1, 'SR', NULL, NULL, NULL),
(64002, '2018-02-24 09:58:35', NULL, NULL, 16867, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 09:58:35', 'admin-1519433982-15194375154399063', 1, 0, '', NULL, NULL, NULL),
(64003, '2018-02-24 09:58:35', NULL, NULL, 16867, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 09:58:35', 'admin-1519433982-15194375154399063', 1, 0, '', NULL, NULL, NULL),
(64004, '2018-02-24 09:46:02', NULL, NULL, 16866, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 09:46:02', 'admin-1519433982-15194367625406943', 1, 0, '', NULL, NULL, NULL),
(64005, '2018-02-24 09:58:09', NULL, NULL, 16867, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1519433982', 'admin', '2018-02-24 09:58:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64006, '2018-02-24 09:46:02', NULL, NULL, 16866, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 09:46:02', 'admin-1519433982-15194367625406943', 1, 0, '', NULL, NULL, NULL),
(64007, '2018-02-24 09:46:02', NULL, NULL, 16866, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519433982', 'admin', '2018-02-24 09:46:02', 'admin-1519433982-15194367625406943', 1, 1, 'SR', NULL, NULL, NULL),
(64008, '2018-02-24 09:45:38', NULL, NULL, 16866, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1519433982', 'admin', '2018-02-24 09:45:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64009, '2018-02-25 12:40:19', NULL, NULL, 16955, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:40:19', 'admin-1519520119-15195336191953918', 1, 0, '', NULL, NULL, NULL),
(64010, '2018-02-25 12:40:19', NULL, NULL, 16955, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:40:19', 'admin-1519520119-15195336191953918', 1, 1, 'SR', NULL, NULL, NULL),
(64011, '2018-02-25 12:40:19', NULL, NULL, 16955, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:40:19', 'admin-1519520119-15195336191953918', 1, 0, '', NULL, NULL, NULL),
(64012, '2018-02-25 00:00:00', NULL, NULL, 16945, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:06:28', 'admin-1519520119-15195243886144655', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(64013, '2018-02-25 13:04:45', NULL, NULL, 16959, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:04:45', 'admin-1519520119-15195350849315177', 1, 1, 'SR', NULL, NULL, NULL),
(64014, '2018-02-25 13:04:45', NULL, NULL, 16959, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:04:45', 'admin-1519520119-15195350849315177', 1, 1, 'SR', NULL, NULL, NULL),
(64015, '2018-02-25 13:04:45', NULL, NULL, 16959, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:04:45', 'admin-1519520119-15195350849315177', 1, 1, 'SR', NULL, NULL, NULL),
(64016, '2018-02-25 13:59:21', NULL, NULL, 16961, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:59:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64017, '2018-02-25 12:52:23', NULL, NULL, 16957, 0, 181, '116', 'Open Food ', 'minced pork rice', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:52:23', 'admin-1519520119-15195343432065876', 1, 0, '', NULL, NULL, NULL),
(64018, '2018-02-25 12:53:02', NULL, NULL, 16958, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:53:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64019, '2018-02-25 09:53:17', NULL, NULL, 16936, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 09:53:17', 'admin-1519520119-15195235976209776', 1, 1, 'SR', NULL, NULL, NULL),
(64020, '2018-02-25 12:05:15', NULL, NULL, 16953, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:05:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64021, '2018-02-25 12:47:34', NULL, NULL, 16956, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:47:34', 'admin-1519520119-15195340541866750', 1, 1, 'SR', NULL, NULL, NULL),
(64022, '2018-02-25 12:50:04', NULL, NULL, 16957, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 12.80, 0.0000, 0.0000, 12.80, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:50:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64023, '2018-02-25 15:28:16', NULL, NULL, 16964, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 15:28:16', 'admin-1519520119-15195436965273767', 1, 0, '', NULL, NULL, NULL),
(64024, '2018-02-25 15:28:36', NULL, NULL, 16965, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1519520119', 'admin', '2018-02-25 15:28:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64025, '2018-02-25 15:28:43', NULL, NULL, 16965, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 15:28:43', 'admin-1519520119-15195437232658124', 1, 1, 'SR', NULL, NULL, NULL),
(64026, '2018-02-25 15:34:00', NULL, NULL, 16966, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1519520119', 'admin', '2018-02-25 15:34:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64027, '2018-02-25 15:34:12', NULL, NULL, 16966, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 15:34:12', 'admin-1519520119-15195440521563395', 1, 1, 'SR', NULL, NULL, NULL),
(64028, '2018-02-25 15:34:12', NULL, NULL, 16966, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 15:34:12', 'admin-1519520119-15195440521563395', 1, 0, '', NULL, NULL, NULL),
(64029, '2018-02-25 13:51:42', NULL, NULL, 16955, 0, 291, '225', 'Smoked Duck Red Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:51:42', 'admin-1519520119-15195379024448537', 1, 0, '', NULL, NULL, NULL),
(64030, '2018-02-25 13:24:24', NULL, NULL, 16952, 0, 181, '116', 'Open Food ', 'ginger chic', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:24:24', 'admin-1519520119-15195362640174324', 1, 0, '', NULL, NULL, NULL),
(64031, '2018-02-25 12:06:11', NULL, NULL, 16953, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:06:11', 'admin-1519520119-15195315710581834', 1, 1, 'SR', NULL, NULL, NULL),
(64032, '2018-02-25 12:06:11', NULL, NULL, 16953, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:06:11', 'admin-1519520119-15195315710581834', 1, 1, 'SR', NULL, NULL, NULL),
(64033, '2018-02-25 12:51:38', NULL, NULL, 16957, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:51:38', 'admin-1519520119-15195342981806360', 1, 0, '', NULL, NULL, NULL),
(64034, '2018-02-25 12:51:38', NULL, NULL, 16957, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:51:38', 'admin-1519520119-15195342981806360', 1, 0, '', NULL, NULL, NULL),
(64035, '2018-02-25 13:32:52', NULL, NULL, 16960, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:32:52', 'admin-1519520119-15195367725443381', 1, 0, '', NULL, NULL, NULL),
(64036, '2018-02-25 13:32:52', NULL, NULL, 16960, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:32:52', 'admin-1519520119-15195367725443381', 1, 0, '', NULL, NULL, NULL),
(64037, '2018-02-25 13:32:52', NULL, NULL, 16960, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:32:52', 'admin-1519520119-15195367725443381', 1, 0, '', NULL, NULL, NULL),
(64038, '2018-02-25 13:32:52', NULL, NULL, 16960, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:32:52', 'admin-1519520119-15195367725443381', 1, 1, 'SR', NULL, NULL, NULL),
(64039, '2018-02-25 13:32:52', NULL, NULL, 16960, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:32:52', 'admin-1519520119-15195367725443381', 1, 0, '', NULL, NULL, NULL),
(64040, '2018-02-25 11:08:39', NULL, NULL, 16946, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:08:39', 'admin-1519520119-15195281194534721', 1, 0, '', NULL, NULL, NULL),
(64041, '2018-02-25 11:08:39', NULL, NULL, 16946, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:08:39', 'admin-1519520119-15195281194534721', 1, 0, '', NULL, NULL, NULL),
(64042, '2018-02-25 15:35:34', NULL, NULL, 16967, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1519520119', 'admin', '2018-02-25 15:35:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64043, '2018-02-25 11:23:24', NULL, NULL, 16948, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:23:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64044, '2018-02-25 11:23:35', NULL, NULL, 16948, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:23:35', 'admin-1519520119-15195290150901327', 1, 0, '', NULL, NULL, NULL),
(64045, '2018-02-25 15:35:41', NULL, NULL, 16967, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 15:35:41', 'admin-1519520119-15195441410858811', 1, 1, 'SR', NULL, NULL, NULL),
(64046, '2018-02-25 15:47:24', NULL, NULL, 16968, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1519520119', 'admin', '2018-02-25 15:47:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64047, '2018-02-25 16:24:30', NULL, NULL, 16968, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 16:24:30', 'admin-1519520119-15195470699479756', 1, 1, 'SR', NULL, NULL, NULL),
(64048, '2018-02-25 16:24:30', NULL, NULL, 16968, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 16:24:30', 'admin-1519520119-15195470699479756', 1, 1, 'SR', NULL, NULL, NULL),
(64049, '2018-02-25 11:13:37', NULL, NULL, 16947, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.40, 0.0000, 0.0000, 7.40, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:13:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64050, '2018-02-25 16:03:44', NULL, NULL, 16961, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 16:03:44', 'admin-1519520119-15195458243213560', 1, 1, 'SR', NULL, NULL, NULL),
(64051, '2018-02-25 13:59:35', NULL, NULL, 16961, 0, 328, '264', 'Basic Blueberries Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:59:35', 'admin-1519520119-15195383752033724', 1, 0, '', NULL, NULL, NULL),
(64052, '2018-02-25 12:51:38', NULL, NULL, 16957, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:51:38', 'admin-1519520119-15195342981806360', 1, 0, '', NULL, NULL, NULL),
(64053, '2018-02-25 13:51:42', NULL, NULL, 16955, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:51:42', 'admin-1519520119-15195379024448537', 1, 1, 'SR', NULL, NULL, NULL),
(64054, '2018-02-25 12:47:34', NULL, NULL, 16956, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:47:34', 'admin-1519520119-15195340541866750', 1, 1, 'SR', NULL, NULL, NULL),
(64055, '2018-02-25 12:40:19', NULL, NULL, 16955, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:40:19', 'admin-1519520119-15195336191953918', 1, 1, 'SR', NULL, NULL, NULL),
(64056, '2018-02-25 17:01:19', NULL, NULL, 16974, 0, 338, '274', 'Chocolate Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 17:01:19', 'admin-1519520119-15195492792418880', 1, 0, '', NULL, NULL, NULL),
(64057, '2018-02-25 15:52:15', NULL, NULL, 16969, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1519520119', 'admin', '2018-02-25 15:52:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64058, '2018-02-25 15:52:30', NULL, NULL, 16969, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 3, 9.00, 27.0000, 0.0000, 27.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 15:52:30', 'admin-1519520119-15195451506095498', 1, 0, '', NULL, NULL, NULL),
(64059, '2018-02-25 15:01:51', NULL, NULL, 16963, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1519520119', 'admin', '2018-02-25 15:01:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64060, '2018-02-25 14:07:28', NULL, NULL, 16962, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 14:07:28', 'admin-1519520119-15195388482359791', 1, 1, 'SR', NULL, NULL, NULL),
(64061, '2018-02-25 14:07:28', NULL, NULL, 16962, 0, 338, '274', 'Chocolate Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 14:07:28', 'admin-1519520119-15195388482359791', 1, 0, '', NULL, NULL, NULL),
(64062, '2018-02-25 15:52:30', NULL, NULL, 16969, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 15:52:30', 'admin-1519520119-15195451506095498', 1, 0, '', NULL, NULL, NULL),
(64063, '2018-02-25 15:52:30', NULL, NULL, 16969, 0, 19, '19', 'Iced Vanilla Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 15:52:30', 'admin-1519520119-15195451506095498', 1, 1, 'SR', NULL, NULL, NULL),
(64064, '2018-02-25 11:30:27', NULL, NULL, 16949, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:30:27', 'admin-1519520119-15195294272322766', 1, 1, 'SR', NULL, NULL, NULL),
(64065, '2018-02-25 11:30:27', NULL, NULL, 16949, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:30:27', 'admin-1519520119-15195294272322766', 1, 1, 'SR', NULL, NULL, NULL),
(64066, '2018-02-25 11:30:27', NULL, NULL, 16949, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:30:27', 'admin-1519520119-15195294272322766', 1, 0, '', NULL, NULL, NULL),
(64067, '2018-02-25 16:22:29', NULL, NULL, 16971, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 16:22:29', 'admin-1519520119-15195469491157492', 1, 1, 'SR', 1, NULL, NULL),
(64068, '2018-02-25 13:53:37', NULL, NULL, 16960, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:53:37', 'admin-1519520119-15195380170548345', 1, 1, 'SR', NULL, NULL, NULL),
(64069, '2018-02-25 13:59:35', NULL, NULL, 16961, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:59:35', 'admin-1519520119-15195383752033724', 1, 0, '', NULL, NULL, NULL),
(64070, '2018-02-25 13:04:45', NULL, NULL, 16959, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:04:45', 'admin-1519520119-15195350849315177', 1, 1, 'SR', NULL, NULL, NULL),
(64071, '2018-02-25 11:14:05', NULL, NULL, 16947, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:14:05', 'admin-1519520119-151952844549063', 1, 0, '', NULL, NULL, NULL),
(64072, '2018-02-25 10:59:20', NULL, NULL, 16940, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:59:20', 'admin-1519520119-15195275603669942', 1, 0, '', NULL, NULL, NULL),
(64073, '2018-02-25 12:26:40', NULL, NULL, 16955, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 24.30, 0.0000, 0.0000, 24.30, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:26:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64074, '2018-02-25 12:26:53', NULL, NULL, 16955, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:26:53', 'admin-1519520119-1519532813341884', 1, 1, 'SR', NULL, NULL, NULL),
(64075, '2018-02-25 16:53:08', NULL, NULL, 16973, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 16:53:08', 'admin-1519520119-15195487880538696', 1, 1, 'SR', NULL, NULL, NULL),
(64076, '2018-02-25 17:01:19', NULL, NULL, 16974, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 17:01:19', 'admin-1519520119-15195492792418880', 1, 1, 'SR', NULL, NULL, NULL),
(64077, '2018-02-25 13:25:57', NULL, NULL, 16960, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:25:57', 'admin-1519520119-15195363569244591', 1, 1, 'SR', NULL, NULL, NULL),
(64078, '2018-02-25 13:25:57', NULL, NULL, 16960, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:25:57', 'admin-1519520119-15195363569244591', 1, 1, 'SR', NULL, NULL, NULL),
(64079, '2018-02-25 11:30:27', NULL, NULL, 16949, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:30:27', 'admin-1519520119-15195294272322766', 1, 0, '', NULL, NULL, NULL),
(64080, '2018-02-25 12:51:38', NULL, NULL, 16957, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:51:38', 'admin-1519520119-15195342981806360', 1, 0, '', NULL, NULL, NULL),
(64081, '2018-02-25 11:08:39', NULL, NULL, 16946, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:08:39', 'admin-1519520119-15195281194534721', 1, 0, '', NULL, NULL, NULL),
(64082, '2018-02-25 11:08:39', NULL, NULL, 16946, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:08:39', 'admin-1519520119-15195281194534721', 1, 0, '', NULL, NULL, NULL),
(64083, '2018-02-25 16:52:36', NULL, NULL, 16973, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1519520119', 'admin', '2018-02-25 16:52:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64084, '2018-02-25 17:01:03', NULL, NULL, 16974, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1519520119', 'admin', '2018-02-25 17:01:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64085, '2018-02-25 17:01:19', NULL, NULL, 16974, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 17:01:19', 'admin-1519520119-15195492792418880', 1, 1, 'SR', NULL, NULL, NULL),
(64086, '2018-02-25 16:57:34', NULL, NULL, 16973, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 3, 11.00, 33.0000, 0.0000, 33.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 16:57:34', 'admin-1519520119-15195490543795576', 1, 1, 'SR', NULL, NULL, NULL),
(64087, '2018-02-25 16:26:33', NULL, NULL, 16970, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 16:26:33', 'admin-1519520119-1519547193837959', 1, 0, '', NULL, NULL, NULL),
(64088, '2018-02-25 16:26:20', NULL, NULL, 16970, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 16:26:20', 'admin-1519520119-15195471808308921', 1, 1, 'SR', NULL, NULL, NULL),
(64089, '2018-02-25 16:26:20', NULL, NULL, 16970, 0, 338, '274', 'Chocolate Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 16:26:20', 'admin-1519520119-15195471808308921', 1, 0, '', NULL, NULL, NULL),
(64090, '2018-02-25 12:53:20', NULL, NULL, 16958, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:53:20', 'admin-1519520119-15195344007194864', 1, 0, '', NULL, NULL, NULL),
(64091, '2018-02-25 12:53:20', NULL, NULL, 16958, 0, 49, '49', 'Mocha Frappe', '', 'Cold Drinks', 'Frappe', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:53:20', 'admin-1519520119-15195344007194864', 1, 1, 'SR', NULL, NULL, NULL),
(64092, '2018-02-25 13:04:07', NULL, NULL, 16959, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.70, 0.0000, 0.0000, 8.70, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:04:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64093, '2018-02-25 12:40:19', NULL, NULL, 16955, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:40:19', 'admin-1519520119-15195336191953918', 1, 1, 'SR', NULL, NULL, NULL),
(64094, '2018-02-25 12:10:54', NULL, NULL, 16952, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:10:54', 'admin-1519520119-15195318541062298', 1, 1, 'SR', NULL, NULL, NULL),
(64095, '2018-02-25 16:14:35', NULL, NULL, 16970, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 16:14:35', 'admin-1519520119-15195464753703046', 1, 0, '', NULL, NULL, NULL),
(64096, '2018-02-25 16:14:35', NULL, NULL, 16970, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 16:14:35', 'admin-1519520119-15195464753703046', 1, 0, '', NULL, NULL, NULL),
(64097, '2018-02-25 16:23:19', NULL, NULL, 16972, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1519520119', 'admin', '2018-02-25 16:23:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64098, '2018-02-25 16:23:27', NULL, NULL, 16972, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 16:23:27', 'admin-1519520119-15195470075364925', 1, 1, 'SR', NULL, NULL, NULL),
(64099, '2018-02-25 16:53:08', NULL, NULL, 16973, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 16:53:08', 'admin-1519520119-15195487880538696', 1, 1, 'SR', NULL, NULL, NULL),
(64100, '2018-02-25 12:47:34', NULL, NULL, 16956, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:47:34', 'admin-1519520119-15195340541866750', 1, 0, '', NULL, NULL, NULL),
(64101, '2018-02-25 11:47:19', NULL, NULL, 16951, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:47:19', 'admin-1519520119-1519530439019996', 1, 1, 'SR', NULL, NULL, NULL),
(64102, '2018-02-25 11:55:42', NULL, NULL, 16949, 0, 181, '116', 'Open Food ', 'ginger chicken', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:55:42', 'admin-1519520119-15195309420954268', 1, 0, '', NULL, NULL, NULL),
(64103, '2018-02-25 11:55:42', NULL, NULL, 16949, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:55:42', 'admin-1519520119-15195309420954268', 1, 1, 'SR', NULL, NULL, NULL),
(64104, '2018-02-25 11:57:32', NULL, NULL, 16952, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.30, 0.0000, 0.0000, 5.30, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:57:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64105, '2018-02-25 11:57:46', NULL, NULL, 16952, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:57:46', 'admin-1519520119-151953106594331', 1, 0, '', NULL, NULL, NULL),
(64106, '2018-02-25 15:35:41', NULL, NULL, 16967, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 15:35:41', 'admin-1519520119-15195441410858811', 1, 1, 'SR', NULL, NULL, NULL),
(64107, '2018-02-25 10:41:12', NULL, NULL, 16940, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:41:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64108, '2018-02-25 10:41:28', NULL, NULL, 16940, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:41:28', 'admin-1519520119-15195264881938225', 1, 0, '', NULL, NULL, NULL),
(64109, '2018-02-25 11:23:35', NULL, NULL, 16948, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:23:35', 'admin-1519520119-15195290150901327', 1, 0, '', NULL, NULL, NULL),
(64110, '2018-02-25 11:28:54', NULL, NULL, 16949, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 17.90, 0.0000, 0.0000, 17.90, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:28:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64111, '2018-02-25 11:30:27', NULL, NULL, 16949, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:30:27', 'admin-1519520119-15195294272322766', 1, 0, '', NULL, NULL, NULL),
(64112, '2018-02-25 10:58:39', NULL, NULL, 16939, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:58:39', 'admin-1519520119-1519527518877380', 1, 1, 'SR', NULL, NULL, NULL),
(64113, '2018-02-25 10:23:06', NULL, NULL, 16939, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:23:06', 'admin-1519520119-15195253862781853', 1, 1, 'SR', NULL, NULL, NULL),
(64114, '2018-02-25 15:28:08', NULL, NULL, 16964, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 15:28:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64115, '2018-02-25 15:01:56', NULL, NULL, 16963, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 15:01:56', 'admin-1519520119-15195421165908088', 1, 0, '', NULL, NULL, NULL),
(64116, '2018-02-25 11:14:05', NULL, NULL, 16947, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:14:05', 'admin-1519520119-151952844549063', 1, 0, '', NULL, NULL, NULL),
(64117, '2018-02-25 10:23:06', NULL, NULL, 16939, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:23:06', 'admin-1519520119-15195253862781853', 1, 1, 'SR', NULL, NULL, NULL),
(64118, '2018-02-25 10:23:06', NULL, NULL, 16939, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:23:06', 'admin-1519520119-15195253862781853', 1, 0, '', NULL, NULL, NULL),
(64119, '2018-02-25 10:41:57', NULL, NULL, 16941, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:41:57', 'admin-1519520119-15195265170932674', 1, 1, 'SR', 1, NULL, NULL),
(64120, '2018-02-25 14:07:28', NULL, NULL, 16962, 0, 181, '116', 'Open Food ', 'ginger chic rice', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 14:07:28', 'admin-1519520119-15195388482359791', 1, 0, '', NULL, NULL, NULL),
(64121, '2018-02-25 14:06:50', NULL, NULL, 16962, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.38, 0.0000, 0.0000, 5.38, 1, '27', 1, '1519520119', 'admin', '2018-02-25 14:06:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64122, '2018-02-25 12:11:02', NULL, NULL, 16954, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:11:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64123, '2018-02-25 12:11:20', NULL, NULL, 16954, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:11:20', 'admin-1519520119-15195318805557123', 1, 0, '', NULL, NULL, NULL),
(64124, '2018-02-25 12:11:20', NULL, NULL, 16954, 0, 153, '87', 'Wake Me Up!', 'sunny side', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:11:20', 'admin-1519520119-15195318805557123', 1, 0, '', NULL, NULL, NULL),
(64125, '2018-02-25 13:32:52', NULL, NULL, 16960, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:32:52', 'admin-1519520119-15195367725443381', 1, 0, '', NULL, NULL, NULL),
(64126, '2018-02-25 10:00:25', NULL, NULL, 16937, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:00:25', 'admin-1519520119-15195240252024071', 1, 0, '', NULL, NULL, NULL),
(64127, '2018-02-25 10:00:25', NULL, NULL, 16937, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:00:25', 'admin-1519520119-15195240252024071', 1, 0, '', NULL, NULL, NULL),
(64128, '2018-02-25 12:26:53', NULL, NULL, 16955, 0, 335, '271', 'Iced Honey Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:26:53', 'admin-1519520119-1519532813341884', 1, 0, '', NULL, NULL, NULL),
(64129, '2018-02-25 09:32:08', NULL, NULL, 16935, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 09:32:08', 'admin-1519520119-15195223283445770', 1, 0, '', NULL, NULL, NULL),
(64130, '2018-02-25 13:25:57', NULL, NULL, 16960, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:25:57', 'admin-1519520119-15195363569244591', 1, 1, 'SR', NULL, NULL, NULL),
(64131, '2018-02-25 13:25:57', NULL, NULL, 16960, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:25:57', 'admin-1519520119-15195363569244591', 1, 1, 'SR', NULL, NULL, NULL),
(64132, '2018-02-25 16:03:56', NULL, NULL, 16970, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1519520119', 'admin', '2018-02-25 16:03:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64133, '2018-02-25 11:30:27', NULL, NULL, 16949, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:30:27', 'admin-1519520119-15195294272322766', 1, 0, '', NULL, NULL, NULL),
(64134, '2018-02-25 11:30:27', NULL, NULL, 16949, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:30:27', 'admin-1519520119-15195294272322766', 1, 0, '', NULL, NULL, NULL),
(64135, '2018-02-25 11:30:27', NULL, NULL, 16949, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:30:27', 'admin-1519520119-15195294272322766', 1, 0, '', NULL, NULL, NULL),
(64136, '2018-02-25 10:00:25', NULL, NULL, 16937, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:00:25', 'admin-1519520119-15195240252024071', 1, 1, 'SR', NULL, NULL, NULL),
(64137, '2018-02-25 10:01:28', NULL, NULL, 16937, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:01:28', 'admin-1519520119-15195240884217742', 1, 1, 'SR', NULL, NULL, NULL),
(64138, '2018-02-25 12:47:22', NULL, NULL, 16956, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:47:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64139, '2018-02-25 11:14:05', NULL, NULL, 16947, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:14:05', 'admin-1519520119-151952844549063', 1, 0, '', NULL, NULL, NULL),
(64140, '2018-02-25 13:25:57', NULL, NULL, 16960, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:25:57', 'admin-1519520119-15195363569244591', 1, 1, 'SR', NULL, NULL, NULL),
(64141, '2018-02-25 13:04:45', NULL, NULL, 16959, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:04:45', 'admin-1519520119-15195350849315177', 1, 0, '', NULL, NULL, NULL),
(64142, '2018-02-25 13:04:45', NULL, NULL, 16959, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:04:45', 'admin-1519520119-15195350849315177', 1, 0, '', NULL, NULL, NULL),
(64143, '2018-02-25 12:51:38', NULL, NULL, 16957, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:51:38', 'admin-1519520119-15195342981806360', 1, 1, 'SR', NULL, NULL, NULL),
(64144, '2018-02-25 12:51:38', NULL, NULL, 16957, 0, 324, '260', 'Blueberry Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:51:38', 'admin-1519520119-15195342981806360', 1, 0, '', NULL, NULL, NULL),
(64145, '2018-02-25 12:51:38', NULL, NULL, 16957, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:51:38', 'admin-1519520119-15195342981806360', 1, 0, '', NULL, NULL, NULL),
(64146, '2018-02-25 12:40:19', NULL, NULL, 16955, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:40:19', 'admin-1519520119-15195336191953918', 1, 1, 'SR', NULL, NULL, NULL),
(64147, '2018-02-25 12:40:19', NULL, NULL, 16955, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:40:19', 'admin-1519520119-15195336191953918', 1, 1, 'SR', NULL, NULL, NULL),
(64148, '2018-02-25 12:40:19', NULL, NULL, 16955, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:40:19', 'admin-1519520119-15195336191953918', 1, 1, 'SR', NULL, NULL, NULL),
(64149, '2018-02-25 16:14:35', NULL, NULL, 16970, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 16:14:35', 'admin-1519520119-15195464753703046', 1, 0, '', NULL, NULL, NULL),
(64150, '2018-02-25 12:40:19', NULL, NULL, 16955, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:40:19', 'admin-1519520119-15195336191953918', 1, 0, '', NULL, NULL, NULL),
(64151, '2018-02-25 12:40:19', NULL, NULL, 16955, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:40:19', 'admin-1519520119-15195336191953918', 1, 0, '', NULL, NULL, NULL),
(64152, '2018-02-25 12:40:19', NULL, NULL, 16955, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:40:19', 'admin-1519520119-15195336191953918', 1, 0, '', NULL, NULL, NULL),
(64153, '2018-02-25 12:40:19', NULL, NULL, 16955, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:40:19', 'admin-1519520119-15195336191953918', 1, 1, 'SR', NULL, NULL, NULL),
(64154, '2018-02-25 11:14:05', NULL, NULL, 16947, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:14:05', 'admin-1519520119-151952844549063', 1, 0, '', NULL, NULL, NULL),
(64155, '2018-02-25 11:14:05', NULL, NULL, 16947, 0, 304, '240', 'Banana is On Fire', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:14:05', 'admin-1519520119-151952844549063', 1, 0, '', NULL, NULL, NULL),
(64156, '2018-02-25 12:11:20', NULL, NULL, 16954, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:11:20', 'admin-1519520119-15195318805557123', 1, 0, '', NULL, NULL, NULL),
(64157, '2018-02-25 12:40:19', NULL, NULL, 16955, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:40:19', 'admin-1519520119-15195336191953918', 1, 0, '', NULL, NULL, NULL),
(64158, '2018-02-25 12:05:20', NULL, NULL, 16953, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:05:20', 'admin-1519520119-15195315208271928', 1, 1, 'SR', NULL, NULL, NULL),
(64159, '2018-02-25 12:11:20', NULL, NULL, 16954, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:11:20', 'admin-1519520119-15195318805557123', 1, 1, 'SR', NULL, NULL, NULL),
(64160, '2018-02-25 12:10:54', NULL, NULL, 16952, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:10:54', 'admin-1519520119-15195318541062298', 1, 1, 'SR', NULL, NULL, NULL),
(64161, '2018-02-25 11:35:22', NULL, NULL, 16950, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:35:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64162, '2018-02-25 11:57:46', NULL, NULL, 16952, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:57:46', 'admin-1519520119-151953106594331', 1, 1, 'SR', NULL, NULL, NULL),
(64163, '2018-02-25 11:47:19', NULL, NULL, 16951, 0, 181, '116', 'Open Food ', 'ginger chicken', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:47:19', 'admin-1519520119-1519530439019996', 1, 0, '', NULL, NULL, NULL),
(64164, '2018-02-25 11:46:49', NULL, NULL, 16951, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.00, 0.0000, 0.0000, 3.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:46:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64165, '2018-02-25 11:35:32', NULL, NULL, 16950, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:35:32', 'admin-1519520119-15195297326167757', 1, 0, '', NULL, NULL, NULL),
(64166, '2018-02-25 11:35:32', NULL, NULL, 16950, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:35:32', 'admin-1519520119-15195297326167757', 1, 1, 'SR', NULL, NULL, NULL),
(64167, '2018-02-25 11:30:27', NULL, NULL, 16949, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:30:27', 'admin-1519520119-15195294272322766', 1, 0, '', NULL, NULL, NULL),
(64168, '2018-02-25 11:30:27', NULL, NULL, 16949, 0, 239, '173', 'Iced Caramel Chocolate', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:30:27', 'admin-1519520119-15195294272322766', 1, 0, '', NULL, NULL, NULL),
(64169, '2018-02-25 11:30:27', NULL, NULL, 16949, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:30:27', 'admin-1519520119-15195294272322766', 1, 0, '', NULL, NULL, NULL),
(64170, '2018-02-25 14:11:28', NULL, NULL, 16962, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 12.80, 1, '27', 1, '1519520119', 'admin', '2018-02-25 14:11:28', 'admin-1519520119-15195390882523468', 1, 0, '', NULL, '20.0', NULL),
(64171, '2018-02-25 15:47:33', NULL, NULL, 16968, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 15:47:33', 'admin-1519520119-15195448529528199', 1, 0, '', NULL, NULL, NULL),
(64172, '2018-02-25 09:31:52', NULL, NULL, 16935, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1519520119', 'admin', '2018-02-25 09:31:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64173, '2018-02-25 09:32:08', NULL, NULL, 16935, 0, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 09:32:08', 'admin-1519520119-15195223283445770', 1, 1, 'SR', NULL, NULL, NULL),
(64174, '2018-02-25 13:25:44', NULL, NULL, 16960, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 16.20, 0.0000, 0.0000, 16.20, 1, '27', 1, '1519520119', 'admin', '2018-02-25 13:25:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64175, '2018-02-25 11:08:39', NULL, NULL, 16946, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:08:39', 'admin-1519520119-15195281194534721', 1, 1, 'SR', NULL, NULL, NULL),
(64176, '2018-02-25 11:08:23', NULL, NULL, 16946, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.80, 0.0000, 0.0000, 9.80, 1, '27', 1, '1519520119', 'admin', '2018-02-25 11:08:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64177, '2018-02-25 00:00:00', NULL, NULL, 16944, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:06:28', 'admin-1519520119-15195243886144655', 1, 0, '', NULL, NULL, NULL),
(64178, '2018-02-25 00:00:00', NULL, NULL, 16942, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, NULL, NULL, 13.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:06:28', 'admin-1519520119-15195243886144655', 1, 0, '', NULL, NULL, NULL),
(64179, '2018-02-25 00:00:00', NULL, NULL, 16943, 0, 301, '237', 'Black Jack', '', 'Cold Drinks', 'Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:06:28', 'admin-1519520119-15195243886144655', 1, 0, '', NULL, NULL, NULL),
(64180, '2018-02-25 00:00:00', NULL, NULL, 16943, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:56:29', 'admin-1519520119-15195273889171935', 1, 0, '', NULL, NULL, NULL),
(64181, '2018-02-25 10:41:28', NULL, NULL, 16940, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:41:28', 'admin-1519520119-15195264881938225', 1, 0, '', NULL, NULL, NULL),
(64182, '2018-02-25 10:57:15', NULL, NULL, 16944, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:57:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64183, '2018-02-25 10:18:33', NULL, NULL, 16937, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:18:33', 'admin-1519520119-15195251134208187', 1, 0, '', NULL, NULL, NULL),
(64184, '2018-02-25 10:23:00', NULL, NULL, 16939, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.70, 0.0000, 0.0000, 5.70, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:23:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64185, '2018-02-25 10:23:06', NULL, NULL, 16939, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:23:06', 'admin-1519520119-15195253862781853', 1, 1, 'SR', NULL, NULL, NULL),
(64186, '2018-02-25 10:56:43', NULL, NULL, 16943, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:56:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64187, '2018-02-25 10:00:25', NULL, NULL, 16937, 0, 75, '75', 'Meatless Aglio Olio ', 'no cili', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:00:25', 'admin-1519520119-15195240252024071', 1, 0, '', NULL, NULL, NULL),
(64188, '2018-02-25 12:47:34', NULL, NULL, 16956, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 12:47:34', 'admin-1519520119-15195340541866750', 1, 0, '', NULL, NULL, NULL),
(64189, '2018-02-25 10:54:11', NULL, NULL, 16942, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:54:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64190, '2018-02-25 00:00:00', NULL, NULL, 16945, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:06:28', 'admin-1519520119-15195243886144655', 1, 0, '', NULL, NULL, NULL),
(64191, '2018-02-25 00:00:00', NULL, NULL, 16945, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', NULL, 1, 2.80, NULL, NULL, 2.80, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:05:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64192, '2018-02-25 00:00:00', NULL, NULL, 16942, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:06:28', 'admin-1519520119-15195243886144655', 1, 1, 'SR', NULL, NULL, NULL),
(64193, '2018-02-25 00:00:00', NULL, NULL, 16944, 0, 335, '271', 'Iced Honey Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:06:28', 'admin-1519520119-15195243886144655', 1, 0, '', NULL, NULL, NULL),
(64194, '2018-02-25 10:58:39', NULL, NULL, 16939, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 10:58:39', 'admin-1519520119-1519527518877380', 1, 1, 'SR', NULL, NULL, NULL),
(64195, '2018-02-25 09:59:58', NULL, NULL, 16937, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.60, 0.0000, 0.0000, 8.60, 1, '27', 1, '1519520119', 'admin', '2018-02-25 09:59:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64196, '2018-02-25 09:53:17', NULL, NULL, 16936, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 09:53:17', 'admin-1519520119-15195235976209776', 1, 0, '', NULL, NULL, NULL),
(64197, '2018-02-25 09:53:06', NULL, NULL, 16936, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1519520119', 'admin', '2018-02-25 09:53:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64198, '2018-02-25 09:18:36', NULL, NULL, 16934, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 09:18:36', 'admin-1519520119-15195215161758152', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(64199, '2018-02-25 09:18:36', NULL, NULL, 16934, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 09:18:36', 'admin-1519520119-15195215161758152', 1, 0, '', NULL, NULL, NULL),
(64200, '2018-02-25 09:18:36', NULL, NULL, 16934, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 09:18:36', 'admin-1519520119-15195215161758152', 1, 1, 'SR', NULL, NULL, NULL),
(64201, '2018-02-25 09:18:36', NULL, NULL, 16934, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519520119', 'admin', '2018-02-25 09:18:36', 'admin-1519520119-15195215161758152', 1, 1, 'SR', NULL, NULL, NULL),
(64202, '2018-02-25 09:18:21', NULL, NULL, 16934, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1519520119', 'admin', '2018-02-25 09:18:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64203, '2018-02-26 14:13:29', NULL, NULL, 16997, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1519636416', 'lois', '2018-02-26 14:13:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64204, '2018-02-26 14:13:37', NULL, NULL, 16997, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 14:13:37', 'lois-1519606882-15196256175453071', 1, 1, 'SR', NULL, NULL, NULL),
(64205, '2018-02-26 14:13:37', NULL, NULL, 16997, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 14:13:37', 'lois-1519606882-15196256175453071', 1, 1, 'SR', NULL, NULL, NULL),
(64206, '2018-02-26 12:00:18', NULL, NULL, 16986, 0, 290, '224', 'Seasoned Chicken Red Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:00:18', 'lois-1519606882-15196176178357717', 1, 0, '', NULL, NULL, NULL),
(64207, '2018-02-26 12:00:17', NULL, NULL, 16986, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:00:17', 'lois-1519606882-15196176178357717', 1, 1, 'SR', NULL, NULL, NULL),
(64208, '2018-02-26 15:52:09', NULL, NULL, 17000, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 15:52:09', 'lois-1519606882-15196315291005640', 1, 0, '', 1, NULL, NULL),
(64209, '2018-02-26 15:52:15', NULL, NULL, 17001, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1519636416', 'lois', '2018-02-26 15:52:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64210, '2018-02-26 15:52:21', NULL, NULL, 17001, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 15:52:21', 'lois-1519606882-15196315411938134', 1, 1, 'SR', NULL, NULL, NULL),
(64211, '2018-02-26 15:47:03', NULL, NULL, 16999, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 15:47:03', 'lois-1519606882-15196312233831241', 1, 1, 'SR', NULL, NULL, NULL),
(64212, '2018-02-26 15:52:09', NULL, NULL, 17000, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 15:52:09', 'lois-1519606882-15196315291005640', 1, 0, '', 1, NULL, NULL),
(64213, '2018-02-26 15:52:09', NULL, NULL, 17000, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 15:52:09', 'lois-1519606882-15196315291005640', 1, 0, '', 1, NULL, NULL),
(64214, '2018-02-26 13:12:24', NULL, NULL, 16994, 0, 31, '31', 'Iced Matcha Latte', '', 'Cold Drinks', 'Non Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 13:12:24', 'lois-1519606882-15196219446173833', 1, 1, 'SR', NULL, NULL, NULL),
(64215, '2018-02-26 13:12:24', NULL, NULL, 16994, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 13:12:24', 'lois-1519606882-15196219446173833', 1, 1, 'SR', NULL, NULL, NULL),
(64216, '2018-02-26 12:29:10', NULL, NULL, 16988, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:29:10', 'lois-1519606882-15196193507819545', 1, 0, '', NULL, NULL, NULL),
(64217, '2018-02-26 12:34:01', NULL, NULL, 16988, 0, 181, '116', 'Open Food ', 'mushroom chic-takew', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:34:01', 'lois-1519606882-15196196417901130', 1, 0, '', NULL, NULL, NULL),
(64218, '2018-02-26 12:34:01', NULL, NULL, 16988, 0, 181, '116', 'Open Food ', 'mushroom chic-takew', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:34:01', 'lois-1519606882-15196196417901130', 1, 0, '', NULL, NULL, NULL),
(64219, '2018-02-26 12:00:17', NULL, NULL, 16986, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:00:17', 'lois-1519606882-15196176178357717', 1, 0, '', NULL, NULL, NULL),
(64220, '2018-02-26 12:00:18', NULL, NULL, 16986, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:00:18', 'lois-1519606882-15196176178357717', 1, 0, '', NULL, NULL, NULL),
(64221, '2018-02-26 09:52:13', NULL, NULL, 16978, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1519636416', 'lois', '2018-02-26 09:52:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64222, '2018-02-26 09:52:17', NULL, NULL, 16978, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 09:52:17', 'lois-1519606882-1519609937228192', 1, 1, 'SR', NULL, NULL, NULL),
(64223, '2018-02-26 15:58:42', NULL, NULL, 17004, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 15:58:42', 'lois-1519606882-15196319225297768', 1, 1, 'SR', NULL, NULL, NULL),
(64224, '2018-02-26 12:00:18', NULL, NULL, 16986, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:00:18', 'lois-1519606882-15196176178357717', 1, 0, '', NULL, NULL, NULL),
(64225, '2018-02-26 12:00:18', NULL, NULL, 16986, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:00:18', 'lois-1519606882-15196176178357717', 1, 0, '', NULL, NULL, NULL),
(64226, '2018-02-26 13:02:13', NULL, NULL, 16992, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 13:02:13', 'lois-1519606882-1519621333815126', 1, 0, '', NULL, NULL, '20.0'),
(64227, '2018-02-26 12:00:17', NULL, NULL, 16986, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:00:17', 'lois-1519606882-15196176178357717', 1, 1, 'SR', NULL, NULL, NULL),
(64228, '2018-02-26 12:29:10', NULL, NULL, 16988, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:29:10', 'lois-1519606882-15196193507819545', 1, 0, '', NULL, NULL, NULL),
(64229, '2018-02-26 12:29:10', NULL, NULL, 16988, 0, 181, '116', 'Open Food ', 'mushroom chicken', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:29:10', 'lois-1519606882-15196193507819545', 1, 0, '', NULL, NULL, NULL),
(64230, '2018-02-26 12:37:42', NULL, NULL, 16989, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:37:42', 'lois-1519606882-15196198626542091', 1, 1, 'SR', NULL, NULL, '10.0'),
(64231, '2018-02-26 12:42:14', NULL, NULL, 16990, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:42:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64232, '2018-02-26 12:42:20', NULL, NULL, 16990, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:42:20', 'lois-1519606882-15196201404494980', 1, 0, '', NULL, NULL, NULL),
(64233, '2018-02-26 13:33:12', NULL, NULL, 16996, 0, 181, '116', 'Open Food ', 'salted pork fried rice', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 13:33:12', 'lois-1519606882-15196231927631992', 1, 0, '', NULL, NULL, NULL),
(64234, '2018-02-26 13:33:12', NULL, NULL, 16996, 0, 181, '116', 'Open Food ', 'salted pork fried rice', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 13:33:12', 'lois-1519606882-15196231927631992', 1, 0, '', NULL, NULL, NULL),
(64235, '2018-02-26 14:33:34', NULL, NULL, 16998, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1519636416', 'lois', '2018-02-26 14:33:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64236, '2018-02-26 13:08:09', NULL, NULL, 16993, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 13:08:09', 'lois-1519606882-15196216888725158', 1, 1, 'SR', 1, NULL, NULL),
(64237, '2018-02-26 10:37:45', NULL, NULL, 16980, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 10:37:45', 'lois-1519606882-15196126652871698', 1, 1, 'SR', 1, NULL, NULL),
(64238, '2018-02-26 10:53:59', NULL, NULL, 16981, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1519636416', 'lois', '2018-02-26 10:53:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64239, '2018-02-26 10:54:13', NULL, NULL, 16981, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 10:54:13', 'lois-1519606882-15196136531884976', 1, 0, '', NULL, NULL, NULL),
(64240, '2018-02-26 10:54:13', NULL, NULL, 16981, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 10:54:13', 'lois-1519606882-15196136531884976', 1, 0, '', NULL, NULL, NULL),
(64241, '2018-02-26 11:08:35', NULL, NULL, 16982, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1519636416', 'lois', '2018-02-26 11:08:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64242, '2018-02-26 11:16:40', NULL, NULL, 16983, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1519636416', 'lois', '2018-02-26 11:16:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64243, '2018-02-26 12:17:42', NULL, NULL, 16987, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:17:42', 'lois-1519606882-15196186627904462', 1, 1, 'SR', NULL, NULL, NULL),
(64244, '2018-02-26 12:28:39', NULL, NULL, 16988, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:28:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64245, '2018-02-26 11:20:30', NULL, NULL, 16982, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 11:20:30', 'lois-1519606882-15196152307927916', 1, 1, 'SR', NULL, NULL, NULL),
(64246, '2018-02-26 15:58:42', NULL, NULL, 17004, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 15:58:42', 'lois-1519606882-15196319225297768', 1, 1, 'SR', NULL, NULL, NULL),
(64247, '2018-02-26 12:37:26', NULL, NULL, 16989, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:37:26', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(64248, '2018-02-26 15:54:59', NULL, NULL, 17002, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 15:54:59', 'lois-1519606882-15196316995413243', 1, 0, '', 1, NULL, NULL),
(64249, '2018-02-26 15:56:22', NULL, NULL, 17003, 0, 265, '199', 'Old Penang PostCard', '', 'DISCOUNT ', '0', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 15:56:22', 'lois-1519606882-15196317823297851', 1, 0, '', 1, NULL, NULL),
(64250, '2018-02-26 15:56:22', NULL, NULL, 17003, 0, 182, '117', 'Open Drinks ', 'stamps', 'Cold Drinks', 'Fresh Juice', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 15:56:22', 'lois-1519606882-15196317823297851', 1, 0, '', 1, NULL, NULL),
(64251, '2018-02-26 15:58:34', NULL, NULL, 17004, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1519636416', 'lois', '2018-02-26 15:58:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64252, '2018-02-26 09:39:01', NULL, NULL, 16977, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 09:39:01', 'lois-1519606882-15196091413603281', 1, 0, '', NULL, NULL, NULL),
(64253, '2018-02-26 09:39:01', NULL, NULL, 16977, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 09:39:01', 'lois-1519606882-15196091413603281', 1, 0, '', NULL, NULL, NULL),
(64254, '2018-02-26 11:16:55', NULL, NULL, 16983, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 11:16:55', 'lois-1519606882-15196150153186131', 1, 0, '', NULL, NULL, NULL),
(64255, '2018-02-26 11:16:55', NULL, NULL, 16983, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 11:16:55', 'lois-1519606882-15196150153186131', 1, 1, 'SR', NULL, NULL, NULL),
(64256, '2018-02-26 14:35:02', NULL, NULL, 16998, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 14:35:02', 'lois-1519606882-15196269027258938', 1, 1, 'SR', NULL, NULL, NULL),
(64257, '2018-02-26 11:21:16', NULL, NULL, 16984, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 11:21:16', 'lois-1519606882-1519615276458613', 1, 0, '', NULL, NULL, NULL),
(64258, '2018-02-26 15:54:59', NULL, NULL, 17002, 0, 263, '197', 'Postcard With Postage', '', 'DISCOUNT ', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 15:54:59', 'lois-1519606882-15196316995413243', 1, 0, '', 1, NULL, NULL),
(64259, '2018-02-26 15:46:52', NULL, NULL, 16999, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1519636416', 'lois', '2018-02-26 15:46:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64260, '2018-02-26 14:35:02', NULL, NULL, 16998, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 14:35:02', 'lois-1519606882-15196269027258938', 1, 1, 'SR', NULL, NULL, NULL),
(64261, '2018-02-26 11:16:55', NULL, NULL, 16983, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 11:16:55', 'lois-1519606882-15196150153186131', 1, 0, '', NULL, NULL, NULL),
(64262, '2018-02-26 14:35:02', NULL, NULL, 16998, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 14:35:02', 'lois-1519606882-15196269027258938', 1, 0, '', NULL, NULL, NULL),
(64263, '2018-02-26 14:00:11', NULL, NULL, 16996, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 14:00:11', 'lois-1519606882-15196248112673750', 1, 0, '', NULL, NULL, NULL),
(64264, '2018-02-26 14:00:11', NULL, NULL, 16996, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 14:00:11', 'lois-1519606882-15196248112673750', 1, 0, '', NULL, NULL, NULL),
(64265, '2018-02-26 13:23:03', NULL, NULL, 16989, 0, 182, '117', 'Open Drinks ', 'I''m single', 'Cold Drinks', 'Fresh Juice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 13:23:03', 'lois-1519606882-1519622583669469', 1, 0, '', NULL, NULL, '10.0'),
(64266, '2018-02-26 13:32:38', NULL, NULL, 16996, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, '1519636416', 'lois', '2018-02-26 13:32:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64267, '2018-02-26 13:23:25', NULL, NULL, 16995, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 13:23:25', 'lois-1519606882-15196226050795257', 1, 0, '', NULL, NULL, NULL),
(64268, '2018-02-26 13:23:25', NULL, NULL, 16995, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 13:23:25', 'lois-1519606882-15196226050795257', 1, 1, 'SR', NULL, NULL, NULL),
(64269, '2018-02-26 11:20:44', NULL, NULL, 16984, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.30, 0.0000, 0.0000, 3.30, 1, '27', 1, '1519636416', 'lois', '2018-02-26 11:20:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64270, '2018-02-26 13:23:14', NULL, NULL, 16995, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 13:23:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64271, '2018-02-26 13:12:24', NULL, NULL, 16994, 0, 223, '226', 'Smoked Duck Aglio Olio', 'less chilli', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 13:12:24', 'lois-1519606882-15196219446173833', 1, 0, '', NULL, NULL, NULL),
(64272, '2018-02-26 13:23:03', NULL, NULL, 16989, 0, 182, '117', 'Open Drinks ', 'I''m single', 'Cold Drinks', 'Fresh Juice', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 13:23:03', 'lois-1519606882-1519622583669469', 1, 0, '', NULL, NULL, '10.0'),
(64273, '2018-02-26 13:12:24', NULL, NULL, 16994, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 13:12:24', 'lois-1519606882-15196219446173833', 1, 0, '', NULL, NULL, NULL),
(64274, '2018-02-26 13:11:24', NULL, NULL, 16994, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1519636416', 'lois', '2018-02-26 13:11:24', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64275, '2018-02-26 12:54:12', NULL, NULL, 16991, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:54:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64276, '2018-02-26 12:54:17', NULL, NULL, 16991, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:54:17', 'lois-1519606882-15196208576411591', 1, 1, 'SR', NULL, NULL, NULL),
(64277, '2018-02-26 12:58:24', NULL, NULL, 16992, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:58:24', 'lois-1519606882-15196211042439081', 1, 0, '', NULL, NULL, '20.0'),
(64278, '2018-02-26 12:58:24', NULL, NULL, 16992, 0, 181, '116', 'Open Food ', 'mushroom chicken', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:58:24', 'lois-1519606882-15196211042439081', 1, 0, '', NULL, NULL, '20.0'),
(64279, '2018-02-26 12:58:24', NULL, NULL, 16992, 0, 181, '116', 'Open Food ', 'stew pork', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:58:24', 'lois-1519606882-15196211042439081', 1, 0, '', NULL, NULL, '20.0'),
(64280, '2018-02-26 12:57:36', NULL, NULL, 16992, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:57:36', '0', 1, 1, 'SR', NULL, NULL, '20.0'),
(64281, '2018-02-26 12:42:29', NULL, NULL, 16989, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:42:29', 'lois-1519606882-15196201495405239', 1, 1, 'SR', NULL, NULL, '10.0'),
(64282, '2018-02-26 12:37:42', NULL, NULL, 16989, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:37:42', 'lois-1519606882-15196198626542091', 1, 1, 'SR', NULL, NULL, '10.0'),
(64283, '2018-02-26 09:03:18', NULL, NULL, 16975, 0, 181, '116', 'Open Food ', 'junior BLT', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 09:03:18', 'lois-1519606882-15196069982243717', 1, 0, '', NULL, NULL, '10.0'),
(64284, '2018-02-26 09:03:18', NULL, NULL, 16975, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 09:03:18', 'lois-1519606882-15196069982243717', 1, 1, 'SR', NULL, NULL, '10.0'),
(64285, '2018-02-26 09:06:45', NULL, NULL, 16976, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, '1519636416', 'lois', '2018-02-26 09:06:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64286, '2018-02-26 12:16:54', NULL, NULL, 16987, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:16:54', 'lois-1519606882-1519618614384792', 1, 1, 'SR', NULL, NULL, NULL),
(64287, '2018-02-26 14:35:02', NULL, NULL, 16998, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 14:35:02', 'lois-1519606882-15196269027258938', 1, 0, '', NULL, NULL, NULL),
(64288, '2018-02-26 14:35:02', NULL, NULL, 16998, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 14:35:02', 'lois-1519606882-15196269027258938', 1, 0, '', NULL, NULL, NULL),
(64289, '2018-02-26 09:39:01', NULL, NULL, 16977, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 09:39:01', 'lois-1519606882-15196091413603281', 1, 1, 'SR', NULL, NULL, NULL),
(64290, '2018-02-26 14:35:02', NULL, NULL, 16998, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 14:35:02', 'lois-1519606882-15196269027258938', 1, 1, 'SR', NULL, NULL, NULL),
(64291, '2018-02-26 11:46:01', NULL, NULL, 16985, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 11:46:01', 'lois-1519606882-15196167610034356', 1, 0, '', NULL, NULL, NULL),
(64292, '2018-02-26 12:00:17', NULL, NULL, 16986, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:00:17', 'lois-1519606882-15196176178357717', 1, 1, 'SR', NULL, NULL, NULL),
(64293, '2018-02-26 11:46:01', NULL, NULL, 16985, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 11:46:01', 'lois-1519606882-15196167610034356', 1, 1, 'SR', NULL, NULL, NULL),
(64294, '2018-02-26 12:16:48', NULL, NULL, 16987, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1519636416', 'lois', '2018-02-26 12:16:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64295, '2018-02-26 11:58:35', NULL, NULL, 16986, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 12.00, 0.0000, 0.0000, 12.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 11:58:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64296, '2018-02-26 11:45:18', NULL, NULL, 16985, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 11:45:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64297, '2018-02-26 11:21:16', NULL, NULL, 16984, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 11:21:16', 'lois-1519606882-1519615276458613', 1, 0, '', NULL, NULL, NULL),
(64298, '2018-02-26 11:20:30', NULL, NULL, 16982, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 11:20:30', 'lois-1519606882-15196152307927916', 1, 1, 'SR', NULL, NULL, NULL),
(64299, '2018-02-26 10:21:54', NULL, NULL, 16979, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 10:21:54', 'lois-1519606882-15196117140092870', 1, 0, '', NULL, NULL, '10.0'),
(64300, '2018-02-26 10:21:54', NULL, NULL, 16979, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 10:21:54', 'lois-1519606882-15196117140092870', 1, 0, '', NULL, NULL, '10.0'),
(64301, '2018-02-26 10:21:08', NULL, NULL, 16979, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 10:21:08', 'lois-1519606882-15196116684438741', 1, 0, '', NULL, NULL, '10.0'),
(64302, '2018-02-26 10:21:08', NULL, NULL, 16979, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 10:21:08', 'lois-1519606882-15196116684438741', 1, 1, 'SR', NULL, NULL, '10.0'),
(64303, '2018-02-26 10:21:08', NULL, NULL, 16979, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 10:21:08', 'lois-1519606882-15196116684438741', 1, 1, 'SR', NULL, NULL, '10.0'),
(64304, '2018-02-26 10:20:57', NULL, NULL, 16979, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1519636416', 'lois', '2018-02-26 10:20:57', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(64305, '2018-02-26 10:00:50', NULL, NULL, 16975, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 10:00:50', 'lois-1519606882-15196104503517682', 1, 0, '', NULL, NULL, '10.0'),
(64306, '2018-02-26 09:38:43', NULL, NULL, 16977, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1519636416', 'lois', '2018-02-26 09:38:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64307, '2018-02-26 09:39:01', NULL, NULL, 16977, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 09:39:01', 'lois-1519606882-15196091413603281', 1, 0, '', NULL, NULL, NULL),
(64308, '2018-02-26 09:22:45', NULL, NULL, 16975, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 09:22:45', 'lois-1519606882-15196081649936252', 1, 0, '', NULL, NULL, '10.0'),
(64309, '2018-02-26 09:22:45', NULL, NULL, 16975, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 09:22:45', 'lois-1519606882-15196081649936252', 1, 1, 'SR', NULL, NULL, '10.0'),
(64310, '2018-02-26 09:07:23', NULL, NULL, 16976, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 09:07:23', 'lois-1519606882-15196072437381281', 1, 0, '', NULL, NULL, NULL),
(64311, '2018-02-26 09:07:23', NULL, NULL, 16976, 0, 24, '24', 'Chai Latte', '', 'Hot Drinks', 'Non Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 09:07:23', 'lois-1519606882-15196072437381281', 1, 1, 'SR', NULL, NULL, NULL),
(64312, '2018-02-26 09:03:01', NULL, NULL, 16975, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1519636416', 'lois', '2018-02-26 09:03:01', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(64313, '2018-02-28 12:38:36', NULL, NULL, 17018, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:38:36', 'admin-1519780133-15197927162951877', 1, 0, '', NULL, NULL, NULL),
(64314, '2018-02-28 12:38:36', NULL, NULL, 17018, 0, 303, '239', 'Pan Fried Dumpling', '', 'Meals', 'Snacks ', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:38:36', 'admin-1519780133-15197927162951877', 1, 0, '', NULL, NULL, NULL),
(64315, '2018-02-28 12:41:06', NULL, NULL, 17019, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:41:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64316, '2018-02-28 11:25:43', NULL, NULL, 17012, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 11:25:43', 'admin-1519780133-15197883434633213', 1, 0, '', NULL, NULL, NULL),
(64317, '2018-02-28 11:37:00', NULL, NULL, 17013, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.40, 0.0000, 0.0000, 3.40, 1, '27', 1, '1519780133', 'admin', '2018-02-28 11:37:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64318, '2018-02-28 11:37:14', NULL, NULL, 17013, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 11:37:14', 'admin-1519780133-15197890347129247', 1, 0, '', NULL, NULL, NULL),
(64319, '2018-02-28 13:20:26', NULL, NULL, 17024, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 13:20:26', 'admin-1519780133-15197952263986123', 1, 0, '', NULL, NULL, NULL),
(64320, '2018-02-28 13:20:26', NULL, NULL, 17024, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 13:20:26', 'admin-1519780133-15197952263986123', 1, 0, '', NULL, NULL, NULL),
(64321, '2018-02-28 11:25:43', NULL, NULL, 17012, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 11:25:43', 'admin-1519780133-15197883434633213', 1, 1, 'SR', NULL, NULL, NULL),
(64322, '2018-02-28 12:58:13', NULL, NULL, 17021, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.90, 0.0000, 0.0000, 7.90, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:58:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64323, '2018-02-28 12:58:40', NULL, NULL, 17021, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:58:40', 'admin-1519780133-15197939206599568', 1, 1, 'SR', NULL, NULL, NULL),
(64324, '2018-02-28 12:58:40', NULL, NULL, 17021, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:58:40', 'admin-1519780133-15197939206599568', 1, 1, 'SR', NULL, NULL, NULL),
(64325, '2018-02-28 15:02:10', NULL, NULL, 17026, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 15:02:10', 'admin-1519780133-15198013307894652', 1, 1, 'SR', 1, NULL, NULL),
(64326, '2018-02-28 12:24:02', NULL, NULL, 17015, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:24:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64327, '2018-02-28 12:35:42', NULL, NULL, 17017, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:35:42', 'admin-1519780133-15197925422377251', 1, 0, '', NULL, NULL, '25.0'),
(64328, '2018-02-28 12:29:20', NULL, NULL, 17016, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:29:20', 'admin-1519780133-15197921600984879', 1, 1, 'SR', NULL, NULL, NULL),
(64329, '2018-02-28 12:29:20', NULL, NULL, 17016, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:29:20', 'admin-1519780133-15197921600984879', 1, 0, '', NULL, NULL, NULL),
(64330, '2018-02-28 12:29:20', NULL, NULL, 17016, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:29:20', 'admin-1519780133-15197921600984879', 1, 0, '', NULL, NULL, NULL),
(64331, '2018-02-28 13:14:03', NULL, NULL, 17022, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 13:14:03', 'admin-1519780133-15197948431457652', 1, 1, 'SR', NULL, NULL, NULL),
(64332, '2018-02-28 13:14:03', NULL, NULL, 17022, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 13:14:03', 'admin-1519780133-15197948431457652', 1, 0, '', NULL, NULL, NULL),
(64333, '2018-02-28 13:14:03', NULL, NULL, 17022, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 13:14:03', 'admin-1519780133-15197948431457652', 1, 1, 'SR', NULL, NULL, NULL),
(64334, '2018-02-28 11:16:30', NULL, NULL, 17010, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1519780133', 'admin', '2018-02-28 11:16:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64335, '2018-02-28 09:38:59', NULL, NULL, 17007, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1519780133', 'admin', '2018-02-28 09:38:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64336, '2018-02-28 09:39:05', NULL, NULL, 17007, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 09:39:05', 'admin-1519780133-15197819450045863', 1, 1, 'SR', NULL, NULL, NULL),
(64337, '2018-02-28 10:15:32', NULL, NULL, 17008, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1519780133', 'admin', '2018-02-28 10:15:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64338, '2018-02-28 10:15:43', NULL, NULL, 17008, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 10:15:43', 'admin-1519780133-15197841435416967', 1, 1, 'SR', NULL, NULL, NULL),
(64339, '2018-02-28 10:15:43', NULL, NULL, 17008, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 10:15:43', 'admin-1519780133-15197841435416967', 1, 0, '', NULL, NULL, NULL),
(64340, '2018-02-28 12:17:15', NULL, NULL, 17014, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:17:15', 'admin-1519780133-15197914350076152', 1, 1, 'SR', NULL, NULL, NULL),
(64341, '2018-02-28 12:17:15', NULL, NULL, 17014, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:17:15', 'admin-1519780133-15197914350076152', 1, 1, 'SR', NULL, NULL, NULL),
(64342, '2018-02-28 11:25:43', NULL, NULL, 17012, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 11:25:43', 'admin-1519780133-15197883434633213', 1, 1, 'SR', NULL, NULL, NULL),
(64343, '2018-02-28 11:16:34', NULL, NULL, 17010, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 11:16:34', 'admin-1519780133-15197877947904423', 1, 1, 'SR', NULL, NULL, NULL),
(64344, '2018-02-28 15:35:40', NULL, NULL, 17027, 0, 182, '117', 'Open Drinks ', 'stamps', 'Cold Drinks', 'Fresh Juice', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 15:35:40', 'admin-1519780133-15198033404914341', 1, 0, '', 1, NULL, NULL),
(64345, '2018-02-28 15:02:10', NULL, NULL, 17026, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 15:02:10', 'admin-1519780133-15198013307894652', 1, 1, 'SR', 1, NULL, NULL),
(64346, '2018-02-28 13:20:26', NULL, NULL, 17024, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 13:20:26', 'admin-1519780133-15197952263986123', 1, 0, '', NULL, NULL, NULL),
(64347, '2018-02-28 13:20:26', NULL, NULL, 17024, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 13:20:26', 'admin-1519780133-15197952263986123', 1, 1, 'SR', NULL, NULL, NULL),
(64348, '2018-02-28 13:20:26', NULL, NULL, 17024, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 13:20:26', 'admin-1519780133-15197952263986123', 1, 1, 'SR', NULL, NULL, NULL),
(64349, '2018-02-28 13:20:26', NULL, NULL, 17024, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 13:20:26', 'admin-1519780133-15197952263986123', 1, 1, 'SR', NULL, NULL, NULL),
(64350, '2018-02-28 09:38:25', NULL, NULL, 17006, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 09:38:25', 'admin-1519780133-1519781904897673', 1, 0, '', NULL, NULL, NULL),
(64351, '2018-02-28 13:15:03', NULL, NULL, 17023, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 13:15:03', 'admin-1519780133-15197949031806213', 1, 1, 'SR', NULL, NULL, NULL),
(64352, '2018-02-28 13:15:03', NULL, NULL, 17023, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 13:15:03', 'admin-1519780133-15197949031806213', 1, 0, '', NULL, NULL, NULL),
(64353, '2018-02-28 11:25:43', NULL, NULL, 17012, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 11:25:43', 'admin-1519780133-15197883434633213', 1, 0, '', NULL, NULL, NULL),
(64354, '2018-02-28 13:32:29', NULL, NULL, 17021, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 13:32:29', 'admin-1519780133-15197959495863954', 1, 1, 'SR', NULL, NULL, NULL),
(64355, '2018-02-28 13:32:29', NULL, NULL, 17021, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 13:32:29', 'admin-1519780133-15197959495863954', 1, 1, 'SR', NULL, NULL, NULL),
(64356, '2018-02-28 11:53:32', NULL, NULL, 17008, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 11:53:32', 'admin-1519780133-15197900123638439', 1, 1, 'SR', NULL, NULL, NULL),
(64357, '2018-02-28 12:16:36', NULL, NULL, 17014, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.40, 0.0000, 0.0000, 8.40, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:16:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64358, '2018-02-28 11:44:47', NULL, NULL, 17013, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 11:44:47', 'admin-1519780133-15197894877511638', 1, 0, '', NULL, NULL, NULL),
(64359, '2018-02-28 11:37:14', NULL, NULL, 17013, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 11:37:14', 'admin-1519780133-15197890347129247', 1, 0, '', NULL, NULL, NULL),
(64360, '2018-02-28 11:37:14', NULL, NULL, 17013, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 11:37:14', 'admin-1519780133-15197890347129247', 1, 0, '', NULL, NULL, NULL),
(64361, '2018-02-28 12:17:15', NULL, NULL, 17014, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:17:15', 'admin-1519780133-15197914350076152', 1, 0, '', NULL, NULL, NULL),
(64362, '2018-02-28 12:17:15', NULL, NULL, 17014, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:17:15', 'admin-1519780133-15197914350076152', 1, 0, '', NULL, NULL, NULL),
(64363, '2018-02-28 13:14:54', NULL, NULL, 17023, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1519780133', 'admin', '2018-02-28 13:14:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64364, '2018-02-28 13:13:34', NULL, NULL, 17022, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1519780133', 'admin', '2018-02-28 13:13:34', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64365, '2018-02-28 13:07:49', NULL, NULL, 17014, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 13:07:49', 'admin-1519780133-15197944693004973', 1, 0, '', NULL, NULL, NULL),
(64366, '2018-02-28 12:58:40', NULL, NULL, 17021, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:58:40', 'admin-1519780133-15197939206599568', 1, 0, '', NULL, NULL, NULL),
(64367, '2018-02-28 12:43:24', NULL, NULL, 17020, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:43:24', 'admin-1519780133-15197930047498147', 1, 1, 'SR', 1, NULL, NULL),
(64368, '2018-02-28 13:14:03', NULL, NULL, 17022, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 13:14:03', 'admin-1519780133-15197948431457652', 1, 1, 'SR', NULL, NULL, NULL),
(64369, '2018-02-28 12:58:40', NULL, NULL, 17021, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:58:40', 'admin-1519780133-15197939206599568', 1, 0, '', NULL, NULL, NULL),
(64370, '2018-02-28 12:41:16', NULL, NULL, 17019, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:41:16', 'admin-1519780133-15197928764913689', 1, 0, '', NULL, NULL, NULL),
(64371, '2018-02-28 12:38:36', NULL, NULL, 17018, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:38:36', 'admin-1519780133-15197927162951877', 1, 0, '', NULL, NULL, NULL),
(64372, '2018-02-28 12:37:41', NULL, NULL, 17018, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:37:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64373, '2018-02-28 12:32:51', NULL, NULL, 17017, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:32:51', 'admin-1519780133-15197923712691454', 1, 1, 'SR', NULL, NULL, '25.0'),
(64374, '2018-02-28 12:34:38', NULL, NULL, 17017, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:34:38', 'admin-1519780133-15197924781366694', 1, 0, '', NULL, NULL, '25.0'),
(64375, '2018-02-28 12:32:51', NULL, NULL, 17017, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:32:51', 'admin-1519780133-15197923712691454', 1, 1, 'SR', NULL, NULL, '25.0'),
(64376, '2018-02-28 12:32:25', NULL, NULL, 17017, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:32:25', '0', 1, 1, 'SR', NULL, NULL, '25.0'),
(64377, '2018-02-28 12:32:51', NULL, NULL, 17017, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:32:51', 'admin-1519780133-15197923712691454', 1, 0, '', NULL, NULL, '25.0'),
(64378, '2018-02-28 12:24:54', NULL, NULL, 17016, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:24:54', 'admin-1519780133-15197918943291966', 1, 0, '', NULL, NULL, NULL),
(64379, '2018-02-28 12:24:45', NULL, NULL, 17016, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:24:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64380, '2018-02-28 12:24:08', NULL, NULL, 17015, NULL, 63, '63', 'Lime', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:24:08', 'admin-1519780133-1519791848081482', 1, 1, 'SR', NULL, NULL, NULL),
(64381, '2018-02-28 10:38:55', NULL, NULL, 17009, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.10, 0.0000, 0.0000, 9.10, 1, '27', 1, '1519780133', 'admin', '2018-02-28 10:38:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64382, '2018-02-28 12:17:15', NULL, NULL, 17014, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:17:15', 'admin-1519780133-15197914350076152', 1, 0, '', NULL, NULL, NULL),
(64383, '2018-02-28 12:58:40', NULL, NULL, 17021, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 12:58:40', 'admin-1519780133-15197939206599568', 1, 0, '', NULL, NULL, NULL),
(64384, '2018-02-28 11:25:43', NULL, NULL, 17012, 0, 238, '172', 'Caramel Chocolate', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 11:25:43', 'admin-1519780133-15197883434633213', 1, 0, '', NULL, NULL, NULL),
(64385, '2018-02-28 11:20:40', NULL, NULL, 17011, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 11:20:40', 'admin-1519780133-15197880404893648', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(64386, '2018-02-28 11:25:15', NULL, NULL, 17012, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 11:25:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64387, '2018-02-28 11:25:43', NULL, NULL, 17012, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 11:25:43', 'admin-1519780133-15197883434633213', 1, 0, '', NULL, NULL, NULL),
(64388, '2018-02-28 11:20:37', NULL, NULL, 17011, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1519780133', 'admin', '2018-02-28 11:20:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64389, '2018-02-28 13:19:47', NULL, NULL, 17024, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1519780133', 'admin', '2018-02-28 13:19:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64390, '2018-02-28 10:41:52', NULL, NULL, 17009, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 10:41:52', 'admin-1519780133-15197857126025831', 1, 1, 'SR', NULL, NULL, NULL),
(64391, '2018-02-28 10:44:37', NULL, NULL, 17009, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 10:44:37', 'admin-1519780133-15197858777863071', 1, 0, '', NULL, NULL, NULL),
(64392, '2018-02-28 10:41:52', NULL, NULL, 17009, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 10:41:52', 'admin-1519780133-15197857126025831', 1, 1, 'SR', NULL, NULL, NULL),
(64393, '2018-02-28 10:41:52', NULL, NULL, 17009, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 10:41:52', 'admin-1519780133-15197857126025831', 1, 0, '', NULL, NULL, NULL),
(64394, '2018-02-28 10:41:52', NULL, NULL, 17009, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 10:41:52', 'admin-1519780133-15197857126025831', 1, 0, '', NULL, NULL, NULL),
(64395, '2018-02-28 10:41:52', NULL, NULL, 17009, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 10:41:52', 'admin-1519780133-15197857126025831', 1, 0, '', NULL, NULL, NULL),
(64396, '2018-02-28 09:38:25', NULL, NULL, 17006, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 09:38:25', 'admin-1519780133-1519781904897673', 1, 0, '', NULL, NULL, NULL),
(64397, '2018-02-28 09:38:25', NULL, NULL, 17006, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 09:38:25', 'admin-1519780133-1519781904897673', 1, 0, '', NULL, NULL, NULL),
(64398, '2018-02-28 09:38:10', NULL, NULL, 17006, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1519780133', 'admin', '2018-02-28 09:38:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64399, '2018-02-28 09:28:31', NULL, NULL, 17005, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 09:28:31', 'admin-1519780133-1519781311757492', 1, 1, 'SR', NULL, NULL, NULL),
(64400, '2018-02-28 09:28:31', NULL, NULL, 17005, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 09:28:31', 'admin-1519780133-1519781311757492', 1, 0, '', NULL, NULL, NULL),
(64401, '2018-02-28 09:28:31', NULL, NULL, 17005, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 09:28:31', 'admin-1519780133-1519781311757492', 1, 0, '', NULL, NULL, NULL),
(64402, '2018-02-28 09:28:31', NULL, NULL, 17005, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 09:28:31', 'admin-1519780133-1519781311757492', 1, 1, 'SR', NULL, NULL, NULL),
(64403, '2018-02-28 09:25:15', NULL, NULL, 17005, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1519780133', 'admin', '2018-02-28 09:25:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64404, '2018-03-03 12:01:51', NULL, NULL, 17091, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:01:51', 'admin-1520038141-15200497111227172', 1, 0, '', NULL, NULL, NULL),
(64405, '2018-03-03 11:46:15', NULL, NULL, 17090, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:46:15', 'admin-1520038141-1520048775405641', 1, 0, '', NULL, NULL, NULL),
(64406, '2018-03-03 00:00:00', NULL, NULL, 17111, NULL, 46, '46', 'Coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, NULL, NULL, 5.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 15:27:28', 'admin-1520038141-15200620478849369', 1, 1, 'SR', NULL, NULL, NULL),
(64407, '2018-03-03 14:30:08', NULL, NULL, 17101, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 14:30:08', 'admin-1520038141-15200586082525714', 1, 0, '', NULL, NULL, NULL),
(64408, '2018-03-03 13:47:45', NULL, NULL, 17099, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 13:47:45', 'admin-1520038141-15200560657404239', 1, 1, 'SR', NULL, NULL, NULL),
(64409, '2018-03-03 12:13:39', NULL, NULL, 17093, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:13:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64410, '2018-03-01 15:35:40', NULL, NULL, 17042, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 15:35:41', 'admin-1519866231-15198897408652837', 1, 0, '', NULL, NULL, NULL),
(64411, '2018-03-02 09:19:05', NULL, NULL, 17043, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1520385034', 'admin', '2018-03-02 09:19:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64412, '2018-03-02 09:19:12', NULL, NULL, 17043, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 09:19:12', 'admin-1519952075-15199535526113688', 1, 0, '', NULL, NULL, NULL),
(64413, '2018-03-03 12:50:32', NULL, NULL, 17098, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:50:32', 'admin-1520038141-15200526318781940', 1, 1, 'SR', NULL, NULL, NULL),
(64414, '2018-03-03 00:00:00', NULL, NULL, 17110, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 15:27:28', 'admin-1520038141-15200620478849369', 1, 1, 'SR', NULL, NULL, NULL),
(64415, '2018-03-03 15:33:20', NULL, NULL, 17107, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1520385034', 'admin', '2018-03-03 15:33:20', 'admin-1520038141-15200624003472318', 1, 0, '', NULL, NULL, NULL),
(64416, '2018-03-03 15:38:48', NULL, NULL, 17104, NULL, 47, '47', 'Light coke', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 15:38:48', 'admin-1520038141-15200627288132298', 1, 1, 'SR', NULL, NULL, NULL),
(64417, '2018-03-03 00:00:00', NULL, NULL, 17108, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 15:27:28', 'admin-1520038141-15200620478849369', 1, 1, 'SR', NULL, NULL, NULL),
(64418, '2018-03-03 00:00:00', NULL, NULL, 17109, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, NULL, NULL, 10.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 15:27:28', 'admin-1520038141-15200620478849369', 1, 1, 'SR', NULL, NULL, NULL),
(64419, '2018-03-04 09:05:31', NULL, NULL, 17119, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:05:31', 'admin-1520125217-1520125531098372', 1, 0, '', NULL, NULL, NULL),
(64420, '2018-03-02 12:46:04', NULL, NULL, 17059, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:46:04', 'admin-1519952075-15199659643493014', 1, 1, 'SR', NULL, NULL, NULL),
(64421, '2018-03-02 12:06:07', NULL, NULL, 17055, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:06:07', 'admin-1519952075-15199635675491369', 1, 0, '', NULL, NULL, NULL),
(64422, '2018-03-02 12:06:07', NULL, NULL, 17055, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:06:07', 'admin-1519952075-15199635675491369', 1, 0, '', NULL, NULL, NULL),
(64423, '2018-03-02 13:58:59', NULL, NULL, 17064, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 13:58:59', 'admin-1519952075-15199703397714344', 1, 1, 'SR', NULL, NULL, NULL),
(64424, '2018-03-04 09:05:31', NULL, NULL, 17119, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:05:31', 'admin-1520125217-1520125531098372', 1, 0, '', NULL, NULL, NULL),
(64425, '2018-03-02 12:23:49', NULL, NULL, 17058, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:23:49', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64426, '2018-03-02 12:23:59', NULL, NULL, 17058, 0, 41, '41', 'Blueberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:23:59', 'admin-1519952075-15199646390641746', 1, 1, 'SR', NULL, NULL, NULL),
(64427, '2018-03-02 12:23:59', NULL, NULL, 17058, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:23:59', 'admin-1519952075-15199646390641746', 1, 0, '', NULL, NULL, NULL),
(64428, '2018-03-02 10:30:41', NULL, NULL, 17049, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 10:30:41', 'admin-1519952075-15199578409425781', 1, 0, '', NULL, NULL, '10.0'),
(64429, '2018-03-02 10:30:41', NULL, NULL, 17049, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 10:30:41', 'admin-1519952075-15199578409425781', 1, 1, 'SR', NULL, NULL, '10.0'),
(64430, '2018-03-02 10:00:47', NULL, NULL, 17045, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 10:00:47', 'admin-1519952075-15199560477982416', 1, 0, '', 1, NULL, NULL),
(64431, '2018-03-03 00:00:00', NULL, NULL, 17118, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 17:02:07', 'admin-1520038141-15200677269194014', 1, 0, '', NULL, NULL, NULL),
(64432, '2018-03-03 17:00:31', NULL, NULL, 17114, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1520385034', 'admin', '2018-03-03 17:00:31', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(64433, '2018-03-03 17:00:36', NULL, NULL, 17114, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 17:00:36', 'admin-1520038141-1520067636366657', 1, 1, 'SR', NULL, NULL, '10.0'),
(64434, '2018-03-03 00:00:00', NULL, NULL, 17118, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 16:48:08', 'admin-1520038141-15200668885008754', 1, 1, 'SR', NULL, NULL, NULL),
(64435, '2018-03-03 16:52:57', NULL, NULL, 17104, NULL, 45, '45', 'Soda', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 16:52:57', 'admin-1520038141-1520067177678584', 1, 1, 'SR', NULL, NULL, NULL),
(64436, '2018-03-03 00:00:00', NULL, NULL, 17111, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', NULL, 1, 0.50, NULL, NULL, 0.50, 1, '27', 1, '1520385034', 'admin', '2018-03-03 15:27:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64437, '2018-03-03 15:33:13', NULL, NULL, 17107, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.59, 0.0000, 0.0000, 1.59, 1, '27', 1, '1520385034', 'admin', '2018-03-03 15:33:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64438, '2018-03-03 11:20:58', NULL, NULL, 17083, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:20:58', 'admin-1520038141-1520047258731649', 1, 0, '', NULL, NULL, NULL),
(64439, '2018-03-03 11:20:58', NULL, NULL, 17083, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:20:58', 'admin-1520038141-1520047258731649', 1, 0, '', NULL, NULL, NULL),
(64440, '2018-03-03 12:19:00', NULL, NULL, 17089, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:19:00', 'admin-1520038141-1520050740320443', 1, 1, 'SR', NULL, NULL, NULL),
(64441, '2018-03-03 12:19:00', NULL, NULL, 17089, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:19:00', 'admin-1520038141-1520050740320443', 1, 1, 'SR', NULL, NULL, NULL),
(64442, '2018-03-03 12:09:17', NULL, NULL, 17092, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:09:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64443, '2018-03-03 11:43:21', NULL, NULL, 17089, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:43:21', 'admin-1520038141-15200486012863431', 1, 1, 'SR', NULL, NULL, NULL),
(64444, '2018-03-03 11:45:54', NULL, NULL, 17090, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:45:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64445, '2018-03-03 00:00:00', NULL, NULL, 17117, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, NULL, NULL, 15.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 16:48:08', 'admin-1520038141-15200668885008754', 1, 1, 'SR', NULL, NULL, NULL),
(64446, '2018-03-03 17:10:38', NULL, NULL, 17117, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1520385034', 'admin', '2018-03-03 17:10:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64447, '2018-03-03 10:23:20', NULL, NULL, 17078, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 10:23:20', 'admin-1520038141-1520043800570788', 1, 0, '', NULL, NULL, NULL),
(64448, '2018-03-02 16:51:44', NULL, NULL, 17073, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1520385034', 'admin', '2018-03-02 16:51:44', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(64449, '2018-03-03 17:09:48', NULL, NULL, 17116, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1520385034', 'admin', '2018-03-03 17:09:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64450, '2018-03-03 00:00:00', NULL, NULL, 17115, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 16:48:08', 'admin-1520038141-15200668885008754', 1, 1, 'SR', NULL, NULL, NULL),
(64451, '2018-03-03 10:23:20', NULL, NULL, 17078, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 10:23:20', 'admin-1520038141-1520043800570788', 1, 1, 'SR', NULL, NULL, NULL),
(64452, '2018-03-03 10:34:04', NULL, NULL, 17079, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1520385034', 'admin', '2018-03-03 10:34:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64453, '2018-03-03 11:19:57', NULL, NULL, 17083, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:19:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64454, '2018-03-03 10:59:53', NULL, NULL, 17082, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 10:59:53', 'admin-1520038141-15200459934859298', 1, 0, '', NULL, NULL, NULL),
(64455, '2018-03-03 10:59:53', NULL, NULL, 17082, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 10:59:53', 'admin-1520038141-15200459934859298', 1, 1, 'SR', NULL, NULL, NULL),
(64456, '2018-03-03 10:59:53', NULL, NULL, 17082, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 10:59:53', 'admin-1520038141-15200459934859298', 1, 0, '', NULL, NULL, NULL),
(64457, '2018-03-03 10:59:53', NULL, NULL, 17082, 0, 328, '264', 'Basic Blueberries Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 10:59:53', 'admin-1520038141-15200459934859298', 1, 0, '', NULL, NULL, NULL),
(64458, '2018-03-03 11:25:45', NULL, NULL, 17084, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:25:45', 'admin-1520038141-15200475450443273', 1, 1, 'SR', NULL, NULL, NULL),
(64459, '2018-03-03 11:25:45', NULL, NULL, 17084, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:25:45', 'admin-1520038141-15200475450443273', 1, 1, 'SR', NULL, NULL, NULL),
(64460, '2018-03-03 11:33:26', NULL, NULL, 17088, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:33:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64461, '2018-03-03 11:33:38', NULL, NULL, 17088, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:33:38', 'admin-1520038141-1520048018747702', 1, 0, '', NULL, NULL, NULL),
(64462, '2018-03-03 11:33:38', NULL, NULL, 17088, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:33:38', 'admin-1520038141-1520048018747702', 1, 0, '', NULL, NULL, NULL),
(64463, '2018-03-03 10:51:15', NULL, NULL, 17081, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 10:51:15', 'admin-1520038141-15200454758428985', 1, 1, 'SR', NULL, NULL, '10.0'),
(64464, '2018-03-03 16:25:30', NULL, NULL, 17110, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1520385034', 'admin', '2018-03-03 16:25:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64465, '2018-03-02 12:04:08', NULL, NULL, 17054, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:04:08', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64466, '2018-03-02 11:40:54', NULL, NULL, 17053, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 11:40:54', 'admin-1519952075-1519962054481489', 1, 1, 'SR', NULL, NULL, '10.0'),
(64467, '2018-03-03 10:42:55', NULL, NULL, 17080, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1520385034', 'admin', '2018-03-03 10:42:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64468, '2018-03-03 10:43:05', NULL, NULL, 17080, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 10:43:05', 'admin-1520038141-15200449858518580', 1, 0, '', NULL, NULL, NULL),
(64469, '2018-03-02 12:58:10', NULL, NULL, 17060, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:58:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64470, '2018-03-02 12:58:52', NULL, NULL, 17060, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:58:52', 'admin-1519952075-15199667324241240', 1, 1, 'SR', NULL, NULL, NULL),
(64471, '2018-03-02 12:58:52', NULL, NULL, 17060, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:58:52', 'admin-1519952075-15199667324241240', 1, 0, '', NULL, NULL, NULL),
(64472, '2018-03-02 12:58:52', NULL, NULL, 17060, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:58:52', 'admin-1519952075-15199667324241240', 1, 0, '', NULL, NULL, NULL),
(64473, '2018-03-02 13:05:33', NULL, NULL, 17054, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 13:05:33', 'admin-1519952075-15199671331874161', 1, 0, '', NULL, NULL, NULL),
(64474, '2018-03-03 15:22:48', NULL, NULL, 17105, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 15:22:48', 'admin-1520038141-1520061768761713', 1, 0, '', NULL, NULL, NULL),
(64475, '2018-03-03 15:22:48', NULL, NULL, 17105, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 15:22:48', 'admin-1520038141-1520061768761713', 1, 0, '', NULL, NULL, NULL),
(64476, '2018-03-02 12:11:15', NULL, NULL, 17056, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:11:15', 'admin-1519952075-15199638752897667', 1, 0, '', NULL, NULL, NULL),
(64477, '2018-03-02 12:11:15', NULL, NULL, 17056, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:11:15', 'admin-1519952075-15199638752897667', 1, 0, '', NULL, NULL, NULL),
(64478, '2018-03-02 12:11:15', NULL, NULL, 17056, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:11:15', 'admin-1519952075-15199638752897667', 1, 1, 'SR', NULL, NULL, NULL),
(64479, '2018-03-02 12:11:15', NULL, NULL, 17056, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:11:15', 'admin-1519952075-15199638752897667', 1, 1, 'SR', NULL, NULL, NULL),
(64480, '2018-03-02 12:11:15', NULL, NULL, 17056, 0, 241, '175', 'Caramel Affogato', '', 'Cold Drinks', 'Frappe', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:11:15', 'admin-1519952075-15199638752897667', 1, 0, '', NULL, NULL, NULL),
(64481, '2018-03-03 15:22:36', NULL, NULL, 17105, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.30, 0.0000, 0.0000, 4.30, 1, '27', 1, '1520385034', 'admin', '2018-03-03 15:22:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64482, '2018-03-03 14:56:21', NULL, NULL, 17102, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 14:56:21', 'admin-1520038141-15200601812423147', 1, 0, '', NULL, NULL, NULL),
(64483, '2018-03-03 10:59:38', NULL, NULL, 17082, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1520385034', 'admin', '2018-03-03 10:59:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64484, '2018-03-03 10:51:06', NULL, NULL, 17081, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1520385034', 'admin', '2018-03-03 10:51:06', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(64485, '2018-03-01 13:04:01', NULL, NULL, 17038, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1520385034', 'admin', '2018-03-01 13:04:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64486, '2018-03-03 15:10:06', NULL, NULL, 17104, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 15:10:06', 'admin-1520038141-152006100659666', 1, 0, '', NULL, NULL, NULL),
(64487, '2018-03-03 15:10:06', NULL, NULL, 17104, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 15:10:06', 'admin-1520038141-152006100659666', 1, 0, '', NULL, NULL, NULL),
(64488, '2018-03-03 15:10:00', NULL, NULL, 17104, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1520385034', 'admin', '2018-03-03 15:10:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64489, '2018-03-03 15:09:28', NULL, NULL, 17103, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 15:09:28', 'admin-1520038141-15200609683693445', 1, 1, 'SR', NULL, NULL, NULL),
(64490, '2018-03-03 15:09:23', NULL, NULL, 17103, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1520385034', 'admin', '2018-03-03 15:09:23', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64491, '2018-03-03 15:00:23', NULL, NULL, 17102, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 15:00:23', 'admin-1520038141-152006042330127', 1, 1, 'SR', NULL, NULL, NULL),
(64492, '2018-03-03 09:18:06', NULL, NULL, 17075, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1520385034', 'admin', '2018-03-03 09:18:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64493, '2018-03-03 09:18:13', NULL, NULL, 17075, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 09:18:13', 'admin-1520038141-15200398936094113', 1, 1, 'SR', NULL, NULL, NULL),
(64494, '2018-03-02 16:01:07', NULL, NULL, 17067, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1520385034', 'admin', '2018-03-02 16:01:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64495, '2018-03-03 00:00:00', NULL, NULL, 17118, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', NULL, 1, 2.00, NULL, NULL, 2.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 16:46:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64496, '2018-03-02 16:16:03', NULL, NULL, 17068, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, '1520385034', 'admin', '2018-03-02 16:16:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64497, '2018-03-02 16:17:57', NULL, NULL, 17068, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 16:17:57', 'admin-1519952075-15199786770537282', 1, 0, '', NULL, NULL, NULL),
(64498, '2018-03-02 16:18:01', NULL, NULL, 17069, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1520385034', 'admin', '2018-03-02 16:18:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64499, '2018-03-03 12:40:11', NULL, NULL, 17097, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:40:11', 'admin-1520038141-15200520112286310', 1, 0, '', NULL, NULL, NULL),
(64500, '2018-03-02 12:16:19', NULL, NULL, 17057, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.90, 0.0000, 0.0000, 1.90, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:16:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64501, '2018-03-03 10:22:57', NULL, NULL, 17078, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1520385034', 'admin', '2018-03-03 10:22:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64502, '2018-03-03 10:43:05', NULL, NULL, 17080, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 10:43:05', 'admin-1520038141-15200449858518580', 1, 0, '', NULL, NULL, NULL),
(64503, '2018-03-03 13:17:14', NULL, NULL, 17094, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 13:17:14', 'admin-1520038141-15200542342451981', 1, 1, 'SR', NULL, NULL, NULL),
(64504, '2018-03-03 13:17:14', NULL, NULL, 17094, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1520385034', 'admin', '2018-03-03 13:17:14', 'admin-1520038141-15200542342451981', 1, 0, '', NULL, NULL, NULL),
(64505, '2018-03-03 13:47:32', NULL, NULL, 17099, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1520385034', 'admin', '2018-03-03 13:47:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64506, '2018-03-03 11:20:58', NULL, NULL, 17083, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:20:58', 'admin-1520038141-1520047258731649', 1, 1, 'SR', NULL, NULL, NULL),
(64507, '2018-03-03 11:20:58', NULL, NULL, 17083, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:20:58', 'admin-1520038141-1520047258731649', 1, 0, '', NULL, NULL, NULL),
(64508, '2018-03-03 09:44:12', NULL, NULL, 17076, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.00, 0.0000, 0.0000, 4.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 09:44:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64509, '2018-03-03 09:44:27', NULL, NULL, 17076, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 09:44:27', 'admin-1520038141-15200414669577462', 1, 0, '', NULL, NULL, NULL),
(64510, '2018-03-03 09:44:27', NULL, NULL, 17076, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 09:44:27', 'admin-1520038141-15200414669577462', 1, 0, '', NULL, NULL, NULL),
(64511, '2018-03-01 15:18:33', NULL, NULL, 17041, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1520385034', 'admin', '2018-03-01 15:18:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64512, '2018-03-01 15:18:47', NULL, NULL, 17041, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 15:18:47', 'admin-1519866231-15198887276782359', 1, 0, '', NULL, NULL, NULL),
(64513, '2018-03-03 14:30:08', NULL, NULL, 17101, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 14:30:08', 'admin-1520038141-15200586082525714', 1, 1, 'SR', NULL, NULL, NULL),
(64514, '2018-03-03 14:30:08', NULL, NULL, 17101, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 14:30:08', 'admin-1520038141-15200586082525714', 1, 0, '', NULL, NULL, NULL),
(64515, '2018-03-03 14:30:08', NULL, NULL, 17101, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 14:30:08', 'admin-1520038141-15200586082525714', 1, 0, '', NULL, NULL, NULL),
(64516, '2018-03-03 14:27:32', NULL, NULL, 17100, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 14:27:32', 'admin-1520038141-1520058452303873', 1, 1, 'SR', NULL, NULL, NULL),
(64517, '2018-03-03 14:29:05', NULL, NULL, 17101, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.90, 0.0000, 0.0000, 9.90, 1, '27', 1, '1520385034', 'admin', '2018-03-03 14:29:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64518, '2018-03-03 14:30:08', NULL, NULL, 17101, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 14:30:08', 'admin-1520038141-15200586082525714', 1, 0, '', NULL, NULL, NULL),
(64519, '2018-03-03 12:10:21', NULL, NULL, 17092, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:10:21', 'admin-1520038141-15200502210105088', 1, 0, '', NULL, NULL, NULL),
(64520, '2018-03-03 10:34:11', NULL, NULL, 17079, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 10:34:11', 'admin-1520038141-15200444509606881', 1, 1, 'SR', NULL, NULL, NULL),
(64521, '2018-03-02 12:14:33', NULL, NULL, 17054, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:14:33', 'admin-1519952075-1519964073500269', 1, 1, 'SR', NULL, NULL, NULL),
(64522, '2018-03-03 14:06:00', NULL, NULL, 17100, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 14:06:00', 'admin-1520038141-15200571601554873', 1, 1, 'SR', NULL, NULL, NULL),
(64523, '2018-03-03 14:01:36', NULL, NULL, 17100, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 14:01:36', 'admin-1520038141-15200568958945570', 1, 0, '', NULL, NULL, NULL),
(64524, '2018-03-03 14:30:08', NULL, NULL, 17101, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 14:30:08', 'admin-1520038141-15200586082525714', 1, 0, '', NULL, NULL, NULL),
(64525, '2018-03-03 11:24:43', NULL, NULL, 17084, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:24:43', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64526, '2018-03-03 13:47:45', NULL, NULL, 17099, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 13:47:45', 'admin-1520038141-15200560657404239', 1, 1, 'SR', NULL, NULL, NULL),
(64527, '2018-03-03 13:47:45', NULL, NULL, 17099, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 13:47:45', 'admin-1520038141-15200560657404239', 1, 1, 'SR', NULL, NULL, NULL),
(64528, '2018-03-03 12:10:21', NULL, NULL, 17092, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:10:21', 'admin-1520038141-15200502210105088', 1, 0, '', NULL, NULL, NULL),
(64529, '2018-03-02 12:07:39', NULL, NULL, 17054, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:07:39', 'admin-1519952075-15199636595892571', 1, 0, '', NULL, NULL, NULL),
(64530, '2018-03-02 12:07:39', NULL, NULL, 17054, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:07:39', 'admin-1519952075-15199636595892571', 1, 1, 'SR', NULL, NULL, NULL),
(64531, '2018-03-03 12:50:32', NULL, NULL, 17098, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:50:32', 'admin-1520038141-15200526318781940', 1, 1, 'SR', NULL, NULL, NULL),
(64532, '2018-03-03 12:50:32', NULL, NULL, 17098, 0, 181, '116', 'Open Food ', 'rice', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:50:32', 'admin-1520038141-15200526318781940', 1, 0, '', NULL, NULL, NULL),
(64533, '2018-03-03 12:50:32', NULL, NULL, 17098, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:50:32', 'admin-1520038141-15200526318781940', 1, 1, 'SR', NULL, NULL, NULL),
(64534, '2018-03-03 12:50:04', NULL, NULL, 17098, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:50:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64535, '2018-03-02 13:29:10', NULL, NULL, 17060, 0, 166, '100', 'Chocolate Dose ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 13:29:10', 'admin-1519952075-1519968550352927', 1, 0, '', NULL, NULL, NULL),
(64536, '2018-03-02 13:53:50', NULL, NULL, 17063, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 13:53:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64537, '2018-03-03 12:40:11', NULL, NULL, 17097, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:40:11', 'admin-1520038141-15200520112286310', 1, 1, 'SR', NULL, NULL, NULL),
(64538, '2018-03-03 12:40:11', NULL, NULL, 17097, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:40:11', 'admin-1520038141-15200520112286310', 1, 1, 'SR', NULL, NULL, NULL),
(64539, '2018-03-03 12:40:11', NULL, NULL, 17097, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:40:11', 'admin-1520038141-15200520112286310', 1, 0, '', NULL, NULL, NULL),
(64540, '2018-03-03 12:38:44', NULL, NULL, 17096, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:38:44', 'admin-1520038141-15200519239074227', 1, 1, 'SR', 1, NULL, NULL),
(64541, '2018-03-03 12:39:45', NULL, NULL, 17097, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:39:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64542, '2018-03-03 12:17:41', NULL, NULL, 17095, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:17:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64543, '2018-03-03 12:17:47', NULL, NULL, 17095, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:17:47', 'admin-1520038141-15200506678472289', 1, 1, 'SR', NULL, NULL, NULL),
(64544, '2018-03-03 12:14:08', NULL, NULL, 17094, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:14:08', 'admin-1520038141-1520050447894421', 1, 0, '', NULL, NULL, NULL),
(64545, '2018-03-03 12:14:08', NULL, NULL, 17094, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:14:08', 'admin-1520038141-1520050447894421', 1, 0, '', NULL, NULL, NULL),
(64546, '2018-03-03 12:13:47', NULL, NULL, 17093, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:13:47', 'admin-1520038141-152005042733675', 1, 1, 'SR', NULL, NULL, NULL),
(64547, '2018-03-03 12:01:51', NULL, NULL, 17091, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:01:51', 'admin-1520038141-15200497111227172', 1, 0, '', NULL, NULL, NULL),
(64548, '2018-03-03 12:01:51', NULL, NULL, 17091, 0, 338, '274', 'Chocolate Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:01:51', 'admin-1520038141-15200497111227172', 1, 0, '', NULL, NULL, NULL),
(64549, '2018-03-03 11:47:13', NULL, NULL, 17089, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:47:13', 'admin-1520038141-15200488330944750', 1, 1, 'SR', NULL, NULL, NULL),
(64550, '2018-03-03 12:10:21', NULL, NULL, 17092, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:10:21', 'admin-1520038141-15200502210105088', 1, 0, '', NULL, NULL, NULL),
(64551, '2018-03-02 16:53:27', NULL, NULL, 17074, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1520385034', 'admin', '2018-03-02 16:53:27', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64552, '2018-03-02 16:53:38', NULL, NULL, 17074, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 16:53:38', 'admin-1519952075-15199808188411114', 1, 0, '', NULL, NULL, NULL),
(64553, '2018-03-01 11:56:35', NULL, NULL, 17032, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 11:56:35', 'admin-1519866231-15198765949026788', 1, 1, 'SR', NULL, NULL, NULL),
(64554, '2018-03-01 00:00:00', NULL, NULL, 17037, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', NULL, 1, 1.60, NULL, NULL, 1.60, 1, '27', 1, '1520385034', 'admin', '2018-03-01 12:12:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64555, '2018-03-01 12:21:19', NULL, NULL, 17034, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1520385034', 'admin', '2018-03-01 12:21:19', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(64556, '2018-03-01 12:21:36', NULL, NULL, 17034, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 3, 12.00, 36.0000, 0.0000, 36.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 12:21:36', 'admin-1519866231-15198780965579327', 1, 1, 'SR', NULL, NULL, '10.0'),
(64557, '2018-03-03 12:01:51', NULL, NULL, 17091, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:01:51', 'admin-1520038141-15200497111227172', 1, 0, '', NULL, NULL, NULL),
(64558, '2018-03-03 12:01:51', NULL, NULL, 17091, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:01:51', 'admin-1520038141-15200497111227172', 1, 0, '', NULL, NULL, NULL),
(64559, '2018-03-03 12:01:51', NULL, NULL, 17091, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:01:51', 'admin-1520038141-15200497111227172', 1, 0, '', NULL, NULL, NULL),
(64560, '2018-03-02 11:40:40', NULL, NULL, 17053, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1520385034', 'admin', '2018-03-02 11:40:40', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(64561, '2018-03-02 11:23:04', NULL, NULL, 17052, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 11:23:04', 'admin-1519952075-15199609842774992', 1, 1, 'SR', NULL, NULL, NULL),
(64562, '2018-03-02 11:23:04', NULL, NULL, 17052, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 11:23:04', 'admin-1519952075-15199609842774992', 1, 0, '', NULL, NULL, NULL),
(64563, '2018-03-01 00:00:00', NULL, NULL, 17037, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, NULL, NULL, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 12:13:52', 'admin-1519866231-1519877632053458', 1, 0, '', NULL, NULL, NULL),
(64564, '2018-03-03 09:53:15', NULL, NULL, 17077, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 09:53:15', 'admin-1520038141-15200419955516121', 1, 0, '', NULL, NULL, NULL),
(64565, '2018-03-03 09:53:15', NULL, NULL, 17077, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 09:53:15', 'admin-1520038141-15200419955516121', 1, 1, 'SR', NULL, NULL, NULL),
(64566, '2018-03-03 11:25:45', NULL, NULL, 17084, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:25:45', 'admin-1520038141-15200475450443273', 1, 0, '', NULL, NULL, NULL),
(64567, '2018-03-03 11:25:45', NULL, NULL, 17084, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:25:45', 'admin-1520038141-15200475450443273', 1, 0, '', NULL, NULL, NULL),
(64568, '2018-03-03 09:53:15', NULL, NULL, 17077, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 09:53:15', 'admin-1520038141-15200419955516121', 1, 1, 'SR', NULL, NULL, NULL),
(64569, '2018-03-03 09:53:15', NULL, NULL, 17077, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 09:53:15', 'admin-1520038141-15200419955516121', 1, 0, '', NULL, NULL, NULL),
(64570, '2018-03-03 14:30:08', NULL, NULL, 17101, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 14:30:08', 'admin-1520038141-15200586082525714', 1, 0, '', NULL, NULL, NULL),
(64571, '2018-03-03 11:46:58', NULL, NULL, 17090, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:46:58', 'admin-1520038141-1520048818499996', 1, 0, '', NULL, NULL, NULL),
(64572, '2018-03-03 11:46:15', NULL, NULL, 17090, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:46:15', 'admin-1520038141-1520048775405641', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(64573, '2018-03-03 11:43:15', NULL, NULL, 17089, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:43:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64574, '2018-03-03 11:33:38', NULL, NULL, 17088, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:33:38', 'admin-1520038141-1520048018747702', 1, 1, 'SR', NULL, NULL, NULL),
(64575, '2018-03-03 09:53:15', NULL, NULL, 17077, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 09:53:15', 'admin-1520038141-15200419955516121', 1, 0, '', NULL, NULL, NULL),
(64576, '2018-03-02 16:53:38', NULL, NULL, 17074, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 16:53:38', 'admin-1519952075-15199808188411114', 1, 0, '', NULL, NULL, NULL),
(64577, '2018-03-03 12:13:51', NULL, NULL, 17094, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.59, 0.0000, 0.0000, 7.59, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:13:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64578, '2018-03-03 16:24:47', NULL, NULL, 17108, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 16:24:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64579, '2018-03-03 11:33:38', NULL, NULL, 17088, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:33:38', 'admin-1520038141-1520048018747702', 1, 0, '', NULL, NULL, NULL),
(64580, '2018-03-03 13:02:14', NULL, NULL, 17093, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 13:02:14', 'admin-1520038141-15200533346376686', 1, 0, '', NULL, NULL, NULL),
(64581, '2018-03-03 09:52:59', NULL, NULL, 17077, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.00, 0.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 09:52:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64582, '2018-03-03 17:09:17', NULL, NULL, 17115, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1520385034', 'admin', '2018-03-03 17:09:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64583, '2018-03-03 12:01:51', NULL, NULL, 17091, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:01:51', 'admin-1520038141-15200497111227172', 1, 0, '', NULL, NULL, NULL),
(64584, '2018-03-03 09:44:27', NULL, NULL, 17076, NULL, 22, '22', 'Honey Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 09:44:27', 'admin-1520038141-15200414669577462', 1, 1, 'SR', NULL, NULL, NULL),
(64585, '2018-03-03 09:21:15', NULL, NULL, 17075, 0, 328, '264', 'Basic Blueberries Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 09:21:15', 'admin-1520038141-15200400756129894', 1, 0, '', NULL, NULL, NULL),
(64586, '2018-03-02 00:00:00', NULL, NULL, 17073, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 16:08:18', 'admin-1519952075-15199780980781481', 1, 0, '', NULL, NULL, '10.0'),
(64587, '2018-03-02 15:21:53', NULL, NULL, 17065, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1520385034', 'admin', '2018-03-02 15:21:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64588, '2018-03-02 15:21:59', NULL, NULL, 17065, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 15:21:59', 'admin-1519952075-15199753196359310', 1, 1, 'SR', NULL, NULL, NULL),
(64589, '2018-03-02 16:53:38', NULL, NULL, 17074, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 16:53:38', 'admin-1519952075-15199808188411114', 1, 0, '', NULL, NULL, NULL),
(64590, '2018-03-02 16:53:38', NULL, NULL, 17074, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 16:53:38', 'admin-1519952075-15199808188411114', 1, 0, '', NULL, NULL, NULL),
(64591, '2018-03-02 16:28:19', NULL, NULL, 17071, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 16:28:19', 'admin-1519952075-15199792989199534', 1, 1, 'SR', NULL, NULL, NULL),
(64592, '2018-03-02 16:36:21', NULL, NULL, 17072, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1520385034', 'admin', '2018-03-02 16:36:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64593, '2018-03-02 16:36:27', NULL, NULL, 17072, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 16:36:27', 'admin-1519952075-15199797877225472', 1, 0, '', NULL, NULL, NULL),
(64594, '2018-03-03 11:20:58', NULL, NULL, 17083, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:20:58', 'admin-1520038141-1520047258731649', 1, 1, 'SR', NULL, NULL, NULL),
(64595, '2018-03-02 16:27:48', NULL, NULL, 17071, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1520385034', 'admin', '2018-03-02 16:27:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64596, '2018-03-02 16:22:29', NULL, NULL, 17070, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 16:22:29', 'admin-1519952075-15199789494428015', 1, 0, '', 1, NULL, NULL),
(64597, '2018-03-02 13:16:13', NULL, NULL, 17062, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 13:16:13', 'admin-1519952075-15199677730162514', 1, 1, 'SR', NULL, NULL, NULL),
(64598, '2018-03-03 00:00:00', NULL, NULL, 17116, 0, 35, '35', 'Passion Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, NULL, NULL, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 16:48:08', 'admin-1520038141-15200668885008754', 1, 1, 'SR', NULL, NULL, NULL),
(64599, '2018-03-02 12:09:40', NULL, NULL, 17056, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.00, 0.0000, 0.0000, 10.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:09:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64600, '2018-03-03 15:33:20', NULL, NULL, 17107, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 15:33:20', 'admin-1520038141-15200624003472318', 1, 1, 'SR', NULL, NULL, NULL),
(64601, '2018-03-03 14:30:08', NULL, NULL, 17101, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 14:30:08', 'admin-1520038141-15200586082525714', 1, 0, '', NULL, NULL, NULL),
(64602, '2018-03-02 16:18:29', NULL, NULL, 17069, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 16:18:29', 'admin-1519952075-15199787096777298', 1, 0, '', NULL, NULL, NULL),
(64603, '2018-03-03 15:22:48', NULL, NULL, 17105, 0, 212, '146', 'Pork Bacon Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 15:22:48', 'admin-1520038141-1520061768761713', 1, 0, '', NULL, NULL, NULL),
(64604, '2018-03-02 16:18:29', NULL, NULL, 17069, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 16:18:29', 'admin-1519952075-15199787096777298', 1, 1, 'SR', NULL, NULL, NULL),
(64605, '2018-03-02 13:08:20', NULL, NULL, 17061, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 13:08:20', 'admin-1519952075-15199673004171710', 1, 0, '', NULL, NULL, NULL),
(64606, '2018-03-02 13:16:02', NULL, NULL, 17062, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1520385034', 'admin', '2018-03-02 13:16:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64607, '2018-03-02 16:18:29', NULL, NULL, 17069, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 16:18:29', 'admin-1519952075-15199787096777298', 1, 1, 'SR', NULL, NULL, NULL),
(64608, '2018-03-02 11:23:04', NULL, NULL, 17052, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 11:23:04', 'admin-1519952075-15199609842774992', 1, 1, 'SR', NULL, NULL, NULL),
(64609, '2018-03-01 11:49:16', NULL, NULL, 17030, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 11:49:16', 'admin-1519866231-15198761564915996', 1, 1, 'SR', NULL, NULL, NULL),
(64610, '2018-03-01 11:54:47', NULL, NULL, 17031, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1520385034', 'admin', '2018-03-01 11:54:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64611, '2018-03-01 12:42:31', NULL, NULL, 17036, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1520385034', 'admin', '2018-03-01 12:42:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64612, '2018-03-02 11:23:04', NULL, NULL, 17052, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 11:23:04', 'admin-1519952075-15199609842774992', 1, 1, 'SR', NULL, NULL, NULL),
(64613, '2018-03-03 09:21:15', NULL, NULL, 17075, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 09:21:15', 'admin-1520038141-15200400756129894', 1, 0, '', NULL, NULL, NULL),
(64614, '2018-03-03 09:18:13', NULL, NULL, 17075, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 09:18:13', 'admin-1520038141-15200398936094113', 1, 1, 'SR', NULL, NULL, NULL),
(64615, '2018-03-02 11:04:40', NULL, NULL, 17051, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 11:04:40', 'admin-1519952075-15199598805743651', 1, 1, 'SR', NULL, NULL, NULL),
(64616, '2018-03-02 11:03:57', NULL, NULL, 17051, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.70, 0.0000, 0.0000, 2.70, 1, '27', 1, '1520385034', 'admin', '2018-03-02 11:03:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64617, '2018-03-02 13:58:59', NULL, NULL, 17064, 0, 181, '116', 'Open Food ', 'Pork rib', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 13:58:59', 'admin-1519952075-15199703397714344', 1, 0, '', NULL, NULL, NULL),
(64618, '2018-03-02 10:30:41', NULL, NULL, 17049, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 10:30:41', 'admin-1519952075-15199578409425781', 1, 0, '', NULL, NULL, '10.0'),
(64619, '2018-03-02 13:58:32', NULL, NULL, 17064, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1520385034', 'admin', '2018-03-02 13:58:32', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64620, '2018-03-02 13:53:57', NULL, NULL, 17063, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 13:53:57', 'admin-1519952075-15199700377983344', 1, 1, 'SR', NULL, NULL, NULL),
(64621, '2018-03-02 10:40:39', NULL, NULL, 17050, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 10:40:39', 'admin-1519952075-15199584394934523', 1, 1, 'SR', NULL, NULL, '10.0'),
(64622, '2018-03-02 10:40:39', NULL, NULL, 17050, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 10:40:39', 'admin-1519952075-15199584394934523', 1, 0, '', NULL, NULL, '10.0'),
(64623, '2018-03-02 10:40:26', NULL, NULL, 17050, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1520385034', 'admin', '2018-03-02 10:40:26', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(64624, '2018-03-02 10:40:39', NULL, NULL, 17050, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 10:40:39', 'admin-1519952075-15199584394934523', 1, 0, '', NULL, NULL, '10.0'),
(64625, '2018-03-01 11:56:35', NULL, NULL, 17032, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 11:56:35', 'admin-1519866231-15198765949026788', 1, 1, 'SR', NULL, NULL, NULL),
(64626, '2018-03-02 13:58:59', NULL, NULL, 17064, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 13:58:59', 'admin-1519952075-15199703397714344', 1, 1, 'SR', NULL, NULL, NULL),
(64627, '2018-03-02 13:16:13', NULL, NULL, 17062, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 13:16:13', 'admin-1519952075-15199677730162514', 1, 1, 'SR', NULL, NULL, NULL),
(64628, '2018-03-01 11:54:58', NULL, NULL, 17031, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 11:54:58', 'admin-1519866231-15198764987278218', 1, 1, 'SR', NULL, NULL, NULL),
(64629, '2018-03-02 12:16:24', NULL, NULL, 17057, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:16:24', 'admin-1519952075-15199641848055345', 1, 1, 'SR', NULL, NULL, NULL),
(64630, '2018-03-02 11:22:37', NULL, NULL, 17052, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 11:22:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64631, '2018-03-02 12:57:34', NULL, NULL, 17055, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:57:34', 'admin-1519952075-15199666540824577', 1, 1, 'SR', NULL, NULL, NULL),
(64632, '2018-03-02 12:57:34', NULL, NULL, 17055, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:57:34', 'admin-1519952075-15199666540824577', 1, 0, '', NULL, NULL, NULL),
(64633, '2018-03-02 12:46:04', NULL, NULL, 17059, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:46:04', 'admin-1519952075-15199659643493014', 1, 1, 'SR', NULL, NULL, NULL),
(64634, '2018-03-02 12:46:04', NULL, NULL, 17059, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:46:04', 'admin-1519952075-15199659643493014', 1, 1, 'SR', NULL, NULL, NULL),
(64635, '2018-03-02 12:46:04', NULL, NULL, 17059, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:46:04', 'admin-1519952075-15199659643493014', 1, 0, '', NULL, NULL, NULL),
(64636, '2018-03-02 10:18:29', NULL, NULL, 17048, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 10:18:29', 'admin-1519952075-1519957109409533', 1, 0, '', NULL, NULL, NULL),
(64637, '2018-03-02 10:30:27', NULL, NULL, 17049, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1520385034', 'admin', '2018-03-02 10:30:27', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(64638, '2018-03-02 10:00:47', NULL, NULL, 17045, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 10:00:47', 'admin-1519952075-15199560477982416', 1, 0, '', 1, NULL, NULL),
(64639, '2018-03-03 14:01:14', NULL, NULL, 17100, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, '1520385034', 'admin', '2018-03-03 14:01:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64640, '2018-03-04 09:05:21', NULL, NULL, 17119, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.40, 0.0000, 0.0000, 5.40, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:05:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64641, '2018-03-03 12:01:21', NULL, NULL, 17091, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 11.00, 0.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:01:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64642, '2018-03-02 10:18:29', NULL, NULL, 17048, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 10:18:29', 'admin-1519952075-1519957109409533', 1, 0, '', NULL, NULL, NULL),
(64643, '2018-03-03 00:00:00', NULL, NULL, 17116, 0, 17, '17', 'Iced Caramel Macchiato ', '', 'Cold Drinks', 'Coffee', 1, 14.00, NULL, NULL, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 16:48:08', 'admin-1520038141-15200668885008754', 1, 1, 'SR', NULL, NULL, NULL),
(64644, '2018-03-03 00:00:00', NULL, NULL, 17117, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 16:48:08', 'admin-1520038141-15200668885008754', 1, 1, 'SR', NULL, NULL, NULL),
(64645, '2018-03-02 13:58:59', NULL, NULL, 17064, 0, 181, '116', 'Open Food ', 'Pork rib', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 13:58:59', 'admin-1519952075-15199703397714344', 1, 0, '', NULL, NULL, NULL),
(64646, '2018-03-02 11:04:40', NULL, NULL, 17051, 0, 328, '264', 'Basic Blueberries Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 11:04:40', 'admin-1519952075-15199598805743651', 1, 0, '', NULL, NULL, NULL),
(64647, '2018-03-01 12:31:15', NULL, NULL, 17035, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 12:31:15', 'admin-1519866231-15198786757686129', 1, 0, '', NULL, NULL, NULL),
(64648, '2018-03-01 12:31:15', NULL, NULL, 17035, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 12:31:15', 'admin-1519866231-15198786757686129', 1, 1, 'SR', NULL, NULL, NULL),
(64649, '2018-03-01 12:31:15', NULL, NULL, 17035, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 12:31:15', 'admin-1519866231-15198786757686129', 1, 1, 'SR', NULL, NULL, NULL),
(64650, '2018-03-03 12:14:08', NULL, NULL, 17094, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:14:08', 'admin-1520038141-1520050447894421', 1, 1, 'SR', NULL, NULL, NULL),
(64651, '2018-03-03 10:51:15', NULL, NULL, 17081, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 10:51:15', 'admin-1520038141-15200454758428985', 1, 1, 'SR', NULL, NULL, '10.0'),
(64652, '2018-03-03 00:00:00', NULL, NULL, 17115, 0, 36, '36', 'Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, NULL, NULL, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 16:48:08', 'admin-1520038141-15200668885008754', 1, 1, 'SR', NULL, NULL, NULL),
(64653, '2018-03-02 10:18:29', NULL, NULL, 17048, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 10:18:29', 'admin-1519952075-1519957109409533', 1, 0, '', NULL, NULL, NULL),
(64654, '2018-03-02 10:03:06', NULL, NULL, 17047, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 10:03:06', 'admin-1519952075-15199561861388921', 1, 0, '', 1, NULL, NULL),
(64655, '2018-03-03 11:20:58', NULL, NULL, 17083, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 11:20:58', 'admin-1520038141-1520047258731649', 1, 1, 'SR', NULL, NULL, NULL),
(64656, '2018-03-03 12:13:47', NULL, NULL, 17093, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:13:47', 'admin-1520038141-152005042733675', 1, 0, '', NULL, NULL, NULL),
(64657, '2018-03-01 14:36:29', NULL, NULL, 17040, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 14:36:29', 'admin-1519866231-15198861890798239', 1, 0, '', NULL, NULL, NULL),
(64658, '2018-03-01 14:36:29', NULL, NULL, 17040, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 14:36:29', 'admin-1519866231-15198861890798239', 1, 1, 'SR', NULL, NULL, NULL),
(64659, '2018-03-02 09:49:19', NULL, NULL, 17044, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.20, 0.0000, 0.0000, 4.20, 1, '27', 1, '1520385034', 'admin', '2018-03-02 09:49:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64660, '2018-03-03 12:14:08', NULL, NULL, 17094, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 12:14:08', 'admin-1520038141-1520050447894421', 1, 0, '', NULL, NULL, NULL),
(64661, '2018-03-02 12:45:52', NULL, NULL, 17059, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:45:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64662, '2018-03-02 09:49:43', NULL, NULL, 17044, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 09:49:43', 'admin-1519952075-15199553836672871', 1, 1, 'SR', NULL, NULL, NULL),
(64663, '2018-03-01 00:00:00', NULL, NULL, 17036, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 12:13:52', 'admin-1519866231-1519877632053458', 1, 0, '', NULL, NULL, NULL),
(64664, '2018-03-02 09:49:43', NULL, NULL, 17044, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 09:49:43', 'admin-1519952075-15199553836672871', 1, 1, 'SR', NULL, NULL, NULL),
(64665, '2018-03-02 09:49:43', NULL, NULL, 17044, 0, 2, '2', 'Espresso Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 09:49:43', 'admin-1519952075-15199553836672871', 1, 1, 'SR', NULL, NULL, NULL),
(64666, '2018-03-02 13:53:57', NULL, NULL, 17063, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 13:53:57', 'admin-1519952075-15199700377983344', 1, 1, 'SR', NULL, NULL, NULL),
(64667, '2018-03-02 09:49:43', NULL, NULL, 17044, NULL, 23, '23', 'Lemon Tea', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 09:49:43', 'admin-1519952075-15199553836672871', 1, 1, 'SR', NULL, NULL, NULL),
(64668, '2018-03-01 15:35:40', NULL, NULL, 17042, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 15:35:40', 'admin-1519866231-15198897408652837', 1, 0, '', NULL, NULL, NULL),
(64669, '2018-03-01 15:35:31', NULL, NULL, 17042, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1520385034', 'admin', '2018-03-01 15:35:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64670, '2018-03-01 15:19:39', NULL, NULL, 17041, 0, 9, '9', 'Affogato', '', 'Hot Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 15:19:39', 'admin-1519866231-15198887798497688', 1, 1, 'SR', NULL, NULL, NULL),
(64671, '2018-03-01 14:36:29', NULL, NULL, 17040, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 14:36:29', 'admin-1519866231-15198861890798239', 1, 1, 'SR', NULL, NULL, NULL),
(64672, '2018-03-02 11:40:54', NULL, NULL, 17053, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 11:40:54', 'admin-1519952075-1519962054481489', 1, 1, 'SR', NULL, NULL, '10.0'),
(64673, '2018-03-01 14:36:29', NULL, NULL, 17040, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 14:36:29', 'admin-1519866231-15198861890798239', 1, 0, '', NULL, NULL, NULL),
(64674, '2018-03-03 10:23:20', NULL, NULL, 17078, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 10:23:20', 'admin-1520038141-1520043800570788', 1, 0, '', NULL, NULL, NULL),
(64675, '2018-03-02 12:16:24', NULL, NULL, 17057, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:16:24', 'admin-1519952075-15199641848055345', 1, 1, 'SR', NULL, NULL, NULL),
(64676, '2018-03-01 13:54:36', NULL, NULL, 17039, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 13:54:36', 'admin-1519866231-15198836764238813', 1, 1, 'SR', NULL, NULL, NULL),
(64677, '2018-03-01 13:54:31', NULL, NULL, 17039, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 13:54:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64678, '2018-03-01 13:54:36', NULL, NULL, 17039, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 13:54:36', 'admin-1519866231-15198836764238813', 1, 1, 'SR', NULL, NULL, NULL),
(64679, '2018-03-01 13:04:06', NULL, NULL, 17038, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 13:04:06', 'admin-1519866231-15198806463625341', 1, 1, 'SR', NULL, NULL, NULL),
(64680, '2018-03-03 09:53:15', NULL, NULL, 17077, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 09:53:15', 'admin-1520038141-15200419955516121', 1, 1, 'SR', NULL, NULL, NULL),
(64681, '2018-03-01 15:12:31', NULL, NULL, 17040, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 15:12:31', 'admin-1519866231-1519888351346673', 1, 1, 'SR', NULL, NULL, NULL),
(64682, '2018-03-01 14:36:10', NULL, NULL, 17040, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1520385034', 'admin', '2018-03-01 14:36:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64683, '2018-03-03 16:25:20', NULL, NULL, 17109, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.00, 0.0000, 0.0000, 1.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 16:25:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64684, '2018-03-02 10:01:50', NULL, NULL, 17046, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 10:01:50', 'admin-1519952075-15199561100007682', 1, 0, '', 1, NULL, NULL),
(64685, '2018-03-02 09:19:12', NULL, NULL, 17043, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 09:19:12', 'admin-1519952075-15199535526113688', 1, 0, '', NULL, NULL, NULL),
(64686, '2018-03-02 12:35:08', NULL, NULL, 17056, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:35:08', 'admin-1519952075-15199653082236928', 1, 1, 'SR', NULL, NULL, NULL),
(64687, '2018-03-02 12:16:12', NULL, NULL, 17056, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:16:12', 'admin-1519952075-15199641719481998', 1, 1, 'SR', NULL, NULL, NULL),
(64688, '2018-03-02 10:18:16', NULL, NULL, 17048, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.70, 0.0000, 0.0000, 4.70, 1, '27', 1, '1520385034', 'admin', '2018-03-02 10:18:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64689, '2018-03-02 12:06:01', NULL, NULL, 17055, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1520385034', 'admin', '2018-03-02 12:06:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64690, '2018-03-02 16:01:13', NULL, NULL, 17067, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-02 16:01:13', 'admin-1519952075-15199776736152090', 1, 1, 'SR', NULL, NULL, NULL),
(64691, '2018-03-01 12:31:15', NULL, NULL, 17035, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 12:31:15', 'admin-1519866231-15198786757686129', 1, 1, 'SR', NULL, NULL, NULL),
(64692, '2018-03-01 12:31:15', NULL, NULL, 17035, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 12:31:15', 'admin-1519866231-15198786757686129', 1, 0, '', NULL, NULL, NULL),
(64693, '2018-03-01 12:21:36', NULL, NULL, 17034, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 12:21:36', 'admin-1519866231-15198780965579327', 1, 1, 'SR', NULL, NULL, '10.0'),
(64694, '2018-03-01 12:21:36', NULL, NULL, 17034, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 12:21:36', 'admin-1519866231-15198780965579327', 1, 1, 'SR', NULL, NULL, '10.0'),
(64695, '2018-03-01 12:30:57', NULL, NULL, 17035, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1520385034', 'admin', '2018-03-01 12:30:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64696, '2018-03-02 13:08:16', NULL, NULL, 17061, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1520385034', 'admin', '2018-03-02 13:08:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64697, '2018-03-01 11:56:35', NULL, NULL, 17032, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 11:56:35', 'admin-1519866231-15198765949026788', 1, 0, '', NULL, NULL, NULL),
(64698, '2018-03-01 11:56:35', NULL, NULL, 17032, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 11:56:35', 'admin-1519866231-15198765949026788', 1, 1, 'SR', NULL, NULL, NULL),
(64699, '2018-03-01 11:55:16', NULL, NULL, 17031, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 11:55:16', 'admin-1519866231-15198765158952354', 1, 1, 'SR', NULL, NULL, NULL),
(64700, '2018-03-01 11:55:41', NULL, NULL, 17032, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.40, 0.0000, 0.0000, 10.40, 1, '27', 1, '1520385034', 'admin', '2018-03-01 11:55:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64701, '2018-03-01 11:56:35', NULL, NULL, 17032, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 11:56:35', 'admin-1519866231-15198765949026788', 1, 0, '', NULL, NULL, NULL),
(64702, '2018-03-01 11:56:35', NULL, NULL, 17032, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 11:56:35', 'admin-1519866231-15198765949026788', 1, 0, '', NULL, NULL, NULL),
(64703, '2018-03-01 11:56:35', NULL, NULL, 17032, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 11:56:35', 'admin-1519866231-15198765949026788', 1, 0, '', NULL, NULL, NULL),
(64704, '2018-03-03 14:56:03', NULL, NULL, 17102, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1520385034', 'admin', '2018-03-03 14:56:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64705, '2018-03-01 11:49:10', NULL, NULL, 17030, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1520385034', 'admin', '2018-03-01 11:49:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64706, '2018-03-01 13:11:09', NULL, NULL, 17030, 0, 34, '34', 'Ginger Lemongrass Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 13:11:09', 'admin-1519866231-15198810696742882', 1, 1, 'SR', NULL, NULL, NULL),
(64707, '2018-03-01 11:54:58', NULL, NULL, 17031, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 11:54:58', 'admin-1519866231-15198764987278218', 1, 1, 'SR', NULL, NULL, NULL),
(64708, '2018-03-01 11:20:04', NULL, NULL, 17029, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 11:20:04', 'admin-1519866231-15198744046791252', 1, 0, '', NULL, NULL, NULL),
(64709, '2018-03-01 10:34:57', NULL, NULL, 17028, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 10:34:57', 'admin-1519866231-15198716971797969', 1, 1, 'SR', NULL, NULL, NULL),
(64710, '2018-03-01 11:20:04', NULL, NULL, 17029, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 11:20:04', 'admin-1519866231-15198744046791252', 1, 0, '', NULL, NULL, NULL),
(64711, '2018-03-01 11:19:57', NULL, NULL, 17029, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1520385034', 'admin', '2018-03-01 11:19:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64712, '2018-03-01 10:34:57', NULL, NULL, 17028, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-01 10:34:57', 'admin-1519866231-15198716971797969', 1, 0, '', NULL, NULL, NULL),
(64713, '2018-03-01 10:34:06', NULL, NULL, 17028, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1520385034', 'admin', '2018-03-01 10:34:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64714, '2018-03-04 09:05:31', NULL, NULL, 17119, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:05:31', 'admin-1520125217-1520125531098372', 1, 1, 'SR', NULL, NULL, NULL),
(64715, '2018-03-04 09:05:31', NULL, NULL, 17119, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:05:31', 'admin-1520125217-1520125531098372', 1, 1, 'SR', NULL, NULL, NULL),
(64716, '2018-03-04 09:07:11', NULL, NULL, 17120, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:07:11', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64717, '2018-03-04 09:07:24', NULL, NULL, 17120, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:07:24', 'admin-1520125217-15201256440405163', 1, 1, 'SR', NULL, NULL, NULL),
(64718, '2018-03-04 09:07:24', NULL, NULL, 17120, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:07:24', 'admin-1520125217-15201256440405163', 1, 1, 'SR', NULL, NULL, NULL),
(64719, '2018-03-04 09:07:46', NULL, NULL, 17121, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 26.10, 0.0000, 0.0000, 26.10, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:07:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64720, '2018-03-04 09:08:29', NULL, NULL, 17121, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:08:29', 'admin-1520125217-15201257089819795', 1, 0, '', NULL, NULL, NULL),
(64721, '2018-03-04 09:08:29', NULL, NULL, 17121, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:08:29', 'admin-1520125217-15201257089819795', 1, 0, '', NULL, NULL, NULL),
(64722, '2018-03-04 09:08:29', NULL, NULL, 17121, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:08:29', 'admin-1520125217-15201257089819795', 1, 0, '', NULL, NULL, NULL),
(64723, '2018-03-04 09:08:29', NULL, NULL, 17121, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:08:29', 'admin-1520125217-15201257089819795', 1, 0, '', NULL, NULL, NULL),
(64724, '2018-03-04 09:08:29', NULL, NULL, 17121, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:08:29', 'admin-1520125217-15201257089819795', 1, 0, '', NULL, NULL, NULL),
(64725, '2018-03-04 09:08:29', NULL, NULL, 17121, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:08:29', 'admin-1520125217-15201257089819795', 1, 0, '', NULL, NULL, NULL),
(64726, '2018-03-04 09:08:29', NULL, NULL, 17121, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:08:29', 'admin-1520125217-15201257089819795', 1, 0, '', NULL, NULL, NULL),
(64727, '2018-03-04 09:08:29', NULL, NULL, 17121, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:08:29', 'admin-1520125217-15201257089819795', 1, 0, '', NULL, NULL, NULL),
(64728, '2018-03-04 09:09:06', NULL, NULL, 17121, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:09:06', 'admin-1520125217-15201257467613710', 1, 1, 'SR', NULL, NULL, NULL),
(64729, '2018-03-04 09:09:06', NULL, NULL, 17121, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:09:06', 'admin-1520125217-15201257467613710', 1, 1, 'SR', NULL, NULL, NULL),
(64730, '2018-03-04 09:09:06', NULL, NULL, 17121, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:09:06', 'admin-1520125217-15201257467613710', 1, 1, 'SR', NULL, NULL, NULL),
(64731, '2018-03-04 09:09:06', NULL, NULL, 17121, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:09:06', 'admin-1520125217-15201257467613710', 1, 1, 'SR', NULL, NULL, NULL),
(64732, '2018-03-04 09:09:06', NULL, NULL, 17121, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:09:06', 'admin-1520125217-15201257467613710', 1, 1, 'SR', NULL, NULL, NULL),
(64733, '2018-03-04 09:09:06', NULL, NULL, 17121, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:09:06', 'admin-1520125217-15201257467613710', 1, 0, '', NULL, NULL, NULL),
(64734, '2018-03-04 09:09:06', NULL, NULL, 17121, 0, 268, '202', 'Iced Cocoa Cappucino', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:09:06', 'admin-1520125217-15201257467613710', 1, 0, '', NULL, NULL, NULL),
(64735, '2018-03-04 09:09:07', NULL, NULL, 17121, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:09:07', 'admin-1520125217-15201257467613710', 1, 1, 'SR', NULL, NULL, NULL),
(64736, '2018-03-04 09:12:05', NULL, NULL, 17121, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:12:05', 'admin-1520125217-15201259249305112', 1, 0, '', NULL, NULL, NULL),
(64737, '2018-03-04 09:12:05', NULL, NULL, 17121, 0, 181, '116', 'Open Food ', 'toast with butter', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:12:05', 'admin-1520125217-15201259249305112', 1, 0, '', NULL, NULL, NULL),
(64738, '2018-03-04 09:12:05', NULL, NULL, 17121, 0, 181, '116', 'Open Food ', 'toast with butter', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:12:05', 'admin-1520125217-15201259249305112', 1, 0, '', NULL, NULL, NULL),
(64739, '2018-03-04 09:12:05', NULL, NULL, 17121, 0, 181, '116', 'Open Food ', 'toast with butter', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:12:05', 'admin-1520125217-15201259249305112', 1, 0, '', NULL, NULL, NULL),
(64740, '2018-03-04 09:12:05', NULL, NULL, 17121, 0, 181, '116', 'Open Food ', 'toast with butter', 'Meals', 'Perfect Meals', 1, 1.00, 1.0000, 0.0000, 1.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:12:05', 'admin-1520125217-15201259249305112', 1, 0, '', NULL, NULL, NULL),
(64741, '2018-03-04 09:15:58', NULL, NULL, 17122, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:15:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64742, '2018-03-04 09:16:15', NULL, NULL, 17122, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:16:15', 'admin-1520125217-15201261749003137', 1, 0, '', NULL, NULL, NULL),
(64743, '2018-03-04 09:16:15', NULL, NULL, 17122, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:16:15', 'admin-1520125217-15201261749003137', 1, 0, '', NULL, NULL, NULL),
(64744, '2018-03-04 09:16:15', NULL, NULL, 17122, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:16:15', 'admin-1520125217-15201261749003137', 1, 0, '', NULL, NULL, NULL),
(64745, '2018-03-04 09:16:15', NULL, NULL, 17122, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:16:15', 'admin-1520125217-15201261749003137', 1, 1, 'SR', NULL, NULL, NULL),
(64746, '2018-03-04 09:16:15', NULL, NULL, 17122, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:16:15', 'admin-1520125217-15201261749003137', 1, 1, 'SR', NULL, NULL, NULL),
(64747, '2018-03-04 09:17:39', NULL, NULL, 17123, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:17:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64748, '2018-03-04 09:17:44', NULL, NULL, 17123, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:17:44', 'admin-1520125217-15201262647546937', 1, 1, 'SR', NULL, NULL, NULL),
(64749, '2018-03-04 09:27:00', NULL, NULL, 17124, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:27:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64750, '2018-03-04 09:27:24', NULL, NULL, 17124, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:27:24', 'admin-1520125217-15201268444707443', 1, 0, '', NULL, NULL, NULL),
(64751, '2018-03-04 09:27:24', NULL, NULL, 17124, 0, 156, '90', 'House Cheddar Omelet', '', 'Meals', 'Morning Bites ', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:27:24', 'admin-1520125217-15201268444707443', 1, 0, '', NULL, NULL, NULL),
(64752, '2018-03-04 09:27:24', NULL, NULL, 17124, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:27:24', 'admin-1520125217-15201268444707443', 1, 1, 'SR', NULL, NULL, NULL),
(64753, '2018-03-04 09:27:24', NULL, NULL, 17124, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:27:24', 'admin-1520125217-15201268444707443', 1, 1, 'SR', NULL, NULL, NULL),
(64754, '2018-03-04 09:27:24', NULL, NULL, 17124, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:27:24', 'admin-1520125217-15201268444707443', 1, 0, '', NULL, NULL, NULL),
(64755, '2018-03-04 09:46:38', NULL, NULL, 17125, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 14.40, 0.0000, 0.0000, 14.40, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:46:38', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64756, '2018-03-04 09:47:54', NULL, NULL, 17125, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:47:54', 'admin-1520125217-15201280744125195', 1, 0, '', NULL, NULL, NULL),
(64757, '2018-03-04 09:47:54', NULL, NULL, 17125, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:47:54', 'admin-1520125217-15201280744125195', 1, 0, '', NULL, NULL, NULL),
(64758, '2018-03-04 09:47:54', NULL, NULL, 17125, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:47:54', 'admin-1520125217-15201280744125195', 1, 0, '', NULL, NULL, NULL),
(64759, '2018-03-04 09:47:54', NULL, NULL, 17125, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:47:54', 'admin-1520125217-15201280744125195', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(64760, '2018-03-04 09:47:54', NULL, NULL, 17125, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:47:54', 'admin-1520125217-15201280744125195', 1, 0, '', NULL, NULL, NULL),
(64761, '2018-03-04 09:47:54', NULL, NULL, 17125, 0, 181, '116', 'Open Food ', 'sausage', 'Meals', 'Perfect Meals', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:47:54', 'admin-1520125217-15201280744125195', 1, 0, '', NULL, NULL, NULL),
(64762, '2018-03-04 09:47:54', NULL, NULL, 17125, NULL, 21, '21', 'Chocolate ', '', 'Hot Drinks', 'Non Coffee', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:47:54', 'admin-1520125217-15201280744125195', 1, 1, 'SR', NULL, NULL, NULL),
(64763, '2018-03-04 09:47:54', NULL, NULL, 17125, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:47:54', 'admin-1520125217-15201280744125195', 1, 1, 'SR', NULL, NULL, NULL),
(64764, '2018-03-04 09:47:54', NULL, NULL, 17125, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:47:54', 'admin-1520125217-15201280744125195', 1, 1, 'SR', NULL, NULL, NULL),
(64765, '2018-03-04 09:47:54', NULL, NULL, 17125, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:47:54', 'admin-1520125217-15201280744125195', 1, 1, 'SR', NULL, NULL, NULL),
(64766, '2018-03-04 09:47:54', NULL, NULL, 17125, 0, 209, '143', 'Honey Lemon', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:47:54', 'admin-1520125217-15201280744125195', 1, 0, '', NULL, NULL, NULL),
(64767, '2018-03-04 09:49:12', NULL, NULL, 17126, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:49:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64768, '2018-03-04 09:49:24', NULL, NULL, 17126, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:49:24', 'admin-1520125217-15201281644469233', 1, 0, '', NULL, NULL, NULL),
(64769, '2018-03-04 09:49:24', NULL, NULL, 17126, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:49:24', 'admin-1520125217-15201281644469233', 1, 1, 'SR', NULL, NULL, NULL),
(64770, '2018-03-04 09:49:24', NULL, NULL, 17126, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:49:24', 'admin-1520125217-15201281644469233', 1, 1, 'SR', NULL, NULL, NULL),
(64771, '2018-03-04 09:56:37', NULL, NULL, 17127, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.30, 0.0000, 0.0000, 1.30, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:56:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64772, '2018-03-04 09:56:42', NULL, NULL, 17127, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:56:42', 'admin-1520125217-15201286019733787', 1, 1, 'SR', NULL, NULL, NULL),
(64773, '2018-03-04 09:58:14', NULL, NULL, 17128, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:58:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64774, '2018-03-04 09:58:30', NULL, NULL, 17128, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:58:30', 'admin-1520125217-15201287103867082', 1, 0, '', NULL, NULL, NULL),
(64775, '2018-03-04 09:58:30', NULL, NULL, 17128, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:58:30', 'admin-1520125217-15201287103867082', 1, 0, '', NULL, NULL, NULL),
(64776, '2018-03-04 09:58:30', NULL, NULL, 17128, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:58:30', 'admin-1520125217-15201287103867082', 1, 1, 'SR', NULL, NULL, NULL),
(64777, '2018-03-04 09:58:30', NULL, NULL, 17128, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 09:58:30', 'admin-1520125217-15201287103867082', 1, 1, 'SR', NULL, NULL, NULL),
(64778, '2018-03-04 10:06:42', NULL, NULL, 17129, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.30, 0.0000, 0.0000, 6.30, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:06:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64779, '2018-03-04 10:07:08', NULL, NULL, 17129, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:07:08', 'admin-1520125217-15201292284553449', 1, 0, '', NULL, NULL, NULL),
(64780, '2018-03-04 10:07:08', NULL, NULL, 17129, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:07:08', 'admin-1520125217-15201292284553449', 1, 0, '', NULL, NULL, NULL),
(64781, '2018-03-04 10:07:08', NULL, NULL, 17129, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:07:08', 'admin-1520125217-15201292284553449', 1, 0, '', NULL, NULL, NULL),
(64782, '2018-03-04 10:07:08', NULL, NULL, 17129, NULL, 64, '64', 'Green Apple', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:07:08', 'admin-1520125217-15201292284553449', 1, 1, 'SR', NULL, NULL, NULL),
(64783, '2018-03-04 10:08:20', NULL, NULL, 17130, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:08:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64784, '2018-03-04 10:08:32', NULL, NULL, 17130, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:08:32', 'admin-1520125217-15201293119024566', 1, 0, '', NULL, NULL, NULL),
(64785, '2018-03-04 10:08:32', NULL, NULL, 17130, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:08:32', 'admin-1520125217-15201293119024566', 1, 0, '', NULL, NULL, NULL),
(64786, '2018-03-04 10:08:32', NULL, NULL, 17130, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:08:32', 'admin-1520125217-15201293119024566', 1, 1, 'SR', NULL, NULL, NULL),
(64787, '2018-03-04 10:08:32', NULL, NULL, 17130, NULL, 4, '4', 'Piccolo', '', 'Hot Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:08:32', 'admin-1520125217-15201293119024566', 1, 1, 'SR', NULL, NULL, NULL),
(64788, '2018-03-04 10:20:18', NULL, NULL, 17131, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:20:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64789, '2018-03-04 10:20:32', NULL, NULL, 17131, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:20:32', 'admin-1520125217-15201300322367915', 1, 0, '', NULL, NULL, NULL),
(64790, '2018-03-04 10:20:32', NULL, NULL, 17131, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:20:32', 'admin-1520125217-15201300322367915', 1, 0, '', NULL, NULL, NULL),
(64791, '2018-03-04 10:20:32', NULL, NULL, 17131, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:20:32', 'admin-1520125217-15201300322367915', 1, 1, 'SR', NULL, NULL, NULL),
(64792, '2018-03-04 10:20:32', NULL, NULL, 17131, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:20:32', 'admin-1520125217-15201300322367915', 1, 1, 'SR', NULL, NULL, NULL),
(64793, '2018-03-04 10:35:37', NULL, NULL, 17132, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:35:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64794, '2018-03-04 10:35:40', NULL, NULL, 17132, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:35:40', 'admin-1520125217-15201309408338027', 1, 1, 'SR', NULL, NULL, NULL),
(64795, '2018-03-04 10:39:40', NULL, NULL, 17133, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.69, 0.0000, 0.0000, 8.69, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:39:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64796, '2018-03-04 10:39:55', NULL, NULL, 17133, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:39:55', 'admin-1520125217-15201311954435510', 1, 0, '', NULL, NULL, NULL),
(64797, '2018-03-04 10:39:55', NULL, NULL, 17133, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:39:55', 'admin-1520125217-15201311954435510', 1, 0, '', NULL, NULL, NULL),
(64798, '2018-03-04 10:39:55', NULL, NULL, 17133, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:39:55', 'admin-1520125217-15201311954435510', 1, 0, '', NULL, NULL, NULL),
(64799, '2018-03-04 10:41:30', NULL, NULL, 17134, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 26.20, 0.0000, 0.0000, 26.20, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:41:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64800, '2018-03-04 10:42:20', NULL, NULL, 17134, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:42:20', 'admin-1520125217-15201313403607558', 1, 0, '', NULL, NULL, NULL),
(64801, '2018-03-04 10:42:20', NULL, NULL, 17134, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:42:20', 'admin-1520125217-15201313403607558', 1, 0, '', NULL, NULL, NULL),
(64802, '2018-03-04 10:42:20', NULL, NULL, 17134, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:42:20', 'admin-1520125217-15201313403607558', 1, 0, '', NULL, NULL, NULL),
(64803, '2018-03-04 10:42:20', NULL, NULL, 17134, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:42:20', 'admin-1520125217-15201313403607558', 1, 1, 'SR', NULL, NULL, NULL),
(64804, '2018-03-04 10:42:20', NULL, NULL, 17134, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:42:20', 'admin-1520125217-15201313403607558', 1, 0, '', NULL, NULL, NULL),
(64805, '2018-03-04 10:42:20', NULL, NULL, 17134, NULL, 25, '25', 'Matcha Latte', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:42:20', 'admin-1520125217-15201313403607558', 1, 1, 'SR', NULL, NULL, NULL),
(64806, '2018-03-04 10:42:20', NULL, NULL, 17134, NULL, 69, '69', 'Mix 3 types', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:42:20', 'admin-1520125217-15201313403607558', 1, 1, 'SR', NULL, NULL, NULL),
(64807, '2018-03-04 10:42:20', NULL, NULL, 17134, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:42:20', 'admin-1520125217-15201313403607558', 1, 1, 'SR', NULL, NULL, NULL),
(64808, '2018-03-04 10:42:20', NULL, NULL, 17134, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:42:20', 'admin-1520125217-15201313403607558', 1, 0, '', NULL, NULL, NULL),
(64809, '2018-03-04 10:42:20', NULL, NULL, 17134, 0, 235, '169', 'I''m Single', '', 'Desserts', '0', 1, 4.00, 4.0000, 0.0000, 4.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:42:20', 'admin-1520125217-15201313403607558', 1, 0, '', NULL, NULL, NULL),
(64810, '2018-03-04 10:44:51', NULL, NULL, 17133, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:44:51', 'admin-1520125217-15201314918538662', 1, 0, '', NULL, NULL, NULL),
(64811, '2018-03-04 10:44:51', NULL, NULL, 17133, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:44:52', 'admin-1520125217-15201314918538662', 1, 0, '', NULL, NULL, NULL),
(64812, '2018-03-04 10:44:52', NULL, NULL, 17133, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:44:52', 'admin-1520125217-15201314918538662', 1, 1, 'SR', NULL, NULL, NULL),
(64813, '2018-03-04 10:45:36', NULL, NULL, 17135, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.60, 0.0000, 0.0000, 5.60, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:45:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64814, '2018-03-04 10:46:12', NULL, NULL, 17135, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:46:12', 'admin-1520125217-15201315722973922', 1, 0, '', NULL, NULL, NULL),
(64815, '2018-03-04 10:46:12', NULL, NULL, 17135, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:46:12', 'admin-1520125217-15201315722973922', 1, 1, 'SR', NULL, NULL, NULL),
(64816, '2018-03-04 10:46:17', NULL, NULL, 17135, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:46:17', 'admin-1520125217-15201315774045394', 1, 0, '', NULL, NULL, NULL),
(64817, '2018-03-04 10:46:27', NULL, NULL, 17134, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:46:27', 'admin-1520125217-15201315874785424', 1, 1, 'SR', NULL, NULL, NULL),
(64818, '2018-03-04 10:51:48', NULL, NULL, 17135, 0, 236, '170', 'Vanilla Milk', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:51:48', 'admin-1520125217-15201319082297728', 1, 0, '', NULL, NULL, NULL),
(64819, '2018-03-04 10:53:16', NULL, NULL, 17134, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:53:16', 'admin-1520125217-15201319963384050', 1, 0, '', NULL, NULL, NULL),
(64820, '2018-03-04 10:53:16', NULL, NULL, 17134, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:53:16', 'admin-1520125217-15201319963384050', 1, 0, '', NULL, NULL, NULL),
(64821, '2018-03-04 10:53:16', NULL, NULL, 17134, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:53:16', 'admin-1520125217-15201319963384050', 1, 0, '', NULL, NULL, NULL),
(64822, '2018-03-04 10:53:16', NULL, NULL, 17134, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:53:16', 'admin-1520125217-15201319963384050', 1, 1, 'SR', NULL, NULL, NULL),
(64823, '2018-03-04 10:53:16', NULL, NULL, 17134, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:53:16', 'admin-1520125217-15201319963384050', 1, 0, '', NULL, NULL, NULL),
(64824, '2018-03-04 11:03:12', NULL, NULL, 17134, 0, 42, '42', 'Passion Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 11:03:12', 'admin-1520125217-15201325922599674', 1, 1, 'SR', NULL, NULL, NULL),
(64825, '2018-03-04 10:53:16', NULL, NULL, 17134, 0, 237, '171', 'Iced Vanilla Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:53:16', 'admin-1520125217-15201319963384050', 1, 0, '', NULL, NULL, NULL),
(64826, '2018-03-04 10:53:16', NULL, NULL, 17134, 0, 301, '237', 'Black Jack', '', 'Cold Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:53:16', 'admin-1520125217-15201319963384050', 1, 0, '', NULL, NULL, NULL),
(64827, '2018-03-04 10:53:16', NULL, NULL, 17134, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:53:16', 'admin-1520125217-15201319963384050', 1, 0, '', NULL, NULL, NULL),
(64828, '2018-03-04 10:53:37', NULL, NULL, 17136, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:53:37', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64829, '2018-03-04 10:53:56', NULL, NULL, 17136, 0, 153, '87', 'Wake Me Up!', ' add sausage,No pork', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:53:56', 'admin-1520125217-15201320361596547', 1, 0, '', NULL, NULL, NULL),
(64830, '2018-03-04 10:53:56', NULL, NULL, 17136, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:53:56', 'admin-1520125217-15201320361596547', 1, 1, 'SR', NULL, NULL, NULL),
(64831, '2018-03-04 10:53:56', NULL, NULL, 17136, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:53:56', 'admin-1520125217-15201320361596547', 1, 1, 'SR', NULL, NULL, NULL),
(64832, '2018-03-04 10:53:56', NULL, NULL, 17136, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:53:56', 'admin-1520125217-15201320361596547', 1, 1, 'SR', NULL, NULL, NULL),
(64833, '2018-03-04 10:55:58', NULL, NULL, 17133, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1520385034', 'admin', '2018-03-04 10:55:58', 'admin-1520125217-15201321583353157', 1, 0, '', NULL, NULL, NULL),
(64834, '2018-03-04 11:00:52', NULL, NULL, 17137, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1520385034', 'admin', '2018-03-04 11:00:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64835, '2018-03-04 11:01:15', NULL, NULL, 17137, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 11:01:15', 'admin-1520125217-15201324750297796', 1, 0, '', NULL, NULL, NULL),
(64836, '2018-03-04 11:01:15', NULL, NULL, 17137, 0, 154, '88', 'Daily Dose BLT', 'egg medium done', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 11:01:15', 'admin-1520125217-15201324750297796', 1, 0, '', NULL, NULL, NULL),
(64837, '2018-03-04 11:15:04', NULL, NULL, 17137, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 11:15:04', 'admin-1520125217-15201333044197657', 1, 1, 'SR', NULL, NULL, NULL),
(64838, '2018-03-04 11:16:48', NULL, NULL, 17138, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, '1520385034', 'admin', '2018-03-04 11:16:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64839, '2018-03-04 11:17:11', NULL, NULL, 17138, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 11:17:11', 'admin-1520125217-15201334314556548', 1, 0, '', NULL, NULL, NULL),
(64840, '2018-03-04 11:17:11', NULL, NULL, 17138, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 11:17:11', 'admin-1520125217-15201334314556548', 1, 0, '', NULL, NULL, NULL),
(64841, '2018-03-04 11:28:50', NULL, NULL, 17139, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1520385034', 'admin', '2018-03-04 11:28:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64842, '2018-03-04 11:28:59', NULL, NULL, 17139, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 11:28:59', 'admin-1520125217-15201341393855417', 1, 0, '', NULL, NULL, NULL),
(64843, '2018-03-04 11:29:41', NULL, NULL, 17140, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1520385034', 'admin', '2018-03-04 11:29:41', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64844, '2018-03-04 11:29:55', NULL, NULL, 17140, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 11:29:55', 'admin-1520125217-15201341949212112', 1, 1, 'SR', NULL, NULL, NULL),
(64845, '2018-03-04 11:29:55', NULL, NULL, 17140, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 11:29:55', 'admin-1520125217-15201341949212112', 1, 1, 'SR', NULL, NULL, NULL),
(64846, '2018-03-04 11:29:55', NULL, NULL, 17140, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 11:29:55', 'admin-1520125217-15201341949212112', 1, 0, '', NULL, NULL, NULL),
(64847, '2018-03-04 11:30:49', NULL, NULL, 17139, 0, 195, '130', 'Iced Tea', '', 'Cold Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 11:30:49', 'admin-1520125217-15201342496101164', 1, 0, '', NULL, NULL, NULL),
(64848, '2018-03-04 11:30:49', NULL, NULL, 17139, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 11:30:49', 'admin-1520125217-15201342496101164', 1, 0, '', NULL, NULL, NULL),
(64849, '2018-03-04 11:30:49', NULL, NULL, 17139, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 11:30:49', 'admin-1520125217-15201342496101164', 1, 0, '', NULL, NULL, NULL),
(64850, '2018-03-04 11:30:49', NULL, NULL, 17139, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 11:30:49', 'admin-1520125217-15201342496101164', 1, 1, 'SR', NULL, NULL, NULL),
(64851, '2018-03-04 12:01:44', NULL, NULL, 17141, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:01:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64852, '2018-03-04 12:02:15', NULL, NULL, 17141, NULL, 67, '67', 'Carrot milk', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:02:15', 'admin-1520125217-15201361352818260', 1, 1, 'SR', NULL, NULL, NULL),
(64853, '2018-03-04 12:02:15', NULL, NULL, 17141, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:02:15', 'admin-1520125217-15201361352818260', 1, 0, '', NULL, NULL, NULL),
(64854, '2018-03-04 12:09:39', NULL, NULL, 17141, 0, 28, '28', 'Iced Honey Milk', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:09:39', 'admin-1520125217-15201365793914390', 1, 1, 'SR', NULL, NULL, NULL),
(64855, '2018-03-04 12:03:36', NULL, NULL, 17142, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:03:36', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64856, '2018-03-04 12:03:41', NULL, NULL, 17142, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:03:41', 'admin-1520125217-1520136221492919', 1, 1, 'SR', NULL, NULL, NULL),
(64857, '2018-03-04 12:03:41', NULL, NULL, 17142, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:03:41', 'admin-1520125217-1520136221492919', 1, 1, 'SR', NULL, NULL, NULL),
(64858, '2018-03-04 12:13:45', NULL, NULL, 17143, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:13:45', 'admin-1520125217-15201368256814094', 1, 0, '', 1, NULL, NULL),
(64859, '2018-03-04 12:14:53', NULL, NULL, 17143, 0, 181, '116', 'Open Food ', 'banana', 'Meals', 'Perfect Meals', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:14:53', 'admin-1520125217-15201368930935923', 1, 0, '', 1, NULL, NULL),
(64860, '2018-03-04 12:17:07', NULL, NULL, 17144, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:17:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64861, '2018-03-04 12:17:20', NULL, NULL, 17144, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:17:20', 'admin-1520125217-15201370398808472', 1, 1, 'SR', NULL, NULL, NULL),
(64862, '2018-03-04 12:17:20', NULL, NULL, 17144, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:17:20', 'admin-1520125217-15201370398808472', 1, 1, 'SR', NULL, NULL, NULL),
(64863, '2018-03-04 12:17:28', NULL, NULL, 17144, 0, 26, '26', 'Iced Honey Lemon', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:17:28', 'admin-1520125217-15201370486309120', 1, 1, 'SR', NULL, NULL, NULL),
(64864, '2018-03-04 16:39:21', NULL, NULL, 17158, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.90, 0.0000, 0.0000, 2.90, 1, '27', 1, '1520385034', 'admin', '2018-03-04 16:39:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64865, '2018-03-04 16:27:50', NULL, NULL, 17157, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 16:27:50', 'admin-1520125217-15201520699066740', 1, 1, 'SR', NULL, NULL, NULL),
(64866, '2018-03-04 16:27:45', NULL, NULL, 17157, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 16:27:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64867, '2018-03-04 12:37:25', NULL, NULL, 17146, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.90, 0.0000, 0.0000, 5.90, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:37:25', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(64868, '2018-03-04 12:37:48', NULL, NULL, 17146, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:37:48', 'admin-1520125217-15201382687545037', 1, 1, 'SR', NULL, NULL, '10.0'),
(64869, '2018-03-04 12:37:48', NULL, NULL, 17146, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:37:48', 'admin-1520125217-15201382687545037', 1, 1, 'SR', NULL, NULL, '10.0'),
(64870, '2018-03-04 12:37:48', NULL, NULL, 17146, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:37:48', 'admin-1520125217-15201382687545037', 1, 0, '', NULL, NULL, '10.0'),
(64871, '2018-03-04 12:37:48', NULL, NULL, 17146, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:37:48', 'admin-1520125217-15201382687545037', 1, 1, 'SR', NULL, NULL, '10.0'),
(64872, '2018-03-04 12:42:14', NULL, NULL, 17147, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 10.60, 0.0000, 0.0000, 10.60, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:42:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64873, '2018-03-04 12:42:54', NULL, NULL, 17147, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:42:54', 'admin-1520125217-15201385745487074', 1, 0, '', NULL, NULL, NULL),
(64874, '2018-03-04 12:42:54', NULL, NULL, 17147, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:42:54', 'admin-1520125217-15201385745487074', 1, 0, '', NULL, NULL, NULL),
(64875, '2018-03-04 12:42:54', NULL, NULL, 17147, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:42:54', 'admin-1520125217-15201385745487074', 1, 1, 'SR', NULL, NULL, NULL),
(64876, '2018-03-04 12:42:54', NULL, NULL, 17147, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:42:54', 'admin-1520125217-15201385745487074', 1, 0, '', NULL, NULL, NULL),
(64877, '2018-03-04 12:47:59', NULL, NULL, 17147, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:47:59', 'admin-1520125217-15201388794344164', 1, 1, 'SR', NULL, NULL, NULL),
(64878, '2018-03-04 12:47:59', NULL, NULL, 17147, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 12:47:59', 'admin-1520125217-15201388794344164', 1, 0, '', NULL, NULL, NULL),
(64879, '2018-03-04 13:01:35', NULL, NULL, 17148, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.00, 0.0000, 0.0000, 6.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 13:01:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64880, '2018-03-04 13:02:24', NULL, NULL, 17148, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 13:02:24', 'admin-1520125217-15201397443455610', 1, 0, '', NULL, NULL, NULL),
(64881, '2018-03-04 13:02:24', NULL, NULL, 17148, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 13:02:24', 'admin-1520125217-15201397443455610', 1, 0, '', NULL, NULL, NULL),
(64882, '2018-03-04 13:02:24', NULL, NULL, 17148, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 13:02:24', 'admin-1520125217-15201397443455610', 1, 1, 'SR', NULL, NULL, NULL),
(64883, '2018-03-04 13:02:24', NULL, NULL, 17148, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 13:02:24', 'admin-1520125217-15201397443455610', 1, 1, 'SR', NULL, NULL, NULL),
(64884, '2018-03-04 13:02:29', NULL, NULL, 17149, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.10, 0.0000, 0.0000, 5.10, 1, '27', 1, '1520385034', 'admin', '2018-03-04 13:02:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64885, '2018-03-04 13:02:43', NULL, NULL, 17149, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 13:02:43', 'admin-1520125217-15201397638002986', 1, 1, 'SR', NULL, NULL, NULL),
(64886, '2018-03-04 13:03:39', NULL, NULL, 17149, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 13:03:39', 'admin-1520125217-15201398194794341', 1, 0, '', NULL, NULL, NULL),
(64887, '2018-03-04 13:02:43', NULL, NULL, 17149, 0, 243, '177', 'Hot Ginger Lemongrass', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 13:02:43', 'admin-1520125217-15201397638002986', 1, 0, '', NULL, NULL, NULL),
(64888, '2018-03-04 13:02:43', NULL, NULL, 17149, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 13:02:43', 'admin-1520125217-15201397638002986', 1, 1, 'SR', NULL, NULL, NULL),
(64889, '2018-03-04 13:13:08', NULL, NULL, 17147, 0, 157, '91', 'Classic French Toast', 'no strawberry', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 13:13:08', 'admin-1520125217-15201403878825017', 1, 0, '', NULL, NULL, NULL),
(64890, '2018-03-04 13:13:50', NULL, NULL, 17150, 0, 185, '120', 'Bottled Water', '', 'Cold Drinks', 'Soda & Beer', 1, 3.00, 3.0000, 0.0000, 3.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 13:13:50', 'admin-1520125217-15201404302186562', 1, 0, '', 1, NULL, NULL),
(64891, '2018-03-04 13:33:30', NULL, NULL, 17151, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1520385034', 'admin', '2018-03-04 13:33:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64892, '2018-03-04 13:33:44', NULL, NULL, 17151, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 13:33:44', 'admin-1520125217-15201416238886159', 1, 0, '', NULL, NULL, NULL),
(64893, '2018-03-04 13:33:44', NULL, NULL, 17151, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 13:33:44', 'admin-1520125217-15201416238886159', 1, 0, '', NULL, NULL, NULL),
(64894, '2018-03-04 13:33:44', NULL, NULL, 17151, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 13:33:44', 'admin-1520125217-15201416238886159', 1, 1, 'SR', NULL, NULL, NULL),
(64895, '2018-03-04 13:42:18', NULL, NULL, 17149, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 13:42:18', 'admin-1520125217-15201421383622714', 1, 0, '', NULL, NULL, NULL),
(64896, '2018-03-04 13:42:45', NULL, NULL, 17149, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 13:42:45', 'admin-1520125217-15201421650609994', 1, 0, '', NULL, NULL, NULL),
(64897, '2018-03-04 13:42:45', NULL, NULL, 17149, 0, 208, 'D0001', 'RM5 DISCOUNT ', '', 'DISCOUNT ', '0', 1, -5.00, -5.0000, 0.0000, -5.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 13:42:45', 'admin-1520125217-15201421650609994', 1, 0, '', NULL, NULL, NULL),
(64898, '2018-03-04 14:04:11', NULL, NULL, 17152, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:04:11', 'admin-1520125217-15201434512199716', 1, 0, '', 1, NULL, NULL),
(64899, '2018-03-04 14:04:11', NULL, NULL, 17152, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:04:11', 'admin-1520125217-15201434512199716', 1, 0, '', 1, NULL, NULL),
(64900, '2018-03-04 14:04:11', NULL, NULL, 17152, 0, 305, '241', 'Sprite', '', 'Cold Drinks', 'Soda & Beer', 1, 5.00, 5.0000, 0.0000, 5.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:04:11', 'admin-1520125217-15201434512199716', 1, 0, '', 1, NULL, NULL),
(64901, '2018-03-04 14:04:11', NULL, NULL, 17152, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:04:11', 'admin-1520125217-15201434512199716', 1, 0, '', 1, NULL, NULL),
(64902, '2018-03-04 14:07:46', NULL, NULL, 17153, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.90, 0.0000, 0.0000, 8.90, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:07:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64903, '2018-03-04 14:08:17', NULL, NULL, 17153, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:08:17', 'admin-1520125217-15201436977655586', 1, 1, 'SR', NULL, NULL, NULL),
(64904, '2018-03-04 14:08:17', NULL, NULL, 17153, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:08:17', 'admin-1520125217-15201436977655586', 1, 0, '', NULL, NULL, NULL),
(64905, '2018-03-04 14:08:17', NULL, NULL, 17153, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:08:17', 'admin-1520125217-15201436977655586', 1, 0, '', NULL, NULL, NULL),
(64906, '2018-03-04 14:08:17', NULL, NULL, 17153, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:08:17', 'admin-1520125217-15201436977655586', 1, 1, 'SR', NULL, NULL, NULL),
(64907, '2018-03-04 14:08:17', NULL, NULL, 17153, 0, 298, '234', 'Salted Caramel Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:08:17', 'admin-1520125217-15201436977655586', 1, 0, '', NULL, NULL, NULL),
(64908, '2018-03-04 14:08:28', NULL, NULL, 17154, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:08:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64909, '2018-03-04 14:08:57', NULL, NULL, 17154, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:08:57', 'admin-1520125217-15201437370817280', 1, 0, '', NULL, NULL, NULL),
(64910, '2018-03-04 14:08:57', NULL, NULL, 17154, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:08:57', 'admin-1520125217-15201437370817280', 1, 0, '', NULL, NULL, NULL),
(64911, '2018-03-04 14:08:57', NULL, NULL, 17154, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:08:57', 'admin-1520125217-15201437370817280', 1, 1, 'SR', NULL, NULL, NULL),
(64912, '2018-03-04 14:08:57', NULL, NULL, 17154, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:08:57', 'admin-1520125217-15201437370817280', 1, 1, 'SR', NULL, NULL, NULL),
(64913, '2018-03-04 14:17:40', NULL, NULL, 17155, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:17:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64914, '2018-03-04 14:17:54', NULL, NULL, 17155, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:17:54', 'admin-1520125217-15201442740692486', 1, 1, 'SR', NULL, NULL, NULL),
(64915, '2018-03-04 14:17:54', NULL, NULL, 17155, 0, 288, '222', 'Smoked Duck Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:17:54', 'admin-1520125217-15201442740692486', 1, 0, '', NULL, NULL, NULL),
(64916, '2018-03-04 14:17:54', NULL, NULL, 17155, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:17:54', 'admin-1520125217-15201442740692486', 1, 0, '', NULL, NULL, NULL),
(64917, '2018-03-04 14:33:05', NULL, NULL, 17156, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.80, 0.0000, 0.0000, 3.80, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:33:05', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64918, '2018-03-04 14:33:28', NULL, NULL, 17156, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:33:28', 'admin-1520125217-15201452080647291', 1, 1, 'SR', NULL, NULL, NULL),
(64919, '2018-03-04 14:33:28', NULL, NULL, 17156, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:33:28', 'admin-1520125217-15201452080647291', 1, 0, '', NULL, NULL, NULL),
(64920, '2018-03-04 14:34:35', NULL, NULL, 17153, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 14:34:35', 'admin-1520125217-15201452753733577', 1, 0, '', NULL, NULL, NULL),
(64921, '2018-03-04 16:39:30', NULL, NULL, 17158, 0, 326, '262', 'Strawberry Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 16:39:30', 'admin-1520125217-15201527698933846', 1, 0, '', NULL, NULL, NULL),
(64922, '2018-03-04 16:39:30', NULL, NULL, 17158, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 16:39:30', 'admin-1520125217-15201527698933846', 1, 1, 'SR', NULL, NULL, NULL),
(64923, '2018-03-04 16:46:04', NULL, NULL, 17157, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1520385034', 'admin', '2018-03-04 16:46:04', 'admin-1520125217-1520153164060227', 1, 1, 'SR', NULL, NULL, NULL),
(64924, '2018-03-05 09:00:18', NULL, NULL, 17159, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1520385034', 'admin', '2018-03-05 09:00:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64925, '2018-03-05 09:00:42', NULL, NULL, 17159, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 09:00:42', 'admin-1520211607-15202116423851460', 1, 1, 'SR', NULL, NULL, NULL),
(64926, '2018-03-05 09:53:50', NULL, NULL, 17159, 0, 181, '116', 'Open Food ', 'junior BLT', 'Meals', 'Perfect Meals', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 09:53:50', 'admin-1520211607-15202148305755731', 1, 0, '', NULL, NULL, NULL),
(64927, '2018-03-05 09:03:31', NULL, NULL, 17160, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.60, 0.0000, 0.0000, 6.60, 1, '27', 1, '1520385034', 'admin', '2018-03-05 09:03:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64928, '2018-03-05 09:03:51', NULL, NULL, 17160, 0, 334, '270', 'Honey Latte', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 09:03:51', 'admin-1520211607-15202118309839434', 1, 0, '', NULL, NULL, NULL),
(64929, '2018-03-05 09:03:51', NULL, NULL, 17160, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 09:03:51', 'admin-1520211607-15202118309839434', 1, 1, 'SR', NULL, NULL, NULL),
(64930, '2018-03-05 09:03:51', NULL, NULL, 17160, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 09:03:51', 'admin-1520211607-15202118309839434', 1, 0, '', NULL, NULL, NULL),
(64931, '2018-03-05 09:03:51', NULL, NULL, 17160, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 09:03:51', 'admin-1520211607-15202118309839434', 1, 0, '', NULL, NULL, NULL),
(64932, '2018-03-05 09:21:13', NULL, NULL, 17161, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1520385034', 'admin', '2018-03-05 09:21:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64933, '2018-03-05 09:21:23', NULL, NULL, 17161, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 09:21:23', 'admin-1520211607-15202128838432119', 1, 0, '', NULL, NULL, NULL),
(64934, '2018-03-05 09:21:23', NULL, NULL, 17161, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 09:21:23', 'admin-1520211607-15202128838432119', 1, 0, '', NULL, NULL, NULL),
(64935, '2018-03-05 09:21:23', NULL, NULL, 17161, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 2, 8.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 09:21:23', 'admin-1520211607-15202128838432119', 1, 1, 'SR', NULL, NULL, NULL),
(64936, '2018-03-05 09:28:01', NULL, NULL, 17161, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 09:28:01', 'admin-1520211607-15202132809009262', 1, 0, '', NULL, NULL, NULL),
(64937, '2018-03-05 09:28:48', NULL, NULL, 17162, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1520385034', 'admin', '2018-03-05 09:28:48', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64938, '2018-03-05 09:28:56', NULL, NULL, 17162, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 09:28:56', 'admin-1520211607-15202133364696431', 1, 0, '', NULL, NULL, NULL),
(64939, '2018-03-05 09:28:56', NULL, NULL, 17162, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 09:28:56', 'admin-1520211607-15202133364696431', 1, 1, 'SR', NULL, NULL, NULL),
(64940, '2018-03-05 09:51:31', NULL, NULL, 17163, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.19, 0.0000, 0.0000, 1.19, 1, '27', 1, '1520385034', 'admin', '2018-03-05 09:51:31', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64941, '2018-03-05 09:51:49', NULL, NULL, 17163, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 09:51:49', 'admin-1520211607-15202147092083781', 1, 1, 'SR', NULL, NULL, NULL),
(64942, '2018-03-05 09:51:49', NULL, NULL, 17163, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1520385034', 'admin', '2018-03-05 09:51:49', 'admin-1520211607-15202147092083781', 1, 0, '', NULL, NULL, NULL),
(64943, '2018-03-05 10:04:35', NULL, NULL, 17161, 0, 172, '106', 'Daily Berries ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 10:04:35', 'admin-1520211607-15202154754484337', 1, 0, '', NULL, NULL, NULL),
(64944, '2018-03-05 10:05:43', NULL, NULL, 17164, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 10:05:43', 'admin-1520211607-15202155432641940', 1, 0, '', 1, NULL, NULL),
(64945, '2018-03-05 11:18:35', NULL, NULL, 17165, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1520385034', 'admin', '2018-03-05 11:18:35', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64946, '2018-03-05 11:18:42', NULL, NULL, 17165, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 11:18:42', 'admin-1520211607-15202199227495287', 1, 0, '', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(64947, '2018-03-05 11:18:42', NULL, NULL, 17165, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 11:18:42', 'admin-1520211607-15202199227495287', 1, 0, '', NULL, NULL, NULL),
(64948, '2018-03-05 11:21:11', NULL, NULL, 17165, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 11:21:11', 'admin-1520211607-1520220071519174', 1, 0, '', NULL, NULL, NULL),
(64949, '2018-03-05 11:21:11', NULL, NULL, 17165, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 11:21:11', 'admin-1520211607-1520220071519174', 1, 0, '', NULL, NULL, NULL),
(64950, '2018-03-05 11:21:59', NULL, NULL, 17166, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.80, 0.0000, 0.0000, 4.80, 1, '27', 1, '1520385034', 'admin', '2018-03-05 11:21:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64951, '2018-03-05 11:22:19', NULL, NULL, 17166, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 11:22:19', 'admin-1520211607-1520220139202544', 1, 0, '', NULL, NULL, NULL),
(64952, '2018-03-05 11:22:19', NULL, NULL, 17166, 0, 30, '30', 'Iced Chai Latte', '', 'Cold Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 11:22:19', 'admin-1520211607-1520220139202544', 1, 1, 'SR', NULL, NULL, NULL),
(64953, '2018-03-05 11:23:35', NULL, NULL, 17166, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 11:23:35', 'admin-1520211607-15202202153029841', 1, 1, 'SR', NULL, NULL, NULL),
(64954, '2018-03-05 11:23:35', NULL, NULL, 17166, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 11:23:35', 'admin-1520211607-15202202153029841', 1, 0, '', NULL, NULL, NULL),
(64955, '2018-03-05 11:43:39', NULL, NULL, 17167, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.70, 0.0000, 0.0000, 3.70, 1, '27', 1, '1520385034', 'admin', '2018-03-05 11:43:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64956, '2018-03-05 11:45:13', NULL, NULL, 17167, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 11:45:13', 'admin-1520211607-1520221513339761', 1, 0, '', NULL, NULL, NULL),
(64957, '2018-03-05 11:45:13', NULL, NULL, 17167, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 11:45:13', 'admin-1520211607-1520221513339761', 1, 0, '', NULL, NULL, NULL),
(64958, '2018-03-05 11:54:32', NULL, NULL, 17165, NULL, 66, '66', 'Watermelon ', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 11:54:32', 'admin-1520211607-15202220721542916', 1, 1, 'SR', NULL, NULL, NULL),
(64959, '2018-03-05 11:58:59', NULL, NULL, 17168, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.50, 0.0000, 0.0000, 5.50, 1, '27', 1, '1520385034', 'admin', '2018-03-05 11:58:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64960, '2018-03-05 11:55:57', NULL, NULL, 17165, 0, 40, '40', 'Banana Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 11:55:57', 'admin-1520211607-15202221577217344', 1, 1, 'SR', NULL, NULL, NULL),
(64961, '2018-03-05 11:59:18', NULL, NULL, 17168, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 11:59:18', 'admin-1520211607-1520222358875836', 1, 0, '', NULL, NULL, NULL),
(64962, '2018-03-05 11:59:18', NULL, NULL, 17168, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 11:59:18', 'admin-1520211607-1520222358875836', 1, 0, '', NULL, NULL, NULL),
(64963, '2018-03-05 12:04:05', NULL, NULL, 17168, 0, 80, '80', 'Oriental Chicken Salad', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:04:05', 'admin-1520211607-1520222645072228', 1, 1, 'SR', NULL, NULL, NULL),
(64964, '2018-03-05 12:03:19', NULL, NULL, 17169, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.19, 0.0000, 0.0000, 4.19, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:03:19', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64965, '2018-03-05 12:03:28', NULL, NULL, 17169, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:03:28', 'admin-1520211607-15202226082906118', 1, 1, 'SR', NULL, NULL, NULL),
(64966, '2018-03-05 12:03:28', NULL, NULL, 17169, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:03:28', 'admin-1520211607-15202226082906118', 1, 1, 'SR', NULL, NULL, NULL),
(64967, '2018-03-05 12:06:30', NULL, NULL, 17170, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.10, 0.0000, 0.0000, 7.10, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:06:30', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64968, '2018-03-05 12:06:44', NULL, NULL, 17171, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:06:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64969, '2018-03-05 12:06:51', NULL, NULL, 17171, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:06:51', 'admin-1520211607-15202228115425688', 1, 1, 'SR', NULL, NULL, NULL),
(64970, '2018-03-05 12:07:22', NULL, NULL, 17170, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:07:22', 'admin-1520211607-1520222842299204', 1, 0, '', NULL, NULL, NULL),
(64971, '2018-03-05 12:07:22', NULL, NULL, 17170, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:07:22', 'admin-1520211607-1520222842299204', 1, 0, '', NULL, NULL, NULL),
(64972, '2018-03-05 12:07:22', NULL, NULL, 17170, 0, 27, '27', 'Iced Chocolate ', '', 'Cold Drinks', 'Non Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:07:22', 'admin-1520211607-1520222842299204', 1, 0, '', NULL, NULL, NULL),
(64973, '2018-03-05 12:07:56', NULL, NULL, 17170, 0, 181, '116', 'Open Food ', 'tomyum', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:07:56', 'admin-1520211607-15202228761858762', 1, 0, '', NULL, NULL, NULL),
(64974, '2018-03-05 12:27:12', NULL, NULL, 17174, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.50, 0.0000, 0.0000, 1.50, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:27:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64975, '2018-03-05 00:00:00', NULL, NULL, 17174, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, NULL, NULL, 6.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:08:22', 'admin-1520211607-1520222902439685', 1, 1, 'SR', NULL, NULL, NULL),
(64976, '2018-03-05 12:08:26', NULL, NULL, 17172, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:08:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64977, '2018-03-05 12:08:35', NULL, NULL, 17172, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:08:35', 'admin-1520211607-15202229151399353', 1, 1, 'SR', NULL, NULL, NULL),
(64978, '2018-03-05 12:08:35', NULL, NULL, 17172, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:08:35', 'admin-1520211607-15202229151399353', 1, 0, '', NULL, NULL, NULL),
(64979, '2018-03-05 12:21:50', NULL, NULL, 17173, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.60, 0.0000, 0.0000, 3.60, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:21:50', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64980, '2018-03-05 12:22:16', NULL, NULL, 17173, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:22:16', 'admin-1520211607-15202237366369842', 1, 0, '', NULL, NULL, NULL),
(64981, '2018-03-05 12:22:16', NULL, NULL, 17173, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:22:16', 'admin-1520211607-15202237366369842', 1, 1, 'SR', NULL, NULL, NULL),
(64982, '2018-03-05 12:22:16', NULL, NULL, 17173, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:22:16', 'admin-1520211607-15202237366369842', 1, 1, 'SR', NULL, NULL, NULL),
(64983, '2018-03-05 12:24:44', NULL, NULL, 17169, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:24:44', 'admin-1520211607-15202238848101526', 1, 1, 'SR', NULL, NULL, NULL),
(64984, '2018-03-05 00:00:00', NULL, NULL, 17174, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, NULL, NULL, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:08:22', 'admin-1520211607-1520222902439685', 1, 1, 'SR', NULL, NULL, NULL),
(64985, '2018-03-05 12:32:14', NULL, NULL, 17169, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:32:14', 'admin-1520211607-15202243345833991', 1, 0, '', NULL, NULL, NULL),
(64986, '2018-03-05 12:37:59', NULL, NULL, 17175, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.20, 0.0000, 0.0000, 9.20, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:37:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64987, '2018-03-05 12:38:24', NULL, NULL, 17175, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:38:24', 'admin-1520211607-15202247041608660', 1, 0, '', NULL, NULL, NULL),
(64988, '2018-03-05 12:38:24', NULL, NULL, 17175, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:38:24', 'admin-1520211607-15202247041608660', 1, 0, '', NULL, NULL, NULL),
(64989, '2018-03-05 12:38:24', NULL, NULL, 17175, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:38:24', 'admin-1520211607-15202247041608660', 1, 0, '', NULL, NULL, NULL),
(64990, '2018-03-05 12:38:24', NULL, NULL, 17175, 0, 16, '16', 'Iced Mocha ', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:38:24', 'admin-1520211607-15202247041608660', 1, 1, 'SR', NULL, NULL, NULL),
(64991, '2018-03-05 12:38:24', NULL, NULL, 17175, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:38:24', 'admin-1520211607-15202247041608660', 1, 1, 'SR', NULL, NULL, NULL),
(64992, '2018-03-05 12:38:24', NULL, NULL, 17175, 0, 247, '181', 'Caramel Chocolate Cheese', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:38:24', 'admin-1520211607-15202247041608660', 1, 0, '', NULL, NULL, NULL),
(64993, '2018-03-05 12:44:20', NULL, NULL, 17176, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:44:20', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64994, '2018-03-05 12:44:31', NULL, NULL, 17176, 0, 181, '116', 'Open Food ', 'tomyam', 'Meals', 'Perfect Meals', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:44:31', 'admin-1520211607-15202250715687374', 1, 0, '', NULL, NULL, NULL),
(64995, '2018-03-05 12:48:52', NULL, NULL, 17177, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.90, 0.0000, 0.0000, 4.90, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:48:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(64996, '2018-03-05 12:49:08', NULL, NULL, 17177, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:49:08', 'admin-1520211607-15202253485463413', 1, 0, '', NULL, NULL, NULL),
(64997, '2018-03-05 12:49:08', NULL, NULL, 17177, 0, 225, '159', 'Smoked Duck Salad', '', 'Meals', 'Salad', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:49:08', 'admin-1520211607-15202253485463413', 1, 0, '', NULL, NULL, NULL),
(64998, '2018-03-05 12:49:08', NULL, NULL, 17177, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:49:08', 'admin-1520211607-15202253485463413', 1, 1, 'SR', NULL, NULL, NULL),
(64999, '2018-03-05 12:59:13', NULL, NULL, 17178, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:59:13', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65000, '2018-03-05 12:59:20', NULL, NULL, 17178, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:59:20', 'admin-1520211607-15202259607978267', 1, 1, 'SR', NULL, NULL, NULL),
(65001, '2018-03-05 12:59:20', NULL, NULL, 17178, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 12:59:20', 'admin-1520211607-15202259607978267', 1, 1, 'SR', NULL, NULL, NULL),
(65002, '2018-03-05 13:07:01', NULL, NULL, 17179, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.40, 0.0000, 0.0000, 4.40, 1, '27', 1, '1520385034', 'admin', '2018-03-05 13:07:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65003, '2018-03-05 13:07:23', NULL, NULL, 17179, 0, 181, '116', 'Open Food ', 'tomyam', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 13:07:23', 'admin-1520211607-1520226443276253', 1, 0, '', NULL, NULL, NULL),
(65004, '2018-03-05 13:07:23', NULL, NULL, 17179, 0, 181, '116', 'Open Food ', 'tomyam', 'Meals', 'Perfect Meals', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 13:07:23', 'admin-1520211607-1520226443276253', 1, 0, '', NULL, NULL, NULL),
(65005, '2018-03-05 13:07:23', NULL, NULL, 17179, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 13:07:23', 'admin-1520211607-1520226443276253', 1, 1, 'SR', NULL, NULL, NULL),
(65006, '2018-03-05 13:07:23', NULL, NULL, 17179, 0, 14, '14', 'Iced Cappucino ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 13:07:23', 'admin-1520211607-1520226443276253', 1, 1, 'SR', NULL, NULL, NULL),
(65007, '2018-03-05 13:10:26', NULL, NULL, 17180, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1520385034', 'admin', '2018-03-05 13:10:26', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65008, '2018-03-05 13:10:30', NULL, NULL, 17180, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 13:10:30', 'admin-1520211607-1520226630785449', 1, 1, 'SR', NULL, NULL, NULL),
(65009, '2018-03-05 13:13:44', NULL, NULL, 17181, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1520385034', 'admin', '2018-03-05 13:13:44', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65010, '2018-03-05 13:13:54', NULL, NULL, 17181, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 2, 12.00, 24.0000, 0.0000, 24.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 13:13:54', 'admin-1520211607-15202268348583616', 1, 1, 'SR', NULL, NULL, NULL),
(65011, '2018-03-05 13:19:08', NULL, NULL, 17176, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 13:19:08', 'admin-1520211607-15202271478868336', 1, 1, 'SR', NULL, NULL, NULL),
(65012, '2018-03-05 13:19:08', NULL, NULL, 17176, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 13:19:08', 'admin-1520211607-15202271478868336', 1, 0, '', NULL, NULL, NULL),
(65013, '2018-03-05 13:19:15', NULL, NULL, 17182, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.30, 0.0000, 0.0000, 7.30, 1, '27', 1, '1520385034', 'admin', '2018-03-05 13:19:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65014, '2018-03-05 13:19:47', NULL, NULL, 17182, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 13:19:47', 'admin-1520211607-15202271872378150', 1, 0, '', NULL, NULL, NULL),
(65015, '2018-03-05 13:19:47', NULL, NULL, 17182, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 13:19:47', 'admin-1520211607-15202271872378150', 1, 0, '', NULL, NULL, NULL),
(65016, '2018-03-05 13:19:47', NULL, NULL, 17182, 0, 79, '79', 'Summer Salad ', '', 'Meals', 'Salad', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 13:19:47', 'admin-1520211607-15202271872378150', 1, 1, 'SR', NULL, NULL, NULL),
(65017, '2018-03-05 13:19:47', NULL, NULL, 17182, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 13:19:47', 'admin-1520211607-15202271872378150', 1, 1, 'SR', NULL, NULL, NULL),
(65018, '2018-03-05 13:19:47', NULL, NULL, 17182, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 13:19:47', 'admin-1520211607-15202271872378150', 1, 0, '', NULL, NULL, NULL),
(65019, '2018-03-05 13:52:53', NULL, NULL, 17183, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, '1520385034', 'admin', '2018-03-05 13:52:53', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65020, '2018-03-05 13:53:00', NULL, NULL, 17183, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 13:53:00', 'admin-1520211607-15202291806703761', 1, 1, 'SR', NULL, NULL, NULL),
(65021, '2018-03-05 13:53:00', NULL, NULL, 17183, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 13:53:00', 'admin-1520211607-15202291806703761', 1, 1, 'SR', NULL, NULL, NULL),
(65022, '2018-03-05 14:02:59', NULL, NULL, 17184, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 14:02:59', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65023, '2018-03-05 14:03:05', NULL, NULL, 17184, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 14:03:05', 'admin-1520211607-15202297854201914', 1, 1, 'SR', NULL, NULL, NULL),
(65024, '2018-03-05 14:03:05', NULL, NULL, 17184, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 14:03:05', 'admin-1520211607-15202297854201914', 1, 1, 'SR', NULL, NULL, NULL),
(65025, '2018-03-05 14:44:52', NULL, NULL, 17185, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, '1520385034', 'admin', '2018-03-05 14:44:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65026, '2018-03-05 14:44:59', NULL, NULL, 17185, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 14:44:59', 'admin-1520211607-15202322994987698', 1, 0, '', NULL, NULL, NULL),
(65027, '2018-03-05 14:45:47', NULL, NULL, 17185, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 14:45:47', 'admin-1520211607-15202323471701790', 1, 0, '', NULL, NULL, NULL),
(65028, '2018-03-05 15:32:51', NULL, NULL, 17186, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1520385034', 'admin', '2018-03-05 15:32:51', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65029, '2018-03-05 15:32:57', NULL, NULL, 17186, 0, 33, '33', 'Cucumber Lime ', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-05 15:32:57', 'admin-1520211607-15202351769149187', 1, 1, 'SR', NULL, NULL, NULL),
(65030, '2018-03-07 09:18:58', NULL, NULL, 17187, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.20, 0.0000, 0.0000, 6.20, 1, '27', 1, '1520385034', 'admin', '2018-03-07 09:18:58', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65031, '2018-03-07 09:19:14', NULL, NULL, 17187, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 09:19:14', 'admin-1520385034-15203855539064145', 1, 0, '', NULL, NULL, NULL),
(65032, '2018-03-07 09:19:14', NULL, NULL, 17187, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 09:19:14', 'admin-1520385034-15203855539064145', 1, 0, '', NULL, NULL, NULL),
(65033, '2018-03-07 09:19:14', NULL, NULL, 17187, NULL, 8, '8', 'Caramel Macchiato ', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 09:19:14', 'admin-1520385034-15203855539064145', 1, 1, 'SR', NULL, NULL, NULL),
(65034, '2018-03-07 09:19:14', NULL, NULL, 17187, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 09:19:14', 'admin-1520385034-15203855539064145', 1, 1, 'SR', NULL, NULL, NULL),
(65035, '2018-03-07 09:36:29', NULL, NULL, 17188, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1520385034', 'admin', '2018-03-07 09:36:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65036, '2018-03-07 09:36:37', NULL, NULL, 17188, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 09:36:37', 'admin-1520385034-15203865976694179', 1, 1, 'SR', NULL, NULL, NULL),
(65037, '2018-03-07 09:43:29', NULL, NULL, 17189, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1520385034', 'admin', '2018-03-07 09:43:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65038, '2018-03-07 09:47:33', NULL, NULL, 17189, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 09:47:33', 'admin-1520385034-15203872537734465', 1, 0, '', NULL, NULL, NULL),
(65039, '2018-03-07 09:47:33', NULL, NULL, 17189, 0, 154, '88', 'Daily Dose BLT', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 09:47:33', 'admin-1520385034-15203872537734465', 1, 0, '', NULL, NULL, NULL),
(65040, '2018-03-07 09:47:33', NULL, NULL, 17189, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 09:47:33', 'admin-1520385034-15203872537734465', 1, 1, 'SR', NULL, NULL, NULL),
(65041, '2018-03-07 09:55:09', NULL, NULL, 17190, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.30, 0.0000, 0.0000, 2.30, 1, '27', 1, '1520385034', 'admin', '2018-03-07 09:55:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65042, '2018-03-07 09:57:14', NULL, NULL, 17190, 0, 157, '91', 'Classic French Toast', '', 'Meals', 'Morning Bites ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 09:57:14', 'admin-1520385034-15203878340851847', 1, 0, '', NULL, NULL, NULL),
(65043, '2018-03-07 09:57:14', NULL, NULL, 17190, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 09:57:14', 'admin-1520385034-15203878340851847', 1, 1, 'SR', NULL, NULL, NULL),
(65044, '2018-03-07 11:11:06', NULL, NULL, 17191, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, '1520385034', 'admin', '2018-03-07 11:11:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65045, '2018-03-07 11:11:56', NULL, NULL, 17191, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 11:11:56', 'admin-1520385034-15203923167005269', 1, 0, '', NULL, NULL, NULL),
(65046, '2018-03-07 11:11:56', NULL, NULL, 17191, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 11:11:56', 'admin-1520385034-15203923167005269', 1, 0, '', NULL, NULL, NULL),
(65047, '2018-03-07 11:11:56', NULL, NULL, 17191, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 11:11:56', 'admin-1520385034-15203923167005269', 1, 1, 'SR', NULL, NULL, NULL),
(65048, '2018-03-07 11:11:56', NULL, NULL, 17191, 0, 338, '274', 'Chocolate Banana Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 11:11:56', 'admin-1520385034-15203923167005269', 1, 0, '', NULL, NULL, NULL),
(65049, '2018-03-07 11:29:03', NULL, NULL, 17192, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.70, 0.0000, 0.0000, 6.70, 1, '27', 1, '1520385034', 'admin', '2018-03-07 11:29:03', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65050, '2018-03-07 11:29:07', NULL, NULL, 17192, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 11:29:07', 'admin-1520385034-15203933471929013', 1, 1, 'SR', NULL, NULL, NULL),
(65051, '2018-03-07 11:54:57', NULL, NULL, 17192, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 11:54:57', 'admin-1520385034-15203948970173852', 1, 1, 'SR', NULL, NULL, NULL),
(65052, '2018-03-07 11:41:18', NULL, NULL, 17193, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.35, 0.0000, 0.0000, 1.35, 1, '27', 1, '1520385034', 'admin', '2018-03-07 11:41:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65053, '2018-03-07 11:41:55', NULL, NULL, 17193, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 11:41:55', 'admin-1520385034-15203941148682251', 1, 1, 'SR', NULL, NULL, NULL),
(65054, '2018-03-07 11:41:55', NULL, NULL, 17193, 0, 278, '212', 'Espresso Shot', '', 'Hot Drinks', 'Coffee', 1, 1.50, 1.5000, 0.0000, 1.50, 1, '27', 1, '1520385034', 'admin', '2018-03-07 11:41:55', 'admin-1520385034-15203941148682251', 1, 0, '', NULL, NULL, NULL),
(65055, '2018-03-07 11:53:40', NULL, NULL, 17194, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.60, 0.0000, 0.0000, 2.60, 1, '27', 1, '1520385034', 'admin', '2018-03-07 11:53:40', '0', 1, 1, 'SR', NULL, NULL, '10.0'),
(65056, '2018-03-07 11:54:12', NULL, NULL, 17194, 0, 181, '116', 'Open Food ', 'BBQ rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 11:54:12', 'admin-1520385034-15203948523356878', 1, 0, '', NULL, NULL, '10.0'),
(65057, '2018-03-07 11:54:57', NULL, NULL, 17192, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 11:54:57', 'admin-1520385034-15203948970173852', 1, 1, 'SR', NULL, NULL, NULL),
(65058, '2018-03-07 11:54:57', NULL, NULL, 17192, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 11:54:57', 'admin-1520385034-15203948970173852', 1, 1, 'SR', NULL, NULL, NULL),
(65059, '2018-03-07 12:02:48', NULL, NULL, 17194, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:02:48', 'admin-1520385034-15203953681342694', 1, 1, 'SR', NULL, NULL, '10.0'),
(65060, '2018-03-07 12:14:47', NULL, NULL, 17195, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.60, 0.0000, 0.0000, 7.60, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:14:47', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65061, '2018-03-07 12:15:51', NULL, NULL, 17195, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:15:51', 'admin-1520385034-1520396151342529', 1, 1, 'SR', NULL, NULL, NULL),
(65062, '2018-03-07 12:15:51', NULL, NULL, 17195, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:15:51', 'admin-1520385034-1520396151342529', 1, 0, '', NULL, NULL, NULL),
(65063, '2018-03-07 12:15:51', NULL, NULL, 17195, 0, 323, '259', 'Ginger Cucumber Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:15:51', 'admin-1520385034-1520396151342529', 1, 0, '', NULL, NULL, NULL),
(65064, '2018-03-07 12:15:51', NULL, NULL, 17195, 0, 181, '116', 'Open Food ', 'bbq', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:15:51', 'admin-1520385034-1520396151342529', 1, 0, '', NULL, NULL, NULL),
(65065, '2018-03-07 12:15:51', NULL, NULL, 17195, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:15:51', 'admin-1520385034-1520396151342529', 1, 0, '', NULL, NULL, NULL),
(65066, '2018-03-07 12:19:17', NULL, NULL, 17196, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.40, 0.0000, 0.0000, 6.40, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:19:17', '0', 1, 1, 'SR', NULL, NULL, '25.0'),
(65067, '2018-03-07 12:19:47', NULL, NULL, 17196, 0, 220, '154', 'Pork Bacon Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:19:47', 'admin-1520385034-15203963871469597', 1, 0, '', NULL, NULL, '25.0'),
(65068, '2018-03-07 12:19:47', NULL, NULL, 17196, 0, 181, '116', 'Open Food ', 'BBQ rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:19:47', 'admin-1520385034-15203963871469597', 1, 0, '', NULL, NULL, '25.0'),
(65069, '2018-03-07 12:19:47', NULL, NULL, 17196, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:19:47', 'admin-1520385034-15203963871469597', 1, 0, '', NULL, NULL, '25.0'),
(65070, '2018-03-07 12:19:47', NULL, NULL, 17196, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:19:47', 'admin-1520385034-15203963871469597', 1, 1, 'SR', NULL, NULL, '25.0'),
(65071, '2018-03-07 12:29:01', NULL, NULL, 17197, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.50, 0.0000, 0.0000, 6.50, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:29:01', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65072, '2018-03-07 12:29:16', NULL, NULL, 17197, 0, 181, '116', 'Open Food ', 'BBQ rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:29:16', 'admin-1520385034-15203969566021115', 1, 0, '', NULL, NULL, NULL),
(65073, '2018-03-07 12:29:16', NULL, NULL, 17197, 0, 181, '116', 'Open Food ', 'BBQ rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:29:16', 'admin-1520385034-15203969566021115', 1, 0, '', NULL, NULL, NULL),
(65074, '2018-03-07 12:29:16', NULL, NULL, 17197, 0, 181, '116', 'Open Food ', 'BBQ rice', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:29:16', 'admin-1520385034-15203969566021115', 1, 0, '', NULL, NULL, NULL),
(65075, '2018-03-07 12:29:28', NULL, NULL, 17198, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.40, 0.0000, 0.0000, 2.40, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:29:28', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65076, '2018-03-07 12:29:38', NULL, NULL, 17198, 0, 77, '77', 'Sarawak Kolomee', '', 'Meals', 'Non-Rice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:29:38', 'admin-1520385034-15203969787875216', 1, 1, 'SR', NULL, NULL, NULL),
(65077, '2018-03-07 12:30:17', NULL, NULL, 17198, 0, 61, '61', 'Slim Fit', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:30:17', 'admin-1520385034-15203970177771022', 1, 1, 'SR', NULL, NULL, NULL),
(65078, '2018-03-07 12:30:37', NULL, NULL, 17197, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:30:37', 'admin-1520385034-15203970369025977', 1, 1, 'SR', NULL, NULL, NULL),
(65079, '2018-03-07 12:33:29', NULL, NULL, 17199, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.10, 0.0000, 0.0000, 4.10, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:33:29', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65080, '2018-03-07 12:33:40', NULL, NULL, 17199, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:33:40', 'admin-1520385034-15203972202133462', 1, 0, '', NULL, NULL, NULL),
(65081, '2018-03-07 12:33:40', NULL, NULL, 17199, 0, 221, '155', 'Seasoned Chicken Pesto Pasta', '', 'Meals', 'Non-Rice', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:33:40', 'admin-1520385034-15203972202133462', 1, 0, '', NULL, NULL, NULL),
(65082, '2018-03-07 12:36:18', NULL, NULL, 17200, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.80, 0.0000, 0.0000, 0.80, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:36:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65083, '2018-03-07 12:36:22', NULL, NULL, 17200, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:36:22', 'admin-1520385034-15203973827418946', 1, 1, 'SR', NULL, NULL, NULL),
(65084, '2018-03-07 12:42:57', NULL, NULL, 17201, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.20, 0.0000, 0.0000, 5.20, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:42:57', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65085, '2018-03-07 12:43:51', NULL, NULL, 17201, 0, 76, '76', 'Meatless Pesto Pasta', '', 'Meals', 'Non-Rice', 2, 17.00, 34.0000, 0.0000, 34.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:43:51', 'admin-1520385034-15203978317424827', 1, 1, 'SR', NULL, NULL, NULL),
(65086, '2018-03-07 12:43:51', NULL, NULL, 17201, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 2, 9.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:43:51', 'admin-1520385034-15203978317424827', 1, 1, 'SR', NULL, NULL, NULL),
(65087, '2018-03-07 12:45:15', NULL, NULL, 17196, 0, 183, '118', 'Plain Rice', '', 'Meals', 'Rice', 1, 2.00, 2.0000, 0.0000, 2.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:45:15', 'admin-1520385034-1520397915182832', 1, 0, '', NULL, NULL, '25.0'),
(65088, '2018-03-07 12:58:22', NULL, NULL, 17202, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.80, 0.0000, 0.0000, 1.80, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:58:22', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65089, '2018-03-07 12:58:33', NULL, NULL, 17202, 0, 181, '116', 'Open Food ', 'bbq', 'Meals', 'Perfect Meals', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 12:58:33', 'admin-1520385034-15203987134139944', 1, 0, '', NULL, NULL, NULL),
(65090, '2018-03-07 13:23:06', NULL, NULL, 17203, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, '1520385034', 'admin', '2018-03-07 13:23:06', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65091, '2018-03-07 13:23:23', NULL, NULL, 17203, 0, 271, '205', 'Take It Easy', '', 'Meals', 'Morning Bites ', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 13:23:23', 'admin-1520385034-15204002034442370', 1, 0, '', NULL, NULL, NULL),
(65092, '2018-03-07 13:23:23', NULL, NULL, 17203, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 13:23:23', 'admin-1520385034-15204002034442370', 1, 0, '', NULL, NULL, NULL),
(65093, '2018-03-07 13:23:23', NULL, NULL, 17203, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 13:23:23', 'admin-1520385034-15204002034442370', 1, 1, 'SR', NULL, NULL, NULL),
(65094, '2018-03-07 13:23:23', NULL, NULL, 17203, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 13:23:23', 'admin-1520385034-15204002034442370', 1, 1, 'SR', NULL, NULL, NULL),
(65095, '2018-03-07 13:31:51', NULL, NULL, 17203, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 13:31:51', 'admin-1520385034-15204007115185419', 1, 1, 'SR', NULL, NULL, NULL),
(65096, '2018-03-07 14:43:17', NULL, NULL, 17207, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, '1520385034', 'admin', '2018-03-07 14:43:17', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65097, '2018-03-07 13:59:30', NULL, NULL, 17192, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 13:59:30', 'admin-1520385034-15204023700585280', 1, 0, '', NULL, NULL, NULL),
(65098, '2018-03-07 00:00:00', NULL, NULL, 17209, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 14:36:18', 'admin-1520385034-15204045782173543', 1, 0, '', NULL, NULL, NULL),
(65099, '2018-03-07 00:00:00', NULL, NULL, 17210, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', NULL, 1, 1.70, NULL, NULL, 1.70, 1, '27', 1, '1520385034', 'admin', '2018-03-07 14:36:12', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65100, '2018-03-07 15:19:00', NULL, NULL, 17209, 0, 0, '_SC', 'Service Charge (10%)', '', 'SERVICE CHARGE', 'SERVICE CHARGE', 1, 1.70, 0.0000, 0.0000, 1.70, 1, '27', 1, '1520385034', 'admin', '2018-03-07 15:19:00', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65101, '2018-03-07 14:36:52', NULL, NULL, 17206, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.40, 0.0000, 0.0000, 1.40, 1, '27', 1, '1520385034', 'admin', '2018-03-07 14:36:52', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65102, '2018-03-07 14:36:56', NULL, NULL, 17206, NULL, 10, '10', 'Dirty Chai', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 14:36:56', 'admin-1520385034-15204046159806170', 1, 1, 'SR', NULL, NULL, NULL),
(65103, '2018-03-07 00:00:00', NULL, NULL, 17207, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, NULL, NULL, 21.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 13:41:15', 'admin-1520385034-15204012755605747', 1, 0, '', NULL, NULL, NULL),
(65104, '2018-03-07 14:53:14', NULL, NULL, 17208, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.00, 0.0000, 0.0000, 7.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 14:53:14', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65105, '2018-03-07 14:53:34', NULL, NULL, 17208, 0, 223, '226', 'Smoked Duck Aglio Olio', '', 'Meals', 'Non-Rice', 1, 22.00, 22.0000, 0.0000, 22.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 14:53:34', 'admin-1520385034-1520405614263958', 1, 0, '', NULL, NULL, NULL),
(65106, '2018-03-07 14:53:34', NULL, NULL, 17208, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 14:53:34', 'admin-1520385034-1520405614263958', 1, 0, '', NULL, NULL, NULL),
(65107, '2018-03-07 14:53:34', NULL, NULL, 17208, 0, 20, '20', 'Iced DD Special', '', 'Cold Drinks', 'Coffee', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 14:53:34', 'admin-1520385034-1520405614263958', 1, 0, '', NULL, NULL, NULL),
(65108, '2018-03-07 14:53:55', NULL, NULL, 17208, 0, 32, '32', 'Tea By Pot ', '', 'Hot Drinks', 'Non Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 14:53:55', 'admin-1520385034-15204056351323267', 1, 1, 'SR', NULL, NULL, NULL),
(65109, '2018-03-07 00:00:00', NULL, NULL, 17210, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, NULL, NULL, 17.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 14:36:18', 'admin-1520385034-15204045782173543', 1, 0, '', NULL, NULL, NULL),
(65110, '2018-03-07 15:48:07', NULL, NULL, 17211, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 15:48:07', 'admin-1520385034-15204088872879633', 1, 0, '', 1, NULL, '10.0'),
(65111, '2018-03-07 15:48:07', NULL, NULL, 17211, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 15:48:07', 'admin-1520385034-15204088872879633', 1, 1, 'SR', 1, NULL, '10.0'),
(65112, '2018-03-07 15:48:07', NULL, NULL, 17211, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 15:48:07', 'admin-1520385034-15204088872879633', 1, 1, 'SR', 1, NULL, '10.0'),
(65113, '2018-03-07 15:48:07', NULL, NULL, 17211, 0, 273, '207', 'Single Cookies', '', 'Desserts', '0', 1, 3.90, 3.9000, 0.0000, 3.90, 1, '27', 1, '1520385034', 'admin', '2018-03-07 15:48:07', 'admin-1520385034-15204088872879633', 1, 0, '', 1, NULL, '10.0'),
(65114, '2018-03-07 16:26:21', NULL, NULL, 17212, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, '1520385034', 'admin', '2018-03-07 16:26:21', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65115, '2018-03-07 16:26:25', NULL, NULL, 17212, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 16:26:25', 'admin-1520385034-1520411185319599', 1, 1, 'SR', NULL, NULL, NULL),
(65116, '2018-03-07 16:34:55', NULL, NULL, 17213, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.10, 0.0000, 0.0000, 1.10, 1, '27', 1, '1520385034', 'admin', '2018-03-07 16:34:55', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65117, '2018-03-07 16:34:57', NULL, NULL, 17213, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, '1520385034', 'admin', '2018-03-07 16:34:57', 'admin-1520385034-1520411697843773', 1, 1, 'SR', NULL, NULL, NULL),
(65118, '2018-03-08 15:10:05', NULL, NULL, 17235, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'lois', '2018-03-08 15:10:05', 'lois-1520469288-15204930052579623', 1, 0, '', NULL, NULL, NULL),
(65119, '2018-03-08 15:10:05', NULL, NULL, 17235, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, NULL, 'lois', '2018-03-08 15:10:05', 'lois-1520469288-15204930052579623', 1, 0, '', NULL, NULL, NULL),
(65120, '2018-03-08 15:09:46', NULL, NULL, 17235, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.20, 0.0000, 0.0000, 3.20, 1, '27', 1, NULL, 'lois', '2018-03-08 15:09:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65121, '2018-03-08 14:52:19', NULL, NULL, 17234, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'lois', '2018-03-08 14:52:19', 'lois-1520469288-1520491938979808', 1, 1, 'SR', NULL, NULL, NULL),
(65122, '2018-03-08 14:52:19', NULL, NULL, 17234, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, NULL, 'lois', '2018-03-08 14:52:19', 'lois-1520469288-1520491938979808', 1, 0, '', NULL, NULL, NULL),
(65123, '2018-03-08 14:52:19', NULL, NULL, 17234, 0, 253, '187', 'Cheese Baked Nachos', '', 'Meals', 'Snacks ', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, NULL, 'lois', '2018-03-08 14:52:19', 'lois-1520469288-1520491938979808', 1, 0, '', NULL, NULL, NULL),
(65124, '2018-03-08 14:52:19', NULL, NULL, 17234, 0, 181, '116', 'Open Food ', 'leek rice', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, NULL, 'lois', '2018-03-08 14:52:19', 'lois-1520469288-1520491938979808', 1, 0, '', NULL, NULL, NULL),
(65125, '2018-03-08 14:51:45', NULL, NULL, 17234, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 7.20, 0.0000, 0.0000, 7.20, 1, '27', 1, NULL, 'lois', '2018-03-08 14:51:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65126, '2018-03-08 14:51:15', NULL, NULL, 17233, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, NULL, 'lois', '2018-03-08 14:51:15', 'lois-1520469288-1520491875730669', 1, 1, 'SR', NULL, NULL, NULL),
(65127, '2018-03-08 14:51:15', NULL, NULL, 17233, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, NULL, 'lois', '2018-03-08 14:51:15', 'lois-1520469288-1520491875730669', 1, 0, '', NULL, NULL, NULL),
(65128, '2018-03-08 14:51:15', NULL, NULL, 17233, 0, 181, '116', 'Open Food ', 'meatball pasta', 'Meals', 'Perfect Meals', 1, 23.00, 23.0000, 0.0000, 23.00, 1, '27', 1, NULL, 'lois', '2018-03-08 14:51:15', 'lois-1520469288-1520491875730669', 1, 0, '', NULL, NULL, NULL),
(65129, '2018-03-08 14:51:15', NULL, NULL, 17233, 0, 328, '264', 'Basic Blueberries Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, NULL, 'lois', '2018-03-08 14:51:15', 'lois-1520469288-1520491875730669', 1, 0, '', NULL, NULL, NULL),
(65130, '2018-03-08 14:56:18', NULL, NULL, 17229, 0, 304, '240', 'Banana is On Fire', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'lois', '2018-03-08 14:56:18', 'lois-1520469288-15204921780604868', 1, 0, '', NULL, NULL, NULL),
(65131, '2018-03-08 14:52:19', NULL, NULL, 17234, 0, 181, '116', 'Open Food ', 'leek rice', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, NULL, 'lois', '2018-03-08 14:52:19', 'lois-1520469288-1520491938979808', 1, 0, '', NULL, NULL, NULL),
(65132, '2018-03-08 14:50:18', NULL, NULL, 17233, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.10, 0.0000, 0.0000, 6.10, 1, '27', 1, NULL, 'lois', '2018-03-08 14:50:18', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65133, '2018-03-08 14:42:50', NULL, NULL, 17232, 0, 37, '37', 'Pineapple Orange Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, NULL, 'lois', '2018-03-08 14:42:50', 'lois-1520469288-1520491370611865', 1, 1, 'SR', NULL, NULL, NULL),
(65134, '2018-03-08 14:42:50', NULL, NULL, 17232, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, NULL, 'lois', '2018-03-08 14:42:50', 'lois-1520469288-1520491370611865', 1, 1, 'SR', NULL, NULL, NULL);
INSERT INTO `fnb_sale_items` (`id`, `date`, `ss_terminal`, `ss_code`, `sale_id`, `si_item_id`, `item_id`, `item_sku`, `item_name`, `item_option`, `category`, `subcategory`, `qty`, `price_per_unit`, `margin`, `cost`, `amount`, `sold`, `terminal`, `printed`, `session`, `ordered_by`, `ordered_time`, `serial`, `warehouse_id`, `taxable`, `tax_code`, `instant_sale`, `discount`, `global_discount`) VALUES
(65135, '2018-03-08 14:42:40', NULL, NULL, 17232, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.50, 0.0000, 0.0000, 3.50, 1, '27', 1, NULL, 'lois', '2018-03-08 14:42:40', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65136, '2018-03-08 14:42:50', NULL, NULL, 17232, 0, 329, '265', 'Peanut Butter Toast', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, NULL, 'lois', '2018-03-08 14:42:50', 'lois-1520469288-1520491370611865', 1, 0, '', NULL, NULL, NULL),
(65137, '2018-03-08 14:33:14', NULL, NULL, 17231, NULL, 68, '68', 'Mix 2 types ', '', 'Cold Drinks', 'Fresh Juice', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, NULL, 'lois', '2018-03-08 14:33:14', 'lois-1520469288-15204907948749775', 1, 1, 'SR', NULL, NULL, NULL),
(65138, '2018-03-08 14:33:14', NULL, NULL, 17231, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, NULL, 'lois', '2018-03-08 14:33:14', 'lois-1520469288-15204907948749775', 1, 1, 'SR', NULL, NULL, NULL),
(65139, '2018-03-08 14:33:04', NULL, NULL, 17231, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.10, 0.0000, 0.0000, 2.10, 1, '27', 1, NULL, 'lois', '2018-03-08 14:33:04', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65140, '2018-03-08 14:02:14', NULL, NULL, 17230, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, NULL, 'lois', '2018-03-08 14:02:14', 'lois-1520469288-15204889348192167', 1, 1, 'SR', NULL, NULL, NULL),
(65141, '2018-03-08 14:02:14', NULL, NULL, 17230, NULL, 44, '44', 'Tiger ', '', 'Cold Drinks', 'Soda & Beer', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, NULL, 'lois', '2018-03-08 14:02:14', 'lois-1520469288-15204889348192167', 1, 1, 'SR', NULL, NULL, NULL),
(65142, '2018-03-08 14:02:09', NULL, NULL, 17230, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.00, 0.0000, 0.0000, 2.00, 1, '27', 1, NULL, 'lois', '2018-03-08 14:02:09', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65143, '2018-03-08 13:47:18', NULL, NULL, 17227, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, NULL, 'lois', '2018-03-08 13:47:18', 'lois-1520469288-1520488038814278', 1, 0, '', NULL, NULL, NULL),
(65144, '2018-03-08 13:45:11', NULL, NULL, 17224, 0, 13, '13', 'Iced Americano', '', 'Cold Drinks', 'Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, NULL, 'lois', '2018-03-08 13:45:11', 'lois-1520469288-15204879116066554', 1, 0, '', NULL, NULL, NULL),
(65145, '2018-03-08 13:45:11', NULL, NULL, 17224, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, NULL, 'lois', '2018-03-08 13:45:11', 'lois-1520469288-15204879116066554', 1, 1, 'SR', NULL, NULL, NULL),
(65146, '2018-03-08 13:41:19', NULL, NULL, 17225, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, NULL, 'lois', '2018-03-08 13:41:19', 'lois-1520469288-15204876791074932', 1, 1, 'SR', NULL, NULL, NULL),
(65147, '2018-03-08 13:36:33', NULL, NULL, 17229, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.50, 0.0000, 0.0000, 2.50, 1, '27', 1, NULL, 'lois', '2018-03-08 13:36:33', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65148, '2018-03-08 13:36:37', NULL, NULL, 17229, NULL, 7, '7', 'Mocha ', '', 'Hot Drinks', 'Coffee', 1, 13.00, 13.0000, 0.0000, 13.00, 1, '27', 1, NULL, 'lois', '2018-03-08 13:36:37', 'lois-1520469288-1520487397249902', 1, 1, 'SR', NULL, NULL, NULL),
(65149, '2018-03-08 13:47:18', NULL, NULL, 17227, 0, 277, '211', 'Iced Ginger Lemongrass', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, NULL, 'lois', '2018-03-08 13:47:18', 'lois-1520469288-1520488038814278', 1, 0, '', NULL, NULL, NULL),
(65150, '2018-03-08 13:29:38', NULL, NULL, 17228, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, NULL, 'lois', '2018-03-08 13:29:38', 'lois-1520469288-15204869781637250', 1, 1, 'SR', NULL, NULL, NULL),
(65151, '2018-03-08 13:29:16', NULL, NULL, 17228, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, NULL, 'lois', '2018-03-08 13:29:16', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65152, '2018-03-08 13:28:42', NULL, NULL, 17227, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.00, 0.0000, 0.0000, 5.00, 1, '27', 1, NULL, 'lois', '2018-03-08 13:28:42', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65153, '2018-03-08 13:19:17', NULL, NULL, 17226, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, NULL, 'lois', '2018-03-08 13:19:17', 'lois-1520469288-15204863570358165', 1, 1, 'SR', NULL, NULL, NULL),
(65154, '2018-03-08 13:19:10', NULL, NULL, 17226, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, NULL, 'lois', '2018-03-08 13:19:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65155, '2018-03-08 13:19:17', NULL, NULL, 17226, 0, 3, '3', 'Americano', '', 'Hot Drinks', 'Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, NULL, 'lois', '2018-03-08 13:19:17', 'lois-1520469288-15204863570358165', 1, 1, 'SR', NULL, NULL, NULL),
(65156, '2018-03-08 13:12:21', NULL, NULL, 17225, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'lois', '2018-03-08 13:12:21', 'lois-1520469288-15204859409779649', 1, 0, '', NULL, NULL, NULL),
(65157, '2018-03-08 13:12:21', NULL, NULL, 17225, 0, 293, '229', 'Classic Yogurt Bowl', '', 'Desserts', '0', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, NULL, 'lois', '2018-03-08 13:12:21', 'lois-1520469288-15204859409779649', 1, 0, '', NULL, NULL, NULL),
(65158, '2018-03-08 13:12:10', NULL, NULL, 17225, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 3.90, 0.0000, 0.0000, 3.90, 1, '27', 1, NULL, 'lois', '2018-03-08 13:12:10', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65159, '2018-03-08 13:11:17', NULL, NULL, 17224, 0, 161, '95', 'Signature Dumpling (10 Pcs) ', '', 'Meals', 'Snacks ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, NULL, 'lois', '2018-03-08 13:11:17', 'lois-1520469288-15204858769145174', 1, 0, '', NULL, NULL, NULL),
(65160, '2018-03-08 13:11:17', NULL, NULL, 17224, 0, 181, '116', 'Open Food ', 'leek', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, NULL, 'lois', '2018-03-08 13:11:17', 'lois-1520469288-15204858769145174', 1, 0, '', NULL, NULL, NULL),
(65161, '2018-03-08 13:29:38', NULL, NULL, 17228, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, NULL, 'lois', '2018-03-08 13:29:38', 'lois-1520469288-15204869781637250', 1, 0, '', NULL, NULL, NULL),
(65162, '2018-03-08 13:29:03', NULL, NULL, 17227, 0, 181, '116', 'Open Food ', 'leek rice', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, NULL, 'lois', '2018-03-08 13:29:03', 'lois-1520469288-15204869437008193', 1, 0, '', NULL, NULL, NULL),
(65163, '2018-03-08 13:29:03', NULL, NULL, 17227, 0, 181, '116', 'Open Food ', 'leek rice', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, NULL, 'lois', '2018-03-08 13:29:03', 'lois-1520469288-15204869437008193', 1, 0, '', NULL, NULL, NULL),
(65164, '2018-03-08 12:54:02', NULL, NULL, 17224, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 6.80, 0.0000, 0.0000, 6.80, 1, '27', 1, NULL, 'lois', '2018-03-08 12:54:02', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65165, '2018-03-08 12:37:19', NULL, NULL, 17223, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, NULL, 'lois', '2018-03-08 12:37:19', 'lois-1520469288-15204838391159450', 1, 1, 'SR', NULL, NULL, NULL),
(65166, '2018-03-08 12:37:19', NULL, NULL, 17223, NULL, 6, '6', 'Latte ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, NULL, 'lois', '2018-03-08 12:37:19', 'lois-1520469288-15204838391159450', 1, 1, 'SR', NULL, NULL, NULL),
(65167, '2018-03-08 12:21:18', NULL, NULL, 17222, 0, 267, '201', 'Cocoa Cappucino', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, NULL, 'lois', '2018-03-08 12:21:18', 'lois-1520469288-15204828785809727', 1, 0, '', NULL, NULL, NULL),
(65168, '2018-03-08 12:21:18', NULL, NULL, 17222, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, NULL, 'lois', '2018-03-08 12:21:18', 'lois-1520469288-15204828785809727', 1, 0, '', NULL, NULL, NULL),
(65169, '2018-03-08 12:20:56', NULL, NULL, 17222, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 5.80, 0.0000, 0.0000, 5.80, 1, '27', 1, NULL, 'lois', '2018-03-08 12:20:56', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65170, '2018-03-08 12:19:21', NULL, NULL, 17221, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, NULL, 'lois', '2018-03-08 12:19:21', 'lois-1520469288-152048276121435', 1, 0, '', NULL, NULL, NULL),
(65171, '2018-03-08 12:19:21', NULL, NULL, 17221, 0, 292, '227', 'Pork Bacon Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, NULL, 'lois', '2018-03-08 12:19:21', 'lois-1520469288-152048276121435', 1, 0, '', NULL, NULL, NULL),
(65172, '2018-03-08 12:19:21', NULL, NULL, 17221, 0, 158, '92', 'Banana Stuffed Nutella Toast ', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, NULL, 'lois', '2018-03-08 12:19:21', 'lois-1520469288-152048276121435', 1, 0, '', NULL, NULL, NULL),
(65173, '2018-03-08 12:19:21', NULL, NULL, 17221, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, NULL, 'lois', '2018-03-08 12:19:21', 'lois-1520469288-152048276121435', 1, 0, '', NULL, NULL, NULL),
(65174, '2018-03-08 12:19:21', NULL, NULL, 17221, 0, 29, '29', 'Iced Lemon Tea', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, NULL, 'lois', '2018-03-08 12:19:21', 'lois-1520469288-152048276121435', 1, 1, 'SR', NULL, NULL, NULL),
(65175, '2018-03-08 12:19:21', NULL, NULL, 17221, 0, 336, '272', 'iced Yuzu', '', 'Cold Drinks', 'Non Coffee', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, NULL, 'lois', '2018-03-08 12:19:21', 'lois-1520469288-152048276121435', 1, 0, '', NULL, NULL, NULL),
(65176, '2018-03-08 12:19:21', NULL, NULL, 17221, 0, 337, '273', 'Hot yuzu', '', 'Hot Drinks', 'Non Coffee', 1, 8.00, 8.0000, 0.0000, 8.00, 1, '27', 1, NULL, 'lois', '2018-03-08 12:19:21', 'lois-1520469288-152048276121435', 1, 0, '', NULL, NULL, NULL),
(65177, '2018-03-08 12:18:39', NULL, NULL, 17221, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 9.80, 0.0000, 0.0000, 9.80, 1, '27', 1, NULL, 'lois', '2018-03-08 12:18:39', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65178, '2018-03-08 11:57:59', NULL, NULL, 17220, NULL, 62, '62', 'Orange', '', 'Cold Drinks', 'Fresh Juice', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, NULL, 'lois', '2018-03-08 11:57:59', 'lois-1520469288-15204814797483584', 1, 1, 'SR', NULL, NULL, NULL),
(65179, '2018-03-08 11:57:54', NULL, NULL, 17220, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 0.90, 0.0000, 0.0000, 0.90, 1, '27', 1, NULL, 'lois', '2018-03-08 11:57:54', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65180, '2018-03-08 11:44:27', NULL, NULL, 17219, 0, 222, '156', 'Seasoned Chicken Aglio Olio', '', 'Meals', 'Non-Rice', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, NULL, 'lois', '2018-03-08 11:44:27', 'lois-1520469288-15204806672334643', 1, 0, '', NULL, NULL, NULL),
(65181, '2018-03-08 11:39:52', NULL, NULL, 17219, 0, 299, '235', 'Iced Salted Caramel Latte', '', 'Cold Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, NULL, 'lois', '2018-03-08 11:39:52', 'lois-1520469288-15204803926133031', 1, 0, '', NULL, NULL, NULL),
(65182, '2018-03-08 11:39:52', NULL, NULL, 17219, 0, 324, '260', 'Blueberry Lemon Soda', '', 'Cold Drinks', 'Refreshing Drinks', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, NULL, 'lois', '2018-03-08 11:39:52', 'lois-1520469288-15204803926133031', 1, 0, '', NULL, NULL, NULL),
(65183, '2018-03-08 11:39:52', NULL, NULL, 17219, 0, 170, '104', 'Daily Cheese ', '', 'Desserts', '0', 1, 10.00, 10.0000, 0.0000, 10.00, 1, '27', 1, NULL, 'lois', '2018-03-08 11:39:52', 'lois-1520469288-15204803926133031', 1, 0, '', NULL, NULL, NULL),
(65184, '2018-03-08 11:39:52', NULL, NULL, 17219, 0, 160, '94', 'Signature Dumpling (5 Pcs)', '', 'Meals', 'Snacks ', 1, 9.00, 9.0000, 0.0000, 9.00, 1, '27', 1, NULL, 'lois', '2018-03-08 11:39:52', 'lois-1520469288-15204803926133031', 1, 0, '', NULL, NULL, NULL),
(65185, '2018-03-08 11:38:19', NULL, NULL, 17219, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, NULL, 'lois', '2018-03-08 11:38:19', 'lois-1520469288-15204802995845698', 1, 1, 'SR', NULL, NULL, NULL),
(65186, '2018-03-08 10:10:28', NULL, NULL, 17218, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, NULL, 'lois', '2018-03-08 10:10:28', 'lois-1520469288-15204750285612817', 1, 1, 'SR', NULL, NULL, NULL),
(65187, '2018-03-08 12:37:15', NULL, NULL, 17223, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.20, 0.0000, 0.0000, 2.20, 1, '27', 1, NULL, 'lois', '2018-03-08 12:37:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65188, '2018-03-08 12:21:18', NULL, NULL, 17222, 0, 15, '15', 'Iced Latte ', '', 'Cold Drinks', 'Coffee', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'lois', '2018-03-08 12:21:18', 'lois-1520469288-15204828785809727', 1, 1, 'SR', NULL, NULL, NULL),
(65189, '2018-03-08 12:21:18', NULL, NULL, 17222, 0, 60, '60', 'The Hulk', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'lois', '2018-03-08 12:21:18', 'lois-1520469288-15204828785809727', 1, 1, 'SR', NULL, NULL, NULL),
(65190, '2018-03-08 11:31:43', NULL, NULL, 17218, NULL, 1, '1', 'Espresso', '', 'Hot Drinks', 'Coffee', 1, 6.00, 6.0000, 0.0000, 6.00, 1, '27', 1, NULL, 'lois', '2018-03-08 11:31:43', 'lois-1520469288-15204799031727384', 1, 1, 'SR', NULL, NULL, NULL),
(65191, '2018-03-08 11:38:15', NULL, NULL, 17219, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 8.10, 0.0000, 0.0000, 8.10, 1, '27', 1, NULL, 'lois', '2018-03-08 11:38:15', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65192, '2018-03-08 10:10:25', NULL, NULL, 17218, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 1.20, 0.0000, 0.0000, 1.20, 1, '27', 1, NULL, 'lois', '2018-03-08 10:10:25', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65193, '2018-03-08 10:09:02', NULL, NULL, 17217, 0, 210, '144', 'Red Riding Hood', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'lois', '2018-03-08 10:09:02', 'lois-1520469288-15204749425652287', 1, 0, '', NULL, NULL, NULL),
(65194, '2018-03-08 10:09:02', NULL, NULL, 17217, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, NULL, 'lois', '2018-03-08 10:09:02', 'lois-1520469288-15204749425652287', 1, 0, '', NULL, NULL, NULL),
(65195, '2018-03-08 09:59:27', NULL, NULL, 17217, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, NULL, 'lois', '2018-03-08 09:59:27', 'lois-1520469288-15204743674588253', 1, 0, '', NULL, NULL, NULL),
(65196, '2018-03-08 12:54:17', NULL, NULL, 17224, 0, 181, '116', 'Open Food ', 'Leek Rice', 'Meals', 'Perfect Meals', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, NULL, 'lois', '2018-03-08 12:54:17', 'lois-1520469288-15204848569825115', 1, 0, '', NULL, NULL, NULL),
(65197, '2018-03-08 09:59:27', NULL, NULL, 17217, 0, 286, '220', 'Joyous Sunny', '', 'Meals', 'Morning Bites ', 1, 20.00, 20.0000, 0.0000, 20.00, 1, '27', 1, NULL, 'lois', '2018-03-08 09:59:27', 'lois-1520469288-15204743674588253', 1, 0, '', NULL, NULL, NULL),
(65198, '2018-03-08 10:09:02', NULL, NULL, 17217, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'lois', '2018-03-08 10:09:02', 'lois-1520469288-15204749425652287', 1, 1, 'SR', NULL, NULL, NULL),
(65199, '2018-03-08 10:09:02', NULL, NULL, 17217, NULL, 12, '12', 'DD Special', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, NULL, 'lois', '2018-03-08 10:09:02', 'lois-1520469288-15204749425652287', 1, 1, 'SR', NULL, NULL, NULL),
(65200, '2018-03-08 10:09:02', NULL, NULL, 17217, 0, 207, '142', 'Cheesy Bacon Toast', '', 'Meals', 'Morning Bites ', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, NULL, 'lois', '2018-03-08 10:09:02', 'lois-1520469288-15204749425652287', 1, 0, '', NULL, NULL, NULL),
(65201, '2018-03-08 09:59:27', NULL, NULL, 17217, 0, 287, '221', 'Meatless Red Pasta', '', 'Meals', 'Non-Rice', 1, 17.00, 17.0000, 0.0000, 17.00, 1, '27', 1, NULL, 'lois', '2018-03-08 09:59:27', 'lois-1520469288-15204743674588253', 1, 0, '', NULL, NULL, NULL),
(65202, '2018-03-08 09:59:07', NULL, NULL, 17217, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 12.40, 0.0000, 0.0000, 12.40, 1, '27', 1, NULL, 'lois', '2018-03-08 09:59:07', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65203, '2018-03-08 09:50:53', NULL, NULL, 17216, 0, 59, '59', 'Sunshine', '', 'Cold Drinks', 'Fresh Juice', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'lois', '2018-03-08 09:50:53', 'lois-1520469288-15204738531702357', 1, 1, 'SR', NULL, NULL, NULL),
(65204, '2018-03-08 09:50:53', NULL, NULL, 17216, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, NULL, 'lois', '2018-03-08 09:50:53', 'lois-1520469288-15204738531702357', 1, 0, '', NULL, NULL, NULL),
(65205, '2018-03-08 09:50:46', NULL, NULL, 17216, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 2.80, 0.0000, 0.0000, 2.80, 1, '27', 1, NULL, 'lois', '2018-03-08 09:50:46', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65206, '2018-03-08 09:48:44', NULL, NULL, 17215, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, NULL, 'lois', '2018-03-08 09:48:44', 'lois-1520469288-15204737246665236', 1, 0, '', NULL, NULL, NULL),
(65207, '2018-03-08 09:48:44', NULL, NULL, 17215, 0, 163, '97', 'Melting Heart ', '', 'Desserts', '0', 1, 12.00, 12.0000, 0.0000, 12.00, 1, '27', 1, NULL, 'lois', '2018-03-08 09:48:44', 'lois-1520469288-15204737246665236', 1, 0, '', NULL, NULL, NULL),
(65208, '2018-03-08 09:48:44', NULL, NULL, 17215, 0, 332, '268', 'Chickpeas & Pumpkin Salad ', '', 'Meals', 'Salad', 1, 18.00, 18.0000, 0.0000, 18.00, 1, '27', 1, NULL, 'lois', '2018-03-08 09:48:44', 'lois-1520469288-15204737246665236', 1, 0, '', NULL, NULL, NULL),
(65209, '2018-03-08 09:48:44', NULL, NULL, 17215, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, NULL, 'lois', '2018-03-08 09:48:44', 'lois-1520469288-15204737246665236', 1, 0, '', NULL, NULL, NULL),
(65210, '2018-03-08 09:48:44', NULL, NULL, 17215, 0, 43, '43', 'Strawberry Smoothies', '', 'Cold Drinks', 'Smoothie', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, NULL, 'lois', '2018-03-08 09:48:44', 'lois-1520469288-15204737246665236', 1, 1, 'SR', NULL, NULL, NULL),
(65211, '2018-03-08 13:19:17', NULL, NULL, 17226, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, NULL, 'lois', '2018-03-08 13:19:17', 'lois-1520469288-15204863570358165', 1, 1, 'SR', NULL, NULL, NULL),
(65212, '2018-03-08 09:45:07', NULL, NULL, 17215, 0, 184, '119', 'Flat White', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, NULL, 'lois', '2018-03-08 09:45:07', 'lois-1520469288-15204735074789878', 1, 0, '', NULL, NULL, NULL),
(65213, '2018-03-08 09:48:44', NULL, NULL, 17215, NULL, 5, '5', 'Cappuccino ', '', 'Hot Drinks', 'Coffee', 1, 11.00, 11.0000, 0.0000, 11.00, 1, '27', 1, NULL, 'lois', '2018-03-08 09:48:44', 'lois-1520469288-15204737246665236', 1, 1, 'SR', NULL, NULL, NULL),
(65214, '2018-03-08 09:45:07', NULL, NULL, 17215, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, NULL, 'lois', '2018-03-08 09:45:07', 'lois-1520469288-15204735074789878', 1, 0, '', NULL, NULL, NULL),
(65215, '2018-03-08 09:45:07', NULL, NULL, 17215, 0, 153, '87', 'Wake Me Up!', '', 'Meals', 'Morning Bites ', 1, 21.00, 21.0000, 0.0000, 21.00, 1, '27', 1, NULL, 'lois', '2018-03-08 09:45:07', 'lois-1520469288-15204735074789878', 1, 0, '', NULL, NULL, NULL),
(65216, '2018-03-08 09:45:07', NULL, NULL, 17215, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, NULL, 'lois', '2018-03-08 09:45:07', 'lois-1520469288-15204735074789878', 1, 1, 'SR', NULL, NULL, NULL),
(65217, '2018-03-08 09:45:07', NULL, NULL, 17215, 0, 38, '38', 'Mixed Berries Smoothie', '', 'Cold Drinks', 'Smoothie', 1, 15.00, 15.0000, 0.0000, 15.00, 1, '27', 1, NULL, 'lois', '2018-03-08 09:45:07', 'lois-1520469288-15204735074789878', 1, 1, 'SR', NULL, NULL, NULL),
(65218, '2018-03-08 09:25:02', NULL, NULL, 17214, NULL, 11, '11', 'Vanilla Latte', '', 'Hot Drinks', 'Coffee', 1, 14.00, 14.0000, 0.0000, 14.00, 1, '27', 1, NULL, 'lois', '2018-03-08 09:25:02', 'lois-1520469288-1520472302348311', 1, 1, 'SR', NULL, NULL, NULL),
(65219, '2018-03-08 09:25:02', NULL, NULL, 17214, 0, 333, '269', 'Morning Omelette', '', 'Meals', 'Morning Bites ', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, NULL, 'lois', '2018-03-08 09:25:02', 'lois-1520469288-1520472302348311', 1, 0, '', NULL, NULL, NULL),
(65220, '2018-03-08 09:44:45', NULL, NULL, 17215, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 17.00, 0.0000, 0.0000, 17.00, 1, '27', 1, NULL, 'lois', '2018-03-08 09:44:45', '0', 1, 1, 'SR', NULL, NULL, NULL),
(65221, '2018-03-08 09:25:02', NULL, NULL, 17214, 0, 75, '75', 'Meatless Aglio Olio ', '', 'Meals', 'Non-Rice', 1, 16.00, 16.0000, 0.0000, 16.00, 1, '27', 1, NULL, 'lois', '2018-03-08 09:25:02', 'lois-1520469288-1520472302348311', 1, 0, '', NULL, NULL, NULL),
(65222, '2018-03-08 09:20:57', NULL, NULL, 17214, 0, 0, '_SC', 'Service Charge (10%)', 'SERVICE CHARGE', 'SERVICE CHARGE', '', 1, 4.60, 0.0000, 0.0000, 4.60, 1, '27', 1, NULL, 'lois', '2018-03-08 09:20:57', '0', 1, 1, 'SR', NULL, NULL, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `fnb_self_service_map`
--

CREATE TABLE `fnb_self_service_map` (
  `id` int(11) UNSIGNED NOT NULL,
  `terminal_id` int(11) DEFAULT NULL,
  `categories` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `printer` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `fnb_subcategory_options`
--

CREATE TABLE `fnb_subcategory_options` (
  `id` int(11) UNSIGNED NOT NULL,
  `category` varchar(128) DEFAULT NULL,
  `name` varchar(128) DEFAULT NULL,
  `options` text,
  `customer_options` text,
  `price` text
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `fnb_table_cards`
--

CREATE TABLE `fnb_table_cards` (
  `id` int(11) UNSIGNED NOT NULL,
  `card_no` varchar(255) DEFAULT NULL,
  `short_no` varchar(255) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `im`
--

CREATE TABLE `im` (
  `id` int(11) NOT NULL,
  `subject` varchar(128) DEFAULT NULL,
  `division` varchar(128) DEFAULT NULL,
  `department` varchar(128) DEFAULT NULL,
  `priority` varchar(128) DEFAULT NULL,
  `from` varchar(128) DEFAULT NULL,
  `to` varchar(128) DEFAULT NULL,
  `message` text,
  `user_copy` int(1) DEFAULT '0',
  `datetime` datetime DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `inventory`
--

CREATE TABLE `inventory` (
  `id` int(11) NOT NULL,
  `primary_image` text,
  `image` text,
  `category` varchar(128) DEFAULT NULL,
  `subcategory` varchar(128) DEFAULT NULL,
  `brand` varchar(128) DEFAULT NULL,
  `location` varchar(128) DEFAULT NULL,
  `name` varchar(128) DEFAULT NULL,
  `model_no` varchar(128) DEFAULT NULL,
  `warranty` varchar(128) DEFAULT NULL,
  `sku` varchar(128) DEFAULT NULL,
  `sku2` varchar(128) DEFAULT NULL,
  `sku3` varchar(128) DEFAULT NULL,
  `sku4` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT '0',
  `alert_quantity` int(11) DEFAULT NULL,
  `max_quantity` int(11) DEFAULT NULL,
  `cost` decimal(10,4) NOT NULL,
  `average_cost` decimal(10,4) DEFAULT NULL,
  `price` decimal(10,2) DEFAULT NULL,
  `price_2` decimal(10,2) DEFAULT NULL,
  `price_3` decimal(10,2) DEFAULT NULL,
  `price_4` decimal(10,2) DEFAULT NULL,
  `price2` decimal(10,2) DEFAULT NULL,
  `price2_2` decimal(10,2) DEFAULT NULL,
  `price2_3` decimal(10,2) DEFAULT NULL,
  `price2_4` decimal(10,2) DEFAULT NULL,
  `price3` decimal(10,2) DEFAULT NULL,
  `price3_2` decimal(10,2) DEFAULT NULL,
  `price3_3` decimal(10,2) DEFAULT NULL,
  `price3_4` decimal(10,2) DEFAULT NULL,
  `price4` decimal(10,2) DEFAULT NULL,
  `price4_2` decimal(10,2) DEFAULT NULL,
  `price4_3` decimal(10,2) DEFAULT NULL,
  `price4_4` decimal(10,2) DEFAULT NULL,
  `description` text,
  `supplier` varchar(128) DEFAULT NULL,
  `remarks` text,
  `ordered_quantity` int(11) DEFAULT NULL,
  `is_active` varchar(10) DEFAULT NULL,
  `is_consigned` varchar(10) DEFAULT NULL,
  `quick` int(1) DEFAULT NULL,
  `adjust_cost` int(1) NOT NULL DEFAULT '0',
  `enter_price` int(1) DEFAULT '0',
  `enter_serial` int(1) DEFAULT NULL,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `redeemable` int(1) DEFAULT NULL,
  `redeem_points` int(11) DEFAULT NULL,
  `current_po` int(11) DEFAULT NULL,
  `current_po_item` int(11) DEFAULT NULL,
  `uom1` varchar(128) DEFAULT NULL,
  `uom2` varchar(128) DEFAULT NULL,
  `uom3` varchar(128) DEFAULT NULL,
  `uom4` varchar(128) DEFAULT NULL,
  `loose_qty2` int(11) DEFAULT NULL,
  `loose_qty3` int(11) DEFAULT NULL,
  `loose_qty4` int(11) DEFAULT NULL,
  `weight` decimal(20,2) DEFAULT NULL,
  `weight_unit` varchar(10) DEFAULT NULL,
  `weight2` decimal(20,2) DEFAULT NULL,
  `weight3` decimal(20,2) DEFAULT NULL,
  `weight4` decimal(20,2) DEFAULT NULL,
  `volume` decimal(20,2) DEFAULT NULL,
  `volume_unit` varchar(10) DEFAULT NULL,
  `volume2` decimal(20,2) DEFAULT NULL,
  `volume3` decimal(20,2) DEFAULT NULL,
  `volume4` decimal(20,2) DEFAULT NULL,
  `min_cart_qty` int(11) DEFAULT NULL,
  `max_cart_qty` int(11) DEFAULT NULL,
  `ready_for_sale` int(1) DEFAULT NULL,
  `last_sold` datetime DEFAULT NULL,
  `isbn` varchar(128) DEFAULT NULL,
  `links` text,
  `linked` text,
  `author` text,
  `publisher` varchar(128) DEFAULT NULL,
  `lastchange` varchar(128) DEFAULT NULL,
  `order` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `purchase_tax_code` varchar(32) DEFAULT NULL,
  `supply_tax_code` varchar(32) DEFAULT NULL,
  `purchase_taxable` int(1) DEFAULT NULL,
  `supply_taxable` int(1) DEFAULT NULL,
  `gl_account` int(11) DEFAULT NULL,
  `sale_account` int(11) DEFAULT NULL,
  `purchase_account` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `inventory_stock_quantities`
--

CREATE TABLE `inventory_stock_quantities` (
  `id` int(11) UNSIGNED NOT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_name` varchar(128) DEFAULT NULL,
  `item_sku` varchar(128) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `alert_quantity` int(11) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `last_sold` datetime DEFAULT NULL,
  `cost` decimal(20,2) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `invoices`
--

CREATE TABLE `invoices` (
  `id` int(11) NOT NULL,
  `txn_no` varchar(32) DEFAULT NULL,
  `quote_id` int(11) DEFAULT NULL,
  `sales_order_id` int(11) DEFAULT NULL,
  `number` varchar(128) DEFAULT NULL,
  `po_number` varchar(128) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `due_date` datetime DEFAULT NULL,
  `received_date` datetime DEFAULT NULL,
  `contact_person` varchar(128) DEFAULT NULL,
  `contact` varchar(128) DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `contact_address` text,
  `delivery_address` text,
  `delivery_tracking_no` varchar(128) DEFAULT NULL,
  `delivery_status` varchar(128) DEFAULT NULL,
  `delivery_date` datetime DEFAULT NULL,
  `shipping` varchar(128) DEFAULT NULL,
  `shipping_id` int(11) DEFAULT NULL,
  `terms` varchar(128) DEFAULT NULL,
  `duration` int(11) DEFAULT NULL,
  `remarks` text,
  `status` varchar(128) DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `payment_date` datetime DEFAULT NULL,
  `payment_reference` varchar(128) DEFAULT NULL,
  `payment_contra` varchar(128) DEFAULT NULL,
  `receipt_no` varchar(128) DEFAULT NULL,
  `handling_charges` decimal(20,2) DEFAULT NULL,
  `adjustment` decimal(20,2) DEFAULT NULL,
  `adjustment_type` varchar(32) DEFAULT NULL,
  `total` decimal(20,2) DEFAULT NULL,
  `total_delivered` decimal(20,2) DEFAULT NULL,
  `cost` decimal(20,2) DEFAULT NULL,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(32) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(32) DEFAULT NULL,
  `no_do` int(1) DEFAULT NULL,
  `amount_cash` decimal(20,2) DEFAULT NULL,
  `amount_cc` decimal(20,2) DEFAULT NULL,
  `amount_cheque` decimal(20,2) DEFAULT NULL,
  `amount_credit` decimal(20,2) DEFAULT NULL,
  `amount_bank_deposit` decimal(20,2) DEFAULT NULL,
  `paid_cash` int(1) DEFAULT NULL,
  `paid_cc` int(1) DEFAULT NULL,
  `paid_cheque` int(1) DEFAULT NULL,
  `paid_credit` int(1) DEFAULT NULL,
  `paid_bank_deposit` int(1) DEFAULT NULL,
  `tax` text,
  `total_tax` decimal(20,2) DEFAULT NULL,
  `sales_reference_id` int(11) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `assigned_to` int(11) DEFAULT NULL,
  `notification` text,
  `consignment` int(1) DEFAULT NULL,
  `referrer_contact_id` int(11) DEFAULT NULL,
  `paid_amount` decimal(20,2) DEFAULT '0.00',
  `charges` text,
  `total_charges` decimal(20,2) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `invoice_items`
--

CREATE TABLE `invoice_items` (
  `id` int(11) NOT NULL,
  `invoice_id` int(11) DEFAULT NULL,
  `type` varchar(32) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `item_name` text,
  `item_description` text,
  `item_id` int(11) DEFAULT NULL,
  `service_id` int(11) DEFAULT NULL,
  `item_sku` varchar(128) DEFAULT NULL,
  `discount` varchar(128) DEFAULT NULL,
  `discount_type` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `price_per_unit` decimal(20,4) DEFAULT NULL,
  `price` decimal(20,2) DEFAULT NULL,
  `cost` decimal(20,2) DEFAULT NULL,
  `margin` decimal(20,2) DEFAULT NULL,
  `delivered` int(11) DEFAULT NULL,
  `delivered_price` decimal(20,2) DEFAULT NULL,
  `done` int(1) DEFAULT NULL,
  `no_do` int(1) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `consignment` int(1) DEFAULT NULL,
  `taxable` int(11) DEFAULT NULL,
  `tax_code` varchar(32) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `jobsheet`
--

CREATE TABLE `jobsheet` (
  `id` int(11) DEFAULT NULL,
  `job` varchar(128) DEFAULT NULL,
  `department` varchar(128) DEFAULT NULL,
  `priority` varchar(128) DEFAULT NULL,
  `deadline` datetime DEFAULT NULL,
  `start` datetime DEFAULT NULL,
  `end` datetime DEFAULT NULL,
  `note` text,
  `user` varchar(128) DEFAULT NULL,
  `assignee` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `journal`
--

CREATE TABLE `journal` (
  `id` int(11) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `journal` varchar(128) DEFAULT NULL,
  `ref` varchar(128) DEFAULT NULL,
  `description` varchar(128) DEFAULT NULL,
  `credit_to` varchar(128) DEFAULT NULL,
  `debit_to` varchar(128) DEFAULT NULL,
  `currency` varchar(5) DEFAULT NULL,
  `amount` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `leads`
--

CREATE TABLE `leads` (
  `id` int(11) NOT NULL,
  `firstname` varchar(128) DEFAULT NULL,
  `lastname` varchar(128) DEFAULT NULL,
  `company` varchar(128) DEFAULT NULL,
  `title` varchar(128) DEFAULT NULL,
  `phone` varchar(128) DEFAULT NULL,
  `mobile` varchar(128) DEFAULT NULL,
  `fax` varchar(128) DEFAULT NULL,
  `email` varchar(128) DEFAULT NULL,
  `assigned_to` text,
  `division` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `source` varchar(128) DEFAULT NULL,
  `campaign` varchar(128) DEFAULT NULL,
  `campaign_name` varchar(128) DEFAULT NULL,
  `address1` varchar(128) DEFAULT NULL,
  `address2` varchar(128) DEFAULT NULL,
  `city` varchar(128) DEFAULT NULL,
  `zipcode` varchar(128) DEFAULT NULL,
  `state` varchar(128) DEFAULT NULL,
  `country` varchar(128) DEFAULT NULL,
  `web` varchar(128) DEFAULT NULL,
  `description` varchar(128) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `leave`
--

CREATE TABLE `leave` (
  `id` int(11) NOT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `from` date DEFAULT NULL,
  `to` date DEFAULT NULL,
  `remarks` text,
  `status` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `leave`
--

INSERT INTO `leave` (`id`, `employee_id`, `type`, `from`, `to`, `remarks`, `status`) VALUES
(2, 27, 'Annual Leave', '2015-12-20', '2015-12-21', 'test', 'Approved');

-- --------------------------------------------------------

--
-- Table structure for table `license`
--

CREATE TABLE `license` (
  `id` int(11) UNSIGNED NOT NULL,
  `date_form` datetime DEFAULT NULL,
  `date_to` double DEFAULT NULL,
  `key` varchar(128) DEFAULT NULL,
  `vkey` varchar(128) DEFAULT NULL,
  `count` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `manufacturing_order`
--

CREATE TABLE `manufacturing_order` (
  `id` int(11) UNSIGNED NOT NULL,
  `customer_id` int(11) DEFAULT NULL,
  `customer` varchar(128) DEFAULT NULL,
  `product_name` varchar(128) DEFAULT NULL,
  `bom_id` int(11) DEFAULT NULL,
  `quantity` int(11) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `progress_date` datetime DEFAULT NULL,
  `actual_progress_date` datetime DEFAULT NULL,
  `remarks` text,
  `end_date` datetime DEFAULT NULL,
  `actual_end_date` datetime DEFAULT NULL,
  `actual_quantity` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `manufacturing_order_components`
--

CREATE TABLE `manufacturing_order_components` (
  `id` int(11) UNSIGNED NOT NULL,
  `component_id` int(11) DEFAULT NULL,
  `raw_material_id` int(11) DEFAULT NULL,
  `name` varchar(128) DEFAULT NULL,
  `uom` varchar(128) DEFAULT NULL,
  `remarks` text,
  `shelf_life` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `members`
--

CREATE TABLE `members` (
  `id` int(11) NOT NULL,
  `name` varchar(128) DEFAULT NULL,
  `nric` varchar(32) DEFAULT NULL,
  `email` varchar(128) DEFAULT NULL,
  `tel` varchar(11) DEFAULT NULL,
  `address1` text,
  `address2` text,
  `zipcode` varchar(128) DEFAULT NULL,
  `points` int(11) DEFAULT NULL,
  `added_on` varchar(32) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `added_by` varchar(32) DEFAULT NULL,
  `modified_by` varchar(32) DEFAULT NULL,
  `remarks` text
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `members`
--

INSERT INTO `members` (`id`, `name`, `nric`, `email`, `tel`, `address1`, `address2`, `zipcode`, `points`, `added_on`, `modified_on`, `added_by`, `modified_by`, `remarks`) VALUES
(1001, 'shafiq', '8880123123', '', '', '', '', '', 1000, '2012-07-09 21:45:38', NULL, 'admin', NULL, NULL),
(5369, 'Azad Affif Ishak', '841217075369', '', '', '', '', '', 0, '2012-08-28 00:00:34', NULL, 'admin', NULL, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `memo`
--

CREATE TABLE `memo` (
  `id` int(11) UNSIGNED NOT NULL,
  `title` text,
  `memo` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` datetime DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` datetime DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `memo`
--

INSERT INTO `memo` (`id`, `title`, `memo`, `added_on`, `added_by`, `modified_on`, `modified_by`) VALUES
(2, 'Incentive Bulan 2', '<p><p>PLEX SOLUTIONS(PG0293513-D)<br>CUSTOMER INCENTIVE REPORT</p><p>From Friday, February 1, 2013 to Thursday, February 28, 2013</p><table><thead><tr><th>No</th><th>Cust Code</th><th>Customer</th><th>Total Purchases</th><th>Voucher Code</th></tr></thead><tbody><tr><td><strong>2% REBATE</strong></td></tr><tr><td>1</td><td>841231087654</td><td>Noraishah Kamarudin</td><td>110.00</td><td>USD2</td></tr><tr><td><strong>3% REBATE</strong></td></tr><tr><td><strong>5% REBATE</strong></td></tr><tr><td>1</td><td>841231</td><td>Asmah Bt Din</td><td>495.00</td><td>TYD2</td></tr><tr><td>2</td><td>820921086022</td><td>Johari Bin Jasuli</td><td>220.00</td><td>U0D2</td></tr></tbody></table><br></p>', '2013-04-11 23:41:13', '0000-00-00 00:00:00', NULL, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `menu_items`
--

CREATE TABLE `menu_items` (
  `id` int(11) NOT NULL,
  `category` varchar(128) DEFAULT NULL,
  `subcategory` varchar(128) DEFAULT NULL,
  `location` varchar(128) DEFAULT NULL,
  `name` varchar(128) DEFAULT NULL,
  `sku` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT '0',
  `cost` float(10,4) NOT NULL,
  `item_price` float(10,2) DEFAULT NULL,
  `price` text,
  `options` text,
  `description` text,
  `supplier` varchar(128) DEFAULT NULL,
  `remarks` text,
  `is_active` varchar(10) DEFAULT NULL,
  `is_consigned` varchar(10) DEFAULT NULL,
  `alert_quantity` int(11) DEFAULT NULL,
  `max_quantity` int(11) DEFAULT NULL,
  `ordered_quantity` int(11) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `quick` int(1) DEFAULT NULL,
  `enter_price` int(1) DEFAULT NULL,
  `order` int(11) DEFAULT NULL,
  `category_order` int(11) DEFAULT NULL,
  `iphone` int(1) DEFAULT NULL,
  `grouped` int(1) DEFAULT NULL,
  `printer` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `menu_printer_map`
--

CREATE TABLE `menu_printer_map` (
  `id` int(11) NOT NULL,
  `categories` tinytext,
  `printer_ip` varchar(32) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `modules`
--

CREATE TABLE `modules` (
  `id` int(11) NOT NULL,
  `name` varchar(128) DEFAULT NULL,
  `controller_name` varchar(128) DEFAULT NULL,
  `tables` text,
  `common` varchar(128) DEFAULT NULL,
  `core` int(1) DEFAULT NULL,
  `actions` text,
  `action_names` text,
  `override` int(1) DEFAULT NULL,
  `enabled` int(11) DEFAULT NULL,
  `dependencies` text,
  `calendar_services` text,
  `custom_user_field` text,
  `custom_user_field_name` text
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `modules`
--

INSERT INTO `modules` (`id`, `name`, `controller_name`, `tables`, `common`, `core`, `actions`, `action_names`, `override`, `enabled`, `dependencies`, `calendar_services`, `custom_user_field`, `custom_user_field_name`) VALUES
(1, 'Dashboard', 'dashboard', NULL, '1', 1, 'Memo\nto_read_all_memo|Read All Memo', NULL, NULL, 1, NULL, NULL, NULL, NULL),
(13, 'Editor', 'editor', NULL, '0', 1, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL),
(14, 'Branches', NULL, NULL, '0', 1, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL),
(2, 'Inventory', 'inventory', NULL, '0', 1, 'Items\nto_view_item|View Item\nto_create_item|Create Item\nto_edit_item|Edit Item\nto_delete_item|Delete Item\nto_adjust_quantity|Adjust Quantity on Grid\nto_change_cost|Adjust Cost on Grid\nto_view_cost|View Cost\n\nPurchase Request\nto_view_purchase_request|View Purchase Request\nto_create_purchase_request|Create Purchase Request\nto_edit_purchase_request|Edit Purchase Request\nto_process_purchase_request|Process Purchase Request\nto_delete_purchase_request|Delete Purchase Request\n\nPurchase Orders\nto_view_purchase_order|View Purchase Order\nto_create_purchase_order|Create Purchase Order\nto_edit_purchase_order|Edit Purchase Order\nto_process_purchase_order|Process Purchase Order\nto_delete_purchase_order|Delete Purchase Order\n\nDebit Notes\nto_view_debit_note|View Debit Note\nto_create_debit_note|Create Debit Note\nto_edit_debit_note|Edit Debit Note\nto_process_debit_note|Process Debit Note\nto_delete_debit_note|Delete Debit Note\n\nStock Movements\nto_view_stock_movement|View Stock Movement\nto_create_stock_movement|Create Stock Movement\nto_edit_stock_movement|Edit Stock Movement\nto_process_stock_movement|Process Stock Movement\nto_delete_stock_movement|Delete Stock Movement\n\nStock Count\nto_view_stock_count|View Stock Count\nto_create_stock_count|Create Stock Count\nto_edit_stock_count|Edit Stock Count\nto_process_stock_count|Process Stock Count\nto_delete_stock_count|Delete Stock Count\n\nSettings\nto_view_settings|View Settings\nto_manage_settings|Manage Settings', 'Count Stock,Manage Warehouse,Access All Warehouse,Adjust Cost on Grid,Adjust Quantity on Grid', NULL, 1, 'Contacts,Inventory', '', '', ''),
(3, 'HR', 'employees', NULL, '0', 1, 'Employees\nto_view_employee|View Employee\nto_create_employee|Create Employee\nto_edit_employee|Edit Employee\nto_delete_employee|Delete Employee\n\nLeaves\nto_view_leaves|View Leave\nto_create_leave|Create Leave\nto_edit_leave|Edit Leave\nto_process_leave|Process Leave\nto_delete_leave|Delete Leave\n\nPayroll\nto_view_pay_slip|View Pay Slip\nto_create_pay_slip|Create Pay Slip\nto_edit_pay_slip|Edit Pay Slip\nto_delete_pay_slip|Delete Pay Slip\n\nRecruitment\nto_view_recruitment|View Recruitment\nto_create_recruitment|Create Recruitment\nto_edit_recruitment|Edit Recruitment\nto_delete_recruitment|Delete Recruitment\nto_process_recruitment|Process Recruitment', NULL, NULL, 1, NULL, NULL, NULL, NULL),
(4, 'Settings', 'settings', NULL, '0', 1, 'Users\nto_view_user|View User\nto_create_user|Create User\nto_edit_user|Edit User\nto_delete_user|Delete User\n\nPermissions\nto_view_permission|View Permission\nto_create_permission|Create Permission\nto_edit_permission|Edit Permission\nto_delete_permission|Delete Permission\n\nSystem Information\nto_view_system_information|View System Information\nto_update_system_information|Update System Information\n\nPOS Terminals\nto_view_pos_terminal|View POS Terminal\nto_create_pos_terminal|Create POS Terminal\nto_edit_pos_terminal|Edit POS Terminal\nto_delete_pos_terminal|Delete POS Terminal\n\nBranch\nto_view_branch|View Branch\nto_create_branch|Create Branch\nto_edit_branch|Edit Branch\nto_delete_branch|Delete Branch\n\nTax\nto_view_tax|View Tax\nto_create_tax|Create Tax\nto_edit_tax|Edit Tax\nto_delete_tax|Delete Tax\n\nCredit Cards\nto_view_credit_card|View Credit Card\nto_create_credit_card|Create Credit Card\nto_edit_credit_card|Edit Credit Card\nto_delete_credit_card|Delete Credit Card\n\nShipping\nto_view_shipping|View Shipping\nto_create_shipping|Create Shipping\nto_edit_shipping|Edit Shipping\nto_delete_shipping|Edit Shipping\n\nSoftware Update\nto_perform_software_update|Perform Software Update', 'Assign Module User Data', NULL, 1, NULL, NULL, NULL, NULL),
(10, 'Accounts', 'accounts', NULL, '0', 1, 'Chart of Accounts\nto_view_account|View Account\nto_create_account|Create Account\nto_edit_account|Edit Account\nto_delete_account|Delete Account\nto_manage_account|Manage Chart of Accounts\n\nJournal\nto_add_entry|Add Entry\nto_edit_entry|Edit Entry\nto_delete_entry|Delete Entry\n\nPayments\nto_create_payment|Create Payment\nto_edit_payment|Edit Payment\nto_delete_payment|Delete Payment\n\nReceipts\nto_create_receipt|Create Receipt\nto_edit_receipt|Edit Receipt\nto_delete_receipt|Delete Receipt\n\nPay Slips\nto_view_payslip|View Pay Slips', NULL, NULL, 1, NULL, NULL, NULL, NULL),
(6, 'Assets', 'assets', NULL, '0', 1, 'Assets\nto_view_asset|View Asset\nto_create_asset|Create Asset\nto_edit_asset|Edit Asset\nto_delete_asset|Delete Assset', NULL, NULL, 1, NULL, NULL, NULL, NULL),
(5, 'Reports', 'reports', NULL, '0', 1, 'Reports\nto_save_report|Save Report\nto_view_saved_report|View Saved Report\nto_create_report_module|Create Report Module\nto_edit_report_module|Edit Report Module\nto_delete_report_module|Delete Report Module', NULL, NULL, 1, 'Sales|Inventory|FnB', NULL, NULL, NULL),
(9, 'FnB', 'fnb', NULL, '0', 1, 'Menu Items\nto_view_menu_item|View Menu Item\nto_add_menu_item|Add Menu Item\nto_edit_menu_item|Edit Menu Item\nto_delete_menu_item|Delete Menu Item\n\nCategories\nto_view_category|View Category\nto_edit_category|Edit Category\n\nPrinter Mapping\nto_view_printer_mapping|View Printer Mapping\nto_add_printer_mapping|Add Printer Mapping\nto_edit_printer_mapping|Edit Printer Mapping\nto_delete_printer_mapping|Delete Printer Mapping', NULL, NULL, 1, NULL, NULL, NULL, NULL),
(11, 'Sales', 'sales', NULL, '0', 1, 'Point-of-Sale\nto_use_pos|Use Point-of-Sale\nto_supervise_pos|Supervise Point-of-Sale\nto_view_cash_sales|View Cash Sales\nto_edit_cash_sales|Edit Cash Sales\nto_checkout_transaction|To Checkout Transaction\nto_discount|To Discount Sales\n\nQuotations\nto_view_quotation|View Quotation\nto_create_quotation|Create Quotation\nto_edit_quotation|Edit Quotation\nto_process_quotation|Process Quotation\nto_delete_quotation|Delete Quotation\n\nSales Order\nto_view_sales_order|View Sales Order\nto_create_sales_order|Create Sales Order\nto_edit_sales_order|Edit Sales Order\nto_process_sales_order|Process Sales Order\nto_delete_sales_order|Delete Sales Order\n\nInvoice\nto_view_invoice|View Invoice\nto_create_invoice|Create Invoice\nto_edit_invoice|Edit Invoice\nto_process_invoice|Process Invoice\nto_delete_invoice|Delete Invoice\n\nDelivery Order\nto_view_delivery_order|View Delivery Order\nto_process_delivery_order|Process Delivery Order\n\nCredit Note\nto_view_credit_note|View Credit Note\nto_create_credit_note|Create Credit Note\nto_edit_credit_note|Edit Credit Note\nto_process_credit_note|Process Credit Note\nto_delete_credit_note|Delete Credit Note\n\nDiscount Rule\nto_view_discount_rule|View Discount Rule\nto_create_discount_rule|Create Discount Rule\nto_edit_discount_rule|Edit Discount Rule\nto_process_discount_rule|Process Discount Rule\nto_delete_discount_rule|Delete Credit Note\n\nPayment Gateway\nto_view_payment_gateway|View Payment Gateway\nto_create_payment_gateway|Create Payment Gateway\nto_edit_payment_gateway|Edit Payment Gateway\nto_delete_payment_gateway|Delete Payment Gateway\n\nSettings\nto_view_settings|View Settings\nto_manage_settings|Manage Settings', 'Use Point-of-Sale,Supervise Point-of-Sale', NULL, 1, 'Contacts,Inventory|Services', NULL, NULL, NULL),
(7, 'Services', 'aservices', NULL, '0', 1, 'Services\nto_view_service|View Service\nto_create_service|Create Service\nto_edit_service|Edit Service\nto_delete_service|Delete Service', NULL, NULL, 1, NULL, NULL, NULL, NULL),
(8, 'Contacts', 'contacts', NULL, '0', 1, 'Contacts\nto_view_contact|View Contact\nto_create_contact|Create Contact\nto_edit_contact|Edit Contact\nto_delete_contact|Delete Contact\n\nCases\nto_view_case|View Case\nto_create_case|Create Case\nto_edit_case|Edit Case\nto_delete_case|Delete Case\nto_create_log|Create Log\nto_delete_log|Delete Log', NULL, NULL, 1, NULL, NULL, NULL, NULL),
(12, 'Clinic', 'clinic', NULL, '0', 1, 'Patient Information System\nto_use_pis|Use PIS\nto_view_patient_details|View Patient Details\nto_view_patient_history|View Patient History\nto_create_patient|Create Patient\nto_edit_patient|Edit Patient\n\nAppointments\nto_create_appointment|Create Appointment\nto_edit_appointment|Edit Appointment\nto_delete_appointment|Delete Appointment', 'To Use Patient Information System', NULL, 0, 'Contacts', 'Patient Appointment', NULL, NULL),
(15, 'Tax', NULL, NULL, '0', 1, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL),
(16, 'Shipping', NULL, NULL, '0', 1, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL),
(17, 'CC', NULL, NULL, '0', 1, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL),
(18, 'SU', NULL, NULL, '0', 1, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL),
(19, 'POS', NULL, NULL, '0', 1, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL),
(20, 'Manufacturing', 'manufacturing', NULL, '0', 1, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `notifications`
--

CREATE TABLE `notifications` (
  `id` int(11) UNSIGNED NOT NULL,
  `module` varchar(128) DEFAULT NULL,
  `user` varchar(128) DEFAULT NULL,
  `description` text,
  `link` text,
  `status` varchar(128) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `viewed_datetime` datetime DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `patients`
--

CREATE TABLE `patients` (
  `id` int(11) UNSIGNED NOT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `marital_status` varchar(10) DEFAULT NULL,
  `weight` varchar(10) DEFAULT NULL,
  `height` varchar(10) DEFAULT NULL,
  `blood_type` varchar(5) DEFAULT NULL,
  `allergy` text,
  `spouse_ic` varchar(15) DEFAULT NULL,
  `gender` varchar(6) DEFAULT NULL,
  `emergency_contact` varchar(128) DEFAULT NULL,
  `ic` varchar(128) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `branch` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `patients`
--

INSERT INTO `patients` (`id`, `contact_id`, `marital_status`, `weight`, `height`, `blood_type`, `allergy`, `spouse_ic`, `gender`, `emergency_contact`, `ic`, `added_on`, `added_by`, `modified_on`, `modified_by`, `branch`) VALUES
(1, NULL, 'Married', '65kg', '175cm', 'A', '', '', 'Male', '0', '820921086022', '2012-11-17 08:43:13', 'admin', '2012-11-17 08:52:31', 'admin', NULL),
(2, NULL, 'Married', '156kg', '165cm', 'A', 'None', '', 'Female', '0', '4321', '2012-11-17 17:59:49', 'admin', NULL, NULL, NULL),
(3, NULL, 'Single', '', '', '', '', '0', 'Male', '', '', '2012-12-02 17:34:58', 'admin', NULL, NULL, NULL),
(4, NULL, 'Single', '65', '163', 'A', 'bla', '0', 'Male', '0124994979', '880102355072', '2012-12-02 17:37:55', 'admin', NULL, NULL, NULL),
(5, 1015, 'Single', 'non-existe', 'short', 'Alien', 'everything. Including himself', '0', 'Male', '', '880102355071', '2012-12-02 17:52:00', 'admin', '2013-02-10 12:41:37', 'admin2', NULL),
(6, 1086, 'Single', '', '', '', '', '0', 'Male', '', '840423105354', '2012-12-20 22:40:13', 'admin', NULL, NULL, NULL),
(12, 1127, 'Married', '200', '189', 'B+', 'Piriton', '0', 'Female', '0125454554', '550515075856', '2013-05-17 16:56:47', 'shamiradnan', NULL, NULL, NULL),
(13, 1128, 'Married', '130', '170', 'O', 'Rosmah', '0', 'Male', '0125454554', '500130125254', '2013-05-17 18:15:43', 'shamiradnan', NULL, NULL, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `patient_history`
--

CREATE TABLE `patient_history` (
  `id` int(11) UNSIGNED NOT NULL,
  `patient_id` int(11) DEFAULT NULL,
  `sale_id` int(11) DEFAULT NULL,
  `problem` text,
  `physical_examination` text,
  `diagnosis` text,
  `treatment` text,
  `meds` text,
  `status` varchar(128) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `branch` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `patient_history`
--

INSERT INTO `patient_history` (`id`, `patient_id`, `sale_id`, `problem`, `physical_examination`, `diagnosis`, `treatment`, `meds`, `status`, `added_on`, `added_by`, `branch`) VALUES
(1, NULL, NULL, 'undefined', 'undefined', 'undefined', 'undefined', NULL, 'Created', '2012-11-16 22:33:05', 'staff_kedah', NULL),
(2, NULL, NULL, 'undefined', 'undefined', 'undefined', 'undefined', NULL, 'Created', '2012-11-16 22:33:28', 'staff_kedah', NULL),
(3, NULL, NULL, 'undefined', 'undefined', 'undefined', 'undefined', NULL, 'Created', '2012-11-16 22:33:43', 'staff_kedah', NULL),
(4, NULL, NULL, 'undefined', 'undefined', 'undefined', 'undefined', NULL, 'Created', '2012-11-16 22:42:09', 'staff_kedah', NULL),
(5, NULL, NULL, 'undefined', 'undefined', 'undefined', 'undefined', NULL, 'Created', '2012-11-16 22:43:12', 'staff_kedah', NULL),
(6, NULL, NULL, 'undefined', 'undefined', 'undefined', 'undefined', NULL, 'Created', '2012-11-17 06:51:44', 'staff_kedah', NULL),
(60, 5, 10034, '', '', '', '', '[{"sale_id":"10034","item_id":"15","date":"2013-03-25","item_sku":"SSL13124","item_sku2":null,"item_name":"Supertripod Standing Lamp","unit":null,"qty":0,"qty_fraction":null,"sku_select":"undefined","price_per_unit":false,"cost":0,"margin":0,"terminal":"20","points":"1","session":"1364219595","amount":"270.00","clinic_dosage":"","warehouse_id":"1"},{"sale_id":"10034","item_id":"25","date":"2013-03-25","item_sku":"SCA1231","item_sku2":null,"item_name":"Almeta","unit":null,"qty":0,"qty_fraction":null,"sku_select":"undefined","price_per_unit":false,"cost":50,"margin":-50,"terminal":"20","points":"0","session":"1364219595","amount":"77.00","clinic_dosage":"","warehouse_id":"1"}]', 'Created', '2013-03-25 21:58:24', 'admin', 1),
(10, NULL, 0, '', '', '', '', NULL, 'Created', '2012-11-17 08:50:31', 'staff_kedah', NULL),
(11, NULL, 0, '', '', '', '', NULL, 'Created', '2012-11-17 08:50:31', 'staff_kedah', NULL),
(13, NULL, 10038, 'jjj', '', '', '', NULL, 'Created', '2012-11-17 09:02:17', 'staff_kedah', NULL),
(14, NULL, 0, '', '', '', '', NULL, 'Created', '2012-11-17 09:10:28', 'staff_kedah', NULL),
(16, 1, 1, '', '', '', '', NULL, 'Created', '2012-11-17 09:37:37', 'staff_kedah', NULL),
(17, 1, 1, '', '', '', '', NULL, 'Created', '2012-11-17 09:37:49', 'staff_kedah', NULL),
(18, 1, 2, '', '', '', '', NULL, 'Created', '2012-11-17 09:39:05', 'staff_kedah', NULL),
(19, 1, 2, 'Fever', 'Swelling', 'fever', 'bekam', NULL, 'Created', '2012-11-17 17:52:30', 'admin3', NULL),
(20, 1, 1, 'Fever', 'Swelling', 'fever', 'bekam', NULL, 'Created', '2012-11-17 17:52:55', 'admin3', NULL),
(21, 1, 3, 'fever', 'swelling', 'lack of water', 'bekam', NULL, 'Created', '2012-11-17 17:57:33', 'staff_kedah', NULL),
(22, 2, 1, 'hbp', 'pening', 'hbp', 'bekam', NULL, 'Created', '2012-11-17 18:08:31', 'staff_kedah', NULL),
(23, NULL, 0, 'hbp', 'pening', 'hbp', 'bekam', NULL, 'Created', '2012-11-17 18:08:49', 'staff_kedah', NULL),
(24, 2, 3, 'hbp', 'pening', 'hbp', 'bekam', NULL, 'Created', '2012-11-17 18:28:24', 'staff_kedah', NULL),
(25, 2, 2, 'test', 'test', 'test', 'test', NULL, 'Created', '2012-11-17 22:42:56', 'staff_kedah', NULL),
(26, 2, 4, 'cubaaan', 'cubaan', 'cubaan', 'bekam', NULL, 'Created', '2012-11-17 22:45:09', 'staff_kedah', NULL),
(27, 2, 4, 'test', 'test', 'tasdad', 'dsadasd', NULL, 'Created', '2012-11-18 11:28:18', 'admin', NULL),
(28, NULL, 0, '', '', '', '', NULL, 'Created', '2012-11-18 18:31:54', 'staff_kedah', NULL),
(29, 1, 5, 'a', 's', 's', 's', NULL, 'Created', '2012-11-18 19:30:28', 'admin3', NULL),
(30, 2, 7, '', '', '', '', NULL, 'Created', '2012-11-18 19:30:49', 'admin3', NULL),
(31, 1, 6, '', '', '', '', NULL, 'Created', '2012-11-18 19:31:48', 'admin3', NULL),
(32, NULL, 9, 'etst', 'test', 'test', 'test', NULL, 'Created', '2012-11-19 21:08:45', 'admin', NULL),
(33, 1, 195, '', '', '', '', NULL, 'Created', '2012-11-26 14:52:08', 'admin', NULL),
(34, NULL, 0, '', '', '', '', NULL, 'Created', '2012-11-27 16:35:38', 'admin', NULL),
(35, NULL, 198, 'TEST', 'TEST', 'TEST', 'TEST', NULL, 'Created', '2012-11-27 17:13:59', 'admin', NULL),
(36, 1, 199, 'test', 'test', 'test', 'test', NULL, 'Created', '2012-11-27 17:20:06', 'admin', NULL),
(37, NULL, 201, 'test', 'test', 'test', 'test', NULL, 'Created', '2012-11-27 17:42:37', 'admin', NULL),
(38, NULL, 202, '', '', '', '', NULL, 'Created', '2012-11-28 22:00:54', 'admin', NULL),
(39, 1, 205, 'sakit dada', 'lebam', 'jatuh', 'bekam', NULL, 'Created', '2012-11-29 19:54:15', 'admin', NULL),
(40, 1, 207, 'test', 'test', 'test', 'test', NULL, 'Created', '2012-11-30 19:54:40', 'admin', NULL),
(41, NULL, 208, 'a', 'b', 'c', 'd', NULL, 'Created', '2012-11-30 21:00:51', 'admin', NULL),
(43, NULL, 0, 'test', 'test', 'test', 'test', NULL, 'Created', '2012-12-03 12:07:56', 'admin', 5),
(62, NULL, 10050, 'testing', 'aadas', 'adasd', 'adas', '[{"sale_id":"10050","item_id":"21","date":"2013-04-28","item_sku":"MC12389012","item_sku2":null,"item_name":"Moon Caption","unit":"","qty":"1","qty_fraction":1,"sku_select":1,"price_per_unit":89,"cost":0,"margin":89,"terminal":"21","points":"0","session":"1366462725","amount":"89.00","clinic_dosage":"3x3x3","warehouse_id":"8"}]', 'Created', '2013-04-28 12:04:07', 'admin2', 8),
(63, NULL, 10055, 'asdas', 'hjhj', 'hj', 'hj', '[{"sale_id":"10055","item_id":"21","date":"2013-04-28","item_sku":"MC12389012","item_sku2":null,"item_name":"Moon Caption","unit":null,"qty":0,"qty_fraction":null,"sku_select":"undefined","price_per_unit":false,"cost":0,"margin":0,"terminal":"21","points":"0","session":"1366462725","amount":"89.00","clinic_dosage":"","warehouse_id":"8"}]', 'Created', '2013-04-28 12:41:57', 'admin2', 8),
(64, 5, 10058, 'test', 'test', 'test', 'test', '[{"sale_id":"10058","item_id":"21","date":"2013-04-28","item_sku":"MC12389012","item_sku2":null,"item_name":"Moon Caption","unit":"","qty":"1","qty_fraction":1,"sku_select":1,"price_per_unit":89,"cost":0,"margin":89,"terminal":"21","points":"0","session":"1366462725","amount":"89.00","clinic_dosage":"","warehouse_id":"8"}]', 'Created', '2013-04-28 12:45:49', 'admin2', 8),
(65, 5, 10062, 'test', 'test', 'tes', 'test', '[{"sale_id":"10062","item_id":"21","date":"2013-04-28","item_sku":"MC12389012","item_sku2":null,"item_name":"Moon Caption","unit":null,"qty":0,"qty_fraction":null,"sku_select":"undefined","price_per_unit":false,"cost":0,"margin":0,"terminal":"20","points":"0","session":"1367133189","amount":"89.00","clinic_dosage":"","warehouse_id":"8"}]', 'Created', '2013-04-28 15:20:57', 'admin2', 8),
(66, NULL, 10066, 'Sakit Perut', 'test', 'test', 'test', '[{"sale_id":"10066","item_id":"15","date":"2013-04-29","item_sku":"SSL13124","item_sku2":null,"item_name":"Supertripod Standing Lamp","unit":"","qty":"1","qty_fraction":1,"sku_select":1,"price_per_unit":270,"cost":0,"margin":270,"terminal":"21","points":"1","session":"1367242070","amount":"270.00","clinic_dosage":"3x3x3","warehouse_id":"1"},{"sale_id":"10066","item_id":"21","date":"2013-04-29","item_sku":"MC12389012","item_sku2":null,"item_name":"Moon Caption","unit":"","qty":"1","qty_fraction":1,"sku_select":1,"price_per_unit":89,"cost":0,"margin":89,"terminal":"21","points":"0","session":"1367242070","amount":"89.00","clinic_dosage":"2x2x2","warehouse_id":"1"}]', 'Created', '2013-04-29 21:34:39', 'admin', 1),
(68, 13, 10084, 'Sakit Mata', 'Meta Merah', 'Ada Ketumbit sebab cuaca Panas', 'Cucuk dengan Ubat. Bagi Eye Mo 2 Drops', '[{"sale_id":"10084","item_id":"74","date":"2013-05-17","item_sku":"987654321","item_sku2":null,"item_name":"Eye Mo","unit":null,"qty":0,"qty_fraction":null,"sku_select":"undefined","price_per_unit":false,"cost":0,"margin":0,"terminal":"21","points":"0","session":"1368787719","amount":"2.50","clinic_dosage":"3","warehouse_id":"8"}]', 'Created', '2013-05-17 19:13:21', 'admin3', 8),
(69, 13, 10086, 'Sakit Mata Lagi', 'Ketumbit dah Pecah . Mata Merah Sikit', 'Mata Semua Okay Tak Ada Masalah', 'Lap Dengan Tisu dan Bagi Eye Mo 2 Drop Lagi', '[{"sale_id":"10086","item_id":"74","date":"2013-05-17","item_sku":"987654321","item_sku2":null,"item_name":"Eye Mo","unit":null,"qty":0,"qty_fraction":null,"sku_select":"undefined","price_per_unit":false,"cost":0,"margin":0,"terminal":"21","points":"0","session":"1368787719","amount":"2.50","clinic_dosage":"3","warehouse_id":"8"}]', 'Created', '2013-05-17 19:25:52', 'admin3', 8),
(70, 13, 10087, 'Mata Belah Kanan Sakit', 'Mata Lebam sikit', 'Lebam sebab kena bola hoki', 'Dema dengan Tuala panas, Letak eye mo 2 drops', '[{"sale_id":"10087","item_id":"74","date":"2013-05-17","item_sku":"987654321","item_sku2":null,"item_name":"Eye Mo","unit":null,"qty":0,"qty_fraction":null,"sku_select":"undefined","price_per_unit":false,"cost":0,"margin":0,"terminal":"21","points":"0","session":"1368787719","amount":"5.00","clinic_dosage":"4","warehouse_id":"8"}]', 'Created', '2013-05-17 19:30:04', 'admin3', 8),
(72, 3, 19, '', '', '', '', '[{"sale_id":"19","item_id":"5","date":"2015-08-04","item_sku":"10011","item_sku2":null,"item_name":"TEST ITEM2","unit":"","qty":"1","qty_fraction":1,"sku_select":1,"price_per_unit":12.5,"cost":10,"margin":2.5,"terminal":"27","points":"1000","session":"1437815363","amount":"12.50","clinic_dosage":"1 tab \\/ per day","warehouse_id":"1"},{"sale_id":"19","item_id":"5","date":"2015-08-04","item_sku":"10011","item_sku2":null,"item_name":"TEST ITEM2","unit":"","qty":"1","qty_fraction":1,"sku_select":1,"price_per_unit":12.5,"cost":10,"margin":2.5,"terminal":"27","points":"1000","session":"1437815363","amount":"12.50","clinic_dosage":"","warehouse_id":"1"}]', 'Created', '2015-08-04 18:19:32', 'admin', 1),
(73, 3, 20, 'tetasd', 'asdsad', 'asdsa dsa ', 'asdasd', '[{"sale_id":"20","item_id":"5","date":"2015-08-04","item_sku":"10011","item_sku2":null,"item_name":"TEST ITEM2","unit":"","qty":"1","qty_fraction":1,"sku_select":1,"price_per_unit":12.5,"cost":10,"margin":2.5,"terminal":"27","points":"1000","session":"1437815363","amount":"12.50","clinic_dosage":"","warehouse_id":"1"}]', 'Created', '2015-08-04 18:21:14', 'admin', 1);

-- --------------------------------------------------------

--
-- Table structure for table `payment_gateways`
--

CREATE TABLE `payment_gateways` (
  `id` int(11) UNSIGNED NOT NULL,
  `name` varchar(128) DEFAULT NULL,
  `namespace` varchar(128) DEFAULT NULL,
  `description` text,
  `initiate_script` text,
  `callback_script` text,
  `status` varchar(128) DEFAULT NULL,
  `percentage` decimal(10,2) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `payment_vouchers`
--

CREATE TABLE `payment_vouchers` (
  `id` int(11) UNSIGNED NOT NULL,
  `txn_no` varchar(255) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `account` varchar(128) DEFAULT NULL,
  `account_id` int(11) DEFAULT NULL,
  `contact` varchar(128) DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `amount_payable` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `void_date` datetime DEFAULT NULL,
  `tax` decimal(20,2) DEFAULT NULL,
  `tax_code` varchar(32) DEFAULT NULL,
  `tax_inclusive` int(1) DEFAULT NULL,
  `recon_date` date DEFAULT NULL,
  `recon_id` int(11) DEFAULT NULL,
  `payee` varchar(255) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `payment_voucher_breakdown`
--

CREATE TABLE `payment_voucher_breakdown` (
  `id` int(11) UNSIGNED NOT NULL,
  `pv_id` int(11) DEFAULT NULL,
  `txn_no` varchar(255) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `contact` varchar(128) DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `account` text,
  `account_id` int(11) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `payment_reference` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `description` text,
  `cc_charge` decimal(20,2) DEFAULT NULL,
  `cc_tax` decimal(20,2) DEFAULT NULL,
  `recon_id` int(11) DEFAULT NULL,
  `recon_date` date DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `payment_voucher_items`
--

CREATE TABLE `payment_voucher_items` (
  `id` int(11) UNSIGNED NOT NULL,
  `pv_id` int(11) DEFAULT NULL,
  `account_id` int(11) DEFAULT NULL,
  `txn_no` varchar(255) DEFAULT NULL,
  `account` varchar(128) DEFAULT NULL,
  `po_id` int(11) DEFAULT NULL,
  `cn_id` int(11) DEFAULT NULL,
  `dn_id` int(11) DEFAULT NULL,
  `invoice_id` int(11) DEFAULT NULL,
  `asset_id` int(11) DEFAULT NULL,
  `reference` varchar(128) DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `contact` varchar(128) DEFAULT NULL,
  `description` text,
  `datetime` datetime DEFAULT NULL,
  `amount_payable` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `tax_code` varchar(255) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `recon_date` date DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `permissions`
--

CREATE TABLE `permissions` (
  `id` int(11) NOT NULL,
  `user_type` varchar(128) DEFAULT NULL,
  `module` text,
  `action` text,
  `divisions` text,
  `super` int(11) DEFAULT '0',
  `lastchange` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `permissions`
--

INSERT INTO `permissions` (`id`, `user_type`, `module`, `action`, `divisions`, `super`, `lastchange`) VALUES
(8, 'Superadmin', NULL, NULL, NULL, 1, NULL),
(9, 'Staff', 'Inventory,Sales,Dashboard', '{"Inventory":{"to_view_item":"1","to_create_item":"1","to_edit_item":"1","to_delete_item":"1","to_adjust_quantity":"1","to_change_cost":"1"},"Sales":{"to_use_pos":"1"}}', NULL, 0, NULL),
(10, 'Manager', 'Inventory,Settings,Reports,FnB,Sales,Contacts,Dashboard', '{"Inventory":{"to_view_item":"1","to_create_item":"1","to_edit_item":"1","to_delete_item":"1","to_adjust_quantity":"1","to_change_cost":"1","to_view_cost":"1","to_view_purchase_request":"1","to_create_purchase_request":"1","to_edit_purchase_request":"1","to_process_purchase_request":"1","to_delete_purchase_request":"1","to_view_purchase_order":"1","to_create_purchase_order":"1","to_edit_purchase_order":"1","to_process_purchase_order":"1","to_delete_purchase_order":"1","to_view_debit_note":"1","to_create_debit_note":"1","to_edit_debit_note":"1","to_process_debit_note":"1","to_delete_debit_note":"1","to_view_stock_movement":"1","to_create_stock_movement":"1","to_edit_stock_movement":"1","to_process_stock_movement":"1","to_delete_stock_movement":"1","to_view_stock_count":"1","to_create_stock_count":"1","to_edit_stock_count":"1","to_process_stock_count":"1"},"Settings":{"to_view_user":"1","to_create_user":"1","to_edit_user":"1","to_delete_user":"1","to_view_permission":"1","to_create_permission":"1","to_edit_permission":"1","to_delete_permission":"1","to_view_pos_terminal":"1","to_create_pos_terminal":"1","to_edit_pos_terminal":"1","to_delete_pos_terminal":"1","to_view_credit_card":"1","to_create_credit_card":"1","to_edit_credit_card":"1","to_delete_credit_card":"1"},"Reports":{"to_save_report":"1","to_view_saved_report":"1","to_create_report_module":"1","to_edit_report_module":"1","to_delete_report_module":"1"},"FnB":{"to_view_menu_item":"1","to_add_menu_item":"1","to_edit_menu_item":"1","to_delete_menu_item":"1","to_view_category":"1","to_edit_category":"1","to_view_printer_mapping":"1","to_add_printer_mapping":"1","to_edit_printer_mapping":"1","to_delete_printer_mapping":"1"},"Sales":{"to_use_pos":"1","to_supervise_pos":"1","to_view_cash_sales":"1","to_edit_cash_sales":"1","to_checkout_transaction":"1","to_discount":"1","to_view_quotation":"1","to_create_quotation":"1","to_edit_quotation":"1","to_process_quotation":"1","to_delete_quotation":"1","to_view_sales_order":"1","to_create_sales_order":"1","to_edit_sales_order":"1","to_process_sales_order":"1","to_delete_sales_order":"1","to_view_invoice":"1","to_create_invoice":"1","to_edit_invoice":"1","to_process_invoice":"1","to_view_delivery_order":"1","to_process_delivery_order":"1","to_view_credit_note":"1","to_create_credit_note":"1","to_edit_credit_note":"1","to_process_credit_note":"1","to_delete_credit_note":"1","to_view_discount_rule":"1","to_create_discount_rule":"1","to_edit_discount_rule":"1","to_process_discount_rule":"1","to_delete_discount_rule":"1","to_view_payment_gateway":"1","to_create_payment_gateway":"1","to_edit_payment_gateway":"1","to_view_settings":"1","to_manage_settings":"1"},"Contacts":{"to_view_contact":"1","to_create_contact":"1","to_edit_contact":"1","to_view_case":"1","to_create_case":"1","to_edit_case":"1","to_delete_case":"1","to_create_log":"1"}}', NULL, 0, NULL),
(11, 'Cashier', 'Sales,Dashboard', '{"Inventory":{"to_view_item":"1","to_create_item":"1","to_view_cost":"1"},"Sales":{"to_use_pos":"1","to_supervise_pos":"1","to_view_cash_sales":"1","to_checkout_transaction":"1"}}', NULL, 0, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `pos_items_template`
--

CREATE TABLE `pos_items_template` (
  `id` int(11) UNSIGNED NOT NULL,
  `name` text,
  `data` text
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `pos_items_template`
--

INSERT INTO `pos_items_template` (`id`, `name`, `data`) VALUES
(7, 'Nicholas', '[{"sku":"1001","price":"25.00","qty":"1"}]'),
(8, 'CustomerA', '[{"sku":"1001","price":"25.00","qty":"10"}]');

-- --------------------------------------------------------

--
-- Table structure for table `potentials`
--

CREATE TABLE `potentials` (
  `id` int(11) NOT NULL,
  `name` varchar(128) DEFAULT NULL,
  `related_to` varchar(128) DEFAULT NULL,
  `lead_id` int(11) DEFAULT NULL,
  `currency` varchar(128) DEFAULT NULL,
  `amount` varchar(32) DEFAULT NULL,
  `assigned_to` text,
  `division` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `expected_close_date` date DEFAULT NULL,
  `lead_source` varchar(128) DEFAULT NULL,
  `next_step` varchar(128) DEFAULT NULL,
  `probability` varchar(128) DEFAULT NULL,
  `campaign` varchar(128) DEFAULT NULL,
  `campaign_name` varchar(128) DEFAULT NULL,
  `sales_stage` varchar(128) DEFAULT NULL,
  `description` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `product_reviews`
--

CREATE TABLE `product_reviews` (
  `id` int(11) UNSIGNED NOT NULL,
  `status` varchar(128) DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `customer_id` int(11) DEFAULT NULL,
  `customer` varchar(128) DEFAULT NULL,
  `review` text,
  `rating` int(11) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `purchase_orders`
--

CREATE TABLE `purchase_orders` (
  `id` int(11) NOT NULL,
  `txn_no` varchar(32) DEFAULT NULL,
  `invoice_number` varchar(128) DEFAULT NULL,
  `pr_id` int(11) DEFAULT NULL,
  `number` varchar(128) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `due_date` datetime DEFAULT NULL,
  `contact_person` varchar(128) DEFAULT NULL,
  `received_date` datetime DEFAULT NULL,
  `supplier` varchar(128) DEFAULT NULL,
  `supplier_id` int(11) DEFAULT NULL,
  `supplier_address` text,
  `delivery_address` text,
  `terms` varchar(128) DEFAULT NULL,
  `duration` int(11) DEFAULT NULL,
  `remarks` text,
  `status` varchar(128) DEFAULT NULL,
  `receipt_no` varchar(128) DEFAULT NULL,
  `handling_charges` decimal(20,2) DEFAULT NULL,
  `adjustment` decimal(20,2) DEFAULT NULL,
  `adjustment_type` varchar(32) DEFAULT NULL,
  `total` decimal(20,2) DEFAULT NULL,
  `total_received` decimal(20,2) DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `payment_date` datetime DEFAULT NULL,
  `payment_reference` varchar(128) DEFAULT NULL,
  `payment_contra` varchar(128) DEFAULT NULL,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(32) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(32) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `tax` text,
  `tax_inclusive` int(1) DEFAULT NULL,
  `total_tax` decimal(20,2) DEFAULT NULL,
  `assigned_to` varchar(128) DEFAULT NULL,
  `paid_amount` decimal(20,2) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `purchase_order_items`
--

CREATE TABLE `purchase_order_items` (
  `id` int(11) NOT NULL,
  `purchase_order_id` int(11) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `item_description` text,
  `item_name` text,
  `item_id` int(11) DEFAULT NULL,
  `discount` varchar(128) DEFAULT NULL,
  `discount_type` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `price_per_unit` decimal(20,4) DEFAULT NULL,
  `price` decimal(20,2) DEFAULT NULL,
  `received` int(11) DEFAULT NULL,
  `received_price` decimal(20,2) DEFAULT NULL,
  `done` int(1) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `taxable` int(1) DEFAULT NULL,
  `tax_code` varchar(32) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `purchase_requests`
--

CREATE TABLE `purchase_requests` (
  `id` int(11) NOT NULL,
  `txn_no` varchar(32) DEFAULT NULL,
  `po_id` int(11) DEFAULT NULL,
  `number` varchar(128) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `due_date` datetime DEFAULT NULL,
  `contact_person` varchar(128) DEFAULT NULL,
  `received_date` datetime DEFAULT NULL,
  `supplier` varchar(128) DEFAULT NULL,
  `supplier_id` int(11) DEFAULT NULL,
  `supplier_address` text,
  `delivery_address` text,
  `terms` varchar(128) DEFAULT NULL,
  `duration` int(11) DEFAULT NULL,
  `remarks` text,
  `status` varchar(128) DEFAULT NULL,
  `receipt_no` varchar(128) DEFAULT NULL,
  `handling_charges` decimal(20,2) DEFAULT NULL,
  `adjustment` decimal(20,2) DEFAULT NULL,
  `adjustment_type` varchar(32) DEFAULT NULL,
  `total` decimal(20,2) DEFAULT NULL,
  `total_received` decimal(20,2) DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `payment_date` datetime DEFAULT NULL,
  `payment_reference` varchar(128) DEFAULT NULL,
  `payment_contra` varchar(128) DEFAULT NULL,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(32) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(32) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `assigned_to` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `purchase_request_items`
--

CREATE TABLE `purchase_request_items` (
  `id` int(11) NOT NULL,
  `purchase_request_id` int(11) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `item_description` text,
  `item_name` text,
  `item_id` int(11) DEFAULT NULL,
  `discount` varchar(128) DEFAULT NULL,
  `discount_type` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `price_per_unit` decimal(20,4) DEFAULT NULL,
  `price` decimal(20,2) DEFAULT NULL,
  `received` int(11) DEFAULT NULL,
  `received_price` decimal(20,2) DEFAULT NULL,
  `done` int(1) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `quotes`
--

CREATE TABLE `quotes` (
  `id` int(11) NOT NULL,
  `txn_no` varchar(32) DEFAULT NULL,
  `quote_id` int(11) DEFAULT NULL,
  `invoice_id` int(11) DEFAULT NULL,
  `sales_order_id` int(11) DEFAULT NULL,
  `number` varchar(128) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `due_date` datetime DEFAULT NULL,
  `contact_person` varchar(128) DEFAULT NULL,
  `payment_date` datetime DEFAULT NULL,
  `received_date` datetime DEFAULT NULL,
  `contact` varchar(128) DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `contact_address` text,
  `delivery_address` text,
  `shipping` varchar(128) DEFAULT NULL,
  `shipping_id` int(11) DEFAULT NULL,
  `terms` varchar(128) DEFAULT NULL,
  `duration` int(11) DEFAULT NULL,
  `remarks` text,
  `status` varchar(128) DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `receipt_no` varchar(128) DEFAULT NULL,
  `handling_charges` decimal(20,2) DEFAULT NULL,
  `adjustment` decimal(20,2) DEFAULT NULL,
  `adjustment_type` varchar(32) DEFAULT NULL,
  `total` decimal(20,2) DEFAULT NULL,
  `total_delivered` decimal(20,2) DEFAULT NULL,
  `cost` decimal(20,4) DEFAULT NULL,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(32) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(32) DEFAULT NULL,
  `no_do` int(1) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `assigned_to` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `quote_items`
--

CREATE TABLE `quote_items` (
  `id` int(11) NOT NULL,
  `quote_id` int(11) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `service_id` int(11) DEFAULT NULL,
  `item_name` varchar(128) DEFAULT NULL,
  `item_description` text,
  `discount` varchar(128) DEFAULT NULL,
  `discount_type` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `price_per_unit` decimal(20,4) DEFAULT NULL,
  `price` decimal(20,2) DEFAULT NULL,
  `cost` decimal(20,4) DEFAULT NULL,
  `done` int(1) DEFAULT NULL,
  `no_do` int(1) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `receipts`
--

CREATE TABLE `receipts` (
  `id` int(11) UNSIGNED NOT NULL,
  `txn_no` varchar(255) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `account_id` int(11) DEFAULT NULL,
  `account` varchar(128) DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `contact` varchar(128) DEFAULT NULL,
  `cost` decimal(20,2) DEFAULT NULL,
  `amount_receivable` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `amount_fees` double(20,2) DEFAULT NULL,
  `amount_effective` double(20,2) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `void_date` datetime DEFAULT NULL,
  `tax` decimal(20,2) DEFAULT NULL,
  `tax_code` varchar(32) DEFAULT NULL,
  `tax_inclusive` int(1) DEFAULT NULL,
  `recon_date` date DEFAULT NULL,
  `recon_id` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `receipt_breakdown`
--

CREATE TABLE `receipt_breakdown` (
  `id` int(11) UNSIGNED NOT NULL,
  `receipt_id` int(11) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `contact` varchar(128) DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `account` varchar(128) DEFAULT NULL,
  `account_id` int(11) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `amount_fees` decimal(20,2) DEFAULT NULL,
  `amount_effective` double(20,2) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `payment_reference` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `description` text,
  `cc_fees` decimal(20,2) DEFAULT NULL,
  `cc_tax` decimal(20,2) DEFAULT NULL,
  `cc_type` int(11) DEFAULT NULL,
  `cc_name` varchar(32) DEFAULT NULL,
  `recon_id` int(11) DEFAULT NULL,
  `recon_date` date DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `receipt_items`
--

CREATE TABLE `receipt_items` (
  `id` int(11) UNSIGNED NOT NULL,
  `receipt_id` int(11) DEFAULT NULL,
  `account_id` int(11) DEFAULT NULL,
  `txn_no` varchar(255) DEFAULT NULL,
  `account` varchar(128) DEFAULT NULL,
  `po_id` int(11) DEFAULT NULL,
  `cn_id` int(11) DEFAULT NULL,
  `dn_id` int(11) DEFAULT NULL,
  `invoice_id` int(11) DEFAULT NULL,
  `asset_id` int(11) DEFAULT NULL,
  `reference` varchar(128) DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `contact` varchar(128) DEFAULT NULL,
  `description` text,
  `datetime` datetime DEFAULT NULL,
  `amount_receivable` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `recon_date` date DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `reports`
--

CREATE TABLE `reports` (
  `id` int(11) UNSIGNED NOT NULL,
  `name` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `description` text,
  `modules` text,
  `permissions` text,
  `process_script` text,
  `display_script` text,
  `script` text,
  `filters` text,
  `frontend` int(1) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `reports`
--

INSERT INTO `reports` (`id`, `name`, `type`, `description`, `modules`, `permissions`, `process_script`, `display_script`, `script`, `filters`, `frontend`, `added_on`, `added_by`, `modified_on`, `modified_by`) VALUES
(2, 'Sales Widget', 'Widget', '', 'false', '0', 'if ($_REQUEST[''date'']){\r\n	list($day, $month, $year) = explode(''/'', $_REQUEST[''date'']);\r\n	$date = $year . ''-'' . $month . ''-'' . $day;\r\n}\r\n\r\n\r\nif ($date){\r\n	$datef = strtotime($date);\r\n} else {\r\n	$datef = strtotime(date(''Y-m-d''));\r\n}\r\n\r\nfor($i = 14; $i < 52; $i++){\r\n	$cur_date = date("Y-m-d H:i:s",$datef + ((60*60*0.5)*$i));\r\n	$next_date = date("Y-m-d H:i:s",$datef + ((60*60*0.5)*($i+1))); \r\n	list($day,$month,$year) = explode(''-'',$cur_date);\r\n\r\n			\r\n	$query = $this->db->query("\r\n		SELECT \r\n			* \r\n		FROM \r\n			`fnb_sales` \r\n		WHERE \r\n			`datetime` >= ''$cur_date'' AND \r\n			`datetime` < ''$next_date'' AND \r\n			`payment_status` = ''Paid''\r\n		UNION\r\n		SELECT \r\n			* \r\n		FROM \r\n			`fnb_buffer_sales` \r\n		WHERE \r\n			`datetime` >= ''$cur_date'' AND \r\n			`datetime` < ''$next_date'' AND \r\n			`payment_status` = ''Paid''\r\n	");\r\n	\r\n	$sales_total = 0;\r\n	if ($query->num_rows()){\r\n		foreach ($query->result() as $sales){\r\n			$sales_total += $sales->amount;\r\n		}\r\n	}\r\n			\r\n	$query = $this->db->query("\r\n		SELECT \r\n			* \r\n		FROM \r\n			`invoices` \r\n		WHERE \r\n			`added_on` >= ''$cur_date'' AND \r\n			`added_on` < ''$next_date''\r\n	");\r\n	\r\n	$invoiced_total = 0;\r\n	if ($query->num_rows()){\r\n		foreach ($query->result() as $invoice){\r\n			$invoiced_total += \r\n				$invoice->total_delivered ? $invoice->total_delivered : $invoice->total;\r\n		}\r\n	}\r\n\r\n					\r\n	$data[] = array($i, $sales_total + $invoiced_total);\r\n	$data_sales[] = array($i, $sales_total);\r\n	$data_invoiced[] = array($i, $invoiced_total);\r\n	\r\n	$sales_grand_total += $sales_total;\r\n	$invoiced_grand_total += $invoiced_total;\r\n	\r\n}\r\n\r\n$json_all = json_encode($data);\r\n$json_sales = json_encode($data_sales);\r\n$json_invoiced = json_encode($data_invoiced);', '<script type="text/javascript">\r\n	\r\n	$(document).ready(function(){\r\n		$(''input.date'').dateEntry({dateFormat: ''dmy/'',spinnerImage: base_url+''images/spinnerDefault.png''})\r\n	})\r\n\r\n	function reloadSalesWidget(){\r\n		var widget	= $(''.sales-widget'').parents(''div.dashboard-widget'').attr(''id'');\r\n		var wid		= widget.split(''-'');\r\n		var id		= wid[1];\r\n		var date	= $(''.sales-date'').val();\r\n		$(''#''+widget).html(''<p align="center"><img src="images/loading.gif"> Loading</p>'');\r\n		\r\n		$.ajax({\r\n			url: base_url + ''reports/generate_widget/'' + id,\r\n			type: ''post'',\r\n			data: ''date=''+date,\r\n			success: function (output){\r\n				$(''#''+widget).html(''<div class="container" style="display:none">''+output+''</div>'');\r\n				$(''#''+widget+'' div.container'').fadeIn();\r\n			\r\n				$(''input.date'').dateEntry({dateFormat: ''dmy/'',spinnerImage: base_url+''images/spinnerDefault.png''})\r\n			}\r\n		})\r\n\r\n	}\r\n	\r\n</script>\r\n<h3 style="background: #EEE; padding: 10px; margin: 0;">Sales Trend</h3>\r\n\r\n\r\n<div class="sales-widget" style="padding: 10px;">\r\n	<div style="float:right; padding-bottom: 20px">\r\n	Date: <input style="width: 80px" type="text" class="date v-text sales-date" \r\n		value="<?php echo date(''d/m/Y'',$datef); ?>" /> \r\n	<button onclick="reloadSalesWidget()" class="v-btn">Go</button>\r\n	</div>\r\n\r\n	<div id="currentMonthSales" style="height: 220px; width: 100%; margin: 20px 0 10px 0">\r\n	\r\n	</div>\r\n	<table style="width: 100%">\r\n		<tr>\r\n			<td style="width: 20%">\r\n				POS Sales<br />\r\n				<strong style="font-size: 15pt;">\r\n					<?php echo $this->system->config(''currency'') . \r\n						number_format($sales_grand_total,2); ?>\r\n				</strong>\r\n			</td>\r\n			<td style="width: 20%">\r\n				Invoiced Sales<br />\r\n				<strong style="font-size: 15pt;">\r\n					<?php echo $this->system->config(''currency'') . \r\n						number_format($invoiced_grand_total,2); ?>\r\n				</strong>\r\n			</td>\r\n			<td style="width: 20%"></td>\r\n			<td style="width: 20%"></td>\r\n			<td style="width: 20%">\r\n				Total Sales<br />\r\n				<strong style="font-size: 15pt;">\r\n					<?php echo $this->system->config(''currency'') . \r\n						number_format($invoiced_grand_total + $sales_grand_total,2); ?>\r\n				</strong>\r\n			</td>\r\n		</tr>\r\n	</table>\r\n</div>\r\n<script type="text/javascript">\r\n	setTimeout(function(){\r\n		$.plot($("#currentMonthSales"), [\r\n			{\r\n				label: ''All'',\r\n				data: <?php echo $json_all; ?>,\r\n				lines: { show: true, fill: false },\r\n				color: ''#4573A7''\r\n			},\r\n			{\r\n				label: ''POS Sales'',\r\n				data: <?php echo $json_sales; ?>,\r\n				lines: { show: true, fill: false },\r\n				color: ''#A94543''\r\n			},\r\n			{\r\n				label: ''Invoiced Sales'',\r\n				data: <?php echo $json_invoiced; ?>,\r\n				lines: { show: true, fill: false },\r\n				color: ''#DB843D''\r\n			},\r\n		],{\r\n			xaxis: {\r\n				ticks: [ \r\n					[14,''7.00AM''],  \r\n					[18,''9.00AM''],  \r\n					[22,''11.00AM''],   \r\n					[26,''1.00PM''],\r\n					[30,''3.00PM''], \r\n					[34,''5.00PM''], \r\n					[38,''7.00PM''], \r\n					[42,''9.00PM''], \r\n					[46,''11.00PM''],\r\n					[50,''01.00AM'']\r\n				],\r\n				min: 12,\r\n				max: 52,\r\n				color: ''#000000''\r\n			},\r\n			yaxis: {\r\n				min: 0,\r\n				color: ''#000000''\r\n			},\r\n			grid: {\r\n				backgroundColor: { colors: [''#FFFFFF'',''#F1F1F1'']},\r\n				color: ''#555'',\r\n				hoverable: true\r\n			}\r\n		});\r\n	}, 100);\r\n	\r\n	\r\nfunction showTooltip(x, y, contents) {\r\n	$(''<div class="plot-tooltip">'' + contents + ''</div>'').css({\r\n		position			: ''absolute'',\r\n		display				: ''none'',\r\n		top					: y + 5,\r\n		left				: x + 5,\r\n		''border-radius''		: ''0 5px 5px 5px'',\r\n		''padding''			: ''5px'',\r\n		''background-color''	: ''#333'',\r\n		''color''				: ''#FFF''\r\n	}).appendTo("body").fadeIn(200);\r\n}\r\n	\r\n$(function(){\r\n	\r\n	var previousPoint = null;\r\n	$("#currentMonthSales").bind("plothover", function (event, pos, item) {\r\n\r\n		if (item) {\r\n			if (previousPoint != item.dataIndex) {\r\n				previousPoint = item.dataIndex;\r\n				$(''div.plot-tooltip'').remove();\r\n				console.log(item);\r\n				var x = item.datapoint[0],\r\n					y = item.datapoint[1].toFixed(2);\r\n				\r\n				if (x > 25){\r\n					x -= 24;\r\n					var ampm = ''PM'';\r\n				} else {\r\n					var ampm = ''AM'';\r\n				}\r\n				var currency = ''<?php echo $this->system->config(''currency''); ?>'';\r\n				var time = (x / 48 * 24);\r\n				var hours = Math.floor(x / 48 * 24);\r\n				var minutes = (time - hours) * 60;\r\n				\r\n				if (hours == 0) hours = 12;\r\n				\r\n				var timeFormat = hours + '':'' + \r\n					(minutes == 0 ? ''00'' : minutes) + ampm;				\r\n\r\n                    \r\n				showTooltip(item.pageX, item.pageY, currency + y + '' at '' + timeFormat);\r\n			}\r\n		} else {\r\n			$(''div.plot-tooltip'').remove();\r\n			previousPoint = null;            \r\n		}\r\n\r\n    });\r\n})	\r\n</script>', NULL, '', NULL, '2012-11-11 11:35:35', 'admin', '2016-05-04 12:02:18', 'sysadmin'),
(15, 'F&B Sales Report', 'Report', 'Produces F&B sales report based on date range.', 'false', '0', 'list($day, $month, $year) = explode(''/'',$inputs[''date_from'']);\r\n$date_from = $year . ''-'' . $month . ''-'' . $day;\r\n$date_from = $date_from . '' 05:00:00'';\r\n\r\nlist($day, $month, $year) = explode(''/'',$inputs[''date_to'']);\r\n$date_to = $year . ''-'' . $month . ''-'' . $day;\r\n$date_to = date(''Y-m-d H:i:s'', strtotime($date_to . '' 23:59:59'') + (60 * 60 * 4));\r\n\r\n\r\n\r\n$query = $this->db->query("SELECT * FROM `fnb_cash_count` WHERE `session` >= ? AND `session` <= ?", \r\n						  array(strtotime($date_from), strtotime($date_to)));\r\n$cashouts = $query->result();\r\n\r\nforeach ($cashouts as $c){\r\n	$cs[] = $c->session;\r\n}\r\n$sess = implode('','',$cs);\r\n\r\n$query = $this->db->query("\r\n	SELECT * FROM `fnb_buffer_sales` \r\n	WHERE \r\n		`datetime` >= ? AND\r\n		`datetime` <= ? AND\r\n		`type` = ''history''\r\nUNION\r\n	SELECT * FROM `fnb_sales` \r\n	WHERE \r\n		`datetime` >= ? AND\r\n		`datetime` <= ? AND\r\n		`type` = ''history''\r\nORDER BY `id` ASC\r\n", array($date_from, $date_to, $date_from, $date_to));\r\n\r\n$sales = $query->result();\r\n						  \r\n$query = $this->db->query("\r\nSELECT SUM(`amount`) AS `total_sc` FROM \r\n	(SELECT * FROM `fnb_buffer_sale_items` \r\n	WHERE \r\n		`date` >= ? AND\r\n		`date` <= ? AND\r\n		`sold` = ''1'' AND\r\n		`item_sku` = ''_SC''\r\nUNION\r\n	SELECT * FROM `fnb_sale_items` \r\n	WHERE \r\n		`date` >= ? AND\r\n		`date` <= ? AND\r\n		`sold` = ''1'' AND\r\n		`item_sku` = ''_SC''\r\nORDER BY `id` ASC) AS T\r\n", array($date_from, $date_to, $date_from, $date_to));\r\n$sc = $query->row();', '<style>\r\n	table.print-standard {\r\n		border-collapse: collapse;\r\n		border-spacing: 0;\r\n		border: 1px solid #333;\r\n	}\r\n	\r\n	table.print-standard th {\r\n		background: #EEE;	\r\n		border: 1px solid #333;\r\n		padding: 2px 5px;\r\n		text-align: center;\r\n	}\r\n	\r\n	table.print-standard td {\r\n		border: 1px solid #333;\r\n		padding: 2px 5px;\r\n	}\r\n	\r\n	table.w100 {\r\n		width: 100%;	\r\n	}\r\n	\r\n	table.print-standard tr.footer {\r\n		background: #EEE;	\r\n	}\r\n</style>\r\n\r\n<h1><?php echo $this->system->config(''company_name''); ?></h1>\r\n<h2 style="text-align: center; margin-bottom: 0; padding-bottom: 0">F&amp;B Sales Report</h2>\r\n<p style="text-align: center;">\r\n	From \r\n		<?php echo date(''l, F j, Y'',strtotime($date_from)); ?> \r\n	to \r\n		<?php echo date(''l, F j, Y'',strtotime($date_to)); ?> \r\n</p>\r\n\r\n<table class="print-standard w100">\r\n	<thead>\r\n		<tr>\r\n			<th>Txn</th>\r\n			<th>Date/Time</th>\r\n			<th>Amount Cash (<?php echo $this->system->config(''currency''); ?>)</th>\r\n			<th>Amount Credit Card (<?php echo $this->system->config(''currency''); ?>)</th>\r\n			<th>Amount Voucher (<?php echo $this->system->config(''currency''); ?>)</th>\r\n			<th>Amount Cheque (<?php echo $this->system->config(''currency''); ?>)</th>\r\n			<th>Amount Discount (<?php echo $this->system->config(''currency''); ?>)</th>\r\n			<th>Amount (<?php echo $this->system->config(''currency''); ?>)</th>\r\n			<th>Service Charge (<?php echo $this->system->config(''currency''); ?>)</th>\r\n			<!--\r\n			<th>SR Tax (<?php echo $this->system->config(''currency''); ?>)</th>\r\n			<th>ZRL Tax (<?php echo $this->system->config(''currency''); ?>)</th>\r\n			-->\r\n			<th>GST (<?php echo $this->system->config(''currency''); ?>)</th>\r\n			<th>Net (<?php echo $this->system->config(''currency''); ?>)</th>\r\n			<th>Customer/Customer of</th>\r\n		</tr>\r\n	</thead>\r\n	<tbody>\r\n		<?php foreach ($sales as $sale): ?>\r\n		<?php\r\n			$SR = $sale->tax_amount;\r\n			$tax =($sale->amount - $sale->tax_amount) * 0.06;\r\n			$ZRL = str_replace('','','''',number_format($tax - $sale->tax_amount,2));\r\n			if ($ZRL < 0) $ZRL = 0;\r\n\r\n			$query = $this->db->query("SELECT * FROM `fnb_buffer_sale_items` WHERE `sale_id` = ? AND `item_sku` = ''_SC'' UNION \r\n					SELECT * FROM `fnb_sale_items` WHERE `sale_id` = ? AND `item_sku` = ''_SC''", array($sale->id, $sale->id));\r\n			$sca = $query->row();\r\n\r\n			$sca->amount = (double) str_replace('','','''',number_format($sca->amount * ((100 - $sca->global_discount) / 100),3));\r\n\r\n		?>\r\n		<tr>\r\n			<td>RC-<?php echo $sale->id; ?></td>\r\n			<td><?php echo date(''d/m/Y h:iA'',strtotime($sale->datetime)); ?></td>\r\n			<td style="text-align: right; width: 90px"><?php echo number_format($sale->amount_cash,2); ?></td>\r\n			<td style="text-align: right; width: 90px"><?php echo number_format($sale->amount_cc,2); ?></td>\r\n			<td style="text-align: right; width: 90px"><?php echo number_format($sale->amount_voucher,2); ?></td>\r\n			<td style="text-align: right; width: 90px"><?php echo number_format($sale->amount_cheque,2); ?></td>\r\n			<td style="text-align: right; width: 90px"><?php echo number_format($sale->amount_discount,2); ?></td>\r\n			<td style="text-align: right; width: 90px"><?php echo number_format($sale->amount,2); ?></td>\r\n			<td style="text-align: right; width: 90px"><?php echo number_format($sca->amount,2); ?></td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px"><?php echo number_format($SR,2); ?></td>\r\n			<td style="text-align: right; width: 90px"><?php echo number_format($ZRL,2); ?></td>\r\n			-->\r\n			<td style="text-align: right; width: 90px"><?php echo number_format($sale->tax_amount,2); ?></td>\r\n			<td style="text-align: right; width: 90px"><?php echo number_format($sale->amount- $sale->tax_amount-$sca->amount,2); ?></td>\r\n			<td><?php echo $sale->customer; ?></td>\r\n		</tr>\r\n		<?php 	\r\n			$t_ac	+= $sale->amount_cash;\r\n			$t_acc	+= $sale->amount_cc;\r\n			$t_av	+= $sale->amount_voucher;\r\n			$t_ach	+= $sale->amount_cheque;\r\n			$t_ad	+= $sale->amount_discount;\r\n			$t_sc	+= $sca->amount;\r\n			$t_a	+= $sale->amount;\r\n			$t_na	+= $sale->amount- $sale->tax_amount-$sca->amount;\r\n			$t_ta	+= $sale->tax_amount;\r\n			$t_sr	+= $SR;\r\n			$t_zrl 	+= $ZRL;\r\n			endforeach; \r\n		?>\r\n		<tr>\r\n			<td colspan="2"></td>\r\n			<td style="text-align: right; width: 90px"><?php echo number_format($t_ac,2); ?></td>\r\n			<td style="text-align: right; width: 90px"><?php echo number_format($t_acc,2); ?></td>\r\n			<td style="text-align: right; width: 90px"><?php echo number_format($t_av,2); ?></td>\r\n			<td style="text-align: right; width: 90px"><?php echo number_format($t_ach,2); ?></td>\r\n			<td style="text-align: right; width: 90px"><?php echo number_format($t_ad,2); ?></td>\r\n			<td style="text-align: right; width: 90px"><?php echo number_format($t_a,2); ?></td>\r\n			<td style="text-align: right; width: 90px"><?php echo number_format($t_sc,2); ?></td>\r\n\r\n			<!--\r\n			<td style="text-align: right; width: 90px"><?php echo number_format($t_sr,2); ?></td>\r\n			<td style="text-align: right; width: 90px"><?php echo number_format($t_zrl,2); ?></td>\r\n			-->\r\n			<td style="text-align: right; width: 90px"><?php echo number_format($t_ta,2); ?></td>\r\n			<td style="text-align: right; width: 90px"><?php echo number_format($t_na,2); ?></td>\r\n			<td></td>\r\n		</tr>\r\n		<tr>\r\n			<td colspan="2"></td>\r\n			<td style="text-align: center; width: 90px"><strong>CASH (A)</strong></td>\r\n			<td style="text-align: center; width: 90px">CREDIT CARD</td>\r\n			<td style="text-align: center; width: 90px">VOUCHER</td>\r\n			<td style="text-align: center; width: 90px">CHEQUE</td>\r\n			<td style="text-align: center; width: 90px">DISCOUNT</td>\r\n			<td style="text-align: center; width: 90px">AMOUNT</td>\r\n			<td style="text-align: center; width: 90px">SERVICE CHARGE</td>\r\n\r\n			<!--\r\n			<td style="text-align: center; width: 90px">SR TAX</td>\r\n			<td style="text-align: center; width: 90px">ZRL TAX</td>\r\n			-->\r\n			<td style="text-align: center; width: 90px">TAX</td>\r\n			<td style="text-align: center; width: 90px">NET AMOUNT</td>\r\n			<td></td>\r\n		</tr>\r\n	</tbody>\r\n	\r\n</table>\r\n\r\n<h2>Total Cashout</h2>\r\n<table class="print-standard w100">\r\n	<thead>\r\n		<tr>\r\n			<th>Cashout Date/Time</th>\r\n			<th>Amount</th>\r\n		</tr>\r\n	</thead>\r\n	<tbody>\r\n		<?php foreach ($cashouts as $cashout): ?>\r\n		<?php\r\n			$tc = $cashout->total_sales + $cashout->discrepancy;\r\n			if ($tc <= 0) $tc = 0;\r\n		?>\r\n		<tr>\r\n			<td><?php echo $cashout->to; ?></td>\r\n			<td style="text-align: right"><?php echo number_format($tc,2); ?></td>\r\n		</tr>\r\n		<?php\r\n			$t += $tc;\r\n		?>\r\n		<?php endforeach; ?>\r\n		<tr>\r\n			<td><strong>TOTAL CASHOUT (B)</strong></td>\r\n			<td style="text-align: right"><?php echo number_format($t, 2); ?></td>\r\n		</tr>\r\n		<tr>\r\n			<td><strong>TIP/(SHORT) (C)</strong></td>\r\n			<td style="text-align: right">\r\n				<?php $ts = $t_ac - $t; ?>\r\n				<?php if ($ts <= 0): ?>\r\n					<?php echo number_format(0-$ts, 2); ?>				\r\n				<?php else: ?>\r\n					(<?php echo number_format($ts, 2); ?>)\r\n				<?php endif; ?>\r\n			</td>\r\n		</tr>\r\n\r\n	</tbody>\r\n</table>\r\n\r\n', NULL, '<div class="filter" style="padding: 10px 5px; font-size: 10pt;">\r\n From\r\n	<input type="text" field="date_from" name="date" \r\n		value="<?php echo date(''d/m/Y''); ?>" \r\n		class="v-text date filter-date" style="width: 80px" />\r\n To\r\n	<input type="text" field="date_to" name="date" \r\n		value="<?php echo date(''d/m/Y''); ?>" \r\n		class="v-text date filter-date" style="width: 80px" />	\r\n	\r\n</div>\r\n<div style="margin-top: 10px"><a class="v-btn generate-btn">Generate</a></div>', NULL, '2015-08-13 14:00:39', 'admin', '2016-02-19 11:05:32', 'sysadmin'),
(16, 'Pax Count Widget', 'Widget', '', 'false', '0', 'if ($_REQUEST[''date'']){\r\n	list($day, $month, $year) = explode(''/'', $_REQUEST[''date'']);\r\n	$date = $year . ''-'' . $month . ''-'' . $day;\r\n} else {\r\n	$date = date(''Y-m-d'');	\r\n}\r\n\r\n$start = date(''Y-m-d 07:00:00'', strtotime($date));\r\n$end = date(''Y-m-d 11:00:00'', strtotime($date));\r\n$brunch_query = $this->db->query("\r\n		SELECT \r\n			SUM(`no_of_pax`) AS `total_pax`\r\n		FROM \r\n			`fnb_sales` \r\n		WHERE \r\n			`datetime` >= ''$start'' AND \r\n			`datetime` < ''$end'' AND \r\n			`payment_status` = ''Paid''\r\n		UNION\r\n		SELECT \r\n			SUM(`no_of_pax`)\r\n		FROM \r\n			`fnb_buffer_sales` \r\n		WHERE \r\n			`datetime` >= ''$start'' AND \r\n			`datetime` < ''$end'' AND \r\n			`payment_status` = ''Paid''\r\n	");\r\n\r\n$brunches = $brunch_query->result();\r\nforeach ($brunches as $brunch){\r\n	$brunch_pax += $brunch->total_pax;	\r\n}\r\n\r\n\r\n$start = date(''Y-m-d 11:00:00'', strtotime($date));\r\n$end = date(''Y-m-d 15:00:00'', strtotime($date));\r\n$lunch_query = $this->db->query("\r\n		SELECT \r\n			SUM(`no_of_pax`) AS `total_pax`\r\n		FROM \r\n			`fnb_sales` \r\n		WHERE \r\n			`datetime` >= ''$start'' AND \r\n			`datetime` < ''$end'' AND \r\n			`payment_status` = ''Paid''\r\n		UNION\r\n		SELECT \r\n			SUM(`no_of_pax`)\r\n		FROM \r\n			`fnb_buffer_sales` \r\n		WHERE \r\n			`datetime` >= ''$start'' AND \r\n			`datetime` < ''$end'' AND \r\n			`payment_status` = ''Paid''\r\n	");\r\n\r\n$lunches = $lunch_query->result();\r\nforeach ($lunches as $lunch){\r\n	$lunch_pax += $lunch->total_pax;	\r\n}\r\n\r\n\r\n\r\n\r\n$start = date(''Y-m-d 18:00:00'', strtotime($date));\r\n$end = date(''Y-m-d 23:59:59'', strtotime($date));\r\n$other_query = $this->db->query("\r\n		SELECT \r\n			SUM(`no_of_pax`) AS `total_pax`\r\n		FROM \r\n			`fnb_sales` \r\n		WHERE \r\n			`datetime` >= ''$start'' AND \r\n			`datetime` < ''$end'' AND \r\n			`payment_status` = ''Paid''\r\n		UNION\r\n		SELECT \r\n			SUM(`no_of_pax`)\r\n		FROM \r\n			`fnb_buffer_sales` \r\n		WHERE \r\n			`datetime` >= ''$start'' AND \r\n			`datetime` < ''$end'' AND \r\n			`payment_status` = ''Paid''\r\n	");\r\n\r\n$others = $other_query->result();\r\nforeach ($others as $other){\r\n	$other_pax += $other->total_pax;	\r\n}\r\n\r\n\r\n\r\n$start = date(''Y-m-d 15:00:00'', strtotime($date));\r\n$end = date(''Y-m-d 18:00:00'', strtotime($date));\r\n$other_query = $this->db->query("\r\n		SELECT \r\n			SUM(`no_of_pax`) AS `total_pax`\r\n		FROM \r\n			`fnb_sales` \r\n		WHERE \r\n			`datetime` >= ''$start'' AND \r\n			`datetime` < ''$end'' AND \r\n			`payment_status` = ''Paid''\r\n		UNION\r\n		SELECT \r\n			SUM(`no_of_pax`)\r\n		FROM \r\n			`fnb_buffer_sales` \r\n		WHERE \r\n			`datetime` >= ''$start'' AND \r\n			`datetime` < ''$end'' AND \r\n			`payment_status` = ''Paid''\r\n	");\r\n\r\n$teas = $other_query->result();\r\nforeach ($teas as $tea){\r\n	$tea_pax += $tea->total_pax;	\r\n}', '<script type="text/javascript">\r\n	\r\n	$(document).ready(function(){\r\n		$(''input.date'').dateEntry({dateFormat: ''dmy/'',spinnerImage: base_url+''images/spinnerDefault.png''})\r\n	})\r\n\r\n	function reloadPCWidget(){\r\n		var widget	= $(''.pc-widget'').parents(''div.dashboard-widget'').attr(''id'');\r\n		var wid		= widget.split(''-'');\r\n		var id		= wid[1];\r\n		var date	= $(''.pc-date'').val();\r\n		$(''#''+widget).html(''<p align="center"><img src="images/loading.gif"> Loading</p>'');\r\n		\r\n		$.ajax({\r\n			url: base_url + ''reports/generate_widget/'' + id,\r\n			type: ''post'',\r\n			data: ''date=''+date,\r\n			success: function (output){\r\n				$(''#''+widget).html(''<div class="container" style="display:none">''+output+''</div>'');\r\n				$(''#''+widget+'' div.container'').fadeIn();\r\n			\r\n				$(''input.date'').dateEntry({dateFormat: ''dmy/'',spinnerImage: base_url+''images/spinnerDefault.png''})\r\n			}\r\n		})\r\n\r\n	}\r\n	\r\n</script>\r\n\r\n<h3 style="background: #EEE; padding: 10px; margin: 0;">Pax Count</h3>\r\n\r\n<div class="pc-widget" style="padding: 10px;">\r\n	\r\n	<div style="float:right; padding-bottom: 20px">\r\n	Date: <input style="width: 80px" type="text" class="date v-text pc-date" \r\n		value="<?php echo date(''d/m/Y'',strtotime($date)); ?>" /> \r\n	<button onclick="reloadPCWidget()" class="v-btn">Go</button>\r\n	</div>\r\n\r\n	<table style="width: 100%">\r\n		<tr>\r\n			<td style="width: 20%">\r\n				7:00AM - 10:59AM<br />\r\n				<strong style="font-size: 15pt;">\r\n					<?php echo number_format($brunch_pax); ?> Pax\r\n				</strong>\r\n			</td>\r\n			<td style="width: 20%">\r\n				11:00AM - 02:59PM<br />\r\n				<strong style="font-size: 15pt;">\r\n					<?php echo number_format($lunch_pax); ?> Pax\r\n				</strong>\r\n			</td>\r\n			<td style="width: 20%">\r\n				03:00PM - 05:59PM<br />\r\n				<strong style="font-size: 15pt;">\r\n					<?php echo number_format($tea_pax); ?> Pax\r\n				</strong>\r\n			</td>\r\n			<td style="width: 20%">\r\n				06:00PM - 11:59PM<br />\r\n				<strong style="font-size: 15pt;">\r\n					<?php echo number_format($other_pax); ?> Pax\r\n				</strong>\r\n			</td>\r\n			<td style="width: 20%"></td>\r\n			<td style="width: 20%">\r\n		\r\n			</td>\r\n		</tr>\r\n	</table>\r\n</div>\r\n', NULL, '', NULL, '2015-08-14 20:26:42', 'admin', '2016-05-04 12:12:03', 'sysadmin'),
(7, 'F&B Sold Items Report', 'Report', 'Produces F&B sold items report based on date range.', 'false', '0', 'list($day, $month, $year) = explode(''/'',$inputs[''date_from'']);\r\n$date_from = $year . ''-'' . $month . ''-'' . $day;\r\n$date_from = $date_from . '' 00:00:00'';\r\n\r\nlist($day, $month, $year) = explode(''/'',$inputs[''date_to'']);\r\n$date_to = $year . ''-'' . $month . ''-'' . $day;\r\n$date_to = $date_to . '' 23:59:59'';\r\n\r\n$query = $this->db->query("\r\nSELECT\r\n	`item_sku`, SUM(`total_amount`) AS `total_amount`, SUM(`total_qty`) AS `total_qty`, `item_name` FROM\r\n	(SELECT \r\n		`item_sku`,\r\n		`item_name`,\r\n		SUM(`qty`) AS `total_qty`,\r\n		SUM(`amount`) AS `total_amount`\r\n	FROM\r\n		`fnb_sale_items` \r\n	WHERE \r\n		`date` >= ? AND\r\n		`date` <= ? AND\r\n		`sold` = 1 AND\r\n		`item_sku` != ''_SC''\r\n	GROUP BY\r\n		`item_sku`\r\n	UNION\r\n	SELECT \r\n		`item_sku`,\r\n		`item_name`,\r\n		SUM(`qty`) AS `total_qty`,\r\n		SUM(`amount`) AS `total_amount`\r\n	FROM\r\n		`fnb_buffer_sale_items`\r\n	WHERE \r\n		`date` >= ? AND\r\n		`date` <= ? AND\r\n		`sold` = 1 AND\r\n		`item_sku` != ''_SC''\r\n	GROUP BY\r\n		`item_sku`\r\n	DESC) \r\n	AS T GROUP BY `item_sku`\r\n	ORDER BY `item_name` ASC", array($date_from, $date_to,$date_from, $date_to));\r\n				\r\n$items = $query->result();\r\n\r\n', '<style>\r\n	table.print-standard {\r\n		border-collapse: collapse;\r\n		border-spacing: 0;\r\n		border: 1px solid #333;\r\n	}\r\n	\r\n	table.print-standard th {\r\n		background: #EEE;	\r\n		border: 1px solid #333;\r\n		padding: 2px 5px;\r\n		text-align: center;\r\n	}\r\n	\r\n	table.print-standard td {\r\n		border: 1px solid #333;\r\n		padding: 2px 5px;\r\n	}\r\n	\r\n	table.w100 {\r\n		width: 100%;	\r\n	}\r\n	\r\n	table.print-standard tr.footer {\r\n		background: #EEE;	\r\n	}\r\n</style>\r\n\r\n<h1><?php echo $this->system->config(''company_name''); ?></h1>\r\n<h2 style="text-align: center; margin-bottom: 0; padding-bottom: 0">F&amp;B Items Sold</h2>\r\n<p style="text-align: center;">\r\n	From \r\n		<?php echo date(''l, F j, Y'',strtotime($date_from)); ?> \r\n	to \r\n		<?php echo date(''l, F j, Y'',strtotime($date_to)); ?> \r\n</p>\r\n\r\n<table class="print-standard w100">\r\n	<thead>\r\n		<tr>\r\n			<th>Item</th>\r\n			<th>SKU</th>\r\n			<th style="width: 150px">\r\n				Total Quantity\r\n			</th>\r\n			<th style="width: 150px">\r\n				Total Amount (<?php echo $this->system->config(''currency''); ?>)\r\n			</th>\r\n		</tr>\r\n	</thead>\r\n	<tbody>\r\n		<?php foreach ($items as $item): ?>\r\n		<tr>\r\n			<td><?php echo $item->item_name; ?></td>\r\n			<td><?php echo $item->item_sku; ?></td>\r\n			<td style="width: 150px; text-align: center">\r\n				<?php echo number_format($item->total_qty); ?>\r\n			</td>\r\n			<td style="width: 150px; text-align: right">\r\n				<?php echo number_format($item->total_amount,2); ?>\r\n			</td>\r\n		</tr>\r\n		<?php 	$grand_total_qty += $item->total_qty;\r\n				$grand_total_amount += $item->total_amount;		\r\n			endforeach; \r\n		?>\r\n		<tr>\r\n			<td colspan="2"><strong>TOTAL</strong></td>\r\n			<td style="text-align: center; font-weight: bold">\r\n				<?php echo number_format($grand_total_qty); ?>\r\n			</td>\r\n			<td style="text-align: right; font-weight: bold">\r\n				<?php echo number_format($grand_total_amount,2); ?>\r\n			</td>\r\n		</tr>\r\n	</tbody>\r\n	\r\n</table>', NULL, '<div class="filter" style="padding: 10px 5px; font-size: 10pt;">\r\n From\r\n	<input type="text" field="date_from" name="date" \r\n		value="<?php echo date(''d/m/Y''); ?>" \r\n		class="v-text date filter-date" style="width: 80px" />\r\n To\r\n	<input type="text" field="date_to" name="date" \r\n		value="<?php echo date(''d/m/Y''); ?>" \r\n		class="v-text date filter-date" style="width: 80px" />	\r\n	\r\n</div>\r\n<div style="margin-top: 10px"><a class="v-btn generate-btn">Generate</a></div>', NULL, '2013-09-27 12:12:15', 'admin', '2016-03-02 17:48:51', 'sysadmin'),
(8, 'F&B Staff Performance Report', 'Report', 'Displays staff sales performance.', 'false', '0', '$date_from = $this->input->post(''date_from'');\r\n$date_to = $this->input->post(''date_to'');\r\n\r\nlist($day, $month, $year) = explode(''/'', $date_from);\r\n$from = $year . ''-'' . $month . ''-'' . $day;\r\n\r\nlist($day, $month, $year) = explode(''/'', $date_to);\r\n$to = $year . ''-'' . $month . ''-'' . $day;\r\n\r\n\r\n$query = $this->db->query("\r\n	SELECT \r\n		SUM(`amount`) AS `total_sales`, \r\n		`ordered_by`\r\n	FROM\r\n		`fnb_sale_items`\r\n	WHERE \r\n		`date` >= ? AND\r\n		`date` <= ? AND\r\n		`sold` = 1\r\n	GROUP BY\r\n		`ordered_by`\r\n	ORDER BY\r\n		`total_sales`\r\n	DESC", array(\r\n			$from . '' 00:00:00'',\r\n			$to . '' 23:59:59''\r\n		));\r\n\r\n$staff_performance = $query->result();', '<h2 style="text-align: center; margin-bottom: 0; padding-bottom: 0">\r\n	Staff F&amp;B Performance Report\r\n</h2>\r\n<p style="text-align: center; \r\n	padding-bottom: 10px; margin-bottom: 20px; border-bottom: 1px solid #CCC">\r\n	Date Range: \r\n	<?php echo date(''l, F j, Y'',strtotime($from)); ?> - \r\n	<?php echo date(''l, F j, Y'',strtotime($to)); ?>\r\n</p>\r\n<table class="grid">\r\n	<thead>\r\n		<tr>\r\n			<th>User</th>\r\n			<th>Sales</th>\r\n		</tr>\r\n	</thead>\r\n	<tbody>\r\n		<?php foreach ($staff_performance as $staff): ?>\r\n		<tr>\r\n			<td>\r\n				<?php echo $staff->ordered_by ? $staff->ordered_by : ''Unknown''; ?>\r\n			</td>\r\n			<td style="text-align: right">\r\n				<?php echo number_format($staff->total_sales, 2); ?>\r\n			</td>\r\n		</tr>\r\n		<?php endforeach; ?>\r\n	</tbody>\r\n</table>\r\n\r\n<hr />', NULL, '<div class="filter" style="padding: 10px 5px; font-size: 10pt;">\r\n Date \r\n	<input type="text" field="date_from" name="date" value="<?php echo date(''d/m/Y''); ?>" \r\n		class="v-text date filter-date" style="width: 80px" />\r\n	\r\n	<input type="text" field="date_to" name="date" value="<?php echo date(''d/m/Y''); ?>" \r\n		class="v-text date filter-date" style="width: 80px" />  \r\n\r\n</div>\r\n	<div style="margin-top: 10px"><a class="v-btn generate-btn">Generate</a></div>\r\n', NULL, '2013-10-07 19:08:51', 'admin', NULL, NULL),
(9, 'F&B Category Sales Report', 'Report', 'Displays sales report by category.', 'false', '0', '$date_from = $this->input->post(''date_from'');\r\n$date_to = $this->input->post(''date_to'');\r\n\r\nlist($day, $month, $year) = explode(''/'', $date_from);\r\n$from = $year . ''-'' . $month . ''-'' . $day;\r\n\r\nlist($day, $month, $year) = explode(''/'', $date_to);\r\n$to = date(''Y-m-d H:i:s'',strtotime($year . ''-'' . $month . ''-'' . $day) + (60 * 60 * 26));\r\n\r\n$this->db->query("UPDATE `fnb_sale_items`  SET `category` = ''SERVICE CHARGE'' WHERE `item_sku` = ''_SC''");\r\n\r\n$query = $this->db->query("\r\nSELECT\r\n	`item_sku`, SUM(`total_sales`) AS `total_sales`, SUM(`total_discount`) AS `total_discount`, SUM(`total_net`) AS `total_net`, `category` FROM\r\n	(SELECT \r\n		`item_sku`,\r\n		(`amount`) AS `total_sales`, \r\n		(ROUND(`amount` * (IF(`global_discount` IS NULL,0,`global_discount`) / 100),3)) AS `total_discount`,\r\n		(`amount` - ROUND(`amount` * (IF(`global_discount` IS NULL,0,`global_discount`) / 100),3)) AS `total_net`,\r\n		IF(`category` IS NULL, ''SERVICE CHARGE'', `category`) AS `category`\r\n	FROM\r\n		`fnb_sale_items` \r\n	WHERE \r\n		`ordered_time` >= ? AND\r\n		`ordered_time` <= ? AND\r\n		`sale_id` != 0 AND\r\n		`sold` = 1\r\n	) AS T GROUP BY `category`\r\n	ORDER BY `total_sales` DESC\r\n", array(\r\n			$from . '' 06:00:00'',\r\n			$to,\r\n			$from . '' 06:00:00'',\r\n			$to\r\n		));\r\n\r\n$sales_per_category = $query->result();\r\n\r\n\r\n\r\nforeach ($sales_per_category as $sale){\r\n	$s = null;\r\n	if ($sale->category){\r\n		$s->label = $sale->item_sku == ''_SC'' ? ''SERVICE CHARGE'' : ($sale->category ? $sale->category : ''Uncategorized'');\r\n		$s->data = (double) $sale->total_sales;\r\n		$data[] = $s;\r\n	}\r\n}\r\n\r\n$pie_chart_data = json_encode($data);', '<h2 style="text-align: center; margin-bottom: 0; padding-bottom: 0">\r\n	F&amp;B Sales Report\r\n</h2>\r\n<p style="text-align: center; \r\n	padding-bottom: 10px; margin-bottom: 20px; border-bottom: 1px solid #CCC">\r\n	Date Range: \r\n	<?php echo date(''l, F j, Y'',strtotime($from)); ?> - \r\n	<?php echo date(''l, F j, Y'',strtotime($to)); ?>\r\n</p>\r\n<div id="piechart" style="height: 350px; width: 100%">\r\n	\r\n</div>\r\n<table class="grid">\r\n	<thead>\r\n		<tr>\r\n			<th>Category</th>\r\n			<th>Amount</th>\r\n			<th>Discount Given</th>\r\n			<th>Net Amount</th>\r\n		</tr>\r\n	</thead>\r\n	<tbody>\r\n		<?php foreach ($sales_per_category as $sale): if ($sale->total_sales): ?>\r\n		<?php if ($sale->item_sku == ''_SC''): ?>\r\n			<?php\r\n				$svc_total_sales += (double) str_replace('','','''',number_format($sale->total_sales,2));\r\n				$svc_total_discount += (double) str_replace('','','''',number_format($sale->total_discount,2));;\r\n				$svc_net = $svc_total_sales - $svc_total_discount;\r\n			?>\r\n		<?php else: ?>\r\n		<tr>\r\n			<td>\r\n				<?php echo $sale->item_sku == ''_SC'' ? ''SERVICE CHARGE'' : ($sale->category ? $sale->category : ''Uncategorized''); ?>\r\n			</td>\r\n			<td style="text-align: right">\r\n				<?php echo number_format($sale->total_sales, 2); ?>\r\n			</td>\r\n			<td style="text-align: right">\r\n				<?php echo number_format($sale->total_discount, 2); ?>\r\n			</td>\r\n			<td style="text-align: right">\r\n				<?php echo number_format($sale->total_net, 2); ?>\r\n			</td>\r\n		</tr>\r\n		<?php\r\n			$ts += $sale->total_sales;\r\n			$td += $sale->total_discount;\r\n			$tn += $sale->total_net;\r\n		?>\r\n		<?php endif; ?>\r\n\r\n		<?php endif; endforeach; ?>\r\n		<tr>\r\n			<td>SERVICE CHARGE</td>\r\n			<td style="text-align: right">\r\n				<?php echo number_format($svc_total_sales, 2); ?>\r\n			</td>\r\n			<td style="text-align: right">\r\n				<?php echo number_format($svc_total_discount, 2); ?>\r\n			</td>\r\n			<td style="text-align: right">\r\n				<?php echo number_format($svc_net, 2); ?>\r\n			</td>\r\n		</tr>\r\n		<tr>\r\n			<td>TOTAL WITH SERVICE CHARGE</td>\r\n			<td style="text-align: right"><strong><?php echo number_format($ts+$svc_total_sales,2); ?></strong></td>\r\n			<td style="text-align: right"><strong><?php echo number_format($td+$svc_total_discount,2); ?></strong></td>\r\n			<td style="text-align: right"><strong><?php echo number_format($tn+$svc_net,2); ?></strong></td>\r\n		</tr>\r\n		<tr>\r\n			<td>NET TOTAL </td>\r\n			<td style="text-align: right"><strong><?php echo number_format($ts,2); ?></strong></td>\r\n			<td style="text-align: right"><strong><?php echo number_format($td,2); ?></strong></td>\r\n			<td style="text-align: right"><strong><?php echo number_format($tn,2); ?></strong></td>\r\n		</tr>\r\n	</tbody>\r\n</table>\r\n<hr />\r\n\r\n\r\n\r\n<hr />\r\n\r\n<script type="text/javascript" src="js/flot/jquery.flot.pie.js"></script>\r\n<script type="text/javascript">\r\n	\r\n	$(document).ready(function(){\r\n		setTimeout(function(){\r\n			var data = <?php echo $pie_chart_data; ?>;\r\n			$.plot(''#piechart'', data, {\r\n				series: {\r\n					pie: { \r\n						show: true\r\n					}\r\n				},\r\n				legend: {\r\n					show: false\r\n				}\r\n			});\r\n		}, 200);\r\n	});\r\n	\r\n</script>\r\n', NULL, '<div class="filter" style="padding: 10px 5px; font-size: 10pt;">\r\n Date \r\n	<input type="text" field="date_from" name="date" value="<?php echo date(''d/m/Y''); ?>" \r\n		class="v-text date filter-date" style="width: 80px" />\r\n	\r\n	<input type="text" field="date_to" name="date" value="<?php echo date(''d/m/Y''); ?>" \r\n		class="v-text date filter-date" style="width: 80px" />  \r\n\r\n</div>\r\n<div style="margin-top: 10px"><a class="v-btn generate-btn">Generate</a></div>\r\n', NULL, '2013-10-07 19:09:32', 'admin', '2016-06-01 16:38:11', 'sysadmin'),
(20, 'Sales by Hour Widget', 'Widget', '', 'false', '0', 'if ($_REQUEST[''date'']){\r\n	list($day, $month, $year) = explode(''/'', $_REQUEST[''date'']);\r\n	$date = $year . ''-'' . $month . ''-'' . $day;\r\n} else {\r\n	$date = date(''Y-m-d'');	\r\n}\r\n\r\n\r\n$start = date(''Y-m-d 07:00:00'', strtotime($date));\r\n$end = date(''Y-m-d 11:00:00'', strtotime($date));\r\n$brunch_query = $this->db->query("\r\n		SELECT \r\n			SUM(`amount`) AS `total_amount`\r\n		FROM \r\n			`fnb_sales` \r\n		WHERE \r\n			`datetime` >= ''$start'' AND \r\n			`datetime` < ''$end'' AND \r\n			`payment_status` = ''Paid''\r\n		UNION\r\n		SELECT \r\n			SUM(`amount`) AS `total_amount`\r\n		FROM \r\n			`fnb_buffer_sales` \r\n		WHERE \r\n			`datetime` >= ''$start'' AND \r\n			`datetime` < ''$end'' AND \r\n			`payment_status` = ''Paid''\r\n	");\r\n\r\n$brunches = $brunch_query->result();\r\nforeach ($brunches as $brunch){\r\n	$brunch_amount += $brunch->total_amount;	\r\n}\r\n\r\n\r\n$start = date(''Y-m-d 11:00:00'', strtotime($date));\r\n$end = date(''Y-m-d 15:00:00'', strtotime($date));\r\n$lunch_query = $this->db->query("\r\n		SELECT \r\n			SUM(`amount`) AS `total_amount`\r\n		FROM \r\n			`fnb_sales` \r\n		WHERE \r\n			`datetime` >= ''$start'' AND \r\n			`datetime` < ''$end'' AND \r\n			`payment_status` = ''Paid''\r\n		UNION\r\n		SELECT \r\n			SUM(`amount`) AS `total_amount`\r\n		FROM \r\n			`fnb_buffer_sales` \r\n		WHERE \r\n			`datetime` >= ''$start'' AND \r\n			`datetime` < ''$end'' AND \r\n			`payment_status` = ''Paid''\r\n	");\r\n\r\n$lunches = $lunch_query->result();\r\nforeach ($lunches as $lunch){\r\n	$lunch_amount += $lunch->total_amount;	\r\n}\r\n\r\n\r\n\r\n\r\n$start = date(''Y-m-d 18:00:00'', strtotime($date));\r\n$end = date(''Y-m-d 23:59:59'', strtotime($date));\r\n$other_query = $this->db->query("\r\n		SELECT \r\n			SUM(`amount`) AS `total_amount`\r\n		FROM \r\n			`fnb_sales` \r\n		WHERE \r\n			`datetime` >= ''$start'' AND \r\n			`datetime` < ''$end'' AND \r\n			`payment_status` = ''Paid''\r\n		UNION\r\n		SELECT \r\n			SUM(`amount`) AS `total_amount`\r\n		FROM \r\n			`fnb_buffer_sales` \r\n		WHERE \r\n			`datetime` >= ''$start'' AND \r\n			`datetime` < ''$end'' AND \r\n			`payment_status` = ''Paid''\r\n	");\r\n\r\n$others = $other_query->result();\r\nforeach ($others as $other){\r\n	$other_amount += $other->total_amount;	\r\n}\r\n\r\n\r\n\r\n$start = date(''Y-m-d 15:00:00'', strtotime($date));\r\n$end = date(''Y-m-d 18:00:00'', strtotime($date));\r\n$other_query = $this->db->query("\r\n		SELECT \r\n			SUM(`amount`) AS `total_amount`\r\n		FROM \r\n			`fnb_sales` \r\n		WHERE \r\n			`datetime` >= ''$start'' AND \r\n			`datetime` < ''$end'' AND \r\n			`payment_status` = ''Paid''\r\n		UNION\r\n		SELECT \r\n			SUM(`amount`) AS `total_amount`\r\n		FROM \r\n			`fnb_buffer_sales` \r\n		WHERE \r\n			`datetime` >= ''$start'' AND \r\n			`datetime` < ''$end'' AND \r\n			`payment_status` = ''Paid''\r\n	");\r\n\r\n$teas = $other_query->result();\r\nforeach ($teas as $tea){\r\n	$tea_amount += $tea->total_amount;	\r\n}', '<script type="text/javascript">\r\n	\r\n	$(document).ready(function(){\r\n		$(''input.date'').dateEntry({dateFormat: ''dmy/'',spinnerImage: base_url+''images/spinnerDefault.png''})\r\n	})\r\n\r\n	function reloadSBHWidget(){\r\n		var widget	= $(''.sbh-widget'').parents(''div.dashboard-widget'').attr(''id'');\r\n		var wid		= widget.split(''-'');\r\n		var id		= wid[1];\r\n		var date	= $(''.sbh-date'').val();\r\n		$(''#''+widget).html(''<p align="center"><img src="images/loading.gif"> Loading</p>'');\r\n		\r\n		$.ajax({\r\n			url: base_url + ''reports/generate_widget/'' + id,\r\n			type: ''post'',\r\n			data: ''date=''+date,\r\n			success: function (output){\r\n				$(''#''+widget).html(''<div class="container" style="display:none">''+output+''</div>'');\r\n				$(''#''+widget+'' div.container'').fadeIn();\r\n			\r\n				$(''input.date'').dateEntry({dateFormat: ''dmy/'',spinnerImage: base_url+''images/spinnerDefault.png''})\r\n			}\r\n		})\r\n\r\n	}\r\n	\r\n</script>\r\n\r\n<h3 style="background: #EEE; padding: 10px; margin: 0;">Sales by Hours</h3>\r\n\r\n<div class="sbh-widget" style="padding: 10px;">\r\n	\r\n	<div style="float:right; padding-bottom: 20px">\r\n	Date: <input style="width: 80px" type="text" class="date v-text sbh-date" \r\n		value="<?php echo date(''d/m/Y'',strtotime($date)); ?>" /> \r\n	<button onclick="reloadSBHWidget()" class="v-btn">Go</button>\r\n	</div>\r\n\r\n	<table style="width: 100%">\r\n		<tr>\r\n			<td style="width: 20%">\r\n				7:00AM - 10:59AM<br />\r\n				<strong style="font-size: 15pt;">\r\n					<?php echo number_format($brunch_amount,2); ?>\r\n				</strong>\r\n			</td>\r\n			<td style="width: 20%">\r\n				11:00AM - 02:59PM<br />\r\n				<strong style="font-size: 15pt;">\r\n					<?php echo number_format($lunch_amount,2); ?>\r\n				</strong>\r\n			</td>\r\n			<td style="width: 20%">\r\n				03:00PM - 05:59PM<br />\r\n				<strong style="font-size: 15pt;">\r\n					<?php echo number_format($tea_amount,2); ?>\r\n				</strong>\r\n			</td>\r\n			<td style="width: 20%">\r\n				06:00PM - 11:59PM<br />\r\n				<strong style="font-size: 15pt;">\r\n					<?php echo number_format($other_amount,2); ?>\r\n				</strong>\r\n			</td>\r\n			<td style="width: 20%"></td>\r\n			<td style="width: 20%">\r\n		\r\n			</td>\r\n		</tr>\r\n	</table>\r\n</div>\r\n', NULL, '', NULL, '2016-05-04 11:18:34', 'sysadmin', '2016-05-04 12:09:35', 'sysadmin'),
(11, 'GST Report', 'Report', 'Generates GST Report based on date range.', 'false', '0', 'list($day, $month, $year) = explode(''/'',$inputs[''date_from'']);\r\n$date_from = $year . ''-'' . $month . ''-'' . $day;\r\n\r\nlist($day, $month, $year) = explode(''/'',$inputs[''date_to'']);\r\n$date_to = $year . ''-'' . $month . ''-'' . $day;\r\n\r\n$branch = $this->system->get_branch_by_id(1);\r\n\r\n$query = $this->db->query("\r\n	SELECT \r\n		SUM(`tax_amount`) AS `tax` \r\n	FROM \r\n		`fnb_sales` \r\n	WHERE \r\n		`datetime` >= ? AND\r\n		`datetime` <= ? AND\r\n		`type` = ''History''", \r\n	array($date_from . '' 00:00:00'', $date_to . '' 23:59:59''));\r\n$pos = $query->row();\r\n\r\n$query = $this->db->query("\r\n	SELECT \r\n		SUM(`total_tax`) AS `tax` \r\n	FROM \r\n		`invoices` \r\n	WHERE \r\n		`date` >= ? AND\r\n		`date` <= ?", \r\n	array($date_from . '' 00:00:00'', $date_to . '' 23:59:59''));\r\n$invoice = $query->row();\r\n\r\n$query = $this->db->query("\r\n	SELECT \r\n		SUM(`total_tax`) AS `tax` \r\n	FROM \r\n		`purchase_orders` \r\n	WHERE \r\n		`date` >= ? AND\r\n		`date` <= ?", \r\n	array($date_from . '' 00:00:00'', $date_to . '' 23:59:59''));\r\n$po = $query->row();\r\n\r\n$total_output_tax = $pos->tax + $invoice->tax;\r\n$total_input_tax = $po->tax;\r\n\r\n$claimable = ($c = $total_input_tax - $total_output_tax) > 0 ? $c : 0;\r\n$payable = ($p = $total_output_tax - $total_input_tax) > 0 ? $p : 0;\r\n\r\n\r\n\r\n$query = $this->db->query("SELECT SUM(`amount`) AS `total` FROM `fnb_sale_items`\r\n	WHERE \r\n		`date` >= ? AND\r\n		`date` <= ? AND\r\n		`tax_code` = ''ZRL''", \r\n	array($date_from . '' 00:00:00'', $date_to . '' 23:59:59''));\r\n$pos_zrl = $query->row();\r\n\r\n$query = $this->db->query("SELECT SUM(`price`) AS `total` FROM `invoice_items`\r\n	WHERE \r\n		`date` >= ? AND\r\n		`date` <= ? AND\r\n		`tax_code` = ''ZRL''", \r\n	array($date_from . '' 00:00:00'', $date_to . '' 23:59:59''));\r\n$po_zrl = $query->row();\r\n\r\n$total_zrl = $pos_zrl->total + $po_zrl->total;', '<style>\r\n	table td {\r\n		padding: 5px;\r\n		\r\n	}\r\n</style>\r\n\r\n<div style="text-align: center">\r\n	<h3><?php echo $branch->name; ?></h3>\r\n	<?php echo $branch->address1; ?><br />\r\n	<?php if ($branch->address2): ?>\r\n		<?php echo $branch->address2; ?><br />\r\n	<?php endif; ?>\r\n	<?php echo $branch->zipcode; ?> <?php echo $branch->city; ?><br />\r\n	<?php echo $branch->state; ?><br />\r\n	<?php echo $branch->country; ?><br />\r\n	<?php if ($branch->tel): ?>\r\n		Tel: <?php echo $branch->tel; ?>\r\n	<?php endif; ?>\r\n	<?php if ($branch->fax): ?>\r\n		&nbsp;&nbsp;&nbsp; Fax: <?php echo $branch->fax; ?>\r\n	<?php endif; ?>\r\n</div>\r\n\r\n<hr />\r\n\r\n<h3 style="text-align: center">GST TRANSACTION SUMMARY \r\n	(<?php echo date(''d/m/Y'',strtotime($date_from)); ?> to <?php echo date(''d/m/Y'',strtotime($date_to)); ?>)\r\n</h3>\r\n\r\n<table style="width: 100%">\r\n	<tr>\r\n		<td></td>\r\n		<td style="border-bottom: 1px solid #000; text-align: right">RM</td>\r\n	</tr>\r\n	<tr>\r\n		<td>Total Value of Standard Rated Supplies [SR]</td>\r\n		<td style="text-align: right"><?php echo number_format($total_output_tax/0.06,2); ?></td>\r\n	</tr>\r\n	<tr>\r\n		<td>Total Output Tax</td>\r\n		<td style="text-align: right"><?php echo number_format($total_output_tax,2); ?></td>\r\n	</tr>\r\n	<tr>\r\n		<td>Total Value of Standard Rated Purchases [TX]</td>\r\n		<td style="text-align: right"><?php echo number_format($total_input_tax/0.06,2); ?></td>\r\n	</tr>\r\n	<tr>\r\n		<td>Total Input Tax</td>\r\n		<td style="text-align: right"><?php echo number_format($total_input_tax,2); ?></td>\r\n	</tr>\r\n	<tr>\r\n		<td style="font-weight: bold">GST Amount Payable</td>\r\n		<td style="font-weight: bold; text-align: right"><?php echo number_format($payable,2); ?></td>\r\n	</tr>\r\n	<tr>\r\n		<td style="font-weight: bold">GST Amount Claimable</td>\r\n		<td style="font-weight: bold; text-align: right"><?php echo number_format($claimable,2); ?></td>\r\n	</tr>\r\n	<tr>\r\n		<td>Total Value of Zero Rated Supplies</td>\r\n		<td style="text-align: right"><?php echo number_format($total_zrl,2); ?></td>\r\n	</tr>\r\n	<tr>\r\n		<td>Total Value of Export Supplies</td>\r\n		<td style="text-align: right">0.00</td>\r\n	</tr>\r\n	<tr>\r\n		<td>Total Value of Exempt Supplies</td>\r\n		<td style="text-align: right">0.00</td>\r\n	</tr>\r\n	<tr>\r\n		<td>Total Value of Supplies Granted GST Relief</td>\r\n		<td style="text-align: right">0.00</td>\r\n	</tr>\r\n	<tr>\r\n		<td>Total Value of Goods Implemented Under ATS</td>\r\n		<td style="text-align: right">0.00</td>\r\n	</tr>\r\n	<tr>\r\n		<td>Total Value GST Suspended Under ATS</td>\r\n		<td style="text-align: right">0.00</td>\r\n	</tr>\r\n	<tr>\r\n		<td>Total Value of Capital Gains Acquired</td>\r\n		<td style="text-align: right">0.00</td>\r\n	</tr>\r\n	<tr>\r\n		<td>Bad Debt Relief</td>\r\n		<td style="text-align: right">0.00</td>\r\n	</tr>\r\n	<tr>\r\n		<td>Bad Debt Recovered</td>\r\n		<td style="text-align: right">0.00</td>\r\n	</tr>\r\n</table>', NULL, '<?php \r\n\r\n	$query = $this->db->query("SELECT * FROM `warehouses` ORDER BY `name` ASC");\r\n	foreach ($query->result() as $branch){\r\n		$branches_dropdown[$branch->id] = $branch->name;\r\n	}\r\n\r\n?>\r\n<div class="filter" style="padding: 10px 5px; font-size: 10pt;">\r\n From\r\n	<input type="text" field="date_from" name="date" \r\n		value="<?php echo date(''d/m/Y''); ?>" \r\n		class="v-text date filter-date" style="width: 80px" />\r\n To\r\n	<input type="text" field="date_to" name="date" \r\n		value="<?php echo date(''d/m/Y''); ?>" \r\n		class="v-text date filter-date" style="width: 80px" />	\r\n	\r\n</div>\r\n<div style="margin-top: 10px"><a class="v-btn generate-btn">Generate</a></div>', NULL, '2015-01-22 11:52:26', 'admin', '2015-09-29 11:05:15', 'sysadmin');
INSERT INTO `reports` (`id`, `name`, `type`, `description`, `modules`, `permissions`, `process_script`, `display_script`, `script`, `filters`, `frontend`, `added_on`, `added_by`, `modified_on`, `modified_by`) VALUES
(12, 'F&B Cashout Report', 'Report', 'Generate any cashout report from last 100 sessions.', 'false', '0', '$cc_id = $inputs[''cash_count_id''];\r\n\r\n$query = $this->db->query("SELECT * FROM `fnb_cash_count` WHERE `id` = ?", array($cc_id));\r\n$cash_count = $query->row();\r\n\r\n$query = $this->db->query("SELECT \r\n		SUM(`amount`) AS `total_sales`, \r\n		SUM(`amount_discount`) AS `total_discount`,\r\n		SUM(`adjustment`) AS `total_adjustment`,\r\n		SUM(`tax_amount`) AS `total_tax`\r\n	FROM `fnb_sales` \r\n	WHERE `session` = ? ORDER BY `id` ASC", array(\r\n	$cash_count->session\r\n));\r\n$sales = $query->row();\r\n\r\n$query = $this->db->query("SELECT SUM(`amount_cash`) AS `total_cash`, \r\n	SUM(`amount_cc`) AS `total_cc`, \r\n	SUM(`amount_voucher`) AS `total_voucher`, \r\n	SUM(`amount_cheque`) AS `total_cheque` FROM `fnb_sales` \r\n	WHERE `session` = ? AND `type` = ''history'' \r\n	ORDER BY `datetime` DESC",array($cash_count->session));	\r\n$pm_breakdown = $query->row();\r\n\r\n\r\n$query = $this->db->query("SELECT\r\n		COUNT(`id`) AS `total_items`\r\n	FROM `fnb_sale_items`\r\n	WHERE `session` = ?", array($cash_count->session));\r\n$items = $query->row();\r\n\r\n$query = $this->db->query("\r\n	SELECT \r\n		SUM(`amount`) AS `total`,\r\n		tax_code\r\n	FROM `fnb_sale_items` \r\n	WHERE `session` = ?\r\n	GROUP BY `tax_code`", \r\narray(\r\n	$cash_count->session\r\n));\r\n$tax_breakdown = $query->result();\r\n\r\n\r\n$from = date(''d/m/Y h:iA'',strtotime($cash_count->from));\r\n$to = date(''d/m/Y h:iA'', strtotime($cash_count->to));\r\n$total_sales = $sales->total_sales;\r\n$total_discount = $sales->total_discount;\r\n$total_adjustment = $sales->total_adjustment;\r\n$total_tax = $sales->total_tax;\r\n$deposited = $cash_count->total_sales + $cash_count->discrepancy;\r\n$session_no = $cash_count->session;\r\n$total_items = $items->total_items;\r\n\r\n$query = $this->db->query("SELECT * \r\n	FROM `fnb_reverts` \r\n	WHERE `datetime` >= ? AND `datetime` <= ?",array($from, $to));\r\n$reverts = $query->result();\r\n\r\nforeach ($reverts as $revert){\r\n	$data = json_decode($revert->data);\r\n	if ($data->void_item->id){\r\n		$total_voided_items += $data->void_item->qty;\r\n		$total_voided_item_amount += $data->void_item->amount;\r\n	} else {\r\n		$total_voided_sales++;\r\n		$total_voided_sales_amount += $data->sale->amount;\r\n	}\r\n}\r\n\r\n\r\n$query = $this->db->query("SELECT\r\n		SUM(`amount`) AS `total_amount`, category\r\n	FROM `fnb_sale_items`\r\n	WHERE `session` = ? GROUP BY `category`", array($cash_count->session));\r\n$categories = $query->result();', '<h1>Cashout Report</h1>\r\n<table style="width: 100%">\r\n	<tr>\r\n		<td>From</td>\r\n		<td style="text-align: right"><?php echo $from; ?></td>\r\n	</tr>\r\n	<tr>\r\n		<td>To</td>\r\n		<td style="text-align: right"><?php echo $to; ?></td>\r\n	</tr>\r\n	<tr>\r\n		<td>Total Gross Sales</td>\r\n		<td style="text-align: right"><?php echo number_format($total_sales,2); ?></td>\r\n	</tr>\r\n	<tr>\r\n		<td>Total Discount Given</td>\r\n		<td style="text-align: right"><?php echo number_format($total_discount,2); ?></td>\r\n	</tr>\r\n	<tr>\r\n		<td>Total Adjustment</td>\r\n		<td style="text-align: right"><?php echo number_format($total_adjustment, 2); ?></td>\r\n	</tr>\r\n	<tr>\r\n		<td>Total Tax</td>\r\n		<td style="text-align: right"><?php echo number_format($total_tax, 2); ?></td>\r\n	</tr>\r\n	<tr>\r\n		<td>Total Net Sales</td>\r\n		<td style="text-align: right">\r\n			<?php echo number_format($total_sales - $total_tax + $total_adjustment,2); ?>\r\n		</td>\r\n	</tr>\r\n	<tr>\r\n		<td>Till Deposit</td>\r\n		<td style="text-align: right"><?php echo number_format($cash_count->deposited,2); ?></td>		\r\n	</tr>\r\n	<tr>\r\n		<td>Counted in Till</td>\r\n		<td style="text-align: right">\r\n			<?php echo number_format($cash_count->deposited+ $cash_count->discrepancy +$pm_breakdown->total_cash,2); ?>\r\n		</td>		\r\n	</tr>\r\n	\r\n	<tr>\r\n		<td>Cashout Amount</td>\r\n		<td style="text-align: right"><?php echo number_format($cash_count->discrepancy +$pm_breakdown->total_cash,2); ?></td>		\r\n	</tr>\r\n	<tr>\r\n		<td>Discrepancy</td>\r\n		<td style="text-align: right"><?php echo number_format($cash_count->discrepancy,2); ?></td>\r\n	</tr>\r\n	<tr>\r\n		<td>Session No.</td>\r\n		<td style="text-align: right"><?php echo $session_no; ?></td>		\r\n	</tr>\r\n	<tr>\r\n		<td>Items Sold</td>\r\n		<td style="text-align: right"><?php echo number_format($total_items); ?></td>		\r\n	</tr>\r\n\r\n</table>\r\n\r\n<br /><br />\r\n	<h3>Payment Breakdown</h3>\r\n	<table style="width: 100%">\r\n		<tr>\r\n			<td>Cash</td>\r\n			<td style="text-align: right"><?php echo number_format($pm_breakdown->total_cash,2); ?></td>\r\n		</tr>\r\n		<tr>\r\n			<td>Credit Card</td>\r\n			<td style="text-align: right"><?php echo number_format($pm_breakdown->total_cc,2); ?></td>\r\n		</tr>\r\n		<tr>\r\n			<td>Voucher</td>\r\n			<td style="text-align: right"><?php echo number_format($pm_breakdown->total_voucher,2); ?></td>\r\n		</tr>\r\n		<tr>\r\n			<td>Cheque</td>\r\n			<td style="text-align: right"><?php echo number_format($pm_breakdown->total_cheque,2); ?></td>\r\n		</tr>\r\n\r\n	</table>\r\n\r\n\r\n\r\n<br /><br />\r\n<h3>Voided Sales</h3>\r\n<table style="width: 100%">\r\n	<tr>\r\n		<td>Total Voided Sales</td>\r\n		<td style="text-align: right"><?php echo number_format($total_voided_sales); ?></td>\r\n	</tr>\r\n	<tr>\r\n		<td>Total Voided Sales Amount</td>\r\n		<td style="text-align: right"><?php echo number_format($total_voided_sales_amount,2); ?></td>\r\n	</tr>\r\n</table>\r\n<!--\r\n<br /><br />\r\n<h3>Tax Breakdown</h3>\r\n<table style="width: 100%">\r\n	<?php foreach ($tax_breakdown as $tax_sale): ?>\r\n	<tr>\r\n		<td><?php echo $tax_sale->tax_code; ?></td>\r\n		<td style="text-align: right"><?php echo number_format($tax_sale->total,2); ?></td>\r\n	</tr>\r\n<?php endforeach; ?>\r\n</table>\r\n-->\r\n\r\n<br /><br />\r\n<h3>Voided Items</h3>\r\n<table style="width: 100%">\r\n	<tr>\r\n		<td>Total Voided Items</td>\r\n		<td style="text-align: right"><?php echo number_format($total_voided_items); ?></td>\r\n	</tr>\r\n	<tr>\r\n		<td>Total Voided Items Amount</td>\r\n		<td style="text-align: right"><?php echo number_format($total_voided_item_amount,2); ?></td>\r\n	</tr>\r\n</table>\r\n	\r\n<br /><br />\r\n<h3>Category Breakdown</h3>\r\n<table style="width: 100%">\r\n	<?php foreach ($categories as $category): ?>\r\n	<tr>\r\n		<td><?php echo $category->category; ?></td>\r\n		<td style="text-align: right"><?php echo number_format($category->total_amount, 2); ?></td>\r\n	</tr>\r\n	<?php endforeach; ?>\r\n</table>', NULL, '<?php \r\n\r\n$query = $this->db->query("SELECT * FROM `fnb_cash_count` ORDER BY `id` DESC LIMIT 100");\r\nforeach ($query->result() as $cc){\r\n	$ccs[$cc->id] = ''#'' . $cc->id . '' '' . date(''d/m/Y - h:iA'', strtotime($cc->to)) . '' - '' . $cc->total_sales;	\r\n}\r\n\r\n?>\r\n<div class="filter" style="padding: 10px 5px; font-size: 10pt;">\r\n Session\r\n	<?php echo form_dropdown(''cash_count_id'',$ccs,'''',''field="cash_count_id"''); ?>\r\n\r\n	\r\n</div>\r\n<div style="margin-top: 10px"><a class="v-btn generate-btn">Generate</a></div>', NULL, '2015-03-12 14:51:38', 'admin', '2015-10-03 12:24:50', 'sysadmin'),
(13, 'F&B Void Report', 'Report', 'Generate voided item and sales report based on date range.', 'false', '0', '$date_from = sql_date_reformat($inputs[''date_from'']);\r\n$date_to = sql_date_reformat($inputs[''date_to'']);\r\n\r\n\r\n$query = $this->db->query("SELECT * \r\n	FROM `fnb_reverts` \r\n	WHERE `datetime` >= ? AND `datetime` <= ?",array($date_from .'' 00:00:00'', $date_to . '' 23:59:59''));\r\n$reverts = $query->result();\r\n\r\n', '<style>\r\n	table.print-standard {\r\n		border-collapse: collapse;\r\n		border-spacing: 0;\r\n		border: 1px solid #333;\r\n	}\r\n	\r\n	table.print-standard th {\r\n		background: #EEE;	\r\n		border: 1px solid #333;\r\n		padding: 2px 5px;\r\n	}\r\n	\r\n	table.print-standard td {\r\n		border: 1px solid #333;\r\n		padding: 2px 5px;\r\n	}\r\n	\r\n	table.w100 {\r\n		width: 100%;	\r\n	}\r\n	\r\n	table.print-standard tr.footer {\r\n		background: #EEE;	\r\n	}\r\n</style>\r\n\r\n<h1 style="text-align: center">Void Report</h1>\r\n<p style="text-align: center;">\r\n	<?php echo date(''d/m/Y h:iA'', strtotime($date_from)); ?>\r\n	- <?php echo date(''d/m/Y h:iA'', strtotime($date_to)); ?>\r\n</p>\r\n\r\n<table class="print-standard w100">\r\n	<thead>\r\n		<tr>\r\n			<th>No</th>\r\n			<th>Date/Time</th>\r\n			<th>Type</th>\r\n			<th>Info</th>\r\n			<th>Performed By</th>\r\n			<th>Amount</th>\r\n		</tr>\r\n	</thead>\r\n	<tbody>\r\n		<?php foreach ($reverts as $revert): $i++; ?>\r\n			<?php\r\n				$data = json_decode($revert->data);\r\n				$items = null;\r\n				if ($data->void_item->id){\r\n					$items[] = $data->void_item;\r\n					$type = ''Item'';\r\n				} else {\r\n					$sale = $data->sale;\r\n					$items = $data->sale_items;\r\n					$type = ''Sale'';\r\n				}\r\n				if ($type == ''Item''){\r\n					$show = 0;\r\n					foreach ($items as $item){\r\n						$show += $item->amount;\r\n					}\r\n				} else {\r\n					$show = 0;\r\n					if ($sale->id) $show = 1;	\r\n				}\r\n			?>\r\n		<?php if ($show): ?>\r\n		<tr>\r\n			<td><?php echo $i; ?></td>\r\n			<td><?php echo date(''d/m/Y h:iA'', strtotime($revert->datetime)); ?></td>\r\n			<td>\r\n				<?php if ($revert->revert): ?>\r\n					Sale Revert			\r\n				<?php else: ?>\r\n					<?php echo $type; ?>\r\n				<?php endif; ?>\r\n			</td>\r\n			<td>\r\n				<strong>RC-<?php echo $sale->id ? $sale->id : $item->sale_id; ?></strong><br />\r\n\r\n				<?php $amount = 0; foreach ($items as $item): ?>\r\n				<div>\r\n					<?php echo $item->item_sku; ?> - <?php echo $item->item_name; ?>\r\n					&mdash; <?php echo $item->ordered_by; ?>\r\n				</div>\r\n				<?php $amount += $item->amount; endforeach; ?>\r\n			</td>\r\n			<td><?php echo $revert->performed_by; ?></td>\r\n			<td style="text-align: right"><?php echo number_format($amount,2); ?></td>\r\n		</tr>\r\n		<?php endif; ?>\r\n		<?php endforeach; ?>\r\n	</tbody>\r\n	\r\n</table>\r\n\r\n\r\n', NULL, '<div class="filter" style="padding: 10px 5px; font-size: 10pt;">\r\n Date \r\n	<input type="text" field="date_from" name="from" value="<?php echo date(''d/m/Y''); ?>" \r\n		class="v-text date filter-date" style="width: 80px" />\r\n	\r\n	<input type="text" field="date_to" name="to" value="<?php echo date(''d/m/Y''); ?>" \r\n		class="v-text date filter-date" style="width: 80px" />  \r\n\r\n</div>\r\n<div style="margin-top: 10px"><a class="v-btn generate-btn">Generate</a></div>\r\n', NULL, '2015-03-12 17:46:08', 'admin', '2015-08-13 13:14:21', 'admin'),
(17, 'F&B Discount Report', 'Report', 'Produces F&B discount report based on date range.', 'false', '0', 'list($day, $month, $year) = explode(''/'',$inputs[''date_from'']);\r\n$date_from = $year . ''-'' . $month . ''-'' . $day;\r\n$date_from = $date_from . '' 06:00:00'';\r\n\r\nlist($day, $month, $year) = explode(''/'',$inputs[''date_to'']);\r\n$date_to = $year . ''-'' . $month . ''-'' . $day;\r\n$date_to = date(''Y-m-d H:i:s'',strtotime($date_to . '' 23:59:59'')+(60*60*3));\r\n\r\n$query = $this->db->query("\r\n	SELECT SUM(`amount_discount`) AS `discount`, `customer`, `customer_id` FROM\r\n		(SELECT * FROM `fnb_buffer_sales` \r\n			WHERE \r\n				`datetime` >= ? AND\r\n				`datetime` <= ? AND\r\n				`type` = ''history''\r\n		UNION\r\n			SELECT * FROM `fnb_sales` \r\n			WHERE \r\n				`datetime` >= ? AND\r\n				`datetime` <= ? AND\r\n				`type` = ''history''\r\n		ORDER BY `id` ASC) AS T\r\n	GROUP BY T.customer_id\r\n", array($date_from, $date_to, $date_from, $date_to));\r\n\r\n$discounts = $query->result();\r\n', '<style>\r\n	table.print-standard {\r\n		border-collapse: collapse;\r\n		border-spacing: 0;\r\n		border: 1px solid #333;\r\n	}\r\n	\r\n	table.print-standard th {\r\n		background: #EEE;	\r\n		border: 1px solid #333;\r\n		padding: 2px 5px;\r\n		text-align: center;\r\n	}\r\n	\r\n	table.print-standard td {\r\n		border: 1px solid #333;\r\n		padding: 2px 5px;\r\n	}\r\n	\r\n	table.w100 {\r\n		width: 100%;	\r\n	}\r\n	\r\n	table.print-standard tr.footer {\r\n		background: #EEE;	\r\n	}\r\n</style>\r\n\r\n<h1><?php echo $this->system->config(''company_name''); ?></h1>\r\n<h2 style="text-align: center; margin-bottom: 0; padding-bottom: 0">F&amp;B Discount Report</h2>\r\n<p style="text-align: center;">\r\n	From \r\n		<?php echo date(''l, F j, Y'',strtotime($date_from)); ?> \r\n	to \r\n		<?php echo date(''l, F j, Y'',strtotime($date_to)); ?> \r\n</p>\r\n\r\n<table class="print-standard w100">\r\n	<thead>\r\n		<tr>\r\n			<th>Customer ID</th>\r\n			<th>Customer/Customer of</th>\r\n			<th>Amount Discount (<?php echo $this->system->config(''currency''); ?>)</th>\r\n		</tr>\r\n	</thead>\r\n	<tbody>\r\n		<?php foreach ($discounts as $discount): ?>\r\n		<tr>\r\n			<td><?php echo $discount->customer_id; ?></td>\r\n			<td><?php echo $discount->customer; ?></td>\r\n			<td style="text-align: right"><?php echo number_format($discount->discount,2); ?></td>\r\n		</tr>\r\n		<?php $td += $discount->discount; ?>\r\n		<?php endforeach; ?>\r\n		<tr>\r\n			\r\n			<td colspan="2"><strong>TOTAL</strong></td>\r\n			<td style="text-align: right; font-weight: bold"><?php echo number_format($td,2); ?></td>\r\n		</tr>\r\n	</tbody>\r\n</table>', NULL, '<div class="filter" style="padding: 10px 5px; font-size: 10pt;">\r\n From\r\n	<input type="text" field="date_from" name="date" \r\n		value="<?php echo date(''d/m/Y''); ?>" \r\n		class="v-text date filter-date" style="width: 80px" />\r\n To\r\n	<input type="text" field="date_to" name="date" \r\n		value="<?php echo date(''d/m/Y''); ?>" \r\n		class="v-text date filter-date" style="width: 80px" />	\r\n	\r\n</div>\r\n<div style="margin-top: 10px"><a class="v-btn generate-btn">Generate</a></div>', NULL, '2015-08-15 11:17:57', 'admin', '2015-10-28 20:43:19', 'sysadmin'),
(22, 'F&B Subcategory Sales Report', 'Report', 'Displays sales report by subcategory.', 'false', '0', '$date_from = $this->input->post(''date_from'');\r\n$date_to = $this->input->post(''date_to'');\r\n\r\nlist($day, $month, $year) = explode(''/'', $date_from);\r\n$from = $year . ''-'' . $month . ''-'' . $day;\r\n\r\nlist($day, $month, $year) = explode(''/'', $date_to);\r\n$to = date(''Y-m-d H:i:s'',strtotime($year . ''-'' . $month . ''-'' . $day) + (60 * 60 * 26));\r\n\r\n// $this->db->query("UPDATE `fnb_sale_items`  SET `subcategory` = ''SERVICE CHARGE'' WHERE `item_sku` = ''_SC''");\r\n\r\n$query = $this->db->query("\r\nSELECT\r\n	`item_sku`, SUM(`total_sales`) AS `total_sales`, SUM(`total_discount`) AS `total_discount`, SUM(`total_net`) AS `total_net`, `subcategory` FROM\r\n	(SELECT \r\n		`item_sku`,\r\n		(`amount`) AS `total_sales`, \r\n		(ROUND(`amount` * (IF(`global_discount` IS NULL,0,`global_discount`) / 100),3)) AS `total_discount`,\r\n		(`amount` - ROUND(`amount` * (IF(`global_discount` IS NULL,0,`global_discount`) / 100),3)) AS `total_net`,\r\n		IF(`subcategory` IS NULL, ''SERVICE CHARGE'', `subcategory`) AS `subcategory`\r\n	FROM\r\n		`fnb_sale_items` \r\n	WHERE \r\n		`ordered_time` >= ? AND\r\n		`ordered_time` <= ? AND\r\n		`sale_id` != 0 AND\r\n		`sold` = 1\r\n	) AS T GROUP BY `subcategory`\r\n	ORDER BY `total_sales` DESC\r\n", array(\r\n			$from . '' 06:00:00'',\r\n			$to,\r\n			$from . '' 06:00:00'',\r\n			$to\r\n		));\r\n\r\n$sales_per_category = $query->result();\r\n\r\n\r\n\r\nforeach ($sales_per_category as $sale){\r\n	$s = null;\r\n	if ($sale->category){\r\n		$s->label = $sale->item_sku == ''_SC'' ? ''SERVICE CHARGE'' : ($sale->category ? $sale->category : ''Uncategorized'');\r\n		$s->data = (double) $sale->total_sales;\r\n		$data[] = $s;\r\n	}\r\n}\r\n\r\n$pie_chart_data = json_encode($data);', '<h2 style="text-align: center; margin-bottom: 0; padding-bottom: 0">\r\n	F&amp;B Subcategory Report\r\n</h2>\r\n<p style="text-align: center; \r\n	padding-bottom: 10px; margin-bottom: 20px; border-bottom: 1px solid #CCC">\r\n	Date Range: \r\n	<?php echo date(''l, F j, Y'',strtotime($from)); ?> - \r\n	<?php echo date(''l, F j, Y'',strtotime($to)); ?>\r\n</p>\r\n<div id="piechart" style="height: 350px; width: 100%">\r\n	\r\n</div>\r\n<table class="grid">\r\n	<thead>\r\n		<tr>\r\n			<th>Subcategory</th>\r\n			<th>Amount</th>\r\n			<th>Discount Given</th>\r\n			<th>Net Amount</th>\r\n		</tr>\r\n	</thead>\r\n	<tbody>\r\n		<?php foreach ($sales_per_category as $sale): if ($sale->total_sales): ?>\r\n		<?php if ($sale->item_sku == ''_SC''): ?>\r\n			<?php\r\n				$svc_total_sales += (double) str_replace('','','''',number_format($sale->total_sales,2));\r\n				$svc_total_discount += (double) str_replace('','','''',number_format($sale->total_discount,2));;\r\n				$svc_net = $svc_total_sales - $svc_total_discount;\r\n			?>\r\n		<?php else: ?>\r\n		<tr>\r\n			<td>\r\n<?php echo $sale->item_sku == ''_SC'' ? ''SERVICE CHARGE'' : ($sale->subcategory ? $sale->subcategory : ''Uncategorized''); ?>\r\n			</td>\r\n			<td style="text-align: right">\r\n				<?php echo number_format($sale->total_sales, 2); ?>\r\n			</td>\r\n			<td style="text-align: right">\r\n				<?php echo number_format($sale->total_discount, 2); ?>\r\n			</td>\r\n			<td style="text-align: right">\r\n				<?php echo number_format($sale->total_net, 2); ?>\r\n			</td>\r\n		</tr>\r\n		<?php\r\n			$ts += $sale->total_sales;\r\n			$td += $sale->total_discount;\r\n			$tn += $sale->total_net;\r\n		?>\r\n		<?php endif; ?>\r\n\r\n		<?php endif; endforeach; ?>\r\n		<tr>\r\n			<td>SERVICE CHARGE</td>\r\n			<td style="text-align: right">\r\n				<?php echo number_format($svc_total_sales, 2); ?>\r\n			</td>\r\n			<td style="text-align: right">\r\n				<?php echo number_format($svc_total_discount, 2); ?>\r\n			</td>\r\n			<td style="text-align: right">\r\n				<?php echo number_format($svc_net, 2); ?>\r\n			</td>\r\n		</tr>\r\n		<tr>\r\n			<td>TOTAL WITH SERVICE CHARGE</td>\r\n			<td style="text-align: right"><strong><?php echo number_format($ts+$svc_total_sales,2); ?></strong></td>\r\n			<td style="text-align: right"><strong><?php echo number_format($td+$svc_total_discount,2); ?></strong></td>\r\n			<td style="text-align: right"><strong><?php echo number_format($tn+$svc_net,2); ?></strong></td>\r\n		</tr>\r\n		<tr>\r\n			<td>NET TOTAL </td>\r\n			<td style="text-align: right"><strong><?php echo number_format($ts,2); ?></strong></td>\r\n			<td style="text-align: right"><strong><?php echo number_format($td,2); ?></strong></td>\r\n			<td style="text-align: right"><strong><?php echo number_format($tn,2); ?></strong></td>\r\n		</tr>\r\n	</tbody>\r\n</table>\r\n<hr />\r\n\r\n\r\n\r\n<hr />\r\n\r\n<script type="text/javascript" src="js/flot/jquery.flot.pie.js"></script>\r\n<script type="text/javascript">\r\n	\r\n	$(document).ready(function(){\r\n		setTimeout(function(){\r\n			var data = <?php echo $pie_chart_data; ?>;\r\n			$.plot(''#piechart'', data, {\r\n				series: {\r\n					pie: { \r\n						show: true\r\n					}\r\n				},\r\n				legend: {\r\n					show: false\r\n				}\r\n			});\r\n		}, 200);\r\n	});\r\n	\r\n</script>\r\n', NULL, '<div class="filter" style="padding: 10px 5px; font-size: 10pt;">\r\n Date \r\n	<input type="text" field="date_from" name="date" value="<?php echo date(''d/m/Y''); ?>" \r\n		class="v-text date filter-date" style="width: 80px" />\r\n	\r\n	<input type="text" field="date_to" name="date" value="<?php echo date(''d/m/Y''); ?>" \r\n		class="v-text date filter-date" style="width: 80px" />  \r\n\r\n</div>\r\n<div style="margin-top: 10px"><a class="v-btn generate-btn">Generate</a></div>\r\n', 0, '2018-01-08 10:58:43', 'admin', '2018-01-08 11:12:13', 'admin');

-- --------------------------------------------------------

--
-- Table structure for table `reports_saved`
--

CREATE TABLE `reports_saved` (
  `id` int(11) UNSIGNED NOT NULL,
  `type` varchar(128) DEFAULT NULL,
  `title` varchar(128) DEFAULT NULL,
  `notes` text,
  `output` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `reports_saved`
--

INSERT INTO `reports_saved` (`id`, `type`, `title`, `notes`, `output`, `added_on`, `added_by`) VALUES
(1, 'Incentive Report', 'Inventive Report', 'Bulan 2', '<style>\r\n	table.print-standard {\r\n		border-collapse: collapse;\r\n		border-spacing: 0;\r\n		border: 1px solid #333;\r\n	}\r\n	\r\n	table.print-standard th {\r\n		background: #EEE;	\r\n		border: 1px solid #333;\r\n		padding: 2px 5px;\r\n		text-align: center;\r\n	}\r\n	\r\n	table.print-standard td {\r\n		border: 1px solid #333;\r\n		padding: 2px 5px;\r\n	}\r\n	\r\n	table.w100 {\r\n		width: 100%;	\r\n	}\r\n	\r\n	table.print-standard tr.footer {\r\n		background: #EEE;	\r\n	}\r\n</style>\r\n<div style="text-align: right">\r\n	<small style="color: #AAA">plexcloud/reports/cir/20130411234024</small>\r\n	<br />\r\n</div>\r\n\r\n<p style="font-weight: bold; text-decoration: underline; padding: 0; margin: 0">\r\n	PLEX SOLUTIONS(PG0293513-D)<br />\r\n	CUSTOMER INCENTIVE REPORT\r\n</p>\r\n\r\n<p style="text-align: center;">\r\n	From \r\n		Friday, February 1, 2013 \r\n	to \r\n		Thursday, February 28, 2013 \r\n</p>\r\n\r\n<table class="print-standard w100">\r\n	<thead>\r\n		<tr>\r\n			<th style="width: 20px">No</th>\r\n			<th style="width: 70px">Cust Code</th>\r\n			<th>Customer</th>\r\n			<th style="width: 80px">Total Purchases</th>\r\n			<th style="width: 80px">Voucher Code</th>\r\n		</tr>\r\n	</thead>\r\n	<tbody>\r\n		<tr>\r\n			<td colspan="5"><strong>2% REBATE</strong></td>\r\n		</tr>\r\n				<tr>\r\n			<td>1</td>\r\n			<td>841231087654</td>\r\n			<td>\r\n				Noraishah Kamarudin			</td>\r\n			<td style="text-align: right">\r\n				110.00			</td>\r\n			<td>\r\n				USD2			</td>\r\n		</tr>\r\n				\r\n		\r\n		<tr>\r\n			<td colspan="5"><strong>3% REBATE</strong></td>\r\n		</tr>\r\n				\r\n		\r\n		<tr>\r\n			<td colspan="5"><strong>5% REBATE</strong></td>\r\n		</tr>\r\n				<tr>\r\n			<td>1</td>\r\n			<td>841231</td>\r\n			<td>\r\n				Asmah Bt Din			</td>\r\n			<td style="text-align: right">\r\n				495.00			</td>\r\n			<td>\r\n				TYD2			</td>\r\n		</tr>\r\n				<tr>\r\n			<td>2</td>\r\n			<td>820921086022</td>\r\n			<td>\r\n				Johari Bin Jasuli			</td>\r\n			<td style="text-align: right">\r\n				220.00			</td>\r\n			<td>\r\n				U0D2			</td>\r\n		</tr>\r\n				\r\n	</tbody>\r\n	\r\n</table>', '2013-04-11 23:40:43', 'admin'),
(2, 'F&B Category Sales Report', '110616', 'daily category report', '<h2 style="text-align: center; margin-bottom: 0; padding-bottom: 0">\r\n	F&amp;B Sales Report\r\n</h2>\r\n<p style="text-align: center; \r\n	padding-bottom: 10px; margin-bottom: 20px; border-bottom: 1px solid #CCC">\r\n	Date Range: \r\n	Saturday, June 11, 2016 - \r\n	Sunday, June 12, 2016</p>\r\n<div id="piechart" style="height: 350px; width: 100%">\r\n	\r\n</div>\r\n<table class="grid">\r\n	<thead>\r\n		<tr>\r\n			<th>Category</th>\r\n			<th>Amount</th>\r\n			<th>Discount Given</th>\r\n			<th>Net Amount</th>\r\n		</tr>\r\n	</thead>\r\n	<tbody>\r\n						<tr>\r\n			<td>\r\n				Cold Drinks			</td>\r\n			<td style="text-align: right">\r\n				438.00			</td>\r\n			<td style="text-align: right">\r\n				0.00			</td>\r\n			<td style="text-align: right">\r\n				438.00			</td>\r\n		</tr>\r\n				\r\n						<tr>\r\n			<td>\r\n				Meals			</td>\r\n			<td style="text-align: right">\r\n				322.00			</td>\r\n			<td style="text-align: right">\r\n				0.00			</td>\r\n			<td style="text-align: right">\r\n				322.00			</td>\r\n		</tr>\r\n				\r\n						<tr>\r\n			<td>\r\n				Hot Drinks			</td>\r\n			<td style="text-align: right">\r\n				306.00			</td>\r\n			<td style="text-align: right">\r\n				0.00			</td>\r\n			<td style="text-align: right">\r\n				306.00			</td>\r\n		</tr>\r\n				\r\n						<tr>\r\n			<td>\r\n				Desserts			</td>\r\n			<td style="text-align: right">\r\n				80.00			</td>\r\n			<td style="text-align: right">\r\n				0.00			</td>\r\n			<td style="text-align: right">\r\n				80.00			</td>\r\n		</tr>\r\n				\r\n				<tr>\r\n			<td>SERVICE CHARGE</td>\r\n			<td style="text-align: right">\r\n				0.00			</td>\r\n			<td style="text-align: right">\r\n				0.00			</td>\r\n			<td style="text-align: right">\r\n				0.00			</td>\r\n		</tr>\r\n		<tr>\r\n			<td>TOTAL WITH SERVICE CHARGE</td>\r\n			<td style="text-align: right"><strong>1,146.00</strong></td>\r\n			<td style="text-align: right"><strong>0.00</strong></td>\r\n			<td style="text-align: right"><strong>1,146.00</strong></td>\r\n		</tr>\r\n		<tr>\r\n			<td>NET TOTAL </td>\r\n			<td style="text-align: right"><strong>1,146.00</strong></td>\r\n			<td style="text-align: right"><strong>0.00</strong></td>\r\n			<td style="text-align: right"><strong>1,146.00</strong></td>\r\n		</tr>\r\n	</tbody>\r\n</table>\r\n<hr />\r\n\r\n\r\n\r\n<hr />\r\n\r\n<script type="text/javascript" src="js/flot/jquery.flot.pie.js"></script>\r\n<script type="text/javascript">\r\n	\r\n	$(document).ready(function(){\r\n		setTimeout(function(){\r\n			var data = [{"label":"Cold Drinks","data":438},{"label":"Meals","data":322},{"label":"Hot Drinks","data":306},{"label":"Desserts","data":80}];\r\n			$.plot(''#piechart'', data, {\r\n				series: {\r\n					pie: { \r\n						show: true\r\n					}\r\n				},\r\n				legend: {\r\n					show: false\r\n				}\r\n			});\r\n		}, 200);\r\n	});\r\n	\r\n</script>\r\n', '2016-06-11 22:21:06', 'lois');
INSERT INTO `reports_saved` (`id`, `type`, `title`, `notes`, `output`, `added_on`, `added_by`) VALUES
(5, 'F&B Sales Report', 'feb 1', '', '<style>\r\n	table.print-standard {\r\n		border-collapse: collapse;\r\n		border-spacing: 0;\r\n		border: 1px solid #333;\r\n	}\r\n	\r\n	table.print-standard th {\r\n		background: #EEE;	\r\n		border: 1px solid #333;\r\n		padding: 2px 5px;\r\n		text-align: center;\r\n	}\r\n	\r\n	table.print-standard td {\r\n		border: 1px solid #333;\r\n		padding: 2px 5px;\r\n	}\r\n	\r\n	table.w100 {\r\n		width: 100%;	\r\n	}\r\n	\r\n	table.print-standard tr.footer {\r\n		background: #EEE;	\r\n	}\r\n</style>\r\n\r\n<h1>The Daily Dose</h1>\r\n<h2 style="text-align: center; margin-bottom: 0; padding-bottom: 0">F&amp;B Sales Report</h2>\r\n<p style="text-align: center;">\r\n	From \r\n		Wednesday, February 1, 2017 \r\n	to \r\n		Friday, February 24, 2017 \r\n</p>\r\n\r\n<table class="print-standard w100">\r\n	<thead>\r\n		<tr>\r\n			<th>Txn</th>\r\n			<th>Date/Time</th>\r\n			<th>Amount Cash (RM)</th>\r\n			<th>Amount Credit Card (RM)</th>\r\n			<th>Amount Voucher (RM)</th>\r\n			<th>Amount Cheque (RM)</th>\r\n			<th>Amount Discount (RM)</th>\r\n			<th>Amount (RM)</th>\r\n			<th>Service Charge (RM)</th>\r\n			<!--\r\n			<th>SR Tax (RM)</th>\r\n			<th>ZRL Tax (RM)</th>\r\n			-->\r\n			<th>GST (RM)</th>\r\n			<th>Net (RM)</th>\r\n			<th>Customer/Customer of</th>\r\n		</tr>\r\n	</thead>\r\n	<tbody>\r\n						<tr>\r\n			<td>RC-6419</td>\r\n			<td>01/02/2017 09:57AM</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.32</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6420</td>\r\n			<td>01/02/2017 10:15AM</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.42</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6421</td>\r\n			<td>01/02/2017 10:53AM</td>\r\n			<td style="text-align: right; width: 90px">6.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.36</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6422</td>\r\n			<td>01/02/2017 12:33PM</td>\r\n			<td style="text-align: right; width: 90px">108.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">108.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.48</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">108.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6423</td>\r\n			<td>01/02/2017 10:58AM</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.42</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6424</td>\r\n			<td>01/02/2017 11:45AM</td>\r\n			<td style="text-align: right; width: 90px">31.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">31.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.86</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">31.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6425</td>\r\n			<td>01/02/2017 11:31AM</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.66</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6426</td>\r\n			<td>01/02/2017 12:13PM</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.44</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6428</td>\r\n			<td>01/02/2017 12:53PM</td>\r\n			<td style="text-align: right; width: 90px">116.10</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.90</td>\r\n			<td style="text-align: right; width: 90px">116.10</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.97</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">116.10</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6429</td>\r\n			<td>01/02/2017 12:32PM</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.44</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6430</td>\r\n			<td>01/02/2017 01:11PM</td>\r\n			<td style="text-align: right; width: 90px">75.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">75.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">4.50</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">75.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6431</td>\r\n			<td>01/02/2017 12:42PM</td>\r\n			<td style="text-align: right; width: 90px">41.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">41.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.46</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">41.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6432</td>\r\n			<td>01/02/2017 12:42PM</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.08</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6433</td>\r\n			<td>01/02/2017 01:52PM</td>\r\n			<td style="text-align: right; width: 90px">57.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">57.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.42</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">57.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6434</td>\r\n			<td>01/02/2017 02:20PM</td>\r\n			<td style="text-align: right; width: 90px">16.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">16.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.96</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">16.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6435</td>\r\n			<td>01/02/2017 12:50PM</td>\r\n			<td style="text-align: right; width: 90px">42.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">42.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.52</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">42.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6436</td>\r\n			<td>01/02/2017 01:12PM</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.66</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6437</td>\r\n			<td>01/02/2017 03:45PM</td>\r\n			<td style="text-align: right; width: 90px">47.70</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.30</td>\r\n			<td style="text-align: right; width: 90px">47.70</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.86</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">47.70</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6438</td>\r\n			<td>01/02/2017 02:16PM</td>\r\n			<td style="text-align: right; width: 90px">35.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">35.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.10</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">35.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6439</td>\r\n			<td>01/02/2017 03:31PM</td>\r\n			<td style="text-align: right; width: 90px">85.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">85.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.10</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">85.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6440</td>\r\n			<td>01/02/2017 02:54PM</td>\r\n			<td style="text-align: right; width: 90px">70.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">70.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">4.20</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">70.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6441</td>\r\n			<td>01/02/2017 03:15PM</td>\r\n			<td style="text-align: right; width: 90px">44.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">44.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.64</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">44.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6442</td>\r\n			<td>01/02/2017 02:46PM</td>\r\n			<td style="text-align: right; width: 90px">15.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">15.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.90</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">15.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6443</td>\r\n			<td>01/02/2017 03:09PM</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.48</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6444</td>\r\n			<td>01/02/2017 03:07PM</td>\r\n			<td style="text-align: right; width: 90px">54.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">54.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.24</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">54.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6445</td>\r\n			<td>01/02/2017 03:24PM</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.66</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6446</td>\r\n			<td>01/02/2017 03:31PM</td>\r\n			<td style="text-align: right; width: 90px">14.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">14.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.84</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">14.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6447</td>\r\n			<td>01/02/2017 03:35PM</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.72</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6448</td>\r\n			<td>01/02/2017 03:50PM</td>\r\n			<td style="text-align: right; width: 90px">9.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">9.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.54</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">9.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6449</td>\r\n			<td>01/02/2017 04:15PM</td>\r\n			<td style="text-align: right; width: 90px">16.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">16.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.96</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">16.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6450</td>\r\n			<td>01/02/2017 05:29PM</td>\r\n			<td style="text-align: right; width: 90px">14.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">14.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.84</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">14.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6451</td>\r\n			<td>01/02/2017 05:11PM</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.08</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6452</td>\r\n			<td>01/02/2017 04:38PM</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.42</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6453</td>\r\n			<td>01/02/2017 05:15PM</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.66</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6454</td>\r\n			<td>01/02/2017 05:15PM</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.60</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6455</td>\r\n			<td>01/02/2017 06:09PM</td>\r\n			<td style="text-align: right; width: 90px">40.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">40.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.40</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">40.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6456</td>\r\n			<td>01/02/2017 09:43PM</td>\r\n			<td style="text-align: right; width: 90px">44.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">44.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.64</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">44.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6457</td>\r\n			<td>01/02/2017 07:03PM</td>\r\n			<td style="text-align: right; width: 90px">23.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">23.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.38</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">23.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6458</td>\r\n			<td>01/02/2017 07:51PM</td>\r\n			<td style="text-align: right; width: 90px">53.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">53.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.18</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">53.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6459</td>\r\n			<td>01/02/2017 07:19PM</td>\r\n			<td style="text-align: right; width: 90px">6.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.36</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6461</td>\r\n			<td>01/02/2017 09:28PM</td>\r\n			<td style="text-align: right; width: 90px">63.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">63.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.78</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">63.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6462</td>\r\n			<td>01/02/2017 08:37PM</td>\r\n			<td style="text-align: right; width: 90px">15.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">15.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.90</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">15.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6463</td>\r\n			<td>01/02/2017 08:52PM</td>\r\n			<td style="text-align: right; width: 90px">48.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">48.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.88</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">48.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6464</td>\r\n			<td>01/02/2017 09:11PM</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.60</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6465</td>\r\n			<td>02/02/2017 09:04AM</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.72</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6466</td>\r\n			<td>02/02/2017 09:28AM</td>\r\n			<td style="text-align: right; width: 90px">63.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">63.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.78</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">63.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6467</td>\r\n			<td>02/02/2017 10:14AM</td>\r\n			<td style="text-align: right; width: 90px">57.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">57.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.42</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">57.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6468</td>\r\n			<td>02/02/2017 09:45AM</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.42</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6469</td>\r\n			<td>02/02/2017 10:35AM</td>\r\n			<td style="text-align: right; width: 90px">34.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">34.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.04</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">34.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6470</td>\r\n			<td>02/02/2017 11:11AM</td>\r\n			<td style="text-align: right; width: 90px">63.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">63.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.78</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">63.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6471</td>\r\n			<td>02/02/2017 11:51AM</td>\r\n			<td style="text-align: right; width: 90px">30.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">30.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.80</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">30.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6472</td>\r\n			<td>02/02/2017 11:44AM</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.44</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6473</td>\r\n			<td>02/02/2017 12:53PM</td>\r\n			<td style="text-align: right; width: 90px">85.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">85.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.10</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">85.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6474</td>\r\n			<td>02/02/2017 11:43AM</td>\r\n			<td style="text-align: right; width: 90px">39.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">39.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.34</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">39.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6475</td>\r\n			<td>02/02/2017 12:16PM</td>\r\n			<td style="text-align: right; width: 90px">77.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">77.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">4.62</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">77.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6476</td>\r\n			<td>02/02/2017 11:59AM</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.48</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6477</td>\r\n			<td>02/02/2017 12:08PM</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.48</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6478</td>\r\n			<td>02/02/2017 12:13PM</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.60</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6479</td>\r\n			<td>02/02/2017 01:59PM</td>\r\n			<td style="text-align: right; width: 90px">94.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">94.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.64</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">94.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6480</td>\r\n			<td>02/02/2017 01:00PM</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.08</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6481</td>\r\n			<td>02/02/2017 01:20PM</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.32</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6482</td>\r\n			<td>02/02/2017 01:17PM</td>\r\n			<td style="text-align: right; width: 90px">20.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">20.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.20</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">20.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6483</td>\r\n			<td>02/02/2017 01:20PM</td>\r\n			<td style="text-align: right; width: 90px">9.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">9.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.54</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">9.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6484</td>\r\n			<td>02/02/2017 03:01PM</td>\r\n			<td style="text-align: right; width: 90px">75.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">75.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">4.50</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">75.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6485</td>\r\n			<td>02/02/2017 02:19PM</td>\r\n			<td style="text-align: right; width: 90px">46.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">46.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.76</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">46.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6486</td>\r\n			<td>02/02/2017 02:58PM</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">106.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">106.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.36</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">106.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6487</td>\r\n			<td>02/02/2017 03:00PM</td>\r\n			<td style="text-align: right; width: 90px">27.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">27.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.62</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">27.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6488</td>\r\n			<td>02/02/2017 02:40PM</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.42</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6489</td>\r\n			<td>02/02/2017 02:45PM</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.72</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6490</td>\r\n			<td>02/02/2017 03:22PM</td>\r\n			<td style="text-align: right; width: 90px">30.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">30.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.80</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">30.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6491</td>\r\n			<td>02/02/2017 03:50PM</td>\r\n			<td style="text-align: right; width: 90px">111.90</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">111.90</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.71</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">111.90</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6492</td>\r\n			<td>02/02/2017 04:00PM</td>\r\n			<td style="text-align: right; width: 90px">72.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">72.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">4.32</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">72.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6493</td>\r\n			<td>02/02/2017 04:45PM</td>\r\n			<td style="text-align: right; width: 90px">79.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">79.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">4.74</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">79.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6494</td>\r\n			<td>02/02/2017 04:35PM</td>\r\n			<td style="text-align: right; width: 90px">25.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">25.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.50</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">25.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6495</td>\r\n			<td>02/02/2017 03:45PM</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.72</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6496</td>\r\n			<td>02/02/2017 04:16PM</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.72</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6497</td>\r\n			<td>02/02/2017 05:11PM</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.66</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6498</td>\r\n			<td>02/02/2017 05:59PM</td>\r\n			<td style="text-align: right; width: 90px">43.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">43.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.58</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">43.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6499</td>\r\n			<td>02/02/2017 06:05PM</td>\r\n			<td style="text-align: right; width: 90px">28.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">28.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.68</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">28.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6500</td>\r\n			<td>02/02/2017 05:40PM</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.60</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6501</td>\r\n			<td>02/02/2017 06:54PM</td>\r\n			<td style="text-align: right; width: 90px">64.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">64.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.84</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">64.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6502</td>\r\n			<td>02/02/2017 06:11PM</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.66</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6503</td>\r\n			<td>02/02/2017 07:21PM</td>\r\n			<td style="text-align: right; width: 90px">60.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">60.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.60</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">60.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6504</td>\r\n			<td>02/02/2017 07:16PM</td>\r\n			<td style="text-align: right; width: 90px">48.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">48.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.88</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">48.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6505</td>\r\n			<td>02/02/2017 07:18PM</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.66</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6506</td>\r\n			<td>02/02/2017 08:56PM</td>\r\n			<td style="text-align: right; width: 90px">46.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">46.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.76</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">46.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6507</td>\r\n			<td>02/02/2017 07:58PM</td>\r\n			<td style="text-align: right; width: 90px">40.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">40.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.40</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">40.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6508</td>\r\n			<td>02/02/2017 08:20PM</td>\r\n			<td style="text-align: right; width: 90px">97.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">97.00</td>\r\n			<td style="text-align: rig', '2017-03-06 10:06:36', 'admin');
INSERT INTO `reports_saved` (`id`, `type`, `title`, `notes`, `output`, `added_on`, `added_by`) VALUES
(6, 'F&B Sales Report', 'FEB 2', '', '<style>\r\n	table.print-standard {\r\n		border-collapse: collapse;\r\n		border-spacing: 0;\r\n		border: 1px solid #333;\r\n	}\r\n	\r\n	table.print-standard th {\r\n		background: #EEE;	\r\n		border: 1px solid #333;\r\n		padding: 2px 5px;\r\n		text-align: center;\r\n	}\r\n	\r\n	table.print-standard td {\r\n		border: 1px solid #333;\r\n		padding: 2px 5px;\r\n	}\r\n	\r\n	table.w100 {\r\n		width: 100%;	\r\n	}\r\n	\r\n	table.print-standard tr.footer {\r\n		background: #EEE;	\r\n	}\r\n</style>\r\n\r\n<h1>The Daily Dose</h1>\r\n<h2 style="text-align: center; margin-bottom: 0; padding-bottom: 0">F&amp;B Sales Report</h2>\r\n<p style="text-align: center;">\r\n	From \r\n		Wednesday, February 22, 2017 \r\n	to \r\n		Tuesday, March 7, 2017 \r\n</p>\r\n\r\n<table class="print-standard w100">\r\n	<thead>\r\n		<tr>\r\n			<th>Txn</th>\r\n			<th>Date/Time</th>\r\n			<th>Amount Cash (RM)</th>\r\n			<th>Amount Credit Card (RM)</th>\r\n			<th>Amount Voucher (RM)</th>\r\n			<th>Amount Cheque (RM)</th>\r\n			<th>Amount Discount (RM)</th>\r\n			<th>Amount (RM)</th>\r\n			<th>Service Charge (RM)</th>\r\n			<!--\r\n			<th>SR Tax (RM)</th>\r\n			<th>ZRL Tax (RM)</th>\r\n			-->\r\n			<th>GST (RM)</th>\r\n			<th>Net (RM)</th>\r\n			<th>Customer/Customer of</th>\r\n		</tr>\r\n	</thead>\r\n	<tbody>\r\n						<tr>\r\n			<td>RC-7067</td>\r\n			<td>22/02/2017 10:02AM</td>\r\n			<td style="text-align: right; width: 90px">28.60</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">28.60</td>\r\n			<td style="text-align: right; width: 90px">2.60</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.72</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">26.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7068</td>\r\n			<td>22/02/2017 10:09AM</td>\r\n			<td style="text-align: right; width: 90px">69.30</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">69.30</td>\r\n			<td style="text-align: right; width: 90px">6.30</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">4.16</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">63.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7069</td>\r\n			<td>22/02/2017 12:24PM</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td style="text-align: right; width: 90px">2.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.32</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">20.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7070</td>\r\n			<td>22/02/2017 10:35AM</td>\r\n			<td style="text-align: right; width: 90px">24.20</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.20</td>\r\n			<td style="text-align: right; width: 90px">2.20</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.45</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7071</td>\r\n			<td>22/02/2017 11:45AM</td>\r\n			<td style="text-align: right; width: 90px">38.50</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">38.50</td>\r\n			<td style="text-align: right; width: 90px">3.50</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.31</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">35.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7072</td>\r\n			<td>22/02/2017 10:53AM</td>\r\n			<td style="text-align: right; width: 90px">29.70</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">29.70</td>\r\n			<td style="text-align: right; width: 90px">2.70</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.78</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">27.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7073</td>\r\n			<td>22/02/2017 11:37AM</td>\r\n			<td style="text-align: right; width: 90px">37.60</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">4.18</td>\r\n			<td style="text-align: right; width: 90px">37.60</td>\r\n			<td style="text-align: right; width: 90px">3.42</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.26</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">34.18</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7074</td>\r\n			<td>22/02/2017 01:47PM</td>\r\n			<td style="text-align: right; width: 90px">27.50</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">27.50</td>\r\n			<td style="text-align: right; width: 90px">2.50</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.65</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">25.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7075</td>\r\n			<td>22/02/2017 11:57AM</td>\r\n			<td style="text-align: right; width: 90px">48.40</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">48.40</td>\r\n			<td style="text-align: right; width: 90px">4.40</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.90</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">44.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7076</td>\r\n			<td>22/02/2017 12:09PM</td>\r\n			<td style="text-align: right; width: 90px">50.05</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">50.05</td>\r\n			<td style="text-align: right; width: 90px">4.55</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.00</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">45.50</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7077</td>\r\n			<td>22/02/2017 08:39PM</td>\r\n			<td style="text-align: right; width: 90px">47.30</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">47.30</td>\r\n			<td style="text-align: right; width: 90px">4.30</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.84</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">43.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7078</td>\r\n			<td>22/02/2017 01:10PM</td>\r\n			<td style="text-align: right; width: 90px">14.30</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">14.30</td>\r\n			<td style="text-align: right; width: 90px">1.30</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.86</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">13.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7079</td>\r\n			<td>22/02/2017 12:37PM</td>\r\n			<td style="text-align: right; width: 90px">24.20</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.20</td>\r\n			<td style="text-align: right; width: 90px">2.20</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.45</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7080</td>\r\n			<td>22/02/2017 01:32PM</td>\r\n			<td style="text-align: right; width: 90px">130.90</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">130.90</td>\r\n			<td style="text-align: right; width: 90px">11.90</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.85</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">119.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7081</td>\r\n			<td>22/02/2017 01:12PM</td>\r\n			<td style="text-align: right; width: 90px">20.90</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">20.90</td>\r\n			<td style="text-align: right; width: 90px">1.90</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.25</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">19.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7082</td>\r\n			<td>22/02/2017 12:55PM</td>\r\n			<td style="text-align: right; width: 90px">15.40</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">15.40</td>\r\n			<td style="text-align: right; width: 90px">1.40</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.92</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">14.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7083</td>\r\n			<td>22/02/2017 01:19PM</td>\r\n			<td style="text-align: right; width: 90px">28.60</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">28.60</td>\r\n			<td style="text-align: right; width: 90px">2.60</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.72</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">26.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7084</td>\r\n			<td>22/02/2017 01:07PM</td>\r\n			<td style="text-align: right; width: 90px">5.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.30</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7085</td>\r\n			<td>22/02/2017 02:27PM</td>\r\n			<td style="text-align: right; width: 90px">9.90</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">9.90</td>\r\n			<td style="text-align: right; width: 90px">0.90</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.59</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">9.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7086</td>\r\n			<td>22/02/2017 02:32PM</td>\r\n			<td style="text-align: right; width: 90px">42.90</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">42.90</td>\r\n			<td style="text-align: right; width: 90px">3.90</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.57</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">39.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7087</td>\r\n			<td>22/02/2017 02:16PM</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.60</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7088</td>\r\n			<td>22/02/2017 02:22PM</td>\r\n			<td style="text-align: right; width: 90px">23.10</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">23.10</td>\r\n			<td style="text-align: right; width: 90px">2.10</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.39</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">21.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7089</td>\r\n			<td>22/02/2017 03:07PM</td>\r\n			<td style="text-align: right; width: 90px">20.90</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">20.90</td>\r\n			<td style="text-align: right; width: 90px">1.90</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.25</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">19.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7090</td>\r\n			<td>22/02/2017 03:26PM</td>\r\n			<td style="text-align: right; width: 90px">15.40</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">15.40</td>\r\n			<td style="text-align: right; width: 90px">1.40</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.92</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">14.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7091</td>\r\n			<td>22/02/2017 03:01PM</td>\r\n			<td style="text-align: right; width: 90px">6.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.36</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7092</td>\r\n			<td>22/02/2017 03:34PM</td>\r\n			<td style="text-align: right; width: 90px">51.70</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">51.70</td>\r\n			<td style="text-align: right; width: 90px">4.70</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.10</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">47.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7093</td>\r\n			<td>22/02/2017 05:14PM</td>\r\n			<td style="text-align: right; width: 90px">24.20</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.20</td>\r\n			<td style="text-align: right; width: 90px">2.20</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.45</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7094</td>\r\n			<td>22/02/2017 05:41PM</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">1.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.66</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7095</td>\r\n			<td>22/02/2017 05:30PM</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.60</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7096</td>\r\n			<td>22/02/2017 06:25PM</td>\r\n			<td style="text-align: right; width: 90px">19.80</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">19.80</td>\r\n			<td style="text-align: right; width: 90px">1.80</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.19</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7097</td>\r\n			<td>22/02/2017 07:10PM</td>\r\n			<td style="text-align: right; width: 90px">14.30</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">14.30</td>\r\n			<td style="text-align: right; width: 90px">1.30</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.86</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">13.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7098</td>\r\n			<td>22/02/2017 07:26PM</td>\r\n			<td style="text-align: right; width: 90px">29.70</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">29.70</td>\r\n			<td style="text-align: right; width: 90px">2.70</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.78</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">27.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7099</td>\r\n			<td>23/02/2017 11:26AM</td>\r\n			<td style="text-align: right; width: 90px">91.30</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">91.30</td>\r\n			<td style="text-align: right; width: 90px">8.30</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.48</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">83.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7100</td>\r\n			<td>23/02/2017 10:57AM</td>\r\n			<td style="text-align: right; width: 90px">29.70</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">29.70</td>\r\n			<td style="text-align: right; width: 90px">2.70</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.78</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">27.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7101</td>\r\n			<td>23/02/2017 11:13AM</td>\r\n			<td style="text-align: right; width: 90px">6.60</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.60</td>\r\n			<td style="text-align: right; width: 90px">0.60</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.40</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7102</td>\r\n			<td>23/02/2017 11:03AM</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.44</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7103</td>\r\n			<td>23/02/2017 01:16PM</td>\r\n			<td style="text-align: right; width: 90px">55.45</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.16</td>\r\n			<td style="text-align: right; width: 90px">55.45</td>\r\n			<td style="text-align: right; width: 90px">5.04</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.33</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">50.41</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7104</td>\r\n			<td>23/02/2017 01:45PM</td>\r\n			<td style="text-align: right; width: 90px">30.80</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">30.80</td>\r\n			<td style="text-align: right; width: 90px">2.80</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.85</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">28.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7105</td>\r\n			<td>23/02/2017 12:12PM</td>\r\n			<td style="text-align: right; width: 90px">24.20</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.20</td>\r\n			<td style="text-align: right; width: 90px">2.20</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.45</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7106</td>\r\n			<td>23/02/2017 12:17PM</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.66</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7107</td>\r\n			<td>23/02/2017 12:44PM</td>\r\n			<td style="text-align: right; width: 90px">17.60</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">17.60</td>\r\n			<td style="text-align: right; width: 90px">1.60</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.06</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">16.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7108</td>\r\n			<td>23/02/2017 01:22PM</td>\r\n			<td style="text-align: right; width: 90px">48.95</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">48.95</td>\r\n			<td style="text-align: right; width: 90px">4.45</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.94</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">44.50</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7109</td>\r\n			<td>23/02/2017 01:35PM</td>\r\n			<td style="text-align: right; width: 90px">159.50</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">159.50</td>\r\n			<td style="text-align: right; width: 90px">14.50</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">9.57</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">145.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7110</td>\r\n			<td>23/02/2017 01:24PM</td>\r\n			<td style="text-align: right; width: 90px">25.30</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">25.30</td>\r\n			<td style="text-align: right; width: 90px">2.30</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.52</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">23.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7111</td>\r\n			<td>23/02/2017 02:22PM</td>\r\n			<td style="text-align: right; width: 90px">41.80</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">41.80</td>\r\n			<td style="text-align: right; width: 90px">3.80</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.51</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">38.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7112</td>\r\n			<td>23/02/2017 03:07PM</td>\r\n			<td style="text-align: right; width: 90px">181.50</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">181.50</td>\r\n			<td style="text-align: right; width: 90px">16.50</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.89</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">165.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7113</td>\r\n			<td>23/02/2017 03:11PM</td>\r\n			<td style="text-align: right; width: 90px">46.20</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">46.20</td>\r\n			<td style="text-align: right; width: 90px">4.20</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.77</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">42.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7114</td>\r\n			<td>23/02/2017 02:32PM</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.42</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7115</td>\r\n			<td>23/02/2017 03:32PM</td>\r\n			<td style="text-align: right; width: 90px">83.60</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">83.60</td>\r\n			<td style="text-align: right; width: 90px">7.60</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.02</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">76.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7116</td>\r\n			<td>23/02/2017 03:21PM</td>\r\n			<td style="text-align: right; width: 90px">55.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">55.00</td>\r\n			<td style="text-align: right; width: 90px">5.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.30</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">50.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7117</td>\r\n			<td>23/02/2017 03:48PM</td>\r\n			<td style="text-align: right; width: 90px">144.10</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">144.10</td>\r\n			<td style="text-align: right; width: 90px">13.10</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.65</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">131.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7119</td>\r\n			<td>23/02/2017 04:01PM</td>\r\n			<td style="text-align: right; width: 90px">20.90</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">20.90</td>\r\n			<td style="text-align: right; width: 90px">1.90</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.25</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">19.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7120</td>\r\n			<td>23/02/2017 05:52PM</td>\r\n			<td style="text-align: right; width: 90px">17.50</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">17.50</td>\r\n			<td style="text-align: right; width: 90px">1.59</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.05</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">15.91</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7122</td>\r\n			<td>23/02/2017 05:29PM</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.60</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7123</td>\r\n			<td>23/02/2017 08:55PM</td>\r\n			<td style="text-align: right; width: 90px">91.30</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">91.30</td>\r\n			<td style="text-align: right; width: 90px">8.30</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.48</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">83.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7124</td>\r\n			<td>23/02/2017 07:13PM</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.60</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7125</td>\r\n			<td>23/02/2017 09:18PM</td>\r\n			<td style="text-align: right; width: 90px">84.70</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">84.70</td>\r\n			<td style="text-align: right; width: 90px">7.70</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.08</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">77.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7126</td>\r\n			<td>23/02/2017 08:55PM</td>\r\n			<td style="text-align: right; width: 90px">19.80</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">19.80</td>\r\n			<td style="text-align: right; width: 90px">1.80</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.19</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7127</td>\r\n			<td>23/02/2017 09:18PM</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td style="text-align: right; width: 90px">2.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.32</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">20.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7128</td>\r\n			<td>23/02/2017 09:15PM</td>\r\n			<td style="text-align: right; width: 90px">69.30</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">69.30</td>\r\n			<td style="text-align: right; width: 90px">6.30</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">4.16</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">63.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7129</td>\r\n			<td>24/02/2017 10:29AM</td>\r\n			<td style="text-align: right; width: 90px">56.10</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">56.10</td>\r\n			<td style="text-align: right; width: 90px">5.10</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.37</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">51.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7130</td>\r\n			<td>24/02/2017 11:37AM</td>\r\n			<td style="text-align: right; width: 90px">58.30</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">58.30</td>\r\n			<td style="text-align: right; width: 90px">5.30</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.50</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">53.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7131</td>\r\n			<td>24/02/2017 10:08AM</td>\r\n			<td style="text-align: right; width: 90px">59.40</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">59.40</td>\r\n			<td style="text-align: right; width: 90px">5.40</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.56</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">54.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7132</td>\r\n			<td>24/02/2017 01:01PM</td>\r\n			<td style="text-align: right; width: 90px">100.10</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">100.10</td>\r\n			<td style="text-align: right; width: 90px">9.10</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.01</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">91.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7133</td>\r\n			<td>24/02/2017 10:55AM</td>\r\n			<td style="text-align: right; width: 90px">8.80</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.80</td>\r\n			<td style="text-align: right; width: 90px">0.80</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.53</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7134</td>\r\n			<td>24/02/2017 12:17PM</td>\r\n			<td style="text-align: right; width: 90px">81.40</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">81.40</td>\r\n			<td style="text-align: right; width: 90px">7.40</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">4.88</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">74.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7135</td>\r\n			<td>24/02/2017 12:11PM</td>\r\n			<td style="text-align: right; width: 90px">19.80</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">19.80</td>\r\n			<td style="text-align: right; width: 90px">1.80</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.19</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7137</td>\r\n			<td>24/02/2017 02:28PM</td>\r\n			<td style="text-align: right; width: 90px">41.80</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">41.80</td>\r\n			<td style="text-align: right; width: 90px">3.80</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.51</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">38.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7138</td>\r\n			<td>24/02/2017 12:37PM</td>\r\n			<td style="text-align: right; width: 90px">75.90</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">75.90</td>\r\n			<td style="text-align: right; width: 90px">6.90</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">4.55</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">69.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7139</td>\r\n			<td>24/02/2017 01:23PM</td>\r\n			<td style="text-align: right; width: 90px">59.40</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">59.40</td>\r\n			<td style="text-align: right; width: 90px">5.40</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.56</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">54.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7140</td>\r\n			<td>24/02/2017 12:11PM</td>\r\n			<td style="text-align: right; width: 90px">6.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.36</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7141</td>\r\n			<td>24/02/2017 01:06PM</td>\r\n			<td style="text-align: right; width: 90px">51.70</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">51.70</td>\r\n			<td style="text-align: right; width: 90px">4.70</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.10</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">47.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7142</td>\r\n			<td>24/02/2017 01:31PM</td>\r\n			<td style="text-align: right; width: 90px">163.90</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">163.90</td>\r\n			<td style="text-align: right; width: 90px">14.90</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">9.83</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">149.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7143</td>\r\n			<td>24/02/2017 01:47PM</td>\r\n			<td style="text-align: right; width: 90px">31.90</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">31.90</td>\r\n			<td style="text-align: right; width: 90px">2.90</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.91</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">29.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7144</td>\r\n			<td>24/02/2017 01:58PM</td>\r\n			<td style="text-align: right; width: 90px">69.30</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">69.30</td>\r\n			<td style="text-align: right; width: 90px">6.30</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">4.16</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">63.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7145</td>\r\n			<td>24/02/2017 02:04PM</td>\r\n			<td style="text-align: right; width: 90px">28.60</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">28.60</td>\r\n			<td style="text-align: right; width: 90px">2.60</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.72</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">26.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7146</td>\r\n			<td>24/02/2017 01:25PM</td>\r\n			<td style="text-align: right; width: 90px">23.40</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.60</td>\r\n			<td style="text-align: right; width: 90px">23.40</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.40</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">23.40</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7147</td>\r\n			<td>24/02/2017 02:57PM</td>\r\n			<td style="text-align: right; width: 90px">105.60</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">105.60</td>\r\n			<td style="text-align: right; width: 90px">9.60</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.34</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">96.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7148</td>\r\n			<td>24/02/2017 01:33PM</td>\r\n			<td style="text-align: right; width: 90px">12.10</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.10</td>\r\n			<td style="text-align: right; width: 90px">1.10</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.73</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7149</td>\r\n			<td>24/02/2017 03:10PM</td>\r\n			<td style="text-align: right; width: 90px">99.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">99.00</td>\r\n			<td style="text-align: right; width: 90px">9.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.94</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">90.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7150</td>\r\n			<td>24/02/2017 02:06PM</td>\r\n			<td style="text-align: right; width: 90px">15.40</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">15.40</td>\r\n			<td style="text-align: right; width: 90px">1.40</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.92</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">14.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7151</td>\r\n			<td>24/02/2017 02:16PM</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.42</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7152</td>\r\n			<td>24/02/2017 04:39PM</td>\r\n			<td style="text-align: right; width: 90px">47.30</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">47.30</td>\r\n			<td style="text-align: right; width: 90px">4.30</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.84</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">43.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7153</td>\r\n			<td>24/02/2017 04:21PM</td>\r\n			<td style="text-align: right; width: 90px">23.10</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">23.10</td>\r\n			<td style="text-align: right; width: 90px">2.10</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.39</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">21.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7154</td>\r\n			<td>24/02/2017 04:08PM</td>\r\n			<td style="text-align: right; width: 90px">8.80</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.80</td>\r\n			<td style="text-align: right; width: 90px">0.80</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.53</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7155</td>\r\n			<td>24/02/2017 05:24PM</td>\r\n			<td style="text-align: right; width: 90px">13.20</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">13.20</td>\r\n			<td style="text-align: right; width: 90px">1.20</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.79</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7156</td>\r\n			<td>24/02/2017 05:23PM</td>\r\n			<td style="text-align: right; width: 90px">8.80</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.80</td>\r\n			<td style="text-align: right; width: 90px">0.80</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.53</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-7157</td>\r\n			<td>24/02/2017 05:24PM</td>\r\n			<td style="text-align: right; width: 90px">13.20</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">13.20</td>\r\n			<td style=', '2017-03-06 10:07:31', 'admin');
INSERT INTO `reports_saved` (`id`, `type`, `title`, `notes`, `output`, `added_on`, `added_by`) VALUES
(7, 'F&B Sales Report', '01022017-15022017', 'Items sold report', '<style>\r\n	table.print-standard {\r\n		border-collapse: collapse;\r\n		border-spacing: 0;\r\n		border: 1px solid #333;\r\n	}\r\n	\r\n	table.print-standard th {\r\n		background: #EEE;	\r\n		border: 1px solid #333;\r\n		padding: 2px 5px;\r\n		text-align: center;\r\n	}\r\n	\r\n	table.print-standard td {\r\n		border: 1px solid #333;\r\n		padding: 2px 5px;\r\n	}\r\n	\r\n	table.w100 {\r\n		width: 100%;	\r\n	}\r\n	\r\n	table.print-standard tr.footer {\r\n		background: #EEE;	\r\n	}\r\n</style>\r\n\r\n<h1>The Daily Dose</h1>\r\n<h2 style="text-align: center; margin-bottom: 0; padding-bottom: 0">F&amp;B Sales Report</h2>\r\n<p style="text-align: center;">\r\n	From \r\n		Wednesday, February 1, 2017 \r\n	to \r\n		Thursday, February 16, 2017 \r\n</p>\r\n\r\n<table class="print-standard w100">\r\n	<thead>\r\n		<tr>\r\n			<th>Txn</th>\r\n			<th>Date/Time</th>\r\n			<th>Amount Cash (RM)</th>\r\n			<th>Amount Credit Card (RM)</th>\r\n			<th>Amount Voucher (RM)</th>\r\n			<th>Amount Cheque (RM)</th>\r\n			<th>Amount Discount (RM)</th>\r\n			<th>Amount (RM)</th>\r\n			<th>Service Charge (RM)</th>\r\n			<!--\r\n			<th>SR Tax (RM)</th>\r\n			<th>ZRL Tax (RM)</th>\r\n			-->\r\n			<th>GST (RM)</th>\r\n			<th>Net (RM)</th>\r\n			<th>Customer/Customer of</th>\r\n		</tr>\r\n	</thead>\r\n	<tbody>\r\n						<tr>\r\n			<td>RC-6419</td>\r\n			<td>01/02/2017 09:57AM</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.32</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6420</td>\r\n			<td>01/02/2017 10:15AM</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.42</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6421</td>\r\n			<td>01/02/2017 10:53AM</td>\r\n			<td style="text-align: right; width: 90px">6.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.36</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6422</td>\r\n			<td>01/02/2017 12:33PM</td>\r\n			<td style="text-align: right; width: 90px">108.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">108.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.48</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">108.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6423</td>\r\n			<td>01/02/2017 10:58AM</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.42</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6424</td>\r\n			<td>01/02/2017 11:45AM</td>\r\n			<td style="text-align: right; width: 90px">31.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">31.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.86</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">31.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6425</td>\r\n			<td>01/02/2017 11:31AM</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.66</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6426</td>\r\n			<td>01/02/2017 12:13PM</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.44</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6428</td>\r\n			<td>01/02/2017 12:53PM</td>\r\n			<td style="text-align: right; width: 90px">116.10</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.90</td>\r\n			<td style="text-align: right; width: 90px">116.10</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.97</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">116.10</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6429</td>\r\n			<td>01/02/2017 12:32PM</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.44</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6430</td>\r\n			<td>01/02/2017 01:11PM</td>\r\n			<td style="text-align: right; width: 90px">75.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">75.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">4.50</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">75.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6431</td>\r\n			<td>01/02/2017 12:42PM</td>\r\n			<td style="text-align: right; width: 90px">41.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">41.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.46</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">41.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6432</td>\r\n			<td>01/02/2017 12:42PM</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.08</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6433</td>\r\n			<td>01/02/2017 01:52PM</td>\r\n			<td style="text-align: right; width: 90px">57.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">57.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.42</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">57.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6434</td>\r\n			<td>01/02/2017 02:20PM</td>\r\n			<td style="text-align: right; width: 90px">16.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">16.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.96</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">16.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6435</td>\r\n			<td>01/02/2017 12:50PM</td>\r\n			<td style="text-align: right; width: 90px">42.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">42.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.52</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">42.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6436</td>\r\n			<td>01/02/2017 01:12PM</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.66</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6437</td>\r\n			<td>01/02/2017 03:45PM</td>\r\n			<td style="text-align: right; width: 90px">47.70</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.30</td>\r\n			<td style="text-align: right; width: 90px">47.70</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.86</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">47.70</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6438</td>\r\n			<td>01/02/2017 02:16PM</td>\r\n			<td style="text-align: right; width: 90px">35.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">35.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.10</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">35.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6439</td>\r\n			<td>01/02/2017 03:31PM</td>\r\n			<td style="text-align: right; width: 90px">85.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">85.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.10</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">85.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6440</td>\r\n			<td>01/02/2017 02:54PM</td>\r\n			<td style="text-align: right; width: 90px">70.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">70.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">4.20</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">70.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6441</td>\r\n			<td>01/02/2017 03:15PM</td>\r\n			<td style="text-align: right; width: 90px">44.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">44.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.64</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">44.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6442</td>\r\n			<td>01/02/2017 02:46PM</td>\r\n			<td style="text-align: right; width: 90px">15.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">15.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.90</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">15.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6443</td>\r\n			<td>01/02/2017 03:09PM</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.48</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6444</td>\r\n			<td>01/02/2017 03:07PM</td>\r\n			<td style="text-align: right; width: 90px">54.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">54.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.24</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">54.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6445</td>\r\n			<td>01/02/2017 03:24PM</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.66</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6446</td>\r\n			<td>01/02/2017 03:31PM</td>\r\n			<td style="text-align: right; width: 90px">14.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">14.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.84</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">14.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6447</td>\r\n			<td>01/02/2017 03:35PM</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.72</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6448</td>\r\n			<td>01/02/2017 03:50PM</td>\r\n			<td style="text-align: right; width: 90px">9.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">9.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.54</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">9.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6449</td>\r\n			<td>01/02/2017 04:15PM</td>\r\n			<td style="text-align: right; width: 90px">16.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">16.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.96</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">16.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6450</td>\r\n			<td>01/02/2017 05:29PM</td>\r\n			<td style="text-align: right; width: 90px">14.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">14.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.84</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">14.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6451</td>\r\n			<td>01/02/2017 05:11PM</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.08</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6452</td>\r\n			<td>01/02/2017 04:38PM</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.42</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6453</td>\r\n			<td>01/02/2017 05:15PM</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.66</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6454</td>\r\n			<td>01/02/2017 05:15PM</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.60</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6455</td>\r\n			<td>01/02/2017 06:09PM</td>\r\n			<td style="text-align: right; width: 90px">40.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">40.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.40</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">40.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6456</td>\r\n			<td>01/02/2017 09:43PM</td>\r\n			<td style="text-align: right; width: 90px">44.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">44.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.64</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">44.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6457</td>\r\n			<td>01/02/2017 07:03PM</td>\r\n			<td style="text-align: right; width: 90px">23.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">23.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.38</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">23.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6458</td>\r\n			<td>01/02/2017 07:51PM</td>\r\n			<td style="text-align: right; width: 90px">53.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">53.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.18</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">53.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6459</td>\r\n			<td>01/02/2017 07:19PM</td>\r\n			<td style="text-align: right; width: 90px">6.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.36</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6461</td>\r\n			<td>01/02/2017 09:28PM</td>\r\n			<td style="text-align: right; width: 90px">63.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">63.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.78</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">63.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6462</td>\r\n			<td>01/02/2017 08:37PM</td>\r\n			<td style="text-align: right; width: 90px">15.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">15.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.90</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">15.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6463</td>\r\n			<td>01/02/2017 08:52PM</td>\r\n			<td style="text-align: right; width: 90px">48.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">48.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.88</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">48.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6464</td>\r\n			<td>01/02/2017 09:11PM</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.60</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6465</td>\r\n			<td>02/02/2017 09:04AM</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.72</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6466</td>\r\n			<td>02/02/2017 09:28AM</td>\r\n			<td style="text-align: right; width: 90px">63.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">63.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.78</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">63.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6467</td>\r\n			<td>02/02/2017 10:14AM</td>\r\n			<td style="text-align: right; width: 90px">57.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">57.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.42</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">57.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6468</td>\r\n			<td>02/02/2017 09:45AM</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.42</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6469</td>\r\n			<td>02/02/2017 10:35AM</td>\r\n			<td style="text-align: right; width: 90px">34.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">34.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.04</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">34.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6470</td>\r\n			<td>02/02/2017 11:11AM</td>\r\n			<td style="text-align: right; width: 90px">63.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">63.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.78</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">63.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6471</td>\r\n			<td>02/02/2017 11:51AM</td>\r\n			<td style="text-align: right; width: 90px">30.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">30.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.80</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">30.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6472</td>\r\n			<td>02/02/2017 11:44AM</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.44</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6473</td>\r\n			<td>02/02/2017 12:53PM</td>\r\n			<td style="text-align: right; width: 90px">85.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">85.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.10</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">85.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6474</td>\r\n			<td>02/02/2017 11:43AM</td>\r\n			<td style="text-align: right; width: 90px">39.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">39.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.34</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">39.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6475</td>\r\n			<td>02/02/2017 12:16PM</td>\r\n			<td style="text-align: right; width: 90px">77.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">77.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">4.62</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">77.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6476</td>\r\n			<td>02/02/2017 11:59AM</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.48</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6477</td>\r\n			<td>02/02/2017 12:08PM</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.48</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6478</td>\r\n			<td>02/02/2017 12:13PM</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.60</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6479</td>\r\n			<td>02/02/2017 01:59PM</td>\r\n			<td style="text-align: right; width: 90px">94.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">94.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.64</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">94.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6480</td>\r\n			<td>02/02/2017 01:00PM</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.08</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6481</td>\r\n			<td>02/02/2017 01:20PM</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.32</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6482</td>\r\n			<td>02/02/2017 01:17PM</td>\r\n			<td style="text-align: right; width: 90px">20.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">20.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.20</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">20.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6483</td>\r\n			<td>02/02/2017 01:20PM</td>\r\n			<td style="text-align: right; width: 90px">9.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">9.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.54</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">9.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6484</td>\r\n			<td>02/02/2017 03:01PM</td>\r\n			<td style="text-align: right; width: 90px">75.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">75.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">4.50</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">75.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6485</td>\r\n			<td>02/02/2017 02:19PM</td>\r\n			<td style="text-align: right; width: 90px">46.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">46.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.76</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">46.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6486</td>\r\n			<td>02/02/2017 02:58PM</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">106.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">106.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.36</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">106.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6487</td>\r\n			<td>02/02/2017 03:00PM</td>\r\n			<td style="text-align: right; width: 90px">27.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">27.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.62</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">27.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6488</td>\r\n			<td>02/02/2017 02:40PM</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.42</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6489</td>\r\n			<td>02/02/2017 02:45PM</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.72</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6490</td>\r\n			<td>02/02/2017 03:22PM</td>\r\n			<td style="text-align: right; width: 90px">30.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">30.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.80</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">30.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6491</td>\r\n			<td>02/02/2017 03:50PM</td>\r\n			<td style="text-align: right; width: 90px">111.90</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">111.90</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.71</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">111.90</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6492</td>\r\n			<td>02/02/2017 04:00PM</td>\r\n			<td style="text-align: right; width: 90px">72.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">72.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">4.32</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">72.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6493</td>\r\n			<td>02/02/2017 04:45PM</td>\r\n			<td style="text-align: right; width: 90px">79.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">79.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">4.74</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">79.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6494</td>\r\n			<td>02/02/2017 04:35PM</td>\r\n			<td style="text-align: right; width: 90px">25.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">25.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.50</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">25.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6495</td>\r\n			<td>02/02/2017 03:45PM</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.72</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6496</td>\r\n			<td>02/02/2017 04:16PM</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.72</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6497</td>\r\n			<td>02/02/2017 05:11PM</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.66</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6498</td>\r\n			<td>02/02/2017 05:59PM</td>\r\n			<td style="text-align: right; width: 90px">43.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">43.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.58</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">43.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6499</td>\r\n			<td>02/02/2017 06:05PM</td>\r\n			<td style="text-align: right; width: 90px">28.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">28.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.68</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">28.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6500</td>\r\n			<td>02/02/2017 05:40PM</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.60</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6501</td>\r\n			<td>02/02/2017 06:54PM</td>\r\n			<td style="text-align: right; width: 90px">64.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">64.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.84</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">64.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6502</td>\r\n			<td>02/02/2017 06:11PM</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.66</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6503</td>\r\n			<td>02/02/2017 07:21PM</td>\r\n			<td style="text-align: right; width: 90px">60.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">60.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.60</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">60.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6504</td>\r\n			<td>02/02/2017 07:16PM</td>\r\n			<td style="text-align: right; width: 90px">48.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">48.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.88</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">48.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6505</td>\r\n			<td>02/02/2017 07:18PM</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.66</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6506</td>\r\n			<td>02/02/2017 08:56PM</td>\r\n			<td style="text-align: right; width: 90px">46.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">46.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.76</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">46.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6507</td>\r\n			<td>02/02/2017 07:58PM</td>\r\n			<td style="text-align: right; width: 90px">40.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">40.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.40</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">40.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6508</td>\r\n			<td>02/02/2017 08:20PM</td>\r\n			<td style="text-align: right; width: 90px">97.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">97.00</td>\r\n			<td style="text-align: r', '2017-03-13 11:36:14', 'lois');
INSERT INTO `reports_saved` (`id`, `type`, `title`, `notes`, `output`, `added_on`, `added_by`) VALUES
(8, 'F&B Category Sales Report', 'service charge reportt 0102-1502', '', '<h2 style="text-align: center; margin-bottom: 0; padding-bottom: 0">\r\n	F&amp;B Sales Report\r\n</h2>\r\n<p style="text-align: center; \r\n	padding-bottom: 10px; margin-bottom: 20px; border-bottom: 1px solid #CCC">\r\n	Date Range: \r\n	Wednesday, February 1, 2017 - \r\n	Thursday, February 16, 2017</p>\r\n<div id="piechart" style="height: 350px; width: 100%">\r\n	\r\n</div>\r\n<table class="grid">\r\n	<thead>\r\n		<tr>\r\n			<th>Category</th>\r\n			<th>Amount</th>\r\n			<th>Discount Given</th>\r\n			<th>Net Amount</th>\r\n		</tr>\r\n	</thead>\r\n	<tbody>\r\n						<tr>\r\n			<td>\r\n				Meals			</td>\r\n			<td style="text-align: right">\r\n				8,487.40			</td>\r\n			<td style="text-align: right">\r\n				77.50			</td>\r\n			<td style="text-align: right">\r\n				8,409.90			</td>\r\n		</tr>\r\n				\r\n						<tr>\r\n			<td>\r\n				Cold Drinks			</td>\r\n			<td style="text-align: right">\r\n				5,865.00			</td>\r\n			<td style="text-align: right">\r\n				43.50			</td>\r\n			<td style="text-align: right">\r\n				5,821.50			</td>\r\n		</tr>\r\n				\r\n						<tr>\r\n			<td>\r\n				Hot Drinks			</td>\r\n			<td style="text-align: right">\r\n				3,435.00			</td>\r\n			<td style="text-align: right">\r\n				15.80			</td>\r\n			<td style="text-align: right">\r\n				3,419.20			</td>\r\n		</tr>\r\n				\r\n						<tr>\r\n			<td>\r\n				Desserts			</td>\r\n			<td style="text-align: right">\r\n				1,049.00			</td>\r\n			<td style="text-align: right">\r\n				3.60			</td>\r\n			<td style="text-align: right">\r\n				1,045.40			</td>\r\n		</tr>\r\n				\r\n									\r\n						<tr>\r\n			<td>\r\n				DISCOUNT 			</td>\r\n			<td style="text-align: right">\r\n				-37.50			</td>\r\n			<td style="text-align: right">\r\n				0.00			</td>\r\n			<td style="text-align: right">\r\n				-37.50			</td>\r\n		</tr>\r\n				\r\n				<tr>\r\n			<td>SERVICE CHARGE</td>\r\n			<td style="text-align: right">\r\n				591.90			</td>\r\n			<td style="text-align: right">\r\n				2.84			</td>\r\n			<td style="text-align: right">\r\n				589.06			</td>\r\n		</tr>\r\n		<tr>\r\n			<td>TOTAL WITH SERVICE CHARGE</td>\r\n			<td style="text-align: right"><strong>19,390.80</strong></td>\r\n			<td style="text-align: right"><strong>143.24</strong></td>\r\n			<td style="text-align: right"><strong>19,247.56</strong></td>\r\n		</tr>\r\n		<tr>\r\n			<td>NET TOTAL </td>\r\n			<td style="text-align: right"><strong>18,798.90</strong></td>\r\n			<td style="text-align: right"><strong>140.40</strong></td>\r\n			<td style="text-align: right"><strong>18,658.50</strong></td>\r\n		</tr>\r\n	</tbody>\r\n</table>\r\n<hr />\r\n\r\n\r\n\r\n<hr />\r\n\r\n<script type="text/javascript" src="js/flot/jquery.flot.pie.js"></script>\r\n<script type="text/javascript">\r\n	\r\n	$(document).ready(function(){\r\n		setTimeout(function(){\r\n			var data = [{"label":"Meals","data":8487.4},{"label":"Cold Drinks","data":5865},{"label":"Hot Drinks","data":3435},{"label":"Desserts","data":1049},{"label":"SERVICE CHARGE","data":591.9},{"label":"DISCOUNT ","data":-37.5}];\r\n			$.plot(''#piechart'', data, {\r\n				series: {\r\n					pie: { \r\n						show: true\r\n					}\r\n				},\r\n				legend: {\r\n					show: false\r\n				}\r\n			});\r\n		}, 200);\r\n	});\r\n	\r\n</script>\r\n', '2017-03-13 11:40:11', 'lois');
INSERT INTO `reports_saved` (`id`, `type`, `title`, `notes`, `output`, `added_on`, `added_by`) VALUES
(9, 'F&B Sales Report', '16022017-28022017', 'Items sold', '<style>\r\n	table.print-standard {\r\n		border-collapse: collapse;\r\n		border-spacing: 0;\r\n		border: 1px solid #333;\r\n	}\r\n	\r\n	table.print-standard th {\r\n		background: #EEE;	\r\n		border: 1px solid #333;\r\n		padding: 2px 5px;\r\n		text-align: center;\r\n	}\r\n	\r\n	table.print-standard td {\r\n		border: 1px solid #333;\r\n		padding: 2px 5px;\r\n	}\r\n	\r\n	table.w100 {\r\n		width: 100%;	\r\n	}\r\n	\r\n	table.print-standard tr.footer {\r\n		background: #EEE;	\r\n	}\r\n</style>\r\n\r\n<h1>The Daily Dose</h1>\r\n<h2 style="text-align: center; margin-bottom: 0; padding-bottom: 0">F&amp;B Sales Report</h2>\r\n<p style="text-align: center;">\r\n	From \r\n		Thursday, February 16, 2017 \r\n	to \r\n		Wednesday, March 1, 2017 \r\n</p>\r\n\r\n<table class="print-standard w100">\r\n	<thead>\r\n		<tr>\r\n			<th>Txn</th>\r\n			<th>Date/Time</th>\r\n			<th>Amount Cash (RM)</th>\r\n			<th>Amount Credit Card (RM)</th>\r\n			<th>Amount Voucher (RM)</th>\r\n			<th>Amount Cheque (RM)</th>\r\n			<th>Amount Discount (RM)</th>\r\n			<th>Amount (RM)</th>\r\n			<th>Service Charge (RM)</th>\r\n			<!--\r\n			<th>SR Tax (RM)</th>\r\n			<th>ZRL Tax (RM)</th>\r\n			-->\r\n			<th>GST (RM)</th>\r\n			<th>Net (RM)</th>\r\n			<th>Customer/Customer of</th>\r\n		</tr>\r\n	</thead>\r\n	<tbody>\r\n						<tr>\r\n			<td>RC-6890</td>\r\n			<td>16/02/2017 09:44AM</td>\r\n			<td style="text-align: right; width: 90px">53.90</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">53.90</td>\r\n			<td style="text-align: right; width: 90px">4.90</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.23</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">49.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6891</td>\r\n			<td>16/02/2017 11:41AM</td>\r\n			<td style="text-align: right; width: 90px">58.30</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">58.30</td>\r\n			<td style="text-align: right; width: 90px">5.30</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.50</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">53.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6892</td>\r\n			<td>16/02/2017 10:56AM</td>\r\n			<td style="text-align: right; width: 90px">49.50</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">49.50</td>\r\n			<td style="text-align: right; width: 90px">4.50</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.97</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">45.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6893</td>\r\n			<td>16/02/2017 10:41AM</td>\r\n			<td style="text-align: right; width: 90px">48.40</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">48.40</td>\r\n			<td style="text-align: right; width: 90px">4.40</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.90</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">44.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6894</td>\r\n			<td>16/02/2017 11:32AM</td>\r\n			<td style="text-align: right; width: 90px">24.20</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.20</td>\r\n			<td style="text-align: right; width: 90px">2.20</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.45</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6895</td>\r\n			<td>16/02/2017 02:06PM</td>\r\n			<td style="text-align: right; width: 90px">12.10</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.10</td>\r\n			<td style="text-align: right; width: 90px">1.10</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.73</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6896</td>\r\n			<td>16/02/2017 11:43AM</td>\r\n			<td style="text-align: right; width: 90px">12.10</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.10</td>\r\n			<td style="text-align: right; width: 90px">1.10</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.73</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6897</td>\r\n			<td>16/02/2017 11:24AM</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.66</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6898</td>\r\n			<td>16/02/2017 12:31PM</td>\r\n			<td style="text-align: right; width: 90px">7.70</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.70</td>\r\n			<td style="text-align: right; width: 90px">0.70</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.46</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6899</td>\r\n			<td>16/02/2017 11:50AM</td>\r\n			<td style="text-align: right; width: 90px">5.50</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.50</td>\r\n			<td style="text-align: right; width: 90px">0.50</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.33</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6900</td>\r\n			<td>16/02/2017 11:54AM</td>\r\n			<td style="text-align: right; width: 90px">14.30</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">14.30</td>\r\n			<td style="text-align: right; width: 90px">1.30</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.86</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">13.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6901</td>\r\n			<td>16/02/2017 01:57PM</td>\r\n			<td style="text-align: right; width: 90px">95.70</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">95.70</td>\r\n			<td style="text-align: right; width: 90px">8.70</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.74</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">87.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6902</td>\r\n			<td>16/02/2017 01:15PM</td>\r\n			<td style="text-align: right; width: 90px">39.60</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">39.60</td>\r\n			<td style="text-align: right; width: 90px">3.60</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.38</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">36.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6903</td>\r\n			<td>16/02/2017 02:02PM</td>\r\n			<td style="text-align: right; width: 90px">24.20</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.20</td>\r\n			<td style="text-align: right; width: 90px">2.20</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.45</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6904</td>\r\n			<td>16/02/2017 01:48PM</td>\r\n			<td style="text-align: right; width: 90px">19.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">19.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.14</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">19.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6905</td>\r\n			<td>16/02/2017 02:46PM</td>\r\n			<td style="text-align: right; width: 90px">19.80</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">19.80</td>\r\n			<td style="text-align: right; width: 90px">1.80</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.19</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6906</td>\r\n			<td>16/02/2017 02:16PM</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.42</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6907</td>\r\n			<td>16/02/2017 03:19PM</td>\r\n			<td style="text-align: right; width: 90px">56.10</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">56.10</td>\r\n			<td style="text-align: right; width: 90px">5.10</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.37</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">51.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6908</td>\r\n			<td>16/02/2017 05:24PM</td>\r\n			<td style="text-align: right; width: 90px">26.40</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">26.40</td>\r\n			<td style="text-align: right; width: 90px">2.40</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.58</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6909</td>\r\n			<td>16/02/2017 05:09PM</td>\r\n			<td style="text-align: right; width: 90px">7.70</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.70</td>\r\n			<td style="text-align: right; width: 90px">0.70</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.46</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6910</td>\r\n			<td>16/02/2017 04:22PM</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">1.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.66</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6911</td>\r\n			<td>16/02/2017 05:48PM</td>\r\n			<td style="text-align: right; width: 90px">14.30</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">14.30</td>\r\n			<td style="text-align: right; width: 90px">1.30</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.86</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">13.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6912</td>\r\n			<td>16/02/2017 06:15PM</td>\r\n			<td style="text-align: right; width: 90px">24.20</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.20</td>\r\n			<td style="text-align: right; width: 90px">2.20</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.45</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6913</td>\r\n			<td>16/02/2017 05:35PM</td>\r\n			<td style="text-align: right; width: 90px">29.70</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">29.70</td>\r\n			<td style="text-align: right; width: 90px">2.70</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.78</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">27.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6914</td>\r\n			<td>16/02/2017 06:37PM</td>\r\n			<td style="text-align: right; width: 90px">14.30</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">14.30</td>\r\n			<td style="text-align: right; width: 90px">1.30</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.86</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">13.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6915</td>\r\n			<td>16/02/2017 06:44PM</td>\r\n			<td style="text-align: right; width: 90px">15.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">15.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.90</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">15.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6916</td>\r\n			<td>16/02/2017 07:30PM</td>\r\n			<td style="text-align: right; width: 90px">16.50</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">16.50</td>\r\n			<td style="text-align: right; width: 90px">1.50</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.99</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">15.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6917</td>\r\n			<td>16/02/2017 07:47PM</td>\r\n			<td style="text-align: right; width: 90px">35.20</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">35.20</td>\r\n			<td style="text-align: right; width: 90px">3.20</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.11</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">32.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6918</td>\r\n			<td>17/02/2017 10:06AM</td>\r\n			<td style="text-align: right; width: 90px">50.60</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">50.60</td>\r\n			<td style="text-align: right; width: 90px">4.60</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.04</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">46.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6919</td>\r\n			<td>17/02/2017 12:20PM</td>\r\n			<td style="text-align: right; width: 90px">44.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">44.00</td>\r\n			<td style="text-align: right; width: 90px">4.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.64</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">40.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6920</td>\r\n			<td>17/02/2017 11:54AM</td>\r\n			<td style="text-align: right; width: 90px">145.20</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">145.20</td>\r\n			<td style="text-align: right; width: 90px">13.20</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.71</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">132.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6921</td>\r\n			<td>17/02/2017 11:15AM</td>\r\n			<td style="text-align: right; width: 90px">19.80</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">19.80</td>\r\n			<td style="text-align: right; width: 90px">1.80</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.19</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">18.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6922</td>\r\n			<td>17/02/2017 12:00PM</td>\r\n			<td style="text-align: right; width: 90px">56.10</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">56.10</td>\r\n			<td style="text-align: right; width: 90px">5.10</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.37</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">51.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6923</td>\r\n			<td>17/02/2017 12:06PM</td>\r\n			<td style="text-align: right; width: 90px">20.90</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">20.90</td>\r\n			<td style="text-align: right; width: 90px">1.90</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.25</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">19.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6924</td>\r\n			<td>17/02/2017 01:36PM</td>\r\n			<td style="text-align: right; width: 90px">46.55</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.17</td>\r\n			<td style="text-align: right; width: 90px">46.55</td>\r\n			<td style="text-align: right; width: 90px">4.23</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.79</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">42.32</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6925</td>\r\n			<td>17/02/2017 02:16PM</td>\r\n			<td style="text-align: right; width: 90px">88.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">88.00</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.28</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">80.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6926</td>\r\n			<td>17/02/2017 01:00PM</td>\r\n			<td style="text-align: right; width: 90px">81.40</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">81.40</td>\r\n			<td style="text-align: right; width: 90px">7.40</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">4.88</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">74.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6927</td>\r\n			<td>17/02/2017 12:59PM</td>\r\n			<td style="text-align: right; width: 90px">48.40</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">48.40</td>\r\n			<td style="text-align: right; width: 90px">4.40</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.90</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">44.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6928</td>\r\n			<td>17/02/2017 01:14PM</td>\r\n			<td style="text-align: right; width: 90px">138.60</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">138.60</td>\r\n			<td style="text-align: right; width: 90px">12.60</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.32</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">126.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6929</td>\r\n			<td>17/02/2017 01:06PM</td>\r\n			<td style="text-align: right; width: 90px">30.80</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">30.80</td>\r\n			<td style="text-align: right; width: 90px">2.80</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.85</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">28.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6930</td>\r\n			<td>17/02/2017 01:48PM</td>\r\n			<td style="text-align: right; width: 90px">66.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">66.00</td>\r\n			<td style="text-align: right; width: 90px">6.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.96</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">60.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6931</td>\r\n			<td>17/02/2017 01:14PM</td>\r\n			<td style="text-align: right; width: 90px">31.90</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">31.90</td>\r\n			<td style="text-align: right; width: 90px">2.90</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.91</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">29.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6932</td>\r\n			<td>17/02/2017 01:45PM</td>\r\n			<td style="text-align: right; width: 90px">91.30</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">91.30</td>\r\n			<td style="text-align: right; width: 90px">8.30</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.48</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">83.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6933</td>\r\n			<td>17/02/2017 02:30PM</td>\r\n			<td style="text-align: right; width: 90px">119.80</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">13.31</td>\r\n			<td style="text-align: right; width: 90px">119.80</td>\r\n			<td style="text-align: right; width: 90px">10.89</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.19</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">108.91</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6934</td>\r\n			<td>17/02/2017 01:50PM</td>\r\n			<td style="text-align: right; width: 90px">12.10</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.10</td>\r\n			<td style="text-align: right; width: 90px">1.10</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.73</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6935</td>\r\n			<td>17/02/2017 03:25PM</td>\r\n			<td style="text-align: right; width: 90px">48.40</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">48.40</td>\r\n			<td style="text-align: right; width: 90px">4.40</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.90</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">44.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6936</td>\r\n			<td>17/02/2017 01:46PM</td>\r\n			<td style="text-align: right; width: 90px">5.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.30</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6937</td>\r\n			<td>17/02/2017 01:49PM</td>\r\n			<td style="text-align: right; width: 90px">8.80</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.80</td>\r\n			<td style="text-align: right; width: 90px">0.80</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.53</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6938</td>\r\n			<td>17/02/2017 05:48PM</td>\r\n			<td style="text-align: right; width: 90px">14.30</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">14.30</td>\r\n			<td style="text-align: right; width: 90px">1.30</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.86</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">13.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6939</td>\r\n			<td>17/02/2017 04:22PM</td>\r\n			<td style="text-align: right; width: 90px">24.20</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.20</td>\r\n			<td style="text-align: right; width: 90px">2.20</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.45</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6940</td>\r\n			<td>17/02/2017 06:30PM</td>\r\n			<td style="text-align: right; width: 90px">30.80</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">30.80</td>\r\n			<td style="text-align: right; width: 90px">2.80</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.85</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">28.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6941</td>\r\n			<td>17/02/2017 07:00PM</td>\r\n			<td style="text-align: right; width: 90px">53.90</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">53.90</td>\r\n			<td style="text-align: right; width: 90px">4.90</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.23</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">49.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6942</td>\r\n			<td>17/02/2017 05:49PM</td>\r\n			<td style="text-align: right; width: 90px">15.40</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">15.40</td>\r\n			<td style="text-align: right; width: 90px">1.40</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.92</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">14.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6943</td>\r\n			<td>17/02/2017 05:55PM</td>\r\n			<td style="text-align: right; width: 90px">39.60</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">39.60</td>\r\n			<td style="text-align: right; width: 90px">3.60</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.38</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">36.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6944</td>\r\n			<td>17/02/2017 07:46PM</td>\r\n			<td style="text-align: right; width: 90px">16.50</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">16.50</td>\r\n			<td style="text-align: right; width: 90px">1.50</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.99</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">15.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6945</td>\r\n			<td>17/02/2017 06:57PM</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td style="text-align: right; width: 90px">2.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.32</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">20.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6946</td>\r\n			<td>17/02/2017 07:10PM</td>\r\n			<td style="text-align: right; width: 90px">8.80</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.80</td>\r\n			<td style="text-align: right; width: 90px">0.80</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.53</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6947</td>\r\n			<td>18/02/2017 09:44AM</td>\r\n			<td style="text-align: right; width: 90px">52.80</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">52.80</td>\r\n			<td style="text-align: right; width: 90px">4.80</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.17</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">48.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6948</td>\r\n			<td>18/02/2017 11:52AM</td>\r\n			<td style="text-align: right; width: 90px">126.50</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">126.50</td>\r\n			<td style="text-align: right; width: 90px">11.50</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.59</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">115.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6949</td>\r\n			<td>18/02/2017 10:15AM</td>\r\n			<td style="text-align: right; width: 90px">61.60</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">61.60</td>\r\n			<td style="text-align: right; width: 90px">5.60</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.70</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">56.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6950</td>\r\n			<td>18/02/2017 10:48AM</td>\r\n			<td style="text-align: right; width: 90px">70.40</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">70.40</td>\r\n			<td style="text-align: right; width: 90px">6.40</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">4.22</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">64.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6951</td>\r\n			<td>18/02/2017 11:00AM</td>\r\n			<td style="text-align: right; width: 90px">114.40</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">114.40</td>\r\n			<td style="text-align: right; width: 90px">10.40</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.86</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">104.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6952</td>\r\n			<td>18/02/2017 12:29PM</td>\r\n			<td style="text-align: right; width: 90px">72.60</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">72.60</td>\r\n			<td style="text-align: right; width: 90px">6.60</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">4.36</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">66.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6953</td>\r\n			<td>18/02/2017 10:49AM</td>\r\n			<td style="text-align: right; width: 90px">9.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">9.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.54</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">9.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6955</td>\r\n			<td>18/02/2017 11:45AM</td>\r\n			<td style="text-align: right; width: 90px">40.70</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">40.70</td>\r\n			<td style="text-align: right; width: 90px">3.70</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.44</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">37.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6956</td>\r\n			<td>18/02/2017 11:13AM</td>\r\n			<td style="text-align: right; width: 90px">26.40</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">26.40</td>\r\n			<td style="text-align: right; width: 90px">2.40</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.58</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6957</td>\r\n			<td>18/02/2017 12:10PM</td>\r\n			<td style="text-align: right; width: 90px">102.30</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">102.30</td>\r\n			<td style="text-align: right; width: 90px">9.30</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.14</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">93.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6958</td>\r\n			<td>18/02/2017 11:17AM</td>\r\n			<td style="text-align: right; width: 90px">5.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.30</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6959</td>\r\n			<td>18/02/2017 12:24PM</td>\r\n			<td style="text-align: right; width: 90px">138.60</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">138.60</td>\r\n			<td style="text-align: right; width: 90px">12.60</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.32</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">126.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6960</td>\r\n			<td>18/02/2017 11:20AM</td>\r\n			<td style="text-align: right; width: 90px">8.80</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.80</td>\r\n			<td style="text-align: right; width: 90px">0.80</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.53</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6961</td>\r\n			<td>18/02/2017 12:19PM</td>\r\n			<td style="text-align: right; width: 90px">82.50</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">82.50</td>\r\n			<td style="text-align: right; width: 90px">7.50</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">4.95</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">75.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6962</td>\r\n			<td>18/02/2017 12:32PM</td>\r\n			<td style="text-align: right; width: 90px">51.70</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">51.70</td>\r\n			<td style="text-align: right; width: 90px">4.70</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.10</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">47.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6963</td>\r\n			<td>18/02/2017 01:00PM</td>\r\n			<td style="text-align: right; width: 90px">26.40</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">26.40</td>\r\n			<td style="text-align: right; width: 90px">2.40</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.58</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">24.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6964</td>\r\n			<td>18/02/2017 02:13PM</td>\r\n			<td style="text-align: right; width: 90px">53.90</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">53.90</td>\r\n			<td style="text-align: right; width: 90px">4.90</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.23</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">49.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6965</td>\r\n			<td>18/02/2017 01:04PM</td>\r\n			<td style="text-align: right; width: 90px">8.80</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.80</td>\r\n			<td style="text-align: right; width: 90px">0.80</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.53</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">8.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6968</td>\r\n			<td>18/02/2017 01:03PM</td>\r\n			<td style="text-align: right; width: 90px">10.80</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.20</td>\r\n			<td style="text-align: right; width: 90px">10.80</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.65</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.80</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6969</td>\r\n			<td>18/02/2017 01:29PM</td>\r\n			<td style="text-align: right; width: 90px">42.90</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">42.90</td>\r\n			<td style="text-align: right; width: 90px">3.90</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.57</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">39.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6970</td>\r\n			<td>18/02/2017 02:13PM</td>\r\n			<td style="text-align: right; width: 90px">62.70</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">62.70</td>\r\n			<td style="text-align: right; width: 90px">5.70</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.76</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">57.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6971</td>\r\n			<td>18/02/2017 01:16PM</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.42</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">7.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6972</td>\r\n			<td>18/02/2017 01:37PM</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">11.00</td>\r\n			<td style="text-align: right; width: 90px">1.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.66</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6973</td>\r\n			<td>18/02/2017 02:42PM</td>\r\n			<td style="text-align: right; width: 90px">90.20</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">90.20</td>\r\n			<td style="text-align: right; width: 90px">8.20</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">5.41</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">82.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6974</td>\r\n			<td>18/02/2017 04:33PM</td>\r\n			<td style="text-align: right; width: 90px">28.70</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">3.19</td>\r\n			<td style="text-align: right; width: 90px">28.70</td>\r\n			<td style="text-align: right; width: 90px">2.61</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.72</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">26.09</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6975</td>\r\n			<td>18/02/2017 02:19PM</td>\r\n			<td style="text-align: right; width: 90px">37.40</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">37.40</td>\r\n			<td style="text-align: right; width: 90px">3.40</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">2.24</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">34.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6976</td>\r\n			<td>18/02/2017 02:19PM</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.60</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">10.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6977</td>\r\n			<td>18/02/2017 03:58PM</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">22.00</td>\r\n			<td style="text-align: right; width: 90px">2.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.32</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">20.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6978</td>\r\n			<td>18/02/2017 05:34PM</td>\r\n			<td style="text-align: right; width: 90px">33.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">33.00</td>\r\n			<td style="text-align: right; width: 90px">3.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.98</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">30.00</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6979</td>\r\n			<td>18/02/2017 04:14PM</td>\r\n			<td style="text-align: right; width: 90px">12.60</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">1.40</td>\r\n			<td style="text-align: right; width: 90px">12.60</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<!--\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.76</td>\r\n			-->\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">12.60</td>\r\n			<td></td>\r\n		</tr>\r\n						<tr>\r\n			<td>RC-6981</td>\r\n			<td>18/02/2017 04:17PM</td>\r\n			<td style="text-align: right; width: 90px">6.60</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">0.00</td>\r\n			<td style="text-align: right; width: 90px">6.60</td>\r\n			<td style="text', '2017-03-13 11:45:03', 'lois');

-- --------------------------------------------------------

--
-- Table structure for table `report_to`
--

CREATE TABLE `report_to` (
  `id` int(11) NOT NULL,
  `supervisor_id` int(11) DEFAULT NULL,
  `supervisor` varchar(128) DEFAULT NULL,
  `subordinate_id` int(11) DEFAULT NULL,
  `subordinate` varchar(128) DEFAULT NULL,
  `reporting_method` varchar(32) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `report_to`
--

INSERT INTO `report_to` (`id`, `supervisor_id`, `supervisor`, `subordinate_id`, `subordinate`, `reporting_method`) VALUES
(1, 28, 'Jane Doe', 27, 'John', 'Direct');

-- --------------------------------------------------------

--
-- Table structure for table `reverts`
--

CREATE TABLE `reverts` (
  `id` int(11) NOT NULL,
  `performed_by` varchar(128) DEFAULT NULL,
  `data` text,
  `datetime` datetime DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `sync` int(1) DEFAULT NULL,
  `sync_time` varchar(128) DEFAULT NULL,
  `client_sync_time` varchar(128) DEFAULT NULL,
  `revert` int(11) DEFAULT NULL,
  `remarks` text
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `salary_deduction_table`
--

CREATE TABLE `salary_deduction_table` (
  `id` int(11) UNSIGNED NOT NULL,
  `gross_from` decimal(20,2) DEFAULT NULL,
  `gross_to` decimal(20,2) DEFAULT NULL,
  `deduction_amount` decimal(20,2) DEFAULT NULL,
  `conditions` text,
  `type` varchar(32) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `salary_deduction_table`
--

INSERT INTO `salary_deduction_table` (`id`, `gross_from`, `gross_to`, `deduction_amount`, `conditions`, `type`) VALUES
(1, '800.00', '899.99', '4.25', NULL, 'SOCSO'),
(2, '900.00', '999.99', '4.75', NULL, 'SOCSO'),
(3, '1000.00', '1099.99', '5.25', NULL, 'SOCSO'),
(4, '1100.00', '1199.99', '5.75', NULL, 'SOCSO'),
(5, '1200.00', '1299.99', '6.25', NULL, 'SOCSO'),
(6, '1300.00', '1399.99', '6.75', NULL, 'SOCSO'),
(7, '1400.00', '1499.99', '7.25', NULL, 'SOCSO'),
(8, '1500.00', '1599.99', '7.75', NULL, 'SOCSO'),
(9, '1600.00', '1699.99', '8.25', NULL, 'SOCSO'),
(10, '1700.00', '1799.99', '8.75', NULL, 'SOCSO'),
(11, '1800.00', '1899.99', '9.25', NULL, 'SOCSO'),
(12, '1900.00', '1999.99', '9.75', NULL, 'SOCSO'),
(13, '2000.00', '2099.99', '10.25', NULL, 'SOCSO'),
(14, '2100.00', '2199.99', '10.75', NULL, 'SOCSO'),
(15, '2200.00', '2299.99', '11.25', NULL, 'SOCSO'),
(16, '2300.00', '2399.99', '11.75', NULL, 'SOCSO'),
(17, '2400.00', '2499.99', '12.25', NULL, 'SOCSO'),
(18, '2500.00', '2599.99', '12.75', NULL, 'SOCSO'),
(19, '2600.00', '2699.99', '13.25', NULL, 'SOCSO'),
(20, '2700.00', '2799.99', '13.75', NULL, 'SOCSO'),
(21, '2800.00', '2899.99', '14.25', NULL, 'SOCSO'),
(22, '2900.00', '999999.99', '14.75', '', 'SOCSO'),
(23, '0.00', '3499.99', '0.00', '', 'Income Tax'),
(26, '3500.00', '3599.99', '14.10', '', 'Income Tax'),
(27, '3600.00', '3699.99', '18.55', '', 'Income Tax'),
(28, '3700.00', '3799.99', '23.00', '', 'Income Tax'),
(29, '3800.00', '3899.99', '27.45', '', 'Income Tax'),
(30, '3900.00', '3999.99', '31.90', '', 'Income Tax'),
(31, '4000.00', '4099.99', '36.35', '', 'Income Tax'),
(32, '4100.00', '4199.99', '40.80', '', 'Income Tax'),
(33, '4200.00', '4299.99', '82.15', '', 'Income Tax'),
(34, '4300.00', '4399.99', '91.05', '', 'Income Tax'),
(35, '4400.00', '4499.99', '99.95', '', 'Income Tax'),
(36, '4500.00', '4599.99', '108.85', '', 'Income Tax'),
(37, '4600.00', '4699.99', '118.35', '', 'Income Tax'),
(38, '4700.00', '4799.99', '128.35', '', 'Income Tax'),
(39, '4800.00', '4899.99', '138.35', '', 'Income Tax'),
(40, '4900.00', '4999.99', '148.35', '', 'Income Tax'),
(41, '5000.00', '5099.99', '158.35', '', 'Income Tax'),
(42, '5100.00', '5199.99', '168.35', '', 'Income Tax'),
(43, '5200.00', '5299.99', '178.35', '', 'Income Tax'),
(44, '5300.00', '5399.99', '188.35', '', 'Income Tax'),
(45, '5400.00', '5499.99', '198.35', '', 'Income Tax'),
(46, '5500.00', '5599.99', '213.35', '', 'Income Tax'),
(47, '5600.00', '5699.99', '229.35', '', 'Income Tax'),
(48, '5700.00', '5799.99', '245.35', '', 'Income Tax'),
(49, '5800.00', '5899.99', '261.35', '', 'Income Tax'),
(50, '5900.00', '5999.99', '277.35', '', 'Income Tax'),
(51, '6000.00', '6099.99', '293.35', '', 'Income Tax'),
(52, '6100.00', '6199.99', '309.35', '', 'Income Tax'),
(53, '6200.00', '6299.99', '325.35', '', 'Income Tax'),
(54, '6300.00', '6399.99', '341.35', '', 'Income Tax'),
(55, '6400.00', '6499.99', '357.35', '', 'Income Tax'),
(56, '6500.00', '6599.99', '373.35', '', 'Income Tax'),
(57, '6600.00', '6699.99', '389.35', '', 'Income Tax'),
(58, '6700.00', '6799.99', '405.35', '', 'Income Tax'),
(59, '6800.00', '6899.99', '421.35', '', 'Income Tax'),
(60, '6900.00', '6999.99', '437.35', '', 'Income Tax'),
(61, '7000.00', '7099.99', '453.35', '', 'Income Tax'),
(62, '7100.00', '7199.99', '470.15', '', 'Income Tax'),
(63, '7200.00', '7299.99', '491.15', '', 'Income Tax'),
(64, '7300.00', '7399.99', '512.15', '', 'Income Tax'),
(65, '7400.00', '7499.99', '533.15', '', 'Income Tax'),
(66, '7500.00', '7599.99', '554.15', '', 'Income Tax'),
(67, '0.00', '30.00', '0.10', '', 'SOCSO'),
(68, '30.01', '49.99', '0.20', '', 'SOCSO'),
(69, '50.00', '69.99', '0.30', '', 'SOCSO'),
(70, '70.00', '99.99', '0.40', '', 'SOCSO'),
(71, '100.00', '139.99', '0.60', '', 'SOCSO'),
(72, '140.00', '199.99', '0.85', '', 'SOCSO'),
(74, '200.00', '299.99', '1.25', '', 'SOCSO'),
(75, '300.00', '399.99', '1.75', '', 'SOCSO'),
(76, '400.00', '499.99', '2.25', '', 'SOCSO'),
(77, '500.00', '599.99', '2.75', '', 'SOCSO'),
(78, '600.00', '699.99', '3.25', '', 'SOCSO'),
(79, '700.00', '799.99', '3.75', '', 'SOCSO'),
(80, '800.00', '899.99', '14.85', '', 'SOCSO Employer Contribution'),
(81, '900.00', '999.99', '16.65', '', 'SOCSO Employer Contribution'),
(82, '1000.00', '1099.99', '18.35', '', 'SOCSO Employer Contribution'),
(83, '1100.00', '1199.99', '20.15', '', 'SOCSO Employer Contribution'),
(84, '1200.00', '1299.99', '21.85', '', 'SOCSO Employer Contribution'),
(85, '1300.00', '1399.99', '23.65', '', 'SOCSO Employer Contribution'),
(86, '1400.00', '1499.99', '25.35', '', 'SOCSO Employer Contribution'),
(87, '1500.00', '1599.99', '27.15', '', 'SOCSO Employer Contribution'),
(88, '1600.00', '1699.99', '28.85', '', 'SOCSO Employer Contribution'),
(89, '1700.00', '1799.99', '30.65', '', 'SOCSO Employer Contribution'),
(90, '1800.00', '1899.99', '32.35', '', 'SOCSO Employer Contribution'),
(91, '1900.00', '1999.99', '34.15', '', 'SOCSO Employer Contribution'),
(92, '2000.00', '2099.99', '35.85', '', 'SOCSO Employer Contribution'),
(93, '2100.00', '2199.99', '37.65', '', 'SOCSO Employer Contribution'),
(94, '2200.00', '2299.99', '39.35', '', 'SOCSO Employer Contribution'),
(95, '2300.00', '2399.99', '41.15', '', 'SOCSO Employer Contribution'),
(96, '2400.00', '2499.99', '42.85', '', 'SOCSO Employer Contribution'),
(97, '2500.00', '2599.99', '44.65', '', 'SOCSO Employer Contribution'),
(98, '2600.00', '2699.99', '46.35', '', 'SOCSO Employer Contribution'),
(99, '2700.00', '2799.99', '48.15', '', 'SOCSO Employer Contribution'),
(100, '2800.00', '2899.99', '49.85', '', 'SOCSO Employer Contribution'),
(101, '2900.00', '999999999.00', '51.65', '', 'SOCSO Employer Contribution'),
(102, '0.00', '29.99', '0.40', '', 'SOCSO Employer Contribution'),
(103, '30.00', '49.99', '0.70', '', 'SOCSO Employer Contribution'),
(104, '50.00', '69.99', '1.10', '', 'SOCSO Employer Contribution'),
(105, '70.00', '99.99', '1.50', '', 'SOCSO Employer Contribution'),
(106, '100.00', '139.99', '2.10', '', 'SOCSO Employer Contribution'),
(107, '140.00', '199.99', '2.95', '', 'SOCSO Employer Contribution'),
(108, '200.00', '299.99', '4.35', '', 'SOCSO Employer Contribution'),
(110, '300.00', '399.99', '6.15', '', 'SOCSO Employer Contribution'),
(111, '400.00', '499.99', '7.85', '', 'SOCSO Employer Contribution'),
(112, '500.00', '599.99', '9.65', '', 'SOCSO Employer Contribution'),
(113, '600.00', '699.99', '11.35', '', 'SOCSO Employer Contribution'),
(114, '700.00', '799.99', '13.15', '', 'SOCSO Employer Contribution');

-- --------------------------------------------------------

--
-- Table structure for table `salary_voucher`
--

CREATE TABLE `salary_voucher` (
  `id` int(11) UNSIGNED NOT NULL,
  `datetime` datetime DEFAULT NULL,
  `employee_id` int(11) DEFAULT NULL,
  `employee` varchar(128) DEFAULT NULL,
  `ic_no` varchar(255) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `amount_employer` decimal(20,2) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `salary_voucher_breakdown`
--

CREATE TABLE `salary_voucher_breakdown` (
  `id` int(11) UNSIGNED NOT NULL,
  `sv_id` int(11) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `account` varchar(128) DEFAULT NULL,
  `account_id` int(11) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `payment_reference` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `salary_voucher_format`
--

CREATE TABLE `salary_voucher_format` (
  `id` int(11) UNSIGNED NOT NULL,
  `name` varchar(128) DEFAULT NULL,
  `field_name` varchar(128) DEFAULT NULL,
  `type` varchar(10) DEFAULT NULL,
  `percentage` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `salary_voucher_format`
--

INSERT INTO `salary_voucher_format` (`id`, `name`, `field_name`, `type`, `percentage`) VALUES
(14, 'EPF Employer Contribution', 'epf_employer', 'Null', '13.000'),
(12, 'SOCSO', 'socso', 'Deduct', ''),
(13, 'EPF Employee Contribution', 'epf_employee', 'Deduct', '11'),
(11, 'Basic', 'Basic', 'Basic', NULL),
(15, 'Income Tax', 'income_tax', 'Deduct', ''),
(16, 'Allowance', 'allowance', 'Add', ''),
(17, 'Claims', 'claims', 'Add', ''),
(18, 'Unpaid Leave', 'unpaidleave', 'BDeduct', '');

-- --------------------------------------------------------

--
-- Table structure for table `salary_voucher_items`
--

CREATE TABLE `salary_voucher_items` (
  `id` int(11) UNSIGNED NOT NULL,
  `sv_id` int(11) DEFAULT NULL,
  `field` varchar(128) DEFAULT NULL,
  `field_id` int(11) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `description` text,
  `amount` decimal(20,2) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `sales`
--

CREATE TABLE `sales` (
  `id` int(11) NOT NULL,
  `txn_no` varchar(32) DEFAULT NULL,
  `user_id` int(11) DEFAULT NULL,
  `username` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `cost` decimal(20,4) DEFAULT NULL,
  `cc_cost` decimal(20,2) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `amount_tendered` decimal(20,2) DEFAULT NULL,
  `amount_change` decimal(20,2) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `payment_details` text,
  `terminal` varchar(32) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `is_redemption` int(1) DEFAULT NULL,
  `discount` varchar(32) DEFAULT NULL,
  `discount_type` varchar(32) DEFAULT NULL,
  `discount_amount` decimal(20,2) DEFAULT NULL,
  `adjustment` decimal(20,2) DEFAULT NULL,
  `amount_cc` decimal(20,2) DEFAULT NULL,
  `amount_cheque` decimal(20,2) DEFAULT NULL,
  `amount_credit` decimal(20,2) DEFAULT NULL,
  `amount_cash` decimal(20,2) DEFAULT NULL,
  `amount_bank_deposit` decimal(20,2) DEFAULT NULL,
  `amount_voucher` decimal(20,2) DEFAULT NULL,
  `cc_bank_amount` decimal(20,2) DEFAULT NULL,
  `cc_fees` decimal(20,2) DEFAULT NULL,
  `cc_tax` decimal(20,2) DEFAULT NULL,
  `cc_name` varchar(32) DEFAULT NULL,
  `subtotal` decimal(20,2) DEFAULT NULL,
  `cheque_received` int(1) DEFAULT NULL,
  `card_type` varchar(128) DEFAULT NULL,
  `customer_id` int(11) DEFAULT NULL,
  `customer` varchar(128) DEFAULT NULL,
  `payment` text,
  `member_id` int(11) DEFAULT NULL,
  `customer_phone` varchar(128) DEFAULT NULL,
  `fnb` int(11) DEFAULT NULL,
  `sync` int(11) DEFAULT NULL,
  `sync_time` varchar(128) DEFAULT NULL,
  `client_sync_time` varchar(128) DEFAULT NULL,
  `pseudo_id` int(20) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `taxes` text,
  `taxable_amount` decimal(20,2) DEFAULT NULL,
  `tax_amount` decimal(20,2) DEFAULT NULL,
  `shipping` int(11) DEFAULT NULL,
  `shipping_name` varchar(128) DEFAULT NULL,
  `shipping_amount` decimal(20,2) DEFAULT NULL,
  `shipping_weight` decimal(20,4) DEFAULT NULL,
  `remarks` text,
  `added_on` datetime DEFAULT NULL,
  `clinic_consultation_status` varchar(128) DEFAULT NULL,
  `usid` varchar(128) DEFAULT NULL,
  `queue_no` bigint(20) DEFAULT NULL,
  `is_consulted` int(11) DEFAULT '0',
  `consultant_id` int(11) DEFAULT NULL,
  `service_charge` decimal(20,2) DEFAULT NULL,
  `recon_date` date DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `sales_breakdown`
--

CREATE TABLE `sales_breakdown` (
  `id` int(11) UNSIGNED NOT NULL,
  `sale_id` int(11) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `contact` varchar(128) DEFAULT '',
  `contact_id` int(11) DEFAULT NULL,
  `account` varchar(128) DEFAULT NULL,
  `account_id` int(11) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `payment_reference` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `sales_discount_item_rules`
--

CREATE TABLE `sales_discount_item_rules` (
  `id` int(11) UNSIGNED NOT NULL,
  `rule_id` int(11) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_name` varchar(256) DEFAULT NULL,
  `item_sku` varchar(128) DEFAULT NULL,
  `item_price` decimal(20,2) DEFAULT NULL,
  `discount_percentage` decimal(10,2) DEFAULT NULL,
  `discount_price` decimal(20,2) DEFAULT NULL,
  `date_from` datetime DEFAULT NULL,
  `date_to` datetime DEFAULT NULL,
  `applies_to` varchar(128) DEFAULT NULL,
  `is_performance_based` int(1) DEFAULT NULL,
  `performance_limit` decimal(20,2) DEFAULT NULL,
  `performance_duration` int(20) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `sales_discount_rules`
--

CREATE TABLE `sales_discount_rules` (
  `id` int(11) UNSIGNED NOT NULL,
  `name` varchar(128) DEFAULT NULL,
  `date_validity` int(1) DEFAULT NULL,
  `date_from` datetime DEFAULT NULL,
  `date_to` datetime DEFAULT NULL,
  `scope` varchar(128) DEFAULT NULL,
  `contact` int(11) DEFAULT NULL,
  `ranks` text,
  `applies_to` varchar(128) DEFAULT NULL,
  `is_performance_based` int(1) DEFAULT NULL,
  `performance_limit` decimal(20,2) DEFAULT NULL,
  `performance_duration` int(20) DEFAULT NULL,
  `remarks` text,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `sales_order`
--

CREATE TABLE `sales_order` (
  `id` int(11) NOT NULL,
  `txn_no` varchar(32) DEFAULT NULL,
  `quote_id` int(11) DEFAULT NULL,
  `invoice_id` int(11) DEFAULT NULL,
  `number` varchar(128) DEFAULT NULL,
  `pr_number` varchar(128) DEFAULT NULL,
  `po_number` varchar(128) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `due_date` datetime DEFAULT NULL,
  `received_date` datetime DEFAULT NULL,
  `contact_person` varchar(128) DEFAULT NULL,
  `contact` varchar(128) DEFAULT NULL,
  `contact_id` int(11) DEFAULT NULL,
  `contact_address` text,
  `delivery_address` text,
  `terms` varchar(128) DEFAULT NULL,
  `duration` int(11) DEFAULT NULL,
  `remarks` text,
  `status` varchar(128) DEFAULT NULL,
  `payment_gateway` varchar(128) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `payment_status` varchar(128) DEFAULT NULL,
  `payment_date` datetime DEFAULT NULL,
  `payment_reference` varchar(128) DEFAULT NULL,
  `payment_contra` varchar(128) DEFAULT NULL,
  `receipt_no` varchar(128) DEFAULT NULL,
  `shipping` varchar(128) DEFAULT NULL,
  `shipping_id` int(11) DEFAULT NULL,
  `handling_charges` decimal(20,2) DEFAULT NULL,
  `adjustment` decimal(20,2) DEFAULT NULL,
  `adjustment_type` varchar(32) DEFAULT NULL,
  `total` decimal(20,2) DEFAULT NULL,
  `total_delivered` decimal(20,2) DEFAULT NULL,
  `cost` decimal(20,2) DEFAULT NULL,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(32) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(32) DEFAULT NULL,
  `no_do` int(1) DEFAULT NULL,
  `amount_cash` decimal(20,2) DEFAULT NULL,
  `amount_cc` decimal(20,2) DEFAULT NULL,
  `amount_cheque` decimal(20,2) DEFAULT NULL,
  `amount_credit` decimal(20,2) DEFAULT NULL,
  `paid_cash` int(1) DEFAULT NULL,
  `paid_cc` int(1) DEFAULT NULL,
  `paid_cheque` int(1) DEFAULT NULL,
  `paid_credit` int(1) DEFAULT NULL,
  `sales_reference_id` int(11) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `assigned_to` varchar(128) DEFAULT NULL,
  `notification` text,
  `consignment` int(1) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `sales_order_items`
--

CREATE TABLE `sales_order_items` (
  `id` int(11) NOT NULL,
  `sales_order_id` int(11) DEFAULT NULL,
  `type` varchar(32) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `item_name` text,
  `item_description` text,
  `item_id` int(11) DEFAULT NULL,
  `service_id` int(11) DEFAULT NULL,
  `item_sku` varchar(128) DEFAULT NULL,
  `discount` varchar(128) DEFAULT NULL,
  `discount_type` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `price_per_unit` decimal(20,4) DEFAULT NULL,
  `price` decimal(20,2) DEFAULT NULL,
  `cost` decimal(20,2) DEFAULT NULL,
  `margin` decimal(20,2) DEFAULT NULL,
  `delivered` int(11) DEFAULT NULL,
  `delivered_price` decimal(20,2) DEFAULT NULL,
  `done` int(1) DEFAULT NULL,
  `no_do` int(1) DEFAULT NULL,
  `division_id` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `consignment` int(1) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `sales_sessions`
--

CREATE TABLE `sales_sessions` (
  `id` int(11) UNSIGNED NOT NULL,
  `identifier` varchar(128) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `logged_in_by` varchar(128) DEFAULT NULL,
  `logged_out_by` varchar(128) DEFAULT NULL,
  `from` datetime DEFAULT NULL,
  `to` datetime DEFAULT NULL,
  `status` varchar(32) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `sales_sessions`
--

INSERT INTO `sales_sessions` (`id`, `identifier`, `session`, `logged_in_by`, `logged_out_by`, `from`, `to`, `status`) VALUES
(1, '1343825713', NULL, 'admin', NULL, '2012-08-01 20:55:13', NULL, 'Active'),
(2, '1344492064', NULL, 'admin3', NULL, '2012-08-09 14:01:04', NULL, 'Active'),
(3, '1346083551', NULL, 'admin2', NULL, '2012-08-28 00:05:51', NULL, 'Active'),
(4, '1350724995', NULL, 'staff_melaka', NULL, '2012-10-20 17:23:15', NULL, 'Active'),
(5, '1350725517', NULL, 'staff_melaka', NULL, '2012-10-20 17:31:57', NULL, 'Active'),
(6, '1350725901', NULL, 'staff_kedah', NULL, '2012-10-20 17:38:21', NULL, 'Active'),
(7, '1350791168', NULL, 'manager_kedah', NULL, '2012-10-21 11:46:08', NULL, 'Active'),
(8, '1351129034', NULL, 'azad', NULL, '2012-10-25 09:37:14', NULL, 'Active'),
(9, '1351925227', NULL, 'admin', NULL, '2012-11-03 14:47:07', NULL, 'Active'),
(10, '1351931360', NULL, 'admin', NULL, '2012-11-03 16:29:20', NULL, 'Active'),
(11, '1351932846', NULL, 'admin', NULL, '2012-11-03 16:54:06', NULL, 'Active'),
(12, '1352196072', NULL, 'admin', NULL, '2012-11-06 18:01:12', NULL, 'Active'),
(13, '1352377701', NULL, 'admin', NULL, '2012-11-08 20:28:21', NULL, 'Active'),
(14, '1352462387', NULL, 'admin2', NULL, '2012-11-09 19:59:47', NULL, 'Active'),
(15, '1352528556', NULL, 'admin', NULL, '2012-11-10 14:22:36', NULL, 'Active'),
(16, '1352597392', NULL, 'admin2', NULL, '2012-11-11 09:29:52', NULL, 'Active'),
(17, '1352602800', NULL, 'admin2', NULL, '2012-11-11 11:00:00', NULL, 'Active'),
(18, '1352605488', NULL, 'staff_melaka', NULL, '2012-11-11 11:44:48', NULL, 'Active'),
(19, '1353068727', NULL, 'admin', NULL, '2012-11-16 20:25:27', NULL, 'Active'),
(20, '1353069292', NULL, 'admin2', NULL, '2012-11-16 20:34:52', NULL, 'Active'),
(21, '1353069833', NULL, 'admin2', NULL, '2012-11-16 20:43:53', NULL, 'Active'),
(22, '1353070265', NULL, 'staff_kedah', NULL, '2012-11-16 20:51:05', NULL, 'Active'),
(23, '1353071009', NULL, 'staff_kedah', NULL, '2012-11-16 21:03:29', NULL, 'Active'),
(24, '1353110348', NULL, 'staff_kedah', NULL, '2012-11-17 07:59:08', NULL, 'Active'),
(25, '1353112192', NULL, 'admin', NULL, '2012-11-17 08:29:52', NULL, 'Active'),
(26, '1353113810', NULL, 'staff_kedah', NULL, '2012-11-17 08:56:50', NULL, 'Active'),
(27, '1353115476', NULL, 'staff_kedah', NULL, '2012-11-17 09:24:36', NULL, 'Active'),
(28, '1353115694', NULL, 'staff_kedah', NULL, '2012-11-17 09:28:14', NULL, 'Active'),
(29, '1353145605', NULL, 'staff_kedah', NULL, '2012-11-17 17:46:45', NULL, 'Active'),
(30, '1353145637', NULL, 'admin3', NULL, '2012-11-17 17:47:17', NULL, 'Active'),
(31, '1353146108', NULL, 'staff_kedah', NULL, '2012-11-17 17:55:08', NULL, 'Active'),
(32, '1353146186', NULL, 'staff_kedah', NULL, '2012-11-17 17:56:26', NULL, 'Active'),
(33, '1353146783', NULL, 'staff_kedah', NULL, '2012-11-17 18:06:23', NULL, 'Active'),
(34, '1353163226', NULL, 'staff_kedah', NULL, '2012-11-17 22:40:26', NULL, 'Active'),
(35, '1353168426', NULL, 'admin', NULL, '2012-11-18 00:07:06', NULL, 'Active'),
(36, '1353168817', NULL, 'admin', NULL, '2012-11-18 00:13:37', NULL, 'Active'),
(37, '1353205931', NULL, 'admin', NULL, '2012-11-18 10:32:11', NULL, 'Active'),
(38, '1353206010', NULL, 'admin', NULL, '2012-11-18 10:33:30', NULL, 'Active'),
(39, '1353207425', NULL, 'staff_kedah', NULL, '2012-11-18 10:57:05', NULL, 'Active'),
(40, '1353208570', NULL, 'admin', NULL, '2012-11-18 11:16:10', NULL, 'Active'),
(41, '1353237968', NULL, 'admin3', NULL, '2012-11-18 19:26:08', NULL, 'Active'),
(42, '1353319734', NULL, 'admin3', NULL, '2012-11-19 18:08:54', NULL, 'Active'),
(43, '1353327605', NULL, 'staff_kedah', NULL, '2012-11-19 20:20:05', NULL, 'Active'),
(44, '1353330439', NULL, 'admin', NULL, '2012-11-19 21:07:19', NULL, 'Active'),
(45, '1353474499', NULL, 'admin', NULL, '2012-11-21 13:08:19', NULL, 'Active'),
(46, '1353491574', NULL, 'admin', NULL, '2012-11-21 17:52:54', NULL, 'Active'),
(47, '1353493448', NULL, 'admin', NULL, '2012-11-21 18:24:08', NULL, 'Active'),
(48, '1354189115', NULL, 'admin', NULL, '2012-11-29 19:38:35', NULL, 'Active'),
(49, '1354192029', NULL, 'jhs1', NULL, '2012-11-29 20:27:09', NULL, 'Active'),
(50, '1354268505', NULL, 'admin', NULL, '2012-11-30 17:41:45', NULL, 'Active'),
(51, '1354327698', NULL, 'admin', NULL, '2012-12-01 10:08:18', NULL, 'Active'),
(52, '1354445019', NULL, 'admin', NULL, '2012-12-02 18:43:39', NULL, 'Active'),
(53, '1354445049', NULL, 'admin', NULL, '2012-12-02 18:44:09', NULL, 'Active'),
(54, '1354445413', NULL, 'shafiq', NULL, '2012-12-02 18:50:13', NULL, 'Active'),
(55, '1354445452', NULL, 'shafiq', NULL, '2012-12-02 18:50:52', NULL, 'Active'),
(56, '1354447061', NULL, 'admin', NULL, '2012-12-02 19:17:41', NULL, 'Active'),
(57, '1354447311', NULL, 'shafiq', NULL, '2012-12-02 19:21:51', NULL, 'Active'),
(58, '1354449783', NULL, 'admin', NULL, '2012-12-02 20:03:03', NULL, 'Active'),
(59, '1354450263', NULL, 'admin', NULL, '2012-12-02 20:11:03', NULL, 'Active'),
(60, '1354545180', NULL, 'admin', NULL, '2012-12-03 22:33:00', NULL, 'Active'),
(61, '1354586782', NULL, 'admin', NULL, '2012-12-04 10:06:22', NULL, 'Active'),
(62, '1354636110', NULL, 'jaafar', NULL, '2012-12-04 23:48:30', NULL, 'Active'),
(63, '1354636484', NULL, 'raja123', NULL, '2012-12-04 23:54:44', NULL, 'Active'),
(64, '1354881152', NULL, 'admin', NULL, '2012-12-07 19:52:32', NULL, 'Active'),
(65, '1355446569', NULL, 'admin2', NULL, '2012-12-14 08:56:09', NULL, 'Active'),
(66, '1355446697', NULL, 'admin2', NULL, '2012-12-14 08:58:17', NULL, 'Active'),
(67, '1355447043', NULL, 'admin2', NULL, '2012-12-14 09:04:03', NULL, 'Active'),
(68, '1356013818', NULL, 'admin', NULL, '2012-12-20 22:30:18', NULL, 'Active'),
(69, '1356014026', NULL, 'admin', NULL, '2012-12-20 22:33:46', NULL, 'Active'),
(70, '1356014775', NULL, 'admin', NULL, '2012-12-20 22:46:15', NULL, 'Active'),
(71, '1356873546', NULL, 'admin', NULL, '2012-12-30 21:19:06', NULL, 'Active'),
(72, '1356873773', NULL, 'admin', NULL, '2012-12-30 21:22:53', NULL, 'Active'),
(73, '1356874887', NULL, 'admin', NULL, '2012-12-30 21:41:27', NULL, 'Active'),
(74, '1356874953', NULL, 'admin', NULL, '2012-12-30 21:42:33', NULL, 'Active'),
(75, '1356875480', NULL, 'admin', NULL, '2012-12-30 21:51:20', NULL, 'Active'),
(76, '1356875731', NULL, 'azman', NULL, '2012-12-30 21:55:31', NULL, 'Active'),
(77, '1356875758', NULL, 'admin', NULL, '2012-12-30 21:55:58', NULL, 'Active'),
(78, '1356876958', NULL, 'azman', NULL, '2012-12-30 22:15:58', NULL, 'Active'),
(79, '1356878170', NULL, 'azman', NULL, '2012-12-30 22:36:10', NULL, 'Active'),
(80, '1356917151', NULL, 'azman', NULL, '2012-12-31 09:25:51', NULL, 'Active'),
(81, '1356917222', NULL, 'admin', NULL, '2012-12-31 09:27:02', NULL, 'Active'),
(82, '1357020806', NULL, 'admin', NULL, '2013-01-01 14:13:26', NULL, 'Active'),
(83, '1357095849', NULL, 'admin', NULL, '2013-01-02 11:04:09', NULL, 'Active'),
(84, '1357639405', NULL, 'admin', NULL, '2013-01-08 18:03:26', NULL, 'Active'),
(85, '1357639647', NULL, 'admin', NULL, '2013-01-08 18:07:27', NULL, 'Active'),
(86, '1358071812', NULL, 'admin', NULL, '2013-01-13 18:10:12', NULL, 'Active'),
(87, '1360464370', NULL, 'kabir', NULL, '2013-02-10 10:46:10', NULL, 'Active'),
(88, '1360464474', NULL, 'kabir', NULL, '2013-02-10 10:47:54', NULL, 'Active'),
(89, '1360472573', NULL, 'kabir', NULL, '2013-02-10 13:02:53', NULL, 'Active'),
(90, '1361263974', NULL, 'admin2', NULL, '2013-02-19 16:52:54', NULL, 'Active'),
(91, '1361336198', NULL, 'admin2', NULL, '2013-02-20 12:56:38', NULL, 'Active'),
(92, '1361339149', NULL, 'admin2', NULL, '2013-02-20 13:45:49', NULL, 'Active'),
(93, '1361340904', NULL, 'admin3', NULL, '2013-02-20 14:15:04', NULL, 'Active'),
(94, '1361340949', NULL, 'admin2', NULL, '2013-02-20 14:15:49', NULL, 'Active'),
(95, '1361340974', NULL, 'admin3', NULL, '2013-02-20 14:16:14', NULL, 'Active'),
(96, '1361341084', NULL, 'jhs1', NULL, '2013-02-20 14:18:04', NULL, 'Active'),
(97, '1361862318', NULL, 'admin3', NULL, '2013-02-26 15:05:18', NULL, 'Active'),
(98, '1362216106', NULL, 'admin2', NULL, '2013-03-02 17:21:46', NULL, 'Active'),
(99, '1362289825', NULL, 'admin3', NULL, '2013-03-03 13:50:25', NULL, 'Active'),
(100, '1362298665', NULL, 'admin3', NULL, '2013-03-03 16:17:45', NULL, 'Active'),
(101, '1362538835', NULL, 'admin3', NULL, '2013-03-06 11:00:35', NULL, 'Active'),
(102, '1362826968', NULL, 'admin2', NULL, '2013-03-09 19:02:48', NULL, 'Active'),
(103, '1362833584', NULL, 'admin2', NULL, '2013-03-09 20:53:04', NULL, 'Active'),
(104, '1363155873', NULL, 'admin2', NULL, '2013-03-13 14:24:33', NULL, 'Active'),
(105, '1363186856', NULL, 'admin', NULL, '2013-03-13 23:00:57', NULL, 'Active'),
(106, '1363186958', NULL, 'admin2', NULL, '2013-03-13 23:02:38', NULL, 'Active'),
(107, '1363272538', NULL, 'admin', NULL, '2013-03-14 22:48:58', NULL, 'Active'),
(108, '1363414286', NULL, 'admin', NULL, '2013-03-16 14:11:26', NULL, 'Active'),
(109, '1363480186', NULL, 'admin', NULL, '2013-03-17 08:29:46', NULL, 'Active'),
(110, '1363705323', NULL, 'admin', NULL, '2013-03-19 23:02:03', NULL, 'Active'),
(111, '1363935237', NULL, 'admin', NULL, '2013-03-22 14:53:57', NULL, 'Active'),
(112, '1364219595', NULL, 'admin', NULL, '2013-03-25 21:53:15', NULL, 'Active'),
(113, '1364299406', NULL, 'admin2', NULL, '2013-03-26 20:03:26', NULL, 'Active'),
(114, '1364742229', NULL, 'admin3', NULL, '2013-03-31 23:03:49', NULL, 'Active'),
(115, '1364749193', NULL, 'admin3', NULL, '2013-04-01 00:59:53', NULL, 'Active'),
(116, '1365391025', NULL, 'admin2', NULL, '2013-04-08 11:17:05', NULL, 'Active'),
(117, '1365391072', NULL, 'admin3', NULL, '2013-04-08 11:17:52', NULL, 'Active'),
(118, '1365391170', NULL, 'admin3', NULL, '2013-04-08 11:19:30', NULL, 'Active'),
(119, '1365391658', NULL, 'admin', NULL, '2013-04-08 11:27:38', NULL, 'Active'),
(120, '1365391812', NULL, 'admin3', NULL, '2013-04-08 11:30:12', NULL, 'Active'),
(121, '1365661179', NULL, 'admin2', NULL, '2013-04-11 14:19:39', NULL, 'Active'),
(122, '1366462725', NULL, 'admin2', NULL, '2013-04-20 20:58:45', NULL, 'Active'),
(123, '1367124536', NULL, 'admin3', NULL, '2013-04-28 12:48:56', NULL, 'Active'),
(124, '1367129822', NULL, 'admin2', NULL, '2013-04-28 14:17:02', NULL, 'Active'),
(125, '1367133189', NULL, 'admin2', NULL, '2013-04-28 15:13:09', NULL, 'Active'),
(126, '1367133769', NULL, 'admin', NULL, '2013-04-28 15:22:49', NULL, 'Active'),
(127, '1367135518', NULL, 'admin3', NULL, '2013-04-28 15:51:58', NULL, 'Active'),
(128, '1367242070', NULL, 'admin', NULL, '2013-04-29 21:27:50', NULL, 'Active'),
(129, '1368281345', NULL, 'admin2', NULL, '2013-05-11 22:09:05', NULL, 'Active'),
(130, '1368759391', NULL, 'admin', NULL, '2013-05-17 10:56:31', NULL, 'Active'),
(131, '1368759717', NULL, 'admin2', NULL, '2013-05-17 11:01:57', NULL, 'Active'),
(132, '1368780694', NULL, 'shamiradnan', NULL, '2013-05-17 16:51:34', NULL, 'Active'),
(133, '1368787205', NULL, 'shamiradnan', NULL, '2013-05-17 18:40:05', NULL, 'Active'),
(134, '1368787719', NULL, 'admin3', NULL, '2013-05-17 18:48:39', NULL, 'Active'),
(135, '1368849570', NULL, 'admin', NULL, '2013-05-18 11:59:30', NULL, 'Active'),
(136, '1368849643', NULL, 'admin', NULL, '2013-05-18 12:00:43', NULL, 'Active'),
(137, '1369305659', NULL, 'admin', NULL, '2013-05-23 18:40:59', NULL, 'Active'),
(138, '1370168848', NULL, 'admin2', NULL, '2013-06-02 18:27:28', NULL, 'Active'),
(139, '1370239627', NULL, 'admin3', NULL, '2013-06-03 14:07:07', NULL, 'Active'),
(140, '1370420812', NULL, 'admin', NULL, '2013-06-05 16:26:52', NULL, 'Active'),
(141, '1370916923', NULL, 'admin2', NULL, '2013-06-11 10:15:23', NULL, 'Active'),
(142, '1371447515', NULL, 'admin', NULL, '2013-06-17 13:38:35', NULL, 'Active'),
(143, '1371447549', NULL, 'admin', NULL, '2013-06-17 13:39:09', NULL, 'Active'),
(144, '1371449819', NULL, 'admin', NULL, '2013-06-17 14:16:59', NULL, 'Active'),
(145, '1371718728', NULL, 'admin', NULL, '2013-06-20 16:58:48', NULL, 'Active'),
(146, '1371718779', NULL, 'admin', NULL, '2013-06-20 16:59:39', NULL, 'Active'),
(147, '1375436267', NULL, 'admin', NULL, '2013-08-02 17:37:47', NULL, 'Active'),
(148, '1377480156', NULL, 'admin', NULL, '2013-08-26 09:22:36', NULL, 'Active'),
(149, '1380254198', NULL, 'admin', NULL, '2013-09-27 11:56:38', NULL, 'Active'),
(150, '1382589436', NULL, 'admin2', NULL, '2013-10-24 12:37:16', NULL, 'Active'),
(151, '1383833101', NULL, 'admin', NULL, '2013-11-07 22:05:01', NULL, 'Active'),
(152, '1383833420', NULL, 'admin', NULL, '2013-11-07 22:10:20', NULL, 'Active'),
(153, '1386160828', NULL, 'azad', NULL, '2013-12-04 20:40:28', NULL, 'Active'),
(154, '1386239742', NULL, 'admin', NULL, '2013-12-05 18:35:42', NULL, 'Active'),
(155, '1386239887', NULL, 'plexcloud', NULL, '2013-12-05 18:38:07', NULL, 'Active'),
(156, '1386240348', NULL, 'admin', NULL, '2013-12-05 18:45:48', NULL, 'Active'),
(157, '1386562030', NULL, 'plexcloud', NULL, '2013-12-09 12:07:10', NULL, 'Active'),
(158, '1386562691', NULL, 'plexcloud', NULL, '2013-12-09 12:18:11', NULL, 'Active'),
(159, '1386562706', NULL, 'plexcloud', NULL, '2013-12-09 12:18:26', NULL, 'Active'),
(160, '1388992742', NULL, 'admin', NULL, '2014-01-06 15:19:02', NULL, 'Active'),
(161, '1390657068', NULL, 'admin', NULL, '2014-01-25 21:37:48', NULL, 'Active'),
(162, '1390662545', NULL, 'admin', NULL, '2014-01-25 23:09:05', NULL, 'Active'),
(163, '1390664198', NULL, 'admin', NULL, '2014-01-25 23:36:38', NULL, 'Active'),
(164, '1390664228', NULL, 'admin', NULL, '2014-01-25 23:37:08', NULL, 'Active'),
(165, '1392386983', NULL, 'admin2', NULL, '2014-02-14 22:09:43', NULL, 'Active'),
(166, '1397829485', NULL, 'azad', NULL, '2014-04-18 21:58:05', NULL, 'Active'),
(167, '1398347855', NULL, 'admin', NULL, '2014-04-24 21:57:35', NULL, 'Active'),
(168, '1400491375', NULL, 'admin2', NULL, '2014-05-19 17:22:55', NULL, 'Active'),
(169, '1402986949', NULL, 'admin2', NULL, '2014-06-17 14:35:49', NULL, 'Active'),
(170, '1407592521', NULL, 'admin2', NULL, '2014-08-09 21:55:21', NULL, 'Active'),
(171, '1407643745', NULL, 'admin', NULL, '2014-08-10 12:09:05', NULL, 'Active'),
(172, '1414198719', NULL, 'admin', NULL, '2014-10-25 08:58:39', NULL, 'Active'),
(173, '1421760401', NULL, 'admin', NULL, '2015-01-20 21:26:41', NULL, 'Active'),
(174, '1426143675', NULL, 'admin', NULL, '2015-03-12 15:01:15', NULL, 'Active'),
(175, '1426143865', NULL, 'admin', NULL, '2015-03-12 15:04:25', NULL, 'Active'),
(176, '1426590009', NULL, 'admin', NULL, '2015-03-17 19:00:09', NULL, 'Active'),
(177, '1426997236', NULL, 'admin', NULL, '2015-03-22 12:07:16', NULL, 'Active'),
(178, '1427268310', NULL, 'admin2', NULL, '2015-03-25 15:25:10', NULL, 'Active'),
(179, '1427714339', NULL, 'admin', NULL, '2015-03-30 19:18:59', NULL, 'Active'),
(180, '1427714373', NULL, 'admin', NULL, '2015-03-30 19:19:33', NULL, 'Active'),
(181, '1427714626', NULL, 'admin', NULL, '2015-03-30 19:23:46', NULL, 'Active'),
(182, '1427764306', NULL, 'admin', NULL, '2015-03-31 09:11:46', NULL, 'Active'),
(183, '1427777522', NULL, 'admin', NULL, '2015-03-31 12:52:02', NULL, 'Active'),
(184, '1427861545', NULL, 'admin', NULL, '2015-04-01 12:12:25', NULL, 'Active'),
(185, '1428499131', NULL, 'admin', NULL, '2015-04-08 21:18:51', NULL, 'Active'),
(186, '1428562931', NULL, 'admin', NULL, '2015-04-09 15:02:11', NULL, 'Active'),
(187, '1428572112', NULL, 'admin', NULL, '2015-04-09 17:35:12', NULL, 'Active'),
(188, '1428657996', NULL, 'admin', NULL, '2015-04-10 17:26:36', NULL, 'Active'),
(189, '1428658141', NULL, 'admin', NULL, '2015-04-10 17:29:01', NULL, 'Active'),
(190, '1428659531', NULL, 'admin', NULL, '2015-04-10 17:52:11', NULL, 'Active'),
(191, '1428671469', NULL, 'admin', NULL, '2015-04-10 21:11:09', NULL, 'Active'),
(192, '1428676045', NULL, 'admin', NULL, '2015-04-10 22:27:25', NULL, 'Active'),
(193, '1428703494', NULL, 'admin', NULL, '2015-04-11 06:04:54', NULL, 'Active'),
(194, '1428703631', NULL, 'admin', NULL, '2015-04-11 06:07:11', NULL, 'Active'),
(195, '1428703889', NULL, 'admin', NULL, '2015-04-11 06:11:29', NULL, 'Active'),
(196, '1428704018', NULL, 'admin', NULL, '2015-04-11 06:13:38', NULL, 'Active'),
(197, '1429336407', NULL, 'admin', NULL, '2015-04-18 13:53:27', NULL, 'Active'),
(198, '1429336654', NULL, 'admin', NULL, '2015-04-18 13:57:34', NULL, 'Active'),
(199, '1429336836', NULL, 'admin', NULL, '2015-04-18 14:00:36', NULL, 'Active'),
(200, '1430391829', NULL, 'admin', NULL, '2015-04-30 19:03:49', NULL, 'Active'),
(201, '1430400811', NULL, 'admin', NULL, '2015-04-30 21:33:31', NULL, 'Active'),
(202, '1430720681', NULL, 'admin', NULL, '2015-05-04 14:24:41', NULL, 'Active'),
(203, '1433052833', NULL, 'admin', NULL, '2015-05-31 14:13:53', NULL, 'Active'),
(204, '1433740489', NULL, 'admin', NULL, '2015-06-08 13:14:49', NULL, 'Active'),
(205, '1436343639', NULL, 'admin2', NULL, '2015-07-08 16:20:39', NULL, 'Active'),
(206, '1437813126', NULL, 'admin', NULL, '2015-07-25 16:32:06', NULL, 'Active'),
(207, '1437813208', NULL, 'admin', NULL, '2015-07-25 16:33:28', NULL, 'Active'),
(208, '1437813218', NULL, 'admin', NULL, '2015-07-25 16:33:38', NULL, 'Active'),
(209, '1437813282', NULL, 'admin', NULL, '2015-07-25 16:34:42', NULL, 'Active'),
(210, '1437815363', NULL, 'admin', NULL, '2015-07-25 17:09:23', NULL, 'Active'),
(211, '1438084781', NULL, 'admin2', NULL, '2015-07-28 19:59:41', NULL, 'Active'),
(212, '1438740131', NULL, 'admin', NULL, '2015-08-05 10:02:11', NULL, 'Active'),
(213, '1438746480', NULL, 'admin', NULL, '2015-08-05 11:48:00', NULL, 'Active'),
(214, '1438749429', NULL, 'waiter1', NULL, '2015-08-05 12:37:09', NULL, 'Active'),
(215, '1439279601', NULL, 'admin', NULL, '2015-08-11 15:53:21', NULL, 'Active'),
(216, '1439282878', NULL, 'admin', NULL, '2015-08-11 16:47:58', NULL, 'Active'),
(217, '1439283023', NULL, 'admin', NULL, '2015-08-11 16:50:23', NULL, 'Active'),
(218, '1439283102', NULL, 'admin', NULL, '2015-08-11 16:51:42', NULL, 'Active'),
(219, '1439283174', NULL, 'admin', NULL, '2015-08-11 16:52:54', NULL, 'Active'),
(220, '1439283249', NULL, 'admin', NULL, '2015-08-11 16:54:09', NULL, 'Active'),
(221, '1439283363', NULL, 'admin', NULL, '2015-08-11 16:56:03', NULL, 'Active'),
(222, '1439283802', NULL, 'admin', NULL, '2015-08-11 17:03:22', NULL, 'Active'),
(223, '1439335085', NULL, 'admin', NULL, '2015-08-12 07:18:05', NULL, 'Active'),
(224, '1439452219', NULL, 'admin', NULL, '2015-08-13 15:50:19', NULL, 'Active'),
(225, '1439452869', NULL, 'admin', NULL, '2015-08-13 16:01:09', NULL, 'Active'),
(226, '1439452941', NULL, 'admin', NULL, '2015-08-13 16:02:21', NULL, 'Active'),
(227, '1439453009', NULL, 'admin', NULL, '2015-08-13 16:03:29', NULL, 'Active'),
(228, '1439454416', NULL, 'admin', NULL, '2015-08-13 16:26:56', NULL, 'Active'),
(229, '1439549489', NULL, 'admin2', NULL, '2015-08-14 18:51:29', NULL, 'Active'),
(230, '1439549627', NULL, 'admin2', NULL, '2015-08-14 18:53:47', NULL, 'Active'),
(231, '1439609954', NULL, 'admin', NULL, '2015-08-15 11:39:14', NULL, 'Active'),
(232, '1441695077', NULL, 'admin', NULL, '2015-09-08 14:51:17', NULL, 'Active'),
(233, '1441786342', NULL, 'admin', NULL, '2015-09-09 16:12:22', NULL, 'Active'),
(234, '1443664527', NULL, 'admin', NULL, '2015-10-01 09:55:27', NULL, 'Active'),
(235, '1443760060', NULL, 'admin', NULL, '2015-10-02 12:27:40', NULL, 'Active'),
(236, '1443843157', NULL, 'admin', NULL, '2015-10-03 11:32:37', NULL, 'Active'),
(237, '1443843640', NULL, 'admin', NULL, '2015-10-03 11:40:40', NULL, 'Active'),
(238, '1443845421', NULL, 'admin', NULL, '2015-10-03 12:10:21', NULL, 'Active'),
(239, '1443846336', NULL, 'admin', NULL, '2015-10-03 12:25:36', NULL, 'Active'),
(240, '1443849775', NULL, 'admin', NULL, '2015-10-03 13:22:55', NULL, 'Active'),
(241, '1443849775', NULL, 'admin', NULL, '2015-10-29 16:11:38', NULL, 'Active'),
(242, '1443849775', NULL, 'admin', NULL, '2015-10-29 16:11:42', NULL, 'Active'),
(243, '1446106312', NULL, 'admin2', NULL, '2015-10-29 16:11:52', NULL, 'Active'),
(244, '1443849775', NULL, 'admin', NULL, '2015-10-29 16:11:58', NULL, 'Active'),
(245, '1443849775', NULL, 'admin', NULL, '2015-10-29 16:27:33', NULL, 'Active'),
(246, '1446107282', NULL, 'admin', NULL, '2015-10-29 16:28:02', NULL, 'Active'),
(247, '1446107626', NULL, 'admin', NULL, '2015-10-29 16:33:46', NULL, 'Active'),
(248, '1446107632', NULL, 'admin', NULL, '2015-10-29 16:33:52', NULL, 'Active'),
(249, '1446107638', NULL, 'admin', NULL, '2015-10-29 16:33:58', NULL, 'Active'),
(250, '1446107685', NULL, 'admin', NULL, '2015-10-29 16:34:45', NULL, 'Active'),
(251, '1446107721', NULL, 'admin', NULL, '2015-10-29 16:35:21', NULL, 'Active'),
(252, '1446107740', NULL, 'admin', NULL, '2015-10-29 16:35:40', NULL, 'Active'),
(253, '1446110769', NULL, 'admin', NULL, '2015-10-29 17:26:09', NULL, 'Active'),
(254, '1446110893', NULL, 'shafiq', NULL, '2015-10-29 17:28:13', NULL, 'Active'),
(255, '1446110898', NULL, 'shafiq', NULL, '2015-10-29 17:28:18', NULL, 'Active'),
(256, '1446110906', NULL, 'shafiq', NULL, '2015-10-29 17:28:26', NULL, 'Active'),
(257, '1446111034', NULL, 'shafiq', NULL, '2015-10-29 17:30:34', NULL, 'Active'),
(258, '1446111055', NULL, 'admin', NULL, '2015-10-29 17:30:55', NULL, 'Active'),
(259, '1446111060', NULL, 'admin', NULL, '2015-10-29 17:31:00', NULL, 'Active'),
(260, '1446117008', NULL, 'admin', NULL, '2015-10-29 19:10:08', NULL, 'Active'),
(261, '1446117062', NULL, 'shafiq', NULL, '2015-10-29 19:11:02', NULL, 'Active'),
(262, '1446117102', NULL, 'admin', NULL, '2015-10-29 19:11:42', NULL, 'Active'),
(263, '1446117117', NULL, 'admin2', NULL, '2015-10-29 19:11:57', NULL, 'Active'),
(264, '1446448505', NULL, 'admin', NULL, '2015-11-02 15:15:05', NULL, 'Active'),
(265, '1446448513', NULL, 'admin', NULL, '2015-11-02 15:15:13', NULL, 'Active'),
(266, '1446535038', NULL, 'admin', NULL, '2015-11-03 15:17:18', NULL, 'Active'),
(267, '1446535168', NULL, 'admin', NULL, '2015-11-03 15:19:28', NULL, 'Active'),
(268, '1446536508', NULL, 'admin', NULL, '2015-11-03 15:41:48', NULL, 'Active'),
(269, '1446536541', NULL, 'admin', NULL, '2015-11-03 15:42:21', NULL, 'Active'),
(270, '1446536793', NULL, 'admin', NULL, '2015-11-03 15:46:33', NULL, 'Active'),
(271, '1446536927', NULL, 'admin', NULL, '2015-11-03 15:48:47', NULL, 'Active'),
(272, '1446536937', NULL, 'admin', NULL, '2015-11-03 15:48:57', NULL, 'Active'),
(273, '1446536944', NULL, 'admin', NULL, '2015-11-03 15:49:04', NULL, 'Active'),
(274, '1446619681', NULL, 'admin', NULL, '2015-11-04 14:48:01', NULL, 'Active'),
(275, '1446619721', NULL, 'admin', NULL, '2015-11-04 14:48:41', NULL, 'Active'),
(276, '1446619748', NULL, 'admin', NULL, '2015-11-04 14:49:08', NULL, 'Active'),
(277, '1446619848', NULL, 'admin', NULL, '2015-11-04 14:50:48', NULL, 'Active'),
(278, '1446620430', NULL, 'admin', NULL, '2015-11-04 15:00:30', NULL, 'Active'),
(279, '1446620439', NULL, 'admin', NULL, '2015-11-04 15:00:39', NULL, 'Active'),
(280, '1446620763', NULL, 'admin', NULL, '2015-11-04 15:06:03', NULL, 'Active'),
(281, '1446697760', NULL, 'admin', NULL, '2015-11-05 12:29:20', NULL, 'Active'),
(282, '1446697782', NULL, 'admin', NULL, '2015-11-05 12:29:42', NULL, 'Active'),
(283, '1446697936', NULL, 'admin', NULL, '2015-11-05 12:32:16', NULL, 'Active'),
(284, '1446698077', NULL, 'admin', NULL, '2015-11-05 12:34:37', NULL, 'Active'),
(285, '1446952870', NULL, 'admin', NULL, '2015-11-08 11:21:10', NULL, 'Active'),
(286, '1446956766', NULL, 'admin', NULL, '2015-11-08 12:26:06', NULL, 'Active'),
(287, '1446957151', NULL, 'admin', NULL, '2015-11-08 12:32:31', NULL, 'Active'),
(288, '1446957227', NULL, 'admin', NULL, '2015-11-08 12:33:47', NULL, 'Active'),
(289, '1446959518', NULL, 'admin', NULL, '2015-11-08 13:11:58', NULL, 'Active'),
(290, '1446959535', NULL, 'admin', NULL, '2015-11-08 13:12:15', NULL, 'Active'),
(291, '1446959958', NULL, 'admin', NULL, '2015-11-08 13:19:18', NULL, 'Active'),
(292, '1446960110', NULL, 'admin', NULL, '2015-11-08 13:21:50', NULL, 'Active'),
(293, '1446961135', NULL, 'admin', NULL, '2015-11-08 13:38:55', NULL, 'Active'),
(294, '1446961888', NULL, 'admin', NULL, '2015-11-08 13:51:28', NULL, 'Active'),
(295, '1446962665', NULL, 'admin', NULL, '2015-11-08 14:04:25', NULL, 'Active'),
(296, '1446962685', NULL, 'admin', NULL, '2015-11-08 14:04:45', NULL, 'Active'),
(297, '1447386883', NULL, 'admin', NULL, '2015-11-13 11:54:43', NULL, 'Active'),
(298, '1447646388', NULL, 'admin', NULL, '2015-11-16 11:59:48', NULL, 'Active'),
(299, '1447646426', NULL, 'admin', NULL, '2015-11-16 12:00:26', NULL, 'Active'),
(300, '1447646620', NULL, 'admin', NULL, '2015-11-16 12:03:40', NULL, 'Active'),
(301, '1447646624', NULL, 'admin', NULL, '2015-11-16 12:03:44', NULL, 'Active'),
(302, '1447646709', NULL, 'admin', NULL, '2015-11-16 12:05:09', NULL, 'Active'),
(303, '1447646721', NULL, 'admin', NULL, '2015-11-16 12:05:21', NULL, 'Active'),
(304, '1447646884', NULL, 'admin', NULL, '2015-11-16 12:08:04', NULL, 'Active'),
(305, '1447647070', NULL, 'admin', NULL, '2015-11-16 12:11:10', NULL, 'Active'),
(306, '1447651501', NULL, 'admin', NULL, '2015-11-16 13:25:01', NULL, 'Active'),
(307, '1447661211', NULL, 'admin', NULL, '2015-11-16 16:06:51', NULL, 'Active'),
(308, '1447731638', NULL, 'admin', NULL, '2015-11-17 11:40:38', NULL, 'Active'),
(309, '1447732133', NULL, 'admin', NULL, '2015-11-17 11:48:53', NULL, 'Active'),
(310, '1447732701', NULL, 'admin', NULL, '2015-11-17 11:58:21', NULL, 'Active'),
(311, '1447733301', NULL, 'admin', NULL, '2015-11-17 12:08:21', NULL, 'Active'),
(312, '1447927266', NULL, 'admin', NULL, '2015-11-19 18:01:06', NULL, 'Active'),
(313, '1447927318', NULL, 'admin', NULL, '2015-11-19 18:01:58', NULL, 'Active'),
(314, '1447927397', NULL, 'admin', NULL, '2015-11-19 18:03:17', NULL, 'Active'),
(315, '1448444443', NULL, 'admin', NULL, '2015-11-25 17:40:43', NULL, 'Active'),
(316, '1449141780', NULL, 'admin', NULL, '2015-12-03 19:23:00', NULL, 'Active'),
(317, '1449202586', NULL, 'admin', NULL, '2015-12-04 12:16:26', NULL, 'Active'),
(318, '1451984044', NULL, 'admin', NULL, '2016-01-05 16:54:04', NULL, 'Active'),
(319, '1452482758', NULL, 'admin', NULL, '2016-01-11 11:25:58', NULL, 'Active'),
(320, '1452482857', NULL, 'admin', NULL, '2016-01-11 11:27:37', NULL, 'Active'),
(321, '1455700146', NULL, 'admin', NULL, '2016-02-17 17:09:06', NULL, 'Active'),
(322, '1455867425', NULL, 'admin', NULL, '2016-02-19 15:37:05', NULL, 'Active'),
(323, '1455937994', NULL, 'admin2', NULL, '2016-02-20 11:13:14', NULL, 'Active'),
(324, '1456126790', NULL, 'admin2', NULL, '2016-02-22 15:39:50', NULL, 'Active'),
(325, '1456472886', NULL, 'admin2', NULL, '2016-02-26 15:48:06', NULL, 'Active'),
(326, '1456959617', NULL, 'admin2', NULL, '2016-03-03 07:00:17', NULL, 'Active'),
(327, '1456988745', NULL, 'admin', NULL, '2016-03-03 15:05:45', NULL, 'Active'),
(328, '1456988959', NULL, 'admin', NULL, '2016-03-03 15:09:19', NULL, 'Active'),
(329, '1459315540', NULL, 'admin', NULL, '2016-03-30 13:25:40', NULL, 'Active'),
(330, '1459315728', NULL, 'admin', NULL, '2016-03-30 13:28:48', NULL, 'Active'),
(331, '1459315762', NULL, 'admin', NULL, '2016-03-30 13:29:22', NULL, 'Active'),
(332, '1459315793', NULL, 'admin', NULL, '2016-03-30 13:29:53', NULL, 'Active'),
(333, '1459315826', NULL, 'admin', NULL, '2016-03-30 13:30:26', NULL, 'Active'),
(334, '1459315939', NULL, 'admin', NULL, '2016-03-30 13:32:19', NULL, 'Active'),
(335, '1459315980', NULL, 'admin', NULL, '2016-03-30 13:33:00', NULL, 'Active'),
(336, '1459417537', NULL, 'admin', NULL, '2016-03-31 17:45:37', NULL, 'Active'),
(337, '1459857624', NULL, 'admin', NULL, '2016-04-05 20:00:24', NULL, 'Active'),
(338, '1459857646', NULL, 'admin', NULL, '2016-04-05 20:00:46', NULL, 'Active'),
(339, '1460698321', NULL, 'admin', NULL, '2016-04-15 13:32:01', NULL, 'Active'),
(340, '1460698346', NULL, 'admin', NULL, '2016-04-15 13:32:26', NULL, 'Active'),
(341, '1460705303', NULL, 'admin', NULL, '2016-04-15 15:28:23', NULL, 'Active'),
(342, '1460705313', NULL, 'admin', NULL, '2016-04-15 15:28:33', NULL, 'Active'),
(343, '1460706571', NULL, 'admin', NULL, '2016-04-15 15:49:31', NULL, 'Active'),
(344, '1460896356', NULL, 'admin', NULL, '2016-04-17 20:32:36', NULL, 'Active'),
(345, '1461043544', NULL, 'admin', NULL, '2016-04-19 13:25:44', NULL, 'Active'),
(346, '1461072445', NULL, 'admin', NULL, '2016-04-19 21:27:25', NULL, 'Active'),
(347, '1461210870', NULL, 'admin', NULL, '2016-04-21 11:54:30', NULL, 'Active'),
(348, '1461227973', NULL, 'admin2', NULL, '2016-04-21 16:39:33', NULL, 'Active'),
(349, '1461228279', NULL, 'admin2', NULL, '2016-04-21 16:44:39', NULL, 'Active'),
(350, '1461232107', NULL, 'admin', NULL, '2016-04-21 17:48:27', NULL, 'Active'),
(351, '1461232203', NULL, 'admin', NULL, '2016-04-21 17:50:03', NULL, 'Active'),
(352, '1461233049', NULL, 'admin', NULL, '2016-04-21 18:04:09', NULL, 'Active'),
(353, '1461244217', NULL, 'admin', NULL, '2016-04-21 21:10:17', NULL, 'Active'),
(354, '1461493712', NULL, 'admin', NULL, '2016-04-24 18:28:32', NULL, 'Active'),
(355, '1462166100', NULL, 'admin', NULL, '2016-05-02 13:15:00', NULL, 'Active'),
(356, '1462172090', NULL, 'admin2', NULL, '2016-05-02 14:54:50', NULL, 'Active'),
(357, '1462175085', NULL, 'admin', NULL, '2016-05-02 15:44:45', NULL, 'Active'),
(358, '1462175102', NULL, 'admin2', NULL, '2016-05-02 15:45:02', NULL, 'Active'),
(359, '1462176103', NULL, 'admin2', NULL, '2016-05-02 16:01:43', NULL, 'Active'),
(360, '1465357674', NULL, 'admin', NULL, '2016-06-08 11:47:54', NULL, 'Active'),
(361, '1465357688', NULL, 'shafiq', NULL, '2016-06-08 11:48:08', NULL, 'Active'),
(362, '1465372055', NULL, 'admin', NULL, '2016-06-08 15:47:35', NULL, 'Active'),
(363, '1465302239', NULL, 'admin', NULL, '2016-06-07 20:23:59', NULL, 'Active'),
(364, '1465302255', NULL, 'admin', NULL, '2016-06-07 20:24:15', NULL, 'Active'),
(365, '1465305034', NULL, 'admin', NULL, '2016-06-07 21:10:34', NULL, 'Active'),
(366, '1465306054', NULL, 'lois', NULL, '2016-06-07 21:27:34', NULL, 'Active'),
(367, '1465306097', NULL, 'admin', NULL, '2016-06-07 21:28:17', NULL, 'Active'),
(368, '1465433720', NULL, 'admin', NULL, '2016-06-09 08:55:20', NULL, 'Active'),
(369, '1465436385', NULL, 'Nick', NULL, '2016-06-09 09:39:45', NULL, 'Active'),
(370, '1465436994', NULL, 'Nick', NULL, '2016-06-09 09:49:54', NULL, 'Active'),
(371, '1465437491', NULL, 'admin', NULL, '2016-06-09 09:58:11', NULL, 'Active'),
(372, '1465438359', NULL, 'Staff', NULL, '2016-06-09 10:12:39', NULL, 'Active'),
(373, '1465438933', NULL, 'Staff', NULL, '2016-06-09 10:22:13', NULL, 'Active'),
(374, '1465454606', NULL, 'admin', NULL, '2016-06-09 14:43:26', NULL, 'Active'),
(375, '1465455002', NULL, 'Staff', NULL, '2016-06-09 14:50:02', NULL, 'Active'),
(376, '1465455232', NULL, 'Staff', NULL, '2016-06-09 14:53:52', NULL, 'Active'),
(377, '1465533868', NULL, 'admin', NULL, '2016-06-10 12:44:28', NULL, 'Active'),
(378, '1465534456', NULL, 'admin', NULL, '2016-06-10 12:54:16', NULL, 'Active'),
(379, '1465535644', NULL, 'Staff', NULL, '2016-06-10 13:14:04', NULL, 'Active'),
(380, '1465547217', NULL, 'Staff', NULL, '2016-06-10 16:26:57', NULL, 'Active'),
(381, '1465604650', NULL, 'Staff', NULL, '2016-06-11 08:24:10', NULL, 'Active'),
(382, '1465612935', NULL, 'Staff', NULL, '2016-06-11 10:42:15', NULL, 'Active'),
(383, '1465630864', NULL, 'lois', NULL, '2016-06-11 15:41:04', NULL, 'Active'),
(384, '1465630908', NULL, 'Staff', NULL, '2016-06-11 15:41:48', NULL, 'Active'),
(385, '1465693602', NULL, 'Staff', NULL, '2016-06-12 09:06:42', NULL, 'Active'),
(386, '1465693855', NULL, 'lois', NULL, '2016-06-12 09:10:55', NULL, 'Active'),
(387, '1465695063', NULL, 'Staff', NULL, '2016-06-12 09:31:03', NULL, 'Active'),
(388, '1465698394', NULL, 'lois', NULL, '2016-06-12 10:26:34', NULL, 'Active'),
(389, '1465698413', NULL, 'Staff', NULL, '2016-06-12 10:26:53', NULL, 'Active'),
(390, '1465705436', NULL, 'Staff', NULL, '2016-06-12 12:23:56', NULL, 'Active'),
(391, '1465729329', NULL, 'admin', NULL, '2016-06-12 19:02:09', NULL, 'Active'),
(392, '1465777486', NULL, 'Staff', NULL, '2016-06-13 08:24:46', NULL, 'Active'),
(393, '1465785916', NULL, 'lois', NULL, '2016-06-13 10:45:16', NULL, 'Active'),
(394, '1465790063', NULL, 'admin', NULL, '2016-06-13 11:54:23', NULL, 'Active'),
(395, '1465820546', NULL, 'Staff', NULL, '2016-06-13 20:22:26', NULL, 'Active'),
(396, '1465864951', NULL, 'lois', NULL, '2016-06-14 08:42:31', NULL, 'Active'),
(397, '1465865775', NULL, 'Staff', NULL, '2016-06-14 08:56:15', NULL, 'Active'),
(398, '1465865812', NULL, 'lois', NULL, '2016-06-14 08:56:52', NULL, 'Active'),
(399, '1465872921', NULL, 'lois', NULL, '2016-06-14 10:55:21', NULL, 'Active'),
(400, '1465903663', NULL, 'Staff', NULL, '2016-06-14 19:27:43', NULL, 'Active'),
(401, '1466038211', NULL, 'Staff', NULL, '2016-06-16 08:50:11', NULL, 'Active'),
(402, '1466051759', NULL, 'lois', NULL, '2016-06-16 12:35:59', NULL, 'Active'),
(403, '1466051789', NULL, 'Staff', NULL, '2016-06-16 12:36:29', NULL, 'Active'),
(404, '1466051819', NULL, 'lois', NULL, '2016-06-16 12:36:59', NULL, 'Active'),
(405, '1466060240', NULL, 'Staff', NULL, '2016-06-16 14:57:20', NULL, 'Active'),
(406, '1466066029', NULL, 'Staff', NULL, '2016-06-16 16:33:49', NULL, 'Active'),
(407, '1466073326', NULL, 'Staff', NULL, '2016-06-16 18:35:26', NULL, 'Active'),
(408, '1466075174', NULL, 'Staff', NULL, '2016-06-16 19:06:14', NULL, 'Active'),
(409, '1466123960', NULL, 'Staff', NULL, '2016-06-17 08:39:20', NULL, 'Active'),
(410, '1466149363', NULL, 'Staff', NULL, '2016-06-17 15:42:43', NULL, 'Active'),
(411, '1466211596', NULL, 'admin', NULL, '2016-06-18 08:59:56', NULL, 'Active'),
(412, '1466214196', NULL, 'Staff', NULL, '2016-06-18 09:43:16', NULL, 'Active'),
(413, '1466216375', NULL, 'admin', NULL, '2016-06-18 10:19:35', NULL, 'Active'),
(414, '1466218339', NULL, 'admin', NULL, '2016-06-18 10:52:19', NULL, 'Active'),
(415, '1466232247', NULL, 'Staff', NULL, '2016-06-18 14:44:07', NULL, 'Active'),
(416, '1466235400', NULL, 'Staff', NULL, '2016-06-18 15:36:40', NULL, 'Active'),
(417, '1466235501', NULL, 'Staff', NULL, '2016-06-18 15:38:21', NULL, 'Active'),
(418, '1466242801', NULL, 'lois', NULL, '2016-06-18 17:40:01', NULL, 'Active'),
(419, '1466258084', NULL, 'Staff', NULL, '2016-06-18 21:54:44', NULL, 'Active'),
(420, '1466297541', NULL, 'Staff', NULL, '2016-06-19 08:52:21', NULL, 'Active'),
(421, '1466303435', NULL, 'Staff', NULL, '2016-06-19 10:30:35', NULL, 'Active'),
(422, '1466308855', NULL, 'Staff', NULL, '2016-06-19 12:00:55', NULL, 'Active'),
(423, '1466311287', NULL, 'Staff', NULL, '2016-06-19 12:41:27', NULL, 'Active'),
(424, '1466314204', NULL, 'admin', NULL, '2016-06-19 13:30:04', NULL, 'Active'),
(425, '1466327744', NULL, 'admin', NULL, '2016-06-19 17:15:44', NULL, 'Active'),
(426, '1466329881', NULL, 'Staff', NULL, '2016-06-19 17:51:21', NULL, 'Active'),
(427, '1466385425', NULL, 'Staff', NULL, '2016-06-20 09:17:05', NULL, 'Active'),
(428, '1466396248', NULL, 'admin', NULL, '2016-06-20 12:17:28', NULL, 'Active'),
(429, '1466404225', NULL, 'admin', NULL, '2016-06-20 14:30:25', NULL, 'Active'),
(430, '1466406307', NULL, 'Nick', NULL, '2016-06-20 15:05:07', NULL, 'Active'),
(431, '1466406496', NULL, 'admin', NULL, '2016-06-20 15:08:16', NULL, 'Active'),
(432, '1466430470', NULL, 'Staff', NULL, '2016-06-20 21:47:50', NULL, 'Active'),
(433, '1466470807', NULL, 'admin', NULL, '2016-06-21 09:00:07', NULL, 'Active'),
(434, '1466487575', NULL, 'admin', NULL, '2016-06-21 13:39:35', NULL, 'Active'),
(435, '1466510328', NULL, 'admin', NULL, '2016-06-21 19:58:48', NULL, 'Active'),
(436, '1466643574', NULL, 'Staff', NULL, '2016-06-23 08:59:34', NULL, 'Active'),
(437, '1466680982', NULL, 'Staff', NULL, '2016-06-23 19:23:02', NULL, 'Active'),
(438, '1466681416', NULL, 'admin', NULL, '2016-06-23 19:30:16', NULL, 'Active'),
(439, '1466682532', NULL, 'Staff', NULL, '2016-06-23 19:48:52', NULL, 'Active'),
(440, '1466685867', NULL, 'lois', NULL, '2016-06-23 20:44:27', NULL, 'Active'),
(441, '1466692225', NULL, 'Staff', NULL, '2016-06-23 22:30:25', NULL, 'Active'),
(442, '1466735869', NULL, 'admin', NULL, '2016-06-24 10:37:49', NULL, 'Active'),
(443, '1466744311', NULL, 'admin', NULL, '2016-06-24 12:58:31', NULL, 'Active'),
(444, '1466750877', NULL, 'admin', NULL, '2016-06-24 14:47:57', NULL, 'Active'),
(445, '1466775310', NULL, 'Staff', NULL, '2016-06-24 21:35:10', NULL, 'Active'),
(446, '1466816172', NULL, 'admin', NULL, '2016-06-25 08:56:12', NULL, 'Active'),
(447, '1466820201', NULL, 'admin', NULL, '2016-06-25 10:03:21', NULL, 'Active'),
(448, '1466827306', NULL, 'admin', NULL, '2016-06-25 12:01:46', NULL, 'Active'),
(449, '1466838809', NULL, 'admin', NULL, '2016-06-25 15:13:29', NULL, 'Active'),
(450, '1466856643', NULL, 'admin', NULL, '2016-06-25 20:10:43', NULL, 'Active'),
(451, '1466862001', NULL, 'Staff', NULL, '2016-06-25 21:40:01', NULL, 'Active'),
(452, '1466903924', NULL, 'admin', NULL, '2016-06-26 09:18:44', NULL, 'Active'),
(453, '1466908083', NULL, 'admin', NULL, '2016-06-26 10:28:03', NULL, 'Active'),
(454, '1466916185', NULL, 'admin', NULL, '2016-06-26 12:43:05', NULL, 'Active'),
(455, '1466917220', NULL, 'admin', NULL, '2016-06-26 13:00:20', NULL, 'Active'),
(456, '1466925591', NULL, 'admin', NULL, '2016-06-26 15:19:51', NULL, 'Active'),
(457, '1466926301', NULL, 'admin', NULL, '2016-06-26 15:31:41', NULL, 'Active'),
(458, '1466949440', NULL, 'Staff', NULL, '2016-06-26 21:57:20', NULL, 'Active'),
(459, '1466989350', NULL, 'admin', NULL, '2016-06-27 09:02:30', NULL, 'Active'),
(460, '1467000232', NULL, 'admin', NULL, '2016-06-27 12:03:52', NULL, 'Active'),
(461, '1467003573', NULL, 'admin', NULL, '2016-06-27 12:59:33', NULL, 'Active'),
(462, '1467033993', NULL, 'Staff', NULL, '2016-06-27 21:26:33', NULL, 'Active'),
(463, '1467075958', NULL, 'Staff', NULL, '2016-06-28 09:05:58', NULL, 'Active'),
(464, '1467085981', NULL, 'admin', NULL, '2016-06-28 11:53:01', NULL, 'Active'),
(465, '1467087017', NULL, 'admin', NULL, '2016-06-28 12:10:17', NULL, 'Active'),
(466, '1467090670', NULL, 'admin', NULL, '2016-06-28 13:11:10', NULL, 'Active'),
(467, '1467115684', NULL, 'Staff', NULL, '2016-06-28 20:08:04', NULL, 'Active'),
(468, '1467250387', NULL, 'Staff', NULL, '2016-06-30 09:33:07', NULL, 'Active'),
(469, '1467285108', NULL, 'lois', NULL, '2016-06-30 19:11:48', NULL, 'Active'),
(470, '1467285143', NULL, 'Staff', NULL, '2016-06-30 19:12:23', NULL, 'Active'),
(471, '1467333426', NULL, 'Staff', NULL, '2016-07-01 08:37:06', NULL, 'Active'),
(472, '1467341003', NULL, 'admin', NULL, '2016-07-01 10:43:23', NULL, 'Active'),
(473, '1467348189', NULL, 'admin', NULL, '2016-07-01 12:43:09', NULL, 'Active'),
(474, '1467367956', NULL, 'admin', NULL, '2016-07-01 18:12:36', NULL, 'Active'),
(475, '1467381702', NULL, 'Staff', NULL, '2016-07-01 22:01:42', NULL, 'Active'),
(476, '1467422461', NULL, 'Staff', NULL, '2016-07-02 09:21:01', NULL, 'Active'),
(477, '1467431407', NULL, 'admin', NULL, '2016-07-02 11:50:07', NULL, 'Active'),
(478, '1467440005', NULL, 'admin', NULL, '2016-07-02 14:13:25', NULL, 'Active'),
(479, '1467448347', NULL, 'admin', NULL, '2016-07-02 16:32:27', NULL, 'Active'),
(480, '1467461692', NULL, 'admin', NULL, '2016-07-02 20:14:52', NULL, 'Active'),
(481, '1467466190', NULL, 'Staff', NULL, '2016-07-02 21:29:50', NULL, 'Active'),
(482, '1467507100', NULL, 'admin', NULL, '2016-07-03 08:51:40', NULL, 'Active'),
(483, '1467512007', NULL, 'admin', NULL, '2016-07-03 10:13:27', NULL, 'Active'),
(484, '1467520953', NULL, 'admin', NULL, '2016-07-03 12:42:33', NULL, 'Active'),
(485, '1467522176', NULL, 'admin', NULL, '2016-07-03 13:02:56', NULL, 'Active'),
(486, '1467523870', NULL, 'admin', NULL, '2016-07-03 13:31:10', NULL, 'Active'),
(487, '1467524695', NULL, 'admin', NULL, '2016-07-03 13:44:55', NULL, 'Active'),
(488, '1467527687', NULL, 'Staff', NULL, '2016-07-03 14:34:47', NULL, 'Active'),
(489, '1467529461', NULL, 'sanni', NULL, '2016-07-03 15:04:21', NULL, 'Active'),
(490, '1467530456', NULL, 'admin', NULL, '2016-07-03 15:20:56', NULL, 'Active'),
(491, '1467548174', NULL, 'Staff', NULL, '2016-07-03 20:16:14', NULL, 'Active'),
(492, '1467680725', NULL, 'admin', NULL, '2016-07-05 09:05:25', NULL, 'Active'),
(493, '1467687402', NULL, 'admin', NULL, '2016-07-05 10:56:42', NULL, 'Active'),
(494, '1467695051', NULL, 'admin', NULL, '2016-07-05 13:04:11', NULL, 'Active'),
(495, '1467724146', NULL, 'Staff', NULL, '2016-07-05 21:09:06', NULL, 'Active'),
(496, '1467764339', NULL, 'admin', NULL, '2016-07-06 08:18:59', NULL, 'Active'),
(497, '1467784297', NULL, 'Staff', NULL, '2016-07-06 13:51:37', NULL, 'Active'),
(498, '1467789963', NULL, 'Staff', NULL, '2016-07-06 15:26:03', NULL, 'Active'),
(499, '1467807304', NULL, 'admin', NULL, '2016-07-06 20:15:04', NULL, 'Active'),
(500, '1467812168', NULL, 'Staff', NULL, '2016-07-06 21:36:08', NULL, 'Active'),
(501, '1467852793', NULL, 'admin', NULL, '2016-07-07 08:53:13', NULL, 'Active'),
(502, '1467859133', NULL, 'admin', NULL, '2016-07-07 10:38:53', NULL, 'Active'),
(503, '1467859150', NULL, 'admin', NULL, '2016-07-07 10:39:10', NULL, 'Active'),
(504, '1467859616', NULL, 'admin', NULL, '2016-07-07 10:46:56', NULL, 'Active'),
(505, '1467860098', NULL, 'admin', NULL, '2016-07-07 10:54:58', NULL, 'Active'),
(506, '1467860400', NULL, 'Staff', NULL, '2016-07-07 11:00:00', NULL, 'Active'),
(507, '1467862578', NULL, 'Staff', NULL, '2016-07-07 11:36:18', NULL, 'Active'),
(508, '1467865379', NULL, 'admin', NULL, '2016-07-07 12:22:59', NULL, 'Active'),
(509, '1467870932', NULL, 'admin', NULL, '2016-07-07 13:55:32', NULL, 'Active'),
(510, '1467874067', NULL, 'admin', NULL, '2016-07-07 14:47:47', NULL, 'Active'),
(511, '1467884827', NULL, 'admin', NULL, '2016-07-07 17:47:07', NULL, 'Active'),
(512, '1467885914', NULL, 'admin', NULL, '2016-07-07 18:05:14', NULL, 'Active'),
(513, '1467891774', NULL, 'admin', NULL, '2016-07-07 19:42:54', NULL, 'Active'),
(514, '1467900626', NULL, 'Staff', NULL, '2016-07-07 22:10:26', NULL, 'Active'),
(515, '1467940051', NULL, 'admin', NULL, '2016-07-08 09:07:31', NULL, 'Active'),
(516, '1467943171', NULL, 'admin', NULL, '2016-07-08 09:59:31', NULL, 'Active'),
(517, '1467945991', NULL, 'admin', NULL, '2016-07-08 10:46:31', NULL, 'Active'),
(518, '1467952712', NULL, 'admin', NULL, '2016-07-08 12:38:32', NULL, 'Active'),
(519, '1467962166', NULL, 'admin', NULL, '2016-07-08 15:16:06', NULL, 'Active'),
(520, '1467972534', NULL, 'admin', NULL, '2016-07-08 18:08:54', NULL, 'Active'),
(521, '1467977705', NULL, 'Staff', NULL, '2016-07-08 19:35:05', NULL, 'Active'),
(522, '1468026127', NULL, 'admin', NULL, '2016-07-09 09:02:07', NULL, 'Active'),
(523, '1468052698', NULL, 'admin', NULL, '2016-07-09 16:24:58', NULL, 'Active'),
(524, '1468062462', NULL, 'admin', NULL, '2016-07-09 19:07:42', NULL, 'Active'),
(525, '1468065170', NULL, 'admin', NULL, '2016-07-09 19:52:50', NULL, 'Active'),
(526, '1468068546', NULL, 'admin', NULL, '2016-07-09 20:49:06', NULL, 'Active'),
(527, '1468069710', NULL, 'admin', NULL, '2016-07-09 21:08:30', NULL, 'Active'),
(528, '1468073319', NULL, 'Staff', NULL, '2016-07-09 22:08:39', NULL, 'Active'),
(529, '1468110352', NULL, 'admin', NULL, '2016-07-10 08:25:52', NULL, 'Active'),
(530, '1468121744', NULL, 'Staff', NULL, '2016-07-10 11:35:44', NULL, 'Active'),
(531, '1468124266', NULL, 'admin', NULL, '2016-07-10 12:17:46', NULL, 'Active'),
(532, '1468133856', NULL, 'admin', NULL, '2016-07-10 14:57:36', NULL, 'Active'),
(533, '1468135169', NULL, 'admin', NULL, '2016-07-10 15:19:29', NULL, 'Active'),
(534, '1468157241', NULL, 'Staff', NULL, '2016-07-10 21:27:21', NULL, 'Active'),
(535, '1468198485', NULL, 'admin', NULL, '2016-07-11 08:54:45', NULL, 'Active'),
(536, '1468230265', NULL, 'admin', NULL, '2016-07-11 17:44:25', NULL, 'Active'),
(537, '1468231244', NULL, 'admin', NULL, '2016-07-11 18:00:44', NULL, 'Active'),
(538, '1468243137', NULL, 'Staff', NULL, '2016-07-11 21:18:57', NULL, 'Active'),
(539, '1468285631', NULL, 'admin', NULL, '2016-07-12 09:07:11', NULL, 'Active'),
(540, '1468315032', NULL, 'admin', NULL, '2016-07-12 17:17:12', NULL, 'Active'),
(541, '1468315063', NULL, 'admin', NULL, '2016-07-12 17:17:43', NULL, 'Active'),
(542, '1468317803', NULL, 'admin', NULL, '2016-07-12 18:03:23', NULL, 'Active'),
(543, '1468320886', NULL, 'admin', NULL, '2016-07-12 18:54:46', NULL, 'Active'),
(544, '1468325176', NULL, 'Staff', NULL, '2016-07-12 20:06:16', NULL, 'Active'),
(545, '1468457720', NULL, 'admin', NULL, '2016-07-14 08:55:20', NULL, 'Active'),
(546, '1468473779', NULL, 'Staff', NULL, '2016-07-14 13:22:59', NULL, 'Active'),
(547, '1468477373', NULL, 'admin', NULL, '2016-07-14 14:22:53', NULL, 'Active'),
(548, '1468479427', NULL, 'Staff', NULL, '2016-07-14 14:57:07', NULL, 'Active'),
(549, '1468491446', NULL, 'admin', NULL, '2016-07-14 18:17:26', NULL, 'Active'),
(550, '1468498624', NULL, 'Staff', NULL, '2016-07-14 20:17:04', NULL, 'Active'),
(551, '1468544076', NULL, 'admin', NULL, '2016-07-15 08:54:36', NULL, 'Active'),
(552, '1468558997', NULL, 'admin', NULL, '2016-07-15 13:03:17', NULL, 'Active'),
(553, '1468572157', NULL, 'admin', NULL, '2016-07-15 16:42:37', NULL, 'Active'),
(554, '1468575286', NULL, 'admin', NULL, '2016-07-15 17:34:46', NULL, 'Active'),
(555, '1468578455', NULL, 'admin', NULL, '2016-07-15 18:27:35', NULL, 'Active'),
(556, '1468588048', NULL, 'admin', NULL, '2016-07-15 21:07:28', NULL, 'Active'),
(557, '1468590609', NULL, 'admin', NULL, '2016-07-15 21:50:09', NULL, 'Active'),
(558, '1468590838', NULL, 'Staff', NULL, '2016-07-15 21:53:58', NULL, 'Active'),
(559, '1468628611', NULL, 'admin', NULL, '2016-07-16 08:23:31', NULL, 'Active'),
(560, '1468639424', NULL, 'admin', NULL, '2016-07-16 11:23:44', NULL, 'Active'),
(561, '1468675805', NULL, 'Staff', NULL, '2016-07-16 21:30:05', NULL, 'Active'),
(562, '1468717848', NULL, 'admin', NULL, '2016-07-17 09:10:48', NULL, 'Active'),
(563, '1468724310', NULL, 'Staff', NULL, '2016-07-17 10:58:30', NULL, 'Active'),
(564, '1468728065', NULL, 'Staff', NULL, '2016-07-17 12:01:05', NULL, 'Active'),
(565, '1468731161', NULL, 'admin', NULL, '2016-07-17 12:52:41', NULL, 'Active'),
(566, '1468735269', NULL, 'admin', NULL, '2016-07-17 14:01:09', NULL, 'Active'),
(567, '1468743545', NULL, 'admin', NULL, '2016-07-17 16:19:05', NULL, 'Active'),
(568, '1468760400', NULL, 'admin', NULL, '2016-07-17 21:00:00', NULL, 'Active'),
(569, '1468766326', NULL, 'Staff', NULL, '2016-07-17 22:38:46', NULL, 'Active'),
(570, '1468804386', NULL, 'admin', NULL, '2016-07-18 09:13:06', NULL, 'Active'),
(571, '1468812919', NULL, 'admin', NULL, '2016-07-18 11:35:19', NULL, 'Active'),
(572, '1468836408', NULL, 'admin', NULL, '2016-07-18 18:06:48', NULL, 'Active'),
(573, '1468837722', NULL, 'admin', NULL, '2016-07-18 18:28:42', NULL, 'Active'),
(574, '1468840398', NULL, 'admin', NULL, '2016-07-18 19:13:18', NULL, 'Active'),
(575, '1468848073', NULL, 'Staff', NULL, '2016-07-18 21:21:13', NULL, 'Active'),
(576, '1468889111', NULL, 'Staff', NULL, '2016-07-19 08:45:11', NULL, 'Active'),
(577, '1468903791', NULL, 'admin', NULL, '2016-07-19 12:49:51', NULL, 'Active'),
(578, '1468911956', NULL, 'admin', NULL, '2016-07-19 15:05:56', NULL, 'Active'),
(579, '1468925175', NULL, 'admin', NULL, '2016-07-19 18:46:15', NULL, 'Active'),
(580, '1468930438', NULL, 'Staff', NULL, '2016-07-19 20:13:58', NULL, 'Active'),
(581, '1469061861', NULL, 'admin', NULL, '2016-07-21 08:44:21', NULL, 'Active'),
(582, '1469075931', NULL, 'admin', NULL, '2016-07-21 12:38:51', NULL, 'Active'),
(583, '1469115065', NULL, 'Staff', NULL, '2016-07-21 23:31:05', NULL, 'Active'),
(584, '1469148115', NULL, 'admin', NULL, '2016-07-22 08:41:55', NULL, 'Active'),
(585, '1469191556', NULL, 'admin', NULL, '2016-07-22 20:45:56', NULL, 'Active'),
(586, '1469196197', NULL, 'Staff', NULL, '2016-07-22 22:03:17', NULL, 'Active'),
(587, '1469236076', NULL, 'admin', NULL, '2016-07-23 09:07:56', NULL, 'Active'),
(588, '1469242079', NULL, 'admin', NULL, '2016-07-23 10:47:59', NULL, 'Active'),
(589, '1469244729', NULL, 'admin', NULL, '2016-07-23 11:32:09', NULL, 'Active'),
(590, '1469248158', NULL, 'admin', NULL, '2016-07-23 12:29:18', NULL, 'Active'),
(591, '1469253261', NULL, 'admin', NULL, '2016-07-23 13:54:21', NULL, 'Active'),
(592, '1469281396', NULL, 'Staff', NULL, '2016-07-23 21:43:16', NULL, 'Active'),
(593, '1469320347', NULL, 'admin', NULL, '2016-07-24 08:32:27', NULL, 'Active'),
(594, '1469326411', NULL, 'admin', NULL, '2016-07-24 10:13:31', NULL, 'Active'),
(595, '1469329245', NULL, 'admin', NULL, '2016-07-24 11:00:45', NULL, 'Active'),
(596, '1469331880', NULL, 'admin', NULL, '2016-07-24 11:44:40', NULL, 'Active'),
(597, '1469334508', NULL, 'admin', NULL, '2016-07-24 12:28:28', NULL, 'Active'),
(598, '1469342237', NULL, 'admin', NULL, '2016-07-24 14:37:17', NULL, 'Active'),
(599, '1469344718', NULL, 'admin', NULL, '2016-07-24 15:18:38', NULL, 'Active'),
(600, '1469359587', NULL, 'sanni', NULL, '2016-07-24 19:26:27', NULL, 'Active'),
(601, '1469412109', NULL, 'Staff', NULL, '2016-07-25 10:01:49', NULL, 'Active'),
(602, '1469423653', NULL, 'admin', NULL, '2016-07-25 13:14:13', NULL, 'Active'),
(603, '1469444275', NULL, 'admin', NULL, '2016-07-25 18:57:55', NULL, 'Active'),
(604, '1469445352', NULL, 'admin', NULL, '2016-07-25 19:15:52', NULL, 'Active'),
(605, '1469445375', NULL, 'admin', NULL, '2016-07-25 19:16:15', NULL, 'Active'),
(606, '1469445420', NULL, 'admin', NULL, '2016-07-25 19:17:00', NULL, 'Active'),
(607, '1469506369', NULL, 'admin', NULL, '2016-07-26 12:12:49', NULL, 'Active'),
(608, '1469528863', NULL, 'admin', NULL, '2016-07-26 18:27:43', NULL, 'Active'),
(609, '1469666931', NULL, 'admin', NULL, '2016-07-28 08:48:51', NULL, 'Active'),
(610, '1469673263', NULL, 'admin', NULL, '2016-07-28 10:34:23', NULL, 'Active'),
(611, '1469676869', NULL, 'Staff', NULL, '2016-07-28 11:34:29', NULL, 'Active'),
(612, '1469684952', NULL, 'Staff', NULL, '2016-07-28 13:49:12', NULL, 'Active'),
(613, '1469693333', NULL, 'admin', NULL, '2016-07-28 16:08:53', NULL, 'Active'),
(614, '1469696146', NULL, 'admin', NULL, '2016-07-28 16:55:46', NULL, 'Active'),
(615, '1469709163', NULL, 'Staff', NULL, '2016-07-28 20:32:43', NULL, 'Active'),
(616, '1469752228', NULL, 'admin', NULL, '2016-07-29 08:30:28', NULL, 'Active'),
(617, '1469783398', NULL, 'admin', NULL, '2016-07-29 17:09:58', NULL, 'Active'),
(618, '1469797949', NULL, 'admin', NULL, '2016-07-29 21:12:29', NULL, 'Active'),
(619, '1469800747', NULL, 'Staff', NULL, '2016-07-29 21:59:07', NULL, 'Active'),
(620, '1469839132', NULL, 'admin', NULL, '2016-07-30 08:38:53', NULL, 'Active'),
(621, '1469850386', NULL, 'admin', NULL, '2016-07-30 11:46:26', NULL, 'Active'),
(622, '1469857554', NULL, 'Staff', NULL, '2016-07-30 13:45:54', NULL, 'Active'),
(623, '1469859643', NULL, 'lois', NULL, '2016-07-30 14:20:43', NULL, 'Active'),
(624, '1469862445', NULL, 'admin', NULL, '2016-07-30 15:07:25', NULL, 'Active'),
(625, '1469869280', NULL, 'admin', NULL, '2016-07-30 17:01:20', NULL, 'Active'),
(626, '1469869414', NULL, 'admin', NULL, '2016-07-30 17:03:34', NULL, 'Active'),
(627, '1469882701', NULL, 'admin', NULL, '2016-07-30 20:45:01', NULL, 'Active'),
(628, '1469886405', NULL, 'Staff', NULL, '2016-07-30 21:46:45', NULL, 'Active'),
(629, '1469924943', NULL, 'admin', NULL, '2016-07-31 08:29:03', NULL, 'Active'),
(630, '1469948456', NULL, 'admin', NULL, '2016-07-31 15:00:56', NULL, 'Active');
INSERT INTO `sales_sessions` (`id`, `identifier`, `session`, `logged_in_by`, `logged_out_by`, `from`, `to`, `status`) VALUES
(631, '1469968670', NULL, 'admin', NULL, '2016-07-31 20:37:50', NULL, 'Active'),
(632, '1469968701', NULL, 'lois', NULL, '2016-07-31 20:38:21', NULL, 'Active'),
(633, '1469973773', NULL, 'admin', NULL, '2016-07-31 22:02:53', NULL, 'Active'),
(634, '1470011762', NULL, 'lois', NULL, '2016-08-01 08:36:02', NULL, 'Active'),
(635, '1470021703', NULL, 'Staff', NULL, '2016-08-01 11:21:43', NULL, 'Active'),
(636, '1470099502', NULL, 'admin', NULL, '2016-08-02 08:58:22', NULL, 'Active'),
(637, '1470120438', NULL, 'admin', NULL, '2016-08-02 14:47:18', NULL, 'Active'),
(638, '1470272375', NULL, 'admin', NULL, '2016-08-04 08:59:35', NULL, 'Active'),
(639, '1470285478', NULL, 'admin', NULL, '2016-08-04 12:37:58', NULL, 'Active'),
(640, '1470358966', NULL, 'sanni', NULL, '2016-08-05 09:02:46', NULL, 'Active'),
(641, '1470364383', NULL, 'admin', NULL, '2016-08-05 10:33:03', NULL, 'Active'),
(642, '1470374356', NULL, 'sanni', NULL, '2016-08-05 13:19:16', NULL, 'Active'),
(643, '1470376059', NULL, 'admin', NULL, '2016-08-05 13:47:39', NULL, 'Active'),
(644, '1470397619', NULL, 'admin', NULL, '2016-08-05 19:46:59', NULL, 'Active'),
(645, '1470446228', NULL, 'sanni', NULL, '2016-08-06 09:17:08', NULL, 'Active'),
(646, '1470450107', NULL, 'sanni', NULL, '2016-08-06 10:21:47', NULL, 'Active'),
(647, '1470451466', NULL, 'admin', NULL, '2016-08-06 10:44:26', NULL, 'Active'),
(648, '1470459027', NULL, 'sanni', NULL, '2016-08-06 12:50:27', NULL, 'Active'),
(649, '1470465155', NULL, 'sanni', NULL, '2016-08-06 14:32:35', NULL, 'Active'),
(650, '1470529443', NULL, 'sanni', NULL, '2016-08-07 08:24:03', NULL, 'Active'),
(651, '1470532862', NULL, 'sanni', NULL, '2016-08-07 09:21:02', NULL, 'Active'),
(652, '1470535040', NULL, 'sanni', NULL, '2016-08-07 09:57:20', NULL, 'Active'),
(653, '1470536308', NULL, 'sanni', NULL, '2016-08-07 10:18:28', NULL, 'Active'),
(654, '1470539688', NULL, 'sanni', NULL, '2016-08-07 11:14:48', NULL, 'Active'),
(655, '1470540055', NULL, 'sanni', NULL, '2016-08-07 11:20:55', NULL, 'Active'),
(656, '1470540083', NULL, 'sanni', NULL, '2016-08-07 11:21:23', NULL, 'Active'),
(657, '1470541411', NULL, 'admin', NULL, '2016-08-07 11:43:31', NULL, 'Active'),
(658, '1470541567', NULL, 'sanni', NULL, '2016-08-07 11:46:07', NULL, 'Active'),
(659, '1470541587', NULL, 'sanni', NULL, '2016-08-07 11:46:27', NULL, 'Active'),
(660, '1470546490', NULL, 'sanni', NULL, '2016-08-07 13:08:10', NULL, 'Active'),
(661, '1470552213', NULL, 'sanni', NULL, '2016-08-07 14:43:33', NULL, 'Active'),
(662, '1470618188', NULL, 'sanni', NULL, '2016-08-08 09:03:08', NULL, 'Active'),
(663, '1470618879', NULL, 'Staff', NULL, '2016-08-08 09:14:39', NULL, 'Active'),
(664, '1470618904', NULL, 'admin', NULL, '2016-08-08 09:15:04', NULL, 'Active'),
(665, '1470635017', NULL, 'sanni', NULL, '2016-08-08 13:43:37', NULL, 'Active'),
(666, '1470660115', NULL, 'admin', NULL, '2016-08-08 20:41:55', NULL, 'Active'),
(667, '1470662053', NULL, 'admin', NULL, '2016-08-08 21:14:13', NULL, 'Active'),
(668, '1470662337', NULL, 'admin', NULL, '2016-08-08 21:18:57', NULL, 'Active'),
(669, '1470663773', NULL, 'admin', NULL, '2016-08-08 21:42:53', NULL, 'Active'),
(670, '1470704366', NULL, 'admin', NULL, '2016-08-09 08:59:26', NULL, 'Active'),
(671, '1470718649', NULL, 'sanni', NULL, '2016-08-09 12:57:29', NULL, 'Active'),
(672, '1470876895', NULL, 'admin', NULL, '2016-08-11 08:54:55', NULL, 'Active'),
(673, '1470963578', NULL, 'admin', NULL, '2016-08-12 08:59:38', NULL, 'Active'),
(674, '1470976926', NULL, 'sanni', NULL, '2016-08-12 12:42:06', NULL, 'Active'),
(675, '1471008056', NULL, 'admin', NULL, '2016-08-12 21:20:56', NULL, 'Active'),
(676, '1471049773', NULL, 'admin', NULL, '2016-08-13 08:56:13', NULL, 'Active'),
(677, '1471056200', NULL, 'admin', NULL, '2016-08-13 10:43:20', NULL, 'Active'),
(678, '1471059503', NULL, 'admin', NULL, '2016-08-13 11:38:23', NULL, 'Active'),
(679, '1471064222', NULL, 'admin', NULL, '2016-08-13 12:57:02', NULL, 'Active'),
(680, '1471134284', NULL, 'admin', NULL, '2016-08-14 08:24:44', NULL, 'Active'),
(681, '1471138765', NULL, 'admin', NULL, '2016-08-14 09:39:25', NULL, 'Active'),
(682, '1471142546', NULL, 'admin', NULL, '2016-08-14 10:42:26', NULL, 'Active'),
(683, '1471142609', NULL, 'admin', NULL, '2016-08-14 10:43:29', NULL, 'Active'),
(684, '1471142633', NULL, 'admin', NULL, '2016-08-14 10:43:53', NULL, 'Active'),
(685, '1471143579', NULL, 'admin', NULL, '2016-08-14 10:59:39', NULL, 'Active'),
(686, '1471145944', NULL, 'admin', NULL, '2016-08-14 11:39:04', NULL, 'Active'),
(687, '1471166545', NULL, 'admin', NULL, '2016-08-14 17:22:25', NULL, 'Active'),
(688, '1471222368', NULL, 'admin', NULL, '2016-08-15 08:52:48', NULL, 'Active'),
(689, '1471234978', NULL, 'admin', NULL, '2016-08-15 12:22:58', NULL, 'Active'),
(690, '1471248880', NULL, 'admin', NULL, '2016-08-15 16:14:40', NULL, 'Active'),
(691, '1471309259', NULL, 'admin', NULL, '2016-08-16 09:00:59', NULL, 'Active'),
(692, '1471319531', NULL, 'admin', NULL, '2016-08-16 11:52:11', NULL, 'Active'),
(693, '1471322882', NULL, 'admin', NULL, '2016-08-16 12:48:02', NULL, 'Active'),
(694, '1471324027', NULL, 'admin', NULL, '2016-08-16 13:07:07', NULL, 'Active'),
(695, '1471483771', NULL, 'Staff', NULL, '2016-08-18 09:29:31', NULL, 'Active'),
(696, '1471569290', NULL, 'admin', NULL, '2016-08-19 09:14:50', NULL, 'Active'),
(697, '1471581015', NULL, 'admin', NULL, '2016-08-19 12:30:15', NULL, 'Active'),
(698, '1471602109', NULL, 'admin', NULL, '2016-08-19 18:21:49', NULL, 'Active'),
(699, '1471612406', NULL, 'admin', NULL, '2016-08-19 21:13:26', NULL, 'Active'),
(700, '1471655526', NULL, 'admin', NULL, '2016-08-20 09:12:06', NULL, 'Active'),
(701, '1471667429', NULL, 'admin', NULL, '2016-08-20 12:30:29', NULL, 'Active'),
(702, '1471741108', NULL, 'admin', NULL, '2016-08-21 08:58:28', NULL, 'Active'),
(703, '1471743730', NULL, 'admin', NULL, '2016-08-21 09:42:10', NULL, 'Active'),
(704, '1471746322', NULL, 'admin', NULL, '2016-08-21 10:25:22', NULL, 'Active'),
(705, '1471749979', NULL, 'admin', NULL, '2016-08-21 11:26:19', NULL, 'Active'),
(706, '1471770451', NULL, 'admin', NULL, '2016-08-21 17:07:31', NULL, 'Active'),
(707, '1471827935', NULL, 'admin', NULL, '2016-08-22 09:05:35', NULL, 'Active'),
(708, '1471827960', NULL, 'admin', NULL, '2016-08-22 09:06:00', NULL, 'Active'),
(709, '1471856101', NULL, 'admin', NULL, '2016-08-22 16:55:01', NULL, 'Active'),
(710, '1471914353', NULL, 'admin', NULL, '2016-08-23 09:05:53', NULL, 'Active'),
(711, '1472086456', NULL, 'lois', NULL, '2016-08-25 08:54:16', NULL, 'Active'),
(712, '1472092621', NULL, 'admin', NULL, '2016-08-25 10:37:01', NULL, 'Active'),
(713, '1472097619', NULL, 'admin', NULL, '2016-08-25 12:00:19', NULL, 'Active'),
(714, '1472173408', NULL, 'admin', NULL, '2016-08-26 09:03:28', NULL, 'Active'),
(715, '1472185694', NULL, 'admin', NULL, '2016-08-26 12:28:14', NULL, 'Active'),
(716, '1472258939', NULL, 'lois', NULL, '2016-08-27 08:48:59', NULL, 'Active'),
(717, '1472271633', NULL, 'admin', NULL, '2016-08-27 12:20:33', NULL, 'Active'),
(718, '1472274868', NULL, 'admin', NULL, '2016-08-27 13:14:28', NULL, 'Active'),
(719, '1472279241', NULL, 'admin', NULL, '2016-08-27 14:27:21', NULL, 'Active'),
(720, '1472281391', NULL, 'admin', NULL, '2016-08-27 15:03:11', NULL, 'Active'),
(721, '1472283451', NULL, 'admin', NULL, '2016-08-27 15:37:31', NULL, 'Active'),
(722, '1472287380', NULL, 'admin', NULL, '2016-08-27 16:43:00', NULL, 'Active'),
(723, '1472300810', NULL, 'admin', NULL, '2016-08-27 20:26:50', NULL, 'Active'),
(724, '1472344579', NULL, 'admin', NULL, '2016-08-28 08:36:19', NULL, 'Active'),
(725, '1472348446', NULL, 'admin', NULL, '2016-08-28 09:40:46', NULL, 'Active'),
(726, '1472350154', NULL, 'admin', NULL, '2016-08-28 10:09:14', NULL, 'Active'),
(727, '1472357188', NULL, 'admin', NULL, '2016-08-28 12:06:28', NULL, 'Active'),
(728, '1472360478', NULL, 'admin', NULL, '2016-08-28 13:01:18', NULL, 'Active'),
(729, '1472382011', NULL, 'admin', NULL, '2016-08-28 19:00:11', NULL, 'Active'),
(730, '1472431662', NULL, 'admin', NULL, '2016-08-29 08:47:42', NULL, 'Active'),
(731, '1472471094', NULL, 'admin', NULL, '2016-08-29 19:44:54', NULL, 'Active'),
(732, '1472605428', NULL, 'admin', NULL, '2016-08-31 09:03:48', NULL, 'Active'),
(733, '1472606948', NULL, 'admin', NULL, '2016-08-31 09:29:08', NULL, 'Active'),
(734, '1472609459', NULL, 'admin', NULL, '2016-08-31 10:10:59', NULL, 'Active'),
(735, '1472610645', NULL, 'admin', NULL, '2016-08-31 10:30:45', NULL, 'Active'),
(736, '1472623467', NULL, 'admin', NULL, '2016-08-31 14:04:27', NULL, 'Active'),
(737, '1472624370', NULL, 'admin', NULL, '2016-08-31 14:19:30', NULL, 'Active'),
(738, '1472624610', NULL, 'admin', NULL, '2016-08-31 14:23:30', NULL, 'Active'),
(739, '1472642327', NULL, 'admin', NULL, '2016-08-31 19:18:47', NULL, 'Active'),
(740, '1472691069', NULL, 'admin', NULL, '2016-09-01 08:51:09', NULL, 'Active'),
(741, '1472701175', NULL, 'admin', NULL, '2016-09-01 11:39:35', NULL, 'Active'),
(742, '1472777808', NULL, 'admin', NULL, '2016-09-02 08:56:48', NULL, 'Active'),
(743, '1472786533', NULL, 'admin', NULL, '2016-09-02 11:22:13', NULL, 'Active'),
(744, '1472794964', NULL, 'admin', NULL, '2016-09-02 13:42:44', NULL, 'Active'),
(745, '1472804577', NULL, 'admin', NULL, '2016-09-02 16:22:57', NULL, 'Active'),
(746, '1472820082', NULL, 'admin', NULL, '2016-09-02 20:41:22', NULL, 'Active'),
(747, '1472864448', NULL, 'admin', NULL, '2016-09-03 09:00:48', NULL, 'Active'),
(748, '1472866970', NULL, 'admin', NULL, '2016-09-03 09:42:50', NULL, 'Active'),
(749, '1472874616', NULL, 'admin', NULL, '2016-09-03 11:50:16', NULL, 'Active'),
(750, '1472879469', NULL, 'admin', NULL, '2016-09-03 13:11:09', NULL, 'Active'),
(751, '1472951138', NULL, 'sanni', NULL, '2016-09-04 09:05:38', NULL, 'Active'),
(752, '1472955853', NULL, 'admin', NULL, '2016-09-04 10:24:13', NULL, 'Active'),
(753, '1472960110', NULL, 'admin', NULL, '2016-09-04 11:35:10', NULL, 'Active'),
(754, '1472963973', NULL, 'admin', NULL, '2016-09-04 12:39:33', NULL, 'Active'),
(755, '1472965852', NULL, 'admin', NULL, '2016-09-04 13:10:52', NULL, 'Active'),
(756, '1472989530', NULL, 'admin', NULL, '2016-09-04 19:45:30', NULL, 'Active'),
(757, '1473037573', NULL, 'admin', NULL, '2016-09-05 09:06:13', NULL, 'Active'),
(758, '1473057839', NULL, 'admin', NULL, '2016-09-05 14:43:59', NULL, 'Active'),
(759, '1473210396', NULL, 'admin', NULL, '2016-09-07 09:06:36', NULL, 'Active'),
(760, '1473226673', NULL, 'admin', NULL, '2016-09-07 13:37:53', NULL, 'Active'),
(761, '1473251390', NULL, 'admin', NULL, '2016-09-07 20:29:50', NULL, 'Active'),
(762, '1473296496', NULL, 'admin', NULL, '2016-09-08 09:01:36', NULL, 'Active'),
(763, '1473305372', NULL, 'admin', NULL, '2016-09-08 11:29:32', NULL, 'Active'),
(764, '1473309015', NULL, 'admin', NULL, '2016-09-08 12:30:15', NULL, 'Active'),
(765, '1473310160', NULL, 'admin', NULL, '2016-09-08 12:49:20', NULL, 'Active'),
(766, '1473319150', NULL, 'admin', NULL, '2016-09-08 15:19:10', NULL, 'Active'),
(767, '1473382685', NULL, 'admin', NULL, '2016-09-09 08:58:05', NULL, 'Active'),
(768, '1473468272', NULL, 'admin', NULL, '2016-09-10 08:44:32', NULL, 'Active'),
(769, '1473478617', NULL, 'admin', NULL, '2016-09-10 11:36:57', NULL, 'Active'),
(770, '1473555747', NULL, 'admin', NULL, '2016-09-11 09:02:27', NULL, 'Active'),
(771, '1473561482', NULL, 'admin', NULL, '2016-09-11 10:38:02', NULL, 'Active'),
(772, '1473562727', NULL, 'admin', NULL, '2016-09-11 10:58:47', NULL, 'Active'),
(773, '1473565886', NULL, 'admin', NULL, '2016-09-11 11:51:26', NULL, 'Active'),
(774, '1473568914', NULL, 'admin', NULL, '2016-09-11 12:41:54', NULL, 'Active'),
(775, '1473569943', NULL, 'admin', NULL, '2016-09-11 12:59:03', NULL, 'Active'),
(776, '1473583045', NULL, 'admin', NULL, '2016-09-11 16:37:25', NULL, 'Active'),
(777, '1473597069', NULL, 'admin', NULL, '2016-09-11 20:31:09', NULL, 'Active'),
(778, '1473641025', NULL, 'admin', NULL, '2016-09-12 08:43:45', NULL, 'Active'),
(779, '1473651429', NULL, 'admin', NULL, '2016-09-12 11:37:09', NULL, 'Active'),
(780, '1473656393', NULL, 'admin', NULL, '2016-09-12 12:59:53', NULL, 'Active'),
(781, '1473671172', NULL, 'admin', NULL, '2016-09-12 17:06:12', NULL, 'Active'),
(782, '1473816737', NULL, 'admin', NULL, '2016-09-14 09:32:17', NULL, 'Active'),
(783, '1473829127', NULL, 'admin', NULL, '2016-09-14 12:58:47', NULL, 'Active'),
(784, '1473900628', NULL, 'admin', NULL, '2016-09-15 08:50:28', NULL, 'Active'),
(785, '1473919465', NULL, 'sanni', NULL, '2016-09-15 14:04:25', NULL, 'Active'),
(786, '1473987292', NULL, 'admin', NULL, '2016-09-16 08:54:52', NULL, 'Active'),
(787, '1473995493', NULL, 'admin', NULL, '2016-09-16 11:11:33', NULL, 'Active'),
(788, '1474007121', NULL, 'admin', NULL, '2016-09-16 14:25:21', NULL, 'Active'),
(789, '1474026586', NULL, 'admin', NULL, '2016-09-16 19:49:46', NULL, 'Active'),
(790, '1474073436', NULL, 'admin', NULL, '2016-09-17 08:50:36', NULL, 'Active'),
(791, '1474085850', NULL, 'admin', NULL, '2016-09-17 12:17:30', NULL, 'Active'),
(792, '1474090057', NULL, 'admin', NULL, '2016-09-17 13:27:37', NULL, 'Active'),
(793, '1474091738', NULL, 'admin', NULL, '2016-09-17 13:55:38', NULL, 'Active'),
(794, '1474104733', NULL, 'admin', NULL, '2016-09-17 17:32:13', NULL, 'Active'),
(795, '1474160102', NULL, 'admin', NULL, '2016-09-18 08:55:02', NULL, 'Active'),
(796, '1474164620', NULL, 'admin', NULL, '2016-09-18 10:10:20', NULL, 'Active'),
(797, '1474169438', NULL, 'admin', NULL, '2016-09-18 11:30:38', NULL, 'Active'),
(798, '1474171822', NULL, 'admin', NULL, '2016-09-18 12:10:22', NULL, 'Active'),
(799, '1474176495', NULL, 'admin', NULL, '2016-09-18 13:28:15', NULL, 'Active'),
(800, '1474246590', NULL, 'admin', NULL, '2016-09-19 08:56:30', NULL, 'Active'),
(801, '1474419959', NULL, 'admin', NULL, '2016-09-21 09:05:59', NULL, 'Active'),
(802, '1474439477', NULL, 'admin', NULL, '2016-09-21 14:31:17', NULL, 'Active'),
(803, '1474462385', NULL, 'admin', NULL, '2016-09-21 20:53:05', NULL, 'Active'),
(804, '1474506276', NULL, 'admin', NULL, '2016-09-22 09:04:36', NULL, 'Active'),
(805, '1474519858', NULL, 'admin', NULL, '2016-09-22 12:50:58', NULL, 'Active'),
(806, '1474592419', NULL, 'admin', NULL, '2016-09-23 09:00:19', NULL, 'Active'),
(807, '1474678577', NULL, 'admin', NULL, '2016-09-24 08:56:17', NULL, 'Active'),
(808, '1474680879', NULL, 'admin', NULL, '2016-09-24 09:34:39', NULL, 'Active'),
(809, '1474683903', NULL, 'admin', NULL, '2016-09-24 10:25:03', NULL, 'Active'),
(810, '1474687052', NULL, 'admin', NULL, '2016-09-24 11:17:32', NULL, 'Active'),
(811, '1474689107', NULL, 'admin', NULL, '2016-09-24 11:51:47', NULL, 'Active'),
(812, '1474692039', NULL, 'admin', NULL, '2016-09-24 12:40:39', NULL, 'Active'),
(813, '1474715615', NULL, 'admin', NULL, '2016-09-24 19:13:35', NULL, 'Active'),
(814, '1474764843', NULL, 'admin', NULL, '2016-09-25 08:54:03', NULL, 'Active'),
(815, '1474768312', NULL, 'admin', NULL, '2016-09-25 09:51:52', NULL, 'Active'),
(816, '1474772709', NULL, 'admin', NULL, '2016-09-25 11:05:09', NULL, 'Active'),
(817, '1474777649', NULL, 'admin', NULL, '2016-09-25 12:27:29', NULL, 'Active'),
(818, '1474777829', NULL, 'admin', NULL, '2016-09-25 12:30:29', NULL, 'Active'),
(819, '1474780224', NULL, 'admin', NULL, '2016-09-25 13:10:24', NULL, 'Active'),
(820, '1474781409', NULL, 'admin', NULL, '2016-09-25 13:30:09', NULL, 'Active'),
(821, '1474803087', NULL, 'admin', NULL, '2016-09-25 19:31:27', NULL, 'Active'),
(822, '1474851543', NULL, 'admin', NULL, '2016-09-26 08:59:03', NULL, 'Active'),
(823, '1474859119', NULL, 'admin', NULL, '2016-09-26 11:05:19', NULL, 'Active'),
(824, '1475023641', NULL, 'admin', NULL, '2016-09-28 08:47:21', NULL, 'Active'),
(825, '1475051348', NULL, 'admin', NULL, '2016-09-28 16:29:08', NULL, 'Active'),
(826, '1475051420', NULL, 'admin', NULL, '2016-09-28 16:30:20', NULL, 'Active'),
(827, '1475051440', NULL, 'sanni', NULL, '2016-09-28 16:30:40', NULL, 'Active'),
(828, '1475053695', NULL, 'admin', NULL, '2016-09-28 17:08:15', NULL, 'Active'),
(829, '1475053798', NULL, 'sanni', NULL, '2016-09-28 17:09:58', NULL, 'Active'),
(830, '1475117693', NULL, 'admin', NULL, '2016-09-29 10:54:53', NULL, 'Active'),
(831, '1475123385', NULL, 'admin', NULL, '2016-09-29 12:29:45', NULL, 'Active'),
(832, '1475144581', NULL, 'admin', NULL, '2016-09-29 18:23:01', NULL, 'Active'),
(833, '1475198761', NULL, 'admin', NULL, '2016-09-30 09:26:01', NULL, 'Active'),
(834, '1475208266', NULL, 'admin', NULL, '2016-09-30 12:04:26', NULL, 'Active'),
(835, '1475212742', NULL, 'admin', NULL, '2016-09-30 13:19:02', NULL, 'Active'),
(836, '1475215868', NULL, 'admin', NULL, '2016-09-30 14:11:08', NULL, 'Active'),
(837, '1475237666', NULL, 'admin', NULL, '2016-09-30 20:14:26', NULL, 'Active'),
(838, '1475283098', NULL, 'admin', NULL, '2016-10-01 08:51:38', NULL, 'Active'),
(839, '1475290683', NULL, 'admin', NULL, '2016-10-01 10:58:03', NULL, 'Active'),
(840, '1475293507', NULL, 'admin', NULL, '2016-10-01 11:45:07', NULL, 'Active'),
(841, '1475302551', NULL, 'admin', NULL, '2016-10-01 14:15:51', NULL, 'Active'),
(842, '1475328400', NULL, 'admin', NULL, '2016-10-01 21:26:40', NULL, 'Active'),
(843, '1475368873', NULL, 'admin', NULL, '2016-10-02 08:41:13', NULL, 'Active'),
(844, '1475376365', NULL, 'admin', NULL, '2016-10-02 10:46:05', NULL, 'Active'),
(845, '1475376918', NULL, 'admin', NULL, '2016-10-02 10:55:18', NULL, 'Active'),
(846, '1475388484', NULL, 'admin', NULL, '2016-10-02 14:08:04', NULL, 'Active'),
(847, '1475395156', NULL, 'admin', NULL, '2016-10-02 15:59:16', NULL, 'Active'),
(848, '1475408080', NULL, 'admin', NULL, '2016-10-02 19:34:40', NULL, 'Active'),
(849, '1475456291', NULL, 'admin', NULL, '2016-10-03 08:58:11', NULL, 'Active'),
(850, '1475459002', NULL, 'admin', NULL, '2016-10-03 09:43:22', NULL, 'Active'),
(851, '1475465542', NULL, 'admin', NULL, '2016-10-03 11:32:22', NULL, 'Active'),
(852, '1475631304', NULL, 'admin', NULL, '2016-10-05 09:35:04', NULL, 'Active'),
(853, '1475642788', NULL, 'admin', NULL, '2016-10-05 12:46:28', NULL, 'Active'),
(854, '1475714739', NULL, 'admin', NULL, '2016-10-06 08:45:39', NULL, 'Active'),
(855, '1475725961', NULL, 'admin', NULL, '2016-10-06 11:52:41', NULL, 'Active'),
(856, '1475748709', NULL, 'admin', NULL, '2016-10-06 18:11:49', NULL, 'Active'),
(857, '1475802181', NULL, 'admin', NULL, '2016-10-07 09:03:01', NULL, 'Active'),
(858, '1475816040', NULL, 'admin', NULL, '2016-10-07 12:54:00', NULL, 'Active'),
(859, '1475825142', NULL, 'admin', NULL, '2016-10-07 15:25:42', NULL, 'Active'),
(860, '1475843650', NULL, 'admin', NULL, '2016-10-07 20:34:10', NULL, 'Active'),
(861, '1475888684', NULL, 'admin', NULL, '2016-10-08 09:04:44', NULL, 'Active'),
(862, '1475892707', NULL, 'admin', NULL, '2016-10-08 10:11:47', NULL, 'Active'),
(863, '1475906803', NULL, 'admin', NULL, '2016-10-08 14:06:43', NULL, 'Active'),
(864, '1475914975', NULL, 'admin', NULL, '2016-10-08 16:22:55', NULL, 'Active'),
(865, '1475929383', NULL, 'admin', NULL, '2016-10-08 20:23:03', NULL, 'Active'),
(866, '1475973475', NULL, 'admin', NULL, '2016-10-09 08:37:55', NULL, 'Active'),
(867, '1475987700', NULL, 'admin', NULL, '2016-10-09 12:35:00', NULL, 'Active'),
(868, '1475991027', NULL, 'admin', NULL, '2016-10-09 13:30:27', NULL, 'Active'),
(869, '1475995191', NULL, 'admin', NULL, '2016-10-09 14:39:51', NULL, 'Active'),
(870, '1476009857', NULL, 'admin', NULL, '2016-10-09 18:44:17', NULL, 'Active'),
(871, '1476064220', NULL, 'admin', NULL, '2016-10-10 09:50:20', NULL, 'Active'),
(872, '1476075805', NULL, 'admin', NULL, '2016-10-10 13:03:25', NULL, 'Active'),
(873, '1476234655', NULL, 'admin', NULL, '2016-10-12 09:10:55', NULL, 'Active'),
(874, '1476246091', NULL, 'admin', NULL, '2016-10-12 12:21:31', NULL, 'Active'),
(875, '1476251885', NULL, 'admin', NULL, '2016-10-12 13:58:05', NULL, 'Active'),
(876, '1476273339', NULL, 'admin', NULL, '2016-10-12 19:55:39', NULL, 'Active'),
(877, '1476320667', NULL, 'admin', NULL, '2016-10-13 09:04:27', NULL, 'Active'),
(878, '1476357929', NULL, 'admin', NULL, '2016-10-13 19:25:29', NULL, 'Active'),
(879, '1476406799', NULL, 'admin', NULL, '2016-10-14 08:59:59', NULL, 'Active'),
(880, '1476424723', NULL, 'admin', NULL, '2016-10-14 13:58:43', NULL, 'Active'),
(881, '1476435711', NULL, 'admin', NULL, '2016-10-14 17:01:51', NULL, 'Active'),
(882, '1476493279', NULL, 'admin', NULL, '2016-10-15 09:01:19', NULL, 'Active'),
(883, '1476496219', NULL, 'admin', NULL, '2016-10-15 09:50:19', NULL, 'Active'),
(884, '1476505036', NULL, 'admin', NULL, '2016-10-15 12:17:16', NULL, 'Active'),
(885, '1476578134', NULL, 'admin', NULL, '2016-10-16 08:35:34', NULL, 'Active'),
(886, '1476585008', NULL, 'admin', NULL, '2016-10-16 10:30:08', NULL, 'Active'),
(887, '1476591076', NULL, 'admin', NULL, '2016-10-16 12:11:16', NULL, 'Active'),
(888, '1476592950', NULL, 'admin', NULL, '2016-10-16 12:42:30', NULL, 'Active'),
(889, '1476666131', NULL, 'admin', NULL, '2016-10-17 09:02:11', NULL, 'Active'),
(890, '1476680633', NULL, 'admin', NULL, '2016-10-17 13:03:53', NULL, 'Active'),
(891, '1476704001', NULL, 'admin', NULL, '2016-10-17 19:33:21', NULL, 'Active'),
(892, '1476839932', NULL, 'admin', NULL, '2016-10-19 09:18:52', NULL, 'Active'),
(893, '1476843247', NULL, 'admin', NULL, '2016-10-19 10:14:07', NULL, 'Active'),
(894, '1476853703', NULL, 'admin', NULL, '2016-10-19 13:08:23', NULL, 'Active'),
(895, '1476860642', NULL, 'admin', NULL, '2016-10-19 15:04:02', NULL, 'Active'),
(896, '1476925373', NULL, 'admin', NULL, '2016-10-20 09:02:53', NULL, 'Active'),
(897, '1476929641', NULL, 'admin', NULL, '2016-10-20 10:14:01', NULL, 'Active'),
(898, '1476941852', NULL, 'admin', NULL, '2016-10-20 13:37:32', NULL, 'Active'),
(899, '1476946160', NULL, 'admin', NULL, '2016-10-20 14:49:20', NULL, 'Active'),
(900, '1476950035', NULL, 'admin', NULL, '2016-10-20 15:53:55', NULL, 'Active'),
(901, '1477012120', NULL, 'admin', NULL, '2016-10-21 09:08:40', NULL, 'Active'),
(902, '1477022052', NULL, 'admin', NULL, '2016-10-21 11:54:12', NULL, 'Active'),
(903, '1477032192', NULL, 'admin', NULL, '2016-10-21 14:43:12', NULL, 'Active'),
(904, '1477050597', NULL, 'admin', NULL, '2016-10-21 19:49:57', NULL, 'Active'),
(905, '1477098312', NULL, 'admin', NULL, '2016-10-22 09:05:12', NULL, 'Active'),
(906, '1477104610', NULL, 'admin', NULL, '2016-10-22 10:50:10', NULL, 'Active'),
(907, '1477115932', NULL, 'admin', NULL, '2016-10-22 13:58:52', NULL, 'Active'),
(908, '1477129686', NULL, 'admin', NULL, '2016-10-22 17:48:06', NULL, 'Active'),
(909, '1477184354', NULL, 'admin', NULL, '2016-10-23 08:59:14', NULL, 'Active'),
(910, '1477187572', NULL, 'admin', NULL, '2016-10-23 09:52:52', NULL, 'Active'),
(911, '1477187654', NULL, 'admin', NULL, '2016-10-23 09:54:14', NULL, 'Active'),
(912, '1477187734', NULL, 'admin', NULL, '2016-10-23 09:55:34', NULL, 'Active'),
(913, '1477191161', NULL, 'admin', NULL, '2016-10-23 10:52:41', NULL, 'Active'),
(914, '1477196420', NULL, 'admin', NULL, '2016-10-23 12:20:20', NULL, 'Active'),
(915, '1477198892', NULL, 'admin', NULL, '2016-10-23 13:01:32', NULL, 'Active'),
(916, '1477200211', NULL, 'admin', NULL, '2016-10-23 13:23:31', NULL, 'Active'),
(917, '1477219527', NULL, 'admin', NULL, '2016-10-23 18:45:27', NULL, 'Active'),
(918, '1477271840', NULL, 'admin', NULL, '2016-10-24 09:17:20', NULL, 'Active'),
(919, '1477279327', NULL, 'admin', NULL, '2016-10-24 11:22:07', NULL, 'Active'),
(920, '1477284302', NULL, 'admin', NULL, '2016-10-24 12:45:02', NULL, 'Active'),
(921, '1477287332', NULL, 'admin', NULL, '2016-10-24 13:35:32', NULL, 'Active'),
(922, '1477310901', NULL, 'admin', NULL, '2016-10-24 20:08:21', NULL, 'Active'),
(923, '1477444933', NULL, 'admin', NULL, '2016-10-26 09:22:13', NULL, 'Active'),
(924, '1477456053', NULL, 'admin', NULL, '2016-10-26 12:27:33', NULL, 'Active'),
(925, '1477530007', NULL, 'admin', NULL, '2016-10-27 09:00:07', NULL, 'Active'),
(926, '1477531714', NULL, 'admin', NULL, '2016-10-27 09:28:34', NULL, 'Active'),
(927, '1477542726', NULL, 'admin', NULL, '2016-10-27 12:32:06', NULL, 'Active'),
(928, '1477566367', NULL, 'admin', NULL, '2016-10-27 19:06:07', NULL, 'Active'),
(929, '1477615835', NULL, 'admin', NULL, '2016-10-28 08:50:35', NULL, 'Active'),
(930, '1477635614', NULL, 'admin', NULL, '2016-10-28 14:20:14', NULL, 'Active'),
(931, '1477656527', NULL, 'admin', NULL, '2016-10-28 20:08:47', NULL, 'Active'),
(932, '1477702887', NULL, 'admin', NULL, '2016-10-29 09:01:27', NULL, 'Active'),
(933, '1477708140', NULL, 'admin', NULL, '2016-10-29 10:29:00', NULL, 'Active'),
(934, '1477714307', NULL, 'admin', NULL, '2016-10-29 12:11:47', NULL, 'Active'),
(935, '1477716034', NULL, 'admin', NULL, '2016-10-29 12:40:34', NULL, 'Active'),
(936, '1477719603', NULL, 'admin', NULL, '2016-10-29 13:40:03', NULL, 'Active'),
(937, '1477788162', NULL, 'admin', NULL, '2016-10-30 08:42:42', NULL, 'Active'),
(938, '1477792371', NULL, 'admin', NULL, '2016-10-30 09:52:51', NULL, 'Active'),
(939, '1477796581', NULL, 'admin', NULL, '2016-10-30 11:03:01', NULL, 'Active'),
(940, '1477797817', NULL, 'admin', NULL, '2016-10-30 11:23:37', NULL, 'Active'),
(941, '1477804305', NULL, 'admin', NULL, '2016-10-30 13:11:45', NULL, 'Active'),
(942, '1477809200', NULL, 'admin', NULL, '2016-10-30 14:33:20', NULL, 'Active'),
(943, '1477831929', NULL, 'admin', NULL, '2016-10-30 20:52:09', NULL, 'Active'),
(944, '1477874906', NULL, 'admin', NULL, '2016-10-31 08:48:26', NULL, 'Active'),
(945, '1477884026', NULL, 'admin', NULL, '2016-10-31 11:20:26', NULL, 'Active'),
(946, '1477884683', NULL, 'admin', NULL, '2016-10-31 11:31:23', NULL, 'Active'),
(947, '1477890078', NULL, 'admin', NULL, '2016-10-31 13:01:18', NULL, 'Active'),
(948, '1477892543', NULL, 'admin', NULL, '2016-10-31 13:42:23', NULL, 'Active'),
(949, '1477907530', NULL, 'admin', NULL, '2016-10-31 17:52:10', NULL, 'Active'),
(950, '1478050101', NULL, 'admin', NULL, '2016-11-02 09:28:21', NULL, 'Active'),
(951, '1478063098', NULL, 'admin', NULL, '2016-11-02 13:04:58', NULL, 'Active'),
(952, '1478135267', NULL, 'admin', NULL, '2016-11-03 09:07:47', NULL, 'Active'),
(953, '1478221054', NULL, 'admin', NULL, '2016-11-04 08:57:34', NULL, 'Active'),
(954, '1478229899', NULL, 'admin', NULL, '2016-11-04 11:24:59', NULL, 'Active'),
(955, '1478239163', NULL, 'admin', NULL, '2016-11-04 13:59:23', NULL, 'Active'),
(956, '1478256345', NULL, 'admin', NULL, '2016-11-04 18:45:45', NULL, 'Active'),
(957, '1478307790', NULL, 'admin', NULL, '2016-11-05 09:03:10', NULL, 'Active'),
(958, '1478312821', NULL, 'admin', NULL, '2016-11-05 10:27:01', NULL, 'Active'),
(959, '1478315211', NULL, 'admin', NULL, '2016-11-05 11:06:51', NULL, 'Active'),
(960, '1478321270', NULL, 'admin', NULL, '2016-11-05 12:47:50', NULL, 'Active'),
(961, '1478346242', NULL, 'admin', NULL, '2016-11-05 19:44:02', NULL, 'Active'),
(962, '1478396082', NULL, 'admin', NULL, '2016-11-06 09:34:42', NULL, 'Active'),
(963, '1478402088', NULL, 'admin', NULL, '2016-11-06 11:14:48', NULL, 'Active'),
(964, '1478404070', NULL, 'admin', NULL, '2016-11-06 11:47:50', NULL, 'Active'),
(965, '1478407929', NULL, 'admin', NULL, '2016-11-06 12:52:09', NULL, 'Active'),
(966, '1478427999', NULL, 'admin', NULL, '2016-11-06 18:26:39', NULL, 'Active'),
(967, '1478480336', NULL, 'admin', NULL, '2016-11-07 08:58:56', NULL, 'Active'),
(968, '1478491786', NULL, 'admin', NULL, '2016-11-07 12:09:46', NULL, 'Active'),
(969, '1478520563', NULL, 'admin', NULL, '2016-11-07 20:09:23', NULL, 'Active'),
(970, '1478653797', NULL, 'admin', NULL, '2016-11-09 09:09:57', NULL, 'Active'),
(971, '1478660244', NULL, 'admin', NULL, '2016-11-09 10:57:24', NULL, 'Active'),
(972, '1478667259', NULL, 'admin', NULL, '2016-11-09 12:54:19', NULL, 'Active'),
(973, '1478739804', NULL, 'admin', NULL, '2016-11-10 09:03:24', NULL, 'Active'),
(974, '1478772270', NULL, 'admin', NULL, '2016-11-10 18:04:30', NULL, 'Active'),
(975, '1478786083', NULL, 'admin', NULL, '2016-11-10 21:54:43', NULL, 'Active'),
(976, '1478825502', NULL, 'admin', NULL, '2016-11-11 08:51:42', NULL, 'Active'),
(977, '1478839571', NULL, 'admin', NULL, '2016-11-11 12:46:11', NULL, 'Active'),
(978, '1478859943', NULL, 'admin', NULL, '2016-11-11 18:25:43', NULL, 'Active'),
(979, '1478911379', NULL, 'admin', NULL, '2016-11-12 08:42:59', NULL, 'Active'),
(980, '1478921809', NULL, 'admin', NULL, '2016-11-12 11:36:49', NULL, 'Active'),
(981, '1478925130', NULL, 'admin', NULL, '2016-11-12 12:32:10', NULL, 'Active'),
(982, '1478936667', NULL, 'admin', NULL, '2016-11-12 15:44:27', NULL, 'Active'),
(983, '1478999196', NULL, 'admin', NULL, '2016-11-13 09:06:36', NULL, 'Active'),
(984, '1479006951', NULL, 'admin', NULL, '2016-11-13 11:15:51', NULL, 'Active'),
(985, '1479010921', NULL, 'admin', NULL, '2016-11-13 12:22:01', NULL, 'Active'),
(986, '1479018307', NULL, 'admin', NULL, '2016-11-13 14:25:07', NULL, 'Active'),
(987, '1479085240', NULL, 'admin', NULL, '2016-11-14 09:00:40', NULL, 'Active'),
(988, '1479094199', NULL, 'admin', NULL, '2016-11-14 11:29:59', NULL, 'Active'),
(989, '1479097840', NULL, 'admin', NULL, '2016-11-14 12:30:40', NULL, 'Active'),
(990, '1479124695', NULL, 'admin', NULL, '2016-11-14 19:58:15', NULL, 'Active'),
(991, '1479260187', NULL, 'admin', NULL, '2016-11-16 09:36:27', NULL, 'Active'),
(992, '1479273066', NULL, 'admin', NULL, '2016-11-16 13:11:06', NULL, 'Active'),
(993, '1479273372', NULL, 'admin', NULL, '2016-11-16 13:16:12', NULL, 'Active'),
(994, '1479282653', NULL, 'admin', NULL, '2016-11-16 15:50:53', NULL, 'Active'),
(995, '1479344553', NULL, 'admin', NULL, '2016-11-17 09:02:33', NULL, 'Active'),
(996, '1479353349', NULL, 'admin', NULL, '2016-11-17 11:29:09', NULL, 'Active'),
(997, '1479383287', NULL, 'admin', NULL, '2016-11-17 19:48:07', NULL, 'Active'),
(998, '1479430813', NULL, 'admin', NULL, '2016-11-18 09:00:13', NULL, 'Active'),
(999, '1479439074', NULL, 'admin', NULL, '2016-11-18 11:17:54', NULL, 'Active'),
(1000, '1479517334', NULL, 'admin', NULL, '2016-11-19 09:02:14', NULL, 'Active'),
(1001, '1479526181', NULL, 'admin', NULL, '2016-11-19 11:29:41', NULL, 'Active'),
(1002, '1479527473', NULL, 'admin', NULL, '2016-11-19 11:51:13', NULL, 'Active'),
(1003, '1479535729', NULL, 'admin', NULL, '2016-11-19 14:08:49', NULL, 'Active'),
(1004, '1479541288', NULL, 'admin', NULL, '2016-11-19 15:41:28', NULL, 'Active'),
(1005, '1479561929', NULL, 'admin', NULL, '2016-11-19 21:25:29', NULL, 'Active'),
(1006, '1479603519', NULL, 'admin', NULL, '2016-11-20 08:58:39', NULL, 'Active'),
(1007, '1479610064', NULL, 'admin', NULL, '2016-11-20 10:47:44', NULL, 'Active'),
(1008, '1479613480', NULL, 'admin', NULL, '2016-11-20 11:44:40', NULL, 'Active'),
(1009, '1479619611', NULL, 'admin', NULL, '2016-11-20 13:26:51', NULL, 'Active'),
(1010, '1479631118', NULL, 'admin', NULL, '2016-11-20 16:38:38', NULL, 'Active'),
(1011, '1479689017', NULL, 'admin', NULL, '2016-11-21 08:43:37', NULL, 'Active'),
(1012, '1479695078', NULL, 'admin', NULL, '2016-11-21 10:24:38', NULL, 'Active'),
(1013, '1479700465', NULL, 'admin', NULL, '2016-11-21 11:54:25', NULL, 'Active'),
(1014, '1479704386', NULL, 'admin', NULL, '2016-11-21 12:59:46', NULL, 'Active'),
(1015, '1479706880', NULL, 'admin', NULL, '2016-11-21 13:41:20', NULL, 'Active'),
(1016, '1479725238', NULL, 'admin', NULL, '2016-11-21 18:47:18', NULL, 'Active'),
(1017, '1479727351', NULL, 'admin', NULL, '2016-11-21 19:22:31', NULL, 'Active'),
(1018, '1479727483', NULL, 'admin', NULL, '2016-11-21 19:24:43', NULL, 'Active'),
(1019, '1479729787', NULL, 'admin', NULL, '2016-11-21 20:03:07', NULL, 'Active'),
(1020, '1479862626', NULL, 'admin', NULL, '2016-11-23 08:57:06', NULL, 'Active'),
(1021, '1479874118', NULL, 'admin', NULL, '2016-11-23 12:08:38', NULL, 'Active'),
(1022, '1479948966', NULL, 'admin', NULL, '2016-11-24 08:56:06', NULL, 'Active'),
(1023, '1479962919', NULL, 'admin', NULL, '2016-11-24 12:48:39', NULL, 'Active'),
(1024, '1480036054', NULL, 'admin', NULL, '2016-11-25 09:07:34', NULL, 'Active'),
(1025, '1480043915', NULL, 'admin', NULL, '2016-11-25 11:18:35', NULL, 'Active'),
(1026, '1480119748', NULL, 'admin', NULL, '2016-11-26 08:22:28', NULL, 'Active'),
(1027, '1480127143', NULL, 'admin', NULL, '2016-11-26 10:25:43', NULL, 'Active'),
(1028, '1480138359', NULL, 'admin', NULL, '2016-11-26 13:32:39', NULL, 'Active'),
(1029, '1480147699', NULL, 'admin', NULL, '2016-11-26 16:08:19', NULL, 'Active'),
(1030, '1480205232', NULL, 'admin', NULL, '2016-11-27 08:07:12', NULL, 'Active'),
(1031, '1480221795', NULL, 'admin', NULL, '2016-11-27 12:43:15', NULL, 'Active'),
(1032, '1480237524', NULL, 'admin', NULL, '2016-11-27 17:05:24', NULL, 'Active'),
(1033, '1480294677', NULL, 'admin', NULL, '2016-11-28 08:57:57', NULL, 'Active'),
(1034, '1480307144', NULL, 'admin', NULL, '2016-11-28 12:25:44', NULL, 'Active'),
(1035, '1480467679', NULL, 'admin', NULL, '2016-11-30 09:01:19', NULL, 'Active'),
(1036, '1480483116', NULL, 'admin', NULL, '2016-11-30 13:18:36', NULL, 'Active'),
(1037, '1480553288', NULL, 'admin', NULL, '2016-12-01 08:48:08', NULL, 'Active'),
(1038, '1480559541', NULL, 'admin', NULL, '2016-12-01 10:32:21', NULL, 'Active'),
(1039, '1480570745', NULL, 'admin', NULL, '2016-12-01 13:39:05', NULL, 'Active'),
(1040, '1480641434', NULL, 'admin', NULL, '2016-12-02 09:17:14', NULL, 'Active'),
(1041, '1480654444', NULL, 'admin', NULL, '2016-12-02 12:54:04', NULL, 'Active'),
(1042, '1480656735', NULL, 'admin', NULL, '2016-12-02 13:32:15', NULL, 'Active'),
(1043, '1480684220', NULL, 'admin', NULL, '2016-12-02 21:10:20', NULL, 'Active'),
(1044, '1480726512', NULL, 'admin', NULL, '2016-12-03 08:55:12', NULL, 'Active'),
(1045, '1480759619', NULL, 'admin', NULL, '2016-12-03 18:06:59', NULL, 'Active'),
(1046, '1480813323', NULL, 'admin', NULL, '2016-12-04 09:02:03', NULL, 'Active'),
(1047, '1480826222', NULL, 'admin', NULL, '2016-12-04 12:37:02', NULL, 'Active'),
(1048, '1480847042', NULL, 'admin', NULL, '2016-12-04 18:24:02', NULL, 'Active'),
(1049, '1480899050', NULL, 'admin', NULL, '2016-12-05 08:50:50', NULL, 'Active'),
(1050, '1480920160', NULL, 'admin', NULL, '2016-12-05 14:42:40', NULL, 'Active'),
(1051, '1481072407', NULL, 'admin', NULL, '2016-12-07 09:00:07', NULL, 'Active'),
(1052, '1481093949', NULL, 'admin', NULL, '2016-12-07 14:59:09', NULL, 'Active'),
(1053, '1481158508', NULL, 'admin', NULL, '2016-12-08 08:55:08', NULL, 'Active'),
(1054, '1481177360', NULL, 'admin', NULL, '2016-12-08 14:09:20', NULL, 'Active'),
(1055, '1481245064', NULL, 'admin', NULL, '2016-12-09 08:57:44', NULL, 'Active'),
(1056, '1481330698', NULL, 'admin', NULL, '2016-12-10 08:44:58', NULL, 'Active'),
(1057, '1481333796', NULL, 'admin', NULL, '2016-12-10 09:36:36', NULL, 'Active'),
(1058, '1481340735', NULL, 'admin', NULL, '2016-12-10 11:32:15', NULL, 'Active'),
(1059, '1481349068', NULL, 'admin', NULL, '2016-12-10 13:51:08', NULL, 'Active'),
(1060, '1481358514', NULL, 'admin', NULL, '2016-12-10 16:28:34', NULL, 'Active'),
(1061, '1481417882', NULL, 'admin', NULL, '2016-12-11 08:58:02', NULL, 'Active'),
(1062, '1481431060', NULL, 'admin', NULL, '2016-12-11 12:37:40', NULL, 'Active'),
(1063, '1481433864', NULL, 'admin', NULL, '2016-12-11 13:24:24', NULL, 'Active'),
(1064, '1481442972', NULL, 'admin', NULL, '2016-12-11 15:56:12', NULL, 'Active'),
(1065, '1481504268', NULL, 'admin', NULL, '2016-12-12 08:57:48', NULL, 'Active'),
(1066, '1481508872', NULL, 'admin', NULL, '2016-12-12 10:14:32', NULL, 'Active'),
(1067, '1481511523', NULL, 'admin', NULL, '2016-12-12 10:58:43', NULL, 'Active'),
(1068, '1481517910', NULL, 'admin', NULL, '2016-12-12 12:45:10', NULL, 'Active'),
(1069, '1481549280', NULL, 'admin', NULL, '2016-12-12 21:28:00', NULL, 'Active'),
(1070, '1481675417', NULL, 'admin', NULL, '2016-12-14 08:30:17', NULL, 'Active'),
(1071, '1481765847', NULL, 'admin', NULL, '2016-12-15 09:37:27', NULL, 'Active'),
(1072, '1481780716', NULL, 'admin', NULL, '2016-12-15 13:45:16', NULL, 'Active'),
(1073, '1481849558', NULL, 'admin', NULL, '2016-12-16 08:52:38', NULL, 'Active'),
(1074, '1481860706', NULL, 'admin', NULL, '2016-12-16 11:58:26', NULL, 'Active'),
(1075, '1481865247', NULL, 'admin', NULL, '2016-12-16 13:14:07', NULL, 'Active'),
(1076, '1481870880', NULL, 'admin', NULL, '2016-12-16 14:48:00', NULL, 'Active'),
(1077, '1481937517', NULL, 'admin', NULL, '2016-12-17 09:18:37', NULL, 'Active'),
(1078, '1481947331', NULL, 'admin', NULL, '2016-12-17 12:02:11', NULL, 'Active'),
(1079, '1481955926', NULL, 'admin', NULL, '2016-12-17 14:25:26', NULL, 'Active'),
(1080, '1481969579', NULL, 'admin', NULL, '2016-12-17 18:12:59', NULL, 'Active'),
(1081, '1481975059', NULL, 'admin', NULL, '2016-12-17 19:44:19', NULL, 'Active'),
(1082, '1481976364', NULL, 'admin', NULL, '2016-12-17 20:06:04', NULL, 'Active'),
(1083, '1481980912', NULL, 'admin', NULL, '2016-12-17 21:21:52', NULL, 'Active'),
(1084, '1482023117', NULL, 'admin', NULL, '2016-12-18 09:05:17', NULL, 'Active'),
(1085, '1482027003', NULL, 'admin', NULL, '2016-12-18 10:10:03', NULL, 'Active'),
(1086, '1482031800', NULL, 'admin', NULL, '2016-12-18 11:30:00', NULL, 'Active'),
(1087, '1482038063', NULL, 'admin', NULL, '2016-12-18 13:14:23', NULL, 'Active'),
(1088, '1482038105', NULL, 'admin', NULL, '2016-12-18 13:15:05', NULL, 'Active'),
(1089, '1482043163', NULL, 'admin', NULL, '2016-12-18 14:39:23', NULL, 'Active'),
(1090, '1482047063', NULL, 'admin', NULL, '2016-12-18 15:44:23', NULL, 'Active'),
(1091, '1482108039', NULL, 'admin', NULL, '2016-12-19 08:40:39', NULL, 'Active'),
(1092, '1482123243', NULL, 'admin', NULL, '2016-12-19 12:54:03', NULL, 'Active'),
(1093, '1482143290', NULL, 'admin', NULL, '2016-12-19 18:28:10', NULL, 'Active'),
(1094, '1482282399', NULL, 'admin', NULL, '2016-12-21 09:06:39', NULL, 'Active'),
(1095, '1482289636', NULL, 'admin', NULL, '2016-12-21 11:07:16', NULL, 'Active'),
(1096, '1482368000', NULL, 'admin', NULL, '2016-12-22 08:53:20', NULL, 'Active'),
(1097, '1482374420', NULL, 'admin', NULL, '2016-12-22 10:40:20', NULL, 'Active'),
(1098, '1482377945', NULL, 'admin', NULL, '2016-12-22 11:39:05', NULL, 'Active'),
(1099, '1482406639', NULL, 'admin', NULL, '2016-12-22 19:37:19', NULL, 'Active'),
(1100, '1482454049', NULL, 'admin', NULL, '2016-12-23 08:47:29', NULL, 'Active'),
(1101, '1482469715', NULL, 'admin', NULL, '2016-12-23 13:08:35', NULL, 'Active'),
(1102, '1482471260', NULL, 'admin', NULL, '2016-12-23 13:34:20', NULL, 'Active'),
(1103, '1482489687', NULL, 'admin', NULL, '2016-12-23 18:41:27', NULL, 'Active'),
(1104, '1482491589', NULL, 'admin', NULL, '2016-12-23 19:13:09', NULL, 'Active'),
(1105, '1482539999', NULL, 'admin', NULL, '2016-12-24 08:39:59', NULL, 'Active'),
(1106, '1482545207', NULL, 'admin', NULL, '2016-12-24 10:06:47', NULL, 'Active'),
(1107, '1482550694', NULL, 'admin', NULL, '2016-12-24 11:38:14', NULL, 'Active'),
(1108, '1482558814', NULL, 'admin', NULL, '2016-12-24 13:53:34', NULL, 'Active'),
(1109, '1482577544', NULL, 'admin', NULL, '2016-12-24 19:05:44', NULL, 'Active'),
(1110, '1482580080', NULL, 'admin', NULL, '2016-12-24 19:48:00', NULL, 'Active'),
(1111, '1482626290', NULL, 'admin', NULL, '2016-12-25 08:38:10', NULL, 'Active'),
(1112, '1482633309', NULL, 'admin', NULL, '2016-12-25 10:35:09', NULL, 'Active'),
(1113, '1482643824', NULL, 'admin', NULL, '2016-12-25 13:30:24', NULL, 'Active'),
(1114, '1482651451', NULL, 'admin', NULL, '2016-12-25 15:37:31', NULL, 'Active'),
(1115, '1482665607', NULL, 'admin', NULL, '2016-12-25 19:33:27', NULL, 'Active'),
(1116, '1482714671', NULL, 'admin', NULL, '2016-12-26 09:11:11', NULL, 'Active'),
(1117, '1482720017', NULL, 'admin', NULL, '2016-12-26 10:40:17', NULL, 'Active'),
(1118, '1482723982', NULL, 'admin', NULL, '2016-12-26 11:46:22', NULL, 'Active'),
(1119, '1482726139', NULL, 'admin', NULL, '2016-12-26 12:22:19', NULL, 'Active'),
(1120, '1482732853', NULL, 'admin', NULL, '2016-12-26 14:14:13', NULL, 'Active'),
(1121, '1482886119', NULL, 'admin', NULL, '2016-12-28 08:48:39', NULL, 'Active'),
(1122, '1482898671', NULL, 'admin', NULL, '2016-12-28 12:17:51', NULL, 'Active'),
(1123, '1482904042', NULL, 'admin', NULL, '2016-12-28 13:47:22', NULL, 'Active'),
(1124, '1482920800', NULL, 'admin', NULL, '2016-12-28 18:26:40', NULL, 'Active'),
(1125, '1482972161', NULL, 'admin', NULL, '2016-12-29 08:42:41', NULL, 'Active'),
(1126, '1482980530', NULL, 'admin', NULL, '2016-12-29 11:02:10', NULL, 'Active'),
(1127, '1483059938', NULL, 'admin', NULL, '2016-12-30 09:05:38', NULL, 'Active'),
(1128, '1483066124', NULL, 'admin', NULL, '2016-12-30 10:48:44', NULL, 'Active'),
(1129, '1483145031', NULL, 'admin', NULL, '2016-12-31 08:43:51', NULL, 'Active'),
(1130, '1483150102', NULL, 'admin', NULL, '2016-12-31 10:08:22', NULL, 'Active'),
(1131, '1483152735', NULL, 'admin', NULL, '2016-12-31 10:52:15', NULL, 'Active'),
(1132, '1483160790', NULL, 'admin', NULL, '2016-12-31 13:06:30', NULL, 'Active'),
(1133, '1483162069', NULL, 'admin', NULL, '2016-12-31 13:27:49', NULL, 'Active'),
(1134, '1483164662', NULL, 'admin', NULL, '2016-12-31 14:11:02', NULL, 'Active'),
(1135, '1483188687', NULL, 'admin', NULL, '2016-12-31 20:51:27', NULL, 'Active'),
(1136, '1483188899', NULL, 'admin', NULL, '2016-12-31 20:54:59', NULL, 'Active'),
(1137, '1483188930', NULL, 'admin', NULL, '2016-12-31 20:55:30', NULL, 'Active'),
(1138, '1483235175', NULL, 'admin', NULL, '2017-01-01 09:46:15', NULL, 'Active'),
(1139, '1483241065', NULL, 'admin', NULL, '2017-01-01 11:24:25', NULL, 'Active'),
(1140, '1483249653', NULL, 'admin', NULL, '2017-01-01 13:47:33', NULL, 'Active'),
(1141, '1483251145', NULL, 'admin', NULL, '2017-01-01 14:12:25', NULL, 'Active'),
(1142, '1483255690', NULL, 'admin', NULL, '2017-01-01 15:28:10', NULL, 'Active'),
(1143, '1483318311', NULL, 'admin', NULL, '2017-01-02 08:51:51', NULL, 'Active'),
(1144, '1483323276', NULL, 'admin', NULL, '2017-01-02 10:14:36', NULL, 'Active'),
(1145, '1483325183', NULL, 'admin', NULL, '2017-01-02 10:46:23', NULL, 'Active'),
(1146, '1483328805', NULL, 'admin', NULL, '2017-01-02 11:46:45', NULL, 'Active'),
(1147, '1483337473', NULL, 'admin', NULL, '2017-01-02 14:11:13', NULL, 'Active'),
(1148, '1483490976', NULL, 'admin', NULL, '2017-01-04 08:49:36', NULL, 'Active'),
(1149, '1483495692', NULL, 'admin', NULL, '2017-01-04 10:08:12', NULL, 'Active'),
(1150, '1483498550', NULL, 'admin', NULL, '2017-01-04 10:55:50', NULL, 'Active'),
(1151, '1483509082', NULL, 'admin', NULL, '2017-01-04 13:51:22', NULL, 'Active'),
(1152, '1483577547', NULL, 'admin', NULL, '2017-01-05 08:52:27', NULL, 'Active'),
(1153, '1483585789', NULL, 'admin', NULL, '2017-01-05 11:09:49', NULL, 'Active'),
(1154, '1483592351', NULL, 'admin', NULL, '2017-01-05 12:59:11', NULL, 'Active'),
(1155, '1483663548', NULL, 'admin', NULL, '2017-01-06 08:45:48', NULL, 'Active'),
(1156, '1483667834', NULL, 'admin', NULL, '2017-01-06 09:57:14', NULL, 'Active'),
(1157, '1483669204', NULL, 'admin', NULL, '2017-01-06 10:20:04', NULL, 'Active'),
(1158, '1483677214', NULL, 'admin', NULL, '2017-01-06 12:33:34', NULL, 'Active'),
(1159, '1483749998', NULL, 'admin', NULL, '2017-01-07 08:46:38', NULL, 'Active'),
(1160, '1483757539', NULL, 'admin', NULL, '2017-01-07 10:52:19', NULL, 'Active'),
(1161, '1483792488', NULL, 'admin', NULL, '2017-01-07 20:34:48', NULL, 'Active'),
(1162, '1483835930', NULL, 'admin', NULL, '2017-01-08 08:38:50', NULL, 'Active'),
(1163, '1483837180', NULL, 'admin', NULL, '2017-01-08 08:59:40', NULL, 'Active'),
(1164, '1483841634', NULL, 'admin', NULL, '2017-01-08 10:13:54', NULL, 'Active'),
(1165, '1483843180', NULL, 'admin', NULL, '2017-01-08 10:39:40', NULL, 'Active'),
(1166, '1483846564', NULL, 'admin', NULL, '2017-01-08 11:36:04', NULL, 'Active'),
(1167, '1483850176', NULL, 'admin', NULL, '2017-01-08 12:36:16', NULL, 'Active'),
(1168, '1483854060', NULL, 'admin', NULL, '2017-01-08 13:41:00', NULL, 'Active'),
(1169, '1483861285', NULL, 'admin', NULL, '2017-01-08 15:41:25', NULL, 'Active'),
(1170, '1483877732', NULL, 'admin', NULL, '2017-01-08 20:15:32', NULL, 'Active'),
(1171, '1483924068', NULL, 'admin', NULL, '2017-01-09 09:07:48', NULL, 'Active'),
(1172, '1483933558', NULL, 'admin', NULL, '2017-01-09 11:45:58', NULL, 'Active'),
(1173, '1484096007', NULL, 'admin', NULL, '2017-01-11 08:53:27', NULL, 'Active'),
(1174, '1484111829', NULL, 'admin', NULL, '2017-01-11 13:17:09', NULL, 'Active'),
(1175, '1484116267', NULL, 'admin', NULL, '2017-01-11 14:31:07', NULL, 'Active'),
(1176, '1484183322', NULL, 'admin', NULL, '2017-01-12 09:08:42', NULL, 'Active'),
(1177, '1484195308', NULL, 'admin', NULL, '2017-01-12 12:28:28', NULL, 'Active'),
(1178, '1484269647', NULL, 'admin', NULL, '2017-01-13 09:07:27', NULL, 'Active'),
(1179, '1484279630', NULL, 'admin', NULL, '2017-01-13 11:53:50', NULL, 'Active'),
(1180, '1484354338', NULL, 'admin', NULL, '2017-01-14 08:38:58', NULL, 'Active'),
(1181, '1484360491', NULL, 'admin', NULL, '2017-01-14 10:21:31', NULL, 'Active'),
(1182, '1484363814', NULL, 'admin', NULL, '2017-01-14 11:16:54', NULL, 'Active'),
(1183, '1484375582', NULL, 'admin', NULL, '2017-01-14 14:33:02', NULL, 'Active'),
(1184, '1484440961', NULL, 'admin', NULL, '2017-01-15 08:42:41', NULL, 'Active'),
(1185, '1484448920', NULL, 'admin', NULL, '2017-01-15 10:55:20', NULL, 'Active'),
(1186, '1484452819', NULL, 'admin', NULL, '2017-01-15 12:00:19', NULL, 'Active'),
(1187, '1484454419', NULL, 'admin', NULL, '2017-01-15 12:26:59', NULL, 'Active'),
(1188, '1484528783', NULL, 'admin', NULL, '2017-01-16 09:06:23', NULL, 'Active'),
(1189, '1484555618', NULL, 'admin', NULL, '2017-01-16 16:33:38', NULL, 'Active'),
(1190, '1484568062', NULL, 'admin', NULL, '2017-01-16 20:01:02', NULL, 'Active'),
(1191, '1484699744', NULL, 'admin', NULL, '2017-01-18 08:35:44', NULL, 'Active'),
(1192, '1484712110', NULL, 'admin', NULL, '2017-01-18 12:01:50', NULL, 'Active'),
(1193, '1484712158', NULL, 'admin', NULL, '2017-01-18 12:02:38', NULL, 'Active'),
(1194, '1484716636', NULL, 'admin', NULL, '2017-01-18 13:17:16', NULL, 'Active'),
(1195, '1484788176', NULL, 'admin', NULL, '2017-01-19 09:09:36', NULL, 'Active'),
(1196, '1484802394', NULL, 'admin', NULL, '2017-01-19 13:06:34', NULL, 'Active'),
(1197, '1484804348', NULL, 'admin', NULL, '2017-01-19 13:39:08', NULL, 'Active'),
(1198, '1484822774', NULL, 'admin', NULL, '2017-01-19 18:46:14', NULL, 'Active'),
(1199, '1484829296', NULL, 'admin', NULL, '2017-01-19 20:34:56', NULL, 'Active'),
(1200, '1484872968', NULL, 'admin', NULL, '2017-01-20 08:42:48', NULL, 'Active'),
(1201, '1484883241', NULL, 'admin', NULL, '2017-01-20 11:34:01', NULL, 'Active'),
(1202, '1484890125', NULL, 'admin', NULL, '2017-01-20 13:28:45', NULL, 'Active'),
(1203, '1484961232', NULL, 'admin', NULL, '2017-01-21 09:13:52', NULL, 'Active'),
(1204, '1484964617', NULL, 'admin', NULL, '2017-01-21 10:10:17', NULL, 'Active'),
(1205, '1484969658', NULL, 'admin', NULL, '2017-01-21 11:34:18', NULL, 'Active'),
(1206, '1484978263', NULL, 'admin', NULL, '2017-01-21 13:57:43', NULL, 'Active'),
(1207, '1485046061', NULL, 'admin', NULL, '2017-01-22 08:47:41', NULL, 'Active'),
(1208, '1485049904', NULL, 'admin', NULL, '2017-01-22 09:51:44', NULL, 'Active'),
(1209, '1485053010', NULL, 'admin', NULL, '2017-01-22 10:43:30', NULL, 'Active'),
(1210, '1485059698', NULL, 'admin', NULL, '2017-01-22 12:34:58', NULL, 'Active'),
(1211, '1485066722', NULL, 'admin', NULL, '2017-01-22 14:32:02', NULL, 'Active'),
(1212, '1485133228', NULL, 'admin', NULL, '2017-01-23 09:00:28', NULL, 'Active'),
(1213, '1485142394', NULL, 'admin', NULL, '2017-01-23 11:33:14', NULL, 'Active'),
(1214, '1485145022', NULL, 'admin', NULL, '2017-01-23 12:17:02', NULL, 'Active'),
(1215, '1485305093', NULL, 'admin', NULL, '2017-01-25 08:44:53', NULL, 'Active'),
(1216, '1485312624', NULL, 'admin', NULL, '2017-01-25 10:50:24', NULL, 'Active'),
(1217, '1485316211', NULL, 'admin', NULL, '2017-01-25 11:50:11', NULL, 'Active'),
(1218, '1485839089', NULL, 'admin', NULL, '2017-01-31 13:04:49', NULL, 'Active'),
(1219, '1485910955', NULL, 'admin', NULL, '2017-02-01 09:02:35', NULL, 'Active'),
(1220, '1485922837', NULL, 'admin', NULL, '2017-02-01 12:20:37', NULL, 'Active'),
(1221, '1485929099', NULL, 'admin', NULL, '2017-02-01 14:04:59', NULL, 'Active'),
(1222, '1485996940', NULL, 'admin', NULL, '2017-02-02 08:55:40', NULL, 'Active'),
(1223, '1486003081', NULL, 'admin', NULL, '2017-02-02 10:38:01', NULL, 'Active'),
(1224, '1486011162', NULL, 'admin', NULL, '2017-02-02 12:52:42', NULL, 'Active'),
(1225, '1486018292', NULL, 'admin', NULL, '2017-02-02 14:51:32', NULL, 'Active'),
(1226, '1486083430', NULL, 'admin', NULL, '2017-02-03 08:57:10', NULL, 'Active'),
(1227, '1486090908', NULL, 'admin', NULL, '2017-02-03 11:01:48', NULL, 'Active'),
(1228, '1486100235', NULL, 'admin', NULL, '2017-02-03 13:37:15', NULL, 'Active'),
(1229, '1486103352', NULL, 'admin', NULL, '2017-02-03 14:29:12', NULL, 'Active'),
(1230, '1486117870', NULL, 'admin', NULL, '2017-02-03 18:31:10', NULL, 'Active'),
(1231, '1486169067', NULL, 'admin', NULL, '2017-02-04 08:44:27', NULL, 'Active'),
(1232, '1486173135', NULL, 'admin', NULL, '2017-02-04 09:52:15', NULL, 'Active'),
(1233, '1486179464', NULL, 'admin', NULL, '2017-02-04 11:37:44', NULL, 'Active'),
(1234, '1486182430', NULL, 'admin', NULL, '2017-02-04 12:27:10', NULL, 'Active'),
(1235, '1486185769', NULL, 'admin', NULL, '2017-02-04 13:22:49', NULL, 'Active'),
(1236, '1486190504', NULL, 'admin', NULL, '2017-02-04 14:41:44', NULL, 'Active'),
(1237, '1486255314', NULL, 'admin', NULL, '2017-02-05 08:41:54', NULL, 'Active'),
(1238, '1486268857', NULL, 'admin', NULL, '2017-02-05 12:27:37', NULL, 'Active'),
(1239, '1486270446', NULL, 'admin', NULL, '2017-02-05 12:54:06', NULL, 'Active'),
(1240, '1486271966', NULL, 'admin', NULL, '2017-02-05 13:19:26', NULL, 'Active'),
(1241, '1486274323', NULL, 'admin', NULL, '2017-02-05 13:58:43', NULL, 'Active'),
(1242, '1486277816', NULL, 'admin', NULL, '2017-02-05 14:56:56', NULL, 'Active'),
(1243, '1486301152', NULL, 'admin', NULL, '2017-02-05 21:25:52', NULL, 'Active'),
(1244, '1486344182', NULL, 'admin', NULL, '2017-02-06 09:23:02', NULL, 'Active'),
(1245, '1486357499', NULL, 'admin', NULL, '2017-02-06 13:04:59', NULL, 'Active'),
(1246, '1486362600', NULL, 'admin', NULL, '2017-02-06 14:30:00', NULL, 'Active'),
(1247, '1486515364', NULL, 'admin', NULL, '2017-02-08 08:56:04', NULL, 'Active'),
(1248, '1486529137', NULL, 'admin', NULL, '2017-02-08 12:45:37', NULL, 'Active'),
(1249, '1486602045', NULL, 'admin', NULL, '2017-02-09 09:00:45', NULL, 'Active'),
(1250, '1486608066', NULL, 'admin', NULL, '2017-02-09 10:41:06', NULL, 'Active'),
(1251, '1486608082', NULL, 'admin', NULL, '2017-02-09 10:41:22', NULL, 'Active'),
(1252, '1486625682', NULL, 'admin', NULL, '2017-02-09 15:34:42', NULL, 'Active'),
(1253, '1486688167', NULL, 'admin', NULL, '2017-02-10 08:56:07', NULL, 'Active'),
(1254, '1486694545', NULL, 'admin', NULL, '2017-02-10 10:42:25', NULL, 'Active'),
(1255, '1486705713', NULL, 'admin', NULL, '2017-02-10 13:48:33', NULL, 'Active'),
(1256, '1486729206', NULL, 'admin', NULL, '2017-02-10 20:20:06', NULL, 'Active'),
(1257, '1486774660', NULL, 'admin', NULL, '2017-02-11 08:57:40', NULL, 'Active'),
(1258, '1486781920', NULL, 'admin', NULL, '2017-02-11 10:58:40', NULL, 'Active');
INSERT INTO `sales_sessions` (`id`, `identifier`, `session`, `logged_in_by`, `logged_out_by`, `from`, `to`, `status`) VALUES
(1259, '1486791391', NULL, 'admin', NULL, '2017-02-11 13:36:31', NULL, 'Active'),
(1260, '1486807745', NULL, 'admin', NULL, '2017-02-11 18:09:05', NULL, 'Active'),
(1261, '1486861609', NULL, 'admin', NULL, '2017-02-12 09:06:49', NULL, 'Active'),
(1262, '1486869507', NULL, 'admin', NULL, '2017-02-12 11:18:27', NULL, 'Active'),
(1263, '1486873925', NULL, 'admin', NULL, '2017-02-12 12:32:05', NULL, 'Active'),
(1264, '1486880131', NULL, 'admin', NULL, '2017-02-12 14:15:31', NULL, 'Active'),
(1265, '1486945644', NULL, 'admin', NULL, '2017-02-13 08:27:24', NULL, 'Active'),
(1266, '1486956031', NULL, 'admin', NULL, '2017-02-13 11:20:31', NULL, 'Active'),
(1267, '1486962836', NULL, 'admin', NULL, '2017-02-13 13:13:56', NULL, 'Active'),
(1268, '1487120746', NULL, 'admin', NULL, '2017-02-15 09:05:46', NULL, 'Active'),
(1269, '1487130775', NULL, 'admin', NULL, '2017-02-15 11:52:55', NULL, 'Active'),
(1270, '1487134777', NULL, 'admin', NULL, '2017-02-15 12:59:37', NULL, 'Active'),
(1271, '1487206907', NULL, 'admin', NULL, '2017-02-16 09:01:47', NULL, 'Active'),
(1272, '1487215491', NULL, 'admin', NULL, '2017-02-16 11:24:51', NULL, 'Active'),
(1273, '1487293216', NULL, 'admin', NULL, '2017-02-17 09:00:16', NULL, 'Active'),
(1274, '1487300076', NULL, 'admin', NULL, '2017-02-17 10:54:36', NULL, 'Active'),
(1275, '1487305904', NULL, 'admin', NULL, '2017-02-17 12:31:44', NULL, 'Active'),
(1276, '1487308134', NULL, 'admin', NULL, '2017-02-17 13:08:54', NULL, 'Active'),
(1277, '1487379229', NULL, 'admin', NULL, '2017-02-18 08:53:49', NULL, 'Active'),
(1278, '1487386808', NULL, 'admin', NULL, '2017-02-18 11:00:08', NULL, 'Active'),
(1279, '1487389486', NULL, 'admin', NULL, '2017-02-18 11:44:46', NULL, 'Active'),
(1280, '1487392068', NULL, 'admin', NULL, '2017-02-18 12:27:48', NULL, 'Active'),
(1281, '1487395910', NULL, 'admin', NULL, '2017-02-18 13:31:50', NULL, 'Active'),
(1282, '1487397442', NULL, 'admin', NULL, '2017-02-18 13:57:22', NULL, 'Active'),
(1283, '1487418467', NULL, 'admin', NULL, '2017-02-18 19:47:47', NULL, 'Active'),
(1284, '1487465265', NULL, 'admin', NULL, '2017-02-19 08:47:45', NULL, 'Active'),
(1285, '1487474314', NULL, 'admin', NULL, '2017-02-19 11:18:34', NULL, 'Active'),
(1286, '1487477240', NULL, 'admin', NULL, '2017-02-19 12:07:20', NULL, 'Active'),
(1287, '1487478945', NULL, 'admin', NULL, '2017-02-19 12:35:45', NULL, 'Active'),
(1288, '1487486050', NULL, 'admin', NULL, '2017-02-19 14:34:10', NULL, 'Active'),
(1289, '1487495165', NULL, 'admin', NULL, '2017-02-19 17:06:05', NULL, 'Active'),
(1290, '1487550909', NULL, 'admin', NULL, '2017-02-20 08:35:09', NULL, 'Active'),
(1291, '1487564551', NULL, 'admin', NULL, '2017-02-20 12:22:31', NULL, 'Active'),
(1292, '1487589252', NULL, 'admin', NULL, '2017-02-20 19:14:12', NULL, 'Active'),
(1293, '1487726054', NULL, 'admin', NULL, '2017-02-22 09:14:14', NULL, 'Active'),
(1294, '1487810252', NULL, 'admin', NULL, '2017-02-23 08:37:32', NULL, 'Active'),
(1295, '1487830626', NULL, 'admin', NULL, '2017-02-23 14:17:06', NULL, 'Active'),
(1296, '1487852013', NULL, 'admin', NULL, '2017-02-23 20:13:33', NULL, 'Active'),
(1297, '1487896883', NULL, 'admin', NULL, '2017-02-24 08:41:23', NULL, 'Active'),
(1298, '1487906895', NULL, 'admin', NULL, '2017-02-24 11:28:15', NULL, 'Active'),
(1299, '1487913138', NULL, 'admin', NULL, '2017-02-24 13:12:18', NULL, 'Active'),
(1300, '1487938890', NULL, 'admin', NULL, '2017-02-24 20:21:30', NULL, 'Active'),
(1301, '1487984790', NULL, 'admin', NULL, '2017-02-25 09:06:30', NULL, 'Active'),
(1302, '1487988459', NULL, 'admin', NULL, '2017-02-25 10:07:39', NULL, 'Active'),
(1303, '1487994990', NULL, 'admin', NULL, '2017-02-25 11:56:30', NULL, 'Active'),
(1304, '1488000130', NULL, 'admin', NULL, '2017-02-25 13:22:10', NULL, 'Active'),
(1305, '1488002678', NULL, 'admin', NULL, '2017-02-25 14:04:38', NULL, 'Active'),
(1306, '1488004602', NULL, 'admin', NULL, '2017-02-25 14:36:42', NULL, 'Active'),
(1307, '1488021498', NULL, 'admin', NULL, '2017-02-25 19:18:18', NULL, 'Active'),
(1308, '1488070900', NULL, 'admin', NULL, '2017-02-26 09:01:40', NULL, 'Active'),
(1309, '1488074363', NULL, 'admin', NULL, '2017-02-26 09:59:23', NULL, 'Active'),
(1310, '1488093337', NULL, 'admin', NULL, '2017-02-26 15:15:37', NULL, 'Active'),
(1311, '1488093351', NULL, 'admin', NULL, '2017-02-26 15:15:51', NULL, 'Active'),
(1312, '1488156993', NULL, 'admin', NULL, '2017-02-27 08:56:33', NULL, 'Active'),
(1313, '1488171734', NULL, 'admin', NULL, '2017-02-27 13:02:14', NULL, 'Active'),
(1314, '1488192900', NULL, 'admin', NULL, '2017-02-27 18:55:00', NULL, 'Active'),
(1315, '1488328212', NULL, 'admin', NULL, '2017-03-01 08:30:12', NULL, 'Active'),
(1316, '1488344010', NULL, 'admin', NULL, '2017-03-01 12:53:30', NULL, 'Active'),
(1317, '1488351757', NULL, 'admin', NULL, '2017-03-01 15:02:37', NULL, 'Active'),
(1318, '1488416323', NULL, 'admin', NULL, '2017-03-02 08:58:43', NULL, 'Active'),
(1319, '1488421861', NULL, 'admin', NULL, '2017-03-02 10:31:01', NULL, 'Active'),
(1320, '1488450701', NULL, 'admin', NULL, '2017-03-02 18:31:41', NULL, 'Active'),
(1321, '1488503650', NULL, 'admin', NULL, '2017-03-03 09:14:10', NULL, 'Active'),
(1322, '1488510217', NULL, 'admin', NULL, '2017-03-03 11:03:37', NULL, 'Active'),
(1323, '1488514799', NULL, 'admin', NULL, '2017-03-03 12:19:59', NULL, 'Active'),
(1324, '1488518799', NULL, 'admin', NULL, '2017-03-03 13:26:39', NULL, 'Active'),
(1325, '1488588848', NULL, 'admin', NULL, '2017-03-04 08:54:08', NULL, 'Active'),
(1326, '1488593894', NULL, 'admin', NULL, '2017-03-04 10:18:14', NULL, 'Active'),
(1327, '1488595909', NULL, 'admin', NULL, '2017-03-04 10:51:49', NULL, 'Active'),
(1328, '1488599397', NULL, 'admin', NULL, '2017-03-04 11:49:57', NULL, 'Active'),
(1329, '1488603664', NULL, 'admin', NULL, '2017-03-04 13:01:04', NULL, 'Active'),
(1330, '1488608002', NULL, 'admin', NULL, '2017-03-04 14:13:22', NULL, 'Active'),
(1331, '1488674581', NULL, 'admin', NULL, '2017-03-05 08:43:01', NULL, 'Active'),
(1332, '1488678420', NULL, 'admin', NULL, '2017-03-05 09:47:00', NULL, 'Active'),
(1333, '1488680401', NULL, 'admin', NULL, '2017-03-05 10:20:01', NULL, 'Active'),
(1334, '1488683386', NULL, 'admin', NULL, '2017-03-05 11:09:46', NULL, 'Active'),
(1335, '1488685968', NULL, 'admin', NULL, '2017-03-05 11:52:48', NULL, 'Active'),
(1336, '1488687133', NULL, 'admin', NULL, '2017-03-05 12:12:13', NULL, 'Active'),
(1337, '1488692103', NULL, 'admin', NULL, '2017-03-05 13:35:03', NULL, 'Active'),
(1338, '1488702266', NULL, 'admin', NULL, '2017-03-05 16:24:26', NULL, 'Active'),
(1339, '1488762280', NULL, 'admin', NULL, '2017-03-06 09:04:40', NULL, 'Active'),
(1340, '1488767651', NULL, 'admin', NULL, '2017-03-06 10:34:11', NULL, 'Active'),
(1341, '1488774486', NULL, 'admin', NULL, '2017-03-06 12:28:06', NULL, 'Active'),
(1342, '1488777303', NULL, 'admin', NULL, '2017-03-06 13:15:03', NULL, 'Active'),
(1343, '1488938904', NULL, 'admin', NULL, '2017-03-08 10:08:24', NULL, 'Active'),
(1344, '1488948551', NULL, 'admin', NULL, '2017-03-08 12:49:11', NULL, 'Active'),
(1345, '1488953146', NULL, 'admin', NULL, '2017-03-08 14:05:46', NULL, 'Active'),
(1346, '1488959498', NULL, 'admin', NULL, '2017-03-08 15:51:38', NULL, 'Active'),
(1347, '1489020426', NULL, 'admin', NULL, '2017-03-09 08:47:06', NULL, 'Active'),
(1348, '1489034323', NULL, 'admin', NULL, '2017-03-09 12:38:43', NULL, 'Active'),
(1349, '1489107002', NULL, 'lois', NULL, '2017-03-10 08:50:02', NULL, 'Active'),
(1350, '1489123543', NULL, 'admin', NULL, '2017-03-10 13:25:43', NULL, 'Active'),
(1351, '1489194179', NULL, 'admin', NULL, '2017-03-11 09:02:59', NULL, 'Active'),
(1352, '1489200450', NULL, 'admin', NULL, '2017-03-11 10:47:30', NULL, 'Active'),
(1353, '1489202449', NULL, 'admin', NULL, '2017-03-11 11:20:49', NULL, 'Active'),
(1354, '1489212539', NULL, 'admin', NULL, '2017-03-11 14:08:59', NULL, 'Active'),
(1355, '1489280563', NULL, 'admin', NULL, '2017-03-12 09:02:43', NULL, 'Active'),
(1356, '1489283284', NULL, 'admin', NULL, '2017-03-12 09:48:04', NULL, 'Active'),
(1357, '1489285491', NULL, 'admin', NULL, '2017-03-12 10:24:51', NULL, 'Active'),
(1358, '1489287976', NULL, 'admin', NULL, '2017-03-12 11:06:16', NULL, 'Active'),
(1359, '1489293234', NULL, 'admin', NULL, '2017-03-12 12:33:54', NULL, 'Active'),
(1360, '1489299142', NULL, 'admin', NULL, '2017-03-12 14:12:22', NULL, 'Active'),
(1361, '1489368385', NULL, 'admin', NULL, '2017-03-13 09:26:25', NULL, 'Active'),
(1362, '1489384397', NULL, 'admin', NULL, '2017-03-13 13:53:17', NULL, 'Active'),
(1363, '1489538992', NULL, 'admin', NULL, '2017-03-15 08:49:52', NULL, 'Active'),
(1364, '1489544898', NULL, 'admin', NULL, '2017-03-15 10:28:18', NULL, 'Active'),
(1365, '1489555735', NULL, 'admin', NULL, '2017-03-15 13:28:55', NULL, 'Active'),
(1366, '1489625354', NULL, 'admin', NULL, '2017-03-16 08:49:14', NULL, 'Active'),
(1367, '1489640169', NULL, 'admin', NULL, '2017-03-16 12:56:09', NULL, 'Active'),
(1368, '1489711683', NULL, 'admin', NULL, '2017-03-17 08:48:03', NULL, 'Active'),
(1369, '1489729219', NULL, 'admin', NULL, '2017-03-17 13:40:19', NULL, 'Active'),
(1370, '1489729230', NULL, 'admin', NULL, '2017-03-17 13:40:30', NULL, 'Active'),
(1371, '1489732339', NULL, 'admin', NULL, '2017-03-17 14:32:19', NULL, 'Active'),
(1372, '1489798849', NULL, 'admin', NULL, '2017-03-18 09:00:49', NULL, 'Active'),
(1373, '1489799352', NULL, 'admin', NULL, '2017-03-18 09:09:12', NULL, 'Active'),
(1374, '1489801241', NULL, 'admin', NULL, '2017-03-18 09:40:41', NULL, 'Active'),
(1375, '1489802985', NULL, 'admin', NULL, '2017-03-18 10:09:45', NULL, 'Active'),
(1376, '1489807771', NULL, 'admin', NULL, '2017-03-18 11:29:31', NULL, 'Active'),
(1377, '1489809794', NULL, 'admin', NULL, '2017-03-18 12:03:14', NULL, 'Active'),
(1378, '1489812004', NULL, 'admin', NULL, '2017-03-18 12:40:04', NULL, 'Active'),
(1379, '1489815317', NULL, 'admin', NULL, '2017-03-18 13:35:17', NULL, 'Active'),
(1380, '1489817773', NULL, 'admin', NULL, '2017-03-18 14:16:13', NULL, 'Active'),
(1381, '1489833380', NULL, 'admin', NULL, '2017-03-18 18:36:20', NULL, 'Active'),
(1382, '1489885177', NULL, 'admin', NULL, '2017-03-19 08:59:37', NULL, 'Active'),
(1383, '1489891524', NULL, 'admin', NULL, '2017-03-19 10:45:24', NULL, 'Active'),
(1384, '1489910045', NULL, 'admin', NULL, '2017-03-19 15:54:05', NULL, 'Active'),
(1385, '1489916754', NULL, 'admin', NULL, '2017-03-19 17:45:54', NULL, 'Active'),
(1386, '1489970962', NULL, 'admin', NULL, '2017-03-20 08:49:22', NULL, 'Active'),
(1387, '1490013893', NULL, 'admin', NULL, '2017-03-20 20:44:53', NULL, 'Active'),
(1388, '1490144908', NULL, 'admin', NULL, '2017-03-22 09:08:28', NULL, 'Active'),
(1389, '1490157479', NULL, 'admin', NULL, '2017-03-22 12:37:59', NULL, 'Active'),
(1390, '1490161551', NULL, 'admin', NULL, '2017-03-22 13:45:51', NULL, 'Active'),
(1391, '1490231242', NULL, 'admin', NULL, '2017-03-23 09:07:22', NULL, 'Active'),
(1392, '1490244611', NULL, 'admin', NULL, '2017-03-23 12:50:11', NULL, 'Active'),
(1393, '1490247953', NULL, 'admin', NULL, '2017-03-23 13:45:53', NULL, 'Active'),
(1394, '1490317137', NULL, 'admin', NULL, '2017-03-24 08:58:57', NULL, 'Active'),
(1395, '1490322950', NULL, 'admin', NULL, '2017-03-24 10:35:50', NULL, 'Active'),
(1396, '1490332569', NULL, 'admin', NULL, '2017-03-24 13:16:09', NULL, 'Active'),
(1397, '1490402245', NULL, 'admin', NULL, '2017-03-25 08:37:25', NULL, 'Active'),
(1398, '1490408968', NULL, 'admin', NULL, '2017-03-25 10:29:28', NULL, 'Active'),
(1399, '1490416195', NULL, 'admin', NULL, '2017-03-25 12:29:55', NULL, 'Active'),
(1400, '1490422947', NULL, 'admin', NULL, '2017-03-25 14:22:27', NULL, 'Active'),
(1401, '1490490760', NULL, 'admin', NULL, '2017-03-26 09:12:40', NULL, 'Active'),
(1402, '1490493485', NULL, 'admin', NULL, '2017-03-26 09:58:05', NULL, 'Active'),
(1403, '1490503360', NULL, 'admin', NULL, '2017-03-26 12:42:40', NULL, 'Active'),
(1404, '1490506376', NULL, 'admin', NULL, '2017-03-26 13:32:56', NULL, 'Active'),
(1405, '1490577124', NULL, 'admin', NULL, '2017-03-27 09:12:04', NULL, 'Active'),
(1406, '1490583316', NULL, 'admin', NULL, '2017-03-27 10:55:16', NULL, 'Active'),
(1407, '1490591865', NULL, 'admin', NULL, '2017-03-27 13:17:45', NULL, 'Active'),
(1408, '1490600459', NULL, 'admin', NULL, '2017-03-27 15:40:59', NULL, 'Active'),
(1409, '1490749547', NULL, 'admin', NULL, '2017-03-29 09:05:47', NULL, 'Active'),
(1410, '1490756880', NULL, 'admin', NULL, '2017-03-29 11:08:00', NULL, 'Active'),
(1411, '1490756895', NULL, 'admin', NULL, '2017-03-29 11:08:15', NULL, 'Active'),
(1412, '1490764197', NULL, 'admin', NULL, '2017-03-29 13:09:57', NULL, 'Active'),
(1413, '1490835159', NULL, 'admin', NULL, '2017-03-30 08:52:39', NULL, 'Active'),
(1414, '1490846116', NULL, 'admin', NULL, '2017-03-30 11:55:16', NULL, 'Active'),
(1415, '1490921958', NULL, 'admin', NULL, '2017-03-31 08:59:18', NULL, 'Active'),
(1416, '1490926551', NULL, 'admin', NULL, '2017-03-31 10:15:51', NULL, 'Active'),
(1417, '1490934758', NULL, 'admin', NULL, '2017-03-31 12:32:38', NULL, 'Active'),
(1418, '1490954852', NULL, 'admin', NULL, '2017-03-31 18:07:32', NULL, 'Active'),
(1419, '1491007994', NULL, 'admin', NULL, '2017-04-01 08:53:14', NULL, 'Active'),
(1420, '1491016270', NULL, 'admin', NULL, '2017-04-01 11:11:10', NULL, 'Active'),
(1421, '1491026052', NULL, 'admin', NULL, '2017-04-01 13:54:12', NULL, 'Active'),
(1422, '1491093991', NULL, 'admin', NULL, '2017-04-02 08:46:31', NULL, 'Active'),
(1423, '1491100802', NULL, 'admin', NULL, '2017-04-02 10:40:02', NULL, 'Active'),
(1424, '1491103005', NULL, 'admin', NULL, '2017-04-02 11:16:45', NULL, 'Active'),
(1425, '1491109946', NULL, 'admin', NULL, '2017-04-02 13:12:26', NULL, 'Active'),
(1426, '1491179430', NULL, 'admin', NULL, '2017-04-03 08:30:30', NULL, 'Active'),
(1427, '1491196225', NULL, 'admin', NULL, '2017-04-03 13:10:25', NULL, 'Active'),
(1428, '1491354607', NULL, 'admin', NULL, '2017-04-05 09:10:07', NULL, 'Active'),
(1429, '1491366674', NULL, 'admin', NULL, '2017-04-05 12:31:14', NULL, 'Active'),
(1430, '1491368731', NULL, 'admin', NULL, '2017-04-05 13:05:31', NULL, 'Active'),
(1431, '1491376599', NULL, 'sanni', NULL, '2017-04-05 15:16:39', NULL, 'Active'),
(1432, '1491439713', NULL, 'admin', NULL, '2017-04-06 08:48:33', NULL, 'Active'),
(1433, '1491439793', NULL, 'admin', NULL, '2017-04-06 08:49:53', NULL, 'Active'),
(1434, '1491439960', NULL, 'admin', NULL, '2017-04-06 08:52:40', NULL, 'Active'),
(1435, '1491453550', NULL, 'admin', NULL, '2017-04-06 12:39:10', NULL, 'Active'),
(1436, '1491473587', NULL, 'admin', NULL, '2017-04-06 18:13:07', NULL, 'Active'),
(1437, '1491525861', NULL, 'admin', NULL, '2017-04-07 08:44:21', NULL, 'Active'),
(1438, '1491543364', NULL, 'admin', NULL, '2017-04-07 13:36:04', NULL, 'Active'),
(1439, '1491613344', NULL, 'admin', NULL, '2017-04-08 09:02:24', NULL, 'Active'),
(1440, '1491615772', NULL, 'admin', NULL, '2017-04-08 09:42:52', NULL, 'Active'),
(1441, '1491618162', NULL, 'admin', NULL, '2017-04-08 10:22:42', NULL, 'Active'),
(1442, '1491625322', NULL, 'admin', NULL, '2017-04-08 12:22:02', NULL, 'Active'),
(1443, '1491644494', NULL, 'admin', NULL, '2017-04-08 17:41:34', NULL, 'Active'),
(1444, '1491698647', NULL, 'admin', NULL, '2017-04-09 08:44:07', NULL, 'Active'),
(1445, '1491704103', NULL, 'admin', NULL, '2017-04-09 10:15:03', NULL, 'Active'),
(1446, '1491705540', NULL, 'admin', NULL, '2017-04-09 10:39:00', NULL, 'Active'),
(1447, '1491708693', NULL, 'admin', NULL, '2017-04-09 11:31:33', NULL, 'Active'),
(1448, '1491710701', NULL, 'admin', NULL, '2017-04-09 12:05:01', NULL, 'Active'),
(1449, '1491715686', NULL, 'admin', NULL, '2017-04-09 13:28:06', NULL, 'Active'),
(1450, '1491718642', NULL, 'admin', NULL, '2017-04-09 14:17:22', NULL, 'Active'),
(1451, '1491721105', NULL, 'admin', NULL, '2017-04-09 14:58:25', NULL, 'Active'),
(1452, '1491724084', NULL, 'admin', NULL, '2017-04-09 15:48:04', NULL, 'Active'),
(1453, '1491787222', NULL, 'admin', NULL, '2017-04-10 09:20:22', NULL, 'Active'),
(1454, '1491799249', NULL, 'admin', NULL, '2017-04-10 12:40:49', NULL, 'Active'),
(1455, '1491804960', NULL, 'admin', NULL, '2017-04-10 14:16:00', NULL, 'Active'),
(1456, '1491958305', NULL, 'admin', NULL, '2017-04-12 08:51:45', NULL, 'Active'),
(1457, '1492045605', NULL, 'admin', NULL, '2017-04-13 09:06:45', NULL, 'Active'),
(1458, '1492052191', NULL, 'admin', NULL, '2017-04-13 10:56:31', NULL, 'Active'),
(1459, '1492130095', NULL, 'admin', NULL, '2017-04-14 08:34:55', NULL, 'Active'),
(1460, '1492143587', NULL, 'admin', NULL, '2017-04-14 12:19:47', NULL, 'Active'),
(1461, '1492217881', NULL, 'admin', NULL, '2017-04-15 08:58:01', NULL, 'Active'),
(1462, '1492219535', NULL, 'admin', NULL, '2017-04-15 09:25:35', NULL, 'Active'),
(1463, '1492226133', NULL, 'admin', NULL, '2017-04-15 11:15:33', NULL, 'Active'),
(1464, '1492237155', NULL, 'admin', NULL, '2017-04-15 14:19:15', NULL, 'Active'),
(1465, '1492303857', NULL, 'admin', NULL, '2017-04-16 08:50:57', NULL, 'Active'),
(1466, '1492310042', NULL, 'admin', NULL, '2017-04-16 10:34:02', NULL, 'Active'),
(1467, '1492313316', NULL, 'admin', NULL, '2017-04-16 11:28:36', NULL, 'Active'),
(1468, '1492313698', NULL, 'admin', NULL, '2017-04-16 11:34:58', NULL, 'Active'),
(1469, '1492315036', NULL, 'admin', NULL, '2017-04-16 11:57:16', NULL, 'Active'),
(1470, '1492317061', NULL, 'admin', NULL, '2017-04-16 12:31:01', NULL, 'Active'),
(1471, '1492321382', NULL, 'admin', NULL, '2017-04-16 13:43:02', NULL, 'Active'),
(1472, '1492823426', NULL, 'admin', NULL, '2017-04-22 09:10:26', NULL, 'Active'),
(1473, '1492832694', NULL, 'admin', NULL, '2017-04-22 11:44:54', NULL, 'Active'),
(1474, '1492835891', NULL, 'admin', NULL, '2017-04-22 12:38:11', NULL, 'Active'),
(1475, '1492841155', NULL, 'admin', NULL, '2017-04-22 14:05:55', NULL, 'Active'),
(1476, '1492909126', NULL, 'admin', NULL, '2017-04-23 08:58:46', NULL, 'Active'),
(1477, '1492914672', NULL, 'admin', NULL, '2017-04-23 10:31:12', NULL, 'Active'),
(1478, '1492919495', NULL, 'admin', NULL, '2017-04-23 11:51:35', NULL, 'Active'),
(1479, '1492923865', NULL, 'admin', NULL, '2017-04-23 13:04:25', NULL, 'Active'),
(1480, '1492936048', NULL, 'admin', NULL, '2017-04-23 16:27:28', NULL, 'Active'),
(1481, '1492995574', NULL, 'admin', NULL, '2017-04-24 08:59:34', NULL, 'Active'),
(1482, '1493000362', NULL, 'admin', NULL, '2017-04-24 10:19:22', NULL, 'Active'),
(1483, '1493005029', NULL, 'admin', NULL, '2017-04-24 11:37:09', NULL, 'Active'),
(1484, '1493013350', NULL, 'admin', NULL, '2017-04-24 13:55:50', NULL, 'Active'),
(1485, '1493014992', NULL, 'admin', NULL, '2017-04-24 14:23:12', NULL, 'Active'),
(1486, '1493168226', NULL, 'admin', NULL, '2017-04-26 08:57:06', NULL, 'Active'),
(1487, '1493187618', NULL, 'admin', NULL, '2017-04-26 14:20:18', NULL, 'Active'),
(1488, '1493199894', NULL, 'admin', NULL, '2017-04-26 17:44:54', NULL, 'Active'),
(1489, '1493255212', NULL, 'admin', NULL, '2017-04-27 09:06:52', NULL, 'Active'),
(1490, '1493268508', NULL, 'admin', NULL, '2017-04-27 12:48:28', NULL, 'Active'),
(1491, '1493278057', NULL, 'admin', NULL, '2017-04-27 15:27:37', NULL, 'Active'),
(1492, '1493341256', NULL, 'admin', NULL, '2017-04-28 09:00:56', NULL, 'Active'),
(1493, '1493348990', NULL, 'admin', NULL, '2017-04-28 11:09:50', NULL, 'Active'),
(1494, '1493349202', NULL, 'admin', NULL, '2017-04-28 11:13:22', NULL, 'Active'),
(1495, '1493353672', NULL, 'admin', NULL, '2017-04-28 12:27:52', NULL, 'Active'),
(1496, '1493427220', NULL, 'admin', NULL, '2017-04-29 08:53:40', NULL, 'Active'),
(1497, '1493445398', NULL, 'admin', NULL, '2017-04-29 13:56:38', NULL, 'Active'),
(1498, '1493512436', NULL, 'admin', NULL, '2017-04-30 08:33:56', NULL, 'Active'),
(1499, '1493517436', NULL, 'admin', NULL, '2017-04-30 09:57:16', NULL, 'Active'),
(1500, '1493519466', NULL, 'admin', NULL, '2017-04-30 10:31:06', NULL, 'Active'),
(1501, '1493523673', NULL, 'admin', NULL, '2017-04-30 11:41:13', NULL, 'Active'),
(1502, '1493527337', NULL, 'admin', NULL, '2017-04-30 12:42:17', NULL, 'Active'),
(1503, '1493530943', NULL, 'admin', NULL, '2017-04-30 13:42:23', NULL, 'Active'),
(1504, '1493599601', NULL, 'admin', NULL, '2017-05-01 08:46:41', NULL, 'Active'),
(1505, '1493602570', NULL, 'admin', NULL, '2017-05-01 09:36:10', NULL, 'Active'),
(1506, '1493603861', NULL, 'admin', NULL, '2017-05-01 09:57:41', NULL, 'Active'),
(1507, '1493605313', NULL, 'admin', NULL, '2017-05-01 10:21:53', NULL, 'Active'),
(1508, '1493607746', NULL, 'admin', NULL, '2017-05-01 11:02:26', NULL, 'Active'),
(1509, '1493609297', NULL, 'admin', NULL, '2017-05-01 11:28:17', NULL, 'Active'),
(1510, '1493611353', NULL, 'admin', NULL, '2017-05-01 12:02:33', NULL, 'Active'),
(1511, '1493620337', NULL, 'admin', NULL, '2017-05-01 14:32:17', NULL, 'Active'),
(1512, '1493634754', NULL, 'admin', NULL, '2017-05-01 18:32:34', NULL, 'Active'),
(1513, '1493773560', NULL, 'admin', NULL, '2017-05-03 09:06:00', NULL, 'Active'),
(1514, '1493776542', NULL, 'admin', NULL, '2017-05-03 09:55:42', NULL, 'Active'),
(1515, '1493786746', NULL, 'admin', NULL, '2017-05-03 12:45:46', NULL, 'Active'),
(1516, '1493860053', NULL, 'admin', NULL, '2017-05-04 09:07:33', NULL, 'Active'),
(1517, '1493864727', NULL, 'admin', NULL, '2017-05-04 10:25:27', NULL, 'Active'),
(1518, '1493947164', NULL, 'admin', NULL, '2017-05-05 09:19:24', NULL, 'Active'),
(1519, '1494030508', NULL, 'admin', NULL, '2017-05-06 08:28:28', NULL, 'Active'),
(1520, '1494041634', NULL, 'admin', NULL, '2017-05-06 11:33:54', NULL, 'Active'),
(1521, '1494046533', NULL, 'admin', NULL, '2017-05-06 12:55:33', NULL, 'Active'),
(1522, '1494047688', NULL, 'admin', NULL, '2017-05-06 13:14:48', NULL, 'Active'),
(1523, '1494048978', NULL, 'admin', NULL, '2017-05-06 13:36:18', NULL, 'Active'),
(1524, '1494052450', NULL, 'admin', NULL, '2017-05-06 14:34:10', NULL, 'Active'),
(1525, '1494063967', NULL, 'admin', NULL, '2017-05-06 17:46:07', NULL, 'Active'),
(1526, '1494118832', NULL, 'admin', NULL, '2017-05-07 09:00:32', NULL, 'Active'),
(1527, '1494123938', NULL, 'admin', NULL, '2017-05-07 10:25:38', NULL, 'Active'),
(1528, '1494134862', NULL, 'admin', NULL, '2017-05-07 13:27:42', NULL, 'Active'),
(1529, '1494137499', NULL, 'admin', NULL, '2017-05-07 14:11:39', NULL, 'Active'),
(1530, '1494137946', NULL, 'admin', NULL, '2017-05-07 14:19:06', NULL, 'Active'),
(1531, '1494205239', NULL, 'admin', NULL, '2017-05-08 09:00:39', NULL, 'Active'),
(1532, '1494218794', NULL, 'admin', NULL, '2017-05-08 12:46:34', NULL, 'Active'),
(1533, '1494226510', NULL, 'admin', NULL, '2017-05-08 14:55:10', NULL, 'Active'),
(1534, '1494377887', NULL, 'admin', NULL, '2017-05-10 08:58:07', NULL, 'Active'),
(1535, '1494380783', NULL, 'admin', NULL, '2017-05-10 09:46:23', NULL, 'Active'),
(1536, '1494383458', NULL, 'admin', NULL, '2017-05-10 10:30:58', NULL, 'Active'),
(1537, '1494384980', NULL, 'admin', NULL, '2017-05-10 10:56:20', NULL, 'Active'),
(1538, '1494389252', NULL, 'admin', NULL, '2017-05-10 12:07:32', NULL, 'Active'),
(1539, '1494398691', NULL, 'admin', NULL, '2017-05-10 14:44:51', NULL, 'Active'),
(1540, '1494463371', NULL, 'admin', NULL, '2017-05-11 08:42:51', NULL, 'Active'),
(1541, '1494473587', NULL, 'admin', NULL, '2017-05-11 11:33:07', NULL, 'Active'),
(1542, '1494479511', NULL, 'admin', NULL, '2017-05-11 13:11:51', NULL, 'Active'),
(1543, '1494551748', NULL, 'admin', NULL, '2017-05-12 09:15:48', NULL, 'Active'),
(1544, '1494558188', NULL, 'admin', NULL, '2017-05-12 11:03:08', NULL, 'Active'),
(1545, '1494564082', NULL, 'admin', NULL, '2017-05-12 12:41:22', NULL, 'Active'),
(1546, '1494567519', NULL, 'admin', NULL, '2017-05-12 13:38:39', NULL, 'Active'),
(1547, '1494637345', NULL, 'admin', NULL, '2017-05-13 09:02:25', NULL, 'Active'),
(1548, '1494641902', NULL, 'admin', NULL, '2017-05-13 10:18:22', NULL, 'Active'),
(1549, '1494644339', NULL, 'admin', NULL, '2017-05-13 10:58:59', NULL, 'Active'),
(1550, '1494644569', NULL, 'admin', NULL, '2017-05-13 11:02:49', NULL, 'Active'),
(1551, '1494646186', NULL, 'admin', NULL, '2017-05-13 11:29:46', NULL, 'Active'),
(1552, '1494650176', NULL, 'admin', NULL, '2017-05-13 12:36:16', NULL, 'Active'),
(1553, '1494723283', NULL, 'admin', NULL, '2017-05-14 08:54:43', NULL, 'Active'),
(1554, '1494727581', NULL, 'admin', NULL, '2017-05-14 10:06:21', NULL, 'Active'),
(1555, '1494730264', NULL, 'admin', NULL, '2017-05-14 10:51:04', NULL, 'Active'),
(1556, '1494732521', NULL, 'admin', NULL, '2017-05-14 11:28:41', NULL, 'Active'),
(1557, '1494734357', NULL, 'admin', NULL, '2017-05-14 11:59:17', NULL, 'Active'),
(1558, '1494738059', NULL, 'admin', NULL, '2017-05-14 13:00:59', NULL, 'Active'),
(1559, '1494741275', NULL, 'admin', NULL, '2017-05-14 13:54:35', NULL, 'Active'),
(1560, '1494810299', NULL, 'admin', NULL, '2017-05-15 09:04:59', NULL, 'Active'),
(1561, '1494812307', NULL, 'admin', NULL, '2017-05-15 09:38:27', NULL, 'Active'),
(1562, '1494820745', NULL, 'admin', NULL, '2017-05-15 11:59:05', NULL, 'Active'),
(1563, '1494827320', NULL, 'admin', NULL, '2017-05-15 13:48:40', NULL, 'Active'),
(1564, '1494981904', NULL, 'admin', NULL, '2017-05-17 08:45:04', NULL, 'Active'),
(1565, '1494990515', NULL, 'admin', NULL, '2017-05-17 11:08:35', NULL, 'Active'),
(1566, '1494997310', NULL, 'admin', NULL, '2017-05-17 13:01:50', NULL, 'Active'),
(1567, '1495000143', NULL, 'admin', NULL, '2017-05-17 13:49:03', NULL, 'Active'),
(1568, '1495069191', NULL, 'admin', NULL, '2017-05-18 08:59:51', NULL, 'Active'),
(1569, '1495085098', NULL, 'admin', NULL, '2017-05-18 13:24:58', NULL, 'Active'),
(1570, '1495154371', NULL, 'admin', NULL, '2017-05-19 08:39:31', NULL, 'Active'),
(1571, '1495160647', NULL, 'admin', NULL, '2017-05-19 10:24:07', NULL, 'Active'),
(1572, '1495170643', NULL, 'admin', NULL, '2017-05-19 13:10:43', NULL, 'Active'),
(1573, '1495241063', NULL, 'admin', NULL, '2017-05-20 08:44:23', NULL, 'Active'),
(1574, '1495245508', NULL, 'admin', NULL, '2017-05-20 09:58:28', NULL, 'Active'),
(1575, '1495251509', NULL, 'admin', NULL, '2017-05-20 11:38:29', NULL, 'Active'),
(1576, '1495255615', NULL, 'admin', NULL, '2017-05-20 12:46:55', NULL, 'Active'),
(1577, '1495268667', NULL, 'admin', NULL, '2017-05-20 16:24:27', NULL, 'Active'),
(1578, '1495327060', NULL, 'admin', NULL, '2017-05-21 08:37:40', NULL, 'Active'),
(1579, '1495333393', NULL, 'admin', NULL, '2017-05-21 10:23:13', NULL, 'Active'),
(1580, '1495337880', NULL, 'admin', NULL, '2017-05-21 11:38:00', NULL, 'Active'),
(1581, '1495347258', NULL, 'admin', NULL, '2017-05-21 14:14:18', NULL, 'Active'),
(1582, '1495349721', NULL, 'admin', NULL, '2017-05-21 14:55:21', NULL, 'Active'),
(1583, '1495415085', NULL, 'admin', NULL, '2017-05-22 09:04:45', NULL, 'Active'),
(1584, '1495423135', NULL, 'admin', NULL, '2017-05-22 11:18:55', NULL, 'Active'),
(1585, '1495425366', NULL, 'admin', NULL, '2017-05-22 11:56:06', NULL, 'Active'),
(1586, '1495436218', NULL, 'admin', NULL, '2017-05-22 14:56:58', NULL, 'Active'),
(1587, '1495588949', NULL, 'admin', NULL, '2017-05-24 09:22:29', NULL, 'Active'),
(1588, '1495672642', NULL, 'admin', NULL, '2017-05-25 08:37:22', NULL, 'Active'),
(1589, '1495678643', NULL, 'admin', NULL, '2017-05-25 10:17:23', NULL, 'Active'),
(1590, '1495690898', NULL, 'admin', NULL, '2017-05-25 13:41:38', NULL, 'Active'),
(1591, '1495760569', NULL, 'admin', NULL, '2017-05-26 09:02:49', NULL, 'Active'),
(1592, '1495765270', NULL, 'admin', NULL, '2017-05-26 10:21:10', NULL, 'Active'),
(1593, '1495768302', NULL, 'admin', NULL, '2017-05-26 11:11:42', NULL, 'Active'),
(1594, '1495777144', NULL, 'admin', NULL, '2017-05-26 13:39:04', NULL, 'Active'),
(1595, '1495784781', NULL, 'admin', NULL, '2017-05-26 15:46:21', NULL, 'Active'),
(1596, '1495846214', NULL, 'admin', NULL, '2017-05-27 08:50:14', NULL, 'Active'),
(1597, '1495849608', NULL, 'admin', NULL, '2017-05-27 09:46:48', NULL, 'Active'),
(1598, '1495850022', NULL, 'admin', NULL, '2017-05-27 09:53:42', NULL, 'Active'),
(1599, '1495850051', NULL, 'admin', NULL, '2017-05-27 09:54:11', NULL, 'Active'),
(1600, '1495853268', NULL, 'admin', NULL, '2017-05-27 10:47:48', NULL, 'Active'),
(1601, '1495854225', NULL, 'admin', NULL, '2017-05-27 11:03:45', NULL, 'Active'),
(1602, '1495861619', NULL, 'admin', NULL, '2017-05-27 13:06:59', NULL, 'Active'),
(1603, '1495864484', NULL, 'admin', NULL, '2017-05-27 13:54:44', NULL, 'Active'),
(1604, '1495865063', NULL, 'admin', NULL, '2017-05-27 14:04:23', NULL, 'Active'),
(1605, '1495866377', NULL, 'admin', NULL, '2017-05-27 14:26:17', NULL, 'Active'),
(1606, '1495933254', NULL, 'admin', NULL, '2017-05-28 09:00:54', NULL, 'Active'),
(1607, '1495938775', NULL, 'admin', NULL, '2017-05-28 10:32:55', NULL, 'Active'),
(1608, '1495941091', NULL, 'admin', NULL, '2017-05-28 11:11:31', NULL, 'Active'),
(1609, '1495942548', NULL, 'admin', NULL, '2017-05-28 11:35:48', NULL, 'Active'),
(1610, '1495945072', NULL, 'admin', NULL, '2017-05-28 12:17:52', NULL, 'Active'),
(1611, '1495946282', NULL, 'admin', NULL, '2017-05-28 12:38:02', NULL, 'Active'),
(1612, '1496020083', NULL, 'admin', NULL, '2017-05-29 09:08:03', NULL, 'Active'),
(1613, '1496027243', NULL, 'admin', NULL, '2017-05-29 11:07:23', NULL, 'Active'),
(1614, '1496034809', NULL, 'admin', NULL, '2017-05-29 13:13:29', NULL, 'Active'),
(1615, '1496036925', NULL, 'admin', NULL, '2017-05-29 13:48:45', NULL, 'Active'),
(1616, '1496192352', NULL, 'admin', NULL, '2017-05-31 08:59:12', NULL, 'Active'),
(1617, '1496199128', NULL, 'admin', NULL, '2017-05-31 10:52:08', NULL, 'Active'),
(1618, '1496207371', NULL, 'admin', NULL, '2017-05-31 13:09:31', NULL, 'Active'),
(1619, '1496209864', NULL, 'admin', NULL, '2017-05-31 13:51:04', NULL, 'Active'),
(1620, '1496213320', NULL, 'admin', NULL, '2017-05-31 14:48:40', NULL, 'Active'),
(1621, '1496279057', NULL, 'admin', NULL, '2017-06-01 09:04:17', NULL, 'Active'),
(1622, '1496284576', NULL, 'admin', NULL, '2017-06-01 10:36:16', NULL, 'Active'),
(1623, '1496364303', NULL, 'admin', NULL, '2017-06-02 08:45:03', NULL, 'Active'),
(1624, '1496372633', NULL, 'admin', NULL, '2017-06-02 11:03:53', NULL, 'Active'),
(1625, '1496451505', NULL, 'admin', NULL, '2017-06-03 08:58:25', NULL, 'Active'),
(1626, '1496454919', NULL, 'admin', NULL, '2017-06-03 09:55:19', NULL, 'Active'),
(1627, '1496456994', NULL, 'admin', NULL, '2017-06-03 10:29:54', NULL, 'Active'),
(1628, '1496460619', NULL, 'admin', NULL, '2017-06-03 11:30:19', NULL, 'Active'),
(1629, '1496463066', NULL, 'admin', NULL, '2017-06-03 12:11:06', NULL, 'Active'),
(1630, '1496466110', NULL, 'admin', NULL, '2017-06-03 13:01:50', NULL, 'Active'),
(1631, '1496471275', NULL, 'admin', NULL, '2017-06-03 14:27:55', NULL, 'Active'),
(1632, '1496537016', NULL, 'admin', NULL, '2017-06-04 08:43:36', NULL, 'Active'),
(1633, '1496542619', NULL, 'admin', NULL, '2017-06-04 10:16:59', NULL, 'Active'),
(1634, '1496544263', NULL, 'admin', NULL, '2017-06-04 10:44:23', NULL, 'Active'),
(1635, '1496546186', NULL, 'admin', NULL, '2017-06-04 11:16:26', NULL, 'Active'),
(1636, '1496549024', NULL, 'admin', NULL, '2017-06-04 12:03:44', NULL, 'Active'),
(1637, '1496549123', NULL, 'admin', NULL, '2017-06-04 12:05:23', NULL, 'Active'),
(1638, '1496552111', NULL, 'admin', NULL, '2017-06-04 12:55:11', NULL, 'Active'),
(1639, '1496556838', NULL, 'admin', NULL, '2017-06-04 14:13:58', NULL, 'Active'),
(1640, '1496624231', NULL, 'admin', NULL, '2017-06-05 08:57:11', NULL, 'Active'),
(1641, '1496635131', NULL, 'admin', NULL, '2017-06-05 11:58:51', NULL, 'Active'),
(1642, '1496641340', NULL, 'admin', NULL, '2017-06-05 13:42:20', NULL, 'Active'),
(1643, '1496797835', NULL, 'admin', NULL, '2017-06-07 09:10:35', NULL, 'Active'),
(1644, '1496810669', NULL, 'admin', NULL, '2017-06-07 12:44:29', NULL, 'Active'),
(1645, '1496884016', NULL, 'admin', NULL, '2017-06-08 09:06:56', NULL, 'Active'),
(1646, '1496886869', NULL, 'admin', NULL, '2017-06-08 09:54:29', NULL, 'Active'),
(1647, '1496894388', NULL, 'admin', NULL, '2017-06-08 11:59:48', NULL, 'Active'),
(1648, '1496897411', NULL, 'admin', NULL, '2017-06-08 12:50:11', NULL, 'Active'),
(1649, '1496901775', NULL, 'admin', NULL, '2017-06-08 14:02:55', NULL, 'Active'),
(1650, '1496968353', NULL, 'admin', NULL, '2017-06-09 08:32:33', NULL, 'Active'),
(1651, '1496977505', NULL, 'admin', NULL, '2017-06-09 11:05:05', NULL, 'Active'),
(1652, '1496985770', NULL, 'admin', NULL, '2017-06-09 13:22:50', NULL, 'Active'),
(1653, '1496990027', NULL, 'admin', NULL, '2017-06-09 14:33:47', NULL, 'Active'),
(1654, '1497053888', NULL, 'admin', NULL, '2017-06-10 08:18:08', NULL, 'Active'),
(1655, '1497056454', NULL, 'admin', NULL, '2017-06-10 09:00:54', NULL, 'Active'),
(1656, '1497059186', NULL, 'admin', NULL, '2017-06-10 09:46:26', NULL, 'Active'),
(1657, '1497062082', NULL, 'admin', NULL, '2017-06-10 10:34:42', NULL, 'Active'),
(1658, '1497064642', NULL, 'admin', NULL, '2017-06-10 11:17:22', NULL, 'Active'),
(1659, '1497067645', NULL, 'admin', NULL, '2017-06-10 12:07:25', NULL, 'Active'),
(1660, '1497072639', NULL, 'admin', NULL, '2017-06-10 13:30:39', NULL, 'Active'),
(1661, '1497078843', NULL, 'admin', NULL, '2017-06-10 15:14:03', NULL, 'Active'),
(1662, '1497141346', NULL, 'admin', NULL, '2017-06-11 08:35:46', NULL, 'Active'),
(1663, '1497147234', NULL, 'admin', NULL, '2017-06-11 10:13:54', NULL, 'Active'),
(1664, '1497152965', NULL, 'admin', NULL, '2017-06-11 11:49:25', NULL, 'Active'),
(1665, '1497158410', NULL, 'admin', NULL, '2017-06-11 13:20:10', NULL, 'Active'),
(1666, '1497228235', NULL, 'admin', NULL, '2017-06-12 08:43:55', NULL, 'Active'),
(1667, '1497234420', NULL, 'admin', NULL, '2017-06-12 10:27:00', NULL, 'Active'),
(1668, '1497241337', NULL, 'admin', NULL, '2017-06-12 12:22:17', NULL, 'Active'),
(1669, '1497246792', NULL, 'admin', NULL, '2017-06-12 13:53:12', NULL, 'Active'),
(1670, '1497251184', NULL, 'admin', NULL, '2017-06-12 15:06:24', NULL, 'Active'),
(1671, '1497401099', NULL, 'admin', NULL, '2017-06-14 08:44:59', NULL, 'Active'),
(1672, '1497412185', NULL, 'admin', NULL, '2017-06-14 11:49:45', NULL, 'Active'),
(1673, '1497488415', NULL, 'admin', NULL, '2017-06-15 09:00:15', NULL, 'Active'),
(1674, '1497497140', NULL, 'admin', NULL, '2017-06-15 11:25:40', NULL, 'Active'),
(1675, '1497508226', NULL, 'admin', NULL, '2017-06-15 14:30:26', NULL, 'Active'),
(1676, '1497572248', NULL, 'admin', NULL, '2017-06-16 08:17:28', NULL, 'Active'),
(1677, '1497585921', NULL, 'admin', NULL, '2017-06-16 12:05:21', NULL, 'Active'),
(1678, '1497591193', NULL, 'admin', NULL, '2017-06-16 13:33:13', NULL, 'Active'),
(1679, '1497594779', NULL, 'admin', NULL, '2017-06-16 14:32:59', NULL, 'Active'),
(1680, '1497660873', NULL, 'admin', NULL, '2017-06-17 08:54:33', NULL, 'Active'),
(1681, '1497667709', NULL, 'admin', NULL, '2017-06-17 10:48:29', NULL, 'Active'),
(1682, '1497671529', NULL, 'admin', NULL, '2017-06-17 11:52:09', NULL, 'Active'),
(1683, '1497673009', NULL, 'admin', NULL, '2017-06-17 12:16:49', NULL, 'Active'),
(1684, '1497675902', NULL, 'admin', NULL, '2017-06-17 13:05:02', NULL, 'Active'),
(1685, '1497686642', NULL, 'admin', NULL, '2017-06-17 16:04:02', NULL, 'Active'),
(1686, '1497747858', NULL, 'admin', NULL, '2017-06-18 09:04:18', NULL, 'Active'),
(1687, '1497751365', NULL, 'admin', NULL, '2017-06-18 10:02:45', NULL, 'Active'),
(1688, '1497757804', NULL, 'admin', NULL, '2017-06-18 11:50:04', NULL, 'Active'),
(1689, '1497760327', NULL, 'admin', NULL, '2017-06-18 12:32:07', NULL, 'Active'),
(1690, '1497762058', NULL, 'admin', NULL, '2017-06-18 13:00:58', NULL, 'Active'),
(1691, '1497764902', NULL, 'admin', NULL, '2017-06-18 13:48:22', NULL, 'Active'),
(1692, '1497834116', NULL, 'admin', NULL, '2017-06-19 09:01:56', NULL, 'Active'),
(1693, '1497836447', NULL, 'admin', NULL, '2017-06-19 09:40:47', NULL, 'Active'),
(1694, '1497844586', NULL, 'admin', NULL, '2017-06-19 11:56:26', NULL, 'Active'),
(1695, '1497850339', NULL, 'admin', NULL, '2017-06-19 13:32:19', NULL, 'Active'),
(1696, '1497854525', NULL, 'admin', NULL, '2017-06-19 14:42:05', NULL, 'Active'),
(1697, '1498007850', NULL, 'admin', NULL, '2017-06-21 09:17:30', NULL, 'Active'),
(1698, '1498014732', NULL, 'admin', NULL, '2017-06-21 11:12:12', NULL, 'Active'),
(1699, '1498018148', NULL, 'admin', NULL, '2017-06-21 12:09:08', NULL, 'Active'),
(1700, '1498023646', NULL, 'admin', NULL, '2017-06-21 13:40:46', NULL, 'Active'),
(1701, '1498092450', NULL, 'admin', NULL, '2017-06-22 08:47:30', NULL, 'Active'),
(1702, '1498097986', NULL, 'admin', NULL, '2017-06-22 10:19:46', NULL, 'Active'),
(1703, '1498105008', NULL, 'admin', NULL, '2017-06-22 12:16:48', NULL, 'Active'),
(1704, '1498178121', NULL, 'admin', NULL, '2017-06-23 08:35:21', NULL, 'Active'),
(1705, '1498189529', NULL, 'admin', NULL, '2017-06-23 11:45:29', NULL, 'Active'),
(1706, '1498195504', NULL, 'admin', NULL, '2017-06-23 13:25:04', NULL, 'Active'),
(1707, '1498265512', NULL, 'admin', NULL, '2017-06-24 08:51:52', NULL, 'Active'),
(1708, '1498270351', NULL, 'admin', NULL, '2017-06-24 10:12:31', NULL, 'Active'),
(1709, '1498271540', NULL, 'admin', NULL, '2017-06-24 10:32:20', NULL, 'Active'),
(1710, '1498274427', NULL, 'admin', NULL, '2017-06-24 11:20:27', NULL, 'Active'),
(1711, '1498280579', NULL, 'admin', NULL, '2017-06-24 13:02:59', NULL, 'Active'),
(1712, '1498287316', NULL, 'admin', NULL, '2017-06-24 14:55:16', NULL, 'Active'),
(1713, '1498350984', NULL, 'admin', NULL, '2017-06-25 08:36:24', NULL, 'Active'),
(1714, '1498355160', NULL, 'admin', NULL, '2017-06-25 09:46:00', NULL, 'Active'),
(1715, '1498357366', NULL, 'admin', NULL, '2017-06-25 10:22:46', NULL, 'Active'),
(1716, '1498358543', NULL, 'admin', NULL, '2017-06-25 10:42:23', NULL, 'Active'),
(1717, '1498361406', NULL, 'admin', NULL, '2017-06-25 11:30:06', NULL, 'Active'),
(1718, '1498362580', NULL, 'admin', NULL, '2017-06-25 11:49:40', NULL, 'Active'),
(1719, '1498365799', NULL, 'admin', NULL, '2017-06-25 12:43:19', NULL, 'Active'),
(1720, '1498367574', NULL, 'admin', NULL, '2017-06-25 13:12:54', NULL, 'Active'),
(1721, '1498369441', NULL, 'admin', NULL, '2017-06-25 13:44:01', NULL, 'Active'),
(1722, '1498370688', NULL, 'admin', NULL, '2017-06-25 14:04:48', NULL, 'Active'),
(1723, '1498438916', NULL, 'admin', NULL, '2017-06-26 09:01:56', NULL, 'Active'),
(1724, '1498440957', NULL, 'admin', NULL, '2017-06-26 09:35:57', NULL, 'Active'),
(1725, '1498442801', NULL, 'admin', NULL, '2017-06-26 10:06:41', NULL, 'Active'),
(1726, '1498443768', NULL, 'admin', NULL, '2017-06-26 10:22:48', NULL, 'Active'),
(1727, '1498445415', NULL, 'admin', NULL, '2017-06-26 10:50:15', NULL, 'Active'),
(1728, '1498447642', NULL, 'admin', NULL, '2017-06-26 11:27:22', NULL, 'Active'),
(1729, '1498448388', NULL, 'admin', NULL, '2017-06-26 11:39:48', NULL, 'Active'),
(1730, '1498450740', NULL, 'admin', NULL, '2017-06-26 12:19:00', NULL, 'Active'),
(1731, '1498456261', NULL, 'admin', NULL, '2017-06-26 13:51:01', NULL, 'Active'),
(1732, '1498457127', NULL, 'admin', NULL, '2017-06-26 14:05:27', NULL, 'Active'),
(1733, '1498611394', NULL, 'admin', NULL, '2017-06-28 08:56:34', NULL, 'Active'),
(1734, '1498617250', NULL, 'admin', NULL, '2017-06-28 10:34:10', NULL, 'Active'),
(1735, '1498626392', NULL, 'admin', NULL, '2017-06-28 13:06:32', NULL, 'Active'),
(1736, '1498696035', NULL, 'admin', NULL, '2017-06-29 08:27:15', NULL, 'Active'),
(1737, '1498704985', NULL, 'admin', NULL, '2017-06-29 10:56:25', NULL, 'Active'),
(1738, '1498710862', NULL, 'admin', NULL, '2017-06-29 12:34:22', NULL, 'Active'),
(1739, '1498714477', NULL, 'admin', NULL, '2017-06-29 13:34:37', NULL, 'Active'),
(1740, '1498783768', NULL, 'admin', NULL, '2017-06-30 08:49:28', NULL, 'Active'),
(1741, '1498792010', NULL, 'admin', NULL, '2017-06-30 11:06:50', NULL, 'Active'),
(1742, '1498871185', NULL, 'admin', NULL, '2017-07-01 09:06:25', NULL, 'Active'),
(1743, '1498876031', NULL, 'admin', NULL, '2017-07-01 10:27:11', NULL, 'Active'),
(1744, '1498880635', NULL, 'admin', NULL, '2017-07-01 11:43:55', NULL, 'Active'),
(1745, '1498882487', NULL, 'admin', NULL, '2017-07-01 12:14:47', NULL, 'Active'),
(1746, '1498895817', NULL, 'admin', NULL, '2017-07-01 15:56:57', NULL, 'Active'),
(1747, '1498957416', NULL, 'admin', NULL, '2017-07-02 09:03:36', NULL, 'Active'),
(1748, '1498961112', NULL, 'admin', NULL, '2017-07-02 10:05:12', NULL, 'Active'),
(1749, '1498965772', NULL, 'admin', NULL, '2017-07-02 11:22:52', NULL, 'Active'),
(1750, '1498968964', NULL, 'admin', NULL, '2017-07-02 12:16:04', NULL, 'Active'),
(1751, '1498970043', NULL, 'admin', NULL, '2017-07-02 12:34:03', NULL, 'Active'),
(1752, '1498972092', NULL, 'admin', NULL, '2017-07-02 13:08:12', NULL, 'Active'),
(1753, '1498973776', NULL, 'admin', NULL, '2017-07-02 13:36:16', NULL, 'Active'),
(1754, '1498976735', NULL, 'admin', NULL, '2017-07-02 14:25:35', NULL, 'Active'),
(1755, '1499043648', NULL, 'admin', NULL, '2017-07-03 09:00:48', NULL, 'Active'),
(1756, '1499047855', NULL, 'admin', NULL, '2017-07-03 10:10:55', NULL, 'Active'),
(1757, '1499053371', NULL, 'admin', NULL, '2017-07-03 11:42:51', NULL, 'Active'),
(1758, '1499056173', NULL, 'admin', NULL, '2017-07-03 12:29:33', NULL, 'Active'),
(1759, '1499217590', NULL, 'admin', NULL, '2017-07-05 09:19:50', NULL, 'Active'),
(1760, '1499223792', NULL, 'admin', NULL, '2017-07-05 11:03:12', NULL, 'Active'),
(1761, '1499228549', NULL, 'admin', NULL, '2017-07-05 12:22:29', NULL, 'Active'),
(1762, '1499303022', NULL, 'admin', NULL, '2017-07-06 09:03:42', NULL, 'Active'),
(1763, '1499309018', NULL, 'admin', NULL, '2017-07-06 10:43:38', NULL, 'Active'),
(1764, '1499317491', NULL, 'admin', NULL, '2017-07-06 13:04:51', NULL, 'Active'),
(1765, '1499321405', NULL, 'admin', NULL, '2017-07-06 14:10:05', NULL, 'Active'),
(1766, '1499387663', NULL, 'admin', NULL, '2017-07-07 08:34:23', NULL, 'Active'),
(1767, '1499394285', NULL, 'admin', NULL, '2017-07-07 10:24:45', NULL, 'Active'),
(1768, '1499398762', NULL, 'admin', NULL, '2017-07-07 11:39:22', NULL, 'Active'),
(1769, '1499401813', NULL, 'admin', NULL, '2017-07-07 12:30:13', NULL, 'Active'),
(1770, '1499404413', NULL, 'admin', NULL, '2017-07-07 13:13:33', NULL, 'Active'),
(1771, '1499407772', NULL, 'admin', NULL, '2017-07-07 14:09:32', NULL, 'Active'),
(1772, '1499475812', NULL, 'admin', NULL, '2017-07-08 09:03:32', NULL, 'Active'),
(1773, '1499477746', NULL, 'admin', NULL, '2017-07-08 09:35:46', NULL, 'Active'),
(1774, '1499480008', NULL, 'admin', NULL, '2017-07-08 10:13:28', NULL, 'Active'),
(1775, '1499480915', NULL, 'admin', NULL, '2017-07-08 10:28:35', NULL, 'Active'),
(1776, '1499485631', NULL, 'admin', NULL, '2017-07-08 11:47:11', NULL, 'Active'),
(1777, '1499488383', NULL, 'admin', NULL, '2017-07-08 12:33:03', NULL, 'Active'),
(1778, '1499490738', NULL, 'admin', NULL, '2017-07-08 13:12:18', NULL, 'Active'),
(1779, '1499495883', NULL, 'admin', NULL, '2017-07-08 14:38:03', NULL, 'Active'),
(1780, '1499560967', NULL, 'admin', NULL, '2017-07-09 08:42:47', NULL, 'Active'),
(1781, '1499566363', NULL, 'admin', NULL, '2017-07-09 10:12:43', NULL, 'Active'),
(1782, '1499568841', NULL, 'admin', NULL, '2017-07-09 10:54:01', NULL, 'Active'),
(1783, '1499572088', NULL, 'admin', NULL, '2017-07-09 11:48:08', NULL, 'Active'),
(1784, '1499574708', NULL, 'admin', NULL, '2017-07-09 12:31:48', NULL, 'Active'),
(1785, '1499577344', NULL, 'admin', NULL, '2017-07-09 13:15:44', NULL, 'Active'),
(1786, '1499579780', NULL, 'admin', NULL, '2017-07-09 13:56:20', NULL, 'Active'),
(1787, '1499648658', NULL, 'admin', NULL, '2017-07-10 09:04:18', NULL, 'Active'),
(1788, '1499650469', NULL, 'admin', NULL, '2017-07-10 09:34:29', NULL, 'Active'),
(1789, '1499652714', NULL, 'admin', NULL, '2017-07-10 10:11:54', NULL, 'Active'),
(1790, '1499655310', NULL, 'admin', NULL, '2017-07-10 10:55:10', NULL, 'Active'),
(1791, '1499662074', NULL, 'admin', NULL, '2017-07-10 12:47:54', NULL, 'Active'),
(1792, '1499821639', NULL, 'admin', NULL, '2017-07-12 09:07:19', NULL, 'Active'),
(1793, '1499831389', NULL, 'admin', NULL, '2017-07-12 11:49:49', NULL, 'Active'),
(1794, '1499835170', NULL, 'admin', NULL, '2017-07-12 12:52:50', NULL, 'Active'),
(1795, '1499836063', NULL, 'admin', NULL, '2017-07-12 13:07:43', NULL, 'Active'),
(1796, '1499845049', NULL, 'admin', NULL, '2017-07-12 15:37:29', NULL, 'Active'),
(1797, '1499906815', NULL, 'admin', NULL, '2017-07-13 08:46:55', NULL, 'Active'),
(1798, '1499913735', NULL, 'admin', NULL, '2017-07-13 10:42:15', NULL, 'Active'),
(1799, '1499932464', NULL, 'admin', NULL, '2017-07-13 15:54:24', NULL, 'Active'),
(1800, '1499993902', NULL, 'admin', NULL, '2017-07-14 08:58:22', NULL, 'Active'),
(1801, '1500000286', NULL, 'admin', NULL, '2017-07-14 10:44:46', NULL, 'Active'),
(1802, '1500007115', NULL, 'admin', NULL, '2017-07-14 12:38:35', NULL, 'Active'),
(1803, '1500014039', NULL, 'admin', NULL, '2017-07-14 14:33:59', NULL, 'Active'),
(1804, '1500079614', NULL, 'admin', NULL, '2017-07-15 08:46:54', NULL, 'Active'),
(1805, '1500084910', NULL, 'admin', NULL, '2017-07-15 10:15:10', NULL, 'Active'),
(1806, '1500091184', NULL, 'admin', NULL, '2017-07-15 11:59:44', NULL, 'Active'),
(1807, '1500100134', NULL, 'admin', NULL, '2017-07-15 14:28:54', NULL, 'Active'),
(1808, '1500107018', NULL, 'admin', NULL, '2017-07-15 16:23:38', NULL, 'Active'),
(1809, '1500165095', NULL, 'admin', NULL, '2017-07-16 08:31:35', NULL, 'Active'),
(1810, '1500169344', NULL, 'admin', NULL, '2017-07-16 09:42:24', NULL, 'Active'),
(1811, '1500172442', NULL, 'admin', NULL, '2017-07-16 10:34:02', NULL, 'Active'),
(1812, '1500177418', NULL, 'admin', NULL, '2017-07-16 11:56:58', NULL, 'Active'),
(1813, '1500179863', NULL, 'admin', NULL, '2017-07-16 12:37:43', NULL, 'Active'),
(1814, '1500181895', NULL, 'admin', NULL, '2017-07-16 13:11:35', NULL, 'Active'),
(1815, '1500184404', NULL, 'admin', NULL, '2017-07-16 13:53:24', NULL, 'Active'),
(1816, '1500189795', NULL, 'admin', NULL, '2017-07-16 15:23:15', NULL, 'Active'),
(1817, '1500252965', NULL, 'admin', NULL, '2017-07-17 08:56:05', NULL, 'Active'),
(1818, '1500261032', NULL, 'admin', NULL, '2017-07-17 11:10:32', NULL, 'Active'),
(1819, '1500265652', NULL, 'admin', NULL, '2017-07-17 12:27:32', NULL, 'Active'),
(1820, '1500270044', NULL, 'admin', NULL, '2017-07-17 13:40:44', NULL, 'Active'),
(1821, '1500426805', NULL, 'admin', NULL, '2017-07-19 09:13:25', NULL, 'Active'),
(1822, '1500429669', NULL, 'admin', NULL, '2017-07-19 10:01:09', NULL, 'Active'),
(1823, '1500439386', NULL, 'admin', NULL, '2017-07-19 12:43:06', NULL, 'Active'),
(1824, '1500456537', NULL, 'admin', NULL, '2017-07-19 17:28:57', NULL, 'Active'),
(1825, '1500512269', NULL, 'admin', NULL, '2017-07-20 08:57:49', NULL, 'Active'),
(1826, '1500518667', NULL, 'admin', NULL, '2017-07-20 10:44:27', NULL, 'Active'),
(1827, '1500524749', NULL, 'admin', NULL, '2017-07-20 12:25:49', NULL, 'Active'),
(1828, '1500527734', NULL, 'admin', NULL, '2017-07-20 13:15:34', NULL, 'Active'),
(1829, '1500598066', NULL, 'admin', NULL, '2017-07-21 08:47:46', NULL, 'Active'),
(1830, '1500603185', NULL, 'admin', NULL, '2017-07-21 10:13:05', NULL, 'Active'),
(1831, '1500606849', NULL, 'admin', NULL, '2017-07-21 11:14:09', NULL, 'Active'),
(1832, '1500611801', NULL, 'admin', NULL, '2017-07-21 12:36:41', NULL, 'Active'),
(1833, '1500684602', NULL, 'admin', NULL, '2017-07-22 08:50:02', NULL, 'Active'),
(1834, '1500690447', NULL, 'admin', NULL, '2017-07-22 10:27:27', NULL, 'Active'),
(1835, '1500691627', NULL, 'admin', NULL, '2017-07-22 10:47:07', NULL, 'Active'),
(1836, '1500691734', NULL, 'admin', NULL, '2017-07-22 10:48:54', NULL, 'Active'),
(1837, '1500692858', NULL, 'admin', NULL, '2017-07-22 11:07:38', NULL, 'Active'),
(1838, '1500702063', NULL, 'admin', NULL, '2017-07-22 13:41:03', NULL, 'Active'),
(1839, '1500706560', NULL, 'admin', NULL, '2017-07-22 14:56:00', NULL, 'Active'),
(1840, '1500709637', NULL, 'admin', NULL, '2017-07-22 15:47:17', NULL, 'Active'),
(1841, '1500771896', NULL, 'admin', NULL, '2017-07-23 09:04:56', NULL, 'Active'),
(1842, '1500773888', NULL, 'admin', NULL, '2017-07-23 09:38:08', NULL, 'Active'),
(1843, '1500776009', NULL, 'admin', NULL, '2017-07-23 10:13:29', NULL, 'Active'),
(1844, '1500778074', NULL, 'admin', NULL, '2017-07-23 10:47:54', NULL, 'Active'),
(1845, '1500779539', NULL, 'admin', NULL, '2017-07-23 11:12:19', NULL, 'Active'),
(1846, '1500781238', NULL, 'admin', NULL, '2017-07-23 11:40:38', NULL, 'Active'),
(1847, '1500857971', NULL, 'admin', NULL, '2017-07-24 08:59:31', NULL, 'Active'),
(1848, '1500864754', NULL, 'admin', NULL, '2017-07-24 10:52:34', NULL, 'Active'),
(1849, '1500871739', NULL, 'admin', NULL, '2017-07-24 12:48:59', NULL, 'Active'),
(1850, '1500875180', NULL, 'admin', NULL, '2017-07-24 13:46:20', NULL, 'Active'),
(1851, '1500875902', NULL, 'admin', NULL, '2017-07-24 13:58:22', NULL, 'Active'),
(1852, '1501031193', NULL, 'admin', NULL, '2017-07-26 09:06:33', NULL, 'Active'),
(1853, '1501037957', NULL, 'admin', NULL, '2017-07-26 10:59:17', NULL, 'Active'),
(1854, '1501040900', NULL, 'admin', NULL, '2017-07-26 11:48:20', NULL, 'Active'),
(1855, '1501044964', NULL, 'admin', NULL, '2017-07-26 12:56:04', NULL, 'Active'),
(1856, '1501053580', NULL, 'admin', NULL, '2017-07-26 15:19:40', NULL, 'Active'),
(1857, '1501115441', NULL, 'admin', NULL, '2017-07-27 08:30:41', NULL, 'Active'),
(1858, '1501134804', NULL, 'admin', NULL, '2017-07-27 13:53:24', NULL, 'Active'),
(1859, '1501147751', NULL, 'admin', NULL, '2017-07-27 17:29:11', NULL, 'Active'),
(1860, '1501203783', NULL, 'admin', NULL, '2017-07-28 09:03:03', NULL, 'Active'),
(1861, '1501208782', NULL, 'admin', NULL, '2017-07-28 10:26:22', NULL, 'Active'),
(1862, '1501213126', NULL, 'admin', NULL, '2017-07-28 11:38:46', NULL, 'Active'),
(1863, '1501220813', NULL, 'admin', NULL, '2017-07-28 13:46:53', NULL, 'Active'),
(1864, '1501290298', NULL, 'admin', NULL, '2017-07-29 09:04:58', NULL, 'Active'),
(1865, '1501293566', NULL, 'admin', NULL, '2017-07-29 09:59:26', NULL, 'Active'),
(1866, '1501293644', NULL, 'admin', NULL, '2017-07-29 10:00:44', NULL, 'Active'),
(1867, '1501296421', NULL, 'admin', NULL, '2017-07-29 10:47:01', NULL, 'Active'),
(1868, '1501297702', NULL, 'admin', NULL, '2017-07-29 11:08:22', NULL, 'Active'),
(1869, '1501299416', NULL, 'admin', NULL, '2017-07-29 11:36:56', NULL, 'Active'),
(1870, '1501304242', NULL, 'admin', NULL, '2017-07-29 12:57:22', NULL, 'Active'),
(1871, '1501307487', NULL, 'admin', NULL, '2017-07-29 13:51:27', NULL, 'Active'),
(1872, '1501376774', NULL, 'admin', NULL, '2017-07-30 09:06:14', NULL, 'Active'),
(1873, '1501379810', NULL, 'admin', NULL, '2017-07-30 09:56:50', NULL, 'Active'),
(1874, '1501380991', NULL, 'admin', NULL, '2017-07-30 10:16:31', NULL, 'Active'),
(1875, '1501384075', NULL, 'admin', NULL, '2017-07-30 11:07:55', NULL, 'Active'),
(1876, '1501384088', NULL, 'admin', NULL, '2017-07-30 11:08:08', NULL, 'Active'),
(1877, '1501386887', NULL, 'admin', NULL, '2017-07-30 11:54:47', NULL, 'Active'),
(1878, '1501388385', NULL, 'admin', NULL, '2017-07-30 12:19:45', NULL, 'Active'),
(1879, '1501390316', NULL, 'admin', NULL, '2017-07-30 12:51:56', NULL, 'Active'),
(1880, '1501390516', NULL, 'admin', NULL, '2017-07-30 12:55:16', NULL, 'Active'),
(1881, '1501392616', NULL, 'admin', NULL, '2017-07-30 13:30:16', NULL, 'Active');
INSERT INTO `sales_sessions` (`id`, `identifier`, `session`, `logged_in_by`, `logged_out_by`, `from`, `to`, `status`) VALUES
(1882, '1501396592', NULL, 'admin', NULL, '2017-07-30 14:36:32', NULL, 'Active'),
(1883, '1501464189', NULL, 'admin', NULL, '2017-07-31 09:23:09', NULL, 'Active'),
(1884, '1501472156', NULL, 'admin', NULL, '2017-07-31 11:35:56', NULL, 'Active'),
(1885, '1501482174', NULL, 'admin', NULL, '2017-07-31 14:22:54', NULL, 'Active'),
(1886, '1501484253', NULL, 'admin', NULL, '2017-07-31 14:57:33', NULL, 'Active'),
(1887, '1501492896', NULL, 'admin', NULL, '2017-07-31 17:21:36', NULL, 'Active'),
(1888, '1501635703', NULL, 'admin', NULL, '2017-08-02 09:01:43', NULL, 'Active'),
(1889, '1501642747', NULL, 'admin', NULL, '2017-08-02 10:59:07', NULL, 'Active'),
(1890, '1501650691', NULL, 'admin', NULL, '2017-08-02 13:11:31', NULL, 'Active'),
(1891, '1501653271', NULL, 'admin', NULL, '2017-08-02 13:54:31', NULL, 'Active'),
(1892, '1501653981', NULL, 'admin', NULL, '2017-08-02 14:06:21', NULL, 'Active'),
(1893, '1501656207', NULL, 'admin', NULL, '2017-08-02 14:43:27', NULL, 'Active'),
(1894, '1501721568', NULL, 'admin', NULL, '2017-08-03 08:52:48', NULL, 'Active'),
(1895, '1501729293', NULL, 'admin', NULL, '2017-08-03 11:01:33', NULL, 'Active'),
(1896, '1501739307', NULL, 'admin', NULL, '2017-08-03 13:48:27', NULL, 'Active'),
(1897, '1501806629', NULL, 'admin', NULL, '2017-08-04 08:30:29', NULL, 'Active'),
(1898, '1501820063', NULL, 'admin', NULL, '2017-08-04 12:14:23', NULL, 'Active'),
(1899, '1501896350', NULL, 'admin', NULL, '2017-08-05 09:25:50', NULL, 'Active'),
(1900, '1501898907', NULL, 'admin', NULL, '2017-08-05 10:08:27', NULL, 'Active'),
(1901, '1501901672', NULL, 'admin', NULL, '2017-08-05 10:54:32', NULL, 'Active'),
(1902, '1501905326', NULL, 'admin', NULL, '2017-08-05 11:55:26', NULL, 'Active'),
(1903, '1501906300', NULL, 'admin', NULL, '2017-08-05 12:11:40', NULL, 'Active'),
(1904, '1501906887', NULL, 'admin', NULL, '2017-08-05 12:21:27', NULL, 'Active'),
(1905, '1501909439', NULL, 'admin', NULL, '2017-08-05 13:03:59', NULL, 'Active'),
(1906, '1501912953', NULL, 'admin', NULL, '2017-08-05 14:02:33', NULL, 'Active'),
(1907, '1501915458', NULL, 'admin', NULL, '2017-08-05 14:44:18', NULL, 'Active'),
(1908, '1501923116', NULL, 'admin', NULL, '2017-08-05 16:51:56', NULL, 'Active'),
(1909, '1501981868', NULL, 'admin', NULL, '2017-08-06 09:11:08', NULL, 'Active'),
(1910, '1501985608', NULL, 'admin', NULL, '2017-08-06 10:13:28', NULL, 'Active'),
(1911, '1501987066', NULL, 'admin', NULL, '2017-08-06 10:37:46', NULL, 'Active'),
(1912, '1501990006', NULL, 'admin', NULL, '2017-08-06 11:26:46', NULL, 'Active'),
(1913, '1501993848', NULL, 'admin', NULL, '2017-08-06 12:30:48', NULL, 'Active'),
(1914, '1501998678', NULL, 'admin', NULL, '2017-08-06 13:51:18', NULL, 'Active'),
(1915, '1502000461', NULL, 'admin', NULL, '2017-08-06 14:21:01', NULL, 'Active'),
(1916, '1502007576', NULL, 'admin', NULL, '2017-08-06 16:19:36', NULL, 'Active'),
(1917, '1502067675', NULL, 'admin', NULL, '2017-08-07 09:01:15', NULL, 'Active'),
(1918, '1502076683', NULL, 'admin', NULL, '2017-08-07 11:31:23', NULL, 'Active'),
(1919, '1502085210', NULL, 'admin', NULL, '2017-08-07 13:53:30', NULL, 'Active'),
(1920, '1502240775', NULL, 'admin', NULL, '2017-08-09 09:06:15', NULL, 'Active'),
(1921, '1502250878', NULL, 'admin', NULL, '2017-08-09 11:54:38', NULL, 'Active'),
(1922, '1502254762', NULL, 'admin', NULL, '2017-08-09 12:59:22', NULL, 'Active'),
(1923, '1502256100', NULL, 'admin', NULL, '2017-08-09 13:21:40', NULL, 'Active'),
(1924, '1502262698', NULL, 'admin', NULL, '2017-08-09 15:11:38', NULL, 'Active'),
(1925, '1502325747', NULL, 'admin', NULL, '2017-08-10 08:42:27', NULL, 'Active'),
(1926, '1502335407', NULL, 'admin', NULL, '2017-08-10 11:23:27', NULL, 'Active'),
(1927, '1502340275', NULL, 'admin', NULL, '2017-08-10 12:44:35', NULL, 'Active'),
(1928, '1502411696', NULL, 'admin', NULL, '2017-08-11 08:34:56', NULL, 'Active'),
(1929, '1502422481', NULL, 'admin', NULL, '2017-08-11 11:34:41', NULL, 'Active'),
(1930, '1502427641', NULL, 'admin', NULL, '2017-08-11 13:00:41', NULL, 'Active'),
(1931, '1502433080', NULL, 'admin', NULL, '2017-08-11 14:31:20', NULL, 'Active'),
(1932, '1502499757', NULL, 'admin', NULL, '2017-08-12 09:02:37', NULL, 'Active'),
(1933, '1502501091', NULL, 'admin', NULL, '2017-08-12 09:24:51', NULL, 'Active'),
(1934, '1502502817', NULL, 'admin', NULL, '2017-08-12 09:53:37', NULL, 'Active'),
(1935, '1502504013', NULL, 'admin', NULL, '2017-08-12 10:13:33', NULL, 'Active'),
(1936, '1502504032', NULL, 'admin', NULL, '2017-08-12 10:13:52', NULL, 'Active'),
(1937, '1502505146', NULL, 'admin', NULL, '2017-08-12 10:32:26', NULL, 'Active'),
(1938, '1502511755', NULL, 'admin', NULL, '2017-08-12 12:22:35', NULL, 'Active'),
(1939, '1502586496', NULL, 'admin', NULL, '2017-08-13 09:08:16', NULL, 'Active'),
(1940, '1502588024', NULL, 'admin', NULL, '2017-08-13 09:33:44', NULL, 'Active'),
(1941, '1502589215', NULL, 'admin', NULL, '2017-08-13 09:53:35', NULL, 'Active'),
(1942, '1502590289', NULL, 'admin', NULL, '2017-08-13 10:11:29', NULL, 'Active'),
(1943, '1502592651', NULL, 'admin', NULL, '2017-08-13 10:50:51', NULL, 'Active'),
(1944, '1502597154', NULL, 'admin', NULL, '2017-08-13 12:05:54', NULL, 'Active'),
(1945, '1502601812', NULL, 'admin', NULL, '2017-08-13 13:23:32', NULL, 'Active'),
(1946, '1502604446', NULL, 'admin', NULL, '2017-08-13 14:07:26', NULL, 'Active'),
(1947, '1502673052', NULL, 'admin', NULL, '2017-08-14 09:10:52', NULL, 'Active'),
(1948, '1502684691', NULL, 'admin', NULL, '2017-08-14 12:24:51', NULL, 'Active'),
(1949, '1502686902', NULL, 'admin', NULL, '2017-08-14 13:01:42', NULL, 'Active'),
(1950, '1502845141', NULL, 'admin', NULL, '2017-08-16 08:59:01', NULL, 'Active'),
(1951, '1502857330', NULL, 'admin', NULL, '2017-08-16 12:22:10', NULL, 'Active'),
(1952, '1502859986', NULL, 'admin', NULL, '2017-08-16 13:06:26', NULL, 'Active'),
(1953, '1502931780', NULL, 'admin', NULL, '2017-08-17 09:03:00', NULL, 'Active'),
(1954, '1502939025', NULL, 'admin', NULL, '2017-08-17 11:03:45', NULL, 'Active'),
(1955, '1502948728', NULL, 'admin', NULL, '2017-08-17 13:45:28', NULL, 'Active'),
(1956, '1503016596', NULL, 'admin', NULL, '2017-08-18 08:36:36', NULL, 'Active'),
(1957, '1503032384', NULL, 'admin', NULL, '2017-08-18 12:59:44', NULL, 'Active'),
(1958, '1503032407', NULL, 'admin', NULL, '2017-08-18 13:00:07', NULL, 'Active'),
(1959, '1503032434', NULL, 'admin', NULL, '2017-08-18 13:00:34', NULL, 'Active'),
(1960, '1503032548', NULL, 'admin', NULL, '2017-08-18 13:02:28', NULL, 'Active'),
(1961, '1503032561', NULL, 'admin', NULL, '2017-08-18 13:02:41', NULL, 'Active'),
(1962, '1503104393', NULL, 'admin', NULL, '2017-08-19 08:59:53', NULL, 'Active'),
(1963, '1503107856', NULL, 'admin', NULL, '2017-08-19 09:57:36', NULL, 'Active'),
(1964, '1503114043', NULL, 'admin', NULL, '2017-08-19 11:40:43', NULL, 'Active'),
(1965, '1503116100', NULL, 'admin', NULL, '2017-08-19 12:15:00', NULL, 'Active'),
(1966, '1503122978', NULL, 'admin', NULL, '2017-08-19 14:09:38', NULL, 'Active'),
(1967, '1503190854', NULL, 'admin', NULL, '2017-08-20 09:00:54', NULL, 'Active'),
(1968, '1503192542', NULL, 'admin', NULL, '2017-08-20 09:29:02', NULL, 'Active'),
(1969, '1503193507', NULL, 'admin', NULL, '2017-08-20 09:45:07', NULL, 'Active'),
(1970, '1503197194', NULL, 'admin', NULL, '2017-08-20 10:46:34', NULL, 'Active'),
(1971, '1503204457', NULL, 'admin', NULL, '2017-08-20 12:47:37', NULL, 'Active'),
(1972, '1503207695', NULL, 'admin', NULL, '2017-08-20 13:41:35', NULL, 'Active'),
(1973, '1503211146', NULL, 'admin', NULL, '2017-08-20 14:39:06', NULL, 'Active'),
(1974, '1503217811', NULL, 'admin', NULL, '2017-08-20 16:30:11', NULL, 'Active'),
(1975, '1503277942', NULL, 'admin', NULL, '2017-08-21 09:12:22', NULL, 'Active'),
(1976, '1503285279', NULL, 'admin', NULL, '2017-08-21 11:14:39', NULL, 'Active'),
(1977, '1503286711', NULL, 'admin', NULL, '2017-08-21 11:38:31', NULL, 'Active'),
(1978, '1503296751', NULL, 'admin', NULL, '2017-08-21 14:25:51', NULL, 'Active'),
(1979, '1503451445', NULL, 'admin', NULL, '2017-08-23 09:24:05', NULL, 'Active'),
(1980, '1503460550', NULL, 'admin', NULL, '2017-08-23 11:55:50', NULL, 'Active'),
(1981, '1503465960', NULL, 'admin', NULL, '2017-08-23 13:26:00', NULL, 'Active'),
(1982, '1503536743', NULL, 'admin', NULL, '2017-08-24 09:05:43', NULL, 'Active'),
(1983, '1503544242', NULL, 'admin', NULL, '2017-08-24 11:10:42', NULL, 'Active'),
(1984, '1503554629', NULL, 'admin', NULL, '2017-08-24 14:03:49', NULL, 'Active'),
(1985, '1503622823', NULL, 'admin', NULL, '2017-08-25 09:00:23', NULL, 'Active'),
(1986, '1503632165', NULL, 'admin', NULL, '2017-08-25 11:36:05', NULL, 'Active'),
(1987, '1503638117', NULL, 'admin', NULL, '2017-08-25 13:15:17', NULL, 'Active'),
(1988, '1503643027', NULL, 'admin', NULL, '2017-08-25 14:37:07', NULL, 'Active'),
(1989, '1503708992', NULL, 'admin', NULL, '2017-08-26 08:56:32', NULL, 'Active'),
(1990, '1503712207', NULL, 'admin', NULL, '2017-08-26 09:50:07', NULL, 'Active'),
(1991, '1503715959', NULL, 'admin', NULL, '2017-08-26 10:52:39', NULL, 'Active'),
(1992, '1503718638', NULL, 'admin', NULL, '2017-08-26 11:37:18', NULL, 'Active'),
(1993, '1503722221', NULL, 'lois', NULL, '2017-08-26 12:37:01', NULL, 'Active'),
(1994, '1503731258', NULL, 'admin', NULL, '2017-08-26 15:07:38', NULL, 'Active'),
(1995, '1503794105', NULL, 'admin', NULL, '2017-08-27 08:35:05', NULL, 'Active'),
(1996, '1503800947', NULL, 'admin', NULL, '2017-08-27 10:29:07', NULL, 'Active'),
(1997, '1503802629', NULL, 'admin', NULL, '2017-08-27 10:57:09', NULL, 'Active'),
(1998, '1503806685', NULL, 'admin', NULL, '2017-08-27 12:04:45', NULL, 'Active'),
(1999, '1503810286', NULL, 'admin', NULL, '2017-08-27 13:04:46', NULL, 'Active'),
(2000, '1503814520', NULL, 'admin', NULL, '2017-08-27 14:15:20', NULL, 'Active'),
(2001, '1503882076', NULL, 'admin', NULL, '2017-08-28 09:01:16', NULL, 'Active'),
(2002, '1503898703', NULL, 'admin', NULL, '2017-08-28 13:38:23', NULL, 'Active'),
(2003, '1504055748', NULL, 'admin', NULL, '2017-08-30 09:15:48', NULL, 'Active'),
(2004, '1504060332', NULL, 'admin', NULL, '2017-08-30 10:32:12', NULL, 'Active'),
(2005, '1504070318', NULL, 'lois', NULL, '2017-08-30 13:18:38', NULL, 'Active'),
(2006, '1504140108', NULL, 'admin', NULL, '2017-08-31 08:41:48', NULL, 'Active'),
(2007, '1504146305', NULL, 'admin', NULL, '2017-08-31 10:25:05', NULL, 'Active'),
(2008, '1504152136', NULL, 'admin', NULL, '2017-08-31 12:02:16', NULL, 'Active'),
(2009, '1504161458', NULL, 'admin', NULL, '2017-08-31 14:37:38', NULL, 'Active'),
(2010, '1504226956', NULL, 'admin', NULL, '2017-09-01 08:49:16', NULL, 'Active'),
(2011, '1504235199', NULL, 'admin', NULL, '2017-09-01 11:06:39', NULL, 'Active'),
(2012, '1504238239', NULL, 'admin', NULL, '2017-09-01 11:57:19', NULL, 'Active'),
(2013, '1504244728', NULL, 'admin', NULL, '2017-09-01 13:45:28', NULL, 'Active'),
(2014, '1504251976', NULL, 'admin', NULL, '2017-09-01 15:46:16', NULL, 'Active'),
(2015, '1504259386', NULL, 'sanni', NULL, '2017-09-01 17:49:46', NULL, 'Active'),
(2016, '1504319848', NULL, 'admin', NULL, '2017-09-02 10:37:28', NULL, 'Active'),
(2017, '1504324863', NULL, 'admin', NULL, '2017-09-02 12:01:03', NULL, 'Active'),
(2018, '1504400131', NULL, 'admin', NULL, '2017-09-03 08:55:31', NULL, 'Active'),
(2019, '1504407199', NULL, 'admin', NULL, '2017-09-03 10:53:19', NULL, 'Active'),
(2020, '1504413175', NULL, 'admin', NULL, '2017-09-03 12:32:55', NULL, 'Active'),
(2021, '1504414860', NULL, 'admin', NULL, '2017-09-03 13:01:00', NULL, 'Active'),
(2022, '1504485270', NULL, 'admin', NULL, '2017-09-04 08:34:30', NULL, 'Active'),
(2023, '1504493749', NULL, 'lois', NULL, '2017-09-04 10:55:49', NULL, 'Active'),
(2024, '1504506284', NULL, 'admin', NULL, '2017-09-04 14:24:44', NULL, 'Active'),
(2025, '1504660309', NULL, 'admin', NULL, '2017-09-06 09:11:49', NULL, 'Active'),
(2026, '1504746280', NULL, 'admin', NULL, '2017-09-07 09:04:40', NULL, 'Active'),
(2027, '1504761354', NULL, 'admin', NULL, '2017-09-07 13:15:54', NULL, 'Active'),
(2028, '1504831437', NULL, 'admin', NULL, '2017-09-08 08:43:57', NULL, 'Active'),
(2029, '1504917608', NULL, 'admin', NULL, '2017-09-09 08:40:08', NULL, 'Active'),
(2030, '1504922410', NULL, 'admin', NULL, '2017-09-09 10:00:10', NULL, 'Active'),
(2031, '1504925273', NULL, 'admin', NULL, '2017-09-09 10:47:53', NULL, 'Active'),
(2032, '1504928998', NULL, 'admin', NULL, '2017-09-09 11:49:58', NULL, 'Active'),
(2033, '1504933524', NULL, 'admin', NULL, '2017-09-09 13:05:24', NULL, 'Active'),
(2034, '1504949053', NULL, 'admin', NULL, '2017-09-09 17:24:13', NULL, 'Active'),
(2035, '1505005586', NULL, 'admin', NULL, '2017-09-10 09:06:26', NULL, 'Active'),
(2036, '1505011244', NULL, 'admin', NULL, '2017-09-10 10:40:44', NULL, 'Active'),
(2037, '1505015850', NULL, 'admin', NULL, '2017-09-10 11:57:30', NULL, 'Active'),
(2038, '1505025773', NULL, 'admin', NULL, '2017-09-10 14:42:53', NULL, 'Active'),
(2039, '1505091452', NULL, 'lois', NULL, '2017-09-11 08:57:32', NULL, 'Active'),
(2040, '1505099080', NULL, 'admin', NULL, '2017-09-11 11:04:40', NULL, 'Active'),
(2041, '1505102471', NULL, 'admin', NULL, '2017-09-11 12:01:11', NULL, 'Active'),
(2042, '1505106729', NULL, 'admin', NULL, '2017-09-11 13:12:09', NULL, 'Active'),
(2043, '1505109385', NULL, 'admin', NULL, '2017-09-11 13:56:25', NULL, 'Active'),
(2044, '1505264071', NULL, 'admin', NULL, '2017-09-13 08:54:31', NULL, 'Active'),
(2045, '1505276547', NULL, 'admin', NULL, '2017-09-13 12:22:27', NULL, 'Active'),
(2046, '1505351129', NULL, 'admin', NULL, '2017-09-14 09:05:29', NULL, 'Active'),
(2047, '1505359355', NULL, 'admin', NULL, '2017-09-14 11:22:35', NULL, 'Active'),
(2048, '1505359937', NULL, 'admin', NULL, '2017-09-14 11:32:17', NULL, 'Active'),
(2049, '1505366253', NULL, 'admin', NULL, '2017-09-14 13:17:33', NULL, 'Active'),
(2050, '1505444587', NULL, 'admin', NULL, '2017-09-15 11:03:07', NULL, 'Active'),
(2051, '1505458856', NULL, 'admin', NULL, '2017-09-15 15:00:56', NULL, 'Active'),
(2052, '1505524105', NULL, 'admin', NULL, '2017-09-16 09:08:25', NULL, 'Active'),
(2053, '1505529213', NULL, 'admin', NULL, '2017-09-16 10:33:33', NULL, 'Active'),
(2054, '1505535925', NULL, 'admin', NULL, '2017-09-16 12:25:25', NULL, 'Active'),
(2055, '1505541957', NULL, 'admin', NULL, '2017-09-16 14:05:57', NULL, 'Active'),
(2056, '1505546592', NULL, 'admin', NULL, '2017-09-16 15:23:12', NULL, 'Active'),
(2057, '1505546617', NULL, 'admin', NULL, '2017-09-16 15:23:37', NULL, 'Active'),
(2058, '1505546718', NULL, 'admin', NULL, '2017-09-16 15:25:18', NULL, 'Active'),
(2059, '1505608753', NULL, 'admin', NULL, '2017-09-17 08:39:13', NULL, 'Active'),
(2060, '1505614815', NULL, 'admin', NULL, '2017-09-17 10:20:15', NULL, 'Active'),
(2061, '1505622616', NULL, 'admin', NULL, '2017-09-17 12:30:16', NULL, 'Active'),
(2062, '1505625561', NULL, 'admin', NULL, '2017-09-17 13:19:21', NULL, 'Active'),
(2063, '1505629426', NULL, 'admin', NULL, '2017-09-17 14:23:46', NULL, 'Active'),
(2064, '1505696771', NULL, 'admin', NULL, '2017-09-18 09:06:11', NULL, 'Active'),
(2065, '1505708590', NULL, 'admin', NULL, '2017-09-18 12:23:10', NULL, 'Active'),
(2066, '1505726890', NULL, 'admin', NULL, '2017-09-18 17:28:10', NULL, 'Active'),
(2067, '1505869259', NULL, 'admin', NULL, '2017-09-20 09:00:59', NULL, 'Active'),
(2068, '1505873825', NULL, 'admin', NULL, '2017-09-20 10:17:05', NULL, 'Active'),
(2069, '1505893878', NULL, 'admin', NULL, '2017-09-20 15:51:18', NULL, 'Active'),
(2070, '1505956814', NULL, 'admin', NULL, '2017-09-21 09:20:14', NULL, 'Active'),
(2071, '1505965162', NULL, 'admin', NULL, '2017-09-21 11:39:22', NULL, 'Active'),
(2072, '1505975619', NULL, 'admin', NULL, '2017-09-21 14:33:39', NULL, 'Active'),
(2073, '1506042971', NULL, 'admin', NULL, '2017-09-22 09:16:11', NULL, 'Active'),
(2074, '1506049672', NULL, 'admin', NULL, '2017-09-22 11:07:52', NULL, 'Active'),
(2075, '1506055637', NULL, 'admin', NULL, '2017-09-22 12:47:17', NULL, 'Active'),
(2076, '1506069153', NULL, 'admin', NULL, '2017-09-22 16:32:33', NULL, 'Active'),
(2077, '1506129025', NULL, 'admin', NULL, '2017-09-23 09:10:25', NULL, 'Active'),
(2078, '1506135454', NULL, 'admin', NULL, '2017-09-23 10:57:34', NULL, 'Active'),
(2079, '1506141352', NULL, 'admin', NULL, '2017-09-23 12:35:52', NULL, 'Active'),
(2080, '1506150067', NULL, 'admin', NULL, '2017-09-23 15:01:08', NULL, 'Active'),
(2081, '1506152110', NULL, 'admin', NULL, '2017-09-23 15:35:10', NULL, 'Active'),
(2082, '1506214529', NULL, 'admin', NULL, '2017-09-24 08:55:29', NULL, 'Active'),
(2083, '1506219774', NULL, 'admin', NULL, '2017-09-24 10:22:54', NULL, 'Active'),
(2084, '1506220539', NULL, 'admin', NULL, '2017-09-24 10:35:39', NULL, 'Active'),
(2085, '1506223104', NULL, 'admin', NULL, '2017-09-24 11:18:24', NULL, 'Active'),
(2086, '1506229681', NULL, 'admin', NULL, '2017-09-24 13:08:01', NULL, 'Active'),
(2087, '1506301454', NULL, 'admin', NULL, '2017-09-25 09:04:14', NULL, 'Active'),
(2088, '1506314121', NULL, 'admin', NULL, '2017-09-25 12:35:21', NULL, 'Active'),
(2089, '1506475268', NULL, 'admin', NULL, '2017-09-27 09:21:08', NULL, 'Active'),
(2090, '1506489928', NULL, 'admin', NULL, '2017-09-27 13:25:28', NULL, 'Active'),
(2091, '1506561336', NULL, 'admin', NULL, '2017-09-28 09:15:36', NULL, 'Active'),
(2092, '1506562404', NULL, 'admin', NULL, '2017-09-28 09:33:24', NULL, 'Active'),
(2093, '1506647044', NULL, 'admin', NULL, '2017-09-29 09:04:04', NULL, 'Active'),
(2094, '1506658325', NULL, 'admin', NULL, '2017-09-29 12:12:05', NULL, 'Active'),
(2095, '1506664852', NULL, 'admin', NULL, '2017-09-29 14:00:52', NULL, 'Active'),
(2096, '1506732936', NULL, 'admin', NULL, '2017-09-30 08:55:36', NULL, 'Active'),
(2097, '1506739636', NULL, 'admin', NULL, '2017-09-30 10:47:16', NULL, 'Active'),
(2098, '1506742277', NULL, 'admin', NULL, '2017-09-30 11:31:17', NULL, 'Active'),
(2099, '1506743665', NULL, 'admin', NULL, '2017-09-30 11:54:25', NULL, 'Active'),
(2100, '1506743821', NULL, 'admin', NULL, '2017-09-30 11:57:01', NULL, 'Active'),
(2101, '1506743997', NULL, 'sanni', NULL, '2017-09-30 11:59:57', NULL, 'Active'),
(2102, '1506750592', NULL, 'admin', NULL, '2017-09-30 13:49:52', NULL, 'Active'),
(2103, '1506818470', NULL, 'admin', NULL, '2017-10-01 08:41:10', NULL, 'Active'),
(2104, '1506825944', NULL, 'admin', NULL, '2017-10-01 10:45:44', NULL, 'Active'),
(2105, '1506828994', NULL, 'admin', NULL, '2017-10-01 11:36:34', NULL, 'Active'),
(2106, '1506835110', NULL, 'admin', NULL, '2017-10-01 13:18:30', NULL, 'Active'),
(2107, '1506837768', NULL, 'admin', NULL, '2017-10-01 14:02:48', NULL, 'Active'),
(2108, '1506906865', NULL, 'admin', NULL, '2017-10-02 09:14:25', NULL, 'Active'),
(2109, '1506916470', NULL, 'admin', NULL, '2017-10-02 11:54:30', NULL, 'Active'),
(2110, '1507079160', NULL, 'admin', NULL, '2017-10-04 09:06:00', NULL, 'Active'),
(2111, '1507094760', NULL, 'admin', NULL, '2017-10-04 13:26:00', NULL, 'Active'),
(2112, '1507107061', NULL, 'admin', NULL, '2017-10-04 16:51:01', NULL, 'Active'),
(2113, '1507164843', NULL, 'admin', NULL, '2017-10-05 08:54:03', NULL, 'Active'),
(2114, '1507167722', NULL, 'admin', NULL, '2017-10-05 09:42:02', NULL, 'Active'),
(2115, '1507175503', NULL, 'admin', NULL, '2017-10-05 11:51:43', NULL, 'Active'),
(2116, '1507182289', NULL, 'admin', NULL, '2017-10-05 13:44:49', NULL, 'Active'),
(2117, '1507197410', NULL, 'admin', NULL, '2017-10-05 17:56:50', NULL, 'Active'),
(2118, '1507257843', NULL, 'admin', NULL, '2017-10-06 10:44:03', NULL, 'Active'),
(2119, '1507269351', NULL, 'admin', NULL, '2017-10-06 13:55:51', NULL, 'Active'),
(2120, '1507338062', NULL, 'admin', NULL, '2017-10-07 09:01:02', NULL, 'Active'),
(2121, '1507345210', NULL, 'admin', NULL, '2017-10-07 11:00:10', NULL, 'Active'),
(2122, '1507353045', NULL, 'admin', NULL, '2017-10-07 13:10:45', NULL, 'Active'),
(2123, '1507357676', NULL, 'admin', NULL, '2017-10-07 14:27:56', NULL, 'Active'),
(2124, '1507424713', NULL, 'admin', NULL, '2017-10-08 09:05:13', NULL, 'Active'),
(2125, '1507432281', NULL, 'admin', NULL, '2017-10-08 11:11:21', NULL, 'Active'),
(2126, '1507438407', NULL, 'admin', NULL, '2017-10-08 12:53:27', NULL, 'Active'),
(2127, '1507442048', NULL, 'admin', NULL, '2017-10-08 13:54:08', NULL, 'Active'),
(2128, '1507452888', NULL, 'admin', NULL, '2017-10-08 16:54:48', NULL, 'Active'),
(2129, '1507511191', NULL, 'admin', NULL, '2017-10-09 09:06:31', NULL, 'Active'),
(2130, '1507522881', NULL, 'admin', NULL, '2017-10-09 12:21:21', NULL, 'Active'),
(2131, '1507535722', NULL, 'admin', NULL, '2017-10-09 15:55:22', NULL, 'Active'),
(2132, '1507684036', NULL, 'admin', NULL, '2017-10-11 09:07:16', NULL, 'Active'),
(2133, '1507689985', NULL, 'admin', NULL, '2017-10-11 10:46:25', NULL, 'Active'),
(2134, '1507715050', NULL, 'admin', NULL, '2017-10-11 17:44:10', NULL, 'Active'),
(2135, '1507769350', NULL, 'admin', NULL, '2017-10-12 08:49:10', NULL, 'Active'),
(2136, '1507781947', NULL, 'admin', NULL, '2017-10-12 12:19:07', NULL, 'Active'),
(2137, '1507856206', NULL, 'admin', NULL, '2017-10-13 08:56:46', NULL, 'Active'),
(2138, '1507867671', NULL, 'admin', NULL, '2017-10-13 12:07:51', NULL, 'Active'),
(2139, '1507880716', NULL, 'admin', NULL, '2017-10-13 15:45:16', NULL, 'Active'),
(2140, '1507942523', NULL, 'admin', NULL, '2017-10-14 08:55:23', NULL, 'Active'),
(2141, '1507948472', NULL, 'admin', NULL, '2017-10-14 10:34:32', NULL, 'Active'),
(2142, '1507955619', NULL, 'admin', NULL, '2017-10-14 12:33:39', NULL, 'Active'),
(2143, '1507967892', NULL, 'admin', NULL, '2017-10-14 15:58:12', NULL, 'Active'),
(2144, '1508028344', NULL, 'admin', NULL, '2017-10-15 08:45:44', NULL, 'Active'),
(2145, '1508033215', NULL, 'admin', NULL, '2017-10-15 10:06:55', NULL, 'Active'),
(2146, '1508034832', NULL, 'admin', NULL, '2017-10-15 10:33:52', NULL, 'Active'),
(2147, '1508038896', NULL, 'admin', NULL, '2017-10-15 11:41:36', NULL, 'Active'),
(2148, '1508042465', NULL, 'admin', NULL, '2017-10-15 12:41:05', NULL, 'Active'),
(2149, '1508045791', NULL, 'admin', NULL, '2017-10-15 13:36:31', NULL, 'Active'),
(2150, '1508051981', NULL, 'admin', NULL, '2017-10-15 15:19:41', NULL, 'Active'),
(2151, '1508052010', NULL, 'admin', NULL, '2017-10-15 15:20:10', NULL, 'Active'),
(2152, '1508116368', NULL, 'admin', NULL, '2017-10-16 09:12:48', NULL, 'Active'),
(2153, '1508122963', NULL, 'admin', NULL, '2017-10-16 11:02:43', NULL, 'Active'),
(2154, '1508125905', NULL, 'admin', NULL, '2017-10-16 11:51:45', NULL, 'Active'),
(2155, '1508130625', NULL, 'admin', NULL, '2017-10-16 13:10:25', NULL, 'Active'),
(2156, '1508287842', NULL, 'admin', NULL, '2017-10-18 08:50:42', NULL, 'Active'),
(2157, '1508292997', NULL, 'admin', NULL, '2017-10-18 10:16:37', NULL, 'Active'),
(2158, '1508297123', NULL, 'admin', NULL, '2017-10-18 11:25:23', NULL, 'Active'),
(2159, '1508300693', NULL, 'admin', NULL, '2017-10-18 12:24:53', NULL, 'Active'),
(2160, '1508305602', NULL, 'admin', NULL, '2017-10-18 13:46:42', NULL, 'Active'),
(2161, '1508308195', NULL, 'admin', NULL, '2017-10-18 14:29:55', NULL, 'Active'),
(2162, '1508315138', NULL, 'admin', NULL, '2017-10-18 16:25:38', NULL, 'Active'),
(2163, '1508373476', NULL, 'admin', NULL, '2017-10-19 08:37:56', NULL, 'Active'),
(2164, '1508381954', NULL, 'admin', NULL, '2017-10-19 10:59:14', NULL, 'Active'),
(2165, '1508392949', NULL, 'admin', NULL, '2017-10-19 14:02:29', NULL, 'Active'),
(2166, '1508461080', NULL, 'admin', NULL, '2017-10-20 08:58:00', NULL, 'Active'),
(2167, '1508476012', NULL, 'admin', NULL, '2017-10-20 13:06:52', NULL, 'Active'),
(2168, '1508546067', NULL, 'admin', NULL, '2017-10-21 08:34:27', NULL, 'Active'),
(2169, '1508553952', NULL, 'admin', NULL, '2017-10-21 10:45:52', NULL, 'Active'),
(2170, '1508556031', NULL, 'admin', NULL, '2017-10-21 11:20:31', NULL, 'Active'),
(2171, '1508562284', NULL, 'admin', NULL, '2017-10-21 13:04:44', NULL, 'Active'),
(2172, '1508633280', NULL, 'admin', NULL, '2017-10-22 08:48:00', NULL, 'Active'),
(2173, '1508637777', NULL, 'admin', NULL, '2017-10-22 10:02:57', NULL, 'Active'),
(2174, '1508640114', NULL, 'admin', NULL, '2017-10-22 10:41:54', NULL, 'Active'),
(2175, '1508644954', NULL, 'admin', NULL, '2017-10-22 12:02:34', NULL, 'Active'),
(2176, '1508720150', NULL, 'admin', NULL, '2017-10-23 08:55:50', NULL, 'Active'),
(2177, '1508732585', NULL, 'admin', NULL, '2017-10-23 12:23:05', NULL, 'Active'),
(2178, '1508892781', NULL, 'admin', NULL, '2017-10-25 08:53:01', NULL, 'Active'),
(2179, '1508909330', NULL, 'admin', NULL, '2017-10-25 13:28:50', NULL, 'Active'),
(2180, '1508978592', NULL, 'admin', NULL, '2017-10-26 08:43:12', NULL, 'Active'),
(2181, '1508993224', NULL, 'admin', NULL, '2017-10-26 12:47:04', NULL, 'Active'),
(2182, '1509065731', NULL, 'admin', NULL, '2017-10-27 08:55:31', NULL, 'Active'),
(2183, '1509151411', NULL, 'admin', NULL, '2017-10-28 08:43:31', NULL, 'Active'),
(2184, '1509158038', NULL, 'admin', NULL, '2017-10-28 10:33:58', NULL, 'Active'),
(2185, '1509162920', NULL, 'admin', NULL, '2017-10-28 11:55:20', NULL, 'Active'),
(2186, '1509170912', NULL, 'admin', NULL, '2017-10-28 14:08:32', NULL, 'Active'),
(2187, '1509173804', NULL, 'admin', NULL, '2017-10-28 14:56:44', NULL, 'Active'),
(2188, '1509238833', NULL, 'admin', NULL, '2017-10-29 09:00:33', NULL, 'Active'),
(2189, '1509243968', NULL, 'admin', NULL, '2017-10-29 10:26:08', NULL, 'Active'),
(2190, '1509246111', NULL, 'admin', NULL, '2017-10-29 11:01:51', NULL, 'Active'),
(2191, '1509249892', NULL, 'admin', NULL, '2017-10-29 12:04:52', NULL, 'Active'),
(2192, '1509257350', NULL, 'admin', NULL, '2017-10-29 14:09:10', NULL, 'Active'),
(2193, '1509260716', NULL, 'admin', NULL, '2017-10-29 15:05:16', NULL, 'Active'),
(2194, '1509324952', NULL, 'admin', NULL, '2017-10-30 08:55:52', NULL, 'Active'),
(2195, '1509334527', NULL, 'admin', NULL, '2017-10-30 11:35:27', NULL, 'Active'),
(2196, '1509498256', NULL, 'admin', NULL, '2017-11-01 09:04:16', NULL, 'Active'),
(2197, '1509513230', NULL, 'admin', NULL, '2017-11-01 13:13:50', NULL, 'Active'),
(2198, '1509583757', NULL, 'admin', NULL, '2017-11-02 08:49:17', NULL, 'Active'),
(2199, '1509595522', NULL, 'admin', NULL, '2017-11-02 12:05:22', NULL, 'Active'),
(2200, '1509613823', NULL, 'admin', NULL, '2017-11-02 17:10:23', NULL, 'Active'),
(2201, '1509757301', NULL, 'admin', NULL, '2017-11-04 09:01:41', NULL, 'Active'),
(2202, '1509758427', NULL, 'admin', NULL, '2017-11-04 09:20:27', NULL, 'Active'),
(2203, '1509761400', NULL, 'admin', NULL, '2017-11-04 10:10:00', NULL, 'Active'),
(2204, '1509763941', NULL, 'admin', NULL, '2017-11-04 10:52:21', NULL, 'Active'),
(2205, '1509769719', NULL, 'admin', NULL, '2017-11-04 12:28:39', NULL, 'Active'),
(2206, '1509842535', NULL, 'admin', NULL, '2017-11-05 08:42:15', NULL, 'Active'),
(2207, '1509850038', NULL, 'admin', NULL, '2017-11-05 10:47:18', NULL, 'Active'),
(2208, '1509855311', NULL, 'admin', NULL, '2017-11-05 12:15:11', NULL, 'Active'),
(2209, '1509863774', NULL, 'admin', NULL, '2017-11-05 14:36:14', NULL, 'Active'),
(2210, '1509929750', NULL, 'admin', NULL, '2017-11-06 08:55:50', NULL, 'Active'),
(2211, '1509954235', NULL, 'admin', NULL, '2017-11-06 15:43:55', NULL, 'Active'),
(2212, '1510103209', NULL, 'admin', NULL, '2017-11-08 09:06:49', NULL, 'Active'),
(2213, '1510189207', NULL, 'admin', NULL, '2017-11-09 09:00:07', NULL, 'Active'),
(2214, '1510195264', NULL, 'admin', NULL, '2017-11-09 10:41:04', NULL, 'Active'),
(2215, '1510276265', NULL, 'admin', NULL, '2017-11-10 09:11:05', NULL, 'Active'),
(2216, '1510362498', NULL, 'admin', NULL, '2017-11-11 09:08:18', NULL, 'Active'),
(2217, '1510385859', NULL, 'admin', NULL, '2017-11-11 15:37:39', NULL, 'Active'),
(2218, '1510446193', NULL, 'admin', NULL, '2017-11-12 08:23:13', NULL, 'Active'),
(2219, '1510449408', NULL, 'admin', NULL, '2017-11-12 09:16:48', NULL, 'Active'),
(2220, '1510535091', NULL, 'admin', NULL, '2017-11-13 09:04:51', NULL, 'Active'),
(2221, '1510707861', NULL, 'admin', NULL, '2017-11-15 09:04:21', NULL, 'Active'),
(2222, '1510794028', NULL, 'admin', NULL, '2017-11-16 09:00:28', NULL, 'Active'),
(2223, '1510880695', NULL, 'admin', NULL, '2017-11-17 09:04:55', NULL, 'Active'),
(2224, '1510967819', NULL, 'admin', NULL, '2017-11-18 09:16:59', NULL, 'Active'),
(2225, '1511052202', NULL, 'admin', NULL, '2017-11-19 08:43:22', NULL, 'Active'),
(2226, '1511139560', NULL, 'admin', NULL, '2017-11-20 08:59:20', NULL, 'Active'),
(2227, '1511312483', NULL, 'admin', NULL, '2017-11-22 09:01:23', NULL, 'Active'),
(2228, '1511322682', NULL, 'admin', NULL, '2017-11-22 11:51:22', NULL, 'Active'),
(2229, '1511400080', NULL, 'admin', NULL, '2017-11-23 09:21:20', NULL, 'Active'),
(2230, '1511485303', NULL, 'admin', NULL, '2017-11-24 09:01:43', NULL, 'Active'),
(2231, '1511570825', NULL, 'admin', NULL, '2017-11-25 08:47:05', NULL, 'Active'),
(2232, '1511656639', NULL, 'admin', NULL, '2017-11-26 08:37:19', NULL, 'Active'),
(2233, '1511689231', NULL, 'admin', NULL, '2017-11-26 17:40:31', NULL, 'Active'),
(2234, '1511744410', NULL, 'admin', NULL, '2017-11-27 09:00:10', NULL, 'Active'),
(2235, '1511917899', NULL, 'admin', NULL, '2017-11-29 09:11:39', NULL, 'Active'),
(2236, '1512004065', NULL, 'admin', NULL, '2017-11-30 09:07:45', NULL, 'Active'),
(2237, '1512017420', NULL, 'admin', NULL, '2017-11-30 12:50:20', NULL, 'Active'),
(2238, '1512090445', NULL, 'admin', NULL, '2017-12-01 09:07:25', NULL, 'Active'),
(2239, '1512176007', NULL, 'admin', NULL, '2017-12-02 08:53:27', NULL, 'Active'),
(2240, '1512262587', NULL, 'admin', NULL, '2017-12-03 08:56:27', NULL, 'Active'),
(2241, '1512276983', NULL, 'admin', NULL, '2017-12-03 12:56:23', NULL, 'Active'),
(2242, '1512348404', NULL, 'admin', NULL, '2017-12-04 08:46:44', NULL, 'Active'),
(2243, '1512522216', NULL, 'admin', NULL, '2017-12-06 09:03:36', NULL, 'Active'),
(2244, '1512607716', NULL, 'admin', NULL, '2017-12-07 08:48:36', NULL, 'Active'),
(2245, '1512694546', NULL, 'admin', NULL, '2017-12-08 08:55:46', NULL, 'Active'),
(2246, '1512781827', NULL, 'admin', NULL, '2017-12-09 09:10:27', NULL, 'Active'),
(2247, '1512802134', NULL, 'admin', NULL, '2017-12-09 14:48:54', NULL, 'Active'),
(2248, '1512867626', NULL, 'admin', NULL, '2017-12-10 09:00:26', NULL, 'Active'),
(2249, '1512954184', NULL, 'admin', NULL, '2017-12-11 09:03:04', NULL, 'Active'),
(2250, '1513127221', NULL, 'admin', NULL, '2017-12-13 09:07:01', NULL, 'Active'),
(2251, '1513212408', NULL, 'admin', NULL, '2017-12-14 08:46:48', NULL, 'Active'),
(2252, '1513299774', NULL, 'admin', NULL, '2017-12-15 09:02:54', NULL, 'Active'),
(2253, '1513386801', NULL, 'admin', NULL, '2017-12-16 09:13:21', NULL, 'Active'),
(2254, '1513470685', NULL, 'admin', NULL, '2017-12-17 08:31:25', NULL, 'Active'),
(2255, '1513559204', NULL, 'admin', NULL, '2017-12-18 09:06:44', NULL, 'Active'),
(2256, '1513591586', NULL, 'admin', NULL, '2017-12-18 18:06:26', NULL, 'Active'),
(2257, '1513731387', NULL, 'admin', NULL, '2017-12-20 08:56:27', NULL, 'Active'),
(2258, '1513825690', NULL, 'lois', NULL, '2017-12-21 11:08:10', NULL, 'Active'),
(2259, '1513843309', NULL, 'admin', NULL, '2017-12-21 16:01:49', NULL, 'Active'),
(2260, '1513903960', NULL, 'admin', NULL, '2017-12-22 08:52:40', NULL, 'Active'),
(2261, '1513991686', NULL, 'admin', NULL, '2017-12-23 09:14:46', NULL, 'Active'),
(2262, '1514076984', NULL, 'admin', NULL, '2017-12-24 08:56:24', NULL, 'Active'),
(2263, '1514162528', NULL, 'admin', NULL, '2017-12-25 08:42:08', NULL, 'Active'),
(2264, '1514336956', NULL, 'admin', NULL, '2017-12-27 09:09:16', NULL, 'Active'),
(2265, '1514421741', NULL, 'admin', NULL, '2017-12-28 08:42:21', NULL, 'Active'),
(2266, '1514509445', NULL, 'admin', NULL, '2017-12-29 09:04:05', NULL, 'Active'),
(2267, '1514595837', NULL, 'admin', NULL, '2017-12-30 09:03:57', NULL, 'Active'),
(2268, '1514682622', NULL, 'admin', NULL, '2017-12-31 09:10:22', NULL, 'Active'),
(2269, '1514768211', NULL, 'admin', NULL, '2018-01-01 08:56:51', NULL, 'Active'),
(2270, '1515027728', NULL, 'admin', NULL, '2018-01-04 09:02:08', NULL, 'Active'),
(2271, '1515112322', NULL, 'lois', NULL, '2018-01-05 08:32:02', NULL, 'Active'),
(2272, '1515112353', NULL, 'admin', NULL, '2018-01-05 08:32:33', NULL, 'Active'),
(2273, '1515201712', NULL, 'admin', NULL, '2018-01-06 09:21:52', NULL, 'Active'),
(2274, '1515286096', NULL, 'admin', NULL, '2018-01-07 08:48:16', NULL, 'Active'),
(2275, '1515371683', NULL, 'admin', NULL, '2018-01-08 08:34:43', NULL, 'Active'),
(2276, '1515546225', NULL, 'admin', NULL, '2018-01-10 09:03:45', NULL, 'Active'),
(2277, '1515581853', NULL, 'admin', NULL, '2018-01-10 18:57:33', NULL, 'Active'),
(2278, '1515719036', NULL, 'admin', NULL, '2018-01-12 09:03:56', NULL, 'Active'),
(2279, '1515805892', NULL, 'admin', NULL, '2018-01-13 09:11:32', NULL, 'Active'),
(2280, '1515891016', NULL, 'admin', NULL, '2018-01-14 08:50:16', NULL, 'Active'),
(2281, '1515978481', NULL, 'admin', NULL, '2018-01-15 09:08:01', NULL, 'Active'),
(2282, '1516151174', NULL, 'admin', NULL, '2018-01-17 09:06:14', NULL, 'Active'),
(2283, '1516237698', NULL, 'admin', NULL, '2018-01-18 09:08:18', NULL, 'Active'),
(2284, '1516321469', NULL, 'admin', NULL, '2018-01-19 08:24:29', NULL, 'Active'),
(2285, '1516410116', NULL, 'admin', NULL, '2018-01-20 09:01:56', NULL, 'Active'),
(2286, '1516415730', NULL, 'admin', NULL, '2018-01-20 10:35:30', NULL, 'Active'),
(2287, '1516441999', NULL, 'admin', NULL, '2018-01-20 17:53:19', NULL, 'Active'),
(2288, '1516496615', NULL, 'admin', NULL, '2018-01-21 09:03:35', NULL, 'Active'),
(2289, '1516509965', NULL, 'admin', NULL, '2018-01-21 12:46:05', NULL, 'Active'),
(2290, '1516583211', NULL, 'admin', NULL, '2018-01-22 09:06:51', NULL, 'Active'),
(2291, '1516755252', NULL, 'admin', NULL, '2018-01-24 08:54:12', NULL, 'Active'),
(2292, '1516842527', NULL, 'admin', NULL, '2018-01-25 09:08:47', NULL, 'Active'),
(2293, '1516928757', NULL, 'admin', NULL, '2018-01-26 09:05:57', NULL, 'Active'),
(2294, '1517014911', NULL, 'admin', NULL, '2018-01-27 09:01:51', NULL, 'Active'),
(2295, '1517100387', NULL, 'admin', NULL, '2018-01-28 08:46:27', NULL, 'Active'),
(2296, '1517186995', NULL, 'admin', NULL, '2018-01-29 08:49:55', NULL, 'Active'),
(2297, '1517358393', NULL, 'admin', NULL, '2018-01-31 08:26:33', NULL, 'Active'),
(2298, '1517447169', NULL, 'admin', NULL, '2018-02-01 09:06:09', NULL, 'Active'),
(2299, '1517534180', NULL, 'admin', NULL, '2018-02-02 09:16:20', NULL, 'Active'),
(2300, '1517620364', NULL, 'admin', NULL, '2018-02-03 09:12:44', NULL, 'Active'),
(2301, '1517707745', NULL, 'admin', NULL, '2018-02-04 09:29:05', NULL, 'Active'),
(2302, '1517793076', NULL, 'admin', NULL, '2018-02-05 09:11:16', NULL, 'Active'),
(2303, '1517965747', NULL, 'admin', NULL, '2018-02-07 09:09:07', NULL, 'Active'),
(2304, '1518051961', NULL, 'admin', NULL, '2018-02-08 09:06:01', NULL, 'Active'),
(2305, '1518135973', NULL, 'admin', NULL, '2018-02-09 08:26:13', NULL, 'Active'),
(2306, '1518223992', NULL, 'admin', NULL, '2018-02-10 08:53:12', NULL, 'Active'),
(2307, '1519091919', NULL, 'admin', NULL, '2018-02-20 09:58:39', NULL, 'Active'),
(2308, '1519173495', NULL, 'admin', NULL, '2018-02-21 08:38:15', NULL, 'Active'),
(2309, '1519190124', NULL, 'admin', NULL, '2018-02-21 13:15:24', NULL, 'Active'),
(2310, '1519261074', NULL, 'admin', NULL, '2018-02-22 08:57:54', NULL, 'Active'),
(2311, '1519348637', NULL, 'admin', NULL, '2018-02-23 09:17:17', NULL, 'Active'),
(2312, '1519433982', NULL, 'admin', NULL, '2018-02-24 08:59:42', NULL, 'Active'),
(2313, '1519520119', NULL, 'admin', NULL, '2018-02-25 08:55:19', NULL, 'Active'),
(2314, '1519606882', NULL, 'lois', NULL, '2018-02-26 09:01:22', NULL, 'Active'),
(2315, '1519636416', NULL, 'admin', NULL, '2018-02-26 17:13:36', NULL, 'Active'),
(2316, '1519780133', NULL, 'admin', NULL, '2018-02-28 09:08:53', NULL, 'Active'),
(2317, '1519866231', NULL, 'admin', NULL, '2018-03-01 09:03:51', NULL, 'Active'),
(2318, '1519894492', NULL, 'admin', NULL, '2018-03-01 16:54:52', NULL, 'Active'),
(2319, '1519894588', NULL, 'admin', NULL, '2018-03-01 16:56:28', NULL, 'Active'),
(2320, '1519952075', NULL, 'admin', NULL, '2018-03-02 08:54:35', NULL, 'Active'),
(2321, '1520038141', NULL, 'admin', NULL, '2018-03-03 08:49:01', NULL, 'Active'),
(2322, '1520125217', NULL, 'admin', NULL, '2018-03-04 09:00:17', NULL, 'Active'),
(2323, '1520211607', NULL, 'admin', NULL, '2018-03-05 09:00:07', NULL, 'Active'),
(2324, '1520385034', NULL, 'admin', NULL, '2018-03-07 09:10:34', NULL, 'Active'),
(2325, '1520469288', NULL, 'lois', NULL, '2018-03-08 08:34:48', NULL, 'Active'),
(2326, '1520494756', NULL, 'admin', NULL, '2018-03-08 15:39:16', NULL, 'Active'),
(2327, '1520557159', NULL, 'admin', NULL, '2018-03-09 08:59:19', NULL, 'Active');

-- --------------------------------------------------------

--
-- Table structure for table `sale_items`
--

CREATE TABLE `sale_items` (
  `id` int(11) NOT NULL,
  `txn_no` varchar(32) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `sale_id` int(11) DEFAULT NULL,
  `pseudo_id` int(11) DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_sku` varchar(128) DEFAULT NULL,
  `item_sku2` varchar(128) DEFAULT NULL,
  `item_name` varchar(128) DEFAULT NULL,
  `item_uom` varchar(128) DEFAULT NULL,
  `sku_select` int(11) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `qty_fraction` int(11) DEFAULT NULL,
  `unit` varchar(128) DEFAULT NULL,
  `price_per_unit` decimal(20,2) DEFAULT NULL,
  `margin` decimal(20,4) DEFAULT NULL,
  `cost` decimal(20,4) DEFAULT NULL,
  `discount_type` varchar(10) DEFAULT NULL,
  `discount_value` decimal(20,2) DEFAULT NULL,
  `discount_amount` decimal(20,2) DEFAULT NULL,
  `global_discount` decimal(20,2) DEFAULT NULL,
  `global_discount_type` varchar(1) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `tax` decimal(20,2) DEFAULT NULL,
  `sold` int(11) DEFAULT NULL,
  `terminal` varchar(32) DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `is_redemption` int(11) DEFAULT NULL,
  `member_id` int(11) DEFAULT NULL,
  `customer_id` int(11) DEFAULT NULL,
  `points` int(11) DEFAULT NULL,
  `redeemed` int(1) DEFAULT '0',
  `serial_no` varchar(128) DEFAULT NULL,
  `fnb` int(1) DEFAULT NULL,
  `sync` int(11) DEFAULT '0',
  `sync_time` varchar(128) DEFAULT NULL,
  `client_sync_time` varchar(128) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `clinic_dosage` text,
  `tax_code` text,
  `taxable` int(11) DEFAULT NULL,
  `return` int(1) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `sale_tax`
--

CREATE TABLE `sale_tax` (
  `id` int(11) UNSIGNED NOT NULL,
  `sale_id` int(11) DEFAULT NULL,
  `tax` varchar(128) DEFAULT NULL,
  `amount` decimal(20,2) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `services`
--

CREATE TABLE `services` (
  `id` int(11) UNSIGNED NOT NULL,
  `name` text,
  `description` text,
  `category` varchar(128) DEFAULT NULL,
  `subcategory` varchar(128) DEFAULT NULL,
  `cost` decimal(20,2) DEFAULT NULL,
  `price` decimal(20,2) DEFAULT NULL,
  `last_tendered` datetime DEFAULT NULL,
  `remarks` text,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `settlements`
--

CREATE TABLE `settlements` (
  `id` int(11) NOT NULL,
  `date` date DEFAULT NULL,
  `reference_no` varchar(128) DEFAULT NULL,
  `customer_id` int(11) DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL,
  `amount` float(10,2) DEFAULT NULL,
  `remarks` text
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `shipping`
--

CREATE TABLE `shipping` (
  `id` int(11) NOT NULL,
  `name` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `measurements_type` varchar(128) DEFAULT NULL,
  `calculation_technique` varchar(128) DEFAULT NULL,
  `shipping_factor` varchar(128) DEFAULT NULL,
  `description` text
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `shipping`
--

INSERT INTO `shipping` (`id`, `name`, `type`, `measurements_type`, `calculation_technique`, `shipping_factor`, `description`) VALUES
(1, 'KTM Courier', 'Surface', 'Metric', '0', '4000', 'Courier service by KTM. RM35 Custom Fees per delivery applies for delivery to Singapore.'),
(6, 'Self Pickup', 'Surface', 'Metric', '0', '0', 'Self pickup at our warehouse or stockist.');

-- --------------------------------------------------------

--
-- Table structure for table `shipping_international_zones`
--

CREATE TABLE `shipping_international_zones` (
  `id` int(11) NOT NULL,
  `name` varchar(128) DEFAULT NULL,
  `description` text,
  `countries` text
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `shipping_international_zones`
--

INSERT INTO `shipping_international_zones` (`id`, `name`, `description`, `countries`) VALUES
(3, 'Singapore', 'Singapore', NULL);

-- --------------------------------------------------------

--
-- Table structure for table `shipping_local_zones`
--

CREATE TABLE `shipping_local_zones` (
  `id` int(11) NOT NULL,
  `name` varchar(128) DEFAULT NULL,
  `description` text,
  `zipcode_from` varchar(128) DEFAULT NULL,
  `zipcode_to` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `shipping_local_zones`
--

INSERT INTO `shipping_local_zones` (`id`, `name`, `description`, `zipcode_from`, `zipcode_to`) VALUES
(7, 'Other Peninsula Zones 20000 - 86999 (Non-Local)', 'Outside local zone within peninsula.', '20000', '86999'),
(3, 'Penang 10000 - 14999 (Local)', 'Pulau Pinang, Tangung Bungah, Gelugor, Bayan Lepas, Butterworth, Bukit Mertajam', '10000', '14999'),
(4, 'Perlis 01000 - 01999 (Non-Local)', 'Perlis', '01000', '01999'),
(6, 'Kedah 05000 - 08999 (Local)', 'Alor Setar, Kulim, Sg Petani', '05000', '08999'),
(8, 'Sabah & Labuan 88000 - 91999 (Non-Local)', 'Sabah & Labuan', '88000', '91999'),
(9, 'Sarawak 93000 - 98999 (Non-Local)', 'Sarawak', '93000', '98999');

-- --------------------------------------------------------

--
-- Table structure for table `shipping_rates`
--

CREATE TABLE `shipping_rates` (
  `id` int(11) NOT NULL,
  `service_id` int(11) DEFAULT NULL,
  `zone_type` varchar(128) DEFAULT NULL,
  `zone_id` int(11) DEFAULT NULL,
  `flat_rate` float(10,2) DEFAULT NULL,
  `first_weight` varchar(32) DEFAULT NULL,
  `first_weight_rate` float(10,2) DEFAULT NULL,
  `subsequent_weight` varchar(32) DEFAULT NULL,
  `subsequent_weight_rate` float(10,2) DEFAULT NULL,
  `max_weight` varchar(32) DEFAULT NULL,
  `max_weight_rate` float(10,2) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `shipping_rates`
--

INSERT INTO `shipping_rates` (`id`, `service_id`, `zone_type`, `zone_id`, `flat_rate`, `first_weight`, `first_weight_rate`, `subsequent_weight`, `subsequent_weight_rate`, `max_weight`, `max_weight_rate`) VALUES
(3, 1, 'Local', 6, 0.00, '10', 7.00, '1', 0.70, '', 0.00),
(2, 4, 'International', 2, 0.00, '1', 10.00, '0.5', 7.00, '', 0.00),
(4, 1, 'Local', 3, 0.00, '10', 7.00, '1', 0.70, '', 0.00),
(5, 1, 'Local', 7, 0.00, '5', 9.00, '1', 1.00, '', 0.00),
(6, 1, 'Local', 4, 0.00, '5', 9.00, '1', 1.00, '', 0.00),
(7, 1, 'Local', 8, 0.00, '5', 50.00, '1', 10.00, '', 0.00),
(8, 1, 'Local', 9, 0.00, '5', 45.00, '1', 9.00, '', 0.00),
(9, 1, 'International', 3, 35.00, '5', 20.00, '1', 1.80, '', 0.00);

-- --------------------------------------------------------

--
-- Table structure for table `states`
--

CREATE TABLE `states` (
  `id` int(11) NOT NULL,
  `country` varchar(250) COLLATE latin1_general_ci DEFAULT NULL,
  `state` varchar(250) COLLATE latin1_general_ci DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

--
-- Dumping data for table `states`
--

INSERT INTO `states` (`id`, `country`, `state`) VALUES
(1, 'name', 'state\r'),
(2, 'Afghanistan', 'Badakhshan\r'),
(3, 'Afghanistan', 'Badghis\r'),
(4, 'Afghanistan', 'Baghlan\r'),
(5, 'Afghanistan', 'Balkh\r'),
(6, 'Afghanistan', 'Bamian\r'),
(7, 'Afghanistan', 'Farah\r'),
(8, 'Afghanistan', 'Faryab\r'),
(9, 'Afghanistan', 'Ghazni\r'),
(10, 'Afghanistan', 'Ghowr\r'),
(11, 'Afghanistan', 'Helmand\r'),
(12, 'Afghanistan', 'Herat\r'),
(13, 'Afghanistan', 'Jowzjan\r'),
(14, 'Afghanistan', 'Kabol\r'),
(15, 'Afghanistan', 'Kandahar\r'),
(16, 'Afghanistan', 'Kapisa\r'),
(17, 'Afghanistan', 'Konar\r'),
(18, 'Afghanistan', 'Kondoz\r'),
(19, 'Afghanistan', 'Laghman\r'),
(20, 'Afghanistan', 'Lowgar\r'),
(21, 'Afghanistan', 'Nangarhar\r'),
(22, 'Afghanistan', 'Nimruz\r'),
(23, 'Afghanistan', 'Oruzgan\r'),
(24, 'Afghanistan', 'Paktia\r'),
(25, 'Afghanistan', 'Paktika\r'),
(26, 'Afghanistan', 'Parvan\r'),
(27, 'Afghanistan', 'Samangan\r'),
(28, 'Afghanistan', 'Sar-e Pol\r'),
(29, 'Afghanistan', 'Takhar\r'),
(30, 'Afghanistan', 'Vardak\r'),
(31, 'Afghanistan', 'Zabol\r'),
(32, 'Albania', 'Berat\r'),
(33, 'Albania', 'Bulqize\r'),
(34, 'Albania', 'Delvine\r'),
(35, 'Albania', 'Devoll (Bilisht)\r'),
(36, 'Albania', 'Diber (Peshkopi)\r'),
(37, 'Albania', 'Durres\r'),
(38, 'Albania', 'Elbasan\r'),
(39, 'Albania', 'Fier\r'),
(40, 'Albania', 'Gjirokaster\r'),
(41, 'Albania', 'Gramsh\r'),
(42, 'Albania', 'Has (Krume)\r'),
(43, 'Albania', 'Kavaje\r'),
(44, 'Albania', 'Kolonje (Erseke)\r'),
(45, 'Albania', 'Korce\r'),
(46, 'Albania', 'Kruje\r'),
(47, 'Albania', 'Kucove\r'),
(48, 'Albania', 'Kukes\r'),
(49, 'Albania', 'Kurbin\r'),
(50, 'Albania', 'Lezhe\r'),
(51, 'Albania', 'Librazhd\r'),
(52, 'Albania', 'Lushnje\r'),
(53, 'Albania', 'Malesi e Madhe (Koplik)\r'),
(54, 'Albania', 'Mallakaster (Ballsh)\r'),
(55, 'Albania', 'Mat (Burrel)\r'),
(56, 'Albania', 'Mirdite (Rreshen)\r'),
(57, 'Albania', 'Peqin\r'),
(58, 'Albania', 'Permet\r'),
(59, 'Albania', 'Pogradec\r'),
(60, 'Albania', 'Puke\r'),
(61, 'Albania', 'Sarande\r'),
(62, 'Albania', 'Shkoder\r'),
(63, 'Albania', 'Skrapar (Corovode)\r'),
(64, 'Albania', 'Tepelene\r'),
(65, 'Albania', 'Tirane (Tirana)\r'),
(66, 'Albania', 'Tirane (Tirana)\r'),
(67, 'Albania', 'Tropoje (Bajram Curri)\r'),
(68, 'Albania', 'Vlore\r'),
(69, 'Algeria', 'Adrar\r'),
(70, 'Algeria', 'Ain Defla\r'),
(71, 'Algeria', 'Ain Temouchent\r'),
(72, 'Algeria', 'Alger\r'),
(73, 'Algeria', 'Annaba\r'),
(74, 'Algeria', 'Batna\r'),
(75, 'Algeria', 'Bechar\r'),
(76, 'Algeria', 'Bejaia\r'),
(77, 'Algeria', 'Biskra\r'),
(78, 'Algeria', 'Blida\r'),
(79, 'Algeria', 'Bordj Bou Arreridj\r'),
(80, 'Algeria', 'Bouira\r'),
(81, 'Algeria', 'Boumerdes\r'),
(82, 'Algeria', 'Chlef\r'),
(83, 'Algeria', 'Constantine\r'),
(84, 'Algeria', 'Djelfa\r'),
(85, 'Algeria', 'El Bayadh\r'),
(86, 'Algeria', 'El Oued\r'),
(87, 'Algeria', 'El Tarf\r'),
(88, 'Algeria', 'Ghardaia\r'),
(89, 'Algeria', 'Guelma\r'),
(90, 'Algeria', 'Illizi\r'),
(91, 'Algeria', 'Jijel\r'),
(92, 'Algeria', 'Khenchela\r'),
(93, 'Algeria', 'Laghouat\r'),
(94, 'Algeria', 'MSila\r'),
(95, 'Algeria', 'Mascara\r'),
(96, 'Algeria', 'Medea\r'),
(97, 'Algeria', 'Mila\r'),
(98, 'Algeria', 'Mostaganem\r'),
(99, 'Algeria', 'Naama\r'),
(100, 'Algeria', 'Oran\r'),
(101, 'Algeria', 'Ouargla\r'),
(102, 'Algeria', 'Oum el Bouaghi\r'),
(103, 'Algeria', 'Relizane\r'),
(104, 'Algeria', 'Saida\r'),
(105, 'Algeria', 'Setif\r'),
(106, 'Algeria', 'Sidi Bel Abbes\r'),
(107, 'Algeria', 'Skikda\r'),
(108, 'Algeria', 'Souk Ahras\r'),
(109, 'Algeria', 'Tamanghasset\r'),
(110, 'Algeria', 'Tebessa\r'),
(111, 'Algeria', 'Tiaret\r'),
(112, 'Algeria', 'Tindouf\r'),
(113, 'Algeria', 'Tipaza\r'),
(114, 'Algeria', 'Tissemsilt\r'),
(115, 'Algeria', 'Tizi Ouzou\r'),
(116, 'Algeria', 'Tlemcen\r'),
(117, 'American Samoa', 'Eastern\r'),
(118, 'American Samoa', 'Manua\r'),
(119, 'American Samoa', 'Rose Island\r'),
(120, 'American Samoa', 'Swains Island\r'),
(121, 'American Samoa', 'Western\r'),
(122, 'Angola', 'Andorra la Vella\r'),
(123, 'Angola', 'Bengo\r'),
(124, 'Angola', 'Benguela\r'),
(125, 'Angola', 'Bie\r'),
(126, 'Angola', 'Cabinda\r'),
(127, 'Angola', 'Canillo\r'),
(128, 'Angola', 'Cuando Cubango\r'),
(129, 'Angola', 'Cuanza Norte\r'),
(130, 'Angola', 'Cuanza Sul\r'),
(131, 'Angola', 'Cunene\r'),
(132, 'Angola', 'Encamp\r'),
(133, 'Angola', 'Escaldes-Engordany\r'),
(134, 'Angola', 'Huambo\r'),
(135, 'Angola', 'Huila\r'),
(136, 'Angola', 'La Massana\r'),
(137, 'Angola', 'Luanda\r'),
(138, 'Angola', 'Lunda Norte\r'),
(139, 'Angola', 'Lunda Sul\r'),
(140, 'Angola', 'Malanje\r'),
(141, 'Angola', 'Moxico\r'),
(142, 'Angola', 'Namibe\r'),
(143, 'Angola', 'Ordino\r'),
(144, 'Angola', 'Sant Julia de Loria\r'),
(145, 'Angola', 'Uige\r'),
(146, 'Angola', 'Zaire\r'),
(147, 'Anguilla', 'Anguilla\r'),
(148, 'Antartica', 'Antartica\r'),
(149, 'Antigua and Barbuda', 'Barbuda\r'),
(150, 'Antigua and Barbuda', 'Redonda\r'),
(151, 'Antigua and Barbuda', 'Saint George\r'),
(152, 'Antigua and Barbuda', 'Saint John\r'),
(153, 'Antigua and Barbuda', 'Saint Mary\r'),
(154, 'Antigua and Barbuda', 'Saint Paul\r'),
(155, 'Antigua and Barbuda', 'Saint Peter\r'),
(156, 'Antigua and Barbuda', 'Saint Philip\r'),
(157, 'Argentina', 'Antartica e Islas del Atlantico Sur\r'),
(158, 'Argentina', 'Buenos Aires\r'),
(159, 'Argentina', 'Buenos Aires Capital Federal\r'),
(160, 'Argentina', 'Catamarca\r'),
(161, 'Argentina', 'Chaco\r'),
(162, 'Argentina', 'Chubut\r'),
(163, 'Argentina', 'Cordoba\r'),
(164, 'Argentina', 'Corrientes\r'),
(165, 'Argentina', 'Entre Rios\r'),
(166, 'Argentina', 'Formosa\r'),
(167, 'Argentina', 'Jujuy\r'),
(168, 'Argentina', 'La Pampa\r'),
(169, 'Argentina', 'La Rioja\r'),
(170, 'Argentina', 'Mendoza\r'),
(171, 'Argentina', 'Misiones\r'),
(172, 'Argentina', 'Neuquen\r'),
(173, 'Argentina', 'Rio Negro\r'),
(174, 'Argentina', 'Salta\r'),
(175, 'Argentina', 'San Juan\r'),
(176, 'Argentina', 'San Luis\r'),
(177, 'Argentina', 'Santa Cruz\r'),
(178, 'Argentina', 'Santa Fe\r'),
(179, 'Argentina', 'Santiago del Estero\r'),
(180, 'Argentina', 'Tierra del Fuego\r'),
(181, 'Argentina', 'Tucuman\r'),
(182, 'Armenia', 'Aragatsotn\r'),
(183, 'Armenia', 'Ararat\r'),
(184, 'Armenia', 'Armavir\r'),
(185, 'Armenia', 'Gegharkunik\r'),
(186, 'Armenia', 'Kotayk\r'),
(187, 'Armenia', 'Lorri\r'),
(188, 'Armenia', 'Shirak\r'),
(189, 'Armenia', 'Syunik\r'),
(190, 'Armenia', 'Tavush\r'),
(191, 'Armenia', 'Vayots Dzor\r'),
(192, 'Armenia', 'Yerevan\r'),
(193, 'Aruba', 'Aruba\r'),
(194, 'Ashmore and Cartier Island', 'Ashmore and Cartier Island\r'),
(195, 'Australia', 'Australian Capital Territory\r'),
(196, 'Australia', 'New South Wales\r'),
(197, 'Australia', 'Northern Territory\r'),
(198, 'Australia', 'Queensland\r'),
(199, 'Australia', 'South Australia\r'),
(200, 'Australia', 'Tasmania\r'),
(201, 'Australia', 'Victoria\r'),
(202, 'Australia', 'Western Australia\r'),
(203, 'Austria', 'Burgenland\r'),
(204, 'Austria', 'Kaernten\r'),
(205, 'Austria', 'Niederoesterreich\r'),
(206, 'Austria', 'Oberoesterreich\r'),
(207, 'Austria', 'Salzburg\r'),
(208, 'Austria', 'Steiermark\r'),
(209, 'Austria', 'Tirol\r'),
(210, 'Austria', 'Vorarlberg\r'),
(211, 'Austria', 'Wien\r'),
(212, 'Azerbaijan', 'Abseron Rayonu\r'),
(213, 'Azerbaijan', 'Agcabadi Rayonu\r'),
(214, 'Azerbaijan', 'Agdam Rayonu\r'),
(215, 'Azerbaijan', 'Agdas Rayonu\r'),
(216, 'Azerbaijan', 'Agstafa Rayonu\r'),
(217, 'Azerbaijan', 'Agsu Rayonu\r'),
(218, 'Azerbaijan', 'Ali Bayramli Sahari\r'),
(219, 'Azerbaijan', 'Astara Rayonu\r'),
(220, 'Azerbaijan', 'Baki Sahari\r'),
(221, 'Azerbaijan', 'Balakan Rayonu\r'),
(222, 'Azerbaijan', 'Barda Rayonu\r'),
(223, 'Azerbaijan', 'Beylaqan Rayonu\r'),
(224, 'Azerbaijan', 'Bilasuvar Rayonu\r'),
(225, 'Azerbaijan', 'Cabrayil Rayonu\r'),
(226, 'Azerbaijan', 'Calilabad Rayonu\r'),
(227, 'Azerbaijan', 'Daskasan Rayonu\r'),
(228, 'Azerbaijan', 'Davaci Rayonu\r'),
(229, 'Azerbaijan', 'Fuzuli Rayonu\r'),
(230, 'Azerbaijan', 'Gadabay Rayonu\r'),
(231, 'Azerbaijan', 'Ganca Sahari\r'),
(232, 'Azerbaijan', 'Goranboy Rayonu\r'),
(233, 'Azerbaijan', 'Goycay Rayonu\r'),
(234, 'Azerbaijan', 'Haciqabul Rayonu\r'),
(235, 'Azerbaijan', 'Imisli Rayonu\r'),
(236, 'Azerbaijan', 'Ismayilli Rayonu\r'),
(237, 'Azerbaijan', 'Kalbacar Rayonu\r'),
(238, 'Azerbaijan', 'Kurdamir Rayonu\r'),
(239, 'Azerbaijan', 'Lacin Rayonu\r'),
(240, 'Azerbaijan', 'Lankaran Rayonu\r'),
(241, 'Azerbaijan', 'Lankaran Sahari\r'),
(242, 'Azerbaijan', 'Lerik Rayonu\r'),
(243, 'Azerbaijan', 'Masalli Rayonu\r'),
(244, 'Azerbaijan', 'Mingacevir Sahari\r'),
(245, 'Azerbaijan', 'Naftalan Sahari\r'),
(246, 'Azerbaijan', 'Naxcivan Muxtar Respublikasi\r'),
(247, 'Azerbaijan', 'Neftcala Rayonu\r'),
(248, 'Azerbaijan', 'Oguz Rayonu\r'),
(249, 'Azerbaijan', 'Qabala Rayonu\r'),
(250, 'Azerbaijan', 'Qax Rayonu\r'),
(251, 'Azerbaijan', 'Qazax Rayonu\r'),
(252, 'Azerbaijan', 'Qobustan Rayonu\r'),
(253, 'Azerbaijan', 'Quba Rayonu\r'),
(254, 'Azerbaijan', 'Qubadli Rayonu\r'),
(255, 'Azerbaijan', 'Qusar Rayonu\r'),
(256, 'Azerbaijan', 'Saatli Rayonu\r'),
(257, 'Azerbaijan', 'Sabirabad Rayonu\r'),
(258, 'Azerbaijan', 'Saki Rayonu\r'),
(259, 'Azerbaijan', 'Saki Sahari\r'),
(260, 'Azerbaijan', 'Salyan Rayonu\r'),
(261, 'Azerbaijan', 'Samaxi Rayonu\r'),
(262, 'Azerbaijan', 'Samkir Rayonu\r'),
(263, 'Azerbaijan', 'Samux Rayonu\r'),
(264, 'Azerbaijan', 'Siyazan Rayonu\r'),
(265, 'Azerbaijan', 'Sumqayit Sahari\r'),
(266, 'Azerbaijan', 'Susa Rayonu\r'),
(267, 'Azerbaijan', 'Susa Sahari\r'),
(268, 'Azerbaijan', 'Tartar Rayonu\r'),
(269, 'Azerbaijan', 'Tovuz Rayonu\r'),
(270, 'Azerbaijan', 'Ucar Rayonu\r'),
(271, 'Azerbaijan', 'Xacmaz Rayonu\r'),
(272, 'Azerbaijan', 'Xankandi Sahari\r'),
(273, 'Azerbaijan', 'Xanlar Rayonu\r'),
(274, 'Azerbaijan', 'Xizi Rayonu\r'),
(275, 'Azerbaijan', 'Xocali Rayonu\r'),
(276, 'Azerbaijan', 'Xocavand Rayonu\r'),
(277, 'Azerbaijan', 'Yardimli Rayonu\r'),
(278, 'Azerbaijan', 'Yevlax Rayonu\r'),
(279, 'Azerbaijan', 'Yevlax Sahari\r'),
(280, 'Azerbaijan', 'Zangilan Rayonu\r'),
(281, 'Azerbaijan', 'Zaqatala Rayonu\r'),
(282, 'Azerbaijan', 'Zardab Rayonu\r'),
(283, 'Bahamas', 'Acklins and Crooked Islands\r'),
(284, 'Bahamas', 'Bimini\r'),
(285, 'Bahamas', 'Cat Island\r'),
(286, 'Bahamas', 'Exuma\r'),
(287, 'Bahamas', 'Freeport\r'),
(288, 'Bahamas', 'Fresh Creek\r'),
(289, 'Bahamas', 'Governors Harbour\r'),
(290, 'Bahamas', 'Green Turtle Cay\r'),
(291, 'Bahamas', 'Harbour Island\r'),
(292, 'Bahamas', 'High Rock\r'),
(293, 'Bahamas', 'Inagua\r'),
(294, 'Bahamas', 'Kemps Bay\r'),
(295, 'Bahamas', 'Long Island\r'),
(296, 'Bahamas', 'Marsh Harbour\r'),
(297, 'Bahamas', 'Mayaguana\r'),
(298, 'Bahamas', 'New Providence\r'),
(299, 'Bahamas', 'Nicholls Town and Berry Islands\r'),
(300, 'Bahamas', 'Ragged Island\r'),
(301, 'Bahamas', 'Rock Sound\r'),
(302, 'Bahamas', 'San Salvador and Rum Cay\r'),
(303, 'Bahamas', 'Sandy Point\r'),
(304, 'Bahrain', 'Al Hadd\r'),
(305, 'Bahrain', 'Al Manamah\r'),
(306, 'Bahrain', 'Al Mintaqah al Gharbiyah\r'),
(307, 'Bahrain', 'Al Mintaqah al Wusta\r'),
(308, 'Bahrain', 'Al Mintaqah ash Shamaliyah\r'),
(309, 'Bahrain', 'Al Muharraq\r'),
(310, 'Bahrain', 'Ar Rifa wa al Mintaqah al Janubiyah\r'),
(311, 'Bahrain', 'Jidd Hafs\r'),
(312, 'Bahrain', 'Juzur Hawar\r'),
(313, 'Bahrain', 'Madinat Isa\r'),
(314, 'Bahrain', 'Madinat Hamad\r'),
(315, 'Bahrain', 'Sitrah\r'),
(316, 'Bangladesh', 'Barisal\r'),
(317, 'Bangladesh', 'Chittagong\r'),
(318, 'Bangladesh', 'Dhaka\r'),
(319, 'Bangladesh', 'Khulna\r'),
(320, 'Bangladesh', 'Rajshahi\r'),
(321, 'Bangladesh', 'Sylhet\r'),
(322, 'Barbados', 'Bridgetown\r'),
(323, 'Barbados', 'Christ Church\r'),
(324, 'Barbados', 'Saint Andrew\r'),
(325, 'Barbados', 'Saint George\r'),
(326, 'Barbados', 'Saint James\r'),
(327, 'Barbados', 'Saint John\r'),
(328, 'Barbados', 'Saint Joseph\r'),
(329, 'Barbados', 'Saint Lucy\r'),
(330, 'Barbados', 'Saint Michael\r'),
(331, 'Barbados', 'Saint Peter\r'),
(332, 'Barbados', 'Saint Philip\r'),
(333, 'Barbados', 'Saint Thomas\r'),
(334, 'Belarus', 'Brestskaya (Brest)\r'),
(335, 'Belarus', 'Homyelskaya (Homyel)\r'),
(336, 'Belarus', 'Horad Minsk\r'),
(337, 'Belarus', 'Hrodzyenskaya (Hrodna)\r'),
(338, 'Belarus', 'Mahilyowskaya (Mahilyow)\r'),
(339, 'Belarus', 'Minskaya\r'),
(340, 'Belarus', 'Vitsyebskaya (Vitsyebsk)\r'),
(341, 'Belgium', 'Antwerpen\r'),
(342, 'Belgium', 'Brabant Wallon\r'),
(343, 'Belgium', 'Brussels Capitol Region\r'),
(344, 'Belgium', 'Hainaut\r'),
(345, 'Belgium', 'Liege\r'),
(346, 'Belgium', 'Limburg\r'),
(347, 'Belgium', 'Luxembourg\r'),
(348, 'Belgium', 'Namur\r'),
(349, 'Belgium', 'Oost-Vlaanderen\r'),
(350, 'Belgium', 'Vlaams Brabant\r'),
(351, 'Belgium', 'West-Vlaanderen\r'),
(352, 'Belize', 'Belize\r'),
(353, 'Belize', 'Cayo\r'),
(354, 'Belize', 'Corozal\r'),
(355, 'Belize', 'Orange Walk\r'),
(356, 'Belize', 'Stann Creek\r'),
(357, 'Belize', 'Toledo\r'),
(358, 'Benin', 'Alibori\r'),
(359, 'Benin', 'Atakora\r'),
(360, 'Benin', 'Atlantique\r'),
(361, 'Benin', 'Borgou\r'),
(362, 'Benin', 'Collines\r'),
(363, 'Benin', 'Couffo\r'),
(364, 'Benin', 'Donga\r'),
(365, 'Benin', 'Littoral\r'),
(366, 'Benin', 'Mono\r'),
(367, 'Benin', 'Oueme\r'),
(368, 'Benin', 'Plateau\r'),
(369, 'Benin', 'Zou\r'),
(370, 'Bermuda', 'Devonshire\r'),
(371, 'Bermuda', 'Hamilton\r'),
(372, 'Bermuda', 'Hamilton\r'),
(373, 'Bermuda', 'Paget\r'),
(374, 'Bermuda', 'Pembroke\r'),
(375, 'Bermuda', 'Saint George\r'),
(376, 'Bermuda', 'Saint Georges\r'),
(377, 'Bermuda', 'Sandys\r'),
(378, 'Bermuda', 'Smiths\r'),
(379, 'Bermuda', 'Southampton\r'),
(380, 'Bermuda', 'Warwick\r'),
(381, 'Bhutan', 'Bumthang\r'),
(382, 'Bhutan', 'Chhukha\r'),
(383, 'Bhutan', 'Chirang\r'),
(384, 'Bhutan', 'Daga\r'),
(385, 'Bhutan', 'Geylegphug\r'),
(386, 'Bhutan', 'Ha\r'),
(387, 'Bhutan', 'Lhuntshi\r'),
(388, 'Bhutan', 'Mongar\r'),
(389, 'Bhutan', 'Paro\r'),
(390, 'Bhutan', 'Pemagatsel\r'),
(391, 'Bhutan', 'Punakha\r'),
(392, 'Bhutan', 'Samchi\r'),
(393, 'Bhutan', 'Samdrup Jongkhar\r'),
(394, 'Bhutan', 'Shemgang\r'),
(395, 'Bhutan', 'Tashigang\r'),
(396, 'Bhutan', 'Thimphu\r'),
(397, 'Bhutan', 'Tongsa\r'),
(398, 'Bhutan', 'Wangdi Phodrang\r'),
(399, 'Bolivia', 'Beni\r'),
(400, 'Bolivia', 'Chuquisaca\r'),
(401, 'Bolivia', 'Cochabamba\r'),
(402, 'Bolivia', 'La Paz\r'),
(403, 'Bolivia', 'Oruro\r'),
(404, 'Bolivia', 'Pando\r'),
(405, 'Bolivia', 'Potosi\r'),
(406, 'Bolivia', 'Santa Cruz\r'),
(407, 'Bolivia', 'Tarija\r'),
(408, 'Bosnia and Herzegovina', 'Federation of Bosnia and Herzegovina\r'),
(409, 'Bosnia and Herzegovina', 'Republika Srpska\r'),
(410, 'Botswana', 'Central\r'),
(411, 'Botswana', 'Chobe\r'),
(412, 'Botswana', 'Francistown\r'),
(413, 'Botswana', 'Gaborone\r'),
(414, 'Botswana', 'Ghanzi\r'),
(415, 'Botswana', 'Kgalagadi\r'),
(416, 'Botswana', 'Kgatleng\r'),
(417, 'Botswana', 'Kweneng\r'),
(418, 'Botswana', 'Lobatse\r'),
(419, 'Botswana', 'Ngamiland\r'),
(420, 'Botswana', 'North-East\r'),
(421, 'Botswana', 'Selebi-Pikwe\r'),
(422, 'Botswana', 'South-East\r'),
(423, 'Botswana', 'Southern\r'),
(424, 'Brazil', 'Acre\r'),
(425, 'Brazil', 'Alagoas\r'),
(426, 'Brazil', 'Amapa\r'),
(427, 'Brazil', 'Amazonas\r'),
(428, 'Brazil', 'Bahia\r'),
(429, 'Brazil', 'Ceara\r'),
(430, 'Brazil', 'Distrito Federal\r'),
(431, 'Brazil', 'Espirito Santo\r'),
(432, 'Brazil', 'Goias\r'),
(433, 'Brazil', 'Maranhao\r'),
(434, 'Brazil', 'Mato Grosso\r'),
(435, 'Brazil', 'Mato Grosso do Sul\r'),
(436, 'Brazil', 'Minas Gerais\r'),
(437, 'Brazil', 'Para\r'),
(438, 'Brazil', 'Paraiba\r'),
(439, 'Brazil', 'Parana\r'),
(440, 'Brazil', 'Pernambuco\r'),
(441, 'Brazil', 'Piaui\r'),
(442, 'Brazil', 'Rio de Janeiro\r'),
(443, 'Brazil', 'Rio Grande do Norte\r'),
(444, 'Brazil', 'Rio Grande do Sul\r'),
(445, 'Brazil', 'Rondonia\r'),
(446, 'Brazil', 'Roraima\r'),
(447, 'Brazil', 'Santa Catarina\r'),
(448, 'Brazil', 'Sao Paulo\r'),
(449, 'Brazil', 'Sergipe\r'),
(450, 'Brazil', 'Tocantins\r'),
(451, 'British Virgin Islands', 'Anegada\r'),
(452, 'British Virgin Islands', 'Jost Van Dyke\r'),
(453, 'British Virgin Islands', 'Tortola\r'),
(454, 'British Virgin Islands', 'Virgin Gorda\r'),
(455, 'BR', 'Belait\r'),
(456, 'BR', 'Brunei and Muara\r'),
(457, 'BR', 'Temburong\r'),
(458, 'BR', 'Tutong\r'),
(459, 'Bulgaria', 'Blagoevgrad\r'),
(460, 'Bulgaria', 'Burgas\r'),
(461, 'Bulgaria', 'Dobrich\r'),
(462, 'Bulgaria', 'Gabrovo\r'),
(463, 'Bulgaria', 'Khaskovo\r'),
(464, 'Bulgaria', 'Kurdzhali\r'),
(465, 'Bulgaria', 'Kyustendil\r'),
(466, 'Bulgaria', 'Lovech\r'),
(467, 'Bulgaria', 'Montana\r'),
(468, 'Bulgaria', 'Pazardzhik\r'),
(469, 'Bulgaria', 'Pernik\r'),
(470, 'Bulgaria', 'Pleven\r'),
(471, 'Bulgaria', 'Plovdiv\r'),
(472, 'Bulgaria', 'Razgrad\r'),
(473, 'Bulgaria', 'Ruse\r'),
(474, 'Bulgaria', 'Shumen\r'),
(475, 'Bulgaria', 'Silistra\r'),
(476, 'Bulgaria', 'Sliven\r'),
(477, 'Bulgaria', 'Smolyan\r'),
(478, 'Bulgaria', 'Sofiya\r'),
(479, 'Bulgaria', 'Sofiya-Grad\r'),
(480, 'Bulgaria', 'Stara Zagora\r'),
(481, 'Bulgaria', 'Turgovishte\r'),
(482, 'Bulgaria', 'Varna\r'),
(483, 'Bulgaria', 'Veliko Turnovo\r'),
(484, 'Bulgaria', 'Vidin\r'),
(485, 'Bulgaria', 'Vratsa\r'),
(486, 'Bulgaria', 'Yambol\r'),
(487, 'Burkina Faso', 'Bale\r'),
(488, 'Burkina Faso', 'Bam\r'),
(489, 'Burkina Faso', 'Banwa\r'),
(490, 'Burkina Faso', 'Bazega\r'),
(491, 'Burkina Faso', 'Bougouriba\r'),
(492, 'Burkina Faso', 'Boulgou\r'),
(493, 'Burkina Faso', 'Boulkiemde\r'),
(494, 'Burkina Faso', 'Comoe\r'),
(495, 'Burkina Faso', 'Ganzourgou\r'),
(496, 'Burkina Faso', 'Gnagna\r'),
(497, 'Burkina Faso', 'Gourma\r'),
(498, 'Burkina Faso', 'Houet\r'),
(499, 'Burkina Faso', 'Ioba\r'),
(500, 'Burkina Faso', 'Kadiogo\r'),
(501, 'Burkina Faso', 'Kenedougou\r'),
(502, 'Burkina Faso', 'Komandjari\r'),
(503, 'Burkina Faso', 'Kompienga\r'),
(504, 'Burkina Faso', 'Kossi\r'),
(505, 'Burkina Faso', 'Koupelogo\r'),
(506, 'Burkina Faso', 'Kouritenga\r'),
(507, 'Burkina Faso', 'Kourweogo\r'),
(508, 'Burkina Faso', 'Leraba\r'),
(509, 'Burkina Faso', 'Loroum\r'),
(510, 'Burkina Faso', 'Mouhoun\r'),
(511, 'Burkina Faso', 'Nahouri\r'),
(512, 'Burkina Faso', 'Namentenga\r'),
(513, 'Burkina Faso', 'Naumbiel\r'),
(514, 'Burkina Faso', 'Nayala\r'),
(515, 'Burkina Faso', 'Oubritenga\r'),
(516, 'Burkina Faso', 'Oudalan\r'),
(517, 'Burkina Faso', 'Passore\r'),
(518, 'Burkina Faso', 'Poni\r'),
(519, 'Burkina Faso', 'Samentenga\r'),
(520, 'Burkina Faso', 'Sanguie\r'),
(521, 'Burkina Faso', 'Seno\r'),
(522, 'Burkina Faso', 'Sissili\r'),
(523, 'Burkina Faso', 'Soum\r'),
(524, 'Burkina Faso', 'Sourou\r'),
(525, 'Burkina Faso', 'Tapoa\r'),
(526, 'Burkina Faso', 'Tuy\r'),
(527, 'Burkina Faso', 'Yagha\r'),
(528, 'Burkina Faso', 'Yatenga\r'),
(529, 'Burkina Faso', 'Ziro\r'),
(530, 'Burkina Faso', 'Zondomo\r'),
(531, 'Burkina Faso', 'Zoundweogo\r'),
(532, 'MM', 'Ayeyarwady\r'),
(533, 'MM', 'Bago\r'),
(534, 'MM', 'Chin State\r'),
(535, 'MM', 'Kachin State\r'),
(536, 'MM', 'Kayah State\r'),
(537, 'MM', 'Kayin State\r'),
(538, 'MM', 'Magway\r'),
(539, 'MM', 'Mandalay\r'),
(540, 'MM', 'Mon State\r'),
(541, 'MM', 'Rakhine State\r'),
(542, 'MM', 'Sagaing\r'),
(543, 'MM', 'Shan State\r'),
(544, 'MM', 'Tanintharyi\r'),
(545, 'MM', 'Yangon\r'),
(546, 'Burundi', 'Bubanza\r'),
(547, 'Burundi', 'Bujumbura\r'),
(548, 'Burundi', 'Bururi\r'),
(549, 'Burundi', 'Cankuzo\r'),
(550, 'Burundi', 'Cibitoke\r'),
(551, 'Burundi', 'Gitega\r'),
(552, 'Burundi', 'Karuzi\r'),
(553, 'Burundi', 'Kayanza\r'),
(554, 'Burundi', 'Kirundo\r'),
(555, 'Burundi', 'Makamba\r'),
(556, 'Burundi', 'Muramvya\r'),
(557, 'Burundi', 'Muyinga\r'),
(558, 'Burundi', 'Mwaro\r'),
(559, 'Burundi', 'Ngozi\r'),
(560, 'Burundi', 'Rutana\r'),
(561, 'Burundi', 'Ruyigi\r'),
(562, 'Cambodia', 'Banteay Mean Cheay\r'),
(563, 'Cambodia', 'Batdambang\r'),
(564, 'Cambodia', 'Kampong Cham\r'),
(565, 'Cambodia', 'Kampong Chhnang\r'),
(566, 'Cambodia', 'Kampong Spoe\r'),
(567, 'Cambodia', 'Kampong Thum\r'),
(568, 'Cambodia', 'Kampot\r'),
(569, 'Cambodia', 'Kandal\r'),
(570, 'Cambodia', 'Kaoh Kong\r'),
(571, 'Cambodia', 'Keb\r'),
(572, 'Cambodia', 'Kracheh\r'),
(573, 'Cambodia', 'Mondol Kiri\r'),
(574, 'Cambodia', 'Otdar Mean Cheay\r'),
(575, 'Cambodia', 'Pailin\r'),
(576, 'Cambodia', 'Phnum Penh\r'),
(577, 'Cambodia', 'Pouthisat\r'),
(578, 'Cambodia', 'Preah Seihanu (Sihanoukville)\r'),
(579, 'Cambodia', 'Preah Vihear\r'),
(580, 'Cambodia', 'Prey Veng\r'),
(581, 'Cambodia', 'Rotanah Kiri\r'),
(582, 'Cambodia', 'Siem Reab\r'),
(583, 'Cambodia', 'Stoeng Treng\r'),
(584, 'Cambodia', 'Svay Rieng\r'),
(585, 'Cambodia', 'Takev\r'),
(586, 'Cameroon', 'Adamaoua\r'),
(587, 'Cameroon', 'Centre\r'),
(588, 'Cameroon', 'Est\r'),
(589, 'Cameroon', 'Extreme-Nord\r'),
(590, 'Cameroon', 'Littoral\r'),
(591, 'Cameroon', 'Nord\r'),
(592, 'Cameroon', 'Nord-Ouest\r'),
(593, 'Cameroon', 'Ouest\r'),
(594, 'Cameroon', 'Sud\r'),
(595, 'Cameroon', 'Sud-Ouest\r'),
(596, 'Canada', 'Alberta\r'),
(597, 'Canada', 'British Columbia\r'),
(598, 'Canada', 'Manitoba\r'),
(599, 'Canada', 'New Brunswick\r'),
(600, 'Canada', 'Newfoundland\r'),
(601, 'Canada', 'Northwest Territories\r'),
(602, 'Canada', 'Nova Scotia\r'),
(603, 'Canada', 'Nunavut\r'),
(604, 'Canada', 'Ontario\r'),
(605, 'Canada', 'Prince Edward Island\r'),
(606, 'Canada', 'Quebec\r'),
(607, 'Canada', 'Saskatchewan\r'),
(608, 'Canada', 'Yukon Territory\r'),
(609, 'Cape Verde', 'Boa Vista\r'),
(610, 'Cape Verde', 'Brava\r'),
(611, 'Cape Verde', 'Maio\r'),
(612, 'Cape Verde', 'Mosteiros\r'),
(613, 'Cape Verde', 'Paul\r'),
(614, 'Cape Verde', 'Porto Novo\r'),
(615, 'Cape Verde', 'Praia\r'),
(616, 'Cape Verde', 'Ribeira Grande\r'),
(617, 'Cape Verde', 'Sal\r'),
(618, 'Cape Verde', 'Santa Catarina\r'),
(619, 'Cape Verde', 'Santa Cruz\r'),
(620, 'Cape Verde', 'Sao Domingos\r'),
(621, 'Cape Verde', 'Sao Filipe\r'),
(622, 'Cape Verde', 'Sao Nicolau\r'),
(623, 'Cape Verde', 'Sao Vicente\r'),
(624, 'Cape Verde', 'Tarrafal\r'),
(625, 'Cayman Islands', 'Creek\r'),
(626, 'Cayman Islands', 'Eastern\r'),
(627, 'Cayman Islands', 'Midland\r'),
(628, 'Cayman Islands', 'South Town\r'),
(629, 'Cayman Islands', 'Spot Bay\r'),
(630, 'Cayman Islands', 'Stake Bay\r'),
(631, 'Cayman Islands', 'West End\r'),
(632, 'Cayman Islands', 'Western\r'),
(633, 'Central African Republic', 'Bamingui-Bangoran\r'),
(634, 'Central African Republic', 'Bangui\r'),
(635, 'Central African Republic', 'Basse-Kotto\r'),
(636, 'Central African Republic', 'Gribingui\r'),
(637, 'Central African Republic', 'Haut-Mbomou\r'),
(638, 'Central African Republic', 'Haute-Kotto\r'),
(639, 'Central African Republic', 'Haute-Sangha\r'),
(640, 'Central African Republic', 'Kemo-Gribingui\r'),
(641, 'Central African Republic', 'Lobaye\r'),
(642, 'Central African Republic', 'Mbomou\r'),
(643, 'Central African Republic', 'Nana-Mambere\r'),
(644, 'Central African Republic', 'Ombella-Mpoko\r'),
(645, 'Central African Republic', 'Ouaka\r'),
(646, 'Central African Republic', 'Ouham\r'),
(647, 'Central African Republic', 'Ouham-Pende\r'),
(648, 'Central African Republic', 'Sangha\r'),
(649, 'Central African Republic', 'Vakaga\r'),
(650, 'Chad', 'Batha\r'),
(651, 'Chad', 'Biltine\r'),
(652, 'Chad', 'Borkou-Ennedi-Tibesti\r'),
(653, 'Chad', 'Chari-Baguirmi\r'),
(654, 'Chad', 'Guera\r'),
(655, 'Chad', 'Kanem\r'),
(656, 'Chad', 'Lac\r'),
(657, 'Chad', 'Logone Occidental\r'),
(658, 'Chad', 'Logone Oriental\r'),
(659, 'Chad', 'Mayo-Kebbi\r'),
(660, 'Chad', 'Moyen-Chari\r'),
(661, 'Chad', 'Ouaddai\r'),
(662, 'Chad', 'Salamat\r'),
(663, 'Chad', 'Tandjile\r'),
(664, 'Chile', 'Aisen del General Carlos Ibanez del Campo\r'),
(665, 'Chile', 'Antofagasta\r'),
(666, 'Chile', 'Araucania\r'),
(667, 'Chile', 'Atacama\r'),
(668, 'Chile', 'Bio-Bio\r'),
(669, 'Chile', 'Coquimbo\r'),
(670, 'Chile', 'Libertador General Bernardo OHiggins\r'),
(671, 'Chile', 'Los Lagos\r'),
(672, 'Chile', 'Magallanes y de la Antartica Chilena\r'),
(673, 'Chile', 'Maule\r'),
(674, 'Chile', 'Region Metropolitana (Santiago)\r'),
(675, 'Chile', 'Tarapaca\r'),
(676, 'Chile', 'Valparaiso\r'),
(677, 'China', 'Anhui\r'),
(678, 'China', 'Beijing\r'),
(679, 'China', 'Chongqing\r'),
(680, 'China', 'Fujian\r'),
(681, 'China', 'Gansu\r'),
(682, 'China', 'Guangdong\r'),
(683, 'China', 'Guangxi\r'),
(684, 'China', 'Guizhou\r'),
(685, 'China', 'Hainan\r'),
(686, 'China', 'Hebei\r'),
(687, 'China', 'Heilongjiang\r'),
(688, 'China', 'Henan\r'),
(689, 'China', 'Hubei\r'),
(690, 'China', 'Hunan\r'),
(691, 'China', 'Jiangsu\r'),
(692, 'China', 'Jiangxi\r'),
(693, 'China', 'Jilin\r'),
(694, 'China', 'Liaoning\r'),
(695, 'China', 'Nei Mongol\r'),
(696, 'China', 'Ningxia\r'),
(697, 'China', 'Qinghai\r'),
(698, 'China', 'Shaanxi\r'),
(699, 'China', 'Shandong\r'),
(700, 'China', 'Shanghai\r'),
(701, 'China', 'Shanxi\r'),
(702, 'China', 'Sichuan\r'),
(703, 'China', 'Tianjin\r'),
(704, 'China', 'Xinjiang\r'),
(705, 'China', 'Xizang (Tibet)\r'),
(706, 'China', 'Yunnan\r'),
(707, 'China', 'Zhejiang\r'),
(708, 'Christmas Island', 'Christmas Island\r'),
(709, 'Clipperton Island', 'Clipperton Island\r'),
(710, 'Cocos (Keeling) Islands', 'Direction Island\r'),
(711, 'Cocos (Keeling) Islands', 'Home Island\r'),
(712, 'Cocos (Keeling) Islands', 'Horsburgh Island\r'),
(713, 'Cocos (Keeling) Islands', 'North Keeling Island\r'),
(714, 'Cocos (Keeling) Islands', 'South Island\r'),
(715, 'Cocos (Keeling) Islands', 'West Island\r'),
(716, 'Colombia', 'Amazonas\r'),
(717, 'Colombia', 'Antioquia\r'),
(718, 'Colombia', 'Arauca\r'),
(719, 'Colombia', 'Atlantico\r'),
(720, 'Colombia', 'Bolivar\r'),
(721, 'Colombia', 'Boyaca\r'),
(722, 'Colombia', 'Caldas\r'),
(723, 'Colombia', 'Caqueta\r'),
(724, 'Colombia', 'Casanare\r'),
(725, 'Colombia', 'Cauca\r'),
(726, 'Colombia', 'Cesar\r'),
(727, 'Colombia', 'Choco\r'),
(728, 'Colombia', 'Cordoba\r'),
(729, 'Colombia', 'Cundinamarca\r'),
(730, 'Colombia', 'Distrito Capital de Santa Fe de Bogota\r'),
(731, 'Colombia', 'Guainia\r'),
(732, 'Colombia', 'Guaviare\r'),
(733, 'Colombia', 'Huila\r'),
(734, 'Colombia', 'La Guajira\r'),
(735, 'Colombia', 'Magdalena\r'),
(736, 'Colombia', 'Meta\r'),
(737, 'Colombia', 'Narino\r'),
(738, 'Colombia', 'Norte de Santander\r'),
(739, 'Colombia', 'Putumayo\r'),
(740, 'Colombia', 'Quindio\r'),
(741, 'Colombia', 'Risaralda\r'),
(742, 'Colombia', 'San Andres y Providencia\r'),
(743, 'Colombia', 'Santander\r'),
(744, 'Colombia', 'Sucre\r'),
(745, 'Colombia', 'Tolima\r'),
(746, 'Colombia', 'Valle del Cauca\r'),
(747, 'Colombia', 'Vaupes\r'),
(748, 'Colombia', 'Vichada\r'),
(749, 'Comoros', 'Anjouan (Nzwani)\r'),
(750, 'Comoros', 'Domoni\r'),
(751, 'Comoros', 'Fomboni\r'),
(752, 'Comoros', 'Grande Comore (Njazidja)\r'),
(753, 'Comoros', 'Moheli (Mwali)\r'),
(754, 'Comoros', 'Moroni\r'),
(755, 'Comoros', 'Moutsamoudou\r'),
(756, 'Congo', 'Bandundu\r'),
(757, 'Congo', 'Bas-Congo\r'),
(758, 'Congo', 'Equateur\r'),
(759, 'Congo', 'Kasai-Occidental\r'),
(760, 'Congo', 'Kasai-Oriental\r'),
(761, 'Congo', 'Katanga\r'),
(762, 'Congo', 'Kinshasa\r'),
(763, 'Congo', 'Maniema\r'),
(764, 'Congo', 'Nord-Kivu\r'),
(765, 'Congo', 'Orientale\r'),
(766, 'Congo', 'Sud-Kivu\r'),
(767, 'Bouenza\r', NULL),
(768, 'Brazzaville\r', NULL),
(769, 'Cuvette\r', NULL),
(770, 'Kouilou\r', NULL),
(771, 'Lekoumou\r', NULL),
(772, 'Likouala\r', NULL),
(773, 'Niari\r', NULL),
(774, 'Plateaux\r', NULL),
(775, 'Pool\r', NULL),
(776, 'Sangha\r', NULL),
(777, 'Cook Islands', 'Aitutaki\r'),
(778, 'Cook Islands', 'Atiu\r'),
(779, 'Cook Islands', 'Avarua\r'),
(780, 'Cook Islands', 'Mangaia\r'),
(781, 'Cook Islands', 'Manihiki\r'),
(782, 'Cook Islands', 'Manuae\r'),
(783, 'Cook Islands', 'Mauke\r'),
(784, 'Cook Islands', 'Mitiaro\r'),
(785, 'Cook Islands', 'Nassau Island\r'),
(786, 'Cook Islands', 'Palmerston\r'),
(787, 'Cook Islands', 'Penrhyn\r'),
(788, 'Cook Islands', 'Pukapuka\r'),
(789, 'Cook Islands', 'Rakahanga\r'),
(790, 'Cook Islands', 'Rarotonga\r'),
(791, 'Cook Islands', 'Suwarrow\r'),
(792, 'Cook Islands', 'Takutea\r'),
(793, 'Costa Rica', 'Alajuela\r'),
(794, 'Costa Rica', 'Cartago\r'),
(795, 'Costa Rica', 'Guanacaste\r'),
(796, 'Costa Rica', 'Heredia\r'),
(797, 'Costa Rica', 'Limon\r'),
(798, 'Costa Rica', 'Puntarenas\r'),
(799, 'Costa Rica', 'San Jose\r'),
(800, 'Cote dIvoire', 'Abengourou\r'),
(801, 'Cote dIvoire', 'Abidjan\r'),
(802, 'Cote dIvoire', 'Aboisso\r'),
(803, 'Cote dIvoire', 'Adiake\r'),
(804, 'Cote dIvoire', 'Adzope\r'),
(805, 'Cote dIvoire', 'Agboville\r'),
(806, 'Cote dIvoire', 'Agnibilekrou\r'),
(807, 'Cote dIvoire', 'Alepe\r'),
(808, 'Cote dIvoire', 'Bangolo\r'),
(809, 'Cote dIvoire', 'Beoumi\r'),
(810, 'Cote dIvoire', 'Biankouma\r'),
(811, 'Cote dIvoire', 'Bocanda\r'),
(812, 'Cote dIvoire', 'Bondoukou\r'),
(813, 'Cote dIvoire', 'Bongouanou\r'),
(814, 'Cote dIvoire', 'Bouafle\r'),
(815, 'Cote dIvoire', 'Bouake\r'),
(816, 'Cote dIvoire', 'Bouna\r'),
(817, 'Cote dIvoire', 'Boundiali\r'),
(818, 'Cote dIvoire', 'Dabakala\r'),
(819, 'Cote dIvoire', 'Dabon\r'),
(820, 'Cote dIvoire', 'Daloa\r'),
(821, 'Cote dIvoire', 'Danane\r'),
(822, 'Cote dIvoire', 'Daoukro\r'),
(823, 'Cote dIvoire', 'Dimbokro\r'),
(824, 'Cote dIvoire', 'Divo\r'),
(825, 'Cote dIvoire', 'Duekoue\r'),
(826, 'Cote dIvoire', 'Ferkessedougou\r'),
(827, 'Cote dIvoire', 'Gagnoa\r'),
(828, 'Cote dIvoire', 'Grand Bassam\r'),
(829, 'Cote dIvoire', 'Grand-Lahou\r'),
(830, 'Cote dIvoire', 'Guiglo\r'),
(831, 'Cote dIvoire', 'Issia\r'),
(832, 'Cote dIvoire', 'Jacqueville\r'),
(833, 'Cote dIvoire', 'Katiola\r'),
(834, 'Cote dIvoire', 'Korhogo\r'),
(835, 'Cote dIvoire', 'Lakota\r'),
(836, 'Cote dIvoire', 'Man\r'),
(837, 'Cote dIvoire', 'Mankono\r'),
(838, 'Cote dIvoire', 'Mbahiakro\r'),
(839, 'Cote dIvoire', 'Odienne\r'),
(840, 'Cote dIvoire', 'Oume\r'),
(841, 'Cote dIvoire', 'Sakassou\r'),
(842, 'Cote dIvoire', 'San-Pedro\r'),
(843, 'Cote dIvoire', 'Sassandra\r'),
(844, 'Cote dIvoire', 'Seguela\r'),
(845, 'Cote dIvoire', 'Sinfra\r'),
(846, 'Cote dIvoire', 'Soubre\r'),
(847, 'Cote dIvoire', 'Tabou\r'),
(848, 'Cote dIvoire', 'Tanda\r'),
(849, 'Cote dIvoire', 'Tiassale\r'),
(850, 'Cote dIvoire', 'Tiebissou\r'),
(851, 'Cote dIvoire', 'Tingrela\r'),
(852, 'Cote dIvoire', 'Touba\r'),
(853, 'Cote dIvoire', 'Toulepleu\r'),
(854, 'Cote dIvoire', 'Toumodi\r'),
(855, 'Cote dIvoire', 'Vavoua\r'),
(856, 'Cote dIvoire', 'Yamoussoukro\r'),
(857, 'Cote dIvoire', 'Zuenoula\r'),
(858, 'Croatia', 'Bjelovarsko-Bilogorska Zupanija\r'),
(859, 'Croatia', 'Brodsko-Posavska Zupanija\r'),
(860, 'Croatia', 'Dubrovacko-Neretvanska Zupanija\r'),
(861, 'Croatia', 'Istarska Zupanija\r'),
(862, 'Croatia', 'Karlovacka Zupanija\r'),
(863, 'Croatia', 'Koprivnicko-Krizevacka Zupanija\r'),
(864, 'Croatia', 'Krapinsko-Zagorska Zupanija\r'),
(865, 'Croatia', 'Licko-Senjska Zupanija\r'),
(866, 'Croatia', 'Medimurska Zupanija\r'),
(867, 'Croatia', 'Osjecko-Baranjska Zupanija\r'),
(868, 'Croatia', 'Pozesko-Slavonska Zupanija\r'),
(869, 'Croatia', 'Primorsko-Goranska Zupanija\r'),
(870, 'Croatia', 'Sibensko-Kninska Zupanija\r'),
(871, 'Croatia', 'Sisacko-Moslavacka Zupanija\r'),
(872, 'Croatia', 'Splitsko-Dalmatinska Zupanija\r'),
(873, 'Croatia', 'Varazdinska Zupanija\r'),
(874, 'Croatia', 'Viroviticko-Podravska Zupanija\r'),
(875, 'Croatia', 'Vukovarsko-Srijemska Zupanija\r'),
(876, 'Croatia', 'Zadarska Zupanija\r'),
(877, 'Croatia', 'Zagreb\r'),
(878, 'Croatia', 'Zagrebacka Zupanija\r'),
(879, 'Cuba', 'Camaguey\r'),
(880, 'Cuba', 'Ciego de Avila\r'),
(881, 'Cuba', 'Cienfuegos\r'),
(882, 'Cuba', 'Ciudad de La Habana\r'),
(883, 'Cuba', 'Granma\r'),
(884, 'Cuba', 'Guantanamo\r'),
(885, 'Cuba', 'Holguin\r'),
(886, 'Cuba', 'Isla de la Juventud\r'),
(887, 'Cuba', 'La Habana\r'),
(888, 'Cuba', 'Las Tunas\r'),
(889, 'Cuba', 'Matanzas\r'),
(890, 'Cuba', 'Pinar del Rio\r'),
(891, 'Cuba', 'Sancti Spiritus\r'),
(892, 'Cuba', 'Santiago de Cuba\r'),
(893, 'Cuba', 'Villa Clara\r'),
(894, 'Cyprus', 'Famagusta\r'),
(895, 'Cyprus', 'Kyrenia\r'),
(896, 'Cyprus', 'Larnaca\r'),
(897, 'Cyprus', 'Limassol\r'),
(898, 'Cyprus', 'Nicosia\r'),
(899, 'Cyprus', 'Paphos\r'),
(900, 'Czeck Republic', 'Brnensky\r'),
(901, 'Czeck Republic', 'Budejovicky\r'),
(902, 'Czeck Republic', 'Jihlavsky\r'),
(903, 'Czeck Republic', 'Karlovarsky\r'),
(904, 'Czeck Republic', 'Kralovehradecky\r'),
(905, 'Czeck Republic', 'Liberecky\r'),
(906, 'Czeck Republic', 'Olomoucky\r'),
(907, 'Czeck Republic', 'Ostravsky\r'),
(908, 'Czeck Republic', 'Pardubicky\r'),
(909, 'Czeck Republic', 'Plzensky\r'),
(910, 'Czeck Republic', 'Praha\r'),
(911, 'Czeck Republic', 'Stredocesky\r'),
(912, 'Czeck Republic', 'Ustecky\r'),
(913, 'Czeck Republic', 'Zlinsky\r'),
(914, 'Denmark', 'Arhus\r'),
(915, 'Denmark', 'Bornholm\r'),
(916, 'Denmark', 'Fredericksberg\r'),
(917, 'Denmark', 'Frederiksborg\r'),
(918, 'Denmark', 'Fyn\r'),
(919, 'Denmark', 'Kobenhavn\r'),
(920, 'Denmark', 'Kobenhavns\r'),
(921, 'Denmark', 'Nordjylland\r'),
(922, 'Denmark', 'Ribe\r'),
(923, 'Denmark', 'Ringkobing\r'),
(924, 'Denmark', 'Roskilde\r'),
(925, 'Denmark', 'Sonderjylland\r'),
(926, 'Denmark', 'Storstrom\r'),
(927, 'Denmark', 'Vejle\r'),
(928, 'Denmark', 'Vestsjalland\r'),
(929, 'Denmark', 'Viborg\r'),
(930, 'Djibouti', 'Ali Sabih\r'),
(931, 'Djibouti', 'Dikhil\r'),
(932, 'Djibouti', 'Djibouti\r'),
(933, 'Djibouti', 'Obock\r'),
(934, 'Djibouti', 'Tadjoura\r'),
(935, 'Dominica', 'Saint Andrew\r'),
(936, 'Dominica', 'Saint David\r'),
(937, 'Dominica', 'Saint George\r'),
(938, 'Dominica', 'Saint John\r'),
(939, 'Dominica', 'Saint Joseph\r'),
(940, 'Dominica', 'Saint Luke\r'),
(941, 'Dominica', 'Saint Mark\r'),
(942, 'Dominica', 'Saint Patrick\r'),
(943, 'Dominica', 'Saint Paul\r'),
(944, 'Dominica', 'Saint Peter\r'),
(945, 'Dominican Republic', 'Azua\r'),
(946, 'Dominican Republic', 'Baoruco\r'),
(947, 'Dominican Republic', 'Barahona\r'),
(948, 'Dominican Republic', 'Dajabon\r'),
(949, 'Dominican Republic', 'Distrito Nacional\r'),
(950, 'Dominican Republic', 'Duarte\r'),
(951, 'Dominican Republic', 'El Seibo\r'),
(952, 'Dominican Republic', 'Elias Pina\r'),
(953, 'Dominican Republic', 'Espaillat\r'),
(954, 'Dominican Republic', 'Hato Mayor\r'),
(955, 'Dominican Republic', 'Independencia\r'),
(956, 'Dominican Republic', 'La Altagracia\r'),
(957, 'Dominican Republic', 'La Romana\r'),
(958, 'Dominican Republic', 'La Vega\r'),
(959, 'Dominican Republic', 'Maria Trinidad Sanchez\r'),
(960, 'Dominican Republic', 'Monsenor Nouel\r'),
(961, 'Dominican Republic', 'Monte Cristi\r'),
(962, 'Dominican Republic', 'Monte Plata\r'),
(963, 'Dominican Republic', 'Pedernales\r'),
(964, 'Dominican Republic', 'Peravia\r'),
(965, 'Dominican Republic', 'Puerto Plata\r'),
(966, 'Dominican Republic', 'Salcedo\r'),
(967, 'Dominican Republic', 'Samana\r'),
(968, 'Dominican Republic', 'San Cristobal\r'),
(969, 'Dominican Republic', 'San Juan\r'),
(970, 'Dominican Republic', 'San Pedro de Macoris\r'),
(971, 'Dominican Republic', 'Sanchez Ramirez\r'),
(972, 'Dominican Republic', 'Santiago\r'),
(973, 'Dominican Republic', 'Santiago Rodriguez\r'),
(974, 'Dominican Republic', 'Valverde\r'),
(975, 'Ecuador', 'Azuay\r'),
(976, 'Ecuador', 'Bolivar\r'),
(977, 'Ecuador', 'Canar\r'),
(978, 'Ecuador', 'Carchi\r'),
(979, 'Ecuador', 'Chimborazo\r'),
(980, 'Ecuador', 'Cotopaxi\r'),
(981, 'Ecuador', 'El Oro\r'),
(982, 'Ecuador', 'Esmeraldas\r'),
(983, 'Ecuador', 'Galapagos\r'),
(984, 'Ecuador', 'Guayas\r'),
(985, 'Ecuador', 'Imbabura\r'),
(986, 'Ecuador', 'Loja\r'),
(987, 'Ecuador', 'Los Rios\r'),
(988, 'Ecuador', 'Manabi\r'),
(989, 'Ecuador', 'Morona-Santiago\r'),
(990, 'Ecuador', 'Napo\r'),
(991, 'Ecuador', 'Orellana\r'),
(992, 'Ecuador', 'Pastaza\r'),
(993, 'Ecuador', 'Pichincha\r'),
(994, 'Ecuador', 'Sucumbios\r'),
(995, 'Ecuador', 'Tungurahua\r'),
(996, 'Ecuador', 'Zamora-Chinchipe\r'),
(997, 'Egypt', 'Ad Daqahliyah\r'),
(998, 'Egypt', 'Al Bahr al Ahmar\r'),
(999, 'Egypt', 'Al Buhayrah\r'),
(1000, 'Egypt', 'Al Fayyum\r'),
(1001, 'Egypt', 'Al Gharbiyah\r'),
(1002, 'Egypt', 'Al Iskandariyah\r'),
(1003, 'Egypt', 'Al Ismailiyah\r'),
(1004, 'Egypt', 'Al Jizah\r'),
(1005, 'Egypt', 'Al Minufiyah\r'),
(1006, 'Egypt', 'Al Minya\r'),
(1007, 'Egypt', 'Al Qahirah\r'),
(1008, 'Egypt', 'Al Qalyubiyah\r'),
(1009, 'Egypt', 'Al Wadi al Jadid\r'),
(1010, 'Egypt', 'As Suways\r'),
(1011, 'Egypt', 'Ash Sharqiyah\r'),
(1012, 'Egypt', 'Aswan\r'),
(1013, 'Egypt', 'Asyut\r'),
(1014, 'Egypt', 'Bani Suwayf\r'),
(1015, 'Egypt', 'Bur Said\r'),
(1016, 'Egypt', 'Dumyat\r'),
(1017, 'Egypt', 'Janub Sina\r'),
(1018, 'Egypt', 'Kafr ash Shaykh\r'),
(1019, 'Egypt', 'Matruh\r'),
(1020, 'Egypt', 'Qina\r'),
(1021, 'Egypt', 'Shamal Sina\r'),
(1022, 'Egypt', 'Suhaj\r'),
(1023, 'El Salvador', 'Ahuachapan\r'),
(1024, 'El Salvador', 'Cabanas\r'),
(1025, 'El Salvador', 'Chalatenango\r'),
(1026, 'El Salvador', 'Cuscatlan\r'),
(1027, 'El Salvador', 'La Libertad\r'),
(1028, 'El Salvador', 'La Paz\r'),
(1029, 'El Salvador', 'La Union\r'),
(1030, 'El Salvador', 'Morazan\r'),
(1031, 'El Salvador', 'San Miguel\r'),
(1032, 'El Salvador', 'San Salvador\r'),
(1033, 'El Salvador', 'San Vicente\r'),
(1034, 'El Salvador', 'Santa Ana\r'),
(1035, 'El Salvador', 'Sonsonate\r'),
(1036, 'El Salvador', 'Usulutan\r'),
(1037, 'England', 'Barking and Dagenham\r'),
(1038, 'England', 'Barnet\r'),
(1039, 'England', 'Barnsley\r'),
(1040, 'England', 'Bath and North East Somerset\r'),
(1041, 'England', 'Bedfordshire\r'),
(1042, 'England', 'Bexley\r'),
(1043, 'England', 'Birmingham\r'),
(1044, 'England', 'Blackburn with Darwen\r'),
(1045, 'England', 'Blackpool\r'),
(1046, 'England', 'Bolton\r'),
(1047, 'England', 'Bournemouth\r'),
(1048, 'England', 'Bracknell Forest\r'),
(1049, 'England', 'Bradford\r'),
(1050, 'England', 'Brent\r'),
(1051, 'England', 'Brighton and Hove\r'),
(1052, 'England', 'Bromley\r'),
(1053, 'England', 'Buckinghamshire\r'),
(1054, 'England', 'Bury\r'),
(1055, 'England', 'Calderdale\r'),
(1056, 'England', 'Cambridgeshire\r'),
(1057, 'England', 'Camden\r'),
(1058, 'England', 'Cheshire\r'),
(1059, 'England', 'City of Bristol\r'),
(1060, 'England', 'City of Kingston upon Hull\r'),
(1061, 'England', 'City of London\r'),
(1062, 'England', 'Cornwall\r'),
(1063, 'England', 'Coventry\r'),
(1064, 'England', 'Croydon\r'),
(1065, 'England', 'Cumbria\r'),
(1066, 'England', 'Darlington\r'),
(1067, 'England', 'Derby\r'),
(1068, 'England', 'Derbyshire\r'),
(1069, 'England', 'Devon\r'),
(1070, 'England', 'Doncaster\r'),
(1071, 'England', 'Dorset\r'),
(1072, 'England', 'Dudley\r'),
(1073, 'England', 'Durham\r'),
(1074, 'England', 'Ealing\r'),
(1075, 'England', 'East Riding of Yorkshire\r'),
(1076, 'England', 'East Sussex\r'),
(1077, 'England', 'Enfield\r'),
(1078, 'England', 'Essex\r'),
(1079, 'England', 'Gateshead\r'),
(1080, 'England', 'Gloucestershire\r'),
(1081, 'England', 'Greenwich\r'),
(1082, 'England', 'Hackney\r'),
(1083, 'England', 'Halton\r'),
(1084, 'England', 'Hammersmith and Fulham\r'),
(1085, 'England', 'Hampshire\r'),
(1086, 'England', 'Haringey\r'),
(1087, 'England', 'Harrow\r'),
(1088, 'England', 'Hartlepool\r'),
(1089, 'England', 'Havering\r'),
(1090, 'England', 'Herefordshire\r'),
(1091, 'England', 'Hertfordshire\r'),
(1092, 'England', 'Hillingdon\r'),
(1093, 'England', 'Hounslow\r'),
(1094, 'England', 'Isle of Wight\r'),
(1095, 'England', 'Islington\r'),
(1096, 'England', 'Kensington and Chelsea\r'),
(1097, 'England', 'Kent\r'),
(1098, 'England', 'Kingston upon Thames\r'),
(1099, 'England', 'Kirklees\r'),
(1100, 'England', 'Knowsley\r'),
(1101, 'England', 'Lambeth\r'),
(1102, 'England', 'Lancashire\r'),
(1103, 'England', 'Leeds\r'),
(1104, 'England', 'Leicester\r'),
(1105, 'England', 'Leicestershire\r'),
(1106, 'England', 'Lewisham\r'),
(1107, 'England', 'Lincolnshire\r'),
(1108, 'England', 'Liverpool\r'),
(1109, 'England', 'Luton\r'),
(1110, 'England', 'Manchester\r'),
(1111, 'England', 'Medway\r'),
(1112, 'England', 'Merton\r'),
(1113, 'England', 'Middlesbrough\r'),
(1114, 'England', 'Milton Keynes\r'),
(1115, 'England', 'Newcastle upon Tyne\r'),
(1116, 'England', 'Newham\r'),
(1117, 'England', 'Norfolk\r'),
(1118, 'England', 'North East Lincolnshire\r'),
(1119, 'England', 'North Lincolnshire\r'),
(1120, 'England', 'North Somerset\r'),
(1121, 'England', 'North Tyneside\r'),
(1122, 'England', 'North Yorkshire\r'),
(1123, 'England', 'Northamptonshire\r'),
(1124, 'England', 'Northumberland\r'),
(1125, 'England', 'Nottingham\r'),
(1126, 'England', 'Nottinghamshire\r'),
(1127, 'England', 'Oldham\r'),
(1128, 'England', 'Oxfordshire\r'),
(1129, 'England', 'Peterborough\r'),
(1130, 'England', 'Plymouth\r'),
(1131, 'England', 'Poole\r'),
(1132, 'England', 'Portsmouth\r'),
(1133, 'England', 'Reading\r'),
(1134, 'England', 'Redbridge\r'),
(1135, 'England', 'Redcar and Cleveland\r'),
(1136, 'England', 'Richmond upon Thames\r'),
(1137, 'England', 'Rochdale\r'),
(1138, 'England', 'Rotherham\r'),
(1139, 'England', 'Rutland\r'),
(1140, 'England', 'Salford\r'),
(1141, 'England', 'Sandwell\r'),
(1142, 'England', 'Sefton\r'),
(1143, 'England', 'Sheffield\r'),
(1144, 'England', 'Shropshire\r'),
(1145, 'England', 'Slough\r'),
(1146, 'England', 'Solihull\r'),
(1147, 'England', 'Somerset\r'),
(1148, 'England', 'South Gloucestershire\r'),
(1149, 'England', 'South Tyneside\r'),
(1150, 'England', 'Southampton\r'),
(1151, 'England', 'Southend-on-Sea\r'),
(1152, 'England', 'Southwark\r'),
(1153, 'England', 'St. Helens\r'),
(1154, 'England', 'Staffordshire\r'),
(1155, 'England', 'Stockport\r'),
(1156, 'England', 'Stockton-on-Tees\r'),
(1157, 'England', 'Stoke-on-Trent\r'),
(1158, 'England', 'Suffolk\r'),
(1159, 'England', 'Sunderland\r'),
(1160, 'England', 'Surrey\r'),
(1161, 'England', 'Sutton\r'),
(1162, 'England', 'Swindon\r'),
(1163, 'England', 'Tameside\r'),
(1164, 'England', 'Telford and Wrekin\r'),
(1165, 'England', 'Thurrock\r'),
(1166, 'England', 'Torbay\r'),
(1167, 'England', 'Tower Hamlets\r'),
(1168, 'England', 'Trafford\r'),
(1169, 'England', 'Wakefield\r'),
(1170, 'England', 'Walsall\r'),
(1171, 'England', 'Waltham Forest\r'),
(1172, 'England', 'Wandsworth\r'),
(1173, 'England', 'Warrington\r'),
(1174, 'England', 'Warwickshire\r'),
(1175, 'England', 'West Berkshire\r'),
(1176, 'England', 'West Sussex\r'),
(1177, 'England', 'Westminster\r'),
(1178, 'England', 'Wigan\r'),
(1179, 'England', 'Wiltshire\r'),
(1180, 'England', 'Windsor and Maidenhead\r'),
(1181, 'England', 'Wirral\r'),
(1182, 'England', 'Wokingham\r'),
(1183, 'England', 'Wolverhampton\r'),
(1184, 'England', 'Worcestershire\r'),
(1185, 'England', 'York\r'),
(1186, 'Equatorial Guinea', 'Annobon\r'),
(1187, 'Equatorial Guinea', 'Bioko Norte\r'),
(1188, 'Equatorial Guinea', 'Bioko Sur\r'),
(1189, 'Equatorial Guinea', 'Centro Sur\r'),
(1190, 'Equatorial Guinea', 'Kie-Ntem\r'),
(1191, 'Equatorial Guinea', 'Litoral\r'),
(1192, 'Equatorial Guinea', 'Wele-Nzas\r'),
(1193, 'Eritrea', 'Akale Guzay\r'),
(1194, 'Eritrea', 'Barka\r'),
(1195, 'Eritrea', 'Denkel\r'),
(1196, 'Eritrea', 'Hamasen\r'),
(1197, 'Eritrea', 'Sahil\r'),
(1198, 'Eritrea', 'Semhar\r'),
(1199, 'Eritrea', 'Senhit\r'),
(1200, 'Eritrea', 'Seraye\r'),
(1201, 'Estonia', 'Harjumaa (Tallinn)\r'),
(1202, 'Estonia', 'Hiiumaa (Kardla)\r'),
(1203, 'Estonia', 'Ida-Virumaa (Johvi)\r'),
(1204, 'Estonia', 'Jarvamaa (Paide)\r'),
(1205, 'Estonia', 'Jogevamaa (Jogeva)\r'),
(1206, 'Estonia', 'Laane-Virumaa (Rakvere)\r'),
(1207, 'Estonia', 'Laanemaa (Haapsalu)\r'),
(1208, 'Estonia', 'Parnumaa (Parnu)\r'),
(1209, 'Estonia', 'Polvamaa (Polva)\r'),
(1210, 'Estonia', 'Raplamaa (Rapla)\r'),
(1211, 'Estonia', 'Saaremaa (Kuessaare)\r'),
(1212, 'Estonia', 'Tartumaa (Tartu)\r'),
(1213, 'Estonia', 'Valgamaa (Valga)\r'),
(1214, 'Estonia', 'Viljandimaa (Viljandi)\r'),
(1215, 'Estonia', 'Vorumaa (Voru)\r'),
(1216, 'Ethiopia', 'Adis Abeba (Addis Ababa)\r'),
(1217, 'Ethiopia', 'Afar\r'),
(1218, 'Ethiopia', 'Amara\r'),
(1219, 'Ethiopia', 'Dire Dawa\r'),
(1220, 'Ethiopia', 'Gambela Hizboch\r'),
(1221, 'Ethiopia', 'Hareri Hizb\r'),
(1222, 'Ethiopia', 'Oromiya\r'),
(1223, 'Ethiopia', 'Sumale\r'),
(1224, 'Ethiopia', 'Tigray\r'),
(1225, 'Ethiopia', 'YeDebub Biheroch Bihereseboch na Hizboch\r'),
(1226, 'Europa Island', 'Europa Island\r'),
(1227, 'Falkland Islands (Islas Malvinas)', 'Falkland Islands (Islas Malvinas)\r'),
(1228, 'Faroe Islands', 'Bordoy\r'),
(1229, 'Faroe Islands', 'Eysturoy\r'),
(1230, 'Faroe Islands', 'Mykines\r'),
(1231, 'Faroe Islands', 'Sandoy\r'),
(1232, 'Faroe Islands', 'Skuvoy\r'),
(1233, 'Faroe Islands', 'Streymoy\r'),
(1234, 'Faroe Islands', 'Suduroy\r'),
(1235, 'Faroe Islands', 'Tvoroyri\r'),
(1236, 'Faroe Islands', 'Vagar\r'),
(1237, 'Fiji', 'Central\r'),
(1238, 'Fiji', 'Eastern\r'),
(1239, 'Fiji', 'Northern\r'),
(1240, 'Fiji', 'Rotuma\r'),
(1241, 'Fiji', 'Western\r'),
(1242, 'Finland', 'Aland\r'),
(1243, 'Finland', 'Etela-Suomen Laani\r'),
(1244, 'Finland', 'Ita-Suomen Laani\r'),
(1245, 'Finland', 'Lansi-Suomen Laani\r'),
(1246, 'Finland', 'Lappi\r'),
(1247, 'Finland', 'Oulun Laani\r'),
(1248, 'France', 'Alsace\r'),
(1249, 'France', 'Aquitaine\r'),
(1250, 'France', 'Auvergne\r'),
(1251, 'France', 'Basse-Normandie\r'),
(1252, 'France', 'Bourgogne\r'),
(1253, 'France', 'Bretagne\r'),
(1254, 'France', 'Centre\r'),
(1255, 'France', 'Champagne-Ardenne\r'),
(1256, 'France', 'Corse\r'),
(1257, 'France', 'Franche-Comte\r'),
(1258, 'France', 'Haute-Normandie\r'),
(1259, 'France', 'Ile-de-France\r'),
(1260, 'France', 'Languedoc-Roussillon\r'),
(1261, 'France', 'Limousin\r'),
(1262, 'France', 'Lorraine\r'),
(1263, 'France', 'Midi-Pyrenees\r'),
(1264, 'France', 'Nord-Pas-de-Calais\r'),
(1265, 'France', 'Pays de la Loire\r'),
(1266, 'France', 'Picardie\r'),
(1267, 'France', 'Poitou-Charentes\r'),
(1268, 'France', 'Provence-Alpes-Cote dAzur\r'),
(1269, 'France', 'Rhone-Alpes\r'),
(1270, 'French Guiana', 'French Guiana\r'),
(1271, 'French Polynesia', 'Archipel des Marquises\r'),
(1272, 'French Polynesia', 'Archipel des Tuamotu\r'),
(1273, 'French Polynesia', 'Archipel des Tubuai\r'),
(1274, 'French Polynesia', 'Iles du Vent\r'),
(1275, 'French Polynesia', 'Iles Sous-le-Vent\r'),
(1276, 'French Southern and Antarctic Lands', 'Adelie Land\r'),
(1277, 'French Southern and Antarctic Lands', 'Ile Crozet\r'),
(1278, 'French Southern and Antarctic Lands', 'Iles Kerguelen\r'),
(1279, 'French Southern and Antarctic Lands', 'Iles Saint-Paul et Amsterdam\r'),
(1280, 'Gabon', 'Estuaire\r'),
(1281, 'Gabon', 'Haut-Ogooue\r'),
(1282, 'Gabon', 'Moyen-Ogooue\r'),
(1283, 'Gabon', 'Ngounie\r'),
(1284, 'Gabon', 'Nyanga\r'),
(1285, 'Gabon', 'Ogooue-Ivindo\r'),
(1286, 'Gabon', 'Ogooue-Lolo\r'),
(1287, 'Gabon', 'Ogooue-Maritime\r'),
(1288, 'Gabon', 'Woleu-Ntem\r'),
(1289, 'Gambia', 'Banjul\r'),
(1290, 'Gambia', 'Central River\r'),
(1291, 'Gambia', 'Lower River\r'),
(1292, 'Gambia', 'North Bank\r'),
(1293, 'Gambia', 'Upper River\r'),
(1294, 'Gambia', 'Western\r'),
(1295, 'Gaza Strip', 'Gaza Strip\r'),
(1296, 'Georgia', 'Abashis\r'),
(1297, 'Georgia', 'Abkhazia or Apkhazetis Avtonomiuri Respublika'),
(1298, '    (Sokhumi)\r', NULL),
(1299, 'Georgia', 'Adigenis\r'),
(1300, 'Georgia', 'Ajaria or Acharis Avtonomiuri Respublika\r'),
(1301, 'Georgia', 'Akhalgoris\r'),
(1302, 'Georgia', 'Akhalkalakis\r'),
(1303, 'Georgia', 'Akhaltsikhis\r'),
(1304, 'Georgia', 'Akhmetis\r'),
(1305, 'Georgia', 'Ambrolauris\r'),
(1306, 'Georgia', 'Aspindzis\r'),
(1307, 'Georgia', 'Baghdatis\r'),
(1308, 'Georgia', 'Bolnisis\r'),
(1309, 'Georgia', 'Borjomis\r'),
(1310, 'Georgia', 'Chkhorotsqus\r'),
(1311, 'Georgia', 'Chokhatauris\r'),
(1312, 'Georgia', 'Chiatura\r'),
(1313, 'Georgia', 'Dedoplistsqaros\r'),
(1314, 'Georgia', 'Dmanisis\r'),
(1315, 'Georgia', 'Dushetis\r'),
(1316, 'Georgia', 'Gardabanis\r'),
(1317, 'Georgia', 'Gori\r'),
(1318, 'Georgia', 'Goris\r'),
(1319, 'Georgia', 'Gurjaanis\r'),
(1320, 'Georgia', 'Javis\r'),
(1321, 'Georgia', 'Karelis\r'),
(1322, 'Georgia', 'Kutaisi\r'),
(1323, 'Georgia', 'Kaspis\r'),
(1324, 'Georgia', 'Kharagaulis\r'),
(1325, 'Georgia', 'Khashuris\r'),
(1326, 'Georgia', 'Khobis\r'),
(1327, 'Georgia', 'Khonis\r'),
(1328, 'Georgia', 'Lagodekhis\r'),
(1329, 'Georgia', 'Lanchkhutis\r'),
(1330, 'Georgia', 'Lentekhis\r'),
(1331, 'Georgia', 'Marneulis\r'),
(1332, 'Georgia', 'Martvilis\r'),
(1333, 'Georgia', 'Mestiis\r'),
(1334, 'Georgia', 'Mtskhetis\r'),
(1335, 'Georgia', 'Ninotsmindis\r'),
(1336, 'Georgia', 'Onis\r'),
(1337, 'Georgia', 'Ozurgetis\r'),
(1338, 'Georgia', 'Poti\r'),
(1339, 'Georgia', 'Qazbegis\r'),
(1340, 'Georgia', 'Qvarlis\r'),
(1341, 'Georgia', 'Rustavi\r'),
(1342, 'Georgia', 'Sachkheris\r'),
(1343, 'Georgia', 'Sagarejos\r'),
(1344, 'Georgia', 'Samtrediis\r'),
(1345, 'Georgia', 'Senakis\r'),
(1346, 'Georgia', 'Sighnaghis\r'),
(1347, 'Georgia', 'Tbilisi\r'),
(1348, 'Georgia', 'Telavis\r'),
(1349, 'Georgia', 'Terjolis\r'),
(1350, 'Georgia', 'Tetritsqaros\r'),
(1351, 'Georgia', 'Tianetis\r'),
(1352, 'Georgia', 'Tqibuli\r'),
(1353, 'Georgia', 'Tsageris\r'),
(1354, 'Georgia', 'Tsalenjikhis\r'),
(1355, 'Georgia', 'Tsalkis\r'),
(1356, 'Georgia', 'Tsqaltubo\r'),
(1357, 'Georgia', 'Vanis\r'),
(1358, 'Georgia', 'Zestaponis\r'),
(1359, 'Georgia', 'Zugdidi\r'),
(1360, 'Georgia', 'Zugdidis\r'),
(1361, 'Germany', 'Baden-Wuerttemberg\r'),
(1362, 'Germany', 'Bayern\r'),
(1363, 'Germany', 'Berlin\r'),
(1364, 'Germany', 'Brandenburg\r'),
(1365, 'Germany', 'Bremen\r'),
(1366, 'Germany', 'Hamburg\r'),
(1367, 'Germany', 'Hessen\r'),
(1368, 'Germany', 'Mecklenburg-Vorpommern\r'),
(1369, 'Germany', 'Niedersachsen\r'),
(1370, 'Germany', 'Nordrhein-Westfalen\r'),
(1371, 'Germany', 'Rheinland-Pfalz\r'),
(1372, 'Germany', 'Saarland\r'),
(1373, 'Germany', 'Sachsen\r'),
(1374, 'Germany', 'Sachsen-Anhalt\r'),
(1375, 'Germany', 'Schleswig-Holstein\r'),
(1376, 'Germany', 'Thueringen\r'),
(1377, 'Ghana', 'Ashanti\r'),
(1378, 'Ghana', 'Brong-Ahafo\r'),
(1379, 'Ghana', 'Central\r'),
(1380, 'Ghana', 'Eastern\r'),
(1381, 'Ghana', 'Greater Accra\r'),
(1382, 'Ghana', 'Northern\r'),
(1383, 'Ghana', 'Upper East\r'),
(1384, 'Ghana', 'Upper West\r'),
(1385, 'Ghana', 'Volta\r'),
(1386, 'Ghana', 'Western\r'),
(1387, 'Gibraltar', 'Gibraltar\r'),
(1388, 'Glorioso Islands', 'Ile du Lys\r'),
(1389, 'Glorioso Islands', 'Ile Glorieuse\r'),
(1390, 'Greece', 'Aitolia kai Akarnania\r'),
(1391, 'Greece', 'Akhaia\r'),
(1392, 'Greece', 'Argolis\r'),
(1393, 'Greece', 'Arkadhia\r'),
(1394, 'Greece', 'Arta\r'),
(1395, 'Greece', 'Attiki\r'),
(1396, 'Greece', 'Ayion Oros (Mt. Athos)\r'),
(1397, 'Greece', 'Dhodhekanisos\r'),
(1398, 'Greece', 'Drama\r'),
(1399, 'Greece', 'Evritania\r'),
(1400, 'Greece', 'Evros\r'),
(1401, 'Greece', 'Evvoia\r'),
(1402, 'Greece', 'Florina\r'),
(1403, 'Greece', 'Fokis\r'),
(1404, 'Greece', 'Fthiotis\r'),
(1405, 'Greece', 'Grevena\r'),
(1406, 'Greece', 'Ilia\r'),
(1407, 'Greece', 'Imathia\r'),
(1408, 'Greece', 'Ioannina\r'),
(1409, 'Greece', 'Irakleion\r'),
(1410, 'Greece', 'Kardhitsa\r'),
(1411, 'Greece', 'Kastoria\r'),
(1412, 'Greece', 'Kavala\r'),
(1413, 'Greece', 'Kefallinia\r'),
(1414, 'Greece', 'Kerkyra\r'),
(1415, 'Greece', 'Khalkidhiki\r'),
(1416, 'Greece', 'Khania\r'),
(1417, 'Greece', 'Khios\r'),
(1418, 'Greece', 'Kikladhes\r'),
(1419, 'Greece', 'Kilkis\r'),
(1420, 'Greece', 'Korinthia\r'),
(1421, 'Greece', 'Kozani\r'),
(1422, 'Greece', 'Lakonia\r'),
(1423, 'Greece', 'Larisa\r'),
(1424, 'Greece', 'Lasithi\r'),
(1425, 'Greece', 'Lesvos\r'),
(1426, 'Greece', 'Levkas\r'),
(1427, 'Greece', 'Magnisia\r'),
(1428, 'Greece', 'Messinia\r'),
(1429, 'Greece', 'Pella\r'),
(1430, 'Greece', 'Pieria\r'),
(1431, 'Greece', 'Preveza\r'),
(1432, 'Greece', 'Rethimni\r'),
(1433, 'Greece', 'Rodhopi\r'),
(1434, 'Greece', 'Samos\r'),
(1435, 'Greece', 'Serrai\r'),
(1436, 'Greece', 'Thesprotia\r'),
(1437, 'Greece', 'Thessaloniki\r'),
(1438, 'Greece', 'Trikala\r'),
(1439, 'Greece', 'Voiotia\r'),
(1440, 'Greece', 'Xanthi\r'),
(1441, 'Greece', 'Zakinthos\r'),
(1442, 'Greenland', 'Avannaa (Nordgronland)\r'),
(1443, 'Greenland', 'Kitaa (Vestgronland)\r'),
(1444, 'Greenland', 'Tunu (Ostgronland)\r'),
(1445, 'Grenada', 'Carriacou and Petit Martinique\r'),
(1446, 'Grenada', 'Saint Andrew\r'),
(1447, 'Grenada', 'Saint David\r'),
(1448, 'Grenada', 'Saint George\r'),
(1449, 'Grenada', 'Saint John\r'),
(1450, 'Grenada', 'Saint Mark\r'),
(1451, 'Grenada', 'Saint Patrick\r'),
(1452, 'Guadeloupe', 'Basse-Terre\r'),
(1453, 'Guadeloupe', 'Grande-Terre\r'),
(1454, 'Guadeloupe', 'Iles de la Petite Terre\r'),
(1455, 'Guadeloupe', 'Iles des Saintes\r'),
(1456, 'Guadeloupe', 'Marie-Galante\r'),
(1457, 'Guam', 'Guam\r'),
(1458, 'Guatemala', 'Alta Verapaz\r'),
(1459, 'Guatemala', 'Baja Verapaz\r'),
(1460, 'Guatemala', 'Chimaltenango\r'),
(1461, 'Guatemala', 'Chiquimula\r'),
(1462, 'Guatemala', 'El Progreso\r'),
(1463, 'Guatemala', 'Escuintla\r'),
(1464, 'Guatemala', 'Guatemala\r'),
(1465, 'Guatemala', 'Huehuetenango\r'),
(1466, 'Guatemala', 'Izabal\r'),
(1467, 'Guatemala', 'Jalapa\r'),
(1468, 'Guatemala', 'Jutiapa\r'),
(1469, 'Guatemala', 'Peten\r'),
(1470, 'Guatemala', 'Quetzaltenango\r'),
(1471, 'Guatemala', 'Quiche\r'),
(1472, 'Guatemala', 'Retalhuleu\r'),
(1473, 'Guatemala', 'Sacatepequez\r'),
(1474, 'Guatemala', 'San Marcos\r'),
(1475, 'Guatemala', 'Santa Rosa\r'),
(1476, 'Guatemala', 'Solola\r'),
(1477, 'Guatemala', 'Suchitepequez\r'),
(1478, 'Guatemala', 'Totonicapan\r'),
(1479, 'Guatemala', 'Zacapa\r'),
(1480, 'Guernsey', 'Castel\r'),
(1481, 'Guernsey', 'Forest\r');
INSERT INTO `states` (`id`, `country`, `state`) VALUES
(1482, 'Guernsey', 'St. Andrew\r'),
(1483, 'Guernsey', 'St. Martin\r'),
(1484, 'Guernsey', 'St. Peter Port\r'),
(1485, 'Guernsey', 'St. Pierre du Bois\r'),
(1486, 'Guernsey', 'St. Sampson\r'),
(1487, 'Guernsey', 'St. Saviour\r'),
(1488, 'Guernsey', 'Torteval\r'),
(1489, 'Guernsey', 'Vale\r'),
(1490, 'Guinea', 'Beyla\r'),
(1491, 'Guinea', 'Boffa\r'),
(1492, 'Guinea', 'Boke\r'),
(1493, 'Guinea', 'Conakry\r'),
(1494, 'Guinea', 'Coyah\r'),
(1495, 'Guinea', 'Dabola\r'),
(1496, 'Guinea', 'Dalaba\r'),
(1497, 'Guinea', 'Dinguiraye\r'),
(1498, 'Guinea', 'Dubreka\r'),
(1499, 'Guinea', 'Faranah\r'),
(1500, 'Guinea', 'Forecariah\r'),
(1501, 'Guinea', 'Fria\r'),
(1502, 'Guinea', 'Gaoual\r'),
(1503, 'Guinea', 'Gueckedou\r'),
(1504, 'Guinea', 'Kankan\r'),
(1505, 'Guinea', 'Kerouane\r'),
(1506, 'Guinea', 'Kindia\r'),
(1507, 'Guinea', 'Kissidougou\r'),
(1508, 'Guinea', 'Koubia\r'),
(1509, 'Guinea', 'Koundara\r'),
(1510, 'Guinea', 'Kouroussa\r'),
(1511, 'Guinea', 'Labe\r'),
(1512, 'Guinea', 'Lelouma\r'),
(1513, 'Guinea', 'Lola\r'),
(1514, 'Guinea', 'Macenta\r'),
(1515, 'Guinea', 'Mali\r'),
(1516, 'Guinea', 'Mamou\r'),
(1517, 'Guinea', 'Mandiana\r'),
(1518, 'Guinea', 'Nzerekore\r'),
(1519, 'Guinea', 'Pita\r'),
(1520, 'Guinea', 'Siguiri\r'),
(1521, 'Guinea', 'Telimele\r'),
(1522, 'Guinea', 'Tougue\r'),
(1523, 'Guinea', 'Yomou\r'),
(1524, 'Guinea-Bissau', 'Bafata\r'),
(1525, 'Guinea-Bissau', 'Biombo\r'),
(1526, 'Guinea-Bissau', 'Bissau\r'),
(1527, 'Guinea-Bissau', 'Bolama-Bijagos\r'),
(1528, 'Guinea-Bissau', 'Cacheu\r'),
(1529, 'Guinea-Bissau', 'Gabu\r'),
(1530, 'Guinea-Bissau', 'Oio\r'),
(1531, 'Guinea-Bissau', 'Quinara\r'),
(1532, 'Guinea-Bissau', 'Tombali\r'),
(1533, 'Guyana', 'Barima-Waini\r'),
(1534, 'Guyana', 'Cuyuni-Mazaruni\r'),
(1535, 'Guyana', 'Demerara-Mahaica\r'),
(1536, 'Guyana', 'East Berbice-Corentyne\r'),
(1537, 'Guyana', 'Essequibo Islands-West Demerara\r'),
(1538, 'Guyana', 'Mahaica-Berbice\r'),
(1539, 'Guyana', 'Pomeroon-Supenaam\r'),
(1540, 'Guyana', 'Potaro-Siparuni\r'),
(1541, 'Guyana', 'Upper Demerara-Berbice\r'),
(1542, 'Guyana', 'Upper Takutu-Upper Essequibo\r'),
(1543, 'Haiti', 'Artibonite\r'),
(1544, 'Haiti', 'Centre\r'),
(1545, 'Haiti', 'GrandAnse\r'),
(1546, 'Haiti', 'Nord\r'),
(1547, 'Haiti', 'Nord-Est\r'),
(1548, 'Haiti', 'Nord-Ouest\r'),
(1549, 'Haiti', 'Ouest\r'),
(1550, 'Haiti', 'Sud\r'),
(1551, 'Haiti', 'Sud-Est\r'),
(1552, 'Heard Island and McDonald Islands', 'Heard Island and McDonald Islands\r'),
(1553, 'Holy See (Vatican City)', 'Holy See (Vatican City)\r'),
(1554, 'Honduras', 'Atlantida\r'),
(1555, 'Honduras', 'Choluteca\r'),
(1556, 'Honduras', 'Colon\r'),
(1557, 'Honduras', 'Comayagua\r'),
(1558, 'Honduras', 'Copan\r'),
(1559, 'Honduras', 'Cortes\r'),
(1560, 'Honduras', 'El Paraiso\r'),
(1561, 'Honduras', 'Francisco Morazan\r'),
(1562, 'Honduras', 'Gracias a Dios\r'),
(1563, 'Honduras', 'Intibuca\r'),
(1564, 'Honduras', 'Islas de la Bahia\r'),
(1565, 'Honduras', 'La Paz\r'),
(1566, 'Honduras', 'Lempira\r'),
(1567, 'Honduras', 'Ocotepeque\r'),
(1568, 'Honduras', 'Olancho\r'),
(1569, 'Honduras', 'Santa Barbara\r'),
(1570, 'Honduras', 'Valle\r'),
(1571, 'Honduras', 'Yoro\r'),
(1572, 'Hong Kong', 'Hong Kong\r'),
(1573, 'Howland Island', 'Howland Island\r'),
(1574, 'Hungary', 'Bacs-Kiskun\r'),
(1575, 'Hungary', 'Baranya\r'),
(1576, 'Hungary', 'Bekes\r'),
(1577, 'Hungary', 'Bekescsaba\r'),
(1578, 'Hungary', 'Borsod-Abauj-Zemplen\r'),
(1579, 'Hungary', 'Budapest\r'),
(1580, 'Hungary', 'Csongrad\r'),
(1581, 'Hungary', 'Debrecen\r'),
(1582, 'Hungary', 'Dunaujvaros\r'),
(1583, 'Hungary', 'Eger\r'),
(1584, 'Hungary', 'Fejer\r'),
(1585, 'Hungary', 'Gyor\r'),
(1586, 'Hungary', 'Gyor-Moson-Sopron\r'),
(1587, 'Hungary', 'Hajdu-Bihar\r'),
(1588, 'Hungary', 'Heves\r'),
(1589, 'Hungary', 'Hodmezovasarhely\r'),
(1590, 'Hungary', 'Jasz-Nagykun-Szolnok\r'),
(1591, 'Hungary', 'Kaposvar\r'),
(1592, 'Hungary', 'Kecskemet\r'),
(1593, 'Hungary', 'Komarom-Esztergom\r'),
(1594, 'Hungary', 'Miskolc\r'),
(1595, 'Hungary', 'Nagykanizsa\r'),
(1596, 'Hungary', 'Nograd\r'),
(1597, 'Hungary', 'Nyiregyhaza\r'),
(1598, 'Hungary', 'Pecs\r'),
(1599, 'Hungary', 'Pest\r'),
(1600, 'Hungary', 'Somogy\r'),
(1601, 'Hungary', 'Sopron\r'),
(1602, 'Hungary', 'Szabolcs-Szatmar-Bereg\r'),
(1603, 'Hungary', 'Szeged\r'),
(1604, 'Hungary', 'Szekesfehervar\r'),
(1605, 'Hungary', 'Szolnok\r'),
(1606, 'Hungary', 'Szombathely\r'),
(1607, 'Hungary', 'Tatabanya\r'),
(1608, 'Hungary', 'Tolna\r'),
(1609, 'Hungary', 'Vas\r'),
(1610, 'Hungary', 'Veszprem\r'),
(1611, 'Hungary', 'Veszprem\r'),
(1612, 'Hungary', 'Zala\r'),
(1613, 'Hungary', 'Zalaegerszeg\r'),
(1614, 'Iceland', 'Akranes\r'),
(1615, 'Iceland', 'Akureyri\r'),
(1616, 'Iceland', 'Arnessysla\r'),
(1617, 'Iceland', 'Austur-Bardhastrandarsysla\r'),
(1618, 'Iceland', 'Austur-Hunavatnssysla\r'),
(1619, 'Iceland', 'Austur-Skaftafellssysla\r'),
(1620, 'Iceland', 'Borgarfjardharsysla\r'),
(1621, 'Iceland', 'Dalasysla\r'),
(1622, 'Iceland', 'Eyjafjardharsysla\r'),
(1623, 'Iceland', 'Gullbringusysla\r'),
(1624, 'Iceland', 'Hafnarfjordhur\r'),
(1625, 'Iceland', 'Husavik\r'),
(1626, 'Iceland', 'Isafjordhur\r'),
(1627, 'Iceland', 'Keflavik\r'),
(1628, 'Iceland', 'Kjosarsysla\r'),
(1629, 'Iceland', 'Kopavogur\r'),
(1630, 'Iceland', 'Myrasysla\r'),
(1631, 'Iceland', 'Neskaupstadhur\r'),
(1632, 'Iceland', 'Nordhur-Isafjardharsysla\r'),
(1633, 'Iceland', 'Nordhur-Mulasys-la\r'),
(1634, 'Iceland', 'Nordhur-Thingeyjarsysla\r'),
(1635, 'Iceland', 'Olafsfjordhur\r'),
(1636, 'Iceland', 'Rangarvallasysla\r'),
(1637, 'Iceland', 'Reykjavik\r'),
(1638, 'Iceland', 'Saudharkrokur\r'),
(1639, 'Iceland', 'Seydhisfjordhur\r'),
(1640, 'Iceland', 'Siglufjordhur\r'),
(1641, 'Iceland', 'Skagafjardharsysla\r'),
(1642, 'Iceland', 'Snaefellsnes-og Hnappadalssysla\r'),
(1643, 'Iceland', 'Strandasysla\r'),
(1644, 'Iceland', 'Sudhur-Mulasysla\r'),
(1645, 'Iceland', 'Sudhur-Thingeyjarsysla\r'),
(1646, 'Iceland', 'Vesttmannaeyjar\r'),
(1647, 'Iceland', 'Vestur-Bardhastrandarsysla\r'),
(1648, 'Iceland', 'Vestur-Hunavatnssysla\r'),
(1649, 'Iceland', 'Vestur-Isafjardharsysla\r'),
(1650, 'Iceland', 'Vestur-Skaftafellssysla\r'),
(1651, 'India', 'Andaman and Nicobar Islands\r'),
(1652, 'India', 'Andhra Pradesh\r'),
(1653, 'India', 'Arunachal Pradesh\r'),
(1654, 'India', 'Assam\r'),
(1655, 'India', 'Bihar\r'),
(1656, 'India', 'Chandigarh\r'),
(1657, 'India', 'Chhattisgarh\r'),
(1658, 'India', 'Dadra and Nagar Haveli\r'),
(1659, 'India', 'Daman and Diu\r'),
(1660, 'India', 'Delhi\r'),
(1661, 'India', 'Goa\r'),
(1662, 'India', 'Gujarat\r'),
(1663, 'India', 'Haryana\r'),
(1664, 'India', 'Himachal Pradesh\r'),
(1665, 'India', 'Jammu and Kashmir\r'),
(1666, 'India', 'Jharkhand\r'),
(1667, 'India', 'Karnataka\r'),
(1668, 'India', 'Kerala\r'),
(1669, 'India', 'Lakshadweep\r'),
(1670, 'India', 'Madhya Pradesh\r'),
(1671, 'India', 'Maharashtra\r'),
(1672, 'India', 'Manipur\r'),
(1673, 'India', 'Meghalaya\r'),
(1674, 'India', 'Mizoram\r'),
(1675, 'India', 'Nagaland\r'),
(1676, 'India', 'Orissa\r'),
(1677, 'India', 'Pondicherry\r'),
(1678, 'India', 'Punjab\r'),
(1679, 'India', 'Rajasthan\r'),
(1680, 'India', 'Sikkim\r'),
(1681, 'India', 'Tamil Nadu\r'),
(1682, 'India', 'Tripura\r'),
(1683, 'India', 'Uttar Pradesh\r'),
(1684, 'India', 'Uttaranchal\r'),
(1685, 'India', 'West Bengal\r'),
(1686, 'ID', 'Aceh\r'),
(1687, 'ID', 'Bali\r'),
(1688, 'ID', 'Banten\r'),
(1689, 'ID', 'Bengkulu\r'),
(1690, 'ID', 'East Timor\r'),
(1691, 'ID', 'Gorontalo\r'),
(1692, 'ID', 'Irian Jaya\r'),
(1693, 'ID', 'Jakarta Raya\r'),
(1694, 'ID', 'Jambi\r'),
(1695, 'ID', 'Jawa Barat\r'),
(1696, 'ID', 'Jawa Tengah\r'),
(1697, 'ID', 'Jawa Timur\r'),
(1698, 'ID', 'Kalimantan Barat\r'),
(1699, 'ID', 'Kalimantan Selatan\r'),
(1700, 'ID', 'Kalimantan Tengah\r'),
(1701, 'ID', 'Kalimantan Timur\r'),
(1702, 'ID', 'Kepulauan Bangka Belitung\r'),
(1703, 'ID', 'Lampung\r'),
(1704, 'ID', 'Maluku\r'),
(1705, 'ID', 'Maluku Utara\r'),
(1706, 'ID', 'Nusa Tenggara Barat\r'),
(1707, 'ID', 'Nusa Tenggara Timur\r'),
(1708, 'ID', 'Riau\r'),
(1709, 'ID', 'Sulawesi Selatan\r'),
(1710, 'ID', 'Sulawesi Tengah\r'),
(1711, 'ID', 'Sulawesi Tenggara\r'),
(1712, 'ID', 'Sulawesi Utara\r'),
(1713, 'ID', 'Sumatera Barat\r'),
(1714, 'ID', 'Sumatera Selatan\r'),
(1715, 'ID', 'Sumatera Utara\r'),
(1716, 'ID', 'Yogyakarta\r'),
(1717, 'Iran', 'Ardabil\r'),
(1718, 'Iran', 'Azarbayjan-e Gharbi\r'),
(1719, 'Iran', 'Azarbayjan-e Sharqi\r'),
(1720, 'Iran', 'Bushehr\r'),
(1721, 'Iran', 'Chahar Mahall va Bakhtiari\r'),
(1722, 'Iran', 'Esfahan\r'),
(1723, 'Iran', 'Fars\r'),
(1724, 'Iran', 'Gilan\r'),
(1725, 'Iran', 'Golestan\r'),
(1726, 'Iran', 'Hamadan\r'),
(1727, 'Iran', 'Hormozgan\r'),
(1728, 'Iran', 'Ilam\r'),
(1729, 'Iran', 'Kerman\r'),
(1730, 'Iran', 'Kermanshah\r'),
(1731, 'Iran', 'Khorasan\r'),
(1732, 'Iran', 'Khuzestan\r'),
(1733, 'Iran', 'Kohgiluyeh va Buyer Ahmad\r'),
(1734, 'Iran', 'Kordestan\r'),
(1735, 'Iran', 'Lorestan\r'),
(1736, 'Iran', 'Markazi\r'),
(1737, 'Iran', 'Mazandaran\r'),
(1738, 'Iran', 'Qazvin\r'),
(1739, 'Iran', 'Qom\r'),
(1740, 'Iran', 'Semnan\r'),
(1741, 'Iran', 'Sistan va Baluchestan\r'),
(1742, 'Iran', 'Tehran\r'),
(1743, 'Iran', 'Yazd\r'),
(1744, 'Iran', 'Zanjan\r'),
(1745, 'Iraq', 'Al Anbar\r'),
(1746, 'Iraq', 'Al Basrah\r'),
(1747, 'Iraq', 'Al Muthanna\r'),
(1748, 'Iraq', 'Al Qadisiyah\r'),
(1749, 'Iraq', 'An Najaf\r'),
(1750, 'Iraq', 'Arbil\r'),
(1751, 'Iraq', 'As Sulaymaniyah\r'),
(1752, 'Iraq', 'At Tamim\r'),
(1753, 'Iraq', 'Babil\r'),
(1754, 'Iraq', 'Baghdad\r'),
(1755, 'Iraq', 'Dahuk\r'),
(1756, 'Iraq', 'Dhi Qar\r'),
(1757, 'Iraq', 'Diyala\r'),
(1758, 'Iraq', 'Karbala\r'),
(1759, 'Iraq', 'Maysan\r'),
(1760, 'Iraq', 'Ninawa\r'),
(1761, 'Iraq', 'Salah ad Din\r'),
(1762, 'Iraq', 'Wasit\r'),
(1763, 'Ireland', 'Carlow\r'),
(1764, 'Ireland', 'Cavan\r'),
(1765, 'Ireland', 'Clare\r'),
(1766, 'Ireland', 'Cork\r'),
(1767, 'Ireland', 'Donegal\r'),
(1768, 'Ireland', 'Dublin\r'),
(1769, 'Ireland', 'Galway\r'),
(1770, 'Ireland', 'Kerry\r'),
(1771, 'Ireland', 'Kildare\r'),
(1772, 'Ireland', 'Kilkenny\r'),
(1773, 'Ireland', 'Laois\r'),
(1774, 'Ireland', 'Leitrim\r'),
(1775, 'Ireland', 'Limerick\r'),
(1776, 'Ireland', 'Longford\r'),
(1777, 'Ireland', 'Louth\r'),
(1778, 'Ireland', 'Mayo\r'),
(1779, 'Ireland', 'Meath\r'),
(1780, 'Ireland', 'Monaghan\r'),
(1781, 'Ireland', 'Offaly\r'),
(1782, 'Ireland', 'Roscommon\r'),
(1783, 'Ireland', 'Sligo\r'),
(1784, 'Ireland', 'Tipperary\r'),
(1785, 'Ireland', 'Waterford\r'),
(1786, 'Ireland', 'Westmeath\r'),
(1787, 'Ireland', 'Wexford\r'),
(1788, 'Ireland', 'Wicklow\r'),
(1789, 'Ireland', ' Northern'),
(1790, 'Ireland', ' Northern'),
(1791, 'Ireland', ' Northern'),
(1792, 'Ireland', ' Northern'),
(1793, 'Ireland', ' Northern'),
(1794, 'Ireland', ' Northern'),
(1795, 'Ireland', ' Northern'),
(1796, 'Ireland', ' Northern'),
(1797, 'Ireland', ' Northern'),
(1798, 'Ireland', ' Northern'),
(1799, 'Ireland', ' Northern'),
(1800, 'Ireland', ' Northern'),
(1801, 'Ireland', ' Northern'),
(1802, 'Ireland', ' Northern'),
(1803, 'Ireland', ' Northern'),
(1804, 'Ireland', ' Northern'),
(1805, 'Ireland', ' Northern'),
(1806, 'Ireland', ' Northern'),
(1807, 'Ireland', ' Northern'),
(1808, 'Ireland', ' Northern'),
(1809, 'Ireland', ' Northern'),
(1810, 'Ireland', ' Northern'),
(1811, 'Ireland', ' Northern'),
(1812, 'Ireland', ' Northern'),
(1813, 'Ireland', ' Northern'),
(1814, 'Ireland', ' Northern'),
(1815, 'Israel', 'Central\r'),
(1816, 'Israel', 'Haifa\r'),
(1817, 'Israel', 'Jerusalem\r'),
(1818, 'Israel', 'Northern\r'),
(1819, 'Israel', 'Southern\r'),
(1820, 'Israel', 'Tel Aviv\r'),
(1821, 'Italy', 'Abruzzi\r'),
(1822, 'Italy', 'Basilicata\r'),
(1823, 'Italy', 'Calabria\r'),
(1824, 'Italy', 'Campania\r'),
(1825, 'Italy', 'Emilia-Romagna\r'),
(1826, 'Italy', 'Friuli-Venezia Giulia\r'),
(1827, 'Italy', 'Lazio\r'),
(1828, 'Italy', 'Liguria\r'),
(1829, 'Italy', 'Lombardia\r'),
(1830, 'Italy', 'Marche\r'),
(1831, 'Italy', 'Molise\r'),
(1832, 'Italy', 'Piemonte\r'),
(1833, 'Italy', 'Puglia\r'),
(1834, 'Italy', 'Sardegna\r'),
(1835, 'Italy', 'Sicilia\r'),
(1836, 'Italy', 'Toscana\r'),
(1837, 'Italy', 'Trentino-Alto Adige\r'),
(1838, 'Italy', 'Umbria\r'),
(1839, 'Italy', 'Valle dAosta\r'),
(1840, 'Italy', 'Veneto\r'),
(1841, 'Jamaica', 'Clarendon\r'),
(1842, 'Jamaica', 'Hanover\r'),
(1843, 'Jamaica', 'Kingston\r'),
(1844, 'Jamaica', 'Manchester\r'),
(1845, 'Jamaica', 'Portland\r'),
(1846, 'Jamaica', 'Saint Andrew\r'),
(1847, 'Jamaica', 'Saint Ann\r'),
(1848, 'Jamaica', 'Saint Catherine\r'),
(1849, 'Jamaica', 'Saint Elizabeth\r'),
(1850, 'Jamaica', 'Saint James\r'),
(1851, 'Jamaica', 'Saint Mary\r'),
(1852, 'Jamaica', 'Saint Thomas\r'),
(1853, 'Jamaica', 'Trelawny\r'),
(1854, 'Jamaica', 'Westmoreland\r'),
(1855, 'Jan Mayen', 'Jan Mayen\r'),
(1856, 'Japan', 'Aichi\r'),
(1857, 'Japan', 'Akita\r'),
(1858, 'Japan', 'Aomori\r'),
(1859, 'Japan', 'Chiba\r'),
(1860, 'Japan', 'Ehime\r'),
(1861, 'Japan', 'Fukui\r'),
(1862, 'Japan', 'Fukuoka\r'),
(1863, 'Japan', 'Fukushima\r'),
(1864, 'Japan', 'Gifu\r'),
(1865, 'Japan', 'Gumma\r'),
(1866, 'Japan', 'Hiroshima\r'),
(1867, 'Japan', 'Hokkaido\r'),
(1868, 'Japan', 'Hyogo\r'),
(1869, 'Japan', 'Ibaraki\r'),
(1870, 'Japan', 'Ishikawa\r'),
(1871, 'Japan', 'Iwate\r'),
(1872, 'Japan', 'Kagawa\r'),
(1873, 'Japan', 'Kagoshima\r'),
(1874, 'Japan', 'Kanagawa\r'),
(1875, 'Japan', 'Kochi\r'),
(1876, 'Japan', 'Kumamoto\r'),
(1877, 'Japan', 'Kyoto\r'),
(1878, 'Japan', 'Mie\r'),
(1879, 'Japan', 'Miyagi\r'),
(1880, 'Japan', 'Miyazaki\r'),
(1881, 'Japan', 'Nagano\r'),
(1882, 'Japan', 'Nagasaki\r'),
(1883, 'Japan', 'Nara\r'),
(1884, 'Japan', 'Niigata\r'),
(1885, 'Japan', 'Oita\r'),
(1886, 'Japan', 'Okayama\r'),
(1887, 'Japan', 'Okinawa\r'),
(1888, 'Japan', 'Osaka\r'),
(1889, 'Japan', 'Saga\r'),
(1890, 'Japan', 'Saitama\r'),
(1891, 'Japan', 'Shiga\r'),
(1892, 'Japan', 'Shimane\r'),
(1893, 'Japan', 'Shizuoka\r'),
(1894, 'Japan', 'Tochigi\r'),
(1895, 'Japan', 'Tokushima\r'),
(1896, 'Japan', 'Tokyo\r'),
(1897, 'Japan', 'Tottori\r'),
(1898, 'Japan', 'Toyama\r'),
(1899, 'Japan', 'Wakayama\r'),
(1900, 'Japan', 'Yamagata\r'),
(1901, 'Japan', 'Yamaguchi\r'),
(1902, 'Japan', 'Yamanashi\r'),
(1903, 'Jarvis Island', 'Jarvis Island\r'),
(1904, 'Jersey', 'Jersey\r'),
(1905, 'Johnston Atoll', 'Johnston Atoll\r'),
(1906, 'Jordan', 'Amman\r'),
(1907, 'Jordan', 'Ajlun\r'),
(1908, 'Jordan', 'Al Aqabah\r'),
(1909, 'Jordan', 'Al Balqa\r'),
(1910, 'Jordan', 'Al Karak\r'),
(1911, 'Jordan', 'Al Mafraq\r'),
(1912, 'Jordan', 'At Tafilah\r'),
(1913, 'Jordan', 'Az Zarqa\r'),
(1914, 'Jordan', 'Irbid\r'),
(1915, 'Jordan', 'Jarash\r'),
(1916, 'Jordan', 'Maan\r'),
(1917, 'Jordan', 'Madaba\r'),
(1918, 'Juan de Nova Island', 'Juan de Nova Island\r'),
(1919, 'Kazakhstan', 'Almaty\r'),
(1920, 'Kazakhstan', 'Aqmola\r'),
(1921, 'Kazakhstan', 'Aqtobe\r'),
(1922, 'Kazakhstan', 'Astana\r'),
(1923, 'Kazakhstan', 'Atyrau\r'),
(1924, 'Kazakhstan', 'Batys Qazaqstan\r'),
(1925, 'Kazakhstan', 'Bayqongyr\r'),
(1926, 'Kazakhstan', 'Mangghystau\r'),
(1927, 'Kazakhstan', 'Ongtustik Qazaqstan\r'),
(1928, 'Kazakhstan', 'Pavlodar\r'),
(1929, 'Kazakhstan', 'Qaraghandy\r'),
(1930, 'Kazakhstan', 'Qostanay\r'),
(1931, 'Kazakhstan', 'Qyzylorda\r'),
(1932, 'Kazakhstan', 'Shyghys Qazaqstan\r'),
(1933, 'Kazakhstan', 'Soltustik Qazaqstan\r'),
(1934, 'Kazakhstan', 'Zhambyl\r'),
(1935, 'Kenya', 'Central\r'),
(1936, 'Kenya', 'Coast\r'),
(1937, 'Kenya', 'Eastern\r'),
(1938, 'Kenya', 'Nairobi Area\r'),
(1939, 'Kenya', 'North Eastern\r'),
(1940, 'Kenya', 'Nyanza\r'),
(1941, 'Kenya', 'Rift Valley\r'),
(1942, 'Kenya', 'Western\r'),
(1943, 'Kiribati', 'Abaiang\r'),
(1944, 'Kiribati', 'Abemama\r'),
(1945, 'Kiribati', 'Aranuka\r'),
(1946, 'Kiribati', 'Arorae\r'),
(1947, 'Kiribati', 'Banaba\r'),
(1948, 'Kiribati', 'Banaba\r'),
(1949, 'Kiribati', 'Beru\r'),
(1950, 'Kiribati', 'Butaritari\r'),
(1951, 'Kiribati', 'Central Gilberts\r'),
(1952, 'Kiribati', 'Gilbert Islands\r'),
(1953, 'Kiribati', 'Kanton\r'),
(1954, 'Kiribati', 'Kiritimati\r'),
(1955, 'Kiribati', 'Kuria\r'),
(1956, 'Kiribati', 'Line Islands\r'),
(1957, 'Kiribati', 'Line Islands\r'),
(1958, 'Kiribati', 'Maiana\r'),
(1959, 'Kiribati', 'Makin\r'),
(1960, 'Kiribati', 'Marakei\r'),
(1961, 'Kiribati', 'Nikunau\r'),
(1962, 'Kiribati', 'Nonouti\r'),
(1963, 'Kiribati', 'Northern Gilberts\r'),
(1964, 'Kiribati', 'Onotoa\r'),
(1965, 'Kiribati', 'Phoenix Islands\r'),
(1966, 'Kiribati', 'Southern Gilberts\r'),
(1967, 'Kiribati', 'Tabiteuea\r'),
(1968, 'Kiribati', 'Tabuaeran\r'),
(1969, 'Kiribati', 'Tamana\r'),
(1970, 'Kiribati', 'Tarawa\r'),
(1971, 'Kiribati', 'Tarawa\r'),
(1972, 'Kiribati', 'Teraina\r'),
(1973, 'Korea', ' North'),
(1974, 'Korea', ' North'),
(1975, 'Korea', ' North'),
(1976, 'Korea', ' North'),
(1977, 'Korea', ' North'),
(1978, 'Korea', ' North'),
(1979, 'Korea', ' North'),
(1980, 'Korea', ' North'),
(1981, 'Korea', ' North'),
(1982, 'Korea', ' North'),
(1983, 'Korea', ' North'),
(1984, 'Korea', ' North'),
(1985, 'Korea', ' South'),
(1986, 'Korea', ' South'),
(1987, 'Korea', ' South'),
(1988, 'Korea', ' South'),
(1989, 'Korea', ' South'),
(1990, 'Korea', ' South'),
(1991, 'Korea', ' South'),
(1992, 'Korea', ' South'),
(1993, 'Korea', ' South'),
(1994, 'Korea', ' South'),
(1995, 'Korea', ' South'),
(1996, 'Korea', ' South'),
(1997, 'Korea', ' South'),
(1998, 'Korea', ' South'),
(1999, 'Korea', ' South'),
(2000, 'Korea', ' South'),
(2001, 'Kuwait', 'Al Asimah\r'),
(2002, 'Kuwait', 'Al Ahmadi\r'),
(2003, 'Kuwait', 'Al Farwaniyah\r'),
(2004, 'Kuwait', 'Al Jahra\r'),
(2005, 'Kuwait', 'Hawalli\r'),
(2006, 'Kyrgyzstan', 'Batken Oblasty\r'),
(2007, 'Kyrgyzstan', 'Bishkek Shaary\r'),
(2008, 'Kyrgyzstan', 'Chuy Oblasty (Bishkek)\r'),
(2009, 'Kyrgyzstan', 'Jalal-Abad Oblasty\r'),
(2010, 'Kyrgyzstan', 'Naryn Oblasty\r'),
(2011, 'Kyrgyzstan', 'Osh Oblasty\r'),
(2012, 'Kyrgyzstan', 'Talas Oblasty\r'),
(2013, 'Kyrgyzstan', 'Ysyk-Kol Oblasty (Karakol)\r'),
(2014, 'LA', 'Attapu\r'),
(2015, 'LA', 'Bokeo\r'),
(2016, 'LA', 'Bolikhamxai\r'),
(2017, 'LA', 'Champasak\r'),
(2018, 'LA', 'Houaphan\r'),
(2019, 'LA', 'Khammouan\r'),
(2020, 'LA', 'Louangnamtha\r'),
(2021, 'LA', 'Louangphabang\r'),
(2022, 'LA', 'Oudomxai\r'),
(2023, 'LA', 'Phongsali\r'),
(2024, 'LA', 'Salavan\r'),
(2025, 'LA', 'Savannakhet\r'),
(2026, 'LA', 'Viangchan\r'),
(2027, 'LA', 'Viangchan\r'),
(2028, 'LA', 'Xaignabouli\r'),
(2029, 'LA', 'Xaisomboun\r'),
(2030, 'LA', 'Xekong\r'),
(2031, 'LA', 'Xiangkhoang\r'),
(2032, 'Latvia', 'Aizkraukles Rajons\r'),
(2033, 'Latvia', 'Aluksnes Rajons\r'),
(2034, 'Latvia', 'Balvu Rajons\r'),
(2035, 'Latvia', 'Bauskas Rajons\r'),
(2036, 'Latvia', 'Cesu Rajons\r'),
(2037, 'Latvia', 'Daugavpils\r'),
(2038, 'Latvia', 'Daugavpils Rajons\r'),
(2039, 'Latvia', 'Dobeles Rajons\r'),
(2040, 'Latvia', 'Gulbenes Rajons\r'),
(2041, 'Latvia', 'Jekabpils Rajons\r'),
(2042, 'Latvia', 'Jelgava\r'),
(2043, 'Latvia', 'Jelgavas Rajons\r'),
(2044, 'Latvia', 'Jurmala\r'),
(2045, 'Latvia', 'Kraslavas Rajons\r'),
(2046, 'Latvia', 'Kuldigas Rajons\r'),
(2047, 'Latvia', 'Leipaja\r'),
(2048, 'Latvia', 'Liepajas Rajons\r'),
(2049, 'Latvia', 'Limbazu Rajons\r'),
(2050, 'Latvia', 'Ludzas Rajons\r'),
(2051, 'Latvia', 'Madonas Rajons\r'),
(2052, 'Latvia', 'Ogres Rajons\r'),
(2053, 'Latvia', 'Preilu Rajons\r'),
(2054, 'Latvia', 'Rezekne\r'),
(2055, 'Latvia', 'Rezeknes Rajons\r'),
(2056, 'Latvia', 'Riga\r'),
(2057, 'Latvia', 'Rigas Rajons\r'),
(2058, 'Latvia', 'Saldus Rajons\r'),
(2059, 'Latvia', 'Talsu Rajons\r'),
(2060, 'Latvia', 'Tukuma Rajons\r'),
(2061, 'Latvia', 'Valkas Rajons\r'),
(2062, 'Latvia', 'Valmieras Rajons\r'),
(2063, 'Latvia', 'Ventspils\r'),
(2064, 'Latvia', 'Ventspils Rajons\r'),
(2065, 'Lebanon', 'Beyrouth\r'),
(2066, 'Lebanon', 'Ech Chimal\r'),
(2067, 'Lebanon', 'Ej Jnoub\r'),
(2068, 'Lebanon', 'El Bekaa\r'),
(2069, 'Lebanon', 'Jabal Loubnane\r'),
(2070, 'Lesotho', 'Berea\r'),
(2071, 'Lesotho', 'Butha-Buthe\r'),
(2072, 'Lesotho', 'Leribe\r'),
(2073, 'Lesotho', 'Mafeteng\r'),
(2074, 'Lesotho', 'Maseru\r'),
(2075, 'Lesotho', 'Mohales Hoek\r'),
(2076, 'Lesotho', 'Mokhotlong\r'),
(2077, 'Lesotho', 'Qachas Nek\r'),
(2078, 'Lesotho', 'Quthing\r'),
(2079, 'Lesotho', 'Thaba-Tseka\r'),
(2080, 'Liberia', 'Bomi\r'),
(2081, 'Liberia', 'Bong\r'),
(2082, 'Liberia', 'Grand Bassa\r'),
(2083, 'Liberia', 'Grand Cape Mount\r'),
(2084, 'Liberia', 'Grand Gedeh\r'),
(2085, 'Liberia', 'Grand Kru\r'),
(2086, 'Liberia', 'Lofa\r'),
(2087, 'Liberia', 'Margibi\r'),
(2088, 'Liberia', 'Maryland\r'),
(2089, 'Liberia', 'Montserrado\r'),
(2090, 'Liberia', 'Nimba\r'),
(2091, 'Liberia', 'River Cess\r'),
(2092, 'Liberia', 'Sinoe\r'),
(2093, 'Libya', 'Ajdabiya\r'),
(2094, 'Libya', 'Al Aziziyah\r'),
(2095, 'Libya', 'Al Fatih\r'),
(2096, 'Libya', 'Al Jabal al Akhdar\r'),
(2097, 'Libya', 'Al Jufrah\r'),
(2098, 'Libya', 'Al Khums\r'),
(2099, 'Libya', 'Al Kufrah\r'),
(2100, 'Libya', 'An Nuqat al Khams\r'),
(2101, 'Libya', 'Ash Shati\r'),
(2102, 'Libya', 'Awbari\r'),
(2103, 'Libya', 'Az Zawiyah\r'),
(2104, 'Libya', 'Banghazi\r'),
(2105, 'Libya', 'Darnah\r'),
(2106, 'Libya', 'Ghadamis\r'),
(2107, 'Libya', 'Gharyan\r'),
(2108, 'Libya', 'Misratah\r'),
(2109, 'Libya', 'Murzuq\r'),
(2110, 'Libya', 'Sabha\r'),
(2111, 'Libya', 'Sawfajjin\r'),
(2112, 'Libya', 'Surt\r'),
(2113, 'Libya', 'Tarabulus\r'),
(2114, 'Libya', 'Tarhunah\r'),
(2115, 'Libya', 'Tubruq\r'),
(2116, 'Libya', 'Yafran\r'),
(2117, 'Libya', 'Zlitan\r'),
(2118, 'Liechtenstein', 'Balzers\r'),
(2119, 'Liechtenstein', 'Eschen\r'),
(2120, 'Liechtenstein', 'Gamprin\r'),
(2121, 'Liechtenstein', 'Mauren\r'),
(2122, 'Liechtenstein', 'Planken\r'),
(2123, 'Liechtenstein', 'Ruggell\r'),
(2124, 'Liechtenstein', 'Schaan\r'),
(2125, 'Liechtenstein', 'Schellenberg\r'),
(2126, 'Liechtenstein', 'Triesen\r'),
(2127, 'Liechtenstein', 'Triesenberg\r'),
(2128, 'Liechtenstein', 'Vaduz\r'),
(2129, 'Lithuania', 'Akmenes Rajonas\r'),
(2130, 'Lithuania', 'Alytaus Rajonas\r'),
(2131, 'Lithuania', 'Alytus\r'),
(2132, 'Lithuania', 'Anyksciu Rajonas\r'),
(2133, 'Lithuania', 'Birstonas\r'),
(2134, 'Lithuania', 'Birzu Rajonas\r'),
(2135, 'Lithuania', 'Druskininkai\r'),
(2136, 'Lithuania', 'Ignalinos Rajonas\r'),
(2137, 'Lithuania', 'Jonavos Rajonas\r'),
(2138, 'Lithuania', 'Joniskio Rajonas\r'),
(2139, 'Lithuania', 'Jurbarko Rajonas\r'),
(2140, 'Lithuania', 'Kaisiadoriu Rajonas\r'),
(2141, 'Lithuania', 'Kaunas\r'),
(2142, 'Lithuania', 'Kauno Rajonas\r'),
(2143, 'Lithuania', 'Kedainiu Rajonas\r'),
(2144, 'Lithuania', 'Kelmes Rajonas\r'),
(2145, 'Lithuania', 'Klaipeda\r'),
(2146, 'Lithuania', 'Klaipedos Rajonas\r'),
(2147, 'Lithuania', 'Kretingos Rajonas\r'),
(2148, 'Lithuania', 'Kupiskio Rajonas\r'),
(2149, 'Lithuania', 'Lazdiju Rajonas\r'),
(2150, 'Lithuania', 'Marijampole\r'),
(2151, 'Lithuania', 'Marijampoles Rajonas\r'),
(2152, 'Lithuania', 'Mazeikiu Rajonas\r'),
(2153, 'Lithuania', 'Moletu Rajonas\r'),
(2154, 'Lithuania', 'Neringa Pakruojo Rajonas\r'),
(2155, 'Lithuania', 'Palanga\r'),
(2156, 'Lithuania', 'Panevezio Rajonas\r'),
(2157, 'Lithuania', 'Panevezys\r'),
(2158, 'Lithuania', 'Pasvalio Rajonas\r'),
(2159, 'Lithuania', 'Plunges Rajonas\r'),
(2160, 'Lithuania', 'Prienu Rajonas\r'),
(2161, 'Lithuania', 'Radviliskio Rajonas\r'),
(2162, 'Lithuania', 'Raseiniu Rajonas\r'),
(2163, 'Lithuania', 'Rokiskio Rajonas\r'),
(2164, 'Lithuania', 'Sakiu Rajonas\r'),
(2165, 'Lithuania', 'Salcininku Rajonas\r'),
(2166, 'Lithuania', 'Siauliai\r'),
(2167, 'Lithuania', 'Siauliu Rajonas\r'),
(2168, 'Lithuania', 'Silales Rajonas\r'),
(2169, 'Lithuania', 'Silutes Rajonas\r'),
(2170, 'Lithuania', 'Sirvintu Rajonas\r'),
(2171, 'Lithuania', 'Skuodo Rajonas\r'),
(2172, 'Lithuania', 'Svencioniu Rajonas\r'),
(2173, 'Lithuania', 'Taurages Rajonas\r'),
(2174, 'Lithuania', 'Telsiu Rajonas\r'),
(2175, 'Lithuania', 'Traku Rajonas\r'),
(2176, 'Lithuania', 'Ukmerges Rajonas\r'),
(2177, 'Lithuania', 'Utenos Rajonas\r'),
(2178, 'Lithuania', 'Varenos Rajonas\r'),
(2179, 'Lithuania', 'Vilkaviskio Rajonas\r'),
(2180, 'Lithuania', 'Vilniaus Rajonas\r'),
(2181, 'Lithuania', 'Vilnius\r'),
(2182, 'Lithuania', 'Zarasu Rajonas\r'),
(2183, 'Luxembourg', 'Diekirch\r'),
(2184, 'Luxembourg', 'Grevenmacher\r'),
(2185, 'Luxembourg', 'Luxembourg\r'),
(2186, 'Macau', 'Macau\r'),
(2187, 'Macedonia', 'Aracinovo\r'),
(2188, 'Macedonia', 'Bac\r'),
(2189, 'Macedonia', 'Belcista\r'),
(2190, 'Macedonia', 'Berovo\r'),
(2191, 'Macedonia', 'Bistrica\r'),
(2192, 'Macedonia', 'Bitola\r'),
(2193, 'Macedonia', 'Blatec\r'),
(2194, 'Macedonia', 'Bogdanci\r'),
(2195, 'Macedonia', 'Bogomila\r'),
(2196, 'Macedonia', 'Bogovinje\r'),
(2197, 'Macedonia', 'Bosilovo\r'),
(2198, 'Macedonia', 'Brvenica\r'),
(2199, 'Macedonia', 'Cair (Skopje)\r'),
(2200, 'Macedonia', 'Capari\r'),
(2201, 'Macedonia', 'Caska\r'),
(2202, 'Macedonia', 'Cegrane\r'),
(2203, 'Macedonia', 'Centar (Skopje)\r'),
(2204, 'Macedonia', 'Centar Zupa\r'),
(2205, 'Macedonia', 'Cesinovo\r'),
(2206, 'Macedonia', 'Cucer-Sandevo\r'),
(2207, 'Macedonia', 'Debar\r'),
(2208, 'Macedonia', 'Delcevo\r'),
(2209, 'Macedonia', 'Delogozdi\r'),
(2210, 'Macedonia', 'Demir Hisar\r'),
(2211, 'Macedonia', 'Demir Kapija\r'),
(2212, 'Macedonia', 'Dobrusevo\r'),
(2213, 'Macedonia', 'Dolna Banjica\r'),
(2214, 'Macedonia', 'Dolneni\r'),
(2215, 'Macedonia', 'Dorce Petrov (Skopje)\r'),
(2216, 'Macedonia', 'Drugovo\r'),
(2217, 'Macedonia', 'Dzepciste\r'),
(2218, 'Macedonia', 'Gazi Baba (Skopje)\r'),
(2219, 'Macedonia', 'Gevgelija\r'),
(2220, 'Macedonia', 'Gostivar\r'),
(2221, 'Macedonia', 'Gradsko\r'),
(2222, 'Macedonia', 'Ilinden\r'),
(2223, 'Macedonia', 'Izvor\r'),
(2224, 'Macedonia', 'Jegunovce\r'),
(2225, 'Macedonia', 'Kamenjane\r'),
(2226, 'Macedonia', 'Karbinci\r'),
(2227, 'Macedonia', 'Karpos (Skopje)\r'),
(2228, 'Macedonia', 'Kavadarci\r'),
(2229, 'Macedonia', 'Kicevo\r'),
(2230, 'Macedonia', 'Kisela Voda (Skopje)\r'),
(2231, 'Macedonia', 'Klecevce\r'),
(2232, 'Macedonia', 'Kocani\r'),
(2233, 'Macedonia', 'Konce\r'),
(2234, 'Macedonia', 'Kondovo\r'),
(2235, 'Macedonia', 'Konopiste\r'),
(2236, 'Macedonia', 'Kosel\r'),
(2237, 'Macedonia', 'Kratovo\r'),
(2238, 'Macedonia', 'Kriva Palanka\r'),
(2239, 'Macedonia', 'Krivogastani\r'),
(2240, 'Macedonia', 'Krusevo\r'),
(2241, 'Macedonia', 'Kuklis\r'),
(2242, 'Macedonia', 'Kukurecani\r'),
(2243, 'Macedonia', 'Kumanovo\r'),
(2244, 'Macedonia', 'Labunista\r'),
(2245, 'Macedonia', 'Lipkovo\r'),
(2246, 'Macedonia', 'Lozovo\r'),
(2247, 'Macedonia', 'Lukovo\r'),
(2248, 'Macedonia', 'Makedonska Kamenica\r'),
(2249, 'Macedonia', 'Makedonski Brod\r'),
(2250, 'Macedonia', 'Mavrovi Anovi\r'),
(2251, 'Macedonia', 'Meseista\r'),
(2252, 'Macedonia', 'Miravci\r'),
(2253, 'Macedonia', 'Mogila\r'),
(2254, 'Macedonia', 'Murtino\r'),
(2255, 'Macedonia', 'Negotino\r'),
(2256, 'Macedonia', 'Negotino-Poloska\r'),
(2257, 'Macedonia', 'Novaci\r'),
(2258, 'Macedonia', 'Novo Selo\r'),
(2259, 'Macedonia', 'Oblesevo\r'),
(2260, 'Macedonia', 'Ohrid\r'),
(2261, 'Macedonia', 'Orasac\r'),
(2262, 'Macedonia', 'Orizari\r'),
(2263, 'Macedonia', 'Oslomej\r'),
(2264, 'Macedonia', 'Pehcevo\r'),
(2265, 'Macedonia', 'Petrovec\r'),
(2266, 'Macedonia', 'Plasnia\r'),
(2267, 'Macedonia', 'Podares\r'),
(2268, 'Macedonia', 'Prilep\r'),
(2269, 'Macedonia', 'Probistip\r'),
(2270, 'Macedonia', 'Radovis\r'),
(2271, 'Macedonia', 'Rankovce\r'),
(2272, 'Macedonia', 'Resen\r'),
(2273, 'Macedonia', 'Rosoman\r'),
(2274, 'Macedonia', 'Rostusa\r'),
(2275, 'Macedonia', 'Samokov\r'),
(2276, 'Macedonia', 'Saraj\r'),
(2277, 'Macedonia', 'Sipkovica\r'),
(2278, 'Macedonia', 'Sopiste\r'),
(2279, 'Macedonia', 'Sopotnika\r'),
(2280, 'Macedonia', 'Srbinovo\r'),
(2281, 'Macedonia', 'Star Dojran\r'),
(2282, 'Macedonia', 'Staravina\r'),
(2283, 'Macedonia', 'Staro Nagoricane\r'),
(2284, 'Macedonia', 'Stip\r'),
(2285, 'Macedonia', 'Struga\r'),
(2286, 'Macedonia', 'Strumica\r'),
(2287, 'Macedonia', 'Studenicani\r'),
(2288, 'Macedonia', 'Suto Orizari (Skopje)\r'),
(2289, 'Macedonia', 'Sveti Nikole\r'),
(2290, 'Macedonia', 'Tearce\r'),
(2291, 'Macedonia', 'Tetovo\r'),
(2292, 'Macedonia', 'Topolcani\r'),
(2293, 'Macedonia', 'Valandovo\r'),
(2294, 'Macedonia', 'Vasilevo\r'),
(2295, 'Macedonia', 'Veles\r'),
(2296, 'Macedonia', 'Velesta\r'),
(2297, 'Macedonia', 'Vevcani\r'),
(2298, 'Macedonia', 'Vinica\r'),
(2299, 'Macedonia', 'Vitoliste\r'),
(2300, 'Macedonia', 'Vranestica\r'),
(2301, 'Macedonia', 'Vrapciste\r'),
(2302, 'Macedonia', 'Vratnica\r'),
(2303, 'Macedonia', 'Vrutok\r'),
(2304, 'Macedonia', 'Zajas\r'),
(2305, 'Macedonia', 'Zelenikovo\r'),
(2306, 'Macedonia', 'Zileno\r'),
(2307, 'Macedonia', 'Zitose\r'),
(2308, 'Macedonia', 'Zletovo\r'),
(2309, 'Macedonia', 'Zrnovci\r'),
(2310, 'Madagascar', 'Antananarivo\r'),
(2311, 'Madagascar', 'Antsiranana\r'),
(2312, 'Madagascar', 'Fianarantsoa\r'),
(2313, 'Madagascar', 'Mahajanga\r'),
(2314, 'Madagascar', 'Toamasina\r'),
(2315, 'Madagascar', 'Toliara\r'),
(2316, 'Malawi', 'Balaka\r'),
(2317, 'Malawi', 'Blantyre\r'),
(2318, 'Malawi', 'Chikwawa\r'),
(2319, 'Malawi', 'Chiradzulu\r'),
(2320, 'Malawi', 'Chitipa\r'),
(2321, 'Malawi', 'Dedza\r'),
(2322, 'Malawi', 'Dowa\r'),
(2323, 'Malawi', 'Karonga\r'),
(2324, 'Malawi', 'Kasungu\r'),
(2325, 'Malawi', 'Likoma\r'),
(2326, 'Malawi', 'Lilongwe\r'),
(2327, 'Malawi', 'Machinga (Kasupe)\r'),
(2328, 'Malawi', 'Mangochi\r'),
(2329, 'Malawi', 'Mchinji\r'),
(2330, 'Malawi', 'Mulanje\r'),
(2331, 'Malawi', 'Mwanza\r'),
(2332, 'Malawi', 'Mzimba\r'),
(2333, 'Malawi', 'Nkhata Bay\r'),
(2334, 'Malawi', 'Nkhotakota\r'),
(2335, 'Malawi', 'Nsanje\r'),
(2336, 'Malawi', 'Ntcheu\r'),
(2337, 'Malawi', 'Ntchisi\r'),
(2338, 'Malawi', 'Phalombe\r'),
(2339, 'Malawi', 'Rumphi\r'),
(2340, 'Malawi', 'Salima\r'),
(2341, 'Malawi', 'Thyolo\r'),
(2342, 'Malawi', 'Zomba\r'),
(2343, 'Malaysia', 'Johor'),
(2344, 'Malaysia', 'Kedah'),
(2345, 'Malaysia', 'Kelantan'),
(2346, 'Malaysia', 'Labuan'),
(2347, 'Malaysia', 'Melaka'),
(2348, 'Malaysia', 'Negeri Sembilan'),
(2349, 'Malaysia', 'Pahang'),
(2350, 'Malaysia', 'Perak'),
(2351, 'Malaysia', 'Perlis'),
(2353, 'Malaysia', 'Sabah'),
(2354, 'Malaysia', 'Sarawak'),
(2355, 'Malaysia', 'Selangor'),
(2356, 'Malaysia', 'Terengganu'),
(2358, 'Maldives', 'Alifu\r'),
(2359, 'Maldives', 'Baa\r'),
(2360, 'Maldives', 'Dhaalu\r'),
(2361, 'Maldives', 'Faafu\r'),
(2362, 'Maldives', 'Gaafu Alifu\r'),
(2363, 'Maldives', 'Gaafu Dhaalu\r'),
(2364, 'Maldives', 'Gnaviyani\r'),
(2365, 'Maldives', 'Haa Alifu\r'),
(2366, 'Maldives', 'Haa Dhaalu\r'),
(2367, 'Maldives', 'Kaafu\r'),
(2368, 'Maldives', 'Laamu\r'),
(2369, 'Maldives', 'Lhaviyani\r'),
(2370, 'Maldives', 'Maale\r'),
(2371, 'Maldives', 'Meemu\r'),
(2372, 'Maldives', 'Noonu\r'),
(2373, 'Maldives', 'Raa\r'),
(2374, 'Maldives', 'Seenu\r'),
(2375, 'Maldives', 'Shaviyani\r'),
(2376, 'Maldives', 'Thaa\r'),
(2377, 'Maldives', 'Vaavu\r'),
(2378, 'Mali', 'Gao\r'),
(2379, 'Mali', 'Kayes\r'),
(2380, 'Mali', 'Kidal\r'),
(2381, 'Mali', 'Koulikoro\r'),
(2382, 'Mali', 'Mopti\r'),
(2383, 'Mali', 'Segou\r'),
(2384, 'Mali', 'Sikasso\r'),
(2385, 'Mali', 'Tombouctou\r'),
(2386, 'Malta', 'Valletta\r'),
(2387, 'Marshall Islands', 'Ailinginae\r'),
(2388, 'Marshall Islands', 'Ailinglaplap\r'),
(2389, 'Marshall Islands', 'Ailuk\r'),
(2390, 'Marshall Islands', 'Arno\r'),
(2391, 'Marshall Islands', 'Aur\r'),
(2392, 'Marshall Islands', 'Bikar\r'),
(2393, 'Marshall Islands', 'Bikini\r'),
(2394, 'Marshall Islands', 'Bokak\r'),
(2395, 'Marshall Islands', 'Ebon\r'),
(2396, 'Marshall Islands', 'Enewetak\r'),
(2397, 'Marshall Islands', 'Erikub\r'),
(2398, 'Marshall Islands', 'Jabat\r'),
(2399, 'Marshall Islands', 'Jaluit\r'),
(2400, 'Marshall Islands', 'Jemo\r'),
(2401, 'Marshall Islands', 'Kili\r'),
(2402, 'Marshall Islands', 'Kwajalein\r'),
(2403, 'Marshall Islands', 'Lae\r'),
(2404, 'Marshall Islands', 'Lib\r'),
(2405, 'Marshall Islands', 'Likiep\r'),
(2406, 'Marshall Islands', 'Majuro\r'),
(2407, 'Marshall Islands', 'Maloelap\r'),
(2408, 'Marshall Islands', 'Mejit\r'),
(2409, 'Marshall Islands', 'Mili\r'),
(2410, 'Marshall Islands', 'Namorik\r'),
(2411, 'Marshall Islands', 'Namu\r'),
(2412, 'Marshall Islands', 'Rongelap\r'),
(2413, 'Marshall Islands', 'Rongrik\r'),
(2414, 'Marshall Islands', 'Toke\r'),
(2415, 'Marshall Islands', 'Ujae\r'),
(2416, 'Marshall Islands', 'Ujelang\r'),
(2417, 'Marshall Islands', 'Utirik\r'),
(2418, 'Marshall Islands', 'Wotho\r'),
(2419, 'Marshall Islands', 'Wotje\r'),
(2420, 'Martinique', 'Martinique\r'),
(2421, 'Mauritania', 'Adrar\r'),
(2422, 'Mauritania', 'Assaba\r'),
(2423, 'Mauritania', 'Brakna\r'),
(2424, 'Mauritania', 'Dakhlet Nouadhibou\r'),
(2425, 'Mauritania', 'Gorgol\r'),
(2426, 'Mauritania', 'Guidimaka\r'),
(2427, 'Mauritania', 'Hodh Ech Chargui\r'),
(2428, 'Mauritania', 'Hodh El Gharbi\r'),
(2429, 'Mauritania', 'Inchiri\r'),
(2430, 'Mauritania', 'Nouakchott\r'),
(2431, 'Mauritania', 'Tagant\r'),
(2432, 'Mauritania', 'Tiris Zemmour\r'),
(2433, 'Mauritania', 'Trarza\r'),
(2434, 'Mauritius', 'Agalega Islands\r'),
(2435, 'Mauritius', 'Black River\r'),
(2436, 'Mauritius', 'Cargados Carajos Shoals\r'),
(2437, 'Mauritius', 'Flacq\r'),
(2438, 'Mauritius', 'Grand Port\r'),
(2439, 'Mauritius', 'Moka\r'),
(2440, 'Mauritius', 'Pamplemousses\r'),
(2441, 'Mauritius', 'Plaines Wilhems\r'),
(2442, 'Mauritius', 'Port Louis\r'),
(2443, 'Mauritius', 'Riviere du Rempart\r'),
(2444, 'Mauritius', 'Rodrigues\r'),
(2445, 'Mauritius', 'Savanne\r'),
(2446, 'Mayotte', 'Mayotte\r'),
(2447, 'Mexico', 'Aguascalientes\r'),
(2448, 'Mexico', 'Baja California\r'),
(2449, 'Mexico', 'Baja California Sur\r'),
(2450, 'Mexico', 'Campeche\r'),
(2451, 'Mexico', 'Chiapas\r'),
(2452, 'Mexico', 'Chihuahua\r'),
(2453, 'Mexico', 'Coahuila de Zaragoza\r'),
(2454, 'Mexico', 'Colima\r'),
(2455, 'Mexico', 'Distrito Federal\r'),
(2456, 'Mexico', 'Durango\r'),
(2457, 'Mexico', 'Guanajuato\r'),
(2458, 'Mexico', 'Guerrero\r'),
(2459, 'Mexico', 'Hidalgo\r'),
(2460, 'Mexico', 'Jalisco\r'),
(2461, 'Mexico', 'Mexico\r'),
(2462, 'Mexico', 'Michoacan de Ocampo\r'),
(2463, 'Mexico', 'Morelos\r'),
(2464, 'Mexico', 'Nayarit\r'),
(2465, 'Mexico', 'Nuevo Leon\r'),
(2466, 'Mexico', 'Oaxaca\r'),
(2467, 'Mexico', 'Puebla\r'),
(2468, 'Mexico', 'Queretaro de Arteaga\r'),
(2469, 'Mexico', 'Quintana Roo\r'),
(2470, 'Mexico', 'San Luis Potosi\r'),
(2471, 'Mexico', 'Sinaloa\r'),
(2472, 'Mexico', 'Sonora\r'),
(2473, 'Mexico', 'Tabasco\r'),
(2474, 'Mexico', 'Tamaulipas\r'),
(2475, 'Mexico', 'Tlaxcala\r'),
(2476, 'Mexico', 'Veracruz-Llave\r'),
(2477, 'Mexico', 'Yucatan\r'),
(2478, 'Mexico', 'Zacatecas\r'),
(2479, 'Micronesia', 'Chuuk (Truk)\r'),
(2480, 'Micronesia', 'Kosrae\r'),
(2481, 'Micronesia', 'Pohnpei\r'),
(2482, 'Micronesia', 'Yap\r'),
(2483, 'Midway Islands', 'Midway Islands\r'),
(2484, 'Moldova', 'Balti\r'),
(2485, 'Moldova', 'Cahul\r'),
(2486, 'Moldova', 'Chisinau\r'),
(2487, 'Moldova', 'Chisinau\r'),
(2488, 'Moldova', 'Dubasari\r'),
(2489, 'Moldova', 'Edinet\r'),
(2490, 'Moldova', 'Gagauzia\r'),
(2491, 'Moldova', 'Lapusna\r'),
(2492, 'Moldova', 'Orhei\r'),
(2493, 'Moldova', 'Soroca\r'),
(2494, 'Moldova', 'Tighina\r'),
(2495, 'Moldova', 'Ungheni\r'),
(2496, 'Monaco', 'Fontvieille\r'),
(2497, 'Monaco', 'La Condamine\r'),
(2498, 'Monaco', 'Monaco-Ville\r'),
(2499, 'Monaco', 'Monte-Carlo\r'),
(2500, 'Mongolia', 'Arhangay\r'),
(2501, 'Mongolia', 'Bayan-Olgiy\r'),
(2502, 'Mongolia', 'Bayanhongor\r'),
(2503, 'Mongolia', 'Bulgan\r'),
(2504, 'Mongolia', 'Darhan\r'),
(2505, 'Mongolia', 'Dornod\r'),
(2506, 'Mongolia', 'Dornogovi\r'),
(2507, 'Mongolia', 'Dundgovi\r'),
(2508, 'Mongolia', 'Dzavhan\r'),
(2509, 'Mongolia', 'Erdenet\r'),
(2510, 'Mongolia', 'Govi-Altay\r'),
(2511, 'Mongolia', 'Hentiy\r'),
(2512, 'Mongolia', 'Hovd\r'),
(2513, 'Mongolia', 'Hovsgol\r'),
(2514, 'Mongolia', 'Omnogovi\r'),
(2515, 'Mongolia', 'Ovorhangay\r'),
(2516, 'Mongolia', 'Selenge\r'),
(2517, 'Mongolia', 'Suhbaatar\r'),
(2518, 'Mongolia', 'Tov\r'),
(2519, 'Mongolia', 'Ulaanbaatar\r'),
(2520, 'Mongolia', 'Uvs\r'),
(2521, 'Montserrat', 'Saint Anthony\r'),
(2522, 'Montserrat', 'Saint Georges\r'),
(2523, 'Montserrat', 'Saint Peters\r'),
(2524, 'Morocco', 'Agadir\r'),
(2525, 'Morocco', 'Al Hoceima\r'),
(2526, 'Morocco', 'Azilal\r'),
(2527, 'Morocco', 'Ben Slimane\r'),
(2528, 'Morocco', 'Beni Mellal\r'),
(2529, 'Morocco', 'Boulemane\r'),
(2530, 'Morocco', 'Casablanca\r'),
(2531, 'Morocco', 'Chaouen\r'),
(2532, 'Morocco', 'El Jadida\r'),
(2533, 'Morocco', 'El Kelaa des Srarhna\r'),
(2534, 'Morocco', 'Er Rachidia\r'),
(2535, 'Morocco', 'Essaouira\r'),
(2536, 'Morocco', 'Fes\r'),
(2537, 'Morocco', 'Figuig\r'),
(2538, 'Morocco', 'Guelmim\r'),
(2539, 'Morocco', 'Ifrane\r'),
(2540, 'Morocco', 'Kenitra\r'),
(2541, 'Morocco', 'Khemisset\r'),
(2542, 'Morocco', 'Khenifra\r'),
(2543, 'Morocco', 'Khouribga\r'),
(2544, 'Morocco', 'Laayoune\r'),
(2545, 'Morocco', 'Larache\r'),
(2546, 'Morocco', 'Marrakech\r'),
(2547, 'Morocco', 'Meknes\r'),
(2548, 'Morocco', 'Nador\r'),
(2549, 'Morocco', 'Ouarzazate\r'),
(2550, 'Morocco', 'Oujda\r'),
(2551, 'Morocco', 'Rabat-Sale\r'),
(2552, 'Morocco', 'Safi\r'),
(2553, 'Morocco', 'Settat\r'),
(2554, 'Morocco', 'Sidi Kacem\r'),
(2555, 'Morocco', 'Tan-Tan\r'),
(2556, 'Morocco', 'Tanger\r'),
(2557, 'Morocco', 'Taounate\r'),
(2558, 'Morocco', 'Taroudannt\r'),
(2559, 'Morocco', 'Tata\r'),
(2560, 'Morocco', 'Taza\r'),
(2561, 'Morocco', 'Tetouan\r'),
(2562, 'Morocco', 'Tiznit\r'),
(2563, 'Mozambique', 'Cabo Delgado\r'),
(2564, 'Mozambique', 'Gaza\r'),
(2565, 'Mozambique', 'Inhambane\r'),
(2566, 'Mozambique', 'Manica\r'),
(2567, 'Mozambique', 'Maputo\r'),
(2568, 'Mozambique', 'Nampula\r'),
(2569, 'Mozambique', 'Niassa\r'),
(2570, 'Mozambique', 'Sofala\r'),
(2571, 'Mozambique', 'Tete\r'),
(2572, 'Mozambique', 'Zambezia\r'),
(2573, 'Namibia', 'Caprivi\r'),
(2574, 'Namibia', 'Erongo\r'),
(2575, 'Namibia', 'Hardap\r'),
(2576, 'Namibia', 'Karas\r'),
(2577, 'Namibia', 'Khomas\r'),
(2578, 'Namibia', 'Kunene\r'),
(2579, 'Namibia', 'Ohangwena\r'),
(2580, 'Namibia', 'Okavango\r'),
(2581, 'Namibia', 'Omaheke\r'),
(2582, 'Namibia', 'Omusati\r'),
(2583, 'Namibia', 'Oshana\r'),
(2584, 'Namibia', 'Oshikoto\r'),
(2585, 'Namibia', 'Otjozondjupa\r'),
(2586, 'Nauru', 'Aiwo\r'),
(2587, 'Nauru', 'Anabar\r'),
(2588, 'Nauru', 'Anetan\r'),
(2589, 'Nauru', 'Anibare\r'),
(2590, 'Nauru', 'Baiti\r'),
(2591, 'Nauru', 'Boe\r'),
(2592, 'Nauru', 'Buada\r'),
(2593, 'Nauru', 'Denigomodu\r'),
(2594, 'Nauru', 'Ewa\r'),
(2595, 'Nauru', 'Ijuw\r'),
(2596, 'Nauru', 'Meneng\r'),
(2597, 'Nauru', 'Nibok\r'),
(2598, 'Nauru', 'Uaboe\r'),
(2599, 'Nauru', 'Yaren\r'),
(2600, 'Nepal', 'Bagmati\r'),
(2601, 'Nepal', 'Bheri\r'),
(2602, 'Nepal', 'Dhawalagiri\r'),
(2603, 'Nepal', 'Gandaki\r'),
(2604, 'Nepal', 'Janakpur\r'),
(2605, 'Nepal', 'Karnali\r'),
(2606, 'Nepal', 'Kosi\r'),
(2607, 'Nepal', 'Lumbini\r'),
(2608, 'Nepal', 'Mahakali\r'),
(2609, 'Nepal', 'Mechi\r'),
(2610, 'Nepal', 'Narayani\r'),
(2611, 'Nepal', 'Rapti\r'),
(2612, 'Nepal', 'Sagarmatha\r'),
(2613, 'Nepal', 'Seti\r'),
(2614, 'Netherlands', 'Drenthe\r'),
(2615, 'Netherlands', 'Flevoland\r'),
(2616, 'Netherlands', 'Friesland\r'),
(2617, 'Netherlands', 'Gelderland\r'),
(2618, 'Netherlands', 'Groningen\r'),
(2619, 'Netherlands', 'Limburg\r'),
(2620, 'Netherlands', 'Noord-Brabant\r'),
(2621, 'Netherlands', 'Noord-Holland\r'),
(2622, 'Netherlands', 'Overijssel\r'),
(2623, 'Netherlands', 'Utrecht\r'),
(2624, 'Netherlands', 'Zeeland\r'),
(2625, 'Netherlands', 'Zuid-Holland\r'),
(2626, 'Netherlands Antilles', 'Netherlands Antilles\r'),
(2627, 'New Caledonia', 'Iles Loyaute\r'),
(2628, 'New Caledonia', 'Nord\r'),
(2629, 'New Caledonia', 'Sud\r'),
(2630, 'New Zealand', 'Akaroa\r'),
(2631, 'New Zealand', 'Amuri\r'),
(2632, 'New Zealand', 'Ashburton\r'),
(2633, 'New Zealand', 'Bay of Islands\r'),
(2634, 'New Zealand', 'Bruce\r'),
(2635, 'New Zealand', 'Buller\r'),
(2636, 'New Zealand', 'Chatham Islands\r'),
(2637, 'New Zealand', 'Cheviot\r'),
(2638, 'New Zealand', 'Clifton\r'),
(2639, 'New Zealand', 'Clutha\r'),
(2640, 'New Zealand', 'Cook\r'),
(2641, 'New Zealand', 'Dannevirke\r'),
(2642, 'New Zealand', 'Egmont\r'),
(2643, 'New Zealand', 'Eketahuna\r'),
(2644, 'New Zealand', 'Ellesmere\r'),
(2645, 'New Zealand', 'Eltham\r'),
(2646, 'New Zealand', 'Eyre\r'),
(2647, 'New Zealand', 'Featherston\r'),
(2648, 'New Zealand', 'Franklin\r'),
(2649, 'New Zealand', 'Golden Bay\r'),
(2650, 'New Zealand', 'Great Barrier Island\r'),
(2651, 'New Zealand', 'Grey\r'),
(2652, 'New Zealand', 'Hauraki Plains\r'),
(2653, 'New Zealand', 'Hawera\r'),
(2654, 'New Zealand', 'Hawkes Bay\r'),
(2655, 'New Zealand', 'Heathcote\r'),
(2656, 'New Zealand', 'Hikurangi\r'),
(2657, 'New Zealand', 'Hobson\r'),
(2658, 'New Zealand', 'Hokianga\r'),
(2659, 'New Zealand', 'Horowhenua\r'),
(2660, 'New Zealand', 'Hurunui\r'),
(2661, 'New Zealand', 'Hutt\r'),
(2662, 'New Zealand', 'Inangahua\r'),
(2663, 'New Zealand', 'Inglewood\r'),
(2664, 'New Zealand', 'Kaikoura\r'),
(2665, 'New Zealand', 'Kairanga\r'),
(2666, 'New Zealand', 'Kiwitea\r'),
(2667, 'New Zealand', 'Lake\r'),
(2668, 'New Zealand', 'Mackenzie\r'),
(2669, 'New Zealand', 'Malvern\r'),
(2670, 'New Zealand', 'Manaia\r'),
(2671, 'New Zealand', 'Manawatu\r'),
(2672, 'New Zealand', 'Mangonui\r'),
(2673, 'New Zealand', 'Maniototo\r'),
(2674, 'New Zealand', 'Marlborough\r'),
(2675, 'New Zealand', 'Masterton\r'),
(2676, 'New Zealand', 'Matamata\r'),
(2677, 'New Zealand', 'Mount Herbert\r'),
(2678, 'New Zealand', 'Ohinemuri\r'),
(2679, 'New Zealand', 'Opotiki\r'),
(2680, 'New Zealand', 'Oroua\r'),
(2681, 'New Zealand', 'Otamatea\r'),
(2682, 'New Zealand', 'Otorohanga\r'),
(2683, 'New Zealand', 'Oxford\r'),
(2684, 'New Zealand', 'Pahiatua\r'),
(2685, 'New Zealand', 'Paparua\r'),
(2686, 'New Zealand', 'Patea\r'),
(2687, 'New Zealand', 'Piako\r'),
(2688, 'New Zealand', 'Pohangina\r'),
(2689, 'New Zealand', 'Raglan\r'),
(2690, 'New Zealand', 'Rangiora\r'),
(2691, 'New Zealand', 'Rangitikei\r'),
(2692, 'New Zealand', 'Rodney\r'),
(2693, 'New Zealand', 'Rotorua\r'),
(2694, 'New Zealand', 'Runanga\r'),
(2695, 'New Zealand', 'Saint Kilda\r'),
(2696, 'New Zealand', 'Silverpeaks\r'),
(2697, 'New Zealand', 'Southland\r'),
(2698, 'New Zealand', 'Stewart Island\r'),
(2699, 'New Zealand', 'Stratford\r'),
(2700, 'New Zealand', 'Strathallan\r'),
(2701, 'New Zealand', 'Taranaki\r'),
(2702, 'New Zealand', 'Taumarunui\r'),
(2703, 'New Zealand', 'Taupo\r'),
(2704, 'New Zealand', 'Tauranga\r'),
(2705, 'New Zealand', 'Thames-Coromandel\r'),
(2706, 'New Zealand', 'Tuapeka\r'),
(2707, 'New Zealand', 'Vincent\r'),
(2708, 'New Zealand', 'Waiapu\r'),
(2709, 'New Zealand', 'Waiheke\r'),
(2710, 'New Zealand', 'Waihemo\r'),
(2711, 'New Zealand', 'Waikato\r'),
(2712, 'New Zealand', 'Waikohu\r'),
(2713, 'New Zealand', 'Waimairi\r'),
(2714, 'New Zealand', 'Waimarino\r'),
(2715, 'New Zealand', 'Waimate\r'),
(2716, 'New Zealand', 'Waimate West\r'),
(2717, 'New Zealand', 'Waimea\r'),
(2718, 'New Zealand', 'Waipa\r'),
(2719, 'New Zealand', 'Waipawa\r'),
(2720, 'New Zealand', 'Waipukurau\r'),
(2721, 'New Zealand', 'Wairarapa South\r'),
(2722, 'New Zealand', 'Wairewa\r'),
(2723, 'New Zealand', 'Wairoa\r'),
(2724, 'New Zealand', 'Waitaki\r'),
(2725, 'New Zealand', 'Waitomo\r'),
(2726, 'New Zealand', 'Waitotara\r'),
(2727, 'New Zealand', 'Wallace\r'),
(2728, 'New Zealand', 'Wanganui\r'),
(2729, 'New Zealand', 'Waverley\r'),
(2730, 'New Zealand', 'Westland\r'),
(2731, 'New Zealand', 'Whakatane\r'),
(2732, 'New Zealand', 'Whangarei\r'),
(2733, 'New Zealand', 'Whangaroa\r'),
(2734, 'New Zealand', 'Woodville\r'),
(2735, 'Nicaragua', 'Atlantico Norte\r'),
(2736, 'Nicaragua', 'Atlantico Sur\r'),
(2737, 'Nicaragua', 'Boaco\r'),
(2738, 'Nicaragua', 'Carazo\r'),
(2739, 'Nicaragua', 'Chinandega\r'),
(2740, 'Nicaragua', 'Chontales\r'),
(2741, 'Nicaragua', 'Esteli\r'),
(2742, 'Nicaragua', 'Granada\r'),
(2743, 'Nicaragua', 'Jinotega\r'),
(2744, 'Nicaragua', 'Leon\r'),
(2745, 'Nicaragua', 'Madriz\r'),
(2746, 'Nicaragua', 'Managua\r'),
(2747, 'Nicaragua', 'Masaya\r'),
(2748, 'Nicaragua', 'Matagalpa\r'),
(2749, 'Nicaragua', 'Nueva Segovia\r'),
(2750, 'Nicaragua', 'Rio San Juan\r'),
(2751, 'Nicaragua', 'Rivas\r'),
(2752, 'Niger', 'Agadez\r'),
(2753, 'Niger', 'Diffa\r'),
(2754, 'Niger', 'Dosso\r'),
(2755, 'Niger', 'Maradi\r'),
(2756, 'Niger', 'Niamey\r'),
(2757, 'Niger', 'Tahoua\r'),
(2758, 'Niger', 'Tillaberi\r'),
(2759, 'Niger', 'Zinder\r'),
(2760, 'Nigeria', 'Abia\r'),
(2761, 'Nigeria', 'Abuja Federal Capital Territory\r'),
(2762, 'Nigeria', 'Adamawa\r'),
(2763, 'Nigeria', 'Akwa Ibom\r'),
(2764, 'Nigeria', 'Anambra\r'),
(2765, 'Nigeria', 'Bauchi\r'),
(2766, 'Nigeria', 'Bayelsa\r'),
(2767, 'Nigeria', 'Benue\r'),
(2768, 'Nigeria', 'Borno\r'),
(2769, 'Nigeria', 'Cross River\r'),
(2770, 'Nigeria', 'Delta\r'),
(2771, 'Nigeria', 'Ebonyi\r'),
(2772, 'Nigeria', 'Edo\r'),
(2773, 'Nigeria', 'Ekiti\r'),
(2774, 'Nigeria', 'Enugu\r'),
(2775, 'Nigeria', 'Gombe\r'),
(2776, 'Nigeria', 'Imo\r'),
(2777, 'Nigeria', 'Jigawa\r'),
(2778, 'Nigeria', 'Kaduna\r'),
(2779, 'Nigeria', 'Kano\r'),
(2780, 'Nigeria', 'Katsina\r'),
(2781, 'Nigeria', 'Kebbi\r'),
(2782, 'Nigeria', 'Kogi\r'),
(2783, 'Nigeria', 'Kwara\r'),
(2784, 'Nigeria', 'Lagos\r'),
(2785, 'Nigeria', 'Nassarawa\r'),
(2786, 'Nigeria', 'Niger\r'),
(2787, 'Nigeria', 'Ogun\r'),
(2788, 'Nigeria', 'Ondo\r'),
(2789, 'Nigeria', 'Osun\r'),
(2790, 'Nigeria', 'Oyo\r'),
(2791, 'Nigeria', 'Plateau\r'),
(2792, 'Nigeria', 'Rivers\r'),
(2793, 'Nigeria', 'Sokoto\r'),
(2794, 'Nigeria', 'Taraba\r'),
(2795, 'Nigeria', 'Yobe\r'),
(2796, 'Nigeria', 'Zamfara\r'),
(2797, 'Niue', 'Niue\r'),
(2798, 'Norfolk Island', 'Norfolk Island\r'),
(2799, 'Northern Mariana Islands', 'Northern Islands\r'),
(2800, 'Northern Mariana Islands', 'Rota\r'),
(2801, 'Northern Mariana Islands', 'Saipan\r'),
(2802, 'Northern Mariana Islands', 'Tinian\r'),
(2803, 'Norway', 'Akershus\r'),
(2804, 'Norway', 'Aust-Agder\r'),
(2805, 'Norway', 'Buskerud\r'),
(2806, 'Norway', 'Finnmark\r'),
(2807, 'Norway', 'Hedmark\r'),
(2808, 'Norway', 'Hordaland\r'),
(2809, 'Norway', 'More og Romsdal\r'),
(2810, 'Norway', 'Nord-Trondelag\r'),
(2811, 'Norway', 'Nordland\r'),
(2812, 'Norway', 'Oppland\r'),
(2813, 'Norway', 'Oslo\r'),
(2814, 'Norway', 'Ostfold\r'),
(2815, 'Norway', 'Rogaland\r'),
(2816, 'Norway', 'Sogn og Fjordane\r'),
(2817, 'Norway', 'Sor-Trondelag\r'),
(2818, 'Norway', 'Telemark\r'),
(2819, 'Norway', 'Troms\r'),
(2820, 'Norway', 'Vest-Agder\r'),
(2821, 'Norway', 'Vestfold\r'),
(2822, 'Oman', 'Ad Dakhiliyah\r'),
(2823, 'Oman', 'Al Batinah\r'),
(2824, 'Oman', 'Al Wusta\r'),
(2825, 'Oman', 'Ash Sharqiyah\r'),
(2826, 'Oman', 'Az Zahirah\r'),
(2827, 'Oman', 'Masqat\r'),
(2828, 'Oman', 'Musandam\r'),
(2829, 'Oman', 'Zufar\r'),
(2830, 'Pakistan', 'Balochistan\r'),
(2831, 'Pakistan', 'Federally Administered Tribal Areas\r'),
(2832, 'Pakistan', 'Islamabad Capital Territory\r'),
(2833, 'Pakistan', 'North-West Frontier Province\r'),
(2834, 'Pakistan', 'Punjab\r'),
(2835, 'Pakistan', 'Sindh\r'),
(2836, 'Palau', 'Aimeliik\r'),
(2837, 'Palau', 'Airai\r'),
(2838, 'Palau', 'Angaur\r'),
(2839, 'Palau', 'Hatobohei\r'),
(2840, 'Palau', 'Kayangel\r'),
(2841, 'Palau', 'Koror\r'),
(2842, 'Palau', 'Melekeok\r'),
(2843, 'Palau', 'Ngaraard\r'),
(2844, 'Palau', 'Ngarchelong\r'),
(2845, 'Palau', 'Ngardmau\r'),
(2846, 'Palau', 'Ngatpang\r'),
(2847, 'Palau', 'Ngchesar\r'),
(2848, 'Palau', 'Ngeremlengui\r'),
(2849, 'Palau', 'Ngiwal\r'),
(2850, 'Palau', 'Palau Island\r'),
(2851, 'Palau', 'Peleliu\r'),
(2852, 'Palau', 'Sonsoral\r'),
(2853, 'Palau', 'Tobi\r'),
(2854, 'Panama', 'Bocas del Toro\r'),
(2855, 'Panama', 'Chiriqui\r'),
(2856, 'Panama', 'Cocle\r'),
(2857, 'Panama', 'Colon\r'),
(2858, 'Panama', 'Darien\r'),
(2859, 'Panama', 'Herrera\r'),
(2860, 'Panama', 'Los Santos\r'),
(2861, 'Panama', 'Panama\r'),
(2862, 'Panama', 'San Blas\r'),
(2863, 'Panama', 'Veraguas\r'),
(2864, 'Papua New Guinea', 'Bougainville\r'),
(2865, 'Papua New Guinea', 'Central\r'),
(2866, 'Papua New Guinea', 'Chimbu\r'),
(2867, 'Papua New Guinea', 'East New Britain\r'),
(2868, 'Papua New Guinea', 'East Sepik\r'),
(2869, 'Papua New Guinea', 'Eastern Highlands\r'),
(2870, 'Papua New Guinea', 'Enga\r'),
(2871, 'Papua New Guinea', 'Gulf\r'),
(2872, 'Papua New Guinea', 'Madang\r'),
(2873, 'Papua New Guinea', 'Manus\r'),
(2874, 'Papua New Guinea', 'Milne Bay\r'),
(2875, 'Papua New Guinea', 'Morobe\r'),
(2876, 'Papua New Guinea', 'National Capital\r'),
(2877, 'Papua New Guinea', 'New Ireland\r'),
(2878, 'Papua New Guinea', 'Northern\r'),
(2879, 'Papua New Guinea', 'Sandaun\r'),
(2880, 'Papua New Guinea', 'Southern Highlands\r'),
(2881, 'Papua New Guinea', 'West New Britain\r'),
(2882, 'Papua New Guinea', 'Western\r'),
(2883, 'Papua New Guinea', 'Western Highlands\r'),
(2884, 'Paraguay', 'Alto Paraguay\r'),
(2885, 'Paraguay', 'Alto Parana\r'),
(2886, 'Paraguay', 'Amambay\r'),
(2887, 'Paraguay', 'Asuncion (city)\r'),
(2888, 'Paraguay', 'Boqueron\r'),
(2889, 'Paraguay', 'Caaguazu\r'),
(2890, 'Paraguay', 'Caazapa\r'),
(2891, 'Paraguay', 'Canindeyu\r'),
(2892, 'Paraguay', 'Central\r'),
(2893, 'Paraguay', 'Concepcion\r'),
(2894, 'Paraguay', 'Cordillera\r'),
(2895, 'Paraguay', 'Guaira\r'),
(2896, 'Paraguay', 'Itapua\r'),
(2897, 'Paraguay', 'Misiones\r'),
(2898, 'Paraguay', 'Neembucu\r'),
(2899, 'Paraguay', 'Paraguari\r'),
(2900, 'Paraguay', 'Presidente Hayes\r'),
(2901, 'Paraguay', 'San Pedro\r'),
(2902, 'Peru', 'Amazonas\r'),
(2903, 'Peru', 'Ancash\r'),
(2904, 'Peru', 'Apurimac\r'),
(2905, 'Peru', 'Arequipa\r'),
(2906, 'Peru', 'Ayacucho\r'),
(2907, 'Peru', 'Cajamarca\r'),
(2908, 'Peru', 'Callao\r'),
(2909, 'Peru', 'Cusco\r'),
(2910, 'Peru', 'Huancavelica\r'),
(2911, 'Peru', 'Huanuco\r'),
(2912, 'Peru', 'Ica\r'),
(2913, 'Peru', 'Junin\r'),
(2914, 'Peru', 'La Libertad\r'),
(2915, 'Peru', 'Lambayeque\r'),
(2916, 'Peru', 'Lima\r'),
(2917, 'Peru', 'Loreto\r'),
(2918, 'Peru', 'Madre de Dios\r'),
(2919, 'Peru', 'Moquegua\r'),
(2920, 'Peru', 'Pasco\r'),
(2921, 'Peru', 'Piura\r'),
(2922, 'Peru', 'Puno\r'),
(2923, 'Peru', 'San Martin\r'),
(2924, 'Peru', 'Tacna\r'),
(2925, 'Peru', 'Tumbes\r'),
(2926, 'Peru', 'Ucayali\r'),
(2927, 'Philippines', 'Abra\r'),
(2928, 'Philippines', 'Agusan del Norte\r'),
(2929, 'Philippines', 'Agusan del Sur\r'),
(2930, 'Philippines', 'Aklan\r'),
(2931, 'Philippines', 'Albay\r'),
(2932, 'Philippines', 'Angeles\r'),
(2933, 'Philippines', 'Antique\r'),
(2934, 'Philippines', 'Aurora\r'),
(2935, 'Philippines', 'Bacolod\r'),
(2936, 'Philippines', 'Bago\r'),
(2937, 'Philippines', 'Baguio\r'),
(2938, 'Philippines', 'Bais\r'),
(2939, 'Philippines', 'Basilan\r'),
(2940, 'Philippines', 'Basilan City\r'),
(2941, 'Philippines', 'Bataan\r'),
(2942, 'Philippines', 'Batanes\r'),
(2943, 'Philippines', 'Batangas\r'),
(2944, 'Philippines', 'Batangas City\r'),
(2945, 'Philippines', 'Benguet\r'),
(2946, 'Philippines', 'Bohol\r'),
(2947, 'Philippines', 'Bukidnon\r'),
(2948, 'Philippines', 'Bulacan\r'),
(2949, 'Philippines', 'Butuan\r'),
(2950, 'Philippines', 'Cabanatuan\r'),
(2951, 'Philippines', 'Cadiz\r'),
(2952, 'Philippines', 'Cagayan\r'),
(2953, 'Philippines', 'Cagayan de Oro\r'),
(2954, 'Philippines', 'Calbayog\r'),
(2955, 'Philippines', 'Caloocan\r'),
(2956, 'Philippines', 'Camarines Norte\r'),
(2957, 'Philippines', 'Camarines Sur\r'),
(2958, 'Philippines', 'Camiguin\r'),
(2959, 'Philippines', 'Canlaon\r'),
(2960, 'Philippines', 'Capiz\r'),
(2961, 'Philippines', 'Catanduanes\r'),
(2962, 'Philippines', 'Cavite\r'),
(2963, 'Philippines', 'Cavite City\r'),
(2964, 'Philippines', 'Cebu\r'),
(2965, 'Philippines', 'Cebu City\r'),
(2966, 'Philippines', 'Cotabato\r'),
(2967, 'Philippines', 'Dagupan\r'),
(2968, 'Philippines', 'Danao\r'),
(2969, 'Philippines', 'Dapitan\r'),
(2970, 'Philippines', 'Davao City Davao\r'),
(2971, 'Philippines', 'Davao del Sur\r'),
(2972, 'Philippines', 'Davao Oriental\r'),
(2973, 'Philippines', 'Dipolog\r'),
(2974, 'Philippines', 'Dumaguete\r'),
(2975, 'Philippines', 'Eastern Samar\r'),
(2976, 'Philippines', 'General Santos\r'),
(2977, 'Philippines', 'Gingoog\r'),
(2978, 'Philippines', 'Ifugao\r'),
(2979, 'Philippines', 'Iligan\r'),
(2980, 'Philippines', 'Ilocos Norte\r'),
(2981, 'Philippines', 'Ilocos Sur\r'),
(2982, 'Philippines', 'Iloilo\r'),
(2983, 'Philippines', 'Iloilo City\r'),
(2984, 'Philippines', 'Iriga\r'),
(2985, 'Philippines', 'Isabela\r'),
(2986, 'Philippines', 'Kalinga-Apayao\r'),
(2987, 'Philippines', 'La Carlota\r'),
(2988, 'Philippines', 'La Union\r'),
(2989, 'Philippines', 'Laguna\r'),
(2990, 'Philippines', 'Lanao del Norte\r'),
(2991, 'Philippines', 'Lanao del Sur\r'),
(2992, 'Philippines', 'Laoag\r'),
(2993, 'Philippines', 'Lapu-Lapu\r'),
(2994, 'Philippines', 'Legaspi\r'),
(2995, 'Philippines', 'Leyte\r'),
(2996, 'Philippines', 'Lipa\r'),
(2997, 'Philippines', 'Lucena\r'),
(2998, 'Philippines', 'Maguindanao\r'),
(2999, 'Philippines', 'Mandaue\r'),
(3000, 'Philippines', 'Manila\r'),
(3001, 'Philippines', 'Marawi\r'),
(3002, 'Philippines', 'Marinduque\r'),
(3003, 'Philippines', 'Masbate\r'),
(3004, 'Philippines', 'Mindoro Occidental\r'),
(3005, 'Philippines', 'Mindoro Oriental\r'),
(3006, 'Philippines', 'Misamis Occidental\r'),
(3007, 'Philippines', 'Misamis Oriental\r'),
(3008, 'Philippines', 'Mountain\r'),
(3009, 'Philippines', 'Naga\r'),
(3010, 'Philippines', 'Negros Occidental\r'),
(3011, 'Philippines', 'Negros Oriental\r'),
(3012, 'Philippines', 'North Cotabato\r');
INSERT INTO `states` (`id`, `country`, `state`) VALUES
(3013, 'Philippines', 'Northern Samar\r'),
(3014, 'Philippines', 'Nueva Ecija\r'),
(3015, 'Philippines', 'Nueva Vizcaya\r'),
(3016, 'Philippines', 'Olongapo\r'),
(3017, 'Philippines', 'Ormoc\r'),
(3018, 'Philippines', 'Oroquieta\r'),
(3019, 'Philippines', 'Ozamis\r'),
(3020, 'Philippines', 'Pagadian\r'),
(3021, 'Philippines', 'Palawan\r'),
(3022, 'Philippines', 'Palayan\r'),
(3023, 'Philippines', 'Pampanga\r'),
(3024, 'Philippines', 'Pangasinan\r'),
(3025, 'Philippines', 'Pasay\r'),
(3026, 'Philippines', 'Puerto Princesa\r'),
(3027, 'Philippines', 'Quezon\r'),
(3028, 'Philippines', 'Quezon City\r'),
(3029, 'Philippines', 'Quirino\r'),
(3030, 'Philippines', 'Rizal\r'),
(3031, 'Philippines', 'Romblon\r'),
(3032, 'Philippines', 'Roxas\r'),
(3033, 'Philippines', 'Samar\r'),
(3034, 'Philippines', 'San Carlos (in Negros Occidental)\r'),
(3035, 'Philippines', 'San Carlos (in Pangasinan)\r'),
(3036, 'Philippines', 'San Jose\r'),
(3037, 'Philippines', 'San Pablo\r'),
(3038, 'Philippines', 'Silay\r'),
(3039, 'Philippines', 'Siquijor\r'),
(3040, 'Philippines', 'Sorsogon\r'),
(3041, 'Philippines', 'South Cotabato\r'),
(3042, 'Philippines', 'Southern Leyte\r'),
(3043, 'Philippines', 'Sultan Kudarat\r'),
(3044, 'Philippines', 'Sulu\r'),
(3045, 'Philippines', 'Surigao\r'),
(3046, 'Philippines', 'Surigao del Norte\r'),
(3047, 'Philippines', 'Surigao del Sur\r'),
(3048, 'Philippines', 'Tacloban\r'),
(3049, 'Philippines', 'Tagaytay\r'),
(3050, 'Philippines', 'Tagbilaran\r'),
(3051, 'Philippines', 'Tangub\r'),
(3052, 'Philippines', 'Tarlac\r'),
(3053, 'Philippines', 'Tawitawi\r'),
(3054, 'Philippines', 'Toledo\r'),
(3055, 'Philippines', 'Trece Martires\r'),
(3056, 'Philippines', 'Zambales\r'),
(3057, 'Philippines', 'Zamboanga\r'),
(3058, 'Philippines', 'Zamboanga del Norte\r'),
(3059, 'Philippines', 'Zamboanga del Sur\r'),
(3060, 'Pitcaim Islands', 'Pitcaim Islands\r'),
(3061, 'Poland', 'Dolnoslaskie\r'),
(3062, 'Poland', 'Kujawsko-Pomorskie\r'),
(3063, 'Poland', 'Lodzkie\r'),
(3064, 'Poland', 'Lubelskie\r'),
(3065, 'Poland', 'Lubuskie\r'),
(3066, 'Poland', 'Malopolskie\r'),
(3067, 'Poland', 'Mazowieckie\r'),
(3068, 'Poland', 'Opolskie\r'),
(3069, 'Poland', 'Podkarpackie\r'),
(3070, 'Poland', 'Podlaskie\r'),
(3071, 'Poland', 'Pomorskie\r'),
(3072, 'Poland', 'Slaskie\r'),
(3073, 'Poland', 'Swietokrzyskie\r'),
(3074, 'Poland', 'Warminsko-Mazurskie\r'),
(3075, 'Poland', 'Wielkopolskie\r'),
(3076, 'Poland', 'Zachodniopomorskie\r'),
(3077, 'Portugal', 'Acores (Azores)\r'),
(3078, 'Portugal', 'Aveiro\r'),
(3079, 'Portugal', 'Beja\r'),
(3080, 'Portugal', 'Braga\r'),
(3081, 'Portugal', 'Braganca\r'),
(3082, 'Portugal', 'Castelo Branco\r'),
(3083, 'Portugal', 'Coimbra\r'),
(3084, 'Portugal', 'Evora\r'),
(3085, 'Portugal', 'Faro\r'),
(3086, 'Portugal', 'Guarda\r'),
(3087, 'Portugal', 'Leiria\r'),
(3088, 'Portugal', 'Lisboa\r'),
(3089, 'Portugal', 'Madeira\r'),
(3090, 'Portugal', 'Portalegre\r'),
(3091, 'Portugal', 'Porto\r'),
(3092, 'Portugal', 'Santarem\r'),
(3093, 'Portugal', 'Setubal\r'),
(3094, 'Portugal', 'Viana do Castelo\r'),
(3095, 'Portugal', 'Vila Real\r'),
(3096, 'Portugal', 'Viseu\r'),
(3097, 'Puerto Rico', 'Adjuntas\r'),
(3098, 'Puerto Rico', 'Aguada\r'),
(3099, 'Puerto Rico', 'Aguadilla\r'),
(3100, 'Puerto Rico', 'Aguas Buenas\r'),
(3101, 'Puerto Rico', 'Aibonito\r'),
(3102, 'Puerto Rico', 'Anasco\r'),
(3103, 'Puerto Rico', 'Arecibo\r'),
(3104, 'Puerto Rico', 'Arroyo\r'),
(3105, 'Puerto Rico', 'Barceloneta\r'),
(3106, 'Puerto Rico', 'Barranquitas\r'),
(3107, 'Puerto Rico', 'Bayamon\r'),
(3108, 'Puerto Rico', 'Cabo Rojo\r'),
(3109, 'Puerto Rico', 'Caguas\r'),
(3110, 'Puerto Rico', 'Camuy\r'),
(3111, 'Puerto Rico', 'Canovanas\r'),
(3112, 'Puerto Rico', 'Carolina\r'),
(3113, 'Puerto Rico', 'Catano\r'),
(3114, 'Puerto Rico', 'Cayey\r'),
(3115, 'Puerto Rico', 'Ceiba\r'),
(3116, 'Puerto Rico', 'Ciales\r'),
(3117, 'Puerto Rico', 'Cidra\r'),
(3118, 'Puerto Rico', 'Coamo\r'),
(3119, 'Puerto Rico', 'Comerio\r'),
(3120, 'Puerto Rico', 'Corozal\r'),
(3121, 'Puerto Rico', 'Culebra\r'),
(3122, 'Puerto Rico', 'Dorado\r'),
(3123, 'Puerto Rico', 'Fajardo\r'),
(3124, 'Puerto Rico', 'Florida\r'),
(3125, 'Puerto Rico', 'Guanica\r'),
(3126, 'Puerto Rico', 'Guayama\r'),
(3127, 'Puerto Rico', 'Guayanilla\r'),
(3128, 'Puerto Rico', 'Guaynabo\r'),
(3129, 'Puerto Rico', 'Gurabo\r'),
(3130, 'Puerto Rico', 'Hatillo\r'),
(3131, 'Puerto Rico', 'Hormigueros\r'),
(3132, 'Puerto Rico', 'Humacao\r'),
(3133, 'Puerto Rico', 'Isabela\r'),
(3134, 'Puerto Rico', 'Jayuya\r'),
(3135, 'Puerto Rico', 'Juana Diaz\r'),
(3136, 'Puerto Rico', 'Juncos\r'),
(3137, 'Puerto Rico', 'Lajas\r'),
(3138, 'Puerto Rico', 'Lares\r'),
(3139, 'Puerto Rico', 'Las Marias\r'),
(3140, 'Puerto Rico', 'Las Piedras\r'),
(3141, 'Puerto Rico', 'Loiza\r'),
(3142, 'Puerto Rico', 'Luquillo\r'),
(3143, 'Puerto Rico', 'Manati\r'),
(3144, 'Puerto Rico', 'Maricao\r'),
(3145, 'Puerto Rico', 'Maunabo\r'),
(3146, 'Puerto Rico', 'Mayaguez\r'),
(3147, 'Puerto Rico', 'Moca\r'),
(3148, 'Puerto Rico', 'Morovis\r'),
(3149, 'Puerto Rico', 'Naguabo\r'),
(3150, 'Puerto Rico', 'Naranjito\r'),
(3151, 'Puerto Rico', 'Orocovis\r'),
(3152, 'Puerto Rico', 'Patillas\r'),
(3153, 'Puerto Rico', 'Penuelas\r'),
(3154, 'Puerto Rico', 'Ponce\r'),
(3155, 'Puerto Rico', 'Quebradillas\r'),
(3156, 'Puerto Rico', 'Rincon\r'),
(3157, 'Puerto Rico', 'Rio Grande\r'),
(3158, 'Puerto Rico', 'Sabana Grande\r'),
(3159, 'Puerto Rico', 'Salinas\r'),
(3160, 'Puerto Rico', 'San German\r'),
(3161, 'Puerto Rico', 'San Juan\r'),
(3162, 'Puerto Rico', 'San Lorenzo\r'),
(3163, 'Puerto Rico', 'San Sebastian\r'),
(3164, 'Puerto Rico', 'Santa Isabel\r'),
(3165, 'Puerto Rico', 'Toa Alta\r'),
(3166, 'Puerto Rico', 'Toa Baja\r'),
(3167, 'Puerto Rico', 'Trujillo Alto\r'),
(3168, 'Puerto Rico', 'Utuado\r'),
(3169, 'Puerto Rico', 'Vega Alta\r'),
(3170, 'Puerto Rico', 'Vega Baja\r'),
(3171, 'Puerto Rico', 'Vieques\r'),
(3172, 'Puerto Rico', 'Villalba\r'),
(3173, 'Puerto Rico', 'Yabucoa\r'),
(3174, 'Puerto Rico', 'Yauco\r'),
(3175, 'Qatar', 'Ad Dawhah\r'),
(3176, 'Qatar', 'Al Ghuwayriyah\r'),
(3177, 'Qatar', 'Al Jumayliyah\r'),
(3178, 'Qatar', 'Al Khawr\r'),
(3179, 'Qatar', 'Al Wakrah\r'),
(3180, 'Qatar', 'Ar Rayyan\r'),
(3181, 'Qatar', 'Jarayan al Batinah\r'),
(3182, 'Qatar', 'Madinat ash Shamal\r'),
(3183, 'Qatar', 'Umm Salal\r'),
(3184, 'Reunion', 'Reunion\r'),
(3185, 'Romainia', 'Alba\r'),
(3186, 'Romainia', 'Arad\r'),
(3187, 'Romainia', 'Arges\r'),
(3188, 'Romainia', 'Bacau\r'),
(3189, 'Romainia', 'Bihor\r'),
(3190, 'Romainia', 'Bistrita-Nasaud\r'),
(3191, 'Romainia', 'Botosani\r'),
(3192, 'Romainia', 'Braila\r'),
(3193, 'Romainia', 'Brasov\r'),
(3194, 'Romainia', 'Bucuresti\r'),
(3195, 'Romainia', 'Buzau\r'),
(3196, 'Romainia', 'Calarasi\r'),
(3197, 'Romainia', 'Caras-Severin\r'),
(3198, 'Romainia', 'Cluj\r'),
(3199, 'Romainia', 'Constanta\r'),
(3200, 'Romainia', 'Covasna\r'),
(3201, 'Romainia', 'Dimbovita\r'),
(3202, 'Romainia', 'Dolj\r'),
(3203, 'Romainia', 'Galati\r'),
(3204, 'Romainia', 'Giurgiu\r'),
(3205, 'Romainia', 'Gorj\r'),
(3206, 'Romainia', 'Harghita\r'),
(3207, 'Romainia', 'Hunedoara\r'),
(3208, 'Romainia', 'Ialomita\r'),
(3209, 'Romainia', 'Iasi\r'),
(3210, 'Romainia', 'Maramures\r'),
(3211, 'Romainia', 'Mehedinti\r'),
(3212, 'Romainia', 'Mures\r'),
(3213, 'Romainia', 'Neamt\r'),
(3214, 'Romainia', 'Olt\r'),
(3215, 'Romainia', 'Prahova\r'),
(3216, 'Romainia', 'Salaj\r'),
(3217, 'Romainia', 'Satu Mare\r'),
(3218, 'Romainia', 'Sibiu\r'),
(3219, 'Romainia', 'Suceava\r'),
(3220, 'Romainia', 'Teleorman\r'),
(3221, 'Romainia', 'Timis\r'),
(3222, 'Romainia', 'Tulcea\r'),
(3223, 'Romainia', 'Vaslui\r'),
(3224, 'Romainia', 'Vilcea\r'),
(3225, 'Romainia', 'Vrancea\r'),
(3226, 'Russia', 'Adygeya (Maykop)\r'),
(3227, 'Russia', 'Aginskiy Buryatskiy (Aginskoye)\r'),
(3228, 'Russia', 'Altay (Gorno-Altaysk)\r'),
(3229, 'Russia', 'Altayskiy (Barnaul)\r'),
(3230, 'Russia', 'Amurskaya (Blagoveshchensk)\r'),
(3231, 'Russia', 'Arkhangelskaya\r'),
(3232, 'Russia', 'Astrakhanskaya\r'),
(3233, 'Russia', 'Bashkortostan (Ufa)\r'),
(3234, 'Russia', 'Belgorodskaya\r'),
(3235, 'Russia', 'Bryanskaya\r'),
(3236, 'Russia', 'Buryatiya (Ulan-Ude)\r'),
(3237, 'Russia', 'Chechnya (Groznyy)\r'),
(3238, 'Russia', 'Chelyabinskaya\r'),
(3239, 'Russia', 'Chitinskaya\r'),
(3240, 'Russia', 'Chukotskiy (Anadyr)\r'),
(3241, 'Russia', 'Chuvashiya (Cheboksary)\r'),
(3242, 'Russia', 'Dagestan (Makhachkala)\r'),
(3243, 'Russia', 'Evenkiyskiy (Tura)\r'),
(3244, 'Russia', 'Ingushetiya (Nazran)\r'),
(3245, 'Russia', 'Irkutskaya\r'),
(3246, 'Russia', 'Ivanovskaya\r'),
(3247, 'Russia', 'Kabardino-Balkariya (Nalchik)\r'),
(3248, 'Russia', 'Kaliningradskaya\r'),
(3249, 'Russia', 'Kalmykiya (Elista)\r'),
(3250, 'Russia', 'Kaluzhskaya\r'),
(3251, 'Russia', 'Kamchatskaya (Petropavlovsk-Kamchatskiy)\r'),
(3252, 'Russia', 'Karachayevo-Cherkesiya (Cherkessk)\r'),
(3253, 'Russia', 'Kareliya (Petrozavodsk)\r'),
(3254, 'Russia', 'Kemerovskaya\r'),
(3255, 'Russia', 'Khabarovskiy\r'),
(3256, 'Russia', 'Khakasiya (Abakan)\r'),
(3257, 'Russia', 'Khanty-Mansiyskiy (Khanty-Mansiysk)\r'),
(3258, 'Russia', 'Kirovskaya\r'),
(3259, 'Russia', 'Komi (Syktyvkar)\r'),
(3260, 'Russia', 'Komi-Permyatskiy (Kudymkar)\r'),
(3261, 'Russia', 'Koryakskiy (Palana)\r'),
(3262, 'Russia', 'Kostromskaya\r'),
(3263, 'Russia', 'Krasnodarskiy\r'),
(3264, 'Russia', 'Krasnoyarskiy\r'),
(3265, 'Russia', 'Kurganskaya\r'),
(3266, 'Russia', 'Kurskaya\r'),
(3267, 'Russia', 'Leningradskaya\r'),
(3268, 'Russia', 'Lipetskaya\r'),
(3269, 'Russia', 'Magadanskaya\r'),
(3270, 'Russia', 'Mariy-El (Yoshkar-Ola)\r'),
(3271, 'Russia', 'Mordoviya (Saransk)\r'),
(3272, 'Russia', 'Moskovskaya\r'),
(3273, 'Russia', 'Moskva (Moscow)\r'),
(3274, 'Russia', 'Murmanskaya\r'),
(3275, 'Russia', 'Nenetskiy (Naryan-Mar)\r'),
(3276, 'Russia', 'Nizhegorodskaya\r'),
(3277, 'Russia', 'Novgorodskaya\r'),
(3278, 'Russia', 'Novosibirskaya\r'),
(3279, 'Russia', 'Omskaya\r'),
(3280, 'Russia', 'Orenburgskaya\r'),
(3281, 'Russia', 'Orlovskaya (Orel)\r'),
(3282, 'Russia', 'Penzenskaya\r'),
(3283, 'Russia', 'Permskaya\r'),
(3284, 'Russia', 'Primorskiy (Vladivostok)\r'),
(3285, 'Russia', 'Pskovskaya\r'),
(3286, 'Russia', 'Rostovskaya\r'),
(3287, 'Russia', 'Ryazanskaya\r'),
(3288, 'Russia', 'Sakha (Yakutsk)\r'),
(3289, 'Russia', 'Sakhalinskaya (Yuzhno-Sakhalinsk)\r'),
(3290, 'Russia', 'Samarskaya\r'),
(3291, 'Russia', 'Sankt-Peterburg (Saint Petersburg)\r'),
(3292, 'Russia', 'Saratovskaya\r'),
(3293, 'Russia', ' Severnaya Osetiya-Alaniya [North Ossetia]\r'),
(3294, 'Russia', 'Smolenskaya\r'),
(3295, 'Russia', 'Stavropolskiy\r'),
(3296, 'Russia', 'Sverdlovskaya (Yekaterinburg)\r'),
(3297, 'Russia', 'Tambovskaya\r'),
(3298, 'Russia', 'Tatarstan (Kazan)\r'),
(3299, 'Russia', 'Taymyrskiy (Dudinka)\r'),
(3300, 'Russia', 'Tomskaya\r'),
(3301, 'Russia', 'Tulskaya\r'),
(3302, 'Russia', 'Tverskaya\r'),
(3303, 'Russia', 'Tyumenskaya\r'),
(3304, 'Russia', 'Tyva (Kyzyl)\r'),
(3305, 'Russia', 'Udmurtiya (Izhevsk)\r'),
(3306, 'Russia', 'Ulyanovskaya\r'),
(3307, 'Russia', 'Ust-Ordynskiy Buryatskiy (Ust-Ordynskiy)\r'),
(3308, 'Russia', 'Vladimirskaya\r'),
(3309, 'Russia', 'Volgogradskaya\r'),
(3310, 'Russia', 'Vologodskaya\r'),
(3311, 'Russia', 'Voronezhskaya\r'),
(3312, 'Russia', 'Yamalo-Nenetskiy (Salekhard)\r'),
(3313, 'Russia', 'Yaroslavskaya\r'),
(3314, 'Russia', 'Yevreyskaya\r'),
(3315, 'Rwanda', 'Butare\r'),
(3316, 'Rwanda', 'Byumba\r'),
(3317, 'Rwanda', 'Cyangugu\r'),
(3318, 'Rwanda', 'Gikongoro\r'),
(3319, 'Rwanda', 'Gisenyi\r'),
(3320, 'Rwanda', 'Gitarama\r'),
(3321, 'Rwanda', 'Kibungo\r'),
(3322, 'Rwanda', 'Kibuye\r'),
(3323, 'Rwanda', 'Kigali Rurale\r'),
(3324, 'Rwanda', 'Kigali-ville\r'),
(3325, 'Rwanda', 'Ruhengeri\r'),
(3326, 'Rwanda', 'Umutara\r'),
(3327, 'Saint Helena', 'Ascension\r'),
(3328, 'Saint Helena', 'Saint Helena\r'),
(3329, 'Saint Helena', 'Tristan da Cunha\r'),
(3330, 'Saint Kitts and Nevis', 'Christ Church Nichola Town\r'),
(3331, 'Saint Kitts and Nevis', 'Saint Anne Sandy Point\r'),
(3332, 'Saint Kitts and Nevis', 'Saint George Basseterre\r'),
(3333, 'Saint Kitts and Nevis', 'Saint George Gingerland\r'),
(3334, 'Saint Kitts and Nevis', 'Saint James Windward\r'),
(3335, 'Saint Kitts and Nevis', 'Saint John Capisterre\r'),
(3336, 'Saint Kitts and Nevis', 'Saint John Figtree\r'),
(3337, 'Saint Kitts and Nevis', 'Saint Mary Cayon\r'),
(3338, 'Saint Kitts and Nevis', 'Saint Paul Capisterre\r'),
(3339, 'Saint Kitts and Nevis', 'Saint Paul Charlestown\r'),
(3340, 'Saint Kitts and Nevis', 'Saint Peter Basseterre\r'),
(3341, 'Saint Kitts and Nevis', 'Saint Thomas Lowland\r'),
(3342, 'Saint Kitts and Nevis', 'Saint Thomas Middle Island\r'),
(3343, 'Saint Kitts and Nevis', 'Trinity Palmetto Point\r'),
(3344, 'Saint Lucia', 'Anse-la-Raye\r'),
(3345, 'Saint Lucia', 'Castries\r'),
(3346, 'Saint Lucia', 'Choiseul\r'),
(3347, 'Saint Lucia', 'Dauphin\r'),
(3348, 'Saint Lucia', 'Dennery\r'),
(3349, 'Saint Lucia', 'Gros Islet\r'),
(3350, 'Saint Lucia', 'Laborie\r'),
(3351, 'Saint Lucia', 'Micoud\r'),
(3352, 'Saint Lucia', 'Praslin\r'),
(3353, 'Saint Lucia', 'Soufriere\r'),
(3354, 'Saint Lucia', 'Vieux Fort\r'),
(3355, 'Saint Pierre and Miquelon', 'Miquelon\r'),
(3356, 'Saint Pierre and Miquelon', 'Saint Pierre\r'),
(3357, 'Saint Vincent and the Grenadines', 'Charlotte\r'),
(3358, 'Saint Vincent and the Grenadines', 'Grenadines\r'),
(3359, 'Saint Vincent and the Grenadines', 'Saint Andrew\r'),
(3360, 'Saint Vincent and the Grenadines', 'Saint David\r'),
(3361, 'Saint Vincent and the Grenadines', 'Saint George\r'),
(3362, 'Saint Vincent and the Grenadines', 'Saint Patrick\r'),
(3363, 'Samoa', 'Aana\r'),
(3364, 'Samoa', 'Aiga-i-le-Tai\r'),
(3365, 'Samoa', 'Atua\r'),
(3366, 'Samoa', 'Faasaleleaga\r'),
(3367, 'Samoa', 'Gagaemauga\r'),
(3368, 'Samoa', 'Gagaifomauga\r'),
(3369, 'Samoa', 'Palauli\r'),
(3370, 'Samoa', 'Satupaitea\r'),
(3371, 'Samoa', 'Tuamasaga\r'),
(3372, 'Samoa', 'Vaa-o-Fonoti\r'),
(3373, 'Samoa', 'Vaisigano\r'),
(3374, 'San Marino', 'Acquaviva\r'),
(3375, 'San Marino', 'Borgo Maggiore\r'),
(3376, 'San Marino', 'Chiesanuova\r'),
(3377, 'San Marino', 'Domagnano\r'),
(3378, 'San Marino', 'Faetano\r'),
(3379, 'San Marino', 'Fiorentino\r'),
(3380, 'San Marino', 'Monte Giardino\r'),
(3381, 'San Marino', 'San Marino\r'),
(3382, 'San Marino', 'Serravalle\r'),
(3383, 'Sao Tome and Principe', 'Principe\r'),
(3384, 'Sao Tome and Principe', 'Sao Tome\r'),
(3385, 'Saudi Arabia', 'Asir\r'),
(3386, 'Saudi Arabia', 'Al Bahah\r'),
(3387, 'Saudi Arabia', 'Al Hudud ash Shamaliyah\r'),
(3388, 'Saudi Arabia', 'Al Jawf\r'),
(3389, 'Saudi Arabia', 'Al Madinah\r'),
(3390, 'Saudi Arabia', 'Al Qasim\r'),
(3391, 'Saudi Arabia', 'Ar Riyad\r'),
(3392, 'Saudi Arabia', 'Ash Sharqiyah (Eastern Province)\r'),
(3393, 'Saudi Arabia', 'Hail\r'),
(3394, 'Saudi Arabia', 'Jizan\r'),
(3395, 'Saudi Arabia', 'Makkah\r'),
(3396, 'Saudi Arabia', 'Najran\r'),
(3397, 'Saudi Arabia', 'Tabuk\r'),
(3398, 'Scotland', 'Aberdeen City\r'),
(3399, 'Scotland', 'Aberdeenshire\r'),
(3400, 'Scotland', 'Angus\r'),
(3401, 'Scotland', 'Argyll and Bute\r'),
(3402, 'Scotland', 'City of Edinburgh\r'),
(3403, 'Scotland', 'Clackmannanshire\r'),
(3404, 'Scotland', 'Dumfries and Galloway\r'),
(3405, 'Scotland', 'Dundee City\r'),
(3406, 'Scotland', 'East Ayrshire\r'),
(3407, 'Scotland', 'East Dunbartonshire\r'),
(3408, 'Scotland', 'East Lothian\r'),
(3409, 'Scotland', 'East Renfrewshire\r'),
(3410, 'Scotland', 'Eilean Siar (Western Isles)\r'),
(3411, 'Scotland', 'Falkirk\r'),
(3412, 'Scotland', 'Fife\r'),
(3413, 'Scotland', 'Glasgow City\r'),
(3414, 'Scotland', 'Highland\r'),
(3415, 'Scotland', 'Inverclyde\r'),
(3416, 'Scotland', 'Midlothian\r'),
(3417, 'Scotland', 'Moray\r'),
(3418, 'Scotland', 'North Ayrshire\r'),
(3419, 'Scotland', 'North Lanarkshire\r'),
(3420, 'Scotland', 'Orkney Islands\r'),
(3421, 'Scotland', 'Perth and Kinross\r'),
(3422, 'Scotland', 'Renfrewshire\r'),
(3423, 'Scotland', 'Shetland Islands\r'),
(3424, 'Scotland', 'South Ayrshire\r'),
(3425, 'Scotland', 'South Lanarkshire\r'),
(3426, 'Scotland', 'Stirling\r'),
(3427, 'Scotland', 'The Scottish Borders\r'),
(3428, 'Scotland', 'West Dunbartonshire\r'),
(3429, 'Scotland', 'West Lothian\r'),
(3430, 'Senegal', 'Dakar\r'),
(3431, 'Senegal', 'Diourbel\r'),
(3432, 'Senegal', 'Fatick\r'),
(3433, 'Senegal', 'Kaolack\r'),
(3434, 'Senegal', 'Kolda\r'),
(3435, 'Senegal', 'Louga\r'),
(3436, 'Senegal', 'Saint-Louis\r'),
(3437, 'Senegal', 'Tambacounda\r'),
(3438, 'Senegal', 'Thies\r'),
(3439, 'Senegal', 'Ziguinchor\r'),
(3440, 'Seychelles', 'Anse aux Pins\r'),
(3441, 'Seychelles', 'Anse Boileau\r'),
(3442, 'Seychelles', 'Anse Etoile\r'),
(3443, 'Seychelles', 'Anse Louis\r'),
(3444, 'Seychelles', 'Anse Royale\r'),
(3445, 'Seychelles', 'Baie Lazare\r'),
(3446, 'Seychelles', 'Baie Sainte Anne\r'),
(3447, 'Seychelles', 'Beau Vallon\r'),
(3448, 'Seychelles', 'Bel Air\r'),
(3449, 'Seychelles', 'Bel Ombre\r'),
(3450, 'Seychelles', 'Cascade\r'),
(3451, 'Seychelles', 'Glacis\r'),
(3452, 'Seychelles', 'Grand Anse (on Mahe)\r'),
(3453, 'Seychelles', 'Grand Anse (on Praslin)\r'),
(3454, 'Seychelles', 'La Digue\r'),
(3455, 'Seychelles', 'La Riviere Anglaise\r'),
(3456, 'Seychelles', 'Mont Buxton\r'),
(3457, 'Seychelles', 'Mont Fleuri\r'),
(3458, 'Seychelles', 'Plaisance\r'),
(3459, 'Seychelles', 'Pointe La Rue\r'),
(3460, 'Seychelles', 'Port Glaud\r'),
(3461, 'Seychelles', 'Saint Louis\r'),
(3462, 'Seychelles', 'Takamaka\r'),
(3463, 'Sierra Leone', 'Eastern\r'),
(3464, 'Sierra Leone', 'Northern\r'),
(3465, 'Sierra Leone', 'Southern\r'),
(3466, 'Sierra Leone', 'Western\r'),
(3467, 'SG', 'Singapore\r'),
(3468, 'Slovakia', 'Banskobystricky\r'),
(3469, 'Slovakia', 'Bratislavsky\r'),
(3470, 'Slovakia', 'Kosicky\r'),
(3471, 'Slovakia', 'Nitriansky\r'),
(3472, 'Slovakia', 'Presovsky\r'),
(3473, 'Slovakia', 'Trenciansky\r'),
(3474, 'Slovakia', 'Trnavsky\r'),
(3475, 'Slovakia', 'Zilinsky\r'),
(3476, 'Slovenia', 'Ajdovscina\r'),
(3477, 'Slovenia', 'Beltinci\r'),
(3478, 'Slovenia', 'Bled\r'),
(3479, 'Slovenia', 'Bohinj\r'),
(3480, 'Slovenia', 'Borovnica\r'),
(3481, 'Slovenia', 'Bovec\r'),
(3482, 'Slovenia', 'Brda\r'),
(3483, 'Slovenia', 'Brezice\r'),
(3484, 'Slovenia', 'Brezovica\r'),
(3485, 'Slovenia', 'Cankova-Tisina\r'),
(3486, 'Slovenia', 'Celje\r'),
(3487, 'Slovenia', 'Cerklje na Gorenjskem\r'),
(3488, 'Slovenia', 'Cerknica\r'),
(3489, 'Slovenia', 'Cerkno\r'),
(3490, 'Slovenia', 'Crensovci\r'),
(3491, 'Slovenia', 'Crna na Koroskem\r'),
(3492, 'Slovenia', 'Crnomelj\r'),
(3493, 'Slovenia', 'Destrnik-Trnovska Vas\r'),
(3494, 'Slovenia', 'Divaca\r'),
(3495, 'Slovenia', 'Dobrepolje\r'),
(3496, 'Slovenia', 'Dobrova-Horjul-Polhov Gradec\r'),
(3497, 'Slovenia', 'Dol pri Ljubljani\r'),
(3498, 'Slovenia', 'Domzale\r'),
(3499, 'Slovenia', 'Dornava\r'),
(3500, 'Slovenia', 'Dravograd\r'),
(3501, 'Slovenia', 'Duplek\r'),
(3502, 'Slovenia', 'Gorenja Vas-Poljane\r'),
(3503, 'Slovenia', 'Gorisnica\r'),
(3504, 'Slovenia', 'Gornja Radgona\r'),
(3505, 'Slovenia', 'Gornji Grad\r'),
(3506, 'Slovenia', 'Gornji Petrovci\r'),
(3507, 'Slovenia', 'Grosuplje\r'),
(3508, 'Slovenia', 'Hodos Salovci\r'),
(3509, 'Slovenia', 'Hrastnik\r'),
(3510, 'Slovenia', 'Hrpelje-Kozina\r'),
(3511, 'Slovenia', 'Idrija\r'),
(3512, 'Slovenia', 'Ig\r'),
(3513, 'Slovenia', 'Ilirska Bistrica\r'),
(3514, 'Slovenia', 'Ivancna Gorica\r'),
(3515, 'Slovenia', 'Izola\r'),
(3516, 'Slovenia', 'Jesenice\r'),
(3517, 'Slovenia', 'Jursinci\r'),
(3518, 'Slovenia', 'Kamnik\r'),
(3519, 'Slovenia', 'Kanal\r'),
(3520, 'Slovenia', 'Kidricevo\r'),
(3521, 'Slovenia', 'Kobarid\r'),
(3522, 'Slovenia', 'Kobilje\r'),
(3523, 'Slovenia', 'Kocevje\r'),
(3524, 'Slovenia', 'Komen\r'),
(3525, 'Slovenia', 'Koper\r'),
(3526, 'Slovenia', 'Kozje\r'),
(3527, 'Slovenia', 'Kranj\r'),
(3528, 'Slovenia', 'Kranjska Gora\r'),
(3529, 'Slovenia', 'Krsko\r'),
(3530, 'Slovenia', 'Kungota\r'),
(3531, 'Slovenia', 'Kuzma\r'),
(3532, 'Slovenia', 'Lasko\r'),
(3533, 'Slovenia', 'Lenart\r'),
(3534, 'Slovenia', 'Lendava\r'),
(3535, 'Slovenia', 'Litija\r'),
(3536, 'Slovenia', 'Ljubljana\r'),
(3537, 'Slovenia', 'Ljubno\r'),
(3538, 'Slovenia', 'Ljutomer\r'),
(3539, 'Slovenia', 'Logatec\r'),
(3540, 'Slovenia', 'Loska Dolina\r'),
(3541, 'Slovenia', 'Loski Potok\r'),
(3542, 'Slovenia', 'Luce\r'),
(3543, 'Slovenia', 'Lukovica\r'),
(3544, 'Slovenia', 'Majsperk\r'),
(3545, 'Slovenia', 'Maribor\r'),
(3546, 'Slovenia', 'Medvode\r'),
(3547, 'Slovenia', 'Menges\r'),
(3548, 'Slovenia', 'Metlika\r'),
(3549, 'Slovenia', 'Mezica\r'),
(3550, 'Slovenia', 'Miren-Kostanjevica\r'),
(3551, 'Slovenia', 'Mislinja\r'),
(3552, 'Slovenia', 'Moravce\r'),
(3553, 'Slovenia', 'Moravske Toplice\r'),
(3554, 'Slovenia', 'Mozirje\r'),
(3555, 'Slovenia', 'Murska Sobota\r'),
(3556, 'Slovenia', 'Muta\r'),
(3557, 'Slovenia', 'Naklo\r'),
(3558, 'Slovenia', 'Nazarje\r'),
(3559, 'Slovenia', 'Nova Gorica\r'),
(3560, 'Slovenia', 'Novo Mesto\r'),
(3561, 'Slovenia', 'Odranci\r'),
(3562, 'Slovenia', 'Ormoz\r'),
(3563, 'Slovenia', 'Osilnica\r'),
(3564, 'Slovenia', 'Pesnica\r'),
(3565, 'Slovenia', 'Piran\r'),
(3566, 'Slovenia', 'Pivka\r'),
(3567, 'Slovenia', 'Podcetrtek\r'),
(3568, 'Slovenia', 'Podvelka-Ribnica\r'),
(3569, 'Slovenia', 'Postojna\r'),
(3570, 'Slovenia', 'Preddvor\r'),
(3571, 'Slovenia', 'Ptuj\r'),
(3572, 'Slovenia', 'Puconci\r'),
(3573, 'Slovenia', 'Race-Fram\r'),
(3574, 'Slovenia', 'Radece\r'),
(3575, 'Slovenia', 'Radenci\r'),
(3576, 'Slovenia', 'Radlje ob Dravi\r'),
(3577, 'Slovenia', 'Radovljica\r'),
(3578, 'Slovenia', 'Ravne-Prevalje\r'),
(3579, 'Slovenia', 'Ribnica\r'),
(3580, 'Slovenia', 'Rogasevci\r'),
(3581, 'Slovenia', 'Rogaska Slatina\r'),
(3582, 'Slovenia', 'Rogatec\r'),
(3583, 'Slovenia', 'Ruse\r'),
(3584, 'Slovenia', 'Semic\r'),
(3585, 'Slovenia', 'Sencur\r'),
(3586, 'Slovenia', 'Sentilj\r'),
(3587, 'Slovenia', 'Sentjernej\r'),
(3588, 'Slovenia', 'Sentjur pri Celju\r'),
(3589, 'Slovenia', 'Sevnica\r'),
(3590, 'Slovenia', 'Sezana\r'),
(3591, 'Slovenia', 'Skocjan\r'),
(3592, 'Slovenia', 'Skofja Loka\r'),
(3593, 'Slovenia', 'Skofljica\r'),
(3594, 'Slovenia', 'Slovenj Gradec\r'),
(3595, 'Slovenia', 'Slovenska Bistrica\r'),
(3596, 'Slovenia', 'Slovenske Konjice\r'),
(3597, 'Slovenia', 'Smarje pri Jelsah\r'),
(3598, 'Slovenia', 'Smartno ob Paki\r'),
(3599, 'Slovenia', 'Sostanj\r'),
(3600, 'Slovenia', 'Starse\r'),
(3601, 'Slovenia', 'Store\r'),
(3602, 'Slovenia', 'Sveti Jurij\r'),
(3603, 'Slovenia', 'Tolmin\r'),
(3604, 'Slovenia', 'Trbovlje\r'),
(3605, 'Slovenia', 'Trebnje\r'),
(3606, 'Slovenia', 'Trzic\r'),
(3607, 'Slovenia', 'Turnisce\r'),
(3608, 'Slovenia', 'Velenje\r'),
(3609, 'Slovenia', 'Velike Lasce\r'),
(3610, 'Slovenia', 'Videm\r'),
(3611, 'Slovenia', 'Vipava\r'),
(3612, 'Slovenia', 'Vitanje\r'),
(3613, 'Slovenia', 'Vodice\r'),
(3614, 'Slovenia', 'Vojnik\r'),
(3615, 'Slovenia', 'Vrhnika\r'),
(3616, 'Slovenia', 'Vuzenica\r'),
(3617, 'Slovenia', 'Zagorje ob Savi\r'),
(3618, 'Slovenia', 'Zalec\r'),
(3619, 'Slovenia', 'Zavrc\r'),
(3620, 'Slovenia', 'Zelezniki\r'),
(3621, 'Slovenia', 'Ziri\r'),
(3622, 'Slovenia', 'Zrece\r'),
(3623, 'Solomon Islands', 'Bellona\r'),
(3624, 'Solomon Islands', 'Central\r'),
(3625, 'Solomon Islands', 'Choiseul (Lauru)\r'),
(3626, 'Solomon Islands', 'Guadalcanal\r'),
(3627, 'Solomon Islands', 'Honiara\r'),
(3628, 'Solomon Islands', 'Isabel\r'),
(3629, 'Solomon Islands', 'Makira\r'),
(3630, 'Solomon Islands', 'Malaita\r'),
(3631, 'Solomon Islands', 'Rennell\r'),
(3632, 'Solomon Islands', 'Temotu\r'),
(3633, 'Solomon Islands', 'Western\r'),
(3634, 'Somalia', 'Awdal\r'),
(3635, 'Somalia', 'Bakool\r'),
(3636, 'Somalia', 'Banaadir\r'),
(3637, 'Somalia', 'Bari\r'),
(3638, 'Somalia', 'Bay\r'),
(3639, 'Somalia', 'Galguduud\r'),
(3640, 'Somalia', 'Gedo\r'),
(3641, 'Somalia', 'Hiiraan\r'),
(3642, 'Somalia', 'Jubbada Dhexe\r'),
(3643, 'Somalia', 'Jubbada Hoose\r'),
(3644, 'Somalia', 'Mudug\r'),
(3645, 'Somalia', 'Nugaal\r'),
(3646, 'Somalia', 'Sanaag\r'),
(3647, 'Somalia', 'Shabeellaha Dhexe\r'),
(3648, 'Somalia', 'Shabeellaha Hoose\r'),
(3649, 'Somalia', 'Sool\r'),
(3650, 'Somalia', 'Togdheer\r'),
(3651, 'Somalia', 'Woqooyi Galbeed\r'),
(3652, 'South Africa', 'Eastern Cape\r'),
(3653, 'South Africa', 'Free State\r'),
(3654, 'South Africa', 'Gauteng\r'),
(3655, 'South Africa', 'KwaZulu-Natal\r'),
(3656, 'South Africa', 'Mpumalanga\r'),
(3657, 'South Africa', 'North-West\r'),
(3658, 'South Africa', 'Northern Cape\r'),
(3659, 'South Africa', 'Northern Province\r'),
(3660, 'South Africa', 'Western Cape\r'),
(3661, 'South Georgia and South Sandwich Islands', 'Bird Island\r'),
(3662, 'South Georgia and South Sandwich Islands', 'Bristol Island\r'),
(3663, 'South Georgia and South Sandwich Islands', 'Clerke Rocks\r'),
(3664, 'South Georgia and South Sandwich Islands', 'Montagu Island\r'),
(3665, 'South Georgia and South Sandwich Islands', 'Saunders Island\r'),
(3666, 'South Georgia and South Sandwich Islands', 'South Georgia\r'),
(3667, 'South Georgia and South Sandwich Islands', 'Southern Thule\r'),
(3668, 'South Georgia and South Sandwich Islands', 'Traversay Islands\r'),
(3669, 'Spain', 'Andalucia\r'),
(3670, 'Spain', 'Aragon\r'),
(3671, 'Spain', 'Asturias\r'),
(3672, 'Spain', 'Baleares (Balearic Islands)\r'),
(3673, 'Spain', 'Canarias (Canary Islands)\r'),
(3674, 'Spain', 'Cantabria\r'),
(3675, 'Spain', 'Castilla y Leon\r'),
(3676, 'Spain', 'Castilla-La Mancha\r'),
(3677, 'Spain', 'Cataluna\r'),
(3678, 'Spain', 'Ceuta\r'),
(3679, 'Spain', 'Communidad Valencian\r'),
(3680, 'Spain', 'Extremadura\r'),
(3681, 'Spain', 'Galicia\r'),
(3682, 'Spain', 'Islas Chafarinas\r'),
(3683, 'Spain', 'La Rioja\r'),
(3684, 'Spain', 'Madrid\r'),
(3685, 'Spain', 'Melilla\r'),
(3686, 'Spain', 'Murcia\r'),
(3687, 'Spain', 'Navarra\r'),
(3688, 'Spain', 'Pais Vasco (Basque Country)\r'),
(3689, 'Spain', 'Penon de Alhucemas\r'),
(3690, 'Spain', 'Penon de Velez de la Gomera\r'),
(3691, 'Spratly Islands', 'Spratly Islands\r'),
(3692, 'Sri Lanka', 'Central\r'),
(3693, 'Sri Lanka', 'Eastern\r'),
(3694, 'Sri Lanka', 'North Central\r'),
(3695, 'Sri Lanka', 'North Eastern\r'),
(3696, 'Sri Lanka', 'North Western\r'),
(3697, 'Sri Lanka', 'Northern\r'),
(3698, 'Sri Lanka', 'Sabaragamuwa\r'),
(3699, 'Sri Lanka', 'Southern\r'),
(3700, 'Sri Lanka', 'Uva\r'),
(3701, 'Sri Lanka', 'Western\r'),
(3702, 'Sudan', 'Aali an Nil\r'),
(3703, 'Sudan', 'Al Bahr al Ahmar\r'),
(3704, 'Sudan', 'Al Buhayrat\r'),
(3705, 'Sudan', 'Al Jazirah\r'),
(3706, 'Sudan', 'Al Khartum\r'),
(3707, 'Sudan', 'Al Qadarif\r'),
(3708, 'Sudan', 'Al Wahdah\r'),
(3709, 'Sudan', 'An Nil al Abyad\r'),
(3710, 'Sudan', 'An Nil al Azraq\r'),
(3711, 'Sudan', 'Ash Shamaliyah\r'),
(3712, 'Sudan', 'Bahr al Jabal\r'),
(3713, 'Sudan', 'Gharb al Istiwaiyah\r'),
(3714, 'Sudan', 'Gharb Bahr al Ghazal\r'),
(3715, 'Sudan', 'Gharb Darfur\r'),
(3716, 'Sudan', 'Gharb Kurdufan\r'),
(3717, 'Sudan', 'Janub Darfur\r'),
(3718, 'Sudan', 'Janub Kurdufan\r'),
(3719, 'Sudan', 'Junqali\r'),
(3720, 'Sudan', 'Kassala\r'),
(3721, 'Sudan', 'Nahr an Nil\r'),
(3722, 'Sudan', 'Shamal Bahr al Ghazal\r'),
(3723, 'Sudan', 'Shamal Darfur\r'),
(3724, 'Sudan', 'Shamal Kurdufan\r'),
(3725, 'Sudan', 'Sharq al Istiwaiyah\r'),
(3726, 'Sudan', 'Sinnar\r'),
(3727, 'Sudan', 'Warab\r'),
(3728, 'Suriname', 'Brokopondo\r'),
(3729, 'Suriname', 'Commewijne\r'),
(3730, 'Suriname', 'Coronie\r'),
(3731, 'Suriname', 'Marowijne\r'),
(3732, 'Suriname', 'Nickerie\r'),
(3733, 'Suriname', 'Para\r'),
(3734, 'Suriname', 'Paramaribo\r'),
(3735, 'Suriname', 'Saramacca\r'),
(3736, 'Suriname', 'Sipaliwini\r'),
(3737, 'Suriname', 'Wanica\r'),
(3738, 'Svalbard', 'Barentsoya\r'),
(3739, 'Svalbard', 'Bjornoya\r'),
(3740, 'Svalbard', 'Edgeoya\r'),
(3741, 'Svalbard', 'Hopen\r'),
(3742, 'Svalbard', 'Kvitoya\r'),
(3743, 'Svalbard', 'Nordaustandet\r'),
(3744, 'Svalbard', 'Prins Karls Forland\r'),
(3745, 'Svalbard', 'Spitsbergen\r'),
(3746, 'Swaziland', 'Hhohho\r'),
(3747, 'Swaziland', 'Lubombo\r'),
(3748, 'Swaziland', 'Manzini\r'),
(3749, 'Swaziland', 'Shiselweni\r'),
(3750, 'Sweden', 'Blekinge\r'),
(3751, 'Sweden', 'Dalarnas\r'),
(3752, 'Sweden', 'Gavleborgs\r'),
(3753, 'Sweden', 'Gotlands\r'),
(3754, 'Sweden', 'Hallands\r'),
(3755, 'Sweden', 'Jamtlands\r'),
(3756, 'Sweden', 'Jonkopings\r'),
(3757, 'Sweden', 'Kalmar\r'),
(3758, 'Sweden', 'Kronobergs\r'),
(3759, 'Sweden', 'Norrbottens\r'),
(3760, 'Sweden', 'Orebro\r'),
(3761, 'Sweden', 'Ostergotlands\r'),
(3762, 'Sweden', 'Skane\r'),
(3763, 'Sweden', 'Sodermanlands\r'),
(3764, 'Sweden', 'Stockholms\r'),
(3765, 'Sweden', 'Uppsala\r'),
(3766, 'Sweden', 'Varmlands\r'),
(3767, 'Sweden', 'Vasterbottens\r'),
(3768, 'Sweden', 'Vasternorrlands\r'),
(3769, 'Sweden', 'Vastmanlands\r'),
(3770, 'Sweden', 'Vastra Gotalands\r'),
(3771, 'Switzerland', 'Aargau\r'),
(3772, 'Switzerland', 'Ausser-Rhoden\r'),
(3773, 'Switzerland', 'Basel-Landschaft\r'),
(3774, 'Switzerland', 'Basel-Stadt\r'),
(3775, 'Switzerland', 'Bern\r'),
(3776, 'Switzerland', 'Fribourg\r'),
(3777, 'Switzerland', 'Geneve\r'),
(3778, 'Switzerland', 'Glarus\r'),
(3779, 'Switzerland', 'Graubunden\r'),
(3780, 'Switzerland', 'Inner-Rhoden\r'),
(3781, 'Switzerland', 'Jura\r'),
(3782, 'Switzerland', 'Luzern\r'),
(3783, 'Switzerland', 'Neuchatel\r'),
(3784, 'Switzerland', 'Nidwalden\r'),
(3785, 'Switzerland', 'Obwalden\r'),
(3786, 'Switzerland', 'Sankt Gallen\r'),
(3787, 'Switzerland', 'Schaffhausen\r'),
(3788, 'Switzerland', 'Schwyz\r'),
(3789, 'Switzerland', 'Solothurn\r'),
(3790, 'Switzerland', 'Thurgau\r'),
(3791, 'Switzerland', 'Ticino\r'),
(3792, 'Switzerland', 'Uri\r'),
(3793, 'Switzerland', 'Valais\r'),
(3794, 'Switzerland', 'Vaud\r'),
(3795, 'Switzerland', 'Zug\r'),
(3796, 'Switzerland', 'Zurich\r'),
(3797, 'Syria', 'Al Hasakah\r'),
(3798, 'Syria', 'Al Ladhiqiyah\r'),
(3799, 'Syria', 'Al Qunaytirah\r'),
(3800, 'Syria', 'Ar Raqqah\r'),
(3801, 'Syria', 'As Suwayda\r'),
(3802, 'Syria', 'Dara\r'),
(3803, 'Syria', 'Dayr az Zawr\r'),
(3804, 'Syria', 'Dimashq\r'),
(3805, 'Syria', 'Halab\r'),
(3806, 'Syria', 'Hamah\r'),
(3807, 'Syria', 'Hims\r'),
(3808, 'Syria', 'Idlib\r'),
(3809, 'Syria', 'Rif Dimashq\r'),
(3810, 'Syria', 'Tartus\r'),
(3811, 'Taiwan', 'Chang-hua\r'),
(3812, 'Taiwan', 'Chi-lung\r'),
(3813, 'Taiwan', 'Chia-i\r'),
(3814, 'Taiwan', 'Chia-i\r'),
(3815, 'Taiwan', 'Chung-hsing-hsin-tsun\r'),
(3816, 'Taiwan', 'Hsin-chu\r'),
(3817, 'Taiwan', 'Hsin-chu\r'),
(3818, 'Taiwan', 'Hua-lien\r'),
(3819, 'Taiwan', 'I-lan\r'),
(3820, 'Taiwan', 'Kao-hsiung\r'),
(3821, 'Taiwan', 'Kao-hsiung\r'),
(3822, 'Taiwan', 'Miao-li\r'),
(3823, 'Taiwan', 'Nan-tou\r'),
(3824, 'Taiwan', 'Peng-hu\r'),
(3825, 'Taiwan', 'Ping-tung\r'),
(3826, 'Taiwan', 'Tai-chung\r'),
(3827, 'Taiwan', 'Tai-chung\r'),
(3828, 'Taiwan', 'Tai-nan\r'),
(3829, 'Taiwan', 'Tai-nan\r'),
(3830, 'Taiwan', 'Tai-pei\r'),
(3831, 'Taiwan', 'Tai-pei\r'),
(3832, 'Taiwan', 'Tai-tung\r'),
(3833, 'Taiwan', 'Tao-yuan\r'),
(3834, 'Taiwan', 'Yun-lin\r'),
(3835, 'Tajikistan', 'Viloyati Khatlon\r'),
(3836, 'Tajikistan', 'Viloyati Leninobod\r'),
(3837, 'Tajikistan', 'Viloyati Mukhtori Kuhistoni Badakhshon\r'),
(3838, 'Tanzania', 'Arusha\r'),
(3839, 'Tanzania', 'Dar es Salaam\r'),
(3840, 'Tanzania', 'Dodoma\r'),
(3841, 'Tanzania', 'Iringa\r'),
(3842, 'Tanzania', 'Kagera\r'),
(3843, 'Tanzania', 'Kigoma\r'),
(3844, 'Tanzania', 'Kilimanjaro\r'),
(3845, 'Tanzania', 'Lindi\r'),
(3846, 'Tanzania', 'Mara\r'),
(3847, 'Tanzania', 'Mbeya\r'),
(3848, 'Tanzania', 'Morogoro\r'),
(3849, 'Tanzania', 'Mtwara\r'),
(3850, 'Tanzania', 'Mwanza\r'),
(3851, 'Tanzania', 'Pemba North\r'),
(3852, 'Tanzania', 'Pemba South\r'),
(3853, 'Tanzania', 'Pwani\r'),
(3854, 'Tanzania', 'Rukwa\r'),
(3855, 'Tanzania', 'Ruvuma\r'),
(3856, 'Tanzania', 'Shinyanga\r'),
(3857, 'Tanzania', 'Singida\r'),
(3858, 'Tanzania', 'Tabora\r'),
(3859, 'Tanzania', 'Tanga\r'),
(3860, 'Tanzania', 'Zanzibar Central/South\r'),
(3861, 'Tanzania', 'Zanzibar North\r'),
(3862, 'Tanzania', 'Zanzibar Urban/West\r'),
(3863, 'Thailand', 'Amnat Charoen\r'),
(3864, 'Thailand', 'Ang Thong\r'),
(3865, 'Thailand', 'Buriram\r'),
(3866, 'Thailand', 'Chachoengsao\r'),
(3867, 'Thailand', 'Chai Nat\r'),
(3868, 'Thailand', 'Chaiyaphum\r'),
(3869, 'Thailand', 'Chanthaburi\r'),
(3870, 'Thailand', 'Chiang Mai\r'),
(3871, 'Thailand', 'Chiang Rai\r'),
(3872, 'Thailand', 'Chon Buri\r'),
(3873, 'Thailand', 'Chumphon\r'),
(3874, 'Thailand', 'Kalasin\r'),
(3875, 'Thailand', 'Kamphaeng Phet\r'),
(3876, 'Thailand', 'Kanchanaburi\r'),
(3877, 'Thailand', 'Khon Kaen\r'),
(3878, 'Thailand', 'Krabi\r'),
(3879, 'Thailand', 'Krung Thep Mahanakhon (Bangkok)\r'),
(3880, 'Thailand', 'Lampang\r'),
(3881, 'Thailand', 'Lamphun\r'),
(3882, 'Thailand', 'Loei\r'),
(3883, 'Thailand', 'Lop Buri\r'),
(3884, 'Thailand', 'Mae Hong Son\r'),
(3885, 'Thailand', 'Maha Sarakham\r'),
(3886, 'Thailand', 'Mukdahan\r'),
(3887, 'Thailand', 'Nakhon Nayok\r'),
(3888, 'Thailand', 'Nakhon Pathom\r'),
(3889, 'Thailand', 'Nakhon Phanom\r'),
(3890, 'Thailand', 'Nakhon Ratchasima\r'),
(3891, 'Thailand', 'Nakhon Sawan\r'),
(3892, 'Thailand', 'Nakhon Si Thammarat\r'),
(3893, 'Thailand', 'Nan\r'),
(3894, 'Thailand', 'Narathiwat\r'),
(3895, 'Thailand', 'Nong Bua Lamphu\r'),
(3896, 'Thailand', 'Nong Khai\r'),
(3897, 'Thailand', 'Nonthaburi\r'),
(3898, 'Thailand', 'Pathum Thani\r'),
(3899, 'Thailand', 'Pattani\r'),
(3900, 'Thailand', 'Phangnga\r'),
(3901, 'Thailand', 'Phatthalung\r'),
(3902, 'Thailand', 'Phayao\r'),
(3903, 'Thailand', 'Phetchabun\r'),
(3904, 'Thailand', 'Phetchaburi\r'),
(3905, 'Thailand', 'Phichit\r'),
(3906, 'Thailand', 'Phitsanulok\r'),
(3907, 'Thailand', 'Phra Nakhon Si Ayutthaya\r'),
(3908, 'Thailand', 'Phrae\r'),
(3909, 'Thailand', 'Phuket\r'),
(3910, 'Thailand', 'Prachin Buri\r'),
(3911, 'Thailand', 'Prachuap Khiri Khan\r'),
(3912, 'Thailand', 'Ranong\r'),
(3913, 'Thailand', 'Ratchaburi\r'),
(3914, 'Thailand', 'Rayong\r'),
(3915, 'Thailand', 'Roi Et\r'),
(3916, 'Thailand', 'Sa Kaeo\r'),
(3917, 'Thailand', 'Sakon Nakhon\r'),
(3918, 'Thailand', 'Samut Prakan\r'),
(3919, 'Thailand', 'Samut Sakhon\r'),
(3920, 'Thailand', 'Samut Songkhram\r'),
(3921, 'Thailand', 'Sara Buri\r'),
(3922, 'Thailand', 'Satun\r'),
(3923, 'Thailand', 'Sing Buri\r'),
(3924, 'Thailand', 'Sisaket\r'),
(3925, 'Thailand', 'Songkhla\r'),
(3926, 'Thailand', 'Sukhothai\r'),
(3927, 'Thailand', 'Suphan Buri\r'),
(3928, 'Thailand', 'Surat Thani\r'),
(3929, 'Thailand', 'Surin\r'),
(3930, 'Thailand', 'Tak\r'),
(3931, 'Thailand', 'Trang\r'),
(3932, 'Thailand', 'Trat\r'),
(3933, 'Thailand', 'Ubon Ratchathani\r'),
(3934, 'Thailand', 'Udon Thani\r'),
(3935, 'Thailand', 'Uthai Thani\r'),
(3936, 'Thailand', 'Uttaradit\r'),
(3937, 'Thailand', 'Yala\r'),
(3938, 'Thailand', 'Yasothon\r'),
(3939, 'Tobago', 'Tobago\r'),
(3940, 'Toga', 'De La Kara\r'),
(3941, 'Toga', 'Des Plateaux\r'),
(3942, 'Toga', 'Des Savanes\r'),
(3943, 'Toga', 'Du Centre\r'),
(3944, 'Toga', 'Maritime\r'),
(3945, 'Tokelau', 'Atafu\r'),
(3946, 'Tokelau', 'Fakaofo\r'),
(3947, 'Tokelau', 'Nukunonu\r'),
(3948, 'Tonga', 'Haapai\r'),
(3949, 'Tonga', 'Tongatapu\r'),
(3950, 'Tonga', 'Vavau\r'),
(3951, 'Trinidad', 'Arima\r'),
(3952, 'Trinidad', 'Caroni\r'),
(3953, 'Trinidad', 'Mayaro\r'),
(3954, 'Trinidad', 'Nariva\r'),
(3955, 'Trinidad', 'Port-of-Spain\r'),
(3956, 'Trinidad', 'Saint Andrew\r'),
(3957, 'Trinidad', 'Saint David\r'),
(3958, 'Trinidad', 'Saint George\r'),
(3959, 'Trinidad', 'Saint Patrick\r'),
(3960, 'Trinidad', 'San Fernando\r'),
(3961, 'Trinidad', 'Victoria\r'),
(3962, 'Tunisia', 'Ariana\r'),
(3963, 'Tunisia', 'Beja\r'),
(3964, 'Tunisia', 'Ben Arous\r'),
(3965, 'Tunisia', 'Bizerte\r'),
(3966, 'Tunisia', 'El Kef\r'),
(3967, 'Tunisia', 'Gabes\r'),
(3968, 'Tunisia', 'Gafsa\r'),
(3969, 'Tunisia', 'Jendouba\r'),
(3970, 'Tunisia', 'Kairouan\r'),
(3971, 'Tunisia', 'Kasserine\r'),
(3972, 'Tunisia', 'Kebili\r'),
(3973, 'Tunisia', 'Mahdia\r'),
(3974, 'Tunisia', 'Medenine\r'),
(3975, 'Tunisia', 'Monastir\r'),
(3976, 'Tunisia', 'Nabeul\r'),
(3977, 'Tunisia', 'Sfax\r'),
(3978, 'Tunisia', 'Sidi Bou Zid\r'),
(3979, 'Tunisia', 'Siliana\r'),
(3980, 'Tunisia', 'Sousse\r'),
(3981, 'Tunisia', 'Tataouine\r'),
(3982, 'Tunisia', 'Tozeur\r'),
(3983, 'Tunisia', 'Tunis\r'),
(3984, 'Tunisia', 'Zaghouan\r'),
(3985, 'Turkey', 'Adana\r'),
(3986, 'Turkey', 'Adiyaman\r'),
(3987, 'Turkey', 'Afyon\r'),
(3988, 'Turkey', 'Agri\r'),
(3989, 'Turkey', 'Aksaray\r'),
(3990, 'Turkey', 'Amasya\r'),
(3991, 'Turkey', 'Ankara\r'),
(3992, 'Turkey', 'Antalya\r'),
(3993, 'Turkey', 'Ardahan\r'),
(3994, 'Turkey', 'Artvin\r'),
(3995, 'Turkey', 'Aydin\r'),
(3996, 'Turkey', 'Balikesir\r'),
(3997, 'Turkey', 'Bartin\r'),
(3998, 'Turkey', 'Batman\r'),
(3999, 'Turkey', 'Bayburt\r'),
(4000, 'Turkey', 'Bilecik\r'),
(4001, 'Turkey', 'Bingol\r'),
(4002, 'Turkey', 'Bitlis\r'),
(4003, 'Turkey', 'Bolu\r'),
(4004, 'Turkey', 'Burdur\r'),
(4005, 'Turkey', 'Bursa\r'),
(4006, 'Turkey', 'Canakkale\r'),
(4007, 'Turkey', 'Cankiri\r'),
(4008, 'Turkey', 'Corum\r'),
(4009, 'Turkey', 'Denizli\r'),
(4010, 'Turkey', 'Diyarbakir\r'),
(4011, 'Turkey', 'Duzce\r'),
(4012, 'Turkey', 'Edirne\r'),
(4013, 'Turkey', 'Elazig\r'),
(4014, 'Turkey', 'Erzincan\r'),
(4015, 'Turkey', 'Erzurum\r'),
(4016, 'Turkey', 'Eskisehir\r'),
(4017, 'Turkey', 'Gaziantep\r'),
(4018, 'Turkey', 'Giresun\r'),
(4019, 'Turkey', 'Gumushane\r'),
(4020, 'Turkey', 'Hakkari\r'),
(4021, 'Turkey', 'Hatay\r'),
(4022, 'Turkey', 'Icel\r'),
(4023, 'Turkey', 'Igdir\r'),
(4024, 'Turkey', 'Isparta\r'),
(4025, 'Turkey', 'Istanbul\r'),
(4026, 'Turkey', 'Izmir\r'),
(4027, 'Turkey', 'Kahramanmaras\r'),
(4028, 'Turkey', 'Karabuk\r'),
(4029, 'Turkey', 'Karaman\r'),
(4030, 'Turkey', 'Kars\r'),
(4031, 'Turkey', 'Kastamonu\r'),
(4032, 'Turkey', 'Kayseri\r'),
(4033, 'Turkey', 'Kilis\r'),
(4034, 'Turkey', 'Kirikkale\r'),
(4035, 'Turkey', 'Kirklareli\r'),
(4036, 'Turkey', 'Kirsehir\r'),
(4037, 'Turkey', 'Kocaeli\r'),
(4038, 'Turkey', 'Konya\r'),
(4039, 'Turkey', 'Kutahya\r'),
(4040, 'Turkey', 'Malatya\r'),
(4041, 'Turkey', 'Manisa\r'),
(4042, 'Turkey', 'Mardin\r'),
(4043, 'Turkey', 'Mugla\r'),
(4044, 'Turkey', 'Mus\r'),
(4045, 'Turkey', 'Nevsehir\r'),
(4046, 'Turkey', 'Nigde\r'),
(4047, 'Turkey', 'Ordu\r'),
(4048, 'Turkey', 'Osmaniye\r'),
(4049, 'Turkey', 'Rize\r'),
(4050, 'Turkey', 'Sakarya\r'),
(4051, 'Turkey', 'Samsun\r'),
(4052, 'Turkey', 'Sanliurfa\r'),
(4053, 'Turkey', 'Siirt\r'),
(4054, 'Turkey', 'Sinop\r'),
(4055, 'Turkey', 'Sirnak\r'),
(4056, 'Turkey', 'Sivas\r'),
(4057, 'Turkey', 'Tekirdag\r'),
(4058, 'Turkey', 'Tokat\r'),
(4059, 'Turkey', 'Trabzon\r'),
(4060, 'Turkey', 'Tunceli\r'),
(4061, 'Turkey', 'Usak\r'),
(4062, 'Turkey', 'Van\r'),
(4063, 'Turkey', 'Yalova\r'),
(4064, 'Turkey', 'Yozgat\r'),
(4065, 'Turkey', 'Zonguldak\r'),
(4066, 'Turkmenistan', 'Ahal Welayaty\r'),
(4067, 'Turkmenistan', 'Balkan Welayaty\r'),
(4068, 'Turkmenistan', 'Dashhowuz Welayaty\r'),
(4069, 'Turkmenistan', 'Lebap Welayaty\r'),
(4070, 'Turkmenistan', 'Mary Welayaty\r'),
(4071, 'Tuvalu', 'Tuvalu\r'),
(4072, 'Uganda', 'Adjumani\r'),
(4073, 'Uganda', 'Apac\r'),
(4074, 'Uganda', 'Arua\r'),
(4075, 'Uganda', 'Bugiri\r'),
(4076, 'Uganda', 'Bundibugyo\r'),
(4077, 'Uganda', 'Bushenyi\r'),
(4078, 'Uganda', 'Busia\r'),
(4079, 'Uganda', 'Gulu\r'),
(4080, 'Uganda', 'Hoima\r'),
(4081, 'Uganda', 'Iganga\r'),
(4082, 'Uganda', 'Jinja\r'),
(4083, 'Uganda', 'Kabale\r'),
(4084, 'Uganda', 'Kabarole\r'),
(4085, 'Uganda', 'Kalangala\r'),
(4086, 'Uganda', 'Kampala\r'),
(4087, 'Uganda', 'Kamuli\r'),
(4088, 'Uganda', 'Kapchorwa\r'),
(4089, 'Uganda', 'Kasese\r'),
(4090, 'Uganda', 'Katakwi\r'),
(4091, 'Uganda', 'Kibale\r'),
(4092, 'Uganda', 'Kiboga\r'),
(4093, 'Uganda', 'Kisoro\r'),
(4094, 'Uganda', 'Kitgum\r'),
(4095, 'Uganda', 'Kotido\r'),
(4096, 'Uganda', 'Kumi\r'),
(4097, 'Uganda', 'Lira\r'),
(4098, 'Uganda', 'Luwero\r'),
(4099, 'Uganda', 'Masaka\r'),
(4100, 'Uganda', 'Masindi\r'),
(4101, 'Uganda', 'Mbale\r'),
(4102, 'Uganda', 'Mbarara\r'),
(4103, 'Uganda', 'Moroto\r'),
(4104, 'Uganda', 'Moyo\r'),
(4105, 'Uganda', 'Mpigi\r'),
(4106, 'Uganda', 'Mubende\r'),
(4107, 'Uganda', 'Mukono\r'),
(4108, 'Uganda', 'Nakasongola\r'),
(4109, 'Uganda', 'Nebbi\r'),
(4110, 'Uganda', 'Ntungamo\r'),
(4111, 'Uganda', 'Pallisa\r'),
(4112, 'Uganda', 'Rakai\r'),
(4113, 'Uganda', 'Rukungiri\r'),
(4114, 'Uganda', 'Sembabule\r'),
(4115, 'Uganda', 'Soroti\r'),
(4116, 'Uganda', 'Tororo\r'),
(4117, 'Ukraine', 'Avtonomna Respublika Krym (Simferopol)\r'),
(4118, 'Ukraine', 'Cherkaska (Cherkasy)\r'),
(4119, 'Ukraine', 'Chernihivska (Chernihiv)\r'),
(4120, 'Ukraine', 'Chernivetska (Chernivtsi)\r'),
(4121, 'Ukraine', 'Dnipropetrovska (Dnipropetrovsk)\r'),
(4122, 'Ukraine', 'Donetska (Donetsk)\r'),
(4123, 'Ukraine', 'Ivano-Frankivska (Ivano-Frankivsk)\r'),
(4124, 'Ukraine', 'Kharkivska (Kharkiv)\r'),
(4125, 'Ukraine', 'Khersonska (Kherson)\r'),
(4126, 'Ukraine', 'Khmelnytska (Khmelnytskyy)\r'),
(4127, 'Ukraine', 'Kirovohradska (Kirovohrad)\r'),
(4128, 'Ukraine', 'Kyyiv\r'),
(4129, 'Ukraine', 'Kyyivska (Kiev)\r'),
(4130, 'Ukraine', 'Lvivska (Lviv)\r'),
(4131, 'Ukraine', 'Luhanska (Luhansk)\r'),
(4132, 'Ukraine', 'Mykolayivska (Mykolayiv)\r'),
(4133, 'Ukraine', 'Odeska (Odesa)\r'),
(4134, 'Ukraine', 'Poltavska (Poltava)\r'),
(4135, 'Ukraine', 'Rivnenska (Rivne)\r'),
(4136, 'Ukraine', 'Sevastopol\r'),
(4137, 'Ukraine', 'Sumska (Sumy)\r'),
(4138, 'Ukraine', 'Ternopilska (Ternopil)\r'),
(4139, 'Ukraine', 'Vinnytska (Vinnytsya)\r'),
(4140, 'Ukraine', 'Volynska (Lutsk)\r'),
(4141, 'Ukraine', 'Zakarpatska (Uzhhorod)\r'),
(4142, 'Ukraine', 'Zaporizka (Zaporizhzhya)\r'),
(4143, 'Ukraine', 'Zhytomyrska (Zhytomyr)\r'),
(4144, 'United Arab Emirates', 'Ajman\r'),
(4145, 'United Arab Emirates', 'Abu Zaby (Abu Dhabi)\r'),
(4146, 'United Arab Emirates', 'Al Fujayrah\r'),
(4147, 'United Arab Emirates', 'Ash Shariqah (Sharjah)\r'),
(4148, 'United Arab Emirates', 'Dubayy (Dubai)\r'),
(4149, 'United Arab Emirates', 'Ras al Khaymah\r'),
(4150, 'United Arab Emirates', 'Umm al Qaywayn\r'),
(4151, 'Uruguay', 'Artigas\r'),
(4152, 'Uruguay', 'Canelones\r'),
(4153, 'Uruguay', 'Cerro Largo\r'),
(4154, 'Uruguay', 'Colonia\r'),
(4155, 'Uruguay', 'Durazno\r'),
(4156, 'Uruguay', 'Flores\r'),
(4157, 'Uruguay', 'Florida\r'),
(4158, 'Uruguay', 'Lavalleja\r'),
(4159, 'Uruguay', 'Maldonado\r'),
(4160, 'Uruguay', 'Montevideo\r'),
(4161, 'Uruguay', 'Paysandu\r'),
(4162, 'Uruguay', 'Rio Negro\r'),
(4163, 'Uruguay', 'Rivera\r'),
(4164, 'Uruguay', 'Rocha\r'),
(4165, 'Uruguay', 'Salto\r'),
(4166, 'Uruguay', 'San Jose\r'),
(4167, 'Uruguay', 'Soriano\r'),
(4168, 'Uruguay', 'Tacuarembo\r'),
(4169, 'Uruguay', 'Treinta y Tres\r'),
(4170, 'United States', 'Alabama\r'),
(4171, 'United States', 'Alaska\r'),
(4172, 'United States', 'Arizona\r'),
(4173, 'United States', 'Arkansas\r'),
(4174, 'United States', 'California\r'),
(4175, 'United States', 'Colorado\r'),
(4176, 'United States', 'Connecticut\r'),
(4177, 'United States', 'Delaware\r'),
(4178, 'United States', 'District of Columbia\r'),
(4179, 'United States', 'Florida\r'),
(4180, 'United States', 'Georgia\r'),
(4181, 'United States', 'Hawaii\r'),
(4182, 'United States', 'Idaho\r'),
(4183, 'United States', 'Illinois\r'),
(4184, 'United States', 'Indiana\r'),
(4185, 'United States', 'Iowa\r'),
(4186, 'United States', 'Kansas\r'),
(4187, 'United States', 'Kentucky\r'),
(4188, 'United States', 'Louisiana\r'),
(4189, 'United States', 'Maine\r'),
(4190, 'United States', 'Maryland\r'),
(4191, 'United States', 'Massachusetts\r'),
(4192, 'United States', 'Michigan\r'),
(4193, 'United States', 'Minnesota\r'),
(4194, 'United States', 'Mississippi\r'),
(4195, 'United States', 'Missouri\r'),
(4196, 'United States', 'Montana\r'),
(4197, 'United States', 'Nebraska\r'),
(4198, 'United States', 'Nevada\r'),
(4199, 'United States', 'New Hampshire\r'),
(4200, 'United States', 'New Jersey\r'),
(4201, 'United States', 'New Mexico\r'),
(4202, 'United States', 'New York\r'),
(4203, 'United States', 'North Carolina\r'),
(4204, 'United States', 'North Dakota\r'),
(4205, 'United States', 'Ohio\r'),
(4206, 'United States', 'Oklahoma\r'),
(4207, 'United States', 'Oregon\r'),
(4208, 'United States', 'Pennsylvania\r'),
(4209, 'United States', 'Rhode Island\r'),
(4210, 'United States', 'South Carolina\r'),
(4211, 'United States', 'South Dakota\r'),
(4212, 'United States', 'Tennessee\r'),
(4213, 'United States', 'Texas\r'),
(4214, 'United States', 'Utah\r'),
(4215, 'United States', 'Vermont\r'),
(4216, 'United States', 'Virginia\r'),
(4217, 'United States', 'Washington\r'),
(4218, 'United States', 'West Virginia\r'),
(4219, 'United States', 'Wisconsin\r'),
(4220, 'United States', 'Wyoming\r'),
(4221, 'Uzbekistan', 'Andijon Wiloyati\r'),
(4222, 'Uzbekistan', 'Bukhoro Wiloyati\r'),
(4223, 'Uzbekistan', 'Farghona Wiloyati\r'),
(4224, 'Uzbekistan', 'Jizzakh Wiloyati\r'),
(4225, 'Uzbekistan', 'Khorazm Wiloyati (Urganch)\r'),
(4226, 'Uzbekistan', 'Namangan Wiloyati\r'),
(4227, 'Uzbekistan', 'Nawoiy Wiloyati\r'),
(4228, 'Uzbekistan', 'Qashqadaryo Wiloyati (Qarshi)\r'),
(4229, 'Uzbekistan', 'Qoraqalpoghiston (Nukus)\r'),
(4230, 'Uzbekistan', 'Samarqand Wiloyati\r'),
(4231, 'Uzbekistan', 'Sirdaryo Wiloyati (Guliston)\r'),
(4232, 'Uzbekistan', 'Surkhondaryo Wiloyati (Termiz)\r'),
(4233, 'Uzbekistan', 'Toshkent Shahri\r'),
(4234, 'Uzbekistan', 'Toshkent Wiloyati\r'),
(4235, 'Vanuatu', 'Malampa\r'),
(4236, 'Vanuatu', 'Penama\r'),
(4237, 'Vanuatu', 'Sanma\r'),
(4238, 'Vanuatu', 'Shefa\r'),
(4239, 'Vanuatu', 'Tafea\r'),
(4240, 'Vanuatu', 'Torba\r'),
(4241, 'Venezuela', 'Amazonas\r'),
(4242, 'Venezuela', 'Anzoategui\r'),
(4243, 'Venezuela', 'Apure\r'),
(4244, 'Venezuela', 'Aragua\r'),
(4245, 'Venezuela', 'Barinas\r'),
(4246, 'Venezuela', 'Bolivar\r'),
(4247, 'Venezuela', 'Carabobo\r'),
(4248, 'Venezuela', 'Cojedes\r'),
(4249, 'Venezuela', 'Delta Amacuro\r'),
(4250, 'Venezuela', 'Dependencias Federales\r'),
(4251, 'Venezuela', 'Distrito Federal\r'),
(4252, 'Venezuela', 'Falcon\r'),
(4253, 'Venezuela', 'Guarico\r'),
(4254, 'Venezuela', 'Lara\r'),
(4255, 'Venezuela', 'Merida\r'),
(4256, 'Venezuela', 'Miranda\r'),
(4257, 'Venezuela', 'Monagas\r'),
(4258, 'Venezuela', 'Nueva Esparta\r'),
(4259, 'Venezuela', 'Portuguesa\r'),
(4260, 'Venezuela', 'Sucre\r'),
(4261, 'Venezuela', 'Tachira\r'),
(4262, 'Venezuela', 'Trujillo\r'),
(4263, 'Venezuela', 'Vargas\r'),
(4264, 'Venezuela', 'Yaracuy\r'),
(4265, 'Venezuela', 'Zulia\r'),
(4266, 'Vietnam', 'An Giang\r'),
(4267, 'Vietnam', 'Ba Ria-Vung Tau\r'),
(4268, 'Vietnam', 'Bac Giang\r'),
(4269, 'Vietnam', 'Bac Kan\r'),
(4270, 'Vietnam', 'Bac Lieu\r'),
(4271, 'Vietnam', 'Bac Ninh\r'),
(4272, 'Vietnam', 'Ben Tre\r'),
(4273, 'Vietnam', 'Binh Dinh\r'),
(4274, 'Vietnam', 'Binh Duong\r'),
(4275, 'Vietnam', 'Binh Phuoc\r'),
(4276, 'Vietnam', 'Binh Thuan\r'),
(4277, 'Vietnam', 'Ca Mau\r'),
(4278, 'Vietnam', 'Can Tho\r'),
(4279, 'Vietnam', 'Cao Bang\r'),
(4280, 'Vietnam', 'Da Nang\r'),
(4281, 'Vietnam', 'Dac Lak\r'),
(4282, 'Vietnam', 'Dong Nai\r'),
(4283, 'Vietnam', 'Dong Thap\r'),
(4284, 'Vietnam', 'Gia Lai\r'),
(4285, 'Vietnam', 'Ha Giang\r'),
(4286, 'Vietnam', 'Ha Nam\r'),
(4287, 'Vietnam', 'Ha Noi\r'),
(4288, 'Vietnam', 'Ha Tay\r'),
(4289, 'Vietnam', 'Ha Tinh\r'),
(4290, 'Vietnam', 'Hai Duong\r'),
(4291, 'Vietnam', 'Hai Phong\r'),
(4292, 'Vietnam', 'Ho Chi Minh\r'),
(4293, 'Vietnam', 'Hoa Binh\r'),
(4294, 'Vietnam', 'Hung Yen\r'),
(4295, 'Vietnam', 'Khanh Hoa\r'),
(4296, 'Vietnam', 'Kien Giang\r'),
(4297, 'Vietnam', 'Kon Tum\r'),
(4298, 'Vietnam', 'Lai Chau\r'),
(4299, 'Vietnam', 'Lam Dong\r'),
(4300, 'Vietnam', 'Lang Son\r'),
(4301, 'Vietnam', 'Lao Cai\r'),
(4302, 'Vietnam', 'Long An\r'),
(4303, 'Vietnam', 'Nam Dinh\r'),
(4304, 'Vietnam', 'Nghe An\r'),
(4305, 'Vietnam', 'Ninh Binh\r'),
(4306, 'Vietnam', 'Ninh Thuan\r'),
(4307, 'Vietnam', 'Phu Tho\r'),
(4308, 'Vietnam', 'Phu Yen\r'),
(4309, 'Vietnam', 'Quang Binh\r'),
(4310, 'Vietnam', 'Quang Nam\r'),
(4311, 'Vietnam', 'Quang Ngai\r'),
(4312, 'Vietnam', 'Quang Ninh\r'),
(4313, 'Vietnam', 'Quang Tri\r'),
(4314, 'Vietnam', 'Soc Trang\r'),
(4315, 'Vietnam', 'Son La\r'),
(4316, 'Vietnam', 'Tay Ninh\r'),
(4317, 'Vietnam', 'Thai Binh\r'),
(4318, 'Vietnam', 'Thai Nguyen\r'),
(4319, 'Vietnam', 'Thanh Hoa\r'),
(4320, 'Vietnam', 'Thua Thien-Hue\r'),
(4321, 'Vietnam', 'Tien Giang\r'),
(4322, 'Vietnam', 'Tra Vinh\r'),
(4323, 'Vietnam', 'Tuyen Quang\r'),
(4324, 'Vietnam', 'Vinh Long\r'),
(4325, 'Vietnam', 'Vinh Phuc\r'),
(4326, 'Vietnam', 'Yen Bai\r'),
(4327, 'Virgin Islands', 'Saint Croix\r'),
(4328, 'Virgin Islands', 'Saint John\r'),
(4329, 'Virgin Islands', 'Saint Thomas\r'),
(4330, 'Wales', 'Blaenau Gwent\r'),
(4331, 'Wales', 'Bridgend\r'),
(4332, 'Wales', 'Caerphilly\r'),
(4333, 'Wales', 'Cardiff\r'),
(4334, 'Wales', 'Carmarthenshire\r'),
(4335, 'Wales', 'Ceredigion\r'),
(4336, 'Wales', 'Conwy\r'),
(4337, 'Wales', 'Denbighshire\r'),
(4338, 'Wales', 'Flintshire\r'),
(4339, 'Wales', 'Gwynedd\r'),
(4340, 'Wales', 'Isle of Anglesey\r'),
(4341, 'Wales', 'Merthyr Tydfil\r'),
(4342, 'Wales', 'Monmouthshire\r'),
(4343, 'Wales', 'Neath Port Talbot\r'),
(4344, 'Wales', 'Newport\r'),
(4345, 'Wales', 'Pembrokeshire\r'),
(4346, 'Wales', 'Powys\r'),
(4347, 'Wales', 'Rhondda Cynon Taff\r'),
(4348, 'Wales', 'Swansea\r'),
(4349, 'Wales', 'The Vale of Glamorgan\r'),
(4350, 'Wales', 'Torfaen\r'),
(4351, 'Wales', 'Wrexham\r'),
(4352, 'Wallis and Futuna', 'Alo\r'),
(4353, 'Wallis and Futuna', 'Sigave\r'),
(4354, 'Wallis and Futuna', 'Wallis\r'),
(4355, 'West Bank', 'West Bank\r'),
(4356, 'Western Sahara', 'Western Sahara\r'),
(4357, 'Yemen', 'Adan\r'),
(4358, 'Yemen', 'Ataq\r'),
(4359, 'Yemen', 'Abyan\r'),
(4360, 'Yemen', 'Al Bayda\r'),
(4361, 'Yemen', 'Al Hudaydah\r'),
(4362, 'Yemen', 'Al Jawf\r'),
(4363, 'Yemen', 'Al Mahrah\r'),
(4364, 'Yemen', 'Al Mahwit\r'),
(4365, 'Yemen', 'Dhamar\r'),
(4366, 'Yemen', 'Hadhramawt\r'),
(4367, 'Yemen', 'Hajjah\r'),
(4368, 'Yemen', 'Ibb\r'),
(4369, 'Yemen', 'Lahij\r'),
(4370, 'Yemen', 'Marib\r'),
(4371, 'Yemen', 'Sadah\r'),
(4372, 'Yemen', 'Sana\r'),
(4373, 'Yemen', 'Taizz\r'),
(4374, 'Yugoslavia', 'Kosovo\r'),
(4375, 'Yugoslavia', 'Montenegro\r'),
(4376, 'Yugoslavia', 'Serbia\r'),
(4377, 'Yugoslavia', 'Vojvodina\r'),
(4378, 'Zambia', 'Central\r'),
(4379, 'Zambia', 'Copperbelt\r'),
(4380, 'Zambia', 'Eastern\r'),
(4381, 'Zambia', 'Luapula\r'),
(4382, 'Zambia', 'Lusaka\r'),
(4383, 'Zambia', 'North-Western\r'),
(4384, 'Zambia', 'Northern\r'),
(4385, 'Zambia', 'Southern\r'),
(4386, 'Zambia', 'Western\r'),
(4387, 'Zimbabwe', 'Bulawayo\r'),
(4388, 'Zimbabwe', 'Harare\r'),
(4389, 'Zimbabwe', 'ManicalandMashonaland Central\r'),
(4390, 'Zimbabwe', 'Mashonaland East\r'),
(4391, 'Zimbabwe', 'Mashonaland West\r'),
(4392, 'Zimbabwe', 'Masvingo\r'),
(4393, 'Zimbabwe', 'Matabeleland North\r'),
(4394, 'Zimbabwe', 'Matabeleland South\r'),
(4395, 'Zimbabwe', 'Midlands\r'),
(4409, 'Malaysia', 'Pulau Pinang'),
(4410, 'Malaysia', 'Kuala Lumpur');

-- --------------------------------------------------------

--
-- Table structure for table `stock_adjustment`
--

CREATE TABLE `stock_adjustment` (
  `id` int(11) NOT NULL,
  `datetime` datetime DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_sku` varchar(128) DEFAULT NULL,
  `item_name` varchar(128) DEFAULT NULL,
  `previous_qty` int(11) DEFAULT NULL,
  `new_qty` int(11) DEFAULT NULL,
  `remarks` text,
  `warehouse_id` int(11) DEFAULT NULL,
  `performed_by` varchar(128) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `stock_count`
--

CREATE TABLE `stock_count` (
  `id` int(11) NOT NULL,
  `event` text,
  `date` datetime DEFAULT NULL,
  `remarks` text,
  `status` varchar(32) DEFAULT NULL,
  `positive_deviation` varchar(32) DEFAULT NULL,
  `negative_deviation` varchar(32) DEFAULT NULL,
  `total_positive_mismatch` int(11) DEFAULT NULL,
  `total_negative_mismatch` int(11) DEFAULT NULL,
  `total_counted` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `stock_count_items`
--

CREATE TABLE `stock_count_items` (
  `id` int(11) NOT NULL,
  `count_id` int(11) DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_name` varchar(128) DEFAULT NULL,
  `item_cost` decimal(20,2) DEFAULT NULL,
  `item_price` decimal(20,2) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `discrepancy` int(11) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `username` varchar(32) DEFAULT NULL,
  `processed_qty` int(11) DEFAULT NULL,
  `processed_discrepancy` int(11) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `subscription`
--

CREATE TABLE `subscription` (
  `id` int(11) UNSIGNED NOT NULL,
  `from_date` date DEFAULT NULL,
  `to_date` date DEFAULT NULL,
  `key` varchar(128) DEFAULT NULL,
  `hash` varchar(128) DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `system_transactions`
--

CREATE TABLE `system_transactions` (
  `id` int(11) UNSIGNED NOT NULL,
  `module` varchar(128) DEFAULT NULL,
  `action` varchar(128) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `record_id` int(11) DEFAULT NULL,
  `record_data` text,
  `datetime` datetime DEFAULT NULL,
  `performed_by` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `system_transactions`
--

INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(1, 'masuk', 'do', 'item', 0, '"841231"', '2012-11-17 08:38:39', 'admin'),
(2, '1', 'edit', 'item', 0, '"test"', '2012-11-17 08:38:39', 'admin'),
(3, 'marital', 'Single', 'item', 0, '"test"', '2012-11-17 08:38:39', 'admin'),
(4, 'gender', 'Female', 'item', 0, '"test"', '2012-11-17 08:38:39', 'admin'),
(5, 'ic', '841231', 'item', 0, '"test"', '2012-11-17 08:38:39', 'admin'),
(6, 'blood_type', 'A', 'item', 0, '"test"', '2012-11-17 08:38:39', 'admin'),
(7, 'weight', 'B', 'item', 0, '"test"', '2012-11-17 08:38:39', 'admin'),
(8, 'height', '', 'item', 0, '"test"', '2012-11-17 08:38:39', 'admin'),
(9, 'allergy', '', 'item', 0, '"test"', '2012-11-17 08:38:39', 'admin'),
(10, 'spouse_ic', '', 'item', 0, '"test"', '2012-11-17 08:38:39', 'admin'),
(11, '2', 'edit', 'item', 0, '"test"', '2012-11-17 08:38:39', 'admin'),
(12, '3', 'edit', 'item', 0, '"test"', '2012-11-17 08:38:39', 'admin'),
(13, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14, 'check', 'edit', 'item', 0, '""', '2012-11-17 08:42:17', 'admin'),
(15, 'check', 'edit', 'item', 0, '""', '2012-11-17 08:42:25', 'admin'),
(16, '3', 'add', 'item', 0, '"test"', '2012-11-17 08:43:13', 'admin'),
(17, 'check', 'edit', 'item', 0, '""', '2012-11-17 08:43:15', 'admin'),
(18, 'masuk', 'do', 'item', 0, '"820921086022"', '2012-11-17 08:52:31', 'admin'),
(19, '1', 'edit', 'item', 0, '"test"', '2012-11-17 08:52:31', 'admin'),
(20, 'marital', 'Married', 'item', 0, '"test"', '2012-11-17 08:52:31', 'admin'),
(21, 'gender', 'Male', 'item', 0, '"test"', '2012-11-17 08:52:31', 'admin'),
(22, 'ic', '820921086022', 'item', 0, '"test"', '2012-11-17 08:52:31', 'admin'),
(23, 'blood_type', 'A', 'item', 0, '"test"', '2012-11-17 08:52:31', 'admin'),
(24, 'weight', '65kg', 'item', 0, '"test"', '2012-11-17 08:52:31', 'admin'),
(25, 'height', '175cm', 'item', 0, '"test"', '2012-11-17 08:52:31', 'admin'),
(26, 'allergy', '', 'item', 0, '"test"', '2012-11-17 08:52:31', 'admin'),
(27, 'spouse_ic', '', 'item', 0, '"test"', '2012-11-17 08:52:31', 'admin'),
(28, '2', 'edit', 'item', 0, '"test"', '2012-11-17 08:52:31', 'admin'),
(29, '3', 'edit', 'item', 0, '"test"', '2012-11-17 08:52:31', 'admin'),
(30, 'check', 'edit', 'item', 0, '""', '2012-11-17 17:44:33', 'admin'),
(31, 'check', 'edit', 'item', 0, '""', '2012-11-17 17:44:55', 'admin'),
(32, 'check', 'edit', 'item', 0, '""', '2012-11-17 17:59:08', 'admin'),
(33, '3', 'add', 'item', 0, '"test"', '2012-11-17 17:59:49', 'admin'),
(34, 'check', 'edit', 'item', 0, '""', '2012-11-17 17:59:51', 'admin'),
(35, 'check', 'edit', 'item', 0, '""', '2012-11-17 18:00:05', 'admin'),
(36, 'inventory', 'delete', 'item', 23, '{"id":"23","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Lenovo All-in-one Touch","model_no":"","warranty":"","sku":"002","sku2":"","sku3":"","sku4":"","qty":10,"alert_quantity":"2","max_quantity":"0","cost":"1600.0000","average_cost":null,"price":"2860.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-10-04 14:48:55","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2012-11-17 18:29:23","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null}', '2012-11-18 00:01:43', 'admin'),
(37, 'inventory', 'delete', 'item', 24, '{"id":"24","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Thermal Printer","model_no":"","warranty":"","sku":"003","sku2":"","sku3":"","sku4":"","qty":10,"alert_quantity":"2","max_quantity":"0","cost":"700.0000","average_cost":null,"price":"880.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-10-04 14:51:07","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null}', '2012-11-18 00:01:47', 'admin'),
(38, 'inventory', 'delete', 'item', 25, '{"id":"25","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Barcode Scanner","model_no":"","warranty":"","sku":"004","sku2":"","sku3":"","sku4":"","qty":10,"alert_quantity":"2","max_quantity":"0","cost":"330.0000","average_cost":null,"price":"380.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-10-04 14:51:43","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null}', '2012-11-18 00:01:50', 'admin'),
(39, 'inventory', 'delete', 'item', 29, '{"id":"29","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"XP Operating System","model_no":"","warranty":"","sku":"008","sku2":"","sku3":"","sku4":"","qty":10,"alert_quantity":"1","max_quantity":"0","cost":"300.0000","average_cost":null,"price":"330.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-10-04 14:54:19","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null}', '2012-11-18 00:01:54', 'admin'),
(40, 'inventory', 'delete', 'item', 30, '{"id":"30","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"adsda","model_no":"","warranty":"","sku":"989","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"2","max_quantity":"0","cost":"1.0000","average_cost":null,"price":"2.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-10 16:48:51","added_by":"admin","modified_on":"2012-11-10 16:49:30","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null}', '2012-11-18 00:01:58', 'admin'),
(41, 'inventory', 'delete', 'item', 20, '{"id":"20","primary_image":null,"image":null,"category":"Household","subcategory":"Grocery","brand":"Nestle","location":"","name":"Milo 3.2KG X 6","model_no":"","warranty":"","sku":"987654321","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"10","max_quantity":"0","cost":"156.0000","average_cost":null,"price":"172.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-09-26 20:44:04","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"BOX","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"16.00","weight_unit":"kg","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2012-11-17 08:32:08","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null}', '2012-11-18 00:02:02', 'admin'),
(42, 'inventory', 'delete', 'item', 21, '{"id":"21","primary_image":null,"image":null,"category":"Household","subcategory":"Grocery","brand":"Nestle","location":"","name":"Nescaf\\u00e9 200GM","model_no":"","warranty":"","sku":"232323","sku2":"232388","sku3":"","sku4":"","qty":0,"alert_quantity":"10","max_quantity":"0","cost":"8.5000","average_cost":null,"price":"11.00","price_2":"0.00","price_3":"0.00","price2":"130.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-09-30 12:29:09","added_by":"admin","modified_on":"2012-09-30 12:33:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"1","uom2":"CTN","uom3":"","uom4":"","loose_qty2":"12","loose_qty3":"0","loose_qty4":"0","weight":"200.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null}', '2012-11-18 00:02:05', 'admin'),
(43, 'inventory', 'delete', 'item', NULL, '[]', '2012-11-18 00:02:16', 'admin'),
(44, 'inventory', 'delete', 'item', 22, '{"id":"22","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Industrial Touch POS Terminal","model_no":"","warranty":"","sku":"001","sku2":"","sku3":"","sku4":"","qty":10,"alert_quantity":"2","max_quantity":"0","cost":"3200.0000","average_cost":null,"price":"3860.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-10-04 14:47:18","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null}', '2012-11-18 00:02:19', 'admin'),
(45, 'inventory', 'delete', 'item', 28, '{"id":"28","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Magnetic Card Reader","model_no":"","warranty":"","sku":"007","sku2":"","sku3":"","sku4":"","qty":10,"alert_quantity":"1","max_quantity":"0","cost":"200.0000","average_cost":null,"price":"250.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-10-04 14:53:40","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null}', '2012-11-18 00:02:22', 'admin'),
(46, 'inventory', 'delete', 'item', 31, '{"id":"31","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"aaaa","model_no":"","warranty":"","sku":"9090","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"8","max_quantity":"0","cost":"1.0000","average_cost":null,"price":"4.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-10 16:52:13","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null}', '2012-11-18 00:02:28', 'admin'),
(47, 'inventory', 'delete', 'item', 27, '{"id":"27","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Pole Display(Customer Price Display)","model_no":"","warranty":"","sku":"006","sku2":"","sku3":"","sku4":"","qty":10,"alert_quantity":"2","max_quantity":"0","cost":"250.0000","average_cost":null,"price":"280.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-10-04 14:53:13","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null}', '2012-11-18 00:02:36', 'admin'),
(48, 'inventory', 'delete', 'item', 32, '{"id":"32","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Madu","model_no":"","warranty":"","sku":"M101","sku2":"","sku3":"","sku4":"","qty":100,"alert_quantity":"1","max_quantity":"0","cost":"1.0000","average_cost":null,"price":"2.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-16 20:45:42","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2012-11-17 22:43:23","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null}', '2012-11-18 00:02:39', 'admin'),
(49, 'inventory', 'delete', 'item', 26, '{"id":"26","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Cash Drawer","model_no":"","warranty":"","sku":"005","sku2":"","sku3":"","sku4":"","qty":10,"alert_quantity":"3","max_quantity":"0","cost":"360.0000","average_cost":null,"price":"380.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-10-04 14:52:23","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null}', '2012-11-18 00:02:43', 'admin'),
(50, 'inventory', 'add', 'item', NULL, '[]', '2012-11-18 00:03:59', 'admin'),
(51, 'inventory', 'add', 'item', NULL, '[]', '2012-11-18 00:04:39', 'admin'),
(52, 'inventory', 'add', 'item', NULL, '[]', '2012-11-18 00:05:12', 'admin'),
(53, 'inventory', 'add', 'item', NULL, '[]', '2012-11-18 00:06:03', 'admin'),
(54, 'contacts', 'edit', 'contact', 1081, '{"id":"1081","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Aminah Bt Din","contact_number":"0","credit_limit":"0.00","rank":"Agent Member","email":"","ic":"4321","password":null,"introducer_ic":null,"address1":"22 Jalan Melaka","address2":"","city":"Ipoh","state":"Perak","zipcode":"14293","country":"Malaysia","tel":"0143078646","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-11-17 17:59:49","added_by":"admin","modified_on":"2012-11-18 00:09:06","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null}', '2012-11-18 00:09:06', 'admin'),
(55, 'contacts', 'edit', 'contact', 1081, '{"id":"1081","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Aminah Bt Din","contact_number":"0","credit_limit":"0.00","rank":"Agent Member","email":"","ic":"4321","password":null,"introducer_ic":null,"address1":"22 Jalan Melaka","address2":"","city":"Ipoh","state":"Perak","zipcode":"14293","country":"Malaysia","tel":"0143078646","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-11-17 17:59:49","added_by":"admin","modified_on":"2012-11-18 00:12:01","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null}', '2012-11-18 00:12:01', 'admin'),
(56, 'inventory', 'edit', 'item', 33, '{"id":"33","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"HA1","model_no":"","warranty":"","sku":"101","sku2":"","sku3":"","sku4":"","qty":100,"alert_quantity":"5","max_quantity":"0","cost":"27.5000","average_cost":null,"price":"50.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:03:59","added_by":"admin","modified_on":"2012-11-18 00:13:10","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null}', '2012-11-18 00:13:10', 'admin'),
(57, 'inventory', 'edit', 'item', 33, '{"id":"33","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"HA1","model_no":"","warranty":"","sku":"101","sku2":"","sku3":"","sku4":"","qty":100,"alert_quantity":"5","max_quantity":"0","cost":"27.5000","average_cost":null,"price":"50.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:03:59","added_by":"admin","modified_on":"2012-11-18 00:14:17","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null}', '2012-11-18 00:14:17', 'admin'),
(58, 'inventory', 'add', 'item', NULL, '[]', '2012-11-18 00:16:16', 'admin'),
(59, 'inventory', 'add', 'item', NULL, '[]', '2012-11-18 00:16:49', 'admin'),
(60, 'inventory', 'add', 'item', NULL, '[]', '2012-11-18 00:17:21', 'admin'),
(61, 'inventory', 'add', 'item', NULL, '[]', '2012-11-18 00:17:46', 'admin'),
(62, 'inventory', 'add', 'item', NULL, '[]', '2012-11-18 00:18:14', 'admin'),
(63, 'inventory', 'edit', 'item', 33, '{"id":"33","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"HA1","model_no":"","warranty":"","sku":"101","sku2":"","sku3":"","sku4":"","qty":100,"alert_quantity":"5","max_quantity":"0","cost":"27.5000","average_cost":null,"price":"50.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:03:59","added_by":"admin","modified_on":"2012-11-18 00:18:46","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"350.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null}', '2012-11-18 00:18:46', 'admin'),
(64, 'inventory', 'edit', 'item', 34, '{"id":"34","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"HA2","model_no":"","warranty":"","sku":"102","sku2":"","sku3":"","sku4":"","qty":100,"alert_quantity":"5","max_quantity":"0","cost":"27.5000","average_cost":null,"price":"50.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-11-18 00:04:39","added_by":"admin","modified_on":"2012-11-18 00:19:05","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"350.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null}', '2012-11-18 00:19:05', 'admin'),
(65, 'inventory', 'edit', 'item', 35, '{"id":"35","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"UPB","model_no":"","warranty":"","sku":"103","sku2":"","sku3":"","sku4":"","qty":100,"alert_quantity":"9","max_quantity":"0","cost":"27.5000","average_cost":null,"price":"50.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-11-18 00:05:12","added_by":"admin","modified_on":"2012-11-18 00:19:17","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"350.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null}', '2012-11-18 00:19:17', 'admin'),
(66, 'sales', 'add', 'so', 10008, '{"id":"10008","quote_id":"0","invoice_id":null,"number":"0","po_number":"0","date":"2012-11-21 00:00:00","due_date":"2012-11-25 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"100.00","total_delivered":null,"cost":null,"tags":"","added_on":"2012-11-21 10:46:21","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"4","assigned_to":null,"notification":null,"orders":[{"id":"10","sales_order_id":"10008","type":"product","date":"2012-11-21 00:00:00","item_name":"HA1","item_description":"","item_id":"33","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"50.0000","price":"50.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"4"},{"id":"11","sales_order_id":"10008","type":"product","date":"2012-11-21 00:00:00","item_name":"HA2","item_description":"","item_id":"34","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"50.0000","price":"50.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"4"}],"products":{"33":{"id":"33","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"HA1","model_no":"","warranty":"","sku":"101","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"5","max_quantity":"0","cost":"27.5000","average_cost":null,"price":"50.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:03:59","added_by":"admin","modified_on":"2012-11-18 00:18:46","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"350.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2012-11-18 11:08:18","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null},"34":{"id":"34","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"HA2","model_no":"","warranty":"","sku":"102","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"5","max_quantity":"0","cost":"27.5000","average_cost":null,"price":"50.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-11-18 00:04:39","added_by":"admin","modified_on":"2012-11-18 00:19:05","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"350.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null}},"services":null}', '2012-11-21 10:46:21', 'admin'),
(67, 'sales', 'status_update', 'so', 10008, '{"id":"10008","quote_id":"0","invoice_id":null,"number":"0","po_number":"0","date":"2012-11-21 00:00:00","due_date":"2012-11-25 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Completed","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"100.00","total_delivered":null,"cost":null,"tags":"","added_on":"2012-11-21 10:46:21","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"4","assigned_to":null,"notification":null,"orders":[{"id":"10","sales_order_id":"10008","type":"product","date":"2012-11-21 00:00:00","item_name":"HA1","item_description":"","item_id":"33","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"50.0000","price":"50.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"4"},{"id":"11","sales_order_id":"10008","type":"product","date":"2012-11-21 00:00:00","item_name":"HA2","item_description":"","item_id":"34","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"50.0000","price":"50.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"4"}],"products":{"33":{"id":"33","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"HA1","model_no":"","warranty":"","sku":"101","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"5","max_quantity":"0","cost":"27.5000","average_cost":null,"price":"50.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:03:59","added_by":"admin","modified_on":"2012-11-18 00:18:46","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"350.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2012-11-18 11:08:18","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null},"34":{"id":"34","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"HA2","model_no":"","warranty":"","sku":"102","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"5","max_quantity":"0","cost":"27.5000","average_cost":null,"price":"50.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-11-18 00:04:39","added_by":"admin","modified_on":"2012-11-18 00:19:05","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"350.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null}},"services":null}', '2012-11-21 10:47:14', 'admin'),
(68, 'sales', 'add', 'invoice', 10009, '{"id":"10009","quote_id":"0","sales_order_id":"10008","number":"0","po_number":"0","date":"2012-11-21 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"100.00","total_delivered":null,"cost":null,"tags":"","added_on":"2012-11-21 10:52:18","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"4","assigned_to":null,"notification":null,"orders":[{"id":"25","invoice_id":"10009","type":"product","date":"2012-11-21 12:00:00","item_name":"HA1","item_description":"","item_id":"33","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"50.0000","price":"50.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"4"},{"id":"26","invoice_id":"10009","type":"product","date":"2012-11-21 12:00:00","item_name":"HA2","item_description":"","item_id":"34","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"50.0000","price":"50.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"4"}],"products":{"33":{"id":"33","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"HA1","model_no":"","warranty":"","sku":"101","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"5","max_quantity":"0","cost":"27.5000","average_cost":null,"price":"50.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:03:59","added_by":"admin","modified_on":"2012-11-18 00:18:46","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"350.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2012-11-18 11:08:18","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null},"34":{"id":"34","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"HA2","model_no":"","warranty":"","sku":"102","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"5","max_quantity":"0","cost":"27.5000","average_cost":null,"price":"50.00","price_2":"0.00","price_3":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-11-18 00:04:39","added_by":"admin","modified_on":"2012-11-18 00:19:05","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"350.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":null,"is_debtor":null,"is_creditor":null,"is_member":"1","is_stakeholder":null,"is_franchise":null,"is_franchisee":null,"company_name":null,"company_registration":null,"contact_person":"azad","contact_number":"9191","credit_limit":null,"rank":null,"email":"zadwani@gmail.com","ic":"123","password":"5ce75bba6298a10e403e09672cf79b5a","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":null,"fax":null,"general_email":"zadwani@gmail.com","terms":null,"description":null,"remarks":null,"tags":"Online Customer,Unverified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":null,"modified_by":null,"status":null,"user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null},"sale":null,"sale_items":null}', '2012-11-21 10:52:18', 'admin'),
(69, 'inventory', 'edit', 'item', 41, '{"id":"41","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"MKM","model_no":"","warranty":"","sku":"205","sku2":"2051","sku3":"2052","sku4":"","qty":104,"alert_quantity":"4","max_quantity":"0","cost":"0.4000","average_cost":null,"price":"1.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:18:14","added_by":"admin","modified_on":"2012-11-27 18:03:47","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"pc","uom2":"strip","uom3":"box","uom4":"","loose_qty2":"12","loose_qty3":"60","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2012-11-27 17:42:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null}', '2012-11-27 18:03:47', 'admin'),
(70, 'inventory', 'add', 'po', 10004, '{"id":"10004","invoice_number":"","number":null,"date":"2012-12-01 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"azad","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop 1\\",\\"mobile\\":\\"+604 - 425 2500\\",\\"address1\\":\\"No. 91, Jalan Lagenda 1\\",\\"address2\\":\\"Lagenda Height\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2012-12-01 11:13:24","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"2","assigned_to":null,"orders":[{"id":"33","purchase_order_id":"10004","date":"2012-12-01 00:00:00","item_description":null,"item_name":"MKM ()","item_id":"41","discount":"0","discount_type":null,"qty":"10","price_per_unit":"0.2000","price":"2.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"2"}],"products":{"41":{"id":"41","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"MKM","model_no":"","warranty":"","sku":"205","sku2":"2051","sku3":"2052","sku4":"","qty":0,"alert_quantity":"4","max_quantity":"0","cost":"0.4000","average_cost":null,"price":"1.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:18:14","added_by":"admin","modified_on":"2012-11-27 18:03:47","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"pc","uom2":"strip","uom3":"box","uom4":"","loose_qty2":"12","loose_qty3":"60","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2012-12-01 10:18:25","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null}}}', '2012-12-01 11:13:24', 'admin'),
(71, 'inventory', 'status_update', 'po', 10004, '{"id":"10004","invoice_number":"","number":null,"date":"2012-12-01 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"azad","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop 1\\",\\"mobile\\":\\"+604 - 425 2500\\",\\"address1\\":\\"No. 91, Jalan Lagenda 1\\",\\"address2\\":\\"Lagenda Height\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2012-12-01 11:13:24","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"2","assigned_to":null,"orders":[{"id":"33","purchase_order_id":"10004","date":"2012-12-01 00:00:00","item_description":null,"item_name":"MKM ()","item_id":"41","discount":"0","discount_type":null,"qty":"10","price_per_unit":"0.2000","price":"2.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"2"}],"products":{"41":{"id":"41","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"MKM","model_no":"","warranty":"","sku":"205","sku2":"2051","sku3":"2052","sku4":"","qty":0,"alert_quantity":"4","max_quantity":"0","cost":"0.4000","average_cost":null,"price":"1.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:18:14","added_by":"admin","modified_on":"2012-11-27 18:03:47","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"pc","uom2":"strip","uom3":"box","uom4":"","loose_qty2":"12","loose_qty3":"60","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2012-12-01 10:18:25","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null}}}', '2012-12-01 11:13:34', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(72, 'inventory', 'receive', 'po', 10004, '{"id":"10004","invoice_number":"","number":null,"date":"2012-12-01 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"azad","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop 1\\",\\"mobile\\":\\"+604 - 425 2500\\",\\"address1\\":\\"No. 91, Jalan Lagenda 1\\",\\"address2\\":\\"Lagenda Height\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2.00","total_received":"2.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2012-12-01 11:13:24","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"2","assigned_to":null,"orders":[{"id":"33","purchase_order_id":"10004","date":"2012-12-01 00:00:00","item_description":null,"item_name":"MKM ()","item_id":"41","discount":"0","discount_type":null,"qty":"10","price_per_unit":"0.2000","price":"2.00","received":"10","received_price":"2.00","done":null,"division_id":null,"warehouse_id":"2"}],"products":{"41":{"id":"41","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"MKM","model_no":"","warranty":"","sku":"205","sku2":"2051","sku3":"2052","sku4":"","qty":10,"alert_quantity":"4","max_quantity":"0","cost":"0.2000","average_cost":null,"price":"1.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:18:14","added_by":"admin","modified_on":"2012-11-27 18:03:47","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"pc","uom2":"strip","uom3":"box","uom4":"","loose_qty2":"12","loose_qty3":"60","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2012-12-01 10:18:25","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null}}}', '2012-12-01 11:13:34', 'admin'),
(73, 'inventory', 'status_update', 'po', 10004, '{"id":"10004","invoice_number":"","number":null,"date":"2012-12-01 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"azad","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop 1\\",\\"mobile\\":\\"+604 - 425 2500\\",\\"address1\\":\\"No. 91, Jalan Lagenda 1\\",\\"address2\\":\\"Lagenda Height\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2.00","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2012-12-01 11:13:24","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"2","assigned_to":null,"orders":[{"id":"33","purchase_order_id":"10004","date":"2012-12-01 00:00:00","item_description":null,"item_name":"MKM ()","item_id":"41","discount":"0","discount_type":null,"qty":"10","price_per_unit":"0.2000","price":"2.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"2"}],"products":{"41":{"id":"41","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"MKM","model_no":"","warranty":"","sku":"205","sku2":"2051","sku3":"2052","sku4":"","qty":0,"alert_quantity":"4","max_quantity":"0","cost":"0.2000","average_cost":null,"price":"1.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:18:14","added_by":"admin","modified_on":"2012-11-27 18:03:47","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"pc","uom2":"strip","uom3":"box","uom4":"","loose_qty2":"12","loose_qty3":"60","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2012-12-01 10:18:25","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null}}}', '2012-12-01 11:15:30', 'admin'),
(74, 'inventory', 'status_update', 'po', 10003, '{"id":"10003","invoice_number":"","number":null,"date":"2012-10-24 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Shamir Adnan","supplier_id":"1013","supplier_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel Branch Sungai Petani\\",\\"mobile\\":\\"+604 - 425 2500\\",\\"address1\\":\\"No. 91, Jalan Lagenda 1\\",\\"address2\\":\\"Lagenda Height\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"5800.00","total_received":"0.00","payment_status":"Paid","payment_date":"2012-10-24 00:00:00","payment_reference":"78","payment_contra":null,"tags":"","added_on":"2012-10-24 21:18:20","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"2","assigned_to":null,"orders":[{"id":"15","purchase_order_id":"10003","date":"2012-10-24 00:00:00","item_description":null,"item_name":"Halagel\\u00ae Flax Seed Oil (120 pcs) ()","item_id":"16","discount":"0","discount_type":null,"qty":"200","price_per_unit":"29.0000","price":"5800.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"2"}],"products":{"16":[]}}', '2012-12-01 11:15:56', 'admin'),
(75, 'sales', 'add', 'quote', 10001, '{"id":"10001","txn_no":"5-10001","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2012-12-01 00:00:00","due_date":"2012-12-01 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"100.00","total_delivered":null,"cost":null,"tags":"","added_on":"2012-12-01 16:33:40","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"5","assigned_to":null,"orders":[{"id":"1","quote_id":"10001","date":"2012-12-01 00:00:00","type":"product","item_id":"33","service_id":"0","item_name":"HA1","item_description":"","discount":"0","discount_type":null,"qty":"1","price_per_unit":"50.0000","price":"50.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"5"},{"id":"2","quote_id":"10001","date":"2012-12-01 00:00:00","type":"product","item_id":"34","service_id":"0","item_name":"HA2","item_description":"","discount":"0","discount_type":null,"qty":"1","price_per_unit":"50.0000","price":"50.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"5"}],"products":{"33":{"id":"33","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"HA1","model_no":"","warranty":"","sku":"101","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"5","max_quantity":"0","cost":"27.5000","average_cost":null,"price":"50.00","price_2":"0.00","price_3":"0.00","price_4":null,"price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":null,"price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":null,"price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":null,"description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:03:59","added_by":"admin","modified_on":"2012-11-18 00:18:46","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"350.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2012-11-30 21:07:06","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null},"34":{"id":"34","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"HA2","model_no":"","warranty":"","sku":"102","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"5","max_quantity":"0","cost":"27.5000","average_cost":null,"price":"50.00","price_2":"0.00","price_3":"0.00","price_4":null,"price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":null,"price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":null,"price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":null,"description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-11-18 00:04:39","added_by":"admin","modified_on":"2012-11-18 00:19:05","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"350.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2012-12-01 10:11:06","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null}},"services":null}', '2012-12-01 16:33:40', 'admin'),
(76, 'sales', 'add', 'quote', 10002, '{"id":"10002","txn_no":"5-10002","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2012-12-01 00:00:00","due_date":"2012-12-02 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Solihin","contact_id":"1077","contact_address":"{\\"address1\\":\\"Mentakab\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"09000\\",\\"city\\":\\"Kulim\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Solihin\\",\\"mobile\\":\\"0143937632\\",\\"address1\\":\\"Mentakab\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"09000\\",\\"city\\":\\"Kulim\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"50.00","total_delivered":null,"cost":null,"tags":"","added_on":"2012-12-01 16:34:57","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"5","assigned_to":null,"orders":[{"id":"3","quote_id":"10002","date":"2012-12-01 00:00:00","type":"product","item_id":"34","service_id":"0","item_name":"HA2","item_description":"","discount":"0","discount_type":null,"qty":"1","price_per_unit":"50.0000","price":"50.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"5"}],"products":{"34":{"id":"34","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"HA2","model_no":"","warranty":"","sku":"102","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"5","max_quantity":"0","cost":"27.5000","average_cost":null,"price":"50.00","price_2":"0.00","price_3":"0.00","price_4":null,"price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":null,"price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":null,"price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":null,"description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-11-18 00:04:39","added_by":"admin","modified_on":"2012-11-18 00:19:05","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"350.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2012-12-01 10:11:06","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null}},"services":null}', '2012-12-01 16:34:57', 'admin'),
(77, 'sales', 'add', 'so', 10001, '{"id":"10001","txn_no":"5-10001","quote_id":"0","invoice_id":null,"number":"0","po_number":"0","date":"2012-12-01 00:00:00","due_date":"2012-12-02 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"250.00","total_delivered":null,"cost":null,"tags":"","added_on":"2012-12-01 18:13:03","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"5","assigned_to":null,"notification":null,"orders":[{"id":"1","sales_order_id":"10001","type":"product","date":"2012-12-01 00:00:00","item_name":"MKM","item_description":"","item_id":"41","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"50.0000","price":"50.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"5"},{"id":"2","sales_order_id":"10001","type":"product","date":"2012-12-01 00:00:00","item_name":"MMK","item_description":"","item_id":"40","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"50.0000","price":"50.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"5"},{"id":"3","sales_order_id":"10001","type":"product","date":"2012-12-01 00:00:00","item_name":"MR","item_description":"","item_id":"37","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"50.0000","price":"50.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"5"},{"id":"4","sales_order_id":"10001","type":"product","date":"2012-12-01 00:00:00","item_name":"MSS","item_description":"","item_id":"38","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"50.0000","price":"50.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"5"},{"id":"5","sales_order_id":"10001","type":"product","date":"2012-12-01 00:00:00","item_name":"MTL","item_description":"","item_id":"39","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"50.0000","price":"50.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"5"}],"products":{"41":{"id":"41","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"MKM","model_no":"","warranty":"","sku":"205","sku2":"2051","sku3":"2052","sku4":"","qty":0,"alert_quantity":"4","max_quantity":"0","cost":"27.5000","average_cost":null,"price":"50.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:18:14","added_by":"admin","modified_on":"2012-11-27 18:03:47","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"pc","uom2":"strip","uom3":"box","uom4":"","loose_qty2":"12","loose_qty3":"60","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2012-12-01 10:18:25","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null},"40":{"id":"40","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"MMK","model_no":"","warranty":"","sku":"204","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"5","max_quantity":"0","cost":"27.5000","average_cost":null,"price":"50.00","price_2":"0.00","price_3":"0.00","price_4":null,"price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":null,"price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":null,"price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":null,"description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:17:46","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null},"37":{"id":"37","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"MR","model_no":"","warranty":"","sku":"201","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"4","max_quantity":"0","cost":"27.5000","average_cost":null,"price":"50.00","price_2":"0.00","price_3":"0.00","price_4":null,"price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":null,"price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":null,"price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":null,"description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-11-18 00:16:16","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"bottle","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2012-11-18 11:08:18","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null},"38":{"id":"38","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"MSS","model_no":"","warranty":"","sku":"202","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"4","max_quantity":"0","cost":"27.5000","average_cost":null,"price":"50.00","price_2":"0.00","price_3":"0.00","price_4":null,"price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":null,"price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":null,"price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":null,"description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-11-18 00:16:49","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"bottle","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null},"39":{"id":"39","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"MTL","model_no":"","warranty":"","sku":"203","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"5","max_quantity":"0","cost":"27.5000","average_cost":null,"price":"50.00","price_2":"0.00","price_3":"0.00","price_4":null,"price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":null,"price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":null,"price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":null,"description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-11-18 00:17:21","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"bottle","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null}},"services":null}', '2012-12-01 18:13:03', 'admin'),
(78, 'inventory', 'edit', 'item', 41, '{"id":"41","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"MKM","model_no":"","warranty":"","sku":"205","sku2":"2051","sku3":"2052","sku4":"","qty":100,"alert_quantity":"4","max_quantity":"0","cost":"27.5000","average_cost":null,"price":"50.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:18:14","added_by":"admin","modified_on":"2012-12-01 19:01:44","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"pc","uom2":"strip","uom3":"box","uom4":"","loose_qty2":"12","loose_qty3":"60","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2012-12-01 10:18:25","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null}', '2012-12-01 19:01:44', 'admin'),
(79, 'inventory', 'edit', 'item', 41, '{"id":"41","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"MKM","model_no":"","warranty":"","sku":"205","sku2":"2051","sku3":"2052","sku4":"","qty":100,"alert_quantity":"4","max_quantity":"0","cost":"27.5000","average_cost":null,"price":"50.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:18:14","added_by":"admin","modified_on":"2012-12-01 19:04:16","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"pc","uom2":"strip","uom3":"box","uom4":"","loose_qty2":"12","loose_qty3":"60","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2012-12-01 10:18:25","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null}', '2012-12-01 19:04:16', 'admin'),
(80, 'inventory', 'edit', 'item', 41, '{"id":"41","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"MKM","model_no":"","warranty":"","sku":"205","sku2":"2051","sku3":"2052","sku4":"","qty":100,"alert_quantity":"4","max_quantity":"0","cost":"27.5000","average_cost":null,"price":"50.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:18:14","added_by":"admin","modified_on":"2012-12-01 19:05:08","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"pc","uom2":"strip","uom3":"box","uom4":"","loose_qty2":"12","loose_qty3":"60","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2012-12-01 10:18:25","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null}', '2012-12-01 19:05:08', 'admin'),
(81, 'inventory', 'edit', 'item', 41, '{"id":"41","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"MKM","model_no":"","warranty":"","sku":"205","sku2":"2051","sku3":"2052","sku4":"","qty":100,"alert_quantity":"4","max_quantity":"0","cost":"0.0000","average_cost":null,"price":"2.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"10.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"50.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:18:14","added_by":"admin","modified_on":"2012-12-02 21:22:15","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"pc","uom2":"strip","uom3":"box","uom4":"","loose_qty2":"12","loose_qty3":"60","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2012-12-01 10:18:25","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null}', '2012-12-02 21:22:15', 'admin'),
(82, 'inventory', 'edit', 'item', 41, '{"id":"41","primary_image":null,"image":null,"category":"Liquid","subcategory":"Madu","brand":"0","location":"","name":"MKM","model_no":"","warranty":"","sku":"205","sku2":"2051","sku3":"2052","sku4":"","qty":99,"alert_quantity":"4","max_quantity":"0","cost":"0.0000","average_cost":null,"price":"2.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"10.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"50.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:18:14","added_by":"admin","modified_on":"2012-12-04 07:57:35","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"pc","uom2":"strip","uom3":"box","uom4":"","loose_qty2":"12","loose_qty3":"60","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2012-12-04 07:54:01","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null}', '2012-12-04 07:57:35', 'admin'),
(83, 'inventory', 'edit', 'item', 41, '{"id":"41","primary_image":null,"image":null,"category":"Liquid","subcategory":"Madu","brand":"0","location":"","name":"MKM","model_no":"","warranty":"","sku":"205","sku2":"2051","sku3":"2052","sku4":"","qty":99,"alert_quantity":"4","max_quantity":"0","cost":"0.0000","average_cost":null,"price":"2.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"10.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"50.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:18:14","added_by":"admin","modified_on":"2012-12-04 08:00:23","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"pc","uom2":"strip","uom3":"box","uom4":"","loose_qty2":"12","loose_qty3":"60","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2012-12-04 07:54:01","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null}', '2012-12-04 08:00:23', 'admin'),
(84, 'inventory', 'edit', 'item', 41, '{"id":"41","primary_image":"ddeu.jpeg","image":"ddeu.jpeg","category":"Liquid","subcategory":"Madu","brand":"0","location":"","name":"MKM","model_no":"","warranty":"","sku":"205","sku2":"2051","sku3":"2052","sku4":"","qty":99,"alert_quantity":"4","max_quantity":"0","cost":"0.0000","average_cost":null,"price":"2.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"10.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"50.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:18:14","added_by":"admin","modified_on":"2012-12-04 08:00:38","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"pc","uom2":"strip","uom3":"box","uom4":"","loose_qty2":"12","loose_qty3":"60","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2012-12-04 07:54:01","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null}', '2012-12-04 08:00:38', 'admin'),
(85, 'inventory', 'add', 'po', 10001, '{"id":"10001","txn_no":"5-10001","invoice_number":"","number":null,"date":"2012-12-06 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":null,"supplier_id":"0","supplier_address":"{\\"address1\\":null,\\"address2\\":null,\\"zipcode\\":null,\\"city\\":null,\\"state\\":null,\\"country\\":null}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2012-12-05 23:36:27","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"5","assigned_to":null,"orders":[{"id":"10","purchase_order_id":"10001","date":"2012-12-06 00:00:00","item_description":null,"item_name":"MKM ()","item_id":"41","discount":"0","discount_type":null,"qty":"8","price_per_unit":"0.0000","price":"0.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"5"}],"products":{"41":{"id":"41","primary_image":"ddeu.jpeg","image":"ddeu.jpeg","category":"Liquid","subcategory":"Madu","brand":"0","location":"","name":"MKM","model_no":"","warranty":"","sku":"205","sku2":"2051","sku3":"2052","sku4":"","qty":26,"alert_quantity":"4","max_quantity":"0","cost":"0.0000","average_cost":null,"price":"2.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"10.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"50.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:18:14","added_by":"admin","modified_on":"2012-12-04 08:00:38","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"pc","uom2":"strip","uom3":"box","uom4":"","loose_qty2":"12","loose_qty3":"60","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2012-12-04 16:12:29","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null}}}', '2012-12-05 23:36:27', 'admin'),
(86, 'inventory', 'edit', 'po', 10001, '{"id":"10001","txn_no":"5-10001","invoice_number":"","number":null,"date":"2012-12-06 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":null,"supplier_id":"0","supplier_address":"{\\"address1\\":null,\\"address2\\":null,\\"zipcode\\":null,\\"city\\":null,\\"state\\":null,\\"country\\":null}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop 3\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2012-12-05 23:36:27","added_by":"admin","modified_on":"2012-12-05 23:40:46","modified_by":"admin","division_id":null,"warehouse_id":"5","assigned_to":null,"orders":[{"id":"11","purchase_order_id":"10001","date":"2012-12-06 00:00:00","item_description":null,"item_name":"MKM ()","item_id":"41","discount":"0","discount_type":null,"qty":"8","price_per_unit":"0.0000","price":"0.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"5"}],"products":{"41":{"id":"41","primary_image":"ddeu.jpeg","image":"ddeu.jpeg","category":"Liquid","subcategory":"Madu","brand":"0","location":"","name":"MKM","model_no":"","warranty":"","sku":"205","sku2":"2051","sku3":"2052","sku4":"","qty":26,"alert_quantity":"4","max_quantity":"0","cost":"0.0000","average_cost":null,"price":"2.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"10.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"50.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-11-18 00:18:14","added_by":"admin","modified_on":"2012-12-04 08:00:38","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"pc","uom2":"strip","uom3":"box","uom4":"","loose_qty2":"12","loose_qty3":"60","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2012-12-04 16:12:29","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"warehouse_id":null}}}', '2012-12-05 23:40:46', 'admin'),
(87, 'contacts', 'edit', 'contact', 1076, '{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5f4dcc3b5aa765d61d8327deb882cf99","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2012-12-06 01:23:38","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-06 01:23:38', 'admin'),
(88, 'contacts', 'edit', 'contact', 1076, '{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5f4dcc3b5aa765d61d8327deb882cf99","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2012-12-06 18:56:32","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-06 18:56:32', 'admin'),
(89, 'contacts', 'edit', 'contact', 1015, '{"id":"1015","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Shafiq Rizwan","contact_number":"0124205391","credit_limit":"0.00","rank":"Agent Member","email":"shafiq@plexsol.com","ic":"880102355071","password":"88aa5e3aad2dbc037bcae4f0a9d5210c","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman Bukit Indah","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"0","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 11:26:32","added_by":"@Plexcart","modified_on":"2012-12-06 20:22:05","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shafiq@plexsol.com1350879496","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-06 20:22:05', 'admin'),
(90, 'contacts', 'edit', 'contact', 1076, '{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5f4dcc3b5aa765d61d8327deb882cf99","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2012-12-09 15:38:04","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-09 15:38:04', 'admin'),
(91, 'contacts', 'edit', 'contact', 1076, '{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5f4dcc3b5aa765d61d8327deb882cf99","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2012-12-09 15:39:03","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-09 15:39:03', 'admin'),
(92, 'contacts', 'edit', 'contact', 1085, '{"id":"1085","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Custom Album","contact_number":"0125445670","credit_limit":"0.00","rank":"0","email":"sales@customalbum.net","ic":"840621075253","password":"da2ec7ad9e322d9b2e226d1dfe90c1c5","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman Bukit Indah","city":"Bukit Mertajam, {emamg","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"sales@customalbum.net","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-12-12 21:44:00","added_by":"@Plexcart","modified_on":"2012-12-12 21:44:44","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-12 21:44:44', 'admin'),
(93, 'inventory', 'add', 'item', NULL, '[]', '2012-12-13 06:54:10', 'admin'),
(94, 'sales', 'deliver', 'invoice', 10005, '{"id":"10005","txn_no":"7-10001","quote_id":null,"sales_order_id":"16","number":null,"po_number":null,"date":"2012-12-13 06:57:13","due_date":null,"received_date":null,"contact_person":null,"contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"zipcode\\":\\"ada\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"Self Pickup","shipping_id":"6","terms":"Cash","duration":"0","remarks":"No remarks","status":"Pending","payment_status":"Paid","payment_date":"2012-12-13 06:57:13","payment_reference":"TXN-TEST1001","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"60.00","total_delivered":"60.00","cost":null,"tags":"Online Sales","added_on":"2012-12-13 06:57:13","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":null,"total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"7","assigned_to":null,"notification":null,"orders":[{"id":"9","invoice_id":"10005","type":"product","date":"2012-12-13 06:57:13","item_name":"Garam Bukit","item_description":"","item_id":"67","service_id":null,"item_sku":"gb01","discount":null,"discount_type":null,"qty":"3","price_per_unit":"20.0000","price":"60.00","cost":"15.00","margin":null,"delivered":"3","delivered_price":"60.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"7"}],"products":{"67":{"id":"67","primary_image":"garambukit.jpg","image":"garambukit.jpg","category":"Home","subcategory":"Accessories","brand":"0","location":"","name":"Garam Bukit","model_no":"","warranty":"","sku":"gb01","sku2":"","sku3":"","sku4":"","qty":97,"alert_quantity":"4","max_quantity":"0","cost":"5.0000","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-13 06:54:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"1.65","weight_unit":"kg","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2012-12-13 06:57:48","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"7"}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5f4dcc3b5aa765d61d8327deb882cf99","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2012-12-09 15:39:03","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1355353015","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2012-12-13 06:57:48', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(95, 'sales', 'status_update', 'invoice', 10005, '{"id":"10005","txn_no":"7-10001","quote_id":null,"sales_order_id":"16","number":null,"po_number":null,"date":"2012-12-13 06:57:13","due_date":null,"received_date":null,"contact_person":null,"contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"zipcode\\":\\"ada\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"Self Pickup","shipping_id":"6","terms":"Cash","duration":"0","remarks":"No remarks","status":"Delivered","payment_status":"Paid","payment_date":"2012-12-13 06:57:13","payment_reference":"TXN-TEST1001","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"60.00","total_delivered":"60.00","cost":null,"tags":"Online Sales","added_on":"2012-12-13 06:57:13","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":null,"total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"7","assigned_to":null,"notification":null,"orders":[{"id":"9","invoice_id":"10005","type":"product","date":"2012-12-13 06:57:13","item_name":"Garam Bukit","item_description":"","item_id":"67","service_id":null,"item_sku":"gb01","discount":null,"discount_type":null,"qty":"3","price_per_unit":"20.0000","price":"60.00","cost":"15.00","margin":null,"delivered":"3","delivered_price":"60.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"7"}],"products":{"67":{"id":"67","primary_image":"garambukit.jpg","image":"garambukit.jpg","category":"Home","subcategory":"Accessories","brand":"0","location":"","name":"Garam Bukit","model_no":"","warranty":"","sku":"gb01","sku2":"","sku3":"","sku4":"","qty":97,"alert_quantity":"4","max_quantity":"0","cost":"5.0000","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-13 06:54:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"1.65","weight_unit":"kg","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2012-12-13 06:57:48","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"7"}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5f4dcc3b5aa765d61d8327deb882cf99","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2012-12-09 15:39:03","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1355353015","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2012-12-13 06:57:51', 'admin'),
(96, 'sales', 'delivery_status_update', 'do', NULL, '[]', '2012-12-13 06:58:21', 'admin'),
(97, 'sales', 'delivery_status_update', 'do', NULL, '[]', '2012-12-13 06:58:33', 'admin'),
(98, 'sales', 'delivery_status_update', 'do', 10005, '{"id":"10005","txn_no":"7-10001","quote_id":null,"sales_order_id":"16","number":null,"po_number":null,"date":"2012-12-13 06:57:13","due_date":null,"received_date":null,"contact_person":null,"contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"zipcode\\":\\"ada\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Delivered","delivery_date":null,"shipping":"Self Pickup","shipping_id":"6","terms":"Cash","duration":"0","remarks":"No remarks","status":"Delivered","payment_status":"Paid","payment_date":"2012-12-13 06:57:13","payment_reference":"TXN-TEST1001","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"60.00","total_delivered":"60.00","cost":null,"tags":"Online Sales","added_on":"2012-12-13 06:57:13","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":null,"total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"7","assigned_to":null,"notification":null,"orders":[{"id":"9","invoice_id":"10005","type":"product","date":"2012-12-13 06:57:13","item_name":"Garam Bukit","item_description":"","item_id":"67","service_id":null,"item_sku":"gb01","discount":null,"discount_type":null,"qty":"3","price_per_unit":"20.0000","price":"60.00","cost":"15.00","margin":null,"delivered":"3","delivered_price":"60.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"7"}],"products":{"67":{"id":"67","primary_image":"garambukit.jpg","image":"garambukit.jpg","category":"Home","subcategory":"Accessories","brand":"0","location":"","name":"Garam Bukit","model_no":"","warranty":"","sku":"gb01","sku2":"","sku3":"","sku4":"","qty":97,"alert_quantity":"4","max_quantity":"0","cost":"5.0000","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-13 06:54:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"1.65","weight_unit":"kg","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2012-12-13 06:57:48","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"7"}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5f4dcc3b5aa765d61d8327deb882cf99","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2012-12-09 15:39:03","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1355353015","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2012-12-13 06:58:54', 'admin'),
(99, 'inventory', 'add', 'item', NULL, '[]', '2012-12-13 07:06:15', 'admin2'),
(100, 'inventory', 'add', 'item', NULL, '[]', '2012-12-14 08:45:02', 'admin'),
(101, 'inventory', 'edit', 'item', 69, '{"id":"69","primary_image":null,"image":"kr01.jpg","category":"Home","subcategory":"Accessories","brand":"0","location":"","name":"Kopi Radix","model_no":"","warranty":"","sku":"kr01","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"4","max_quantity":"0","cost":"9.0000","average_cost":null,"price":"11.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-14 08:45:02","added_by":"admin","modified_on":"2012-12-14 08:46:13","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"100.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"7"}', '2012-12-14 08:46:13', 'admin'),
(102, 'inventory', 'edit', 'item', 69, '{"id":"69","primary_image":"kr01.jpg","image":"kr01.jpg","category":"Home","subcategory":"Accessories","brand":"0","location":"","name":"Kopi Radix","model_no":"","warranty":"","sku":"kr01","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"4","max_quantity":"0","cost":"9.0000","average_cost":null,"price":"11.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-14 08:45:02","added_by":"admin","modified_on":"2012-12-14 08:46:17","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"100.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"7"}', '2012-12-14 08:46:17', 'admin'),
(103, 'inventory', 'add', 'item', NULL, '[]', '2012-12-14 08:48:33', 'admin2'),
(104, 'inventory', 'edit', 'item', 70, '{"id":"70","primary_image":"kr011.jpg","image":"kr011.jpg","category":"Home","subcategory":"Accessories","brand":"0","location":"","name":"Coffee Radix","model_no":"","warranty":"","sku":"kr01","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"7","max_quantity":"0","cost":"9.0000","average_cost":null,"price":"13.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-14 08:48:33","added_by":"admin2","modified_on":"2012-12-14 08:49:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2012-12-14 08:49:36', 'admin2'),
(105, 'contacts', 'edit', 'contact', 1076, '{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5f4dcc3b5aa765d61d8327deb882cf99","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2012-12-14 08:51:38","modified_by":"admin2","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1355353015","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-14 08:51:38', 'admin2'),
(106, 'sales', 'deliver', 'invoice', 10006, '{"id":"10006","txn_no":"1-10005","quote_id":null,"sales_order_id":"19","number":null,"po_number":null,"date":"2012-12-14 08:52:32","due_date":null,"received_date":null,"contact_person":null,"contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"zipcode\\":\\"ada\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"Self Pickup","shipping_id":"6","terms":"Cash","duration":"0","remarks":"No remarks","status":"Pending","payment_status":"Paid","payment_date":"2012-12-14 08:52:32","payment_reference":"TXN-TEST1001","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"337.50","total_delivered":"337.50","cost":null,"tags":"Online Sales","added_on":"2012-12-14 08:52:32","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":null,"total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"10","invoice_id":"10006","type":"product","date":"2012-12-14 08:52:32","item_name":"Slice Table Lamp","item_description":"","item_id":"10","service_id":null,"item_sku":"STL1230","discount":null,"discount_type":null,"qty":"3","price_per_unit":"112.5000","price":"337.50","cost":"270.00","margin":null,"delivered":"3","delivered_price":"337.50","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"10":{"id":"10","primary_image":"Slice20.jpg","image":"Slice20.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Slice Table Lamp","model_no":"","warranty":"","sku":"STL1230","sku2":"","sku3":"","sku4":"","qty":97,"alert_quantity":"2","max_quantity":"0","cost":"90.0000","average_cost":null,"price":"112.50","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 12:59:59","added_by":"admin","modified_on":"2012-12-12 13:00:13","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2012-12-14 08:53:31","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5f4dcc3b5aa765d61d8327deb882cf99","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2012-12-14 08:51:38","modified_by":"admin2","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1355446310","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2012-12-14 08:53:31', 'admin2'),
(107, 'sales', 'status_update', 'invoice', 10006, '{"id":"10006","txn_no":"1-10005","quote_id":null,"sales_order_id":"19","number":null,"po_number":null,"date":"2012-12-14 08:52:32","due_date":null,"received_date":null,"contact_person":null,"contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"zipcode\\":\\"ada\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"Self Pickup","shipping_id":"6","terms":"Cash","duration":"0","remarks":"No remarks","status":"Delivered","payment_status":"Paid","payment_date":"2012-12-14 08:52:32","payment_reference":"TXN-TEST1001","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"337.50","total_delivered":"337.50","cost":null,"tags":"Online Sales","added_on":"2012-12-14 08:52:32","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":null,"total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"10","invoice_id":"10006","type":"product","date":"2012-12-14 08:52:32","item_name":"Slice Table Lamp","item_description":"","item_id":"10","service_id":null,"item_sku":"STL1230","discount":null,"discount_type":null,"qty":"3","price_per_unit":"112.5000","price":"337.50","cost":"270.00","margin":null,"delivered":"3","delivered_price":"337.50","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"10":{"id":"10","primary_image":"Slice20.jpg","image":"Slice20.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Slice Table Lamp","model_no":"","warranty":"","sku":"STL1230","sku2":"","sku3":"","sku4":"","qty":97,"alert_quantity":"2","max_quantity":"0","cost":"90.0000","average_cost":null,"price":"112.50","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 12:59:59","added_by":"admin","modified_on":"2012-12-12 13:00:13","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2012-12-14 08:53:31","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5f4dcc3b5aa765d61d8327deb882cf99","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2012-12-14 08:51:38","modified_by":"admin2","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1355446310","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2012-12-14 08:53:34', 'admin2'),
(108, 'sales', 'delivery_status_update', 'do', NULL, '[]', '2012-12-14 08:53:42', 'admin2'),
(109, 'sales', 'delivery_status_update', 'do', NULL, '[]', '2012-12-14 08:53:57', 'admin2'),
(110, 'sales', 'delivery_status_update', 'do', NULL, '[]', '2012-12-14 08:54:10', 'admin2'),
(111, 'sales', 'delivery_status_update', 'do', 10006, '{"id":"10006","txn_no":"1-10005","quote_id":null,"sales_order_id":"19","number":null,"po_number":null,"date":"2012-12-14 08:52:32","due_date":null,"received_date":null,"contact_person":null,"contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"zipcode\\":\\"ada\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Delivered","delivery_date":null,"shipping":"Self Pickup","shipping_id":"6","terms":"Cash","duration":"0","remarks":"No remarks","status":"Delivered","payment_status":"Paid","payment_date":"2012-12-14 08:52:32","payment_reference":"TXN-TEST1001","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"337.50","total_delivered":"337.50","cost":null,"tags":"Online Sales","added_on":"2012-12-14 08:52:32","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":null,"total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"10","invoice_id":"10006","type":"product","date":"2012-12-14 08:52:32","item_name":"Slice Table Lamp","item_description":"","item_id":"10","service_id":null,"item_sku":"STL1230","discount":null,"discount_type":null,"qty":"3","price_per_unit":"112.5000","price":"337.50","cost":"270.00","margin":null,"delivered":"3","delivered_price":"337.50","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"10":{"id":"10","primary_image":"Slice20.jpg","image":"Slice20.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Slice Table Lamp","model_no":"","warranty":"","sku":"STL1230","sku2":"","sku3":"","sku4":"","qty":97,"alert_quantity":"2","max_quantity":"0","cost":"90.0000","average_cost":null,"price":"112.50","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 12:59:59","added_by":"admin","modified_on":"2012-12-12 13:00:13","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2012-12-14 08:53:31","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5f4dcc3b5aa765d61d8327deb882cf99","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2012-12-14 08:51:38","modified_by":"admin2","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1355446310","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2012-12-14 08:54:21', 'admin2'),
(112, 'sales', 'add', 'so', 20, '{"id":"20","txn_no":"7-10002","quote_id":"0","invoice_id":null,"number":"0","po_number":"0","date":"2012-12-27 00:00:00","due_date":"2012-12-27 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Asmah Bt Din","contact_id":"1078","contact_address":"{\\"address1\\":\\"Jalan\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Asmah Bt Din\\",\\"mobile\\":\\"01430922\\",\\"address1\\":\\"Jalan\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"31.00","total_delivered":null,"cost":null,"tags":"","added_on":"2012-12-27 10:35:22","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"7","assigned_to":null,"notification":null,"orders":[{"id":"11","sales_order_id":"20","type":"product","date":"2012-12-27 00:00:00","item_name":"Garam Bukit","item_description":"","item_id":"67","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"20.0000","price":"20.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"7"},{"id":"12","sales_order_id":"20","type":"product","date":"2012-12-27 00:00:00","item_name":"Kopi Radix","item_description":"","item_id":"69","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"11.0000","price":"11.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"7"}],"products":{"67":{"id":"67","primary_image":"garambukit.jpg","image":"garambukit.jpg","category":"Home","subcategory":"Accessories","brand":"0","location":"","name":"Garam Bukit","model_no":"","warranty":"","sku":"gb01","sku2":"","sku3":"","sku4":"","qty":97,"alert_quantity":"4","max_quantity":"0","cost":"5.0000","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-13 06:54:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"1.65","weight_unit":"kg","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2012-12-13 06:57:48","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"7"},"69":{"id":"69","primary_image":"kr01.jpg","image":"kr01.jpg","category":"Home","subcategory":"Accessories","brand":"0","location":"","name":"Kopi Radix","model_no":"","warranty":"","sku":"kr01","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"4","max_quantity":"0","cost":"9.0000","average_cost":null,"price":"11.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-14 08:45:02","added_by":"admin","modified_on":"2012-12-14 08:46:17","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"100.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"7"}},"services":null}', '2012-12-27 10:35:22', 'admin'),
(113, 'sales', 'status_update', 'so', 20, '{"id":"20","txn_no":"7-10002","quote_id":"0","invoice_id":null,"number":"0","po_number":"0","date":"2012-12-27 00:00:00","due_date":"2012-12-27 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Asmah Bt Din","contact_id":"1078","contact_address":"{\\"address1\\":\\"Jalan\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Asmah Bt Din\\",\\"mobile\\":\\"01430922\\",\\"address1\\":\\"Jalan\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Completed","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"31.00","total_delivered":null,"cost":null,"tags":"","added_on":"2012-12-27 10:35:22","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"7","assigned_to":null,"notification":null,"orders":[{"id":"11","sales_order_id":"20","type":"product","date":"2012-12-27 00:00:00","item_name":"Garam Bukit","item_description":"","item_id":"67","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"20.0000","price":"20.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"7"},{"id":"12","sales_order_id":"20","type":"product","date":"2012-12-27 00:00:00","item_name":"Kopi Radix","item_description":"","item_id":"69","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"11.0000","price":"11.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"7"}],"products":{"67":{"id":"67","primary_image":"garambukit.jpg","image":"garambukit.jpg","category":"Home","subcategory":"Accessories","brand":"0","location":"","name":"Garam Bukit","model_no":"","warranty":"","sku":"gb01","sku2":"","sku3":"","sku4":"","qty":97,"alert_quantity":"4","max_quantity":"0","cost":"5.0000","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-13 06:54:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"1.65","weight_unit":"kg","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2012-12-13 06:57:48","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"7"},"69":{"id":"69","primary_image":"kr01.jpg","image":"kr01.jpg","category":"Home","subcategory":"Accessories","brand":"0","location":"","name":"Kopi Radix","model_no":"","warranty":"","sku":"kr01","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"4","max_quantity":"0","cost":"9.0000","average_cost":null,"price":"11.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-14 08:45:02","added_by":"admin","modified_on":"2012-12-14 08:46:17","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"100.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"7"}},"services":null}', '2012-12-27 10:35:35', 'admin'),
(114, 'sales', 'add', 'invoice', 10007, '{"id":"10007","txn_no":"7-10002","quote_id":"0","sales_order_id":"20","number":"0","po_number":"0","date":"2012-12-27 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Asmah Bt Din","contact_id":"1078","contact_address":"{\\"address1\\":\\"Jalan\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Asmah Bt Din\\",\\"mobile\\":\\"01430922\\",\\"address1\\":\\"Jalan\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"31.00","total_delivered":null,"cost":null,"tags":"","added_on":"2012-12-27 10:38:16","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"7","assigned_to":null,"notification":null,"orders":[{"id":"11","invoice_id":"10007","type":"product","date":"2012-12-27 12:00:00","item_name":"Garam Bukit","item_description":"","item_id":"67","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"20.0000","price":"20.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"7"},{"id":"12","invoice_id":"10007","type":"product","date":"2012-12-27 12:00:00","item_name":"Kopi Radix","item_description":"","item_id":"69","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"11.0000","price":"11.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"7"}],"products":{"67":{"id":"67","primary_image":"garambukit.jpg","image":"garambukit.jpg","category":"Home","subcategory":"Accessories","brand":"0","location":"","name":"Garam Bukit","model_no":"","warranty":"","sku":"gb01","sku2":"","sku3":"","sku4":"","qty":97,"alert_quantity":"4","max_quantity":"0","cost":"5.0000","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-13 06:54:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"1.65","weight_unit":"kg","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2012-12-13 06:57:48","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"7"},"69":{"id":"69","primary_image":"kr01.jpg","image":"kr01.jpg","category":"Home","subcategory":"Accessories","brand":"0","location":"","name":"Kopi Radix","model_no":"","warranty":"","sku":"kr01","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"4","max_quantity":"0","cost":"9.0000","average_cost":null,"price":"11.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-14 08:45:02","added_by":"admin","modified_on":"2012-12-14 08:46:17","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"100.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"7"}},"services":null,"customer":{"id":"1078","is_customer":null,"is_supplier":null,"is_debtor":null,"is_creditor":null,"is_member":null,"is_stakeholder":null,"is_franchise":null,"is_franchisee":null,"company_name":null,"company_registration":null,"contact_person":"Asmah Bt Din","contact_number":"01430922","credit_limit":null,"rank":null,"email":"","ic":"841231","password":null,"introducer_ic":null,"address1":"Jalan","address2":"","city":"Bukit","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"01430922","fax":null,"general_email":null,"terms":null,"description":null,"remarks":null,"tags":null,"added_on":"2012-11-16 21:04:45","added_by":"admin","modified_on":"2012-11-17 08:38:39","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2012-12-27 10:38:17', 'admin'),
(115, 'inventory', 'delete', 'item', 68, '{"id":"68","primary_image":"omega3.jpg","image":"omega3.jpg","category":"Home","subcategory":"0","brand":"0","location":"","name":"Omega 3","model_no":"","warranty":"","sku":"om1","sku2":"","sku3":"","sku4":"","qty":100,"alert_quantity":"3","max_quantity":"0","cost":"5.0000","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-13 07:06:15","added_by":"admin2","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"100.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2012-12-27 10:42:52', 'admin'),
(116, 'inventory', 'delete', 'item', 70, '{"id":"70","primary_image":"kr011.jpg","image":"kr011.jpg","category":"Home","subcategory":"Accessories","brand":"0","location":"","name":"Coffee Radix","model_no":"","warranty":"","sku":"KR01","sku2":"","sku3":"","sku4":"","qty":99,"alert_quantity":"7","max_quantity":"0","cost":"9.0000","average_cost":null,"price":"13.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-14 08:48:33","added_by":"admin2","modified_on":"2012-12-14 08:49:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2012-12-27 10:43:01', 'admin'),
(117, 'contacts', 'add', 'contact', 1087, '{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 22:45:14', 'admin'),
(118, 'contacts', 'add', 'contact', 1088, '{"id":"1088","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Kamalia Azim Ahmad","contact_number":"0178854331","credit_limit":"0.00","rank":"Agent Member","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:57","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 22:45:57', 'admin'),
(119, 'contacts', 'add', 'contact', 1089, '{"id":"1089","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Mohd Yusof Adam","contact_number":"0189955375","credit_limit":"0.00","rank":"Agent Member","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:46:38","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 22:46:38', 'admin'),
(120, 'contacts', 'add', 'contact', 1090, '{"id":"1090","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"The Walking Stars","company_registration":"","contact_person":"Ziad Karim Jusoh","contact_number":"0366874556","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:47:21","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 22:47:21', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(121, 'contacts', 'add', 'contact', 1091, '{"id":"1091","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Farid Kamil","contact_number":"0196653485","credit_limit":"0.00","rank":"Agent Member","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:48:08","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 22:48:08', 'admin'),
(122, 'contacts', 'add', 'contact', 1092, '{"id":"1092","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Badrul Amin Zakaria","contact_number":"0142565845","credit_limit":"0.00","rank":"Agent Member","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:49:06","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 22:49:06', 'admin'),
(123, 'contacts', 'add', 'contact', 1093, '{"id":"1093","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"QWERTY Sdn Berhad","company_registration":"","contact_person":"Adam Lim Chang Shi","contact_number":"0165984671","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:49:53","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 22:49:53', 'admin'),
(124, 'contacts', 'add', 'contact', 1094, '{"id":"1094","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Che Mohd Haniff Ahmad","contact_number":"0167865151","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:50:26","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 22:50:26', 'admin'),
(125, 'contacts', 'add', 'contact', 1095, '{"id":"1095","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"David Zorlan","contact_number":"0167759456","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:50:55","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 22:50:55', 'admin'),
(126, 'contacts', 'add', 'contact', 1096, '{"id":"1096","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Eugene Ken Cee","contact_number":"0136565747","credit_limit":"0.00","rank":"Agent Member","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:51:21","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 22:51:21', 'admin'),
(127, 'contacts', 'add', 'contact', 1097, '{"id":"1097","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Roger Federed Sdn Bhd","company_registration":"","contact_person":"Federed Roger","contact_number":"048575662","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:52:16","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 22:52:16', 'admin'),
(128, 'contacts', 'add', 'contact', 1098, '{"id":"1098","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Hamzah Kassim","contact_number":"0168787596","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:55:39","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 22:55:39', 'admin'),
(129, 'contacts', 'add', 'contact', 1099, '{"id":"1099","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Irvine Calvine","contact_number":"036969854","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:56:09","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 22:56:09', 'admin'),
(130, 'contacts', 'add', 'contact', 1100, '{"id":"1100","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Jasmine Kaur","contact_number":"0145869756","credit_limit":"0.00","rank":"Agent Member","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:56:36","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 22:56:36', 'admin'),
(131, 'contacts', 'add', 'contact', 1101, '{"id":"1101","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Jamiran Kamur","contact_number":"0169833215","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:57:06","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 22:57:06', 'admin'),
(132, 'contacts', 'add', 'contact', 1102, '{"id":"1102","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Loren Calliph","contact_number":"0186654250","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:57:33","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 22:57:33', 'admin'),
(133, 'contacts', 'add', 'contact', 1103, '{"id":"1103","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Land Mind Consultant","company_registration":"","contact_person":"Benjamin Franklin","contact_number":"0398981122","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:58:06","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 22:58:06', 'admin'),
(134, 'contacts', 'add', 'contact', 1104, '{"id":"1104","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Lavish Built Enterprise","company_registration":"","contact_person":"Richarcd Khan","contact_number":"0167545663","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:59:11","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 22:59:11', 'admin'),
(135, 'contacts', 'add', 'contact', 1105, '{"id":"1105","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Indigo Technologies Sdn Bhd","company_registration":"","contact_person":"Frank Lampard","contact_number":"0369102012","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:59:45","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 22:59:45', 'admin'),
(136, 'contacts', 'add', 'contact', 1106, '{"id":"1106","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Muhammad Ferhad","contact_number":"0147520123","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:00:42","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 23:00:42', 'admin'),
(137, 'contacts', 'add', 'contact', 1107, '{"id":"1107","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Nur Akmal Hamzah","contact_number":"0138475216","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:01:10","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 23:01:10', 'admin'),
(138, 'contacts', 'add', 'contact', 1108, '{"id":"1108","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Noraishah Kamarudin","contact_number":"0153210321","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:01:35","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 23:01:35', 'admin'),
(139, 'contacts', 'add', 'contact', 1109, '{"id":"1109","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Noramalina Mape","contact_number":"0138457123","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:01:53","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 23:01:53', 'admin'),
(140, 'contacts', 'add', 'contact', 1110, '{"id":"1110","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Omran Omar","contact_number":"0187563214","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:02:14","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 23:02:14', 'admin'),
(141, 'contacts', 'add', 'contact', 1111, '{"id":"1111","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Orlando Bloom","contact_number":"0134512398","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:02:34","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 23:02:34', 'admin'),
(142, 'contacts', 'add', 'contact', 1112, '{"id":"1112","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Prima Land Ent.","company_registration":"","contact_person":"Jalil Khairuddin","contact_number":"0136575484","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:06:09","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 23:06:09', 'admin'),
(143, 'contacts', 'add', 'contact', 1113, '{"id":"1113","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Prima Electronic Ent.","company_registration":"","contact_person":"Pak Hussin Man","contact_number":"0128529631","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:06:44","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 23:06:44', 'admin'),
(144, 'contacts', 'add', 'contact', 1114, '{"id":"1114","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Prima Movies Ent.","company_registration":"","contact_person":"Michael Kane","contact_number":"0138465259","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:07:09","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 23:07:09', 'admin'),
(145, 'contacts', 'add', 'contact', 1115, '{"id":"1115","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Quantity Land Ent","company_registration":"","contact_person":"Jeyakumar","contact_number":"0168945765","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:07:48","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 23:07:48', 'admin'),
(146, 'contacts', 'add', 'contact', 1116, '{"id":"1116","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Quest Tech Ent.","company_registration":"","contact_person":"Tarmimi Zuhan","contact_number":"0154758964","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:08:16","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 23:08:16', 'admin'),
(147, 'contacts', 'add', 'contact', 1117, '{"id":"1117","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Roslan Rais","contact_number":"0167418521","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:10:08","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 23:10:08', 'admin'),
(148, 'contacts', 'add', 'contact', 1118, '{"id":"1118","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Rosnah Mat Aris","contact_number":"0167845612","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:11:12","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 23:11:12', 'admin'),
(149, 'contacts', 'add', 'contact', 1119, '{"id":"1119","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Rohaya Jusoh","contact_number":"0165231462","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:12:55","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 23:12:55', 'admin'),
(150, 'contacts', 'add', 'contact', 1120, '{"id":"1120","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Star Diamond Ent.","company_registration":"","contact_person":"Shariman Sharif","contact_number":"0143218654","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:13:20","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 23:13:20', 'admin'),
(151, 'contacts', 'edit', 'contact', 1087, '{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 23:15:13', 'admin'),
(152, 'contacts', 'edit', 'contact', 1088, '{"id":"1088","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Kamalia Azim Ahmad","contact_number":"0178854331","credit_limit":"0.00","rank":"Agent Member","email":"","ic":"","password":"","introducer_ic":null,"address1":"13 Jalan Admin","address2":"Taman Admin","city":"Johor Bahru","state":"Johor","zipcode":"36900","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:57","added_by":"admin","modified_on":"2012-12-28 23:20:00","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 23:20:00', 'admin'),
(153, 'contacts', 'edit', 'contact', 1089, '{"id":"1089","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Mohd Yusof Adam","contact_number":"0189955375","credit_limit":"0.00","rank":"Agent Member","email":"","ic":"","password":"","introducer_ic":null,"address1":"68 Jalan Taman Muda","address2":"Taman Muda","city":"Taiping","state":"Perak","zipcode":"16900","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:46:38","added_by":"admin","modified_on":"2012-12-28 23:21:02","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 23:21:02', 'admin'),
(154, 'contacts', 'edit', 'contact', 1090, '{"id":"1090","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"The Walking Stars","company_registration":"","contact_person":"Ziad Karim Jusoh","contact_number":"0366874556","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Blok 1, Jalan Jaya Usaha","address2":"Kawasan Jaya Usaha","city":"Kulim","state":"Kedah","zipcode":"09000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:47:21","added_by":"admin","modified_on":"2012-12-28 23:23:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 23:23:13', 'admin'),
(155, 'contacts', 'edit', 'contact', 1091, '{"id":"1091","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Farid Kamil","contact_number":"0196653485","credit_limit":"0.00","rank":"Agent Member","email":"","ic":"","password":"","introducer_ic":null,"address1":"11 Persimpangan Kulit","address2":"Taman Wayang Kulit","city":"Kulim","state":"Kedah","zipcode":"09000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:48:08","added_by":"admin","modified_on":"2012-12-28 23:24:20","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2012-12-28 23:24:20', 'admin'),
(156, 'tax', 'add', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"5","enabled":"1"}', '2012-12-30 21:04:03', 'admin'),
(157, 'sales', 'add', 'invoice', 10008, '{"id":"10008","txn_no":"1-10006","quote_id":"0","sales_order_id":"0","number":"0","po_number":"2348928","date":"2012-12-30 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"1","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"42.00","adjustment":"0.00","adjustment_type":"Add","total":"5276.00","total_delivered":null,"cost":null,"tags":"","added_on":"2012-12-30 21:04:12","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"1\\":\\"0.00\\"}","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"13","invoice_id":"10008","type":"product","date":"2012-12-30 12:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"6.0000","price":"60.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"14","invoice_id":"10008","type":"product","date":"2012-12-30 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"12","price_per_unit":"77.0000","price":"924.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"15","invoice_id":"10008","type":"product","date":"2012-12-30 12:00:00","item_name":"Basic Bankbook Holder","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"55.0000","price":"550.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"16","invoice_id":"10008","type":"product","date":"2012-12-30 12:00:00","item_name":"Black Silk Scarves with Pin","item_description":"","item_id":"37","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"12","price_per_unit":"45.0000","price":"540.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"17","invoice_id":"10008","type":"product","date":"2012-12-30 12:00:00","item_name":"Blossom Bag","item_description":"","item_id":"57","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"12","price_per_unit":"180.0000","price":"2160.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"18","invoice_id":"10008","type":"product","date":"2012-12-30 12:00:00","item_name":"Blossom Tote Bag","item_description":"","item_id":"52","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"5","price_per_unit":"200.0000","price":"1000.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"2","max_quantity":"0","cost":"2.0000","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"2","max_quantity":"0","cost":"50.0000","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"2","max_quantity":"0","cost":"20.0000","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"37":{"id":"37","primary_image":"BlackSlikScarvesWithPin.jpg","image":"BlackSlikScarvesWithPin.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Black Silk Scarves with Pin","model_no":"","warranty":"","sku":"BSSP908023","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"2","max_quantity":"0","cost":"20.0000","average_cost":null,"price":"49.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:33:04","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"57":{"id":"57","primary_image":"BlossomBag.jpg","image":"BlossomBag.jpg","category":"Women","subcategory":"Bags","brand":"0","location":"","name":"Blossom Bag","model_no":"","warranty":"","sku":"BB13119","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"2","max_quantity":"0","cost":"120.0000","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:52:28","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"52":{"id":"52","primary_image":"BlossomToteBag.jpg","image":"BlossomToteBag.jpg","category":"Women","subcategory":"Bags","brand":"0","location":"","name":"Blossom Tote Bag","model_no":"","warranty":"","sku":"BTB1231","sku2":"","sku3":"","sku4":"","qty":0,"alert_quantity":"2","max_quantity":"0","cost":"190.0000","average_cost":null,"price":"230.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:50:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2012-12-30 21:04:14', 'admin'),
(158, 'sales', 'edit', 'invoice', NULL, '[]', '2012-12-30 21:04:32', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(159, 'sales', 'deliver', 'invoice', 10008, '{"id":"10008","txn_no":"1-10006","quote_id":"0","sales_order_id":"0","number":"0","po_number":"2348928","date":"2012-12-30 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"1","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"42.00","adjustment":"0.00","adjustment_type":"Add","total":"5276.00","total_delivered":"5276.00","cost":null,"tags":"","added_on":"2012-12-30 21:04:12","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"1\\":\\"0.00\\"}","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"13","invoice_id":"10008","type":"product","date":"2012-12-30 12:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"6.0000","price":"60.00","cost":"20.00","margin":null,"delivered":"10","delivered_price":"60.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"14","invoice_id":"10008","type":"product","date":"2012-12-30 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"12","price_per_unit":"77.0000","price":"924.00","cost":"600.00","margin":null,"delivered":"12","delivered_price":"924.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"15","invoice_id":"10008","type":"product","date":"2012-12-30 12:00:00","item_name":"Basic Bankbook Holder","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"55.0000","price":"550.00","cost":"200.00","margin":null,"delivered":"10","delivered_price":"550.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"16","invoice_id":"10008","type":"product","date":"2012-12-30 12:00:00","item_name":"Black Silk Scarves with Pin","item_description":"","item_id":"37","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"12","price_per_unit":"45.0000","price":"540.00","cost":"240.00","margin":null,"delivered":"12","delivered_price":"540.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"17","invoice_id":"10008","type":"product","date":"2012-12-30 12:00:00","item_name":"Blossom Bag","item_description":"","item_id":"57","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"12","price_per_unit":"180.0000","price":"2160.00","cost":"1440.00","margin":null,"delivered":"12","delivered_price":"2160.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"18","invoice_id":"10008","type":"product","date":"2012-12-30 12:00:00","item_name":"Blossom Tote Bag","item_description":"","item_id":"52","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"5","price_per_unit":"200.0000","price":"1000.00","cost":"950.00","margin":null,"delivered":"5","delivered_price":"1000.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":-10,"alert_quantity":"2","max_quantity":"0","cost":"2.0000","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":-12,"alert_quantity":"2","max_quantity":"0","cost":"50.0000","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":-10,"alert_quantity":"2","max_quantity":"0","cost":"20.0000","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"37":{"id":"37","primary_image":"BlackSlikScarvesWithPin.jpg","image":"BlackSlikScarvesWithPin.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Black Silk Scarves with Pin","model_no":"","warranty":"","sku":"BSSP908023","sku2":"","sku3":"","sku4":"","qty":-12,"alert_quantity":"2","max_quantity":"0","cost":"20.0000","average_cost":null,"price":"49.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:33:04","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:55","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"57":{"id":"57","primary_image":"BlossomBag.jpg","image":"BlossomBag.jpg","category":"Women","subcategory":"Bags","brand":"0","location":"","name":"Blossom Bag","model_no":"","warranty":"","sku":"BB13119","sku2":"","sku3":"","sku4":"","qty":-12,"alert_quantity":"2","max_quantity":"0","cost":"120.0000","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:52:28","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:55","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"52":{"id":"52","primary_image":"BlossomToteBag.jpg","image":"BlossomToteBag.jpg","category":"Women","subcategory":"Bags","brand":"0","location":"","name":"Blossom Tote Bag","model_no":"","warranty":"","sku":"BTB1231","sku2":"","sku3":"","sku4":"","qty":-5,"alert_quantity":"2","max_quantity":"0","cost":"190.0000","average_cost":null,"price":"230.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:50:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:55","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2012-12-30 21:05:55', 'admin'),
(160, 'sales', 'status_update', 'invoice', 10008, '{"id":"10008","txn_no":"1-10006","quote_id":"0","sales_order_id":"0","number":"0","po_number":"2348928","date":"2012-12-30 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"1","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"42.00","adjustment":"0.00","adjustment_type":"Add","total":"5276.00","total_delivered":"5276.00","cost":null,"tags":"","added_on":"2012-12-30 21:04:12","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"1\\":\\"0.00\\"}","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"13","invoice_id":"10008","type":"product","date":"2012-12-30 12:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"6.0000","price":"60.00","cost":"20.00","margin":null,"delivered":"10","delivered_price":"60.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"14","invoice_id":"10008","type":"product","date":"2012-12-30 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"12","price_per_unit":"77.0000","price":"924.00","cost":"600.00","margin":null,"delivered":"12","delivered_price":"924.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"15","invoice_id":"10008","type":"product","date":"2012-12-30 12:00:00","item_name":"Basic Bankbook Holder","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"55.0000","price":"550.00","cost":"200.00","margin":null,"delivered":"10","delivered_price":"550.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"16","invoice_id":"10008","type":"product","date":"2012-12-30 12:00:00","item_name":"Black Silk Scarves with Pin","item_description":"","item_id":"37","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"12","price_per_unit":"45.0000","price":"540.00","cost":"240.00","margin":null,"delivered":"12","delivered_price":"540.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"17","invoice_id":"10008","type":"product","date":"2012-12-30 12:00:00","item_name":"Blossom Bag","item_description":"","item_id":"57","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"12","price_per_unit":"180.0000","price":"2160.00","cost":"1440.00","margin":null,"delivered":"12","delivered_price":"2160.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"18","invoice_id":"10008","type":"product","date":"2012-12-30 12:00:00","item_name":"Blossom Tote Bag","item_description":"","item_id":"52","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"5","price_per_unit":"200.0000","price":"1000.00","cost":"950.00","margin":null,"delivered":"5","delivered_price":"1000.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":-10,"alert_quantity":"2","max_quantity":"0","cost":"2.0000","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":-12,"alert_quantity":"2","max_quantity":"0","cost":"50.0000","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":-10,"alert_quantity":"2","max_quantity":"0","cost":"20.0000","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"37":{"id":"37","primary_image":"BlackSlikScarvesWithPin.jpg","image":"BlackSlikScarvesWithPin.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Black Silk Scarves with Pin","model_no":"","warranty":"","sku":"BSSP908023","sku2":"","sku3":"","sku4":"","qty":-12,"alert_quantity":"2","max_quantity":"0","cost":"20.0000","average_cost":null,"price":"49.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:33:04","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:55","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"57":{"id":"57","primary_image":"BlossomBag.jpg","image":"BlossomBag.jpg","category":"Women","subcategory":"Bags","brand":"0","location":"","name":"Blossom Bag","model_no":"","warranty":"","sku":"BB13119","sku2":"","sku3":"","sku4":"","qty":-12,"alert_quantity":"2","max_quantity":"0","cost":"120.0000","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:52:28","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:55","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"52":{"id":"52","primary_image":"BlossomToteBag.jpg","image":"BlossomToteBag.jpg","category":"Women","subcategory":"Bags","brand":"0","location":"","name":"Blossom Tote Bag","model_no":"","warranty":"","sku":"BTB1231","sku2":"","sku3":"","sku4":"","qty":-5,"alert_quantity":"2","max_quantity":"0","cost":"190.0000","average_cost":null,"price":"230.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:50:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:55","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2012-12-30 21:06:03', 'admin'),
(161, 'sales', 'status_update', 'so', 4, '{"id":"4","txn_no":"1-10001","quote_id":null,"invoice_id":"10001","number":null,"po_number":null,"date":"2012-12-12 21:39:12","due_date":"2013-01-11 21:39:12","received_date":null,"contact_person":null,"contact":"Shafiq Rizwan","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman Bukit Indah\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Shafiq Rizwan\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman Bukit Indah\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"zipcode\\":\\"14000\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"No remarks","status":"Pending","payment_gateway":"testgateway","payment_method":"Test Gateway","payment_status":"Paid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":"Self Pickup","shipping_id":"6","handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"1017.50","total_delivered":null,"cost":"350.00","tags":"Online Sales","added_on":"2012-12-12 21:39:12","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":"[{\\"type\\":\\"New Order\\",\\"datetime\\":\\"2012-12-12 21:39:13\\",\\"by\\":\\"Auto-Responder\\",\\"status\\":\\"Paid\\"}]","orders":[{"id":"1","sales_order_id":"4","type":"product","date":"2012-12-12 21:39:12","item_name":"Slice Table Lamp","item_description":"","item_id":"10","service_id":null,"item_sku":"STL1230","discount":null,"discount_type":null,"qty":"3","price_per_unit":"112.5000","price":"337.50","cost":"270.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"3","sales_order_id":"4","type":"product","date":"2012-12-12 21:39:12","item_name":"Torsade Table Lamp 30","item_description":"","item_id":"12","service_id":null,"item_sku":"TTL23012","discount":null,"discount_type":null,"qty":"2","price_per_unit":"120.0000","price":"240.00","cost":"160.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"2","sales_order_id":"4","type":"product","date":"2012-12-12 21:39:12","item_name":"Tripod Nest","item_description":"","item_id":"11","service_id":null,"item_sku":"TN1230","discount":null,"discount_type":null,"qty":"2","price_per_unit":"220.0000","price":"440.00","cost":"360.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"10":{"id":"10","primary_image":"Slice20.jpg","image":"Slice20.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Slice Table Lamp","model_no":"","warranty":"","sku":"STL1230","sku2":"","sku3":"","sku4":"","qty":97,"alert_quantity":"2","max_quantity":"0","cost":"90.0000","average_cost":null,"price":"112.50","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 12:59:59","added_by":"admin","modified_on":"2012-12-12 13:00:13","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2012-12-14 08:53:31","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"11":{"id":"11","primary_image":"Tripod_Nest___caption.jpg","image":"Tripod_Nest___caption.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Tripod Nest","model_no":"","warranty":"","sku":"TN1230","sku2":"","sku3":"","sku4":"","qty":100,"alert_quantity":"2","max_quantity":"0","cost":"180.0000","average_cost":null,"price":"220.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:01:12","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"12":{"id":"12","primary_image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Torsade Table Lamp 30","model_no":"","warranty":"","sku":"TTL23012","sku2":"","sku3":"","sku4":"","qty":100,"alert_quantity":"1","max_quantity":"0","cost":"80.0000","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:03:25","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2012-12-30 22:44:51', 'admin'),
(162, 'sales', 'status_update', 'so', 4, '{"id":"4","txn_no":"1-10001","quote_id":null,"invoice_id":"10001","number":null,"po_number":null,"date":"2012-12-12 21:39:12","due_date":"2013-01-11 21:39:12","received_date":null,"contact_person":null,"contact":"Shafiq Rizwan","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman Bukit Indah\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Shafiq Rizwan\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman Bukit Indah\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"zipcode\\":\\"14000\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"No remarks","status":"Completed","payment_gateway":"testgateway","payment_method":"Test Gateway","payment_status":"Paid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":"Self Pickup","shipping_id":"6","handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"1017.50","total_delivered":null,"cost":"350.00","tags":"Online Sales","added_on":"2012-12-12 21:39:12","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":"[{\\"type\\":\\"New Order\\",\\"datetime\\":\\"2012-12-12 21:39:13\\",\\"by\\":\\"Auto-Responder\\",\\"status\\":\\"Paid\\"}]","orders":[{"id":"1","sales_order_id":"4","type":"product","date":"2012-12-12 21:39:12","item_name":"Slice Table Lamp","item_description":"","item_id":"10","service_id":null,"item_sku":"STL1230","discount":null,"discount_type":null,"qty":"3","price_per_unit":"112.5000","price":"337.50","cost":"270.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"3","sales_order_id":"4","type":"product","date":"2012-12-12 21:39:12","item_name":"Torsade Table Lamp 30","item_description":"","item_id":"12","service_id":null,"item_sku":"TTL23012","discount":null,"discount_type":null,"qty":"2","price_per_unit":"120.0000","price":"240.00","cost":"160.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"2","sales_order_id":"4","type":"product","date":"2012-12-12 21:39:12","item_name":"Tripod Nest","item_description":"","item_id":"11","service_id":null,"item_sku":"TN1230","discount":null,"discount_type":null,"qty":"2","price_per_unit":"220.0000","price":"440.00","cost":"360.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"10":{"id":"10","primary_image":"Slice20.jpg","image":"Slice20.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Slice Table Lamp","model_no":"","warranty":"","sku":"STL1230","sku2":"","sku3":"","sku4":"","qty":97,"alert_quantity":"2","max_quantity":"0","cost":"90.0000","average_cost":null,"price":"112.50","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 12:59:59","added_by":"admin","modified_on":"2012-12-12 13:00:13","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2012-12-14 08:53:31","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"11":{"id":"11","primary_image":"Tripod_Nest___caption.jpg","image":"Tripod_Nest___caption.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Tripod Nest","model_no":"","warranty":"","sku":"TN1230","sku2":"","sku3":"","sku4":"","qty":100,"alert_quantity":"2","max_quantity":"0","cost":"180.0000","average_cost":null,"price":"220.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:01:12","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"12":{"id":"12","primary_image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Torsade Table Lamp 30","model_no":"","warranty":"","sku":"TTL23012","sku2":"","sku3":"","sku4":"","qty":100,"alert_quantity":"1","max_quantity":"0","cost":"80.0000","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:03:25","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2012-12-30 22:45:07', 'admin'),
(163, 'sales', 'add', 'so', 21, '{"id":"21","txn_no":"1-10006","quote_id":"0","invoice_id":null,"number":"0","po_number":"0","date":"2012-12-01 00:00:00","due_date":"2012-12-05 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"187.00","total_delivered":null,"cost":null,"tags":"","added_on":"2012-12-30 22:45:56","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"13","sales_order_id":"21","type":"product","date":"2012-12-01 00:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"6.0000","price":"6.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"14","sales_order_id":"21","type":"product","date":"2012-12-01 00:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"77.0000","price":"77.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"15","sales_order_id":"21","type":"product","date":"2012-12-01 00:00:00","item_name":"Basic Bankbook Holder","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"55.0000","price":"55.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"16","sales_order_id":"21","type":"product","date":"2012-12-01 00:00:00","item_name":"Black Silk Scarves with Pin","item_description":"","item_id":"37","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"49.0000","price":"49.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":-10,"alert_quantity":"2","max_quantity":"0","cost":"2.0000","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":-12,"alert_quantity":"2","max_quantity":"0","cost":"50.0000","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":-10,"alert_quantity":"2","max_quantity":"0","cost":"20.0000","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"37":{"id":"37","primary_image":"BlackSlikScarvesWithPin.jpg","image":"BlackSlikScarvesWithPin.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Black Silk Scarves with Pin","model_no":"","warranty":"","sku":"BSSP908023","sku2":"","sku3":"","sku4":"","qty":-12,"alert_quantity":"2","max_quantity":"0","cost":"20.0000","average_cost":null,"price":"49.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:33:04","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:55","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2012-12-30 22:45:56', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(164, 'sales', 'status_update', 'so', 21, '{"id":"21","txn_no":"1-10006","quote_id":"0","invoice_id":null,"number":"0","po_number":"0","date":"2012-12-01 00:00:00","due_date":"2012-12-05 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Completed","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"187.00","total_delivered":null,"cost":null,"tags":"","added_on":"2012-12-30 22:45:56","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"13","sales_order_id":"21","type":"product","date":"2012-12-01 00:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"6.0000","price":"6.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"14","sales_order_id":"21","type":"product","date":"2012-12-01 00:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"77.0000","price":"77.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"15","sales_order_id":"21","type":"product","date":"2012-12-01 00:00:00","item_name":"Basic Bankbook Holder","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"55.0000","price":"55.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"16","sales_order_id":"21","type":"product","date":"2012-12-01 00:00:00","item_name":"Black Silk Scarves with Pin","item_description":"","item_id":"37","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"49.0000","price":"49.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":-10,"alert_quantity":"2","max_quantity":"0","cost":"2.0000","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":-12,"alert_quantity":"2","max_quantity":"0","cost":"50.0000","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":-10,"alert_quantity":"2","max_quantity":"0","cost":"20.0000","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"37":{"id":"37","primary_image":"BlackSlikScarvesWithPin.jpg","image":"BlackSlikScarvesWithPin.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Black Silk Scarves with Pin","model_no":"","warranty":"","sku":"BSSP908023","sku2":"","sku3":"","sku4":"","qty":-12,"alert_quantity":"2","max_quantity":"0","cost":"20.0000","average_cost":null,"price":"49.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:33:04","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:55","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2012-12-30 22:46:09', 'admin'),
(165, 'sales', 'add', 'invoice', 10009, '{"id":"10009","txn_no":"1-10007","quote_id":"0","sales_order_id":"21","number":"0","po_number":"0","date":"2012-12-01 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"187.00","total_delivered":null,"cost":null,"tags":"","added_on":"2012-12-30 22:46:25","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"25","invoice_id":"10009","type":"product","date":"2012-12-01 12:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"6.0000","price":"6.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"26","invoice_id":"10009","type":"product","date":"2012-12-01 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"77.0000","price":"77.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"27","invoice_id":"10009","type":"product","date":"2012-12-01 12:00:00","item_name":"Basic Bankbook Holder","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"55.0000","price":"55.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"28","invoice_id":"10009","type":"product","date":"2012-12-01 12:00:00","item_name":"Black Silk Scarves with Pin","item_description":"","item_id":"37","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"49.0000","price":"49.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":-10,"alert_quantity":"2","max_quantity":"0","cost":"2.0000","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":-12,"alert_quantity":"2","max_quantity":"0","cost":"50.0000","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":-10,"alert_quantity":"2","max_quantity":"0","cost":"20.0000","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"37":{"id":"37","primary_image":"BlackSlikScarvesWithPin.jpg","image":"BlackSlikScarvesWithPin.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Black Silk Scarves with Pin","model_no":"","warranty":"","sku":"BSSP908023","sku2":"","sku3":"","sku4":"","qty":-12,"alert_quantity":"2","max_quantity":"0","cost":"20.0000","average_cost":null,"price":"49.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:33:04","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:55","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2012-12-30 22:46:25', 'admin'),
(166, 'inventory', 'add', 'po', 10001, '{"id":"10001","txn_no":"1-10001","invoice_number":"1","number":null,"date":"2013-01-02 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"52.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-01-02 13:48:20","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"11","purchase_order_id":"10001","date":"2013-01-02 00:00:00","item_description":null,"item_name":"Accessory Strap ()","item_id":"66","discount":"0","discount_type":null,"qty":"1","price_per_unit":"2.0000","price":"2.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"},{"id":"12","purchase_order_id":"10001","date":"2013-01-02 00:00:00","item_description":null,"item_name":"Almeta ()","item_id":"25","discount":"0","discount_type":null,"qty":"1","price_per_unit":"50.0000","price":"50.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":-10,"alert_quantity":"2","max_quantity":"0","cost":"2.0000","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":-12,"alert_quantity":"2","max_quantity":"0","cost":"50.0000","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-01-02 13:48:20', 'admin'),
(167, 'contacts', 'add', 'contact', 1121, '{"id":"1121","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Restoran Nasi Kandar Subaidah (M) Sdn.Bhd  (CF)","company_registration":"527629-A","contact_person":"Hakim","contact_number":"012-413-2656","credit_limit":"0.00","rank":"0","email":"subaidahoffice@gmail.com","ic":"","password":"6e7eced602e8be0425dd26867dbab90b","introducer_ic":null,"address1":"5018,Jalan chain Ferry ,","address2":"","city":"Butterworth","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"012-207-2656","fax":"04-3324090","general_email":"subaidah080@gmail.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-01-28 09:10:01","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2013-01-28 09:10:01', 'admin'),
(168, 'inventory', 'edit', 'item', 15, '{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"9","alert_quantity":"3","max_quantity":"0","cost":null,"average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-10 11:01:52","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2013-02-10 11:01:52', 'admin2'),
(169, 'inventory', 'edit', 'item', 15, '{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"9","alert_quantity":"3","max_quantity":"0","cost":null,"average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-10 11:02:24","modified_by":"admin2","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2013-02-10 11:02:24', 'admin2'),
(170, 'inventory', 'edit', 'item', 15, '{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"9","alert_quantity":"3","max_quantity":"0","cost":null,"average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-10 11:03:43","modified_by":"admin2","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2013-02-10 11:03:43', 'admin2'),
(171, 'inventory', 'add', 'po', 10002, '{"id":"10002","txn_no":"1-10002","invoice_number":"","number":null,"date":"2013-02-10 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"30000.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-02-10 11:05:17","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"13","purchase_order_id":"10002","date":"2013-02-10 00:00:00","item_description":null,"item_name":"Supertripod Standing Lamp ()","item_id":"15","discount":"0","discount_type":null,"qty":"100","price_per_unit":"300.0000","price":"30000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"9","alert_quantity":"3","max_quantity":"0","cost":null,"average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-10 11:03:43","modified_by":"admin2","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-02-10 11:05:18', 'admin2'),
(172, 'sales', 'add', 'so', 22, '{"id":"22","txn_no":"1-10007","quote_id":"0","invoice_id":null,"number":"0","po_number":"10002","date":"2013-02-10 00:00:00","due_date":"2013-02-10 00:00:00","received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"30000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-02-10 11:07:43","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"17","sales_order_id":"22","type":"product","date":"2013-02-10 00:00:00","item_name":"Supertripod Standing Lamp ()","item_description":"","item_id":"15","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"300.0000","price":"30000.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"9","alert_quantity":"3","max_quantity":"0","cost":null,"average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-10 11:03:43","modified_by":"admin2","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2013-02-10 11:07:43', 'admin2'),
(173, 'sales', 'status_update', 'so', 22, '{"id":"22","txn_no":"1-10007","quote_id":"0","invoice_id":null,"number":"0","po_number":"10002","date":"2013-02-10 00:00:00","due_date":"2013-02-10 00:00:00","received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Completed","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"30000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-02-10 11:07:43","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"17","sales_order_id":"22","type":"product","date":"2013-02-10 00:00:00","item_name":"Supertripod Standing Lamp ()","item_description":"","item_id":"15","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"300.0000","price":"30000.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"9","alert_quantity":"3","max_quantity":"0","cost":null,"average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-10 11:03:43","modified_by":"admin2","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2013-02-10 11:10:15', 'admin2'),
(174, 'sales', 'add', 'invoice', 10010, '{"id":"10010","txn_no":"1-10008","quote_id":"0","sales_order_id":"22","number":"0","po_number":"10002","date":"2013-02-10 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2700.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-02-10 11:11:44","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"29","invoice_id":"10010","type":"product","date":"2013-02-10 12:00:00","item_name":"Supertripod Standing Lamp ()","item_description":"","item_id":"15","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"9","price_per_unit":"300.0000","price":"2700.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"9","alert_quantity":"3","max_quantity":"0","cost":null,"average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-10 11:03:43","modified_by":"admin2","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-02-10 11:11:45', 'admin2'),
(175, 'sales', 'status_update', 'invoice', 10010, '{"id":"10010","txn_no":"1-10008","quote_id":"0","sales_order_id":"22","number":"0","po_number":"10002","date":"2013-02-10 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2700.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-02-10 11:11:44","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"29","invoice_id":"10010","type":"product","date":"2013-02-10 12:00:00","item_name":"Supertripod Standing Lamp ()","item_description":"","item_id":"15","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"9","price_per_unit":"300.0000","price":"2700.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"9","alert_quantity":"3","max_quantity":"0","cost":null,"average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-10 11:03:43","modified_by":"admin2","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-02-10 11:12:20', 'admin2');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(176, 'sales', 'status_update', 'invoice', 10010, '{"id":"10010","txn_no":"1-10008","quote_id":"0","sales_order_id":"22","number":"0","po_number":"10002","date":"2013-02-10 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2700.00","total_delivered":"0.00","cost":null,"tags":"","added_on":"2013-02-10 11:11:44","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"29","invoice_id":"10010","type":"product","date":"2013-02-10 12:00:00","item_name":"Supertripod Standing Lamp ()","item_description":"","item_id":"15","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"9","price_per_unit":"300.0000","price":"2700.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":null,"done":"0","no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"9","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-10 11:03:43","modified_by":"admin2","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-02-10 11:12:32', 'admin2'),
(177, 'sales', 'deliver', 'invoice', 10010, '{"id":"10010","txn_no":"1-10008","quote_id":"0","sales_order_id":"22","number":"0","po_number":"10002","date":"2013-02-10 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2700.00","total_delivered":"2700.00","cost":null,"tags":"","added_on":"2013-02-10 11:11:44","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"29","invoice_id":"10010","type":"product","date":"2013-02-10 12:00:00","item_name":"Supertripod Standing Lamp ()","item_description":"","item_id":"15","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"9","price_per_unit":"300.0000","price":"2700.00","cost":"0.00","margin":null,"delivered":"9","delivered_price":"2700.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-10 11:03:43","modified_by":"admin2","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-10 11:12:45","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-02-10 11:12:45', 'admin2'),
(178, 'sales', 'deliver', 'invoice', 10010, '{"id":"10010","txn_no":"1-10008","quote_id":"0","sales_order_id":"22","number":"0","po_number":"10002","date":"2013-02-10 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2700.00","total_delivered":"2700.00","cost":null,"tags":"","added_on":"2013-02-10 11:11:44","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"29","invoice_id":"10010","type":"product","date":"2013-02-10 12:00:00","item_name":"Supertripod Standing Lamp ()","item_description":"","item_id":"15","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"9","price_per_unit":"300.0000","price":"2700.00","cost":"0.00","margin":null,"delivered":"9","delivered_price":"2700.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-10 11:03:43","modified_by":"admin2","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-10 11:13:03","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-02-10 11:13:03', 'admin2'),
(179, 'sales', 'status_update', 'invoice', 10010, '{"id":"10010","txn_no":"1-10008","quote_id":"0","sales_order_id":"22","number":"0","po_number":"10002","date":"2013-02-10 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Partially Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2700.00","total_delivered":"2700.00","cost":null,"tags":"","added_on":"2013-02-10 11:11:44","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"29","invoice_id":"10010","type":"product","date":"2013-02-10 12:00:00","item_name":"Supertripod Standing Lamp ()","item_description":"","item_id":"15","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"9","price_per_unit":"300.0000","price":"2700.00","cost":"0.00","margin":null,"delivered":"9","delivered_price":"2700.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-10 11:03:43","modified_by":"admin2","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-10 11:13:03","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-02-10 11:14:57', 'admin2'),
(180, 'sales', 'deliver', 'invoice', 10010, '{"id":"10010","txn_no":"1-10008","quote_id":"0","sales_order_id":"22","number":"0","po_number":"10002","date":"2013-02-10 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2700.00","total_delivered":"2700.00","cost":null,"tags":"","added_on":"2013-02-10 11:11:44","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"29","invoice_id":"10010","type":"product","date":"2013-02-10 12:00:00","item_name":"Supertripod Standing Lamp ()","item_description":"","item_id":"15","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"9","price_per_unit":"300.0000","price":"2700.00","cost":"0.00","margin":null,"delivered":"9","delivered_price":"2700.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-10 11:03:43","modified_by":"admin2","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-10 11:15:01","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-02-10 11:15:01', 'admin2'),
(181, 'inventory', 'edit', 'item', 15, '{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-10 13:09:47","modified_by":"admin2","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-10 11:15:01","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2013-02-10 13:09:47', 'admin2'),
(182, 'inventory', 'edit', 'item', 15, '{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"Supertripod Standing Lamp","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:10","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-10 11:15:01","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2013-02-20 11:41:10', 'admin'),
(183, 'inventory', 'edit', 'item', 15, '{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-10 11:15:01","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2013-02-20 11:41:31', 'admin'),
(184, 'contacts', 'edit', 'contact', 1076, '{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"3d32c3d0e1b0a15a281b356beca225ca","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2013-02-20 11:42:49","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1355446310","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2013-02-20 11:42:49', 'admin'),
(185, 'sales', 'deliver', 'invoice', 10012, '{"id":"10012","txn_no":"1-10010","quote_id":null,"sales_order_id":"28","number":null,"po_number":null,"date":"2013-02-20 11:46:43","due_date":null,"received_date":null,"contact_person":null,"contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"22 Jalan Pegaga 2\\",\\"address2\\":\\"Taman Pegaga\\",\\"city\\":\\"Lunas\\",\\"state\\":\\"Kedah\\",\\"zipcode\\":\\"09600\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"Self Pickup","shipping_id":"6","terms":"Cash","duration":"0","remarks":"No remarks","status":"Pending","payment_status":"Paid","payment_date":"2013-02-20 11:46:43","payment_reference":"TXN-TEST1001","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"241.50","total_delivered":"241.50","cost":null,"tags":"Online Sales","added_on":"2013-02-20 11:46:43","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":null,"total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"32","invoice_id":"10012","type":"product","date":"2013-02-20 11:46:43","item_name":"Torsade Oblong Table","item_description":"","item_id":"9","service_id":null,"item_sku":"TOT1001","discount":null,"discount_type":null,"qty":"1","price_per_unit":"129.0000","price":"129.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"129.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"33","invoice_id":"10012","type":"product","date":"2013-02-20 11:46:43","item_name":"Slice Table Lamp","item_description":"","item_id":"10","service_id":null,"item_sku":"STL1230","discount":null,"discount_type":null,"qty":"1","price_per_unit":"112.5000","price":"112.50","cost":"0.00","margin":null,"delivered":"1","delivered_price":"112.50","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"9":{"id":"9","primary_image":"xTorsade2040.jpg.pagespeed_.ic_.0WQhAEsZIc_.jpg","image":"xTorsade2040.jpg.pagespeed_.ic_.0WQhAEsZIc_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Torsade Oblong Table","model_no":"","warranty":"","sku":"TOT1001","sku2":"","sku3":"","sku4":"","qty":"99","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"129.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 12:58:49","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 12:00:08","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"10":{"id":"10","primary_image":"Slice20.jpg","image":"Slice20.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Slice Table Lamp","model_no":"","warranty":"","sku":"STL1230","sku2":"","sku3":"","sku4":"","qty":"96","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"112.50","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 12:59:59","added_by":"admin","modified_on":"2012-12-12 13:00:13","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-20 12:00:08","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"3d32c3d0e1b0a15a281b356beca225ca","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2013-02-20 11:42:49","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1361331784","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-02-20 12:00:08', 'admin'),
(186, 'sales', 'status_update', 'invoice', 10012, '{"id":"10012","txn_no":"1-10010","quote_id":null,"sales_order_id":"28","number":null,"po_number":null,"date":"2013-02-20 11:46:43","due_date":null,"received_date":null,"contact_person":null,"contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"22 Jalan Pegaga 2\\",\\"address2\\":\\"Taman Pegaga\\",\\"city\\":\\"Lunas\\",\\"state\\":\\"Kedah\\",\\"zipcode\\":\\"09600\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"Self Pickup","shipping_id":"6","terms":"Cash","duration":"0","remarks":"No remarks","status":"Delivered","payment_status":"Paid","payment_date":"2013-02-20 11:46:43","payment_reference":"TXN-TEST1001","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"241.50","total_delivered":"241.50","cost":null,"tags":"Online Sales","added_on":"2013-02-20 11:46:43","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":null,"total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"32","invoice_id":"10012","type":"product","date":"2013-02-20 11:46:43","item_name":"Torsade Oblong Table","item_description":"","item_id":"9","service_id":null,"item_sku":"TOT1001","discount":null,"discount_type":null,"qty":"1","price_per_unit":"129.0000","price":"129.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"129.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"33","invoice_id":"10012","type":"product","date":"2013-02-20 11:46:43","item_name":"Slice Table Lamp","item_description":"","item_id":"10","service_id":null,"item_sku":"STL1230","discount":null,"discount_type":null,"qty":"1","price_per_unit":"112.5000","price":"112.50","cost":"0.00","margin":null,"delivered":"1","delivered_price":"112.50","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"9":{"id":"9","primary_image":"xTorsade2040.jpg.pagespeed_.ic_.0WQhAEsZIc_.jpg","image":"xTorsade2040.jpg.pagespeed_.ic_.0WQhAEsZIc_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Torsade Oblong Table","model_no":"","warranty":"","sku":"TOT1001","sku2":"","sku3":"","sku4":"","qty":"99","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"129.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 12:58:49","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 12:00:08","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"10":{"id":"10","primary_image":"Slice20.jpg","image":"Slice20.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Slice Table Lamp","model_no":"","warranty":"","sku":"STL1230","sku2":"","sku3":"","sku4":"","qty":"96","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"112.50","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 12:59:59","added_by":"admin","modified_on":"2012-12-12 13:00:13","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-20 12:00:08","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"3d32c3d0e1b0a15a281b356beca225ca","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2013-02-20 11:42:49","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1361331784","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-02-20 12:00:11', 'admin'),
(187, 'sales', 'deliver', 'invoice', 10011, '{"id":"10011","txn_no":"1-10009","quote_id":null,"sales_order_id":"25","number":null,"po_number":null,"date":"2013-02-20 11:45:20","due_date":null,"received_date":null,"contact_person":null,"contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"22 Jalan Pegaga 2\\",\\"address2\\":\\"Taman Pegaga\\",\\"city\\":\\"Lunas\\",\\"state\\":\\"Kedah\\",\\"zipcode\\":\\"09600\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"Self Pickup","shipping_id":"6","terms":"Cash","duration":"0","remarks":"No remarks","status":"Pending","payment_status":"Paid","payment_date":"2013-02-20 11:45:20","payment_reference":"TXN-TEST1001","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"241.50","total_delivered":"241.50","cost":null,"tags":"Online Sales","added_on":"2013-02-20 11:45:20","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":null,"total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"30","invoice_id":"10011","type":"product","date":"2013-02-20 11:45:21","item_name":"Torsade Oblong Table","item_description":"","item_id":"9","service_id":null,"item_sku":"TOT1001","discount":null,"discount_type":null,"qty":"1","price_per_unit":"129.0000","price":"129.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"129.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"31","invoice_id":"10011","type":"product","date":"2013-02-20 11:45:21","item_name":"Slice Table Lamp","item_description":"","item_id":"10","service_id":null,"item_sku":"STL1230","discount":null,"discount_type":null,"qty":"1","price_per_unit":"112.5000","price":"112.50","cost":"0.00","margin":null,"delivered":"1","delivered_price":"112.50","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"9":{"id":"9","primary_image":"xTorsade2040.jpg.pagespeed_.ic_.0WQhAEsZIc_.jpg","image":"xTorsade2040.jpg.pagespeed_.ic_.0WQhAEsZIc_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Torsade Oblong Table","model_no":"","warranty":"","sku":"TOT1001","sku2":"","sku3":"","sku4":"","qty":"98","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"129.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 12:58:49","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 12:16:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"10":{"id":"10","primary_image":"Slice20.jpg","image":"Slice20.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Slice Table Lamp","model_no":"","warranty":"","sku":"STL1230","sku2":"","sku3":"","sku4":"","qty":"95","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"112.50","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 12:59:59","added_by":"admin","modified_on":"2012-12-12 13:00:13","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-20 12:16:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"3d32c3d0e1b0a15a281b356beca225ca","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2013-02-20 11:42:49","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1361331784","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-02-20 12:16:54', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(188, 'sales', 'status_update', 'invoice', 10011, '{"id":"10011","txn_no":"1-10009","quote_id":null,"sales_order_id":"25","number":null,"po_number":null,"date":"2013-02-20 11:45:20","due_date":null,"received_date":null,"contact_person":null,"contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"22 Jalan Pegaga 2\\",\\"address2\\":\\"Taman Pegaga\\",\\"city\\":\\"Lunas\\",\\"state\\":\\"Kedah\\",\\"zipcode\\":\\"09600\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"Self Pickup","shipping_id":"6","terms":"Cash","duration":"0","remarks":"No remarks","status":"Delivered","payment_status":"Paid","payment_date":"2013-02-20 11:45:20","payment_reference":"TXN-TEST1001","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"241.50","total_delivered":"241.50","cost":null,"tags":"Online Sales","added_on":"2013-02-20 11:45:20","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":null,"total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"30","invoice_id":"10011","type":"product","date":"2013-02-20 11:45:21","item_name":"Torsade Oblong Table","item_description":"","item_id":"9","service_id":null,"item_sku":"TOT1001","discount":null,"discount_type":null,"qty":"1","price_per_unit":"129.0000","price":"129.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"129.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"31","invoice_id":"10011","type":"product","date":"2013-02-20 11:45:21","item_name":"Slice Table Lamp","item_description":"","item_id":"10","service_id":null,"item_sku":"STL1230","discount":null,"discount_type":null,"qty":"1","price_per_unit":"112.5000","price":"112.50","cost":"0.00","margin":null,"delivered":"1","delivered_price":"112.50","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"9":{"id":"9","primary_image":"xTorsade2040.jpg.pagespeed_.ic_.0WQhAEsZIc_.jpg","image":"xTorsade2040.jpg.pagespeed_.ic_.0WQhAEsZIc_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Torsade Oblong Table","model_no":"","warranty":"","sku":"TOT1001","sku2":"","sku3":"","sku4":"","qty":"98","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"129.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 12:58:49","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 12:16:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"10":{"id":"10","primary_image":"Slice20.jpg","image":"Slice20.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Slice Table Lamp","model_no":"","warranty":"","sku":"STL1230","sku2":"","sku3":"","sku4":"","qty":"95","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"112.50","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 12:59:59","added_by":"admin","modified_on":"2012-12-12 13:00:13","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-20 12:16:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"3d32c3d0e1b0a15a281b356beca225ca","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2013-02-20 11:42:49","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1361331784","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-02-20 12:16:56', 'admin'),
(189, 'sales', 'delivery_status_update', 'do', 10012, '{"id":"10012","txn_no":"1-10010","quote_id":null,"sales_order_id":"28","number":null,"po_number":null,"date":"2013-02-20 11:46:43","due_date":null,"received_date":null,"contact_person":null,"contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"22 Jalan Pegaga 2\\",\\"address2\\":\\"Taman Pegaga\\",\\"city\\":\\"Lunas\\",\\"state\\":\\"Kedah\\",\\"zipcode\\":\\"09600\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Delivered","delivery_date":null,"shipping":"Self Pickup","shipping_id":"6","terms":"Cash","duration":"0","remarks":"No remarks","status":"Delivered","payment_status":"Paid","payment_date":"2013-02-20 11:46:43","payment_reference":"TXN-TEST1001","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"241.50","total_delivered":"241.50","cost":null,"tags":"Online Sales","added_on":"2013-02-20 11:46:43","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":null,"total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"32","invoice_id":"10012","type":"product","date":"2013-02-20 11:46:43","item_name":"Torsade Oblong Table","item_description":"","item_id":"9","service_id":null,"item_sku":"TOT1001","discount":null,"discount_type":null,"qty":"1","price_per_unit":"129.0000","price":"129.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"129.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"33","invoice_id":"10012","type":"product","date":"2013-02-20 11:46:43","item_name":"Slice Table Lamp","item_description":"","item_id":"10","service_id":null,"item_sku":"STL1230","discount":null,"discount_type":null,"qty":"1","price_per_unit":"112.5000","price":"112.50","cost":"0.00","margin":null,"delivered":"1","delivered_price":"112.50","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"9":{"id":"9","primary_image":"xTorsade2040.jpg.pagespeed_.ic_.0WQhAEsZIc_.jpg","image":"xTorsade2040.jpg.pagespeed_.ic_.0WQhAEsZIc_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Torsade Oblong Table","model_no":"","warranty":"","sku":"TOT1001","sku2":"","sku3":"","sku4":"","qty":"98","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"129.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 12:58:49","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 12:16:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"10":{"id":"10","primary_image":"Slice20.jpg","image":"Slice20.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Slice Table Lamp","model_no":"","warranty":"","sku":"STL1230","sku2":"","sku3":"","sku4":"","qty":"95","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"112.50","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 12:59:59","added_by":"admin","modified_on":"2012-12-12 13:00:13","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-20 12:16:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"3d32c3d0e1b0a15a281b356beca225ca","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2013-02-20 11:42:49","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1361331784","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-02-20 12:23:06', 'admin'),
(190, 'sales', 'delivery_info_update', 'do', 10011, '{"id":"10011","txn_no":"1-10009","quote_id":null,"sales_order_id":"25","number":null,"po_number":null,"date":"2013-02-20 11:45:20","due_date":null,"received_date":null,"contact_person":null,"contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"22 Jalan Pegaga 2\\",\\"address2\\":\\"Taman Pegaga\\",\\"city\\":\\"Lunas\\",\\"state\\":\\"Kedah\\",\\"zipcode\\":\\"09600\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":"123","delivery_status":"Pending","delivery_date":"2013-02-20 00:00:00","shipping":"Self Pickup","shipping_id":"6","terms":"Cash","duration":"0","remarks":"No remarks","status":"Delivered","payment_status":"Paid","payment_date":"2013-02-20 11:45:20","payment_reference":"TXN-TEST1001","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"241.50","total_delivered":"241.50","cost":null,"tags":"Online Sales","added_on":"2013-02-20 11:45:20","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":null,"total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"30","invoice_id":"10011","type":"product","date":"2013-02-20 11:45:21","item_name":"Torsade Oblong Table","item_description":"","item_id":"9","service_id":null,"item_sku":"TOT1001","discount":null,"discount_type":null,"qty":"1","price_per_unit":"129.0000","price":"129.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"129.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"31","invoice_id":"10011","type":"product","date":"2013-02-20 11:45:21","item_name":"Slice Table Lamp","item_description":"","item_id":"10","service_id":null,"item_sku":"STL1230","discount":null,"discount_type":null,"qty":"1","price_per_unit":"112.5000","price":"112.50","cost":"0.00","margin":null,"delivered":"1","delivered_price":"112.50","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"9":{"id":"9","primary_image":"xTorsade2040.jpg.pagespeed_.ic_.0WQhAEsZIc_.jpg","image":"xTorsade2040.jpg.pagespeed_.ic_.0WQhAEsZIc_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Torsade Oblong Table","model_no":"","warranty":"","sku":"TOT1001","sku2":"","sku3":"","sku4":"","qty":"98","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"129.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 12:58:49","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 12:16:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"10":{"id":"10","primary_image":"Slice20.jpg","image":"Slice20.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Slice Table Lamp","model_no":"","warranty":"","sku":"STL1230","sku2":"","sku3":"","sku4":"","qty":"95","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"112.50","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 12:59:59","added_by":"admin","modified_on":"2012-12-12 13:00:13","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-20 12:16:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"3d32c3d0e1b0a15a281b356beca225ca","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2013-02-20 11:42:49","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1361331784","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-02-20 12:26:32', 'admin'),
(191, 'sales', 'deliver', 'invoice', 10009, '{"id":"10009","txn_no":"1-10007","quote_id":"0","sales_order_id":"21","number":"0","po_number":"0","date":"2012-12-01 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"187.00","total_delivered":"187.00","cost":null,"tags":"","added_on":"2012-12-30 22:46:25","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"25","invoice_id":"10009","type":"product","date":"2012-12-01 12:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"6.0000","price":"6.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"6.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"26","invoice_id":"10009","type":"product","date":"2012-12-01 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"77.0000","price":"77.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"77.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"27","invoice_id":"10009","type":"product","date":"2012-12-01 12:00:00","item_name":"Basic Bankbook Holder","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"55.0000","price":"55.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"55.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"28","invoice_id":"10009","type":"product","date":"2012-12-01 12:00:00","item_name":"Black Silk Scarves with Pin","item_description":"","item_id":"37","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"49.0000","price":"49.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"49.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"-11","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"-13","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"-11","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"37":{"id":"37","primary_image":"BlackSlikScarvesWithPin.jpg","image":"BlackSlikScarvesWithPin.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Black Silk Scarves with Pin","model_no":"","warranty":"","sku":"BSSP908023","sku2":"","sku3":"","sku4":"","qty":"-13","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"49.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:33:04","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-02-20 22:44:49', 'admin'),
(192, 'sales', 'status_update', 'invoice', 10009, '{"id":"10009","txn_no":"1-10007","quote_id":"0","sales_order_id":"21","number":"0","po_number":"0","date":"2012-12-01 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"187.00","total_delivered":"187.00","cost":null,"tags":"","added_on":"2012-12-30 22:46:25","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"25","invoice_id":"10009","type":"product","date":"2012-12-01 12:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"6.0000","price":"6.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"6.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"26","invoice_id":"10009","type":"product","date":"2012-12-01 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"77.0000","price":"77.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"77.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"27","invoice_id":"10009","type":"product","date":"2012-12-01 12:00:00","item_name":"Basic Bankbook Holder","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"55.0000","price":"55.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"55.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"28","invoice_id":"10009","type":"product","date":"2012-12-01 12:00:00","item_name":"Black Silk Scarves with Pin","item_description":"","item_id":"37","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"49.0000","price":"49.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"49.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"-11","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"-13","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"-11","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"37":{"id":"37","primary_image":"BlackSlikScarvesWithPin.jpg","image":"BlackSlikScarvesWithPin.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Black Silk Scarves with Pin","model_no":"","warranty":"","sku":"BSSP908023","sku2":"","sku3":"","sku4":"","qty":"-13","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"49.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:33:04","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-02-20 22:44:53', 'admin'),
(193, 'tax', 'edit', 'tax', 1, '{"id":"1","type":"0","name":"Service Tax","percentage":"5.000","enabled":"0"}', '2013-02-20 23:40:56', 'admin'),
(194, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"5.000","enabled":"0"}', '2013-02-20 23:40:58', 'admin'),
(195, 'inventory', 'add', 'po', 10003, '{"id":"10003","txn_no":"1-10003","invoice_number":"","number":null,"date":"2013-02-27 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-02-27 11:12:55","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"16","purchase_order_id":"10003","date":"2013-02-27 00:00:00","item_description":null,"item_name":"Supertripod Standing Lamp ()","item_id":"15","discount":"0","discount_type":null,"qty":"99","price_per_unit":"0.0000","price":"0.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"1","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-20 13:10:33","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-02-27 11:12:55', 'admin2'),
(196, 'inventory', 'paid', 'po', 10003, '{"id":"10003","txn_no":"1-10003","invoice_number":"","number":null,"date":"2013-02-27 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":null,"payment_status":"Paid","payment_date":"2013-02-27 00:00:00","payment_reference":"11","payment_contra":null,"tags":"","added_on":"2013-02-27 11:12:55","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"16","purchase_order_id":"10003","date":"2013-02-27 00:00:00","item_description":null,"item_name":"Supertripod Standing Lamp ()","item_id":"15","discount":"0","discount_type":null,"qty":"99","price_per_unit":"0.0000","price":"0.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"1","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-20 13:10:33","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-02-27 11:13:41', 'admin2'),
(197, 'inventory', 'receive', 'po', 10003, '{"id":"10003","txn_no":"1-10003","invoice_number":"","number":null,"date":"2013-02-27 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":"0.00","payment_status":"Paid","payment_date":"2013-02-27 00:00:00","payment_reference":"11","payment_contra":null,"tags":"","added_on":"2013-02-27 11:12:55","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"16","purchase_order_id":"10003","date":"2013-02-27 00:00:00","item_description":null,"item_name":"Supertripod Standing Lamp ()","item_id":"15","discount":"0","discount_type":null,"qty":"99","price_per_unit":"0.0000","price":"0.00","received":"99","received_price":"0.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"1","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-20 13:10:33","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-02-27 11:13:45', 'admin2');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(198, 'inventory', 'status_update', 'po', 10003, '{"id":"10003","txn_no":"1-10003","invoice_number":"","number":null,"date":"2013-02-27 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":"0.00","payment_status":"Paid","payment_date":"2013-02-27 00:00:00","payment_reference":"11","payment_contra":null,"tags":"","added_on":"2013-02-27 11:12:55","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"16","purchase_order_id":"10003","date":"2013-02-27 00:00:00","item_description":null,"item_name":"Supertripod Standing Lamp ()","item_id":"15","discount":"0","discount_type":null,"qty":"99","price_per_unit":"0.0000","price":"0.00","received":"99","received_price":"0.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"1","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-20 13:10:33","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-02-27 11:13:45', 'admin2'),
(199, 'inventory', 'add', 'po', 10004, '{"id":"10004","txn_no":"1-10004","invoice_number":"","number":null,"date":"2013-02-27 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-02-27 12:21:44","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"17","purchase_order_id":"10004","date":"2013-02-27 00:00:00","item_description":null,"item_name":"Supertripod Standing Lamp ()","item_id":"15","discount":"0","discount_type":null,"qty":"200","price_per_unit":"0.0000","price":"0.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"1","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-20 13:10:33","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-02-27 12:21:45', 'admin2'),
(200, 'inventory', 'paid', 'po', 10004, '{"id":"10004","txn_no":"1-10004","invoice_number":"","number":null,"date":"2013-02-27 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":null,"payment_status":"Paid","payment_date":"2013-02-27 00:00:00","payment_reference":"123","payment_contra":null,"tags":"","added_on":"2013-02-27 12:21:44","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"17","purchase_order_id":"10004","date":"2013-02-27 00:00:00","item_description":null,"item_name":"Supertripod Standing Lamp ()","item_id":"15","discount":"0","discount_type":null,"qty":"200","price_per_unit":"0.0000","price":"0.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"1","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-20 13:10:33","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-02-27 12:21:54', 'admin2'),
(201, 'inventory', 'receive', 'po', 10004, '{"id":"10004","txn_no":"1-10004","invoice_number":"","number":null,"date":"2013-02-27 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":"0.00","payment_status":"Paid","payment_date":"2013-02-27 00:00:00","payment_reference":"123","payment_contra":null,"tags":"","added_on":"2013-02-27 12:21:44","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"17","purchase_order_id":"10004","date":"2013-02-27 00:00:00","item_description":null,"item_name":"Supertripod Standing Lamp ()","item_id":"15","discount":"0","discount_type":null,"qty":"200","price_per_unit":"0.0000","price":"0.00","received":"200","received_price":"0.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"100","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-20 13:10:33","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-02-27 12:22:00', 'admin2'),
(202, 'inventory', 'status_update', 'po', NULL, '[]', '2013-02-27 12:22:00', 'admin2'),
(203, 'inventory', 'receive', 'po', 10004, '{"id":"10004","txn_no":"1-10004","invoice_number":"","number":null,"date":"2013-02-27 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":"0.00","payment_status":"Paid","payment_date":"2013-02-27 00:00:00","payment_reference":"123","payment_contra":null,"tags":"","added_on":"2013-02-27 12:21:44","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"17","purchase_order_id":"10004","date":"2013-02-27 00:00:00","item_description":null,"item_name":"Supertripod Standing Lamp ()","item_id":"15","discount":"0","discount_type":null,"qty":"200","price_per_unit":"0.0000","price":"0.00","received":"200","received_price":"0.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"300","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-20 13:10:33","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-02-27 12:22:07', 'admin2'),
(204, 'inventory', 'status_update', 'po', NULL, '[]', '2013-02-27 12:22:08', 'admin2'),
(205, 'inventory', 'add', 'po', 10005, '{"id":"10005","txn_no":"1-10005","invoice_number":"","number":null,"date":"2013-02-27 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-02-27 12:23:18","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"18","purchase_order_id":"10005","date":"2013-02-27 00:00:00","item_description":null,"item_name":"Supertripod Standing Lamp ()","item_id":"15","discount":"0","discount_type":null,"qty":"300","price_per_unit":"0.0000","price":"0.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"300","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-20 13:10:33","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-02-27 12:23:18', 'admin2'),
(206, 'inventory', 'paid', 'po', 10005, '{"id":"10005","txn_no":"1-10005","invoice_number":"","number":null,"date":"2013-02-27 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":null,"payment_status":"Paid","payment_date":"2013-02-27 00:00:00","payment_reference":"124","payment_contra":null,"tags":"","added_on":"2013-02-27 12:23:18","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"18","purchase_order_id":"10005","date":"2013-02-27 00:00:00","item_description":null,"item_name":"Supertripod Standing Lamp ()","item_id":"15","discount":"0","discount_type":null,"qty":"300","price_per_unit":"0.0000","price":"0.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"300","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-20 13:10:33","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-02-27 12:23:31', 'admin2'),
(207, 'inventory', 'receive', 'po', 10005, '{"id":"10005","txn_no":"1-10005","invoice_number":"","number":null,"date":"2013-02-27 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":"0.00","payment_status":"Paid","payment_date":"2013-02-27 00:00:00","payment_reference":"124","payment_contra":null,"tags":"","added_on":"2013-02-27 12:23:18","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"18","purchase_order_id":"10005","date":"2013-02-27 00:00:00","item_description":null,"item_name":"Supertripod Standing Lamp ()","item_id":"15","discount":"0","discount_type":null,"qty":"300","price_per_unit":"0.0000","price":"0.00","received":"300","received_price":"0.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"300","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-20 13:10:33","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-02-27 12:24:08', 'admin2'),
(208, 'inventory', 'status_update', 'po', NULL, '[]', '2013-02-27 12:24:09', 'admin2'),
(209, 'inventory', 'receive', 'po', 10005, '{"id":"10005","txn_no":"1-10005","invoice_number":"","number":null,"date":"2013-02-27 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":"0.00","payment_status":"Paid","payment_date":"2013-02-27 00:00:00","payment_reference":"124","payment_contra":null,"tags":"","added_on":"2013-02-27 12:23:18","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"18","purchase_order_id":"10005","date":"2013-02-27 00:00:00","item_description":null,"item_name":"Supertripod Standing Lamp ()","item_id":"15","discount":"0","discount_type":null,"qty":"300","price_per_unit":"0.0000","price":"0.00","received":"300","received_price":"0.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"600","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-20 13:10:33","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-02-27 12:24:17', 'admin2'),
(210, 'inventory', 'status_update', 'po', NULL, '[]', '2013-02-27 12:24:18', 'admin2'),
(211, 'inventory', 'add', 'po', 10006, '{"id":"10006","txn_no":"1-10006","invoice_number":"","number":null,"date":"2013-02-27 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"22000.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-02-27 18:05:03","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"19","purchase_order_id":"10006","date":"2013-02-27 00:00:00","item_description":null,"item_name":"Super Riva Aquarama ()","item_id":"31","discount":"0","discount_type":null,"qty":"100","price_per_unit":"220.0000","price":"22000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"31":{"id":"31","primary_image":"SuperRivaAquarama.jpg","image":"SuperRivaAquarama.jpg","category":"Home","subcategory":"Arts and Craft","brand":"0","location":"","name":"Super Riva Aquarama","model_no":"","warranty":"","sku":"SRA123129","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"390.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:25:26","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-02-27 18:05:04', 'admin2'),
(212, 'inventory', 'paid', 'po', 10006, '{"id":"10006","txn_no":"1-10006","invoice_number":"","number":null,"date":"2013-02-27 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"22000.00","total_received":null,"payment_status":"Paid","payment_date":"2013-02-27 00:00:00","payment_reference":"123","payment_contra":null,"tags":"","added_on":"2013-02-27 18:05:03","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"19","purchase_order_id":"10006","date":"2013-02-27 00:00:00","item_description":null,"item_name":"Super Riva Aquarama ()","item_id":"31","discount":"0","discount_type":null,"qty":"100","price_per_unit":"220.0000","price":"22000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"31":{"id":"31","primary_image":"SuperRivaAquarama.jpg","image":"SuperRivaAquarama.jpg","category":"Home","subcategory":"Arts and Craft","brand":"0","location":"","name":"Super Riva Aquarama","model_no":"","warranty":"","sku":"SRA123129","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"390.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:25:26","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-02-27 18:05:50', 'admin2'),
(213, 'inventory', 'receive', 'po', 10006, '{"id":"10006","txn_no":"1-10006","invoice_number":"","number":null,"date":"2013-02-27 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"22000.00","total_received":"22000.00","payment_status":"Paid","payment_date":"2013-02-27 00:00:00","payment_reference":"123","payment_contra":null,"tags":"","added_on":"2013-02-27 18:05:03","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"19","purchase_order_id":"10006","date":"2013-02-27 00:00:00","item_description":null,"item_name":"Super Riva Aquarama ()","item_id":"31","discount":"0","discount_type":null,"qty":"100","price_per_unit":"220.0000","price":"22000.00","received":"100","received_price":"22000.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"31":{"id":"31","primary_image":"SuperRivaAquarama.jpg","image":"SuperRivaAquarama.jpg","category":"Home","subcategory":"Arts and Craft","brand":"0","location":"","name":"Super Riva Aquarama","model_no":"","warranty":"","sku":"SRA123129","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"220.00","average_cost":null,"price":"390.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:25:26","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-02-27 18:06:25', 'admin2'),
(214, 'inventory', 'status_update', 'po', NULL, '[]', '2013-02-27 18:06:26', 'admin2'),
(215, 'inventory', 'receive', 'po', 10006, '{"id":"10006","txn_no":"1-10006","invoice_number":"","number":null,"date":"2013-02-27 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"22000.00","total_received":"22000.00","payment_status":"Paid","payment_date":"2013-02-27 00:00:00","payment_reference":"123","payment_contra":null,"tags":"","added_on":"2013-02-27 18:05:03","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"19","purchase_order_id":"10006","date":"2013-02-27 00:00:00","item_description":null,"item_name":"Super Riva Aquarama ()","item_id":"31","discount":"0","discount_type":null,"qty":"100","price_per_unit":"220.0000","price":"22000.00","received":"100","received_price":"22000.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"31":{"id":"31","primary_image":"SuperRivaAquarama.jpg","image":"SuperRivaAquarama.jpg","category":"Home","subcategory":"Arts and Craft","brand":"0","location":"","name":"Super Riva Aquarama","model_no":"","warranty":"","sku":"SRA123129","sku2":"","sku3":"","sku4":"","qty":"100","alert_quantity":"2","max_quantity":"0","cost":"220.00","average_cost":null,"price":"390.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:25:26","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-02-27 18:06:46', 'admin2'),
(216, 'inventory', 'status_update', 'po', NULL, '[]', '2013-02-27 18:06:46', 'admin2'),
(217, 'inventory', 'add', 'po', 10007, '{"id":"10007","txn_no":"1-10007","invoice_number":"","number":null,"date":"2013-03-03 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"The Walking Stars","supplier_id":"1090","supplier_address":"{\\"address1\\":\\"Blok 1, Jalan Jaya Usaha\\",\\"address2\\":\\"Kawasan Jaya Usaha\\",\\"zipcode\\":\\"09000\\",\\"city\\":\\"Kulim\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"650.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-03 16:01:12","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"20","purchase_order_id":"10007","date":"2013-03-03 00:00:00","item_description":null,"item_name":"Almeta ()","item_id":"25","discount":"0","discount_type":null,"qty":"13","price_per_unit":"50.0000","price":"650.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"-13","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-03 16:01:13', 'admin2'),
(218, 'inventory', 'receive', 'po', 10007, '{"id":"10007","txn_no":"1-10007","invoice_number":"","number":null,"date":"2013-03-03 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"The Walking Stars","supplier_id":"1090","supplier_address":"{\\"address1\\":\\"Blok 1, Jalan Jaya Usaha\\",\\"address2\\":\\"Kawasan Jaya Usaha\\",\\"zipcode\\":\\"09000\\",\\"city\\":\\"Kulim\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"650.00","total_received":"650.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-03 16:01:12","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"20","purchase_order_id":"10007","date":"2013-03-03 00:00:00","item_description":null,"item_name":"Almeta ()","item_id":"25","discount":"0","discount_type":null,"qty":"13","price_per_unit":"50.0000","price":"650.00","received":"13","received_price":"650.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-03 16:01:37', 'admin2'),
(219, 'inventory', 'status_update', 'po', 10007, '{"id":"10007","txn_no":"1-10007","invoice_number":"","number":null,"date":"2013-03-03 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"The Walking Stars","supplier_id":"1090","supplier_address":"{\\"address1\\":\\"Blok 1, Jalan Jaya Usaha\\",\\"address2\\":\\"Kawasan Jaya Usaha\\",\\"zipcode\\":\\"09000\\",\\"city\\":\\"Kulim\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"650.00","total_received":"650.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-03 16:01:12","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"20","purchase_order_id":"10007","date":"2013-03-03 00:00:00","item_description":null,"item_name":"Almeta ()","item_id":"25","discount":"0","discount_type":null,"qty":"13","price_per_unit":"50.0000","price":"650.00","received":"13","received_price":"650.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-03 16:01:37', 'admin2'),
(220, 'inventory', 'add', 'po', 10008, '{"id":"10008","txn_no":"1-10008","invoice_number":"","number":null,"date":"2013-03-03 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"The Walking Stars","supplier_id":"1090","supplier_address":"{\\"address1\\":\\"Blok 1, Jalan Jaya Usaha\\",\\"address2\\":\\"Kawasan Jaya Usaha\\",\\"zipcode\\":\\"09000\\",\\"city\\":\\"Kulim\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4950.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-03 16:02:16","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"21","purchase_order_id":"10008","date":"2013-03-03 00:00:00","item_description":null,"item_name":"Almeta ()","item_id":"25","discount":"0","discount_type":null,"qty":"99","price_per_unit":"50.0000","price":"4950.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-03 16:02:16', 'admin2');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(221, 'inventory', 'receive', 'po', 10008, '{"id":"10008","txn_no":"1-10008","invoice_number":"","number":null,"date":"2013-03-03 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"The Walking Stars","supplier_id":"1090","supplier_address":"{\\"address1\\":\\"Blok 1, Jalan Jaya Usaha\\",\\"address2\\":\\"Kawasan Jaya Usaha\\",\\"zipcode\\":\\"09000\\",\\"city\\":\\"Kulim\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4950.00","total_received":"4950.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-03 16:02:16","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"21","purchase_order_id":"10008","date":"2013-03-03 00:00:00","item_description":null,"item_name":"Almeta ()","item_id":"25","discount":"0","discount_type":null,"qty":"99","price_per_unit":"50.0000","price":"4950.00","received":"99","received_price":"4950.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"99","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-03 16:02:40', 'admin2'),
(222, 'inventory', 'status_update', 'po', 10008, '{"id":"10008","txn_no":"1-10008","invoice_number":"","number":null,"date":"2013-03-03 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"The Walking Stars","supplier_id":"1090","supplier_address":"{\\"address1\\":\\"Blok 1, Jalan Jaya Usaha\\",\\"address2\\":\\"Kawasan Jaya Usaha\\",\\"zipcode\\":\\"09000\\",\\"city\\":\\"Kulim\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4950.00","total_received":"4950.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-03 16:02:16","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"21","purchase_order_id":"10008","date":"2013-03-03 00:00:00","item_description":null,"item_name":"Almeta ()","item_id":"25","discount":"0","discount_type":null,"qty":"99","price_per_unit":"50.0000","price":"4950.00","received":"99","received_price":"4950.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"99","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-03 16:02:40', 'admin2'),
(223, 'inventory', 'add', 'po', 10001, '{"id":"10001","txn_no":"1-10001","invoice_number":"","number":null,"date":"2013-03-03 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"13860.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-03 16:16:20","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","purchase_order_id":"10001","date":"2013-03-03 00:00:00","item_description":null,"item_name":"Evolution Standing Lamp ()","item_id":"14","discount":"0","discount_type":null,"qty":"99","price_per_unit":"140.0000","price":"13860.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-03 16:16:20', 'admin2'),
(224, 'inventory', 'receive', 'po', 10001, '{"id":"10001","txn_no":"1-10001","invoice_number":"","number":null,"date":"2013-03-03 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"13860.00","total_received":"13860.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-03 16:16:20","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","purchase_order_id":"10001","date":"2013-03-03 00:00:00","item_description":null,"item_name":"Evolution Standing Lamp ()","item_id":"14","discount":"0","discount_type":null,"qty":"99","price_per_unit":"140.0000","price":"13860.00","received":"99","received_price":"13860.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"99","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-03 16:16:31', 'admin2'),
(225, 'inventory', 'status_update', 'po', 10001, '{"id":"10001","txn_no":"1-10001","invoice_number":"","number":null,"date":"2013-03-03 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"13860.00","total_received":"13860.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-03 16:16:20","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","purchase_order_id":"10001","date":"2013-03-03 00:00:00","item_description":null,"item_name":"Evolution Standing Lamp ()","item_id":"14","discount":"0","discount_type":null,"qty":"99","price_per_unit":"140.0000","price":"13860.00","received":"99","received_price":"13860.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"99","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-03 16:16:31', 'admin2'),
(226, 'inventory', 'add', 'po', 10002, '{"id":"10002","txn_no":"1-10002","invoice_number":"","number":null,"date":"2013-03-03 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"59.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-03 16:22:07","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"2","purchase_order_id":"10002","date":"2013-03-03 00:00:00","item_description":null,"item_name":"Resin Potpourri ()","item_id":"19","discount":"0","discount_type":"d","qty":"1","price_per_unit":"59.0000","price":"59.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"19":{"id":"19","primary_image":"xResinPotpourri20.jpg","image":"xResinPotpourri20.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Resin Potpourri","model_no":"","warranty":"","sku":"RP22431","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"79.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:11:46","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-03 16:22:07', 'admin2'),
(227, 'inventory', 'receive', 'po', 10002, '{"id":"10002","txn_no":"1-10002","invoice_number":"","number":null,"date":"2013-03-03 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"59.00","total_received":"59.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-03 16:22:07","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"2","purchase_order_id":"10002","date":"2013-03-03 00:00:00","item_description":null,"item_name":"Resin Potpourri ()","item_id":"19","discount":"0","discount_type":"d","qty":"1","price_per_unit":"59.0000","price":"59.00","received":"1","received_price":"59.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"19":{"id":"19","primary_image":"xResinPotpourri20.jpg","image":"xResinPotpourri20.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Resin Potpourri","model_no":"","warranty":"","sku":"RP22431","sku2":"","sku3":"","sku4":"","qty":"1","alert_quantity":"2","max_quantity":"0","cost":"59.00","average_cost":null,"price":"79.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:11:46","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-03 16:22:18', 'admin2'),
(228, 'inventory', 'status_update', 'po', 10002, '{"id":"10002","txn_no":"1-10002","invoice_number":"","number":null,"date":"2013-03-03 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"59.00","total_received":"59.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-03 16:22:07","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"2","purchase_order_id":"10002","date":"2013-03-03 00:00:00","item_description":null,"item_name":"Resin Potpourri ()","item_id":"19","discount":"0","discount_type":"d","qty":"1","price_per_unit":"59.0000","price":"59.00","received":"1","received_price":"59.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"19":{"id":"19","primary_image":"xResinPotpourri20.jpg","image":"xResinPotpourri20.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Resin Potpourri","model_no":"","warranty":"","sku":"RP22431","sku2":"","sku3":"","sku4":"","qty":"1","alert_quantity":"2","max_quantity":"0","cost":"59.00","average_cost":null,"price":"79.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:11:46","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-03 16:22:18', 'admin2'),
(229, 'inventory', 'add', 'po', 10003, '{"id":"10003","txn_no":"1-10003","invoice_number":"","number":null,"date":"2013-03-03 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"158.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-03 16:24:29","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"3","purchase_order_id":"10003","date":"2013-03-03 00:00:00","item_description":null,"item_name":"Resin Potpourri ()","item_id":"19","discount":"0","discount_type":null,"qty":"2","price_per_unit":"79.0000","price":"158.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"19":{"id":"19","primary_image":"xResinPotpourri20.jpg","image":"xResinPotpourri20.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Resin Potpourri","model_no":"","warranty":"","sku":"RP22431","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"59.00","average_cost":null,"price":"79.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:11:46","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-03 16:23:11","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-03 16:24:29', 'admin2'),
(230, 'inventory', 'receive', 'po', 10003, '{"id":"10003","txn_no":"1-10003","invoice_number":"","number":null,"date":"2013-03-03 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"158.00","total_received":"158.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-03 16:24:29","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"3","purchase_order_id":"10003","date":"2013-03-03 00:00:00","item_description":null,"item_name":"Resin Potpourri ()","item_id":"19","discount":"0","discount_type":null,"qty":"2","price_per_unit":"79.0000","price":"158.00","received":"2","received_price":"158.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"19":{"id":"19","primary_image":"xResinPotpourri20.jpg","image":"xResinPotpourri20.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Resin Potpourri","model_no":"","warranty":"","sku":"RP22431","sku2":"","sku3":"","sku4":"","qty":"2","alert_quantity":"2","max_quantity":"0","cost":"59.00","average_cost":null,"price":"79.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:11:46","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-03 16:23:11","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-03 16:24:37', 'admin2'),
(231, 'inventory', 'status_update', 'po', 10003, '{"id":"10003","txn_no":"1-10003","invoice_number":"","number":null,"date":"2013-03-03 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"158.00","total_received":"158.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-03 16:24:29","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"3","purchase_order_id":"10003","date":"2013-03-03 00:00:00","item_description":null,"item_name":"Resin Potpourri ()","item_id":"19","discount":"0","discount_type":null,"qty":"2","price_per_unit":"79.0000","price":"158.00","received":"2","received_price":"158.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"19":{"id":"19","primary_image":"xResinPotpourri20.jpg","image":"xResinPotpourri20.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Resin Potpourri","model_no":"","warranty":"","sku":"RP22431","sku2":"","sku3":"","sku4":"","qty":"2","alert_quantity":"2","max_quantity":"0","cost":"59.00","average_cost":null,"price":"79.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:11:46","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-03 16:23:11","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-03 16:24:37', 'admin2'),
(232, 'inventory', 'add', 'po', 10004, '{"id":"10004","txn_no":"1-10004","invoice_number":"","number":null,"date":"2013-03-03 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"59.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-03 16:25:47","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"4","purchase_order_id":"10004","date":"2013-03-03 00:00:00","item_description":null,"item_name":"Resin Potpourri ()","item_id":"19","discount":"0","discount_type":null,"qty":"1","price_per_unit":"59.0000","price":"59.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"19":{"id":"19","primary_image":"xResinPotpourri20.jpg","image":"xResinPotpourri20.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Resin Potpourri","model_no":"","warranty":"","sku":"RP22431","sku2":"","sku3":"","sku4":"","qty":"1","alert_quantity":"2","max_quantity":"0","cost":"79.00","average_cost":null,"price":"79.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:11:46","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-03 16:25:03","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-03 16:25:47', 'admin2'),
(233, 'inventory', 'receive', 'po', 10004, '{"id":"10004","txn_no":"1-10004","invoice_number":"","number":null,"date":"2013-03-03 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"59.00","total_received":"59.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-03 16:25:47","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"4","purchase_order_id":"10004","date":"2013-03-03 00:00:00","item_description":null,"item_name":"Resin Potpourri ()","item_id":"19","discount":"0","discount_type":null,"qty":"1","price_per_unit":"59.0000","price":"59.00","received":"1","received_price":"59.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"19":{"id":"19","primary_image":"xResinPotpourri20.jpg","image":"xResinPotpourri20.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Resin Potpourri","model_no":"","warranty":"","sku":"RP22431","sku2":"","sku3":"","sku4":"","qty":"2","alert_quantity":"2","max_quantity":"0","cost":"79.00","average_cost":null,"price":"79.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:11:46","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-03 16:25:03","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-03 16:25:58', 'admin2'),
(234, 'inventory', 'status_update', 'po', 10004, '{"id":"10004","txn_no":"1-10004","invoice_number":"","number":null,"date":"2013-03-03 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"59.00","total_received":"59.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-03 16:25:47","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"4","purchase_order_id":"10004","date":"2013-03-03 00:00:00","item_description":null,"item_name":"Resin Potpourri ()","item_id":"19","discount":"0","discount_type":null,"qty":"1","price_per_unit":"59.0000","price":"59.00","received":"1","received_price":"59.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"19":{"id":"19","primary_image":"xResinPotpourri20.jpg","image":"xResinPotpourri20.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Resin Potpourri","model_no":"","warranty":"","sku":"RP22431","sku2":"","sku3":"","sku4":"","qty":"2","alert_quantity":"2","max_quantity":"0","cost":"79.00","average_cost":null,"price":"79.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:11:46","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-03 16:25:03","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-03 16:25:58', 'admin2'),
(235, 'contacts', 'edit', 'contact', 1076, '{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5ce75bba6298a10e403e09672cf79b5a","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2013-03-06 07:29:46","modified_by":"admin2","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1361331784","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2013-03-06 07:29:46', 'admin2'),
(236, 'sales', 'deliver', 'invoice', 10001, '{"id":"10001","txn_no":"1-10001","quote_id":null,"sales_order_id":"10003","number":null,"po_number":null,"date":"2013-03-06 07:30:52","due_date":null,"received_date":null,"contact_person":null,"contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"zipcode\\":\\"ada\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"Self Pickup","shipping_id":"6","terms":"Cash","duration":"0","remarks":"No remarks","status":"Pending","payment_status":"Paid","payment_date":"2013-03-06 07:30:52","payment_reference":"TXN-TEST1001","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"190.00","total_delivered":"190.00","cost":null,"tags":"Online Sales","added_on":"2013-03-06 07:30:52","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":null,"total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"1","invoice_id":"10001","type":"product","date":"2013-03-06 07:30:52","item_name":"Evolution Standing Lamp","item_description":"","item_id":"14","service_id":null,"item_sku":"ESL2191","discount":null,"discount_type":null,"qty":"1","price_per_unit":"190.0000","price":"190.00","cost":"140.00","margin":null,"delivered":"1","delivered_price":"190.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"96","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 07:36:50","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5ce75bba6298a10e403e09672cf79b5a","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2013-03-06 07:29:46","modified_by":"admin2","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1362526200","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-06 07:36:50', 'admin2'),
(237, 'sales', 'status_update', 'invoice', 10001, '{"id":"10001","txn_no":"1-10001","quote_id":null,"sales_order_id":"10003","number":null,"po_number":null,"date":"2013-03-06 07:30:52","due_date":null,"received_date":null,"contact_person":null,"contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"zipcode\\":\\"ada\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"Self Pickup","shipping_id":"6","terms":"Cash","duration":"0","remarks":"No remarks","status":"Delivered","payment_status":"Paid","payment_date":"2013-03-06 07:30:52","payment_reference":"TXN-TEST1001","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"190.00","total_delivered":"190.00","cost":null,"tags":"Online Sales","added_on":"2013-03-06 07:30:52","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":null,"total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"1","invoice_id":"10001","type":"product","date":"2013-03-06 07:30:52","item_name":"Evolution Standing Lamp","item_description":"","item_id":"14","service_id":null,"item_sku":"ESL2191","discount":null,"discount_type":null,"qty":"1","price_per_unit":"190.0000","price":"190.00","cost":"140.00","margin":null,"delivered":"1","delivered_price":"190.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"96","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 07:36:50","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5ce75bba6298a10e403e09672cf79b5a","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2013-03-06 07:29:46","modified_by":"admin2","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1362526200","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-06 07:36:53', 'admin2');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(238, 'sales', 'delivery_info_update', 'do', 10001, '{"id":"10001","txn_no":"1-10001","quote_id":null,"sales_order_id":"10003","number":null,"po_number":null,"date":"2013-03-06 07:30:52","due_date":null,"received_date":null,"contact_person":null,"contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"zipcode\\":\\"ada\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":"123","delivery_status":"Pending","delivery_date":"2013-03-06 00:00:00","shipping":"Self Pickup","shipping_id":"6","terms":"Cash","duration":"0","remarks":"No remarks","status":"Delivered","payment_status":"Paid","payment_date":"2013-03-06 07:30:52","payment_reference":"TXN-TEST1001","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"190.00","total_delivered":"190.00","cost":null,"tags":"Online Sales","added_on":"2013-03-06 07:30:52","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":null,"total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"1","invoice_id":"10001","type":"product","date":"2013-03-06 07:30:52","item_name":"Evolution Standing Lamp","item_description":"","item_id":"14","service_id":null,"item_sku":"ESL2191","discount":null,"discount_type":null,"qty":"1","price_per_unit":"190.0000","price":"190.00","cost":"140.00","margin":null,"delivered":"1","delivered_price":"190.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"96","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 07:36:50","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5ce75bba6298a10e403e09672cf79b5a","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2013-03-06 07:29:46","modified_by":"admin2","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1362526200","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-06 07:37:06', 'admin2'),
(239, 'sales', 'delivery_status_update', 'do', 10001, '{"id":"10001","txn_no":"1-10001","quote_id":null,"sales_order_id":"10003","number":null,"po_number":null,"date":"2013-03-06 07:30:52","due_date":null,"received_date":null,"contact_person":null,"contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"zipcode\\":\\"ada\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":"123","delivery_status":"Ready for Pick-up","delivery_date":"2013-03-06 00:00:00","shipping":"Self Pickup","shipping_id":"6","terms":"Cash","duration":"0","remarks":"No remarks","status":"Delivered","payment_status":"Paid","payment_date":"2013-03-06 07:30:52","payment_reference":"TXN-TEST1001","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"190.00","total_delivered":"190.00","cost":null,"tags":"Online Sales","added_on":"2013-03-06 07:30:52","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":null,"total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"1","invoice_id":"10001","type":"product","date":"2013-03-06 07:30:52","item_name":"Evolution Standing Lamp","item_description":"","item_id":"14","service_id":null,"item_sku":"ESL2191","discount":null,"discount_type":null,"qty":"1","price_per_unit":"190.0000","price":"190.00","cost":"140.00","margin":null,"delivered":"1","delivered_price":"190.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"96","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 07:36:50","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5ce75bba6298a10e403e09672cf79b5a","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2013-03-06 07:29:46","modified_by":"admin2","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1362526200","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-06 07:37:28', 'admin2'),
(240, 'inventory', 'add', 'item', NULL, '[]', '2013-03-06 09:17:23', 'admin'),
(241, 'inventory', 'add', 'po', 10005, '{"id":"10005","txn_no":"1-10005","invoice_number":"161561561","number":null,"date":"2013-03-06 00:00:00","due_date":"2013-04-05 00:00:00","contact_person":"Administrator ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"30","remarks":"Urgent delivery by Tuesday","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"5000.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-06 09:52:25","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"6","purchase_order_id":"10005","date":"2013-03-06 00:00:00","item_description":null,"item_name":"Nokia 3310 ()","item_id":"71","discount":"0","discount_type":null,"qty":"100","price_per_unit":"50.0000","price":"5000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"71":{"id":"71","primary_image":"nokia-3310-old-gold.jpg","image":"nokia-3310-old-gold.jpg","category":"Handphone","subcategory":"Bar","brand":"Nokia","location":"","name":"Nokia 3310","model_no":"","warranty":"1","sku":"014191239012","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"20","max_quantity":"0","cost":"0.00","average_cost":null,"price":"150.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Nokia 3310 the most powerful handphone ever that can use as a mobile phone, no camera, no 3G, just a pure GSM Phone","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2013-03-06 09:17:24","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"101.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"2","max_cart_qty":"10","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-06 09:52:25', 'admin'),
(242, 'inventory', 'add', 'po', 10006, '{"id":"10006","txn_no":"1-10006","invoice_number":"651611146","number":null,"date":"2013-03-06 00:00:00","due_date":"2013-04-05 00:00:00","contact_person":"Administrator ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"30","remarks":"Need this items urgently","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"5200.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-06 10:27:49","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"9","purchase_order_id":"10006","date":"2013-03-06 00:00:00","item_description":null,"item_name":"Evolution Standing Lamp ()","item_id":"14","discount":"0","discount_type":null,"qty":"30","price_per_unit":"140.0000","price":"4200.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"},{"id":"8","purchase_order_id":"10006","date":"2013-03-06 00:00:00","item_description":null,"item_name":"Nokia 3310 ()","item_id":"71","discount":"0","discount_type":null,"qty":"20","price_per_unit":"50.0000","price":"1000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"71":{"id":"71","primary_image":"nokia-3310-old-gold.jpg","image":"nokia-3310-old-gold.jpg","category":"Handphone","subcategory":"Bar","brand":"Nokia","location":"","name":"Nokia 3310","model_no":"","warranty":"1","sku":"014191239012","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"20","max_quantity":"0","cost":"0.00","average_cost":null,"price":"150.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Nokia 3310 the most powerful handphone ever that can use as a mobile phone, no camera, no 3G, just a pure GSM Phone","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2013-03-06 09:17:24","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"101.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"2","max_cart_qty":"10","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 07:36:50","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-06 10:27:49', 'admin'),
(243, 'inventory', 'paid', 'po', 10006, '{"id":"10006","txn_no":"1-10006","invoice_number":"651611146","number":null,"date":"2013-03-06 00:00:00","due_date":"2013-04-05 00:00:00","contact_person":"Administrator ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"30","remarks":"Need this items urgently","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"5200.00","total_received":null,"payment_status":"Paid","payment_date":"2013-03-06 00:00:00","payment_reference":"6451282","payment_contra":null,"tags":"","added_on":"2013-03-06 10:27:49","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"9","purchase_order_id":"10006","date":"2013-03-06 00:00:00","item_description":null,"item_name":"Evolution Standing Lamp ()","item_id":"14","discount":"0","discount_type":null,"qty":"30","price_per_unit":"140.0000","price":"4200.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"},{"id":"8","purchase_order_id":"10006","date":"2013-03-06 00:00:00","item_description":null,"item_name":"Nokia 3310 ()","item_id":"71","discount":"0","discount_type":null,"qty":"20","price_per_unit":"50.0000","price":"1000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"71":{"id":"71","primary_image":"nokia-3310-old-gold.jpg","image":"nokia-3310-old-gold.jpg","category":"Handphone","subcategory":"Bar","brand":"Nokia","location":"","name":"Nokia 3310","model_no":"","warranty":"1","sku":"014191239012","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"20","max_quantity":"0","cost":"0.00","average_cost":null,"price":"150.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Nokia 3310 the most powerful handphone ever that can use as a mobile phone, no camera, no 3G, just a pure GSM Phone","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2013-03-06 09:17:24","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"101.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"2","max_cart_qty":"10","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 07:36:50","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-06 10:28:26', 'admin'),
(244, 'inventory', 'status_update', 'po', 10006, '{"id":"10006","txn_no":"1-10006","invoice_number":"651611146","number":null,"date":"2013-03-06 00:00:00","due_date":"2013-04-05 00:00:00","contact_person":"Administrator ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"30","remarks":"Need this items urgently","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"5200.00","total_received":null,"payment_status":"Paid","payment_date":"2013-03-06 00:00:00","payment_reference":"6451282","payment_contra":null,"tags":"","added_on":"2013-03-06 10:27:49","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"9","purchase_order_id":"10006","date":"2013-03-06 00:00:00","item_description":null,"item_name":"Evolution Standing Lamp ()","item_id":"14","discount":"0","discount_type":null,"qty":"30","price_per_unit":"140.0000","price":"4200.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"},{"id":"8","purchase_order_id":"10006","date":"2013-03-06 00:00:00","item_description":null,"item_name":"Nokia 3310 ()","item_id":"71","discount":"0","discount_type":null,"qty":"20","price_per_unit":"50.0000","price":"1000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"71":{"id":"71","primary_image":"nokia-3310-old-gold.jpg","image":"nokia-3310-old-gold.jpg","category":"Handphone","subcategory":"Bar","brand":"Nokia","location":"","name":"Nokia 3310","model_no":"","warranty":"1","sku":"014191239012","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"20","max_quantity":"0","cost":"0.00","average_cost":null,"price":"150.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Nokia 3310 the most powerful handphone ever that can use as a mobile phone, no camera, no 3G, just a pure GSM Phone","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2013-03-06 09:17:24","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"101.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"2","max_cart_qty":"10","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 07:36:50","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-06 10:28:34', 'admin'),
(245, 'inventory', 'add', 'po', 10007, '{"id":"10007","txn_no":"1-10007","invoice_number":"","number":null,"date":"2013-03-06 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"14220.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-06 16:06:03","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"12","purchase_order_id":"10007","date":"2013-03-06 00:00:00","item_description":null,"item_name":"Evolution Standing Lamp ()","item_id":"14","discount":"0","discount_type":null,"qty":"100","price_per_unit":"140.0000","price":"14000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"},{"id":"13","purchase_order_id":"10007","date":"2013-03-06 00:00:00","item_description":null,"item_name":"Resin Driftwood Table Lamp ()","item_id":"13","discount":"0","discount_type":null,"qty":"2","price_per_unit":"110.0000","price":"220.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"},{"id":"14","purchase_order_id":"10007","date":"2013-03-06 00:00:00","item_description":null,"item_name":"Supertripod Standing Lamp ()","item_id":"15","discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 07:36:50","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"13":{"id":"13","primary_image":"xResin-Driftwood15.jpg.pagespeed_.ic_._ovNPDZfT2_.jpg","image":"xResin-Driftwood15.jpg.pagespeed_.ic_._ovNPDZfT2_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Resin Driftwood Table Lamp","model_no":"","warranty":"","sku":"RDTL2131","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"150.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:04:09","added_by":"admin","modified_on":"2012-12-12 13:04:36","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"100","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-03 13:51:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-06 16:06:03', 'admin2'),
(246, 'sales', 'add', 'so', 10004, '{"id":"10004","txn_no":"1-10002","quote_id":"0","invoice_id":null,"number":"0","po_number":"10007","date":"2013-03-06 00:00:00","due_date":"2013-03-06 00:00:00","received_date":null,"contact_person":"JawiHerbShop ","contact":null,"contact_id":null,"contact_address":"{\\"address1\\":null,\\"address2\\":null,\\"zipcode\\":null,\\"city\\":null,\\"state\\":null,\\"country\\":null}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"14220.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-06 16:07:11","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"2","sales_order_id":"10004","type":"product","date":"2013-03-06 00:00:00","item_name":"Evolution Standing Lamp ()","item_description":"","item_id":"14","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"140.0000","price":"14000.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"3","sales_order_id":"10004","type":"product","date":"2013-03-06 00:00:00","item_name":"Resin Driftwood Table Lamp ()","item_description":"","item_id":"13","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"2","price_per_unit":"110.0000","price":"220.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"4","sales_order_id":"10004","type":"product","date":"2013-03-06 00:00:00","item_name":"Supertripod Standing Lamp ()","item_description":"","item_id":"15","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 07:36:50","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"13":{"id":"13","primary_image":"xResin-Driftwood15.jpg.pagespeed_.ic_._ovNPDZfT2_.jpg","image":"xResin-Driftwood15.jpg.pagespeed_.ic_._ovNPDZfT2_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Resin Driftwood Table Lamp","model_no":"","warranty":"","sku":"RDTL2131","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"150.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:04:09","added_by":"admin","modified_on":"2012-12-12 13:04:36","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"100","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-03 13:51:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2013-03-06 16:07:11', 'admin2'),
(247, 'inventory', 'status_update', 'po', 10007, '{"id":"10007","txn_no":"1-10007","invoice_number":"","number":null,"date":"2013-03-06 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"14220.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-06 16:06:03","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"12","purchase_order_id":"10007","date":"2013-03-06 00:00:00","item_description":null,"item_name":"Evolution Standing Lamp ()","item_id":"14","discount":"0","discount_type":null,"qty":"100","price_per_unit":"140.0000","price":"14000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"},{"id":"13","purchase_order_id":"10007","date":"2013-03-06 00:00:00","item_description":null,"item_name":"Resin Driftwood Table Lamp ()","item_id":"13","discount":"0","discount_type":null,"qty":"2","price_per_unit":"110.0000","price":"220.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"},{"id":"14","purchase_order_id":"10007","date":"2013-03-06 00:00:00","item_description":null,"item_name":"Supertripod Standing Lamp ()","item_id":"15","discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 07:36:50","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"13":{"id":"13","primary_image":"xResin-Driftwood15.jpg.pagespeed_.ic_._ovNPDZfT2_.jpg","image":"xResin-Driftwood15.jpg.pagespeed_.ic_._ovNPDZfT2_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Resin Driftwood Table Lamp","model_no":"","warranty":"","sku":"RDTL2131","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"150.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:04:09","added_by":"admin","modified_on":"2012-12-12 13:04:36","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"100","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-03 13:51:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-06 16:08:41', 'admin2');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(248, 'inventory', 'status_update', 'po', 10007, '{"id":"10007","txn_no":"1-10007","invoice_number":"","number":null,"date":"2013-03-06 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Partially Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"14220.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-06 16:06:03","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"12","purchase_order_id":"10007","date":"2013-03-06 00:00:00","item_description":null,"item_name":"Evolution Standing Lamp ()","item_id":"14","discount":"0","discount_type":null,"qty":"100","price_per_unit":"140.0000","price":"14000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"},{"id":"13","purchase_order_id":"10007","date":"2013-03-06 00:00:00","item_description":null,"item_name":"Resin Driftwood Table Lamp ()","item_id":"13","discount":"0","discount_type":null,"qty":"2","price_per_unit":"110.0000","price":"220.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"},{"id":"14","purchase_order_id":"10007","date":"2013-03-06 00:00:00","item_description":null,"item_name":"Supertripod Standing Lamp ()","item_id":"15","discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 07:36:50","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"13":{"id":"13","primary_image":"xResin-Driftwood15.jpg.pagespeed_.ic_._ovNPDZfT2_.jpg","image":"xResin-Driftwood15.jpg.pagespeed_.ic_._ovNPDZfT2_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Resin Driftwood Table Lamp","model_no":"","warranty":"","sku":"RDTL2131","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"150.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:04:09","added_by":"admin","modified_on":"2012-12-12 13:04:36","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"100","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-03 13:51:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-06 16:08:53', 'admin2'),
(249, 'sales', 'status_update', 'so', 10004, '{"id":"10004","txn_no":"1-10002","quote_id":"0","invoice_id":null,"number":"0","po_number":"10007","date":"2013-03-06 00:00:00","due_date":"2013-03-06 00:00:00","received_date":null,"contact_person":"JawiHerbShop ","contact":null,"contact_id":null,"contact_address":"{\\"address1\\":null,\\"address2\\":null,\\"zipcode\\":null,\\"city\\":null,\\"state\\":null,\\"country\\":null}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Completed","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"14220.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-06 16:07:11","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"2","sales_order_id":"10004","type":"product","date":"2013-03-06 00:00:00","item_name":"Evolution Standing Lamp ()","item_description":"","item_id":"14","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"140.0000","price":"14000.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"3","sales_order_id":"10004","type":"product","date":"2013-03-06 00:00:00","item_name":"Resin Driftwood Table Lamp ()","item_description":"","item_id":"13","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"2","price_per_unit":"110.0000","price":"220.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"4","sales_order_id":"10004","type":"product","date":"2013-03-06 00:00:00","item_name":"Supertripod Standing Lamp ()","item_description":"","item_id":"15","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 07:36:50","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"13":{"id":"13","primary_image":"xResin-Driftwood15.jpg.pagespeed_.ic_._ovNPDZfT2_.jpg","image":"xResin-Driftwood15.jpg.pagespeed_.ic_._ovNPDZfT2_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Resin Driftwood Table Lamp","model_no":"","warranty":"","sku":"RDTL2131","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"150.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:04:09","added_by":"admin","modified_on":"2012-12-12 13:04:36","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"100","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-03 13:51:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2013-03-06 16:09:47', 'admin2'),
(250, 'sales', 'add', 'invoice', 10002, '{"id":"10002","txn_no":"1-10002","quote_id":"0","sales_order_id":"10004","number":"0","po_number":"10007","date":"2013-03-06 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":null,"contact_id":null,"contact_address":"{\\"address1\\":null,\\"address2\\":null,\\"zipcode\\":null,\\"city\\":null,\\"state\\":null,\\"country\\":null}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"14220.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-06 16:10:15","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"2","invoice_id":"10002","type":"product","date":"2013-03-06 12:00:00","item_name":"Evolution Standing Lamp ()","item_description":"","item_id":"14","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"140.0000","price":"14000.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"3","invoice_id":"10002","type":"product","date":"2013-03-06 12:00:00","item_name":"Resin Driftwood Table Lamp ()","item_description":"","item_id":"13","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"2","price_per_unit":"110.0000","price":"220.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"4","invoice_id":"10002","type":"product","date":"2013-03-06 12:00:00","item_name":"Supertripod Standing Lamp ()","item_description":"","item_id":"15","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 07:36:50","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"13":{"id":"13","primary_image":"xResin-Driftwood15.jpg.pagespeed_.ic_._ovNPDZfT2_.jpg","image":"xResin-Driftwood15.jpg.pagespeed_.ic_._ovNPDZfT2_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Resin Driftwood Table Lamp","model_no":"","warranty":"","sku":"RDTL2131","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"150.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:04:09","added_by":"admin","modified_on":"2012-12-12 13:04:36","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"100","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-03 13:51:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":[],"sale":null,"sale_items":null}', '2013-03-06 16:10:15', 'admin2'),
(251, 'sales', 'paid', 'invoice', 10002, '{"id":"10002","txn_no":"1-10002","quote_id":"0","sales_order_id":"10004","number":"0","po_number":"10007","date":"2013-03-06 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":null,"contact_id":null,"contact_address":"{\\"address1\\":null,\\"address2\\":null,\\"zipcode\\":null,\\"city\\":null,\\"state\\":null,\\"country\\":null}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Paid","payment_date":"2013-03-06 00:00:00","payment_reference":"33","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"14220.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-06 16:10:15","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"2","invoice_id":"10002","type":"product","date":"2013-03-06 12:00:00","item_name":"Evolution Standing Lamp ()","item_description":"","item_id":"14","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"140.0000","price":"14000.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"3","invoice_id":"10002","type":"product","date":"2013-03-06 12:00:00","item_name":"Resin Driftwood Table Lamp ()","item_description":"","item_id":"13","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"2","price_per_unit":"110.0000","price":"220.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"4","invoice_id":"10002","type":"product","date":"2013-03-06 12:00:00","item_name":"Supertripod Standing Lamp ()","item_description":"","item_id":"15","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 07:36:50","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"13":{"id":"13","primary_image":"xResin-Driftwood15.jpg.pagespeed_.ic_._ovNPDZfT2_.jpg","image":"xResin-Driftwood15.jpg.pagespeed_.ic_._ovNPDZfT2_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Resin Driftwood Table Lamp","model_no":"","warranty":"","sku":"RDTL2131","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"150.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:04:09","added_by":"admin","modified_on":"2012-12-12 13:04:36","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"100","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-03 13:51:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":[],"sale":null,"sale_items":null}', '2013-03-06 16:10:27', 'admin2'),
(252, 'sales', 'deliver', 'invoice', 10002, '{"id":"10002","txn_no":"1-10002","quote_id":"0","sales_order_id":"10004","number":"0","po_number":"10007","date":"2013-03-06 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":null,"contact_id":null,"contact_address":"{\\"address1\\":null,\\"address2\\":null,\\"zipcode\\":null,\\"city\\":null,\\"state\\":null,\\"country\\":null}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Paid","payment_date":"2013-03-06 00:00:00","payment_reference":"33","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"14220.00","total_delivered":"14220.00","cost":null,"tags":"","added_on":"2013-03-06 16:10:15","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"2","invoice_id":"10002","type":"product","date":"2013-03-06 12:00:00","item_name":"Evolution Standing Lamp ()","item_description":"","item_id":"14","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"140.0000","price":"14000.00","cost":"13580.00","margin":null,"delivered":"100","delivered_price":"14000.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"3","invoice_id":"10002","type":"product","date":"2013-03-06 12:00:00","item_name":"Resin Driftwood Table Lamp ()","item_description":"","item_id":"13","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"2","price_per_unit":"110.0000","price":"220.00","cost":"0.00","margin":null,"delivered":"2","delivered_price":"220.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"4","invoice_id":"10002","type":"product","date":"2013-03-06 12:00:00","item_name":"Supertripod Standing Lamp ()","item_description":"","item_id":"15","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"0.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"-4","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 16:10:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"13":{"id":"13","primary_image":"xResin-Driftwood15.jpg.pagespeed_.ic_._ovNPDZfT2_.jpg","image":"xResin-Driftwood15.jpg.pagespeed_.ic_._ovNPDZfT2_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Resin Driftwood Table Lamp","model_no":"","warranty":"","sku":"RDTL2131","sku2":"","sku3":"","sku4":"","qty":"-2","alert_quantity":"2","max_quantity":"0","cost":"110.00","average_cost":null,"price":"150.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:04:09","added_by":"admin","modified_on":"2012-12-12 13:04:36","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-06 16:10:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"99","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 16:10:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":[],"sale":null,"sale_items":null}', '2013-03-06 16:10:47', 'admin2'),
(253, 'sales', 'status_update', 'invoice', 10001, '{"id":"10001","txn_no":"1-10001","quote_id":null,"sales_order_id":"10003","number":null,"po_number":null,"date":"2013-03-06 07:30:52","due_date":null,"received_date":null,"contact_person":null,"contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"zipcode\\":\\"ada\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":"123","delivery_status":"Ready for Pick-up","delivery_date":"2013-03-06 00:00:00","shipping":"Self Pickup","shipping_id":"6","terms":"Cash","duration":"0","remarks":"No remarks","status":"Partially Delivered","payment_status":"Paid","payment_date":"2013-03-06 07:30:52","payment_reference":"TXN-TEST1001","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"190.00","total_delivered":"190.00","cost":null,"tags":"Online Sales","added_on":"2013-03-06 07:30:52","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":null,"total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"1","invoice_id":"10001","type":"product","date":"2013-03-06 07:30:52","item_name":"Evolution Standing Lamp","item_description":"","item_id":"14","service_id":null,"item_sku":"ESL2191","discount":null,"discount_type":null,"qty":"1","price_per_unit":"190.0000","price":"190.00","cost":"140.00","margin":null,"delivered":"1","delivered_price":"190.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"-4","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 16:10:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5ce75bba6298a10e403e09672cf79b5a","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2013-03-06 07:29:46","modified_by":"admin2","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1362526200","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-06 16:12:38', 'admin2'),
(254, 'sales', 'unpaid', 'invoice', 10001, '{"id":"10001","txn_no":"1-10001","quote_id":null,"sales_order_id":"10003","number":null,"po_number":null,"date":"2013-03-06 07:30:52","due_date":null,"received_date":null,"contact_person":null,"contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"zipcode\\":\\"ada\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":"123","delivery_status":"Ready for Pick-up","delivery_date":"2013-03-06 00:00:00","shipping":"Self Pickup","shipping_id":"6","terms":"Cash","duration":"0","remarks":"No remarks","status":"Partially Delivered","payment_status":"Unpaid","payment_date":"0000-00-00 00:00:00","payment_reference":"","payment_contra":"","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"190.00","total_delivered":"190.00","cost":null,"tags":"Online Sales","added_on":"2013-03-06 07:30:52","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":null,"total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"1","invoice_id":"10001","type":"product","date":"2013-03-06 07:30:52","item_name":"Evolution Standing Lamp","item_description":"","item_id":"14","service_id":null,"item_sku":"ESL2191","discount":null,"discount_type":null,"qty":"1","price_per_unit":"190.0000","price":"190.00","cost":"140.00","margin":null,"delivered":"1","delivered_price":"190.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"-4","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 16:10:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5ce75bba6298a10e403e09672cf79b5a","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2013-03-06 07:29:46","modified_by":"admin2","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1362526200","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-06 16:12:44', 'admin2');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(255, 'sales', 'unpaid', 'invoice', 10002, '{"id":"10002","txn_no":"1-10002","quote_id":"0","sales_order_id":"10004","number":"0","po_number":"10007","date":"2013-03-06 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":null,"contact_id":null,"contact_address":"{\\"address1\\":null,\\"address2\\":null,\\"zipcode\\":null,\\"city\\":null,\\"state\\":null,\\"country\\":null}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":"0000-00-00 00:00:00","payment_reference":"","payment_contra":"","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"14220.00","total_delivered":"14220.00","cost":null,"tags":"","added_on":"2013-03-06 16:10:15","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"2","invoice_id":"10002","type":"product","date":"2013-03-06 12:00:00","item_name":"Evolution Standing Lamp ()","item_description":"","item_id":"14","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"140.0000","price":"14000.00","cost":"13580.00","margin":null,"delivered":"100","delivered_price":"14000.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"3","invoice_id":"10002","type":"product","date":"2013-03-06 12:00:00","item_name":"Resin Driftwood Table Lamp ()","item_description":"","item_id":"13","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"2","price_per_unit":"110.0000","price":"220.00","cost":"0.00","margin":null,"delivered":"2","delivered_price":"220.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"4","invoice_id":"10002","type":"product","date":"2013-03-06 12:00:00","item_name":"Supertripod Standing Lamp ()","item_description":"","item_id":"15","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"0.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"-4","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 16:10:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"13":{"id":"13","primary_image":"xResin-Driftwood15.jpg.pagespeed_.ic_._ovNPDZfT2_.jpg","image":"xResin-Driftwood15.jpg.pagespeed_.ic_._ovNPDZfT2_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Resin Driftwood Table Lamp","model_no":"","warranty":"","sku":"RDTL2131","sku2":"","sku3":"","sku4":"","qty":"-2","alert_quantity":"2","max_quantity":"0","cost":"110.00","average_cost":null,"price":"150.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:04:09","added_by":"admin","modified_on":"2012-12-12 13:04:36","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-06 16:10:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"99","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 16:10:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":[],"sale":null,"sale_items":null}', '2013-03-06 16:14:05', 'admin2'),
(256, 'sales', 'status_update', 'invoice', 10002, '{"id":"10002","txn_no":"1-10002","quote_id":"0","sales_order_id":"10004","number":"0","po_number":"10007","date":"2013-03-06 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":null,"contact_id":null,"contact_address":"{\\"address1\\":null,\\"address2\\":null,\\"zipcode\\":null,\\"city\\":null,\\"state\\":null,\\"country\\":null}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Partially Delivered","payment_status":"Unpaid","payment_date":"0000-00-00 00:00:00","payment_reference":"","payment_contra":"","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"14220.00","total_delivered":"14220.00","cost":null,"tags":"","added_on":"2013-03-06 16:10:15","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"2","invoice_id":"10002","type":"product","date":"2013-03-06 12:00:00","item_name":"Evolution Standing Lamp ()","item_description":"","item_id":"14","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"140.0000","price":"14000.00","cost":"13580.00","margin":null,"delivered":"100","delivered_price":"14000.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"3","invoice_id":"10002","type":"product","date":"2013-03-06 12:00:00","item_name":"Resin Driftwood Table Lamp ()","item_description":"","item_id":"13","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"2","price_per_unit":"110.0000","price":"220.00","cost":"0.00","margin":null,"delivered":"2","delivered_price":"220.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"4","invoice_id":"10002","type":"product","date":"2013-03-06 12:00:00","item_name":"Supertripod Standing Lamp ()","item_description":"","item_id":"15","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"0.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"-4","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 16:10:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"13":{"id":"13","primary_image":"xResin-Driftwood15.jpg.pagespeed_.ic_._ovNPDZfT2_.jpg","image":"xResin-Driftwood15.jpg.pagespeed_.ic_._ovNPDZfT2_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Resin Driftwood Table Lamp","model_no":"","warranty":"","sku":"RDTL2131","sku2":"","sku3":"","sku4":"","qty":"-2","alert_quantity":"2","max_quantity":"0","cost":"110.00","average_cost":null,"price":"150.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:04:09","added_by":"admin","modified_on":"2012-12-12 13:04:36","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-06 16:10:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"99","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-02-20 11:41:31","modified_by":"admin","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 16:10:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":[],"sale":null,"sale_items":null}', '2013-03-06 16:14:23', 'admin2'),
(257, 'sales', 'add', 'invoice', 10003, '{"id":"10003","txn_no":"1-10003","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2013-03-07 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"377.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-06 23:40:42","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"5","invoice_id":"10003","type":"product","date":"2013-03-07 12:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"6.0000","price":"6.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"6","invoice_id":"10003","type":"product","date":"2013-03-07 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"77.0000","price":"77.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"7","invoice_id":"10003","type":"product","date":"2013-03-07 12:00:00","item_name":"Basic Bankbook Holder","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"55.0000","price":"55.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"8","invoice_id":"10003","type":"product","date":"2013-03-07 12:00:00","item_name":"Black Silk Scarves with Pin","item_description":"","item_id":"37","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"49.0000","price":"49.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"9","invoice_id":"10003","type":"product","date":"2013-03-07 12:00:00","item_name":"Blossom Bag","item_description":"","item_id":"57","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"190.0000","price":"190.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"37":{"id":"37","primary_image":"BlackSlikScarvesWithPin.jpg","image":"BlackSlikScarvesWithPin.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Black Silk Scarves with Pin","model_no":"","warranty":"","sku":"BSSP908023","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"49.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:33:04","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"57":{"id":"57","primary_image":"BlossomBag.jpg","image":"BlossomBag.jpg","category":"Women","subcategory":"Bags","brand":"0","location":"","name":"Blossom Bag","model_no":"","warranty":"","sku":"BB13119","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:52:28","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:55","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-06 23:40:43', 'admin2'),
(258, 'sales', 'edit', 'invoice', 10003, '{"id":"10003","txn_no":"1-10003","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2013-03-07 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"18850.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-06 23:40:42","added_by":"admin2","modified_on":"2013-03-06 23:41:14","modified_by":"admin2","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"13","invoice_id":"10003","type":"product","date":"2013-03-07 12:00:00","item_name":"Black Silk Scarves with Pin","item_description":"","item_id":"37","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"50","price_per_unit":"49.0000","price":"2450.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"12","invoice_id":"10003","type":"product","date":"2013-03-07 12:00:00","item_name":"Basic Bankbook Holder","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"50","price_per_unit":"55.0000","price":"2750.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"11","invoice_id":"10003","type":"product","date":"2013-03-07 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"50","price_per_unit":"77.0000","price":"3850.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"10","invoice_id":"10003","type":"product","date":"2013-03-07 12:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"50","price_per_unit":"6.0000","price":"300.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"14","invoice_id":"10003","type":"product","date":"2013-03-07 12:00:00","item_name":"Blossom Bag","item_description":"","item_id":"57","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"50","price_per_unit":"190.0000","price":"9500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"37":{"id":"37","primary_image":"BlackSlikScarvesWithPin.jpg","image":"BlackSlikScarvesWithPin.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Black Silk Scarves with Pin","model_no":"","warranty":"","sku":"BSSP908023","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"49.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:33:04","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"57":{"id":"57","primary_image":"BlossomBag.jpg","image":"BlossomBag.jpg","category":"Women","subcategory":"Bags","brand":"0","location":"","name":"Blossom Bag","model_no":"","warranty":"","sku":"BB13119","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:52:28","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:55","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-06 23:41:14', 'admin2'),
(259, 'inventory', 'add', 'item', NULL, '[]', '2013-03-07 09:38:25', 'admin2'),
(260, 'inventory', 'edit', 'item', 72, '{"id":"72","primary_image":"logos.jpeg","image":"logos.jpeg","category":"Handphone","subcategory":"Accessories","brand":"0","location":"","name":"nokia3310","model_no":"","warranty":"","sku":"123","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"100.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2013-03-07 09:38:25","added_by":"admin2","modified_on":"2013-03-07 09:38:46","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2013-03-07 09:38:46', 'admin2'),
(261, 'inventory', 'edit', 'item', 72, '{"id":"72","primary_image":"logos.jpeg","image":"logos.jpeg","category":"Handphone","subcategory":"Accessories","brand":"0","location":"","name":"nokia3310","model_no":"","warranty":"","sku":"123","sku2":"","sku3":"","sku4":"","qty":"10","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"100.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2013-03-07 09:38:25","added_by":"admin2","modified_on":"2013-03-07 09:39:54","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"10","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2013-03-07 09:39:54', 'admin2'),
(262, 'inventory', 'add', 'item', 72, '{"id":"72","primary_image":"logos.jpeg","image":"logos.jpeg","category":"Handphone","subcategory":"Accessories","brand":"0","location":"","name":"nokia3310","model_no":"","warranty":"","sku":"123","sku2":"","sku3":"","sku4":"","qty":"10","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"100.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2013-03-07 09:38:25","added_by":"admin2","modified_on":"2013-03-07 09:39:54","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"10","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2013-03-07 10:51:23', 'admin2'),
(263, 'inventory', 'add', 'item', NULL, '[]', '2013-03-07 10:51:28', 'admin2'),
(264, 'inventory', 'edit', 'item', 73, '{"id":"73","primary_image":null,"image":null,"category":"Ibadah","subcategory":"Umrah","brand":"0","location":"","name":"Pakej Umrah 2014","model_no":"","warranty":"","sku":"123456","sku2":"","sku3":"","sku4":"","qty":"1000","alert_quantity":"0","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4500.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"14 hari \\n","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2013-03-07 10:51:28","added_by":"admin2","modified_on":"2013-03-07 10:53:57","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2013-03-07 10:53:57', 'admin2'),
(265, 'accounts', 'void_rc', 'rc', 10001, '{"id":"10001","type":"Income (Sales)","datetime":"2013-03-07 00:00:00","account_id":null,"account":null,"contact_id":"1087","contact":"Dinamika Enterprise","cost":null,"amount":"4354.00","amount_fees":"0.00","amount_effective":"4354.00","status":"Voided","added_on":"2013-03-06 23:43:56","added_by":"admin2","void_date":null,"items":[{"id":"1","receipt_id":"10001","account_id":null,"account":null,"po_id":null,"cn_id":null,"dn_id":null,"invoice_id":"10003","asset_id":null,"reference":null,"contact_id":"1087","contact":"Dinamika Enterprise","description":null,"datetime":"2013-03-07 00:00:00","amount":"18850.00","status":"Voided"},{"id":"2","receipt_id":"10001","account_id":null,"account":null,"po_id":"10007","cn_id":null,"dn_id":null,"invoice_id":null,"asset_id":null,"reference":null,"contact_id":"1087","contact":"Dinamika Enterprise","description":null,"datetime":"2013-03-06 23:43:56","amount":"14220.00","status":"Voided"},{"id":"3","receipt_id":"10001","account_id":null,"account":null,"po_id":"10002","cn_id":null,"dn_id":null,"invoice_id":null,"asset_id":null,"reference":null,"contact_id":"1087","contact":"Dinamika Enterprise","description":null,"datetime":"2013-03-06 23:43:56","amount":"59.00","status":"Voided"},{"id":"4","receipt_id":"10001","account_id":null,"account":null,"po_id":"10003","cn_id":null,"dn_id":null,"invoice_id":null,"asset_id":null,"reference":null,"contact_id":"1087","contact":"Dinamika Enterprise","description":null,"datetime":"2013-03-06 23:43:56","amount":"158.00","status":"Voided"},{"id":"5","receipt_id":"10001","account_id":null,"account":null,"po_id":"10004","cn_id":null,"dn_id":null,"invoice_id":null,"asset_id":null,"reference":null,"contact_id":"1087","contact":"Dinamika Enterprise","description":null,"datetime":"2013-03-06 23:43:56","amount":"59.00","status":"Voided"}],"breakdown":[{"id":"1","receipt_id":"10001","datetime":"2013-03-06 23:43:56","contact":"Dinamika Enterprise","contact_id":"1087","account":"Maybank","account_id":"1104","amount":"4354.00","amount_fees":"0.00","amount_effective":"4354.00","payment_method":"Cheque","payment_reference":"RHB123456","status":"Voided"}]}', '2013-03-07 11:10:01', 'admin2');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(266, 'sales', 'unpaid', 'invoice', 10003, '{"id":"10003","txn_no":"1-10003","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2013-03-07 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":"0000-00-00 00:00:00","payment_reference":"","payment_contra":"","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"18850.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-06 23:40:42","added_by":"admin2","modified_on":"2013-03-06 23:41:14","modified_by":"admin2","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"13","invoice_id":"10003","type":"product","date":"2013-03-07 12:00:00","item_name":"Black Silk Scarves with Pin","item_description":"","item_id":"37","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"50","price_per_unit":"49.0000","price":"2450.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"12","invoice_id":"10003","type":"product","date":"2013-03-07 12:00:00","item_name":"Basic Bankbook Holder","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"50","price_per_unit":"55.0000","price":"2750.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"11","invoice_id":"10003","type":"product","date":"2013-03-07 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"50","price_per_unit":"77.0000","price":"3850.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"10","invoice_id":"10003","type":"product","date":"2013-03-07 12:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"50","price_per_unit":"6.0000","price":"300.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"14","invoice_id":"10003","type":"product","date":"2013-03-07 12:00:00","item_name":"Blossom Bag","item_description":"","item_id":"57","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"50","price_per_unit":"190.0000","price":"9500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"37":{"id":"37","primary_image":"BlackSlikScarvesWithPin.jpg","image":"BlackSlikScarvesWithPin.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Black Silk Scarves with Pin","model_no":"","warranty":"","sku":"BSSP908023","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"49.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:33:04","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"57":{"id":"57","primary_image":"BlossomBag.jpg","image":"BlossomBag.jpg","category":"Women","subcategory":"Bags","brand":"0","location":"","name":"Blossom Bag","model_no":"","warranty":"","sku":"BB13119","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:52:28","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:55","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-07 11:10:01', 'admin2'),
(267, 'sales', 'status_update', 'invoice', 10003, '{"id":"10003","txn_no":"1-10003","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2013-03-07 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Partially Delivered","payment_status":"Unpaid","payment_date":"0000-00-00 00:00:00","payment_reference":"","payment_contra":"","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"18850.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-06 23:40:42","added_by":"admin2","modified_on":"2013-03-06 23:41:14","modified_by":"admin2","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"13","invoice_id":"10003","type":"product","date":"2013-03-07 12:00:00","item_name":"Black Silk Scarves with Pin","item_description":"","item_id":"37","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"50","price_per_unit":"49.0000","price":"2450.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"12","invoice_id":"10003","type":"product","date":"2013-03-07 12:00:00","item_name":"Basic Bankbook Holder","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"50","price_per_unit":"55.0000","price":"2750.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"11","invoice_id":"10003","type":"product","date":"2013-03-07 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"50","price_per_unit":"77.0000","price":"3850.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"10","invoice_id":"10003","type":"product","date":"2013-03-07 12:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"50","price_per_unit":"6.0000","price":"300.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"14","invoice_id":"10003","type":"product","date":"2013-03-07 12:00:00","item_name":"Blossom Bag","item_description":"","item_id":"57","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"50","price_per_unit":"190.0000","price":"9500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"37":{"id":"37","primary_image":"BlackSlikScarvesWithPin.jpg","image":"BlackSlikScarvesWithPin.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Black Silk Scarves with Pin","model_no":"","warranty":"","sku":"BSSP908023","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"49.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:33:04","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"57":{"id":"57","primary_image":"BlossomBag.jpg","image":"BlossomBag.jpg","category":"Women","subcategory":"Bags","brand":"0","location":"","name":"Blossom Bag","model_no":"","warranty":"","sku":"BB13119","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:52:28","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2012-12-30 21:05:55","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-07 11:10:04', 'admin2'),
(268, 'check', 'edit', 'item', 0, '""', '2013-03-07 11:19:46', 'admin2'),
(269, 'sales', 'status_update', 'invoice', 10001, '{"id":"10001","txn_no":"1-10001","quote_id":null,"sales_order_id":"10003","number":null,"po_number":null,"date":"2013-03-06 07:30:52","due_date":null,"received_date":null,"contact_person":null,"contact":"azad","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"azad\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"zipcode\\":\\"ada\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":"123","delivery_status":"Ready for Pick-up","delivery_date":"2013-03-06 00:00:00","shipping":"Self Pickup","shipping_id":"6","terms":"Cash","duration":"0","remarks":"No remarks","status":"Pending","payment_status":"Unpaid","payment_date":"0000-00-00 00:00:00","payment_reference":"","payment_contra":"","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"190.00","total_delivered":"0.00","cost":null,"tags":"Online Sales","added_on":"2013-03-06 07:30:52","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":null,"total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"orders":[{"id":"1","invoice_id":"10001","type":"product","date":"2013-03-06 07:30:52","item_name":"Evolution Standing Lamp","item_description":"","item_id":"14","service_id":null,"item_sku":"ESL2191","discount":null,"discount_type":null,"qty":"1","price_per_unit":"190.0000","price":"190.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"190.00","done":"0","no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 16:10:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5ce75bba6298a10e403e09672cf79b5a","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2013-03-06 07:29:46","modified_by":"admin2","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1362561781","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-07 11:58:45', 'admin2'),
(270, 'inventory', 'edit', 'item', 12, '{"id":"12","primary_image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Torsade Table Lamp 30","model_no":"","warranty":"","sku":"TTL23012","sku2":"4321","sku3":"","sku4":"","qty":"99","alert_quantity":"1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:03:25","added_by":"admin","modified_on":"2013-03-09 13:36:43","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"24","uom2":"44","uom3":"","uom4":"","loose_qty2":"2","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2013-03-09 13:36:43', 'admin2'),
(271, 'sales', 'add', 'so', 10005, '{"id":"10005","txn_no":"1-10003","quote_id":"0","invoice_id":null,"number":"0","po_number":"0","date":"2013-03-11 00:00:00","due_date":"2013-03-11 00:00:00","received_date":null,"contact_person":"JawiHerbShop ","contact":"Land Mind Consultant","contact_id":"1103","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Land Mind Consultant\\",\\"mobile\\":\\"0398981122\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Negeri Sembilan\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"600.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-11 21:44:56","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"5","sales_order_id":"10005","type":"product","date":"2013-03-11 00:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"6.0000","price":"600.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2013-03-11 21:44:56', 'admin2'),
(272, 'sales', 'status_update', 'so', 10005, '{"id":"10005","txn_no":"1-10003","quote_id":"0","invoice_id":null,"number":"0","po_number":"0","date":"2013-03-11 00:00:00","due_date":"2013-03-11 00:00:00","received_date":null,"contact_person":"JawiHerbShop ","contact":"Land Mind Consultant","contact_id":"1103","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Land Mind Consultant\\",\\"mobile\\":\\"0398981122\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Negeri Sembilan\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Completed","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"600.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-11 21:44:56","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"5","sales_order_id":"10005","type":"product","date":"2013-03-11 00:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"6.0000","price":"600.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2013-03-11 21:45:50', 'admin2'),
(273, 'sales', 'add', 'invoice', 10004, '{"id":"10004","txn_no":"1-10004","quote_id":"0","sales_order_id":"10005","number":"0","po_number":"N\\/A","date":"2013-03-11 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Land Mind Consultant","contact_id":"1103","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Land Mind Consultant\\",\\"mobile\\":\\"0398981122\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Negeri Sembilan\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"600.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-11 21:46:00","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"15","invoice_id":"10004","type":"product","date":"2013-03-11 12:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"6.0000","price":"600.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1103","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Land Mind Consultant","company_registration":"","contact_person":"Benjamin Franklin","contact_number":"0398981122","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:58:06","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 21:46:00', 'admin2'),
(274, 'sales', 'status_update', 'invoice', 10004, '{"id":"10004","txn_no":"1-10004","quote_id":"0","sales_order_id":"10005","number":"0","po_number":"N\\/A","date":"2013-03-11 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Land Mind Consultant","contact_id":"1103","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Land Mind Consultant\\",\\"mobile\\":\\"0398981122\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Negeri Sembilan\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Partially Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"600.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-11 21:46:00","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"15","invoice_id":"10004","type":"product","date":"2013-03-11 12:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"6.0000","price":"600.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1103","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Land Mind Consultant","company_registration":"","contact_person":"Benjamin Franklin","contact_number":"0398981122","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:58:06","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 21:46:20', 'admin2'),
(275, 'sales', 'deliver', 'invoice', 10004, '{"id":"10004","txn_no":"1-10004","quote_id":"0","sales_order_id":"10005","number":"0","po_number":"N\\/A","date":"2013-03-11 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Land Mind Consultant","contact_id":"1103","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Land Mind Consultant\\",\\"mobile\\":\\"0398981122\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Negeri Sembilan\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"600.00","total_delivered":"330.00","cost":null,"tags":"","added_on":"2013-03-11 21:46:00","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"15","invoice_id":"10004","type":"product","date":"2013-03-11 12:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"6.0000","price":"600.00","cost":"110.00","margin":null,"delivered":"55","delivered_price":"330.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"-55","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 21:46:37","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1103","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Land Mind Consultant","company_registration":"","contact_person":"Benjamin Franklin","contact_number":"0398981122","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:58:06","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 21:46:37', 'admin2');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(276, 'inventory', 'add', 'po', 10008, '{"id":"10008","txn_no":"8-10001","invoice_number":"","number":null,"date":"2013-03-11 00:00:00","due_date":null,"contact_person":"Administrator 3 ","received_date":null,"supplier":"Dinamika Enterprise","supplier_id":"1087","supplier_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-11 21:56:19","added_by":"admin3","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"8","assigned_to":null,"orders":[{"id":"18","purchase_order_id":"10008","date":"2013-03-11 00:00:00","item_description":null,"item_name":"Almeta ()","item_id":"25","discount":"0","discount_type":null,"qty":"50","price_per_unit":"50.0000","price":"2500.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"8"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"100","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-11 21:56:19', 'admin3'),
(277, 'sales', 'add', 'so', 10006, '{"id":"10006","txn_no":"1-10004","quote_id":"0","invoice_id":null,"number":"0","po_number":"0","date":"2013-03-11 00:00:00","due_date":"2013-03-11 00:00:00","received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-11 21:58:45","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"6","sales_order_id":"10006","type":"product","date":"2013-03-11 00:00:00","item_name":"Torsade Table Lamp 30","item_description":"","item_id":"12","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"120.0000","price":"1200.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"12":{"id":"12","primary_image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Torsade Table Lamp 30","model_no":"","warranty":"","sku":"TTL23012","sku2":"4321","sku3":"","sku4":"","qty":"99","alert_quantity":"1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:03:25","added_by":"admin","modified_on":"2013-03-09 13:36:43","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"24","uom2":"44","uom3":"","uom4":"","loose_qty2":"2","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2013-03-11 21:58:45', 'admin2'),
(278, 'sales', 'status_update', 'so', 10006, '{"id":"10006","txn_no":"1-10004","quote_id":"0","invoice_id":null,"number":"0","po_number":"0","date":"2013-03-11 00:00:00","due_date":"2013-03-11 00:00:00","received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Completed","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-11 21:58:45","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"6","sales_order_id":"10006","type":"product","date":"2013-03-11 00:00:00","item_name":"Torsade Table Lamp 30","item_description":"","item_id":"12","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"120.0000","price":"1200.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"12":{"id":"12","primary_image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Torsade Table Lamp 30","model_no":"","warranty":"","sku":"TTL23012","sku2":"4321","sku3":"","sku4":"","qty":"99","alert_quantity":"1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:03:25","added_by":"admin","modified_on":"2013-03-09 13:36:43","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"24","uom2":"44","uom3":"","uom4":"","loose_qty2":"2","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2013-03-11 21:59:58', 'admin2'),
(279, 'sales', 'add', 'invoice', 10005, '{"id":"10005","txn_no":"1-10005","quote_id":"0","sales_order_id":"10006","number":"0","po_number":"N\\/A","date":"2013-03-11 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-11 22:00:40","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"16","invoice_id":"10005","type":"product","date":"2013-03-11 12:00:00","item_name":"Torsade Table Lamp 30","item_description":"","item_id":"12","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"120.0000","price":"1200.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"12":{"id":"12","primary_image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Torsade Table Lamp 30","model_no":"","warranty":"","sku":"TTL23012","sku2":"4321","sku3":"","sku4":"","qty":"99","alert_quantity":"1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:03:25","added_by":"admin","modified_on":"2013-03-09 13:36:43","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"24","uom2":"44","uom3":"","uom4":"","loose_qty2":"2","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:00:41', 'admin2'),
(280, 'sales', 'paid', 'invoice', 10005, '{"id":"10005","txn_no":"1-10005","quote_id":"0","sales_order_id":"10006","number":"0","po_number":"N\\/A","date":"2013-03-11 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Paid","payment_date":"2013-03-11 00:00:00","payment_reference":"123","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-11 22:00:40","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"16","invoice_id":"10005","type":"product","date":"2013-03-11 12:00:00","item_name":"Torsade Table Lamp 30","item_description":"","item_id":"12","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"120.0000","price":"1200.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"12":{"id":"12","primary_image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Torsade Table Lamp 30","model_no":"","warranty":"","sku":"TTL23012","sku2":"4321","sku3":"","sku4":"","qty":"99","alert_quantity":"1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:03:25","added_by":"admin","modified_on":"2013-03-09 13:36:43","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"24","uom2":"44","uom3":"","uom4":"","loose_qty2":"2","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:01:53', 'admin2'),
(281, 'sales', 'deliver', 'invoice', 10005, '{"id":"10005","txn_no":"1-10005","quote_id":"0","sales_order_id":"10006","number":"0","po_number":"N\\/A","date":"2013-03-11 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Paid","payment_date":"2013-03-11 00:00:00","payment_reference":"123","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1200.00","total_delivered":"600.00","cost":null,"tags":"","added_on":"2013-03-11 22:00:40","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"16","invoice_id":"10005","type":"product","date":"2013-03-11 12:00:00","item_name":"Torsade Table Lamp 30","item_description":"","item_id":"12","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"120.0000","price":"1200.00","cost":"0.00","margin":null,"delivered":"5","delivered_price":"600.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"12":{"id":"12","primary_image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Torsade Table Lamp 30","model_no":"","warranty":"","sku":"TTL23012","sku2":"4321","sku3":"","sku4":"","qty":"94","alert_quantity":"1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:03:25","added_by":"admin","modified_on":"2013-03-09 13:36:43","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"24","uom2":"44","uom3":"","uom4":"","loose_qty2":"2","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-11 22:02:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:02:05', 'admin2'),
(282, 'sales', 'deliver', 'invoice', 10005, '{"id":"10005","txn_no":"1-10005","quote_id":"0","sales_order_id":"10006","number":"0","po_number":"N\\/A","date":"2013-03-11 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Paid","payment_date":"2013-03-11 00:00:00","payment_reference":"123","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1200.00","total_delivered":"600.00","cost":null,"tags":"","added_on":"2013-03-11 22:00:40","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"16","invoice_id":"10005","type":"product","date":"2013-03-11 12:00:00","item_name":"Torsade Table Lamp 30","item_description":"","item_id":"12","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"120.0000","price":"1200.00","cost":"0.00","margin":null,"delivered":"5","delivered_price":"600.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"12":{"id":"12","primary_image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Torsade Table Lamp 30","model_no":"","warranty":"","sku":"TTL23012","sku2":"4321","sku3":"","sku4":"","qty":"94","alert_quantity":"1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:03:25","added_by":"admin","modified_on":"2013-03-09 13:36:43","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"24","uom2":"44","uom3":"","uom4":"","loose_qty2":"2","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-11 22:02:36","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:02:36', 'admin2'),
(283, 'sales', 'status_update', 'invoice', 10005, '{"id":"10005","txn_no":"1-10005","quote_id":"0","sales_order_id":"10006","number":"0","po_number":"N\\/A","date":"2013-03-11 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Partially Delivered","payment_status":"Paid","payment_date":"2013-03-11 00:00:00","payment_reference":"123","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1200.00","total_delivered":"600.00","cost":null,"tags":"","added_on":"2013-03-11 22:00:40","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"16","invoice_id":"10005","type":"product","date":"2013-03-11 12:00:00","item_name":"Torsade Table Lamp 30","item_description":"","item_id":"12","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"120.0000","price":"1200.00","cost":"0.00","margin":null,"delivered":"5","delivered_price":"600.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"12":{"id":"12","primary_image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Torsade Table Lamp 30","model_no":"","warranty":"","sku":"TTL23012","sku2":"4321","sku3":"","sku4":"","qty":"94","alert_quantity":"1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:03:25","added_by":"admin","modified_on":"2013-03-09 13:36:43","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"24","uom2":"44","uom3":"","uom4":"","loose_qty2":"2","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-11 22:02:36","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:02:40', 'admin2'),
(284, 'sales', 'status_update', 'invoice', 10004, '{"id":"10004","txn_no":"1-10004","quote_id":"0","sales_order_id":"10005","number":"0","po_number":"N\\/A","date":"2013-03-11 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Land Mind Consultant","contact_id":"1103","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Land Mind Consultant\\",\\"mobile\\":\\"0398981122\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Negeri Sembilan\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Partially Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"600.00","total_delivered":"330.00","cost":null,"tags":"","added_on":"2013-03-11 21:46:00","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"15","invoice_id":"10004","type":"product","date":"2013-03-11 12:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"6.0000","price":"600.00","cost":"110.00","margin":null,"delivered":"55","delivered_price":"330.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"-55","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 21:46:37","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1103","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Land Mind Consultant","company_registration":"","contact_person":"Benjamin Franklin","contact_number":"0398981122","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:58:06","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:05:16', 'admin2'),
(285, 'sales', 'deliver', 'invoice', 10005, '{"id":"10005","txn_no":"1-10005","quote_id":"0","sales_order_id":"10006","number":"0","po_number":"N\\/A","date":"2013-03-11 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Paid","payment_date":"2013-03-11 00:00:00","payment_reference":"123","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1200.00","total_delivered":"1200.00","cost":null,"tags":"","added_on":"2013-03-11 22:00:40","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"16","invoice_id":"10005","type":"product","date":"2013-03-11 12:00:00","item_name":"Torsade Table Lamp 30","item_description":"","item_id":"12","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"120.0000","price":"1200.00","cost":"0.00","margin":null,"delivered":"10","delivered_price":"1200.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"12":{"id":"12","primary_image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Torsade Table Lamp 30","model_no":"","warranty":"","sku":"TTL23012","sku2":"4321","sku3":"","sku4":"","qty":"89","alert_quantity":"1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:03:25","added_by":"admin","modified_on":"2013-03-09 13:36:43","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"24","uom2":"44","uom3":"","uom4":"","loose_qty2":"2","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-11 22:08:41","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:08:41', 'admin'),
(286, 'sales', 'status_update', 'invoice', 10005, '{"id":"10005","txn_no":"1-10005","quote_id":"0","sales_order_id":"10006","number":"0","po_number":"N\\/A","date":"2013-03-11 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Paid","payment_date":"2013-03-11 00:00:00","payment_reference":"123","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1200.00","total_delivered":"1200.00","cost":null,"tags":"","added_on":"2013-03-11 22:00:40","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"16","invoice_id":"10005","type":"product","date":"2013-03-11 12:00:00","item_name":"Torsade Table Lamp 30","item_description":"","item_id":"12","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"120.0000","price":"1200.00","cost":"0.00","margin":null,"delivered":"10","delivered_price":"1200.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"12":{"id":"12","primary_image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Torsade Table Lamp 30","model_no":"","warranty":"","sku":"TTL23012","sku2":"4321","sku3":"","sku4":"","qty":"89","alert_quantity":"1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:03:25","added_by":"admin","modified_on":"2013-03-09 13:36:43","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"24","uom2":"44","uom3":"","uom4":"","loose_qty2":"2","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-11 22:08:41","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:08:43', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(287, 'sales', 'status_update', 'invoice', 10004, '{"id":"10004","txn_no":"1-10004","quote_id":"0","sales_order_id":"10005","number":"0","po_number":"N\\/A","date":"2013-03-11 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Land Mind Consultant","contact_id":"1103","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Land Mind Consultant\\",\\"mobile\\":\\"0398981122\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Negeri Sembilan\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"600.00","total_delivered":"0.00","cost":null,"tags":"","added_on":"2013-03-11 21:46:00","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"15","invoice_id":"10004","type":"product","date":"2013-03-11 12:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"6.0000","price":"600.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"330.00","done":"0","no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 21:46:37","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1103","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Land Mind Consultant","company_registration":"","contact_person":"Benjamin Franklin","contact_number":"0398981122","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:58:06","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:09:18', 'admin2'),
(288, 'sales', 'deliver', 'invoice', 10004, '{"id":"10004","txn_no":"1-10004","quote_id":"0","sales_order_id":"10005","number":"0","po_number":"N\\/A","date":"2013-03-11 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Land Mind Consultant","contact_id":"1103","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Land Mind Consultant\\",\\"mobile\\":\\"0398981122\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Negeri Sembilan\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"600.00","total_delivered":"0.00","cost":null,"tags":"","added_on":"2013-03-11 21:46:00","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"15","invoice_id":"10004","type":"product","date":"2013-03-11 12:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"6.0000","price":"600.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"0.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:09:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1103","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Land Mind Consultant","company_registration":"","contact_person":"Benjamin Franklin","contact_number":"0398981122","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:58:06","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:09:49', 'admin'),
(289, 'sales', 'status_update', 'invoice', 10004, '{"id":"10004","txn_no":"1-10004","quote_id":"0","sales_order_id":"10005","number":"0","po_number":"N\\/A","date":"2013-03-11 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Land Mind Consultant","contact_id":"1103","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Land Mind Consultant\\",\\"mobile\\":\\"0398981122\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Negeri Sembilan\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Partially Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"600.00","total_delivered":"0.00","cost":null,"tags":"","added_on":"2013-03-11 21:46:00","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"15","invoice_id":"10004","type":"product","date":"2013-03-11 12:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"6.0000","price":"600.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"0.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:09:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1103","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Land Mind Consultant","company_registration":"","contact_person":"Benjamin Franklin","contact_number":"0398981122","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:58:06","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:09:51', 'admin'),
(290, 'sales', 'deliver', 'invoice', 10004, '{"id":"10004","txn_no":"1-10004","quote_id":"0","sales_order_id":"10005","number":"0","po_number":"N\\/A","date":"2013-03-11 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Land Mind Consultant","contact_id":"1103","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Land Mind Consultant\\",\\"mobile\\":\\"0398981122\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Negeri Sembilan\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"600.00","total_delivered":"30.00","cost":null,"tags":"","added_on":"2013-03-11 21:46:00","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"15","invoice_id":"10004","type":"product","date":"2013-03-11 12:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"6.0000","price":"600.00","cost":"10.00","margin":null,"delivered":"5","delivered_price":"30.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"-5","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:10:21","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1103","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Land Mind Consultant","company_registration":"","contact_person":"Benjamin Franklin","contact_number":"0398981122","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:58:06","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:10:21', 'admin'),
(291, 'sales', 'status_update', 'invoice', 10004, '{"id":"10004","txn_no":"1-10004","quote_id":"0","sales_order_id":"10005","number":"0","po_number":"N\\/A","date":"2013-03-11 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Land Mind Consultant","contact_id":"1103","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Land Mind Consultant\\",\\"mobile\\":\\"0398981122\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Negeri Sembilan\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Partially Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"600.00","total_delivered":"30.00","cost":null,"tags":"","added_on":"2013-03-11 21:46:00","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"15","invoice_id":"10004","type":"product","date":"2013-03-11 12:00:00","item_name":"Accessory Strap","item_description":"","item_id":"66","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"6.0000","price":"600.00","cost":"10.00","margin":null,"delivered":"5","delivered_price":"30.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"-5","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:10:21","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1103","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Land Mind Consultant","company_registration":"","contact_person":"Benjamin Franklin","contact_number":"0398981122","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:58:06","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:10:23', 'admin'),
(292, 'sales', 'add', 'so', 10007, '{"id":"10007","txn_no":"1-10005","quote_id":"0","invoice_id":null,"number":"0","po_number":"0","date":"2013-03-12 00:00:00","due_date":"2013-03-12 00:00:00","received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3850.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-11 22:14:29","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"7","sales_order_id":"10007","type":"product","date":"2013-03-12 00:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"50","price_per_unit":"77.0000","price":"3850.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"99","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2013-03-11 22:14:29', 'admin2'),
(293, 'sales', 'edit', 'so', 10007, '{"id":"10007","txn_no":"1-10005","quote_id":"0","invoice_id":null,"number":"0","po_number":"0","date":"2013-03-12 00:00:00","due_date":"2013-03-12 00:00:00","received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3850.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-11 22:14:29","added_by":"admin2","modified_on":"2013-03-11 22:14:46","modified_by":"admin2","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"8","sales_order_id":"10007","type":"product","date":"2013-03-12 00:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"50","price_per_unit":"77.0000","price":"3850.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"99","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2013-03-11 22:14:46', 'admin2'),
(294, 'sales', 'status_update', 'so', 10007, '{"id":"10007","txn_no":"1-10005","quote_id":"0","invoice_id":null,"number":"0","po_number":"0","date":"2013-03-12 00:00:00","due_date":"2013-03-12 00:00:00","received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Completed","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3850.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-11 22:14:29","added_by":"admin2","modified_on":"2013-03-11 22:14:46","modified_by":"admin2","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"8","sales_order_id":"10007","type":"product","date":"2013-03-12 00:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"50","price_per_unit":"77.0000","price":"3850.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"99","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2013-03-11 22:15:13', 'admin2'),
(295, 'sales', 'add', 'invoice', 10006, '{"id":"10006","txn_no":"1-10006","quote_id":"0","sales_order_id":"10007","number":"0","po_number":"N\\/A","date":"2013-03-12 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-11 22:16:43","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"17","invoice_id":"10006","type":"product","date":"2013-03-12 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"99","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:16:43', 'admin2'),
(296, 'sales', 'paid', 'invoice', 10006, '{"id":"10006","txn_no":"1-10006","quote_id":"0","sales_order_id":"10007","number":"0","po_number":"N\\/A","date":"2013-03-12 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Paid","payment_date":"2013-03-12 00:00:00","payment_reference":"123","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-11 22:16:43","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"17","invoice_id":"10006","type":"product","date":"2013-03-12 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"99","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:18:32', 'admin2'),
(297, 'sales', 'deliver', 'invoice', 10006, '{"id":"10006","txn_no":"1-10006","quote_id":"0","sales_order_id":"10007","number":"0","po_number":"N\\/A","date":"2013-03-12 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Paid","payment_date":"2013-03-12 00:00:00","payment_reference":"123","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":"770.00","cost":null,"tags":"","added_on":"2013-03-11 22:16:43","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"17","invoice_id":"10006","type":"product","date":"2013-03-12 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":"0.00","margin":null,"delivered":"10","delivered_price":"770.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"89","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:18:41","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:18:41', 'admin2'),
(298, 'sales', 'deliver', 'invoice', 10006, '{"id":"10006","txn_no":"1-10006","quote_id":"0","sales_order_id":"10007","number":"0","po_number":"N\\/A","date":"2013-03-12 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Paid","payment_date":"2013-03-12 00:00:00","payment_reference":"123","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":"770.00","cost":null,"tags":"","added_on":"2013-03-11 22:16:43","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"17","invoice_id":"10006","type":"product","date":"2013-03-12 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":"0.00","margin":null,"delivered":"10","delivered_price":"770.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"89","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:19:28","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:19:28', 'admin2');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(299, 'sales', 'deliver', 'invoice', 10006, '{"id":"10006","txn_no":"1-10006","quote_id":"0","sales_order_id":"10007","number":"0","po_number":"N\\/A","date":"2013-03-12 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Paid","payment_date":"2013-03-12 00:00:00","payment_reference":"123","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":"770.00","cost":null,"tags":"","added_on":"2013-03-11 22:16:43","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"17","invoice_id":"10006","type":"product","date":"2013-03-12 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":"0.00","margin":null,"delivered":"10","delivered_price":"770.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"89","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:19:52","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:19:52', 'admin'),
(300, 'sales', 'status_update', 'invoice', 10006, '{"id":"10006","txn_no":"1-10006","quote_id":"0","sales_order_id":"10007","number":"0","po_number":"N\\/A","date":"2013-03-12 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Paid","payment_date":"2013-03-12 00:00:00","payment_reference":"123","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":"770.00","cost":null,"tags":"","added_on":"2013-03-11 22:16:43","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"17","invoice_id":"10006","type":"product","date":"2013-03-12 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":"0.00","margin":null,"delivered":"10","delivered_price":"770.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"89","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:19:52","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:19:54', 'admin'),
(301, 'sales', 'add', 'invoice', 10007, '{"id":"10007","txn_no":"1-10007","quote_id":"0","sales_order_id":"10007","number":"0","po_number":"N\\/A","date":"2013-03-12 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-11 22:20:55","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"18","invoice_id":"10007","type":"product","date":"2013-03-12 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"89","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:19:52","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:20:55', 'admin2'),
(302, 'sales', 'paid', 'invoice', 10007, '{"id":"10007","txn_no":"1-10007","quote_id":"0","sales_order_id":"10007","number":"0","po_number":"N\\/A","date":"2013-03-12 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Paid","payment_date":"2013-03-12 00:00:00","payment_reference":"12","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-11 22:20:55","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"18","invoice_id":"10007","type":"product","date":"2013-03-12 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"89","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:19:52","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:21:10', 'admin2'),
(303, 'sales', 'deliver', 'invoice', 10007, '{"id":"10007","txn_no":"1-10007","quote_id":"0","sales_order_id":"10007","number":"0","po_number":"N\\/A","date":"2013-03-12 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Paid","payment_date":"2013-03-12 00:00:00","payment_reference":"12","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":"770.00","cost":null,"tags":"","added_on":"2013-03-11 22:20:55","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"18","invoice_id":"10007","type":"product","date":"2013-03-12 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":"0.00","margin":null,"delivered":"10","delivered_price":"770.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"79","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:21:16","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:21:16', 'admin2'),
(304, 'sales', 'deliver', 'invoice', 10007, '{"id":"10007","txn_no":"1-10007","quote_id":"0","sales_order_id":"10007","number":"0","po_number":"N\\/A","date":"2013-03-12 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Paid","payment_date":"2013-03-12 00:00:00","payment_reference":"12","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":"770.00","cost":null,"tags":"","added_on":"2013-03-11 22:20:55","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"18","invoice_id":"10007","type":"product","date":"2013-03-12 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":"0.00","margin":null,"delivered":"10","delivered_price":"770.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"79","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:21:59","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:21:59', 'admin2'),
(305, 'sales', 'status_update', 'invoice', 10007, '{"id":"10007","txn_no":"1-10007","quote_id":"0","sales_order_id":"10007","number":"0","po_number":"N\\/A","date":"2013-03-12 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Paid","payment_date":"2013-03-12 00:00:00","payment_reference":"12","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":"770.00","cost":null,"tags":"","added_on":"2013-03-11 22:20:55","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"18","invoice_id":"10007","type":"product","date":"2013-03-12 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":"0.00","margin":null,"delivered":"10","delivered_price":"770.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"79","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:21:59","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:22:01', 'admin2'),
(306, 'sales', 'add', 'invoice', 10008, '{"id":"10008","txn_no":"1-10008","quote_id":"0","sales_order_id":"10007","number":"0","po_number":"N\\/A","date":"2013-03-12 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-11 22:22:30","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"19","invoice_id":"10008","type":"product","date":"2013-03-12 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"79","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:21:59","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:22:30', 'admin2'),
(307, 'sales', 'deliver', 'invoice', 10008, '{"id":"10008","txn_no":"1-10008","quote_id":"0","sales_order_id":"10007","number":"0","po_number":"N\\/A","date":"2013-03-12 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":"770.00","cost":null,"tags":"","added_on":"2013-03-11 22:22:30","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"19","invoice_id":"10008","type":"product","date":"2013-03-12 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":"0.00","margin":null,"delivered":"10","delivered_price":"770.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"69","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:22:50","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:22:50', 'admin2'),
(308, 'sales', 'deliver', 'invoice', 10008, '{"id":"10008","txn_no":"1-10008","quote_id":"0","sales_order_id":"10007","number":"0","po_number":"N\\/A","date":"2013-03-12 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":"770.00","cost":null,"tags":"","added_on":"2013-03-11 22:22:30","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"19","invoice_id":"10008","type":"product","date":"2013-03-12 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":"0.00","margin":null,"delivered":"10","delivered_price":"770.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"69","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:25:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:25:47', 'admin2'),
(309, 'sales', 'status_update', 'invoice', 10008, '{"id":"10008","txn_no":"1-10008","quote_id":"0","sales_order_id":"10007","number":"0","po_number":"N\\/A","date":"2013-03-12 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":"770.00","cost":null,"tags":"","added_on":"2013-03-11 22:22:30","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"19","invoice_id":"10008","type":"product","date":"2013-03-12 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":"0.00","margin":null,"delivered":"10","delivered_price":"770.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"69","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:25:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:25:49', 'admin2');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(310, 'sales', 'add', 'invoice', 10009, '{"id":"10009","txn_no":"1-10009","quote_id":"0","sales_order_id":"10007","number":"0","po_number":"N\\/A","date":"2013-03-12 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-11 22:28:18","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"20","invoice_id":"10009","type":"product","date":"2013-03-12 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"69","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:25:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:28:18', 'admin2'),
(311, 'sales', 'deliver', 'invoice', 10009, '{"id":"10009","txn_no":"1-10009","quote_id":"0","sales_order_id":"10007","number":"0","po_number":"N\\/A","date":"2013-03-12 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":"770.00","cost":null,"tags":"","added_on":"2013-03-11 22:28:18","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"20","invoice_id":"10009","type":"product","date":"2013-03-12 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":"0.00","margin":null,"delivered":"10","delivered_price":"770.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"59","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:30:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:30:34', 'admin2'),
(312, 'sales', 'status_update', 'invoice', 10009, '{"id":"10009","txn_no":"1-10009","quote_id":"0","sales_order_id":"10007","number":"0","po_number":"N\\/A","date":"2013-03-12 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":"770.00","cost":null,"tags":"","added_on":"2013-03-11 22:28:18","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"20","invoice_id":"10009","type":"product","date":"2013-03-12 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":"0.00","margin":null,"delivered":"10","delivered_price":"770.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"59","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:30:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-11 22:30:36', 'admin2'),
(313, 'sales', 'add', 'invoice', 10010, '{"id":"10010","txn_no":"1-10010","quote_id":"0","sales_order_id":"10007","number":"0","po_number":"N\\/A","date":"2013-03-12 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-12 21:02:45","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"21","invoice_id":"10010","type":"product","date":"2013-03-12 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"59","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:30:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-12 21:02:46', 'admin2'),
(314, 'sales', 'status_update', 'invoice', 10010, '{"id":"10010","txn_no":"1-10010","quote_id":"0","sales_order_id":"10007","number":"0","po_number":"N\\/A","date":"2013-03-12 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-12 21:02:45","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"21","invoice_id":"10010","type":"product","date":"2013-03-12 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"59","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:30:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-12 21:03:03', 'admin2'),
(315, 'sales', 'status_update', 'invoice', 10010, '{"id":"10010","txn_no":"1-10010","quote_id":"0","sales_order_id":"10007","number":"0","po_number":"N\\/A","date":"2013-03-12 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":"0.00","cost":null,"tags":"","added_on":"2013-03-12 21:02:45","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"21","invoice_id":"10010","type":"product","date":"2013-03-12 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":null,"done":"0","no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"59","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:30:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-12 21:03:53', 'admin2'),
(316, 'sales', 'deliver', 'invoice', 10010, '{"id":"10010","txn_no":"1-10010","quote_id":"0","sales_order_id":"10007","number":"0","po_number":"N\\/A","date":"2013-03-12 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":"770.00","cost":null,"tags":"","added_on":"2013-03-12 21:02:45","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"21","invoice_id":"10010","type":"product","date":"2013-03-12 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":"0.00","margin":null,"delivered":"10","delivered_price":"770.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"49","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-12 21:04:06","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-12 21:04:06', 'admin2'),
(317, 'sales', 'add', 'so', 10008, '{"id":"10008","txn_no":"1-10006","quote_id":"0","invoice_id":null,"number":"0","po_number":"0","date":"2013-03-16 00:00:00","due_date":"2014-03-16 00:00:00","received_date":null,"contact_person":"JawiHerbShop ","contact":"Roger Federed Sdn Bhd","contact_id":"1097","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Roger Federed Sdn Bhd\\",\\"mobile\\":\\"048575662\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-16 13:26:41","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"9","sales_order_id":"10008","type":"product","date":"2013-03-16 00:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"49","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-12 21:04:06","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2013-03-16 13:26:42', 'admin2'),
(318, 'sales', 'status_update', 'so', 10008, '{"id":"10008","txn_no":"1-10006","quote_id":"0","invoice_id":null,"number":"0","po_number":"0","date":"2013-03-16 00:00:00","due_date":"2014-03-16 00:00:00","received_date":null,"contact_person":"JawiHerbShop ","contact":"Roger Federed Sdn Bhd","contact_id":"1097","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Roger Federed Sdn Bhd\\",\\"mobile\\":\\"048575662\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Completed","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"770.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-16 13:26:41","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"9","sales_order_id":"10008","type":"product","date":"2013-03-16 00:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"77.0000","price":"770.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"49","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-12 21:04:06","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2013-03-16 13:31:31', 'admin2'),
(319, 'sales', 'add', 'invoice', 10011, '{"id":"10011","txn_no":"1-10011","quote_id":"0","sales_order_id":"10008","number":"0","po_number":"N\\/A","date":"2013-03-16 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Roger Federed Sdn Bhd","contact_id":"1097","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Roger Federed Sdn Bhd\\",\\"mobile\\":\\"048575662\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"385.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-16 13:33:04","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"22","invoice_id":"10011","type":"product","date":"2013-03-16 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"5","price_per_unit":"77.0000","price":"385.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"49","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-12 21:04:06","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1097","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Roger Federed Sdn Bhd","company_registration":"","contact_person":"Federed Roger","contact_number":"048575662","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:52:16","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-16 13:33:05', 'admin2'),
(320, 'sales', 'add', 'invoice', 10012, '{"id":"10012","txn_no":"1-10012","quote_id":"0","sales_order_id":"10008","number":"0","po_number":"N\\/A","date":"2013-03-16 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Roger Federed Sdn Bhd","contact_id":"1097","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Roger Federed Sdn Bhd\\",\\"mobile\\":\\"048575662\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"385.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-16 13:35:04","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"23","invoice_id":"10012","type":"product","date":"2013-03-16 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"5","price_per_unit":"77.0000","price":"385.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"49","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-12 21:04:06","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1097","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Roger Federed Sdn Bhd","company_registration":"","contact_person":"Federed Roger","contact_number":"048575662","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:52:16","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-16 13:35:04', 'admin2'),
(321, 'inventory', 'add', 'po', 10009, '{"id":"10009","txn_no":"1-10008","invoice_number":"","number":null,"date":"2013-03-16 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Roger Federed Sdn Bhd","supplier_id":"1097","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Main\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"\\",\\"country\\":\\"\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"200.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-16 14:12:52","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"20","purchase_order_id":"10009","date":"2013-03-16 00:00:00","item_description":null,"item_name":"Basic Bankbook Holder ()","item_id":"36","discount":"0","discount_type":null,"qty":"10","price_per_unit":"20.0000","price":"200.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-16 14:12:52', 'admin2');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(322, 'inventory', 'edit', 'item', 36, '{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"100","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-02-20 22:44:49","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2013-03-16 14:14:36', 'admin2'),
(323, 'sales', 'add', 'so', 10009, '{"id":"10009","txn_no":"1-10007","quote_id":"0","invoice_id":null,"number":"0","po_number":"0","date":"2013-03-16 00:00:00","due_date":"2013-03-16 00:00:00","received_date":null,"contact_person":"JawiHerbShop ","contact":"Indigo Technologies Sdn Bhd","contact_id":"1105","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Indigo Technologies Sdn Bhd\\",\\"mobile\\":\\"0369102012\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"5500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-16 14:16:21","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"10","sales_order_id":"10009","type":"product","date":"2013-03-16 00:00:00","item_name":"Basic Bankbook Holder","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"55.0000","price":"5500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"90","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-16 14:15:11","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2013-03-16 14:16:21', 'admin2'),
(324, 'sales', 'status_update', 'so', 10009, '{"id":"10009","txn_no":"1-10007","quote_id":"0","invoice_id":null,"number":"0","po_number":"0","date":"2013-03-16 00:00:00","due_date":"2013-03-16 00:00:00","received_date":null,"contact_person":"JawiHerbShop ","contact":"Indigo Technologies Sdn Bhd","contact_id":"1105","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Indigo Technologies Sdn Bhd\\",\\"mobile\\":\\"0369102012\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Completed","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"5500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-16 14:16:21","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"10","sales_order_id":"10009","type":"product","date":"2013-03-16 00:00:00","item_name":"Basic Bankbook Holder","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"55.0000","price":"5500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"90","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-16 14:15:11","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2013-03-16 14:16:49', 'admin2'),
(325, 'sales', 'add', 'invoice', 10013, '{"id":"10013","txn_no":"1-10013","quote_id":"0","sales_order_id":"10009","number":"0","po_number":"N\\/A","date":"2013-03-16 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Indigo Technologies Sdn Bhd","contact_id":"1105","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Indigo Technologies Sdn Bhd\\",\\"mobile\\":\\"0369102012\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"550.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-16 14:17:15","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"24","invoice_id":"10013","type":"product","date":"2013-03-16 12:00:00","item_name":"Basic Bankbook Holder","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"55.0000","price":"550.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"90","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-16 14:15:11","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1105","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Indigo Technologies Sdn Bhd","company_registration":"","contact_person":"Frank Lampard","contact_number":"0369102012","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:59:45","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-16 14:17:15', 'admin2'),
(326, 'sales', 'deliver', 'invoice', 10013, '{"id":"10013","txn_no":"1-10013","quote_id":"0","sales_order_id":"10009","number":"0","po_number":"N\\/A","date":"2013-03-16 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Indigo Technologies Sdn Bhd","contact_id":"1105","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Indigo Technologies Sdn Bhd\\",\\"mobile\\":\\"0369102012\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"550.00","total_delivered":"550.00","cost":null,"tags":"","added_on":"2013-03-16 14:17:15","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"24","invoice_id":"10013","type":"product","date":"2013-03-16 12:00:00","item_name":"Basic Bankbook Holder","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"55.0000","price":"550.00","cost":"0.00","margin":null,"delivered":"10","delivered_price":"550.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"80","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-16 14:17:29","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1105","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Indigo Technologies Sdn Bhd","company_registration":"","contact_person":"Frank Lampard","contact_number":"0369102012","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:59:45","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-16 14:17:29', 'admin2'),
(327, 'sales', 'status_update', 'invoice', 10013, '{"id":"10013","txn_no":"1-10013","quote_id":"0","sales_order_id":"10009","number":"0","po_number":"N\\/A","date":"2013-03-16 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Indigo Technologies Sdn Bhd","contact_id":"1105","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Indigo Technologies Sdn Bhd\\",\\"mobile\\":\\"0369102012\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"550.00","total_delivered":"550.00","cost":null,"tags":"","added_on":"2013-03-16 14:17:15","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"24","invoice_id":"10013","type":"product","date":"2013-03-16 12:00:00","item_name":"Basic Bankbook Holder","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"55.0000","price":"550.00","cost":"0.00","margin":null,"delivered":"10","delivered_price":"550.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"80","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-16 14:17:29","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1105","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Indigo Technologies Sdn Bhd","company_registration":"","contact_person":"Frank Lampard","contact_number":"0369102012","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:59:45","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-16 14:20:10', 'admin2'),
(328, 'sales', 'paid', 'invoice', 10013, '{"id":"10013","txn_no":"1-10013","quote_id":"0","sales_order_id":"10009","number":"0","po_number":"N\\/A","date":"2013-03-16 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Indigo Technologies Sdn Bhd","contact_id":"1105","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Indigo Technologies Sdn Bhd\\",\\"mobile\\":\\"0369102012\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Paid","payment_date":"2013-03-16 00:00:00","payment_reference":"123","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"550.00","total_delivered":"550.00","cost":null,"tags":"","added_on":"2013-03-16 14:17:15","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"24","invoice_id":"10013","type":"product","date":"2013-03-16 12:00:00","item_name":"Basic Bankbook Holder","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"55.0000","price":"550.00","cost":"0.00","margin":null,"delivered":"10","delivered_price":"550.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"80","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-16 14:17:29","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1105","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Indigo Technologies Sdn Bhd","company_registration":"","contact_person":"Frank Lampard","contact_number":"0369102012","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:59:45","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-16 14:20:18', 'admin2'),
(329, 'contacts', 'edit', 'contact', 1076, '{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"1","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5ce75bba6298a10e403e09672cf79b5a","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2013-03-20 09:47:51","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1362561781","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2013-03-20 09:47:51', 'admin'),
(330, 'contacts', 'edit', 'contact', 1076, '{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"1","is_franchisee":null,"company_name":"Branch 1","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5ce75bba6298a10e403e09672cf79b5a","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2013-03-20 09:49:29","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1362561781","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2013-03-20 09:49:29', 'admin'),
(331, 'contacts', 'edit', 'contact', 1126, '{"id":"1126","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"joe billy","contact_number":"82828","credit_limit":"0.00","rank":"0","email":"","ic":"878782","password":null,"introducer_ic":null,"address1":"","address2":"","city":"","state":"0","zipcode":"","country":"0","tel":"82828","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-03-10 00:22:00","added_by":"admin2","modified_on":"2013-03-21 11:36:20","modified_by":"azizan","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2013-03-21 11:36:20', 'azizan'),
(332, 'contacts', 'edit', 'contact', 1126, '{"id":"1126","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"joe billy","contact_number":"82828","credit_limit":"0.00","rank":"0","email":"","ic":"878782","password":null,"introducer_ic":null,"address1":"","address2":"","city":"","state":"0","zipcode":"","country":"0","tel":"82828","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-03-10 00:22:00","added_by":"admin2","modified_on":"2013-03-21 11:37:06","modified_by":"azizan","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2013-03-21 11:37:06', 'azizan'),
(333, 'contacts', 'edit', 'contact', 1015, '{"id":"1015","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"1","is_franchise":"0","is_franchisee":null,"company_name":"Plexsol HQ","company_registration":"","contact_person":"Shafiq Rizwan","contact_number":"0124205391","credit_limit":"0.00","rank":"Agent Member","email":"shafiq@plexsol.com","ic":"880102355071","password":"88aa5e3aad2dbc037bcae4f0a9d5210c","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"0124205391","fax":"","general_email":"0","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 11:26:32","added_by":"@Plexcart","modified_on":"2013-03-21 12:04:40","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shafiq@plexsol.com1355319281","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2013-03-21 12:04:40', 'admin'),
(334, 'inventory', 'add', 'pr', NULL, '[]', '2013-03-21 12:26:47', 'admin2'),
(335, 'inventory', 'status_update', 'pr', 1, '{"id":"1","txn_no":"8-10001","po_id":null,"number":null,"date":"2013-03-21 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Plexsol HQ","supplier_id":"1015","supplier_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Branch 1\\",\\"mobile\\":\\"\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Completed","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4900.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-21 12:26:47","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"8","assigned_to":null,"orders":[{"id":"1","purchase_request_id":"1","date":"2013-03-21 00:00:00","item_description":null,"item_name":"Basic Bankbook Holder ()","item_id":"36","discount":"0","discount_type":"d","qty":"100","price_per_unit":"49.0000","price":"4900.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"8"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":null,"alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-19 23:02:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-21 22:46:19', 'admin2'),
(336, 'inventory', 'add', 'po', 10010, '{"id":"10010","txn_no":"8-10002","invoice_number":"","pr_id":"1","number":null,"date":"2013-03-21 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Plexsol HQ","supplier_id":"1015","supplier_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Branch 1\\",\\"mobile\\":\\"\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4900.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-21 22:46:42","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"8","assigned_to":null,"orders":[{"id":"22","purchase_order_id":"10010","date":"2013-03-21 00:00:00","item_description":null,"item_name":"Basic Bankbook Holder ()","item_id":"36","discount":"0","discount_type":"d","qty":"100","price_per_unit":"49.0000","price":"4900.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"8"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":null,"alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-19 23:02:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-21 22:46:43', 'admin2'),
(337, 'inventory', 'paid', 'po', 10010, '{"id":"10010","txn_no":"8-10002","invoice_number":"","pr_id":"1","number":null,"date":"2013-03-21 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Plexsol HQ","supplier_id":"1015","supplier_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Branch 1\\",\\"mobile\\":\\"\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4900.00","total_received":null,"payment_status":"Paid","payment_date":"2013-03-22 00:00:00","payment_reference":"122","payment_contra":null,"tags":"","added_on":"2013-03-21 22:46:42","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"8","assigned_to":null,"orders":[{"id":"22","purchase_order_id":"10010","date":"2013-03-21 00:00:00","item_description":null,"item_name":"Basic Bankbook Holder ()","item_id":"36","discount":"0","discount_type":"d","qty":"100","price_per_unit":"49.0000","price":"4900.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"8"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":null,"alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-19 23:02:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-21 22:47:10', 'admin2'),
(338, 'inventory', 'receive', 'po', 10010, '{"id":"10010","txn_no":"8-10002","invoice_number":"","pr_id":"1","number":null,"date":"2013-03-21 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Plexsol HQ","supplier_id":"1015","supplier_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Branch 1\\",\\"mobile\\":\\"\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4900.00","total_received":"4900.00","payment_status":"Paid","payment_date":"2013-03-22 00:00:00","payment_reference":"122","payment_contra":null,"tags":"","added_on":"2013-03-21 22:46:42","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"8","assigned_to":null,"orders":[{"id":"22","purchase_order_id":"10010","date":"2013-03-21 00:00:00","item_description":null,"item_name":"Basic Bankbook Holder ()","item_id":"36","discount":"0","discount_type":"d","qty":"100","price_per_unit":"49.0000","price":"4900.00","received":"100","received_price":"4900.00","done":null,"division_id":null,"warehouse_id":"8"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"100","alert_quantity":"2","max_quantity":"0","cost":"49.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-19 23:02:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-21 22:47:18', 'admin2'),
(339, 'inventory', 'status_update', 'po', 10010, '{"id":"10010","txn_no":"8-10002","invoice_number":"","pr_id":"1","number":null,"date":"2013-03-21 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Plexsol HQ","supplier_id":"1015","supplier_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Branch 1\\",\\"mobile\\":\\"\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4900.00","total_received":"4900.00","payment_status":"Paid","payment_date":"2013-03-22 00:00:00","payment_reference":"122","payment_contra":null,"tags":"","added_on":"2013-03-21 22:46:42","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"8","assigned_to":null,"orders":[{"id":"22","purchase_order_id":"10010","date":"2013-03-21 00:00:00","item_description":null,"item_name":"Basic Bankbook Holder ()","item_id":"36","discount":"0","discount_type":"d","qty":"100","price_per_unit":"49.0000","price":"4900.00","received":"100","received_price":"4900.00","done":null,"division_id":null,"warehouse_id":"8"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"100","alert_quantity":"2","max_quantity":"0","cost":"49.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-19 23:02:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-21 22:47:18', 'admin2'),
(340, 'sales', 'add', 'so', 10010, '{"id":"10010","txn_no":"1-10008","quote_id":"0","invoice_id":null,"number":"0","po_number":"8-10002","date":"2013-03-21 00:00:00","due_date":"2013-03-22 00:00:00","received_date":null,"contact_person":"JawiHerbShop ","contact":"Branch 1","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Branch 1\\",\\"mobile\\":\\"\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4900.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-21 22:49:08","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"11","sales_order_id":"10010","type":"product","date":"2013-03-21 00:00:00","item_name":"Basic Bankbook Holder ()","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":"d","qty":"100","price_per_unit":"49.0000","price":"4900.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"89","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-19 23:02:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2013-03-21 22:49:09', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(341, 'sales', 'status_update', 'so', 10010, '{"id":"10010","txn_no":"1-10008","quote_id":"0","invoice_id":null,"number":"0","po_number":"8-10002","date":"2013-03-21 00:00:00","due_date":"2013-03-22 00:00:00","received_date":null,"contact_person":"JawiHerbShop ","contact":"Branch 1","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Branch 1\\",\\"mobile\\":\\"\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Completed","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4900.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-21 22:49:08","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"11","sales_order_id":"10010","type":"product","date":"2013-03-21 00:00:00","item_name":"Basic Bankbook Holder ()","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":"d","qty":"100","price_per_unit":"49.0000","price":"4900.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"89","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-19 23:02:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2013-03-21 22:49:20', 'admin'),
(342, 'sales', 'add', 'invoice', 10014, '{"id":"10014","txn_no":"1-10014","quote_id":"0","sales_order_id":"10010","number":"0","po_number":"8-10002","date":"2013-03-21 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Branch 1","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Branch 1\\",\\"mobile\\":\\"\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"490.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-21 22:50:00","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"25","invoice_id":"10014","type":"product","date":"2013-03-21 12:00:00","item_name":"Basic Bankbook Holder ()","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":"d","qty":"10","price_per_unit":"49.0000","price":"490.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"89","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-19 23:02:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"1","is_franchisee":null,"company_name":"Branch 1","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5ce75bba6298a10e403e09672cf79b5a","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2013-03-20 09:49:29","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1362561781","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-21 22:50:01', 'admin'),
(343, 'sales', 'paid', 'invoice', 10014, '{"id":"10014","txn_no":"1-10014","quote_id":"0","sales_order_id":"10010","number":"0","po_number":"8-10002","date":"2013-03-21 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Branch 1","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Branch 1\\",\\"mobile\\":\\"\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Paid","payment_date":"2013-03-22 00:00:00","payment_reference":"123","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"490.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-03-21 22:50:00","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"25","invoice_id":"10014","type":"product","date":"2013-03-21 12:00:00","item_name":"Basic Bankbook Holder ()","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":"d","qty":"10","price_per_unit":"49.0000","price":"490.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"89","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-19 23:02:54","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"1","is_franchisee":null,"company_name":"Branch 1","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5ce75bba6298a10e403e09672cf79b5a","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2013-03-20 09:49:29","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1362561781","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-21 22:50:39', 'admin'),
(344, 'sales', 'deliver', 'invoice', 10014, '{"id":"10014","txn_no":"1-10014","quote_id":"0","sales_order_id":"10010","number":"0","po_number":"8-10002","date":"2013-03-21 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Branch 1","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Branch 1\\",\\"mobile\\":\\"\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Paid","payment_date":"2013-03-22 00:00:00","payment_reference":"123","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"490.00","total_delivered":"490.00","cost":null,"tags":"","added_on":"2013-03-21 22:50:00","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"25","invoice_id":"10014","type":"product","date":"2013-03-21 12:00:00","item_name":"Basic Bankbook Holder ()","item_description":"","item_id":"36","service_id":"0","item_sku":null,"discount":"0","discount_type":"d","qty":"10","price_per_unit":"49.0000","price":"490.00","cost":"0.00","margin":null,"delivered":"10","delivered_price":"490.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"79","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-21 22:50:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"1","is_franchisee":null,"company_name":"Branch 1","company_registration":"","contact_person":"azad","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5ce75bba6298a10e403e09672cf79b5a","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2013-03-20 09:49:29","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1362561781","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-03-21 22:50:47', 'admin'),
(345, 'inventory', 'status_update', 'po', 10010, '{"id":"10010","txn_no":"8-10002","invoice_number":"","pr_id":"1","number":null,"date":"2013-03-21 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Plexsol HQ","supplier_id":"1015","supplier_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Branch 1\\",\\"mobile\\":\\"\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4900.00","total_received":"0.00","payment_status":"Paid","payment_date":"2013-03-22 00:00:00","payment_reference":"122","payment_contra":null,"tags":"","added_on":"2013-03-21 22:46:42","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"8","assigned_to":null,"orders":[{"id":"22","purchase_order_id":"10010","date":"2013-03-21 00:00:00","item_description":null,"item_name":"Basic Bankbook Holder ()","item_id":"36","discount":"0","discount_type":"d","qty":"100","price_per_unit":"49.0000","price":"4900.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"8"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"49.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-21 22:50:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-21 22:53:20', 'admin2'),
(346, 'inventory', 'receive', 'po', 10010, '{"id":"10010","txn_no":"8-10002","invoice_number":"","pr_id":"1","number":null,"date":"2013-03-21 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Plexsol HQ","supplier_id":"1015","supplier_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Branch 1\\",\\"mobile\\":\\"\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4900.00","total_received":"4410.00","payment_status":"Paid","payment_date":"2013-03-22 00:00:00","payment_reference":"122","payment_contra":null,"tags":"","added_on":"2013-03-21 22:46:42","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"8","assigned_to":null,"orders":[{"id":"22","purchase_order_id":"10010","date":"2013-03-21 00:00:00","item_description":null,"item_name":"Basic Bankbook Holder ()","item_id":"36","discount":"0","discount_type":"d","qty":"100","price_per_unit":"49.0000","price":"4900.00","received":"90","received_price":"4410.00","done":null,"division_id":null,"warehouse_id":"8"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"90","alert_quantity":"2","max_quantity":"0","cost":"49.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-21 22:50:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-21 23:02:30', 'admin2'),
(347, 'inventory', 'status_update', 'po', 10010, '{"id":"10010","txn_no":"8-10002","invoice_number":"","pr_id":"1","number":null,"date":"2013-03-21 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Plexsol HQ","supplier_id":"1015","supplier_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Branch 1\\",\\"mobile\\":\\"\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4900.00","total_received":"4410.00","payment_status":"Paid","payment_date":"2013-03-22 00:00:00","payment_reference":"122","payment_contra":null,"tags":"","added_on":"2013-03-21 22:46:42","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"8","assigned_to":null,"orders":[{"id":"22","purchase_order_id":"10010","date":"2013-03-21 00:00:00","item_description":null,"item_name":"Basic Bankbook Holder ()","item_id":"36","discount":"0","discount_type":"d","qty":"100","price_per_unit":"49.0000","price":"4900.00","received":"90","received_price":"4410.00","done":null,"division_id":null,"warehouse_id":"8"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"90","alert_quantity":"2","max_quantity":"0","cost":"49.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-21 22:50:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-21 23:02:30', 'admin2'),
(348, 'inventory', 'edit', 'item', 15, '{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":null,"alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"0.00","price_4":"12.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-03-21 23:06:29","modified_by":"admin2","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 16:10:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2013-03-21 23:06:30', 'admin2'),
(349, 'inventory', 'edit', 'item', 15, '{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":null,"alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"0.00","price_3":"13.00","price_4":"12.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-03-21 23:07:50","modified_by":"admin2","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 16:10:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2013-03-21 23:07:50', 'admin2'),
(350, 'inventory', 'edit', 'item', 15, '{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":null,"alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"11.00","price_3":"12.00","price_4":"13.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-03-21 23:09:31","modified_by":"admin2","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 16:10:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2013-03-21 23:09:31', 'admin2'),
(351, 'inventory', 'add', 'pr', NULL, '[]', '2013-03-26 21:56:19', 'admin2'),
(352, 'inventory', 'edit', 'pr', 2, '{"id":"2","txn_no":"8-10002","po_id":null,"number":null,"date":"2013-03-26 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Plexsol HQ","supplier_id":"1015","supplier_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Branch 1\\",\\"mobile\\":\\"\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4410.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-26 21:56:19","added_by":"admin2","modified_on":"2013-03-26 21:57:24","modified_by":"admin2","division_id":null,"warehouse_id":"8","assigned_to":null,"orders":[{"id":"3","purchase_request_id":"2","date":"2013-03-26 00:00:00","item_description":null,"item_name":"Basic Bankbook Holder ()","item_id":"36","discount":"0","discount_type":null,"qty":"90","price_per_unit":"49.0000","price":"4410.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"8"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"90","alert_quantity":"2","max_quantity":"0","cost":"49.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-21 22:50:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-26 21:57:24', 'admin2'),
(353, 'inventory', 'edit', 'pr', 2, '{"id":"2","txn_no":"8-10002","po_id":null,"number":null,"date":"2013-03-26 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Plexsol HQ","supplier_id":"1015","supplier_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Branch 1\\",\\"mobile\\":\\"\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4410.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-26 21:56:19","added_by":"admin2","modified_on":"2013-03-26 21:57:34","modified_by":"admin2","division_id":null,"warehouse_id":"8","assigned_to":null,"orders":[{"id":"4","purchase_request_id":"2","date":"2013-03-26 00:00:00","item_description":null,"item_name":"Basic Bankbook Holder ()","item_id":"36","discount":"0","discount_type":null,"qty":"90","price_per_unit":"49.0000","price":"4410.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"8"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"90","alert_quantity":"2","max_quantity":"0","cost":"49.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-21 22:50:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-26 21:57:34', 'admin2'),
(354, 'inventory', 'add', 'pr', NULL, '[]', '2013-03-26 21:58:05', 'admin2'),
(355, 'inventory', 'edit', 'pr', 3, '{"id":"3","txn_no":"8-10003","po_id":null,"number":null,"date":"2013-03-26 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Branch 1\\",\\"mobile\\":\\"\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"5439.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-26 21:58:05","added_by":"admin2","modified_on":"2013-03-26 21:59:23","modified_by":"admin2","division_id":null,"warehouse_id":"8","assigned_to":null,"orders":[{"id":"6","purchase_request_id":"3","date":"2013-03-26 00:00:00","item_description":null,"item_name":"Basic Bankbook Holder ()","item_id":"36","discount":"0","discount_type":null,"qty":"111","price_per_unit":"49.0000","price":"5439.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"8"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"90","alert_quantity":"2","max_quantity":"0","cost":"49.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-21 22:50:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-26 21:59:24', 'admin2'),
(356, 'inventory', 'edit', 'pr', 3, '{"id":"3","txn_no":"8-10003","po_id":null,"number":null,"date":"2013-03-26 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Branch 1\\",\\"mobile\\":\\"\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"5439.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-26 21:58:05","added_by":"admin2","modified_on":"2013-03-26 21:59:47","modified_by":"admin2","division_id":null,"warehouse_id":"8","assigned_to":null,"orders":[{"id":"7","purchase_request_id":"3","date":"2013-03-26 00:00:00","item_description":null,"item_name":"Basic Bankbook Holder ()","item_id":"36","discount":"0","discount_type":null,"qty":"111","price_per_unit":"49.0000","price":"5439.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"8"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"90","alert_quantity":"2","max_quantity":"0","cost":"49.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-21 22:50:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-26 21:59:47', 'admin2'),
(357, 'inventory', 'edit', 'pr', 2, '{"id":"2","txn_no":"8-10002","po_id":null,"number":null,"date":"2013-03-26 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Plexsol HQ","supplier_id":"1015","supplier_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Branch 1\\",\\"mobile\\":\\"\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4410.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-26 21:56:19","added_by":"admin2","modified_on":"2013-03-26 22:00:47","modified_by":"admin2","division_id":null,"warehouse_id":"8","assigned_to":null,"orders":[{"id":"8","purchase_request_id":"2","date":"2013-03-26 00:00:00","item_description":null,"item_name":"Basic Bankbook Holder ()","item_id":"36","discount":"0","discount_type":null,"qty":"90","price_per_unit":"49.0000","price":"4410.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"8"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"90","alert_quantity":"2","max_quantity":"0","cost":"49.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-21 22:50:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-26 22:00:47', 'admin2'),
(358, 'inventory', 'status_update', 'pr', 2, '{"id":"2","txn_no":"8-10002","po_id":null,"number":null,"date":"2013-03-26 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Plexsol HQ","supplier_id":"1015","supplier_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Branch 1\\",\\"mobile\\":\\"\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Completed","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4410.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-26 21:56:19","added_by":"admin2","modified_on":"2013-03-26 22:00:47","modified_by":"admin2","division_id":null,"warehouse_id":"8","assigned_to":null,"orders":[{"id":"8","purchase_request_id":"2","date":"2013-03-26 00:00:00","item_description":null,"item_name":"Basic Bankbook Holder ()","item_id":"36","discount":"0","discount_type":null,"qty":"90","price_per_unit":"49.0000","price":"4410.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"8"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"90","alert_quantity":"2","max_quantity":"0","cost":"49.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-21 22:50:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-26 22:02:17', 'admin2');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(359, 'inventory', 'add', 'po', 10011, '{"id":"10011","txn_no":"8-10003","invoice_number":"","pr_id":"1","number":null,"date":"2013-03-21 00:00:00","due_date":null,"contact_person":"JawiHerbShop ","received_date":null,"supplier":"Plexsol HQ","supplier_id":"1015","supplier_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Branch 1\\",\\"mobile\\":\\"\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4900.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-03-26 23:50:11","added_by":"admin2","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"8","assigned_to":null,"orders":[{"id":"23","purchase_order_id":"10011","date":"2013-03-21 00:00:00","item_description":null,"item_name":"Basic Bankbook Holder ()","item_id":"36","discount":"0","discount_type":"d","qty":"100","price_per_unit":"49.0000","price":"4900.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"8"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"90","alert_quantity":"2","max_quantity":"0","cost":"49.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-21 22:50:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-03-26 23:50:11', 'admin2'),
(360, 'contacts', 'edit', 'contact', 1078, '{"id":"1078","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Asmah Bt Din","contact_number":"01430922","credit_limit":"0.00","rank":"0","email":"","ic":"841231","password":null,"introducer_ic":null,"address1":"Jalan","address2":"","city":"Bukit","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"01430922","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-11-16 21:04:45","added_by":"admin","modified_on":"2013-03-31 23:03:06","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2013-03-31 23:03:06', 'admin'),
(361, 'contacts', 'edit', 'contact', 1078, '{"id":"1078","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Asmah Bt Din","contact_number":"01430922","credit_limit":"0.00","rank":"Normal Member","email":"","ic":"841231","password":null,"introducer_ic":null,"address1":"Jalan","address2":"","city":"Bukit","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"01430922","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-11-16 21:04:45","added_by":"admin","modified_on":"2013-03-31 23:46:28","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2013-03-31 23:46:28', 'admin'),
(362, 'contacts', 'edit', 'contact', 1108, '{"id":"1108","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Noraishah Kamarudin","contact_number":"0153210321","credit_limit":"0.00","rank":"Normal Member","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"0","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:01:35","added_by":"admin","modified_on":"2013-04-01 00:21:34","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2013-04-01 00:21:34', 'admin'),
(363, 'contacts', 'edit', 'contact', 1015, '{"id":"1015","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"1","is_franchise":"0","is_franchisee":null,"company_name":"Plexsol HQ","company_registration":"","contact_person":"Shafiq Rizwan","contact_number":"0124205391","credit_limit":"0.00","rank":"Normal Member","email":"shafiq@plexsol.com","ic":"880102355071","password":"88aa5e3aad2dbc037bcae4f0a9d5210c","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"0124205391","fax":"","general_email":"0","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 11:26:32","added_by":"@Plexcart","modified_on":"2013-04-01 14:15:33","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shafiq@plexsol.com1355319281","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2013-04-01 14:15:33', 'admin'),
(364, 'contacts', 'edit', 'contact', 1108, '{"id":"1108","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Noraishah Kamarudin","contact_number":"0153210321","credit_limit":"0.00","rank":"Normal Member","email":"","ic":"841231087654","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"0","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:01:35","added_by":"admin","modified_on":"2013-04-01 20:49:00","modified_by":"admin2","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2013-04-01 20:49:00', 'admin2'),
(365, 'sales', 'add', 'so', 10011, '{"id":"10011","txn_no":"8-10001","quote_id":"0","invoice_id":null,"number":"0","pr_number":null,"po_number":"0","date":"2013-04-05 00:00:00","due_date":"2013-04-05 00:00:00","received_date":null,"contact_person":"Administrator 3 ","contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"77.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-04-04 23:02:56","added_by":"admin3","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"8","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"12","sales_order_id":"10011","type":"product","date":"2013-04-05 00:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"77.0000","price":"77.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"8","consignment":"0"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"100","alert_quantity":"2","max_quantity":"0","cost":"0.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-25 22:15:19","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2013-04-04 23:02:57', 'admin3'),
(366, 'contacts', 'edit', 'contact', 1080, '{"id":"1080","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Johari Bin Jasuli","contact_number":"0143076543","credit_limit":"0.00","rank":"Normal Member","email":"","ic":"820921086022","password":null,"introducer_ic":null,"address1":"22","address2":"","city":"Lunas","state":"Kedah","zipcode":"09600","country":"Malaysia","tel":"0143076543","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-11-17 08:43:13","added_by":"admin","modified_on":"2013-04-11 14:32:25","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2013-04-11 14:32:25', 'admin'),
(367, 'inventory', 'edit', 'item', 71, '{"id":"71","primary_image":"nokia-3310-old-gold.jpg","image":"nokia-3310-old-gold.jpg","category":"Handphone","subcategory":"Bar","brand":"Nokia","location":"","name":"Nokia 3310","model_no":"","warranty":"1","sku":"014191239012","sku2":"","sku3":"","sku4":"","qty":null,"alert_quantity":"20","max_quantity":"0","cost":"0.00","average_cost":null,"price":"150.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Nokia 3310 the most powerful handphone ever that can use as a mobile phone, no camera, no 3G, just a pure GSM Phone","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2013-03-06 09:17:24","added_by":"admin","modified_on":"2013-04-29 21:10:36","modified_by":"admin3","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"101.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-14 22:56:09","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2013-04-29 21:10:36', 'admin3'),
(368, 'inventory', 'add', 'pr', NULL, '[]', '2013-05-11 22:26:11', 'admin'),
(369, 'inventory', 'status_update', 'pr', 4, '{"id":"4","txn_no":"1-10001","po_id":null,"number":null,"date":"2013-05-12 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Lavish Built Enterprise","supplier_id":"1104","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0125445670\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"Kindly deliver before Friday. Thank you","status":"Completed","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"6000.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-05-11 22:26:11","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"9","purchase_request_id":"4","date":"2013-05-12 00:00:00","item_description":null,"item_name":"Evolution Standing Lamp ()","item_id":"14","discount":"0","discount_type":null,"qty":"50","price_per_unit":"120.0000","price":"6000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 16:10:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-05-11 22:26:33', 'admin'),
(370, 'inventory', 'add', 'po', 10012, '{"id":"10012","txn_no":"1-10009","invoice_number":"","pr_id":"4","number":null,"date":"2013-05-12 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Lavish Built Enterprise","supplier_id":"1104","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"Kindly deliver before Friday. Thank you","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"6000.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-05-11 22:27:02","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"24","purchase_order_id":"10012","date":"2013-05-12 00:00:00","item_description":null,"item_name":"Evolution Standing Lamp ()","item_id":"14","discount":"0","discount_type":null,"qty":"50","price_per_unit":"120.0000","price":"6000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 16:10:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-05-11 22:27:02', 'admin'),
(371, 'inventory', 'receive', 'po', 10012, '{"id":"10012","txn_no":"1-10009","invoice_number":"","pr_id":"4","number":null,"date":"2013-05-12 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Lavish Built Enterprise","supplier_id":"1104","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"Kindly deliver before Friday. Thank you","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"6000.00","total_received":"6000.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-05-11 22:27:02","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"24","purchase_order_id":"10012","date":"2013-05-12 00:00:00","item_description":null,"item_name":"Evolution Standing Lamp ()","item_id":"14","discount":"0","discount_type":null,"qty":"50","price_per_unit":"120.0000","price":"6000.00","received":"50","received_price":"6000.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"47","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 16:10:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-05-11 22:27:21', 'admin'),
(372, 'inventory', 'status_update', 'po', 10012, '{"id":"10012","txn_no":"1-10009","invoice_number":"","pr_id":"4","number":null,"date":"2013-05-12 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Lavish Built Enterprise","supplier_id":"1104","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"Kindly deliver before Friday. Thank you","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"6000.00","total_received":"6000.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2013-05-11 22:27:02","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"24","purchase_order_id":"10012","date":"2013-05-12 00:00:00","item_description":null,"item_name":"Evolution Standing Lamp ()","item_id":"14","discount":"0","discount_type":null,"qty":"50","price_per_unit":"120.0000","price":"6000.00","received":"50","received_price":"6000.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"47","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 16:10:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-05-11 22:27:22', 'admin'),
(373, 'inventory', 'paid', 'po', 10012, '{"id":"10012","txn_no":"1-10009","invoice_number":"","pr_id":"4","number":null,"date":"2013-05-12 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Lavish Built Enterprise","supplier_id":"1104","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"Kindly deliver before Friday. Thank you","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"6000.00","total_received":"6000.00","payment_status":"Paid","payment_date":"2013-05-12 00:00:00","payment_reference":"5391482","payment_contra":null,"tags":"","added_on":"2013-05-11 22:27:02","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"24","purchase_order_id":"10012","date":"2013-05-12 00:00:00","item_description":null,"item_name":"Evolution Standing Lamp ()","item_id":"14","discount":"0","discount_type":null,"qty":"50","price_per_unit":"120.0000","price":"6000.00","received":"50","received_price":"6000.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"14":{"id":"14","primary_image":"Evolution_(table)___caption11.jpg","image":"Evolution_(table)___caption11.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Evolution Standing Lamp","model_no":"","warranty":"","sku":"ESL2191","sku2":"","sku3":"","sku4":"","qty":"47","alert_quantity":"2","max_quantity":"0","cost":"140.00","average_cost":null,"price":"190.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:06:18","added_by":"admin","modified_on":"2012-12-12 13:06:34","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-06 16:10:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2013-05-11 22:27:41', 'admin'),
(374, 'inventory', 'add', 'item', NULL, '[]', '2013-05-17 19:07:24', 'admin'),
(375, 'inventory', 'edit', 'item', 74, '{"id":"74","primary_image":null,"image":null,"category":"Medicine","subcategory":"Eye","brand":"Eyemo","location":"","name":"Eye Mo","model_no":"","warranty":"","sku":"987654321","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"10","max_quantity":"0","cost":"0.00","average_cost":null,"price":"2.50","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2013-05-17 19:07:24","added_by":"admin","modified_on":"2013-05-17 19:08:02","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2013-05-17 19:08:02', 'admin'),
(376, 'inventory', 'add', 'item', NULL, '[]', '2013-05-17 19:10:36', 'admin'),
(377, 'sales', 'add', 'quote', 10001, '{"id":"10001","txn_no":"1-10001","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-05-24 00:00:00","due_date":"2013-05-24 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Roger Federed Sdn Bhd","contact_id":"1097","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Roger Federed Sdn Bhd\\",\\"mobile\\":\\"048575662\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"22000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-05-24 12:37:44","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","quote_id":"10001","date":"2013-05-24 00:00:00","type":"service","item_id":"0","service_id":"23","item_name":"Plexcloud","item_description":"HR ....","discount":"2000","discount_type":"d","qty":"1","price_per_unit":"24000.0000","price":"24000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"23":{"id":"23","name":"Air Zam2 storage","description":"","category":"0","subcategory":"0","cost":"0.00","price":"2.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-03-07 12:02:05","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"1"}}}', '2013-05-24 12:37:44', 'admin'),
(378, 'contacts', 'add', 'contact', 1129, '{"id":"1129","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Ramli Buyong","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"Kuala Kangsar","state":"Perak","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"0135105563 ","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-05-31 12:30:19","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2013-05-31 12:30:20', 'admin2'),
(379, 'sales', 'add', 'invoice', 10015, '{"id":"10015","txn_no":"1-10015","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2013-05-31 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Ramli Buyong","contact_id":"1129","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Kuala Kangsar\\",\\"state\\":\\"Perak\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Ramli Buyong\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Kuala Kangsar\\",\\"state\\":\\"Perak\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"999.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-05-31 12:31:18","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"26","invoice_id":"10015","type":"service","date":"2013-05-31 12:00:00","item_name":"Plexsol BookHomeStay System","item_description":"Wordpress BookHomeStay System","item_id":"0","service_id":"24","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"999.0000","price":"999.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"24":{"id":"24","name":"Plexsol BookHomeStay System","description":"Wordpress BookHomeStay System","category":"0","subcategory":"0","cost":"200.00","price":"999.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-05-31 12:28:32","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1129","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Ramli Buyong","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"Kuala Kangsar","state":"Perak","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"0135105563 ","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-05-31 12:30:19","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-05-31 12:31:19', 'admin2'),
(380, 'sales', 'edit', 'invoice', 10015, '{"id":"10015","txn_no":"1-10015","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2013-05-31 12:00:00","due_date":null,"received_date":null,"contact_person":"Ramli Buyong","contact":"Ramli Buyong","contact_id":"1129","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Kuala Kangsar\\",\\"state\\":\\"Perak\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Ramli Buyong\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Kuala Kangsar\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"999.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-05-31 12:31:18","added_by":"admin2","modified_on":"2013-05-31 12:35:01","modified_by":"admin2","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"27","invoice_id":"10015","type":"service","date":"2013-05-31 12:00:00","item_name":"Plexsol BookHomeStay System","item_description":"Wordpress BookHomeStay System","item_id":"0","service_id":"24","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"999.0000","price":"999.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"24":{"id":"24","name":"Plexsol BookHomeStay System","description":"Wordpress BookHomeStay System","category":"0","subcategory":"0","cost":"200.00","price":"999.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-05-31 12:28:32","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1129","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Ramli Buyong","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"Kuala Kangsar","state":"Perak","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"0135105563 ","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-05-31 12:30:19","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null},"sale":null,"sale_items":null}', '2013-05-31 12:35:01', 'admin2'),
(381, 'sales', 'add', 'quote', 10002, '{"id":"10002","txn_no":"1-10002","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-03 00:00:00","due_date":"2013-06-02 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Dinamika Enterprise","contact_id":"1087","contact_address":"{\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Dinamika Enterprise\\",\\"mobile\\":\\"045368559\\",\\"address1\\":\\"20 Jalan Maju 1\\",\\"address2\\":\\"Taman Maju Jaya\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"6.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-03 14:08:13","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"2","quote_id":"10002","date":"2013-06-03 00:00:00","type":"product","item_id":"66","service_id":"0","item_name":"Accessory Strap","item_description":"","discount":"0","discount_type":null,"qty":"1","price_per_unit":"6.0000","price":"6.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:10:21","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2013-06-03 14:08:13', 'admin'),
(382, 'sales', 'add', 'quote', 10003, '{"id":"10003","txn_no":"1-10003","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-03 00:00:00","due_date":"2013-06-06 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-03 14:11:01","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"3","quote_id":"10003","date":"2013-06-03 00:00:00","type":"service","item_id":"0","service_id":"25","item_name":"Short Course PID","item_description":"Bla Bla","discount":"0","discount_type":"p","qty":"1","price_per_unit":"3200.0000","price":"3200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"25":{"id":"25","name":"Short Course PID","description":"Bla Bla","category":"0","subcategory":"0","cost":"500.00","price":"3200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-03 14:09:29","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"1"}}}', '2013-06-03 14:11:01', 'admin'),
(383, 'sales', 'add', 'so', 10012, '{"id":"10012","txn_no":"1-10009","quote_id":"10003","invoice_id":null,"number":"0","pr_number":null,"po_number":"QUO-10003","date":"2013-06-03 00:00:00","due_date":"0000-00-00 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"false","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-03 14:14:37","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"13","sales_order_id":"10012","type":"service","date":"2013-06-03 00:00:00","item_name":"Short Course PID","item_description":"Bla Bla","item_id":"0","service_id":"25","item_sku":null,"discount":"0","discount_type":"p","qty":"1","price_per_unit":"3200.0000","price":"3200.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"25":{"id":"25","name":"Short Course PID","description":"Bla Bla","category":"0","subcategory":"0","cost":"500.00","price":"3200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-03 14:09:29","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"1"}}}', '2013-06-03 14:14:37', 'admin'),
(384, 'contacts', 'add', 'contact', 1130, '{"id":"1130","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Jawi Herbs Shop","company_registration":"","contact_person":"Azham Affif Ishak","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-06-04 19:40:20","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2013-06-04 19:40:21', 'admin2');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(385, 'sales', 'add', 'quote', 10004, '{"id":"10004","txn_no":"1-10004","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-04 00:00:00","due_date":"2013-07-04 00:00:00","contact_person":"JawiHerbShop ","payment_date":null,"received_date":null,"contact":"Jawi Herbs Shop","contact_id":"1130","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"5750.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-04 19:42:36","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"4","quote_id":"10004","date":"2013-06-04 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n1 Year Warranty","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5000.0000","price":"5000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"5","quote_id":"10004","date":"2013-06-04 00:00:00","type":"service","item_id":"0","service_id":"29","item_name":"Sound System","item_description":"Speakers \\nMicrophone\\n\\n1 Year Warranty","discount":"0","discount_type":null,"qty":"1","price_per_unit":"450.0000","price":"450.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"6","quote_id":"10004","date":"2013-06-04 00:00:00","type":"service","item_id":"0","service_id":"27","item_name":"Standard Wiring","item_description":"LCD Mounting\\nSpeaker Wiring","discount":"0","discount_type":null,"qty":"1","price_per_unit":"300.0000","price":"300.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer","category":"0","subcategory":"0","cost":"3000.00","price":"5000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"0"},"29":{"id":"29","name":"Sound System","description":"Speakers \\nMicrophone","category":"0","subcategory":"0","cost":"399.00","price":"450.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:39:15","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"0"},"27":{"id":"27","name":"Standard Wiring","description":"LCD Mounting\\nSpeaker Wiring","category":"0","subcategory":"0","cost":"200.00","price":"300.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:35:07","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-06-04 19:42:36', 'admin2'),
(386, 'sales', 'edit', 'quote', 10004, '{"id":"10004","txn_no":"1-10004","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-04 00:00:00","due_date":"2013-07-04 00:00:00","contact_person":"JawiHerbShop ","payment_date":null,"received_date":null,"contact":"Jawi Herbs Shop","contact_id":"1130","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"5000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-04 19:42:36","added_by":"admin2","modified_on":"2013-06-05 20:42:19","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"7","quote_id":"10004","date":"2013-06-04 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n1 Year Warranty","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5000.0000","price":"5000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer","category":"0","subcategory":"0","cost":"3000.00","price":"5000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-06-05 20:42:19', 'admin2'),
(387, 'sales', 'edit', 'quote', 10004, '{"id":"10004","txn_no":"1-10004","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-04 00:00:00","due_date":"2013-07-04 00:00:00","contact_person":"JawiHerbShop ","payment_date":null,"received_date":null,"contact":"Jawi Herbs Shop","contact_id":"1130","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"7000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-04 19:42:36","added_by":"admin2","modified_on":"2013-06-05 21:00:47","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"8","quote_id":"10004","date":"2013-06-04 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n1 Year Warranty","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5000.0000","price":"5000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"9","quote_id":"10004","date":"2013-06-04 00:00:00","type":"service","item_id":"0","service_id":"30","item_name":"Plexcloud Clinic System &#40; Monthly &#41;","item_description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","discount":"0","discount_type":null,"qty":"1","price_per_unit":"2000.0000","price":"2000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-05 20:43:07","modified_by":"admin2","warehouse_id":"0"},"30":{"id":"30","name":"Plexcloud Clinic System","description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","category":"0","subcategory":"0","cost":"1000.00","price":"2000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-05 20:54:56","added_by":"admin2","modified_on":"2013-06-05 20:58:27","modified_by":"admin2","warehouse_id":"0"}}}', '2013-06-05 21:00:47', 'admin2'),
(388, 'contacts', 'add', 'contact', 1131, '{"id":"1131","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Malaysian Institute of Road Safety Research (MIROS)","company_registration":"","contact_person":"Hizal Hanis","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot 125-135, Jalan TKS 1","address2":"Taman Kajang Sentral","city":"Kajang","state":"Selangor","zipcode":"43000 ","country":"Malaysia","tel":"","fax":"","general_email":"dg@miros.gov.my ","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-06-07 10:43:41","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2013-06-07 10:43:41', 'admin2'),
(389, 'sales', 'add', 'quote', 10005, '{"id":"10005","txn_no":"1-10005","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-07 00:00:00","due_date":"2013-07-07 00:00:00","contact_person":"Hizal Hanis","payment_date":null,"received_date":null,"contact":"Malaysian Institute of Road Safety Research (MIROS)","contact_id":"1131","contact_address":"{\\"address1\\":\\"Lot 125-135, Jalan TKS 1\\",\\"address2\\":\\"Taman Kajang Sentral\\",\\"zipcode\\":\\"43000 \\",\\"city\\":\\"Kajang\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Malaysian Institute of Road Safety Research (MIROS)\\",\\"mobile\\":\\"\\",\\"address1\\":\\"Lot 125-135, Jalan TKS 1\\",\\"address2\\":\\"Taman Kajang Sentral\\",\\"zipcode\\":\\"43000 \\",\\"city\\":\\"Kajang\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"65000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-07 10:44:47","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"10","quote_id":"10005","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"31","item_name":"Data Collection and Analysis with Android Mobile Support","item_description":"4 Months of Product Development\\n3 Months of Product Support\\n\\nData Collection\\nTo provide a Web Based Application on Accident data collection.\\n\\n* Multiple User\\n* Permission Levels for User\\n* Data Collection Form\\n* Documentation of System\\n* Training Usage of the System\\n\\nData Analytics\\nAn analytic tool for the data collection in producing reports of the collected data.\\n\\n* Heat Map (Black Area)\\n* Cross Filtering Between Inputs from Data Collection\\n* Training Usage of the System\\n* Documentation of System\\n\\nMobile Implementation \\n* Mobile development for On-Site data Collection\\n* Sketching App for Data\\n* Data sending to Main Server for cases\\n* Training and Documentation\\n\\nTraining\\n* Training to MIROS in-house programmers will be conducted during the support month\\n\\nSource Code\\n* Source Code Copyrights will be handed over to MIROS","discount":"0","discount_type":null,"qty":"1","price_per_unit":"65000.0000","price":"65000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"31":{"id":"31","name":"Data Collection and Analysis with Android Mobile Support","description":"4 Months of Product Development\\n3 Months of Product Support\\n\\nData Collection\\nTo provide a Web Based Application on Accident data collection.\\n\\n* Multiple User\\n* Permission Levels for User\\n* Data Collection Form\\n* Documentation of System\\n* Training Usage of the System\\n\\nData Analytics\\nAn analytic tool for the data collection in producing reports of the collected data.\\n\\n* Heat Map (Black Area)\\n* Cross Filtering Between Inputs from Data Collection\\n* Training Usage of the System\\n* Documentation of System\\n\\nMobile Implementation \\n* Mobile development for On-Site data Collection\\n* Sketching App for Data\\n* Data sending to Main Server for cases\\n* Training and Documentation\\n\\nTraining\\n* Training to MIROS in-house programmers will be conducted during the support month\\n\\nSource Code\\n* Source Code Copyrights will be handed over to MIROS","category":"0","subcategory":"0","cost":"60000.00","price":"65000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-07 10:42:02","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-06-07 10:44:47', 'admin2'),
(390, 'sales', 'edit', 'quote', 10004, '{"id":"10004","txn_no":"1-10004","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-04 00:00:00","due_date":"2013-07-04 00:00:00","contact_person":"JawiHerbShop ","payment_date":null,"received_date":null,"contact":"Jawi Herbs Shop","contact_id":"1130","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"7200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-04 19:42:36","added_by":"admin2","modified_on":"2013-06-07 10:57:16","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"11","quote_id":"10004","date":"2013-06-04 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Built-in IC Card Reader\\n5) Barcode Scanner\\n1 Year Warranty","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5200.0000","price":"5200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"12","quote_id":"10004","date":"2013-06-04 00:00:00","type":"service","item_id":"0","service_id":"30","item_name":"Plexcloud Clinic System &#40; Monthly &#41;","item_description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","discount":"0","discount_type":null,"qty":"1","price_per_unit":"2000.0000","price":"2000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"30":{"id":"30","name":"Plexcloud Clinic System","description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","category":"0","subcategory":"0","cost":"1000.00","price":"2000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-05 20:54:56","added_by":"admin2","modified_on":"2013-06-05 20:58:27","modified_by":"admin2","warehouse_id":"0"},"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-05 20:43:07","modified_by":"admin2","warehouse_id":"0"}}}', '2013-06-07 10:57:16', 'admin2'),
(391, 'sales', 'edit', 'quote', 10004, '{"id":"10004","txn_no":"1-10004","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-04 00:00:00","due_date":"2013-07-04 00:00:00","contact_person":"JawiHerbShop ","payment_date":null,"received_date":null,"contact":"Jawi Herbs Shop","contact_id":"1130","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"With annual subscription, we will be giving 1 month discount for the Plexcloud Clinic System","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"27200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-04 19:42:36","added_by":"admin2","modified_on":"2013-06-07 11:01:04","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"13","quote_id":"10004","date":"2013-06-04 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Built-in IC Card Reader\\n5) Barcode Scanner\\n1 Year Warranty","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5200.0000","price":"5200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"14","quote_id":"10004","date":"2013-06-04 00:00:00","type":"service","item_id":"0","service_id":"30","item_name":"Plexcloud Clinic System &#40;Annually&#41;","item_description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","discount":"2000","discount_type":"d","qty":"1","price_per_unit":"24000.0000","price":"24000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-05 20:43:07","modified_by":"admin2","warehouse_id":"0"},"30":{"id":"30","name":"Plexcloud Clinic System &#40;Annually&#41;","description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","category":"0","subcategory":"0","cost":"1000.00","price":"24000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-05 20:54:56","added_by":"admin2","modified_on":"2013-06-07 10:59:08","modified_by":"admin2","warehouse_id":"0"}}}', '2013-06-07 11:01:04', 'admin2'),
(392, 'contacts', 'edit', 'contact', 1130, '{"id":"1130","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Jawi Herbs Shop","company_registration":"","contact_person":"Azham Affif Ishak","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"21-G, Lorong Kelasah 1","address2":"Taman Kelasah","city":"Seberang Jaya","state":"Pulau Pinang","zipcode":"13700","country":"Malaysia","tel":"604 399 7721","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-06-04 19:40:20","added_by":"admin2","modified_on":"2013-06-07 11:03:23","modified_by":"admin2","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null}', '2013-06-07 11:03:23', 'admin2'),
(393, 'sales', 'add', 'quote', 10006, '{"id":"10006","txn_no":"1-10006","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-07 00:00:00","due_date":"2013-06-07 00:00:00","contact_person":"JawiHerbShop ","payment_date":null,"received_date":null,"contact":"Jawi Herbs Shop","contact_id":"1130","contact_address":"{\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop\\",\\"mobile\\":\\"604 399 7721\\",\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"29200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-07 11:06:09","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"15","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5200.0000","price":"5200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"16","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"30","item_name":"Plexcloud Clinic System &#40;Annually&#41;","item_description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","discount":"2000","discount_type":null,"qty":"1","price_per_unit":"24000.0000","price":"24000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-05 20:43:07","modified_by":"admin2","warehouse_id":"0"},"30":{"id":"30","name":"Plexcloud Clinic System &#40;Annually&#41;","description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","category":"0","subcategory":"0","cost":"1000.00","price":"24000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-05 20:54:56","added_by":"admin2","modified_on":"2013-06-07 10:59:08","modified_by":"admin2","warehouse_id":"0"}}}', '2013-06-07 11:06:10', 'admin2'),
(394, 'sales', 'edit', 'quote', 10006, '{"id":"10006","txn_no":"1-10006","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-07 00:00:00","due_date":"2013-06-07 00:00:00","contact_person":"JawiHerbShop ","payment_date":null,"received_date":null,"contact":"Jawi Herbs Shop","contact_id":"1130","contact_address":"{\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop\\",\\"mobile\\":\\"604 399 7721\\",\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"We will be giving out 2 months discount for Plexcloud Clinic System annual subscription. \\n","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"25200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-07 11:06:09","added_by":"admin2","modified_on":"2013-06-07 11:08:19","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"17","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5200.0000","price":"5200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"18","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"30","item_name":"Plexcloud Clinic System &#40;Annually&#41;","item_description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","discount":"4000","discount_type":"d","qty":"1","price_per_unit":"24000.0000","price":"24000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-05 20:43:07","modified_by":"admin2","warehouse_id":"0"},"30":{"id":"30","name":"Plexcloud Clinic System &#40;Annually&#41;","description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","category":"0","subcategory":"0","cost":"1000.00","price":"24000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-05 20:54:56","added_by":"admin2","modified_on":"2013-06-07 10:59:08","modified_by":"admin2","warehouse_id":"0"}}}', '2013-06-07 11:08:19', 'admin2'),
(395, 'sales', 'edit', 'quote', 10006, '{"id":"10006","txn_no":"1-10006","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-07 00:00:00","due_date":"2013-06-07 00:00:00","contact_person":"JawiHerbShop ","payment_date":null,"received_date":null,"contact":"Jawi Herbs Shop","contact_id":"1130","contact_address":"{\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop\\",\\"mobile\\":\\"604 399 7721\\",\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"We will be giving out 2 months discount for Plexcloud Clinic System annual subscription. \\n","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"25200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-07 11:06:09","added_by":"admin2","modified_on":"2013-06-07 11:12:39","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"20","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5200.0000","price":"5200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"19","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"30","item_name":"Plexcloud Clinic System &#40;Annually&#41;","item_description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","discount":"4000","discount_type":"d","qty":"1","price_per_unit":"24000.0000","price":"24000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"},"30":{"id":"30","name":"Plexcloud Clinic System &#40;Annually&#41;","description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","category":"0","subcategory":"0","cost":"1000.00","price":"24000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-05 20:54:56","added_by":"admin2","modified_on":"2013-06-07 10:59:08","modified_by":"admin2","warehouse_id":"0"}}}', '2013-06-07 11:12:39', 'admin2'),
(396, 'sales', 'edit', 'quote', 10006, '{"id":"10006","txn_no":"1-10006","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-07 00:00:00","due_date":"2013-06-07 00:00:00","contact_person":"JawiHerbShop ","payment_date":null,"received_date":null,"contact":"Jawi Herbs Shop","contact_id":"1130","contact_address":"{\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop\\",\\"mobile\\":\\"604 399 7721\\",\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"We will be giving out 2 months discount for Plexcloud Clinic System annual subscription. \\n","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"25200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-07 11:06:09","added_by":"admin2","modified_on":"2013-06-07 16:20:07","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"21","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5200.0000","price":"5200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"22","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"30","item_name":"Plexcloud Clinic System &#40;Annually&#41;","item_description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","discount":"4000","discount_type":"d","qty":"1","price_per_unit":"24000.0000","price":"24000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"},"30":{"id":"30","name":"Plexcloud Clinic System &#40;Annually&#41;","description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","category":"0","subcategory":"0","cost":"1000.00","price":"24000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-05 20:54:56","added_by":"admin2","modified_on":"2013-06-07 10:59:08","modified_by":"admin2","warehouse_id":"0"}}}', '2013-06-07 16:20:07', 'admin2'),
(397, 'sales', 'edit', 'quote', 10006, '{"id":"10006","txn_no":"1-10006","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-07 00:00:00","due_date":"2013-06-07 00:00:00","contact_person":"JawiHerbShop ","payment_date":null,"received_date":null,"contact":"Jawi Herbs Shop","contact_id":"1130","contact_address":"{\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop\\",\\"mobile\\":\\"604 399 7721\\",\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"We will be giving out 2 months discount for Plexcloud Clinic System annual subscription. \\n","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"24400.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-07 11:06:09","added_by":"admin2","modified_on":"2013-06-07 16:27:42","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"23","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5200.0000","price":"5200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"24","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"30","item_name":"Plexcloud Clinic System &#40;Annually&#41;","item_description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","discount":"20","discount_type":"p","qty":"1","price_per_unit":"24000.0000","price":"24000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"30":{"id":"30","name":"Plexcloud Clinic System &#40;Annually&#41;","description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","category":"0","subcategory":"0","cost":"1000.00","price":"24000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-05 20:54:56","added_by":"admin2","modified_on":"2013-06-07 10:59:08","modified_by":"admin2","warehouse_id":"0"},"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"}}}', '2013-06-07 16:27:42', 'admin2'),
(398, 'sales', 'edit', 'quote', 10006, '{"id":"10006","txn_no":"1-10006","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-07 00:00:00","due_date":"2013-06-07 00:00:00","contact_person":"JawiHerbShop ","payment_date":null,"received_date":null,"contact":"Jawi Herbs Shop","contact_id":"1130","contact_address":"{\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop\\",\\"mobile\\":\\"604 399 7721\\",\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"We will be giving out 2 months discount for Plexcloud Clinic System annual subscription. \\n","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"29180.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-07 11:06:09","added_by":"admin2","modified_on":"2013-06-07 16:40:52","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"25","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5200.0000","price":"5200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"26","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"30","item_name":"Plexcloud Clinic System &#40;Annually&#41;","item_description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","discount":"20","discount_type":"d","qty":"1","price_per_unit":"24000.0000","price":"24000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"},"30":{"id":"30","name":"Plexcloud Clinic System &#40;Annually&#41;","description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","category":"0","subcategory":"0","cost":"1000.00","price":"24000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-05 20:54:56","added_by":"admin2","modified_on":"2013-06-07 10:59:08","modified_by":"admin2","warehouse_id":"0"}}}', '2013-06-07 16:40:52', 'admin2'),
(399, 'sales', 'edit', 'quote', 10006, '{"id":"10006","txn_no":"1-10006","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-07 00:00:00","due_date":"2013-06-07 00:00:00","contact_person":"JawiHerbShop ","payment_date":null,"received_date":null,"contact":"Jawi Herbs Shop","contact_id":"1130","contact_address":"{\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop\\",\\"mobile\\":\\"604 399 7721\\",\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"We will be giving out 2 months discount for Plexcloud Clinic System annual subscription. \\n","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"24400.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-07 11:06:09","added_by":"admin2","modified_on":"2013-06-07 16:41:33","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"27","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5200.0000","price":"5200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"28","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"30","item_name":"Plexcloud Clinic System &#40;Annually&#41;","item_description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","discount":"20","discount_type":"p","qty":"1","price_per_unit":"24000.0000","price":"24000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"},"30":{"id":"30","name":"Plexcloud Clinic System &#40;Annually&#41;","description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","category":"0","subcategory":"0","cost":"1000.00","price":"24000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-05 20:54:56","added_by":"admin2","modified_on":"2013-06-07 10:59:08","modified_by":"admin2","warehouse_id":"0"}}}', '2013-06-07 16:41:33', 'admin2'),
(400, 'sales', 'edit', 'quote', 10006, '{"id":"10006","txn_no":"1-10006","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-07 00:00:00","due_date":"2013-06-07 00:00:00","contact_person":"JawiHerbShop ","payment_date":null,"received_date":null,"contact":"Jawi Herbs Shop","contact_id":"1130","contact_address":"{\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop\\",\\"mobile\\":\\"604 399 7721\\",\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"We will be giving out 2 months discount for Plexcloud Clinic System annual subscription. \\n","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"25200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-07 11:06:09","added_by":"admin2","modified_on":"2013-06-07 16:58:47","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"29","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5200.0000","price":"5200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"30","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"30","item_name":"Plexcloud Clinic System &#40;Annually&#41;","item_description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","discount":"4000","discount_type":"d","qty":"1","price_per_unit":"24000.0000","price":"24000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"},"30":{"id":"30","name":"Plexcloud Clinic System &#40;Annually&#41;","description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","category":"0","subcategory":"0","cost":"1000.00","price":"24000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-05 20:54:56","added_by":"admin2","modified_on":"2013-06-07 10:59:08","modified_by":"admin2","warehouse_id":"0"}}}', '2013-06-07 16:58:47', 'admin2');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(401, 'sales', 'edit', 'quote', 10006, '{"id":"10006","txn_no":"1-10006","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-07 00:00:00","due_date":"2013-06-07 00:00:00","contact_person":"JawiHerbShop ","payment_date":null,"received_date":null,"contact":"Jawi Herbs Shop","contact_id":"1130","contact_address":"{\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop\\",\\"mobile\\":\\"604 399 7721\\",\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"We will be giving out 2 months discount for Plexcloud Clinic System annual subscription. \\n","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"25199.80","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-07 11:06:09","added_by":"admin2","modified_on":"2013-06-07 17:06:34","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"31","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5200.0000","price":"5200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"32","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"30","item_name":"Plexcloud Clinic System &#40;Annually&#41;","item_description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","discount":"4000.20","discount_type":"d","qty":"1","price_per_unit":"24000.0000","price":"24000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"},"30":{"id":"30","name":"Plexcloud Clinic System &#40;Annually&#41;","description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","category":"0","subcategory":"0","cost":"1000.00","price":"24000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-05 20:54:56","added_by":"admin2","modified_on":"2013-06-07 10:59:08","modified_by":"admin2","warehouse_id":"0"}}}', '2013-06-07 17:06:34', 'admin2'),
(402, 'sales', 'edit', 'quote', 10006, '{"id":"10006","txn_no":"1-10006","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-07 00:00:00","due_date":"2013-06-07 00:00:00","contact_person":"JawiHerbShop ","payment_date":null,"received_date":null,"contact":"Jawi Herbs Shop","contact_id":"1130","contact_address":"{\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop\\",\\"mobile\\":\\"604 399 7721\\",\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"We will be giving out 2 months discount for Plexcloud Clinic System annual subscription. \\n","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"25200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-07 11:06:09","added_by":"admin2","modified_on":"2013-06-07 17:07:51","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"33","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5200.0000","price":"5200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"34","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"30","item_name":"Plexcloud Clinic System &#40;Annually&#41;","item_description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","discount":"4000","discount_type":"d","qty":"1","price_per_unit":"24000.0000","price":"24000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"},"30":{"id":"30","name":"Plexcloud Clinic System &#40;Annually&#41;","description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","category":"0","subcategory":"0","cost":"1000.00","price":"24000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-05 20:54:56","added_by":"admin2","modified_on":"2013-06-07 10:59:08","modified_by":"admin2","warehouse_id":"0"}}}', '2013-06-07 17:07:51', 'admin2'),
(403, 'sales', 'edit', 'quote', 10006, '{"id":"10006","txn_no":"1-10006","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-07 00:00:00","due_date":"2013-06-07 00:00:00","contact_person":"JawiHerbShop ","payment_date":null,"received_date":null,"contact":"Jawi Herbs Shop","contact_id":"1130","contact_address":"{\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop\\",\\"mobile\\":\\"604 399 7721\\",\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"We will be giving out 2 months discount for Plexcloud Clinic System annual subscription. \\n","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"25257.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-07 11:06:09","added_by":"admin2","modified_on":"2013-06-07 17:16:05","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"35","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5200.0000","price":"5200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"37","quote_id":"10006","date":"2013-06-07 00:00:00","type":"product","item_id":"25","service_id":"0","item_name":"Almeta","item_description":"","discount":"20","discount_type":"d","qty":"1","price_per_unit":"77.0000","price":"77.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"36","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"30","item_name":"Plexcloud Clinic System &#40;Annually&#41;","item_description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","discount":"4000","discount_type":"d","qty":"1","price_per_unit":"24000.0000","price":"24000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-25 22:15:19","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"},"30":{"id":"30","name":"Plexcloud Clinic System &#40;Annually&#41;","description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","category":"0","subcategory":"0","cost":"1000.00","price":"24000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-05 20:54:56","added_by":"admin2","modified_on":"2013-06-07 10:59:08","modified_by":"admin2","warehouse_id":"0"}}}', '2013-06-07 17:16:05', 'admin2'),
(404, 'sales', 'edit', 'quote', 10006, '{"id":"10006","txn_no":"1-10006","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-07 00:00:00","due_date":"2013-06-07 00:00:00","contact_person":"JawiHerbShop ","payment_date":null,"received_date":null,"contact":"Jawi Herbs Shop","contact_id":"1130","contact_address":"{\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop\\",\\"mobile\\":\\"604 399 7721\\",\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"We will be giving out 2 months discount for Plexcloud Clinic System annual subscription. \\n","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"25206.16","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-07 11:06:09","added_by":"admin2","modified_on":"2013-06-07 17:18:54","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"38","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5200.0000","price":"5200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"39","quote_id":"10006","date":"2013-06-07 00:00:00","type":"product","item_id":"25","service_id":"0","item_name":"Almeta","item_description":"","discount":"92","discount_type":"p","qty":"1","price_per_unit":"77.0000","price":"77.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"40","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"30","item_name":"Plexcloud Clinic System &#40;Annually&#41;","item_description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","discount":"4000","discount_type":"d","qty":"1","price_per_unit":"24000.0000","price":"24000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-25 22:15:19","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":{"30":{"id":"30","name":"Plexcloud Clinic System &#40;Annually&#41;","description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","category":"0","subcategory":"0","cost":"1000.00","price":"24000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-05 20:54:56","added_by":"admin2","modified_on":"2013-06-07 10:59:08","modified_by":"admin2","warehouse_id":"0"},"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"}}}', '2013-06-07 17:18:54', 'admin2'),
(405, 'sales', 'edit', 'quote', 10006, '{"id":"10006","txn_no":"1-10006","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-07 00:00:00","due_date":"2013-06-07 00:00:00","contact_person":"JawiHerbShop ","payment_date":null,"received_date":null,"contact":"Jawi Herbs Shop","contact_id":"1130","contact_address":"{\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Jawi Herbs Shop\\",\\"mobile\\":\\"604 399 7721\\",\\"address1\\":\\"21-G, Lorong Kelasah 1\\",\\"address2\\":\\"Taman Kelasah\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Jaya\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"We will be giving out 2 months discount for Plexcloud Clinic System annual subscription. \\n","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"25200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-07 11:06:09","added_by":"admin2","modified_on":"2013-06-07 17:48:10","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"41","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5200.0000","price":"5200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"42","quote_id":"10006","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"30","item_name":"Plexcloud Clinic System &#40;Annually&#41;","item_description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","discount":"4000","discount_type":"d","qty":"1","price_per_unit":"24000.0000","price":"24000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"},"30":{"id":"30","name":"Plexcloud Clinic System &#40;Annually&#41;","description":"Monthly commitment of RM2000\\nModules Included:\\n1) Contacts\\n2) Clinic\\n3) Sales\\n4) Inventory\\n5) Services\\n6) HR\\n7) Reports\\n8) Account","category":"0","subcategory":"0","cost":"1000.00","price":"24000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-05 20:54:56","added_by":"admin2","modified_on":"2013-06-07 10:59:08","modified_by":"admin2","warehouse_id":"0"}}}', '2013-06-07 17:48:10', 'admin2'),
(406, 'sales', 'add', 'quote', 10007, '{"id":"10007","txn_no":"1-10007","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-14 00:00:00","due_date":"2013-07-12 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"17.10","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-12 11:38:20","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"43","quote_id":"10007","date":"2013-06-14 00:00:00","type":"product","item_id":"66","service_id":"0","item_name":"Accessory Strap","item_description":"","discount":"5","discount_type":"p","qty":"3","price_per_unit":"6.0000","price":"18.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:10:21","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2013-06-12 11:38:21', 'admin'),
(407, 'contacts', 'add', 'contact', 1132, '{"id":"1132","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Casemix Solutions Sdn Bhd","company_registration":"940598-D","contact_person":"Syed Mohamad Hamzah Al-Junid Syed Abdul Rahman","contact_number":"012 562 1716","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Level 5, Nursing Hostel Building","address2":"Universiti Kebangsaan Malaysia Medical Center","city":"Cheras","state":"Selangor","zipcode":"56000","country":"Malaysia","tel":"0391456685","fax":"","general_email":"info@casemix.com.my","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-06-14 12:21:05","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2013-06-14 12:21:05', 'admin'),
(408, 'sales', 'add', 'quote', 10008, '{"id":"10008","txn_no":"1-10008","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-14 00:00:00","due_date":"2013-06-30 00:00:00","contact_person":"Syed Mohamad Hamzah Al-Junid Syed Abdul Rahman","payment_date":null,"received_date":null,"contact":"Casemix Solutions Sdn Bhd","contact_id":"1132","contact_address":"{\\"address1\\":\\"Level 5, Nursing Hostel Building\\",\\"address2\\":\\"Universiti Kebangsaan Malaysia Medical Center\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Casemix Solutions Sdn Bhd\\",\\"mobile\\":\\"0391456685\\",\\"address1\\":\\"Level 5, Nursing Hostel Building\\",\\"address2\\":\\"Universiti Kebangsaan Malaysia Medical Center\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-14 12:23:36","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":null,"products":null,"services":null}', '2013-06-14 12:23:36', 'admin'),
(409, 'sales', 'edit', 'quote', 10008, '{"id":"10008","txn_no":"1-10008","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-14 00:00:00","due_date":"2013-06-30 00:00:00","contact_person":"Syed Mohamad Hamzah Al-Junid Syed Abdul Rahman","payment_date":null,"received_date":null,"contact":"Casemix Solutions Sdn Bhd","contact_id":"1132","contact_address":"{\\"address1\\":\\"Level 5, Nursing Hostel Building\\",\\"address2\\":\\"Universiti Kebangsaan Malaysia Medical Center\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Casemix Solutions Sdn Bhd\\",\\"mobile\\":\\"0391456685\\",\\"address1\\":\\"Level 5, Nursing Hostel Building\\",\\"address2\\":\\"Universiti Kebangsaan Malaysia Medical Center\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-14 12:23:36","added_by":"admin","modified_on":"2013-06-14 12:26:29","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"45","quote_id":"10008","date":"2013-06-14 00:00:00","type":"service","item_id":"0","service_id":"32","item_name":"Website Development, Design & Training","item_description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3500.0000","price":"3500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-06-14 12:26:29', 'admin'),
(410, 'sales', 'edit', 'quote', 10008, '{"id":"10008","txn_no":"1-10008","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-14 00:00:00","due_date":"2013-06-30 00:00:00","contact_person":"Syed Mohamad Hamzah Al-Junid Syed Abdul Rahman","payment_date":null,"received_date":null,"contact":"Casemix Solutions Sdn Bhd","contact_id":"1132","contact_address":"{\\"address1\\":\\"Level 5, Nursing Hostel Building\\",\\"address2\\":\\"Universiti Kebangsaan Malaysia Medical Center\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Casemix Solutions Sdn Bhd\\",\\"mobile\\":\\"0391456685\\",\\"address1\\":\\"Level 5, Nursing Hostel Building\\",\\"address2\\":\\"Universiti Kebangsaan Malaysia Medical Center\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-14 12:23:36","added_by":"admin","modified_on":"2013-06-14 12:28:35","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"46","quote_id":"10008","date":"2013-06-14 00:00:00","type":"service","item_id":"0","service_id":"32","item_name":"Website Development, Design & Training","item_description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3500.0000","price":"3500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-06-14 12:28:35', 'admin'),
(411, 'contacts', 'edit', 'contact', 1132, '{"id":"1132","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Casemix Solutions Sdn Bhd","company_registration":"940598-D","contact_person":"Syed Mohamad Hamzah Al-Junid Syed Abdul Rahman","contact_number":"012 562 1716","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Level 5, Nursing Hostel Building","address2":"Universiti Kebangsaan Malaysia Medical Center","city":"Cheras","state":"Kuala Lumpur","zipcode":"56000","country":"Malaysia","tel":"0391456685","fax":"","general_email":"info@casemix.com.my","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-06-14 12:21:05","added_by":"admin","modified_on":"2013-06-14 12:29:31","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2013-06-14 12:29:31', 'admin'),
(412, 'sales', 'edit', 'quote', 10008, '{"id":"10008","txn_no":"1-10008","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-14 00:00:00","due_date":"2013-06-30 00:00:00","contact_person":"Syed Mohamad Hamzah Al-Junid Syed Abdul Rahman","payment_date":null,"received_date":null,"contact":"Casemix Solutions Sdn Bhd","contact_id":"1132","contact_address":"{\\"address1\\":\\"Level 5, Nursing Hostel Building\\",\\"address2\\":\\"Universiti Kebangsaan Malaysia Medical Center\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Casemix Solutions Sdn Bhd\\",\\"mobile\\":\\"0391456685\\",\\"address1\\":\\"Level 5, Nursing Hostel Building\\",\\"address2\\":\\"Universiti Kebangsaan Malaysia Medical Center\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-14 12:23:36","added_by":"admin","modified_on":"2013-06-14 12:30:15","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"47","quote_id":"10008","date":"2013-06-14 00:00:00","type":"service","item_id":"0","service_id":"32","item_name":"Website Development, Design & Training","item_description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3500.0000","price":"3500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-06-14 12:30:15', 'admin'),
(413, 'sales', 'edit', 'quote', 10008, '{"id":"10008","txn_no":"1-10008","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-14 00:00:00","due_date":"2013-06-30 00:00:00","contact_person":"Syed Mohamad Hamzah Al-Junid Syed Abdul Rahman","payment_date":null,"received_date":null,"contact":"Casemix Solutions Sdn Bhd","contact_id":"1132","contact_address":"{\\"address1\\":\\"Level 5, Nursing Hostel Building\\",\\"address2\\":\\"Universiti Kebangsaan Malaysia Medical Center\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Casemix Solutions Sdn Bhd\\",\\"mobile\\":\\"0391456685\\",\\"address1\\":\\"Level 5, Nursing Hostel Building\\",\\"address2\\":\\"Universiti Kebangsaan Malaysia Medical Center\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-14 12:23:36","added_by":"admin","modified_on":"2013-06-14 12:33:27","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"48","quote_id":"10008","date":"2013-06-14 00:00:00","type":"service","item_id":"0","service_id":"32","item_name":"Website Development, Design & Training","item_description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3500.0000","price":"3500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":"2013-06-14 12:30:53","modified_by":"admin","warehouse_id":"0"}}}', '2013-06-14 12:33:27', 'admin'),
(414, 'sales', 'edit', 'quote', 10008, '{"id":"10008","txn_no":"1-10008","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-14 00:00:00","due_date":"2013-06-30 00:00:00","contact_person":"Syed Mohamad Hamzah Al-Junid Syed Abdul Rahman","payment_date":null,"received_date":null,"contact":"Casemix Solutions Sdn Bhd","contact_id":"1132","contact_address":"{\\"address1\\":\\"Level 5, Nursing Hostel Building\\",\\"address2\\":\\"Universiti Kebangsaan Malaysia Medical Center\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Casemix Solutions Sdn Bhd\\",\\"mobile\\":\\"0391456685\\",\\"address1\\":\\"Level 5, Nursing Hostel Building\\",\\"address2\\":\\"Universiti Kebangsaan Malaysia Medical Center\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-14 12:23:36","added_by":"admin","modified_on":"2013-06-14 12:33:33","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"49","quote_id":"10008","date":"2013-06-14 00:00:00","type":"service","item_id":"0","service_id":"32","item_name":"Website Development, Design & Training","item_description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3500.0000","price":"3500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":"2013-06-14 12:30:53","modified_by":"admin","warehouse_id":"0"}}}', '2013-06-14 12:33:33', 'admin'),
(415, 'contacts', 'add', 'contact', 1133, '{"id":"1133","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"CGT Petroleum","company_registration":"","contact_person":"Ustaz Muhammad","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. A29-2A, Jalan TKS 1 Taman Kajang Sentral","address2":"Taman Kajang Sentral","city":"Kajang","state":"Selangor","zipcode":"43000","country":"Malaysia","tel":"6019-276 7105","fax":"","general_email":"muhammad@cgtpetroleum.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-06-17 11:05:58","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2013-06-17 11:05:58', 'admin'),
(416, 'sales', 'add', 'invoice', 10016, '{"id":"10016","txn_no":"1-10016","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2013-06-17 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"CGT Petroleum","contact_id":"1133","contact_address":"{\\"address1\\":\\"No. A29-2A, Jalan TKS 1 Taman Kajang Sentral\\",\\"address2\\":\\"Taman Kajang Sentral\\",\\"zipcode\\":\\"43000\\",\\"city\\":\\"Kajang\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"CGT Petroleum\\",\\"mobile\\":\\"6019-276 7105\\",\\"address1\\":\\"No. A29-2A, Jalan TKS 1 Taman Kajang Sentral\\",\\"address2\\":\\"Taman Kajang Sentral\\",\\"zipcode\\":\\"43000\\",\\"city\\":\\"Kajang\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1250.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-17 11:07:31","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"28","invoice_id":"10016","type":"service","date":"2013-06-17 12:00:00","item_name":"Web Refurbishment of CGT Petroleum","item_description":"Refurbishment of CGT Website\\n- Courses Registration Module\\n- Recode of Website Engine for simpler management\\n- Page and Content Management ","item_id":"0","service_id":"33","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1100.0000","price":"1100.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"},{"id":"29","invoice_id":"10016","type":"service","date":"2013-06-17 12:00:00","item_name":"Training of Wordpress","item_description":"Train the staff of CGT Petroleum for the web management of CGT Petroleum Website","item_id":"0","service_id":"34","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"150.0000","price":"150.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"33":{"id":"33","name":"Web Refurbishment of CGT Petroleum","description":"Refurbishment of CGT Website\\n- Courses Registration Module\\n- Recode of Website Engine for simpler management\\n- Page and Content Management ","category":"0","subcategory":"0","cost":"0.00","price":"1100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-17 11:00:54","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"},"34":{"id":"34","name":"Training of Wordpress","description":"Train the staff of CGT Petroleum for the web management of CGT Petroleum Website","category":"0","subcategory":"0","cost":"0.00","price":"150.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-17 11:01:43","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1133","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"CGT Petroleum","company_registration":"","contact_person":"Ustaz Muhammad","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. A29-2A, Jalan TKS 1 Taman Kajang Sentral","address2":"Taman Kajang Sentral","city":"Kajang","state":"Selangor","zipcode":"43000","country":"Malaysia","tel":"6019-276 7105","fax":"","general_email":"muhammad@cgtpetroleum.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-06-17 11:05:58","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2013-06-17 11:07:33', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(417, 'sales', 'add', 'quote', 10009, '{"id":"10009","txn_no":"8-10001","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-17 00:00:00","due_date":"2013-06-30 00:00:00","contact_person":"Administrator 3 ","payment_date":null,"received_date":null,"contact":"CGT Petroleum","contact_id":"1133","contact_address":"{\\"address1\\":\\"No. A29-2A, Jalan TKS 1 Taman Kajang Sentral\\",\\"address2\\":\\"Taman Kajang Sentral\\",\\"zipcode\\":\\"43000\\",\\"city\\":\\"Kajang\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"CGT Petroleum\\",\\"mobile\\":\\"6019-276 7105\\",\\"address1\\":\\"No. A29-2A, Jalan TKS 1 Taman Kajang Sentral\\",\\"address2\\":\\"Taman Kajang Sentral\\",\\"zipcode\\":\\"43000\\",\\"city\\":\\"Kajang\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-17 11:19:11","added_by":"admin3","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"8","assigned_to":null,"orders":[{"id":"50","quote_id":"10009","date":"2013-06-17 00:00:00","type":"service","item_id":"0","service_id":"35","item_name":"Plexcloud Sales System","item_description":"System for Business module\\n- Contacts Module\\n- Sales Module\\n- Services Module\\n\\nThis system is an auto-generated system for ease of creating, Quotation, Invoices, Sales Order, Delivery Orders, Credit Note.\\n\\nNote\\nThe charges of the System is RM 350 \\/ mo, with a year contract basis.\\nIf full payment made, a discount of 2 months will be given.","discount":"0","discount_type":null,"qty":"1","price_per_unit":"4200.0000","price":"4200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"8"}],"products":null,"services":{"35":{"id":"35","name":"Plexcloud Sales System","description":"System for Business module\\n- Contacts Module\\n- Sales Module\\n- Services Module\\n\\nThis system is an auto-generated system for ease of creating, Quotation, Invoices, Sales Order, Delivery Orders, Credit Note.\\n\\nThe charges of the System is RM 350 \\/ mo","category":"0","subcategory":"0","cost":"0.00","price":"350.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-17 11:12:49","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-06-17 11:19:11', 'admin3'),
(418, 'inventory', 'edit', 'item', 74, '{"id":"74","primary_image":null,"image":null,"category":"Medicine","subcategory":"Eye","brand":"Eyemo","location":"","name":"Eye Mo","model_no":"","warranty":"","sku":"987654321","sku2":"","sku3":"","sku4":"","qty":"42","alert_quantity":"10","max_quantity":"0","cost":"0.00","average_cost":null,"price":"2.50","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2013-05-17 19:07:24","added_by":"admin","modified_on":"2013-06-17 19:19:01","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2013-06-13 12:38:18","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2013-06-17 19:19:01', 'admin'),
(419, 'sales', 'edit', 'quote', 10005, '{"id":"10005","txn_no":"1-10005","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-07 00:00:00","due_date":"2013-07-07 00:00:00","contact_person":"Hizal Hanis","payment_date":null,"received_date":null,"contact":"Malaysian Institute of Road Safety Research (MIROS)","contact_id":"1131","contact_address":"{\\"address1\\":\\"Lot 125-135, Jalan TKS 1\\",\\"address2\\":\\"Taman Kajang Sentral\\",\\"zipcode\\":\\"43000 \\",\\"city\\":\\"Kajang\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Malaysian Institute of Road Safety Research (MIROS)\\",\\"mobile\\":\\"\\",\\"address1\\":\\"Lot 125-135, Jalan TKS 1\\",\\"address2\\":\\"Taman Kajang Sentral\\",\\"zipcode\\":\\"43000 \\",\\"city\\":\\"Kajang\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"49999.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-07 10:44:47","added_by":"admin2","modified_on":"2013-07-11 14:24:25","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"51","quote_id":"10005","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"31","item_name":"Data Collection and Analysis with Android Mobile Support","item_description":"3 Months of Product Development\\n2 Months of Product Support\\n4 Months Warranty\\nData Collection\\nTo provide a Web Based Application on Accident data collection.\\n\\n* Multiple User\\n* Permission Levels for User\\n* Data Collection Form\\n* Documentation of System\\n* Training Usage of the System\\n\\nData Analytics\\nAn analytic tool for the data collection in producing reports of the collected data.\\n\\n* Heat Map (Black Area)\\n* Cross Filtering Between Inputs from Data Collection\\n* Training Usage of the System\\n* Documentation of System\\n\\nMobile Implementation \\n* Mobile development for On-Site data Collection\\n* Sketching App for Data\\n* Data sending to Main Server for cases\\n* Training and Documentation\\n\\nTraining\\n* Training to MIROS in-house programmers will be conducted during the support month\\n\\nSource Code\\n* Source Code Copyrights will be handed over to MIROS","discount":"0","discount_type":null,"qty":"1","price_per_unit":"49999.0000","price":"49999.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"31":{"id":"31","name":"Data Collection and Analysis with Android Mobile Support","description":"3 Months of Product Development\\n2 Months of Product Support\\n4 Months Warranty\\nData Collection\\nTo provide a Web Based Application on Accident data collection.\\n\\n* Multiple User\\n* Permission Levels for User\\n* Data Collection Form\\n* Documentation of System\\n* Training Usage of the System\\n\\nData Analytics\\nAn analytic tool for the data collection in producing reports of the collected data.\\n\\n* Heat Map (Black Area)\\n* Cross Filtering Between Inputs from Data Collection\\n* Training Usage of the System\\n* Documentation of System\\n\\nMobile Implementation \\n* Mobile development for On-Site data Collection\\n* Sketching App for Data\\n* Data sending to Main Server for cases\\n* Training and Documentation\\n\\nTraining\\n* Training to MIROS in-house programmers will be conducted during the support month\\n\\nSource Code\\n* Source Code Copyrights will be handed over to MIROS","category":"0","subcategory":"0","cost":"60000.00","price":"49999.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-07 10:42:02","added_by":"admin2","modified_on":"2013-07-11 14:22:48","modified_by":"admin2","warehouse_id":"0"}}}', '2013-07-11 14:24:25', 'admin2'),
(420, 'sales', 'edit', 'quote', 10005, '{"id":"10005","txn_no":"1-10005","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-06-07 00:00:00","due_date":"2013-07-07 00:00:00","contact_person":"","payment_date":null,"received_date":null,"contact":"Malaysian Institute of Road Safety Research (MIROS)","contact_id":"1131","contact_address":"{\\"address1\\":\\"Lot 125-135, Jalan TKS 1\\",\\"address2\\":\\"Taman Kajang Sentral\\",\\"zipcode\\":\\"43000 \\",\\"city\\":\\"Kajang\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Malaysian Institute of Road Safety Research (MIROS)\\",\\"mobile\\":\\"\\",\\"address1\\":\\"Lot 125-135, Jalan TKS 1\\",\\"address2\\":\\"Taman Kajang Sentral\\",\\"zipcode\\":\\"43000 \\",\\"city\\":\\"Kajang\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"49999.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-06-07 10:44:47","added_by":"admin2","modified_on":"2013-07-11 14:27:20","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"52","quote_id":"10005","date":"2013-06-07 00:00:00","type":"service","item_id":"0","service_id":"31","item_name":"MEMBANGUN, MEMBEKAL, MENGHANTAR, MEMASANG DAN MENGUJILARI SISTEM ANALISA DAN PENGURUSAN PENGKALAN DATA KEMALANGAN JALAN RAYA","item_description":"3 Months of Product Development\\n2 Months of Product Support\\n4 Months Warranty\\nData Collection\\nTo provide a Web Based Application on Accident data collection.\\n\\n* Multiple User\\n* Permission Levels for User\\n* Data Collection Form\\n* Documentation of System\\n* Training Usage of the System\\n\\nData Analytics\\nAn analytic tool for the data collection in producing reports of the collected data.\\n\\n* Heat Map (Black Area)\\n* Cross Filtering Between Inputs from Data Collection\\n* Training Usage of the System\\n* Documentation of System\\n\\nMobile Implementation \\n* Mobile development for On-Site data Collection\\n* Sketching App for Data\\n* Data sending to Main Server for cases\\n* Training and Documentation\\n\\nTraining\\n* Training to MIROS in-house programmers will be conducted during the support month\\n\\nSource Code\\n* Source Code Copyrights will be handed over to MIROS","discount":"0","discount_type":null,"qty":"1","price_per_unit":"49999.0000","price":"49999.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"31":{"id":"31","name":"MEMBANGUN, MEMBEKAL, MENGHANTAR, MEMASANG DAN MENGUJILARI SISTEM ANALISA DAN PENGURUSAN PENGKALAN DATA KEMALANGAN JALAN RAYA","description":"3 Months of Product Development\\n2 Months of Product Support\\n4 Months Warranty\\nData Collection\\nTo provide a Web Based Application on Accident data collection.\\n\\n* Multiple User\\n* Permission Levels for User\\n* Data Collection Form\\n* Documentation of System\\n* Training Usage of the System\\n\\nData Analytics\\nAn analytic tool for the data collection in producing reports of the collected data.\\n\\n* Heat Map (Black Area)\\n* Cross Filtering Between Inputs from Data Collection\\n* Training Usage of the System\\n* Documentation of System\\n\\nMobile Implementation \\n* Mobile development for On-Site data Collection\\n* Sketching App for Data\\n* Data sending to Main Server for cases\\n* Training and Documentation\\n\\nTraining\\n* Training to MIROS in-house programmers will be conducted during the support month\\n\\nSource Code\\n* Source Code Copyrights will be handed over to MIROS","category":"0","subcategory":"0","cost":"60000.00","price":"49999.00","last_tendered":null,"remarks":"MEMBANGUN, MEMBEKAL, MENGHANTAR, MEMASANG DAN MENGUJILARI SISTEM ANALISA DAN PENGURUSAN PENGKALAN DATA KEMALANGAN JALAN RAYA BAGI INSTITUT PENYELIDIKAN KESELAMATAN JALAN RAYA MALAYSIA, LOT 135 JLN TKS 1, TAMAN KAJANG SENTRAL, 43000 KAJANG, SELANGOR       ","tags":null,"added_on":"2013-06-07 10:42:02","added_by":"admin2","modified_on":"2013-07-11 14:26:33","modified_by":"admin2","warehouse_id":"0"}}}', '2013-07-11 14:27:20', 'admin2'),
(421, 'contacts', 'edit', 'contact', 1131, '{"id":"1131","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Malaysian Institute of Road Safety Research (MIROS)","company_registration":"","contact_person":"Project Manager","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot 125-135, Jalan TKS 1","address2":"Taman Kajang Sentral","city":"Kajang","state":"Selangor","zipcode":"43000 ","country":"Malaysia","tel":"","fax":"","general_email":"dg@miros.gov.my ","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-06-07 10:43:41","added_by":"admin2","modified_on":"2013-07-11 14:28:09","modified_by":"admin2","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2013-07-11 14:28:09', 'admin2'),
(422, 'contacts', 'add', 'contact', 1134, '{"id":"1134","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Al Kanz Hadramawt","company_registration":"","contact_person":"Halim","contact_number":"0124710546","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 134 Persiaran6 Hitech Avenue","address2":"","city":"Kulim","state":"Kedah","zipcode":"09000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-07-16 20:50:27","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2013-07-16 20:50:27', 'admin2'),
(423, 'sales', 'add', 'quote', 10010, '{"id":"10010","txn_no":"1-10009","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-07-16 00:00:00","due_date":"2013-07-16 00:00:00","contact_person":"Halim ","payment_date":null,"received_date":null,"contact":"Al Kanz Hadramawt","contact_id":"1134","contact_address":"{\\"address1\\":\\"No. 134 Persiaran6 Hitech Avenue\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"09000\\",\\"city\\":\\"Kulim\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Al Kanz Hadramawt\\",\\"mobile\\":\\"0124710546\\",\\"address1\\":\\"No. 134 Persiaran6 Hitech Avenue\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"09000\\",\\"city\\":\\"Kulim\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"5450.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-07-16 20:54:17","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"53","quote_id":"10010","date":"2013-07-16 00:00:00","type":"service","item_id":"0","service_id":"36","item_name":"F&B Plexcloud Hardwares","item_description":"All-in-one-POS ( MSI Touch Screen)\\n3 Thermal Printers\\n1 Cash Drawer\\n1 Ipod Touch","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5000.0000","price":"5000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"54","quote_id":"10010","date":"2013-07-16 00:00:00","type":"service","item_id":"0","service_id":"37","item_name":"F&B Plexcloud Subscription (Monthly)","item_description":"RM450\\/monthly subscription fee","discount":"0","discount_type":null,"qty":"1","price_per_unit":"450.0000","price":"450.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"36":{"id":"36","name":"F&B Plexcloud Hardwares","description":"All-in-one-POS ( MSI Touch Screen)\\n3 Thermal Printers\\n1 Cash Drawer\\n1 Ipod Touch","category":"0","subcategory":"0","cost":"4979.00","price":"5000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-07-16 20:48:43","added_by":"admin2","modified_on":"2013-07-16 20:52:02","modified_by":"admin2","warehouse_id":"0"},"37":{"id":"37","name":"F&B Plexcloud Subscription","description":"RM450\\/monthly subscription fee","category":"0","subcategory":"0","cost":"400.00","price":"450.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-07-16 20:52:51","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-07-16 20:54:17', 'admin2'),
(424, 'inventory', 'edit', 'item', 69, '{"id":"69","primary_image":"kr01.jpg","image":"kr01.jpg","category":"Home","subcategory":"Accessories","brand":"0","location":"","name":"Kopi Radix","model_no":"","warranty":"","sku":"kr01","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"4","max_quantity":"0","cost":"0.00","average_cost":null,"price":"11.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-14 08:45:02","added_by":"admin","modified_on":"2013-08-26 10:16:40","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"100.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"7"}', '2013-08-26 10:16:40', 'admin'),
(425, 'sales', 'add', 'so', 10013, '{"id":"10013","txn_no":"1-10010","quote_id":"10008","invoice_id":null,"number":"0","pr_number":null,"po_number":"QUO-10008","date":"2013-06-14 00:00:00","due_date":"0000-00-00 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Casemix Solutions Sdn Bhd","contact_id":"1132","contact_address":"{\\"address1\\":\\"Level 5, Nursing Hostel Building\\",\\"address2\\":\\"Universiti Kebangsaan Malaysia Medical Center\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"false","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-09-02 16:10:45","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"14","sales_order_id":"10013","type":"service","date":"2013-06-14 00:00:00","item_name":"Website Development, Design & Training","item_description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","item_id":"0","service_id":"32","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"3500.0000","price":"3500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":"2013-06-14 12:30:53","modified_by":"admin","warehouse_id":"0"}}}', '2013-09-02 16:10:45', 'admin'),
(426, 'sales', 'status_update', 'so', 10013, '{"id":"10013","txn_no":"1-10010","quote_id":"10008","invoice_id":null,"number":"0","pr_number":null,"po_number":"QUO-10008","date":"2013-06-14 00:00:00","due_date":"0000-00-00 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Casemix Solutions Sdn Bhd","contact_id":"1132","contact_address":"{\\"address1\\":\\"Level 5, Nursing Hostel Building\\",\\"address2\\":\\"Universiti Kebangsaan Malaysia Medical Center\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"false","terms":"Credit","duration":"0","remarks":"","status":"Completed","payment_gateway":null,"payment_method":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-09-02 16:10:45","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"14","sales_order_id":"10013","type":"service","date":"2013-06-14 00:00:00","item_name":"Website Development, Design & Training","item_description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","item_id":"0","service_id":"32","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"3500.0000","price":"3500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":"2013-06-14 12:30:53","modified_by":"admin","warehouse_id":"0"}}}', '2013-09-02 16:10:54', 'admin'),
(427, 'sales', 'add', 'invoice', 10017, '{"id":"10017","txn_no":"1-10017","quote_id":"10008","sales_order_id":"10013","number":"0","po_number":"QUO-10008","date":"2013-06-14 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Casemix Solutions Sdn Bhd","contact_id":"1132","contact_address":"{\\"address1\\":\\"Level 5, Nursing Hostel Building\\",\\"address2\\":\\"Universiti Kebangsaan Malaysia Medical Center\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-09-02 16:11:15","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"30","invoice_id":"10017","type":"service","date":"2013-06-14 12:00:00","item_name":"Website Development, Design & Training","item_description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","item_id":"0","service_id":"32","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"3500.0000","price":"3500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":"2013-06-14 12:30:53","modified_by":"admin","warehouse_id":"0"}},"customer":{"id":"1132","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Casemix Solutions Sdn Bhd","company_registration":"940598-D","contact_person":"Syed Mohamad Hamzah Al-Junid Syed Abdul Rahman","contact_number":"012 562 1716","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Level 5, Nursing Hostel Building","address2":"Universiti Kebangsaan Malaysia Medical Center","city":"Cheras","state":"Kuala Lumpur","zipcode":"56000","country":"Malaysia","tel":"0391456685","fax":"","general_email":"info@casemix.com.my","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-06-14 12:21:05","added_by":"admin","modified_on":"2013-06-14 12:29:31","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2013-09-02 16:11:15', 'admin'),
(428, 'contacts', 'edit', 'contact', 1013, '{"id":"1013","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Shamir Adnan","contact_number":"0125445670","credit_limit":"0.00","rank":"0","email":"shamiradnan@gmail.com","ic":"840621055253","password":"da2ec7ad9e322d9b2e226d1dfe90c1c5","introducer_ic":"846655445500","address1":"41, Lorong Indah","address2":"Taman Bukit Indah","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"shamiradnan@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 10:10:02","added_by":"@Plexcart","modified_on":"2013-09-03 11:54:41","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shamiradnan@gmail.com1348067723","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2013-09-03 11:54:41', 'admin'),
(429, 'contacts', 'edit', 'contact', 1013, '{"id":"1013","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Shamir Adnan","contact_number":"0125445670","credit_limit":"0.00","rank":"0","email":"shamiradnan@gmail.com","ic":"840621055253","password":"da2ec7ad9e322d9b2e226d1dfe90c1c5","introducer_ic":"846655445500","address1":"41, Lorong Indah","address2":"Taman Bukit Inda","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"shamiradnan@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 10:10:02","added_by":"@Plexcart","modified_on":"2013-09-03 11:56:46","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shamiradnan@gmail.com1348067723","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2013-09-03 11:56:46', 'admin'),
(430, 'contacts', 'add', 'contact', 1135, '{"id":"1135","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Brickfields Asia College","company_registration":"","contact_person":"Mr. Nadar Thiagendran","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Selangor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-09-06 22:39:34","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1378478374"}', '2013-09-06 22:39:34', 'admin'),
(431, 'inventory', 'add', 'item', NULL, '[]', '2013-09-06 22:41:18', 'admin'),
(432, 'sales', 'add', 'quote', 10011, '{"id":"10011","txn_no":"1-10010","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-09-07 00:00:00","due_date":"2013-09-17 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Brickfields Asia College","contact_id":"1135","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Brickfields Asia College\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"54900.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-09-06 22:51:15","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"55","quote_id":"10011","date":"2013-09-07 00:00:00","type":"product","item_id":"77","service_id":"0","item_name":"All-In-One POS","item_description":"","discount":"0","discount_type":null,"qty":"11","price_per_unit":"3900.0000","price":"42900.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"56","quote_id":"10011","date":"2013-09-07 00:00:00","type":"service","item_id":"0","service_id":"36","item_name":"F&B Plexcloud Server-based Software System","item_description":"- Lifetime License\\n- Central F&B Item Management\\n- Central Price Management\\n- Central Branch\\/Stall Management\\n- Central Reporting System","discount":"0","discount_type":null,"qty":"1","price_per_unit":"10000.0000","price":"10000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"57","quote_id":"10011","date":"2013-09-07 00:00:00","type":"service","item_id":"0","service_id":"35","item_name":"Deployment & Installation Fees","item_description":"- Wireless Hardware & Configuration\\n- POS Configuration","discount":"0","discount_type":null,"qty":"1","price_per_unit":"2000.0000","price":"2000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"77":{"id":"77","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"All-In-One POS","model_no":"","warranty":"","sku":"POS01231","sku2":"","sku3":"","sku4":"","qty":null,"alert_quantity":"0","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4000.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2013-09-06 22:41:18","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":"1378478478","order":null,"warehouse_id":"1"}},"services":{"36":{"id":"36","name":"F&B Plexcloud Hardwares","description":"All-in-one-POS ( MSI Touch Screen)\\n3 Thermal Printers\\n1 Cash Drawer\\n1 Ipod Touch","category":"0","subcategory":"0","cost":"4979.00","price":"5000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-07-16 20:48:43","added_by":"admin2","modified_on":"2013-07-16 20:52:02","modified_by":"admin2","warehouse_id":"0"},"35":{"id":"35","name":"Plexcloud Sales System","description":"System for Business module\\n- Contacts Module\\n- Sales Module\\n- Services Module\\n\\nThis system is an auto-generated system for ease of creating, Quotation, Invoices, Sales Order, Delivery Orders, Credit Note.\\n\\nThe charges of the System is RM 350 \\/ mo","category":"0","subcategory":"0","cost":"0.00","price":"350.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-17 11:12:49","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-09-06 22:51:16', 'admin'),
(433, 'contacts', 'add', 'contact', 1136, '{"id":"1136","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Amanila","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"Kuala Lumpur","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"amalina.amir@yahoo.com.my","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-10-22 12:28:03","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1382416083"}', '2013-10-22 12:28:03', 'admin2'),
(434, 'contacts', 'edit', 'contact', 1136, '{"id":"1136","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Amalina","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"Kuala Lumpur","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"amalina.amir@yahoo.com.my","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-10-22 12:28:03","added_by":"admin2","modified_on":"2013-10-22 12:28:47","modified_by":"admin2","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1382416127"}', '2013-10-22 12:28:47', 'admin2'),
(435, 'contacts', 'edit', 'contact', 1136, '{"id":"1136","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Amalina","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"Shah Alam","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"amalina.amir@yahoo.com.my","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-10-22 12:28:03","added_by":"admin2","modified_on":"2013-10-22 12:29:42","modified_by":"admin2","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1382416182"}', '2013-10-22 12:29:42', 'admin2'),
(436, 'sales', 'add', 'quote', 10012, '{"id":"10012","txn_no":"1-10011","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-10-22 00:00:00","due_date":"2013-11-22 00:00:00","contact_person":"JawiHerbShop ","payment_date":null,"received_date":null,"contact":"Amalina","contact_id":"1136","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Shah Alam\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Amalina\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Shah Alam\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-10-22 12:30:50","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"58","quote_id":"10012","date":"2013-10-22 00:00:00","type":"service","item_id":"0","service_id":"39","item_name":"Plexsol Property","item_description":"","discount":"0","discount_type":null,"qty":"1","price_per_unit":"1000.0000","price":"1000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"59","quote_id":"10012","date":"2013-10-22 00:00:00","type":"service","item_id":"0","service_id":"38","item_name":"Plexsol Simple E-commerce","item_description":"","discount":"0","discount_type":null,"qty":"1","price_per_unit":"1000.0000","price":"1000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"39":{"id":"39","name":"Plexsol Property","description":"","category":"0","subcategory":"0","cost":"800.00","price":"1000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-22 12:26:47","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"0"},"38":{"id":"38","name":"Plexsol Simple E-commerce","description":"","category":"0","subcategory":"0","cost":"800.00","price":"1000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-22 12:26:29","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-10-22 12:30:50', 'admin2'),
(437, 'sales', 'edit', 'quote', 10012, '{"id":"10012","txn_no":"1-10011","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-10-22 00:00:00","due_date":"2013-11-22 00:00:00","contact_person":"","payment_date":null,"received_date":null,"contact":"Amalina","contact_id":"1136","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Shah Alam\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Amalina\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Shah Alam\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-10-22 12:30:50","added_by":"admin2","modified_on":"2013-10-22 12:31:26","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"60","quote_id":"10012","date":"2013-10-22 00:00:00","type":"service","item_id":"0","service_id":"39","item_name":"Plexsol Property","item_description":"","discount":"0","discount_type":null,"qty":"1","price_per_unit":"1000.0000","price":"1000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"61","quote_id":"10012","date":"2013-10-22 00:00:00","type":"service","item_id":"0","service_id":"38","item_name":"Plexsol Simple E-commerce","item_description":"","discount":"0","discount_type":null,"qty":"1","price_per_unit":"1000.0000","price":"1000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"38":{"id":"38","name":"Plexsol Simple E-commerce","description":"","category":"0","subcategory":"0","cost":"800.00","price":"1000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-22 12:26:29","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"0"},"39":{"id":"39","name":"Plexsol Property","description":"","category":"0","subcategory":"0","cost":"800.00","price":"1000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-22 12:26:47","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-10-22 12:31:26', 'admin2'),
(438, 'contacts', 'edit', 'contact', 1136, '{"id":"1136","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Amalina","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"Shah Alam","state":"Kuala Lumpur","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"amalina.amir@yahoo.com.my","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-10-22 12:28:03","added_by":"admin2","modified_on":"2013-10-22 12:32:14","modified_by":"admin2","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1382416334"}', '2013-10-22 12:32:14', 'admin2'),
(439, 'sales', 'delete', 'quote', 10012, '{"id":"10012","txn_no":"1-10011","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-10-22 00:00:00","due_date":"2013-11-22 00:00:00","contact_person":"","payment_date":null,"received_date":null,"contact":"Amalina","contact_id":"1136","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Shah Alam\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Amalina\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Shah Alam\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-10-22 12:30:50","added_by":"admin2","modified_on":"2013-10-22 12:31:26","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"60","quote_id":"10012","date":"2013-10-22 00:00:00","type":"service","item_id":"0","service_id":"39","item_name":"Plexsol Property","item_description":"","discount":"0","discount_type":null,"qty":"1","price_per_unit":"1000.0000","price":"1000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"61","quote_id":"10012","date":"2013-10-22 00:00:00","type":"service","item_id":"0","service_id":"38","item_name":"Plexsol Simple E-commerce","item_description":"","discount":"0","discount_type":null,"qty":"1","price_per_unit":"1000.0000","price":"1000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"38":{"id":"38","name":"Plexsol Simple E-commerce","description":"","category":"0","subcategory":"0","cost":"800.00","price":"1000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-22 12:26:29","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"0"},"39":{"id":"39","name":"Plexsol Property","description":"","category":"0","subcategory":"0","cost":"800.00","price":"1000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-22 12:26:47","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-10-22 12:32:41', 'admin2');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(440, 'sales', 'add', 'quote', 10013, '{"id":"10013","txn_no":"1-10011","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-10-22 00:00:00","due_date":"2013-11-22 00:00:00","contact_person":"","payment_date":null,"received_date":null,"contact":"Amalina","contact_id":"1136","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Shah Alam\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Amalina\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Shah Alam\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-10-22 12:33:30","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"62","quote_id":"10013","date":"2013-10-22 00:00:00","type":"service","item_id":"0","service_id":"39","item_name":"Plexsol Property","item_description":"","discount":"0","discount_type":null,"qty":"1","price_per_unit":"1000.0000","price":"1000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"63","quote_id":"10013","date":"2013-10-22 00:00:00","type":"service","item_id":"0","service_id":"38","item_name":"Plexsol Simple E-commerce","item_description":"","discount":"0","discount_type":null,"qty":"1","price_per_unit":"1000.0000","price":"1000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"38":{"id":"38","name":"Plexsol Simple E-commerce","description":"","category":"0","subcategory":"0","cost":"800.00","price":"1000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-22 12:26:29","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"0"},"39":{"id":"39","name":"Plexsol Property","description":"","category":"0","subcategory":"0","cost":"800.00","price":"1000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-22 12:26:47","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-10-22 12:33:30', 'admin2'),
(441, 'contacts', 'add', 'contact', 1137, '{"id":"1137","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"?Expert Strategies Analysis Sdn Bhd","company_registration":"986403-A","contact_person":"Teh Chai Soon","contact_number":"012-4849490","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"3-92, D''Piazza Mall","address2":"Jalan Mahsuri","city":"Bayan Lepas","state":"Pulau Pinang","zipcode":"11900","country":"Malaysia","tel":"","fax":"","general_email":"royce_teh@gmail.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-10-24 23:51:21","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1382629881"}', '2013-10-24 23:51:22', 'admin'),
(442, 'contacts', 'edit', 'contact', 1137, '{"id":"1137","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Expert Strategies Analysis Sdn Bhd","company_registration":"986403-A","contact_person":"Teh Chai Soon","contact_number":"012-4849490","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"3-92, D''Piazza Mall","address2":"Jalan Mahsuri","city":"Bayan Lepas","state":"Pulau Pinang","zipcode":"11900","country":"Malaysia","tel":"","fax":"","general_email":"royce_teh@gmail.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-10-24 23:51:21","added_by":"admin","modified_on":"2013-10-24 23:52:52","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1382629972"}', '2013-10-24 23:52:52', 'admin'),
(443, 'sales', 'add', 'quote', 10014, '{"id":"10014","txn_no":"1-10012","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-10-25 00:00:00","due_date":"2013-11-25 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Expert Strategies Analysis Sdn Bhd","contact_id":"1137","contact_address":"{\\"address1\\":\\"3-92, D''Piazza Mall\\",\\"address2\\":\\"Jalan Mahsuri\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Expert Strategies Analysis Sdn Bhd\\",\\"mobile\\":\\"012-4849490\\",\\"address1\\":\\"3-92, D''Piazza Mall\\",\\"address2\\":\\"Jalan Mahsuri\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"Project will be carried out in two phases with 1 month duration for each phase\\n\\nPhase 1: Web Portal\\nPhase 2: Membership & Referral System","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-10-25 00:26:49","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"64","quote_id":"10014","date":"2013-10-25 00:00:00","type":"service","item_id":"0","service_id":"40","item_name":"Cloud Membership & Referral System","item_description":"Cloud Information\\n - RAM scale up to 4GB\\n - Dedicated Server\\n - Hosted on RackSpace\\n - Linux \\n\\nDeliverables\\n----------------\\nWeb Portal\\n - Banner Design\\n - Custom Layout\\n - Content Writeup\\n - Forum \\n - SSL Certificate\\n \\nMembership & Referral System\\n - Customised features\\n - Payment-Gateway Ready [ We support both ipay88 and MolPay ]\\n\\nService\\n - 50 man hours per month [ Additional hour will be charged RM40\\/hour ]\\n\\nAnnual Cost [ Waived for the first year ]\\n - Domain [RM 50.00] \\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"40":{"id":"40","name":"Membership & Referral System","description":"Website\\n\\n","category":"0","subcategory":"0","cost":"1000.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-25 00:08:41","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-10-25 00:26:49', 'admin'),
(444, 'sales', 'edit', 'quote', 10014, '{"id":"10014","txn_no":"1-10012","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-10-25 00:00:00","due_date":"2013-11-25 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Expert Strategies Analysis Sdn Bhd","contact_id":"1137","contact_address":"{\\"address1\\":\\"3-92, D''Piazza Mall\\",\\"address2\\":\\"Jalan Mahsuri\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Expert Strategies Analysis Sdn Bhd\\",\\"mobile\\":\\"012-4849490\\",\\"address1\\":\\"3-92, D''Piazza Mall\\",\\"address2\\":\\"Jalan Mahsuri\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"The aforementioned price is for a year. We expect monthly paid out which is RM2500\\/month\\n\\nProject will be carried out in two phases with 1 month duration for each phase\\n\\nPhase 1: Web Portal\\nPhase 2: Membership & Referral System\\n\\nMinimum 1 year contract","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"30000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-10-25 00:26:49","added_by":"admin","modified_on":"2013-10-25 00:36:47","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"65","quote_id":"10014","date":"2013-10-25 00:00:00","type":"service","item_id":"0","service_id":"40","item_name":"Cloud Membership & Referral System","item_description":"Cloud Information\\n- RAM scale up to 4GB\\n- Dedicated Server\\n- Hosted on RackSpace\\n- Linux \\nDeliverables\\n----------------\\nWeb Portal\\n- Banner Design\\n- Custom Layout\\n- Content Writeup\\n- Forum \\n- SSL Certificate\\nMembership & Referral System\\n- Customised features\\n- Payment-Gateway Ready [ We support both ipay88 and MolPay ]\\nService\\n- 50 man hours per month [ Additional hour will be charged RM40\\/hour ]\\nAnnual Cost [ Waived for th","discount":"0","discount_type":null,"qty":"1","price_per_unit":"30000.0000","price":"30000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"40":{"id":"40","name":"Cloud Membership & Referral System","description":"Cloud Information\\n- RAM scale up to 4GB\\n- Dedicated Server\\n- Hosted on RackSpace\\n- Linux \\nDeliverables\\n----------------\\nWeb Portal\\n- Banner Design\\n- Custom Layout\\n- Content Writeup\\n- Forum \\n- SSL Certificate\\nMembership & Referral System\\n- Customised features\\n- Payment-Gateway Ready [ We support both ipay88 and MolPay ]\\nService\\n- 50 man hours per month [ Additional hour will be charged RM40\\/hour ]\\nAnnual Cost [ Waived for th","category":"0","subcategory":"0","cost":"1000.00","price":"30000.00","last_tendered":null,"remarks":"RM2500 Monthly","tags":null,"added_on":"2013-10-25 00:08:41","added_by":"admin","modified_on":"2013-10-25 00:34:13","modified_by":"admin","warehouse_id":"0"}}}', '2013-10-25 00:36:47', 'admin'),
(445, 'sales', 'edit', 'quote', 10014, '{"id":"10014","txn_no":"1-10012","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-10-25 00:00:00","due_date":"2013-11-25 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Expert Strategies Analysis Sdn Bhd","contact_id":"1137","contact_address":"{\\"address1\\":\\"3-92, D''Piazza Mall\\",\\"address2\\":\\"Jalan Mahsuri\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Expert Strategies Analysis Sdn Bhd\\",\\"mobile\\":\\"012-4849490\\",\\"address1\\":\\"3-92, D''Piazza Mall\\",\\"address2\\":\\"Jalan Mahsuri\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"The aforementioned price is for a year. We expect monthly paid out which is RM2500\\/month\\n\\nProject will be carried out in two phases with 1 month duration for each phase\\n\\nPhase 1: Web Portal\\nPhase 2: Membership & Referral System\\n\\nMinimum 1 year contract","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"30000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-10-25 00:26:49","added_by":"admin","modified_on":"2013-10-25 00:37:38","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"66","quote_id":"10014","date":"2013-10-25 00:00:00","type":"service","item_id":"0","service_id":"40","item_name":"Cloud Membership & Referral System","item_description":"Cloud Information\\n- RAM scale up to 4GB\\n- Dedicated Server\\n- Hosted on RackSpace\\n- Linux \\n\\nDeliverables\\n----------------\\n\\nWeb Portal\\n- Banner Design\\n- Custom Layout\\n- Content Writeup\\n- Forum \\n- SSL Certificate\\n\\nMembership & Referral System\\n- Customised features\\n- Customised reports and charts\\n- Payment-Gateway Ready [ We support both ipay88 and MolPay ]\\nService\\n- 50 man hours per month [ Additional hour will be charged RM40\\/hour ]\\n\\nAnnual Cost [ Waived for the first year]\\n- RM50\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"30000.0000","price":"30000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"40":{"id":"40","name":"Cloud Membership & Referral System","description":"Cloud Information\\n- RAM scale up to 4GB\\n- Dedicated Server\\n- Hosted on RackSpace\\n- Linux \\nDeliverables\\n----------------\\nWeb Portal\\n- Banner Design\\n- Custom Layout\\n- Content Writeup\\n- Forum \\n- SSL Certificate\\nMembership & Referral System\\n- Customised features\\n- Payment-Gateway Ready [ We support both ipay88 and MolPay ]\\nService\\n- 50 man hours per month [ Additional hour will be charged RM40\\/hour ]\\nAnnual Cost [ Waived for th","category":"0","subcategory":"0","cost":"1000.00","price":"30000.00","last_tendered":null,"remarks":"RM2500 Monthly","tags":null,"added_on":"2013-10-25 00:08:41","added_by":"admin","modified_on":"2013-10-25 00:34:13","modified_by":"admin","warehouse_id":"0"}}}', '2013-10-25 00:37:38', 'admin'),
(446, 'sales', 'edit', 'quote', 10014, '{"id":"10014","txn_no":"1-10012","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-10-25 00:00:00","due_date":"2013-11-25 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Expert Strategies Analysis Sdn Bhd","contact_id":"1137","contact_address":"{\\"address1\\":\\"3-92, D''Piazza Mall\\",\\"address2\\":\\"Jalan Mahsuri\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Expert Strategies Analysis Sdn Bhd\\",\\"mobile\\":\\"012-4849490\\",\\"address1\\":\\"3-92, D''Piazza Mall\\",\\"address2\\":\\"Jalan Mahsuri\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"30000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-10-25 00:26:49","added_by":"admin","modified_on":"2013-10-25 13:03:50","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"67","quote_id":"10014","date":"2013-10-25 00:00:00","type":"service","item_id":"0","service_id":"40","item_name":"Cloud Membership & Referral System","item_description":"Cloud Information\\n- 1GB RAM Scalable to 32GB (Charges vary on Configuration)\\n- Cloud Virtual Private Server \\n- Linux Ubuntu\\n\\nDeliverables\\n----------------\\n\\nWeb Portal\\n- Banner Design\\n- Up to 20 Pages Design\\n- Content Writeup up to 4000 Words\\n- Forum \\n\\nMembership & Referral System\\n- Commission Module\\n- Report and Charting Module\\n- Membership & Referral Module\\n- Payment-Gateway Ready \\n- Member Hierarchal Module\\n \\nService\\n- 50 man hours per month [ Additional hour will be charged RM40\\/hour ]\\n\\nQuoted price can be converted to term payment for 12 months for RM2500","discount":"0","discount_type":null,"qty":"1","price_per_unit":"30000.0000","price":"30000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"40":{"id":"40","name":"Cloud Membership & Referral System","description":"Cloud Information\\n- RAM scale up to 4GB\\n- Dedicated Server\\n- Hosted on RackSpace\\n- Linux \\nDeliverables\\n----------------\\nWeb Portal\\n- Banner Design\\n- Custom Layout\\n- Content Writeup\\n- Forum \\n- SSL Certificate\\nMembership & Referral System\\n- Customised features\\n- Payment-Gateway Ready [ We support both ipay88 and MolPay ]\\nService\\n- 50 man hours per month [ Additional hour will be charged RM40\\/hour ]\\nAnnual Cost [ Waived for th","category":"0","subcategory":"0","cost":"1000.00","price":"30000.00","last_tendered":null,"remarks":"RM2500 Monthly","tags":null,"added_on":"2013-10-25 00:08:41","added_by":"admin","modified_on":"2013-10-25 00:34:13","modified_by":"admin","warehouse_id":"0"}}}', '2013-10-25 13:03:50', 'admin'),
(447, 'sales', 'edit', 'quote', 10014, '{"id":"10014","txn_no":"1-10012","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-10-25 00:00:00","due_date":"2013-11-25 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Expert Strategies Analysis Sdn Bhd","contact_id":"1137","contact_address":"{\\"address1\\":\\"3-92, D''Piazza Mall\\",\\"address2\\":\\"Jalan Mahsuri\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Expert Strategies Analysis Sdn Bhd\\",\\"mobile\\":\\"012-4849490\\",\\"address1\\":\\"3-92, D''Piazza Mall\\",\\"address2\\":\\"Jalan Mahsuri\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"30000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-10-25 00:26:49","added_by":"admin","modified_on":"2013-10-25 13:09:59","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"68","quote_id":"10014","date":"2013-10-25 00:00:00","type":"service","item_id":"0","service_id":"40","item_name":"Cloud Membership & Referral System","item_description":"Cloud Information\\n- 1GB RAM Scalable to 32GB (Charges vary on Configuration)\\n- Cloud Virtual Private Server \\n- Linux Ubuntu\\n\\nDeliverables\\n----------------\\n\\nWeb Portal\\n- Banner Design\\n- Up to 20 Pages Design\\n- Content Writeup up to 4000 Words\\n- Forum \\n\\nMembership & Referral System\\n- Commission Module\\n- Report and Charting Module\\n- Membership & Referral Module\\n- Payment-Gateway Ready \\n- Member Hierarchal Module\\n \\nService\\n- 50 man hours per month [ Additional hour will be charged RM40\\/hour ]\\n\\nQuoted price can be converted to term payment for 12 months for RM2500","discount":"0","discount_type":null,"qty":"1","price_per_unit":"30000.0000","price":"30000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"69","quote_id":"10014","date":"2013-10-25 00:00:00","type":"service","item_id":"0","service_id":"41","item_name":"Domain Annual Fee","item_description":"Waived for 1st year","discount":"100","discount_type":"p","qty":"1","price_per_unit":"50.0000","price":"50.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"70","quote_id":"10014","date":"2013-10-25 00:00:00","type":"service","item_id":"0","service_id":"42","item_name":"Extended Validation(Green Bar) SSL Certificate","item_description":"Waived for 1st year","discount":"100","discount_type":"p","qty":"1","price_per_unit":"500.0000","price":"500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"40":{"id":"40","name":"Cloud Membership & Referral System","description":"Cloud Information\\n- RAM scale up to 4GB\\n- Dedicated Server\\n- Hosted on RackSpace\\n- Linux \\nDeliverables\\n----------------\\nWeb Portal\\n- Banner Design\\n- Custom Layout\\n- Content Writeup\\n- Forum \\n- SSL Certificate\\nMembership & Referral System\\n- Customised features\\n- Payment-Gateway Ready [ We support both ipay88 and MolPay ]\\nService\\n- 50 man hours per month [ Additional hour will be charged RM40\\/hour ]\\nAnnual Cost [ Waived for th","category":"0","subcategory":"0","cost":"1000.00","price":"30000.00","last_tendered":null,"remarks":"RM2500 Monthly","tags":null,"added_on":"2013-10-25 00:08:41","added_by":"admin","modified_on":"2013-10-25 00:34:13","modified_by":"admin","warehouse_id":"0"},"41":{"id":"41","name":"Domain Annual Fee","description":"","category":"0","subcategory":"0","cost":"40.00","price":"50.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-25 13:05:01","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"},"42":{"id":"42","name":"Extended Validation(Green Bar) SSL Certificate","description":"","category":"0","subcategory":"0","cost":"0.00","price":"500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-25 13:06:26","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-10-25 13:10:00', 'admin'),
(448, 'sales', 'edit', 'quote', 10014, '{"id":"10014","txn_no":"1-10012","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-10-26 00:00:00","due_date":"2013-11-26 00:00:00","contact_person":"Azad Affif Ishak","payment_date":null,"received_date":null,"contact":"Expert Strategies Analysis Sdn Bhd","contact_id":"1137","contact_address":"{\\"address1\\":\\"3-92, D''Piazza Mall\\",\\"address2\\":\\"Jalan Mahsuri\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Expert Strategies Analysis Sdn Bhd\\",\\"mobile\\":\\"012-4849490\\",\\"address1\\":\\"3-92, D''Piazza Mall\\",\\"address2\\":\\"Jalan Mahsuri\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"30050.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-10-25 00:26:49","added_by":"admin","modified_on":"2013-10-26 07:34:50","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"71","quote_id":"10014","date":"2013-10-26 00:00:00","type":"service","item_id":"0","service_id":"40","item_name":"Cloud Membership & Referral System","item_description":"Cloud Information\\n- 1GB RAM Scalable to 32GB (Charges vary on Configuration)\\n- Cloud Virtual Private Server \\n- Linux Ubuntu\\n\\nDeliverables\\n----------------\\n\\nWeb Portal\\n- Banner Design\\n- Up to 20 Pages Design\\n- Content Writeup up to 4000 Words\\n- Forum \\n\\nMembership & Referral System\\n- Commission Module\\n- Report and Charting Module\\n- Membership & Referral Module\\n- Payment-Gateway Ready \\n- Member Hierarchal Module\\n \\nService\\n- 50 man hours per month [ Additional hour will be charged RM40\\/hour ]\\n\\nQuoted price can be converted to term payment for 12 months for RM2500","discount":"0","discount_type":null,"qty":"1","price_per_unit":"30000.0000","price":"30000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"72","quote_id":"10014","date":"2013-10-26 00:00:00","type":"service","item_id":"0","service_id":"41","item_name":"Domain Annual Fee","item_description":"Waived for 1st year","discount":"100","discount_type":null,"qty":"1","price_per_unit":"50.0000","price":"50.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"73","quote_id":"10014","date":"2013-10-26 00:00:00","type":"service","item_id":"0","service_id":"42","item_name":"Extended Validation(Green Bar) SSL Certificate Annual Fee","item_description":"Waived for 1st year","discount":"100","discount_type":"p","qty":"1","price_per_unit":"500.0000","price":"500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"41":{"id":"41","name":"Domain Annual Fee","description":"","category":"0","subcategory":"0","cost":"40.00","price":"50.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-25 13:05:01","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"},"42":{"id":"42","name":"Extended Validation(Green Bar) SSL Certificate","description":"","category":"0","subcategory":"0","cost":"0.00","price":"500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-25 13:06:26","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"},"40":{"id":"40","name":"Cloud Membership & Referral System","description":"Cloud Information\\n- RAM scale up to 4GB\\n- Dedicated Server\\n- Hosted on RackSpace\\n- Linux \\nDeliverables\\n----------------\\nWeb Portal\\n- Banner Design\\n- Custom Layout\\n- Content Writeup\\n- Forum \\n- SSL Certificate\\nMembership & Referral System\\n- Customised features\\n- Payment-Gateway Ready [ We support both ipay88 and MolPay ]\\nService\\n- 50 man hours per month [ Additional hour will be charged RM40\\/hour ]\\nAnnual Cost [ Waived for th","category":"0","subcategory":"0","cost":"1000.00","price":"30000.00","last_tendered":null,"remarks":"RM2500 Monthly","tags":null,"added_on":"2013-10-25 00:08:41","added_by":"admin","modified_on":"2013-10-25 00:34:13","modified_by":"admin","warehouse_id":"0"}}}', '2013-10-26 07:34:50', 'admin'),
(449, 'sales', 'edit', 'quote', 10014, '{"id":"10014","txn_no":"1-10012","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-10-26 00:00:00","due_date":"2013-11-26 00:00:00","contact_person":"Azad Affif Ishak","payment_date":null,"received_date":null,"contact":"Expert Strategies Analysis Sdn Bhd","contact_id":"1137","contact_address":"{\\"address1\\":\\"3-92, D''Piazza Mall\\",\\"address2\\":\\"Jalan Mahsuri\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Expert Strategies Analysis Sdn Bhd\\",\\"mobile\\":\\"012-4849490\\",\\"address1\\":\\"3-92, D''Piazza Mall\\",\\"address2\\":\\"Jalan Mahsuri\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"This is a Software as a service(SaaS) based system","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"30050.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-10-25 00:26:49","added_by":"admin","modified_on":"2013-10-26 07:46:12","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"74","quote_id":"10014","date":"2013-10-26 00:00:00","type":"service","item_id":"0","service_id":"40","item_name":"Cloud Membership & Referral System","item_description":"Cloud Information\\n- 1GB RAM Scalable to 32GB (Charges vary on Configuration)\\n- Cloud Virtual Private Server \\n- Linux Ubuntu\\n\\nDeliverables\\n----------------\\n\\nWeb Portal\\n- Banner Design\\n- Up to 20 Pages Design\\n- Content Writeup up to 4000 Words\\n- Forum \\n\\nMembership & Referral System\\n- Commission Module\\n- Report and Charting Module\\n- Membership & Referral Module\\n- Payment-Gateway Ready \\n- Member Hierarchal Module\\n \\nService\\n- 50 man hours per month [ Additional hour will be charged RM40\\/hour ]\\n\\nQuoted price can be converted to term payment for 12 months for RM2500","discount":"0","discount_type":null,"qty":"1","price_per_unit":"30000.0000","price":"30000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"75","quote_id":"10014","date":"2013-10-26 00:00:00","type":"service","item_id":"0","service_id":"41","item_name":"Domain Annual Fee","item_description":"Waived for 1st year","discount":"100","discount_type":null,"qty":"1","price_per_unit":"50.0000","price":"50.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"76","quote_id":"10014","date":"2013-10-26 00:00:00","type":"service","item_id":"0","service_id":"42","item_name":"Extended Validation(Green Bar) SSL Certificate Annual Fee","item_description":"Waived for 1st year","discount":"100","discount_type":"p","qty":"1","price_per_unit":"500.0000","price":"500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"40":{"id":"40","name":"Cloud Membership & Referral System","description":"Cloud Information\\n- RAM scale up to 4GB\\n- Dedicated Server\\n- Hosted on RackSpace\\n- Linux \\nDeliverables\\n----------------\\nWeb Portal\\n- Banner Design\\n- Custom Layout\\n- Content Writeup\\n- Forum \\n- SSL Certificate\\nMembership & Referral System\\n- Customised features\\n- Payment-Gateway Ready [ We support both ipay88 and MolPay ]\\nService\\n- 50 man hours per month [ Additional hour will be charged RM40\\/hour ]\\nAnnual Cost [ Waived for th","category":"0","subcategory":"0","cost":"1000.00","price":"30000.00","last_tendered":null,"remarks":"RM2500 Monthly","tags":null,"added_on":"2013-10-25 00:08:41","added_by":"admin","modified_on":"2013-10-25 00:34:13","modified_by":"admin","warehouse_id":"0"},"41":{"id":"41","name":"Domain Annual Fee","description":"","category":"0","subcategory":"0","cost":"40.00","price":"50.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-25 13:05:01","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"},"42":{"id":"42","name":"Extended Validation(Green Bar) SSL Certificate","description":"","category":"0","subcategory":"0","cost":"0.00","price":"500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-25 13:06:26","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-10-26 07:46:13', 'admin'),
(450, 'sales', 'edit', 'quote', 10014, '{"id":"10014","txn_no":"1-10012","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-10-26 00:00:00","due_date":"2013-11-26 00:00:00","contact_person":"Azad Affif Ishak","payment_date":null,"received_date":null,"contact":"Expert Strategies Analysis Sdn Bhd","contact_id":"1137","contact_address":"{\\"address1\\":\\"3-92, D''Piazza Mall\\",\\"address2\\":\\"Jalan Mahsuri\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Expert Strategies Analysis Sdn Bhd\\",\\"mobile\\":\\"012-4849490\\",\\"address1\\":\\"3-92, D''Piazza Mall\\",\\"address2\\":\\"Jalan Mahsuri\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"This is a Software as a service(SaaS) based system","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"30000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-10-25 00:26:49","added_by":"admin","modified_on":"2013-10-26 07:47:34","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"77","quote_id":"10014","date":"2013-10-26 00:00:00","type":"service","item_id":"0","service_id":"40","item_name":"Cloud Membership & Referral System","item_description":"Cloud Information\\n- 1GB RAM Scalable to 32GB (Charges vary on Configuration)\\n- Cloud Virtual Private Server \\n- Linux Ubuntu\\n\\nDeliverables\\n----------------\\n\\nWeb Portal\\n- Banner Design\\n- Up to 20 Pages Design\\n- Content Writeup up to 4000 Words\\n- Forum \\n\\nMembership & Referral System\\n- Commission Module\\n- Report and Charting Module\\n- Membership & Referral Module\\n- Payment-Gateway Ready \\n- Member Hierarchal Module\\n \\nService\\n- 50 man hours per month [ Additional hour will be charged RM40\\/hour ]\\n\\nQuoted price can be converted to term payment for 12 months for RM2500","discount":"0","discount_type":null,"qty":"1","price_per_unit":"30000.0000","price":"30000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"78","quote_id":"10014","date":"2013-10-26 00:00:00","type":"service","item_id":"0","service_id":"41","item_name":"Domain Annual Fee","item_description":"Waived for 1st year","discount":"100","discount_type":"p","qty":"1","price_per_unit":"50.0000","price":"50.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"79","quote_id":"10014","date":"2013-10-26 00:00:00","type":"service","item_id":"0","service_id":"42","item_name":"Extended Validation(Green Bar) SSL Certificate Annual Fee","item_description":"Waived for 1st year","discount":"100","discount_type":"p","qty":"1","price_per_unit":"500.0000","price":"500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"41":{"id":"41","name":"Domain Annual Fee","description":"","category":"0","subcategory":"0","cost":"40.00","price":"50.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-25 13:05:01","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"},"42":{"id":"42","name":"Extended Validation(Green Bar) SSL Certificate","description":"","category":"0","subcategory":"0","cost":"0.00","price":"500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-25 13:06:26","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"},"40":{"id":"40","name":"Cloud Membership & Referral System","description":"Cloud Information\\n- RAM scale up to 4GB\\n- Dedicated Server\\n- Hosted on RackSpace\\n- Linux \\nDeliverables\\n----------------\\nWeb Portal\\n- Banner Design\\n- Custom Layout\\n- Content Writeup\\n- Forum \\n- SSL Certificate\\nMembership & Referral System\\n- Customised features\\n- Payment-Gateway Ready [ We support both ipay88 and MolPay ]\\nService\\n- 50 man hours per month [ Additional hour will be charged RM40\\/hour ]\\nAnnual Cost [ Waived for th","category":"0","subcategory":"0","cost":"1000.00","price":"30000.00","last_tendered":null,"remarks":"RM2500 Monthly","tags":null,"added_on":"2013-10-25 00:08:41","added_by":"admin","modified_on":"2013-10-25 00:34:13","modified_by":"admin","warehouse_id":"0"}}}', '2013-10-26 07:47:34', 'admin'),
(451, 'contacts', 'add', 'contact', 1138, '{"id":"1138","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Beachfront Services Sdn. Bhd.","company_registration":"","contact_person":"Marvin Seow","contact_number":"0166337555","credit_limit":"0.00","rank":"0","email":"","ic":"163E-11-02","password":"","introducer_ic":null,"address1":"HUNZA TOWER","address2":"KELAWEI ROAD","city":"","state":"Pulau Pinang","zipcode":"10250","country":"Malaysia","tel":"04-2189 275","fax":"04-2288 277","general_email":"seowpm@hunzagroup.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-10-31 15:00:38","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1383202838"}', '2013-10-31 15:00:38', 'admin'),
(452, 'sales', 'add', 'quote', 10015, '{"id":"10015","txn_no":"1-10013","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-10-31 00:00:00","due_date":"2013-11-30 00:00:00","contact_person":"Marvin Seow","payment_date":null,"received_date":null,"contact":"Beachfront Services Sdn. Bhd.","contact_id":"1138","contact_address":"{\\"address1\\":\\"HUNZA TOWER\\",\\"address2\\":\\"KELAWEI ROAD\\",\\"zipcode\\":\\"10250\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Beachfront Services Sdn. Bhd.\\",\\"mobile\\":\\"04-2189 275\\",\\"address1\\":\\"HUNZA TOWER\\",\\"address2\\":\\"KELAWEI ROAD\\",\\"zipcode\\":\\"10250\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-10-31 15:01:27","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":null,"products":null,"services":null}', '2013-10-31 15:01:27', 'admin'),
(453, 'sales', 'edit', 'quote', 10015, '{"id":"10015","txn_no":"1-10013","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-10-31 00:00:00","due_date":"2013-11-30 00:00:00","contact_person":"Marvin Seow","payment_date":null,"received_date":null,"contact":"Beachfront Services Sdn. Bhd.","contact_id":"1138","contact_address":"{\\"address1\\":\\"HUNZA TOWER\\",\\"address2\\":\\"KELAWEI ROAD\\",\\"zipcode\\":\\"10250\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Beachfront Services Sdn. Bhd.\\",\\"mobile\\":\\"04-2189 275\\",\\"address1\\":\\"HUNZA TOWER\\",\\"address2\\":\\"KELAWEI ROAD\\",\\"zipcode\\":\\"10250\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"31800.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-10-31 15:01:27","added_by":"admin","modified_on":"2013-10-31 15:07:50","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"81","quote_id":"10015","date":"2013-10-31 00:00:00","type":"service","item_id":"0","service_id":"44","item_name":"Hardware and Software Solutions for Valet Parking","item_description":"Hardware Solutions\\n4 x (RM1920) Portable Thermal Printer \\n4 x (RM 1000) Portable Tablet \\/ Phone\\n1 x (RM2500) POS system\\n1 x (RM 650) Thermal Printer\\n1 x (RM 157) LINKSYS RE1000 W\\/L-N RANGE EXTENDER\\n4 x (RM 200) Wifi N Router(MIMO)\\n\\nWiring RM 500.00\\n\\nSoftware Solutions \\n1 Year Service Rental\\nSaaS RM 3,000.00 \\/ monthly","discount":"0","discount_type":null,"qty":"1","price_per_unit":"31800.0000","price":"31800.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"44":{"id":"44","name":"Hardware and Software Solutions for Valet Parking","description":"Hardware Solutions\\n4 x (RM1920) Portable Thermal Printer \\n4 x (RM 1000) Portable Tablet \\/ Phone\\n1 x (RM2500) POS system\\n1 x (RM 650) Thermal Printer\\n1 x (RM 157) LINKSYS RE1000 W\\/L-N RANGE EXTENDER\\n4 x (RM 200) Wifi N Router(MIMO)\\n\\nWiring RM 500.00\\n\\nSoftware Solutions \\n1 Year Service Rental\\nSaaS RM 3,000.00 \\/ monthly","category":"0","subcategory":"0","cost":"7800.00","price":"31800.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-31 15:06:20","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-10-31 15:07:50', 'admin'),
(454, 'sales', 'edit', 'quote', 10015, '{"id":"10015","txn_no":"1-10013","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-10-31 00:00:00","due_date":"2013-11-30 00:00:00","contact_person":"Marvin Seow","payment_date":null,"received_date":null,"contact":"Beachfront Services Sdn. Bhd.","contact_id":"1138","contact_address":"{\\"address1\\":\\"HUNZA TOWER\\",\\"address2\\":\\"KELAWEI ROAD\\",\\"zipcode\\":\\"10250\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Beachfront Services Sdn. Bhd.\\",\\"mobile\\":\\"04-2189 275\\",\\"address1\\":\\"HUNZA TOWER\\",\\"address2\\":\\"KELAWEI ROAD\\",\\"zipcode\\":\\"10250\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"31800.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-10-31 15:01:27","added_by":"admin","modified_on":"2013-11-01 11:19:28","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"82","quote_id":"10015","date":"2013-10-31 00:00:00","type":"service","item_id":"0","service_id":"44","item_name":"Hardwares","item_description":"4 units Portable Thermal Printer \\n4 units Handheld Device\\n1 unit Point-Of-Sale(POS) System\\n1 unit Cash Drawer\\n1 unit Thermal Printer\\n1 unit Host Computer\\n1 unit Wireless-N Router\\n3 units Wireless Extender\\n\\nFee is inclusive of installation fee\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"31800.0000","price":"31800.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"44":{"id":"44","name":"Hardware and Software Solutions for Valet Parking","description":"Hardware Solutions\\n4 x (RM1920) Portable Thermal Printer \\n4 x (RM 1000) Portable Tablet \\/ Phone\\n1 x (RM2500) POS system\\n1 x (RM 650) Thermal Printer\\n1 x (RM 157) LINKSYS RE1000 W\\/L-N RANGE EXTENDER\\n4 x (RM 200) Wifi N Router(MIMO)\\n\\nWiring RM 500.00\\n\\nSoftware Solutions \\n1 Year Service Rental\\nSaaS RM 3,000.00 \\/ monthly","category":"0","subcategory":"0","cost":"7800.00","price":"31800.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-31 15:06:20","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-11-01 11:19:28', 'admin'),
(455, 'sales', 'edit', 'quote', 10015, '{"id":"10015","txn_no":"1-10013","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-10-31 00:00:00","due_date":"2013-11-30 00:00:00","contact_person":"Marvin Seow","payment_date":null,"received_date":null,"contact":"Beachfront Services Sdn. Bhd.","contact_id":"1138","contact_address":"{\\"address1\\":\\"HUNZA TOWER\\",\\"address2\\":\\"KELAWEI ROAD\\",\\"zipcode\\":\\"10250\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Beachfront Services Sdn. Bhd.\\",\\"mobile\\":\\"04-2189 275\\",\\"address1\\":\\"HUNZA TOWER\\",\\"address2\\":\\"KELAWEI ROAD\\",\\"zipcode\\":\\"10250\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"56000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-10-31 15:01:27","added_by":"admin","modified_on":"2013-11-01 11:25:06","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"85","quote_id":"10015","date":"2013-10-31 00:00:00","type":"service","item_id":"0","service_id":"44","item_name":"Free Upgrade to Cloud Based System","item_description":"This will be deployed after 4 months of service","discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"44":{"id":"44","name":"Hardware and Software Solutions for Valet Parking","description":"Hardware Solutions\\n4 x (RM1920) Portable Thermal Printer \\n4 x (RM 1000) Portable Tablet \\/ Phone\\n1 x (RM2500) POS system\\n1 x (RM 650) Thermal Printer\\n1 x (RM 157) LINKSYS RE1000 W\\/L-N RANGE EXTENDER\\n4 x (RM 200) Wifi N Router(MIMO)\\n\\nWiring RM 500.00\\n\\nSoftware Solutions \\n1 Year Service Rental\\nSaaS RM 3,000.00 \\/ monthly","category":"0","subcategory":"0","cost":"7800.00","price":"31800.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-31 15:06:20","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-11-01 11:25:06', 'admin'),
(456, 'sales', 'add', 'quote', 10016, '{"id":"10016","txn_no":"1-10014","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-11-01 00:00:00","due_date":"2013-12-01 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Beachfront Services Sdn. Bhd.","contact_id":"1138","contact_address":"{\\"address1\\":\\"HUNZA TOWER\\",\\"address2\\":\\"KELAWEI ROAD\\",\\"zipcode\\":\\"10250\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Beachfront Services Sdn. Bhd.\\",\\"mobile\\":\\"04-2189 275\\",\\"address1\\":\\"HUNZA TOWER\\",\\"address2\\":\\"KELAWEI ROAD\\",\\"zipcode\\":\\"10250\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"56000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-11-01 11:39:22","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"86","quote_id":"10016","date":"2013-11-01 00:00:00","type":"service","item_id":"0","service_id":"44","item_name":"Hardwares ","item_description":"\\n4 units Portable Thermal Printer \\n4 units Portable Handheld Device\\n1 unit  Point of Sale Touch Screen\\n1 unit Cash Drawer\\n1 unit Thermal Printer\\n3 units WiFi Extender\\n1 unit Wiress N Router\\n\\nPrice is inclusive of installation fee","discount":"0","discount_type":null,"qty":"1","price_per_unit":"20000.0000","price":"20000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"87","quote_id":"10016","date":"2013-11-01 00:00:00","type":"service","item_id":"0","service_id":"45","item_name":"Parking System Software","item_description":"Quoted price can be converted to 12 months term payment for RM3000 monthly","discount":"0","discount_type":null,"qty":"1","price_per_unit":"36000.0000","price":"36000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"88","quote_id":"10016","date":"2013-11-01 00:00:00","type":"service","item_id":"0","service_id":"46","item_name":"Upgrade to Cloud Based System","item_description":"The upgrade will be deployed after 4 months of service","discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"44":{"id":"44","name":"Hardwares ","description":"\\n4 units Portable Thermal Printer \\n4 units Portable Handheld Device\\n1 unit  Point of Sale Touch Screen\\n1 unit Cash Drawer\\n1 unit Thermal Printer\\n3 units WiFi Extender\\n1 unit Wiress N Router\\n\\nPrice is inclusive of installation fee","category":"0","subcategory":"0","cost":"18921.00","price":"20000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-31 15:06:20","added_by":"admin","modified_on":"2013-11-01 11:33:20","modified_by":"admin","warehouse_id":"0"},"45":{"id":"45","name":"Parking System Software","description":"Quoted price can be converted to 12 months term payment for RM3000 monthly","category":"0","subcategory":"0","cost":"36000.00","price":"36000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-11-01 11:35:11","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"},"46":{"id":"46","name":"Upgrade to Cloud Based System","description":"The upgrade will be deployed after 4 months of service","category":"0","subcategory":"0","cost":"0.00","price":"0.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-11-01 11:36:10","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-11-01 11:39:22', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(457, 'sales', 'edit', 'quote', 10016, '{"id":"10016","txn_no":"1-10014","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-11-01 00:00:00","due_date":"2013-12-01 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Beachfront Services Sdn. Bhd.","contact_id":"1138","contact_address":"{\\"address1\\":\\"HUNZA TOWER\\",\\"address2\\":\\"KELAWEI ROAD\\",\\"zipcode\\":\\"10250\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Beachfront Services Sdn. Bhd.\\",\\"mobile\\":\\"04-2189 275\\",\\"address1\\":\\"HUNZA TOWER\\",\\"address2\\":\\"KELAWEI ROAD\\",\\"zipcode\\":\\"10250\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"56000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-11-01 11:39:22","added_by":"admin","modified_on":"2013-11-01 11:40:12","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"89","quote_id":"10016","date":"2013-11-01 00:00:00","type":"service","item_id":"0","service_id":"44","item_name":"Hardwares ","item_description":"4 units Portable Thermal Printer \\n4 units Portable Handheld Device\\n1 unit  Point of Sale Touch Screen\\n1 unit Cash Drawer\\n1 unit Thermal Printer\\n3 units WiFi Extender\\n1 unit Wiress N Router\\n\\nPrice is inclusive of installation fee","discount":"0","discount_type":null,"qty":"1","price_per_unit":"20000.0000","price":"20000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"90","quote_id":"10016","date":"2013-11-01 00:00:00","type":"service","item_id":"0","service_id":"45","item_name":"Parking System Software","item_description":"Quoted price can be converted to 12 months term payment for RM3000 monthly","discount":"0","discount_type":null,"qty":"1","price_per_unit":"36000.0000","price":"36000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"91","quote_id":"10016","date":"2013-11-01 00:00:00","type":"service","item_id":"0","service_id":"46","item_name":"Upgrade to Cloud Based System","item_description":"The upgrade will be deployed after 4 months of service","discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"45":{"id":"45","name":"Parking System Software","description":"Quoted price can be converted to 12 months term payment for RM3000 monthly","category":"0","subcategory":"0","cost":"36000.00","price":"36000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-11-01 11:35:11","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"},"46":{"id":"46","name":"Upgrade to Cloud Based System","description":"The upgrade will be deployed after 4 months of service","category":"0","subcategory":"0","cost":"0.00","price":"0.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-11-01 11:36:10","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"},"44":{"id":"44","name":"Hardwares ","description":"\\n4 units Portable Thermal Printer \\n4 units Portable Handheld Device\\n1 unit  Point of Sale Touch Screen\\n1 unit Cash Drawer\\n1 unit Thermal Printer\\n3 units WiFi Extender\\n1 unit Wiress N Router\\n\\nPrice is inclusive of installation fee","category":"0","subcategory":"0","cost":"18921.00","price":"20000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-31 15:06:20","added_by":"admin","modified_on":"2013-11-01 11:33:20","modified_by":"admin","warehouse_id":"0"}}}', '2013-11-01 11:40:12', 'admin'),
(458, 'sales', 'edit', 'quote', 10016, '{"id":"10016","txn_no":"1-10014","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-11-01 00:00:00","due_date":"2013-12-01 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Beachfront Services Sdn. Bhd.","contact_id":"1138","contact_address":"{\\"address1\\":\\"HUNZA TOWER\\",\\"address2\\":\\"KELAWEI ROAD\\",\\"zipcode\\":\\"10250\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Beachfront Services Sdn. Bhd.\\",\\"mobile\\":\\"04-2189 275\\",\\"address1\\":\\"HUNZA TOWER\\",\\"address2\\":\\"KELAWEI ROAD\\",\\"zipcode\\":\\"10250\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"This quotation is for Software as a service (Saas) solution","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"56000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-11-01 11:39:22","added_by":"admin","modified_on":"2013-11-01 11:40:53","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"92","quote_id":"10016","date":"2013-11-01 00:00:00","type":"service","item_id":"0","service_id":"44","item_name":"Hardwares ","item_description":"4 units Portable Thermal Printer \\n4 units Portable Handheld Device\\n1 unit  Point of Sale Touch Screen\\n1 unit Cash Drawer\\n1 unit Thermal Printer\\n3 units WiFi Extender\\n1 unit Wiress N Router\\n\\nPrice is inclusive of installation fee","discount":"0","discount_type":null,"qty":"1","price_per_unit":"20000.0000","price":"20000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"93","quote_id":"10016","date":"2013-11-01 00:00:00","type":"service","item_id":"0","service_id":"45","item_name":"Parking System Software","item_description":"Quoted price can be converted to 12 months term payment for RM3000 monthly","discount":"0","discount_type":null,"qty":"1","price_per_unit":"36000.0000","price":"36000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"94","quote_id":"10016","date":"2013-11-01 00:00:00","type":"service","item_id":"0","service_id":"46","item_name":"Upgrade to Cloud Based System","item_description":"The upgrade will be deployed after 4 months of service","discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"46":{"id":"46","name":"Upgrade to Cloud Based System","description":"The upgrade will be deployed after 4 months of service","category":"0","subcategory":"0","cost":"0.00","price":"0.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-11-01 11:36:10","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"},"44":{"id":"44","name":"Hardwares ","description":"\\n4 units Portable Thermal Printer \\n4 units Portable Handheld Device\\n1 unit  Point of Sale Touch Screen\\n1 unit Cash Drawer\\n1 unit Thermal Printer\\n3 units WiFi Extender\\n1 unit Wiress N Router\\n\\nPrice is inclusive of installation fee","category":"0","subcategory":"0","cost":"18921.00","price":"20000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-31 15:06:20","added_by":"admin","modified_on":"2013-11-01 11:33:20","modified_by":"admin","warehouse_id":"0"},"45":{"id":"45","name":"Parking System Software","description":"Quoted price can be converted to 12 months term payment for RM3000 monthly","category":"0","subcategory":"0","cost":"36000.00","price":"36000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-11-01 11:35:11","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-11-01 11:40:53', 'admin'),
(459, 'sales', 'add', 'quote', 10017, '{"id":"10017","txn_no":"1-10015","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-11-01 00:00:00","due_date":"2013-12-01 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Beachfront Services Sdn. Bhd.","contact_id":"1138","contact_address":"{\\"address1\\":\\"HUNZA TOWER\\",\\"address2\\":\\"KELAWEI ROAD\\",\\"zipcode\\":\\"10250\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Beachfront Services Sdn. Bhd.\\",\\"mobile\\":\\"04-2189 275\\",\\"address1\\":\\"HUNZA TOWER\\",\\"address2\\":\\"KELAWEI ROAD\\",\\"zipcode\\":\\"10250\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"This quotation is for one time off solution","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"60000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-11-01 11:48:34","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"95","quote_id":"10017","date":"2013-11-01 00:00:00","type":"service","item_id":"0","service_id":"44","item_name":"Hardwares ","item_description":"\\n4 units Portable Thermal Printer \\n4 units Portable Handheld Device\\n1 unit  Point of Sale Touch Screen\\n1 unit Cash Drawer\\n1 unit Thermal Printer\\n3 units WiFi Extender\\n1 unit Wiress N Router\\n\\nPrice is inclusive of installation fee","discount":"0","discount_type":null,"qty":"1","price_per_unit":"20000.0000","price":"20000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"96","quote_id":"10017","date":"2013-11-01 00:00:00","type":"service","item_id":"0","service_id":"45","item_name":"Parking System Software","item_description":"1 year warranty \\n\\n4 months support ( 20 man hours per month)\\n\\nQuoted price can be converted to 12 months term payment for RM3000 monthly ","discount":"0","discount_type":null,"qty":"1","price_per_unit":"40000.0000","price":"40000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"44":{"id":"44","name":"Hardwares ","description":"\\n4 units Portable Thermal Printer \\n4 units Portable Handheld Device\\n1 unit  Point of Sale Touch Screen\\n1 unit Cash Drawer\\n1 unit Thermal Printer\\n3 units WiFi Extender\\n1 unit Wiress N Router\\n\\nPrice is inclusive of installation fee","category":"0","subcategory":"0","cost":"18921.00","price":"20000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-31 15:06:20","added_by":"admin","modified_on":"2013-11-01 11:33:20","modified_by":"admin","warehouse_id":"0"},"45":{"id":"45","name":"Parking System Software","description":"Quoted price can be converted to 12 months term payment for RM3000 monthly","category":"0","subcategory":"0","cost":"36000.00","price":"36000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-11-01 11:35:11","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-11-01 11:48:34', 'admin'),
(460, 'sales', 'edit', 'quote', 10016, '{"id":"10016","txn_no":"1-10014","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-11-01 00:00:00","due_date":"2013-12-01 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Beachfront Services Sdn. Bhd.","contact_id":"1138","contact_address":"{\\"address1\\":\\"HUNZA TOWER\\",\\"address2\\":\\"KELAWEI ROAD\\",\\"zipcode\\":\\"10250\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Beachfront Services Sdn. Bhd.\\",\\"mobile\\":\\"04-2189 275\\",\\"address1\\":\\"HUNZA TOWER\\",\\"address2\\":\\"KELAWEI ROAD\\",\\"zipcode\\":\\"10250\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"This quotation is for Software as a service (Saas) solution","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"56000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-11-01 11:39:22","added_by":"admin","modified_on":"2013-11-01 11:49:43","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"97","quote_id":"10016","date":"2013-11-01 00:00:00","type":"service","item_id":"0","service_id":"44","item_name":"Hardwares ","item_description":"4 units Portable Thermal Printer \\n4 units Portable Handheld Device\\n1 unit  Point of Sale Touch Screen\\n1 unit Cash Drawer\\n1 unit Thermal Printer\\n3 units WiFi Extender\\n1 unit Wiress N Router\\n\\nPrice is inclusive of installation fee","discount":"0","discount_type":null,"qty":"1","price_per_unit":"20000.0000","price":"20000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"98","quote_id":"10016","date":"2013-11-01 00:00:00","type":"service","item_id":"0","service_id":"45","item_name":"Parking System Software","item_description":"Service\\n20 man hours support per month\\n\\nQuoted price can be converted to 12 months term payment for RM3000 monthly","discount":"0","discount_type":null,"qty":"1","price_per_unit":"36000.0000","price":"36000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"99","quote_id":"10016","date":"2013-11-01 00:00:00","type":"service","item_id":"0","service_id":"46","item_name":"Upgrade to Cloud Based System","item_description":"The upgrade will be deployed after 4 months of service","discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"44":{"id":"44","name":"Hardwares ","description":"\\n4 units Portable Thermal Printer \\n4 units Portable Handheld Device\\n1 unit  Point of Sale Touch Screen\\n1 unit Cash Drawer\\n1 unit Thermal Printer\\n3 units WiFi Extender\\n1 unit Wiress N Router\\n\\nPrice is inclusive of installation fee","category":"0","subcategory":"0","cost":"18921.00","price":"20000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-10-31 15:06:20","added_by":"admin","modified_on":"2013-11-01 11:33:20","modified_by":"admin","warehouse_id":"0"},"45":{"id":"45","name":"Parking System Software","description":"Quoted price can be converted to 12 months term payment for RM3000 monthly","category":"0","subcategory":"0","cost":"36000.00","price":"36000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-11-01 11:35:11","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"},"46":{"id":"46","name":"Upgrade to Cloud Based System","description":"The upgrade will be deployed after 4 months of service","category":"0","subcategory":"0","cost":"0.00","price":"0.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-11-01 11:36:10","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-11-01 11:49:43', 'admin'),
(461, 'contacts', 'add', 'contact', 1139, '{"id":"1139","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Shafiq Rizwan Bin Shaukat","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"shafiq@plexsol.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-03 11:39:53","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1383449993"}', '2013-11-03 11:39:53', 'admin'),
(462, 'contacts', 'add', 'contact', 1140, '{"id":"1140","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Teh Chai Soon","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Pulau Pinang","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-06 12:45:29","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1383713129"}', '2013-11-06 12:45:30', 'admin2'),
(463, 'sales', 'add', 'quote', 10018, '{"id":"10018","txn_no":"1-10016","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-11-06 00:00:00","due_date":"2013-11-12 00:00:00","contact_person":"JawiHerbShop ","payment_date":null,"received_date":null,"contact":"Teh Chai Soon","contact_id":"1140","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Teh Chai Soon\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"880.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-11-06 12:47:09","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"100","quote_id":"10018","date":"2013-11-06 00:00:00","type":"service","item_id":"0","service_id":"15","item_name":"Plex Training Center Renting Fee for October","item_description":"Total hours : 22 ","discount":"0","discount_type":null,"qty":"1","price_per_unit":"880.0000","price":"880.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"15":{"id":"15","name":"Thermal Printer","description":"","category":"0","subcategory":"0","cost":"700.00","price":"880.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-10-04 14:18:09","added_by":"admin","modified_on":"2012-10-04 14:18:25","modified_by":"admin","warehouse_id":null}}}', '2013-11-06 12:47:09', 'admin2'),
(464, 'sales', 'edit', 'quote', 10018, '{"id":"10018","txn_no":"1-10016","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-11-06 00:00:00","due_date":"2013-11-12 00:00:00","contact_person":"Azad","payment_date":null,"received_date":null,"contact":"Teh Chai Soon","contact_id":"1140","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Teh Chai Soon\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"880.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-11-06 12:47:09","added_by":"admin2","modified_on":"2013-11-06 12:47:31","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"101","quote_id":"10018","date":"2013-11-06 00:00:00","type":"service","item_id":"0","service_id":"15","item_name":"Plex Training Center Renting Fee for October","item_description":"Total hours : 22 ","discount":"0","discount_type":null,"qty":"1","price_per_unit":"880.0000","price":"880.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"15":{"id":"15","name":"Thermal Printer","description":"","category":"0","subcategory":"0","cost":"700.00","price":"880.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-10-04 14:18:09","added_by":"admin","modified_on":"2012-10-04 14:18:25","modified_by":"admin","warehouse_id":null}}}', '2013-11-06 12:47:31', 'admin2'),
(465, 'sales', 'edit', 'quote', 10018, '{"id":"10018","txn_no":"1-10016","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-11-06 00:00:00","due_date":"2013-11-12 00:00:00","contact_person":"Azad","payment_date":null,"received_date":null,"contact":"Teh Chai Soon","contact_id":"1140","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Teh Chai Soon\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"440.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-11-06 12:47:09","added_by":"admin2","modified_on":"2013-11-06 12:50:57","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"102","quote_id":"10018","date":"2013-11-06 00:00:00","type":"service","item_id":"0","service_id":"15","item_name":"Plex Training Center Renting Fee for October","item_description":"Total hours : 22 ","discount":"50","discount_type":"p","qty":"1","price_per_unit":"880.0000","price":"880.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"15":{"id":"15","name":"Thermal Printer","description":"","category":"0","subcategory":"0","cost":"700.00","price":"880.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-10-04 14:18:09","added_by":"admin","modified_on":"2012-10-04 14:18:25","modified_by":"admin","warehouse_id":null}}}', '2013-11-06 12:50:57', 'admin2'),
(466, 'contacts', 'add', 'contact', 1141, '{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"En. Faisol","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"}', '2013-11-11 22:02:24', 'admin2'),
(467, 'sales', 'add', 'quote', 10019, '{"id":"10019","txn_no":"1-10017","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-11-11 00:00:00","due_date":"2013-12-11 00:00:00","contact_person":"Azad Affif Ishak","payment_date":null,"received_date":null,"contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3860.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-11-11 22:07:31","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"103","quote_id":"10019","date":"2013-11-11 00:00:00","type":"service","item_id":"0","service_id":"13","item_name":"Point Of Sale (POS) Hardwares","item_description":"1 unit MSI  AP1612 POS\\n1 unit Cash Drawer\\n1 unit Thermal Printer","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3860.0000","price":"3860.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"13":{"id":"13","name":"Industrial Touch POS Terminal","description":"","category":"0","subcategory":"0","cost":"3200.00","price":"3860.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-10-04 14:15:20","added_by":"admin","modified_on":"2012-10-04 14:18:49","modified_by":"admin","warehouse_id":null}}}', '2013-11-11 22:07:32', 'admin2'),
(468, 'sales', 'edit', 'quote', 10019, '{"id":"10019","txn_no":"1-10017","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-11-11 00:00:00","due_date":"2013-12-11 00:00:00","contact_person":"Azad Affif Ishak","payment_date":null,"received_date":null,"contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-11-11 22:07:31","added_by":"admin2","modified_on":"2013-11-11 22:09:34","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"104","quote_id":"10019","date":"2013-11-11 00:00:00","type":"service","item_id":"0","service_id":"13","item_name":"Point Of Sale (POS) Hardwares","item_description":"1 unit MSI  AP1612 POS\\n1 unit Cash Drawer\\n1 unit Thermal Printer","discount":"0","discount_type":null,"qty":"1","price_per_unit":"4200.0000","price":"4200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"13":{"id":"13","name":"Industrial Touch POS Terminal","description":"","category":"0","subcategory":"0","cost":"3200.00","price":"3860.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-10-04 14:15:20","added_by":"admin","modified_on":"2012-10-04 14:18:49","modified_by":"admin","warehouse_id":null}}}', '2013-11-11 22:09:34', 'admin2'),
(469, 'contacts', 'add', 'contact', 1142, '{"id":"1142","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"ABD NASIR BIN MOHD","contact_number":"013-3682390","credit_limit":"0.00","rank":"Agent Member","email":"","ic":"","password":"","introducer_ic":null,"address1":"45, JALAN USJ 4\\/1E, UEP SUBANG JAYA,","address2":"47600 SUBANG JAYA SELANGOR","city":"SUBANG JAYA","state":"Selangor","zipcode":"47600","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-12-03 16:06:54","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1386058014"}', '2013-12-03 16:06:54', 'admin2'),
(470, 'contacts', 'delete', 'contact', 1142, '{"id":"1142","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"ABD NASIR BIN MOHD","contact_number":"013-3682390","credit_limit":"0.00","rank":"Agent Member","email":"","ic":"","password":"","introducer_ic":null,"address1":"45, JALAN USJ 4\\/1E, UEP SUBANG JAYA,","address2":"47600 SUBANG JAYA SELANGOR","city":"SUBANG JAYA","state":"Selangor","zipcode":"47600","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-12-03 16:06:54","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1386058014"}', '2013-12-03 16:10:17', 'admin2'),
(471, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"5.000","enabled":"1"}', '2013-12-05 18:50:23', 'admin'),
(472, 'contacts', 'add', 'contact', 1143, '{"id":"1143","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Bafana Roasters Sdn. Bhd","company_registration":"","contact_person":"Ahmad Fadli","contact_number":"0194223298","credit_limit":"0.00","rank":"0","email":"","ic":"No1,tgkt bawah, Jln Dagangan 2, bertam perdana 1, 13200 kepala batas, Penang","password":"","introducer_ic":null,"address1":"No 1 , Tingkat Bawah, Jalan Dagangan 2","address2":"Bertam Perdana 1","city":"Kepala Batas","state":"Pulau Pinang","zipcode":"13200","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-12-11 18:11:24","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1386756684"}', '2013-12-11 18:11:24', 'admin2'),
(473, 'sales', 'add', 'quote', 10020, '{"id":"10020","txn_no":"1-10018","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-12-11 00:00:00","due_date":"2013-12-11 00:00:00","contact_person":"Ahmad Fadli ","payment_date":null,"received_date":null,"contact":"Bafana Roasters Sdn. Bhd","contact_id":"1143","contact_address":"{\\"address1\\":\\"No 1 , Tingkat Bawah, Jalan Dagangan 2\\",\\"address2\\":\\"Bertam Perdana 1\\",\\"zipcode\\":\\"13200\\",\\"city\\":\\"Kepala Batas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Bafana Roasters Sdn. Bhd\\",\\"mobile\\":\\"0194223298\\",\\"address1\\":\\"No 1 , Tingkat Bawah, Jalan Dagangan 2\\",\\"address2\\":\\"Bertam Perdana 1\\",\\"zipcode\\":\\"13200\\",\\"city\\":\\"Kepala Batas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"16700.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-12-11 21:14:02","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"105","quote_id":"10020","date":"2013-12-11 00:00:00","type":"service","item_id":"0","service_id":"37","item_name":"F&B Plexcloud ","item_description":"Plexcloud Modules Included:\\n\\nF&B Module \\nAccount  [Beta]\\nHR [Beta]\\nReport [Beta]\\n\\nHardwares Included:\\n\\n1 Unit F&B Plexcloud in a box\\n2 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\nQuoted price can be converted to 18 months term payment for RM900 monthly ","discount":"0","discount_type":null,"qty":"1","price_per_unit":"16200.0000","price":"16200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"106","quote_id":"10020","date":"2013-12-11 00:00:00","type":"service","item_id":"0","service_id":"27","item_name":"Installation & Wiring","item_description":"","discount":"0","discount_type":null,"qty":"1","price_per_unit":"500.0000","price":"500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"37":{"id":"37","name":"Basic F&B Plexcloud Subscription ","description":"Plexcloud Modules Included:\\n\\nF&B Module \\nAccount  [Beta]\\nHR [Beta]\\nReport [Beta]\\n\\nHardwares Included:\\n\\n1 Unit F&B Plexcloud in a box\\n2 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\n\\nQuoted price can be converted to 18 months term payment for RM900 monthly ","category":"0","subcategory":"0","cost":"400.00","price":"16200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-07-16 20:52:51","added_by":"admin2","modified_on":"2013-12-11 21:10:55","modified_by":"admin2","warehouse_id":"0"},"27":{"id":"27","name":"Standard Wiring","description":"LCD Mounting\\nSpeaker Wiring","category":"0","subcategory":"0","cost":"200.00","price":"300.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:35:07","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-12-11 21:14:02', 'admin2'),
(474, 'sales', 'edit', 'quote', 10020, '{"id":"10020","txn_no":"1-10018","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-12-11 00:00:00","due_date":"2013-12-12 00:00:00","contact_person":"Azad Affif Ishak","payment_date":null,"received_date":null,"contact":"Bafana Roasters Sdn. Bhd","contact_id":"1143","contact_address":"{\\"address1\\":\\"No 1 , Tingkat Bawah, Jalan Dagangan 2\\",\\"address2\\":\\"Bertam Perdana 1\\",\\"zipcode\\":\\"13200\\",\\"city\\":\\"Kepala Batas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Bafana Roasters Sdn. Bhd\\",\\"mobile\\":\\"0194223298\\",\\"address1\\":\\"No 1 , Tingkat Bawah, Jalan Dagangan 2\\",\\"address2\\":\\"Bertam Perdana 1\\",\\"zipcode\\":\\"13200\\",\\"city\\":\\"Kepala Batas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"16700.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-12-11 21:14:02","added_by":"admin2","modified_on":"2013-12-11 21:15:27","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"107","quote_id":"10020","date":"2013-12-11 00:00:00","type":"service","item_id":"0","service_id":"37","item_name":"F&B Plexcloud ","item_description":"Plexcloud Modules Included:\\n\\nF&B Module \\nAccount  [Beta]\\nHR [Beta]\\nReport [Beta]\\n\\nHardwares Included:\\n\\n1 Unit F&B Plexcloud in a box\\n2 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\nQuoted price can be converted to 18 months term payment for RM900 monthly ","discount":"0","discount_type":null,"qty":"1","price_per_unit":"16200.0000","price":"16200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"108","quote_id":"10020","date":"2013-12-11 00:00:00","type":"service","item_id":"0","service_id":"27","item_name":"Installation & Wiring","item_description":"","discount":"0","discount_type":null,"qty":"1","price_per_unit":"500.0000","price":"500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"27":{"id":"27","name":"Standard Wiring","description":"LCD Mounting\\nSpeaker Wiring","category":"0","subcategory":"0","cost":"200.00","price":"300.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:35:07","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"0"},"37":{"id":"37","name":"Basic F&B Plexcloud Subscription ","description":"Plexcloud Modules Included:\\n\\nF&B Module \\nAccount  [Beta]\\nHR [Beta]\\nReport [Beta]\\n\\nHardwares Included:\\n\\n1 Unit F&B Plexcloud in a box\\n2 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\n\\nQuoted price can be converted to 18 months term payment for RM900 monthly ","category":"0","subcategory":"0","cost":"400.00","price":"16200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-07-16 20:52:51","added_by":"admin2","modified_on":"2013-12-11 21:10:55","modified_by":"admin2","warehouse_id":"0"}}}', '2013-12-11 21:15:27', 'admin2'),
(475, 'sales', 'edit', 'quote', 10020, '{"id":"10020","txn_no":"1-10018","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-12-11 00:00:00","due_date":"2013-12-12 00:00:00","contact_person":"Azad Affif Ishak","payment_date":null,"received_date":null,"contact":"Bafana Roasters Sdn. Bhd","contact_id":"1143","contact_address":"{\\"address1\\":\\"No 1 , Tingkat Bawah, Jalan Dagangan 2\\",\\"address2\\":\\"Bertam Perdana 1\\",\\"zipcode\\":\\"13200\\",\\"city\\":\\"Kepala Batas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Bafana Roasters Sdn. Bhd\\",\\"mobile\\":\\"0194223298\\",\\"address1\\":\\"No 1 , Tingkat Bawah, Jalan Dagangan 2\\",\\"address2\\":\\"Bertam Perdana 1\\",\\"zipcode\\":\\"13200\\",\\"city\\":\\"Kepala Batas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"16700.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-12-11 21:14:02","added_by":"admin2","modified_on":"2013-12-11 21:20:12","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"109","quote_id":"10020","date":"2013-12-11 00:00:00","type":"service","item_id":"0","service_id":"37","item_name":"F&B Plexcloud ","item_description":"Plexcloud Modules Included:\\n\\nF&B Module \\nReport\\nAccount  [Beta]\\nHR [Beta]\\n\\nHardwares Included:\\n\\n1 Unit F&B Plexcloud in a box\\n2 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\nQuoted price can be converted to 18 months term payment for RM900 monthly ","discount":"0","discount_type":null,"qty":"1","price_per_unit":"16200.0000","price":"16200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"110","quote_id":"10020","date":"2013-12-11 00:00:00","type":"service","item_id":"0","service_id":"27","item_name":"Installation & Wiring","item_description":"","discount":"0","discount_type":null,"qty":"1","price_per_unit":"500.0000","price":"500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"37":{"id":"37","name":"Basic F&B Plexcloud Subscription ","description":"Plexcloud Modules Included:\\n\\nF&B Module \\nAccount  [Beta]\\nHR [Beta]\\nReport [Beta]\\n\\nHardwares Included:\\n\\n1 Unit F&B Plexcloud in a box\\n2 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\n\\nQuoted price can be converted to 18 months term payment for RM900 monthly ","category":"0","subcategory":"0","cost":"400.00","price":"16200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-07-16 20:52:51","added_by":"admin2","modified_on":"2013-12-11 21:10:55","modified_by":"admin2","warehouse_id":"0"},"27":{"id":"27","name":"Standard Wiring","description":"LCD Mounting\\nSpeaker Wiring","category":"0","subcategory":"0","cost":"200.00","price":"300.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:35:07","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-12-11 21:20:12', 'admin2'),
(476, 'sales', 'edit', 'quote', 10020, '{"id":"10020","txn_no":"1-10018","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-12-11 00:00:00","due_date":"2013-12-12 00:00:00","contact_person":"Azad Affif Ishak","payment_date":null,"received_date":null,"contact":"Bafana Roasters Sdn. Bhd","contact_id":"1143","contact_address":"{\\"address1\\":\\"No 1 , Tingkat Bawah, Jalan Dagangan 2\\",\\"address2\\":\\"Bertam Perdana 1\\",\\"zipcode\\":\\"13200\\",\\"city\\":\\"Kepala Batas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Bafana Roasters Sdn. Bhd\\",\\"mobile\\":\\"0194223298\\",\\"address1\\":\\"No 1 , Tingkat Bawah, Jalan Dagangan 2\\",\\"address2\\":\\"Bertam Perdana 1\\",\\"zipcode\\":\\"13200\\",\\"city\\":\\"Kepala Batas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"Wireless router is not included based on the assumption that client already has internet facility at premise.","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"16700.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-12-11 21:14:02","added_by":"admin2","modified_on":"2013-12-11 21:32:04","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"111","quote_id":"10020","date":"2013-12-11 00:00:00","type":"service","item_id":"0","service_id":"37","item_name":"F&B Plexcloud ","item_description":"Plexcloud Modules Included:\\n\\nF&B Module \\nReport\\nAccount  [Beta]\\nHR [Beta]\\n\\nHardwares Included:\\n\\n1 Unit F&B Plexcloud in a box\\n2 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\nQuoted price can be converted to 18 months term payment for RM900 monthly ","discount":"0","discount_type":null,"qty":"1","price_per_unit":"16200.0000","price":"16200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"112","quote_id":"10020","date":"2013-12-11 00:00:00","type":"service","item_id":"0","service_id":"27","item_name":"Installation & Wiring","item_description":"","discount":"0","discount_type":null,"qty":"1","price_per_unit":"500.0000","price":"500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"27":{"id":"27","name":"Standard Wiring","description":"LCD Mounting\\nSpeaker Wiring","category":"0","subcategory":"0","cost":"200.00","price":"300.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:35:07","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"0"},"37":{"id":"37","name":"Basic F&B Plexcloud Subscription ","description":"Plexcloud Modules Included:\\n\\nF&B Module \\nAccount  [Beta]\\nHR [Beta]\\nReport [Beta]\\n\\nHardwares Included:\\n\\n1 Unit F&B Plexcloud in a box\\n2 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\n\\nQuoted price can be converted to 18 months term payment for RM900 monthly ","category":"0","subcategory":"0","cost":"400.00","price":"16200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-07-16 20:52:51","added_by":"admin2","modified_on":"2013-12-11 21:10:55","modified_by":"admin2","warehouse_id":"0"}}}', '2013-12-11 21:32:04', 'admin2'),
(477, 'sales', 'edit', 'quote', 10020, '{"id":"10020","txn_no":"1-10018","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-12-11 00:00:00","due_date":"2013-12-12 00:00:00","contact_person":"Azad Affif Ishak","payment_date":null,"received_date":null,"contact":"Bafana Roasters Sdn. Bhd","contact_id":"1143","contact_address":"{\\"address1\\":\\"No 1 , Tingkat Bawah, Jalan Dagangan 2\\",\\"address2\\":\\"Bertam Perdana 1\\",\\"zipcode\\":\\"13200\\",\\"city\\":\\"Kepala Batas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Bafana Roasters Sdn. Bhd\\",\\"mobile\\":\\"0194223298\\",\\"address1\\":\\"No 1 , Tingkat Bawah, Jalan Dagangan 2\\",\\"address2\\":\\"Bertam Perdana 1\\",\\"zipcode\\":\\"13200\\",\\"city\\":\\"Kepala Batas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"16700.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-12-11 21:14:02","added_by":"admin2","modified_on":"2013-12-11 21:32:41","modified_by":"admin2","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"113","quote_id":"10020","date":"2013-12-11 00:00:00","type":"service","item_id":"0","service_id":"37","item_name":"F&B Plexcloud ","item_description":"Plexcloud Modules Included:\\n\\nF&B Module \\nReport\\nAccount  [Beta]\\nHR [Beta]\\n\\nHardwares Included:\\n\\n1 Unit F&B Plexcloud in a box\\n2 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\nQuoted price can be converted to 18 months term payment for RM900 monthly \\n\\nWireless router is not included based on the assumption that client already has internet facility at premise.","discount":"0","discount_type":null,"qty":"1","price_per_unit":"16200.0000","price":"16200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"114","quote_id":"10020","date":"2013-12-11 00:00:00","type":"service","item_id":"0","service_id":"27","item_name":"Installation & Wiring","item_description":"","discount":"0","discount_type":null,"qty":"1","price_per_unit":"500.0000","price":"500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"37":{"id":"37","name":"Basic F&B Plexcloud Subscription ","description":"Plexcloud Modules Included:\\n\\nF&B Module \\nAccount  [Beta]\\nHR [Beta]\\nReport [Beta]\\n\\nHardwares Included:\\n\\n1 Unit F&B Plexcloud in a box\\n2 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\n\\nQuoted price can be converted to 18 months term payment for RM900 monthly ","category":"0","subcategory":"0","cost":"400.00","price":"16200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-07-16 20:52:51","added_by":"admin2","modified_on":"2013-12-11 21:10:55","modified_by":"admin2","warehouse_id":"0"},"27":{"id":"27","name":"Standard Wiring","description":"LCD Mounting\\nSpeaker Wiring","category":"0","subcategory":"0","cost":"200.00","price":"300.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:35:07","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-12-11 21:32:41', 'admin2');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(478, 'sales', 'add', 'so', 10014, '{"id":"10014","txn_no":"1-10011","quote_id":"10005","invoice_id":null,"number":"0","pr_number":null,"po_number":"QUO-10005","date":"2013-06-07 00:00:00","due_date":"0000-00-00 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Malaysian Institute of Road Safety Research (MIROS)","contact_id":"1131","contact_address":"{\\"address1\\":\\"Lot 125-135, Jalan TKS 1\\",\\"address2\\":\\"Taman Kajang Sentral\\",\\"zipcode\\":\\"43000 \\",\\"city\\":\\"Kajang\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"false","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"49999.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-12-13 12:13:39","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"15","sales_order_id":"10014","type":"service","date":"2013-06-07 00:00:00","item_name":"MEMBANGUN, MEMBEKAL, MENGHANTAR, MEMASANG DAN MENGUJILARI SISTEM ANALISA DAN PENGURUSAN PENGKALAN DATA KEMALANGAN JALAN RAYA","item_description":"3 Months of Product Development\\n2 Months of Product Support\\n4 Months Warranty\\nData Collection\\nTo provide a Web Based Application on Accident data collection.\\n\\n* Multiple User\\n* Permission Levels for User\\n* Data Collection Form\\n* Documentation of System\\n* Training Usage of the System\\n\\nData Analytics\\nAn analytic tool for the data collection in producing reports of the collected data.\\n\\n* Heat Map (Black Area)\\n* Cross Filtering Between Inputs from Data Collection\\n* Training Usage of the System\\n* Documentation of System\\n\\nMobile Implementation \\n* Mobile development for On-Site data Collection\\n* Sketching App for Data\\n* Data sending to Main Server for cases\\n* Training and Documentation\\n\\nTraining\\n* Training to MIROS in-house programmers will be conducted during the support month\\n\\nSource Code\\n* Source Code Copyrights will be handed over to MIROS","item_id":"0","service_id":"31","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"49999.0000","price":"49999.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"31":{"id":"31","name":"MEMBANGUN, MEMBEKAL, MENGHANTAR, MEMASANG DAN MENGUJILARI SISTEM ANALISA DAN PENGURUSAN PENGKALAN DATA KEMALANGAN JALAN RAYA","description":"3 Months of Product Development\\n2 Months of Product Support\\n4 Months Warranty\\nData Collection\\nTo provide a Web Based Application on Accident data collection.\\n\\n* Multiple User\\n* Permission Levels for User\\n* Data Collection Form\\n* Documentation of System\\n* Training Usage of the System\\n\\nData Analytics\\nAn analytic tool for the data collection in producing reports of the collected data.\\n\\n* Heat Map (Black Area)\\n* Cross Filtering Between Inputs from Data Collection\\n* Training Usage of the System\\n* Documentation of System\\n\\nMobile Implementation \\n* Mobile development for On-Site data Collection\\n* Sketching App for Data\\n* Data sending to Main Server for cases\\n* Training and Documentation\\n\\nTraining\\n* Training to MIROS in-house programmers will be conducted during the support month\\n\\nSource Code\\n* Source Code Copyrights will be handed over to MIROS","category":"0","subcategory":"0","cost":"60000.00","price":"49999.00","last_tendered":null,"remarks":"MEMBANGUN, MEMBEKAL, MENGHANTAR, MEMASANG DAN MENGUJILARI SISTEM ANALISA DAN PENGURUSAN PENGKALAN DATA KEMALANGAN JALAN RAYA BAGI INSTITUT PENYELIDIKAN KESELAMATAN JALAN RAYA MALAYSIA, LOT 135 JLN TKS 1, TAMAN KAJANG SENTRAL, 43000 KAJANG, SELANGOR       ","tags":null,"added_on":"2013-06-07 10:42:02","added_by":"admin2","modified_on":"2013-07-11 14:26:33","modified_by":"admin2","warehouse_id":"0"}}}', '2013-12-13 12:13:41', 'admin'),
(479, 'sales', 'status_update', 'so', 10014, '{"id":"10014","txn_no":"1-10011","quote_id":"10005","invoice_id":null,"number":"0","pr_number":null,"po_number":"QUO-10005","date":"2013-06-07 00:00:00","due_date":"0000-00-00 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Malaysian Institute of Road Safety Research (MIROS)","contact_id":"1131","contact_address":"{\\"address1\\":\\"Lot 125-135, Jalan TKS 1\\",\\"address2\\":\\"Taman Kajang Sentral\\",\\"zipcode\\":\\"43000 \\",\\"city\\":\\"Kajang\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"false","terms":"Credit","duration":"0","remarks":"","status":"Completed","payment_gateway":null,"payment_method":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"49999.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-12-13 12:13:39","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"15","sales_order_id":"10014","type":"service","date":"2013-06-07 00:00:00","item_name":"MEMBANGUN, MEMBEKAL, MENGHANTAR, MEMASANG DAN MENGUJILARI SISTEM ANALISA DAN PENGURUSAN PENGKALAN DATA KEMALANGAN JALAN RAYA","item_description":"3 Months of Product Development\\n2 Months of Product Support\\n4 Months Warranty\\nData Collection\\nTo provide a Web Based Application on Accident data collection.\\n\\n* Multiple User\\n* Permission Levels for User\\n* Data Collection Form\\n* Documentation of System\\n* Training Usage of the System\\n\\nData Analytics\\nAn analytic tool for the data collection in producing reports of the collected data.\\n\\n* Heat Map (Black Area)\\n* Cross Filtering Between Inputs from Data Collection\\n* Training Usage of the System\\n* Documentation of System\\n\\nMobile Implementation \\n* Mobile development for On-Site data Collection\\n* Sketching App for Data\\n* Data sending to Main Server for cases\\n* Training and Documentation\\n\\nTraining\\n* Training to MIROS in-house programmers will be conducted during the support month\\n\\nSource Code\\n* Source Code Copyrights will be handed over to MIROS","item_id":"0","service_id":"31","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"49999.0000","price":"49999.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"31":{"id":"31","name":"MEMBANGUN, MEMBEKAL, MENGHANTAR, MEMASANG DAN MENGUJILARI SISTEM ANALISA DAN PENGURUSAN PENGKALAN DATA KEMALANGAN JALAN RAYA","description":"3 Months of Product Development\\n2 Months of Product Support\\n4 Months Warranty\\nData Collection\\nTo provide a Web Based Application on Accident data collection.\\n\\n* Multiple User\\n* Permission Levels for User\\n* Data Collection Form\\n* Documentation of System\\n* Training Usage of the System\\n\\nData Analytics\\nAn analytic tool for the data collection in producing reports of the collected data.\\n\\n* Heat Map (Black Area)\\n* Cross Filtering Between Inputs from Data Collection\\n* Training Usage of the System\\n* Documentation of System\\n\\nMobile Implementation \\n* Mobile development for On-Site data Collection\\n* Sketching App for Data\\n* Data sending to Main Server for cases\\n* Training and Documentation\\n\\nTraining\\n* Training to MIROS in-house programmers will be conducted during the support month\\n\\nSource Code\\n* Source Code Copyrights will be handed over to MIROS","category":"0","subcategory":"0","cost":"60000.00","price":"49999.00","last_tendered":null,"remarks":"MEMBANGUN, MEMBEKAL, MENGHANTAR, MEMASANG DAN MENGUJILARI SISTEM ANALISA DAN PENGURUSAN PENGKALAN DATA KEMALANGAN JALAN RAYA BAGI INSTITUT PENYELIDIKAN KESELAMATAN JALAN RAYA MALAYSIA, LOT 135 JLN TKS 1, TAMAN KAJANG SENTRAL, 43000 KAJANG, SELANGOR       ","tags":null,"added_on":"2013-06-07 10:42:02","added_by":"admin2","modified_on":"2013-07-11 14:26:33","modified_by":"admin2","warehouse_id":"0"}}}', '2013-12-13 12:15:28', 'admin'),
(480, 'sales', 'add', 'invoice', 10018, '{"id":"10018","txn_no":"1-10018","quote_id":"10005","sales_order_id":"10014","number":"0","po_number":"QUO-10005","date":"2013-06-07 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Malaysian Institute of Road Safety Research (MIROS)","contact_id":"1131","contact_address":"{\\"address1\\":\\"Lot 125-135, Jalan TKS 1\\",\\"address2\\":\\"Taman Kajang Sentral\\",\\"zipcode\\":\\"43000 \\",\\"city\\":\\"Kajang\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"49999.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-12-13 12:15:52","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"31","invoice_id":"10018","type":"service","date":"2013-06-07 12:00:00","item_name":"MEMBANGUN, MEMBEKAL, MENGHANTAR, MEMASANG DAN MENGUJILARI SISTEM ANALISA DAN PENGURUSAN PENGKALAN DATA KEMALANGAN JALAN RAYA","item_description":"3 Months of Product Development\\n2 Months of Product Support\\n4 Months Warranty\\nData Collection\\nTo provide a Web Based Application on Accident data collection.\\n\\n* Multiple User\\n* Permission Levels for User\\n* Data Collection Form\\n* Documentation of System\\n* Training Usage of the System\\n\\nData Analytics\\nAn analytic tool for the data collection in producing reports of the collected data.\\n\\n* Heat Map (Black Area)\\n* Cross Filtering Between Inputs from Data Collection\\n* Training Usage of the System\\n* Documentation of System\\n\\nMobile Implementation \\n* Mobile development for On-Site data Collection\\n* Sketching App for Data\\n* Data sending to Main Server for cases\\n* Training and Documentation\\n\\nTraining\\n* Training to MIROS in-house programmers will be conducted during the support month\\n\\nSource Code\\n* Source Code Copyrights will be handed over to MIROS","item_id":"0","service_id":"31","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"49999.0000","price":"49999.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"31":{"id":"31","name":"MEMBANGUN, MEMBEKAL, MENGHANTAR, MEMASANG DAN MENGUJILARI SISTEM ANALISA DAN PENGURUSAN PENGKALAN DATA KEMALANGAN JALAN RAYA","description":"3 Months of Product Development\\n2 Months of Product Support\\n4 Months Warranty\\nData Collection\\nTo provide a Web Based Application on Accident data collection.\\n\\n* Multiple User\\n* Permission Levels for User\\n* Data Collection Form\\n* Documentation of System\\n* Training Usage of the System\\n\\nData Analytics\\nAn analytic tool for the data collection in producing reports of the collected data.\\n\\n* Heat Map (Black Area)\\n* Cross Filtering Between Inputs from Data Collection\\n* Training Usage of the System\\n* Documentation of System\\n\\nMobile Implementation \\n* Mobile development for On-Site data Collection\\n* Sketching App for Data\\n* Data sending to Main Server for cases\\n* Training and Documentation\\n\\nTraining\\n* Training to MIROS in-house programmers will be conducted during the support month\\n\\nSource Code\\n* Source Code Copyrights will be handed over to MIROS","category":"0","subcategory":"0","cost":"60000.00","price":"49999.00","last_tendered":null,"remarks":"MEMBANGUN, MEMBEKAL, MENGHANTAR, MEMASANG DAN MENGUJILARI SISTEM ANALISA DAN PENGURUSAN PENGKALAN DATA KEMALANGAN JALAN RAYA BAGI INSTITUT PENYELIDIKAN KESELAMATAN JALAN RAYA MALAYSIA, LOT 135 JLN TKS 1, TAMAN KAJANG SENTRAL, 43000 KAJANG, SELANGOR       ","tags":null,"added_on":"2013-06-07 10:42:02","added_by":"admin2","modified_on":"2013-07-11 14:26:33","modified_by":"admin2","warehouse_id":"0"}},"customer":{"id":"1131","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Malaysian Institute of Road Safety Research (MIROS)","company_registration":"","contact_person":"Project Manager","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot 125-135, Jalan TKS 1","address2":"Taman Kajang Sentral","city":"Kajang","state":"Selangor","zipcode":"43000 ","country":"Malaysia","tel":"","fax":"","general_email":"dg@miros.gov.my ","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-06-07 10:43:41","added_by":"admin2","modified_on":"2013-07-11 14:28:09","modified_by":"admin2","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2013-12-13 12:15:53', 'admin'),
(481, 'sales', 'edit', 'invoice', NULL, '[]', '2013-12-13 15:30:14', 'admin'),
(482, 'sales', 'edit', 'invoice', NULL, '[]', '2013-12-13 15:30:38', 'admin'),
(483, 'sales', 'edit', 'invoice', NULL, '[]', '2013-12-13 15:31:17', 'admin'),
(484, 'contacts', 'add', 'contact', 1144, '{"id":"1144","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"An Nahdhoh Inn","company_registration":"","contact_person":"Akmal Mohd","contact_number":"04-521 3500 ","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Kg Petani,","address2":"Kubang Semang, ","city":"Bukit Mertajam, ","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-12-27 11:18:39","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2013-12-27 11:18:39', 'admin'),
(485, 'sales', 'add', 'quote', 10021, '{"id":"10021","txn_no":"1-10019","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-12-27 00:00:00","due_date":"2014-01-27 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"An Nahdhoh Inn","contact_id":"1144","contact_address":"{\\"address1\\":\\"Kg Petani,\\",\\"address2\\":\\"Kubang Semang, \\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam, \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"An Nahdhoh Inn\\",\\"mobile\\":\\"04-521 3500 \\",\\"address1\\":\\"Kg Petani,\\",\\"address2\\":\\"Kubang Semang, \\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam, \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"5000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-12-27 11:22:00","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"115","quote_id":"10021","date":"2013-12-27 00:00:00","type":"service","item_id":"0","service_id":"50","item_name":"Hotel Management System","item_description":"This is an Web Based hotel management system. This system covers the following below ;\\n\\n- Deposit\\n- Invoicing\\n- Guest Check in \\/ Check Out\\n- Room Management\\n- Guest Records\\n- Reports","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5000.0000","price":"5000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"50":{"id":"50","name":"Hotel Management System","description":"","category":"0","subcategory":"0","cost":"0.00","price":"5000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-12-27 11:16:14","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-12-27 11:22:00', 'admin'),
(486, 'contacts', 'add', 'contact', 1145, '{"id":"1145","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Aida Cafe Bertam","company_registration":"","contact_person":"Karim","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Bertam","address2":"","city":"Kepala Batas","state":"Pulau Pinang","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-12-29 19:30:40","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2013-12-29 19:30:40', 'admin'),
(487, 'sales', 'add', 'quote', 10022, '{"id":"10022","txn_no":"1-10020","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-12-29 00:00:00","due_date":"2014-01-29 00:00:00","contact_person":"Azad Affif Ishak ","payment_date":null,"received_date":null,"contact":"Aida Cafe Bertam","contact_id":"1145","contact_address":"{\\"address1\\":\\"Bertam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Kepala Batas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Aida Cafe Bertam\\",\\"mobile\\":\\"\\",\\"address1\\":\\"Bertam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Kepala Batas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"16200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-12-29 19:32:44","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"116","quote_id":"10022","date":"2013-12-29 00:00:00","type":"service","item_id":"0","service_id":"37","item_name":"Basic F&B Plexcloud Subscription ","item_description":"Plexcloud Modules Included:\\n\\nF&B Module \\nSale Module\\nInventory Module\\nReport\\n\\nHardwares Included:\\n\\n1 Unit F&B Plexcloud in a box\\n2 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"16200.0000","price":"16200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"37":{"id":"37","name":"Basic F&B Plexcloud Subscription ","description":"Plexcloud Modules Included:\\n\\nF&B Module \\nAccount  [Beta]\\nHR [Beta]\\nReport [Beta]\\n\\nHardwares Included:\\n\\n1 Unit F&B Plexcloud in a box\\n2 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\n\\nQuoted price can be converted to 18 months term payment for RM900 monthly ","category":"0","subcategory":"0","cost":"400.00","price":"16200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-07-16 20:52:51","added_by":"admin2","modified_on":"2013-12-11 21:10:55","modified_by":"admin2","warehouse_id":"0"}}}', '2013-12-29 19:32:44', 'admin'),
(488, 'sales', 'add', 'quote', 10023, '{"id":"10023","txn_no":"1-10021","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-12-29 00:00:00","due_date":"2014-01-29 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Aida Cafe Bertam","contact_id":"1145","contact_address":"{\\"address1\\":\\"Bertam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Kepala Batas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Aida Cafe Bertam\\",\\"mobile\\":\\"\\",\\"address1\\":\\"Bertam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Kepala Batas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"13400.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-12-29 19:35:04","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"117","quote_id":"10023","date":"2013-12-29 00:00:00","type":"service","item_id":"0","service_id":"37","item_name":"F&B Plexcloud","item_description":"Plexcloud Modules Included:\\n\\nF&B Module \\nSales Module\\nInventory Module\\nReport\\n\\nHardwares Included:\\n\\n1 unit PC Set\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer ","discount":"0","discount_type":null,"qty":"1","price_per_unit":"13400.0000","price":"13400.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"37":{"id":"37","name":"Basic F&B Plexcloud Subscription ","description":"Plexcloud Modules Included:\\n\\nF&B Module \\nAccount  [Beta]\\nHR [Beta]\\nReport [Beta]\\n\\nHardwares Included:\\n\\n1 Unit F&B Plexcloud in a box\\n2 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\n\\nQuoted price can be converted to 18 months term payment for RM900 monthly ","category":"0","subcategory":"0","cost":"400.00","price":"16200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-07-16 20:52:51","added_by":"admin2","modified_on":"2013-12-11 21:10:55","modified_by":"admin2","warehouse_id":"0"}}}', '2013-12-29 19:35:04', 'admin'),
(489, 'sales', 'edit', 'quote', 10022, '{"id":"10022","txn_no":"1-10020","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-12-29 00:00:00","due_date":"2014-01-29 00:00:00","contact_person":"Azad Affif Ishak ","payment_date":null,"received_date":null,"contact":"Aida Cafe Bertam","contact_id":"1145","contact_address":"{\\"address1\\":\\"Bertam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Kepala Batas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Aida Cafe Bertam\\",\\"mobile\\":\\"\\",\\"address1\\":\\"Bertam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Kepala Batas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"16200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-12-29 19:32:44","added_by":"admin","modified_on":"2013-12-29 19:35:43","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"118","quote_id":"10022","date":"2013-12-29 00:00:00","type":"service","item_id":"0","service_id":"37","item_name":"Mobile F&B Plexcloud","item_description":"Plexcloud Modules Included:\\n\\nF&B Module \\nSale Module\\nInventory Module\\nReport\\n\\nHardwares Included:\\n\\n2 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"16200.0000","price":"16200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"37":{"id":"37","name":"Basic F&B Plexcloud Subscription ","description":"Plexcloud Modules Included:\\n\\nF&B Module \\nAccount  [Beta]\\nHR [Beta]\\nReport [Beta]\\n\\nHardwares Included:\\n\\n1 Unit F&B Plexcloud in a box\\n2 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\n\\nQuoted price can be converted to 18 months term payment for RM900 monthly ","category":"0","subcategory":"0","cost":"400.00","price":"16200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-07-16 20:52:51","added_by":"admin2","modified_on":"2013-12-11 21:10:55","modified_by":"admin2","warehouse_id":"0"}}}', '2013-12-29 19:35:43', 'admin'),
(490, 'contacts', 'add', 'contact', 1146, '{"id":"1146","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Quahec","company_registration":"","contact_person":"Quahec","contact_number":"","credit_limit":"0.00","rank":"0","email":"quahec@hotmail.com","ic":"","password":"0d65fac46b3557d7d86457d275160e5c","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-12-30 14:44:42","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2013-12-30 14:44:42', 'admin'),
(491, 'sales', 'add', 'quote', 10024, '{"id":"10024","txn_no":"1-10022","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2013-12-30 00:00:00","due_date":"2014-01-30 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Quahec","contact_id":"1146","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Quahec\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2013-12-30 14:45:46","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"119","quote_id":"10024","date":"2013-12-30 00:00:00","type":"service","item_id":"0","service_id":"51","item_name":"Website Development and Payment Gateway","item_description":"Web Development and Design\\nPayment Gateway Integration\\n1 Month Web Support\\nSystem Training and Understanding\\nPromotional Banner Design","discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"51":{"id":"51","name":"Website Development and Payment Gateway","description":"Web Development and Design\\nPayment Gateway Integration\\n1 Month Web Support\\nSystem Training and Understanding","category":"0","subcategory":"0","cost":"0.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-12-30 14:40:10","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2013-12-30 14:45:46', 'admin'),
(492, 'contacts', 'edit', 'contact', 1146, '{"id":"1146","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Quahec","company_registration":"","contact_person":"Quahec","contact_number":"","credit_limit":"0.00","rank":"0","email":"quahec@hotmail.com","ic":"","password":"0d65fac46b3557d7d86457d275160e5c","introducer_ic":null,"address1":"","address2":"","city":"","state":"Pulau Pinang","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-12-30 14:44:42","added_by":"admin","modified_on":"2013-12-30 14:46:40","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2013-12-30 14:46:45', 'admin'),
(493, 'contacts', 'add', 'contact', 1147, '{"id":"1147","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Rozita","company_registration":"","contact_person":"Rozita","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lagenda Heights","address2":"","city":"Sungai Petani","state":"Kedah","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-01-02 12:36:04","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-01-02 12:36:04', 'admin'),
(494, 'sales', 'add', 'quote', 10025, '{"id":"10025","txn_no":"1-10023","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-01-02 00:00:00","due_date":"2014-01-02 00:00:00","contact_person":"Azad ","payment_date":null,"received_date":null,"contact":"Rozita","contact_id":"1147","contact_address":"{\\"address1\\":\\"Lagenda Heights\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Rozita\\",\\"mobile\\":\\"\\",\\"address1\\":\\"Lagenda Heights\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-01-02 12:37:49","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"120","quote_id":"10025","date":"2014-01-02 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n","discount":"200","discount_type":"d","qty":"1","price_per_unit":"4200.0000","price":"4200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"}}}', '2014-01-02 12:37:49', 'admin'),
(495, 'sales', 'add', 'so', 10015, '{"id":"10015","txn_no":"1-10012","quote_id":"10025","invoice_id":null,"number":"0","pr_number":null,"po_number":"QUO-10025","date":"2014-01-02 00:00:00","due_date":"0000-00-00 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Rozita","contact_id":"1147","contact_address":"{\\"address1\\":\\"Lagenda Heights\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"false","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-01-02 12:38:08","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"16","sales_order_id":"10015","type":"service","date":"2014-01-02 00:00:00","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n","item_id":"0","service_id":"26","item_sku":null,"discount":"200","discount_type":"d","qty":"1","price_per_unit":"4200.0000","price":"4200.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"}}}', '2014-01-02 12:38:09', 'admin'),
(496, 'sales', 'status_update', 'so', 10015, '{"id":"10015","txn_no":"1-10012","quote_id":"10025","invoice_id":null,"number":"0","pr_number":null,"po_number":"QUO-10025","date":"2014-01-02 00:00:00","due_date":"0000-00-00 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Rozita","contact_id":"1147","contact_address":"{\\"address1\\":\\"Lagenda Heights\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"false","terms":"Credit","duration":"0","remarks":"","status":"Completed","payment_gateway":null,"payment_method":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-01-02 12:38:08","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"16","sales_order_id":"10015","type":"service","date":"2014-01-02 00:00:00","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n","item_id":"0","service_id":"26","item_sku":null,"discount":"200","discount_type":"d","qty":"1","price_per_unit":"4200.0000","price":"4200.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"}}}', '2014-01-02 12:38:15', 'admin'),
(497, 'sales', 'add', 'invoice', 10019, '{"id":"10019","txn_no":"1-10019","quote_id":"10025","sales_order_id":"10015","number":"0","po_number":"QUO-10025","date":"2014-01-02 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Rozita","contact_id":"1147","contact_address":"{\\"address1\\":\\"Lagenda Heights\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-01-02 12:38:29","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"35","invoice_id":"10019","type":"service","date":"2014-01-02 12:00:00","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n","item_id":"0","service_id":"26","item_sku":null,"discount":"200","discount_type":"d","qty":"1","price_per_unit":"4200.0000","price":"4200.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"}},"customer":{"id":"1147","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Rozita","company_registration":"","contact_person":"Rozita","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lagenda Heights","address2":"","city":"Sungai Petani","state":"Kedah","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-01-02 12:36:04","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-01-02 12:38:29', 'admin'),
(498, 'inventory', 'add', 'pr', NULL, '[]', '2014-01-09 12:47:37', 'admin'),
(499, 'inventory', 'status_update', 'pr', 5, '{"id":"5","txn_no":"1-10002","po_id":null,"number":null,"date":"2014-01-09 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Completed","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-01-09 12:47:37","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"10","purchase_request_id":"5","date":"2014-01-09 00:00:00","item_description":null,"item_name":"Supertripod Standing Lamp ()","item_id":"15","discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"15":{"id":"15","primary_image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","image":"xSupertripod___caption1.jpg.pagespeed_.ic_.Aavu0xGFhT_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Supertripod Standing Lamp","model_no":"","warranty":"","sku":"SSL13124","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"270.00","price_2":"11.00","price_3":"12.00","price_4":"13.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"Supertripod Standing Lamp","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"1","enter_serial":"0","tags":"","added_on":"2012-12-12 13:07:29","added_by":"admin","modified_on":"2013-03-21 23:09:31","modified_by":"admin2","redeemable":"1","redeem_points":"1","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-04-29 21:35:31","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2014-01-09 12:47:53', 'admin'),
(500, 'inventory', 'add', 'pr', NULL, '[]', '2014-01-10 01:36:01', 'azizan'),
(501, 'inventory', 'status_update', 'pr', 6, '{"id":"6","txn_no":"1-10003","po_id":null,"number":null,"date":"2014-01-10 00:00:00","due_date":null,"contact_person":" ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Completed","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3000.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-01-10 01:36:01","added_by":"azizan","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"11","purchase_request_id":"6","date":"2014-01-10 00:00:00","item_description":null,"item_name":"All-In-One POS ()","item_id":"77","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3000.0000","price":"3000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"77":{"id":"77","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"All-In-One POS","model_no":"","warranty":"","sku":"POS01231","sku2":"","sku3":"","sku4":"","qty":null,"alert_quantity":"0","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4000.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2013-09-06 22:41:18","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":"1378478478","order":null,"warehouse_id":"1"}}}', '2014-01-10 01:53:11', 'azizan'),
(502, 'inventory', 'add', 'pr', NULL, '[]', '2014-01-10 01:56:15', 'azizan');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(503, 'inventory', 'status_update', 'pr', 7, '{"id":"7","txn_no":"1-10004","po_id":null,"number":null,"date":"2014-01-10 00:00:00","due_date":null,"contact_person":" ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Completed","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-01-10 01:56:15","added_by":"azizan","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"12","purchase_request_id":"7","date":"2014-01-10 00:00:00","item_description":null,"item_name":"Accessory Strap ()","item_id":"66","discount":"0","discount_type":null,"qty":"1","price_per_unit":"2.0000","price":"2.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:10:21","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2014-01-10 01:57:52', 'azizan'),
(504, 'inventory', 'status_update', 'pr', 7, '{"id":"7","txn_no":"1-10004","po_id":null,"number":null,"date":"2014-01-10 00:00:00","due_date":null,"contact_person":" ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-01-10 01:56:15","added_by":"azizan","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"12","purchase_request_id":"7","date":"2014-01-10 00:00:00","item_description":null,"item_name":"Accessory Strap ()","item_id":"66","discount":"0","discount_type":null,"qty":"1","price_per_unit":"2.0000","price":"2.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:10:21","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2014-01-10 02:06:02', 'azizan'),
(505, 'inventory', 'edit', 'pr', 7, '{"id":"7","txn_no":"1-10004","po_id":null,"number":null,"date":"2014-01-10 00:00:00","due_date":null,"contact_person":" ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-01-10 01:56:15","added_by":"azizan","modified_on":"2014-01-10 02:06:16","modified_by":"azizan","division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"13","purchase_request_id":"7","date":"2014-01-10 00:00:00","item_description":null,"item_name":"Accessory Strap ()","item_id":"66","discount":"0","discount_type":null,"qty":"1","price_per_unit":"2.0000","price":"2.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:10:21","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2014-01-10 02:06:16', 'azizan'),
(506, 'inventory', 'status_update', 'pr', 7, '{"id":"7","txn_no":"1-10004","po_id":null,"number":null,"date":"2014-01-10 00:00:00","due_date":null,"contact_person":" ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Completed","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-01-10 01:56:15","added_by":"azizan","modified_on":"2014-01-10 02:06:16","modified_by":"azizan","division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"13","purchase_request_id":"7","date":"2014-01-10 00:00:00","item_description":null,"item_name":"Accessory Strap ()","item_id":"66","discount":"0","discount_type":null,"qty":"1","price_per_unit":"2.0000","price":"2.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:10:21","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2014-01-10 02:06:38', 'azizan'),
(507, 'inventory', 'add', 'po', 10013, '{"id":"10013","txn_no":"1-10010","invoice_number":"","pr_id":"7","number":null,"date":"2014-01-10 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-01-10 02:07:23","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"26","purchase_order_id":"10013","date":"2014-01-10 00:00:00","item_description":null,"item_name":"Accessory Strap ()","item_id":"66","discount":"0","discount_type":null,"qty":"1","price_per_unit":"2.0000","price":"2.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:10:21","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2014-01-10 02:07:24', 'admin'),
(508, 'inventory', 'status_update', 'pr', 7, '{"id":"7","txn_no":"1-10004","po_id":"10013","number":null,"date":"2014-01-10 00:00:00","due_date":null,"contact_person":" ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-01-10 01:56:15","added_by":"azizan","modified_on":"2014-01-10 02:06:16","modified_by":"azizan","division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"13","purchase_request_id":"7","date":"2014-01-10 00:00:00","item_description":null,"item_name":"Accessory Strap ()","item_id":"66","discount":"0","discount_type":null,"qty":"1","price_per_unit":"2.0000","price":"2.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:10:21","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2014-01-10 02:08:31', 'azizan'),
(509, 'inventory', 'edit', 'pr', 7, '{"id":"7","txn_no":"1-10004","po_id":"10013","number":null,"date":"2014-01-10 00:00:00","due_date":null,"contact_person":" ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3002.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-01-10 01:56:15","added_by":"azizan","modified_on":"2014-01-10 02:13:08","modified_by":"azizan","division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"14","purchase_request_id":"7","date":"2014-01-10 00:00:00","item_description":null,"item_name":"Accessory Strap ()","item_id":"66","discount":"0","discount_type":null,"qty":"1","price_per_unit":"2.0000","price":"2.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"},{"id":"15","purchase_request_id":"7","date":"2014-01-10 00:00:00","item_description":null,"item_name":"All-In-One POS ()","item_id":"77","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3000.0000","price":"3000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:10:21","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"77":{"id":"77","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"All-In-One POS","model_no":"","warranty":"","sku":"POS01231","sku2":"","sku3":"","sku4":"","qty":null,"alert_quantity":"0","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4000.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2013-09-06 22:41:18","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":"1378478478","order":null,"warehouse_id":"1"}}}', '2014-01-10 02:13:08', 'azizan'),
(510, 'inventory', 'edit', 'pr', 7, '{"id":"7","txn_no":"1-10004","po_id":"10013","number":null,"date":"2014-01-10 00:00:00","due_date":null,"contact_person":" ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3002.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-01-10 01:56:15","added_by":"azizan","modified_on":"2014-01-10 10:30:37","modified_by":"azizan","division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"16","purchase_request_id":"7","date":"2014-01-10 00:00:00","item_description":null,"item_name":"Accessory Strap ()","item_id":"66","discount":"0","discount_type":null,"qty":"1","price_per_unit":"2.0000","price":"2.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"},{"id":"18","purchase_request_id":"7","date":"2014-01-10 00:00:00","item_description":null,"item_name":"All-In-One POS ()","item_id":"77","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3000.0000","price":"3000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"},{"id":"17","purchase_request_id":"7","date":"2014-01-10 00:00:00","item_description":null,"item_name":"Basic Bankbook Holder ()","item_id":"36","discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"73","alert_quantity":"2","max_quantity":"0","cost":"49.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-06-20 17:21:03","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:10:21","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"77":{"id":"77","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"All-In-One POS","model_no":"","warranty":"","sku":"POS01231","sku2":"","sku3":"","sku4":"","qty":null,"alert_quantity":"0","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4000.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2013-09-06 22:41:18","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":"1378478478","order":null,"warehouse_id":"1"}}}', '2014-01-10 10:30:38', 'azizan'),
(511, 'inventory', 'edit', 'pr', 7, '{"id":"7","txn_no":"1-10004","po_id":"10013","number":null,"date":"2014-01-10 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3092.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-01-10 01:56:15","added_by":"azizan","modified_on":"2014-01-10 10:36:16","modified_by":"admin","division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"19","purchase_request_id":"7","date":"2014-01-10 00:00:00","item_description":null,"item_name":"Accessory Strap ()","item_id":"66","discount":"0","discount_type":null,"qty":"1","price_per_unit":"2.0000","price":"2.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"},{"id":"20","purchase_request_id":"7","date":"2014-01-10 00:00:00","item_description":null,"item_name":"All-In-One POS ()","item_id":"77","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3000.0000","price":"3000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"},{"id":"21","purchase_request_id":"7","date":"2014-01-10 00:00:00","item_description":null,"item_name":"Basic Bankbook Holder ()","item_id":"36","discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"},{"id":"23","purchase_request_id":"7","date":"2014-01-10 00:00:00","item_description":null,"item_name":"Table Case Metallic Leather ()","item_id":"54","discount":"0","discount_type":null,"qty":"1","price_per_unit":"90.0000","price":"90.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"},{"id":"22","purchase_request_id":"7","date":"2014-01-10 00:00:00","item_description":null,"item_name":"Torsade Table Lamp 30 (24)","item_id":"12","discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"36":{"id":"36","primary_image":"BasicBankbookHolder.jpg","image":"BasicBankbookHolder.jpg","category":"Women","subcategory":"Accessories","brand":"0","location":"","name":"Basic Bankbook Holder","model_no":"","warranty":"","sku":"BBH235830","sku2":"","sku3":"","sku4":"","qty":"73","alert_quantity":"2","max_quantity":"0","cost":"49.00","average_cost":null,"price":"55.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"1","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:32:20","added_by":"admin","modified_on":"2013-03-16 14:14:36","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-06-20 17:21:03","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"77":{"id":"77","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"All-In-One POS","model_no":"","warranty":"","sku":"POS01231","sku2":"","sku3":"","sku4":"","qty":null,"alert_quantity":"0","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4000.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2013-09-06 22:41:18","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":"1378478478","order":null,"warehouse_id":"1"},"66":{"id":"66","primary_image":"AccessoryStrap.jpg","image":"AccessoryStrap.jpg","category":"Men","subcategory":"Accessories","brand":"0","location":"","name":"Accessory Strap","model_no":"","warranty":"","sku":"AS1022","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"2.00","average_cost":null,"price":"6.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 14:00:02","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-11 22:10:21","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"12":{"id":"12","primary_image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","image":"xTorsade30.jpg.pagespeed_.ic_.-gW70U-ZJ3_.jpg","category":"Home","subcategory":"Lighting","brand":"0","location":"","name":"Torsade Table Lamp 30","model_no":"","warranty":"","sku":"TTL23012","sku2":"4321","sku3":"","sku4":"","qty":"0","alert_quantity":"1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:03:25","added_by":"admin","modified_on":"2013-03-09 13:36:43","modified_by":"admin2","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"24","uom2":"44","uom3":"","uom4":"","loose_qty2":"2","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2013-03-11 22:08:41","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"54":{"id":"54","primary_image":"TabletCaseMetallicLeather.jpg","image":"TabletCaseMetallicLeather.jpg","category":"Women","subcategory":"Bags","brand":"0","location":"","name":"Table Case Metallic Leather","model_no":"","warranty":"","sku":"TCML12349801","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"3","max_quantity":"0","cost":"0.00","average_cost":null,"price":"160.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:51:01","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2014-01-10 10:36:17', 'admin'),
(512, 'inventory', 'add', 'dn', 10001, '{"id":"10001","txn_no":"1-10001","cn_number":"","date":"2014-01-13 00:00:00","contact_person":"Administrator ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":null,"terms":"Credit","remarks":"","status":"Pending","payment_status":"Unpaid","payment_reference":null,"payment_date":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3000.00","total_received":null,"tags":"","added_on":"2014-01-13 00:09:08","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","debit_note_id":"10001","date":"2014-01-13 00:00:00","item_id":"77","item_name":"All-In-One POS ()","item_description":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"3000.0000","price":"3000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"77":{"id":"77","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"All-In-One POS","model_no":"","warranty":"","sku":"POS01231","sku2":"","sku3":"","sku4":"","qty":null,"alert_quantity":"0","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4000.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2013-09-06 22:41:18","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":"1378478478","order":null,"warehouse_id":"1"}}}', '2014-01-13 00:09:08', 'admin'),
(513, 'inventory', 'status_update', 'pr', 6, '{"id":"6","txn_no":"1-10003","po_id":null,"number":null,"date":"2014-01-10 00:00:00","due_date":null,"contact_person":" ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3000.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-01-10 01:36:01","added_by":"azizan","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"11","purchase_request_id":"6","date":"2014-01-10 00:00:00","item_description":null,"item_name":"All-In-One POS ()","item_id":"77","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3000.0000","price":"3000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"77":{"id":"77","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"All-In-One POS","model_no":"","warranty":"","sku":"POS01231","sku2":"","sku3":"","sku4":"","qty":null,"alert_quantity":"0","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4000.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2013-09-06 22:41:18","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":"1378478478","order":null,"warehouse_id":"1"}}}', '2014-01-21 11:20:25', 'admin'),
(514, 'inventory', 'edit', 'pr', 6, '{"id":"6","txn_no":"1-10003","po_id":null,"number":null,"date":"2014-01-10 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3000.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-01-10 01:36:01","added_by":"azizan","modified_on":"2014-01-21 11:20:38","modified_by":"admin","division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"24","purchase_request_id":"6","date":"2014-01-10 00:00:00","item_description":null,"item_name":"All-In-One POS ()","item_id":"77","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3000.0000","price":"3000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"77":{"id":"77","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"All-In-One POS","model_no":"","warranty":"","sku":"POS01231","sku2":"","sku3":"","sku4":"","qty":null,"alert_quantity":"0","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4000.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2013-09-06 22:41:18","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":"1378478478","order":null,"warehouse_id":"1"}}}', '2014-01-21 11:20:38', 'admin'),
(515, 'inventory', 'edit', 'pr', 6, '{"id":"6","txn_no":"1-10003","po_id":null,"number":null,"date":"2014-01-10 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3000.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-01-10 01:36:01","added_by":"azizan","modified_on":"2014-01-21 11:21:01","modified_by":"admin","division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"25","purchase_request_id":"6","date":"2014-01-10 00:00:00","item_description":null,"item_name":"All-In-One POS ()","item_id":"77","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3000.0000","price":"3000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"77":{"id":"77","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"All-In-One POS","model_no":"","warranty":"","sku":"POS01231","sku2":"","sku3":"","sku4":"","qty":null,"alert_quantity":"0","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4000.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2013-09-06 22:41:18","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":"1378478478","order":null,"warehouse_id":"1"}}}', '2014-01-21 11:21:01', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(516, 'inventory', 'status_update', 'pr', 6, '{"id":"6","txn_no":"1-10003","po_id":null,"number":null,"date":"2014-01-10 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Completed","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3000.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-01-10 01:36:01","added_by":"azizan","modified_on":"2014-01-21 11:21:01","modified_by":"admin","division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"25","purchase_request_id":"6","date":"2014-01-10 00:00:00","item_description":null,"item_name":"All-In-One POS ()","item_id":"77","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3000.0000","price":"3000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"77":{"id":"77","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"All-In-One POS","model_no":"","warranty":"","sku":"POS01231","sku2":"","sku3":"","sku4":"","qty":null,"alert_quantity":"0","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4000.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2013-09-06 22:41:18","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":"1378478478","order":null,"warehouse_id":"1"}}}', '2014-01-21 11:21:10', 'admin'),
(517, 'inventory', 'status_update', 'pr', 6, '{"id":"6","txn_no":"1-10003","po_id":null,"number":null,"date":"2014-01-10 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3000.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-01-10 01:36:01","added_by":"azizan","modified_on":"2014-01-21 11:21:01","modified_by":"admin","division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"25","purchase_request_id":"6","date":"2014-01-10 00:00:00","item_description":null,"item_name":"All-In-One POS ()","item_id":"77","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3000.0000","price":"3000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"77":{"id":"77","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"All-In-One POS","model_no":"","warranty":"","sku":"POS01231","sku2":"","sku3":"","sku4":"","qty":null,"alert_quantity":"0","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4000.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2013-09-06 22:41:18","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":"1378478478","order":null,"warehouse_id":"1"}}}', '2014-01-21 11:21:13', 'admin'),
(518, 'inventory', 'edit', 'pr', 6, '{"id":"6","txn_no":"1-10003","po_id":null,"number":null,"date":"2014-01-10 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3000.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-01-10 01:36:01","added_by":"azizan","modified_on":"2014-01-21 11:21:20","modified_by":"admin","division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"26","purchase_request_id":"6","date":"2014-01-10 00:00:00","item_description":null,"item_name":"All-In-One POS ()","item_id":"77","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3000.0000","price":"3000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"77":{"id":"77","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"All-In-One POS","model_no":"","warranty":"","sku":"POS01231","sku2":"","sku3":"","sku4":"","qty":null,"alert_quantity":"0","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4000.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2013-09-06 22:41:18","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":"1378478478","order":null,"warehouse_id":"1"}}}', '2014-01-21 11:21:20', 'admin'),
(519, 'inventory', 'status_update', 'pr', 6, '{"id":"6","txn_no":"1-10003","po_id":null,"number":null,"date":"2014-01-10 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Completed","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3000.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-01-10 01:36:01","added_by":"azizan","modified_on":"2014-01-21 11:21:20","modified_by":"admin","division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"26","purchase_request_id":"6","date":"2014-01-10 00:00:00","item_description":null,"item_name":"All-In-One POS ()","item_id":"77","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3000.0000","price":"3000.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"77":{"id":"77","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"All-In-One POS","model_no":"","warranty":"","sku":"POS01231","sku2":"","sku3":"","sku4":"","qty":null,"alert_quantity":"0","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4000.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2013-09-06 22:41:18","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":"1378478478","order":null,"warehouse_id":"1"}}}', '2014-01-21 11:21:26', 'admin'),
(520, 'contacts', 'edit', 'contact', 1141, '{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:12","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"}', '2014-01-25 23:29:12', 'admin'),
(521, 'contacts', 'edit', 'contact', 1141, '{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"}', '2014-01-25 23:29:58', 'admin'),
(522, 'sales', 'add', 'invoice', 10020, '{"id":"10020","txn_no":"1-10020","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-01-26 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2625.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-01-26 01:49:59","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"125.00\\"}","total_tax":"125.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"36","invoice_id":"10020","type":"service","date":"2014-01-26 12:00:00","item_name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","item_description":"December 2013","item_id":"0","service_id":"52","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"52":{"id":"52","name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","description":"","category":"0","subcategory":"0","cost":"2000.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-01-26 01:47:56","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-01-26 01:50:00', 'admin'),
(523, 'sales', 'add', 'invoice', 10021, '{"id":"10021","txn_no":"1-10021","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-01-26 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-01-26 01:52:59","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"0.00\\"}","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"37","invoice_id":"10021","type":"service","date":"2014-01-26 12:00:00","item_name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","item_description":"January 2014","item_id":"0","service_id":"52","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"52":{"id":"52","name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","description":"","category":"0","subcategory":"0","cost":"2000.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-01-26 01:47:56","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-01-26 01:52:59', 'admin'),
(524, 'sales', 'edit', 'invoice', NULL, '[]', '2014-01-26 01:53:30', 'admin'),
(525, 'sales', 'edit', 'invoice', NULL, '[]', '2014-01-26 01:53:44', 'admin'),
(526, 'sales', 'deliver', 'invoice', 10020, '{"id":"10020","txn_no":"1-10020","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-01-26 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2625.00","total_delivered":"2500.00","cost":null,"tags":"","added_on":"2014-01-26 01:49:59","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"125.00\\"}","total_tax":"125.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"36","invoice_id":"10020","type":"service","date":"2014-01-26 12:00:00","item_name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","item_description":"December 2013","item_id":"0","service_id":"52","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":"1","delivered_price":"2500.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"52":{"id":"52","name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","description":"","category":"0","subcategory":"0","cost":"2000.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-01-26 01:47:56","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-01-26 02:08:15', 'admin'),
(527, 'sales', 'status_update', 'invoice', 10020, '{"id":"10020","txn_no":"1-10020","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-01-26 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Partially Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2625.00","total_delivered":"2500.00","cost":null,"tags":"","added_on":"2014-01-26 01:49:59","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"125.00\\"}","total_tax":"125.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"36","invoice_id":"10020","type":"service","date":"2014-01-26 12:00:00","item_name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","item_description":"December 2013","item_id":"0","service_id":"52","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":"1","delivered_price":"2500.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"52":{"id":"52","name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","description":"","category":"0","subcategory":"0","cost":"2000.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-01-26 01:47:56","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-01-26 02:08:18', 'admin'),
(528, 'sales', 'status_update', 'invoice', 10020, '{"id":"10020","txn_no":"1-10020","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-01-26 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2625.00","total_delivered":"0.00","cost":null,"tags":"","added_on":"2014-01-26 01:49:59","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"125.00\\"}","total_tax":"125.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"36","invoice_id":"10020","type":"service","date":"2014-01-26 12:00:00","item_name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","item_description":"December 2013","item_id":"0","service_id":"52","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"2500.00","done":"0","no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"52":{"id":"52","name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","description":"","category":"0","subcategory":"0","cost":"2000.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-01-26 01:47:56","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-01-26 16:46:18', 'admin'),
(529, 'sales', 'edit', 'invoice', NULL, '[]', '2014-01-26 18:29:14', 'admin'),
(530, 'sales', 'edit', 'invoice', NULL, '[]', '2014-01-27 12:45:08', 'admin'),
(531, 'sales', 'edit', 'invoice', NULL, '[]', '2014-01-27 12:53:25', 'admin'),
(532, 'sales', 'edit', 'invoice', NULL, '[]', '2014-01-27 12:55:24', 'admin'),
(533, 'sales', 'edit', 'invoice', NULL, '[]', '2014-01-27 12:59:14', 'admin'),
(534, 'sales', 'edit', 'invoice', NULL, '[]', '2014-01-27 12:59:29', 'admin'),
(535, 'sales', 'edit', 'invoice', NULL, '[]', '2014-01-27 13:02:23', 'admin'),
(536, 'sales', 'edit', 'invoice', NULL, '[]', '2014-01-27 13:03:13', 'admin'),
(537, 'sales', 'edit', 'invoice', NULL, '[]', '2014-01-27 13:05:13', 'admin'),
(538, 'sales', 'edit', 'invoice', NULL, '[]', '2014-01-27 13:06:57', 'admin'),
(539, 'sales', 'edit', 'invoice', NULL, '[]', '2014-01-27 13:11:59', 'admin'),
(540, 'sales', 'edit', 'invoice', NULL, '[]', '2014-01-27 13:14:56', 'admin'),
(541, 'sales', 'edit', 'invoice', NULL, '[]', '2014-01-27 13:20:53', 'admin'),
(542, 'sales', 'edit', 'invoice', NULL, '[]', '2014-01-27 13:23:25', 'admin'),
(543, 'sales', 'edit', 'invoice', NULL, '[]', '2014-01-27 13:23:32', 'admin'),
(544, 'sales', 'edit', 'invoice', NULL, '[]', '2014-01-27 13:24:19', 'admin'),
(545, 'sales', 'edit', 'invoice', 10020, '{"id":"10020","txn_no":"1-10020","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-01-26 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2625.00","total_delivered":"0.00","cost":null,"tags":"","added_on":"2014-01-26 01:49:59","added_by":"admin","modified_on":"2014-01-27 13:25:26","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"125.00\\"}","total_tax":"125.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"56","invoice_id":"10020","type":"service","date":"2014-01-26 12:00:00","item_name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","item_description":"December 2013","item_id":"0","service_id":"52","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"52":{"id":"52","name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","description":"","category":"0","subcategory":"0","cost":"2000.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-01-26 01:47:56","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-01-27 13:25:26', 'admin'),
(546, 'sales', 'edit', 'invoice', 10020, '{"id":"10020","txn_no":"1-10020","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-01-26 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":"0.00","cost":null,"tags":"","added_on":"2014-01-26 01:49:59","added_by":"admin","modified_on":"2014-01-27 13:25:31","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"57","invoice_id":"10020","type":"service","date":"2014-01-26 12:00:00","item_name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","item_description":"December 2013","item_id":"0","service_id":"52","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"52":{"id":"52","name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","description":"","category":"0","subcategory":"0","cost":"2000.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-01-26 01:47:56","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-01-27 13:25:31', 'admin'),
(547, 'sales', 'edit', 'invoice', 10021, '{"id":"10021","txn_no":"1-10021","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-01-26 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-01-26 01:52:59","added_by":"admin","modified_on":"2014-01-27 13:25:53","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"58","invoice_id":"10021","type":"service","date":"2014-01-26 12:00:00","item_name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","item_description":"January 2014","item_id":"0","service_id":"52","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"52":{"id":"52","name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","description":"","category":"0","subcategory":"0","cost":"2000.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-01-26 01:47:56","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-01-27 13:25:53', 'admin'),
(548, 'sales', 'edit', 'invoice', 10021, '{"id":"10021","txn_no":"1-10021","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-01-10 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-01-26 01:52:59","added_by":"admin","modified_on":"2014-01-27 13:28:00","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"59","invoice_id":"10021","type":"service","date":"2014-01-10 12:00:00","item_name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","item_description":"January 2014","item_id":"0","service_id":"52","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"52":{"id":"52","name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","description":"","category":"0","subcategory":"0","cost":"2000.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-01-26 01:47:56","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-01-27 13:28:00', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(549, 'sales', 'edit', 'invoice', 10021, '{"id":"10021","txn_no":"1-10021","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-01-26 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-01-26 01:52:59","added_by":"admin","modified_on":"2014-01-27 13:28:46","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"60","invoice_id":"10021","type":"service","date":"2014-01-26 12:00:00","item_name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","item_description":"January 2014","item_id":"0","service_id":"52","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"52":{"id":"52","name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","description":"","category":"0","subcategory":"0","cost":"2000.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-01-26 01:47:56","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-01-27 13:28:46', 'admin'),
(550, 'sales', 'edit', 'invoice', 10021, '{"id":"10021","txn_no":"1-10021","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-01-26 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-01-26 01:52:59","added_by":"admin","modified_on":"2014-01-27 13:28:51","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"61","invoice_id":"10021","type":"service","date":"2014-01-26 12:00:00","item_name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","item_description":"January 2014","item_id":"0","service_id":"52","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"52":{"id":"52","name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","description":"","category":"0","subcategory":"0","cost":"2000.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-01-26 01:47:56","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-01-27 13:28:51', 'admin'),
(551, 'sales', 'edit', 'invoice', 10021, '{"id":"10021","txn_no":"1-10021","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-01-26 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-01-26 01:52:59","added_by":"admin","modified_on":"2014-01-27 13:28:58","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"62","invoice_id":"10021","type":"service","date":"2014-01-26 12:00:00","item_name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","item_description":"January 2014","item_id":"0","service_id":"52","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"52":{"id":"52","name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","description":"","category":"0","subcategory":"0","cost":"2000.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-01-26 01:47:56","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-01-27 13:28:58', 'admin'),
(552, 'sales', 'edit', 'invoice', 10020, '{"id":"10020","txn_no":"1-10020","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-01-10 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":"0.00","cost":null,"tags":"","added_on":"2014-01-26 01:49:59","added_by":"admin","modified_on":"2014-01-27 13:29:12","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"63","invoice_id":"10020","type":"service","date":"2014-01-10 12:00:00","item_name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","item_description":"December 2013","item_id":"0","service_id":"52","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"52":{"id":"52","name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","description":"","category":"0","subcategory":"0","cost":"2000.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-01-26 01:47:56","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-01-27 13:29:12', 'admin'),
(553, 'contacts', 'add', 'contact', 1148, '{"id":"1148","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Alpha Catalyst Consulting Sdn Bhd","company_registration":"","contact_person":"Azim","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Level 36","address2":"Menara Maxis","city":"Kuala Lumpur City Centre","state":"Kuala Lumpur","zipcode":"50088","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-01-29 12:30:15","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-01-29 12:30:15', 'admin'),
(554, 'sales', 'add', 'invoice', 10022, '{"id":"10022","txn_no":"1-10022","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-01-29 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Alpha Catalyst Consulting Sdn Bhd","contact_id":"1148","contact_address":"{\\"address1\\":\\"Level 36\\",\\"address2\\":\\"Menara Maxis\\",\\"zipcode\\":\\"50088\\",\\"city\\":\\"Kuala Lumpur City Centre\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Alpha Catalyst Consulting Sdn Bhd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"Level 36\\",\\"address2\\":\\"Menara Maxis\\",\\"zipcode\\":\\"50088\\",\\"city\\":\\"Kuala Lumpur City Centre\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-01-29 12:32:14","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"64","invoice_id":"10022","type":"service","date":"2014-01-29 12:00:00","item_name":"Consulting & Professional Fee","item_description":"","item_id":"0","service_id":"22","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"4500.0000","price":"4500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"22":{"id":"22","name":"Consultation Fee","description":"","category":"0","subcategory":"0","cost":"10.00","price":"20.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-11-08 21:12:47","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}},"customer":{"id":"1148","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Alpha Catalyst Consulting Sdn Bhd","company_registration":"","contact_person":"Azim","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Level 36","address2":"Menara Maxis","city":"Kuala Lumpur City Centre","state":"Kuala Lumpur","zipcode":"50088","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-01-29 12:30:15","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-01-29 12:32:15', 'admin'),
(555, 'sales', 'add', 'invoice', 10023, '{"id":"10023","txn_no":"1-10023","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-02-04 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Teh Chai Soon","contact_id":"1140","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Teh Chai Soon\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"RM40 \\/ Hour","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"420.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-02-04 13:52:45","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"65","invoice_id":"10023","type":"service","date":"2014-02-04 12:00:00","item_name":"Seminar Room","item_description":"January \\n17 Jan 2014 - 4 hours\\n18 Jan 2014 - 4 hours\\n19 Jan 2014 - 2 hours","item_id":"0","service_id":"53","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"400.0000","price":"400.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"53":{"id":"53","name":"Seminar Room","description":"","category":"0","subcategory":"0","cost":"40.00","price":"40.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-02-04 13:50:57","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1140","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Teh Chai Soon","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Pulau Pinang","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-06 12:45:29","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1383713129"},"sale":null,"sale_items":null}', '2014-02-04 13:52:45', 'admin'),
(556, 'sales', 'edit', 'invoice', 10023, '{"id":"10023","txn_no":"1-10023","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-02-04 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Teh Chai Soon","contact_id":"1140","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Teh Chai Soon\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"RM40 \\/ Hour","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-02-04 13:52:45","added_by":"admin","modified_on":"2014-02-04 13:53:28","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"66","invoice_id":"10023","type":"service","date":"2014-02-04 12:00:00","item_name":"Seminar Room","item_description":"January \\n17 Jan 2014 - 4 hours\\n18 Jan 2014 - 4 hours\\n19 Jan 2014 - 2 hours","item_id":"0","service_id":"53","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"4000.0000","price":"4000.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"53":{"id":"53","name":"Seminar Room","description":"","category":"0","subcategory":"0","cost":"40.00","price":"40.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-02-04 13:50:57","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1140","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Teh Chai Soon","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Pulau Pinang","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-06 12:45:29","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1383713129"},"sale":null,"sale_items":null}', '2014-02-04 13:53:28', 'admin'),
(557, 'contacts', 'add', 'contact', 1149, '{"id":"1149","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Guru","contact_number":"0166337919","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Kuala Lumpur","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-02-11 23:24:34","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-02-11 23:24:34', 'admin'),
(558, 'sales', 'add', 'quote', 10026, '{"id":"10026","txn_no":"1-10024","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-02-12 00:00:00","due_date":"2014-02-12 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Guru","contact_id":"1149","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Guru\\",\\"mobile\\":\\"0166337919\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"17900.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-02-11 23:31:00","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"121","quote_id":"10026","date":"2014-02-12 00:00:00","type":"service","item_id":"0","service_id":"37","item_name":"Basic F&B Plexcloud Subscription ","item_description":"Plexcloud Modules Included:\\n\\nF&B Module \\nContacts Module\\nReport Module\\nSales Module\\n\\nHardwares Included:\\n\\n\\n6 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\n\\nQuoted price can be converted to 18 months term payment for RM900 monthly ","discount":"0","discount_type":null,"qty":"1","price_per_unit":"17900.0000","price":"17900.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"37":{"id":"37","name":"Basic F&B Plexcloud Subscription ","description":"Plexcloud Modules Included:\\n\\nF&B Module \\nAccount  [Beta]\\nHR [Beta]\\nReport [Beta]\\n\\nHardwares Included:\\n\\n1 Unit F&B Plexcloud in a box\\n2 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\n\\nQuoted price can be converted to 18 months term payment for RM900 monthly ","category":"0","subcategory":"0","cost":"400.00","price":"16200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-07-16 20:52:51","added_by":"admin2","modified_on":"2013-12-11 21:10:55","modified_by":"admin2","warehouse_id":"0"}}}', '2014-02-11 23:31:00', 'admin'),
(559, 'sales', 'edit', 'quote', 10026, '{"id":"10026","txn_no":"1-10024","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-02-12 00:00:00","due_date":"2014-02-12 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Guru","contact_id":"1149","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Guru\\",\\"mobile\\":\\"0166337919\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"17900.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-02-11 23:31:00","added_by":"admin","modified_on":"2014-02-11 23:32:48","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"122","quote_id":"10026","date":"2014-02-12 00:00:00","type":"service","item_id":"0","service_id":"37","item_name":"F&B Plexcloud","item_description":"Plexcloud Modules Included:\\n\\nF&B Module \\nContacts Module\\nReport Module\\nSales Module\\n\\nHardwares Included:\\n\\n\\n6 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer ","discount":"0","discount_type":null,"qty":"1","price_per_unit":"17900.0000","price":"17900.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"37":{"id":"37","name":"Basic F&B Plexcloud Subscription ","description":"Plexcloud Modules Included:\\n\\nF&B Module \\nAccount  [Beta]\\nHR [Beta]\\nReport [Beta]\\n\\nHardwares Included:\\n\\n1 Unit F&B Plexcloud in a box\\n2 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\n\\nQuoted price can be converted to 18 months term payment for RM900 monthly ","category":"0","subcategory":"0","cost":"400.00","price":"16200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-07-16 20:52:51","added_by":"admin2","modified_on":"2013-12-11 21:10:55","modified_by":"admin2","warehouse_id":"0"}}}', '2014-02-11 23:32:48', 'admin'),
(560, 'sales', 'add', 'so', 10016, '{"id":"10016","txn_no":"1-10013","quote_id":"0","invoice_id":null,"number":"0","pr_number":null,"po_number":"0","date":"2014-02-15 00:00:00","due_date":"2014-02-15 00:00:00","received_date":null,"contact_person":"JawiHerbShop ","contact":"Noraishah Kamarudin","contact_id":"1108","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"0\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Noraishah Kamarudin\\",\\"mobile\\":\\"0153210321\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"231.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-02-14 22:05:46","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"17","sales_order_id":"10016","type":"product","date":"2014-02-15 00:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"3","price_per_unit":"77.0000","price":"231.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-25 22:15:19","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2014-02-14 22:05:46', 'admin2'),
(561, 'sales', 'status_update', 'so', 10016, '{"id":"10016","txn_no":"1-10013","quote_id":"0","invoice_id":null,"number":"0","pr_number":null,"po_number":"0","date":"2014-02-15 00:00:00","due_date":"2014-02-15 00:00:00","received_date":null,"contact_person":"JawiHerbShop ","contact":"Noraishah Kamarudin","contact_id":"1108","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"0\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Noraishah Kamarudin\\",\\"mobile\\":\\"0153210321\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","terms":"Credit","duration":"0","remarks":"","status":"Completed","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"231.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-02-14 22:05:46","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"17","sales_order_id":"10016","type":"product","date":"2014-02-15 00:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"3","price_per_unit":"77.0000","price":"231.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-25 22:15:19","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2014-02-14 22:06:11', 'admin2'),
(562, 'sales', 'add', 'invoice', 10024, '{"id":"10024","txn_no":"1-10024","quote_id":"0","sales_order_id":"10016","number":"0","po_number":"N\\/A","date":"2014-02-15 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Noraishah Kamarudin","contact_id":"1108","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"0\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Noraishah Kamarudin\\",\\"mobile\\":\\"0153210321\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"231.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-02-14 22:06:37","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"67","invoice_id":"10024","type":"product","date":"2014-02-15 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"3","price_per_unit":"77.0000","price":"231.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-25 22:15:19","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1108","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Noraishah Kamarudin","contact_number":"0153210321","credit_limit":"0.00","rank":"Normal Member","email":"","ic":"841231087654","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"0","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:01:35","added_by":"admin","modified_on":"2013-04-01 20:49:00","modified_by":"admin2","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-02-14 22:06:38', 'admin2'),
(563, 'sales', 'status_update', 'invoice', 10024, '{"id":"10024","txn_no":"1-10024","quote_id":"0","sales_order_id":"10016","number":"0","po_number":"N\\/A","date":"2014-02-15 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Noraishah Kamarudin","contact_id":"1108","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"0\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Noraishah Kamarudin\\",\\"mobile\\":\\"0153210321\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Partially Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"231.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-02-14 22:06:37","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"67","invoice_id":"10024","type":"product","date":"2014-02-15 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"3","price_per_unit":"77.0000","price":"231.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-25 22:15:19","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1108","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Noraishah Kamarudin","contact_number":"0153210321","credit_limit":"0.00","rank":"Normal Member","email":"","ic":"841231087654","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"0","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:01:35","added_by":"admin","modified_on":"2013-04-01 20:49:00","modified_by":"admin2","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-02-14 22:07:16', 'admin2');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(564, 'sales', 'status_update', 'invoice', 10024, '{"id":"10024","txn_no":"1-10024","quote_id":"0","sales_order_id":"10016","number":"0","po_number":"N\\/A","date":"2014-02-15 12:00:00","due_date":null,"received_date":null,"contact_person":"JawiHerbShop ","contact":"Noraishah Kamarudin","contact_id":"1108","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"0\\",\\"country\\":\\"0\\"}","delivery_address":"{\\"name\\":\\"Noraishah Kamarudin\\",\\"mobile\\":\\"0153210321\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"231.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-02-14 22:06:37","added_by":"admin2","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"67","invoice_id":"10024","type":"product","date":"2014-02-15 12:00:00","item_name":"Almeta","item_description":"","item_id":"25","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"3","price_per_unit":"77.0000","price":"231.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"25":{"id":"25","primary_image":"Almeta.jpg","image":"Almeta.jpg","category":"Home","subcategory":"Bedding","brand":"0","location":"","name":"Almeta","model_no":"","warranty":"","sku":"SCA1231","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"2","max_quantity":"0","cost":"50.00","average_cost":null,"price":"77.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2012-12-12 13:19:20","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":null,"weight3":null,"weight4":null,"volume":"0.00","volume_unit":"cm3","volume2":null,"volume3":null,"volume4":null,"min_cart_qty":"1","max_cart_qty":"2","ready_for_sale":"1","last_sold":"2013-03-25 22:15:19","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1108","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Noraishah Kamarudin","contact_number":"0153210321","credit_limit":"0.00","rank":"Normal Member","email":"","ic":"841231087654","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"0","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:01:35","added_by":"admin","modified_on":"2013-04-01 20:49:00","modified_by":"admin2","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-02-14 22:07:28', 'admin2'),
(565, 'sales', 'edit', 'invoice', 10019, '{"id":"10019","txn_no":"1-10019","quote_id":"10025","sales_order_id":"10015","number":"0","po_number":"QUO-10025","date":"2014-01-02 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Rozita","contact_id":"1147","contact_address":"{\\"address1\\":\\"Lagenda Heights\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"Balance RM2000.00","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-01-02 12:38:29","added_by":"admin","modified_on":"2014-02-17 13:34:54","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"68","invoice_id":"10019","type":"service","date":"2014-01-02 12:00:00","item_name":"All-In-One POS ","item_description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n","item_id":"0","service_id":"26","item_sku":null,"discount":"200","discount_type":"d","qty":"1","price_per_unit":"4200.0000","price":"4200.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"}},"customer":{"id":"1147","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Rozita","company_registration":"","contact_person":"Rozita","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lagenda Heights","address2":"","city":"Sungai Petani","state":"Kedah","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-01-02 12:36:04","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-02-17 13:34:54', 'admin'),
(566, 'contacts', 'add', 'contact', 1150, '{"id":"1150","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Kas Baiduri","company_registration":"00225346-D","contact_person":"Amar ","contact_number":"0111 - 465 3330","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Pulau Pinang","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"info@kasbaiduri.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-02-18 14:42:02","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-02-18 14:42:02', 'admin'),
(567, 'contacts', 'add', 'contact', 1151, '{"id":"1151","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Collaborative Research in Engineering, Science & Technology (CREST)","company_registration":"","contact_person":"Nurshahida Bt Azman","contact_number":"604 652 0088","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"sains@usm,Block C, Ground Floor","address2":" No.10 Persiaran Bukit Jambul","city":"Bayan Lepas","state":"Pulau Pinang","zipcode":"11900 ","country":"Malaysia","tel":"604 652 0088","fax":"604 652 0099","general_email":"nurshahida@crest.my","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-02-24 09:26:24","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-02-24 09:26:24', 'admin'),
(568, 'sales', 'add', 'quote', 10027, '{"id":"10027","txn_no":"1-10025","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-02-19 00:00:00","due_date":"2014-03-19 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Collaborative Research in Engineering, Science & Technology (CREST)","contact_id":"1151","contact_address":"{\\"address1\\":\\"sains@usm,Block C, Ground Floor\\",\\"address2\\":\\" No.10 Persiaran Bukit Jambul\\",\\"zipcode\\":\\"11900 \\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Collaborative Research in Engineering, Science & Technology (CREST)\\",\\"mobile\\":\\"604 652 0088\\",\\"address1\\":\\"sains@usm,Block C, Ground Floor\\",\\"address2\\":\\" No.10 Persiaran Bukit Jambul\\",\\"zipcode\\":\\"11900 \\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4400.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-02-24 09:28:09","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"123","quote_id":"10027","date":"2014-02-19 00:00:00","type":"service","item_id":"0","service_id":"54","item_name":"Equipment and Supplier Query System and Wordpress Maintenance","item_description":"A. Equipment and Supplier Query System\\n\\nRM 3,800.00\\n\\n1. One admin Login system with entry\\n2. Database entry of Equipment and Supplier\\n3. To display result based on Equipment Query\\n\\nB. Wordpress Maintenance\\n\\nRM 600.00\\n\\n1. To update the content of Crest.my\\n2. Content is provided by Crest.my\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"4400.0000","price":"4400.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"54":{"id":"54","name":"Equipment and Supplier Query System and Wordpress Maintenance","description":"A. Equipment and Supplier Query System\\n\\nRM 3,800.00\\n\\n1. One admin Login system with entry\\n2. Database entry of Equipment and Supplier\\n3. To display result based on Equipment Query\\n\\nB. Wordpress Maintenance\\n\\nRM 600.00\\n\\n1. To update the content of Crest.my\\n2. Content is provided by Crest.my\\n","category":"0","subcategory":"0","cost":"800.00","price":"4400.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-02-24 09:23:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2014-02-24 09:28:09', 'admin'),
(569, 'sales', 'edit', 'quote', 10027, '{"id":"10027","txn_no":"1-10025","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-02-19 00:00:00","due_date":"2014-03-19 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Collaborative Research in Engineering, Science & Technology (CREST)","contact_id":"1151","contact_address":"{\\"address1\\":\\"sains@usm,Block C, Ground Floor\\",\\"address2\\":\\" No.10 Persiaran Bukit Jambul\\",\\"zipcode\\":\\"11900 \\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Collaborative Research in Engineering, Science & Technology (CREST)\\",\\"mobile\\":\\"604 652 0088\\",\\"address1\\":\\"sains@usm,Block C, Ground Floor\\",\\"address2\\":\\" No.10 Persiaran Bukit Jambul\\",\\"zipcode\\":\\"11900 \\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4400.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-02-24 09:28:09","added_by":"admin","modified_on":"2014-02-24 09:30:23","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"124","quote_id":"10027","date":"2014-02-19 00:00:00","type":"service","item_id":"0","service_id":"54","item_name":"Equipment and Supplier Query System and Wordpress Maintenance","item_description":"A. Equipment and Supplier Query System\\n\\nRM 3,800.00\\n\\n1. One admin Login system with entry\\n2. Database entry of Equipment and Supplier\\n3. To display result based on Equipment Query\\n\\nDuration of Completion 1 Month\\n\\nB. Wordpress Maintenance\\n\\nRM 600.00\\n\\n1. To update the content of Crest.my\\n2. Content is provided by Crest.my\\n\\nDuration of Completion 1 Week","discount":"0","discount_type":null,"qty":"1","price_per_unit":"4400.0000","price":"4400.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"54":{"id":"54","name":"Equipment and Supplier Query System and Wordpress Maintenance","description":"A. Equipment and Supplier Query System\\n\\nRM 3,800.00\\n\\n1. One admin Login system with entry\\n2. Database entry of Equipment and Supplier\\n3. To display result based on Equipment Query\\n\\nB. Wordpress Maintenance\\n\\nRM 600.00\\n\\n1. To update the content of Crest.my\\n2. Content is provided by Crest.my\\n","category":"0","subcategory":"0","cost":"800.00","price":"4400.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-02-24 09:23:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2014-02-24 09:30:23', 'admin'),
(570, 'sales', 'edit', 'invoice', 10022, '{"id":"10022","txn_no":"1-10022","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-02-24 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Alpha Catalyst Consulting Sdn Bhd","contact_id":"1148","contact_address":"{\\"address1\\":\\"Level 36\\",\\"address2\\":\\"Menara Maxis\\",\\"zipcode\\":\\"50088\\",\\"city\\":\\"Kuala Lumpur City Centre\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Alpha Catalyst Consulting Sdn Bhd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"Level 36\\",\\"address2\\":\\"Menara Maxis\\",\\"zipcode\\":\\"50088\\",\\"city\\":\\"Kuala Lumpur City Centre\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-01-29 12:32:14","added_by":"admin","modified_on":"2014-02-24 11:23:03","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"69","invoice_id":"10022","type":"service","date":"2014-02-24 12:00:00","item_name":"Consulting & Professional Fee","item_description":"","item_id":"0","service_id":"22","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"4500.0000","price":"4500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"22":{"id":"22","name":"Consultation Fee","description":"","category":"0","subcategory":"0","cost":"10.00","price":"20.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-11-08 21:12:47","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}},"customer":{"id":"1148","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Alpha Catalyst Consulting Sdn Bhd","company_registration":"","contact_person":"Azim","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Level 36","address2":"Menara Maxis","city":"Kuala Lumpur City Centre","state":"Kuala Lumpur","zipcode":"50088","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-01-29 12:30:15","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-02-24 11:23:04', 'admin'),
(571, 'sales', 'status_update', 'invoice', 10022, '{"id":"10022","txn_no":"1-10022","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-02-24 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Alpha Catalyst Consulting Sdn Bhd","contact_id":"1148","contact_address":"{\\"address1\\":\\"Level 36\\",\\"address2\\":\\"Menara Maxis\\",\\"zipcode\\":\\"50088\\",\\"city\\":\\"Kuala Lumpur City Centre\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Alpha Catalyst Consulting Sdn Bhd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"Level 36\\",\\"address2\\":\\"Menara Maxis\\",\\"zipcode\\":\\"50088\\",\\"city\\":\\"Kuala Lumpur City Centre\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-01-29 12:32:14","added_by":"admin","modified_on":"2014-02-24 11:23:03","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"69","invoice_id":"10022","type":"service","date":"2014-02-24 12:00:00","item_name":"Consulting & Professional Fee","item_description":"","item_id":"0","service_id":"22","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"4500.0000","price":"4500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"22":{"id":"22","name":"Consultation Fee","description":"","category":"0","subcategory":"0","cost":"10.00","price":"20.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-11-08 21:12:47","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}},"customer":{"id":"1148","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Alpha Catalyst Consulting Sdn Bhd","company_registration":"","contact_person":"Azim","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Level 36","address2":"Menara Maxis","city":"Kuala Lumpur City Centre","state":"Kuala Lumpur","zipcode":"50088","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-01-29 12:30:15","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-02-24 11:23:43', 'admin'),
(572, 'sales', 'status_update', 'invoice', 10022, '{"id":"10022","txn_no":"1-10022","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-02-24 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Alpha Catalyst Consulting Sdn Bhd","contact_id":"1148","contact_address":"{\\"address1\\":\\"Level 36\\",\\"address2\\":\\"Menara Maxis\\",\\"zipcode\\":\\"50088\\",\\"city\\":\\"Kuala Lumpur City Centre\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Alpha Catalyst Consulting Sdn Bhd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"Level 36\\",\\"address2\\":\\"Menara Maxis\\",\\"zipcode\\":\\"50088\\",\\"city\\":\\"Kuala Lumpur City Centre\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4500.00","total_delivered":"0.00","cost":null,"tags":"","added_on":"2014-01-29 12:32:14","added_by":"admin","modified_on":"2014-02-24 11:23:03","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"69","invoice_id":"10022","type":"service","date":"2014-02-24 12:00:00","item_name":"Consulting & Professional Fee","item_description":"","item_id":"0","service_id":"22","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"4500.0000","price":"4500.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":null,"done":"0","no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"22":{"id":"22","name":"Consultation Fee","description":"","category":"0","subcategory":"0","cost":"10.00","price":"20.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-11-08 21:12:47","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}},"customer":{"id":"1148","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Alpha Catalyst Consulting Sdn Bhd","company_registration":"","contact_person":"Azim","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Level 36","address2":"Menara Maxis","city":"Kuala Lumpur City Centre","state":"Kuala Lumpur","zipcode":"50088","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-01-29 12:30:15","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-02-24 11:24:09', 'admin'),
(573, 'sales', 'edit', 'invoice', 10022, '{"id":"10022","txn_no":"1-10022","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-02-24 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Alpha Catalyst Consulting Sdn Bhd","contact_id":"1148","contact_address":"{\\"address1\\":\\"Level 36\\",\\"address2\\":\\"Menara Maxis\\",\\"zipcode\\":\\"50088\\",\\"city\\":\\"Kuala Lumpur City Centre\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Alpha Catalyst Consulting Sdn Bhd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"Level 36\\",\\"address2\\":\\"Menara Maxis\\",\\"zipcode\\":\\"50088\\",\\"city\\":\\"Kuala Lumpur City Centre\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4500.00","total_delivered":"0.00","cost":null,"tags":"","added_on":"2014-01-29 12:32:14","added_by":"admin","modified_on":"2014-02-24 11:24:27","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"70","invoice_id":"10022","type":"service","date":"2014-02-24 12:00:00","item_name":"IT Professional Fee (Jan 2014)","item_description":"","item_id":"0","service_id":"22","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"4500.0000","price":"4500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"22":{"id":"22","name":"Consultation Fee","description":"","category":"0","subcategory":"0","cost":"10.00","price":"20.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-11-08 21:12:47","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}},"customer":{"id":"1148","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Alpha Catalyst Consulting Sdn Bhd","company_registration":"","contact_person":"Azim","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Level 36","address2":"Menara Maxis","city":"Kuala Lumpur City Centre","state":"Kuala Lumpur","zipcode":"50088","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-01-29 12:30:15","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-02-24 11:24:27', 'admin'),
(574, 'sales', 'add', 'invoice', 10025, '{"id":"10025","txn_no":"1-10025","quote_id":"0","sales_order_id":"0","number":"0","po_number":"KAS-0001","date":"2014-02-25 12:00:00","due_date":null,"received_date":null,"contact_person":"Shamir Adnan","contact":"Kas Baiduri","contact_id":"1150","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Kas Baiduri\\",\\"mobile\\":\\"0111 - 465 3330\\",\\"address1\\":\\"No 16-A Tingkat 1, Kompleks Sempilai\\",\\"address2\\":\\"Jalan Sempilai, Seberang Jaya\\",\\"zipcode\\":\\"13700\\",\\"city\\":\\"Seberang Perai\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-02-24 23:16:28","added_by":"shamiradnan","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"71","invoice_id":"10025","type":"service","date":"2014-02-25 12:00:00","item_name":"Plexcloud Sales System for KasBaiduri","item_description":"1. Deployment of Plexcloud for KasBaiduri\\n2. Training usage of Plexcloud System\\n","item_id":"0","service_id":"55","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"4000.0000","price":"4000.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"55":{"id":"55","name":"Plexcloud Sales System for KasBaiduri","description":"1. Deployment of Plexcloud for KasBaiduri\\n2. Training usage of Plexcloud System\\n","category":"0","subcategory":"0","cost":"0.00","price":"4000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-02-24 23:13:40","added_by":"shamiradnan","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1150","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Kas Baiduri","company_registration":"00225346-D","contact_person":"Amar ","contact_number":"0111 - 465 3330","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Pulau Pinang","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"info@kasbaiduri.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-02-18 14:42:02","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-02-24 23:16:28', 'shamiradnan'),
(575, 'contacts', 'add', 'contact', 1152, '{"id":"1152","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Expert Strategies Sdn. Bhd.","company_registration":"","contact_person":"Expert Strategies Sdn. Bhd.","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-08 10:00:44","added_by":"shamiradnan","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-08 10:00:44', 'shamiradnan'),
(576, 'sales', 'add', 'invoice', 10026, '{"id":"10026","txn_no":"1-10026","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-03-08 12:00:00","due_date":null,"received_date":null,"contact_person":"Shamir Adnan","contact":"Expert Strategies Sdn. Bhd.","contact_id":"1152","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Expert Strategies Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"660.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-03-08 10:03:54","added_by":"shamiradnan","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"0.00\\"}","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"72","invoice_id":"10026","type":"service","date":"2014-03-08 12:00:00","item_name":"Plexsol Office Rental","item_description":"Plexsol Seminar Hall Rental ","item_id":"0","service_id":"57","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"660.0000","price":"660.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"57":{"id":"57","name":"Plexsol Office Rental","description":"Seminar Hall Rental ","category":"0","subcategory":"0","cost":"300.00","price":"660.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-03-08 10:01:53","added_by":"shamiradnan","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1152","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Expert Strategies Sdn. Bhd.","company_registration":"","contact_person":"Expert Strategies Sdn. Bhd.","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-08 10:00:44","added_by":"shamiradnan","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-03-08 10:03:55', 'shamiradnan'),
(577, 'contacts', 'add', 'contact', 1153, '{"id":"1153","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Uniform Gallery Sdn. Bhd.","company_registration":"","contact_person":"Uniform Gallery","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-09 10:08:58","added_by":"shamiradnan","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 10:08:58', 'shamiradnan'),
(578, 'contacts', 'delete', 'contact', 1077, '{"id":"1077","is_customer":null,"is_supplier":null,"is_debtor":null,"is_creditor":null,"is_member":null,"is_stakeholder":null,"is_franchise":null,"is_franchisee":null,"company_name":null,"company_registration":null,"contact_person":"Solihin","contact_number":"0","credit_limit":null,"rank":null,"email":"","ic":"828412075463","password":null,"introducer_ic":null,"address1":"Mentakab","address2":"","city":"Kulim","state":"Kedah","zipcode":"09000","country":"Malaysia","tel":"0143937632","fax":null,"general_email":null,"terms":null,"description":null,"remarks":null,"tags":null,"added_on":"2012-11-16 20:53:52","added_by":"admin","modified_on":"2012-11-17 08:31:52","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:54:11', 'azad'),
(579, 'contacts', 'delete', 'contact', 1078, '{"id":"1078","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Asmah Bt Din","contact_number":"01430922","credit_limit":"0.00","rank":"Normal Member","email":"","ic":"841231","password":null,"introducer_ic":null,"address1":"Jalan","address2":"","city":"Bukit","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"01430922","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-11-16 21:04:45","added_by":"admin","modified_on":"2013-03-31 23:46:28","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:54:14', 'azad'),
(580, 'contacts', 'delete', 'contact', 1079, '{"id":"1079","is_customer":null,"is_supplier":null,"is_debtor":null,"is_creditor":null,"is_member":null,"is_stakeholder":null,"is_franchise":null,"is_franchisee":null,"company_name":null,"company_registration":null,"contact_person":"Ahmad Bin Abu","contact_number":"0","credit_limit":null,"rank":null,"email":"ahmad@gmail.com","ic":"989878","password":null,"introducer_ic":null,"address1":"Jalan Sekolah","address2":"","city":"Bayan Baru","state":"Pulau Pinang","zipcode":"14300","country":"Malaysia","tel":"123432","fax":null,"general_email":null,"terms":null,"description":null,"remarks":null,"tags":null,"added_on":"2012-11-17 07:57:22","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:54:17', 'azad'),
(581, 'contacts', 'delete', 'contact', 1080, '{"id":"1080","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Johari Bin Jasuli","contact_number":"0143076543","credit_limit":"0.00","rank":"Normal Member","email":"","ic":"820921086022","password":null,"introducer_ic":null,"address1":"22","address2":"","city":"Lunas","state":"Kedah","zipcode":"09600","country":"Malaysia","tel":"0143076543","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-11-17 08:43:13","added_by":"admin","modified_on":"2013-04-11 14:32:25","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:54:20', 'azad'),
(582, 'contacts', 'delete', 'contact', 1081, '{"id":"1081","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Aminah Bt Din","contact_number":"0","credit_limit":"0.00","rank":"Agent Member","email":"","ic":"4321","password":null,"introducer_ic":null,"address1":"22 Jalan Melaka","address2":"","city":"Ipoh","state":"Perak","zipcode":"14293","country":"Malaysia","tel":"0143078646","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-11-17 17:59:49","added_by":"admin","modified_on":"2012-11-18 00:12:01","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:55:58', 'azad'),
(583, 'contacts', 'delete', 'contact', 1085, '{"id":"1085","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Custom Album","contact_number":"0125445670","credit_limit":"0.00","rank":"0","email":"sales@customalbum.net","ic":"840621075253","password":"da2ec7ad9e322d9b2e226d1dfe90c1c5","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman Bukit Indah","city":"Bukit Mertajam, {emamg","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"sales@customalbum.net","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-12-12 21:44:00","added_by":"@Plexcart","modified_on":"2012-12-12 21:44:44","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"sales@customalbum.net1355319899","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:56:03', 'azad'),
(584, 'contacts', 'delete', 'contact', 1086, '{"id":"1086","is_customer":"1","is_supplier":null,"is_debtor":null,"is_creditor":null,"is_member":null,"is_stakeholder":null,"is_franchise":null,"is_franchisee":null,"company_name":null,"company_registration":null,"contact_person":"Zakiah","contact_number":"0125445670","credit_limit":null,"rank":null,"email":null,"ic":"840423105354","password":null,"introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"0125445670","fax":null,"general_email":"","terms":null,"description":null,"remarks":null,"tags":null,"added_on":"2012-12-20 22:40:13","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:56:06', 'azad'),
(585, 'contacts', 'delete', 'contact', 1087, '{"id":"1087","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Dinamika Enterprise","company_registration":"","contact_person":"Muhammad Zaid Kamal","contact_number":"045368559","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"20 Jalan Maju 1","address2":"Taman Maju Jaya","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:13","added_by":"admin","modified_on":"2012-12-28 23:15:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:56:10', 'azad'),
(586, 'contacts', 'delete', 'contact', 1088, '{"id":"1088","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Kamalia Azim Ahmad","contact_number":"0178854331","credit_limit":"0.00","rank":"Agent Member","email":"","ic":"","password":"","introducer_ic":null,"address1":"13 Jalan Admin","address2":"Taman Admin","city":"Johor Bahru","state":"Johor","zipcode":"36900","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:45:57","added_by":"admin","modified_on":"2012-12-28 23:20:00","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:56:42', 'azad'),
(587, 'contacts', 'delete', 'contact', 1089, '{"id":"1089","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Mohd Yusof Adam","contact_number":"0189955375","credit_limit":"0.00","rank":"Agent Member","email":"","ic":"","password":"","introducer_ic":null,"address1":"68 Jalan Taman Muda","address2":"Taman Muda","city":"Taiping","state":"Perak","zipcode":"16900","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:46:38","added_by":"admin","modified_on":"2012-12-28 23:21:02","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:56:47', 'azad'),
(588, 'contacts', 'delete', 'contact', 1090, '{"id":"1090","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"The Walking Stars","company_registration":"","contact_person":"Ziad Karim Jusoh","contact_number":"0366874556","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Blok 1, Jalan Jaya Usaha","address2":"Kawasan Jaya Usaha","city":"Kulim","state":"Kedah","zipcode":"09000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:47:21","added_by":"admin","modified_on":"2012-12-28 23:23:13","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:57:04', 'azad'),
(589, 'contacts', 'delete', 'contact', 1091, '{"id":"1091","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Farid Kamil","contact_number":"0196653485","credit_limit":"0.00","rank":"Agent Member","email":"","ic":"","password":"","introducer_ic":null,"address1":"11 Persimpangan Kulit","address2":"Taman Wayang Kulit","city":"Kulim","state":"Kedah","zipcode":"09000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:48:08","added_by":"admin","modified_on":"2012-12-28 23:24:20","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:57:07', 'azad');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(590, 'contacts', 'delete', 'contact', 1092, '{"id":"1092","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Badrul Amin Zakaria","contact_number":"0142565845","credit_limit":"0.00","rank":"Agent Member","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:49:06","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:57:11', 'azad'),
(591, 'contacts', 'delete', 'contact', 1093, '{"id":"1093","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"QWERTY Sdn Berhad","company_registration":"","contact_person":"Adam Lim Chang Shi","contact_number":"0165984671","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:49:53","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:57:14', 'azad'),
(592, 'contacts', 'delete', 'contact', 1094, '{"id":"1094","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Che Mohd Haniff Ahmad","contact_number":"0167865151","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:50:26","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:57:17', 'azad'),
(593, 'contacts', 'delete', 'contact', 1095, '{"id":"1095","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"David Zorlan","contact_number":"0167759456","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:50:55","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:57:24', 'azad'),
(594, 'contacts', 'delete', 'contact', 1097, '{"id":"1097","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Roger Federed Sdn Bhd","company_registration":"","contact_person":"Federed Roger","contact_number":"048575662","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:52:16","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:57:44', 'azad'),
(595, 'contacts', 'delete', 'contact', 1096, '{"id":"1096","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Eugene Ken Cee","contact_number":"0136565747","credit_limit":"0.00","rank":"Agent Member","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:51:21","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:57:48', 'azad'),
(596, 'contacts', 'delete', 'contact', 1098, '{"id":"1098","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Hamzah Kassim","contact_number":"0168787596","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:55:39","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:57:53', 'azad'),
(597, 'contacts', 'delete', 'contact', 1099, '{"id":"1099","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Irvine Calvine","contact_number":"036969854","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:56:09","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:57:57', 'azad'),
(598, 'contacts', 'delete', 'contact', 1100, '{"id":"1100","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Jasmine Kaur","contact_number":"0145869756","credit_limit":"0.00","rank":"Agent Member","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:56:36","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:58:05', 'azad'),
(599, 'contacts', 'delete', 'contact', 1101, '{"id":"1101","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Jamiran Kamur","contact_number":"0169833215","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:57:06","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:58:11', 'azad'),
(600, 'contacts', 'delete', 'contact', 1102, '{"id":"1102","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Loren Calliph","contact_number":"0186654250","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:57:33","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:58:16', 'azad'),
(601, 'contacts', 'delete', 'contact', 1103, '{"id":"1103","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Land Mind Consultant","company_registration":"","contact_person":"Benjamin Franklin","contact_number":"0398981122","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:58:06","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:58:19', 'azad'),
(602, 'contacts', 'delete', 'contact', 1104, '{"id":"1104","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Lavish Built Enterprise","company_registration":"","contact_person":"Richarcd Khan","contact_number":"0167545663","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:59:11","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:58:23', 'azad'),
(603, 'contacts', 'delete', 'contact', 1105, '{"id":"1105","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Indigo Technologies Sdn Bhd","company_registration":"","contact_person":"Frank Lampard","contact_number":"0369102012","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 22:59:45","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:58:31', 'azad'),
(604, 'contacts', 'delete', 'contact', 1106, '{"id":"1106","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Muhammad Ferhad","contact_number":"0147520123","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:00:42","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:58:35', 'azad'),
(605, 'contacts', 'delete', 'contact', 1107, '{"id":"1107","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Nur Akmal Hamzah","contact_number":"0138475216","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:01:10","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:58:38', 'azad'),
(606, 'contacts', 'delete', 'contact', 1109, '{"id":"1109","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Noramalina Mape","contact_number":"0138457123","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:01:53","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:58:44', 'azad'),
(607, 'contacts', 'delete', 'contact', 1110, '{"id":"1110","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Omran Omar","contact_number":"0187563214","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"0","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2012-12-28 23:02:14","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-09 11:58:48', 'azad'),
(608, 'inventory', 'add', 'item', NULL, '[]', '2014-03-09 12:44:23', 'azad'),
(609, 'inventory', 'delete', 'item', 1, '{"id":"1","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"t","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"0","max_quantity":"0","cost":"0.00","average_cost":null,"price":"3.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-09 12:44:23","added_by":"azad","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2014-03-09 12:45:00', 'azad'),
(610, 'contacts', 'edit', 'contact', 1076, '{"id":"1076","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"0","is_franchise":"1","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Azad Affif Ishak","contact_number":"9191","credit_limit":"0.00","rank":"0","email":"zadwani@gmail.com","ic":"123","password":"5ce75bba6298a10e403e09672cf79b5a","introducer_ic":"","address1":"asda","address2":"adas","city":"ada","state":"Johor","zipcode":"ada","country":"Malaysia","tel":"","fax":"","general_email":"zadwani@gmail.com","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-11-16 16:28:17","added_by":"@Plexcart","modified_on":"2014-03-12 09:56:09","modified_by":"azad","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"zadwani@gmail.com1362561781","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-12 09:56:09', 'azad'),
(611, 'inventory', 'add', 'item', NULL, '[]', '2014-03-13 17:40:19', 'azad'),
(612, 'inventory', 'receive', 'po', 10013, '{"id":"10013","txn_no":"1-10010","invoice_number":"","pr_id":"7","number":null,"date":"2014-01-10 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2.00","total_received":"2.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-01-10 02:07:23","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"26","purchase_order_id":"10013","date":"2014-01-10 00:00:00","item_description":null,"item_name":"Accessory Strap ()","item_id":"66","discount":"0","discount_type":null,"qty":"1","price_per_unit":"2.0000","price":"2.00","received":"1","received_price":"2.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"66":[]}}', '2014-03-13 17:40:52', 'azad'),
(613, 'inventory', 'status_update', 'po', 10013, '{"id":"10013","txn_no":"1-10010","invoice_number":"","pr_id":"7","number":null,"date":"2014-01-10 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Branch 1","supplier_id":"1076","supplier_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2.00","total_received":"2.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-01-10 02:07:23","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"26","purchase_order_id":"10013","date":"2014-01-10 00:00:00","item_description":null,"item_name":"Accessory Strap ()","item_id":"66","discount":"0","discount_type":null,"qty":"1","price_per_unit":"2.0000","price":"2.00","received":"1","received_price":"2.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"66":[]}}', '2014-03-13 17:40:52', 'azad'),
(614, 'inventory', 'add', 'po', 10014, '{"id":"10014","txn_no":"1-10011","invoice_number":"","pr_id":"0","number":null,"date":"2014-03-13 00:00:00","due_date":null,"contact_person":" ","received_date":null,"supplier":"Plexsol HQ","supplier_id":"1015","supplier_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"160.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-03-13 21:05:06","added_by":"azad","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"29","purchase_order_id":"10014","date":"2014-03-13 00:00:00","item_description":null,"item_name":"Dishwash 1000ml ()","item_id":"2","discount":"0","discount_type":null,"qty":"80","price_per_unit":"2.0000","price":"160.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"10","max_quantity":"0","cost":"0.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2014-03-13 21:05:06', 'azad'),
(615, 'inventory', 'receive', 'po', 10014, '{"id":"10014","txn_no":"1-10011","invoice_number":"","pr_id":"0","number":null,"date":"2014-03-13 00:00:00","due_date":null,"contact_person":" ","received_date":null,"supplier":"Plexsol HQ","supplier_id":"1015","supplier_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"160.00","total_received":"160.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-03-13 21:05:06","added_by":"azad","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"29","purchase_order_id":"10014","date":"2014-03-13 00:00:00","item_description":null,"item_name":"Dishwash 1000ml ()","item_id":"2","discount":"0","discount_type":null,"qty":"80","price_per_unit":"2.0000","price":"160.00","received":"80","received_price":"160.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"80","alert_quantity":"10","max_quantity":"0","cost":"0.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2014-03-13 21:05:26', 'azad'),
(616, 'inventory', 'status_update', 'po', 10014, '{"id":"10014","txn_no":"1-10011","invoice_number":"","pr_id":"0","number":null,"date":"2014-03-13 00:00:00","due_date":null,"contact_person":" ","received_date":null,"supplier":"Plexsol HQ","supplier_id":"1015","supplier_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"160.00","total_received":"160.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-03-13 21:05:06","added_by":"azad","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"29","purchase_order_id":"10014","date":"2014-03-13 00:00:00","item_description":null,"item_name":"Dishwash 1000ml ()","item_id":"2","discount":"0","discount_type":null,"qty":"80","price_per_unit":"2.0000","price":"160.00","received":"80","received_price":"160.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"80","alert_quantity":"10","max_quantity":"0","cost":"0.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2014-03-13 21:05:26', 'azad'),
(617, 'inventory', 'add', 'po', 10015, '{"id":"10015","txn_no":"8-10004","invoice_number":"","pr_id":"0","number":null,"date":"2014-03-13 00:00:00","due_date":null,"contact_person":" ","received_date":null,"supplier":"Prima Land Ent.","supplier_id":"1112","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"200.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-03-13 21:11:39","added_by":"plexcloud","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"8","assigned_to":null,"orders":[{"id":"30","purchase_order_id":"10015","date":"2014-03-13 00:00:00","item_description":null,"item_name":"Dishwash 1000ml ()","item_id":"2","discount":"0","discount_type":null,"qty":"100","price_per_unit":"2.0000","price":"200.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"8"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":null,"alert_quantity":"10","max_quantity":"0","cost":"0.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2014-03-13 21:11:39', 'plexcloud'),
(618, 'inventory', 'receive', 'po', 10015, '{"id":"10015","txn_no":"8-10004","invoice_number":"","pr_id":"0","number":null,"date":"2014-03-13 00:00:00","due_date":null,"contact_person":" ","received_date":null,"supplier":"Prima Land Ent.","supplier_id":"1112","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"200.00","total_received":"200.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-03-13 21:11:39","added_by":"plexcloud","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"8","assigned_to":null,"orders":[{"id":"30","purchase_order_id":"10015","date":"2014-03-13 00:00:00","item_description":null,"item_name":"Dishwash 1000ml ()","item_id":"2","discount":"0","discount_type":null,"qty":"100","price_per_unit":"2.0000","price":"200.00","received":"100","received_price":"200.00","done":null,"division_id":null,"warehouse_id":"8"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"100","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2014-03-13 21:12:20', 'plexcloud'),
(619, 'inventory', 'status_update', 'po', 10015, '{"id":"10015","txn_no":"8-10004","invoice_number":"","pr_id":"0","number":null,"date":"2014-03-13 00:00:00","due_date":null,"contact_person":" ","received_date":null,"supplier":"Prima Land Ent.","supplier_id":"1112","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"200.00","total_received":"200.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2014-03-13 21:11:39","added_by":"plexcloud","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"8","assigned_to":null,"orders":[{"id":"30","purchase_order_id":"10015","date":"2014-03-13 00:00:00","item_description":null,"item_name":"Dishwash 1000ml ()","item_id":"2","discount":"0","discount_type":null,"qty":"100","price_per_unit":"2.0000","price":"200.00","received":"100","received_price":"200.00","done":null,"division_id":null,"warehouse_id":"8"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"100","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}}}', '2014-03-13 21:12:22', 'plexcloud'),
(620, 'sales', 'edit', 'invoice', NULL, '[]', '2014-03-20 20:02:32', 'shamiradnan'),
(621, 'contacts', 'add', 'contact', 1154, '{"id":"1154","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Uniform Gallery","company_registration":"","contact_person":"Uniform Gallery","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No 42, 43 & 43A, Blok E","address2":"Seri Bangi, Jln 8\\/35, Seksyen 8","city":"Bandar Baru Bangi","state":"Selangor","zipcode":"43650","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-21 08:58:49","added_by":"shafiq","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-21 08:58:49', 'shafiq'),
(622, 'contacts', 'delete', 'contact', 1153, '{"id":"1153","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Uniform Gallery Sdn. Bhd.","company_registration":"","contact_person":"Uniform Gallery","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-09 10:08:58","added_by":"shamiradnan","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-21 08:59:06', 'shafiq'),
(623, 'sales', 'add', 'invoice', 10027, '{"id":"10027","txn_no":"1-10027","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-03-21 12:00:00","due_date":null,"received_date":null,"contact_person":"Rozita Hani","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-03-21 09:14:36","added_by":"shamiradnan","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"0.00\\"}","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"74","invoice_id":"10027","type":"service","date":"2014-03-21 12:00:00","item_name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","item_description":"","item_id":"0","service_id":"52","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"52":{"id":"52","name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","description":"","category":"0","subcategory":"0","cost":"2000.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-01-26 01:47:56","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-03-21 09:14:37', 'shamiradnan'),
(624, 'sales', 'edit', 'invoice', NULL, '[]', '2014-03-21 09:15:52', 'shamiradnan'),
(625, 'sales', 'add', 'invoice', 10028, '{"id":"10028","txn_no":"1-10028","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-03-21 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Uniform Gallery","contact_id":"1154","contact_address":"{\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Uniform Gallery\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3600.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-03-21 09:16:49","added_by":"shamiradnan","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"0.00\\"}","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"76","invoice_id":"10028","type":"service","date":"2014-03-21 12:00:00","item_name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","item_description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","item_id":"0","service_id":"58","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"3600.0000","price":"3600.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"58":{"id":"58","name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","category":"0","subcategory":"0","cost":"0.00","price":"3600.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-03-21 09:01:39","added_by":"shafiq","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1154","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Uniform Gallery","company_registration":"","contact_person":"Uniform Gallery","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No 42, 43 & 43A, Blok E","address2":"Seri Bangi, Jln 8\\/35, Seksyen 8","city":"Bandar Baru Bangi","state":"Selangor","zipcode":"43650","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-21 08:58:49","added_by":"shafiq","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-03-21 09:16:49', 'shamiradnan'),
(626, 'contacts', 'edit', 'contact', 1154, '{"id":"1154","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Uniform Gallery","company_registration":"","contact_person":"Uniform Gallery","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No 42, 43 & 43A, Blok E","address2":"Seri Bangi, Jln 8\\/35, Seksyen 8","city":"Bandar Baru Bangi","state":"Selangor","zipcode":"43650","country":"Malaysia","tel":"","fax":"","general_email":"lguniformgallery@yahoo.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-21 08:58:49","added_by":"shafiq","modified_on":"2014-03-21 09:21:34","modified_by":"shafiq","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-21 09:21:34', 'shafiq');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(627, 'contacts', 'add', 'contact', 1155, '{"id":"1155","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"AmaniLittleCloset.com","company_registration":"","contact_person":"Amani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-21 09:22:52","added_by":"shamiradnan","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-21 09:22:52', 'shamiradnan'),
(628, 'sales', 'add', 'invoice', 10029, '{"id":"10029","txn_no":"1-10029","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-03-21 12:00:00","due_date":null,"received_date":null,"contact_person":"Shamir Adnan","contact":"AmaniLittleCloset.com","contact_id":"1155","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"AmaniLittleCloset.com\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-03-21 09:23:55","added_by":"shamiradnan","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"0.00\\"}","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"77","invoice_id":"10029","type":"service","date":"2014-03-21 12:00:00","item_name":"Renewal of Domain and Hosting","item_description":"Yearly Renewal of Domain and Hosting","item_id":"0","service_id":"56","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"200.0000","price":"200.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"56":{"id":"56","name":"Renewal of Domain and Hosting","description":"Yearly Renewal of Domain and Hosting","category":"0","subcategory":"0","cost":"50.00","price":"200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-02-24 23:24:46","added_by":"shamiradnan","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1155","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"AmaniLittleCloset.com","company_registration":"","contact_person":"Amani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-21 09:22:52","added_by":"shamiradnan","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-03-21 09:23:55', 'shamiradnan'),
(629, 'contacts', 'add', 'contact', 1156, '{"id":"1156","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"The Pixelicious Moment","company_registration":"","contact_person":"Mohd Faruq","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-23 18:38:11","added_by":"shamiradnan","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-23 18:38:11', 'shamiradnan'),
(630, 'sales', 'add', 'invoice', 10030, '{"id":"10030","txn_no":"1-10030","quote_id":"0","sales_order_id":"0","number":"0","po_number":"Nil","date":"2014-03-23 12:00:00","due_date":null,"received_date":null,"contact_person":"Shamir Adnan","contact":"The Pixelicious Moment","contact_id":"1156","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"The Pixelicious Moment\\",\\"mobile\\":\\"\\",\\"address1\\":\\"www.ThePixelicioutMoment.com\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"RM 250 has been paid as Processing Fee","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-03-23 18:39:48","added_by":"shamiradnan","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"0.00\\"}","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"78","invoice_id":"10030","type":"service","date":"2014-03-23 12:00:00","item_name":"Photography Website Promotion","item_description":"1. Hosting and Domain for www.ThePixeliciousMoment.com\\n2. Deploying the Lace style design \\n3. Provide Free tutorial of System","item_id":"0","service_id":"59","item_sku":null,"discount":"250","discount_type":"d","qty":"1","price_per_unit":"450.0000","price":"450.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"59":{"id":"59","name":"Photography Website Promotion","description":"1. Hosting and Domain for www.ThePixeliciousMoment.com\\n2. Deploying the Lace style design \\n3. Provide Free tutorial of System","category":"0","subcategory":"0","cost":"50.00","price":"450.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-03-23 18:37:17","added_by":"shamiradnan","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1156","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"The Pixelicious Moment","company_registration":"","contact_person":"Mohd Faruq","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-23 18:38:11","added_by":"shamiradnan","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-03-23 18:39:48', 'shamiradnan'),
(631, 'sales', 'edit', 'quote', 10027, '{"id":"10027","txn_no":"1-10025","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-03-26 00:00:00","due_date":"2014-04-26 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Collaborative Research in Engineering, Science & Technology (CREST)","contact_id":"1151","contact_address":"{\\"address1\\":\\"sains@usm,Block C, Ground Floor\\",\\"address2\\":\\" No.10 Persiaran Bukit Jambul\\",\\"zipcode\\":\\"11900 \\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Collaborative Research in Engineering, Science & Technology (CREST)\\",\\"mobile\\":\\"604 652 0088\\",\\"address1\\":\\"sains@usm,Block C, Ground Floor\\",\\"address2\\":\\" No.10 Persiaran Bukit Jambul\\",\\"zipcode\\":\\"11900 \\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4400.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-02-24 09:28:09","added_by":"admin","modified_on":"2014-03-26 02:46:37","modified_by":"shamiradnan","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"125","quote_id":"10027","date":"2014-03-26 00:00:00","type":"service","item_id":"0","service_id":"54","item_name":"Equipment and Supplier Query System and Wordpress Maintenance","item_description":"A. Equipment and Supplier Query System\\n\\nRM 3,800.00\\n\\n1. One admin Login system with entry\\n2. Database entry of Equipment and Supplier\\n3. To display result based on Equipment Query\\n\\nDuration of Completion 1 Month\\n\\nB. Wordpress Maintenance\\n\\nRM 600.00\\n\\n1. To update the content of Crest.my\\n2. Content is provided by Crest.my\\n\\nDuration of Completion 1 Week","discount":"0","discount_type":null,"qty":"1","price_per_unit":"4400.0000","price":"4400.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"54":{"id":"54","name":"Equipment and Supplier Query System and Wordpress Maintenance","description":"A. Equipment and Supplier Query System\\n\\nRM 3,800.00\\n\\n1. One admin Login system with entry\\n2. Database entry of Equipment and Supplier\\n3. To display result based on Equipment Query\\n\\nB. Wordpress Maintenance\\n\\nRM 600.00\\n\\n1. To update the content of Crest.my\\n2. Content is provided by Crest.my\\n","category":"0","subcategory":"0","cost":"800.00","price":"4400.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-02-24 09:23:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2014-03-26 02:46:37', 'shamiradnan'),
(632, 'contacts', 'add', 'contact', 1157, '{"id":"1157","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Crest","company_registration":"PG-00021","contact_person":"Mr. Chin Fung Wei","contact_number":"04 652 0088","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-26 16:31:01","added_by":"shamiradnan","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-26 16:31:02', 'shamiradnan'),
(633, 'contacts', 'edit', 'contact', 1157, '{"id":"1157","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Crest","company_registration":"PG-00021","contact_person":"Mr. Chin Fung Wei","contact_number":"04 652 0088 \\/ 04 ","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-26 16:31:01","added_by":"shamiradnan","modified_on":"2014-03-26 16:31:55","modified_by":"shamiradnan","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-03-26 16:31:55', 'shamiradnan'),
(634, 'sales', 'edit', 'quote', 10027, '{"id":"10027","txn_no":"1-10025","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-03-26 00:00:00","due_date":"2014-04-26 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Collaborative Research in Engineering, Science & Technology (CREST)","contact_id":"1151","contact_address":"{\\"address1\\":\\"sains@usm,Block C, Ground Floor\\",\\"address2\\":\\" No.10 Persiaran Bukit Jambul\\",\\"zipcode\\":\\"11900 \\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Collaborative Research in Engineering, Science & Technology (CREST)\\",\\"mobile\\":\\"604 652 0088\\",\\"address1\\":\\"sains@usm,Block C, Ground Floor\\",\\"address2\\":\\" No.10 Persiaran Bukit Jambul\\",\\"zipcode\\":\\"11900 \\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4400.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-02-24 09:28:09","added_by":"admin","modified_on":"2014-03-31 08:10:43","modified_by":"shamiradnan","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"126","quote_id":"10027","date":"2014-03-26 00:00:00","type":"service","item_id":"0","service_id":"54","item_name":"Equipment and Supplier Query System and Wordpress Maintenance","item_description":"A. Equipment and Supplier Query System\\n\\nRM 3,800.00\\n\\nThis system will display and search list of vendors from database. It will provide details of Service Provider\\/Vendor of the \\"Shared Service Name\\" , Model , Facilities, Person In Charge,  Email, Address, Phone Number and Etc. This system will have the followings \\n\\n1. One admin Login system with entry\\n2. Database entry of Equipment and Supplier\\n3. To display result based on Equipment Query\\n\\nDuration of Completion 1 Month\\n\\nB. System Maintenance\\n\\nRM 600.00\\n\\n1. To update the content of Crest.my\\n2. Content is provided by Crest.my\\n\\nAttached Together with This Quotes\\n1. The mock up of the System\\n\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"4400.0000","price":"4400.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"54":{"id":"54","name":"Equipment and Supplier Query System and Wordpress Maintenance","description":"A. Equipment and Supplier Query System\\n\\nRM 3,800.00\\n\\n1. One admin Login system with entry\\n2. Database entry of Equipment and Supplier\\n3. To display result based on Equipment Query\\n\\nB. Wordpress Maintenance\\n\\nRM 600.00\\n\\n1. To update the content of Crest.my\\n2. Content is provided by Crest.my\\n","category":"0","subcategory":"0","cost":"800.00","price":"4400.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-02-24 09:23:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2014-03-31 08:10:43', 'shamiradnan'),
(635, 'sales', 'edit', 'quote', 10027, '{"id":"10027","txn_no":"1-10025","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-03-26 00:00:00","due_date":"2014-04-26 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Collaborative Research in Engineering, Science & Technology (CREST)","contact_id":"1151","contact_address":"{\\"address1\\":\\"sains@usm,Block C, Ground Floor\\",\\"address2\\":\\" No.10 Persiaran Bukit Jambul\\",\\"zipcode\\":\\"11900 \\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Collaborative Research in Engineering, Science & Technology (CREST)\\",\\"mobile\\":\\"604 652 0088\\",\\"address1\\":\\"sains@usm,Block C, Ground Floor\\",\\"address2\\":\\" No.10 Persiaran Bukit Jambul\\",\\"zipcode\\":\\"11900 \\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4400.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-02-24 09:28:09","added_by":"admin","modified_on":"2014-03-31 08:10:51","modified_by":"shamiradnan","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"127","quote_id":"10027","date":"2014-03-26 00:00:00","type":"service","item_id":"0","service_id":"54","item_name":"Equipment and Supplier Query System and Wordpress Maintenance","item_description":"A. Equipment and Supplier Query System\\n\\nRM 3,800.00\\n\\nThis system will display and search list of vendors from database. It will provide details of Service Provider\\/Vendor of the \\"Shared Service Name\\" , Model , Facilities, Person In Charge,  Email, Address, Phone Number and Etc. This system will have the followings \\n\\n1. One admin Login system with entry\\n2. Database entry of Equipment and Supplier\\n3. To display result based on Equipment Query\\n\\nDuration of Completion 1 Month\\n\\nB. System Maintenance\\n\\nRM 600.00\\n\\n1. To update the content of Crest.my\\n2. Content is provided by Crest.my\\n\\nAttached Together with This Quotes\\n1. The mock up of the System\\n\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"4400.0000","price":"4400.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"54":{"id":"54","name":"Equipment and Supplier Query System and Wordpress Maintenance","description":"A. Equipment and Supplier Query System\\n\\nRM 3,800.00\\n\\n1. One admin Login system with entry\\n2. Database entry of Equipment and Supplier\\n3. To display result based on Equipment Query\\n\\nB. Wordpress Maintenance\\n\\nRM 600.00\\n\\n1. To update the content of Crest.my\\n2. Content is provided by Crest.my\\n","category":"0","subcategory":"0","cost":"800.00","price":"4400.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-02-24 09:23:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2014-03-31 08:10:51', 'shamiradnan'),
(636, 'sales', 'edit', 'invoice', NULL, '[]', '2014-04-02 08:59:28', 'shamiradnan'),
(637, 'contacts', 'add', 'contact', 1158, '{"id":"1158","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"D''Tandoor Bukit Mertajam","company_registration":"","contact_person":"Pn. Yusriza","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No 43, Lorong Perda Selatan 2","address2":"Bandar Perda","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-04-02 11:15:09","added_by":"shafiq","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-04-02 11:15:09', 'shafiq'),
(638, 'sales', 'add', 'quote', 10028, '{"id":"10028","txn_no":"2-10001","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-04-02 00:00:00","due_date":"2014-04-09 00:00:00","contact_person":" Shafiq Rizwan","payment_date":null,"received_date":null,"contact":"D''Tandoor Bukit Mertajam","contact_id":"1158","contact_address":"{\\"address1\\":\\"No 43, Lorong Perda Selatan 2\\",\\"address2\\":\\"Bandar Perda\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"D''Tandoor Bukit Mertajam\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No 43, Lorong Perda Selatan 2\\",\\"address2\\":\\"Bandar Perda\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"9500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-04-02 12:07:23","added_by":"shafiq","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"2","assigned_to":null,"orders":[{"id":"128","quote_id":"10028","date":"2014-04-02 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"Food and Beverage POS ","item_description":"Packages Included:\\n1) 1 x All-In-One Touch Screen POS\\n2) 1 x Cash Drawer\\n3) 3 x Thermal Printer\\n4) 1 x iPod Touch (waiter terminal)\\n5) Plexcloud Food and Beverage Software\\n6) Installation","discount":"0","discount_type":null,"qty":"1","price_per_unit":"9500.0000","price":"9500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"2"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"}}}', '2014-04-02 12:07:23', 'shafiq'),
(639, 'contacts', 'add', 'contact', 1159, '{"id":"1159","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"HAJAH BAIDAH","contact_number":"+6019-7135605","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-04-03 19:05:26","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-04-03 19:05:26', 'admin'),
(640, 'contacts', 'edit', 'contact', 1159, '{"id":"1159","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"PUAN HAJAH BAIDAH","contact_number":"+6019-7135605","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-04-03 19:05:26","added_by":"admin","modified_on":"2014-04-03 19:07:36","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-04-03 19:07:36', 'admin'),
(641, 'sales', 'add', 'quote', 10029, '{"id":"10029","txn_no":"1-10026","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-04-03 00:00:00","due_date":"2014-04-03 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"PUAN HAJAH BAIDAH","contact_id":"1159","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"PUAN HAJAH BAIDAH\\",\\"mobile\\":\\"+6019-7135605\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-04-03 19:19:04","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"129","quote_id":"10029","date":"2014-04-03 00:00:00","type":"service","item_id":"0","service_id":"9","item_name":"Web Design & Development","item_description":"","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3500.0000","price":"3500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"9":{"id":"9","name":"Web Design & Development","description":"","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-05-31 13:45:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}}}', '2014-04-03 19:19:04', 'admin'),
(642, 'sales', 'edit', 'quote', 10029, '{"id":"10029","txn_no":"1-10026","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-04-03 00:00:00","due_date":"2014-04-03 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"PUAN HAJAH BAIDAH","contact_id":"1159","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"PUAN HAJAH BAIDAH\\",\\"mobile\\":\\"+6019-7135605\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-04-03 19:19:04","added_by":"admin","modified_on":"2014-04-03 19:21:35","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"130","quote_id":"10029","date":"2014-04-03 00:00:00","type":"service","item_id":"0","service_id":"9","item_name":"Web Design & Development","item_description":"5 - 10 Pages Web Design\\n.com Domain (RM50\\/year. Waived for first year)\\n1GB Hosting (RM100\\/year. Waived for first year)","discount":"0","discount_type":null,"qty":"1","price_per_unit":"1500.0000","price":"1500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"9":{"id":"9","name":"Web Design & Development","description":"","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-05-31 13:45:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}}}', '2014-04-03 19:21:35', 'admin'),
(643, 'contacts', 'edit', 'contact', 1159, '{"id":"1159","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"PUAN HAJAH BAIDAH","contact_number":"+6019-7135605","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"NO.6-01, JALAN PADI EMAS 5\\/2","address2":"BANDAR BARU UDA","city":"JOHOR BAHRU","state":"Johor","zipcode":"81200","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-04-03 19:05:26","added_by":"admin","modified_on":"2014-04-03 19:35:56","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-04-03 19:35:56', 'admin'),
(644, 'sales', 'edit', 'quote', 10029, '{"id":"10029","txn_no":"1-10026","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-04-03 00:00:00","due_date":"2014-04-03 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"PUAN HAJAH BAIDAH","contact_id":"1159","contact_address":"{\\"address1\\":\\"NO.6-01, JALAN PADI EMAS 5\\\\\\/2\\",\\"address2\\":\\"BANDAR BARU UDA\\",\\"zipcode\\":\\"81200\\",\\"city\\":\\"JOHOR BAHRU\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"PUAN HAJAH BAIDAH\\",\\"mobile\\":\\"+6019-7135605\\",\\"address1\\":\\"NO.6-01, JALAN PADI EMAS 5\\\\\\/2\\",\\"address2\\":\\"BANDAR BARU UDA\\",\\"zipcode\\":\\"81200\\",\\"city\\":\\"JOHOR BAHRU\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-04-03 19:19:04","added_by":"admin","modified_on":"2014-04-03 19:38:06","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"131","quote_id":"10029","date":"2014-04-03 00:00:00","type":"service","item_id":"0","service_id":"9","item_name":"Web Design & Development","item_description":"5 - 10 Pages Web Design\\n.com Domain (RM50\\/year. Waived for first year)\\n1GB Hosting (RM100\\/year. Waived for first year)","discount":"0","discount_type":null,"qty":"1","price_per_unit":"1500.0000","price":"1500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"9":{"id":"9","name":"Web Design & Development","description":"","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-05-31 13:45:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}}}', '2014-04-03 19:38:06', 'admin'),
(645, 'sales', 'edit', 'invoice', NULL, '[]', '2014-04-04 00:00:11', 'azad'),
(646, 'sales', 'edit', 'invoice', NULL, '[]', '2014-04-04 00:10:40', 'azad'),
(647, 'sales', 'add', 'invoice', 10031, '{"id":"10031","txn_no":"1-10031","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-04-04 12:00:00","due_date":null,"received_date":null,"contact_person":" ","contact":null,"contact_id":null,"contact_address":"{\\"address1\\":null,\\"address2\\":null,\\"zipcode\\":null,\\"city\\":null,\\"state\\":null,\\"country\\":null}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-04-04 00:12:05","added_by":"azad","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"0.00\\"}","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":null,"products":null,"services":null,"customer":[],"sale":null,"sale_items":null}', '2014-04-04 00:12:06', 'azad'),
(648, 'inventory', 'add', 'item', NULL, '[]', '2014-04-05 21:17:03', 'azad'),
(649, 'sales', 'add', 'invoice', 10032, '{"id":"10032","txn_no":"1-10032","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-04-05 12:00:00","due_date":null,"received_date":null,"contact_person":" ","contact":"Teh Chai Soon","contact_id":"1140","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Teh Chai Soon\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"Rented on 12 March , 23 March","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"160.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-04-05 21:18:38","added_by":"azad","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"0.00\\"}","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"84","invoice_id":"10032","type":"product","date":"2014-04-05 12:00:00","item_name":"1 Hour Plex Training Rent","item_description":"","item_id":"3","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"4","price_per_unit":"40.0000","price":"160.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"3":{"id":"3","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"1 Hour Plex Training Rent","model_no":"","warranty":"","sku":"000101","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"10","max_quantity":"0","cost":"0.00","average_cost":null,"price":"40.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-04-05 21:17:03","added_by":"azad","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1140","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Teh Chai Soon","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Pulau Pinang","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-06 12:45:29","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1383713129"},"sale":null,"sale_items":null}', '2014-04-05 21:18:39', 'azad'),
(650, 'contacts', 'add', 'contact', 1160, '{"id":"1160","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"MALAYSIAN NPK FERTILIZER SDN BHD","company_registration":"","contact_person":"MALAYSIAN NPK FERTILIZER SDN BHD","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"BATU 2, JALAN JENIANG","address2":"P.O BOX 24","city":"GURUN","state":"Kedah","zipcode":"08300","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-04-08 10:41:05","added_by":"shafiq","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-04-08 10:41:06', 'shafiq'),
(651, 'sales', 'add', 'quote', 10030, '{"id":"10030","txn_no":"2-10002","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-04-08 00:00:00","due_date":"2014-04-25 00:00:00","contact_person":" ","payment_date":null,"received_date":null,"contact":"MALAYSIAN NPK FERTILIZER SDN BHD","contact_id":"1160","contact_address":"{\\"address1\\":\\"BATU 2, JALAN JENIANG\\",\\"address2\\":\\"P.O BOX 24\\",\\"zipcode\\":\\"08300\\",\\"city\\":\\"GURUN\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"MALAYSIAN NPK FERTILIZER SDN BHD\\",\\"mobile\\":\\"\\",\\"address1\\":\\"BATU 2, JALAN JENIANG\\",\\"address2\\":\\"P.O BOX 24\\",\\"zipcode\\":\\"08300\\",\\"city\\":\\"GURUN\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"8500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-04-08 10:44:14","added_by":"shafiq","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"2","assigned_to":null,"orders":[{"id":"132","quote_id":"10030","date":"2014-04-08 00:00:00","type":"service","item_id":"0","service_id":"32","item_name":"Website Development, Design & Training","item_description":"1)  Content Management System\\n\\n- Drag & Drop Plex Content Management System\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"8500.0000","price":"8500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"2"}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":"2013-06-14 12:30:53","modified_by":"admin","warehouse_id":"0"}}}', '2014-04-08 10:44:14', 'shafiq'),
(652, 'sales', 'add', 'quote', 10031, '{"id":"10031","txn_no":"2-10003","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-04-08 00:00:00","due_date":"2014-04-25 00:00:00","contact_person":" ","payment_date":null,"received_date":null,"contact":"MALAYSIAN NPK FERTILIZER SDN BHD","contact_id":"1160","contact_address":"{\\"address1\\":\\"BATU 2, JALAN JENIANG\\",\\"address2\\":\\"P.O BOX 24\\",\\"zipcode\\":\\"08300\\",\\"city\\":\\"GURUN\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"MALAYSIAN NPK FERTILIZER SDN BHD\\",\\"mobile\\":\\"\\",\\"address1\\":\\"BATU 2, JALAN JENIANG\\",\\"address2\\":\\"P.O BOX 24\\",\\"zipcode\\":\\"08300\\",\\"city\\":\\"GURUN\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"8500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-04-08 10:44:14","added_by":"shafiq","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"2","assigned_to":null,"orders":[{"id":"133","quote_id":"10031","date":"2014-04-08 00:00:00","type":"service","item_id":"0","service_id":"32","item_name":"Website Development, Design & Training","item_description":"1)  Content Management System\\n\\n- Drag & Drop Plex Content Management System\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"8500.0000","price":"8500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"2"}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":"2013-06-14 12:30:53","modified_by":"admin","warehouse_id":"0"}}}', '2014-04-08 10:44:14', 'shafiq'),
(653, 'sales', 'delete', 'quote', 10030, '{"id":"10030","txn_no":"2-10002","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-04-08 00:00:00","due_date":"2014-04-25 00:00:00","contact_person":" ","payment_date":null,"received_date":null,"contact":"MALAYSIAN NPK FERTILIZER SDN BHD","contact_id":"1160","contact_address":"{\\"address1\\":\\"BATU 2, JALAN JENIANG\\",\\"address2\\":\\"P.O BOX 24\\",\\"zipcode\\":\\"08300\\",\\"city\\":\\"GURUN\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"MALAYSIAN NPK FERTILIZER SDN BHD\\",\\"mobile\\":\\"\\",\\"address1\\":\\"BATU 2, JALAN JENIANG\\",\\"address2\\":\\"P.O BOX 24\\",\\"zipcode\\":\\"08300\\",\\"city\\":\\"GURUN\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"8500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-04-08 10:44:14","added_by":"shafiq","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"2","assigned_to":null,"orders":[{"id":"132","quote_id":"10030","date":"2014-04-08 00:00:00","type":"service","item_id":"0","service_id":"32","item_name":"Website Development, Design & Training","item_description":"1)  Content Management System\\n\\n- Drag & Drop Plex Content Management System\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"8500.0000","price":"8500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"2"}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":"2013-06-14 12:30:53","modified_by":"admin","warehouse_id":"0"}}}', '2014-04-08 10:44:21', 'shafiq');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(654, 'sales', 'edit', 'quote', 10031, '{"id":"10031","txn_no":"2-10003","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-04-08 00:00:00","due_date":"2014-04-25 00:00:00","contact_person":" ","payment_date":null,"received_date":null,"contact":"MALAYSIAN NPK FERTILIZER SDN BHD","contact_id":"1160","contact_address":"{\\"address1\\":\\"BATU 2, JALAN JENIANG\\",\\"address2\\":\\"P.O BOX 24\\",\\"zipcode\\":\\"08300\\",\\"city\\":\\"GURUN\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"MALAYSIAN NPK FERTILIZER SDN BHD\\",\\"mobile\\":\\"\\",\\"address1\\":\\"BATU 2, JALAN JENIANG\\",\\"address2\\":\\"P.O BOX 24\\",\\"zipcode\\":\\"08300\\",\\"city\\":\\"GURUN\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"8500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-04-08 10:44:14","added_by":"shafiq","modified_on":"2014-04-08 11:51:40","modified_by":"shafiq","no_do":null,"division_id":null,"warehouse_id":"2","assigned_to":null,"orders":[{"id":"134","quote_id":"10031","date":"2014-04-08 00:00:00","type":"service","item_id":"0","service_id":"32","item_name":"Website Development, Design & Training","item_description":"1)  Content Management System\\n\\n- Drag & Drop Plex Content Management System\\n- WYSIWYG Capabilities\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"8500.0000","price":"8500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"2"}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":"2013-06-14 12:30:53","modified_by":"admin","warehouse_id":"0"}}}', '2014-04-08 11:51:40', 'shafiq'),
(655, 'sales', 'add', 'invoice', 10033, '{"id":"10033","txn_no":"1-10033","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-03-01 12:00:00","due_date":null,"received_date":null,"contact_person":" ","contact":"Teh Chai Soon","contact_id":"1140","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Teh Chai Soon\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"240.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-04-10 09:31:20","added_by":"azad","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"0.00\\"}","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"85","invoice_id":"10033","type":"product","date":"2014-03-01 12:00:00","item_name":"1 Hour Plex Training Rent","item_description":"","item_id":"3","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"6","price_per_unit":"40.0000","price":"240.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"3":{"id":"3","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"1 Hour Plex Training Rent","model_no":"","warranty":"","sku":"000101","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"10","max_quantity":"0","cost":"0.00","average_cost":null,"price":"40.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-04-05 21:17:03","added_by":"azad","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1140","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Teh Chai Soon","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Pulau Pinang","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-06 12:45:29","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1383713129"},"sale":null,"sale_items":null}', '2014-04-10 09:31:20', 'azad'),
(656, 'sales', 'delete', 'invoice', 10032, '{"id":"10032","txn_no":"1-10032","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-04-05 12:00:00","due_date":null,"received_date":null,"contact_person":" ","contact":"Teh Chai Soon","contact_id":"1140","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Teh Chai Soon\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"Rented on 12 March , 23 March","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"160.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-04-05 21:18:38","added_by":"azad","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"0.00\\"}","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"84","invoice_id":"10032","type":"product","date":"2014-04-05 12:00:00","item_name":"1 Hour Plex Training Rent","item_description":"","item_id":"3","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"4","price_per_unit":"40.0000","price":"160.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"3":{"id":"3","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"1 Hour Plex Training Rent","model_no":"","warranty":"","sku":"000101","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"10","max_quantity":"0","cost":"0.00","average_cost":null,"price":"40.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-04-05 21:17:03","added_by":"azad","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1140","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Teh Chai Soon","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Pulau Pinang","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-06 12:45:29","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1383713129"},"sale":null,"sale_items":null}', '2014-04-10 09:31:43', 'azad'),
(657, 'sales', 'add', 'invoice', 10034, '{"id":"10034","txn_no":"1-10034","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-03-01 12:00:00","due_date":null,"received_date":null,"contact_person":" ","contact":"Teh Chai Soon","contact_id":"1140","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Teh Chai Soon\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"240.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-04-10 09:34:30","added_by":"azad","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"0.00\\"}","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"86","invoice_id":"10034","type":"service","date":"2014-03-01 12:00:00","item_name":"Seminar Room","item_description":"6 Hours  ( 15,16 & 23 Feb)","item_id":"0","service_id":"53","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"240.0000","price":"240.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"53":{"id":"53","name":"Seminar Room","description":"","category":"0","subcategory":"0","cost":"40.00","price":"40.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-02-04 13:50:57","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1140","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Teh Chai Soon","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Pulau Pinang","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-06 12:45:29","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1383713129"},"sale":null,"sale_items":null}', '2014-04-10 09:34:30', 'azad'),
(658, 'sales', 'status_update', 'invoice', 10034, '{"id":"10034","txn_no":"1-10034","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-03-01 12:00:00","due_date":null,"received_date":null,"contact_person":" ","contact":"Teh Chai Soon","contact_id":"1140","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Teh Chai Soon\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"240.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-04-10 09:34:30","added_by":"azad","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"0.00\\"}","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"86","invoice_id":"10034","type":"service","date":"2014-03-01 12:00:00","item_name":"Seminar Room","item_description":"6 Hours  ( 15,16 & 23 Feb)","item_id":"0","service_id":"53","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"240.0000","price":"240.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"53":{"id":"53","name":"Seminar Room","description":"","category":"0","subcategory":"0","cost":"40.00","price":"40.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-02-04 13:50:57","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1140","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Teh Chai Soon","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Pulau Pinang","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-06 12:45:29","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1383713129"},"sale":null,"sale_items":null}', '2014-04-10 09:37:10', 'azad'),
(659, 'sales', 'add', 'invoice', 10035, '{"id":"10035","txn_no":"1-10035","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-04-10 12:00:00","due_date":null,"received_date":null,"contact_person":" ","contact":"Teh Chai Soon","contact_id":"1140","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Teh Chai Soon\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"42.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-04-10 09:38:01","added_by":"azad","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"2.00\\"}","total_tax":"2.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"87","invoice_id":"10035","type":"service","date":"2014-04-10 12:00:00","item_name":"Seminar Room","item_description":"4 hours ( 16 & 22 March)","item_id":"0","service_id":"53","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"40.0000","price":"40.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"53":{"id":"53","name":"Seminar Room","description":"","category":"0","subcategory":"0","cost":"40.00","price":"40.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-02-04 13:50:57","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1140","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Teh Chai Soon","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Pulau Pinang","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-06 12:45:29","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1383713129"},"sale":null,"sale_items":null}', '2014-04-10 09:38:01', 'azad'),
(660, 'sales', 'edit', 'quote', 10027, '{"id":"10027","txn_no":"1-10025","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-03-26 00:00:00","due_date":"2014-04-26 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Collaborative Research in Engineering, Science & Technology (CREST)","contact_id":"1151","contact_address":"{\\"address1\\":\\"sains@usm,Block C, Ground Floor\\",\\"address2\\":\\" No.10 Persiaran Bukit Jambul\\",\\"zipcode\\":\\"11900 \\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Collaborative Research in Engineering, Science & Technology (CREST)\\",\\"mobile\\":\\"604 652 0088\\",\\"address1\\":\\"sains@usm,Block C, Ground Floor\\",\\"address2\\":\\" No.10 Persiaran Bukit Jambul\\",\\"zipcode\\":\\"11900 \\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4400.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-02-24 09:28:09","added_by":"admin","modified_on":"2014-04-10 09:40:51","modified_by":"shamiradnan","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"135","quote_id":"10027","date":"2014-03-26 00:00:00","type":"service","item_id":"0","service_id":"54","item_name":"Equipment and Supplier Query System and Wordpress Maintenance","item_description":"A. Equipment and Supplier Query System\\n\\nRM 3,800.00\\n\\nThis system will display and search list of vendors from database. It will provide details of Service Provider\\/Vendor of the \\"Shared Service Name\\" , Model , Facilities, Person In Charge,  Email, Address, Phone Number and Etc. This system will have the followings \\n\\n1. One admin Login system with entry\\n2. Database entry of Equipment and Supplier\\n3. To display result based on Equipment Query\\n\\nDuration of Completion 1 Month\\n\\nB. System Maintenance\\n\\nRM 600.00\\n\\n1. To update the content of Crest.my\\n2. Content is provided by Crest.my\\n\\nAttached Together with This Quotes\\n1. The mock up of the System\\n\\n\\nPayment Terms*\\n\\n1. 50% Project Kick Start\\n2. 50% Completion of Project \\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"4400.0000","price":"4400.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"54":{"id":"54","name":"Equipment and Supplier Query System and Wordpress Maintenance","description":"A. Equipment and Supplier Query System\\n\\nRM 3,800.00\\n\\n1. One admin Login system with entry\\n2. Database entry of Equipment and Supplier\\n3. To display result based on Equipment Query\\n\\nB. Wordpress Maintenance\\n\\nRM 600.00\\n\\n1. To update the content of Crest.my\\n2. Content is provided by Crest.my\\n","category":"0","subcategory":"0","cost":"800.00","price":"4400.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-02-24 09:23:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2014-04-10 09:40:51', 'shamiradnan'),
(661, 'sales', 'edit', 'quote', 10027, '{"id":"10027","txn_no":"1-10025","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-03-26 00:00:00","due_date":"2014-04-26 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Collaborative Research in Engineering, Science & Technology (CREST)","contact_id":"1151","contact_address":"{\\"address1\\":\\"sains@usm,Block C, Ground Floor\\",\\"address2\\":\\" No.10 Persiaran Bukit Jambul\\",\\"zipcode\\":\\"11900 \\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Collaborative Research in Engineering, Science & Technology (CREST)\\",\\"mobile\\":\\"604 652 0088\\",\\"address1\\":\\"sains@usm,Block C, Ground Floor\\",\\"address2\\":\\" No.10 Persiaran Bukit Jambul\\",\\"zipcode\\":\\"11900 \\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4400.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-02-24 09:28:09","added_by":"admin","modified_on":"2014-04-10 09:41:27","modified_by":"shamiradnan","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"136","quote_id":"10027","date":"2014-03-26 00:00:00","type":"service","item_id":"0","service_id":"54","item_name":"Equipment and Supplier Query System and Wordpress Maintenance","item_description":"A. Equipment and Supplier Query System\\n\\nRM 3,800.00\\n\\nThis system will display and search list of vendors from database. It will provide details of Service Provider\\/Vendor of the \\"Shared Service Name\\" , Model , Facilities, Person In Charge,  Email, Address, Phone Number and Etc. This system will have the followings \\n\\n1. One admin Login system with entry\\n2. Database entry of Equipment and Supplier\\n3. To display result based on Equipment Query\\n\\nDuration of Completion 1 Month\\n\\nB. System Maintenance\\n\\nRM 600.00\\n\\n1. To update the content of Crest.my\\n2. Content is provided by Crest.my\\n\\nAttached Together with This Quotes\\n1. The mock up of the System\\n\\n\\nPayment Terms*\\n\\n1. 50% Project Kick Start\\n2. 50% Completion of Project \\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"4400.0000","price":"4400.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"54":{"id":"54","name":"Equipment and Supplier Query System and Wordpress Maintenance","description":"A. Equipment and Supplier Query System\\n\\nRM 3,800.00\\n\\n1. One admin Login system with entry\\n2. Database entry of Equipment and Supplier\\n3. To display result based on Equipment Query\\n\\nB. Wordpress Maintenance\\n\\nRM 600.00\\n\\n1. To update the content of Crest.my\\n2. Content is provided by Crest.my\\n","category":"0","subcategory":"0","cost":"800.00","price":"4400.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-02-24 09:23:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2014-04-10 09:41:27', 'shamiradnan'),
(662, 'sales', 'delete', 'invoice', 10035, '{"id":"10035","txn_no":"1-10035","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-04-10 12:00:00","due_date":null,"received_date":null,"contact_person":" ","contact":"Teh Chai Soon","contact_id":"1140","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Teh Chai Soon\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"42.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-04-10 09:38:01","added_by":"azad","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"2.00\\"}","total_tax":"2.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"87","invoice_id":"10035","type":"service","date":"2014-04-10 12:00:00","item_name":"Seminar Room","item_description":"4 hours ( 16 & 22 March)","item_id":"0","service_id":"53","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"40.0000","price":"40.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"53":{"id":"53","name":"Seminar Room","description":"","category":"0","subcategory":"0","cost":"40.00","price":"40.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-02-04 13:50:57","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1140","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Teh Chai Soon","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Pulau Pinang","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-06 12:45:29","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1383713129"},"sale":null,"sale_items":null}', '2014-04-10 09:41:35', 'azad'),
(663, 'sales', 'add', 'invoice', 10036, '{"id":"10036","txn_no":"1-10035","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-04-10 12:00:00","due_date":null,"received_date":null,"contact_person":" ","contact":"Teh Chai Soon","contact_id":"1140","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Teh Chai Soon\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"160.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-04-10 09:42:22","added_by":"azad","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"0.00\\"}","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"88","invoice_id":"10036","type":"service","date":"2014-04-10 12:00:00","item_name":"Seminar Room","item_description":"4 Hours (12 and 22 March)","item_id":"0","service_id":"53","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"160.0000","price":"160.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"53":{"id":"53","name":"Seminar Room","description":"","category":"0","subcategory":"0","cost":"40.00","price":"40.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-02-04 13:50:57","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1140","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Teh Chai Soon","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Pulau Pinang","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-06 12:45:29","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1383713129"},"sale":null,"sale_items":null}', '2014-04-10 09:42:22', 'azad'),
(664, 'sales', 'edit', 'quote', 10027, '{"id":"10027","txn_no":"1-10025","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-03-26 00:00:00","due_date":"2014-04-26 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Collaborative Research in Engineering, Science & Technology (CREST)","contact_id":"1151","contact_address":"{\\"address1\\":\\"sains@usm,Block C, Ground Floor\\",\\"address2\\":\\" No.10 Persiaran Bukit Jambul\\",\\"zipcode\\":\\"11900 \\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Collaborative Research in Engineering, Science & Technology (CREST)\\",\\"mobile\\":\\"604 652 0088\\",\\"address1\\":\\"sains@usm,Block C, Ground Floor\\",\\"address2\\":\\" No.10 Persiaran Bukit Jambul\\",\\"zipcode\\":\\"11900 \\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"5900.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-02-24 09:28:09","added_by":"admin","modified_on":"2014-04-10 11:12:22","modified_by":"shamiradnan","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"137","quote_id":"10027","date":"2014-03-26 00:00:00","type":"service","item_id":"0","service_id":"54","item_name":"Equipment and Supplier Query System and Wordpress Maintenance","item_description":"A. Equipment and Supplier Query System\\n\\nRM 3,800.00\\n\\nThis system will display and search list of vendors from database. It will provide details of Service Provider\\/Vendor of the \\"Shared Service Name\\" , Model , Facilities, Person In Charge,  Email, Address, Phone Number and Etc. This system will have the followings \\n\\n1. One admin Login system with entry\\n2. Database entry of Equipment and Supplier\\n3. To display result based on Equipment Query\\n\\nDuration of Completion 1 Month\\n\\nB. System Maintenance\\n\\nRM 600.00\\n\\n1. To update the content of Crest.my\\n2. Content is provided by Crest.my\\n\\nAttached Together with This Quotes\\n1. The mock up of the System\\n\\nC. Project Submission System \\n\\nRM 1500.00\\n\\nThis system allows end user to submit brief information of their project and skill\\/talent requirement. The information submitted will be displayed as a list of projects. Interested Researcher(skill\\/talent) who is interested with the project will be able to view to project details and download application form.\\n\\nDuration of Completion 1 Month","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5900.0000","price":"5900.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"54":{"id":"54","name":"Equipment and Supplier Query System and Wordpress Maintenance","description":"A. Equipment and Supplier Query System\\n\\nRM 3,800.00\\n\\n1. One admin Login system with entry\\n2. Database entry of Equipment and Supplier\\n3. To display result based on Equipment Query\\n\\nB. Wordpress Maintenance\\n\\nRM 600.00\\n\\n1. To update the content of Crest.my\\n2. Content is provided by Crest.my\\n","category":"0","subcategory":"0","cost":"800.00","price":"4400.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-02-24 09:23:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2014-04-10 11:12:23', 'shamiradnan'),
(665, 'sales', 'edit', 'quote', 10027, '{"id":"10027","txn_no":"1-10025","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-03-26 00:00:00","due_date":"2014-04-26 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Collaborative Research in Engineering, Science & Technology (CREST)","contact_id":"1151","contact_address":"{\\"address1\\":\\"sains@usm,Block C, Ground Floor\\",\\"address2\\":\\" No.10 Persiaran Bukit Jambul\\",\\"zipcode\\":\\"11900 \\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Collaborative Research in Engineering, Science & Technology (CREST)\\",\\"mobile\\":\\"604 652 0088\\",\\"address1\\":\\"sains@usm,Block C, Ground Floor\\",\\"address2\\":\\" No.10 Persiaran Bukit Jambul\\",\\"zipcode\\":\\"11900 \\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"5900.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-02-24 09:28:09","added_by":"admin","modified_on":"2014-04-10 11:13:22","modified_by":"shamiradnan","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"138","quote_id":"10027","date":"2014-03-26 00:00:00","type":"service","item_id":"0","service_id":"54","item_name":"Equipment and Supplier Query System and Wordpress Maintenance","item_description":"A. Equipment and Supplier Query System\\nRM 3,800.00\\n\\nThis system will display and search list of vendors from database. It will provide details of Service Provider\\/Vendor of the \\"Shared Service Name\\" , Model , Facilities, Person In Charge,  Email, Address, Phone Number and Etc. This system will have the followings \\n\\n1. One admin Login system with entry\\n2. Database entry of Equipment and Supplier\\n3. To display result based on Equipment Query\\n\\nDuration of Completion 1 Month\\n\\n-----\\n\\nB. System Maintenance\\nRM 600.00\\n\\n1. To update the content of Crest.my\\n2. Content is provided by Crest.my\\n\\nAttached Together with This Quotes\\n1. The mock up of the System\\n\\n-----\\n\\nC. Project Submission System \\nRM 1500.00\\n\\nThis system allows end user to submit brief information of their project and skill\\/talent requirement. The information submitted will be displayed as a list of projects. Interested Researcher(skill\\/talent) who is interested with the project will be able to view to project details and download application form.\\n\\nDuration of Completion 1 Month","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5900.0000","price":"5900.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"54":{"id":"54","name":"Equipment and Supplier Query System and Wordpress Maintenance","description":"A. Equipment and Supplier Query System\\n\\nRM 3,800.00\\n\\n1. One admin Login system with entry\\n2. Database entry of Equipment and Supplier\\n3. To display result based on Equipment Query\\n\\nB. Wordpress Maintenance\\n\\nRM 600.00\\n\\n1. To update the content of Crest.my\\n2. Content is provided by Crest.my\\n","category":"0","subcategory":"0","cost":"800.00","price":"4400.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-02-24 09:23:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2014-04-10 11:13:22', 'shamiradnan'),
(666, 'sales', 'edit', 'quote', 10028, '{"id":"10028","txn_no":"2-10001","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-04-02 00:00:00","due_date":"2014-04-09 00:00:00","contact_person":" Shafiq Rizwan","payment_date":null,"received_date":null,"contact":"D''Tandoor Bukit Mertajam","contact_id":"1158","contact_address":"{\\"address1\\":\\"No 43, Lorong Perda Selatan 2\\",\\"address2\\":\\"Bandar Perda\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"D''Tandoor Bukit Mertajam\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No 43, Lorong Perda Selatan 2\\",\\"address2\\":\\"Bandar Perda\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"8700.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-04-02 12:07:23","added_by":"shafiq","modified_on":"2014-04-18 15:54:37","modified_by":"shafiq","no_do":null,"division_id":null,"warehouse_id":"2","assigned_to":null,"orders":[{"id":"139","quote_id":"10028","date":"2014-04-02 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"Food and Beverage POS ","item_description":"Packages Included:\\n1) 1 x All-In-One Touch Screen POS\\n2) 1 x Cash Drawer\\n3) 3 x Thermal Printer\\n5) Plexcloud Food and Beverage Software\\n6) Installation","discount":"0","discount_type":null,"qty":"1","price_per_unit":"8700.0000","price":"8700.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"2"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"}}}', '2014-04-18 15:54:37', 'shafiq'),
(667, 'sales', 'add', 'invoice', 10037, '{"id":"10037","txn_no":"1-10036","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-04-21 12:00:00","due_date":null,"received_date":null,"contact_person":"Shamir Adnan","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2625.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-04-21 18:33:59","added_by":"shamiradnan","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"125.00\\"}","total_tax":"125.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"89","invoice_id":"10037","type":"service","date":"2014-04-21 12:00:00","item_name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","item_description":"","item_id":"0","service_id":"52","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"52":{"id":"52","name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","description":"","category":"0","subcategory":"0","cost":"2000.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-01-26 01:47:56","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-04-21 18:33:59', 'shamiradnan'),
(668, 'sales', 'edit', 'invoice', NULL, '[]', '2014-04-21 18:34:31', 'shamiradnan');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(669, 'sales', 'add', 'invoice', 10038, '{"id":"10038","txn_no":"1-10037","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-04-21 12:00:00","due_date":null,"received_date":null,"contact_person":"Shamir Adnan","contact":"Uniform Gallery","contact_id":"1154","contact_address":"{\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Uniform Gallery\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3780.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-04-21 18:36:02","added_by":"shamiradnan","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"180.00\\"}","total_tax":"180.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"91","invoice_id":"10038","type":"service","date":"2014-04-21 12:00:00","item_name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","item_description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","item_id":"0","service_id":"58","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"3600.0000","price":"3600.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"58":{"id":"58","name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","category":"0","subcategory":"0","cost":"0.00","price":"3600.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-03-21 09:01:39","added_by":"shafiq","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1154","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Uniform Gallery","company_registration":"","contact_person":"Uniform Gallery","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No 42, 43 & 43A, Blok E","address2":"Seri Bangi, Jln 8\\/35, Seksyen 8","city":"Bandar Baru Bangi","state":"Selangor","zipcode":"43650","country":"Malaysia","tel":"","fax":"","general_email":"lguniformgallery@yahoo.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-21 08:58:49","added_by":"shafiq","modified_on":"2014-03-21 09:21:34","modified_by":"shafiq","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-04-21 18:36:02', 'shamiradnan'),
(670, 'sales', 'edit', 'invoice', NULL, '[]', '2014-04-21 18:36:15', 'shamiradnan'),
(671, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"5.000","enabled":"0"}', '2014-04-26 19:56:25', 'shafiq'),
(672, 'sales', 'edit', 'invoice', 10038, '{"id":"10038","txn_no":"1-10037","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-04-21 12:00:00","due_date":null,"received_date":null,"contact_person":"Shamir Adnan","contact":"Uniform Gallery","contact_id":"1154","contact_address":"{\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Uniform Gallery\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3600.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-04-21 18:36:02","added_by":"shamiradnan","modified_on":"2014-04-26 19:56:40","modified_by":"shafiq","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"93","invoice_id":"10038","type":"service","date":"2014-04-21 12:00:00","item_name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","item_description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","item_id":"0","service_id":"58","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"3600.0000","price":"3600.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"58":{"id":"58","name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","category":"0","subcategory":"0","cost":"0.00","price":"3600.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-03-21 09:01:39","added_by":"shafiq","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1154","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Uniform Gallery","company_registration":"","contact_person":"Uniform Gallery","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No 42, 43 & 43A, Blok E","address2":"Seri Bangi, Jln 8\\/35, Seksyen 8","city":"Bandar Baru Bangi","state":"Selangor","zipcode":"43650","country":"Malaysia","tel":"","fax":"","general_email":"lguniformgallery@yahoo.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-21 08:58:49","added_by":"shafiq","modified_on":"2014-03-21 09:21:34","modified_by":"shafiq","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-04-26 19:56:40', 'shafiq'),
(673, 'sales', 'edit', 'invoice', 10037, '{"id":"10037","txn_no":"1-10036","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-04-21 12:00:00","due_date":null,"received_date":null,"contact_person":"Shamir Adnan","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-04-21 18:33:59","added_by":"shamiradnan","modified_on":"2014-04-26 19:56:47","modified_by":"shafiq","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"94","invoice_id":"10037","type":"service","date":"2014-04-21 12:00:00","item_name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","item_description":"","item_id":"0","service_id":"52","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"52":{"id":"52","name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","description":"","category":"0","subcategory":"0","cost":"2000.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-01-26 01:47:56","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-04-26 19:56:48', 'shafiq'),
(674, 'sales', 'add', 'invoice', 10039, '{"id":"10039","txn_no":"1-10038","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-05-07 12:00:00","due_date":null,"received_date":null,"contact_person":"Shamir Adnan","contact":"Ramli Buyong","contact_id":"1129","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Kuala Kangsar\\",\\"state\\":\\"Perak\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Ramli Buyong\\",\\"mobile\\":\\"\\",\\"address1\\":\\"www.RamliHomestay.com\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"Kuala Kangsar\\",\\"state\\":\\"Perak\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-05-07 14:45:07","added_by":"shamiradnan","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"95","invoice_id":"10039","type":"service","date":"2014-05-07 12:00:00","item_name":"Renewal of Domain and Hosting","item_description":"Yearly Renewal of Domain and Hosting","item_id":"0","service_id":"56","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"200.0000","price":"200.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"56":{"id":"56","name":"Renewal of Domain and Hosting","description":"Yearly Renewal of Domain and Hosting","category":"0","subcategory":"0","cost":"50.00","price":"200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-02-24 23:24:46","added_by":"shamiradnan","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1129","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Ramli Buyong","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"Kuala Kangsar","state":"Perak","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"0135105563 ","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-05-31 12:30:19","added_by":"admin2","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-05-07 14:45:07', 'shamiradnan'),
(675, 'contacts', 'add', 'contact', 1161, '{"id":"1161","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Kedai Kecil Dina","company_registration":"","contact_person":"Diana","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-05-07 14:47:08","added_by":"shamiradnan","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-05-07 14:47:08', 'shamiradnan'),
(676, 'sales', 'add', 'invoice', 10040, '{"id":"10040","txn_no":"1-10039","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-05-07 12:00:00","due_date":null,"received_date":null,"contact_person":"Shamir Adnan","contact":"Kedai Kecil Dina","contact_id":"1161","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Kedai Kecil Dina\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"450.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-05-07 14:49:06","added_by":"shamiradnan","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"96","invoice_id":"10040","type":"service","date":"2014-05-07 12:00:00","item_name":"OneOrder Website","item_description":"*Free domain and Hosting 1st year","item_id":"0","service_id":"60","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"450.0000","price":"450.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"60":{"id":"60","name":"OneOrder Website","description":"","category":"0","subcategory":"0","cost":"100.00","price":"450.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-05-07 14:48:22","added_by":"shamiradnan","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1161","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Kedai Kecil Dina","company_registration":"","contact_person":"Diana","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-05-07 14:47:08","added_by":"shamiradnan","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-05-07 14:49:06', 'shamiradnan'),
(677, 'contacts', 'add', 'contact', 1162, '{"id":"1162","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Darulaman Golf Resort","company_registration":"","contact_person":"Mohamad Zaher Bin Ahmad","contact_number":"0139869596","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Bandar Darulaman","address2":"P.O Box 24","city":"Jitra","state":"Kedah","zipcode":"06007","country":"Malaysia","tel":"","fax":"","general_email":"zaher_dgcc@yahoo.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-05-15 12:59:29","added_by":"azad","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-05-15 12:59:29', 'azad'),
(678, 'sales', 'add', 'quote', 10032, '{"id":"10032","txn_no":"1-10027","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-05-15 00:00:00","due_date":"2014-06-15 00:00:00","contact_person":" ","payment_date":null,"received_date":null,"contact":"Darulaman Golf Resort","contact_id":"1162","contact_address":"{\\"address1\\":\\"Bandar Darulaman\\",\\"address2\\":\\"P.O Box 24\\",\\"zipcode\\":\\"06007\\",\\"city\\":\\"Jitra\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Darulaman Golf Resort\\",\\"mobile\\":\\"0139869596\\",\\"address1\\":\\"Bandar Darulaman\\",\\"address2\\":\\"P.O Box 24\\",\\"zipcode\\":\\"06007\\",\\"city\\":\\"Jitra\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"8000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-05-15 13:01:02","added_by":"azad","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"140","quote_id":"10032","date":"2014-05-15 00:00:00","type":"service","item_id":"0","service_id":"37","item_name":"Basic F&B Plexcloud Subscription ","item_description":"Plexcloud Modules Included:\\n\\nF&B Module \\nHR [Beta]\\nReport]\\n\\nHardwares Included:\\n\\n1 Unit F&B Plexcloud in a box\\n2 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\n\\nQuoted price can be converted to 18 months term payment for RM900 monthly ","discount":"0","discount_type":null,"qty":"1","price_per_unit":"8000.0000","price":"8000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"37":{"id":"37","name":"Basic F&B Plexcloud Subscription ","description":"Plexcloud Modules Included:\\n\\nF&B Module \\nAccount  [Beta]\\nHR [Beta]\\nReport [Beta]\\n\\nHardwares Included:\\n\\n1 Unit F&B Plexcloud in a box\\n2 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\n\\nQuoted price can be converted to 18 months term payment for RM900 monthly ","category":"0","subcategory":"0","cost":"400.00","price":"16200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-07-16 20:52:51","added_by":"admin2","modified_on":"2013-12-11 21:10:55","modified_by":"admin2","warehouse_id":"0"}}}', '2014-05-15 13:01:02', 'azad'),
(679, 'sales', 'edit', 'quote', 10032, '{"id":"10032","txn_no":"1-10027","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-05-15 00:00:00","due_date":"2014-06-15 00:00:00","contact_person":" Azad Affif ishak","payment_date":null,"received_date":null,"contact":"Darulaman Golf Resort","contact_id":"1162","contact_address":"{\\"address1\\":\\"Bandar Darulaman\\",\\"address2\\":\\"P.O Box 24\\",\\"zipcode\\":\\"06007\\",\\"city\\":\\"Jitra\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Darulaman Golf Resort\\",\\"mobile\\":\\"0139869596\\",\\"address1\\":\\"Bandar Darulaman\\",\\"address2\\":\\"P.O Box 24\\",\\"zipcode\\":\\"06007\\",\\"city\\":\\"Jitra\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"8000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-05-15 13:01:02","added_by":"azad","modified_on":"2014-05-15 13:01:24","modified_by":"azad","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"141","quote_id":"10032","date":"2014-05-15 00:00:00","type":"service","item_id":"0","service_id":"37","item_name":"Basic F&B Plexcloud Subscription ","item_description":"Plexcloud Modules Included:\\n\\nF&B Module \\nHR [Beta]\\nReport]\\n\\nHardwares Included:\\n\\n1 Unit F&B Plexcloud in a box\\n2 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\n\\nQuoted price can be converted to 18 months term payment for RM900 monthly ","discount":"0","discount_type":null,"qty":"1","price_per_unit":"8000.0000","price":"8000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"37":{"id":"37","name":"Basic F&B Plexcloud Subscription ","description":"Plexcloud Modules Included:\\n\\nF&B Module \\nAccount  [Beta]\\nHR [Beta]\\nReport [Beta]\\n\\nHardwares Included:\\n\\n1 Unit F&B Plexcloud in a box\\n2 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\n\\nQuoted price can be converted to 18 months term payment for RM900 monthly ","category":"0","subcategory":"0","cost":"400.00","price":"16200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-07-16 20:52:51","added_by":"admin2","modified_on":"2013-12-11 21:10:55","modified_by":"admin2","warehouse_id":"0"}}}', '2014-05-15 13:01:24', 'azad'),
(680, 'sales', 'edit', 'quote', 10032, '{"id":"10032","txn_no":"1-10027","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-05-15 00:00:00","due_date":"2014-06-15 00:00:00","contact_person":" Azad Affif ishak","payment_date":null,"received_date":null,"contact":"Darulaman Golf Resort","contact_id":"1162","contact_address":"{\\"address1\\":\\"Bandar Darulaman\\",\\"address2\\":\\"P.O Box 24\\",\\"zipcode\\":\\"06007\\",\\"city\\":\\"Jitra\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Darulaman Golf Resort\\",\\"mobile\\":\\"0139869596\\",\\"address1\\":\\"Bandar Darulaman\\",\\"address2\\":\\"P.O Box 24\\",\\"zipcode\\":\\"06007\\",\\"city\\":\\"Jitra\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"8000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-05-15 13:01:02","added_by":"azad","modified_on":"2014-05-15 13:04:18","modified_by":"azad","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"142","quote_id":"10032","date":"2014-05-15 00:00:00","type":"service","item_id":"0","service_id":"37","item_name":"Basic F&B Plexcloud Subscription ","item_description":"Plexcloud Modules Included:\\n\\nF&B Module \\nHR [Beta]\\nReport]\\n\\nHardwares Included:\\n\\n\\n2 Units Ipod Touch\\n3 Units Thermal Printer\\n1 Unit Cash Drawer\\n\\n","discount":"","discount_type":"p","qty":"1","price_per_unit":"8000.0000","price":"8000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"37":{"id":"37","name":"Basic F&B Plexcloud Subscription ","description":"Plexcloud Modules Included:\\n\\nF&B Module \\nAccount  [Beta]\\nHR [Beta]\\nReport [Beta]\\n\\nHardwares Included:\\n\\n1 Unit F&B Plexcloud in a box\\n2 Units Ipod Touch\\n4 Units Thermal Printer\\n1 Unit Touch Screen POS\\n1 Unit Cash Drawer\\n\\n\\nQuoted price can be converted to 18 months term payment for RM900 monthly ","category":"0","subcategory":"0","cost":"400.00","price":"16200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-07-16 20:52:51","added_by":"admin2","modified_on":"2013-12-11 21:10:55","modified_by":"admin2","warehouse_id":"0"}}}', '2014-05-15 13:04:18', 'azad'),
(681, 'contacts', 'add', 'contact', 1163, '{"id":"1163","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Redzuan","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-05-16 09:52:41","added_by":"shafiq","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-05-16 09:52:41', 'shafiq'),
(682, 'sales', 'add', 'quote', 10033, '{"id":"10033","txn_no":"1-10028","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-05-16 00:00:00","due_date":"2014-05-25 00:00:00","contact_person":" ","payment_date":null,"received_date":null,"contact":"Redzuan","contact_id":"1163","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Redzuan\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-05-16 09:53:55","added_by":"shafiq","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"143","quote_id":"10033","date":"2014-05-16 00:00:00","type":"service","item_id":"0","service_id":"7","item_name":"Android App Application Development","item_description":"- Content App with Google Ads","discount":"0","discount_type":null,"qty":"1","price_per_unit":"1500.0000","price":"1500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"7":{"id":"7","name":"iOS App Application Development","description":"","category":"0","subcategory":"0","cost":"0.00","price":"1500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-04-18 07:03:14","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}}}', '2014-05-16 09:53:56', 'shafiq'),
(683, 'contacts', 'edit', 'contact', 1163, '{"id":"1163","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Redzuan","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Kuala Lumpur","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-05-16 09:52:41","added_by":"shafiq","modified_on":"2014-05-16 09:55:03","modified_by":"shafiq","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-05-16 09:55:03', 'shafiq'),
(684, 'sales', 'edit', 'quote', 10033, '{"id":"10033","txn_no":"1-10028","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-05-16 00:00:00","due_date":"2014-05-25 00:00:00","contact_person":" ","payment_date":null,"received_date":null,"contact":"Redzuan","contact_id":"1163","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Redzuan\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-05-16 09:53:55","added_by":"shafiq","modified_on":"2014-05-16 09:55:22","modified_by":"shafiq","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"144","quote_id":"10033","date":"2014-05-16 00:00:00","type":"service","item_id":"0","service_id":"7","item_name":"Android App Application Development","item_description":"- Content App with Google Ads","discount":"0","discount_type":null,"qty":"1","price_per_unit":"1500.0000","price":"1500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"7":{"id":"7","name":"iOS App Application Development","description":"","category":"0","subcategory":"0","cost":"0.00","price":"1500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-04-18 07:03:14","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}}}', '2014-05-16 09:55:22', 'shafiq'),
(685, 'sales', 'add', 'invoice', 10041, '{"id":"10041","txn_no":"1-10040","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-05-27 12:00:00","due_date":null,"received_date":null,"contact_person":"Shamir Adnan","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-05-27 09:42:39","added_by":"shamiradnan","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"97","invoice_id":"10041","type":"service","date":"2014-05-27 12:00:00","item_name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","item_description":"","item_id":"0","service_id":"52","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"52":{"id":"52","name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","description":"","category":"0","subcategory":"0","cost":"2000.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-01-26 01:47:56","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-05-27 09:42:39', 'shamiradnan'),
(686, 'sales', 'add', 'invoice', 10042, '{"id":"10042","txn_no":"1-10041","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-05-27 12:00:00","due_date":null,"received_date":null,"contact_person":"Shamir Adnan","contact":"Uniform Gallery","contact_id":"1154","contact_address":"{\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Uniform Gallery\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3600.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-05-27 09:43:14","added_by":"shamiradnan","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"98","invoice_id":"10042","type":"service","date":"2014-05-27 12:00:00","item_name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","item_description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","item_id":"0","service_id":"58","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"3600.0000","price":"3600.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"58":{"id":"58","name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","category":"0","subcategory":"0","cost":"0.00","price":"3600.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-03-21 09:01:39","added_by":"shafiq","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1154","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Uniform Gallery","company_registration":"","contact_person":"Uniform Gallery","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No 42, 43 & 43A, Blok E","address2":"Seri Bangi, Jln 8\\/35, Seksyen 8","city":"Bandar Baru Bangi","state":"Selangor","zipcode":"43650","country":"Malaysia","tel":"","fax":"","general_email":"lguniformgallery@yahoo.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-21 08:58:49","added_by":"shafiq","modified_on":"2014-03-21 09:21:34","modified_by":"shafiq","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-05-27 09:43:14', 'shamiradnan'),
(687, 'sales', 'add', 'so', 10017, '{"id":"10017","txn_no":"1-10014","quote_id":"0","invoice_id":null,"number":"0","pr_number":null,"po_number":"0","date":"2014-06-16 00:00:00","due_date":"2014-06-16 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"9.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-06-16 10:07:43","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"18","sales_order_id":"10017","type":"product","date":"2014-06-16 00:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"9.0000","price":"9.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"79","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2014-04-18 22:02:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2014-06-16 10:07:43', 'admin'),
(688, 'sales', 'edit', 'so', 10017, '{"id":"10017","txn_no":"1-10014","quote_id":"0","invoice_id":null,"number":"0","pr_number":null,"po_number":"0","date":"2014-06-16 00:00:00","due_date":"2014-06-16 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"9.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-06-16 10:07:43","added_by":"admin","modified_on":"2014-06-16 12:20:03","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"19","sales_order_id":"10017","type":"product","date":"2014-06-16 00:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"9.0000","price":"9.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"79","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2014-04-18 22:02:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2014-06-16 12:20:03', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(689, 'sales', 'status_update', 'so', 10017, '{"id":"10017","txn_no":"1-10014","quote_id":"0","invoice_id":null,"number":"0","pr_number":null,"po_number":"0","date":"2014-06-16 00:00:00","due_date":"2014-06-16 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Completed","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"9.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-06-16 10:07:43","added_by":"admin","modified_on":"2014-06-16 12:20:03","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"19","sales_order_id":"10017","type":"product","date":"2014-06-16 00:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"9.0000","price":"9.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"79","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2014-04-18 22:02:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2014-06-16 12:20:19', 'admin'),
(690, 'sales', 'add', 'invoice', 10043, '{"id":"10043","txn_no":"1-10042","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-06-16 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"9.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-06-16 12:21:14","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"99","invoice_id":"10043","type":"product","date":"2014-06-16 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"9.0000","price":"9.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"79","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2014-04-18 22:02:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1015","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"1","is_franchise":"0","is_franchisee":null,"company_name":"Plexsol HQ","company_registration":"","contact_person":"Shafiq Rizwan","contact_number":"0124205391","credit_limit":"0.00","rank":"Normal Member","email":"shafiq@plexsol.com","ic":"880102355071","password":"88aa5e3aad2dbc037bcae4f0a9d5210c","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"0124205391","fax":"","general_email":"0","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 11:26:32","added_by":"@Plexcart","modified_on":"2013-04-01 14:15:33","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shafiq@plexsol.com1355319281","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-06-16 12:21:14', 'admin'),
(691, 'sales', 'deliver', 'invoice', 10043, '{"id":"10043","txn_no":"1-10042","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-06-16 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"9.00","total_delivered":"9.00","cost":null,"tags":"","added_on":"2014-06-16 12:21:14","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"99","invoice_id":"10043","type":"product","date":"2014-06-16 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"9.0000","price":"9.00","cost":"2.00","margin":null,"delivered":"1","delivered_price":"9.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"78","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2014-06-16 12:21:56","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1015","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"1","is_franchise":"0","is_franchisee":null,"company_name":"Plexsol HQ","company_registration":"","contact_person":"Shafiq Rizwan","contact_number":"0124205391","credit_limit":"0.00","rank":"Normal Member","email":"shafiq@plexsol.com","ic":"880102355071","password":"88aa5e3aad2dbc037bcae4f0a9d5210c","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"0124205391","fax":"","general_email":"0","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 11:26:32","added_by":"@Plexcart","modified_on":"2013-04-01 14:15:33","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shafiq@plexsol.com1355319281","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-06-16 12:21:56', 'admin'),
(692, 'sales', 'status_update', 'invoice', 10043, '{"id":"10043","txn_no":"1-10042","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-06-16 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"9.00","total_delivered":"9.00","cost":null,"tags":"","added_on":"2014-06-16 12:21:14","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"99","invoice_id":"10043","type":"product","date":"2014-06-16 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"9.0000","price":"9.00","cost":"2.00","margin":null,"delivered":"1","delivered_price":"9.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"78","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2014-06-16 12:21:56","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1015","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"1","is_franchise":"0","is_franchisee":null,"company_name":"Plexsol HQ","company_registration":"","contact_person":"Shafiq Rizwan","contact_number":"0124205391","credit_limit":"0.00","rank":"Normal Member","email":"shafiq@plexsol.com","ic":"880102355071","password":"88aa5e3aad2dbc037bcae4f0a9d5210c","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"0124205391","fax":"","general_email":"0","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 11:26:32","added_by":"@Plexcart","modified_on":"2013-04-01 14:15:33","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shafiq@plexsol.com1355319281","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-06-16 12:21:58', 'admin'),
(693, 'sales', 'status_update', 'invoice', 10043, '{"id":"10043","txn_no":"1-10042","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-06-16 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"9.00","total_delivered":"0.00","cost":null,"tags":"","added_on":"2014-06-16 12:21:14","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"99","invoice_id":"10043","type":"product","date":"2014-06-16 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"9.0000","price":"9.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"9.00","done":"0","no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"79","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2014-06-16 12:21:56","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1015","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"1","is_franchise":"0","is_franchisee":null,"company_name":"Plexsol HQ","company_registration":"","contact_person":"Shafiq Rizwan","contact_number":"0124205391","credit_limit":"0.00","rank":"Normal Member","email":"shafiq@plexsol.com","ic":"880102355071","password":"88aa5e3aad2dbc037bcae4f0a9d5210c","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"0124205391","fax":"","general_email":"0","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 11:26:32","added_by":"@Plexcart","modified_on":"2013-04-01 14:15:33","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shafiq@plexsol.com1355319281","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-06-16 12:31:47', 'admin'),
(694, 'sales', 'status_update', 'invoice', 10043, '{"id":"10043","txn_no":"1-10042","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-06-16 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"9.00","total_delivered":"0.00","cost":null,"tags":"","added_on":"2014-06-16 12:21:14","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"99","invoice_id":"10043","type":"product","date":"2014-06-16 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"9.0000","price":"9.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"9.00","done":"0","no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"79","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2014-06-16 12:21:56","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1015","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"1","is_franchise":"0","is_franchisee":null,"company_name":"Plexsol HQ","company_registration":"","contact_person":"Shafiq Rizwan","contact_number":"0124205391","credit_limit":"0.00","rank":"Normal Member","email":"shafiq@plexsol.com","ic":"880102355071","password":"88aa5e3aad2dbc037bcae4f0a9d5210c","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"0124205391","fax":"","general_email":"0","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 11:26:32","added_by":"@Plexcart","modified_on":"2013-04-01 14:15:33","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shafiq@plexsol.com1355319281","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-06-16 12:32:12', 'admin'),
(695, 'sales', 'add', 'so', 10018, '{"id":"10018","txn_no":"1-10015","quote_id":"0","invoice_id":null,"number":"0","pr_number":null,"po_number":"0","date":"2014-06-16 00:00:00","due_date":"2014-06-16 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"45.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-06-16 12:32:50","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"20","sales_order_id":"10018","type":"product","date":"2014-06-16 00:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"5","price_per_unit":"9.0000","price":"45.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"79","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2014-06-16 12:21:56","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2014-06-16 12:32:50', 'admin'),
(696, 'sales', 'add', 'invoice', 10044, '{"id":"10044","txn_no":"1-10043","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-06-16 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"9.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-06-16 12:35:11","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"100","invoice_id":"10044","type":"product","date":"2014-06-16 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"9.0000","price":"9.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"79","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2014-06-16 12:21:56","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1015","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"1","is_franchise":"0","is_franchisee":null,"company_name":"Plexsol HQ","company_registration":"","contact_person":"Shafiq Rizwan","contact_number":"0124205391","credit_limit":"0.00","rank":"Normal Member","email":"shafiq@plexsol.com","ic":"880102355071","password":"88aa5e3aad2dbc037bcae4f0a9d5210c","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"0124205391","fax":"","general_email":"0","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 11:26:32","added_by":"@Plexcart","modified_on":"2013-04-01 14:15:33","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shafiq@plexsol.com1355319281","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-06-16 12:35:11', 'admin'),
(697, 'sales', 'add', 'invoice', 10045, '{"id":"10045","txn_no":"1-10044","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-06-16 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"9.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-06-16 12:36:41","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"101","invoice_id":"10045","type":"product","date":"2014-06-16 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"9.0000","price":"9.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"79","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2014-06-16 12:21:56","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1015","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"1","is_franchise":"0","is_franchisee":null,"company_name":"Plexsol HQ","company_registration":"","contact_person":"Shafiq Rizwan","contact_number":"0124205391","credit_limit":"0.00","rank":"Normal Member","email":"shafiq@plexsol.com","ic":"880102355071","password":"88aa5e3aad2dbc037bcae4f0a9d5210c","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"0124205391","fax":"","general_email":"0","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 11:26:32","added_by":"@Plexcart","modified_on":"2013-04-01 14:15:33","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shafiq@plexsol.com1355319281","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-06-16 12:36:41', 'admin'),
(698, 'sales', 'status_update', 'so', 10024, '{"id":"10024","txn_no":"1-10016","quote_id":null,"invoice_id":null,"number":null,"pr_number":null,"po_number":null,"date":"2014-06-16 12:47:21","due_date":"2014-07-16 12:47:21","received_date":null,"contact_person":null,"contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Shafiq Rizwan\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"zipcode\\":\\"14000\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"No remarks","status":"Pending","payment_gateway":"Manual Payment","payment_method":"Manual","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":"Self Pickup","shipping_id":"6","handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"27.00","total_delivered":null,"cost":"2.00","tags":"Online Sales","added_on":"2014-06-16 12:47:21","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":null,"orders":[{"id":"22","sales_order_id":"10024","type":"product","date":"2014-06-16 12:47:21","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":null,"item_sku":"2001","discount":null,"discount_type":null,"qty":"3","price_per_unit":"9.0000","price":"27.00","cost":"6.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-16 12:38:47","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2014-06-16 12:21:56","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2014-06-16 12:48:48', 'admin'),
(699, 'sales', 'status_update', 'so', 10024, '{"id":"10024","txn_no":"1-10016","quote_id":null,"invoice_id":null,"number":null,"pr_number":null,"po_number":null,"date":"2014-06-16 12:47:21","due_date":"2014-07-16 12:47:21","received_date":null,"contact_person":null,"contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Shafiq Rizwan\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"zipcode\\":\\"14000\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"No remarks","status":"Backordered","payment_gateway":"Manual Payment","payment_method":"Manual","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":"Self Pickup","shipping_id":"6","handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"27.00","total_delivered":null,"cost":"2.00","tags":"Online Sales","added_on":"2014-06-16 12:47:21","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":null,"orders":[{"id":"22","sales_order_id":"10024","type":"product","date":"2014-06-16 12:47:21","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":null,"item_sku":"2001","discount":null,"discount_type":null,"qty":"3","price_per_unit":"9.0000","price":"27.00","cost":"6.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-16 12:38:47","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2014-06-16 12:21:56","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2014-06-16 12:48:56', 'admin'),
(700, 'sales', 'status_update', 'so', 10024, '{"id":"10024","txn_no":"1-10016","quote_id":null,"invoice_id":null,"number":null,"pr_number":null,"po_number":null,"date":"2014-06-16 12:47:21","due_date":"2014-07-16 12:47:21","received_date":null,"contact_person":null,"contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Shafiq Rizwan\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"zipcode\\":\\"14000\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"No remarks","status":"Completed","payment_gateway":"Manual Payment","payment_method":"Manual","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":"Self Pickup","shipping_id":"6","handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"27.00","total_delivered":null,"cost":"2.00","tags":"Online Sales","added_on":"2014-06-16 12:47:21","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":null,"orders":[{"id":"22","sales_order_id":"10024","type":"product","date":"2014-06-16 12:47:21","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":null,"item_sku":"2001","discount":null,"discount_type":null,"qty":"3","price_per_unit":"9.0000","price":"27.00","cost":"6.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-16 12:38:47","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2014-06-16 12:21:56","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2014-06-16 12:49:39', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(701, 'sales', 'add', 'invoice', 10047, '{"id":"10047","txn_no":"1-10045","quote_id":"0","sales_order_id":"10024","number":"0","po_number":"N\\/A","date":"2014-06-16 12:00:00","due_date":null,"received_date":null,"contact_person":"","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Shafiq Rizwan\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"6","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"27.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-06-16 12:49:43","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"103","invoice_id":"10047","type":"product","date":"2014-06-16 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"","discount_type":null,"qty":"3","price_per_unit":"9.0000","price":"27.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-16 12:38:47","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2014-06-16 12:21:56","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1015","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"1","is_franchise":"0","is_franchisee":null,"company_name":"Plexsol HQ","company_registration":"","contact_person":"Shafiq Rizwan","contact_number":"0124205391","credit_limit":"0.00","rank":"Normal Member","email":"shafiq@plexsol.com","ic":"880102355071","password":"88aa5e3aad2dbc037bcae4f0a9d5210c","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"0124205391","fax":"","general_email":"0","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 11:26:32","added_by":"@Plexcart","modified_on":"2013-04-01 14:15:33","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shafiq@plexsol.com1402893746","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-06-16 12:49:43', 'admin'),
(702, 'sales', 'status_update', 'invoice', 10043, '{"id":"10043","txn_no":"1-10042","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-06-16 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"9.00","total_delivered":"0.00","cost":null,"tags":"","added_on":"2014-06-16 12:21:14","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"99","invoice_id":"10043","type":"product","date":"2014-06-16 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"9.0000","price":"9.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"9.00","done":"0","no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-16 12:38:47","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2014-06-16 12:21:56","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1015","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"1","is_franchise":"0","is_franchisee":null,"company_name":"Plexsol HQ","company_registration":"","contact_person":"Shafiq Rizwan","contact_number":"0124205391","credit_limit":"0.00","rank":"Normal Member","email":"shafiq@plexsol.com","ic":"880102355071","password":"88aa5e3aad2dbc037bcae4f0a9d5210c","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"0124205391","fax":"","general_email":"0","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 11:26:32","added_by":"@Plexcart","modified_on":"2013-04-01 14:15:33","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shafiq@plexsol.com1402893746","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-06-16 12:50:00', 'admin'),
(703, 'sales', 'deliver', 'invoice', 10043, '{"id":"10043","txn_no":"1-10042","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-06-16 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"9.00","total_delivered":"9.00","cost":null,"tags":"","added_on":"2014-06-16 12:21:14","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"99","invoice_id":"10043","type":"product","date":"2014-06-16 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"9.0000","price":"9.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"9.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-1","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-16 12:38:47","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2014-06-16 12:50:10","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1015","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"1","is_franchise":"0","is_franchisee":null,"company_name":"Plexsol HQ","company_registration":"","contact_person":"Shafiq Rizwan","contact_number":"0124205391","credit_limit":"0.00","rank":"Normal Member","email":"shafiq@plexsol.com","ic":"880102355071","password":"88aa5e3aad2dbc037bcae4f0a9d5210c","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"0124205391","fax":"","general_email":"0","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 11:26:32","added_by":"@Plexcart","modified_on":"2013-04-01 14:15:33","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shafiq@plexsol.com1402893746","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-06-16 12:50:10', 'admin'),
(704, 'sales', 'status_update', 'invoice', 10043, '{"id":"10043","txn_no":"1-10042","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-06-16 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"9.00","total_delivered":"9.00","cost":null,"tags":"","added_on":"2014-06-16 12:21:14","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"99","invoice_id":"10043","type":"product","date":"2014-06-16 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"9.0000","price":"9.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"9.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-1","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-16 12:38:47","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2014-06-16 12:50:10","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1015","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"1","is_franchise":"0","is_franchisee":null,"company_name":"Plexsol HQ","company_registration":"","contact_person":"Shafiq Rizwan","contact_number":"0124205391","credit_limit":"0.00","rank":"Normal Member","email":"shafiq@plexsol.com","ic":"880102355071","password":"88aa5e3aad2dbc037bcae4f0a9d5210c","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"0124205391","fax":"","general_email":"0","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 11:26:32","added_by":"@Plexcart","modified_on":"2013-04-01 14:15:33","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shafiq@plexsol.com1402893746","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-06-16 12:50:12', 'admin'),
(705, 'sales', 'status_update', 'so', 10024, '{"id":"10024","txn_no":"1-10016","quote_id":null,"invoice_id":"10047","number":null,"pr_number":null,"po_number":null,"date":"2014-06-16 12:47:21","due_date":"2014-07-16 12:47:21","received_date":null,"contact_person":null,"contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Shafiq Rizwan\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"zipcode\\":\\"14000\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"No remarks","status":"Backordered","payment_gateway":"Manual Payment","payment_method":"Manual","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":"Self Pickup","shipping_id":"6","handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"27.00","total_delivered":null,"cost":"2.00","tags":"Online Sales","added_on":"2014-06-16 12:47:21","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":null,"orders":[{"id":"22","sales_order_id":"10024","type":"product","date":"2014-06-16 12:47:21","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":null,"item_sku":"2001","discount":null,"discount_type":null,"qty":"3","price_per_unit":"9.0000","price":"27.00","cost":"6.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-1","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-16 12:38:47","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2014-06-16 12:50:10","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2014-06-16 12:51:19', 'admin'),
(706, 'sales', 'status_update', 'so', 10024, '{"id":"10024","txn_no":"1-10016","quote_id":null,"invoice_id":"10047","number":null,"pr_number":null,"po_number":null,"date":"2014-06-16 12:47:21","due_date":"2014-07-16 12:47:21","received_date":null,"contact_person":null,"contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Shafiq Rizwan\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"zipcode\\":\\"14000\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"No remarks","status":"Pending","payment_gateway":"Manual Payment","payment_method":"Manual","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":"Self Pickup","shipping_id":"6","handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"27.00","total_delivered":null,"cost":"2.00","tags":"Online Sales","added_on":"2014-06-16 12:47:21","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":null,"orders":[{"id":"22","sales_order_id":"10024","type":"product","date":"2014-06-16 12:47:21","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":null,"item_sku":"2001","discount":null,"discount_type":null,"qty":"3","price_per_unit":"9.0000","price":"27.00","cost":"6.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-1","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-16 12:38:47","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2014-06-16 12:50:10","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2014-06-16 14:56:50', 'admin'),
(707, 'sales', 'delete', 'so', 10024, '{"id":"10024","txn_no":"1-10016","quote_id":null,"invoice_id":"10047","number":null,"pr_number":null,"po_number":null,"date":"2014-06-16 12:47:21","due_date":"2014-07-16 12:47:21","received_date":null,"contact_person":null,"contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Shafiq Rizwan\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"zipcode\\":\\"14000\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"No remarks","status":"Pending","payment_gateway":"Manual Payment","payment_method":"Manual","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":"Self Pickup","shipping_id":"6","handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"27.00","total_delivered":null,"cost":"2.00","tags":"Online Sales","added_on":"2014-06-16 12:47:21","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":null,"orders":[{"id":"22","sales_order_id":"10024","type":"product","date":"2014-06-16 12:47:21","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":null,"item_sku":"2001","discount":null,"discount_type":null,"qty":"3","price_per_unit":"9.0000","price":"27.00","cost":"6.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-1","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-16 12:38:47","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2014-06-16 12:50:10","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2014-06-16 14:56:56', 'admin'),
(708, 'sales', 'status_update', 'so', 10027, '{"id":"10027","txn_no":"1-10016","quote_id":null,"invoice_id":null,"number":null,"pr_number":null,"po_number":null,"date":"2014-06-16 14:57:01","due_date":"2014-07-16 14:57:01","received_date":null,"contact_person":null,"contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Shafiq Rizwan\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"zipcode\\":\\"14000\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"No remarks","status":"Completed","payment_gateway":"Manual Payment","payment_method":"Manual","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":"Self Pickup","shipping_id":"6","handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"27.00","total_delivered":null,"cost":"2.00","tags":"Online Sales","added_on":"2014-06-16 14:57:01","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":null,"orders":[{"id":"23","sales_order_id":"10027","type":"product","date":"2014-06-16 14:57:01","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":null,"item_sku":"2001","discount":null,"discount_type":null,"qty":"3","price_per_unit":"9.0000","price":"27.00","cost":"6.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-1","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-16 12:38:47","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2014-06-16 12:50:10","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2014-06-16 14:57:50', 'admin'),
(709, 'sales', 'status_update', 'so', 10027, '{"id":"10027","txn_no":"1-10016","quote_id":null,"invoice_id":null,"number":null,"pr_number":null,"po_number":null,"date":"2014-06-16 14:57:01","due_date":"2014-07-16 14:57:01","received_date":null,"contact_person":null,"contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Shafiq Rizwan\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"zipcode\\":\\"14000\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"No remarks","status":"Backordered","payment_gateway":"Manual Payment","payment_method":"Manual","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":"Self Pickup","shipping_id":"6","handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"27.00","total_delivered":null,"cost":"2.00","tags":"Online Sales","added_on":"2014-06-16 14:57:01","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":"[{\\"type\\":\\"New Order\\",\\"datetime\\":\\"2014-06-16 20:52:08\\",\\"by\\":\\"admin\\",\\"status\\":null,\\"ref\\":null}]","consignment":null,"orders":[{"id":"23","sales_order_id":"10027","type":"product","date":"2014-06-16 14:57:01","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":null,"item_sku":"2001","discount":null,"discount_type":null,"qty":"3","price_per_unit":"9.0000","price":"27.00","cost":"6.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-1","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-16 12:38:47","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2014-06-16 12:50:10","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2014-06-16 20:53:21', 'admin'),
(710, 'sales', 'status_update', 'so', 10030, '{"id":"10030","txn_no":"1-10017","quote_id":null,"invoice_id":null,"number":null,"pr_number":null,"po_number":null,"date":"2014-06-16 21:28:22","due_date":"2014-07-16 21:28:22","received_date":null,"contact_person":null,"contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Shafiq Rizwan\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"zipcode\\":\\"14000\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"No remarks","status":"Backordered","payment_gateway":"Manual Payment","payment_method":"Manual","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":"Self Pickup","shipping_id":"6","handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"107.00","total_delivered":null,"cost":"2.00","tags":"Online Sales","added_on":"2014-06-16 21:28:22","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":null,"orders":[{"id":"25","sales_order_id":"10030","type":"product","date":"2014-06-16 21:28:22","item_name":"1 Hour Plex Training Rent","item_description":"","item_id":"3","service_id":null,"item_sku":"000101","discount":null,"discount_type":null,"qty":"2","price_per_unit":"40.0000","price":"80.00","cost":"0.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null},{"id":"24","sales_order_id":"10030","type":"product","date":"2014-06-16 21:28:22","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":null,"item_sku":"2001","discount":null,"discount_type":null,"qty":"3","price_per_unit":"9.0000","price":"27.00","cost":"6.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-1","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-16 12:38:47","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2014-06-16 12:50:10","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"3":{"id":"3","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"1 Hour Plex Training Rent","model_no":"","warranty":"","sku":"000101","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"10","max_quantity":"0","cost":"0.00","average_cost":null,"price":"40.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-04-05 21:17:03","added_by":"azad","modified_on":"2014-06-16 13:41:43","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2014-06-16 21:29:04', 'admin'),
(711, 'sales', 'status_update', 'so', 10030, '{"id":"10030","txn_no":"1-10017","quote_id":null,"invoice_id":null,"number":null,"pr_number":null,"po_number":null,"date":"2014-06-16 21:28:22","due_date":"2014-07-16 21:28:22","received_date":null,"contact_person":null,"contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Shafiq Rizwan\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"zipcode\\":\\"14000\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"No remarks","status":"Completed","payment_gateway":"Manual Payment","payment_method":"Manual","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":"Self Pickup","shipping_id":"6","handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"107.00","total_delivered":null,"cost":"2.00","tags":"Online Sales","added_on":"2014-06-16 21:28:22","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":null,"orders":[{"id":"25","sales_order_id":"10030","type":"product","date":"2014-06-16 21:28:22","item_name":"1 Hour Plex Training Rent","item_description":"","item_id":"3","service_id":null,"item_sku":"000101","discount":null,"discount_type":null,"qty":"2","price_per_unit":"40.0000","price":"80.00","cost":"0.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null},{"id":"24","sales_order_id":"10030","type":"product","date":"2014-06-16 21:28:22","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":null,"item_sku":"2001","discount":null,"discount_type":null,"qty":"3","price_per_unit":"9.0000","price":"27.00","cost":"6.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-1","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-16 12:38:47","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2014-06-16 12:50:10","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"3":{"id":"3","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"1 Hour Plex Training Rent","model_no":"","warranty":"","sku":"000101","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"10","max_quantity":"0","cost":"0.00","average_cost":null,"price":"40.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-04-05 21:17:03","added_by":"azad","modified_on":"2014-06-16 13:41:43","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2014-06-16 21:29:15', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(712, 'sales', 'status_update', 'so', 10030, '{"id":"10030","txn_no":"1-10017","quote_id":null,"invoice_id":null,"number":null,"pr_number":null,"po_number":null,"date":"2014-06-16 21:28:22","due_date":"2014-07-16 21:28:22","received_date":null,"contact_person":null,"contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Shafiq Rizwan\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"zipcode\\":\\"14000\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"No remarks","status":"Backordered","payment_gateway":"Manual Payment","payment_method":"Manual","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":"Self Pickup","shipping_id":"6","handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"107.00","total_delivered":null,"cost":"2.00","tags":"Online Sales","added_on":"2014-06-16 21:28:22","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":null,"orders":[{"id":"25","sales_order_id":"10030","type":"product","date":"2014-06-16 21:28:22","item_name":"1 Hour Plex Training Rent","item_description":"","item_id":"3","service_id":null,"item_sku":"000101","discount":null,"discount_type":null,"qty":"2","price_per_unit":"40.0000","price":"80.00","cost":"0.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null},{"id":"24","sales_order_id":"10030","type":"product","date":"2014-06-16 21:28:22","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":null,"item_sku":"2001","discount":null,"discount_type":null,"qty":"3","price_per_unit":"9.0000","price":"27.00","cost":"6.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-1","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-16 12:38:47","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2014-06-16 12:50:10","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"3":{"id":"3","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"1 Hour Plex Training Rent","model_no":"","warranty":"","sku":"000101","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"10","max_quantity":"0","cost":"0.00","average_cost":null,"price":"40.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-04-05 21:17:03","added_by":"azad","modified_on":"2014-06-16 13:41:43","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2014-06-16 21:29:22', 'admin'),
(713, 'sales', 'status_update', 'so', 10030, '{"id":"10030","txn_no":"1-10017","quote_id":null,"invoice_id":null,"number":null,"pr_number":null,"po_number":null,"date":"2014-06-16 21:28:22","due_date":"2014-07-16 21:28:22","received_date":null,"contact_person":null,"contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Shafiq Rizwan\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"zipcode\\":\\"14000\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"No remarks","status":"Completed","payment_gateway":"Manual Payment","payment_method":"Manual","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":"Self Pickup","shipping_id":"6","handling_charges":"0.00","adjustment":"0.00","adjustment_type":"0","total":"107.00","total_delivered":null,"cost":"2.00","tags":"Online Sales","added_on":"2014-06-16 21:28:22","added_by":"@Plexcart","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":"[{\\"type\\":\\"New Order\\",\\"datetime\\":\\"2014-06-16 21:29:27\\",\\"by\\":\\"admin\\",\\"status\\":\\"Backordered\\"}]","consignment":null,"orders":[{"id":"25","sales_order_id":"10030","type":"product","date":"2014-06-16 21:28:22","item_name":"1 Hour Plex Training Rent","item_description":"","item_id":"3","service_id":null,"item_sku":"000101","discount":null,"discount_type":null,"qty":"2","price_per_unit":"40.0000","price":"80.00","cost":"0.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null},{"id":"24","sales_order_id":"10030","type":"product","date":"2014-06-16 21:28:22","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":null,"item_sku":"2001","discount":null,"discount_type":null,"qty":"3","price_per_unit":"9.0000","price":"27.00","cost":"6.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-1","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-16 12:38:47","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":"2014-06-16 12:50:10","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"},"3":{"id":"3","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"1 Hour Plex Training Rent","model_no":"","warranty":"","sku":"000101","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"10","max_quantity":"0","cost":"0.00","average_cost":null,"price":"40.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-04-05 21:17:03","added_by":"azad","modified_on":"2014-06-16 13:41:43","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"1","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2014-06-16 21:30:06', 'admin'),
(714, 'sales', 'add', 'so', 10031, '{"id":"10031","txn_no":"1-10018","quote_id":"0","invoice_id":null,"number":"0","pr_number":null,"po_number":"0","date":"2014-06-17 00:00:00","due_date":"2014-06-17 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"90.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-06-17 15:45:24","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"26","sales_order_id":"10031","type":"product","date":"2014-06-17 00:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"9.0000","price":"90.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"2":{"id":"2","primary_image":"liquid.jpg","image":"liquid.jpg","category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-17","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"10.00","price_3":"11.00","price_4":"12.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-17 15:41:18","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"5","max_cart_qty":"100","ready_for_sale":"1","last_sold":"2014-06-17 15:29:09","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2014-06-17 15:45:24', 'admin'),
(715, 'sales', 'add', 'invoice', 10048, '{"id":"10048","txn_no":"1-10046","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-06-17 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"63.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-06-17 15:46:11","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"104","invoice_id":"10048","type":"product","date":"2014-06-17 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"7","price_per_unit":"9.0000","price":"63.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"2":{"id":"2","primary_image":"liquid.jpg","image":"liquid.jpg","category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-17","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"10.00","price_3":"11.00","price_4":"12.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-17 15:41:18","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"5","max_cart_qty":"100","ready_for_sale":"1","last_sold":"2014-06-17 15:29:09","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1015","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"1","is_franchise":"0","is_franchisee":null,"company_name":"Plexsol HQ","company_registration":"","contact_person":"Shafiq Rizwan","contact_number":"0124205391","credit_limit":"0.00","rank":"Normal Member","email":"shafiq@plexsol.com","ic":"880102355071","password":"88aa5e3aad2dbc037bcae4f0a9d5210c","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"0124205391","fax":"","general_email":"0","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 11:26:32","added_by":"@Plexcart","modified_on":"2013-04-01 14:15:33","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shafiq@plexsol.com1402925289","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-06-17 15:46:11', 'admin'),
(716, 'sales', 'add', 'invoice', 10049, '{"id":"10049","txn_no":"1-10047","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-07-17 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"36.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-06-17 15:46:44","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"105","invoice_id":"10049","type":"product","date":"2014-07-17 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"4","price_per_unit":"9.0000","price":"36.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"2":{"id":"2","primary_image":"liquid.jpg","image":"liquid.jpg","category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-17","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"10.00","price_3":"11.00","price_4":"12.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-17 15:41:18","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"5","max_cart_qty":"100","ready_for_sale":"1","last_sold":"2014-06-17 15:29:09","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1015","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"1","is_franchise":"0","is_franchisee":null,"company_name":"Plexsol HQ","company_registration":"","contact_person":"Shafiq Rizwan","contact_number":"0124205391","credit_limit":"0.00","rank":"Normal Member","email":"shafiq@plexsol.com","ic":"880102355071","password":"88aa5e3aad2dbc037bcae4f0a9d5210c","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"0124205391","fax":"","general_email":"0","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 11:26:32","added_by":"@Plexcart","modified_on":"2013-04-01 14:15:33","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shafiq@plexsol.com1402925289","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-06-17 15:46:44', 'admin'),
(717, 'sales', 'status_update', 'so', 10034, '{"id":"10034","txn_no":"1-10019","quote_id":null,"invoice_id":null,"number":"0","pr_number":null,"po_number":"0","date":"2014-06-17 00:00:00","due_date":"2014-07-17 00:00:00","received_date":null,"contact_person":"","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Shafiq Rizwan\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"No remarks","status":"Completed","payment_gateway":"Manual Payment","payment_method":"Manual","payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":"Self Pickup","shipping_id":"6","handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"90.00","total_delivered":null,"cost":"2.00","tags":"Online Sales","added_on":"2014-06-17 16:25:13","added_by":"@Plexcart","modified_on":"2014-06-17 16:26:40","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"27","sales_order_id":"10034","type":"product","date":"2014-06-17 16:25:13","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":null,"item_sku":"2001","discount":null,"discount_type":null,"qty":"5","price_per_unit":"9.0000","price":"45.00","cost":"10.00","margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":{"2":{"id":"2","primary_image":"liquid.jpg","image":"liquid.jpg","category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-17","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"10.00","price_3":"11.00","price_4":"12.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-17 15:41:18","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"5","max_cart_qty":"100","ready_for_sale":"1","last_sold":"2014-06-17 15:29:09","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2014-06-17 16:26:56', 'admin'),
(718, 'sales', 'add', 'invoice', 10050, '{"id":"10050","txn_no":"1-10048","quote_id":"0","sales_order_id":"10034","number":"0","po_number":"N\\/A","date":"2014-06-17 12:00:00","due_date":null,"received_date":null,"contact_person":"","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Shafiq Rizwan\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"6","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"45.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-06-17 16:27:29","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"106","invoice_id":"10050","type":"product","date":"2014-06-17 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"","discount_type":null,"qty":"5","price_per_unit":"9.0000","price":"45.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"2":{"id":"2","primary_image":"liquid.jpg","image":"liquid.jpg","category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-17","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"10.00","price_3":"11.00","price_4":"12.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-17 15:41:18","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"5","max_cart_qty":"100","ready_for_sale":"1","last_sold":"2014-06-17 15:29:09","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1015","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"1","is_franchise":"0","is_franchisee":null,"company_name":"Plexsol HQ","company_registration":"","contact_person":"Shafiq Rizwan","contact_number":"0124205391","credit_limit":"0.00","rank":"Normal Member","email":"shafiq@plexsol.com","ic":"880102355071","password":"88aa5e3aad2dbc037bcae4f0a9d5210c","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"0124205391","fax":"","general_email":"0","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 11:26:32","added_by":"@Plexcart","modified_on":"2013-04-01 14:15:33","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shafiq@plexsol.com1402993405","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-06-17 16:27:29', 'admin'),
(719, 'sales', 'add', 'invoice', 10051, '{"id":"10051","txn_no":"1-10049","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-06-23 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-06-23 10:43:32","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"107","invoice_id":"10051","type":"service","date":"2014-06-23 12:00:00","item_name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","item_description":"","item_id":"0","service_id":"52","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"52":{"id":"52","name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","description":"","category":"0","subcategory":"0","cost":"2000.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-01-26 01:47:56","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-06-23 10:43:32', 'admin'),
(720, 'sales', 'add', 'invoice', 10052, '{"id":"10052","txn_no":"1-10050","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-06-23 12:00:00","due_date":null,"received_date":null,"contact_person":"","contact":"Uniform Gallery","contact_id":"1154","contact_address":"{\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Uniform Gallery\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3600.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-06-23 10:45:10","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"108","invoice_id":"10052","type":"service","date":"2014-06-23 12:00:00","item_name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","item_description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","item_id":"0","service_id":"58","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"3600.0000","price":"3600.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"58":{"id":"58","name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","category":"0","subcategory":"0","cost":"0.00","price":"3600.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-03-21 09:01:39","added_by":"shafiq","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1154","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Uniform Gallery","company_registration":"","contact_person":"Uniform Gallery","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No 42, 43 & 43A, Blok E","address2":"Seri Bangi, Jln 8\\/35, Seksyen 8","city":"Bandar Baru Bangi","state":"Selangor","zipcode":"43650","country":"Malaysia","tel":"","fax":"","general_email":"lguniformgallery@yahoo.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-21 08:58:49","added_by":"shafiq","modified_on":"2014-03-21 09:21:34","modified_by":"shafiq","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-06-23 10:45:10', 'admin'),
(721, 'sales', 'edit', 'invoice', 10051, '{"id":"10051","txn_no":"1-10049","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-06-23 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-06-23 10:43:32","added_by":"admin","modified_on":"2014-06-23 10:45:21","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"109","invoice_id":"10051","type":"service","date":"2014-06-23 12:00:00","item_name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","item_description":"","item_id":"0","service_id":"52","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"52":{"id":"52","name":"Plexcloud + PlexCMS + Franchise Warehouse Monthly Subscription","description":"","category":"0","subcategory":"0","cost":"2000.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-01-26 01:47:56","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-06-23 10:45:21', 'admin'),
(722, 'contacts', 'add', 'contact', 1164, '{"id":"1164","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"MyTone","company_registration":"","contact_person":"MyTone","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-07-03 12:44:37","added_by":"shamiradnan","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-07-03 12:44:38', 'shamiradnan'),
(723, 'sales', 'add', 'invoice', 10053, '{"id":"10053","txn_no":"1-10051","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-07-03 12:00:00","due_date":null,"received_date":null,"contact_person":"Shamir Adnan","contact":"MyTone","contact_id":"1164","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"MyTone\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"150.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-07-03 12:51:13","added_by":"shamiradnan","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"110","invoice_id":"10053","type":"service","date":"2014-07-03 12:00:00","item_name":"Domain & Hosting","item_description":"Domain & Hosting for 1year","item_id":"0","service_id":"61","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"150.0000","price":"150.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"61":{"id":"61","name":"Domain & Hosting","description":"","category":"0","subcategory":"0","cost":"50.00","price":"150.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-07-03 12:47:05","added_by":"shamiradnan","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1164","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"MyTone","company_registration":"","contact_person":"MyTone","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-07-03 12:44:37","added_by":"shamiradnan","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-07-03 12:51:13', 'shamiradnan'),
(724, 'sales', 'edit', 'quote', 10033, '{"id":"10033","txn_no":"1-10028","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-05-16 00:00:00","due_date":"2014-05-25 00:00:00","contact_person":" ","payment_date":null,"received_date":null,"contact":"Redzuan","contact_id":"1163","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Redzuan\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"100.00","adjustment":"0.00","adjustment_type":"Add","total":"1450.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-05-16 09:53:55","added_by":"shafiq","modified_on":"2014-07-10 09:46:56","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"145","quote_id":"10033","date":"2014-05-16 00:00:00","type":"service","item_id":"0","service_id":"7","item_name":"Android App Application Development","item_description":"- Content App with Google Ads","discount":"10","discount_type":"p","qty":"1","price_per_unit":"1500.0000","price":"1500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"7":{"id":"7","name":"iOS App Application Development","description":"","category":"0","subcategory":"0","cost":"0.00","price":"1500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-04-18 07:03:14","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}}}', '2014-07-10 09:46:56', 'admin'),
(725, 'contacts', 'add', 'contact', 1165, '{"id":"1165","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Azham Affif","contact_number":"0105117721","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Kedah","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"am7721@gmail.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-07-22 14:20:19","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-07-22 14:20:19', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(726, 'sales', 'add', 'invoice', 10054, '{"id":"10054","txn_no":"1-10052","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-07-22 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Azham Affif","contact_id":"1165","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Azham Affif\\",\\"mobile\\":\\"0105117721\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"130.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-07-22 14:21:29","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"111","invoice_id":"10054","type":"service","date":"2014-07-22 12:00:00","item_name":"Domain","item_description":"313.my\\nNext renewal will be on 22\\/07\\/2015","item_id":"0","service_id":"61","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"130.0000","price":"130.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"61":{"id":"61","name":"Domain & Hosting","description":"","category":"0","subcategory":"0","cost":"50.00","price":"150.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-07-03 12:47:05","added_by":"shamiradnan","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1165","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Azham Affif","contact_number":"0105117721","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Kedah","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"am7721@gmail.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-07-22 14:20:19","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-07-22 14:21:29', 'admin'),
(727, 'sales', 'add', 'invoice', 10055, '{"id":"10055","txn_no":"1-10053","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-07-26 12:00:00","due_date":"2014-08-25 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Restoran Nasi Kandar Subaidah (M) Sdn.Bhd  (CF)","contact_id":"1121","contact_address":"{\\"address1\\":\\"5018,Jalan chain Ferry ,\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Restoran Nasi Kandar Subaidah (M) Sdn.Bhd  (CF)\\",\\"mobile\\":\\"012-207-2656\\",\\"address1\\":\\"5018,Jalan chain Ferry ,\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"30","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"360.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-08-01 09:26:30","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"112","invoice_id":"10055","type":"product","date":"2014-07-26 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"30","price_per_unit":"12.0000","price":"360.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"2":{"id":"2","primary_image":"liquid.jpg","image":"liquid.jpg","category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-17","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"10.00","price_3":"11.00","price_4":"12.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-17 15:41:18","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"5","max_cart_qty":"100","ready_for_sale":"1","last_sold":"2014-06-17 15:29:09","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1121","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Restoran Nasi Kandar Subaidah (M) Sdn.Bhd  (CF)","company_registration":"527629-A","contact_person":"Hakim","contact_number":"012-413-2656","credit_limit":"0.00","rank":"0","email":"subaidahoffice@gmail.com","ic":"","password":"6e7eced602e8be0425dd26867dbab90b","introducer_ic":null,"address1":"5018,Jalan chain Ferry ,","address2":"","city":"Butterworth","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"012-207-2656","fax":"04-3324090","general_email":"subaidah080@gmail.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-01-28 09:10:01","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-08-01 09:26:30', 'admin'),
(728, 'sales', 'deliver', 'invoice', 10055, '{"id":"10055","txn_no":"1-10053","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-07-26 12:00:00","due_date":"2014-08-25 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Restoran Nasi Kandar Subaidah (M) Sdn.Bhd  (CF)","contact_id":"1121","contact_address":"{\\"address1\\":\\"5018,Jalan chain Ferry ,\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Restoran Nasi Kandar Subaidah (M) Sdn.Bhd  (CF)\\",\\"mobile\\":\\"012-207-2656\\",\\"address1\\":\\"5018,Jalan chain Ferry ,\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"30","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"360.00","total_delivered":"360.00","cost":null,"tags":"","added_on":"2014-08-01 09:26:30","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"112","invoice_id":"10055","type":"product","date":"2014-07-26 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"30","price_per_unit":"12.0000","price":"360.00","cost":null,"margin":null,"delivered":"0","delivered_price":"360.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"2":{"id":"2","primary_image":"liquid.jpg","image":"liquid.jpg","category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-17","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"10.00","price_3":"11.00","price_4":"12.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-17 15:41:18","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"5","max_cart_qty":"100","ready_for_sale":"1","last_sold":"2014-08-01 09:26:45","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1121","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Restoran Nasi Kandar Subaidah (M) Sdn.Bhd  (CF)","company_registration":"527629-A","contact_person":"Hakim","contact_number":"012-413-2656","credit_limit":"0.00","rank":"0","email":"subaidahoffice@gmail.com","ic":"","password":"6e7eced602e8be0425dd26867dbab90b","introducer_ic":null,"address1":"5018,Jalan chain Ferry ,","address2":"","city":"Butterworth","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"012-207-2656","fax":"04-3324090","general_email":"subaidah080@gmail.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-01-28 09:10:01","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-08-01 09:26:45', 'admin'),
(729, 'sales', 'status_update', 'invoice', 10055, '{"id":"10055","txn_no":"1-10053","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-07-26 12:00:00","due_date":"2014-08-25 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Restoran Nasi Kandar Subaidah (M) Sdn.Bhd  (CF)","contact_id":"1121","contact_address":"{\\"address1\\":\\"5018,Jalan chain Ferry ,\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Restoran Nasi Kandar Subaidah (M) Sdn.Bhd  (CF)\\",\\"mobile\\":\\"012-207-2656\\",\\"address1\\":\\"5018,Jalan chain Ferry ,\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"30","remarks":"","status":"Partially Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"360.00","total_delivered":"360.00","cost":null,"tags":"","added_on":"2014-08-01 09:26:30","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"112","invoice_id":"10055","type":"product","date":"2014-07-26 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"30","price_per_unit":"12.0000","price":"360.00","cost":null,"margin":null,"delivered":"0","delivered_price":"360.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"2":{"id":"2","primary_image":"liquid.jpg","image":"liquid.jpg","category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-17","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"10.00","price_3":"11.00","price_4":"12.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-17 15:41:18","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"5","max_cart_qty":"100","ready_for_sale":"1","last_sold":"2014-08-01 09:26:45","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1121","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Restoran Nasi Kandar Subaidah (M) Sdn.Bhd  (CF)","company_registration":"527629-A","contact_person":"Hakim","contact_number":"012-413-2656","credit_limit":"0.00","rank":"0","email":"subaidahoffice@gmail.com","ic":"","password":"6e7eced602e8be0425dd26867dbab90b","introducer_ic":null,"address1":"5018,Jalan chain Ferry ,","address2":"","city":"Butterworth","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"012-207-2656","fax":"04-3324090","general_email":"subaidah080@gmail.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-01-28 09:10:01","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-08-01 09:26:48', 'admin'),
(730, 'sales', 'deliver', 'invoice', 10055, '{"id":"10055","txn_no":"1-10053","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-07-26 12:00:00","due_date":"2014-08-25 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Restoran Nasi Kandar Subaidah (M) Sdn.Bhd  (CF)","contact_id":"1121","contact_address":"{\\"address1\\":\\"5018,Jalan chain Ferry ,\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Restoran Nasi Kandar Subaidah (M) Sdn.Bhd  (CF)\\",\\"mobile\\":\\"012-207-2656\\",\\"address1\\":\\"5018,Jalan chain Ferry ,\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"30","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"360.00","total_delivered":"360.00","cost":null,"tags":"","added_on":"2014-08-01 09:26:30","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"112","invoice_id":"10055","type":"product","date":"2014-07-26 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"30","price_per_unit":"12.0000","price":"360.00","cost":null,"margin":null,"delivered":"30","delivered_price":"360.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"2":{"id":"2","primary_image":"liquid.jpg","image":"liquid.jpg","category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-47","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"10.00","price_3":"11.00","price_4":"12.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-17 15:41:18","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"5","max_cart_qty":"100","ready_for_sale":"1","last_sold":"2014-08-01 09:26:53","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1121","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Restoran Nasi Kandar Subaidah (M) Sdn.Bhd  (CF)","company_registration":"527629-A","contact_person":"Hakim","contact_number":"012-413-2656","credit_limit":"0.00","rank":"0","email":"subaidahoffice@gmail.com","ic":"","password":"6e7eced602e8be0425dd26867dbab90b","introducer_ic":null,"address1":"5018,Jalan chain Ferry ,","address2":"","city":"Butterworth","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"012-207-2656","fax":"04-3324090","general_email":"subaidah080@gmail.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-01-28 09:10:01","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-08-01 09:26:53', 'admin'),
(731, 'sales', 'status_update', 'invoice', 10055, '{"id":"10055","txn_no":"1-10053","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-07-26 12:00:00","due_date":"2014-08-25 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Restoran Nasi Kandar Subaidah (M) Sdn.Bhd  (CF)","contact_id":"1121","contact_address":"{\\"address1\\":\\"5018,Jalan chain Ferry ,\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Restoran Nasi Kandar Subaidah (M) Sdn.Bhd  (CF)\\",\\"mobile\\":\\"012-207-2656\\",\\"address1\\":\\"5018,Jalan chain Ferry ,\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"30","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"360.00","total_delivered":"360.00","cost":null,"tags":"","added_on":"2014-08-01 09:26:30","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"112","invoice_id":"10055","type":"product","date":"2014-07-26 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"30","price_per_unit":"12.0000","price":"360.00","cost":null,"margin":null,"delivered":"30","delivered_price":"360.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"2":{"id":"2","primary_image":"liquid.jpg","image":"liquid.jpg","category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-47","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"10.00","price_3":"11.00","price_4":"12.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-17 15:41:18","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"5","max_cart_qty":"100","ready_for_sale":"1","last_sold":"2014-08-01 09:26:53","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1121","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Restoran Nasi Kandar Subaidah (M) Sdn.Bhd  (CF)","company_registration":"527629-A","contact_person":"Hakim","contact_number":"012-413-2656","credit_limit":"0.00","rank":"0","email":"subaidahoffice@gmail.com","ic":"","password":"6e7eced602e8be0425dd26867dbab90b","introducer_ic":null,"address1":"5018,Jalan chain Ferry ,","address2":"","city":"Butterworth","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"012-207-2656","fax":"04-3324090","general_email":"subaidah080@gmail.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-01-28 09:10:01","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-08-01 09:26:55', 'admin'),
(732, 'contacts', 'add', 'contact', 1166, '{"id":"1166","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Azmi","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"Public Mutual","tags":"","added_on":"2014-08-01 09:29:59","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-08-01 09:29:59', 'admin'),
(733, 'sales', 'add', 'quote', 10034, '{"id":"10034","txn_no":"1-10029","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-08-01 00:00:00","due_date":"2014-08-08 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Azmi","contact_id":"1166","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Azmi\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"999.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-08-01 09:31:55","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"146","quote_id":"10034","date":"2014-08-01 00:00:00","type":"service","item_id":"0","service_id":"9","item_name":"Web Design","item_description":"- Developed on Wordpress\\n- 1 logo\\n- 1 banner\\n- Free 1 year domain + hosting","discount":"0","discount_type":null,"qty":"1","price_per_unit":"999.0000","price":"999.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"9":{"id":"9","name":"Web Design & Development","description":"","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-05-31 13:45:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}}}', '2014-08-01 09:31:55', 'admin'),
(734, 'sales', 'add', 'invoice', 10056, '{"id":"10056","txn_no":"1-10054","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-07-20 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-08-02 10:44:20","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"113","invoice_id":"10056","type":"service","date":"2014-07-20 12:00:00","item_name":"Halagel Warehouse Management System","item_description":"Halagel Subscription Fee to PlexCloud and PlexCMS","item_id":"0","service_id":"12","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"12":{"id":"12","name":"Halagel Warehouse Management System","description":"Halagel Subscription Fee to PlexCloud and PlexCMS","category":"0","subcategory":"0","cost":"2500.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-09-30 16:31:50","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-08-02 10:44:20', 'admin'),
(735, 'sales', 'add', 'invoice', 10057, '{"id":"10057","txn_no":"1-10055","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-07-20 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Uniform Gallery","contact_id":"1154","contact_address":"{\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Uniform Gallery\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3600.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-08-02 10:45:24","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"114","invoice_id":"10057","type":"service","date":"2014-07-20 12:00:00","item_name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","item_description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","item_id":"0","service_id":"58","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"3600.0000","price":"3600.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"58":{"id":"58","name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","category":"0","subcategory":"0","cost":"0.00","price":"3600.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-03-21 09:01:39","added_by":"shafiq","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1154","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Uniform Gallery","company_registration":"","contact_person":"Uniform Gallery","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No 42, 43 & 43A, Blok E","address2":"Seri Bangi, Jln 8\\/35, Seksyen 8","city":"Bandar Baru Bangi","state":"Selangor","zipcode":"43650","country":"Malaysia","tel":"","fax":"","general_email":"lguniformgallery@yahoo.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-21 08:58:49","added_by":"shafiq","modified_on":"2014-03-21 09:21:34","modified_by":"shafiq","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-08-02 10:45:24', 'admin'),
(736, 'contacts', 'add', 'contact', 1167, '{"id":"1167","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Growth Lightning Solutions","company_registration":"","contact_person":"Nicholas Teng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"37-16-3, Victoria Heights","address2":"Hilir Paya Terubong 2","city":"Bayan Lepas","state":"Pulau Pinang","zipcode":"11900","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-08-06 14:26:36","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-08-06 14:26:36', 'admin'),
(737, 'sales', 'add', 'invoice', 10058, '{"id":"10058","txn_no":"1-10056","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-08-06 12:00:00","due_date":null,"received_date":null,"contact_person":"Nicholas Teng ","contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Growth Lightning Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1250.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-08-06 14:28:17","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"115","invoice_id":"10058","type":"service","date":"2014-08-06 12:00:00","item_name":"Journey Malaysia Site Revamp","item_description":"50% PROJECT INITIATION FEE","item_id":"0","service_id":"9","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1250.0000","price":"1250.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"9":{"id":"9","name":"Web Design & Development","description":"","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-05-31 13:45:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}},"customer":{"id":"1167","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Growth Lightning Solutions","company_registration":"","contact_person":"Nicholas Teng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"37-16-3, Victoria Heights","address2":"Hilir Paya Terubong 2","city":"Bayan Lepas","state":"Pulau Pinang","zipcode":"11900","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-08-06 14:26:36","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-08-06 14:28:18', 'admin'),
(738, 'sales', 'edit', 'invoice', 10058, '{"id":"10058","txn_no":"1-10056","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-08-06 12:00:00","due_date":null,"received_date":null,"contact_person":"Azad","contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Growth Lightning Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1250.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-08-06 14:28:17","added_by":"admin","modified_on":"2014-08-06 14:28:44","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"116","invoice_id":"10058","type":"service","date":"2014-08-06 12:00:00","item_name":"Journey Malaysia Site Revamp","item_description":"50% PROJECT INITIATION FEE","item_id":"0","service_id":"9","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1250.0000","price":"1250.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"9":{"id":"9","name":"Web Design & Development","description":"","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-05-31 13:45:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}},"customer":{"id":"1167","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Growth Lightning Solutions","company_registration":"","contact_person":"Nicholas Teng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"37-16-3, Victoria Heights","address2":"Hilir Paya Terubong 2","city":"Bayan Lepas","state":"Pulau Pinang","zipcode":"11900","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-08-06 14:26:36","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-08-06 14:28:44', 'admin'),
(739, 'sales', 'deliver', 'invoice', 10058, '{"id":"10058","txn_no":"1-10056","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-08-06 12:00:00","due_date":null,"received_date":null,"contact_person":"Azad","contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Growth Lightning Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1250.00","total_delivered":"1250.00","cost":null,"tags":"","added_on":"2014-08-06 14:28:17","added_by":"admin","modified_on":"2014-08-06 14:28:44","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"116","invoice_id":"10058","type":"service","date":"2014-08-06 12:00:00","item_name":"Journey Malaysia Site Revamp","item_description":"50% PROJECT INITIATION FEE","item_id":"0","service_id":"9","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1250.0000","price":"1250.00","cost":null,"margin":null,"delivered":"1","delivered_price":"1250.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"9":{"id":"9","name":"Web Design & Development","description":"","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-05-31 13:45:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}},"customer":{"id":"1167","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Growth Lightning Solutions","company_registration":"","contact_person":"Nicholas Teng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"37-16-3, Victoria Heights","address2":"Hilir Paya Terubong 2","city":"Bayan Lepas","state":"Pulau Pinang","zipcode":"11900","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-08-06 14:26:36","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-08-06 14:28:57', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(740, 'sales', 'status_update', 'invoice', 10058, '{"id":"10058","txn_no":"1-10056","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-08-06 12:00:00","due_date":null,"received_date":null,"contact_person":"Azad","contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Growth Lightning Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Partially Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1250.00","total_delivered":"1250.00","cost":null,"tags":"","added_on":"2014-08-06 14:28:17","added_by":"admin","modified_on":"2014-08-06 14:28:44","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"116","invoice_id":"10058","type":"service","date":"2014-08-06 12:00:00","item_name":"Journey Malaysia Site Revamp","item_description":"50% PROJECT INITIATION FEE","item_id":"0","service_id":"9","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1250.0000","price":"1250.00","cost":null,"margin":null,"delivered":"1","delivered_price":"1250.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"9":{"id":"9","name":"Web Design & Development","description":"","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-05-31 13:45:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}},"customer":{"id":"1167","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Growth Lightning Solutions","company_registration":"","contact_person":"Nicholas Teng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"37-16-3, Victoria Heights","address2":"Hilir Paya Terubong 2","city":"Bayan Lepas","state":"Pulau Pinang","zipcode":"11900","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-08-06 14:26:36","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-08-06 14:29:00', 'admin'),
(741, 'sales', 'add', 'quote', 10035, '{"id":"10035","txn_no":"1-10030","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-08-06 00:00:00","due_date":"2014-08-06 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Azad Affif Ishak","contact_id":"1076","contact_address":"{\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Azad Affif Ishak\\",\\"mobile\\":\\"9191\\",\\"address1\\":\\"asda\\",\\"address2\\":\\"adas\\",\\"zipcode\\":\\"ada\\",\\"city\\":\\"ada\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-08-06 18:42:04","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"147","quote_id":"10035","date":"2014-08-06 00:00:00","type":"service","item_id":"0","service_id":"6","item_name":"Android App Application Development","item_description":"color : \\nvolume:\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"1000.0000","price":"1000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"6":{"id":"6","name":"Android App Application Development","description":"","category":"0","subcategory":"0","cost":"0.00","price":"1500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-04-18 07:03:04","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}}}', '2014-08-06 18:42:04', 'admin'),
(742, 'sales', 'edit', 'so', 10031, '{"id":"10031","txn_no":"1-10018","quote_id":"0","invoice_id":null,"number":"0","pr_number":null,"po_number":"0","date":"2014-06-17 00:00:00","due_date":"2014-06-17 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"8100.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-06-17 15:45:24","added_by":"admin","modified_on":"2014-08-06 18:51:27","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"28","sales_order_id":"10031","type":"product","date":"2014-06-17 00:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"10","discount_type":"p","qty":"1000","price_per_unit":"9.0000","price":"9000.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"2":{"id":"2","primary_image":"liquid.jpg","image":"liquid.jpg","category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-47","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"10.00","price_3":"11.00","price_4":"12.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-17 15:41:18","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"5","max_cart_qty":"100","ready_for_sale":"1","last_sold":"2014-08-01 09:26:53","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2014-08-06 18:51:27', 'admin'),
(743, 'sales', 'status_update', 'so', 10031, '{"id":"10031","txn_no":"1-10018","quote_id":"0","invoice_id":null,"number":"0","pr_number":null,"po_number":"0","date":"2014-06-17 00:00:00","due_date":"2014-06-17 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Consignment","duration":"0","remarks":"","status":"Completed","payment_gateway":null,"payment_method":null,"payment_status":"0","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"8100.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-06-17 15:45:24","added_by":"admin","modified_on":"2014-08-06 18:51:27","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"28","sales_order_id":"10031","type":"product","date":"2014-06-17 00:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"10","discount_type":"p","qty":"1000","price_per_unit":"9.0000","price":"9000.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"2":{"id":"2","primary_image":"liquid.jpg","image":"liquid.jpg","category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-47","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"10.00","price_3":"11.00","price_4":"12.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-17 15:41:18","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"5","max_cart_qty":"100","ready_for_sale":"1","last_sold":"2014-08-01 09:26:53","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null}', '2014-08-06 18:51:49', 'admin'),
(744, 'sales', 'add', 'invoice', 10059, '{"id":"10059","txn_no":"1-10057","quote_id":"0","sales_order_id":"10031","number":"0","po_number":"N\\/A","date":"2014-06-17 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"8100.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-08-06 18:52:23","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"117","invoice_id":"10059","type":"product","date":"2014-06-17 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"10","discount_type":"p","qty":"1000","price_per_unit":"9.0000","price":"9000.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"2":{"id":"2","primary_image":"liquid.jpg","image":"liquid.jpg","category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-47","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"10.00","price_3":"11.00","price_4":"12.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-17 15:41:18","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"5","max_cart_qty":"100","ready_for_sale":"1","last_sold":"2014-08-01 09:26:53","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1015","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"1","is_franchise":"0","is_franchisee":null,"company_name":"Plexsol HQ","company_registration":"","contact_person":"Shafiq Rizwan","contact_number":"0124205391","credit_limit":"0.00","rank":"Normal Member","email":"shafiq@plexsol.com","ic":"880102355071","password":"88aa5e3aad2dbc037bcae4f0a9d5210c","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"0124205391","fax":"","general_email":"0","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 11:26:32","added_by":"@Plexcart","modified_on":"2013-04-01 14:15:33","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shafiq@plexsol.com1402993405","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-08-06 18:52:23', 'admin'),
(745, 'sales', 'status_update', 'invoice', 10049, '{"id":"10049","txn_no":"1-10047","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-07-17 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Partially Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"36.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-06-17 15:46:44","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"105","invoice_id":"10049","type":"product","date":"2014-07-17 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"4","price_per_unit":"9.0000","price":"36.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"2":{"id":"2","primary_image":"liquid.jpg","image":"liquid.jpg","category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-47","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"10.00","price_3":"11.00","price_4":"12.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-17 15:41:18","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"5","max_cart_qty":"100","ready_for_sale":"1","last_sold":"2014-08-01 09:26:53","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1015","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"1","is_franchise":"0","is_franchisee":null,"company_name":"Plexsol HQ","company_registration":"","contact_person":"Shafiq Rizwan","contact_number":"0124205391","credit_limit":"0.00","rank":"Normal Member","email":"shafiq@plexsol.com","ic":"880102355071","password":"88aa5e3aad2dbc037bcae4f0a9d5210c","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"0124205391","fax":"","general_email":"0","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 11:26:32","added_by":"@Plexcart","modified_on":"2013-04-01 14:15:33","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shafiq@plexsol.com1402993405","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-08-06 18:54:21', 'admin'),
(746, 'sales', 'status_update', 'invoice', 10049, '{"id":"10049","txn_no":"1-10047","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-07-17 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"36.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-06-17 15:46:44","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"105","invoice_id":"10049","type":"product","date":"2014-07-17 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"4","price_per_unit":"9.0000","price":"36.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"2":{"id":"2","primary_image":"liquid.jpg","image":"liquid.jpg","category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-47","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"10.00","price_3":"11.00","price_4":"12.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-17 15:41:18","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"5","max_cart_qty":"100","ready_for_sale":"1","last_sold":"2014-08-01 09:26:53","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1015","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"1","is_franchise":"0","is_franchisee":null,"company_name":"Plexsol HQ","company_registration":"","contact_person":"Shafiq Rizwan","contact_number":"0124205391","credit_limit":"0.00","rank":"Normal Member","email":"shafiq@plexsol.com","ic":"880102355071","password":"88aa5e3aad2dbc037bcae4f0a9d5210c","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"0124205391","fax":"","general_email":"0","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 11:26:32","added_by":"@Plexcart","modified_on":"2013-04-01 14:15:33","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shafiq@plexsol.com1402993405","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-08-06 18:54:30', 'admin'),
(747, 'sales', 'delivery_info_update', 'do', 10049, '{"id":"10049","txn_no":"1-10047","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-07-17 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Plexsol HQ","contact_id":"1015","contact_address":"{\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plexsol HQ\\",\\"mobile\\":\\"0124205391\\",\\"address1\\":\\"41, Lorong Indah\\",\\"address2\\":\\"Taman\\",\\"zipcode\\":\\"14000\\",\\"city\\":\\"Bukit Mertajam\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":"KTM123","delivery_status":"Pending","delivery_date":"2014-08-06 00:00:00","shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"36.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-06-17 15:46:44","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"105","invoice_id":"10049","type":"product","date":"2014-07-17 12:00:00","item_name":"Dishwash 1000ml","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"4","price_per_unit":"9.0000","price":"36.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":{"2":{"id":"2","primary_image":"liquid.jpg","image":"liquid.jpg","category":"0","subcategory":"0","brand":"0","location":"","name":"Dishwash 1000ml","model_no":"","warranty":"","sku":"2001","sku2":"","sku3":"","sku4":"","qty":"-47","alert_quantity":"10","max_quantity":"0","cost":"2.00","average_cost":null,"price":"9.00","price_2":"10.00","price_3":"11.00","price_4":"12.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2014-03-13 17:40:19","added_by":"azad","modified_on":"2014-06-17 15:41:18","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"5","max_cart_qty":"100","ready_for_sale":"1","last_sold":"2014-08-01 09:26:53","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}},"services":null,"customer":{"id":"1015","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"1","is_stakeholder":"1","is_franchise":"0","is_franchisee":null,"company_name":"Plexsol HQ","company_registration":"","contact_person":"Shafiq Rizwan","contact_number":"0124205391","credit_limit":"0.00","rank":"Normal Member","email":"shafiq@plexsol.com","ic":"880102355071","password":"88aa5e3aad2dbc037bcae4f0a9d5210c","introducer_ic":"","address1":"41, Lorong Indah","address2":"Taman","city":"Bukit Mertajam","state":"Pulau Pinang","zipcode":"14000","country":"Malaysia","tel":"0124205391","fax":"","general_email":"0","terms":"0","description":"0","remarks":"","tags":"Online Customer,Verified","added_on":"2012-09-11 11:26:32","added_by":"@Plexcart","modified_on":"2013-04-01 14:15:33","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":"shafiq@plexsol.com1402993405","division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-08-06 18:55:17', 'admin'),
(748, 'contacts', 'add', 'contact', 1168, '{"id":"1168","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"TshirtCrony","company_registration":"","contact_person":"Salleh","contact_number":"0123564818","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Kedah","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-08-07 08:59:08","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-08-07 08:59:08', 'admin'),
(749, 'sales', 'add', 'quote', 10036, '{"id":"10036","txn_no":"1-10031","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-08-07 00:00:00","due_date":"2014-09-07 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"TshirtCrony","contact_id":"1168","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TshirtCrony\\",\\"mobile\\":\\"0123564818\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"Quotation price is the based on minimum charge for a month.","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"800.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-08-07 09:14:56","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"148","quote_id":"10036","date":"2014-08-07 00:00:00","type":"service","item_id":"0","service_id":"32","item_name":"Website Development, Design & Training","item_description":"PlexCMS\\n- Company Website\\n- Tshirt Configurator\\n- Add-To-Cart Feature Integrated with Plexcloud\\n\\n\\nPlexcloud\\n- Sales Module\\n  > Quotation\\n  > Sales Order\\n  > Invoice\\n  > Delivery Order\\n- Services Module\\n- Inventory Module\\n- Dashboard Module\\n- Contacts Module\\n- Report Module\\n\\nSupport\\n- Full support on Plexcloud and PlexCMS \\n- 8 hours dedicated support in a week\\n\\nFee : RM800 (Monthly base fee ) + 1% Sales Profit\\n\\n\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"800.0000","price":"800.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":"2013-06-14 12:30:53","modified_by":"admin","warehouse_id":"0"}}}', '2014-08-07 09:14:56', 'admin'),
(750, 'sales', 'edit', 'quote', 10036, '{"id":"10036","txn_no":"1-10031","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-08-07 00:00:00","due_date":"2014-09-07 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"TshirtCrony","contact_id":"1168","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TshirtCrony\\",\\"mobile\\":\\"0123564818\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"Quotation price is based on minimum charge for a month.","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"800.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-08-07 09:14:56","added_by":"admin","modified_on":"2014-08-07 09:15:26","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"149","quote_id":"10036","date":"2014-08-07 00:00:00","type":"service","item_id":"0","service_id":"32","item_name":"Website Development, Design & Training","item_description":"PlexCMS\\n- Company Website\\n- Tshirt Configurator\\n- Add-To-Cart Feature Integrated with Plexcloud\\n\\n\\nPlexcloud\\n- Sales Module\\n  > Quotation\\n  > Sales Order\\n  > Invoice\\n  > Delivery Order\\n- Services Module\\n- Inventory Module\\n- Dashboard Module\\n- Contacts Module\\n- Report Module\\n\\nSupport\\n- Full support on Plexcloud and PlexCMS \\n- 8 hours dedicated support in a week\\n\\nFee : RM800 (Monthly base fee ) + 1% Sales Profit\\n\\n\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"800.0000","price":"800.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":"2013-06-14 12:30:53","modified_by":"admin","warehouse_id":"0"}}}', '2014-08-07 09:15:26', 'admin'),
(751, 'sales', 'edit', 'quote', 10036, '{"id":"10036","txn_no":"1-10031","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-08-07 00:00:00","due_date":"2014-09-07 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"TshirtCrony","contact_id":"1168","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TshirtCrony\\",\\"mobile\\":\\"0123564818\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"Quotation price is based on minimum charge for a month.","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"800.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-08-07 09:14:56","added_by":"admin","modified_on":"2014-08-07 09:17:26","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"150","quote_id":"10036","date":"2014-08-07 00:00:00","type":"service","item_id":"0","service_id":"32","item_name":"Website Development, Design & Training","item_description":"PlexCMS\\n- Company Website\\n- Tshirt Configurator\\n- Add-To-Cart Feature Integrated with Plexcloud\\n\\n\\nPlexcloud\\n- Sales Module\\n  > Quotation\\n  > Sales Order\\n  > Invoice\\n  > Delivery Order\\n- Services Module\\n- Inventory Module\\n- Dashboard Module\\n- Contacts Module\\n- Report Module\\n\\nSupport\\n- Full support on Plexcloud and PlexCMS \\n- 5 hours dedicated support in a week\\n\\nFee : RM800 (Monthly base fee ) + 1% Sales Profit\\n\\n\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"800.0000","price":"800.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":"2013-06-14 12:30:53","modified_by":"admin","warehouse_id":"0"}}}', '2014-08-07 09:17:26', 'admin'),
(752, 'sales', 'add', 'invoice', 10060, '{"id":"10060","txn_no":"1-10058","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-08-20 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-08-24 16:03:16","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"118","invoice_id":"10060","type":"service","date":"2014-08-20 12:00:00","item_name":"Halagel Warehouse Management System","item_description":"Halagel Subscription Fee to PlexCloud and PlexCMS","item_id":"0","service_id":"12","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"12":{"id":"12","name":"Halagel Warehouse Management System","description":"Halagel Subscription Fee to PlexCloud and PlexCMS","category":"0","subcategory":"0","cost":"2500.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-09-30 16:31:50","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-08-24 16:03:16', 'admin'),
(753, 'sales', 'add', 'invoice', 10061, '{"id":"10061","txn_no":"1-10059","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-08-20 12:00:00","due_date":null,"received_date":null,"contact_person":"","contact":"Uniform Gallery","contact_id":"1154","contact_address":"{\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Uniform Gallery\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3600.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-08-24 16:03:43","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"119","invoice_id":"10061","type":"service","date":"2014-08-20 12:00:00","item_name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","item_description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","item_id":"0","service_id":"58","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"3600.0000","price":"3600.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"58":{"id":"58","name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","category":"0","subcategory":"0","cost":"0.00","price":"3600.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-03-21 09:01:39","added_by":"shafiq","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1154","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Uniform Gallery","company_registration":"","contact_person":"Uniform Gallery","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No 42, 43 & 43A, Blok E","address2":"Seri Bangi, Jln 8\\/35, Seksyen 8","city":"Bandar Baru Bangi","state":"Selangor","zipcode":"43650","country":"Malaysia","tel":"","fax":"","general_email":"lguniformgallery@yahoo.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-21 08:58:49","added_by":"shafiq","modified_on":"2014-03-21 09:21:34","modified_by":"shafiq","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-08-24 16:03:43', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(754, 'sales', 'add', 'quote', 10037, '{"id":"10037","txn_no":"1-10032","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-09-21 00:00:00","due_date":"2014-10-21 00:00:00","contact_person":"Shamir Adnan","payment_date":null,"received_date":null,"contact":"TshirtCrony","contact_id":"1168","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TshirtCrony\\",\\"mobile\\":\\"0123564818\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-09-23 20:10:08","added_by":"shamiradnan","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"151","quote_id":"10037","date":"2014-09-21 00:00:00","type":"service","item_id":"0","service_id":"32","item_name":"Website Development, Design & Training","item_description":"PlexCMS\\n- Company Website\\n- Tshirt Configurator\\n- Add-To-Cart Feature Integrated with Plexcloud\\n\\n\\nPlexcloud\\n- Sales Module\\n  > Quotation\\n  > Sales Order\\n  > Invoice\\n  > Delivery Order\\n- Services Module\\n- Inventory Module\\n- Dashboard Module\\n- Contacts Module\\n- Report Module\\n\\nSupport\\n- Full support on Plexcloud and PlexCMS \\n- 5 hours dedicated support in a week\\n\\nFee : RM1000 (Monthly base fee )","discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":"2013-06-14 12:30:53","modified_by":"admin","warehouse_id":"0"}}}', '2014-09-23 20:10:08', 'shamiradnan'),
(755, 'sales', 'edit', 'quote', 10037, '{"id":"10037","txn_no":"1-10032","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-09-21 00:00:00","due_date":"2014-10-21 00:00:00","contact_person":"Shamir Adnan","payment_date":null,"received_date":null,"contact":"TshirtCrony","contact_id":"1168","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TshirtCrony\\",\\"mobile\\":\\"0123564818\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-09-23 20:10:08","added_by":"shamiradnan","modified_on":"2014-09-24 15:39:57","modified_by":"shamiradnan","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"152","quote_id":"10037","date":"2014-09-21 00:00:00","type":"service","item_id":"0","service_id":"32","item_name":"Website Design and Development with Agent\\/User site","item_description":"RM 2,500 + RM 800(m\\/o)\\n\\n- Company Website Design and Development\\n- Tshirt Configurator\\n- Add To Cart Integrated with Agent\\/User Site\\n\\nPlexcloud System\\n- Sales Module\\n  > Quotation\\n  > Sales Order\\n  > Invoice\\n  > Delivery Order\\n- Services Module\\n- Inventory Module\\n- Dashboard Module\\n- Contacts Module\\n- Report Module\\n\\nSupport\\n- Full support on Plexcloud and PlexCMS \\n- 5 hours dedicated support in a week\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":"2013-06-14 12:30:53","modified_by":"admin","warehouse_id":"0"}}}', '2014-09-24 15:39:57', 'shamiradnan'),
(756, 'sales', 'add', 'quote', 10038, '{"id":"10038","txn_no":"1-10033","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-09-21 00:00:00","due_date":"2014-10-21 00:00:00","contact_person":"Shamir Adnan","payment_date":null,"received_date":null,"contact":"TshirtCrony","contact_id":"1168","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TshirtCrony\\",\\"mobile\\":\\"0123564818\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-09-24 15:40:59","added_by":"shamiradnan","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"153","quote_id":"10038","date":"2014-09-21 00:00:00","type":"service","item_id":"0","service_id":"32","item_name":"Website Design and Development only ","item_description":"- Company Website Design and Develeopment\\n- Tshirt Configurator\\n- Basic Order\\n- Promotion banners","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3500.0000","price":"3500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":"2013-06-14 12:30:53","modified_by":"admin","warehouse_id":"0"}}}', '2014-09-24 15:40:59', 'shamiradnan'),
(757, 'sales', 'edit', 'quote', 10038, '{"id":"10038","txn_no":"1-10033","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-09-21 00:00:00","due_date":"2014-10-21 00:00:00","contact_person":"Shamir Adnan","payment_date":null,"received_date":null,"contact":"TshirtCrony","contact_id":"1168","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TshirtCrony\\",\\"mobile\\":\\"0123564818\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-09-24 15:40:59","added_by":"shamiradnan","modified_on":"2014-09-24 15:41:12","modified_by":"shamiradnan","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"154","quote_id":"10038","date":"2014-09-21 00:00:00","type":"service","item_id":"0","service_id":"32","item_name":"Website Design and Development only ","item_description":"- Company Website Design and Develeopment\\n- Tshirt Configurator\\n- Basic Order\\n- Promotion banners","discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":"2013-06-14 12:30:53","modified_by":"admin","warehouse_id":"0"}}}', '2014-09-24 15:41:12', 'shamiradnan'),
(758, 'sales', 'add', 'invoice', 10062, '{"id":"10062","txn_no":"1-10060","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-09-20 12:00:00","due_date":null,"received_date":null,"contact_person":"Shamir Adnan","contact":"Uniform Gallery","contact_id":"1154","contact_address":"{\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Uniform Gallery\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3600.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-09-29 16:07:16","added_by":"shamiradnan","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"120","invoice_id":"10062","type":"service","date":"2014-09-20 12:00:00","item_name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","item_description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","item_id":"0","service_id":"58","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"3600.0000","price":"3600.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"58":{"id":"58","name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","category":"0","subcategory":"0","cost":"0.00","price":"3600.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-03-21 09:01:39","added_by":"shafiq","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1154","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Uniform Gallery","company_registration":"","contact_person":"Uniform Gallery","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No 42, 43 & 43A, Blok E","address2":"Seri Bangi, Jln 8\\/35, Seksyen 8","city":"Bandar Baru Bangi","state":"Selangor","zipcode":"43650","country":"Malaysia","tel":"","fax":"","general_email":"lguniformgallery@yahoo.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-21 08:58:49","added_by":"shafiq","modified_on":"2014-03-21 09:21:34","modified_by":"shafiq","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-09-29 16:07:16', 'shamiradnan'),
(759, 'sales', 'add', 'invoice', 10063, '{"id":"10063","txn_no":"1-10061","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-09-20 12:00:00","due_date":null,"received_date":null,"contact_person":"Shamir Adnan","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-09-29 16:07:43","added_by":"shamiradnan","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"121","invoice_id":"10063","type":"service","date":"2014-09-20 12:00:00","item_name":"Halagel Warehouse Management System","item_description":"Halagel Subscription Fee to PlexCloud and PlexCMS","item_id":"0","service_id":"12","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"12":{"id":"12","name":"Halagel Warehouse Management System","description":"Halagel Subscription Fee to PlexCloud and PlexCMS","category":"0","subcategory":"0","cost":"2500.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-09-30 16:31:50","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-09-29 16:07:43', 'shamiradnan'),
(760, 'sales', 'edit', 'invoice', 10063, '{"id":"10063","txn_no":"1-10061","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-09-20 12:00:00","due_date":null,"received_date":null,"contact_person":"Shamir Adnan","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-09-29 16:07:43","added_by":"shamiradnan","modified_on":"2014-09-29 16:08:02","modified_by":"shamiradnan","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"122","invoice_id":"10063","type":"service","date":"2014-09-20 12:00:00","item_name":"Halagel Warehouse Management System","item_description":"Halagel Subscription Fee to PlexCloud and PlexCMS","item_id":"0","service_id":"12","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"12":{"id":"12","name":"Halagel Warehouse Management System","description":"Halagel Subscription Fee to PlexCloud and PlexCMS","category":"0","subcategory":"0","cost":"2500.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-09-30 16:31:50","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-09-29 16:08:02', 'shamiradnan'),
(761, 'sales', 'add', 'invoice', 10064, '{"id":"10064","txn_no":"1-10062","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-10-20 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Uniform Gallery","contact_id":"1154","contact_address":"{\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Uniform Gallery\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3600.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-10-30 12:06:51","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"123","invoice_id":"10064","type":"service","date":"2014-10-20 12:00:00","item_name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","item_description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","item_id":"0","service_id":"58","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"3600.0000","price":"3600.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"58":{"id":"58","name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","category":"0","subcategory":"0","cost":"0.00","price":"3600.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-03-21 09:01:39","added_by":"shafiq","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1154","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Uniform Gallery","company_registration":"","contact_person":"Uniform Gallery","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No 42, 43 & 43A, Blok E","address2":"Seri Bangi, Jln 8\\/35, Seksyen 8","city":"Bandar Baru Bangi","state":"Selangor","zipcode":"43650","country":"Malaysia","tel":"","fax":"","general_email":"lguniformgallery@yahoo.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-21 08:58:49","added_by":"shafiq","modified_on":"2014-03-21 09:21:34","modified_by":"shafiq","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-10-30 12:06:51', 'admin'),
(762, 'sales', 'add', 'invoice', 10065, '{"id":"10065","txn_no":"1-10063","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-10-20 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-10-30 12:07:26","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"124","invoice_id":"10065","type":"service","date":"2014-10-20 12:00:00","item_name":"Halagel Warehouse Management System","item_description":"Halagel Subscription Fee to PlexCloud and PlexCMS","item_id":"0","service_id":"12","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"12":{"id":"12","name":"Halagel Warehouse Management System","description":"Halagel Subscription Fee to PlexCloud and PlexCMS","category":"0","subcategory":"0","cost":"2500.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-09-30 16:31:50","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-10-30 12:07:26', 'admin'),
(763, 'sales', 'edit', 'invoice', 10065, '{"id":"10065","txn_no":"1-10063","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-10-20 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Halagel (M) Sdn. Bhd","contact_id":"1141","contact_address":"{\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Halagel (M) Sdn. Bhd\\",\\"mobile\\":\\"+604 - 4481 287\\\\\\/288\\",\\"address1\\":\\"Lot A137, Jalan 2B,\\",\\"address2\\":\\"Kawasan Perusahaan MIEL Sungai Lalang,\\",\\"zipcode\\":\\"08000\\",\\"city\\":\\"Sungai Petani\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-10-30 12:07:26","added_by":"admin","modified_on":"2014-10-30 12:07:53","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"125","invoice_id":"10065","type":"service","date":"2014-10-20 12:00:00","item_name":"Halagel Warehouse Management System","item_description":"Halagel Subscription Fee to PlexCloud and PlexCMS","item_id":"0","service_id":"12","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"12":{"id":"12","name":"Halagel Warehouse Management System","description":"Halagel Subscription Fee to PlexCloud and PlexCMS","category":"0","subcategory":"0","cost":"2500.00","price":"2500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-09-30 16:31:50","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}},"customer":{"id":"1141","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Halagel (M) Sdn. Bhd","company_registration":"","contact_person":"Rozita Hani","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Lot A137, Jalan 2B,","address2":"Kawasan Perusahaan MIEL Sungai Lalang,","city":"Sungai Petani","state":"Kedah","zipcode":"08000","country":"Malaysia","tel":"+604 - 4481 287\\/288","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2013-11-11 22:02:23","added_by":"admin2","modified_on":"2014-01-25 23:29:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":"1384178543"},"sale":null,"sale_items":null}', '2014-10-30 12:07:53', 'admin'),
(764, 'sales', 'edit', 'invoice', 10064, '{"id":"10064","txn_no":"1-10062","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-10-20 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Uniform Gallery","contact_id":"1154","contact_address":"{\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Uniform Gallery\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3600.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-10-30 12:06:51","added_by":"admin","modified_on":"2014-10-30 12:08:10","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"126","invoice_id":"10064","type":"service","date":"2014-10-20 12:00:00","item_name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","item_description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","item_id":"0","service_id":"58","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"3600.0000","price":"3600.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"58":{"id":"58","name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","category":"0","subcategory":"0","cost":"0.00","price":"3600.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-03-21 09:01:39","added_by":"shafiq","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1154","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Uniform Gallery","company_registration":"","contact_person":"Uniform Gallery","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No 42, 43 & 43A, Blok E","address2":"Seri Bangi, Jln 8\\/35, Seksyen 8","city":"Bandar Baru Bangi","state":"Selangor","zipcode":"43650","country":"Malaysia","tel":"","fax":"","general_email":"lguniformgallery@yahoo.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-21 08:58:49","added_by":"shafiq","modified_on":"2014-03-21 09:21:34","modified_by":"shafiq","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-10-30 12:08:10', 'admin'),
(765, 'sales', 'add', 'invoice', 10066, '{"id":"10066","txn_no":"1-10064","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-10-30 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Growth Lightning Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1250.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-10-30 15:03:49","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"127","invoice_id":"10066","type":"service","date":"2014-10-30 12:00:00","item_name":"Journey Malaysia Site Revamp","item_description":"50%  Project Completion Fee","item_id":"0","service_id":"23","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1250.0000","price":"1250.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"23":{"id":"23","name":"Air Zam2 storage","description":"","category":"0","subcategory":"0","cost":"0.00","price":"2.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-03-07 12:02:05","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"1"}},"customer":{"id":"1167","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Growth Lightning Solutions","company_registration":"","contact_person":"Nicholas Teng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"37-16-3, Victoria Heights","address2":"Hilir Paya Terubong 2","city":"Bayan Lepas","state":"Pulau Pinang","zipcode":"11900","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-08-06 14:26:36","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-10-30 15:03:49', 'admin'),
(766, 'sales', 'add', 'invoice', 10067, '{"id":"10067","txn_no":"1-10065","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-10-30 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Growth Lightning Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"5000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-10-30 15:12:49","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"128","invoice_id":"10067","type":"service","date":"2014-10-30 12:00:00","item_name":"Project Spec Jewellery","item_description":"50% Project Initation Fee","item_id":"0","service_id":"23","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"5000.0000","price":"5000.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"23":{"id":"23","name":"Air Zam2 storage","description":"","category":"0","subcategory":"0","cost":"0.00","price":"2.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-03-07 12:02:05","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"1"}},"customer":{"id":"1167","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Growth Lightning Solutions","company_registration":"","contact_person":"Nicholas Teng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"37-16-3, Victoria Heights","address2":"Hilir Paya Terubong 2","city":"Bayan Lepas","state":"Pulau Pinang","zipcode":"11900","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-08-06 14:26:36","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-10-30 15:12:49', 'admin'),
(767, 'sales', 'add', 'invoice', 10068, '{"id":"10068","txn_no":"1-10066","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-10-30 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Growth Lightning Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-10-30 15:30:00","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"129","invoice_id":"10068","type":"service","date":"2014-10-30 12:00:00","item_name":"Rental & Electriticy","item_description":"August and September\\n(RM300 + RM100)*2 = RM800","item_id":"0","service_id":"23","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2.0000","price":"2.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"23":{"id":"23","name":"Air Zam2 storage","description":"","category":"0","subcategory":"0","cost":"0.00","price":"2.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-03-07 12:02:05","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"1"}},"customer":{"id":"1167","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Growth Lightning Solutions","company_registration":"","contact_person":"Nicholas Teng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"37-16-3, Victoria Heights","address2":"Hilir Paya Terubong 2","city":"Bayan Lepas","state":"Pulau Pinang","zipcode":"11900","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-08-06 14:26:36","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-10-30 15:30:00', 'admin'),
(768, 'sales', 'add', 'quote', 10039, '{"id":"10039","txn_no":"1-10034","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-10-31 00:00:00","due_date":"2014-11-30 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Growth Lightning Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-10-31 17:55:36","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"155","quote_id":"10039","date":"2014-10-31 00:00:00","type":"service","item_id":"0","service_id":"23","item_name":"E-commerce with Customizer","item_description":"","discount":"0","discount_type":null,"qty":"1","price_per_unit":"10000.0000","price":"10000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"23":{"id":"23","name":"Air Zam2 storage","description":"","category":"0","subcategory":"0","cost":"0.00","price":"2.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-03-07 12:02:05","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"1"}}}', '2014-10-31 17:55:36', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(769, 'sales', 'edit', 'invoice', 10068, '{"id":"10068","txn_no":"1-10066","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-10-30 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Growth Lightning Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-10-30 15:30:00","added_by":"admin","modified_on":"2014-11-12 13:29:58","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"130","invoice_id":"10068","type":"service","date":"2014-10-30 12:00:00","item_name":"Rental & Electriticy","item_description":"August,September,October\\n(RM300 + RM100)*3 = RM1200","item_id":"0","service_id":"23","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1200.0000","price":"1200.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"23":{"id":"23","name":"Air Zam2 storage","description":"","category":"0","subcategory":"0","cost":"0.00","price":"2.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-03-07 12:02:05","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"1"}},"customer":{"id":"1167","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Growth Lightning Solutions","company_registration":"","contact_person":"Nicholas Teng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"37-16-3, Victoria Heights","address2":"Hilir Paya Terubong 2","city":"Bayan Lepas","state":"Pulau Pinang","zipcode":"11900","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-08-06 14:26:36","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-11-12 13:29:58', 'admin'),
(770, 'sales', 'edit', 'invoice', 10068, '{"id":"10068","txn_no":"1-10066","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-10-30 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Growth Lightning Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-10-30 15:30:00","added_by":"admin","modified_on":"2014-11-12 13:31:09","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"131","invoice_id":"10068","type":"service","date":"2014-10-30 12:00:00","item_name":"Rental & Electriticy","item_description":"August,September,October\\n(RM300 + RM100)*3 = RM1200","item_id":"0","service_id":"23","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1200.0000","price":"1200.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"23":{"id":"23","name":"Air Zam2 storage","description":"","category":"0","subcategory":"0","cost":"0.00","price":"2.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-03-07 12:02:05","added_by":"admin2","modified_on":null,"modified_by":null,"warehouse_id":"1"}},"customer":{"id":"1167","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Growth Lightning Solutions","company_registration":"","contact_person":"Nicholas Teng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"37-16-3, Victoria Heights","address2":"Hilir Paya Terubong 2","city":"Bayan Lepas","state":"Pulau Pinang","zipcode":"11900","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-08-06 14:26:36","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-11-12 13:31:09', 'admin'),
(771, 'sales', 'add', 'so', 10035, '{"id":"10035","txn_no":"1-10020","quote_id":"10038","invoice_id":null,"number":"0","pr_number":null,"po_number":"QUO-10038","date":"2014-09-21 00:00:00","due_date":"0000-00-00 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"TshirtCrony","contact_id":"1168","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"false","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-11-18 11:33:01","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"29","sales_order_id":"10035","type":"service","date":"2014-09-21 00:00:00","item_name":"Website Design and Development only ","item_description":"- Company Website Design and Develeopment\\n- Tshirt Configurator\\n- Basic Order\\n- Promotion banners","item_id":"0","service_id":"32","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":"2013-06-14 12:30:53","modified_by":"admin","warehouse_id":"0"}}}', '2014-11-18 11:33:01', 'admin'),
(772, 'sales', 'status_update', 'so', 10035, '{"id":"10035","txn_no":"1-10020","quote_id":"10038","invoice_id":null,"number":"0","pr_number":null,"po_number":"QUO-10038","date":"2014-09-21 00:00:00","due_date":"0000-00-00 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"TshirtCrony","contact_id":"1168","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"false","terms":"Credit","duration":"0","remarks":"","status":"Completed","payment_gateway":null,"payment_method":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-11-18 11:33:01","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"29","sales_order_id":"10035","type":"service","date":"2014-09-21 00:00:00","item_name":"Website Design and Development only ","item_description":"- Company Website Design and Develeopment\\n- Tshirt Configurator\\n- Basic Order\\n- Promotion banners","item_id":"0","service_id":"32","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":"2013-06-14 12:30:53","modified_by":"admin","warehouse_id":"0"}}}', '2014-11-18 11:33:17', 'admin'),
(773, 'sales', 'add', 'invoice', 10069, '{"id":"10069","txn_no":"1-10067","quote_id":"10038","sales_order_id":"10035","number":"0","po_number":"QUO-10038","date":"2014-09-21 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"TshirtCrony","contact_id":"1168","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1250.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-11-18 11:35:25","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"132","invoice_id":"10069","type":"service","date":"2014-09-21 12:00:00","item_name":"Website Design and Development only ","item_description":"50% Project Initiation Fee \\n- Company Website Design and Develeopment\\n- Tshirt Configurator\\n- Basic Order\\n- Promotion banners","item_id":"0","service_id":"32","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1250.0000","price":"1250.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":"2013-06-14 12:30:53","modified_by":"admin","warehouse_id":"0"}},"customer":{"id":"1168","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"TshirtCrony","company_registration":"","contact_person":"Salleh","contact_number":"0123564818","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Kedah","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-08-07 08:59:08","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-11-18 11:35:25', 'admin'),
(774, 'sales', 'edit', 'invoice', 10069, '{"id":"10069","txn_no":"1-10067","quote_id":"10038","sales_order_id":"10035","number":"0","po_number":"QUO-10038","date":"2014-09-21 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"TshirtCrony","contact_id":"1168","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1400.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-11-18 11:35:25","added_by":"admin","modified_on":"2014-11-18 11:39:28","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"133","invoice_id":"10069","type":"service","date":"2014-09-21 12:00:00","item_name":"Website Design and Development only ","item_description":"50% Project Initiation Fee \\n- Company Website Design and Develeopment\\n- Tshirt Configurator\\n- Basic Order\\n- Promotion banners","item_id":"0","service_id":"32","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1250.0000","price":"1250.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null},{"id":"134","invoice_id":"10069","type":"service","date":"2014-09-21 12:00:00","item_name":"Domain & Hosting","item_description":"http:\\/\\/tshirtcrony.com - RM50\\nHosting - RM150\\n","item_id":"0","service_id":"61","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"150.0000","price":"150.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":"2013-06-14 12:30:53","modified_by":"admin","warehouse_id":"0"},"61":{"id":"61","name":"Domain & Hosting","description":"","category":"0","subcategory":"0","cost":"50.00","price":"150.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-07-03 12:47:05","added_by":"shamiradnan","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1168","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"TshirtCrony","company_registration":"","contact_person":"Salleh","contact_number":"0123564818","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Kedah","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-08-07 08:59:08","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-11-18 11:39:28', 'admin'),
(775, 'sales', 'edit', 'invoice', 10069, '{"id":"10069","txn_no":"1-10067","quote_id":"10038","sales_order_id":"10035","number":"0","po_number":"QUO-10038","date":"2014-09-21 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"TshirtCrony","contact_id":"1168","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1450.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-11-18 11:35:25","added_by":"admin","modified_on":"2014-11-18 11:40:33","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"136","invoice_id":"10069","type":"service","date":"2014-09-21 12:00:00","item_name":"Domain & Hosting","item_description":"http:\\/\\/tshirtcrony.com - RM50\\nHosting - RM150\\n","item_id":"0","service_id":"61","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"200.0000","price":"200.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null},{"id":"135","invoice_id":"10069","type":"service","date":"2014-09-21 12:00:00","item_name":"Website Design and Development only ","item_description":"50% Project Initiation Fee \\n- Company Website Design and Develeopment\\n- Tshirt Configurator\\n- Basic Order\\n- Promotion banners","item_id":"0","service_id":"32","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1250.0000","price":"1250.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null}],"products":null,"services":{"61":{"id":"61","name":"Domain & Hosting","description":"","category":"0","subcategory":"0","cost":"50.00","price":"150.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-07-03 12:47:05","added_by":"shamiradnan","modified_on":null,"modified_by":null,"warehouse_id":"0"},"32":{"id":"32","name":"Website Development, Design & Training","description":"1)  Content Management System\\n\\n- Website Design and Implementation\\n- News Feed\\n- Facebook Integration\\n   (Facebook Like \\/ Facebook News Feed)\\n- Contact Form\\n- Class Online Registration \\n- Classes Listing\\n- Gallery for Photos and News\\n- Content Writing \\n- Website Content PreManagement\\n\\n2) 1 Day training of system usage\\n\\n- Staff train for system usage (4 hours)\\n- Online Video tutorial of using the system\\n\\n3) Payment Terms\\n\\n- Project Kick Start RM 2,000\\n- Project Completion RM 1,500\\n\\nKindly Make Payment to \\nPlex Solution CIMB Bank\\n0744 0001 0070 56","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-14 12:24:29","added_by":"admin","modified_on":"2013-06-14 12:30:53","modified_by":"admin","warehouse_id":"0"}},"customer":{"id":"1168","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"TshirtCrony","company_registration":"","contact_person":"Salleh","contact_number":"0123564818","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Kedah","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-08-07 08:59:08","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-11-18 11:40:33', 'admin'),
(776, 'sales', 'add', 'invoice', 10070, '{"id":"10070","txn_no":"1-10068","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-11-21 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Uniform Gallery","contact_id":"1154","contact_address":"{\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Uniform Gallery\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3600.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-12-04 10:51:45","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"137","invoice_id":"10070","type":"service","date":"2014-11-21 12:00:00","item_name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","item_description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","item_id":"0","service_id":"58","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"3600.0000","price":"3600.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"58":{"id":"58","name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","category":"0","subcategory":"0","cost":"0.00","price":"3600.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-03-21 09:01:39","added_by":"shafiq","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1154","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Uniform Gallery","company_registration":"","contact_person":"Uniform Gallery","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No 42, 43 & 43A, Blok E","address2":"Seri Bangi, Jln 8\\/35, Seksyen 8","city":"Bandar Baru Bangi","state":"Selangor","zipcode":"43650","country":"Malaysia","tel":"","fax":"","general_email":"lguniformgallery@yahoo.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-21 08:58:49","added_by":"shafiq","modified_on":"2014-03-21 09:21:34","modified_by":"shafiq","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-12-04 10:51:45', 'admin'),
(777, 'sales', 'add', 'quote', 10040, '{"id":"10040","txn_no":"1-10035","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-12-04 00:00:00","due_date":"2015-01-04 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Growth Lightning Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"12000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-12-04 11:01:40","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"156","quote_id":"10040","date":"2014-12-04 00:00:00","type":"service","item_id":"0","service_id":"62","item_name":"B2B Web Based Ordering System","item_description":"- Tiered Pricing System\\n- Multi-User Login\\n- Category Based for promotion and product display\\n- End User Client login\\n- Needs MOQ specifications for each product (They have different MOQ for different products)\\n- Integration with in-house tracking software\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"12000.0000","price":"12000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"62":{"id":"62","name":"B2B Web Based Ordering System","description":"- Tiered Pricing System\\n- Multi-User Login\\n- Category Based for promotion and product display\\n- End User Client login\\n- Needs MOQ specifications for each product (They have different MOQ for different products)\\n- Integration with in-house tracking software\\n","category":"0","subcategory":"0","cost":"8000.00","price":"12000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-12-04 11:00:59","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2014-12-04 11:01:40', 'admin'),
(778, 'sales', 'add', 'quote', 10041, '{"id":"10041","txn_no":"1-10036","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-12-05 00:00:00","due_date":"2014-12-12 00:00:00","contact_person":" ","payment_date":null,"received_date":null,"contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Growth Lightning Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4800.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-12-05 18:32:31","added_by":"shafiq","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"157","quote_id":"10041","date":"2014-12-05 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"GST Compliant POS System","item_description":"Sales Reporting\\nGross Profit Reporting\\nGAF File Generation\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3500.0000","price":"3500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"159","quote_id":"10041","date":"2014-12-05 00:00:00","type":"service","item_id":"0","service_id":"9","item_name":"Cloud Based POS System &#40;Subscription&#41;","item_description":"Online Data\\nOnline Sales and Inventory\\nOnline Backup\\nRM150\\/mo\\n\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"150.0000","price":"150.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"},"9":{"id":"9","name":"Web Design & Development","description":"","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-05-31 13:45:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}}}', '2014-12-05 18:32:31', 'shafiq'),
(779, 'sales', 'edit', 'quote', 10041, '{"id":"10041","txn_no":"1-10036","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-12-05 00:00:00","due_date":"2014-12-12 00:00:00","contact_person":" ","payment_date":null,"received_date":null,"contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Growth Lightning Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4850.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-12-05 18:32:31","added_by":"shafiq","modified_on":"2014-12-05 18:33:57","modified_by":"shafiq","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"160","quote_id":"10041","date":"2014-12-05 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"GST Compliant POS System","item_description":"Sales Reporting\\nGross Profit Reporting\\nGAF File Generation\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3500.0000","price":"3500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"162","quote_id":"10041","date":"2014-12-05 00:00:00","type":"service","item_id":"0","service_id":"22","item_name":"Hardware Costs","item_description":"Thermal Printer RM600\\nCash Drawer RM250\\nBarcode Scanner RM350\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"1200.0000","price":"1200.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"161","quote_id":"10041","date":"2014-12-05 00:00:00","type":"service","item_id":"0","service_id":"9","item_name":"Cloud Based POS System &#40;Subscription&#41;","item_description":"Online Data\\nOnline Sales and Inventory\\nOnline Backup\\nRM150\\/mo\\n\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"150.0000","price":"150.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"22":{"id":"22","name":"Consultation Fee","description":"","category":"0","subcategory":"0","cost":"10.00","price":"20.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-11-08 21:12:47","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null},"9":{"id":"9","name":"Web Design & Development","description":"","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-05-31 13:45:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null},"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"}}}', '2014-12-05 18:33:57', 'shafiq'),
(780, 'sales', 'add', 'invoice', 10071, '{"id":"10071","txn_no":"1-10069","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2014-12-20 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Uniform Gallery","contact_id":"1154","contact_address":"{\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Uniform Gallery\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No 42, 43 & 43A, Blok E\\",\\"address2\\":\\"Seri Bangi, Jln 8\\\\\\/35, Seksyen 8\\",\\"zipcode\\":\\"43650\\",\\"city\\":\\"Bandar Baru Bangi\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"3600.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-12-08 10:02:25","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"138","invoice_id":"10071","type":"service","date":"2014-12-20 12:00:00","item_name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","item_description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","item_id":"0","service_id":"58","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"3600.0000","price":"3600.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"58":{"id":"58","name":"Plexcloud POS, Sales, Inventory and Accounts System [UG]","description":"Plexcloud Sales & Inventory with POS x 6 Branch [POS350BM]","category":"0","subcategory":"0","cost":"0.00","price":"3600.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-03-21 09:01:39","added_by":"shafiq","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"1154","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Uniform Gallery","company_registration":"","contact_person":"Uniform Gallery","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No 42, 43 & 43A, Blok E","address2":"Seri Bangi, Jln 8\\/35, Seksyen 8","city":"Bandar Baru Bangi","state":"Selangor","zipcode":"43650","country":"Malaysia","tel":"","fax":"","general_email":"lguniformgallery@yahoo.com","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-03-21 08:58:49","added_by":"shafiq","modified_on":"2014-03-21 09:21:34","modified_by":"shafiq","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-12-08 10:02:25', 'admin'),
(781, 'sales', 'edit', 'quote', 10041, '{"id":"10041","txn_no":"1-10036","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-12-05 00:00:00","due_date":"2014-12-12 00:00:00","contact_person":" ","payment_date":null,"received_date":null,"contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Growth Lightning Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"7350.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-12-05 18:32:31","added_by":"shafiq","modified_on":"2014-12-10 11:47:47","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"163","quote_id":"10041","date":"2014-12-05 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"GST Compliant POS System","item_description":"Sales Reporting\\nGross Profit Reporting\\nGAF File Generation\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3500.0000","price":"3500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"164","quote_id":"10041","date":"2014-12-05 00:00:00","type":"service","item_id":"0","service_id":"22","item_name":"Hardware Costs","item_description":"Touch POS RM2500\\nThermal Printer RM600\\nCash Drawer RM250\\nBarcode Scanner RM350\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3700.0000","price":"3700.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"165","quote_id":"10041","date":"2014-12-05 00:00:00","type":"service","item_id":"0","service_id":"9","item_name":"Cloud Based POS System &#40;Subscription&#41;","item_description":"Online Data\\nOnline Sales and Inventory\\nOnline Backup\\nRM150\\/mo\\n\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"150.0000","price":"150.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"9":{"id":"9","name":"Web Design & Development","description":"","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-05-31 13:45:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null},"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"},"22":{"id":"22","name":"Consultation Fee","description":"","category":"0","subcategory":"0","cost":"10.00","price":"20.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-11-08 21:12:47","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}}}', '2014-12-10 11:47:47', 'admin'),
(782, 'sales', 'edit', 'quote', 10041, '{"id":"10041","txn_no":"1-10036","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-12-05 00:00:00","due_date":"2014-12-12 00:00:00","contact_person":" ","payment_date":null,"received_date":null,"contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Growth Lightning Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"7700.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-12-05 18:32:31","added_by":"shafiq","modified_on":"2014-12-10 11:48:36","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"166","quote_id":"10041","date":"2014-12-05 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"GST Compliant POS System","item_description":"Sales Reporting\\nGross Profit Reporting\\nGAF File Generation\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3500.0000","price":"3500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"167","quote_id":"10041","date":"2014-12-05 00:00:00","type":"service","item_id":"0","service_id":"22","item_name":"Hardware Costs","item_description":"Touch POS RM2500\\nThermal Printer RM600\\nCash Drawer RM250\\nBarcode Scanner RM350\\nPole Display RM350\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"4050.0000","price":"4050.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"168","quote_id":"10041","date":"2014-12-05 00:00:00","type":"service","item_id":"0","service_id":"9","item_name":"Cloud Based POS System &#40;Subscription&#41;","item_description":"Online Data\\nOnline Sales and Inventory\\nOnline Backup\\nRM150\\/mo\\n\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"150.0000","price":"150.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"},"22":{"id":"22","name":"Consultation Fee","description":"","category":"0","subcategory":"0","cost":"10.00","price":"20.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-11-08 21:12:47","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null},"9":{"id":"9","name":"Web Design & Development","description":"","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-05-31 13:45:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}}}', '2014-12-10 11:48:36', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(783, 'contacts', 'add', 'contact', 1169, '{"id":"1169","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Shaupiq Ahmad","company_registration":"","contact_person":"012555555","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-12-11 14:57:55","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2014-12-11 14:57:55', 'admin'),
(784, 'sales', 'status_update', 'quote', 10041, '{"id":"10041","txn_no":"1-10036","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-12-05 00:00:00","due_date":"2014-12-12 00:00:00","contact_person":" ","payment_date":null,"received_date":null,"contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Growth Lightning Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Accepted","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"7700.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-12-05 18:32:31","added_by":"shafiq","modified_on":"2014-12-10 11:48:36","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"166","quote_id":"10041","date":"2014-12-05 00:00:00","type":"service","item_id":"0","service_id":"26","item_name":"GST Compliant POS System","item_description":"Sales Reporting\\nGross Profit Reporting\\nGAF File Generation\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"3500.0000","price":"3500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"167","quote_id":"10041","date":"2014-12-05 00:00:00","type":"service","item_id":"0","service_id":"22","item_name":"Hardware Costs","item_description":"Touch POS RM2500\\nThermal Printer RM600\\nCash Drawer RM250\\nBarcode Scanner RM350\\nPole Display RM350\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"4050.0000","price":"4050.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"},{"id":"168","quote_id":"10041","date":"2014-12-05 00:00:00","type":"service","item_id":"0","service_id":"9","item_name":"Cloud Based POS System &#40;Subscription&#41;","item_description":"Online Data\\nOnline Sales and Inventory\\nOnline Backup\\nRM150\\/mo\\n\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"150.0000","price":"150.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"},"22":{"id":"22","name":"Consultation Fee","description":"","category":"0","subcategory":"0","cost":"10.00","price":"20.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-11-08 21:12:47","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null},"9":{"id":"9","name":"Web Design & Development","description":"","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-05-31 13:45:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}}}', '2014-12-13 13:58:25', 'admin'),
(785, 'sales', 'add', 'so', 10036, '{"id":"10036","txn_no":"1-10021","quote_id":"10041","invoice_id":null,"number":"0","pr_number":null,"po_number":"QUO-10041","date":"2014-12-05 00:00:00","due_date":"0000-00-00 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"false","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"7700.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-12-13 13:58:36","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"30","sales_order_id":"10036","type":"service","date":"2014-12-05 00:00:00","item_name":"GST Compliant POS System","item_description":"Sales Reporting\\nGross Profit Reporting\\nGAF File Generation\\n","item_id":"0","service_id":"26","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"3500.0000","price":"3500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"},{"id":"31","sales_order_id":"10036","type":"service","date":"2014-12-05 00:00:00","item_name":"Hardware Costs","item_description":"Touch POS RM2500\\nThermal Printer RM600\\nCash Drawer RM250\\nBarcode Scanner RM350\\nPole Display RM350\\n","item_id":"0","service_id":"22","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"4050.0000","price":"4050.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"},{"id":"32","sales_order_id":"10036","type":"service","date":"2014-12-05 00:00:00","item_name":"Cloud Based POS System &#40;Subscription&#41;","item_description":"Online Data\\nOnline Sales and Inventory\\nOnline Backup\\nRM150\\/mo\\n\\n","item_id":"0","service_id":"9","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"150.0000","price":"150.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"},"22":{"id":"22","name":"Consultation Fee","description":"","category":"0","subcategory":"0","cost":"10.00","price":"20.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-11-08 21:12:47","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null},"9":{"id":"9","name":"Web Design & Development","description":"","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-05-31 13:45:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}}}', '2014-12-13 13:58:36', 'admin'),
(786, 'sales', 'status_update', 'so', 10036, '{"id":"10036","txn_no":"1-10021","quote_id":"10041","invoice_id":null,"number":"0","pr_number":null,"po_number":"QUO-10041","date":"2014-12-05 00:00:00","due_date":"0000-00-00 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"false","terms":"Credit","duration":"0","remarks":"","status":"Completed","payment_gateway":null,"payment_method":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"7700.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-12-13 13:58:36","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"30","sales_order_id":"10036","type":"service","date":"2014-12-05 00:00:00","item_name":"GST Compliant POS System","item_description":"Sales Reporting\\nGross Profit Reporting\\nGAF File Generation\\n","item_id":"0","service_id":"26","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"3500.0000","price":"3500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"},{"id":"31","sales_order_id":"10036","type":"service","date":"2014-12-05 00:00:00","item_name":"Hardware Costs","item_description":"Touch POS RM2500\\nThermal Printer RM600\\nCash Drawer RM250\\nBarcode Scanner RM350\\nPole Display RM350\\n","item_id":"0","service_id":"22","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"4050.0000","price":"4050.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"},{"id":"32","sales_order_id":"10036","type":"service","date":"2014-12-05 00:00:00","item_name":"Cloud Based POS System &#40;Subscription&#41;","item_description":"Online Data\\nOnline Sales and Inventory\\nOnline Backup\\nRM150\\/mo\\n\\n","item_id":"0","service_id":"9","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"150.0000","price":"150.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"},"22":{"id":"22","name":"Consultation Fee","description":"","category":"0","subcategory":"0","cost":"10.00","price":"20.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-11-08 21:12:47","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null},"9":{"id":"9","name":"Web Design & Development","description":"","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-05-31 13:45:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}}}', '2014-12-13 13:58:42', 'admin'),
(787, 'sales', 'add', 'invoice', 10072, '{"id":"10072","txn_no":"1-10070","quote_id":"10041","sales_order_id":"10036","number":"0","po_number":"QUO-10041","date":"2014-12-05 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"7700.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-12-13 13:58:47","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","orders":[{"id":"139","invoice_id":"10072","type":"service","date":"2014-12-05 12:00:00","item_name":"GST Compliant POS System","item_description":"Sales Reporting\\nGross Profit Reporting\\nGAF File Generation\\n","item_id":"0","service_id":"26","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"3500.0000","price":"3500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"},{"id":"140","invoice_id":"10072","type":"service","date":"2014-12-05 12:00:00","item_name":"Hardware Costs","item_description":"Touch POS RM2500\\nThermal Printer RM600\\nCash Drawer RM250\\nBarcode Scanner RM350\\nPole Display RM350\\n","item_id":"0","service_id":"22","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"4050.0000","price":"4050.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"},{"id":"141","invoice_id":"10072","type":"service","date":"2014-12-05 12:00:00","item_name":"Cloud Based POS System &#40;Subscription&#41;","item_description":"Online Data\\nOnline Sales and Inventory\\nOnline Backup\\nRM150\\/mo\\n\\n","item_id":"0","service_id":"9","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"150.0000","price":"150.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"},"22":{"id":"22","name":"Consultation Fee","description":"","category":"0","subcategory":"0","cost":"10.00","price":"20.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-11-08 21:12:47","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null},"9":{"id":"9","name":"Web Design & Development","description":"","category":"0","subcategory":"0","cost":"0.00","price":"3500.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-05-31 13:45:32","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":null}},"customer":{"id":"1167","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Growth Lightning Solutions","company_registration":"","contact_person":"Nicholas Teng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"37-16-3, Victoria Heights","address2":"Hilir Paya Terubong 2","city":"Bayan Lepas","state":"Pulau Pinang","zipcode":"11900","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-08-06 14:26:36","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-12-13 13:58:48', 'admin'),
(788, 'sales', 'add', 'quote', 10042, '{"id":"10042","txn_no":"1-10037","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-12-12 00:00:00","due_date":"2014-12-31 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Growth Lightning Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"6800.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-12-13 15:39:36","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"169","quote_id":"10042","date":"2014-12-12 00:00:00","type":"service","item_id":"0","service_id":"13","item_name":"Booking and Ordering Website System","item_description":"- End user Login\\n- Multiple SKU''s\\n- Booking and Ordering\\n- Easy search\\n- Categorized Items\\/Products","discount":"0","discount_type":null,"qty":"1","price_per_unit":"6800.0000","price":"6800.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"13":{"id":"13","name":"Industrial Touch POS Terminal","description":"","category":"0","subcategory":"0","cost":"3200.00","price":"3860.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-10-04 14:15:20","added_by":"admin","modified_on":"2012-10-04 14:18:49","modified_by":"admin","warehouse_id":null}}}', '2014-12-13 15:39:36', 'admin'),
(789, 'sales', 'edit', 'quote', 10042, '{"id":"10042","txn_no":"1-10037","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-12-12 00:00:00","due_date":"2014-12-31 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Growth Lightning Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"7000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-12-13 15:39:36","added_by":"admin","modified_on":"2014-12-13 15:41:01","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"170","quote_id":"10042","date":"2014-12-12 00:00:00","type":"service","item_id":"0","service_id":"13","item_name":"Booking and Ordering Website System","item_description":"- End user Login and registration\\n- Multiple SKU''s\\n- Booking and Ordering\\n- Easy search\\n- Categorized Items\\/Products","discount":"0","discount_type":null,"qty":"1","price_per_unit":"7000.0000","price":"7000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"13":{"id":"13","name":"Industrial Touch POS Terminal","description":"","category":"0","subcategory":"0","cost":"3200.00","price":"3860.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-10-04 14:15:20","added_by":"admin","modified_on":"2012-10-04 14:18:49","modified_by":"admin","warehouse_id":null}}}', '2014-12-13 15:41:01', 'admin'),
(790, 'sales', 'edit', 'quote', 10042, '{"id":"10042","txn_no":"1-10037","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-12-12 00:00:00","due_date":"2014-12-31 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Growth Lightning Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-12-13 15:39:36","added_by":"admin","modified_on":"2014-12-13 18:24:10","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"171","quote_id":"10042","date":"2014-12-12 00:00:00","type":"service","item_id":"0","service_id":"13","item_name":"Booking and Ordering Website System","item_description":"- End user Login and registration\\n- Multiple SKU''s\\n- Booking and Ordering\\n- Easy search\\n- Categorized Items\\/Products","discount":"0","discount_type":null,"qty":"1","price_per_unit":"4500.0000","price":"4500.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"13":{"id":"13","name":"Industrial Touch POS Terminal","description":"","category":"0","subcategory":"0","cost":"3200.00","price":"3860.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2012-10-04 14:15:20","added_by":"admin","modified_on":"2012-10-04 14:18:49","modified_by":"admin","warehouse_id":null}}}', '2014-12-13 18:24:10', 'admin'),
(791, 'sales', 'edit', 'quote', 10040, '{"id":"10040","txn_no":"1-10035","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2014-12-04 00:00:00","due_date":"2015-01-04 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Growth Lightning Solutions","contact_id":"1167","contact_address":"{\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Growth Lightning Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"37-16-3, Victoria Heights\\",\\"address2\\":\\"Hilir Paya Terubong 2\\",\\"zipcode\\":\\"11900\\",\\"city\\":\\"Bayan Lepas\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"6000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-12-04 11:01:40","added_by":"admin","modified_on":"2014-12-13 18:29:40","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"172","quote_id":"10040","date":"2014-12-04 00:00:00","type":"service","item_id":"0","service_id":"62","item_name":"B2B Web Based Ordering System","item_description":"- Tiered Pricing System\\n- Multi-User Login\\n- Category Based for promotion and product display\\n- End User Client login\\n- Needs MOQ specifications for each product (They have different MOQ for different products)\\n- Integration with in-house tracking software\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"6000.0000","price":"6000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"62":{"id":"62","name":"B2B Web Based Ordering System","description":"- Tiered Pricing System\\n- Multi-User Login\\n- Category Based for promotion and product display\\n- End User Client login\\n- Needs MOQ specifications for each product (They have different MOQ for different products)\\n- Integration with in-house tracking software\\n","category":"0","subcategory":"0","cost":"8000.00","price":"12000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2014-12-04 11:00:59","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2014-12-13 18:29:40', 'admin'),
(792, 'sales', 'add', 'invoice', 10073, '{"id":"10073","txn_no":"1-10071","quote_id":"0","sales_order_id":"0","number":"0","po_number":"PO014767","date":"2014-12-16 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"MALAYSIAN NPK FERTILIZER SDN BHD","contact_id":"1160","contact_address":"{\\"address1\\":\\"BATU 2, JALAN JENIANG\\",\\"address2\\":\\"P.O BOX 24\\",\\"zipcode\\":\\"08300\\",\\"city\\":\\"GURUN\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"MALAYSIAN NPK FERTILIZER SDN BHD\\",\\"mobile\\":\\"\\",\\"address1\\":\\"BATU 2, JALAN JENIANG\\",\\"address2\\":\\"P.O BOX 24\\",\\"zipcode\\":\\"08300\\",\\"city\\":\\"GURUN\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"8500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-12-15 23:24:34","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"142","invoice_id":"10073","type":"service","date":"2014-12-16 12:00:00","item_name":"Content Management System","item_description":"- Drag & Drop PlexCMS\\n- WYSIWYG Capabilities\\n- News Feed\\n- Contact Form\\n- Photo Gallery\\n- Content Writng\\n- Website Content Premanagement\\n\\nTraining for the CMS Usage\\nFOC \\/ Inclusive of Procurement System","item_id":"0","service_id":"26","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"8500.0000","price":"8500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"}},"customer":{"id":"1160","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"MALAYSIAN NPK FERTILIZER SDN BHD","company_registration":"","contact_person":"MALAYSIAN NPK FERTILIZER SDN BHD","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"BATU 2, JALAN JENIANG","address2":"P.O BOX 24","city":"GURUN","state":"Kedah","zipcode":"08300","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-04-08 10:41:05","added_by":"shafiq","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-12-15 23:24:34', 'admin'),
(793, 'sales', 'delivery_status_update', 'do', 10073, '{"id":"10073","txn_no":"1-10071","quote_id":"0","sales_order_id":"0","number":"0","po_number":"PO014767","date":"2014-12-16 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"MALAYSIAN NPK FERTILIZER SDN BHD","contact_id":"1160","contact_address":"{\\"address1\\":\\"BATU 2, JALAN JENIANG\\",\\"address2\\":\\"P.O BOX 24\\",\\"zipcode\\":\\"08300\\",\\"city\\":\\"GURUN\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"MALAYSIAN NPK FERTILIZER SDN BHD\\",\\"mobile\\":\\"\\",\\"address1\\":\\"BATU 2, JALAN JENIANG\\",\\"address2\\":\\"P.O BOX 24\\",\\"zipcode\\":\\"08300\\",\\"city\\":\\"GURUN\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Delivered","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"8500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2014-12-15 23:24:34","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"142","invoice_id":"10073","type":"service","date":"2014-12-16 12:00:00","item_name":"Content Management System","item_description":"- Drag & Drop PlexCMS\\n- WYSIWYG Capabilities\\n- News Feed\\n- Contact Form\\n- Photo Gallery\\n- Content Writng\\n- Website Content Premanagement\\n\\nTraining for the CMS Usage\\nFOC \\/ Inclusive of Procurement System","item_id":"0","service_id":"26","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"8500.0000","price":"8500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"}},"customer":{"id":"1160","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"MALAYSIAN NPK FERTILIZER SDN BHD","company_registration":"","contact_person":"MALAYSIAN NPK FERTILIZER SDN BHD","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"BATU 2, JALAN JENIANG","address2":"P.O BOX 24","city":"GURUN","state":"Kedah","zipcode":"08300","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-04-08 10:41:05","added_by":"shafiq","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-12-15 23:25:16', 'admin'),
(794, 'sales', 'deliver', 'invoice', 10073, '{"id":"10073","txn_no":"1-10071","quote_id":"0","sales_order_id":"0","number":"0","po_number":"PO014767","date":"2014-12-16 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"MALAYSIAN NPK FERTILIZER SDN BHD","contact_id":"1160","contact_address":"{\\"address1\\":\\"BATU 2, JALAN JENIANG\\",\\"address2\\":\\"P.O BOX 24\\",\\"zipcode\\":\\"08300\\",\\"city\\":\\"GURUN\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"MALAYSIAN NPK FERTILIZER SDN BHD\\",\\"mobile\\":\\"\\",\\"address1\\":\\"BATU 2, JALAN JENIANG\\",\\"address2\\":\\"P.O BOX 24\\",\\"zipcode\\":\\"08300\\",\\"city\\":\\"GURUN\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Delivered","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"8500.00","total_delivered":"8500.00","cost":null,"tags":"","added_on":"2014-12-15 23:24:34","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"142","invoice_id":"10073","type":"service","date":"2014-12-16 12:00:00","item_name":"Content Management System","item_description":"- Drag & Drop PlexCMS\\n- WYSIWYG Capabilities\\n- News Feed\\n- Contact Form\\n- Photo Gallery\\n- Content Writng\\n- Website Content Premanagement\\n\\nTraining for the CMS Usage\\nFOC \\/ Inclusive of Procurement System","item_id":"0","service_id":"26","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"8500.0000","price":"8500.00","cost":null,"margin":null,"delivered":"1","delivered_price":"8500.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"}},"customer":{"id":"1160","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"MALAYSIAN NPK FERTILIZER SDN BHD","company_registration":"","contact_person":"MALAYSIAN NPK FERTILIZER SDN BHD","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"BATU 2, JALAN JENIANG","address2":"P.O BOX 24","city":"GURUN","state":"Kedah","zipcode":"08300","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-04-08 10:41:05","added_by":"shafiq","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-12-15 23:25:40', 'admin'),
(795, 'sales', 'status_update', 'invoice', 10073, '{"id":"10073","txn_no":"1-10071","quote_id":"0","sales_order_id":"0","number":"0","po_number":"PO014767","date":"2014-12-16 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"MALAYSIAN NPK FERTILIZER SDN BHD","contact_id":"1160","contact_address":"{\\"address1\\":\\"BATU 2, JALAN JENIANG\\",\\"address2\\":\\"P.O BOX 24\\",\\"zipcode\\":\\"08300\\",\\"city\\":\\"GURUN\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"MALAYSIAN NPK FERTILIZER SDN BHD\\",\\"mobile\\":\\"\\",\\"address1\\":\\"BATU 2, JALAN JENIANG\\",\\"address2\\":\\"P.O BOX 24\\",\\"zipcode\\":\\"08300\\",\\"city\\":\\"GURUN\\",\\"state\\":\\"Kedah\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Delivered","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"8500.00","total_delivered":"8500.00","cost":null,"tags":"","added_on":"2014-12-15 23:24:34","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"false","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"142","invoice_id":"10073","type":"service","date":"2014-12-16 12:00:00","item_name":"Content Management System","item_description":"- Drag & Drop PlexCMS\\n- WYSIWYG Capabilities\\n- News Feed\\n- Contact Form\\n- Photo Gallery\\n- Content Writng\\n- Website Content Premanagement\\n\\nTraining for the CMS Usage\\nFOC \\/ Inclusive of Procurement System","item_id":"0","service_id":"26","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"8500.0000","price":"8500.00","cost":null,"margin":null,"delivered":"1","delivered_price":"8500.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"26":{"id":"26","name":"All-In-One POS ","description":"Packages Included:\\n1) One All-In-One Touch Screen POS\\n2) One Cash Drawer\\n3) One Thermal Printer\\n4) Barcode Scanner\\n5) Built-In IC card reader","category":"0","subcategory":"0","cost":"3000.00","price":"5200.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2013-06-04 19:33:54","added_by":"admin2","modified_on":"2013-06-07 11:11:14","modified_by":"admin2","warehouse_id":"0"}},"customer":{"id":"1160","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"MALAYSIAN NPK FERTILIZER SDN BHD","company_registration":"","contact_person":"MALAYSIAN NPK FERTILIZER SDN BHD","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"BATU 2, JALAN JENIANG","address2":"P.O BOX 24","city":"GURUN","state":"Kedah","zipcode":"08300","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2014-04-08 10:41:05","added_by":"shafiq","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2014-12-15 23:25:42', 'admin'),
(796, 'contacts', 'add', 'contact', 1, '{"id":"1","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"asdasd","company_registration":"","contact_person":"asdasd","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-01-20 20:59:14","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2015-01-20 20:59:14', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(797, 'inventory', 'add', 'po', 10001, '{"id":"10001","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-01-20 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"764.40","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-01-20 21:00:24","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"646","discount":"0","discount_type":null,"qty":"12","price_per_unit":"1.3500","price":"16.20","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"},{"id":"3","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"648","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.7500","price":"33.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"},{"id":"2","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"647","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.0000","price":"24.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"},{"id":"4","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"1 GALLON PAIL                               (DOZ)","item_id":"195","discount":"0","discount_type":null,"qty":"12","price_per_unit":"19.2000","price":"230.40","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"},{"id":"5","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"1 \\u00bd GALLON PAIL (DOZ)","item_id":"224","discount":"0","discount_type":null,"qty":"12","price_per_unit":"38.4000","price":"460.80","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"646":{"id":"646","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721535","sku2":null,"sku3":null,"sku4":null,"qty":null,"alert_quantity":null,"max_quantity":null,"cost":"0.00","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4881","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"647":{"id":"647","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721542","sku2":null,"sku3":null,"sku4":null,"qty":null,"alert_quantity":null,"max_quantity":null,"cost":"0.00","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4882","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"648":{"id":"648","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721559","sku2":null,"sku3":null,"sku4":null,"qty":null,"alert_quantity":null,"max_quantity":null,"cost":"0.00","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4883","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"195":{"id":"195","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"1 GALLON PAIL                              ","model_no":null,"warranty":null,"sku":"9555070707591","sku2":null,"sku3":null,"sku4":null,"qty":null,"alert_quantity":null,"max_quantity":null,"cost":"0.00","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"3761","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"DOZ","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"224":{"id":"224","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"1 \\u00bd GALLON PAIL","model_no":null,"warranty":null,"sku":"9555070710768        B 30.40","sku2":null,"sku3":null,"sku4":null,"qty":null,"alert_quantity":null,"max_quantity":null,"cost":"0.00","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"3875","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"DOZ","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null}}}', '2015-01-20 21:00:24', 'admin'),
(798, 'inventory', 'receive', 'po', 10001, '{"id":"10001","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-01-20 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"764.40","total_received":"756.30","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-01-20 21:00:24","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"646","discount":"0","discount_type":null,"qty":"12","price_per_unit":"1.3500","price":"16.20","received":"6","received_price":"8.10","done":null,"division_id":null,"warehouse_id":"1"},{"id":"3","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"648","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.7500","price":"33.00","received":"12","received_price":"33.00","done":null,"division_id":null,"warehouse_id":"1"},{"id":"2","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"647","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.0000","price":"24.00","received":"12","received_price":"24.00","done":null,"division_id":null,"warehouse_id":"1"},{"id":"4","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"1 GALLON PAIL                               (DOZ)","item_id":"195","discount":"0","discount_type":null,"qty":"12","price_per_unit":"19.2000","price":"230.40","received":"12","received_price":"230.40","done":null,"division_id":null,"warehouse_id":"1"},{"id":"5","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"1 \\u00bd GALLON PAIL (DOZ)","item_id":"224","discount":"0","discount_type":null,"qty":"12","price_per_unit":"38.4000","price":"460.80","received":"12","received_price":"460.80","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"646":{"id":"646","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721535","sku2":null,"sku3":null,"sku4":null,"qty":"6","alert_quantity":null,"max_quantity":null,"cost":"1.35","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4881","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"647":{"id":"647","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721542","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"2.00","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4882","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"648":{"id":"648","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721559","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"2.75","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4883","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"195":{"id":"195","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"1 GALLON PAIL                              ","model_no":null,"warranty":null,"sku":"9555070707591","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"19.20","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"3761","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"DOZ","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"224":{"id":"224","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"1 \\u00bd GALLON PAIL","model_no":null,"warranty":null,"sku":"9555070710768        B 30.40","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"38.40","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"3875","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"DOZ","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null}}}', '2015-01-20 21:01:18', 'admin'),
(799, 'inventory', 'status_update', 'po', 10001, '{"id":"10001","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-01-20 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Partially Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"764.40","total_received":"756.30","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-01-20 21:00:24","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"646","discount":"0","discount_type":null,"qty":"12","price_per_unit":"1.3500","price":"16.20","received":"6","received_price":"8.10","done":null,"division_id":null,"warehouse_id":"1"},{"id":"3","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"648","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.7500","price":"33.00","received":"12","received_price":"33.00","done":null,"division_id":null,"warehouse_id":"1"},{"id":"2","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"647","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.0000","price":"24.00","received":"12","received_price":"24.00","done":null,"division_id":null,"warehouse_id":"1"},{"id":"4","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"1 GALLON PAIL                               (DOZ)","item_id":"195","discount":"0","discount_type":null,"qty":"12","price_per_unit":"19.2000","price":"230.40","received":"12","received_price":"230.40","done":null,"division_id":null,"warehouse_id":"1"},{"id":"5","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"1 \\u00bd GALLON PAIL (DOZ)","item_id":"224","discount":"0","discount_type":null,"qty":"12","price_per_unit":"38.4000","price":"460.80","received":"12","received_price":"460.80","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"646":{"id":"646","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721535","sku2":null,"sku3":null,"sku4":null,"qty":"6","alert_quantity":null,"max_quantity":null,"cost":"1.35","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4881","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"647":{"id":"647","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721542","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"2.00","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4882","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"648":{"id":"648","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721559","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"2.75","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4883","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"195":{"id":"195","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"1 GALLON PAIL                              ","model_no":null,"warranty":null,"sku":"9555070707591","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"19.20","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"3761","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"DOZ","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"224":{"id":"224","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"1 \\u00bd GALLON PAIL","model_no":null,"warranty":null,"sku":"9555070710768        B 30.40","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"38.40","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"3875","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"DOZ","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null}}}', '2015-01-20 21:01:18', 'admin'),
(800, 'inventory', 'receive', 'po', 10001, '{"id":"10001","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-01-20 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Partially Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"764.40","total_received":"764.40","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-01-20 21:00:24","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"646","discount":"0","discount_type":null,"qty":"12","price_per_unit":"1.3500","price":"16.20","received":"12","received_price":"16.20","done":null,"division_id":null,"warehouse_id":"1"},{"id":"3","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"648","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.7500","price":"33.00","received":"12","received_price":"33.00","done":null,"division_id":null,"warehouse_id":"1"},{"id":"2","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"647","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.0000","price":"24.00","received":"12","received_price":"24.00","done":null,"division_id":null,"warehouse_id":"1"},{"id":"4","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"1 GALLON PAIL                               (DOZ)","item_id":"195","discount":"0","discount_type":null,"qty":"12","price_per_unit":"19.2000","price":"230.40","received":"12","received_price":"230.40","done":null,"division_id":null,"warehouse_id":"1"},{"id":"5","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"1 \\u00bd GALLON PAIL (DOZ)","item_id":"224","discount":"0","discount_type":null,"qty":"12","price_per_unit":"38.4000","price":"460.80","received":"12","received_price":"460.80","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"646":{"id":"646","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721535","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"1.35","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4881","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"647":{"id":"647","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721542","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"2.00","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4882","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"648":{"id":"648","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721559","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"2.75","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4883","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"195":{"id":"195","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"1 GALLON PAIL                              ","model_no":null,"warranty":null,"sku":"9555070707591","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"19.20","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"3761","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"DOZ","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"224":{"id":"224","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"1 \\u00bd GALLON PAIL","model_no":null,"warranty":null,"sku":"9555070710768        B 30.40","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"38.40","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"3875","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"DOZ","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null}}}', '2015-01-20 21:01:46', 'admin'),
(801, 'inventory', 'status_update', 'po', 10001, '{"id":"10001","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-01-20 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"764.40","total_received":"764.40","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-01-20 21:00:24","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"646","discount":"0","discount_type":null,"qty":"12","price_per_unit":"1.3500","price":"16.20","received":"12","received_price":"16.20","done":null,"division_id":null,"warehouse_id":"1"},{"id":"3","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"648","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.7500","price":"33.00","received":"12","received_price":"33.00","done":null,"division_id":null,"warehouse_id":"1"},{"id":"2","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"647","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.0000","price":"24.00","received":"12","received_price":"24.00","done":null,"division_id":null,"warehouse_id":"1"},{"id":"4","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"1 GALLON PAIL                               (DOZ)","item_id":"195","discount":"0","discount_type":null,"qty":"12","price_per_unit":"19.2000","price":"230.40","received":"12","received_price":"230.40","done":null,"division_id":null,"warehouse_id":"1"},{"id":"5","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"1 \\u00bd GALLON PAIL (DOZ)","item_id":"224","discount":"0","discount_type":null,"qty":"12","price_per_unit":"38.4000","price":"460.80","received":"12","received_price":"460.80","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"646":{"id":"646","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721535","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"1.35","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4881","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"647":{"id":"647","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721542","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"2.00","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4882","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"648":{"id":"648","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721559","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"2.75","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4883","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"195":{"id":"195","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"1 GALLON PAIL                              ","model_no":null,"warranty":null,"sku":"9555070707591","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"19.20","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"3761","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"DOZ","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"224":{"id":"224","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"1 \\u00bd GALLON PAIL","model_no":null,"warranty":null,"sku":"9555070710768        B 30.40","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"38.40","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"3875","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"DOZ","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null}}}', '2015-01-20 21:01:47', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(802, 'inventory', 'status_update', 'po', 10001, '{"id":"10001","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-01-20 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"764.40","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-01-20 21:00:24","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"646","discount":"0","discount_type":null,"qty":"12","price_per_unit":"1.3500","price":"16.20","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1"},{"id":"3","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"648","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.7500","price":"33.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1"},{"id":"2","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"647","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.0000","price":"24.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1"},{"id":"4","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"1 GALLON PAIL                               (DOZ)","item_id":"195","discount":"0","discount_type":null,"qty":"12","price_per_unit":"19.2000","price":"230.40","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1"},{"id":"5","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"1 \\u00bd GALLON PAIL (DOZ)","item_id":"224","discount":"0","discount_type":null,"qty":"12","price_per_unit":"38.4000","price":"460.80","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1"}],"products":{"646":{"id":"646","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721535","sku2":null,"sku3":null,"sku4":null,"qty":"0","alert_quantity":null,"max_quantity":null,"cost":"1.35","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4881","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"647":{"id":"647","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721542","sku2":null,"sku3":null,"sku4":null,"qty":"0","alert_quantity":null,"max_quantity":null,"cost":"2.00","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4882","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"648":{"id":"648","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721559","sku2":null,"sku3":null,"sku4":null,"qty":"0","alert_quantity":null,"max_quantity":null,"cost":"2.75","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4883","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"195":{"id":"195","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"1 GALLON PAIL                              ","model_no":null,"warranty":null,"sku":"9555070707591","sku2":null,"sku3":null,"sku4":null,"qty":"0","alert_quantity":null,"max_quantity":null,"cost":"19.20","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"3761","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"DOZ","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"224":{"id":"224","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"1 \\u00bd GALLON PAIL","model_no":null,"warranty":null,"sku":"9555070710768        B 30.40","sku2":null,"sku3":null,"sku4":null,"qty":"0","alert_quantity":null,"max_quantity":null,"cost":"38.40","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"3875","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"DOZ","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null}}}', '2015-01-20 21:02:32', 'admin'),
(803, 'inventory', 'receive', 'po', 10001, '{"id":"10001","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-01-20 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"764.40","total_received":"756.30","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-01-20 21:00:24","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"646","discount":"0","discount_type":null,"qty":"12","price_per_unit":"1.3500","price":"16.20","received":"6","received_price":"8.10","done":null,"division_id":null,"warehouse_id":"1"},{"id":"3","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"648","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.7500","price":"33.00","received":"12","received_price":"33.00","done":null,"division_id":null,"warehouse_id":"1"},{"id":"2","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"647","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.0000","price":"24.00","received":"12","received_price":"24.00","done":null,"division_id":null,"warehouse_id":"1"},{"id":"4","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"1 GALLON PAIL                               (DOZ)","item_id":"195","discount":"0","discount_type":null,"qty":"12","price_per_unit":"19.2000","price":"230.40","received":"12","received_price":"230.40","done":null,"division_id":null,"warehouse_id":"1"},{"id":"5","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"1 \\u00bd GALLON PAIL (DOZ)","item_id":"224","discount":"0","discount_type":null,"qty":"12","price_per_unit":"38.4000","price":"460.80","received":"12","received_price":"460.80","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"646":{"id":"646","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721535","sku2":null,"sku3":null,"sku4":null,"qty":"6","alert_quantity":null,"max_quantity":null,"cost":"1.35","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4881","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"647":{"id":"647","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721542","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"2.00","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4882","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"648":{"id":"648","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721559","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"2.75","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4883","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"195":{"id":"195","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"1 GALLON PAIL                              ","model_no":null,"warranty":null,"sku":"9555070707591","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"19.20","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"3761","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"DOZ","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"224":{"id":"224","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"1 \\u00bd GALLON PAIL","model_no":null,"warranty":null,"sku":"9555070710768        B 30.40","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"38.40","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"3875","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"DOZ","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null}}}', '2015-01-20 21:02:39', 'admin'),
(804, 'inventory', 'status_update', 'po', 10001, '{"id":"10001","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-01-20 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Partially Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"764.40","total_received":"756.30","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-01-20 21:00:24","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"646","discount":"0","discount_type":null,"qty":"12","price_per_unit":"1.3500","price":"16.20","received":"6","received_price":"8.10","done":null,"division_id":null,"warehouse_id":"1"},{"id":"3","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"648","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.7500","price":"33.00","received":"12","received_price":"33.00","done":null,"division_id":null,"warehouse_id":"1"},{"id":"2","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_id":"647","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.0000","price":"24.00","received":"12","received_price":"24.00","done":null,"division_id":null,"warehouse_id":"1"},{"id":"4","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"1 GALLON PAIL                               (DOZ)","item_id":"195","discount":"0","discount_type":null,"qty":"12","price_per_unit":"19.2000","price":"230.40","received":"12","received_price":"230.40","done":null,"division_id":null,"warehouse_id":"1"},{"id":"5","purchase_order_id":"10001","date":"2015-01-20 00:00:00","item_description":null,"item_name":"1 \\u00bd GALLON PAIL (DOZ)","item_id":"224","discount":"0","discount_type":null,"qty":"12","price_per_unit":"38.4000","price":"460.80","received":"12","received_price":"460.80","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"646":{"id":"646","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721535","sku2":null,"sku3":null,"sku4":null,"qty":"6","alert_quantity":null,"max_quantity":null,"cost":"1.35","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4881","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"647":{"id":"647","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721542","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"2.00","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4882","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"648":{"id":"648","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721559","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"2.75","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4883","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"195":{"id":"195","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"1 GALLON PAIL                              ","model_no":null,"warranty":null,"sku":"9555070707591","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"19.20","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"3761","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"DOZ","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"224":{"id":"224","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"1 \\u00bd GALLON PAIL","model_no":null,"warranty":null,"sku":"9555070710768        B 30.40","sku2":null,"sku3":null,"sku4":null,"qty":"12","alert_quantity":null,"max_quantity":null,"cost":"38.40","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"3875","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"DOZ","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null}}}', '2015-01-20 21:02:39', 'admin'),
(805, 'inventory', 'add', 'dn', 10001, '{"id":"10001","txn_no":"1-10001","cn_number":"","date":"2015-01-20 00:00:00","contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":null,"terms":"Credit","remarks":"","status":"Pending","payment_status":"Unpaid","payment_reference":null,"payment_date":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"6.75","total_received":null,"tags":"","added_on":"2015-01-20 21:05:23","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","debit_note_id":"10001","date":"2015-01-20 00:00:00","item_id":"646","item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_description":null,"discount":"0","discount_type":null,"qty":"5","price_per_unit":"1.3500","price":"6.75","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"646":{"id":"646","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721535","sku2":null,"sku3":null,"sku4":null,"qty":"6","alert_quantity":null,"max_quantity":null,"cost":"1.35","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4881","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null}}}', '2015-01-20 21:05:23', 'admin'),
(806, 'inventory', 'status_update', 'dn', 10001, '{"id":"10001","txn_no":"1-10001","cn_number":"","date":"2015-01-20 00:00:00","contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":null,"terms":"Credit","remarks":"","status":"Returned","payment_status":"Unpaid","payment_reference":null,"payment_date":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"6.75","total_received":null,"tags":"","added_on":"2015-01-20 21:05:23","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","debit_note_id":"10001","date":"2015-01-20 00:00:00","item_id":"646","item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_description":null,"discount":"0","discount_type":null,"qty":"5","price_per_unit":"1.3500","price":"6.75","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"646":{"id":"646","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721535","sku2":null,"sku3":null,"sku4":null,"qty":"6","alert_quantity":null,"max_quantity":null,"cost":"1.35","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4881","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null}}}', '2015-01-20 21:05:34', 'admin'),
(807, 'inventory', 'receive', 'dn', 10001, '{"id":"10001","txn_no":"1-10001","cn_number":"","date":"2015-01-20 00:00:00","contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":null,"terms":"Credit","remarks":"","status":"Returned","payment_status":"Unpaid","payment_reference":null,"payment_date":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"6.75","total_received":"6.75","tags":"","added_on":"2015-01-20 21:05:23","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","debit_note_id":"10001","date":"2015-01-20 00:00:00","item_id":"646","item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_description":null,"discount":"0","discount_type":null,"qty":"5","price_per_unit":"1.3500","price":"6.75","received":"5","received_price":"6.75","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"646":{"id":"646","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721535","sku2":null,"sku3":null,"sku4":null,"qty":"1","alert_quantity":null,"max_quantity":null,"cost":"1.35","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4881","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null}}}', '2015-01-20 21:05:34', 'admin'),
(808, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6","enabled":"1"}', '2015-01-22 15:55:51', 'admin'),
(809, 'sales', 'add', 'invoice', 10001, '{"id":"10001","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-01-22 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"asdasd","contact_id":"1","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"asdasd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"27.56","total_delivered":null,"cost":null,"tags":"","added_on":"2015-01-22 15:58:45","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"1.56\\"}","total_tax":"1.56","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"1","invoice_id":"10001","type":"product","date":"2015-01-22 12:00:00","item_name":"\\"BUBBLE\\" FOOD CONTAINER","item_description":"","item_id":"646","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"12.0000","price":"12.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"},{"id":"2","invoice_id":"10001","type":"product","date":"2015-01-22 12:00:00","item_name":"\\"BUBBLE\\" FOOD CONTAINER","item_description":"","item_id":"647","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"14.0000","price":"14.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"646":{"id":"646","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721535","sku2":null,"sku3":null,"sku4":null,"qty":"1","alert_quantity":null,"max_quantity":null,"cost":"1.35","average_cost":null,"price":"0.00","price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4881","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"647":{"id":"647","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721542","sku2":null,"sku3":null,"sku4":null,"qty":"11","alert_quantity":null,"max_quantity":null,"cost":"2.00","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4882","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":"2015-01-20 21:29:26","isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null}},"services":null,"customer":{"id":"1","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"asdasd","company_registration":"","contact_person":"asdasd","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-01-20 20:59:14","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2015-01-22 15:58:45', 'admin'),
(810, 'sales', 'deliver', 'invoice', 10001, '{"id":"10001","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-01-22 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"asdasd","contact_id":"1","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"asdasd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"27.56","total_delivered":"26.00","cost":null,"tags":"","added_on":"2015-01-22 15:58:45","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"1.56\\"}","total_tax":"1.56","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"1","invoice_id":"10001","type":"product","date":"2015-01-22 12:00:00","item_name":"\\"BUBBLE\\" FOOD CONTAINER","item_description":"","item_id":"646","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"12.0000","price":"12.00","cost":"1.35","margin":null,"delivered":"1","delivered_price":"12.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"},{"id":"2","invoice_id":"10001","type":"product","date":"2015-01-22 12:00:00","item_name":"\\"BUBBLE\\" FOOD CONTAINER","item_description":"","item_id":"647","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"14.0000","price":"14.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"14.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"646":{"id":"646","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721535","sku2":null,"sku3":null,"sku4":null,"qty":"0","alert_quantity":null,"max_quantity":null,"cost":"1.35","average_cost":null,"price":"0.00","price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4881","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":"2015-01-22 15:59:22","isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"647":{"id":"647","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721542","sku2":null,"sku3":null,"sku4":null,"qty":"11","alert_quantity":null,"max_quantity":null,"cost":"2.00","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4882","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":"2015-01-22 15:59:22","isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null}},"services":null,"customer":{"id":"1","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"asdasd","company_registration":"","contact_person":"asdasd","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-01-20 20:59:14","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2015-01-22 15:59:22', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(811, 'sales', 'status_update', 'invoice', 10001, '{"id":"10001","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-01-22 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"asdasd","contact_id":"1","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"asdasd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Partially Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"27.56","total_delivered":"26.00","cost":null,"tags":"","added_on":"2015-01-22 15:58:45","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"1.56\\"}","total_tax":"1.56","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"1","invoice_id":"10001","type":"product","date":"2015-01-22 12:00:00","item_name":"\\"BUBBLE\\" FOOD CONTAINER","item_description":"","item_id":"646","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"12.0000","price":"12.00","cost":"1.35","margin":null,"delivered":"1","delivered_price":"12.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"},{"id":"2","invoice_id":"10001","type":"product","date":"2015-01-22 12:00:00","item_name":"\\"BUBBLE\\" FOOD CONTAINER","item_description":"","item_id":"647","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"14.0000","price":"14.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"14.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"646":{"id":"646","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721535","sku2":null,"sku3":null,"sku4":null,"qty":"0","alert_quantity":null,"max_quantity":null,"cost":"1.35","average_cost":null,"price":"0.00","price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4881","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":"2015-01-22 15:59:22","isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"647":{"id":"647","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721542","sku2":null,"sku3":null,"sku4":null,"qty":"11","alert_quantity":null,"max_quantity":null,"cost":"2.00","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4882","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":"2015-01-22 15:59:22","isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null}},"services":null,"customer":{"id":"1","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"asdasd","company_registration":"","contact_person":"asdasd","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-01-20 20:59:14","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2015-01-22 15:59:24', 'admin'),
(812, 'sales', 'deliver', 'invoice', 10001, '{"id":"10001","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-01-22 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"asdasd","contact_id":"1","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"asdasd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"27.56","total_delivered":"26.00","cost":null,"tags":"","added_on":"2015-01-22 15:58:45","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"1.56\\"}","total_tax":"1.56","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"1","invoice_id":"10001","type":"product","date":"2015-01-22 12:00:00","item_name":"\\"BUBBLE\\" FOOD CONTAINER","item_description":"","item_id":"646","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"12.0000","price":"12.00","cost":"1.35","margin":null,"delivered":"1","delivered_price":"12.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"},{"id":"2","invoice_id":"10001","type":"product","date":"2015-01-22 12:00:00","item_name":"\\"BUBBLE\\" FOOD CONTAINER","item_description":"","item_id":"647","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"14.0000","price":"14.00","cost":"2.00","margin":null,"delivered":"1","delivered_price":"14.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"646":{"id":"646","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721535","sku2":null,"sku3":null,"sku4":null,"qty":"0","alert_quantity":null,"max_quantity":null,"cost":"1.35","average_cost":null,"price":"0.00","price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4881","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":"2015-01-22 15:59:35","isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"647":{"id":"647","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721542","sku2":null,"sku3":null,"sku4":null,"qty":"10","alert_quantity":null,"max_quantity":null,"cost":"2.00","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4882","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":"2015-01-22 15:59:35","isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null}},"services":null,"customer":{"id":"1","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"asdasd","company_registration":"","contact_person":"asdasd","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-01-20 20:59:14","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2015-01-22 15:59:35', 'admin'),
(813, 'sales', 'status_update', 'invoice', 10001, '{"id":"10001","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-01-22 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"asdasd","contact_id":"1","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"asdasd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"27.56","total_delivered":"26.00","cost":null,"tags":"","added_on":"2015-01-22 15:58:45","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"1.56\\"}","total_tax":"1.56","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"1","invoice_id":"10001","type":"product","date":"2015-01-22 12:00:00","item_name":"\\"BUBBLE\\" FOOD CONTAINER","item_description":"","item_id":"646","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"12.0000","price":"12.00","cost":"1.35","margin":null,"delivered":"1","delivered_price":"12.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"},{"id":"2","invoice_id":"10001","type":"product","date":"2015-01-22 12:00:00","item_name":"\\"BUBBLE\\" FOOD CONTAINER","item_description":"","item_id":"647","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"14.0000","price":"14.00","cost":"2.00","margin":null,"delivered":"1","delivered_price":"14.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"646":{"id":"646","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721535","sku2":null,"sku3":null,"sku4":null,"qty":"0","alert_quantity":null,"max_quantity":null,"cost":"1.35","average_cost":null,"price":"0.00","price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4881","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":"2015-01-22 15:59:35","isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null},"647":{"id":"647","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"\\"BUBBLE\\" FOOD CONTAINER","model_no":null,"warranty":null,"sku":"9555070721542","sku2":null,"sku3":null,"sku4":null,"qty":"10","alert_quantity":null,"max_quantity":null,"cost":"2.00","average_cost":null,"price":null,"price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"JT4882","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":"PCS","uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":"2015-01-22 15:59:35","isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null}},"services":null,"customer":{"id":"1","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"asdasd","company_registration":"","contact_person":"asdasd","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-01-20 20:59:14","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null},"sale":null,"sale_items":null}', '2015-01-22 15:59:36', 'admin'),
(814, 'inventory', 'add', 'item', NULL, '[]', '2015-01-25 07:51:54', 'admin'),
(815, 'inventory', 'add', 'item', 854, '{"id":"854","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"test item","model_no":"","warranty":"","sku":"test1234","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"1","max_quantity":"0","cost":null,"average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-01-25 07:51:54","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2015-01-25 07:52:00', 'admin'),
(816, 'inventory', 'add', 'item', NULL, '[]', '2015-01-25 07:52:04', 'admin'),
(817, 'inventory', 'add', 'item', 855, '{"id":"855","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"test item","model_no":"","warranty":"","sku":"test12345","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"1","max_quantity":"0","cost":null,"average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-01-25 07:52:04","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2015-01-25 07:53:47', 'admin'),
(818, 'inventory', 'add', 'item', NULL, '[]', '2015-01-25 07:54:00', 'admin'),
(819, 'inventory', 'add', 'item', 856, '{"id":"856","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"TEST STOCK","model_no":"","warranty":"","sku":"test12345678","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"1","max_quantity":"0","cost":null,"average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-01-25 07:54:00","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1"}', '2015-01-25 07:54:38', 'admin'),
(820, 'inventory', 'add', 'item', NULL, '[]', '2015-01-25 07:54:43', 'admin'),
(821, 'inventory', 'add', 'item', NULL, '[]', '2015-01-25 07:55:01', 'admin'),
(822, 'inventory', 'add', 'item', NULL, '[]', '2015-01-25 16:01:26', 'admin'),
(823, 'contacts', 'add', 'contact', 2, '{"id":"2","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Idea Workshop Sdn Bhd","company_registration":"676351-P","contact_person":"Shin Luis Tseng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"4-2 Jalan Telawi 2","address2":"Bangsar Baru","city":"Kuala Lumpur","state":"Kuala Lumpur","zipcode":"59100","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-02-12 14:18:13","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null}', '2015-02-12 14:18:13', 'admin'),
(824, 'inventory', 'edit', 'item', 2, '{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-12 10:21:04","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-01-21 07:29:29","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"IM","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"0"}', '2015-03-12 10:21:04', 'admin'),
(825, 'inventory', 'edit', 'item', 2, '{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-12 10:21:43","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-01-21 07:29:29","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"IM","supply_tax_code":"ZRL","purchase_taxable":"1","supply_taxable":"1"}', '2015-03-12 10:21:43', 'admin'),
(826, 'inventory', 'edit', 'item', 2, '{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-12 10:21:49","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-01-21 07:29:29","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"IM","supply_tax_code":"ZRL","purchase_taxable":"1","supply_taxable":"0"}', '2015-03-12 10:21:49', 'admin'),
(827, 'tax', 'delete', 'tax', 1, '{"id":"1","type":"0","name":"Service Tax","percentage":"5.000","enabled":"0"}', '2015-03-17 20:22:04', 'admin'),
(828, 'inventory', 'edit', 'item', 2, '{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-17 20:22:27","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-01-21 07:29:29","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"IM","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}', '2015-03-17 20:22:27', 'admin'),
(829, 'inventory', 'edit', 'item', 3, '{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}', '2015-03-22 10:52:58', 'admin'),
(830, 'tax', 'add', 'tax', 3, '{"id":"3","type":"0","name":"Service Tax","percentage":"10","enabled":"1"}', '2015-03-22 11:41:06', 'admin'),
(831, 'tax', 'delete', 'tax', 3, '{"id":"3","type":"0","name":"Service Tax","percentage":"10","enabled":"1"}', '2015-03-22 11:45:26', 'admin'),
(832, 'inventory', 'add', 'item', NULL, '[]', '2015-03-22 12:03:24', 'admin'),
(833, 'inventory', 'edit', 'item', 101983, '{"id":"101983","primary_image":null,"image":null,"category":"FOOD AND BEVERAGE","subcategory":"CANNED DRINKS","brand":"","location":"","name":"COKE","model_no":"","warranty":"","sku":"12345","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"10","max_quantity":"0","cost":"1.50","average_cost":null,"price":"2.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-03-22 12:03:24","added_by":"admin","modified_on":"2015-03-22 12:06:07","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}', '2015-03-22 12:06:07', 'admin'),
(834, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"0","enabled":"1"}', '2015-03-26 14:56:51', 'admin'),
(835, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6","enabled":"1"}', '2015-03-30 17:15:46', 'admin'),
(836, 'sales', 'add', 'invoice', 10002, '{"id":"10002","txn_no":"1-10002","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-03-31 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Idea Workshop Sdn Bhd","contact_id":"2","contact_address":"{\\"address1\\":\\"4-2 Jalan Telawi 2\\",\\"address2\\":\\"Bangsar Baru\\",\\"zipcode\\":\\"59100\\",\\"city\\":\\"Kuala Lumpur\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Idea Workshop Sdn Bhd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"4-2 Jalan Telawi 2\\",\\"address2\\":\\"Bangsar Baru\\",\\"zipcode\\":\\"59100\\",\\"city\\":\\"Kuala Lumpur\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"12466.40","total_delivered":null,"cost":null,"tags":"","added_on":"2015-03-31 09:57:17","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"26.40\\"}","total_tax":"26.40","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"3","invoice_id":"10002","type":"product","date":"2015-03-31 12:00:00","item_name":"5 PCS BRUSH [SR]","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"4.4000","price":"440.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":""},{"id":"4","invoice_id":"10002","type":"product","date":"2015-03-31 12:00:00","item_name":"BRUSH [ZRL]","item_description":"","item_id":"3","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"120.0000","price":"12000.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-13","alert_quantity":"-1","max_quantity":"0","cost":"3.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-17 20:22:27","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-03-30 19:23:58","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"IM","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"},"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-1","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-03-22 12:00:36","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"2","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Idea Workshop Sdn Bhd","company_registration":"676351-P","contact_person":"Shin Luis Tseng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"4-2 Jalan Telawi 2","address2":"Bangsar Baru","city":"Kuala Lumpur","state":"Kuala Lumpur","zipcode":"59100","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-02-12 14:18:13","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":null},"sale":null,"sale_items":null}', '2015-03-31 09:57:17', 'admin'),
(837, 'sales', 'edit', 'invoice', NULL, '[]', '2015-03-31 09:58:16', 'admin'),
(838, 'sales', 'edit', 'invoice', NULL, '[]', '2015-03-31 09:58:28', 'admin'),
(839, 'sales', 'delete', 'invoice', 10002, '{"id":"10002","txn_no":"1-10002","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-03-31 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Idea Workshop Sdn Bhd","contact_id":"2","contact_address":"{\\"address1\\":\\"4-2 Jalan Telawi 2\\",\\"address2\\":\\"Bangsar Baru\\",\\"zipcode\\":\\"59100\\",\\"city\\":\\"Kuala Lumpur\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Idea Workshop Sdn Bhd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"4-2 Jalan Telawi 2\\",\\"address2\\":\\"Bangsar Baru\\",\\"zipcode\\":\\"59100\\",\\"city\\":\\"Kuala Lumpur\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"12466.40","total_delivered":null,"cost":null,"tags":"","added_on":"2015-03-31 09:57:17","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"26.40\\"}","total_tax":"26.40","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"3","invoice_id":"10002","type":"product","date":"2015-03-31 12:00:00","item_name":"5 PCS BRUSH [SR]","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"4.4000","price":"440.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":""},{"id":"4","invoice_id":"10002","type":"product","date":"2015-03-31 12:00:00","item_name":"BRUSH [ZRL]","item_description":"","item_id":"3","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"120.0000","price":"12000.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-13","alert_quantity":"-1","max_quantity":"0","cost":"3.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-17 20:22:27","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-03-30 19:23:58","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"IM","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"},"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-1","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-03-22 12:00:36","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"2","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Idea Workshop Sdn Bhd","company_registration":"676351-P","contact_person":"Shin Luis Tseng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"4-2 Jalan Telawi 2","address2":"Bangsar Baru","city":"Kuala Lumpur","state":"Kuala Lumpur","zipcode":"59100","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-02-12 14:18:13","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":null},"sale":null,"sale_items":null}', '2015-03-31 09:58:38', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(840, 'sales', 'add', 'invoice', 10003, '{"id":"10003","txn_no":"1-10002","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-03-31 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Idea Workshop Sdn Bhd","contact_id":"2","contact_address":"{\\"address1\\":\\"4-2 Jalan Telawi 2\\",\\"address2\\":\\"Bangsar Baru\\",\\"zipcode\\":\\"59100\\",\\"city\\":\\"Kuala Lumpur\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Idea Workshop Sdn Bhd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"4-2 Jalan Telawi 2\\",\\"address2\\":\\"Bangsar Baru\\",\\"zipcode\\":\\"59100\\",\\"city\\":\\"Kuala Lumpur\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"46.64","total_delivered":null,"cost":null,"tags":"","added_on":"2015-03-31 09:59:02","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"2.64\\"}","total_tax":"2.64","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"7","invoice_id":"10003","type":"product","date":"2015-03-31 12:00:00","item_name":"5 PCS BRUSH [SR]","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"4.4000","price":"44.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":""}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-13","alert_quantity":"-1","max_quantity":"0","cost":"3.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-17 20:22:27","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-03-30 19:23:58","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"IM","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}},"services":null,"customer":{"id":"2","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Idea Workshop Sdn Bhd","company_registration":"676351-P","contact_person":"Shin Luis Tseng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"4-2 Jalan Telawi 2","address2":"Bangsar Baru","city":"Kuala Lumpur","state":"Kuala Lumpur","zipcode":"59100","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-02-12 14:18:13","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":null},"sale":null,"sale_items":null}', '2015-03-31 09:59:02', 'admin'),
(841, 'tax', 'add', 'tax', 4, '{"id":"4","type":"0","name":"test","percentage":"2","enabled":"1","inclusive":"1"}', '2015-04-08 13:08:13', 'admin'),
(842, 'tax', 'add', 'tax', 5, '{"id":"5","type":"0","name":"test","percentage":"1","enabled":"1","inclusive":"0"}', '2015-04-08 13:08:44', 'admin'),
(843, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"0","inclusive":"1"}', '2015-04-08 13:12:37', 'admin'),
(844, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"0","inclusive":"0"}', '2015-04-08 13:12:55', 'admin'),
(845, 'tax', 'edit', 'tax', 5, '{"id":"5","type":"0","name":"test","percentage":"1.000","enabled":"0","inclusive":"0"}', '2015-04-08 13:13:45', 'admin'),
(846, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"0"}', '2015-04-08 13:15:22', 'admin'),
(847, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"0"}', '2015-04-08 13:15:45', 'admin'),
(848, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"0"}', '2015-04-08 13:15:48', 'admin'),
(849, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"0"}', '2015-04-08 13:15:52', 'admin'),
(850, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"0"}', '2015-04-08 13:16:24', 'admin'),
(851, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"0"}', '2015-04-08 13:17:15', 'admin'),
(852, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"0","inclusive":"0"}', '2015-04-08 13:17:18', 'admin'),
(853, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"0"}', '2015-04-08 13:17:22', 'admin'),
(854, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"1"}', '2015-04-08 13:17:25', 'admin'),
(855, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"0"}', '2015-04-08 13:17:29', 'admin'),
(856, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"0"}', '2015-04-08 13:17:32', 'admin'),
(857, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"0"}', '2015-04-08 13:18:51', 'admin'),
(858, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"1"}', '2015-04-08 13:18:54', 'admin'),
(859, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"5","enabled":"1","inclusive":"1"}', '2015-04-08 13:19:03', 'admin'),
(860, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6","enabled":"1","inclusive":"1"}', '2015-04-08 13:19:08', 'admin'),
(861, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"VAT","percentage":"6.000","enabled":"1","inclusive":"1"}', '2015-04-08 13:19:10', 'admin'),
(862, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"1"}', '2015-04-08 13:19:14', 'admin'),
(863, 'tax', 'delete', 'tax', 4, '{"id":"4","type":"0","name":"test","percentage":"2","enabled":"1","inclusive":"1"}', '2015-04-08 13:19:16', 'admin'),
(864, 'tax', 'delete', 'tax', 5, '{"id":"5","type":"0","name":"test","percentage":"1.000","enabled":"0","inclusive":"0"}', '2015-04-08 13:19:23', 'admin'),
(865, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"1"}', '2015-04-08 17:59:54', 'admin'),
(866, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"0"}', '2015-04-08 17:59:59', 'admin'),
(867, 'inventory', 'edit', 'item', 2, '{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-17","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}', '2015-04-09 16:30:32', 'admin'),
(868, 'inventory', 'add', 'po', 10002, '{"id":"10002","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-04-09 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"24.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-04-09 16:37:22","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"{\\"2\\":\\"1.20\\"}","total_tax":"1.20","assigned_to":null,"orders":[{"id":"13","purchase_order_id":"10002","date":"2015-04-09 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"0","discount_type":null,"qty":"1","price_per_unit":"20.0000","price":"20.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":null,"tax_code":null},{"id":"14","purchase_order_id":"10002","date":"2015-04-09 00:00:00","item_description":null,"item_name":"BRUSH (GR)","item_id":"3","discount":"0","discount_type":null,"qty":"2","price_per_unit":"2.0000","price":"4.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":null,"tax_code":null}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-17","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"},"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-04-09 16:37:22', 'admin'),
(869, 'inventory', 'delete', 'po', 10002, '{"id":"10002","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-04-09 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"24.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-04-09 16:37:22","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"{\\"2\\":\\"1.20\\"}","total_tax":"1.20","assigned_to":null,"orders":[{"id":"13","purchase_order_id":"10002","date":"2015-04-09 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"0","discount_type":null,"qty":"1","price_per_unit":"20.0000","price":"20.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":null,"tax_code":null},{"id":"14","purchase_order_id":"10002","date":"2015-04-09 00:00:00","item_description":null,"item_name":"BRUSH (GR)","item_id":"3","discount":"0","discount_type":null,"qty":"2","price_per_unit":"2.0000","price":"4.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":null,"tax_code":null}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-17","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"},"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-04-09 16:39:52', 'admin'),
(870, 'inventory', 'add', 'po', 10003, '{"id":"10003","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-04-09 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"31.20","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-04-09 16:41:35","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"{\\"2\\":\\"1.20\\"}","total_tax":"1.20","assigned_to":null,"orders":[{"id":"15","purchase_order_id":"10003","date":"2015-04-09 00:00:00","item_description":null,"item_name":"3pcs Paint Brush Set (TUCSON USA)  ()","item_id":"101486","discount":"0","discount_type":null,"qty":"10","price_per_unit":"1.0000","price":"10.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""},{"id":"16","purchase_order_id":"10003","date":"2015-04-09 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"0","discount_type":null,"qty":"1","price_per_unit":"20.0000","price":"20.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-17","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"},"101486":{"id":"101486","primary_image":null,"image":null,"category":null,"subcategory":null,"brand":null,"location":null,"name":"3pcs Paint Brush Set (TUCSON USA) ","model_no":null,"warranty":null,"sku":"55010326","sku2":null,"sku3":null,"sku4":null,"qty":"0","alert_quantity":"-1","max_quantity":null,"cost":"1.00","average_cost":null,"price":"2.00","price_2":null,"price_3":null,"price_4":null,"price2":null,"price2_2":null,"price2_3":null,"price2_4":null,"price3":null,"price3_2":null,"price3_3":null,"price3_4":null,"price4":null,"price4_2":null,"price4_3":null,"price4_4":null,"description":"China","supplier":null,"remarks":null,"ordered_quantity":null,"is_active":null,"is_consigned":null,"quick":null,"adjust_cost":"0","enter_price":"0","enter_serial":null,"tags":null,"added_on":null,"added_by":null,"modified_on":null,"modified_by":null,"redeemable":null,"redeem_points":null,"current_po":null,"current_po_item":null,"uom1":null,"uom2":null,"uom3":null,"uom4":null,"loose_qty2":null,"loose_qty3":null,"loose_qty4":null,"weight":null,"weight_unit":null,"weight2":null,"weight3":null,"weight4":null,"volume":null,"volume_unit":null,"volume2":null,"volume3":null,"volume4":null,"min_cart_qty":null,"max_cart_qty":null,"ready_for_sale":null,"last_sold":null,"isbn":null,"links":null,"linked":null,"author":null,"publisher":null,"lastchange":null,"order":null,"warehouse_id":null,"purchase_tax_code":null,"supply_tax_code":null,"purchase_taxable":null,"supply_taxable":null}}}', '2015-04-09 16:41:35', 'admin'),
(871, 'inventory', 'edit', 'po', NULL, '[]', '2015-04-09 17:43:55', 'admin'),
(872, 'inventory', 'edit', 'po', NULL, '[]', '2015-04-09 17:44:55', 'admin'),
(873, 'inventory', 'edit', 'po', NULL, '[]', '2015-04-09 17:45:21', 'admin'),
(874, 'inventory', 'add', 'po', 10004, '{"id":"10004","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-04-09 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"41.20","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-04-09 17:46:37","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"amount\\":\\"1.20\\"}]","total_tax":"1.20","assigned_to":null,"orders":[{"id":"23","purchase_order_id":"10004","date":"2015-04-09 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"1.0000","price":"20.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"},{"id":"24","purchase_order_id":"10004","date":"2015-04-09 00:00:00","item_description":null,"item_name":"BRUSH (GR)","item_id":"3","discount":"0","discount_type":null,"qty":"20","price_per_unit":"1.0000","price":"20.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZRL"}],"products":{"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"},"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-17","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-04-09 17:46:37', 'admin'),
(875, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"1"}', '2015-04-10 17:11:46', 'admin'),
(876, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"0"}', '2015-04-10 17:52:05', 'admin'),
(877, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"1"}', '2015-04-11 06:13:34', 'admin'),
(878, 'inventory', 'add', 'po', 10005, '{"id":"10005","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-04-11 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"63.60","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-04-11 06:15:50","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"amount\\":\\"3.60\\"}]","total_tax":"3.60","assigned_to":null,"orders":[{"id":"25","purchase_order_id":"10005","date":"2015-04-11 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"0","discount_type":null,"qty":"30","price_per_unit":"2.0000","price":"60.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-17","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-04-11 06:15:50', 'admin'),
(879, 'sales', 'add', 'invoice', 10004, '{"id":"10004","txn_no":"1-10003","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-04-14 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"asdasd","contact_id":"1","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"asdasd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1246.64","total_delivered":null,"cost":null,"tags":"","added_on":"2015-04-14 14:24:20","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"amount\\":\\"2.64\\"}]","total_tax":"2.64","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"8","invoice_id":"10004","type":"product","date":"2015-04-14 12:00:00","item_name":"5 PCS BRUSH [SR]","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"4.4000","price":"44.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"TX"},{"id":"9","invoice_id":"10004","type":"product","date":"2015-04-14 12:00:00","item_name":"BRUSH [ZRL]","item_description":"","item_id":"3","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"120.0000","price":"1200.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"},"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"1","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"asdasd","company_registration":"","contact_person":"asdasd","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-01-20 20:59:14","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":null},"sale":null,"sale_items":null}', '2015-04-14 14:24:20', 'admin'),
(880, 'sales', 'add', 'invoice', 10005, '{"id":"10005","txn_no":"1-10004","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-04-14 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"asdasd","contact_id":"1","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"asdasd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"124.40","total_delivered":null,"cost":null,"tags":"","added_on":"2015-04-14 14:34:33","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"amount\\":\\"0.26\\"}]","total_tax":"0.26","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"10","invoice_id":"10005","type":"product","date":"2015-04-14 12:00:00","item_name":"5 PCS BRUSH [SR]","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"4.4000","price":"4.40","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"},{"id":"11","invoice_id":"10005","type":"product","date":"2015-04-14 12:00:00","item_name":"BRUSH [ZRL]","item_description":"","item_id":"3","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"120.0000","price":"120.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":"ZRL"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"},"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"1","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"asdasd","company_registration":"","contact_person":"asdasd","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-01-20 20:59:14","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":null},"sale":null,"sale_items":null}', '2015-04-14 14:34:33', 'admin'),
(881, 'sales', 'edit', 'invoice', NULL, '[]', '2015-04-14 14:35:09', 'admin'),
(882, 'sales', 'edit', 'invoice', NULL, '[]', '2015-04-14 14:36:33', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(883, 'sales', 'delete', 'invoice', 10003, '{"id":"10003","txn_no":"1-10002","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-03-31 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Idea Workshop Sdn Bhd","contact_id":"2","contact_address":"{\\"address1\\":\\"4-2 Jalan Telawi 2\\",\\"address2\\":\\"Bangsar Baru\\",\\"zipcode\\":\\"59100\\",\\"city\\":\\"Kuala Lumpur\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Idea Workshop Sdn Bhd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"4-2 Jalan Telawi 2\\",\\"address2\\":\\"Bangsar Baru\\",\\"zipcode\\":\\"59100\\",\\"city\\":\\"Kuala Lumpur\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"46.64","total_delivered":null,"cost":null,"tags":"","added_on":"2015-03-31 09:59:02","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"2.64\\"}","total_tax":"2.64","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"7","invoice_id":"10003","type":"product","date":"2015-03-31 12:00:00","item_name":"5 PCS BRUSH [SR]","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"4.4000","price":"44.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":""}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}},"services":null,"customer":{"id":"2","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Idea Workshop Sdn Bhd","company_registration":"676351-P","contact_person":"Shin Luis Tseng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"4-2 Jalan Telawi 2","address2":"Bangsar Baru","city":"Kuala Lumpur","state":"Kuala Lumpur","zipcode":"59100","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-02-12 14:18:13","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":null},"sale":null,"sale_items":null}', '2015-04-14 14:38:52', 'admin'),
(884, 'sales', 'delete', 'invoice', 10004, '{"id":"10004","txn_no":"1-10003","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-04-14 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"asdasd","contact_id":"1","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"asdasd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1246.64","total_delivered":null,"cost":null,"tags":"","added_on":"2015-04-14 14:24:20","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"amount\\":\\"2.64\\"}]","total_tax":"2.64","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"8","invoice_id":"10004","type":"product","date":"2015-04-14 12:00:00","item_name":"5 PCS BRUSH [SR]","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"4.4000","price":"44.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"TX"},{"id":"9","invoice_id":"10004","type":"product","date":"2015-04-14 12:00:00","item_name":"BRUSH [ZRL]","item_description":"","item_id":"3","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"120.0000","price":"1200.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"},"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"1","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"asdasd","company_registration":"","contact_person":"asdasd","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-01-20 20:59:14","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":null},"sale":null,"sale_items":null}', '2015-04-14 14:38:54', 'admin'),
(885, 'sales', 'delete', 'invoice', 10005, '{"id":"10005","txn_no":"1-10004","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-04-14 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"asdasd","contact_id":"1","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"asdasd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"124.40","total_delivered":null,"cost":null,"tags":"","added_on":"2015-04-14 14:34:33","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"amount\\":\\"0.26\\"}]","total_tax":"0.26","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"10","invoice_id":"10005","type":"product","date":"2015-04-14 12:00:00","item_name":"5 PCS BRUSH [SR]","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"4.4000","price":"4.40","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"},{"id":"11","invoice_id":"10005","type":"product","date":"2015-04-14 12:00:00","item_name":"BRUSH [ZRL]","item_description":"","item_id":"3","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"120.0000","price":"120.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":"ZRL"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"},"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"1","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"asdasd","company_registration":"","contact_person":"asdasd","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-01-20 20:59:14","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":null},"sale":null,"sale_items":null}', '2015-04-14 14:38:55', 'admin'),
(886, 'sales', 'status_update', 'invoice', 10001, '{"id":"10001","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-01-22 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"asdasd","contact_id":"1","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"asdasd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"27.56","total_delivered":"0.00","cost":null,"tags":"","added_on":"2015-01-22 15:58:45","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"1.56\\"}","total_tax":"1.56","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"1","invoice_id":"10001","type":"product","date":"2015-01-22 12:00:00","item_name":"\\"BUBBLE\\" FOOD CONTAINER","item_description":"","item_id":"646","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"12.0000","price":"12.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"12.00","done":"0","no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":null,"tax_code":null},{"id":"2","invoice_id":"10001","type":"product","date":"2015-01-22 12:00:00","item_name":"\\"BUBBLE\\" FOOD CONTAINER","item_description":"","item_id":"647","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"14.0000","price":"14.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"14.00","done":"0","no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":null,"tax_code":null}],"products":{"646":{"id":"646","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"JT4881 \\"BUBBLE\\"REC CONTAINER","model_no":"","warranty":"","sku":"9555070721535","sku2":"","sku3":"","sku4":"","qty":"-5","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"1.50","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"JT4881","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-02-24 12:17:11","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"UNIT","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-03-01 13:42:06","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":null,"supply_tax_code":null,"purchase_taxable":null,"supply_taxable":null},"647":{"id":"647","primary_image":null,"image":null,"category":"PLASTIC","subcategory":"","brand":"APPLE LADY","location":"","name":"JT4882 \\"BUBBLE\\" REC CONTAINER","model_no":"","warranty":"","sku":"9555070721542","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"2.50","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"JT4882","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-02-24 12:18:53","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"UNIT","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-01-21 07:38:43","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":null,"supply_tax_code":null,"purchase_taxable":null,"supply_taxable":null}},"services":null,"customer":{"id":"1","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"asdasd","company_registration":"","contact_person":"asdasd","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-01-20 20:59:14","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":null},"sale":null,"sale_items":null}', '2015-04-14 14:38:58', 'admin'),
(887, 'sales', 'delete', 'invoice', 10001, '{"id":"10001","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-01-22 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"asdasd","contact_id":"1","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"asdasd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"27.56","total_delivered":"0.00","cost":null,"tags":"","added_on":"2015-01-22 15:58:45","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"{\\"2\\":\\"1.56\\"}","total_tax":"1.56","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"1","invoice_id":"10001","type":"product","date":"2015-01-22 12:00:00","item_name":"\\"BUBBLE\\" FOOD CONTAINER","item_description":"","item_id":"646","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"12.0000","price":"12.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"12.00","done":"0","no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":null,"tax_code":null},{"id":"2","invoice_id":"10001","type":"product","date":"2015-01-22 12:00:00","item_name":"\\"BUBBLE\\" FOOD CONTAINER","item_description":"","item_id":"647","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"14.0000","price":"14.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"14.00","done":"0","no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":null,"tax_code":null}],"products":{"646":{"id":"646","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"JT4881 \\"BUBBLE\\"REC CONTAINER","model_no":"","warranty":"","sku":"9555070721535","sku2":"","sku3":"","sku4":"","qty":"-5","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"1.50","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"JT4881","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-02-24 12:17:11","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"UNIT","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-03-01 13:42:06","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":null,"supply_tax_code":null,"purchase_taxable":null,"supply_taxable":null},"647":{"id":"647","primary_image":null,"image":null,"category":"PLASTIC","subcategory":"","brand":"APPLE LADY","location":"","name":"JT4882 \\"BUBBLE\\" REC CONTAINER","model_no":"","warranty":"","sku":"9555070721542","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"2.50","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"JT4882","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-02-24 12:18:53","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"UNIT","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-01-21 07:38:43","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":null,"supply_tax_code":null,"purchase_taxable":null,"supply_taxable":null}},"services":null,"customer":{"id":"1","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"asdasd","company_registration":"","contact_person":"asdasd","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-01-20 20:59:14","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":null},"sale":null,"sale_items":null}', '2015-04-14 14:39:04', 'admin'),
(888, 'sales', 'add', 'invoice', 10006, '{"id":"10006","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-04-14 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Idea Workshop Sdn Bhd","contact_id":"2","contact_address":"{\\"address1\\":\\"4-2 Jalan Telawi 2\\",\\"address2\\":\\"Bangsar Baru\\",\\"zipcode\\":\\"59100\\",\\"city\\":\\"Kuala Lumpur\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Idea Workshop Sdn Bhd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"4-2 Jalan Telawi 2\\",\\"address2\\":\\"Bangsar Baru\\",\\"zipcode\\":\\"59100\\",\\"city\\":\\"Kuala Lumpur\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"44.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-04-14 14:40:02","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"2.64\\"}]","total_tax":"2.64","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"14","invoice_id":"10006","type":"product","date":"2015-04-14 12:00:00","item_name":"5 PCS BRUSH [SR]","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"4.4000","price":"44.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}},"services":null,"customer":{"id":"2","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Idea Workshop Sdn Bhd","company_registration":"676351-P","contact_person":"Shin Luis Tseng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"4-2 Jalan Telawi 2","address2":"Bangsar Baru","city":"Kuala Lumpur","state":"Kuala Lumpur","zipcode":"59100","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-02-12 14:18:13","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":null},"sale":null,"sale_items":null}', '2015-04-14 14:40:02', 'admin'),
(889, 'sales', 'edit', 'invoice', NULL, '[]', '2015-04-14 14:47:36', 'admin'),
(890, 'inventory', 'delete', 'po', 10004, '{"id":"10004","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-04-09 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"41.20","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-04-09 17:46:37","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"amount\\":\\"1.20\\"}]","total_tax":"1.20","assigned_to":null,"orders":[{"id":"23","purchase_order_id":"10004","date":"2015-04-09 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"1.0000","price":"20.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"},{"id":"24","purchase_order_id":"10004","date":"2015-04-09 00:00:00","item_description":null,"item_name":"BRUSH (GR)","item_id":"3","discount":"0","discount_type":null,"qty":"20","price_per_unit":"1.0000","price":"20.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZRL"}],"products":{"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"},"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-04-14 14:51:16', 'admin'),
(891, 'inventory', 'delete', 'po', 10005, '{"id":"10005","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-04-11 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"63.60","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-04-11 06:15:50","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"amount\\":\\"3.60\\"}]","total_tax":"3.60","assigned_to":null,"orders":[{"id":"25","purchase_order_id":"10005","date":"2015-04-11 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"0","discount_type":null,"qty":"30","price_per_unit":"2.0000","price":"60.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-04-14 14:51:18', 'admin'),
(892, 'inventory', 'add', 'po', 10006, '{"id":"10006","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-04-01 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"21.20","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-04-14 15:01:16","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"amount\\":\\"1.20\\"}]","total_tax":"1.20","assigned_to":null,"orders":[{"id":"26","purchase_order_id":"10006","date":"2015-04-01 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"0","discount_type":null,"qty":"10","price_per_unit":"2.0000","price":"20.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-04-14 15:01:16', 'admin'),
(893, 'inventory', 'edit', 'po', NULL, '[]', '2015-04-14 15:02:01', 'admin'),
(894, 'inventory', 'edit', 'po', NULL, '[]', '2015-04-14 15:03:01', 'admin'),
(895, 'inventory', 'edit', 'po', NULL, '[]', '2015-04-14 15:03:12', 'admin'),
(896, 'inventory', 'delete', 'po', 10006, '{"id":"10006","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-04-01 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"21.20","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-04-14 15:01:16","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"amount\\":\\"1.20\\"}]","total_tax":"1.20","assigned_to":null,"orders":[{"id":"26","purchase_order_id":"10006","date":"2015-04-01 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"0","discount_type":null,"qty":"10","price_per_unit":"2.0000","price":"20.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-04-14 15:03:32', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(897, 'inventory', 'add', 'po', 10007, '{"id":"10007","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-04-01 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"20.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-04-14 15:03:50","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"amount\\":\\"1.20\\"}]","total_tax":"1.20","assigned_to":null,"orders":[{"id":"30","purchase_order_id":"10007","date":"2015-04-01 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"0","discount_type":null,"qty":"10","price_per_unit":"2.0000","price":"20.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-04-14 15:03:50', 'admin'),
(898, 'inventory', 'edit', 'po', NULL, '[]', '2015-04-14 15:04:51', 'admin'),
(899, 'inventory', 'delete', 'po', 10007, '{"id":"10007","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-04-01 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"20.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-04-14 15:03:50","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"amount\\":\\"1.20\\"}]","total_tax":"1.20","assigned_to":null,"orders":[{"id":"30","purchase_order_id":"10007","date":"2015-04-01 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"0","discount_type":null,"qty":"10","price_per_unit":"2.0000","price":"20.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-04-14 15:04:59', 'admin'),
(900, 'inventory', 'add', 'po', 10008, '{"id":"10008","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-04-14 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"30.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-04-14 15:05:26","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"1.20\\"}]","total_tax":"1.20","assigned_to":null,"orders":[{"id":"32","purchase_order_id":"10008","date":"2015-04-14 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"0","discount_type":null,"qty":"10","price_per_unit":"2.0000","price":"20.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"},{"id":"33","purchase_order_id":"10008","date":"2015-04-14 00:00:00","item_description":null,"item_name":"BRUSH (GR)","item_id":"3","discount":"0","discount_type":null,"qty":"10","price_per_unit":"1.0000","price":"10.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZRL"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"},"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-04-14 15:05:26', 'admin'),
(901, 'inventory', 'edit', 'po', NULL, '[]', '2015-04-14 15:05:45', 'admin'),
(902, 'inventory', 'edit', 'po', NULL, '[]', '2015-04-14 15:06:06', 'admin'),
(903, 'inventory', 'edit', 'po', NULL, '[]', '2015-04-14 15:06:42', 'admin'),
(904, 'inventory', 'edit', 'po', NULL, '[]', '2015-04-14 15:11:02', 'admin'),
(905, 'inventory', 'edit', 'po', NULL, '[]', '2015-04-14 15:11:21', 'admin'),
(906, 'inventory', 'edit', 'po', NULL, '[]', '2015-04-14 15:12:13', 'admin'),
(907, 'inventory', 'edit', 'po', NULL, '[]', '2015-04-14 15:12:44', 'admin'),
(908, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"0"}', '2015-04-14 23:07:14', 'admin'),
(909, 'sales', 'edit', 'invoice', 10006, '{"id":"10006","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-04-14 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Idea Workshop Sdn Bhd","contact_id":"2","contact_address":"{\\"address1\\":\\"4-2 Jalan Telawi 2\\",\\"address2\\":\\"Bangsar Baru\\",\\"zipcode\\":\\"59100\\",\\"city\\":\\"Kuala Lumpur\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Idea Workshop Sdn Bhd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"4-2 Jalan Telawi 2\\",\\"address2\\":\\"Bangsar Baru\\",\\"zipcode\\":\\"59100\\",\\"city\\":\\"Kuala Lumpur\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1246.64","total_delivered":null,"cost":null,"tags":"","added_on":"2015-04-14 14:40:02","added_by":"admin","modified_on":"2015-04-21 10:44:05","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"2.64\\"}]","total_tax":"2.64","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"16","invoice_id":"10006","type":"product","date":"2015-04-14 12:00:00","item_name":"5 PCS BRUSH [SR]","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"4.4000","price":"44.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"},{"id":"17","invoice_id":"10006","type":"product","date":"2015-04-14 12:00:00","item_name":"BRUSH [ZRL]","item_description":"","item_id":"3","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"120.0000","price":"1200.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":null,"tax_code":null}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"},"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"2","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Idea Workshop Sdn Bhd","company_registration":"676351-P","contact_person":"Shin Luis Tseng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"4-2 Jalan Telawi 2","address2":"Bangsar Baru","city":"Kuala Lumpur","state":"Kuala Lumpur","zipcode":"59100","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-02-12 14:18:13","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":null},"sale":null,"sale_items":null}', '2015-04-21 10:44:05', 'admin'),
(910, 'sales', 'add', 'invoice', 10007, '{"id":"10007","txn_no":"1-10002","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-04-21 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"asdasd","contact_id":"1","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"asdasd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"166.64","total_delivered":null,"cost":null,"tags":"","added_on":"2015-04-21 10:47:55","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"2.64\\"}]","total_tax":"2.64","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"18","invoice_id":"10007","type":"product","date":"2015-04-21 12:00:00","item_name":"BRUSH [ZRL]","item_description":"","item_id":"3","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"120.0000","price":"120.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":"ZRL"},{"id":"19","invoice_id":"10007","type":"product","date":"2015-04-21 12:00:00","item_name":"5 PCS BRUSH [SR]","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"4.4000","price":"44.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"}],"products":{"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"},"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}},"services":null,"customer":{"id":"1","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"asdasd","company_registration":"","contact_person":"asdasd","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-01-20 20:59:14","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":null},"sale":null,"sale_items":null}', '2015-04-21 10:47:55', 'admin'),
(911, 'sales', 'edit', 'invoice', 10006, '{"id":"10006","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-04-14 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Idea Workshop Sdn Bhd","contact_id":"2","contact_address":"{\\"address1\\":\\"4-2 Jalan Telawi 2\\",\\"address2\\":\\"Bangsar Baru\\",\\"zipcode\\":\\"59100\\",\\"city\\":\\"Kuala Lumpur\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Idea Workshop Sdn Bhd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"4-2 Jalan Telawi 2\\",\\"address2\\":\\"Bangsar Baru\\",\\"zipcode\\":\\"59100\\",\\"city\\":\\"Kuala Lumpur\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"46.64","total_delivered":null,"cost":null,"tags":"","added_on":"2015-04-14 14:40:02","added_by":"admin","modified_on":"2015-04-21 10:48:10","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"2.64\\"}]","total_tax":"2.64","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"20","invoice_id":"10006","type":"product","date":"2015-04-14 12:00:00","item_name":"5 PCS BRUSH [SR]","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"4.4000","price":"44.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}},"services":null,"customer":{"id":"2","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Idea Workshop Sdn Bhd","company_registration":"676351-P","contact_person":"Shin Luis Tseng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"4-2 Jalan Telawi 2","address2":"Bangsar Baru","city":"Kuala Lumpur","state":"Kuala Lumpur","zipcode":"59100","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-02-12 14:18:13","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":null},"sale":null,"sale_items":null}', '2015-04-21 10:48:10', 'admin'),
(912, 'sales', 'edit', 'invoice', 10006, '{"id":"10006","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-04-14 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Idea Workshop Sdn Bhd","contact_id":"2","contact_address":"{\\"address1\\":\\"4-2 Jalan Telawi 2\\",\\"address2\\":\\"Bangsar Baru\\",\\"zipcode\\":\\"59100\\",\\"city\\":\\"Kuala Lumpur\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Idea Workshop Sdn Bhd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"4-2 Jalan Telawi 2\\",\\"address2\\":\\"Bangsar Baru\\",\\"zipcode\\":\\"59100\\",\\"city\\":\\"Kuala Lumpur\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"166.64","total_delivered":null,"cost":null,"tags":"","added_on":"2015-04-14 14:40:02","added_by":"admin","modified_on":"2015-04-21 10:50:49","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"2.64\\"}]","total_tax":"2.64","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"22","invoice_id":"10006","type":"product","date":"2015-04-14 12:00:00","item_name":"BRUSH [ZRL]","item_description":"","item_id":"3","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"120.0000","price":"120.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":null,"tax_code":null},{"id":"21","invoice_id":"10006","type":"product","date":"2015-04-14 12:00:00","item_name":"5 PCS BRUSH [SR]","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"4.4000","price":"44.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"}],"products":{"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"},"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}},"services":null,"customer":{"id":"2","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Idea Workshop Sdn Bhd","company_registration":"676351-P","contact_person":"Shin Luis Tseng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"4-2 Jalan Telawi 2","address2":"Bangsar Baru","city":"Kuala Lumpur","state":"Kuala Lumpur","zipcode":"59100","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-02-12 14:18:13","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":null},"sale":null,"sale_items":null}', '2015-04-21 10:50:49', 'admin'),
(913, 'sales', 'edit', 'invoice', 10007, '{"id":"10007","txn_no":"1-10002","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-04-21 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"asdasd","contact_id":"1","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"asdasd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"120.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-04-21 10:47:55","added_by":"admin","modified_on":"2015-04-21 11:36:25","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"23","invoice_id":"10007","type":"product","date":"2015-04-21 12:00:00","item_name":"BRUSH [ZRL]","item_description":"","item_id":"3","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"120.0000","price":"120.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":null,"tax_code":null}],"products":{"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"1","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"asdasd","company_registration":"","contact_person":"asdasd","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-01-20 20:59:14","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":null},"sale":null,"sale_items":null}', '2015-04-21 11:36:25', 'admin'),
(914, 'sales', 'edit', 'invoice', 10007, '{"id":"10007","txn_no":"1-10002","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-04-21 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"asdasd","contact_id":"1","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"asdasd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"124.66","total_delivered":null,"cost":null,"tags":"","added_on":"2015-04-21 10:47:55","added_by":"admin","modified_on":"2015-04-21 11:38:50","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.26\\"}]","total_tax":"0.26","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"24","invoice_id":"10007","type":"product","date":"2015-04-21 12:00:00","item_name":"5 PCS BRUSH [SR]","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"4.4000","price":"4.40","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"},{"id":"25","invoice_id":"10007","type":"product","date":"2015-04-21 12:00:00","item_name":"BRUSH [ZRL]","item_description":"","item_id":"3","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"120.0000","price":"120.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"0","tax_code":"ZRL"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"},"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"1","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"asdasd","company_registration":"","contact_person":"asdasd","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-01-20 20:59:14","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":null},"sale":null,"sale_items":null}', '2015-04-21 11:38:50', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(915, 'inventory', 'add', 'po', 10009, '{"id":"10009","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-19 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-19 16:48:44","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.11\\"}]","tax_inclusive":"1","total_tax":"0.11","assigned_to":null,"orders":[{"id":"48","purchase_order_id":"10009","date":"2015-05-19 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"0","discount_type":null,"qty":"1","price_per_unit":"2.0000","price":"2.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-19 16:48:44', 'admin'),
(916, 'inventory', 'receive', 'po', 10008, '{"id":"10008","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-04-14 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"34.00","total_received":"34.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-04-14 15:05:26","added_by":"admin","modified_on":"2015-04-14 15:12:44","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"1.44\\"}]","tax_inclusive":null,"total_tax":"1.44","assigned_to":null,"orders":[{"id":"44","purchase_order_id":"10008","date":"2015-04-14 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.0000","price":"24.00","received":"12","received_price":"24.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"},{"id":"45","purchase_order_id":"10008","date":"2015-04-14 00:00:00","item_description":null,"item_name":"BRUSH (GR)","item_id":"3","discount":"0","discount_type":null,"qty":"10","price_per_unit":"1.0000","price":"10.00","received":"10","received_price":"10.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZRL"}],"products":{"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"7","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"},"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-7","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-25 14:07:54', 'admin'),
(917, 'inventory', 'status_update', 'po', 10008, '{"id":"10008","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-04-14 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"34.00","total_received":"34.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-04-14 15:05:26","added_by":"admin","modified_on":"2015-04-14 15:12:44","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"1.44\\"}]","tax_inclusive":null,"total_tax":"1.44","assigned_to":null,"orders":[{"id":"44","purchase_order_id":"10008","date":"2015-04-14 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.0000","price":"24.00","received":"12","received_price":"24.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"},{"id":"45","purchase_order_id":"10008","date":"2015-04-14 00:00:00","item_description":null,"item_name":"BRUSH (GR)","item_id":"3","discount":"0","discount_type":null,"qty":"10","price_per_unit":"1.0000","price":"10.00","received":"10","received_price":"10.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZRL"}],"products":{"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"7","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"},"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-7","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-25 14:07:54', 'admin'),
(918, 'inventory', 'status_update', 'po', 10008, '{"id":"10008","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-04-14 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"34.00","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-04-14 15:05:26","added_by":"admin","modified_on":"2015-04-14 15:12:44","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"1.44\\"}]","tax_inclusive":null,"total_tax":"1.44","assigned_to":null,"orders":[{"id":"44","purchase_order_id":"10008","date":"2015-04-14 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.0000","price":"24.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"},{"id":"45","purchase_order_id":"10008","date":"2015-04-14 00:00:00","item_description":null,"item_name":"BRUSH (GR)","item_id":"3","discount":"0","discount_type":null,"qty":"10","price_per_unit":"1.0000","price":"10.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZRL"}],"products":{"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"},"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-25 14:25:47', 'admin'),
(919, 'inventory', 'edit', 'po', NULL, '[]', '2015-05-25 14:25:59', 'admin'),
(920, 'inventory', 'receive', 'po', 10008, '{"id":"10008","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-04-14 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"RNK SUBAIDAH\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"32.90","total_received":"35.30","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-04-14 15:05:26","added_by":"admin","modified_on":"2015-05-25 14:25:59","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"1.30\\"}]","tax_inclusive":"0","total_tax":"1.30","assigned_to":null,"orders":[{"id":"46","purchase_order_id":"10008","date":"2015-04-14 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.0000","price":"24.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"},{"id":"47","purchase_order_id":"10008","date":"2015-04-14 00:00:00","item_description":null,"item_name":"BRUSH (GR)","item_id":"3","discount":"0","discount_type":null,"qty":"10","price_per_unit":"1.0000","price":"10.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZRL"}],"products":{"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"7","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"},"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-7","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-25 14:26:05', 'admin'),
(921, 'inventory', 'status_update', 'po', 10008, '{"id":"10008","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-04-14 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"RNK SUBAIDAH\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"32.90","total_received":"35.30","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-04-14 15:05:26","added_by":"admin","modified_on":"2015-05-25 14:25:59","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"1.30\\"}]","tax_inclusive":"0","total_tax":"1.30","assigned_to":null,"orders":[{"id":"46","purchase_order_id":"10008","date":"2015-04-14 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.0000","price":"24.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"},{"id":"47","purchase_order_id":"10008","date":"2015-04-14 00:00:00","item_description":null,"item_name":"BRUSH (GR)","item_id":"3","discount":"0","discount_type":null,"qty":"10","price_per_unit":"1.0000","price":"10.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZRL"}],"products":{"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"7","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"},"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-7","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-25 14:26:05', 'admin'),
(922, 'inventory', 'status_update', 'po', 10008, '{"id":"10008","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-04-14 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"RNK SUBAIDAH\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Partially Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"32.90","total_received":"35.30","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-04-14 15:05:26","added_by":"admin","modified_on":"2015-05-25 14:25:59","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"1.30\\"}]","tax_inclusive":"0","total_tax":"1.30","assigned_to":null,"orders":[{"id":"46","purchase_order_id":"10008","date":"2015-04-14 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.0000","price":"24.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"},{"id":"47","purchase_order_id":"10008","date":"2015-04-14 00:00:00","item_description":null,"item_name":"BRUSH (GR)","item_id":"3","discount":"0","discount_type":null,"qty":"10","price_per_unit":"1.0000","price":"10.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZRL"}],"products":{"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"7","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"},"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-7","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-25 14:26:26', 'admin'),
(923, 'inventory', 'status_update', 'po', 10008, '{"id":"10008","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-04-14 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"RNK SUBAIDAH\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"32.90","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-04-14 15:05:26","added_by":"admin","modified_on":"2015-05-25 14:25:59","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"1.30\\"}]","tax_inclusive":"0","total_tax":"1.30","assigned_to":null,"orders":[{"id":"44","purchase_order_id":"10008","date":"2015-04-14 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"0","discount_type":null,"qty":"12","price_per_unit":"2.0000","price":"24.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"},{"id":"45","purchase_order_id":"10008","date":"2015-04-14 00:00:00","item_description":null,"item_name":"BRUSH (GR)","item_id":"3","discount":"0","discount_type":null,"qty":"10","price_per_unit":"1.0000","price":"10.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZRL"}],"products":{"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"},"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-25 14:26:41', 'admin'),
(924, 'inventory', 'edit', 'po', NULL, '[]', '2015-05-25 14:27:01', 'admin'),
(925, 'inventory', 'edit', 'po', NULL, '[]', '2015-05-25 14:27:20', 'admin'),
(926, 'inventory', 'delete', 'po', 10008, '{"id":"10008","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-04-14 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"RNK SUBAIDAH\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"35.44","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-04-14 15:05:26","added_by":"admin","modified_on":"2015-05-25 14:27:20","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"orders":null,"products":null}', '2015-05-25 14:32:20', 'admin'),
(927, 'inventory', 'delete', 'po', 10009, '{"id":"10009","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-19 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-19 16:48:44","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.11\\"}]","tax_inclusive":"1","total_tax":"0.11","assigned_to":null,"orders":[{"id":"48","purchase_order_id":"10009","date":"2015-05-19 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"0","discount_type":null,"qty":"1","price_per_unit":"2.0000","price":"2.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-25 14:32:22', 'admin'),
(928, 'inventory', 'add', 'po', 10010, '{"id":"10010","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-25 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"31.20","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-25 14:34:07","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"1.20\\"}]","tax_inclusive":"0","total_tax":"1.20","assigned_to":null,"orders":[{"id":"55","purchase_order_id":"10010","date":"2015-05-25 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"0","discount_type":null,"qty":"10","price_per_unit":"2.0000","price":"20.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"},{"id":"56","purchase_order_id":"10010","date":"2015-05-25 00:00:00","item_description":null,"item_name":"BRUSH (GR)","item_id":"3","discount":"0","discount_type":null,"qty":"10","price_per_unit":"1.0000","price":"10.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZRL"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"},"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-05-25 14:34:07', 'admin'),
(929, 'inventory', 'edit', 'po', NULL, '[]', '2015-05-25 14:34:30', 'admin'),
(930, 'inventory', 'edit', 'po', NULL, '[]', '2015-05-25 14:34:39', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(931, 'inventory', 'receive', 'po', 10010, '{"id":"10010","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-25 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"RNK SUBAIDAH\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"28.08","total_received":"28.08","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-25 14:34:07","added_by":"admin","modified_on":"2015-05-25 14:34:39","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"1.08\\"}]","tax_inclusive":"0","total_tax":"1.08","assigned_to":null,"orders":[{"id":"59","purchase_order_id":"10010","date":"2015-05-25 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"10","discount_type":"p","qty":"10","price_per_unit":"2.0000","price":"20.00","received":"10","received_price":"18.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"},{"id":"60","purchase_order_id":"10010","date":"2015-05-25 00:00:00","item_description":null,"item_name":"BRUSH (GR)","item_id":"3","discount":"10","discount_type":"p","qty":"10","price_per_unit":"1.0000","price":"10.00","received":"10","received_price":"9.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZRL"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-9","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"},"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"7","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-05-25 14:35:01', 'admin'),
(932, 'inventory', 'status_update', 'po', 10010, '{"id":"10010","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-25 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"RNK SUBAIDAH\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"28.08","total_received":"28.08","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-25 14:34:07","added_by":"admin","modified_on":"2015-05-25 14:34:39","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"1.08\\"}]","tax_inclusive":"0","total_tax":"1.08","assigned_to":null,"orders":[{"id":"59","purchase_order_id":"10010","date":"2015-05-25 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"10","discount_type":"p","qty":"10","price_per_unit":"2.0000","price":"20.00","received":"10","received_price":"18.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"},{"id":"60","purchase_order_id":"10010","date":"2015-05-25 00:00:00","item_description":null,"item_name":"BRUSH (GR)","item_id":"3","discount":"10","discount_type":"p","qty":"10","price_per_unit":"1.0000","price":"10.00","received":"10","received_price":"9.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZRL"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-9","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"},"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"7","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-05-25 14:35:01', 'admin'),
(933, 'inventory', 'status_update', 'po', 10010, '{"id":"10010","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-25 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"RNK SUBAIDAH\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Partially Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"28.08","total_received":"28.08","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-25 14:34:07","added_by":"admin","modified_on":"2015-05-25 14:34:39","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"1.08\\"}]","tax_inclusive":"0","total_tax":"1.08","assigned_to":null,"orders":[{"id":"59","purchase_order_id":"10010","date":"2015-05-25 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"10","discount_type":"p","qty":"10","price_per_unit":"2.0000","price":"20.00","received":"10","received_price":"18.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"},{"id":"60","purchase_order_id":"10010","date":"2015-05-25 00:00:00","item_description":null,"item_name":"BRUSH (GR)","item_id":"3","discount":"10","discount_type":"p","qty":"10","price_per_unit":"1.0000","price":"10.00","received":"10","received_price":"9.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZRL"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-9","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"},"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"7","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-05-25 14:48:42', 'admin'),
(934, 'inventory', 'status_update', 'po', 10010, '{"id":"10010","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-25 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"RNK SUBAIDAH\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"28.08","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-25 14:34:07","added_by":"admin","modified_on":"2015-05-25 14:34:39","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"1.08\\"}]","tax_inclusive":"0","total_tax":"1.08","assigned_to":null,"orders":[{"id":"59","purchase_order_id":"10010","date":"2015-05-25 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"10","discount_type":"p","qty":"10","price_per_unit":"2.0000","price":"20.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"},{"id":"60","purchase_order_id":"10010","date":"2015-05-25 00:00:00","item_description":null,"item_name":"BRUSH (GR)","item_id":"3","discount":"10","discount_type":"p","qty":"10","price_per_unit":"1.0000","price":"10.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZRL"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"},"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-05-25 14:48:47', 'admin'),
(935, 'inventory', 'delete', 'po', 10010, '{"id":"10010","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-25 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"RNK SUBAIDAH\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"28.08","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-25 14:34:07","added_by":"admin","modified_on":"2015-05-25 14:34:39","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"1.08\\"}]","tax_inclusive":"0","total_tax":"1.08","assigned_to":null,"orders":[{"id":"59","purchase_order_id":"10010","date":"2015-05-25 00:00:00","item_description":null,"item_name":"5 PCS BRUSH (SET)","item_id":"2","discount":"10","discount_type":"p","qty":"10","price_per_unit":"2.0000","price":"20.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"},{"id":"60","purchase_order_id":"10010","date":"2015-05-25 00:00:00","item_description":null,"item_name":"BRUSH (GR)","item_id":"3","discount":"10","discount_type":"p","qty":"10","price_per_unit":"1.0000","price":"10.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZRL"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"},"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-05-31 11:57:55', 'admin'),
(936, 'sales', 'delete', 'invoice', 10006, '{"id":"10006","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-04-14 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Idea Workshop Sdn Bhd","contact_id":"2","contact_address":"{\\"address1\\":\\"4-2 Jalan Telawi 2\\",\\"address2\\":\\"Bangsar Baru\\",\\"zipcode\\":\\"59100\\",\\"city\\":\\"Kuala Lumpur\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Idea Workshop Sdn Bhd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"4-2 Jalan Telawi 2\\",\\"address2\\":\\"Bangsar Baru\\",\\"zipcode\\":\\"59100\\",\\"city\\":\\"Kuala Lumpur\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"166.64","total_delivered":null,"cost":null,"tags":"","added_on":"2015-04-14 14:40:02","added_by":"admin","modified_on":"2015-04-21 10:50:49","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"2.64\\"}]","total_tax":"2.64","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"22","invoice_id":"10006","type":"product","date":"2015-04-14 12:00:00","item_name":"BRUSH [ZRL]","item_description":"","item_id":"3","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"120.0000","price":"120.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"0","tax_code":"ZRL"},{"id":"21","invoice_id":"10006","type":"product","date":"2015-04-14 12:00:00","item_name":"5 PCS BRUSH [SR]","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"4.4000","price":"44.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"}],"products":{"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"},"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}},"services":null,"customer":{"id":"2","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Idea Workshop Sdn Bhd","company_registration":"676351-P","contact_person":"Shin Luis Tseng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"4-2 Jalan Telawi 2","address2":"Bangsar Baru","city":"Kuala Lumpur","state":"Kuala Lumpur","zipcode":"59100","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-02-12 14:18:13","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":null},"sale":null,"sale_items":null}', '2015-05-31 11:58:01', 'admin'),
(937, 'sales', 'delete', 'invoice', 10007, '{"id":"10007","txn_no":"1-10002","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-04-21 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"asdasd","contact_id":"1","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"asdasd\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"124.66","total_delivered":null,"cost":null,"tags":"","added_on":"2015-04-21 10:47:55","added_by":"admin","modified_on":"2015-04-21 11:38:50","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.26\\"}]","total_tax":"0.26","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"24","invoice_id":"10007","type":"product","date":"2015-04-21 12:00:00","item_name":"5 PCS BRUSH [SR]","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"4.4000","price":"4.40","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"},{"id":"25","invoice_id":"10007","type":"product","date":"2015-04-21 12:00:00","item_name":"BRUSH [ZRL]","item_description":"","item_id":"3","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"120.0000","price":"120.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"0","tax_code":"ZRL"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"5 PCS BRUSH","model_no":"","warranty":"","sku":"9555070700059","sku2":"","sku3":"","sku4":"","qty":"-19","alert_quantity":"-1","max_quantity":"0","cost":"0.00","average_cost":null,"price":"4.40","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/5","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-04-09 16:30:32","modified_by":"admin","redeemable":"1","redeem_points":"100","current_po":null,"current_po_item":null,"uom1":"SET","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-14 12:04:34","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"},"3":{"id":"3","primary_image":null,"image":null,"category":"","subcategory":"","brand":"","location":"","name":"BRUSH","model_no":"","warranty":"","sku":"9555070700066","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"-1","max_quantity":"0","cost":"1.00","average_cost":null,"price":"120.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"105\\/A","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":null,"added_by":null,"modified_on":"2015-03-22 10:52:58","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"GR","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-04-01 12:18:39","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"1","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"asdasd","company_registration":"","contact_person":"asdasd","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-01-20 20:59:14","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":null},"sale":null,"sale_items":null}', '2015-05-31 11:58:03', 'admin'),
(938, 'inventory', 'add', 'item', NULL, '[]', '2015-05-31 14:09:03', 'admin'),
(939, 'inventory', 'add', 'item', NULL, '[]', '2015-05-31 14:09:23', 'admin'),
(940, 'contacts', 'delete', 'contact', 1, '{"id":"1","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"asdasd","company_registration":"","contact_person":"asdasd","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-01-20 20:59:14","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":null}', '2015-05-31 14:15:48', 'admin'),
(941, 'contacts', 'delete', 'contact', 2, '{"id":"2","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Idea Workshop Sdn Bhd","company_registration":"676351-P","contact_person":"Shin Luis Tseng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"4-2 Jalan Telawi 2","address2":"Bangsar Baru","city":"Kuala Lumpur","state":"Kuala Lumpur","zipcode":"59100","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-02-12 14:18:13","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":null}', '2015-05-31 14:15:51', 'admin'),
(942, 'contacts', 'add', 'contact', 3, '{"id":"3","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"TEST SUPPLIER","company_registration":"","contact_person":"TEST SUPPLIER","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-05-31 14:16:04","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-05-31 14:16:04', 'admin'),
(943, 'inventory', 'add', 'po', 10011, '{"id":"10011","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-01 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"100.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 14:18:05","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"orders":[{"id":"63","purchase_order_id":"10011","date":"2015-05-01 00:00:00","item_description":null,"item_name":"ZERO RATED ITEM ()","item_id":"1","discount":"0","discount_type":null,"qty":"10","price_per_unit":"10.0000","price":"100.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZRL"}],"products":{"1":{"id":"1","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"ZERO RATED ITEM","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"-7","alert_quantity":"1","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:03","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"ZP","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-05-31 14:18:05', 'admin'),
(944, 'inventory', 'receive', 'po', 10011, '{"id":"10011","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-01 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"100.00","total_received":"100.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 14:18:05","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"orders":[{"id":"63","purchase_order_id":"10011","date":"2015-05-01 00:00:00","item_description":null,"item_name":"ZERO RATED ITEM ()","item_id":"1","discount":"0","discount_type":null,"qty":"10","price_per_unit":"10.0000","price":"100.00","received":"10","received_price":"100.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZRL"}],"products":{"1":{"id":"1","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"ZERO RATED ITEM","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"3","alert_quantity":"1","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:03","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"ZP","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-05-31 14:18:17', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(945, 'inventory', 'status_update', 'po', 10011, '{"id":"10011","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-01 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"100.00","total_received":"100.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 14:18:05","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"orders":[{"id":"63","purchase_order_id":"10011","date":"2015-05-01 00:00:00","item_description":null,"item_name":"ZERO RATED ITEM ()","item_id":"1","discount":"0","discount_type":null,"qty":"10","price_per_unit":"10.0000","price":"100.00","received":"10","received_price":"100.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZRL"}],"products":{"1":{"id":"1","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"ZERO RATED ITEM","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"3","alert_quantity":"1","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:03","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"ZP","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-05-31 14:18:17', 'admin'),
(946, 'inventory', 'add', 'po', 10012, '{"id":"10012","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-02 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"200.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 14:19:02","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"11.32\\"}]","tax_inclusive":"1","total_tax":"11.32","assigned_to":null,"orders":[{"id":"64","purchase_order_id":"10012","date":"2015-05-02 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"13","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-31 14:19:02', 'admin'),
(947, 'inventory', 'edit', 'po', NULL, '[]', '2015-05-31 14:19:09', 'admin'),
(948, 'inventory', 'edit', 'po', NULL, '[]', '2015-05-31 14:19:25', 'admin'),
(949, 'inventory', 'receive', 'po', 10012, '{"id":"10012","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-02 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"200.00","total_received":"200.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 14:19:02","added_by":"admin","modified_on":"2015-05-31 14:19:25","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"11.32\\"}]","tax_inclusive":"1","total_tax":"11.32","assigned_to":null,"orders":[{"id":"64","purchase_order_id":"10012","date":"2015-05-02 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"20","received_price":"200.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"33","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-31 14:21:45', 'admin'),
(950, 'inventory', 'status_update', 'po', 10012, '{"id":"10012","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-02 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"200.00","total_received":"200.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 14:19:02","added_by":"admin","modified_on":"2015-05-31 14:19:25","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"11.32\\"}]","tax_inclusive":"1","total_tax":"11.32","assigned_to":null,"orders":[{"id":"64","purchase_order_id":"10012","date":"2015-05-02 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"20","received_price":"200.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"33","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-31 14:21:45', 'admin'),
(951, 'inventory', 'status_update', 'po', 10012, '{"id":"10012","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-02 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"200.00","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 14:19:02","added_by":"admin","modified_on":"2015-05-31 14:19:25","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"11.32\\"}]","tax_inclusive":"1","total_tax":"11.32","assigned_to":null,"orders":[{"id":"64","purchase_order_id":"10012","date":"2015-05-02 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"13","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-31 14:21:51', 'admin'),
(952, 'inventory', 'edit', 'po', NULL, '[]', '2015-05-31 14:21:58', 'admin'),
(953, 'inventory', 'receive', 'po', 10012, '{"id":"10012","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-02 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"212.00","total_received":"212.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 14:19:02","added_by":"admin","modified_on":"2015-05-31 14:21:58","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"12.00\\"}]","tax_inclusive":"0","total_tax":"12.00","assigned_to":null,"orders":[{"id":"65","purchase_order_id":"10012","date":"2015-05-02 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"33","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-31 14:22:03', 'admin'),
(954, 'inventory', 'status_update', 'po', 10012, '{"id":"10012","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-02 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"212.00","total_received":"212.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 14:19:02","added_by":"admin","modified_on":"2015-05-31 14:21:58","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"12.00\\"}]","tax_inclusive":"0","total_tax":"12.00","assigned_to":null,"orders":[{"id":"65","purchase_order_id":"10012","date":"2015-05-02 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"33","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-31 14:22:03', 'admin'),
(955, 'inventory', 'status_update', 'po', 10012, '{"id":"10012","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-02 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"212.00","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 14:19:02","added_by":"admin","modified_on":"2015-05-31 14:21:58","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"12.00\\"}]","tax_inclusive":"0","total_tax":"12.00","assigned_to":null,"orders":[{"id":"64","purchase_order_id":"10012","date":"2015-05-02 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"13","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-31 14:22:19', 'admin'),
(956, 'inventory', 'receive', 'po', 10012, '{"id":"10012","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-02 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"212.00","total_received":"212.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 14:19:02","added_by":"admin","modified_on":"2015-05-31 14:21:58","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"12.00\\"}]","tax_inclusive":"0","total_tax":"12.00","assigned_to":null,"orders":[{"id":"65","purchase_order_id":"10012","date":"2015-05-02 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"33","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-31 14:22:25', 'admin'),
(957, 'inventory', 'status_update', 'po', 10012, '{"id":"10012","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-02 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"212.00","total_received":"212.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 14:19:02","added_by":"admin","modified_on":"2015-05-31 14:21:58","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"12.00\\"}]","tax_inclusive":"0","total_tax":"12.00","assigned_to":null,"orders":[{"id":"65","purchase_order_id":"10012","date":"2015-05-02 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"33","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-31 14:22:26', 'admin'),
(958, 'inventory', 'status_update', 'po', 10012, '{"id":"10012","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-02 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"212.00","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 14:19:02","added_by":"admin","modified_on":"2015-05-31 14:21:58","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"12.00\\"}]","tax_inclusive":"0","total_tax":"12.00","assigned_to":null,"orders":[{"id":"64","purchase_order_id":"10012","date":"2015-05-02 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"-6","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-31 14:24:38', 'admin'),
(959, 'inventory', 'receive', 'po', 10012, '{"id":"10012","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-02 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"212.00","total_received":"212.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 14:19:02","added_by":"admin","modified_on":"2015-05-31 14:21:58","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"12.00\\"}]","tax_inclusive":"0","total_tax":"12.00","assigned_to":null,"orders":[{"id":"64","purchase_order_id":"10012","date":"2015-05-02 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"20","received_price":"200.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"14","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-31 14:24:44', 'admin'),
(960, 'inventory', 'status_update', 'po', 10012, '{"id":"10012","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-02 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Partially Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"212.00","total_received":"212.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 14:19:02","added_by":"admin","modified_on":"2015-05-31 14:21:58","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"12.00\\"}]","tax_inclusive":"0","total_tax":"12.00","assigned_to":null,"orders":[{"id":"64","purchase_order_id":"10012","date":"2015-05-02 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"20","received_price":"200.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"14","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-31 14:24:44', 'admin'),
(961, 'inventory', 'receive', 'po', 10012, '{"id":"10012","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-02 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Partially Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"212.00","total_received":"212.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 14:19:02","added_by":"admin","modified_on":"2015-05-31 14:21:58","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"12.00\\"}]","tax_inclusive":"0","total_tax":"12.00","assigned_to":null,"orders":[{"id":"64","purchase_order_id":"10012","date":"2015-05-02 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"20","received_price":"200.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"14","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-31 14:24:47', 'admin'),
(962, 'inventory', 'status_update', 'po', 10012, '{"id":"10012","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-02 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"212.00","total_received":"212.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 14:19:02","added_by":"admin","modified_on":"2015-05-31 14:21:58","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"12.00\\"}]","tax_inclusive":"0","total_tax":"12.00","assigned_to":null,"orders":[{"id":"64","purchase_order_id":"10012","date":"2015-05-02 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"20","received_price":"200.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"14","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-31 14:24:47', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(963, 'inventory', 'add', 'po', 10013, '{"id":"10013","txn_no":"1-10003","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-31 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"90.22","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 18:28:16","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"5.11\\"}]","tax_inclusive":"0","total_tax":"5.11","assigned_to":null,"orders":[{"id":"68","purchase_order_id":"10013","date":"2015-05-31 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"1","price_per_unit":"85.1100","price":"85.11","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"14","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-31 18:28:16', 'admin'),
(964, 'inventory', 'receive', 'po', 10013, '{"id":"10013","txn_no":"1-10003","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-31 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"90.22","total_received":"90.22","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 18:28:16","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"5.11\\"}]","tax_inclusive":"0","total_tax":"5.11","assigned_to":null,"orders":[{"id":"68","purchase_order_id":"10013","date":"2015-05-31 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"1","price_per_unit":"85.1100","price":"85.11","received":"1","received_price":"85.11","done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"15","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-31 19:17:53', 'admin'),
(965, 'inventory', 'status_update', 'po', 10013, '{"id":"10013","txn_no":"1-10003","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-31 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"90.22","total_received":"90.22","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 18:28:16","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"5.11\\"}]","tax_inclusive":"0","total_tax":"5.11","assigned_to":null,"orders":[{"id":"68","purchase_order_id":"10013","date":"2015-05-31 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"1","price_per_unit":"85.1100","price":"85.11","received":"1","received_price":"85.11","done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"15","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-31 19:17:53', 'admin'),
(966, 'inventory', 'add', 'po', 10014, '{"id":"10014","txn_no":"1-10004","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-10 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"412.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 19:23:06","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"12.00\\"}]","tax_inclusive":"0","total_tax":"12.00","assigned_to":null,"orders":[{"id":"69","purchase_order_id":"10014","date":"2015-05-10 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"},{"id":"70","purchase_order_id":"10014","date":"2015-05-10 00:00:00","item_description":null,"item_name":"ZERO RATED ITEM ()","item_id":"1","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZRL"}],"products":{"1":{"id":"1","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"ZERO RATED ITEM","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"3","alert_quantity":"1","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:03","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"ZP","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"},"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"15","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-31 19:23:06', 'admin'),
(967, 'inventory', 'receive', 'po', 10014, '{"id":"10014","txn_no":"1-10004","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-10 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"412.00","total_received":"412.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 19:23:06","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"12.00\\"}]","tax_inclusive":"0","total_tax":"12.00","assigned_to":null,"orders":[{"id":"69","purchase_order_id":"10014","date":"2015-05-10 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"20","received_price":"200.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"},{"id":"70","purchase_order_id":"10014","date":"2015-05-10 00:00:00","item_description":null,"item_name":"ZERO RATED ITEM ()","item_id":"1","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"20","received_price":"200.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZRL"}],"products":{"1":{"id":"1","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"ZERO RATED ITEM","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"23","alert_quantity":"1","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:03","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"ZP","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"},"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"35","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-31 19:23:12', 'admin'),
(968, 'inventory', 'status_update', 'po', 10014, '{"id":"10014","txn_no":"1-10004","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-10 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"412.00","total_received":"412.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 19:23:06","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"12.00\\"}]","tax_inclusive":"0","total_tax":"12.00","assigned_to":null,"orders":[{"id":"69","purchase_order_id":"10014","date":"2015-05-10 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"20","received_price":"200.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"SR"},{"id":"70","purchase_order_id":"10014","date":"2015-05-10 00:00:00","item_description":null,"item_name":"ZERO RATED ITEM ()","item_id":"1","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"20","received_price":"200.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZRL"}],"products":{"1":{"id":"1","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"ZERO RATED ITEM","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"23","alert_quantity":"1","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:03","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"ZP","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"},"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"35","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-05-31 19:23:12', 'admin'),
(969, 'contacts', 'add', 'contact', 4, '{"id":"4","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"IT SOFTWARE APPLICATION SERVICES SDN BHD","company_registration":"","contact_person":"MR RAJALUDIN","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"7090, Jalan Bagan Ajam","address2":"","city":"Butterworth","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-03 14:01:49","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-06-03 14:01:49', 'admin'),
(970, 'sales', 'add', 'invoice', 10008, '{"id":"10008","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-05-10 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"IT SOFTWARE APPLICATION SERVICES SDN BHD","contact_id":"4","contact_address":"{\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"IT SOFTWARE APPLICATION SERVICES SDN BHD\\",\\"mobile\\":\\"\\",\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1750.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-06-03 14:02:52","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"26","invoice_id":"10008","type":"service","date":"2015-05-10 12:00:00","item_name":"Plexcloud Point-of-Sale Installation x 2 Units","item_description":"","item_id":"0","service_id":"10002","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1750.0000","price":"1750.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":null,"services":{"10002":{"id":"10002","name":"Website Design","description":"","category":"0","subcategory":"0","cost":"0.00","price":"1000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-02-12 14:19:10","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"4","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"IT SOFTWARE APPLICATION SERVICES SDN BHD","company_registration":"","contact_person":"MR RAJALUDIN","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"7090, Jalan Bagan Ajam","address2":"","city":"Butterworth","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-03 14:01:49","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-06-03 14:02:52', 'admin'),
(971, 'sales', 'add', 'invoice', 10009, '{"id":"10009","txn_no":"1-10002","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-06-03 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"IT SOFTWARE APPLICATION SERVICES SDN BHD","contact_id":"4","contact_address":"{\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"IT SOFTWARE APPLICATION SERVICES SDN BHD\\",\\"mobile\\":\\"\\",\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1750.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-06-03 14:03:15","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"27","invoice_id":"10009","type":"service","date":"2015-06-03 12:00:00","item_name":"Plexcloud Point-of-Sale Installation x 2 Units","item_description":"","item_id":"0","service_id":"10002","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1750.0000","price":"1750.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":null,"services":{"10002":{"id":"10002","name":"Website Design","description":"","category":"0","subcategory":"0","cost":"0.00","price":"1000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-02-12 14:19:10","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"4","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"IT SOFTWARE APPLICATION SERVICES SDN BHD","company_registration":"","contact_person":"MR RAJALUDIN","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"7090, Jalan Bagan Ajam","address2":"","city":"Butterworth","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-03 14:01:49","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-06-03 14:03:15', 'admin'),
(972, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"0","inclusive":"0"}', '2015-06-03 14:04:02', 'admin'),
(973, 'sales', 'edit', 'invoice', 10009, '{"id":"10009","txn_no":"1-10202","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-06-03 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"IT SOFTWARE APPLICATION SERVICES SDN BHD","contact_id":"4","contact_address":"{\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"IT SOFTWARE APPLICATION SERVICES SDN BHD\\",\\"mobile\\":\\"\\",\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1750.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-06-03 14:03:15","added_by":"admin","modified_on":"2015-06-03 14:04:28","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"28","invoice_id":"10009","type":"service","date":"2015-06-03 12:00:00","item_name":"Plexcloud Point-of-Sale Installation x 2 Units","item_description":"","item_id":"0","service_id":"10002","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1750.0000","price":"1750.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"0","tax_code":""}],"products":null,"services":{"10002":{"id":"10002","name":"Website Design","description":"","category":"0","subcategory":"0","cost":"0.00","price":"1000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-02-12 14:19:10","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"4","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"IT SOFTWARE APPLICATION SERVICES SDN BHD","company_registration":"","contact_person":"MR RAJALUDIN","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"7090, Jalan Bagan Ajam","address2":"","city":"Butterworth","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-03 14:01:49","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-06-03 14:04:28', 'admin'),
(974, 'sales', 'edit', 'invoice', 10008, '{"id":"10008","txn_no":"1-10201","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-05-10 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"IT SOFTWARE APPLICATION SERVICES SDN BHD","contact_id":"4","contact_address":"{\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"IT SOFTWARE APPLICATION SERVICES SDN BHD\\",\\"mobile\\":\\"\\",\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1750.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-06-03 14:02:52","added_by":"admin","modified_on":"2015-06-03 14:04:35","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"29","invoice_id":"10008","type":"service","date":"2015-05-10 12:00:00","item_name":"Plexcloud Point-of-Sale Installation x 2 Units","item_description":"","item_id":"0","service_id":"10002","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1750.0000","price":"1750.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"0","tax_code":""}],"products":null,"services":{"10002":{"id":"10002","name":"Website Design","description":"","category":"0","subcategory":"0","cost":"0.00","price":"1000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-02-12 14:19:10","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"4","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"IT SOFTWARE APPLICATION SERVICES SDN BHD","company_registration":"","contact_person":"MR RAJALUDIN","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"7090, Jalan Bagan Ajam","address2":"","city":"Butterworth","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-03 14:01:49","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-06-03 14:04:35', 'admin'),
(975, 'contacts', 'add', 'contact', 5, '{"id":"5","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"TEST CUSTOMER","contact_number":"123456789","credit_limit":"0.00","rank":"NORMAL MEMBER","email":"","ic":"123456789","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-08 12:15:53","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-06-08 12:15:53', 'admin'),
(976, 'inventory', 'edit', 'item', 1, '{"id":"1","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"ZERO RATED ITEM","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"23","alert_quantity":"1","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"18.00","price_3":"16.00","price_4":"15.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:03","added_by":"admin","modified_on":"2015-06-09 21:28:11","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"ZP","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}', '2015-06-09 21:28:11', 'admin'),
(977, 'inventory', 'edit', 'item', 2, '{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"35","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"13.00","price_3":"12.00","price_4":"11.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":"2015-06-09 21:28:21","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-05-31 14:15:05","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}', '2015-06-09 21:28:21', 'admin'),
(978, 'contacts', 'edit', 'contact', 6, '{"id":"6","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"TEST","contact_number":"12345","credit_limit":"0.00","rank":"NORMAL MEMBER","email":"","ic":"12345","password":null,"introducer_ic":null,"address1":"","address2":"","city":"","state":"0","zipcode":"","country":"0","tel":"12345","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-09 21:28:56","added_by":"admin","modified_on":"2015-06-09 21:29:14","modified_by":"admin","status":"Active","user_type":"0","user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-06-09 21:29:14', 'admin'),
(979, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"0"}', '2015-06-10 22:23:09', 'admin'),
(980, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"0","inclusive":"0"}', '2015-06-10 22:30:19', 'admin'),
(981, 'contacts', 'delete', 'contact', 6, '{"id":"6","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"TEST","contact_number":"12345","credit_limit":"0.00","rank":"NORMAL MEMBER","email":"","ic":"12345","password":null,"introducer_ic":null,"address1":"","address2":"","city":"","state":"0","zipcode":"","country":"0","tel":"12345","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-09 21:28:56","added_by":"admin","modified_on":"2015-06-09 21:29:14","modified_by":"admin","status":"Active","user_type":"0","user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-06-13 09:54:45', 'admin'),
(982, 'contacts', 'add', 'contact', 7, '{"id":"7","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"D AVENUE TECHNOLOGIES SDN BHD","company_registration":"","contact_person":"Bee Leng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Unit B-2-11 Block B, No 2 Jalan PJU 1A\\/7A","address2":"Ara Damansara","city":"Petaling Jaya","state":"Selangor","zipcode":"47301","country":"Malaysia","tel":"+603 7832 1113","fax":"+603 7832 1138","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-24 11:24:24","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-06-24 11:24:24', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(983, 'sales', 'deliver', 'invoice', 10009, '{"id":"10009","txn_no":"1-10202","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-06-03 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"IT SOFTWARE APPLICATION SERVICES SDN BHD","contact_id":"4","contact_address":"{\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"IT SOFTWARE APPLICATION SERVICES SDN BHD\\",\\"mobile\\":\\"\\",\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1750.00","total_delivered":"1750.00","cost":null,"tags":"","added_on":"2015-06-03 14:03:15","added_by":"admin","modified_on":"2015-06-03 14:04:28","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"28","invoice_id":"10009","type":"service","date":"2015-06-03 12:00:00","item_name":"Plexcloud Point-of-Sale Installation x 2 Units","item_description":"","item_id":"0","service_id":"10002","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1750.0000","price":"1750.00","cost":null,"margin":null,"delivered":"1","delivered_price":"1750.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"0","tax_code":""}],"products":null,"services":{"10002":{"id":"10002","name":"Website Design","description":"","category":"0","subcategory":"0","cost":"0.00","price":"1000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-02-12 14:19:10","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"4","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"IT SOFTWARE APPLICATION SERVICES SDN BHD","company_registration":"","contact_person":"MR RAJALUDIN","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"7090, Jalan Bagan Ajam","address2":"","city":"Butterworth","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-03 14:01:49","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-06-24 11:24:41', 'admin'),
(984, 'sales', 'status_update', 'invoice', 10009, '{"id":"10009","txn_no":"1-10202","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-06-03 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"IT SOFTWARE APPLICATION SERVICES SDN BHD","contact_id":"4","contact_address":"{\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"IT SOFTWARE APPLICATION SERVICES SDN BHD\\",\\"mobile\\":\\"\\",\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1750.00","total_delivered":"1750.00","cost":null,"tags":"","added_on":"2015-06-03 14:03:15","added_by":"admin","modified_on":"2015-06-03 14:04:28","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"28","invoice_id":"10009","type":"service","date":"2015-06-03 12:00:00","item_name":"Plexcloud Point-of-Sale Installation x 2 Units","item_description":"","item_id":"0","service_id":"10002","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1750.0000","price":"1750.00","cost":null,"margin":null,"delivered":"1","delivered_price":"1750.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"0","tax_code":""}],"products":null,"services":{"10002":{"id":"10002","name":"Website Design","description":"","category":"0","subcategory":"0","cost":"0.00","price":"1000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-02-12 14:19:10","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"4","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"IT SOFTWARE APPLICATION SERVICES SDN BHD","company_registration":"","contact_person":"MR RAJALUDIN","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"7090, Jalan Bagan Ajam","address2":"","city":"Butterworth","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-03 14:01:49","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-06-24 11:24:43', 'admin'),
(985, 'sales', 'deliver', 'invoice', 10008, '{"id":"10008","txn_no":"1-10201","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-05-10 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"IT SOFTWARE APPLICATION SERVICES SDN BHD","contact_id":"4","contact_address":"{\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"IT SOFTWARE APPLICATION SERVICES SDN BHD\\",\\"mobile\\":\\"\\",\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1750.00","total_delivered":"1750.00","cost":null,"tags":"","added_on":"2015-06-03 14:02:52","added_by":"admin","modified_on":"2015-06-03 14:04:35","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"29","invoice_id":"10008","type":"service","date":"2015-05-10 12:00:00","item_name":"Plexcloud Point-of-Sale Installation x 2 Units","item_description":"","item_id":"0","service_id":"10002","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1750.0000","price":"1750.00","cost":null,"margin":null,"delivered":"1","delivered_price":"1750.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"0","tax_code":""}],"products":null,"services":{"10002":{"id":"10002","name":"Website Design","description":"","category":"0","subcategory":"0","cost":"0.00","price":"1000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-02-12 14:19:10","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"4","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"IT SOFTWARE APPLICATION SERVICES SDN BHD","company_registration":"","contact_person":"MR RAJALUDIN","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"7090, Jalan Bagan Ajam","address2":"","city":"Butterworth","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-03 14:01:49","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-06-24 11:24:55', 'admin'),
(986, 'sales', 'status_update', 'invoice', 10008, '{"id":"10008","txn_no":"1-10201","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-05-10 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"IT SOFTWARE APPLICATION SERVICES SDN BHD","contact_id":"4","contact_address":"{\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"IT SOFTWARE APPLICATION SERVICES SDN BHD\\",\\"mobile\\":\\"\\",\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1750.00","total_delivered":"1750.00","cost":null,"tags":"","added_on":"2015-06-03 14:02:52","added_by":"admin","modified_on":"2015-06-03 14:04:35","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"29","invoice_id":"10008","type":"service","date":"2015-05-10 12:00:00","item_name":"Plexcloud Point-of-Sale Installation x 2 Units","item_description":"","item_id":"0","service_id":"10002","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1750.0000","price":"1750.00","cost":null,"margin":null,"delivered":"1","delivered_price":"1750.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"0","tax_code":""}],"products":null,"services":{"10002":{"id":"10002","name":"Website Design","description":"","category":"0","subcategory":"0","cost":"0.00","price":"1000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-02-12 14:19:10","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"4","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"IT SOFTWARE APPLICATION SERVICES SDN BHD","company_registration":"","contact_person":"MR RAJALUDIN","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"7090, Jalan Bagan Ajam","address2":"","city":"Butterworth","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-03 14:01:49","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-06-24 11:24:58', 'admin'),
(987, 'sales', 'add', 'invoice', 10010, '{"id":"10010","txn_no":"1-10203","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-06-23 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"D AVENUE TECHNOLOGIES SDN BHD","contact_id":"7","contact_address":"{\\"address1\\":\\"Unit B-2-11 Block B, No 2 Jalan PJU 1A\\\\\\/7A\\",\\"address2\\":\\"Ara Damansara\\",\\"zipcode\\":\\"47301\\",\\"city\\":\\"Petaling Jaya\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"D AVENUE TECHNOLOGIES SDN BHD\\",\\"mobile\\":\\"+603 7832 1113\\",\\"address1\\":\\"Unit B-2-11 Block B, No 2 Jalan PJU 1A\\\\\\/7A\\",\\"address2\\":\\"Ara Damansara\\",\\"zipcode\\":\\"47301\\",\\"city\\":\\"Petaling Jaya\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-06-24 11:25:44","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"30","invoice_id":"10010","type":"service","date":"2015-06-23 12:00:00","item_name":"On-Site Registration System for eRezeki","item_description":"- Web-based\\n- iPad Optimized","item_id":"0","service_id":"10002","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"500.0000","price":"500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":null,"services":{"10002":{"id":"10002","name":"Website Design","description":"","category":"0","subcategory":"0","cost":"0.00","price":"1000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-02-12 14:19:10","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"7","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"D AVENUE TECHNOLOGIES SDN BHD","company_registration":"","contact_person":"Bee Leng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Unit B-2-11 Block B, No 2 Jalan PJU 1A\\/7A","address2":"Ara Damansara","city":"Petaling Jaya","state":"Selangor","zipcode":"47301","country":"Malaysia","tel":"+603 7832 1113","fax":"+603 7832 1138","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-24 11:24:24","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-06-24 11:25:44', 'admin'),
(988, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"0"}', '2015-07-02 21:47:32', 'admin'),
(989, 'sales', 'add', 'invoice', 10011, '{"id":"10011","txn_no":"1-10204","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-07-10 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"TEST CUSTOMER","contact_id":"5","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TEST CUSTOMER\\",\\"mobile\\":\\"123456789\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"335.80","total_delivered":null,"cost":null,"tags":"","added_on":"2015-07-10 15:08:43","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"7.80\\"}]","total_tax":"7.80","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"31","invoice_id":"10011","type":"product","date":"2015-07-10 12:00:00","item_name":"STANDARD RATED ITEM [SR]","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"13.0000","price":"130.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"},{"id":"32","invoice_id":"10011","type":"product","date":"2015-07-10 12:00:00","item_name":"ZERO RATED ITEM [ZRL]","item_description":"","item_id":"1","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"11","price_per_unit":"18.0000","price":"198.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":"ZRL"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"34","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"13.00","price_3":"12.00","price_4":"11.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":"2015-06-09 21:28:21","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-07-04 11:15:07","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"},"1":{"id":"1","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"ZERO RATED ITEM","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"24","alert_quantity":"1","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"18.00","price_3":"16.00","price_4":"15.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:03","added_by":"admin","modified_on":"2015-06-09 21:28:11","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-07-04 11:15:07","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"ZP","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"5","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"TEST CUSTOMER","contact_number":"123456789","credit_limit":"0.00","rank":"NORMAL MEMBER","email":"","ic":"123456789","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-08 12:15:53","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-07-10 15:08:43', 'admin'),
(990, 'inventory', 'add', 'item', NULL, '[]', '2015-07-11 20:27:09', 'admin'),
(991, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"1"}', '2015-07-25 18:08:43', 'admin'),
(992, 'cc', 'edit', 'cc', 5, '{"id":"5","name":"VISA","percentage":"1.12","enabled":"1"}', '2015-07-29 16:49:42', 'admin'),
(993, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"0"}', '2015-08-02 17:46:48', 'admin'),
(994, 'sales', 'status_update', 'invoice', 10009, '{"id":"10009","txn_no":"1-10202","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-06-03 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"IT SOFTWARE APPLICATION SERVICES SDN BHD","contact_id":"4","contact_address":"{\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"IT SOFTWARE APPLICATION SERVICES SDN BHD\\",\\"mobile\\":\\"\\",\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1750.00","total_delivered":"0.00","cost":null,"tags":"","added_on":"2015-06-03 14:03:15","added_by":"admin","modified_on":"2015-06-03 14:04:28","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"28","invoice_id":"10009","type":"service","date":"2015-06-03 12:00:00","item_name":"Plexcloud Point-of-Sale Installation x 2 Units","item_description":"","item_id":"0","service_id":"10002","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1750.0000","price":"1750.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"1750.00","done":"0","no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"0","tax_code":""}],"products":null,"services":{"10002":{"id":"10002","name":"Website Design","description":"","category":"0","subcategory":"0","cost":"0.00","price":"1000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-02-12 14:19:10","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"4","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"IT SOFTWARE APPLICATION SERVICES SDN BHD","company_registration":"","contact_person":"MR RAJALUDIN","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"7090, Jalan Bagan Ajam","address2":"","city":"Butterworth","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-03 14:01:49","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-08-04 09:59:25', 'admin'),
(995, 'sales', 'status_update', 'invoice', 10008, '{"id":"10008","txn_no":"1-10201","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-05-10 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"IT SOFTWARE APPLICATION SERVICES SDN BHD","contact_id":"4","contact_address":"{\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"IT SOFTWARE APPLICATION SERVICES SDN BHD\\",\\"mobile\\":\\"\\",\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1750.00","total_delivered":"0.00","cost":null,"tags":"","added_on":"2015-06-03 14:02:52","added_by":"admin","modified_on":"2015-06-03 14:04:35","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"29","invoice_id":"10008","type":"service","date":"2015-05-10 12:00:00","item_name":"Plexcloud Point-of-Sale Installation x 2 Units","item_description":"","item_id":"0","service_id":"10002","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1750.0000","price":"1750.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"1750.00","done":"0","no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"0","tax_code":""}],"products":null,"services":{"10002":{"id":"10002","name":"Website Design","description":"","category":"0","subcategory":"0","cost":"0.00","price":"1000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-02-12 14:19:10","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"4","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"IT SOFTWARE APPLICATION SERVICES SDN BHD","company_registration":"","contact_person":"MR RAJALUDIN","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"7090, Jalan Bagan Ajam","address2":"","city":"Butterworth","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-03 14:01:49","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-08-04 09:59:30', 'admin'),
(996, 'sales', 'delete', 'invoice', 10011, '{"id":"10011","txn_no":"1-10204","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-07-10 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"TEST CUSTOMER","contact_id":"5","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TEST CUSTOMER\\",\\"mobile\\":\\"123456789\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"335.80","total_delivered":null,"cost":null,"tags":"","added_on":"2015-07-10 15:08:43","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"7.80\\"}]","total_tax":"7.80","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"31","invoice_id":"10011","type":"product","date":"2015-07-10 12:00:00","item_name":"STANDARD RATED ITEM [SR]","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"13.0000","price":"130.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"},{"id":"32","invoice_id":"10011","type":"product","date":"2015-07-10 12:00:00","item_name":"ZERO RATED ITEM [ZRL]","item_description":"","item_id":"1","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"11","price_per_unit":"18.0000","price":"198.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":"ZRL"}],"products":{"2":{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"30","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"13.00","price_3":"12.00","price_4":"11.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":"2015-06-09 21:28:21","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-02 17:47:00","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"},"1":{"id":"1","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"ZERO RATED ITEM","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"21","alert_quantity":"1","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"18.00","price_3":"16.00","price_4":"15.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:03","added_by":"admin","modified_on":"2015-06-09 21:28:11","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-02 17:47:00","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"ZP","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"5","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"TEST CUSTOMER","contact_number":"123456789","credit_limit":"0.00","rank":"NORMAL MEMBER","email":"","ic":"123456789","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-08 12:15:53","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-08-04 09:59:33', 'admin'),
(997, 'sales', 'delete', 'invoice', 10010, '{"id":"10010","txn_no":"1-10203","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-06-23 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"D AVENUE TECHNOLOGIES SDN BHD","contact_id":"7","contact_address":"{\\"address1\\":\\"Unit B-2-11 Block B, No 2 Jalan PJU 1A\\\\\\/7A\\",\\"address2\\":\\"Ara Damansara\\",\\"zipcode\\":\\"47301\\",\\"city\\":\\"Petaling Jaya\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"D AVENUE TECHNOLOGIES SDN BHD\\",\\"mobile\\":\\"+603 7832 1113\\",\\"address1\\":\\"Unit B-2-11 Block B, No 2 Jalan PJU 1A\\\\\\/7A\\",\\"address2\\":\\"Ara Damansara\\",\\"zipcode\\":\\"47301\\",\\"city\\":\\"Petaling Jaya\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-06-24 11:25:44","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"30","invoice_id":"10010","type":"service","date":"2015-06-23 12:00:00","item_name":"On-Site Registration System for eRezeki","item_description":"- Web-based\\n- iPad Optimized","item_id":"0","service_id":"10002","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"500.0000","price":"500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":null,"services":{"10002":{"id":"10002","name":"Website Design","description":"","category":"0","subcategory":"0","cost":"0.00","price":"1000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-02-12 14:19:10","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"7","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"D AVENUE TECHNOLOGIES SDN BHD","company_registration":"","contact_person":"Bee Leng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Unit B-2-11 Block B, No 2 Jalan PJU 1A\\/7A","address2":"Ara Damansara","city":"Petaling Jaya","state":"Selangor","zipcode":"47301","country":"Malaysia","tel":"+603 7832 1113","fax":"+603 7832 1138","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-24 11:24:24","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-08-04 09:59:35', 'admin'),
(998, 'sales', 'delete', 'invoice', 10009, '{"id":"10009","txn_no":"1-10202","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-06-03 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"IT SOFTWARE APPLICATION SERVICES SDN BHD","contact_id":"4","contact_address":"{\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"IT SOFTWARE APPLICATION SERVICES SDN BHD\\",\\"mobile\\":\\"\\",\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1750.00","total_delivered":"0.00","cost":null,"tags":"","added_on":"2015-06-03 14:03:15","added_by":"admin","modified_on":"2015-06-03 14:04:28","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"28","invoice_id":"10009","type":"service","date":"2015-06-03 12:00:00","item_name":"Plexcloud Point-of-Sale Installation x 2 Units","item_description":"","item_id":"0","service_id":"10002","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1750.0000","price":"1750.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"1750.00","done":"0","no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"0","tax_code":""}],"products":null,"services":{"10002":{"id":"10002","name":"Website Design","description":"","category":"0","subcategory":"0","cost":"0.00","price":"1000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-02-12 14:19:10","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"4","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"IT SOFTWARE APPLICATION SERVICES SDN BHD","company_registration":"","contact_person":"MR RAJALUDIN","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"7090, Jalan Bagan Ajam","address2":"","city":"Butterworth","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-03 14:01:49","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-08-04 09:59:37', 'admin'),
(999, 'sales', 'delete', 'invoice', 10008, '{"id":"10008","txn_no":"1-10201","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-05-10 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"IT SOFTWARE APPLICATION SERVICES SDN BHD","contact_id":"4","contact_address":"{\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"IT SOFTWARE APPLICATION SERVICES SDN BHD\\",\\"mobile\\":\\"\\",\\"address1\\":\\"7090, Jalan Bagan Ajam\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"Butterworth\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1750.00","total_delivered":"0.00","cost":null,"tags":"","added_on":"2015-06-03 14:02:52","added_by":"admin","modified_on":"2015-06-03 14:04:35","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"29","invoice_id":"10008","type":"service","date":"2015-05-10 12:00:00","item_name":"Plexcloud Point-of-Sale Installation x 2 Units","item_description":"","item_id":"0","service_id":"10002","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1750.0000","price":"1750.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"1750.00","done":"0","no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"0","tax_code":""}],"products":null,"services":{"10002":{"id":"10002","name":"Website Design","description":"","category":"0","subcategory":"0","cost":"0.00","price":"1000.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-02-12 14:19:10","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"4","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"IT SOFTWARE APPLICATION SERVICES SDN BHD","company_registration":"","contact_person":"MR RAJALUDIN","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"7090, Jalan Bagan Ajam","address2":"","city":"Butterworth","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-03 14:01:49","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-08-04 09:59:40', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(1000, 'inventory', 'delete', 'item', 1, '{"id":"1","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"ZERO RATED ITEM","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"21","alert_quantity":"1","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"18.00","price_3":"16.00","price_4":"15.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:03","added_by":"admin","modified_on":"2015-06-09 21:28:11","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-02 17:47:00","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"ZP","supply_tax_code":"ZRL","purchase_taxable":"0","supply_taxable":"0"}', '2015-08-04 09:59:55', 'admin'),
(1001, 'inventory', 'delete', 'item', 2, '{"id":"2","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"STANDARD RATED ITEM","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"30","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"15.00","price_2":"13.00","price_3":"12.00","price_4":"11.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-05-31 14:09:23","added_by":"admin","modified_on":"2015-06-09 21:28:21","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-02 17:47:00","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}', '2015-08-04 09:59:57', 'admin'),
(1002, 'inventory', 'delete', 'item', 3, '{"id":"3","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1003","sku2":"","sku3":"","sku4":"","qty":"-1","alert_quantity":"10","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-07-11 20:27:09","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-07-25 18:03:42","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}', '2015-08-04 09:59:59', 'admin'),
(1003, 'inventory', 'status_update', 'po', 10013, '{"id":"10013","txn_no":"1-10003","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-31 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"90.22","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 18:28:16","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"5.11\\"}]","tax_inclusive":"0","total_tax":"5.11","assigned_to":null,"orders":[{"id":"68","purchase_order_id":"10013","date":"2015-05-31 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"1","price_per_unit":"85.1100","price":"85.11","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"TX"}],"products":{"2":[]}}', '2015-08-04 10:00:07', 'admin'),
(1004, 'inventory', 'status_update', 'po', 10014, '{"id":"10014","txn_no":"1-10004","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-10 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"412.00","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 19:23:06","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"12.00\\"}]","tax_inclusive":"0","total_tax":"12.00","assigned_to":null,"orders":[{"id":"69","purchase_order_id":"10014","date":"2015-05-10 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"TX"},{"id":"70","purchase_order_id":"10014","date":"2015-05-10 00:00:00","item_description":null,"item_name":"ZERO RATED ITEM ()","item_id":"1","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZP"}],"products":{"1":[],"2":[]}}', '2015-08-04 10:00:13', 'admin'),
(1005, 'inventory', 'status_update', 'po', 10012, '{"id":"10012","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-02 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"212.00","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 14:19:02","added_by":"admin","modified_on":"2015-05-31 14:21:58","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"12.00\\"}]","tax_inclusive":"0","total_tax":"12.00","assigned_to":null,"orders":[{"id":"64","purchase_order_id":"10012","date":"2015-05-02 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"TX"}],"products":{"2":[]}}', '2015-08-04 10:00:18', 'admin'),
(1006, 'inventory', 'status_update', 'po', 10011, '{"id":"10011","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-01 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"100.00","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 14:18:05","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"orders":[{"id":"63","purchase_order_id":"10011","date":"2015-05-01 00:00:00","item_description":null,"item_name":"ZERO RATED ITEM ()","item_id":"1","discount":"0","discount_type":null,"qty":"10","price_per_unit":"10.0000","price":"100.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZP"}],"products":{"1":[]}}', '2015-08-04 10:00:23', 'admin'),
(1007, 'inventory', 'delete', 'po', 10013, '{"id":"10013","txn_no":"1-10003","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-31 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"90.22","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 18:28:16","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"5.11\\"}]","tax_inclusive":"0","total_tax":"5.11","assigned_to":null,"orders":[{"id":"68","purchase_order_id":"10013","date":"2015-05-31 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"1","price_per_unit":"85.1100","price":"85.11","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"TX"}],"products":{"2":[]}}', '2015-08-04 10:00:26', 'admin'),
(1008, 'inventory', 'delete', 'po', 10014, '{"id":"10014","txn_no":"1-10004","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-10 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"412.00","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 19:23:06","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"12.00\\"}]","tax_inclusive":"0","total_tax":"12.00","assigned_to":null,"orders":[{"id":"69","purchase_order_id":"10014","date":"2015-05-10 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"TX"},{"id":"70","purchase_order_id":"10014","date":"2015-05-10 00:00:00","item_description":null,"item_name":"ZERO RATED ITEM ()","item_id":"1","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZP"}],"products":{"1":[],"2":[]}}', '2015-08-04 10:00:28', 'admin'),
(1009, 'inventory', 'delete', 'po', 10012, '{"id":"10012","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-02 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"212.00","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 14:19:02","added_by":"admin","modified_on":"2015-05-31 14:21:58","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"12.00\\"}]","tax_inclusive":"0","total_tax":"12.00","assigned_to":null,"orders":[{"id":"64","purchase_order_id":"10012","date":"2015-05-02 00:00:00","item_description":null,"item_name":"STANDARD RATED ITEM ()","item_id":"2","discount":"0","discount_type":null,"qty":"20","price_per_unit":"10.0000","price":"200.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"TX"}],"products":{"2":[]}}', '2015-08-04 10:00:30', 'admin'),
(1010, 'inventory', 'delete', 'po', 10011, '{"id":"10011","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-05-01 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"TEST SUPPLIER","supplier_id":"3","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Cash","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"100.00","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-05-31 14:18:05","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"orders":[{"id":"63","purchase_order_id":"10011","date":"2015-05-01 00:00:00","item_description":null,"item_name":"ZERO RATED ITEM ()","item_id":"1","discount":"0","discount_type":null,"qty":"10","price_per_unit":"10.0000","price":"100.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"0","tax_code":"ZP"}],"products":{"1":[]}}', '2015-08-04 10:00:32', 'admin'),
(1011, 'inventory', 'status_update', 'dn', 10001, '{"id":"10001","txn_no":"1-10001","cn_number":"","date":"2015-01-20 00:00:00","contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":null,"terms":"Credit","remarks":"","status":"Pending","payment_status":"Unpaid","payment_reference":null,"payment_date":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"6.75","total_received":"0.00","tags":"","added_on":"2015-01-20 21:05:23","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","debit_note_id":"10001","date":"2015-01-20 00:00:00","item_id":"646","item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_description":null,"discount":"0","discount_type":null,"qty":"5","price_per_unit":"1.3500","price":"6.75","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1"}],"products":{"646":[]}}', '2015-08-04 10:00:36', 'admin'),
(1012, 'inventory', 'delete', 'dn', 10001, '{"id":"10001","txn_no":"1-10001","cn_number":"","date":"2015-01-20 00:00:00","contact_person":"Administrator ","received_date":null,"supplier":"asdasd","supplier_id":"1","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":null,"terms":"Credit","remarks":"","status":"Pending","payment_status":"Unpaid","payment_reference":null,"payment_date":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"6.75","total_received":"0.00","tags":"","added_on":"2015-01-20 21:05:23","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","debit_note_id":"10001","date":"2015-01-20 00:00:00","item_id":"646","item_name":"\\"BUBBLE\\" FOOD CONTAINER (PCS)","item_description":null,"discount":"0","discount_type":null,"qty":"5","price_per_unit":"1.3500","price":"6.75","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1"}],"products":{"646":[]}}', '2015-08-04 10:00:42', 'admin'),
(1013, 'contacts', 'delete', 'contact', 3, '{"id":"3","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"TEST SUPPLIER","company_registration":"","contact_person":"TEST SUPPLIER","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-05-31 14:16:04","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-08-04 10:06:41', 'admin'),
(1014, 'contacts', 'delete', 'contact', 4, '{"id":"4","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"IT SOFTWARE APPLICATION SERVICES SDN BHD","company_registration":"","contact_person":"MR RAJALUDIN","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"7090, Jalan Bagan Ajam","address2":"","city":"Butterworth","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-03 14:01:49","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-08-04 10:06:43', 'admin'),
(1015, 'contacts', 'delete', 'contact', 5, '{"id":"5","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"TEST CUSTOMER","contact_number":"123456789","credit_limit":"0.00","rank":"NORMAL MEMBER","email":"","ic":"123456789","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-08 12:15:53","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-08-04 10:06:44', 'admin'),
(1016, 'contacts', 'delete', 'contact', 7, '{"id":"7","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"D AVENUE TECHNOLOGIES SDN BHD","company_registration":"","contact_person":"Bee Leng","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"Unit B-2-11 Block B, No 2 Jalan PJU 1A\\/7A","address2":"Ara Damansara","city":"Petaling Jaya","state":"Selangor","zipcode":"47301","country":"Malaysia","tel":"+603 7832 1113","fax":"+603 7832 1138","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-06-24 11:24:24","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-08-04 10:06:46', 'admin'),
(1017, 'contacts', 'delete', 'contact', 8, '{"id":"8","is_customer":"1","is_supplier":null,"is_debtor":null,"is_creditor":null,"is_member":null,"is_stakeholder":null,"is_franchise":null,"is_franchisee":null,"company_name":null,"company_registration":null,"contact_person":"TEST COMPANY","contact_number":"0124205391","credit_limit":null,"rank":null,"email":null,"ic":"PG239201-1","password":null,"introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"","tel":"0124205391","fax":null,"general_email":"","terms":null,"description":null,"remarks":null,"tags":null,"added_on":"2015-07-25 18:03:13","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":"0","user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":null}', '2015-08-04 10:06:49', 'admin'),
(1018, 'contacts', 'add', 'contact', 9, '{"id":"9","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"TEST SDM BHD","company_registration":"12312","contact_person":"JOHN DOE","contact_number":"1312321","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-08-04 10:28:02","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"1312312"}', '2015-08-04 10:28:02', 'admin'),
(1019, 'inventory', 'add', 'item', NULL, '[]', '2015-08-04 10:35:10', 'admin'),
(1020, 'sales', 'add', 'quote', 10001, '{"id":"10001","txn_no":"1-10001","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2015-08-04 00:00:00","due_date":"2015-08-11 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"TEST SDM BHD","contact_id":"9","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TEST SDM BHD\\",\\"mobile\\":\\"1312321\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-08-04 10:36:43","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","quote_id":"10001","date":"2015-08-04 00:00:00","type":"product","item_id":"4","service_id":"0","item_name":"TEST ITEM []","item_description":"","discount":"0","discount_type":null,"qty":"100","price_per_unit":"20.0000","price":"2000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"4":{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}},"services":null}', '2015-08-04 10:36:43', 'admin'),
(1021, 'sales', 'add', 'so', 10001, '{"id":"10001","txn_no":"1-10001","quote_id":"10001","invoice_id":null,"number":"0","pr_number":null,"po_number":"QUO-10001","date":"2015-08-04 00:00:00","due_date":"0000-00-00 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"TEST SDM BHD","contact_id":"9","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"false","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-08-04 10:38:47","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"1","sales_order_id":"10001","type":"product","date":"2015-08-04 00:00:00","item_name":"TEST ITEM []","item_description":"","item_id":"4","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"20.0000","price":"2000.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"4":{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}},"services":null}', '2015-08-04 10:38:47', 'admin'),
(1022, 'sales', 'add', 'invoice', 10012, '{"id":"10012","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"32131","date":"2015-08-04 12:00:00","due_date":"2015-09-03 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"TEST SDM BHD","contact_id":"9","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TEST SDM BHD\\",\\"mobile\\":\\"1312321\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"30","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-08-04 10:40:19","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"33","invoice_id":"10012","type":"product","date":"2015-08-04 12:00:00","item_name":"TEST ITEM []","item_description":"","item_id":"4","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"20.0000","price":"2000.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":{"4":{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"9","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"TEST SDM BHD","company_registration":"12312","contact_person":"JOHN DOE","contact_number":"1312321","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-08-04 10:28:02","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"1312312"},"sale":null,"sale_items":null}', '2015-08-04 10:40:19', 'admin'),
(1023, 'sales', 'deliver', 'invoice', 10012, '{"id":"10012","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"32131","date":"2015-08-04 12:00:00","due_date":"2015-09-03 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"TEST SDM BHD","contact_id":"9","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TEST SDM BHD\\",\\"mobile\\":\\"1312321\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"30","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2000.00","total_delivered":"2000.00","cost":null,"tags":"","added_on":"2015-08-04 10:40:19","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"33","invoice_id":"10012","type":"product","date":"2015-08-04 12:00:00","item_name":"TEST ITEM []","item_description":"","item_id":"4","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"20.0000","price":"2000.00","cost":"1000.00","margin":null,"delivered":"100","delivered_price":"2000.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":{"4":{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"-100","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-04 10:41:12","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"9","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"TEST SDM BHD","company_registration":"12312","contact_person":"JOHN DOE","contact_number":"1312321","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-08-04 10:28:02","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"1312312"},"sale":null,"sale_items":null}', '2015-08-04 10:41:12', 'admin'),
(1024, 'sales', 'status_update', 'invoice', 10012, '{"id":"10012","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"32131","date":"2015-08-04 12:00:00","due_date":"2015-09-03 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"TEST SDM BHD","contact_id":"9","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TEST SDM BHD\\",\\"mobile\\":\\"1312321\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"30","remarks":"","status":"Partially Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2000.00","total_delivered":"2000.00","cost":null,"tags":"","added_on":"2015-08-04 10:40:19","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"33","invoice_id":"10012","type":"product","date":"2015-08-04 12:00:00","item_name":"TEST ITEM []","item_description":"","item_id":"4","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"20.0000","price":"2000.00","cost":"1000.00","margin":null,"delivered":"100","delivered_price":"2000.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":{"4":{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"-100","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-04 10:41:12","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"9","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"TEST SDM BHD","company_registration":"12312","contact_person":"JOHN DOE","contact_number":"1312321","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-08-04 10:28:02","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"1312312"},"sale":null,"sale_items":null}', '2015-08-04 10:41:21', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(1025, 'sales', 'deliver', 'invoice', 10012, '{"id":"10012","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"32131","date":"2015-08-04 12:00:00","due_date":"2015-09-03 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"TEST SDM BHD","contact_id":"9","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TEST SDM BHD\\",\\"mobile\\":\\"1312321\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"30","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2000.00","total_delivered":"1180.00","cost":null,"tags":"","added_on":"2015-08-04 10:40:19","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"33","invoice_id":"10012","type":"product","date":"2015-08-04 12:00:00","item_name":"TEST ITEM []","item_description":"","item_id":"4","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"20.0000","price":"2000.00","cost":"590.00","margin":null,"delivered":"59","delivered_price":"1180.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":{"4":{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"-59","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-04 10:41:28","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"9","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"TEST SDM BHD","company_registration":"12312","contact_person":"JOHN DOE","contact_number":"1312321","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-08-04 10:28:02","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"1312312"},"sale":null,"sale_items":null}', '2015-08-04 10:41:28', 'admin'),
(1026, 'sales', 'status_update', 'invoice', 10012, '{"id":"10012","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"32131","date":"2015-08-04 12:00:00","due_date":"2015-09-03 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"TEST SDM BHD","contact_id":"9","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TEST SDM BHD\\",\\"mobile\\":\\"1312321\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"30","remarks":"","status":"Partially Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2000.00","total_delivered":"1180.00","cost":null,"tags":"","added_on":"2015-08-04 10:40:19","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"33","invoice_id":"10012","type":"product","date":"2015-08-04 12:00:00","item_name":"TEST ITEM []","item_description":"","item_id":"4","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"20.0000","price":"2000.00","cost":"590.00","margin":null,"delivered":"59","delivered_price":"1180.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":{"4":{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"-59","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-04 10:41:28","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"9","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"TEST SDM BHD","company_registration":"12312","contact_person":"JOHN DOE","contact_number":"1312321","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-08-04 10:28:02","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"1312312"},"sale":null,"sale_items":null}', '2015-08-04 10:41:29', 'admin'),
(1027, 'sales', 'deliver', 'invoice', 10012, '{"id":"10012","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"32131","date":"2015-08-04 12:00:00","due_date":"2015-09-03 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"TEST SDM BHD","contact_id":"9","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TEST SDM BHD\\",\\"mobile\\":\\"1312321\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"30","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2000.00","total_delivered":"2000.00","cost":null,"tags":"","added_on":"2015-08-04 10:40:19","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"33","invoice_id":"10012","type":"product","date":"2015-08-04 12:00:00","item_name":"TEST ITEM []","item_description":"","item_id":"4","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"20.0000","price":"2000.00","cost":"1000.00","margin":null,"delivered":"100","delivered_price":"2000.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":{"4":{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"-100","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-04 10:41:53","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"9","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"TEST SDM BHD","company_registration":"12312","contact_person":"JOHN DOE","contact_number":"1312321","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-08-04 10:28:02","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"1312312"},"sale":null,"sale_items":null}', '2015-08-04 10:41:53', 'admin'),
(1028, 'sales', 'status_update', 'invoice', 10012, '{"id":"10012","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"32131","date":"2015-08-04 12:00:00","due_date":"2015-09-03 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"TEST SDM BHD","contact_id":"9","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TEST SDM BHD\\",\\"mobile\\":\\"1312321\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"30","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2000.00","total_delivered":"2000.00","cost":null,"tags":"","added_on":"2015-08-04 10:40:19","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"33","invoice_id":"10012","type":"product","date":"2015-08-04 12:00:00","item_name":"TEST ITEM []","item_description":"","item_id":"4","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"20.0000","price":"2000.00","cost":"1000.00","margin":null,"delivered":"100","delivered_price":"2000.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":{"4":{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"-100","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-04 10:41:53","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"9","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"TEST SDM BHD","company_registration":"12312","contact_person":"JOHN DOE","contact_number":"1312321","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-08-04 10:28:02","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"1312312"},"sale":null,"sale_items":null}', '2015-08-04 10:41:56', 'admin'),
(1029, 'sales', 'delivery_status_update', 'do', 10012, '{"id":"10012","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"32131","date":"2015-08-04 12:00:00","due_date":"2015-09-03 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"TEST SDM BHD","contact_id":"9","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TEST SDM BHD\\",\\"mobile\\":\\"1312321\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Delivered","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"30","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2000.00","total_delivered":"2000.00","cost":null,"tags":"","added_on":"2015-08-04 10:40:19","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"33","invoice_id":"10012","type":"product","date":"2015-08-04 12:00:00","item_name":"TEST ITEM []","item_description":"","item_id":"4","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"20.0000","price":"2000.00","cost":"1000.00","margin":null,"delivered":"100","delivered_price":"2000.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":{"4":{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"-100","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-04 10:41:53","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"9","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"TEST SDM BHD","company_registration":"12312","contact_person":"JOHN DOE","contact_number":"1312321","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-08-04 10:28:02","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"1312312"},"sale":null,"sale_items":null}', '2015-08-04 10:43:08', 'admin'),
(1030, 'sales', 'add', 'cn', 10001, '{"id":"10001","txn_no":"1-10001","dn_number":"","date":"2015-08-04 00:00:00","contact_person":"Administrator ","received_date":null,"contact":"TEST SDM BHD","contact_id":"9","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":null,"terms":"Credit","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"100.00","total_received":null,"tags":"","added_on":"2015-08-04 10:44:33","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","credit_note_id":"10001","date":"2015-08-04 00:00:00","item_id":"4","item_name":"TEST ITEM []","item_description":null,"discount":"0","discount_type":null,"qty":"5","price_per_unit":"20.0000","price":"100.00","cost":null,"received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"4":{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"-100","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-04 10:41:53","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-08-04 10:44:33', 'admin'),
(1031, 'sales', 'receive', 'cn', 10001, '{"id":"10001","txn_no":"1-10001","dn_number":"","date":"2015-08-04 00:00:00","contact_person":"Administrator ","received_date":null,"contact":"TEST SDM BHD","contact_id":"9","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":null,"terms":"Credit","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"100.00","total_received":"100.00","tags":"","added_on":"2015-08-04 10:44:33","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","credit_note_id":"10001","date":"2015-08-04 00:00:00","item_id":"4","item_name":"TEST ITEM []","item_description":null,"discount":"0","discount_type":null,"qty":"5","price_per_unit":"20.0000","price":"100.00","cost":"50.0000","received":"5","received_price":"100.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"4":{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"-95","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-04 10:41:53","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-08-04 10:44:44', 'admin'),
(1032, 'sales', 'status_update', 'cn', 10001, '{"id":"10001","txn_no":"1-10001","dn_number":"","date":"2015-08-04 00:00:00","contact_person":"Administrator ","received_date":null,"contact":"TEST SDM BHD","contact_id":"9","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":null,"terms":"Credit","remarks":"","status":"Received","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"100.00","total_received":"100.00","tags":"","added_on":"2015-08-04 10:44:33","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","credit_note_id":"10001","date":"2015-08-04 00:00:00","item_id":"4","item_name":"TEST ITEM []","item_description":null,"discount":"0","discount_type":null,"qty":"5","price_per_unit":"20.0000","price":"100.00","cost":"50.0000","received":"5","received_price":"100.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"4":{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"-95","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-04 10:41:53","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-08-04 10:44:45', 'admin'),
(1033, 'inventory', 'add', 'item', NULL, '[]', '2015-08-04 10:53:19', 'admin'),
(1034, 'inventory', 'add', 'po', 10015, '{"id":"10015","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-08-04 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":null,"supplier_id":"0","supplier_address":"{\\"address1\\":null,\\"address2\\":null,\\"zipcode\\":null,\\"city\\":null,\\"state\\":null,\\"country\\":null}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"500.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-08-04 10:57:18","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"1","total_tax":"0.00","assigned_to":null,"orders":[{"id":"76","purchase_order_id":"10015","date":"2015-08-04 00:00:00","item_description":null,"item_name":"TEST ITEM ()","item_id":"4","discount":"12","discount_type":null,"qty":"100","price_per_unit":"5.0000","price":"500.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"4":{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"-95","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-04 10:41:53","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-08-04 10:57:18', 'admin'),
(1035, 'inventory', 'receive', 'po', 10015, '{"id":"10015","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-08-04 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":null,"supplier_id":"0","supplier_address":"{\\"address1\\":null,\\"address2\\":null,\\"zipcode\\":null,\\"city\\":null,\\"state\\":null,\\"country\\":null}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"500.00","total_received":"500.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-08-04 10:57:18","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"1","total_tax":"0.00","assigned_to":null,"orders":[{"id":"76","purchase_order_id":"10015","date":"2015-08-04 00:00:00","item_description":null,"item_name":"TEST ITEM ()","item_id":"4","discount":"12","discount_type":null,"qty":"100","price_per_unit":"5.0000","price":"500.00","received":"100","received_price":"500.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"4":{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"5","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-04 10:41:53","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-08-04 10:57:41', 'admin'),
(1036, 'inventory', 'status_update', 'po', 10015, '{"id":"10015","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-08-04 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":null,"supplier_id":"0","supplier_address":"{\\"address1\\":null,\\"address2\\":null,\\"zipcode\\":null,\\"city\\":null,\\"state\\":null,\\"country\\":null}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"500.00","total_received":"500.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-08-04 10:57:18","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"1","total_tax":"0.00","assigned_to":null,"orders":[{"id":"76","purchase_order_id":"10015","date":"2015-08-04 00:00:00","item_description":null,"item_name":"TEST ITEM ()","item_id":"4","discount":"12","discount_type":null,"qty":"100","price_per_unit":"5.0000","price":"500.00","received":"100","received_price":"500.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"4":{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"5","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-04 10:41:53","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-08-04 10:57:41', 'admin'),
(1037, 'inventory', 'add', 'dn', 10002, '{"id":"10002","txn_no":"1-10001","cn_number":"","date":"2015-08-04 00:00:00","contact_person":"Administrator ","received_date":null,"supplier":"TEST SDM BHD","supplier_id":"9","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":null,"terms":"Credit","remarks":"","status":"Pending","payment_status":"Unpaid","payment_reference":null,"payment_date":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10.00","total_received":null,"tags":"","added_on":"2015-08-04 10:59:06","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"2","debit_note_id":"10002","date":"2015-08-04 00:00:00","item_id":"4","item_name":"TEST ITEM ()","item_description":null,"discount":"0","discount_type":null,"qty":"2","price_per_unit":"5.0000","price":"10.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"4":{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"5","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-04 10:41:53","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-08-04 10:59:06', 'admin'),
(1038, 'inventory', 'status_update', 'dn', 10002, '{"id":"10002","txn_no":"1-10001","cn_number":"","date":"2015-08-04 00:00:00","contact_person":"Administrator ","received_date":null,"supplier":"TEST SDM BHD","supplier_id":"9","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":null,"terms":"Credit","remarks":"","status":"Returned","payment_status":"Unpaid","payment_reference":null,"payment_date":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10.00","total_received":null,"tags":"","added_on":"2015-08-04 10:59:06","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"2","debit_note_id":"10002","date":"2015-08-04 00:00:00","item_id":"4","item_name":"TEST ITEM ()","item_description":null,"discount":"0","discount_type":null,"qty":"2","price_per_unit":"5.0000","price":"10.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"4":{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"5","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-04 10:41:53","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-08-04 10:59:35', 'admin'),
(1039, 'inventory', 'receive', 'dn', 10002, '{"id":"10002","txn_no":"1-10001","cn_number":"","date":"2015-08-04 00:00:00","contact_person":"Administrator ","received_date":null,"supplier":"TEST SDM BHD","supplier_id":"9","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":null,"terms":"Credit","remarks":"","status":"Returned","payment_status":"Unpaid","payment_reference":null,"payment_date":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10.00","total_received":"10.00","tags":"","added_on":"2015-08-04 10:59:06","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"2","debit_note_id":"10002","date":"2015-08-04 00:00:00","item_id":"4","item_name":"TEST ITEM ()","item_description":null,"discount":"0","discount_type":null,"qty":"2","price_per_unit":"5.0000","price":"10.00","received":"2","received_price":"10.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":{"4":{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"3","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-04 10:41:53","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-08-04 10:59:35', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(1040, 'sales', 'status_update', 'invoice', 10012, '{"id":"10012","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"32131","date":"2015-08-04 12:00:00","due_date":"2015-09-03 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"TEST SDM BHD","contact_id":"9","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TEST SDM BHD\\",\\"mobile\\":\\"1312321\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Delivered","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"30","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2000.00","total_delivered":"0.00","cost":null,"tags":"","added_on":"2015-08-04 10:40:19","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"33","invoice_id":"10012","type":"product","date":"2015-08-04 12:00:00","item_name":"TEST ITEM []","item_description":"","item_id":"4","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"20.0000","price":"2000.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"2000.00","done":"0","no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":{"4":{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"120","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-04 10:41:53","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"9","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"TEST SDM BHD","company_registration":"12312","contact_person":"JOHN DOE","contact_number":"1312321","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-08-04 10:28:02","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"1312312"},"sale":null,"sale_items":null}', '2015-08-04 12:18:55', 'admin'),
(1041, 'sales', 'deliver', 'invoice', 10012, '{"id":"10012","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"32131","date":"2015-08-04 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"TEST SDM BHD","contact_id":"9","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TEST SDM BHD\\",\\"mobile\\":\\"1312321\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Delivered","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Paid","payment_date":"2015-08-04 12:43:09","payment_reference":"10004","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2000.00","total_delivered":"2044.00","cost":null,"tags":"function","added_on":"2015-08-04 10:40:19","added_by":"admin","modified_on":"2015-08-04 12:19:05","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"33","invoice_id":"10012","type":"product","date":"2015-08-04 12:00:00","item_name":"TEST ITEM []","item_description":"","item_id":"4","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"20.0000","price":"2000.00","cost":"425.00","margin":null,"delivered":"100","delivered_price":"2000.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""},{"id":"15","invoice_id":"10012","type":"product","date":"2015-04-14 12:00:00","item_name":"5 PCS BRUSH [SR]","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"4.4000","price":"44.00","cost":"0.00","margin":null,"delivered":"10","delivered_price":"44.00","done":"1","no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"}],"products":{"4":{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"20","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-07 17:14:03","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"},"2":[]},"services":null,"customer":{"id":"9","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"TEST SDM BHD","company_registration":"12312","contact_person":"JOHN DOE","contact_number":"1312321","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-08-04 10:28:02","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"1312312"},"sale":null,"sale_items":null}', '2015-08-07 17:14:03', 'admin'),
(1042, 'sales', 'status_update', 'invoice', 10012, '{"id":"10012","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"32131","date":"2015-08-04 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"TEST SDM BHD","contact_id":"9","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TEST SDM BHD\\",\\"mobile\\":\\"1312321\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Delivered","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Paid","payment_date":"2015-08-04 12:43:09","payment_reference":"10004","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2000.00","total_delivered":"2044.00","cost":null,"tags":"function","added_on":"2015-08-04 10:40:19","added_by":"admin","modified_on":"2015-08-04 12:19:05","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"33","invoice_id":"10012","type":"product","date":"2015-08-04 12:00:00","item_name":"TEST ITEM []","item_description":"","item_id":"4","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"20.0000","price":"2000.00","cost":"425.00","margin":null,"delivered":"100","delivered_price":"2000.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""},{"id":"15","invoice_id":"10012","type":"product","date":"2015-04-14 12:00:00","item_name":"5 PCS BRUSH [SR]","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"4.4000","price":"44.00","cost":"0.00","margin":null,"delivered":"10","delivered_price":"44.00","done":"1","no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"}],"products":{"4":{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"20","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-07 17:14:03","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"},"2":[]},"services":null,"customer":{"id":"9","is_customer":"1","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"TEST SDM BHD","company_registration":"12312","contact_person":"JOHN DOE","contact_number":"1312321","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-08-04 10:28:02","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"1312312"},"sale":null,"sale_items":null}', '2015-08-07 17:14:04', 'admin'),
(1043, 'contacts', 'edit', 'contact', 9, '{"id":"9","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"KUANCHAN (PG) LIQUOR DISTRIBUTORS SDN BHD","company_registration":"254832-W","contact_person":"KUANCHAN (PG) LIQUOR DISTRIBUTORS SDN BHD","contact_number":"04-2270578","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"17 LINTANG BURMA","address2":"","city":"","state":"Pulau Pinang","zipcode":"10250","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-08-04 10:28:02","added_by":"admin","modified_on":"2015-08-11 13:52:56","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"001631780864"}', '2015-08-11 13:52:56', 'admin'),
(1044, 'inventory', 'delete', 'item', 4, '{"id":"4","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1234","sku2":"","sku3":"","sku4":"","qty":"20","alert_quantity":"3","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:35:10","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-07 17:14:03","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}', '2015-08-11 13:53:15', 'admin'),
(1045, 'inventory', 'delete', 'item', 5, '{"id":"5","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM2","model_no":"","warranty":"","sku":"10011","sku2":"1001C","sku3":"","sku4":"","qty":"-3","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"12.50","price_2":"12.00","price_3":"11.00","price_4":"10.50","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"1","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-04 10:53:19","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"1","redeem_points":"1000","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"12","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-08-04 18:21:21","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}', '2015-08-11 13:53:18', 'admin'),
(1046, 'inventory', 'add', 'item', NULL, '[]', '2015-08-11 13:55:42', 'admin'),
(1047, 'inventory', 'add', 'po', 10016, '{"id":"10016","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-08-11 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"KUANCHAN (PG) LIQUOR DISTRIBUTORS SDN BHD","supplier_id":"9","supplier_address":"{\\"address1\\":\\"17 LINTANG BURMA\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"10250\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"360.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-08-11 13:56:33","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"orders":[{"id":"78","purchase_order_id":"10016","date":"2015-08-11 00:00:00","item_description":null,"item_name":"PAULANER HEFE 500ML ()","item_id":"6","discount":"0","discount_type":null,"qty":"20","price_per_unit":"18.0000","price":"360.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"6":{"id":"6","primary_image":null,"image":null,"category":"Beverage","subcategory":"Liquor","brand":"0","location":"","name":"PAULANER HEFE 500ML","model_no":"","warranty":"","sku":"BER-PAULANER","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"0","max_quantity":"0","cost":"18.00","average_cost":null,"price":"18.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-11 13:55:42","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-08-11 13:56:33', 'admin'),
(1048, 'contacts', 'delete', 'contact', 9, '{"id":"9","is_customer":"0","is_supplier":"1","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"KUANCHAN (PG) LIQUOR DISTRIBUTORS SDN BHD","company_registration":"254832-W","contact_person":"KUANCHAN (PG) LIQUOR DISTRIBUTORS SDN BHD","contact_number":"04-2270578","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"17 LINTANG BURMA","address2":"","city":"","state":"Pulau Pinang","zipcode":"10250","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-08-04 10:28:02","added_by":"admin","modified_on":"2015-08-11 13:52:56","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"001631780864"}', '2015-08-12 10:18:55', 'admin'),
(1049, 'contacts', 'add', 'contact', 10, '{"id":"10","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"TEST 1","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"1001","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-08-12 14:49:30","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-08-12 14:49:30', 'admin'),
(1050, 'contacts', 'add', 'contact', 11, '{"id":"11","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"TEST 2","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"1002","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-08-12 14:49:37","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-08-12 14:49:37', 'admin'),
(1051, 'contacts', 'add', 'contact', 12, '{"id":"12","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"IT SOFTWARE APPLICATION SERVICES COMPANY SDN BHD","company_registration":"","contact_person":"RAJALUDIN","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"7090 JALAN BAGAN AJAM","address2":"BAGAN AJAM","city":"BUTTERWORTH","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-08-14 14:55:47","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-08-14 14:55:47', 'admin'),
(1052, 'contacts', 'delete', 'contact', 11, '{"id":"11","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"TEST 2","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"1002","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-08-12 14:49:37","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-08-26 15:04:48', 'admin'),
(1053, 'contacts', 'delete', 'contact', 10, '{"id":"10","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"TEST 1","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"1001","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-08-12 14:49:30","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-08-26 15:04:51', 'admin'),
(1054, 'inventory', 'delete', 'item', 6, '{"id":"6","primary_image":null,"image":null,"category":"Beverage","subcategory":"Liquor","brand":"0","location":"","name":"PAULANER HEFE 500ML","model_no":"","warranty":"","sku":"BER-PAULANER","sku2":"","sku3":"","sku4":"","qty":"10","alert_quantity":"0","max_quantity":"0","cost":"18.00","average_cost":null,"price":"18.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-08-11 13:55:42","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}', '2015-09-08 11:13:42', 'admin'),
(1055, 'sales', 'add', 'invoice', 10013, '{"id":"10013","txn_no":"1-10002","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-09-08 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"IT SOFTWARE APPLICATION SERVICES COMPANY SDN BHD","contact_id":"12","contact_address":"{\\"address1\\":\\"7090 JALAN BAGAN AJAM\\",\\"address2\\":\\"BAGAN AJAM\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"BUTTERWORTH\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"IT SOFTWARE APPLICATION SERVICES COMPANY SDN BHD\\",\\"mobile\\":\\"\\",\\"address1\\":\\"7090 JALAN BAGAN AJAM\\",\\"address2\\":\\"BAGAN AJAM\\",\\"zipcode\\":\\"13000\\",\\"city\\":\\"BUTTERWORTH\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-09-08 11:15:05","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"34","invoice_id":"10013","type":"service","date":"2015-09-08 12:00:00","item_name":"Subaidah Website Upgrade","item_description":"- Content Management System\\n- Responsive Design\\n- Content Update","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"12","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"IT SOFTWARE APPLICATION SERVICES COMPANY SDN BHD","company_registration":"","contact_person":"RAJALUDIN","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"7090 JALAN BAGAN AJAM","address2":"BAGAN AJAM","city":"BUTTERWORTH","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-08-14 14:55:47","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-09-08 11:15:05', 'admin'),
(1056, 'contacts', 'add', 'contact', 13, '{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-09-08 11:16:02', 'admin'),
(1057, 'sales', 'edit', 'invoice', 10013, '{"id":"10013","txn_no":"1-10002","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-09-08 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-09-08 11:15:05","added_by":"admin","modified_on":"2015-09-08 11:16:11","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"35","invoice_id":"10013","type":"service","date":"2015-09-08 12:00:00","item_name":"Subaidah Website Upgrade","item_description":"- Content Management System\\n- Responsive Design\\n- Content Update","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"0","tax_code":""}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-09-08 11:16:11', 'admin'),
(1058, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"0","inclusive":"0"}', '2015-09-08 11:16:36', 'admin'),
(1059, 'sales', 'edit', 'invoice', 10013, '{"id":"10013","txn_no":"1-10002","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-09-08 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-09-08 11:15:05","added_by":"admin","modified_on":"2015-09-08 11:16:46","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"36","invoice_id":"10013","type":"service","date":"2015-09-08 12:00:00","item_name":"Subaidah Website Upgrade","item_description":"- Content Management System\\n- Responsive Design\\n- Content Update","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"0","tax_code":""}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-09-08 11:16:46', 'admin'),
(1060, 'contacts', 'add', 'contact', 14, '{"id":"14","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Bagus Adapter","company_registration":"","contact_person":"Azlan Ali","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"B-3A-1, Megan Phoenix Business Park","address2":"Jalan 2\\/142A, Off Jalan Cheras","city":"Cheras","state":"Kuala Lumpur","zipcode":"56000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-09 12:19:34","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-09-09 12:19:34', 'admin'),
(1061, 'sales', 'add', 'invoice', 10014, '{"id":"10014","txn_no":"1-10003","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-09-08 12:00:00","due_date":null,"received_date":null,"contact_person":"Shafiq","contact":"Bagus Adapter","contact_id":"14","contact_address":"{\\"address1\\":\\"B-3A-1, Megan Phoenix Business Park\\",\\"address2\\":\\"Jalan 2\\\\\\/142A, Off Jalan Cheras\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Bagus Adapter\\",\\"mobile\\":\\"\\",\\"address1\\":\\"B-3A-1, Megan Phoenix Business Park\\",\\"address2\\":\\"Jalan 2\\\\\\/142A, Off Jalan Cheras\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-09-09 12:21:15","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"38","invoice_id":"10014","type":"service","date":"2015-09-08 12:00:00","item_name":"Packaging Design + Business Card Design","item_description":"","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"400.0000","price":"400.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""},{"id":"37","invoice_id":"10014","type":"service","date":"2015-09-08 12:00:00","item_name":"Custom Web Development Completion (50%)","item_description":"Bagus Adapter E-Commerce Website\\nLogo Design","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"800.0000","price":"800.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"14","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Bagus Adapter","company_registration":"","contact_person":"Azlan Ali","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"B-3A-1, Megan Phoenix Business Park","address2":"Jalan 2\\/142A, Off Jalan Cheras","city":"Cheras","state":"Kuala Lumpur","zipcode":"56000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-09 12:19:34","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-09-09 12:21:15', 'admin'),
(1062, 'contacts', 'delete', 'contact', 12, '{"id":"12","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"IT SOFTWARE APPLICATION SERVICES COMPANY SDN BHD","company_registration":"","contact_person":"RAJALUDIN","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"7090 JALAN BAGAN AJAM","address2":"BAGAN AJAM","city":"BUTTERWORTH","state":"Pulau Pinang","zipcode":"13000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-08-14 14:55:47","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-09-10 11:35:12', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(1063, 'sales', 'delete', 'invoice', 10014, '{"id":"10014","txn_no":"1-10003","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-09-08 12:00:00","due_date":null,"received_date":null,"contact_person":"Shafiq","contact":"Bagus Adapter","contact_id":"14","contact_address":"{\\"address1\\":\\"B-3A-1, Megan Phoenix Business Park\\",\\"address2\\":\\"Jalan 2\\\\\\/142A, Off Jalan Cheras\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Bagus Adapter\\",\\"mobile\\":\\"\\",\\"address1\\":\\"B-3A-1, Megan Phoenix Business Park\\",\\"address2\\":\\"Jalan 2\\\\\\/142A, Off Jalan Cheras\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-09-09 12:21:15","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"38","invoice_id":"10014","type":"service","date":"2015-09-08 12:00:00","item_name":"Packaging Design + Business Card Design","item_description":"","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"400.0000","price":"400.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""},{"id":"37","invoice_id":"10014","type":"service","date":"2015-09-08 12:00:00","item_name":"Custom Web Development Completion (50%)","item_description":"Bagus Adapter E-Commerce Website\\nLogo Design","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"800.0000","price":"800.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"14","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Bagus Adapter","company_registration":"","contact_person":"Azlan Ali","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"B-3A-1, Megan Phoenix Business Park","address2":"Jalan 2\\/142A, Off Jalan Cheras","city":"Cheras","state":"Kuala Lumpur","zipcode":"56000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-09 12:19:34","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-09-10 11:38:08', 'admin'),
(1064, 'sales', 'delete', 'invoice', 10013, '{"id":"10013","txn_no":"1-10002","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-09-08 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-09-08 11:15:05","added_by":"admin","modified_on":"2015-09-08 11:16:46","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"36","invoice_id":"10013","type":"service","date":"2015-09-08 12:00:00","item_name":"Subaidah Website Upgrade","item_description":"- Content Management System\\n- Responsive Design\\n- Content Update","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2500.0000","price":"2500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"0","tax_code":""}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-09-10 11:38:10', 'admin'),
(1065, 'sales', 'delete', 'so', 10001, '{"id":"10001","txn_no":"1-10001","quote_id":"10001","invoice_id":null,"number":"0","pr_number":null,"po_number":"QUO-10001","date":"2015-08-04 00:00:00","due_date":"0000-00-00 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"TEST SDM BHD","contact_id":"9","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"false","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-08-04 10:38:47","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"1","sales_order_id":"10001","type":"product","date":"2015-08-04 00:00:00","item_name":"TEST ITEM []","item_description":"","item_id":"4","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"20.0000","price":"2000.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":{"4":[]},"services":null}', '2015-09-10 11:38:13', 'admin'),
(1066, 'sales', 'delete', 'quote', 10001, '{"id":"10001","txn_no":"1-10001","quote_id":null,"invoice_id":null,"sales_order_id":"0","number":"0","date":"2015-08-04 00:00:00","due_date":"2015-08-11 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"TEST SDM BHD","contact_id":"9","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TEST SDM BHD\\",\\"mobile\\":\\"1312321\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-08-04 10:36:43","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","quote_id":"10001","date":"2015-08-04 00:00:00","type":"product","item_id":"4","service_id":"0","item_name":"TEST ITEM []","item_description":"","discount":"0","discount_type":null,"qty":"100","price_per_unit":"20.0000","price":"2000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":{"4":[]},"services":null}', '2015-09-10 11:38:16', 'admin'),
(1067, 'sales', 'status_update', 'invoice', 10012, '{"id":"10012","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"32131","date":"2015-08-04 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"TEST SDM BHD","contact_id":"9","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TEST SDM BHD\\",\\"mobile\\":\\"1312321\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Delivered","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Paid","payment_date":"2015-08-04 12:43:09","payment_reference":"10004","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2000.00","total_delivered":"0.00","cost":null,"tags":"function","added_on":"2015-08-04 10:40:19","added_by":"admin","modified_on":"2015-08-04 12:19:05","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"15","invoice_id":"10012","type":"product","date":"2015-04-14 12:00:00","item_name":"5 PCS BRUSH [SR]","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"4.4000","price":"44.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"44.00","done":"0","no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"},{"id":"33","invoice_id":"10012","type":"product","date":"2015-08-04 12:00:00","item_name":"TEST ITEM []","item_description":"","item_id":"4","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"20.0000","price":"2000.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"2000.00","done":"0","no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":{"2":[],"4":[]},"services":null,"customer":[],"sale":null,"sale_items":null}', '2015-09-10 11:38:22', 'admin'),
(1068, 'sales', 'delete', 'invoice', 10012, '{"id":"10012","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"32131","date":"2015-08-04 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"TEST SDM BHD","contact_id":"9","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"TEST SDM BHD\\",\\"mobile\\":\\"1312321\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Delivered","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Paid","payment_date":"2015-08-04 12:43:09","payment_reference":"10004","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2000.00","total_delivered":"0.00","cost":null,"tags":"function","added_on":"2015-08-04 10:40:19","added_by":"admin","modified_on":"2015-08-04 12:19:05","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"15","invoice_id":"10012","type":"product","date":"2015-04-14 12:00:00","item_name":"5 PCS BRUSH [SR]","item_description":"","item_id":"2","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"10","price_per_unit":"4.4000","price":"44.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"44.00","done":"0","no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"},{"id":"33","invoice_id":"10012","type":"product","date":"2015-08-04 12:00:00","item_name":"TEST ITEM []","item_description":"","item_id":"4","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"100","price_per_unit":"20.0000","price":"2000.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"2000.00","done":"0","no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":{"2":[],"4":[]},"services":null,"customer":[],"sale":null,"sale_items":null}', '2015-09-10 11:38:28', 'admin'),
(1069, 'sales', 'status_update', 'cn', 10001, '{"id":"10001","txn_no":"1-10001","dn_number":"","date":"2015-08-04 00:00:00","contact_person":"Administrator ","received_date":null,"contact":"TEST SDM BHD","contact_id":"9","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":null,"terms":"Credit","remarks":"","status":"Pending","payment_status":"Paid","payment_date":"2015-08-04 12:38:06","payment_reference":"10010","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"100.00","total_received":"0.00","tags":"","added_on":"2015-08-04 10:44:33","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"1","credit_note_id":"10001","date":"2015-08-04 00:00:00","item_id":"4","item_name":"TEST ITEM []","item_description":null,"discount":"0","discount_type":null,"qty":"5","price_per_unit":"20.0000","price":"100.00","cost":"0.0000","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1"}],"products":{"4":[]}}', '2015-09-10 11:38:36', 'admin'),
(1070, 'inventory', 'status_update', 'po', 10016, '{"id":"10016","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-08-11 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"KUANCHAN (PG) LIQUOR DISTRIBUTORS SDN BHD","supplier_id":"9","supplier_address":"{\\"address1\\":\\"17 LINTANG BURMA\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"10250\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"360.00","total_received":null,"payment_status":"Paid","payment_date":"2015-08-11 13:57:33","payment_reference":"10013","payment_contra":null,"tags":"","added_on":"2015-08-11 13:56:33","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"orders":[{"id":"78","purchase_order_id":"10016","date":"2015-08-11 00:00:00","item_description":null,"item_name":"PAULANER HEFE 500ML ()","item_id":"6","discount":"0","discount_type":null,"qty":"20","price_per_unit":"18.0000","price":"360.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"6":[]}}', '2015-09-10 11:39:04', 'admin'),
(1071, 'inventory', 'status_update', 'po', 10016, '{"id":"10016","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-08-11 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"KUANCHAN (PG) LIQUOR DISTRIBUTORS SDN BHD","supplier_id":"9","supplier_address":"{\\"address1\\":\\"17 LINTANG BURMA\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"10250\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"360.00","total_received":"0.00","payment_status":"Paid","payment_date":"2015-08-11 13:57:33","payment_reference":"10013","payment_contra":null,"tags":"","added_on":"2015-08-11 13:56:33","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"orders":[{"id":"78","purchase_order_id":"10016","date":"2015-08-11 00:00:00","item_description":null,"item_name":"PAULANER HEFE 500ML ()","item_id":"6","discount":"0","discount_type":null,"qty":"20","price_per_unit":"18.0000","price":"360.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"6":[]}}', '2015-09-10 11:39:08', 'admin'),
(1072, 'inventory', 'delete', 'po', 10016, '{"id":"10016","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-08-11 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"KUANCHAN (PG) LIQUOR DISTRIBUTORS SDN BHD","supplier_id":"9","supplier_address":"{\\"address1\\":\\"17 LINTANG BURMA\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"10250\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"360.00","total_received":"0.00","payment_status":"Paid","payment_date":"2015-08-11 13:57:33","payment_reference":"10013","payment_contra":null,"tags":"","added_on":"2015-08-11 13:56:33","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"orders":[{"id":"78","purchase_order_id":"10016","date":"2015-08-11 00:00:00","item_description":null,"item_name":"PAULANER HEFE 500ML ()","item_id":"6","discount":"0","discount_type":null,"qty":"20","price_per_unit":"18.0000","price":"360.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"6":[]}}', '2015-09-10 11:39:13', 'admin'),
(1073, 'inventory', 'status_update', 'po', 10015, '{"id":"10015","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-08-04 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":null,"supplier_id":"0","supplier_address":"{\\"address1\\":null,\\"address2\\":null,\\"zipcode\\":null,\\"city\\":null,\\"state\\":null,\\"country\\":null}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"500.00","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-08-04 10:57:18","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"1","total_tax":"0.00","assigned_to":null,"orders":[{"id":"76","purchase_order_id":"10015","date":"2015-08-04 00:00:00","item_description":null,"item_name":"TEST ITEM ()","item_id":"4","discount":"12","discount_type":null,"qty":"100","price_per_unit":"5.0000","price":"500.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"4":[]}}', '2015-09-10 11:39:17', 'admin'),
(1074, 'inventory', 'delete', 'po', 10015, '{"id":"10015","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-08-04 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":null,"supplier_id":"0","supplier_address":"{\\"address1\\":null,\\"address2\\":null,\\"zipcode\\":null,\\"city\\":null,\\"state\\":null,\\"country\\":null}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"500.00","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-08-04 10:57:18","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"1","total_tax":"0.00","assigned_to":null,"orders":[{"id":"76","purchase_order_id":"10015","date":"2015-08-04 00:00:00","item_description":null,"item_name":"TEST ITEM ()","item_id":"4","discount":"12","discount_type":null,"qty":"100","price_per_unit":"5.0000","price":"500.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"4":[]}}', '2015-09-10 11:39:20', 'admin'),
(1075, 'contacts', 'edit', 'contact', 13, '{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"0.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2015-10-07 04:48:19","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-10-07 04:48:19', 'admin'),
(1076, 'contacts', 'edit', 'contact', 14, '{"id":"14","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Bagus Adapter","company_registration":"","contact_person":"Azlan Ali","contact_number":"","credit_limit":"0.00","credit_term":"0","discount_limit":"10.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"B-3A-1, Megan Phoenix Business Park","address2":"Jalan 2\\/142A, Off Jalan Cheras","city":"Cheras","state":"Kuala Lumpur","zipcode":"56000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-09 12:19:34","added_by":"admin","modified_on":"2015-10-07 07:36:04","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-10-07 07:36:04', 'admin'),
(1077, 'cc', 'edit', 'cc', 4, '{"id":"4","name":"Master Card","percentage":"1.80","tax":"6.00","enabled":"0"}', '2015-10-11 13:59:48', 'admin'),
(1078, 'cc', 'edit', 'cc', 5, '{"id":"5","name":"VISA","percentage":"1.12","tax":"6.00","enabled":"1"}', '2015-10-11 13:59:55', 'admin'),
(1079, 'cc', 'edit', 'cc', 4, '{"id":"4","name":"Master Card","percentage":"1.80","tax":"0.00","enabled":"0"}', '2015-10-11 14:01:06', 'admin'),
(1080, 'cc', 'edit', 'cc', 6, '{"id":"6","name":"AMEX","percentage":"2.75","tax":"6.00","enabled":"1"}', '2015-10-11 14:01:09', 'admin'),
(1081, 'cc', 'edit', 'cc', 7, '{"id":"7","name":"MEPS","percentage":"1.50","tax":"6.00","enabled":"1"}', '2015-10-11 14:01:41', 'admin'),
(1082, 'cc', 'edit', 'cc', 7, '{"id":"7","name":"MEPS","percentage":"1.50","tax":"6.00","enabled":"1"}', '2015-10-11 14:01:49', 'admin'),
(1083, 'cc', 'edit', 'cc', 7, '{"id":"7","name":"MEPS","percentage":"1.50","tax":"5.00","enabled":"1"}', '2015-10-11 14:01:52', 'admin'),
(1084, 'cc', 'edit', 'cc', 6, '{"id":"6","name":"AMEX","percentage":"2.75","tax":"5.00","enabled":"1"}', '2015-10-11 14:01:55', 'admin'),
(1085, 'cc', 'edit', 'cc', 5, '{"id":"5","name":"VISA","percentage":"1.12","tax":"5.00","enabled":"1"}', '2015-10-11 14:01:58', 'admin'),
(1086, 'cc', 'edit', 'cc', 4, '{"id":"4","name":"Master Card","percentage":"1.80","tax":"5.00","enabled":"0"}', '2015-10-11 14:02:00', 'admin'),
(1087, 'cc', 'edit', 'cc', 7, '{"id":"7","name":"MEPS","percentage":"1.50","tax":"6.00","enabled":"1"}', '2015-10-11 14:02:04', 'admin'),
(1088, 'cc', 'edit', 'cc', 6, '{"id":"6","name":"AMEX","percentage":"2.75","tax":"6.00","enabled":"1"}', '2015-10-11 14:02:07', 'admin'),
(1089, 'cc', 'edit', 'cc', 5, '{"id":"5","name":"VISA","percentage":"1.12","tax":"6.00","enabled":"1"}', '2015-10-11 14:02:10', 'admin'),
(1090, 'cc', 'edit', 'cc', 4, '{"id":"4","name":"Master Card","percentage":"1.80","tax":"6.00","enabled":"1"}', '2015-10-11 14:02:13', 'admin'),
(1091, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"0"}', '2015-10-11 16:50:35', 'admin'),
(1092, 'contacts', 'add', 'contact', 15, '{"id":"15","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"","company_registration":"","contact_person":"Open Quotation","contact_number":"","credit_limit":"0.00","credit_term":"0","discount_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-10-17 09:29:24","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-10-17 09:29:24', 'admin'),
(1093, 'sales', 'add', 'quote', 10002, '{"id":"10002","txn_no":"1-10001","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2015-10-17 00:00:00","due_date":"2015-10-24 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Open Quotation","contact_id":"15","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Open Quotation\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4800.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-10-17 09:38:21","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"2","quote_id":"10002","date":"2015-10-17 00:00:00","type":"service","item_id":"0","service_id":"10003","item_name":"Warehouse + Retail POS ","item_description":"MODULES\\nPoint of Sales\\nInventory Management\\nStock Count Module\\nReporting Module\\nGST Module\\nSales & Invoicing Module\\n\\nTRAINING\\n2 x 3 Hour Session\\n","discount":"0","discount_type":null,"qty":"1","price_per_unit":"4800.0000","price":"4800.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2015-10-17 09:38:21', 'admin'),
(1094, 'sales', 'add', 'invoice', 10015, '{"id":"10015","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-10-24 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1100.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-10-24 10:04:36","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"39","invoice_id":"10015","type":"service","date":"2015-10-24 12:00:00","item_name":"Custom Order","item_description":"","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1100.0000","price":"1100.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"0.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2015-10-07 04:48:19","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-10-24 10:04:36', 'admin'),
(1095, 'sales', 'deliver', 'invoice', 10015, '{"id":"10015","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-10-24 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1100.00","total_delivered":"1100.00","cost":null,"tags":"","added_on":"2015-10-24 10:04:36","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"39","invoice_id":"10015","type":"service","date":"2015-10-24 12:00:00","item_name":"Custom Order","item_description":"","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1100.0000","price":"1100.00","cost":null,"margin":null,"delivered":"1","delivered_price":"1100.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"0.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2015-10-07 04:48:19","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-10-24 10:04:43', 'admin'),
(1096, 'sales', 'status_update', 'invoice', 10015, '{"id":"10015","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-10-24 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1100.00","total_delivered":"1100.00","cost":null,"tags":"","added_on":"2015-10-24 10:04:36","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"39","invoice_id":"10015","type":"service","date":"2015-10-24 12:00:00","item_name":"Custom Order","item_description":"","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1100.0000","price":"1100.00","cost":null,"margin":null,"delivered":"1","delivered_price":"1100.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"0.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2015-10-07 04:48:19","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-10-24 10:04:44', 'admin'),
(1097, 'inventory', 'add', 'item', NULL, '[]', '2015-10-26 15:02:56', 'admin'),
(1098, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"1"}', '2015-10-26 15:03:11', 'admin'),
(1099, 'contacts', 'add', 'contact', 16, '{"id":"16","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"JStudio","company_registration":"002127464-K","contact_person":"Amin","contact_number":"","credit_limit":"0.00","credit_term":"0","discount_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Kuala Lumpur","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-10-27 00:01:45","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-10-27 00:01:45', 'admin'),
(1100, 'sales', 'add', 'quote', 10003, '{"id":"10003","txn_no":"1-10242","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2015-10-27 00:00:00","due_date":"2015-11-03 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"JStudio","contact_id":"16","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"JStudio\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-10-27 00:03:56","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"3","quote_id":"10003","date":"2015-10-27 00:00:00","type":"service","item_id":"0","service_id":"10003","item_name":"Custom Order WP Plugin","item_description":"- Product Custom Order\\n- WooCommerce Integration\\n- Custom Order Option Management\\n- Shortcode Plugin","discount":"0","discount_type":null,"qty":"1","price_per_unit":"1000.0000","price":"1000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2015-10-27 00:03:56', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(1101, 'sales', 'status_update', 'invoice', 10015, '{"id":"10015","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-10-24 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Paid","payment_date":"2015-10-24 10:05:05","payment_reference":"10007","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1100.00","total_delivered":"0.00","cost":null,"tags":"","added_on":"2015-10-24 10:04:36","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":null,"orders":[{"id":"39","invoice_id":"10015","type":"service","date":"2015-10-24 12:00:00","item_name":"Custom Order","item_description":"","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1100.0000","price":"1100.00","cost":"0.00","margin":null,"delivered":"0","delivered_price":"1100.00","done":"0","no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"0.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2015-10-07 04:48:19","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-10-29 12:28:56', 'admin'),
(1102, 'sales', 'edit', 'invoice', 10015, '{"id":"10015","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-10-24 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Paid","payment_date":"2015-10-24 10:05:05","payment_reference":"10007","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1100.00","total_delivered":"0.00","cost":null,"tags":"","added_on":"2015-10-24 10:04:36","added_by":"admin","modified_on":"2015-10-29 12:29:01","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"13","orders":[{"id":"40","invoice_id":"10015","type":"service","date":"2015-10-24 12:00:00","item_name":"Custom Order","item_description":"","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1100.0000","price":"1100.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"0","tax_code":""}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"0.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2015-10-07 04:48:19","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-10-29 12:29:01', 'admin'),
(1103, 'sales', 'add', 'invoice', 10016, '{"id":"10016","txn_no":"1-10002","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-10-29 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-10-29 12:29:13","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"14","orders":null,"products":null,"services":null,"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"0.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2015-10-07 04:48:19","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-10-29 12:29:13', 'admin'),
(1104, 'contacts', 'edit', 'contact', 16, '{"id":"16","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"1","company_name":"JStudio","company_registration":"002127464-K","contact_person":"Amin","contact_number":"","credit_limit":"0.00","credit_term":"0","discount_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Kuala Lumpur","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-10-27 00:01:45","added_by":"admin","modified_on":"2015-10-29 14:56:37","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""}', '2015-10-29 14:56:37', 'admin'),
(1105, 'sales', 'add', 'invoice', 10017, '{"id":"10017","txn_no":"1-10003","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-11-03 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"20.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-11-03 13:45:26","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"1.13\\"}]","total_tax":"1.13","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","orders":[{"id":"42","invoice_id":"10017","type":"product","date":"2015-11-03 12:00:00","item_name":"TEST ITEM [SR]","item_description":"","item_id":"7","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"20.0000","price":"20.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"}],"products":{"7":{"id":"7","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-10-26 15:02:56","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-10-26 15:03:25","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}},"services":null,"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":null,"is_prospect":null,"company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"0.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2015-10-07 04:48:19","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":""},"sale":null,"sale_items":null}', '2015-11-03 13:45:26', 'admin'),
(1106, 'inventory', 'edit', 'item', 7, '{"id":"7","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEMTEST ITEMTEST ITEMTEST ITEMTEST ITEM","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"-3","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-10-26 15:02:56","added_by":"admin","modified_on":"2015-11-05 12:32:46","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-10-26 15:03:25","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}', '2015-11-05 12:32:46', 'admin'),
(1107, 'sales', 'add', 'so', 10002, '{"id":"10002","txn_no":"1-10001","quote_id":"10003","invoice_id":null,"number":"0","pr_number":null,"po_number":"QUO-10003","date":"2015-10-27 00:00:00","due_date":"0000-00-00 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"JStudio","contact_id":"16","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"false","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_gateway":null,"payment_method":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-11-09 07:38:51","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"2","sales_order_id":"10002","type":"service","date":"2015-10-27 00:00:00","item_name":"Custom Order WP Plugin - 50% Project Initiation Fee","item_description":"- Product Custom Order\\n- WooCommerce Integration\\n- Custom Order Option Management\\n- Shortcode Plugin","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"500.0000","price":"500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2015-11-09 07:38:51', 'admin'),
(1108, 'sales', 'status_update', 'so', 10002, '{"id":"10002","txn_no":"1-10001","quote_id":"10003","invoice_id":null,"number":"0","pr_number":null,"po_number":"QUO-10003","date":"2015-10-27 00:00:00","due_date":"0000-00-00 00:00:00","received_date":null,"contact_person":"Administrator ","contact":"JStudio","contact_id":"16","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"false","terms":"Credit","duration":"0","remarks":"","status":"Completed","payment_gateway":null,"payment_method":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"shipping":null,"shipping_id":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-11-09 07:38:51","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","orders":[{"id":"2","sales_order_id":"10002","type":"service","date":"2015-10-27 00:00:00","item_name":"Custom Order WP Plugin - 50% Project Initiation Fee","item_description":"- Product Custom Order\\n- WooCommerce Integration\\n- Custom Order Option Management\\n- Shortcode Plugin","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"500.0000","price":"500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0"}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2015-11-09 07:39:03', 'admin'),
(1109, 'sales', 'add', 'invoice', 10018, '{"id":"10018","txn_no":"1-10004","quote_id":"10003","sales_order_id":"10002","number":"0","po_number":"QUO-10003","date":"2015-10-27 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"JStudio","contact_id":"16","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-11-09 07:39:28","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","referrer_contact_id":"0","orders":[{"id":"43","invoice_id":"10018","type":"service","date":"2015-10-27 12:00:00","item_name":"Custom Order WP Plugin - 50% Project Initiation Fee","item_description":"- Product Custom Order\\n- WooCommerce Integration\\n- Custom Order Option Management\\n- Shortcode Plugin","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"500.0000","price":"500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1","taxable":null,"tax_code":null}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"16","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"1","company_name":"JStudio","company_registration":"002127464-K","contact_person":"Amin","contact_number":"","credit_limit":"0.00","credit_term":"0","discount_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Kuala Lumpur","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-10-27 00:01:45","added_by":"admin","modified_on":"2015-10-29 14:56:37","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2015-11-09 07:39:28', 'admin'),
(1110, 'sales', 'add', 'quote', 10004, '{"id":"10004","txn_no":"1-10243","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2015-11-17 00:00:00","due_date":"2015-11-26 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"JStudio","contact_id":"16","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"JStudio\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"7000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-11-17 08:41:26","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"4","quote_id":"10004","date":"2015-11-17 00:00:00","type":"service","item_id":"0","service_id":"10003","item_name":"WYSIWYG Content Management System &#40;PlexCMS&#41;","item_description":"- Mail Blast Module\\n- User Membership Module\\n- Plexcart with Payment Gateway Integration\\n- User-based Content Module","discount":"0","discount_type":null,"qty":"1","price_per_unit":"7000.0000","price":"7000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2015-11-17 08:41:26', 'admin'),
(1111, 'inventory', 'add', 'po', 10017, '{"id":"10017","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Subaidah Holdings Sdn. Bhd.","supplier_id":"13","supplier_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10.60","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 10:50:05","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.60\\"}]","tax_inclusive":"0","total_tax":"0.60","assigned_to":null,"paid_amount":null,"orders":[{"id":"80","purchase_order_id":"10017","date":"2015-11-17 00:00:00","item_description":null,"item_name":"TEST ITEMTEST ITEMTEST ITEMTEST ITEMTEST ITEM ()","item_id":"7","discount":"0","discount_type":null,"qty":"1","price_per_unit":"10.0000","price":"10.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"TX"}],"products":{"7":{"id":"7","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEMTEST ITEMTEST ITEMTEST ITEMTEST ITEM","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"-7","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-10-26 15:02:56","added_by":"admin","modified_on":"2015-11-05 12:32:46","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-11-05 12:36:56","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-11-17 10:50:05', 'admin'),
(1112, 'inventory', 'add', 'po', 10018, '{"id":"10018","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Subaidah Holdings Sdn. Bhd.","supplier_id":"13","supplier_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10.60","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 10:54:37","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.60\\"}]","tax_inclusive":"0","total_tax":"0.60","assigned_to":null,"paid_amount":null,"orders":[{"id":"81","purchase_order_id":"10018","date":"2015-11-17 00:00:00","item_description":null,"item_name":"TEST ITEMTEST ITEMTEST ITEMTEST ITEMTEST ITEM ()","item_id":"7","discount":"0","discount_type":null,"qty":"1","price_per_unit":"10.0000","price":"10.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"TX"}],"products":{"7":{"id":"7","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEMTEST ITEMTEST ITEMTEST ITEMTEST ITEM","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"-7","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-10-26 15:02:56","added_by":"admin","modified_on":"2015-11-05 12:32:46","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-11-05 12:36:56","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}}}', '2015-11-17 10:54:37', 'admin'),
(1113, 'inventory', 'delete', 'item', 7, '{"id":"7","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEMTEST ITEMTEST ITEMTEST ITEMTEST ITEM","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"-7","alert_quantity":"0","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-10-26 15:02:56","added_by":"admin","modified_on":"2015-11-05 12:32:46","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-11-05 12:36:56","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}', '2015-11-17 10:55:40', 'admin'),
(1114, 'inventory', 'add', 'item', NULL, '[]', '2015-11-17 10:55:54', 'admin'),
(1115, 'inventory', 'delete', 'po', 10017, '{"id":"10017","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Subaidah Holdings Sdn. Bhd.","supplier_id":"13","supplier_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10.60","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 10:50:05","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.60\\"}]","tax_inclusive":"0","total_tax":"0.60","assigned_to":null,"paid_amount":null,"orders":[{"id":"80","purchase_order_id":"10017","date":"2015-11-17 00:00:00","item_description":null,"item_name":"TEST ITEMTEST ITEMTEST ITEMTEST ITEMTEST ITEM ()","item_id":"7","discount":"0","discount_type":null,"qty":"1","price_per_unit":"10.0000","price":"10.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"TX"}],"products":{"7":[]}}', '2015-11-17 10:56:00', 'admin'),
(1116, 'inventory', 'delete', 'po', 10018, '{"id":"10018","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Subaidah Holdings Sdn. Bhd.","supplier_id":"13","supplier_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10.60","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 10:54:37","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.60\\"}]","tax_inclusive":"0","total_tax":"0.60","assigned_to":null,"paid_amount":null,"orders":[{"id":"81","purchase_order_id":"10018","date":"2015-11-17 00:00:00","item_description":null,"item_name":"TEST ITEMTEST ITEMTEST ITEMTEST ITEMTEST ITEM ()","item_id":"7","discount":"0","discount_type":null,"qty":"1","price_per_unit":"10.0000","price":"10.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"TX"}],"products":{"7":[]}}', '2015-11-17 10:56:02', 'admin'),
(1117, 'inventory', 'add', 'po', 10019, '{"id":"10019","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Subaidah Holdings Sdn. Bhd.","supplier_id":"13","supplier_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 10:56:57","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"83","purchase_order_id":"10019","date":"2015-11-17 00:00:00","item_description":null,"item_name":"TEST ITEM ()","item_id":"8","discount":"0","discount_type":null,"qty":"1","price_per_unit":"10.0000","price":"10.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"8":{"id":"8","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"10","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:55:54","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-11-17 10:56:57', 'admin'),
(1118, 'inventory', 'delete', 'item', 8, '{"id":"8","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"10","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:55:54","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}', '2015-11-17 10:57:27', 'admin'),
(1119, 'inventory', 'add', 'item', NULL, '[]', '2015-11-17 10:57:38', 'admin'),
(1120, 'inventory', 'add', 'po', 10020, '{"id":"10020","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Bagus Adapter","supplier_id":"14","supplier_address":"{\\"address1\\":\\"B-3A-1, Megan Phoenix Business Park\\",\\"address2\\":\\"Jalan 2\\\\\\/142A, Off Jalan Cheras\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 10:57:59","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"85","purchase_order_id":"10020","date":"2015-11-17 00:00:00","item_description":null,"item_name":"TEST ITEM ()","item_id":"9","discount":"0","discount_type":null,"qty":"1","price_per_unit":"10.0000","price":"10.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"9":{"id":"9","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"TEST ITEM","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"10","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:57:38","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-11-17 10:57:59', 'admin'),
(1121, 'inventory', 'add', 'item', NULL, '[]', '2015-11-17 10:59:53', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(1122, 'inventory', 'add', 'po', 10021, '{"id":"10021","txn_no":"1-10003","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Subaidah Holdings Sdn. Bhd.","supplier_id":"13","supplier_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 11:00:08","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"87","purchase_order_id":"10021","date":"2015-11-17 00:00:00","item_description":null,"item_name":"test ()","item_id":"10","discount":"0","discount_type":null,"qty":"1","price_per_unit":"10.0000","price":"10.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-11-17 11:00:08', 'admin'),
(1123, 'inventory', 'add', 'po', 10022, '{"id":"10022","txn_no":"1-10004","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"JStudio","supplier_id":"16","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 11:00:53","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"88","purchase_order_id":"10022","date":"2015-11-17 00:00:00","item_description":null,"item_name":"test ()","item_id":"10","discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-11-17 11:00:53', 'admin'),
(1124, 'inventory', 'add', 'po', 10023, '{"id":"10023","txn_no":"1-10005","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"","received_date":null,"supplier":"Bagus Adapter","supplier_id":"14","supplier_address":"{\\"address1\\":\\"B-3A-1, Megan Phoenix Business Park\\",\\"address2\\":\\"Jalan 2\\\\\\/142A, Off Jalan Cheras\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 11:01:22","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"89","purchase_order_id":"10023","date":"2015-11-17 00:00:00","item_description":null,"item_name":"test ()","item_id":"10","discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-11-17 11:01:22', 'admin'),
(1125, 'inventory', 'add', 'po', 10024, '{"id":"10024","txn_no":"1-10006","invoice_number":"","pr_id":"0","number":null,"date":"2015-12-03 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"JStudio","supplier_id":"16","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"100.00","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-12-03 19:26:06","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"90","purchase_order_id":"10024","date":"2015-12-03 00:00:00","item_description":null,"item_name":"test ()","item_id":"10","discount":"0","discount_type":null,"qty":"100","price_per_unit":"1.0000","price":"100.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"-12","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-12-03 19:23:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-12-03 19:26:06', 'admin'),
(1126, 'inventory', 'receive', 'po', 10024, '{"id":"10024","txn_no":"1-10006","invoice_number":"","pr_id":"0","number":null,"date":"2015-12-03 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"JStudio","supplier_id":"16","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"100.00","total_received":"100.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-12-03 19:26:06","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"90","purchase_order_id":"10024","date":"2015-12-03 00:00:00","item_description":null,"item_name":"test ()","item_id":"10","discount":"0","discount_type":null,"qty":"100","price_per_unit":"1.0000","price":"100.00","received":"100","received_price":"100.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"88","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-12-03 19:23:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-12-03 19:26:26', 'admin'),
(1127, 'inventory', 'status_update', 'po', 10024, '{"id":"10024","txn_no":"1-10006","invoice_number":"","pr_id":"0","number":null,"date":"2015-12-03 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"JStudio","supplier_id":"16","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"100.00","total_received":"100.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-12-03 19:26:06","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"90","purchase_order_id":"10024","date":"2015-12-03 00:00:00","item_description":null,"item_name":"test ()","item_id":"10","discount":"0","discount_type":null,"qty":"100","price_per_unit":"1.0000","price":"100.00","received":"100","received_price":"100.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"88","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-12-03 19:23:47","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-12-03 19:26:26', 'admin'),
(1128, 'contacts', 'add', 'contact', 18, '{"id":"18","is_customer":"0","is_supplier":null,"is_debtor":null,"is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Eazyla Marketing","company_registration":"PG0010322-K","contact_person":"Hong Guan","contact_number":"","credit_limit":"0.00","credit_term":"0","discount_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Pulau Pinang","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-12-07 09:55:17","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null}', '2015-12-07 09:55:17', 'admin'),
(1129, 'sales', 'add', 'invoice', 10019, '{"id":"10019","txn_no":"1-10005","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-12-07 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Eazyla Marketing","contact_id":"18","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Eazyla Marketing\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-12-07 09:59:31","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":null,"orders":[{"id":"44","invoice_id":"10019","type":"service","date":"2015-12-07 12:00:00","item_name":"China Freight Management and Tracking - Project Initiation Fee 50%","item_description":"Order Placement\\nCustomer Account \\nCustomer Credits Management","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1000.0000","price":"1000.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"18","is_customer":"0","is_supplier":null,"is_debtor":null,"is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Eazyla Marketing","company_registration":"PG0010322-K","contact_person":"Hong Guan","contact_number":"","credit_limit":"0.00","credit_term":"0","discount_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Pulau Pinang","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-12-07 09:55:17","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2015-12-07 09:59:31', 'admin'),
(1130, 'sales', 'edit', 'invoice', 10016, '{"id":"10016","txn_no":"1-10002","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-10-29 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"26.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-10-29 12:29:13","added_by":"admin","modified_on":"2015-12-15 08:44:53","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"14","paid_amount":null,"orders":[{"id":"45","invoice_id":"10016","type":"product","date":"2015-10-29 12:00:00","item_name":"test []","item_description":"","item_id":"10","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"26.0000","price":"26.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"78","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-12-04 12:21:40","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":null,"is_prospect":null,"company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"0.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2015-10-07 04:48:19","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2015-12-15 08:44:53', 'admin'),
(1131, 'sales', 'add', 'cn', 10002, '{"id":"10002","txn_no":"1-10001","dn_number":"","date":"2015-12-15 00:00:00","contact_person":"Administrator ","received_date":null,"contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":null,"terms":"Credit","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"26.00","total_received":null,"tags":"","added_on":"2015-12-15 08:52:27","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"paid_amount":null,"orders":[{"id":"2","credit_note_id":"10002","date":"2015-12-15 00:00:00","item_id":"10","item_name":"test []","item_description":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"26.0000","price":"26.00","cost":null,"received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"78","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-12-04 12:21:40","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-12-15 08:52:27', 'admin'),
(1132, 'sales', 'deliver', 'invoice', 10015, '{"id":"10015","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-10-24 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":"2015-10-24 10:05:05","payment_reference":"","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1100.00","total_delivered":"1100.00","cost":null,"tags":"","added_on":"2015-10-24 10:04:36","added_by":"admin","modified_on":"2015-10-29 12:29:01","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"13","paid_amount":null,"orders":[{"id":"40","invoice_id":"10015","type":"service","date":"2015-10-24 12:00:00","item_name":"Custom Order","item_description":"","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1100.0000","price":"1100.00","cost":null,"margin":null,"delivered":"1","delivered_price":"1100.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"0","tax_code":""}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":null,"is_prospect":null,"company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"0.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2015-10-07 04:48:19","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2015-12-15 12:08:36', 'admin'),
(1133, 'sales', 'status_update', 'invoice', 10015, '{"id":"10015","txn_no":"1-10001","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-10-24 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":"2015-10-24 10:05:05","payment_reference":"","payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1100.00","total_delivered":"1100.00","cost":null,"tags":"","added_on":"2015-10-24 10:04:36","added_by":"admin","modified_on":"2015-10-29 12:29:01","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"13","paid_amount":null,"orders":[{"id":"40","invoice_id":"10015","type":"service","date":"2015-10-24 12:00:00","item_name":"Custom Order","item_description":"","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1100.0000","price":"1100.00","cost":null,"margin":null,"delivered":"1","delivered_price":"1100.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"0","tax_code":""}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":null,"is_prospect":null,"company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"0.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2015-10-07 04:48:19","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2015-12-15 12:08:38', 'admin'),
(1134, 'inventory', 'receive', 'po', 10019, '{"id":"10019","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Subaidah Holdings Sdn. Bhd.","supplier_id":"13","supplier_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10.00","total_received":"10.00","payment_status":"Unpaid","payment_date":"2015-12-15 11:07:53","payment_reference":"10021","payment_contra":null,"tags":"","added_on":"2015-11-17 10:56:57","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"83","purchase_order_id":"10019","date":"2015-11-17 00:00:00","item_description":null,"item_name":"TEST ITEM ()","item_id":"8","discount":"0","discount_type":null,"qty":"1","price_per_unit":"10.0000","price":"10.00","received":"1","received_price":"10.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"8":[]}}', '2015-12-16 11:25:28', 'admin'),
(1135, 'inventory', 'status_update', 'po', 10019, '{"id":"10019","txn_no":"1-10001","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Subaidah Holdings Sdn. Bhd.","supplier_id":"13","supplier_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10.00","total_received":"10.00","payment_status":"Unpaid","payment_date":"2015-12-15 11:07:53","payment_reference":"10021","payment_contra":null,"tags":"","added_on":"2015-11-17 10:56:57","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"83","purchase_order_id":"10019","date":"2015-11-17 00:00:00","item_description":null,"item_name":"TEST ITEM ()","item_id":"8","discount":"0","discount_type":null,"qty":"1","price_per_unit":"10.0000","price":"10.00","received":"1","received_price":"10.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"8":[]}}', '2015-12-16 11:25:28', 'admin'),
(1136, 'inventory', 'receive', 'po', 10023, '{"id":"10023","txn_no":"1-10005","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"","received_date":null,"supplier":"Bagus Adapter","supplier_id":"14","supplier_address":"{\\"address1\\":\\"B-3A-1, Megan Phoenix Business Park\\",\\"address2\\":\\"Jalan 2\\\\\\/142A, Off Jalan Cheras\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 11:01:22","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"89","purchase_order_id":"10023","date":"2015-11-17 00:00:00","item_description":null,"item_name":"test ()","item_id":"10","discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","received":"1","received_price":"0.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"79","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-12-04 12:21:40","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-12-16 11:25:36', 'admin'),
(1137, 'inventory', 'status_update', 'po', 10023, '{"id":"10023","txn_no":"1-10005","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"","received_date":null,"supplier":"Bagus Adapter","supplier_id":"14","supplier_address":"{\\"address1\\":\\"B-3A-1, Megan Phoenix Business Park\\",\\"address2\\":\\"Jalan 2\\\\\\/142A, Off Jalan Cheras\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 11:01:22","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"89","purchase_order_id":"10023","date":"2015-11-17 00:00:00","item_description":null,"item_name":"test ()","item_id":"10","discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","received":"1","received_price":"0.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"79","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-12-04 12:21:40","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-12-16 11:25:36', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(1138, 'inventory', 'receive', 'po', 10022, '{"id":"10022","txn_no":"1-10004","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"JStudio","supplier_id":"16","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 11:00:53","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"88","purchase_order_id":"10022","date":"2015-11-17 00:00:00","item_description":null,"item_name":"test ()","item_id":"10","discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","received":"1","received_price":"0.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"80","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-12-04 12:21:40","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-12-16 11:25:44', 'admin'),
(1139, 'inventory', 'status_update', 'po', 10022, '{"id":"10022","txn_no":"1-10004","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"JStudio","supplier_id":"16","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 11:00:53","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"88","purchase_order_id":"10022","date":"2015-11-17 00:00:00","item_description":null,"item_name":"test ()","item_id":"10","discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","received":"1","received_price":"0.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"80","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-12-04 12:21:40","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-12-16 11:25:44', 'admin'),
(1140, 'inventory', 'status_update', 'po', 10023, '{"id":"10023","txn_no":"1-10005","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"","received_date":null,"supplier":"Bagus Adapter","supplier_id":"14","supplier_address":"{\\"address1\\":\\"B-3A-1, Megan Phoenix Business Park\\",\\"address2\\":\\"Jalan 2\\\\\\/142A, Off Jalan Cheras\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"0\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 11:01:22","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"89","purchase_order_id":"10023","date":"2015-11-17 00:00:00","item_description":null,"item_name":"test ()","item_id":"10","discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"79","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-12-04 12:21:40","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-12-16 11:25:58', 'admin'),
(1141, 'inventory', 'edit', 'po', 10023, '{"id":"10023","txn_no":"1-10005","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Bagus Adapter","supplier_id":"14","supplier_address":"{\\"address1\\":\\"B-3A-1, Megan Phoenix Business Park\\",\\"address2\\":\\"Jalan 2\\\\\\/142A, Off Jalan Cheras\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10.00","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 11:01:22","added_by":"admin","modified_on":"2015-12-16 11:26:12","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":\\"10023\\",\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"91","purchase_order_id":"10023","date":"2015-11-17 00:00:00","item_description":null,"item_name":"test ()","item_id":"10","discount":"0","discount_type":null,"qty":"1","price_per_unit":"10.0000","price":"10.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"79","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-12-04 12:21:40","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-12-16 11:26:12', 'admin'),
(1142, 'inventory', 'status_update', 'po', 10022, '{"id":"10022","txn_no":"1-10004","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"JStudio","supplier_id":"16","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"0.00","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 11:00:53","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"88","purchase_order_id":"10022","date":"2015-11-17 00:00:00","item_description":null,"item_name":"test ()","item_id":"10","discount":"0","discount_type":null,"qty":"1","price_per_unit":"0.0000","price":"0.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"78","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-12-04 12:21:40","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-12-16 11:26:18', 'admin'),
(1143, 'inventory', 'edit', 'po', 10022, '{"id":"10022","txn_no":"1-10004","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"JStudio","supplier_id":"16","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10.00","total_received":"0.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 11:00:53","added_by":"admin","modified_on":"2015-12-16 11:26:25","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":\\"10022\\",\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"92","purchase_order_id":"10022","date":"2015-11-17 00:00:00","item_description":null,"item_name":"test ()","item_id":"10","discount":"0","discount_type":null,"qty":"1","price_per_unit":"10.0000","price":"10.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"78","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-12-04 12:21:40","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-12-16 11:26:25', 'admin'),
(1144, 'inventory', 'receive', 'po', 10023, '{"id":"10023","txn_no":"1-10005","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Bagus Adapter","supplier_id":"14","supplier_address":"{\\"address1\\":\\"B-3A-1, Megan Phoenix Business Park\\",\\"address2\\":\\"Jalan 2\\\\\\/142A, Off Jalan Cheras\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10.00","total_received":"10.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 11:01:22","added_by":"admin","modified_on":"2015-12-16 11:26:12","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":\\"10023\\",\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"91","purchase_order_id":"10023","date":"2015-11-17 00:00:00","item_description":null,"item_name":"test ()","item_id":"10","discount":"0","discount_type":null,"qty":"1","price_per_unit":"10.0000","price":"10.00","received":"1","received_price":"10.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"79","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-12-04 12:21:40","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-12-16 11:26:33', 'admin'),
(1145, 'inventory', 'status_update', 'po', 10023, '{"id":"10023","txn_no":"1-10005","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Bagus Adapter","supplier_id":"14","supplier_address":"{\\"address1\\":\\"B-3A-1, Megan Phoenix Business Park\\",\\"address2\\":\\"Jalan 2\\\\\\/142A, Off Jalan Cheras\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10.00","total_received":"10.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 11:01:22","added_by":"admin","modified_on":"2015-12-16 11:26:12","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":\\"10023\\",\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"91","purchase_order_id":"10023","date":"2015-11-17 00:00:00","item_description":null,"item_name":"test ()","item_id":"10","discount":"0","discount_type":null,"qty":"1","price_per_unit":"10.0000","price":"10.00","received":"1","received_price":"10.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"79","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-12-04 12:21:40","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-12-16 11:26:33', 'admin'),
(1146, 'inventory', 'receive', 'po', 10022, '{"id":"10022","txn_no":"1-10004","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"JStudio","supplier_id":"16","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10.00","total_received":"10.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 11:00:53","added_by":"admin","modified_on":"2015-12-16 11:26:25","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":\\"10022\\",\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"92","purchase_order_id":"10022","date":"2015-11-17 00:00:00","item_description":null,"item_name":"test ()","item_id":"10","discount":"0","discount_type":null,"qty":"1","price_per_unit":"10.0000","price":"10.00","received":"1","received_price":"10.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"80","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-12-04 12:21:40","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-12-16 11:26:40', 'admin'),
(1147, 'inventory', 'status_update', 'po', 10022, '{"id":"10022","txn_no":"1-10004","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"JStudio","supplier_id":"16","supplier_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Plex Solutions\\",\\"mobile\\":\\"0143076411\\",\\"address1\\":\\"No. 92, Tingkat 3 D''Piazza Mall\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"11950\\",\\"city\\":\\"Bayan Baru\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10.00","total_received":"10.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 11:00:53","added_by":"admin","modified_on":"2015-12-16 11:26:25","modified_by":"admin","division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":\\"10022\\",\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"92","purchase_order_id":"10022","date":"2015-11-17 00:00:00","item_description":null,"item_name":"test ()","item_id":"10","discount":"0","discount_type":null,"qty":"1","price_per_unit":"10.0000","price":"10.00","received":"1","received_price":"10.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"80","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-12-04 12:21:40","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-12-16 11:26:40', 'admin'),
(1148, 'inventory', 'receive', 'po', 10021, '{"id":"10021","txn_no":"1-10003","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Subaidah Holdings Sdn. Bhd.","supplier_id":"13","supplier_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10.00","total_received":"10.00","payment_status":"Unpaid","payment_date":"2015-12-15 11:07:53","payment_reference":"10021","payment_contra":null,"tags":"","added_on":"2015-11-17 11:00:08","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"87","purchase_order_id":"10021","date":"2015-11-17 00:00:00","item_description":null,"item_name":"test ()","item_id":"10","discount":"0","discount_type":null,"qty":"1","price_per_unit":"10.0000","price":"10.00","received":"1","received_price":"10.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"81","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-12-04 12:21:40","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-12-16 11:26:46', 'admin'),
(1149, 'inventory', 'status_update', 'po', 10021, '{"id":"10021","txn_no":"1-10003","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Subaidah Holdings Sdn. Bhd.","supplier_id":"13","supplier_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10.00","total_received":"10.00","payment_status":"Unpaid","payment_date":"2015-12-15 11:07:53","payment_reference":"10021","payment_contra":null,"tags":"","added_on":"2015-11-17 11:00:08","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"87","purchase_order_id":"10021","date":"2015-11-17 00:00:00","item_description":null,"item_name":"test ()","item_id":"10","discount":"0","discount_type":null,"qty":"1","price_per_unit":"10.0000","price":"10.00","received":"1","received_price":"10.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"81","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-12-04 12:21:40","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}}}', '2015-12-16 11:26:46', 'admin'),
(1150, 'inventory', 'receive', 'po', 10020, '{"id":"10020","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Bagus Adapter","supplier_id":"14","supplier_address":"{\\"address1\\":\\"B-3A-1, Megan Phoenix Business Park\\",\\"address2\\":\\"Jalan 2\\\\\\/142A, Off Jalan Cheras\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10.00","total_received":"10.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 10:57:59","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"85","purchase_order_id":"10020","date":"2015-11-17 00:00:00","item_description":null,"item_name":"TEST ITEM ()","item_id":"9","discount":"0","discount_type":null,"qty":"1","price_per_unit":"10.0000","price":"10.00","received":"1","received_price":"10.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"9":[]}}', '2015-12-16 11:26:52', 'admin'),
(1151, 'inventory', 'status_update', 'po', 10020, '{"id":"10020","txn_no":"1-10002","invoice_number":"","pr_id":"0","number":null,"date":"2015-11-17 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Bagus Adapter","supplier_id":"14","supplier_address":"{\\"address1\\":\\"B-3A-1, Megan Phoenix Business Park\\",\\"address2\\":\\"Jalan 2\\\\\\/142A, Off Jalan Cheras\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Received","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"10.00","total_received":"10.00","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2015-11-17 10:57:59","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","tax_inclusive":"0","total_tax":"0.00","assigned_to":null,"paid_amount":null,"orders":[{"id":"85","purchase_order_id":"10020","date":"2015-11-17 00:00:00","item_description":null,"item_name":"TEST ITEM ()","item_id":"9","discount":"0","discount_type":null,"qty":"1","price_per_unit":"10.0000","price":"10.00","received":"1","received_price":"10.00","done":null,"division_id":null,"warehouse_id":"1","taxable":"0","tax_code":""}],"products":{"9":[]}}', '2015-12-16 11:26:52', 'admin'),
(1152, 'inventory', 'status_update', 'dn', 10004, '{"id":"10004","txn_no":"1-10002","cn_number":"","date":"2015-12-15 00:00:00","contact_person":"","received_date":null,"supplier":"Subaidah Holdings Sdn. Bhd.","supplier_id":"13","supplier_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":null,"terms":"Credit","remarks":"Overpaid for PV-10020","status":"Returned","payment_status":"Unpaid","payment_reference":null,"payment_date":"2015-12-15 11:07:53","payment_contra":"10021","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"","total":"5.00","total_received":null,"tags":"","added_on":"2015-12-15 10:12:06","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"paid_amount":null,"orders":[{"id":"4","debit_note_id":"10004","date":"2015-12-15 00:00:00","item_id":"0","item_name":"Overpaid for PV-10020","item_description":"","discount":"","discount_type":"","qty":"1","price_per_unit":"5.0000","price":"5.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1"}],"products":[[]]}', '2015-12-16 11:27:03', 'admin'),
(1153, 'inventory', 'receive', 'dn', 10004, '{"id":"10004","txn_no":"1-10002","cn_number":"","date":"2015-12-15 00:00:00","contact_person":"","received_date":null,"supplier":"Subaidah Holdings Sdn. Bhd.","supplier_id":"13","supplier_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":null,"terms":"Credit","remarks":"Overpaid for PV-10020","status":"Returned","payment_status":"Unpaid","payment_reference":null,"payment_date":"2015-12-15 11:07:53","payment_contra":"10021","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"","total":"5.00","total_received":"5.00","tags":"","added_on":"2015-12-15 10:12:06","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"paid_amount":null,"orders":[{"id":"4","debit_note_id":"10004","date":"2015-12-15 00:00:00","item_id":"0","item_name":"Overpaid for PV-10020","item_description":"","discount":"","discount_type":"","qty":"1","price_per_unit":"5.0000","price":"5.00","received":"1","received_price":"5.00","done":null,"division_id":null,"warehouse_id":"1"}],"products":[[]]}', '2015-12-16 11:27:03', 'admin'),
(1154, 'inventory', 'status_update', 'dn', 10004, '{"id":"10004","txn_no":"1-10002","cn_number":"","date":"2015-12-15 00:00:00","contact_person":"","received_date":null,"supplier":"Subaidah Holdings Sdn. Bhd.","supplier_id":"13","supplier_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":null,"terms":"Credit","remarks":"Overpaid for PV-10020","status":"Pending","payment_status":"Unpaid","payment_reference":null,"payment_date":"2015-12-15 11:07:53","payment_contra":"10021","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"","total":"5.00","total_received":"0.00","tags":"","added_on":"2015-12-15 10:12:06","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"paid_amount":null,"orders":[{"id":"4","debit_note_id":"10004","date":"2015-12-15 00:00:00","item_id":"0","item_name":"Overpaid for PV-10020","item_description":"","discount":"","discount_type":"","qty":"1","price_per_unit":"5.0000","price":"5.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1"}],"products":[[]]}', '2015-12-16 11:27:19', 'admin'),
(1155, 'inventory', 'delete', 'dn', 10004, '{"id":"10004","txn_no":"1-10002","cn_number":"","date":"2015-12-15 00:00:00","contact_person":"","received_date":null,"supplier":"Subaidah Holdings Sdn. Bhd.","supplier_id":"13","supplier_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":null,"terms":"Credit","remarks":"Overpaid for PV-10020","status":"Pending","payment_status":"Unpaid","payment_reference":null,"payment_date":"2015-12-15 11:07:53","payment_contra":"10021","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"","total":"5.00","total_received":"0.00","tags":"","added_on":"2015-12-15 10:12:06","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"paid_amount":null,"orders":[{"id":"4","debit_note_id":"10004","date":"2015-12-15 00:00:00","item_id":"0","item_name":"Overpaid for PV-10020","item_description":"","discount":"","discount_type":"","qty":"1","price_per_unit":"5.0000","price":"5.00","received":"0","received_price":"0.00","done":"0","division_id":null,"warehouse_id":"1"}],"products":[[]]}', '2015-12-16 11:27:26', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(1156, 'sales', 'deliver', 'invoice', 10019, '{"id":"10019","txn_no":"1-10005","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-12-07 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Eazyla Marketing","contact_id":"18","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Eazyla Marketing\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1000.00","total_delivered":"1000.00","cost":null,"tags":"","added_on":"2015-12-07 09:59:31","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":null,"orders":[{"id":"44","invoice_id":"10019","type":"service","date":"2015-12-07 12:00:00","item_name":"China Freight Management and Tracking - Project Initiation Fee 50%","item_description":"Order Placement\\nCustomer Account \\nCustomer Credits Management","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1000.0000","price":"1000.00","cost":null,"margin":null,"delivered":"1","delivered_price":"1000.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"18","is_customer":"0","is_supplier":null,"is_debtor":null,"is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Eazyla Marketing","company_registration":"PG0010322-K","contact_person":"Hong Guan","contact_number":"","credit_limit":"0.00","credit_term":"0","discount_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Pulau Pinang","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-12-07 09:55:17","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2015-12-16 11:27:44', 'admin'),
(1157, 'sales', 'status_update', 'invoice', 10019, '{"id":"10019","txn_no":"1-10005","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-12-07 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Eazyla Marketing","contact_id":"18","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Eazyla Marketing\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1000.00","total_delivered":"1000.00","cost":null,"tags":"","added_on":"2015-12-07 09:59:31","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":null,"orders":[{"id":"44","invoice_id":"10019","type":"service","date":"2015-12-07 12:00:00","item_name":"China Freight Management and Tracking - Project Initiation Fee 50%","item_description":"Order Placement\\nCustomer Account \\nCustomer Credits Management","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1000.0000","price":"1000.00","cost":null,"margin":null,"delivered":"1","delivered_price":"1000.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"18","is_customer":"0","is_supplier":null,"is_debtor":null,"is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Eazyla Marketing","company_registration":"PG0010322-K","contact_person":"Hong Guan","contact_number":"","credit_limit":"0.00","credit_term":"0","discount_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Pulau Pinang","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-12-07 09:55:17","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2015-12-16 11:27:46', 'admin'),
(1158, 'sales', 'deliver', 'invoice', 10017, '{"id":"10017","txn_no":"1-10003","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-11-03 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":"2015-12-15 11:07:53","payment_reference":null,"payment_contra":"10021","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"20.00","total_delivered":"20.00","cost":null,"tags":"","added_on":"2015-11-03 13:45:26","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"1.13\\"}]","total_tax":"1.13","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":null,"orders":[{"id":"42","invoice_id":"10017","type":"product","date":"2015-11-03 12:00:00","item_name":"TEST ITEM [SR]","item_description":"","item_id":"7","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"20.0000","price":"20.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"20.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"}],"products":{"7":[]},"services":null,"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":null,"is_prospect":null,"company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"0.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2015-10-07 04:48:19","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2015-12-16 11:27:53', 'admin'),
(1159, 'sales', 'status_update', 'invoice', 10017, '{"id":"10017","txn_no":"1-10003","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-11-03 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":"2015-12-15 11:07:53","payment_reference":null,"payment_contra":"10021","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"20.00","total_delivered":"20.00","cost":null,"tags":"","added_on":"2015-11-03 13:45:26","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"1.13\\"}]","total_tax":"1.13","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":null,"orders":[{"id":"42","invoice_id":"10017","type":"product","date":"2015-11-03 12:00:00","item_name":"TEST ITEM [SR]","item_description":"","item_id":"7","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"20.0000","price":"20.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"20.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"}],"products":{"7":[]},"services":null,"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":null,"is_prospect":null,"company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"0.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2015-10-07 04:48:19","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2015-12-16 11:27:55', 'admin'),
(1160, 'sales', 'deliver', 'invoice', 10016, '{"id":"10016","txn_no":"1-10002","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-10-29 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":"2015-12-15 11:07:53","payment_reference":null,"payment_contra":"10021","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"26.00","total_delivered":"26.00","cost":null,"tags":"","added_on":"2015-10-29 12:29:13","added_by":"admin","modified_on":"2015-12-15 08:44:53","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"14","paid_amount":null,"orders":[{"id":"45","invoice_id":"10016","type":"product","date":"2015-10-29 12:00:00","item_name":"test []","item_description":"","item_id":"10","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"26.0000","price":"26.00","cost":"1.00","margin":null,"delivered":"1","delivered_price":"26.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"80","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-12-16 11:28:04","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":null,"is_prospect":null,"company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"0.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2015-10-07 04:48:19","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2015-12-16 11:28:04', 'admin'),
(1161, 'sales', 'status_update', 'invoice', 10016, '{"id":"10016","txn_no":"1-10002","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2015-10-29 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":"2015-12-15 11:07:53","payment_reference":null,"payment_contra":"10021","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"26.00","total_delivered":"26.00","cost":null,"tags":"","added_on":"2015-10-29 12:29:13","added_by":"admin","modified_on":"2015-12-15 08:44:53","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"1\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"14","paid_amount":null,"orders":[{"id":"45","invoice_id":"10016","type":"product","date":"2015-10-29 12:00:00","item_name":"test []","item_description":"","item_id":"10","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"26.0000","price":"26.00","cost":"1.00","margin":null,"delivered":"1","delivered_price":"26.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"0","tax_code":""}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"80","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2015-12-16 11:28:04","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"","supply_tax_code":"","purchase_taxable":"0","supply_taxable":"0"}},"services":null,"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":null,"is_prospect":null,"company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"0.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2015-10-07 04:48:19","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2015-12-16 11:28:06', 'admin'),
(1162, 'sales', 'deliver', 'invoice', 10018, '{"id":"10018","txn_no":"1-10004","quote_id":"10003","sales_order_id":"10002","number":"0","po_number":"QUO-10003","date":"2015-10-27 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"JStudio","contact_id":"16","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"500.00","total_delivered":"500.00","cost":null,"tags":"","added_on":"2015-11-09 07:39:28","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","referrer_contact_id":"0","paid_amount":null,"orders":[{"id":"43","invoice_id":"10018","type":"service","date":"2015-10-27 12:00:00","item_name":"Custom Order WP Plugin - 50% Project Initiation Fee","item_description":"- Product Custom Order\\n- WooCommerce Integration\\n- Custom Order Option Management\\n- Shortcode Plugin","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"500.0000","price":"500.00","cost":null,"margin":null,"delivered":"1","delivered_price":"500.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1","taxable":null,"tax_code":null}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"16","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"1","company_name":"JStudio","company_registration":"002127464-K","contact_person":"Amin","contact_number":"","credit_limit":"0.00","credit_term":"0","discount_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Kuala Lumpur","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-10-27 00:01:45","added_by":"admin","modified_on":"2015-10-29 14:56:37","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2015-12-16 11:28:14', 'admin'),
(1163, 'sales', 'status_update', 'invoice', 10018, '{"id":"10018","txn_no":"1-10004","quote_id":"10003","sales_order_id":"10002","number":"0","po_number":"QUO-10003","date":"2015-10-27 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"JStudio","contact_id":"16","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"country\\":\\"0\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"500.00","total_delivered":"500.00","cost":null,"tags":"","added_on":"2015-11-09 07:39:28","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"null","total_tax":null,"sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"1","referrer_contact_id":"0","paid_amount":null,"orders":[{"id":"43","invoice_id":"10018","type":"service","date":"2015-10-27 12:00:00","item_name":"Custom Order WP Plugin - 50% Project Initiation Fee","item_description":"- Product Custom Order\\n- WooCommerce Integration\\n- Custom Order Option Management\\n- Shortcode Plugin","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"500.0000","price":"500.00","cost":null,"margin":null,"delivered":"1","delivered_price":"500.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"1","taxable":null,"tax_code":null}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"16","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"1","company_name":"JStudio","company_registration":"002127464-K","contact_person":"Amin","contact_number":"","credit_limit":"0.00","credit_term":"0","discount_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Kuala Lumpur","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-10-27 00:01:45","added_by":"admin","modified_on":"2015-10-29 14:56:37","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2015-12-16 11:28:15', 'admin'),
(1164, 'contacts', 'edit', 'contact', 17, '{"id":"17","is_customer":"1","is_supplier":"0","is_debtor":null,"is_creditor":null,"is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"","company_registration":"","contact_person":"TAN ","contact_number":"1234","credit_limit":"10000.00","credit_term":"0","discount_limit":"0.00","rank":"0","email":"","ic":"1345","password":null,"introducer_ic":null,"address1":"","address2":" ","city":"","state":"0","zipcode":"","country":"0","tel":"1234","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-12-03 19:30:53","added_by":"admin","modified_on":"2016-01-12 12:07:55","modified_by":"admin","status":"Active","user_type":"0","user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null}', '2016-01-12 12:07:55', 'admin'),
(1165, 'sales', 'edit', 'quote', 10002, '{"id":"10002","txn_no":"1-10241","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2015-10-17 00:00:00","due_date":"2015-10-24 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"Open Quotation","contact_id":"15","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Open Quotation\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"4320.00","total_delivered":null,"cost":null,"tags":"","added_on":"2015-10-17 09:38:21","added_by":"admin","modified_on":"2016-01-23 10:32:51","modified_by":"admin","no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"5","quote_id":"10002","date":"2015-10-17 00:00:00","type":"service","item_id":"0","service_id":"10003","item_name":"Warehouse + Retail POS ","item_description":"MODULES\\nPoint of Sales\\nInventory Management\\nStock Count Module\\nReporting Module\\nGST Module\\nSales & Invoicing Module\\n\\nTRAINING\\n2 x 3 Hour Session\\n","discount":"10","discount_type":"p","qty":"1","price_per_unit":"4800.0000","price":"4800.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2016-01-23 10:32:51', 'admin'),
(1166, 'contacts', 'edit', 'contact', 13, '{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"5000.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2016-01-30 09:41:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null}', '2016-01-30 09:41:58', 'admin'),
(1167, 'inventory', 'edit', 'item', 10, '{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"62","alert_quantity":"5","max_quantity":"0","cost":"1.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":"2016-01-30 13:48:49","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-01-30 13:45:35","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1"}', '2016-01-30 13:48:49', 'admin'),
(1168, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"1","inclusive":"0"}', '2016-01-30 13:49:27', 'admin'),
(1169, 'sales', 'add', 'invoice', 10031, '{"id":"10031","txn_no":"1-10011","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2016-03-03 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"27.56","total_delivered":null,"cost":null,"tags":"","added_on":"2016-03-03 09:09:24","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"1.56\\"}]","total_tax":"1.56","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":"0.00","orders":[{"id":"57","invoice_id":"10031","type":"product","date":"2016-03-03 12:00:00","item_name":"test [SR]","item_description":"test description","item_id":"10","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"26.0000","price":"26.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"100","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":"2016-01-30 13:48:49","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-02-28 18:30:00","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null}},"services":null,"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"5000.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2016-01-30 09:41:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2016-03-03 09:09:24', 'admin'),
(1170, 'sales', 'add', 'invoice', 10032, '{"id":"10032","txn_no":"1-10012","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2016-03-04 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"27.56","total_delivered":null,"cost":null,"tags":"","added_on":"2016-03-04 11:28:46","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"1.56\\"}]","total_tax":"1.56","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":"0.00","orders":[{"id":"58","invoice_id":"10032","type":"product","date":"2016-03-04 12:00:00","item_name":"test [SR]","item_description":"test","item_id":"10","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"26.0000","price":"26.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"100","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":"2016-01-30 13:48:49","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-02-28 18:30:00","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null}},"services":null,"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"5000.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2016-01-30 09:41:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2016-03-04 11:28:46', 'admin'),
(1171, 'inventory', 'add', 'po', 10025, '{"id":"10025","txn_no":"1-10007","invoice_number":"","pr_id":"0","number":null,"date":"2016-03-04 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Subaidah Holdings Sdn. Bhd.","supplier_id":"13","supplier_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1.06","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2016-03-04 11:39:55","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.06\\"}]","tax_inclusive":"0","total_tax":"0.06","assigned_to":null,"paid_amount":null,"orders":[{"id":"93","purchase_order_id":"10025","date":"2016-03-04 00:00:00","item_description":"asdsa dsad asdasd","item_name":"test ()","item_id":"10","discount":"0","discount_type":null,"qty":"1","price_per_unit":"1.0000","price":"1.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"TX"}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"100","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":"2016-01-30 13:48:49","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-02-28 18:30:00","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null}}}', '2016-03-04 11:39:55', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(1172, 'contacts', 'add', 'contact', 19, '{"id":"19","is_customer":"0","is_supplier":null,"is_debtor":null,"is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Aliya VCO","company_registration":"","contact_person":"Noraisah Abu Bakar","contact_number":"","credit_limit":"0.00","credit_term":"0","discount_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Selangor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2016-03-17 18:01:18","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null}', '2016-03-17 18:01:18', 'admin'),
(1173, 'sales', 'add', 'invoice', 10033, '{"id":"10033","txn_no":"1-10013","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2016-03-17 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Aliya VCO","contact_id":"19","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Aliya VCO\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"1500.00","total_delivered":null,"cost":null,"tags":"","added_on":"2016-03-17 18:02:26","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":"0.00","orders":[{"id":"59","invoice_id":"10033","type":"service","date":"2016-03-17 12:00:00","item_name":"E-Commerce Website","item_description":"AliyaVCOInspiration.com Domain Registration\\nPlexCMS Content Management System\\nContent Design and Population\\n","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"1500.0000","price":"1500.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"19","is_customer":"0","is_supplier":null,"is_debtor":null,"is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Aliya VCO","company_registration":"","contact_person":"Noraisah Abu Bakar","contact_number":"","credit_limit":"0.00","credit_term":"0","discount_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Selangor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2016-03-17 18:01:18","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2016-03-17 18:02:26', 'admin'),
(1174, 'inventory', 'add', 'item', NULL, '[]', '2016-03-23 17:00:05', 'admin'),
(1175, 'sales', 'add', 'invoice', 10034, '{"id":"10034","txn_no":"1-10014","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2016-03-23 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Bagus Adapter","contact_id":"14","contact_address":"{\\"address1\\":\\"B-3A-1, Megan Phoenix Business Park\\",\\"address2\\":\\"Jalan 2\\\\\\/142A, Off Jalan Cheras\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Bagus Adapter\\",\\"mobile\\":\\"\\",\\"address1\\":\\"B-3A-1, Megan Phoenix Business Park\\",\\"address2\\":\\"Jalan 2\\\\\\/142A, Off Jalan Cheras\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"48.76","total_delivered":null,"cost":null,"tags":"","added_on":"2016-03-23 17:55:01","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"2.76\\"}]","total_tax":"2.76","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":"0.00","orders":[{"id":"60","invoice_id":"10034","type":"product","date":"2016-03-23 12:00:00","item_name":"test [SR]","item_description":"","item_id":"10","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"26.0000","price":"26.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"},{"id":"61","invoice_id":"10034","type":"product","date":"2016-03-23 12:00:00","item_name":"test item 2 [SR]","item_description":"","item_id":"11","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"20.0000","price":"20.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"100","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":"2016-01-30 13:48:49","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-02-28 18:30:00","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null},"11":{"id":"11","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test item 2","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"0","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2016-03-23 17:00:05","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":null,"isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null}},"services":null,"customer":{"id":"14","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":null,"is_prospect":null,"company_name":"Bagus Adapter","company_registration":"","contact_person":"Azlan Ali","contact_number":"","credit_limit":"0.00","credit_term":"0","discount_limit":"10.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"B-3A-1, Megan Phoenix Business Park","address2":"Jalan 2\\/142A, Off Jalan Cheras","city":"Cheras","state":"Kuala Lumpur","zipcode":"56000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-09 12:19:34","added_by":"admin","modified_on":"2015-10-07 07:36:04","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2016-03-23 17:55:01', 'admin'),
(1176, 'sales', 'deliver', 'invoice', 10034, '{"id":"10034","txn_no":"1-10014","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2016-03-23 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Bagus Adapter","contact_id":"14","contact_address":"{\\"address1\\":\\"B-3A-1, Megan Phoenix Business Park\\",\\"address2\\":\\"Jalan 2\\\\\\/142A, Off Jalan Cheras\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Bagus Adapter\\",\\"mobile\\":\\"\\",\\"address1\\":\\"B-3A-1, Megan Phoenix Business Park\\",\\"address2\\":\\"Jalan 2\\\\\\/142A, Off Jalan Cheras\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"48.76","total_delivered":"48.76","cost":null,"tags":"","added_on":"2016-03-23 17:55:01","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"2.76\\"}]","total_tax":"2.76","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":"0.00","orders":[{"id":"60","invoice_id":"10034","type":"product","date":"2016-03-23 12:00:00","item_name":"test [SR]","item_description":"","item_id":"10","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"26.0000","price":"26.00","cost":"10.00","margin":null,"delivered":"1","delivered_price":"26.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"},{"id":"61","invoice_id":"10034","type":"product","date":"2016-03-23 12:00:00","item_name":"test item 2 [SR]","item_description":"","item_id":"11","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"20.0000","price":"20.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"20.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"99","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":"2016-01-30 13:48:49","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-03-23 17:55:11","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null},"11":{"id":"11","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test item 2","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"-1","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2016-03-23 17:00:05","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-03-23 17:55:11","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null}},"services":null,"customer":{"id":"14","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":null,"is_prospect":null,"company_name":"Bagus Adapter","company_registration":"","contact_person":"Azlan Ali","contact_number":"","credit_limit":"0.00","credit_term":"0","discount_limit":"10.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"B-3A-1, Megan Phoenix Business Park","address2":"Jalan 2\\/142A, Off Jalan Cheras","city":"Cheras","state":"Kuala Lumpur","zipcode":"56000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-09 12:19:34","added_by":"admin","modified_on":"2015-10-07 07:36:04","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2016-03-23 17:55:11', 'admin'),
(1177, 'sales', 'status_update', 'invoice', 10034, '{"id":"10034","txn_no":"1-10014","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2016-03-23 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Bagus Adapter","contact_id":"14","contact_address":"{\\"address1\\":\\"B-3A-1, Megan Phoenix Business Park\\",\\"address2\\":\\"Jalan 2\\\\\\/142A, Off Jalan Cheras\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Bagus Adapter\\",\\"mobile\\":\\"\\",\\"address1\\":\\"B-3A-1, Megan Phoenix Business Park\\",\\"address2\\":\\"Jalan 2\\\\\\/142A, Off Jalan Cheras\\",\\"zipcode\\":\\"56000\\",\\"city\\":\\"Cheras\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Cash","duration":"0","remarks":"","status":"Partially Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"48.76","total_delivered":"48.76","cost":null,"tags":"","added_on":"2016-03-23 17:55:01","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"2.76\\"}]","total_tax":"2.76","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":"0.00","orders":[{"id":"60","invoice_id":"10034","type":"product","date":"2016-03-23 12:00:00","item_name":"test [SR]","item_description":"","item_id":"10","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"26.0000","price":"26.00","cost":"10.00","margin":null,"delivered":"1","delivered_price":"26.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"},{"id":"61","invoice_id":"10034","type":"product","date":"2016-03-23 12:00:00","item_name":"test item 2 [SR]","item_description":"","item_id":"11","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"20.0000","price":"20.00","cost":"0.00","margin":null,"delivered":"1","delivered_price":"20.00","done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"99","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":"2016-01-30 13:48:49","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-03-23 17:55:11","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null},"11":{"id":"11","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test item 2","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"-1","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2016-03-23 17:00:05","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-03-23 17:55:11","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null}},"services":null,"customer":{"id":"14","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":null,"is_prospect":null,"company_name":"Bagus Adapter","company_registration":"","contact_person":"Azlan Ali","contact_number":"","credit_limit":"0.00","credit_term":"0","discount_limit":"10.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"B-3A-1, Megan Phoenix Business Park","address2":"Jalan 2\\/142A, Off Jalan Cheras","city":"Cheras","state":"Kuala Lumpur","zipcode":"56000","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-09 12:19:34","added_by":"admin","modified_on":"2015-10-07 07:36:04","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2016-03-23 17:55:13', 'admin'),
(1178, 'sales', 'add', 'invoice', 10035, '{"id":"10035","txn_no":"1-10015","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2016-04-08 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2016-04-08 07:57:20","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":"0.00","orders":[{"id":"62","invoice_id":"10035","type":"service","date":"2016-04-08 12:00:00","item_name":"Custom Order","item_description":"","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"100.0000","price":"100.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""},{"id":"63","invoice_id":"10035","type":"service","date":"2016-04-08 12:00:00","item_name":"Custom Order","item_description":"","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"100.0000","price":"100.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"5000.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2016-01-30 09:41:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2016-04-08 07:57:20', 'admin'),
(1179, 'sales', 'add', 'invoice', 10036, '{"id":"10036","txn_no":"1-10016","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2016-04-08 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"82.68","total_delivered":null,"cost":null,"tags":"","added_on":"2016-04-08 08:00:10","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"4.68\\"}]","total_tax":"4.68","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":"0.00","orders":[{"id":"64","invoice_id":"10036","type":"product","date":"2016-04-08 12:00:00","item_name":"test [SR]","item_description":"","item_id":"10","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"26.0000","price":"26.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"},{"id":"65","invoice_id":"10036","type":"product","date":"2016-04-08 12:00:00","item_name":"test [SR]","item_description":"","item_id":"10","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"2","price_per_unit":"26.0000","price":"52.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"98","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"26.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":"2016-01-30 13:48:49","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-04-02 11:44:27","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null}},"services":null,"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"5000.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2016-01-30 09:41:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2016-04-08 08:00:10', 'admin'),
(1180, 'sales', 'status_update', 'invoice', 10035, '{"id":"10035","txn_no":"1-10015","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2016-04-08 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Delivered","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"200.00","total_delivered":null,"cost":null,"tags":"","added_on":"2016-04-08 07:57:20","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":"0.00","orders":[{"id":"62","invoice_id":"10035","type":"service","date":"2016-04-08 12:00:00","item_name":"Custom Order","item_description":"","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"100.0000","price":"100.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""},{"id":"63","invoice_id":"10035","type":"service","date":"2016-04-08 12:00:00","item_name":"Custom Order","item_description":"","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"100.0000","price":"100.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"5000.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2016-01-30 09:41:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2016-04-24 08:43:40', 'admin'),
(1181, 'sales', 'add', 'invoice', 10037, '{"id":"10037","txn_no":"1-10017","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2016-04-25 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Eazyla Marketing","contact_id":"18","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Eazyla Marketing\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"2000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2016-04-25 09:14:00","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"0.00\\"}]","total_tax":"0.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":"0.00","orders":[{"id":"66","invoice_id":"10037","type":"service","date":"2016-04-25 12:00:00","item_name":"Everydayship.com Website Development","item_description":"Order Management\\nAPI Integration\\nCustomer Credit Management\\n","item_id":"0","service_id":"10003","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"2000.0000","price":"2000.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"0","tax_code":""}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}},"customer":{"id":"18","is_customer":"0","is_supplier":null,"is_debtor":null,"is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Eazyla Marketing","company_registration":"PG0010322-K","contact_person":"Hong Guan","contact_number":"","credit_limit":"0.00","credit_term":"0","discount_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Pulau Pinang","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-12-07 09:55:17","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2016-04-25 09:14:00', 'admin'),
(1182, 'inventory', 'add', 'po', 10026, '{"id":"10026","txn_no":"1-10008","invoice_number":"","pr_id":"0","number":null,"date":"2016-05-02 00:00:00","due_date":null,"contact_person":"Administrator ","received_date":null,"supplier":"Subaidah Holdings Sdn. Bhd.","supplier_id":"13","supplier_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","terms":"Credit","duration":"0","remarks":"","status":"Pending","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"21.20","total_received":null,"payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"tags":"","added_on":"2016-05-02 16:25:23","added_by":"admin","modified_on":null,"modified_by":null,"division_id":null,"warehouse_id":"1","tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"1.20\\"}]","tax_inclusive":"0","total_tax":"1.20","assigned_to":null,"paid_amount":null,"orders":[{"id":"95","purchase_order_id":"10026","date":"2016-05-02 00:00:00","item_description":"","item_name":"test ()","item_id":"10","discount":"0","discount_type":null,"qty":"1","price_per_unit":"20.0000","price":"20.00","received":null,"received_price":null,"done":null,"division_id":null,"warehouse_id":"1","taxable":"1","tax_code":"TX"}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"98","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"30.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":"2016-01-30 13:48:49","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-04-02 11:44:27","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null}}}', '2016-05-02 16:25:23', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(1183, 'sales', 'add', 'invoice', 10038, '{"id":"10038","txn_no":"1-10018","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2016-05-13 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Aliya VCO","contact_id":"19","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Aliya VCO\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Selangor\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"34.80","total_delivered":null,"cost":null,"tags":"","added_on":"2016-05-13 15:02:13","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"1.80\\"}]","total_tax":"1.80","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":"0.00","charges":"[{\\"percentage\\":\\"10.00\\",\\"id\\":1,\\"name\\":\\"Service Charge\\",\\"amount\\":\\"3.00\\"}]","total_charges":"3.00","orders":[{"id":"67","invoice_id":"10038","type":"product","date":"2016-05-13 12:00:00","item_name":"test [SR]","item_description":"TEST","item_id":"10","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"30.0000","price":"30.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"98","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"30.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":"2016-01-30 13:48:49","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-04-02 11:44:27","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null}},"services":null,"customer":{"id":"19","is_customer":"0","is_supplier":null,"is_debtor":null,"is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Aliya VCO","company_registration":"","contact_person":"Noraisah Abu Bakar","contact_number":"","credit_limit":"0.00","credit_term":"0","discount_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Selangor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2016-03-17 18:01:18","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2016-05-13 15:02:13', 'admin'),
(1184, 'sales', 'edit', 'invoice', NULL, '[]', '2016-05-13 15:05:09', 'admin'),
(1185, 'sales', 'edit', 'invoice', NULL, '[]', '2016-05-13 15:05:35', 'admin'),
(1186, 'sales', 'edit', 'invoice', NULL, '[]', '2016-05-13 15:07:18', 'admin'),
(1187, 'sales', 'edit', 'invoice', NULL, '[]', '2016-05-13 15:08:03', 'admin'),
(1188, 'sales', 'add', 'invoice', 10039, '{"id":"10039","txn_no":"1-10019","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2016-05-13 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"58.30","total_delivered":null,"cost":null,"tags":"","added_on":"2016-05-13 15:10:37","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"3.30\\"}]","total_tax":"3.30","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":"0.00","charges":"[{\\"percentage\\":\\"10.00\\",\\"id\\":1,\\"name\\":\\"Service Charge\\",\\"amount\\":\\"5.00\\"}]","total_charges":"5.00","orders":[{"id":"72","invoice_id":"10039","type":"product","date":"2016-05-13 12:00:00","item_name":"test [SR]","item_description":"","item_id":"10","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"30.0000","price":"30.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"},{"id":"73","invoice_id":"10039","type":"product","date":"2016-05-13 12:00:00","item_name":"test item 2 [SR]","item_description":"","item_id":"11","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"20.0000","price":"20.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"98","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"30.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":"2016-01-30 13:48:49","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-04-02 11:44:27","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null},"11":{"id":"11","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test item 2","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"-4","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2016-03-23 17:00:05","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-04-02 11:46:55","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null}},"services":null,"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"5000.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2016-01-30 09:41:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2016-05-13 15:10:37', 'admin'),
(1189, 'sales', 'edit', 'invoice', NULL, '[]', '2016-05-13 15:12:51', 'admin'),
(1190, 'sales', 'edit', 'invoice', NULL, '[]', '2016-05-13 15:14:32', 'admin'),
(1191, 'sales', 'edit', 'invoice', NULL, '[]', '2016-05-13 15:21:32', 'admin'),
(1192, 'sales', 'edit', 'invoice', NULL, '[]', '2016-05-13 15:23:18', 'admin'),
(1193, 'sales', 'edit', 'invoice', 10039, '{"id":"10039","txn_no":"1-10019","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2016-05-13 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"53.00","total_delivered":null,"cost":null,"tags":"","added_on":"2016-05-13 15:10:37","added_by":"admin","modified_on":"2016-05-13 15:23:49","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"3.00\\"}]","total_tax":"3.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":"0.00","charges":"{\\"1\\":{\\"percentage\\":null,\\"id\\":\\"10039\\",\\"name\\":null,\\"amount\\":\\"0.00\\"}}","total_charges":"0.00","orders":[{"id":"83","invoice_id":"10039","type":"product","date":"2016-05-13 12:00:00","item_name":"test item 2 [SR]","item_description":null,"item_id":"11","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"20.0000","price":"20.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"},{"id":"82","invoice_id":"10039","type":"product","date":"2016-05-13 12:00:00","item_name":"test [SR]","item_description":null,"item_id":"10","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"30.0000","price":"30.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"}],"products":{"11":{"id":"11","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test item 2","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"-4","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2016-03-23 17:00:05","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-04-02 11:46:55","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null},"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"98","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"30.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":"2016-01-30 13:48:49","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-04-02 11:44:27","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null}},"services":null,"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"5000.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2016-01-30 09:41:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2016-05-13 15:23:49', 'admin'),
(1194, 'sales', 'edit', 'invoice', 10039, '{"id":"10039","txn_no":"1-10019","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2016-05-13 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"58.30","total_delivered":null,"cost":null,"tags":"","added_on":"2016-05-13 15:10:37","added_by":"admin","modified_on":"2016-05-13 15:31:46","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"3.30\\"}]","total_tax":"3.30","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":"0.00","charges":"{\\"1\\":{\\"percentage\\":null,\\"id\\":\\"10039\\",\\"name\\":null,\\"amount\\":\\"5.00\\"}}","total_charges":"5.00","orders":[{"id":"84","invoice_id":"10039","type":"product","date":"2016-05-13 12:00:00","item_name":"test item 2 [SR]","item_description":null,"item_id":"11","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"20.0000","price":"20.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"},{"id":"85","invoice_id":"10039","type":"product","date":"2016-05-13 12:00:00","item_name":"test [SR]","item_description":null,"item_id":"10","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"30.0000","price":"30.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"}],"products":{"11":{"id":"11","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test item 2","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"-4","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2016-03-23 17:00:05","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-04-02 11:46:55","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null},"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"98","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"30.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":"2016-01-30 13:48:49","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-04-02 11:44:27","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null}},"services":null,"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"5000.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2016-01-30 09:41:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2016-05-13 15:31:46', 'admin'),
(1195, 'sales', 'edit', 'invoice', 10039, '{"id":"10039","txn_no":"1-10019","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2016-05-13 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"58.30","total_delivered":null,"cost":null,"tags":"","added_on":"2016-05-13 15:10:37","added_by":"admin","modified_on":"2016-05-13 15:43:01","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"3.30\\"}]","total_tax":"3.30","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":"0.00","charges":"{\\"1\\":{\\"percentage\\":\\"10.00\\",\\"id\\":1,\\"name\\":\\"Service Charge\\",\\"amount\\":\\"5.00\\"}}","total_charges":"5.00","orders":[{"id":"86","invoice_id":"10039","type":"product","date":"2016-05-13 12:00:00","item_name":"test item 2 [SR]","item_description":null,"item_id":"11","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"20.0000","price":"20.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"},{"id":"87","invoice_id":"10039","type":"product","date":"2016-05-13 12:00:00","item_name":"test [SR]","item_description":null,"item_id":"10","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"30.0000","price":"30.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"}],"products":{"11":{"id":"11","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test item 2","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"-4","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2016-03-23 17:00:05","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-04-02 11:46:55","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null},"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"98","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"30.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":"2016-01-30 13:48:49","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-04-02 11:44:27","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null}},"services":null,"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"5000.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2016-01-30 09:41:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2016-05-13 15:43:01', 'admin'),
(1196, 'sales', 'edit', 'invoice', 10039, '{"id":"10039","txn_no":"1-10019","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2016-05-13 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"53.00","total_delivered":null,"cost":null,"tags":"","added_on":"2016-05-13 15:10:37","added_by":"admin","modified_on":"2016-05-13 15:45:47","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"3.00\\"}]","total_tax":"3.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":"0.00","charges":"{\\"1\\":{\\"percentage\\":\\"10.00\\",\\"id\\":1,\\"name\\":\\"Service Charge\\",\\"amount\\":\\"0.00\\"}}","total_charges":"0.00","orders":[{"id":"89","invoice_id":"10039","type":"product","date":"2016-05-13 12:00:00","item_name":"test [SR]","item_description":null,"item_id":"10","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"30.0000","price":"30.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"},{"id":"88","invoice_id":"10039","type":"product","date":"2016-05-13 12:00:00","item_name":"test item 2 [SR]","item_description":null,"item_id":"11","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"20.0000","price":"20.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"98","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"30.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":"2016-01-30 13:48:49","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-04-02 11:44:27","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null},"11":{"id":"11","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test item 2","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"-4","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2016-03-23 17:00:05","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-04-02 11:46:55","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null}},"services":null,"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"5000.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2016-01-30 09:41:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2016-05-13 15:45:47', 'admin'),
(1197, 'sales', 'edit', 'invoice', 10039, '{"id":"10039","txn_no":"1-10019","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2016-05-13 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"53.00","total_delivered":null,"cost":null,"tags":"","added_on":"2016-05-13 15:10:37","added_by":"admin","modified_on":"2016-05-13 15:45:58","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"3.00\\"}]","total_tax":"3.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":"0.00","charges":"{\\"1\\":{\\"percentage\\":\\"10.00\\",\\"id\\":1,\\"name\\":\\"Service Charge\\",\\"amount\\":\\"0.00\\"}}","total_charges":"0.00","orders":[{"id":"90","invoice_id":"10039","type":"product","date":"2016-05-13 12:00:00","item_name":"test [SR]","item_description":null,"item_id":"10","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"30.0000","price":"30.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"},{"id":"91","invoice_id":"10039","type":"product","date":"2016-05-13 12:00:00","item_name":"test item 2 [SR]","item_description":null,"item_id":"11","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"20.0000","price":"20.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"98","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"30.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":"2016-01-30 13:48:49","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-04-02 11:44:27","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null},"11":{"id":"11","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test item 2","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"-4","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2016-03-23 17:00:05","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-04-02 11:46:55","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null}},"services":null,"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"5000.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2016-01-30 09:41:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2016-05-13 15:45:58', 'admin');
INSERT INTO `system_transactions` (`id`, `module`, `action`, `type`, `record_id`, `record_data`, `datetime`, `performed_by`) VALUES
(1198, 'sales', 'edit', 'invoice', 10039, '{"id":"10039","txn_no":"1-10019","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2016-05-13 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"53.00","total_delivered":null,"cost":null,"tags":"","added_on":"2016-05-13 15:10:37","added_by":"admin","modified_on":"2016-05-13 15:46:06","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"3.00\\"}]","total_tax":"3.00","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":"0.00","charges":"{\\"1\\":{\\"percentage\\":\\"10.00\\",\\"id\\":1,\\"name\\":\\"Service Charge\\",\\"amount\\":\\"0.00\\"}}","total_charges":"0.00","orders":[{"id":"93","invoice_id":"10039","type":"product","date":"2016-05-13 12:00:00","item_name":"test item 2 [SR]","item_description":null,"item_id":"11","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"20.0000","price":"20.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"},{"id":"92","invoice_id":"10039","type":"product","date":"2016-05-13 12:00:00","item_name":"test [SR]","item_description":null,"item_id":"10","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"30.0000","price":"30.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"}],"products":{"11":{"id":"11","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test item 2","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"-4","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2016-03-23 17:00:05","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-04-02 11:46:55","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null},"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"98","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"30.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":"2016-01-30 13:48:49","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-04-02 11:44:27","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null}},"services":null,"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"5000.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2016-01-30 09:41:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2016-05-13 15:46:06', 'admin'),
(1199, 'sales', 'edit', 'invoice', 10039, '{"id":"10039","txn_no":"1-10019","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2016-05-13 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"58.30","total_delivered":null,"cost":null,"tags":"","added_on":"2016-05-13 15:10:37","added_by":"admin","modified_on":"2016-05-13 15:47:35","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"3.30\\"}]","total_tax":"3.30","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":"0.00","charges":"{\\"1\\":{\\"percentage\\":\\"10.00\\",\\"id\\":1,\\"name\\":\\"Service Charge\\",\\"amount\\":\\"5.00\\"}}","total_charges":"5.00","orders":[{"id":"95","invoice_id":"10039","type":"product","date":"2016-05-13 12:00:00","item_name":"test [SR]","item_description":null,"item_id":"10","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"30.0000","price":"30.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"},{"id":"94","invoice_id":"10039","type":"product","date":"2016-05-13 12:00:00","item_name":"test item 2 [SR]","item_description":null,"item_id":"11","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"20.0000","price":"20.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"98","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"30.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":"2016-01-30 13:48:49","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-04-02 11:44:27","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null},"11":{"id":"11","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test item 2","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"-4","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2016-03-23 17:00:05","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-04-02 11:46:55","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null}},"services":null,"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"5000.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2016-01-30 09:41:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2016-05-13 15:47:35', 'admin'),
(1200, 'sales', 'edit', 'invoice', 10039, '{"id":"10039","txn_no":"1-10019","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2016-05-13 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"Subaidah Holdings Sdn. Bhd.","contact_id":"13","contact_address":"{\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"Subaidah Holdings Sdn. Bhd.\\",\\"mobile\\":\\"\\",\\"address1\\":\\"No. 7088\\",\\"address2\\":\\"Jalan Bagan Ajam\\",\\"zipcode\\":\\"13000 \\",\\"city\\":\\"Butterworth \\",\\"state\\":\\"Pulau Pinang\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"58.30","total_delivered":null,"cost":null,"tags":"","added_on":"2016-05-13 15:10:37","added_by":"admin","modified_on":"2016-05-13 15:47:43","modified_by":"admin","no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"3.30\\"}]","total_tax":"3.30","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":"0.00","charges":"{\\"1\\":{\\"percentage\\":\\"10.00\\",\\"id\\":1,\\"name\\":\\"Service Charge\\",\\"amount\\":\\"3\\"}}","total_charges":"3.00","orders":[{"id":"97","invoice_id":"10039","type":"product","date":"2016-05-13 12:00:00","item_name":"test [SR]","item_description":null,"item_id":"10","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"30.0000","price":"30.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"},{"id":"96","invoice_id":"10039","type":"product","date":"2016-05-13 12:00:00","item_name":"test item 2 [SR]","item_description":null,"item_id":"11","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"20.0000","price":"20.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":null,"taxable":"1","tax_code":"SR"}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"98","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"30.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":"2016-01-30 13:48:49","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-04-02 11:44:27","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null},"11":{"id":"11","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test item 2","model_no":"","warranty":"","sku":"1002","sku2":"","sku3":"","sku4":"","qty":"-4","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"20.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2016-03-23 17:00:05","added_by":"admin","modified_on":null,"modified_by":null,"redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-04-02 11:46:55","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null}},"services":null,"customer":{"id":"13","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"Subaidah Holdings Sdn. Bhd.","company_registration":"","contact_person":"Rajaludin","contact_number":"","credit_limit":"5000.00","credit_term":"30","discount_limit":"1000.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"No. 7088","address2":"Jalan Bagan Ajam","city":"Butterworth ","state":"Pulau Pinang","zipcode":"13000 ","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-09-08 11:16:02","added_by":"admin","modified_on":"2016-01-30 09:41:58","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2016-05-13 15:47:43', 'admin'),
(1201, 'contacts', 'add', 'contact', 20, '{"id":"20","is_customer":"0","is_supplier":null,"is_debtor":null,"is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"MyTutor","company_registration":"","contact_person":"Mr. Faiz","contact_number":"","credit_limit":"0.00","credit_term":"0","discount_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Johor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2016-05-22 11:53:03","added_by":"admin","modified_on":null,"modified_by":null,"status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null}', '2016-05-22 11:53:03', 'admin'),
(1202, 'sales', 'add', 'quote', 10005, '{"id":"10005","txn_no":"1-10244","quote_id":null,"invoice_id":null,"sales_order_id":null,"number":"0","date":"2016-05-22 00:00:00","due_date":"2016-05-29 00:00:00","contact_person":"Administrator ","payment_date":null,"received_date":null,"contact":"MyTutor","contact_id":"20","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"MyTutor\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Johor\\",\\"country\\":\\"Malaysia\\"}","shipping":null,"shipping_id":null,"terms":"0","duration":"0","remarks":"","status":"Pending","payment_status":"0","receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"15000.00","total_delivered":null,"cost":null,"tags":"","added_on":"2016-05-22 12:02:27","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"orders":[{"id":"9","quote_id":"10005","date":"2016-05-22 00:00:00","type":"service","item_id":"0","service_id":"10003","item_name":"Backend User Interface","item_description":"End-user management\\nTutor management\\nData administration backend\\nSystem parameters and configuration backend","discount":"0","discount_type":null,"qty":"1","price_per_unit":"5000.0000","price":"5000.00","cost":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1"}],"products":null,"services":{"10003":{"id":"10003","name":"Custom Order","description":"","category":"0","subcategory":"0","cost":"20.00","price":"100.00","last_tendered":null,"remarks":"","tags":null,"added_on":"2015-08-04 11:05:03","added_by":"admin","modified_on":null,"modified_by":null,"warehouse_id":"0"}}}', '2016-05-22 12:02:27', 'admin'),
(1203, 'contacts', 'edit', 'contact', 20, '{"id":"20","is_customer":"0","is_supplier":"0","is_debtor":null,"is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"0","company_name":"MyTutor","company_registration":"","contact_person":"Mr. Faiz","contact_number":"","credit_limit":"0.00","credit_term":"0","discount_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Selangor","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2016-05-22 11:53:03","added_by":"admin","modified_on":"2016-05-22 12:27:35","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null}', '2016-05-22 12:27:35', 'admin'),
(1204, 'sales', 'add', 'invoice', 10040, '{"id":"10040","txn_no":"1-10020","quote_id":"0","sales_order_id":"0","number":"0","po_number":"","date":"2016-05-26 12:00:00","due_date":null,"received_date":null,"contact_person":"Administrator ","contact":"JStudio","contact_id":"16","contact_address":"{\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_address":"{\\"name\\":\\"JStudio\\",\\"mobile\\":\\"\\",\\"address1\\":\\"\\",\\"address2\\":\\"\\",\\"zipcode\\":\\"\\",\\"city\\":\\"\\",\\"state\\":\\"Kuala Lumpur\\",\\"country\\":\\"Malaysia\\"}","delivery_tracking_no":null,"delivery_status":"Pending","delivery_date":null,"shipping":"0","shipping_id":"0","terms":"Credit","duration":"0","remarks":"","status":"Pending","payment_status":"Unpaid","payment_date":null,"payment_reference":null,"payment_contra":null,"receipt_no":null,"handling_charges":"0.00","adjustment":"0.00","adjustment_type":"Add","total":"34.98","total_delivered":null,"cost":null,"tags":"","added_on":"2016-05-26 15:15:47","added_by":"admin","modified_on":null,"modified_by":null,"no_do":null,"amount_cash":null,"amount_cc":null,"amount_cheque":null,"amount_credit":null,"amount_bank_deposit":null,"paid_cash":null,"paid_cc":null,"paid_cheque":null,"paid_credit":null,"paid_bank_deposit":null,"tax":"[{\\"percentage\\":\\"6.000\\",\\"id\\":2,\\"name\\":\\"GST\\",\\"inclusive\\":\\"0\\",\\"amount\\":\\"1.98\\"}]","total_tax":"1.98","sales_reference_id":null,"division_id":null,"warehouse_id":"1","assigned_to":null,"notification":null,"consignment":"0","referrer_contact_id":"0","paid_amount":"0.00","charges":"{\\"1\\":{\\"percentage\\":\\"10.00\\",\\"id\\":1,\\"name\\":\\"Service Charge\\",\\"amount\\":\\"3.00\\"}}","total_charges":"3.00","orders":[{"id":"98","invoice_id":"10040","type":"product","date":"2016-05-26 12:00:00","item_name":"test [SR]","item_description":"","item_id":"10","service_id":"0","item_sku":null,"discount":"0","discount_type":null,"qty":"1","price_per_unit":"30.0000","price":"30.00","cost":null,"margin":null,"delivered":null,"delivered_price":null,"done":null,"no_do":null,"division_id":null,"warehouse_id":"1","consignment":"0","taxable":"1","tax_code":"SR"}],"products":{"10":{"id":"10","primary_image":null,"image":null,"category":"0","subcategory":"0","brand":"0","location":"","name":"test","model_no":"","warranty":"","sku":"1001","sku2":"","sku3":"","sku4":"","qty":"98","alert_quantity":"5","max_quantity":"0","cost":"10.00","average_cost":null,"price":"30.00","price_2":"0.00","price_3":"0.00","price_4":"0.00","price2":"0.00","price2_2":"0.00","price2_3":"0.00","price2_4":"0.00","price3":"0.00","price3_2":"0.00","price3_3":"0.00","price3_4":"0.00","price4":"0.00","price4_2":"0.00","price4_3":"0.00","price4_4":"0.00","description":"","supplier":null,"remarks":"","ordered_quantity":null,"is_active":null,"is_consigned":"0","quick":"0","adjust_cost":"0","enter_price":"0","enter_serial":"0","tags":"","added_on":"2015-11-17 10:59:53","added_by":"admin","modified_on":"2016-01-30 13:48:49","modified_by":"admin","redeemable":"0","redeem_points":"0","current_po":null,"current_po_item":null,"uom1":"","uom2":"","uom3":"","uom4":"","loose_qty2":"0","loose_qty3":"0","loose_qty4":"0","weight":"0.00","weight_unit":"g","weight2":"0.00","weight3":"0.00","weight4":"0.00","volume":"0.00","volume_unit":"cm3","volume2":"0.00","volume3":"0.00","volume4":"0.00","min_cart_qty":"0","max_cart_qty":"0","ready_for_sale":"0","last_sold":"2016-04-02 11:44:27","isbn":"","links":"","linked":null,"author":"","publisher":"","lastchange":null,"order":null,"warehouse_id":"1","purchase_tax_code":"TX","supply_tax_code":"SR","purchase_taxable":"1","supply_taxable":"1","gl_account":null,"sale_account":null,"purchase_account":null}},"services":null,"customer":{"id":"16","is_customer":"0","is_supplier":"0","is_debtor":"0","is_creditor":"0","is_member":"0","is_stakeholder":"0","is_franchise":"0","is_franchisee":null,"is_agent":"0","is_prospect":"1","company_name":"JStudio","company_registration":"002127464-K","contact_person":"Amin","contact_number":"","credit_limit":"0.00","credit_term":"0","discount_limit":"0.00","rank":"0","email":"","ic":"","password":"","introducer_ic":null,"address1":"","address2":"","city":"","state":"Kuala Lumpur","zipcode":"","country":"Malaysia","tel":"","fax":"","general_email":"","terms":"0","description":"0","remarks":"","tags":"","added_on":"2015-10-27 00:01:45","added_by":"admin","modified_on":"2015-10-29 14:56:37","modified_by":"admin","status":"Active","user_type":null,"user_verified":null,"loyalty_points":null,"current_session":null,"division_id":null,"assigned_to":null,"facebook_id":null,"nationality":null,"lastchange":null,"tax_no":"","notes":null},"sale":null,"sale_items":null}', '2016-05-26 15:15:47', 'admin'),
(1205, 'tax', 'edit', 'tax', 2, '{"id":"2","type":"0","name":"GST","percentage":"6.000","enabled":"0","inclusive":"0"}', '2016-06-07 20:54:26', 'admin');

-- --------------------------------------------------------

--
-- Table structure for table `tags`
--

CREATE TABLE `tags` (
  `id` int(11) UNSIGNED NOT NULL,
  `name` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `user` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `tax`
--

CREATE TABLE `tax` (
  `id` int(11) NOT NULL,
  `type` varchar(128) DEFAULT NULL,
  `name` varchar(128) DEFAULT NULL,
  `percentage` varchar(128) DEFAULT NULL,
  `enabled` varchar(128) DEFAULT NULL,
  `inclusive` int(1) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `tax`
--

INSERT INTO `tax` (`id`, `type`, `name`, `percentage`, `enabled`, `inclusive`) VALUES
(2, '0', 'GST', '6.000', '0', 0);

-- --------------------------------------------------------

--
-- Table structure for table `tax_codes_purchase`
--

CREATE TABLE `tax_codes_purchase` (
  `id` int(11) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `tax_codes_supply`
--

CREATE TABLE `tax_codes_supply` (
  `id` int(11) UNSIGNED NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `terminals`
--

CREATE TABLE `terminals` (
  `id` int(11) UNSIGNED NOT NULL,
  `name` varchar(32) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `ip` varchar(32) DEFAULT NULL,
  `printer_name` varchar(255) DEFAULT NULL,
  `printer_type` varchar(255) DEFAULT NULL,
  `printer_width` int(11) DEFAULT NULL,
  `printer_footer` text,
  `display_name` varchar(128) DEFAULT NULL,
  `drawer_name` varchar(128) DEFAULT NULL,
  `trigger_chars` varchar(128) DEFAULT NULL,
  `identifier` varchar(8) DEFAULT NULL,
  `key` varchar(8) DEFAULT NULL,
  `auth_key` varchar(128) DEFAULT NULL,
  `pd_welcome1` varchar(20) DEFAULT NULL,
  `pd_welcome2` varchar(20) DEFAULT NULL,
  `pd_thankyou` varchar(20) DEFAULT NULL,
  `till_deposit` decimal(20,2) DEFAULT NULL,
  `linked_with_warehouse` int(1) DEFAULT NULL,
  `warehouse_id` int(11) DEFAULT NULL,
  `lastchange` int(20) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `terminals`
--

INSERT INTO `terminals` (`id`, `name`, `type`, `ip`, `printer_name`, `printer_type`, `printer_width`, `printer_footer`, `display_name`, `drawer_name`, `trigger_chars`, `identifier`, `key`, `auth_key`, `pd_welcome1`, `pd_welcome2`, `pd_thankyou`, `till_deposit`, `linked_with_warehouse`, `warehouse_id`, `lastchange`) VALUES
(27, 'LOCALHOST', 'Static', '127.0.0.1', '', 'REGULAR', 48, 'WIFI Password: thedailydose\n\nTHANK YOU! PLEASE COME AGAIN!', '', '192.168.1.51', '27,112,48,55,121', NULL, NULL, NULL, '', '', '', '500.00', NULL, 0, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `transactions`
--

CREATE TABLE `transactions` (
  `id` int(11) DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `type_id` int(11) DEFAULT NULL,
  `debit_credit` int(11) DEFAULT NULL,
  `reference_no` varchar(128) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `details` text,
  `amount` decimal(20,2) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `users`
--

CREATE TABLE `users` (
  `id` int(11) NOT NULL,
  `username` varchar(128) DEFAULT NULL,
  `password` varchar(128) DEFAULT NULL,
  `dob` date DEFAULT NULL,
  `type` varchar(128) DEFAULT NULL,
  `link_type` varchar(128) DEFAULT NULL,
  `link_with` int(11) DEFAULT NULL,
  `gender` varchar(128) DEFAULT NULL,
  `email` varchar(128) DEFAULT NULL,
  `firstname` varchar(128) DEFAULT NULL,
  `lastname` varchar(128) DEFAULT NULL,
  `phone` varchar(32) DEFAULT NULL,
  `mobile` varchar(32) DEFAULT NULL,
  `role` varchar(128) DEFAULT NULL,
  `ip` varchar(15) DEFAULT NULL,
  `last_login` datetime DEFAULT NULL,
  `session` varchar(128) DEFAULT NULL,
  `timeout` varchar(128) DEFAULT NULL,
  `active` int(1) DEFAULT NULL,
  `terminal_active` int(1) DEFAULT NULL,
  `terminal_type` varchar(128) DEFAULT NULL,
  `terminal_identifier` varchar(128) DEFAULT NULL,
  `terminal_key` varchar(128) DEFAULT NULL,
  `terminal_ip` varchar(32) DEFAULT NULL,
  `terminal_session` varchar(128) DEFAULT NULL,
  `terminal_last_login` datetime DEFAULT NULL,
  `terminal_id` int(11) DEFAULT NULL,
  `terminal_name` varchar(128) DEFAULT NULL,
  `terminal_lock` int(1) DEFAULT NULL,
  `flag` varchar(128) DEFAULT NULL,
  `hash` varchar(128) DEFAULT NULL,
  `status` varchar(32) DEFAULT NULL,
  `data` text,
  `division` varchar(128) DEFAULT NULL,
  `branch` int(11) DEFAULT NULL,
  `employee_id` int(11) DEFAULT '0',
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `lastchange` varchar(128) DEFAULT NULL,
  `keycard` text
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `users`
--

INSERT INTO `users` (`id`, `username`, `password`, `dob`, `type`, `link_type`, `link_with`, `gender`, `email`, `firstname`, `lastname`, `phone`, `mobile`, `role`, `ip`, `last_login`, `session`, `timeout`, `active`, `terminal_active`, `terminal_type`, `terminal_identifier`, `terminal_key`, `terminal_ip`, `terminal_session`, `terminal_last_login`, `terminal_id`, `terminal_name`, `terminal_lock`, `flag`, `hash`, `status`, `data`, `division`, `branch`, `employee_id`, `added_on`, `added_by`, `modified_on`, `modified_by`, `lastchange`, `keycard`) VALUES
(10003, 'admin', '0192023a7bbd73250516f069df18b500', NULL, 'Superadmin', NULL, NULL, 'Male', 'admin', 'Administrator', '', '', '', '0', '::1', '2012-08-01 20:55:13', 'n7mo1phstgidkntk603ia7f3o3', '1520669961', 1, 1, 'Static', NULL, NULL, '127.0.0.1', '1520557159', '2018-03-09 08:59:19', 27, 'LOCALHOST', NULL, '1', '22e2dfd53c9d938729404a0e671c11a0', 'Active', 'false', 'Admin', 1, 0, NULL, NULL, NULL, NULL, NULL, 'admin123'),
(10006, 'admin2', '0192023a7bbd73250516f069df18b500', NULL, 'Superadmin', NULL, NULL, 'Male', 'admin', 'Administrator', '', '', '', '0', '113.210.130.132', '2012-08-28 00:05:51', 'bo1rf7r9h7i1chobjqcglfcv53', '1392474665', NULL, 1, 'Static', NULL, NULL, '172.20.10.1', '1462176103', '2016-05-02 16:01:43', 30, 'PHONE 2', NULL, '1', 'd9d38f46705ad4c239eec1535dc0fceb', 'Active', 'false', '', 1, 0, NULL, NULL, NULL, NULL, NULL, ''),
(10007, 'admin3', '25f9e794323b453885f5181f1b624d0b', NULL, 'Superadmin', NULL, NULL, 'Male', '', 'Administrator', '', '', '', '0', '118.101.239.249', '2012-08-09 14:01:04', '1kk65ccc37qu2pdbcs8pl3u6i2', '1371576543', 1, 0, '', '', '39196959894f205b99bc7852d8fa042c', '', '', '0000-00-00 00:00:00', 21, 'azad', NULL, '1', 'ab196de0370e763d414bb9b33ebd843e', 'Active', 'false', 'Admin', 1, 0, NULL, NULL, NULL, NULL, NULL, ''),
(10008, 'lois', '3de5d4fb38ffa230450e8190aa1190af', NULL, 'Manager', NULL, NULL, '0', '', '', '', '', '', '0', '::1', NULL, 'n7mo1phstgidkntk603ia7f3o3', '1520670168', NULL, 1, 'Static', NULL, NULL, NULL, '1520469288', '2018-03-08 08:34:48', NULL, 'LOCALHOST', NULL, '1', 'ef5aa500ad46044c1b01d36e920c0184', 'Active', 'false', '', 1, 0, NULL, NULL, NULL, NULL, NULL, ''),
(10009, 'Nick', '0192023a7bbd73250516f069df18b500', '2016-06-12', 'Manager', NULL, NULL, '0', 'admin', '', '', '', '', '0', NULL, NULL, NULL, NULL, NULL, 1, 'Static', NULL, NULL, NULL, '1466406307', '2016-06-20 15:05:07', NULL, 'LOCALHOST', NULL, NULL, NULL, 'Active', '', '', 1, 0, NULL, NULL, NULL, NULL, NULL, ''),
(10010, 'sanni', 'be42cad6e7e76deaf8bcc82ba76de402', NULL, 'Manager', NULL, NULL, '0', '', '', '', '', '', '0', '::1', NULL, '5g8jc67134v48f4ac3di19a874', '1483361872', NULL, 1, 'Static', NULL, NULL, NULL, '1506743997', '2017-09-30 11:59:57', NULL, 'LOCALHOST', NULL, '1', 'b037e640aa2b9683fa532a965da2f07f', 'Active', 'false', '', 1, 0, NULL, NULL, NULL, NULL, NULL, ''),
(10011, 'Staff', 'e10adc3949ba59abbe56e057f20f883e', NULL, 'Cashier', NULL, NULL, '0', '', '', '', '', '', '0', '::1', NULL, '4e5td9o1ub86t79cdf4293ute7', '1467366859', NULL, 0, '', '', NULL, '', '', '0000-00-00 00:00:00', 27, 'LOCALHOST', NULL, '1', '71a0db9f71fc86a49b973be9148a20e9', 'Active', 'false', '', 1, 0, NULL, NULL, NULL, NULL, NULL, '');

-- --------------------------------------------------------

--
-- Table structure for table `vacancies`
--

CREATE TABLE `vacancies` (
  `id` int(11) NOT NULL,
  `job_title` varchar(128) DEFAULT NULL,
  `manager` int(11) DEFAULT NULL,
  `description` text,
  `closing_date` date DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `vacancies`
--

INSERT INTO `vacancies` (`id`, `job_title`, `manager`, `description`, `closing_date`, `status`) VALUES
(2, 'Waiter', 0, '', '2015-08-04', 'Active');

-- --------------------------------------------------------

--
-- Table structure for table `warehouses`
--

CREATE TABLE `warehouses` (
  `id` int(11) UNSIGNED NOT NULL,
  `name` varchar(128) DEFAULT NULL,
  `address1` text,
  `address2` text,
  `city` varchar(128) DEFAULT NULL,
  `state` varchar(128) DEFAULT NULL,
  `zipcode` varchar(128) DEFAULT NULL,
  `country` varchar(128) DEFAULT NULL,
  `telephone` varchar(128) DEFAULT NULL,
  `tel` varchar(128) DEFAULT NULL,
  `fax` varchar(128) DEFAULT NULL,
  `email` varchar(128) DEFAULT NULL,
  `remarks` text,
  `tags` text,
  `type` varchar(128) DEFAULT NULL,
  `type_reference` int(11) DEFAULT NULL,
  `online_store` int(11) DEFAULT NULL,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `warehouses`
--

INSERT INTO `warehouses` (`id`, `name`, `address1`, `address2`, `city`, `state`, `zipcode`, `country`, `telephone`, `tel`, `fax`, `email`, `remarks`, `tags`, `type`, `type_reference`, `online_store`, `added_on`, `added_by`, `modified_on`, `modified_by`) VALUES
(1, 'The Daily Dose', '36, Stewart Lane', '', 'Georgetown ', 'Pulau Pinang', '10200', 'Malaysia', NULL, '604-2519168', '', 'dailydosepenang@gmail.com', '', '', 'Stakeholder', 0, NULL, '2012-12-12 14:49:21', 'admin', '2016-06-07 20:54:09', 'admin');

-- --------------------------------------------------------

--
-- Table structure for table `warehouse_movements`
--

CREATE TABLE `warehouse_movements` (
  `id` int(11) UNSIGNED NOT NULL,
  `from_warehouse` int(11) DEFAULT NULL,
  `from_warehouse_name` varchar(128) DEFAULT NULL,
  `from_warehouse_address` text,
  `to_warehouse` int(11) DEFAULT NULL,
  `to_warehouse_name` varchar(128) DEFAULT NULL,
  `to_warehouse_address` text,
  `total_items` int(11) DEFAULT NULL,
  `delivered_date` datetime DEFAULT NULL,
  `received_date` datetime DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL,
  `tags` text,
  `added_on` datetime DEFAULT NULL,
  `added_by` varchar(128) DEFAULT NULL,
  `modified_on` datetime DEFAULT NULL,
  `modified_by` varchar(128) DEFAULT NULL,
  `remarks` text
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `warehouse_movement_items`
--

CREATE TABLE `warehouse_movement_items` (
  `id` int(11) UNSIGNED NOT NULL,
  `movement_id` int(11) DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `item_name` varchar(256) DEFAULT NULL,
  `item_sku` varchar(128) DEFAULT NULL,
  `from_warehouse` varchar(128) DEFAULT NULL,
  `from_warehouse_name` varchar(128) DEFAULT NULL,
  `to_warehouse` int(11) DEFAULT NULL,
  `to_warehouse_name` varchar(128) DEFAULT NULL,
  `qty` int(11) DEFAULT NULL,
  `delivered_date` datetime DEFAULT NULL,
  `received_date` datetime DEFAULT NULL,
  `status` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `_files`
--

CREATE TABLE `_files` (
  `id` int(11) UNSIGNED NOT NULL,
  `datetime` datetime DEFAULT NULL,
  `filename` text,
  `uploaded` int(1) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `_txn`
--

CREATE TABLE `_txn` (
  `id` int(11) UNSIGNED NOT NULL,
  `datetime` datetime DEFAULT NULL,
  `sql` text,
  `done` int(1) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Indexes for dumped tables
--

--
-- Indexes for table `account`
--
ALTER TABLE `account`
  ADD PRIMARY KEY (`account_id`);

--
-- Indexes for table `account_bank_recon`
--
ALTER TABLE `account_bank_recon`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `account_closure`
--
ALTER TABLE `account_closure`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `account_payables`
--
ALTER TABLE `account_payables`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `account_receivables`
--
ALTER TABLE `account_receivables`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `account_transactions`
--
ALTER TABLE `account_transactions`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `applicants`
--
ALTER TABLE `applicants`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `assets`
--
ALTER TABLE `assets`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `asset_depreciations`
--
ALTER TABLE `asset_depreciations`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `buffer_sale_items`
--
ALTER TABLE `buffer_sale_items`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `buffer_sale_itemssales`
--
ALTER TABLE `buffer_sale_itemssales`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `buffer_sale_item_sales`
--
ALTER TABLE `buffer_sale_item_sales`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `buffer_tax`
--
ALTER TABLE `buffer_tax`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `calendar`
--
ALTER TABLE `calendar`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `calendar_task_logs`
--
ALTER TABLE `calendar_task_logs`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `campaign`
--
ALTER TABLE `campaign`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `cash_count`
--
ALTER TABLE `cash_count`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `charges`
--
ALTER TABLE `charges`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `config`
--
ALTER TABLE `config`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `config_branch`
--
ALTER TABLE `config_branch`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `contacts`
--
ALTER TABLE `contacts`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `contact_cases`
--
ALTER TABLE `contact_cases`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `contact_logs`
--
ALTER TABLE `contact_logs`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `countries`
--
ALTER TABLE `countries`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `credit_cards`
--
ALTER TABLE `credit_cards`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `credit_notes`
--
ALTER TABLE `credit_notes`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `credit_note_items`
--
ALTER TABLE `credit_note_items`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `customers`
--
ALTER TABLE `customers`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `debit_notes`
--
ALTER TABLE `debit_notes`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `debit_note_items`
--
ALTER TABLE `debit_note_items`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `department`
--
ALTER TABLE `department`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `disposal_appreciation`
--
ALTER TABLE `disposal_appreciation`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `disposal_depreciation`
--
ALTER TABLE `disposal_depreciation`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `editor_compilations`
--
ALTER TABLE `editor_compilations`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `editor_live_contents`
--
ALTER TABLE `editor_live_contents`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `editor_profiles`
--
ALTER TABLE `editor_profiles`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `editor_revisions`
--
ALTER TABLE `editor_revisions`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `editor_sessions`
--
ALTER TABLE `editor_sessions`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `email_notifications`
--
ALTER TABLE `email_notifications`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `employees`
--
ALTER TABLE `employees`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `employee_cico`
--
ALTER TABLE `employee_cico`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `employee_dependents`
--
ALTER TABLE `employee_dependents`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `employee_documents`
--
ALTER TABLE `employee_documents`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `employee_education`
--
ALTER TABLE `employee_education`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `employee_emergency_contacts`
--
ALTER TABLE `employee_emergency_contacts`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `employee_languages`
--
ALTER TABLE `employee_languages`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `employee_licenses`
--
ALTER TABLE `employee_licenses`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `employee_skills`
--
ALTER TABLE `employee_skills`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `employee_work_experience`
--
ALTER TABLE `employee_work_experience`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `employment`
--
ALTER TABLE `employment`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `fifo`
--
ALTER TABLE `fifo`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `fnb_buffer_sales`
--
ALTER TABLE `fnb_buffer_sales`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `fnb_buffer_sale_items`
--
ALTER TABLE `fnb_buffer_sale_items`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `fnb_cash_count`
--
ALTER TABLE `fnb_cash_count`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `fnb_category_options`
--
ALTER TABLE `fnb_category_options`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `fnb_delivery_orders`
--
ALTER TABLE `fnb_delivery_orders`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `fnb_delivery_order_items`
--
ALTER TABLE `fnb_delivery_order_items`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `fnb_inventory`
--
ALTER TABLE `fnb_inventory`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `fnb_printer_map`
--
ALTER TABLE `fnb_printer_map`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `fnb_reverts`
--
ALTER TABLE `fnb_reverts`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `fnb_sales`
--
ALTER TABLE `fnb_sales`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `fnb_sale_items`
--
ALTER TABLE `fnb_sale_items`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `fnb_self_service_map`
--
ALTER TABLE `fnb_self_service_map`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `fnb_subcategory_options`
--
ALTER TABLE `fnb_subcategory_options`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `fnb_table_cards`
--
ALTER TABLE `fnb_table_cards`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `im`
--
ALTER TABLE `im`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `inventory`
--
ALTER TABLE `inventory`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `inventory_stock_quantities`
--
ALTER TABLE `inventory_stock_quantities`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `invoices`
--
ALTER TABLE `invoices`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `invoice_items`
--
ALTER TABLE `invoice_items`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `leads`
--
ALTER TABLE `leads`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `leave`
--
ALTER TABLE `leave`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `license`
--
ALTER TABLE `license`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `manufacturing_order`
--
ALTER TABLE `manufacturing_order`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `manufacturing_order_components`
--
ALTER TABLE `manufacturing_order_components`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `members`
--
ALTER TABLE `members`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `memo`
--
ALTER TABLE `memo`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `menu_items`
--
ALTER TABLE `menu_items`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `menu_printer_map`
--
ALTER TABLE `menu_printer_map`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `modules`
--
ALTER TABLE `modules`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `notifications`
--
ALTER TABLE `notifications`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `patients`
--
ALTER TABLE `patients`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `patient_history`
--
ALTER TABLE `patient_history`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `payment_gateways`
--
ALTER TABLE `payment_gateways`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `payment_vouchers`
--
ALTER TABLE `payment_vouchers`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `payment_voucher_breakdown`
--
ALTER TABLE `payment_voucher_breakdown`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `payment_voucher_items`
--
ALTER TABLE `payment_voucher_items`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `permissions`
--
ALTER TABLE `permissions`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `pos_items_template`
--
ALTER TABLE `pos_items_template`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `potentials`
--
ALTER TABLE `potentials`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `product_reviews`
--
ALTER TABLE `product_reviews`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `purchase_orders`
--
ALTER TABLE `purchase_orders`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `purchase_order_items`
--
ALTER TABLE `purchase_order_items`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `purchase_requests`
--
ALTER TABLE `purchase_requests`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `purchase_request_items`
--
ALTER TABLE `purchase_request_items`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `quotes`
--
ALTER TABLE `quotes`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `quote_items`
--
ALTER TABLE `quote_items`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `receipts`
--
ALTER TABLE `receipts`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `receipt_breakdown`
--
ALTER TABLE `receipt_breakdown`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `receipt_items`
--
ALTER TABLE `receipt_items`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `reports`
--
ALTER TABLE `reports`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `reports_saved`
--
ALTER TABLE `reports_saved`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `report_to`
--
ALTER TABLE `report_to`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `reverts`
--
ALTER TABLE `reverts`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `salary_deduction_table`
--
ALTER TABLE `salary_deduction_table`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `salary_voucher`
--
ALTER TABLE `salary_voucher`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `salary_voucher_breakdown`
--
ALTER TABLE `salary_voucher_breakdown`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `salary_voucher_format`
--
ALTER TABLE `salary_voucher_format`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `salary_voucher_items`
--
ALTER TABLE `salary_voucher_items`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `sales`
--
ALTER TABLE `sales`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `sales_breakdown`
--
ALTER TABLE `sales_breakdown`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `sales_discount_item_rules`
--
ALTER TABLE `sales_discount_item_rules`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `sales_discount_rules`
--
ALTER TABLE `sales_discount_rules`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `sales_order`
--
ALTER TABLE `sales_order`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `sales_order_items`
--
ALTER TABLE `sales_order_items`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `sales_sessions`
--
ALTER TABLE `sales_sessions`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `sale_items`
--
ALTER TABLE `sale_items`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `sale_tax`
--
ALTER TABLE `sale_tax`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `services`
--
ALTER TABLE `services`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `settlements`
--
ALTER TABLE `settlements`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `shipping`
--
ALTER TABLE `shipping`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `shipping_international_zones`
--
ALTER TABLE `shipping_international_zones`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `shipping_local_zones`
--
ALTER TABLE `shipping_local_zones`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `shipping_rates`
--
ALTER TABLE `shipping_rates`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `states`
--
ALTER TABLE `states`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `stock_adjustment`
--
ALTER TABLE `stock_adjustment`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `stock_count`
--
ALTER TABLE `stock_count`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `stock_count_items`
--
ALTER TABLE `stock_count_items`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `subscription`
--
ALTER TABLE `subscription`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `system_transactions`
--
ALTER TABLE `system_transactions`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `tags`
--
ALTER TABLE `tags`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `tax`
--
ALTER TABLE `tax`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `tax_codes_purchase`
--
ALTER TABLE `tax_codes_purchase`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `tax_codes_supply`
--
ALTER TABLE `tax_codes_supply`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `terminals`
--
ALTER TABLE `terminals`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `users`
--
ALTER TABLE `users`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `vacancies`
--
ALTER TABLE `vacancies`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `warehouses`
--
ALTER TABLE `warehouses`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `warehouse_movements`
--
ALTER TABLE `warehouse_movements`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `warehouse_movement_items`
--
ALTER TABLE `warehouse_movement_items`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `_files`
--
ALTER TABLE `_files`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `_txn`
--
ALTER TABLE `_txn`
  ADD PRIMARY KEY (`id`);

--
-- AUTO_INCREMENT for dumped tables
--

--
-- AUTO_INCREMENT for table `account`
--
ALTER TABLE `account`
  MODIFY `account_id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `account_bank_recon`
--
ALTER TABLE `account_bank_recon`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `account_closure`
--
ALTER TABLE `account_closure`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `account_payables`
--
ALTER TABLE `account_payables`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `account_receivables`
--
ALTER TABLE `account_receivables`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `account_transactions`
--
ALTER TABLE `account_transactions`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `applicants`
--
ALTER TABLE `applicants`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;
--
-- AUTO_INCREMENT for table `assets`
--
ALTER TABLE `assets`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `asset_depreciations`
--
ALTER TABLE `asset_depreciations`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `buffer_sale_items`
--
ALTER TABLE `buffer_sale_items`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `buffer_sale_itemssales`
--
ALTER TABLE `buffer_sale_itemssales`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `buffer_sale_item_sales`
--
ALTER TABLE `buffer_sale_item_sales`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `buffer_tax`
--
ALTER TABLE `buffer_tax`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `calendar`
--
ALTER TABLE `calendar`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=179;
--
-- AUTO_INCREMENT for table `calendar_task_logs`
--
ALTER TABLE `calendar_task_logs`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `campaign`
--
ALTER TABLE `campaign`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `cash_count`
--
ALTER TABLE `cash_count`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `charges`
--
ALTER TABLE `charges`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;
--
-- AUTO_INCREMENT for table `config`
--
ALTER TABLE `config`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=136;
--
-- AUTO_INCREMENT for table `config_branch`
--
ALTER TABLE `config_branch`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=25567;
--
-- AUTO_INCREMENT for table `contacts`
--
ALTER TABLE `contacts`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `contact_cases`
--
ALTER TABLE `contact_cases`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=32;
--
-- AUTO_INCREMENT for table `contact_logs`
--
ALTER TABLE `contact_logs`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=62;
--
-- AUTO_INCREMENT for table `countries`
--
ALTER TABLE `countries`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=240;
--
-- AUTO_INCREMENT for table `credit_cards`
--
ALTER TABLE `credit_cards`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=8;
--
-- AUTO_INCREMENT for table `credit_notes`
--
ALTER TABLE `credit_notes`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `credit_note_items`
--
ALTER TABLE `credit_note_items`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `customers`
--
ALTER TABLE `customers`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `debit_notes`
--
ALTER TABLE `debit_notes`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `debit_note_items`
--
ALTER TABLE `debit_note_items`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `department`
--
ALTER TABLE `department`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `disposal_appreciation`
--
ALTER TABLE `disposal_appreciation`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `disposal_depreciation`
--
ALTER TABLE `disposal_depreciation`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `editor_compilations`
--
ALTER TABLE `editor_compilations`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `editor_live_contents`
--
ALTER TABLE `editor_live_contents`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `editor_profiles`
--
ALTER TABLE `editor_profiles`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `editor_revisions`
--
ALTER TABLE `editor_revisions`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=75;
--
-- AUTO_INCREMENT for table `editor_sessions`
--
ALTER TABLE `editor_sessions`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=122;
--
-- AUTO_INCREMENT for table `email_notifications`
--
ALTER TABLE `email_notifications`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `employees`
--
ALTER TABLE `employees`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=30;
--
-- AUTO_INCREMENT for table `employee_cico`
--
ALTER TABLE `employee_cico`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=20;
--
-- AUTO_INCREMENT for table `employee_dependents`
--
ALTER TABLE `employee_dependents`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `employee_documents`
--
ALTER TABLE `employee_documents`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `employee_education`
--
ALTER TABLE `employee_education`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `employee_emergency_contacts`
--
ALTER TABLE `employee_emergency_contacts`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `employee_languages`
--
ALTER TABLE `employee_languages`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `employee_licenses`
--
ALTER TABLE `employee_licenses`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `employee_skills`
--
ALTER TABLE `employee_skills`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `employee_work_experience`
--
ALTER TABLE `employee_work_experience`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `employment`
--
ALTER TABLE `employment`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=12;
--
-- AUTO_INCREMENT for table `fifo`
--
ALTER TABLE `fifo`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=6;
--
-- AUTO_INCREMENT for table `fnb_buffer_sales`
--
ALTER TABLE `fnb_buffer_sales`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=17259;
--
-- AUTO_INCREMENT for table `fnb_buffer_sale_items`
--
ALTER TABLE `fnb_buffer_sale_items`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=68393;
--
-- AUTO_INCREMENT for table `fnb_cash_count`
--
ALTER TABLE `fnb_cash_count`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=535;
--
-- AUTO_INCREMENT for table `fnb_category_options`
--
ALTER TABLE `fnb_category_options`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `fnb_delivery_orders`
--
ALTER TABLE `fnb_delivery_orders`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `fnb_delivery_order_items`
--
ALTER TABLE `fnb_delivery_order_items`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `fnb_inventory`
--
ALTER TABLE `fnb_inventory`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=340;
--
-- AUTO_INCREMENT for table `fnb_printer_map`
--
ALTER TABLE `fnb_printer_map`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=6;
--
-- AUTO_INCREMENT for table `fnb_reverts`
--
ALTER TABLE `fnb_reverts`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1476;
--
-- AUTO_INCREMENT for table `fnb_sales`
--
ALTER TABLE `fnb_sales`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=17236;
--
-- AUTO_INCREMENT for table `fnb_sale_items`
--
ALTER TABLE `fnb_sale_items`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=65223;
--
-- AUTO_INCREMENT for table `fnb_self_service_map`
--
ALTER TABLE `fnb_self_service_map`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `fnb_subcategory_options`
--
ALTER TABLE `fnb_subcategory_options`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `fnb_table_cards`
--
ALTER TABLE `fnb_table_cards`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `im`
--
ALTER TABLE `im`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `inventory`
--
ALTER TABLE `inventory`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `inventory_stock_quantities`
--
ALTER TABLE `inventory_stock_quantities`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `invoices`
--
ALTER TABLE `invoices`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `invoice_items`
--
ALTER TABLE `invoice_items`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `leads`
--
ALTER TABLE `leads`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `leave`
--
ALTER TABLE `leave`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3;
--
-- AUTO_INCREMENT for table `license`
--
ALTER TABLE `license`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `manufacturing_order`
--
ALTER TABLE `manufacturing_order`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `manufacturing_order_components`
--
ALTER TABLE `manufacturing_order_components`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `members`
--
ALTER TABLE `members`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=5370;
--
-- AUTO_INCREMENT for table `memo`
--
ALTER TABLE `memo`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3;
--
-- AUTO_INCREMENT for table `menu_items`
--
ALTER TABLE `menu_items`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `menu_printer_map`
--
ALTER TABLE `menu_printer_map`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `modules`
--
ALTER TABLE `modules`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=21;
--
-- AUTO_INCREMENT for table `notifications`
--
ALTER TABLE `notifications`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `patients`
--
ALTER TABLE `patients`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=14;
--
-- AUTO_INCREMENT for table `patient_history`
--
ALTER TABLE `patient_history`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=74;
--
-- AUTO_INCREMENT for table `payment_gateways`
--
ALTER TABLE `payment_gateways`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `payment_vouchers`
--
ALTER TABLE `payment_vouchers`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `payment_voucher_breakdown`
--
ALTER TABLE `payment_voucher_breakdown`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `payment_voucher_items`
--
ALTER TABLE `payment_voucher_items`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `permissions`
--
ALTER TABLE `permissions`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=12;
--
-- AUTO_INCREMENT for table `pos_items_template`
--
ALTER TABLE `pos_items_template`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=9;
--
-- AUTO_INCREMENT for table `potentials`
--
ALTER TABLE `potentials`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `product_reviews`
--
ALTER TABLE `product_reviews`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `purchase_orders`
--
ALTER TABLE `purchase_orders`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `purchase_order_items`
--
ALTER TABLE `purchase_order_items`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `purchase_requests`
--
ALTER TABLE `purchase_requests`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `purchase_request_items`
--
ALTER TABLE `purchase_request_items`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `quotes`
--
ALTER TABLE `quotes`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `quote_items`
--
ALTER TABLE `quote_items`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `receipts`
--
ALTER TABLE `receipts`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `receipt_breakdown`
--
ALTER TABLE `receipt_breakdown`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `receipt_items`
--
ALTER TABLE `receipt_items`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `reports`
--
ALTER TABLE `reports`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=23;
--
-- AUTO_INCREMENT for table `reports_saved`
--
ALTER TABLE `reports_saved`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=10;
--
-- AUTO_INCREMENT for table `report_to`
--
ALTER TABLE `report_to`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;
--
-- AUTO_INCREMENT for table `reverts`
--
ALTER TABLE `reverts`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `salary_deduction_table`
--
ALTER TABLE `salary_deduction_table`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=115;
--
-- AUTO_INCREMENT for table `salary_voucher`
--
ALTER TABLE `salary_voucher`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `salary_voucher_breakdown`
--
ALTER TABLE `salary_voucher_breakdown`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `salary_voucher_format`
--
ALTER TABLE `salary_voucher_format`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=19;
--
-- AUTO_INCREMENT for table `salary_voucher_items`
--
ALTER TABLE `salary_voucher_items`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `sales`
--
ALTER TABLE `sales`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `sales_breakdown`
--
ALTER TABLE `sales_breakdown`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `sales_discount_item_rules`
--
ALTER TABLE `sales_discount_item_rules`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `sales_discount_rules`
--
ALTER TABLE `sales_discount_rules`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `sales_order`
--
ALTER TABLE `sales_order`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `sales_order_items`
--
ALTER TABLE `sales_order_items`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `sales_sessions`
--
ALTER TABLE `sales_sessions`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2328;
--
-- AUTO_INCREMENT for table `sale_items`
--
ALTER TABLE `sale_items`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `sale_tax`
--
ALTER TABLE `sale_tax`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `services`
--
ALTER TABLE `services`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `settlements`
--
ALTER TABLE `settlements`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `shipping`
--
ALTER TABLE `shipping`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=7;
--
-- AUTO_INCREMENT for table `shipping_international_zones`
--
ALTER TABLE `shipping_international_zones`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=4;
--
-- AUTO_INCREMENT for table `shipping_local_zones`
--
ALTER TABLE `shipping_local_zones`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=10;
--
-- AUTO_INCREMENT for table `shipping_rates`
--
ALTER TABLE `shipping_rates`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=10;
--
-- AUTO_INCREMENT for table `states`
--
ALTER TABLE `states`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=4411;
--
-- AUTO_INCREMENT for table `stock_adjustment`
--
ALTER TABLE `stock_adjustment`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `stock_count`
--
ALTER TABLE `stock_count`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `stock_count_items`
--
ALTER TABLE `stock_count_items`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `subscription`
--
ALTER TABLE `subscription`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `system_transactions`
--
ALTER TABLE `system_transactions`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1206;
--
-- AUTO_INCREMENT for table `tags`
--
ALTER TABLE `tags`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `tax`
--
ALTER TABLE `tax`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3;
--
-- AUTO_INCREMENT for table `tax_codes_purchase`
--
ALTER TABLE `tax_codes_purchase`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `tax_codes_supply`
--
ALTER TABLE `tax_codes_supply`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `terminals`
--
ALTER TABLE `terminals`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=33;
--
-- AUTO_INCREMENT for table `users`
--
ALTER TABLE `users`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=10012;
--
-- AUTO_INCREMENT for table `vacancies`
--
ALTER TABLE `vacancies`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3;
--
-- AUTO_INCREMENT for table `warehouses`
--
ALTER TABLE `warehouses`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;
--
-- AUTO_INCREMENT for table `warehouse_movements`
--
ALTER TABLE `warehouse_movements`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `warehouse_movement_items`
--
ALTER TABLE `warehouse_movement_items`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `_files`
--
ALTER TABLE `_files`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `_txn`
--
ALTER TABLE `_txn`
  MODIFY `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
